# Autogenerated file. Changes will be overwritten.

try:
    import coriolis
except ImportError:
    import CRL, Hurricane, Viewer, Cfg
    from Hurricane import (
        Technology, DataBase, DbU, Library,
        Layer, BasicLayer,
        Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
        Instance, Transformation,
        NetExternalComponents,
    )
    from helpers import u, l
    from helpers.technology import setEnclosures
    from helpers.overlay import CfgCache, UpdateSession
else:
    from coriolis import CRL, Hurricane, Viewer, Cfg
    from coriolis.Hurricane import (
        Technology, DataBase, DbU, Library,
        Layer, BasicLayer,
        Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
        Instance, Transformation,
        NetExternalComponents,
    )
    from coriolis.helpers import u, l
    from coriolis.helpers.technology import setEnclosures
    from coriolis.helpers.overlay import CfgCache, UpdateSession

__all__ = ["setup"]

def createRL(tech, net, layer, coords):
    coords = [Point(u(x), u(y)) for x,y in coords]
    Rectilinear.create(net, tech.getLayer(layer), coords)

def _routing():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()

    # No standard cell library
    pass


def _load():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()
    rootlib = db.getRootLibrary()

    lib = Library.create(rootlib, 'IOLib')
    new_cells = {
        'GateDecode': Cell.create(lib, 'GateDecode'),
        'LevelUp': Cell.create(lib, 'LevelUp'),
        'Gallery': Cell.create(lib, 'Gallery'),
        'BulkConn_200WNoUp': Cell.create(lib, 'BulkConn_200WNoUp'),
        'LevelDown': Cell.create(lib, 'LevelDown'),
        'SecondaryProtection': Cell.create(lib, 'SecondaryProtection'),
        'GuardRing_P18000W8728HFF': Cell.create(lib, 'GuardRing_P18000W8728HFF'),
        'GuardRing_N17368W8096HTF': Cell.create(lib, 'GuardRing_N17368W8096HTF'),
        'Clamp_P32N4D': Cell.create(lib, 'Clamp_P32N4D'),
        'Filler200': Cell.create(lib, 'Filler200'),
        'BulkConn_400WNoUp': Cell.create(lib, 'BulkConn_400WNoUp'),
        'Filler400': Cell.create(lib, 'Filler400'),
        'BulkConn_1000WNoUp': Cell.create(lib, 'BulkConn_1000WNoUp'),
        'Filler1000': Cell.create(lib, 'Filler1000'),
        'BulkConn_2000WNoUp': Cell.create(lib, 'BulkConn_2000WNoUp'),
        'Filler2000': Cell.create(lib, 'Filler2000'),
        'BulkConn_4000WNoUp': Cell.create(lib, 'BulkConn_4000WNoUp'),
        'Filler4000': Cell.create(lib, 'Filler4000'),
        'BulkConn_10000WNoUp': Cell.create(lib, 'BulkConn_10000WNoUp'),
        'Filler10000': Cell.create(lib, 'Filler10000'),
        'Corner': Cell.create(lib, 'Corner'),
        'IOPadVss': Cell.create(lib, 'IOPadVss'),
        'Pad_15800W12000H': Cell.create(lib, 'Pad_15800W12000H'),
        'GuardRing_N18000W4468HFF': Cell.create(lib, 'GuardRing_N18000W4468HFF'),
        'GuardRing_P17368W3836HFF': Cell.create(lib, 'GuardRing_P17368W3836HFF'),
        'Clamp_N32N0D': Cell.create(lib, 'Clamp_N32N0D'),
        'Clamp_P32N0D': Cell.create(lib, 'Clamp_P32N0D'),
        'BulkConn_18000WUp': Cell.create(lib, 'BulkConn_18000WUp'),
        'IOPadVdd': Cell.create(lib, 'IOPadVdd'),
        'IOPadIn': Cell.create(lib, 'IOPadIn'),
        'IOPadOut': Cell.create(lib, 'IOPadOut'),
        'Clamp_N32N4D': Cell.create(lib, 'Clamp_N32N4D'),
        'GateLevelUp': Cell.create(lib, 'GateLevelUp'),
        'IOPadTriOut': Cell.create(lib, 'IOPadTriOut'),
        'IOPadInOut': Cell.create(lib, 'IOPadInOut'),
        'IOPadIOVss': Cell.create(lib, 'IOPadIOVss'),
        'IOPadIOVdd': Cell.create(lib, 'IOPadIOVdd'),
        'Clamp_N32N32D': Cell.create(lib, 'Clamp_N32N32D'),
        'RCClampResistor': Cell.create(lib, 'RCClampResistor'),
        'GuardRing_P12310W3968HFT': Cell.create(lib, 'GuardRing_P12310W3968HFT'),
        'GuardRing_N8666W2488HTT': Cell.create(lib, 'GuardRing_N8666W2488HTT'),
        'RCClampInverter': Cell.create(lib, 'RCClampInverter'),
        'IOPadAnalog': Cell.create(lib, 'IOPadAnalog'),
        'Clamp_N12N0D': Cell.create(lib, 'Clamp_N12N0D'),
        'Clamp_P12N0D': Cell.create(lib, 'Clamp_P12N0D'),
    }

    cell = new_cells['GateDecode']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-15.0), u(7.879999999999999), u(10.0),
        ))
        nets = {
            'd': Net.create(cell, 'd'),
            'de': Net.create(cell, 'de'),
            'de_n': Net.create(cell, 'de_n'),
            'iovdd': Net.create(cell, 'iovdd'),
            'ngate': Net.create(cell, 'ngate'),
            'ngate_core': Net.create(cell, 'ngate_core'),
            'pgate': Net.create(cell, 'pgate'),
            'pgate_core': Net.create(cell, 'pgate_core'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['de']
        createRL(
            tech, net, 'li',
            ((3.05,6.29),(3.05,6.46),(3.22,6.46),(3.22,6.29),(3.05,6.29)),
        )
        createRL(
            tech, net, 'li',
            ((4.17,6.29),(4.17,6.46),(4.34,6.46),(4.34,6.29),(4.17,6.29)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.05,6.29),(3.05,6.46),(3.22,6.46),(3.22,6.29),(3.05,6.29)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.17,6.29),(4.17,6.46),(4.34,6.46),(4.34,6.29),(4.17,6.29)),
        )
        createRL(
            tech, net, 'm1',
            ((3.02,6.23),(3.02,10.0),(3.39,10.0),(3.39,6.52),(4.37,6.52),(4.37,6.23),(3.02,6.23)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(3.205), u(0.37), u(6.23), u(10.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(3.205), u(0.37), u(6.23), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['d']
        createRL(
            tech, net, 'li',
            ((2.495,5.86),(2.495,6.03),(2.665,6.03),(2.665,5.86),(2.495,5.86)),
        )
        createRL(
            tech, net, 'li',
            ((0.495,5.86),(0.495,6.03),(0.665,6.03),(0.665,5.86),(0.495,5.86)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.495,5.86),(2.495,6.03),(2.665,6.03),(2.665,5.86),(2.495,5.86)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.495,5.86),(0.495,6.03),(0.665,6.03),(0.665,5.86),(0.495,5.86)),
        )
        createRL(
            tech, net, 'm1',
            ((0.465,5.8),(0.465,10.0),(0.835,10.0),(0.835,6.09),(2.695,6.09),(2.695,5.8),(0.465,5.8)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(0.65), u(0.37), u(5.8), u(10.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(0.65), u(0.37), u(5.8), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['de_n']
        createRL(
            tech, net, 'li',
            ((4.845,5.43),(4.845,5.6),(5.015,5.6),(5.015,5.43),(4.845,5.43)),
        )
        createRL(
            tech, net, 'li',
            ((1.05,5.43),(1.05,5.6),(1.22,5.6),(1.22,5.43),(1.05,5.43)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.845,5.43),(4.845,5.6),(5.015,5.6),(5.015,5.43),(4.845,5.43)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.05,5.43),(1.05,5.6),(1.22,5.6),(1.22,5.43),(1.05,5.43)),
        )
        createRL(
            tech, net, 'm1',
            ((1.02,5.37),(1.02,5.66),(5.045,5.66),(5.045,5.37),(1.02,5.37)),
        )
        net = nets['ngate_core']
        createRL(
            tech, net, 'li',
            ((1.4,1.37),(1.4,1.54),(1.57,1.54),(1.57,1.37),(1.4,1.37)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.4,1.37),(1.4,1.54),(1.57,1.54),(1.57,1.37),(1.4,1.37)),
        )
        createRL(
            tech, net, 'm1',
            ((2.095,-6.075),(2.095,1.31),(1.37,1.31),(1.37,1.6),(2.325,1.6),(2.325,-6.075),(2.095,-6.075)),
        )
        net = nets['pgate_core']
        createRL(
            tech, net, 'li',
            ((3.4,1.37),(3.4,1.54),(3.57,1.54),(3.57,1.37),(3.4,1.37)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.4,1.37),(3.4,1.54),(3.57,1.54),(3.57,1.37),(3.4,1.37)),
        )
        createRL(
            tech, net, 'm1',
            ((5.535,-6.075),(5.535,1.31),(3.37,1.31),(3.37,1.6),(5.765,1.6),(5.765,-6.075),(5.535,-6.075)),
        )
        net = nets['ngate']
        createRL(
            tech, net, 'm1',
            ((4.05,-14.325),(4.05,-7.195),(4.28,-7.195),(4.28,-14.325),(4.05,-14.325)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(4.165), u(0.23), u(-14.325), u(-7.195),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(4.165), u(0.23), u(-14.325), u(-7.195),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['pgate']
        createRL(
            tech, net, 'm1',
            ((7.49,-14.325),(7.49,-7.195),(7.72,-7.195),(7.72,-14.325),(7.49,-14.325)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(7.605), u(0.23), u(-14.325), u(-7.195),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(7.605), u(0.23), u(-14.325), u(-7.195),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'li',
            ((7.635,-6.455),(7.635,-6.285),(7.805,-6.285),(7.805,-6.455),(7.635,-6.455)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,0.0),(0.0,1.2),(7.88,1.2),(7.88,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((7.635,-6.455),(7.635,-6.285),(7.805,-6.285),(7.805,-6.455),(7.635,-6.455)),
        )
        createRL(
            tech, net, 'mcon',
            ((7.635,0.075),(7.635,0.245),(7.805,0.245),(7.805,0.075),(7.635,0.075)),
        )
        createRL(
            tech, net, 'm1',
            ((7.605,-6.515),(7.605,0.305),(7.835,0.305),(7.835,-6.515),(7.605,-6.515)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(0.6), u(1.2), u(0.0), u(7.879999999999999),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(0.6), u(1.2), u(0.0), u(7.879999999999999),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'li',
            ((0.0,8.8),(0.0,10.0),(7.88,10.0),(7.88,8.8),(0.0,8.8)),
        )
        createRL(
            tech, net, 'li',
            ((0.075,-1.13),(0.075,-0.87),(4.44,-0.87),(4.44,-1.13),(0.075,-1.13)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(9.4), u(1.2), u(0.0), u(7.879999999999999),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(9.4), u(1.2), u(0.0), u(7.879999999999999),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'mcon',
            ((0.075,-1.115),(0.075,-0.945),(0.245,-0.945),(0.245,-1.115),(0.075,-1.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.075,8.875),(0.075,9.045),(0.245,9.045),(0.245,8.875),(0.075,8.875)),
        )
        createRL(
            tech, net, 'm1',
            ((0.045,-1.175),(0.045,9.105),(0.275,9.105),(0.275,-1.175),(0.045,-1.175)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'li',
            ((0.0,-15.13),(0.0,-14.87),(7.88,-14.87),(7.88,-15.13),(0.0,-15.13)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(-15.0), u(0.26), u(0.0), u(7.879999999999999),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(-15.0), u(0.26), u(0.0), u(7.879999999999999),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['d'].setDirection(Net.Direction.IN)
        nets['de'].setDirection(Net.Direction.IN)
        nets['ngate'].setDirection(Net.Direction.IN)
        nets['pgate'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'ngate_nor', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(2.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pgate_nand', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(4.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'oe_inv', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['LevelUp']
        except:
            subcell = af.getCell('LevelUp', 0)
        trans = Transformation(
            u(1.0), u(-15.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'ngate_levelup', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['LevelUp']
        except:
            subcell = af.getCell('LevelUp', 0)
        trans = Transformation(
            u(4.4399999999999995), u(-15.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pgate_levelup', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['LevelUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.44), u(14.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'i_n': Net.create(cell, 'i_n'),
            'iovdd': Net.create(cell, 'iovdd'),
            'lvld': Net.create(cell, 'lvld'),
            'lvld_n': Net.create(cell, 'lvld_n'),
            'o': Net.create(cell, 'o'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i_n']
        createRL(
            tech, net, 'difftap',
            ((0.135,11.04),(0.135,13.6),(0.4,13.6),(0.4,11.04),(0.135,11.04)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.135,8.895),(0.135,10.355),(0.4,10.355),(0.4,8.895),(0.135,8.895)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,5.23),(1.275,5.4),(1.445,5.4),(1.445,5.23),(1.275,5.23)),
        )
        createRL(
            tech, net, 'licon',
            ((0.665,5.23),(0.665,5.4),(0.835,5.4),(0.835,5.23),(0.665,5.23)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,9.03),(0.175,9.2),(0.345,9.2),(0.345,9.03),(0.175,9.03)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,9.37),(0.175,9.54),(0.345,9.54),(0.345,9.37),(0.175,9.37)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,9.71),(0.175,9.88),(0.345,9.88),(0.345,9.71),(0.175,9.71)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,10.05),(0.175,10.22),(0.345,10.22),(0.345,10.05),(0.175,10.05)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,11.215),(0.175,11.385),(0.345,11.385),(0.345,11.215),(0.175,11.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,11.555),(0.175,11.725),(0.345,11.725),(0.345,11.555),(0.175,11.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,11.895),(0.175,12.065),(0.345,12.065),(0.345,11.895),(0.175,11.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,12.235),(0.175,12.405),(0.345,12.405),(0.345,12.235),(0.175,12.235)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,12.575),(0.175,12.745),(0.345,12.745),(0.345,12.575),(0.175,12.575)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,12.915),(0.175,13.085),(0.345,13.085),(0.345,12.915),(0.175,12.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,13.255),(0.175,13.425),(0.345,13.425),(0.345,13.255),(0.175,13.255)),
        )
        createRL(
            tech, net, 'li',
            ((0.665,4.95),(0.665,5.48),(0.835,5.48),(0.835,4.95),(0.665,4.95)),
        )
        createRL(
            tech, net, 'li',
            ((1.275,5.15),(1.275,5.48),(1.445,5.48),(1.445,5.15),(1.275,5.15)),
        )
        createRL(
            tech, net, 'li',
            ((0.085,8.95),(0.085,13.505),(0.345,13.505),(0.345,8.95),(0.085,8.95)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,8.985),(0.13,9.155),(0.3,9.155),(0.3,8.985),(0.13,8.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,9.345),(0.13,9.515),(0.3,9.515),(0.3,9.345),(0.13,9.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,9.705),(0.13,9.875),(0.3,9.875),(0.3,9.705),(0.13,9.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,10.065),(0.13,10.235),(0.3,10.235),(0.3,10.065),(0.13,10.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,10.425),(0.13,10.595),(0.3,10.595),(0.3,10.425),(0.13,10.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,10.785),(0.13,10.955),(0.3,10.955),(0.3,10.785),(0.13,10.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,11.145),(0.13,11.315),(0.3,11.315),(0.3,11.145),(0.13,11.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,11.505),(0.13,11.675),(0.3,11.675),(0.3,11.505),(0.13,11.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,11.865),(0.13,12.035),(0.3,12.035),(0.3,11.865),(0.13,11.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,12.225),(0.13,12.395),(0.3,12.395),(0.3,12.225),(0.13,12.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,12.585),(0.13,12.755),(0.3,12.755),(0.3,12.585),(0.13,12.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,12.945),(0.13,13.115),(0.3,13.115),(0.3,12.945),(0.13,12.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.13,13.305),(0.13,13.475),(0.3,13.475),(0.3,13.305),(0.13,13.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.665,4.95),(0.665,5.12),(0.835,5.12),(0.835,4.95),(0.665,4.95)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.665,5.31),(0.665,5.48),(0.835,5.48),(0.835,5.31),(0.665,5.31)),
        )
        createRL(
            tech, net, 'm1',
            ((0.1,4.89),(0.1,13.535),(0.33,13.535),(0.33,5.54),(0.865,5.54),(0.865,4.89),(0.1,4.89)),
        )
        createRL(
            tech, net, 'poly',
            ((1.195,5.46),(1.195,8.12),(1.695,8.12),(1.695,5.46),(1.195,5.46)),
        )
        createRL(
            tech, net, 'poly',
            ((0.415,5.46),(0.415,8.12),(0.915,8.12),(0.915,5.46),(0.415,5.46)),
        )
        createRL(
            tech, net, 'poly',
            ((1.195,5.18),(1.195,5.45),(1.525,5.45),(1.525,5.18),(1.195,5.18)),
        )
        createRL(
            tech, net, 'poly',
            ((0.585,5.18),(0.585,5.45),(0.915,5.45),(0.915,5.18),(0.585,5.18)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((0.01,8.77),(0.01,10.48),(1.46,10.48),(1.46,8.77),(0.01,8.77)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(3.565,14.25),(3.565,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(3.565,0.25),(3.565,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((0.0,5.465),(0.0,8.115),(3.44,8.115),(3.44,5.465),(0.0,5.465)),
        )
        createRL(
            tech, net, 'psdm',
            ((0.0,0.38),(0.0,5.03),(3.44,5.03),(3.44,0.38),(0.0,0.38)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(3.565,8.75),(3.565,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((0.01,10.915),(0.01,13.725),(1.46,13.725),(1.46,10.915),(0.01,10.915)),
        )
        createRL(
            tech, net, 'hvi',
            ((-0.18,0.305),(-0.18,8.195),(3.62,8.195),(3.62,0.305),(-0.18,0.305)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'nwm',
            ((0.0,10.7),(0.0,10.86),(-0.045,10.86),(-0.045,13.695),(-0.095,13.695),(-0.095,14.305),(3.535,14.305),(3.535,13.695),(3.44,13.695),(3.44,10.7),(0.0,10.7)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(3.44,14.125),(3.44,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.4,11.04),(0.4,13.6),(0.815,13.6),(0.815,11.04),(0.4,11.04)),
        )
        createRL(
            tech, net, 'licon',
            ((0.275,13.915),(0.275,14.085),(0.445,14.085),(0.445,13.915),(0.275,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.615,13.915),(0.615,14.085),(0.785,14.085),(0.785,13.915),(0.615,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.955,13.915),(0.955,14.085),(1.125,14.085),(1.125,13.915),(0.955,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.295,13.915),(1.295,14.085),(1.465,14.085),(1.465,13.915),(1.295,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.635,13.915),(1.635,14.085),(1.805,14.085),(1.805,13.915),(1.635,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.975,13.915),(1.975,14.085),(2.145,14.085),(2.145,13.915),(1.975,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.315,13.915),(2.315,14.085),(2.485,14.085),(2.485,13.915),(2.315,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.655,13.915),(2.655,14.085),(2.825,14.085),(2.825,13.915),(2.655,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.995,13.915),(2.995,14.085),(3.165,14.085),(3.165,13.915),(2.995,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,11.215),(0.605,11.385),(0.775,11.385),(0.775,11.215),(0.605,11.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,11.555),(0.605,11.725),(0.775,11.725),(0.775,11.555),(0.605,11.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,11.895),(0.605,12.065),(0.775,12.065),(0.775,11.895),(0.605,11.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,12.235),(0.605,12.405),(0.775,12.405),(0.775,12.235),(0.605,12.235)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,12.575),(0.605,12.745),(0.775,12.745),(0.775,12.575),(0.605,12.575)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,12.915),(0.605,13.085),(0.775,13.085),(0.775,12.915),(0.605,12.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,13.255),(0.605,13.425),(0.775,13.425),(0.775,13.255),(0.605,13.255)),
        )
        createRL(
            tech, net, 'li',
            ((0.605,11.04),(0.605,13.87),(0.0,13.87),(0.0,14.13),(3.44,14.13),(3.44,13.87),(0.775,13.87),(0.775,11.04),(0.605,11.04)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(14.0), u(0.26), u(0.0), u(3.44),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(14.0), u(0.26), u(0.0), u(3.44),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(3.44,8.625),(3.44,8.375),(0.0,8.375)),
        )
        createRL(
            tech, net, 'difftap',
            ((2.26,5.59),(2.26,7.99),(3.025,7.99),(3.025,5.59),(2.26,5.59)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.195,5.59),(1.195,7.99),(1.8,7.99),(1.8,5.59),(1.195,5.59)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.415,5.59),(0.415,7.99),(1.18,7.99),(1.18,5.59),(0.415,5.59)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.4,8.895),(0.4,10.355),(0.815,10.355),(0.815,8.895),(0.4,8.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,5.855),(0.97,6.025),(1.14,6.025),(1.14,5.855),(0.97,5.855)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,6.195),(0.97,6.365),(1.14,6.365),(1.14,6.195),(0.97,6.195)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,6.535),(0.97,6.705),(1.14,6.705),(1.14,6.535),(0.97,6.535)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,6.875),(0.97,7.045),(1.14,7.045),(1.14,6.875),(0.97,6.875)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,7.215),(0.97,7.385),(1.14,7.385),(1.14,7.215),(0.97,7.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,7.555),(0.97,7.725),(1.14,7.725),(1.14,7.555),(0.97,7.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,9.03),(0.605,9.2),(0.775,9.2),(0.775,9.03),(0.605,9.03)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,9.37),(0.605,9.54),(0.775,9.54),(0.775,9.37),(0.605,9.37)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,9.71),(0.605,9.88),(0.775,9.88),(0.775,9.71),(0.605,9.71)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,10.05),(0.605,10.22),(0.775,10.22),(0.775,10.05),(0.605,10.05)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,5.855),(2.3,6.025),(2.47,6.025),(2.47,5.855),(2.3,5.855)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,6.195),(2.3,6.365),(2.47,6.365),(2.47,6.195),(2.3,6.195)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,6.535),(2.3,6.705),(2.47,6.705),(2.47,6.535),(2.3,6.535)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,6.875),(2.3,7.045),(2.47,7.045),(2.47,6.875),(2.3,6.875)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,7.215),(2.3,7.385),(2.47,7.385),(2.47,7.215),(2.3,7.215)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,7.555),(2.3,7.725),(2.47,7.725),(2.47,7.555),(2.3,7.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.275,8.415),(0.275,8.585),(0.445,8.585),(0.445,8.415),(0.275,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.615,8.415),(0.615,8.585),(0.785,8.585),(0.785,8.415),(0.615,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.955,8.415),(0.955,8.585),(1.125,8.585),(1.125,8.415),(0.955,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.295,8.415),(1.295,8.585),(1.465,8.585),(1.465,8.415),(1.295,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.635,8.415),(1.635,8.585),(1.805,8.585),(1.805,8.415),(1.635,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.975,8.415),(1.975,8.585),(2.145,8.585),(2.145,8.415),(1.975,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.315,8.415),(2.315,8.585),(2.485,8.585),(2.485,8.415),(2.315,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.655,8.415),(2.655,8.585),(2.825,8.585),(2.825,8.415),(2.655,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.995,8.415),(2.995,8.585),(3.165,8.585),(3.165,8.415),(2.995,8.415)),
        )
        createRL(
            tech, net, 'li',
            ((0.97,5.775),(0.97,8.37),(0.0,8.37),(0.0,8.63),(0.605,8.63),(0.605,10.355),(0.775,10.355),(0.775,8.63),(3.44,8.63),(3.44,8.37),(2.47,8.37),(2.47,5.775),(2.3,5.775),(2.3,8.37),(1.14,8.37),(1.14,5.775),(0.97,5.775)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(8.5), u(0.26), u(0.0), u(3.44),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(8.5), u(0.26), u(0.0), u(3.44),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'poly',
            ((0.4,8.765),(0.4,13.73),(0.55,13.73),(0.55,10.865),(0.815,10.865),(0.815,10.535),(0.55,10.535),(0.55,8.765),(0.4,8.765)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,9.03),(1.125,9.2),(1.295,9.2),(1.295,9.03),(1.125,9.03)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,9.37),(1.125,9.54),(1.295,9.54),(1.295,9.37),(1.125,9.37)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,9.71),(1.125,9.88),(1.295,9.88),(1.295,9.71),(1.125,9.71)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,10.05),(1.125,10.22),(1.295,10.22),(1.295,10.05),(1.125,10.05)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,11.215),(1.125,11.385),(1.295,11.385),(1.295,11.215),(1.125,11.215)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,11.555),(1.125,11.725),(1.295,11.725),(1.295,11.555),(1.125,11.555)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,11.895),(1.125,12.065),(1.295,12.065),(1.295,11.895),(1.125,11.895)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,12.235),(1.125,12.405),(1.295,12.405),(1.295,12.235),(1.125,12.235)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,12.575),(1.125,12.745),(1.295,12.745),(1.295,12.575),(1.125,12.575)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,12.915),(1.125,13.085),(1.295,13.085),(1.295,12.915),(1.125,12.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.125,13.255),(1.125,13.425),(1.295,13.425),(1.295,13.255),(1.125,13.255)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,10.615),(0.595,10.785),(0.765,10.785),(0.765,10.615),(0.595,10.615)),
        )
        createRL(
            tech, net, 'li',
            ((1.275,4.95),(1.275,5.48),(1.445,5.48),(1.445,4.95),(1.275,4.95)),
        )
        createRL(
            tech, net, 'li',
            ((1.125,8.95),(1.125,10.525),(0.595,10.525),(0.595,10.87),(1.125,10.87),(1.125,13.505),(1.295,13.505),(1.295,8.95),(1.125,8.95)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.085,8.895),(1.085,10.355),(1.335,10.355),(1.335,8.895),(1.085,8.895)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.085,11.04),(1.085,13.6),(1.335,13.6),(1.335,11.04),(1.085,11.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.275,4.95),(1.275,5.12),(1.445,5.12),(1.445,4.95),(1.275,4.95)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.275,5.31),(1.275,5.48),(1.445,5.48),(1.445,5.31),(1.275,5.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,8.985),(1.125,9.155),(1.295,9.155),(1.295,8.985),(1.125,8.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,9.345),(1.125,9.515),(1.295,9.515),(1.295,9.345),(1.125,9.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,9.705),(1.125,9.875),(1.295,9.875),(1.295,9.705),(1.125,9.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,10.065),(1.125,10.235),(1.295,10.235),(1.295,10.065),(1.125,10.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,10.425),(1.125,10.595),(1.295,10.595),(1.295,10.425),(1.125,10.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,10.785),(1.125,10.955),(1.295,10.955),(1.295,10.785),(1.125,10.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,11.145),(1.125,11.315),(1.295,11.315),(1.295,11.145),(1.125,11.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,11.505),(1.125,11.675),(1.295,11.675),(1.295,11.505),(1.125,11.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,11.865),(1.125,12.035),(1.295,12.035),(1.295,11.865),(1.125,11.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,12.225),(1.125,12.395),(1.295,12.395),(1.295,12.225),(1.125,12.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,12.585),(1.125,12.755),(1.295,12.755),(1.295,12.585),(1.125,12.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,12.945),(1.125,13.115),(1.295,13.115),(1.295,12.945),(1.125,12.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.125,13.305),(1.125,13.475),(1.295,13.475),(1.295,13.305),(1.125,13.305)),
        )
        createRL(
            tech, net, 'm1',
            ((1.095,4.89),(1.095,13.535),(1.325,13.535),(1.325,5.54),(1.475,5.54),(1.475,4.89),(1.095,4.89)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(1.21), u(0.23), u(8.925), u(13.535),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(1.21), u(0.23), u(8.925), u(13.535),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['lvld']
        createRL(
            tech, net, 'difftap',
            ((0.15,2.495),(0.15,2.915),(0.415,2.915),(0.415,2.495),(0.15,2.495)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.09,5.59),(1.09,7.99),(1.195,7.99),(1.195,5.59),(1.09,5.59)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.15,5.59),(0.15,7.99),(0.415,7.99),(0.415,5.59),(0.15,5.59)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,5.855),(0.19,6.025),(0.36,6.025),(0.36,5.855),(0.19,5.855)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,6.195),(0.19,6.365),(0.36,6.365),(0.36,6.195),(0.19,6.195)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,6.535),(0.19,6.705),(0.36,6.705),(0.36,6.535),(0.19,6.535)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,6.875),(0.19,7.045),(0.36,7.045),(0.36,6.875),(0.19,6.875)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,7.215),(0.19,7.385),(0.36,7.385),(0.36,7.215),(0.19,7.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,7.555),(0.19,7.725),(0.36,7.725),(0.36,7.555),(0.19,7.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.19,2.62),(0.19,2.79),(0.36,2.79),(0.36,2.62),(0.19,2.62)),
        )
        createRL(
            tech, net, 'licon',
            ((0.665,3.105),(0.665,3.275),(0.835,3.275),(0.835,3.105),(0.665,3.105)),
        )
        createRL(
            tech, net, 'li',
            ((0.19,2.54),(0.19,7.805),(0.36,7.805),(0.36,3.855),(1.445,3.855),(1.445,3.525),(0.36,3.525),(0.36,2.54),(0.19,2.54)),
        )
        createRL(
            tech, net, 'li',
            ((0.665,3.025),(0.665,3.355),(0.835,3.355),(0.835,3.025),(0.665,3.025)),
        )
        createRL(
            tech, net, 'poly',
            ((1.195,2.365),(1.195,3.825),(1.695,3.825),(1.695,2.365),(1.195,2.365)),
        )
        createRL(
            tech, net, 'poly',
            ((0.415,2.365),(0.415,3.325),(0.915,3.325),(0.915,2.365),(0.415,2.365)),
        )
        createRL(
            tech, net, 'poly',
            ((0.415,5.18),(0.415,8.12),(0.915,8.12),(0.915,5.18),(0.415,5.18)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'nwm',
            ((-0.095,-0.305),(-0.095,0.305),(0.0,0.305),(0.0,2.315),(-0.03,2.315),(-0.03,3.095),(0.0,3.095),(0.0,5.25),(3.44,5.25),(3.44,5.085),(3.47,5.085),(3.47,0.325),(3.44,0.325),(3.44,0.305),(3.535,0.305),(3.535,-0.305),(-0.095,-0.305)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.415,2.495),(0.415,2.915),(1.695,2.915),(1.695,2.495),(0.415,2.495)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(3.44,0.125),(3.44,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'difftap',
            ((2.26,0.505),(2.26,4.905),(3.025,4.905),(3.025,0.505),(2.26,0.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,2.62),(0.97,2.79),(1.14,2.79),(1.14,2.62),(0.97,2.62)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,0.75),(2.3,0.92),(2.47,0.92),(2.47,0.75),(2.3,0.75)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,1.09),(2.3,1.26),(2.47,1.26),(2.47,1.09),(2.3,1.09)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,1.43),(2.3,1.6),(2.47,1.6),(2.47,1.43),(2.3,1.43)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,1.77),(2.3,1.94),(2.47,1.94),(2.47,1.77),(2.3,1.77)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,2.11),(2.3,2.28),(2.47,2.28),(2.47,2.11),(2.3,2.11)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,2.45),(2.3,2.62),(2.47,2.62),(2.47,2.45),(2.3,2.45)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,2.79),(2.3,2.96),(2.47,2.96),(2.47,2.79),(2.3,2.79)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,3.13),(2.3,3.3),(2.47,3.3),(2.47,3.13),(2.3,3.13)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,3.47),(2.3,3.64),(2.47,3.64),(2.47,3.47),(2.3,3.47)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,3.81),(2.3,3.98),(2.47,3.98),(2.47,3.81),(2.3,3.81)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,4.15),(2.3,4.32),(2.47,4.32),(2.47,4.15),(2.3,4.15)),
        )
        createRL(
            tech, net, 'licon',
            ((2.3,4.49),(2.3,4.66),(2.47,4.66),(2.47,4.49),(2.3,4.49)),
        )
        createRL(
            tech, net, 'licon',
            ((0.275,-0.085),(0.275,0.085),(0.445,0.085),(0.445,-0.085),(0.275,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.615,-0.085),(0.615,0.085),(0.785,0.085),(0.785,-0.085),(0.615,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.955,-0.085),(0.955,0.085),(1.125,0.085),(1.125,-0.085),(0.955,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.295,-0.085),(1.295,0.085),(1.465,0.085),(1.465,-0.085),(1.295,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.635,-0.085),(1.635,0.085),(1.805,0.085),(1.805,-0.085),(1.635,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.975,-0.085),(1.975,0.085),(2.145,0.085),(2.145,-0.085),(1.975,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.315,-0.085),(2.315,0.085),(2.485,0.085),(2.485,-0.085),(2.315,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.655,-0.085),(2.655,0.085),(2.825,0.085),(2.825,-0.085),(2.655,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.995,-0.085),(2.995,0.085),(3.165,0.085),(3.165,-0.085),(2.995,-0.085)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,-0.13),(0.0,0.13),(0.89,0.13),(0.89,2.79),(1.22,2.79),(1.22,0.13),(2.3,0.13),(2.3,4.74),(2.47,4.74),(2.47,0.13),(3.44,0.13),(3.44,-0.13),(0.0,-0.13)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(0.0), u(0.26), u(0.0), u(3.44),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(0.0), u(0.26), u(0.0), u(3.44),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['lvld_n']
        createRL(
            tech, net, 'poly',
            ((1.195,5.18),(1.195,8.12),(1.695,8.12),(1.695,5.18),(1.195,5.18)),
        )
        createRL(
            tech, net, 'poly',
            ((0.415,2.365),(0.415,3.045),(0.915,3.045),(0.915,2.365),(0.415,2.365)),
        )
        createRL(
            tech, net, 'poly',
            ((2.525,0.375),(2.525,8.12),(3.025,8.12),(3.025,0.375),(2.525,0.375)),
        )
        createRL(
            tech, net, 'poly',
            ((1.195,3.555),(1.195,3.825),(1.525,3.825),(1.525,3.555),(1.195,3.555)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.695,2.495),(1.695,2.915),(1.96,2.915),(1.96,2.495),(1.695,2.495)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.71,5.59),(1.71,7.99),(1.96,7.99),(1.96,5.59),(1.71,5.59)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,2.62),(1.75,2.79),(1.92,2.79),(1.92,2.62),(1.75,2.62)),
        )
        createRL(
            tech, net, 'licon',
            ((2.605,5.165),(2.605,5.335),(2.775,5.335),(2.775,5.165),(2.605,5.165)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,5.855),(1.75,6.025),(1.92,6.025),(1.92,5.855),(1.75,5.855)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,6.195),(1.75,6.365),(1.92,6.365),(1.92,6.195),(1.75,6.195)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,6.535),(1.75,6.705),(1.92,6.705),(1.92,6.535),(1.75,6.535)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,6.875),(1.75,7.045),(1.92,7.045),(1.92,6.875),(1.75,6.875)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,7.215),(1.75,7.385),(1.92,7.385),(1.92,7.215),(1.75,7.215)),
        )
        createRL(
            tech, net, 'licon',
            ((1.75,7.555),(1.75,7.725),(1.92,7.725),(1.92,7.555),(1.75,7.555)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,3.605),(1.275,3.775),(1.445,3.775),(1.445,3.605),(1.275,3.605)),
        )
        createRL(
            tech, net, 'li',
            ((1.275,3.525),(1.275,3.855),(1.445,3.855),(1.445,3.525),(1.275,3.525)),
        )
        createRL(
            tech, net, 'li',
            ((1.75,2.54),(1.75,3.025),(0.665,3.025),(0.665,3.355),(1.75,3.355),(1.75,7.805),(1.92,7.805),(1.92,5.415),(2.775,5.415),(2.775,5.085),(1.92,5.085),(1.92,2.54),(1.75,2.54)),
        )
        net = nets['o']
        createRL(
            tech, net, 'difftap',
            ((3.025,5.59),(3.025,7.99),(3.29,7.99),(3.29,5.59),(3.025,5.59)),
        )
        createRL(
            tech, net, 'difftap',
            ((3.025,0.505),(3.025,4.905),(3.29,4.905),(3.29,0.505),(3.025,0.505)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,0.75),(3.08,0.92),(3.25,0.92),(3.25,0.75),(3.08,0.75)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,1.09),(3.08,1.26),(3.25,1.26),(3.25,1.09),(3.08,1.09)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,1.43),(3.08,1.6),(3.25,1.6),(3.25,1.43),(3.08,1.43)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,1.77),(3.08,1.94),(3.25,1.94),(3.25,1.77),(3.08,1.77)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,2.11),(3.08,2.28),(3.25,2.28),(3.25,2.11),(3.08,2.11)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,2.45),(3.08,2.62),(3.25,2.62),(3.25,2.45),(3.08,2.45)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,2.79),(3.08,2.96),(3.25,2.96),(3.25,2.79),(3.08,2.79)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,3.13),(3.08,3.3),(3.25,3.3),(3.25,3.13),(3.08,3.13)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,3.47),(3.08,3.64),(3.25,3.64),(3.25,3.47),(3.08,3.47)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,3.81),(3.08,3.98),(3.25,3.98),(3.25,3.81),(3.08,3.81)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,4.15),(3.08,4.32),(3.25,4.32),(3.25,4.15),(3.08,4.15)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,4.49),(3.08,4.66),(3.25,4.66),(3.25,4.49),(3.08,4.49)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,5.855),(3.08,6.025),(3.25,6.025),(3.25,5.855),(3.08,5.855)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,6.195),(3.08,6.365),(3.25,6.365),(3.25,6.195),(3.08,6.195)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,6.535),(3.08,6.705),(3.25,6.705),(3.25,6.535),(3.08,6.535)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,6.875),(3.08,7.045),(3.25,7.045),(3.25,6.875),(3.08,6.875)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,7.215),(3.08,7.385),(3.25,7.385),(3.25,7.215),(3.08,7.215)),
        )
        createRL(
            tech, net, 'licon',
            ((3.08,7.555),(3.08,7.725),(3.25,7.725),(3.25,7.555),(3.08,7.555)),
        )
        createRL(
            tech, net, 'li',
            ((3.08,0.67),(3.08,7.805),(3.25,7.805),(3.25,0.67),(3.08,0.67)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,0.735),(3.08,0.905),(3.25,0.905),(3.25,0.735),(3.08,0.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,1.095),(3.08,1.265),(3.25,1.265),(3.25,1.095),(3.08,1.095)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,1.455),(3.08,1.625),(3.25,1.625),(3.25,1.455),(3.08,1.455)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,1.815),(3.08,1.985),(3.25,1.985),(3.25,1.815),(3.08,1.815)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,2.175),(3.08,2.345),(3.25,2.345),(3.25,2.175),(3.08,2.175)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,2.535),(3.08,2.705),(3.25,2.705),(3.25,2.535),(3.08,2.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,2.895),(3.08,3.065),(3.25,3.065),(3.25,2.895),(3.08,2.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,3.255),(3.08,3.425),(3.25,3.425),(3.25,3.255),(3.08,3.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,3.615),(3.08,3.785),(3.25,3.785),(3.25,3.615),(3.08,3.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,3.975),(3.08,4.145),(3.25,4.145),(3.25,3.975),(3.08,3.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,4.335),(3.08,4.505),(3.25,4.505),(3.25,4.335),(3.08,4.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,4.695),(3.08,4.865),(3.25,4.865),(3.25,4.695),(3.08,4.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,5.055),(3.08,5.225),(3.25,5.225),(3.25,5.055),(3.08,5.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,5.415),(3.08,5.585),(3.25,5.585),(3.25,5.415),(3.08,5.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,5.775),(3.08,5.945),(3.25,5.945),(3.25,5.775),(3.08,5.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,6.135),(3.08,6.305),(3.25,6.305),(3.25,6.135),(3.08,6.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,6.495),(3.08,6.665),(3.25,6.665),(3.25,6.495),(3.08,6.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,6.855),(3.08,7.025),(3.25,7.025),(3.25,6.855),(3.08,6.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,7.215),(3.08,7.385),(3.25,7.385),(3.25,7.215),(3.08,7.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.08,7.575),(3.08,7.745),(3.25,7.745),(3.25,7.575),(3.08,7.575)),
        )
        createRL(
            tech, net, 'm1',
            ((3.05,0.675),(3.05,7.805),(3.28,7.805),(3.28,0.675),(3.05,0.675)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(3.165), u(0.23), u(0.675), u(7.805),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(3.165), u(0.23), u(0.675), u(7.805),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['o'].setDirection(Net.Direction.IN)

    cell = new_cells['Gallery']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(810.0), u(188.0),
        ))
        nets = {

        }
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['in_s'].setDirection(Net.Direction.IN)
        nets['in_pad'].setDirection(Net.Direction.IN)
        nets['out_d'].setDirection(Net.Direction.IN)
        nets['out_pad'].setDirection(Net.Direction.IN)
        nets['triout_d'].setDirection(Net.Direction.IN)
        nets['triout_de'].setDirection(Net.Direction.IN)
        nets['triout_pad'].setDirection(Net.Direction.IN)
        nets['io_s'].setDirection(Net.Direction.IN)
        nets['io_d'].setDirection(Net.Direction.IN)
        nets['io_de'].setDirection(Net.Direction.IN)
        nets['io_pad'].setDirection(Net.Direction.IN)
        nets['ana_out'].setDirection(Net.Direction.IN)
        nets['ana_outres'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['IOPadVss']
        except:
            subcell = af.getCell('IOPadVss', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadvss', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadVdd']
        except:
            subcell = af.getCell('IOPadVdd', 0)
        trans = Transformation(
            u(90.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadvdd', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadIn']
        except:
            subcell = af.getCell('IOPadIn', 0)
        trans = Transformation(
            u(180.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadin', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadOut']
        except:
            subcell = af.getCell('IOPadOut', 0)
        trans = Transformation(
            u(270.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadout', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadTriOut']
        except:
            subcell = af.getCell('IOPadTriOut', 0)
        trans = Transformation(
            u(360.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadtriout', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadInOut']
        except:
            subcell = af.getCell('IOPadInOut', 0)
        trans = Transformation(
            u(450.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadinout', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadIOVss']
        except:
            subcell = af.getCell('IOPadIOVss', 0)
        trans = Transformation(
            u(540.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadiovss', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadIOVdd']
        except:
            subcell = af.getCell('IOPadIOVdd', 0)
        trans = Transformation(
            u(630.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadiovdd', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['IOPadAnalog']
        except:
            subcell = af.getCell('IOPadAnalog', 0)
        trans = Transformation(
            u(720.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'iopadanalog', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_200WNoUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.08499999999998), u(1.0), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(1.0,0.125),(1.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(1.18,0.42),(1.18,-0.42),(-0.18,-0.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(1.125,14.25),(1.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(1.125,0.25),(1.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(1.125,8.75),(1.125,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(1.125,-6.18),(1.125,-30.085),(-0.125,-30.085)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(1.0,8.625),(1.0,8.375),(0.0,8.375)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(1.0,14.125),(1.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(1.18,14.42),(1.18,13.58),(-0.18,13.58)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(1.0,-6.305),(1.0,-29.96),(0.0,-29.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['LevelDown']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.49), u(14.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'bulk': Net.create(cell, 'bulk'),
            'core': Net.create(cell, 'core'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'pad': Net.create(cell, 'pad'),
            'padres': Net.create(cell, 'padres'),
            'padres_n': Net.create(cell, 'padres_n'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['core']
        createRL(
            tech, net, 'difftap',
            ((0.135,11.04),(0.135,13.6),(0.4,13.6),(0.4,11.04),(0.135,11.04)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.135,8.895),(0.135,10.355),(0.4,10.355),(0.4,8.895),(0.135,8.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,9.03),(0.175,9.2),(0.345,9.2),(0.345,9.03),(0.175,9.03)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,9.37),(0.175,9.54),(0.345,9.54),(0.345,9.37),(0.175,9.37)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,9.71),(0.175,9.88),(0.345,9.88),(0.345,9.71),(0.175,9.71)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,10.05),(0.175,10.22),(0.345,10.22),(0.345,10.05),(0.175,10.05)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,11.215),(0.175,11.385),(0.345,11.385),(0.345,11.215),(0.175,11.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,11.555),(0.175,11.725),(0.345,11.725),(0.345,11.555),(0.175,11.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,11.895),(0.175,12.065),(0.345,12.065),(0.345,11.895),(0.175,11.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,12.235),(0.175,12.405),(0.345,12.405),(0.345,12.235),(0.175,12.235)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,12.575),(0.175,12.745),(0.345,12.745),(0.345,12.575),(0.175,12.575)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,12.915),(0.175,13.085),(0.345,13.085),(0.345,12.915),(0.175,12.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.175,13.255),(0.175,13.425),(0.345,13.425),(0.345,13.255),(0.175,13.255)),
        )
        createRL(
            tech, net, 'li',
            ((0.175,8.95),(0.175,13.505),(0.345,13.505),(0.345,8.95),(0.175,8.95)),
        )
        Vertical.create(
            net, tech.getLayer('li.pin'),
            u(0.26), u(0.17), u(8.95), u(13.505),
        )
        pin = Vertical.create(
            net, tech.getLayer('li'),
            u(0.26), u(0.17), u(8.95), u(13.505),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(6.615,14.25),(6.615,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((0.01,8.77),(0.01,10.48),(2.33,10.48),(2.33,8.77),(0.01,8.77)),
        )
        createRL(
            tech, net, 'psdm',
            ((0.01,10.915),(0.01,13.725),(2.33,13.725),(2.33,10.915),(0.01,10.915)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(6.615,8.75),(6.615,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'hvi',
            ((0.995,8.805),(0.995,13.69),(2.385,13.69),(2.385,8.805),(0.995,8.805)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.4,8.895),(0.4,10.355),(0.815,10.355),(0.815,8.895),(0.4,8.895)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.175,9.005),(1.175,10.355),(1.94,10.355),(1.94,9.005),(1.175,9.005)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(6.49,8.625),(6.49,8.375),(0.0,8.375)),
        )
        createRL(
            tech, net, 'licon',
            ((0.27,8.415),(0.27,8.585),(0.44,8.585),(0.44,8.415),(0.27,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.61,8.415),(0.61,8.585),(0.78,8.585),(0.78,8.415),(0.61,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.95,8.415),(0.95,8.585),(1.12,8.585),(1.12,8.415),(0.95,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.29,8.415),(1.29,8.585),(1.46,8.585),(1.46,8.415),(1.29,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.63,8.415),(1.63,8.585),(1.8,8.585),(1.8,8.415),(1.63,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.97,8.415),(1.97,8.585),(2.14,8.585),(2.14,8.415),(1.97,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.31,8.415),(2.31,8.585),(2.48,8.585),(2.48,8.415),(2.31,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.65,8.415),(2.65,8.585),(2.82,8.585),(2.82,8.415),(2.65,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.99,8.415),(2.99,8.585),(3.16,8.585),(3.16,8.415),(2.99,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((3.33,8.415),(3.33,8.585),(3.5,8.585),(3.5,8.415),(3.33,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((3.67,8.415),(3.67,8.585),(3.84,8.585),(3.84,8.415),(3.67,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((4.01,8.415),(4.01,8.585),(4.18,8.585),(4.18,8.415),(4.01,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((4.35,8.415),(4.35,8.585),(4.52,8.585),(4.52,8.415),(4.35,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((4.69,8.415),(4.69,8.585),(4.86,8.585),(4.86,8.415),(4.69,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((5.03,8.415),(5.03,8.585),(5.2,8.585),(5.2,8.415),(5.03,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((5.37,8.415),(5.37,8.585),(5.54,8.585),(5.54,8.415),(5.37,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((5.71,8.415),(5.71,8.585),(5.88,8.585),(5.88,8.415),(5.71,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((6.05,8.415),(6.05,8.585),(6.22,8.585),(6.22,8.415),(6.05,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,9.255),(1.215,9.425),(1.385,9.425),(1.385,9.255),(1.215,9.255)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,9.595),(1.215,9.765),(1.385,9.765),(1.385,9.595),(1.215,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,9.935),(1.215,10.105),(1.385,10.105),(1.385,9.935),(1.215,9.935)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,9.03),(0.605,9.2),(0.775,9.2),(0.775,9.03),(0.605,9.03)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,9.37),(0.605,9.54),(0.775,9.54),(0.775,9.37),(0.605,9.37)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,9.71),(0.605,9.88),(0.775,9.88),(0.775,9.71),(0.605,9.71)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,10.05),(0.605,10.22),(0.775,10.22),(0.775,10.05),(0.605,10.05)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,8.37),(0.0,8.63),(0.605,8.63),(0.605,10.3),(0.775,10.3),(0.775,10.185),(1.385,10.185),(1.385,8.63),(6.49,8.63),(6.49,8.37),(0.0,8.37)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(8.5), u(0.26), u(0.0), u(6.49),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(8.5), u(0.26), u(0.0), u(6.49),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['padres_n']
        createRL(
            tech, net, 'poly',
            ((0.4,8.765),(0.4,13.73),(0.55,13.73),(0.55,10.865),(0.82,10.865),(0.82,10.535),(0.55,10.535),(0.55,8.765),(0.4,8.765)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.94,11.04),(1.94,13.49),(2.205,13.49),(2.205,11.04),(1.94,11.04)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.94,9.005),(1.94,10.355),(2.205,10.355),(2.205,9.005),(1.94,9.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.6,10.615),(0.6,10.785),(0.77,10.785),(0.77,10.615),(0.6,10.615)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,9.255),(1.995,9.425),(2.165,9.425),(2.165,9.255),(1.995,9.255)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,9.595),(1.995,9.765),(2.165,9.765),(2.165,9.595),(1.995,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,9.935),(1.995,10.105),(2.165,10.105),(2.165,9.935),(1.995,9.935)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,11.33),(1.995,11.5),(2.165,11.5),(2.165,11.33),(1.995,11.33)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,11.67),(1.995,11.84),(2.165,11.84),(2.165,11.67),(1.995,11.67)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,12.01),(1.995,12.18),(2.165,12.18),(2.165,12.01),(1.995,12.01)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,12.35),(1.995,12.52),(2.165,12.52),(2.165,12.35),(1.995,12.35)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,12.69),(1.995,12.86),(2.165,12.86),(2.165,12.69),(1.995,12.69)),
        )
        createRL(
            tech, net, 'licon',
            ((1.995,13.03),(1.995,13.2),(2.165,13.2),(2.165,13.03),(1.995,13.03)),
        )
        createRL(
            tech, net, 'li',
            ((1.995,9.175),(1.995,10.185),(2.165,10.185),(2.165,11.25),(1.995,11.25),(1.995,13.28),(2.335,13.28),(2.335,9.175),(1.995,9.175)),
        )
        createRL(
            tech, net, 'li',
            ((0.52,10.615),(0.52,10.785),(0.85,10.785),(0.85,10.615),(0.52,10.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.165,11.045),(2.165,11.215),(2.335,11.215),(2.335,11.045),(2.165,11.045)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.52,10.615),(0.52,10.785),(0.69,10.785),(0.69,10.615),(0.52,10.615)),
        )
        createRL(
            tech, net, 'm1',
            ((0.49,10.555),(0.49,11.275),(2.365,11.275),(2.365,10.985),(0.72,10.985),(0.72,10.555),(0.49,10.555)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((-0.045,10.86),(-0.045,13.78),(0.995,13.78),(0.995,10.86),(-0.045,10.86)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(6.49,14.125),(6.49,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'difftap',
            ((1.175,11.04),(1.175,13.49),(1.94,13.49),(1.94,11.04),(1.175,11.04)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.4,11.04),(0.4,13.6),(0.815,13.6),(0.815,11.04),(0.4,11.04)),
        )
        createRL(
            tech, net, 'nwm',
            ((0.0,10.7),(0.0,10.86),(-0.03,10.86),(-0.03,13.695),(-0.095,13.695),(-0.095,14.305),(6.585,14.305),(6.585,13.695),(6.49,13.695),(6.49,10.7),(0.0,10.7)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,11.215),(0.605,11.385),(0.775,11.385),(0.775,11.215),(0.605,11.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,11.555),(0.605,11.725),(0.775,11.725),(0.775,11.555),(0.605,11.555)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,11.895),(0.605,12.065),(0.775,12.065),(0.775,11.895),(0.605,11.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,12.235),(0.605,12.405),(0.775,12.405),(0.775,12.235),(0.605,12.235)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,12.575),(0.605,12.745),(0.775,12.745),(0.775,12.575),(0.605,12.575)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,12.915),(0.605,13.085),(0.775,13.085),(0.775,12.915),(0.605,12.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.605,13.255),(0.605,13.425),(0.775,13.425),(0.775,13.255),(0.605,13.255)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,11.33),(1.215,11.5),(1.385,11.5),(1.385,11.33),(1.215,11.33)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,11.67),(1.215,11.84),(1.385,11.84),(1.385,11.67),(1.215,11.67)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,12.01),(1.215,12.18),(1.385,12.18),(1.385,12.01),(1.215,12.01)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,12.35),(1.215,12.52),(1.385,12.52),(1.385,12.35),(1.215,12.35)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,12.69),(1.215,12.86),(1.385,12.86),(1.385,12.69),(1.215,12.69)),
        )
        createRL(
            tech, net, 'licon',
            ((1.215,13.03),(1.215,13.2),(1.385,13.2),(1.385,13.03),(1.215,13.03)),
        )
        createRL(
            tech, net, 'licon',
            ((0.27,13.915),(0.27,14.085),(0.44,14.085),(0.44,13.915),(0.27,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.61,13.915),(0.61,14.085),(0.78,14.085),(0.78,13.915),(0.61,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.95,13.915),(0.95,14.085),(1.12,14.085),(1.12,13.915),(0.95,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.29,13.915),(1.29,14.085),(1.46,14.085),(1.46,13.915),(1.29,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.63,13.915),(1.63,14.085),(1.8,14.085),(1.8,13.915),(1.63,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.97,13.915),(1.97,14.085),(2.14,14.085),(2.14,13.915),(1.97,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.31,13.915),(2.31,14.085),(2.48,14.085),(2.48,13.915),(2.31,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.65,13.915),(2.65,14.085),(2.82,14.085),(2.82,13.915),(2.65,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.99,13.915),(2.99,14.085),(3.16,14.085),(3.16,13.915),(2.99,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((3.33,13.915),(3.33,14.085),(3.5,14.085),(3.5,13.915),(3.33,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((3.67,13.915),(3.67,14.085),(3.84,14.085),(3.84,13.915),(3.67,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((4.01,13.915),(4.01,14.085),(4.18,14.085),(4.18,13.915),(4.01,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((4.35,13.915),(4.35,14.085),(4.52,14.085),(4.52,13.915),(4.35,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((4.69,13.915),(4.69,14.085),(4.86,14.085),(4.86,13.915),(4.69,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((5.03,13.915),(5.03,14.085),(5.2,14.085),(5.2,13.915),(5.03,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((5.37,13.915),(5.37,14.085),(5.54,14.085),(5.54,13.915),(5.37,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((5.71,13.915),(5.71,14.085),(5.88,14.085),(5.88,13.915),(5.71,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((6.05,13.915),(6.05,14.085),(6.22,14.085),(6.22,13.915),(6.05,13.915)),
        )
        createRL(
            tech, net, 'li',
            ((0.605,11.135),(0.605,13.87),(0.0,13.87),(0.0,14.13),(6.49,14.13),(6.49,13.87),(1.385,13.87),(1.385,11.25),(0.775,11.25),(0.775,11.135),(0.605,11.135)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(14.0), u(0.26), u(0.0), u(6.49),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(14.0), u(0.26), u(0.0), u(6.49),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['padres']
        createRL(
            tech, net, 'poly',
            ((1.44,8.875),(1.44,13.62),(1.94,13.62),(1.94,8.875),(1.44,8.875)),
        )
        createRL(
            tech, net, 'licon',
            ((1.72,10.615),(1.72,10.785),(1.89,10.785),(1.89,10.615),(1.72,10.615)),
        )
        createRL(
            tech, net, 'li',
            ((1.64,10.615),(1.64,10.785),(1.97,10.785),(1.97,10.615),(1.64,10.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.64,10.615),(1.64,10.785),(1.81,10.785),(1.81,10.615),(1.64,10.615)),
        )
        createRL(
            tech, net, 'm1',
            ((1.61,0.125),(1.61,10.845),(1.84,10.845),(1.84,0.125),(1.61,0.125)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((0.995,10.86),(0.995,13.67),(1.605,13.67),(1.605,10.86),(0.995,10.86)),
        )
        createRL(
            tech, net, 'nwm',
            ((1.775,10.86),(1.775,13.67),(2.385,13.67),(2.385,10.86),(1.775,10.86)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'm1',
            ((1.155,-6.305),(1.155,-4.895),(2.005,-4.895),(2.005,-6.305),(1.155,-6.305)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(1.58), u(0.85), u(-6.305), u(-4.895),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(1.58), u(0.85), u(-6.305), u(-4.895),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovss']
        createRL(
            tech, net, 'm1',
            ((2.96,-6.085),(2.96,-5.075),(4.46,-5.075),(4.46,-6.085),(2.96,-6.085)),
        )
        Horizontal.create(
            net, tech.getLayer('m1.pin'),
            u(-5.58), u(1.01), u(2.96), u(4.46),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m1'),
            u(-5.58), u(1.01), u(2.96), u(4.46),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'li',
            ((0.0,-0.13),(0.0,0.13),(6.49,0.13),(6.49,-0.13),(0.0,-0.13)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(0.0), u(0.26), u(0.0), u(6.49),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(0.0), u(0.26), u(0.0), u(6.49),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        nets['core'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['SecondaryProtection']
        except:
            subcell = af.getCell('SecondaryProtection', 0)
        trans = Transformation(
            u(0.0), u(-6.305), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'secondprot', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['SecondaryProtection']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.35), u(6.43),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'core': Net.create(cell, 'core'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['*']
        createRL(
            tech, net, 'polyres',
            ((1.075,1.375),(1.075,1.705),(2.085,1.705),(2.085,1.375),(1.075,1.375)),
        )
        createRL(
            tech, net, 'poly',
            ((1.08,1.375),(1.08,1.705),(2.08,1.705),(2.08,1.375),(1.08,1.375)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-0.125),(-0.125,2.475),(0.605,2.475),(0.605,0.605),(2.555,0.605),(2.555,2.475),(-0.125,2.475),(-0.125,3.205),(3.285,3.205),(3.285,-0.125),(-0.125,-0.125)),
        )
        createRL(
            tech, net, 'psdm',
            ((0.625,4.805),(0.625,5.805),(5.725,5.805),(5.725,4.805),(0.625,4.805)),
        )
        createRL(
            tech, net, 'psdm',
            ((4.135,-0.125),(4.135,2.475),(4.865,2.475),(4.865,0.605),(5.745,0.605),(5.745,2.475),(4.135,2.475),(4.135,3.205),(6.475,3.205),(6.475,-0.125),(4.135,-0.125)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,4.055),(-0.125,5.825),(0.605,5.825),(0.605,4.785),(5.745,4.785),(5.745,5.825),(-0.125,5.825),(-0.125,6.555),(6.475,6.555),(6.475,4.055),(-0.125,4.055)),
        )
        createRL(
            tech, net, 'nsdm',
            ((4.885,0.625),(4.885,2.455),(5.725,2.455),(5.725,0.625),(4.885,0.625)),
        )
        createRL(
            tech, net, 'areaid_diode',
            ((5.005,0.745),(5.005,2.335),(5.605,2.335),(5.605,0.745),(5.005,0.745)),
        )
        createRL(
            tech, net, 'areaid_diode',
            ((0.745,4.925),(0.745,5.685),(5.605,5.685),(5.605,4.925),(0.745,4.925)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'poly',
            ((1.08,1.08),(1.08,1.375),(2.08,1.375),(2.08,1.08),(1.08,1.08)),
        )
        createRL(
            tech, net, 'licon',
            ((1.155,1.16),(1.155,1.33),(1.325,1.33),(1.325,1.16),(1.155,1.16)),
        )
        createRL(
            tech, net, 'licon',
            ((1.495,1.16),(1.495,1.33),(1.665,1.33),(1.665,1.16),(1.495,1.16)),
        )
        createRL(
            tech, net, 'licon',
            ((1.835,1.16),(1.835,1.33),(2.005,1.33),(2.005,1.16),(1.835,1.16)),
        )
        createRL(
            tech, net, 'li',
            ((1.155,1.08),(1.155,1.41),(2.005,1.41),(2.005,1.08),(1.155,1.08)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.315,1.24),(1.315,1.41),(1.485,1.41),(1.485,1.24),(1.315,1.24)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.675,1.24),(1.675,1.41),(1.845,1.41),(1.845,1.24),(1.675,1.24)),
        )
        createRL(
            tech, net, 'm1',
            ((1.155,0.0),(1.155,1.41),(1.285,1.41),(1.285,1.47),(1.875,1.47),(1.875,1.41),(2.005,1.41),(2.005,0.0),(1.155,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(1.58), u(0.85), u(0.0), u(1.41),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(1.58), u(0.85), u(0.0), u(1.41),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['core']
        createRL(
            tech, net, 'poly',
            ((1.08,1.705),(1.08,2.0),(2.08,2.0),(2.08,1.705),(1.08,1.705)),
        )
        createRL(
            tech, net, 'licon',
            ((0.88,5.05),(0.88,5.22),(1.05,5.22),(1.05,5.05),(0.88,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((1.22,5.05),(1.22,5.22),(1.39,5.22),(1.39,5.05),(1.22,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((1.56,5.05),(1.56,5.22),(1.73,5.22),(1.73,5.05),(1.56,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((1.9,5.05),(1.9,5.22),(2.07,5.22),(2.07,5.05),(1.9,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((2.24,5.05),(2.24,5.22),(2.41,5.22),(2.41,5.05),(2.24,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((2.58,5.05),(2.58,5.22),(2.75,5.22),(2.75,5.05),(2.58,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((2.92,5.05),(2.92,5.22),(3.09,5.22),(3.09,5.05),(2.92,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((3.26,5.05),(3.26,5.22),(3.43,5.22),(3.43,5.05),(3.26,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((3.6,5.05),(3.6,5.22),(3.77,5.22),(3.77,5.05),(3.6,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((3.94,5.05),(3.94,5.22),(4.11,5.22),(4.11,5.05),(3.94,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((4.28,5.05),(4.28,5.22),(4.45,5.22),(4.45,5.05),(4.28,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((4.62,5.05),(4.62,5.22),(4.79,5.22),(4.79,5.05),(4.62,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((4.96,5.05),(4.96,5.22),(5.13,5.22),(5.13,5.05),(4.96,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((5.3,5.05),(5.3,5.22),(5.47,5.22),(5.47,5.05),(5.3,5.05)),
        )
        createRL(
            tech, net, 'licon',
            ((0.88,5.39),(0.88,5.56),(1.05,5.56),(1.05,5.39),(0.88,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((1.22,5.39),(1.22,5.56),(1.39,5.56),(1.39,5.39),(1.22,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((1.56,5.39),(1.56,5.56),(1.73,5.56),(1.73,5.39),(1.56,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((1.9,5.39),(1.9,5.56),(2.07,5.56),(2.07,5.39),(1.9,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((2.24,5.39),(2.24,5.56),(2.41,5.56),(2.41,5.39),(2.24,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((2.58,5.39),(2.58,5.56),(2.75,5.56),(2.75,5.39),(2.58,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((2.92,5.39),(2.92,5.56),(3.09,5.56),(3.09,5.39),(2.92,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((3.26,5.39),(3.26,5.56),(3.43,5.56),(3.43,5.39),(3.26,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((3.6,5.39),(3.6,5.56),(3.77,5.56),(3.77,5.39),(3.6,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((3.94,5.39),(3.94,5.56),(4.11,5.56),(4.11,5.39),(3.94,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((4.28,5.39),(4.28,5.56),(4.45,5.56),(4.45,5.39),(4.28,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((4.62,5.39),(4.62,5.56),(4.79,5.56),(4.79,5.39),(4.62,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((4.96,5.39),(4.96,5.56),(5.13,5.56),(5.13,5.39),(4.96,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((5.3,5.39),(5.3,5.56),(5.47,5.56),(5.47,5.39),(5.3,5.39)),
        )
        createRL(
            tech, net, 'licon',
            ((1.155,1.75),(1.155,1.92),(1.325,1.92),(1.325,1.75),(1.155,1.75)),
        )
        createRL(
            tech, net, 'licon',
            ((1.495,1.75),(1.495,1.92),(1.665,1.92),(1.665,1.75),(1.495,1.75)),
        )
        createRL(
            tech, net, 'licon',
            ((1.835,1.75),(1.835,1.92),(2.005,1.92),(2.005,1.75),(1.835,1.75)),
        )
        createRL(
            tech, net, 'licon',
            ((5.05,0.945),(5.05,1.115),(5.22,1.115),(5.22,0.945),(5.05,0.945)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,0.945),(5.39,1.115),(5.56,1.115),(5.56,0.945),(5.39,0.945)),
        )
        createRL(
            tech, net, 'licon',
            ((5.05,1.285),(5.05,1.455),(5.22,1.455),(5.22,1.285),(5.05,1.285)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,1.285),(5.39,1.455),(5.56,1.455),(5.56,1.285),(5.39,1.285)),
        )
        createRL(
            tech, net, 'licon',
            ((5.05,1.625),(5.05,1.795),(5.22,1.795),(5.22,1.625),(5.05,1.625)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,1.625),(5.39,1.795),(5.56,1.795),(5.56,1.625),(5.39,1.625)),
        )
        createRL(
            tech, net, 'licon',
            ((5.05,1.965),(5.05,2.135),(5.22,2.135),(5.22,1.965),(5.05,1.965)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,1.965),(5.39,2.135),(5.56,2.135),(5.56,1.965),(5.39,1.965)),
        )
        createRL(
            tech, net, 'li',
            ((1.155,1.67),(1.155,2.0),(2.005,2.0),(2.005,1.67),(1.155,1.67)),
        )
        createRL(
            tech, net, 'li',
            ((5.05,0.865),(5.05,2.215),(5.56,2.215),(5.56,0.865),(5.05,0.865)),
        )
        createRL(
            tech, net, 'li',
            ((0.88,4.97),(0.88,5.64),(5.47,5.64),(5.47,4.97),(0.88,4.97)),
        )
        createRL(
            tech, net, 'difftap',
            ((5.01,0.75),(5.01,2.33),(5.6,2.33),(5.6,0.75),(5.01,0.75)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.75,4.93),(0.75,5.68),(5.6,5.68),(5.6,4.93),(0.75,4.93)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.93,5.04),(0.93,5.21),(1.1,5.21),(1.1,5.04),(0.93,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.29,5.04),(1.29,5.21),(1.46,5.21),(1.46,5.04),(1.29,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.65,5.04),(1.65,5.21),(1.82,5.21),(1.82,5.04),(1.65,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.01,5.04),(2.01,5.21),(2.18,5.21),(2.18,5.04),(2.01,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.37,5.04),(2.37,5.21),(2.54,5.21),(2.54,5.04),(2.37,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.73,5.04),(2.73,5.21),(2.9,5.21),(2.9,5.04),(2.73,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.09,5.04),(3.09,5.21),(3.26,5.21),(3.26,5.04),(3.09,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.45,5.04),(3.45,5.21),(3.62,5.21),(3.62,5.04),(3.45,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.81,5.04),(3.81,5.21),(3.98,5.21),(3.98,5.04),(3.81,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.17,5.04),(4.17,5.21),(4.34,5.21),(4.34,5.04),(4.17,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.53,5.04),(4.53,5.21),(4.7,5.21),(4.7,5.04),(4.53,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.89,5.04),(4.89,5.21),(5.06,5.21),(5.06,5.04),(4.89,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.25,5.04),(5.25,5.21),(5.42,5.21),(5.42,5.04),(5.25,5.04)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.93,5.4),(0.93,5.57),(1.1,5.57),(1.1,5.4),(0.93,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.29,5.4),(1.29,5.57),(1.46,5.57),(1.46,5.4),(1.29,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.65,5.4),(1.65,5.57),(1.82,5.57),(1.82,5.4),(1.65,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.01,5.4),(2.01,5.57),(2.18,5.57),(2.18,5.4),(2.01,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.37,5.4),(2.37,5.57),(2.54,5.57),(2.54,5.4),(2.37,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.73,5.4),(2.73,5.57),(2.9,5.57),(2.9,5.4),(2.73,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.09,5.4),(3.09,5.57),(3.26,5.57),(3.26,5.4),(3.09,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.45,5.4),(3.45,5.57),(3.62,5.57),(3.62,5.4),(3.45,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.81,5.4),(3.81,5.57),(3.98,5.57),(3.98,5.4),(3.81,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.17,5.4),(4.17,5.57),(4.34,5.57),(4.34,5.4),(4.17,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.53,5.4),(4.53,5.57),(4.7,5.57),(4.7,5.4),(4.53,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.89,5.4),(4.89,5.57),(5.06,5.57),(5.06,5.4),(4.89,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.25,5.4),(5.25,5.57),(5.42,5.57),(5.42,5.4),(5.25,5.4)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.315,1.67),(1.315,1.84),(1.485,1.84),(1.485,1.67),(1.315,1.67)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.675,1.67),(1.675,1.84),(1.845,1.84),(1.845,1.67),(1.675,1.67)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.22,0.915),(5.22,1.085),(5.39,1.085),(5.39,0.915),(5.22,0.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.22,1.275),(5.22,1.445),(5.39,1.445),(5.39,1.275),(5.22,1.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.22,1.635),(5.22,1.805),(5.39,1.805),(5.39,1.635),(5.22,1.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.22,1.995),(5.22,2.165),(5.39,2.165),(5.39,1.995),(5.22,1.995)),
        )
        createRL(
            tech, net, 'm1',
            ((1.285,1.61),(1.285,1.67),(1.155,1.67),(1.155,4.97),(0.88,4.97),(0.88,6.43),(5.47,6.43),(5.47,4.97),(2.005,4.97),(2.005,1.67),(1.875,1.67),(1.875,1.61),(1.285,1.61)),
        )
        createRL(
            tech, net, 'm1',
            ((5.19,0.855),(5.19,2.225),(5.42,2.225),(5.42,0.855),(5.19,0.855)),
        )
        Horizontal.create(
            net, tech.getLayer('m1.pin'),
            u(5.7), u(1.46), u(0.8799999999999999), u(5.47),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m1'),
            u(5.7), u(1.46), u(0.8799999999999999), u(5.47),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,0.0),(0.0,2.6),(0.48,2.6),(0.48,0.48),(2.68,0.48),(2.68,2.6),(0.0,2.6),(0.0,3.08),(3.16,3.08),(3.16,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((4.26,0.0),(4.26,2.6),(4.74,2.6),(4.74,0.48),(5.87,0.48),(5.87,2.6),(4.26,2.6),(4.26,3.08),(6.35,3.08),(6.35,0.0),(4.26,0.0)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,0.155),(4.88,0.325),(5.05,0.325),(5.05,0.155),(4.88,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((1.495,0.155),(1.495,0.325),(1.665,0.325),(1.665,0.155),(1.495,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((1.155,0.155),(1.155,0.325),(1.325,0.325),(1.325,0.155),(1.155,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((4.54,0.155),(4.54,0.325),(4.71,0.325),(4.71,0.155),(4.54,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,0.945),(0.155,1.115),(0.325,1.115),(0.325,0.945),(0.155,0.945)),
        )
        createRL(
            tech, net, 'licon',
            ((1.835,0.155),(1.835,0.325),(2.005,0.325),(2.005,0.155),(1.835,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((5.22,2.755),(5.22,2.925),(5.39,2.925),(5.39,2.755),(5.22,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((2.835,0.605),(2.835,0.775),(3.005,0.775),(3.005,0.605),(2.835,0.605)),
        )
        createRL(
            tech, net, 'licon',
            ((5.56,2.755),(5.56,2.925),(5.73,2.925),(5.73,2.755),(5.56,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((0.815,2.755),(0.815,2.925),(0.985,2.925),(0.985,2.755),(0.815,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((4.415,0.945),(4.415,1.115),(4.585,1.115),(4.585,0.945),(4.415,0.945)),
        )
        createRL(
            tech, net, 'licon',
            ((2.835,2.305),(2.835,2.475),(3.005,2.475),(3.005,2.305),(2.835,2.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.855,2.755),(2.855,2.925),(3.025,2.925),(3.025,2.755),(2.855,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,0.945),(6.025,1.115),(6.195,1.115),(6.195,0.945),(6.025,0.945)),
        )
        createRL(
            tech, net, 'licon',
            ((2.175,2.755),(2.175,2.925),(2.345,2.925),(2.345,2.755),(2.175,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((2.515,2.755),(2.515,2.925),(2.685,2.925),(2.685,2.755),(2.515,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((2.835,1.965),(2.835,2.135),(3.005,2.135),(3.005,1.965),(2.835,1.965)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,2.755),(5.9,2.925),(6.07,2.925),(6.07,2.755),(5.9,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((0.475,0.155),(0.475,0.325),(0.645,0.325),(0.645,0.155),(0.475,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.815,0.155),(0.815,0.325),(0.985,0.325),(0.985,0.155),(0.815,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,0.605),(0.155,0.775),(0.325,0.775),(0.325,0.605),(0.155,0.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,1.285),(0.155,1.455),(0.325,1.455),(0.325,1.285),(0.155,1.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,1.625),(0.155,1.795),(0.325,1.795),(0.325,1.625),(0.155,1.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,2.305),(0.155,2.475),(0.325,2.475),(0.325,2.305),(0.155,2.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,1.965),(0.155,2.135),(0.325,2.135),(0.325,1.965),(0.155,1.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.135,2.755),(0.135,2.925),(0.305,2.925),(0.305,2.755),(0.135,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((1.155,2.755),(1.155,2.925),(1.325,2.925),(1.325,2.755),(1.155,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((1.495,2.755),(1.495,2.925),(1.665,2.925),(1.665,2.755),(1.495,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((2.835,0.945),(2.835,1.115),(3.005,1.115),(3.005,0.945),(2.835,0.945)),
        )
        createRL(
            tech, net, 'licon',
            ((4.415,0.605),(4.415,0.775),(4.585,0.775),(4.585,0.605),(4.415,0.605)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,2.755),(4.88,2.925),(5.05,2.925),(5.05,2.755),(4.88,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,0.605),(6.025,0.775),(6.195,0.775),(6.195,0.605),(6.025,0.605)),
        )
        createRL(
            tech, net, 'licon',
            ((4.415,1.285),(4.415,1.455),(4.585,1.455),(4.585,1.285),(4.415,1.285)),
        )
        createRL(
            tech, net, 'licon',
            ((4.415,1.625),(4.415,1.795),(4.585,1.795),(4.585,1.625),(4.415,1.625)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,1.285),(6.025,1.455),(6.195,1.455),(6.195,1.285),(6.025,1.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,1.625),(6.025,1.795),(6.195,1.795),(6.195,1.625),(6.025,1.625)),
        )
        createRL(
            tech, net, 'licon',
            ((4.415,1.965),(4.415,2.135),(4.585,2.135),(4.585,1.965),(4.415,1.965)),
        )
        createRL(
            tech, net, 'licon',
            ((2.835,1.285),(2.835,1.455),(3.005,1.455),(3.005,1.285),(2.835,1.285)),
        )
        createRL(
            tech, net, 'licon',
            ((2.835,1.625),(2.835,1.795),(3.005,1.795),(3.005,1.625),(2.835,1.625)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,1.965),(6.025,2.135),(6.195,2.135),(6.195,1.965),(6.025,1.965)),
        )
        createRL(
            tech, net, 'licon',
            ((4.415,2.305),(4.415,2.475),(4.585,2.475),(4.585,2.305),(4.415,2.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.855,0.155),(2.855,0.325),(3.025,0.325),(3.025,0.155),(2.855,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,2.305),(6.025,2.475),(6.195,2.475),(6.195,2.305),(6.025,2.305)),
        )
        createRL(
            tech, net, 'licon',
            ((1.835,2.755),(1.835,2.925),(2.005,2.925),(2.005,2.755),(1.835,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((4.54,2.755),(4.54,2.925),(4.71,2.925),(4.71,2.755),(4.54,2.755)),
        )
        createRL(
            tech, net, 'licon',
            ((2.515,0.155),(2.515,0.325),(2.685,0.325),(2.685,0.155),(2.515,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((2.175,0.155),(2.175,0.325),(2.345,0.325),(2.345,0.155),(2.175,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((5.22,0.155),(5.22,0.325),(5.39,0.325),(5.39,0.155),(5.22,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((5.56,0.155),(5.56,0.325),(5.73,0.325),(5.73,0.155),(5.56,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,0.155),(5.9,0.325),(6.07,0.325),(6.07,0.155),(5.9,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.135,0.155),(0.135,0.325),(0.305,0.325),(0.305,0.155),(0.135,0.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.475,2.755),(0.475,2.925),(0.645,2.925),(0.645,2.755),(0.475,2.755)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,0.0),(0.0,2.6),(0.48,2.6),(0.48,0.48),(2.68,0.48),(2.68,2.6),(0.0,2.6),(0.0,3.08),(3.16,3.08),(3.16,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'li',
            ((4.26,0.0),(4.26,2.6),(4.74,2.6),(4.74,0.48),(5.87,0.48),(5.87,2.6),(4.26,2.6),(4.26,3.08),(6.35,3.08),(6.35,0.0),(4.26,0.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.26,0.28),(4.26,0.45),(4.43,0.45),(4.43,0.28),(4.26,0.28)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.26,0.64),(4.26,0.81),(4.43,0.81),(4.43,0.64),(4.26,0.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.26,1.0),(4.26,1.17),(4.43,1.17),(4.43,1.0),(4.26,1.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.99,0.28),(2.99,0.45),(3.16,0.45),(3.16,0.28),(2.99,0.28)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.99,0.64),(2.99,0.81),(3.16,0.81),(3.16,0.64),(2.99,0.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.99,1.0),(2.99,1.17),(3.16,1.17),(3.16,1.0),(2.99,1.0)),
        )
        createRL(
            tech, net, 'm1',
            ((2.96,0.22),(2.96,1.23),(4.46,1.23),(4.46,0.22),(2.96,0.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m1.pin'),
            u(0.725), u(1.01), u(2.96), u(4.46),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m1'),
            u(0.725), u(1.01), u(2.96), u(4.46),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'nwm',
            ((-0.18,4.0),(-0.18,6.61),(6.53,6.61),(6.53,4.0),(-0.18,4.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,4.18),(0.0,5.95),(0.48,5.95),(0.48,4.66),(5.87,4.66),(5.87,5.95),(0.0,5.95),(0.0,6.43),(6.35,6.43),(6.35,4.18),(0.0,4.18)),
        )
        createRL(
            tech, net, 'licon',
            ((0.54,4.335),(0.54,4.505),(0.71,4.505),(0.71,4.335),(0.54,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((3.94,4.335),(3.94,4.505),(4.11,4.505),(4.11,4.335),(3.94,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,5.22),(6.025,5.39),(6.195,5.39),(6.195,5.22),(6.025,5.22)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,5.56),(6.025,5.73),(6.195,5.73),(6.195,5.56),(6.025,5.56)),
        )
        createRL(
            tech, net, 'licon',
            ((0.54,6.105),(0.54,6.275),(0.71,6.275),(0.71,6.105),(0.54,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((4.96,4.335),(4.96,4.505),(5.13,4.505),(5.13,4.335),(4.96,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((2.24,4.335),(2.24,4.505),(2.41,4.505),(2.41,4.335),(2.24,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((2.58,4.335),(2.58,4.505),(2.75,4.505),(2.75,4.335),(2.58,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((3.94,6.105),(3.94,6.275),(4.11,6.275),(4.11,6.105),(3.94,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((1.9,4.335),(1.9,4.505),(2.07,4.505),(2.07,4.335),(1.9,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((6.025,4.88),(6.025,5.05),(6.195,5.05),(6.195,4.88),(6.025,4.88)),
        )
        createRL(
            tech, net, 'licon',
            ((2.24,6.105),(2.24,6.275),(2.41,6.275),(2.41,6.105),(2.24,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((2.58,6.105),(2.58,6.275),(2.75,6.275),(2.75,6.105),(2.58,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,4.88),(0.155,5.05),(0.325,5.05),(0.325,4.88),(0.155,4.88)),
        )
        createRL(
            tech, net, 'licon',
            ((4.96,6.105),(4.96,6.275),(5.13,6.275),(5.13,6.105),(4.96,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((1.9,6.105),(1.9,6.275),(2.07,6.275),(2.07,6.105),(1.9,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((5.3,6.105),(5.3,6.275),(5.47,6.275),(5.47,6.105),(5.3,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((5.64,6.105),(5.64,6.275),(5.81,6.275),(5.81,6.105),(5.64,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((5.3,4.335),(5.3,4.505),(5.47,4.505),(5.47,4.335),(5.3,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((5.64,4.335),(5.64,4.505),(5.81,4.505),(5.81,4.335),(5.64,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((0.88,4.335),(0.88,4.505),(1.05,4.505),(1.05,4.335),(0.88,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((0.88,6.105),(0.88,6.275),(1.05,6.275),(1.05,6.105),(0.88,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.2,4.335),(0.2,4.505),(0.37,4.505),(0.37,4.335),(0.2,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((0.2,6.105),(0.2,6.275),(0.37,6.275),(0.37,6.105),(0.2,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((1.22,6.105),(1.22,6.275),(1.39,6.275),(1.39,6.105),(1.22,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((2.92,4.335),(2.92,4.505),(3.09,4.505),(3.09,4.335),(2.92,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,5.56),(0.155,5.73),(0.325,5.73),(0.325,5.56),(0.155,5.56)),
        )
        createRL(
            tech, net, 'licon',
            ((1.56,6.105),(1.56,6.275),(1.73,6.275),(1.73,6.105),(1.56,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((1.56,4.335),(1.56,4.505),(1.73,4.505),(1.73,4.335),(1.56,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((1.22,4.335),(1.22,4.505),(1.39,4.505),(1.39,4.335),(1.22,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((4.62,4.335),(4.62,4.505),(4.79,4.505),(4.79,4.335),(4.62,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((4.28,4.335),(4.28,4.505),(4.45,4.505),(4.45,4.335),(4.28,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((2.92,6.105),(2.92,6.275),(3.09,6.275),(3.09,6.105),(2.92,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((4.28,6.105),(4.28,6.275),(4.45,6.275),(4.45,6.105),(4.28,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((4.62,6.105),(4.62,6.275),(4.79,6.275),(4.79,6.105),(4.62,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((3.26,6.105),(3.26,6.275),(3.43,6.275),(3.43,6.105),(3.26,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((3.6,6.105),(3.6,6.275),(3.77,6.275),(3.77,6.105),(3.6,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((5.98,4.335),(5.98,4.505),(6.15,4.505),(6.15,4.335),(5.98,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((3.26,4.335),(3.26,4.505),(3.43,4.505),(3.43,4.335),(3.26,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((3.6,4.335),(3.6,4.505),(3.77,4.505),(3.77,4.335),(3.6,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((5.98,6.105),(5.98,6.275),(6.15,6.275),(6.15,6.105),(5.98,6.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,5.22),(0.155,5.39),(0.325,5.39),(0.325,5.22),(0.155,5.22)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,4.18),(0.0,5.95),(0.48,5.95),(0.48,4.66),(5.87,4.66),(5.87,5.95),(0.0,5.95),(0.0,6.43),(6.35,6.43),(6.35,4.18),(0.0,4.18)),
        )
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        nets['core'].setDirection(Net.Direction.IN)

    cell = new_cells['GuardRing_P18000W8728HFF']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-45.0), u(-21.82), u(45.0), u(21.82),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'conn': Net.create(cell, 'conn'),
        }
        net = nets['conn']
        createRL(
            tech, net, 'difftap',
            ((-45.0,-21.82),(-45.0,21.34),(-44.52,21.34),(-44.52,-21.34),(44.52,-21.34),(44.52,21.34),(-45.0,21.34),(-45.0,21.82),(45.0,21.82),(45.0,-21.82),(-45.0,-21.82)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,15.215),(44.675,15.385),(44.845,15.385),(44.845,15.215),(44.675,15.215)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,15.555),(44.675,15.725),(44.845,15.725),(44.845,15.555),(44.675,15.555)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-15.725),(44.675,-15.555),(44.845,-15.555),(44.845,-15.725),(44.675,-15.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-15.385),(44.675,-15.215),(44.845,-15.215),(44.845,-15.385),(44.675,-15.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.965,-21.665),(10.965,-21.495),(11.135,-21.495),(11.135,-21.665),(10.965,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((3.145,21.495),(3.145,21.665),(3.315,21.665),(3.315,21.495),(3.145,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.485,21.495),(3.485,21.665),(3.655,21.665),(3.655,21.495),(3.485,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.825,21.495),(3.825,21.665),(3.995,21.665),(3.995,21.495),(3.825,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.995,-21.665),(-3.995,-21.495),(-3.825,-21.495),(-3.825,-21.665),(-3.995,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.655,-21.665),(-3.655,-21.495),(-3.485,-21.495),(-3.485,-21.665),(-3.655,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.315,-21.665),(-3.315,-21.495),(-3.145,-21.495),(-3.145,-21.665),(-3.315,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.875,21.495),(-31.875,21.665),(-31.705,21.665),(-31.705,21.495),(-31.875,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.535,21.495),(-31.535,21.665),(-31.365,21.665),(-31.365,21.495),(-31.535,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.195,21.495),(-31.195,21.665),(-31.025,21.665),(-31.025,21.495),(-31.195,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,-21.665),(31.025,-21.495),(31.195,-21.495),(31.195,-21.665),(31.025,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.365,-21.665),(31.365,-21.495),(31.535,-21.495),(31.535,-21.665),(31.365,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.705,-21.665),(31.705,-21.495),(31.875,-21.495),(31.875,-21.665),(31.705,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-13.005),(44.675,-12.835),(44.845,-12.835),(44.845,-13.005),(44.675,-13.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-16.405),(44.675,-16.235),(44.845,-16.235),(44.845,-16.405),(44.675,-16.405)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.675,21.495),(-21.675,21.665),(-21.505,21.665),(-21.505,21.495),(-21.675,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.335,21.495),(-21.335,21.665),(-21.165,21.665),(-21.165,21.495),(-21.335,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.165,-21.665),(21.165,-21.495),(21.335,-21.495),(21.335,-21.665),(21.165,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.505,-21.665),(21.505,-21.495),(21.675,-21.495),(21.675,-21.665),(21.505,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,18.275),(44.675,18.445),(44.845,18.445),(44.845,18.275),(44.675,18.275)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,18.615),(44.675,18.785),(44.845,18.785),(44.845,18.615),(44.675,18.615)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-18.785),(44.675,-18.615),(44.845,-18.615),(44.845,-18.785),(44.675,-18.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-18.445),(44.675,-18.275),(44.845,-18.275),(44.845,-18.445),(44.675,-18.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.285,21.495),(44.285,21.665),(44.455,21.665),(44.455,21.495),(44.285,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.625,21.495),(44.625,21.665),(44.795,21.665),(44.795,21.495),(44.625,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.835,21.495),(-12.835,21.665),(-12.665,21.665),(-12.665,21.495),(-12.835,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.495,21.495),(-12.495,21.665),(-12.325,21.665),(-12.325,21.495),(-12.495,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.935,21.495),(-34.935,21.665),(-34.765,21.665),(-34.765,21.495),(-34.935,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.595,21.495),(-34.595,21.665),(-34.425,21.665),(-34.425,21.495),(-34.595,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.255,21.495),(-34.255,21.665),(-34.085,21.665),(-34.085,21.495),(-34.255,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.935,-21.665),(-34.935,-21.495),(-34.765,-21.495),(-34.765,-21.665),(-34.935,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.595,-21.665),(-34.595,-21.495),(-34.425,-21.495),(-34.425,-21.665),(-34.595,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.255,-21.665),(-34.255,-21.495),(-34.085,-21.495),(-34.085,-21.665),(-34.255,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.155,-21.665),(-29.155,-21.495),(-28.985,-21.495),(-28.985,-21.665),(-29.155,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.285,21.495),(10.285,21.665),(10.455,21.665),(10.455,21.495),(10.285,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.625,21.495),(10.625,21.665),(10.795,21.665),(10.795,21.495),(10.625,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.285,-21.665),(10.285,-21.495),(10.455,-21.495),(10.455,-21.665),(10.285,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.625,-21.665),(10.625,-21.495),(10.795,-21.495),(10.795,-21.665),(10.625,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((4.845,21.495),(4.845,21.665),(5.015,21.665),(5.015,21.495),(4.845,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,8.075),(44.675,8.245),(44.845,8.245),(44.845,8.075),(44.675,8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,8.415),(44.675,8.585),(44.845,8.585),(44.845,8.415),(44.675,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,8.755),(44.675,8.925),(44.845,8.925),(44.845,8.755),(44.675,8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.975,21.495),(-19.975,21.665),(-19.805,21.665),(-19.805,21.495),(-19.975,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.635,21.495),(-19.635,21.665),(-19.465,21.665),(-19.465,21.495),(-19.635,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.295,21.495),(-19.295,21.665),(-19.125,21.665),(-19.125,21.495),(-19.295,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,8.755),(-44.845,8.925),(-44.675,8.925),(-44.675,8.755),(-44.845,8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.115,21.495),(-44.115,21.665),(-43.945,21.665),(-43.945,21.495),(-44.115,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,8.075),(-44.845,8.245),(-44.675,8.245),(-44.675,8.075),(-44.845,8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,8.415),(-44.845,8.585),(-44.675,8.585),(-44.675,8.415),(-44.845,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((19.125,-21.665),(19.125,-21.495),(19.295,-21.495),(19.295,-21.665),(19.125,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.465,-21.665),(19.465,-21.495),(19.635,-21.495),(19.635,-21.665),(19.465,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.845,-21.665),(21.845,-21.495),(22.015,-21.495),(22.015,-21.665),(21.845,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.095,21.495),(-9.095,21.665),(-8.925,21.665),(-8.925,21.495),(-9.095,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.445,-21.665),(1.445,-21.495),(1.615,-21.495),(1.615,-21.665),(1.445,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,5.695),(-44.845,5.865),(-44.675,5.865),(-44.675,5.695),(-44.845,5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,5.015),(-44.845,5.185),(-44.675,5.185),(-44.675,5.015),(-44.845,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,5.355),(-44.845,5.525),(-44.675,5.525),(-44.675,5.355),(-44.845,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-5.865),(-44.845,-5.695),(-44.675,-5.695),(-44.675,-5.865),(-44.845,-5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-5.525),(-44.845,-5.355),(-44.675,-5.355),(-44.675,-5.525),(-44.845,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-5.185),(-44.845,-5.015),(-44.675,-5.015),(-44.675,-5.185),(-44.845,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,2.975),(44.675,3.145),(44.845,3.145),(44.845,2.975),(44.675,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,17.255),(-44.845,17.425),(-44.675,17.425),(-44.675,17.255),(-44.845,17.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,17.595),(-44.845,17.765),(-44.675,17.765),(-44.675,17.595),(-44.845,17.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-17.765),(-44.845,-17.595),(-44.675,-17.595),(-44.675,-17.765),(-44.845,-17.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-17.425),(-44.845,-17.255),(-44.675,-17.255),(-44.675,-17.425),(-44.845,-17.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.965,21.495),(10.965,21.665),(11.135,21.665),(11.135,21.495),(10.965,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.185,21.495),(39.185,21.665),(39.355,21.665),(39.355,21.495),(39.185,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.525,21.495),(39.525,21.665),(39.695,21.665),(39.695,21.495),(39.525,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.695,-21.665),(-39.695,-21.495),(-39.525,-21.495),(-39.525,-21.665),(-39.695,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.355,-21.665),(-39.355,-21.495),(-39.185,-21.495),(-39.185,-21.665),(-39.355,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((1.785,21.495),(1.785,21.665),(1.955,21.665),(1.955,21.495),(1.785,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.895,21.495),(-15.895,21.665),(-15.725,21.665),(-15.725,21.495),(-15.895,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.555,21.495),(-15.555,21.665),(-15.385,21.665),(-15.385,21.495),(-15.555,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.215,21.495),(-15.215,21.665),(-15.045,21.665),(-15.045,21.495),(-15.215,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.955,-21.665),(-1.955,-21.495),(-1.785,-21.495),(-1.785,-21.665),(-1.955,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.045,-21.665),(15.045,-21.495),(15.215,-21.495),(15.215,-21.665),(15.045,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.385,-21.665),(15.385,-21.495),(15.555,-21.495),(15.555,-21.665),(15.385,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.725,-21.665),(15.725,-21.495),(15.895,-21.495),(15.895,-21.665),(15.725,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.755,21.495),(-8.755,21.665),(-8.585,21.665),(-8.585,21.495),(-8.755,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.415,21.495),(-8.415,21.665),(-8.245,21.665),(-8.245,21.495),(-8.415,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.755,-21.665),(-8.755,-21.495),(-8.585,-21.495),(-8.585,-21.665),(-8.755,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.415,-21.665),(-8.415,-21.495),(-8.245,-21.495),(-8.245,-21.665),(-8.415,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-1.105),(44.675,-0.935),(44.845,-0.935),(44.845,-1.105),(44.675,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.955,21.495),(-18.955,21.665),(-18.785,21.665),(-18.785,21.495),(-18.955,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.615,21.495),(-18.615,21.665),(-18.445,21.665),(-18.445,21.495),(-18.615,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.275,21.495),(-18.275,21.665),(-18.105,21.665),(-18.105,21.495),(-18.275,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.955,-21.665),(-18.955,-21.495),(-18.785,-21.495),(-18.785,-21.665),(-18.955,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.615,-21.665),(-18.615,-21.495),(-18.445,-21.495),(-18.445,-21.665),(-18.615,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.275,-21.665),(-18.275,-21.495),(-18.105,-21.495),(-18.105,-21.665),(-18.275,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.015,-21.665),(-39.015,-21.495),(-38.845,-21.495),(-38.845,-21.665),(-39.015,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.975,21.495),(-36.975,21.665),(-36.805,21.665),(-36.805,21.495),(-36.975,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.635,21.495),(-36.635,21.665),(-36.465,21.665),(-36.465,21.495),(-36.635,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.295,21.495),(-36.295,21.665),(-36.125,21.665),(-36.125,21.495),(-36.295,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.975,-21.665),(-36.975,-21.495),(-36.805,-21.495),(-36.805,-21.665),(-36.975,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.635,-21.665),(-36.635,-21.495),(-36.465,-21.495),(-36.465,-21.665),(-36.635,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.295,-21.665),(-36.295,-21.495),(-36.125,-21.495),(-36.125,-21.665),(-36.295,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.545,-21.665),(23.545,-21.495),(23.715,-21.495),(23.715,-21.665),(23.545,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,9.095),(44.675,9.265),(44.845,9.265),(44.845,9.095),(44.675,9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,9.435),(44.675,9.605),(44.845,9.605),(44.845,9.435),(44.675,9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,9.775),(44.675,9.945),(44.845,9.945),(44.845,9.775),(44.675,9.775)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-9.945),(44.675,-9.775),(44.845,-9.775),(44.845,-9.945),(44.675,-9.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-9.605),(44.675,-9.435),(44.845,-9.435),(44.845,-9.605),(44.675,-9.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-9.265),(44.675,-9.095),(44.845,-9.095),(44.845,-9.265),(44.675,-9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.655,21.495),(-20.655,21.665),(-20.485,21.665),(-20.485,21.495),(-20.655,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.315,21.495),(-20.315,21.665),(-20.145,21.665),(-20.145,21.495),(-20.315,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.995,21.495),(-20.995,21.665),(-20.825,21.665),(-20.825,21.495),(-20.995,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.995,-21.665),(-20.995,-21.495),(-20.825,-21.495),(-20.825,-21.665),(-20.995,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,20.315),(-44.845,20.485),(-44.675,20.485),(-44.675,20.315),(-44.845,20.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,20.655),(-44.845,20.825),(-44.675,20.825),(-44.675,20.655),(-44.845,20.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.655,-21.665),(-20.655,-21.495),(-20.485,-21.495),(-20.485,-21.665),(-20.655,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.315,-21.665),(-20.315,-21.495),(-20.145,-21.495),(-20.145,-21.665),(-20.315,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.935,21.495),(-0.935,21.665),(-0.765,21.665),(-0.765,21.495),(-0.935,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,3.995),(44.675,4.165),(44.845,4.165),(44.845,3.995),(44.675,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.935,-21.665),(-0.935,-21.495),(-0.765,-21.495),(-0.765,-21.665),(-0.935,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-20.825),(44.675,-20.655),(44.845,-20.655),(44.845,-20.825),(44.675,-20.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-20.485),(44.675,-20.315),(44.845,-20.315),(44.845,-20.485),(44.675,-20.485)),
        )
        createRL(
            tech, net, 'licon',
            ((2.805,-21.665),(2.805,-21.495),(2.975,-21.495),(2.975,-21.665),(2.805,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-0.765),(-44.845,-0.595),(-44.675,-0.595),(-44.675,-0.765),(-44.845,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-0.765),(44.675,-0.595),(44.845,-0.595),(44.845,-0.765),(44.675,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,15.895),(44.675,16.065),(44.845,16.065),(44.845,15.895),(44.675,15.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,3.655),(-44.845,3.825),(-44.675,3.825),(-44.675,3.655),(-44.845,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,3.315),(-44.845,3.485),(-44.675,3.485),(-44.675,3.315),(-44.845,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-3.825),(-44.845,-3.655),(-44.675,-3.655),(-44.675,-3.825),(-44.845,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-3.485),(-44.845,-3.315),(-44.675,-3.315),(-44.675,-3.485),(-44.845,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-3.145),(-44.845,-2.975),(-44.675,-2.975),(-44.675,-3.145),(-44.845,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.015,21.495),(-5.015,21.665),(-4.845,21.665),(-4.845,21.495),(-5.015,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-17.085),(44.675,-16.915),(44.845,-16.915),(44.845,-17.085),(44.675,-17.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,13.175),(44.675,13.345),(44.845,13.345),(44.845,13.175),(44.675,13.175)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,13.515),(44.675,13.685),(44.845,13.685),(44.845,13.515),(44.675,13.515)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-13.685),(44.675,-13.515),(44.845,-13.515),(44.845,-13.685),(44.675,-13.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-13.345),(44.675,-13.175),(44.845,-13.175),(44.845,-13.345),(44.675,-13.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,18.955),(44.675,19.125),(44.845,19.125),(44.845,18.955),(44.675,18.955)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-18.105),(44.675,-17.935),(44.845,-17.935),(44.845,-18.105),(44.675,-18.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.355,21.495),(-5.355,21.665),(-5.185,21.665),(-5.185,21.495),(-5.355,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.695,21.495),(-5.695,21.665),(-5.525,21.665),(-5.525,21.495),(-5.695,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.205,21.495),(40.205,21.665),(40.375,21.665),(40.375,21.495),(40.205,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.545,21.495),(40.545,21.665),(40.715,21.665),(40.715,21.495),(40.545,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,1.615),(44.675,1.785),(44.845,1.785),(44.845,1.615),(44.675,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-1.785),(44.675,-1.615),(44.845,-1.615),(44.845,-1.785),(44.675,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((5.185,-21.665),(5.185,-21.495),(5.355,-21.495),(5.355,-21.665),(5.185,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((5.525,-21.665),(5.525,-21.495),(5.695,-21.495),(5.695,-21.665),(5.525,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.205,-21.665),(40.205,-21.495),(40.375,-21.495),(40.375,-21.665),(40.205,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.545,-21.665),(40.545,-21.495),(40.715,-21.495),(40.715,-21.665),(40.545,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.305,21.495),(28.305,21.665),(28.475,21.665),(28.475,21.495),(28.305,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.645,21.495),(28.645,21.665),(28.815,21.665),(28.815,21.495),(28.645,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.305,-21.665),(28.305,-21.495),(28.475,-21.495),(28.475,-21.665),(28.305,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.645,-21.665),(28.645,-21.495),(28.815,-21.495),(28.815,-21.665),(28.645,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.055,-21.665),(-41.055,-21.495),(-40.885,-21.495),(-40.885,-21.665),(-41.055,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,15.215),(-44.845,15.385),(-44.675,15.385),(-44.675,15.215),(-44.845,15.215)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,15.555),(-44.845,15.725),(-44.675,15.725),(-44.675,15.555),(-44.845,15.555)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-15.725),(-44.845,-15.555),(-44.675,-15.555),(-44.675,-15.725),(-44.845,-15.725)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-15.385),(-44.845,-15.215),(-44.675,-15.215),(-44.675,-15.385),(-44.845,-15.385)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.035,-21.665),(-40.035,-21.495),(-39.865,-21.495),(-39.865,-21.665),(-40.035,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-4.165),(44.675,-3.995),(44.845,-3.995),(44.845,-4.165),(44.675,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.975,21.495),(-2.975,21.665),(-2.805,21.665),(-2.805,21.495),(-2.975,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.635,21.495),(-2.635,21.665),(-2.465,21.665),(-2.465,21.495),(-2.635,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.295,21.495),(-2.295,21.665),(-2.125,21.665),(-2.125,21.495),(-2.295,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.975,-21.665),(-2.975,-21.495),(-2.805,-21.495),(-2.805,-21.665),(-2.975,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.635,-21.665),(-2.635,-21.495),(-2.465,-21.495),(-2.465,-21.665),(-2.635,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.295,-21.665),(-2.295,-21.495),(-2.125,-21.495),(-2.125,-21.665),(-2.295,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.075,-21.665),(-25.075,-21.495),(-24.905,-21.495),(-24.905,-21.665),(-25.075,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.865,-21.665),(39.865,-21.495),(40.035,-21.495),(40.035,-21.665),(39.865,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-0.425),(-44.845,-0.255),(-44.675,-0.255),(-44.675,-0.425),(-44.845,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-0.425),(44.675,-0.255),(44.845,-0.255),(44.845,-0.425),(44.675,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.995,21.495),(-3.995,21.665),(-3.825,21.665),(-3.825,21.495),(-3.995,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.655,21.495),(-3.655,21.665),(-3.485,21.665),(-3.485,21.495),(-3.655,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.315,21.495),(-3.315,21.665),(-3.145,21.665),(-3.145,21.495),(-3.315,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.145,-21.665),(3.145,-21.495),(3.315,-21.495),(3.315,-21.665),(3.145,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((3.485,-21.665),(3.485,-21.495),(3.655,-21.495),(3.655,-21.665),(3.485,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.135,21.495),(-28.135,21.665),(-27.965,21.665),(-27.965,21.495),(-28.135,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.055,-21.665),(-24.055,-21.495),(-23.885,-21.495),(-23.885,-21.665),(-24.055,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((3.825,-21.665),(3.825,-21.495),(3.995,-21.495),(3.995,-21.665),(3.825,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((5.865,-21.665),(5.865,-21.495),(6.035,-21.495),(6.035,-21.665),(5.865,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.045,-21.665),(32.045,-21.495),(32.215,-21.495),(32.215,-21.665),(32.045,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.725,-21.665),(32.725,-21.495),(32.895,-21.495),(32.895,-21.665),(32.725,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,6.375),(-44.845,6.545),(-44.675,6.545),(-44.675,6.375),(-44.845,6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,6.035),(-44.845,6.205),(-44.675,6.205),(-44.675,6.035),(-44.845,6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,6.715),(-44.845,6.885),(-44.675,6.885),(-44.675,6.715),(-44.845,6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-6.885),(-44.845,-6.715),(-44.675,-6.715),(-44.675,-6.885),(-44.845,-6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-6.545),(-44.845,-6.375),(-44.675,-6.375),(-44.675,-6.545),(-44.845,-6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-6.205),(-44.845,-6.035),(-44.675,-6.035),(-44.675,-6.205),(-44.845,-6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,14.195),(44.675,14.365),(44.845,14.365),(44.845,14.195),(44.675,14.195)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,14.535),(44.675,14.705),(44.845,14.705),(44.845,14.535),(44.675,14.535)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-14.705),(44.675,-14.535),(44.845,-14.535),(44.845,-14.705),(44.675,-14.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-14.365),(44.675,-14.195),(44.845,-14.195),(44.845,-14.365),(44.675,-14.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.085,21.495),(34.085,21.665),(34.255,21.665),(34.255,21.495),(34.085,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.425,21.495),(34.425,21.665),(34.595,21.665),(34.595,21.495),(34.425,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.765,21.495),(34.765,21.665),(34.935,21.665),(34.935,21.495),(34.765,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.085,-21.665),(34.085,-21.495),(34.255,-21.495),(34.255,-21.665),(34.085,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.425,-21.665),(34.425,-21.495),(34.595,-21.495),(34.595,-21.665),(34.425,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.765,-21.665),(34.765,-21.495),(34.935,-21.495),(34.935,-21.665),(34.765,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,16.235),(44.675,16.405),(44.845,16.405),(44.845,16.235),(44.675,16.235)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,16.575),(44.675,16.745),(44.845,16.745),(44.845,16.575),(44.675,16.575)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,16.235),(-44.845,16.405),(-44.675,16.405),(-44.675,16.235),(-44.845,16.235)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,16.575),(-44.845,16.745),(-44.675,16.745),(-44.675,16.575),(-44.845,16.575)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-17.085),(-44.845,-16.915),(-44.675,-16.915),(-44.675,-17.085),(-44.845,-17.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.065,21.495),(33.065,21.665),(33.235,21.665),(33.235,21.495),(33.065,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.405,21.495),(33.405,21.665),(33.575,21.665),(33.575,21.495),(33.405,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.745,21.495),(33.745,21.665),(33.915,21.665),(33.915,21.495),(33.745,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.235,-21.665),(-33.235,-21.495),(-33.065,-21.495),(-33.065,-21.665),(-33.235,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.915,-21.665),(-33.915,-21.495),(-33.745,-21.495),(-33.745,-21.665),(-33.915,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.575,-21.665),(-33.575,-21.495),(-33.405,-21.495),(-33.405,-21.665),(-33.575,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,19.975),(44.675,20.145),(44.845,20.145),(44.845,19.975),(44.675,19.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.205,21.495),(23.205,21.665),(23.375,21.665),(23.375,21.495),(23.205,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.545,21.495),(23.545,21.665),(23.715,21.665),(23.715,21.495),(23.545,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.715,-21.665),(-23.715,-21.495),(-23.545,-21.495),(-23.545,-21.665),(-23.715,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.375,-21.665),(-23.375,-21.495),(-23.205,-21.495),(-23.205,-21.665),(-23.375,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.945,-21.665),(43.945,-21.495),(44.115,-21.495),(44.115,-21.665),(43.945,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,20.315),(44.675,20.485),(44.845,20.485),(44.845,20.315),(44.675,20.315)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,20.655),(44.675,20.825),(44.845,20.825),(44.845,20.655),(44.675,20.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-20.825),(-44.845,-20.655),(-44.675,-20.655),(-44.675,-20.825),(-44.845,-20.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-20.485),(-44.845,-20.315),(-44.675,-20.315),(-44.675,-20.485),(-44.845,-20.485)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-19.125),(-44.845,-18.955),(-44.675,-18.955),(-44.675,-19.125),(-44.845,-19.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.965,-21.665),(27.965,-21.495),(28.135,-21.495),(28.135,-21.665),(27.965,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((41.225,21.495),(41.225,21.665),(41.395,21.665),(41.395,21.495),(41.225,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.565,21.495),(41.565,21.665),(41.735,21.665),(41.735,21.495),(41.565,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.735,-21.665),(-41.735,-21.495),(-41.565,-21.495),(-41.565,-21.665),(-41.735,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.395,-21.665),(-41.395,-21.495),(-41.225,-21.495),(-41.225,-21.665),(-41.395,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.035,21.495),(-40.035,21.665),(-39.865,21.665),(-39.865,21.495),(-40.035,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,17.255),(44.675,17.425),(44.845,17.425),(44.845,17.255),(44.675,17.255)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,17.595),(44.675,17.765),(44.845,17.765),(44.845,17.595),(44.675,17.595)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-17.765),(44.675,-17.595),(44.845,-17.595),(44.845,-17.765),(44.675,-17.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.035,-21.665),(-23.035,-21.495),(-22.865,-21.495),(-22.865,-21.665),(-23.035,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-17.425),(44.675,-17.255),(44.845,-17.255),(44.845,-17.425),(44.675,-17.425)),
        )
        createRL(
            tech, net, 'licon',
            ((4.845,-21.665),(4.845,-21.495),(5.015,-21.495),(5.015,-21.665),(4.845,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.175,21.495),(-30.175,21.665),(-30.005,21.665),(-30.005,21.495),(-30.175,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,12.495),(-44.845,12.665),(-44.675,12.665),(-44.675,12.495),(-44.845,12.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.855,21.495),(-30.855,21.665),(-30.685,21.665),(-30.685,21.495),(-30.855,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.515,21.495),(-30.515,21.665),(-30.345,21.665),(-30.345,21.495),(-30.515,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,12.155),(-44.845,12.325),(-44.675,12.325),(-44.675,12.155),(-44.845,12.155)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.855,-21.665),(-30.855,-21.495),(-30.685,-21.495),(-30.685,-21.665),(-30.855,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.515,-21.665),(-30.515,-21.495),(-30.345,-21.495),(-30.345,-21.665),(-30.515,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.175,-21.665),(-30.175,-21.495),(-30.005,-21.495),(-30.005,-21.665),(-30.175,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-12.665),(44.675,-12.495),(44.845,-12.495),(44.845,-12.665),(44.675,-12.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-12.325),(44.675,-12.155),(44.845,-12.155),(44.845,-12.325),(44.675,-12.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.245,21.495),(25.245,21.665),(25.415,21.665),(25.415,21.495),(25.245,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.585,21.495),(25.585,21.665),(25.755,21.665),(25.755,21.495),(25.585,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.695,21.495),(-39.695,21.665),(-39.525,21.665),(-39.525,21.495),(-39.695,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.355,21.495),(-39.355,21.665),(-39.185,21.665),(-39.185,21.495),(-39.355,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.755,-21.665),(-25.755,-21.495),(-25.585,-21.495),(-25.585,-21.665),(-25.755,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.055,21.495),(-24.055,21.665),(-23.885,21.665),(-23.885,21.495),(-24.055,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.415,-21.665),(-25.415,-21.495),(-25.245,-21.495),(-25.245,-21.665),(-25.415,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.185,-21.665),(39.185,-21.495),(39.355,-21.495),(39.355,-21.665),(39.185,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.525,-21.665),(39.525,-21.495),(39.695,-21.495),(39.695,-21.665),(39.525,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,20.995),(-44.845,21.165),(-44.675,21.165),(-44.675,20.995),(-44.845,20.995)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-20.145),(44.675,-19.975),(44.845,-19.975),(44.845,-20.145),(44.675,-20.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.955,21.495),(-1.955,21.665),(-1.785,21.665),(-1.785,21.495),(-1.955,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.785,-21.665),(1.785,-21.495),(1.955,-21.495),(1.955,-21.665),(1.785,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.675,21.495),(-4.675,21.665),(-4.505,21.665),(-4.505,21.495),(-4.675,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.335,21.495),(-4.335,21.665),(-4.165,21.665),(-4.165,21.495),(-4.335,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.675,-21.665),(-4.675,-21.495),(-4.505,-21.495),(-4.505,-21.665),(-4.675,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.115,-21.665),(-44.115,-21.495),(-43.945,-21.495),(-43.945,-21.665),(-44.115,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.335,-21.665),(-4.335,-21.495),(-4.165,-21.495),(-4.165,-21.665),(-4.335,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-2.125),(44.675,-1.955),(44.845,-1.955),(44.845,-2.125),(44.675,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-4.165),(-44.845,-3.995),(-44.675,-3.995),(-44.675,-4.165),(-44.845,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.105,21.495),(18.105,21.665),(18.275,21.665),(18.275,21.495),(18.105,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.445,21.495),(18.445,21.665),(18.615,21.665),(18.615,21.495),(18.445,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.785,21.495),(18.785,21.665),(18.955,21.665),(18.955,21.495),(18.785,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,13.855),(-44.845,14.025),(-44.675,14.025),(-44.675,13.855),(-44.845,13.855)),
        )
        createRL(
            tech, net, 'licon',
            ((18.105,-21.665),(18.105,-21.495),(18.275,-21.495),(18.275,-21.665),(18.105,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.445,-21.665),(18.445,-21.495),(18.615,-21.495),(18.615,-21.665),(18.445,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.785,-21.665),(18.785,-21.495),(18.955,-21.495),(18.955,-21.665),(18.785,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.615,-21.665),(-1.615,-21.495),(-1.445,-21.495),(-1.445,-21.665),(-1.615,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((24.225,21.495),(24.225,21.665),(24.395,21.665),(24.395,21.495),(24.225,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.565,21.495),(24.565,21.665),(24.735,21.665),(24.735,21.495),(24.565,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.225,-21.665),(24.225,-21.495),(24.395,-21.495),(24.395,-21.665),(24.225,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((24.565,-21.665),(24.565,-21.495),(24.735,-21.495),(24.735,-21.665),(24.565,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((12.325,21.495),(12.325,21.665),(12.495,21.665),(12.495,21.495),(12.325,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.665,21.495),(12.665,21.665),(12.835,21.665),(12.835,21.495),(12.665,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.325,-21.665),(12.325,-21.495),(12.495,-21.495),(12.495,-21.665),(12.325,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((12.665,-21.665),(12.665,-21.495),(12.835,-21.495),(12.835,-21.665),(12.665,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,15.895),(-44.845,16.065),(-44.675,16.065),(-44.675,15.895),(-44.845,15.895)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-16.745),(44.675,-16.575),(44.845,-16.575),(44.845,-16.745),(44.675,-16.745)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.095,-21.665),(-9.095,-21.495),(-8.925,-21.495),(-8.925,-21.665),(-9.095,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.885,-21.665),(23.885,-21.495),(24.055,-21.495),(24.055,-21.665),(23.885,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-2.125),(-44.845,-1.955),(-44.675,-1.955),(-44.675,-2.125),(-44.845,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.155,21.495),(-12.155,21.665),(-11.985,21.665),(-11.985,21.495),(-12.155,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.075,-21.665),(-8.075,-21.495),(-7.905,-21.495),(-7.905,-21.665),(-8.075,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.875,21.495),(-14.875,21.665),(-14.705,21.665),(-14.705,21.495),(-14.875,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.535,21.495),(-14.535,21.665),(-14.365,21.665),(-14.365,21.495),(-14.535,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.195,21.495),(-14.195,21.665),(-14.025,21.665),(-14.025,21.495),(-14.195,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.875,-21.665),(-14.875,-21.495),(-14.705,-21.495),(-14.705,-21.665),(-14.875,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.535,-21.665),(-14.535,-21.495),(-14.365,-21.495),(-14.365,-21.665),(-14.535,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.195,-21.665),(-14.195,-21.495),(-14.025,-21.495),(-14.025,-21.665),(-14.195,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,14.875),(44.675,15.045),(44.845,15.045),(44.845,14.875),(44.675,14.875)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-0.085),(-44.845,0.085),(-44.675,0.085),(-44.675,-0.085),(-44.845,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-0.085),(44.675,0.085),(44.845,0.085),(44.845,-0.085),(44.675,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-14.025),(44.675,-13.855),(44.845,-13.855),(44.845,-14.025),(44.675,-14.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,2.295),(44.675,2.465),(44.845,2.465),(44.845,2.295),(44.675,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,2.635),(44.675,2.805),(44.845,2.805),(44.845,2.635),(44.675,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-2.805),(44.675,-2.635),(44.845,-2.635),(44.845,-2.805),(44.675,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-2.465),(44.675,-2.295),(44.845,-2.295),(44.845,-2.465),(44.675,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,5.015),(44.675,5.185),(44.845,5.185),(44.845,5.015),(44.675,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,5.355),(44.675,5.525),(44.845,5.525),(44.845,5.355),(44.675,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,5.695),(44.675,5.865),(44.845,5.865),(44.845,5.695),(44.675,5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-5.865),(44.675,-5.695),(44.845,-5.695),(44.845,-5.865),(44.675,-5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-5.525),(44.675,-5.355),(44.845,-5.355),(44.845,-5.525),(44.675,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-5.185),(44.675,-5.015),(44.845,-5.015),(44.845,-5.185),(44.675,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,16.915),(44.675,17.085),(44.845,17.085),(44.845,16.915),(44.675,16.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,10.795),(-44.845,10.965),(-44.675,10.965),(-44.675,10.795),(-44.845,10.795)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,16.915),(-44.845,17.085),(-44.675,17.085),(-44.675,16.915),(-44.845,16.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,10.115),(-44.845,10.285),(-44.675,10.285),(-44.675,10.115),(-44.845,10.115)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,10.455),(-44.845,10.625),(-44.675,10.625),(-44.675,10.455),(-44.845,10.455)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-10.965),(-44.845,-10.795),(-44.675,-10.795),(-44.675,-10.965),(-44.845,-10.965)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-10.625),(-44.845,-10.455),(-44.675,-10.455),(-44.675,-10.625),(-44.845,-10.625)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-10.285),(-44.845,-10.115),(-44.675,-10.115),(-44.675,-10.285),(-44.845,-10.285)),
        )
        createRL(
            tech, net, 'licon',
            ((41.905,21.495),(41.905,21.665),(42.075,21.665),(42.075,21.495),(41.905,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,19.295),(44.675,19.465),(44.845,19.465),(44.845,19.295),(44.675,19.295)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,19.635),(44.675,19.805),(44.845,19.805),(44.845,19.635),(44.675,19.635)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-19.805),(44.675,-19.635),(44.845,-19.635),(44.845,-19.805),(44.675,-19.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-19.465),(44.675,-19.295),(44.845,-19.295),(44.845,-19.465),(44.675,-19.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,12.495),(44.675,12.665),(44.845,12.665),(44.845,12.495),(44.675,12.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,12.155),(44.675,12.325),(44.845,12.325),(44.845,12.155),(44.675,12.155)),
        )
        createRL(
            tech, net, 'licon',
            ((2.125,21.495),(2.125,21.665),(2.295,21.665),(2.295,21.495),(2.125,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.465,21.495),(2.465,21.665),(2.635,21.665),(2.635,21.495),(2.465,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.805,21.495),(2.805,21.665),(2.975,21.665),(2.975,21.495),(2.805,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-12.665),(-44.845,-12.495),(-44.675,-12.495),(-44.675,-12.665),(-44.845,-12.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-12.325),(-44.845,-12.155),(-44.675,-12.155),(-44.675,-12.325),(-44.845,-12.325)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.075,-21.665),(-42.075,-21.495),(-41.905,-21.495),(-41.905,-21.665),(-42.075,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((2.125,-21.665),(2.125,-21.495),(2.295,-21.495),(2.295,-21.665),(2.125,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((2.465,-21.665),(2.465,-21.495),(2.635,-21.495),(2.635,-21.665),(2.465,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.225,21.495),(7.225,21.665),(7.395,21.665),(7.395,21.495),(7.225,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.565,21.495),(7.565,21.665),(7.735,21.665),(7.735,21.495),(7.565,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.735,-21.665),(-7.735,-21.495),(-7.565,-21.495),(-7.565,-21.665),(-7.735,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.395,-21.665),(-7.395,-21.495),(-7.225,-21.495),(-7.225,-21.665),(-7.395,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.925,21.495),(25.925,21.665),(26.095,21.665),(26.095,21.495),(25.925,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.015,21.495),(-39.015,21.665),(-38.845,21.665),(-38.845,21.495),(-39.015,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,20.995),(44.675,21.165),(44.845,21.165),(44.845,20.995),(44.675,20.995)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-20.145),(-44.845,-19.975),(-44.675,-19.975),(-44.675,-20.145),(-44.845,-20.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.865,21.495),(39.865,21.665),(40.035,21.665),(40.035,21.495),(39.865,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.985,-21.665),(11.985,-21.495),(12.155,-21.495),(12.155,-21.665),(11.985,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.385,-21.665),(32.385,-21.495),(32.555,-21.495),(32.555,-21.665),(32.385,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.015,-21.665),(-22.015,-21.495),(-21.845,-21.495),(-21.845,-21.665),(-22.015,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.045,21.495),(32.045,21.665),(32.215,21.665),(32.215,21.495),(32.045,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.385,21.495),(32.385,21.665),(32.555,21.665),(32.555,21.495),(32.385,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.725,21.495),(32.725,21.665),(32.895,21.665),(32.895,21.495),(32.725,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.595,21.495),(-0.595,21.665),(-0.425,21.665),(-0.425,21.495),(-0.595,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.895,21.495),(-32.895,21.665),(-32.725,21.665),(-32.725,21.495),(-32.895,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.555,21.495),(-32.555,21.665),(-32.385,21.665),(-32.385,21.495),(-32.555,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.215,21.495),(-32.215,21.665),(-32.045,21.665),(-32.045,21.495),(-32.215,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.895,-21.665),(-32.895,-21.495),(-32.725,-21.495),(-32.725,-21.665),(-32.895,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.555,-21.665),(-32.555,-21.495),(-32.385,-21.495),(-32.385,-21.665),(-32.555,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.215,-21.665),(-32.215,-21.495),(-32.045,-21.495),(-32.045,-21.665),(-32.215,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.415,21.495),(-42.415,21.665),(-42.245,21.665),(-42.245,21.495),(-42.415,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,0.255),(44.675,0.425),(44.845,0.425),(44.845,0.255),(44.675,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.755,21.495),(-42.755,21.665),(-42.585,21.665),(-42.585,21.495),(-42.755,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,0.255),(-44.845,0.425),(-44.675,0.425),(-44.675,0.255),(-44.845,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,1.275),(-44.845,1.445),(-44.675,1.445),(-44.675,1.275),(-44.845,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-1.445),(-44.845,-1.275),(-44.675,-1.275),(-44.675,-1.445),(-44.845,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.755,-21.665),(-42.755,-21.495),(-42.585,-21.495),(-42.585,-21.665),(-42.755,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,12.835),(-44.845,13.005),(-44.675,13.005),(-44.675,12.835),(-44.845,12.835)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.415,-21.665),(-42.415,-21.495),(-42.245,-21.495),(-42.245,-21.665),(-42.415,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.055,-21.665),(-7.055,-21.495),(-6.885,-21.495),(-6.885,-21.665),(-7.055,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.915,21.495),(-33.915,21.665),(-33.745,21.665),(-33.745,21.495),(-33.915,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.575,21.495),(-33.575,21.665),(-33.405,21.665),(-33.405,21.495),(-33.575,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.465,21.495),(36.465,21.665),(36.635,21.665),(36.635,21.495),(36.465,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.805,21.495),(36.805,21.665),(36.975,21.665),(36.975,21.495),(36.805,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.125,21.495),(36.125,21.665),(36.295,21.665),(36.295,21.495),(36.125,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.235,21.495),(-33.235,21.665),(-33.065,21.665),(-33.065,21.495),(-33.235,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.065,-21.665),(33.065,-21.495),(33.235,-21.495),(33.235,-21.665),(33.065,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.405,-21.665),(33.405,-21.495),(33.575,-21.495),(33.575,-21.665),(33.405,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.745,-21.665),(33.745,-21.495),(33.915,-21.495),(33.915,-21.665),(33.745,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((36.125,-21.665),(36.125,-21.495),(36.295,-21.495),(36.295,-21.665),(36.125,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((36.465,-21.665),(36.465,-21.495),(36.635,-21.495),(36.635,-21.665),(36.465,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((36.805,-21.665),(36.805,-21.495),(36.975,-21.495),(36.975,-21.665),(36.805,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.265,21.495),(9.265,21.665),(9.435,21.665),(9.435,21.495),(9.265,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.605,21.495),(9.605,21.665),(9.775,21.665),(9.775,21.495),(9.605,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.715,21.495),(-23.715,21.665),(-23.545,21.665),(-23.545,21.495),(-23.715,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.375,21.495),(-23.375,21.665),(-23.205,21.665),(-23.205,21.495),(-23.375,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.775,-21.665),(-9.775,-21.495),(-9.605,-21.495),(-9.605,-21.665),(-9.775,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.075,21.495),(-8.075,21.665),(-7.905,21.665),(-7.905,21.495),(-8.075,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.675,21.495),(-38.675,21.665),(-38.505,21.665),(-38.505,21.495),(-38.675,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.335,21.495),(-38.335,21.665),(-38.165,21.665),(-38.165,21.495),(-38.335,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.675,-21.665),(-38.675,-21.495),(-38.505,-21.495),(-38.505,-21.665),(-38.675,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.335,-21.665),(-38.335,-21.495),(-38.165,-21.495),(-38.165,-21.665),(-38.335,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-15.045),(44.675,-14.875),(44.845,-14.875),(44.845,-15.045),(44.675,-15.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.145,21.495),(20.145,21.665),(20.315,21.665),(20.315,21.495),(20.145,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.485,21.495),(20.485,21.665),(20.655,21.665),(20.655,21.495),(20.485,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.825,21.495),(20.825,21.665),(20.995,21.665),(20.995,21.495),(20.825,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.135,-21.665),(-28.135,-21.495),(-27.965,-21.495),(-27.965,-21.665),(-28.135,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.145,-21.665),(20.145,-21.495),(20.315,-21.495),(20.315,-21.665),(20.145,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.485,-21.665),(20.485,-21.495),(20.655,-21.495),(20.655,-21.665),(20.485,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.825,-21.665),(20.825,-21.495),(20.995,-21.495),(20.995,-21.665),(20.825,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.945,21.495),(43.945,21.665),(44.115,21.665),(44.115,21.495),(43.945,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.085,21.495),(0.085,21.665),(0.255,21.665),(0.255,21.495),(0.085,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,3.995),(-44.845,4.165),(-44.675,4.165),(-44.675,3.995),(-44.845,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((0.085,-21.665),(0.085,-21.495),(0.255,-21.495),(0.255,-21.665),(0.085,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.015,-21.665),(-5.015,-21.495),(-4.845,-21.495),(-4.845,-21.665),(-5.015,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.355,21.495),(-22.355,21.665),(-22.185,21.665),(-22.185,21.495),(-22.355,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.695,21.495),(-22.695,21.665),(-22.525,21.665),(-22.525,21.495),(-22.695,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.325,21.495),(29.325,21.665),(29.495,21.665),(29.495,21.495),(29.325,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.665,21.495),(29.665,21.665),(29.835,21.665),(29.835,21.495),(29.665,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.835,-21.665),(-29.835,-21.495),(-29.665,-21.495),(-29.665,-21.665),(-29.835,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.495,-21.665),(-29.495,-21.495),(-29.325,-21.495),(-29.325,-21.665),(-29.495,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.695,-21.665),(-22.695,-21.495),(-22.525,-21.495),(-22.525,-21.665),(-22.695,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.095,21.495),(-43.095,21.665),(-42.925,21.665),(-42.925,21.495),(-43.095,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.355,-21.665),(-22.355,-21.495),(-22.185,-21.495),(-22.185,-21.665),(-22.355,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((17.085,21.495),(17.085,21.665),(17.255,21.665),(17.255,21.495),(17.085,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.425,21.495),(17.425,21.665),(17.595,21.665),(17.595,21.495),(17.425,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.765,21.495),(17.765,21.665),(17.935,21.665),(17.935,21.495),(17.765,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.935,-21.665),(-17.935,-21.495),(-17.765,-21.495),(-17.765,-21.665),(-17.935,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.595,-21.665),(-17.595,-21.495),(-17.425,-21.495),(-17.425,-21.665),(-17.595,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.255,-21.665),(-17.255,-21.495),(-17.085,-21.495),(-17.085,-21.665),(-17.255,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.625,-21.665),(44.625,-21.495),(44.795,-21.495),(44.795,-21.665),(44.625,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.965,21.495),(27.965,21.665),(28.135,21.665),(28.135,21.495),(27.965,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-21.165),(-44.845,-20.995),(-44.675,-20.995),(-44.675,-21.165),(-44.845,-21.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.735,21.495),(-41.735,21.665),(-41.565,21.665),(-41.565,21.495),(-41.735,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.395,21.495),(-41.395,21.665),(-41.225,21.665),(-41.225,21.495),(-41.395,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.805,-21.665),(19.805,-21.495),(19.975,-21.495),(19.975,-21.665),(19.805,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((41.225,-21.665),(41.225,-21.495),(41.395,-21.495),(41.395,-21.665),(41.225,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((41.565,-21.665),(41.565,-21.495),(41.735,-21.495),(41.735,-21.665),(41.565,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.265,21.495),(43.265,21.665),(43.435,21.665),(43.435,21.495),(43.265,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.605,21.495),(43.605,21.665),(43.775,21.665),(43.775,21.495),(43.605,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.775,-21.665),(-43.775,-21.495),(-43.605,-21.495),(-43.605,-21.665),(-43.775,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.435,-21.665),(-43.435,-21.495),(-43.265,-21.495),(-43.265,-21.665),(-43.435,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.115,21.495),(-27.115,21.665),(-26.945,21.665),(-26.945,21.495),(-27.115,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.075,21.495),(-42.075,21.665),(-41.905,21.665),(-41.905,21.495),(-42.075,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.495),(30.005,21.665),(30.175,21.665),(30.175,21.495),(30.005,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.345,21.495),(30.345,21.665),(30.515,21.665),(30.515,21.495),(30.345,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.685,21.495),(30.685,21.665),(30.855,21.665),(30.855,21.495),(30.685,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,-21.665),(30.005,-21.495),(30.175,-21.495),(30.175,-21.665),(30.005,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.345,-21.665),(30.345,-21.495),(30.515,-21.495),(30.515,-21.665),(30.345,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.685,-21.665),(30.685,-21.495),(30.855,-21.495),(30.855,-21.665),(30.685,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.755,21.495),(-25.755,21.665),(-25.585,21.665),(-25.585,21.495),(-25.755,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.415,21.495),(-25.415,21.665),(-25.245,21.665),(-25.245,21.495),(-25.415,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.245,-21.665),(25.245,-21.495),(25.415,-21.495),(25.415,-21.665),(25.245,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.585,-21.665),(25.585,-21.495),(25.755,-21.495),(25.755,-21.665),(25.585,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.285,21.495),(27.285,21.665),(27.455,21.665),(27.455,21.495),(27.285,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.625,21.495),(27.625,21.665),(27.795,21.665),(27.795,21.495),(27.625,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.245,21.495),(8.245,21.665),(8.415,21.665),(8.415,21.495),(8.245,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.585,21.495),(8.585,21.665),(8.755,21.665),(8.755,21.495),(8.585,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.795,-21.665),(-27.795,-21.495),(-27.625,-21.495),(-27.625,-21.665),(-27.795,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.455,-21.665),(-27.455,-21.495),(-27.285,-21.495),(-27.285,-21.665),(-27.455,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.245,-21.665),(8.245,-21.495),(8.415,-21.495),(8.415,-21.665),(8.245,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.585,-21.665),(8.585,-21.495),(8.755,-21.495),(8.755,-21.665),(8.585,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,4.675),(-44.845,4.845),(-44.675,4.845),(-44.675,4.675),(-44.845,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,4.335),(-44.845,4.505),(-44.675,4.505),(-44.675,4.335),(-44.845,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-4.845),(44.675,-4.675),(44.845,-4.675),(44.845,-4.845),(44.675,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-4.505),(44.675,-4.335),(44.845,-4.335),(44.845,-4.505),(44.675,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,7.055),(44.675,7.225),(44.845,7.225),(44.845,7.055),(44.675,7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,7.395),(44.675,7.565),(44.845,7.565),(44.845,7.395),(44.675,7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,7.735),(44.675,7.905),(44.845,7.905),(44.845,7.735),(44.675,7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-7.905),(44.675,-7.735),(44.845,-7.735),(44.845,-7.905),(44.675,-7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-7.565),(44.675,-7.395),(44.845,-7.395),(44.845,-7.565),(44.675,-7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-7.225),(44.675,-7.055),(44.845,-7.055),(44.845,-7.225),(44.675,-7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((41.905,-21.665),(41.905,-21.495),(42.075,-21.495),(42.075,-21.665),(41.905,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.015,21.495),(-22.015,21.665),(-21.845,21.665),(-21.845,21.495),(-22.015,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.095,-21.665),(-43.095,-21.495),(-42.925,-21.495),(-42.925,-21.665),(-43.095,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.885,-21.665),(40.885,-21.495),(41.055,-21.495),(41.055,-21.665),(40.885,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.065,21.495),(16.065,21.665),(16.235,21.665),(16.235,21.495),(16.065,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.405,21.495),(16.405,21.665),(16.575,21.665),(16.575,21.495),(16.405,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.745,21.495),(16.745,21.665),(16.915,21.665),(16.915,21.495),(16.745,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.915,21.495),(-16.915,21.665),(-16.745,21.665),(-16.745,21.495),(-16.915,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.575,21.495),(-16.575,21.665),(-16.405,21.665),(-16.405,21.495),(-16.575,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.235,21.495),(-16.235,21.665),(-16.065,21.665),(-16.065,21.495),(-16.235,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.915,-21.665),(-16.915,-21.495),(-16.745,-21.495),(-16.745,-21.665),(-16.915,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.575,-21.665),(-16.575,-21.495),(-16.405,-21.495),(-16.405,-21.665),(-16.575,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.235,-21.665),(-16.235,-21.495),(-16.065,-21.495),(-16.065,-21.665),(-16.235,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.065,-21.665),(16.065,-21.495),(16.235,-21.495),(16.235,-21.665),(16.065,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.905,-21.665),(7.905,-21.495),(8.075,-21.495),(8.075,-21.665),(7.905,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.885,21.495),(40.885,21.665),(41.055,21.665),(41.055,21.495),(40.885,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.985,21.495),(28.985,21.665),(29.155,21.665),(29.155,21.495),(28.985,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.845,21.495),(21.845,21.665),(22.015,21.665),(22.015,21.495),(21.845,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.925,-21.665),(25.925,-21.495),(26.095,-21.495),(26.095,-21.665),(25.925,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.615,21.495),(-1.615,21.665),(-1.445,21.665),(-1.445,21.495),(-1.615,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.115,-21.665),(-27.115,-21.495),(-26.945,-21.495),(-26.945,-21.665),(-27.115,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,18.275),(-44.845,18.445),(-44.675,18.445),(-44.675,18.275),(-44.845,18.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,17.935),(-44.845,18.105),(-44.675,18.105),(-44.675,17.935),(-44.845,17.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,18.615),(-44.845,18.785),(-44.675,18.785),(-44.675,18.615),(-44.845,18.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-18.785),(-44.845,-18.615),(-44.675,-18.615),(-44.675,-18.785),(-44.845,-18.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,11.475),(44.675,11.645),(44.845,11.645),(44.845,11.475),(44.675,11.475)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,11.135),(44.675,11.305),(44.845,11.305),(44.845,11.135),(44.675,11.135)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,11.815),(44.675,11.985),(44.845,11.985),(44.845,11.815),(44.675,11.815)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-18.445),(-44.845,-18.275),(-44.675,-18.275),(-44.675,-18.445),(-44.845,-18.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-11.985),(44.675,-11.815),(44.845,-11.815),(44.845,-11.985),(44.675,-11.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-11.645),(44.675,-11.475),(44.845,-11.475),(44.845,-11.645),(44.675,-11.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-11.305),(44.675,-11.135),(44.845,-11.135),(44.845,-11.305),(44.675,-11.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.425,21.495),(0.425,21.665),(0.595,21.665),(0.595,21.495),(0.425,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.425,-21.665),(0.425,-21.495),(0.595,-21.495),(0.595,-21.665),(0.425,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,12.835),(44.675,13.005),(44.845,13.005),(44.845,12.835),(44.675,12.835)),
        )
        createRL(
            tech, net, 'licon',
            ((1.105,21.495),(1.105,21.665),(1.275,21.665),(1.275,21.495),(1.105,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.275,-21.665),(-1.275,-21.495),(-1.105,-21.495),(-1.105,-21.665),(-1.275,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.095,-21.665),(-26.095,-21.495),(-25.925,-21.495),(-25.925,-21.665),(-26.095,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,19.975),(-44.845,20.145),(-44.675,20.145),(-44.675,19.975),(-44.845,19.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.945,21.495),(9.945,21.665),(10.115,21.665),(10.115,21.495),(9.945,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.035,21.495),(-23.035,21.665),(-22.865,21.665),(-22.865,21.495),(-23.035,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.025,21.495),(14.025,21.665),(14.195,21.665),(14.195,21.495),(14.025,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.365,21.495),(14.365,21.665),(14.535,21.665),(14.535,21.495),(14.365,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.705,21.495),(14.705,21.665),(14.875,21.665),(14.875,21.495),(14.705,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.885,21.495),(23.885,21.665),(24.055,21.665),(24.055,21.495),(23.885,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.025,-21.665),(14.025,-21.495),(14.195,-21.495),(14.195,-21.665),(14.025,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((14.365,-21.665),(14.365,-21.495),(14.535,-21.495),(14.535,-21.665),(14.365,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((14.705,-21.665),(14.705,-21.495),(14.875,-21.495),(14.875,-21.665),(14.705,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.825,21.495),(37.825,21.665),(37.995,21.665),(37.995,21.495),(37.825,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.145,21.495),(37.145,21.665),(37.315,21.665),(37.315,21.495),(37.145,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.485,21.495),(37.485,21.665),(37.655,21.665),(37.655,21.495),(37.485,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.995,-21.665),(-37.995,-21.495),(-37.825,-21.495),(-37.825,-21.665),(-37.995,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.655,-21.665),(-37.655,-21.495),(-37.485,-21.495),(-37.485,-21.665),(-37.655,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.315,-21.665),(-37.315,-21.495),(-37.145,-21.495),(-37.145,-21.665),(-37.315,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.035,-21.665),(-6.035,-21.495),(-5.865,-21.495),(-5.865,-21.665),(-6.035,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,2.975),(-44.845,3.145),(-44.675,3.145),(-44.675,2.975),(-44.845,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.775,21.495),(-26.775,21.665),(-26.605,21.665),(-26.605,21.495),(-26.775,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.435,21.495),(-26.435,21.665),(-26.265,21.665),(-26.265,21.495),(-26.435,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.775,-21.665),(-26.775,-21.495),(-26.605,-21.495),(-26.605,-21.665),(-26.775,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.435,-21.665),(-26.435,-21.495),(-26.265,-21.495),(-26.265,-21.665),(-26.435,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((24.905,-21.665),(24.905,-21.495),(25.075,-21.495),(25.075,-21.665),(24.905,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.925,-21.665),(42.925,-21.495),(43.095,-21.495),(43.095,-21.665),(42.925,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.765,21.495),(0.765,21.665),(0.935,21.665),(0.935,21.495),(0.765,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.765,-21.665),(0.765,-21.495),(0.935,-21.495),(0.935,-21.665),(0.765,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.735,21.495),(-7.735,21.665),(-7.565,21.665),(-7.565,21.495),(-7.735,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.395,21.495),(-7.395,21.665),(-7.225,21.665),(-7.225,21.495),(-7.395,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.225,-21.665),(7.225,-21.495),(7.395,-21.495),(7.395,-21.665),(7.225,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.565,-21.665),(7.565,-21.495),(7.735,-21.495),(7.735,-21.665),(7.565,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,0.595),(44.675,0.765),(44.845,0.765),(44.845,0.595),(44.675,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,0.595),(-44.845,0.765),(-44.675,0.765),(-44.675,0.595),(-44.845,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((35.105,21.495),(35.105,21.665),(35.275,21.665),(35.275,21.495),(35.105,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.445,21.495),(35.445,21.665),(35.615,21.665),(35.615,21.495),(35.445,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.785,21.495),(35.785,21.665),(35.955,21.665),(35.955,21.495),(35.785,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.955,-21.665),(-35.955,-21.495),(-35.785,-21.495),(-35.785,-21.665),(-35.955,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.615,-21.665),(-35.615,-21.495),(-35.445,-21.495),(-35.445,-21.665),(-35.615,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.275,-21.665),(-35.275,-21.495),(-35.105,-21.495),(-35.105,-21.665),(-35.275,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((4.165,21.495),(4.165,21.665),(4.335,21.665),(4.335,21.495),(4.165,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.505,21.495),(4.505,21.665),(4.675,21.665),(4.675,21.495),(4.505,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.165,-21.665),(4.165,-21.495),(4.335,-21.495),(4.335,-21.665),(4.165,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.155,-21.665),(-12.155,-21.495),(-11.985,-21.495),(-11.985,-21.665),(-12.155,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,4.335),(44.675,4.505),(44.845,4.505),(44.845,4.335),(44.675,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,4.675),(44.675,4.845),(44.845,4.845),(44.845,4.675),(44.675,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-4.845),(-44.845,-4.675),(-44.675,-4.675),(-44.675,-4.845),(-44.845,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-4.505),(-44.845,-4.335),(-44.675,-4.335),(-44.675,-4.505),(-44.845,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((4.505,-21.665),(4.505,-21.495),(4.675,-21.495),(4.675,-21.665),(4.505,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-13.005),(-44.845,-12.835),(-44.675,-12.835),(-44.675,-13.005),(-44.845,-13.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.745,-21.665),(16.745,-21.495),(16.915,-21.495),(16.915,-21.665),(16.745,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.845,-21.665),(38.845,-21.495),(39.015,-21.495),(39.015,-21.665),(38.845,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.715,21.495),(-6.715,21.665),(-6.545,21.665),(-6.545,21.495),(-6.715,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.375,21.495),(-6.375,21.665),(-6.205,21.665),(-6.205,21.495),(-6.375,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.005,21.495),(13.005,21.665),(13.175,21.665),(13.175,21.495),(13.005,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.345,21.495),(13.345,21.665),(13.515,21.665),(13.515,21.495),(13.345,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.685,21.495),(13.685,21.665),(13.855,21.665),(13.855,21.495),(13.685,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.855,-21.665),(-13.855,-21.495),(-13.685,-21.495),(-13.685,-21.665),(-13.855,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.515,-21.665),(-13.515,-21.495),(-13.345,-21.495),(-13.345,-21.665),(-13.515,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.175,-21.665),(-13.175,-21.495),(-13.005,-21.495),(-13.005,-21.665),(-13.175,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,14.195),(-44.845,14.365),(-44.675,14.365),(-44.675,14.195),(-44.845,14.195)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,14.535),(-44.845,14.705),(-44.675,14.705),(-44.675,14.535),(-44.845,14.535)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-14.705),(-44.845,-14.535),(-44.675,-14.535),(-44.675,-14.705),(-44.845,-14.705)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-14.365),(-44.845,-14.195),(-44.675,-14.195),(-44.675,-14.365),(-44.845,-14.365)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.795,21.495),(-44.795,21.665),(-44.625,21.665),(-44.625,21.495),(-44.795,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.455,21.495),(-44.455,21.665),(-44.285,21.665),(-44.285,21.495),(-44.455,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.795,-21.665),(-44.795,-21.495),(-44.625,-21.495),(-44.625,-21.665),(-44.795,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.455,-21.665),(-44.455,-21.495),(-44.285,-21.495),(-44.285,-21.665),(-44.455,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,13.855),(44.675,14.025),(44.845,14.025),(44.845,13.855),(44.675,13.855)),
        )
        createRL(
            tech, net, 'licon',
            ((11.985,21.495),(11.985,21.665),(12.155,21.665),(12.155,21.495),(11.985,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.865,-21.665),(22.865,-21.495),(23.035,-21.495),(23.035,-21.665),(22.865,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.245,21.495),(42.245,21.665),(42.415,21.665),(42.415,21.495),(42.245,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.585,21.495),(42.585,21.665),(42.755,21.665),(42.755,21.495),(42.585,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-16.745),(-44.845,-16.575),(-44.675,-16.575),(-44.675,-16.745),(-44.845,-16.745)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-16.405),(-44.845,-16.235),(-44.675,-16.235),(-44.675,-16.405),(-44.845,-16.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,1.275),(44.675,1.445),(44.845,1.445),(44.845,1.275),(44.675,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-1.105),(-44.845,-0.935),(-44.675,-0.935),(-44.675,-1.105),(-44.845,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-1.445),(44.675,-1.275),(44.845,-1.275),(44.845,-1.445),(44.675,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.135,21.495),(-11.135,21.665),(-10.965,21.665),(-10.965,21.495),(-11.135,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.245,-21.665),(42.245,-21.495),(42.415,-21.495),(42.415,-21.665),(42.245,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.585,-21.665),(42.585,-21.495),(42.755,-21.495),(42.755,-21.665),(42.585,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.095,21.495),(-26.095,21.665),(-25.925,21.665),(-25.925,21.495),(-26.095,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.155,21.495),(-29.155,21.665),(-28.985,21.665),(-28.985,21.495),(-29.155,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.775,21.495),(-9.775,21.665),(-9.605,21.665),(-9.605,21.495),(-9.775,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.435,21.495),(-9.435,21.665),(-9.265,21.665),(-9.265,21.495),(-9.435,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.265,-21.665),(9.265,-21.495),(9.435,-21.495),(9.435,-21.665),(9.265,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.605,-21.665),(9.605,-21.495),(9.775,-21.495),(9.775,-21.665),(9.605,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.165,21.495),(38.165,21.665),(38.335,21.665),(38.335,21.495),(38.165,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.505,21.495),(38.505,21.665),(38.675,21.665),(38.675,21.495),(38.505,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.305,21.495),(11.305,21.665),(11.475,21.665),(11.475,21.495),(11.305,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.645,21.495),(11.645,21.665),(11.815,21.665),(11.815,21.495),(11.645,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.815,-21.665),(-11.815,-21.495),(-11.645,-21.495),(-11.645,-21.665),(-11.815,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.475,-21.665),(-11.475,-21.495),(-11.305,-21.495),(-11.305,-21.665),(-11.475,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.165,-21.665),(38.165,-21.495),(38.335,-21.495),(38.335,-21.665),(38.165,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.505,-21.665),(38.505,-21.495),(38.675,-21.495),(38.675,-21.665),(38.505,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-15.045),(-44.845,-14.875),(-44.675,-14.875),(-44.675,-15.045),(-44.845,-15.045)),
        )
        createRL(
            tech, net, 'licon',
            ((22.525,21.495),(22.525,21.665),(22.695,21.665),(22.695,21.495),(22.525,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.185,21.495),(22.185,21.665),(22.355,21.665),(22.355,21.495),(22.185,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.835,21.495),(-29.835,21.665),(-29.665,21.665),(-29.665,21.495),(-29.835,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.495,21.495),(-29.495,21.665),(-29.325,21.665),(-29.325,21.495),(-29.495,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.185,-21.665),(22.185,-21.495),(22.355,-21.495),(22.355,-21.665),(22.185,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((29.325,-21.665),(29.325,-21.495),(29.495,-21.495),(29.495,-21.665),(29.325,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((29.665,-21.665),(29.665,-21.495),(29.835,-21.495),(29.835,-21.665),(29.665,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.525,-21.665),(22.525,-21.495),(22.695,-21.495),(22.695,-21.665),(22.525,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,1.955),(-44.845,2.125),(-44.675,2.125),(-44.675,1.955),(-44.845,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.935,21.495),(-17.935,21.665),(-17.765,21.665),(-17.765,21.495),(-17.935,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.595,21.495),(-17.595,21.665),(-17.425,21.665),(-17.425,21.495),(-17.595,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.255,21.495),(-17.255,21.665),(-17.085,21.665),(-17.085,21.495),(-17.255,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.035,21.495),(-6.035,21.665),(-5.865,21.665),(-5.865,21.495),(-6.035,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.085,-21.665),(17.085,-21.495),(17.255,-21.495),(17.255,-21.665),(17.085,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((17.425,-21.665),(17.425,-21.495),(17.595,-21.495),(17.595,-21.665),(17.425,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((17.765,-21.665),(17.765,-21.495),(17.935,-21.495),(17.935,-21.665),(17.765,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((24.905,21.495),(24.905,21.665),(25.075,21.665),(25.075,21.495),(24.905,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.775,21.495),(-43.775,21.665),(-43.605,21.665),(-43.605,21.495),(-43.775,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.435,21.495),(-43.435,21.665),(-43.265,21.665),(-43.265,21.495),(-43.435,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.265,-21.665),(43.265,-21.495),(43.435,-21.495),(43.435,-21.665),(43.265,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.605,-21.665),(43.605,-21.495),(43.775,-21.495),(43.775,-21.665),(43.605,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((5.865,21.495),(5.865,21.665),(6.035,21.665),(6.035,21.495),(5.865,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.945,-21.665),(9.945,-21.495),(10.115,-21.495),(10.115,-21.665),(9.945,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.925,21.495),(42.925,21.665),(43.095,21.665),(43.095,21.495),(42.925,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.135,-21.665),(-11.135,-21.495),(-10.965,-21.495),(-10.965,-21.665),(-11.135,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,18.955),(-44.845,19.125),(-44.675,19.125),(-44.675,18.955),(-44.845,18.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-18.105),(-44.845,-17.935),(-44.675,-17.935),(-44.675,-18.105),(-44.845,-18.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.455,21.495),(-27.455,21.665),(-27.285,21.665),(-27.285,21.495),(-27.455,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.795,21.495),(-27.795,21.665),(-27.625,21.665),(-27.625,21.495),(-27.795,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.625,-21.665),(27.625,-21.495),(27.795,-21.495),(27.795,-21.665),(27.625,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.285,-21.665),(27.285,-21.495),(27.455,-21.495),(27.455,-21.665),(27.285,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.845,21.495),(38.845,21.665),(39.015,21.665),(39.015,21.495),(38.845,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.285,-21.665),(44.285,-21.495),(44.455,-21.495),(44.455,-21.665),(44.285,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,7.395),(-44.845,7.565),(-44.675,7.565),(-44.675,7.395),(-44.845,7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,7.735),(-44.845,7.905),(-44.675,7.905),(-44.675,7.735),(-44.845,7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,7.055),(-44.845,7.225),(-44.675,7.225),(-44.675,7.055),(-44.845,7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-7.905),(-44.845,-7.735),(-44.675,-7.735),(-44.675,-7.905),(-44.845,-7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-7.565),(-44.845,-7.395),(-44.675,-7.395),(-44.675,-7.565),(-44.845,-7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-7.225),(-44.845,-7.055),(-44.675,-7.055),(-44.675,-7.225),(-44.845,-7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((22.865,21.495),(22.865,21.665),(23.035,21.665),(23.035,21.495),(22.865,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,19.635),(-44.845,19.805),(-44.675,19.805),(-44.675,19.635),(-44.845,19.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,19.295),(-44.845,19.465),(-44.675,19.465),(-44.675,19.295),(-44.845,19.295)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-19.805),(-44.845,-19.635),(-44.675,-19.635),(-44.675,-19.805),(-44.845,-19.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-19.465),(-44.845,-19.295),(-44.675,-19.295),(-44.675,-19.465),(-44.845,-19.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.115,-21.665),(-10.115,-21.495),(-9.945,-21.495),(-9.945,-21.665),(-10.115,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.055,21.495),(-7.055,21.665),(-6.885,21.665),(-6.885,21.495),(-7.055,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.495),(31.025,21.665),(31.195,21.665),(31.195,21.495),(31.025,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.365,21.495),(31.365,21.665),(31.535,21.665),(31.535,21.495),(31.365,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.705,21.495),(31.705,21.665),(31.875,21.665),(31.875,21.495),(31.705,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.875,-21.665),(-31.875,-21.495),(-31.705,-21.495),(-31.705,-21.665),(-31.875,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.535,-21.665),(-31.535,-21.495),(-31.365,-21.495),(-31.365,-21.665),(-31.535,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.195,-21.665),(-31.195,-21.495),(-31.025,-21.495),(-31.025,-21.665),(-31.195,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.905,21.495),(7.905,21.665),(8.075,21.665),(8.075,21.495),(7.905,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.405,-21.665),(16.405,-21.495),(16.575,-21.495),(16.575,-21.665),(16.405,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,6.035),(44.675,6.205),(44.845,6.205),(44.845,6.035),(44.675,6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,6.375),(44.675,6.545),(44.845,6.545),(44.845,6.375),(44.675,6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,6.715),(44.675,6.885),(44.845,6.885),(44.845,6.715),(44.675,6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-6.885),(44.675,-6.715),(44.845,-6.715),(44.845,-6.885),(44.675,-6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-6.545),(44.675,-6.375),(44.845,-6.375),(44.845,-6.545),(44.675,-6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-6.205),(44.675,-6.035),(44.845,-6.035),(44.845,-6.205),(44.675,-6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.165,21.495),(21.165,21.665),(21.335,21.665),(21.335,21.495),(21.165,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.505,21.495),(21.505,21.665),(21.675,21.665),(21.675,21.495),(21.505,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.675,-21.665),(-21.675,-21.495),(-21.505,-21.495),(-21.505,-21.665),(-21.675,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.335,-21.665),(-21.335,-21.495),(-21.165,-21.495),(-21.165,-21.665),(-21.335,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,17.935),(44.675,18.105),(44.845,18.105),(44.845,17.935),(44.675,17.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.255,21.495),(-0.255,21.665),(-0.085,21.665),(-0.085,21.495),(-0.255,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.255,-21.665),(-0.255,-21.495),(-0.085,-21.495),(-0.085,-21.665),(-0.255,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.795,21.495),(-10.795,21.665),(-10.625,21.665),(-10.625,21.495),(-10.795,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.455,21.495),(-10.455,21.665),(-10.285,21.665),(-10.285,21.495),(-10.455,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.795,-21.665),(-10.795,-21.495),(-10.625,-21.495),(-10.625,-21.665),(-10.795,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.455,-21.665),(-10.455,-21.495),(-10.285,-21.495),(-10.285,-21.665),(-10.455,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.925,-21.665),(8.925,-21.495),(9.095,-21.495),(9.095,-21.665),(8.925,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.275,21.495),(-1.275,21.665),(-1.105,21.665),(-1.105,21.495),(-1.275,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.105,-21.665),(1.105,-21.495),(1.275,-21.495),(1.275,-21.665),(1.105,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,3.315),(44.675,3.485),(44.845,3.485),(44.845,3.315),(44.675,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,3.655),(44.675,3.825),(44.845,3.825),(44.845,3.655),(44.675,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-3.825),(44.675,-3.655),(44.845,-3.655),(44.845,-3.825),(44.675,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.595,-21.665),(-0.595,-21.495),(-0.425,-21.495),(-0.425,-21.665),(-0.595,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-3.485),(44.675,-3.315),(44.845,-3.315),(44.845,-3.485),(44.675,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-3.145),(44.675,-2.975),(44.845,-2.975),(44.845,-3.145),(44.675,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.945,-21.665),(26.945,-21.495),(27.115,-21.495),(27.115,-21.665),(26.945,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,0.935),(44.675,1.105),(44.845,1.105),(44.845,0.935),(44.675,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,0.935),(-44.845,1.105),(-44.675,1.105),(-44.675,0.935),(-44.845,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((19.125,21.495),(19.125,21.665),(19.295,21.665),(19.295,21.495),(19.125,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.465,21.495),(19.465,21.665),(19.635,21.665),(19.635,21.495),(19.465,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.805,21.495),(19.805,21.665),(19.975,21.665),(19.975,21.495),(19.805,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.975,-21.665),(-19.975,-21.495),(-19.805,-21.495),(-19.805,-21.665),(-19.975,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.635,-21.665),(-19.635,-21.495),(-19.465,-21.495),(-19.465,-21.665),(-19.635,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.295,-21.665),(-19.295,-21.495),(-19.125,-21.495),(-19.125,-21.665),(-19.295,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,13.175),(-44.845,13.345),(-44.675,13.345),(-44.675,13.175),(-44.845,13.175)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,13.515),(-44.845,13.685),(-44.675,13.685),(-44.675,13.515),(-44.845,13.515)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-13.685),(-44.845,-13.515),(-44.675,-13.515),(-44.675,-13.685),(-44.845,-13.685)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-13.345),(-44.845,-13.175),(-44.675,-13.175),(-44.675,-13.345),(-44.845,-13.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.985,-21.665),(28.985,-21.495),(29.155,-21.495),(29.155,-21.665),(28.985,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,14.875),(-44.845,15.045),(-44.675,15.045),(-44.675,14.875),(-44.845,14.875)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-14.025),(-44.845,-13.855),(-44.675,-13.855),(-44.675,-14.025),(-44.845,-14.025)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.995,21.495),(-37.995,21.665),(-37.825,21.665),(-37.825,21.495),(-37.995,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.655,21.495),(-37.655,21.665),(-37.485,21.665),(-37.485,21.495),(-37.655,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.315,21.495),(-37.315,21.665),(-37.145,21.665),(-37.145,21.495),(-37.315,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.145,-21.665),(37.145,-21.495),(37.315,-21.495),(37.315,-21.665),(37.145,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.485,-21.665),(37.485,-21.495),(37.655,-21.495),(37.655,-21.665),(37.485,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.825,-21.665),(37.825,-21.495),(37.995,-21.495),(37.995,-21.665),(37.825,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((1.445,21.495),(1.445,21.665),(1.615,21.665),(1.615,21.495),(1.445,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.815,21.495),(-28.815,21.665),(-28.645,21.665),(-28.645,21.495),(-28.815,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.475,21.495),(-28.475,21.665),(-28.305,21.665),(-28.305,21.495),(-28.475,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.815,-21.665),(-28.815,-21.495),(-28.645,-21.495),(-28.645,-21.665),(-28.815,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.475,-21.665),(-28.475,-21.495),(-28.305,-21.495),(-28.305,-21.665),(-28.475,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.885,-21.665),(6.885,-21.495),(7.055,-21.495),(7.055,-21.665),(6.885,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-21.165),(44.675,-20.995),(44.845,-20.995),(44.845,-21.165),(44.675,-21.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-16.065),(-44.845,-15.895),(-44.675,-15.895),(-44.675,-16.065),(-44.845,-16.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,10.795),(44.675,10.965),(44.845,10.965),(44.845,10.795),(44.675,10.795)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,10.115),(44.675,10.285),(44.845,10.285),(44.845,10.115),(44.675,10.115)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,10.455),(44.675,10.625),(44.845,10.625),(44.845,10.455),(44.675,10.455)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-10.965),(44.675,-10.795),(44.845,-10.795),(44.845,-10.965),(44.675,-10.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-10.625),(44.675,-10.455),(44.845,-10.455),(44.845,-10.625),(44.675,-10.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-10.285),(44.675,-10.115),(44.845,-10.115),(44.845,-10.285),(44.675,-10.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-16.065),(44.675,-15.895),(44.845,-15.895),(44.845,-16.065),(44.675,-16.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.265,21.495),(26.265,21.665),(26.435,21.665),(26.435,21.495),(26.265,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.605,21.495),(26.605,21.665),(26.775,21.665),(26.775,21.495),(26.605,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.265,-21.665),(26.265,-21.495),(26.435,-21.495),(26.435,-21.665),(26.265,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.605,-21.665),(26.605,-21.495),(26.775,-21.495),(26.775,-21.665),(26.605,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.115,21.495),(-10.115,21.665),(-9.945,21.665),(-9.945,21.495),(-10.115,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.055,21.495),(-41.055,21.665),(-40.885,21.665),(-40.885,21.495),(-41.055,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.275,21.495),(-35.275,21.665),(-35.105,21.665),(-35.105,21.495),(-35.275,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.955,21.495),(-35.955,21.665),(-35.785,21.665),(-35.785,21.495),(-35.955,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.615,21.495),(-35.615,21.665),(-35.445,21.665),(-35.445,21.495),(-35.615,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.105,-21.665),(35.105,-21.495),(35.275,-21.495),(35.275,-21.665),(35.105,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.445,-21.665),(35.445,-21.495),(35.615,-21.495),(35.615,-21.665),(35.445,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.785,-21.665),(35.785,-21.495),(35.955,-21.495),(35.955,-21.665),(35.785,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.045,21.495),(15.045,21.665),(15.215,21.665),(15.215,21.495),(15.045,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.385,21.495),(15.385,21.665),(15.555,21.665),(15.555,21.495),(15.385,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.725,21.495),(15.725,21.665),(15.895,21.665),(15.895,21.495),(15.725,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.895,-21.665),(-15.895,-21.495),(-15.725,-21.495),(-15.725,-21.665),(-15.895,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.555,-21.665),(-15.555,-21.495),(-15.385,-21.495),(-15.385,-21.665),(-15.555,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.215,-21.665),(-15.215,-21.495),(-15.045,-21.495),(-15.045,-21.665),(-15.215,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.205,-21.665),(23.205,-21.495),(23.375,-21.495),(23.375,-21.665),(23.205,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.075,21.495),(-25.075,21.665),(-24.905,21.665),(-24.905,21.495),(-25.075,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.205,21.495),(6.205,21.665),(6.375,21.665),(6.375,21.495),(6.205,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.545,21.495),(6.545,21.665),(6.715,21.665),(6.715,21.495),(6.545,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.855,21.495),(-13.855,21.665),(-13.685,21.665),(-13.685,21.495),(-13.855,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.515,21.495),(-13.515,21.665),(-13.345,21.665),(-13.345,21.495),(-13.515,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.175,21.495),(-13.175,21.665),(-13.005,21.665),(-13.005,21.495),(-13.175,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.005,-21.665),(13.005,-21.495),(13.175,-21.495),(13.175,-21.665),(13.005,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.345,-21.665),(13.345,-21.495),(13.515,-21.495),(13.515,-21.665),(13.345,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.685,-21.665),(13.685,-21.495),(13.855,-21.495),(13.855,-21.665),(13.685,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.205,-21.665),(6.205,-21.495),(6.375,-21.495),(6.375,-21.665),(6.205,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.545,-21.665),(6.545,-21.495),(6.715,-21.495),(6.715,-21.665),(6.545,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.925,21.495),(8.925,21.665),(9.095,21.665),(9.095,21.495),(8.925,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-8.585),(44.675,-8.415),(44.845,-8.415),(44.845,-8.585),(44.675,-8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-8.245),(44.675,-8.075),(44.845,-8.075),(44.845,-8.245),(44.675,-8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.945,21.495),(26.945,21.665),(27.115,21.665),(27.115,21.495),(26.945,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,9.095),(-44.845,9.265),(-44.675,9.265),(-44.675,9.095),(-44.845,9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,9.435),(-44.845,9.605),(-44.675,9.605),(-44.675,9.435),(-44.845,9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,9.775),(-44.845,9.945),(-44.675,9.945),(-44.675,9.775),(-44.845,9.775)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-9.945),(-44.845,-9.775),(-44.675,-9.775),(-44.675,-9.945),(-44.845,-9.945)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-9.605),(-44.845,-9.435),(-44.675,-9.435),(-44.675,-9.605),(-44.845,-9.605)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-9.265),(-44.845,-9.095),(-44.675,-9.095),(-44.675,-9.265),(-44.845,-9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-8.925),(-44.845,-8.755),(-44.675,-8.755),(-44.675,-8.925),(-44.845,-8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-8.585),(-44.845,-8.415),(-44.675,-8.415),(-44.675,-8.585),(-44.845,-8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.815,21.495),(-11.815,21.665),(-11.645,21.665),(-11.645,21.495),(-11.815,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.475,21.495),(-11.475,21.665),(-11.305,21.665),(-11.305,21.495),(-11.475,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.715,21.495),(-40.715,21.665),(-40.545,21.665),(-40.545,21.495),(-40.715,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.375,21.495),(-40.375,21.665),(-40.205,21.665),(-40.205,21.495),(-40.375,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-8.245),(-44.845,-8.075),(-44.675,-8.075),(-44.675,-8.245),(-44.845,-8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.715,-21.665),(-40.715,-21.495),(-40.545,-21.495),(-40.545,-21.665),(-40.715,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.375,-21.665),(-40.375,-21.495),(-40.205,-21.495),(-40.205,-21.665),(-40.375,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-8.925),(44.675,-8.755),(44.845,-8.755),(44.845,-8.925),(44.675,-8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.305,-21.665),(11.305,-21.495),(11.475,-21.495),(11.475,-21.665),(11.305,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.645,-21.665),(11.645,-21.495),(11.815,-21.495),(11.815,-21.665),(11.645,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,11.135),(-44.845,11.305),(-44.675,11.305),(-44.675,11.135),(-44.845,11.135)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,11.475),(-44.845,11.645),(-44.675,11.645),(-44.675,11.475),(-44.845,11.475)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,11.815),(-44.845,11.985),(-44.675,11.985),(-44.675,11.815),(-44.845,11.815)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-11.985),(-44.845,-11.815),(-44.675,-11.815),(-44.675,-11.985),(-44.845,-11.985)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-11.645),(-44.845,-11.475),(-44.675,-11.475),(-44.675,-11.645),(-44.845,-11.645)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-11.305),(-44.845,-11.135),(-44.675,-11.135),(-44.675,-11.305),(-44.845,-11.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-19.125),(44.675,-18.955),(44.845,-18.955),(44.845,-19.125),(44.675,-19.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.715,-21.665),(-6.715,-21.495),(-6.545,-21.495),(-6.545,-21.665),(-6.715,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.375,-21.665),(-6.375,-21.495),(-6.205,-21.495),(-6.205,-21.665),(-6.375,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.735,21.495),(-24.735,21.665),(-24.565,21.665),(-24.565,21.495),(-24.735,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.395,21.495),(-24.395,21.665),(-24.225,21.665),(-24.225,21.495),(-24.395,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.735,-21.665),(-24.735,-21.495),(-24.565,-21.495),(-24.565,-21.665),(-24.735,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.395,-21.665),(-24.395,-21.495),(-24.225,-21.495),(-24.225,-21.665),(-24.395,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,1.955),(44.675,2.125),(44.845,2.125),(44.845,1.955),(44.675,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((6.885,21.495),(6.885,21.665),(7.055,21.665),(7.055,21.495),(6.885,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.835,-21.665),(-12.835,-21.495),(-12.665,-21.495),(-12.665,-21.665),(-12.835,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.495,-21.665),(-12.495,-21.495),(-12.325,-21.495),(-12.325,-21.665),(-12.495,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((5.185,21.495),(5.185,21.665),(5.355,21.665),(5.355,21.495),(5.185,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.525,21.495),(5.525,21.665),(5.695,21.665),(5.695,21.495),(5.525,21.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,1.615),(-44.845,1.785),(-44.675,1.785),(-44.675,1.615),(-44.845,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-1.785),(-44.845,-1.615),(-44.675,-1.615),(-44.675,-1.785),(-44.845,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.695,-21.665),(-5.695,-21.495),(-5.525,-21.495),(-5.525,-21.665),(-5.695,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.355,-21.665),(-5.355,-21.495),(-5.185,-21.495),(-5.185,-21.665),(-5.355,-21.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,2.295),(-44.845,2.465),(-44.675,2.465),(-44.675,2.295),(-44.845,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,2.635),(-44.845,2.805),(-44.675,2.805),(-44.675,2.635),(-44.845,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-2.805),(-44.845,-2.635),(-44.675,-2.635),(-44.675,-2.805),(-44.845,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-2.465),(-44.845,-2.295),(-44.675,-2.295),(-44.675,-2.465),(-44.845,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.435,-21.665),(-9.435,-21.495),(-9.265,-21.495),(-9.265,-21.665),(-9.435,-21.665)),
        )
        createRL(
            tech, net, 'li',
            ((-45.0,-21.82),(-45.0,21.34),(-44.52,21.34),(-44.52,-21.34),(44.52,-21.34),(44.52,21.34),(-45.0,21.34),(-45.0,21.82),(45.0,21.82),(45.0,-21.82),(-45.0,-21.82)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((-45.125,-21.945),(-45.125,21.215),(-44.395,21.215),(-44.395,-21.215),(44.395,-21.215),(44.395,21.215),(-45.125,21.215),(-45.125,21.945),(45.125,21.945),(45.125,-21.945),(-45.125,-21.945)),
        )
        nets['conn'].setDirection(Net.Direction.IN)

    cell = new_cells['GuardRing_N17368W8096HTF']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-43.42), u(-20.240000000000002), u(43.42), u(20.240000000000002),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'conn': Net.create(cell, 'conn'),
        }
        net = nets['conn']
        createRL(
            tech, net, 'difftap',
            ((-43.42,-20.24),(-43.42,19.76),(-42.94,19.76),(-42.94,-19.76),(42.94,-19.76),(42.94,19.76),(-43.42,19.76),(-43.42,20.24),(43.42,20.24),(43.42,-20.24),(-43.42,-20.24)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,13.345),(43.095,13.515),(43.265,13.515),(43.265,13.345),(43.095,13.345)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,13.685),(43.095,13.855),(43.265,13.855),(43.265,13.685),(43.095,13.685)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,13.005),(43.095,13.175),(43.265,13.175),(43.265,13.005),(43.095,13.005)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-13.855),(-43.265,-13.685),(-43.095,-13.685),(-43.095,-13.855),(-43.265,-13.855)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-13.515),(-43.265,-13.345),(-43.095,-13.345),(-43.095,-13.515),(-43.265,-13.515)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-13.175),(-43.265,-13.005),(-43.095,-13.005),(-43.095,-13.175),(-43.265,-13.175)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.005,-20.085),(-13.005,-19.915),(-12.835,-19.915),(-12.835,-20.085),(-13.005,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.995,-20.085),(20.995,-19.915),(21.165,-19.915),(21.165,-20.085),(20.995,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.245,19.915),(-42.245,20.085),(-42.075,20.085),(-42.075,19.915),(-42.245,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.925,19.915),(-42.925,20.085),(-42.755,20.085),(-42.755,19.915),(-42.925,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.585,19.915),(-42.585,20.085),(-42.415,20.085),(-42.415,19.915),(-42.585,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-0.595),(-43.265,-0.425),(-43.095,-0.425),(-43.095,-0.595),(-43.265,-0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-0.595),(43.095,-0.425),(43.265,-0.425),(43.265,-0.595),(43.095,-0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.085,-20.085),(-17.085,-19.915),(-16.915,-19.915),(-16.915,-20.085),(-17.085,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,6.205),(43.095,6.375),(43.265,6.375),(43.265,6.205),(43.095,6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,6.545),(43.095,6.715),(43.265,6.715),(43.265,6.545),(43.095,6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,6.205),(-43.265,6.375),(-43.095,6.375),(-43.095,6.205),(-43.265,6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,6.545),(-43.265,6.715),(-43.095,6.715),(-43.095,6.545),(-43.265,6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.665,-20.085),(-29.665,-19.915),(-29.495,-19.915),(-29.495,-20.085),(-29.665,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.325,-20.085),(-29.325,-19.915),(-29.155,-19.915),(-29.155,-20.085),(-29.325,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((29.155,-20.085),(29.155,-19.915),(29.325,-19.915),(29.325,-20.085),(29.155,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((29.495,-20.085),(29.495,-19.915),(29.665,-19.915),(29.665,-20.085),(29.495,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,19.915),(43.095,20.085),(43.265,20.085),(43.265,19.915),(43.095,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.885,-20.085),(-6.885,-19.915),(-6.715,-19.915),(-6.715,-20.085),(-6.885,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.545,-20.085),(-6.545,-19.915),(-6.375,-19.915),(-6.375,-20.085),(-6.545,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.205,-20.085),(-6.205,-19.915),(-6.035,-19.915),(-6.035,-20.085),(-6.205,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.035,-20.085),(6.035,-19.915),(6.205,-19.915),(6.205,-20.085),(6.035,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.745,-20.085),(-16.745,-19.915),(-16.575,-19.915),(-16.575,-20.085),(-16.745,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.405,-20.085),(-16.405,-19.915),(-16.235,-19.915),(-16.235,-20.085),(-16.405,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.375,-20.085),(6.375,-19.915),(6.545,-19.915),(6.545,-20.085),(6.375,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.715,-20.085),(6.715,-19.915),(6.885,-19.915),(6.885,-20.085),(6.715,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.115,19.915),(27.115,20.085),(27.285,20.085),(27.285,19.915),(27.115,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((27.455,19.915),(27.455,20.085),(27.625,20.085),(27.625,19.915),(27.455,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((27.795,19.915),(27.795,20.085),(27.965,20.085),(27.965,19.915),(27.795,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.965,-20.085),(-10.965,-19.915),(-10.795,-19.915),(-10.795,-20.085),(-10.965,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.625,-20.085),(-10.625,-19.915),(-10.455,-19.915),(-10.455,-20.085),(-10.625,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.285,-20.085),(-10.285,-19.915),(-10.115,-19.915),(-10.115,-20.085),(-10.285,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.115,-20.085),(10.115,-19.915),(10.285,-19.915),(10.285,-20.085),(10.115,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.455,-20.085),(10.455,-19.915),(10.625,-19.915),(10.625,-20.085),(10.455,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.795,-20.085),(10.795,-19.915),(10.965,-19.915),(10.965,-20.085),(10.795,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.025,-20.085),(-31.025,-19.915),(-30.855,-19.915),(-30.855,-20.085),(-31.025,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.465,19.915),(-36.465,20.085),(-36.295,20.085),(-36.295,19.915),(-36.465,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.805,19.915),(-36.805,20.085),(-36.635,20.085),(-36.635,19.915),(-36.805,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,16.065),(43.095,16.235),(43.265,16.235),(43.265,16.065),(43.095,16.065)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,16.405),(43.095,16.575),(43.265,16.575),(43.265,16.405),(43.095,16.405)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,16.745),(43.095,16.915),(43.265,16.915),(43.265,16.745),(43.095,16.745)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,16.065),(-43.265,16.235),(-43.095,16.235),(-43.095,16.065),(-43.265,16.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,16.405),(-43.265,16.575),(-43.095,16.575),(-43.095,16.405),(-43.265,16.405)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,16.745),(-43.265,16.915),(-43.095,16.915),(-43.095,16.745),(-43.265,16.745)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,8.925),(43.095,9.095),(43.265,9.095),(43.265,8.925),(43.095,8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,8.925),(-43.265,9.095),(-43.095,9.095),(-43.095,8.925),(-43.265,8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.255,19.915),(34.255,20.085),(34.425,20.085),(34.425,19.915),(34.255,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((34.595,19.915),(34.595,20.085),(34.765,20.085),(34.765,19.915),(34.595,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.825,19.915),(-20.825,20.085),(-20.655,20.085),(-20.655,19.915),(-20.825,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.485,19.915),(-20.485,20.085),(-20.315,20.085),(-20.315,19.915),(-20.485,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,7.225),(-43.265,7.395),(-43.095,7.395),(-43.095,7.225),(-43.265,7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,7.565),(-43.265,7.735),(-43.095,7.735),(-43.095,7.565),(-43.265,7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-7.735),(43.095,-7.565),(43.265,-7.565),(43.265,-7.735),(43.095,-7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-7.395),(43.095,-7.225),(43.265,-7.225),(43.265,-7.395),(43.095,-7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.825,-20.085),(-3.825,-19.915),(-3.655,-19.915),(-3.655,-20.085),(-3.825,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.485,-20.085),(-3.485,-19.915),(-3.315,-19.915),(-3.315,-20.085),(-3.485,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,11.985),(-43.265,12.155),(-43.095,12.155),(-43.095,11.985),(-43.265,11.985)),
        )
        createRL(
            tech, net, 'licon',
            ((3.315,-20.085),(3.315,-19.915),(3.485,-19.915),(3.485,-20.085),(3.315,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((3.655,-20.085),(3.655,-19.915),(3.825,-19.915),(3.825,-20.085),(3.655,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,19.125),(-43.265,19.295),(-43.095,19.295),(-43.095,19.125),(-43.265,19.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,19.465),(-43.265,19.635),(-43.095,19.635),(-43.095,19.465),(-43.265,19.465)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-19.635),(43.095,-19.465),(43.265,-19.465),(43.265,-19.635),(43.095,-19.635)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-19.295),(43.095,-19.125),(43.265,-19.125),(43.265,-19.295),(43.095,-19.295)),
        )
        createRL(
            tech, net, 'licon',
            ((41.055,19.915),(41.055,20.085),(41.225,20.085),(41.225,19.915),(41.055,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((41.395,19.915),(41.395,20.085),(41.565,20.085),(41.565,19.915),(41.395,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((41.735,19.915),(41.735,20.085),(41.905,20.085),(41.905,19.915),(41.735,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-8.075),(-43.265,-7.905),(-43.095,-7.905),(-43.095,-8.075),(-43.265,-8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-8.075),(43.095,-7.905),(43.265,-7.905),(43.265,-8.075),(43.095,-8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.105,-20.085),(-18.105,-19.915),(-17.935,-19.915),(-17.935,-20.085),(-18.105,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.955,-20.085),(18.955,-19.915),(19.125,-19.915),(19.125,-20.085),(18.955,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-17.595),(43.095,-17.425),(43.265,-17.425),(43.265,-17.595),(43.095,-17.595)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-17.255),(43.095,-17.085),(43.265,-17.085),(43.265,-17.255),(43.095,-17.255)),
        )
        createRL(
            tech, net, 'licon',
            ((18.615,-20.085),(18.615,-19.915),(18.785,-19.915),(18.785,-20.085),(18.615,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.935,19.915),(34.935,20.085),(35.105,20.085),(35.105,19.915),(34.935,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((25.075,19.915),(25.075,20.085),(25.245,20.085),(25.245,19.915),(25.075,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,19.915),(25.415,20.085),(25.585,20.085),(25.585,19.915),(25.415,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((25.755,19.915),(25.755,20.085),(25.925,20.085),(25.925,19.915),(25.755,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.145,-20.085),(-37.145,-19.915),(-36.975,-19.915),(-36.975,-20.085),(-37.145,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.765,-20.085),(-34.765,-19.915),(-34.595,-19.915),(-34.595,-20.085),(-34.765,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.425,-20.085),(-34.425,-19.915),(-34.255,-19.915),(-34.255,-20.085),(-34.425,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.255,-20.085),(34.255,-19.915),(34.425,-19.915),(34.425,-20.085),(34.255,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.595,-20.085),(34.595,-19.915),(34.765,-19.915),(34.765,-20.085),(34.595,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.905,-20.085),(-7.905,-19.915),(-7.735,-19.915),(-7.735,-20.085),(-7.905,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-12.835),(-43.265,-12.665),(-43.095,-12.665),(-43.095,-12.835),(-43.265,-12.835)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-12.495),(-43.265,-12.325),(-43.095,-12.325),(-43.095,-12.495),(-43.265,-12.495)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.565,-20.085),(-7.565,-19.915),(-7.395,-19.915),(-7.395,-20.085),(-7.565,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.225,-20.085),(-7.225,-19.915),(-7.055,-19.915),(-7.055,-20.085),(-7.225,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.055,-20.085),(7.055,-19.915),(7.225,-19.915),(7.225,-20.085),(7.055,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.395,-20.085),(7.395,-19.915),(7.565,-19.915),(7.565,-20.085),(7.395,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.735,-20.085),(7.735,-19.915),(7.905,-19.915),(7.905,-20.085),(7.735,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-12.835),(43.095,-12.665),(43.265,-12.665),(43.265,-12.835),(43.095,-12.835)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-12.495),(43.095,-12.325),(43.265,-12.325),(43.265,-12.495),(43.095,-12.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.035,19.915),(6.035,20.085),(6.205,20.085),(6.205,19.915),(6.035,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((6.375,19.915),(6.375,20.085),(6.545,20.085),(6.545,19.915),(6.375,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((6.715,19.915),(6.715,20.085),(6.885,20.085),(6.885,19.915),(6.715,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.165,-20.085),(-21.165,-19.915),(-20.995,-19.915),(-20.995,-20.085),(-21.165,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-10.795),(-43.265,-10.625),(-43.095,-10.625),(-43.095,-10.795),(-43.265,-10.795)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-10.455),(-43.265,-10.285),(-43.095,-10.285),(-43.095,-10.455),(-43.265,-10.455)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-10.795),(43.095,-10.625),(43.265,-10.625),(43.265,-10.795),(43.095,-10.795)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-10.455),(43.095,-10.285),(43.265,-10.285),(43.265,-10.455),(43.095,-10.455)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.145,-20.085),(-20.145,-19.915),(-19.975,-19.915),(-19.975,-20.085),(-20.145,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.115,19.915),(10.115,20.085),(10.285,20.085),(10.285,19.915),(10.115,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((10.455,19.915),(10.455,20.085),(10.625,20.085),(10.625,19.915),(10.455,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((10.795,19.915),(10.795,20.085),(10.965,20.085),(10.965,19.915),(10.795,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.865,19.915),(-5.865,20.085),(-5.695,20.085),(-5.695,19.915),(-5.865,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.525,19.915),(-5.525,20.085),(-5.355,20.085),(-5.355,19.915),(-5.525,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.185,19.915),(-5.185,20.085),(-5.015,20.085),(-5.015,19.915),(-5.185,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((13.855,-20.085),(13.855,-19.915),(14.025,-19.915),(14.025,-20.085),(13.855,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.845,19.915),(-38.845,20.085),(-38.675,20.085),(-38.675,19.915),(-38.845,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.505,19.915),(-38.505,20.085),(-38.335,20.085),(-38.335,19.915),(-38.505,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.045,-20.085),(-15.045,-19.915),(-14.875,-19.915),(-14.875,-20.085),(-15.045,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.765,-20.085),(-17.765,-19.915),(-17.595,-19.915),(-17.595,-20.085),(-17.765,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,12.325),(43.095,12.495),(43.265,12.495),(43.265,12.325),(43.095,12.325)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,12.665),(43.095,12.835),(43.265,12.835),(43.265,12.665),(43.095,12.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,12.325),(-43.265,12.495),(-43.095,12.495),(-43.095,12.325),(-43.265,12.325)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,12.665),(-43.265,12.835),(-43.095,12.835),(-43.095,12.665),(-43.265,12.665)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.425,-20.085),(-17.425,-19.915),(-17.255,-19.915),(-17.255,-20.085),(-17.425,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((17.255,-20.085),(17.255,-19.915),(17.425,-19.915),(17.425,-20.085),(17.255,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((17.595,-20.085),(17.595,-19.915),(17.765,-19.915),(17.765,-20.085),(17.595,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.275,19.915),(18.275,20.085),(18.445,20.085),(18.445,19.915),(18.275,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((18.615,19.915),(18.615,20.085),(18.785,20.085),(18.785,19.915),(18.615,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.065,19.915),(-33.065,20.085),(-32.895,20.085),(-32.895,19.915),(-33.065,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.185,19.915),(-22.185,20.085),(-22.015,20.085),(-22.015,19.915),(-22.185,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.865,19.915),(-22.865,20.085),(-22.695,20.085),(-22.695,19.915),(-22.865,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.525,19.915),(-22.525,20.085),(-22.355,20.085),(-22.355,19.915),(-22.525,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,0.085),(43.095,0.255),(43.265,0.255),(43.265,0.085),(43.095,0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,0.085),(-43.265,0.255),(-43.095,0.255),(-43.095,0.085),(-43.265,0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,1.105),(-43.265,1.275),(-43.095,1.275),(-43.095,1.105),(-43.265,1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-1.275),(43.095,-1.105),(43.265,-1.105),(43.265,-1.275),(43.095,-1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((35.275,19.915),(35.275,20.085),(35.445,20.085),(35.445,19.915),(35.275,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((35.615,19.915),(35.615,20.085),(35.785,20.085),(35.785,19.915),(35.615,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((31.195,19.915),(31.195,20.085),(31.365,20.085),(31.365,19.915),(31.195,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((31.535,19.915),(31.535,20.085),(31.705,20.085),(31.705,19.915),(31.535,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.615,19.915),(1.615,20.085),(1.785,20.085),(1.785,19.915),(1.615,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.265,19.915),(-26.265,20.085),(-26.095,20.085),(-26.095,19.915),(-26.265,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.945,19.915),(-26.945,20.085),(-26.775,20.085),(-26.775,19.915),(-26.945,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.605,19.915),(-26.605,20.085),(-26.435,20.085),(-26.435,19.915),(-26.605,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,6.885),(43.095,7.055),(43.265,7.055),(43.265,6.885),(43.095,6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,6.885),(-43.265,7.055),(-43.095,7.055),(-43.095,6.885),(-43.265,6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.895,19.915),(32.895,20.085),(33.065,20.085),(33.065,19.915),(32.895,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.165,19.915),(-38.165,20.085),(-37.995,20.085),(-37.995,19.915),(-38.165,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.685,-20.085),(-13.685,-19.915),(-13.515,-19.915),(-13.515,-20.085),(-13.685,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.955,19.915),(18.955,20.085),(19.125,20.085),(19.125,19.915),(18.955,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.345,-20.085),(-13.345,-19.915),(-13.175,-19.915),(-13.175,-20.085),(-13.345,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.175,-20.085),(13.175,-19.915),(13.345,-19.915),(13.345,-20.085),(13.175,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.515,-20.085),(13.515,-19.915),(13.685,-19.915),(13.685,-20.085),(13.515,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.145,19.915),(-3.145,20.085),(-2.975,20.085),(-2.975,19.915),(-3.145,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((16.915,-20.085),(16.915,-19.915),(17.085,-19.915),(17.085,-20.085),(16.915,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((39.015,19.915),(39.015,20.085),(39.185,20.085),(39.185,19.915),(39.015,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((39.355,19.915),(39.355,20.085),(39.525,20.085),(39.525,19.915),(39.355,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((39.695,19.915),(39.695,20.085),(39.865,20.085),(39.865,19.915),(39.695,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,1.445),(43.095,1.615),(43.265,1.615),(43.265,1.445),(43.095,1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.425,19.915),(-0.425,20.085),(-0.255,20.085),(-0.255,19.915),(-0.425,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,13.005),(-43.265,13.175),(-43.095,13.175),(-43.095,13.005),(-43.265,13.005)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,13.345),(-43.265,13.515),(-43.095,13.515),(-43.095,13.345),(-43.265,13.345)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,13.685),(-43.265,13.855),(-43.095,13.855),(-43.095,13.685),(-43.265,13.685)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-13.855),(43.095,-13.685),(43.265,-13.685),(43.265,-13.855),(43.095,-13.855)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-13.515),(43.095,-13.345),(43.265,-13.345),(43.265,-13.515),(43.095,-13.515)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-13.175),(43.095,-13.005),(43.265,-13.005),(43.265,-13.175),(43.095,-13.175)),
        )
        createRL(
            tech, net, 'licon',
            ((22.695,-20.085),(22.695,-19.915),(22.865,-19.915),(22.865,-20.085),(22.695,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.135,19.915),(11.135,20.085),(11.305,20.085),(11.305,19.915),(11.135,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((11.475,19.915),(11.475,20.085),(11.645,20.085),(11.645,19.915),(11.475,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((11.815,19.915),(11.815,20.085),(11.985,20.085),(11.985,19.915),(11.815,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-9.095),(-43.265,-8.925),(-43.095,-8.925),(-43.095,-9.095),(-43.265,-9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-0.255),(-43.265,-0.085),(-43.095,-0.085),(-43.095,-0.255),(-43.265,-0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-0.255),(43.095,-0.085),(43.265,-0.085),(43.265,-0.255),(43.095,-0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.845,19.915),(-4.845,20.085),(-4.675,20.085),(-4.675,19.915),(-4.845,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.505,19.915),(-4.505,20.085),(-4.335,20.085),(-4.335,19.915),(-4.505,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.445,-20.085),(-1.445,-19.915),(-1.275,-19.915),(-1.275,-20.085),(-1.445,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,-20.085),(1.275,-19.915),(1.445,-19.915),(1.445,-20.085),(1.275,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,19.915),(-43.265,20.085),(-43.095,20.085),(-43.095,19.915),(-43.265,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.885,-20.085),(-40.885,-19.915),(-40.715,-19.915),(-40.715,-20.085),(-40.885,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.295,19.915),(2.295,20.085),(2.465,20.085),(2.465,19.915),(2.295,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.635,19.915),(2.635,20.085),(2.805,20.085),(2.805,19.915),(2.635,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.545,-20.085),(-40.545,-19.915),(-40.375,-19.915),(-40.375,-20.085),(-40.545,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.205,-20.085),(-40.205,-19.915),(-40.035,-19.915),(-40.035,-20.085),(-40.205,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.995,-20.085),(37.995,-19.915),(38.165,-19.915),(38.165,-20.085),(37.995,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,3.145),(43.095,3.315),(43.265,3.315),(43.265,3.145),(43.095,3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,3.485),(43.095,3.655),(43.265,3.655),(43.265,3.485),(43.095,3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,3.825),(43.095,3.995),(43.265,3.995),(43.265,3.825),(43.095,3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-3.995),(-43.265,-3.825),(-43.095,-3.825),(-43.095,-3.995),(-43.265,-3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-3.655),(-43.265,-3.485),(-43.095,-3.485),(-43.095,-3.655),(-43.265,-3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-3.315),(-43.265,-3.145),(-43.095,-3.145),(-43.095,-3.315),(-43.265,-3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.725,19.915),(-32.725,20.085),(-32.555,20.085),(-32.555,19.915),(-32.725,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.385,19.915),(-32.385,20.085),(-32.215,20.085),(-32.215,19.915),(-32.385,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.625,19.915),(-27.625,20.085),(-27.455,20.085),(-27.455,19.915),(-27.625,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.285,19.915),(-27.285,20.085),(-27.115,20.085),(-27.115,19.915),(-27.285,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.965,19.915),(-27.965,20.085),(-27.795,20.085),(-27.795,19.915),(-27.965,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.145,19.915),(-37.145,20.085),(-36.975,20.085),(-36.975,19.915),(-37.145,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((15.215,19.915),(15.215,20.085),(15.385,20.085),(15.385,19.915),(15.215,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((15.555,19.915),(15.555,20.085),(15.725,20.085),(15.725,19.915),(15.555,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((9.095,19.915),(9.095,20.085),(9.265,20.085),(9.265,19.915),(9.095,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((9.435,19.915),(9.435,20.085),(9.605,20.085),(9.605,19.915),(9.435,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((9.775,19.915),(9.775,20.085),(9.945,20.085),(9.945,19.915),(9.775,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((16.915,19.915),(16.915,20.085),(17.085,20.085),(17.085,19.915),(16.915,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-12.155),(-43.265,-11.985),(-43.095,-11.985),(-43.095,-12.155),(-43.265,-12.155)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-12.155),(43.095,-11.985),(43.265,-11.985),(43.265,-12.155),(43.095,-12.155)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.765,19.915),(-34.765,20.085),(-34.595,20.085),(-34.595,19.915),(-34.765,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.425,19.915),(-34.425,20.085),(-34.255,20.085),(-34.255,19.915),(-34.425,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-10.115),(-43.265,-9.945),(-43.095,-9.945),(-43.095,-10.115),(-43.265,-10.115)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-10.115),(43.095,-9.945),(43.265,-9.945),(43.265,-10.115),(43.095,-10.115)),
        )
        createRL(
            tech, net, 'licon',
            ((33.915,19.915),(33.915,20.085),(34.085,20.085),(34.085,19.915),(33.915,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.825,-20.085),(-37.825,-19.915),(-37.655,-19.915),(-37.655,-20.085),(-37.825,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.485,-20.085),(-37.485,-19.915),(-37.315,-19.915),(-37.315,-20.085),(-37.485,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.315,-20.085),(37.315,-19.915),(37.485,-19.915),(37.485,-20.085),(37.315,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.655,-20.085),(37.655,-19.915),(37.825,-19.915),(37.825,-20.085),(37.655,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.905,19.915),(-41.905,20.085),(-41.735,20.085),(-41.735,19.915),(-41.905,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.565,19.915),(-41.565,20.085),(-41.395,20.085),(-41.395,19.915),(-41.565,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.225,19.915),(-41.225,20.085),(-41.055,20.085),(-41.055,19.915),(-41.225,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.005,19.915),(-13.005,20.085),(-12.835,20.085),(-12.835,19.915),(-13.005,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.845,-20.085),(-21.845,-19.915),(-21.675,-19.915),(-21.675,-20.085),(-21.845,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.085,19.915),(-34.085,20.085),(-33.915,20.085),(-33.915,19.915),(-34.085,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.505,-20.085),(-21.505,-19.915),(-21.335,-19.915),(-21.335,-20.085),(-21.505,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.335,-20.085),(21.335,-19.915),(21.505,-19.915),(21.505,-20.085),(21.335,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.675,-20.085),(21.675,-19.915),(21.845,-19.915),(21.845,-20.085),(21.675,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((12.835,19.915),(12.835,20.085),(13.005,20.085),(13.005,19.915),(12.835,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.045,-20.085),(-32.045,-19.915),(-31.875,-19.915),(-31.875,-20.085),(-32.045,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.925,19.915),(-25.925,20.085),(-25.755,20.085),(-25.755,19.915),(-25.925,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.585,19.915),(-25.585,20.085),(-25.415,20.085),(-25.415,19.915),(-25.585,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.245,19.915),(-25.245,20.085),(-25.075,20.085),(-25.075,19.915),(-25.245,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((39.355,-20.085),(39.355,-19.915),(39.525,-19.915),(39.525,-20.085),(39.355,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.085,19.915),(-17.085,20.085),(-16.915,20.085),(-16.915,19.915),(-17.085,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((33.235,19.915),(33.235,20.085),(33.405,20.085),(33.405,19.915),(33.235,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((33.575,19.915),(33.575,20.085),(33.745,20.085),(33.745,19.915),(33.575,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((28.135,-20.085),(28.135,-19.915),(28.305,-19.915),(28.305,-20.085),(28.135,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.475,-20.085),(28.475,-19.915),(28.645,-19.915),(28.645,-20.085),(28.475,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.815,-20.085),(28.815,-19.915),(28.985,-19.915),(28.985,-20.085),(28.815,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.885,19.915),(-6.885,20.085),(-6.715,20.085),(-6.715,19.915),(-6.885,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.545,19.915),(-6.545,20.085),(-6.375,20.085),(-6.375,19.915),(-6.545,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.205,19.915),(-6.205,20.085),(-6.035,20.085),(-6.035,19.915),(-6.205,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((19.295,19.915),(19.295,20.085),(19.465,20.085),(19.465,19.915),(19.295,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((19.635,19.915),(19.635,20.085),(19.805,20.085),(19.805,19.915),(19.635,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.425,-20.085),(-0.425,-19.915),(-0.255,-19.915),(-0.255,-20.085),(-0.425,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.965,19.915),(-10.965,20.085),(-10.795,20.085),(-10.795,19.915),(-10.965,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.625,19.915),(-10.625,20.085),(-10.455,20.085),(-10.455,19.915),(-10.625,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.285,19.915),(-10.285,20.085),(-10.115,20.085),(-10.115,19.915),(-10.285,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.105,19.915),(-35.105,20.085),(-34.935,20.085),(-34.935,19.915),(-35.105,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.025,19.915),(-31.025,20.085),(-30.855,20.085),(-30.855,19.915),(-31.025,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.785,-20.085),(-18.785,-19.915),(-18.615,-19.915),(-18.615,-20.085),(-18.785,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.445,-20.085),(-18.445,-19.915),(-18.275,-19.915),(-18.275,-20.085),(-18.445,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.745,19.915),(-16.745,20.085),(-16.575,20.085),(-16.575,19.915),(-16.745,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.405,19.915),(-16.405,20.085),(-16.235,20.085),(-16.235,19.915),(-16.405,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,7.905),(43.095,8.075),(43.265,8.075),(43.265,7.905),(43.095,7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-2.975),(-43.265,-2.805),(-43.095,-2.805),(-43.095,-2.975),(-43.265,-2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-2.635),(-43.265,-2.465),(-43.095,-2.465),(-43.095,-2.635),(-43.265,-2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-2.295),(-43.265,-2.125),(-43.095,-2.125),(-43.095,-2.295),(-43.265,-2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-2.975),(43.095,-2.805),(43.265,-2.805),(43.265,-2.975),(43.095,-2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-2.635),(43.095,-2.465),(43.265,-2.465),(43.265,-2.635),(43.095,-2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-2.295),(43.095,-2.125),(43.265,-2.125),(43.265,-2.295),(43.095,-2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((33.915,-20.085),(33.915,-19.915),(34.085,-19.915),(34.085,-20.085),(33.915,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-16.915),(-43.265,-16.745),(-43.095,-16.745),(-43.095,-16.915),(-43.265,-16.915)),
        )
        createRL(
            tech, net, 'licon',
            ((23.035,19.915),(23.035,20.085),(23.205,20.085),(23.205,19.915),(23.035,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((23.375,19.915),(23.375,20.085),(23.545,20.085),(23.545,19.915),(23.375,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((23.715,19.915),(23.715,20.085),(23.885,20.085),(23.885,19.915),(23.715,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-16.575),(-43.265,-16.405),(-43.095,-16.405),(-43.095,-16.575),(-43.265,-16.575)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-16.235),(-43.265,-16.065),(-43.095,-16.065),(-43.095,-16.235),(-43.265,-16.235)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-16.915),(43.095,-16.745),(43.265,-16.745),(43.265,-16.915),(43.095,-16.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-16.575),(43.095,-16.405),(43.265,-16.405),(43.265,-16.575),(43.095,-16.575)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-16.235),(43.095,-16.065),(43.265,-16.065),(43.265,-16.235),(43.095,-16.235)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.785,19.915),(-18.785,20.085),(-18.615,20.085),(-18.615,19.915),(-18.785,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.445,19.915),(-18.445,20.085),(-18.275,20.085),(-18.275,19.915),(-18.445,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,5.865),(43.095,6.035),(43.265,6.035),(43.265,5.865),(43.095,5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-14.875),(-43.265,-14.705),(-43.095,-14.705),(-43.095,-14.875),(-43.265,-14.875)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-14.535),(-43.265,-14.365),(-43.095,-14.365),(-43.095,-14.535),(-43.265,-14.535)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-14.195),(-43.265,-14.025),(-43.095,-14.025),(-43.095,-14.195),(-43.265,-14.195)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-14.875),(43.095,-14.705),(43.265,-14.705),(43.265,-14.875),(43.095,-14.875)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-14.535),(43.095,-14.365),(43.265,-14.365),(43.265,-14.535),(43.095,-14.535)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-14.195),(43.095,-14.025),(43.265,-14.025),(43.265,-14.195),(43.095,-14.195)),
        )
        createRL(
            tech, net, 'licon',
            ((3.995,-20.085),(3.995,-19.915),(4.165,-19.915),(4.165,-20.085),(3.995,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.785,19.915),(-35.785,20.085),(-35.615,20.085),(-35.615,19.915),(-35.785,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.445,19.915),(-35.445,20.085),(-35.275,20.085),(-35.275,19.915),(-35.445,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.785,19.915),(-1.785,20.085),(-1.615,20.085),(-1.615,19.915),(-1.785,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.705,19.915),(-31.705,20.085),(-31.535,20.085),(-31.535,19.915),(-31.705,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.365,19.915),(-31.365,20.085),(-31.195,20.085),(-31.195,19.915),(-31.365,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.005,-20.085),(-30.005,-19.915),(-29.835,-19.915),(-29.835,-20.085),(-30.005,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.855,-20.085),(30.855,-19.915),(31.025,-19.915),(31.025,-20.085),(30.855,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.105,19.915),(-18.105,20.085),(-17.935,20.085),(-17.935,19.915),(-18.105,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((29.835,19.915),(29.835,20.085),(30.005,20.085),(30.005,19.915),(29.835,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.065,-20.085),(-16.065,-19.915),(-15.895,-19.915),(-15.895,-20.085),(-16.065,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.865,19.915),(-39.865,20.085),(-39.695,20.085),(-39.695,19.915),(-39.865,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.525,19.915),(-39.525,20.085),(-39.355,20.085),(-39.355,19.915),(-39.525,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.185,19.915),(-39.185,20.085),(-39.015,20.085),(-39.015,19.915),(-39.185,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,1.445),(-43.265,1.615),(-43.095,1.615),(-43.095,1.445),(-43.265,1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.905,-20.085),(-24.905,-19.915),(-24.735,-19.915),(-24.735,-20.085),(-24.905,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.565,-20.085),(-24.565,-19.915),(-24.395,-19.915),(-24.395,-20.085),(-24.565,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.225,-20.085),(-24.225,-19.915),(-24.055,-19.915),(-24.055,-20.085),(-24.225,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((36.975,19.915),(36.975,20.085),(37.145,20.085),(37.145,19.915),(36.975,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((28.475,19.915),(28.475,20.085),(28.645,20.085),(28.645,19.915),(28.475,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((28.815,19.915),(28.815,20.085),(28.985,20.085),(28.985,19.915),(28.815,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((28.135,19.915),(28.135,20.085),(28.305,20.085),(28.305,19.915),(28.135,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.745,-20.085),(-33.745,-19.915),(-33.575,-19.915),(-33.575,-20.085),(-33.745,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.405,-20.085),(-33.405,-19.915),(-33.235,-19.915),(-33.235,-20.085),(-33.405,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.235,-20.085),(33.235,-19.915),(33.405,-19.915),(33.405,-20.085),(33.235,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.575,-20.085),(33.575,-19.915),(33.745,-19.915),(33.745,-20.085),(33.575,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.985,19.915),(-11.985,20.085),(-11.815,20.085),(-11.815,19.915),(-11.985,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.645,19.915),(-11.645,20.085),(-11.475,20.085),(-11.475,19.915),(-11.645,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.305,19.915),(-11.305,20.085),(-11.135,20.085),(-11.135,19.915),(-11.305,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.125,-20.085),(-2.125,-19.915),(-1.955,-19.915),(-1.955,-20.085),(-2.125,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-9.095),(43.095,-8.925),(43.265,-8.925),(43.265,-9.095),(43.095,-9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((42.755,-20.085),(42.755,-19.915),(42.925,-19.915),(42.925,-20.085),(42.755,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.165,19.915),(-21.165,20.085),(-20.995,20.085),(-20.995,19.915),(-21.165,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-20.085),(-43.265,-19.915),(-43.095,-19.915),(-43.095,-20.085),(-43.265,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-20.085),(43.095,-19.915),(43.265,-19.915),(43.265,-20.085),(43.095,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.995,19.915),(20.995,20.085),(21.165,20.085),(21.165,19.915),(20.995,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,1.785),(43.095,1.955),(43.265,1.955),(43.265,1.785),(43.095,1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.045,19.915),(-15.045,20.085),(-14.875,20.085),(-14.875,19.915),(-15.045,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-1.955),(-43.265,-1.785),(-43.095,-1.785),(-43.095,-1.955),(-43.265,-1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((0.255,19.915),(0.255,20.085),(0.425,20.085),(0.425,19.915),(0.255,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.805,-20.085),(-2.805,-19.915),(-2.635,-19.915),(-2.635,-20.085),(-2.805,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((29.155,19.915),(29.155,20.085),(29.325,20.085),(29.325,19.915),(29.155,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((29.495,19.915),(29.495,20.085),(29.665,20.085),(29.665,19.915),(29.495,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.465,-20.085),(-2.465,-19.915),(-2.295,-19.915),(-2.295,-20.085),(-2.465,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.475,-20.085),(11.475,-19.915),(11.645,-19.915),(11.645,-20.085),(11.475,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.295,-20.085),(2.295,-19.915),(2.465,-19.915),(2.465,-20.085),(2.295,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.635,-20.085),(2.635,-19.915),(2.805,-19.915),(2.805,-20.085),(2.635,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.985,-20.085),(-28.985,-19.915),(-28.815,-19.915),(-28.815,-20.085),(-28.985,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.645,-20.085),(-28.645,-19.915),(-28.475,-19.915),(-28.475,-20.085),(-28.645,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.305,-20.085),(-28.305,-19.915),(-28.135,-19.915),(-28.135,-20.085),(-28.305,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((36.295,-20.085),(36.295,-19.915),(36.465,-19.915),(36.465,-20.085),(36.295,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((36.635,-20.085),(36.635,-19.915),(36.805,-19.915),(36.805,-20.085),(36.635,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.165,19.915),(-4.165,20.085),(-3.995,20.085),(-3.995,19.915),(-4.165,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((17.935,-20.085),(17.935,-19.915),(18.105,-19.915),(18.105,-20.085),(17.935,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.175,19.915),(30.175,20.085),(30.345,20.085),(30.345,19.915),(30.175,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.915),(30.515,20.085),(30.685,20.085),(30.685,19.915),(30.515,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.805,19.915),(-2.805,20.085),(-2.635,20.085),(-2.635,19.915),(-2.805,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.465,19.915),(-2.465,20.085),(-2.295,20.085),(-2.295,19.915),(-2.465,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,3.485),(-43.265,3.655),(-43.095,3.655),(-43.095,3.485),(-43.265,3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,3.825),(-43.265,3.995),(-43.095,3.995),(-43.095,3.825),(-43.265,3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,3.145),(-43.265,3.315),(-43.095,3.315),(-43.095,3.145),(-43.265,3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-3.995),(43.095,-3.825),(43.265,-3.825),(43.265,-3.995),(43.095,-3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-3.655),(43.095,-3.485),(43.265,-3.485),(43.265,-3.655),(43.095,-3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-3.315),(43.095,-3.145),(43.265,-3.145),(43.265,-3.315),(43.095,-3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((3.995,19.915),(3.995,20.085),(4.165,20.085),(4.165,19.915),(3.995,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.725,19.915),(-15.725,20.085),(-15.555,20.085),(-15.555,19.915),(-15.725,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.385,19.915),(-15.385,20.085),(-15.215,20.085),(-15.215,19.915),(-15.385,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.865,-20.085),(-5.865,-19.915),(-5.695,-19.915),(-5.695,-20.085),(-5.865,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.525,-20.085),(-5.525,-19.915),(-5.355,-19.915),(-5.355,-20.085),(-5.525,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.185,-20.085),(-5.185,-19.915),(-5.015,-19.915),(-5.015,-20.085),(-5.185,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((5.015,-20.085),(5.015,-19.915),(5.185,-19.915),(5.185,-20.085),(5.015,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((5.355,-20.085),(5.355,-19.915),(5.525,-19.915),(5.525,-20.085),(5.355,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((5.695,-20.085),(5.695,-19.915),(5.865,-19.915),(5.865,-20.085),(5.695,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.945,19.915),(-9.945,20.085),(-9.775,20.085),(-9.775,19.915),(-9.945,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.605,19.915),(-9.605,20.085),(-9.435,20.085),(-9.435,19.915),(-9.605,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.265,19.915),(-9.265,20.085),(-9.095,20.085),(-9.095,19.915),(-9.265,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.025,-20.085),(-14.025,-19.915),(-13.855,-19.915),(-13.855,-20.085),(-14.025,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((14.875,-20.085),(14.875,-19.915),(15.045,-19.915),(15.045,-20.085),(14.875,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.905,-20.085),(-41.905,-19.915),(-41.735,-19.915),(-41.735,-20.085),(-41.905,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.565,-20.085),(-41.565,-19.915),(-41.395,-19.915),(-41.395,-20.085),(-41.565,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.225,-20.085),(-41.225,-19.915),(-41.055,-19.915),(-41.055,-20.085),(-41.225,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((12.155,-20.085),(12.155,-19.915),(12.325,-19.915),(12.325,-20.085),(12.155,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((12.495,-20.085),(12.495,-19.915),(12.665,-19.915),(12.665,-20.085),(12.495,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.055,-20.085),(41.055,-19.915),(41.225,-19.915),(41.225,-20.085),(41.055,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.395,-20.085),(41.395,-19.915),(41.565,-19.915),(41.565,-20.085),(41.395,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.735,-20.085),(41.735,-19.915),(41.905,-19.915),(41.905,-20.085),(41.735,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.855,19.915),(30.855,20.085),(31.025,20.085),(31.025,19.915),(30.855,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((3.315,19.915),(3.315,20.085),(3.485,20.085),(3.485,19.915),(3.315,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((3.655,19.915),(3.655,20.085),(3.825,20.085),(3.825,19.915),(3.655,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,10.625),(43.095,10.795),(43.265,10.795),(43.265,10.625),(43.095,10.625)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,10.285),(43.095,10.455),(43.265,10.455),(43.265,10.285),(43.095,10.285)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,10.285),(-43.265,10.455),(-43.095,10.455),(-43.095,10.285),(-43.265,10.285)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,10.625),(-43.265,10.795),(-43.095,10.795),(-43.095,10.625),(-43.265,10.625)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.125,19.915),(-19.125,20.085),(-18.955,20.085),(-18.955,19.915),(-19.125,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((31.875,-20.085),(31.875,-19.915),(32.045,-19.915),(32.045,-20.085),(31.875,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-11.135),(-43.265,-10.965),(-43.095,-10.965),(-43.095,-11.135),(-43.265,-11.135)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.145,-20.085),(-3.145,-19.915),(-2.975,-19.915),(-2.975,-20.085),(-3.145,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.995,19.915),(37.995,20.085),(38.165,20.085),(38.165,19.915),(37.995,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((7.055,19.915),(7.055,20.085),(7.225,20.085),(7.225,19.915),(7.055,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((7.395,19.915),(7.395,20.085),(7.565,20.085),(7.565,19.915),(7.395,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((7.735,19.915),(7.735,20.085),(7.905,20.085),(7.905,19.915),(7.735,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((17.935,19.915),(17.935,20.085),(18.105,20.085),(18.105,19.915),(17.935,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((24.395,19.915),(24.395,20.085),(24.565,20.085),(24.565,19.915),(24.395,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,5.185),(43.095,5.355),(43.265,5.355),(43.265,5.185),(43.095,5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,9.945),(43.095,10.115),(43.265,10.115),(43.265,9.945),(43.095,9.945)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,5.525),(43.095,5.695),(43.265,5.695),(43.265,5.525),(43.095,5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-5.695),(-43.265,-5.525),(-43.095,-5.525),(-43.095,-5.695),(-43.265,-5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-5.355),(-43.265,-5.185),(-43.095,-5.185),(-43.095,-5.355),(-43.265,-5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.745,19.915),(-33.745,20.085),(-33.575,20.085),(-33.575,19.915),(-33.745,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.405,19.915),(-33.405,20.085),(-33.235,20.085),(-33.235,19.915),(-33.405,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((40.035,19.915),(40.035,20.085),(40.205,20.085),(40.205,19.915),(40.035,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((40.375,19.915),(40.375,20.085),(40.545,20.085),(40.545,19.915),(40.375,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((40.715,19.915),(40.715,20.085),(40.885,20.085),(40.885,19.915),(40.715,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,17.085),(43.095,17.255),(43.265,17.255),(43.265,17.085),(43.095,17.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,17.425),(43.095,17.595),(43.265,17.595),(43.265,17.425),(43.095,17.425)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,17.765),(43.095,17.935),(43.265,17.935),(43.265,17.765),(43.095,17.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-17.935),(-43.265,-17.765),(-43.095,-17.765),(-43.095,-17.935),(-43.265,-17.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-17.595),(-43.265,-17.425),(-43.095,-17.425),(-43.095,-17.595),(-43.265,-17.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.465,19.915),(-19.465,20.085),(-19.295,20.085),(-19.295,19.915),(-19.465,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.805,19.915),(-19.805,20.085),(-19.635,20.085),(-19.635,19.915),(-19.805,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((14.195,19.915),(14.195,20.085),(14.365,20.085),(14.365,19.915),(14.195,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((14.535,19.915),(14.535,20.085),(14.705,20.085),(14.705,19.915),(14.535,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-17.255),(-43.265,-17.085),(-43.095,-17.085),(-43.095,-17.255),(-43.265,-17.255)),
        )
        createRL(
            tech, net, 'licon',
            ((32.215,-20.085),(32.215,-19.915),(32.385,-19.915),(32.385,-20.085),(32.215,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.555,-20.085),(32.555,-19.915),(32.725,-19.915),(32.725,-20.085),(32.555,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.315,19.915),(37.315,20.085),(37.485,20.085),(37.485,19.915),(37.315,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((37.655,19.915),(37.655,20.085),(37.825,20.085),(37.825,19.915),(37.655,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,7.905),(-43.265,8.075),(-43.095,8.075),(-43.095,7.905),(-43.265,7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,18.445),(43.095,18.615),(43.265,18.615),(43.265,18.445),(43.095,18.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.695,-20.085),(39.695,-19.915),(39.865,-19.915),(39.865,-20.085),(39.695,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((17.255,19.915),(17.255,20.085),(17.425,20.085),(17.425,19.915),(17.255,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((17.595,19.915),(17.595,20.085),(17.765,20.085),(17.765,19.915),(17.595,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.805,-20.085),(-36.805,-19.915),(-36.635,-19.915),(-36.635,-20.085),(-36.805,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.465,-20.085),(-36.465,-19.915),(-36.295,-19.915),(-36.295,-20.085),(-36.465,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.855,19.915),(13.855,20.085),(14.025,20.085),(14.025,19.915),(13.855,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.205,19.915),(-23.205,20.085),(-23.035,20.085),(-23.035,19.915),(-23.205,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.885,19.915),(-23.885,20.085),(-23.715,20.085),(-23.715,19.915),(-23.885,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.545,19.915),(-23.545,20.085),(-23.375,20.085),(-23.375,19.915),(-23.545,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.925,-20.085),(-8.925,-19.915),(-8.755,-19.915),(-8.755,-20.085),(-8.925,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.585,-20.085),(-8.585,-19.915),(-8.415,-19.915),(-8.415,-20.085),(-8.585,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.245,-20.085),(-8.245,-19.915),(-8.075,-19.915),(-8.075,-20.085),(-8.245,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,5.865),(-43.265,6.035),(-43.095,6.035),(-43.095,5.865),(-43.265,5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.275,-20.085),(18.275,-19.915),(18.445,-19.915),(18.445,-20.085),(18.275,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((14.875,19.915),(14.875,20.085),(15.045,20.085),(15.045,19.915),(14.875,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((12.155,19.915),(12.155,20.085),(12.325,20.085),(12.325,19.915),(12.155,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((12.495,19.915),(12.495,20.085),(12.665,20.085),(12.665,19.915),(12.495,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((40.035,-20.085),(40.035,-19.915),(40.205,-19.915),(40.205,-20.085),(40.035,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.375,-20.085),(40.375,-19.915),(40.545,-19.915),(40.545,-20.085),(40.375,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.715,-20.085),(40.715,-19.915),(40.885,-19.915),(40.885,-20.085),(40.715,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.965,-20.085),(-27.965,-19.915),(-27.795,-19.915),(-27.795,-20.085),(-27.965,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-6.715),(-43.265,-6.545),(-43.095,-6.545),(-43.095,-6.715),(-43.265,-6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-6.375),(-43.265,-6.205),(-43.095,-6.205),(-43.095,-6.375),(-43.265,-6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.625,-20.085),(-27.625,-19.915),(-27.455,-19.915),(-27.455,-20.085),(-27.625,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.285,-20.085),(-27.285,-19.915),(-27.115,-19.915),(-27.115,-20.085),(-27.285,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-6.715),(43.095,-6.545),(43.265,-6.545),(43.265,-6.715),(43.095,-6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-6.375),(43.095,-6.205),(43.265,-6.205),(43.265,-6.375),(43.095,-6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((27.115,-20.085),(27.115,-19.915),(27.285,-19.915),(27.285,-20.085),(27.115,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.455,-20.085),(27.455,-19.915),(27.625,-19.915),(27.625,-20.085),(27.455,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.795,-20.085),(27.795,-19.915),(27.965,-19.915),(27.965,-20.085),(27.795,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.105,-20.085),(-1.105,-19.915),(-0.935,-19.915),(-0.935,-20.085),(-1.105,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,15.045),(43.095,15.215),(43.265,15.215),(43.265,15.045),(43.095,15.045)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,15.385),(43.095,15.555),(43.265,15.555),(43.265,15.385),(43.095,15.385)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,15.725),(43.095,15.895),(43.265,15.895),(43.265,15.725),(43.095,15.725)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.045,19.915),(-32.045,20.085),(-31.875,20.085),(-31.875,19.915),(-32.045,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-15.895),(-43.265,-15.725),(-43.095,-15.725),(-43.095,-15.895),(-43.265,-15.895)),
        )
        createRL(
            tech, net, 'licon',
            ((13.175,19.915),(13.175,20.085),(13.345,20.085),(13.345,19.915),(13.175,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((13.515,19.915),(13.515,20.085),(13.685,20.085),(13.685,19.915),(13.515,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-15.555),(-43.265,-15.385),(-43.095,-15.385),(-43.095,-15.555),(-43.265,-15.555)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-15.215),(-43.265,-15.045),(-43.095,-15.045),(-43.095,-15.215),(-43.265,-15.215)),
        )
        createRL(
            tech, net, 'licon',
            ((24.055,-20.085),(24.055,-19.915),(24.225,-19.915),(24.225,-20.085),(24.055,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((24.395,-20.085),(24.395,-19.915),(24.565,-19.915),(24.565,-20.085),(24.395,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((24.735,-20.085),(24.735,-19.915),(24.905,-19.915),(24.905,-20.085),(24.735,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.665,-20.085),(-12.665,-19.915),(-12.495,-19.915),(-12.495,-20.085),(-12.665,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.325,-20.085),(-12.325,-19.915),(-12.155,-19.915),(-12.155,-20.085),(-12.325,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.315,-20.085),(20.315,-19.915),(20.485,-19.915),(20.485,-20.085),(20.315,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.655,-20.085),(20.655,-19.915),(20.825,-19.915),(20.825,-20.085),(20.655,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,0.425),(43.095,0.595),(43.265,0.595),(43.265,0.425),(43.095,0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,0.425),(-43.265,0.595),(-43.095,0.595),(-43.095,0.425),(-43.265,0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.955,19.915),(35.955,20.085),(36.125,20.085),(36.125,19.915),(35.955,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.085,-20.085),(-0.085,-19.915),(0.085,-19.915),(0.085,-20.085),(-0.085,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.935,-20.085),(0.935,-19.915),(1.105,-19.915),(1.105,-20.085),(0.935,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-4.675),(-43.265,-4.505),(-43.095,-4.505),(-43.095,-4.675),(-43.265,-4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-4.335),(-43.265,-4.165),(-43.095,-4.165),(-43.095,-4.335),(-43.265,-4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-4.675),(43.095,-4.505),(43.265,-4.505),(43.265,-4.675),(43.095,-4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-4.335),(43.095,-4.165),(43.265,-4.165),(43.265,-4.335),(43.095,-4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,1.785),(-43.265,1.955),(-43.095,1.955),(-43.095,1.785),(-43.265,1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.685,-20.085),(-30.685,-19.915),(-30.515,-19.915),(-30.515,-20.085),(-30.685,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.345,-20.085),(-30.345,-19.915),(-30.175,-19.915),(-30.175,-20.085),(-30.345,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-1.955),(43.095,-1.785),(43.265,-1.785),(43.265,-1.955),(43.095,-1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((30.175,-20.085),(30.175,-19.915),(30.345,-19.915),(30.345,-20.085),(30.175,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.665,19.915),(-29.665,20.085),(-29.495,20.085),(-29.495,19.915),(-29.665,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.325,19.915),(-29.325,20.085),(-29.155,20.085),(-29.155,19.915),(-29.325,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,-20.085),(30.515,-19.915),(30.685,-19.915),(30.685,-20.085),(30.515,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.925,-20.085),(-25.925,-19.915),(-25.755,-19.915),(-25.755,-20.085),(-25.925,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.585,-20.085),(-25.585,-19.915),(-25.415,-19.915),(-25.415,-20.085),(-25.585,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,19.915),(1.275,20.085),(1.445,20.085),(1.445,19.915),(1.275,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.245,-20.085),(-25.245,-19.915),(-25.075,-19.915),(-25.075,-20.085),(-25.245,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.075,-20.085),(25.075,-19.915),(25.245,-19.915),(25.245,-20.085),(25.075,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,-20.085),(25.415,-19.915),(25.585,-19.915),(25.585,-20.085),(25.415,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.755,-20.085),(25.755,-19.915),(25.925,-19.915),(25.925,-20.085),(25.755,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.975,-20.085),(2.975,-19.915),(3.145,-19.915),(3.145,-20.085),(2.975,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.685,19.915),(-30.685,20.085),(-30.515,20.085),(-30.515,19.915),(-30.685,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.345,19.915),(-30.345,20.085),(-30.175,20.085),(-30.175,19.915),(-30.345,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-7.055),(-43.265,-6.885),(-43.095,-6.885),(-43.095,-7.055),(-43.265,-7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,10.965),(43.095,11.135),(43.265,11.135),(43.265,10.965),(43.095,10.965)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,10.965),(-43.265,11.135),(-43.095,11.135),(-43.095,10.965),(-43.265,10.965)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.845,-20.085),(-38.845,-19.915),(-38.675,-19.915),(-38.675,-20.085),(-38.845,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.505,-20.085),(-38.505,-19.915),(-38.335,-19.915),(-38.335,-20.085),(-38.505,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((38.335,-20.085),(38.335,-19.915),(38.505,-19.915),(38.505,-20.085),(38.335,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,-20.085),(38.675,-19.915),(38.845,-19.915),(38.845,-20.085),(38.675,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.895,-20.085),(15.895,-19.915),(16.065,-19.915),(16.065,-20.085),(15.895,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.955,-20.085),(35.955,-19.915),(36.125,-19.915),(36.125,-20.085),(35.955,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-1.615),(-43.265,-1.445),(-43.095,-1.445),(-43.095,-1.615),(-43.265,-1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((11.815,-20.085),(11.815,-19.915),(11.985,-19.915),(11.985,-20.085),(11.815,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,11.305),(43.095,11.475),(43.265,11.475),(43.265,11.305),(43.095,11.305)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,11.645),(43.095,11.815),(43.265,11.815),(43.265,11.645),(43.095,11.645)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-11.815),(-43.265,-11.645),(-43.095,-11.645),(-43.095,-11.815),(-43.265,-11.815)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-11.475),(-43.265,-11.305),(-43.095,-11.305),(-43.095,-11.475),(-43.265,-11.475)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,4.505),(43.095,4.675),(43.265,4.675),(43.265,4.505),(43.095,4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,4.165),(43.095,4.335),(43.265,4.335),(43.265,4.165),(43.095,4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,4.165),(-43.265,4.335),(-43.095,4.335),(-43.095,4.165),(-43.265,4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,4.505),(-43.265,4.675),(-43.095,4.675),(-43.095,4.505),(-43.265,4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-5.015),(-43.265,-4.845),(-43.095,-4.845),(-43.095,-5.015),(-43.265,-5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.165,-20.085),(-38.165,-19.915),(-37.995,-19.915),(-37.995,-20.085),(-38.165,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((36.295,19.915),(36.295,20.085),(36.465,20.085),(36.465,19.915),(36.295,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((36.635,19.915),(36.635,20.085),(36.805,20.085),(36.805,19.915),(36.635,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((19.975,-20.085),(19.975,-19.915),(20.145,-19.915),(20.145,-20.085),(19.975,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,9.265),(43.095,9.435),(43.265,9.435),(43.265,9.265),(43.095,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,9.605),(43.095,9.775),(43.265,9.775),(43.265,9.605),(43.095,9.605)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.065,19.915),(-16.065,20.085),(-15.895,20.085),(-15.895,19.915),(-16.065,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-9.775),(-43.265,-9.605),(-43.095,-9.605),(-43.095,-9.775),(-43.265,-9.775)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-9.435),(-43.265,-9.265),(-43.095,-9.265),(-43.095,-9.435),(-43.265,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((22.015,-20.085),(22.015,-19.915),(22.185,-19.915),(22.185,-20.085),(22.015,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.105,19.915),(-1.105,20.085),(-0.935,20.085),(-0.935,19.915),(-1.105,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((24.735,19.915),(24.735,20.085),(24.905,20.085),(24.905,19.915),(24.735,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((24.055,19.915),(24.055,20.085),(24.225,20.085),(24.225,19.915),(24.055,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,18.785),(43.095,18.955),(43.265,18.955),(43.265,18.785),(43.095,18.785)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,18.105),(43.095,18.275),(43.265,18.275),(43.265,18.105),(43.095,18.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,18.105),(-43.265,18.275),(-43.095,18.275),(-43.095,18.105),(-43.265,18.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,18.445),(-43.265,18.615),(-43.095,18.615),(-43.095,18.445),(-43.265,18.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,18.785),(-43.265,18.955),(-43.095,18.955),(-43.095,18.785),(-43.265,18.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.885,19.915),(-40.885,20.085),(-40.715,20.085),(-40.715,19.915),(-40.885,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((20.315,19.915),(20.315,20.085),(20.485,20.085),(20.485,19.915),(20.315,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((20.655,19.915),(20.655,20.085),(20.825,20.085),(20.825,19.915),(20.655,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.005,19.915),(-30.005,20.085),(-29.835,20.085),(-29.835,19.915),(-30.005,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.825,19.915),(-3.825,20.085),(-3.655,20.085),(-3.655,19.915),(-3.825,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.485,19.915),(-3.485,20.085),(-3.315,20.085),(-3.315,19.915),(-3.485,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.905,19.915),(-24.905,20.085),(-24.735,20.085),(-24.735,19.915),(-24.905,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.565,19.915),(-24.565,20.085),(-24.395,20.085),(-24.395,19.915),(-24.565,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.225,19.915),(-24.225,20.085),(-24.055,20.085),(-24.055,19.915),(-24.225,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.705,-20.085),(-31.705,-19.915),(-31.535,-19.915),(-31.535,-20.085),(-31.705,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.365,-20.085),(-31.365,-19.915),(-31.195,-19.915),(-31.195,-20.085),(-31.365,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.785,-20.085),(-1.785,-19.915),(-1.615,-19.915),(-1.615,-20.085),(-1.785,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.615,-20.085),(1.615,-19.915),(1.785,-19.915),(1.785,-20.085),(1.615,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.195,-20.085),(31.195,-19.915),(31.365,-19.915),(31.365,-20.085),(31.195,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.935,19.915),(0.935,20.085),(1.105,20.085),(1.105,19.915),(0.935,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((31.535,-20.085),(31.535,-19.915),(31.705,-19.915),(31.705,-20.085),(31.535,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.675,19.915),(21.675,20.085),(21.845,20.085),(21.845,19.915),(21.675,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((21.335,19.915),(21.335,20.085),(21.505,20.085),(21.505,19.915),(21.335,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.825,-20.085),(-20.825,-19.915),(-20.655,-19.915),(-20.655,-20.085),(-20.825,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.485,-20.085),(-20.485,-19.915),(-20.315,-19.915),(-20.315,-20.085),(-20.485,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-11.135),(43.095,-10.965),(43.265,-10.965),(43.265,-11.135),(43.095,-11.135)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,2.125),(43.095,2.295),(43.265,2.295),(43.265,2.125),(43.095,2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,2.465),(43.095,2.635),(43.265,2.635),(43.265,2.465),(43.095,2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,2.805),(43.095,2.975),(43.265,2.975),(43.265,2.805),(43.095,2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.125,19.915),(-2.125,20.085),(-1.955,20.085),(-1.955,19.915),(-2.125,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,2.125),(-43.265,2.295),(-43.095,2.295),(-43.095,2.125),(-43.265,2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,2.465),(-43.265,2.635),(-43.095,2.635),(-43.095,2.465),(-43.265,2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,2.805),(-43.265,2.975),(-43.095,2.975),(-43.095,2.805),(-43.265,2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.905,19.915),(-7.905,20.085),(-7.735,20.085),(-7.735,19.915),(-7.905,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.565,19.915),(-7.565,20.085),(-7.395,20.085),(-7.395,19.915),(-7.565,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.225,19.915),(-7.225,20.085),(-7.055,20.085),(-7.055,19.915),(-7.225,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.705,-20.085),(-14.705,-19.915),(-14.535,-19.915),(-14.535,-20.085),(-14.705,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.365,-20.085),(-14.365,-19.915),(-14.195,-19.915),(-14.195,-20.085),(-14.365,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.085,19.915),(-0.085,20.085),(0.085,20.085),(0.085,19.915),(-0.085,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((14.195,-20.085),(14.195,-19.915),(14.365,-19.915),(14.365,-20.085),(14.195,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((14.535,-20.085),(14.535,-19.915),(14.705,-19.915),(14.705,-20.085),(14.535,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,5.185),(-43.265,5.355),(-43.095,5.355),(-43.095,5.185),(-43.265,5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,9.945),(-43.265,10.115),(-43.095,10.115),(-43.095,9.945),(-43.265,9.945)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,5.525),(-43.265,5.695),(-43.095,5.695),(-43.095,5.525),(-43.265,5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-5.695),(43.095,-5.525),(43.265,-5.525),(43.265,-5.695),(43.095,-5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-5.355),(43.095,-5.185),(43.265,-5.185),(43.265,-5.355),(43.095,-5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.125,19.915),(-36.125,20.085),(-35.955,20.085),(-35.955,19.915),(-36.125,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.985,19.915),(-28.985,20.085),(-28.815,20.085),(-28.815,19.915),(-28.985,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.645,19.915),(-28.645,20.085),(-28.475,20.085),(-28.475,19.915),(-28.645,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.305,19.915),(-28.305,20.085),(-28.135,20.085),(-28.135,19.915),(-28.305,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,17.085),(-43.265,17.255),(-43.095,17.255),(-43.095,17.085),(-43.265,17.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,17.425),(-43.265,17.595),(-43.095,17.595),(-43.095,17.425),(-43.265,17.425)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,17.765),(-43.265,17.935),(-43.095,17.935),(-43.095,17.765),(-43.265,17.765)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-17.935),(43.095,-17.765),(43.265,-17.765),(43.265,-17.935),(43.095,-17.935)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,14.025),(43.095,14.195),(43.265,14.195),(43.265,14.025),(43.095,14.025)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,14.365),(43.095,14.535),(43.265,14.535),(43.265,14.365),(43.095,14.365)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,14.705),(43.095,14.875),(43.265,14.875),(43.265,14.705),(43.095,14.705)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.705,19.915),(-14.705,20.085),(-14.535,20.085),(-14.535,19.915),(-14.705,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.365,19.915),(-14.365,20.085),(-14.195,20.085),(-14.195,19.915),(-14.365,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,14.025),(-43.265,14.195),(-43.095,14.195),(-43.095,14.025),(-43.265,14.025)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,14.365),(-43.265,14.535),(-43.095,14.535),(-43.095,14.365),(-43.265,14.365)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,14.705),(-43.265,14.875),(-43.095,14.875),(-43.095,14.705),(-43.265,14.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.875,19.915),(31.875,20.085),(32.045,20.085),(32.045,19.915),(31.875,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-6.035),(-43.265,-5.865),(-43.095,-5.865),(-43.095,-6.035),(-43.265,-6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-6.035),(43.095,-5.865),(43.265,-5.865),(43.265,-6.035),(43.095,-6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.985,-20.085),(-11.985,-19.915),(-11.815,-19.915),(-11.815,-20.085),(-11.985,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.975,19.915),(2.975,20.085),(3.145,20.085),(3.145,19.915),(2.975,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.765,-20.085),(-0.765,-19.915),(-0.595,-19.915),(-0.595,-20.085),(-0.765,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.645,-20.085),(-11.645,-19.915),(-11.475,-19.915),(-11.475,-20.085),(-11.645,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.075,19.915),(42.075,20.085),(42.245,20.085),(42.245,19.915),(42.075,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((42.415,19.915),(42.415,20.085),(42.585,20.085),(42.585,19.915),(42.415,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((42.755,19.915),(42.755,20.085),(42.925,20.085),(42.925,19.915),(42.755,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.145,19.915),(-20.145,20.085),(-19.975,20.085),(-19.975,19.915),(-20.145,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.305,-20.085),(-11.305,-19.915),(-11.135,-19.915),(-11.135,-20.085),(-11.305,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.135,-20.085),(11.135,-19.915),(11.305,-19.915),(11.305,-20.085),(11.135,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,-20.085),(0.595,-19.915),(0.765,-19.915),(0.765,-20.085),(0.595,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.485,19.915),(-37.485,20.085),(-37.315,20.085),(-37.315,19.915),(-37.485,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.825,19.915),(-37.825,20.085),(-37.655,20.085),(-37.655,19.915),(-37.825,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((8.075,-20.085),(8.075,-19.915),(8.245,-19.915),(8.245,-20.085),(8.075,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.415,-20.085),(8.415,-19.915),(8.585,-19.915),(8.585,-20.085),(8.415,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.755,-20.085),(8.755,-19.915),(8.925,-19.915),(8.925,-20.085),(8.755,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.895,19.915),(15.895,20.085),(16.065,20.085),(16.065,19.915),(15.895,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.765,19.915),(-17.765,20.085),(-17.595,20.085),(-17.595,19.915),(-17.765,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.425,19.915),(-17.425,20.085),(-17.255,20.085),(-17.255,19.915),(-17.425,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((4.335,-20.085),(4.335,-19.915),(4.505,-19.915),(4.505,-20.085),(4.335,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((4.675,-20.085),(4.675,-19.915),(4.845,-19.915),(4.845,-20.085),(4.675,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.165,-20.085),(-4.165,-19.915),(-3.995,-19.915),(-3.995,-20.085),(-4.165,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.955,-20.085),(1.955,-19.915),(2.125,-19.915),(2.125,-20.085),(1.955,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((19.975,19.915),(19.975,20.085),(20.145,20.085),(20.145,19.915),(19.975,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.025,19.915),(-14.025,20.085),(-13.855,20.085),(-13.855,19.915),(-14.025,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((16.235,-20.085),(16.235,-19.915),(16.405,-19.915),(16.405,-20.085),(16.235,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.575,-20.085),(16.575,-19.915),(16.745,-19.915),(16.745,-20.085),(16.575,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.215,19.915),(32.215,20.085),(32.385,20.085),(32.385,19.915),(32.215,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((32.555,19.915),(32.555,20.085),(32.725,20.085),(32.725,19.915),(32.555,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((36.975,-20.085),(36.975,-19.915),(37.145,-19.915),(37.145,-20.085),(36.975,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.725,-20.085),(-15.725,-19.915),(-15.555,-19.915),(-15.555,-20.085),(-15.725,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.385,-20.085),(-15.385,-19.915),(-15.215,-19.915),(-15.215,-20.085),(-15.385,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.215,-20.085),(15.215,-19.915),(15.385,-19.915),(15.385,-20.085),(15.215,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.065,-20.085),(-33.065,-19.915),(-32.895,-19.915),(-32.895,-20.085),(-33.065,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.555,-20.085),(15.555,-19.915),(15.725,-19.915),(15.725,-20.085),(15.555,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,15.045),(-43.265,15.215),(-43.095,15.215),(-43.095,15.045),(-43.265,15.045)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,15.385),(-43.265,15.555),(-43.095,15.555),(-43.095,15.385),(-43.265,15.385)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,15.725),(-43.265,15.895),(-43.095,15.895),(-43.095,15.725),(-43.265,15.725)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-15.555),(43.095,-15.385),(43.265,-15.385),(43.265,-15.555),(43.095,-15.555)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-15.215),(43.095,-15.045),(43.265,-15.045),(43.265,-15.215),(43.095,-15.215)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.685,19.915),(-13.685,20.085),(-13.515,20.085),(-13.515,19.915),(-13.685,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.345,19.915),(-13.345,20.085),(-13.175,20.085),(-13.175,19.915),(-13.345,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.085,-20.085),(-34.085,-19.915),(-33.915,-19.915),(-33.915,-20.085),(-34.085,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.935,-20.085),(34.935,-19.915),(35.105,-19.915),(35.105,-20.085),(34.935,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-15.895),(43.095,-15.725),(43.265,-15.725),(43.265,-15.895),(43.095,-15.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.945,-20.085),(-9.945,-19.915),(-9.775,-19.915),(-9.775,-20.085),(-9.945,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.605,-20.085),(-9.605,-19.915),(-9.435,-19.915),(-9.435,-20.085),(-9.605,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.265,-20.085),(-9.265,-19.915),(-9.095,-19.915),(-9.095,-20.085),(-9.265,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.095,-20.085),(9.095,-19.915),(9.265,-19.915),(9.265,-20.085),(9.095,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.435,-20.085),(9.435,-19.915),(9.605,-19.915),(9.605,-20.085),(9.435,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.775,-20.085),(9.775,-19.915),(9.945,-19.915),(9.945,-20.085),(9.775,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.105,-20.085),(-35.105,-19.915),(-34.935,-19.915),(-34.935,-20.085),(-35.105,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-11.475),(43.095,-11.305),(43.265,-11.305),(43.265,-11.475),(43.095,-11.475)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,7.225),(43.095,7.395),(43.265,7.395),(43.265,7.225),(43.095,7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,7.565),(43.095,7.735),(43.265,7.735),(43.265,7.565),(43.095,7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-7.735),(-43.265,-7.565),(-43.095,-7.565),(-43.095,-7.735),(-43.265,-7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.545,19.915),(-40.545,20.085),(-40.375,20.085),(-40.375,19.915),(-40.545,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.205,19.915),(-40.205,20.085),(-40.035,20.085),(-40.035,19.915),(-40.205,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-7.395),(-43.265,-7.225),(-43.095,-7.225),(-43.095,-7.395),(-43.265,-7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.865,-20.085),(-22.865,-19.915),(-22.695,-19.915),(-22.695,-20.085),(-22.865,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.525,-20.085),(-22.525,-19.915),(-22.355,-19.915),(-22.355,-20.085),(-22.525,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.185,-20.085),(-22.185,-19.915),(-22.015,-19.915),(-22.015,-20.085),(-22.185,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.585,-20.085),(-42.585,-19.915),(-42.415,-19.915),(-42.415,-20.085),(-42.585,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,11.985),(43.095,12.155),(43.265,12.155),(43.265,11.985),(43.095,11.985)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.245,-20.085),(-42.245,-19.915),(-42.075,-19.915),(-42.075,-20.085),(-42.245,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.925,-20.085),(-42.925,-19.915),(-42.755,-19.915),(-42.755,-20.085),(-42.925,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,19.125),(43.095,19.295),(43.265,19.295),(43.265,19.125),(43.095,19.125)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,19.465),(43.095,19.635),(43.265,19.635),(43.265,19.465),(43.095,19.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-19.635),(-43.265,-19.465),(-43.095,-19.465),(-43.095,-19.635),(-43.265,-19.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-19.295),(-43.265,-19.125),(-43.095,-19.125),(-43.095,-19.295),(-43.265,-19.295)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,4.845),(43.095,5.015),(43.265,5.015),(43.265,4.845),(43.095,4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,4.845),(-43.265,5.015),(-43.095,5.015),(-43.095,4.845),(-43.265,4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.945,-20.085),(-26.945,-19.915),(-26.775,-19.915),(-26.775,-20.085),(-26.945,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.605,-20.085),(-26.605,-19.915),(-26.435,-19.915),(-26.435,-20.085),(-26.605,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.265,-20.085),(-26.265,-19.915),(-26.095,-19.915),(-26.095,-20.085),(-26.265,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((12.835,-20.085),(12.835,-19.915),(13.005,-19.915),(13.005,-20.085),(12.835,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.095,-20.085),(26.095,-19.915),(26.265,-19.915),(26.265,-20.085),(26.095,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.435,-20.085),(26.435,-19.915),(26.605,-19.915),(26.605,-20.085),(26.435,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.775,-20.085),(26.775,-19.915),(26.945,-19.915),(26.945,-20.085),(26.775,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.955,19.915),(1.955,20.085),(2.125,20.085),(2.125,19.915),(1.955,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,19.915),(0.595,20.085),(0.765,20.085),(0.765,19.915),(0.595,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.765,19.915),(-0.765,20.085),(-0.595,20.085),(-0.595,19.915),(-0.765,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,8.245),(43.095,8.415),(43.265,8.415),(43.265,8.245),(43.095,8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,8.585),(43.095,8.755),(43.265,8.755),(43.265,8.585),(43.095,8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.445,19.915),(-1.445,20.085),(-1.275,20.085),(-1.275,19.915),(-1.445,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,8.585),(-43.265,8.755),(-43.095,8.755),(-43.095,8.585),(-43.265,8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,8.245),(-43.265,8.415),(-43.095,8.415),(-43.095,8.245),(-43.265,8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((8.075,19.915),(8.075,20.085),(8.245,20.085),(8.245,19.915),(8.075,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((8.415,19.915),(8.415,20.085),(8.585,20.085),(8.585,19.915),(8.415,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((8.755,19.915),(8.755,20.085),(8.925,20.085),(8.925,19.915),(8.755,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.785,-20.085),(-35.785,-19.915),(-35.615,-19.915),(-35.615,-20.085),(-35.785,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.445,-20.085),(-35.445,-19.915),(-35.275,-19.915),(-35.275,-20.085),(-35.445,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.275,-20.085),(35.275,-19.915),(35.445,-19.915),(35.445,-20.085),(35.275,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.615,-20.085),(35.615,-19.915),(35.785,-19.915),(35.785,-20.085),(35.615,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((4.335,19.915),(4.335,20.085),(4.505,20.085),(4.505,19.915),(4.335,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((4.675,19.915),(4.675,20.085),(4.845,20.085),(4.845,19.915),(4.675,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.125,-20.085),(-19.125,-19.915),(-18.955,-19.915),(-18.955,-20.085),(-19.125,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-7.055),(43.095,-6.885),(43.265,-6.885),(43.265,-7.055),(43.095,-7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.925,19.915),(-8.925,20.085),(-8.755,20.085),(-8.755,19.915),(-8.925,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.585,19.915),(-8.585,20.085),(-8.415,20.085),(-8.415,19.915),(-8.585,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.245,19.915),(-8.245,20.085),(-8.075,20.085),(-8.075,19.915),(-8.245,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.805,-20.085),(-19.805,-19.915),(-19.635,-19.915),(-19.635,-20.085),(-19.805,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.465,-20.085),(-19.465,-19.915),(-19.295,-19.915),(-19.295,-20.085),(-19.465,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((19.295,-20.085),(19.295,-19.915),(19.465,-19.915),(19.465,-20.085),(19.295,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((19.635,-20.085),(19.635,-19.915),(19.805,-19.915),(19.805,-20.085),(19.635,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-1.615),(43.095,-1.445),(43.265,-1.445),(43.265,-1.615),(43.095,-1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((16.235,19.915),(16.235,20.085),(16.405,20.085),(16.405,19.915),(16.235,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((16.575,19.915),(16.575,20.085),(16.745,20.085),(16.745,19.915),(16.575,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((5.015,19.915),(5.015,20.085),(5.185,20.085),(5.185,19.915),(5.015,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((5.355,19.915),(5.355,20.085),(5.525,20.085),(5.525,19.915),(5.355,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((5.695,19.915),(5.695,20.085),(5.865,20.085),(5.865,19.915),(5.695,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,11.305),(-43.265,11.475),(-43.095,11.475),(-43.095,11.305),(-43.265,11.305)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,11.645),(-43.265,11.815),(-43.095,11.815),(-43.095,11.645),(-43.265,11.645)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-11.815),(43.095,-11.645),(43.265,-11.645),(43.265,-11.815),(43.095,-11.815)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.865,-20.085),(-39.865,-19.915),(-39.695,-19.915),(-39.695,-20.085),(-39.865,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-8.755),(-43.265,-8.585),(-43.095,-8.585),(-43.095,-8.755),(-43.265,-8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-8.415),(-43.265,-8.245),(-43.095,-8.245),(-43.095,-8.415),(-43.265,-8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.525,-20.085),(-39.525,-19.915),(-39.355,-19.915),(-39.355,-20.085),(-39.525,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.185,-20.085),(-39.185,-19.915),(-39.015,-19.915),(-39.015,-20.085),(-39.185,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.845,-20.085),(-4.845,-19.915),(-4.675,-19.915),(-4.675,-20.085),(-4.845,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.505,-20.085),(-4.505,-19.915),(-4.335,-19.915),(-4.335,-20.085),(-4.505,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-8.755),(43.095,-8.585),(43.265,-8.585),(43.265,-8.755),(43.095,-8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-8.415),(43.095,-8.245),(43.265,-8.245),(43.265,-8.415),(43.095,-8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((39.015,-20.085),(39.015,-19.915),(39.185,-19.915),(39.185,-20.085),(39.015,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-5.015),(43.095,-4.845),(43.265,-4.845),(43.265,-5.015),(43.095,-5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((38.335,19.915),(38.335,20.085),(38.505,20.085),(38.505,19.915),(38.335,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,19.915),(38.675,20.085),(38.845,20.085),(38.845,19.915),(38.675,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,9.265),(-43.265,9.435),(-43.095,9.435),(-43.095,9.265),(-43.265,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,9.605),(-43.265,9.775),(-43.095,9.775),(-43.095,9.605),(-43.265,9.605)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-9.775),(43.095,-9.605),(43.265,-9.605),(43.265,-9.775),(43.095,-9.775)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-9.435),(43.095,-9.265),(43.265,-9.265),(43.265,-9.435),(43.095,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((42.075,-20.085),(42.075,-19.915),(42.245,-19.915),(42.245,-20.085),(42.075,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.415,-20.085),(42.415,-19.915),(42.585,-19.915),(42.585,-20.085),(42.415,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.885,-20.085),(-23.885,-19.915),(-23.715,-19.915),(-23.715,-20.085),(-23.885,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.545,-20.085),(-23.545,-19.915),(-23.375,-19.915),(-23.375,-20.085),(-23.545,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.205,-20.085),(-23.205,-19.915),(-23.035,-19.915),(-23.035,-20.085),(-23.205,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.035,-20.085),(23.035,-19.915),(23.205,-19.915),(23.205,-20.085),(23.035,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.375,-20.085),(23.375,-19.915),(23.545,-19.915),(23.545,-20.085),(23.375,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.715,-20.085),(23.715,-19.915),(23.885,-19.915),(23.885,-20.085),(23.715,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.385,-20.085),(-32.385,-19.915),(-32.215,-19.915),(-32.215,-20.085),(-32.385,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.725,-20.085),(-32.725,-19.915),(-32.555,-19.915),(-32.555,-20.085),(-32.725,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((22.015,19.915),(22.015,20.085),(22.185,20.085),(22.185,19.915),(22.015,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((22.355,19.915),(22.355,20.085),(22.525,20.085),(22.525,19.915),(22.355,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((22.695,19.915),(22.695,20.085),(22.865,20.085),(22.865,19.915),(22.695,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((32.895,-20.085),(32.895,-19.915),(33.065,-19.915),(33.065,-20.085),(32.895,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.325,19.915),(-12.325,20.085),(-12.155,20.085),(-12.155,19.915),(-12.325,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.665,19.915),(-12.665,20.085),(-12.495,20.085),(-12.495,19.915),(-12.665,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,0.765),(43.095,0.935),(43.265,0.935),(43.265,0.765),(43.095,0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,0.765),(-43.265,0.935),(-43.095,0.935),(-43.095,0.765),(-43.265,0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-0.935),(-43.265,-0.765),(-43.095,-0.765),(-43.095,-0.935),(-43.265,-0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,1.105),(43.095,1.275),(43.265,1.275),(43.265,1.105),(43.095,1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-1.275),(-43.265,-1.105),(-43.095,-1.105),(-43.095,-1.275),(-43.265,-1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-0.935),(43.095,-0.765),(43.265,-0.765),(43.265,-0.935),(43.095,-0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.125,-20.085),(-36.125,-19.915),(-35.955,-19.915),(-35.955,-20.085),(-36.125,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.095,19.915),(26.095,20.085),(26.265,20.085),(26.265,19.915),(26.095,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((26.435,19.915),(26.435,20.085),(26.605,20.085),(26.605,19.915),(26.435,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((26.775,19.915),(26.775,20.085),(26.945,20.085),(26.945,19.915),(26.775,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((22.355,-20.085),(22.355,-19.915),(22.525,-19.915),(22.525,-20.085),(22.355,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-18.955),(-43.265,-18.785),(-43.095,-18.785),(-43.095,-18.955),(-43.265,-18.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.845,19.915),(-21.845,20.085),(-21.675,20.085),(-21.675,19.915),(-21.845,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.505,19.915),(-21.505,20.085),(-21.335,20.085),(-21.335,19.915),(-21.505,19.915)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-18.615),(-43.265,-18.445),(-43.095,-18.445),(-43.095,-18.615),(-43.265,-18.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-18.275),(-43.265,-18.105),(-43.095,-18.105),(-43.095,-18.275),(-43.265,-18.275)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-18.955),(43.095,-18.785),(43.265,-18.785),(43.265,-18.955),(43.095,-18.955)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-18.615),(43.095,-18.445),(43.265,-18.445),(43.265,-18.615),(43.095,-18.615)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-18.275),(43.095,-18.105),(43.265,-18.105),(43.265,-18.275),(43.095,-18.275)),
        )
        createRL(
            tech, net, 'licon',
            ((29.835,-20.085),(29.835,-19.915),(30.005,-19.915),(30.005,-20.085),(29.835,-20.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.255,-20.085),(0.255,-19.915),(0.425,-19.915),(0.425,-20.085),(0.255,-20.085)),
        )
        createRL(
            tech, net, 'li',
            ((-43.42,-20.24),(-43.42,19.76),(-42.94,19.76),(-42.94,-19.76),(42.94,-19.76),(42.94,19.76),(-43.42,19.76),(-43.42,20.24),(43.42,20.24),(43.42,-20.24),(-43.42,-20.24)),
        )
        createRL(
            tech, net, 'nwm',
            ((-43.6,-20.42),(-43.6,20.42),(43.6,20.42),(43.6,-20.42),(-43.6,-20.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-43.545,-20.365),(-43.545,19.635),(-42.815,19.635),(-42.815,-19.635),(42.815,-19.635),(42.815,19.635),(-43.545,19.635),(-43.545,20.365),(43.545,20.365),(43.545,-20.365),(-43.545,-20.365)),
        )
        nets['conn'].setDirection(Net.Direction.IN)

    cell = new_cells['Clamp_P32N4D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(43.64),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'gate': Net.create(cell, 'gate'),
            'iovdd': Net.create(cell, 'iovdd'),
            'off': Net.create(cell, 'off'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((28.965,2.72),(28.965,40.92),(32.235,40.92),(32.235,2.72),(28.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.965,2.72),(76.965,40.92),(80.235,40.92),(80.235,2.72),(76.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,40.92),(8.235,40.92),(8.235,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.765,2.72),(81.765,40.92),(83.75,40.92),(83.75,2.72),(81.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,40.92),(37.035,40.92),(37.035,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.165,2.72),(72.165,40.92),(75.435,40.92),(75.435,2.72),(72.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.165,2.72),(24.165,40.92),(27.435,40.92),(27.435,2.72),(24.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.365,2.72),(67.365,40.92),(70.635,40.92),(70.635,2.72),(67.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,40.92),(46.635,40.92),(46.635,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.365,2.72),(19.365,40.92),(22.635,40.92),(22.635,2.72),(19.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.565,2.72),(62.565,40.92),(65.835,40.92),(65.835,2.72),(62.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,40.92),(41.835,40.92),(41.835,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.565,2.72),(14.565,40.92),(17.835,40.92),(17.835,2.72),(14.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,40.92),(56.235,40.92),(56.235,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,40.92),(61.035,40.92),(61.035,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.765,2.72),(9.765,40.92),(13.035,40.92),(13.035,2.72),(9.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,40.92),(51.435,40.92),(51.435,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.045),(31.025,29.215),(31.195,29.215),(31.195,29.045),(31.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.725),(31.025,29.895),(31.195,29.895),(31.195,29.725),(31.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.385),(31.025,29.555),(31.195,29.555),(31.195,29.385),(31.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.285),(39.605,24.455),(39.775,24.455),(39.775,24.285),(39.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.645),(16.115,8.815),(16.285,8.815),(16.285,8.645),(16.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.305),(16.115,8.475),(16.285,8.475),(16.285,8.305),(16.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.585),(30.515,22.755),(30.685,22.755),(30.685,22.585),(30.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.245),(30.515,22.415),(30.685,22.415),(30.685,22.245),(30.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,34.145),(7.025,34.315),(7.195,34.315),(7.195,34.145),(7.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,34.825),(7.025,34.995),(7.195,34.995),(7.195,34.825),(7.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,34.485),(7.025,34.655),(7.195,34.655),(7.195,34.485),(7.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,29.385),(20.405,29.555),(20.575,29.555),(20.575,29.385),(20.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.245),(39.605,39.415),(39.775,39.415),(39.775,39.245),(39.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.105),(69.425,15.275),(69.595,15.275),(69.595,15.105),(69.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.445),(69.425,15.615),(69.595,15.615),(69.595,15.445),(69.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.965),(59.315,25.135),(59.485,25.135),(59.485,24.965),(59.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,24.965),(59.825,25.135),(59.995,25.135),(59.995,24.965),(59.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.745),(34.805,13.915),(34.975,13.915),(34.975,13.745),(34.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.065),(34.805,13.235),(34.975,13.235),(34.975,13.065),(34.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.925),(73.205,6.095),(73.375,6.095),(73.375,5.925),(73.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.925),(73.715,6.095),(73.885,6.095),(73.885,5.925),(73.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.165),(44.405,18.335),(44.575,18.335),(44.575,18.165),(44.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,36.525),(15.605,36.695),(15.775,36.695),(15.775,36.525),(15.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,36.185),(15.605,36.355),(15.775,36.355),(15.775,36.185),(15.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,33.125),(74.225,33.295),(74.395,33.295),(74.395,33.125),(74.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,33.465),(74.225,33.635),(74.395,33.635),(74.395,33.465),(74.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,33.805),(74.225,33.975),(74.395,33.975),(74.395,33.805),(74.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.465),(16.115,16.635),(16.285,16.635),(16.285,16.465),(16.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.185),(58.805,36.355),(58.975,36.355),(58.975,36.185),(58.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.525),(58.805,36.695),(58.975,36.695),(58.975,36.525),(58.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,39.245),(83.315,39.415),(83.485,39.415),(83.485,39.245),(83.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.165),(82.805,18.335),(82.975,18.335),(82.975,18.165),(82.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.885),(44.915,38.055),(45.085,38.055),(45.085,37.885),(44.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.925),(50.225,40.095),(50.395,40.095),(50.395,39.925),(50.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.985),(35.315,26.155),(35.485,26.155),(35.485,25.985),(35.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.985),(35.825,26.155),(35.995,26.155),(35.995,25.985),(35.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.865),(34.805,20.035),(34.975,20.035),(34.975,19.865),(34.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,34.825),(25.205,34.995),(25.375,34.995),(25.375,34.825),(25.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,34.145),(25.205,34.315),(25.375,34.315),(25.375,34.145),(25.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,34.485),(25.205,34.655),(25.375,34.655),(25.375,34.485),(25.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.725),(40.115,12.895),(40.285,12.895),(40.285,12.725),(40.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.725),(40.625,12.895),(40.795,12.895),(40.795,12.725),(40.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.385),(40.115,12.555),(40.285,12.555),(40.285,12.385),(40.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.385),(40.625,12.555),(40.795,12.555),(40.795,12.385),(40.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.045),(40.115,12.215),(40.285,12.215),(40.285,12.045),(40.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.045),(40.625,12.215),(40.795,12.215),(40.795,12.045),(40.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.145),(31.025,34.315),(31.195,34.315),(31.195,34.145),(31.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.485),(31.025,34.655),(31.195,34.655),(31.195,34.485),(31.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.825),(31.025,34.995),(31.195,34.995),(31.195,34.825),(31.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,22.245),(20.405,22.415),(20.575,22.415),(20.575,22.245),(20.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,29.045),(15.605,29.215),(15.775,29.215),(15.775,29.045),(15.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,29.725),(15.605,29.895),(15.775,29.895),(15.775,29.725),(15.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,24.965),(25.205,25.135),(25.375,25.135),(25.375,24.965),(25.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,24.965),(21.425,25.135),(21.595,25.135),(21.595,24.965),(21.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,39.245),(11.315,39.415),(11.485,39.415),(11.485,39.245),(11.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.025),(45.425,11.195),(45.595,11.195),(45.595,11.025),(45.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.705),(45.425,11.875),(45.595,11.875),(45.595,11.705),(45.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.285),(79.025,7.455),(79.195,7.455),(79.195,7.285),(79.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,40.605),(45.425,40.775),(45.595,40.775),(45.595,40.605),(45.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,39.925),(25.205,40.095),(25.375,40.095),(25.375,39.925),(25.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.265),(15.605,6.435),(15.775,6.435),(15.775,6.265),(15.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.805),(50.225,33.975),(50.395,33.975),(50.395,33.805),(50.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.465),(50.225,33.635),(50.395,33.635),(50.395,33.465),(50.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.125),(50.225,33.295),(50.395,33.295),(50.395,33.125),(50.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,27.685),(21.425,27.855),(21.595,27.855),(21.595,27.685),(21.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.825),(59.315,34.995),(59.485,34.995),(59.485,34.825),(59.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,34.825),(59.825,34.995),(59.995,34.995),(59.995,34.825),(59.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.485),(59.315,34.655),(59.485,34.655),(59.485,34.485),(59.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,34.485),(59.825,34.655),(59.995,34.655),(59.995,34.485),(59.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.145),(59.315,34.315),(59.485,34.315),(59.485,34.145),(59.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,34.145),(59.825,34.315),(59.995,34.315),(59.995,34.145),(59.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.065),(16.625,13.235),(16.795,13.235),(16.795,13.065),(16.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.565),(50.225,21.735),(50.395,21.735),(50.395,21.565),(50.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.745),(16.625,13.915),(16.795,13.915),(16.795,13.745),(16.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.405),(16.625,13.575),(16.795,13.575),(16.795,13.405),(16.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.105),(45.425,15.275),(45.595,15.275),(45.595,15.105),(45.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.225),(49.205,21.395),(49.375,21.395),(49.375,21.225),(49.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.225),(49.715,21.395),(49.885,21.395),(49.885,21.225),(49.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.565),(49.205,21.735),(49.375,21.735),(49.375,21.565),(49.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.565),(49.715,21.735),(49.885,21.735),(49.885,21.565),(49.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.405),(83.315,13.575),(83.485,13.575),(83.485,13.405),(83.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.985),(44.915,9.155),(45.085,9.155),(45.085,8.985),(44.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.345),(63.605,10.515),(63.775,10.515),(63.775,10.345),(63.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,31.425),(82.805,31.595),(82.975,31.595),(82.975,31.425),(82.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,31.765),(82.805,31.935),(82.975,31.935),(82.975,31.765),(82.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,31.085),(82.805,31.255),(82.975,31.255),(82.975,31.085),(82.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,27.005),(74.225,27.175),(74.395,27.175),(74.395,27.005),(74.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,27.345),(78.515,27.515),(78.685,27.515),(78.685,27.345),(78.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,27.005),(78.515,27.175),(78.685,27.175),(78.685,27.005),(78.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,27.345),(78.005,27.515),(78.175,27.515),(78.175,27.345),(78.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,27.005),(78.005,27.175),(78.175,27.175),(78.175,27.005),(78.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,22.925),(7.025,23.095),(7.195,23.095),(7.195,22.925),(7.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,30.065),(16.115,30.235),(16.285,30.235),(16.285,30.065),(16.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,30.745),(16.115,30.915),(16.285,30.915),(16.285,30.745),(16.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,38.225),(63.605,38.395),(63.775,38.395),(63.775,38.225),(63.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.865),(49.205,20.035),(49.375,20.035),(49.375,19.865),(49.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.645),(11.315,8.815),(11.485,8.815),(11.485,8.645),(11.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.305),(11.315,8.475),(11.485,8.475),(11.485,8.305),(11.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.345),(49.205,27.515),(49.375,27.515),(49.375,27.345),(49.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.345),(49.715,27.515),(49.885,27.515),(49.885,27.345),(49.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.005),(49.205,27.175),(49.375,27.175),(49.375,27.005),(49.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.005),(49.715,27.175),(49.885,27.175),(49.885,27.005),(49.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.305),(11.825,8.475),(11.995,8.475),(11.995,8.305),(11.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.865),(49.715,20.035),(49.885,20.035),(49.885,19.865),(49.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.105),(40.115,15.275),(40.285,15.275),(40.285,15.105),(40.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.105),(40.625,15.275),(40.795,15.275),(40.795,15.105),(40.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.445),(40.115,15.615),(40.285,15.615),(40.285,15.445),(40.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.445),(40.625,15.615),(40.795,15.615),(40.795,15.445),(40.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.865),(15.605,20.035),(15.775,20.035),(15.775,19.865),(15.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.625),(31.025,24.795),(31.195,24.795),(31.195,24.625),(31.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,39.925),(74.225,40.095),(74.395,40.095),(74.395,39.925),(74.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,20.885),(73.205,21.055),(73.375,21.055),(73.375,20.885),(73.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,20.885),(73.715,21.055),(73.885,21.055),(73.885,20.885),(73.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.545),(54.005,37.715),(54.175,37.715),(54.175,37.545),(54.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.205),(54.515,37.375),(54.685,37.375),(54.685,37.205),(54.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,21.225),(68.405,21.395),(68.575,21.395),(68.575,21.225),(68.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.205),(58.805,20.375),(58.975,20.375),(58.975,20.205),(58.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.545),(58.805,20.715),(58.975,20.715),(58.975,20.545),(58.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,23.265),(78.005,23.435),(78.175,23.435),(78.175,23.265),(78.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,23.265),(78.515,23.435),(78.685,23.435),(78.685,23.265),(78.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.525),(82.805,19.695),(82.975,19.695),(82.975,19.525),(82.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,31.425),(68.405,31.595),(68.575,31.595),(68.575,31.425),(68.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,40.265),(11.315,40.435),(11.485,40.435),(11.485,40.265),(11.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.205),(54.515,20.375),(54.685,20.375),(54.685,20.205),(54.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.545),(54.005,20.715),(54.175,20.715),(54.175,20.545),(54.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.285),(50.225,7.455),(50.395,7.455),(50.395,7.285),(50.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.565),(54.005,38.735),(54.175,38.735),(54.175,38.565),(54.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.225),(54.515,38.395),(54.685,38.395),(54.685,38.225),(54.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.085),(45.425,14.255),(45.595,14.255),(45.595,14.085),(45.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.425),(45.425,14.595),(45.595,14.595),(45.595,14.425),(45.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.765),(45.425,14.935),(45.595,14.935),(45.595,14.765),(45.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.145),(64.115,17.315),(64.285,17.315),(64.285,17.145),(64.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.145),(64.625,17.315),(64.795,17.315),(64.795,17.145),(64.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.485),(64.115,17.655),(64.285,17.655),(64.285,17.485),(64.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.485),(64.625,17.655),(64.795,17.655),(64.795,17.485),(64.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.825),(64.115,17.995),(64.285,17.995),(64.285,17.825),(64.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.825),(64.625,17.995),(64.795,17.995),(64.795,17.825),(64.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,37.205),(26.225,37.375),(26.395,37.375),(26.395,37.205),(26.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.465),(54.005,16.635),(54.175,16.635),(54.175,16.465),(54.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.805),(54.515,16.975),(54.685,16.975),(54.685,16.805),(54.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.125),(54.515,16.295),(54.685,16.295),(54.685,16.125),(54.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.845),(34.805,19.015),(34.975,19.015),(34.975,18.845),(34.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.345),(59.315,27.515),(59.485,27.515),(59.485,27.345),(59.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,27.345),(59.825,27.515),(59.995,27.515),(59.995,27.345),(59.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,38.225),(20.915,38.395),(21.085,38.395),(21.085,38.225),(20.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,39.585),(7.025,39.755),(7.195,39.755),(7.195,39.585),(7.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.385),(35.315,12.555),(35.485,12.555),(35.485,12.385),(35.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.385),(35.825,12.555),(35.995,12.555),(35.995,12.385),(35.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.725),(35.825,12.895),(35.995,12.895),(35.995,12.725),(35.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.045),(35.315,12.215),(35.485,12.215),(35.485,12.045),(35.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.045),(35.825,12.215),(35.995,12.215),(35.995,12.045),(35.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.725),(35.315,12.895),(35.485,12.895),(35.485,12.725),(35.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.885),(44.915,4.055),(45.085,4.055),(45.085,3.885),(44.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.745),(59.315,30.915),(59.485,30.915),(59.485,30.745),(59.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,30.745),(59.825,30.915),(59.995,30.915),(59.995,30.745),(59.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.065),(59.315,30.235),(59.485,30.235),(59.485,30.065),(59.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,30.065),(59.825,30.235),(59.995,30.235),(59.995,30.065),(59.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.565),(35.315,38.735),(35.485,38.735),(35.485,38.565),(35.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.565),(35.825,38.735),(35.995,38.735),(35.995,38.565),(35.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,39.925),(6.515,40.095),(6.685,40.095),(6.685,39.925),(6.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.265),(25.715,6.435),(25.885,6.435),(25.885,6.265),(25.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.605),(25.715,6.775),(25.885,6.775),(25.885,6.605),(25.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.265),(6.515,6.435),(6.685,6.435),(6.685,6.265),(6.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,28.025),(15.605,28.195),(15.775,28.195),(15.775,28.025),(15.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,28.365),(15.605,28.535),(15.775,28.535),(15.775,28.365),(15.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,28.705),(15.605,28.875),(15.775,28.875),(15.775,28.705),(15.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.585),(26.225,5.755),(26.395,5.755),(26.395,5.585),(26.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.845),(26.225,19.015),(26.395,19.015),(26.395,18.845),(26.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.505),(10.805,18.675),(10.975,18.675),(10.975,18.505),(10.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.205),(35.315,3.375),(35.485,3.375),(35.485,3.205),(35.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.205),(35.825,3.375),(35.995,3.375),(35.995,3.205),(35.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,35.845),(20.405,36.015),(20.575,36.015),(20.575,35.845),(20.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.045),(34.805,29.215),(34.975,29.215),(34.975,29.045),(34.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.725),(34.805,29.895),(34.975,29.895),(34.975,29.725),(34.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.205),(7.025,3.375),(7.195,3.375),(7.195,3.205),(7.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.245),(44.405,5.415),(44.575,5.415),(44.575,5.245),(44.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,37.205),(25.205,37.375),(25.375,37.375),(25.375,37.205),(25.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.865),(45.425,20.035),(45.595,20.035),(45.595,19.865),(45.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,33.805),(20.405,33.975),(20.575,33.975),(20.575,33.805),(20.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,33.125),(20.405,33.295),(20.575,33.295),(20.575,33.125),(20.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,33.465),(20.405,33.635),(20.575,33.635),(20.575,33.465),(20.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.745),(54.515,30.915),(54.685,30.915),(54.685,30.745),(54.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.065),(54.515,30.235),(54.685,30.235),(54.685,30.065),(54.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.405),(54.515,30.575),(54.685,30.575),(54.685,30.405),(54.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.405),(31.025,13.575),(31.195,13.575),(31.195,13.405),(31.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.745),(31.025,13.915),(31.195,13.915),(31.195,13.745),(31.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.065),(31.025,13.235),(31.195,13.235),(31.195,13.065),(31.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.125),(15.605,16.295),(15.775,16.295),(15.775,16.125),(15.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.805),(15.605,16.975),(15.775,16.975),(15.775,16.805),(15.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.985),(79.025,9.155),(79.195,9.155),(79.195,8.985),(79.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.265),(30.005,6.435),(30.175,6.435),(30.175,6.265),(30.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,20.885),(30.005,21.055),(30.175,21.055),(30.175,20.885),(30.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.925),(59.315,40.095),(59.485,40.095),(59.485,39.925),(59.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,39.925),(59.825,40.095),(59.995,40.095),(59.995,39.925),(59.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.865),(82.805,20.035),(82.975,20.035),(82.975,19.865),(82.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.545),(21.425,3.715),(21.595,3.715),(21.595,3.545),(21.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.905),(35.315,22.075),(35.485,22.075),(35.485,21.905),(35.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.905),(35.825,22.075),(35.995,22.075),(35.995,21.905),(35.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,27.685),(30.005,27.855),(30.175,27.855),(30.175,27.685),(30.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.005),(30.515,27.175),(30.685,27.175),(30.685,27.005),(30.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.385),(83.315,12.555),(83.485,12.555),(83.485,12.385),(83.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.445),(83.315,15.615),(83.485,15.615),(83.485,15.445),(83.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.485),(83.315,17.655),(83.485,17.655),(83.485,17.485),(83.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.105),(35.315,15.275),(35.485,15.275),(35.485,15.105),(35.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.105),(35.825,15.275),(35.995,15.275),(35.995,15.105),(35.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.265),(58.805,6.435),(58.975,6.435),(58.975,6.265),(58.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.605),(58.805,6.775),(58.975,6.775),(58.975,6.605),(58.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,26.665),(7.025,26.835),(7.195,26.835),(7.195,26.665),(7.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.605),(34.805,6.775),(34.975,6.775),(34.975,6.605),(34.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.605),(54.515,6.775),(54.685,6.775),(54.685,6.605),(54.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.265),(54.005,6.435),(54.175,6.435),(54.175,6.265),(54.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.705),(30.515,28.875),(30.685,28.875),(30.685,28.705),(30.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.025),(30.515,28.195),(30.685,28.195),(30.685,28.025),(30.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.365),(30.515,28.535),(30.685,28.535),(30.685,28.365),(30.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,21.905),(11.315,22.075),(11.485,22.075),(11.485,21.905),(11.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,35.165),(21.425,35.335),(21.595,35.335),(21.595,35.165),(21.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,35.505),(21.425,35.675),(21.595,35.675),(21.595,35.505),(21.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.245),(55.025,22.415),(55.195,22.415),(55.195,22.245),(55.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.585),(55.025,22.755),(55.195,22.755),(55.195,22.585),(55.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.845),(6.515,19.015),(6.685,19.015),(6.685,18.845),(6.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.985),(31.025,9.155),(31.195,9.155),(31.195,8.985),(31.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.885),(79.025,4.055),(79.195,4.055),(79.195,3.885),(79.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.865),(40.115,20.035),(40.285,20.035),(40.285,19.865),(40.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.865),(40.625,20.035),(40.795,20.035),(40.795,19.865),(40.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.485),(49.205,17.655),(49.375,17.655),(49.375,17.485),(49.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.485),(49.715,17.655),(49.885,17.655),(49.885,17.485),(49.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,24.285),(74.225,24.455),(74.395,24.455),(74.395,24.285),(74.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,22.925),(83.315,23.095),(83.485,23.095),(83.485,22.925),(83.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,27.685),(63.605,27.855),(63.775,27.855),(63.775,27.685),(63.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.305),(50.225,25.475),(50.395,25.475),(50.395,25.305),(50.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.645),(50.225,25.815),(50.395,25.815),(50.395,25.645),(50.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.885),(59.825,4.055),(59.995,4.055),(59.995,3.885),(59.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.885),(59.315,4.055),(59.485,4.055),(59.485,3.885),(59.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,40.265),(26.225,40.435),(26.395,40.435),(26.395,40.265),(26.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.425),(44.405,31.595),(44.575,31.595),(44.575,31.425),(44.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.165),(25.715,18.335),(25.885,18.335),(25.885,18.165),(25.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.505),(25.715,18.675),(25.885,18.675),(25.885,18.505),(25.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.285),(54.005,7.455),(54.175,7.455),(54.175,7.285),(54.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.825),(16.115,17.995),(16.285,17.995),(16.285,17.825),(16.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.145),(16.115,17.315),(16.285,17.315),(16.285,17.145),(16.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.485),(16.115,17.655),(16.285,17.655),(16.285,17.485),(16.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.965),(39.605,8.135),(39.775,8.135),(39.775,7.965),(39.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,35.165),(26.225,35.335),(26.395,35.335),(26.395,35.165),(26.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,35.505),(26.225,35.675),(26.395,35.675),(26.395,35.505),(26.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.665),(79.025,9.835),(79.195,9.835),(79.195,9.665),(79.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.405),(7.025,13.575),(7.195,13.575),(7.195,13.405),(7.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.205),(49.205,20.375),(49.375,20.375),(49.375,20.205),(49.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.205),(49.715,20.375),(49.885,20.375),(49.885,20.205),(49.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.545),(49.205,20.715),(49.375,20.715),(49.375,20.545),(49.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.545),(49.715,20.715),(49.885,20.715),(49.885,20.545),(49.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.485),(68.915,17.655),(69.085,17.655),(69.085,17.485),(68.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.505),(44.915,18.675),(45.085,18.675),(45.085,18.505),(44.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.885),(31.025,4.055),(31.195,4.055),(31.195,3.885),(31.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,27.005),(68.915,27.175),(69.085,27.175),(69.085,27.005),(68.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,39.925),(10.805,40.095),(10.975,40.095),(10.975,39.925),(10.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.285),(55.025,24.455),(55.195,24.455),(55.195,24.285),(55.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.625),(55.025,24.795),(55.195,24.795),(55.195,24.625),(55.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.305),(26.225,8.475),(26.395,8.475),(26.395,8.305),(26.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.645),(26.225,8.815),(26.395,8.815),(26.395,8.645),(26.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,21.565),(68.915,21.735),(69.085,21.735),(69.085,21.565),(68.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.225),(44.405,4.395),(44.575,4.395),(44.575,4.225),(44.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.565),(44.405,4.735),(44.575,4.735),(44.575,4.565),(44.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.065),(79.025,13.235),(79.195,13.235),(79.195,13.065),(79.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.985),(55.025,26.155),(55.195,26.155),(55.195,25.985),(55.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,30.065),(68.915,30.235),(69.085,30.235),(69.085,30.065),(68.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,30.405),(68.915,30.575),(69.085,30.575),(69.085,30.405),(68.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,30.745),(68.915,30.915),(69.085,30.915),(69.085,30.745),(68.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.405),(79.025,13.575),(79.195,13.575),(79.195,13.405),(79.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.525),(63.605,19.695),(63.775,19.695),(63.775,19.525),(63.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.185),(63.605,19.355),(63.775,19.355),(63.775,19.185),(63.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.745),(79.025,13.915),(79.195,13.915),(79.195,13.745),(79.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.585),(68.405,5.755),(68.575,5.755),(68.575,5.585),(68.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.965),(63.605,8.135),(63.775,8.135),(63.775,7.965),(63.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.765),(16.115,14.935),(16.285,14.935),(16.285,14.765),(16.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.085),(16.115,14.255),(16.285,14.255),(16.285,14.085),(16.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,23.265),(82.805,23.435),(82.975,23.435),(82.975,23.265),(82.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,37.885),(20.915,38.055),(21.085,38.055),(21.085,37.885),(20.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.785),(20.405,15.955),(20.575,15.955),(20.575,15.785),(20.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.165),(59.315,18.335),(59.485,18.335),(59.485,18.165),(59.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.165),(59.825,18.335),(59.995,18.335),(59.995,18.165),(59.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,35.165),(69.425,35.335),(69.595,35.335),(69.595,35.165),(69.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,35.505),(69.425,35.675),(69.595,35.675),(69.595,35.505),(69.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.825),(7.025,17.995),(7.195,17.995),(7.195,17.825),(7.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.145),(7.025,17.315),(7.195,17.315),(7.195,17.145),(7.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.945),(45.425,7.115),(45.595,7.115),(45.595,6.945),(45.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.145),(21.425,17.315),(21.595,17.315),(21.595,17.145),(21.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.485),(21.425,17.655),(21.595,17.655),(21.595,17.485),(21.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.825),(21.425,17.995),(21.595,17.995),(21.595,17.825),(21.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.585),(44.915,22.755),(45.085,22.755),(45.085,22.585),(44.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.245),(44.915,22.415),(45.085,22.415),(45.085,22.245),(44.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.865),(20.405,20.035),(20.575,20.035),(20.575,19.865),(20.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.925),(40.115,23.095),(40.285,23.095),(40.285,22.925),(40.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.925),(40.625,23.095),(40.795,23.095),(40.795,22.925),(40.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.485),(54.005,17.655),(54.175,17.655),(54.175,17.485),(54.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.825),(54.515,17.995),(54.685,17.995),(54.685,17.825),(54.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.145),(54.515,17.315),(54.685,17.315),(54.685,17.145),(54.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.225),(34.805,38.395),(34.975,38.395),(34.975,38.225),(34.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.825),(11.825,17.995),(11.995,17.995),(11.995,17.825),(11.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.145),(11.825,17.315),(11.995,17.315),(11.995,17.145),(11.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.485),(11.825,17.655),(11.995,17.655),(11.995,17.485),(11.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.585),(20.915,5.755),(21.085,5.755),(21.085,5.585),(20.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.105),(55.025,15.275),(55.195,15.275),(55.195,15.105),(55.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,29.045),(64.115,29.215),(64.285,29.215),(64.285,29.045),(64.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,29.045),(64.625,29.215),(64.795,29.215),(64.795,29.045),(64.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,29.385),(64.115,29.555),(64.285,29.555),(64.285,29.385),(64.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,29.385),(64.625,29.555),(64.795,29.555),(64.795,29.385),(64.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,29.725),(64.115,29.895),(64.285,29.895),(64.285,29.725),(64.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,29.725),(64.625,29.895),(64.795,29.895),(64.795,29.725),(64.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.205),(50.225,20.375),(50.395,20.375),(50.395,20.205),(50.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.545),(50.225,20.715),(50.395,20.715),(50.395,20.545),(50.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.545),(69.425,3.715),(69.595,3.715),(69.595,3.545),(69.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,22.585),(16.625,22.755),(16.795,22.755),(16.795,22.585),(16.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,37.885),(73.205,38.055),(73.375,38.055),(73.375,37.885),(73.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,37.885),(73.715,38.055),(73.885,38.055),(73.885,37.885),(73.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,39.585),(78.005,39.755),(78.175,39.755),(78.175,39.585),(78.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,39.585),(78.515,39.755),(78.685,39.755),(78.685,39.585),(78.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.745),(44.915,30.915),(45.085,30.915),(45.085,30.745),(44.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.065),(44.915,30.235),(45.085,30.235),(45.085,30.065),(44.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.885),(45.425,21.055),(45.595,21.055),(45.595,20.885),(45.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.765),(83.315,14.935),(83.485,14.935),(83.485,14.765),(83.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.425),(83.315,14.595),(83.485,14.595),(83.485,14.425),(83.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.085),(83.315,14.255),(83.485,14.255),(83.485,14.085),(83.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.865),(49.205,37.035),(49.375,37.035),(49.375,36.865),(49.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.865),(49.715,37.035),(49.885,37.035),(49.885,36.865),(49.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.545),(44.405,3.715),(44.575,3.715),(44.575,3.545),(44.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.205),(44.405,3.375),(44.575,3.375),(44.575,3.205),(44.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,40.605),(63.605,40.775),(63.775,40.775),(63.775,40.605),(63.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,20.885),(16.625,21.055),(16.795,21.055),(16.795,20.885),(16.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.665),(73.715,9.835),(73.885,9.835),(73.885,9.665),(73.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.665),(73.205,9.835),(73.375,9.835),(73.375,9.665),(73.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.885),(59.315,21.055),(59.485,21.055),(59.485,20.885),(59.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,20.885),(59.825,21.055),(59.995,21.055),(59.995,20.885),(59.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.925),(39.605,40.095),(39.775,40.095),(39.775,39.925),(39.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.305),(39.605,25.475),(39.775,25.475),(39.775,25.305),(39.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.325),(20.405,9.495),(20.575,9.495),(20.575,9.325),(20.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.805),(45.425,33.975),(45.595,33.975),(45.595,33.805),(45.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.125),(45.425,33.295),(45.595,33.295),(45.595,33.125),(45.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.465),(45.425,33.635),(45.595,33.635),(45.595,33.465),(45.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,22.925),(20.915,23.095),(21.085,23.095),(21.085,22.925),(20.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,34.145),(11.315,34.315),(11.485,34.315),(11.485,34.145),(11.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,34.145),(11.825,34.315),(11.995,34.315),(11.995,34.145),(11.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,34.825),(11.315,34.995),(11.485,34.995),(11.485,34.825),(11.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,34.825),(11.825,34.995),(11.995,34.995),(11.995,34.825),(11.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,34.485),(11.315,34.655),(11.485,34.655),(11.485,34.485),(11.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,34.485),(11.825,34.655),(11.995,34.655),(11.995,34.485),(11.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,24.965),(69.425,25.135),(69.595,25.135),(69.595,24.965),(69.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,26.665),(31.025,26.835),(31.195,26.835),(31.195,26.665),(31.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,39.245),(30.005,39.415),(30.175,39.415),(30.175,39.245),(30.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.545),(50.225,3.715),(50.395,3.715),(50.395,3.545),(50.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.645),(20.915,8.815),(21.085,8.815),(21.085,8.645),(20.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,40.605),(49.205,40.775),(49.375,40.775),(49.375,40.605),(49.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,40.605),(49.715,40.775),(49.885,40.775),(49.885,40.605),(49.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.085),(55.025,14.255),(55.195,14.255),(55.195,14.085),(55.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.425),(55.025,14.595),(55.195,14.595),(55.195,14.425),(55.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.105),(30.005,15.275),(30.175,15.275),(30.175,15.105),(30.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.445),(30.005,15.615),(30.175,15.615),(30.175,15.445),(30.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.765),(55.025,14.935),(55.195,14.935),(55.195,14.765),(55.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.245),(6.515,5.415),(6.685,5.415),(6.685,5.245),(6.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.585),(6.515,5.755),(6.685,5.755),(6.685,5.585),(6.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.845),(15.605,19.015),(15.775,19.015),(15.775,18.845),(15.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.885),(64.625,4.055),(64.795,4.055),(64.795,3.885),(64.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.885),(64.115,4.055),(64.285,4.055),(64.285,3.885),(64.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,27.685),(69.425,27.855),(69.595,27.855),(69.595,27.685),(69.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.385),(68.915,12.555),(69.085,12.555),(69.085,12.385),(68.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.725),(68.915,12.895),(69.085,12.895),(69.085,12.725),(68.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.045),(68.915,12.215),(69.085,12.215),(69.085,12.045),(68.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.365),(79.025,11.535),(79.195,11.535),(79.195,11.365),(79.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.705),(79.025,11.875),(79.195,11.875),(79.195,11.705),(79.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.025),(79.025,11.195),(79.195,11.195),(79.195,11.025),(79.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.005),(44.915,27.175),(45.085,27.175),(45.085,27.005),(44.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.345),(44.915,27.515),(45.085,27.515),(45.085,27.345),(44.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.925),(79.025,6.095),(79.195,6.095),(79.195,5.925),(79.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.645),(74.225,8.815),(74.395,8.815),(74.395,8.645),(74.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.025),(30.005,11.195),(30.175,11.195),(30.175,11.025),(30.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.705),(30.005,11.875),(30.175,11.875),(30.175,11.705),(30.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.985),(73.205,9.155),(73.375,9.155),(73.375,8.985),(73.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.985),(73.715,9.155),(73.885,9.155),(73.885,8.985),(73.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.785),(44.915,32.955),(45.085,32.955),(45.085,32.785),(44.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.105),(44.915,32.275),(45.085,32.275),(45.085,32.105),(44.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.445),(44.915,32.615),(45.085,32.615),(45.085,32.445),(44.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.425),(44.915,31.595),(45.085,31.595),(45.085,31.425),(44.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.905),(15.605,5.075),(15.775,5.075),(15.775,4.905),(15.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.285),(83.315,7.455),(83.485,7.455),(83.485,7.285),(83.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.425),(35.825,14.595),(35.995,14.595),(35.995,14.425),(35.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.425),(35.315,14.595),(35.485,14.595),(35.485,14.425),(35.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.185),(30.515,36.355),(30.685,36.355),(30.685,36.185),(30.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.525),(30.515,36.695),(30.685,36.695),(30.685,36.525),(30.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.445),(44.405,15.615),(44.575,15.615),(44.575,15.445),(44.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.785),(44.405,15.955),(44.575,15.955),(44.575,15.785),(44.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,26.665),(15.605,26.835),(15.775,26.835),(15.775,26.665),(15.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,38.905),(16.115,39.075),(16.285,39.075),(16.285,38.905),(16.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,33.805),(16.625,33.975),(16.795,33.975),(16.795,33.805),(16.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,33.125),(16.625,33.295),(16.795,33.295),(16.795,33.125),(16.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,33.465),(16.625,33.635),(16.795,33.635),(16.795,33.465),(16.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,25.985),(10.805,26.155),(10.975,26.155),(10.975,25.985),(10.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,32.105),(68.405,32.275),(68.575,32.275),(68.575,32.105),(68.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,32.445),(68.405,32.615),(68.575,32.615),(68.575,32.445),(68.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,32.785),(68.405,32.955),(68.575,32.955),(68.575,32.785),(68.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,25.305),(79.025,25.475),(79.195,25.475),(79.195,25.305),(79.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.165),(54.515,18.335),(54.685,18.335),(54.685,18.165),(54.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.505),(54.005,18.675),(54.175,18.675),(54.175,18.505),(54.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.225),(63.605,4.395),(63.775,4.395),(63.775,4.225),(63.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.565),(63.605,4.735),(63.775,4.735),(63.775,4.565),(63.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.365),(25.715,11.535),(25.885,11.535),(25.885,11.365),(25.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,25.985),(7.025,26.155),(7.195,26.155),(7.195,25.985),(7.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.885),(16.625,4.055),(16.795,4.055),(16.795,3.885),(16.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,38.565),(69.425,38.735),(69.595,38.735),(69.595,38.565),(69.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,40.605),(25.205,40.775),(25.375,40.775),(25.375,40.605),(25.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.965),(44.405,8.135),(44.575,8.135),(44.575,7.965),(44.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.365),(31.025,11.535),(31.195,11.535),(31.195,11.365),(31.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.705),(31.025,11.875),(31.195,11.875),(31.195,11.705),(31.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.025),(31.025,11.195),(31.195,11.195),(31.195,11.025),(31.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,29.385),(16.115,29.555),(16.285,29.555),(16.285,29.385),(16.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,36.865),(73.205,37.035),(73.375,37.035),(73.375,36.865),(73.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,36.865),(73.715,37.035),(73.885,37.035),(73.885,36.865),(73.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,29.725),(16.115,29.895),(16.285,29.895),(16.285,29.725),(16.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,29.045),(16.115,29.215),(16.285,29.215),(16.285,29.045),(16.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.285),(11.315,7.455),(11.485,7.455),(11.485,7.285),(11.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.865),(39.605,3.035),(39.775,3.035),(39.775,2.865),(39.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.245),(55.025,39.415),(55.195,39.415),(55.195,39.245),(55.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.945),(16.625,7.115),(16.795,7.115),(16.795,6.945),(16.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,21.905),(16.115,22.075),(16.285,22.075),(16.285,21.905),(16.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.245),(10.805,5.415),(10.975,5.415),(10.975,5.245),(10.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.785),(20.915,15.955),(21.085,15.955),(21.085,15.785),(20.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.885),(50.225,4.055),(50.395,4.055),(50.395,3.885),(50.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.585),(49.205,39.755),(49.375,39.755),(49.375,39.585),(49.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.585),(49.715,39.755),(49.885,39.755),(49.885,39.585),(49.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.685),(45.425,27.855),(45.595,27.855),(45.595,27.685),(45.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.425),(10.805,14.595),(10.975,14.595),(10.975,14.425),(10.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.765),(10.805,14.935),(10.975,14.935),(10.975,14.765),(10.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.085),(10.805,14.255),(10.975,14.255),(10.975,14.085),(10.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,32.445),(30.005,32.615),(30.175,32.615),(30.175,32.445),(30.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,32.785),(30.005,32.955),(30.175,32.955),(30.175,32.785),(30.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,32.105),(30.005,32.275),(30.175,32.275),(30.175,32.105),(30.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.105),(63.605,15.275),(63.775,15.275),(63.775,15.105),(63.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,35.845),(82.805,36.015),(82.975,36.015),(82.975,35.845),(82.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,36.525),(11.825,36.695),(11.995,36.695),(11.995,36.525),(11.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,36.185),(11.825,36.355),(11.995,36.355),(11.995,36.185),(11.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.325),(54.005,9.495),(54.175,9.495),(54.175,9.325),(54.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.665),(54.515,9.835),(54.685,9.835),(54.685,9.665),(54.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,38.565),(68.405,38.735),(68.575,38.735),(68.575,38.565),(68.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,29.385),(82.805,29.555),(82.975,29.555),(82.975,29.385),(82.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,37.545),(10.805,37.715),(10.975,37.715),(10.975,37.545),(10.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,25.645),(74.225,25.815),(74.395,25.815),(74.395,25.645),(74.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.325),(6.515,9.495),(6.685,9.495),(6.685,9.325),(6.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.665),(6.515,9.835),(6.685,9.835),(6.685,9.665),(6.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,40.605),(44.915,40.775),(45.085,40.775),(45.085,40.605),(44.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,34.145),(83.315,34.315),(83.485,34.315),(83.485,34.145),(83.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,34.485),(83.315,34.655),(83.485,34.655),(83.485,34.485),(83.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,34.825),(83.315,34.995),(83.485,34.995),(83.485,34.825),(83.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.265),(59.315,23.435),(59.485,23.435),(59.485,23.265),(59.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,23.265),(59.825,23.435),(59.995,23.435),(59.995,23.265),(59.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.545),(63.605,3.715),(63.775,3.715),(63.775,3.545),(63.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.205),(63.605,3.375),(63.775,3.375),(63.775,3.205),(63.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.245),(31.025,39.415),(31.195,39.415),(31.195,39.245),(31.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,39.245),(73.205,39.415),(73.375,39.415),(73.375,39.245),(73.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,39.245),(73.715,39.415),(73.885,39.415),(73.885,39.245),(73.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.965),(39.605,25.135),(39.775,25.135),(39.775,24.965),(39.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.585),(45.425,22.755),(45.595,22.755),(45.595,22.585),(45.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.985),(16.115,9.155),(16.285,9.155),(16.285,8.985),(16.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.245),(73.205,5.415),(73.375,5.415),(73.375,5.245),(73.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.245),(73.715,5.415),(73.885,5.415),(73.885,5.245),(73.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.845),(44.405,19.015),(44.575,19.015),(44.575,18.845),(44.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,36.865),(15.605,37.035),(15.775,37.035),(15.775,36.865),(15.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.745),(68.405,13.915),(68.575,13.915),(68.575,13.745),(68.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.065),(68.405,13.235),(68.575,13.235),(68.575,13.065),(68.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,32.445),(25.205,32.615),(25.375,32.615),(25.375,32.445),(25.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,32.785),(25.205,32.955),(25.375,32.955),(25.375,32.785),(25.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,32.105),(25.205,32.275),(25.375,32.275),(25.375,32.105),(25.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.405),(68.405,13.575),(68.575,13.575),(68.575,13.405),(68.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.485),(69.425,17.655),(69.595,17.655),(69.595,17.485),(69.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.145),(69.425,17.315),(69.595,17.315),(69.595,17.145),(69.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,33.465),(11.315,33.635),(11.485,33.635),(11.485,33.465),(11.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,33.805),(11.315,33.975),(11.485,33.975),(11.485,33.805),(11.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,33.125),(11.315,33.295),(11.485,33.295),(11.485,33.125),(11.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.085),(44.915,14.255),(45.085,14.255),(45.085,14.085),(44.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.765),(44.915,14.935),(45.085,14.935),(45.085,14.765),(44.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.825),(69.425,17.995),(69.595,17.995),(69.595,17.825),(69.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,2.865),(83.315,3.035),(83.485,3.035),(83.485,2.865),(83.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,24.625),(11.315,24.795),(11.485,24.795),(11.485,24.625),(11.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.865),(58.805,37.035),(58.975,37.035),(58.975,36.865),(58.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.845),(82.805,19.015),(82.975,19.015),(82.975,18.845),(82.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.245),(50.225,39.415),(50.395,39.415),(50.395,39.245),(50.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.305),(35.315,25.475),(35.485,25.475),(35.485,25.305),(35.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.305),(35.825,25.475),(35.995,25.475),(35.995,25.305),(35.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.025),(7.025,11.195),(7.195,11.195),(7.195,11.025),(7.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.705),(7.025,11.875),(7.195,11.875),(7.195,11.705),(7.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.905),(11.825,5.075),(11.995,5.075),(11.995,4.905),(11.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.725),(78.005,12.895),(78.175,12.895),(78.175,12.725),(78.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.725),(78.515,12.895),(78.685,12.895),(78.685,12.725),(78.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,22.585),(63.605,22.755),(63.775,22.755),(63.775,22.585),(63.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.045),(78.005,12.215),(78.175,12.215),(78.175,12.045),(78.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.325),(26.225,9.495),(26.395,9.495),(26.395,9.325),(26.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.045),(78.515,12.215),(78.685,12.215),(78.685,12.045),(78.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.225),(50.225,4.395),(50.395,4.395),(50.395,4.225),(50.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.565),(50.225,4.735),(50.395,4.735),(50.395,4.565),(50.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.665),(39.605,9.835),(39.775,9.835),(39.775,9.665),(39.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,37.885),(15.605,38.055),(15.775,38.055),(15.775,37.885),(15.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,2.865),(11.315,3.035),(11.485,3.035),(11.485,2.865),(11.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.065),(20.915,13.235),(21.085,13.235),(21.085,13.065),(20.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.745),(20.915,13.915),(21.085,13.915),(21.085,13.745),(20.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.405),(20.915,13.575),(21.085,13.575),(21.085,13.405),(20.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.945),(15.605,7.115),(15.775,7.115),(15.775,6.945),(15.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.225),(83.315,4.395),(83.485,4.395),(83.485,4.225),(83.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.465),(68.915,16.635),(69.085,16.635),(69.085,16.465),(68.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.265),(40.115,23.435),(40.285,23.435),(40.285,23.265),(40.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.265),(40.625,23.435),(40.795,23.435),(40.795,23.265),(40.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.605),(40.115,23.775),(40.285,23.775),(40.285,23.605),(40.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.605),(40.625,23.775),(40.795,23.775),(40.795,23.605),(40.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,25.645),(20.405,25.815),(20.575,25.815),(20.575,25.645),(20.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.865),(45.425,3.035),(45.595,3.035),(45.595,2.865),(45.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.505),(20.405,18.675),(20.575,18.675),(20.575,18.505),(20.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.305),(44.915,8.475),(45.085,8.475),(45.085,8.305),(44.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.645),(44.915,8.815),(45.085,8.815),(45.085,8.645),(44.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.925),(45.425,6.095),(45.595,6.095),(45.595,5.925),(45.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.905),(59.315,5.075),(59.485,5.075),(59.485,4.905),(59.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,32.785),(15.605,32.955),(15.775,32.955),(15.775,32.785),(15.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,32.445),(15.605,32.615),(15.775,32.615),(15.775,32.445),(15.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,32.105),(15.605,32.275),(15.775,32.275),(15.775,32.105),(15.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.445),(44.915,15.615),(45.085,15.615),(45.085,15.445),(44.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.785),(44.915,15.955),(45.085,15.955),(45.085,15.785),(44.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.385),(15.605,12.555),(15.775,12.555),(15.775,12.385),(15.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.905),(59.825,5.075),(59.995,5.075),(59.995,4.905),(59.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.345),(25.205,10.515),(25.375,10.515),(25.375,10.345),(25.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,23.605),(10.805,23.775),(10.975,23.775),(10.975,23.605),(10.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.505),(59.315,35.675),(59.485,35.675),(59.485,35.505),(59.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,35.505),(59.825,35.675),(59.995,35.675),(59.995,35.505),(59.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.165),(59.315,35.335),(59.485,35.335),(59.485,35.165),(59.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,35.165),(59.825,35.335),(59.995,35.335),(59.995,35.165),(59.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.005),(31.025,10.175),(31.195,10.175),(31.195,10.005),(31.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.685),(31.025,10.855),(31.195,10.855),(31.195,10.685),(31.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.165),(73.205,18.335),(73.375,18.335),(73.375,18.165),(73.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.165),(73.715,18.335),(73.885,18.335),(73.885,18.165),(73.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,38.905),(63.605,39.075),(63.775,39.075),(63.775,38.905),(63.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.985),(11.315,9.155),(11.485,9.155),(11.485,8.985),(11.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.985),(11.825,9.155),(11.995,9.155),(11.995,8.985),(11.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.005),(20.405,10.175),(20.575,10.175),(20.575,10.005),(20.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.345),(20.405,10.515),(20.575,10.515),(20.575,10.345),(20.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.685),(20.405,10.855),(20.575,10.855),(20.575,10.685),(20.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.045),(40.625,29.215),(40.795,29.215),(40.795,29.045),(40.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.725),(40.115,29.895),(40.285,29.895),(40.285,29.725),(40.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.725),(40.625,29.895),(40.795,29.895),(40.795,29.725),(40.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.045),(40.115,29.215),(40.285,29.215),(40.285,29.045),(40.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,31.085),(26.225,31.255),(26.395,31.255),(26.395,31.085),(26.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,31.425),(26.225,31.595),(26.395,31.595),(26.395,31.425),(26.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,31.765),(26.225,31.935),(26.395,31.935),(26.395,31.765),(26.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.525),(54.005,19.695),(54.175,19.695),(54.175,19.525),(54.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.185),(54.005,19.355),(54.175,19.355),(54.175,19.185),(54.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.265),(55.025,6.435),(55.195,6.435),(55.195,6.265),(55.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,39.245),(74.225,39.415),(74.395,39.415),(74.395,39.245),(74.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,33.125),(83.315,33.295),(83.485,33.295),(83.485,33.125),(83.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,33.465),(83.315,33.635),(83.485,33.635),(83.485,33.465),(83.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,33.805),(83.315,33.975),(83.485,33.975),(83.485,33.805),(83.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.885),(58.805,21.055),(58.975,21.055),(58.975,20.885),(58.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.885),(54.515,21.055),(54.685,21.055),(54.685,20.885),(54.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.905),(54.515,39.075),(54.685,39.075),(54.685,38.905),(54.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.625),(68.405,7.795),(68.575,7.795),(68.575,7.625),(68.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.265),(69.425,6.435),(69.595,6.435),(69.595,6.265),(69.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.605),(69.425,6.775),(69.595,6.775),(69.595,6.605),(69.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,23.265),(79.025,23.435),(79.195,23.435),(79.195,23.265),(79.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,23.605),(79.025,23.775),(79.195,23.775),(79.195,23.605),(79.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.145),(39.605,34.315),(39.775,34.315),(39.775,34.145),(39.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.485),(39.605,34.655),(39.775,34.655),(39.775,34.485),(39.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.825),(39.605,34.995),(39.775,34.995),(39.775,34.825),(39.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.605),(21.425,6.775),(21.595,6.775),(21.595,6.605),(21.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,31.425),(78.005,31.595),(78.175,31.595),(78.175,31.425),(78.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,31.425),(78.515,31.595),(78.685,31.595),(78.685,31.425),(78.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,33.125),(69.425,33.295),(69.595,33.295),(69.595,33.125),(69.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,33.465),(69.425,33.635),(69.595,33.635),(69.595,33.465),(69.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,33.805),(69.425,33.975),(69.595,33.975),(69.595,33.805),(69.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,37.545),(69.425,37.715),(69.595,37.715),(69.595,37.545),(69.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,21.905),(10.805,22.075),(10.975,22.075),(10.975,21.905),(10.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,31.765),(64.115,31.935),(64.285,31.935),(64.285,31.765),(64.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,31.765),(64.625,31.935),(64.795,31.935),(64.795,31.765),(64.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,31.085),(64.115,31.255),(64.285,31.255),(64.285,31.085),(64.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,31.085),(64.625,31.255),(64.795,31.255),(64.795,31.085),(64.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.945),(54.005,24.115),(54.175,24.115),(54.175,23.945),(54.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.525),(59.825,19.695),(59.995,19.695),(59.995,19.525),(59.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.525),(59.315,19.695),(59.485,19.695),(59.485,19.525),(59.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.865),(7.025,20.035),(7.195,20.035),(7.195,19.865),(7.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.465),(40.115,16.635),(40.285,16.635),(40.285,16.465),(40.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.465),(40.625,16.635),(40.795,16.635),(40.795,16.465),(40.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,26.665),(6.515,26.835),(6.685,26.835),(6.685,26.665),(6.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,26.325),(6.515,26.495),(6.685,26.495),(6.685,26.325),(6.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.745),(30.005,13.915),(30.175,13.915),(30.175,13.745),(30.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.065),(30.005,13.235),(30.175,13.235),(30.175,13.065),(30.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,39.245),(6.515,39.415),(6.685,39.415),(6.685,39.245),(6.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.945),(25.715,7.115),(25.885,7.115),(25.885,6.945),(25.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.945),(6.515,7.115),(6.685,7.115),(6.685,6.945),(6.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.145),(68.405,17.315),(68.575,17.315),(68.575,17.145),(68.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.825),(68.405,17.995),(68.575,17.995),(68.575,17.825),(68.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.425),(63.605,14.595),(63.775,14.595),(63.775,14.425),(63.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.925),(11.825,6.095),(11.995,6.095),(11.995,5.925),(11.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,35.505),(20.405,35.675),(20.575,35.675),(20.575,35.505),(20.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,35.165),(20.405,35.335),(20.575,35.335),(20.575,35.165),(20.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,39.585),(20.405,39.755),(20.575,39.755),(20.575,39.585),(20.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,38.565),(78.515,38.735),(78.685,38.735),(78.685,38.565),(78.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,38.565),(78.005,38.735),(78.175,38.735),(78.175,38.565),(78.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,37.545),(68.405,37.715),(68.575,37.715),(68.575,37.545),(68.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.865),(54.515,20.035),(54.685,20.035),(54.685,19.865),(54.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.665),(35.315,9.835),(35.485,9.835),(35.485,9.665),(35.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.665),(35.825,9.835),(35.995,9.835),(35.995,9.665),(35.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.305),(20.405,8.475),(20.575,8.475),(20.575,8.305),(20.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.905),(31.025,22.075),(31.195,22.075),(31.195,21.905),(31.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,25.985),(68.405,26.155),(68.575,26.155),(68.575,25.985),(68.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.945),(30.005,7.115),(30.175,7.115),(30.175,6.945),(30.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,32.105),(68.915,32.275),(69.085,32.275),(69.085,32.105),(68.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,32.445),(68.915,32.615),(69.085,32.615),(69.085,32.445),(68.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,32.785),(68.915,32.955),(69.085,32.955),(69.085,32.785),(68.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.225),(35.315,21.395),(35.485,21.395),(35.485,21.225),(35.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.225),(35.825,21.395),(35.995,21.395),(35.995,21.225),(35.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,33.125),(21.425,33.295),(21.595,33.295),(21.595,33.125),(21.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,33.805),(21.425,33.975),(21.595,33.975),(21.595,33.805),(21.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,33.465),(21.425,33.635),(21.595,33.635),(21.595,33.465),(21.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,38.225),(30.005,38.395),(30.175,38.395),(30.175,38.225),(30.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.945),(58.805,7.115),(58.975,7.115),(58.975,6.945),(58.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.825),(54.515,34.995),(54.685,34.995),(54.685,34.825),(54.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.145),(54.515,34.315),(54.685,34.315),(54.685,34.145),(54.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.485),(54.515,34.655),(54.685,34.655),(54.685,34.485),(54.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.945),(54.005,7.115),(54.175,7.115),(54.175,6.945),(54.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.425),(82.805,14.595),(82.975,14.595),(82.975,14.425),(82.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.625),(64.115,7.795),(64.285,7.795),(64.285,7.625),(64.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.625),(64.625,7.795),(64.795,7.795),(64.795,7.625),(64.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,21.225),(11.315,21.395),(11.485,21.395),(11.485,21.225),(11.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,21.565),(11.315,21.735),(11.485,21.735),(11.485,21.565),(11.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,21.565),(11.825,21.735),(11.995,21.735),(11.995,21.565),(11.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.025),(50.225,11.195),(50.395,11.195),(50.395,11.025),(50.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.705),(50.225,11.875),(50.395,11.875),(50.395,11.705),(50.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.525),(40.115,19.695),(40.285,19.695),(40.285,19.525),(40.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.525),(40.625,19.695),(40.795,19.695),(40.795,19.525),(40.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.185),(40.625,19.355),(40.795,19.355),(40.795,19.185),(40.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,32.785),(16.115,32.955),(16.285,32.955),(16.285,32.785),(16.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,32.445),(16.115,32.615),(16.285,32.615),(16.285,32.445),(16.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,32.105),(16.115,32.275),(16.285,32.275),(16.285,32.105),(16.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.805),(25.205,16.975),(25.375,16.975),(25.375,16.805),(25.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.465),(7.025,16.635),(7.195,16.635),(7.195,16.465),(7.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.185),(44.405,36.355),(44.575,36.355),(44.575,36.185),(44.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.525),(44.405,36.695),(44.575,36.695),(44.575,36.525),(44.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.125),(25.205,16.295),(25.375,16.295),(25.375,16.125),(25.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,24.965),(74.225,25.135),(74.395,25.135),(74.395,24.965),(74.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.065),(25.205,13.235),(25.375,13.235),(25.375,13.065),(25.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.745),(25.205,13.915),(25.375,13.915),(25.375,13.745),(25.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.405),(25.205,13.575),(25.375,13.575),(25.375,13.405),(25.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.605),(44.915,6.775),(45.085,6.775),(45.085,6.605),(44.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.265),(44.915,6.435),(45.085,6.435),(45.085,6.265),(44.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.405),(58.805,13.575),(58.975,13.575),(58.975,13.405),(58.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.845),(25.715,19.015),(25.885,19.015),(25.885,18.845),(25.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,32.785),(20.915,32.955),(21.085,32.955),(21.085,32.785),(20.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.145),(30.515,34.315),(30.685,34.315),(30.685,34.145),(30.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.485),(30.515,34.655),(30.685,34.655),(30.685,34.485),(30.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.825),(30.515,34.995),(30.685,34.995),(30.685,34.825),(30.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,32.445),(20.915,32.615),(21.085,32.615),(21.085,32.445),(20.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,32.105),(20.915,32.275),(21.085,32.275),(21.085,32.105),(20.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.925),(44.915,40.095),(45.085,40.095),(45.085,39.925),(44.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,29.045),(11.825,29.215),(11.995,29.215),(11.995,29.045),(11.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,29.385),(11.315,29.555),(11.485,29.555),(11.485,29.385),(11.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,37.545),(64.115,37.715),(64.285,37.715),(64.285,37.545),(64.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,37.545),(64.625,37.715),(64.795,37.715),(64.795,37.545),(64.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,40.265),(34.805,40.435),(34.975,40.435),(34.975,40.265),(34.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,29.385),(11.825,29.555),(11.995,29.555),(11.995,29.385),(11.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,29.725),(11.825,29.895),(11.995,29.895),(11.995,29.725),(11.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.625),(16.115,7.795),(16.285,7.795),(16.285,7.625),(16.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.625),(15.605,7.795),(15.775,7.795),(15.775,7.625),(15.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.885),(49.205,21.055),(49.375,21.055),(49.375,20.885),(49.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.885),(49.715,21.055),(49.885,21.055),(49.885,20.885),(49.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.745),(40.115,13.915),(40.285,13.915),(40.285,13.745),(40.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.745),(40.625,13.915),(40.795,13.915),(40.795,13.745),(40.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.065),(40.625,13.235),(40.795,13.235),(40.795,13.065),(40.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,39.245),(10.805,39.415),(10.975,39.415),(10.975,39.245),(10.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.925),(83.315,6.095),(83.485,6.095),(83.485,5.925),(83.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.965),(55.025,25.135),(55.195,25.135),(55.195,24.965),(55.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.985),(26.225,9.155),(26.395,9.155),(26.395,8.985),(26.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.545),(58.805,37.715),(58.975,37.715),(58.975,37.545),(58.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,26.665),(25.715,26.835),(25.885,26.835),(25.885,26.665),(25.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,26.325),(25.715,26.495),(25.885,26.495),(25.885,26.325),(25.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,26.325),(11.825,26.495),(11.995,26.495),(11.995,26.325),(11.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.305),(55.025,25.475),(55.195,25.475),(55.195,25.305),(55.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.565),(10.805,4.735),(10.975,4.735),(10.975,4.565),(10.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.225),(10.805,4.395),(10.975,4.395),(10.975,4.225),(10.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,29.385),(78.005,29.555),(78.175,29.555),(78.175,29.385),(78.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,29.385),(78.515,29.555),(78.685,29.555),(78.685,29.385),(78.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,35.845),(25.715,36.015),(25.885,36.015),(25.885,35.845),(25.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.325),(16.625,9.495),(16.795,9.495),(16.795,9.325),(16.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.845),(59.315,19.015),(59.485,19.015),(59.485,18.845),(59.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.845),(59.825,19.015),(59.995,19.015),(59.995,18.845),(59.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.925),(55.025,40.095),(55.195,40.095),(55.195,39.925),(55.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,37.205),(16.625,37.375),(16.795,37.375),(16.795,37.205),(16.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,26.665),(20.405,26.835),(20.575,26.835),(20.575,26.665),(20.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,26.325),(20.405,26.495),(20.575,26.495),(20.575,26.325),(20.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.025),(11.315,11.195),(11.485,11.195),(11.485,11.025),(11.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.705),(11.315,11.875),(11.485,11.875),(11.485,11.705),(11.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.665),(10.805,9.835),(10.975,9.835),(10.975,9.665),(10.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.185),(20.405,19.355),(20.575,19.355),(20.575,19.185),(20.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.865),(73.205,20.035),(73.375,20.035),(73.375,19.865),(73.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.865),(73.715,20.035),(73.885,20.035),(73.885,19.865),(73.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.605),(68.405,6.775),(68.575,6.775),(68.575,6.605),(68.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.905),(34.805,39.075),(34.975,39.075),(34.975,38.905),(34.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.145),(58.805,17.315),(58.975,17.315),(58.975,17.145),(58.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,30.405),(20.405,30.575),(20.575,30.575),(20.575,30.405),(20.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.825),(58.805,17.995),(58.975,17.995),(58.975,17.825),(58.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.485),(58.805,17.655),(58.975,17.655),(58.975,17.485),(58.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,28.025),(7.025,28.195),(7.195,28.195),(7.195,28.025),(7.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,28.365),(7.025,28.535),(7.195,28.535),(7.195,28.365),(7.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,28.705),(7.025,28.875),(7.195,28.875),(7.195,28.705),(7.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,2.865),(78.515,3.035),(78.685,3.035),(78.685,2.865),(78.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,38.905),(68.915,39.075),(69.085,39.075),(69.085,38.905),(68.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,2.865),(78.005,3.035),(78.175,3.035),(78.175,2.865),(78.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.345),(31.025,27.515),(31.195,27.515),(31.195,27.345),(31.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,21.225),(78.005,21.395),(78.175,21.395),(78.175,21.225),(78.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,21.225),(78.515,21.395),(78.685,21.395),(78.685,21.225),(78.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,21.565),(78.005,21.735),(78.175,21.735),(78.175,21.565),(78.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,21.565),(78.515,21.735),(78.685,21.735),(78.685,21.565),(78.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.965),(79.025,8.135),(79.195,8.135),(79.195,7.965),(79.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.885),(50.225,21.055),(50.395,21.055),(50.395,20.885),(50.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,22.925),(16.115,23.095),(16.285,23.095),(16.285,22.925),(16.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,37.205),(68.915,37.375),(69.085,37.375),(69.085,37.205),(68.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.625),(34.805,24.795),(34.975,24.795),(34.975,24.625),(34.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.685),(15.605,10.855),(15.775,10.855),(15.775,10.685),(15.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.925),(31.025,40.095),(31.195,40.095),(31.195,39.925),(31.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.005),(15.605,10.175),(15.775,10.175),(15.775,10.005),(15.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.345),(15.605,10.515),(15.775,10.515),(15.775,10.345),(15.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,37.205),(73.205,37.375),(73.375,37.375),(73.375,37.205),(73.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,37.205),(73.715,37.375),(73.885,37.375),(73.885,37.205),(73.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.025),(44.915,11.195),(45.085,11.195),(45.085,11.025),(44.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,39.925),(73.205,40.095),(73.375,40.095),(73.375,39.925),(73.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,39.925),(73.715,40.095),(73.885,40.095),(73.885,39.925),(73.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,23.265),(73.205,23.435),(73.375,23.435),(73.375,23.265),(73.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,23.265),(73.715,23.435),(73.885,23.435),(73.885,23.265),(73.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,27.005),(64.625,27.175),(64.795,27.175),(64.795,27.005),(64.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,27.005),(64.115,27.175),(64.285,27.175),(64.285,27.005),(64.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,40.265),(83.315,40.435),(83.485,40.435),(83.485,40.265),(83.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.905),(58.805,5.075),(58.975,5.075),(58.975,4.905),(58.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.945),(44.405,24.115),(44.575,24.115),(44.575,23.945),(44.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.905),(54.515,5.075),(54.685,5.075),(54.685,4.905),(54.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.885),(44.405,38.055),(44.575,38.055),(44.575,37.885),(44.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,2.865),(30.005,3.035),(30.175,3.035),(30.175,2.865),(30.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.225),(44.405,21.395),(44.575,21.395),(44.575,21.225),(44.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.925),(25.205,6.095),(25.375,6.095),(25.375,5.925),(25.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.185),(39.605,19.355),(39.775,19.355),(39.775,19.185),(39.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,22.925),(68.405,23.095),(68.575,23.095),(68.575,22.925),(68.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.125),(30.005,16.295),(30.175,16.295),(30.175,16.125),(30.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.805),(30.005,16.975),(30.175,16.975),(30.175,16.805),(30.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.305),(44.405,8.475),(44.575,8.475),(44.575,8.305),(44.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.645),(44.405,8.815),(44.575,8.815),(44.575,8.645),(44.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.025),(58.805,11.195),(58.975,11.195),(58.975,11.025),(58.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.705),(58.805,11.875),(58.975,11.875),(58.975,11.705),(58.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,37.545),(79.025,37.715),(79.195,37.715),(79.195,37.545),(79.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.385),(73.205,12.555),(73.375,12.555),(73.375,12.385),(73.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.385),(73.715,12.555),(73.885,12.555),(73.885,12.385),(73.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,29.045),(26.225,29.215),(26.395,29.215),(26.395,29.045),(26.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,29.725),(26.225,29.895),(26.395,29.895),(26.395,29.725),(26.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.285),(74.225,7.455),(74.395,7.455),(74.395,7.285),(74.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,23.265),(64.115,23.435),(64.285,23.435),(64.285,23.265),(64.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,23.265),(64.625,23.435),(64.795,23.435),(64.795,23.265),(64.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,23.605),(64.115,23.775),(64.285,23.775),(64.285,23.605),(64.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,23.605),(64.625,23.775),(64.795,23.775),(64.795,23.605),(64.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.605),(31.025,23.775),(31.195,23.775),(31.195,23.605),(31.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.145),(44.915,34.315),(45.085,34.315),(45.085,34.145),(44.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.485),(44.915,34.655),(45.085,34.655),(45.085,34.485),(44.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.825),(44.915,34.995),(45.085,34.995),(45.085,34.825),(44.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.305),(35.315,8.475),(35.485,8.475),(35.485,8.305),(35.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.305),(35.825,8.475),(35.995,8.475),(35.995,8.305),(35.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.645),(35.315,8.815),(35.485,8.815),(35.485,8.645),(35.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.645),(35.825,8.815),(35.995,8.815),(35.995,8.645),(35.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.965),(55.025,8.135),(55.195,8.135),(55.195,7.965),(55.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.205),(64.115,3.375),(64.285,3.375),(64.285,3.205),(64.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.545),(64.115,3.715),(64.285,3.715),(64.285,3.545),(64.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.205),(64.625,3.375),(64.795,3.375),(64.795,3.205),(64.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,28.365),(11.315,28.535),(11.485,28.535),(11.485,28.365),(11.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.545),(64.625,3.715),(64.795,3.715),(64.795,3.545),(64.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,27.005),(6.515,27.175),(6.685,27.175),(6.685,27.005),(6.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.585),(79.025,5.755),(79.195,5.755),(79.195,5.585),(79.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.245),(79.025,5.415),(79.195,5.415),(79.195,5.245),(79.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,2.865),(63.605,3.035),(63.775,3.035),(63.775,2.865),(63.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.505),(58.805,35.675),(58.975,35.675),(58.975,35.505),(58.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.165),(58.805,35.335),(58.975,35.335),(58.975,35.165),(58.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.865),(6.515,20.035),(6.685,20.035),(6.685,19.865),(6.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.925),(50.225,6.095),(50.395,6.095),(50.395,5.925),(50.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.565),(55.025,4.735),(55.195,4.735),(55.195,4.565),(55.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.545),(35.315,20.715),(35.485,20.715),(35.485,20.545),(35.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.545),(35.825,20.715),(35.995,20.715),(35.995,20.545),(35.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,31.425),(16.115,31.595),(16.285,31.595),(16.285,31.425),(16.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.525),(44.915,19.695),(45.085,19.695),(45.085,19.525),(44.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.565),(50.225,38.735),(50.395,38.735),(50.395,38.565),(50.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.865),(30.515,37.035),(30.685,37.035),(30.685,36.865),(30.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.925),(54.515,23.095),(54.685,23.095),(54.685,22.925),(54.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.925),(16.115,6.095),(16.285,6.095),(16.285,5.925),(16.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.745),(58.805,30.915),(58.975,30.915),(58.975,30.745),(58.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.065),(58.805,30.235),(58.975,30.235),(58.975,30.065),(58.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.405),(58.805,30.575),(58.975,30.575),(58.975,30.405),(58.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.405),(11.315,13.575),(11.485,13.575),(11.485,13.405),(11.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,23.605),(15.605,23.775),(15.775,23.775),(15.775,23.605),(15.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,23.265),(15.605,23.435),(15.775,23.435),(15.775,23.265),(15.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.845),(54.515,19.015),(54.685,19.015),(54.685,18.845),(54.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.925),(74.225,6.095),(74.395,6.095),(74.395,5.925),(74.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.425),(54.515,31.595),(54.685,31.595),(54.685,31.425),(54.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.765),(54.005,31.935),(54.175,31.935),(54.175,31.765),(54.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.085),(54.005,31.255),(54.175,31.255),(54.175,31.085),(54.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,25.305),(7.025,25.475),(7.195,25.475),(7.195,25.305),(7.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.205),(16.625,3.375),(16.795,3.375),(16.795,3.205),(16.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.545),(49.205,37.715),(49.375,37.715),(49.375,37.545),(49.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.545),(49.715,37.715),(49.885,37.715),(49.885,37.545),(49.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,29.385),(25.205,29.555),(25.375,29.555),(25.375,29.385),(25.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,29.725),(25.205,29.895),(25.375,29.895),(25.375,29.725),(25.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,29.045),(25.205,29.215),(25.375,29.215),(25.375,29.045),(25.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.485),(59.315,17.655),(59.485,17.655),(59.485,17.485),(59.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.485),(59.825,17.655),(59.995,17.655),(59.995,17.485),(59.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.225),(34.805,21.395),(34.975,21.395),(34.975,21.225),(34.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.725),(16.115,12.895),(16.285,12.895),(16.285,12.725),(16.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.045),(16.115,12.215),(16.285,12.215),(16.285,12.045),(16.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,40.265),(58.805,40.435),(58.975,40.435),(58.975,40.265),(58.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.725),(39.605,29.895),(39.775,29.895),(39.775,29.725),(39.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.045),(39.605,29.215),(39.775,29.215),(39.775,29.045),(39.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.385),(39.605,29.555),(39.775,29.555),(39.775,29.385),(39.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,21.905),(7.025,22.075),(7.195,22.075),(7.195,21.905),(7.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,36.865),(11.825,37.035),(11.995,37.035),(11.995,36.865),(11.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.645),(49.205,8.815),(49.375,8.815),(49.375,8.645),(49.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.645),(49.715,8.815),(49.885,8.815),(49.885,8.645),(49.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.325),(34.805,9.495),(34.975,9.495),(34.975,9.325),(34.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.105),(58.805,32.275),(58.975,32.275),(58.975,32.105),(58.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.785),(58.805,32.955),(58.975,32.955),(58.975,32.785),(58.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.445),(58.805,32.615),(58.975,32.615),(58.975,32.445),(58.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.785),(74.225,15.955),(74.395,15.955),(74.395,15.785),(74.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,23.605),(21.425,23.775),(21.595,23.775),(21.595,23.605),(21.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,21.565),(25.205,21.735),(25.375,21.735),(25.375,21.565),(25.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.885),(68.915,4.055),(69.085,4.055),(69.085,3.885),(68.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,38.565),(25.205,38.735),(25.375,38.735),(25.375,38.565),(25.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,23.945),(79.025,24.115),(79.195,24.115),(79.195,23.945),(79.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,23.265),(20.915,23.435),(21.085,23.435),(21.085,23.265),(20.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.265),(11.315,6.435),(11.485,6.435),(11.485,6.265),(11.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.265),(11.825,6.435),(11.995,6.435),(11.995,6.265),(11.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.605),(11.315,6.775),(11.485,6.775),(11.485,6.605),(11.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,37.885),(6.515,38.055),(6.685,38.055),(6.685,37.885),(6.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.625),(73.205,7.795),(73.375,7.795),(73.375,7.625),(73.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.625),(73.715,7.795),(73.885,7.795),(73.885,7.625),(73.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.125),(21.425,16.295),(21.595,16.295),(21.595,16.125),(21.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.465),(21.425,16.635),(21.595,16.635),(21.595,16.465),(21.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.805),(21.425,16.975),(21.595,16.975),(21.595,16.805),(21.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.485),(44.915,17.655),(45.085,17.655),(45.085,17.485),(44.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.645),(59.825,8.815),(59.995,8.815),(59.995,8.645),(59.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,40.265),(69.425,40.435),(69.595,40.435),(69.595,40.265),(69.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.645),(59.315,8.815),(59.485,8.815),(59.485,8.645),(59.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.245),(20.405,5.415),(20.575,5.415),(20.575,5.245),(20.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.585),(20.405,5.755),(20.575,5.755),(20.575,5.585),(20.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.305),(30.005,8.475),(30.175,8.475),(30.175,8.305),(30.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,38.565),(20.405,38.735),(20.575,38.735),(20.575,38.565),(20.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.925),(64.115,6.095),(64.285,6.095),(64.285,5.925),(64.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.925),(64.625,6.095),(64.795,6.095),(64.795,5.925),(64.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.045),(26.225,12.215),(26.395,12.215),(26.395,12.045),(26.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.925),(78.005,6.095),(78.175,6.095),(78.175,5.925),(78.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.925),(78.515,6.095),(78.685,6.095),(78.685,5.925),(78.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.385),(26.225,12.555),(26.395,12.555),(26.395,12.385),(26.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.725),(26.225,12.895),(26.395,12.895),(26.395,12.725),(26.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.125),(11.825,16.295),(11.995,16.295),(11.995,16.125),(11.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.465),(11.825,16.635),(11.995,16.635),(11.995,16.465),(11.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.805),(11.825,16.975),(11.995,16.975),(11.995,16.805),(11.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.565),(59.315,38.735),(59.485,38.735),(59.485,38.565),(59.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,38.565),(59.825,38.735),(59.995,38.735),(59.995,38.565),(59.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.545),(30.515,3.715),(30.685,3.715),(30.685,3.545),(30.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.205),(30.515,3.375),(30.685,3.375),(30.685,3.205),(30.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,27.345),(20.405,27.515),(20.575,27.515),(20.575,27.345),(20.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,31.425),(25.715,31.595),(25.885,31.595),(25.885,31.425),(25.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,31.765),(25.715,31.935),(25.885,31.935),(25.885,31.765),(25.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,31.085),(25.715,31.255),(25.885,31.255),(25.885,31.085),(25.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,31.765),(11.315,31.935),(11.485,31.935),(11.485,31.765),(11.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,31.425),(11.315,31.595),(11.485,31.595),(11.485,31.425),(11.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,31.085),(11.315,31.255),(11.485,31.255),(11.485,31.085),(11.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,37.205),(15.605,37.375),(15.775,37.375),(15.775,37.205),(15.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.105),(50.225,32.275),(50.395,32.275),(50.395,32.105),(50.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.445),(50.225,32.615),(50.395,32.615),(50.395,32.445),(50.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.785),(50.225,32.955),(50.395,32.955),(50.395,32.785),(50.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,37.885),(30.005,38.055),(30.175,38.055),(30.175,37.885),(30.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,20.545),(74.225,20.715),(74.395,20.715),(74.395,20.545),(74.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,20.205),(74.225,20.375),(74.395,20.375),(74.395,20.205),(74.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.685),(16.625,10.855),(16.795,10.855),(16.795,10.685),(16.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.045),(30.515,29.215),(30.685,29.215),(30.685,29.045),(30.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.725),(30.515,29.895),(30.685,29.895),(30.685,29.725),(30.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.345),(16.625,10.515),(16.795,10.515),(16.795,10.345),(16.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.005),(16.625,10.175),(16.795,10.175),(16.795,10.005),(16.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.545),(40.115,20.715),(40.285,20.715),(40.285,20.545),(40.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.545),(40.625,20.715),(40.795,20.715),(40.795,20.545),(40.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.245),(45.425,39.415),(45.595,39.415),(45.595,39.245),(45.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.645),(21.425,8.815),(21.595,8.815),(21.595,8.645),(21.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,35.845),(15.605,36.015),(15.775,36.015),(15.775,35.845),(15.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,34.145),(68.405,34.315),(68.575,34.315),(68.575,34.145),(68.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,34.485),(68.405,34.655),(68.575,34.655),(68.575,34.485),(68.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,34.825),(68.405,34.995),(68.575,34.995),(68.575,34.825),(68.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.565),(68.405,4.735),(68.575,4.735),(68.575,4.565),(68.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,23.265),(68.405,23.435),(68.575,23.435),(68.575,23.265),(68.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.265),(35.315,6.435),(35.485,6.435),(35.485,6.265),(35.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.265),(35.825,6.435),(35.995,6.435),(35.995,6.265),(35.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.925),(30.515,6.095),(30.685,6.095),(30.685,5.925),(30.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.385),(11.315,12.555),(11.485,12.555),(11.485,12.385),(11.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.285),(69.425,7.455),(69.595,7.455),(69.595,7.285),(69.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,40.605),(6.515,40.775),(6.685,40.775),(6.685,40.605),(6.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,20.205),(79.025,20.375),(79.195,20.375),(79.195,20.205),(79.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,20.545),(79.025,20.715),(79.195,20.715),(79.195,20.545),(79.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.685),(58.805,27.855),(58.975,27.855),(58.975,27.685),(58.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.245),(45.425,5.415),(45.595,5.415),(45.595,5.245),(45.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,40.265),(21.425,40.435),(21.595,40.435),(21.595,40.265),(21.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.865),(44.915,37.035),(45.085,37.035),(45.085,36.865),(44.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.225),(30.515,21.395),(30.685,21.395),(30.685,21.225),(30.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.565),(30.515,21.735),(30.685,21.735),(30.685,21.565),(30.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,24.285),(82.805,24.455),(82.975,24.455),(82.975,24.285),(82.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,24.625),(82.805,24.795),(82.975,24.795),(82.975,24.625),(82.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.605),(10.805,6.775),(10.975,6.775),(10.975,6.605),(10.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.545),(44.915,3.715),(45.085,3.715),(45.085,3.545),(44.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.885),(83.315,4.055),(83.485,4.055),(83.485,3.885),(83.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.205),(55.025,3.375),(55.195,3.375),(55.195,3.205),(55.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.345),(83.315,10.515),(83.485,10.515),(83.485,10.345),(83.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.325),(45.425,9.495),(45.595,9.495),(45.595,9.325),(45.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.845),(73.205,19.015),(73.375,19.015),(73.375,18.845),(73.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.845),(73.715,19.015),(73.885,19.015),(73.885,18.845),(73.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,24.625),(68.405,24.795),(68.575,24.795),(68.575,24.625),(68.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,27.685),(16.625,27.855),(16.795,27.855),(16.795,27.685),(16.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,27.345),(16.115,27.515),(16.285,27.515),(16.285,27.345),(16.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,28.365),(68.405,28.535),(68.575,28.535),(68.575,28.365),(68.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,28.705),(68.405,28.875),(68.575,28.875),(68.575,28.705),(68.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,28.025),(68.405,28.195),(68.575,28.195),(68.575,28.025),(68.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.665),(7.025,9.835),(7.195,9.835),(7.195,9.665),(7.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,23.945),(83.315,24.115),(83.485,24.115),(83.485,23.945),(83.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,31.425),(10.805,31.595),(10.975,31.595),(10.975,31.425),(10.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.105),(16.115,15.275),(16.285,15.275),(16.285,15.105),(16.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.785),(16.625,15.955),(16.795,15.955),(16.795,15.785),(16.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.945),(55.025,7.115),(55.195,7.115),(55.195,6.945),(55.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.525),(58.805,19.695),(58.975,19.695),(58.975,19.525),(58.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.485),(30.005,17.655),(30.175,17.655),(30.175,17.485),(30.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.445),(7.025,15.615),(7.195,15.615),(7.195,15.445),(7.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.105),(7.025,15.275),(7.195,15.275),(7.195,15.105),(7.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.965),(15.605,8.135),(15.775,8.135),(15.775,7.965),(15.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,20.545),(25.205,20.715),(25.375,20.715),(25.375,20.545),(25.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.205),(78.515,3.375),(78.685,3.375),(78.685,3.205),(78.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.205),(78.005,3.375),(78.175,3.375),(78.175,3.205),(78.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.925),(50.225,23.095),(50.395,23.095),(50.395,22.925),(50.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.225),(44.915,4.395),(45.085,4.395),(45.085,4.225),(44.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.565),(44.915,4.735),(45.085,4.735),(45.085,4.565),(44.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,26.325),(73.715,26.495),(73.885,26.495),(73.885,26.325),(73.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.905),(68.405,5.075),(68.575,5.075),(68.575,4.905),(68.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,26.325),(73.205,26.495),(73.375,26.495),(73.375,26.325),(73.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.005),(69.425,10.175),(69.595,10.175),(69.595,10.005),(69.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.685),(69.425,10.855),(69.595,10.855),(69.595,10.685),(69.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.345),(69.425,10.515),(69.595,10.515),(69.595,10.345),(69.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.885),(21.425,4.055),(21.595,4.055),(21.595,3.885),(21.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,38.225),(79.025,38.395),(79.195,38.395),(79.195,38.225),(79.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.005),(21.425,10.175),(21.595,10.175),(21.595,10.005),(21.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.685),(21.425,10.855),(21.595,10.855),(21.595,10.685),(21.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.925),(7.025,6.095),(7.195,6.095),(7.195,5.925),(7.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,22.925),(25.715,23.095),(25.885,23.095),(25.885,22.925),(25.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.585),(16.625,5.755),(16.795,5.755),(16.795,5.585),(16.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.945),(69.425,7.115),(69.595,7.115),(69.595,6.945),(69.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.565),(64.115,4.735),(64.285,4.735),(64.285,4.565),(64.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.565),(64.625,4.735),(64.795,4.735),(64.795,4.565),(64.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.265),(73.205,6.435),(73.375,6.435),(73.375,6.265),(73.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.265),(73.715,6.435),(73.885,6.435),(73.885,6.265),(73.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.645),(34.805,25.815),(34.975,25.815),(34.975,25.645),(34.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.285),(30.515,7.455),(30.685,7.455),(30.685,7.285),(30.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,23.265),(16.115,23.435),(16.285,23.435),(16.285,23.265),(16.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.385),(74.225,12.555),(74.395,12.555),(74.395,12.385),(74.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.725),(74.225,12.895),(74.395,12.895),(74.395,12.725),(74.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.045),(74.225,12.215),(74.395,12.215),(74.395,12.045),(74.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,36.525),(16.625,36.695),(16.795,36.695),(16.795,36.525),(16.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,36.185),(16.625,36.355),(16.795,36.355),(16.795,36.185),(16.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.965),(21.425,8.135),(21.595,8.135),(21.595,7.965),(21.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,31.425),(6.515,31.595),(6.685,31.595),(6.685,31.425),(6.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.265),(54.005,23.435),(54.175,23.435),(54.175,23.265),(54.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.605),(54.005,23.775),(54.175,23.775),(54.175,23.605),(54.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.145),(25.205,17.315),(25.375,17.315),(25.375,17.145),(25.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.825),(25.205,17.995),(25.375,17.995),(25.375,17.825),(25.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.705),(39.605,28.875),(39.775,28.875),(39.775,28.705),(39.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.025),(39.605,28.195),(39.775,28.195),(39.775,28.025),(39.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.665),(55.025,9.835),(55.195,9.835),(55.195,9.665),(55.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.925),(31.025,6.095),(31.195,6.095),(31.195,5.925),(31.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.325),(55.025,9.495),(55.195,9.495),(55.195,9.325),(55.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.505),(30.005,18.675),(30.175,18.675),(30.175,18.505),(30.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,31.765),(79.025,31.935),(79.195,31.935),(79.195,31.765),(79.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,31.085),(79.025,31.255),(79.195,31.255),(79.195,31.085),(79.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.245),(11.825,5.415),(11.995,5.415),(11.995,5.245),(11.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.645),(45.425,8.815),(45.595,8.815),(45.595,8.645),(45.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.885),(50.225,38.055),(50.395,38.055),(50.395,37.885),(50.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.285),(10.805,7.455),(10.975,7.455),(10.975,7.285),(10.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.565),(16.625,4.735),(16.795,4.735),(16.795,4.565),(16.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.165),(49.205,35.335),(49.375,35.335),(49.375,35.165),(49.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.165),(49.715,35.335),(49.885,35.335),(49.885,35.165),(49.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.505),(49.205,35.675),(49.375,35.675),(49.375,35.505),(49.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.505),(49.715,35.675),(49.885,35.675),(49.885,35.505),(49.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.405),(55.025,13.575),(55.195,13.575),(55.195,13.405),(55.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.205),(73.715,3.375),(73.885,3.375),(73.885,3.205),(73.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.545),(68.405,3.715),(68.575,3.715),(68.575,3.545),(68.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.205),(73.205,3.375),(73.375,3.375),(73.375,3.205),(73.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.865),(58.805,20.035),(58.975,20.035),(58.975,19.865),(58.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.985),(20.405,9.155),(20.575,9.155),(20.575,8.985),(20.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.225),(31.025,21.395),(31.195,21.395),(31.195,21.225),(31.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,39.245),(63.605,39.415),(63.775,39.415),(63.775,39.245),(63.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,23.945),(73.205,24.115),(73.375,24.115),(73.375,23.945),(73.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,23.945),(73.715,24.115),(73.885,24.115),(73.885,23.945),(73.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.785),(11.825,15.955),(11.995,15.955),(11.995,15.785),(11.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,40.265),(68.405,40.435),(68.575,40.435),(68.575,40.265),(68.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.045),(54.005,29.215),(54.175,29.215),(54.175,29.045),(54.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.385),(54.515,29.555),(54.685,29.555),(54.685,29.385),(54.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.725),(54.005,29.895),(54.175,29.895),(54.175,29.725),(54.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,27.685),(7.025,27.855),(7.195,27.855),(7.195,27.685),(7.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.565),(40.115,4.735),(40.285,4.735),(40.285,4.565),(40.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.565),(40.625,4.735),(40.795,4.735),(40.795,4.565),(40.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,23.605),(68.915,23.775),(69.085,23.775),(69.085,23.605),(68.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,38.905),(30.005,39.075),(30.175,39.075),(30.175,38.905),(30.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,27.685),(11.825,27.855),(11.995,27.855),(11.995,27.685),(11.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.545),(34.805,20.715),(34.975,20.715),(34.975,20.545),(34.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,28.025),(26.225,28.195),(26.395,28.195),(26.395,28.025),(26.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,28.705),(26.225,28.875),(26.395,28.875),(26.395,28.705),(26.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,28.365),(26.225,28.535),(26.395,28.535),(26.395,28.365),(26.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,32.785),(10.805,32.955),(10.975,32.955),(10.975,32.785),(10.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.905),(54.515,22.075),(54.685,22.075),(54.685,21.905),(54.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,32.105),(10.805,32.275),(10.975,32.275),(10.975,32.105),(10.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,32.445),(10.805,32.615),(10.975,32.615),(10.975,32.445),(10.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,21.565),(15.605,21.735),(15.775,21.735),(15.775,21.565),(15.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.425),(39.605,31.595),(39.775,31.595),(39.775,31.425),(39.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.225),(39.605,38.395),(39.775,38.395),(39.775,38.225),(39.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,40.605),(73.205,40.775),(73.375,40.775),(73.375,40.605),(73.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,40.605),(73.715,40.775),(73.885,40.775),(73.885,40.605),(73.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.865),(44.405,37.035),(44.575,37.035),(44.575,36.865),(44.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.965),(25.715,8.135),(25.885,8.135),(25.885,7.965),(25.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.245),(54.515,5.415),(54.685,5.415),(54.685,5.245),(54.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.585),(54.005,5.755),(54.175,5.755),(54.175,5.585),(54.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,34.825),(20.915,34.995),(21.085,34.995),(21.085,34.825),(20.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,34.145),(20.915,34.315),(21.085,34.315),(21.085,34.145),(20.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,34.485),(20.915,34.655),(21.085,34.655),(21.085,34.485),(20.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.425),(78.515,14.595),(78.685,14.595),(78.685,14.425),(78.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.425),(78.005,14.595),(78.175,14.595),(78.175,14.425),(78.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,24.625),(64.115,24.795),(64.285,24.795),(64.285,24.625),(64.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,24.625),(64.625,24.795),(64.795,24.795),(64.795,24.625),(64.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.045),(55.025,12.215),(55.195,12.215),(55.195,12.045),(55.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.725),(55.025,12.895),(55.195,12.895),(55.195,12.725),(55.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.545),(30.515,37.715),(30.685,37.715),(30.685,37.545),(30.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.085),(7.025,14.255),(7.195,14.255),(7.195,14.085),(7.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.765),(7.025,14.935),(7.195,14.935),(7.195,14.765),(7.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.585),(35.315,39.755),(35.485,39.755),(35.485,39.585),(35.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.585),(35.825,39.755),(35.995,39.755),(35.995,39.585),(35.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.885),(69.425,4.055),(69.595,4.055),(69.595,3.885),(69.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,2.865),(6.515,3.035),(6.685,3.035),(6.685,2.865),(6.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.005),(40.115,27.175),(40.285,27.175),(40.285,27.005),(40.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.005),(40.625,27.175),(40.795,27.175),(40.795,27.005),(40.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.345),(40.115,27.515),(40.285,27.515),(40.285,27.345),(40.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.345),(40.625,27.515),(40.795,27.515),(40.795,27.345),(40.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,21.565),(82.805,21.735),(82.975,21.735),(82.975,21.565),(82.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.585),(83.315,5.755),(83.485,5.755),(83.485,5.585),(83.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.245),(83.315,5.415),(83.485,5.415),(83.485,5.245),(83.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.785),(10.805,15.955),(10.975,15.955),(10.975,15.785),(10.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.445),(10.805,15.615),(10.975,15.615),(10.975,15.445),(10.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.245),(30.005,5.415),(30.175,5.415),(30.175,5.245),(30.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.725),(20.405,12.895),(20.575,12.895),(20.575,12.725),(20.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.385),(20.405,12.555),(20.575,12.555),(20.575,12.385),(20.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.045),(20.405,12.215),(20.575,12.215),(20.575,12.045),(20.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.285),(35.315,7.455),(35.485,7.455),(35.485,7.285),(35.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.285),(35.825,7.455),(35.995,7.455),(35.995,7.285),(35.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.905),(40.115,5.075),(40.285,5.075),(40.285,4.905),(40.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.905),(40.625,5.075),(40.795,5.075),(40.795,4.905),(40.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.965),(69.425,8.135),(69.595,8.135),(69.595,7.965),(69.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.125),(54.515,33.295),(54.685,33.295),(54.685,33.125),(54.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.805),(54.515,33.975),(54.685,33.975),(54.685,33.805),(54.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.465),(54.515,33.635),(54.685,33.635),(54.685,33.465),(54.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.605),(58.805,23.775),(58.975,23.775),(58.975,23.605),(58.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.685),(59.315,10.855),(59.485,10.855),(59.485,10.685),(59.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.685),(59.825,10.855),(59.995,10.855),(59.995,10.685),(59.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.005),(59.315,10.175),(59.485,10.175),(59.485,10.005),(59.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.005),(59.825,10.175),(59.995,10.175),(59.995,10.005),(59.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.345),(59.315,10.515),(59.485,10.515),(59.485,10.345),(59.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.345),(59.825,10.515),(59.995,10.515),(59.995,10.345),(59.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,23.945),(15.605,24.115),(15.775,24.115),(15.775,23.945),(15.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.765),(30.515,14.935),(30.685,14.935),(30.685,14.765),(30.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,39.245),(16.625,39.415),(16.795,39.415),(16.795,39.245),(16.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.085),(30.515,14.255),(30.685,14.255),(30.685,14.085),(30.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.625),(44.405,24.795),(44.575,24.795),(44.575,24.625),(44.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.525),(55.025,19.695),(55.195,19.695),(55.195,19.525),(55.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.605),(49.205,23.775),(49.375,23.775),(49.375,23.605),(49.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.605),(49.715,23.775),(49.885,23.775),(49.885,23.605),(49.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.785),(15.605,15.955),(15.775,15.955),(15.775,15.785),(15.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.165),(7.025,18.335),(7.195,18.335),(7.195,18.165),(7.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.505),(7.025,18.675),(7.195,18.675),(7.195,18.505),(7.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.365),(44.405,28.535),(44.575,28.535),(44.575,28.365),(44.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,37.545),(7.025,37.715),(7.195,37.715),(7.195,37.545),(7.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.585),(68.915,5.755),(69.085,5.755),(69.085,5.585),(68.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.245),(68.915,5.415),(69.085,5.415),(69.085,5.245),(68.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,37.545),(82.805,37.715),(82.975,37.715),(82.975,37.545),(82.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,22.245),(7.025,22.415),(7.195,22.415),(7.195,22.245),(7.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,22.585),(7.025,22.755),(7.195,22.755),(7.195,22.585),(7.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,20.545),(64.115,20.715),(64.285,20.715),(64.285,20.545),(64.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,20.545),(64.625,20.715),(64.795,20.715),(64.795,20.545),(64.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.625),(35.315,24.795),(35.485,24.795),(35.485,24.625),(35.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.625),(35.825,24.795),(35.995,24.795),(35.995,24.625),(35.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.505),(11.825,18.675),(11.995,18.675),(11.995,18.505),(11.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,38.225),(26.225,38.395),(26.395,38.395),(26.395,38.225),(26.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,34.145),(68.915,34.315),(69.085,34.315),(69.085,34.145),(68.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,34.485),(68.915,34.655),(69.085,34.655),(69.085,34.485),(68.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,34.825),(68.915,34.995),(69.085,34.995),(69.085,34.825),(68.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.785),(54.515,15.955),(54.685,15.955),(54.685,15.785),(54.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,38.225),(68.915,38.395),(69.085,38.395),(69.085,38.225),(68.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,24.625),(63.605,24.795),(63.775,24.795),(63.775,24.625),(63.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.525),(16.115,19.695),(16.285,19.695),(16.285,19.525),(16.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,34.485),(82.805,34.655),(82.975,34.655),(82.975,34.485),(82.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,34.825),(82.805,34.995),(82.975,34.995),(82.975,34.825),(82.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,34.145),(82.805,34.315),(82.975,34.315),(82.975,34.145),(82.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.085),(68.405,14.255),(68.575,14.255),(68.575,14.085),(68.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.765),(68.405,14.935),(68.575,14.935),(68.575,14.765),(68.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.205),(31.025,20.375),(31.195,20.375),(31.195,20.205),(31.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,23.605),(69.425,23.775),(69.595,23.775),(69.595,23.605),(69.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,28.365),(63.605,28.535),(63.775,28.535),(63.775,28.365),(63.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,26.665),(21.425,26.835),(21.595,26.835),(21.595,26.665),(21.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,37.885),(68.915,38.055),(69.085,38.055),(69.085,37.885),(68.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.425),(11.315,14.595),(11.485,14.595),(11.485,14.425),(11.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.765),(11.315,14.935),(11.485,14.935),(11.485,14.765),(11.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.765),(11.825,14.935),(11.995,14.935),(11.995,14.765),(11.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.085),(11.315,14.255),(11.485,14.255),(11.485,14.085),(11.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.085),(11.825,14.255),(11.995,14.255),(11.995,14.085),(11.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.025),(73.205,11.195),(73.375,11.195),(73.375,11.025),(73.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,28.705),(16.625,28.875),(16.795,28.875),(16.795,28.705),(16.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,28.025),(16.625,28.195),(16.795,28.195),(16.795,28.025),(16.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,26.325),(26.225,26.495),(26.395,26.495),(26.395,26.325),(26.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,38.565),(11.315,38.735),(11.485,38.735),(11.485,38.565),(11.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,30.065),(21.425,30.235),(21.595,30.235),(21.595,30.065),(21.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,30.405),(21.425,30.575),(21.595,30.575),(21.595,30.405),(21.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,30.745),(21.425,30.915),(21.595,30.915),(21.595,30.745),(21.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,37.545),(20.405,37.715),(20.575,37.715),(20.575,37.545),(20.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.465),(69.425,16.635),(69.595,16.635),(69.595,16.465),(69.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,24.285),(7.025,24.455),(7.195,24.455),(7.195,24.285),(7.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.905),(58.805,22.075),(58.975,22.075),(58.975,21.905),(58.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.625),(49.205,24.795),(49.375,24.795),(49.375,24.625),(49.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.625),(49.715,24.795),(49.885,24.795),(49.885,24.625),(49.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,26.665),(54.515,26.835),(54.685,26.835),(54.685,26.665),(54.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,26.325),(54.515,26.495),(54.685,26.495),(54.685,26.325),(54.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,36.865),(68.915,37.035),(69.085,37.035),(69.085,36.865),(68.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.685),(44.405,27.855),(44.575,27.855),(44.575,27.685),(44.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,20.545),(15.605,20.715),(15.775,20.715),(15.775,20.545),(15.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,40.605),(50.225,40.775),(50.395,40.775),(50.395,40.605),(50.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.245),(25.205,5.415),(25.375,5.415),(25.375,5.245),(25.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.585),(25.205,5.755),(25.375,5.755),(25.375,5.585),(25.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.245),(58.805,5.415),(58.975,5.415),(58.975,5.245),(58.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.245),(34.805,5.415),(34.975,5.415),(34.975,5.245),(34.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.585),(34.805,5.755),(34.975,5.755),(34.975,5.585),(34.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,31.425),(73.205,31.595),(73.375,31.595),(73.375,31.425),(73.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,31.425),(73.715,31.595),(73.885,31.595),(73.885,31.425),(73.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.985),(44.405,9.155),(44.575,9.155),(44.575,8.985),(44.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,29.385),(10.805,29.555),(10.975,29.555),(10.975,29.385),(10.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,29.045),(10.805,29.215),(10.975,29.215),(10.975,29.045),(10.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,29.725),(10.805,29.895),(10.975,29.895),(10.975,29.725),(10.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,39.585),(64.115,39.755),(64.285,39.755),(64.285,39.585),(64.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,39.585),(64.625,39.755),(64.795,39.755),(64.795,39.585),(64.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.045),(55.025,29.215),(55.195,29.215),(55.195,29.045),(55.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.725),(55.025,29.895),(55.195,29.895),(55.195,29.725),(55.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,25.305),(78.005,25.475),(78.175,25.475),(78.175,25.305),(78.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,25.305),(78.515,25.475),(78.685,25.475),(78.685,25.305),(78.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,37.885),(25.715,38.055),(25.885,38.055),(25.885,37.885),(25.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,39.245),(21.425,39.415),(21.595,39.415),(21.595,39.245),(21.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.985),(35.315,9.155),(35.485,9.155),(35.485,8.985),(35.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.985),(35.825,9.155),(35.995,9.155),(35.995,8.985),(35.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.445),(39.605,15.615),(39.775,15.615),(39.775,15.445),(39.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.625),(30.515,24.795),(30.685,24.795),(30.685,24.625),(30.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,39.245),(25.715,39.415),(25.885,39.415),(25.885,39.245),(25.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.485),(44.405,17.655),(44.575,17.655),(44.575,17.485),(44.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.545),(30.515,20.715),(30.685,20.715),(30.685,20.545),(30.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.025),(20.405,11.195),(20.575,11.195),(20.575,11.025),(20.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.365),(20.405,11.535),(20.575,11.535),(20.575,11.365),(20.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.705),(20.405,11.875),(20.575,11.875),(20.575,11.705),(20.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.445),(25.205,15.615),(25.375,15.615),(25.375,15.445),(25.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.785),(25.205,15.955),(25.375,15.955),(25.375,15.785),(25.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.105),(25.205,15.275),(25.375,15.275),(25.375,15.105),(25.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.385),(34.805,12.555),(34.975,12.555),(34.975,12.385),(34.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.725),(34.805,12.895),(34.975,12.895),(34.975,12.725),(34.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.045),(34.805,12.215),(34.975,12.215),(34.975,12.045),(34.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.725),(54.515,12.895),(54.685,12.895),(54.685,12.725),(54.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.385),(54.005,12.555),(54.175,12.555),(54.175,12.385),(54.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.045),(54.515,12.215),(54.685,12.215),(54.685,12.045),(54.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.905),(35.315,5.075),(35.485,5.075),(35.485,4.905),(35.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.905),(35.825,5.075),(35.995,5.075),(35.995,4.905),(35.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.085),(31.025,31.255),(31.195,31.255),(31.195,31.085),(31.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.765),(31.025,31.935),(31.195,31.935),(31.195,31.765),(31.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.125),(74.225,16.295),(74.395,16.295),(74.395,16.125),(74.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.805),(74.225,16.975),(74.395,16.975),(74.395,16.805),(74.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.465),(74.225,16.635),(74.395,16.635),(74.395,16.465),(74.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,38.565),(15.605,38.735),(15.775,38.735),(15.775,38.565),(15.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.685),(10.805,10.855),(10.975,10.855),(10.975,10.685),(10.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.005),(10.805,10.175),(10.975,10.175),(10.975,10.005),(10.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.345),(10.805,10.515),(10.975,10.515),(10.975,10.345),(10.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.745),(39.605,30.915),(39.775,30.915),(39.775,30.745),(39.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.065),(39.605,30.235),(39.775,30.235),(39.775,30.065),(39.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.405),(39.605,30.575),(39.775,30.575),(39.775,30.405),(39.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.365),(55.025,11.535),(55.195,11.535),(55.195,11.365),(55.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.005),(20.915,10.175),(21.085,10.175),(21.085,10.005),(20.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.345),(20.915,10.515),(21.085,10.515),(21.085,10.345),(20.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.685),(20.915,10.855),(21.085,10.855),(21.085,10.685),(20.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,30.065),(79.025,30.235),(79.195,30.235),(79.195,30.065),(79.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,30.405),(79.025,30.575),(79.195,30.575),(79.195,30.405),(79.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,30.745),(79.025,30.915),(79.195,30.915),(79.195,30.745),(79.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.925),(63.605,6.095),(63.775,6.095),(63.775,5.925),(63.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,38.225),(7.025,38.395),(7.195,38.395),(7.195,38.225),(7.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.785),(34.805,15.955),(34.975,15.955),(34.975,15.785),(34.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,38.565),(83.315,38.735),(83.485,38.735),(83.485,38.565),(83.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.365),(55.025,28.535),(55.195,28.535),(55.195,28.365),(55.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.265),(39.605,23.435),(39.775,23.435),(39.775,23.265),(39.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.605),(39.605,23.775),(39.775,23.775),(39.775,23.605),(39.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,25.645),(82.805,25.815),(82.975,25.815),(82.975,25.645),(82.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.145),(45.425,17.315),(45.595,17.315),(45.595,17.145),(45.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.825),(45.425,17.995),(45.595,17.995),(45.595,17.825),(45.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,39.925),(64.115,40.095),(64.285,40.095),(64.285,39.925),(64.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,39.925),(64.625,40.095),(64.795,40.095),(64.795,39.925),(64.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.545),(82.805,3.715),(82.975,3.715),(82.975,3.545),(82.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.165),(34.805,35.335),(34.975,35.335),(34.975,35.165),(34.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.505),(34.805,35.675),(34.975,35.675),(34.975,35.505),(34.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,23.945),(30.005,24.115),(30.175,24.115),(30.175,23.945),(30.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,31.765),(15.605,31.935),(15.775,31.935),(15.775,31.765),(15.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,31.425),(15.605,31.595),(15.775,31.595),(15.775,31.425),(15.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,31.085),(15.605,31.255),(15.775,31.255),(15.775,31.085),(15.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.385),(44.405,12.555),(44.575,12.555),(44.575,12.385),(44.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,39.245),(69.425,39.415),(69.595,39.415),(69.595,39.245),(69.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,21.565),(7.025,21.735),(7.195,21.735),(7.195,21.565),(7.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,21.225),(7.025,21.395),(7.195,21.395),(7.195,21.225),(7.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.265),(7.025,6.435),(7.195,6.435),(7.195,6.265),(7.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.605),(7.025,6.775),(7.195,6.775),(7.195,6.605),(7.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,36.525),(25.205,36.695),(25.375,36.695),(25.375,36.525),(25.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,36.185),(25.205,36.355),(25.375,36.355),(25.375,36.185),(25.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,22.925),(73.205,23.095),(73.375,23.095),(73.375,22.925),(73.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,22.925),(73.715,23.095),(73.885,23.095),(73.885,22.925),(73.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.865),(30.005,20.035),(30.175,20.035),(30.175,19.865),(30.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.405),(40.115,30.575),(40.285,30.575),(40.285,30.405),(40.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.405),(40.625,30.575),(40.795,30.575),(40.795,30.405),(40.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,21.225),(20.405,21.395),(20.575,21.395),(20.575,21.225),(20.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,21.565),(20.405,21.735),(20.575,21.735),(20.575,21.565),(20.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.725),(35.315,29.895),(35.485,29.895),(35.485,29.725),(35.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.725),(35.825,29.895),(35.995,29.895),(35.995,29.725),(35.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.045),(35.315,29.215),(35.485,29.215),(35.485,29.045),(35.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.045),(35.825,29.215),(35.995,29.215),(35.995,29.045),(35.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.185),(55.025,36.355),(55.195,36.355),(55.195,36.185),(55.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.525),(55.025,36.695),(55.195,36.695),(55.195,36.525),(55.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.965),(35.315,8.135),(35.485,8.135),(35.485,7.965),(35.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.965),(35.825,8.135),(35.995,8.135),(35.995,7.965),(35.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.065),(69.425,13.235),(69.595,13.235),(69.595,13.065),(69.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.745),(69.425,13.915),(69.595,13.915),(69.595,13.745),(69.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,25.645),(11.825,25.815),(11.995,25.815),(11.995,25.645),(11.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.565),(25.715,4.735),(25.885,4.735),(25.885,4.565),(25.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,24.285),(16.115,24.455),(16.285,24.455),(16.285,24.285),(16.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.065),(21.425,13.235),(21.595,13.235),(21.595,13.065),(21.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.745),(21.425,13.915),(21.595,13.915),(21.595,13.745),(21.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.405),(21.425,13.575),(21.595,13.575),(21.595,13.405),(21.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.945),(11.315,7.115),(11.485,7.115),(11.485,6.945),(11.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,30.405),(73.715,30.575),(73.885,30.575),(73.885,30.405),(73.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,30.405),(73.205,30.575),(73.375,30.575),(73.375,30.405),(73.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.945),(11.825,7.115),(11.995,7.115),(11.995,6.945),(11.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,40.605),(79.025,40.775),(79.195,40.775),(79.195,40.605),(79.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,39.925),(83.315,40.095),(83.485,40.095),(83.485,39.925),(83.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.985),(30.005,9.155),(30.175,9.155),(30.175,8.985),(30.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.925),(44.915,23.095),(45.085,23.095),(45.085,22.925),(44.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.585),(40.625,22.755),(40.795,22.755),(40.795,22.585),(40.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.585),(40.115,22.755),(40.285,22.755),(40.285,22.585),(40.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.725),(63.605,12.895),(63.775,12.895),(63.775,12.725),(63.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.045),(63.605,12.215),(63.775,12.215),(63.775,12.045),(63.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.885),(82.805,4.055),(82.975,4.055),(82.975,3.885),(82.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.025),(44.405,11.195),(44.575,11.195),(44.575,11.025),(44.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.705),(44.405,11.875),(44.575,11.875),(44.575,11.705),(44.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.525),(21.425,19.695),(21.595,19.695),(21.595,19.525),(21.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.005),(54.005,27.175),(54.175,27.175),(54.175,27.005),(54.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.345),(54.005,27.515),(54.175,27.515),(54.175,27.345),(54.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,20.885),(74.225,21.055),(74.395,21.055),(74.395,20.885),(74.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,26.665),(69.425,26.835),(69.595,26.835),(69.595,26.665),(69.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.445),(73.205,15.615),(73.375,15.615),(73.375,15.445),(73.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.445),(73.715,15.615),(73.885,15.615),(73.885,15.445),(73.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,40.605),(30.005,40.775),(30.175,40.775),(30.175,40.605),(30.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.605),(35.825,23.775),(35.995,23.775),(35.995,23.605),(35.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.385),(49.205,29.555),(49.375,29.555),(49.375,29.385),(49.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.265),(35.315,23.435),(35.485,23.435),(35.485,23.265),(35.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.265),(35.825,23.435),(35.995,23.435),(35.995,23.265),(35.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.385),(49.715,29.555),(49.885,29.555),(49.885,29.385),(49.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,39.925),(11.315,40.095),(11.485,40.095),(11.485,39.925),(11.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.605),(35.315,23.775),(35.485,23.775),(35.485,23.605),(35.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.185),(54.005,36.355),(54.175,36.355),(54.175,36.185),(54.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.525),(54.005,36.695),(54.175,36.695),(54.175,36.525),(54.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,39.925),(63.605,40.095),(63.775,40.095),(63.775,39.925),(63.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,31.085),(69.425,31.255),(69.595,31.255),(69.595,31.085),(69.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,31.765),(69.425,31.935),(69.595,31.935),(69.595,31.765),(69.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.405),(50.225,30.575),(50.395,30.575),(50.395,30.405),(50.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,30.065),(69.425,30.235),(69.595,30.235),(69.595,30.065),(69.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,30.745),(69.425,30.915),(69.595,30.915),(69.595,30.745),(69.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,35.165),(30.005,35.335),(30.175,35.335),(30.175,35.165),(30.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,35.505),(30.005,35.675),(30.175,35.675),(30.175,35.505),(30.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,21.905),(21.425,22.075),(21.595,22.075),(21.595,21.905),(21.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.945),(35.825,7.115),(35.995,7.115),(35.995,6.945),(35.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.745),(31.025,30.915),(31.195,30.915),(31.195,30.745),(31.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.065),(31.025,30.235),(31.195,30.235),(31.195,30.065),(31.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,20.205),(16.115,20.375),(16.285,20.375),(16.285,20.205),(16.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,23.265),(11.315,23.435),(11.485,23.435),(11.485,23.265),(11.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,20.885),(79.025,21.055),(79.195,21.055),(79.195,20.885),(79.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,2.865),(20.915,3.035),(21.085,3.035),(21.085,2.865),(20.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.025),(68.915,11.195),(69.085,11.195),(69.085,11.025),(68.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.705),(68.915,11.875),(69.085,11.875),(69.085,11.705),(68.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.905),(25.715,5.075),(25.885,5.075),(25.885,4.905),(25.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.185),(44.915,36.355),(45.085,36.355),(45.085,36.185),(44.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.525),(44.915,36.695),(45.085,36.695),(45.085,36.525),(44.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,35.165),(25.205,35.335),(25.375,35.335),(25.375,35.165),(25.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,24.965),(82.805,25.135),(82.975,25.135),(82.975,24.965),(82.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,40.265),(20.915,40.435),(21.085,40.435),(21.085,40.265),(20.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,35.505),(25.205,35.675),(25.375,35.675),(25.375,35.505),(25.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.705),(20.915,11.875),(21.085,11.875),(21.085,11.705),(20.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.025),(20.915,11.195),(21.085,11.195),(21.085,11.025),(20.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.505),(31.025,35.675),(31.195,35.675),(31.195,35.505),(31.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.165),(31.025,35.335),(31.195,35.335),(31.195,35.165),(31.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.865),(59.825,20.035),(59.995,20.035),(59.995,19.865),(59.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.865),(59.315,20.035),(59.485,20.035),(59.485,19.865),(59.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,35.845),(78.005,36.015),(78.175,36.015),(78.175,35.845),(78.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,35.845),(78.515,36.015),(78.685,36.015),(78.685,35.845),(78.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,27.005),(26.225,27.175),(26.395,27.175),(26.395,27.005),(26.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,27.345),(26.225,27.515),(26.395,27.515),(26.395,27.345),(26.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.465),(10.805,16.635),(10.975,16.635),(10.975,16.465),(10.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.985),(68.915,9.155),(69.085,9.155),(69.085,8.985),(68.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.925),(30.515,40.095),(30.685,40.095),(30.685,39.925),(30.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,24.285),(26.225,24.455),(26.395,24.455),(26.395,24.285),(26.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,24.625),(26.225,24.795),(26.395,24.795),(26.395,24.625),(26.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.565),(30.515,4.735),(30.685,4.735),(30.685,4.565),(30.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.885),(54.515,38.055),(54.685,38.055),(54.685,37.885),(54.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,21.905),(68.405,22.075),(68.575,22.075),(68.575,21.905),(68.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.365),(54.515,28.535),(54.685,28.535),(54.685,28.365),(54.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.705),(54.005,28.875),(54.175,28.875),(54.175,28.705),(54.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.025),(54.005,28.195),(54.175,28.195),(54.175,28.025),(54.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,35.845),(7.025,36.015),(7.195,36.015),(7.195,35.845),(7.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,2.865),(16.115,3.035),(16.285,3.035),(16.285,2.865),(16.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.925),(54.005,40.095),(54.175,40.095),(54.175,39.925),(54.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.625),(82.805,7.795),(82.975,7.795),(82.975,7.625),(82.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,38.905),(79.025,39.075),(79.195,39.075),(79.195,38.905),(79.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.625),(54.515,24.795),(54.685,24.795),(54.685,24.625),(54.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.285),(54.515,24.455),(54.685,24.455),(54.685,24.285),(54.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,31.425),(20.405,31.595),(20.575,31.595),(20.575,31.425),(20.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,31.765),(20.405,31.935),(20.575,31.935),(20.575,31.765),(20.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,31.085),(20.405,31.255),(20.575,31.255),(20.575,31.085),(20.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,40.265),(78.005,40.435),(78.175,40.435),(78.175,40.265),(78.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,40.265),(78.515,40.435),(78.685,40.435),(78.685,40.265),(78.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.245),(7.025,5.415),(7.195,5.415),(7.195,5.245),(7.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.585),(7.025,5.755),(7.195,5.755),(7.195,5.585),(7.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,38.565),(16.625,38.735),(16.795,38.735),(16.795,38.565),(16.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,37.885),(26.225,38.055),(26.395,38.055),(26.395,37.885),(26.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,40.605),(64.115,40.775),(64.285,40.775),(64.285,40.605),(64.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,40.605),(64.625,40.775),(64.795,40.775),(64.795,40.605),(64.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.685),(49.205,10.855),(49.375,10.855),(49.375,10.685),(49.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.005),(49.205,10.175),(49.375,10.175),(49.375,10.005),(49.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.005),(49.715,10.175),(49.885,10.175),(49.885,10.005),(49.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.685),(49.715,10.855),(49.885,10.855),(49.885,10.685),(49.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.265),(74.225,6.435),(74.395,6.435),(74.395,6.265),(74.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.605),(74.225,6.775),(74.395,6.775),(74.395,6.605),(74.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,25.985),(83.315,26.155),(83.485,26.155),(83.485,25.985),(83.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.165),(39.605,18.335),(39.775,18.335),(39.775,18.165),(39.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.945),(73.715,7.115),(73.885,7.115),(73.885,6.945),(73.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.945),(73.205,7.115),(73.375,7.115),(73.375,6.945),(73.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,36.865),(16.625,37.035),(16.795,37.035),(16.795,36.865),(16.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.765),(55.025,31.935),(55.195,31.935),(55.195,31.765),(55.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.085),(55.025,31.255),(55.195,31.255),(55.195,31.085),(55.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.865),(40.115,3.035),(40.285,3.035),(40.285,2.865),(40.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.865),(40.625,3.035),(40.795,3.035),(40.795,2.865),(40.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.325),(20.915,9.495),(21.085,9.495),(21.085,9.325),(20.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.265),(16.115,6.435),(16.285,6.435),(16.285,6.265),(16.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.605),(16.115,6.775),(16.285,6.775),(16.285,6.605),(16.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.645),(64.625,8.815),(64.795,8.815),(64.795,8.645),(64.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.305),(64.625,8.475),(64.795,8.475),(64.795,8.305),(64.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.645),(64.115,8.815),(64.285,8.815),(64.285,8.645),(64.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.305),(64.115,8.475),(64.285,8.475),(64.285,8.305),(64.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.245),(31.025,5.415),(31.195,5.415),(31.195,5.245),(31.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.585),(31.025,5.755),(31.195,5.755),(31.195,5.585),(31.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.145),(74.225,17.315),(74.395,17.315),(74.395,17.145),(74.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,26.325),(45.425,26.495),(45.595,26.495),(45.595,26.325),(45.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.825),(74.225,17.995),(74.395,17.995),(74.395,17.825),(74.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.965),(74.225,8.135),(74.395,8.135),(74.395,7.965),(74.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.625),(34.805,7.795),(34.975,7.795),(34.975,7.625),(34.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,30.405),(30.005,30.575),(30.175,30.575),(30.175,30.405),(30.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.905),(55.025,22.075),(55.195,22.075),(55.195,21.905),(55.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,40.265),(15.605,40.435),(15.775,40.435),(15.775,40.265),(15.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.925),(44.405,6.095),(44.575,6.095),(44.575,5.925),(44.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.425),(73.205,14.595),(73.375,14.595),(73.375,14.425),(73.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.425),(73.715,14.595),(73.885,14.595),(73.885,14.425),(73.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.405),(45.425,30.575),(45.595,30.575),(45.595,30.405),(45.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,33.805),(26.225,33.975),(26.395,33.975),(26.395,33.805),(26.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,33.125),(26.225,33.295),(26.395,33.295),(26.395,33.125),(26.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,33.465),(26.225,33.635),(26.395,33.635),(26.395,33.465),(26.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,40.265),(16.625,40.435),(16.795,40.435),(16.795,40.265),(16.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,26.665),(30.005,26.835),(30.175,26.835),(30.175,26.665),(30.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.925),(44.405,23.095),(44.575,23.095),(44.575,22.925),(44.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.905),(30.515,5.075),(30.685,5.075),(30.685,4.905),(30.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.865),(58.805,3.035),(58.975,3.035),(58.975,2.865),(58.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,25.645),(63.605,25.815),(63.775,25.815),(63.775,25.645),(63.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.745),(45.425,13.915),(45.595,13.915),(45.595,13.745),(45.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.065),(45.425,13.235),(45.595,13.235),(45.595,13.065),(45.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.365),(35.315,28.535),(35.485,28.535),(35.485,28.365),(35.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.365),(35.825,28.535),(35.995,28.535),(35.995,28.365),(35.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,22.245),(11.825,22.415),(11.995,22.415),(11.995,22.245),(11.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,22.925),(74.225,23.095),(74.395,23.095),(74.395,22.925),(74.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.225),(78.005,4.395),(78.175,4.395),(78.175,4.225),(78.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.225),(78.515,4.395),(78.685,4.395),(78.685,4.225),(78.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.305),(16.625,8.475),(16.795,8.475),(16.795,8.305),(16.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.645),(16.625,8.815),(16.795,8.815),(16.795,8.645),(16.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,30.065),(74.225,30.235),(74.395,30.235),(74.395,30.065),(74.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,30.405),(74.225,30.575),(74.395,30.575),(74.395,30.405),(74.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,30.745),(74.225,30.915),(74.395,30.915),(74.395,30.745),(74.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,2.865),(64.115,3.035),(64.285,3.035),(64.285,2.865),(64.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,2.865),(64.625,3.035),(64.795,3.035),(64.795,2.865),(64.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.465),(16.625,16.635),(16.795,16.635),(16.795,16.465),(16.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,28.025),(10.805,28.195),(10.975,28.195),(10.975,28.025),(10.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,28.705),(10.805,28.875),(10.975,28.875),(10.975,28.705),(10.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.465),(59.825,16.635),(59.995,16.635),(59.995,16.465),(59.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.465),(59.315,16.635),(59.485,16.635),(59.485,16.465),(59.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,38.225),(64.115,38.395),(64.285,38.395),(64.285,38.225),(64.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,38.225),(64.625,38.395),(64.795,38.395),(64.795,38.225),(64.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.645),(49.205,25.815),(49.375,25.815),(49.375,25.645),(49.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.645),(49.715,25.815),(49.885,25.815),(49.885,25.645),(49.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.185),(45.425,36.355),(45.595,36.355),(45.595,36.185),(45.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.525),(45.425,36.695),(45.595,36.695),(45.595,36.525),(45.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.905),(39.605,39.075),(39.775,39.075),(39.775,38.905),(39.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.185),(11.825,19.355),(11.995,19.355),(11.995,19.185),(11.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.525),(11.315,19.695),(11.485,19.695),(11.485,19.525),(11.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.525),(11.825,19.695),(11.995,19.695),(11.995,19.525),(11.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.905),(82.805,5.075),(82.975,5.075),(82.975,4.905),(82.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,25.985),(21.425,26.155),(21.595,26.155),(21.595,25.985),(21.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,34.825),(25.715,34.995),(25.885,34.995),(25.885,34.825),(25.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,34.145),(25.715,34.315),(25.885,34.315),(25.885,34.145),(25.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,34.485),(25.715,34.655),(25.885,34.655),(25.885,34.485),(25.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.745),(49.205,13.915),(49.375,13.915),(49.375,13.745),(49.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.065),(49.205,13.235),(49.375,13.235),(49.375,13.065),(49.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.745),(49.715,13.915),(49.885,13.915),(49.885,13.745),(49.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.365),(49.205,28.535),(49.375,28.535),(49.375,28.365),(49.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.365),(49.715,28.535),(49.885,28.535),(49.885,28.365),(49.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.705),(49.205,28.875),(49.375,28.875),(49.375,28.705),(49.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.705),(49.715,28.875),(49.885,28.875),(49.885,28.705),(49.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.025),(49.205,28.195),(49.375,28.195),(49.375,28.025),(49.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.025),(49.715,28.195),(49.885,28.195),(49.885,28.025),(49.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.565),(39.605,21.735),(39.775,21.735),(39.775,21.565),(39.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.985),(50.225,26.155),(50.395,26.155),(50.395,25.985),(50.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,39.585),(11.825,39.755),(11.995,39.755),(11.995,39.585),(11.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,39.925),(25.715,40.095),(25.885,40.095),(25.885,39.925),(25.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.385),(45.425,12.555),(45.595,12.555),(45.595,12.385),(45.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.565),(7.025,4.735),(7.195,4.735),(7.195,4.565),(7.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.225),(7.025,4.395),(7.195,4.395),(7.195,4.225),(7.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,27.345),(21.425,27.515),(21.595,27.515),(21.595,27.345),(21.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,28.025),(6.515,28.195),(6.685,28.195),(6.685,28.025),(6.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,28.705),(6.515,28.875),(6.685,28.875),(6.685,28.705),(6.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.065),(16.115,13.235),(16.285,13.235),(16.285,13.065),(16.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.745),(16.115,13.915),(16.285,13.915),(16.285,13.745),(16.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.405),(16.115,13.575),(16.285,13.575),(16.285,13.405),(16.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.785),(45.425,15.955),(45.595,15.955),(45.595,15.785),(45.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.485),(15.605,17.655),(15.775,17.655),(15.775,17.485),(15.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,27.685),(20.915,27.855),(21.085,27.855),(21.085,27.685),(20.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.065),(59.315,13.235),(59.485,13.235),(59.485,13.065),(59.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.065),(59.825,13.235),(59.995,13.235),(59.995,13.065),(59.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.405),(59.315,13.575),(59.485,13.575),(59.485,13.405),(59.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.405),(59.825,13.575),(59.995,13.575),(59.995,13.405),(59.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.745),(59.315,13.915),(59.485,13.915),(59.485,13.745),(59.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.325),(44.915,9.495),(45.085,9.495),(45.085,9.325),(44.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.745),(59.825,13.915),(59.995,13.915),(59.995,13.745),(59.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.325),(68.915,9.495),(69.085,9.495),(69.085,9.325),(68.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.665),(68.915,9.835),(69.085,9.835),(69.085,9.665),(68.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.845),(7.025,19.015),(7.195,19.015),(7.195,18.845),(7.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,27.685),(78.005,27.855),(78.175,27.855),(78.175,27.685),(78.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,27.685),(78.515,27.855),(78.685,27.855),(78.685,27.685),(78.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.705),(82.805,11.875),(82.975,11.875),(82.975,11.705),(82.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.025),(82.805,11.195),(82.975,11.195),(82.975,11.025),(82.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.925),(68.915,6.095),(69.085,6.095),(69.085,5.925),(68.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.945),(39.605,24.115),(39.775,24.115),(39.775,23.945),(39.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.305),(54.515,25.475),(54.685,25.475),(54.685,25.305),(54.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.645),(54.005,25.815),(54.175,25.815),(54.175,25.645),(54.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,30.405),(16.625,30.575),(16.795,30.575),(16.795,30.405),(16.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.405),(82.805,13.575),(82.975,13.575),(82.975,13.405),(82.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.425),(58.805,31.595),(58.975,31.595),(58.975,31.425),(58.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.765),(58.805,31.935),(58.975,31.935),(58.975,31.765),(58.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.085),(58.805,31.255),(58.975,31.255),(58.975,31.085),(58.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.685),(49.205,27.855),(49.375,27.855),(49.375,27.685),(49.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.685),(49.715,27.855),(49.885,27.855),(49.885,27.685),(49.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,38.905),(26.225,39.075),(26.395,39.075),(26.395,38.905),(26.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.365),(50.225,28.535),(50.395,28.535),(50.395,28.365),(50.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.145),(45.425,34.315),(45.595,34.315),(45.595,34.145),(45.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.485),(45.425,34.655),(45.595,34.655),(45.595,34.485),(45.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.825),(45.425,34.995),(45.595,34.995),(45.595,34.825),(45.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.685),(40.115,10.855),(40.285,10.855),(40.285,10.685),(40.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.685),(40.625,10.855),(40.795,10.855),(40.795,10.685),(40.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.005),(40.115,10.175),(40.285,10.175),(40.285,10.005),(40.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.005),(40.625,10.175),(40.795,10.175),(40.795,10.005),(40.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.345),(40.115,10.515),(40.285,10.515),(40.285,10.345),(40.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.345),(40.625,10.515),(40.795,10.515),(40.795,10.345),(40.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.265),(39.605,6.435),(39.775,6.435),(39.775,6.265),(39.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.885),(31.025,21.055),(31.195,21.055),(31.195,20.885),(31.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.825),(10.805,17.995),(10.975,17.995),(10.975,17.825),(10.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.145),(10.805,17.315),(10.975,17.315),(10.975,17.145),(10.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.485),(10.805,17.655),(10.975,17.655),(10.975,17.485),(10.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.905),(20.915,5.075),(21.085,5.075),(21.085,4.905),(20.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.185),(74.225,19.355),(74.395,19.355),(74.395,19.185),(74.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,21.905),(63.605,22.075),(63.775,22.075),(63.775,21.905),(63.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,40.265),(39.605,40.435),(39.775,40.435),(39.775,40.265),(39.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.905),(55.025,5.075),(55.195,5.075),(55.195,4.905),(55.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,32.105),(6.515,32.275),(6.685,32.275),(6.685,32.105),(6.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,32.785),(6.515,32.955),(6.685,32.955),(6.685,32.785),(6.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,40.605),(11.825,40.775),(11.995,40.775),(11.995,40.605),(11.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,32.445),(6.515,32.615),(6.685,32.615),(6.685,32.445),(6.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.685),(78.005,10.855),(78.175,10.855),(78.175,10.685),(78.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.685),(78.515,10.855),(78.685,10.855),(78.685,10.685),(78.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.005),(78.515,10.175),(78.685,10.175),(78.685,10.005),(78.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.005),(78.005,10.175),(78.175,10.175),(78.175,10.005),(78.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,25.645),(26.225,25.815),(26.395,25.815),(26.395,25.645),(26.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.545),(6.515,3.715),(6.685,3.715),(6.685,3.545),(6.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,24.965),(7.025,25.135),(7.195,25.135),(7.195,24.965),(7.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,25.645),(20.915,25.815),(21.085,25.815),(21.085,25.645),(20.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,36.525),(68.915,36.695),(69.085,36.695),(69.085,36.525),(68.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,36.185),(68.915,36.355),(69.085,36.355),(69.085,36.185),(68.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.605),(78.005,6.775),(78.175,6.775),(78.175,6.605),(78.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.605),(78.515,6.775),(78.685,6.775),(78.685,6.605),(78.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,29.385),(20.915,29.555),(21.085,29.555),(21.085,29.385),(20.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,29.725),(20.915,29.895),(21.085,29.895),(21.085,29.725),(20.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,29.045),(20.915,29.215),(21.085,29.215),(21.085,29.045),(20.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.605),(55.025,23.775),(55.195,23.775),(55.195,23.605),(55.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.525),(69.425,19.695),(69.595,19.695),(69.595,19.525),(69.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.185),(69.425,19.355),(69.595,19.355),(69.595,19.185),(69.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,40.265),(20.405,40.435),(20.575,40.435),(20.575,40.265),(20.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.425),(26.225,14.595),(26.395,14.595),(26.395,14.425),(26.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,37.205),(25.715,37.375),(25.885,37.375),(25.885,37.205),(25.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.225),(68.915,4.395),(69.085,4.395),(69.085,4.225),(68.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.925),(6.515,6.095),(6.685,6.095),(6.685,5.925),(6.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,37.205),(74.225,37.375),(74.395,37.375),(74.395,37.205),(74.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,35.845),(6.515,36.015),(6.685,36.015),(6.685,35.845),(6.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,35.165),(83.315,35.335),(83.485,35.335),(83.485,35.165),(83.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,35.505),(83.315,35.675),(83.485,35.675),(83.485,35.505),(83.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.205),(11.825,3.375),(11.995,3.375),(11.995,3.205),(11.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.545),(11.315,3.715),(11.485,3.715),(11.485,3.545),(11.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.545),(11.825,3.715),(11.995,3.715),(11.995,3.545),(11.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.605),(30.515,6.775),(30.685,6.775),(30.685,6.605),(30.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.545),(68.915,3.715),(69.085,3.715),(69.085,3.545),(68.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,27.345),(30.005,27.515),(30.175,27.515),(30.175,27.345),(30.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.285),(68.405,7.455),(68.575,7.455),(68.575,7.285),(68.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.785),(83.315,15.955),(83.485,15.955),(83.485,15.785),(83.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.205),(20.915,3.375),(21.085,3.375),(21.085,3.205),(20.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,22.585),(64.115,22.755),(64.285,22.755),(64.285,22.585),(64.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,22.585),(64.625,22.755),(64.795,22.755),(64.795,22.585),(64.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.885),(6.515,4.055),(6.685,4.055),(6.685,3.885),(6.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,35.505),(11.315,35.675),(11.485,35.675),(11.485,35.505),(11.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,35.505),(11.825,35.675),(11.995,35.675),(11.995,35.505),(11.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,35.165),(11.315,35.335),(11.485,35.335),(11.485,35.165),(11.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,35.165),(11.825,35.335),(11.995,35.335),(11.995,35.165),(11.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.605),(44.405,23.775),(44.575,23.775),(44.575,23.605),(44.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.505),(55.025,18.675),(55.195,18.675),(55.195,18.505),(55.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,26.665),(50.225,26.835),(50.395,26.835),(50.395,26.665),(50.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.865),(49.205,3.035),(49.375,3.035),(49.375,2.865),(49.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.865),(49.715,3.035),(49.885,3.035),(49.885,2.865),(49.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.125),(39.605,16.295),(39.775,16.295),(39.775,16.125),(39.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.805),(39.605,16.975),(39.775,16.975),(39.775,16.805),(39.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.045),(49.715,12.215),(49.885,12.215),(49.885,12.045),(49.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.725),(49.205,12.895),(49.375,12.895),(49.375,12.725),(49.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.725),(49.715,12.895),(49.885,12.895),(49.885,12.725),(49.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.385),(49.205,12.555),(49.375,12.555),(49.375,12.385),(49.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.385),(49.715,12.555),(49.885,12.555),(49.885,12.385),(49.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.045),(49.205,12.215),(49.375,12.215),(49.375,12.045),(49.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,28.365),(68.915,28.535),(69.085,28.535),(69.085,28.365),(68.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.245),(63.605,5.415),(63.775,5.415),(63.775,5.245),(63.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,38.905),(7.025,39.075),(7.195,39.075),(7.195,38.905),(7.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.205),(39.605,20.375),(39.775,20.375),(39.775,20.205),(39.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.005),(35.315,27.175),(35.485,27.175),(35.485,27.005),(35.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.005),(35.825,27.175),(35.995,27.175),(35.995,27.005),(35.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.925),(10.805,6.095),(10.975,6.095),(10.975,5.925),(10.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,23.265),(30.005,23.435),(30.175,23.435),(30.175,23.265),(30.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,23.605),(30.005,23.775),(30.175,23.775),(30.175,23.605),(30.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,27.005),(63.605,27.175),(63.775,27.175),(63.775,27.005),(63.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.145),(16.625,17.315),(16.795,17.315),(16.795,17.145),(16.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.485),(16.625,17.655),(16.795,17.655),(16.795,17.485),(16.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.825),(16.625,17.995),(16.795,17.995),(16.795,17.825),(16.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.945),(7.025,7.115),(7.195,7.115),(7.195,6.945),(7.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,36.865),(25.205,37.035),(25.375,37.035),(25.375,36.865),(25.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,38.565),(74.225,38.735),(74.395,38.735),(74.395,38.565),(74.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.385),(59.315,12.555),(59.485,12.555),(59.485,12.385),(59.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.885),(25.205,4.055),(25.375,4.055),(25.375,3.885),(25.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.385),(59.825,12.555),(59.995,12.555),(59.995,12.385),(59.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.945),(59.315,24.115),(59.485,24.115),(59.485,23.945),(59.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,23.945),(59.825,24.115),(59.995,24.115),(59.995,23.945),(59.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.225),(21.425,4.395),(21.595,4.395),(21.595,4.225),(21.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.565),(21.425,4.735),(21.595,4.735),(21.595,4.565),(21.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,27.685),(68.915,27.855),(69.085,27.855),(69.085,27.685),(68.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.205),(74.225,3.375),(74.395,3.375),(74.395,3.205),(74.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.865),(55.025,37.035),(55.195,37.035),(55.195,36.865),(55.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,34.485),(15.605,34.655),(15.775,34.655),(15.775,34.485),(15.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,34.145),(15.605,34.315),(15.775,34.315),(15.775,34.145),(15.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,34.825),(15.605,34.995),(15.775,34.995),(15.775,34.825),(15.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.925),(49.205,23.095),(49.375,23.095),(49.375,22.925),(49.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.925),(49.715,23.095),(49.885,23.095),(49.885,22.925),(49.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,23.605),(74.225,23.775),(74.395,23.775),(74.395,23.605),(74.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,24.965),(16.115,25.135),(16.285,25.135),(16.285,24.965),(16.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.105),(68.405,15.275),(68.575,15.275),(68.575,15.105),(68.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.445),(68.405,15.615),(68.575,15.615),(68.575,15.445),(68.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.425),(16.625,14.595),(16.795,14.595),(16.795,14.425),(16.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.545),(39.605,37.715),(39.775,37.715),(39.775,37.545),(39.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.485),(35.315,17.655),(35.485,17.655),(35.485,17.485),(35.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.485),(35.825,17.655),(35.995,17.655),(35.995,17.485),(35.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.825),(35.315,17.995),(35.485,17.995),(35.485,17.825),(35.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.825),(35.825,17.995),(35.995,17.995),(35.995,17.825),(35.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.145),(35.315,17.315),(35.485,17.315),(35.485,17.145),(35.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.145),(35.825,17.315),(35.995,17.315),(35.995,17.145),(35.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.305),(54.515,8.475),(54.685,8.475),(54.685,8.305),(54.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.645),(54.005,8.815),(54.175,8.815),(54.175,8.645),(54.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.925),(34.805,23.095),(34.975,23.095),(34.975,22.925),(34.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,40.265),(35.315,40.435),(35.485,40.435),(35.485,40.265),(35.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,40.265),(35.825,40.435),(35.995,40.435),(35.995,40.265),(35.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.225),(58.805,38.395),(58.975,38.395),(58.975,38.225),(58.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,23.265),(7.025,23.435),(7.195,23.435),(7.195,23.265),(7.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,23.265),(63.605,23.435),(63.775,23.435),(63.775,23.265),(63.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.145),(20.405,17.315),(20.575,17.315),(20.575,17.145),(20.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.825),(20.405,17.995),(20.575,17.995),(20.575,17.825),(20.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,22.585),(16.115,22.755),(16.285,22.755),(16.285,22.585),(16.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.865),(54.005,37.035),(54.175,37.035),(54.175,36.865),(54.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.845),(20.915,19.015),(21.085,19.015),(21.085,18.845),(20.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.105),(59.825,15.275),(59.995,15.275),(59.995,15.105),(59.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.105),(59.315,15.275),(59.485,15.275),(59.485,15.105),(59.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.285),(16.625,7.455),(16.795,7.455),(16.795,7.285),(16.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,21.225),(21.425,21.395),(21.595,21.395),(21.595,21.225),(21.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.285),(15.605,7.455),(15.775,7.455),(15.775,7.285),(15.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.925),(55.025,6.095),(55.195,6.095),(55.195,5.925),(55.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,29.725),(68.405,29.895),(68.575,29.895),(68.575,29.725),(68.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,29.045),(68.405,29.215),(68.575,29.215),(68.575,29.045),(68.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,20.885),(16.115,21.055),(16.285,21.055),(16.285,20.885),(16.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,33.125),(25.205,33.295),(25.375,33.295),(25.375,33.125),(25.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,33.805),(25.205,33.975),(25.375,33.975),(25.375,33.805),(25.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,33.465),(25.205,33.635),(25.375,33.635),(25.375,33.465),(25.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.885),(45.425,4.055),(45.595,4.055),(45.595,3.885),(45.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.905),(64.115,5.075),(64.285,5.075),(64.285,4.905),(64.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.905),(64.625,5.075),(64.795,5.075),(64.795,4.905),(64.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.325),(25.715,9.495),(25.885,9.495),(25.885,9.325),(25.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.665),(25.715,9.835),(25.885,9.835),(25.885,9.665),(25.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.885),(26.225,4.055),(26.395,4.055),(26.395,3.885),(26.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,21.225),(26.225,21.395),(26.395,21.395),(26.395,21.225),(26.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,21.565),(26.225,21.735),(26.395,21.735),(26.395,21.565),(26.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.685),(11.315,10.855),(11.485,10.855),(11.485,10.685),(11.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.005),(11.315,10.175),(11.485,10.175),(11.485,10.005),(11.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.385),(58.805,29.555),(58.975,29.555),(58.975,29.385),(58.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.345),(11.315,10.515),(11.485,10.515),(11.485,10.345),(11.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.345),(11.825,10.515),(11.995,10.515),(11.995,10.345),(11.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,22.245),(68.405,22.415),(68.575,22.415),(68.575,22.245),(68.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,22.585),(68.405,22.755),(68.575,22.755),(68.575,22.585),(68.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.605),(44.915,23.775),(45.085,23.775),(45.085,23.605),(44.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.165),(64.115,18.335),(64.285,18.335),(64.285,18.165),(64.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.165),(64.625,18.335),(64.795,18.335),(64.795,18.165),(64.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.965),(45.425,8.135),(45.595,8.135),(45.595,7.965),(45.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.285),(58.805,7.455),(58.975,7.455),(58.975,7.285),(58.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.305),(68.915,8.475),(69.085,8.475),(69.085,8.305),(68.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.405),(20.405,13.575),(20.575,13.575),(20.575,13.405),(20.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.645),(68.915,8.815),(69.085,8.815),(69.085,8.645),(68.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.265),(82.805,6.435),(82.975,6.435),(82.975,6.265),(82.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.125),(45.425,16.295),(45.595,16.295),(45.595,16.125),(45.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.805),(45.425,16.975),(45.595,16.975),(45.595,16.805),(45.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.245),(30.515,39.415),(30.685,39.415),(30.685,39.245),(30.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.545),(35.315,37.715),(35.485,37.715),(35.485,37.545),(35.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.545),(35.825,37.715),(35.995,37.715),(35.995,37.545),(35.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.245),(44.405,39.415),(44.575,39.415),(44.575,39.245),(44.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.785),(30.515,15.955),(30.685,15.955),(30.685,15.785),(30.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,36.185),(63.605,36.355),(63.775,36.355),(63.775,36.185),(63.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,36.525),(63.605,36.695),(63.775,36.695),(63.775,36.525),(63.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.905),(16.625,5.075),(16.795,5.075),(16.795,4.905),(16.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,24.965),(26.225,25.135),(26.395,25.135),(26.395,24.965),(26.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,27.345),(69.425,27.515),(69.595,27.515),(69.595,27.345),(69.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.565),(69.425,4.735),(69.595,4.735),(69.595,4.565),(69.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.685),(44.915,27.855),(45.085,27.855),(45.085,27.685),(44.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.225),(39.605,4.395),(39.775,4.395),(39.775,4.225),(39.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.185),(10.805,19.355),(10.975,19.355),(10.975,19.185),(10.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.025),(30.515,11.195),(30.685,11.195),(30.685,11.025),(30.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.705),(30.515,11.875),(30.685,11.875),(30.685,11.705),(30.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.585),(59.315,39.755),(59.485,39.755),(59.485,39.585),(59.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,39.585),(59.825,39.755),(59.995,39.755),(59.995,39.585),(59.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.245),(54.005,39.415),(54.175,39.415),(54.175,39.245),(54.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.585),(54.515,39.755),(54.685,39.755),(54.685,39.585),(54.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.965),(54.515,25.135),(54.685,25.135),(54.685,24.965),(54.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.585),(58.805,22.755),(58.975,22.755),(58.975,22.585),(58.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.845),(50.225,36.015),(50.395,36.015),(50.395,35.845),(50.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.685),(50.225,10.855),(50.395,10.855),(50.395,10.685),(50.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.005),(50.225,10.175),(50.395,10.175),(50.395,10.005),(50.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.265),(45.425,23.435),(45.595,23.435),(45.595,23.265),(45.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.605),(45.425,23.775),(45.595,23.775),(45.595,23.605),(45.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.245),(54.005,22.415),(54.175,22.415),(54.175,22.245),(54.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.585),(54.005,22.755),(54.175,22.755),(54.175,22.585),(54.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.665),(15.605,9.835),(15.775,9.835),(15.775,9.665),(15.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.365),(44.915,28.535),(45.085,28.535),(45.085,28.365),(44.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.785),(54.515,32.955),(54.685,32.955),(54.685,32.785),(54.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.445),(54.515,32.615),(54.685,32.615),(54.685,32.445),(54.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,40.265),(59.315,40.435),(59.485,40.435),(59.485,40.265),(59.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,40.265),(59.825,40.435),(59.995,40.435),(59.995,40.265),(59.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.105),(54.515,32.275),(54.685,32.275),(54.685,32.105),(54.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.985),(45.425,26.155),(45.595,26.155),(45.595,25.985),(45.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,33.125),(16.115,33.295),(16.285,33.295),(16.285,33.125),(16.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,33.465),(16.115,33.635),(16.285,33.635),(16.285,33.465),(16.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,33.805),(16.115,33.975),(16.285,33.975),(16.285,33.805),(16.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.945),(74.225,7.115),(74.395,7.115),(74.395,6.945),(74.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,25.305),(83.315,25.475),(83.485,25.475),(83.485,25.305),(83.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.845),(39.605,19.015),(39.775,19.015),(39.775,18.845),(39.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,40.265),(74.225,40.435),(74.395,40.435),(74.395,40.265),(74.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,39.585),(26.225,39.755),(26.395,39.755),(26.395,39.585),(26.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.025),(25.205,11.195),(25.375,11.195),(25.375,11.025),(25.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.705),(25.205,11.875),(25.375,11.875),(25.375,11.705),(25.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.885),(16.115,4.055),(16.285,4.055),(16.285,3.885),(16.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,40.605),(25.715,40.775),(25.885,40.775),(25.885,40.605),(25.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.925),(39.605,23.095),(39.775,23.095),(39.775,22.925),(39.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,39.585),(79.025,39.755),(79.195,39.755),(79.195,39.585),(79.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,36.185),(83.315,36.355),(83.485,36.355),(83.485,36.185),(83.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,36.525),(83.315,36.695),(83.485,36.695),(83.485,36.525),(83.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.945),(16.115,7.115),(16.285,7.115),(16.285,6.945),(16.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.425),(68.915,14.595),(69.085,14.595),(69.085,14.425),(68.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.785),(68.915,15.955),(69.085,15.955),(69.085,15.785),(68.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.985),(64.115,9.155),(64.285,9.155),(64.285,8.985),(64.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.985),(64.625,9.155),(64.795,9.155),(64.795,8.985),(64.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.545),(39.605,3.715),(39.775,3.715),(39.775,3.545),(39.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.225),(55.025,21.395),(55.195,21.395),(55.195,21.225),(55.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.165),(50.225,18.335),(50.395,18.335),(50.395,18.165),(50.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.505),(50.225,18.675),(50.395,18.675),(50.395,18.505),(50.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.345),(45.425,27.515),(45.595,27.515),(45.595,27.345),(45.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.105),(30.515,32.275),(30.685,32.275),(30.685,32.105),(30.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.445),(30.515,32.615),(30.685,32.615),(30.685,32.445),(30.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.785),(30.515,32.955),(30.685,32.955),(30.685,32.785),(30.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.785),(6.515,15.955),(6.685,15.955),(6.685,15.785),(6.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.105),(6.515,15.275),(6.685,15.275),(6.685,15.105),(6.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.865),(25.205,20.035),(25.375,20.035),(25.375,19.865),(25.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.825),(50.225,17.995),(50.395,17.995),(50.395,17.825),(50.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.145),(50.225,17.315),(50.395,17.315),(50.395,17.145),(50.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,36.525),(11.315,36.695),(11.485,36.695),(11.485,36.525),(11.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,36.185),(11.315,36.355),(11.485,36.355),(11.485,36.185),(11.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,20.545),(21.425,20.715),(21.595,20.715),(21.595,20.545),(21.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,20.205),(21.425,20.375),(21.595,20.375),(21.595,20.205),(21.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,35.845),(20.915,36.015),(21.085,36.015),(21.085,35.845),(20.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.165),(45.425,18.335),(45.595,18.335),(45.595,18.165),(45.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.665),(44.405,9.835),(44.575,9.835),(44.575,9.665),(44.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,22.925),(11.315,23.095),(11.485,23.095),(11.485,22.925),(11.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.365),(6.515,11.535),(6.685,11.535),(6.685,11.365),(6.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.965),(44.915,25.135),(45.085,25.135),(45.085,24.965),(44.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,25.305),(68.915,25.475),(69.085,25.475),(69.085,25.305),(68.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.985),(16.625,9.155),(16.795,9.155),(16.795,8.985),(16.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,32.785),(20.405,32.955),(20.575,32.955),(20.575,32.785),(20.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,32.445),(20.405,32.615),(20.575,32.615),(20.575,32.445),(20.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,32.105),(20.405,32.275),(20.575,32.275),(20.575,32.105),(20.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.925),(30.515,23.095),(30.685,23.095),(30.685,22.925),(30.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.565),(26.225,4.735),(26.395,4.735),(26.395,4.565),(26.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,29.385),(68.915,29.555),(69.085,29.555),(69.085,29.385),(68.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.745),(44.405,13.915),(44.575,13.915),(44.575,13.745),(44.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.065),(44.405,13.235),(44.575,13.235),(44.575,13.065),(44.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.405),(44.405,13.575),(44.575,13.575),(44.575,13.405),(44.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.865),(55.025,20.035),(55.195,20.035),(55.195,19.865),(55.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.765),(6.515,14.935),(6.685,14.935),(6.685,14.765),(6.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.085),(6.515,14.255),(6.685,14.255),(6.685,14.085),(6.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,32.445),(25.715,32.615),(25.885,32.615),(25.885,32.445),(25.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,32.785),(25.715,32.955),(25.885,32.955),(25.885,32.785),(25.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,32.105),(25.715,32.275),(25.885,32.275),(25.885,32.105),(25.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,36.185),(78.515,36.355),(78.685,36.355),(78.685,36.185),(78.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,36.185),(78.005,36.355),(78.175,36.355),(78.175,36.185),(78.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,36.525),(78.005,36.695),(78.175,36.695),(78.175,36.525),(78.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,36.525),(78.515,36.695),(78.685,36.695),(78.685,36.525),(78.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,24.625),(11.825,24.795),(11.995,24.795),(11.995,24.625),(11.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,35.845),(74.225,36.015),(74.395,36.015),(74.395,35.845),(74.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.865),(68.405,20.035),(68.575,20.035),(68.575,19.865),(68.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,38.905),(64.115,39.075),(64.285,39.075),(64.285,38.905),(64.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,38.905),(64.625,39.075),(64.795,39.075),(64.795,38.905),(64.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.865),(45.425,37.035),(45.595,37.035),(45.595,36.865),(45.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.905),(11.315,5.075),(11.485,5.075),(11.485,4.905),(11.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.865),(55.025,3.035),(55.195,3.035),(55.195,2.865),(55.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,25.645),(21.425,25.815),(21.595,25.815),(21.595,25.645),(21.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,25.305),(21.425,25.475),(21.595,25.475),(21.595,25.305),(21.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.545),(55.025,20.715),(55.195,20.715),(55.195,20.545),(55.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,22.925),(20.405,23.095),(20.575,23.095),(20.575,22.925),(20.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.005),(50.225,27.175),(50.395,27.175),(50.395,27.005),(50.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.345),(50.225,27.515),(50.395,27.515),(50.395,27.345),(50.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.925),(35.315,23.095),(35.485,23.095),(35.485,22.925),(35.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.925),(35.825,23.095),(35.995,23.095),(35.995,22.925),(35.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.425),(59.315,14.595),(59.485,14.595),(59.485,14.425),(59.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.425),(59.825,14.595),(59.995,14.595),(59.995,14.425),(59.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,2.865),(11.825,3.035),(11.995,3.035),(11.995,2.865),(11.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,21.225),(64.115,21.395),(64.285,21.395),(64.285,21.225),(64.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,21.225),(64.625,21.395),(64.795,21.395),(64.795,21.225),(64.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,21.565),(64.115,21.735),(64.285,21.735),(64.285,21.565),(64.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,21.565),(64.625,21.735),(64.795,21.735),(64.795,21.565),(64.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.745),(39.605,13.915),(39.775,13.915),(39.775,13.745),(39.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.065),(39.605,13.235),(39.775,13.235),(39.775,13.065),(39.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.245),(44.915,39.415),(45.085,39.415),(45.085,39.245),(44.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,38.565),(10.805,38.735),(10.975,38.735),(10.975,38.565),(10.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.905),(26.225,5.075),(26.395,5.075),(26.395,4.905),(26.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.085),(54.515,14.255),(54.685,14.255),(54.685,14.085),(54.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.765),(54.515,14.935),(54.685,14.935),(54.685,14.765),(54.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.425),(54.515,14.595),(54.685,14.595),(54.685,14.425),(54.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,34.825),(26.225,34.995),(26.395,34.995),(26.395,34.825),(26.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,34.145),(26.225,34.315),(26.395,34.315),(26.395,34.145),(26.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,34.485),(26.225,34.655),(26.395,34.655),(26.395,34.485),(26.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,39.585),(82.805,39.755),(82.975,39.755),(82.975,39.585),(82.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.205),(10.805,3.375),(10.975,3.375),(10.975,3.205),(10.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.925),(58.805,40.095),(58.975,40.095),(58.975,39.925),(58.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,35.505),(63.605,35.675),(63.775,35.675),(63.775,35.505),(63.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,35.165),(63.605,35.335),(63.775,35.335),(63.775,35.165),(63.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.005),(25.715,10.175),(25.885,10.175),(25.885,10.005),(25.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.685),(25.715,10.855),(25.885,10.855),(25.885,10.685),(25.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.485),(39.605,17.655),(39.775,17.655),(39.775,17.485),(39.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.785),(45.425,32.955),(45.595,32.955),(45.595,32.785),(45.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.105),(45.425,32.275),(45.595,32.275),(45.595,32.105),(45.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.445),(45.425,32.615),(45.595,32.615),(45.595,32.445),(45.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,37.885),(16.625,38.055),(16.795,38.055),(16.795,37.885),(16.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.385),(44.915,12.555),(45.085,12.555),(45.085,12.385),(44.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,40.265),(10.805,40.435),(10.975,40.435),(10.975,40.265),(10.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,35.505),(10.805,35.675),(10.975,35.675),(10.975,35.505),(10.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,35.165),(10.805,35.335),(10.975,35.335),(10.975,35.165),(10.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.185),(79.025,19.355),(79.195,19.355),(79.195,19.185),(79.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.525),(79.025,19.695),(79.195,19.695),(79.195,19.525),(79.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.125),(58.805,33.295),(58.975,33.295),(58.975,33.125),(58.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.805),(58.805,33.975),(58.975,33.975),(58.975,33.805),(58.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.465),(58.805,33.635),(58.975,33.635),(58.975,33.465),(58.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.945),(39.605,7.115),(39.775,7.115),(39.775,6.945),(39.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,21.905),(78.005,22.075),(78.175,22.075),(78.175,21.905),(78.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,21.905),(78.515,22.075),(78.685,22.075),(78.685,21.905),(78.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,21.225),(63.605,21.395),(63.775,21.395),(63.775,21.225),(63.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,21.565),(63.605,21.735),(63.775,21.735),(63.775,21.565),(63.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.865),(20.915,20.035),(21.085,20.035),(21.085,19.865),(20.915,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,21.565),(83.315,21.735),(83.485,21.735),(83.485,21.565),(83.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.185),(50.225,36.355),(50.395,36.355),(50.395,36.185),(50.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.525),(50.225,36.695),(50.395,36.695),(50.395,36.525),(50.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.585),(50.225,22.755),(50.395,22.755),(50.395,22.585),(50.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.565),(74.225,4.735),(74.395,4.735),(74.395,4.565),(74.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.225),(74.225,4.395),(74.395,4.395),(74.395,4.225),(74.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.685),(39.605,27.855),(39.775,27.855),(39.775,27.685),(39.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.805),(44.915,33.975),(45.085,33.975),(45.085,33.805),(44.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.125),(44.915,33.295),(45.085,33.295),(45.085,33.125),(44.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.465),(44.915,33.635),(45.085,33.635),(45.085,33.465),(44.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.925),(35.315,6.095),(35.485,6.095),(35.485,5.925),(35.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.925),(35.825,6.095),(35.995,6.095),(35.995,5.925),(35.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.905),(44.405,22.075),(44.575,22.075),(44.575,21.905),(44.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.405),(30.515,13.575),(30.685,13.575),(30.685,13.405),(30.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.745),(44.915,13.915),(45.085,13.915),(45.085,13.745),(44.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.405),(44.915,13.575),(45.085,13.575),(45.085,13.405),(44.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,35.165),(73.715,35.335),(73.885,35.335),(73.885,35.165),(73.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,35.505),(73.205,35.675),(73.375,35.675),(73.375,35.505),(73.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,35.505),(73.715,35.675),(73.885,35.675),(73.885,35.505),(73.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,35.165),(73.205,35.335),(73.375,35.335),(73.375,35.165),(73.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.305),(7.025,8.475),(7.195,8.475),(7.195,8.305),(7.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,23.945),(7.025,24.115),(7.195,24.115),(7.195,23.945),(7.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.925),(11.315,6.095),(11.485,6.095),(11.485,5.925),(11.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,23.945),(63.605,24.115),(63.775,24.115),(63.775,23.945),(63.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.225),(44.405,38.395),(44.575,38.395),(44.575,38.225),(44.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.845),(68.915,19.015),(69.085,19.015),(69.085,18.845),(68.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.645),(68.405,8.815),(68.575,8.815),(68.575,8.645),(68.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.885),(20.405,4.055),(20.575,4.055),(20.575,3.885),(20.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.785),(49.715,15.955),(49.885,15.955),(49.885,15.785),(49.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.105),(49.205,15.275),(49.375,15.275),(49.375,15.105),(49.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.105),(49.715,15.275),(49.885,15.275),(49.885,15.105),(49.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.445),(49.205,15.615),(49.375,15.615),(49.375,15.445),(49.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.445),(49.715,15.615),(49.885,15.615),(49.885,15.445),(49.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.785),(49.205,15.955),(49.375,15.955),(49.375,15.785),(49.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,20.545),(26.225,20.715),(26.395,20.715),(26.395,20.545),(26.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.645),(82.805,8.815),(82.975,8.815),(82.975,8.645),(82.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.305),(82.805,8.475),(82.975,8.475),(82.975,8.305),(82.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,40.265),(55.025,40.435),(55.195,40.435),(55.195,40.265),(55.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.225),(45.425,38.395),(45.595,38.395),(45.595,38.225),(45.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.345),(73.205,10.515),(73.375,10.515),(73.375,10.345),(73.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.345),(73.715,10.515),(73.885,10.515),(73.885,10.345),(73.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.225),(30.515,38.395),(30.685,38.395),(30.685,38.225),(30.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.025),(16.625,11.195),(16.795,11.195),(16.795,11.025),(16.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.365),(16.625,11.535),(16.795,11.535),(16.795,11.365),(16.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.705),(16.625,11.875),(16.795,11.875),(16.795,11.705),(16.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,34.485),(78.005,34.655),(78.175,34.655),(78.175,34.485),(78.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,34.485),(78.515,34.655),(78.685,34.655),(78.685,34.485),(78.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,34.825),(78.005,34.995),(78.175,34.995),(78.175,34.825),(78.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,34.825),(78.515,34.995),(78.685,34.995),(78.685,34.825),(78.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,34.145),(78.005,34.315),(78.175,34.315),(78.175,34.145),(78.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,34.145),(78.515,34.315),(78.685,34.315),(78.685,34.145),(78.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.925),(55.025,23.095),(55.195,23.095),(55.195,22.925),(55.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.685),(68.405,10.855),(68.575,10.855),(68.575,10.685),(68.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.005),(68.405,10.175),(68.575,10.175),(68.575,10.005),(68.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,25.645),(69.425,25.815),(69.595,25.815),(69.595,25.645),(69.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.145),(34.805,34.315),(34.975,34.315),(34.975,34.145),(34.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.485),(34.805,34.655),(34.975,34.655),(34.975,34.485),(34.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.825),(34.805,34.995),(34.975,34.995),(34.975,34.825),(34.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.745),(34.805,30.915),(34.975,30.915),(34.975,30.745),(34.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.065),(34.805,30.235),(34.975,30.235),(34.975,30.065),(34.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.405),(34.805,30.575),(34.975,30.575),(34.975,30.405),(34.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.465),(25.715,16.635),(25.885,16.635),(25.885,16.465),(25.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.885),(39.605,21.055),(39.775,21.055),(39.775,20.885),(39.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,39.245),(15.605,39.415),(15.775,39.415),(15.775,39.245),(15.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.265),(79.025,6.435),(79.195,6.435),(79.195,6.265),(79.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,39.245),(68.405,39.415),(68.575,39.415),(68.575,39.245),(68.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.905),(34.805,22.075),(34.975,22.075),(34.975,21.905),(34.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.545),(55.025,37.715),(55.195,37.715),(55.195,37.545),(55.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.865),(21.425,20.035),(21.595,20.035),(21.595,19.865),(21.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.065),(25.715,13.235),(25.885,13.235),(25.885,13.065),(25.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.745),(25.715,13.915),(25.885,13.915),(25.885,13.745),(25.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.405),(25.715,13.575),(25.885,13.575),(25.885,13.405),(25.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.385),(39.605,12.555),(39.775,12.555),(39.775,12.385),(39.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.125),(78.005,16.295),(78.175,16.295),(78.175,16.125),(78.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.125),(78.515,16.295),(78.685,16.295),(78.685,16.125),(78.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.805),(78.005,16.975),(78.175,16.975),(78.175,16.805),(78.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.805),(78.515,16.975),(78.685,16.975),(78.685,16.805),(78.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,40.265),(54.005,40.435),(54.175,40.435),(54.175,40.265),(54.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,40.605),(54.515,40.775),(54.685,40.775),(54.685,40.605),(54.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,26.665),(58.805,26.835),(58.975,26.835),(58.975,26.665),(58.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,26.325),(58.805,26.495),(58.975,26.495),(58.975,26.325),(58.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.625),(16.625,7.795),(16.795,7.795),(16.795,7.625),(16.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.185),(50.225,19.355),(50.395,19.355),(50.395,19.185),(50.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,31.765),(30.005,31.935),(30.175,31.935),(30.175,31.765),(30.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,31.425),(30.005,31.595),(30.175,31.595),(30.175,31.425),(30.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,31.085),(30.005,31.255),(30.175,31.255),(30.175,31.085),(30.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,40.605),(44.405,40.775),(44.575,40.775),(44.575,40.605),(44.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,26.665),(25.205,26.835),(25.375,26.835),(25.375,26.665),(25.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,26.325),(25.205,26.495),(25.375,26.495),(25.375,26.325),(25.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.545),(31.025,37.715),(31.195,37.715),(31.195,37.545),(31.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.205),(34.805,37.375),(34.975,37.375),(34.975,37.205),(34.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.685),(44.405,10.855),(44.575,10.855),(44.575,10.685),(44.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.005),(44.405,10.175),(44.575,10.175),(44.575,10.005),(44.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.345),(44.405,10.515),(44.575,10.515),(44.575,10.345),(44.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.265),(26.225,6.435),(26.395,6.435),(26.395,6.265),(26.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,24.625),(68.915,24.795),(69.085,24.795),(69.085,24.625),(68.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.025),(39.605,11.195),(39.775,11.195),(39.775,11.025),(39.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.705),(39.605,11.875),(39.775,11.875),(39.775,11.705),(39.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.665),(16.115,9.835),(16.285,9.835),(16.285,9.665),(16.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.985),(54.515,9.155),(54.685,9.155),(54.685,8.985),(54.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.925),(20.405,6.095),(20.575,6.095),(20.575,5.925),(20.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,37.205),(16.115,37.375),(16.285,37.375),(16.285,37.205),(16.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.905),(58.805,39.075),(58.975,39.075),(58.975,38.905),(58.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.325),(83.315,9.495),(83.485,9.495),(83.485,9.325),(83.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.665),(83.315,9.835),(83.485,9.835),(83.485,9.665),(83.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.905),(49.205,5.075),(49.375,5.075),(49.375,4.905),(49.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,20.205),(69.425,20.375),(69.595,20.375),(69.595,20.205),(69.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,20.545),(69.425,20.715),(69.595,20.715),(69.595,20.545),(69.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.905),(49.715,5.075),(49.885,5.075),(49.885,4.905),(49.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,20.205),(63.605,20.375),(63.775,20.375),(63.775,20.205),(63.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,20.545),(63.605,20.715),(63.775,20.715),(63.775,20.545),(63.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.865),(16.625,20.035),(16.795,20.035),(16.795,19.865),(16.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.685),(31.025,27.855),(31.195,27.855),(31.195,27.685),(31.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,39.585),(20.915,39.755),(21.085,39.755),(21.085,39.585),(20.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,22.925),(16.625,23.095),(16.795,23.095),(16.795,22.925),(16.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.925),(45.425,40.095),(45.595,40.095),(45.595,39.925),(45.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.165),(20.915,18.335),(21.085,18.335),(21.085,18.165),(20.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.205),(40.115,37.375),(40.285,37.375),(40.285,37.205),(40.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.205),(40.625,37.375),(40.795,37.375),(40.795,37.205),(40.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.605),(40.115,6.775),(40.285,6.775),(40.285,6.605),(40.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.605),(40.625,6.775),(40.795,6.775),(40.795,6.605),(40.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.265),(40.115,6.435),(40.285,6.435),(40.285,6.265),(40.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.265),(40.625,6.435),(40.795,6.435),(40.795,6.265),(40.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.585),(55.025,5.755),(55.195,5.755),(55.195,5.585),(55.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.245),(55.025,5.415),(55.195,5.415),(55.195,5.245),(55.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,27.685),(64.115,27.855),(64.285,27.855),(64.285,27.685),(64.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,27.685),(64.625,27.855),(64.795,27.855),(64.795,27.685),(64.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,23.265),(20.405,23.435),(20.575,23.435),(20.575,23.265),(20.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,31.425),(63.605,31.595),(63.775,31.595),(63.775,31.425),(63.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.525),(31.025,19.695),(31.195,19.695),(31.195,19.525),(31.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,20.205),(11.825,20.375),(11.995,20.375),(11.995,20.205),(11.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,20.545),(11.825,20.715),(11.995,20.715),(11.995,20.545),(11.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,27.685),(15.605,27.855),(15.775,27.855),(15.775,27.685),(15.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.905),(59.315,22.075),(59.485,22.075),(59.485,21.905),(59.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,21.905),(59.825,22.075),(59.995,22.075),(59.995,21.905),(59.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.905),(30.515,22.075),(30.685,22.075),(30.685,21.905),(30.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,21.565),(10.805,21.735),(10.975,21.735),(10.975,21.565),(10.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.925),(25.715,6.095),(25.885,6.095),(25.885,5.925),(25.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,22.245),(20.915,22.415),(21.085,22.415),(21.085,22.245),(20.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.465),(30.515,16.635),(30.685,16.635),(30.685,16.465),(30.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.805),(68.405,16.975),(68.575,16.975),(68.575,16.805),(68.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.125),(68.405,16.295),(68.575,16.295),(68.575,16.125),(68.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.465),(68.405,16.635),(68.575,16.635),(68.575,16.465),(68.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.845),(64.115,19.015),(64.285,19.015),(64.285,18.845),(64.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.845),(64.625,19.015),(64.795,19.015),(64.795,18.845),(64.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.945),(82.805,7.115),(82.975,7.115),(82.975,6.945),(82.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.185),(49.205,19.355),(49.375,19.355),(49.375,19.185),(49.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,24.285),(20.405,24.455),(20.575,24.455),(20.575,24.285),(20.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,24.625),(20.405,24.795),(20.575,24.795),(20.575,24.625),(20.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.865),(54.005,3.035),(54.175,3.035),(54.175,2.865),(54.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,32.105),(82.805,32.275),(82.975,32.275),(82.975,32.105),(82.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,32.445),(82.805,32.615),(82.975,32.615),(82.975,32.445),(82.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,32.785),(82.805,32.955),(82.975,32.955),(82.975,32.785),(82.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.665),(64.115,9.835),(64.285,9.835),(64.285,9.665),(64.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.665),(64.625,9.835),(64.795,9.835),(64.795,9.665),(64.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,36.865),(63.605,37.035),(63.775,37.035),(63.775,36.865),(63.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.425),(49.715,14.595),(49.885,14.595),(49.885,14.425),(49.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.765),(49.205,14.935),(49.375,14.935),(49.375,14.765),(49.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.765),(49.715,14.935),(49.885,14.935),(49.885,14.765),(49.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.425),(49.205,14.595),(49.375,14.595),(49.375,14.425),(49.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.085),(49.205,14.255),(49.375,14.255),(49.375,14.085),(49.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.085),(49.715,14.255),(49.885,14.255),(49.885,14.085),(49.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,28.365),(20.405,28.535),(20.575,28.535),(20.575,28.365),(20.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,28.705),(20.405,28.875),(20.575,28.875),(20.575,28.705),(20.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,28.025),(20.405,28.195),(20.575,28.195),(20.575,28.025),(20.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.645),(44.405,25.815),(44.575,25.815),(44.575,25.645),(44.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.305),(44.405,25.475),(44.575,25.475),(44.575,25.305),(44.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.185),(15.605,19.355),(15.775,19.355),(15.775,19.185),(15.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.325),(69.425,9.495),(69.595,9.495),(69.595,9.325),(69.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,27.685),(6.515,27.855),(6.685,27.855),(6.685,27.685),(6.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,40.265),(68.915,40.435),(69.085,40.435),(69.085,40.265),(68.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,38.565),(82.805,38.735),(82.975,38.735),(82.975,38.565),(82.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.225),(79.025,4.395),(79.195,4.395),(79.195,4.225),(79.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,39.585),(68.915,39.755),(69.085,39.755),(69.085,39.585),(68.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.665),(21.425,9.835),(21.595,9.835),(21.595,9.665),(21.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,22.245),(79.025,22.415),(79.195,22.415),(79.195,22.245),(79.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.165),(68.405,18.335),(68.575,18.335),(68.575,18.165),(68.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,31.765),(16.625,31.935),(16.795,31.935),(16.795,31.765),(16.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,31.085),(16.625,31.255),(16.795,31.255),(16.795,31.085),(16.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.165),(78.005,18.335),(78.175,18.335),(78.175,18.165),(78.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.165),(78.515,18.335),(78.685,18.335),(78.685,18.165),(78.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.505),(78.005,18.675),(78.175,18.675),(78.175,18.505),(78.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.505),(78.515,18.675),(78.685,18.675),(78.685,18.505),(78.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.045),(64.115,12.215),(64.285,12.215),(64.285,12.045),(64.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.725),(64.115,12.895),(64.285,12.895),(64.285,12.725),(64.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.725),(64.625,12.895),(64.795,12.895),(64.795,12.725),(64.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.045),(64.625,12.215),(64.795,12.215),(64.795,12.045),(64.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.645),(45.425,25.815),(45.595,25.815),(45.595,25.645),(45.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.305),(45.425,25.475),(45.595,25.475),(45.595,25.305),(45.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.865),(35.315,20.035),(35.485,20.035),(35.485,19.865),(35.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.865),(35.825,20.035),(35.995,20.035),(35.995,19.865),(35.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.065),(11.825,13.235),(11.995,13.235),(11.995,13.065),(11.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.745),(11.825,13.915),(11.995,13.915),(11.995,13.745),(11.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.305),(63.605,8.475),(63.775,8.475),(63.775,8.305),(63.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.205),(16.115,3.375),(16.285,3.375),(16.285,3.205),(16.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.605),(50.225,23.775),(50.395,23.775),(50.395,23.605),(50.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.805),(73.205,16.975),(73.375,16.975),(73.375,16.805),(73.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.805),(73.715,16.975),(73.885,16.975),(73.885,16.805),(73.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.125),(73.205,16.295),(73.375,16.295),(73.375,16.125),(73.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.125),(73.715,16.295),(73.885,16.295),(73.885,16.125),(73.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.465),(73.205,16.635),(73.375,16.635),(73.375,16.465),(73.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.465),(73.715,16.635),(73.885,16.635),(73.885,16.465),(73.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,36.865),(83.315,37.035),(83.485,37.035),(83.485,36.865),(83.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.865),(11.315,20.035),(11.485,20.035),(11.485,19.865),(11.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,29.385),(25.715,29.555),(25.885,29.555),(25.885,29.385),(25.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,29.725),(25.715,29.895),(25.885,29.895),(25.885,29.725),(25.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,29.045),(25.715,29.215),(25.885,29.215),(25.885,29.045),(25.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.845),(50.225,19.015),(50.395,19.015),(50.395,18.845),(50.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.385),(16.625,12.555),(16.795,12.555),(16.795,12.385),(16.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,35.845),(16.625,36.015),(16.795,36.015),(16.795,35.845),(16.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,32.105),(63.605,32.275),(63.775,32.275),(63.775,32.105),(63.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,32.445),(63.605,32.615),(63.775,32.615),(63.775,32.445),(63.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,32.785),(63.605,32.955),(63.775,32.955),(63.775,32.785),(63.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.525),(45.425,19.695),(45.595,19.695),(45.595,19.525),(45.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.185),(45.425,19.355),(45.595,19.355),(45.595,19.185),(45.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,36.865),(11.315,37.035),(11.485,37.035),(11.485,36.865),(11.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,20.885),(21.425,21.055),(21.595,21.055),(21.595,20.885),(21.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,34.145),(20.405,34.315),(20.575,34.315),(20.575,34.145),(20.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,34.485),(20.405,34.655),(20.575,34.655),(20.575,34.485),(20.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,34.825),(20.405,34.995),(20.575,34.995),(20.575,34.825),(20.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,38.565),(21.425,38.735),(21.595,38.735),(21.595,38.565),(21.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.265),(83.315,6.435),(83.485,6.435),(83.485,6.265),(83.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.545),(45.425,37.715),(45.595,37.715),(45.595,37.545),(45.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.845),(45.425,19.015),(45.595,19.015),(45.595,18.845),(45.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.105),(74.225,15.275),(74.395,15.275),(74.395,15.105),(74.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,21.565),(25.715,21.735),(25.885,21.735),(25.885,21.565),(25.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.285),(44.915,24.455),(45.085,24.455),(45.085,24.285),(44.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.905),(45.425,22.075),(45.595,22.075),(45.595,21.905),(45.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.625),(44.915,24.795),(45.085,24.795),(45.085,24.625),(44.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,25.985),(68.915,26.155),(69.085,26.155),(69.085,25.985),(68.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.545),(54.005,3.715),(54.175,3.715),(54.175,3.545),(54.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.205),(54.005,3.375),(54.175,3.375),(54.175,3.205),(54.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.925),(45.425,23.095),(45.595,23.095),(45.595,22.925),(45.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,38.565),(25.715,38.735),(25.885,38.735),(25.885,38.565),(25.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.105),(79.025,15.275),(79.195,15.275),(79.195,15.105),(79.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,25.985),(11.315,26.155),(11.485,26.155),(11.485,25.985),(11.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.365),(34.805,28.535),(34.975,28.535),(34.975,28.365),(34.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.705),(34.805,28.875),(34.975,28.875),(34.975,28.705),(34.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.025),(34.805,28.195),(34.975,28.195),(34.975,28.025),(34.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.445),(79.025,15.615),(79.195,15.615),(79.195,15.445),(79.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,37.885),(11.315,38.055),(11.485,38.055),(11.485,37.885),(11.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,37.885),(11.825,38.055),(11.995,38.055),(11.995,37.885),(11.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.485),(55.025,17.655),(55.195,17.655),(55.195,17.485),(55.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.685),(39.605,10.855),(39.775,10.855),(39.775,10.685),(39.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.005),(39.605,10.175),(39.775,10.175),(39.775,10.005),(39.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.345),(39.605,10.515),(39.775,10.515),(39.775,10.345),(39.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.965),(68.915,8.135),(69.085,8.135),(69.085,7.965),(68.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,33.805),(73.205,33.975),(73.375,33.975),(73.375,33.805),(73.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,33.465),(73.715,33.635),(73.885,33.635),(73.885,33.465),(73.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,33.465),(73.205,33.635),(73.375,33.635),(73.375,33.465),(73.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,33.805),(73.715,33.975),(73.885,33.975),(73.885,33.805),(73.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,33.125),(73.205,33.295),(73.375,33.295),(73.375,33.125),(73.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,33.125),(73.715,33.295),(73.885,33.295),(73.885,33.125),(73.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.905),(44.915,39.075),(45.085,39.075),(45.085,38.905),(44.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,36.865),(78.005,37.035),(78.175,37.035),(78.175,36.865),(78.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,36.865),(78.515,37.035),(78.685,37.035),(78.685,36.865),(78.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.865),(35.315,3.035),(35.485,3.035),(35.485,2.865),(35.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.865),(35.825,3.035),(35.995,3.035),(35.995,2.865),(35.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.905),(31.025,5.075),(31.195,5.075),(31.195,4.905),(31.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.525),(68.405,19.695),(68.575,19.695),(68.575,19.525),(68.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.185),(68.405,19.355),(68.575,19.355),(68.575,19.185),(68.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.645),(30.515,8.815),(30.685,8.815),(30.685,8.645),(30.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.205),(79.025,3.375),(79.195,3.375),(79.195,3.205),(79.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.945),(20.915,7.115),(21.085,7.115),(21.085,6.945),(20.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.545),(30.005,3.715),(30.175,3.715),(30.175,3.545),(30.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.205),(30.005,3.375),(30.175,3.375),(30.175,3.205),(30.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.925),(54.515,6.095),(54.685,6.095),(54.685,5.925),(54.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.245),(31.025,22.415),(31.195,22.415),(31.195,22.245),(31.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.585),(31.025,22.755),(31.195,22.755),(31.195,22.585),(31.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,27.685),(20.405,27.855),(20.575,27.855),(20.575,27.685),(20.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.285),(58.805,24.455),(58.975,24.455),(58.975,24.285),(58.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.625),(58.805,24.795),(58.975,24.795),(58.975,24.625),(58.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.965),(54.515,8.135),(54.685,8.135),(54.685,7.965),(54.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.205),(59.825,3.375),(59.995,3.375),(59.995,3.205),(59.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.545),(59.315,3.715),(59.485,3.715),(59.485,3.545),(59.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.545),(59.825,3.715),(59.995,3.715),(59.995,3.545),(59.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.205),(59.315,3.375),(59.485,3.375),(59.485,3.205),(59.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,38.225),(73.715,38.395),(73.885,38.395),(73.885,38.225),(73.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,38.225),(73.205,38.395),(73.375,38.395),(73.375,38.225),(73.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,29.385),(30.005,29.555),(30.175,29.555),(30.175,29.385),(30.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.105),(31.025,15.275),(31.195,15.275),(31.195,15.105),(31.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.785),(31.025,15.955),(31.195,15.955),(31.195,15.785),(31.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.965),(6.515,8.135),(6.685,8.135),(6.685,7.965),(6.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,30.745),(63.605,30.915),(63.775,30.915),(63.775,30.745),(63.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,30.065),(63.605,30.235),(63.775,30.235),(63.775,30.065),(63.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.225),(20.405,4.395),(20.575,4.395),(20.575,4.225),(20.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.565),(20.405,4.735),(20.575,4.735),(20.575,4.565),(20.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.125),(34.805,16.295),(34.975,16.295),(34.975,16.125),(34.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.805),(34.805,16.975),(34.975,16.975),(34.975,16.805),(34.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.205),(31.025,3.375),(31.195,3.375),(31.195,3.205),(31.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,25.305),(64.115,25.475),(64.285,25.475),(64.285,25.305),(64.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,25.305),(64.625,25.475),(64.795,25.475),(64.795,25.305),(64.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.885),(54.515,4.055),(54.685,4.055),(54.685,3.885),(54.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.925),(30.005,6.095),(30.175,6.095),(30.175,5.925),(30.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.725),(11.825,12.895),(11.995,12.895),(11.995,12.725),(11.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.045),(11.825,12.215),(11.995,12.215),(11.995,12.045),(11.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.265),(59.315,6.435),(59.485,6.435),(59.485,6.265),(59.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.265),(59.825,6.435),(59.995,6.435),(59.995,6.265),(59.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.105),(64.115,15.275),(64.285,15.275),(64.285,15.105),(64.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.545),(44.405,37.715),(44.575,37.715),(44.575,37.545),(44.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.505),(83.315,18.675),(83.485,18.675),(83.485,18.505),(83.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.105),(64.625,15.275),(64.795,15.275),(64.795,15.105),(64.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.285),(20.405,7.455),(20.575,7.455),(20.575,7.285),(20.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.125),(35.315,16.295),(35.485,16.295),(35.485,16.125),(35.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.125),(35.825,16.295),(35.995,16.295),(35.995,16.125),(35.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.805),(35.315,16.975),(35.485,16.975),(35.485,16.805),(35.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.805),(35.825,16.975),(35.995,16.975),(35.995,16.805),(35.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.345),(58.805,27.515),(58.975,27.515),(58.975,27.345),(58.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.965),(30.005,8.135),(30.175,8.135),(30.175,7.965),(30.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.225),(49.205,38.395),(49.375,38.395),(49.375,38.225),(49.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.225),(49.715,38.395),(49.885,38.395),(49.885,38.225),(49.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.245),(58.805,39.415),(58.975,39.415),(58.975,39.245),(58.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,2.865),(79.025,3.035),(79.195,3.035),(79.195,2.865),(79.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.225),(30.005,21.395),(30.175,21.395),(30.175,21.225),(30.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.565),(30.005,21.735),(30.175,21.735),(30.175,21.565),(30.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.125),(26.225,16.295),(26.395,16.295),(26.395,16.125),(26.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.805),(26.225,16.975),(26.395,16.975),(26.395,16.805),(26.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,36.525),(20.405,36.695),(20.575,36.695),(20.575,36.525),(20.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,36.185),(20.405,36.355),(20.575,36.355),(20.575,36.185),(20.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.285),(44.405,7.455),(44.575,7.455),(44.575,7.285),(44.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,28.025),(64.115,28.195),(64.285,28.195),(64.285,28.025),(64.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,28.025),(64.625,28.195),(64.795,28.195),(64.795,28.025),(64.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,28.705),(64.115,28.875),(64.285,28.875),(64.285,28.705),(64.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,28.705),(64.625,28.875),(64.795,28.875),(64.795,28.705),(64.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.545),(49.205,3.715),(49.375,3.715),(49.375,3.545),(49.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.545),(49.715,3.715),(49.885,3.715),(49.885,3.545),(49.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,39.925),(15.605,40.095),(15.775,40.095),(15.775,39.925),(15.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.305),(6.515,8.475),(6.685,8.475),(6.685,8.305),(6.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.645),(6.515,8.815),(6.685,8.815),(6.685,8.645),(6.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,27.345),(16.625,27.515),(16.795,27.515),(16.795,27.345),(16.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,27.685),(16.115,27.855),(16.285,27.855),(16.285,27.685),(16.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.685),(6.515,10.855),(6.685,10.855),(6.685,10.685),(6.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.005),(6.515,10.175),(6.685,10.175),(6.685,10.005),(6.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.345),(6.515,10.515),(6.685,10.515),(6.685,10.345),(6.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.245),(40.115,5.415),(40.285,5.415),(40.285,5.245),(40.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.245),(40.625,5.415),(40.795,5.415),(40.795,5.245),(40.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,30.065),(82.805,30.235),(82.975,30.235),(82.975,30.065),(82.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,30.745),(82.805,30.915),(82.975,30.915),(82.975,30.745),(82.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,37.885),(83.315,38.055),(83.485,38.055),(83.485,37.885),(83.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.445),(16.625,15.615),(16.795,15.615),(16.795,15.445),(16.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.145),(30.515,17.315),(30.685,17.315),(30.685,17.145),(30.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.825),(30.515,17.995),(30.685,17.995),(30.685,17.825),(30.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.885),(11.315,4.055),(11.485,4.055),(11.485,3.885),(11.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.585),(50.225,5.755),(50.395,5.755),(50.395,5.585),(50.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.785),(7.025,15.955),(7.195,15.955),(7.195,15.785),(7.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.865),(50.225,37.035),(50.395,37.035),(50.395,36.865),(50.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,20.545),(25.715,20.715),(25.885,20.715),(25.885,20.545),(25.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.165),(44.915,35.335),(45.085,35.335),(45.085,35.165),(44.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.505),(44.915,35.675),(45.085,35.675),(45.085,35.505),(44.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.025),(73.715,11.195),(73.885,11.195),(73.885,11.025),(73.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.925),(34.805,40.095),(34.975,40.095),(34.975,39.925),(34.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,22.925),(25.205,23.095),(25.375,23.095),(25.375,22.925),(25.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,20.545),(6.515,20.715),(6.685,20.715),(6.685,20.545),(6.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,20.205),(6.515,20.375),(6.685,20.375),(6.685,20.205),(6.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.585),(16.115,5.755),(16.285,5.755),(16.285,5.585),(16.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.285),(30.005,7.455),(30.175,7.455),(30.175,7.285),(30.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,23.265),(16.625,23.435),(16.795,23.435),(16.795,23.265),(16.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.245),(35.315,5.415),(35.485,5.415),(35.485,5.245),(35.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.245),(35.825,5.415),(35.995,5.415),(35.995,5.245),(35.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.465),(6.515,16.635),(6.685,16.635),(6.685,16.465),(6.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.585),(35.315,5.755),(35.485,5.755),(35.485,5.585),(35.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.585),(35.825,5.755),(35.995,5.755),(35.995,5.585),(35.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,36.525),(16.115,36.695),(16.285,36.695),(16.285,36.525),(16.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,36.185),(16.115,36.355),(16.285,36.355),(16.285,36.185),(16.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.285),(64.115,7.455),(64.285,7.455),(64.285,7.285),(64.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.285),(64.625,7.455),(64.795,7.455),(64.795,7.285),(64.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.925),(58.805,6.095),(58.975,6.095),(58.975,5.925),(58.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,24.285),(83.315,24.455),(83.485,24.455),(83.485,24.285),(83.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,24.625),(83.315,24.795),(83.485,24.795),(83.485,24.625),(83.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,30.405),(68.405,30.575),(68.575,30.575),(68.575,30.405),(68.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,30.065),(68.405,30.235),(68.575,30.235),(68.575,30.065),(68.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,30.745),(68.405,30.915),(68.575,30.915),(68.575,30.745),(68.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,29.045),(73.205,29.215),(73.375,29.215),(73.375,29.045),(73.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,29.385),(73.205,29.555),(73.375,29.555),(73.375,29.385),(73.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,29.385),(73.715,29.555),(73.885,29.555),(73.885,29.385),(73.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,29.725),(73.205,29.895),(73.375,29.895),(73.375,29.725),(73.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,29.725),(73.715,29.895),(73.885,29.895),(73.885,29.725),(73.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,29.045),(73.715,29.215),(73.885,29.215),(73.885,29.045),(73.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.485),(25.715,17.655),(25.885,17.655),(25.885,17.485),(25.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.925),(34.805,6.095),(34.975,6.095),(34.975,5.925),(34.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.805),(34.805,33.975),(34.975,33.975),(34.975,33.805),(34.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.125),(34.805,33.295),(34.975,33.295),(34.975,33.125),(34.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.465),(34.805,33.635),(34.975,33.635),(34.975,33.465),(34.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.345),(54.515,10.515),(54.685,10.515),(54.685,10.345),(54.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.005),(54.515,10.175),(54.685,10.175),(54.685,10.005),(54.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.685),(54.515,10.855),(54.685,10.855),(54.685,10.685),(54.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.145),(63.605,17.315),(63.775,17.315),(63.775,17.145),(63.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.485),(63.605,17.655),(63.775,17.655),(63.775,17.485),(63.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.825),(63.605,17.995),(63.775,17.995),(63.775,17.825),(63.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.345),(35.825,10.515),(35.995,10.515),(35.995,10.345),(35.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.345),(35.315,10.515),(35.485,10.515),(35.485,10.345),(35.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.685),(35.315,10.855),(35.485,10.855),(35.485,10.685),(35.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.685),(35.825,10.855),(35.995,10.855),(35.995,10.685),(35.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.005),(35.315,10.175),(35.485,10.175),(35.485,10.005),(35.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.005),(35.825,10.175),(35.995,10.175),(35.995,10.005),(35.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.985),(7.025,9.155),(7.195,9.155),(7.195,8.985),(7.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,30.065),(25.205,30.235),(25.375,30.235),(25.375,30.065),(25.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,30.405),(25.205,30.575),(25.375,30.575),(25.375,30.405),(25.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,30.745),(25.205,30.915),(25.375,30.915),(25.375,30.745),(25.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.505),(30.515,18.675),(30.685,18.675),(30.685,18.505),(30.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.425),(50.225,14.595),(50.395,14.595),(50.395,14.425),(50.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,30.745),(11.825,30.915),(11.995,30.915),(11.995,30.745),(11.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,30.065),(11.825,30.235),(11.995,30.235),(11.995,30.065),(11.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,30.405),(11.825,30.575),(11.995,30.575),(11.995,30.405),(11.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.245),(11.315,5.415),(11.485,5.415),(11.485,5.245),(11.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.225),(31.025,38.395),(31.195,38.395),(31.195,38.225),(31.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.905),(44.405,39.075),(44.575,39.075),(44.575,38.905),(44.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,25.985),(78.005,26.155),(78.175,26.155),(78.175,25.985),(78.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,25.985),(78.515,26.155),(78.685,26.155),(78.685,25.985),(78.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.165),(68.915,18.335),(69.085,18.335),(69.085,18.165),(68.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.085),(31.025,14.255),(31.195,14.255),(31.195,14.085),(31.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.765),(31.025,14.935),(31.195,14.935),(31.195,14.765),(31.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.305),(69.425,8.475),(69.595,8.475),(69.595,8.305),(69.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.645),(69.425,8.815),(69.595,8.815),(69.595,8.645),(69.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.565),(16.115,4.735),(16.285,4.735),(16.285,4.565),(16.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.585),(44.405,22.755),(44.575,22.755),(44.575,22.585),(44.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,25.645),(16.115,25.815),(16.285,25.815),(16.285,25.645),(16.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,25.305),(16.115,25.475),(16.285,25.475),(16.285,25.305),(16.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,39.925),(21.425,40.095),(21.595,40.095),(21.595,39.925),(21.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,40.265),(7.025,40.435),(7.195,40.435),(7.195,40.265),(7.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.585),(44.915,5.755),(45.085,5.755),(45.085,5.585),(44.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.205),(20.405,3.375),(20.575,3.375),(20.575,3.205),(20.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.285),(39.605,7.455),(39.775,7.455),(39.775,7.285),(39.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,21.565),(73.205,21.735),(73.375,21.735),(73.375,21.565),(73.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,21.565),(73.715,21.735),(73.885,21.735),(73.885,21.565),(73.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.425),(20.405,14.595),(20.575,14.595),(20.575,14.425),(20.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.985),(82.805,9.155),(82.975,9.155),(82.975,8.985),(82.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,30.405),(6.515,30.575),(6.685,30.575),(6.685,30.405),(6.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.225),(15.605,4.395),(15.775,4.395),(15.775,4.225),(15.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.565),(15.605,4.735),(15.775,4.735),(15.775,4.565),(15.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.905),(45.425,39.075),(45.595,39.075),(45.595,38.905),(45.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.565),(55.025,38.735),(55.195,38.735),(55.195,38.565),(55.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.105),(11.825,15.275),(11.995,15.275),(11.995,15.105),(11.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.445),(11.825,15.615),(11.995,15.615),(11.995,15.445),(11.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,22.585),(74.225,22.755),(74.395,22.755),(74.395,22.585),(74.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,26.665),(44.405,26.835),(44.575,26.835),(44.575,26.665),(44.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,27.345),(7.025,27.515),(7.195,27.515),(7.195,27.345),(7.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.905),(45.425,5.075),(45.595,5.075),(45.595,4.905),(45.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.905),(30.515,39.075),(30.685,39.075),(30.685,38.905),(30.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.405),(44.405,30.575),(44.575,30.575),(44.575,30.405),(44.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,34.825),(16.625,34.995),(16.795,34.995),(16.795,34.825),(16.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,29.725),(74.225,29.895),(74.395,29.895),(74.395,29.725),(74.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,29.045),(74.225,29.215),(74.395,29.215),(74.395,29.045),(74.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,34.485),(16.625,34.655),(16.795,34.655),(16.795,34.485),(16.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,40.605),(82.805,40.775),(82.975,40.775),(82.975,40.605),(82.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,34.145),(16.625,34.315),(16.795,34.315),(16.795,34.145),(16.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,37.545),(6.515,37.715),(6.685,37.715),(6.685,37.545),(6.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,27.685),(11.315,27.855),(11.485,27.855),(11.485,27.685),(11.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,33.125),(68.405,33.295),(68.575,33.295),(68.575,33.125),(68.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,33.465),(68.405,33.635),(68.575,33.635),(68.575,33.465),(68.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,33.805),(68.405,33.975),(68.575,33.975),(68.575,33.805),(68.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,20.885),(68.915,21.055),(69.085,21.055),(69.085,20.885),(68.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,40.265),(40.115,40.435),(40.285,40.435),(40.285,40.265),(40.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,40.265),(40.625,40.435),(40.795,40.435),(40.795,40.265),(40.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.545),(44.915,37.715),(45.085,37.715),(45.085,37.545),(44.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,34.145),(74.225,34.315),(74.395,34.315),(74.395,34.145),(74.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,34.485),(74.225,34.655),(74.395,34.655),(74.395,34.485),(74.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,34.825),(74.225,34.995),(74.395,34.995),(74.395,34.825),(74.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.285),(20.915,7.455),(21.085,7.455),(21.085,7.285),(20.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.585),(64.115,5.755),(64.285,5.755),(64.285,5.585),(64.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.585),(64.625,5.755),(64.795,5.755),(64.795,5.585),(64.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.965),(25.205,8.135),(25.375,8.135),(25.375,7.965),(25.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,27.005),(68.405,27.175),(68.575,27.175),(68.575,27.005),(68.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.285),(78.005,7.455),(78.175,7.455),(78.175,7.285),(78.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.285),(78.515,7.455),(78.685,7.455),(78.685,7.285),(78.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.945),(79.025,7.115),(79.195,7.115),(79.195,6.945),(79.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,28.025),(82.805,28.195),(82.975,28.195),(82.975,28.025),(82.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,28.365),(82.805,28.535),(82.975,28.535),(82.975,28.365),(82.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,28.705),(82.805,28.875),(82.975,28.875),(82.975,28.705),(82.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.285),(44.915,7.455),(45.085,7.455),(45.085,7.285),(44.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,37.545),(30.005,37.715),(30.175,37.715),(30.175,37.545),(30.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,33.805),(30.005,33.975),(30.175,33.975),(30.175,33.805),(30.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,33.125),(30.005,33.295),(30.175,33.295),(30.175,33.125),(30.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,33.465),(30.005,33.635),(30.175,33.635),(30.175,33.465),(30.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,39.925),(69.425,40.095),(69.595,40.095),(69.595,39.925),(69.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.545),(59.315,37.715),(59.485,37.715),(59.485,37.545),(59.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,37.545),(59.825,37.715),(59.995,37.715),(59.995,37.545),(59.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.065),(26.225,13.235),(26.395,13.235),(26.395,13.065),(26.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.745),(26.225,13.915),(26.395,13.915),(26.395,13.745),(26.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,28.365),(21.425,28.535),(21.595,28.535),(21.595,28.365),(21.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,28.705),(21.425,28.875),(21.595,28.875),(21.595,28.705),(21.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,28.025),(21.425,28.195),(21.595,28.195),(21.595,28.025),(21.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.325),(30.515,9.495),(30.685,9.495),(30.685,9.325),(30.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.665),(30.515,9.835),(30.685,9.835),(30.685,9.665),(30.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.685),(40.115,27.855),(40.285,27.855),(40.285,27.685),(40.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.685),(40.625,27.855),(40.795,27.855),(40.795,27.685),(40.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.965),(49.205,8.135),(49.375,8.135),(49.375,7.965),(49.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.965),(49.715,8.135),(49.885,8.135),(49.885,7.965),(49.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.085),(79.025,14.255),(79.195,14.255),(79.195,14.085),(79.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.765),(79.025,14.935),(79.195,14.935),(79.195,14.765),(79.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.385),(68.405,12.555),(68.575,12.555),(68.575,12.385),(68.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.305),(50.225,8.475),(50.395,8.475),(50.395,8.305),(50.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.145),(49.205,34.315),(49.375,34.315),(49.375,34.145),(49.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.145),(49.715,34.315),(49.885,34.315),(49.885,34.145),(49.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.825),(49.205,34.995),(49.375,34.995),(49.375,34.825),(49.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.485),(49.205,34.655),(49.375,34.655),(49.375,34.485),(49.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.485),(49.715,34.655),(49.885,34.655),(49.885,34.485),(49.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.825),(49.715,34.995),(49.885,34.995),(49.885,34.825),(49.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.965),(68.405,8.135),(68.575,8.135),(68.575,7.965),(68.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.585),(30.515,5.755),(30.685,5.755),(30.685,5.585),(30.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,21.905),(20.405,22.075),(20.575,22.075),(20.575,21.905),(20.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,39.245),(16.115,39.415),(16.285,39.415),(16.285,39.245),(16.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.425),(30.005,14.595),(30.175,14.595),(30.175,14.425),(30.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.185),(78.005,19.355),(78.175,19.355),(78.175,19.185),(78.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.185),(78.515,19.355),(78.685,19.355),(78.685,19.185),(78.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.525),(78.005,19.695),(78.175,19.695),(78.175,19.525),(78.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.525),(78.515,19.695),(78.685,19.695),(78.685,19.525),(78.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,26.325),(83.315,26.495),(83.485,26.495),(83.485,26.325),(83.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,26.665),(83.315,26.835),(83.485,26.835),(83.485,26.665),(83.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,23.945),(26.225,24.115),(26.395,24.115),(26.395,23.945),(26.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.945),(26.225,7.115),(26.395,7.115),(26.395,6.945),(26.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.445),(15.605,15.615),(15.775,15.615),(15.775,15.445),(15.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.125),(82.805,16.295),(82.975,16.295),(82.975,16.125),(82.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.465),(82.805,16.635),(82.975,16.635),(82.975,16.465),(82.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.805),(82.805,16.975),(82.975,16.975),(82.975,16.805),(82.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.425),(64.625,14.595),(64.795,14.595),(64.795,14.425),(64.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.085),(58.805,14.255),(58.975,14.255),(58.975,14.085),(58.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.765),(58.805,14.935),(58.975,14.935),(58.975,14.765),(58.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.425),(58.805,14.595),(58.975,14.595),(58.975,14.425),(58.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,20.885),(69.425,21.055),(69.595,21.055),(69.595,20.885),(69.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,20.885),(63.605,21.055),(63.775,21.055),(63.775,20.885),(63.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.105),(54.515,15.275),(54.685,15.275),(54.685,15.105),(54.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.445),(54.005,15.615),(54.175,15.615),(54.175,15.445),(54.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.245),(40.115,39.415),(40.285,39.415),(40.285,39.245),(40.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.245),(40.625,39.415),(40.795,39.415),(40.795,39.245),(40.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.185),(16.625,19.355),(16.795,19.355),(16.795,19.185),(16.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,23.605),(83.315,23.775),(83.485,23.775),(83.485,23.605),(83.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.905),(69.425,5.075),(69.595,5.075),(69.595,4.905),(69.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,22.585),(69.425,22.755),(69.595,22.755),(69.595,22.585),(69.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.945),(35.315,24.115),(35.485,24.115),(35.485,23.945),(35.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.945),(35.825,24.115),(35.995,24.115),(35.995,23.945),(35.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,37.545),(21.425,37.715),(21.595,37.715),(21.595,37.545),(21.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.025),(54.515,11.195),(54.685,11.195),(54.685,11.025),(54.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.705),(54.515,11.875),(54.685,11.875),(54.685,11.705),(54.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.365),(54.005,11.535),(54.175,11.535),(54.175,11.365),(54.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.945),(34.805,24.115),(34.975,24.115),(34.975,23.945),(34.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.945),(40.625,7.115),(40.795,7.115),(40.795,6.945),(40.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,35.845),(68.405,36.015),(68.575,36.015),(68.575,35.845),(68.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,28.705),(16.115,28.875),(16.285,28.875),(16.285,28.705),(16.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,28.025),(16.115,28.195),(16.285,28.195),(16.285,28.025),(16.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,38.225),(11.825,38.395),(11.995,38.395),(11.995,38.225),(11.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.285),(49.205,7.455),(49.375,7.455),(49.375,7.285),(49.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.285),(49.715,7.455),(49.885,7.455),(49.885,7.285),(49.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.305),(58.805,25.475),(58.975,25.475),(58.975,25.305),(58.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.925),(69.425,6.095),(69.595,6.095),(69.595,5.925),(69.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.305),(40.115,25.475),(40.285,25.475),(40.285,25.305),(40.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.305),(40.625,25.475),(40.795,25.475),(40.795,25.305),(40.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,37.205),(78.515,37.375),(78.685,37.375),(78.685,37.205),(78.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,37.205),(78.005,37.375),(78.175,37.375),(78.175,37.205),(78.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,23.945),(11.315,24.115),(11.485,24.115),(11.485,23.945),(11.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.325),(49.205,9.495),(49.375,9.495),(49.375,9.325),(49.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.325),(49.715,9.495),(49.885,9.495),(49.885,9.325),(49.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.925),(21.425,6.095),(21.595,6.095),(21.595,5.925),(21.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.505),(34.805,18.675),(34.975,18.675),(34.975,18.505),(34.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,20.885),(11.825,21.055),(11.995,21.055),(11.995,20.885),(11.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.225),(59.315,21.395),(59.485,21.395),(59.485,21.225),(59.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,21.225),(59.825,21.395),(59.995,21.395),(59.995,21.225),(59.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.225),(59.315,4.395),(59.485,4.395),(59.485,4.225),(59.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.225),(59.825,4.395),(59.995,4.395),(59.995,4.225),(59.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.485),(73.205,17.655),(73.375,17.655),(73.375,17.485),(73.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.485),(73.715,17.655),(73.885,17.655),(73.885,17.485),(73.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.485),(34.805,17.655),(34.975,17.655),(34.975,17.485),(34.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.825),(34.805,17.995),(34.975,17.995),(34.975,17.825),(34.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.145),(34.805,17.315),(34.975,17.315),(34.975,17.145),(34.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.625),(21.425,7.795),(21.595,7.795),(21.595,7.625),(21.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.245),(25.715,5.415),(25.885,5.415),(25.885,5.245),(25.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.585),(25.715,5.755),(25.885,5.755),(25.885,5.585),(25.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.885),(39.605,4.055),(39.775,4.055),(39.775,3.885),(39.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.365),(26.225,11.535),(26.395,11.535),(26.395,11.365),(26.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.425),(44.405,14.595),(44.575,14.595),(44.575,14.425),(44.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.545),(50.225,37.715),(50.395,37.715),(50.395,37.545),(50.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.065),(74.225,13.235),(74.395,13.235),(74.395,13.065),(74.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.745),(74.225,13.915),(74.395,13.915),(74.395,13.745),(74.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,24.965),(20.405,25.135),(20.575,25.135),(20.575,24.965),(20.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.825),(6.515,17.995),(6.685,17.995),(6.685,17.825),(6.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.145),(6.515,17.315),(6.685,17.315),(6.685,17.145),(6.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.485),(6.515,17.655),(6.685,17.655),(6.685,17.485),(6.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.865),(44.405,20.035),(44.575,20.035),(44.575,19.865),(44.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,26.325),(68.915,26.495),(69.085,26.495),(69.085,26.325),(68.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,2.865),(74.225,3.035),(74.395,3.035),(74.395,2.865),(74.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.585),(49.205,5.755),(49.375,5.755),(49.375,5.585),(49.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.585),(49.715,5.755),(49.885,5.755),(49.885,5.585),(49.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,24.285),(30.005,24.455),(30.175,24.455),(30.175,24.285),(30.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.365),(68.405,11.535),(68.575,11.535),(68.575,11.365),(68.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.645),(79.025,8.815),(79.195,8.815),(79.195,8.645),(79.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,29.045),(83.315,29.215),(83.485,29.215),(83.485,29.045),(83.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,29.385),(83.315,29.555),(83.485,29.555),(83.485,29.385),(83.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,29.725),(83.315,29.895),(83.485,29.895),(83.485,29.725),(83.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,39.585),(25.205,39.755),(25.375,39.755),(25.375,39.585),(25.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.785),(82.805,15.955),(82.975,15.955),(82.975,15.785),(82.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,2.865),(25.715,3.035),(25.885,3.035),(25.885,2.865),(25.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.845),(68.405,19.015),(68.575,19.015),(68.575,18.845),(68.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,20.545),(30.005,20.715),(30.175,20.715),(30.175,20.545),(30.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.445),(25.715,15.615),(25.885,15.615),(25.885,15.445),(25.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.105),(25.715,15.275),(25.885,15.275),(25.885,15.105),(25.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.845),(78.005,19.015),(78.175,19.015),(78.175,18.845),(78.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.845),(78.515,19.015),(78.685,19.015),(78.685,18.845),(78.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,30.065),(78.005,30.235),(78.175,30.235),(78.175,30.065),(78.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,30.065),(78.515,30.235),(78.685,30.235),(78.685,30.065),(78.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,30.405),(78.005,30.575),(78.175,30.575),(78.175,30.405),(78.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,30.405),(78.515,30.575),(78.685,30.575),(78.685,30.405),(78.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,30.745),(78.005,30.915),(78.175,30.915),(78.175,30.745),(78.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,30.745),(78.515,30.915),(78.685,30.915),(78.685,30.745),(78.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.925),(39.605,6.095),(39.775,6.095),(39.775,5.925),(39.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.305),(58.805,8.475),(58.975,8.475),(58.975,8.305),(58.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,40.605),(31.025,40.775),(31.195,40.775),(31.195,40.605),(31.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,2.865),(82.805,3.035),(82.975,3.035),(82.975,2.865),(82.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,26.665),(16.115,26.835),(16.285,26.835),(16.285,26.665),(16.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,26.325),(16.115,26.495),(16.285,26.495),(16.285,26.325),(16.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,33.125),(79.025,33.295),(79.195,33.295),(79.195,33.125),(79.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,33.465),(79.025,33.635),(79.195,33.635),(79.195,33.465),(79.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,33.805),(79.025,33.975),(79.195,33.975),(79.195,33.805),(79.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,23.945),(68.915,24.115),(69.085,24.115),(69.085,23.945),(68.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,26.665),(78.005,26.835),(78.175,26.835),(78.175,26.665),(78.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,26.665),(78.515,26.835),(78.685,26.835),(78.685,26.665),(78.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.005),(34.805,27.175),(34.975,27.175),(34.975,27.005),(34.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.705),(40.625,11.875),(40.795,11.875),(40.795,11.705),(40.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.025),(40.115,11.195),(40.285,11.195),(40.285,11.025),(40.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.025),(40.625,11.195),(40.795,11.195),(40.795,11.025),(40.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.425),(15.605,14.595),(15.775,14.595),(15.775,14.425),(15.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.705),(40.115,11.875),(40.285,11.875),(40.285,11.705),(40.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.705),(49.715,11.875),(49.885,11.875),(49.885,11.705),(49.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.025),(49.205,11.195),(49.375,11.195),(49.375,11.025),(49.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.025),(49.715,11.195),(49.885,11.195),(49.885,11.025),(49.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.705),(49.205,11.875),(49.375,11.875),(49.375,11.705),(49.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.985),(63.605,9.155),(63.775,9.155),(63.775,8.985),(63.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,26.665),(49.715,26.835),(49.885,26.835),(49.885,26.665),(49.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,26.325),(49.205,26.495),(49.375,26.495),(49.375,26.325),(49.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,26.325),(49.715,26.495),(49.885,26.495),(49.885,26.325),(49.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,26.665),(49.205,26.835),(49.375,26.835),(49.375,26.665),(49.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.225),(54.005,21.395),(54.175,21.395),(54.175,21.225),(54.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.565),(54.005,21.735),(54.175,21.735),(54.175,21.565),(54.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.385),(82.805,12.555),(82.975,12.555),(82.975,12.385),(82.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.725),(82.805,12.895),(82.975,12.895),(82.975,12.725),(82.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.045),(82.805,12.215),(82.975,12.215),(82.975,12.045),(82.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.185),(7.025,19.355),(7.195,19.355),(7.195,19.185),(7.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.525),(7.025,19.695),(7.195,19.695),(7.195,19.525),(7.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.165),(79.025,18.335),(79.195,18.335),(79.195,18.165),(79.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.505),(79.025,18.675),(79.195,18.675),(79.195,18.505),(79.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,22.245),(78.005,22.415),(78.175,22.415),(78.175,22.245),(78.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,22.245),(78.515,22.415),(78.685,22.415),(78.685,22.245),(78.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.945),(30.515,24.115),(30.685,24.115),(30.685,23.945),(30.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,26.665),(44.915,26.835),(45.085,26.835),(45.085,26.665),(44.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,35.505),(16.625,35.675),(16.795,35.675),(16.795,35.505),(16.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,35.165),(16.625,35.335),(16.795,35.335),(16.795,35.165),(16.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.585),(82.805,5.755),(82.975,5.755),(82.975,5.585),(82.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.245),(82.805,5.415),(82.975,5.415),(82.975,5.245),(82.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.125),(64.115,16.295),(64.285,16.295),(64.285,16.125),(64.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.125),(64.625,16.295),(64.795,16.295),(64.795,16.125),(64.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.805),(64.115,16.975),(64.285,16.975),(64.285,16.805),(64.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.805),(64.625,16.975),(64.795,16.975),(64.795,16.805),(64.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.845),(39.605,36.015),(39.775,36.015),(39.775,35.845),(39.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,36.525),(25.715,36.695),(25.885,36.695),(25.885,36.525),(25.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,36.185),(25.715,36.355),(25.885,36.355),(25.885,36.185),(25.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.945),(83.315,7.115),(83.485,7.115),(83.485,6.945),(83.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.865),(30.515,20.035),(30.685,20.035),(30.685,19.865),(30.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.845),(44.915,19.015),(45.085,19.015),(45.085,18.845),(44.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,26.665),(59.315,26.835),(59.485,26.835),(59.485,26.665),(59.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,26.665),(59.825,26.835),(59.995,26.835),(59.995,26.665),(59.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.965),(83.315,8.135),(83.485,8.135),(83.485,7.965),(83.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.225),(45.425,21.395),(45.595,21.395),(45.595,21.225),(45.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,37.545),(63.605,37.715),(63.775,37.715),(63.775,37.545),(63.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,26.325),(82.805,26.495),(82.975,26.495),(82.975,26.325),(82.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.205),(58.805,3.375),(58.975,3.375),(58.975,3.205),(58.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.525),(83.315,19.695),(83.485,19.695),(83.485,19.525),(83.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,22.925),(26.225,23.095),(26.395,23.095),(26.395,22.925),(26.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,22.245),(10.805,22.415),(10.975,22.415),(10.975,22.245),(10.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.225),(73.205,4.395),(73.375,4.395),(73.375,4.225),(73.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.225),(73.715,4.395),(73.885,4.395),(73.885,4.225),(73.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.565),(73.205,4.735),(73.375,4.735),(73.375,4.565),(73.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.565),(73.715,4.735),(73.885,4.735),(73.885,4.565),(73.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,25.305),(11.315,25.475),(11.485,25.475),(11.485,25.305),(11.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.225),(25.205,4.395),(25.375,4.395),(25.375,4.225),(25.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,37.205),(11.315,37.375),(11.485,37.375),(11.485,37.205),(11.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,37.205),(11.825,37.375),(11.995,37.375),(11.995,37.205),(11.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.265),(31.025,6.435),(31.195,6.435),(31.195,6.265),(31.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,24.285),(16.625,24.455),(16.795,24.455),(16.795,24.285),(16.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,30.065),(26.225,30.235),(26.395,30.235),(26.395,30.065),(26.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,30.745),(26.225,30.915),(26.395,30.915),(26.395,30.745),(26.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.345),(55.025,10.515),(55.195,10.515),(55.195,10.345),(55.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,37.545),(20.915,37.715),(21.085,37.715),(21.085,37.545),(20.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.225),(44.915,38.395),(45.085,38.395),(45.085,38.225),(44.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.665),(40.115,9.835),(40.285,9.835),(40.285,9.665),(40.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.665),(40.625,9.835),(40.795,9.835),(40.795,9.665),(40.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.965),(11.825,8.135),(11.995,8.135),(11.995,7.965),(11.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.245),(34.805,22.415),(34.975,22.415),(34.975,22.245),(34.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.585),(34.805,22.755),(34.975,22.755),(34.975,22.585),(34.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.085),(64.115,14.255),(64.285,14.255),(64.285,14.085),(64.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.265),(20.915,6.435),(21.085,6.435),(21.085,6.265),(20.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.185),(39.605,36.355),(39.775,36.355),(39.775,36.185),(39.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.525),(39.605,36.695),(39.775,36.695),(39.775,36.525),(39.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.005),(34.805,10.175),(34.975,10.175),(34.975,10.005),(34.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.685),(34.805,10.855),(34.975,10.855),(34.975,10.685),(34.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.965),(58.805,25.135),(58.975,25.135),(58.975,24.965),(58.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,2.865),(73.205,3.035),(73.375,3.035),(73.375,2.865),(73.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,2.865),(73.715,3.035),(73.885,3.035),(73.885,2.865),(73.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.685),(54.005,27.855),(54.175,27.855),(54.175,27.685),(54.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.025),(35.825,11.195),(35.995,11.195),(35.995,11.025),(35.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.705),(35.315,11.875),(35.485,11.875),(35.485,11.705),(35.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.025),(35.315,11.195),(35.485,11.195),(35.485,11.025),(35.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.705),(35.825,11.875),(35.995,11.875),(35.995,11.705),(35.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.625),(54.515,7.795),(54.685,7.795),(54.685,7.625),(54.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,38.905),(73.205,39.075),(73.375,39.075),(73.375,38.905),(73.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,38.905),(73.715,39.075),(73.885,39.075),(73.885,38.905),(73.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.785),(73.715,15.955),(73.885,15.955),(73.885,15.785),(73.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.785),(73.205,15.955),(73.375,15.955),(73.375,15.785),(73.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,40.265),(30.515,40.435),(30.685,40.435),(30.685,40.265),(30.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,31.085),(83.315,31.255),(83.485,31.255),(83.485,31.085),(83.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,31.765),(83.315,31.935),(83.485,31.935),(83.485,31.765),(83.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,38.225),(6.515,38.395),(6.685,38.395),(6.685,38.225),(6.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,31.425),(83.315,31.595),(83.485,31.595),(83.485,31.425),(83.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.525),(20.915,19.695),(21.085,19.695),(21.085,19.525),(20.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.405),(10.805,13.575),(10.975,13.575),(10.975,13.405),(10.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.165),(30.515,35.335),(30.685,35.335),(30.685,35.165),(30.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.505),(30.515,35.675),(30.685,35.675),(30.685,35.505),(30.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,39.925),(78.005,40.095),(78.175,40.095),(78.175,39.925),(78.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,39.925),(78.515,40.095),(78.685,40.095),(78.685,39.925),(78.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.545),(45.425,20.715),(45.595,20.715),(45.595,20.545),(45.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,34.145),(69.425,34.315),(69.595,34.315),(69.595,34.145),(69.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,34.485),(69.425,34.655),(69.595,34.655),(69.595,34.485),(69.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,34.825),(69.425,34.995),(69.595,34.995),(69.595,34.825),(69.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,36.525),(79.025,36.695),(79.195,36.695),(79.195,36.525),(79.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,36.185),(79.025,36.355),(79.195,36.355),(79.195,36.185),(79.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,20.545),(16.625,20.715),(16.795,20.715),(16.795,20.545),(16.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,23.265),(11.825,23.435),(11.995,23.435),(11.995,23.265),(11.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.005),(68.915,10.175),(69.085,10.175),(69.085,10.005),(68.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.685),(68.915,10.855),(69.085,10.855),(69.085,10.685),(68.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.545),(59.315,20.715),(59.485,20.715),(59.485,20.545),(59.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,20.545),(59.825,20.715),(59.995,20.715),(59.995,20.545),(59.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.945),(59.315,7.115),(59.485,7.115),(59.485,6.945),(59.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.165),(31.025,18.335),(31.195,18.335),(31.195,18.165),(31.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.505),(31.025,18.675),(31.195,18.675),(31.195,18.505),(31.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.945),(59.825,7.115),(59.995,7.115),(59.995,6.945),(59.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.885),(34.805,4.055),(34.975,4.055),(34.975,3.885),(34.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.365),(21.425,11.535),(21.595,11.535),(21.595,11.365),(21.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.705),(40.115,28.875),(40.285,28.875),(40.285,28.705),(40.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.705),(40.625,28.875),(40.795,28.875),(40.795,28.705),(40.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.025),(40.115,28.195),(40.285,28.195),(40.285,28.025),(40.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.025),(40.625,28.195),(40.795,28.195),(40.795,28.025),(40.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.365),(40.115,28.535),(40.285,28.535),(40.285,28.365),(40.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.365),(40.625,28.535),(40.795,28.535),(40.795,28.365),(40.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,24.285),(79.025,24.455),(79.195,24.455),(79.195,24.285),(79.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.625),(30.005,7.795),(30.175,7.795),(30.175,7.625),(30.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.905),(49.205,39.075),(49.375,39.075),(49.375,38.905),(49.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.905),(49.715,39.075),(49.885,39.075),(49.885,38.905),(49.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,35.505),(25.715,35.675),(25.885,35.675),(25.885,35.505),(25.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,35.165),(25.715,35.335),(25.885,35.335),(25.885,35.165),(25.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.165),(54.005,35.335),(54.175,35.335),(54.175,35.165),(54.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.505),(54.005,35.675),(54.175,35.675),(54.175,35.505),(54.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.225),(6.515,4.395),(6.685,4.395),(6.685,4.225),(6.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.565),(6.515,4.735),(6.685,4.735),(6.685,4.565),(6.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.325),(50.225,9.495),(50.395,9.495),(50.395,9.325),(50.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.665),(50.225,9.835),(50.395,9.835),(50.395,9.665),(50.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,29.045),(79.025,29.215),(79.195,29.215),(79.195,29.045),(79.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,29.725),(79.025,29.895),(79.195,29.895),(79.195,29.725),(79.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,28.025),(79.025,28.195),(79.195,28.195),(79.195,28.025),(79.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,28.705),(79.025,28.875),(79.195,28.875),(79.195,28.705),(79.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.285),(45.425,24.455),(45.595,24.455),(45.595,24.285),(45.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,36.865),(20.405,37.035),(20.575,37.035),(20.575,36.865),(20.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.405),(54.005,13.575),(54.175,13.575),(54.175,13.405),(54.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.745),(54.515,13.915),(54.685,13.915),(54.685,13.745),(54.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,24.625),(69.425,24.795),(69.595,24.795),(69.595,24.625),(69.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.985),(54.515,26.155),(54.685,26.155),(54.685,25.985),(54.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.405),(6.515,13.575),(6.685,13.575),(6.685,13.405),(6.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.985),(6.515,9.155),(6.685,9.155),(6.685,8.985),(6.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.185),(73.205,19.355),(73.375,19.355),(73.375,19.185),(73.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.185),(73.715,19.355),(73.885,19.355),(73.885,19.185),(73.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,27.005),(82.805,27.175),(82.975,27.175),(82.975,27.005),(82.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,27.345),(82.805,27.515),(82.975,27.515),(82.975,27.345),(82.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.225),(40.115,38.395),(40.285,38.395),(40.285,38.225),(40.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.225),(40.625,38.395),(40.795,38.395),(40.795,38.225),(40.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.985),(20.915,9.155),(21.085,9.155),(21.085,8.985),(20.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,28.705),(69.425,28.875),(69.595,28.875),(69.595,28.705),(69.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,28.025),(69.425,28.195),(69.595,28.195),(69.595,28.025),(69.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.365),(59.315,28.535),(59.485,28.535),(59.485,28.365),(59.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,28.365),(59.825,28.535),(59.995,28.535),(59.995,28.365),(59.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.505),(15.605,18.675),(15.775,18.675),(15.775,18.505),(15.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.465),(79.025,16.635),(79.195,16.635),(79.195,16.465),(79.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,37.205),(83.315,37.375),(83.485,37.375),(83.485,37.205),(83.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.225),(30.005,4.395),(30.175,4.395),(30.175,4.225),(30.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.425),(34.805,31.595),(34.975,31.595),(34.975,31.425),(34.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.185),(35.315,36.355),(35.485,36.355),(35.485,36.185),(35.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.185),(35.825,36.355),(35.995,36.355),(35.995,36.185),(35.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.525),(35.315,36.695),(35.485,36.695),(35.485,36.525),(35.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.525),(35.825,36.695),(35.995,36.695),(35.995,36.525),(35.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.625),(39.605,7.795),(39.775,7.795),(39.775,7.625),(39.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.645),(73.205,8.815),(73.375,8.815),(73.375,8.645),(73.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.645),(73.715,8.815),(73.885,8.815),(73.885,8.645),(73.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,2.865),(16.625,3.035),(16.795,3.035),(16.795,2.865),(16.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.245),(34.805,39.415),(34.975,39.415),(34.975,39.245),(34.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.305),(25.715,8.475),(25.885,8.475),(25.885,8.305),(25.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.645),(25.715,8.815),(25.885,8.815),(25.885,8.645),(25.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.225),(58.805,4.395),(58.975,4.395),(58.975,4.225),(58.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,38.565),(16.115,38.735),(16.285,38.735),(16.285,38.565),(16.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.565),(34.805,4.735),(34.975,4.735),(34.975,4.565),(34.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,20.885),(6.515,21.055),(6.685,21.055),(6.685,20.885),(6.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.565),(54.005,4.735),(54.175,4.735),(54.175,4.565),(54.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.225),(54.515,4.395),(54.685,4.395),(54.685,4.225),(54.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.485),(20.915,17.655),(21.085,17.655),(21.085,17.485),(20.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,25.645),(30.005,25.815),(30.175,25.815),(30.175,25.645),(30.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,25.305),(30.005,25.475),(30.175,25.475),(30.175,25.305),(30.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.625),(63.605,7.795),(63.775,7.795),(63.775,7.625),(63.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,21.225),(20.915,21.395),(21.085,21.395),(21.085,21.225),(20.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,21.565),(20.915,21.735),(21.085,21.735),(21.085,21.565),(20.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,36.865),(16.115,37.035),(16.285,37.035),(16.285,36.865),(16.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,26.325),(40.115,26.495),(40.285,26.495),(40.285,26.325),(40.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,26.325),(40.625,26.495),(40.795,26.495),(40.795,26.325),(40.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.845),(54.515,36.015),(54.685,36.015),(54.685,35.845),(54.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.285),(50.225,24.455),(50.395,24.455),(50.395,24.285),(50.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.625),(50.225,24.795),(50.395,24.795),(50.395,24.625),(50.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.245),(39.605,22.415),(39.775,22.415),(39.775,22.245),(39.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.585),(39.605,22.755),(39.775,22.755),(39.775,22.585),(39.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,24.965),(83.315,25.135),(83.485,25.135),(83.485,24.965),(83.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.165),(49.205,18.335),(49.375,18.335),(49.375,18.165),(49.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.165),(49.715,18.335),(49.885,18.335),(49.885,18.165),(49.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.525),(34.805,19.695),(34.975,19.695),(34.975,19.525),(34.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.185),(34.805,19.355),(34.975,19.355),(34.975,19.185),(34.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,21.565),(6.515,21.735),(6.685,21.735),(6.685,21.565),(6.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,21.225),(6.515,21.395),(6.685,21.395),(6.685,21.225),(6.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.625),(58.805,7.795),(58.975,7.795),(58.975,7.625),(58.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.325),(11.825,9.495),(11.995,9.495),(11.995,9.325),(11.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.665),(11.825,9.835),(11.995,9.835),(11.995,9.665),(11.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.665),(11.315,9.835),(11.485,9.835),(11.485,9.665),(11.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.405),(30.515,30.575),(30.685,30.575),(30.685,30.405),(30.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.765),(59.315,31.935),(59.485,31.935),(59.485,31.765),(59.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,31.765),(59.825,31.935),(59.995,31.935),(59.995,31.765),(59.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.085),(59.315,31.255),(59.485,31.255),(59.485,31.085),(59.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,31.085),(59.825,31.255),(59.995,31.255),(59.995,31.085),(59.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.905),(31.025,39.075),(31.195,39.075),(31.195,38.905),(31.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.625),(44.915,7.795),(45.085,7.795),(45.085,7.625),(44.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.145),(82.805,17.315),(82.975,17.315),(82.975,17.145),(82.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.825),(82.805,17.995),(82.975,17.995),(82.975,17.825),(82.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.985),(69.425,9.155),(69.595,9.155),(69.595,8.985),(69.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,30.405),(83.315,30.575),(83.485,30.575),(83.485,30.405),(83.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,40.265),(16.115,40.435),(16.285,40.435),(16.285,40.265),(16.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,26.665),(30.515,26.835),(30.685,26.835),(30.685,26.665),(30.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,37.885),(74.225,38.055),(74.395,38.055),(74.395,37.885),(74.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,23.945),(68.405,24.115),(68.575,24.115),(68.575,23.945),(68.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.965),(7.025,8.135),(7.195,8.135),(7.195,7.965),(7.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.345),(82.805,10.515),(82.975,10.515),(82.975,10.345),(82.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.865),(26.225,20.035),(26.395,20.035),(26.395,19.865),(26.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,22.245),(11.315,22.415),(11.485,22.415),(11.485,22.245),(11.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.365),(69.425,11.535),(69.595,11.535),(69.595,11.365),(69.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.305),(15.605,8.475),(15.775,8.475),(15.775,8.305),(15.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.365),(44.915,11.535),(45.085,11.535),(45.085,11.365),(44.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.645),(15.605,8.815),(15.775,8.815),(15.775,8.645),(15.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.625),(39.605,24.795),(39.775,24.795),(39.775,24.625),(39.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.625),(35.315,7.795),(35.485,7.795),(35.485,7.625),(35.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.625),(35.825,7.795),(35.995,7.795),(35.995,7.625),(35.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.905),(34.805,5.075),(34.975,5.075),(34.975,4.905),(34.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,29.725),(20.405,29.895),(20.575,29.895),(20.575,29.725),(20.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,29.045),(20.405,29.215),(20.575,29.215),(20.575,29.045),(20.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.585),(39.605,39.755),(39.775,39.755),(39.775,39.585),(39.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.785),(69.425,15.955),(69.595,15.955),(69.595,15.785),(69.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.085),(69.425,14.255),(69.595,14.255),(69.595,14.085),(69.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.425),(69.425,14.595),(69.595,14.595),(69.595,14.425),(69.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.405),(34.805,13.575),(34.975,13.575),(34.975,13.405),(34.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.765),(69.425,14.935),(69.595,14.935),(69.595,14.765),(69.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.505),(44.405,18.675),(44.575,18.675),(44.575,18.505),(44.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.425),(21.425,14.595),(21.595,14.595),(21.595,14.425),(21.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.085),(21.425,14.255),(21.595,14.255),(21.595,14.085),(21.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.765),(21.425,14.935),(21.595,14.935),(21.595,14.765),(21.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,20.205),(68.915,20.375),(69.085,20.375),(69.085,20.205),(68.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,20.545),(68.915,20.715),(69.085,20.715),(69.085,20.545),(68.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.125),(16.115,16.295),(16.285,16.295),(16.285,16.125),(16.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.805),(16.115,16.975),(16.285,16.975),(16.285,16.805),(16.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.665),(58.805,9.835),(58.975,9.835),(58.975,9.665),(58.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.325),(58.805,9.495),(58.975,9.495),(58.975,9.325),(58.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,39.585),(83.315,39.755),(83.485,39.755),(83.485,39.585),(83.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.505),(82.805,18.675),(82.975,18.675),(82.975,18.505),(82.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,27.005),(83.315,27.175),(83.485,27.175),(83.485,27.005),(83.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,27.345),(83.315,27.515),(83.485,27.515),(83.485,27.345),(83.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,22.585),(20.405,22.755),(20.575,22.755),(20.575,22.585),(20.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,29.385),(15.605,29.555),(15.775,29.555),(15.775,29.385),(15.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.245),(35.315,22.415),(35.485,22.415),(35.485,22.245),(35.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.245),(35.825,22.415),(35.995,22.415),(35.995,22.245),(35.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.585),(35.315,22.755),(35.485,22.755),(35.485,22.585),(35.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.585),(35.825,22.755),(35.995,22.755),(35.995,22.585),(35.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.525),(68.915,19.695),(69.085,19.695),(69.085,19.525),(68.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.185),(68.915,19.355),(69.085,19.355),(69.085,19.185),(68.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,39.585),(11.315,39.755),(11.485,39.755),(11.485,39.585),(11.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.445),(49.205,32.615),(49.375,32.615),(49.375,32.445),(49.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.445),(49.715,32.615),(49.885,32.615),(49.885,32.445),(49.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.105),(49.205,32.275),(49.375,32.275),(49.375,32.105),(49.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.105),(49.715,32.275),(49.885,32.275),(49.885,32.105),(49.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.785),(49.205,32.955),(49.375,32.955),(49.375,32.785),(49.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.785),(49.715,32.955),(49.885,32.955),(49.885,32.785),(49.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.365),(45.425,11.535),(45.595,11.535),(45.595,11.365),(45.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.605),(64.625,6.775),(64.795,6.775),(64.795,6.605),(64.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,40.265),(45.425,40.435),(45.595,40.435),(45.595,40.265),(45.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.605),(15.605,6.775),(15.775,6.775),(15.775,6.605),(15.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.265),(64.625,6.435),(64.795,6.435),(64.795,6.265),(64.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.265),(64.115,6.435),(64.285,6.435),(64.285,6.265),(64.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.985),(31.025,26.155),(31.195,26.155),(31.195,25.985),(31.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.285),(7.025,7.455),(7.195,7.455),(7.195,7.285),(7.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,27.005),(25.715,27.175),(25.885,27.175),(25.885,27.005),(25.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,27.685),(25.205,27.855),(25.375,27.855),(25.375,27.685),(25.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,27.345),(25.715,27.515),(25.885,27.515),(25.885,27.345),(25.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.985),(50.225,9.155),(50.395,9.155),(50.395,8.985),(50.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.225),(50.225,21.395),(50.395,21.395),(50.395,21.225),(50.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.445),(45.425,15.615),(45.595,15.615),(45.595,15.445),(45.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,27.005),(20.915,27.175),(21.085,27.175),(21.085,27.005),(20.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,27.345),(20.915,27.515),(21.085,27.515),(21.085,27.345),(20.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.865),(31.025,20.035),(31.195,20.035),(31.195,19.865),(31.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.065),(83.315,13.235),(83.485,13.235),(83.485,13.065),(83.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.745),(83.315,13.915),(83.485,13.915),(83.485,13.745),(83.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.685),(63.605,10.855),(63.775,10.855),(63.775,10.685),(63.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.005),(63.605,10.175),(63.775,10.175),(63.775,10.005),(63.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,31.425),(20.915,31.595),(21.085,31.595),(21.085,31.425),(20.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,27.345),(74.225,27.515),(74.395,27.515),(74.395,27.345),(74.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,31.765),(20.915,31.935),(21.085,31.935),(21.085,31.765),(20.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,31.085),(20.915,31.255),(21.085,31.255),(21.085,31.085),(20.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,23.265),(26.225,23.435),(26.395,23.435),(26.395,23.265),(26.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,23.605),(26.225,23.775),(26.395,23.775),(26.395,23.605),(26.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,23.945),(10.805,24.115),(10.975,24.115),(10.975,23.945),(10.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,25.985),(15.605,26.155),(15.775,26.155),(15.775,25.985),(15.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,30.405),(16.115,30.575),(16.285,30.575),(16.285,30.405),(16.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,38.565),(63.605,38.735),(63.775,38.735),(63.775,38.565),(63.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.645),(11.825,8.815),(11.995,8.815),(11.995,8.645),(11.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,36.525),(74.225,36.695),(74.395,36.695),(74.395,36.525),(74.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,36.185),(74.225,36.355),(74.395,36.355),(74.395,36.185),(74.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.125),(44.405,16.295),(44.575,16.295),(44.575,16.125),(44.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.465),(44.405,16.635),(44.575,16.635),(44.575,16.465),(44.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.805),(44.405,16.975),(44.575,16.975),(44.575,16.805),(44.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,28.025),(78.005,28.195),(78.175,28.195),(78.175,28.025),(78.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,28.025),(78.515,28.195),(78.685,28.195),(78.685,28.025),(78.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,28.365),(78.005,28.535),(78.175,28.535),(78.175,28.365),(78.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,28.365),(78.515,28.535),(78.685,28.535),(78.685,28.365),(78.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,28.705),(78.005,28.875),(78.175,28.875),(78.175,28.705),(78.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,28.705),(78.515,28.875),(78.685,28.875),(78.685,28.705),(78.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.785),(40.115,15.955),(40.285,15.955),(40.285,15.785),(40.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.785),(40.625,15.955),(40.795,15.955),(40.795,15.785),(40.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.285),(31.025,24.455),(31.195,24.455),(31.195,24.285),(31.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.205),(44.405,20.375),(44.575,20.375),(44.575,20.205),(44.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.545),(44.405,20.715),(44.575,20.715),(44.575,20.545),(44.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.545),(54.515,37.715),(54.685,37.715),(54.685,37.545),(54.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.205),(54.005,37.375),(54.175,37.375),(54.175,37.205),(54.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,2.865),(69.425,3.035),(69.595,3.035),(69.595,2.865),(69.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,21.565),(68.405,21.735),(68.575,21.735),(68.575,21.565),(68.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,23.605),(78.005,23.775),(78.175,23.775),(78.175,23.605),(78.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,23.605),(78.515,23.775),(78.685,23.775),(78.685,23.605),(78.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,35.505),(15.605,35.675),(15.775,35.675),(15.775,35.505),(15.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,35.165),(15.605,35.335),(15.775,35.335),(15.775,35.165),(15.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.605),(34.805,23.775),(34.975,23.775),(34.975,23.605),(34.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.265),(34.805,23.435),(34.975,23.435),(34.975,23.265),(34.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.365),(31.025,28.535),(31.195,28.535),(31.195,28.365),(31.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.705),(31.025,28.875),(31.195,28.875),(31.195,28.705),(31.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.025),(31.025,28.195),(31.195,28.195),(31.195,28.025),(31.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.185),(82.805,19.355),(82.975,19.355),(82.975,19.185),(82.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,31.765),(68.405,31.935),(68.575,31.935),(68.575,31.765),(68.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,31.085),(68.405,31.255),(68.575,31.255),(68.575,31.085),(68.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,40.605),(11.315,40.775),(11.485,40.775),(11.485,40.605),(11.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,35.505),(68.405,35.675),(68.575,35.675),(68.575,35.505),(68.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,35.165),(68.405,35.335),(68.575,35.335),(68.575,35.165),(68.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.365),(34.805,11.535),(34.975,11.535),(34.975,11.365),(34.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.705),(34.805,11.875),(34.975,11.875),(34.975,11.705),(34.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.025),(34.805,11.195),(34.975,11.195),(34.975,11.025),(34.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.205),(54.005,20.375),(54.175,20.375),(54.175,20.205),(54.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,38.905),(11.825,39.075),(11.995,39.075),(11.995,38.905),(11.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.545),(54.515,20.715),(54.685,20.715),(54.685,20.545),(54.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.565),(54.515,38.735),(54.685,38.735),(54.685,38.565),(54.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.225),(54.005,38.395),(54.175,38.395),(54.175,38.225),(54.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,26.665),(10.805,26.835),(10.975,26.835),(10.975,26.665),(10.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,26.325),(10.805,26.495),(10.975,26.495),(10.975,26.325),(10.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.245),(69.425,5.415),(69.595,5.415),(69.595,5.245),(69.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.585),(69.425,5.755),(69.595,5.755),(69.595,5.585),(69.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,37.545),(26.225,37.715),(26.395,37.715),(26.395,37.545),(26.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.245),(21.425,5.415),(21.595,5.415),(21.595,5.245),(21.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.585),(21.425,5.755),(21.595,5.755),(21.595,5.585),(21.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.805),(54.005,16.975),(54.175,16.975),(54.175,16.805),(54.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.465),(54.515,16.635),(54.685,16.635),(54.685,16.465),(54.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.125),(54.005,16.295),(54.175,16.295),(54.175,16.125),(54.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.265),(63.605,6.435),(63.775,6.435),(63.775,6.265),(63.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.605),(63.605,6.775),(63.775,6.775),(63.775,6.605),(63.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.785),(44.405,32.955),(44.575,32.955),(44.575,32.785),(44.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.105),(44.405,32.275),(44.575,32.275),(44.575,32.105),(44.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.005),(59.315,27.175),(59.485,27.175),(59.485,27.005),(59.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,27.005),(59.825,27.175),(59.995,27.175),(59.995,27.005),(59.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.445),(44.405,32.615),(44.575,32.615),(44.575,32.445),(44.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,38.565),(20.915,38.735),(21.085,38.735),(21.085,38.565),(20.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,39.245),(7.025,39.415),(7.195,39.415),(7.195,39.245),(7.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.125),(31.025,16.295),(31.195,16.295),(31.195,16.125),(31.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.465),(31.025,16.635),(31.195,16.635),(31.195,16.465),(31.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.805),(31.025,16.975),(31.195,16.975),(31.195,16.805),(31.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,21.905),(26.225,22.075),(26.395,22.075),(26.395,21.905),(26.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,37.885),(69.425,38.055),(69.595,38.055),(69.595,37.885),(69.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,24.625),(15.605,24.795),(15.775,24.795),(15.775,24.625),(15.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,24.285),(15.605,24.455),(15.775,24.455),(15.775,24.285),(15.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.065),(64.115,13.235),(64.285,13.235),(64.285,13.065),(64.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.065),(64.625,13.235),(64.795,13.235),(64.795,13.065),(64.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.405),(64.115,13.575),(64.285,13.575),(64.285,13.405),(64.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.405),(64.625,13.575),(64.795,13.575),(64.795,13.405),(64.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.745),(64.115,13.915),(64.285,13.915),(64.285,13.745),(64.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.745),(64.625,13.915),(64.795,13.915),(64.795,13.745),(64.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,30.405),(59.825,30.575),(59.995,30.575),(59.995,30.405),(59.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.405),(59.315,30.575),(59.485,30.575),(59.485,30.405),(59.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.225),(35.315,38.395),(35.485,38.395),(35.485,38.225),(35.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.225),(35.825,38.395),(35.995,38.395),(35.995,38.225),(35.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.205),(83.315,3.375),(83.485,3.375),(83.485,3.205),(83.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.545),(83.315,3.715),(83.485,3.715),(83.485,3.545),(83.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.605),(6.515,6.775),(6.685,6.775),(6.685,6.605),(6.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.245),(26.225,5.415),(26.395,5.415),(26.395,5.245),(26.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.165),(10.805,18.335),(10.975,18.335),(10.975,18.165),(10.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.005),(30.005,10.175),(30.175,10.175),(30.175,10.005),(30.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.345),(30.005,10.515),(30.175,10.515),(30.175,10.345),(30.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.685),(30.005,10.855),(30.175,10.855),(30.175,10.685),(30.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.545),(35.315,3.715),(35.485,3.715),(35.485,3.545),(35.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.545),(35.825,3.715),(35.995,3.715),(35.995,3.545),(35.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.385),(34.805,29.555),(34.975,29.555),(34.975,29.385),(34.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.545),(7.025,3.715),(7.195,3.715),(7.195,3.545),(7.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.585),(44.405,5.755),(44.575,5.755),(44.575,5.585),(44.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,37.545),(25.205,37.715),(25.375,37.715),(25.375,37.545),(25.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,22.585),(82.805,22.755),(82.975,22.755),(82.975,22.585),(82.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,22.245),(82.805,22.415),(82.975,22.415),(82.975,22.245),(82.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.525),(44.405,19.695),(44.575,19.695),(44.575,19.525),(44.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.185),(44.405,19.355),(44.575,19.355),(44.575,19.185),(44.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,24.965),(30.005,25.135),(30.175,25.135),(30.175,24.965),(30.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.745),(54.005,30.915),(54.175,30.915),(54.175,30.745),(54.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.065),(54.005,30.235),(54.175,30.235),(54.175,30.065),(54.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.405),(54.005,30.575),(54.175,30.575),(54.175,30.405),(54.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.465),(15.605,16.635),(15.775,16.635),(15.775,16.465),(15.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.605),(30.005,6.775),(30.175,6.775),(30.175,6.605),(30.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.905),(44.915,5.075),(45.085,5.075),(45.085,4.905),(44.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,32.785),(69.425,32.955),(69.595,32.955),(69.595,32.785),(69.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,32.105),(69.425,32.275),(69.595,32.275),(69.595,32.105),(69.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,32.445),(69.425,32.615),(69.595,32.615),(69.595,32.445),(69.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.205),(21.425,3.375),(21.595,3.375),(21.595,3.205),(21.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.585),(39.605,5.755),(39.775,5.755),(39.775,5.585),(39.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.245),(39.605,5.415),(39.775,5.415),(39.775,5.245),(39.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.985),(58.805,9.155),(58.975,9.155),(58.975,8.985),(58.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.345),(30.515,27.515),(30.685,27.515),(30.685,27.345),(30.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.725),(83.315,12.895),(83.485,12.895),(83.485,12.725),(83.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.845),(55.025,36.015),(55.195,36.015),(55.195,35.845),(55.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.045),(83.315,12.215),(83.485,12.215),(83.485,12.045),(83.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.145),(83.315,17.315),(83.485,17.315),(83.485,17.145),(83.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.825),(83.315,17.995),(83.485,17.995),(83.485,17.825),(83.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.105),(83.315,15.275),(83.485,15.275),(83.485,15.105),(83.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.945),(45.425,24.115),(45.595,24.115),(45.595,23.945),(45.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.445),(35.315,15.615),(35.485,15.615),(35.485,15.445),(35.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.445),(35.825,15.615),(35.995,15.615),(35.995,15.445),(35.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.785),(35.315,15.955),(35.485,15.955),(35.485,15.785),(35.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.785),(35.825,15.955),(35.995,15.955),(35.995,15.785),(35.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,26.325),(7.025,26.495),(7.195,26.495),(7.195,26.325),(7.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.265),(34.805,6.435),(34.975,6.435),(34.975,6.265),(34.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.605),(54.005,6.775),(54.175,6.775),(54.175,6.605),(54.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.265),(54.515,6.435),(54.685,6.435),(54.685,6.265),(54.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,21.905),(11.825,22.075),(11.995,22.075),(11.995,21.905),(11.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.845),(79.025,19.015),(79.195,19.015),(79.195,18.845),(79.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.145),(49.205,17.315),(49.375,17.315),(49.375,17.145),(49.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.685),(35.315,27.855),(35.485,27.855),(35.485,27.685),(35.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,24.625),(74.225,24.795),(74.395,24.795),(74.395,24.625),(74.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.825),(49.205,17.995),(49.375,17.995),(49.375,17.825),(49.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.145),(49.715,17.315),(49.885,17.315),(49.885,17.145),(49.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.685),(35.825,27.855),(35.995,27.855),(35.995,27.685),(35.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.825),(49.715,17.995),(49.885,17.995),(49.885,17.825),(49.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,33.125),(68.915,33.295),(69.085,33.295),(69.085,33.125),(68.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,33.465),(68.915,33.635),(69.085,33.635),(69.085,33.465),(68.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,33.805),(68.915,33.975),(69.085,33.975),(69.085,33.805),(68.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.265),(30.515,23.435),(30.685,23.435),(30.685,23.265),(30.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.605),(30.515,23.775),(30.685,23.775),(30.685,23.605),(30.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,40.605),(26.225,40.775),(26.395,40.775),(26.395,40.605),(26.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.765),(44.405,31.935),(44.575,31.935),(44.575,31.765),(44.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.085),(44.405,31.255),(44.575,31.255),(44.575,31.085),(44.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.285),(54.515,7.455),(54.685,7.455),(54.685,7.285),(54.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,36.865),(25.715,37.035),(25.885,37.035),(25.885,36.865),(25.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,26.665),(79.025,26.835),(79.195,26.835),(79.195,26.665),(79.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,26.325),(79.025,26.495),(79.195,26.495),(79.195,26.325),(79.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.325),(79.025,9.495),(79.195,9.495),(79.195,9.325),(79.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.065),(7.025,13.235),(7.195,13.235),(7.195,13.065),(7.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.745),(7.025,13.915),(7.195,13.915),(7.195,13.745),(7.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.885),(25.715,4.055),(25.885,4.055),(25.885,3.885),(25.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.145),(68.915,17.315),(69.085,17.315),(69.085,17.145),(68.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.825),(68.915,17.995),(69.085,17.995),(69.085,17.825),(68.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.165),(44.915,18.335),(45.085,18.335),(45.085,18.165),(44.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,32.105),(26.225,32.275),(26.395,32.275),(26.395,32.105),(26.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,32.445),(26.225,32.615),(26.395,32.615),(26.395,32.445),(26.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,32.785),(26.225,32.955),(26.395,32.955),(26.395,32.785),(26.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,27.345),(68.915,27.515),(69.085,27.515),(69.085,27.345),(68.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,21.225),(68.915,21.395),(69.085,21.395),(69.085,21.225),(68.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.385),(79.025,12.555),(79.195,12.555),(79.195,12.385),(79.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,31.425),(68.915,31.595),(69.085,31.595),(69.085,31.425),(68.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,31.765),(68.915,31.935),(69.085,31.935),(69.085,31.765),(68.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,31.085),(68.915,31.255),(69.085,31.255),(69.085,31.085),(68.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.725),(79.025,12.895),(79.195,12.895),(79.195,12.725),(79.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.045),(79.025,12.215),(79.195,12.215),(79.195,12.045),(79.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.245),(68.405,5.415),(68.575,5.415),(68.575,5.245),(68.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.945),(31.025,7.115),(31.195,7.115),(31.195,6.945),(31.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,24.965),(16.625,25.135),(16.795,25.135),(16.795,24.965),(16.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,2.865),(68.405,3.035),(68.575,3.035),(68.575,2.865),(68.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,30.065),(10.805,30.235),(10.975,30.235),(10.975,30.065),(10.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,30.405),(10.805,30.575),(10.975,30.575),(10.975,30.405),(10.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,32.105),(7.025,32.275),(7.195,32.275),(7.195,32.105),(7.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,32.785),(7.025,32.955),(7.195,32.955),(7.195,32.785),(7.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,32.445),(7.025,32.615),(7.195,32.615),(7.195,32.445),(7.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,30.745),(10.805,30.915),(10.975,30.915),(10.975,30.745),(10.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.425),(16.115,14.595),(16.285,14.595),(16.285,14.425),(16.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.945),(68.915,7.115),(69.085,7.115),(69.085,6.945),(68.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,23.605),(82.805,23.775),(82.975,23.775),(82.975,23.605),(82.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.105),(20.405,15.275),(20.575,15.275),(20.575,15.105),(20.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.445),(20.405,15.615),(20.575,15.615),(20.575,15.445),(20.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.885),(49.715,4.055),(49.885,4.055),(49.885,3.885),(49.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.885),(49.205,4.055),(49.375,4.055),(49.375,3.885),(49.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.505),(59.315,18.675),(59.485,18.675),(59.485,18.505),(59.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.505),(59.825,18.675),(59.995,18.675),(59.995,18.505),(59.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.485),(7.025,17.655),(7.195,17.655),(7.195,17.485),(7.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,33.465),(10.805,33.635),(10.975,33.635),(10.975,33.465),(10.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,33.805),(10.805,33.975),(10.975,33.975),(10.975,33.805),(10.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,33.125),(10.805,33.295),(10.975,33.295),(10.975,33.125),(10.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.485),(54.515,17.655),(54.685,17.655),(54.685,17.485),(54.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.825),(54.005,17.995),(54.175,17.995),(54.175,17.825),(54.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.145),(54.005,17.315),(54.175,17.315),(54.175,17.145),(54.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.565),(34.805,38.735),(34.975,38.735),(34.975,38.565),(34.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.865),(39.605,37.035),(39.775,37.035),(39.775,36.865),(39.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.245),(20.915,5.415),(21.085,5.415),(21.085,5.245),(20.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.785),(55.025,15.955),(55.195,15.955),(55.195,15.785),(55.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.445),(55.025,15.615),(55.195,15.615),(55.195,15.445),(55.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.725),(31.025,12.895),(31.195,12.895),(31.195,12.725),(31.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.385),(31.025,12.555),(31.195,12.555),(31.195,12.385),(31.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.045),(31.025,12.215),(31.195,12.215),(31.195,12.045),(31.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.205),(69.425,3.375),(69.595,3.375),(69.595,3.205),(69.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,38.905),(6.515,39.075),(6.685,39.075),(6.685,38.905),(6.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,21.905),(64.115,22.075),(64.285,22.075),(64.285,21.905),(64.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,21.905),(64.625,22.075),(64.795,22.075),(64.795,21.905),(64.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,22.245),(16.625,22.415),(16.795,22.415),(16.795,22.245),(16.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,35.845),(26.225,36.015),(26.395,36.015),(26.395,35.845),(26.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.105),(50.225,15.275),(50.395,15.275),(50.395,15.105),(50.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.445),(50.225,15.615),(50.395,15.615),(50.395,15.445),(50.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.785),(50.225,15.955),(50.395,15.955),(50.395,15.785),(50.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.785),(59.315,15.955),(59.485,15.955),(59.485,15.785),(59.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.285),(16.115,7.455),(16.285,7.455),(16.285,7.285),(16.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.785),(59.825,15.955),(59.995,15.955),(59.995,15.785),(59.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.285),(82.805,7.455),(82.975,7.455),(82.975,7.285),(82.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,39.245),(78.005,39.415),(78.175,39.415),(78.175,39.245),(78.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,39.245),(78.515,39.415),(78.685,39.415),(78.685,39.245),(78.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.405),(44.915,30.575),(45.085,30.575),(45.085,30.405),(44.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,36.865),(79.025,37.035),(79.195,37.035),(79.195,36.865),(79.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,40.265),(63.605,40.435),(63.775,40.435),(63.775,40.265),(63.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,33.125),(25.715,33.295),(25.885,33.295),(25.885,33.125),(25.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,33.805),(25.715,33.975),(25.885,33.975),(25.885,33.805),(25.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,33.465),(25.715,33.635),(25.885,33.635),(25.885,33.465),(25.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.325),(73.205,9.495),(73.375,9.495),(73.375,9.325),(73.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.325),(73.715,9.495),(73.885,9.495),(73.885,9.325),(73.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.465),(20.915,16.635),(21.085,16.635),(21.085,16.465),(20.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.125),(20.915,16.295),(21.085,16.295),(21.085,16.125),(20.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.805),(20.915,16.975),(21.085,16.975),(21.085,16.805),(20.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.845),(31.025,19.015),(31.195,19.015),(31.195,18.845),(31.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.325),(25.205,9.495),(25.375,9.495),(25.375,9.325),(25.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.665),(25.205,9.835),(25.375,9.835),(25.375,9.665),(25.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,24.965),(79.025,25.135),(79.195,25.135),(79.195,24.965),(79.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.645),(39.605,25.815),(39.775,25.815),(39.775,25.645),(39.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.665),(20.405,9.835),(20.575,9.835),(20.575,9.665),(20.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.965),(45.425,25.135),(45.595,25.135),(45.595,24.965),(45.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,27.345),(10.805,27.515),(10.975,27.515),(10.975,27.345),(10.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,27.005),(10.805,27.175),(10.975,27.175),(10.975,27.005),(10.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,37.885),(79.025,38.055),(79.195,38.055),(79.195,37.885),(79.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,26.325),(31.025,26.495),(31.195,26.495),(31.195,26.325),(31.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,39.585),(30.005,39.755),(30.175,39.755),(30.175,39.585),(30.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.205),(50.225,3.375),(50.395,3.375),(50.395,3.205),(50.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.905),(40.115,39.075),(40.285,39.075),(40.285,38.905),(40.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.905),(40.625,39.075),(40.795,39.075),(40.795,38.905),(40.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.305),(20.915,8.475),(21.085,8.475),(21.085,8.305),(20.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,33.465),(64.115,33.635),(64.285,33.635),(64.285,33.465),(64.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,33.125),(64.115,33.295),(64.285,33.295),(64.285,33.125),(64.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,40.265),(49.205,40.435),(49.375,40.435),(49.375,40.265),(49.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,40.265),(49.715,40.435),(49.885,40.435),(49.885,40.265),(49.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,33.125),(64.625,33.295),(64.795,33.295),(64.795,33.125),(64.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,33.465),(64.625,33.635),(64.795,33.635),(64.795,33.465),(64.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,33.805),(64.115,33.975),(64.285,33.975),(64.285,33.805),(64.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,33.805),(64.625,33.975),(64.795,33.975),(64.795,33.805),(64.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.785),(30.005,15.955),(30.175,15.955),(30.175,15.785),(30.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.905),(16.115,5.075),(16.285,5.075),(16.285,4.905),(16.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,27.005),(73.205,27.175),(73.375,27.175),(73.375,27.005),(73.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,27.005),(73.715,27.175),(73.885,27.175),(73.885,27.005),(73.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,27.345),(73.205,27.515),(73.375,27.515),(73.375,27.345),(73.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,27.345),(73.715,27.515),(73.885,27.515),(73.885,27.345),(73.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,35.165),(82.805,35.335),(82.975,35.335),(82.975,35.165),(82.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,35.505),(82.805,35.675),(82.975,35.675),(82.975,35.505),(82.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,24.625),(10.805,24.795),(10.975,24.795),(10.975,24.625),(10.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,24.285),(10.805,24.455),(10.975,24.455),(10.975,24.285),(10.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.885),(40.625,4.055),(40.795,4.055),(40.795,3.885),(40.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.885),(40.115,4.055),(40.285,4.055),(40.285,3.885),(40.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.865),(35.315,37.035),(35.485,37.035),(35.485,36.865),(35.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.865),(35.825,37.035),(35.995,37.035),(35.995,36.865),(35.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.725),(20.915,12.895),(21.085,12.895),(21.085,12.725),(20.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.385),(20.915,12.555),(21.085,12.555),(21.085,12.385),(20.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.045),(20.915,12.215),(21.085,12.215),(21.085,12.045),(20.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.305),(74.225,8.475),(74.395,8.475),(74.395,8.305),(74.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.365),(30.005,11.535),(30.175,11.535),(30.175,11.365),(30.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.765),(44.915,31.935),(45.085,31.935),(45.085,31.765),(44.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.085),(44.915,31.255),(45.085,31.255),(45.085,31.085),(44.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.985),(25.715,9.155),(25.885,9.155),(25.885,8.985),(25.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.765),(35.825,14.935),(35.995,14.935),(35.995,14.765),(35.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,32.105),(79.025,32.275),(79.195,32.275),(79.195,32.105),(79.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,32.445),(79.025,32.615),(79.195,32.615),(79.195,32.445),(79.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,32.785),(79.025,32.955),(79.195,32.955),(79.195,32.785),(79.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.085),(35.315,14.255),(35.485,14.255),(35.485,14.085),(35.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.085),(35.825,14.255),(35.995,14.255),(35.995,14.085),(35.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.105),(44.405,15.275),(44.575,15.275),(44.575,15.105),(44.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.765),(35.315,14.935),(35.485,14.935),(35.485,14.765),(35.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,26.325),(15.605,26.495),(15.775,26.495),(15.775,26.325),(15.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.725),(30.515,12.895),(30.685,12.895),(30.685,12.725),(30.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.385),(30.515,12.555),(30.685,12.555),(30.685,12.385),(30.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.045),(30.515,12.215),(30.685,12.215),(30.685,12.045),(30.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,25.645),(79.025,25.815),(79.195,25.815),(79.195,25.645),(79.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.165),(54.005,18.335),(54.175,18.335),(54.175,18.165),(54.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.505),(54.515,18.675),(54.685,18.675),(54.685,18.505),(54.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.105),(34.805,32.275),(34.975,32.275),(34.975,32.105),(34.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.445),(34.805,32.615),(34.975,32.615),(34.975,32.445),(34.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.785),(34.805,32.955),(34.975,32.955),(34.975,32.785),(34.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.025),(25.715,11.195),(25.885,11.195),(25.885,11.025),(25.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.285),(59.315,7.455),(59.485,7.455),(59.485,7.285),(59.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.285),(59.825,7.455),(59.995,7.455),(59.995,7.285),(59.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.705),(25.715,11.875),(25.885,11.875),(25.885,11.705),(25.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,38.225),(69.425,38.395),(69.595,38.395),(69.595,38.225),(69.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,40.265),(25.205,40.435),(25.375,40.435),(25.375,40.265),(25.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,21.905),(20.915,22.075),(21.085,22.075),(21.085,21.905),(20.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.965),(50.225,25.135),(50.395,25.135),(50.395,24.965),(50.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.885),(49.205,38.055),(49.375,38.055),(49.375,37.885),(49.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.885),(49.715,38.055),(49.885,38.055),(49.885,37.885),(49.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.065),(15.605,13.235),(15.775,13.235),(15.775,13.065),(15.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.745),(15.605,13.915),(15.775,13.915),(15.775,13.745),(15.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.405),(15.605,13.575),(15.775,13.575),(15.775,13.405),(15.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.285),(11.825,7.455),(11.995,7.455),(11.995,7.285),(11.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.225),(11.825,4.395),(11.995,4.395),(11.995,4.225),(11.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.565),(11.825,4.735),(11.995,4.735),(11.995,4.565),(11.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.845),(49.205,19.015),(49.375,19.015),(49.375,18.845),(49.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.845),(49.715,19.015),(49.885,19.015),(49.885,18.845),(49.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.585),(55.025,39.755),(55.195,39.755),(55.195,39.585),(55.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.585),(10.805,5.755),(10.975,5.755),(10.975,5.585),(10.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.885),(44.915,21.055),(45.085,21.055),(45.085,20.885),(44.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.285),(25.205,7.455),(25.375,7.455),(25.375,7.285),(25.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.245),(49.205,39.415),(49.375,39.415),(49.375,39.245),(49.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.245),(49.715,39.415),(49.885,39.415),(49.885,39.245),(49.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.625),(26.225,7.795),(26.395,7.795),(26.395,7.625),(26.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.445),(63.605,15.615),(63.775,15.615),(63.775,15.445),(63.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.865),(25.715,20.035),(25.885,20.035),(25.885,19.865),(25.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.625),(79.025,7.795),(79.195,7.795),(79.195,7.625),(79.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,36.185),(82.805,36.355),(82.975,36.355),(82.975,36.185),(82.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,36.525),(82.805,36.695),(82.975,36.695),(82.975,36.525),(82.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.325),(54.515,9.495),(54.685,9.495),(54.685,9.325),(54.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.665),(54.005,9.835),(54.175,9.835),(54.175,9.665),(54.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,38.225),(68.405,38.395),(68.575,38.395),(68.575,38.225),(68.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,29.045),(82.805,29.215),(82.975,29.215),(82.975,29.045),(82.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,29.725),(82.805,29.895),(82.975,29.895),(82.975,29.725),(82.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,37.205),(10.805,37.375),(10.975,37.375),(10.975,37.205),(10.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.785),(58.805,15.955),(58.975,15.955),(58.975,15.785),(58.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,25.305),(74.225,25.475),(74.395,25.475),(74.395,25.305),(74.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.105),(58.805,15.275),(58.975,15.275),(58.975,15.105),(58.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,40.265),(44.915,40.435),(45.085,40.435),(45.085,40.265),(44.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.445),(58.805,15.615),(58.975,15.615),(58.975,15.445),(58.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,22.925),(11.825,23.095),(11.995,23.095),(11.995,22.925),(11.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.785),(78.005,15.955),(78.175,15.955),(78.175,15.785),(78.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.785),(78.515,15.955),(78.685,15.955),(78.685,15.785),(78.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.605),(59.315,23.775),(59.485,23.775),(59.485,23.605),(59.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,23.605),(59.825,23.775),(59.995,23.775),(59.995,23.605),(59.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.585),(31.025,39.755),(31.195,39.755),(31.195,39.585),(31.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,21.905),(25.205,22.075),(25.375,22.075),(25.375,21.905),(25.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.985),(15.605,9.155),(15.775,9.155),(15.775,8.985),(15.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,39.585),(73.205,39.755),(73.375,39.755),(73.375,39.585),(73.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,39.585),(73.715,39.755),(73.885,39.755),(73.885,39.585),(73.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.325),(68.405,9.495),(68.575,9.495),(68.575,9.325),(68.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.665),(68.405,9.835),(68.575,9.835),(68.575,9.665),(68.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.245),(45.425,22.415),(45.595,22.415),(45.595,22.245),(45.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,22.925),(30.005,23.095),(30.175,23.095),(30.175,22.925),(30.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.225),(35.315,4.395),(35.485,4.395),(35.485,4.225),(35.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.225),(35.825,4.395),(35.995,4.395),(35.995,4.225),(35.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.565),(35.315,4.735),(35.485,4.735),(35.485,4.565),(35.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.565),(35.825,4.735),(35.995,4.735),(35.995,4.565),(35.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.165),(16.625,18.335),(16.795,18.335),(16.795,18.165),(16.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.505),(16.625,18.675),(16.795,18.675),(16.795,18.505),(16.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,39.925),(7.025,40.095),(7.195,40.095),(7.195,39.925),(7.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,23.265),(25.715,23.435),(25.885,23.435),(25.885,23.265),(25.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,23.605),(25.715,23.775),(25.885,23.775),(25.885,23.605),(25.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.585),(73.205,5.755),(73.375,5.755),(73.375,5.585),(73.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.585),(73.715,5.755),(73.885,5.755),(73.885,5.585),(73.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.465),(58.805,16.635),(58.975,16.635),(58.975,16.465),(58.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.805),(58.805,16.975),(58.975,16.975),(58.975,16.805),(58.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.125),(58.805,16.295),(58.975,16.295),(58.975,16.125),(58.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.425),(44.915,14.595),(45.085,14.595),(45.085,14.425),(44.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.625),(31.025,7.795),(31.195,7.795),(31.195,7.625),(31.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,24.285),(11.315,24.455),(11.485,24.455),(11.485,24.285),(11.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.585),(50.225,39.755),(50.395,39.755),(50.395,39.585),(50.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.645),(35.315,25.815),(35.485,25.815),(35.485,25.645),(35.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.645),(35.825,25.815),(35.995,25.815),(35.995,25.645),(35.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.365),(7.025,11.535),(7.195,11.535),(7.195,11.365),(7.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.385),(78.005,12.555),(78.175,12.555),(78.175,12.385),(78.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.385),(78.515,12.555),(78.685,12.555),(78.685,12.385),(78.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,22.245),(63.605,22.415),(63.775,22.415),(63.775,22.245),(63.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.665),(26.225,9.835),(26.395,9.835),(26.395,9.665),(26.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.885),(15.605,4.055),(15.775,4.055),(15.775,3.885),(15.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.685),(50.225,27.855),(50.395,27.855),(50.395,27.685),(50.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.325),(39.605,9.495),(39.775,9.495),(39.775,9.325),(39.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.625),(55.025,7.795),(55.195,7.795),(55.195,7.625),(55.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.945),(64.115,7.115),(64.285,7.115),(64.285,6.945),(64.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.945),(64.625,7.115),(64.795,7.115),(64.795,6.945),(64.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.645),(31.025,25.815),(31.195,25.815),(31.195,25.645),(31.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.305),(31.025,25.475),(31.195,25.475),(31.195,25.305),(31.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.565),(83.315,4.735),(83.485,4.735),(83.485,4.565),(83.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,32.445),(78.005,32.615),(78.175,32.615),(78.175,32.445),(78.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,32.445),(78.515,32.615),(78.685,32.615),(78.685,32.445),(78.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,32.105),(78.005,32.275),(78.175,32.275),(78.175,32.105),(78.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,32.105),(78.515,32.275),(78.685,32.275),(78.685,32.105),(78.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,32.785),(78.005,32.955),(78.175,32.955),(78.175,32.785),(78.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,32.785),(78.515,32.955),(78.685,32.955),(78.685,32.785),(78.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.805),(68.915,16.975),(69.085,16.975),(69.085,16.805),(68.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.125),(68.915,16.295),(69.085,16.295),(69.085,16.125),(68.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.925),(15.605,6.095),(15.775,6.095),(15.775,5.925),(15.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,25.305),(20.405,25.475),(20.575,25.475),(20.575,25.305),(20.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.865),(64.115,20.035),(64.285,20.035),(64.285,19.865),(64.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.865),(64.625,20.035),(64.795,20.035),(64.795,19.865),(64.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.645),(10.805,8.815),(10.975,8.815),(10.975,8.645),(10.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.305),(10.805,8.475),(10.975,8.475),(10.975,8.305),(10.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.165),(20.405,18.335),(20.575,18.335),(20.575,18.165),(20.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,27.005),(79.025,27.175),(79.195,27.175),(79.195,27.005),(79.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,27.345),(79.025,27.515),(79.195,27.515),(79.195,27.345),(79.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,29.385),(6.515,29.555),(6.685,29.555),(6.685,29.385),(6.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,29.045),(6.515,29.215),(6.685,29.215),(6.685,29.045),(6.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,29.725),(6.515,29.895),(6.685,29.895),(6.685,29.725),(6.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,21.905),(79.025,22.075),(79.195,22.075),(79.195,21.905),(79.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.885),(34.805,38.055),(34.975,38.055),(34.975,37.885),(34.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.045),(15.605,12.215),(15.775,12.215),(15.775,12.045),(15.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.105),(44.915,15.275),(45.085,15.275),(45.085,15.105),(44.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.725),(15.605,12.895),(15.775,12.895),(15.775,12.725),(15.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.005),(25.205,10.175),(25.375,10.175),(25.375,10.005),(25.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.685),(25.205,10.855),(25.375,10.855),(25.375,10.685),(25.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,23.265),(10.805,23.435),(10.975,23.435),(10.975,23.265),(10.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.345),(31.025,10.515),(31.195,10.515),(31.195,10.345),(31.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.945),(44.915,24.115),(45.085,24.115),(45.085,23.945),(44.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,37.885),(16.115,38.055),(16.285,38.055),(16.285,37.885),(16.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.625),(45.425,7.795),(45.595,7.795),(45.595,7.625),(45.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,25.645),(15.605,25.815),(15.775,25.815),(15.775,25.645),(15.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,25.305),(15.605,25.475),(15.775,25.475),(15.775,25.305),(15.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.505),(73.205,18.675),(73.375,18.675),(73.375,18.505),(73.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.505),(73.715,18.675),(73.885,18.675),(73.885,18.505),(73.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,36.865),(74.225,37.035),(74.395,37.035),(74.395,36.865),(74.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.065),(50.225,13.235),(50.395,13.235),(50.395,13.065),(50.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.405),(50.225,13.575),(50.395,13.575),(50.395,13.405),(50.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.745),(50.225,13.915),(50.395,13.915),(50.395,13.745),(50.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.385),(40.625,29.555),(40.795,29.555),(40.795,29.385),(40.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.385),(40.115,29.555),(40.285,29.555),(40.285,29.385),(40.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.525),(54.515,19.695),(54.685,19.695),(54.685,19.525),(54.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.605),(55.025,6.775),(55.195,6.775),(55.195,6.605),(55.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.965),(31.025,25.135),(31.195,25.135),(31.195,24.965),(31.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.885),(44.405,21.055),(44.575,21.055),(44.575,20.885),(44.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,39.585),(74.225,39.755),(74.395,39.755),(74.395,39.585),(74.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.885),(40.115,38.055),(40.285,38.055),(40.285,37.885),(40.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.885),(40.625,38.055),(40.795,38.055),(40.795,37.885),(40.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.905),(83.315,5.075),(83.485,5.075),(83.485,4.905),(83.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.145),(44.405,34.315),(44.575,34.315),(44.575,34.145),(44.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.485),(44.405,34.655),(44.575,34.655),(44.575,34.485),(44.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.825),(44.405,34.995),(44.575,34.995),(44.575,34.825),(44.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.885),(54.005,21.055),(54.175,21.055),(54.175,20.885),(54.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.905),(54.005,39.075),(54.175,39.075),(54.175,38.905),(54.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.345),(39.605,27.515),(39.775,27.515),(39.775,27.345),(39.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.005),(39.605,27.175),(39.775,27.175),(39.775,27.005),(39.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.945),(40.115,24.115),(40.285,24.115),(40.285,23.945),(40.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.945),(40.625,24.115),(40.795,24.115),(40.795,23.945),(40.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,22.245),(25.205,22.415),(25.375,22.415),(25.375,22.245),(25.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,22.585),(25.205,22.755),(25.375,22.755),(25.375,22.585),(25.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.945),(63.605,7.115),(63.775,7.115),(63.775,6.945),(63.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.845),(35.315,36.015),(35.485,36.015),(35.485,35.845),(35.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.845),(35.825,36.015),(35.995,36.015),(35.995,35.845),(35.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.265),(21.425,6.435),(21.595,6.435),(21.595,6.265),(21.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,31.085),(78.005,31.255),(78.175,31.255),(78.175,31.085),(78.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,31.085),(78.515,31.255),(78.685,31.255),(78.685,31.085),(78.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,31.765),(78.005,31.935),(78.175,31.935),(78.175,31.765),(78.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,31.765),(78.515,31.935),(78.685,31.935),(78.685,31.765),(78.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.965),(59.315,8.135),(59.485,8.135),(59.485,7.965),(59.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.965),(59.825,8.135),(59.995,8.135),(59.995,7.965),(59.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,37.205),(69.425,37.375),(69.595,37.375),(69.595,37.205),(69.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,24.965),(15.605,25.135),(15.775,25.135),(15.775,24.965),(15.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,31.425),(64.115,31.595),(64.285,31.595),(64.285,31.425),(64.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,31.425),(64.625,31.595),(64.795,31.595),(64.795,31.425),(64.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.945),(54.515,24.115),(54.685,24.115),(54.685,23.945),(54.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.185),(59.825,19.355),(59.995,19.355),(59.995,19.185),(59.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.185),(59.315,19.355),(59.485,19.355),(59.485,19.185),(59.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.905),(35.315,39.075),(35.485,39.075),(35.485,38.905),(35.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.905),(35.825,39.075),(35.995,39.075),(35.995,38.905),(35.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.125),(40.115,16.295),(40.285,16.295),(40.285,16.125),(40.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.125),(40.625,16.295),(40.795,16.295),(40.795,16.125),(40.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.805),(40.115,16.975),(40.285,16.975),(40.285,16.805),(40.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.805),(40.625,16.975),(40.795,16.975),(40.795,16.805),(40.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.305),(55.025,8.475),(55.195,8.475),(55.195,8.305),(55.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.645),(55.025,8.815),(55.195,8.815),(55.195,8.645),(55.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.405),(30.005,13.575),(30.175,13.575),(30.175,13.405),(30.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.685),(7.025,10.855),(7.195,10.855),(7.195,10.685),(7.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.345),(7.025,10.515),(7.195,10.515),(7.195,10.345),(7.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,39.585),(6.515,39.755),(6.685,39.755),(6.685,39.585),(6.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.005),(7.025,10.175),(7.195,10.175),(7.195,10.005),(7.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.925),(59.315,6.095),(59.485,6.095),(59.485,5.925),(59.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.925),(59.825,6.095),(59.995,6.095),(59.995,5.925),(59.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,21.225),(16.625,21.395),(16.795,21.395),(16.795,21.225),(16.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,21.565),(16.625,21.735),(16.795,21.735),(16.795,21.565),(16.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.465),(20.405,16.635),(20.575,16.635),(20.575,16.465),(20.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.125),(20.405,16.295),(20.575,16.295),(20.575,16.125),(20.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.805),(20.405,16.975),(20.575,16.975),(20.575,16.805),(20.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.845),(10.805,19.015),(10.975,19.015),(10.975,18.845),(10.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.485),(68.405,17.655),(68.575,17.655),(68.575,17.485),(68.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.085),(63.605,14.255),(63.775,14.255),(63.775,14.085),(63.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.065),(68.915,13.235),(69.085,13.235),(69.085,13.065),(68.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.405),(68.915,13.575),(69.085,13.575),(69.085,13.405),(68.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.745),(68.915,13.915),(69.085,13.915),(69.085,13.745),(68.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.765),(63.605,14.935),(63.775,14.935),(63.775,14.765),(63.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,39.245),(20.405,39.415),(20.575,39.415),(20.575,39.245),(20.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.645),(34.805,8.815),(34.975,8.815),(34.975,8.645),(34.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,32.105),(11.825,32.275),(11.995,32.275),(11.995,32.105),(11.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,34.825),(63.605,34.995),(63.775,34.995),(63.775,34.825),(63.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,34.485),(63.605,34.655),(63.775,34.655),(63.775,34.485),(63.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,34.145),(63.605,34.315),(63.775,34.315),(63.775,34.145),(63.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,32.785),(11.825,32.955),(11.995,32.955),(11.995,32.785),(11.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,32.445),(11.825,32.615),(11.995,32.615),(11.995,32.445),(11.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.305),(34.805,8.475),(34.975,8.475),(34.975,8.305),(34.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,33.805),(6.515,33.975),(6.685,33.975),(6.685,33.805),(6.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,33.125),(6.515,33.295),(6.685,33.295),(6.685,33.125),(6.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,33.465),(6.515,33.635),(6.685,33.635),(6.685,33.465),(6.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,37.205),(68.405,37.375),(68.575,37.375),(68.575,37.205),(68.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,38.225),(78.005,38.395),(78.175,38.395),(78.175,38.225),(78.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,38.225),(78.515,38.395),(78.685,38.395),(78.685,38.225),(78.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,20.545),(20.405,20.715),(20.575,20.715),(20.575,20.545),(20.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,20.205),(20.405,20.375),(20.575,20.375),(20.575,20.205),(20.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.865),(54.005,20.035),(54.175,20.035),(54.175,19.865),(54.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.885),(68.405,4.055),(68.575,4.055),(68.575,3.885),(68.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.985),(44.405,26.155),(44.575,26.155),(44.575,25.985),(44.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.325),(35.315,9.495),(35.485,9.495),(35.485,9.325),(35.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.325),(35.825,9.495),(35.995,9.495),(35.995,9.325),(35.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.645),(20.405,8.815),(20.575,8.815),(20.575,8.645),(20.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,35.505),(7.025,35.675),(7.195,35.675),(7.195,35.505),(7.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,35.165),(7.025,35.335),(7.195,35.335),(7.195,35.165),(7.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.025),(15.605,11.195),(15.775,11.195),(15.775,11.025),(15.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.365),(15.605,11.535),(15.775,11.535),(15.775,11.365),(15.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.705),(15.605,11.875),(15.775,11.875),(15.775,11.705),(15.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.865),(83.315,20.035),(83.485,20.035),(83.485,19.865),(83.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,21.225),(74.225,21.395),(74.395,21.395),(74.395,21.225),(74.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,21.565),(74.225,21.735),(74.395,21.735),(74.395,21.565),(74.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.565),(35.315,21.735),(35.485,21.735),(35.485,21.565),(35.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.565),(35.825,21.735),(35.995,21.735),(35.995,21.565),(35.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,22.925),(68.915,23.095),(69.085,23.095),(69.085,22.925),(68.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,22.925),(64.115,23.095),(64.285,23.095),(64.285,22.925),(64.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,22.925),(64.625,23.095),(64.795,23.095),(64.795,22.925),(64.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,38.565),(30.005,38.735),(30.175,38.735),(30.175,38.565),(30.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.705),(16.115,11.875),(16.285,11.875),(16.285,11.705),(16.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.025),(16.115,11.195),(16.285,11.195),(16.285,11.025),(16.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.365),(16.115,11.535),(16.285,11.535),(16.285,11.365),(16.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.945),(34.805,7.115),(34.975,7.115),(34.975,6.945),(34.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.825),(54.005,34.995),(54.175,34.995),(54.175,34.825),(54.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.145),(54.005,34.315),(54.175,34.315),(54.175,34.145),(54.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.485),(54.005,34.655),(54.175,34.655),(54.175,34.485),(54.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.085),(82.805,14.255),(82.975,14.255),(82.975,14.085),(82.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.765),(82.805,14.935),(82.975,14.935),(82.975,14.765),(82.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,21.225),(11.825,21.395),(11.995,21.395),(11.995,21.225),(11.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.625),(40.115,7.795),(40.285,7.795),(40.285,7.625),(40.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.625),(40.625,7.795),(40.795,7.795),(40.795,7.625),(40.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.365),(50.225,11.535),(50.395,11.535),(50.395,11.365),(50.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,21.905),(15.605,22.075),(15.775,22.075),(15.775,21.905),(15.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.125),(7.025,16.295),(7.195,16.295),(7.195,16.125),(7.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.805),(7.025,16.975),(7.195,16.975),(7.195,16.805),(7.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.465),(25.205,16.635),(25.375,16.635),(25.375,16.465),(25.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.065),(73.205,13.235),(73.375,13.235),(73.375,13.065),(73.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.065),(73.715,13.235),(73.885,13.235),(73.885,13.065),(73.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.405),(73.205,13.575),(73.375,13.575),(73.375,13.405),(73.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.405),(73.715,13.575),(73.885,13.575),(73.885,13.405),(73.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.745),(73.205,13.915),(73.375,13.915),(73.375,13.745),(73.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.745),(73.715,13.915),(73.885,13.915),(73.885,13.745),(73.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.065),(58.805,13.235),(58.975,13.235),(58.975,13.065),(58.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.745),(58.805,13.915),(58.975,13.915),(58.975,13.745),(58.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,35.845),(79.025,36.015),(79.195,36.015),(79.195,35.845),(79.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,29.045),(11.315,29.215),(11.485,29.215),(11.485,29.045),(11.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,29.725),(11.315,29.895),(11.485,29.895),(11.485,29.725),(11.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,37.205),(64.115,37.375),(64.285,37.375),(64.285,37.205),(64.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,37.205),(64.625,37.375),(64.795,37.375),(64.795,37.205),(64.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,40.605),(34.805,40.775),(34.975,40.775),(34.975,40.605),(34.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.765),(30.515,31.935),(30.685,31.935),(30.685,31.765),(30.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.425),(30.515,31.595),(30.685,31.595),(30.685,31.425),(30.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.085),(30.515,31.255),(30.685,31.255),(30.685,31.085),(30.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.305),(40.115,8.475),(40.285,8.475),(40.285,8.305),(40.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.305),(40.625,8.475),(40.795,8.475),(40.795,8.305),(40.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.645),(40.115,8.815),(40.285,8.815),(40.285,8.645),(40.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.645),(40.625,8.815),(40.795,8.815),(40.795,8.645),(40.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.405),(40.115,13.575),(40.285,13.575),(40.285,13.405),(40.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.405),(40.625,13.575),(40.795,13.575),(40.795,13.405),(40.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.185),(59.315,36.355),(59.485,36.355),(59.485,36.185),(59.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,36.185),(59.825,36.355),(59.995,36.355),(59.995,36.185),(59.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.525),(59.315,36.695),(59.485,36.695),(59.485,36.525),(59.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,36.525),(59.825,36.695),(59.995,36.695),(59.995,36.525),(59.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,39.585),(10.805,39.755),(10.975,39.755),(10.975,39.585),(10.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,21.905),(68.915,22.075),(69.085,22.075),(69.085,21.905),(68.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.205),(58.805,37.375),(58.975,37.375),(58.975,37.205),(58.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,26.665),(11.825,26.835),(11.995,26.835),(11.995,26.665),(11.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,26.665),(11.315,26.835),(11.485,26.835),(11.485,26.665),(11.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,26.325),(11.315,26.495),(11.485,26.495),(11.485,26.325),(11.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.945),(58.805,24.115),(58.975,24.115),(58.975,23.945),(58.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.645),(55.025,25.815),(55.195,25.815),(55.195,25.645),(55.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,29.045),(78.005,29.215),(78.175,29.215),(78.175,29.045),(78.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,29.045),(78.515,29.215),(78.685,29.215),(78.685,29.045),(78.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,29.725),(78.005,29.895),(78.175,29.895),(78.175,29.725),(78.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,29.725),(78.515,29.895),(78.685,29.895),(78.685,29.725),(78.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.265),(68.915,6.435),(69.085,6.435),(69.085,6.265),(68.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.605),(68.915,6.775),(69.085,6.775),(69.085,6.605),(68.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.625),(68.915,7.795),(69.085,7.795),(69.085,7.625),(68.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.665),(16.625,9.835),(16.795,9.835),(16.795,9.665),(16.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.965),(64.115,8.135),(64.285,8.135),(64.285,7.965),(64.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.965),(64.625,8.135),(64.795,8.135),(64.795,7.965),(64.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,37.885),(7.025,38.055),(7.195,38.055),(7.195,37.885),(7.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.165),(58.805,18.335),(58.975,18.335),(58.975,18.165),(58.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.965),(40.115,8.135),(40.285,8.135),(40.285,7.965),(40.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.965),(40.625,8.135),(40.795,8.135),(40.795,7.965),(40.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.625),(20.915,7.795),(21.085,7.795),(21.085,7.625),(20.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.505),(58.805,18.675),(58.975,18.675),(58.975,18.505),(58.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,37.545),(16.625,37.715),(16.795,37.715),(16.795,37.545),(16.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.665),(59.315,9.835),(59.485,9.835),(59.485,9.665),(59.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.665),(59.825,9.835),(59.995,9.835),(59.995,9.665),(59.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.325),(59.315,9.495),(59.485,9.495),(59.485,9.325),(59.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.325),(59.825,9.495),(59.995,9.495),(59.995,9.325),(59.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.845),(45.425,36.015),(45.595,36.015),(45.595,35.845),(45.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.025),(11.825,11.195),(11.995,11.195),(11.995,11.025),(11.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.365),(11.315,11.535),(11.485,11.535),(11.485,11.365),(11.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.365),(11.825,11.535),(11.995,11.535),(11.995,11.365),(11.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.705),(11.825,11.875),(11.995,11.875),(11.995,11.705),(11.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.325),(10.805,9.495),(10.975,9.495),(10.975,9.325),(10.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.525),(20.405,19.695),(20.575,19.695),(20.575,19.525),(20.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.925),(49.205,40.095),(49.375,40.095),(49.375,39.925),(49.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.925),(49.715,40.095),(49.885,40.095),(49.885,39.925),(49.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.265),(68.405,6.435),(68.575,6.435),(68.575,6.265),(68.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,30.065),(20.405,30.235),(20.575,30.235),(20.575,30.065),(20.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,30.745),(20.405,30.915),(20.575,30.915),(20.575,30.745),(20.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.865),(16.115,20.035),(16.285,20.035),(16.285,19.865),(16.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.925),(20.915,6.095),(21.085,6.095),(21.085,5.925),(20.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.005),(31.025,27.175),(31.195,27.175),(31.195,27.005),(31.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.185),(6.515,19.355),(6.685,19.355),(6.685,19.185),(6.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.525),(6.515,19.695),(6.685,19.695),(6.685,19.525),(6.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.145),(40.115,17.315),(40.285,17.315),(40.285,17.145),(40.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.145),(40.625,17.315),(40.795,17.315),(40.795,17.145),(40.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.485),(40.115,17.655),(40.285,17.655),(40.285,17.485),(40.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.485),(40.625,17.655),(40.795,17.655),(40.795,17.485),(40.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.825),(40.115,17.995),(40.285,17.995),(40.285,17.825),(40.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.825),(40.625,17.995),(40.795,17.995),(40.795,17.825),(40.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,2.865),(10.805,3.035),(10.975,3.035),(10.975,2.865),(10.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,37.545),(68.915,37.715),(69.085,37.715),(69.085,37.545),(68.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.285),(34.805,24.455),(34.975,24.455),(34.975,24.285),(34.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,37.545),(73.205,37.715),(73.375,37.715),(73.375,37.545),(73.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,37.545),(73.715,37.715),(73.885,37.715),(73.885,37.545),(73.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.965),(16.115,8.135),(16.285,8.135),(16.285,7.965),(16.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.125),(39.605,33.295),(39.775,33.295),(39.775,33.125),(39.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.465),(39.605,33.635),(39.775,33.635),(39.775,33.465),(39.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,23.605),(73.205,23.775),(73.375,23.775),(73.375,23.605),(73.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,23.605),(73.715,23.775),(73.885,23.775),(73.885,23.605),(73.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,27.345),(64.115,27.515),(64.285,27.515),(64.285,27.345),(64.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,27.345),(64.625,27.515),(64.795,27.515),(64.795,27.345),(64.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.805),(39.605,33.975),(39.775,33.975),(39.775,33.805),(39.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,25.985),(64.115,26.155),(64.285,26.155),(64.285,25.985),(64.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,25.985),(64.625,26.155),(64.795,26.155),(64.795,25.985),(64.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,40.605),(83.315,40.775),(83.485,40.775),(83.485,40.605),(83.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,23.945),(25.715,24.115),(25.885,24.115),(25.885,23.945),(25.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.905),(54.005,5.075),(54.175,5.075),(54.175,4.905),(54.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,35.505),(68.915,35.675),(69.085,35.675),(69.085,35.505),(68.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,35.165),(68.915,35.335),(69.085,35.335),(69.085,35.165),(68.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,20.205),(11.315,20.375),(11.485,20.375),(11.485,20.205),(11.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,20.545),(11.315,20.715),(11.485,20.715),(11.485,20.545),(11.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,27.005),(15.605,27.175),(15.775,27.175),(15.775,27.005),(15.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,27.345),(15.605,27.515),(15.775,27.515),(15.775,27.345),(15.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.565),(44.405,21.735),(44.575,21.735),(44.575,21.565),(44.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.905),(30.005,22.075),(30.175,22.075),(30.175,21.905),(30.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.965),(31.025,8.135),(31.195,8.135),(31.195,7.965),(31.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.525),(39.605,19.695),(39.775,19.695),(39.775,19.525),(39.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.465),(30.005,16.635),(30.175,16.635),(30.175,16.465),(30.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.365),(58.805,11.535),(58.975,11.535),(58.975,11.365),(58.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,37.205),(79.025,37.375),(79.195,37.375),(79.195,37.205),(79.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.045),(73.715,12.215),(73.885,12.215),(73.885,12.045),(73.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.725),(73.205,12.895),(73.375,12.895),(73.375,12.725),(73.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,29.385),(26.225,29.555),(26.395,29.555),(26.395,29.385),(26.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,23.945),(6.515,24.115),(6.685,24.115),(6.685,23.945),(6.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.725),(73.715,12.895),(73.885,12.895),(73.885,12.725),(73.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.045),(73.205,12.215),(73.375,12.215),(73.375,12.045),(73.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.725),(25.205,12.895),(25.375,12.895),(25.375,12.725),(25.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.385),(25.205,12.555),(25.375,12.555),(25.375,12.385),(25.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.045),(25.205,12.215),(25.375,12.215),(25.375,12.045),(25.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.625),(25.715,7.795),(25.885,7.795),(25.885,7.625),(25.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.925),(40.115,6.095),(40.285,6.095),(40.285,5.925),(40.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.925),(40.625,6.095),(40.795,6.095),(40.795,5.925),(40.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.265),(31.025,23.435),(31.195,23.435),(31.195,23.265),(31.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,28.025),(11.315,28.195),(11.485,28.195),(11.485,28.025),(11.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,28.025),(11.825,28.195),(11.995,28.195),(11.995,28.025),(11.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,28.365),(11.825,28.535),(11.995,28.535),(11.995,28.365),(11.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,28.705),(11.315,28.875),(11.485,28.875),(11.485,28.705),(11.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,28.705),(11.825,28.875),(11.995,28.875),(11.995,28.705),(11.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,24.965),(10.805,25.135),(10.975,25.135),(10.975,24.965),(10.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,27.345),(6.515,27.515),(6.685,27.515),(6.685,27.345),(6.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.205),(40.115,3.375),(40.285,3.375),(40.285,3.205),(40.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.545),(40.115,3.715),(40.285,3.715),(40.285,3.545),(40.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.545),(40.625,3.715),(40.795,3.715),(40.795,3.545),(40.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.205),(40.625,3.375),(40.795,3.375),(40.795,3.205),(40.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.785),(55.025,32.955),(55.195,32.955),(55.195,32.785),(55.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.445),(55.025,32.615),(55.195,32.615),(55.195,32.445),(55.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.105),(55.025,32.275),(55.195,32.275),(55.195,32.105),(55.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.985),(74.225,9.155),(74.395,9.155),(74.395,8.985),(74.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.225),(55.025,4.395),(55.195,4.395),(55.195,4.225),(55.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.205),(35.315,20.375),(35.485,20.375),(35.485,20.205),(35.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.205),(35.825,20.375),(35.995,20.375),(35.995,20.205),(35.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,31.765),(16.115,31.935),(16.285,31.935),(16.285,31.765),(16.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,31.085),(16.115,31.255),(16.285,31.255),(16.285,31.085),(16.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.225),(50.225,38.395),(50.395,38.395),(50.395,38.225),(50.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.925),(58.805,23.095),(58.975,23.095),(58.975,22.925),(58.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.125),(83.315,16.295),(83.485,16.295),(83.485,16.125),(83.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.465),(83.315,16.635),(83.485,16.635),(83.485,16.465),(83.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.805),(83.315,16.975),(83.485,16.975),(83.485,16.805),(83.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.925),(54.005,23.095),(54.175,23.095),(54.175,22.925),(54.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.065),(11.315,13.235),(11.485,13.235),(11.485,13.065),(11.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.745),(11.315,13.915),(11.485,13.915),(11.485,13.745),(11.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.845),(54.005,19.015),(54.175,19.015),(54.175,18.845),(54.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.425),(54.005,31.595),(54.175,31.595),(54.175,31.425),(54.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.765),(54.515,31.935),(54.685,31.935),(54.685,31.765),(54.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.085),(54.515,31.255),(54.685,31.255),(54.685,31.085),(54.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,25.645),(7.025,25.815),(7.195,25.815),(7.195,25.645),(7.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.545),(16.625,3.715),(16.795,3.715),(16.795,3.545),(16.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,38.905),(69.425,39.075),(69.595,39.075),(69.595,38.905),(69.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.205),(49.205,37.375),(49.375,37.375),(49.375,37.205),(49.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.205),(49.715,37.375),(49.885,37.375),(49.885,37.205),(49.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,31.765),(7.025,31.935),(7.195,31.935),(7.195,31.765),(7.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,31.425),(7.025,31.595),(7.195,31.595),(7.195,31.425),(7.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,31.085),(7.025,31.255),(7.195,31.255),(7.195,31.085),(7.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.145),(59.315,17.315),(59.485,17.315),(59.485,17.145),(59.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.145),(59.825,17.315),(59.995,17.315),(59.995,17.145),(59.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.825),(59.315,17.995),(59.485,17.995),(59.485,17.825),(59.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.825),(59.825,17.995),(59.995,17.995),(59.995,17.825),(59.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.205),(44.915,20.375),(45.085,20.375),(45.085,20.205),(44.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.545),(44.915,20.715),(45.085,20.715),(45.085,20.545),(44.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.565),(34.805,21.735),(34.975,21.735),(34.975,21.565),(34.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.385),(16.115,12.555),(16.285,12.555),(16.285,12.385),(16.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,35.845),(16.115,36.015),(16.285,36.015),(16.285,35.845),(16.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,40.605),(58.805,40.775),(58.975,40.775),(58.975,40.605),(58.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,23.945),(64.115,24.115),(64.285,24.115),(64.285,23.945),(64.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,23.945),(64.625,24.115),(64.795,24.115),(64.795,23.945),(64.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,25.985),(16.115,26.155),(16.285,26.155),(16.285,25.985),(16.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,36.865),(82.805,37.035),(82.975,37.035),(82.975,36.865),(82.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.305),(49.205,8.475),(49.375,8.475),(49.375,8.305),(49.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,38.905),(68.405,39.075),(68.575,39.075),(68.575,38.905),(68.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.305),(49.715,8.475),(49.885,8.475),(49.885,8.305),(49.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.845),(58.805,36.015),(58.975,36.015),(58.975,35.845),(58.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.665),(34.805,9.835),(34.975,9.835),(34.975,9.665),(34.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.865),(31.025,3.035),(31.195,3.035),(31.195,2.865),(31.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,23.265),(21.425,23.435),(21.595,23.435),(21.595,23.265),(21.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,21.225),(25.205,21.395),(25.375,21.395),(25.375,21.225),(25.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.785),(26.225,15.955),(26.395,15.955),(26.395,15.785),(26.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.845),(40.115,36.015),(40.285,36.015),(40.285,35.845),(40.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.845),(40.625,36.015),(40.795,36.015),(40.795,35.845),(40.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,38.225),(25.205,38.395),(25.375,38.395),(25.375,38.225),(25.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,22.245),(26.225,22.415),(26.395,22.415),(26.395,22.245),(26.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,22.585),(26.225,22.755),(26.395,22.755),(26.395,22.585),(26.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.845),(16.625,19.015),(16.795,19.015),(16.795,18.845),(16.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.885),(20.915,4.055),(21.085,4.055),(21.085,3.885),(20.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,25.985),(11.825,26.155),(11.995,26.155),(11.995,25.985),(11.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,23.605),(20.915,23.775),(21.085,23.775),(21.085,23.605),(20.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.125),(40.115,33.295),(40.285,33.295),(40.285,33.125),(40.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.125),(40.625,33.295),(40.795,33.295),(40.795,33.125),(40.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.805),(40.115,33.975),(40.285,33.975),(40.285,33.805),(40.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.805),(40.625,33.975),(40.795,33.975),(40.795,33.805),(40.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.465),(40.115,33.635),(40.285,33.635),(40.285,33.465),(40.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.465),(40.625,33.635),(40.795,33.635),(40.795,33.465),(40.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.605),(11.825,6.775),(11.995,6.775),(11.995,6.605),(11.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.145),(44.915,17.315),(45.085,17.315),(45.085,17.145),(44.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.825),(44.915,17.995),(45.085,17.995),(45.085,17.825),(44.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,24.965),(11.315,25.135),(11.485,25.135),(11.485,24.965),(11.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.305),(59.825,8.475),(59.995,8.475),(59.995,8.305),(59.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,40.605),(69.425,40.775),(69.595,40.775),(69.595,40.605),(69.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.305),(59.315,8.475),(59.485,8.475),(59.485,8.305),(59.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.645),(30.005,8.815),(30.175,8.815),(30.175,8.645),(30.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,38.225),(20.405,38.395),(20.575,38.395),(20.575,38.225),(20.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.285),(45.425,7.455),(45.595,7.455),(45.595,7.285),(45.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.225),(44.915,21.395),(45.085,21.395),(45.085,21.225),(44.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.565),(44.915,21.735),(45.085,21.735),(45.085,21.565),(44.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,36.185),(68.405,36.355),(68.575,36.355),(68.575,36.185),(68.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,36.525),(68.405,36.695),(68.575,36.695),(68.575,36.525),(68.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.225),(59.315,38.395),(59.485,38.395),(59.485,38.225),(59.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,38.225),(59.825,38.395),(59.995,38.395),(59.995,38.225),(59.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.925),(44.405,40.095),(44.575,40.095),(44.575,39.925),(44.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,27.005),(20.405,27.175),(20.575,27.175),(20.575,27.005),(20.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,37.545),(15.605,37.715),(15.775,37.715),(15.775,37.545),(15.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.385),(30.515,29.555),(30.685,29.555),(30.685,29.385),(30.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.205),(40.115,20.375),(40.285,20.375),(40.285,20.205),(40.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.205),(40.625,20.375),(40.795,20.375),(40.795,20.205),(40.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,39.925),(20.915,40.095),(21.085,40.095),(21.085,39.925),(20.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.585),(45.425,39.755),(45.595,39.755),(45.595,39.585),(45.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.305),(21.425,8.475),(21.595,8.475),(21.595,8.305),(21.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.225),(68.405,4.395),(68.575,4.395),(68.575,4.225),(68.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,23.605),(68.405,23.775),(68.575,23.775),(68.575,23.605),(68.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.005),(55.025,27.175),(55.195,27.175),(55.195,27.005),(55.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.345),(55.025,27.515),(55.195,27.515),(55.195,27.345),(55.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.605),(35.315,6.775),(35.485,6.775),(35.485,6.605),(35.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.605),(35.825,6.775),(35.995,6.775),(35.995,6.605),(35.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.545),(25.205,3.715),(25.375,3.715),(25.375,3.545),(25.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.205),(25.205,3.375),(25.375,3.375),(25.375,3.205),(25.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.165),(63.605,18.335),(63.775,18.335),(63.775,18.165),(63.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.505),(63.605,18.675),(63.775,18.675),(63.775,18.505),(63.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.245),(15.605,5.415),(15.775,5.415),(15.775,5.245),(15.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.585),(15.605,5.755),(15.775,5.755),(15.775,5.585),(15.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.525),(64.625,19.695),(64.795,19.695),(64.795,19.525),(64.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.185),(64.625,19.355),(64.795,19.355),(64.795,19.185),(64.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.185),(64.115,19.355),(64.285,19.355),(64.285,19.185),(64.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.725),(11.315,12.895),(11.485,12.895),(11.485,12.725),(11.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.045),(11.315,12.215),(11.485,12.215),(11.485,12.045),(11.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.525),(64.115,19.695),(64.285,19.695),(64.285,19.525),(64.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.985),(10.805,9.155),(10.975,9.155),(10.975,8.985),(10.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.845),(20.405,19.015),(20.575,19.015),(20.575,18.845),(20.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,32.105),(74.225,32.275),(74.395,32.275),(74.395,32.105),(74.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,32.445),(74.225,32.615),(74.395,32.615),(74.395,32.445),(74.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,32.785),(74.225,32.955),(74.395,32.955),(74.395,32.785),(74.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,40.265),(6.515,40.435),(6.685,40.435),(6.685,40.265),(6.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,21.225),(79.025,21.395),(79.195,21.395),(79.195,21.225),(79.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,21.565),(79.025,21.735),(79.195,21.735),(79.195,21.565),(79.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.785),(64.115,15.955),(64.285,15.955),(64.285,15.785),(64.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.785),(64.625,15.955),(64.795,15.955),(64.795,15.785),(64.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.325),(82.805,9.495),(82.975,9.495),(82.975,9.325),(82.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.665),(82.805,9.835),(82.975,9.835),(82.975,9.665),(82.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.965),(30.515,8.135),(30.685,8.135),(30.685,7.965),(30.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.585),(45.425,5.755),(45.595,5.755),(45.595,5.585),(45.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.085),(49.205,31.255),(49.375,31.255),(49.375,31.085),(49.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.085),(49.715,31.255),(49.885,31.255),(49.885,31.085),(49.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.765),(49.205,31.935),(49.375,31.935),(49.375,31.765),(49.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,40.605),(21.425,40.775),(21.595,40.775),(21.595,40.605),(21.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.765),(49.715,31.935),(49.885,31.935),(49.885,31.765),(49.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.425),(49.205,31.595),(49.375,31.595),(49.375,31.425),(49.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.425),(49.715,31.595),(49.885,31.595),(49.885,31.425),(49.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,22.925),(6.515,23.095),(6.685,23.095),(6.685,22.925),(6.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.265),(10.805,6.435),(10.975,6.435),(10.975,6.265),(10.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.205),(44.915,3.375),(45.085,3.375),(45.085,3.205),(44.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,28.365),(25.205,28.535),(25.375,28.535),(25.375,28.365),(25.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,28.705),(25.205,28.875),(25.375,28.875),(25.375,28.705),(25.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,28.025),(25.205,28.195),(25.375,28.195),(25.375,28.025),(25.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.545),(55.025,3.715),(55.195,3.715),(55.195,3.545),(55.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.685),(83.315,10.855),(83.485,10.855),(83.485,10.685),(83.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.005),(83.315,10.175),(83.485,10.175),(83.485,10.005),(83.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.665),(45.425,9.835),(45.595,9.835),(45.595,9.665),(45.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.885),(35.315,4.055),(35.485,4.055),(35.485,3.885),(35.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,24.285),(68.405,24.455),(68.575,24.455),(68.575,24.285),(68.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.885),(35.825,4.055),(35.995,4.055),(35.995,3.885),(35.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,27.005),(16.115,27.175),(16.285,27.175),(16.285,27.005),(16.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.885),(7.025,4.055),(7.195,4.055),(7.195,3.885),(7.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.865),(44.405,3.035),(44.575,3.035),(44.575,2.865),(44.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.885),(30.515,4.055),(30.685,4.055),(30.685,3.885),(30.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.325),(7.025,9.495),(7.195,9.495),(7.195,9.325),(7.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,31.765),(10.805,31.935),(10.975,31.935),(10.975,31.765),(10.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,31.085),(10.805,31.255),(10.975,31.255),(10.975,31.085),(10.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.445),(16.115,15.615),(16.285,15.615),(16.285,15.445),(16.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.165),(21.425,18.335),(21.595,18.335),(21.595,18.165),(21.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.505),(21.425,18.675),(21.595,18.675),(21.595,18.505),(21.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.185),(58.805,19.355),(58.975,19.355),(58.975,19.185),(58.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.305),(78.005,8.475),(78.175,8.475),(78.175,8.305),(78.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.305),(78.515,8.475),(78.685,8.475),(78.685,8.305),(78.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.645),(78.005,8.815),(78.175,8.815),(78.175,8.645),(78.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.645),(78.515,8.815),(78.685,8.815),(78.685,8.645),(78.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.145),(30.005,17.315),(30.175,17.315),(30.175,17.145),(30.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,36.185),(64.115,36.355),(64.285,36.355),(64.285,36.185),(64.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,36.185),(64.625,36.355),(64.795,36.355),(64.795,36.185),(64.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,36.525),(64.115,36.695),(64.285,36.695),(64.285,36.525),(64.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,36.525),(64.625,36.695),(64.795,36.695),(64.795,36.525),(64.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.825),(30.005,17.995),(30.175,17.995),(30.175,17.825),(30.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,39.925),(68.915,40.095),(69.085,40.095),(69.085,39.925),(68.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,20.205),(25.205,20.375),(25.375,20.375),(25.375,20.205),(25.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.545),(78.005,3.715),(78.175,3.715),(78.175,3.545),(78.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.545),(78.515,3.715),(78.685,3.715),(78.685,3.545),(78.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,26.665),(73.205,26.835),(73.375,26.835),(73.375,26.665),(73.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,26.665),(73.715,26.835),(73.885,26.835),(73.885,26.665),(73.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,29.045),(63.605,29.215),(63.775,29.215),(63.775,29.045),(63.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,29.385),(63.605,29.555),(63.775,29.555),(63.775,29.385),(63.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,29.725),(63.605,29.895),(63.775,29.895),(63.775,29.725),(63.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.965),(82.805,8.135),(82.975,8.135),(82.975,7.965),(82.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,38.565),(79.025,38.735),(79.195,38.735),(79.195,38.565),(79.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.985),(58.805,26.155),(58.975,26.155),(58.975,25.985),(58.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.345),(21.425,10.515),(21.595,10.515),(21.595,10.345),(21.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.985),(40.115,26.155),(40.285,26.155),(40.285,25.985),(40.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.985),(40.625,26.155),(40.795,26.155),(40.795,25.985),(40.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,37.885),(78.005,38.055),(78.175,38.055),(78.175,37.885),(78.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,37.885),(78.515,38.055),(78.685,38.055),(78.685,37.885),(78.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.685),(74.225,10.855),(74.395,10.855),(74.395,10.685),(74.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.005),(74.225,10.175),(74.395,10.175),(74.395,10.005),(74.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.345),(74.225,10.515),(74.395,10.515),(74.395,10.345),(74.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.545),(45.425,3.715),(45.595,3.715),(45.595,3.545),(45.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.205),(45.425,3.375),(45.595,3.375),(45.595,3.205),(45.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.245),(16.625,5.415),(16.795,5.415),(16.795,5.245),(16.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.225),(64.115,4.395),(64.285,4.395),(64.285,4.225),(64.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.225),(64.625,4.395),(64.795,4.395),(64.795,4.225),(64.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.945),(21.425,7.115),(21.595,7.115),(21.595,6.945),(21.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.605),(73.715,6.775),(73.885,6.775),(73.885,6.605),(73.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.605),(73.205,6.775),(73.375,6.775),(73.375,6.605),(73.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.305),(34.805,25.475),(34.975,25.475),(34.975,25.305),(34.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,23.605),(16.115,23.775),(16.285,23.775),(16.285,23.605),(16.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,35.845),(21.425,36.015),(21.595,36.015),(21.595,35.845),(21.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,31.765),(6.515,31.935),(6.685,31.935),(6.685,31.765),(6.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,31.085),(6.515,31.255),(6.685,31.255),(6.685,31.085),(6.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.265),(54.515,23.435),(54.685,23.435),(54.685,23.265),(54.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.605),(54.515,23.775),(54.685,23.775),(54.685,23.605),(54.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.485),(25.205,17.655),(25.375,17.655),(25.375,17.485),(25.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.985),(55.025,9.155),(55.195,9.155),(55.195,8.985),(55.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.245),(59.315,5.415),(59.485,5.415),(59.485,5.245),(59.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.245),(59.825,5.415),(59.995,5.415),(59.995,5.245),(59.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.585),(59.315,5.755),(59.485,5.755),(59.485,5.585),(59.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.585),(59.825,5.755),(59.995,5.755),(59.995,5.585),(59.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.365),(39.605,28.535),(39.775,28.535),(39.775,28.365),(39.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,30.065),(25.715,30.235),(25.885,30.235),(25.885,30.065),(25.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,30.405),(25.715,30.575),(25.885,30.575),(25.885,30.405),(25.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,30.745),(25.715,30.915),(25.885,30.915),(25.885,30.745),(25.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.165),(30.005,18.335),(30.175,18.335),(30.175,18.165),(30.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,30.065),(11.315,30.235),(11.485,30.235),(11.485,30.065),(11.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,30.405),(11.315,30.575),(11.485,30.575),(11.485,30.405),(11.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,30.745),(11.315,30.915),(11.485,30.915),(11.485,30.745),(11.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.965),(78.005,8.135),(78.175,8.135),(78.175,7.965),(78.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.965),(34.805,8.135),(34.975,8.135),(34.975,7.965),(34.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.965),(78.515,8.135),(78.685,8.135),(78.685,7.965),(78.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.585),(11.825,5.755),(11.995,5.755),(11.995,5.585),(11.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,31.425),(79.025,31.595),(79.195,31.595),(79.195,31.425),(79.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.305),(45.425,8.475),(45.595,8.475),(45.595,8.305),(45.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,25.645),(6.515,25.815),(6.685,25.815),(6.685,25.645),(6.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,25.305),(6.515,25.475),(6.685,25.475),(6.685,25.305),(6.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.985),(34.805,9.155),(34.975,9.155),(34.975,8.985),(34.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,38.905),(78.005,39.075),(78.175,39.075),(78.175,38.905),(78.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,38.905),(78.515,39.075),(78.685,39.075),(78.685,38.905),(78.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,20.885),(20.405,21.055),(20.575,21.055),(20.575,20.885),(20.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.225),(16.625,4.395),(16.795,4.395),(16.795,4.225),(16.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,25.645),(16.625,25.815),(16.795,25.815),(16.795,25.645),(16.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,25.305),(16.625,25.475),(16.795,25.475),(16.795,25.305),(16.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.065),(55.025,13.235),(55.195,13.235),(55.195,13.065),(55.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.745),(55.025,13.915),(55.195,13.915),(55.195,13.745),(55.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.545),(73.205,3.715),(73.375,3.715),(73.375,3.545),(73.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.545),(73.715,3.715),(73.885,3.715),(73.885,3.545),(73.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.205),(68.405,3.375),(68.575,3.375),(68.575,3.205),(68.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.925),(59.315,23.095),(59.485,23.095),(59.485,22.925),(59.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,22.925),(59.825,23.095),(59.995,23.095),(59.995,22.925),(59.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,25.985),(25.715,26.155),(25.885,26.155),(25.885,25.985),(25.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.565),(31.025,21.735),(31.195,21.735),(31.195,21.565),(31.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,25.985),(63.605,26.155),(63.775,26.155),(63.775,25.985),(63.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.885),(78.005,4.055),(78.175,4.055),(78.175,3.885),(78.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,39.585),(63.605,39.755),(63.775,39.755),(63.775,39.585),(63.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.885),(78.515,4.055),(78.685,4.055),(78.685,3.885),(78.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.105),(35.315,32.275),(35.485,32.275),(35.485,32.105),(35.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.105),(35.825,32.275),(35.995,32.275),(35.995,32.105),(35.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.445),(35.315,32.615),(35.485,32.615),(35.485,32.445),(35.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.445),(35.825,32.615),(35.995,32.615),(35.995,32.445),(35.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.105),(11.315,15.275),(11.485,15.275),(11.485,15.105),(11.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.785),(35.315,32.955),(35.485,32.955),(35.485,32.785),(35.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.785),(35.825,32.955),(35.995,32.955),(35.995,32.785),(35.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.445),(11.315,15.615),(11.485,15.615),(11.485,15.445),(11.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,40.605),(68.405,40.775),(68.575,40.775),(68.575,40.605),(68.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.045),(54.515,29.215),(54.685,29.215),(54.685,29.045),(54.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.385),(54.005,29.555),(54.175,29.555),(54.175,29.385),(54.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.725),(54.515,29.895),(54.685,29.895),(54.685,29.725),(54.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,31.765),(21.425,31.935),(21.595,31.935),(21.595,31.765),(21.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,31.425),(21.425,31.595),(21.595,31.595),(21.595,31.425),(21.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,31.085),(21.425,31.255),(21.595,31.255),(21.595,31.085),(21.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.905),(44.405,5.075),(44.575,5.075),(44.575,4.905),(44.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.225),(40.625,4.395),(40.795,4.395),(40.795,4.225),(40.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.225),(40.115,4.395),(40.285,4.395),(40.285,4.225),(40.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.865),(63.605,20.035),(63.775,20.035),(63.775,19.865),(63.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,23.265),(68.915,23.435),(69.085,23.435),(69.085,23.265),(68.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,34.485),(16.115,34.655),(16.285,34.655),(16.285,34.485),(16.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,34.145),(16.115,34.315),(16.285,34.315),(16.285,34.145),(16.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,34.825),(16.115,34.995),(16.285,34.995),(16.285,34.825),(16.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,23.945),(16.115,24.115),(16.285,24.115),(16.285,23.945),(16.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,27.345),(11.315,27.515),(11.485,27.515),(11.485,27.345),(11.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,27.005),(11.315,27.175),(11.485,27.175),(11.485,27.005),(11.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.205),(34.805,20.375),(34.975,20.375),(34.975,20.205),(34.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.865),(44.915,3.035),(45.085,3.035),(45.085,2.865),(44.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,35.845),(69.425,36.015),(69.595,36.015),(69.595,35.845),(69.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.905),(54.005,22.075),(54.175,22.075),(54.175,21.905),(54.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,21.225),(15.605,21.395),(15.775,21.395),(15.775,21.225),(15.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.985),(49.205,26.155),(49.375,26.155),(49.375,25.985),(49.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.985),(49.715,26.155),(49.885,26.155),(49.885,25.985),(49.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.765),(39.605,31.935),(39.775,31.935),(39.775,31.765),(39.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.085),(39.605,31.255),(39.775,31.255),(39.775,31.085),(39.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.565),(39.605,38.735),(39.775,38.735),(39.775,38.565),(39.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,40.265),(73.205,40.435),(73.375,40.435),(73.375,40.265),(73.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,40.265),(73.715,40.435),(73.885,40.435),(73.885,40.265),(73.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,27.685),(68.405,27.855),(68.575,27.855),(68.575,27.685),(68.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.285),(34.805,7.455),(34.975,7.455),(34.975,7.285),(34.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.585),(54.515,5.755),(54.685,5.755),(54.685,5.585),(54.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.245),(54.005,5.415),(54.175,5.415),(54.175,5.245),(54.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.945),(31.025,24.115),(31.195,24.115),(31.195,23.945),(31.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.765),(78.515,14.935),(78.685,14.935),(78.685,14.765),(78.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.085),(78.515,14.255),(78.685,14.255),(78.685,14.085),(78.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,24.285),(25.715,24.455),(25.885,24.455),(25.885,24.285),(25.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,24.625),(25.715,24.795),(25.885,24.795),(25.885,24.625),(25.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.085),(78.005,14.255),(78.175,14.255),(78.175,14.085),(78.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.765),(78.005,14.935),(78.175,14.935),(78.175,14.765),(78.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.905),(39.605,22.075),(39.775,22.075),(39.775,21.905),(39.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,24.285),(64.115,24.455),(64.285,24.455),(64.285,24.285),(64.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,24.285),(64.625,24.455),(64.795,24.455),(64.795,24.285),(64.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.685),(45.425,10.855),(45.595,10.855),(45.595,10.685),(45.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.005),(45.425,10.175),(45.595,10.175),(45.595,10.005),(45.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.205),(30.515,37.375),(30.685,37.375),(30.685,37.205),(30.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.345),(45.425,10.515),(45.595,10.515),(45.595,10.345),(45.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.385),(55.025,12.555),(55.195,12.555),(55.195,12.385),(55.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.925),(82.805,6.095),(82.975,6.095),(82.975,5.925),(82.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.425),(7.025,14.595),(7.195,14.595),(7.195,14.425),(7.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.805),(30.515,33.975),(30.685,33.975),(30.685,33.805),(30.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.125),(30.515,33.295),(30.685,33.295),(30.685,33.125),(30.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.245),(35.315,39.415),(35.485,39.415),(35.485,39.245),(35.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.245),(35.825,39.415),(35.995,39.415),(35.995,39.245),(35.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.465),(30.515,33.635),(30.685,33.635),(30.685,33.465),(30.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.185),(25.205,19.355),(25.375,19.355),(25.375,19.185),(25.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.525),(25.205,19.695),(25.375,19.695),(25.375,19.525),(25.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.385),(7.025,12.555),(7.195,12.555),(7.195,12.385),(7.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.725),(7.025,12.895),(7.195,12.895),(7.195,12.725),(7.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.045),(7.025,12.215),(7.195,12.215),(7.195,12.045),(7.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.325),(30.005,9.495),(30.175,9.495),(30.175,9.325),(30.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.665),(30.005,9.835),(30.175,9.835),(30.175,9.665),(30.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,21.225),(82.805,21.395),(82.975,21.395),(82.975,21.225),(82.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.985),(40.115,9.155),(40.285,9.155),(40.285,8.985),(40.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.985),(40.625,9.155),(40.795,9.155),(40.795,8.985),(40.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.865),(59.315,37.035),(59.485,37.035),(59.485,36.865),(59.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,36.865),(59.825,37.035),(59.995,37.035),(59.995,36.865),(59.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.745),(49.205,30.915),(49.375,30.915),(49.375,30.745),(49.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.745),(49.715,30.915),(49.885,30.915),(49.885,30.745),(49.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.105),(10.805,15.275),(10.975,15.275),(10.975,15.105),(10.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.065),(49.205,30.235),(49.375,30.235),(49.375,30.065),(49.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.065),(49.715,30.235),(49.885,30.235),(49.885,30.065),(49.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.405),(49.205,30.575),(49.375,30.575),(49.375,30.405),(49.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.405),(49.715,30.575),(49.885,30.575),(49.885,30.405),(49.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,34.145),(6.515,34.315),(6.685,34.315),(6.685,34.145),(6.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,34.485),(6.515,34.655),(6.685,34.655),(6.685,34.485),(6.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,34.825),(6.515,34.995),(6.685,34.995),(6.685,34.825),(6.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.585),(30.005,5.755),(30.175,5.755),(30.175,5.585),(30.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,24.285),(78.005,24.455),(78.175,24.455),(78.175,24.285),(78.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,24.285),(78.515,24.455),(78.685,24.455),(78.685,24.285),(78.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,24.625),(78.515,24.795),(78.685,24.795),(78.685,24.625),(78.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,24.625),(78.005,24.795),(78.175,24.795),(78.175,24.625),(78.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.965),(20.405,8.135),(20.575,8.135),(20.575,7.965),(20.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.805),(54.005,33.975),(54.175,33.975),(54.175,33.805),(54.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.125),(54.005,33.295),(54.175,33.295),(54.175,33.125),(54.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.465),(54.005,33.635),(54.175,33.635),(54.175,33.465),(54.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.265),(58.805,23.435),(58.975,23.435),(58.975,23.265),(58.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,39.585),(16.625,39.755),(16.795,39.755),(16.795,39.585),(16.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.425),(30.515,14.595),(30.685,14.595),(30.685,14.425),(30.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.285),(44.405,24.455),(44.575,24.455),(44.575,24.285),(44.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,20.205),(78.005,20.375),(78.175,20.375),(78.175,20.205),(78.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,20.205),(78.515,20.375),(78.685,20.375),(78.685,20.205),(78.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,20.545),(78.005,20.715),(78.175,20.715),(78.175,20.545),(78.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,20.545),(78.515,20.715),(78.685,20.715),(78.685,20.545),(78.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.185),(55.025,19.355),(55.195,19.355),(55.195,19.185),(55.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.805),(55.025,33.975),(55.195,33.975),(55.195,33.805),(55.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.465),(55.025,33.635),(55.195,33.635),(55.195,33.465),(55.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.125),(55.025,33.295),(55.195,33.295),(55.195,33.125),(55.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.265),(49.205,23.435),(49.375,23.435),(49.375,23.265),(49.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.265),(49.715,23.435),(49.885,23.435),(49.885,23.265),(49.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.705),(44.405,28.875),(44.575,28.875),(44.575,28.705),(44.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.025),(44.405,28.195),(44.575,28.195),(44.575,28.025),(44.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,37.205),(7.025,37.375),(7.195,37.375),(7.195,37.205),(7.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.845),(58.805,19.015),(58.975,19.015),(58.975,18.845),(58.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,37.205),(82.805,37.375),(82.975,37.375),(82.975,37.205),(82.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,20.205),(64.115,20.375),(64.285,20.375),(64.285,20.205),(64.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,20.205),(64.625,20.375),(64.795,20.375),(64.795,20.205),(64.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.665),(63.605,9.835),(63.775,9.835),(63.775,9.665),(63.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.325),(63.605,9.495),(63.775,9.495),(63.775,9.325),(63.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.285),(35.315,24.455),(35.485,24.455),(35.485,24.285),(35.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.285),(35.825,24.455),(35.995,24.455),(35.995,24.285),(35.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.165),(11.315,18.335),(11.485,18.335),(11.485,18.165),(11.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.945),(68.405,7.115),(68.575,7.115),(68.575,6.945),(68.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.165),(11.825,18.335),(11.995,18.335),(11.995,18.165),(11.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.505),(11.315,18.675),(11.485,18.675),(11.485,18.505),(11.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.725),(10.805,12.895),(10.975,12.895),(10.975,12.725),(10.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.385),(10.805,12.555),(10.975,12.555),(10.975,12.385),(10.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.045),(10.805,12.215),(10.975,12.215),(10.975,12.045),(10.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,38.565),(26.225,38.735),(26.395,38.735),(26.395,38.565),(26.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.785),(54.005,15.955),(54.175,15.955),(54.175,15.785),(54.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,38.565),(68.915,38.735),(69.085,38.735),(69.085,38.565),(68.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,24.285),(63.605,24.455),(63.775,24.455),(63.775,24.285),(63.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.165),(69.425,18.335),(69.595,18.335),(69.595,18.165),(69.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.505),(69.425,18.675),(69.595,18.675),(69.595,18.505),(69.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.185),(16.115,19.355),(16.285,19.355),(16.285,19.185),(16.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.425),(68.405,14.595),(68.575,14.595),(68.575,14.425),(68.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.545),(31.025,20.715),(31.195,20.715),(31.195,20.545),(31.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.745),(63.605,13.915),(63.775,13.915),(63.775,13.745),(63.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,23.265),(69.425,23.435),(69.595,23.435),(69.595,23.265),(69.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.065),(63.605,13.235),(63.775,13.235),(63.775,13.065),(63.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.405),(63.605,13.575),(63.775,13.575),(63.775,13.405),(63.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,28.025),(63.605,28.195),(63.775,28.195),(63.775,28.025),(63.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,28.705),(63.605,28.875),(63.775,28.875),(63.775,28.705),(63.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.805),(31.025,33.975),(31.195,33.975),(31.195,33.805),(31.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.125),(31.025,33.295),(31.195,33.295),(31.195,33.125),(31.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.465),(31.025,33.635),(31.195,33.635),(31.195,33.465),(31.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,26.325),(21.425,26.495),(21.595,26.495),(21.595,26.325),(21.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.425),(11.825,14.595),(11.995,14.595),(11.995,14.425),(11.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.965),(34.805,25.135),(34.975,25.135),(34.975,24.965),(34.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,28.365),(16.625,28.535),(16.795,28.535),(16.795,28.365),(16.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,26.665),(26.225,26.835),(26.395,26.835),(26.395,26.665),(26.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,38.225),(11.315,38.395),(11.485,38.395),(11.485,38.225),(11.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,23.945),(11.825,24.115),(11.995,24.115),(11.995,23.945),(11.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,37.205),(20.405,37.375),(20.575,37.375),(20.575,37.205),(20.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.805),(69.425,16.975),(69.595,16.975),(69.595,16.805),(69.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.125),(69.425,16.295),(69.595,16.295),(69.595,16.125),(69.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,24.625),(7.025,24.795),(7.195,24.795),(7.195,24.625),(7.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.125),(63.605,16.295),(63.775,16.295),(63.775,16.125),(63.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.805),(63.605,16.975),(63.775,16.975),(63.775,16.805),(63.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.465),(63.605,16.635),(63.775,16.635),(63.775,16.465),(63.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.285),(49.205,24.455),(49.375,24.455),(49.375,24.285),(49.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.285),(49.715,24.455),(49.885,24.455),(49.885,24.285),(49.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.165),(35.315,18.335),(35.485,18.335),(35.485,18.165),(35.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.165),(35.825,18.335),(35.995,18.335),(35.995,18.165),(35.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.505),(35.315,18.675),(35.485,18.675),(35.485,18.505),(35.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.505),(35.825,18.675),(35.995,18.675),(35.995,18.505),(35.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.385),(6.515,12.555),(6.685,12.555),(6.685,12.385),(6.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.725),(6.515,12.895),(6.685,12.895),(6.685,12.725),(6.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.045),(6.515,12.215),(6.685,12.215),(6.685,12.045),(6.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,26.665),(54.005,26.835),(54.175,26.835),(54.175,26.665),(54.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,26.325),(54.005,26.495),(54.175,26.495),(54.175,26.325),(54.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,39.925),(16.625,40.095),(16.795,40.095),(16.795,39.925),(16.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,20.885),(11.315,21.055),(11.485,21.055),(11.485,20.885),(11.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.905),(63.605,5.075),(63.775,5.075),(63.775,4.905),(63.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.965),(73.715,8.135),(73.885,8.135),(73.885,7.965),(73.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.965),(73.205,8.135),(73.375,8.135),(73.375,7.965),(73.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,20.205),(15.605,20.375),(15.775,20.375),(15.775,20.205),(15.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,40.265),(50.225,40.435),(50.395,40.435),(50.395,40.265),(50.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.585),(58.805,5.755),(58.975,5.755),(58.975,5.585),(58.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,31.085),(73.715,31.255),(73.885,31.255),(73.885,31.085),(73.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,31.765),(73.205,31.935),(73.375,31.935),(73.375,31.765),(73.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,31.765),(73.715,31.935),(73.885,31.935),(73.885,31.765),(73.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,31.085),(73.205,31.255),(73.375,31.255),(73.375,31.085),(73.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,23.605),(6.515,23.775),(6.685,23.775),(6.685,23.605),(6.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,23.265),(6.515,23.435),(6.685,23.435),(6.685,23.265),(6.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,39.245),(64.115,39.415),(64.285,39.415),(64.285,39.245),(64.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,39.245),(64.625,39.415),(64.795,39.415),(64.795,39.245),(64.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,39.925),(68.405,40.095),(68.575,40.095),(68.575,39.925),(68.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.385),(55.025,29.555),(55.195,29.555),(55.195,29.385),(55.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,25.645),(78.005,25.815),(78.175,25.815),(78.175,25.645),(78.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,25.645),(78.515,25.815),(78.685,25.815),(78.685,25.645),(78.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,39.585),(21.425,39.755),(21.595,39.755),(21.595,39.585),(21.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,25.985),(73.205,26.155),(73.375,26.155),(73.375,25.985),(73.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,25.985),(73.715,26.155),(73.885,26.155),(73.885,25.985),(73.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.785),(39.605,15.955),(39.775,15.955),(39.775,15.785),(39.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.105),(39.605,15.275),(39.775,15.275),(39.775,15.105),(39.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.285),(30.515,24.455),(30.685,24.455),(30.685,24.285),(30.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,2.865),(26.225,3.035),(26.395,3.035),(26.395,2.865),(26.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,39.585),(25.715,39.755),(25.885,39.755),(25.885,39.585),(25.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.105),(82.805,15.275),(82.975,15.275),(82.975,15.105),(82.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.445),(82.805,15.615),(82.975,15.615),(82.975,15.445),(82.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,2.865),(25.205,3.035),(25.375,3.035),(25.375,2.865),(25.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,22.925),(79.025,23.095),(79.195,23.095),(79.195,22.925),(79.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.885),(35.315,21.055),(35.485,21.055),(35.485,20.885),(35.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.885),(35.825,21.055),(35.995,21.055),(35.995,20.885),(35.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.185),(30.005,19.355),(30.175,19.355),(30.175,19.185),(30.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.525),(30.005,19.695),(30.175,19.695),(30.175,19.525),(30.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.145),(44.405,17.315),(44.575,17.315),(44.575,17.145),(44.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.825),(44.405,17.995),(44.575,17.995),(44.575,17.825),(44.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.205),(30.515,20.375),(30.685,20.375),(30.685,20.205),(30.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.885),(63.605,4.055),(63.775,4.055),(63.775,3.885),(63.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.905),(50.225,39.075),(50.395,39.075),(50.395,38.905),(50.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.725),(54.005,12.895),(54.175,12.895),(54.175,12.725),(54.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.385),(54.515,12.555),(54.685,12.555),(54.685,12.385),(54.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.045),(54.005,12.215),(54.175,12.215),(54.175,12.045),(54.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,26.325),(16.625,26.495),(16.795,26.495),(16.795,26.325),(16.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,26.665),(16.625,26.835),(16.795,26.835),(16.795,26.665),(16.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.425),(31.025,31.595),(31.195,31.595),(31.195,31.425),(31.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,26.325),(39.605,26.495),(39.775,26.495),(39.775,26.325),(39.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,38.225),(15.605,38.395),(15.775,38.395),(15.775,38.225),(15.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,26.665),(39.605,26.835),(39.775,26.835),(39.775,26.665),(39.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,36.865),(20.915,37.035),(21.085,37.035),(21.085,36.865),(20.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.685),(34.805,27.855),(34.975,27.855),(34.975,27.685),(34.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,25.985),(30.005,26.155),(30.175,26.155),(30.175,25.985),(30.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.025),(55.025,11.195),(55.195,11.195),(55.195,11.025),(55.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.705),(55.025,11.875),(55.195,11.875),(55.195,11.705),(55.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.285),(73.205,7.455),(73.375,7.455),(73.375,7.285),(73.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.285),(73.715,7.455),(73.885,7.455),(73.885,7.285),(73.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,38.565),(7.025,38.735),(7.195,38.735),(7.195,38.565),(7.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,38.225),(83.315,38.395),(83.485,38.395),(83.485,38.225),(83.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,21.905),(6.515,22.075),(6.685,22.075),(6.685,21.905),(6.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.705),(55.025,28.875),(55.195,28.875),(55.195,28.705),(55.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.025),(55.025,28.195),(55.195,28.195),(55.195,28.025),(55.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,25.305),(82.805,25.475),(82.975,25.475),(82.975,25.305),(82.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.485),(45.425,17.655),(45.595,17.655),(45.595,17.485),(45.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.905),(50.225,5.075),(50.395,5.075),(50.395,4.905),(50.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,24.625),(73.205,24.795),(73.375,24.795),(73.375,24.625),(73.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,24.625),(73.715,24.795),(73.885,24.795),(73.885,24.625),(73.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.205),(82.805,3.375),(82.975,3.375),(82.975,3.205),(82.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,24.285),(73.205,24.455),(73.375,24.455),(73.375,24.285),(73.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,24.285),(73.715,24.455),(73.885,24.455),(73.885,24.285),(73.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,22.245),(83.315,22.415),(83.485,22.415),(83.485,22.245),(83.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,22.585),(83.315,22.755),(83.485,22.755),(83.485,22.585),(83.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,35.505),(16.115,35.675),(16.285,35.675),(16.285,35.505),(16.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,35.165),(16.115,35.335),(16.285,35.335),(16.285,35.165),(16.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,20.205),(82.805,20.375),(82.975,20.375),(82.975,20.205),(82.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,20.545),(82.805,20.715),(82.975,20.715),(82.975,20.545),(82.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.185),(31.025,36.355),(31.195,36.355),(31.195,36.185),(31.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.525),(31.025,36.695),(31.195,36.695),(31.195,36.525),(31.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.725),(44.405,12.895),(44.575,12.895),(44.575,12.725),(44.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.045),(44.405,12.215),(44.575,12.215),(44.575,12.045),(44.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,39.585),(69.425,39.755),(69.595,39.755),(69.595,39.585),(69.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.985),(49.205,9.155),(49.375,9.155),(49.375,8.985),(49.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.985),(49.715,9.155),(49.885,9.155),(49.885,8.985),(49.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,23.945),(20.405,24.115),(20.575,24.115),(20.575,23.945),(20.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.745),(40.115,30.915),(40.285,30.915),(40.285,30.745),(40.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.745),(40.625,30.915),(40.795,30.915),(40.795,30.745),(40.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.065),(40.115,30.235),(40.285,30.235),(40.285,30.065),(40.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.065),(40.625,30.235),(40.795,30.235),(40.795,30.065),(40.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.165),(40.115,35.335),(40.285,35.335),(40.285,35.165),(40.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.165),(40.625,35.335),(40.795,35.335),(40.795,35.165),(40.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.505),(40.115,35.675),(40.285,35.675),(40.285,35.505),(40.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.505),(40.625,35.675),(40.795,35.675),(40.795,35.505),(40.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,38.905),(25.205,39.075),(25.375,39.075),(25.375,38.905),(25.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.385),(35.315,29.555),(35.485,29.555),(35.485,29.385),(35.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.385),(35.825,29.555),(35.995,29.555),(35.995,29.385),(35.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,23.945),(74.225,24.115),(74.395,24.115),(74.395,23.945),(74.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.405),(69.425,13.575),(69.595,13.575),(69.595,13.405),(69.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,25.305),(11.825,25.475),(11.995,25.475),(11.995,25.305),(11.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.125),(44.915,16.295),(45.085,16.295),(45.085,16.125),(44.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.465),(44.915,16.635),(45.085,16.635),(45.085,16.465),(44.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.805),(44.915,16.975),(45.085,16.975),(45.085,16.805),(44.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.225),(25.715,4.395),(25.885,4.395),(25.885,4.225),(25.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,24.625),(16.115,24.795),(16.285,24.795),(16.285,24.625),(16.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,30.065),(73.205,30.235),(73.375,30.235),(73.375,30.065),(73.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,30.065),(73.715,30.235),(73.885,30.235),(73.885,30.065),(73.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,30.745),(73.205,30.915),(73.375,30.915),(73.375,30.745),(73.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,30.745),(73.715,30.915),(73.885,30.915),(73.885,30.745),(73.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.845),(59.315,36.015),(59.485,36.015),(59.485,35.845),(59.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,35.165),(78.005,35.335),(78.175,35.335),(78.175,35.165),(78.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,35.165),(78.515,35.335),(78.685,35.335),(78.685,35.165),(78.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,35.505),(78.005,35.675),(78.175,35.675),(78.175,35.505),(78.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,35.505),(78.515,35.675),(78.685,35.675),(78.685,35.505),(78.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,35.845),(59.825,36.015),(59.995,36.015),(59.995,35.845),(59.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.885),(39.605,38.055),(39.775,38.055),(39.775,37.885),(39.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,40.265),(79.025,40.435),(79.195,40.435),(79.195,40.265),(79.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.625),(44.405,7.795),(44.575,7.795),(44.575,7.625),(44.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.985),(59.825,9.155),(59.995,9.155),(59.995,8.985),(59.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.985),(59.315,9.155),(59.485,9.155),(59.485,8.985),(59.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,38.905),(20.405,39.075),(20.575,39.075),(20.575,38.905),(20.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.905),(44.915,22.075),(45.085,22.075),(45.085,21.905),(44.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,36.865),(68.405,37.035),(68.575,37.035),(68.575,36.865),(68.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,34.145),(10.805,34.315),(10.975,34.315),(10.975,34.145),(10.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,34.825),(10.805,34.995),(10.975,34.995),(10.975,34.825),(10.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,34.485),(10.805,34.655),(10.975,34.655),(10.975,34.485),(10.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.245),(40.115,22.415),(40.285,22.415),(40.285,22.245),(40.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.245),(40.625,22.415),(40.795,22.415),(40.795,22.245),(40.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.905),(59.315,39.075),(59.485,39.075),(59.485,38.905),(59.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,38.905),(59.825,39.075),(59.995,39.075),(59.995,38.905),(59.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.925),(31.025,23.095),(31.195,23.095),(31.195,22.925),(31.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.385),(63.605,12.555),(63.775,12.555),(63.775,12.385),(63.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.845),(34.805,36.015),(34.975,36.015),(34.975,35.845),(34.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.365),(44.405,11.535),(44.575,11.535),(44.575,11.365),(44.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.185),(21.425,19.355),(21.595,19.355),(21.595,19.185),(21.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.005),(54.515,27.175),(54.685,27.175),(54.685,27.005),(54.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.345),(54.515,27.515),(54.685,27.515),(54.685,27.345),(54.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,26.325),(69.425,26.495),(69.595,26.495),(69.595,26.325),(69.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.105),(73.205,15.275),(73.375,15.275),(73.375,15.105),(73.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.105),(73.715,15.275),(73.885,15.275),(73.885,15.105),(73.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,40.265),(30.005,40.435),(30.175,40.435),(30.175,40.265),(30.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.605),(20.405,6.775),(20.575,6.775),(20.575,6.605),(20.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.265),(20.405,6.435),(20.575,6.435),(20.575,6.265),(20.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.725),(49.715,29.895),(49.885,29.895),(49.885,29.725),(49.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.045),(49.715,29.215),(49.885,29.215),(49.885,29.045),(49.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.725),(49.205,29.895),(49.375,29.895),(49.375,29.725),(49.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.045),(49.205,29.215),(49.375,29.215),(49.375,29.045),(49.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.885),(40.115,21.055),(40.285,21.055),(40.285,20.885),(40.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.885),(40.625,21.055),(40.795,21.055),(40.795,20.885),(40.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.185),(54.515,36.355),(54.685,36.355),(54.685,36.185),(54.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.525),(54.515,36.695),(54.685,36.695),(54.685,36.525),(54.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.085),(25.205,14.255),(25.375,14.255),(25.375,14.085),(25.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.765),(25.205,14.935),(25.375,14.935),(25.375,14.765),(25.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.425),(25.205,14.595),(25.375,14.595),(25.375,14.425),(25.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,31.425),(69.425,31.595),(69.595,31.595),(69.595,31.425),(69.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.745),(50.225,30.915),(50.395,30.915),(50.395,30.745),(50.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.985),(21.425,9.155),(21.595,9.155),(21.595,8.985),(21.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.065),(50.225,30.235),(50.395,30.235),(50.395,30.065),(50.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,30.405),(69.425,30.575),(69.595,30.575),(69.595,30.405),(69.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.405),(31.025,30.575),(31.195,30.575),(31.195,30.405),(31.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.845),(63.605,19.015),(63.775,19.015),(63.775,18.845),(63.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.905),(50.225,22.075),(50.395,22.075),(50.395,21.905),(50.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,20.545),(16.115,20.715),(16.285,20.715),(16.285,20.545),(16.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,23.605),(11.315,23.775),(11.485,23.775),(11.485,23.605),(11.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,22.925),(15.605,23.095),(15.775,23.095),(15.775,22.925),(15.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.365),(68.915,11.535),(69.085,11.535),(69.085,11.365),(68.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.625),(30.515,7.795),(30.685,7.795),(30.685,7.625),(30.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.025),(63.605,11.195),(63.775,11.195),(63.775,11.025),(63.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.705),(63.605,11.875),(63.775,11.875),(63.775,11.705),(63.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,40.605),(20.915,40.775),(21.085,40.775),(21.085,40.605),(20.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.365),(63.605,11.535),(63.775,11.535),(63.775,11.365),(63.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,26.665),(35.315,26.835),(35.485,26.835),(35.485,26.665),(35.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.365),(20.915,11.535),(21.085,11.535),(21.085,11.365),(20.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,26.665),(35.825,26.835),(35.995,26.835),(35.995,26.665),(35.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,26.325),(35.315,26.495),(35.485,26.495),(35.485,26.325),(35.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,26.325),(35.825,26.495),(35.995,26.495),(35.995,26.325),(35.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.945),(10.805,7.115),(10.975,7.115),(10.975,6.945),(10.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.805),(10.805,16.975),(10.975,16.975),(10.975,16.805),(10.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.125),(10.805,16.295),(10.975,16.295),(10.975,16.125),(10.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.165),(74.225,18.335),(74.395,18.335),(74.395,18.165),(74.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.505),(74.225,18.675),(74.395,18.675),(74.395,18.505),(74.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,26.665),(63.605,26.835),(63.775,26.835),(63.775,26.665),(63.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,26.325),(63.605,26.495),(63.775,26.495),(63.775,26.325),(63.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,24.965),(68.405,25.135),(68.575,25.135),(68.575,24.965),(68.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,30.065),(15.605,30.235),(15.775,30.235),(15.775,30.065),(15.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,30.405),(15.605,30.575),(15.775,30.575),(15.775,30.405),(15.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,30.745),(15.605,30.915),(15.775,30.915),(15.775,30.745),(15.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.885),(35.315,38.055),(35.485,38.055),(35.485,37.885),(35.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.885),(35.825,38.055),(35.995,38.055),(35.995,37.885),(35.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.565),(49.715,4.735),(49.885,4.735),(49.885,4.565),(49.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.225),(49.205,4.395),(49.375,4.395),(49.375,4.225),(49.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.225),(49.715,4.395),(49.885,4.395),(49.885,4.225),(49.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.565),(49.205,4.735),(49.375,4.735),(49.375,4.565),(49.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,27.685),(82.805,27.855),(82.975,27.855),(82.975,27.685),(82.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.845),(44.405,36.015),(44.575,36.015),(44.575,35.845),(44.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.425),(39.605,14.595),(39.775,14.595),(39.775,14.425),(39.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.765),(39.605,14.935),(39.775,14.935),(39.775,14.765),(39.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.085),(39.605,14.255),(39.775,14.255),(39.775,14.085),(39.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,20.545),(7.025,20.715),(7.195,20.715),(7.195,20.545),(7.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,20.205),(7.025,20.375),(7.195,20.375),(7.195,20.205),(7.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.425),(45.425,31.595),(45.595,31.595),(45.595,31.425),(45.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.765),(45.425,31.935),(45.595,31.935),(45.595,31.765),(45.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.085),(45.425,31.255),(45.595,31.255),(45.595,31.085),(45.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.225),(30.515,4.395),(30.685,4.395),(30.685,4.225),(30.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.845),(21.425,19.015),(21.595,19.015),(21.595,18.845),(21.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.985),(78.005,9.155),(78.175,9.155),(78.175,8.985),(78.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.985),(78.515,9.155),(78.685,9.155),(78.685,8.985),(78.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,36.865),(64.115,37.035),(64.285,37.035),(64.285,36.865),(64.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,36.865),(64.625,37.035),(64.795,37.035),(64.795,36.865),(64.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.825),(79.025,17.995),(79.195,17.995),(79.195,17.825),(79.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.145),(79.025,17.315),(79.195,17.315),(79.195,17.145),(79.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.485),(79.025,17.655),(79.195,17.655),(79.195,17.485),(79.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.805),(44.405,33.975),(44.575,33.975),(44.575,33.805),(44.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.885),(54.005,38.055),(54.175,38.055),(54.175,37.885),(54.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.125),(44.405,33.295),(44.575,33.295),(44.575,33.125),(44.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.465),(44.405,33.635),(44.575,33.635),(44.575,33.465),(44.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.365),(54.005,28.535),(54.175,28.535),(54.175,28.365),(54.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.705),(54.515,28.875),(54.685,28.875),(54.685,28.705),(54.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.025),(54.515,28.195),(54.685,28.195),(54.685,28.025),(54.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,22.925),(21.425,23.095),(21.595,23.095),(21.595,22.925),(21.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,20.885),(25.205,21.055),(25.375,21.055),(25.375,20.885),(25.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,35.845),(30.005,36.015),(30.175,36.015),(30.175,35.845),(30.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.685),(44.915,10.855),(45.085,10.855),(45.085,10.685),(44.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.005),(44.915,10.175),(45.085,10.175),(45.085,10.005),(44.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.345),(44.915,10.515),(45.085,10.515),(45.085,10.345),(44.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.925),(54.515,40.095),(54.685,40.095),(54.685,39.925),(54.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.305),(25.205,8.475),(25.375,8.475),(25.375,8.305),(25.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.645),(25.205,8.815),(25.375,8.815),(25.375,8.645),(25.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.625),(54.005,24.795),(54.175,24.795),(54.175,24.625),(54.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.285),(54.005,24.455),(54.175,24.455),(54.175,24.285),(54.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,40.605),(78.005,40.775),(78.175,40.775),(78.175,40.605),(78.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,40.605),(78.515,40.775),(78.685,40.775),(78.685,40.605),(78.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,38.225),(16.625,38.395),(16.795,38.395),(16.795,38.225),(16.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.985),(59.315,26.155),(59.485,26.155),(59.485,25.985),(59.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,25.985),(59.825,26.155),(59.995,26.155),(59.995,25.985),(59.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,40.265),(64.115,40.435),(64.285,40.435),(64.285,40.265),(64.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,40.265),(64.625,40.435),(64.795,40.435),(64.795,40.265),(64.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.345),(49.205,10.515),(49.375,10.515),(49.375,10.345),(49.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.045),(21.425,12.215),(21.595,12.215),(21.595,12.045),(21.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.385),(21.425,12.555),(21.595,12.555),(21.595,12.385),(21.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.345),(49.715,10.515),(49.885,10.515),(49.885,10.345),(49.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.725),(21.425,12.895),(21.595,12.895),(21.595,12.725),(21.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.645),(30.515,25.815),(30.685,25.815),(30.685,25.645),(30.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.305),(30.515,25.475),(30.685,25.475),(30.685,25.305),(30.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.505),(39.605,18.675),(39.775,18.675),(39.775,18.505),(39.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,39.925),(26.225,40.095),(26.395,40.095),(26.395,39.925),(26.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.945),(49.205,24.115),(49.375,24.115),(49.375,23.945),(49.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.945),(49.715,24.115),(49.885,24.115),(49.885,23.945),(49.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.425),(55.025,31.595),(55.195,31.595),(55.195,31.425),(55.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.025),(59.315,11.195),(59.485,11.195),(59.485,11.025),(59.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.025),(59.825,11.195),(59.995,11.195),(59.995,11.025),(59.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.365),(59.315,11.535),(59.485,11.535),(59.485,11.365),(59.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.365),(59.825,11.535),(59.995,11.535),(59.995,11.365),(59.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.705),(59.315,11.875),(59.485,11.875),(59.485,11.705),(59.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.705),(59.825,11.875),(59.995,11.875),(59.995,11.705),(59.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.605),(64.115,6.775),(64.285,6.775),(64.285,6.605),(64.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.665),(20.915,9.835),(21.085,9.835),(21.085,9.665),(20.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.225),(82.805,4.395),(82.975,4.395),(82.975,4.225),(82.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.925),(26.225,6.095),(26.395,6.095),(26.395,5.925),(26.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.565),(82.805,4.735),(82.975,4.735),(82.975,4.565),(82.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.485),(74.225,17.655),(74.395,17.655),(74.395,17.485),(74.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,2.865),(15.605,3.035),(15.775,3.035),(15.775,2.865),(15.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,26.665),(45.425,26.835),(45.595,26.835),(45.595,26.665),(45.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.845),(30.005,19.015),(30.175,19.015),(30.175,18.845),(30.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.625),(78.515,7.795),(78.685,7.795),(78.685,7.625),(78.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.625),(78.005,7.795),(78.175,7.795),(78.175,7.625),(78.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,30.745),(30.005,30.915),(30.175,30.915),(30.175,30.745),(30.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.985),(45.425,9.155),(45.595,9.155),(45.595,8.985),(45.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,30.065),(30.005,30.235),(30.175,30.235),(30.175,30.065),(30.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.025),(10.805,11.195),(10.975,11.195),(10.975,11.025),(10.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.365),(10.805,11.535),(10.975,11.535),(10.975,11.365),(10.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.705),(10.805,11.875),(10.975,11.875),(10.975,11.705),(10.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,40.605),(15.605,40.775),(15.775,40.775),(15.775,40.605),(15.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.765),(73.715,14.935),(73.885,14.935),(73.885,14.765),(73.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.085),(73.205,14.255),(73.375,14.255),(73.375,14.085),(73.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.085),(73.715,14.255),(73.885,14.255),(73.885,14.085),(73.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.765),(73.205,14.935),(73.375,14.935),(73.375,14.765),(73.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.745),(45.425,30.915),(45.595,30.915),(45.595,30.745),(45.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.065),(45.425,30.235),(45.595,30.235),(45.595,30.065),(45.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,40.605),(16.625,40.775),(16.795,40.775),(16.795,40.605),(16.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,26.325),(30.005,26.495),(30.175,26.495),(30.175,26.325),(30.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.605),(50.225,6.775),(50.395,6.775),(50.395,6.605),(50.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.265),(50.225,6.435),(50.395,6.435),(50.395,6.265),(50.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,33.125),(82.805,33.295),(82.975,33.295),(82.975,33.125),(82.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,33.465),(82.805,33.635),(82.975,33.635),(82.975,33.465),(82.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,33.805),(82.805,33.975),(82.975,33.975),(82.975,33.805),(82.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,25.305),(25.715,25.475),(25.885,25.475),(25.885,25.305),(25.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,25.645),(25.715,25.815),(25.885,25.815),(25.885,25.645),(25.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,25.305),(63.605,25.475),(63.775,25.475),(63.775,25.305),(63.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.405),(45.425,13.575),(45.595,13.575),(45.595,13.405),(45.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.705),(35.315,28.875),(35.485,28.875),(35.485,28.705),(35.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.705),(35.825,28.875),(35.995,28.875),(35.995,28.705),(35.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.025),(35.315,28.195),(35.485,28.195),(35.485,28.025),(35.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.025),(35.825,28.195),(35.995,28.195),(35.995,28.025),(35.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,22.585),(11.825,22.755),(11.995,22.755),(11.995,22.585),(11.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,34.485),(79.025,34.655),(79.195,34.655),(79.195,34.485),(79.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,34.825),(79.025,34.995),(79.195,34.995),(79.195,34.825),(79.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,34.145),(79.025,34.315),(79.195,34.315),(79.195,34.145),(79.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.625),(83.315,7.795),(83.485,7.795),(83.485,7.625),(83.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.565),(78.005,4.735),(78.175,4.735),(78.175,4.565),(78.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.565),(78.515,4.735),(78.685,4.735),(78.685,4.565),(78.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,22.245),(30.005,22.415),(30.175,22.415),(30.175,22.245),(30.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,22.585),(30.005,22.755),(30.175,22.755),(30.175,22.585),(30.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,26.665),(55.025,26.835),(55.195,26.835),(55.195,26.665),(55.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,26.325),(55.025,26.495),(55.195,26.495),(55.195,26.325),(55.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.905),(10.805,5.075),(10.975,5.075),(10.975,4.905),(10.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.525),(35.315,19.695),(35.485,19.695),(35.485,19.525),(35.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.525),(35.825,19.695),(35.995,19.695),(35.995,19.525),(35.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.185),(35.825,19.355),(35.995,19.355),(35.995,19.185),(35.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.745),(55.025,30.915),(55.195,30.915),(55.195,30.745),(55.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.065),(55.025,30.235),(55.195,30.235),(55.195,30.065),(55.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.405),(55.025,30.575),(55.195,30.575),(55.195,30.405),(55.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.805),(35.315,33.975),(35.485,33.975),(35.485,33.805),(35.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.805),(35.825,33.975),(35.995,33.975),(35.995,33.805),(35.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.125),(35.315,33.295),(35.485,33.295),(35.485,33.125),(35.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.125),(35.825,33.295),(35.995,33.295),(35.995,33.125),(35.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.465),(35.315,33.635),(35.485,33.635),(35.485,33.465),(35.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.465),(35.825,33.635),(35.995,33.635),(35.995,33.465),(35.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.885),(34.805,21.055),(34.975,21.055),(34.975,20.885),(34.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.125),(16.625,16.295),(16.795,16.295),(16.795,16.125),(16.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.805),(16.625,16.975),(16.795,16.975),(16.795,16.805),(16.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,28.365),(10.805,28.535),(10.975,28.535),(10.975,28.365),(10.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.805),(59.315,16.975),(59.485,16.975),(59.485,16.805),(59.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.125),(59.315,16.295),(59.485,16.295),(59.485,16.125),(59.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.125),(59.825,16.295),(59.995,16.295),(59.995,16.125),(59.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.805),(59.825,16.975),(59.995,16.975),(59.995,16.805),(59.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.625),(11.315,7.795),(11.485,7.795),(11.485,7.625),(11.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.625),(11.825,7.795),(11.995,7.795),(11.995,7.625),(11.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,38.565),(64.115,38.735),(64.285,38.735),(64.285,38.565),(64.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,38.565),(64.625,38.735),(64.795,38.735),(64.795,38.565),(64.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.305),(49.715,25.475),(49.885,25.475),(49.885,25.305),(49.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,27.685),(83.315,27.855),(83.485,27.855),(83.485,27.685),(83.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.305),(49.205,25.475),(49.375,25.475),(49.375,25.305),(49.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.185),(34.805,36.355),(34.975,36.355),(34.975,36.185),(34.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.525),(34.805,36.695),(34.975,36.695),(34.975,36.525),(34.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.185),(11.315,19.355),(11.485,19.355),(11.485,19.185),(11.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.485),(31.025,17.655),(31.195,17.655),(31.195,17.485),(31.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,28.365),(20.915,28.535),(21.085,28.535),(21.085,28.365),(20.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,28.705),(20.915,28.875),(21.085,28.875),(21.085,28.705),(20.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,28.025),(20.915,28.195),(21.085,28.195),(21.085,28.025),(20.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.825),(31.025,17.995),(31.195,17.995),(31.195,17.825),(31.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.145),(31.025,17.315),(31.195,17.315),(31.195,17.145),(31.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.405),(49.715,13.575),(49.885,13.575),(49.885,13.405),(49.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.405),(49.205,13.575),(49.375,13.575),(49.375,13.405),(49.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.285),(26.225,7.455),(26.395,7.455),(26.395,7.285),(26.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,24.965),(25.715,25.135),(25.885,25.135),(25.885,24.965),(25.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.225),(39.605,21.395),(39.775,21.395),(39.775,21.225),(39.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,24.965),(64.115,25.135),(64.285,25.135),(64.285,24.965),(64.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,24.965),(64.625,25.135),(64.795,25.135),(64.795,24.965),(64.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,39.245),(11.825,39.415),(11.995,39.415),(11.995,39.245),(11.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,21.905),(69.425,22.075),(69.595,22.075),(69.595,21.905),(69.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.725),(45.425,12.895),(45.595,12.895),(45.595,12.725),(45.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.045),(45.425,12.215),(45.595,12.215),(45.595,12.045),(45.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.425),(35.825,31.595),(35.995,31.595),(35.995,31.425),(35.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.765),(35.315,31.935),(35.485,31.935),(35.485,31.765),(35.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.765),(35.825,31.935),(35.995,31.935),(35.995,31.765),(35.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.425),(35.315,31.595),(35.485,31.595),(35.485,31.425),(35.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.085),(35.315,31.255),(35.485,31.255),(35.485,31.085),(35.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.085),(35.825,31.255),(35.995,31.255),(35.995,31.085),(35.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.385),(69.425,12.555),(69.595,12.555),(69.595,12.385),(69.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.725),(69.425,12.895),(69.595,12.895),(69.595,12.725),(69.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.045),(69.425,12.215),(69.595,12.215),(69.595,12.045),(69.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,27.005),(25.205,27.175),(25.375,27.175),(25.375,27.005),(25.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,27.685),(25.715,27.855),(25.885,27.855),(25.885,27.685),(25.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,27.345),(25.205,27.515),(25.375,27.515),(25.375,27.345),(25.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.965),(50.225,8.135),(50.395,8.135),(50.395,7.965),(50.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,27.005),(21.425,27.175),(21.595,27.175),(21.595,27.005),(21.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,28.365),(6.515,28.535),(6.685,28.535),(6.685,28.365),(6.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.905),(78.005,5.075),(78.175,5.075),(78.175,4.905),(78.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.905),(78.515,5.075),(78.685,5.075),(78.685,4.905),(78.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.825),(15.605,17.995),(15.775,17.995),(15.775,17.825),(15.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.145),(15.605,17.315),(15.775,17.315),(15.775,17.145),(15.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,24.965),(78.005,25.135),(78.175,25.135),(78.175,24.965),(78.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,24.965),(78.515,25.135),(78.685,25.135),(78.685,24.965),(78.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.665),(44.915,9.835),(45.085,9.835),(45.085,9.665),(44.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,39.925),(82.805,40.095),(82.975,40.095),(82.975,39.925),(82.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,24.625),(6.515,24.795),(6.685,24.795),(6.685,24.625),(6.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,24.285),(6.515,24.455),(6.685,24.455),(6.685,24.285),(6.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,34.145),(73.205,34.315),(73.375,34.315),(73.375,34.145),(73.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,34.145),(73.715,34.315),(73.885,34.315),(73.885,34.145),(73.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,34.485),(73.205,34.655),(73.375,34.655),(73.375,34.485),(73.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,34.485),(73.715,34.655),(73.885,34.655),(73.885,34.485),(73.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,34.825),(73.205,34.995),(73.375,34.995),(73.375,34.825),(73.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,34.825),(73.715,34.995),(73.885,34.995),(73.885,34.825),(73.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.925),(68.405,6.095),(68.575,6.095),(68.575,5.925),(68.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.965),(44.405,25.135),(44.575,25.135),(44.575,24.965),(44.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,20.885),(78.005,21.055),(78.175,21.055),(78.175,20.885),(78.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,20.885),(78.515,21.055),(78.685,21.055),(78.685,20.885),(78.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,27.685),(74.225,27.855),(74.395,27.855),(74.395,27.685),(74.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.225),(40.115,21.395),(40.285,21.395),(40.285,21.225),(40.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.225),(40.625,21.395),(40.795,21.395),(40.795,21.225),(40.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.565),(40.115,21.735),(40.285,21.735),(40.285,21.565),(40.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.565),(40.625,21.735),(40.795,21.735),(40.795,21.565),(40.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.865),(39.605,20.035),(39.775,20.035),(39.775,19.865),(39.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.285),(31.025,7.455),(31.195,7.455),(31.195,7.285),(31.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.365),(82.805,11.535),(82.975,11.535),(82.975,11.365),(82.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,24.965),(20.915,25.135),(21.085,25.135),(21.085,24.965),(20.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.305),(54.005,25.475),(54.175,25.475),(54.175,25.305),(54.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.645),(54.515,25.815),(54.685,25.815),(54.685,25.645),(54.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,20.885),(64.115,21.055),(64.285,21.055),(64.285,20.885),(64.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,30.065),(16.625,30.235),(16.795,30.235),(16.795,30.065),(16.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,30.745),(16.625,30.915),(16.795,30.915),(16.795,30.745),(16.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,20.885),(64.625,21.055),(64.795,21.055),(64.795,20.885),(64.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.965),(35.825,25.135),(35.995,25.135),(35.995,24.965),(35.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.965),(35.315,25.135),(35.485,25.135),(35.485,24.965),(35.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.065),(82.805,13.235),(82.975,13.235),(82.975,13.065),(82.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.745),(82.805,13.915),(82.975,13.915),(82.975,13.745),(82.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.845),(11.315,19.015),(11.485,19.015),(11.485,18.845),(11.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.845),(11.825,19.015),(11.995,19.015),(11.995,18.845),(11.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.705),(50.225,28.875),(50.395,28.875),(50.395,28.705),(50.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.025),(50.225,28.195),(50.395,28.195),(50.395,28.025),(50.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,24.965),(63.605,25.135),(63.775,25.135),(63.775,24.965),(63.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.845),(69.425,19.015),(69.595,19.015),(69.595,18.845),(69.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.905),(68.915,5.075),(69.085,5.075),(69.085,4.905),(68.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.605),(39.605,6.775),(39.775,6.775),(39.775,6.605),(39.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,35.505),(6.515,35.675),(6.685,35.675),(6.685,35.505),(6.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,35.165),(6.515,35.335),(6.685,35.335),(6.685,35.165),(6.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.525),(74.225,19.695),(74.395,19.695),(74.395,19.525),(74.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,22.925),(69.425,23.095),(69.595,23.095),(69.595,22.925),(69.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,40.605),(39.605,40.775),(39.775,40.775),(39.775,40.605),(39.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,21.905),(83.315,22.075),(83.485,22.075),(83.485,21.905),(83.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,40.265),(11.825,40.435),(11.995,40.435),(11.995,40.265),(11.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.345),(78.005,10.515),(78.175,10.515),(78.175,10.345),(78.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.345),(78.515,10.515),(78.685,10.515),(78.685,10.345),(78.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,38.905),(11.315,39.075),(11.485,39.075),(11.485,38.905),(11.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.905),(7.025,5.075),(7.195,5.075),(7.195,4.905),(7.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,33.465),(7.025,33.635),(7.195,33.635),(7.195,33.465),(7.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,33.805),(7.025,33.975),(7.195,33.975),(7.195,33.805),(7.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,33.125),(7.025,33.295),(7.195,33.295),(7.195,33.125),(7.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,25.305),(26.225,25.475),(26.395,25.475),(26.395,25.305),(26.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.205),(6.515,3.375),(6.685,3.375),(6.685,3.205),(6.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.685),(59.315,27.855),(59.485,27.855),(59.485,27.685),(59.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,27.685),(59.825,27.855),(59.995,27.855),(59.995,27.685),(59.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.965),(49.205,25.135),(49.375,25.135),(49.375,24.965),(49.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.965),(49.715,25.135),(49.885,25.135),(49.885,24.965),(49.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.845),(35.315,19.015),(35.485,19.015),(35.485,18.845),(35.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.845),(35.825,19.015),(35.995,19.015),(35.995,18.845),(35.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,25.305),(20.915,25.475),(21.085,25.475),(21.085,25.305),(20.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.785),(40.625,32.955),(40.795,32.955),(40.795,32.785),(40.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.105),(40.115,32.275),(40.285,32.275),(40.285,32.105),(40.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.105),(40.625,32.275),(40.795,32.275),(40.795,32.105),(40.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.445),(40.115,32.615),(40.285,32.615),(40.285,32.445),(40.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.445),(40.625,32.615),(40.795,32.615),(40.795,32.445),(40.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.785),(40.115,32.955),(40.285,32.955),(40.285,32.785),(40.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,20.885),(15.605,21.055),(15.775,21.055),(15.775,20.885),(15.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.265),(78.005,6.435),(78.175,6.435),(78.175,6.265),(78.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.265),(78.515,6.435),(78.685,6.435),(78.685,6.265),(78.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.305),(39.605,8.475),(39.775,8.475),(39.775,8.305),(39.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.645),(39.605,8.815),(39.775,8.815),(39.775,8.645),(39.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.265),(55.025,23.435),(55.195,23.435),(55.195,23.265),(55.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.465),(50.225,16.635),(50.395,16.635),(50.395,16.465),(50.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.805),(50.225,16.975),(50.395,16.975),(50.395,16.805),(50.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.265),(25.205,6.435),(25.375,6.435),(25.375,6.265),(25.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.605),(25.205,6.775),(25.375,6.775),(25.375,6.605),(25.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.125),(50.225,16.295),(50.395,16.295),(50.395,16.125),(50.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,40.605),(20.405,40.775),(20.575,40.775),(20.575,40.605),(20.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.005),(30.515,10.175),(30.685,10.175),(30.685,10.005),(30.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.345),(30.515,10.515),(30.685,10.515),(30.685,10.345),(30.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.685),(30.515,10.855),(30.685,10.855),(30.685,10.685),(30.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.085),(74.225,14.255),(74.395,14.255),(74.395,14.085),(74.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.425),(74.225,14.595),(74.395,14.595),(74.395,14.425),(74.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.765),(74.225,14.935),(74.395,14.935),(74.395,14.765),(74.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.325),(31.025,9.495),(31.195,9.495),(31.195,9.325),(31.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.665),(31.025,9.835),(31.195,9.835),(31.195,9.665),(31.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.965),(44.915,8.135),(45.085,8.135),(45.085,7.965),(44.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.085),(26.225,14.255),(26.395,14.255),(26.395,14.085),(26.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.765),(26.225,14.935),(26.395,14.935),(26.395,14.765),(26.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,37.545),(25.715,37.715),(25.885,37.715),(25.885,37.545),(25.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.565),(68.915,4.735),(69.085,4.735),(69.085,4.565),(68.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,25.305),(73.715,25.475),(73.885,25.475),(73.885,25.305),(73.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,25.305),(73.205,25.475),(73.375,25.475),(73.375,25.305),(73.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,25.645),(73.205,25.815),(73.375,25.815),(73.375,25.645),(73.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,25.645),(73.715,25.815),(73.885,25.815),(73.885,25.645),(73.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,37.545),(74.225,37.715),(74.395,37.715),(74.395,37.545),(74.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.225),(20.915,4.395),(21.085,4.395),(21.085,4.225),(20.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.565),(20.915,4.735),(21.085,4.735),(21.085,4.565),(20.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.965),(30.515,25.135),(30.685,25.135),(30.685,24.965),(30.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.865),(74.225,20.035),(74.395,20.035),(74.395,19.865),(74.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.205),(11.315,3.375),(11.485,3.375),(11.485,3.205),(11.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.265),(30.515,6.435),(30.685,6.435),(30.685,6.265),(30.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.845),(44.915,36.015),(45.085,36.015),(45.085,35.845),(44.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.885),(30.515,21.055),(30.685,21.055),(30.685,20.885),(30.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.205),(68.915,3.375),(69.085,3.375),(69.085,3.205),(68.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,27.005),(30.005,27.175),(30.175,27.175),(30.175,27.005),(30.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.685),(30.515,27.855),(30.685,27.855),(30.685,27.685),(30.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,38.905),(15.605,39.075),(15.775,39.075),(15.775,38.905),(15.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.545),(20.915,3.715),(21.085,3.715),(21.085,3.545),(20.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,22.245),(64.115,22.415),(64.285,22.415),(64.285,22.245),(64.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,22.245),(64.625,22.415),(64.795,22.415),(64.795,22.245),(64.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,36.525),(20.915,36.695),(21.085,36.695),(21.085,36.525),(20.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,36.185),(20.915,36.355),(21.085,36.355),(21.085,36.185),(20.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.265),(44.405,23.435),(44.575,23.435),(44.575,23.265),(44.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.165),(55.025,18.335),(55.195,18.335),(55.195,18.165),(55.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,26.325),(50.225,26.495),(50.395,26.495),(50.395,26.325),(50.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,28.365),(30.005,28.535),(30.175,28.535),(30.175,28.365),(30.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,28.025),(30.005,28.195),(30.175,28.195),(30.175,28.025),(30.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,28.705),(30.005,28.875),(30.175,28.875),(30.175,28.705),(30.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.465),(39.605,16.635),(39.775,16.635),(39.775,16.465),(39.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,30.065),(7.025,30.235),(7.195,30.235),(7.195,30.065),(7.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,30.405),(7.025,30.575),(7.195,30.575),(7.195,30.405),(7.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,30.745),(7.025,30.915),(7.195,30.915),(7.195,30.745),(7.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,28.705),(68.915,28.875),(69.085,28.875),(69.085,28.705),(68.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,28.025),(68.915,28.195),(69.085,28.195),(69.085,28.025),(68.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,25.985),(69.425,26.155),(69.595,26.155),(69.595,25.985),(69.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.585),(63.605,5.755),(63.775,5.755),(63.775,5.585),(63.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,38.905),(83.315,39.075),(83.485,39.075),(83.485,38.905),(83.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.545),(39.605,20.715),(39.775,20.715),(39.775,20.545),(39.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.345),(35.315,27.515),(35.485,27.515),(35.485,27.345),(35.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,22.925),(78.005,23.095),(78.175,23.095),(78.175,22.925),(78.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,22.925),(78.515,23.095),(78.685,23.095),(78.685,22.925),(78.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.345),(35.825,27.515),(35.995,27.515),(35.995,27.345),(35.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,36.525),(69.425,36.695),(69.595,36.695),(69.595,36.525),(69.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,36.185),(69.425,36.355),(69.595,36.355),(69.595,36.185),(69.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,24.965),(73.205,25.135),(73.375,25.135),(73.375,24.965),(73.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,24.965),(73.715,25.135),(73.885,25.135),(73.885,24.965),(73.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.885),(55.025,38.055),(55.195,38.055),(55.195,37.885),(55.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,27.345),(63.605,27.515),(63.775,27.515),(63.775,27.345),(63.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.965),(10.805,8.135),(10.975,8.135),(10.975,7.965),(10.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,20.885),(82.805,21.055),(82.975,21.055),(82.975,20.885),(82.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.065),(35.315,30.235),(35.485,30.235),(35.485,30.065),(35.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.065),(35.825,30.235),(35.995,30.235),(35.995,30.065),(35.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.745),(35.315,30.915),(35.485,30.915),(35.485,30.745),(35.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.745),(35.825,30.915),(35.995,30.915),(35.995,30.745),(35.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.405),(35.315,30.575),(35.485,30.575),(35.485,30.405),(35.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.405),(35.825,30.575),(35.995,30.575),(35.995,30.405),(35.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.865),(31.025,37.035),(31.195,37.035),(31.195,36.865),(31.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.165),(25.205,18.335),(25.375,18.335),(25.375,18.165),(25.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.505),(25.205,18.675),(25.375,18.675),(25.375,18.505),(25.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.265),(49.205,6.435),(49.375,6.435),(49.375,6.265),(49.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.265),(49.715,6.435),(49.885,6.435),(49.885,6.265),(49.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.605),(49.205,6.775),(49.375,6.775),(49.375,6.605),(49.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.605),(49.715,6.775),(49.885,6.775),(49.885,6.605),(49.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,36.525),(10.805,36.695),(10.975,36.695),(10.975,36.525),(10.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,36.185),(10.805,36.355),(10.975,36.355),(10.975,36.185),(10.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,38.225),(74.225,38.395),(74.395,38.395),(74.395,38.225),(74.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,37.885),(10.805,38.055),(10.975,38.055),(10.975,37.885),(10.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,25.985),(74.225,26.155),(74.395,26.155),(74.395,25.985),(74.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.725),(59.315,12.895),(59.485,12.895),(59.485,12.725),(59.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.725),(59.825,12.895),(59.995,12.895),(59.995,12.725),(59.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.045),(59.315,12.215),(59.485,12.215),(59.485,12.045),(59.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.045),(59.825,12.215),(59.995,12.215),(59.995,12.045),(59.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.545),(74.225,3.715),(74.395,3.715),(74.395,3.545),(74.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.885),(31.025,38.055),(31.195,38.055),(31.195,37.885),(31.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,22.925),(10.805,23.095),(10.975,23.095),(10.975,22.925),(10.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,23.265),(74.225,23.435),(74.395,23.435),(74.395,23.265),(74.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.205),(26.225,3.375),(26.395,3.375),(26.395,3.205),(26.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.545),(26.225,3.715),(26.395,3.715),(26.395,3.545),(26.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.785),(68.405,15.955),(68.575,15.955),(68.575,15.785),(68.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.085),(16.625,14.255),(16.795,14.255),(16.795,14.085),(16.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.765),(16.625,14.935),(16.795,14.935),(16.795,14.765),(16.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,24.965),(68.915,25.135),(69.085,25.135),(69.085,24.965),(68.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.205),(39.605,37.375),(39.775,37.375),(39.775,37.205),(39.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.305),(54.005,8.475),(54.175,8.475),(54.175,8.305),(54.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.645),(54.515,8.815),(54.685,8.815),(54.685,8.645),(54.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,36.525),(21.425,36.695),(21.595,36.695),(21.595,36.525),(21.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,36.185),(21.425,36.355),(21.595,36.355),(21.595,36.185),(21.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.885),(55.025,4.055),(55.195,4.055),(55.195,3.885),(55.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.725),(50.225,12.895),(50.395,12.895),(50.395,12.725),(50.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.385),(50.225,12.555),(50.395,12.555),(50.395,12.385),(50.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,40.605),(35.315,40.775),(35.485,40.775),(35.485,40.605),(35.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,40.605),(35.825,40.775),(35.995,40.775),(35.995,40.605),(35.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.045),(50.225,12.215),(50.395,12.215),(50.395,12.045),(50.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.565),(58.805,38.735),(58.975,38.735),(58.975,38.565),(58.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,23.605),(7.025,23.775),(7.195,23.775),(7.195,23.605),(7.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.825),(11.315,17.995),(11.485,17.995),(11.485,17.825),(11.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.145),(11.315,17.315),(11.485,17.315),(11.485,17.145),(11.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.485),(11.315,17.655),(11.485,17.655),(11.485,17.485),(11.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,23.605),(63.605,23.775),(63.775,23.775),(63.775,23.605),(63.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.425),(20.915,14.595),(21.085,14.595),(21.085,14.425),(20.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.085),(20.915,14.255),(21.085,14.255),(21.085,14.085),(20.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.765),(20.915,14.935),(21.085,14.935),(21.085,14.765),(20.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.105),(31.025,32.275),(31.195,32.275),(31.195,32.105),(31.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.445),(31.025,32.615),(31.195,32.615),(31.195,32.445),(31.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.785),(31.025,32.955),(31.195,32.955),(31.195,32.785),(31.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,33.125),(63.605,33.295),(63.775,33.295),(63.775,33.125),(63.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,33.805),(63.605,33.975),(63.775,33.975),(63.775,33.805),(63.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,33.465),(63.605,33.635),(63.775,33.635),(63.775,33.465),(63.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.485),(20.405,17.655),(20.575,17.655),(20.575,17.485),(20.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.945),(20.405,7.115),(20.575,7.115),(20.575,6.945),(20.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,22.245),(16.115,22.415),(16.285,22.415),(16.285,22.245),(16.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.865),(54.515,37.035),(54.685,37.035),(54.685,36.865),(54.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.725),(44.405,29.895),(44.575,29.895),(44.575,29.725),(44.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.045),(44.405,29.215),(44.575,29.215),(44.575,29.045),(44.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.385),(44.405,29.555),(44.575,29.555),(44.575,29.385),(44.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.445),(59.825,15.615),(59.995,15.615),(59.995,15.445),(59.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.445),(59.315,15.615),(59.485,15.615),(59.485,15.445),(59.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,21.565),(21.425,21.735),(21.595,21.735),(21.595,21.565),(21.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,29.385),(68.405,29.555),(68.575,29.555),(68.575,29.385),(68.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.905),(21.425,5.075),(21.595,5.075),(21.595,4.905),(21.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.165),(50.225,35.335),(50.395,35.335),(50.395,35.165),(50.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.505),(50.225,35.675),(50.395,35.675),(50.395,35.505),(50.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,25.985),(20.405,26.155),(20.575,26.155),(20.575,25.985),(20.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.885),(74.225,4.055),(74.395,4.055),(74.395,3.885),(74.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.785),(59.315,32.955),(59.485,32.955),(59.485,32.785),(59.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.105),(59.315,32.275),(59.485,32.275),(59.485,32.105),(59.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,32.105),(59.825,32.275),(59.995,32.275),(59.995,32.105),(59.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,32.445),(59.825,32.615),(59.995,32.615),(59.995,32.445),(59.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,32.785),(59.825,32.955),(59.995,32.955),(59.995,32.785),(59.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.445),(59.315,32.615),(59.485,32.615),(59.485,32.445),(59.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.285),(63.605,7.455),(63.775,7.455),(63.775,7.285),(63.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.685),(11.825,10.855),(11.995,10.855),(11.995,10.685),(11.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.005),(11.825,10.175),(11.995,10.175),(11.995,10.005),(11.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.045),(58.805,29.215),(58.975,29.215),(58.975,29.045),(58.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.725),(58.805,29.895),(58.975,29.895),(58.975,29.725),(58.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.285),(68.915,7.455),(69.085,7.455),(69.085,7.285),(68.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,27.685),(10.805,27.855),(10.975,27.855),(10.975,27.685),(10.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.845),(74.225,19.015),(74.395,19.015),(74.395,18.845),(74.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.265),(44.915,23.435),(45.085,23.435),(45.085,23.265),(44.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.505),(64.115,18.675),(64.285,18.675),(64.285,18.505),(64.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.505),(64.625,18.675),(64.795,18.675),(64.795,18.505),(64.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.065),(20.405,13.235),(20.575,13.235),(20.575,13.065),(20.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.745),(20.405,13.915),(20.575,13.915),(20.575,13.745),(20.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.605),(82.805,6.775),(82.975,6.775),(82.975,6.605),(82.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.465),(45.425,16.635),(45.595,16.635),(45.595,16.465),(45.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.585),(30.515,39.755),(30.685,39.755),(30.685,39.585),(30.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.205),(35.315,37.375),(35.485,37.375),(35.485,37.205),(35.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.205),(35.825,37.375),(35.995,37.375),(35.995,37.205),(35.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.505),(44.405,35.675),(44.575,35.675),(44.575,35.505),(44.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.165),(44.405,35.335),(44.575,35.335),(44.575,35.165),(44.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,34.825),(21.425,34.995),(21.595,34.995),(21.595,34.825),(21.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,34.145),(21.425,34.315),(21.595,34.315),(21.595,34.145),(21.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.765),(64.625,14.935),(64.795,14.935),(64.795,14.765),(64.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.425),(64.115,14.595),(64.285,14.595),(64.285,14.425),(64.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.085),(64.625,14.255),(64.795,14.255),(64.795,14.085),(64.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,34.485),(21.425,34.655),(21.595,34.655),(21.595,34.485),(21.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.585),(44.405,39.755),(44.575,39.755),(44.575,39.585),(44.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,36.525),(6.515,36.695),(6.685,36.695),(6.685,36.525),(6.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,36.185),(6.515,36.355),(6.685,36.355),(6.685,36.185),(6.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.765),(64.115,14.935),(64.285,14.935),(64.285,14.765),(64.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.105),(30.515,15.275),(30.685,15.275),(30.685,15.105),(30.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.445),(30.515,15.615),(30.685,15.615),(30.685,15.445),(30.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,20.885),(7.025,21.055),(7.195,21.055),(7.195,20.885),(7.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.845),(49.205,36.015),(49.375,36.015),(49.375,35.845),(49.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.845),(49.715,36.015),(49.885,36.015),(49.885,35.845),(49.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.885),(73.205,4.055),(73.375,4.055),(73.375,3.885),(73.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.885),(73.715,4.055),(73.885,4.055),(73.885,3.885),(73.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,27.685),(73.205,27.855),(73.375,27.855),(73.375,27.685),(73.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,27.685),(73.715,27.855),(73.885,27.855),(73.885,27.685),(73.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,27.005),(69.425,27.175),(69.595,27.175),(69.595,27.005),(69.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.225),(69.425,4.395),(69.595,4.395),(69.595,4.225),(69.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.565),(39.605,4.735),(39.775,4.735),(39.775,4.565),(39.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.525),(10.805,19.695),(10.975,19.695),(10.975,19.525),(10.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.365),(30.515,11.535),(30.685,11.535),(30.685,11.365),(30.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.245),(59.315,39.415),(59.485,39.415),(59.485,39.245),(59.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,39.245),(59.825,39.415),(59.995,39.415),(59.995,39.245),(59.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.245),(54.515,39.415),(54.685,39.415),(54.685,39.245),(54.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.585),(54.005,39.755),(54.175,39.755),(54.175,39.585),(54.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.985),(25.205,9.155),(25.375,9.155),(25.375,8.985),(25.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.965),(54.005,25.135),(54.175,25.135),(54.175,24.965),(54.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.245),(58.805,22.415),(58.975,22.415),(58.975,22.245),(58.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,36.185),(30.005,36.355),(30.175,36.355),(30.175,36.185),(30.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,36.525),(30.005,36.695),(30.175,36.695),(30.175,36.525),(30.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.345),(50.225,10.515),(50.395,10.515),(50.395,10.345),(50.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,38.905),(16.625,39.075),(16.795,39.075),(16.795,38.905),(16.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,25.645),(59.825,25.815),(59.995,25.815),(59.995,25.645),(59.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.305),(59.315,25.475),(59.485,25.475),(59.485,25.305),(59.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.245),(54.515,22.415),(54.685,22.415),(54.685,22.245),(54.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.585),(54.515,22.755),(54.685,22.755),(54.685,22.585),(54.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,25.305),(59.825,25.475),(59.995,25.475),(59.995,25.305),(59.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.645),(59.315,25.815),(59.485,25.815),(59.485,25.645),(59.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.325),(15.605,9.495),(15.775,9.495),(15.775,9.325),(15.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.705),(44.915,28.875),(45.085,28.875),(45.085,28.705),(44.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.385),(30.005,12.555),(30.175,12.555),(30.175,12.385),(30.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.105),(54.005,32.275),(54.175,32.275),(54.175,32.105),(54.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.785),(54.005,32.955),(54.175,32.955),(54.175,32.785),(54.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,40.605),(59.315,40.775),(59.485,40.775),(59.485,40.605),(59.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,40.605),(59.825,40.775),(59.995,40.775),(59.995,40.605),(59.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.445),(54.005,32.615),(54.175,32.615),(54.175,32.445),(54.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.045),(30.005,12.215),(30.175,12.215),(30.175,12.045),(30.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.025),(44.915,28.195),(45.085,28.195),(45.085,28.025),(44.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.725),(30.005,12.895),(30.175,12.895),(30.175,12.725),(30.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,25.645),(83.315,25.815),(83.485,25.815),(83.485,25.645),(83.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.805),(49.715,16.975),(49.885,16.975),(49.885,16.805),(49.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.125),(49.715,16.295),(49.885,16.295),(49.885,16.125),(49.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.465),(49.205,16.635),(49.375,16.635),(49.375,16.465),(49.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.465),(49.715,16.635),(49.885,16.635),(49.885,16.465),(49.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.805),(49.205,16.975),(49.375,16.975),(49.375,16.805),(49.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.125),(49.205,16.295),(49.375,16.295),(49.375,16.125),(49.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,40.605),(74.225,40.775),(74.395,40.775),(74.395,40.605),(74.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,39.245),(26.225,39.415),(26.395,39.415),(26.395,39.245),(26.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.365),(25.205,11.535),(25.375,11.535),(25.375,11.365),(25.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,40.265),(25.715,40.435),(25.885,40.435),(25.885,40.265),(25.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.945),(50.225,24.115),(50.395,24.115),(50.395,23.945),(50.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,35.165),(74.225,35.335),(74.395,35.335),(74.395,35.165),(74.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,35.505),(74.225,35.675),(74.395,35.675),(74.395,35.505),(74.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,29.385),(16.625,29.555),(16.795,29.555),(16.795,29.385),(16.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,29.725),(16.625,29.895),(16.795,29.895),(16.795,29.725),(16.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,29.045),(16.625,29.215),(16.795,29.215),(16.795,29.045),(16.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,39.245),(79.025,39.415),(79.195,39.415),(79.195,39.245),(79.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.565),(11.315,4.735),(11.485,4.735),(11.485,4.565),(11.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.225),(11.315,4.395),(11.485,4.395),(11.485,4.225),(11.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.725),(58.805,12.895),(58.975,12.895),(58.975,12.725),(58.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.385),(58.805,12.555),(58.975,12.555),(58.975,12.385),(58.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.045),(58.805,12.215),(58.975,12.215),(58.975,12.045),(58.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,21.905),(16.625,22.075),(16.795,22.075),(16.795,21.905),(16.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.085),(68.915,14.255),(69.085,14.255),(69.085,14.085),(68.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.765),(68.915,14.935),(69.085,14.935),(69.085,14.765),(68.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.105),(68.915,15.275),(69.085,15.275),(69.085,15.105),(68.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.445),(68.915,15.615),(69.085,15.615),(69.085,15.445),(68.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.625),(74.225,7.795),(74.395,7.795),(74.395,7.625),(74.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.205),(39.605,3.375),(39.775,3.375),(39.775,3.205),(39.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.285),(25.715,7.455),(25.885,7.455),(25.885,7.285),(25.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.565),(55.025,21.735),(55.195,21.735),(55.195,21.565),(55.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.105),(20.915,15.275),(21.085,15.275),(21.085,15.105),(20.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.445),(20.915,15.615),(21.085,15.615),(21.085,15.445),(20.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.005),(45.425,27.175),(45.595,27.175),(45.595,27.005),(45.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,37.885),(68.405,38.055),(68.575,38.055),(68.575,37.885),(68.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.785),(63.605,15.955),(63.775,15.955),(63.775,15.785),(63.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.945),(50.225,7.115),(50.395,7.115),(50.395,6.945),(50.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.445),(6.515,15.615),(6.685,15.615),(6.685,15.445),(6.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.485),(50.225,17.655),(50.395,17.655),(50.395,17.485),(50.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.905),(39.605,5.075),(39.775,5.075),(39.775,4.905),(39.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.885),(45.425,38.055),(45.595,38.055),(45.595,37.885),(45.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.505),(45.425,18.675),(45.595,18.675),(45.595,18.505),(45.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.865),(10.805,20.035),(10.975,20.035),(10.975,19.865),(10.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.325),(44.405,9.495),(44.575,9.495),(44.575,9.325),(44.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.645),(44.915,25.815),(45.085,25.815),(45.085,25.645),(44.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.105),(78.515,15.275),(78.685,15.275),(78.685,15.105),(78.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.305),(44.915,25.475),(45.085,25.475),(45.085,25.305),(44.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.445),(78.005,15.615),(78.175,15.615),(78.175,15.445),(78.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.445),(78.515,15.615),(78.685,15.615),(78.685,15.445),(78.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.105),(78.005,15.275),(78.175,15.275),(78.175,15.105),(78.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.025),(6.515,11.195),(6.685,11.195),(6.685,11.025),(6.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.705),(6.515,11.875),(6.685,11.875),(6.685,11.705),(6.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,21.905),(25.715,22.075),(25.885,22.075),(25.885,21.905),(25.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,25.645),(68.915,25.815),(69.085,25.815),(69.085,25.645),(68.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,21.905),(74.225,22.075),(74.395,22.075),(74.395,21.905),(74.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.725),(44.915,29.895),(45.085,29.895),(45.085,29.725),(44.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.045),(44.915,29.215),(45.085,29.215),(45.085,29.045),(44.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.385),(44.915,29.555),(45.085,29.555),(45.085,29.385),(44.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.165),(16.115,18.335),(16.285,18.335),(16.285,18.165),(16.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.505),(16.115,18.675),(16.285,18.675),(16.285,18.505),(16.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.225),(26.225,4.395),(26.395,4.395),(26.395,4.225),(26.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,29.045),(68.915,29.215),(69.085,29.215),(69.085,29.045),(68.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,29.725),(68.915,29.895),(69.085,29.895),(69.085,29.725),(68.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.705),(78.515,11.875),(78.685,11.875),(78.685,11.705),(78.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.365),(78.005,11.535),(78.175,11.535),(78.175,11.365),(78.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,23.605),(25.205,23.775),(25.375,23.775),(25.375,23.605),(25.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,23.265),(25.205,23.435),(25.375,23.435),(25.375,23.265),(25.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.365),(78.515,11.535),(78.685,11.535),(78.685,11.365),(78.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.705),(78.005,11.875),(78.175,11.875),(78.175,11.705),(78.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.025),(78.005,11.195),(78.175,11.195),(78.175,11.025),(78.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.025),(78.515,11.195),(78.685,11.195),(78.685,11.025),(78.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.425),(6.515,14.595),(6.685,14.595),(6.685,14.425),(6.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,33.125),(11.825,33.295),(11.995,33.295),(11.995,33.125),(11.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,33.465),(11.825,33.635),(11.995,33.635),(11.995,33.465),(11.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,33.805),(11.825,33.975),(11.995,33.975),(11.995,33.805),(11.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,24.285),(11.825,24.455),(11.995,24.455),(11.995,24.285),(11.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.945),(55.025,24.115),(55.195,24.115),(55.195,23.945),(55.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.125),(55.025,16.295),(55.195,16.295),(55.195,16.125),(55.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.805),(55.025,16.975),(55.195,16.975),(55.195,16.805),(55.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.465),(55.025,16.635),(55.195,16.635),(55.195,16.465),(55.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.865),(34.805,37.035),(34.975,37.035),(34.975,36.865),(34.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.765),(40.115,31.935),(40.285,31.935),(40.285,31.765),(40.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.765),(40.625,31.935),(40.795,31.935),(40.795,31.765),(40.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.425),(40.115,31.595),(40.285,31.595),(40.285,31.425),(40.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.425),(40.625,31.595),(40.795,31.595),(40.795,31.425),(40.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.085),(40.115,31.255),(40.285,31.255),(40.285,31.085),(40.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.085),(40.625,31.255),(40.795,31.255),(40.795,31.085),(40.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.205),(55.025,20.375),(55.195,20.375),(55.195,20.205),(55.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.765),(59.315,14.935),(59.485,14.935),(59.485,14.765),(59.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.765),(59.825,14.935),(59.995,14.935),(59.995,14.765),(59.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.085),(59.825,14.255),(59.995,14.255),(59.995,14.085),(59.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.085),(59.315,14.255),(59.485,14.255),(59.485,14.085),(59.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,21.225),(69.425,21.395),(69.595,21.395),(69.595,21.225),(69.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,21.565),(69.425,21.735),(69.595,21.735),(69.595,21.565),(69.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.165),(39.605,35.335),(39.775,35.335),(39.775,35.165),(39.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.505),(39.605,35.675),(39.775,35.675),(39.775,35.505),(39.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.405),(39.605,13.575),(39.775,13.575),(39.775,13.405),(39.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.585),(44.915,39.755),(45.085,39.755),(45.085,39.585),(44.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,37.885),(64.115,38.055),(64.285,38.055),(64.285,37.885),(64.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,37.885),(64.625,38.055),(64.795,38.055),(64.795,37.885),(64.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.625),(50.225,7.795),(50.395,7.795),(50.395,7.625),(50.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,38.225),(10.805,38.395),(10.975,38.395),(10.975,38.225),(10.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.365),(73.205,11.535),(73.375,11.535),(73.375,11.365),(73.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.365),(73.715,11.535),(73.885,11.535),(73.885,11.365),(73.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.085),(34.805,14.255),(34.975,14.255),(34.975,14.085),(34.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.425),(34.805,14.595),(34.975,14.595),(34.975,14.425),(34.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.765),(34.805,14.935),(34.975,14.935),(34.975,14.765),(34.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.685),(58.805,10.855),(58.975,10.855),(58.975,10.685),(58.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.005),(58.805,10.175),(58.975,10.175),(58.975,10.005),(58.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.345),(58.805,10.515),(58.975,10.515),(58.975,10.345),(58.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.705),(73.715,11.875),(73.885,11.875),(73.885,11.705),(73.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.705),(73.205,11.875),(73.375,11.875),(73.375,11.705),(73.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.885),(58.805,38.055),(58.975,38.055),(58.975,37.885),(58.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,27.685),(79.025,27.855),(79.195,27.855),(79.195,27.685),(79.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.765),(54.005,14.935),(54.175,14.935),(54.175,14.765),(54.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.085),(54.005,14.255),(54.175,14.255),(54.175,14.085),(54.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.425),(54.005,14.595),(54.175,14.595),(54.175,14.425),(54.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,39.245),(82.805,39.415),(82.975,39.415),(82.975,39.245),(82.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,24.965),(6.515,25.135),(6.685,25.135),(6.685,24.965),(6.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.545),(10.805,3.715),(10.975,3.715),(10.975,3.545),(10.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,22.245),(6.515,22.415),(6.685,22.415),(6.685,22.245),(6.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,22.585),(6.515,22.755),(6.685,22.755),(6.685,22.585),(6.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.345),(25.715,10.515),(25.885,10.515),(25.885,10.345),(25.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.145),(39.605,17.315),(39.775,17.315),(39.775,17.145),(39.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.825),(39.605,17.995),(39.775,17.995),(39.775,17.825),(39.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,24.285),(20.915,24.455),(21.085,24.455),(21.085,24.285),(20.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,24.625),(20.915,24.795),(21.085,24.795),(21.085,24.625),(20.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.725),(44.915,12.895),(45.085,12.895),(45.085,12.725),(44.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,40.605),(10.805,40.775),(10.975,40.775),(10.975,40.605),(10.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.045),(44.915,12.215),(45.085,12.215),(45.085,12.045),(44.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.825),(55.025,34.995),(55.195,34.995),(55.195,34.825),(55.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.145),(55.025,34.315),(55.195,34.315),(55.195,34.145),(55.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.485),(55.025,34.655),(55.195,34.655),(55.195,34.485),(55.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.065),(78.005,13.235),(78.175,13.235),(78.175,13.065),(78.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.065),(78.515,13.235),(78.685,13.235),(78.685,13.065),(78.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,21.225),(83.315,21.395),(83.485,21.395),(83.485,21.225),(83.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.405),(78.005,13.575),(78.175,13.575),(78.175,13.405),(78.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.405),(78.515,13.575),(78.685,13.575),(78.685,13.405),(78.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.745),(78.005,13.915),(78.175,13.915),(78.175,13.745),(78.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.745),(78.515,13.915),(78.685,13.915),(78.685,13.745),(78.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.245),(50.225,22.415),(50.395,22.415),(50.395,22.245),(50.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.145),(40.115,34.315),(40.285,34.315),(40.285,34.145),(40.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.145),(40.625,34.315),(40.795,34.315),(40.795,34.145),(40.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.485),(40.115,34.655),(40.285,34.655),(40.285,34.485),(40.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.485),(40.625,34.655),(40.795,34.655),(40.795,34.485),(40.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.825),(40.115,34.995),(40.285,34.995),(40.285,34.825),(40.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.825),(40.625,34.995),(40.795,34.995),(40.795,34.825),(40.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,22.245),(25.715,22.415),(25.885,22.415),(25.885,22.245),(25.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,22.585),(25.715,22.755),(25.885,22.755),(25.885,22.585),(25.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,25.645),(10.805,25.815),(10.975,25.815),(10.975,25.645),(10.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,25.305),(10.805,25.475),(10.975,25.475),(10.975,25.305),(10.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.625),(20.405,7.795),(20.575,7.795),(20.575,7.625),(20.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,32.785),(83.315,32.955),(83.485,32.955),(83.485,32.785),(83.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,32.105),(83.315,32.275),(83.485,32.275),(83.485,32.105),(83.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,32.445),(83.315,32.615),(83.485,32.615),(83.485,32.445),(83.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.325),(74.225,9.495),(74.395,9.495),(74.395,9.325),(74.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.665),(74.225,9.835),(74.395,9.835),(74.395,9.665),(74.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,25.985),(20.915,26.155),(21.085,26.155),(21.085,25.985),(20.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.885),(10.805,4.055),(10.975,4.055),(10.975,3.885),(10.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.025),(58.805,28.195),(58.975,28.195),(58.975,28.025),(58.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.365),(58.805,28.535),(58.975,28.535),(58.975,28.365),(58.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.705),(58.805,28.875),(58.975,28.875),(58.975,28.705),(58.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.945),(78.005,7.115),(78.175,7.115),(78.175,6.945),(78.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.945),(78.515,7.115),(78.685,7.115),(78.685,6.945),(78.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.985),(39.605,9.155),(39.775,9.155),(39.775,8.985),(39.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.745),(30.515,13.915),(30.685,13.915),(30.685,13.745),(30.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.065),(30.515,13.235),(30.685,13.235),(30.685,13.065),(30.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.945),(25.205,7.115),(25.375,7.115),(25.375,6.945),(25.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,21.225),(16.115,21.395),(16.285,21.395),(16.285,21.225),(16.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,21.565),(16.115,21.735),(16.285,21.735),(16.285,21.565),(16.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.645),(7.025,8.815),(7.195,8.815),(7.195,8.645),(7.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,32.785),(11.315,32.955),(11.485,32.955),(11.485,32.785),(11.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,32.445),(11.315,32.615),(11.485,32.615),(11.485,32.445),(11.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.565),(44.405,38.735),(44.575,38.735),(44.575,38.565),(44.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,32.105),(11.315,32.275),(11.485,32.275),(11.485,32.105),(11.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,35.845),(10.805,36.015),(10.975,36.015),(10.975,35.845),(10.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.025),(64.115,11.195),(64.285,11.195),(64.285,11.025),(64.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.025),(64.625,11.195),(64.795,11.195),(64.795,11.025),(64.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.365),(64.115,11.535),(64.285,11.535),(64.285,11.365),(64.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.365),(64.625,11.535),(64.795,11.535),(64.795,11.365),(64.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.705),(64.115,11.875),(64.285,11.875),(64.285,11.705),(64.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.685),(79.025,10.855),(79.195,10.855),(79.195,10.685),(79.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.345),(79.025,10.515),(79.195,10.515),(79.195,10.345),(79.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.705),(64.625,11.875),(64.795,11.875),(64.795,11.705),(64.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.005),(79.025,10.175),(79.195,10.175),(79.195,10.005),(79.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.305),(68.405,8.475),(68.575,8.475),(68.575,8.305),(68.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,22.925),(82.805,23.095),(82.975,23.095),(82.975,22.925),(82.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,22.245),(59.825,22.415),(59.995,22.415),(59.995,22.245),(59.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.585),(59.315,22.755),(59.485,22.755),(59.485,22.585),(59.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.245),(59.315,22.415),(59.485,22.415),(59.485,22.245),(59.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,22.585),(59.825,22.755),(59.995,22.755),(59.995,22.585),(59.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,32.785),(73.715,32.955),(73.885,32.955),(73.885,32.785),(73.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,32.105),(73.205,32.275),(73.375,32.275),(73.375,32.105),(73.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,32.105),(73.715,32.275),(73.885,32.275),(73.885,32.105),(73.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,32.445),(73.205,32.615),(73.375,32.615),(73.375,32.445),(73.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,32.445),(73.715,32.615),(73.885,32.615),(73.885,32.445),(73.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,32.785),(73.205,32.955),(73.375,32.955),(73.375,32.785),(73.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,21.905),(73.205,22.075),(73.375,22.075),(73.375,21.905),(73.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,21.905),(73.715,22.075),(73.885,22.075),(73.885,21.905),(73.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.945),(30.515,7.115),(30.685,7.115),(30.685,6.945),(30.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,32.445),(64.625,32.615),(64.795,32.615),(64.795,32.445),(64.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,32.105),(64.115,32.275),(64.285,32.275),(64.285,32.105),(64.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,32.105),(64.625,32.275),(64.795,32.275),(64.795,32.105),(64.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,32.785),(64.115,32.955),(64.285,32.955),(64.285,32.785),(64.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,32.785),(64.625,32.955),(64.795,32.955),(64.795,32.785),(64.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,32.445),(64.115,32.615),(64.285,32.615),(64.285,32.445),(64.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.905),(74.225,5.075),(74.395,5.075),(74.395,4.905),(74.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,20.205),(26.225,20.375),(26.395,20.375),(26.395,20.205),(26.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,40.605),(55.025,40.775),(55.195,40.775),(55.195,40.605),(55.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.565),(45.425,38.735),(45.595,38.735),(45.595,38.565),(45.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.685),(73.205,10.855),(73.375,10.855),(73.375,10.685),(73.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.685),(73.715,10.855),(73.885,10.855),(73.885,10.685),(73.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.005),(73.205,10.175),(73.375,10.175),(73.375,10.005),(73.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.005),(73.715,10.175),(73.885,10.175),(73.885,10.005),(73.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.565),(30.515,38.735),(30.685,38.735),(30.685,38.565),(30.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.425),(50.225,31.595),(50.395,31.595),(50.395,31.425),(50.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.765),(50.225,31.935),(50.395,31.935),(50.395,31.765),(50.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.085),(50.225,31.255),(50.395,31.255),(50.395,31.085),(50.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.845),(55.025,19.015),(55.195,19.015),(55.195,18.845),(55.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.345),(68.405,10.515),(68.575,10.515),(68.575,10.345),(68.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,25.305),(69.425,25.475),(69.595,25.475),(69.595,25.305),(69.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,32.785),(16.625,32.955),(16.795,32.955),(16.795,32.785),(16.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,32.445),(16.625,32.615),(16.795,32.615),(16.795,32.445),(16.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,32.105),(16.625,32.275),(16.795,32.275),(16.795,32.105),(16.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.125),(25.715,16.295),(25.885,16.295),(25.885,16.125),(25.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.805),(25.715,16.975),(25.885,16.975),(25.885,16.805),(25.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,36.865),(69.425,37.035),(69.595,37.035),(69.595,36.865),(69.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,39.585),(15.605,39.755),(15.775,39.755),(15.775,39.585),(15.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.605),(79.025,6.775),(79.195,6.775),(79.195,6.605),(79.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,39.585),(68.405,39.755),(68.575,39.755),(68.575,39.585),(68.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.205),(55.025,37.375),(55.195,37.375),(55.195,37.205),(55.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.625),(10.805,7.795),(10.975,7.795),(10.975,7.625),(10.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.725),(39.605,12.895),(39.775,12.895),(39.775,12.725),(39.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.045),(39.605,12.215),(39.775,12.215),(39.775,12.045),(39.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.465),(78.005,16.635),(78.175,16.635),(78.175,16.465),(78.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.465),(78.515,16.635),(78.685,16.635),(78.685,16.465),(78.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.845),(25.205,19.015),(25.375,19.015),(25.375,18.845),(25.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,40.265),(54.515,40.435),(54.685,40.435),(54.685,40.265),(54.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,40.605),(54.005,40.775),(54.175,40.775),(54.175,40.605),(54.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,20.205),(83.315,20.375),(83.485,20.375),(83.485,20.205),(83.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,20.545),(83.315,20.715),(83.485,20.715),(83.485,20.545),(83.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.885),(59.315,38.055),(59.485,38.055),(59.485,37.885),(59.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,37.885),(59.825,38.055),(59.995,38.055),(59.995,37.885),(59.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,34.145),(30.005,34.315),(30.175,34.315),(30.175,34.145),(30.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,34.485),(30.005,34.655),(30.175,34.655),(30.175,34.485),(30.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,34.825),(30.005,34.995),(30.175,34.995),(30.175,34.825),(30.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.945),(49.205,7.115),(49.375,7.115),(49.375,6.945),(49.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,36.865),(10.805,37.035),(10.975,37.035),(10.975,36.865),(10.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,38.905),(74.225,39.075),(74.395,39.075),(74.395,38.905),(74.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.605),(44.405,6.775),(44.575,6.775),(44.575,6.605),(44.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.265),(44.405,6.435),(44.575,6.435),(44.575,6.265),(44.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.525),(50.225,19.695),(50.395,19.695),(50.395,19.525),(50.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,23.945),(21.425,24.115),(21.595,24.115),(21.595,23.945),(21.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,40.265),(44.405,40.435),(44.575,40.435),(44.575,40.265),(44.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.205),(31.025,37.375),(31.195,37.375),(31.195,37.205),(31.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.545),(34.805,37.715),(34.975,37.715),(34.975,37.545),(34.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,35.845),(25.205,36.015),(25.375,36.015),(25.375,35.845),(25.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.605),(26.225,6.775),(26.395,6.775),(26.395,6.605),(26.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.845),(31.025,36.015),(31.195,36.015),(31.195,35.845),(31.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,24.285),(68.915,24.455),(69.085,24.455),(69.085,24.285),(68.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,39.925),(79.025,40.095),(79.195,40.095),(79.195,39.925),(79.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.365),(39.605,11.535),(39.775,11.535),(39.775,11.365),(39.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.985),(54.005,9.155),(54.175,9.155),(54.175,8.985),(54.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.325),(16.115,9.495),(16.285,9.495),(16.285,9.325),(16.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,36.865),(21.425,37.035),(21.595,37.035),(21.595,36.865),(21.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,37.545),(16.115,37.715),(16.285,37.715),(16.285,37.545),(16.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,31.425),(74.225,31.595),(74.395,31.595),(74.395,31.425),(74.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,31.765),(74.225,31.935),(74.395,31.935),(74.395,31.765),(74.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,31.085),(74.225,31.255),(74.395,31.255),(74.395,31.085),(74.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.865),(68.915,20.035),(69.085,20.035),(69.085,19.865),(68.915,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,37.885),(21.425,38.055),(21.595,38.055),(21.595,37.885),(21.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,39.245),(20.915,39.415),(21.085,39.415),(21.085,39.245),(20.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.505),(20.915,18.675),(21.085,18.675),(21.085,18.505),(20.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.545),(40.115,37.715),(40.285,37.715),(40.285,37.545),(40.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.545),(40.625,37.715),(40.795,37.715),(40.795,37.545),(40.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.965),(16.625,8.135),(16.795,8.135),(16.795,7.965),(16.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.865),(50.225,20.035),(50.395,20.035),(50.395,19.865),(50.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,23.605),(20.405,23.775),(20.575,23.775),(20.575,23.605),(20.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,31.765),(63.605,31.935),(63.775,31.935),(63.775,31.765),(63.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,31.085),(63.605,31.255),(63.775,31.255),(63.775,31.085),(63.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,23.945),(25.205,24.115),(25.375,24.115),(25.375,23.945),(25.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.865),(30.515,3.035),(30.685,3.035),(30.685,2.865),(30.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.145),(78.005,17.315),(78.175,17.315),(78.175,17.145),(78.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.145),(78.515,17.315),(78.685,17.315),(78.685,17.145),(78.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.185),(31.025,19.355),(31.195,19.355),(31.195,19.185),(31.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.485),(78.005,17.655),(78.175,17.655),(78.175,17.485),(78.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.485),(78.515,17.655),(78.685,17.655),(78.685,17.485),(78.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.825),(78.005,17.995),(78.175,17.995),(78.175,17.825),(78.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.825),(78.515,17.995),(78.685,17.995),(78.685,17.825),(78.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.625),(59.315,7.795),(59.485,7.795),(59.485,7.625),(59.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.625),(59.825,7.795),(59.995,7.795),(59.995,7.625),(59.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,21.225),(10.805,21.395),(10.975,21.395),(10.975,21.225),(10.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,22.585),(20.915,22.755),(21.085,22.755),(21.085,22.585),(20.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.125),(30.515,16.295),(30.685,16.295),(30.685,16.125),(30.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.805),(30.515,16.975),(30.685,16.975),(30.685,16.805),(30.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,32.785),(21.425,32.955),(21.595,32.955),(21.595,32.785),(21.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,32.445),(21.425,32.615),(21.595,32.615),(21.595,32.445),(21.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,32.105),(21.425,32.275),(21.595,32.275),(21.595,32.105),(21.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.125),(59.315,33.295),(59.485,33.295),(59.485,33.125),(59.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,33.125),(59.825,33.295),(59.995,33.295),(59.995,33.125),(59.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.805),(59.315,33.975),(59.485,33.975),(59.485,33.805),(59.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,33.805),(59.825,33.975),(59.995,33.975),(59.995,33.805),(59.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.465),(59.315,33.635),(59.485,33.635),(59.485,33.465),(59.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,33.465),(59.825,33.635),(59.995,33.635),(59.995,33.465),(59.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.725),(25.715,12.895),(25.885,12.895),(25.885,12.725),(25.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.385),(25.715,12.555),(25.885,12.555),(25.885,12.385),(25.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.045),(25.715,12.215),(25.885,12.215),(25.885,12.045),(25.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,20.205),(68.405,20.375),(68.575,20.375),(68.575,20.205),(68.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.625),(25.205,7.795),(25.375,7.795),(25.375,7.625),(25.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,20.545),(68.405,20.715),(68.575,20.715),(68.575,20.545),(68.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.525),(49.205,19.695),(49.375,19.695),(49.375,19.525),(49.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.525),(49.715,19.695),(49.885,19.695),(49.885,19.525),(49.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,36.525),(7.025,36.695),(7.195,36.695),(7.195,36.525),(7.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,36.185),(7.025,36.355),(7.195,36.355),(7.195,36.185),(7.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.865),(54.515,3.035),(54.685,3.035),(54.685,2.865),(54.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,36.865),(6.515,37.035),(6.685,37.035),(6.685,36.865),(6.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.325),(64.115,9.495),(64.285,9.495),(64.285,9.325),(64.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.325),(64.625,9.495),(64.795,9.495),(64.795,9.325),(64.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.925),(49.205,6.095),(49.375,6.095),(49.375,5.925),(49.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.925),(49.715,6.095),(49.885,6.095),(49.885,5.925),(49.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.665),(69.425,9.835),(69.595,9.835),(69.595,9.665),(69.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.525),(15.605,19.695),(15.775,19.695),(15.775,19.525),(15.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,21.44),(85.76,21.61),(85.93,21.61),(85.93,21.44),(85.76,21.44)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,40.605),(68.915,40.775),(69.085,40.775),(69.085,40.605),(68.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,38.225),(82.805,38.395),(82.975,38.395),(82.975,38.225),(82.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.485),(35.315,34.655),(35.485,34.655),(35.485,34.485),(35.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.485),(35.825,34.655),(35.995,34.655),(35.995,34.485),(35.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.825),(35.825,34.995),(35.995,34.995),(35.995,34.825),(35.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.145),(35.315,34.315),(35.485,34.315),(35.485,34.145),(35.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.825),(35.315,34.995),(35.485,34.995),(35.485,34.825),(35.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,39.245),(68.915,39.415),(69.085,39.415),(69.085,39.245),(68.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,25.305),(68.405,25.475),(68.575,25.475),(68.575,25.305),(68.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,25.645),(68.405,25.815),(68.575,25.815),(68.575,25.645),(68.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.145),(35.825,34.315),(35.995,34.315),(35.995,34.145),(35.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.565),(79.025,4.735),(79.195,4.735),(79.195,4.565),(79.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.325),(21.425,9.495),(21.595,9.495),(21.595,9.325),(21.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,22.585),(79.025,22.755),(79.195,22.755),(79.195,22.585),(79.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.505),(68.405,18.675),(68.575,18.675),(68.575,18.505),(68.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,31.425),(16.625,31.595),(16.795,31.595),(16.795,31.425),(16.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.625),(49.205,7.795),(49.375,7.795),(49.375,7.625),(49.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.625),(49.715,7.795),(49.885,7.795),(49.885,7.625),(49.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,33.805),(20.915,33.975),(21.085,33.975),(21.085,33.805),(20.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,33.125),(20.915,33.295),(21.085,33.295),(21.085,33.125),(20.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,33.465),(20.915,33.635),(21.085,33.635),(21.085,33.465),(20.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.385),(64.115,12.555),(64.285,12.555),(64.285,12.385),(64.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,36.865),(30.005,37.035),(30.175,37.035),(30.175,36.865),(30.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.385),(64.625,12.555),(64.795,12.555),(64.795,12.385),(64.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.925),(16.625,6.095),(16.795,6.095),(16.795,5.925),(16.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.405),(11.825,13.575),(11.995,13.575),(11.995,13.405),(11.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.985),(34.805,26.155),(34.975,26.155),(34.975,25.985),(34.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.645),(63.605,8.815),(63.775,8.815),(63.775,8.645),(63.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.105),(39.605,32.275),(39.775,32.275),(39.775,32.105),(39.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.445),(39.605,32.615),(39.775,32.615),(39.775,32.445),(39.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.785),(39.605,32.955),(39.775,32.955),(39.775,32.785),(39.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.545),(16.115,3.715),(16.285,3.715),(16.285,3.545),(16.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.265),(50.225,23.435),(50.395,23.435),(50.395,23.265),(50.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.285),(21.425,7.455),(21.595,7.455),(21.595,7.285),(21.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.225),(31.025,4.395),(31.195,4.395),(31.195,4.225),(31.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.565),(31.025,4.735),(31.195,4.735),(31.195,4.565),(31.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.865),(11.825,20.035),(11.995,20.035),(11.995,19.865),(11.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.645),(83.315,8.815),(83.485,8.815),(83.485,8.645),(83.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.305),(83.315,8.475),(83.485,8.475),(83.485,8.305),(83.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,25.985),(6.515,26.155),(6.685,26.155),(6.685,25.985),(6.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.725),(16.625,12.895),(16.795,12.895),(16.795,12.725),(16.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.045),(16.625,12.215),(16.795,12.215),(16.795,12.045),(16.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,25.985),(16.625,26.155),(16.795,26.155),(16.795,25.985),(16.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.285),(55.025,7.455),(55.195,7.455),(55.195,7.285),(55.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.905),(79.025,5.075),(79.195,5.075),(79.195,4.905),(79.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,22.245),(73.715,22.415),(73.885,22.415),(73.885,22.245),(73.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,22.245),(73.205,22.415),(73.375,22.415),(73.375,22.245),(73.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,22.585),(73.715,22.755),(73.885,22.755),(73.885,22.585),(73.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,22.585),(73.205,22.755),(73.375,22.755),(73.375,22.585),(73.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,38.225),(21.425,38.395),(21.595,38.395),(21.595,38.225),(21.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.605),(83.315,6.775),(83.485,6.775),(83.485,6.605),(83.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.205),(45.425,37.375),(45.595,37.375),(45.595,37.205),(45.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.445),(74.225,15.615),(74.395,15.615),(74.395,15.445),(74.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.985),(44.915,26.155),(45.085,26.155),(45.085,25.985),(44.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,21.225),(25.715,21.395),(25.885,21.395),(25.885,21.225),(25.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.045),(50.225,29.215),(50.395,29.215),(50.395,29.045),(50.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.385),(50.225,29.555),(50.395,29.555),(50.395,29.385),(50.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.725),(50.225,29.895),(50.395,29.895),(50.395,29.725),(50.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.105),(26.225,15.275),(26.395,15.275),(26.395,15.105),(26.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.445),(26.225,15.615),(26.395,15.615),(26.395,15.445),(26.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.545),(54.515,3.715),(54.685,3.715),(54.685,3.545),(54.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.205),(54.515,3.375),(54.685,3.375),(54.685,3.205),(54.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,37.885),(63.605,38.055),(63.775,38.055),(63.775,37.885),(63.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,38.225),(25.715,38.395),(25.885,38.395),(25.885,38.225),(25.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.845),(16.115,19.015),(16.285,19.015),(16.285,18.845),(16.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.165),(55.025,35.335),(55.195,35.335),(55.195,35.165),(55.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.505),(55.025,35.675),(55.195,35.675),(55.195,35.505),(55.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.785),(79.025,15.955),(79.195,15.955),(79.195,15.785),(79.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.825),(55.025,17.995),(55.195,17.995),(55.195,17.825),(55.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.145),(55.025,17.315),(55.195,17.315),(55.195,17.145),(55.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,24.965),(11.825,25.135),(11.995,25.135),(11.995,24.965),(11.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.965),(20.915,8.135),(21.085,8.135),(21.085,7.965),(20.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,20.885),(20.915,21.055),(21.085,21.055),(21.085,20.885),(20.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,36.185),(26.225,36.355),(26.395,36.355),(26.395,36.185),(26.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,36.525),(26.225,36.695),(26.395,36.695),(26.395,36.525),(26.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.305),(30.515,8.475),(30.685,8.475),(30.685,8.305),(30.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.545),(79.025,3.715),(79.195,3.715),(79.195,3.545),(79.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,22.925),(63.605,23.095),(63.775,23.095),(63.775,22.925),(63.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.885),(55.025,21.055),(55.195,21.055),(55.195,20.885),(55.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.125),(11.315,16.295),(11.485,16.295),(11.485,16.125),(11.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.465),(11.315,16.635),(11.485,16.635),(11.485,16.465),(11.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.805),(11.315,16.975),(11.485,16.975),(11.485,16.805),(11.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.925),(54.005,6.095),(54.175,6.095),(54.175,5.925),(54.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,31.425),(25.205,31.595),(25.375,31.595),(25.375,31.425),(25.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,31.765),(25.205,31.935),(25.375,31.935),(25.375,31.765),(25.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,31.085),(25.205,31.255),(25.375,31.255),(25.375,31.085),(25.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,31.425),(11.825,31.595),(11.995,31.595),(11.995,31.425),(11.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,31.765),(11.825,31.935),(11.995,31.935),(11.995,31.765),(11.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,31.085),(11.825,31.255),(11.995,31.255),(11.995,31.085),(11.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.965),(54.005,8.135),(54.175,8.135),(54.175,7.965),(54.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.885),(30.515,38.055),(30.685,38.055),(30.685,37.885),(30.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,38.565),(73.205,38.735),(73.375,38.735),(73.375,38.565),(73.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,38.565),(73.715,38.735),(73.885,38.735),(73.885,38.565),(73.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.925),(35.315,40.095),(35.485,40.095),(35.485,39.925),(35.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.925),(35.825,40.095),(35.995,40.095),(35.995,39.925),(35.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,29.045),(30.005,29.215),(30.175,29.215),(30.175,29.045),(30.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.445),(31.025,15.615),(31.195,15.615),(31.195,15.445),(31.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,29.725),(30.005,29.895),(30.175,29.895),(30.175,29.725),(30.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.005),(16.115,10.175),(16.285,10.175),(16.285,10.005),(16.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.685),(16.115,10.855),(16.285,10.855),(16.285,10.685),(16.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.345),(16.115,10.515),(16.285,10.515),(16.285,10.345),(16.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,30.405),(63.605,30.575),(63.775,30.575),(63.775,30.405),(63.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,21.905),(82.805,22.075),(82.975,22.075),(82.975,21.905),(82.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.685),(55.025,27.855),(55.195,27.855),(55.195,27.685),(55.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,35.845),(64.115,36.015),(64.285,36.015),(64.285,35.845),(64.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,35.845),(64.625,36.015),(64.795,36.015),(64.795,35.845),(64.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,26.665),(20.915,26.835),(21.085,26.835),(21.085,26.665),(20.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,26.325),(20.915,26.495),(21.085,26.495),(21.085,26.325),(20.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.545),(25.715,3.715),(25.885,3.715),(25.885,3.545),(25.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.205),(25.715,3.375),(25.885,3.375),(25.885,3.205),(25.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,38.905),(10.805,39.075),(10.975,39.075),(10.975,38.905),(10.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.465),(34.805,16.635),(34.975,16.635),(34.975,16.465),(34.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.545),(31.025,3.715),(31.195,3.715),(31.195,3.545),(31.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,25.645),(64.115,25.815),(64.285,25.815),(64.285,25.645),(64.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,25.645),(64.625,25.815),(64.795,25.815),(64.795,25.645),(64.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.885),(54.005,4.055),(54.175,4.055),(54.175,3.885),(54.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.385),(11.825,12.555),(11.995,12.555),(11.995,12.385),(11.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.605),(59.315,6.775),(59.485,6.775),(59.485,6.605),(59.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.605),(59.825,6.775),(59.995,6.775),(59.995,6.605),(59.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,22.585),(15.605,22.755),(15.775,22.755),(15.775,22.585),(15.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,22.245),(15.605,22.415),(15.775,22.415),(15.775,22.245),(15.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.445),(64.625,15.615),(64.795,15.615),(64.795,15.445),(64.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.445),(64.115,15.615),(64.285,15.615),(64.285,15.445),(64.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.205),(44.405,37.375),(44.575,37.375),(44.575,37.205),(44.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.165),(83.315,18.335),(83.485,18.335),(83.485,18.165),(83.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.465),(35.315,16.635),(35.485,16.635),(35.485,16.465),(35.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.465),(35.825,16.635),(35.995,16.635),(35.995,16.465),(35.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.085),(40.115,14.255),(40.285,14.255),(40.285,14.085),(40.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.425),(40.625,14.595),(40.795,14.595),(40.795,14.425),(40.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.005),(58.805,27.175),(58.975,27.175),(58.975,27.005),(58.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.085),(40.625,14.255),(40.795,14.255),(40.795,14.085),(40.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.765),(40.625,14.935),(40.795,14.935),(40.795,14.765),(40.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.425),(40.115,14.595),(40.285,14.595),(40.285,14.425),(40.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.565),(49.205,38.735),(49.375,38.735),(49.375,38.565),(49.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.565),(49.715,38.735),(49.885,38.735),(49.885,38.565),(49.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.585),(58.805,39.755),(58.975,39.755),(58.975,39.585),(58.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.765),(40.115,14.935),(40.285,14.935),(40.285,14.765),(40.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.465),(26.225,16.635),(26.395,16.635),(26.395,16.465),(26.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,28.365),(25.715,28.535),(25.885,28.535),(25.885,28.365),(25.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,28.705),(25.715,28.875),(25.885,28.875),(25.885,28.705),(25.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,28.025),(25.715,28.195),(25.885,28.195),(25.885,28.025),(25.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,28.365),(64.115,28.535),(64.285,28.535),(64.285,28.365),(64.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,28.365),(64.625,28.535),(64.795,28.535),(64.795,28.365),(64.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.205),(49.205,3.375),(49.375,3.375),(49.375,3.205),(49.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.205),(49.715,3.375),(49.885,3.375),(49.885,3.205),(49.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.865),(69.425,20.035),(69.595,20.035),(69.595,19.865),(69.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,37.885),(82.805,38.055),(82.975,38.055),(82.975,37.885),(82.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,27.005),(16.625,27.175),(16.795,27.175),(16.795,27.005),(16.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.885),(30.005,4.055),(30.175,4.055),(30.175,3.885),(30.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.585),(40.115,5.755),(40.285,5.755),(40.285,5.585),(40.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.585),(40.625,5.755),(40.795,5.755),(40.795,5.585),(40.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,30.405),(82.805,30.575),(82.975,30.575),(82.975,30.405),(82.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.785),(16.115,15.955),(16.285,15.955),(16.285,15.785),(16.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.105),(16.625,15.275),(16.795,15.275),(16.795,15.105),(16.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.485),(30.515,17.655),(30.685,17.655),(30.685,17.485),(30.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.885),(11.825,4.055),(11.995,4.055),(11.995,3.885),(11.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,23.945),(69.425,24.115),(69.595,24.115),(69.595,23.945),(69.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,35.845),(83.315,36.015),(83.485,36.015),(83.485,35.845),(83.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.805),(49.205,33.975),(49.375,33.975),(49.375,33.805),(49.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.805),(49.715,33.975),(49.885,33.975),(49.885,33.805),(49.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.465),(49.205,33.635),(49.375,33.635),(49.375,33.465),(49.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.465),(49.715,33.635),(49.885,33.635),(49.885,33.465),(49.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.125),(49.205,33.295),(49.375,33.295),(49.375,33.125),(49.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.125),(49.715,33.295),(49.885,33.295),(49.885,33.125),(49.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.185),(40.115,36.355),(40.285,36.355),(40.285,36.185),(40.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.185),(40.625,36.355),(40.795,36.355),(40.795,36.185),(40.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.525),(40.115,36.695),(40.285,36.695),(40.285,36.525),(40.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.525),(40.625,36.695),(40.795,36.695),(40.795,36.525),(40.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,26.665),(34.805,26.835),(34.975,26.835),(34.975,26.665),(34.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,26.325),(34.805,26.495),(34.975,26.495),(34.975,26.325),(34.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.285),(6.515,7.455),(6.685,7.455),(6.685,7.285),(6.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.245),(50.225,5.415),(50.395,5.415),(50.395,5.245),(50.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,22.245),(21.425,22.415),(21.595,22.415),(21.595,22.245),(21.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,22.585),(21.425,22.755),(21.595,22.755),(21.595,22.585),(21.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,20.205),(25.715,20.375),(25.885,20.375),(25.885,20.205),(25.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,29.385),(21.425,29.555),(21.595,29.555),(21.595,29.385),(21.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,29.725),(21.425,29.895),(21.595,29.895),(21.595,29.725),(21.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,29.045),(21.425,29.215),(21.595,29.215),(21.595,29.045),(21.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.905),(20.405,5.075),(20.575,5.075),(20.575,4.905),(20.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.685),(64.115,10.855),(64.285,10.855),(64.285,10.685),(64.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.685),(64.625,10.855),(64.795,10.855),(64.795,10.685),(64.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.005),(64.115,10.175),(64.285,10.175),(64.285,10.005),(64.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.005),(64.625,10.175),(64.795,10.175),(64.795,10.005),(64.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.345),(64.115,10.515),(64.285,10.515),(64.285,10.345),(64.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.345),(64.625,10.515),(64.795,10.515),(64.795,10.345),(64.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,37.885),(20.405,38.055),(20.575,38.055),(20.575,37.885),(20.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.245),(16.115,5.415),(16.285,5.415),(16.285,5.245),(16.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.005),(26.225,10.175),(26.395,10.175),(26.395,10.005),(26.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.345),(26.225,10.515),(26.395,10.515),(26.395,10.345),(26.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.685),(26.225,10.855),(26.395,10.855),(26.395,10.685),(26.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,35.845),(11.315,36.015),(11.485,36.015),(11.485,35.845),(11.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,35.845),(11.825,36.015),(11.995,36.015),(11.995,35.845),(11.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.165),(40.115,18.335),(40.285,18.335),(40.285,18.165),(40.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.165),(40.625,18.335),(40.795,18.335),(40.795,18.165),(40.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.505),(40.115,18.675),(40.285,18.675),(40.285,18.505),(40.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.505),(40.625,18.675),(40.795,18.675),(40.795,18.505),(40.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.225),(45.425,4.395),(45.595,4.395),(45.595,4.225),(45.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.565),(45.425,4.735),(45.595,4.735),(45.595,4.565),(45.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,26.325),(68.405,26.495),(68.575,26.495),(68.575,26.325),(68.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,26.665),(68.405,26.835),(68.575,26.835),(68.575,26.665),(68.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,23.605),(16.625,23.775),(16.795,23.775),(16.795,23.605),(16.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.585),(74.225,5.755),(74.395,5.755),(74.395,5.585),(74.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.245),(74.225,5.415),(74.395,5.415),(74.395,5.245),(74.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.125),(6.515,16.295),(6.685,16.295),(6.685,16.125),(6.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.805),(6.515,16.975),(6.685,16.975),(6.685,16.805),(6.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.285),(40.625,7.455),(40.795,7.455),(40.795,7.285),(40.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.285),(40.115,7.455),(40.285,7.455),(40.285,7.285),(40.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.145),(25.715,17.315),(25.885,17.315),(25.885,17.145),(25.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.825),(25.715,17.995),(25.885,17.995),(25.885,17.825),(25.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.345),(54.005,10.515),(54.175,10.515),(54.175,10.345),(54.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.005),(54.005,10.175),(54.175,10.175),(54.175,10.005),(54.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.685),(54.005,10.855),(54.175,10.855),(54.175,10.685),(54.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.965),(58.805,8.135),(58.975,8.135),(58.975,7.965),(58.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.085),(50.225,14.255),(50.395,14.255),(50.395,14.085),(50.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.765),(50.225,14.935),(50.395,14.935),(50.395,14.765),(50.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.165),(30.515,18.335),(30.685,18.335),(30.685,18.165),(30.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.585),(11.315,5.755),(11.485,5.755),(11.485,5.585),(11.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.565),(31.025,38.735),(31.195,38.735),(31.195,38.565),(31.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.505),(68.915,18.675),(69.085,18.675),(69.085,18.505),(68.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.425),(31.025,14.595),(31.195,14.595),(31.195,14.425),(31.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.985),(68.405,9.155),(68.575,9.155),(68.575,8.985),(68.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.225),(16.115,4.395),(16.285,4.395),(16.285,4.225),(16.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.245),(44.405,22.415),(44.575,22.415),(44.575,22.245),(44.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.285),(40.115,24.455),(40.285,24.455),(40.285,24.285),(40.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.285),(40.625,24.455),(40.795,24.455),(40.795,24.285),(40.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.625),(40.115,24.795),(40.285,24.795),(40.285,24.625),(40.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,25.985),(25.205,26.155),(25.375,26.155),(25.375,25.985),(25.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.625),(40.625,24.795),(40.795,24.795),(40.795,24.625),(40.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,40.605),(7.025,40.775),(7.195,40.775),(7.195,40.605),(7.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.245),(44.915,5.415),(45.085,5.415),(45.085,5.245),(44.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.545),(20.405,3.715),(20.575,3.715),(20.575,3.545),(20.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,21.225),(73.205,21.395),(73.375,21.395),(73.375,21.225),(73.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,21.225),(73.715,21.395),(73.885,21.395),(73.885,21.225),(73.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.085),(20.405,14.255),(20.575,14.255),(20.575,14.085),(20.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.765),(20.405,14.935),(20.575,14.935),(20.575,14.765),(20.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,20.885),(26.225,21.055),(26.395,21.055),(26.395,20.885),(26.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,30.065),(6.515,30.235),(6.685,30.235),(6.685,30.065),(6.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,30.745),(6.515,30.915),(6.685,30.915),(6.685,30.745),(6.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,20.205),(10.805,20.375),(10.975,20.375),(10.975,20.205),(10.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,20.545),(10.805,20.715),(10.975,20.715),(10.975,20.545),(10.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.225),(55.025,38.395),(55.195,38.395),(55.195,38.225),(55.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.785),(11.315,15.955),(11.485,15.955),(11.485,15.785),(11.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,22.245),(74.225,22.415),(74.395,22.415),(74.395,22.245),(74.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,26.325),(44.405,26.495),(44.575,26.495),(44.575,26.325),(44.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,27.005),(7.025,27.175),(7.195,27.175),(7.195,27.005),(7.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,22.245),(68.915,22.415),(69.085,22.415),(69.085,22.245),(68.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,22.585),(68.915,22.755),(69.085,22.755),(69.085,22.585),(68.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.285),(59.315,24.455),(59.485,24.455),(59.485,24.285),(59.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,24.285),(59.825,24.455),(59.995,24.455),(59.995,24.285),(59.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.625),(59.315,24.795),(59.485,24.795),(59.485,24.625),(59.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,24.625),(59.825,24.795),(59.995,24.795),(59.995,24.625),(59.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,23.945),(20.915,24.115),(21.085,24.115),(21.085,23.945),(20.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.745),(44.405,30.915),(44.575,30.915),(44.575,30.745),(44.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.065),(44.405,30.235),(44.575,30.235),(44.575,30.065),(44.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,29.385),(74.225,29.555),(74.395,29.555),(74.395,29.385),(74.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,40.265),(82.805,40.435),(82.975,40.435),(82.975,40.265),(82.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.325),(78.005,9.495),(78.175,9.495),(78.175,9.325),(78.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.325),(78.515,9.495),(78.685,9.495),(78.685,9.325),(78.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.665),(78.005,9.835),(78.175,9.835),(78.175,9.665),(78.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.665),(78.515,9.835),(78.685,9.835),(78.685,9.665),(78.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,23.945),(16.625,24.115),(16.795,24.115),(16.795,23.945),(16.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,37.205),(6.515,37.375),(6.685,37.375),(6.685,37.205),(6.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,27.005),(11.825,27.175),(11.995,27.175),(11.995,27.005),(11.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,27.345),(11.825,27.515),(11.995,27.515),(11.995,27.345),(11.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,40.605),(40.115,40.775),(40.285,40.775),(40.285,40.605),(40.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,40.605),(40.625,40.775),(40.795,40.775),(40.795,40.605),(40.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.205),(44.915,37.375),(45.085,37.375),(45.085,37.205),(44.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.245),(64.115,5.415),(64.285,5.415),(64.285,5.245),(64.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.245),(64.625,5.415),(64.795,5.415),(64.795,5.245),(64.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,27.345),(68.405,27.515),(68.575,27.515),(68.575,27.345),(68.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.245),(78.005,5.415),(78.175,5.415),(78.175,5.245),(78.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.245),(78.515,5.415),(78.685,5.415),(78.685,5.245),(78.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.585),(78.005,5.755),(78.175,5.755),(78.175,5.585),(78.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.585),(78.515,5.755),(78.685,5.755),(78.685,5.585),(78.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,25.985),(82.805,26.155),(82.975,26.155),(82.975,25.985),(82.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,24.285),(25.205,24.455),(25.375,24.455),(25.375,24.285),(25.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,24.625),(25.205,24.795),(25.375,24.795),(25.375,24.625),(25.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,24.285),(21.425,24.455),(21.595,24.455),(21.595,24.285),(21.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,24.625),(21.425,24.795),(21.595,24.795),(21.595,24.625),(21.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,37.205),(30.005,37.375),(30.175,37.375),(30.175,37.205),(30.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,20.885),(83.315,21.055),(83.485,21.055),(83.485,20.885),(83.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,37.205),(59.825,37.375),(59.995,37.375),(59.995,37.205),(59.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.205),(59.315,37.375),(59.485,37.375),(59.485,37.205),(59.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.185),(25.715,19.355),(25.885,19.355),(25.885,19.185),(25.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.525),(25.715,19.695),(25.885,19.695),(25.885,19.525),(25.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.405),(26.225,13.575),(26.395,13.575),(26.395,13.405),(26.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.865),(34.805,3.035),(34.975,3.035),(34.975,2.865),(34.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.945),(44.405,7.115),(44.575,7.115),(44.575,6.945),(44.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.425),(79.025,14.595),(79.195,14.595),(79.195,14.425),(79.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.725),(68.405,12.895),(68.575,12.895),(68.575,12.725),(68.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.045),(68.405,12.215),(68.575,12.215),(68.575,12.045),(68.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.645),(50.225,8.815),(50.395,8.815),(50.395,8.645),(50.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.825),(58.805,34.995),(58.975,34.995),(58.975,34.825),(58.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.485),(58.805,34.655),(58.975,34.655),(58.975,34.485),(58.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.145),(58.805,34.315),(58.975,34.315),(58.975,34.145),(58.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.245),(30.515,5.415),(30.685,5.415),(30.685,5.245),(30.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.905),(49.205,22.075),(49.375,22.075),(49.375,21.905),(49.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.905),(49.715,22.075),(49.885,22.075),(49.885,21.905),(49.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.765),(30.005,14.935),(30.175,14.935),(30.175,14.765),(30.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,39.585),(16.115,39.755),(16.285,39.755),(16.285,39.585),(16.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.085),(30.005,14.255),(30.175,14.255),(30.175,14.085),(30.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,28.025),(73.715,28.195),(73.885,28.195),(73.885,28.025),(73.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,28.365),(73.205,28.535),(73.375,28.535),(73.375,28.365),(73.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,28.365),(73.715,28.535),(73.885,28.535),(73.885,28.365),(73.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,28.705),(73.205,28.875),(73.375,28.875),(73.375,28.705),(73.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,28.705),(73.715,28.875),(73.885,28.875),(73.885,28.705),(73.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,28.025),(73.205,28.195),(73.375,28.195),(73.375,28.025),(73.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.105),(15.605,15.275),(15.775,15.275),(15.775,15.105),(15.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,26.665),(64.115,26.835),(64.285,26.835),(64.285,26.665),(64.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,26.665),(64.625,26.835),(64.795,26.835),(64.795,26.665),(64.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,26.325),(64.115,26.495),(64.285,26.495),(64.285,26.325),(64.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,26.325),(64.625,26.495),(64.795,26.495),(64.795,26.325),(64.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,39.925),(20.405,40.095),(20.575,40.095),(20.575,39.925),(20.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,34.825),(64.115,34.995),(64.285,34.995),(64.285,34.825),(64.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,34.825),(64.625,34.995),(64.795,34.995),(64.795,34.825),(64.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,34.485),(64.115,34.655),(64.285,34.655),(64.285,34.485),(64.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,34.485),(64.625,34.655),(64.795,34.655),(64.795,34.485),(64.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,34.145),(64.115,34.315),(64.285,34.315),(64.285,34.145),(64.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,34.145),(64.625,34.315),(64.795,34.315),(64.795,34.145),(64.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.205),(15.605,3.375),(15.775,3.375),(15.775,3.205),(15.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.545),(15.605,3.715),(15.775,3.715),(15.775,3.545),(15.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.445),(54.515,15.615),(54.685,15.615),(54.685,15.445),(54.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.105),(54.005,15.275),(54.175,15.275),(54.175,15.105),(54.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.585),(40.115,39.755),(40.285,39.755),(40.285,39.585),(40.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.585),(40.625,39.755),(40.795,39.755),(40.795,39.585),(40.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.525),(16.625,19.695),(16.795,19.695),(16.795,19.525),(16.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,23.265),(83.315,23.435),(83.485,23.435),(83.485,23.265),(83.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.145),(26.225,17.315),(26.395,17.315),(26.395,17.145),(26.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.485),(26.225,17.655),(26.395,17.655),(26.395,17.485),(26.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.825),(26.225,17.995),(26.395,17.995),(26.395,17.825),(26.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,20.545),(73.715,20.715),(73.885,20.715),(73.885,20.545),(73.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,20.205),(73.715,20.375),(73.885,20.375),(73.885,20.205),(73.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,20.545),(73.205,20.715),(73.375,20.715),(73.375,20.545),(73.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,20.205),(73.205,20.375),(73.375,20.375),(73.375,20.205),(73.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,22.245),(69.425,22.415),(69.595,22.415),(69.595,22.245),(69.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,37.205),(21.425,37.375),(21.595,37.375),(21.595,37.205),(21.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,29.385),(69.425,29.555),(69.595,29.555),(69.595,29.385),(69.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,29.725),(69.425,29.895),(69.595,29.895),(69.595,29.725),(69.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,29.045),(69.425,29.215),(69.595,29.215),(69.595,29.045),(69.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.145),(50.225,34.315),(50.395,34.315),(50.395,34.145),(50.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.825),(50.225,34.995),(50.395,34.995),(50.395,34.825),(50.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.485),(50.225,34.655),(50.395,34.655),(50.395,34.485),(50.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.705),(54.005,11.875),(54.175,11.875),(54.175,11.705),(54.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,23.945),(78.005,24.115),(78.175,24.115),(78.175,23.945),(78.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,23.945),(78.515,24.115),(78.685,24.115),(78.685,23.945),(78.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.025),(54.005,11.195),(54.175,11.195),(54.175,11.025),(54.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.365),(54.515,11.535),(54.685,11.535),(54.685,11.365),(54.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.625),(7.025,7.795),(7.195,7.795),(7.195,7.625),(7.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,28.365),(16.115,28.535),(16.285,28.535),(16.285,28.365),(16.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,38.565),(11.825,38.735),(11.995,38.735),(11.995,38.565),(11.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.645),(58.805,25.815),(58.975,25.815),(58.975,25.645),(58.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.645),(40.115,25.815),(40.285,25.815),(40.285,25.645),(40.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.645),(40.625,25.815),(40.795,25.815),(40.795,25.645),(40.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,37.545),(78.005,37.715),(78.175,37.715),(78.175,37.545),(78.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,37.545),(78.515,37.715),(78.685,37.715),(78.685,37.545),(78.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,33.125),(78.005,33.295),(78.175,33.295),(78.175,33.125),(78.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,33.125),(78.515,33.295),(78.685,33.295),(78.685,33.125),(78.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,33.465),(78.005,33.635),(78.175,33.635),(78.175,33.465),(78.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,33.465),(78.515,33.635),(78.685,33.635),(78.685,33.465),(78.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,33.805),(78.005,33.975),(78.175,33.975),(78.175,33.805),(78.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,33.805),(78.515,33.975),(78.685,33.975),(78.685,33.805),(78.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.665),(49.205,9.835),(49.375,9.835),(49.375,9.665),(49.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.665),(49.715,9.835),(49.885,9.835),(49.885,9.665),(49.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.165),(34.805,18.335),(34.975,18.335),(34.975,18.165),(34.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,38.905),(20.915,39.075),(21.085,39.075),(21.085,38.905),(20.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,39.925),(16.115,40.095),(16.285,40.095),(16.285,39.925),(16.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.865),(78.005,20.035),(78.175,20.035),(78.175,19.865),(78.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.865),(78.515,20.035),(78.685,20.035),(78.685,19.865),(78.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.565),(59.315,21.735),(59.485,21.735),(59.485,21.565),(59.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,21.565),(59.825,21.735),(59.995,21.735),(59.995,21.565),(59.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.565),(59.315,4.735),(59.485,4.735),(59.485,4.565),(59.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.565),(59.825,4.735),(59.995,4.735),(59.995,4.565),(59.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.005),(44.405,27.175),(44.575,27.175),(44.575,27.005),(44.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.345),(44.405,27.515),(44.575,27.515),(44.575,27.345),(44.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.825),(73.715,17.995),(73.885,17.995),(73.885,17.825),(73.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.145),(73.715,17.315),(73.885,17.315),(73.885,17.145),(73.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.145),(73.205,17.315),(73.375,17.315),(73.375,17.145),(73.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.825),(73.205,17.995),(73.375,17.995),(73.375,17.825),(73.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.025),(74.225,11.195),(74.395,11.195),(74.395,11.025),(74.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.365),(74.225,11.535),(74.395,11.535),(74.395,11.365),(74.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.705),(74.225,11.875),(74.395,11.875),(74.395,11.705),(74.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.165),(26.225,18.335),(26.395,18.335),(26.395,18.165),(26.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.505),(26.225,18.675),(26.395,18.675),(26.395,18.505),(26.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,2.865),(7.025,3.035),(7.195,3.035),(7.195,2.865),(7.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.025),(26.225,11.195),(26.395,11.195),(26.395,11.025),(26.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.705),(26.225,11.875),(26.395,11.875),(26.395,11.705),(26.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,20.885),(68.405,21.055),(68.575,21.055),(68.575,20.885),(68.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.085),(44.405,14.255),(44.575,14.255),(44.575,14.085),(44.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.765),(44.405,14.935),(44.575,14.935),(44.575,14.765),(44.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.205),(50.225,37.375),(50.395,37.375),(50.395,37.205),(50.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.405),(74.225,13.575),(74.395,13.575),(74.395,13.405),(74.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,36.865),(7.025,37.035),(7.195,37.035),(7.195,36.865),(7.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,37.885),(25.205,38.055),(25.375,38.055),(25.375,37.885),(25.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.925),(40.115,40.095),(40.285,40.095),(40.285,39.925),(40.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.925),(40.625,40.095),(40.795,40.095),(40.795,39.925),(40.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,26.665),(68.915,26.835),(69.085,26.835),(69.085,26.665),(68.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.245),(49.205,5.415),(49.375,5.415),(49.375,5.245),(49.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.245),(49.715,5.415),(49.885,5.415),(49.885,5.245),(49.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.045),(59.315,29.215),(59.485,29.215),(59.485,29.045),(59.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,29.045),(59.825,29.215),(59.995,29.215),(59.995,29.045),(59.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.385),(59.315,29.555),(59.485,29.555),(59.485,29.385),(59.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,29.385),(59.825,29.555),(59.995,29.555),(59.995,29.385),(59.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.725),(59.315,29.895),(59.485,29.895),(59.485,29.725),(59.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,29.725),(59.825,29.895),(59.995,29.895),(59.995,29.725),(59.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,24.625),(30.005,24.795),(30.175,24.795),(30.175,24.625),(30.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,35.505),(20.915,35.675),(21.085,35.675),(21.085,35.505),(20.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,35.165),(20.915,35.335),(21.085,35.335),(21.085,35.165),(20.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,38.905),(82.805,39.075),(82.975,39.075),(82.975,38.905),(82.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.705),(68.405,11.875),(68.575,11.875),(68.575,11.705),(68.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.025),(68.405,11.195),(68.575,11.195),(68.575,11.025),(68.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.305),(79.025,8.475),(79.195,8.475),(79.195,8.305),(79.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,39.245),(25.205,39.415),(25.375,39.415),(25.375,39.245),(25.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.525),(30.515,19.695),(30.685,19.695),(30.685,19.525),(30.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.185),(30.515,19.355),(30.685,19.355),(30.685,19.185),(30.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,20.205),(30.005,20.375),(30.175,20.375),(30.175,20.205),(30.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,2.865),(21.425,3.035),(21.595,3.035),(21.595,2.865),(21.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.785),(25.715,15.955),(25.885,15.955),(25.885,15.785),(25.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.645),(58.805,8.815),(58.975,8.815),(58.975,8.645),(58.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,40.265),(31.025,40.435),(31.195,40.435),(31.195,40.265),(31.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,26.325),(78.005,26.495),(78.175,26.495),(78.175,26.325),(78.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,26.325),(78.515,26.495),(78.685,26.495),(78.685,26.325),(78.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.345),(34.805,27.515),(34.975,27.515),(34.975,27.345),(34.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.165),(35.315,35.335),(35.485,35.335),(35.485,35.165),(35.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.165),(35.825,35.335),(35.995,35.335),(35.995,35.165),(35.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.505),(35.315,35.675),(35.485,35.675),(35.485,35.505),(35.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.505),(35.825,35.675),(35.995,35.675),(35.995,35.505),(35.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.985),(30.515,26.155),(30.685,26.155),(30.685,25.985),(30.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.365),(40.115,11.535),(40.285,11.535),(40.285,11.365),(40.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.365),(40.625,11.535),(40.795,11.535),(40.795,11.365),(40.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.765),(15.605,14.935),(15.775,14.935),(15.775,14.765),(15.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.085),(15.605,14.255),(15.775,14.255),(15.775,14.085),(15.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.365),(49.205,11.535),(49.375,11.535),(49.375,11.365),(49.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.365),(49.715,11.535),(49.885,11.535),(49.885,11.365),(49.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.865),(50.225,3.035),(50.395,3.035),(50.395,2.865),(50.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.225),(54.515,21.395),(54.685,21.395),(54.685,21.225),(54.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.565),(54.515,21.735),(54.685,21.735),(54.685,21.565),(54.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.165),(6.515,18.335),(6.685,18.335),(6.685,18.165),(6.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.505),(6.515,18.675),(6.685,18.675),(6.685,18.505),(6.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.645),(31.025,8.815),(31.195,8.815),(31.195,8.645),(31.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.305),(31.025,8.475),(31.195,8.475),(31.195,8.305),(31.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.105),(34.805,15.275),(34.975,15.275),(34.975,15.105),(34.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.445),(34.805,15.615),(34.975,15.615),(34.975,15.445),(34.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,2.865),(20.405,3.035),(20.575,3.035),(20.575,2.865),(20.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,22.585),(78.005,22.755),(78.175,22.755),(78.175,22.585),(78.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,22.585),(78.515,22.755),(78.685,22.755),(78.685,22.585),(78.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.985),(83.315,9.155),(83.485,9.155),(83.485,8.985),(83.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,26.325),(44.915,26.495),(45.085,26.495),(45.085,26.325),(44.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.865),(59.315,3.035),(59.485,3.035),(59.485,2.865),(59.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,2.865),(59.825,3.035),(59.995,3.035),(59.995,2.865),(59.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.465),(64.115,16.635),(64.285,16.635),(64.285,16.465),(64.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.465),(64.625,16.635),(64.795,16.635),(64.795,16.465),(64.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,38.905),(21.425,39.075),(21.595,39.075),(21.595,38.905),(21.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,26.325),(59.315,26.495),(59.485,26.495),(59.485,26.325),(59.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,26.325),(59.825,26.495),(59.995,26.495),(59.995,26.325),(59.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.565),(45.425,21.735),(45.595,21.735),(45.595,21.565),(45.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,37.205),(63.605,37.375),(63.775,37.375),(63.775,37.205),(63.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,26.665),(82.805,26.835),(82.975,26.835),(82.975,26.665),(82.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,38.905),(25.715,39.075),(25.885,39.075),(25.885,38.905),(25.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.545),(58.805,3.715),(58.975,3.715),(58.975,3.545),(58.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.185),(83.315,19.355),(83.485,19.355),(83.485,19.185),(83.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.625),(69.425,7.795),(69.595,7.795),(69.595,7.625),(69.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,22.585),(10.805,22.755),(10.975,22.755),(10.975,22.585),(10.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.545),(34.805,3.715),(34.975,3.715),(34.975,3.545),(34.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.205),(34.805,3.375),(34.975,3.375),(34.975,3.205),(34.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.245),(49.205,22.415),(49.375,22.415),(49.375,22.245),(49.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.245),(49.715,22.415),(49.885,22.415),(49.885,22.245),(49.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.585),(49.205,22.755),(49.375,22.755),(49.375,22.585),(49.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.585),(49.715,22.755),(49.885,22.755),(49.885,22.585),(49.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,25.645),(11.315,25.815),(11.485,25.815),(11.485,25.645),(11.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.565),(25.205,4.735),(25.375,4.735),(25.375,4.565),(25.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,37.545),(11.315,37.715),(11.485,37.715),(11.485,37.545),(11.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,37.545),(11.825,37.715),(11.995,37.715),(11.995,37.545),(11.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.605),(31.025,6.775),(31.195,6.775),(31.195,6.605),(31.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,35.845),(63.605,36.015),(63.775,36.015),(63.775,35.845),(63.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,24.625),(16.625,24.795),(16.795,24.795),(16.795,24.625),(16.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,30.405),(26.225,30.575),(26.395,30.575),(26.395,30.405),(26.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,23.945),(82.805,24.115),(82.975,24.115),(82.975,23.945),(82.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.685),(55.025,10.855),(55.195,10.855),(55.195,10.685),(55.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,37.205),(20.915,37.375),(21.085,37.375),(21.085,37.205),(20.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.005),(55.025,10.175),(55.195,10.175),(55.195,10.005),(55.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.565),(44.915,38.735),(45.085,38.735),(45.085,38.565),(44.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.325),(40.115,9.495),(40.285,9.495),(40.285,9.325),(40.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.325),(40.625,9.495),(40.795,9.495),(40.795,9.325),(40.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.605),(45.425,6.775),(45.595,6.775),(45.595,6.605),(45.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.965),(11.315,8.135),(11.485,8.135),(11.485,7.965),(11.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.265),(45.425,6.435),(45.595,6.435),(45.595,6.265),(45.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,20.545),(20.915,20.715),(21.085,20.715),(21.085,20.545),(20.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,20.205),(20.915,20.375),(21.085,20.375),(21.085,20.205),(20.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,36.865),(26.225,37.035),(26.395,37.035),(26.395,36.865),(26.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.985),(30.515,9.155),(30.685,9.155),(30.685,8.985),(30.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.605),(20.915,6.775),(21.085,6.775),(21.085,6.605),(20.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.725),(45.425,29.895),(45.595,29.895),(45.595,29.725),(45.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.045),(45.425,29.215),(45.595,29.215),(45.595,29.045),(45.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.385),(45.425,29.555),(45.595,29.555),(45.595,29.385),(45.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.365),(83.315,11.535),(83.485,11.535),(83.485,11.365),(83.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.705),(83.315,11.875),(83.485,11.875),(83.485,11.705),(83.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.025),(83.315,11.195),(83.485,11.195),(83.485,11.025),(83.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.865),(79.025,20.035),(79.195,20.035),(79.195,19.865),(79.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.345),(34.805,10.515),(34.975,10.515),(34.975,10.345),(34.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.685),(54.515,27.855),(54.685,27.855),(54.685,27.685),(54.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.365),(35.315,11.535),(35.485,11.535),(35.485,11.365),(35.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.365),(35.825,11.535),(35.995,11.535),(35.995,11.365),(35.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.625),(54.005,7.795),(54.175,7.795),(54.175,7.625),(54.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,29.385),(7.025,29.555),(7.195,29.555),(7.195,29.385),(7.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,29.045),(7.025,29.215),(7.195,29.215),(7.195,29.045),(7.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,29.725),(7.025,29.895),(7.195,29.895),(7.195,29.725),(7.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,40.605),(30.515,40.775),(30.685,40.775),(30.685,40.605),(30.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,28.705),(83.315,28.875),(83.485,28.875),(83.485,28.705),(83.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,28.025),(83.315,28.195),(83.485,28.195),(83.485,28.025),(83.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,28.365),(83.315,28.535),(83.485,28.535),(83.485,28.365),(83.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,35.165),(79.025,35.335),(79.195,35.335),(79.195,35.165),(79.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,35.505),(79.025,35.675),(79.195,35.675),(79.195,35.505),(79.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,38.565),(6.515,38.735),(6.685,38.735),(6.685,38.565),(6.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.185),(20.915,19.355),(21.085,19.355),(21.085,19.185),(20.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,39.925),(11.825,40.095),(11.995,40.095),(11.995,39.925),(11.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.625),(6.515,7.795),(6.685,7.795),(6.685,7.625),(6.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.065),(10.805,13.235),(10.975,13.235),(10.975,13.065),(10.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.745),(10.805,13.915),(10.975,13.915),(10.975,13.745),(10.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.425),(25.715,14.595),(25.885,14.595),(25.885,14.425),(25.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.085),(25.715,14.255),(25.885,14.255),(25.885,14.085),(25.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.765),(25.715,14.935),(25.885,14.935),(25.885,14.765),(25.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,26.665),(74.225,26.835),(74.395,26.835),(74.395,26.665),(74.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,26.325),(74.225,26.495),(74.395,26.495),(74.395,26.325),(74.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,35.165),(64.625,35.335),(64.795,35.335),(64.795,35.165),(64.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,35.505),(64.115,35.675),(64.285,35.675),(64.285,35.505),(64.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,35.505),(64.625,35.675),(64.795,35.675),(64.795,35.505),(64.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,35.165),(64.115,35.335),(64.285,35.335),(64.285,35.165),(64.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.205),(45.425,20.375),(45.595,20.375),(45.595,20.205),(45.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.185),(49.205,36.355),(49.375,36.355),(49.375,36.185),(49.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.185),(49.715,36.355),(49.885,36.355),(49.885,36.185),(49.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.525),(49.205,36.695),(49.375,36.695),(49.375,36.525),(49.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.525),(49.715,36.695),(49.885,36.695),(49.885,36.525),(49.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.885),(44.405,4.055),(44.575,4.055),(44.575,3.885),(44.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,20.205),(16.625,20.375),(16.795,20.375),(16.795,20.205),(16.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,23.605),(11.825,23.775),(11.995,23.775),(11.995,23.605),(11.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.345),(68.915,10.515),(69.085,10.515),(69.085,10.345),(68.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.205),(59.315,20.375),(59.485,20.375),(59.485,20.205),(59.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,20.205),(59.825,20.375),(59.995,20.375),(59.995,20.205),(59.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.885),(58.805,4.055),(58.975,4.055),(58.975,3.885),(58.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,28.365),(74.225,28.535),(74.395,28.535),(74.395,28.365),(74.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.905),(73.715,5.075),(73.885,5.075),(73.885,4.905),(73.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,28.705),(74.225,28.875),(74.395,28.875),(74.395,28.705),(74.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,28.025),(74.225,28.195),(74.395,28.195),(74.395,28.025),(74.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.905),(73.205,5.075),(73.375,5.075),(73.375,4.905),(73.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.565),(58.805,21.735),(58.975,21.735),(58.975,21.565),(58.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.225),(58.805,21.395),(58.975,21.395),(58.975,21.225),(58.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.025),(21.425,11.195),(21.595,11.195),(21.595,11.025),(21.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.705),(21.425,11.875),(21.595,11.875),(21.595,11.705),(21.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.845),(83.315,19.015),(83.485,19.015),(83.485,18.845),(83.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,24.625),(79.025,24.795),(79.195,24.795),(79.195,24.625),(79.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.905),(25.205,5.075),(25.375,5.075),(25.375,4.905),(25.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.985),(39.605,26.155),(39.775,26.155),(39.775,25.985),(39.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.905),(40.625,22.075),(40.795,22.075),(40.795,21.905),(40.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.905),(40.115,22.075),(40.285,22.075),(40.285,21.905),(40.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.165),(54.515,35.335),(54.685,35.335),(54.685,35.165),(54.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.505),(54.515,35.675),(54.685,35.675),(54.685,35.505),(54.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,29.385),(79.025,29.555),(79.195,29.555),(79.195,29.385),(79.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,28.365),(79.025,28.535),(79.195,28.535),(79.195,28.365),(79.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,27.685),(26.225,27.855),(26.395,27.855),(26.395,27.685),(26.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,33.125),(15.605,33.295),(15.775,33.295),(15.775,33.125),(15.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,33.465),(15.605,33.635),(15.775,33.635),(15.775,33.465),(15.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,33.805),(15.605,33.975),(15.775,33.975),(15.775,33.805),(15.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.625),(45.425,24.795),(45.595,24.795),(45.595,24.625),(45.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.065),(54.005,13.235),(54.175,13.235),(54.175,13.065),(54.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.405),(54.515,13.575),(54.685,13.575),(54.685,13.405),(54.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.745),(54.005,13.915),(54.175,13.915),(54.175,13.745),(54.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,35.845),(73.205,36.015),(73.375,36.015),(73.375,35.845),(73.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,35.845),(73.715,36.015),(73.885,36.015),(73.885,35.845),(73.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.785),(21.425,15.955),(21.595,15.955),(21.595,15.785),(21.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.105),(21.425,15.275),(21.595,15.275),(21.595,15.105),(21.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.445),(21.425,15.615),(21.595,15.615),(21.595,15.445),(21.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,24.285),(69.425,24.455),(69.595,24.455),(69.595,24.285),(69.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.985),(54.005,26.155),(54.175,26.155),(54.175,25.985),(54.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.065),(6.515,13.235),(6.685,13.235),(6.685,13.065),(6.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.745),(6.515,13.915),(6.685,13.915),(6.685,13.745),(6.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.165),(45.425,35.335),(45.595,35.335),(45.595,35.165),(45.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.505),(45.425,35.675),(45.595,35.675),(45.595,35.505),(45.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.705),(45.425,28.875),(45.595,28.875),(45.595,28.705),(45.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.025),(45.425,28.195),(45.595,28.195),(45.595,28.025),(45.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.365),(45.425,28.535),(45.595,28.535),(45.595,28.365),(45.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,39.925),(30.005,40.095),(30.175,40.095),(30.175,39.925),(30.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.525),(73.205,19.695),(73.375,19.695),(73.375,19.525),(73.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.525),(73.715,19.695),(73.885,19.695),(73.885,19.525),(73.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.565),(40.625,38.735),(40.795,38.735),(40.795,38.565),(40.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.565),(40.115,38.735),(40.285,38.735),(40.285,38.565),(40.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.025),(59.315,28.195),(59.485,28.195),(59.485,28.025),(59.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,28.025),(59.825,28.195),(59.995,28.195),(59.995,28.025),(59.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.705),(59.315,28.875),(59.485,28.875),(59.485,28.705),(59.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,28.705),(59.825,28.875),(59.995,28.875),(59.995,28.705),(59.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,28.365),(69.425,28.535),(69.595,28.535),(69.595,28.365),(69.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.165),(15.605,18.335),(15.775,18.335),(15.775,18.165),(15.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.125),(79.025,16.295),(79.195,16.295),(79.195,16.125),(79.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.805),(79.025,16.975),(79.195,16.975),(79.195,16.805),(79.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,37.545),(83.315,37.715),(83.485,37.715),(83.485,37.545),(83.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.565),(30.005,4.735),(30.175,4.735),(30.175,4.565),(30.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.765),(34.805,31.935),(34.975,31.935),(34.975,31.765),(34.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.085),(34.805,31.255),(34.975,31.255),(34.975,31.085),(34.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.865),(40.115,37.035),(40.285,37.035),(40.285,36.865),(40.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.865),(40.625,37.035),(40.795,37.035),(40.795,36.865),(40.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.185),(26.225,19.355),(26.395,19.355),(26.395,19.185),(26.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.525),(26.225,19.695),(26.395,19.695),(26.395,19.525),(26.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,20.885),(25.715,21.055),(25.885,21.055),(25.885,20.885),(25.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.305),(73.715,8.475),(73.885,8.475),(73.885,8.305),(73.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.305),(73.205,8.475),(73.375,8.475),(73.375,8.305),(73.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.845),(30.515,36.015),(30.685,36.015),(30.685,35.845),(30.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.585),(34.805,39.755),(34.975,39.755),(34.975,39.585),(34.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.565),(58.805,4.735),(58.975,4.735),(58.975,4.565),(58.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,38.225),(16.115,38.395),(16.285,38.395),(16.285,38.225),(16.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.225),(34.805,4.395),(34.975,4.395),(34.975,4.225),(34.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,25.985),(26.225,26.155),(26.395,26.155),(26.395,25.985),(26.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.565),(54.515,4.735),(54.685,4.735),(54.685,4.565),(54.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.225),(54.005,4.395),(54.175,4.395),(54.175,4.225),(54.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.845),(40.115,19.015),(40.285,19.015),(40.285,18.845),(40.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.845),(40.625,19.015),(40.795,19.015),(40.795,18.845),(40.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.145),(20.915,17.315),(21.085,17.315),(21.085,17.145),(20.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.825),(20.915,17.995),(21.085,17.995),(21.085,17.825),(20.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,25.985),(79.025,26.155),(79.195,26.155),(79.195,25.985),(79.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,35.845),(68.915,36.015),(69.085,36.015),(69.085,35.845),(68.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.905),(6.515,5.075),(6.685,5.075),(6.685,4.905),(6.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,26.665),(40.115,26.835),(40.285,26.835),(40.285,26.665),(40.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.845),(54.005,36.015),(54.175,36.015),(54.175,35.845),(54.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,26.665),(40.625,26.835),(40.795,26.835),(40.795,26.665),(40.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,30.065),(20.915,30.235),(21.085,30.235),(21.085,30.065),(20.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,30.405),(20.915,30.575),(21.085,30.575),(21.085,30.405),(20.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,30.745),(20.915,30.915),(21.085,30.915),(21.085,30.745),(20.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,36.525),(73.205,36.695),(73.375,36.695),(73.375,36.525),(73.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,36.525),(73.715,36.695),(73.885,36.695),(73.885,36.525),(73.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,36.185),(73.205,36.355),(73.375,36.355),(73.375,36.185),(73.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,36.185),(73.715,36.355),(73.885,36.355),(73.885,36.185),(73.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.405),(35.315,13.575),(35.485,13.575),(35.485,13.405),(35.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.405),(35.825,13.575),(35.995,13.575),(35.995,13.405),(35.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.745),(35.315,13.915),(35.485,13.915),(35.485,13.745),(35.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.745),(35.825,13.915),(35.995,13.915),(35.995,13.745),(35.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.065),(35.825,13.235),(35.995,13.235),(35.995,13.065),(35.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.505),(49.205,18.675),(49.375,18.675),(49.375,18.505),(49.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.505),(49.715,18.675),(49.885,18.675),(49.885,18.505),(49.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.265),(16.625,6.435),(16.795,6.435),(16.795,6.265),(16.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.605),(16.625,6.775),(16.795,6.775),(16.795,6.605),(16.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.845),(30.515,19.015),(30.685,19.015),(30.685,18.845),(30.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.325),(11.315,9.495),(11.485,9.495),(11.485,9.325),(11.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.425),(59.315,31.595),(59.485,31.595),(59.485,31.425),(59.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,31.425),(59.825,31.595),(59.995,31.595),(59.995,31.425),(59.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.745),(30.515,30.915),(30.685,30.915),(30.685,30.745),(30.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.065),(30.515,30.235),(30.685,30.235),(30.685,30.065),(30.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.965),(26.225,8.135),(26.395,8.135),(26.395,7.965),(26.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.485),(82.805,17.655),(82.975,17.655),(82.975,17.485),(82.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,30.065),(83.315,30.235),(83.485,30.235),(83.485,30.065),(83.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,30.745),(83.315,30.915),(83.485,30.915),(83.485,30.745),(83.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,40.605),(16.115,40.775),(16.285,40.775),(16.285,40.605),(16.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,26.325),(30.515,26.495),(30.685,26.495),(30.685,26.325),(30.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.905),(30.005,5.075),(30.175,5.075),(30.175,4.905),(30.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.965),(40.625,25.135),(40.795,25.135),(40.795,24.965),(40.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.965),(40.115,25.135),(40.285,25.135),(40.285,24.965),(40.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,30.405),(64.115,30.575),(64.285,30.575),(64.285,30.405),(64.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,30.405),(64.625,30.575),(64.795,30.575),(64.795,30.405),(64.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,30.745),(64.115,30.915),(64.285,30.915),(64.285,30.745),(64.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,30.745),(64.625,30.915),(64.795,30.915),(64.795,30.745),(64.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,30.065),(64.115,30.235),(64.285,30.235),(64.285,30.065),(64.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,30.065),(64.625,30.235),(64.795,30.235),(64.795,30.065),(64.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,25.305),(25.205,25.475),(25.375,25.475),(25.375,25.305),(25.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,25.645),(25.205,25.815),(25.375,25.815),(25.375,25.645),(25.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.925),(44.915,6.095),(45.085,6.095),(45.085,5.925),(44.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.685),(82.805,10.855),(82.975,10.855),(82.975,10.685),(82.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.005),(82.805,10.175),(82.975,10.175),(82.975,10.005),(82.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,22.585),(11.315,22.755),(11.485,22.755),(11.485,22.585),(11.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.025),(69.425,11.195),(69.595,11.195),(69.595,11.025),(69.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.705),(69.425,11.875),(69.595,11.875),(69.595,11.705),(69.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,20.885),(10.805,21.055),(10.975,21.055),(10.975,20.885),(10.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,2.865),(68.915,3.035),(69.085,3.035),(69.085,2.865),(68.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.905),(55.025,39.075),(55.195,39.075),(55.195,38.905),(55.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.705),(44.915,11.875),(45.085,11.875),(45.085,11.705),(44.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.865),(44.915,20.035),(45.085,20.035),(45.085,19.865),(44.915,19.865)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.58),(73.715,2.06),(73.885,2.06),(73.885,1.58),(73.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,41.58),(25.715,42.06),(25.885,42.06),(25.885,41.58),(25.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,41.58),(78.515,42.06),(78.685,42.06),(78.685,41.58),(78.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.205,2.785),(73.205,40.855),(74.395,40.855),(74.395,2.785),(73.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((63.605,2.785),(63.605,40.855),(64.795,40.855),(64.795,2.785),(63.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((6.515,2.785),(6.515,40.855),(7.195,40.855),(7.195,2.785),(6.515,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.785),(58.805,40.855),(59.995,40.855),(59.995,2.785),(58.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,41.58),(20.915,42.06),(21.085,42.06),(21.085,41.58),(20.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,41.58),(68.915,42.06),(69.085,42.06),(69.085,41.58),(68.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,21.36),(85.76,21.44),(85.58,21.44),(85.58,21.61),(85.76,21.61),(85.76,21.69),(85.93,21.69),(85.93,21.61),(86.11,21.61),(86.11,21.44),(85.93,21.44),(85.93,21.36),(85.76,21.36)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.58),(25.715,2.06),(25.885,2.06),(25.885,1.58),(25.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.58),(78.515,2.06),(78.685,2.06),(78.685,1.58),(78.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((78.005,2.785),(78.005,40.855),(79.195,40.855),(79.195,2.785),(78.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,41.58),(16.115,42.06),(16.285,42.06),(16.285,41.58),(16.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,41.58),(59.315,42.06),(59.485,42.06),(59.485,41.58),(59.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.785),(54.005,40.855),(55.195,40.855),(55.195,2.785),(54.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((20.405,2.785),(20.405,40.855),(21.595,40.855),(21.595,2.785),(20.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.785),(44.405,40.855),(45.595,40.855),(45.595,2.785),(44.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.58),(16.115,2.06),(16.285,2.06),(16.285,1.58),(16.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,41.58),(40.115,42.06),(40.285,42.06),(40.285,41.58),(40.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,1.735),(85.58,1.905),(86.11,1.905),(86.11,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,41.58),(30.515,42.06),(30.685,42.06),(30.685,41.58),(30.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.58),(59.315,2.06),(59.485,2.06),(59.485,1.58),(59.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,41.58),(11.315,42.06),(11.485,42.06),(11.485,41.58),(11.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,41.58),(6.77,42.06),(6.94,42.06),(6.94,41.58),(6.77,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,41.58),(83.06,42.06),(83.23,42.06),(83.23,41.58),(83.06,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((68.405,2.785),(68.405,40.855),(69.595,40.855),(69.595,2.785),(68.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,41.58),(49.715,42.06),(49.885,42.06),(49.885,41.58),(49.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.58),(6.77,2.06),(6.94,2.06),(6.94,1.58),(6.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.58),(68.915,2.06),(69.085,2.06),(69.085,1.58),(68.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,41.58),(44.915,42.06),(45.085,42.06),(45.085,41.58),(44.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,41.58),(54.515,42.06),(54.685,42.06),(54.685,41.58),(54.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((25.205,2.785),(25.205,40.855),(26.395,40.855),(26.395,2.785),(25.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,41.58),(73.715,42.06),(73.885,42.06),(73.885,41.58),(73.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.58),(30.515,2.06),(30.685,2.06),(30.685,1.58),(30.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.005,2.785),(30.005,40.855),(31.195,40.855),(31.195,2.785),(30.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.785),(34.805,40.855),(35.995,40.855),(35.995,2.785),(34.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((82.805,2.785),(82.805,40.855),(83.485,40.855),(83.485,2.785),(82.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.785),(49.205,40.855),(50.395,40.855),(50.395,2.785),(49.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,41.58),(64.115,42.06),(64.285,42.06),(64.285,41.58),(64.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.58),(11.315,2.06),(11.485,2.06),(11.485,1.58),(11.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.58),(83.06,2.06),(83.23,2.06),(83.23,1.58),(83.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((15.605,2.785),(15.605,40.855),(16.795,40.855),(16.795,2.785),(15.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.785),(39.605,40.855),(40.795,40.855),(40.795,2.785),(39.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,41.58),(35.315,42.06),(35.485,42.06),(35.485,41.58),(35.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((10.805,2.785),(10.805,40.855),(11.995,40.855),(11.995,2.785),(10.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.58),(20.915,2.06),(21.085,2.06),(21.085,1.58),(20.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.58),(64.115,2.06),(64.285,2.06),(64.285,1.58),(64.115,1.58)),
        )
        createRL(
            tech, net, 'nwm',
            ((3.85,39.99),(3.85,41.1),(4.46,41.1),(4.46,39.99),(3.85,39.99)),
        )
        createRL(
            tech, net, 'nwm',
            ((6.07,2.54),(6.07,41.1),(83.93,41.1),(83.93,2.54),(6.07,2.54)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,41.735),(44.915,41.905),(45.085,41.905),(45.085,41.735),(44.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,41.735),(78.515,41.905),(78.685,41.905),(78.685,41.735),(78.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,41.735),(59.315,41.905),(59.485,41.905),(59.485,41.735),(59.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,2.835),(78.515,3.005),(78.685,3.005),(78.685,2.835),(78.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.195),(78.515,3.365),(78.685,3.365),(78.685,3.195),(78.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.555),(78.515,3.725),(78.685,3.725),(78.685,3.555),(78.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.915),(78.515,4.085),(78.685,4.085),(78.685,3.915),(78.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.275),(78.515,4.445),(78.685,4.445),(78.685,4.275),(78.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.635),(78.515,4.805),(78.685,4.805),(78.685,4.635),(78.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.995),(78.515,5.165),(78.685,5.165),(78.685,4.995),(78.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.355),(78.515,5.525),(78.685,5.525),(78.685,5.355),(78.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.715),(78.515,5.885),(78.685,5.885),(78.685,5.715),(78.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.075),(78.515,6.245),(78.685,6.245),(78.685,6.075),(78.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.435),(78.515,6.605),(78.685,6.605),(78.685,6.435),(78.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.795),(78.515,6.965),(78.685,6.965),(78.685,6.795),(78.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.155),(78.515,7.325),(78.685,7.325),(78.685,7.155),(78.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.515),(78.515,7.685),(78.685,7.685),(78.685,7.515),(78.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.875),(78.515,8.045),(78.685,8.045),(78.685,7.875),(78.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.235),(78.515,8.405),(78.685,8.405),(78.685,8.235),(78.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.595),(78.515,8.765),(78.685,8.765),(78.685,8.595),(78.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.955),(78.515,9.125),(78.685,9.125),(78.685,8.955),(78.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.315),(78.515,9.485),(78.685,9.485),(78.685,9.315),(78.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.675),(78.515,9.845),(78.685,9.845),(78.685,9.675),(78.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.035),(78.515,10.205),(78.685,10.205),(78.685,10.035),(78.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.395),(78.515,10.565),(78.685,10.565),(78.685,10.395),(78.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.755),(78.515,10.925),(78.685,10.925),(78.685,10.755),(78.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.115),(78.515,11.285),(78.685,11.285),(78.685,11.115),(78.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.475),(78.515,11.645),(78.685,11.645),(78.685,11.475),(78.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.835),(78.515,12.005),(78.685,12.005),(78.685,11.835),(78.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.195),(78.515,12.365),(78.685,12.365),(78.685,12.195),(78.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.555),(78.515,12.725),(78.685,12.725),(78.685,12.555),(78.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.915),(78.515,13.085),(78.685,13.085),(78.685,12.915),(78.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.275),(78.515,13.445),(78.685,13.445),(78.685,13.275),(78.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.635),(78.515,13.805),(78.685,13.805),(78.685,13.635),(78.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.995),(78.515,14.165),(78.685,14.165),(78.685,13.995),(78.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.355),(78.515,14.525),(78.685,14.525),(78.685,14.355),(78.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.715),(78.515,14.885),(78.685,14.885),(78.685,14.715),(78.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.075),(78.515,15.245),(78.685,15.245),(78.685,15.075),(78.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.435),(78.515,15.605),(78.685,15.605),(78.685,15.435),(78.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.795),(78.515,15.965),(78.685,15.965),(78.685,15.795),(78.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.155),(78.515,16.325),(78.685,16.325),(78.685,16.155),(78.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.515),(78.515,16.685),(78.685,16.685),(78.685,16.515),(78.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.875),(78.515,17.045),(78.685,17.045),(78.685,16.875),(78.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.235),(78.515,17.405),(78.685,17.405),(78.685,17.235),(78.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.595),(78.515,17.765),(78.685,17.765),(78.685,17.595),(78.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.955),(78.515,18.125),(78.685,18.125),(78.685,17.955),(78.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.315),(78.515,18.485),(78.685,18.485),(78.685,18.315),(78.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.675),(78.515,18.845),(78.685,18.845),(78.685,18.675),(78.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.035),(78.515,19.205),(78.685,19.205),(78.685,19.035),(78.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.395),(78.515,19.565),(78.685,19.565),(78.685,19.395),(78.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.755),(78.515,19.925),(78.685,19.925),(78.685,19.755),(78.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.115),(78.515,20.285),(78.685,20.285),(78.685,20.115),(78.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.475),(78.515,20.645),(78.685,20.645),(78.685,20.475),(78.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.835),(78.515,21.005),(78.685,21.005),(78.685,20.835),(78.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,21.195),(78.515,21.365),(78.685,21.365),(78.685,21.195),(78.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,21.555),(78.515,21.725),(78.685,21.725),(78.685,21.555),(78.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,21.915),(78.515,22.085),(78.685,22.085),(78.685,21.915),(78.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,22.275),(78.515,22.445),(78.685,22.445),(78.685,22.275),(78.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,22.635),(78.515,22.805),(78.685,22.805),(78.685,22.635),(78.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,22.995),(78.515,23.165),(78.685,23.165),(78.685,22.995),(78.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,23.355),(78.515,23.525),(78.685,23.525),(78.685,23.355),(78.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,23.715),(78.515,23.885),(78.685,23.885),(78.685,23.715),(78.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,24.075),(78.515,24.245),(78.685,24.245),(78.685,24.075),(78.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,24.435),(78.515,24.605),(78.685,24.605),(78.685,24.435),(78.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,24.795),(78.515,24.965),(78.685,24.965),(78.685,24.795),(78.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,25.155),(78.515,25.325),(78.685,25.325),(78.685,25.155),(78.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,25.515),(78.515,25.685),(78.685,25.685),(78.685,25.515),(78.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,25.875),(78.515,26.045),(78.685,26.045),(78.685,25.875),(78.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,26.235),(78.515,26.405),(78.685,26.405),(78.685,26.235),(78.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,26.595),(78.515,26.765),(78.685,26.765),(78.685,26.595),(78.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,26.955),(78.515,27.125),(78.685,27.125),(78.685,26.955),(78.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,27.315),(78.515,27.485),(78.685,27.485),(78.685,27.315),(78.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,27.675),(78.515,27.845),(78.685,27.845),(78.685,27.675),(78.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,28.035),(78.515,28.205),(78.685,28.205),(78.685,28.035),(78.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,28.395),(78.515,28.565),(78.685,28.565),(78.685,28.395),(78.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,28.755),(78.515,28.925),(78.685,28.925),(78.685,28.755),(78.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,29.115),(78.515,29.285),(78.685,29.285),(78.685,29.115),(78.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,29.475),(78.515,29.645),(78.685,29.645),(78.685,29.475),(78.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,29.835),(78.515,30.005),(78.685,30.005),(78.685,29.835),(78.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,30.195),(78.515,30.365),(78.685,30.365),(78.685,30.195),(78.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,30.555),(78.515,30.725),(78.685,30.725),(78.685,30.555),(78.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,30.915),(78.515,31.085),(78.685,31.085),(78.685,30.915),(78.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,31.275),(78.515,31.445),(78.685,31.445),(78.685,31.275),(78.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,31.635),(78.515,31.805),(78.685,31.805),(78.685,31.635),(78.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,31.995),(78.515,32.165),(78.685,32.165),(78.685,31.995),(78.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,32.355),(78.515,32.525),(78.685,32.525),(78.685,32.355),(78.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,32.715),(78.515,32.885),(78.685,32.885),(78.685,32.715),(78.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,33.075),(78.515,33.245),(78.685,33.245),(78.685,33.075),(78.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,33.435),(78.515,33.605),(78.685,33.605),(78.685,33.435),(78.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,33.795),(78.515,33.965),(78.685,33.965),(78.685,33.795),(78.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,34.155),(78.515,34.325),(78.685,34.325),(78.685,34.155),(78.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,34.515),(78.515,34.685),(78.685,34.685),(78.685,34.515),(78.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,34.875),(78.515,35.045),(78.685,35.045),(78.685,34.875),(78.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,35.235),(78.515,35.405),(78.685,35.405),(78.685,35.235),(78.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,35.595),(78.515,35.765),(78.685,35.765),(78.685,35.595),(78.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,35.955),(78.515,36.125),(78.685,36.125),(78.685,35.955),(78.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,36.315),(78.515,36.485),(78.685,36.485),(78.685,36.315),(78.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,36.675),(78.515,36.845),(78.685,36.845),(78.685,36.675),(78.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,37.035),(78.515,37.205),(78.685,37.205),(78.685,37.035),(78.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,37.395),(78.515,37.565),(78.685,37.565),(78.685,37.395),(78.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,37.755),(78.515,37.925),(78.685,37.925),(78.685,37.755),(78.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,38.115),(78.515,38.285),(78.685,38.285),(78.685,38.115),(78.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,38.475),(78.515,38.645),(78.685,38.645),(78.685,38.475),(78.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,38.835),(78.515,39.005),(78.685,39.005),(78.685,38.835),(78.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,39.195),(78.515,39.365),(78.685,39.365),(78.685,39.195),(78.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,39.555),(78.515,39.725),(78.685,39.725),(78.685,39.555),(78.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,39.915),(78.515,40.085),(78.685,40.085),(78.685,39.915),(78.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,40.275),(78.515,40.445),(78.685,40.445),(78.685,40.275),(78.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,40.635),(78.515,40.805),(78.685,40.805),(78.685,40.635),(78.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,2.835),(30.515,3.005),(30.685,3.005),(30.685,2.835),(30.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.195),(30.515,3.365),(30.685,3.365),(30.685,3.195),(30.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.555),(30.515,3.725),(30.685,3.725),(30.685,3.555),(30.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.915),(30.515,4.085),(30.685,4.085),(30.685,3.915),(30.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.275),(30.515,4.445),(30.685,4.445),(30.685,4.275),(30.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.635),(30.515,4.805),(30.685,4.805),(30.685,4.635),(30.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.995),(30.515,5.165),(30.685,5.165),(30.685,4.995),(30.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.355),(30.515,5.525),(30.685,5.525),(30.685,5.355),(30.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.715),(30.515,5.885),(30.685,5.885),(30.685,5.715),(30.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.075),(30.515,6.245),(30.685,6.245),(30.685,6.075),(30.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.435),(30.515,6.605),(30.685,6.605),(30.685,6.435),(30.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.795),(30.515,6.965),(30.685,6.965),(30.685,6.795),(30.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.155),(30.515,7.325),(30.685,7.325),(30.685,7.155),(30.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.515),(30.515,7.685),(30.685,7.685),(30.685,7.515),(30.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.875),(30.515,8.045),(30.685,8.045),(30.685,7.875),(30.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.235),(30.515,8.405),(30.685,8.405),(30.685,8.235),(30.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.595),(30.515,8.765),(30.685,8.765),(30.685,8.595),(30.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.955),(30.515,9.125),(30.685,9.125),(30.685,8.955),(30.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.315),(30.515,9.485),(30.685,9.485),(30.685,9.315),(30.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.675),(30.515,9.845),(30.685,9.845),(30.685,9.675),(30.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.035),(30.515,10.205),(30.685,10.205),(30.685,10.035),(30.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.395),(30.515,10.565),(30.685,10.565),(30.685,10.395),(30.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.755),(30.515,10.925),(30.685,10.925),(30.685,10.755),(30.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.115),(30.515,11.285),(30.685,11.285),(30.685,11.115),(30.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.475),(30.515,11.645),(30.685,11.645),(30.685,11.475),(30.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.835),(30.515,12.005),(30.685,12.005),(30.685,11.835),(30.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.195),(30.515,12.365),(30.685,12.365),(30.685,12.195),(30.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.555),(30.515,12.725),(30.685,12.725),(30.685,12.555),(30.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.915),(30.515,13.085),(30.685,13.085),(30.685,12.915),(30.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.275),(30.515,13.445),(30.685,13.445),(30.685,13.275),(30.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.635),(30.515,13.805),(30.685,13.805),(30.685,13.635),(30.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.995),(30.515,14.165),(30.685,14.165),(30.685,13.995),(30.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.355),(30.515,14.525),(30.685,14.525),(30.685,14.355),(30.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.715),(30.515,14.885),(30.685,14.885),(30.685,14.715),(30.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.075),(30.515,15.245),(30.685,15.245),(30.685,15.075),(30.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.435),(30.515,15.605),(30.685,15.605),(30.685,15.435),(30.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.795),(30.515,15.965),(30.685,15.965),(30.685,15.795),(30.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.155),(30.515,16.325),(30.685,16.325),(30.685,16.155),(30.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.515),(30.515,16.685),(30.685,16.685),(30.685,16.515),(30.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.875),(30.515,17.045),(30.685,17.045),(30.685,16.875),(30.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.235),(30.515,17.405),(30.685,17.405),(30.685,17.235),(30.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.595),(30.515,17.765),(30.685,17.765),(30.685,17.595),(30.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.955),(30.515,18.125),(30.685,18.125),(30.685,17.955),(30.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.315),(30.515,18.485),(30.685,18.485),(30.685,18.315),(30.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.675),(30.515,18.845),(30.685,18.845),(30.685,18.675),(30.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.035),(30.515,19.205),(30.685,19.205),(30.685,19.035),(30.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.395),(30.515,19.565),(30.685,19.565),(30.685,19.395),(30.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.755),(30.515,19.925),(30.685,19.925),(30.685,19.755),(30.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.115),(30.515,20.285),(30.685,20.285),(30.685,20.115),(30.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.475),(30.515,20.645),(30.685,20.645),(30.685,20.475),(30.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.835),(30.515,21.005),(30.685,21.005),(30.685,20.835),(30.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,21.195),(30.515,21.365),(30.685,21.365),(30.685,21.195),(30.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,21.555),(30.515,21.725),(30.685,21.725),(30.685,21.555),(30.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,21.915),(30.515,22.085),(30.685,22.085),(30.685,21.915),(30.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,22.275),(30.515,22.445),(30.685,22.445),(30.685,22.275),(30.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,22.635),(30.515,22.805),(30.685,22.805),(30.685,22.635),(30.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,22.995),(30.515,23.165),(30.685,23.165),(30.685,22.995),(30.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,23.355),(30.515,23.525),(30.685,23.525),(30.685,23.355),(30.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,23.715),(30.515,23.885),(30.685,23.885),(30.685,23.715),(30.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,24.075),(30.515,24.245),(30.685,24.245),(30.685,24.075),(30.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,24.435),(30.515,24.605),(30.685,24.605),(30.685,24.435),(30.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,24.795),(30.515,24.965),(30.685,24.965),(30.685,24.795),(30.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,25.155),(30.515,25.325),(30.685,25.325),(30.685,25.155),(30.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,25.515),(30.515,25.685),(30.685,25.685),(30.685,25.515),(30.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,25.875),(30.515,26.045),(30.685,26.045),(30.685,25.875),(30.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,26.235),(30.515,26.405),(30.685,26.405),(30.685,26.235),(30.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,26.595),(30.515,26.765),(30.685,26.765),(30.685,26.595),(30.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,26.955),(30.515,27.125),(30.685,27.125),(30.685,26.955),(30.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,27.315),(30.515,27.485),(30.685,27.485),(30.685,27.315),(30.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,27.675),(30.515,27.845),(30.685,27.845),(30.685,27.675),(30.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,28.035),(30.515,28.205),(30.685,28.205),(30.685,28.035),(30.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,28.395),(30.515,28.565),(30.685,28.565),(30.685,28.395),(30.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,28.755),(30.515,28.925),(30.685,28.925),(30.685,28.755),(30.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,29.115),(30.515,29.285),(30.685,29.285),(30.685,29.115),(30.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,29.475),(30.515,29.645),(30.685,29.645),(30.685,29.475),(30.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,29.835),(30.515,30.005),(30.685,30.005),(30.685,29.835),(30.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,30.195),(30.515,30.365),(30.685,30.365),(30.685,30.195),(30.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,30.555),(30.515,30.725),(30.685,30.725),(30.685,30.555),(30.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,30.915),(30.515,31.085),(30.685,31.085),(30.685,30.915),(30.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,31.275),(30.515,31.445),(30.685,31.445),(30.685,31.275),(30.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,31.635),(30.515,31.805),(30.685,31.805),(30.685,31.635),(30.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,31.995),(30.515,32.165),(30.685,32.165),(30.685,31.995),(30.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,32.355),(30.515,32.525),(30.685,32.525),(30.685,32.355),(30.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,32.715),(30.515,32.885),(30.685,32.885),(30.685,32.715),(30.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,33.075),(30.515,33.245),(30.685,33.245),(30.685,33.075),(30.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,33.435),(30.515,33.605),(30.685,33.605),(30.685,33.435),(30.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,33.795),(30.515,33.965),(30.685,33.965),(30.685,33.795),(30.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,34.155),(30.515,34.325),(30.685,34.325),(30.685,34.155),(30.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,34.515),(30.515,34.685),(30.685,34.685),(30.685,34.515),(30.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,34.875),(30.515,35.045),(30.685,35.045),(30.685,34.875),(30.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,35.235),(30.515,35.405),(30.685,35.405),(30.685,35.235),(30.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,35.595),(30.515,35.765),(30.685,35.765),(30.685,35.595),(30.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,35.955),(30.515,36.125),(30.685,36.125),(30.685,35.955),(30.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,36.315),(30.515,36.485),(30.685,36.485),(30.685,36.315),(30.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,36.675),(30.515,36.845),(30.685,36.845),(30.685,36.675),(30.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,37.035),(30.515,37.205),(30.685,37.205),(30.685,37.035),(30.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,37.395),(30.515,37.565),(30.685,37.565),(30.685,37.395),(30.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,37.755),(30.515,37.925),(30.685,37.925),(30.685,37.755),(30.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,38.115),(30.515,38.285),(30.685,38.285),(30.685,38.115),(30.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,38.475),(30.515,38.645),(30.685,38.645),(30.685,38.475),(30.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,38.835),(30.515,39.005),(30.685,39.005),(30.685,38.835),(30.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,39.195),(30.515,39.365),(30.685,39.365),(30.685,39.195),(30.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,39.555),(30.515,39.725),(30.685,39.725),(30.685,39.555),(30.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,39.915),(30.515,40.085),(30.685,40.085),(30.685,39.915),(30.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,40.275),(30.515,40.445),(30.685,40.445),(30.685,40.275),(30.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,40.635),(30.515,40.805),(30.685,40.805),(30.685,40.635),(30.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.835),(44.915,3.005),(45.085,3.005),(45.085,2.835),(44.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.195),(44.915,3.365),(45.085,3.365),(45.085,3.195),(44.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.555),(44.915,3.725),(45.085,3.725),(45.085,3.555),(44.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.915),(44.915,4.085),(45.085,4.085),(45.085,3.915),(44.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.275),(44.915,4.445),(45.085,4.445),(45.085,4.275),(44.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.635),(44.915,4.805),(45.085,4.805),(45.085,4.635),(44.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.995),(44.915,5.165),(45.085,5.165),(45.085,4.995),(44.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.355),(44.915,5.525),(45.085,5.525),(45.085,5.355),(44.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.715),(44.915,5.885),(45.085,5.885),(45.085,5.715),(44.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.075),(44.915,6.245),(45.085,6.245),(45.085,6.075),(44.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.435),(44.915,6.605),(45.085,6.605),(45.085,6.435),(44.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.795),(44.915,6.965),(45.085,6.965),(45.085,6.795),(44.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.155),(44.915,7.325),(45.085,7.325),(45.085,7.155),(44.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.515),(44.915,7.685),(45.085,7.685),(45.085,7.515),(44.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.875),(44.915,8.045),(45.085,8.045),(45.085,7.875),(44.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.235),(44.915,8.405),(45.085,8.405),(45.085,8.235),(44.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.595),(44.915,8.765),(45.085,8.765),(45.085,8.595),(44.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.955),(44.915,9.125),(45.085,9.125),(45.085,8.955),(44.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.315),(44.915,9.485),(45.085,9.485),(45.085,9.315),(44.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.675),(44.915,9.845),(45.085,9.845),(45.085,9.675),(44.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.035),(44.915,10.205),(45.085,10.205),(45.085,10.035),(44.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.395),(44.915,10.565),(45.085,10.565),(45.085,10.395),(44.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.755),(44.915,10.925),(45.085,10.925),(45.085,10.755),(44.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.115),(44.915,11.285),(45.085,11.285),(45.085,11.115),(44.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.475),(44.915,11.645),(45.085,11.645),(45.085,11.475),(44.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.835),(44.915,12.005),(45.085,12.005),(45.085,11.835),(44.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.195),(44.915,12.365),(45.085,12.365),(45.085,12.195),(44.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.555),(44.915,12.725),(45.085,12.725),(45.085,12.555),(44.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.915),(44.915,13.085),(45.085,13.085),(45.085,12.915),(44.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.275),(44.915,13.445),(45.085,13.445),(45.085,13.275),(44.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.635),(44.915,13.805),(45.085,13.805),(45.085,13.635),(44.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.995),(44.915,14.165),(45.085,14.165),(45.085,13.995),(44.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.355),(44.915,14.525),(45.085,14.525),(45.085,14.355),(44.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.715),(44.915,14.885),(45.085,14.885),(45.085,14.715),(44.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.075),(44.915,15.245),(45.085,15.245),(45.085,15.075),(44.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.435),(44.915,15.605),(45.085,15.605),(45.085,15.435),(44.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.795),(44.915,15.965),(45.085,15.965),(45.085,15.795),(44.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.155),(44.915,16.325),(45.085,16.325),(45.085,16.155),(44.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.515),(44.915,16.685),(45.085,16.685),(45.085,16.515),(44.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.875),(44.915,17.045),(45.085,17.045),(45.085,16.875),(44.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.235),(44.915,17.405),(45.085,17.405),(45.085,17.235),(44.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.595),(44.915,17.765),(45.085,17.765),(45.085,17.595),(44.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.955),(44.915,18.125),(45.085,18.125),(45.085,17.955),(44.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.315),(44.915,18.485),(45.085,18.485),(45.085,18.315),(44.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.675),(44.915,18.845),(45.085,18.845),(45.085,18.675),(44.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.035),(44.915,19.205),(45.085,19.205),(45.085,19.035),(44.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.395),(44.915,19.565),(45.085,19.565),(45.085,19.395),(44.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.755),(44.915,19.925),(45.085,19.925),(45.085,19.755),(44.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.115),(44.915,20.285),(45.085,20.285),(45.085,20.115),(44.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.475),(44.915,20.645),(45.085,20.645),(45.085,20.475),(44.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.835),(44.915,21.005),(45.085,21.005),(45.085,20.835),(44.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.195),(44.915,21.365),(45.085,21.365),(45.085,21.195),(44.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.555),(44.915,21.725),(45.085,21.725),(45.085,21.555),(44.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.915),(44.915,22.085),(45.085,22.085),(45.085,21.915),(44.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.275),(44.915,22.445),(45.085,22.445),(45.085,22.275),(44.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.635),(44.915,22.805),(45.085,22.805),(45.085,22.635),(44.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.995),(44.915,23.165),(45.085,23.165),(45.085,22.995),(44.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,23.355),(44.915,23.525),(45.085,23.525),(45.085,23.355),(44.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,23.715),(44.915,23.885),(45.085,23.885),(45.085,23.715),(44.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.075),(44.915,24.245),(45.085,24.245),(45.085,24.075),(44.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.435),(44.915,24.605),(45.085,24.605),(45.085,24.435),(44.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.795),(44.915,24.965),(45.085,24.965),(45.085,24.795),(44.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.155),(44.915,25.325),(45.085,25.325),(45.085,25.155),(44.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.515),(44.915,25.685),(45.085,25.685),(45.085,25.515),(44.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.875),(44.915,26.045),(45.085,26.045),(45.085,25.875),(44.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.235),(44.915,26.405),(45.085,26.405),(45.085,26.235),(44.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.595),(44.915,26.765),(45.085,26.765),(45.085,26.595),(44.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.955),(44.915,27.125),(45.085,27.125),(45.085,26.955),(44.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,27.315),(44.915,27.485),(45.085,27.485),(45.085,27.315),(44.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,27.675),(44.915,27.845),(45.085,27.845),(45.085,27.675),(44.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.035),(44.915,28.205),(45.085,28.205),(45.085,28.035),(44.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.395),(44.915,28.565),(45.085,28.565),(45.085,28.395),(44.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.755),(44.915,28.925),(45.085,28.925),(45.085,28.755),(44.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.115),(44.915,29.285),(45.085,29.285),(45.085,29.115),(44.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.475),(44.915,29.645),(45.085,29.645),(45.085,29.475),(44.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.835),(44.915,30.005),(45.085,30.005),(45.085,29.835),(44.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.195),(44.915,30.365),(45.085,30.365),(45.085,30.195),(44.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.555),(44.915,30.725),(45.085,30.725),(45.085,30.555),(44.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.915),(44.915,31.085),(45.085,31.085),(45.085,30.915),(44.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.275),(44.915,31.445),(45.085,31.445),(45.085,31.275),(44.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.635),(44.915,31.805),(45.085,31.805),(45.085,31.635),(44.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.995),(44.915,32.165),(45.085,32.165),(45.085,31.995),(44.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.355),(44.915,32.525),(45.085,32.525),(45.085,32.355),(44.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.715),(44.915,32.885),(45.085,32.885),(45.085,32.715),(44.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.075),(44.915,33.245),(45.085,33.245),(45.085,33.075),(44.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.435),(44.915,33.605),(45.085,33.605),(45.085,33.435),(44.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.795),(44.915,33.965),(45.085,33.965),(45.085,33.795),(44.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.155),(44.915,34.325),(45.085,34.325),(45.085,34.155),(44.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.515),(44.915,34.685),(45.085,34.685),(45.085,34.515),(44.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.875),(44.915,35.045),(45.085,35.045),(45.085,34.875),(44.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.235),(44.915,35.405),(45.085,35.405),(45.085,35.235),(44.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.595),(44.915,35.765),(45.085,35.765),(45.085,35.595),(44.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.955),(44.915,36.125),(45.085,36.125),(45.085,35.955),(44.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.315),(44.915,36.485),(45.085,36.485),(45.085,36.315),(44.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.675),(44.915,36.845),(45.085,36.845),(45.085,36.675),(44.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.035),(44.915,37.205),(45.085,37.205),(45.085,37.035),(44.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.395),(44.915,37.565),(45.085,37.565),(45.085,37.395),(44.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.755),(44.915,37.925),(45.085,37.925),(45.085,37.755),(44.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.115),(44.915,38.285),(45.085,38.285),(45.085,38.115),(44.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.475),(44.915,38.645),(45.085,38.645),(45.085,38.475),(44.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.835),(44.915,39.005),(45.085,39.005),(45.085,38.835),(44.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.195),(44.915,39.365),(45.085,39.365),(45.085,39.195),(44.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.555),(44.915,39.725),(45.085,39.725),(45.085,39.555),(44.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.915),(44.915,40.085),(45.085,40.085),(45.085,39.915),(44.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,40.275),(44.915,40.445),(45.085,40.445),(45.085,40.275),(44.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,40.635),(44.915,40.805),(45.085,40.805),(45.085,40.635),(44.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,41.735),(68.915,41.905),(69.085,41.905),(69.085,41.735),(68.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,41.735),(11.315,41.905),(11.485,41.905),(11.485,41.735),(11.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,2.835),(73.715,3.005),(73.885,3.005),(73.885,2.835),(73.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.195),(73.715,3.365),(73.885,3.365),(73.885,3.195),(73.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.555),(73.715,3.725),(73.885,3.725),(73.885,3.555),(73.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.915),(73.715,4.085),(73.885,4.085),(73.885,3.915),(73.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.275),(73.715,4.445),(73.885,4.445),(73.885,4.275),(73.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.635),(73.715,4.805),(73.885,4.805),(73.885,4.635),(73.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.995),(73.715,5.165),(73.885,5.165),(73.885,4.995),(73.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.355),(73.715,5.525),(73.885,5.525),(73.885,5.355),(73.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.715),(73.715,5.885),(73.885,5.885),(73.885,5.715),(73.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.075),(73.715,6.245),(73.885,6.245),(73.885,6.075),(73.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.435),(73.715,6.605),(73.885,6.605),(73.885,6.435),(73.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.795),(73.715,6.965),(73.885,6.965),(73.885,6.795),(73.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.155),(73.715,7.325),(73.885,7.325),(73.885,7.155),(73.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.515),(73.715,7.685),(73.885,7.685),(73.885,7.515),(73.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.875),(73.715,8.045),(73.885,8.045),(73.885,7.875),(73.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.235),(73.715,8.405),(73.885,8.405),(73.885,8.235),(73.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.595),(73.715,8.765),(73.885,8.765),(73.885,8.595),(73.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.955),(73.715,9.125),(73.885,9.125),(73.885,8.955),(73.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.315),(73.715,9.485),(73.885,9.485),(73.885,9.315),(73.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.675),(73.715,9.845),(73.885,9.845),(73.885,9.675),(73.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.035),(73.715,10.205),(73.885,10.205),(73.885,10.035),(73.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.395),(73.715,10.565),(73.885,10.565),(73.885,10.395),(73.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.755),(73.715,10.925),(73.885,10.925),(73.885,10.755),(73.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.115),(73.715,11.285),(73.885,11.285),(73.885,11.115),(73.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.475),(73.715,11.645),(73.885,11.645),(73.885,11.475),(73.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.835),(73.715,12.005),(73.885,12.005),(73.885,11.835),(73.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.195),(73.715,12.365),(73.885,12.365),(73.885,12.195),(73.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.555),(73.715,12.725),(73.885,12.725),(73.885,12.555),(73.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.915),(73.715,13.085),(73.885,13.085),(73.885,12.915),(73.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.275),(73.715,13.445),(73.885,13.445),(73.885,13.275),(73.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.635),(73.715,13.805),(73.885,13.805),(73.885,13.635),(73.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.995),(73.715,14.165),(73.885,14.165),(73.885,13.995),(73.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.355),(73.715,14.525),(73.885,14.525),(73.885,14.355),(73.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.715),(73.715,14.885),(73.885,14.885),(73.885,14.715),(73.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.075),(73.715,15.245),(73.885,15.245),(73.885,15.075),(73.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.435),(73.715,15.605),(73.885,15.605),(73.885,15.435),(73.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.795),(73.715,15.965),(73.885,15.965),(73.885,15.795),(73.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.155),(73.715,16.325),(73.885,16.325),(73.885,16.155),(73.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.515),(73.715,16.685),(73.885,16.685),(73.885,16.515),(73.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.875),(73.715,17.045),(73.885,17.045),(73.885,16.875),(73.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.235),(73.715,17.405),(73.885,17.405),(73.885,17.235),(73.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.595),(73.715,17.765),(73.885,17.765),(73.885,17.595),(73.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.955),(73.715,18.125),(73.885,18.125),(73.885,17.955),(73.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.315),(73.715,18.485),(73.885,18.485),(73.885,18.315),(73.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.675),(73.715,18.845),(73.885,18.845),(73.885,18.675),(73.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.035),(73.715,19.205),(73.885,19.205),(73.885,19.035),(73.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.395),(73.715,19.565),(73.885,19.565),(73.885,19.395),(73.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.755),(73.715,19.925),(73.885,19.925),(73.885,19.755),(73.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.115),(73.715,20.285),(73.885,20.285),(73.885,20.115),(73.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.475),(73.715,20.645),(73.885,20.645),(73.885,20.475),(73.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.835),(73.715,21.005),(73.885,21.005),(73.885,20.835),(73.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,21.195),(73.715,21.365),(73.885,21.365),(73.885,21.195),(73.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,21.555),(73.715,21.725),(73.885,21.725),(73.885,21.555),(73.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,21.915),(73.715,22.085),(73.885,22.085),(73.885,21.915),(73.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,22.275),(73.715,22.445),(73.885,22.445),(73.885,22.275),(73.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,22.635),(73.715,22.805),(73.885,22.805),(73.885,22.635),(73.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,22.995),(73.715,23.165),(73.885,23.165),(73.885,22.995),(73.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,23.355),(73.715,23.525),(73.885,23.525),(73.885,23.355),(73.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,23.715),(73.715,23.885),(73.885,23.885),(73.885,23.715),(73.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,24.075),(73.715,24.245),(73.885,24.245),(73.885,24.075),(73.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,24.435),(73.715,24.605),(73.885,24.605),(73.885,24.435),(73.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,24.795),(73.715,24.965),(73.885,24.965),(73.885,24.795),(73.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,25.155),(73.715,25.325),(73.885,25.325),(73.885,25.155),(73.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,25.515),(73.715,25.685),(73.885,25.685),(73.885,25.515),(73.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,25.875),(73.715,26.045),(73.885,26.045),(73.885,25.875),(73.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,26.235),(73.715,26.405),(73.885,26.405),(73.885,26.235),(73.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,26.595),(73.715,26.765),(73.885,26.765),(73.885,26.595),(73.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,26.955),(73.715,27.125),(73.885,27.125),(73.885,26.955),(73.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,27.315),(73.715,27.485),(73.885,27.485),(73.885,27.315),(73.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,27.675),(73.715,27.845),(73.885,27.845),(73.885,27.675),(73.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,28.035),(73.715,28.205),(73.885,28.205),(73.885,28.035),(73.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,28.395),(73.715,28.565),(73.885,28.565),(73.885,28.395),(73.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,28.755),(73.715,28.925),(73.885,28.925),(73.885,28.755),(73.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,29.115),(73.715,29.285),(73.885,29.285),(73.885,29.115),(73.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,29.475),(73.715,29.645),(73.885,29.645),(73.885,29.475),(73.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,29.835),(73.715,30.005),(73.885,30.005),(73.885,29.835),(73.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,30.195),(73.715,30.365),(73.885,30.365),(73.885,30.195),(73.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,30.555),(73.715,30.725),(73.885,30.725),(73.885,30.555),(73.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,30.915),(73.715,31.085),(73.885,31.085),(73.885,30.915),(73.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,31.275),(73.715,31.445),(73.885,31.445),(73.885,31.275),(73.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,31.635),(73.715,31.805),(73.885,31.805),(73.885,31.635),(73.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,31.995),(73.715,32.165),(73.885,32.165),(73.885,31.995),(73.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,32.355),(73.715,32.525),(73.885,32.525),(73.885,32.355),(73.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,32.715),(73.715,32.885),(73.885,32.885),(73.885,32.715),(73.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,33.075),(73.715,33.245),(73.885,33.245),(73.885,33.075),(73.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,33.435),(73.715,33.605),(73.885,33.605),(73.885,33.435),(73.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,33.795),(73.715,33.965),(73.885,33.965),(73.885,33.795),(73.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,34.155),(73.715,34.325),(73.885,34.325),(73.885,34.155),(73.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,34.515),(73.715,34.685),(73.885,34.685),(73.885,34.515),(73.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,34.875),(73.715,35.045),(73.885,35.045),(73.885,34.875),(73.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,35.235),(73.715,35.405),(73.885,35.405),(73.885,35.235),(73.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,35.595),(73.715,35.765),(73.885,35.765),(73.885,35.595),(73.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,35.955),(73.715,36.125),(73.885,36.125),(73.885,35.955),(73.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,36.315),(73.715,36.485),(73.885,36.485),(73.885,36.315),(73.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,36.675),(73.715,36.845),(73.885,36.845),(73.885,36.675),(73.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,37.035),(73.715,37.205),(73.885,37.205),(73.885,37.035),(73.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,37.395),(73.715,37.565),(73.885,37.565),(73.885,37.395),(73.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,37.755),(73.715,37.925),(73.885,37.925),(73.885,37.755),(73.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,38.115),(73.715,38.285),(73.885,38.285),(73.885,38.115),(73.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,38.475),(73.715,38.645),(73.885,38.645),(73.885,38.475),(73.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,38.835),(73.715,39.005),(73.885,39.005),(73.885,38.835),(73.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,39.195),(73.715,39.365),(73.885,39.365),(73.885,39.195),(73.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,39.555),(73.715,39.725),(73.885,39.725),(73.885,39.555),(73.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,39.915),(73.715,40.085),(73.885,40.085),(73.885,39.915),(73.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,40.275),(73.715,40.445),(73.885,40.445),(73.885,40.275),(73.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,40.635),(73.715,40.805),(73.885,40.805),(73.885,40.635),(73.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,41.735),(16.115,41.905),(16.285,41.905),(16.285,41.735),(16.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,41.735),(83.06,41.905),(83.23,41.905),(83.23,41.735),(83.06,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,1.735),(85.58,1.905),(85.75,1.905),(85.75,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,1.735),(85.94,1.905),(86.11,1.905),(86.11,1.735),(85.94,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,41.735),(49.715,41.905),(49.885,41.905),(49.885,41.735),(49.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,2.835),(68.915,3.005),(69.085,3.005),(69.085,2.835),(68.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.195),(68.915,3.365),(69.085,3.365),(69.085,3.195),(68.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.555),(68.915,3.725),(69.085,3.725),(69.085,3.555),(68.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.915),(68.915,4.085),(69.085,4.085),(69.085,3.915),(68.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.275),(68.915,4.445),(69.085,4.445),(69.085,4.275),(68.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.635),(68.915,4.805),(69.085,4.805),(69.085,4.635),(68.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.995),(68.915,5.165),(69.085,5.165),(69.085,4.995),(68.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.355),(68.915,5.525),(69.085,5.525),(69.085,5.355),(68.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.715),(68.915,5.885),(69.085,5.885),(69.085,5.715),(68.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.075),(68.915,6.245),(69.085,6.245),(69.085,6.075),(68.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.435),(68.915,6.605),(69.085,6.605),(69.085,6.435),(68.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.795),(68.915,6.965),(69.085,6.965),(69.085,6.795),(68.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.155),(68.915,7.325),(69.085,7.325),(69.085,7.155),(68.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.515),(68.915,7.685),(69.085,7.685),(69.085,7.515),(68.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.875),(68.915,8.045),(69.085,8.045),(69.085,7.875),(68.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.235),(68.915,8.405),(69.085,8.405),(69.085,8.235),(68.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.595),(68.915,8.765),(69.085,8.765),(69.085,8.595),(68.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.955),(68.915,9.125),(69.085,9.125),(69.085,8.955),(68.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.315),(68.915,9.485),(69.085,9.485),(69.085,9.315),(68.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.675),(68.915,9.845),(69.085,9.845),(69.085,9.675),(68.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.035),(68.915,10.205),(69.085,10.205),(69.085,10.035),(68.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.395),(68.915,10.565),(69.085,10.565),(69.085,10.395),(68.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.755),(68.915,10.925),(69.085,10.925),(69.085,10.755),(68.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.115),(68.915,11.285),(69.085,11.285),(69.085,11.115),(68.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.475),(68.915,11.645),(69.085,11.645),(69.085,11.475),(68.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.835),(68.915,12.005),(69.085,12.005),(69.085,11.835),(68.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.195),(68.915,12.365),(69.085,12.365),(69.085,12.195),(68.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.555),(68.915,12.725),(69.085,12.725),(69.085,12.555),(68.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.915),(68.915,13.085),(69.085,13.085),(69.085,12.915),(68.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.275),(68.915,13.445),(69.085,13.445),(69.085,13.275),(68.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.635),(68.915,13.805),(69.085,13.805),(69.085,13.635),(68.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.995),(68.915,14.165),(69.085,14.165),(69.085,13.995),(68.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.355),(68.915,14.525),(69.085,14.525),(69.085,14.355),(68.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.715),(68.915,14.885),(69.085,14.885),(69.085,14.715),(68.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.075),(68.915,15.245),(69.085,15.245),(69.085,15.075),(68.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.435),(68.915,15.605),(69.085,15.605),(69.085,15.435),(68.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.795),(68.915,15.965),(69.085,15.965),(69.085,15.795),(68.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.155),(68.915,16.325),(69.085,16.325),(69.085,16.155),(68.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.515),(68.915,16.685),(69.085,16.685),(69.085,16.515),(68.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.875),(68.915,17.045),(69.085,17.045),(69.085,16.875),(68.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.235),(68.915,17.405),(69.085,17.405),(69.085,17.235),(68.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.595),(68.915,17.765),(69.085,17.765),(69.085,17.595),(68.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.955),(68.915,18.125),(69.085,18.125),(69.085,17.955),(68.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.315),(68.915,18.485),(69.085,18.485),(69.085,18.315),(68.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.675),(68.915,18.845),(69.085,18.845),(69.085,18.675),(68.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.035),(68.915,19.205),(69.085,19.205),(69.085,19.035),(68.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.395),(68.915,19.565),(69.085,19.565),(69.085,19.395),(68.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.755),(68.915,19.925),(69.085,19.925),(69.085,19.755),(68.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.115),(68.915,20.285),(69.085,20.285),(69.085,20.115),(68.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.475),(68.915,20.645),(69.085,20.645),(69.085,20.475),(68.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.835),(68.915,21.005),(69.085,21.005),(69.085,20.835),(68.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,21.195),(68.915,21.365),(69.085,21.365),(69.085,21.195),(68.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,21.555),(68.915,21.725),(69.085,21.725),(69.085,21.555),(68.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,21.915),(68.915,22.085),(69.085,22.085),(69.085,21.915),(68.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,22.275),(68.915,22.445),(69.085,22.445),(69.085,22.275),(68.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,22.635),(68.915,22.805),(69.085,22.805),(69.085,22.635),(68.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,22.995),(68.915,23.165),(69.085,23.165),(69.085,22.995),(68.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,23.355),(68.915,23.525),(69.085,23.525),(69.085,23.355),(68.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,23.715),(68.915,23.885),(69.085,23.885),(69.085,23.715),(68.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,24.075),(68.915,24.245),(69.085,24.245),(69.085,24.075),(68.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,24.435),(68.915,24.605),(69.085,24.605),(69.085,24.435),(68.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,24.795),(68.915,24.965),(69.085,24.965),(69.085,24.795),(68.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,25.155),(68.915,25.325),(69.085,25.325),(69.085,25.155),(68.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,25.515),(68.915,25.685),(69.085,25.685),(69.085,25.515),(68.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,25.875),(68.915,26.045),(69.085,26.045),(69.085,25.875),(68.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,26.235),(68.915,26.405),(69.085,26.405),(69.085,26.235),(68.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,26.595),(68.915,26.765),(69.085,26.765),(69.085,26.595),(68.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,26.955),(68.915,27.125),(69.085,27.125),(69.085,26.955),(68.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,27.315),(68.915,27.485),(69.085,27.485),(69.085,27.315),(68.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,27.675),(68.915,27.845),(69.085,27.845),(69.085,27.675),(68.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,28.035),(68.915,28.205),(69.085,28.205),(69.085,28.035),(68.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,28.395),(68.915,28.565),(69.085,28.565),(69.085,28.395),(68.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,28.755),(68.915,28.925),(69.085,28.925),(69.085,28.755),(68.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,29.115),(68.915,29.285),(69.085,29.285),(69.085,29.115),(68.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,29.475),(68.915,29.645),(69.085,29.645),(69.085,29.475),(68.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,29.835),(68.915,30.005),(69.085,30.005),(69.085,29.835),(68.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,30.195),(68.915,30.365),(69.085,30.365),(69.085,30.195),(68.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,30.555),(68.915,30.725),(69.085,30.725),(69.085,30.555),(68.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,30.915),(68.915,31.085),(69.085,31.085),(69.085,30.915),(68.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,31.275),(68.915,31.445),(69.085,31.445),(69.085,31.275),(68.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,31.635),(68.915,31.805),(69.085,31.805),(69.085,31.635),(68.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,31.995),(68.915,32.165),(69.085,32.165),(69.085,31.995),(68.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,32.355),(68.915,32.525),(69.085,32.525),(69.085,32.355),(68.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,32.715),(68.915,32.885),(69.085,32.885),(69.085,32.715),(68.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,33.075),(68.915,33.245),(69.085,33.245),(69.085,33.075),(68.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,33.435),(68.915,33.605),(69.085,33.605),(69.085,33.435),(68.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,33.795),(68.915,33.965),(69.085,33.965),(69.085,33.795),(68.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,34.155),(68.915,34.325),(69.085,34.325),(69.085,34.155),(68.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,34.515),(68.915,34.685),(69.085,34.685),(69.085,34.515),(68.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,34.875),(68.915,35.045),(69.085,35.045),(69.085,34.875),(68.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,35.235),(68.915,35.405),(69.085,35.405),(69.085,35.235),(68.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,35.595),(68.915,35.765),(69.085,35.765),(69.085,35.595),(68.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,35.955),(68.915,36.125),(69.085,36.125),(69.085,35.955),(68.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,36.315),(68.915,36.485),(69.085,36.485),(69.085,36.315),(68.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,36.675),(68.915,36.845),(69.085,36.845),(69.085,36.675),(68.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,37.035),(68.915,37.205),(69.085,37.205),(69.085,37.035),(68.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,37.395),(68.915,37.565),(69.085,37.565),(69.085,37.395),(68.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,37.755),(68.915,37.925),(69.085,37.925),(69.085,37.755),(68.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,38.115),(68.915,38.285),(69.085,38.285),(69.085,38.115),(68.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,38.475),(68.915,38.645),(69.085,38.645),(69.085,38.475),(68.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,38.835),(68.915,39.005),(69.085,39.005),(69.085,38.835),(68.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,39.195),(68.915,39.365),(69.085,39.365),(69.085,39.195),(68.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,39.555),(68.915,39.725),(69.085,39.725),(69.085,39.555),(68.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,39.915),(68.915,40.085),(69.085,40.085),(69.085,39.915),(68.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,40.275),(68.915,40.445),(69.085,40.445),(69.085,40.275),(68.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,40.635),(68.915,40.805),(69.085,40.805),(69.085,40.635),(68.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,2.835),(20.915,3.005),(21.085,3.005),(21.085,2.835),(20.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.195),(20.915,3.365),(21.085,3.365),(21.085,3.195),(20.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.555),(20.915,3.725),(21.085,3.725),(21.085,3.555),(20.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.915),(20.915,4.085),(21.085,4.085),(21.085,3.915),(20.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.275),(20.915,4.445),(21.085,4.445),(21.085,4.275),(20.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.635),(20.915,4.805),(21.085,4.805),(21.085,4.635),(20.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.995),(20.915,5.165),(21.085,5.165),(21.085,4.995),(20.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.355),(20.915,5.525),(21.085,5.525),(21.085,5.355),(20.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.715),(20.915,5.885),(21.085,5.885),(21.085,5.715),(20.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.075),(20.915,6.245),(21.085,6.245),(21.085,6.075),(20.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.435),(20.915,6.605),(21.085,6.605),(21.085,6.435),(20.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.795),(20.915,6.965),(21.085,6.965),(21.085,6.795),(20.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.155),(20.915,7.325),(21.085,7.325),(21.085,7.155),(20.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.515),(20.915,7.685),(21.085,7.685),(21.085,7.515),(20.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.875),(20.915,8.045),(21.085,8.045),(21.085,7.875),(20.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.235),(20.915,8.405),(21.085,8.405),(21.085,8.235),(20.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.595),(20.915,8.765),(21.085,8.765),(21.085,8.595),(20.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.955),(20.915,9.125),(21.085,9.125),(21.085,8.955),(20.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.315),(20.915,9.485),(21.085,9.485),(21.085,9.315),(20.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.675),(20.915,9.845),(21.085,9.845),(21.085,9.675),(20.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.035),(20.915,10.205),(21.085,10.205),(21.085,10.035),(20.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.395),(20.915,10.565),(21.085,10.565),(21.085,10.395),(20.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.755),(20.915,10.925),(21.085,10.925),(21.085,10.755),(20.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.115),(20.915,11.285),(21.085,11.285),(21.085,11.115),(20.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.475),(20.915,11.645),(21.085,11.645),(21.085,11.475),(20.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.835),(20.915,12.005),(21.085,12.005),(21.085,11.835),(20.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.195),(20.915,12.365),(21.085,12.365),(21.085,12.195),(20.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.555),(20.915,12.725),(21.085,12.725),(21.085,12.555),(20.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.915),(20.915,13.085),(21.085,13.085),(21.085,12.915),(20.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.275),(20.915,13.445),(21.085,13.445),(21.085,13.275),(20.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.635),(20.915,13.805),(21.085,13.805),(21.085,13.635),(20.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.995),(20.915,14.165),(21.085,14.165),(21.085,13.995),(20.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.355),(20.915,14.525),(21.085,14.525),(21.085,14.355),(20.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.715),(20.915,14.885),(21.085,14.885),(21.085,14.715),(20.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.075),(20.915,15.245),(21.085,15.245),(21.085,15.075),(20.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.435),(20.915,15.605),(21.085,15.605),(21.085,15.435),(20.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.795),(20.915,15.965),(21.085,15.965),(21.085,15.795),(20.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.155),(20.915,16.325),(21.085,16.325),(21.085,16.155),(20.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.515),(20.915,16.685),(21.085,16.685),(21.085,16.515),(20.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.875),(20.915,17.045),(21.085,17.045),(21.085,16.875),(20.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.235),(20.915,17.405),(21.085,17.405),(21.085,17.235),(20.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.595),(20.915,17.765),(21.085,17.765),(21.085,17.595),(20.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.955),(20.915,18.125),(21.085,18.125),(21.085,17.955),(20.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.315),(20.915,18.485),(21.085,18.485),(21.085,18.315),(20.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.675),(20.915,18.845),(21.085,18.845),(21.085,18.675),(20.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.035),(20.915,19.205),(21.085,19.205),(21.085,19.035),(20.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.395),(20.915,19.565),(21.085,19.565),(21.085,19.395),(20.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.755),(20.915,19.925),(21.085,19.925),(21.085,19.755),(20.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.115),(20.915,20.285),(21.085,20.285),(21.085,20.115),(20.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.475),(20.915,20.645),(21.085,20.645),(21.085,20.475),(20.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.835),(20.915,21.005),(21.085,21.005),(21.085,20.835),(20.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,21.195),(20.915,21.365),(21.085,21.365),(21.085,21.195),(20.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,21.555),(20.915,21.725),(21.085,21.725),(21.085,21.555),(20.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,21.915),(20.915,22.085),(21.085,22.085),(21.085,21.915),(20.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,22.275),(20.915,22.445),(21.085,22.445),(21.085,22.275),(20.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,22.635),(20.915,22.805),(21.085,22.805),(21.085,22.635),(20.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,22.995),(20.915,23.165),(21.085,23.165),(21.085,22.995),(20.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,23.355),(20.915,23.525),(21.085,23.525),(21.085,23.355),(20.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,23.715),(20.915,23.885),(21.085,23.885),(21.085,23.715),(20.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,24.075),(20.915,24.245),(21.085,24.245),(21.085,24.075),(20.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,24.435),(20.915,24.605),(21.085,24.605),(21.085,24.435),(20.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,24.795),(20.915,24.965),(21.085,24.965),(21.085,24.795),(20.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,25.155),(20.915,25.325),(21.085,25.325),(21.085,25.155),(20.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,25.515),(20.915,25.685),(21.085,25.685),(21.085,25.515),(20.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,25.875),(20.915,26.045),(21.085,26.045),(21.085,25.875),(20.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,26.235),(20.915,26.405),(21.085,26.405),(21.085,26.235),(20.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,26.595),(20.915,26.765),(21.085,26.765),(21.085,26.595),(20.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,26.955),(20.915,27.125),(21.085,27.125),(21.085,26.955),(20.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,27.315),(20.915,27.485),(21.085,27.485),(21.085,27.315),(20.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,27.675),(20.915,27.845),(21.085,27.845),(21.085,27.675),(20.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,28.035),(20.915,28.205),(21.085,28.205),(21.085,28.035),(20.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,28.395),(20.915,28.565),(21.085,28.565),(21.085,28.395),(20.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,28.755),(20.915,28.925),(21.085,28.925),(21.085,28.755),(20.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,29.115),(20.915,29.285),(21.085,29.285),(21.085,29.115),(20.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,29.475),(20.915,29.645),(21.085,29.645),(21.085,29.475),(20.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,29.835),(20.915,30.005),(21.085,30.005),(21.085,29.835),(20.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,30.195),(20.915,30.365),(21.085,30.365),(21.085,30.195),(20.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,30.555),(20.915,30.725),(21.085,30.725),(21.085,30.555),(20.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,30.915),(20.915,31.085),(21.085,31.085),(21.085,30.915),(20.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,31.275),(20.915,31.445),(21.085,31.445),(21.085,31.275),(20.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,31.635),(20.915,31.805),(21.085,31.805),(21.085,31.635),(20.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,31.995),(20.915,32.165),(21.085,32.165),(21.085,31.995),(20.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,32.355),(20.915,32.525),(21.085,32.525),(21.085,32.355),(20.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,32.715),(20.915,32.885),(21.085,32.885),(21.085,32.715),(20.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,33.075),(20.915,33.245),(21.085,33.245),(21.085,33.075),(20.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,33.435),(20.915,33.605),(21.085,33.605),(21.085,33.435),(20.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,33.795),(20.915,33.965),(21.085,33.965),(21.085,33.795),(20.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,34.155),(20.915,34.325),(21.085,34.325),(21.085,34.155),(20.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,34.515),(20.915,34.685),(21.085,34.685),(21.085,34.515),(20.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,34.875),(20.915,35.045),(21.085,35.045),(21.085,34.875),(20.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,35.235),(20.915,35.405),(21.085,35.405),(21.085,35.235),(20.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,35.595),(20.915,35.765),(21.085,35.765),(21.085,35.595),(20.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,35.955),(20.915,36.125),(21.085,36.125),(21.085,35.955),(20.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,36.315),(20.915,36.485),(21.085,36.485),(21.085,36.315),(20.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,36.675),(20.915,36.845),(21.085,36.845),(21.085,36.675),(20.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,37.035),(20.915,37.205),(21.085,37.205),(21.085,37.035),(20.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,37.395),(20.915,37.565),(21.085,37.565),(21.085,37.395),(20.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,37.755),(20.915,37.925),(21.085,37.925),(21.085,37.755),(20.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,38.115),(20.915,38.285),(21.085,38.285),(21.085,38.115),(20.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,38.475),(20.915,38.645),(21.085,38.645),(21.085,38.475),(20.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,38.835),(20.915,39.005),(21.085,39.005),(21.085,38.835),(20.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,39.195),(20.915,39.365),(21.085,39.365),(21.085,39.195),(20.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,39.555),(20.915,39.725),(21.085,39.725),(21.085,39.555),(20.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,39.915),(20.915,40.085),(21.085,40.085),(21.085,39.915),(20.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,40.275),(20.915,40.445),(21.085,40.445),(21.085,40.275),(20.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,40.635),(20.915,40.805),(21.085,40.805),(21.085,40.635),(20.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,21.44),(85.58,21.61),(85.75,21.61),(85.75,21.44),(85.58,21.44)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,21.44),(85.94,21.61),(86.11,21.61),(86.11,21.44),(85.94,21.44)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,41.735),(40.115,41.905),(40.285,41.905),(40.285,41.735),(40.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,41.735),(73.715,41.905),(73.885,41.905),(73.885,41.735),(73.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,41.735),(20.915,41.905),(21.085,41.905),(21.085,41.735),(20.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,41.735),(30.515,41.905),(30.685,41.905),(30.685,41.735),(30.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.835),(49.715,3.005),(49.885,3.005),(49.885,2.835),(49.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.195),(49.715,3.365),(49.885,3.365),(49.885,3.195),(49.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.555),(49.715,3.725),(49.885,3.725),(49.885,3.555),(49.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.915),(49.715,4.085),(49.885,4.085),(49.885,3.915),(49.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.275),(49.715,4.445),(49.885,4.445),(49.885,4.275),(49.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.635),(49.715,4.805),(49.885,4.805),(49.885,4.635),(49.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.995),(49.715,5.165),(49.885,5.165),(49.885,4.995),(49.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.355),(49.715,5.525),(49.885,5.525),(49.885,5.355),(49.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.715),(49.715,5.885),(49.885,5.885),(49.885,5.715),(49.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.075),(49.715,6.245),(49.885,6.245),(49.885,6.075),(49.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.435),(49.715,6.605),(49.885,6.605),(49.885,6.435),(49.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.795),(49.715,6.965),(49.885,6.965),(49.885,6.795),(49.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.155),(49.715,7.325),(49.885,7.325),(49.885,7.155),(49.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.515),(49.715,7.685),(49.885,7.685),(49.885,7.515),(49.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.875),(49.715,8.045),(49.885,8.045),(49.885,7.875),(49.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.235),(49.715,8.405),(49.885,8.405),(49.885,8.235),(49.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.595),(49.715,8.765),(49.885,8.765),(49.885,8.595),(49.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.955),(49.715,9.125),(49.885,9.125),(49.885,8.955),(49.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.315),(49.715,9.485),(49.885,9.485),(49.885,9.315),(49.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.675),(49.715,9.845),(49.885,9.845),(49.885,9.675),(49.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.035),(49.715,10.205),(49.885,10.205),(49.885,10.035),(49.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.395),(49.715,10.565),(49.885,10.565),(49.885,10.395),(49.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.755),(49.715,10.925),(49.885,10.925),(49.885,10.755),(49.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.115),(49.715,11.285),(49.885,11.285),(49.885,11.115),(49.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.475),(49.715,11.645),(49.885,11.645),(49.885,11.475),(49.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.835),(49.715,12.005),(49.885,12.005),(49.885,11.835),(49.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.195),(49.715,12.365),(49.885,12.365),(49.885,12.195),(49.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.555),(49.715,12.725),(49.885,12.725),(49.885,12.555),(49.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.915),(49.715,13.085),(49.885,13.085),(49.885,12.915),(49.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.275),(49.715,13.445),(49.885,13.445),(49.885,13.275),(49.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.635),(49.715,13.805),(49.885,13.805),(49.885,13.635),(49.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.995),(49.715,14.165),(49.885,14.165),(49.885,13.995),(49.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.355),(49.715,14.525),(49.885,14.525),(49.885,14.355),(49.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.715),(49.715,14.885),(49.885,14.885),(49.885,14.715),(49.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.075),(49.715,15.245),(49.885,15.245),(49.885,15.075),(49.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.435),(49.715,15.605),(49.885,15.605),(49.885,15.435),(49.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.795),(49.715,15.965),(49.885,15.965),(49.885,15.795),(49.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.155),(49.715,16.325),(49.885,16.325),(49.885,16.155),(49.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.515),(49.715,16.685),(49.885,16.685),(49.885,16.515),(49.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.875),(49.715,17.045),(49.885,17.045),(49.885,16.875),(49.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.235),(49.715,17.405),(49.885,17.405),(49.885,17.235),(49.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.595),(49.715,17.765),(49.885,17.765),(49.885,17.595),(49.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.955),(49.715,18.125),(49.885,18.125),(49.885,17.955),(49.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.315),(49.715,18.485),(49.885,18.485),(49.885,18.315),(49.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.675),(49.715,18.845),(49.885,18.845),(49.885,18.675),(49.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.035),(49.715,19.205),(49.885,19.205),(49.885,19.035),(49.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.395),(49.715,19.565),(49.885,19.565),(49.885,19.395),(49.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.755),(49.715,19.925),(49.885,19.925),(49.885,19.755),(49.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.115),(49.715,20.285),(49.885,20.285),(49.885,20.115),(49.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.475),(49.715,20.645),(49.885,20.645),(49.885,20.475),(49.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.835),(49.715,21.005),(49.885,21.005),(49.885,20.835),(49.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.195),(49.715,21.365),(49.885,21.365),(49.885,21.195),(49.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.555),(49.715,21.725),(49.885,21.725),(49.885,21.555),(49.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.915),(49.715,22.085),(49.885,22.085),(49.885,21.915),(49.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.275),(49.715,22.445),(49.885,22.445),(49.885,22.275),(49.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.635),(49.715,22.805),(49.885,22.805),(49.885,22.635),(49.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.995),(49.715,23.165),(49.885,23.165),(49.885,22.995),(49.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,23.355),(49.715,23.525),(49.885,23.525),(49.885,23.355),(49.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,23.715),(49.715,23.885),(49.885,23.885),(49.885,23.715),(49.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.075),(49.715,24.245),(49.885,24.245),(49.885,24.075),(49.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.435),(49.715,24.605),(49.885,24.605),(49.885,24.435),(49.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.795),(49.715,24.965),(49.885,24.965),(49.885,24.795),(49.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.155),(49.715,25.325),(49.885,25.325),(49.885,25.155),(49.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.515),(49.715,25.685),(49.885,25.685),(49.885,25.515),(49.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.875),(49.715,26.045),(49.885,26.045),(49.885,25.875),(49.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.235),(49.715,26.405),(49.885,26.405),(49.885,26.235),(49.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.595),(49.715,26.765),(49.885,26.765),(49.885,26.595),(49.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.955),(49.715,27.125),(49.885,27.125),(49.885,26.955),(49.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,27.315),(49.715,27.485),(49.885,27.485),(49.885,27.315),(49.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,27.675),(49.715,27.845),(49.885,27.845),(49.885,27.675),(49.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.035),(49.715,28.205),(49.885,28.205),(49.885,28.035),(49.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.395),(49.715,28.565),(49.885,28.565),(49.885,28.395),(49.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.755),(49.715,28.925),(49.885,28.925),(49.885,28.755),(49.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.115),(49.715,29.285),(49.885,29.285),(49.885,29.115),(49.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.475),(49.715,29.645),(49.885,29.645),(49.885,29.475),(49.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.835),(49.715,30.005),(49.885,30.005),(49.885,29.835),(49.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.195),(49.715,30.365),(49.885,30.365),(49.885,30.195),(49.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.555),(49.715,30.725),(49.885,30.725),(49.885,30.555),(49.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.915),(49.715,31.085),(49.885,31.085),(49.885,30.915),(49.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.275),(49.715,31.445),(49.885,31.445),(49.885,31.275),(49.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.635),(49.715,31.805),(49.885,31.805),(49.885,31.635),(49.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.995),(49.715,32.165),(49.885,32.165),(49.885,31.995),(49.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,32.355),(49.715,32.525),(49.885,32.525),(49.885,32.355),(49.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,32.715),(49.715,32.885),(49.885,32.885),(49.885,32.715),(49.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.075),(49.715,33.245),(49.885,33.245),(49.885,33.075),(49.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.435),(49.715,33.605),(49.885,33.605),(49.885,33.435),(49.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.795),(49.715,33.965),(49.885,33.965),(49.885,33.795),(49.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.155),(49.715,34.325),(49.885,34.325),(49.885,34.155),(49.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.515),(49.715,34.685),(49.885,34.685),(49.885,34.515),(49.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.875),(49.715,35.045),(49.885,35.045),(49.885,34.875),(49.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.235),(49.715,35.405),(49.885,35.405),(49.885,35.235),(49.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.595),(49.715,35.765),(49.885,35.765),(49.885,35.595),(49.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.955),(49.715,36.125),(49.885,36.125),(49.885,35.955),(49.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,36.315),(49.715,36.485),(49.885,36.485),(49.885,36.315),(49.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,36.675),(49.715,36.845),(49.885,36.845),(49.885,36.675),(49.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.035),(49.715,37.205),(49.885,37.205),(49.885,37.035),(49.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.395),(49.715,37.565),(49.885,37.565),(49.885,37.395),(49.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.755),(49.715,37.925),(49.885,37.925),(49.885,37.755),(49.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.115),(49.715,38.285),(49.885,38.285),(49.885,38.115),(49.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.475),(49.715,38.645),(49.885,38.645),(49.885,38.475),(49.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.835),(49.715,39.005),(49.885,39.005),(49.885,38.835),(49.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.195),(49.715,39.365),(49.885,39.365),(49.885,39.195),(49.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.555),(49.715,39.725),(49.885,39.725),(49.885,39.555),(49.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.915),(49.715,40.085),(49.885,40.085),(49.885,39.915),(49.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,40.275),(49.715,40.445),(49.885,40.445),(49.885,40.275),(49.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,40.635),(49.715,40.805),(49.885,40.805),(49.885,40.635),(49.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,2.835),(6.77,3.005),(6.94,3.005),(6.94,2.835),(6.77,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.195),(6.77,3.365),(6.94,3.365),(6.94,3.195),(6.77,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.555),(6.77,3.725),(6.94,3.725),(6.94,3.555),(6.77,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.915),(6.77,4.085),(6.94,4.085),(6.94,3.915),(6.77,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.275),(6.77,4.445),(6.94,4.445),(6.94,4.275),(6.77,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.635),(6.77,4.805),(6.94,4.805),(6.94,4.635),(6.77,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.995),(6.77,5.165),(6.94,5.165),(6.94,4.995),(6.77,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.355),(6.77,5.525),(6.94,5.525),(6.94,5.355),(6.77,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.715),(6.77,5.885),(6.94,5.885),(6.94,5.715),(6.77,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.075),(6.77,6.245),(6.94,6.245),(6.94,6.075),(6.77,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.435),(6.77,6.605),(6.94,6.605),(6.94,6.435),(6.77,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.795),(6.77,6.965),(6.94,6.965),(6.94,6.795),(6.77,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.155),(6.77,7.325),(6.94,7.325),(6.94,7.155),(6.77,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.515),(6.77,7.685),(6.94,7.685),(6.94,7.515),(6.77,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.875),(6.77,8.045),(6.94,8.045),(6.94,7.875),(6.77,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.235),(6.77,8.405),(6.94,8.405),(6.94,8.235),(6.77,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.595),(6.77,8.765),(6.94,8.765),(6.94,8.595),(6.77,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.955),(6.77,9.125),(6.94,9.125),(6.94,8.955),(6.77,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.315),(6.77,9.485),(6.94,9.485),(6.94,9.315),(6.77,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.675),(6.77,9.845),(6.94,9.845),(6.94,9.675),(6.77,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.035),(6.77,10.205),(6.94,10.205),(6.94,10.035),(6.77,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.395),(6.77,10.565),(6.94,10.565),(6.94,10.395),(6.77,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.755),(6.77,10.925),(6.94,10.925),(6.94,10.755),(6.77,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.115),(6.77,11.285),(6.94,11.285),(6.94,11.115),(6.77,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.475),(6.77,11.645),(6.94,11.645),(6.94,11.475),(6.77,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.835),(6.77,12.005),(6.94,12.005),(6.94,11.835),(6.77,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.195),(6.77,12.365),(6.94,12.365),(6.94,12.195),(6.77,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.555),(6.77,12.725),(6.94,12.725),(6.94,12.555),(6.77,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.915),(6.77,13.085),(6.94,13.085),(6.94,12.915),(6.77,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.275),(6.77,13.445),(6.94,13.445),(6.94,13.275),(6.77,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.635),(6.77,13.805),(6.94,13.805),(6.94,13.635),(6.77,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.995),(6.77,14.165),(6.94,14.165),(6.94,13.995),(6.77,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.355),(6.77,14.525),(6.94,14.525),(6.94,14.355),(6.77,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.715),(6.77,14.885),(6.94,14.885),(6.94,14.715),(6.77,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.075),(6.77,15.245),(6.94,15.245),(6.94,15.075),(6.77,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.435),(6.77,15.605),(6.94,15.605),(6.94,15.435),(6.77,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.795),(6.77,15.965),(6.94,15.965),(6.94,15.795),(6.77,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.155),(6.77,16.325),(6.94,16.325),(6.94,16.155),(6.77,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.515),(6.77,16.685),(6.94,16.685),(6.94,16.515),(6.77,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.875),(6.77,17.045),(6.94,17.045),(6.94,16.875),(6.77,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.235),(6.77,17.405),(6.94,17.405),(6.94,17.235),(6.77,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.595),(6.77,17.765),(6.94,17.765),(6.94,17.595),(6.77,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.955),(6.77,18.125),(6.94,18.125),(6.94,17.955),(6.77,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.315),(6.77,18.485),(6.94,18.485),(6.94,18.315),(6.77,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.675),(6.77,18.845),(6.94,18.845),(6.94,18.675),(6.77,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.035),(6.77,19.205),(6.94,19.205),(6.94,19.035),(6.77,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.395),(6.77,19.565),(6.94,19.565),(6.94,19.395),(6.77,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.755),(6.77,19.925),(6.94,19.925),(6.94,19.755),(6.77,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.115),(6.77,20.285),(6.94,20.285),(6.94,20.115),(6.77,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.475),(6.77,20.645),(6.94,20.645),(6.94,20.475),(6.77,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.835),(6.77,21.005),(6.94,21.005),(6.94,20.835),(6.77,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,21.195),(6.77,21.365),(6.94,21.365),(6.94,21.195),(6.77,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,21.555),(6.77,21.725),(6.94,21.725),(6.94,21.555),(6.77,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,21.915),(6.77,22.085),(6.94,22.085),(6.94,21.915),(6.77,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,22.275),(6.77,22.445),(6.94,22.445),(6.94,22.275),(6.77,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,22.635),(6.77,22.805),(6.94,22.805),(6.94,22.635),(6.77,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,22.995),(6.77,23.165),(6.94,23.165),(6.94,22.995),(6.77,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,23.355),(6.77,23.525),(6.94,23.525),(6.94,23.355),(6.77,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,23.715),(6.77,23.885),(6.94,23.885),(6.94,23.715),(6.77,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,24.075),(6.77,24.245),(6.94,24.245),(6.94,24.075),(6.77,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,24.435),(6.77,24.605),(6.94,24.605),(6.94,24.435),(6.77,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,24.795),(6.77,24.965),(6.94,24.965),(6.94,24.795),(6.77,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,25.155),(6.77,25.325),(6.94,25.325),(6.94,25.155),(6.77,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,25.515),(6.77,25.685),(6.94,25.685),(6.94,25.515),(6.77,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,25.875),(6.77,26.045),(6.94,26.045),(6.94,25.875),(6.77,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,26.235),(6.77,26.405),(6.94,26.405),(6.94,26.235),(6.77,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,26.595),(6.77,26.765),(6.94,26.765),(6.94,26.595),(6.77,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,26.955),(6.77,27.125),(6.94,27.125),(6.94,26.955),(6.77,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,27.315),(6.77,27.485),(6.94,27.485),(6.94,27.315),(6.77,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,27.675),(6.77,27.845),(6.94,27.845),(6.94,27.675),(6.77,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,28.035),(6.77,28.205),(6.94,28.205),(6.94,28.035),(6.77,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,28.395),(6.77,28.565),(6.94,28.565),(6.94,28.395),(6.77,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,28.755),(6.77,28.925),(6.94,28.925),(6.94,28.755),(6.77,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,29.115),(6.77,29.285),(6.94,29.285),(6.94,29.115),(6.77,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,29.475),(6.77,29.645),(6.94,29.645),(6.94,29.475),(6.77,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,29.835),(6.77,30.005),(6.94,30.005),(6.94,29.835),(6.77,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,30.195),(6.77,30.365),(6.94,30.365),(6.94,30.195),(6.77,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,30.555),(6.77,30.725),(6.94,30.725),(6.94,30.555),(6.77,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,30.915),(6.77,31.085),(6.94,31.085),(6.94,30.915),(6.77,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,31.275),(6.77,31.445),(6.94,31.445),(6.94,31.275),(6.77,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,31.635),(6.77,31.805),(6.94,31.805),(6.94,31.635),(6.77,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,31.995),(6.77,32.165),(6.94,32.165),(6.94,31.995),(6.77,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,32.355),(6.77,32.525),(6.94,32.525),(6.94,32.355),(6.77,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,32.715),(6.77,32.885),(6.94,32.885),(6.94,32.715),(6.77,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,33.075),(6.77,33.245),(6.94,33.245),(6.94,33.075),(6.77,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,33.435),(6.77,33.605),(6.94,33.605),(6.94,33.435),(6.77,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,33.795),(6.77,33.965),(6.94,33.965),(6.94,33.795),(6.77,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,34.155),(6.77,34.325),(6.94,34.325),(6.94,34.155),(6.77,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,34.515),(6.77,34.685),(6.94,34.685),(6.94,34.515),(6.77,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,34.875),(6.77,35.045),(6.94,35.045),(6.94,34.875),(6.77,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,35.235),(6.77,35.405),(6.94,35.405),(6.94,35.235),(6.77,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,35.595),(6.77,35.765),(6.94,35.765),(6.94,35.595),(6.77,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,35.955),(6.77,36.125),(6.94,36.125),(6.94,35.955),(6.77,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,36.315),(6.77,36.485),(6.94,36.485),(6.94,36.315),(6.77,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,36.675),(6.77,36.845),(6.94,36.845),(6.94,36.675),(6.77,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,37.035),(6.77,37.205),(6.94,37.205),(6.94,37.035),(6.77,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,37.395),(6.77,37.565),(6.94,37.565),(6.94,37.395),(6.77,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,37.755),(6.77,37.925),(6.94,37.925),(6.94,37.755),(6.77,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,38.115),(6.77,38.285),(6.94,38.285),(6.94,38.115),(6.77,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,38.475),(6.77,38.645),(6.94,38.645),(6.94,38.475),(6.77,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,38.835),(6.77,39.005),(6.94,39.005),(6.94,38.835),(6.77,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,39.195),(6.77,39.365),(6.94,39.365),(6.94,39.195),(6.77,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,39.555),(6.77,39.725),(6.94,39.725),(6.94,39.555),(6.77,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,39.915),(6.77,40.085),(6.94,40.085),(6.94,39.915),(6.77,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,40.275),(6.77,40.445),(6.94,40.445),(6.94,40.275),(6.77,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,40.635),(6.77,40.805),(6.94,40.805),(6.94,40.635),(6.77,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,41.735),(35.315,41.905),(35.485,41.905),(35.485,41.735),(35.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,2.835),(83.06,3.005),(83.23,3.005),(83.23,2.835),(83.06,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.195),(83.06,3.365),(83.23,3.365),(83.23,3.195),(83.06,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.555),(83.06,3.725),(83.23,3.725),(83.23,3.555),(83.06,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.915),(83.06,4.085),(83.23,4.085),(83.23,3.915),(83.06,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.275),(83.06,4.445),(83.23,4.445),(83.23,4.275),(83.06,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.635),(83.06,4.805),(83.23,4.805),(83.23,4.635),(83.06,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.995),(83.06,5.165),(83.23,5.165),(83.23,4.995),(83.06,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.355),(83.06,5.525),(83.23,5.525),(83.23,5.355),(83.06,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.715),(83.06,5.885),(83.23,5.885),(83.23,5.715),(83.06,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.075),(83.06,6.245),(83.23,6.245),(83.23,6.075),(83.06,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.435),(83.06,6.605),(83.23,6.605),(83.23,6.435),(83.06,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.795),(83.06,6.965),(83.23,6.965),(83.23,6.795),(83.06,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.155),(83.06,7.325),(83.23,7.325),(83.23,7.155),(83.06,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.515),(83.06,7.685),(83.23,7.685),(83.23,7.515),(83.06,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.875),(83.06,8.045),(83.23,8.045),(83.23,7.875),(83.06,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.235),(83.06,8.405),(83.23,8.405),(83.23,8.235),(83.06,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.595),(83.06,8.765),(83.23,8.765),(83.23,8.595),(83.06,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.955),(83.06,9.125),(83.23,9.125),(83.23,8.955),(83.06,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.315),(83.06,9.485),(83.23,9.485),(83.23,9.315),(83.06,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.675),(83.06,9.845),(83.23,9.845),(83.23,9.675),(83.06,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.035),(83.06,10.205),(83.23,10.205),(83.23,10.035),(83.06,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.395),(83.06,10.565),(83.23,10.565),(83.23,10.395),(83.06,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.755),(83.06,10.925),(83.23,10.925),(83.23,10.755),(83.06,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.115),(83.06,11.285),(83.23,11.285),(83.23,11.115),(83.06,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.475),(83.06,11.645),(83.23,11.645),(83.23,11.475),(83.06,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.835),(83.06,12.005),(83.23,12.005),(83.23,11.835),(83.06,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.195),(83.06,12.365),(83.23,12.365),(83.23,12.195),(83.06,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.555),(83.06,12.725),(83.23,12.725),(83.23,12.555),(83.06,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.915),(83.06,13.085),(83.23,13.085),(83.23,12.915),(83.06,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.275),(83.06,13.445),(83.23,13.445),(83.23,13.275),(83.06,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.635),(83.06,13.805),(83.23,13.805),(83.23,13.635),(83.06,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.995),(83.06,14.165),(83.23,14.165),(83.23,13.995),(83.06,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.355),(83.06,14.525),(83.23,14.525),(83.23,14.355),(83.06,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.715),(83.06,14.885),(83.23,14.885),(83.23,14.715),(83.06,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.075),(83.06,15.245),(83.23,15.245),(83.23,15.075),(83.06,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.435),(83.06,15.605),(83.23,15.605),(83.23,15.435),(83.06,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.795),(83.06,15.965),(83.23,15.965),(83.23,15.795),(83.06,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.155),(83.06,16.325),(83.23,16.325),(83.23,16.155),(83.06,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.515),(83.06,16.685),(83.23,16.685),(83.23,16.515),(83.06,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.875),(83.06,17.045),(83.23,17.045),(83.23,16.875),(83.06,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.235),(83.06,17.405),(83.23,17.405),(83.23,17.235),(83.06,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.595),(83.06,17.765),(83.23,17.765),(83.23,17.595),(83.06,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.955),(83.06,18.125),(83.23,18.125),(83.23,17.955),(83.06,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.315),(83.06,18.485),(83.23,18.485),(83.23,18.315),(83.06,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.675),(83.06,18.845),(83.23,18.845),(83.23,18.675),(83.06,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.035),(83.06,19.205),(83.23,19.205),(83.23,19.035),(83.06,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.395),(83.06,19.565),(83.23,19.565),(83.23,19.395),(83.06,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.755),(83.06,19.925),(83.23,19.925),(83.23,19.755),(83.06,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.115),(83.06,20.285),(83.23,20.285),(83.23,20.115),(83.06,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.475),(83.06,20.645),(83.23,20.645),(83.23,20.475),(83.06,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.835),(83.06,21.005),(83.23,21.005),(83.23,20.835),(83.06,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,21.195),(83.06,21.365),(83.23,21.365),(83.23,21.195),(83.06,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,21.555),(83.06,21.725),(83.23,21.725),(83.23,21.555),(83.06,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,21.915),(83.06,22.085),(83.23,22.085),(83.23,21.915),(83.06,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,22.275),(83.06,22.445),(83.23,22.445),(83.23,22.275),(83.06,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,22.635),(83.06,22.805),(83.23,22.805),(83.23,22.635),(83.06,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,22.995),(83.06,23.165),(83.23,23.165),(83.23,22.995),(83.06,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,23.355),(83.06,23.525),(83.23,23.525),(83.23,23.355),(83.06,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,23.715),(83.06,23.885),(83.23,23.885),(83.23,23.715),(83.06,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,24.075),(83.06,24.245),(83.23,24.245),(83.23,24.075),(83.06,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,24.435),(83.06,24.605),(83.23,24.605),(83.23,24.435),(83.06,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,24.795),(83.06,24.965),(83.23,24.965),(83.23,24.795),(83.06,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,25.155),(83.06,25.325),(83.23,25.325),(83.23,25.155),(83.06,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,25.515),(83.06,25.685),(83.23,25.685),(83.23,25.515),(83.06,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,25.875),(83.06,26.045),(83.23,26.045),(83.23,25.875),(83.06,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,26.235),(83.06,26.405),(83.23,26.405),(83.23,26.235),(83.06,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,26.595),(83.06,26.765),(83.23,26.765),(83.23,26.595),(83.06,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,26.955),(83.06,27.125),(83.23,27.125),(83.23,26.955),(83.06,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,27.315),(83.06,27.485),(83.23,27.485),(83.23,27.315),(83.06,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,27.675),(83.06,27.845),(83.23,27.845),(83.23,27.675),(83.06,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,28.035),(83.06,28.205),(83.23,28.205),(83.23,28.035),(83.06,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,28.395),(83.06,28.565),(83.23,28.565),(83.23,28.395),(83.06,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,28.755),(83.06,28.925),(83.23,28.925),(83.23,28.755),(83.06,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,29.115),(83.06,29.285),(83.23,29.285),(83.23,29.115),(83.06,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,29.475),(83.06,29.645),(83.23,29.645),(83.23,29.475),(83.06,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,29.835),(83.06,30.005),(83.23,30.005),(83.23,29.835),(83.06,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,30.195),(83.06,30.365),(83.23,30.365),(83.23,30.195),(83.06,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,30.555),(83.06,30.725),(83.23,30.725),(83.23,30.555),(83.06,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,30.915),(83.06,31.085),(83.23,31.085),(83.23,30.915),(83.06,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,31.275),(83.06,31.445),(83.23,31.445),(83.23,31.275),(83.06,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,31.635),(83.06,31.805),(83.23,31.805),(83.23,31.635),(83.06,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,31.995),(83.06,32.165),(83.23,32.165),(83.23,31.995),(83.06,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,32.355),(83.06,32.525),(83.23,32.525),(83.23,32.355),(83.06,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,32.715),(83.06,32.885),(83.23,32.885),(83.23,32.715),(83.06,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,33.075),(83.06,33.245),(83.23,33.245),(83.23,33.075),(83.06,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,33.435),(83.06,33.605),(83.23,33.605),(83.23,33.435),(83.06,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,33.795),(83.06,33.965),(83.23,33.965),(83.23,33.795),(83.06,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,34.155),(83.06,34.325),(83.23,34.325),(83.23,34.155),(83.06,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,34.515),(83.06,34.685),(83.23,34.685),(83.23,34.515),(83.06,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,34.875),(83.06,35.045),(83.23,35.045),(83.23,34.875),(83.06,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,35.235),(83.06,35.405),(83.23,35.405),(83.23,35.235),(83.06,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,35.595),(83.06,35.765),(83.23,35.765),(83.23,35.595),(83.06,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,35.955),(83.06,36.125),(83.23,36.125),(83.23,35.955),(83.06,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,36.315),(83.06,36.485),(83.23,36.485),(83.23,36.315),(83.06,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,36.675),(83.06,36.845),(83.23,36.845),(83.23,36.675),(83.06,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,37.035),(83.06,37.205),(83.23,37.205),(83.23,37.035),(83.06,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,37.395),(83.06,37.565),(83.23,37.565),(83.23,37.395),(83.06,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,37.755),(83.06,37.925),(83.23,37.925),(83.23,37.755),(83.06,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,38.115),(83.06,38.285),(83.23,38.285),(83.23,38.115),(83.06,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,38.475),(83.06,38.645),(83.23,38.645),(83.23,38.475),(83.06,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,38.835),(83.06,39.005),(83.23,39.005),(83.23,38.835),(83.06,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,39.195),(83.06,39.365),(83.23,39.365),(83.23,39.195),(83.06,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,39.555),(83.06,39.725),(83.23,39.725),(83.23,39.555),(83.06,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,39.915),(83.06,40.085),(83.23,40.085),(83.23,39.915),(83.06,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,40.275),(83.06,40.445),(83.23,40.445),(83.23,40.275),(83.06,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,40.635),(83.06,40.805),(83.23,40.805),(83.23,40.635),(83.06,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.835),(54.515,3.005),(54.685,3.005),(54.685,2.835),(54.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.195),(54.515,3.365),(54.685,3.365),(54.685,3.195),(54.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.555),(54.515,3.725),(54.685,3.725),(54.685,3.555),(54.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.915),(54.515,4.085),(54.685,4.085),(54.685,3.915),(54.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.275),(54.515,4.445),(54.685,4.445),(54.685,4.275),(54.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.635),(54.515,4.805),(54.685,4.805),(54.685,4.635),(54.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.995),(54.515,5.165),(54.685,5.165),(54.685,4.995),(54.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.355),(54.515,5.525),(54.685,5.525),(54.685,5.355),(54.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.715),(54.515,5.885),(54.685,5.885),(54.685,5.715),(54.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.075),(54.515,6.245),(54.685,6.245),(54.685,6.075),(54.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.435),(54.515,6.605),(54.685,6.605),(54.685,6.435),(54.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.795),(54.515,6.965),(54.685,6.965),(54.685,6.795),(54.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.155),(54.515,7.325),(54.685,7.325),(54.685,7.155),(54.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.515),(54.515,7.685),(54.685,7.685),(54.685,7.515),(54.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.875),(54.515,8.045),(54.685,8.045),(54.685,7.875),(54.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.235),(54.515,8.405),(54.685,8.405),(54.685,8.235),(54.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.595),(54.515,8.765),(54.685,8.765),(54.685,8.595),(54.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.955),(54.515,9.125),(54.685,9.125),(54.685,8.955),(54.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.315),(54.515,9.485),(54.685,9.485),(54.685,9.315),(54.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.675),(54.515,9.845),(54.685,9.845),(54.685,9.675),(54.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.035),(54.515,10.205),(54.685,10.205),(54.685,10.035),(54.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.395),(54.515,10.565),(54.685,10.565),(54.685,10.395),(54.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.755),(54.515,10.925),(54.685,10.925),(54.685,10.755),(54.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.115),(54.515,11.285),(54.685,11.285),(54.685,11.115),(54.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.475),(54.515,11.645),(54.685,11.645),(54.685,11.475),(54.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.835),(54.515,12.005),(54.685,12.005),(54.685,11.835),(54.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.195),(54.515,12.365),(54.685,12.365),(54.685,12.195),(54.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.555),(54.515,12.725),(54.685,12.725),(54.685,12.555),(54.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.915),(54.515,13.085),(54.685,13.085),(54.685,12.915),(54.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.275),(54.515,13.445),(54.685,13.445),(54.685,13.275),(54.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.635),(54.515,13.805),(54.685,13.805),(54.685,13.635),(54.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.995),(54.515,14.165),(54.685,14.165),(54.685,13.995),(54.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.355),(54.515,14.525),(54.685,14.525),(54.685,14.355),(54.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.715),(54.515,14.885),(54.685,14.885),(54.685,14.715),(54.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.075),(54.515,15.245),(54.685,15.245),(54.685,15.075),(54.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.435),(54.515,15.605),(54.685,15.605),(54.685,15.435),(54.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.795),(54.515,15.965),(54.685,15.965),(54.685,15.795),(54.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.155),(54.515,16.325),(54.685,16.325),(54.685,16.155),(54.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.515),(54.515,16.685),(54.685,16.685),(54.685,16.515),(54.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.875),(54.515,17.045),(54.685,17.045),(54.685,16.875),(54.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.235),(54.515,17.405),(54.685,17.405),(54.685,17.235),(54.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.595),(54.515,17.765),(54.685,17.765),(54.685,17.595),(54.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.955),(54.515,18.125),(54.685,18.125),(54.685,17.955),(54.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.315),(54.515,18.485),(54.685,18.485),(54.685,18.315),(54.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.675),(54.515,18.845),(54.685,18.845),(54.685,18.675),(54.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.035),(54.515,19.205),(54.685,19.205),(54.685,19.035),(54.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.395),(54.515,19.565),(54.685,19.565),(54.685,19.395),(54.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.755),(54.515,19.925),(54.685,19.925),(54.685,19.755),(54.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.115),(54.515,20.285),(54.685,20.285),(54.685,20.115),(54.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.475),(54.515,20.645),(54.685,20.645),(54.685,20.475),(54.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.835),(54.515,21.005),(54.685,21.005),(54.685,20.835),(54.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.195),(54.515,21.365),(54.685,21.365),(54.685,21.195),(54.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.555),(54.515,21.725),(54.685,21.725),(54.685,21.555),(54.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.915),(54.515,22.085),(54.685,22.085),(54.685,21.915),(54.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.275),(54.515,22.445),(54.685,22.445),(54.685,22.275),(54.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.635),(54.515,22.805),(54.685,22.805),(54.685,22.635),(54.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.995),(54.515,23.165),(54.685,23.165),(54.685,22.995),(54.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,23.355),(54.515,23.525),(54.685,23.525),(54.685,23.355),(54.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,23.715),(54.515,23.885),(54.685,23.885),(54.685,23.715),(54.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.075),(54.515,24.245),(54.685,24.245),(54.685,24.075),(54.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.435),(54.515,24.605),(54.685,24.605),(54.685,24.435),(54.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.795),(54.515,24.965),(54.685,24.965),(54.685,24.795),(54.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.155),(54.515,25.325),(54.685,25.325),(54.685,25.155),(54.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.515),(54.515,25.685),(54.685,25.685),(54.685,25.515),(54.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.875),(54.515,26.045),(54.685,26.045),(54.685,25.875),(54.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.235),(54.515,26.405),(54.685,26.405),(54.685,26.235),(54.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.595),(54.515,26.765),(54.685,26.765),(54.685,26.595),(54.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.955),(54.515,27.125),(54.685,27.125),(54.685,26.955),(54.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,27.315),(54.515,27.485),(54.685,27.485),(54.685,27.315),(54.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,27.675),(54.515,27.845),(54.685,27.845),(54.685,27.675),(54.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.035),(54.515,28.205),(54.685,28.205),(54.685,28.035),(54.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.395),(54.515,28.565),(54.685,28.565),(54.685,28.395),(54.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.755),(54.515,28.925),(54.685,28.925),(54.685,28.755),(54.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.115),(54.515,29.285),(54.685,29.285),(54.685,29.115),(54.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.475),(54.515,29.645),(54.685,29.645),(54.685,29.475),(54.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.835),(54.515,30.005),(54.685,30.005),(54.685,29.835),(54.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.195),(54.515,30.365),(54.685,30.365),(54.685,30.195),(54.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.555),(54.515,30.725),(54.685,30.725),(54.685,30.555),(54.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.915),(54.515,31.085),(54.685,31.085),(54.685,30.915),(54.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.275),(54.515,31.445),(54.685,31.445),(54.685,31.275),(54.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.635),(54.515,31.805),(54.685,31.805),(54.685,31.635),(54.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.995),(54.515,32.165),(54.685,32.165),(54.685,31.995),(54.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,32.355),(54.515,32.525),(54.685,32.525),(54.685,32.355),(54.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,32.715),(54.515,32.885),(54.685,32.885),(54.685,32.715),(54.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.075),(54.515,33.245),(54.685,33.245),(54.685,33.075),(54.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.435),(54.515,33.605),(54.685,33.605),(54.685,33.435),(54.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.795),(54.515,33.965),(54.685,33.965),(54.685,33.795),(54.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.155),(54.515,34.325),(54.685,34.325),(54.685,34.155),(54.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.515),(54.515,34.685),(54.685,34.685),(54.685,34.515),(54.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.875),(54.515,35.045),(54.685,35.045),(54.685,34.875),(54.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.235),(54.515,35.405),(54.685,35.405),(54.685,35.235),(54.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.595),(54.515,35.765),(54.685,35.765),(54.685,35.595),(54.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.955),(54.515,36.125),(54.685,36.125),(54.685,35.955),(54.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,36.315),(54.515,36.485),(54.685,36.485),(54.685,36.315),(54.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,36.675),(54.515,36.845),(54.685,36.845),(54.685,36.675),(54.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.035),(54.515,37.205),(54.685,37.205),(54.685,37.035),(54.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.395),(54.515,37.565),(54.685,37.565),(54.685,37.395),(54.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.755),(54.515,37.925),(54.685,37.925),(54.685,37.755),(54.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.115),(54.515,38.285),(54.685,38.285),(54.685,38.115),(54.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.475),(54.515,38.645),(54.685,38.645),(54.685,38.475),(54.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.835),(54.515,39.005),(54.685,39.005),(54.685,38.835),(54.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.195),(54.515,39.365),(54.685,39.365),(54.685,39.195),(54.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.555),(54.515,39.725),(54.685,39.725),(54.685,39.555),(54.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.915),(54.515,40.085),(54.685,40.085),(54.685,39.915),(54.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,40.275),(54.515,40.445),(54.685,40.445),(54.685,40.275),(54.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,40.635),(54.515,40.805),(54.685,40.805),(54.685,40.635),(54.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,2.835),(25.715,3.005),(25.885,3.005),(25.885,2.835),(25.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.195),(25.715,3.365),(25.885,3.365),(25.885,3.195),(25.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.555),(25.715,3.725),(25.885,3.725),(25.885,3.555),(25.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.915),(25.715,4.085),(25.885,4.085),(25.885,3.915),(25.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.275),(25.715,4.445),(25.885,4.445),(25.885,4.275),(25.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.635),(25.715,4.805),(25.885,4.805),(25.885,4.635),(25.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.995),(25.715,5.165),(25.885,5.165),(25.885,4.995),(25.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.355),(25.715,5.525),(25.885,5.525),(25.885,5.355),(25.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.715),(25.715,5.885),(25.885,5.885),(25.885,5.715),(25.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.075),(25.715,6.245),(25.885,6.245),(25.885,6.075),(25.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.435),(25.715,6.605),(25.885,6.605),(25.885,6.435),(25.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.795),(25.715,6.965),(25.885,6.965),(25.885,6.795),(25.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.155),(25.715,7.325),(25.885,7.325),(25.885,7.155),(25.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.515),(25.715,7.685),(25.885,7.685),(25.885,7.515),(25.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.875),(25.715,8.045),(25.885,8.045),(25.885,7.875),(25.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.235),(25.715,8.405),(25.885,8.405),(25.885,8.235),(25.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.595),(25.715,8.765),(25.885,8.765),(25.885,8.595),(25.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.955),(25.715,9.125),(25.885,9.125),(25.885,8.955),(25.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.315),(25.715,9.485),(25.885,9.485),(25.885,9.315),(25.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.675),(25.715,9.845),(25.885,9.845),(25.885,9.675),(25.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.035),(25.715,10.205),(25.885,10.205),(25.885,10.035),(25.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.395),(25.715,10.565),(25.885,10.565),(25.885,10.395),(25.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.755),(25.715,10.925),(25.885,10.925),(25.885,10.755),(25.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.115),(25.715,11.285),(25.885,11.285),(25.885,11.115),(25.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.475),(25.715,11.645),(25.885,11.645),(25.885,11.475),(25.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.835),(25.715,12.005),(25.885,12.005),(25.885,11.835),(25.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.195),(25.715,12.365),(25.885,12.365),(25.885,12.195),(25.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.555),(25.715,12.725),(25.885,12.725),(25.885,12.555),(25.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.915),(25.715,13.085),(25.885,13.085),(25.885,12.915),(25.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.275),(25.715,13.445),(25.885,13.445),(25.885,13.275),(25.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.635),(25.715,13.805),(25.885,13.805),(25.885,13.635),(25.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.995),(25.715,14.165),(25.885,14.165),(25.885,13.995),(25.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.355),(25.715,14.525),(25.885,14.525),(25.885,14.355),(25.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.715),(25.715,14.885),(25.885,14.885),(25.885,14.715),(25.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.075),(25.715,15.245),(25.885,15.245),(25.885,15.075),(25.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.435),(25.715,15.605),(25.885,15.605),(25.885,15.435),(25.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.795),(25.715,15.965),(25.885,15.965),(25.885,15.795),(25.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.155),(25.715,16.325),(25.885,16.325),(25.885,16.155),(25.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.515),(25.715,16.685),(25.885,16.685),(25.885,16.515),(25.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.875),(25.715,17.045),(25.885,17.045),(25.885,16.875),(25.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.235),(25.715,17.405),(25.885,17.405),(25.885,17.235),(25.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.595),(25.715,17.765),(25.885,17.765),(25.885,17.595),(25.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.955),(25.715,18.125),(25.885,18.125),(25.885,17.955),(25.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.315),(25.715,18.485),(25.885,18.485),(25.885,18.315),(25.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.675),(25.715,18.845),(25.885,18.845),(25.885,18.675),(25.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.035),(25.715,19.205),(25.885,19.205),(25.885,19.035),(25.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.395),(25.715,19.565),(25.885,19.565),(25.885,19.395),(25.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.755),(25.715,19.925),(25.885,19.925),(25.885,19.755),(25.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.115),(25.715,20.285),(25.885,20.285),(25.885,20.115),(25.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.475),(25.715,20.645),(25.885,20.645),(25.885,20.475),(25.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.835),(25.715,21.005),(25.885,21.005),(25.885,20.835),(25.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,21.195),(25.715,21.365),(25.885,21.365),(25.885,21.195),(25.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,21.555),(25.715,21.725),(25.885,21.725),(25.885,21.555),(25.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,21.915),(25.715,22.085),(25.885,22.085),(25.885,21.915),(25.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,22.275),(25.715,22.445),(25.885,22.445),(25.885,22.275),(25.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,22.635),(25.715,22.805),(25.885,22.805),(25.885,22.635),(25.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,22.995),(25.715,23.165),(25.885,23.165),(25.885,22.995),(25.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,23.355),(25.715,23.525),(25.885,23.525),(25.885,23.355),(25.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,23.715),(25.715,23.885),(25.885,23.885),(25.885,23.715),(25.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,24.075),(25.715,24.245),(25.885,24.245),(25.885,24.075),(25.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,24.435),(25.715,24.605),(25.885,24.605),(25.885,24.435),(25.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,24.795),(25.715,24.965),(25.885,24.965),(25.885,24.795),(25.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,25.155),(25.715,25.325),(25.885,25.325),(25.885,25.155),(25.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,25.515),(25.715,25.685),(25.885,25.685),(25.885,25.515),(25.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,25.875),(25.715,26.045),(25.885,26.045),(25.885,25.875),(25.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,26.235),(25.715,26.405),(25.885,26.405),(25.885,26.235),(25.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,26.595),(25.715,26.765),(25.885,26.765),(25.885,26.595),(25.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,26.955),(25.715,27.125),(25.885,27.125),(25.885,26.955),(25.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,27.315),(25.715,27.485),(25.885,27.485),(25.885,27.315),(25.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,27.675),(25.715,27.845),(25.885,27.845),(25.885,27.675),(25.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,28.035),(25.715,28.205),(25.885,28.205),(25.885,28.035),(25.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,28.395),(25.715,28.565),(25.885,28.565),(25.885,28.395),(25.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,28.755),(25.715,28.925),(25.885,28.925),(25.885,28.755),(25.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,29.115),(25.715,29.285),(25.885,29.285),(25.885,29.115),(25.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,29.475),(25.715,29.645),(25.885,29.645),(25.885,29.475),(25.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,29.835),(25.715,30.005),(25.885,30.005),(25.885,29.835),(25.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,30.195),(25.715,30.365),(25.885,30.365),(25.885,30.195),(25.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,30.555),(25.715,30.725),(25.885,30.725),(25.885,30.555),(25.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,30.915),(25.715,31.085),(25.885,31.085),(25.885,30.915),(25.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,31.275),(25.715,31.445),(25.885,31.445),(25.885,31.275),(25.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,31.635),(25.715,31.805),(25.885,31.805),(25.885,31.635),(25.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,31.995),(25.715,32.165),(25.885,32.165),(25.885,31.995),(25.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,32.355),(25.715,32.525),(25.885,32.525),(25.885,32.355),(25.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,32.715),(25.715,32.885),(25.885,32.885),(25.885,32.715),(25.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,33.075),(25.715,33.245),(25.885,33.245),(25.885,33.075),(25.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,33.435),(25.715,33.605),(25.885,33.605),(25.885,33.435),(25.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,33.795),(25.715,33.965),(25.885,33.965),(25.885,33.795),(25.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,34.155),(25.715,34.325),(25.885,34.325),(25.885,34.155),(25.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,34.515),(25.715,34.685),(25.885,34.685),(25.885,34.515),(25.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,34.875),(25.715,35.045),(25.885,35.045),(25.885,34.875),(25.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,35.235),(25.715,35.405),(25.885,35.405),(25.885,35.235),(25.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,35.595),(25.715,35.765),(25.885,35.765),(25.885,35.595),(25.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,35.955),(25.715,36.125),(25.885,36.125),(25.885,35.955),(25.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,36.315),(25.715,36.485),(25.885,36.485),(25.885,36.315),(25.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,36.675),(25.715,36.845),(25.885,36.845),(25.885,36.675),(25.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,37.035),(25.715,37.205),(25.885,37.205),(25.885,37.035),(25.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,37.395),(25.715,37.565),(25.885,37.565),(25.885,37.395),(25.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,37.755),(25.715,37.925),(25.885,37.925),(25.885,37.755),(25.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,38.115),(25.715,38.285),(25.885,38.285),(25.885,38.115),(25.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,38.475),(25.715,38.645),(25.885,38.645),(25.885,38.475),(25.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,38.835),(25.715,39.005),(25.885,39.005),(25.885,38.835),(25.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,39.195),(25.715,39.365),(25.885,39.365),(25.885,39.195),(25.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,39.555),(25.715,39.725),(25.885,39.725),(25.885,39.555),(25.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,39.915),(25.715,40.085),(25.885,40.085),(25.885,39.915),(25.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,40.275),(25.715,40.445),(25.885,40.445),(25.885,40.275),(25.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,40.635),(25.715,40.805),(25.885,40.805),(25.885,40.635),(25.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.835),(40.115,3.005),(40.285,3.005),(40.285,2.835),(40.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.195),(40.115,3.365),(40.285,3.365),(40.285,3.195),(40.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.555),(40.115,3.725),(40.285,3.725),(40.285,3.555),(40.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.915),(40.115,4.085),(40.285,4.085),(40.285,3.915),(40.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.275),(40.115,4.445),(40.285,4.445),(40.285,4.275),(40.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.635),(40.115,4.805),(40.285,4.805),(40.285,4.635),(40.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.995),(40.115,5.165),(40.285,5.165),(40.285,4.995),(40.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.355),(40.115,5.525),(40.285,5.525),(40.285,5.355),(40.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.715),(40.115,5.885),(40.285,5.885),(40.285,5.715),(40.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.075),(40.115,6.245),(40.285,6.245),(40.285,6.075),(40.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.435),(40.115,6.605),(40.285,6.605),(40.285,6.435),(40.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.795),(40.115,6.965),(40.285,6.965),(40.285,6.795),(40.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.155),(40.115,7.325),(40.285,7.325),(40.285,7.155),(40.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.515),(40.115,7.685),(40.285,7.685),(40.285,7.515),(40.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.875),(40.115,8.045),(40.285,8.045),(40.285,7.875),(40.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.235),(40.115,8.405),(40.285,8.405),(40.285,8.235),(40.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.595),(40.115,8.765),(40.285,8.765),(40.285,8.595),(40.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.955),(40.115,9.125),(40.285,9.125),(40.285,8.955),(40.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.315),(40.115,9.485),(40.285,9.485),(40.285,9.315),(40.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.675),(40.115,9.845),(40.285,9.845),(40.285,9.675),(40.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.035),(40.115,10.205),(40.285,10.205),(40.285,10.035),(40.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.395),(40.115,10.565),(40.285,10.565),(40.285,10.395),(40.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.755),(40.115,10.925),(40.285,10.925),(40.285,10.755),(40.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.115),(40.115,11.285),(40.285,11.285),(40.285,11.115),(40.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.475),(40.115,11.645),(40.285,11.645),(40.285,11.475),(40.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.835),(40.115,12.005),(40.285,12.005),(40.285,11.835),(40.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.195),(40.115,12.365),(40.285,12.365),(40.285,12.195),(40.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.555),(40.115,12.725),(40.285,12.725),(40.285,12.555),(40.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.915),(40.115,13.085),(40.285,13.085),(40.285,12.915),(40.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.275),(40.115,13.445),(40.285,13.445),(40.285,13.275),(40.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.635),(40.115,13.805),(40.285,13.805),(40.285,13.635),(40.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.995),(40.115,14.165),(40.285,14.165),(40.285,13.995),(40.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.355),(40.115,14.525),(40.285,14.525),(40.285,14.355),(40.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.715),(40.115,14.885),(40.285,14.885),(40.285,14.715),(40.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.075),(40.115,15.245),(40.285,15.245),(40.285,15.075),(40.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.435),(40.115,15.605),(40.285,15.605),(40.285,15.435),(40.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.795),(40.115,15.965),(40.285,15.965),(40.285,15.795),(40.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.155),(40.115,16.325),(40.285,16.325),(40.285,16.155),(40.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.515),(40.115,16.685),(40.285,16.685),(40.285,16.515),(40.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.875),(40.115,17.045),(40.285,17.045),(40.285,16.875),(40.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.235),(40.115,17.405),(40.285,17.405),(40.285,17.235),(40.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.595),(40.115,17.765),(40.285,17.765),(40.285,17.595),(40.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.955),(40.115,18.125),(40.285,18.125),(40.285,17.955),(40.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.315),(40.115,18.485),(40.285,18.485),(40.285,18.315),(40.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.675),(40.115,18.845),(40.285,18.845),(40.285,18.675),(40.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.035),(40.115,19.205),(40.285,19.205),(40.285,19.035),(40.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.395),(40.115,19.565),(40.285,19.565),(40.285,19.395),(40.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.755),(40.115,19.925),(40.285,19.925),(40.285,19.755),(40.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.115),(40.115,20.285),(40.285,20.285),(40.285,20.115),(40.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.475),(40.115,20.645),(40.285,20.645),(40.285,20.475),(40.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.835),(40.115,21.005),(40.285,21.005),(40.285,20.835),(40.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.195),(40.115,21.365),(40.285,21.365),(40.285,21.195),(40.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.555),(40.115,21.725),(40.285,21.725),(40.285,21.555),(40.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.915),(40.115,22.085),(40.285,22.085),(40.285,21.915),(40.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.275),(40.115,22.445),(40.285,22.445),(40.285,22.275),(40.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.635),(40.115,22.805),(40.285,22.805),(40.285,22.635),(40.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.995),(40.115,23.165),(40.285,23.165),(40.285,22.995),(40.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,23.355),(40.115,23.525),(40.285,23.525),(40.285,23.355),(40.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,23.715),(40.115,23.885),(40.285,23.885),(40.285,23.715),(40.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.075),(40.115,24.245),(40.285,24.245),(40.285,24.075),(40.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.435),(40.115,24.605),(40.285,24.605),(40.285,24.435),(40.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.795),(40.115,24.965),(40.285,24.965),(40.285,24.795),(40.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.155),(40.115,25.325),(40.285,25.325),(40.285,25.155),(40.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.515),(40.115,25.685),(40.285,25.685),(40.285,25.515),(40.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.875),(40.115,26.045),(40.285,26.045),(40.285,25.875),(40.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.235),(40.115,26.405),(40.285,26.405),(40.285,26.235),(40.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.595),(40.115,26.765),(40.285,26.765),(40.285,26.595),(40.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.955),(40.115,27.125),(40.285,27.125),(40.285,26.955),(40.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,27.315),(40.115,27.485),(40.285,27.485),(40.285,27.315),(40.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,27.675),(40.115,27.845),(40.285,27.845),(40.285,27.675),(40.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.035),(40.115,28.205),(40.285,28.205),(40.285,28.035),(40.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.395),(40.115,28.565),(40.285,28.565),(40.285,28.395),(40.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.755),(40.115,28.925),(40.285,28.925),(40.285,28.755),(40.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.115),(40.115,29.285),(40.285,29.285),(40.285,29.115),(40.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.475),(40.115,29.645),(40.285,29.645),(40.285,29.475),(40.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.835),(40.115,30.005),(40.285,30.005),(40.285,29.835),(40.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.195),(40.115,30.365),(40.285,30.365),(40.285,30.195),(40.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.555),(40.115,30.725),(40.285,30.725),(40.285,30.555),(40.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.915),(40.115,31.085),(40.285,31.085),(40.285,30.915),(40.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.275),(40.115,31.445),(40.285,31.445),(40.285,31.275),(40.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.635),(40.115,31.805),(40.285,31.805),(40.285,31.635),(40.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.995),(40.115,32.165),(40.285,32.165),(40.285,31.995),(40.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,32.355),(40.115,32.525),(40.285,32.525),(40.285,32.355),(40.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,32.715),(40.115,32.885),(40.285,32.885),(40.285,32.715),(40.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.075),(40.115,33.245),(40.285,33.245),(40.285,33.075),(40.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.435),(40.115,33.605),(40.285,33.605),(40.285,33.435),(40.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.795),(40.115,33.965),(40.285,33.965),(40.285,33.795),(40.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.155),(40.115,34.325),(40.285,34.325),(40.285,34.155),(40.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.515),(40.115,34.685),(40.285,34.685),(40.285,34.515),(40.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.875),(40.115,35.045),(40.285,35.045),(40.285,34.875),(40.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.235),(40.115,35.405),(40.285,35.405),(40.285,35.235),(40.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.595),(40.115,35.765),(40.285,35.765),(40.285,35.595),(40.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.955),(40.115,36.125),(40.285,36.125),(40.285,35.955),(40.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,36.315),(40.115,36.485),(40.285,36.485),(40.285,36.315),(40.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,36.675),(40.115,36.845),(40.285,36.845),(40.285,36.675),(40.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.035),(40.115,37.205),(40.285,37.205),(40.285,37.035),(40.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.395),(40.115,37.565),(40.285,37.565),(40.285,37.395),(40.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.755),(40.115,37.925),(40.285,37.925),(40.285,37.755),(40.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.115),(40.115,38.285),(40.285,38.285),(40.285,38.115),(40.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.475),(40.115,38.645),(40.285,38.645),(40.285,38.475),(40.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.835),(40.115,39.005),(40.285,39.005),(40.285,38.835),(40.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.195),(40.115,39.365),(40.285,39.365),(40.285,39.195),(40.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.555),(40.115,39.725),(40.285,39.725),(40.285,39.555),(40.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.915),(40.115,40.085),(40.285,40.085),(40.285,39.915),(40.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,40.275),(40.115,40.445),(40.285,40.445),(40.285,40.275),(40.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,40.635),(40.115,40.805),(40.285,40.805),(40.285,40.635),(40.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,41.735),(54.515,41.905),(54.685,41.905),(54.685,41.735),(54.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,2.835),(64.115,3.005),(64.285,3.005),(64.285,2.835),(64.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.195),(64.115,3.365),(64.285,3.365),(64.285,3.195),(64.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.555),(64.115,3.725),(64.285,3.725),(64.285,3.555),(64.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.915),(64.115,4.085),(64.285,4.085),(64.285,3.915),(64.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.275),(64.115,4.445),(64.285,4.445),(64.285,4.275),(64.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.635),(64.115,4.805),(64.285,4.805),(64.285,4.635),(64.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.995),(64.115,5.165),(64.285,5.165),(64.285,4.995),(64.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.355),(64.115,5.525),(64.285,5.525),(64.285,5.355),(64.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.715),(64.115,5.885),(64.285,5.885),(64.285,5.715),(64.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.075),(64.115,6.245),(64.285,6.245),(64.285,6.075),(64.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.435),(64.115,6.605),(64.285,6.605),(64.285,6.435),(64.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.795),(64.115,6.965),(64.285,6.965),(64.285,6.795),(64.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.155),(64.115,7.325),(64.285,7.325),(64.285,7.155),(64.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.515),(64.115,7.685),(64.285,7.685),(64.285,7.515),(64.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.875),(64.115,8.045),(64.285,8.045),(64.285,7.875),(64.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.235),(64.115,8.405),(64.285,8.405),(64.285,8.235),(64.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.595),(64.115,8.765),(64.285,8.765),(64.285,8.595),(64.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.955),(64.115,9.125),(64.285,9.125),(64.285,8.955),(64.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.315),(64.115,9.485),(64.285,9.485),(64.285,9.315),(64.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.675),(64.115,9.845),(64.285,9.845),(64.285,9.675),(64.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.035),(64.115,10.205),(64.285,10.205),(64.285,10.035),(64.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.395),(64.115,10.565),(64.285,10.565),(64.285,10.395),(64.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.755),(64.115,10.925),(64.285,10.925),(64.285,10.755),(64.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.115),(64.115,11.285),(64.285,11.285),(64.285,11.115),(64.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.475),(64.115,11.645),(64.285,11.645),(64.285,11.475),(64.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.835),(64.115,12.005),(64.285,12.005),(64.285,11.835),(64.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.195),(64.115,12.365),(64.285,12.365),(64.285,12.195),(64.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.555),(64.115,12.725),(64.285,12.725),(64.285,12.555),(64.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.915),(64.115,13.085),(64.285,13.085),(64.285,12.915),(64.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.275),(64.115,13.445),(64.285,13.445),(64.285,13.275),(64.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.635),(64.115,13.805),(64.285,13.805),(64.285,13.635),(64.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.995),(64.115,14.165),(64.285,14.165),(64.285,13.995),(64.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.355),(64.115,14.525),(64.285,14.525),(64.285,14.355),(64.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.715),(64.115,14.885),(64.285,14.885),(64.285,14.715),(64.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.075),(64.115,15.245),(64.285,15.245),(64.285,15.075),(64.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.435),(64.115,15.605),(64.285,15.605),(64.285,15.435),(64.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.795),(64.115,15.965),(64.285,15.965),(64.285,15.795),(64.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.155),(64.115,16.325),(64.285,16.325),(64.285,16.155),(64.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.515),(64.115,16.685),(64.285,16.685),(64.285,16.515),(64.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.875),(64.115,17.045),(64.285,17.045),(64.285,16.875),(64.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.235),(64.115,17.405),(64.285,17.405),(64.285,17.235),(64.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.595),(64.115,17.765),(64.285,17.765),(64.285,17.595),(64.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.955),(64.115,18.125),(64.285,18.125),(64.285,17.955),(64.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.315),(64.115,18.485),(64.285,18.485),(64.285,18.315),(64.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.675),(64.115,18.845),(64.285,18.845),(64.285,18.675),(64.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.035),(64.115,19.205),(64.285,19.205),(64.285,19.035),(64.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.395),(64.115,19.565),(64.285,19.565),(64.285,19.395),(64.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.755),(64.115,19.925),(64.285,19.925),(64.285,19.755),(64.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.115),(64.115,20.285),(64.285,20.285),(64.285,20.115),(64.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.475),(64.115,20.645),(64.285,20.645),(64.285,20.475),(64.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.835),(64.115,21.005),(64.285,21.005),(64.285,20.835),(64.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,21.195),(64.115,21.365),(64.285,21.365),(64.285,21.195),(64.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,21.555),(64.115,21.725),(64.285,21.725),(64.285,21.555),(64.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,21.915),(64.115,22.085),(64.285,22.085),(64.285,21.915),(64.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,22.275),(64.115,22.445),(64.285,22.445),(64.285,22.275),(64.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,22.635),(64.115,22.805),(64.285,22.805),(64.285,22.635),(64.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,22.995),(64.115,23.165),(64.285,23.165),(64.285,22.995),(64.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,23.355),(64.115,23.525),(64.285,23.525),(64.285,23.355),(64.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,23.715),(64.115,23.885),(64.285,23.885),(64.285,23.715),(64.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,24.075),(64.115,24.245),(64.285,24.245),(64.285,24.075),(64.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,24.435),(64.115,24.605),(64.285,24.605),(64.285,24.435),(64.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,24.795),(64.115,24.965),(64.285,24.965),(64.285,24.795),(64.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,25.155),(64.115,25.325),(64.285,25.325),(64.285,25.155),(64.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,25.515),(64.115,25.685),(64.285,25.685),(64.285,25.515),(64.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,25.875),(64.115,26.045),(64.285,26.045),(64.285,25.875),(64.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,26.235),(64.115,26.405),(64.285,26.405),(64.285,26.235),(64.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,26.595),(64.115,26.765),(64.285,26.765),(64.285,26.595),(64.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,26.955),(64.115,27.125),(64.285,27.125),(64.285,26.955),(64.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,27.315),(64.115,27.485),(64.285,27.485),(64.285,27.315),(64.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,27.675),(64.115,27.845),(64.285,27.845),(64.285,27.675),(64.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,28.035),(64.115,28.205),(64.285,28.205),(64.285,28.035),(64.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,28.395),(64.115,28.565),(64.285,28.565),(64.285,28.395),(64.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,28.755),(64.115,28.925),(64.285,28.925),(64.285,28.755),(64.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,29.115),(64.115,29.285),(64.285,29.285),(64.285,29.115),(64.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,29.475),(64.115,29.645),(64.285,29.645),(64.285,29.475),(64.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,29.835),(64.115,30.005),(64.285,30.005),(64.285,29.835),(64.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,30.195),(64.115,30.365),(64.285,30.365),(64.285,30.195),(64.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,30.555),(64.115,30.725),(64.285,30.725),(64.285,30.555),(64.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,30.915),(64.115,31.085),(64.285,31.085),(64.285,30.915),(64.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,31.275),(64.115,31.445),(64.285,31.445),(64.285,31.275),(64.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,31.635),(64.115,31.805),(64.285,31.805),(64.285,31.635),(64.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,31.995),(64.115,32.165),(64.285,32.165),(64.285,31.995),(64.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,32.355),(64.115,32.525),(64.285,32.525),(64.285,32.355),(64.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,32.715),(64.115,32.885),(64.285,32.885),(64.285,32.715),(64.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,33.075),(64.115,33.245),(64.285,33.245),(64.285,33.075),(64.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,33.435),(64.115,33.605),(64.285,33.605),(64.285,33.435),(64.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,33.795),(64.115,33.965),(64.285,33.965),(64.285,33.795),(64.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,34.155),(64.115,34.325),(64.285,34.325),(64.285,34.155),(64.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,34.515),(64.115,34.685),(64.285,34.685),(64.285,34.515),(64.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,34.875),(64.115,35.045),(64.285,35.045),(64.285,34.875),(64.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,35.235),(64.115,35.405),(64.285,35.405),(64.285,35.235),(64.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,35.595),(64.115,35.765),(64.285,35.765),(64.285,35.595),(64.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,35.955),(64.115,36.125),(64.285,36.125),(64.285,35.955),(64.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,36.315),(64.115,36.485),(64.285,36.485),(64.285,36.315),(64.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,36.675),(64.115,36.845),(64.285,36.845),(64.285,36.675),(64.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,37.035),(64.115,37.205),(64.285,37.205),(64.285,37.035),(64.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,37.395),(64.115,37.565),(64.285,37.565),(64.285,37.395),(64.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,37.755),(64.115,37.925),(64.285,37.925),(64.285,37.755),(64.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,38.115),(64.115,38.285),(64.285,38.285),(64.285,38.115),(64.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,38.475),(64.115,38.645),(64.285,38.645),(64.285,38.475),(64.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,38.835),(64.115,39.005),(64.285,39.005),(64.285,38.835),(64.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,39.195),(64.115,39.365),(64.285,39.365),(64.285,39.195),(64.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,39.555),(64.115,39.725),(64.285,39.725),(64.285,39.555),(64.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,39.915),(64.115,40.085),(64.285,40.085),(64.285,39.915),(64.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,40.275),(64.115,40.445),(64.285,40.445),(64.285,40.275),(64.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,40.635),(64.115,40.805),(64.285,40.805),(64.285,40.635),(64.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,41.735),(25.715,41.905),(25.885,41.905),(25.885,41.735),(25.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,2.835),(59.315,3.005),(59.485,3.005),(59.485,2.835),(59.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.195),(59.315,3.365),(59.485,3.365),(59.485,3.195),(59.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.555),(59.315,3.725),(59.485,3.725),(59.485,3.555),(59.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.915),(59.315,4.085),(59.485,4.085),(59.485,3.915),(59.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.275),(59.315,4.445),(59.485,4.445),(59.485,4.275),(59.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.635),(59.315,4.805),(59.485,4.805),(59.485,4.635),(59.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.995),(59.315,5.165),(59.485,5.165),(59.485,4.995),(59.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.355),(59.315,5.525),(59.485,5.525),(59.485,5.355),(59.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.715),(59.315,5.885),(59.485,5.885),(59.485,5.715),(59.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.075),(59.315,6.245),(59.485,6.245),(59.485,6.075),(59.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.435),(59.315,6.605),(59.485,6.605),(59.485,6.435),(59.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.795),(59.315,6.965),(59.485,6.965),(59.485,6.795),(59.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.155),(59.315,7.325),(59.485,7.325),(59.485,7.155),(59.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.515),(59.315,7.685),(59.485,7.685),(59.485,7.515),(59.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.875),(59.315,8.045),(59.485,8.045),(59.485,7.875),(59.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.235),(59.315,8.405),(59.485,8.405),(59.485,8.235),(59.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.595),(59.315,8.765),(59.485,8.765),(59.485,8.595),(59.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.955),(59.315,9.125),(59.485,9.125),(59.485,8.955),(59.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.315),(59.315,9.485),(59.485,9.485),(59.485,9.315),(59.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.675),(59.315,9.845),(59.485,9.845),(59.485,9.675),(59.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.035),(59.315,10.205),(59.485,10.205),(59.485,10.035),(59.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.395),(59.315,10.565),(59.485,10.565),(59.485,10.395),(59.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.755),(59.315,10.925),(59.485,10.925),(59.485,10.755),(59.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.115),(59.315,11.285),(59.485,11.285),(59.485,11.115),(59.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.475),(59.315,11.645),(59.485,11.645),(59.485,11.475),(59.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.835),(59.315,12.005),(59.485,12.005),(59.485,11.835),(59.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.195),(59.315,12.365),(59.485,12.365),(59.485,12.195),(59.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.555),(59.315,12.725),(59.485,12.725),(59.485,12.555),(59.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.915),(59.315,13.085),(59.485,13.085),(59.485,12.915),(59.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.275),(59.315,13.445),(59.485,13.445),(59.485,13.275),(59.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.635),(59.315,13.805),(59.485,13.805),(59.485,13.635),(59.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.995),(59.315,14.165),(59.485,14.165),(59.485,13.995),(59.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.355),(59.315,14.525),(59.485,14.525),(59.485,14.355),(59.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.715),(59.315,14.885),(59.485,14.885),(59.485,14.715),(59.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.075),(59.315,15.245),(59.485,15.245),(59.485,15.075),(59.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.435),(59.315,15.605),(59.485,15.605),(59.485,15.435),(59.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.795),(59.315,15.965),(59.485,15.965),(59.485,15.795),(59.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.155),(59.315,16.325),(59.485,16.325),(59.485,16.155),(59.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.515),(59.315,16.685),(59.485,16.685),(59.485,16.515),(59.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.875),(59.315,17.045),(59.485,17.045),(59.485,16.875),(59.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.235),(59.315,17.405),(59.485,17.405),(59.485,17.235),(59.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.595),(59.315,17.765),(59.485,17.765),(59.485,17.595),(59.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.955),(59.315,18.125),(59.485,18.125),(59.485,17.955),(59.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.315),(59.315,18.485),(59.485,18.485),(59.485,18.315),(59.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.675),(59.315,18.845),(59.485,18.845),(59.485,18.675),(59.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.035),(59.315,19.205),(59.485,19.205),(59.485,19.035),(59.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.395),(59.315,19.565),(59.485,19.565),(59.485,19.395),(59.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.755),(59.315,19.925),(59.485,19.925),(59.485,19.755),(59.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.115),(59.315,20.285),(59.485,20.285),(59.485,20.115),(59.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.475),(59.315,20.645),(59.485,20.645),(59.485,20.475),(59.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.835),(59.315,21.005),(59.485,21.005),(59.485,20.835),(59.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,21.195),(59.315,21.365),(59.485,21.365),(59.485,21.195),(59.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,21.555),(59.315,21.725),(59.485,21.725),(59.485,21.555),(59.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,21.915),(59.315,22.085),(59.485,22.085),(59.485,21.915),(59.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,22.275),(59.315,22.445),(59.485,22.445),(59.485,22.275),(59.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,22.635),(59.315,22.805),(59.485,22.805),(59.485,22.635),(59.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,22.995),(59.315,23.165),(59.485,23.165),(59.485,22.995),(59.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,23.355),(59.315,23.525),(59.485,23.525),(59.485,23.355),(59.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,23.715),(59.315,23.885),(59.485,23.885),(59.485,23.715),(59.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,24.075),(59.315,24.245),(59.485,24.245),(59.485,24.075),(59.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,24.435),(59.315,24.605),(59.485,24.605),(59.485,24.435),(59.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,24.795),(59.315,24.965),(59.485,24.965),(59.485,24.795),(59.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,25.155),(59.315,25.325),(59.485,25.325),(59.485,25.155),(59.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,25.515),(59.315,25.685),(59.485,25.685),(59.485,25.515),(59.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,25.875),(59.315,26.045),(59.485,26.045),(59.485,25.875),(59.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,26.235),(59.315,26.405),(59.485,26.405),(59.485,26.235),(59.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,26.595),(59.315,26.765),(59.485,26.765),(59.485,26.595),(59.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,26.955),(59.315,27.125),(59.485,27.125),(59.485,26.955),(59.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,27.315),(59.315,27.485),(59.485,27.485),(59.485,27.315),(59.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,27.675),(59.315,27.845),(59.485,27.845),(59.485,27.675),(59.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,28.035),(59.315,28.205),(59.485,28.205),(59.485,28.035),(59.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,28.395),(59.315,28.565),(59.485,28.565),(59.485,28.395),(59.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,28.755),(59.315,28.925),(59.485,28.925),(59.485,28.755),(59.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,29.115),(59.315,29.285),(59.485,29.285),(59.485,29.115),(59.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,29.475),(59.315,29.645),(59.485,29.645),(59.485,29.475),(59.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,29.835),(59.315,30.005),(59.485,30.005),(59.485,29.835),(59.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,30.195),(59.315,30.365),(59.485,30.365),(59.485,30.195),(59.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,30.555),(59.315,30.725),(59.485,30.725),(59.485,30.555),(59.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,30.915),(59.315,31.085),(59.485,31.085),(59.485,30.915),(59.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,31.275),(59.315,31.445),(59.485,31.445),(59.485,31.275),(59.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,31.635),(59.315,31.805),(59.485,31.805),(59.485,31.635),(59.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,31.995),(59.315,32.165),(59.485,32.165),(59.485,31.995),(59.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,32.355),(59.315,32.525),(59.485,32.525),(59.485,32.355),(59.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,32.715),(59.315,32.885),(59.485,32.885),(59.485,32.715),(59.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,33.075),(59.315,33.245),(59.485,33.245),(59.485,33.075),(59.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,33.435),(59.315,33.605),(59.485,33.605),(59.485,33.435),(59.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,33.795),(59.315,33.965),(59.485,33.965),(59.485,33.795),(59.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,34.155),(59.315,34.325),(59.485,34.325),(59.485,34.155),(59.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,34.515),(59.315,34.685),(59.485,34.685),(59.485,34.515),(59.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,34.875),(59.315,35.045),(59.485,35.045),(59.485,34.875),(59.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,35.235),(59.315,35.405),(59.485,35.405),(59.485,35.235),(59.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,35.595),(59.315,35.765),(59.485,35.765),(59.485,35.595),(59.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,35.955),(59.315,36.125),(59.485,36.125),(59.485,35.955),(59.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,36.315),(59.315,36.485),(59.485,36.485),(59.485,36.315),(59.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,36.675),(59.315,36.845),(59.485,36.845),(59.485,36.675),(59.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,37.035),(59.315,37.205),(59.485,37.205),(59.485,37.035),(59.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,37.395),(59.315,37.565),(59.485,37.565),(59.485,37.395),(59.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,37.755),(59.315,37.925),(59.485,37.925),(59.485,37.755),(59.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,38.115),(59.315,38.285),(59.485,38.285),(59.485,38.115),(59.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,38.475),(59.315,38.645),(59.485,38.645),(59.485,38.475),(59.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,38.835),(59.315,39.005),(59.485,39.005),(59.485,38.835),(59.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,39.195),(59.315,39.365),(59.485,39.365),(59.485,39.195),(59.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,39.555),(59.315,39.725),(59.485,39.725),(59.485,39.555),(59.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,39.915),(59.315,40.085),(59.485,40.085),(59.485,39.915),(59.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,40.275),(59.315,40.445),(59.485,40.445),(59.485,40.275),(59.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,40.635),(59.315,40.805),(59.485,40.805),(59.485,40.635),(59.315,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,41.735),(64.115,41.905),(64.285,41.905),(64.285,41.735),(64.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,41.735),(6.77,41.905),(6.94,41.905),(6.94,41.735),(6.77,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,2.835),(11.315,3.005),(11.485,3.005),(11.485,2.835),(11.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.195),(11.315,3.365),(11.485,3.365),(11.485,3.195),(11.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.555),(11.315,3.725),(11.485,3.725),(11.485,3.555),(11.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.915),(11.315,4.085),(11.485,4.085),(11.485,3.915),(11.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.275),(11.315,4.445),(11.485,4.445),(11.485,4.275),(11.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.635),(11.315,4.805),(11.485,4.805),(11.485,4.635),(11.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.995),(11.315,5.165),(11.485,5.165),(11.485,4.995),(11.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.355),(11.315,5.525),(11.485,5.525),(11.485,5.355),(11.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.715),(11.315,5.885),(11.485,5.885),(11.485,5.715),(11.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.075),(11.315,6.245),(11.485,6.245),(11.485,6.075),(11.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.435),(11.315,6.605),(11.485,6.605),(11.485,6.435),(11.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.795),(11.315,6.965),(11.485,6.965),(11.485,6.795),(11.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.155),(11.315,7.325),(11.485,7.325),(11.485,7.155),(11.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.515),(11.315,7.685),(11.485,7.685),(11.485,7.515),(11.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.875),(11.315,8.045),(11.485,8.045),(11.485,7.875),(11.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.235),(11.315,8.405),(11.485,8.405),(11.485,8.235),(11.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.595),(11.315,8.765),(11.485,8.765),(11.485,8.595),(11.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.955),(11.315,9.125),(11.485,9.125),(11.485,8.955),(11.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.315),(11.315,9.485),(11.485,9.485),(11.485,9.315),(11.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.675),(11.315,9.845),(11.485,9.845),(11.485,9.675),(11.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.035),(11.315,10.205),(11.485,10.205),(11.485,10.035),(11.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.395),(11.315,10.565),(11.485,10.565),(11.485,10.395),(11.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.755),(11.315,10.925),(11.485,10.925),(11.485,10.755),(11.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.115),(11.315,11.285),(11.485,11.285),(11.485,11.115),(11.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.475),(11.315,11.645),(11.485,11.645),(11.485,11.475),(11.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.835),(11.315,12.005),(11.485,12.005),(11.485,11.835),(11.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.195),(11.315,12.365),(11.485,12.365),(11.485,12.195),(11.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.555),(11.315,12.725),(11.485,12.725),(11.485,12.555),(11.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.915),(11.315,13.085),(11.485,13.085),(11.485,12.915),(11.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.275),(11.315,13.445),(11.485,13.445),(11.485,13.275),(11.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.635),(11.315,13.805),(11.485,13.805),(11.485,13.635),(11.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.995),(11.315,14.165),(11.485,14.165),(11.485,13.995),(11.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.355),(11.315,14.525),(11.485,14.525),(11.485,14.355),(11.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.715),(11.315,14.885),(11.485,14.885),(11.485,14.715),(11.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.075),(11.315,15.245),(11.485,15.245),(11.485,15.075),(11.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.435),(11.315,15.605),(11.485,15.605),(11.485,15.435),(11.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.795),(11.315,15.965),(11.485,15.965),(11.485,15.795),(11.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.155),(11.315,16.325),(11.485,16.325),(11.485,16.155),(11.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.515),(11.315,16.685),(11.485,16.685),(11.485,16.515),(11.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.875),(11.315,17.045),(11.485,17.045),(11.485,16.875),(11.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.235),(11.315,17.405),(11.485,17.405),(11.485,17.235),(11.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.595),(11.315,17.765),(11.485,17.765),(11.485,17.595),(11.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.955),(11.315,18.125),(11.485,18.125),(11.485,17.955),(11.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.315),(11.315,18.485),(11.485,18.485),(11.485,18.315),(11.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.675),(11.315,18.845),(11.485,18.845),(11.485,18.675),(11.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.035),(11.315,19.205),(11.485,19.205),(11.485,19.035),(11.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.395),(11.315,19.565),(11.485,19.565),(11.485,19.395),(11.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.755),(11.315,19.925),(11.485,19.925),(11.485,19.755),(11.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.115),(11.315,20.285),(11.485,20.285),(11.485,20.115),(11.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.475),(11.315,20.645),(11.485,20.645),(11.485,20.475),(11.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.835),(11.315,21.005),(11.485,21.005),(11.485,20.835),(11.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,21.195),(11.315,21.365),(11.485,21.365),(11.485,21.195),(11.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,21.555),(11.315,21.725),(11.485,21.725),(11.485,21.555),(11.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,21.915),(11.315,22.085),(11.485,22.085),(11.485,21.915),(11.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,22.275),(11.315,22.445),(11.485,22.445),(11.485,22.275),(11.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,22.635),(11.315,22.805),(11.485,22.805),(11.485,22.635),(11.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,22.995),(11.315,23.165),(11.485,23.165),(11.485,22.995),(11.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,23.355),(11.315,23.525),(11.485,23.525),(11.485,23.355),(11.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,23.715),(11.315,23.885),(11.485,23.885),(11.485,23.715),(11.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,24.075),(11.315,24.245),(11.485,24.245),(11.485,24.075),(11.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,24.435),(11.315,24.605),(11.485,24.605),(11.485,24.435),(11.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,24.795),(11.315,24.965),(11.485,24.965),(11.485,24.795),(11.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,25.155),(11.315,25.325),(11.485,25.325),(11.485,25.155),(11.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,25.515),(11.315,25.685),(11.485,25.685),(11.485,25.515),(11.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,25.875),(11.315,26.045),(11.485,26.045),(11.485,25.875),(11.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,26.235),(11.315,26.405),(11.485,26.405),(11.485,26.235),(11.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,26.595),(11.315,26.765),(11.485,26.765),(11.485,26.595),(11.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,26.955),(11.315,27.125),(11.485,27.125),(11.485,26.955),(11.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,27.315),(11.315,27.485),(11.485,27.485),(11.485,27.315),(11.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,27.675),(11.315,27.845),(11.485,27.845),(11.485,27.675),(11.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,28.035),(11.315,28.205),(11.485,28.205),(11.485,28.035),(11.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,28.395),(11.315,28.565),(11.485,28.565),(11.485,28.395),(11.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,28.755),(11.315,28.925),(11.485,28.925),(11.485,28.755),(11.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,29.115),(11.315,29.285),(11.485,29.285),(11.485,29.115),(11.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,29.475),(11.315,29.645),(11.485,29.645),(11.485,29.475),(11.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,29.835),(11.315,30.005),(11.485,30.005),(11.485,29.835),(11.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,30.195),(11.315,30.365),(11.485,30.365),(11.485,30.195),(11.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,30.555),(11.315,30.725),(11.485,30.725),(11.485,30.555),(11.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,30.915),(11.315,31.085),(11.485,31.085),(11.485,30.915),(11.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,31.275),(11.315,31.445),(11.485,31.445),(11.485,31.275),(11.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,31.635),(11.315,31.805),(11.485,31.805),(11.485,31.635),(11.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,31.995),(11.315,32.165),(11.485,32.165),(11.485,31.995),(11.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,32.355),(11.315,32.525),(11.485,32.525),(11.485,32.355),(11.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,32.715),(11.315,32.885),(11.485,32.885),(11.485,32.715),(11.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,33.075),(11.315,33.245),(11.485,33.245),(11.485,33.075),(11.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,33.435),(11.315,33.605),(11.485,33.605),(11.485,33.435),(11.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,33.795),(11.315,33.965),(11.485,33.965),(11.485,33.795),(11.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,34.155),(11.315,34.325),(11.485,34.325),(11.485,34.155),(11.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,34.515),(11.315,34.685),(11.485,34.685),(11.485,34.515),(11.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,34.875),(11.315,35.045),(11.485,35.045),(11.485,34.875),(11.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,35.235),(11.315,35.405),(11.485,35.405),(11.485,35.235),(11.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,35.595),(11.315,35.765),(11.485,35.765),(11.485,35.595),(11.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,35.955),(11.315,36.125),(11.485,36.125),(11.485,35.955),(11.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,36.315),(11.315,36.485),(11.485,36.485),(11.485,36.315),(11.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,36.675),(11.315,36.845),(11.485,36.845),(11.485,36.675),(11.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,37.035),(11.315,37.205),(11.485,37.205),(11.485,37.035),(11.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,37.395),(11.315,37.565),(11.485,37.565),(11.485,37.395),(11.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,37.755),(11.315,37.925),(11.485,37.925),(11.485,37.755),(11.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,38.115),(11.315,38.285),(11.485,38.285),(11.485,38.115),(11.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,38.475),(11.315,38.645),(11.485,38.645),(11.485,38.475),(11.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,38.835),(11.315,39.005),(11.485,39.005),(11.485,38.835),(11.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,39.195),(11.315,39.365),(11.485,39.365),(11.485,39.195),(11.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,39.555),(11.315,39.725),(11.485,39.725),(11.485,39.555),(11.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,39.915),(11.315,40.085),(11.485,40.085),(11.485,39.915),(11.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,40.275),(11.315,40.445),(11.485,40.445),(11.485,40.275),(11.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,40.635),(11.315,40.805),(11.485,40.805),(11.485,40.635),(11.315,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,2.835),(16.115,3.005),(16.285,3.005),(16.285,2.835),(16.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.195),(16.115,3.365),(16.285,3.365),(16.285,3.195),(16.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.555),(16.115,3.725),(16.285,3.725),(16.285,3.555),(16.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.915),(16.115,4.085),(16.285,4.085),(16.285,3.915),(16.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.275),(16.115,4.445),(16.285,4.445),(16.285,4.275),(16.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.635),(16.115,4.805),(16.285,4.805),(16.285,4.635),(16.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.995),(16.115,5.165),(16.285,5.165),(16.285,4.995),(16.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.355),(16.115,5.525),(16.285,5.525),(16.285,5.355),(16.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.715),(16.115,5.885),(16.285,5.885),(16.285,5.715),(16.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.075),(16.115,6.245),(16.285,6.245),(16.285,6.075),(16.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.435),(16.115,6.605),(16.285,6.605),(16.285,6.435),(16.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.795),(16.115,6.965),(16.285,6.965),(16.285,6.795),(16.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.155),(16.115,7.325),(16.285,7.325),(16.285,7.155),(16.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.515),(16.115,7.685),(16.285,7.685),(16.285,7.515),(16.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.875),(16.115,8.045),(16.285,8.045),(16.285,7.875),(16.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.235),(16.115,8.405),(16.285,8.405),(16.285,8.235),(16.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.595),(16.115,8.765),(16.285,8.765),(16.285,8.595),(16.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.955),(16.115,9.125),(16.285,9.125),(16.285,8.955),(16.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.315),(16.115,9.485),(16.285,9.485),(16.285,9.315),(16.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.675),(16.115,9.845),(16.285,9.845),(16.285,9.675),(16.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.035),(16.115,10.205),(16.285,10.205),(16.285,10.035),(16.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.395),(16.115,10.565),(16.285,10.565),(16.285,10.395),(16.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.755),(16.115,10.925),(16.285,10.925),(16.285,10.755),(16.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.115),(16.115,11.285),(16.285,11.285),(16.285,11.115),(16.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.475),(16.115,11.645),(16.285,11.645),(16.285,11.475),(16.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.835),(16.115,12.005),(16.285,12.005),(16.285,11.835),(16.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.195),(16.115,12.365),(16.285,12.365),(16.285,12.195),(16.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.555),(16.115,12.725),(16.285,12.725),(16.285,12.555),(16.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.915),(16.115,13.085),(16.285,13.085),(16.285,12.915),(16.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.275),(16.115,13.445),(16.285,13.445),(16.285,13.275),(16.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.635),(16.115,13.805),(16.285,13.805),(16.285,13.635),(16.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.995),(16.115,14.165),(16.285,14.165),(16.285,13.995),(16.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.355),(16.115,14.525),(16.285,14.525),(16.285,14.355),(16.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.715),(16.115,14.885),(16.285,14.885),(16.285,14.715),(16.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.075),(16.115,15.245),(16.285,15.245),(16.285,15.075),(16.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.435),(16.115,15.605),(16.285,15.605),(16.285,15.435),(16.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.795),(16.115,15.965),(16.285,15.965),(16.285,15.795),(16.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.155),(16.115,16.325),(16.285,16.325),(16.285,16.155),(16.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.515),(16.115,16.685),(16.285,16.685),(16.285,16.515),(16.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.875),(16.115,17.045),(16.285,17.045),(16.285,16.875),(16.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.235),(16.115,17.405),(16.285,17.405),(16.285,17.235),(16.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.595),(16.115,17.765),(16.285,17.765),(16.285,17.595),(16.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.955),(16.115,18.125),(16.285,18.125),(16.285,17.955),(16.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.315),(16.115,18.485),(16.285,18.485),(16.285,18.315),(16.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.675),(16.115,18.845),(16.285,18.845),(16.285,18.675),(16.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.035),(16.115,19.205),(16.285,19.205),(16.285,19.035),(16.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.395),(16.115,19.565),(16.285,19.565),(16.285,19.395),(16.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.755),(16.115,19.925),(16.285,19.925),(16.285,19.755),(16.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.115),(16.115,20.285),(16.285,20.285),(16.285,20.115),(16.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.475),(16.115,20.645),(16.285,20.645),(16.285,20.475),(16.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.835),(16.115,21.005),(16.285,21.005),(16.285,20.835),(16.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,21.195),(16.115,21.365),(16.285,21.365),(16.285,21.195),(16.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,21.555),(16.115,21.725),(16.285,21.725),(16.285,21.555),(16.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,21.915),(16.115,22.085),(16.285,22.085),(16.285,21.915),(16.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,22.275),(16.115,22.445),(16.285,22.445),(16.285,22.275),(16.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,22.635),(16.115,22.805),(16.285,22.805),(16.285,22.635),(16.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,22.995),(16.115,23.165),(16.285,23.165),(16.285,22.995),(16.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,23.355),(16.115,23.525),(16.285,23.525),(16.285,23.355),(16.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,23.715),(16.115,23.885),(16.285,23.885),(16.285,23.715),(16.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,24.075),(16.115,24.245),(16.285,24.245),(16.285,24.075),(16.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,24.435),(16.115,24.605),(16.285,24.605),(16.285,24.435),(16.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,24.795),(16.115,24.965),(16.285,24.965),(16.285,24.795),(16.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,25.155),(16.115,25.325),(16.285,25.325),(16.285,25.155),(16.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,25.515),(16.115,25.685),(16.285,25.685),(16.285,25.515),(16.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,25.875),(16.115,26.045),(16.285,26.045),(16.285,25.875),(16.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,26.235),(16.115,26.405),(16.285,26.405),(16.285,26.235),(16.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,26.595),(16.115,26.765),(16.285,26.765),(16.285,26.595),(16.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,26.955),(16.115,27.125),(16.285,27.125),(16.285,26.955),(16.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,27.315),(16.115,27.485),(16.285,27.485),(16.285,27.315),(16.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,27.675),(16.115,27.845),(16.285,27.845),(16.285,27.675),(16.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,28.035),(16.115,28.205),(16.285,28.205),(16.285,28.035),(16.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,28.395),(16.115,28.565),(16.285,28.565),(16.285,28.395),(16.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,28.755),(16.115,28.925),(16.285,28.925),(16.285,28.755),(16.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,29.115),(16.115,29.285),(16.285,29.285),(16.285,29.115),(16.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,29.475),(16.115,29.645),(16.285,29.645),(16.285,29.475),(16.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,29.835),(16.115,30.005),(16.285,30.005),(16.285,29.835),(16.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,30.195),(16.115,30.365),(16.285,30.365),(16.285,30.195),(16.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,30.555),(16.115,30.725),(16.285,30.725),(16.285,30.555),(16.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,30.915),(16.115,31.085),(16.285,31.085),(16.285,30.915),(16.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,31.275),(16.115,31.445),(16.285,31.445),(16.285,31.275),(16.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,31.635),(16.115,31.805),(16.285,31.805),(16.285,31.635),(16.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,31.995),(16.115,32.165),(16.285,32.165),(16.285,31.995),(16.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,32.355),(16.115,32.525),(16.285,32.525),(16.285,32.355),(16.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,32.715),(16.115,32.885),(16.285,32.885),(16.285,32.715),(16.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,33.075),(16.115,33.245),(16.285,33.245),(16.285,33.075),(16.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,33.435),(16.115,33.605),(16.285,33.605),(16.285,33.435),(16.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,33.795),(16.115,33.965),(16.285,33.965),(16.285,33.795),(16.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,34.155),(16.115,34.325),(16.285,34.325),(16.285,34.155),(16.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,34.515),(16.115,34.685),(16.285,34.685),(16.285,34.515),(16.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,34.875),(16.115,35.045),(16.285,35.045),(16.285,34.875),(16.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,35.235),(16.115,35.405),(16.285,35.405),(16.285,35.235),(16.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,35.595),(16.115,35.765),(16.285,35.765),(16.285,35.595),(16.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,35.955),(16.115,36.125),(16.285,36.125),(16.285,35.955),(16.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,36.315),(16.115,36.485),(16.285,36.485),(16.285,36.315),(16.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,36.675),(16.115,36.845),(16.285,36.845),(16.285,36.675),(16.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,37.035),(16.115,37.205),(16.285,37.205),(16.285,37.035),(16.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,37.395),(16.115,37.565),(16.285,37.565),(16.285,37.395),(16.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,37.755),(16.115,37.925),(16.285,37.925),(16.285,37.755),(16.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,38.115),(16.115,38.285),(16.285,38.285),(16.285,38.115),(16.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,38.475),(16.115,38.645),(16.285,38.645),(16.285,38.475),(16.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,38.835),(16.115,39.005),(16.285,39.005),(16.285,38.835),(16.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,39.195),(16.115,39.365),(16.285,39.365),(16.285,39.195),(16.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,39.555),(16.115,39.725),(16.285,39.725),(16.285,39.555),(16.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,39.915),(16.115,40.085),(16.285,40.085),(16.285,39.915),(16.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,40.275),(16.115,40.445),(16.285,40.445),(16.285,40.275),(16.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,40.635),(16.115,40.805),(16.285,40.805),(16.285,40.635),(16.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.835),(35.315,3.005),(35.485,3.005),(35.485,2.835),(35.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.195),(35.315,3.365),(35.485,3.365),(35.485,3.195),(35.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.555),(35.315,3.725),(35.485,3.725),(35.485,3.555),(35.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.915),(35.315,4.085),(35.485,4.085),(35.485,3.915),(35.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.275),(35.315,4.445),(35.485,4.445),(35.485,4.275),(35.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.635),(35.315,4.805),(35.485,4.805),(35.485,4.635),(35.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.995),(35.315,5.165),(35.485,5.165),(35.485,4.995),(35.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.355),(35.315,5.525),(35.485,5.525),(35.485,5.355),(35.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.715),(35.315,5.885),(35.485,5.885),(35.485,5.715),(35.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.075),(35.315,6.245),(35.485,6.245),(35.485,6.075),(35.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.435),(35.315,6.605),(35.485,6.605),(35.485,6.435),(35.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.795),(35.315,6.965),(35.485,6.965),(35.485,6.795),(35.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.155),(35.315,7.325),(35.485,7.325),(35.485,7.155),(35.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.515),(35.315,7.685),(35.485,7.685),(35.485,7.515),(35.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.875),(35.315,8.045),(35.485,8.045),(35.485,7.875),(35.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.235),(35.315,8.405),(35.485,8.405),(35.485,8.235),(35.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.595),(35.315,8.765),(35.485,8.765),(35.485,8.595),(35.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.955),(35.315,9.125),(35.485,9.125),(35.485,8.955),(35.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.315),(35.315,9.485),(35.485,9.485),(35.485,9.315),(35.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.675),(35.315,9.845),(35.485,9.845),(35.485,9.675),(35.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.035),(35.315,10.205),(35.485,10.205),(35.485,10.035),(35.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.395),(35.315,10.565),(35.485,10.565),(35.485,10.395),(35.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.755),(35.315,10.925),(35.485,10.925),(35.485,10.755),(35.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.115),(35.315,11.285),(35.485,11.285),(35.485,11.115),(35.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.475),(35.315,11.645),(35.485,11.645),(35.485,11.475),(35.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.835),(35.315,12.005),(35.485,12.005),(35.485,11.835),(35.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.195),(35.315,12.365),(35.485,12.365),(35.485,12.195),(35.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.555),(35.315,12.725),(35.485,12.725),(35.485,12.555),(35.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.915),(35.315,13.085),(35.485,13.085),(35.485,12.915),(35.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.275),(35.315,13.445),(35.485,13.445),(35.485,13.275),(35.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.635),(35.315,13.805),(35.485,13.805),(35.485,13.635),(35.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.995),(35.315,14.165),(35.485,14.165),(35.485,13.995),(35.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.355),(35.315,14.525),(35.485,14.525),(35.485,14.355),(35.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.715),(35.315,14.885),(35.485,14.885),(35.485,14.715),(35.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.075),(35.315,15.245),(35.485,15.245),(35.485,15.075),(35.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.435),(35.315,15.605),(35.485,15.605),(35.485,15.435),(35.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.795),(35.315,15.965),(35.485,15.965),(35.485,15.795),(35.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.155),(35.315,16.325),(35.485,16.325),(35.485,16.155),(35.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.515),(35.315,16.685),(35.485,16.685),(35.485,16.515),(35.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.875),(35.315,17.045),(35.485,17.045),(35.485,16.875),(35.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.235),(35.315,17.405),(35.485,17.405),(35.485,17.235),(35.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.595),(35.315,17.765),(35.485,17.765),(35.485,17.595),(35.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.955),(35.315,18.125),(35.485,18.125),(35.485,17.955),(35.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.315),(35.315,18.485),(35.485,18.485),(35.485,18.315),(35.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.675),(35.315,18.845),(35.485,18.845),(35.485,18.675),(35.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.035),(35.315,19.205),(35.485,19.205),(35.485,19.035),(35.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.395),(35.315,19.565),(35.485,19.565),(35.485,19.395),(35.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.755),(35.315,19.925),(35.485,19.925),(35.485,19.755),(35.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.115),(35.315,20.285),(35.485,20.285),(35.485,20.115),(35.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.475),(35.315,20.645),(35.485,20.645),(35.485,20.475),(35.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.835),(35.315,21.005),(35.485,21.005),(35.485,20.835),(35.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.195),(35.315,21.365),(35.485,21.365),(35.485,21.195),(35.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.555),(35.315,21.725),(35.485,21.725),(35.485,21.555),(35.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.915),(35.315,22.085),(35.485,22.085),(35.485,21.915),(35.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.275),(35.315,22.445),(35.485,22.445),(35.485,22.275),(35.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.635),(35.315,22.805),(35.485,22.805),(35.485,22.635),(35.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.995),(35.315,23.165),(35.485,23.165),(35.485,22.995),(35.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,23.355),(35.315,23.525),(35.485,23.525),(35.485,23.355),(35.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,23.715),(35.315,23.885),(35.485,23.885),(35.485,23.715),(35.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.075),(35.315,24.245),(35.485,24.245),(35.485,24.075),(35.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.435),(35.315,24.605),(35.485,24.605),(35.485,24.435),(35.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.795),(35.315,24.965),(35.485,24.965),(35.485,24.795),(35.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.155),(35.315,25.325),(35.485,25.325),(35.485,25.155),(35.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.515),(35.315,25.685),(35.485,25.685),(35.485,25.515),(35.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.875),(35.315,26.045),(35.485,26.045),(35.485,25.875),(35.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.235),(35.315,26.405),(35.485,26.405),(35.485,26.235),(35.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.595),(35.315,26.765),(35.485,26.765),(35.485,26.595),(35.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.955),(35.315,27.125),(35.485,27.125),(35.485,26.955),(35.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,27.315),(35.315,27.485),(35.485,27.485),(35.485,27.315),(35.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,27.675),(35.315,27.845),(35.485,27.845),(35.485,27.675),(35.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.035),(35.315,28.205),(35.485,28.205),(35.485,28.035),(35.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.395),(35.315,28.565),(35.485,28.565),(35.485,28.395),(35.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.755),(35.315,28.925),(35.485,28.925),(35.485,28.755),(35.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.115),(35.315,29.285),(35.485,29.285),(35.485,29.115),(35.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.475),(35.315,29.645),(35.485,29.645),(35.485,29.475),(35.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.835),(35.315,30.005),(35.485,30.005),(35.485,29.835),(35.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.195),(35.315,30.365),(35.485,30.365),(35.485,30.195),(35.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.555),(35.315,30.725),(35.485,30.725),(35.485,30.555),(35.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.915),(35.315,31.085),(35.485,31.085),(35.485,30.915),(35.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.275),(35.315,31.445),(35.485,31.445),(35.485,31.275),(35.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.635),(35.315,31.805),(35.485,31.805),(35.485,31.635),(35.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.995),(35.315,32.165),(35.485,32.165),(35.485,31.995),(35.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,32.355),(35.315,32.525),(35.485,32.525),(35.485,32.355),(35.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,32.715),(35.315,32.885),(35.485,32.885),(35.485,32.715),(35.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.075),(35.315,33.245),(35.485,33.245),(35.485,33.075),(35.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.435),(35.315,33.605),(35.485,33.605),(35.485,33.435),(35.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.795),(35.315,33.965),(35.485,33.965),(35.485,33.795),(35.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.155),(35.315,34.325),(35.485,34.325),(35.485,34.155),(35.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.515),(35.315,34.685),(35.485,34.685),(35.485,34.515),(35.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.875),(35.315,35.045),(35.485,35.045),(35.485,34.875),(35.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.235),(35.315,35.405),(35.485,35.405),(35.485,35.235),(35.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.595),(35.315,35.765),(35.485,35.765),(35.485,35.595),(35.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.955),(35.315,36.125),(35.485,36.125),(35.485,35.955),(35.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,36.315),(35.315,36.485),(35.485,36.485),(35.485,36.315),(35.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,36.675),(35.315,36.845),(35.485,36.845),(35.485,36.675),(35.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.035),(35.315,37.205),(35.485,37.205),(35.485,37.035),(35.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.395),(35.315,37.565),(35.485,37.565),(35.485,37.395),(35.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.755),(35.315,37.925),(35.485,37.925),(35.485,37.755),(35.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.115),(35.315,38.285),(35.485,38.285),(35.485,38.115),(35.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.475),(35.315,38.645),(35.485,38.645),(35.485,38.475),(35.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.835),(35.315,39.005),(35.485,39.005),(35.485,38.835),(35.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.195),(35.315,39.365),(35.485,39.365),(35.485,39.195),(35.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.555),(35.315,39.725),(35.485,39.725),(35.485,39.555),(35.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.915),(35.315,40.085),(35.485,40.085),(35.485,39.915),(35.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,40.275),(35.315,40.445),(35.485,40.445),(35.485,40.275),(35.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,40.635),(35.315,40.805),(35.485,40.805),(35.485,40.635),(35.315,40.635)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.0),(16.07,43.64),(16.33,43.64),(16.33,0.0),(16.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.0),(64.07,43.64),(64.33,43.64),(64.33,0.0),(64.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.0),(20.87,43.64),(21.13,43.64),(21.13,0.0),(20.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,43.64),(45.13,43.64),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.0),(68.87,43.64),(69.13,43.64),(69.13,0.0),(68.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,43.64),(49.93,43.64),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.0),(30.47,43.64),(30.73,43.64),(30.73,0.0),(30.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.0),(78.47,43.64),(78.73,43.64),(78.73,0.0),(78.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,21.67),(86.14,21.67),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,43.64),(54.73,43.64),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,43.64),(40.33,43.64),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.0),(11.27,43.64),(11.53,43.64),(11.53,0.0),(11.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,43.64),(35.53,43.64),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.0),(59.27,43.64),(59.53,43.64),(59.53,0.0),(59.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.0),(73.67,43.64),(73.93,43.64),(73.93,0.0),(73.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.0),(83.015,43.64),(83.275,43.64),(83.275,0.0),(83.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.0),(25.67,43.64),(25.93,43.64),(25.93,0.0),(25.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.0),(6.725,43.64),(6.985,43.64),(6.985,0.0),(6.725,0.0)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.145),(11.325,0.295),(11.475,0.295),(11.475,0.145),(11.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.465),(11.325,0.615),(11.475,0.615),(11.475,0.465),(11.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.785),(11.325,0.935),(11.475,0.935),(11.475,0.785),(11.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.105),(11.325,1.255),(11.475,1.255),(11.475,1.105),(11.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.425),(11.325,1.575),(11.475,1.575),(11.475,1.425),(11.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.745),(11.325,1.895),(11.475,1.895),(11.475,1.745),(11.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.065),(11.325,2.215),(11.475,2.215),(11.475,2.065),(11.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.385),(11.325,2.535),(11.475,2.535),(11.475,2.385),(11.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.705),(11.325,2.855),(11.475,2.855),(11.475,2.705),(11.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.025),(11.325,3.175),(11.475,3.175),(11.475,3.025),(11.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.345),(11.325,3.495),(11.475,3.495),(11.475,3.345),(11.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.665),(11.325,3.815),(11.475,3.815),(11.475,3.665),(11.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.985),(11.325,4.135),(11.475,4.135),(11.475,3.985),(11.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.305),(11.325,4.455),(11.475,4.455),(11.475,4.305),(11.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.625),(11.325,4.775),(11.475,4.775),(11.475,4.625),(11.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.945),(11.325,5.095),(11.475,5.095),(11.475,4.945),(11.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.265),(11.325,5.415),(11.475,5.415),(11.475,5.265),(11.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.585),(11.325,5.735),(11.475,5.735),(11.475,5.585),(11.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.905),(11.325,6.055),(11.475,6.055),(11.475,5.905),(11.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.225),(11.325,6.375),(11.475,6.375),(11.475,6.225),(11.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.545),(11.325,6.695),(11.475,6.695),(11.475,6.545),(11.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.865),(11.325,7.015),(11.475,7.015),(11.475,6.865),(11.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.185),(11.325,7.335),(11.475,7.335),(11.475,7.185),(11.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.505),(11.325,7.655),(11.475,7.655),(11.475,7.505),(11.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.825),(11.325,7.975),(11.475,7.975),(11.475,7.825),(11.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.145),(11.325,8.295),(11.475,8.295),(11.475,8.145),(11.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.465),(11.325,8.615),(11.475,8.615),(11.475,8.465),(11.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.785),(11.325,8.935),(11.475,8.935),(11.475,8.785),(11.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.105),(11.325,9.255),(11.475,9.255),(11.475,9.105),(11.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.425),(11.325,9.575),(11.475,9.575),(11.475,9.425),(11.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.745),(11.325,9.895),(11.475,9.895),(11.475,9.745),(11.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.065),(11.325,10.215),(11.475,10.215),(11.475,10.065),(11.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.385),(11.325,10.535),(11.475,10.535),(11.475,10.385),(11.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.705),(11.325,10.855),(11.475,10.855),(11.475,10.705),(11.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.025),(11.325,11.175),(11.475,11.175),(11.475,11.025),(11.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.345),(11.325,11.495),(11.475,11.495),(11.475,11.345),(11.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.665),(11.325,11.815),(11.475,11.815),(11.475,11.665),(11.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.985),(11.325,12.135),(11.475,12.135),(11.475,11.985),(11.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.305),(11.325,12.455),(11.475,12.455),(11.475,12.305),(11.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.625),(11.325,12.775),(11.475,12.775),(11.475,12.625),(11.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.945),(11.325,13.095),(11.475,13.095),(11.475,12.945),(11.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.265),(11.325,13.415),(11.475,13.415),(11.475,13.265),(11.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.585),(11.325,13.735),(11.475,13.735),(11.475,13.585),(11.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.905),(11.325,14.055),(11.475,14.055),(11.475,13.905),(11.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.225),(11.325,14.375),(11.475,14.375),(11.475,14.225),(11.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.545),(11.325,14.695),(11.475,14.695),(11.475,14.545),(11.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.865),(11.325,15.015),(11.475,15.015),(11.475,14.865),(11.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.185),(11.325,15.335),(11.475,15.335),(11.475,15.185),(11.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.505),(11.325,15.655),(11.475,15.655),(11.475,15.505),(11.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.825),(11.325,15.975),(11.475,15.975),(11.475,15.825),(11.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.145),(11.325,16.295),(11.475,16.295),(11.475,16.145),(11.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.465),(11.325,16.615),(11.475,16.615),(11.475,16.465),(11.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.785),(11.325,16.935),(11.475,16.935),(11.475,16.785),(11.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.105),(11.325,17.255),(11.475,17.255),(11.475,17.105),(11.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.425),(11.325,17.575),(11.475,17.575),(11.475,17.425),(11.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.745),(11.325,17.895),(11.475,17.895),(11.475,17.745),(11.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.065),(11.325,18.215),(11.475,18.215),(11.475,18.065),(11.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.385),(11.325,18.535),(11.475,18.535),(11.475,18.385),(11.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.705),(11.325,18.855),(11.475,18.855),(11.475,18.705),(11.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.025),(11.325,19.175),(11.475,19.175),(11.475,19.025),(11.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.345),(11.325,19.495),(11.475,19.495),(11.475,19.345),(11.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.665),(11.325,19.815),(11.475,19.815),(11.475,19.665),(11.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.985),(11.325,20.135),(11.475,20.135),(11.475,19.985),(11.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.305),(11.325,20.455),(11.475,20.455),(11.475,20.305),(11.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.625),(11.325,20.775),(11.475,20.775),(11.475,20.625),(11.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.945),(11.325,21.095),(11.475,21.095),(11.475,20.945),(11.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.265),(11.325,21.415),(11.475,21.415),(11.475,21.265),(11.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.585),(11.325,21.735),(11.475,21.735),(11.475,21.585),(11.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.905),(11.325,22.055),(11.475,22.055),(11.475,21.905),(11.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,22.225),(11.325,22.375),(11.475,22.375),(11.475,22.225),(11.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,22.545),(11.325,22.695),(11.475,22.695),(11.475,22.545),(11.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,22.865),(11.325,23.015),(11.475,23.015),(11.475,22.865),(11.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,23.185),(11.325,23.335),(11.475,23.335),(11.475,23.185),(11.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,23.505),(11.325,23.655),(11.475,23.655),(11.475,23.505),(11.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,23.825),(11.325,23.975),(11.475,23.975),(11.475,23.825),(11.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,24.145),(11.325,24.295),(11.475,24.295),(11.475,24.145),(11.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,24.465),(11.325,24.615),(11.475,24.615),(11.475,24.465),(11.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,24.785),(11.325,24.935),(11.475,24.935),(11.475,24.785),(11.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,25.105),(11.325,25.255),(11.475,25.255),(11.475,25.105),(11.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,25.425),(11.325,25.575),(11.475,25.575),(11.475,25.425),(11.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,25.745),(11.325,25.895),(11.475,25.895),(11.475,25.745),(11.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,26.065),(11.325,26.215),(11.475,26.215),(11.475,26.065),(11.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,26.385),(11.325,26.535),(11.475,26.535),(11.475,26.385),(11.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,26.705),(11.325,26.855),(11.475,26.855),(11.475,26.705),(11.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.025),(11.325,27.175),(11.475,27.175),(11.475,27.025),(11.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.345),(11.325,27.495),(11.475,27.495),(11.475,27.345),(11.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.665),(11.325,27.815),(11.475,27.815),(11.475,27.665),(11.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.985),(11.325,28.135),(11.475,28.135),(11.475,27.985),(11.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,28.305),(11.325,28.455),(11.475,28.455),(11.475,28.305),(11.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,28.625),(11.325,28.775),(11.475,28.775),(11.475,28.625),(11.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,28.945),(11.325,29.095),(11.475,29.095),(11.475,28.945),(11.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,29.265),(11.325,29.415),(11.475,29.415),(11.475,29.265),(11.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,29.585),(11.325,29.735),(11.475,29.735),(11.475,29.585),(11.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,29.905),(11.325,30.055),(11.475,30.055),(11.475,29.905),(11.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,30.225),(11.325,30.375),(11.475,30.375),(11.475,30.225),(11.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,30.545),(11.325,30.695),(11.475,30.695),(11.475,30.545),(11.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,30.865),(11.325,31.015),(11.475,31.015),(11.475,30.865),(11.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,31.185),(11.325,31.335),(11.475,31.335),(11.475,31.185),(11.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,31.505),(11.325,31.655),(11.475,31.655),(11.475,31.505),(11.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,31.825),(11.325,31.975),(11.475,31.975),(11.475,31.825),(11.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,32.145),(11.325,32.295),(11.475,32.295),(11.475,32.145),(11.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,32.465),(11.325,32.615),(11.475,32.615),(11.475,32.465),(11.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,32.785),(11.325,32.935),(11.475,32.935),(11.475,32.785),(11.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,33.105),(11.325,33.255),(11.475,33.255),(11.475,33.105),(11.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,33.425),(11.325,33.575),(11.475,33.575),(11.475,33.425),(11.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,33.745),(11.325,33.895),(11.475,33.895),(11.475,33.745),(11.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,34.065),(11.325,34.215),(11.475,34.215),(11.475,34.065),(11.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,34.385),(11.325,34.535),(11.475,34.535),(11.475,34.385),(11.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,34.705),(11.325,34.855),(11.475,34.855),(11.475,34.705),(11.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.025),(11.325,35.175),(11.475,35.175),(11.475,35.025),(11.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.345),(11.325,35.495),(11.475,35.495),(11.475,35.345),(11.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.665),(11.325,35.815),(11.475,35.815),(11.475,35.665),(11.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.985),(11.325,36.135),(11.475,36.135),(11.475,35.985),(11.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,36.305),(11.325,36.455),(11.475,36.455),(11.475,36.305),(11.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,36.625),(11.325,36.775),(11.475,36.775),(11.475,36.625),(11.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,36.945),(11.325,37.095),(11.475,37.095),(11.475,36.945),(11.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,37.265),(11.325,37.415),(11.475,37.415),(11.475,37.265),(11.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,37.585),(11.325,37.735),(11.475,37.735),(11.475,37.585),(11.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,37.905),(11.325,38.055),(11.475,38.055),(11.475,37.905),(11.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,38.225),(11.325,38.375),(11.475,38.375),(11.475,38.225),(11.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,38.545),(11.325,38.695),(11.475,38.695),(11.475,38.545),(11.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,38.865),(11.325,39.015),(11.475,39.015),(11.475,38.865),(11.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,39.185),(11.325,39.335),(11.475,39.335),(11.475,39.185),(11.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,39.505),(11.325,39.655),(11.475,39.655),(11.475,39.505),(11.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,39.825),(11.325,39.975),(11.475,39.975),(11.475,39.825),(11.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,40.145),(11.325,40.295),(11.475,40.295),(11.475,40.145),(11.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,40.465),(11.325,40.615),(11.475,40.615),(11.475,40.465),(11.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,40.785),(11.325,40.935),(11.475,40.935),(11.475,40.785),(11.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,41.105),(11.325,41.255),(11.475,41.255),(11.475,41.105),(11.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,41.425),(11.325,41.575),(11.475,41.575),(11.475,41.425),(11.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,41.745),(11.325,41.895),(11.475,41.895),(11.475,41.745),(11.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,42.065),(11.325,42.215),(11.475,42.215),(11.475,42.065),(11.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,42.385),(11.325,42.535),(11.475,42.535),(11.475,42.385),(11.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,42.705),(11.325,42.855),(11.475,42.855),(11.475,42.705),(11.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,43.025),(11.325,43.175),(11.475,43.175),(11.475,43.025),(11.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,43.345),(11.325,43.495),(11.475,43.495),(11.475,43.345),(11.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.145),(35.325,0.295),(35.475,0.295),(35.475,0.145),(35.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.465),(35.325,0.615),(35.475,0.615),(35.475,0.465),(35.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.785),(35.325,0.935),(35.475,0.935),(35.475,0.785),(35.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.105),(35.325,1.255),(35.475,1.255),(35.475,1.105),(35.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.425),(35.325,1.575),(35.475,1.575),(35.475,1.425),(35.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.745),(35.325,1.895),(35.475,1.895),(35.475,1.745),(35.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.065),(35.325,2.215),(35.475,2.215),(35.475,2.065),(35.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.385),(35.325,2.535),(35.475,2.535),(35.475,2.385),(35.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.705),(35.325,2.855),(35.475,2.855),(35.475,2.705),(35.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.025),(35.325,3.175),(35.475,3.175),(35.475,3.025),(35.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.345),(35.325,3.495),(35.475,3.495),(35.475,3.345),(35.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.665),(35.325,3.815),(35.475,3.815),(35.475,3.665),(35.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.985),(35.325,4.135),(35.475,4.135),(35.475,3.985),(35.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.305),(35.325,4.455),(35.475,4.455),(35.475,4.305),(35.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.625),(35.325,4.775),(35.475,4.775),(35.475,4.625),(35.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.945),(35.325,5.095),(35.475,5.095),(35.475,4.945),(35.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.265),(35.325,5.415),(35.475,5.415),(35.475,5.265),(35.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.585),(35.325,5.735),(35.475,5.735),(35.475,5.585),(35.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.905),(35.325,6.055),(35.475,6.055),(35.475,5.905),(35.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.225),(35.325,6.375),(35.475,6.375),(35.475,6.225),(35.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.545),(35.325,6.695),(35.475,6.695),(35.475,6.545),(35.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.865),(35.325,7.015),(35.475,7.015),(35.475,6.865),(35.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.185),(35.325,7.335),(35.475,7.335),(35.475,7.185),(35.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.505),(35.325,7.655),(35.475,7.655),(35.475,7.505),(35.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.825),(35.325,7.975),(35.475,7.975),(35.475,7.825),(35.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.145),(35.325,8.295),(35.475,8.295),(35.475,8.145),(35.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.465),(35.325,8.615),(35.475,8.615),(35.475,8.465),(35.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.785),(35.325,8.935),(35.475,8.935),(35.475,8.785),(35.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.105),(35.325,9.255),(35.475,9.255),(35.475,9.105),(35.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.425),(35.325,9.575),(35.475,9.575),(35.475,9.425),(35.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.745),(35.325,9.895),(35.475,9.895),(35.475,9.745),(35.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.065),(35.325,10.215),(35.475,10.215),(35.475,10.065),(35.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.385),(35.325,10.535),(35.475,10.535),(35.475,10.385),(35.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.705),(35.325,10.855),(35.475,10.855),(35.475,10.705),(35.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.025),(35.325,11.175),(35.475,11.175),(35.475,11.025),(35.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.345),(35.325,11.495),(35.475,11.495),(35.475,11.345),(35.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.665),(35.325,11.815),(35.475,11.815),(35.475,11.665),(35.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.985),(35.325,12.135),(35.475,12.135),(35.475,11.985),(35.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.305),(35.325,12.455),(35.475,12.455),(35.475,12.305),(35.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.625),(35.325,12.775),(35.475,12.775),(35.475,12.625),(35.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.945),(35.325,13.095),(35.475,13.095),(35.475,12.945),(35.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.265),(35.325,13.415),(35.475,13.415),(35.475,13.265),(35.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.585),(35.325,13.735),(35.475,13.735),(35.475,13.585),(35.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.905),(35.325,14.055),(35.475,14.055),(35.475,13.905),(35.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.225),(35.325,14.375),(35.475,14.375),(35.475,14.225),(35.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.545),(35.325,14.695),(35.475,14.695),(35.475,14.545),(35.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.865),(35.325,15.015),(35.475,15.015),(35.475,14.865),(35.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.185),(35.325,15.335),(35.475,15.335),(35.475,15.185),(35.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.505),(35.325,15.655),(35.475,15.655),(35.475,15.505),(35.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.825),(35.325,15.975),(35.475,15.975),(35.475,15.825),(35.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.145),(35.325,16.295),(35.475,16.295),(35.475,16.145),(35.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.465),(35.325,16.615),(35.475,16.615),(35.475,16.465),(35.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.785),(35.325,16.935),(35.475,16.935),(35.475,16.785),(35.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.105),(35.325,17.255),(35.475,17.255),(35.475,17.105),(35.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.425),(35.325,17.575),(35.475,17.575),(35.475,17.425),(35.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.745),(35.325,17.895),(35.475,17.895),(35.475,17.745),(35.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.065),(35.325,18.215),(35.475,18.215),(35.475,18.065),(35.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.385),(35.325,18.535),(35.475,18.535),(35.475,18.385),(35.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.705),(35.325,18.855),(35.475,18.855),(35.475,18.705),(35.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.025),(35.325,19.175),(35.475,19.175),(35.475,19.025),(35.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.345),(35.325,19.495),(35.475,19.495),(35.475,19.345),(35.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.665),(35.325,19.815),(35.475,19.815),(35.475,19.665),(35.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.985),(35.325,20.135),(35.475,20.135),(35.475,19.985),(35.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.305),(35.325,20.455),(35.475,20.455),(35.475,20.305),(35.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.625),(35.325,20.775),(35.475,20.775),(35.475,20.625),(35.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.945),(35.325,21.095),(35.475,21.095),(35.475,20.945),(35.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.265),(35.325,21.415),(35.475,21.415),(35.475,21.265),(35.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.585),(35.325,21.735),(35.475,21.735),(35.475,21.585),(35.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.905),(35.325,22.055),(35.475,22.055),(35.475,21.905),(35.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.225),(35.325,22.375),(35.475,22.375),(35.475,22.225),(35.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.545),(35.325,22.695),(35.475,22.695),(35.475,22.545),(35.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.865),(35.325,23.015),(35.475,23.015),(35.475,22.865),(35.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.185),(35.325,23.335),(35.475,23.335),(35.475,23.185),(35.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.505),(35.325,23.655),(35.475,23.655),(35.475,23.505),(35.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.825),(35.325,23.975),(35.475,23.975),(35.475,23.825),(35.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.145),(35.325,24.295),(35.475,24.295),(35.475,24.145),(35.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.465),(35.325,24.615),(35.475,24.615),(35.475,24.465),(35.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.785),(35.325,24.935),(35.475,24.935),(35.475,24.785),(35.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.105),(35.325,25.255),(35.475,25.255),(35.475,25.105),(35.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.425),(35.325,25.575),(35.475,25.575),(35.475,25.425),(35.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.745),(35.325,25.895),(35.475,25.895),(35.475,25.745),(35.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.065),(35.325,26.215),(35.475,26.215),(35.475,26.065),(35.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.385),(35.325,26.535),(35.475,26.535),(35.475,26.385),(35.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.705),(35.325,26.855),(35.475,26.855),(35.475,26.705),(35.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.025),(35.325,27.175),(35.475,27.175),(35.475,27.025),(35.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.345),(35.325,27.495),(35.475,27.495),(35.475,27.345),(35.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.665),(35.325,27.815),(35.475,27.815),(35.475,27.665),(35.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.985),(35.325,28.135),(35.475,28.135),(35.475,27.985),(35.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.305),(35.325,28.455),(35.475,28.455),(35.475,28.305),(35.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.625),(35.325,28.775),(35.475,28.775),(35.475,28.625),(35.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.945),(35.325,29.095),(35.475,29.095),(35.475,28.945),(35.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.265),(35.325,29.415),(35.475,29.415),(35.475,29.265),(35.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.585),(35.325,29.735),(35.475,29.735),(35.475,29.585),(35.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.905),(35.325,30.055),(35.475,30.055),(35.475,29.905),(35.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.225),(35.325,30.375),(35.475,30.375),(35.475,30.225),(35.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.545),(35.325,30.695),(35.475,30.695),(35.475,30.545),(35.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.865),(35.325,31.015),(35.475,31.015),(35.475,30.865),(35.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.185),(35.325,31.335),(35.475,31.335),(35.475,31.185),(35.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.505),(35.325,31.655),(35.475,31.655),(35.475,31.505),(35.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.825),(35.325,31.975),(35.475,31.975),(35.475,31.825),(35.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.145),(35.325,32.295),(35.475,32.295),(35.475,32.145),(35.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.465),(35.325,32.615),(35.475,32.615),(35.475,32.465),(35.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.785),(35.325,32.935),(35.475,32.935),(35.475,32.785),(35.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.105),(35.325,33.255),(35.475,33.255),(35.475,33.105),(35.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.425),(35.325,33.575),(35.475,33.575),(35.475,33.425),(35.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.745),(35.325,33.895),(35.475,33.895),(35.475,33.745),(35.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.065),(35.325,34.215),(35.475,34.215),(35.475,34.065),(35.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.385),(35.325,34.535),(35.475,34.535),(35.475,34.385),(35.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.705),(35.325,34.855),(35.475,34.855),(35.475,34.705),(35.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.025),(35.325,35.175),(35.475,35.175),(35.475,35.025),(35.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.345),(35.325,35.495),(35.475,35.495),(35.475,35.345),(35.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.665),(35.325,35.815),(35.475,35.815),(35.475,35.665),(35.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.985),(35.325,36.135),(35.475,36.135),(35.475,35.985),(35.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.305),(35.325,36.455),(35.475,36.455),(35.475,36.305),(35.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.625),(35.325,36.775),(35.475,36.775),(35.475,36.625),(35.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.945),(35.325,37.095),(35.475,37.095),(35.475,36.945),(35.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.265),(35.325,37.415),(35.475,37.415),(35.475,37.265),(35.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.585),(35.325,37.735),(35.475,37.735),(35.475,37.585),(35.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.905),(35.325,38.055),(35.475,38.055),(35.475,37.905),(35.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.225),(35.325,38.375),(35.475,38.375),(35.475,38.225),(35.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.545),(35.325,38.695),(35.475,38.695),(35.475,38.545),(35.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.865),(35.325,39.015),(35.475,39.015),(35.475,38.865),(35.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.185),(35.325,39.335),(35.475,39.335),(35.475,39.185),(35.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.505),(35.325,39.655),(35.475,39.655),(35.475,39.505),(35.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.825),(35.325,39.975),(35.475,39.975),(35.475,39.825),(35.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.145),(35.325,40.295),(35.475,40.295),(35.475,40.145),(35.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.465),(35.325,40.615),(35.475,40.615),(35.475,40.465),(35.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.785),(35.325,40.935),(35.475,40.935),(35.475,40.785),(35.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.105),(35.325,41.255),(35.475,41.255),(35.475,41.105),(35.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.425),(35.325,41.575),(35.475,41.575),(35.475,41.425),(35.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.745),(35.325,41.895),(35.475,41.895),(35.475,41.745),(35.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.065),(35.325,42.215),(35.475,42.215),(35.475,42.065),(35.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.385),(35.325,42.535),(35.475,42.535),(35.475,42.385),(35.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.705),(35.325,42.855),(35.475,42.855),(35.475,42.705),(35.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,43.025),(35.325,43.175),(35.475,43.175),(35.475,43.025),(35.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,43.345),(35.325,43.495),(35.475,43.495),(35.475,43.345),(35.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.145),(40.125,0.295),(40.275,0.295),(40.275,0.145),(40.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.465),(40.125,0.615),(40.275,0.615),(40.275,0.465),(40.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.785),(40.125,0.935),(40.275,0.935),(40.275,0.785),(40.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.105),(40.125,1.255),(40.275,1.255),(40.275,1.105),(40.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.425),(40.125,1.575),(40.275,1.575),(40.275,1.425),(40.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.745),(40.125,1.895),(40.275,1.895),(40.275,1.745),(40.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.065),(40.125,2.215),(40.275,2.215),(40.275,2.065),(40.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.385),(40.125,2.535),(40.275,2.535),(40.275,2.385),(40.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.705),(40.125,2.855),(40.275,2.855),(40.275,2.705),(40.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.025),(40.125,3.175),(40.275,3.175),(40.275,3.025),(40.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.345),(40.125,3.495),(40.275,3.495),(40.275,3.345),(40.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.665),(40.125,3.815),(40.275,3.815),(40.275,3.665),(40.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.985),(40.125,4.135),(40.275,4.135),(40.275,3.985),(40.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.305),(40.125,4.455),(40.275,4.455),(40.275,4.305),(40.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.625),(40.125,4.775),(40.275,4.775),(40.275,4.625),(40.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.945),(40.125,5.095),(40.275,5.095),(40.275,4.945),(40.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.265),(40.125,5.415),(40.275,5.415),(40.275,5.265),(40.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.585),(40.125,5.735),(40.275,5.735),(40.275,5.585),(40.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.905),(40.125,6.055),(40.275,6.055),(40.275,5.905),(40.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.225),(40.125,6.375),(40.275,6.375),(40.275,6.225),(40.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.545),(40.125,6.695),(40.275,6.695),(40.275,6.545),(40.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.865),(40.125,7.015),(40.275,7.015),(40.275,6.865),(40.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.185),(40.125,7.335),(40.275,7.335),(40.275,7.185),(40.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.505),(40.125,7.655),(40.275,7.655),(40.275,7.505),(40.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.825),(40.125,7.975),(40.275,7.975),(40.275,7.825),(40.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.145),(40.125,8.295),(40.275,8.295),(40.275,8.145),(40.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.465),(40.125,8.615),(40.275,8.615),(40.275,8.465),(40.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.785),(40.125,8.935),(40.275,8.935),(40.275,8.785),(40.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.105),(40.125,9.255),(40.275,9.255),(40.275,9.105),(40.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.425),(40.125,9.575),(40.275,9.575),(40.275,9.425),(40.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.745),(40.125,9.895),(40.275,9.895),(40.275,9.745),(40.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.065),(40.125,10.215),(40.275,10.215),(40.275,10.065),(40.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.385),(40.125,10.535),(40.275,10.535),(40.275,10.385),(40.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.705),(40.125,10.855),(40.275,10.855),(40.275,10.705),(40.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.025),(40.125,11.175),(40.275,11.175),(40.275,11.025),(40.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.345),(40.125,11.495),(40.275,11.495),(40.275,11.345),(40.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.665),(40.125,11.815),(40.275,11.815),(40.275,11.665),(40.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.985),(40.125,12.135),(40.275,12.135),(40.275,11.985),(40.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.305),(40.125,12.455),(40.275,12.455),(40.275,12.305),(40.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.625),(40.125,12.775),(40.275,12.775),(40.275,12.625),(40.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.945),(40.125,13.095),(40.275,13.095),(40.275,12.945),(40.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.265),(40.125,13.415),(40.275,13.415),(40.275,13.265),(40.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.585),(40.125,13.735),(40.275,13.735),(40.275,13.585),(40.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.905),(40.125,14.055),(40.275,14.055),(40.275,13.905),(40.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.225),(40.125,14.375),(40.275,14.375),(40.275,14.225),(40.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.545),(40.125,14.695),(40.275,14.695),(40.275,14.545),(40.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.865),(40.125,15.015),(40.275,15.015),(40.275,14.865),(40.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.185),(40.125,15.335),(40.275,15.335),(40.275,15.185),(40.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.505),(40.125,15.655),(40.275,15.655),(40.275,15.505),(40.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.825),(40.125,15.975),(40.275,15.975),(40.275,15.825),(40.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.145),(40.125,16.295),(40.275,16.295),(40.275,16.145),(40.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.465),(40.125,16.615),(40.275,16.615),(40.275,16.465),(40.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.785),(40.125,16.935),(40.275,16.935),(40.275,16.785),(40.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.105),(40.125,17.255),(40.275,17.255),(40.275,17.105),(40.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.425),(40.125,17.575),(40.275,17.575),(40.275,17.425),(40.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.745),(40.125,17.895),(40.275,17.895),(40.275,17.745),(40.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.065),(40.125,18.215),(40.275,18.215),(40.275,18.065),(40.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.385),(40.125,18.535),(40.275,18.535),(40.275,18.385),(40.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.705),(40.125,18.855),(40.275,18.855),(40.275,18.705),(40.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.025),(40.125,19.175),(40.275,19.175),(40.275,19.025),(40.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.345),(40.125,19.495),(40.275,19.495),(40.275,19.345),(40.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.665),(40.125,19.815),(40.275,19.815),(40.275,19.665),(40.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.985),(40.125,20.135),(40.275,20.135),(40.275,19.985),(40.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.305),(40.125,20.455),(40.275,20.455),(40.275,20.305),(40.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.625),(40.125,20.775),(40.275,20.775),(40.275,20.625),(40.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.945),(40.125,21.095),(40.275,21.095),(40.275,20.945),(40.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.265),(40.125,21.415),(40.275,21.415),(40.275,21.265),(40.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.585),(40.125,21.735),(40.275,21.735),(40.275,21.585),(40.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.905),(40.125,22.055),(40.275,22.055),(40.275,21.905),(40.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.225),(40.125,22.375),(40.275,22.375),(40.275,22.225),(40.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.545),(40.125,22.695),(40.275,22.695),(40.275,22.545),(40.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.865),(40.125,23.015),(40.275,23.015),(40.275,22.865),(40.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.185),(40.125,23.335),(40.275,23.335),(40.275,23.185),(40.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.505),(40.125,23.655),(40.275,23.655),(40.275,23.505),(40.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.825),(40.125,23.975),(40.275,23.975),(40.275,23.825),(40.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.145),(40.125,24.295),(40.275,24.295),(40.275,24.145),(40.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.465),(40.125,24.615),(40.275,24.615),(40.275,24.465),(40.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.785),(40.125,24.935),(40.275,24.935),(40.275,24.785),(40.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.105),(40.125,25.255),(40.275,25.255),(40.275,25.105),(40.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.425),(40.125,25.575),(40.275,25.575),(40.275,25.425),(40.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.745),(40.125,25.895),(40.275,25.895),(40.275,25.745),(40.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.065),(40.125,26.215),(40.275,26.215),(40.275,26.065),(40.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.385),(40.125,26.535),(40.275,26.535),(40.275,26.385),(40.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.705),(40.125,26.855),(40.275,26.855),(40.275,26.705),(40.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.025),(40.125,27.175),(40.275,27.175),(40.275,27.025),(40.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.345),(40.125,27.495),(40.275,27.495),(40.275,27.345),(40.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.665),(40.125,27.815),(40.275,27.815),(40.275,27.665),(40.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.985),(40.125,28.135),(40.275,28.135),(40.275,27.985),(40.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.305),(40.125,28.455),(40.275,28.455),(40.275,28.305),(40.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.625),(40.125,28.775),(40.275,28.775),(40.275,28.625),(40.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.945),(40.125,29.095),(40.275,29.095),(40.275,28.945),(40.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.265),(40.125,29.415),(40.275,29.415),(40.275,29.265),(40.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.585),(40.125,29.735),(40.275,29.735),(40.275,29.585),(40.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.905),(40.125,30.055),(40.275,30.055),(40.275,29.905),(40.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.225),(40.125,30.375),(40.275,30.375),(40.275,30.225),(40.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.545),(40.125,30.695),(40.275,30.695),(40.275,30.545),(40.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.865),(40.125,31.015),(40.275,31.015),(40.275,30.865),(40.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.185),(40.125,31.335),(40.275,31.335),(40.275,31.185),(40.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.505),(40.125,31.655),(40.275,31.655),(40.275,31.505),(40.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.825),(40.125,31.975),(40.275,31.975),(40.275,31.825),(40.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.145),(40.125,32.295),(40.275,32.295),(40.275,32.145),(40.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.465),(40.125,32.615),(40.275,32.615),(40.275,32.465),(40.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.785),(40.125,32.935),(40.275,32.935),(40.275,32.785),(40.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.105),(40.125,33.255),(40.275,33.255),(40.275,33.105),(40.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.425),(40.125,33.575),(40.275,33.575),(40.275,33.425),(40.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.745),(40.125,33.895),(40.275,33.895),(40.275,33.745),(40.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.065),(40.125,34.215),(40.275,34.215),(40.275,34.065),(40.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.385),(40.125,34.535),(40.275,34.535),(40.275,34.385),(40.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.705),(40.125,34.855),(40.275,34.855),(40.275,34.705),(40.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.025),(40.125,35.175),(40.275,35.175),(40.275,35.025),(40.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.345),(40.125,35.495),(40.275,35.495),(40.275,35.345),(40.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.665),(40.125,35.815),(40.275,35.815),(40.275,35.665),(40.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.985),(40.125,36.135),(40.275,36.135),(40.275,35.985),(40.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.305),(40.125,36.455),(40.275,36.455),(40.275,36.305),(40.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.625),(40.125,36.775),(40.275,36.775),(40.275,36.625),(40.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.945),(40.125,37.095),(40.275,37.095),(40.275,36.945),(40.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.265),(40.125,37.415),(40.275,37.415),(40.275,37.265),(40.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.585),(40.125,37.735),(40.275,37.735),(40.275,37.585),(40.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.905),(40.125,38.055),(40.275,38.055),(40.275,37.905),(40.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.225),(40.125,38.375),(40.275,38.375),(40.275,38.225),(40.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.545),(40.125,38.695),(40.275,38.695),(40.275,38.545),(40.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.865),(40.125,39.015),(40.275,39.015),(40.275,38.865),(40.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.185),(40.125,39.335),(40.275,39.335),(40.275,39.185),(40.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.505),(40.125,39.655),(40.275,39.655),(40.275,39.505),(40.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.825),(40.125,39.975),(40.275,39.975),(40.275,39.825),(40.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.145),(40.125,40.295),(40.275,40.295),(40.275,40.145),(40.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.465),(40.125,40.615),(40.275,40.615),(40.275,40.465),(40.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.785),(40.125,40.935),(40.275,40.935),(40.275,40.785),(40.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.105),(40.125,41.255),(40.275,41.255),(40.275,41.105),(40.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.425),(40.125,41.575),(40.275,41.575),(40.275,41.425),(40.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.745),(40.125,41.895),(40.275,41.895),(40.275,41.745),(40.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.065),(40.125,42.215),(40.275,42.215),(40.275,42.065),(40.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.385),(40.125,42.535),(40.275,42.535),(40.275,42.385),(40.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.705),(40.125,42.855),(40.275,42.855),(40.275,42.705),(40.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,43.025),(40.125,43.175),(40.275,43.175),(40.275,43.025),(40.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,43.345),(40.125,43.495),(40.275,43.495),(40.275,43.345),(40.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.145),(16.125,0.295),(16.275,0.295),(16.275,0.145),(16.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.465),(16.125,0.615),(16.275,0.615),(16.275,0.465),(16.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.785),(16.125,0.935),(16.275,0.935),(16.275,0.785),(16.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.105),(16.125,1.255),(16.275,1.255),(16.275,1.105),(16.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.425),(16.125,1.575),(16.275,1.575),(16.275,1.425),(16.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.745),(16.125,1.895),(16.275,1.895),(16.275,1.745),(16.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.065),(16.125,2.215),(16.275,2.215),(16.275,2.065),(16.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.385),(16.125,2.535),(16.275,2.535),(16.275,2.385),(16.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.705),(16.125,2.855),(16.275,2.855),(16.275,2.705),(16.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.025),(16.125,3.175),(16.275,3.175),(16.275,3.025),(16.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.345),(16.125,3.495),(16.275,3.495),(16.275,3.345),(16.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.665),(16.125,3.815),(16.275,3.815),(16.275,3.665),(16.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.985),(16.125,4.135),(16.275,4.135),(16.275,3.985),(16.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.305),(16.125,4.455),(16.275,4.455),(16.275,4.305),(16.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.625),(16.125,4.775),(16.275,4.775),(16.275,4.625),(16.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.945),(16.125,5.095),(16.275,5.095),(16.275,4.945),(16.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.265),(16.125,5.415),(16.275,5.415),(16.275,5.265),(16.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.585),(16.125,5.735),(16.275,5.735),(16.275,5.585),(16.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.905),(16.125,6.055),(16.275,6.055),(16.275,5.905),(16.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.225),(16.125,6.375),(16.275,6.375),(16.275,6.225),(16.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.545),(16.125,6.695),(16.275,6.695),(16.275,6.545),(16.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.865),(16.125,7.015),(16.275,7.015),(16.275,6.865),(16.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.185),(16.125,7.335),(16.275,7.335),(16.275,7.185),(16.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.505),(16.125,7.655),(16.275,7.655),(16.275,7.505),(16.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.825),(16.125,7.975),(16.275,7.975),(16.275,7.825),(16.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.145),(16.125,8.295),(16.275,8.295),(16.275,8.145),(16.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.465),(16.125,8.615),(16.275,8.615),(16.275,8.465),(16.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.785),(16.125,8.935),(16.275,8.935),(16.275,8.785),(16.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.105),(16.125,9.255),(16.275,9.255),(16.275,9.105),(16.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.425),(16.125,9.575),(16.275,9.575),(16.275,9.425),(16.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.745),(16.125,9.895),(16.275,9.895),(16.275,9.745),(16.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.065),(16.125,10.215),(16.275,10.215),(16.275,10.065),(16.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.385),(16.125,10.535),(16.275,10.535),(16.275,10.385),(16.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.705),(16.125,10.855),(16.275,10.855),(16.275,10.705),(16.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.025),(16.125,11.175),(16.275,11.175),(16.275,11.025),(16.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.345),(16.125,11.495),(16.275,11.495),(16.275,11.345),(16.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.665),(16.125,11.815),(16.275,11.815),(16.275,11.665),(16.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.985),(16.125,12.135),(16.275,12.135),(16.275,11.985),(16.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.305),(16.125,12.455),(16.275,12.455),(16.275,12.305),(16.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.625),(16.125,12.775),(16.275,12.775),(16.275,12.625),(16.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.945),(16.125,13.095),(16.275,13.095),(16.275,12.945),(16.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.265),(16.125,13.415),(16.275,13.415),(16.275,13.265),(16.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.585),(16.125,13.735),(16.275,13.735),(16.275,13.585),(16.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.905),(16.125,14.055),(16.275,14.055),(16.275,13.905),(16.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.225),(16.125,14.375),(16.275,14.375),(16.275,14.225),(16.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.545),(16.125,14.695),(16.275,14.695),(16.275,14.545),(16.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.865),(16.125,15.015),(16.275,15.015),(16.275,14.865),(16.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.185),(16.125,15.335),(16.275,15.335),(16.275,15.185),(16.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.505),(16.125,15.655),(16.275,15.655),(16.275,15.505),(16.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.825),(16.125,15.975),(16.275,15.975),(16.275,15.825),(16.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.145),(16.125,16.295),(16.275,16.295),(16.275,16.145),(16.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.465),(16.125,16.615),(16.275,16.615),(16.275,16.465),(16.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.785),(16.125,16.935),(16.275,16.935),(16.275,16.785),(16.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.105),(16.125,17.255),(16.275,17.255),(16.275,17.105),(16.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.425),(16.125,17.575),(16.275,17.575),(16.275,17.425),(16.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.745),(16.125,17.895),(16.275,17.895),(16.275,17.745),(16.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.065),(16.125,18.215),(16.275,18.215),(16.275,18.065),(16.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.385),(16.125,18.535),(16.275,18.535),(16.275,18.385),(16.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.705),(16.125,18.855),(16.275,18.855),(16.275,18.705),(16.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.025),(16.125,19.175),(16.275,19.175),(16.275,19.025),(16.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.345),(16.125,19.495),(16.275,19.495),(16.275,19.345),(16.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.665),(16.125,19.815),(16.275,19.815),(16.275,19.665),(16.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.985),(16.125,20.135),(16.275,20.135),(16.275,19.985),(16.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.305),(16.125,20.455),(16.275,20.455),(16.275,20.305),(16.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.625),(16.125,20.775),(16.275,20.775),(16.275,20.625),(16.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.945),(16.125,21.095),(16.275,21.095),(16.275,20.945),(16.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.265),(16.125,21.415),(16.275,21.415),(16.275,21.265),(16.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.585),(16.125,21.735),(16.275,21.735),(16.275,21.585),(16.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.905),(16.125,22.055),(16.275,22.055),(16.275,21.905),(16.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,22.225),(16.125,22.375),(16.275,22.375),(16.275,22.225),(16.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,22.545),(16.125,22.695),(16.275,22.695),(16.275,22.545),(16.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,22.865),(16.125,23.015),(16.275,23.015),(16.275,22.865),(16.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,23.185),(16.125,23.335),(16.275,23.335),(16.275,23.185),(16.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,23.505),(16.125,23.655),(16.275,23.655),(16.275,23.505),(16.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,23.825),(16.125,23.975),(16.275,23.975),(16.275,23.825),(16.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,24.145),(16.125,24.295),(16.275,24.295),(16.275,24.145),(16.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,24.465),(16.125,24.615),(16.275,24.615),(16.275,24.465),(16.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,24.785),(16.125,24.935),(16.275,24.935),(16.275,24.785),(16.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,25.105),(16.125,25.255),(16.275,25.255),(16.275,25.105),(16.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,25.425),(16.125,25.575),(16.275,25.575),(16.275,25.425),(16.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,25.745),(16.125,25.895),(16.275,25.895),(16.275,25.745),(16.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,26.065),(16.125,26.215),(16.275,26.215),(16.275,26.065),(16.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,26.385),(16.125,26.535),(16.275,26.535),(16.275,26.385),(16.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,26.705),(16.125,26.855),(16.275,26.855),(16.275,26.705),(16.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.025),(16.125,27.175),(16.275,27.175),(16.275,27.025),(16.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.345),(16.125,27.495),(16.275,27.495),(16.275,27.345),(16.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.665),(16.125,27.815),(16.275,27.815),(16.275,27.665),(16.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.985),(16.125,28.135),(16.275,28.135),(16.275,27.985),(16.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,28.305),(16.125,28.455),(16.275,28.455),(16.275,28.305),(16.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,28.625),(16.125,28.775),(16.275,28.775),(16.275,28.625),(16.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,28.945),(16.125,29.095),(16.275,29.095),(16.275,28.945),(16.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,29.265),(16.125,29.415),(16.275,29.415),(16.275,29.265),(16.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,29.585),(16.125,29.735),(16.275,29.735),(16.275,29.585),(16.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,29.905),(16.125,30.055),(16.275,30.055),(16.275,29.905),(16.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,30.225),(16.125,30.375),(16.275,30.375),(16.275,30.225),(16.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,30.545),(16.125,30.695),(16.275,30.695),(16.275,30.545),(16.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,30.865),(16.125,31.015),(16.275,31.015),(16.275,30.865),(16.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,31.185),(16.125,31.335),(16.275,31.335),(16.275,31.185),(16.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,31.505),(16.125,31.655),(16.275,31.655),(16.275,31.505),(16.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,31.825),(16.125,31.975),(16.275,31.975),(16.275,31.825),(16.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,32.145),(16.125,32.295),(16.275,32.295),(16.275,32.145),(16.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,32.465),(16.125,32.615),(16.275,32.615),(16.275,32.465),(16.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,32.785),(16.125,32.935),(16.275,32.935),(16.275,32.785),(16.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,33.105),(16.125,33.255),(16.275,33.255),(16.275,33.105),(16.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,33.425),(16.125,33.575),(16.275,33.575),(16.275,33.425),(16.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,33.745),(16.125,33.895),(16.275,33.895),(16.275,33.745),(16.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,34.065),(16.125,34.215),(16.275,34.215),(16.275,34.065),(16.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,34.385),(16.125,34.535),(16.275,34.535),(16.275,34.385),(16.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,34.705),(16.125,34.855),(16.275,34.855),(16.275,34.705),(16.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.025),(16.125,35.175),(16.275,35.175),(16.275,35.025),(16.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.345),(16.125,35.495),(16.275,35.495),(16.275,35.345),(16.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.665),(16.125,35.815),(16.275,35.815),(16.275,35.665),(16.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.985),(16.125,36.135),(16.275,36.135),(16.275,35.985),(16.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,36.305),(16.125,36.455),(16.275,36.455),(16.275,36.305),(16.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,36.625),(16.125,36.775),(16.275,36.775),(16.275,36.625),(16.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,36.945),(16.125,37.095),(16.275,37.095),(16.275,36.945),(16.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,37.265),(16.125,37.415),(16.275,37.415),(16.275,37.265),(16.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,37.585),(16.125,37.735),(16.275,37.735),(16.275,37.585),(16.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,37.905),(16.125,38.055),(16.275,38.055),(16.275,37.905),(16.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,38.225),(16.125,38.375),(16.275,38.375),(16.275,38.225),(16.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,38.545),(16.125,38.695),(16.275,38.695),(16.275,38.545),(16.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,38.865),(16.125,39.015),(16.275,39.015),(16.275,38.865),(16.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,39.185),(16.125,39.335),(16.275,39.335),(16.275,39.185),(16.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,39.505),(16.125,39.655),(16.275,39.655),(16.275,39.505),(16.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,39.825),(16.125,39.975),(16.275,39.975),(16.275,39.825),(16.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,40.145),(16.125,40.295),(16.275,40.295),(16.275,40.145),(16.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,40.465),(16.125,40.615),(16.275,40.615),(16.275,40.465),(16.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,40.785),(16.125,40.935),(16.275,40.935),(16.275,40.785),(16.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,41.105),(16.125,41.255),(16.275,41.255),(16.275,41.105),(16.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,41.425),(16.125,41.575),(16.275,41.575),(16.275,41.425),(16.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,41.745),(16.125,41.895),(16.275,41.895),(16.275,41.745),(16.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,42.065),(16.125,42.215),(16.275,42.215),(16.275,42.065),(16.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,42.385),(16.125,42.535),(16.275,42.535),(16.275,42.385),(16.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,42.705),(16.125,42.855),(16.275,42.855),(16.275,42.705),(16.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,43.025),(16.125,43.175),(16.275,43.175),(16.275,43.025),(16.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,43.345),(16.125,43.495),(16.275,43.495),(16.275,43.345),(16.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.145),(83.07,0.295),(83.22,0.295),(83.22,0.145),(83.07,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.465),(83.07,0.615),(83.22,0.615),(83.22,0.465),(83.07,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.785),(83.07,0.935),(83.22,0.935),(83.22,0.785),(83.07,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.105),(83.07,1.255),(83.22,1.255),(83.22,1.105),(83.07,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.425),(83.07,1.575),(83.22,1.575),(83.22,1.425),(83.07,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.745),(83.07,1.895),(83.22,1.895),(83.22,1.745),(83.07,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.065),(83.07,2.215),(83.22,2.215),(83.22,2.065),(83.07,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.385),(83.07,2.535),(83.22,2.535),(83.22,2.385),(83.07,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.705),(83.07,2.855),(83.22,2.855),(83.22,2.705),(83.07,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.025),(83.07,3.175),(83.22,3.175),(83.22,3.025),(83.07,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.345),(83.07,3.495),(83.22,3.495),(83.22,3.345),(83.07,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.665),(83.07,3.815),(83.22,3.815),(83.22,3.665),(83.07,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.985),(83.07,4.135),(83.22,4.135),(83.22,3.985),(83.07,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.305),(83.07,4.455),(83.22,4.455),(83.22,4.305),(83.07,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.625),(83.07,4.775),(83.22,4.775),(83.22,4.625),(83.07,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.945),(83.07,5.095),(83.22,5.095),(83.22,4.945),(83.07,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.265),(83.07,5.415),(83.22,5.415),(83.22,5.265),(83.07,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.585),(83.07,5.735),(83.22,5.735),(83.22,5.585),(83.07,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.905),(83.07,6.055),(83.22,6.055),(83.22,5.905),(83.07,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.225),(83.07,6.375),(83.22,6.375),(83.22,6.225),(83.07,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.545),(83.07,6.695),(83.22,6.695),(83.22,6.545),(83.07,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.865),(83.07,7.015),(83.22,7.015),(83.22,6.865),(83.07,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.185),(83.07,7.335),(83.22,7.335),(83.22,7.185),(83.07,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.505),(83.07,7.655),(83.22,7.655),(83.22,7.505),(83.07,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.825),(83.07,7.975),(83.22,7.975),(83.22,7.825),(83.07,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.145),(83.07,8.295),(83.22,8.295),(83.22,8.145),(83.07,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.465),(83.07,8.615),(83.22,8.615),(83.22,8.465),(83.07,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.785),(83.07,8.935),(83.22,8.935),(83.22,8.785),(83.07,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.105),(83.07,9.255),(83.22,9.255),(83.22,9.105),(83.07,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.425),(83.07,9.575),(83.22,9.575),(83.22,9.425),(83.07,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.745),(83.07,9.895),(83.22,9.895),(83.22,9.745),(83.07,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.065),(83.07,10.215),(83.22,10.215),(83.22,10.065),(83.07,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.385),(83.07,10.535),(83.22,10.535),(83.22,10.385),(83.07,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.705),(83.07,10.855),(83.22,10.855),(83.22,10.705),(83.07,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.025),(83.07,11.175),(83.22,11.175),(83.22,11.025),(83.07,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.345),(83.07,11.495),(83.22,11.495),(83.22,11.345),(83.07,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.665),(83.07,11.815),(83.22,11.815),(83.22,11.665),(83.07,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.985),(83.07,12.135),(83.22,12.135),(83.22,11.985),(83.07,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.305),(83.07,12.455),(83.22,12.455),(83.22,12.305),(83.07,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.625),(83.07,12.775),(83.22,12.775),(83.22,12.625),(83.07,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.945),(83.07,13.095),(83.22,13.095),(83.22,12.945),(83.07,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.265),(83.07,13.415),(83.22,13.415),(83.22,13.265),(83.07,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.585),(83.07,13.735),(83.22,13.735),(83.22,13.585),(83.07,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.905),(83.07,14.055),(83.22,14.055),(83.22,13.905),(83.07,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.225),(83.07,14.375),(83.22,14.375),(83.22,14.225),(83.07,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.545),(83.07,14.695),(83.22,14.695),(83.22,14.545),(83.07,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.865),(83.07,15.015),(83.22,15.015),(83.22,14.865),(83.07,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.185),(83.07,15.335),(83.22,15.335),(83.22,15.185),(83.07,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.505),(83.07,15.655),(83.22,15.655),(83.22,15.505),(83.07,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.825),(83.07,15.975),(83.22,15.975),(83.22,15.825),(83.07,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.145),(83.07,16.295),(83.22,16.295),(83.22,16.145),(83.07,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.465),(83.07,16.615),(83.22,16.615),(83.22,16.465),(83.07,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.785),(83.07,16.935),(83.22,16.935),(83.22,16.785),(83.07,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.105),(83.07,17.255),(83.22,17.255),(83.22,17.105),(83.07,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.425),(83.07,17.575),(83.22,17.575),(83.22,17.425),(83.07,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.745),(83.07,17.895),(83.22,17.895),(83.22,17.745),(83.07,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.065),(83.07,18.215),(83.22,18.215),(83.22,18.065),(83.07,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.385),(83.07,18.535),(83.22,18.535),(83.22,18.385),(83.07,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.705),(83.07,18.855),(83.22,18.855),(83.22,18.705),(83.07,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.025),(83.07,19.175),(83.22,19.175),(83.22,19.025),(83.07,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.345),(83.07,19.495),(83.22,19.495),(83.22,19.345),(83.07,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.665),(83.07,19.815),(83.22,19.815),(83.22,19.665),(83.07,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.985),(83.07,20.135),(83.22,20.135),(83.22,19.985),(83.07,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.305),(83.07,20.455),(83.22,20.455),(83.22,20.305),(83.07,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.625),(83.07,20.775),(83.22,20.775),(83.22,20.625),(83.07,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.945),(83.07,21.095),(83.22,21.095),(83.22,20.945),(83.07,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.265),(83.07,21.415),(83.22,21.415),(83.22,21.265),(83.07,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.585),(83.07,21.735),(83.22,21.735),(83.22,21.585),(83.07,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.905),(83.07,22.055),(83.22,22.055),(83.22,21.905),(83.07,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,22.225),(83.07,22.375),(83.22,22.375),(83.22,22.225),(83.07,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,22.545),(83.07,22.695),(83.22,22.695),(83.22,22.545),(83.07,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,22.865),(83.07,23.015),(83.22,23.015),(83.22,22.865),(83.07,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,23.185),(83.07,23.335),(83.22,23.335),(83.22,23.185),(83.07,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,23.505),(83.07,23.655),(83.22,23.655),(83.22,23.505),(83.07,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,23.825),(83.07,23.975),(83.22,23.975),(83.22,23.825),(83.07,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,24.145),(83.07,24.295),(83.22,24.295),(83.22,24.145),(83.07,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,24.465),(83.07,24.615),(83.22,24.615),(83.22,24.465),(83.07,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,24.785),(83.07,24.935),(83.22,24.935),(83.22,24.785),(83.07,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,25.105),(83.07,25.255),(83.22,25.255),(83.22,25.105),(83.07,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,25.425),(83.07,25.575),(83.22,25.575),(83.22,25.425),(83.07,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,25.745),(83.07,25.895),(83.22,25.895),(83.22,25.745),(83.07,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,26.065),(83.07,26.215),(83.22,26.215),(83.22,26.065),(83.07,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,26.385),(83.07,26.535),(83.22,26.535),(83.22,26.385),(83.07,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,26.705),(83.07,26.855),(83.22,26.855),(83.22,26.705),(83.07,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.025),(83.07,27.175),(83.22,27.175),(83.22,27.025),(83.07,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.345),(83.07,27.495),(83.22,27.495),(83.22,27.345),(83.07,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.665),(83.07,27.815),(83.22,27.815),(83.22,27.665),(83.07,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.985),(83.07,28.135),(83.22,28.135),(83.22,27.985),(83.07,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,28.305),(83.07,28.455),(83.22,28.455),(83.22,28.305),(83.07,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,28.625),(83.07,28.775),(83.22,28.775),(83.22,28.625),(83.07,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,28.945),(83.07,29.095),(83.22,29.095),(83.22,28.945),(83.07,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,29.265),(83.07,29.415),(83.22,29.415),(83.22,29.265),(83.07,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,29.585),(83.07,29.735),(83.22,29.735),(83.22,29.585),(83.07,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,29.905),(83.07,30.055),(83.22,30.055),(83.22,29.905),(83.07,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,30.225),(83.07,30.375),(83.22,30.375),(83.22,30.225),(83.07,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,30.545),(83.07,30.695),(83.22,30.695),(83.22,30.545),(83.07,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,30.865),(83.07,31.015),(83.22,31.015),(83.22,30.865),(83.07,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,31.185),(83.07,31.335),(83.22,31.335),(83.22,31.185),(83.07,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,31.505),(83.07,31.655),(83.22,31.655),(83.22,31.505),(83.07,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,31.825),(83.07,31.975),(83.22,31.975),(83.22,31.825),(83.07,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,32.145),(83.07,32.295),(83.22,32.295),(83.22,32.145),(83.07,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,32.465),(83.07,32.615),(83.22,32.615),(83.22,32.465),(83.07,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,32.785),(83.07,32.935),(83.22,32.935),(83.22,32.785),(83.07,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,33.105),(83.07,33.255),(83.22,33.255),(83.22,33.105),(83.07,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,33.425),(83.07,33.575),(83.22,33.575),(83.22,33.425),(83.07,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,33.745),(83.07,33.895),(83.22,33.895),(83.22,33.745),(83.07,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,34.065),(83.07,34.215),(83.22,34.215),(83.22,34.065),(83.07,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,34.385),(83.07,34.535),(83.22,34.535),(83.22,34.385),(83.07,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,34.705),(83.07,34.855),(83.22,34.855),(83.22,34.705),(83.07,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.025),(83.07,35.175),(83.22,35.175),(83.22,35.025),(83.07,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.345),(83.07,35.495),(83.22,35.495),(83.22,35.345),(83.07,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.665),(83.07,35.815),(83.22,35.815),(83.22,35.665),(83.07,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.985),(83.07,36.135),(83.22,36.135),(83.22,35.985),(83.07,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,36.305),(83.07,36.455),(83.22,36.455),(83.22,36.305),(83.07,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,36.625),(83.07,36.775),(83.22,36.775),(83.22,36.625),(83.07,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,36.945),(83.07,37.095),(83.22,37.095),(83.22,36.945),(83.07,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,37.265),(83.07,37.415),(83.22,37.415),(83.22,37.265),(83.07,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,37.585),(83.07,37.735),(83.22,37.735),(83.22,37.585),(83.07,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,37.905),(83.07,38.055),(83.22,38.055),(83.22,37.905),(83.07,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,38.225),(83.07,38.375),(83.22,38.375),(83.22,38.225),(83.07,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,38.545),(83.07,38.695),(83.22,38.695),(83.22,38.545),(83.07,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,38.865),(83.07,39.015),(83.22,39.015),(83.22,38.865),(83.07,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,39.185),(83.07,39.335),(83.22,39.335),(83.22,39.185),(83.07,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,39.505),(83.07,39.655),(83.22,39.655),(83.22,39.505),(83.07,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,39.825),(83.07,39.975),(83.22,39.975),(83.22,39.825),(83.07,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,40.145),(83.07,40.295),(83.22,40.295),(83.22,40.145),(83.07,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,40.465),(83.07,40.615),(83.22,40.615),(83.22,40.465),(83.07,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,40.785),(83.07,40.935),(83.22,40.935),(83.22,40.785),(83.07,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,41.105),(83.07,41.255),(83.22,41.255),(83.22,41.105),(83.07,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,41.425),(83.07,41.575),(83.22,41.575),(83.22,41.425),(83.07,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,41.745),(83.07,41.895),(83.22,41.895),(83.22,41.745),(83.07,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,42.065),(83.07,42.215),(83.22,42.215),(83.22,42.065),(83.07,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,42.385),(83.07,42.535),(83.22,42.535),(83.22,42.385),(83.07,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,42.705),(83.07,42.855),(83.22,42.855),(83.22,42.705),(83.07,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,43.025),(83.07,43.175),(83.22,43.175),(83.22,43.025),(83.07,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,43.345),(83.07,43.495),(83.22,43.495),(83.22,43.345),(83.07,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.145),(73.725,0.295),(73.875,0.295),(73.875,0.145),(73.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.465),(73.725,0.615),(73.875,0.615),(73.875,0.465),(73.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.785),(73.725,0.935),(73.875,0.935),(73.875,0.785),(73.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.105),(73.725,1.255),(73.875,1.255),(73.875,1.105),(73.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.425),(73.725,1.575),(73.875,1.575),(73.875,1.425),(73.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.745),(73.725,1.895),(73.875,1.895),(73.875,1.745),(73.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.065),(73.725,2.215),(73.875,2.215),(73.875,2.065),(73.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.385),(73.725,2.535),(73.875,2.535),(73.875,2.385),(73.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.705),(73.725,2.855),(73.875,2.855),(73.875,2.705),(73.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.025),(73.725,3.175),(73.875,3.175),(73.875,3.025),(73.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.345),(73.725,3.495),(73.875,3.495),(73.875,3.345),(73.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.665),(73.725,3.815),(73.875,3.815),(73.875,3.665),(73.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.985),(73.725,4.135),(73.875,4.135),(73.875,3.985),(73.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.305),(73.725,4.455),(73.875,4.455),(73.875,4.305),(73.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.625),(73.725,4.775),(73.875,4.775),(73.875,4.625),(73.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.945),(73.725,5.095),(73.875,5.095),(73.875,4.945),(73.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.265),(73.725,5.415),(73.875,5.415),(73.875,5.265),(73.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.585),(73.725,5.735),(73.875,5.735),(73.875,5.585),(73.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.905),(73.725,6.055),(73.875,6.055),(73.875,5.905),(73.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.225),(73.725,6.375),(73.875,6.375),(73.875,6.225),(73.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.545),(73.725,6.695),(73.875,6.695),(73.875,6.545),(73.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.865),(73.725,7.015),(73.875,7.015),(73.875,6.865),(73.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.185),(73.725,7.335),(73.875,7.335),(73.875,7.185),(73.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.505),(73.725,7.655),(73.875,7.655),(73.875,7.505),(73.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.825),(73.725,7.975),(73.875,7.975),(73.875,7.825),(73.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.145),(73.725,8.295),(73.875,8.295),(73.875,8.145),(73.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.465),(73.725,8.615),(73.875,8.615),(73.875,8.465),(73.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.785),(73.725,8.935),(73.875,8.935),(73.875,8.785),(73.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.105),(73.725,9.255),(73.875,9.255),(73.875,9.105),(73.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.425),(73.725,9.575),(73.875,9.575),(73.875,9.425),(73.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.745),(73.725,9.895),(73.875,9.895),(73.875,9.745),(73.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.065),(73.725,10.215),(73.875,10.215),(73.875,10.065),(73.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.385),(73.725,10.535),(73.875,10.535),(73.875,10.385),(73.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.705),(73.725,10.855),(73.875,10.855),(73.875,10.705),(73.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.025),(73.725,11.175),(73.875,11.175),(73.875,11.025),(73.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.345),(73.725,11.495),(73.875,11.495),(73.875,11.345),(73.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.665),(73.725,11.815),(73.875,11.815),(73.875,11.665),(73.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.985),(73.725,12.135),(73.875,12.135),(73.875,11.985),(73.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.305),(73.725,12.455),(73.875,12.455),(73.875,12.305),(73.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.625),(73.725,12.775),(73.875,12.775),(73.875,12.625),(73.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.945),(73.725,13.095),(73.875,13.095),(73.875,12.945),(73.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.265),(73.725,13.415),(73.875,13.415),(73.875,13.265),(73.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.585),(73.725,13.735),(73.875,13.735),(73.875,13.585),(73.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.905),(73.725,14.055),(73.875,14.055),(73.875,13.905),(73.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.225),(73.725,14.375),(73.875,14.375),(73.875,14.225),(73.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.545),(73.725,14.695),(73.875,14.695),(73.875,14.545),(73.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.865),(73.725,15.015),(73.875,15.015),(73.875,14.865),(73.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.185),(73.725,15.335),(73.875,15.335),(73.875,15.185),(73.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.505),(73.725,15.655),(73.875,15.655),(73.875,15.505),(73.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.825),(73.725,15.975),(73.875,15.975),(73.875,15.825),(73.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.145),(73.725,16.295),(73.875,16.295),(73.875,16.145),(73.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.465),(73.725,16.615),(73.875,16.615),(73.875,16.465),(73.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.785),(73.725,16.935),(73.875,16.935),(73.875,16.785),(73.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.105),(73.725,17.255),(73.875,17.255),(73.875,17.105),(73.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.425),(73.725,17.575),(73.875,17.575),(73.875,17.425),(73.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.745),(73.725,17.895),(73.875,17.895),(73.875,17.745),(73.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.065),(73.725,18.215),(73.875,18.215),(73.875,18.065),(73.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.385),(73.725,18.535),(73.875,18.535),(73.875,18.385),(73.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.705),(73.725,18.855),(73.875,18.855),(73.875,18.705),(73.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.025),(73.725,19.175),(73.875,19.175),(73.875,19.025),(73.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.345),(73.725,19.495),(73.875,19.495),(73.875,19.345),(73.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.665),(73.725,19.815),(73.875,19.815),(73.875,19.665),(73.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.985),(73.725,20.135),(73.875,20.135),(73.875,19.985),(73.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.305),(73.725,20.455),(73.875,20.455),(73.875,20.305),(73.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.625),(73.725,20.775),(73.875,20.775),(73.875,20.625),(73.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.945),(73.725,21.095),(73.875,21.095),(73.875,20.945),(73.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.265),(73.725,21.415),(73.875,21.415),(73.875,21.265),(73.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.585),(73.725,21.735),(73.875,21.735),(73.875,21.585),(73.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.905),(73.725,22.055),(73.875,22.055),(73.875,21.905),(73.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,22.225),(73.725,22.375),(73.875,22.375),(73.875,22.225),(73.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,22.545),(73.725,22.695),(73.875,22.695),(73.875,22.545),(73.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,22.865),(73.725,23.015),(73.875,23.015),(73.875,22.865),(73.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,23.185),(73.725,23.335),(73.875,23.335),(73.875,23.185),(73.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,23.505),(73.725,23.655),(73.875,23.655),(73.875,23.505),(73.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,23.825),(73.725,23.975),(73.875,23.975),(73.875,23.825),(73.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,24.145),(73.725,24.295),(73.875,24.295),(73.875,24.145),(73.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,24.465),(73.725,24.615),(73.875,24.615),(73.875,24.465),(73.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,24.785),(73.725,24.935),(73.875,24.935),(73.875,24.785),(73.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,25.105),(73.725,25.255),(73.875,25.255),(73.875,25.105),(73.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,25.425),(73.725,25.575),(73.875,25.575),(73.875,25.425),(73.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,25.745),(73.725,25.895),(73.875,25.895),(73.875,25.745),(73.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,26.065),(73.725,26.215),(73.875,26.215),(73.875,26.065),(73.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,26.385),(73.725,26.535),(73.875,26.535),(73.875,26.385),(73.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,26.705),(73.725,26.855),(73.875,26.855),(73.875,26.705),(73.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.025),(73.725,27.175),(73.875,27.175),(73.875,27.025),(73.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.345),(73.725,27.495),(73.875,27.495),(73.875,27.345),(73.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.665),(73.725,27.815),(73.875,27.815),(73.875,27.665),(73.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.985),(73.725,28.135),(73.875,28.135),(73.875,27.985),(73.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,28.305),(73.725,28.455),(73.875,28.455),(73.875,28.305),(73.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,28.625),(73.725,28.775),(73.875,28.775),(73.875,28.625),(73.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,28.945),(73.725,29.095),(73.875,29.095),(73.875,28.945),(73.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,29.265),(73.725,29.415),(73.875,29.415),(73.875,29.265),(73.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,29.585),(73.725,29.735),(73.875,29.735),(73.875,29.585),(73.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,29.905),(73.725,30.055),(73.875,30.055),(73.875,29.905),(73.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,30.225),(73.725,30.375),(73.875,30.375),(73.875,30.225),(73.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,30.545),(73.725,30.695),(73.875,30.695),(73.875,30.545),(73.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,30.865),(73.725,31.015),(73.875,31.015),(73.875,30.865),(73.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,31.185),(73.725,31.335),(73.875,31.335),(73.875,31.185),(73.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,31.505),(73.725,31.655),(73.875,31.655),(73.875,31.505),(73.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,31.825),(73.725,31.975),(73.875,31.975),(73.875,31.825),(73.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,32.145),(73.725,32.295),(73.875,32.295),(73.875,32.145),(73.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,32.465),(73.725,32.615),(73.875,32.615),(73.875,32.465),(73.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,32.785),(73.725,32.935),(73.875,32.935),(73.875,32.785),(73.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,33.105),(73.725,33.255),(73.875,33.255),(73.875,33.105),(73.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,33.425),(73.725,33.575),(73.875,33.575),(73.875,33.425),(73.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,33.745),(73.725,33.895),(73.875,33.895),(73.875,33.745),(73.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,34.065),(73.725,34.215),(73.875,34.215),(73.875,34.065),(73.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,34.385),(73.725,34.535),(73.875,34.535),(73.875,34.385),(73.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,34.705),(73.725,34.855),(73.875,34.855),(73.875,34.705),(73.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.025),(73.725,35.175),(73.875,35.175),(73.875,35.025),(73.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.345),(73.725,35.495),(73.875,35.495),(73.875,35.345),(73.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.665),(73.725,35.815),(73.875,35.815),(73.875,35.665),(73.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.985),(73.725,36.135),(73.875,36.135),(73.875,35.985),(73.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,36.305),(73.725,36.455),(73.875,36.455),(73.875,36.305),(73.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,36.625),(73.725,36.775),(73.875,36.775),(73.875,36.625),(73.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,36.945),(73.725,37.095),(73.875,37.095),(73.875,36.945),(73.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,37.265),(73.725,37.415),(73.875,37.415),(73.875,37.265),(73.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,37.585),(73.725,37.735),(73.875,37.735),(73.875,37.585),(73.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,37.905),(73.725,38.055),(73.875,38.055),(73.875,37.905),(73.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,38.225),(73.725,38.375),(73.875,38.375),(73.875,38.225),(73.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,38.545),(73.725,38.695),(73.875,38.695),(73.875,38.545),(73.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,38.865),(73.725,39.015),(73.875,39.015),(73.875,38.865),(73.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,39.185),(73.725,39.335),(73.875,39.335),(73.875,39.185),(73.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,39.505),(73.725,39.655),(73.875,39.655),(73.875,39.505),(73.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,39.825),(73.725,39.975),(73.875,39.975),(73.875,39.825),(73.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,40.145),(73.725,40.295),(73.875,40.295),(73.875,40.145),(73.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,40.465),(73.725,40.615),(73.875,40.615),(73.875,40.465),(73.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,40.785),(73.725,40.935),(73.875,40.935),(73.875,40.785),(73.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,41.105),(73.725,41.255),(73.875,41.255),(73.875,41.105),(73.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,41.425),(73.725,41.575),(73.875,41.575),(73.875,41.425),(73.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,41.745),(73.725,41.895),(73.875,41.895),(73.875,41.745),(73.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,42.065),(73.725,42.215),(73.875,42.215),(73.875,42.065),(73.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,42.385),(73.725,42.535),(73.875,42.535),(73.875,42.385),(73.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,42.705),(73.725,42.855),(73.875,42.855),(73.875,42.705),(73.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,43.025),(73.725,43.175),(73.875,43.175),(73.875,43.025),(73.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,43.345),(73.725,43.495),(73.875,43.495),(73.875,43.345),(73.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.145),(59.325,0.295),(59.475,0.295),(59.475,0.145),(59.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.465),(59.325,0.615),(59.475,0.615),(59.475,0.465),(59.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.785),(59.325,0.935),(59.475,0.935),(59.475,0.785),(59.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.105),(59.325,1.255),(59.475,1.255),(59.475,1.105),(59.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.425),(59.325,1.575),(59.475,1.575),(59.475,1.425),(59.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.745),(59.325,1.895),(59.475,1.895),(59.475,1.745),(59.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.065),(59.325,2.215),(59.475,2.215),(59.475,2.065),(59.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.385),(59.325,2.535),(59.475,2.535),(59.475,2.385),(59.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.705),(59.325,2.855),(59.475,2.855),(59.475,2.705),(59.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.025),(59.325,3.175),(59.475,3.175),(59.475,3.025),(59.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.345),(59.325,3.495),(59.475,3.495),(59.475,3.345),(59.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.665),(59.325,3.815),(59.475,3.815),(59.475,3.665),(59.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.985),(59.325,4.135),(59.475,4.135),(59.475,3.985),(59.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.305),(59.325,4.455),(59.475,4.455),(59.475,4.305),(59.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.625),(59.325,4.775),(59.475,4.775),(59.475,4.625),(59.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.945),(59.325,5.095),(59.475,5.095),(59.475,4.945),(59.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.265),(59.325,5.415),(59.475,5.415),(59.475,5.265),(59.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.585),(59.325,5.735),(59.475,5.735),(59.475,5.585),(59.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.905),(59.325,6.055),(59.475,6.055),(59.475,5.905),(59.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.225),(59.325,6.375),(59.475,6.375),(59.475,6.225),(59.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.545),(59.325,6.695),(59.475,6.695),(59.475,6.545),(59.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.865),(59.325,7.015),(59.475,7.015),(59.475,6.865),(59.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.185),(59.325,7.335),(59.475,7.335),(59.475,7.185),(59.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.505),(59.325,7.655),(59.475,7.655),(59.475,7.505),(59.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.825),(59.325,7.975),(59.475,7.975),(59.475,7.825),(59.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.145),(59.325,8.295),(59.475,8.295),(59.475,8.145),(59.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.465),(59.325,8.615),(59.475,8.615),(59.475,8.465),(59.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.785),(59.325,8.935),(59.475,8.935),(59.475,8.785),(59.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.105),(59.325,9.255),(59.475,9.255),(59.475,9.105),(59.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.425),(59.325,9.575),(59.475,9.575),(59.475,9.425),(59.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.745),(59.325,9.895),(59.475,9.895),(59.475,9.745),(59.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.065),(59.325,10.215),(59.475,10.215),(59.475,10.065),(59.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.385),(59.325,10.535),(59.475,10.535),(59.475,10.385),(59.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.705),(59.325,10.855),(59.475,10.855),(59.475,10.705),(59.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.025),(59.325,11.175),(59.475,11.175),(59.475,11.025),(59.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.345),(59.325,11.495),(59.475,11.495),(59.475,11.345),(59.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.665),(59.325,11.815),(59.475,11.815),(59.475,11.665),(59.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.985),(59.325,12.135),(59.475,12.135),(59.475,11.985),(59.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.305),(59.325,12.455),(59.475,12.455),(59.475,12.305),(59.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.625),(59.325,12.775),(59.475,12.775),(59.475,12.625),(59.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.945),(59.325,13.095),(59.475,13.095),(59.475,12.945),(59.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.265),(59.325,13.415),(59.475,13.415),(59.475,13.265),(59.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.585),(59.325,13.735),(59.475,13.735),(59.475,13.585),(59.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.905),(59.325,14.055),(59.475,14.055),(59.475,13.905),(59.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.225),(59.325,14.375),(59.475,14.375),(59.475,14.225),(59.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.545),(59.325,14.695),(59.475,14.695),(59.475,14.545),(59.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.865),(59.325,15.015),(59.475,15.015),(59.475,14.865),(59.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.185),(59.325,15.335),(59.475,15.335),(59.475,15.185),(59.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.505),(59.325,15.655),(59.475,15.655),(59.475,15.505),(59.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.825),(59.325,15.975),(59.475,15.975),(59.475,15.825),(59.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.145),(59.325,16.295),(59.475,16.295),(59.475,16.145),(59.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.465),(59.325,16.615),(59.475,16.615),(59.475,16.465),(59.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.785),(59.325,16.935),(59.475,16.935),(59.475,16.785),(59.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.105),(59.325,17.255),(59.475,17.255),(59.475,17.105),(59.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.425),(59.325,17.575),(59.475,17.575),(59.475,17.425),(59.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.745),(59.325,17.895),(59.475,17.895),(59.475,17.745),(59.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.065),(59.325,18.215),(59.475,18.215),(59.475,18.065),(59.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.385),(59.325,18.535),(59.475,18.535),(59.475,18.385),(59.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.705),(59.325,18.855),(59.475,18.855),(59.475,18.705),(59.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.025),(59.325,19.175),(59.475,19.175),(59.475,19.025),(59.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.345),(59.325,19.495),(59.475,19.495),(59.475,19.345),(59.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.665),(59.325,19.815),(59.475,19.815),(59.475,19.665),(59.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.985),(59.325,20.135),(59.475,20.135),(59.475,19.985),(59.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.305),(59.325,20.455),(59.475,20.455),(59.475,20.305),(59.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.625),(59.325,20.775),(59.475,20.775),(59.475,20.625),(59.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.945),(59.325,21.095),(59.475,21.095),(59.475,20.945),(59.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.265),(59.325,21.415),(59.475,21.415),(59.475,21.265),(59.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.585),(59.325,21.735),(59.475,21.735),(59.475,21.585),(59.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.905),(59.325,22.055),(59.475,22.055),(59.475,21.905),(59.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,22.225),(59.325,22.375),(59.475,22.375),(59.475,22.225),(59.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,22.545),(59.325,22.695),(59.475,22.695),(59.475,22.545),(59.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,22.865),(59.325,23.015),(59.475,23.015),(59.475,22.865),(59.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,23.185),(59.325,23.335),(59.475,23.335),(59.475,23.185),(59.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,23.505),(59.325,23.655),(59.475,23.655),(59.475,23.505),(59.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,23.825),(59.325,23.975),(59.475,23.975),(59.475,23.825),(59.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,24.145),(59.325,24.295),(59.475,24.295),(59.475,24.145),(59.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,24.465),(59.325,24.615),(59.475,24.615),(59.475,24.465),(59.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,24.785),(59.325,24.935),(59.475,24.935),(59.475,24.785),(59.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,25.105),(59.325,25.255),(59.475,25.255),(59.475,25.105),(59.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,25.425),(59.325,25.575),(59.475,25.575),(59.475,25.425),(59.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,25.745),(59.325,25.895),(59.475,25.895),(59.475,25.745),(59.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,26.065),(59.325,26.215),(59.475,26.215),(59.475,26.065),(59.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,26.385),(59.325,26.535),(59.475,26.535),(59.475,26.385),(59.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,26.705),(59.325,26.855),(59.475,26.855),(59.475,26.705),(59.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.025),(59.325,27.175),(59.475,27.175),(59.475,27.025),(59.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.345),(59.325,27.495),(59.475,27.495),(59.475,27.345),(59.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.665),(59.325,27.815),(59.475,27.815),(59.475,27.665),(59.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.985),(59.325,28.135),(59.475,28.135),(59.475,27.985),(59.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,28.305),(59.325,28.455),(59.475,28.455),(59.475,28.305),(59.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,28.625),(59.325,28.775),(59.475,28.775),(59.475,28.625),(59.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,28.945),(59.325,29.095),(59.475,29.095),(59.475,28.945),(59.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,29.265),(59.325,29.415),(59.475,29.415),(59.475,29.265),(59.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,29.585),(59.325,29.735),(59.475,29.735),(59.475,29.585),(59.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,29.905),(59.325,30.055),(59.475,30.055),(59.475,29.905),(59.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,30.225),(59.325,30.375),(59.475,30.375),(59.475,30.225),(59.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,30.545),(59.325,30.695),(59.475,30.695),(59.475,30.545),(59.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,30.865),(59.325,31.015),(59.475,31.015),(59.475,30.865),(59.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,31.185),(59.325,31.335),(59.475,31.335),(59.475,31.185),(59.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,31.505),(59.325,31.655),(59.475,31.655),(59.475,31.505),(59.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,31.825),(59.325,31.975),(59.475,31.975),(59.475,31.825),(59.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,32.145),(59.325,32.295),(59.475,32.295),(59.475,32.145),(59.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,32.465),(59.325,32.615),(59.475,32.615),(59.475,32.465),(59.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,32.785),(59.325,32.935),(59.475,32.935),(59.475,32.785),(59.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,33.105),(59.325,33.255),(59.475,33.255),(59.475,33.105),(59.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,33.425),(59.325,33.575),(59.475,33.575),(59.475,33.425),(59.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,33.745),(59.325,33.895),(59.475,33.895),(59.475,33.745),(59.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,34.065),(59.325,34.215),(59.475,34.215),(59.475,34.065),(59.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,34.385),(59.325,34.535),(59.475,34.535),(59.475,34.385),(59.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,34.705),(59.325,34.855),(59.475,34.855),(59.475,34.705),(59.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.025),(59.325,35.175),(59.475,35.175),(59.475,35.025),(59.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.345),(59.325,35.495),(59.475,35.495),(59.475,35.345),(59.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.665),(59.325,35.815),(59.475,35.815),(59.475,35.665),(59.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.985),(59.325,36.135),(59.475,36.135),(59.475,35.985),(59.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,36.305),(59.325,36.455),(59.475,36.455),(59.475,36.305),(59.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,36.625),(59.325,36.775),(59.475,36.775),(59.475,36.625),(59.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,36.945),(59.325,37.095),(59.475,37.095),(59.475,36.945),(59.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,37.265),(59.325,37.415),(59.475,37.415),(59.475,37.265),(59.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,37.585),(59.325,37.735),(59.475,37.735),(59.475,37.585),(59.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,37.905),(59.325,38.055),(59.475,38.055),(59.475,37.905),(59.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,38.225),(59.325,38.375),(59.475,38.375),(59.475,38.225),(59.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,38.545),(59.325,38.695),(59.475,38.695),(59.475,38.545),(59.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,38.865),(59.325,39.015),(59.475,39.015),(59.475,38.865),(59.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,39.185),(59.325,39.335),(59.475,39.335),(59.475,39.185),(59.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,39.505),(59.325,39.655),(59.475,39.655),(59.475,39.505),(59.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,39.825),(59.325,39.975),(59.475,39.975),(59.475,39.825),(59.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,40.145),(59.325,40.295),(59.475,40.295),(59.475,40.145),(59.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,40.465),(59.325,40.615),(59.475,40.615),(59.475,40.465),(59.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,40.785),(59.325,40.935),(59.475,40.935),(59.475,40.785),(59.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,41.105),(59.325,41.255),(59.475,41.255),(59.475,41.105),(59.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,41.425),(59.325,41.575),(59.475,41.575),(59.475,41.425),(59.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,41.745),(59.325,41.895),(59.475,41.895),(59.475,41.745),(59.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,42.065),(59.325,42.215),(59.475,42.215),(59.475,42.065),(59.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,42.385),(59.325,42.535),(59.475,42.535),(59.475,42.385),(59.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,42.705),(59.325,42.855),(59.475,42.855),(59.475,42.705),(59.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,43.025),(59.325,43.175),(59.475,43.175),(59.475,43.025),(59.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,43.345),(59.325,43.495),(59.475,43.495),(59.475,43.345),(59.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.145),(20.925,0.295),(21.075,0.295),(21.075,0.145),(20.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.465),(20.925,0.615),(21.075,0.615),(21.075,0.465),(20.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.785),(20.925,0.935),(21.075,0.935),(21.075,0.785),(20.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.105),(20.925,1.255),(21.075,1.255),(21.075,1.105),(20.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.425),(20.925,1.575),(21.075,1.575),(21.075,1.425),(20.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.745),(20.925,1.895),(21.075,1.895),(21.075,1.745),(20.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.065),(20.925,2.215),(21.075,2.215),(21.075,2.065),(20.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.385),(20.925,2.535),(21.075,2.535),(21.075,2.385),(20.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.705),(20.925,2.855),(21.075,2.855),(21.075,2.705),(20.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.025),(20.925,3.175),(21.075,3.175),(21.075,3.025),(20.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.345),(20.925,3.495),(21.075,3.495),(21.075,3.345),(20.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.665),(20.925,3.815),(21.075,3.815),(21.075,3.665),(20.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.985),(20.925,4.135),(21.075,4.135),(21.075,3.985),(20.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.305),(20.925,4.455),(21.075,4.455),(21.075,4.305),(20.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.625),(20.925,4.775),(21.075,4.775),(21.075,4.625),(20.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.945),(20.925,5.095),(21.075,5.095),(21.075,4.945),(20.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.265),(20.925,5.415),(21.075,5.415),(21.075,5.265),(20.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.585),(20.925,5.735),(21.075,5.735),(21.075,5.585),(20.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.905),(20.925,6.055),(21.075,6.055),(21.075,5.905),(20.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.225),(20.925,6.375),(21.075,6.375),(21.075,6.225),(20.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.545),(20.925,6.695),(21.075,6.695),(21.075,6.545),(20.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.865),(20.925,7.015),(21.075,7.015),(21.075,6.865),(20.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.185),(20.925,7.335),(21.075,7.335),(21.075,7.185),(20.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.505),(20.925,7.655),(21.075,7.655),(21.075,7.505),(20.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.825),(20.925,7.975),(21.075,7.975),(21.075,7.825),(20.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.145),(20.925,8.295),(21.075,8.295),(21.075,8.145),(20.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.465),(20.925,8.615),(21.075,8.615),(21.075,8.465),(20.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.785),(20.925,8.935),(21.075,8.935),(21.075,8.785),(20.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.105),(20.925,9.255),(21.075,9.255),(21.075,9.105),(20.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.425),(20.925,9.575),(21.075,9.575),(21.075,9.425),(20.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.745),(20.925,9.895),(21.075,9.895),(21.075,9.745),(20.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.065),(20.925,10.215),(21.075,10.215),(21.075,10.065),(20.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.385),(20.925,10.535),(21.075,10.535),(21.075,10.385),(20.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.705),(20.925,10.855),(21.075,10.855),(21.075,10.705),(20.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.025),(20.925,11.175),(21.075,11.175),(21.075,11.025),(20.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.345),(20.925,11.495),(21.075,11.495),(21.075,11.345),(20.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.665),(20.925,11.815),(21.075,11.815),(21.075,11.665),(20.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.985),(20.925,12.135),(21.075,12.135),(21.075,11.985),(20.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.305),(20.925,12.455),(21.075,12.455),(21.075,12.305),(20.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.625),(20.925,12.775),(21.075,12.775),(21.075,12.625),(20.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.945),(20.925,13.095),(21.075,13.095),(21.075,12.945),(20.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.265),(20.925,13.415),(21.075,13.415),(21.075,13.265),(20.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.585),(20.925,13.735),(21.075,13.735),(21.075,13.585),(20.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.905),(20.925,14.055),(21.075,14.055),(21.075,13.905),(20.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.225),(20.925,14.375),(21.075,14.375),(21.075,14.225),(20.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.545),(20.925,14.695),(21.075,14.695),(21.075,14.545),(20.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.865),(20.925,15.015),(21.075,15.015),(21.075,14.865),(20.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.185),(20.925,15.335),(21.075,15.335),(21.075,15.185),(20.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.505),(20.925,15.655),(21.075,15.655),(21.075,15.505),(20.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.825),(20.925,15.975),(21.075,15.975),(21.075,15.825),(20.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.145),(20.925,16.295),(21.075,16.295),(21.075,16.145),(20.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.465),(20.925,16.615),(21.075,16.615),(21.075,16.465),(20.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.785),(20.925,16.935),(21.075,16.935),(21.075,16.785),(20.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.105),(20.925,17.255),(21.075,17.255),(21.075,17.105),(20.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.425),(20.925,17.575),(21.075,17.575),(21.075,17.425),(20.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.745),(20.925,17.895),(21.075,17.895),(21.075,17.745),(20.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.065),(20.925,18.215),(21.075,18.215),(21.075,18.065),(20.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.385),(20.925,18.535),(21.075,18.535),(21.075,18.385),(20.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.705),(20.925,18.855),(21.075,18.855),(21.075,18.705),(20.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.025),(20.925,19.175),(21.075,19.175),(21.075,19.025),(20.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.345),(20.925,19.495),(21.075,19.495),(21.075,19.345),(20.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.665),(20.925,19.815),(21.075,19.815),(21.075,19.665),(20.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.985),(20.925,20.135),(21.075,20.135),(21.075,19.985),(20.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.305),(20.925,20.455),(21.075,20.455),(21.075,20.305),(20.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.625),(20.925,20.775),(21.075,20.775),(21.075,20.625),(20.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.945),(20.925,21.095),(21.075,21.095),(21.075,20.945),(20.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.265),(20.925,21.415),(21.075,21.415),(21.075,21.265),(20.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.585),(20.925,21.735),(21.075,21.735),(21.075,21.585),(20.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.905),(20.925,22.055),(21.075,22.055),(21.075,21.905),(20.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,22.225),(20.925,22.375),(21.075,22.375),(21.075,22.225),(20.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,22.545),(20.925,22.695),(21.075,22.695),(21.075,22.545),(20.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,22.865),(20.925,23.015),(21.075,23.015),(21.075,22.865),(20.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,23.185),(20.925,23.335),(21.075,23.335),(21.075,23.185),(20.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,23.505),(20.925,23.655),(21.075,23.655),(21.075,23.505),(20.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,23.825),(20.925,23.975),(21.075,23.975),(21.075,23.825),(20.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,24.145),(20.925,24.295),(21.075,24.295),(21.075,24.145),(20.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,24.465),(20.925,24.615),(21.075,24.615),(21.075,24.465),(20.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,24.785),(20.925,24.935),(21.075,24.935),(21.075,24.785),(20.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,25.105),(20.925,25.255),(21.075,25.255),(21.075,25.105),(20.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,25.425),(20.925,25.575),(21.075,25.575),(21.075,25.425),(20.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,25.745),(20.925,25.895),(21.075,25.895),(21.075,25.745),(20.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,26.065),(20.925,26.215),(21.075,26.215),(21.075,26.065),(20.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,26.385),(20.925,26.535),(21.075,26.535),(21.075,26.385),(20.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,26.705),(20.925,26.855),(21.075,26.855),(21.075,26.705),(20.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.025),(20.925,27.175),(21.075,27.175),(21.075,27.025),(20.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.345),(20.925,27.495),(21.075,27.495),(21.075,27.345),(20.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.665),(20.925,27.815),(21.075,27.815),(21.075,27.665),(20.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.985),(20.925,28.135),(21.075,28.135),(21.075,27.985),(20.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,28.305),(20.925,28.455),(21.075,28.455),(21.075,28.305),(20.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,28.625),(20.925,28.775),(21.075,28.775),(21.075,28.625),(20.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,28.945),(20.925,29.095),(21.075,29.095),(21.075,28.945),(20.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,29.265),(20.925,29.415),(21.075,29.415),(21.075,29.265),(20.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,29.585),(20.925,29.735),(21.075,29.735),(21.075,29.585),(20.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,29.905),(20.925,30.055),(21.075,30.055),(21.075,29.905),(20.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,30.225),(20.925,30.375),(21.075,30.375),(21.075,30.225),(20.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,30.545),(20.925,30.695),(21.075,30.695),(21.075,30.545),(20.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,30.865),(20.925,31.015),(21.075,31.015),(21.075,30.865),(20.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,31.185),(20.925,31.335),(21.075,31.335),(21.075,31.185),(20.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,31.505),(20.925,31.655),(21.075,31.655),(21.075,31.505),(20.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,31.825),(20.925,31.975),(21.075,31.975),(21.075,31.825),(20.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,32.145),(20.925,32.295),(21.075,32.295),(21.075,32.145),(20.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,32.465),(20.925,32.615),(21.075,32.615),(21.075,32.465),(20.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,32.785),(20.925,32.935),(21.075,32.935),(21.075,32.785),(20.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,33.105),(20.925,33.255),(21.075,33.255),(21.075,33.105),(20.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,33.425),(20.925,33.575),(21.075,33.575),(21.075,33.425),(20.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,33.745),(20.925,33.895),(21.075,33.895),(21.075,33.745),(20.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,34.065),(20.925,34.215),(21.075,34.215),(21.075,34.065),(20.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,34.385),(20.925,34.535),(21.075,34.535),(21.075,34.385),(20.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,34.705),(20.925,34.855),(21.075,34.855),(21.075,34.705),(20.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.025),(20.925,35.175),(21.075,35.175),(21.075,35.025),(20.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.345),(20.925,35.495),(21.075,35.495),(21.075,35.345),(20.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.665),(20.925,35.815),(21.075,35.815),(21.075,35.665),(20.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.985),(20.925,36.135),(21.075,36.135),(21.075,35.985),(20.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,36.305),(20.925,36.455),(21.075,36.455),(21.075,36.305),(20.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,36.625),(20.925,36.775),(21.075,36.775),(21.075,36.625),(20.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,36.945),(20.925,37.095),(21.075,37.095),(21.075,36.945),(20.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,37.265),(20.925,37.415),(21.075,37.415),(21.075,37.265),(20.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,37.585),(20.925,37.735),(21.075,37.735),(21.075,37.585),(20.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,37.905),(20.925,38.055),(21.075,38.055),(21.075,37.905),(20.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,38.225),(20.925,38.375),(21.075,38.375),(21.075,38.225),(20.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,38.545),(20.925,38.695),(21.075,38.695),(21.075,38.545),(20.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,38.865),(20.925,39.015),(21.075,39.015),(21.075,38.865),(20.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,39.185),(20.925,39.335),(21.075,39.335),(21.075,39.185),(20.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,39.505),(20.925,39.655),(21.075,39.655),(21.075,39.505),(20.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,39.825),(20.925,39.975),(21.075,39.975),(21.075,39.825),(20.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,40.145),(20.925,40.295),(21.075,40.295),(21.075,40.145),(20.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,40.465),(20.925,40.615),(21.075,40.615),(21.075,40.465),(20.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,40.785),(20.925,40.935),(21.075,40.935),(21.075,40.785),(20.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,41.105),(20.925,41.255),(21.075,41.255),(21.075,41.105),(20.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,41.425),(20.925,41.575),(21.075,41.575),(21.075,41.425),(20.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,41.745),(20.925,41.895),(21.075,41.895),(21.075,41.745),(20.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,42.065),(20.925,42.215),(21.075,42.215),(21.075,42.065),(20.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,42.385),(20.925,42.535),(21.075,42.535),(21.075,42.385),(20.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,42.705),(20.925,42.855),(21.075,42.855),(21.075,42.705),(20.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,43.025),(20.925,43.175),(21.075,43.175),(21.075,43.025),(20.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,43.345),(20.925,43.495),(21.075,43.495),(21.075,43.345),(20.925,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.145),(6.78,0.295),(6.93,0.295),(6.93,0.145),(6.78,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.465),(6.78,0.615),(6.93,0.615),(6.93,0.465),(6.78,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.785),(6.78,0.935),(6.93,0.935),(6.93,0.785),(6.78,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.105),(6.78,1.255),(6.93,1.255),(6.93,1.105),(6.78,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.425),(6.78,1.575),(6.93,1.575),(6.93,1.425),(6.78,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.745),(6.78,1.895),(6.93,1.895),(6.93,1.745),(6.78,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.065),(6.78,2.215),(6.93,2.215),(6.93,2.065),(6.78,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.385),(6.78,2.535),(6.93,2.535),(6.93,2.385),(6.78,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.705),(6.78,2.855),(6.93,2.855),(6.93,2.705),(6.78,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.025),(6.78,3.175),(6.93,3.175),(6.93,3.025),(6.78,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.345),(6.78,3.495),(6.93,3.495),(6.93,3.345),(6.78,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.665),(6.78,3.815),(6.93,3.815),(6.93,3.665),(6.78,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.985),(6.78,4.135),(6.93,4.135),(6.93,3.985),(6.78,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.305),(6.78,4.455),(6.93,4.455),(6.93,4.305),(6.78,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.625),(6.78,4.775),(6.93,4.775),(6.93,4.625),(6.78,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.945),(6.78,5.095),(6.93,5.095),(6.93,4.945),(6.78,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.265),(6.78,5.415),(6.93,5.415),(6.93,5.265),(6.78,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.585),(6.78,5.735),(6.93,5.735),(6.93,5.585),(6.78,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.905),(6.78,6.055),(6.93,6.055),(6.93,5.905),(6.78,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.225),(6.78,6.375),(6.93,6.375),(6.93,6.225),(6.78,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.545),(6.78,6.695),(6.93,6.695),(6.93,6.545),(6.78,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.865),(6.78,7.015),(6.93,7.015),(6.93,6.865),(6.78,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.185),(6.78,7.335),(6.93,7.335),(6.93,7.185),(6.78,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.505),(6.78,7.655),(6.93,7.655),(6.93,7.505),(6.78,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.825),(6.78,7.975),(6.93,7.975),(6.93,7.825),(6.78,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.145),(6.78,8.295),(6.93,8.295),(6.93,8.145),(6.78,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.465),(6.78,8.615),(6.93,8.615),(6.93,8.465),(6.78,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.785),(6.78,8.935),(6.93,8.935),(6.93,8.785),(6.78,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.105),(6.78,9.255),(6.93,9.255),(6.93,9.105),(6.78,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.425),(6.78,9.575),(6.93,9.575),(6.93,9.425),(6.78,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.745),(6.78,9.895),(6.93,9.895),(6.93,9.745),(6.78,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.065),(6.78,10.215),(6.93,10.215),(6.93,10.065),(6.78,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.385),(6.78,10.535),(6.93,10.535),(6.93,10.385),(6.78,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.705),(6.78,10.855),(6.93,10.855),(6.93,10.705),(6.78,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.025),(6.78,11.175),(6.93,11.175),(6.93,11.025),(6.78,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.345),(6.78,11.495),(6.93,11.495),(6.93,11.345),(6.78,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.665),(6.78,11.815),(6.93,11.815),(6.93,11.665),(6.78,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.985),(6.78,12.135),(6.93,12.135),(6.93,11.985),(6.78,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.305),(6.78,12.455),(6.93,12.455),(6.93,12.305),(6.78,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.625),(6.78,12.775),(6.93,12.775),(6.93,12.625),(6.78,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.945),(6.78,13.095),(6.93,13.095),(6.93,12.945),(6.78,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.265),(6.78,13.415),(6.93,13.415),(6.93,13.265),(6.78,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.585),(6.78,13.735),(6.93,13.735),(6.93,13.585),(6.78,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.905),(6.78,14.055),(6.93,14.055),(6.93,13.905),(6.78,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.225),(6.78,14.375),(6.93,14.375),(6.93,14.225),(6.78,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.545),(6.78,14.695),(6.93,14.695),(6.93,14.545),(6.78,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.865),(6.78,15.015),(6.93,15.015),(6.93,14.865),(6.78,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.185),(6.78,15.335),(6.93,15.335),(6.93,15.185),(6.78,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.505),(6.78,15.655),(6.93,15.655),(6.93,15.505),(6.78,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.825),(6.78,15.975),(6.93,15.975),(6.93,15.825),(6.78,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.145),(6.78,16.295),(6.93,16.295),(6.93,16.145),(6.78,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.465),(6.78,16.615),(6.93,16.615),(6.93,16.465),(6.78,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.785),(6.78,16.935),(6.93,16.935),(6.93,16.785),(6.78,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.105),(6.78,17.255),(6.93,17.255),(6.93,17.105),(6.78,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.425),(6.78,17.575),(6.93,17.575),(6.93,17.425),(6.78,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.745),(6.78,17.895),(6.93,17.895),(6.93,17.745),(6.78,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.065),(6.78,18.215),(6.93,18.215),(6.93,18.065),(6.78,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.385),(6.78,18.535),(6.93,18.535),(6.93,18.385),(6.78,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.705),(6.78,18.855),(6.93,18.855),(6.93,18.705),(6.78,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.025),(6.78,19.175),(6.93,19.175),(6.93,19.025),(6.78,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.345),(6.78,19.495),(6.93,19.495),(6.93,19.345),(6.78,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.665),(6.78,19.815),(6.93,19.815),(6.93,19.665),(6.78,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.985),(6.78,20.135),(6.93,20.135),(6.93,19.985),(6.78,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.305),(6.78,20.455),(6.93,20.455),(6.93,20.305),(6.78,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.625),(6.78,20.775),(6.93,20.775),(6.93,20.625),(6.78,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.945),(6.78,21.095),(6.93,21.095),(6.93,20.945),(6.78,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.265),(6.78,21.415),(6.93,21.415),(6.93,21.265),(6.78,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.585),(6.78,21.735),(6.93,21.735),(6.93,21.585),(6.78,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.905),(6.78,22.055),(6.93,22.055),(6.93,21.905),(6.78,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,22.225),(6.78,22.375),(6.93,22.375),(6.93,22.225),(6.78,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,22.545),(6.78,22.695),(6.93,22.695),(6.93,22.545),(6.78,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,22.865),(6.78,23.015),(6.93,23.015),(6.93,22.865),(6.78,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,23.185),(6.78,23.335),(6.93,23.335),(6.93,23.185),(6.78,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,23.505),(6.78,23.655),(6.93,23.655),(6.93,23.505),(6.78,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,23.825),(6.78,23.975),(6.93,23.975),(6.93,23.825),(6.78,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,24.145),(6.78,24.295),(6.93,24.295),(6.93,24.145),(6.78,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,24.465),(6.78,24.615),(6.93,24.615),(6.93,24.465),(6.78,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,24.785),(6.78,24.935),(6.93,24.935),(6.93,24.785),(6.78,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,25.105),(6.78,25.255),(6.93,25.255),(6.93,25.105),(6.78,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,25.425),(6.78,25.575),(6.93,25.575),(6.93,25.425),(6.78,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,25.745),(6.78,25.895),(6.93,25.895),(6.93,25.745),(6.78,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,26.065),(6.78,26.215),(6.93,26.215),(6.93,26.065),(6.78,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,26.385),(6.78,26.535),(6.93,26.535),(6.93,26.385),(6.78,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,26.705),(6.78,26.855),(6.93,26.855),(6.93,26.705),(6.78,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.025),(6.78,27.175),(6.93,27.175),(6.93,27.025),(6.78,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.345),(6.78,27.495),(6.93,27.495),(6.93,27.345),(6.78,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.665),(6.78,27.815),(6.93,27.815),(6.93,27.665),(6.78,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.985),(6.78,28.135),(6.93,28.135),(6.93,27.985),(6.78,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,28.305),(6.78,28.455),(6.93,28.455),(6.93,28.305),(6.78,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,28.625),(6.78,28.775),(6.93,28.775),(6.93,28.625),(6.78,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,28.945),(6.78,29.095),(6.93,29.095),(6.93,28.945),(6.78,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,29.265),(6.78,29.415),(6.93,29.415),(6.93,29.265),(6.78,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,29.585),(6.78,29.735),(6.93,29.735),(6.93,29.585),(6.78,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,29.905),(6.78,30.055),(6.93,30.055),(6.93,29.905),(6.78,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,30.225),(6.78,30.375),(6.93,30.375),(6.93,30.225),(6.78,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,30.545),(6.78,30.695),(6.93,30.695),(6.93,30.545),(6.78,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,30.865),(6.78,31.015),(6.93,31.015),(6.93,30.865),(6.78,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,31.185),(6.78,31.335),(6.93,31.335),(6.93,31.185),(6.78,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,31.505),(6.78,31.655),(6.93,31.655),(6.93,31.505),(6.78,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,31.825),(6.78,31.975),(6.93,31.975),(6.93,31.825),(6.78,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,32.145),(6.78,32.295),(6.93,32.295),(6.93,32.145),(6.78,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,32.465),(6.78,32.615),(6.93,32.615),(6.93,32.465),(6.78,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,32.785),(6.78,32.935),(6.93,32.935),(6.93,32.785),(6.78,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,33.105),(6.78,33.255),(6.93,33.255),(6.93,33.105),(6.78,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,33.425),(6.78,33.575),(6.93,33.575),(6.93,33.425),(6.78,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,33.745),(6.78,33.895),(6.93,33.895),(6.93,33.745),(6.78,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,34.065),(6.78,34.215),(6.93,34.215),(6.93,34.065),(6.78,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,34.385),(6.78,34.535),(6.93,34.535),(6.93,34.385),(6.78,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,34.705),(6.78,34.855),(6.93,34.855),(6.93,34.705),(6.78,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.025),(6.78,35.175),(6.93,35.175),(6.93,35.025),(6.78,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.345),(6.78,35.495),(6.93,35.495),(6.93,35.345),(6.78,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.665),(6.78,35.815),(6.93,35.815),(6.93,35.665),(6.78,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.985),(6.78,36.135),(6.93,36.135),(6.93,35.985),(6.78,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,36.305),(6.78,36.455),(6.93,36.455),(6.93,36.305),(6.78,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,36.625),(6.78,36.775),(6.93,36.775),(6.93,36.625),(6.78,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,36.945),(6.78,37.095),(6.93,37.095),(6.93,36.945),(6.78,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,37.265),(6.78,37.415),(6.93,37.415),(6.93,37.265),(6.78,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,37.585),(6.78,37.735),(6.93,37.735),(6.93,37.585),(6.78,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,37.905),(6.78,38.055),(6.93,38.055),(6.93,37.905),(6.78,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,38.225),(6.78,38.375),(6.93,38.375),(6.93,38.225),(6.78,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,38.545),(6.78,38.695),(6.93,38.695),(6.93,38.545),(6.78,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,38.865),(6.78,39.015),(6.93,39.015),(6.93,38.865),(6.78,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,39.185),(6.78,39.335),(6.93,39.335),(6.93,39.185),(6.78,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,39.505),(6.78,39.655),(6.93,39.655),(6.93,39.505),(6.78,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,39.825),(6.78,39.975),(6.93,39.975),(6.93,39.825),(6.78,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,40.145),(6.78,40.295),(6.93,40.295),(6.93,40.145),(6.78,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,40.465),(6.78,40.615),(6.93,40.615),(6.93,40.465),(6.78,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,40.785),(6.78,40.935),(6.93,40.935),(6.93,40.785),(6.78,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,41.105),(6.78,41.255),(6.93,41.255),(6.93,41.105),(6.78,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,41.425),(6.78,41.575),(6.93,41.575),(6.93,41.425),(6.78,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,41.745),(6.78,41.895),(6.93,41.895),(6.93,41.745),(6.78,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,42.065),(6.78,42.215),(6.93,42.215),(6.93,42.065),(6.78,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,42.385),(6.78,42.535),(6.93,42.535),(6.93,42.385),(6.78,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,42.705),(6.78,42.855),(6.93,42.855),(6.93,42.705),(6.78,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,43.025),(6.78,43.175),(6.93,43.175),(6.93,43.025),(6.78,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,43.345),(6.78,43.495),(6.93,43.495),(6.93,43.345),(6.78,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.145),(30.525,0.295),(30.675,0.295),(30.675,0.145),(30.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.465),(30.525,0.615),(30.675,0.615),(30.675,0.465),(30.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.785),(30.525,0.935),(30.675,0.935),(30.675,0.785),(30.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.105),(30.525,1.255),(30.675,1.255),(30.675,1.105),(30.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.425),(30.525,1.575),(30.675,1.575),(30.675,1.425),(30.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.745),(30.525,1.895),(30.675,1.895),(30.675,1.745),(30.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.065),(30.525,2.215),(30.675,2.215),(30.675,2.065),(30.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.385),(30.525,2.535),(30.675,2.535),(30.675,2.385),(30.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.705),(30.525,2.855),(30.675,2.855),(30.675,2.705),(30.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.025),(30.525,3.175),(30.675,3.175),(30.675,3.025),(30.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.345),(30.525,3.495),(30.675,3.495),(30.675,3.345),(30.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.665),(30.525,3.815),(30.675,3.815),(30.675,3.665),(30.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.985),(30.525,4.135),(30.675,4.135),(30.675,3.985),(30.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.305),(30.525,4.455),(30.675,4.455),(30.675,4.305),(30.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.625),(30.525,4.775),(30.675,4.775),(30.675,4.625),(30.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.945),(30.525,5.095),(30.675,5.095),(30.675,4.945),(30.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.265),(30.525,5.415),(30.675,5.415),(30.675,5.265),(30.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.585),(30.525,5.735),(30.675,5.735),(30.675,5.585),(30.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.905),(30.525,6.055),(30.675,6.055),(30.675,5.905),(30.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.225),(30.525,6.375),(30.675,6.375),(30.675,6.225),(30.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.545),(30.525,6.695),(30.675,6.695),(30.675,6.545),(30.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.865),(30.525,7.015),(30.675,7.015),(30.675,6.865),(30.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.185),(30.525,7.335),(30.675,7.335),(30.675,7.185),(30.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.505),(30.525,7.655),(30.675,7.655),(30.675,7.505),(30.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.825),(30.525,7.975),(30.675,7.975),(30.675,7.825),(30.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.145),(30.525,8.295),(30.675,8.295),(30.675,8.145),(30.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.465),(30.525,8.615),(30.675,8.615),(30.675,8.465),(30.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.785),(30.525,8.935),(30.675,8.935),(30.675,8.785),(30.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.105),(30.525,9.255),(30.675,9.255),(30.675,9.105),(30.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.425),(30.525,9.575),(30.675,9.575),(30.675,9.425),(30.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.745),(30.525,9.895),(30.675,9.895),(30.675,9.745),(30.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.065),(30.525,10.215),(30.675,10.215),(30.675,10.065),(30.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.385),(30.525,10.535),(30.675,10.535),(30.675,10.385),(30.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.705),(30.525,10.855),(30.675,10.855),(30.675,10.705),(30.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.025),(30.525,11.175),(30.675,11.175),(30.675,11.025),(30.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.345),(30.525,11.495),(30.675,11.495),(30.675,11.345),(30.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.665),(30.525,11.815),(30.675,11.815),(30.675,11.665),(30.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.985),(30.525,12.135),(30.675,12.135),(30.675,11.985),(30.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.305),(30.525,12.455),(30.675,12.455),(30.675,12.305),(30.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.625),(30.525,12.775),(30.675,12.775),(30.675,12.625),(30.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.945),(30.525,13.095),(30.675,13.095),(30.675,12.945),(30.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.265),(30.525,13.415),(30.675,13.415),(30.675,13.265),(30.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.585),(30.525,13.735),(30.675,13.735),(30.675,13.585),(30.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.905),(30.525,14.055),(30.675,14.055),(30.675,13.905),(30.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.225),(30.525,14.375),(30.675,14.375),(30.675,14.225),(30.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.545),(30.525,14.695),(30.675,14.695),(30.675,14.545),(30.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.865),(30.525,15.015),(30.675,15.015),(30.675,14.865),(30.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.185),(30.525,15.335),(30.675,15.335),(30.675,15.185),(30.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.505),(30.525,15.655),(30.675,15.655),(30.675,15.505),(30.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.825),(30.525,15.975),(30.675,15.975),(30.675,15.825),(30.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.145),(30.525,16.295),(30.675,16.295),(30.675,16.145),(30.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.465),(30.525,16.615),(30.675,16.615),(30.675,16.465),(30.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.785),(30.525,16.935),(30.675,16.935),(30.675,16.785),(30.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.105),(30.525,17.255),(30.675,17.255),(30.675,17.105),(30.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.425),(30.525,17.575),(30.675,17.575),(30.675,17.425),(30.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.745),(30.525,17.895),(30.675,17.895),(30.675,17.745),(30.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.065),(30.525,18.215),(30.675,18.215),(30.675,18.065),(30.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.385),(30.525,18.535),(30.675,18.535),(30.675,18.385),(30.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.705),(30.525,18.855),(30.675,18.855),(30.675,18.705),(30.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.025),(30.525,19.175),(30.675,19.175),(30.675,19.025),(30.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.345),(30.525,19.495),(30.675,19.495),(30.675,19.345),(30.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.665),(30.525,19.815),(30.675,19.815),(30.675,19.665),(30.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.985),(30.525,20.135),(30.675,20.135),(30.675,19.985),(30.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.305),(30.525,20.455),(30.675,20.455),(30.675,20.305),(30.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.625),(30.525,20.775),(30.675,20.775),(30.675,20.625),(30.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.945),(30.525,21.095),(30.675,21.095),(30.675,20.945),(30.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.265),(30.525,21.415),(30.675,21.415),(30.675,21.265),(30.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.585),(30.525,21.735),(30.675,21.735),(30.675,21.585),(30.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.905),(30.525,22.055),(30.675,22.055),(30.675,21.905),(30.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,22.225),(30.525,22.375),(30.675,22.375),(30.675,22.225),(30.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,22.545),(30.525,22.695),(30.675,22.695),(30.675,22.545),(30.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,22.865),(30.525,23.015),(30.675,23.015),(30.675,22.865),(30.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,23.185),(30.525,23.335),(30.675,23.335),(30.675,23.185),(30.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,23.505),(30.525,23.655),(30.675,23.655),(30.675,23.505),(30.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,23.825),(30.525,23.975),(30.675,23.975),(30.675,23.825),(30.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,24.145),(30.525,24.295),(30.675,24.295),(30.675,24.145),(30.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,24.465),(30.525,24.615),(30.675,24.615),(30.675,24.465),(30.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,24.785),(30.525,24.935),(30.675,24.935),(30.675,24.785),(30.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,25.105),(30.525,25.255),(30.675,25.255),(30.675,25.105),(30.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,25.425),(30.525,25.575),(30.675,25.575),(30.675,25.425),(30.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,25.745),(30.525,25.895),(30.675,25.895),(30.675,25.745),(30.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,26.065),(30.525,26.215),(30.675,26.215),(30.675,26.065),(30.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,26.385),(30.525,26.535),(30.675,26.535),(30.675,26.385),(30.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,26.705),(30.525,26.855),(30.675,26.855),(30.675,26.705),(30.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.025),(30.525,27.175),(30.675,27.175),(30.675,27.025),(30.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.345),(30.525,27.495),(30.675,27.495),(30.675,27.345),(30.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.665),(30.525,27.815),(30.675,27.815),(30.675,27.665),(30.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.985),(30.525,28.135),(30.675,28.135),(30.675,27.985),(30.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,28.305),(30.525,28.455),(30.675,28.455),(30.675,28.305),(30.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,28.625),(30.525,28.775),(30.675,28.775),(30.675,28.625),(30.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,28.945),(30.525,29.095),(30.675,29.095),(30.675,28.945),(30.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,29.265),(30.525,29.415),(30.675,29.415),(30.675,29.265),(30.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,29.585),(30.525,29.735),(30.675,29.735),(30.675,29.585),(30.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,29.905),(30.525,30.055),(30.675,30.055),(30.675,29.905),(30.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,30.225),(30.525,30.375),(30.675,30.375),(30.675,30.225),(30.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,30.545),(30.525,30.695),(30.675,30.695),(30.675,30.545),(30.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,30.865),(30.525,31.015),(30.675,31.015),(30.675,30.865),(30.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,31.185),(30.525,31.335),(30.675,31.335),(30.675,31.185),(30.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,31.505),(30.525,31.655),(30.675,31.655),(30.675,31.505),(30.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,31.825),(30.525,31.975),(30.675,31.975),(30.675,31.825),(30.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,32.145),(30.525,32.295),(30.675,32.295),(30.675,32.145),(30.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,32.465),(30.525,32.615),(30.675,32.615),(30.675,32.465),(30.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,32.785),(30.525,32.935),(30.675,32.935),(30.675,32.785),(30.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,33.105),(30.525,33.255),(30.675,33.255),(30.675,33.105),(30.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,33.425),(30.525,33.575),(30.675,33.575),(30.675,33.425),(30.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,33.745),(30.525,33.895),(30.675,33.895),(30.675,33.745),(30.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,34.065),(30.525,34.215),(30.675,34.215),(30.675,34.065),(30.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,34.385),(30.525,34.535),(30.675,34.535),(30.675,34.385),(30.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,34.705),(30.525,34.855),(30.675,34.855),(30.675,34.705),(30.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.025),(30.525,35.175),(30.675,35.175),(30.675,35.025),(30.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.345),(30.525,35.495),(30.675,35.495),(30.675,35.345),(30.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.665),(30.525,35.815),(30.675,35.815),(30.675,35.665),(30.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.985),(30.525,36.135),(30.675,36.135),(30.675,35.985),(30.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,36.305),(30.525,36.455),(30.675,36.455),(30.675,36.305),(30.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,36.625),(30.525,36.775),(30.675,36.775),(30.675,36.625),(30.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,36.945),(30.525,37.095),(30.675,37.095),(30.675,36.945),(30.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,37.265),(30.525,37.415),(30.675,37.415),(30.675,37.265),(30.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,37.585),(30.525,37.735),(30.675,37.735),(30.675,37.585),(30.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,37.905),(30.525,38.055),(30.675,38.055),(30.675,37.905),(30.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,38.225),(30.525,38.375),(30.675,38.375),(30.675,38.225),(30.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,38.545),(30.525,38.695),(30.675,38.695),(30.675,38.545),(30.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,38.865),(30.525,39.015),(30.675,39.015),(30.675,38.865),(30.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,39.185),(30.525,39.335),(30.675,39.335),(30.675,39.185),(30.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,39.505),(30.525,39.655),(30.675,39.655),(30.675,39.505),(30.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,39.825),(30.525,39.975),(30.675,39.975),(30.675,39.825),(30.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,40.145),(30.525,40.295),(30.675,40.295),(30.675,40.145),(30.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,40.465),(30.525,40.615),(30.675,40.615),(30.675,40.465),(30.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,40.785),(30.525,40.935),(30.675,40.935),(30.675,40.785),(30.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,41.105),(30.525,41.255),(30.675,41.255),(30.675,41.105),(30.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,41.425),(30.525,41.575),(30.675,41.575),(30.675,41.425),(30.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,41.745),(30.525,41.895),(30.675,41.895),(30.675,41.745),(30.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,42.065),(30.525,42.215),(30.675,42.215),(30.675,42.065),(30.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,42.385),(30.525,42.535),(30.675,42.535),(30.675,42.385),(30.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,42.705),(30.525,42.855),(30.675,42.855),(30.675,42.705),(30.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,43.025),(30.525,43.175),(30.675,43.175),(30.675,43.025),(30.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,43.345),(30.525,43.495),(30.675,43.495),(30.675,43.345),(30.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.145),(54.525,0.295),(54.675,0.295),(54.675,0.145),(54.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.465),(54.525,0.615),(54.675,0.615),(54.675,0.465),(54.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.785),(54.525,0.935),(54.675,0.935),(54.675,0.785),(54.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.105),(54.525,1.255),(54.675,1.255),(54.675,1.105),(54.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.425),(54.525,1.575),(54.675,1.575),(54.675,1.425),(54.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.745),(54.525,1.895),(54.675,1.895),(54.675,1.745),(54.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.065),(54.525,2.215),(54.675,2.215),(54.675,2.065),(54.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.385),(54.525,2.535),(54.675,2.535),(54.675,2.385),(54.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.705),(54.525,2.855),(54.675,2.855),(54.675,2.705),(54.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.025),(54.525,3.175),(54.675,3.175),(54.675,3.025),(54.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.345),(54.525,3.495),(54.675,3.495),(54.675,3.345),(54.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.665),(54.525,3.815),(54.675,3.815),(54.675,3.665),(54.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.985),(54.525,4.135),(54.675,4.135),(54.675,3.985),(54.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.305),(54.525,4.455),(54.675,4.455),(54.675,4.305),(54.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.625),(54.525,4.775),(54.675,4.775),(54.675,4.625),(54.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.945),(54.525,5.095),(54.675,5.095),(54.675,4.945),(54.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.265),(54.525,5.415),(54.675,5.415),(54.675,5.265),(54.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.585),(54.525,5.735),(54.675,5.735),(54.675,5.585),(54.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.905),(54.525,6.055),(54.675,6.055),(54.675,5.905),(54.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.225),(54.525,6.375),(54.675,6.375),(54.675,6.225),(54.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.545),(54.525,6.695),(54.675,6.695),(54.675,6.545),(54.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.865),(54.525,7.015),(54.675,7.015),(54.675,6.865),(54.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.185),(54.525,7.335),(54.675,7.335),(54.675,7.185),(54.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.505),(54.525,7.655),(54.675,7.655),(54.675,7.505),(54.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.825),(54.525,7.975),(54.675,7.975),(54.675,7.825),(54.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.145),(54.525,8.295),(54.675,8.295),(54.675,8.145),(54.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.465),(54.525,8.615),(54.675,8.615),(54.675,8.465),(54.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.785),(54.525,8.935),(54.675,8.935),(54.675,8.785),(54.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.105),(54.525,9.255),(54.675,9.255),(54.675,9.105),(54.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.425),(54.525,9.575),(54.675,9.575),(54.675,9.425),(54.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.745),(54.525,9.895),(54.675,9.895),(54.675,9.745),(54.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.065),(54.525,10.215),(54.675,10.215),(54.675,10.065),(54.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.385),(54.525,10.535),(54.675,10.535),(54.675,10.385),(54.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.705),(54.525,10.855),(54.675,10.855),(54.675,10.705),(54.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.025),(54.525,11.175),(54.675,11.175),(54.675,11.025),(54.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.345),(54.525,11.495),(54.675,11.495),(54.675,11.345),(54.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.665),(54.525,11.815),(54.675,11.815),(54.675,11.665),(54.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.985),(54.525,12.135),(54.675,12.135),(54.675,11.985),(54.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.305),(54.525,12.455),(54.675,12.455),(54.675,12.305),(54.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.625),(54.525,12.775),(54.675,12.775),(54.675,12.625),(54.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.945),(54.525,13.095),(54.675,13.095),(54.675,12.945),(54.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.265),(54.525,13.415),(54.675,13.415),(54.675,13.265),(54.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.585),(54.525,13.735),(54.675,13.735),(54.675,13.585),(54.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.905),(54.525,14.055),(54.675,14.055),(54.675,13.905),(54.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.225),(54.525,14.375),(54.675,14.375),(54.675,14.225),(54.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.545),(54.525,14.695),(54.675,14.695),(54.675,14.545),(54.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.865),(54.525,15.015),(54.675,15.015),(54.675,14.865),(54.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.185),(54.525,15.335),(54.675,15.335),(54.675,15.185),(54.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.505),(54.525,15.655),(54.675,15.655),(54.675,15.505),(54.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.825),(54.525,15.975),(54.675,15.975),(54.675,15.825),(54.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.145),(54.525,16.295),(54.675,16.295),(54.675,16.145),(54.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.465),(54.525,16.615),(54.675,16.615),(54.675,16.465),(54.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.785),(54.525,16.935),(54.675,16.935),(54.675,16.785),(54.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.105),(54.525,17.255),(54.675,17.255),(54.675,17.105),(54.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.425),(54.525,17.575),(54.675,17.575),(54.675,17.425),(54.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.745),(54.525,17.895),(54.675,17.895),(54.675,17.745),(54.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.065),(54.525,18.215),(54.675,18.215),(54.675,18.065),(54.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.385),(54.525,18.535),(54.675,18.535),(54.675,18.385),(54.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.705),(54.525,18.855),(54.675,18.855),(54.675,18.705),(54.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.025),(54.525,19.175),(54.675,19.175),(54.675,19.025),(54.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.345),(54.525,19.495),(54.675,19.495),(54.675,19.345),(54.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.665),(54.525,19.815),(54.675,19.815),(54.675,19.665),(54.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.985),(54.525,20.135),(54.675,20.135),(54.675,19.985),(54.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.305),(54.525,20.455),(54.675,20.455),(54.675,20.305),(54.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.625),(54.525,20.775),(54.675,20.775),(54.675,20.625),(54.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.945),(54.525,21.095),(54.675,21.095),(54.675,20.945),(54.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.265),(54.525,21.415),(54.675,21.415),(54.675,21.265),(54.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.585),(54.525,21.735),(54.675,21.735),(54.675,21.585),(54.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.905),(54.525,22.055),(54.675,22.055),(54.675,21.905),(54.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.225),(54.525,22.375),(54.675,22.375),(54.675,22.225),(54.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.545),(54.525,22.695),(54.675,22.695),(54.675,22.545),(54.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.865),(54.525,23.015),(54.675,23.015),(54.675,22.865),(54.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.185),(54.525,23.335),(54.675,23.335),(54.675,23.185),(54.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.505),(54.525,23.655),(54.675,23.655),(54.675,23.505),(54.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.825),(54.525,23.975),(54.675,23.975),(54.675,23.825),(54.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.145),(54.525,24.295),(54.675,24.295),(54.675,24.145),(54.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.465),(54.525,24.615),(54.675,24.615),(54.675,24.465),(54.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.785),(54.525,24.935),(54.675,24.935),(54.675,24.785),(54.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.105),(54.525,25.255),(54.675,25.255),(54.675,25.105),(54.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.425),(54.525,25.575),(54.675,25.575),(54.675,25.425),(54.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.745),(54.525,25.895),(54.675,25.895),(54.675,25.745),(54.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.065),(54.525,26.215),(54.675,26.215),(54.675,26.065),(54.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.385),(54.525,26.535),(54.675,26.535),(54.675,26.385),(54.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.705),(54.525,26.855),(54.675,26.855),(54.675,26.705),(54.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.025),(54.525,27.175),(54.675,27.175),(54.675,27.025),(54.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.345),(54.525,27.495),(54.675,27.495),(54.675,27.345),(54.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.665),(54.525,27.815),(54.675,27.815),(54.675,27.665),(54.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.985),(54.525,28.135),(54.675,28.135),(54.675,27.985),(54.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.305),(54.525,28.455),(54.675,28.455),(54.675,28.305),(54.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.625),(54.525,28.775),(54.675,28.775),(54.675,28.625),(54.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.945),(54.525,29.095),(54.675,29.095),(54.675,28.945),(54.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.265),(54.525,29.415),(54.675,29.415),(54.675,29.265),(54.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.585),(54.525,29.735),(54.675,29.735),(54.675,29.585),(54.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.905),(54.525,30.055),(54.675,30.055),(54.675,29.905),(54.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.225),(54.525,30.375),(54.675,30.375),(54.675,30.225),(54.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.545),(54.525,30.695),(54.675,30.695),(54.675,30.545),(54.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.865),(54.525,31.015),(54.675,31.015),(54.675,30.865),(54.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.185),(54.525,31.335),(54.675,31.335),(54.675,31.185),(54.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.505),(54.525,31.655),(54.675,31.655),(54.675,31.505),(54.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.825),(54.525,31.975),(54.675,31.975),(54.675,31.825),(54.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.145),(54.525,32.295),(54.675,32.295),(54.675,32.145),(54.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.465),(54.525,32.615),(54.675,32.615),(54.675,32.465),(54.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.785),(54.525,32.935),(54.675,32.935),(54.675,32.785),(54.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.105),(54.525,33.255),(54.675,33.255),(54.675,33.105),(54.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.425),(54.525,33.575),(54.675,33.575),(54.675,33.425),(54.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.745),(54.525,33.895),(54.675,33.895),(54.675,33.745),(54.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.065),(54.525,34.215),(54.675,34.215),(54.675,34.065),(54.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.385),(54.525,34.535),(54.675,34.535),(54.675,34.385),(54.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.705),(54.525,34.855),(54.675,34.855),(54.675,34.705),(54.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.025),(54.525,35.175),(54.675,35.175),(54.675,35.025),(54.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.345),(54.525,35.495),(54.675,35.495),(54.675,35.345),(54.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.665),(54.525,35.815),(54.675,35.815),(54.675,35.665),(54.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.985),(54.525,36.135),(54.675,36.135),(54.675,35.985),(54.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.305),(54.525,36.455),(54.675,36.455),(54.675,36.305),(54.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.625),(54.525,36.775),(54.675,36.775),(54.675,36.625),(54.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.945),(54.525,37.095),(54.675,37.095),(54.675,36.945),(54.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.265),(54.525,37.415),(54.675,37.415),(54.675,37.265),(54.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.585),(54.525,37.735),(54.675,37.735),(54.675,37.585),(54.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.905),(54.525,38.055),(54.675,38.055),(54.675,37.905),(54.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.225),(54.525,38.375),(54.675,38.375),(54.675,38.225),(54.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.545),(54.525,38.695),(54.675,38.695),(54.675,38.545),(54.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.865),(54.525,39.015),(54.675,39.015),(54.675,38.865),(54.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.185),(54.525,39.335),(54.675,39.335),(54.675,39.185),(54.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.505),(54.525,39.655),(54.675,39.655),(54.675,39.505),(54.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.825),(54.525,39.975),(54.675,39.975),(54.675,39.825),(54.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.145),(54.525,40.295),(54.675,40.295),(54.675,40.145),(54.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.465),(54.525,40.615),(54.675,40.615),(54.675,40.465),(54.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.785),(54.525,40.935),(54.675,40.935),(54.675,40.785),(54.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.105),(54.525,41.255),(54.675,41.255),(54.675,41.105),(54.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.425),(54.525,41.575),(54.675,41.575),(54.675,41.425),(54.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.745),(54.525,41.895),(54.675,41.895),(54.675,41.745),(54.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.065),(54.525,42.215),(54.675,42.215),(54.675,42.065),(54.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.385),(54.525,42.535),(54.675,42.535),(54.675,42.385),(54.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.705),(54.525,42.855),(54.675,42.855),(54.675,42.705),(54.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,43.025),(54.525,43.175),(54.675,43.175),(54.675,43.025),(54.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,43.345),(54.525,43.495),(54.675,43.495),(54.675,43.345),(54.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.145),(49.725,0.295),(49.875,0.295),(49.875,0.145),(49.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.465),(49.725,0.615),(49.875,0.615),(49.875,0.465),(49.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.785),(49.725,0.935),(49.875,0.935),(49.875,0.785),(49.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.105),(49.725,1.255),(49.875,1.255),(49.875,1.105),(49.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.425),(49.725,1.575),(49.875,1.575),(49.875,1.425),(49.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.745),(49.725,1.895),(49.875,1.895),(49.875,1.745),(49.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.065),(49.725,2.215),(49.875,2.215),(49.875,2.065),(49.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.385),(49.725,2.535),(49.875,2.535),(49.875,2.385),(49.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.705),(49.725,2.855),(49.875,2.855),(49.875,2.705),(49.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.025),(49.725,3.175),(49.875,3.175),(49.875,3.025),(49.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.345),(49.725,3.495),(49.875,3.495),(49.875,3.345),(49.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.665),(49.725,3.815),(49.875,3.815),(49.875,3.665),(49.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.985),(49.725,4.135),(49.875,4.135),(49.875,3.985),(49.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.305),(49.725,4.455),(49.875,4.455),(49.875,4.305),(49.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.625),(49.725,4.775),(49.875,4.775),(49.875,4.625),(49.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.945),(49.725,5.095),(49.875,5.095),(49.875,4.945),(49.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.265),(49.725,5.415),(49.875,5.415),(49.875,5.265),(49.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.585),(49.725,5.735),(49.875,5.735),(49.875,5.585),(49.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.905),(49.725,6.055),(49.875,6.055),(49.875,5.905),(49.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.225),(49.725,6.375),(49.875,6.375),(49.875,6.225),(49.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.545),(49.725,6.695),(49.875,6.695),(49.875,6.545),(49.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.865),(49.725,7.015),(49.875,7.015),(49.875,6.865),(49.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.185),(49.725,7.335),(49.875,7.335),(49.875,7.185),(49.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.505),(49.725,7.655),(49.875,7.655),(49.875,7.505),(49.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.825),(49.725,7.975),(49.875,7.975),(49.875,7.825),(49.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.145),(49.725,8.295),(49.875,8.295),(49.875,8.145),(49.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.465),(49.725,8.615),(49.875,8.615),(49.875,8.465),(49.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.785),(49.725,8.935),(49.875,8.935),(49.875,8.785),(49.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.105),(49.725,9.255),(49.875,9.255),(49.875,9.105),(49.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.425),(49.725,9.575),(49.875,9.575),(49.875,9.425),(49.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.745),(49.725,9.895),(49.875,9.895),(49.875,9.745),(49.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.065),(49.725,10.215),(49.875,10.215),(49.875,10.065),(49.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.385),(49.725,10.535),(49.875,10.535),(49.875,10.385),(49.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.705),(49.725,10.855),(49.875,10.855),(49.875,10.705),(49.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.025),(49.725,11.175),(49.875,11.175),(49.875,11.025),(49.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.345),(49.725,11.495),(49.875,11.495),(49.875,11.345),(49.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.665),(49.725,11.815),(49.875,11.815),(49.875,11.665),(49.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.985),(49.725,12.135),(49.875,12.135),(49.875,11.985),(49.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.305),(49.725,12.455),(49.875,12.455),(49.875,12.305),(49.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.625),(49.725,12.775),(49.875,12.775),(49.875,12.625),(49.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.945),(49.725,13.095),(49.875,13.095),(49.875,12.945),(49.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.265),(49.725,13.415),(49.875,13.415),(49.875,13.265),(49.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.585),(49.725,13.735),(49.875,13.735),(49.875,13.585),(49.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.905),(49.725,14.055),(49.875,14.055),(49.875,13.905),(49.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.225),(49.725,14.375),(49.875,14.375),(49.875,14.225),(49.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.545),(49.725,14.695),(49.875,14.695),(49.875,14.545),(49.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.865),(49.725,15.015),(49.875,15.015),(49.875,14.865),(49.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.185),(49.725,15.335),(49.875,15.335),(49.875,15.185),(49.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.505),(49.725,15.655),(49.875,15.655),(49.875,15.505),(49.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.825),(49.725,15.975),(49.875,15.975),(49.875,15.825),(49.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.145),(49.725,16.295),(49.875,16.295),(49.875,16.145),(49.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.465),(49.725,16.615),(49.875,16.615),(49.875,16.465),(49.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.785),(49.725,16.935),(49.875,16.935),(49.875,16.785),(49.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.105),(49.725,17.255),(49.875,17.255),(49.875,17.105),(49.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.425),(49.725,17.575),(49.875,17.575),(49.875,17.425),(49.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.745),(49.725,17.895),(49.875,17.895),(49.875,17.745),(49.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.065),(49.725,18.215),(49.875,18.215),(49.875,18.065),(49.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.385),(49.725,18.535),(49.875,18.535),(49.875,18.385),(49.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.705),(49.725,18.855),(49.875,18.855),(49.875,18.705),(49.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.025),(49.725,19.175),(49.875,19.175),(49.875,19.025),(49.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.345),(49.725,19.495),(49.875,19.495),(49.875,19.345),(49.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.665),(49.725,19.815),(49.875,19.815),(49.875,19.665),(49.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.985),(49.725,20.135),(49.875,20.135),(49.875,19.985),(49.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.305),(49.725,20.455),(49.875,20.455),(49.875,20.305),(49.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.625),(49.725,20.775),(49.875,20.775),(49.875,20.625),(49.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.945),(49.725,21.095),(49.875,21.095),(49.875,20.945),(49.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.265),(49.725,21.415),(49.875,21.415),(49.875,21.265),(49.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.585),(49.725,21.735),(49.875,21.735),(49.875,21.585),(49.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.905),(49.725,22.055),(49.875,22.055),(49.875,21.905),(49.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.225),(49.725,22.375),(49.875,22.375),(49.875,22.225),(49.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.545),(49.725,22.695),(49.875,22.695),(49.875,22.545),(49.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.865),(49.725,23.015),(49.875,23.015),(49.875,22.865),(49.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.185),(49.725,23.335),(49.875,23.335),(49.875,23.185),(49.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.505),(49.725,23.655),(49.875,23.655),(49.875,23.505),(49.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.825),(49.725,23.975),(49.875,23.975),(49.875,23.825),(49.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.145),(49.725,24.295),(49.875,24.295),(49.875,24.145),(49.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.465),(49.725,24.615),(49.875,24.615),(49.875,24.465),(49.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.785),(49.725,24.935),(49.875,24.935),(49.875,24.785),(49.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.105),(49.725,25.255),(49.875,25.255),(49.875,25.105),(49.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.425),(49.725,25.575),(49.875,25.575),(49.875,25.425),(49.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.745),(49.725,25.895),(49.875,25.895),(49.875,25.745),(49.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.065),(49.725,26.215),(49.875,26.215),(49.875,26.065),(49.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.385),(49.725,26.535),(49.875,26.535),(49.875,26.385),(49.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.705),(49.725,26.855),(49.875,26.855),(49.875,26.705),(49.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.025),(49.725,27.175),(49.875,27.175),(49.875,27.025),(49.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.345),(49.725,27.495),(49.875,27.495),(49.875,27.345),(49.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.665),(49.725,27.815),(49.875,27.815),(49.875,27.665),(49.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.985),(49.725,28.135),(49.875,28.135),(49.875,27.985),(49.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.305),(49.725,28.455),(49.875,28.455),(49.875,28.305),(49.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.625),(49.725,28.775),(49.875,28.775),(49.875,28.625),(49.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.945),(49.725,29.095),(49.875,29.095),(49.875,28.945),(49.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.265),(49.725,29.415),(49.875,29.415),(49.875,29.265),(49.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.585),(49.725,29.735),(49.875,29.735),(49.875,29.585),(49.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.905),(49.725,30.055),(49.875,30.055),(49.875,29.905),(49.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.225),(49.725,30.375),(49.875,30.375),(49.875,30.225),(49.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.545),(49.725,30.695),(49.875,30.695),(49.875,30.545),(49.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.865),(49.725,31.015),(49.875,31.015),(49.875,30.865),(49.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.185),(49.725,31.335),(49.875,31.335),(49.875,31.185),(49.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.505),(49.725,31.655),(49.875,31.655),(49.875,31.505),(49.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.825),(49.725,31.975),(49.875,31.975),(49.875,31.825),(49.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.145),(49.725,32.295),(49.875,32.295),(49.875,32.145),(49.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.465),(49.725,32.615),(49.875,32.615),(49.875,32.465),(49.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.785),(49.725,32.935),(49.875,32.935),(49.875,32.785),(49.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.105),(49.725,33.255),(49.875,33.255),(49.875,33.105),(49.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.425),(49.725,33.575),(49.875,33.575),(49.875,33.425),(49.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.745),(49.725,33.895),(49.875,33.895),(49.875,33.745),(49.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.065),(49.725,34.215),(49.875,34.215),(49.875,34.065),(49.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.385),(49.725,34.535),(49.875,34.535),(49.875,34.385),(49.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.705),(49.725,34.855),(49.875,34.855),(49.875,34.705),(49.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.025),(49.725,35.175),(49.875,35.175),(49.875,35.025),(49.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.345),(49.725,35.495),(49.875,35.495),(49.875,35.345),(49.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.665),(49.725,35.815),(49.875,35.815),(49.875,35.665),(49.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.985),(49.725,36.135),(49.875,36.135),(49.875,35.985),(49.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.305),(49.725,36.455),(49.875,36.455),(49.875,36.305),(49.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.625),(49.725,36.775),(49.875,36.775),(49.875,36.625),(49.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.945),(49.725,37.095),(49.875,37.095),(49.875,36.945),(49.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.265),(49.725,37.415),(49.875,37.415),(49.875,37.265),(49.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.585),(49.725,37.735),(49.875,37.735),(49.875,37.585),(49.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.905),(49.725,38.055),(49.875,38.055),(49.875,37.905),(49.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.225),(49.725,38.375),(49.875,38.375),(49.875,38.225),(49.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.545),(49.725,38.695),(49.875,38.695),(49.875,38.545),(49.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.865),(49.725,39.015),(49.875,39.015),(49.875,38.865),(49.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.185),(49.725,39.335),(49.875,39.335),(49.875,39.185),(49.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.505),(49.725,39.655),(49.875,39.655),(49.875,39.505),(49.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.825),(49.725,39.975),(49.875,39.975),(49.875,39.825),(49.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.145),(49.725,40.295),(49.875,40.295),(49.875,40.145),(49.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.465),(49.725,40.615),(49.875,40.615),(49.875,40.465),(49.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.785),(49.725,40.935),(49.875,40.935),(49.875,40.785),(49.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.105),(49.725,41.255),(49.875,41.255),(49.875,41.105),(49.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.425),(49.725,41.575),(49.875,41.575),(49.875,41.425),(49.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.745),(49.725,41.895),(49.875,41.895),(49.875,41.745),(49.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.065),(49.725,42.215),(49.875,42.215),(49.875,42.065),(49.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.385),(49.725,42.535),(49.875,42.535),(49.875,42.385),(49.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.705),(49.725,42.855),(49.875,42.855),(49.875,42.705),(49.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,43.025),(49.725,43.175),(49.875,43.175),(49.875,43.025),(49.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,43.345),(49.725,43.495),(49.875,43.495),(49.875,43.345),(49.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.145),(64.125,0.295),(64.275,0.295),(64.275,0.145),(64.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.465),(64.125,0.615),(64.275,0.615),(64.275,0.465),(64.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.785),(64.125,0.935),(64.275,0.935),(64.275,0.785),(64.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.105),(64.125,1.255),(64.275,1.255),(64.275,1.105),(64.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.425),(64.125,1.575),(64.275,1.575),(64.275,1.425),(64.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.745),(64.125,1.895),(64.275,1.895),(64.275,1.745),(64.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.065),(64.125,2.215),(64.275,2.215),(64.275,2.065),(64.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.385),(64.125,2.535),(64.275,2.535),(64.275,2.385),(64.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.705),(64.125,2.855),(64.275,2.855),(64.275,2.705),(64.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.025),(64.125,3.175),(64.275,3.175),(64.275,3.025),(64.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.345),(64.125,3.495),(64.275,3.495),(64.275,3.345),(64.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.665),(64.125,3.815),(64.275,3.815),(64.275,3.665),(64.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.985),(64.125,4.135),(64.275,4.135),(64.275,3.985),(64.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.305),(64.125,4.455),(64.275,4.455),(64.275,4.305),(64.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.625),(64.125,4.775),(64.275,4.775),(64.275,4.625),(64.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.945),(64.125,5.095),(64.275,5.095),(64.275,4.945),(64.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.265),(64.125,5.415),(64.275,5.415),(64.275,5.265),(64.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.585),(64.125,5.735),(64.275,5.735),(64.275,5.585),(64.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.905),(64.125,6.055),(64.275,6.055),(64.275,5.905),(64.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.225),(64.125,6.375),(64.275,6.375),(64.275,6.225),(64.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.545),(64.125,6.695),(64.275,6.695),(64.275,6.545),(64.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.865),(64.125,7.015),(64.275,7.015),(64.275,6.865),(64.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.185),(64.125,7.335),(64.275,7.335),(64.275,7.185),(64.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.505),(64.125,7.655),(64.275,7.655),(64.275,7.505),(64.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.825),(64.125,7.975),(64.275,7.975),(64.275,7.825),(64.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.145),(64.125,8.295),(64.275,8.295),(64.275,8.145),(64.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.465),(64.125,8.615),(64.275,8.615),(64.275,8.465),(64.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.785),(64.125,8.935),(64.275,8.935),(64.275,8.785),(64.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.105),(64.125,9.255),(64.275,9.255),(64.275,9.105),(64.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.425),(64.125,9.575),(64.275,9.575),(64.275,9.425),(64.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.745),(64.125,9.895),(64.275,9.895),(64.275,9.745),(64.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.065),(64.125,10.215),(64.275,10.215),(64.275,10.065),(64.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.385),(64.125,10.535),(64.275,10.535),(64.275,10.385),(64.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.705),(64.125,10.855),(64.275,10.855),(64.275,10.705),(64.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.025),(64.125,11.175),(64.275,11.175),(64.275,11.025),(64.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.345),(64.125,11.495),(64.275,11.495),(64.275,11.345),(64.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.665),(64.125,11.815),(64.275,11.815),(64.275,11.665),(64.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.985),(64.125,12.135),(64.275,12.135),(64.275,11.985),(64.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.305),(64.125,12.455),(64.275,12.455),(64.275,12.305),(64.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.625),(64.125,12.775),(64.275,12.775),(64.275,12.625),(64.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.945),(64.125,13.095),(64.275,13.095),(64.275,12.945),(64.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.265),(64.125,13.415),(64.275,13.415),(64.275,13.265),(64.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.585),(64.125,13.735),(64.275,13.735),(64.275,13.585),(64.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.905),(64.125,14.055),(64.275,14.055),(64.275,13.905),(64.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.225),(64.125,14.375),(64.275,14.375),(64.275,14.225),(64.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.545),(64.125,14.695),(64.275,14.695),(64.275,14.545),(64.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.865),(64.125,15.015),(64.275,15.015),(64.275,14.865),(64.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.185),(64.125,15.335),(64.275,15.335),(64.275,15.185),(64.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.505),(64.125,15.655),(64.275,15.655),(64.275,15.505),(64.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.825),(64.125,15.975),(64.275,15.975),(64.275,15.825),(64.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.145),(64.125,16.295),(64.275,16.295),(64.275,16.145),(64.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.465),(64.125,16.615),(64.275,16.615),(64.275,16.465),(64.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.785),(64.125,16.935),(64.275,16.935),(64.275,16.785),(64.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.105),(64.125,17.255),(64.275,17.255),(64.275,17.105),(64.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.425),(64.125,17.575),(64.275,17.575),(64.275,17.425),(64.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.745),(64.125,17.895),(64.275,17.895),(64.275,17.745),(64.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.065),(64.125,18.215),(64.275,18.215),(64.275,18.065),(64.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.385),(64.125,18.535),(64.275,18.535),(64.275,18.385),(64.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.705),(64.125,18.855),(64.275,18.855),(64.275,18.705),(64.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.025),(64.125,19.175),(64.275,19.175),(64.275,19.025),(64.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.345),(64.125,19.495),(64.275,19.495),(64.275,19.345),(64.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.665),(64.125,19.815),(64.275,19.815),(64.275,19.665),(64.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.985),(64.125,20.135),(64.275,20.135),(64.275,19.985),(64.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.305),(64.125,20.455),(64.275,20.455),(64.275,20.305),(64.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.625),(64.125,20.775),(64.275,20.775),(64.275,20.625),(64.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.945),(64.125,21.095),(64.275,21.095),(64.275,20.945),(64.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.265),(64.125,21.415),(64.275,21.415),(64.275,21.265),(64.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.585),(64.125,21.735),(64.275,21.735),(64.275,21.585),(64.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.905),(64.125,22.055),(64.275,22.055),(64.275,21.905),(64.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,22.225),(64.125,22.375),(64.275,22.375),(64.275,22.225),(64.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,22.545),(64.125,22.695),(64.275,22.695),(64.275,22.545),(64.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,22.865),(64.125,23.015),(64.275,23.015),(64.275,22.865),(64.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,23.185),(64.125,23.335),(64.275,23.335),(64.275,23.185),(64.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,23.505),(64.125,23.655),(64.275,23.655),(64.275,23.505),(64.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,23.825),(64.125,23.975),(64.275,23.975),(64.275,23.825),(64.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,24.145),(64.125,24.295),(64.275,24.295),(64.275,24.145),(64.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,24.465),(64.125,24.615),(64.275,24.615),(64.275,24.465),(64.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,24.785),(64.125,24.935),(64.275,24.935),(64.275,24.785),(64.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,25.105),(64.125,25.255),(64.275,25.255),(64.275,25.105),(64.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,25.425),(64.125,25.575),(64.275,25.575),(64.275,25.425),(64.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,25.745),(64.125,25.895),(64.275,25.895),(64.275,25.745),(64.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,26.065),(64.125,26.215),(64.275,26.215),(64.275,26.065),(64.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,26.385),(64.125,26.535),(64.275,26.535),(64.275,26.385),(64.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,26.705),(64.125,26.855),(64.275,26.855),(64.275,26.705),(64.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.025),(64.125,27.175),(64.275,27.175),(64.275,27.025),(64.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.345),(64.125,27.495),(64.275,27.495),(64.275,27.345),(64.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.665),(64.125,27.815),(64.275,27.815),(64.275,27.665),(64.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.985),(64.125,28.135),(64.275,28.135),(64.275,27.985),(64.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,28.305),(64.125,28.455),(64.275,28.455),(64.275,28.305),(64.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,28.625),(64.125,28.775),(64.275,28.775),(64.275,28.625),(64.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,28.945),(64.125,29.095),(64.275,29.095),(64.275,28.945),(64.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,29.265),(64.125,29.415),(64.275,29.415),(64.275,29.265),(64.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,29.585),(64.125,29.735),(64.275,29.735),(64.275,29.585),(64.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,29.905),(64.125,30.055),(64.275,30.055),(64.275,29.905),(64.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,30.225),(64.125,30.375),(64.275,30.375),(64.275,30.225),(64.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,30.545),(64.125,30.695),(64.275,30.695),(64.275,30.545),(64.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,30.865),(64.125,31.015),(64.275,31.015),(64.275,30.865),(64.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,31.185),(64.125,31.335),(64.275,31.335),(64.275,31.185),(64.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,31.505),(64.125,31.655),(64.275,31.655),(64.275,31.505),(64.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,31.825),(64.125,31.975),(64.275,31.975),(64.275,31.825),(64.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,32.145),(64.125,32.295),(64.275,32.295),(64.275,32.145),(64.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,32.465),(64.125,32.615),(64.275,32.615),(64.275,32.465),(64.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,32.785),(64.125,32.935),(64.275,32.935),(64.275,32.785),(64.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,33.105),(64.125,33.255),(64.275,33.255),(64.275,33.105),(64.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,33.425),(64.125,33.575),(64.275,33.575),(64.275,33.425),(64.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,33.745),(64.125,33.895),(64.275,33.895),(64.275,33.745),(64.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,34.065),(64.125,34.215),(64.275,34.215),(64.275,34.065),(64.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,34.385),(64.125,34.535),(64.275,34.535),(64.275,34.385),(64.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,34.705),(64.125,34.855),(64.275,34.855),(64.275,34.705),(64.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.025),(64.125,35.175),(64.275,35.175),(64.275,35.025),(64.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.345),(64.125,35.495),(64.275,35.495),(64.275,35.345),(64.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.665),(64.125,35.815),(64.275,35.815),(64.275,35.665),(64.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.985),(64.125,36.135),(64.275,36.135),(64.275,35.985),(64.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,36.305),(64.125,36.455),(64.275,36.455),(64.275,36.305),(64.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,36.625),(64.125,36.775),(64.275,36.775),(64.275,36.625),(64.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,36.945),(64.125,37.095),(64.275,37.095),(64.275,36.945),(64.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,37.265),(64.125,37.415),(64.275,37.415),(64.275,37.265),(64.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,37.585),(64.125,37.735),(64.275,37.735),(64.275,37.585),(64.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,37.905),(64.125,38.055),(64.275,38.055),(64.275,37.905),(64.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,38.225),(64.125,38.375),(64.275,38.375),(64.275,38.225),(64.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,38.545),(64.125,38.695),(64.275,38.695),(64.275,38.545),(64.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,38.865),(64.125,39.015),(64.275,39.015),(64.275,38.865),(64.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,39.185),(64.125,39.335),(64.275,39.335),(64.275,39.185),(64.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,39.505),(64.125,39.655),(64.275,39.655),(64.275,39.505),(64.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,39.825),(64.125,39.975),(64.275,39.975),(64.275,39.825),(64.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,40.145),(64.125,40.295),(64.275,40.295),(64.275,40.145),(64.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,40.465),(64.125,40.615),(64.275,40.615),(64.275,40.465),(64.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,40.785),(64.125,40.935),(64.275,40.935),(64.275,40.785),(64.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,41.105),(64.125,41.255),(64.275,41.255),(64.275,41.105),(64.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,41.425),(64.125,41.575),(64.275,41.575),(64.275,41.425),(64.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,41.745),(64.125,41.895),(64.275,41.895),(64.275,41.745),(64.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,42.065),(64.125,42.215),(64.275,42.215),(64.275,42.065),(64.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,42.385),(64.125,42.535),(64.275,42.535),(64.275,42.385),(64.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,42.705),(64.125,42.855),(64.275,42.855),(64.275,42.705),(64.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,43.025),(64.125,43.175),(64.275,43.175),(64.275,43.025),(64.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,43.345),(64.125,43.495),(64.275,43.495),(64.275,43.345),(64.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.145),(78.525,0.295),(78.675,0.295),(78.675,0.145),(78.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.465),(78.525,0.615),(78.675,0.615),(78.675,0.465),(78.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.785),(78.525,0.935),(78.675,0.935),(78.675,0.785),(78.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.105),(78.525,1.255),(78.675,1.255),(78.675,1.105),(78.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.425),(78.525,1.575),(78.675,1.575),(78.675,1.425),(78.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.745),(78.525,1.895),(78.675,1.895),(78.675,1.745),(78.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.065),(78.525,2.215),(78.675,2.215),(78.675,2.065),(78.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.385),(78.525,2.535),(78.675,2.535),(78.675,2.385),(78.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.705),(78.525,2.855),(78.675,2.855),(78.675,2.705),(78.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.025),(78.525,3.175),(78.675,3.175),(78.675,3.025),(78.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.345),(78.525,3.495),(78.675,3.495),(78.675,3.345),(78.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.665),(78.525,3.815),(78.675,3.815),(78.675,3.665),(78.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.985),(78.525,4.135),(78.675,4.135),(78.675,3.985),(78.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.305),(78.525,4.455),(78.675,4.455),(78.675,4.305),(78.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.625),(78.525,4.775),(78.675,4.775),(78.675,4.625),(78.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.945),(78.525,5.095),(78.675,5.095),(78.675,4.945),(78.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.265),(78.525,5.415),(78.675,5.415),(78.675,5.265),(78.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.585),(78.525,5.735),(78.675,5.735),(78.675,5.585),(78.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.905),(78.525,6.055),(78.675,6.055),(78.675,5.905),(78.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.225),(78.525,6.375),(78.675,6.375),(78.675,6.225),(78.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.545),(78.525,6.695),(78.675,6.695),(78.675,6.545),(78.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.865),(78.525,7.015),(78.675,7.015),(78.675,6.865),(78.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.185),(78.525,7.335),(78.675,7.335),(78.675,7.185),(78.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.505),(78.525,7.655),(78.675,7.655),(78.675,7.505),(78.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.825),(78.525,7.975),(78.675,7.975),(78.675,7.825),(78.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.145),(78.525,8.295),(78.675,8.295),(78.675,8.145),(78.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.465),(78.525,8.615),(78.675,8.615),(78.675,8.465),(78.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.785),(78.525,8.935),(78.675,8.935),(78.675,8.785),(78.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.105),(78.525,9.255),(78.675,9.255),(78.675,9.105),(78.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.425),(78.525,9.575),(78.675,9.575),(78.675,9.425),(78.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.745),(78.525,9.895),(78.675,9.895),(78.675,9.745),(78.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.065),(78.525,10.215),(78.675,10.215),(78.675,10.065),(78.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.385),(78.525,10.535),(78.675,10.535),(78.675,10.385),(78.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.705),(78.525,10.855),(78.675,10.855),(78.675,10.705),(78.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.025),(78.525,11.175),(78.675,11.175),(78.675,11.025),(78.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.345),(78.525,11.495),(78.675,11.495),(78.675,11.345),(78.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.665),(78.525,11.815),(78.675,11.815),(78.675,11.665),(78.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.985),(78.525,12.135),(78.675,12.135),(78.675,11.985),(78.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.305),(78.525,12.455),(78.675,12.455),(78.675,12.305),(78.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.625),(78.525,12.775),(78.675,12.775),(78.675,12.625),(78.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.945),(78.525,13.095),(78.675,13.095),(78.675,12.945),(78.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.265),(78.525,13.415),(78.675,13.415),(78.675,13.265),(78.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.585),(78.525,13.735),(78.675,13.735),(78.675,13.585),(78.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.905),(78.525,14.055),(78.675,14.055),(78.675,13.905),(78.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.225),(78.525,14.375),(78.675,14.375),(78.675,14.225),(78.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.545),(78.525,14.695),(78.675,14.695),(78.675,14.545),(78.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.865),(78.525,15.015),(78.675,15.015),(78.675,14.865),(78.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.185),(78.525,15.335),(78.675,15.335),(78.675,15.185),(78.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.505),(78.525,15.655),(78.675,15.655),(78.675,15.505),(78.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.825),(78.525,15.975),(78.675,15.975),(78.675,15.825),(78.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.145),(78.525,16.295),(78.675,16.295),(78.675,16.145),(78.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.465),(78.525,16.615),(78.675,16.615),(78.675,16.465),(78.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.785),(78.525,16.935),(78.675,16.935),(78.675,16.785),(78.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.105),(78.525,17.255),(78.675,17.255),(78.675,17.105),(78.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.425),(78.525,17.575),(78.675,17.575),(78.675,17.425),(78.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.745),(78.525,17.895),(78.675,17.895),(78.675,17.745),(78.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.065),(78.525,18.215),(78.675,18.215),(78.675,18.065),(78.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.385),(78.525,18.535),(78.675,18.535),(78.675,18.385),(78.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.705),(78.525,18.855),(78.675,18.855),(78.675,18.705),(78.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.025),(78.525,19.175),(78.675,19.175),(78.675,19.025),(78.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.345),(78.525,19.495),(78.675,19.495),(78.675,19.345),(78.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.665),(78.525,19.815),(78.675,19.815),(78.675,19.665),(78.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.985),(78.525,20.135),(78.675,20.135),(78.675,19.985),(78.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.305),(78.525,20.455),(78.675,20.455),(78.675,20.305),(78.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.625),(78.525,20.775),(78.675,20.775),(78.675,20.625),(78.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.945),(78.525,21.095),(78.675,21.095),(78.675,20.945),(78.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.265),(78.525,21.415),(78.675,21.415),(78.675,21.265),(78.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.585),(78.525,21.735),(78.675,21.735),(78.675,21.585),(78.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.905),(78.525,22.055),(78.675,22.055),(78.675,21.905),(78.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,22.225),(78.525,22.375),(78.675,22.375),(78.675,22.225),(78.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,22.545),(78.525,22.695),(78.675,22.695),(78.675,22.545),(78.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,22.865),(78.525,23.015),(78.675,23.015),(78.675,22.865),(78.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,23.185),(78.525,23.335),(78.675,23.335),(78.675,23.185),(78.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,23.505),(78.525,23.655),(78.675,23.655),(78.675,23.505),(78.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,23.825),(78.525,23.975),(78.675,23.975),(78.675,23.825),(78.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,24.145),(78.525,24.295),(78.675,24.295),(78.675,24.145),(78.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,24.465),(78.525,24.615),(78.675,24.615),(78.675,24.465),(78.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,24.785),(78.525,24.935),(78.675,24.935),(78.675,24.785),(78.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,25.105),(78.525,25.255),(78.675,25.255),(78.675,25.105),(78.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,25.425),(78.525,25.575),(78.675,25.575),(78.675,25.425),(78.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,25.745),(78.525,25.895),(78.675,25.895),(78.675,25.745),(78.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,26.065),(78.525,26.215),(78.675,26.215),(78.675,26.065),(78.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,26.385),(78.525,26.535),(78.675,26.535),(78.675,26.385),(78.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,26.705),(78.525,26.855),(78.675,26.855),(78.675,26.705),(78.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.025),(78.525,27.175),(78.675,27.175),(78.675,27.025),(78.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.345),(78.525,27.495),(78.675,27.495),(78.675,27.345),(78.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.665),(78.525,27.815),(78.675,27.815),(78.675,27.665),(78.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.985),(78.525,28.135),(78.675,28.135),(78.675,27.985),(78.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,28.305),(78.525,28.455),(78.675,28.455),(78.675,28.305),(78.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,28.625),(78.525,28.775),(78.675,28.775),(78.675,28.625),(78.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,28.945),(78.525,29.095),(78.675,29.095),(78.675,28.945),(78.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,29.265),(78.525,29.415),(78.675,29.415),(78.675,29.265),(78.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,29.585),(78.525,29.735),(78.675,29.735),(78.675,29.585),(78.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,29.905),(78.525,30.055),(78.675,30.055),(78.675,29.905),(78.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,30.225),(78.525,30.375),(78.675,30.375),(78.675,30.225),(78.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,30.545),(78.525,30.695),(78.675,30.695),(78.675,30.545),(78.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,30.865),(78.525,31.015),(78.675,31.015),(78.675,30.865),(78.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,31.185),(78.525,31.335),(78.675,31.335),(78.675,31.185),(78.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,31.505),(78.525,31.655),(78.675,31.655),(78.675,31.505),(78.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,31.825),(78.525,31.975),(78.675,31.975),(78.675,31.825),(78.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,32.145),(78.525,32.295),(78.675,32.295),(78.675,32.145),(78.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,32.465),(78.525,32.615),(78.675,32.615),(78.675,32.465),(78.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,32.785),(78.525,32.935),(78.675,32.935),(78.675,32.785),(78.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,33.105),(78.525,33.255),(78.675,33.255),(78.675,33.105),(78.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,33.425),(78.525,33.575),(78.675,33.575),(78.675,33.425),(78.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,33.745),(78.525,33.895),(78.675,33.895),(78.675,33.745),(78.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,34.065),(78.525,34.215),(78.675,34.215),(78.675,34.065),(78.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,34.385),(78.525,34.535),(78.675,34.535),(78.675,34.385),(78.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,34.705),(78.525,34.855),(78.675,34.855),(78.675,34.705),(78.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.025),(78.525,35.175),(78.675,35.175),(78.675,35.025),(78.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.345),(78.525,35.495),(78.675,35.495),(78.675,35.345),(78.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.665),(78.525,35.815),(78.675,35.815),(78.675,35.665),(78.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.985),(78.525,36.135),(78.675,36.135),(78.675,35.985),(78.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,36.305),(78.525,36.455),(78.675,36.455),(78.675,36.305),(78.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,36.625),(78.525,36.775),(78.675,36.775),(78.675,36.625),(78.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,36.945),(78.525,37.095),(78.675,37.095),(78.675,36.945),(78.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,37.265),(78.525,37.415),(78.675,37.415),(78.675,37.265),(78.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,37.585),(78.525,37.735),(78.675,37.735),(78.675,37.585),(78.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,37.905),(78.525,38.055),(78.675,38.055),(78.675,37.905),(78.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,38.225),(78.525,38.375),(78.675,38.375),(78.675,38.225),(78.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,38.545),(78.525,38.695),(78.675,38.695),(78.675,38.545),(78.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,38.865),(78.525,39.015),(78.675,39.015),(78.675,38.865),(78.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,39.185),(78.525,39.335),(78.675,39.335),(78.675,39.185),(78.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,39.505),(78.525,39.655),(78.675,39.655),(78.675,39.505),(78.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,39.825),(78.525,39.975),(78.675,39.975),(78.675,39.825),(78.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,40.145),(78.525,40.295),(78.675,40.295),(78.675,40.145),(78.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,40.465),(78.525,40.615),(78.675,40.615),(78.675,40.465),(78.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,40.785),(78.525,40.935),(78.675,40.935),(78.675,40.785),(78.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,41.105),(78.525,41.255),(78.675,41.255),(78.675,41.105),(78.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,41.425),(78.525,41.575),(78.675,41.575),(78.675,41.425),(78.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,41.745),(78.525,41.895),(78.675,41.895),(78.675,41.745),(78.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,42.065),(78.525,42.215),(78.675,42.215),(78.675,42.065),(78.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,42.385),(78.525,42.535),(78.675,42.535),(78.675,42.385),(78.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,42.705),(78.525,42.855),(78.675,42.855),(78.675,42.705),(78.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,43.025),(78.525,43.175),(78.675,43.175),(78.675,43.025),(78.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,43.345),(78.525,43.495),(78.675,43.495),(78.675,43.345),(78.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.145),(25.725,0.295),(25.875,0.295),(25.875,0.145),(25.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.465),(25.725,0.615),(25.875,0.615),(25.875,0.465),(25.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.785),(25.725,0.935),(25.875,0.935),(25.875,0.785),(25.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.105),(25.725,1.255),(25.875,1.255),(25.875,1.105),(25.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.425),(25.725,1.575),(25.875,1.575),(25.875,1.425),(25.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.745),(25.725,1.895),(25.875,1.895),(25.875,1.745),(25.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.065),(25.725,2.215),(25.875,2.215),(25.875,2.065),(25.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.385),(25.725,2.535),(25.875,2.535),(25.875,2.385),(25.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.705),(25.725,2.855),(25.875,2.855),(25.875,2.705),(25.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.025),(25.725,3.175),(25.875,3.175),(25.875,3.025),(25.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.345),(25.725,3.495),(25.875,3.495),(25.875,3.345),(25.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.665),(25.725,3.815),(25.875,3.815),(25.875,3.665),(25.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.985),(25.725,4.135),(25.875,4.135),(25.875,3.985),(25.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.305),(25.725,4.455),(25.875,4.455),(25.875,4.305),(25.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.625),(25.725,4.775),(25.875,4.775),(25.875,4.625),(25.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.945),(25.725,5.095),(25.875,5.095),(25.875,4.945),(25.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.265),(25.725,5.415),(25.875,5.415),(25.875,5.265),(25.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.585),(25.725,5.735),(25.875,5.735),(25.875,5.585),(25.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.905),(25.725,6.055),(25.875,6.055),(25.875,5.905),(25.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.225),(25.725,6.375),(25.875,6.375),(25.875,6.225),(25.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.545),(25.725,6.695),(25.875,6.695),(25.875,6.545),(25.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.865),(25.725,7.015),(25.875,7.015),(25.875,6.865),(25.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.185),(25.725,7.335),(25.875,7.335),(25.875,7.185),(25.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.505),(25.725,7.655),(25.875,7.655),(25.875,7.505),(25.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.825),(25.725,7.975),(25.875,7.975),(25.875,7.825),(25.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.145),(25.725,8.295),(25.875,8.295),(25.875,8.145),(25.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.465),(25.725,8.615),(25.875,8.615),(25.875,8.465),(25.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.785),(25.725,8.935),(25.875,8.935),(25.875,8.785),(25.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.105),(25.725,9.255),(25.875,9.255),(25.875,9.105),(25.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.425),(25.725,9.575),(25.875,9.575),(25.875,9.425),(25.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.745),(25.725,9.895),(25.875,9.895),(25.875,9.745),(25.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.065),(25.725,10.215),(25.875,10.215),(25.875,10.065),(25.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.385),(25.725,10.535),(25.875,10.535),(25.875,10.385),(25.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.705),(25.725,10.855),(25.875,10.855),(25.875,10.705),(25.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.025),(25.725,11.175),(25.875,11.175),(25.875,11.025),(25.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.345),(25.725,11.495),(25.875,11.495),(25.875,11.345),(25.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.665),(25.725,11.815),(25.875,11.815),(25.875,11.665),(25.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.985),(25.725,12.135),(25.875,12.135),(25.875,11.985),(25.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.305),(25.725,12.455),(25.875,12.455),(25.875,12.305),(25.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.625),(25.725,12.775),(25.875,12.775),(25.875,12.625),(25.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.945),(25.725,13.095),(25.875,13.095),(25.875,12.945),(25.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.265),(25.725,13.415),(25.875,13.415),(25.875,13.265),(25.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.585),(25.725,13.735),(25.875,13.735),(25.875,13.585),(25.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.905),(25.725,14.055),(25.875,14.055),(25.875,13.905),(25.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.225),(25.725,14.375),(25.875,14.375),(25.875,14.225),(25.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.545),(25.725,14.695),(25.875,14.695),(25.875,14.545),(25.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.865),(25.725,15.015),(25.875,15.015),(25.875,14.865),(25.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.185),(25.725,15.335),(25.875,15.335),(25.875,15.185),(25.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.505),(25.725,15.655),(25.875,15.655),(25.875,15.505),(25.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.825),(25.725,15.975),(25.875,15.975),(25.875,15.825),(25.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.145),(25.725,16.295),(25.875,16.295),(25.875,16.145),(25.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.465),(25.725,16.615),(25.875,16.615),(25.875,16.465),(25.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.785),(25.725,16.935),(25.875,16.935),(25.875,16.785),(25.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.105),(25.725,17.255),(25.875,17.255),(25.875,17.105),(25.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.425),(25.725,17.575),(25.875,17.575),(25.875,17.425),(25.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.745),(25.725,17.895),(25.875,17.895),(25.875,17.745),(25.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.065),(25.725,18.215),(25.875,18.215),(25.875,18.065),(25.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.385),(25.725,18.535),(25.875,18.535),(25.875,18.385),(25.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.705),(25.725,18.855),(25.875,18.855),(25.875,18.705),(25.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.025),(25.725,19.175),(25.875,19.175),(25.875,19.025),(25.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.345),(25.725,19.495),(25.875,19.495),(25.875,19.345),(25.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.665),(25.725,19.815),(25.875,19.815),(25.875,19.665),(25.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.985),(25.725,20.135),(25.875,20.135),(25.875,19.985),(25.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.305),(25.725,20.455),(25.875,20.455),(25.875,20.305),(25.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.625),(25.725,20.775),(25.875,20.775),(25.875,20.625),(25.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.945),(25.725,21.095),(25.875,21.095),(25.875,20.945),(25.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.265),(25.725,21.415),(25.875,21.415),(25.875,21.265),(25.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.585),(25.725,21.735),(25.875,21.735),(25.875,21.585),(25.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.905),(25.725,22.055),(25.875,22.055),(25.875,21.905),(25.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,22.225),(25.725,22.375),(25.875,22.375),(25.875,22.225),(25.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,22.545),(25.725,22.695),(25.875,22.695),(25.875,22.545),(25.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,22.865),(25.725,23.015),(25.875,23.015),(25.875,22.865),(25.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,23.185),(25.725,23.335),(25.875,23.335),(25.875,23.185),(25.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,23.505),(25.725,23.655),(25.875,23.655),(25.875,23.505),(25.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,23.825),(25.725,23.975),(25.875,23.975),(25.875,23.825),(25.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,24.145),(25.725,24.295),(25.875,24.295),(25.875,24.145),(25.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,24.465),(25.725,24.615),(25.875,24.615),(25.875,24.465),(25.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,24.785),(25.725,24.935),(25.875,24.935),(25.875,24.785),(25.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,25.105),(25.725,25.255),(25.875,25.255),(25.875,25.105),(25.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,25.425),(25.725,25.575),(25.875,25.575),(25.875,25.425),(25.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,25.745),(25.725,25.895),(25.875,25.895),(25.875,25.745),(25.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,26.065),(25.725,26.215),(25.875,26.215),(25.875,26.065),(25.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,26.385),(25.725,26.535),(25.875,26.535),(25.875,26.385),(25.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,26.705),(25.725,26.855),(25.875,26.855),(25.875,26.705),(25.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.025),(25.725,27.175),(25.875,27.175),(25.875,27.025),(25.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.345),(25.725,27.495),(25.875,27.495),(25.875,27.345),(25.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.665),(25.725,27.815),(25.875,27.815),(25.875,27.665),(25.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.985),(25.725,28.135),(25.875,28.135),(25.875,27.985),(25.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,28.305),(25.725,28.455),(25.875,28.455),(25.875,28.305),(25.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,28.625),(25.725,28.775),(25.875,28.775),(25.875,28.625),(25.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,28.945),(25.725,29.095),(25.875,29.095),(25.875,28.945),(25.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,29.265),(25.725,29.415),(25.875,29.415),(25.875,29.265),(25.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,29.585),(25.725,29.735),(25.875,29.735),(25.875,29.585),(25.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,29.905),(25.725,30.055),(25.875,30.055),(25.875,29.905),(25.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,30.225),(25.725,30.375),(25.875,30.375),(25.875,30.225),(25.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,30.545),(25.725,30.695),(25.875,30.695),(25.875,30.545),(25.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,30.865),(25.725,31.015),(25.875,31.015),(25.875,30.865),(25.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,31.185),(25.725,31.335),(25.875,31.335),(25.875,31.185),(25.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,31.505),(25.725,31.655),(25.875,31.655),(25.875,31.505),(25.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,31.825),(25.725,31.975),(25.875,31.975),(25.875,31.825),(25.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,32.145),(25.725,32.295),(25.875,32.295),(25.875,32.145),(25.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,32.465),(25.725,32.615),(25.875,32.615),(25.875,32.465),(25.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,32.785),(25.725,32.935),(25.875,32.935),(25.875,32.785),(25.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,33.105),(25.725,33.255),(25.875,33.255),(25.875,33.105),(25.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,33.425),(25.725,33.575),(25.875,33.575),(25.875,33.425),(25.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,33.745),(25.725,33.895),(25.875,33.895),(25.875,33.745),(25.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,34.065),(25.725,34.215),(25.875,34.215),(25.875,34.065),(25.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,34.385),(25.725,34.535),(25.875,34.535),(25.875,34.385),(25.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,34.705),(25.725,34.855),(25.875,34.855),(25.875,34.705),(25.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.025),(25.725,35.175),(25.875,35.175),(25.875,35.025),(25.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.345),(25.725,35.495),(25.875,35.495),(25.875,35.345),(25.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.665),(25.725,35.815),(25.875,35.815),(25.875,35.665),(25.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.985),(25.725,36.135),(25.875,36.135),(25.875,35.985),(25.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,36.305),(25.725,36.455),(25.875,36.455),(25.875,36.305),(25.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,36.625),(25.725,36.775),(25.875,36.775),(25.875,36.625),(25.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,36.945),(25.725,37.095),(25.875,37.095),(25.875,36.945),(25.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,37.265),(25.725,37.415),(25.875,37.415),(25.875,37.265),(25.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,37.585),(25.725,37.735),(25.875,37.735),(25.875,37.585),(25.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,37.905),(25.725,38.055),(25.875,38.055),(25.875,37.905),(25.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,38.225),(25.725,38.375),(25.875,38.375),(25.875,38.225),(25.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,38.545),(25.725,38.695),(25.875,38.695),(25.875,38.545),(25.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,38.865),(25.725,39.015),(25.875,39.015),(25.875,38.865),(25.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,39.185),(25.725,39.335),(25.875,39.335),(25.875,39.185),(25.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,39.505),(25.725,39.655),(25.875,39.655),(25.875,39.505),(25.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,39.825),(25.725,39.975),(25.875,39.975),(25.875,39.825),(25.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,40.145),(25.725,40.295),(25.875,40.295),(25.875,40.145),(25.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,40.465),(25.725,40.615),(25.875,40.615),(25.875,40.465),(25.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,40.785),(25.725,40.935),(25.875,40.935),(25.875,40.785),(25.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,41.105),(25.725,41.255),(25.875,41.255),(25.875,41.105),(25.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,41.425),(25.725,41.575),(25.875,41.575),(25.875,41.425),(25.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,41.745),(25.725,41.895),(25.875,41.895),(25.875,41.745),(25.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,42.065),(25.725,42.215),(25.875,42.215),(25.875,42.065),(25.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,42.385),(25.725,42.535),(25.875,42.535),(25.875,42.385),(25.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,42.705),(25.725,42.855),(25.875,42.855),(25.875,42.705),(25.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,43.025),(25.725,43.175),(25.875,43.175),(25.875,43.025),(25.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,43.345),(25.725,43.495),(25.875,43.495),(25.875,43.345),(25.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.145),(44.925,0.295),(45.075,0.295),(45.075,0.145),(44.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.465),(44.925,0.615),(45.075,0.615),(45.075,0.465),(44.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.785),(44.925,0.935),(45.075,0.935),(45.075,0.785),(44.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.105),(44.925,1.255),(45.075,1.255),(45.075,1.105),(44.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.425),(44.925,1.575),(45.075,1.575),(45.075,1.425),(44.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.745),(44.925,1.895),(45.075,1.895),(45.075,1.745),(44.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.065),(44.925,2.215),(45.075,2.215),(45.075,2.065),(44.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.385),(44.925,2.535),(45.075,2.535),(45.075,2.385),(44.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.705),(44.925,2.855),(45.075,2.855),(45.075,2.705),(44.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.025),(44.925,3.175),(45.075,3.175),(45.075,3.025),(44.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.345),(44.925,3.495),(45.075,3.495),(45.075,3.345),(44.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.665),(44.925,3.815),(45.075,3.815),(45.075,3.665),(44.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.985),(44.925,4.135),(45.075,4.135),(45.075,3.985),(44.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.305),(44.925,4.455),(45.075,4.455),(45.075,4.305),(44.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.625),(44.925,4.775),(45.075,4.775),(45.075,4.625),(44.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.945),(44.925,5.095),(45.075,5.095),(45.075,4.945),(44.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.265),(44.925,5.415),(45.075,5.415),(45.075,5.265),(44.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.585),(44.925,5.735),(45.075,5.735),(45.075,5.585),(44.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.905),(44.925,6.055),(45.075,6.055),(45.075,5.905),(44.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.225),(44.925,6.375),(45.075,6.375),(45.075,6.225),(44.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.545),(44.925,6.695),(45.075,6.695),(45.075,6.545),(44.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.865),(44.925,7.015),(45.075,7.015),(45.075,6.865),(44.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.185),(44.925,7.335),(45.075,7.335),(45.075,7.185),(44.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.505),(44.925,7.655),(45.075,7.655),(45.075,7.505),(44.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.825),(44.925,7.975),(45.075,7.975),(45.075,7.825),(44.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.145),(44.925,8.295),(45.075,8.295),(45.075,8.145),(44.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.465),(44.925,8.615),(45.075,8.615),(45.075,8.465),(44.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.785),(44.925,8.935),(45.075,8.935),(45.075,8.785),(44.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.105),(44.925,9.255),(45.075,9.255),(45.075,9.105),(44.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.425),(44.925,9.575),(45.075,9.575),(45.075,9.425),(44.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.745),(44.925,9.895),(45.075,9.895),(45.075,9.745),(44.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.065),(44.925,10.215),(45.075,10.215),(45.075,10.065),(44.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.385),(44.925,10.535),(45.075,10.535),(45.075,10.385),(44.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.705),(44.925,10.855),(45.075,10.855),(45.075,10.705),(44.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.025),(44.925,11.175),(45.075,11.175),(45.075,11.025),(44.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.345),(44.925,11.495),(45.075,11.495),(45.075,11.345),(44.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.665),(44.925,11.815),(45.075,11.815),(45.075,11.665),(44.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.985),(44.925,12.135),(45.075,12.135),(45.075,11.985),(44.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.305),(44.925,12.455),(45.075,12.455),(45.075,12.305),(44.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.625),(44.925,12.775),(45.075,12.775),(45.075,12.625),(44.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.945),(44.925,13.095),(45.075,13.095),(45.075,12.945),(44.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.265),(44.925,13.415),(45.075,13.415),(45.075,13.265),(44.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.585),(44.925,13.735),(45.075,13.735),(45.075,13.585),(44.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.905),(44.925,14.055),(45.075,14.055),(45.075,13.905),(44.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.225),(44.925,14.375),(45.075,14.375),(45.075,14.225),(44.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.545),(44.925,14.695),(45.075,14.695),(45.075,14.545),(44.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.865),(44.925,15.015),(45.075,15.015),(45.075,14.865),(44.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.185),(44.925,15.335),(45.075,15.335),(45.075,15.185),(44.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.505),(44.925,15.655),(45.075,15.655),(45.075,15.505),(44.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.825),(44.925,15.975),(45.075,15.975),(45.075,15.825),(44.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.145),(44.925,16.295),(45.075,16.295),(45.075,16.145),(44.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.465),(44.925,16.615),(45.075,16.615),(45.075,16.465),(44.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.785),(44.925,16.935),(45.075,16.935),(45.075,16.785),(44.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.105),(44.925,17.255),(45.075,17.255),(45.075,17.105),(44.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.425),(44.925,17.575),(45.075,17.575),(45.075,17.425),(44.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.745),(44.925,17.895),(45.075,17.895),(45.075,17.745),(44.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.065),(44.925,18.215),(45.075,18.215),(45.075,18.065),(44.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.385),(44.925,18.535),(45.075,18.535),(45.075,18.385),(44.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.705),(44.925,18.855),(45.075,18.855),(45.075,18.705),(44.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.025),(44.925,19.175),(45.075,19.175),(45.075,19.025),(44.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.345),(44.925,19.495),(45.075,19.495),(45.075,19.345),(44.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.665),(44.925,19.815),(45.075,19.815),(45.075,19.665),(44.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.985),(44.925,20.135),(45.075,20.135),(45.075,19.985),(44.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.305),(44.925,20.455),(45.075,20.455),(45.075,20.305),(44.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.625),(44.925,20.775),(45.075,20.775),(45.075,20.625),(44.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.945),(44.925,21.095),(45.075,21.095),(45.075,20.945),(44.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.265),(44.925,21.415),(45.075,21.415),(45.075,21.265),(44.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.585),(44.925,21.735),(45.075,21.735),(45.075,21.585),(44.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.905),(44.925,22.055),(45.075,22.055),(45.075,21.905),(44.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.225),(44.925,22.375),(45.075,22.375),(45.075,22.225),(44.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.545),(44.925,22.695),(45.075,22.695),(45.075,22.545),(44.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.865),(44.925,23.015),(45.075,23.015),(45.075,22.865),(44.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.185),(44.925,23.335),(45.075,23.335),(45.075,23.185),(44.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.505),(44.925,23.655),(45.075,23.655),(45.075,23.505),(44.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.825),(44.925,23.975),(45.075,23.975),(45.075,23.825),(44.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.145),(44.925,24.295),(45.075,24.295),(45.075,24.145),(44.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.465),(44.925,24.615),(45.075,24.615),(45.075,24.465),(44.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.785),(44.925,24.935),(45.075,24.935),(45.075,24.785),(44.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.105),(44.925,25.255),(45.075,25.255),(45.075,25.105),(44.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.425),(44.925,25.575),(45.075,25.575),(45.075,25.425),(44.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.745),(44.925,25.895),(45.075,25.895),(45.075,25.745),(44.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.065),(44.925,26.215),(45.075,26.215),(45.075,26.065),(44.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.385),(44.925,26.535),(45.075,26.535),(45.075,26.385),(44.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.705),(44.925,26.855),(45.075,26.855),(45.075,26.705),(44.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.025),(44.925,27.175),(45.075,27.175),(45.075,27.025),(44.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.345),(44.925,27.495),(45.075,27.495),(45.075,27.345),(44.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.665),(44.925,27.815),(45.075,27.815),(45.075,27.665),(44.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.985),(44.925,28.135),(45.075,28.135),(45.075,27.985),(44.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.305),(44.925,28.455),(45.075,28.455),(45.075,28.305),(44.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.625),(44.925,28.775),(45.075,28.775),(45.075,28.625),(44.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.945),(44.925,29.095),(45.075,29.095),(45.075,28.945),(44.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.265),(44.925,29.415),(45.075,29.415),(45.075,29.265),(44.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.585),(44.925,29.735),(45.075,29.735),(45.075,29.585),(44.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.905),(44.925,30.055),(45.075,30.055),(45.075,29.905),(44.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.225),(44.925,30.375),(45.075,30.375),(45.075,30.225),(44.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.545),(44.925,30.695),(45.075,30.695),(45.075,30.545),(44.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.865),(44.925,31.015),(45.075,31.015),(45.075,30.865),(44.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.185),(44.925,31.335),(45.075,31.335),(45.075,31.185),(44.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.505),(44.925,31.655),(45.075,31.655),(45.075,31.505),(44.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.825),(44.925,31.975),(45.075,31.975),(45.075,31.825),(44.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.145),(44.925,32.295),(45.075,32.295),(45.075,32.145),(44.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.465),(44.925,32.615),(45.075,32.615),(45.075,32.465),(44.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.785),(44.925,32.935),(45.075,32.935),(45.075,32.785),(44.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.105),(44.925,33.255),(45.075,33.255),(45.075,33.105),(44.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.425),(44.925,33.575),(45.075,33.575),(45.075,33.425),(44.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.745),(44.925,33.895),(45.075,33.895),(45.075,33.745),(44.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.065),(44.925,34.215),(45.075,34.215),(45.075,34.065),(44.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.385),(44.925,34.535),(45.075,34.535),(45.075,34.385),(44.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.705),(44.925,34.855),(45.075,34.855),(45.075,34.705),(44.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.025),(44.925,35.175),(45.075,35.175),(45.075,35.025),(44.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.345),(44.925,35.495),(45.075,35.495),(45.075,35.345),(44.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.665),(44.925,35.815),(45.075,35.815),(45.075,35.665),(44.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.985),(44.925,36.135),(45.075,36.135),(45.075,35.985),(44.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.305),(44.925,36.455),(45.075,36.455),(45.075,36.305),(44.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.625),(44.925,36.775),(45.075,36.775),(45.075,36.625),(44.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.945),(44.925,37.095),(45.075,37.095),(45.075,36.945),(44.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.265),(44.925,37.415),(45.075,37.415),(45.075,37.265),(44.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.585),(44.925,37.735),(45.075,37.735),(45.075,37.585),(44.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.905),(44.925,38.055),(45.075,38.055),(45.075,37.905),(44.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.225),(44.925,38.375),(45.075,38.375),(45.075,38.225),(44.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.545),(44.925,38.695),(45.075,38.695),(45.075,38.545),(44.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.865),(44.925,39.015),(45.075,39.015),(45.075,38.865),(44.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.185),(44.925,39.335),(45.075,39.335),(45.075,39.185),(44.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.505),(44.925,39.655),(45.075,39.655),(45.075,39.505),(44.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.825),(44.925,39.975),(45.075,39.975),(45.075,39.825),(44.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.145),(44.925,40.295),(45.075,40.295),(45.075,40.145),(44.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.465),(44.925,40.615),(45.075,40.615),(45.075,40.465),(44.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.785),(44.925,40.935),(45.075,40.935),(45.075,40.785),(44.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.105),(44.925,41.255),(45.075,41.255),(45.075,41.105),(44.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.425),(44.925,41.575),(45.075,41.575),(45.075,41.425),(44.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.745),(44.925,41.895),(45.075,41.895),(45.075,41.745),(44.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.065),(44.925,42.215),(45.075,42.215),(45.075,42.065),(44.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.385),(44.925,42.535),(45.075,42.535),(45.075,42.385),(44.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.705),(44.925,42.855),(45.075,42.855),(45.075,42.705),(44.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,43.025),(44.925,43.175),(45.075,43.175),(45.075,43.025),(44.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,43.345),(44.925,43.495),(45.075,43.495),(45.075,43.345),(44.925,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.145),(68.925,0.295),(69.075,0.295),(69.075,0.145),(68.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.465),(68.925,0.615),(69.075,0.615),(69.075,0.465),(68.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.785),(68.925,0.935),(69.075,0.935),(69.075,0.785),(68.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.105),(68.925,1.255),(69.075,1.255),(69.075,1.105),(68.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.425),(68.925,1.575),(69.075,1.575),(69.075,1.425),(68.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.745),(68.925,1.895),(69.075,1.895),(69.075,1.745),(68.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.065),(68.925,2.215),(69.075,2.215),(69.075,2.065),(68.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.385),(68.925,2.535),(69.075,2.535),(69.075,2.385),(68.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.705),(68.925,2.855),(69.075,2.855),(69.075,2.705),(68.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.025),(68.925,3.175),(69.075,3.175),(69.075,3.025),(68.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.345),(68.925,3.495),(69.075,3.495),(69.075,3.345),(68.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.665),(68.925,3.815),(69.075,3.815),(69.075,3.665),(68.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.985),(68.925,4.135),(69.075,4.135),(69.075,3.985),(68.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.305),(68.925,4.455),(69.075,4.455),(69.075,4.305),(68.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.625),(68.925,4.775),(69.075,4.775),(69.075,4.625),(68.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.945),(68.925,5.095),(69.075,5.095),(69.075,4.945),(68.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.265),(68.925,5.415),(69.075,5.415),(69.075,5.265),(68.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.585),(68.925,5.735),(69.075,5.735),(69.075,5.585),(68.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.905),(68.925,6.055),(69.075,6.055),(69.075,5.905),(68.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.225),(68.925,6.375),(69.075,6.375),(69.075,6.225),(68.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.545),(68.925,6.695),(69.075,6.695),(69.075,6.545),(68.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.865),(68.925,7.015),(69.075,7.015),(69.075,6.865),(68.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.185),(68.925,7.335),(69.075,7.335),(69.075,7.185),(68.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.505),(68.925,7.655),(69.075,7.655),(69.075,7.505),(68.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.825),(68.925,7.975),(69.075,7.975),(69.075,7.825),(68.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.145),(68.925,8.295),(69.075,8.295),(69.075,8.145),(68.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.465),(68.925,8.615),(69.075,8.615),(69.075,8.465),(68.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.785),(68.925,8.935),(69.075,8.935),(69.075,8.785),(68.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.105),(68.925,9.255),(69.075,9.255),(69.075,9.105),(68.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.425),(68.925,9.575),(69.075,9.575),(69.075,9.425),(68.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.745),(68.925,9.895),(69.075,9.895),(69.075,9.745),(68.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.065),(68.925,10.215),(69.075,10.215),(69.075,10.065),(68.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.385),(68.925,10.535),(69.075,10.535),(69.075,10.385),(68.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.705),(68.925,10.855),(69.075,10.855),(69.075,10.705),(68.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.025),(68.925,11.175),(69.075,11.175),(69.075,11.025),(68.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.345),(68.925,11.495),(69.075,11.495),(69.075,11.345),(68.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.665),(68.925,11.815),(69.075,11.815),(69.075,11.665),(68.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.985),(68.925,12.135),(69.075,12.135),(69.075,11.985),(68.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.305),(68.925,12.455),(69.075,12.455),(69.075,12.305),(68.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.625),(68.925,12.775),(69.075,12.775),(69.075,12.625),(68.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.945),(68.925,13.095),(69.075,13.095),(69.075,12.945),(68.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.265),(68.925,13.415),(69.075,13.415),(69.075,13.265),(68.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.585),(68.925,13.735),(69.075,13.735),(69.075,13.585),(68.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.905),(68.925,14.055),(69.075,14.055),(69.075,13.905),(68.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.225),(68.925,14.375),(69.075,14.375),(69.075,14.225),(68.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.545),(68.925,14.695),(69.075,14.695),(69.075,14.545),(68.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.865),(68.925,15.015),(69.075,15.015),(69.075,14.865),(68.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.185),(68.925,15.335),(69.075,15.335),(69.075,15.185),(68.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.505),(68.925,15.655),(69.075,15.655),(69.075,15.505),(68.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.825),(68.925,15.975),(69.075,15.975),(69.075,15.825),(68.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.145),(68.925,16.295),(69.075,16.295),(69.075,16.145),(68.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.465),(68.925,16.615),(69.075,16.615),(69.075,16.465),(68.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.785),(68.925,16.935),(69.075,16.935),(69.075,16.785),(68.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.105),(68.925,17.255),(69.075,17.255),(69.075,17.105),(68.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.425),(68.925,17.575),(69.075,17.575),(69.075,17.425),(68.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.745),(68.925,17.895),(69.075,17.895),(69.075,17.745),(68.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.065),(68.925,18.215),(69.075,18.215),(69.075,18.065),(68.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.385),(68.925,18.535),(69.075,18.535),(69.075,18.385),(68.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.705),(68.925,18.855),(69.075,18.855),(69.075,18.705),(68.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.025),(68.925,19.175),(69.075,19.175),(69.075,19.025),(68.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.345),(68.925,19.495),(69.075,19.495),(69.075,19.345),(68.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.665),(68.925,19.815),(69.075,19.815),(69.075,19.665),(68.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.985),(68.925,20.135),(69.075,20.135),(69.075,19.985),(68.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.305),(68.925,20.455),(69.075,20.455),(69.075,20.305),(68.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.625),(68.925,20.775),(69.075,20.775),(69.075,20.625),(68.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.945),(68.925,21.095),(69.075,21.095),(69.075,20.945),(68.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.265),(68.925,21.415),(69.075,21.415),(69.075,21.265),(68.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.585),(68.925,21.735),(69.075,21.735),(69.075,21.585),(68.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.905),(68.925,22.055),(69.075,22.055),(69.075,21.905),(68.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,22.225),(68.925,22.375),(69.075,22.375),(69.075,22.225),(68.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,22.545),(68.925,22.695),(69.075,22.695),(69.075,22.545),(68.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,22.865),(68.925,23.015),(69.075,23.015),(69.075,22.865),(68.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,23.185),(68.925,23.335),(69.075,23.335),(69.075,23.185),(68.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,23.505),(68.925,23.655),(69.075,23.655),(69.075,23.505),(68.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,23.825),(68.925,23.975),(69.075,23.975),(69.075,23.825),(68.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,24.145),(68.925,24.295),(69.075,24.295),(69.075,24.145),(68.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,24.465),(68.925,24.615),(69.075,24.615),(69.075,24.465),(68.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,24.785),(68.925,24.935),(69.075,24.935),(69.075,24.785),(68.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,25.105),(68.925,25.255),(69.075,25.255),(69.075,25.105),(68.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,25.425),(68.925,25.575),(69.075,25.575),(69.075,25.425),(68.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,25.745),(68.925,25.895),(69.075,25.895),(69.075,25.745),(68.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,26.065),(68.925,26.215),(69.075,26.215),(69.075,26.065),(68.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,26.385),(68.925,26.535),(69.075,26.535),(69.075,26.385),(68.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,26.705),(68.925,26.855),(69.075,26.855),(69.075,26.705),(68.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.025),(68.925,27.175),(69.075,27.175),(69.075,27.025),(68.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.345),(68.925,27.495),(69.075,27.495),(69.075,27.345),(68.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.665),(68.925,27.815),(69.075,27.815),(69.075,27.665),(68.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.985),(68.925,28.135),(69.075,28.135),(69.075,27.985),(68.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,28.305),(68.925,28.455),(69.075,28.455),(69.075,28.305),(68.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,28.625),(68.925,28.775),(69.075,28.775),(69.075,28.625),(68.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,28.945),(68.925,29.095),(69.075,29.095),(69.075,28.945),(68.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,29.265),(68.925,29.415),(69.075,29.415),(69.075,29.265),(68.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,29.585),(68.925,29.735),(69.075,29.735),(69.075,29.585),(68.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,29.905),(68.925,30.055),(69.075,30.055),(69.075,29.905),(68.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,30.225),(68.925,30.375),(69.075,30.375),(69.075,30.225),(68.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,30.545),(68.925,30.695),(69.075,30.695),(69.075,30.545),(68.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,30.865),(68.925,31.015),(69.075,31.015),(69.075,30.865),(68.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,31.185),(68.925,31.335),(69.075,31.335),(69.075,31.185),(68.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,31.505),(68.925,31.655),(69.075,31.655),(69.075,31.505),(68.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,31.825),(68.925,31.975),(69.075,31.975),(69.075,31.825),(68.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,32.145),(68.925,32.295),(69.075,32.295),(69.075,32.145),(68.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,32.465),(68.925,32.615),(69.075,32.615),(69.075,32.465),(68.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,32.785),(68.925,32.935),(69.075,32.935),(69.075,32.785),(68.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,33.105),(68.925,33.255),(69.075,33.255),(69.075,33.105),(68.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,33.425),(68.925,33.575),(69.075,33.575),(69.075,33.425),(68.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,33.745),(68.925,33.895),(69.075,33.895),(69.075,33.745),(68.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,34.065),(68.925,34.215),(69.075,34.215),(69.075,34.065),(68.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,34.385),(68.925,34.535),(69.075,34.535),(69.075,34.385),(68.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,34.705),(68.925,34.855),(69.075,34.855),(69.075,34.705),(68.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.025),(68.925,35.175),(69.075,35.175),(69.075,35.025),(68.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.345),(68.925,35.495),(69.075,35.495),(69.075,35.345),(68.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.665),(68.925,35.815),(69.075,35.815),(69.075,35.665),(68.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.985),(68.925,36.135),(69.075,36.135),(69.075,35.985),(68.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,36.305),(68.925,36.455),(69.075,36.455),(69.075,36.305),(68.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,36.625),(68.925,36.775),(69.075,36.775),(69.075,36.625),(68.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,36.945),(68.925,37.095),(69.075,37.095),(69.075,36.945),(68.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,37.265),(68.925,37.415),(69.075,37.415),(69.075,37.265),(68.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,37.585),(68.925,37.735),(69.075,37.735),(69.075,37.585),(68.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,37.905),(68.925,38.055),(69.075,38.055),(69.075,37.905),(68.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,38.225),(68.925,38.375),(69.075,38.375),(69.075,38.225),(68.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,38.545),(68.925,38.695),(69.075,38.695),(69.075,38.545),(68.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,38.865),(68.925,39.015),(69.075,39.015),(69.075,38.865),(68.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,39.185),(68.925,39.335),(69.075,39.335),(69.075,39.185),(68.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,39.505),(68.925,39.655),(69.075,39.655),(69.075,39.505),(68.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,39.825),(68.925,39.975),(69.075,39.975),(69.075,39.825),(68.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,40.145),(68.925,40.295),(69.075,40.295),(69.075,40.145),(68.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,40.465),(68.925,40.615),(69.075,40.615),(69.075,40.465),(68.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,40.785),(68.925,40.935),(69.075,40.935),(69.075,40.785),(68.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,41.105),(68.925,41.255),(69.075,41.255),(69.075,41.105),(68.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,41.425),(68.925,41.575),(69.075,41.575),(69.075,41.425),(68.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,41.745),(68.925,41.895),(69.075,41.895),(69.075,41.745),(68.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,42.065),(68.925,42.215),(69.075,42.215),(69.075,42.065),(68.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,42.385),(68.925,42.535),(69.075,42.535),(69.075,42.385),(68.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,42.705),(68.925,42.855),(69.075,42.855),(69.075,42.705),(68.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,43.025),(68.925,43.175),(69.075,43.175),(69.075,43.025),(68.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,43.345),(68.925,43.495),(69.075,43.495),(69.075,43.345),(68.925,43.345)),
        )
        createRL(
            tech, net, 'm2',
            ((16.07,0.06),(16.07,43.58),(16.33,43.58),(16.33,0.06),(16.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((64.07,0.06),(64.07,43.58),(64.33,43.58),(64.33,0.06),(64.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.06),(54.47,43.58),(54.73,43.58),(54.73,0.06),(54.47,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((20.87,0.06),(20.87,43.58),(21.13,43.58),(21.13,0.06),(20.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.06),(44.87,43.58),(45.13,43.58),(45.13,0.06),(44.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((68.87,0.06),(68.87,43.58),(69.13,43.58),(69.13,0.06),(68.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.06),(49.67,43.58),(49.93,43.58),(49.93,0.06),(49.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((30.47,0.06),(30.47,43.58),(30.73,43.58),(30.73,0.06),(30.47,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((78.47,0.06),(78.47,43.58),(78.73,43.58),(78.73,0.06),(78.47,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.06),(40.07,43.58),(40.33,43.58),(40.33,0.06),(40.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((73.67,0.06),(73.67,43.58),(73.93,43.58),(73.93,0.06),(73.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((11.27,0.06),(11.27,43.58),(11.53,43.58),(11.53,0.06),(11.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.06),(35.27,43.58),(35.53,43.58),(35.53,0.06),(35.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((59.27,0.06),(59.27,43.58),(59.53,43.58),(59.53,0.06),(59.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((83.015,0.06),(83.015,43.58),(83.275,43.58),(83.275,0.06),(83.015,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((25.67,0.06),(25.67,43.58),(25.93,43.58),(25.93,0.06),(25.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((6.725,0.06),(6.725,43.58),(6.985,43.58),(6.985,0.06),(6.725,0.06)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.36),(85.68,21.655),(86.01,21.655),(86.01,21.36),(85.68,21.36)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((39.85,2.595),(39.85,41.045),(40.55,41.045),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((30.25,2.595),(30.25,41.045),(30.95,41.045),(30.95,2.595),(30.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((25.45,2.595),(25.45,41.045),(26.15,41.045),(26.15,2.595),(25.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.65,2.595),(68.65,41.045),(69.35,41.045),(69.35,2.595),(68.65,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((73.45,2.595),(73.45,41.045),(74.15,41.045),(74.15,2.595),(73.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((78.25,2.595),(78.25,41.045),(78.95,41.045),(78.95,2.595),(78.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.65,2.595),(44.65,41.045),(45.35,41.045),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.05,2.595),(35.05,41.045),(35.75,41.045),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((6.125,2.595),(6.125,41.045),(6.95,41.045),(6.95,2.595),(6.125,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.45,2.595),(49.45,41.045),(50.15,41.045),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.25,2.595),(54.25,41.045),(54.95,41.045),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((59.05,2.595),(59.05,41.045),(59.75,41.045),(59.75,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((83.05,2.595),(83.05,41.045),(83.875,41.045),(83.875,2.595),(83.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((15.85,2.595),(15.85,41.045),(16.55,41.045),(16.55,2.595),(15.85,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((11.05,2.595),(11.05,41.045),(11.75,41.045),(11.75,2.595),(11.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((20.65,2.595),(20.65,41.045),(21.35,41.045),(21.35,2.595),(20.65,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((63.85,2.595),(63.85,41.045),(64.55,41.045),(64.55,2.595),(63.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((16.55,2.595),(16.55,41.045),(20.65,41.045),(20.65,2.595),(16.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((64.55,2.595),(64.55,41.045),(68.65,41.045),(68.65,2.595),(64.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((11.75,2.595),(11.75,41.045),(15.85,41.045),(15.85,2.595),(11.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.75,2.595),(35.75,41.045),(39.85,41.045),(39.85,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.15,2.595),(26.15,41.045),(30.25,41.045),(30.25,2.595),(26.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.75,2.595),(59.75,41.045),(63.85,41.045),(63.85,2.595),(59.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((74.15,2.595),(74.15,41.045),(78.25,41.045),(78.25,2.595),(74.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.95,2.595),(30.95,41.045),(35.05,41.045),(35.05,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((21.35,2.595),(21.35,41.045),(25.45,41.045),(25.45,2.595),(21.35,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.95,2.595),(54.95,41.045),(59.05,41.045),(59.05,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((69.35,2.595),(69.35,41.045),(73.45,41.045),(73.45,2.595),(69.35,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((78.95,2.595),(78.95,41.045),(83.05,41.045),(83.05,2.595),(78.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.55,2.595),(40.55,41.045),(44.65,41.045),(44.65,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.15,2.595),(50.15,41.045),(54.25,41.045),(54.25,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((3.905,40.045),(3.905,41.045),(4.405,41.045),(4.405,40.045),(3.905,40.045)),
        )
        createRL(
            tech, net, 'psdm',
            ((6.95,2.595),(6.95,41.045),(11.05,41.045),(11.05,2.595),(6.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.35,2.595),(45.35,41.045),(49.45,41.045),(49.45,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((6.05,2.52),(6.05,41.12),(83.95,41.12),(83.95,2.52),(6.05,2.52)),
        )
        createRL(
            tech, net, 'areaid_diode',
            ((4.025,40.165),(4.025,40.925),(4.285,40.925),(4.285,40.165),(4.025,40.165)),
        )
        createRL(
            tech, net, 'polyres',
            ((85.675,21.655),(85.675,21.985),(86.015,21.985),(86.015,21.655),(85.675,21.655)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.655),(85.68,21.985),(86.01,21.985),(86.01,21.655),(85.68,21.655)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((61.035,2.72),(61.035,40.92),(62.565,40.92),(62.565,2.72),(61.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.635,2.72),(70.635,40.92),(72.165,40.92),(72.165,2.72),(70.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.035,2.72),(13.035,40.92),(14.565,40.92),(14.565,2.72),(13.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.635,2.72),(22.635,40.92),(24.165,40.92),(24.165,2.72),(22.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.835,2.72),(65.835,40.92),(67.365,40.92),(67.365,2.72),(65.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,40.92),(48.165,40.92),(48.165,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.835,2.72),(17.835,40.92),(19.365,40.92),(19.365,2.72),(17.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,40.92),(38.565,40.92),(38.565,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,40.92),(33.765,40.92),(33.765,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.235,2.72),(80.235,40.92),(81.765,40.92),(81.765,2.72),(80.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.235,2.72),(8.235,40.92),(9.765,40.92),(9.765,2.72),(8.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.435,2.72),(27.435,40.92),(28.965,40.92),(28.965,2.72),(27.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,40.92),(43.365,40.92),(43.365,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,40.92),(57.765,40.92),(57.765,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,40.92),(52.965,40.92),(52.965,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.435,2.72),(75.435,40.92),(76.965,40.92),(76.965,2.72),(75.435,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.705),(33.085,11.875),(33.255,11.875),(33.255,11.705),(33.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.085),(66.345,14.255),(66.515,14.255),(66.515,14.085),(66.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.085),(66.685,14.255),(66.855,14.255),(66.855,14.085),(66.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.425),(66.345,14.595),(66.515,14.595),(66.515,14.425),(66.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.425),(66.685,14.595),(66.855,14.595),(66.855,14.425),(66.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.765),(66.345,14.935),(66.515,14.935),(66.515,14.765),(66.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.765),(66.685,14.935),(66.855,14.935),(66.855,14.765),(66.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.925),(23.145,6.095),(23.315,6.095),(23.315,5.925),(23.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,37.545),(8.745,37.715),(8.915,37.715),(8.915,37.545),(8.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,37.205),(8.745,37.375),(8.915,37.375),(8.915,37.205),(8.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.925),(23.485,6.095),(23.655,6.095),(23.655,5.925),(23.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,20.205),(61.885,20.375),(62.055,20.375),(62.055,20.205),(61.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,20.545),(61.885,20.715),(62.055,20.715),(62.055,20.545),(61.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.525),(32.745,19.695),(32.915,19.695),(32.915,19.525),(32.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.185),(32.745,19.355),(32.915,19.355),(32.915,19.185),(32.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.905),(47.145,39.075),(47.315,39.075),(47.315,38.905),(47.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.905),(47.485,39.075),(47.655,39.075),(47.655,38.905),(47.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.925),(13.885,6.095),(14.055,6.095),(14.055,5.925),(13.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.845),(76.285,19.015),(76.455,19.015),(76.455,18.845),(76.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.965),(76.285,8.135),(76.455,8.135),(76.455,7.965),(76.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,20.885),(75.945,21.055),(76.115,21.055),(76.115,20.885),(75.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.225),(56.745,4.395),(56.915,4.395),(56.915,4.225),(56.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.045),(42.685,12.215),(42.855,12.215),(42.855,12.045),(42.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.965),(61.885,8.135),(62.055,8.135),(62.055,7.965),(61.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.105),(32.745,15.275),(32.915,15.275),(32.915,15.105),(32.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,38.905),(23.145,39.075),(23.315,39.075),(23.315,38.905),(23.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,38.905),(23.485,39.075),(23.655,39.075),(23.655,38.905),(23.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.445),(32.745,15.615),(32.915,15.615),(32.915,15.445),(32.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.785),(32.745,15.955),(32.915,15.955),(32.915,15.785),(32.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.205),(47.145,20.375),(47.315,20.375),(47.315,20.205),(47.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.205),(47.485,20.375),(47.655,20.375),(47.655,20.205),(47.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.545),(47.145,20.715),(47.315,20.715),(47.315,20.545),(47.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.545),(47.485,20.715),(47.655,20.715),(47.655,20.545),(47.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.225),(32.745,4.395),(32.915,4.395),(32.915,4.225),(32.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.565),(32.745,4.735),(32.915,4.735),(32.915,4.565),(32.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.885),(13.545,4.055),(13.715,4.055),(13.715,3.885),(13.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,28.705),(28.285,28.875),(28.455,28.875),(28.455,28.705),(28.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,36.185),(66.345,36.355),(66.515,36.355),(66.515,36.185),(66.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,36.185),(66.685,36.355),(66.855,36.355),(66.855,36.185),(66.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,36.525),(66.345,36.695),(66.515,36.695),(66.515,36.525),(66.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,36.525),(66.685,36.695),(66.855,36.695),(66.855,36.525),(66.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.445),(37.885,32.615),(38.055,32.615),(38.055,32.445),(37.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.785),(37.885,32.955),(38.055,32.955),(38.055,32.785),(37.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.105),(37.885,32.275),(38.055,32.275),(38.055,32.105),(37.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,36.185),(75.945,36.355),(76.115,36.355),(76.115,36.185),(75.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,36.525),(75.945,36.695),(76.115,36.695),(76.115,36.525),(75.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.965),(37.545,8.135),(37.715,8.135),(37.715,7.965),(37.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,27.005),(61.885,27.175),(62.055,27.175),(62.055,27.005),(61.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,27.345),(61.885,27.515),(62.055,27.515),(62.055,27.345),(61.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,27.685),(61.885,27.855),(62.055,27.855),(62.055,27.685),(61.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.245),(27.945,5.415),(28.115,5.415),(28.115,5.245),(27.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.585),(27.945,5.755),(28.115,5.755),(28.115,5.585),(27.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.985),(71.145,9.155),(71.315,9.155),(71.315,8.985),(71.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.985),(71.485,9.155),(71.655,9.155),(71.655,8.985),(71.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.865),(56.745,3.035),(56.915,3.035),(56.915,2.865),(56.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.285),(8.745,7.455),(8.915,7.455),(8.915,7.285),(8.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.925),(52.285,23.095),(52.455,23.095),(52.455,22.925),(52.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.985),(23.145,9.155),(23.315,9.155),(23.315,8.985),(23.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.985),(23.485,9.155),(23.655,9.155),(23.655,8.985),(23.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.945),(13.545,7.115),(13.715,7.115),(13.715,6.945),(13.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,24.625),(61.545,24.795),(61.715,24.795),(61.715,24.625),(61.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,31.425),(61.885,31.595),(62.055,31.595),(62.055,31.425),(61.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,31.765),(61.885,31.935),(62.055,31.935),(62.055,31.765),(61.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,31.085),(61.885,31.255),(62.055,31.255),(62.055,31.085),(61.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,24.285),(61.885,24.455),(62.055,24.455),(62.055,24.285),(61.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,24.625),(61.885,24.795),(62.055,24.795),(62.055,24.625),(61.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.145),(61.545,17.315),(61.715,17.315),(61.715,17.145),(61.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.485),(61.545,17.655),(61.715,17.655),(61.715,17.485),(61.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,25.645),(80.745,25.815),(80.915,25.815),(80.915,25.645),(80.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,25.305),(80.745,25.475),(80.915,25.475),(80.915,25.305),(80.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.425),(18.345,14.595),(18.515,14.595),(18.515,14.425),(18.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,35.845),(13.545,36.015),(13.715,36.015),(13.715,35.845),(13.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.565),(32.745,38.735),(32.915,38.735),(32.915,38.565),(32.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.225),(32.745,38.395),(32.915,38.395),(32.915,38.225),(32.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.765),(47.145,31.935),(47.315,31.935),(47.315,31.765),(47.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.765),(47.485,31.935),(47.655,31.935),(47.655,31.765),(47.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.425),(47.145,31.595),(47.315,31.595),(47.315,31.425),(47.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.425),(47.485,31.595),(47.655,31.595),(47.655,31.425),(47.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.085),(47.145,31.255),(47.315,31.255),(47.315,31.085),(47.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.085),(47.485,31.255),(47.655,31.255),(47.655,31.085),(47.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,26.665),(32.745,26.835),(32.915,26.835),(32.915,26.665),(32.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,26.325),(32.745,26.495),(32.915,26.495),(32.915,26.325),(32.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,35.845),(9.085,36.015),(9.255,36.015),(9.255,35.845),(9.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,24.285),(9.085,24.455),(9.255,24.455),(9.255,24.285),(9.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,24.625),(9.085,24.795),(9.255,24.795),(9.255,24.625),(9.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.545),(37.885,3.715),(38.055,3.715),(38.055,3.545),(37.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.205),(37.885,3.375),(38.055,3.375),(38.055,3.205),(37.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,38.905),(61.545,39.075),(61.715,39.075),(61.715,38.905),(61.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.525),(9.085,19.695),(9.255,19.695),(9.255,19.525),(9.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.185),(9.085,19.355),(9.255,19.355),(9.255,19.185),(9.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.645),(42.685,8.815),(42.855,8.815),(42.855,8.645),(42.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.865),(33.085,3.035),(33.255,3.035),(33.255,2.865),(33.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.865),(32.745,37.035),(32.915,37.035),(32.915,36.865),(32.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.005),(71.145,10.175),(71.315,10.175),(71.315,10.005),(71.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.005),(71.485,10.175),(71.655,10.175),(71.655,10.005),(71.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.105),(52.285,15.275),(52.455,15.275),(52.455,15.105),(52.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.305),(56.745,25.475),(56.915,25.475),(56.915,25.305),(56.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.645),(56.745,25.815),(56.915,25.815),(56.915,25.645),(56.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.005),(37.545,10.175),(37.715,10.175),(37.715,10.005),(37.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.345),(37.545,10.515),(37.715,10.515),(37.715,10.345),(37.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.685),(37.545,10.855),(37.715,10.855),(37.715,10.685),(37.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,27.345),(71.145,27.515),(71.315,27.515),(71.315,27.345),(71.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,27.345),(71.485,27.515),(71.655,27.515),(71.655,27.345),(71.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,27.005),(71.145,27.175),(71.315,27.175),(71.315,27.005),(71.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,27.005),(71.485,27.175),(71.655,27.175),(71.655,27.005),(71.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,27.685),(71.145,27.855),(71.315,27.855),(71.315,27.685),(71.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,27.685),(71.485,27.855),(71.655,27.855),(71.655,27.685),(71.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,39.925),(13.545,40.095),(13.715,40.095),(13.715,39.925),(13.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.265),(37.545,23.435),(37.715,23.435),(37.715,23.265),(37.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.605),(37.545,23.775),(37.715,23.775),(37.715,23.605),(37.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.205),(13.885,3.375),(14.055,3.375),(14.055,3.205),(13.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.545),(13.885,3.715),(14.055,3.715),(14.055,3.545),(13.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.505),(52.285,18.675),(52.455,18.675),(52.455,18.505),(52.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.165),(52.285,18.335),(52.455,18.335),(52.455,18.165),(52.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.985),(56.745,9.155),(56.915,9.155),(56.915,8.985),(56.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.245),(51.945,5.415),(52.115,5.415),(52.115,5.245),(51.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.585),(51.945,5.755),(52.115,5.755),(52.115,5.585),(51.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.285),(75.945,7.455),(76.115,7.455),(76.115,7.285),(75.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.005),(42.345,10.175),(42.515,10.175),(42.515,10.005),(42.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,20.885),(13.545,21.055),(13.715,21.055),(13.715,20.885),(13.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.005),(42.685,10.175),(42.855,10.175),(42.855,10.005),(42.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.345),(42.345,10.515),(42.515,10.515),(42.515,10.345),(42.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.065),(56.745,30.235),(56.915,30.235),(56.915,30.065),(56.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.405),(56.745,30.575),(56.915,30.575),(56.915,30.405),(56.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.745),(56.745,30.915),(56.915,30.915),(56.915,30.745),(56.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.345),(42.685,10.515),(42.855,10.515),(42.855,10.345),(42.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.685),(42.345,10.855),(42.515,10.855),(42.515,10.685),(42.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.685),(42.685,10.855),(42.855,10.855),(42.855,10.685),(42.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.525),(75.945,19.695),(76.115,19.695),(76.115,19.525),(75.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,21.225),(61.545,21.395),(61.715,21.395),(61.715,21.225),(61.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,21.565),(61.545,21.735),(61.715,21.735),(61.715,21.565),(61.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.765),(47.145,14.935),(47.315,14.935),(47.315,14.765),(47.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.765),(47.485,14.935),(47.655,14.935),(47.655,14.765),(47.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.085),(47.145,14.255),(47.315,14.255),(47.315,14.085),(47.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,37.205),(76.285,37.375),(76.455,37.375),(76.455,37.205),(76.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,37.545),(76.285,37.715),(76.455,37.715),(76.455,37.545),(76.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.085),(47.485,14.255),(47.655,14.255),(47.655,14.085),(47.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.425),(47.145,14.595),(47.315,14.595),(47.315,14.425),(47.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,34.145),(80.745,34.315),(80.915,34.315),(80.915,34.145),(80.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,34.485),(80.745,34.655),(80.915,34.655),(80.915,34.485),(80.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,34.825),(80.745,34.995),(80.915,34.995),(80.915,34.825),(80.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.585),(80.745,5.755),(80.915,5.755),(80.915,5.585),(80.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.625),(52.285,7.795),(52.455,7.795),(52.455,7.625),(52.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.945),(37.545,7.115),(37.715,7.115),(37.715,6.945),(37.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.825),(47.145,34.995),(47.315,34.995),(47.315,34.825),(47.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.825),(47.485,34.995),(47.655,34.995),(47.655,34.825),(47.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.485),(47.145,34.655),(47.315,34.655),(47.315,34.485),(47.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.485),(47.485,34.655),(47.655,34.655),(47.655,34.485),(47.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.145),(47.145,34.315),(47.315,34.315),(47.315,34.145),(47.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.145),(47.485,34.315),(47.655,34.315),(47.655,34.145),(47.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.525),(33.085,19.695),(33.255,19.695),(33.255,19.525),(33.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.185),(33.085,19.355),(33.255,19.355),(33.255,19.185),(33.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.285),(27.945,7.455),(28.115,7.455),(28.115,7.285),(27.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,23.945),(28.285,24.115),(28.455,24.115),(28.455,23.945),(28.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.685),(57.085,10.855),(57.255,10.855),(57.255,10.685),(57.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.005),(57.085,10.175),(57.255,10.175),(57.255,10.005),(57.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,40.265),(32.745,40.435),(32.915,40.435),(32.915,40.265),(32.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,40.605),(32.745,40.775),(32.915,40.775),(32.915,40.605),(32.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.345),(57.085,10.515),(57.255,10.515),(57.255,10.345),(57.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.905),(32.745,5.075),(32.915,5.075),(32.915,4.905),(32.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,21.905),(76.285,22.075),(76.455,22.075),(76.455,21.905),(76.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.425),(33.085,14.595),(33.255,14.595),(33.255,14.425),(33.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,23.605),(13.545,23.775),(13.715,23.775),(13.715,23.605),(13.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,23.265),(13.545,23.435),(13.715,23.435),(13.715,23.265),(13.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.225),(9.085,4.395),(9.255,4.395),(9.255,4.225),(9.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.565),(9.085,4.735),(9.255,4.735),(9.255,4.565),(9.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.905),(8.745,5.075),(8.915,5.075),(8.915,4.905),(8.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,25.985),(13.545,26.155),(13.715,26.155),(13.715,25.985),(13.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.885),(56.745,38.055),(56.915,38.055),(56.915,37.885),(56.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,38.225),(61.885,38.395),(62.055,38.395),(62.055,38.225),(61.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,38.565),(61.885,38.735),(62.055,38.735),(62.055,38.565),(61.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,21.225),(28.285,21.395),(28.455,21.395),(28.455,21.225),(28.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,21.565),(28.285,21.735),(28.455,21.735),(28.455,21.565),(28.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.285),(56.745,7.455),(56.915,7.455),(56.915,7.285),(56.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,27.005),(80.745,27.175),(80.915,27.175),(80.915,27.005),(80.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,27.345),(80.745,27.515),(80.915,27.515),(80.915,27.345),(80.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,27.685),(80.745,27.855),(80.915,27.855),(80.915,27.685),(80.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.665),(61.885,9.835),(62.055,9.835),(62.055,9.665),(61.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.325),(61.885,9.495),(62.055,9.495),(62.055,9.325),(61.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,35.505),(13.885,35.675),(14.055,35.675),(14.055,35.505),(13.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,40.265),(52.285,40.435),(52.455,40.435),(52.455,40.265),(52.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,40.605),(52.285,40.775),(52.455,40.775),(52.455,40.605),(52.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,35.165),(13.885,35.335),(14.055,35.335),(14.055,35.165),(13.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.865),(52.285,3.035),(52.455,3.035),(52.455,2.865),(52.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.185),(23.145,19.355),(23.315,19.355),(23.315,19.185),(23.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.185),(23.485,19.355),(23.655,19.355),(23.655,19.185),(23.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.525),(23.145,19.695),(23.315,19.695),(23.315,19.525),(23.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.525),(23.485,19.695),(23.655,19.695),(23.655,19.525),(23.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.665),(71.145,9.835),(71.315,9.835),(71.315,9.665),(71.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.665),(71.485,9.835),(71.655,9.835),(71.655,9.665),(71.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.325),(71.145,9.495),(71.315,9.495),(71.315,9.325),(71.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.325),(71.485,9.495),(71.655,9.495),(71.655,9.325),(71.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,24.965),(13.545,25.135),(13.715,25.135),(13.715,24.965),(13.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.105),(33.085,15.275),(33.255,15.275),(33.255,15.105),(33.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.445),(33.085,15.615),(33.255,15.615),(33.255,15.445),(33.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.785),(33.085,15.955),(33.255,15.955),(33.255,15.785),(33.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.645),(61.545,8.815),(61.715,8.815),(61.715,8.645),(61.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.305),(61.545,8.475),(61.715,8.475),(61.715,8.305),(61.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.185),(56.745,36.355),(56.915,36.355),(56.915,36.185),(56.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.525),(56.745,36.695),(56.915,36.695),(56.915,36.525),(56.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,39.925),(61.885,40.095),(62.055,40.095),(62.055,39.925),(61.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.105),(80.745,15.275),(80.915,15.275),(80.915,15.105),(80.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.445),(80.745,15.615),(80.915,15.615),(80.915,15.445),(80.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.785),(80.745,15.955),(80.915,15.955),(80.915,15.785),(80.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,20.885),(71.145,21.055),(71.315,21.055),(71.315,20.885),(71.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,20.885),(71.485,21.055),(71.655,21.055),(71.655,20.885),(71.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.685),(52.285,10.855),(52.455,10.855),(52.455,10.685),(52.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.005),(52.285,10.175),(52.455,10.175),(52.455,10.005),(52.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.345),(52.285,10.515),(52.455,10.515),(52.455,10.345),(52.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,32.445),(81.085,32.615),(81.255,32.615),(81.255,32.445),(81.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,32.785),(81.085,32.955),(81.255,32.955),(81.255,32.785),(81.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,32.105),(81.085,32.275),(81.255,32.275),(81.255,32.105),(81.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.245),(81.085,5.415),(81.255,5.415),(81.255,5.245),(81.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.585),(81.085,5.755),(81.255,5.755),(81.255,5.585),(81.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.585),(56.745,22.755),(56.915,22.755),(56.915,22.585),(56.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.245),(56.745,22.415),(56.915,22.415),(56.915,22.245),(56.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,29.045),(61.545,29.215),(61.715,29.215),(61.715,29.045),(61.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,29.385),(61.545,29.555),(61.715,29.555),(61.715,29.385),(61.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,29.725),(61.545,29.895),(61.715,29.895),(61.715,29.725),(61.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,21.905),(66.345,22.075),(66.515,22.075),(66.515,21.905),(66.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,21.905),(66.685,22.075),(66.855,22.075),(66.855,21.905),(66.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.465),(13.545,16.635),(13.715,16.635),(13.715,16.465),(13.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.805),(13.545,16.975),(13.715,16.975),(13.715,16.805),(13.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.125),(13.545,16.295),(13.715,16.295),(13.715,16.125),(13.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,36.185),(9.085,36.355),(9.255,36.355),(9.255,36.185),(9.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,36.525),(9.085,36.695),(9.255,36.695),(9.255,36.525),(9.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.065),(71.145,13.235),(71.315,13.235),(71.315,13.065),(71.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.065),(71.485,13.235),(71.655,13.235),(71.655,13.065),(71.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.405),(71.145,13.575),(71.315,13.575),(71.315,13.405),(71.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.405),(71.485,13.575),(71.655,13.575),(71.655,13.405),(71.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.385),(71.145,12.555),(71.315,12.555),(71.315,12.385),(71.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.685),(37.885,27.855),(38.055,27.855),(38.055,27.685),(37.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.005),(37.885,27.175),(38.055,27.175),(38.055,27.005),(37.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.345),(37.885,27.515),(38.055,27.515),(38.055,27.345),(37.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.385),(71.485,12.555),(71.655,12.555),(71.655,12.385),(71.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.725),(71.145,12.895),(71.315,12.895),(71.315,12.725),(71.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.945),(13.885,7.115),(14.055,7.115),(14.055,6.945),(13.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.725),(71.485,12.895),(71.655,12.895),(71.655,12.725),(71.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.045),(71.145,12.215),(71.315,12.215),(71.315,12.045),(71.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.045),(71.485,12.215),(71.655,12.215),(71.655,12.045),(71.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,25.985),(76.285,26.155),(76.455,26.155),(76.455,25.985),(76.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.885),(37.545,21.055),(37.715,21.055),(37.715,20.885),(37.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,27.685),(13.545,27.855),(13.715,27.855),(13.715,27.685),(13.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,27.345),(13.545,27.515),(13.715,27.515),(13.715,27.345),(13.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,27.005),(13.545,27.175),(13.715,27.175),(13.715,27.005),(13.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,30.405),(27.945,30.575),(28.115,30.575),(28.115,30.405),(27.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,30.745),(27.945,30.915),(28.115,30.915),(28.115,30.745),(27.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,30.065),(27.945,30.235),(28.115,30.235),(28.115,30.065),(27.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.285),(32.745,24.455),(32.915,24.455),(32.915,24.285),(32.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.625),(32.745,24.795),(32.915,24.795),(32.915,24.625),(32.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.385),(23.145,12.555),(23.315,12.555),(23.315,12.385),(23.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.385),(23.485,12.555),(23.655,12.555),(23.655,12.385),(23.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.405),(42.345,13.575),(42.515,13.575),(42.515,13.405),(42.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.405),(42.685,13.575),(42.855,13.575),(42.855,13.405),(42.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.745),(42.345,13.915),(42.515,13.915),(42.515,13.745),(42.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.745),(42.685,13.915),(42.855,13.915),(42.855,13.745),(42.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,25.645),(28.285,25.815),(28.455,25.815),(28.455,25.645),(28.285,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,25.305),(28.285,25.475),(28.455,25.475),(28.455,25.305),(28.285,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.065),(42.345,13.235),(42.515,13.235),(42.515,13.065),(42.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.065),(42.685,13.235),(42.855,13.235),(42.855,13.065),(42.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.885),(52.285,4.055),(52.455,4.055),(52.455,3.885),(52.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.285),(51.945,7.455),(52.115,7.455),(52.115,7.285),(51.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.425),(37.885,31.595),(38.055,31.595),(38.055,31.425),(37.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.765),(37.885,31.935),(38.055,31.935),(38.055,31.765),(37.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.085),(37.885,31.255),(38.055,31.255),(38.055,31.085),(37.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.105),(81.085,15.275),(81.255,15.275),(81.255,15.105),(81.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.445),(81.085,15.615),(81.255,15.615),(81.255,15.445),(81.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.785),(81.085,15.955),(81.255,15.955),(81.255,15.785),(81.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.885),(56.745,21.055),(56.915,21.055),(56.915,20.885),(56.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,36.865),(28.285,37.035),(28.455,37.035),(28.455,36.865),(28.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.285),(37.885,24.455),(38.055,24.455),(38.055,24.285),(37.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.625),(37.885,24.795),(38.055,24.795),(38.055,24.625),(37.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,38.905),(9.085,39.075),(9.255,39.075),(9.255,38.905),(9.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.885),(8.745,4.055),(8.915,4.055),(8.915,3.885),(8.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.905),(42.345,39.075),(42.515,39.075),(42.515,38.905),(42.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.905),(42.685,39.075),(42.855,39.075),(42.855,38.905),(42.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.985),(13.885,9.155),(14.055,9.155),(14.055,8.985),(13.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.765),(9.085,14.935),(9.255,14.935),(9.255,14.765),(9.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.085),(9.085,14.255),(9.255,14.255),(9.255,14.085),(9.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.425),(9.085,14.595),(9.255,14.595),(9.255,14.425),(9.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.905),(37.545,5.075),(37.715,5.075),(37.715,4.905),(37.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,20.885),(81.085,21.055),(81.255,21.055),(81.255,20.885),(81.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.945),(56.745,7.115),(56.915,7.115),(56.915,6.945),(56.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,39.245),(13.885,39.415),(14.055,39.415),(14.055,39.245),(13.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,38.905),(75.945,39.075),(76.115,39.075),(76.115,38.905),(75.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,39.585),(13.885,39.755),(14.055,39.755),(14.055,39.585),(13.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.585),(57.085,22.755),(57.255,22.755),(57.255,22.585),(57.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.245),(57.085,22.415),(57.255,22.415),(57.255,22.245),(57.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.265),(28.285,6.435),(28.455,6.435),(28.455,6.265),(28.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.945),(32.745,7.115),(32.915,7.115),(32.915,6.945),(32.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.605),(28.285,6.775),(28.455,6.775),(28.455,6.605),(28.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,23.265),(80.745,23.435),(80.915,23.435),(80.915,23.265),(80.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,23.605),(80.745,23.775),(80.915,23.775),(80.915,23.605),(80.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.245),(42.345,22.415),(42.515,22.415),(42.515,22.245),(42.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.245),(42.685,22.415),(42.855,22.415),(42.855,22.245),(42.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.585),(42.345,22.755),(42.515,22.755),(42.515,22.585),(42.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.585),(42.685,22.755),(42.855,22.755),(42.855,22.585),(42.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.505),(13.885,18.675),(14.055,18.675),(14.055,18.505),(13.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.165),(13.885,18.335),(14.055,18.335),(14.055,18.165),(13.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,2.865),(9.085,3.035),(9.255,3.035),(9.255,2.865),(9.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.945),(8.745,7.115),(8.915,7.115),(8.915,6.945),(8.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.305),(18.345,8.475),(18.515,8.475),(18.515,8.305),(18.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.305),(18.685,8.475),(18.855,8.475),(18.855,8.305),(18.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.645),(18.345,8.815),(18.515,8.815),(18.515,8.645),(18.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.645),(18.685,8.815),(18.855,8.815),(18.855,8.645),(18.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,36.185),(80.745,36.355),(80.915,36.355),(80.915,36.185),(80.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,36.525),(80.745,36.695),(80.915,36.695),(80.915,36.525),(80.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,39.245),(80.745,39.415),(80.915,39.415),(80.915,39.245),(80.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,39.585),(80.745,39.755),(80.915,39.755),(80.915,39.585),(80.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.905),(61.545,5.075),(61.715,5.075),(61.715,4.905),(61.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,2.865),(81.085,3.035),(81.255,3.035),(81.255,2.865),(81.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,22.925),(27.945,23.095),(28.115,23.095),(28.115,22.925),(27.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.145),(71.145,17.315),(71.315,17.315),(71.315,17.145),(71.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.145),(71.485,17.315),(71.655,17.315),(71.655,17.145),(71.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.825),(71.145,17.995),(71.315,17.995),(71.315,17.825),(71.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.825),(71.485,17.995),(71.655,17.995),(71.655,17.825),(71.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.485),(71.145,17.655),(71.315,17.655),(71.315,17.485),(71.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.485),(71.485,17.655),(71.655,17.655),(71.655,17.485),(71.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.025),(56.745,28.195),(56.915,28.195),(56.915,28.025),(56.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.365),(56.745,28.535),(56.915,28.535),(56.915,28.365),(56.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.705),(56.745,28.875),(56.915,28.875),(56.915,28.705),(56.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,36.865),(13.885,37.035),(14.055,37.035),(14.055,36.865),(13.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,35.845),(8.745,36.015),(8.915,36.015),(8.915,35.845),(8.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,25.985),(13.885,26.155),(14.055,26.155),(14.055,25.985),(13.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.125),(37.545,16.295),(37.715,16.295),(37.715,16.125),(37.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.465),(37.545,16.635),(37.715,16.635),(37.715,16.465),(37.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.805),(37.545,16.975),(37.715,16.975),(37.715,16.805),(37.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.565),(56.745,4.735),(56.915,4.735),(56.915,4.565),(56.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.945),(57.085,7.115),(57.255,7.115),(57.255,6.945),(57.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.845),(52.285,36.015),(52.455,36.015),(52.455,35.845),(52.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,33.465),(61.885,33.635),(62.055,33.635),(62.055,33.465),(61.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,33.805),(61.885,33.975),(62.055,33.975),(62.055,33.805),(61.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,33.125),(61.885,33.295),(62.055,33.295),(62.055,33.125),(61.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.145),(37.885,17.315),(38.055,17.315),(38.055,17.145),(37.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.485),(37.885,17.655),(38.055,17.655),(38.055,17.485),(37.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,30.065),(66.345,30.235),(66.515,30.235),(66.515,30.065),(66.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,30.065),(66.685,30.235),(66.855,30.235),(66.855,30.065),(66.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,30.745),(66.345,30.915),(66.515,30.915),(66.515,30.745),(66.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,30.745),(66.685,30.915),(66.855,30.915),(66.855,30.745),(66.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,30.405),(66.345,30.575),(66.515,30.575),(66.515,30.405),(66.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,30.405),(66.685,30.575),(66.855,30.575),(66.855,30.405),(66.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,20.205),(27.945,20.375),(28.115,20.375),(28.115,20.205),(27.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,20.545),(27.945,20.715),(28.115,20.715),(28.115,20.545),(27.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.945),(33.085,7.115),(33.255,7.115),(33.255,6.945),(33.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.465),(52.285,16.635),(52.455,16.635),(52.455,16.465),(52.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.805),(52.285,16.975),(52.455,16.975),(52.455,16.805),(52.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.125),(52.285,16.295),(52.455,16.295),(52.455,16.125),(52.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.265),(75.945,6.435),(76.115,6.435),(76.115,6.265),(75.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.605),(75.945,6.775),(76.115,6.775),(76.115,6.605),(75.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.825),(66.685,17.995),(66.855,17.995),(66.855,17.825),(66.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.225),(80.745,4.395),(80.915,4.395),(80.915,4.225),(80.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.565),(80.745,4.735),(80.915,4.735),(80.915,4.565),(80.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.265),(51.945,23.435),(52.115,23.435),(52.115,23.265),(51.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.605),(51.945,23.775),(52.115,23.775),(52.115,23.605),(51.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,33.805),(8.745,33.975),(8.915,33.975),(8.915,33.805),(8.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,33.125),(8.745,33.295),(8.915,33.295),(8.915,33.125),(8.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,33.465),(8.745,33.635),(8.915,33.635),(8.915,33.465),(8.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,32.785),(23.485,32.955),(23.655,32.955),(23.655,32.785),(23.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.405),(47.485,13.575),(47.655,13.575),(47.655,13.405),(47.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,36.865),(76.285,37.035),(76.455,37.035),(76.455,36.865),(76.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.225),(37.885,21.395),(38.055,21.395),(38.055,21.225),(37.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.565),(37.885,21.735),(38.055,21.735),(38.055,21.565),(37.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.265),(27.945,6.435),(28.115,6.435),(28.115,6.265),(27.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,22.585),(13.885,22.755),(14.055,22.755),(14.055,22.585),(13.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,38.565),(66.345,38.735),(66.515,38.735),(66.515,38.565),(66.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,38.565),(66.685,38.735),(66.855,38.735),(66.855,38.565),(66.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,38.225),(66.345,38.395),(66.515,38.395),(66.515,38.225),(66.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,38.225),(66.685,38.395),(66.855,38.395),(66.855,38.225),(66.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.965),(51.945,25.135),(52.115,25.135),(52.115,24.965),(51.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,22.245),(13.885,22.415),(14.055,22.415),(14.055,22.245),(13.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.205),(52.285,20.375),(52.455,20.375),(52.455,20.205),(52.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.545),(52.285,20.715),(52.455,20.715),(52.455,20.545),(52.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.945),(61.885,7.115),(62.055,7.115),(62.055,6.945),(61.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.205),(32.745,20.375),(32.915,20.375),(32.915,20.205),(32.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.545),(32.745,20.715),(32.915,20.715),(32.915,20.545),(32.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,40.265),(71.145,40.435),(71.315,40.435),(71.315,40.265),(71.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,40.265),(71.485,40.435),(71.655,40.435),(71.655,40.265),(71.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,40.605),(71.145,40.775),(71.315,40.775),(71.315,40.605),(71.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,40.605),(71.485,40.775),(71.655,40.775),(71.655,40.605),(71.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.805),(52.285,33.975),(52.455,33.975),(52.455,33.805),(52.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.125),(52.285,33.295),(52.455,33.295),(52.455,33.125),(52.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.465),(52.285,33.635),(52.455,33.635),(52.455,33.465),(52.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.905),(81.085,5.075),(81.255,5.075),(81.255,4.905),(81.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.745),(57.085,13.915),(57.255,13.915),(57.255,13.745),(57.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.065),(57.085,13.235),(57.255,13.235),(57.255,13.065),(57.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.405),(57.085,13.575),(57.255,13.575),(57.255,13.405),(57.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.685),(61.545,10.855),(61.715,10.855),(61.715,10.685),(61.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.005),(61.545,10.175),(61.715,10.175),(61.715,10.005),(61.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.345),(61.545,10.515),(61.715,10.515),(61.715,10.345),(61.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.725),(52.285,12.895),(52.455,12.895),(52.455,12.725),(52.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.145),(13.885,17.315),(14.055,17.315),(14.055,17.145),(13.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.845),(27.945,19.015),(28.115,19.015),(28.115,18.845),(27.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.825),(13.885,17.995),(14.055,17.995),(14.055,17.825),(13.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.485),(13.885,17.655),(14.055,17.655),(14.055,17.485),(13.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.265),(52.285,6.435),(52.455,6.435),(52.455,6.265),(52.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.605),(52.285,6.775),(52.455,6.775),(52.455,6.605),(52.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.645),(52.285,8.815),(52.455,8.815),(52.455,8.645),(52.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.305),(52.285,8.475),(52.455,8.475),(52.455,8.305),(52.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.665),(47.145,9.835),(47.315,9.835),(47.315,9.665),(47.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.165),(37.885,18.335),(38.055,18.335),(38.055,18.165),(37.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.505),(37.885,18.675),(38.055,18.675),(38.055,18.505),(37.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.665),(47.485,9.835),(47.655,9.835),(47.655,9.665),(47.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,20.545),(23.145,20.715),(23.315,20.715),(23.315,20.545),(23.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,29.725),(23.145,29.895),(23.315,29.895),(23.315,29.725),(23.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,29.725),(23.485,29.895),(23.655,29.895),(23.655,29.725),(23.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,29.045),(23.145,29.215),(23.315,29.215),(23.315,29.045),(23.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,29.045),(23.485,29.215),(23.655,29.215),(23.655,29.045),(23.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,29.385),(23.145,29.555),(23.315,29.555),(23.315,29.385),(23.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,29.385),(23.485,29.555),(23.655,29.555),(23.655,29.385),(23.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,31.425),(61.545,31.595),(61.715,31.595),(61.715,31.425),(61.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,31.765),(61.545,31.935),(61.715,31.935),(61.715,31.765),(61.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,31.085),(61.545,31.255),(61.715,31.255),(61.715,31.085),(61.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.965),(51.945,8.135),(52.115,8.135),(52.115,7.965),(51.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.565),(51.945,38.735),(52.115,38.735),(52.115,38.565),(51.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.225),(51.945,38.395),(52.115,38.395),(52.115,38.225),(51.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,21.225),(13.885,21.395),(14.055,21.395),(14.055,21.225),(13.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,21.565),(13.885,21.735),(14.055,21.735),(14.055,21.565),(13.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.825),(51.945,34.995),(52.115,34.995),(52.115,34.825),(51.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.485),(51.945,34.655),(52.115,34.655),(52.115,34.485),(51.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.145),(51.945,34.315),(52.115,34.315),(52.115,34.145),(51.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.385),(37.545,29.555),(37.715,29.555),(37.715,29.385),(37.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.725),(37.545,29.895),(37.715,29.895),(37.715,29.725),(37.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.045),(37.545,29.215),(37.715,29.215),(37.715,29.045),(37.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,23.945),(61.885,24.115),(62.055,24.115),(62.055,23.945),(61.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,21.905),(75.945,22.075),(76.115,22.075),(76.115,21.905),(75.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.785),(51.945,15.955),(52.115,15.955),(52.115,15.785),(51.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.445),(51.945,15.615),(52.115,15.615),(52.115,15.445),(51.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.505),(13.545,18.675),(13.715,18.675),(13.715,18.505),(13.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.165),(13.545,18.335),(13.715,18.335),(13.715,18.165),(13.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.105),(51.945,15.275),(52.115,15.275),(52.115,15.105),(51.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,30.405),(13.885,30.575),(14.055,30.575),(14.055,30.405),(13.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,30.065),(13.885,30.235),(14.055,30.235),(14.055,30.065),(13.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.925),(47.145,23.095),(47.315,23.095),(47.315,22.925),(47.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.925),(47.485,23.095),(47.655,23.095),(47.655,22.925),(47.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,23.945),(80.745,24.115),(80.915,24.115),(80.915,23.945),(80.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,30.745),(13.885,30.915),(14.055,30.915),(14.055,30.745),(13.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.305),(9.085,8.475),(9.255,8.475),(9.255,8.305),(9.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,37.205),(13.545,37.375),(13.715,37.375),(13.715,37.205),(13.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,37.545),(13.545,37.715),(13.715,37.715),(13.715,37.545),(13.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.645),(9.085,8.815),(9.255,8.815),(9.255,8.645),(9.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,39.925),(71.145,40.095),(71.315,40.095),(71.315,39.925),(71.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,39.925),(71.485,40.095),(71.655,40.095),(71.655,39.925),(71.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.925),(37.545,6.095),(37.715,6.095),(37.715,5.925),(37.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,38.225),(18.345,38.395),(18.515,38.395),(18.515,38.225),(18.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,38.225),(18.685,38.395),(18.855,38.395),(18.855,38.225),(18.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,38.565),(18.345,38.735),(18.515,38.735),(18.515,38.565),(18.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,38.565),(18.685,38.735),(18.855,38.735),(18.855,38.565),(18.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.925),(33.085,40.095),(33.255,40.095),(33.255,39.925),(33.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,39.925),(80.745,40.095),(80.915,40.095),(80.915,39.925),(80.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,22.585),(13.545,22.755),(13.715,22.755),(13.715,22.585),(13.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,22.245),(13.545,22.415),(13.715,22.415),(13.715,22.245),(13.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.905),(33.085,5.075),(33.255,5.075),(33.255,4.905),(33.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.245),(37.885,22.415),(38.055,22.415),(38.055,22.245),(37.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.585),(37.885,22.755),(38.055,22.755),(38.055,22.585),(37.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.225),(52.285,21.395),(52.455,21.395),(52.455,21.225),(52.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.845),(56.745,19.015),(56.915,19.015),(56.915,18.845),(56.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,28.365),(28.285,28.535),(28.455,28.535),(28.455,28.365),(28.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.125),(42.345,16.295),(42.515,16.295),(42.515,16.125),(42.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.125),(42.685,16.295),(42.855,16.295),(42.855,16.125),(42.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.465),(42.345,16.635),(42.515,16.635),(42.515,16.465),(42.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.465),(42.685,16.635),(42.855,16.635),(42.855,16.465),(42.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.805),(42.345,16.975),(42.515,16.975),(42.515,16.805),(42.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.805),(42.685,16.975),(42.855,16.975),(42.855,16.805),(42.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.025),(66.685,11.195),(66.855,11.195),(66.855,11.025),(66.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.285),(13.885,7.455),(14.055,7.455),(14.055,7.285),(13.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.625),(37.545,7.795),(37.715,7.795),(37.715,7.625),(37.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.705),(71.145,11.875),(71.315,11.875),(71.315,11.705),(71.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.705),(71.485,11.875),(71.655,11.875),(71.655,11.705),(71.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.365),(71.145,11.535),(71.315,11.535),(71.315,11.365),(71.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.365),(71.485,11.535),(71.655,11.535),(71.655,11.365),(71.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.025),(71.145,11.195),(71.315,11.195),(71.315,11.025),(71.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.025),(71.485,11.195),(71.655,11.195),(71.655,11.025),(71.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.925),(13.545,6.095),(13.715,6.095),(13.715,5.925),(13.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.545),(75.945,3.715),(76.115,3.715),(76.115,3.545),(75.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.205),(75.945,3.375),(76.115,3.375),(76.115,3.205),(75.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.465),(57.085,16.635),(57.255,16.635),(57.255,16.465),(57.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.125),(57.085,16.295),(57.255,16.295),(57.255,16.125),(57.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,26.665),(56.745,26.835),(56.915,26.835),(56.915,26.665),(56.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,26.325),(56.745,26.495),(56.915,26.495),(56.915,26.325),(56.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.805),(57.085,16.975),(57.255,16.975),(57.255,16.805),(57.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.925),(52.285,6.095),(52.455,6.095),(52.455,5.925),(52.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.645),(66.345,8.815),(66.515,8.815),(66.515,8.645),(66.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.645),(66.685,8.815),(66.855,8.815),(66.855,8.645),(66.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.305),(66.345,8.475),(66.515,8.475),(66.515,8.305),(66.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.305),(66.685,8.475),(66.855,8.475),(66.855,8.305),(66.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.025),(23.145,11.195),(23.315,11.195),(23.315,11.025),(23.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.025),(23.485,11.195),(23.655,11.195),(23.655,11.025),(23.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.365),(23.145,11.535),(23.315,11.535),(23.315,11.365),(23.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.365),(23.485,11.535),(23.655,11.535),(23.655,11.365),(23.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.705),(23.145,11.875),(23.315,11.875),(23.315,11.705),(23.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.705),(23.485,11.875),(23.655,11.875),(23.655,11.705),(23.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.305),(76.285,8.475),(76.455,8.475),(76.455,8.305),(76.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.645),(76.285,8.815),(76.455,8.815),(76.455,8.645),(76.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.745),(47.485,30.915),(47.655,30.915),(47.655,30.745),(47.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.065),(47.145,30.235),(47.315,30.235),(47.315,30.065),(47.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.065),(47.485,30.235),(47.655,30.235),(47.655,30.065),(47.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.405),(47.145,30.575),(47.315,30.575),(47.315,30.405),(47.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.405),(47.485,30.575),(47.655,30.575),(47.655,30.405),(47.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.745),(47.145,30.915),(47.315,30.915),(47.315,30.745),(47.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.545),(27.945,3.715),(28.115,3.715),(28.115,3.545),(27.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.205),(27.945,3.375),(28.115,3.375),(28.115,3.205),(27.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.525),(52.285,19.695),(52.455,19.695),(52.455,19.525),(52.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,38.905),(76.285,39.075),(76.455,39.075),(76.455,38.905),(76.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.185),(52.285,19.355),(52.455,19.355),(52.455,19.185),(52.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.905),(80.745,5.075),(80.915,5.075),(80.915,4.905),(80.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.025),(42.345,11.195),(42.515,11.195),(42.515,11.025),(42.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.025),(42.685,11.195),(42.855,11.195),(42.855,11.025),(42.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.365),(42.345,11.535),(42.515,11.535),(42.515,11.365),(42.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.365),(42.685,11.535),(42.855,11.535),(42.855,11.365),(42.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.705),(42.345,11.875),(42.515,11.875),(42.515,11.705),(42.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.705),(42.685,11.875),(42.855,11.875),(42.855,11.705),(42.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.305),(28.285,8.475),(28.455,8.475),(28.455,8.305),(28.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.645),(28.285,8.815),(28.455,8.815),(28.455,8.645),(28.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.925),(76.285,6.095),(76.455,6.095),(76.455,5.925),(76.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.505),(47.145,18.675),(47.315,18.675),(47.315,18.505),(47.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.505),(47.485,18.675),(47.655,18.675),(47.655,18.505),(47.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.165),(47.145,18.335),(47.315,18.335),(47.315,18.165),(47.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.165),(47.485,18.335),(47.655,18.335),(47.655,18.165),(47.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.625),(13.545,7.795),(13.715,7.795),(13.715,7.625),(13.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,31.765),(8.745,31.935),(8.915,31.935),(8.915,31.765),(8.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,31.425),(8.745,31.595),(8.915,31.595),(8.915,31.425),(8.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,31.085),(8.745,31.255),(8.915,31.255),(8.915,31.085),(8.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.845),(57.085,19.015),(57.255,19.015),(57.255,18.845),(57.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,35.845),(81.085,36.015),(81.255,36.015),(81.255,35.845),(81.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.165),(37.545,18.335),(37.715,18.335),(37.715,18.165),(37.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.505),(37.545,18.675),(37.715,18.675),(37.715,18.505),(37.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.105),(75.945,15.275),(76.115,15.275),(76.115,15.105),(75.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.445),(75.945,15.615),(76.115,15.615),(76.115,15.445),(75.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.785),(75.945,15.955),(76.115,15.955),(76.115,15.785),(75.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.245),(37.545,22.415),(37.715,22.415),(37.715,22.245),(37.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.585),(37.545,22.755),(37.715,22.755),(37.715,22.585),(37.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.425),(33.085,31.595),(33.255,31.595),(33.255,31.425),(33.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.765),(33.085,31.935),(33.255,31.935),(33.255,31.765),(33.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.085),(33.085,31.255),(33.255,31.255),(33.255,31.085),(33.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.105),(27.945,15.275),(28.115,15.275),(28.115,15.105),(27.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.445),(27.945,15.615),(28.115,15.615),(28.115,15.445),(27.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.785),(27.945,15.955),(28.115,15.955),(28.115,15.785),(27.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.965),(56.745,25.135),(56.915,25.135),(56.915,24.965),(56.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.225),(51.945,21.395),(52.115,21.395),(52.115,21.225),(51.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.565),(51.945,21.735),(52.115,21.735),(52.115,21.565),(51.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,20.205),(61.545,20.375),(61.715,20.375),(61.715,20.205),(61.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,20.545),(61.545,20.715),(61.715,20.715),(61.715,20.545),(61.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.265),(52.285,23.435),(52.455,23.435),(52.455,23.265),(52.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.605),(52.285,23.775),(52.455,23.775),(52.455,23.605),(52.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,39.245),(13.545,39.415),(13.715,39.415),(13.715,39.245),(13.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,39.585),(13.545,39.755),(13.715,39.755),(13.715,39.585),(13.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.765),(56.745,14.935),(56.915,14.935),(56.915,14.765),(56.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.745),(47.145,13.915),(47.315,13.915),(47.315,13.745),(47.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.065),(47.485,13.235),(47.655,13.235),(47.655,13.065),(47.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.085),(56.745,14.255),(56.915,14.255),(56.915,14.085),(56.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,26.665),(80.745,26.835),(80.915,26.835),(80.915,26.665),(80.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,26.325),(80.745,26.495),(80.915,26.495),(80.915,26.325),(80.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.145),(51.945,17.315),(52.115,17.315),(52.115,17.145),(51.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.825),(51.945,17.995),(52.115,17.995),(52.115,17.825),(51.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.485),(51.945,17.655),(52.115,17.655),(52.115,17.485),(51.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,26.665),(57.085,26.835),(57.255,26.835),(57.255,26.665),(57.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,26.325),(57.085,26.495),(57.255,26.495),(57.255,26.325),(57.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.445),(37.545,32.615),(37.715,32.615),(37.715,32.445),(37.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.785),(37.545,32.955),(37.715,32.955),(37.715,32.785),(37.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.105),(37.545,32.275),(37.715,32.275),(37.715,32.105),(37.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.425),(37.545,31.595),(37.715,31.595),(37.715,31.425),(37.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.765),(37.545,31.935),(37.715,31.935),(37.715,31.765),(37.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.085),(37.545,31.255),(37.715,31.255),(37.715,31.085),(37.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.945),(57.085,24.115),(57.255,24.115),(57.255,23.945),(57.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,23.605),(8.745,23.775),(8.915,23.775),(8.915,23.605),(8.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,23.265),(8.745,23.435),(8.915,23.435),(8.915,23.265),(8.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.745),(51.945,13.915),(52.115,13.915),(52.115,13.745),(51.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.065),(51.945,13.235),(52.115,13.235),(52.115,13.065),(51.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.405),(51.945,13.575),(52.115,13.575),(52.115,13.405),(51.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,25.305),(61.885,25.475),(62.055,25.475),(62.055,25.305),(61.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,25.645),(61.885,25.815),(62.055,25.815),(62.055,25.645),(61.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.345),(76.285,10.515),(76.455,10.515),(76.455,10.345),(76.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,37.545),(71.145,37.715),(71.315,37.715),(71.315,37.545),(71.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,37.545),(71.485,37.715),(71.655,37.715),(71.655,37.545),(71.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,37.205),(71.145,37.375),(71.315,37.375),(71.315,37.205),(71.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,37.205),(71.485,37.375),(71.655,37.375),(71.655,37.205),(71.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.685),(76.285,10.855),(76.455,10.855),(76.455,10.685),(76.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.105),(37.885,15.275),(38.055,15.275),(38.055,15.105),(37.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.445),(37.885,15.615),(38.055,15.615),(38.055,15.445),(37.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.785),(37.885,15.955),(38.055,15.955),(38.055,15.785),(37.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.905),(56.745,22.075),(56.915,22.075),(56.915,21.905),(56.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.905),(37.885,5.075),(38.055,5.075),(38.055,4.905),(37.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,21.225),(76.285,21.395),(76.455,21.395),(76.455,21.225),(76.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,21.565),(76.285,21.735),(76.455,21.735),(76.455,21.565),(76.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,35.845),(23.485,36.015),(23.655,36.015),(23.655,35.845),(23.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,35.845),(23.145,36.015),(23.315,36.015),(23.315,35.845),(23.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,25.985),(66.345,26.155),(66.515,26.155),(66.515,25.985),(66.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,25.985),(66.685,26.155),(66.855,26.155),(66.855,25.985),(66.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.925),(57.085,6.095),(57.255,6.095),(57.255,5.925),(57.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.105),(42.685,32.275),(42.855,32.275),(42.855,32.105),(42.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.445),(42.345,32.615),(42.515,32.615),(42.515,32.445),(42.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.445),(42.685,32.615),(42.855,32.615),(42.855,32.445),(42.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.785),(42.345,32.955),(42.515,32.955),(42.515,32.785),(42.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.785),(42.685,32.955),(42.855,32.955),(42.855,32.785),(42.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.105),(42.345,32.275),(42.515,32.275),(42.515,32.105),(42.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.205),(56.745,37.375),(56.915,37.375),(56.915,37.205),(56.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.865),(47.145,37.035),(47.315,37.035),(47.315,36.865),(47.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.865),(47.485,37.035),(47.655,37.035),(47.655,36.865),(47.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.545),(56.745,37.715),(56.915,37.715),(56.915,37.545),(56.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,29.045),(61.885,29.215),(62.055,29.215),(62.055,29.045),(61.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,29.385),(61.885,29.555),(62.055,29.555),(62.055,29.385),(61.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,29.725),(61.885,29.895),(62.055,29.895),(62.055,29.725),(61.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,24.965),(27.945,25.135),(28.115,25.135),(28.115,24.965),(27.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.605),(27.945,6.775),(28.115,6.775),(28.115,6.605),(27.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.925),(33.085,6.095),(33.255,6.095),(33.255,5.925),(33.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.585),(71.145,5.755),(71.315,5.755),(71.315,5.585),(71.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,36.865),(23.145,37.035),(23.315,37.035),(23.315,36.865),(23.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,36.865),(23.485,37.035),(23.655,37.035),(23.655,36.865),(23.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,26.665),(52.285,26.835),(52.455,26.835),(52.455,26.665),(52.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,26.325),(52.285,26.495),(52.455,26.495),(52.455,26.325),(52.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,28.365),(76.285,28.535),(76.455,28.535),(76.455,28.365),(76.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.885),(37.545,38.055),(37.715,38.055),(37.715,37.885),(37.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,35.165),(28.285,35.335),(28.455,35.335),(28.455,35.165),(28.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,35.505),(28.285,35.675),(28.455,35.675),(28.455,35.505),(28.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.185),(80.745,19.355),(80.915,19.355),(80.915,19.185),(80.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.525),(80.745,19.695),(80.915,19.695),(80.915,19.525),(80.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,28.025),(61.545,28.195),(61.715,28.195),(61.715,28.025),(61.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,28.365),(61.545,28.535),(61.715,28.535),(61.715,28.365),(61.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,28.705),(61.545,28.875),(61.715,28.875),(61.715,28.705),(61.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.765),(18.345,14.935),(18.515,14.935),(18.515,14.765),(18.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,26.665),(61.885,26.835),(62.055,26.835),(62.055,26.665),(61.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,26.325),(61.885,26.495),(62.055,26.495),(62.055,26.325),(61.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.145),(37.885,34.315),(38.055,34.315),(38.055,34.145),(37.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.485),(37.885,34.655),(38.055,34.655),(38.055,34.485),(37.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.825),(37.885,34.995),(38.055,34.995),(38.055,34.825),(37.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.065),(52.285,30.235),(52.455,30.235),(52.455,30.065),(52.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.405),(52.285,30.575),(52.455,30.575),(52.455,30.405),(52.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.745),(52.285,30.915),(52.455,30.915),(52.455,30.745),(52.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.625),(57.085,7.795),(57.255,7.795),(57.255,7.625),(57.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,35.505),(80.745,35.675),(80.915,35.675),(80.915,35.505),(80.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,35.165),(80.745,35.335),(80.915,35.335),(80.915,35.165),(80.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.465),(8.745,16.635),(8.915,16.635),(8.915,16.465),(8.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.805),(8.745,16.975),(8.915,16.975),(8.915,16.805),(8.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.045),(47.145,29.215),(47.315,29.215),(47.315,29.045),(47.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.045),(47.485,29.215),(47.655,29.215),(47.655,29.045),(47.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.385),(47.145,29.555),(47.315,29.555),(47.315,29.385),(47.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.385),(47.485,29.555),(47.655,29.555),(47.655,29.385),(47.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.725),(47.145,29.895),(47.315,29.895),(47.315,29.725),(47.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.725),(47.485,29.895),(47.655,29.895),(47.655,29.725),(47.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.125),(8.745,16.295),(8.915,16.295),(8.915,16.125),(8.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.185),(81.085,19.355),(81.255,19.355),(81.255,19.185),(81.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,39.245),(81.085,39.415),(81.255,39.415),(81.255,39.245),(81.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,39.585),(81.085,39.755),(81.255,39.755),(81.255,39.585),(81.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.625),(33.085,7.795),(33.255,7.795),(33.255,7.625),(33.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,28.025),(23.485,28.195),(23.655,28.195),(23.655,28.025),(23.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,28.025),(23.145,28.195),(23.315,28.195),(23.315,28.025),(23.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,28.705),(23.145,28.875),(23.315,28.875),(23.315,28.705),(23.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,28.705),(23.485,28.875),(23.655,28.875),(23.655,28.705),(23.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.165),(37.545,35.335),(37.715,35.335),(37.715,35.165),(37.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.505),(37.545,35.675),(37.715,35.675),(37.715,35.505),(37.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,28.365),(23.145,28.535),(23.315,28.535),(23.315,28.365),(23.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,28.365),(23.485,28.535),(23.655,28.535),(23.655,28.365),(23.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,21.225),(66.345,21.395),(66.515,21.395),(66.515,21.225),(66.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,21.225),(66.685,21.395),(66.855,21.395),(66.855,21.225),(66.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,21.565),(66.345,21.735),(66.515,21.735),(66.515,21.565),(66.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,21.565),(66.685,21.735),(66.855,21.735),(66.855,21.565),(66.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.905),(18.345,5.075),(18.515,5.075),(18.515,4.905),(18.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.905),(18.685,5.075),(18.855,5.075),(18.855,4.905),(18.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.825),(9.085,17.995),(9.255,17.995),(9.255,17.825),(9.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.485),(9.085,17.655),(9.255,17.655),(9.255,17.485),(9.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.185),(37.545,36.355),(37.715,36.355),(37.715,36.185),(37.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.525),(37.545,36.695),(37.715,36.695),(37.715,36.525),(37.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,30.065),(75.945,30.235),(76.115,30.235),(76.115,30.065),(75.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,30.405),(75.945,30.575),(76.115,30.575),(76.115,30.405),(75.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,30.745),(75.945,30.915),(76.115,30.915),(76.115,30.745),(75.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,25.305),(76.285,25.475),(76.455,25.475),(76.455,25.305),(76.285,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,25.645),(76.285,25.815),(76.455,25.815),(76.455,25.645),(76.285,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,28.025),(80.745,28.195),(80.915,28.195),(80.915,28.025),(80.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,28.365),(80.745,28.535),(80.915,28.535),(80.915,28.365),(80.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,28.705),(80.745,28.875),(80.915,28.875),(80.915,28.705),(80.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,37.885),(23.145,38.055),(23.315,38.055),(23.315,37.885),(23.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,37.885),(23.485,38.055),(23.655,38.055),(23.655,37.885),(23.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,29.725),(8.745,29.895),(8.915,29.895),(8.915,29.725),(8.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,29.385),(8.745,29.555),(8.915,29.555),(8.915,29.385),(8.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,29.045),(8.745,29.215),(8.915,29.215),(8.915,29.045),(8.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,32.785),(18.345,32.955),(18.515,32.955),(18.515,32.785),(18.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,32.785),(18.685,32.955),(18.855,32.955),(18.855,32.785),(18.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,32.105),(18.345,32.275),(18.515,32.275),(18.515,32.105),(18.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,32.105),(18.685,32.275),(18.855,32.275),(18.855,32.105),(18.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,32.445),(18.345,32.615),(18.515,32.615),(18.515,32.445),(18.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,32.445),(18.685,32.615),(18.855,32.615),(18.855,32.445),(18.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,22.245),(28.285,22.415),(28.455,22.415),(28.455,22.245),(28.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,22.585),(28.285,22.755),(28.455,22.755),(28.455,22.585),(28.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.265),(23.145,6.435),(23.315,6.435),(23.315,6.265),(23.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.265),(23.485,6.435),(23.655,6.435),(23.655,6.265),(23.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.605),(23.145,6.775),(23.315,6.775),(23.315,6.605),(23.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.605),(23.485,6.775),(23.655,6.775),(23.655,6.605),(23.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,36.185),(61.885,36.355),(62.055,36.355),(62.055,36.185),(61.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,36.525),(61.885,36.695),(62.055,36.695),(62.055,36.525),(61.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.125),(32.745,16.295),(32.915,16.295),(32.915,16.125),(32.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.465),(32.745,16.635),(32.915,16.635),(32.915,16.465),(32.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.805),(32.745,16.975),(32.915,16.975),(32.915,16.805),(32.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.885),(42.345,21.055),(42.515,21.055),(42.515,20.885),(42.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.885),(42.685,21.055),(42.855,21.055),(42.855,20.885),(42.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.845),(61.885,19.015),(62.055,19.015),(62.055,18.845),(61.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.645),(47.145,8.815),(47.315,8.815),(47.315,8.645),(47.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.645),(47.485,8.815),(47.655,8.815),(47.655,8.645),(47.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.305),(47.145,8.475),(47.315,8.475),(47.315,8.305),(47.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.305),(47.485,8.475),(47.655,8.475),(47.655,8.305),(47.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.305),(81.085,8.475),(81.255,8.475),(81.255,8.305),(81.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.645),(81.085,8.815),(81.255,8.815),(81.255,8.645),(81.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.665),(66.345,9.835),(66.515,9.835),(66.515,9.665),(66.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.665),(66.685,9.835),(66.855,9.835),(66.855,9.665),(66.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.325),(66.345,9.495),(66.515,9.495),(66.515,9.325),(66.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.325),(66.685,9.495),(66.855,9.495),(66.855,9.325),(66.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.625),(81.085,7.795),(81.255,7.795),(81.255,7.625),(81.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,36.525),(8.745,36.695),(8.915,36.695),(8.915,36.525),(8.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,36.185),(8.745,36.355),(8.915,36.355),(8.915,36.185),(8.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.545),(33.085,37.715),(33.255,37.715),(33.255,37.545),(33.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.205),(33.085,37.375),(33.255,37.375),(33.255,37.205),(33.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,39.925),(13.885,40.095),(14.055,40.095),(14.055,39.925),(13.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.065),(27.945,13.235),(28.115,13.235),(28.115,13.065),(27.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.405),(27.945,13.575),(28.115,13.575),(28.115,13.405),(27.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.745),(27.945,13.915),(28.115,13.915),(28.115,13.745),(27.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.145),(47.145,17.315),(47.315,17.315),(47.315,17.145),(47.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.145),(47.485,17.315),(47.655,17.315),(47.655,17.145),(47.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.825),(47.145,17.995),(47.315,17.995),(47.315,17.825),(47.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.825),(47.485,17.995),(47.655,17.995),(47.655,17.825),(47.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.485),(47.145,17.655),(47.315,17.655),(47.315,17.485),(47.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.485),(47.485,17.655),(47.655,17.655),(47.655,17.485),(47.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.585),(61.885,5.755),(62.055,5.755),(62.055,5.585),(61.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.245),(61.885,5.415),(62.055,5.415),(62.055,5.245),(61.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.905),(42.345,5.075),(42.515,5.075),(42.515,4.905),(42.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.905),(42.685,5.075),(42.855,5.075),(42.855,4.905),(42.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,22.925),(75.945,23.095),(76.115,23.095),(76.115,22.925),(75.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.025),(56.745,11.195),(56.915,11.195),(56.915,11.025),(56.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.365),(56.745,11.535),(56.915,11.535),(56.915,11.365),(56.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.705),(56.745,11.875),(56.915,11.875),(56.915,11.705),(56.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,23.945),(8.745,24.115),(8.915,24.115),(8.915,23.945),(8.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,38.905),(13.545,39.075),(13.715,39.075),(13.715,38.905),(13.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,21.905),(18.345,22.075),(18.515,22.075),(18.515,21.905),(18.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,21.905),(18.685,22.075),(18.855,22.075),(18.855,21.905),(18.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,26.665),(28.285,26.835),(28.455,26.835),(28.455,26.665),(28.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,26.325),(28.285,26.495),(28.455,26.495),(28.455,26.325),(28.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.945),(42.345,24.115),(42.515,24.115),(42.515,23.945),(42.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.945),(42.685,24.115),(42.855,24.115),(42.855,23.945),(42.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.405),(37.545,13.575),(37.715,13.575),(37.715,13.405),(37.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.705),(42.345,28.875),(42.515,28.875),(42.515,28.705),(42.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.705),(42.685,28.875),(42.855,28.875),(42.855,28.705),(42.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.365),(42.345,28.535),(42.515,28.535),(42.515,28.365),(42.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.365),(42.685,28.535),(42.855,28.535),(42.855,28.365),(42.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.025),(42.345,28.195),(42.515,28.195),(42.515,28.025),(42.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.025),(42.685,28.195),(42.855,28.195),(42.855,28.025),(42.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.745),(37.545,13.915),(37.715,13.915),(37.715,13.745),(37.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.065),(37.545,13.235),(37.715,13.235),(37.715,13.065),(37.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.785),(47.145,32.955),(47.315,32.955),(47.315,32.785),(47.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.785),(47.485,32.955),(47.655,32.955),(47.655,32.785),(47.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.105),(47.145,32.275),(47.315,32.275),(47.315,32.105),(47.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.105),(47.485,32.275),(47.655,32.275),(47.655,32.105),(47.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.445),(47.145,32.615),(47.315,32.615),(47.315,32.445),(47.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.445),(47.485,32.615),(47.655,32.615),(47.655,32.445),(47.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,34.825),(9.085,34.995),(9.255,34.995),(9.255,34.825),(9.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,34.485),(9.085,34.655),(9.255,34.655),(9.255,34.485),(9.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,34.145),(9.085,34.315),(9.255,34.315),(9.255,34.145),(9.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,30.405),(28.285,30.575),(28.455,30.575),(28.455,30.405),(28.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,30.745),(28.285,30.915),(28.455,30.915),(28.455,30.745),(28.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,30.065),(28.285,30.235),(28.455,30.235),(28.455,30.065),(28.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.765),(51.945,14.935),(52.115,14.935),(52.115,14.765),(51.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.085),(51.945,14.255),(52.115,14.255),(52.115,14.085),(51.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.425),(51.945,14.595),(52.115,14.595),(52.115,14.425),(51.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.845),(37.885,36.015),(38.055,36.015),(38.055,35.845),(37.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,22.925),(61.885,23.095),(62.055,23.095),(62.055,22.925),(61.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,36.865),(71.145,37.035),(71.315,37.035),(71.315,36.865),(71.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,36.865),(71.485,37.035),(71.655,37.035),(71.655,36.865),(71.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.425),(32.745,14.595),(32.915,14.595),(32.915,14.425),(32.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.765),(32.745,14.935),(32.915,14.935),(32.915,14.765),(32.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.765),(13.885,14.935),(14.055,14.935),(14.055,14.765),(13.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.085),(13.885,14.255),(14.055,14.255),(14.055,14.085),(13.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.425),(13.885,14.595),(14.055,14.595),(14.055,14.425),(13.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.225),(61.885,4.395),(62.055,4.395),(62.055,4.225),(61.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.105),(23.145,15.275),(23.315,15.275),(23.315,15.105),(23.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.565),(61.885,4.735),(62.055,4.735),(62.055,4.565),(61.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.005),(23.145,10.175),(23.315,10.175),(23.315,10.005),(23.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.005),(23.485,10.175),(23.655,10.175),(23.655,10.005),(23.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.345),(23.145,10.515),(23.315,10.515),(23.315,10.345),(23.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.345),(23.485,10.515),(23.655,10.515),(23.655,10.345),(23.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.045),(57.085,29.215),(57.255,29.215),(57.255,29.045),(57.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.385),(57.085,29.555),(57.255,29.555),(57.255,29.385),(57.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.725),(57.085,29.895),(57.255,29.895),(57.255,29.725),(57.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.985),(47.145,26.155),(47.315,26.155),(47.315,25.985),(47.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,26.665),(61.545,26.835),(61.715,26.835),(61.715,26.665),(61.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.985),(47.485,26.155),(47.655,26.155),(47.655,25.985),(47.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,26.325),(61.545,26.495),(61.715,26.495),(61.715,26.325),(61.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.305),(33.085,8.475),(33.255,8.475),(33.255,8.305),(33.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.645),(33.085,8.815),(33.255,8.815),(33.255,8.645),(33.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.385),(57.085,12.555),(57.255,12.555),(57.255,12.385),(57.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.725),(57.085,12.895),(57.255,12.895),(57.255,12.725),(57.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.045),(57.085,12.215),(57.255,12.215),(57.255,12.045),(57.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.305),(37.885,25.475),(38.055,25.475),(38.055,25.305),(37.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.645),(37.885,25.815),(38.055,25.815),(38.055,25.645),(37.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.325),(18.345,9.495),(18.515,9.495),(18.515,9.325),(18.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.325),(18.685,9.495),(18.855,9.495),(18.855,9.325),(18.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.665),(18.345,9.835),(18.515,9.835),(18.515,9.665),(18.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.665),(18.685,9.835),(18.855,9.835),(18.855,9.665),(18.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.885),(37.885,38.055),(38.055,38.055),(38.055,37.885),(37.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.285),(52.285,24.455),(52.455,24.455),(52.455,24.285),(52.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.625),(52.285,24.795),(52.455,24.795),(52.455,24.625),(52.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,37.545),(13.885,37.715),(14.055,37.715),(14.055,37.545),(13.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,37.205),(13.885,37.375),(14.055,37.375),(14.055,37.205),(13.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.785),(66.685,15.955),(66.855,15.955),(66.855,15.785),(66.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.845),(75.945,19.015),(76.115,19.015),(76.115,18.845),(75.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.565),(37.545,38.735),(37.715,38.735),(37.715,38.565),(37.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.225),(37.545,38.395),(37.715,38.395),(37.715,38.225),(37.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,30.065),(61.545,30.235),(61.715,30.235),(61.715,30.065),(61.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,30.405),(61.545,30.575),(61.715,30.575),(61.715,30.405),(61.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,30.745),(61.545,30.915),(61.715,30.915),(61.715,30.745),(61.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.885),(57.085,38.055),(57.255,38.055),(57.255,37.885),(57.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.285),(37.545,24.455),(37.715,24.455),(37.715,24.285),(37.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.385),(37.885,29.555),(38.055,29.555),(38.055,29.385),(37.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.725),(37.885,29.895),(38.055,29.895),(38.055,29.725),(37.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.045),(37.885,29.215),(38.055,29.215),(38.055,29.045),(37.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.625),(37.545,24.795),(37.715,24.795),(37.715,24.625),(37.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.765),(81.085,14.935),(81.255,14.935),(81.255,14.765),(81.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.085),(81.085,14.255),(81.255,14.255),(81.255,14.085),(81.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.425),(81.085,14.595),(81.255,14.595),(81.255,14.425),(81.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.025),(52.285,28.195),(52.455,28.195),(52.455,28.025),(52.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.365),(52.285,28.535),(52.455,28.535),(52.455,28.365),(52.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.705),(52.285,28.875),(52.455,28.875),(52.455,28.705),(52.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.885),(47.145,38.055),(47.315,38.055),(47.315,37.885),(47.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.885),(47.485,38.055),(47.655,38.055),(47.655,37.885),(47.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.265),(47.145,6.435),(47.315,6.435),(47.315,6.265),(47.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.865),(47.145,20.035),(47.315,20.035),(47.315,19.865),(47.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.145),(42.345,17.315),(42.515,17.315),(42.515,17.145),(42.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.145),(42.685,17.315),(42.855,17.315),(42.855,17.145),(42.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.485),(42.345,17.655),(42.515,17.655),(42.515,17.485),(42.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.485),(42.685,17.655),(42.855,17.655),(42.855,17.485),(42.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.825),(42.345,17.995),(42.515,17.995),(42.515,17.825),(42.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.825),(42.685,17.995),(42.855,17.995),(42.855,17.825),(42.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.865),(47.485,20.035),(47.655,20.035),(47.655,19.865),(47.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.265),(47.485,6.435),(47.655,6.435),(47.655,6.265),(47.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,24.285),(66.345,24.455),(66.515,24.455),(66.515,24.285),(66.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,24.285),(66.685,24.455),(66.855,24.455),(66.855,24.285),(66.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,24.625),(66.345,24.795),(66.515,24.795),(66.515,24.625),(66.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,24.625),(66.685,24.795),(66.855,24.795),(66.855,24.625),(66.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.705),(37.545,28.875),(37.715,28.875),(37.715,28.705),(37.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.365),(37.545,28.535),(37.715,28.535),(37.715,28.365),(37.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.025),(37.545,28.195),(37.715,28.195),(37.715,28.025),(37.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,2.865),(75.945,3.035),(76.115,3.035),(76.115,2.865),(75.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,35.845),(61.545,36.015),(61.715,36.015),(61.715,35.845),(61.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,26.665),(37.885,26.835),(38.055,26.835),(38.055,26.665),(37.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,26.325),(37.885,26.495),(38.055,26.495),(38.055,26.325),(37.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,36.865),(81.085,37.035),(81.255,37.035),(81.255,36.865),(81.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,35.165),(71.145,35.335),(71.315,35.335),(71.315,35.165),(71.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,35.165),(71.485,35.335),(71.655,35.335),(71.655,35.165),(71.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,35.505),(71.145,35.675),(71.315,35.675),(71.315,35.505),(71.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,35.505),(71.485,35.675),(71.655,35.675),(71.655,35.505),(71.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.765),(51.945,31.935),(52.115,31.935),(52.115,31.765),(51.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.425),(51.945,31.595),(52.115,31.595),(52.115,31.425),(51.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.085),(51.945,31.255),(52.115,31.255),(52.115,31.085),(51.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.245),(57.085,39.415),(57.255,39.415),(57.255,39.245),(57.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.585),(57.085,39.755),(57.255,39.755),(57.255,39.585),(57.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,2.865),(27.945,3.035),(28.115,3.035),(28.115,2.865),(27.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.185),(57.085,36.355),(57.255,36.355),(57.255,36.185),(57.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.525),(57.085,36.695),(57.255,36.695),(57.255,36.525),(57.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.105),(61.885,15.275),(62.055,15.275),(62.055,15.105),(61.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.445),(61.885,15.615),(62.055,15.615),(62.055,15.445),(61.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.785),(61.885,15.955),(62.055,15.955),(62.055,15.785),(61.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,20.885),(9.085,21.055),(9.255,21.055),(9.255,20.885),(9.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.225),(57.085,21.395),(57.255,21.395),(57.255,21.225),(57.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.345),(51.945,27.515),(52.115,27.515),(52.115,27.345),(51.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,30.065),(18.345,30.235),(18.515,30.235),(18.515,30.065),(18.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,30.065),(18.685,30.235),(18.855,30.235),(18.855,30.065),(18.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.005),(51.945,27.175),(52.115,27.175),(52.115,27.005),(51.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.685),(51.945,27.855),(52.115,27.855),(52.115,27.685),(51.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,36.865),(18.345,37.035),(18.515,37.035),(18.515,36.865),(18.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.785),(52.285,32.955),(52.455,32.955),(52.455,32.785),(52.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.105),(52.285,32.275),(52.455,32.275),(52.455,32.105),(52.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.445),(52.285,32.615),(52.455,32.615),(52.455,32.445),(52.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,36.865),(18.685,37.035),(18.855,37.035),(18.855,36.865),(18.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,23.945),(76.285,24.115),(76.455,24.115),(76.455,23.945),(76.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.425),(18.685,14.595),(18.855,14.595),(18.855,14.425),(18.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.985),(33.085,26.155),(33.255,26.155),(33.255,25.985),(33.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.405),(32.745,30.575),(32.915,30.575),(32.915,30.405),(32.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.745),(32.745,30.915),(32.915,30.915),(32.915,30.745),(32.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.065),(32.745,30.235),(32.915,30.235),(32.915,30.065),(32.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.905),(57.085,39.075),(57.255,39.075),(57.255,38.905),(57.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,32.105),(66.345,32.275),(66.515,32.275),(66.515,32.105),(66.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,32.105),(66.685,32.275),(66.855,32.275),(66.855,32.105),(66.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,32.445),(66.345,32.615),(66.515,32.615),(66.515,32.445),(66.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,32.445),(66.685,32.615),(66.855,32.615),(66.855,32.445),(66.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,32.785),(66.345,32.955),(66.515,32.955),(66.515,32.785),(66.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,32.785),(66.685,32.955),(66.855,32.955),(66.855,32.785),(66.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.905),(37.885,39.075),(38.055,39.075),(38.055,38.905),(37.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.305),(8.745,8.475),(8.915,8.475),(8.915,8.305),(8.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.645),(8.745,8.815),(8.915,8.815),(8.915,8.645),(8.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,39.925),(61.545,40.095),(61.715,40.095),(61.715,39.925),(61.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.025),(37.545,11.195),(37.715,11.195),(37.715,11.025),(37.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.365),(37.545,11.535),(37.715,11.535),(37.715,11.365),(37.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.705),(37.545,11.875),(37.715,11.875),(37.715,11.705),(37.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,37.885),(81.085,38.055),(81.255,38.055),(81.255,37.885),(81.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.525),(27.945,19.695),(28.115,19.695),(28.115,19.525),(27.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.185),(27.945,19.355),(28.115,19.355),(28.115,19.185),(27.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.665),(56.745,9.835),(56.915,9.835),(56.915,9.665),(56.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.325),(56.745,9.495),(56.915,9.495),(56.915,9.325),(56.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.265),(61.545,6.435),(61.715,6.435),(61.715,6.265),(61.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.605),(61.545,6.775),(61.715,6.775),(61.715,6.605),(61.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,24.285),(28.285,24.455),(28.455,24.455),(28.455,24.285),(28.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,24.625),(28.285,24.795),(28.455,24.795),(28.455,24.625),(28.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.885),(75.945,4.055),(76.115,4.055),(76.115,3.885),(75.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.245),(52.285,5.415),(52.455,5.415),(52.455,5.245),(52.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.585),(52.285,5.755),(52.455,5.755),(52.455,5.585),(52.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,40.605),(81.085,40.775),(81.255,40.775),(81.255,40.605),(81.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,40.265),(81.085,40.435),(81.255,40.435),(81.255,40.265),(81.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.105),(37.545,15.275),(37.715,15.275),(37.715,15.105),(37.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.445),(37.545,15.615),(37.715,15.615),(37.715,15.445),(37.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.785),(37.545,15.955),(37.715,15.955),(37.715,15.785),(37.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.885),(27.945,4.055),(28.115,4.055),(28.115,3.885),(27.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.465),(51.945,16.635),(52.115,16.635),(52.115,16.465),(51.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.805),(51.945,16.975),(52.115,16.975),(52.115,16.805),(51.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.125),(51.945,16.295),(52.115,16.295),(52.115,16.125),(51.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.905),(51.945,5.075),(52.115,5.075),(52.115,4.905),(51.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.625),(8.745,7.795),(8.915,7.795),(8.915,7.625),(8.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.845),(56.745,36.015),(56.915,36.015),(56.915,35.845),(56.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,34.145),(27.945,34.315),(28.115,34.315),(28.115,34.145),(27.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,34.485),(27.945,34.655),(28.115,34.655),(28.115,34.485),(27.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,34.825),(27.945,34.995),(28.115,34.995),(28.115,34.825),(27.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,31.425),(23.485,31.595),(23.655,31.595),(23.655,31.425),(23.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,31.425),(23.145,31.595),(23.315,31.595),(23.315,31.425),(23.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,31.765),(23.485,31.935),(23.655,31.935),(23.655,31.765),(23.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,31.765),(23.145,31.935),(23.315,31.935),(23.315,31.765),(23.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,31.085),(23.145,31.255),(23.315,31.255),(23.315,31.085),(23.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,31.085),(23.485,31.255),(23.655,31.255),(23.655,31.085),(23.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,40.265),(8.745,40.435),(8.915,40.435),(8.915,40.265),(8.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,40.605),(8.745,40.775),(8.915,40.775),(8.915,40.605),(8.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.265),(9.085,6.435),(9.255,6.435),(9.255,6.265),(9.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.605),(9.085,6.775),(9.255,6.775),(9.255,6.605),(9.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,35.505),(61.885,35.675),(62.055,35.675),(62.055,35.505),(61.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,35.165),(61.885,35.335),(62.055,35.335),(62.055,35.165),(61.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.525),(8.745,19.695),(8.915,19.695),(8.915,19.525),(8.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.185),(8.745,19.355),(8.915,19.355),(8.915,19.185),(8.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.345),(52.285,27.515),(52.455,27.515),(52.455,27.345),(52.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.005),(52.285,27.175),(52.455,27.175),(52.455,27.005),(52.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.685),(52.285,27.855),(52.455,27.855),(52.455,27.685),(52.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.245),(76.285,5.415),(76.455,5.415),(76.455,5.245),(76.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.585),(76.285,5.755),(76.455,5.755),(76.455,5.585),(76.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.425),(57.085,31.595),(57.255,31.595),(57.255,31.425),(57.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.765),(57.085,31.935),(57.255,31.935),(57.255,31.765),(57.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.085),(57.085,31.255),(57.255,31.255),(57.255,31.085),(57.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.605),(71.145,6.775),(71.315,6.775),(71.315,6.605),(71.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.605),(71.485,6.775),(71.655,6.775),(71.655,6.605),(71.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.265),(71.145,6.435),(71.315,6.435),(71.315,6.265),(71.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.265),(71.485,6.435),(71.655,6.435),(71.655,6.265),(71.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.405),(33.085,30.575),(33.255,30.575),(33.255,30.405),(33.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.745),(33.085,30.915),(33.255,30.915),(33.255,30.745),(33.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.065),(33.085,30.235),(33.255,30.235),(33.255,30.065),(33.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,31.425),(27.945,31.595),(28.115,31.595),(28.115,31.425),(27.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,31.765),(27.945,31.935),(28.115,31.935),(28.115,31.765),(27.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,31.085),(27.945,31.255),(28.115,31.255),(28.115,31.085),(27.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.025),(47.145,11.195),(47.315,11.195),(47.315,11.025),(47.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.905),(33.085,22.075),(33.255,22.075),(33.255,21.905),(33.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.025),(47.485,11.195),(47.655,11.195),(47.655,11.025),(47.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,35.845),(76.285,36.015),(76.455,36.015),(76.455,35.845),(76.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.465),(56.745,33.635),(56.915,33.635),(56.915,33.465),(56.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.805),(56.745,33.975),(56.915,33.975),(56.915,33.805),(56.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.125),(56.745,33.295),(56.915,33.295),(56.915,33.125),(56.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,2.865),(28.285,3.035),(28.455,3.035),(28.455,2.865),(28.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,21.905),(23.145,22.075),(23.315,22.075),(23.315,21.905),(23.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,21.905),(23.485,22.075),(23.655,22.075),(23.655,21.905),(23.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.905),(27.945,5.075),(28.115,5.075),(28.115,4.905),(27.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.125),(32.745,33.295),(32.915,33.295),(32.915,33.125),(32.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.465),(32.745,33.635),(32.915,33.635),(32.915,33.465),(32.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.805),(32.745,33.975),(32.915,33.975),(32.915,33.805),(32.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,26.665),(37.545,26.835),(37.715,26.835),(37.715,26.665),(37.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,26.325),(37.545,26.495),(37.715,26.495),(37.715,26.325),(37.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.405),(75.945,13.575),(76.115,13.575),(76.115,13.405),(75.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.745),(75.945,13.915),(76.115,13.915),(76.115,13.745),(75.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.065),(75.945,13.235),(76.115,13.235),(76.115,13.065),(75.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,27.685),(27.945,27.855),(28.115,27.855),(28.115,27.685),(27.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,27.345),(27.945,27.515),(28.115,27.515),(28.115,27.345),(27.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,27.005),(27.945,27.175),(28.115,27.175),(28.115,27.005),(27.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.985),(37.545,9.155),(37.715,9.155),(37.715,8.985),(37.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.865),(61.545,20.035),(61.715,20.035),(61.715,19.865),(61.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,28.025),(13.885,28.195),(14.055,28.195),(14.055,28.025),(13.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,28.365),(13.885,28.535),(14.055,28.535),(14.055,28.365),(13.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,28.705),(13.885,28.875),(14.055,28.875),(14.055,28.705),(13.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.565),(33.085,38.735),(33.255,38.735),(33.255,38.565),(33.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.225),(33.085,38.395),(33.255,38.395),(33.255,38.225),(33.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.605),(47.145,6.775),(47.315,6.775),(47.315,6.605),(47.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.605),(47.485,6.775),(47.655,6.775),(47.655,6.605),(47.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,39.245),(8.745,39.415),(8.915,39.415),(8.915,39.245),(8.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,39.585),(8.745,39.755),(8.915,39.755),(8.915,39.585),(8.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,25.645),(9.085,25.815),(9.255,25.815),(9.255,25.645),(9.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,25.305),(9.085,25.475),(9.255,25.475),(9.255,25.305),(9.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,26.665),(42.345,26.835),(42.515,26.835),(42.515,26.665),(42.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,26.665),(42.685,26.835),(42.855,26.835),(42.855,26.665),(42.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.405),(37.545,30.575),(37.715,30.575),(37.715,30.405),(37.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.745),(37.545,30.915),(37.715,30.915),(37.715,30.745),(37.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.065),(37.545,30.235),(37.715,30.235),(37.715,30.065),(37.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,26.325),(42.345,26.495),(42.515,26.495),(42.515,26.325),(42.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.605),(33.085,23.775),(33.255,23.775),(33.255,23.605),(33.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.265),(33.085,23.435),(33.255,23.435),(33.255,23.265),(33.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,26.325),(42.685,26.495),(42.855,26.495),(42.855,26.325),(42.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.205),(57.085,3.375),(57.255,3.375),(57.255,3.205),(57.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.545),(57.085,3.715),(57.255,3.715),(57.255,3.545),(57.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.745),(61.545,13.915),(61.715,13.915),(61.715,13.745),(61.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.045),(51.945,29.215),(52.115,29.215),(52.115,29.045),(51.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.385),(51.945,29.555),(52.115,29.555),(52.115,29.385),(51.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.725),(51.945,29.895),(52.115,29.895),(52.115,29.725),(51.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.065),(61.545,13.235),(61.715,13.235),(61.715,13.065),(61.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.405),(61.545,13.575),(61.715,13.575),(61.715,13.405),(61.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.545),(33.085,3.715),(33.255,3.715),(33.255,3.545),(33.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.205),(33.085,3.375),(33.255,3.375),(33.255,3.205),(33.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,38.225),(80.745,38.395),(80.915,38.395),(80.915,38.225),(80.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,38.565),(80.745,38.735),(80.915,38.735),(80.915,38.565),(80.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.765),(75.945,14.935),(76.115,14.935),(76.115,14.765),(75.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,24.625),(80.745,24.795),(80.915,24.795),(80.915,24.625),(80.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,24.285),(80.745,24.455),(80.915,24.455),(80.915,24.285),(80.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.085),(75.945,14.255),(76.115,14.255),(76.115,14.085),(75.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.425),(75.945,14.595),(76.115,14.595),(76.115,14.425),(75.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.245),(47.145,5.415),(47.315,5.415),(47.315,5.245),(47.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.245),(47.485,5.415),(47.655,5.415),(47.655,5.245),(47.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.585),(47.145,5.755),(47.315,5.755),(47.315,5.585),(47.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.585),(47.485,5.755),(47.655,5.755),(47.655,5.585),(47.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.245),(23.145,5.415),(23.315,5.415),(23.315,5.245),(23.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.245),(23.485,5.415),(23.655,5.415),(23.655,5.245),(23.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.585),(23.145,5.755),(23.315,5.755),(23.315,5.585),(23.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.585),(23.485,5.755),(23.655,5.755),(23.655,5.585),(23.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.305),(51.945,25.475),(52.115,25.475),(52.115,25.305),(51.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.645),(51.945,25.815),(52.115,25.815),(52.115,25.645),(51.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.745),(8.745,13.915),(8.915,13.915),(8.915,13.745),(8.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.065),(8.745,13.235),(8.915,13.235),(8.915,13.065),(8.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.085),(27.945,14.255),(28.115,14.255),(28.115,14.085),(27.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.425),(27.945,14.595),(28.115,14.595),(28.115,14.425),(27.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.765),(27.945,14.935),(28.115,14.935),(28.115,14.765),(27.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.405),(8.745,13.575),(8.915,13.575),(8.915,13.405),(8.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.885),(51.945,21.055),(52.115,21.055),(52.115,20.885),(51.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,23.945),(61.545,24.115),(61.715,24.115),(61.715,23.945),(61.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,20.205),(75.945,20.375),(76.115,20.375),(76.115,20.205),(75.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,20.545),(75.945,20.715),(76.115,20.715),(76.115,20.545),(75.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,31.425),(81.085,31.595),(81.255,31.595),(81.255,31.425),(81.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,31.765),(81.085,31.935),(81.255,31.935),(81.255,31.765),(81.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,31.085),(81.085,31.255),(81.255,31.255),(81.255,31.085),(81.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.225),(56.745,21.395),(56.915,21.395),(56.915,21.225),(56.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.565),(56.745,21.735),(56.915,21.735),(56.915,21.565),(56.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.885),(47.145,21.055),(47.315,21.055),(47.315,20.885),(47.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.885),(47.485,21.055),(47.655,21.055),(47.655,20.885),(47.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.345),(71.145,10.515),(71.315,10.515),(71.315,10.345),(71.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.345),(71.485,10.515),(71.655,10.515),(71.655,10.345),(71.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.685),(71.145,10.855),(71.315,10.855),(71.315,10.685),(71.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,20.885),(13.885,21.055),(14.055,21.055),(14.055,20.885),(13.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.685),(71.485,10.855),(71.655,10.855),(71.655,10.685),(71.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.285),(47.145,24.455),(47.315,24.455),(47.315,24.285),(47.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.285),(47.485,24.455),(47.655,24.455),(47.655,24.285),(47.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.625),(47.145,24.795),(47.315,24.795),(47.315,24.625),(47.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.625),(47.485,24.795),(47.655,24.795),(47.655,24.625),(47.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.945),(51.945,7.115),(52.115,7.115),(52.115,6.945),(51.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.605),(66.345,6.775),(66.515,6.775),(66.515,6.605),(66.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.605),(66.685,6.775),(66.855,6.775),(66.855,6.605),(66.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.265),(66.345,6.435),(66.515,6.435),(66.515,6.265),(66.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,25.305),(66.345,25.475),(66.515,25.475),(66.515,25.305),(66.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,25.305),(66.685,25.475),(66.855,25.475),(66.855,25.305),(66.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,25.645),(66.345,25.815),(66.515,25.815),(66.515,25.645),(66.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,36.865),(66.345,37.035),(66.515,37.035),(66.515,36.865),(66.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,36.865),(66.685,37.035),(66.855,37.035),(66.855,36.865),(66.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,25.645),(66.685,25.815),(66.855,25.815),(66.855,25.645),(66.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.545),(81.085,3.715),(81.255,3.715),(81.255,3.545),(81.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.205),(81.085,3.375),(81.255,3.375),(81.255,3.205),(81.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.025),(47.145,28.195),(47.315,28.195),(47.315,28.025),(47.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.025),(47.485,28.195),(47.655,28.195),(47.655,28.025),(47.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.365),(47.145,28.535),(47.315,28.535),(47.315,28.365),(47.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.365),(47.485,28.535),(47.655,28.535),(47.655,28.365),(47.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.125),(33.085,33.295),(33.255,33.295),(33.255,33.125),(33.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.465),(33.085,33.635),(33.255,33.635),(33.255,33.465),(33.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.805),(33.085,33.975),(33.255,33.975),(33.255,33.805),(33.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.705),(47.145,28.875),(47.315,28.875),(47.315,28.705),(47.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.705),(47.485,28.875),(47.655,28.875),(47.655,28.705),(47.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,32.105),(27.945,32.275),(28.115,32.275),(28.115,32.105),(27.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,32.445),(27.945,32.615),(28.115,32.615),(28.115,32.445),(27.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,32.785),(27.945,32.955),(28.115,32.955),(28.115,32.785),(27.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.925),(27.945,6.095),(28.115,6.095),(28.115,5.925),(27.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.165),(42.345,18.335),(42.515,18.335),(42.515,18.165),(42.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.165),(42.685,18.335),(42.855,18.335),(42.855,18.165),(42.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.505),(42.345,18.675),(42.515,18.675),(42.515,18.505),(42.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.505),(42.685,18.675),(42.855,18.675),(42.855,18.505),(42.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.545),(51.945,37.715),(52.115,37.715),(52.115,37.545),(51.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.205),(51.945,37.375),(52.115,37.375),(52.115,37.205),(51.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,24.285),(18.345,24.455),(18.515,24.455),(18.515,24.285),(18.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,24.285),(18.685,24.455),(18.855,24.455),(18.855,24.285),(18.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,24.625),(18.345,24.795),(18.515,24.795),(18.515,24.625),(18.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,24.625),(18.685,24.795),(18.855,24.795),(18.855,24.625),(18.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.765),(18.685,14.935),(18.855,14.935),(18.855,14.765),(18.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,29.045),(71.145,29.215),(71.315,29.215),(71.315,29.045),(71.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,29.045),(71.485,29.215),(71.655,29.215),(71.655,29.045),(71.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,29.385),(71.145,29.555),(71.315,29.555),(71.315,29.385),(71.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,29.385),(71.485,29.555),(71.655,29.555),(71.655,29.385),(71.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,28.025),(71.145,28.195),(71.315,28.195),(71.315,28.025),(71.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,28.025),(71.485,28.195),(71.655,28.195),(71.655,28.025),(71.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,28.365),(71.145,28.535),(71.315,28.535),(71.315,28.365),(71.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,28.365),(71.485,28.535),(71.655,28.535),(71.655,28.365),(71.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,28.705),(71.145,28.875),(71.315,28.875),(71.315,28.705),(71.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,29.725),(71.145,29.895),(71.315,29.895),(71.315,29.725),(71.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,28.705),(71.485,28.875),(71.655,28.875),(71.655,28.705),(71.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.965),(8.745,8.135),(8.915,8.135),(8.915,7.965),(8.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.185),(61.885,19.355),(62.055,19.355),(62.055,19.185),(61.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.525),(61.885,19.695),(62.055,19.695),(62.055,19.525),(61.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.305),(32.745,8.475),(32.915,8.475),(32.915,8.305),(32.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.645),(32.745,8.815),(32.915,8.815),(32.915,8.645),(32.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.385),(56.745,12.555),(56.915,12.555),(56.915,12.385),(56.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.725),(56.745,12.895),(56.915,12.895),(56.915,12.725),(56.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.045),(56.745,12.215),(56.915,12.215),(56.915,12.045),(56.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.965),(42.345,8.135),(42.515,8.135),(42.515,7.965),(42.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,39.245),(23.145,39.415),(23.315,39.415),(23.315,39.245),(23.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,39.245),(23.485,39.415),(23.655,39.415),(23.655,39.245),(23.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,39.585),(23.145,39.755),(23.315,39.755),(23.315,39.585),(23.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,37.885),(18.345,38.055),(18.515,38.055),(18.515,37.885),(18.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,37.885),(18.685,38.055),(18.855,38.055),(18.855,37.885),(18.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.905),(32.745,39.075),(32.915,39.075),(32.915,38.905),(32.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,39.585),(23.485,39.755),(23.655,39.755),(23.655,39.585),(23.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.965),(42.685,8.135),(42.855,8.135),(42.855,7.965),(42.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,24.965),(13.885,25.135),(14.055,25.135),(14.055,24.965),(13.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,24.965),(9.085,25.135),(9.255,25.135),(9.255,24.965),(9.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.465),(61.885,16.635),(62.055,16.635),(62.055,16.465),(61.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.125),(61.885,16.295),(62.055,16.295),(62.055,16.125),(61.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.805),(61.885,16.975),(62.055,16.975),(62.055,16.805),(61.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.465),(47.145,16.635),(47.315,16.635),(47.315,16.465),(47.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.225),(27.945,4.395),(28.115,4.395),(28.115,4.225),(27.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.565),(27.945,4.735),(28.115,4.735),(28.115,4.565),(27.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.465),(47.485,16.635),(47.655,16.635),(47.655,16.465),(47.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.805),(47.145,16.975),(47.315,16.975),(47.315,16.805),(47.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.805),(47.485,16.975),(47.655,16.975),(47.655,16.805),(47.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.125),(47.145,16.295),(47.315,16.295),(47.315,16.125),(47.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.125),(47.485,16.295),(47.655,16.295),(47.655,16.125),(47.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,26.665),(66.345,26.835),(66.515,26.835),(66.515,26.665),(66.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,26.665),(66.685,26.835),(66.855,26.835),(66.855,26.665),(66.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,26.325),(66.345,26.495),(66.515,26.495),(66.515,26.325),(66.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,26.325),(66.685,26.495),(66.855,26.495),(66.855,26.325),(66.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.285),(33.085,24.455),(33.255,24.455),(33.255,24.285),(33.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.625),(33.085,24.795),(33.255,24.795),(33.255,24.625),(33.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.265),(18.345,6.435),(18.515,6.435),(18.515,6.265),(18.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,29.725),(27.945,29.895),(28.115,29.895),(28.115,29.725),(27.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,29.385),(27.945,29.555),(28.115,29.555),(28.115,29.385),(27.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,29.045),(27.945,29.215),(28.115,29.215),(28.115,29.045),(27.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,20.205),(80.745,20.375),(80.915,20.375),(80.915,20.205),(80.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,20.545),(80.745,20.715),(80.915,20.715),(80.915,20.545),(80.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.625),(51.945,7.795),(52.115,7.795),(52.115,7.625),(51.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,25.985),(18.345,26.155),(18.515,26.155),(18.515,25.985),(18.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,25.985),(18.685,26.155),(18.855,26.155),(18.855,25.985),(18.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.025),(61.545,11.195),(61.715,11.195),(61.715,11.025),(61.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.365),(61.545,11.535),(61.715,11.535),(61.715,11.365),(61.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.705),(61.545,11.875),(61.715,11.875),(61.715,11.705),(61.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.885),(37.885,21.055),(38.055,21.055),(38.055,20.885),(37.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,39.925),(8.745,40.095),(8.915,40.095),(8.915,39.925),(8.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.985),(51.945,9.155),(52.115,9.155),(52.115,8.985),(51.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.565),(52.285,4.735),(52.455,4.735),(52.455,4.565),(52.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.225),(52.285,4.395),(52.455,4.395),(52.455,4.225),(52.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.145),(8.745,17.315),(8.915,17.315),(8.915,17.145),(8.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.825),(8.745,17.995),(8.915,17.995),(8.915,17.825),(8.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.485),(8.745,17.655),(8.915,17.655),(8.915,17.485),(8.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,25.645),(27.945,25.815),(28.115,25.815),(28.115,25.645),(27.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,25.305),(27.945,25.475),(28.115,25.475),(28.115,25.305),(27.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.405),(37.885,13.575),(38.055,13.575),(38.055,13.405),(37.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.745),(37.885,13.915),(38.055,13.915),(38.055,13.745),(37.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.065),(37.885,13.235),(38.055,13.235),(38.055,13.065),(37.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.925),(18.345,6.095),(18.515,6.095),(18.515,5.925),(18.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.925),(18.685,6.095),(18.855,6.095),(18.855,5.925),(18.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.885),(9.085,4.055),(9.255,4.055),(9.255,3.885),(9.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,27.685),(9.085,27.855),(9.255,27.855),(9.255,27.685),(9.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,27.345),(9.085,27.515),(9.255,27.515),(9.255,27.345),(9.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,27.005),(9.085,27.175),(9.255,27.175),(9.255,27.005),(9.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.845),(52.285,19.015),(52.455,19.015),(52.455,18.845),(52.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,28.705),(66.345,28.875),(66.515,28.875),(66.515,28.705),(66.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,28.705),(66.685,28.875),(66.855,28.875),(66.855,28.705),(66.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,28.025),(66.345,28.195),(66.515,28.195),(66.515,28.025),(66.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,28.025),(66.685,28.195),(66.855,28.195),(66.855,28.025),(66.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,34.145),(71.145,34.315),(71.315,34.315),(71.315,34.145),(71.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,34.145),(71.485,34.315),(71.655,34.315),(71.655,34.145),(71.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,34.485),(71.145,34.655),(71.315,34.655),(71.315,34.485),(71.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,34.485),(71.485,34.655),(71.655,34.655),(71.655,34.485),(71.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,34.825),(71.145,34.995),(71.315,34.995),(71.315,34.825),(71.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,34.825),(71.485,34.995),(71.655,34.995),(71.655,34.825),(71.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,36.865),(27.945,37.035),(28.115,37.035),(28.115,36.865),(27.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.925),(51.945,6.095),(52.115,6.095),(52.115,5.925),(51.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.385),(37.545,12.555),(37.715,12.555),(37.715,12.385),(37.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.725),(37.545,12.895),(37.715,12.895),(37.715,12.725),(37.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.045),(37.545,12.215),(37.715,12.215),(37.715,12.045),(37.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.825),(37.885,17.995),(38.055,17.995),(38.055,17.825),(37.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.105),(61.545,15.275),(61.715,15.275),(61.715,15.105),(61.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.445),(61.545,15.615),(61.715,15.615),(61.715,15.445),(61.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.785),(61.545,15.955),(61.715,15.955),(61.715,15.785),(61.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.965),(18.345,8.135),(18.515,8.135),(18.515,7.965),(18.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.965),(18.685,8.135),(18.855,8.135),(18.855,7.965),(18.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.005),(37.885,10.175),(38.055,10.175),(38.055,10.005),(37.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.345),(37.885,10.515),(38.055,10.515),(38.055,10.345),(37.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.725),(23.145,12.895),(23.315,12.895),(23.315,12.725),(23.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.685),(37.885,10.855),(38.055,10.855),(38.055,10.685),(37.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,21.225),(18.345,21.395),(18.515,21.395),(18.515,21.225),(18.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,21.225),(18.685,21.395),(18.855,21.395),(18.855,21.225),(18.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,21.565),(18.345,21.735),(18.515,21.735),(18.515,21.565),(18.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,21.565),(18.685,21.735),(18.855,21.735),(18.855,21.565),(18.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.605),(42.345,6.775),(42.515,6.775),(42.515,6.605),(42.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.605),(42.685,6.775),(42.855,6.775),(42.855,6.605),(42.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.265),(42.345,6.435),(42.515,6.435),(42.515,6.265),(42.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.265),(42.685,6.435),(42.855,6.435),(42.855,6.265),(42.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,26.665),(23.145,26.835),(23.315,26.835),(23.315,26.665),(23.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,26.665),(23.485,26.835),(23.655,26.835),(23.655,26.665),(23.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,26.325),(23.145,26.495),(23.315,26.495),(23.315,26.325),(23.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,26.325),(23.485,26.495),(23.655,26.495),(23.655,26.325),(23.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.505),(57.085,35.675),(57.255,35.675),(57.255,35.505),(57.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.165),(57.085,35.335),(57.255,35.335),(57.255,35.165),(57.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.445),(9.085,15.615),(9.255,15.615),(9.255,15.445),(9.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.025),(57.085,28.195),(57.255,28.195),(57.255,28.025),(57.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.365),(57.085,28.535),(57.255,28.535),(57.255,28.365),(57.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.225),(56.745,38.395),(56.915,38.395),(56.915,38.225),(56.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.565),(56.745,38.735),(56.915,38.735),(56.915,38.565),(56.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.705),(57.085,28.875),(57.255,28.875),(57.255,28.705),(57.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.165),(33.085,35.335),(33.255,35.335),(33.255,35.165),(33.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.505),(33.085,35.675),(33.255,35.675),(33.255,35.505),(33.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,25.645),(13.545,25.815),(13.715,25.815),(13.715,25.645),(13.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,25.305),(13.545,25.475),(13.715,25.475),(13.715,25.305),(13.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,27.685),(28.285,27.855),(28.455,27.855),(28.455,27.685),(28.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,27.345),(28.285,27.515),(28.455,27.515),(28.455,27.345),(28.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,27.005),(28.285,27.175),(28.455,27.175),(28.455,27.005),(28.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.145),(57.085,17.315),(57.255,17.315),(57.255,17.145),(57.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.485),(57.085,17.655),(57.255,17.655),(57.255,17.485),(57.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.825),(57.085,17.995),(57.255,17.995),(57.255,17.825),(57.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,30.065),(23.485,30.235),(23.655,30.235),(23.655,30.065),(23.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,30.065),(23.145,30.235),(23.315,30.235),(23.315,30.065),(23.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,30.405),(23.145,30.575),(23.315,30.575),(23.315,30.405),(23.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,30.405),(23.485,30.575),(23.655,30.575),(23.655,30.405),(23.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,30.745),(23.145,30.915),(23.315,30.915),(23.315,30.745),(23.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,30.745),(23.485,30.915),(23.655,30.915),(23.655,30.745),(23.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,34.145),(66.345,34.315),(66.515,34.315),(66.515,34.145),(66.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,34.145),(66.685,34.315),(66.855,34.315),(66.855,34.145),(66.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,34.485),(66.345,34.655),(66.515,34.655),(66.515,34.485),(66.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,34.485),(66.685,34.655),(66.855,34.655),(66.855,34.485),(66.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,34.825),(66.345,34.995),(66.515,34.995),(66.515,34.825),(66.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,34.825),(66.685,34.995),(66.855,34.995),(66.855,34.825),(66.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,26.665),(51.945,26.835),(52.115,26.835),(52.115,26.665),(51.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,26.325),(51.945,26.495),(52.115,26.495),(52.115,26.325),(51.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.145),(42.345,34.315),(42.515,34.315),(42.515,34.145),(42.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.145),(42.685,34.315),(42.855,34.315),(42.855,34.145),(42.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.485),(42.345,34.655),(42.515,34.655),(42.515,34.485),(42.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.485),(42.685,34.655),(42.855,34.655),(42.855,34.485),(42.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.825),(42.345,34.995),(42.515,34.995),(42.515,34.825),(42.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.825),(42.685,34.995),(42.855,34.995),(42.855,34.825),(42.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.985),(61.545,9.155),(61.715,9.155),(61.715,8.985),(61.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.865),(56.745,37.035),(56.915,37.035),(56.915,36.865),(56.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.245),(47.145,39.415),(47.315,39.415),(47.315,39.245),(47.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.245),(47.485,39.415),(47.655,39.415),(47.655,39.245),(47.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.585),(47.145,39.755),(47.315,39.755),(47.315,39.585),(47.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.585),(47.485,39.755),(47.655,39.755),(47.655,39.585),(47.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.905),(75.945,5.075),(76.115,5.075),(76.115,4.905),(75.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.925),(56.745,23.095),(56.915,23.095),(56.915,22.925),(56.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.285),(42.345,7.455),(42.515,7.455),(42.515,7.285),(42.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.285),(42.685,7.455),(42.855,7.455),(42.855,7.285),(42.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.185),(37.545,19.355),(37.715,19.355),(37.715,19.185),(37.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.525),(37.545,19.695),(37.715,19.695),(37.715,19.525),(37.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,36.865),(9.085,37.035),(9.255,37.035),(9.255,36.865),(9.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.905),(71.485,5.075),(71.655,5.075),(71.655,4.905),(71.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.265),(81.085,6.435),(81.255,6.435),(81.255,6.265),(81.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.605),(81.085,6.775),(81.255,6.775),(81.255,6.605),(81.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.925),(8.745,6.095),(8.915,6.095),(8.915,5.925),(8.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.265),(13.885,6.435),(14.055,6.435),(14.055,6.265),(13.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.605),(13.885,6.775),(14.055,6.775),(14.055,6.605),(13.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.685),(56.745,10.855),(56.915,10.855),(56.915,10.685),(56.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.005),(56.745,10.175),(56.915,10.175),(56.915,10.005),(56.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.345),(56.745,10.515),(56.915,10.515),(56.915,10.345),(56.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.965),(52.285,8.135),(52.455,8.135),(52.455,7.965),(52.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.865),(28.285,20.035),(28.455,20.035),(28.455,19.865),(28.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.985),(57.085,26.155),(57.255,26.155),(57.255,25.985),(57.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,23.945),(27.945,24.115),(28.115,24.115),(28.115,23.945),(27.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.965),(32.745,25.135),(32.915,25.135),(32.915,24.965),(32.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.205),(57.085,20.375),(57.255,20.375),(57.255,20.205),(57.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.545),(57.085,20.715),(57.255,20.715),(57.255,20.545),(57.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,33.805),(76.285,33.975),(76.455,33.975),(76.455,33.805),(76.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,33.125),(76.285,33.295),(76.455,33.295),(76.455,33.125),(76.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,33.465),(76.285,33.635),(76.455,33.635),(76.455,33.465),(76.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.185),(71.145,19.355),(71.315,19.355),(71.315,19.185),(71.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.205),(52.285,3.375),(52.455,3.375),(52.455,3.205),(52.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.545),(52.285,3.715),(52.455,3.715),(52.455,3.545),(52.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.125),(66.345,16.295),(66.515,16.295),(66.515,16.125),(66.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.125),(66.685,16.295),(66.855,16.295),(66.855,16.125),(66.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,28.365),(66.345,28.535),(66.515,28.535),(66.515,28.365),(66.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,28.365),(66.685,28.535),(66.855,28.535),(66.855,28.365),(66.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.465),(66.345,16.635),(66.515,16.635),(66.515,16.465),(66.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.465),(66.685,16.635),(66.855,16.635),(66.855,16.465),(66.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.805),(66.345,16.975),(66.515,16.975),(66.515,16.805),(66.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.805),(66.685,16.975),(66.855,16.975),(66.855,16.805),(66.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.945),(80.745,7.115),(80.915,7.115),(80.915,6.945),(80.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.205),(8.745,3.375),(8.915,3.375),(8.915,3.205),(8.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.545),(8.745,3.715),(8.915,3.715),(8.915,3.545),(8.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,34.145),(23.145,34.315),(23.315,34.315),(23.315,34.145),(23.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,34.145),(23.485,34.315),(23.655,34.315),(23.655,34.145),(23.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,34.485),(23.145,34.655),(23.315,34.655),(23.315,34.485),(23.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,34.485),(23.485,34.655),(23.655,34.655),(23.655,34.485),(23.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,34.825),(23.145,34.995),(23.315,34.995),(23.315,34.825),(23.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,34.825),(23.485,34.995),(23.655,34.995),(23.655,34.825),(23.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.905),(37.545,22.075),(37.715,22.075),(37.715,21.905),(37.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.305),(13.885,8.475),(14.055,8.475),(14.055,8.305),(13.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.645),(13.885,8.815),(14.055,8.815),(14.055,8.645),(13.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.525),(13.545,19.695),(13.715,19.695),(13.715,19.525),(13.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.185),(13.545,19.355),(13.715,19.355),(13.715,19.185),(13.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.285),(23.145,7.455),(23.315,7.455),(23.315,7.285),(23.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,37.885),(66.345,38.055),(66.515,38.055),(66.515,37.885),(66.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,37.885),(66.685,38.055),(66.855,38.055),(66.855,37.885),(66.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,26.665),(33.085,26.835),(33.255,26.835),(33.255,26.665),(33.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,26.325),(33.085,26.495),(33.255,26.495),(33.255,26.325),(33.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.285),(23.485,7.455),(23.655,7.455),(23.655,7.285),(23.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.405),(80.745,13.575),(80.915,13.575),(80.915,13.405),(80.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.745),(80.745,13.915),(80.915,13.915),(80.915,13.745),(80.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,34.145),(18.345,34.315),(18.515,34.315),(18.515,34.145),(18.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,34.145),(18.685,34.315),(18.855,34.315),(18.855,34.145),(18.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,34.485),(18.345,34.655),(18.515,34.655),(18.515,34.485),(18.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,34.485),(18.685,34.655),(18.855,34.655),(18.855,34.485),(18.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,34.825),(18.345,34.995),(18.515,34.995),(18.515,34.825),(18.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,34.825),(18.685,34.995),(18.855,34.995),(18.855,34.825),(18.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.145),(28.285,17.315),(28.455,17.315),(28.455,17.145),(28.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.825),(28.285,17.995),(28.455,17.995),(28.455,17.825),(28.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.485),(28.285,17.655),(28.455,17.655),(28.455,17.485),(28.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,38.225),(75.945,38.395),(76.115,38.395),(76.115,38.225),(75.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,38.565),(75.945,38.735),(76.115,38.735),(76.115,38.565),(75.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.925),(57.085,23.095),(57.255,23.095),(57.255,22.925),(57.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,34.485),(75.945,34.655),(76.115,34.655),(76.115,34.485),(75.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,34.825),(75.945,34.995),(76.115,34.995),(76.115,34.825),(75.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,34.145),(75.945,34.315),(76.115,34.315),(76.115,34.145),(75.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.625),(37.885,7.795),(38.055,7.795),(38.055,7.625),(37.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.925),(42.345,23.095),(42.515,23.095),(42.515,22.925),(42.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.925),(42.685,23.095),(42.855,23.095),(42.855,22.925),(42.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.945),(28.285,7.115),(28.455,7.115),(28.455,6.945),(28.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.885),(32.745,38.055),(32.915,38.055),(32.915,37.885),(32.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.925),(80.745,6.095),(80.915,6.095),(80.915,5.925),(80.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.605),(18.685,6.775),(18.855,6.775),(18.855,6.605),(18.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,37.885),(9.085,38.055),(9.255,38.055),(9.255,37.885),(9.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.985),(18.345,9.155),(18.515,9.155),(18.515,8.985),(18.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.985),(18.685,9.155),(18.855,9.155),(18.855,8.985),(18.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,36.865),(80.745,37.035),(80.915,37.035),(80.915,36.865),(80.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,24.965),(75.945,25.135),(76.115,25.135),(76.115,24.965),(75.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,39.245),(61.545,39.415),(61.715,39.415),(61.715,39.245),(61.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,39.585),(61.545,39.755),(61.715,39.755),(61.715,39.585),(61.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.925),(51.945,40.095),(52.115,40.095),(52.115,39.925),(51.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.725),(13.885,12.895),(14.055,12.895),(14.055,12.725),(13.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.385),(13.885,12.555),(14.055,12.555),(14.055,12.385),(13.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.045),(13.885,12.215),(14.055,12.215),(14.055,12.045),(13.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,22.245),(27.945,22.415),(28.115,22.415),(28.115,22.245),(27.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,22.585),(27.945,22.755),(28.115,22.755),(28.115,22.585),(27.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,21.905),(13.545,22.075),(13.715,22.075),(13.715,21.905),(13.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.405),(42.345,30.575),(42.515,30.575),(42.515,30.405),(42.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.405),(42.685,30.575),(42.855,30.575),(42.855,30.405),(42.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.745),(42.345,30.915),(42.515,30.915),(42.515,30.745),(42.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.745),(42.685,30.915),(42.855,30.915),(42.855,30.745),(42.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.065),(42.345,30.235),(42.515,30.235),(42.515,30.065),(42.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.065),(42.685,30.235),(42.855,30.235),(42.855,30.065),(42.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.145),(32.745,17.315),(32.915,17.315),(32.915,17.145),(32.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.825),(32.745,17.995),(32.915,17.995),(32.915,17.825),(32.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.485),(32.745,17.655),(32.915,17.655),(32.915,17.485),(32.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.325),(9.085,9.495),(9.255,9.495),(9.255,9.325),(9.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.665),(9.085,9.835),(9.255,9.835),(9.255,9.665),(9.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.765),(37.545,14.935),(37.715,14.935),(37.715,14.765),(37.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.085),(37.545,14.255),(37.715,14.255),(37.715,14.085),(37.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,24.625),(76.285,24.795),(76.455,24.795),(76.455,24.625),(76.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,24.285),(76.285,24.455),(76.455,24.455),(76.455,24.285),(76.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.425),(37.545,14.595),(37.715,14.595),(37.715,14.425),(37.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,36.185),(13.885,36.355),(14.055,36.355),(14.055,36.185),(13.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,36.525),(13.885,36.695),(14.055,36.695),(14.055,36.525),(13.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,35.505),(8.745,35.675),(8.915,35.675),(8.915,35.505),(8.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,35.165),(8.745,35.335),(8.915,35.335),(8.915,35.165),(8.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.865),(27.945,20.035),(28.115,20.035),(28.115,19.865),(27.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,40.265),(13.885,40.435),(14.055,40.435),(14.055,40.265),(13.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,40.605),(13.885,40.775),(14.055,40.775),(14.055,40.605),(13.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.625),(13.885,7.795),(14.055,7.795),(14.055,7.625),(13.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,39.245),(9.085,39.415),(9.255,39.415),(9.255,39.245),(9.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,39.585),(9.085,39.755),(9.255,39.755),(9.255,39.585),(9.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,38.565),(28.285,38.735),(28.455,38.735),(28.455,38.565),(28.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,38.225),(28.285,38.395),(28.455,38.395),(28.455,38.225),(28.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.285),(37.545,7.455),(37.715,7.455),(37.715,7.285),(37.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.685),(42.345,27.855),(42.515,27.855),(42.515,27.685),(42.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.685),(42.685,27.855),(42.855,27.855),(42.855,27.685),(42.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.005),(42.345,27.175),(42.515,27.175),(42.515,27.005),(42.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.005),(42.685,27.175),(42.855,27.175),(42.855,27.005),(42.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.345),(42.345,27.515),(42.515,27.515),(42.515,27.345),(42.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.345),(42.685,27.515),(42.855,27.515),(42.855,27.345),(42.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.245),(32.745,22.415),(32.915,22.415),(32.915,22.245),(32.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.585),(32.745,22.755),(32.915,22.755),(32.915,22.585),(32.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.505),(52.285,35.675),(52.455,35.675),(52.455,35.505),(52.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.165),(52.285,35.335),(52.455,35.335),(52.455,35.165),(52.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.865),(56.745,20.035),(56.915,20.035),(56.915,19.865),(56.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,28.025),(76.285,28.195),(76.455,28.195),(76.455,28.025),(76.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,30.065),(80.745,30.235),(80.915,30.235),(80.915,30.065),(80.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,30.405),(80.745,30.575),(80.915,30.575),(80.915,30.405),(80.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,31.425),(71.145,31.595),(71.315,31.595),(71.315,31.425),(71.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,40.605),(18.685,40.775),(18.855,40.775),(18.855,40.605),(18.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,31.425),(71.485,31.595),(71.655,31.595),(71.655,31.425),(71.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,31.765),(71.145,31.935),(71.315,31.935),(71.315,31.765),(71.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,31.765),(71.485,31.935),(71.655,31.935),(71.655,31.765),(71.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.245),(52.285,39.415),(52.455,39.415),(52.455,39.245),(52.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.585),(52.285,39.755),(52.455,39.755),(52.455,39.585),(52.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.065),(57.085,30.235),(57.255,30.235),(57.255,30.065),(57.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.405),(57.085,30.575),(57.255,30.575),(57.255,30.405),(57.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.745),(57.085,30.915),(57.255,30.915),(57.255,30.745),(57.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,40.265),(18.345,40.435),(18.515,40.435),(18.515,40.265),(18.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.965),(66.345,8.135),(66.515,8.135),(66.515,7.965),(66.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.965),(66.685,8.135),(66.855,8.135),(66.855,7.965),(66.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.965),(57.085,8.135),(57.255,8.135),(57.255,7.965),(57.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,40.265),(80.745,40.435),(80.915,40.435),(80.915,40.265),(80.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,40.605),(80.745,40.775),(80.915,40.775),(80.915,40.605),(80.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,34.145),(61.545,34.315),(61.715,34.315),(61.715,34.145),(61.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,34.485),(61.545,34.655),(61.715,34.655),(61.715,34.485),(61.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,34.825),(61.545,34.995),(61.715,34.995),(61.715,34.825),(61.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.065),(32.745,13.235),(32.915,13.235),(32.915,13.065),(32.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.405),(32.745,13.575),(32.915,13.575),(32.915,13.405),(32.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.745),(32.745,13.915),(32.915,13.915),(32.915,13.745),(32.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,39.925),(81.085,40.095),(81.255,40.095),(81.255,39.925),(81.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.965),(33.085,8.135),(33.255,8.135),(33.255,7.965),(33.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.285),(61.545,7.455),(61.715,7.455),(61.715,7.285),(61.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,2.865),(23.145,3.035),(23.315,3.035),(23.315,2.865),(23.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.905),(37.885,22.075),(38.055,22.075),(38.055,21.905),(37.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,2.865),(23.485,3.035),(23.655,3.035),(23.655,2.865),(23.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.225),(75.945,4.395),(76.115,4.395),(76.115,4.225),(75.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.565),(75.945,4.735),(76.115,4.735),(76.115,4.565),(75.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,38.905),(66.345,39.075),(66.515,39.075),(66.515,38.905),(66.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,38.905),(66.685,39.075),(66.855,39.075),(66.855,38.905),(66.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.145),(57.085,34.315),(57.255,34.315),(57.255,34.145),(57.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.485),(57.085,34.655),(57.255,34.655),(57.255,34.485),(57.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.825),(57.085,34.995),(57.255,34.995),(57.255,34.825),(57.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.285),(51.945,24.455),(52.115,24.455),(52.115,24.285),(51.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.625),(51.945,24.795),(52.115,24.795),(52.115,24.625),(51.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,31.425),(75.945,31.595),(76.115,31.595),(76.115,31.425),(75.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,31.765),(75.945,31.935),(76.115,31.935),(76.115,31.765),(75.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,31.085),(75.945,31.255),(76.115,31.255),(76.115,31.085),(75.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.885),(52.285,21.055),(52.455,21.055),(52.455,20.885),(52.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.885),(32.745,21.055),(32.915,21.055),(32.915,20.885),(32.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.265),(61.885,6.435),(62.055,6.435),(62.055,6.265),(61.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.925),(56.745,6.095),(56.915,6.095),(56.915,5.925),(56.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,23.605),(23.145,23.775),(23.315,23.775),(23.315,23.605),(23.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,23.605),(23.485,23.775),(23.655,23.775),(23.655,23.605),(23.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,23.265),(23.145,23.435),(23.315,23.435),(23.315,23.265),(23.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,23.265),(23.485,23.435),(23.655,23.435),(23.655,23.265),(23.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.145),(33.085,34.315),(33.255,34.315),(33.255,34.145),(33.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.485),(33.085,34.655),(33.255,34.655),(33.255,34.485),(33.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,22.585),(76.285,22.755),(76.455,22.755),(76.455,22.585),(76.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,22.245),(76.285,22.415),(76.455,22.415),(76.455,22.245),(76.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.825),(33.085,34.995),(33.255,34.995),(33.255,34.825),(33.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.925),(32.745,6.095),(32.915,6.095),(32.915,5.925),(32.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.745),(61.885,13.915),(62.055,13.915),(62.055,13.745),(61.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.065),(61.885,13.235),(62.055,13.235),(62.055,13.065),(61.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.405),(61.885,13.575),(62.055,13.575),(62.055,13.405),(61.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.865),(37.885,37.035),(38.055,37.035),(38.055,36.865),(37.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.505),(27.945,18.675),(28.115,18.675),(28.115,18.505),(27.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.165),(27.945,18.335),(28.115,18.335),(28.115,18.165),(27.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.025),(13.885,11.195),(14.055,11.195),(14.055,11.025),(13.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.865),(13.885,20.035),(14.055,20.035),(14.055,19.865),(13.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.365),(13.885,11.535),(14.055,11.535),(14.055,11.365),(13.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.705),(13.885,11.875),(14.055,11.875),(14.055,11.705),(13.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.985),(27.945,9.155),(28.115,9.155),(28.115,8.985),(27.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.945),(52.285,7.115),(52.455,7.115),(52.455,6.945),(52.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.985),(52.285,9.155),(52.455,9.155),(52.455,8.985),(52.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,27.005),(75.945,27.175),(76.115,27.175),(76.115,27.005),(75.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,27.345),(75.945,27.515),(76.115,27.515),(76.115,27.345),(75.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,27.685),(75.945,27.855),(76.115,27.855),(76.115,27.685),(75.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,28.705),(18.345,28.875),(18.515,28.875),(18.515,28.705),(18.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,28.705),(18.685,28.875),(18.855,28.875),(18.855,28.705),(18.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,28.025),(18.345,28.195),(18.515,28.195),(18.515,28.025),(18.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,28.025),(18.685,28.195),(18.855,28.195),(18.855,28.025),(18.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,28.365),(18.345,28.535),(18.515,28.535),(18.515,28.365),(18.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,28.365),(18.685,28.535),(18.855,28.535),(18.855,28.365),(18.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.245),(33.085,22.415),(33.255,22.415),(33.255,22.245),(33.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.585),(33.085,22.755),(33.255,22.755),(33.255,22.585),(33.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.185),(57.085,19.355),(57.255,19.355),(57.255,19.185),(57.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.525),(57.085,19.695),(57.255,19.695),(57.255,19.525),(57.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.305),(52.285,25.475),(52.455,25.475),(52.455,25.305),(52.285,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.385),(61.545,12.555),(61.715,12.555),(61.715,12.385),(61.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.725),(61.545,12.895),(61.715,12.895),(61.715,12.725),(61.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.045),(61.545,12.215),(61.715,12.215),(61.715,12.045),(61.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,21.905),(13.885,22.075),(14.055,22.075),(14.055,21.905),(13.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.685),(61.885,10.855),(62.055,10.855),(62.055,10.685),(61.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.005),(61.885,10.175),(62.055,10.175),(62.055,10.005),(61.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.345),(61.885,10.515),(62.055,10.515),(62.055,10.345),(61.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.765),(52.285,14.935),(52.455,14.935),(52.455,14.765),(52.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.085),(52.285,14.255),(52.455,14.255),(52.455,14.085),(52.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.425),(52.285,14.595),(52.455,14.595),(52.455,14.425),(52.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.305),(80.745,8.475),(80.915,8.475),(80.915,8.305),(80.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.645),(80.745,8.815),(80.915,8.815),(80.915,8.645),(80.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.185),(42.345,19.355),(42.515,19.355),(42.515,19.185),(42.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.185),(42.685,19.355),(42.855,19.355),(42.855,19.185),(42.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.525),(42.345,19.695),(42.515,19.695),(42.515,19.525),(42.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.525),(42.685,19.695),(42.855,19.695),(42.855,19.525),(42.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.965),(81.085,8.135),(81.255,8.135),(81.255,7.965),(81.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.445),(23.145,15.615),(23.315,15.615),(23.315,15.445),(23.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,20.205),(8.745,20.375),(8.915,20.375),(8.915,20.205),(8.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,20.545),(8.745,20.715),(8.915,20.715),(8.915,20.545),(8.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.905),(23.145,5.075),(23.315,5.075),(23.315,4.905),(23.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.905),(23.485,5.075),(23.655,5.075),(23.655,4.905),(23.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,26.665),(76.285,26.835),(76.455,26.835),(76.455,26.665),(76.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,26.325),(76.285,26.495),(76.455,26.495),(76.455,26.325),(76.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.845),(13.545,19.015),(13.715,19.015),(13.715,18.845),(13.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.905),(52.285,22.075),(52.455,22.075),(52.455,21.905),(52.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.985),(9.085,9.155),(9.255,9.155),(9.255,8.985),(9.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.585),(37.545,5.755),(37.715,5.755),(37.715,5.585),(37.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,38.905),(18.345,39.075),(18.515,39.075),(18.515,38.905),(18.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,38.905),(18.685,39.075),(18.855,39.075),(18.855,38.905),(18.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.245),(37.545,5.415),(37.715,5.415),(37.715,5.245),(37.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.185),(75.945,19.355),(76.115,19.355),(76.115,19.185),(75.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.325),(47.145,9.495),(47.315,9.495),(47.315,9.325),(47.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,30.065),(76.285,30.235),(76.455,30.235),(76.455,30.065),(76.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,30.405),(76.285,30.575),(76.455,30.575),(76.455,30.405),(76.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,30.745),(76.285,30.915),(76.455,30.915),(76.455,30.745),(76.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.125),(80.745,16.295),(80.915,16.295),(80.915,16.125),(80.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.465),(80.745,16.635),(80.915,16.635),(80.915,16.465),(80.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.985),(42.345,26.155),(42.515,26.155),(42.515,25.985),(42.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.985),(42.685,26.155),(42.855,26.155),(42.855,25.985),(42.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.805),(80.745,16.975),(80.915,16.975),(80.915,16.805),(80.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,22.925),(13.545,23.095),(13.715,23.095),(13.715,22.925),(13.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,23.265),(61.545,23.435),(61.715,23.435),(61.715,23.265),(61.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,23.605),(61.545,23.775),(61.715,23.775),(61.715,23.605),(61.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,40.265),(23.145,40.435),(23.315,40.435),(23.315,40.265),(23.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,40.265),(23.485,40.435),(23.655,40.435),(23.655,40.265),(23.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,40.605),(23.145,40.775),(23.315,40.775),(23.315,40.605),(23.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,40.605),(23.485,40.775),(23.655,40.775),(23.655,40.605),(23.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,26.665),(27.945,26.835),(28.115,26.835),(28.115,26.665),(27.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,25.985),(61.545,26.155),(61.715,26.155),(61.715,25.985),(61.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,26.325),(27.945,26.495),(28.115,26.495),(28.115,26.325),(27.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,20.205),(23.485,20.375),(23.655,20.375),(23.655,20.205),(23.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,2.865),(61.885,3.035),(62.055,3.035),(62.055,2.865),(61.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,24.625),(81.085,24.795),(81.255,24.795),(81.255,24.625),(81.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,24.285),(81.085,24.455),(81.255,24.455),(81.255,24.285),(81.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,23.265),(81.085,23.435),(81.255,23.435),(81.255,23.265),(81.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,23.605),(81.085,23.775),(81.255,23.775),(81.255,23.605),(81.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.525),(71.485,19.695),(71.655,19.695),(71.655,19.525),(71.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.245),(37.885,39.415),(38.055,39.415),(38.055,39.245),(37.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.585),(37.885,39.755),(38.055,39.755),(38.055,39.585),(37.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.145),(66.345,17.315),(66.515,17.315),(66.515,17.145),(66.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.145),(66.685,17.315),(66.855,17.315),(66.855,17.145),(66.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.725),(33.085,29.895),(33.255,29.895),(33.255,29.725),(33.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.385),(33.085,29.555),(33.255,29.555),(33.255,29.385),(33.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.045),(33.085,29.215),(33.255,29.215),(33.255,29.045),(33.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.025),(9.085,11.195),(9.255,11.195),(9.255,11.025),(9.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.365),(9.085,11.535),(9.255,11.535),(9.255,11.365),(9.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.705),(9.085,11.875),(9.255,11.875),(9.255,11.705),(9.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.765),(8.745,14.935),(8.915,14.935),(8.915,14.765),(8.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.085),(8.745,14.255),(8.915,14.255),(8.915,14.085),(8.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.425),(8.745,14.595),(8.915,14.595),(8.915,14.425),(8.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.245),(13.545,5.415),(13.715,5.415),(13.715,5.245),(13.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.585),(13.545,5.755),(13.715,5.755),(13.715,5.585),(13.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,31.085),(71.485,31.255),(71.655,31.255),(71.655,31.085),(71.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.865),(37.885,20.035),(38.055,20.035),(38.055,19.865),(37.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.985),(66.345,9.155),(66.515,9.155),(66.515,8.985),(66.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.865),(47.145,3.035),(47.315,3.035),(47.315,2.865),(47.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.865),(47.485,3.035),(47.655,3.035),(47.655,2.865),(47.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.985),(66.685,9.155),(66.855,9.155),(66.855,8.985),(66.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,23.605),(61.885,23.775),(62.055,23.775),(62.055,23.605),(61.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.985),(76.285,9.155),(76.455,9.155),(76.455,8.985),(76.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.965),(13.545,8.135),(13.715,8.135),(13.715,7.965),(13.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.285),(57.085,7.455),(57.255,7.455),(57.255,7.285),(57.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.465),(18.345,16.635),(18.515,16.635),(18.515,16.465),(18.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.465),(18.685,16.635),(18.855,16.635),(18.855,16.465),(18.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.125),(18.345,16.295),(18.515,16.295),(18.515,16.125),(18.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.125),(18.685,16.295),(18.855,16.295),(18.855,16.125),(18.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.805),(18.345,16.975),(18.515,16.975),(18.515,16.805),(18.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.805),(18.685,16.975),(18.855,16.975),(18.855,16.805),(18.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.985),(28.285,9.155),(28.455,9.155),(28.455,8.985),(28.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.265),(18.685,6.435),(18.855,6.435),(18.855,6.265),(18.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.285),(57.085,24.455),(57.255,24.455),(57.255,24.285),(57.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.625),(57.085,24.795),(57.255,24.795),(57.255,24.625),(57.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,32.105),(28.285,32.275),(28.455,32.275),(28.455,32.105),(28.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,32.445),(28.285,32.615),(28.455,32.615),(28.455,32.445),(28.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,32.785),(28.285,32.955),(28.455,32.955),(28.455,32.785),(28.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.845),(47.145,19.015),(47.315,19.015),(47.315,18.845),(47.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.845),(47.485,19.015),(47.655,19.015),(47.655,18.845),(47.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,37.205),(18.345,37.375),(18.515,37.375),(18.515,37.205),(18.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,37.205),(18.685,37.375),(18.855,37.375),(18.855,37.205),(18.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,37.545),(18.345,37.715),(18.515,37.715),(18.515,37.545),(18.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,37.545),(18.685,37.715),(18.855,37.715),(18.855,37.545),(18.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.325),(13.545,9.495),(13.715,9.495),(13.715,9.325),(13.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.665),(13.545,9.835),(13.715,9.835),(13.715,9.665),(13.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.105),(56.745,15.275),(56.915,15.275),(56.915,15.105),(56.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.445),(56.745,15.615),(56.915,15.615),(56.915,15.445),(56.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.785),(56.745,15.955),(56.915,15.955),(56.915,15.785),(56.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,27.345),(61.545,27.515),(61.715,27.515),(61.715,27.345),(61.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,27.685),(61.545,27.855),(61.715,27.855),(61.715,27.685),(61.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,27.005),(61.545,27.175),(61.715,27.175),(61.715,27.005),(61.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.285),(42.345,24.455),(42.515,24.455),(42.515,24.285),(42.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.285),(42.685,24.455),(42.855,24.455),(42.855,24.285),(42.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,37.205),(61.885,37.375),(62.055,37.375),(62.055,37.205),(61.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,37.545),(61.885,37.715),(62.055,37.715),(62.055,37.545),(61.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.625),(42.345,24.795),(42.515,24.795),(42.515,24.625),(42.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.625),(42.685,24.795),(42.855,24.795),(42.855,24.625),(42.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.845),(37.545,19.015),(37.715,19.015),(37.715,18.845),(37.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.085),(28.285,14.255),(28.455,14.255),(28.455,14.085),(28.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.425),(28.285,14.595),(28.455,14.595),(28.455,14.425),(28.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.765),(28.285,14.935),(28.455,14.935),(28.455,14.765),(28.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,40.265),(66.345,40.435),(66.515,40.435),(66.515,40.265),(66.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,40.265),(66.685,40.435),(66.855,40.435),(66.855,40.265),(66.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,40.605),(66.345,40.775),(66.515,40.775),(66.515,40.605),(66.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,40.605),(66.685,40.775),(66.855,40.775),(66.855,40.605),(66.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.505),(9.085,18.675),(9.255,18.675),(9.255,18.505),(9.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.925),(57.085,40.095),(57.255,40.095),(57.255,39.925),(57.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.165),(9.085,18.335),(9.255,18.335),(9.255,18.165),(9.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,35.165),(27.945,35.335),(28.115,35.335),(28.115,35.165),(27.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,35.505),(27.945,35.675),(28.115,35.675),(28.115,35.505),(27.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.925),(37.545,23.095),(37.715,23.095),(37.715,22.925),(37.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,25.645),(18.345,25.815),(18.515,25.815),(18.515,25.645),(18.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,25.645),(18.685,25.815),(18.855,25.815),(18.855,25.645),(18.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,25.305),(18.345,25.475),(18.515,25.475),(18.515,25.305),(18.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,25.305),(18.685,25.475),(18.855,25.475),(18.855,25.305),(18.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,40.265),(28.285,40.435),(28.455,40.435),(28.455,40.265),(28.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,40.605),(28.285,40.775),(28.455,40.775),(28.455,40.605),(28.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.905),(47.145,5.075),(47.315,5.075),(47.315,4.905),(47.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.905),(47.485,5.075),(47.655,5.075),(47.655,4.905),(47.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.905),(51.945,22.075),(52.115,22.075),(52.115,21.905),(51.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.865),(42.345,20.035),(42.515,20.035),(42.515,19.865),(42.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.865),(42.685,20.035),(42.855,20.035),(42.855,19.865),(42.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,20.885),(61.545,21.055),(61.715,21.055),(61.715,20.885),(61.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.425),(61.545,14.595),(61.715,14.595),(61.715,14.425),(61.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.765),(61.545,14.935),(61.715,14.935),(61.715,14.765),(61.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.085),(61.545,14.255),(61.715,14.255),(61.715,14.085),(61.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,30.065),(81.085,30.235),(81.255,30.235),(81.255,30.065),(81.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,30.405),(81.085,30.575),(81.255,30.575),(81.255,30.405),(81.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,30.745),(81.085,30.915),(81.255,30.915),(81.255,30.745),(81.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.245),(18.345,5.415),(18.515,5.415),(18.515,5.245),(18.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,37.885),(28.285,38.055),(28.455,38.055),(28.455,37.885),(28.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.245),(18.685,5.415),(18.855,5.415),(18.855,5.245),(18.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.585),(18.345,5.755),(18.515,5.755),(18.515,5.585),(18.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.585),(18.685,5.755),(18.855,5.755),(18.855,5.585),(18.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.545),(37.545,3.715),(37.715,3.715),(37.715,3.545),(37.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,26.665),(47.145,26.835),(47.315,26.835),(47.315,26.665),(47.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,26.665),(47.485,26.835),(47.655,26.835),(47.655,26.665),(47.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,26.325),(47.145,26.495),(47.315,26.495),(47.315,26.325),(47.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,26.325),(47.485,26.495),(47.655,26.495),(47.655,26.325),(47.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.205),(37.545,3.375),(37.715,3.375),(37.715,3.205),(37.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,2.865),(61.545,3.035),(61.715,3.035),(61.715,2.865),(61.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.245),(56.745,39.415),(56.915,39.415),(56.915,39.245),(56.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.585),(56.745,39.755),(56.915,39.755),(56.915,39.585),(56.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.505),(66.345,18.675),(66.515,18.675),(66.515,18.505),(66.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.505),(66.685,18.675),(66.855,18.675),(66.855,18.505),(66.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.165),(66.345,18.335),(66.515,18.335),(66.515,18.165),(66.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.165),(66.685,18.335),(66.855,18.335),(66.855,18.165),(66.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,20.205),(66.345,20.375),(66.515,20.375),(66.515,20.205),(66.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,20.205),(66.685,20.375),(66.855,20.375),(66.855,20.205),(66.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,20.545),(66.345,20.715),(66.515,20.715),(66.515,20.545),(66.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,20.545),(66.685,20.715),(66.855,20.715),(66.855,20.545),(66.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,25.985),(61.885,26.155),(62.055,26.155),(62.055,25.985),(61.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,40.605),(18.345,40.775),(18.515,40.775),(18.515,40.605),(18.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,32.445),(76.285,32.615),(76.455,32.615),(76.455,32.445),(76.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,32.785),(76.285,32.955),(76.455,32.955),(76.455,32.785),(76.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,32.105),(76.285,32.275),(76.455,32.275),(76.455,32.105),(76.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,25.985),(81.085,26.155),(81.255,26.155),(81.255,25.985),(81.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.205),(13.545,3.375),(13.715,3.375),(13.715,3.205),(13.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.545),(13.545,3.715),(13.715,3.715),(13.715,3.545),(13.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.585),(57.085,5.755),(57.255,5.755),(57.255,5.585),(57.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,25.985),(23.145,26.155),(23.315,26.155),(23.315,25.985),(23.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,25.985),(23.485,26.155),(23.655,26.155),(23.655,25.985),(23.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,24.965),(61.545,25.135),(61.715,25.135),(61.715,24.965),(61.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.705),(51.945,11.875),(52.115,11.875),(52.115,11.705),(51.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.365),(51.945,11.535),(52.115,11.535),(52.115,11.365),(51.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.505),(8.745,18.675),(8.915,18.675),(8.915,18.505),(8.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.165),(8.745,18.335),(8.915,18.335),(8.915,18.165),(8.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.025),(51.945,11.195),(52.115,11.195),(52.115,11.025),(51.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.245),(57.085,5.415),(57.255,5.415),(57.255,5.245),(57.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,2.865),(71.145,3.035),(71.315,3.035),(71.315,2.865),(71.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,2.865),(71.485,3.035),(71.655,3.035),(71.655,2.865),(71.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.165),(23.145,18.335),(23.315,18.335),(23.315,18.165),(23.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,24.285),(27.945,24.455),(28.115,24.455),(28.115,24.285),(27.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,24.625),(27.945,24.795),(28.115,24.795),(28.115,24.625),(27.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.165),(23.485,18.335),(23.655,18.335),(23.655,18.165),(23.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.505),(23.145,18.675),(23.315,18.675),(23.315,18.505),(23.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.505),(23.485,18.675),(23.655,18.675),(23.655,18.505),(23.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,26.665),(18.345,26.835),(18.515,26.835),(18.515,26.665),(18.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,26.665),(18.685,26.835),(18.855,26.835),(18.855,26.665),(18.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,26.325),(18.345,26.495),(18.515,26.495),(18.515,26.325),(18.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,26.325),(18.685,26.495),(18.855,26.495),(18.855,26.325),(18.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.245),(33.085,5.415),(33.255,5.415),(33.255,5.245),(33.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.585),(33.085,5.755),(33.255,5.755),(33.255,5.585),(33.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.805),(37.545,33.975),(37.715,33.975),(37.715,33.805),(37.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.125),(37.545,33.295),(37.715,33.295),(37.715,33.125),(37.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.465),(37.545,33.635),(37.715,33.635),(37.715,33.465),(37.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.205),(37.545,37.375),(37.715,37.375),(37.715,37.205),(37.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.545),(37.545,37.715),(37.715,37.715),(37.715,37.545),(37.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.985),(75.945,9.155),(76.115,9.155),(76.115,8.985),(75.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,22.245),(23.145,22.415),(23.315,22.415),(23.315,22.245),(23.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,22.245),(23.485,22.415),(23.655,22.415),(23.655,22.245),(23.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,22.585),(23.145,22.755),(23.315,22.755),(23.315,22.585),(23.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,22.585),(23.485,22.755),(23.655,22.755),(23.655,22.585),(23.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.465),(61.545,16.635),(61.715,16.635),(61.715,16.465),(61.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.125),(61.545,16.295),(61.715,16.295),(61.715,16.125),(61.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.805),(61.545,16.975),(61.715,16.975),(61.715,16.805),(61.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.885),(71.145,4.055),(71.315,4.055),(71.315,3.885),(71.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.885),(71.485,4.055),(71.655,4.055),(71.655,3.885),(71.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,21.905),(71.145,22.075),(71.315,22.075),(71.315,21.905),(71.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,21.905),(71.485,22.075),(71.655,22.075),(71.655,21.905),(71.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.985),(37.545,26.155),(37.715,26.155),(37.715,25.985),(37.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.885),(47.145,4.055),(47.315,4.055),(47.315,3.885),(47.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.885),(47.485,4.055),(47.655,4.055),(47.655,3.885),(47.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.765),(42.345,14.935),(42.515,14.935),(42.515,14.765),(42.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.765),(42.685,14.935),(42.855,14.935),(42.855,14.765),(42.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.085),(42.345,14.255),(42.515,14.255),(42.515,14.085),(42.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.085),(42.685,14.255),(42.855,14.255),(42.855,14.085),(42.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.425),(42.345,14.595),(42.515,14.595),(42.515,14.425),(42.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.425),(42.685,14.595),(42.855,14.595),(42.855,14.425),(42.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.885),(23.145,4.055),(23.315,4.055),(23.315,3.885),(23.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.885),(23.485,4.055),(23.655,4.055),(23.655,3.885),(23.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.145),(61.885,17.315),(62.055,17.315),(62.055,17.145),(61.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.485),(61.885,17.655),(62.055,17.655),(62.055,17.485),(61.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.825),(61.885,17.995),(62.055,17.995),(62.055,17.825),(61.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.145),(80.745,17.315),(80.915,17.315),(80.915,17.145),(80.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.485),(80.745,17.655),(80.915,17.655),(80.915,17.485),(80.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.825),(80.745,17.995),(80.915,17.995),(80.915,17.825),(80.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.505),(32.745,18.675),(32.915,18.675),(32.915,18.505),(32.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.165),(32.745,18.335),(32.915,18.335),(32.915,18.165),(32.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,35.505),(13.545,35.675),(13.715,35.675),(13.715,35.505),(13.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,35.165),(13.545,35.335),(13.715,35.335),(13.715,35.165),(13.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,40.265),(56.745,40.435),(56.915,40.435),(56.915,40.265),(56.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,40.605),(56.745,40.775),(56.915,40.775),(56.915,40.605),(56.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.865),(37.545,37.035),(37.715,37.035),(37.715,36.865),(37.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,23.945),(75.945,24.115),(76.115,24.115),(76.115,23.945),(75.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.245),(8.745,5.415),(8.915,5.415),(8.915,5.245),(8.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.585),(8.745,5.755),(8.915,5.755),(8.915,5.585),(8.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,21.225),(61.885,21.395),(62.055,21.395),(62.055,21.225),(61.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,21.565),(61.885,21.735),(62.055,21.735),(62.055,21.565),(61.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,35.505),(9.085,35.675),(9.255,35.675),(9.255,35.505),(9.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,35.165),(9.085,35.335),(9.255,35.335),(9.255,35.165),(9.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,38.565),(8.745,38.735),(8.915,38.735),(8.915,38.565),(8.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,38.225),(8.745,38.395),(8.915,38.395),(8.915,38.225),(8.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.885),(37.885,4.055),(38.055,4.055),(38.055,3.885),(37.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.105),(71.145,15.275),(71.315,15.275),(71.315,15.105),(71.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.105),(71.485,15.275),(71.655,15.275),(71.655,15.105),(71.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.445),(71.145,15.615),(71.315,15.615),(71.315,15.445),(71.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.445),(71.485,15.615),(71.655,15.615),(71.655,15.445),(71.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.785),(71.145,15.955),(71.315,15.955),(71.315,15.785),(71.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.785),(71.485,15.955),(71.655,15.955),(71.655,15.785),(71.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.385),(76.285,12.555),(76.455,12.555),(76.455,12.385),(76.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,37.205),(23.145,37.375),(23.315,37.375),(23.315,37.205),(23.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,37.205),(23.485,37.375),(23.655,37.375),(23.655,37.205),(23.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,37.545),(23.145,37.715),(23.315,37.715),(23.315,37.545),(23.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,37.545),(23.485,37.715),(23.655,37.715),(23.655,37.545),(23.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,23.945),(66.345,24.115),(66.515,24.115),(66.515,23.945),(66.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,23.945),(66.685,24.115),(66.855,24.115),(66.855,23.945),(66.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.025),(33.085,11.195),(33.255,11.195),(33.255,11.025),(33.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,40.605),(37.885,40.775),(38.055,40.775),(38.055,40.605),(37.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,40.265),(37.885,40.435),(38.055,40.435),(38.055,40.265),(37.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.945),(23.145,7.115),(23.315,7.115),(23.315,6.945),(23.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.945),(23.485,7.115),(23.655,7.115),(23.655,6.945),(23.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,22.925),(28.285,23.095),(28.455,23.095),(28.455,22.925),(28.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.385),(28.285,12.555),(28.455,12.555),(28.455,12.385),(28.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.725),(28.285,12.895),(28.455,12.895),(28.455,12.725),(28.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,33.125),(71.145,33.295),(71.315,33.295),(71.315,33.125),(71.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,33.125),(71.485,33.295),(71.655,33.295),(71.655,33.125),(71.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,33.465),(71.145,33.635),(71.315,33.635),(71.315,33.465),(71.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,33.465),(71.485,33.635),(71.655,33.635),(71.655,33.465),(71.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,33.805),(71.145,33.975),(71.315,33.975),(71.315,33.805),(71.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,33.805),(71.485,33.975),(71.655,33.975),(71.655,33.805),(71.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,30.745),(18.345,30.915),(18.515,30.915),(18.515,30.745),(18.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.725),(32.745,29.895),(32.915,29.895),(32.915,29.725),(32.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.385),(32.745,29.555),(32.915,29.555),(32.915,29.385),(32.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.045),(32.745,29.215),(32.915,29.215),(32.915,29.045),(32.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.945),(33.085,24.115),(33.255,24.115),(33.255,23.945),(33.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.165),(61.885,18.335),(62.055,18.335),(62.055,18.165),(61.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.145),(76.285,17.315),(76.455,17.315),(76.455,17.145),(76.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.485),(76.285,17.655),(76.455,17.655),(76.455,17.485),(76.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.825),(76.285,17.995),(76.455,17.995),(76.455,17.825),(76.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.505),(61.885,18.675),(62.055,18.675),(62.055,18.505),(61.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.985),(47.145,9.155),(47.315,9.155),(47.315,8.985),(47.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.985),(47.485,9.155),(47.655,9.155),(47.655,8.985),(47.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.985),(81.085,9.155),(81.255,9.155),(81.255,8.985),(81.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.705),(52.285,11.875),(52.455,11.875),(52.455,11.705),(52.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.365),(52.285,11.535),(52.455,11.535),(52.455,11.365),(52.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.025),(52.285,11.195),(52.455,11.195),(52.455,11.025),(52.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,37.545),(66.345,37.715),(66.515,37.715),(66.515,37.545),(66.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,37.545),(66.685,37.715),(66.855,37.715),(66.855,37.545),(66.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,37.205),(66.345,37.375),(66.515,37.375),(66.515,37.205),(66.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,37.205),(66.685,37.375),(66.855,37.375),(66.855,37.205),(66.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,21.905),(81.085,22.075),(81.255,22.075),(81.255,21.905),(81.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.105),(57.085,15.275),(57.255,15.275),(57.255,15.105),(57.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.445),(57.085,15.615),(57.255,15.615),(57.255,15.445),(57.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.785),(57.085,15.955),(57.255,15.955),(57.255,15.785),(57.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.785),(56.745,32.955),(56.915,32.955),(56.915,32.785),(56.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.105),(56.745,32.275),(56.915,32.275),(56.915,32.105),(56.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.445),(56.745,32.615),(56.915,32.615),(56.915,32.445),(56.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,24.285),(8.745,24.455),(8.915,24.455),(8.915,24.285),(8.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,24.625),(8.745,24.795),(8.915,24.795),(8.915,24.625),(8.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.905),(32.745,22.075),(32.915,22.075),(32.915,21.905),(32.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,36.865),(8.745,37.035),(8.915,37.035),(8.915,36.865),(8.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.685),(37.545,27.855),(37.715,27.855),(37.715,27.685),(37.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.005),(37.545,27.175),(37.715,27.175),(37.715,27.005),(37.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.345),(37.545,27.515),(37.715,27.515),(37.715,27.345),(37.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.105),(32.745,32.275),(32.915,32.275),(32.915,32.105),(32.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.445),(32.745,32.615),(32.915,32.615),(32.915,32.445),(32.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.785),(32.745,32.955),(32.915,32.955),(32.915,32.785),(32.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.965),(37.885,8.135),(38.055,8.135),(38.055,7.965),(37.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.885),(13.885,4.055),(14.055,4.055),(14.055,3.885),(13.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,37.205),(27.945,37.375),(28.115,37.375),(28.115,37.205),(27.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.545),(32.745,37.715),(32.915,37.715),(32.915,37.545),(32.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.205),(32.745,37.375),(32.915,37.375),(32.915,37.205),(32.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,37.545),(27.945,37.715),(28.115,37.715),(28.115,37.545),(27.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.505),(33.085,18.675),(33.255,18.675),(33.255,18.505),(33.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.165),(33.085,18.335),(33.255,18.335),(33.255,18.165),(33.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.105),(18.345,15.275),(18.515,15.275),(18.515,15.105),(18.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.105),(18.685,15.275),(18.855,15.275),(18.855,15.105),(18.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.445),(18.345,15.615),(18.515,15.615),(18.515,15.445),(18.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.445),(18.685,15.615),(18.855,15.615),(18.855,15.445),(18.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.785),(18.345,15.955),(18.515,15.955),(18.515,15.785),(18.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.785),(18.685,15.955),(18.855,15.955),(18.855,15.785),(18.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.925),(61.885,6.095),(62.055,6.095),(62.055,5.925),(61.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.025),(75.945,11.195),(76.115,11.195),(76.115,11.025),(75.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.365),(75.945,11.535),(76.115,11.535),(76.115,11.365),(75.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.705),(75.945,11.875),(76.115,11.875),(76.115,11.705),(75.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,22.585),(75.945,22.755),(76.115,22.755),(76.115,22.585),(75.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,22.245),(75.945,22.415),(76.115,22.415),(76.115,22.245),(75.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.925),(56.745,40.095),(56.915,40.095),(56.915,39.925),(56.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,32.785),(9.085,32.955),(9.255,32.955),(9.255,32.785),(9.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,32.105),(9.085,32.275),(9.255,32.275),(9.255,32.105),(9.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,32.445),(9.085,32.615),(9.255,32.615),(9.255,32.445),(9.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,25.985),(8.745,26.155),(8.915,26.155),(8.915,25.985),(8.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.025),(27.945,11.195),(28.115,11.195),(28.115,11.025),(27.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.365),(27.945,11.535),(28.115,11.535),(28.115,11.365),(27.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.705),(27.945,11.875),(28.115,11.875),(28.115,11.705),(27.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,24.285),(23.145,24.455),(23.315,24.455),(23.315,24.285),(23.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,24.285),(23.485,24.455),(23.655,24.455),(23.655,24.285),(23.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,24.625),(23.145,24.795),(23.315,24.795),(23.315,24.625),(23.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,24.625),(23.485,24.795),(23.655,24.795),(23.655,24.625),(23.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.885),(61.545,4.055),(61.715,4.055),(61.715,3.885),(61.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.865),(75.945,20.035),(76.115,20.035),(76.115,19.865),(75.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.025),(81.085,11.195),(81.255,11.195),(81.255,11.025),(81.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.365),(81.085,11.535),(81.255,11.535),(81.255,11.365),(81.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.705),(81.085,11.875),(81.255,11.875),(81.255,11.705),(81.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.545),(42.345,3.715),(42.515,3.715),(42.515,3.545),(42.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.545),(42.685,3.715),(42.855,3.715),(42.855,3.545),(42.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.205),(42.345,3.375),(42.515,3.375),(42.515,3.205),(42.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.205),(42.685,3.375),(42.855,3.375),(42.855,3.205),(42.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.765),(80.745,14.935),(80.915,14.935),(80.915,14.765),(80.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.085),(80.745,14.255),(80.915,14.255),(80.915,14.085),(80.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.425),(80.745,14.595),(80.915,14.595),(80.915,14.425),(80.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.525),(81.085,19.695),(81.255,19.695),(81.255,19.525),(81.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,28.025),(28.285,28.195),(28.455,28.195),(28.455,28.025),(28.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.225),(13.545,4.395),(13.715,4.395),(13.715,4.225),(13.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.565),(13.545,4.735),(13.715,4.735),(13.715,4.565),(13.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.265),(42.345,23.435),(42.515,23.435),(42.515,23.265),(42.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.265),(42.685,23.435),(42.855,23.435),(42.855,23.265),(42.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.605),(42.345,23.775),(42.515,23.775),(42.515,23.605),(42.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.605),(42.685,23.775),(42.855,23.775),(42.855,23.605),(42.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.965),(13.885,8.135),(14.055,8.135),(14.055,7.965),(13.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.225),(8.745,4.395),(8.915,4.395),(8.915,4.225),(8.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.565),(8.745,4.735),(8.915,4.735),(8.915,4.565),(8.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.005),(9.085,10.175),(9.255,10.175),(9.255,10.005),(9.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.785),(51.945,32.955),(52.115,32.955),(52.115,32.785),(51.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.105),(51.945,32.275),(52.115,32.275),(52.115,32.105),(51.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.445),(51.945,32.615),(52.115,32.615),(52.115,32.445),(51.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.505),(28.285,18.675),(28.455,18.675),(28.455,18.505),(28.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,22.585),(61.885,22.755),(62.055,22.755),(62.055,22.585),(61.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,22.245),(61.885,22.415),(62.055,22.415),(62.055,22.245),(61.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.165),(28.285,18.335),(28.455,18.335),(28.455,18.165),(28.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.345),(9.085,10.515),(9.255,10.515),(9.255,10.345),(9.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.685),(9.085,10.855),(9.255,10.855),(9.255,10.685),(9.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,35.845),(13.885,36.015),(14.055,36.015),(14.055,35.845),(13.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.305),(47.145,25.475),(47.315,25.475),(47.315,25.305),(47.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.305),(47.485,25.475),(47.655,25.475),(47.655,25.305),(47.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.645),(47.145,25.815),(47.315,25.815),(47.315,25.645),(47.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.645),(47.485,25.815),(47.655,25.815),(47.655,25.645),(47.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.985),(33.085,9.155),(33.255,9.155),(33.255,8.985),(33.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.325),(51.945,9.495),(52.115,9.495),(52.115,9.325),(51.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.765),(76.285,14.935),(76.455,14.935),(76.455,14.765),(76.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.085),(76.285,14.255),(76.455,14.255),(76.455,14.085),(76.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.425),(76.285,14.595),(76.455,14.595),(76.455,14.425),(76.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.665),(51.945,9.835),(52.115,9.835),(52.115,9.665),(51.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.985),(37.885,26.155),(38.055,26.155),(38.055,25.985),(37.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,23.265),(71.145,23.435),(71.315,23.435),(71.315,23.265),(71.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,23.265),(71.485,23.435),(71.655,23.435),(71.655,23.265),(71.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,23.605),(71.145,23.775),(71.315,23.775),(71.315,23.605),(71.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,23.605),(71.485,23.775),(71.655,23.775),(71.655,23.605),(71.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.965),(52.285,25.135),(52.455,25.135),(52.455,24.965),(52.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,2.865),(8.745,3.035),(8.915,3.035),(8.915,2.865),(8.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,32.785),(61.885,32.955),(62.055,32.955),(62.055,32.785),(61.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,32.105),(61.885,32.275),(62.055,32.275),(62.055,32.105),(61.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,32.445),(61.885,32.615),(62.055,32.615),(62.055,32.445),(61.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,37.885),(13.885,38.055),(14.055,38.055),(14.055,37.885),(13.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.965),(61.545,8.135),(61.715,8.135),(61.715,7.965),(61.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.385),(18.345,12.555),(18.515,12.555),(18.515,12.385),(18.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.385),(18.685,12.555),(18.855,12.555),(18.855,12.385),(18.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.725),(18.345,12.895),(18.515,12.895),(18.515,12.725),(18.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,39.925),(23.145,40.095),(23.315,40.095),(23.315,39.925),(23.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,39.925),(23.485,40.095),(23.655,40.095),(23.655,39.925),(23.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.725),(18.685,12.895),(18.855,12.895),(18.855,12.725),(18.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.045),(18.345,12.215),(18.515,12.215),(18.515,12.045),(18.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.045),(18.685,12.215),(18.855,12.215),(18.855,12.045),(18.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.585),(56.745,5.755),(56.915,5.755),(56.915,5.585),(56.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.245),(56.745,5.415),(56.915,5.415),(56.915,5.245),(56.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.165),(75.945,18.335),(76.115,18.335),(76.115,18.165),(75.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.505),(75.945,18.675),(76.115,18.675),(76.115,18.505),(75.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,29.045),(75.945,29.215),(76.115,29.215),(76.115,29.045),(75.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,29.385),(75.945,29.555),(76.115,29.555),(76.115,29.385),(75.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,29.725),(75.945,29.895),(76.115,29.895),(76.115,29.725),(75.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.905),(37.545,39.075),(37.715,39.075),(37.715,38.905),(37.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.245),(32.745,5.415),(32.915,5.415),(32.915,5.245),(32.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.585),(32.745,5.755),(32.915,5.755),(32.915,5.585),(32.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.205),(57.085,37.375),(57.255,37.375),(57.255,37.205),(57.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.545),(57.085,37.715),(57.255,37.715),(57.255,37.545),(57.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.965),(37.545,25.135),(37.715,25.135),(37.715,24.965),(37.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,36.185),(13.545,36.355),(13.715,36.355),(13.715,36.185),(13.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,36.525),(13.545,36.695),(13.715,36.695),(13.715,36.525),(13.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.305),(13.545,8.475),(13.715,8.475),(13.715,8.305),(13.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.645),(13.545,8.815),(13.715,8.815),(13.715,8.645),(13.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.545),(47.145,37.715),(47.315,37.715),(47.315,37.545),(47.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.545),(47.485,37.715),(47.655,37.715),(47.655,37.545),(47.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.205),(47.145,37.375),(47.315,37.375),(47.315,37.205),(47.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.205),(47.485,37.375),(47.655,37.375),(47.655,37.205),(47.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.945),(47.145,7.115),(47.315,7.115),(47.315,6.945),(47.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.945),(47.485,7.115),(47.655,7.115),(47.655,6.945),(47.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,22.585),(80.745,22.755),(80.915,22.755),(80.915,22.585),(80.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,22.245),(80.745,22.415),(80.915,22.415),(80.915,22.245),(80.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.545),(18.345,3.715),(18.515,3.715),(18.515,3.545),(18.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,25.645),(75.945,25.815),(76.115,25.815),(76.115,25.645),(75.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,25.305),(75.945,25.475),(76.115,25.475),(76.115,25.305),(75.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.545),(18.685,3.715),(18.855,3.715),(18.855,3.545),(18.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.205),(18.345,3.375),(18.515,3.375),(18.515,3.205),(18.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.205),(18.685,3.375),(18.855,3.375),(18.855,3.205),(18.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.825),(52.285,34.995),(52.455,34.995),(52.455,34.825),(52.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.485),(52.285,34.655),(52.455,34.655),(52.455,34.485),(52.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.145),(52.285,34.315),(52.455,34.315),(52.455,34.145),(52.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,24.965),(66.345,25.135),(66.515,25.135),(66.515,24.965),(66.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,24.965),(66.685,25.135),(66.855,25.135),(66.855,24.965),(66.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,20.205),(18.345,20.375),(18.515,20.375),(18.515,20.205),(18.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,20.205),(18.685,20.375),(18.855,20.375),(18.855,20.205),(18.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,20.545),(18.345,20.715),(18.515,20.715),(18.515,20.545),(18.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.845),(47.145,36.015),(47.315,36.015),(47.315,35.845),(47.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.845),(47.485,36.015),(47.655,36.015),(47.655,35.845),(47.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,20.545),(18.685,20.715),(18.855,20.715),(18.855,20.545),(18.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.165),(61.545,18.335),(61.715,18.335),(61.715,18.165),(61.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.505),(61.545,18.675),(61.715,18.675),(61.715,18.505),(61.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.285),(76.285,7.455),(76.455,7.455),(76.455,7.285),(76.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.865),(57.085,37.035),(57.255,37.035),(57.255,36.865),(57.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.445),(52.285,15.615),(52.455,15.615),(52.455,15.445),(52.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,30.065),(61.885,30.235),(62.055,30.235),(62.055,30.065),(61.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,30.405),(61.885,30.575),(62.055,30.575),(62.055,30.405),(61.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,30.745),(61.885,30.915),(62.055,30.915),(62.055,30.745),(61.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.205),(61.885,3.375),(62.055,3.375),(62.055,3.205),(61.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.545),(61.885,3.715),(62.055,3.715),(62.055,3.545),(61.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.665),(81.085,9.835),(81.255,9.835),(81.255,9.665),(81.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.325),(81.085,9.495),(81.255,9.495),(81.255,9.325),(81.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.785),(23.485,15.955),(23.655,15.955),(23.655,15.785),(23.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.945),(52.285,24.115),(52.455,24.115),(52.455,23.945),(52.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.225),(37.545,4.395),(37.715,4.395),(37.715,4.225),(37.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.565),(37.545,4.735),(37.715,4.735),(37.715,4.565),(37.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.425),(47.485,14.595),(47.655,14.595),(47.655,14.425),(47.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.565),(61.545,4.735),(61.715,4.735),(61.715,4.565),(61.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.165),(51.945,18.335),(52.115,18.335),(52.115,18.165),(51.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,22.585),(61.545,22.755),(61.715,22.755),(61.715,22.585),(61.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,22.245),(61.545,22.415),(61.715,22.415),(61.715,22.245),(61.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.645),(33.085,25.815),(33.255,25.815),(33.255,25.645),(33.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.305),(33.085,25.475),(33.255,25.475),(33.255,25.305),(33.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.305),(42.345,8.475),(42.515,8.475),(42.515,8.305),(42.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.305),(42.685,8.475),(42.855,8.475),(42.855,8.305),(42.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,26.665),(71.145,26.835),(71.315,26.835),(71.315,26.665),(71.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,26.665),(71.485,26.835),(71.655,26.835),(71.655,26.665),(71.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.865),(51.945,37.035),(52.115,37.035),(52.115,36.865),(51.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,26.325),(71.145,26.495),(71.315,26.495),(71.315,26.325),(71.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,26.325),(71.485,26.495),(71.655,26.495),(71.655,26.325),(71.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,40.265),(13.545,40.435),(13.715,40.435),(13.715,40.265),(13.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,40.605),(13.545,40.775),(13.715,40.775),(13.715,40.605),(13.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.645),(42.345,8.815),(42.515,8.815),(42.515,8.645),(42.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,32.445),(23.145,32.615),(23.315,32.615),(23.315,32.445),(23.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,32.105),(23.145,32.275),(23.315,32.275),(23.315,32.105),(23.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,27.345),(66.345,27.515),(66.515,27.515),(66.515,27.345),(66.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,27.345),(66.685,27.515),(66.855,27.515),(66.855,27.345),(66.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,27.005),(66.345,27.175),(66.515,27.175),(66.515,27.005),(66.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,27.005),(66.685,27.175),(66.855,27.175),(66.855,27.005),(66.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,27.685),(66.345,27.855),(66.515,27.855),(66.515,27.685),(66.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,27.685),(66.685,27.855),(66.855,27.855),(66.855,27.685),(66.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,39.245),(28.285,39.415),(28.455,39.415),(28.455,39.245),(28.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,39.585),(28.285,39.755),(28.455,39.755),(28.455,39.585),(28.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.985),(37.885,9.155),(38.055,9.155),(38.055,8.985),(37.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,26.665),(75.945,26.835),(76.115,26.835),(76.115,26.665),(75.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,26.325),(75.945,26.495),(76.115,26.495),(76.115,26.325),(75.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.305),(42.345,25.475),(42.515,25.475),(42.515,25.305),(42.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.305),(42.685,25.475),(42.855,25.475),(42.855,25.305),(42.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.645),(42.345,25.815),(42.515,25.815),(42.515,25.645),(42.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.225),(37.885,38.395),(38.055,38.395),(38.055,38.225),(37.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,27.005),(76.285,27.175),(76.455,27.175),(76.455,27.005),(76.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,27.345),(76.285,27.515),(76.455,27.515),(76.455,27.345),(76.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,27.685),(76.285,27.855),(76.455,27.855),(76.455,27.685),(76.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.565),(37.885,38.735),(38.055,38.735),(38.055,38.565),(37.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.645),(42.685,25.815),(42.855,25.815),(42.855,25.645),(42.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.985),(8.745,9.155),(8.915,9.155),(8.915,8.985),(8.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.385),(52.285,12.555),(52.455,12.555),(52.455,12.385),(52.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,30.405),(71.485,30.575),(71.655,30.575),(71.655,30.405),(71.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,30.065),(71.145,30.235),(71.315,30.235),(71.315,30.065),(71.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,30.065),(71.485,30.235),(71.655,30.235),(71.655,30.065),(71.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,30.405),(71.145,30.575),(71.315,30.575),(71.315,30.405),(71.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,30.745),(71.145,30.915),(71.315,30.915),(71.315,30.745),(71.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,30.745),(71.485,30.915),(71.655,30.915),(71.655,30.745),(71.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.365),(33.085,28.535),(33.255,28.535),(33.255,28.365),(33.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.025),(33.085,28.195),(33.255,28.195),(33.255,28.025),(33.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.705),(33.085,28.875),(33.255,28.875),(33.255,28.705),(33.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.725),(47.145,12.895),(47.315,12.895),(47.315,12.725),(47.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.725),(47.485,12.895),(47.655,12.895),(47.655,12.725),(47.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.385),(47.145,12.555),(47.315,12.555),(47.315,12.385),(47.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.385),(47.485,12.555),(47.655,12.555),(47.655,12.385),(47.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.325),(47.485,9.495),(47.655,9.495),(47.655,9.325),(47.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.045),(47.145,12.215),(47.315,12.215),(47.315,12.045),(47.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.045),(47.485,12.215),(47.655,12.215),(47.655,12.045),(47.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.905),(56.745,5.075),(56.915,5.075),(56.915,4.905),(56.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,37.205),(81.085,37.375),(81.255,37.375),(81.255,37.205),(81.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,37.545),(81.085,37.715),(81.255,37.715),(81.255,37.545),(81.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.885),(42.345,4.055),(42.515,4.055),(42.515,3.885),(42.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.885),(42.685,4.055),(42.855,4.055),(42.855,3.885),(42.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,26.665),(81.085,26.835),(81.255,26.835),(81.255,26.665),(81.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,26.325),(81.085,26.495),(81.255,26.495),(81.255,26.325),(81.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.905),(13.545,5.075),(13.715,5.075),(13.715,4.905),(13.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.325),(27.945,9.495),(28.115,9.495),(28.115,9.325),(27.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.665),(27.945,9.835),(28.115,9.835),(28.115,9.665),(27.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.905),(42.345,22.075),(42.515,22.075),(42.515,21.905),(42.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.905),(42.685,22.075),(42.855,22.075),(42.855,21.905),(42.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.925),(37.885,40.095),(38.055,40.095),(38.055,39.925),(37.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.945),(61.545,7.115),(61.715,7.115),(61.715,6.945),(61.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,24.965),(28.285,25.135),(28.455,25.135),(28.455,24.965),(28.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.225),(52.285,38.395),(52.455,38.395),(52.455,38.225),(52.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.565),(52.285,38.735),(52.455,38.735),(52.455,38.565),(52.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.105),(66.345,15.275),(66.515,15.275),(66.515,15.105),(66.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.105),(66.685,15.275),(66.855,15.275),(66.855,15.105),(66.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.285),(32.745,7.455),(32.915,7.455),(32.915,7.285),(32.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.445),(66.345,15.615),(66.515,15.615),(66.515,15.445),(66.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.345),(28.285,10.515),(28.455,10.515),(28.455,10.345),(28.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.685),(28.285,10.855),(28.455,10.855),(28.455,10.685),(28.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.445),(66.685,15.615),(66.855,15.615),(66.855,15.445),(66.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.785),(66.345,15.955),(66.515,15.955),(66.515,15.785),(66.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,22.585),(66.345,22.755),(66.515,22.755),(66.515,22.585),(66.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,22.585),(66.685,22.755),(66.855,22.755),(66.855,22.585),(66.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,22.245),(66.345,22.415),(66.515,22.415),(66.515,22.245),(66.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,22.245),(66.685,22.415),(66.855,22.415),(66.855,22.245),(66.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.625),(28.285,7.795),(28.455,7.795),(28.455,7.625),(28.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.925),(47.145,40.095),(47.315,40.095),(47.315,39.925),(47.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.925),(47.485,40.095),(47.655,40.095),(47.655,39.925),(47.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.325),(13.885,9.495),(14.055,9.495),(14.055,9.325),(13.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.665),(13.885,9.835),(14.055,9.835),(14.055,9.665),(13.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.465),(56.745,16.635),(56.915,16.635),(56.915,16.465),(56.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.425),(56.745,31.595),(56.915,31.595),(56.915,31.425),(56.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.765),(56.745,31.935),(56.915,31.935),(56.915,31.765),(56.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.085),(56.745,31.255),(56.915,31.255),(56.915,31.085),(56.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.125),(56.745,16.295),(56.915,16.295),(56.915,16.125),(56.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.805),(56.745,16.975),(56.915,16.975),(56.915,16.805),(56.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,23.945),(18.345,24.115),(18.515,24.115),(18.515,23.945),(18.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,23.945),(18.685,24.115),(18.855,24.115),(18.855,23.945),(18.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.505),(56.745,35.675),(56.915,35.675),(56.915,35.505),(56.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.165),(56.745,35.335),(56.915,35.335),(56.915,35.165),(56.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.605),(61.885,6.775),(62.055,6.775),(62.055,6.605),(61.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,40.265),(61.885,40.435),(62.055,40.435),(62.055,40.265),(61.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,40.605),(61.885,40.775),(62.055,40.775),(62.055,40.605),(61.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.945),(9.085,7.115),(9.255,7.115),(9.255,6.945),(9.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.865),(76.285,20.035),(76.455,20.035),(76.455,19.865),(76.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.365),(33.085,11.535),(33.255,11.535),(33.255,11.365),(33.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.345),(66.345,10.515),(66.515,10.515),(66.515,10.345),(66.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.345),(66.685,10.515),(66.855,10.515),(66.855,10.345),(66.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.185),(33.085,36.355),(33.255,36.355),(33.255,36.185),(33.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.525),(33.085,36.695),(33.255,36.695),(33.255,36.525),(33.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.685),(66.345,10.855),(66.515,10.855),(66.515,10.685),(66.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.685),(66.685,10.855),(66.855,10.855),(66.855,10.685),(66.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.005),(66.345,10.175),(66.515,10.175),(66.515,10.005),(66.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.005),(66.685,10.175),(66.855,10.175),(66.855,10.005),(66.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.945),(71.145,7.115),(71.315,7.115),(71.315,6.945),(71.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.945),(71.485,7.115),(71.655,7.115),(71.655,6.945),(71.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.225),(81.085,4.395),(81.255,4.395),(81.255,4.225),(81.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.565),(81.085,4.735),(81.255,4.735),(81.255,4.565),(81.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.145),(9.085,17.315),(9.255,17.315),(9.255,17.145),(9.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.225),(33.085,21.395),(33.255,21.395),(33.255,21.225),(33.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.565),(33.085,21.735),(33.255,21.735),(33.255,21.565),(33.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,35.165),(76.285,35.335),(76.455,35.335),(76.455,35.165),(76.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,35.505),(76.285,35.675),(76.455,35.675),(76.455,35.505),(76.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.025),(28.285,11.195),(28.455,11.195),(28.455,11.025),(28.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.365),(28.285,11.535),(28.455,11.535),(28.455,11.365),(28.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.705),(28.285,11.875),(28.455,11.875),(28.455,11.705),(28.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,39.245),(76.285,39.415),(76.455,39.415),(76.455,39.245),(76.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,39.585),(76.285,39.755),(76.455,39.755),(76.455,39.585),(76.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.425),(23.145,14.595),(23.315,14.595),(23.315,14.425),(23.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.425),(23.485,14.595),(23.655,14.595),(23.655,14.425),(23.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.765),(23.145,14.935),(23.315,14.935),(23.315,14.765),(23.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.765),(23.485,14.935),(23.655,14.935),(23.655,14.765),(23.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,21.225),(23.145,21.395),(23.315,21.395),(23.315,21.225),(23.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,21.225),(23.485,21.395),(23.655,21.395),(23.655,21.225),(23.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,21.565),(23.145,21.735),(23.315,21.735),(23.315,21.565),(23.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,21.565),(23.485,21.735),(23.655,21.735),(23.655,21.565),(23.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,39.925),(27.945,40.095),(28.115,40.095),(28.115,39.925),(27.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.085),(23.145,14.255),(23.315,14.255),(23.315,14.085),(23.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.125),(28.285,16.295),(28.455,16.295),(28.455,16.125),(28.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.465),(28.285,16.635),(28.455,16.635),(28.455,16.465),(28.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.805),(28.285,16.975),(28.455,16.975),(28.455,16.805),(28.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.885),(18.345,4.055),(18.515,4.055),(18.515,3.885),(18.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.885),(18.685,4.055),(18.855,4.055),(18.855,3.885),(18.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.685),(51.945,10.855),(52.115,10.855),(52.115,10.685),(51.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,35.845),(27.945,36.015),(28.115,36.015),(28.115,35.845),(27.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.005),(51.945,10.175),(52.115,10.175),(52.115,10.005),(51.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.345),(51.945,10.515),(52.115,10.515),(52.115,10.345),(51.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.005),(13.545,10.175),(13.715,10.175),(13.715,10.005),(13.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.345),(13.545,10.515),(13.715,10.515),(13.715,10.345),(13.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.685),(13.545,10.855),(13.715,10.855),(13.715,10.685),(13.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.865),(9.085,20.035),(9.255,20.035),(9.255,19.865),(9.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,23.605),(27.945,23.775),(28.115,23.775),(28.115,23.605),(27.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,23.265),(27.945,23.435),(28.115,23.435),(28.115,23.265),(27.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.905),(33.085,39.075),(33.255,39.075),(33.255,38.905),(33.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.925),(71.145,6.095),(71.315,6.095),(71.315,5.925),(71.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.385),(66.345,12.555),(66.515,12.555),(66.515,12.385),(66.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.385),(66.685,12.555),(66.855,12.555),(66.855,12.385),(66.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.725),(66.345,12.895),(66.515,12.895),(66.515,12.725),(66.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.725),(66.685,12.895),(66.855,12.895),(66.855,12.725),(66.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.045),(66.345,12.215),(66.515,12.215),(66.515,12.045),(66.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.045),(66.685,12.215),(66.855,12.215),(66.855,12.045),(66.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.705),(47.145,11.875),(47.315,11.875),(47.315,11.705),(47.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.705),(47.485,11.875),(47.655,11.875),(47.655,11.705),(47.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.365),(47.145,11.535),(47.315,11.535),(47.315,11.365),(47.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.365),(47.485,11.535),(47.655,11.535),(47.655,11.365),(47.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,34.825),(13.545,34.995),(13.715,34.995),(13.715,34.825),(13.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,34.485),(13.545,34.655),(13.715,34.655),(13.715,34.485),(13.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.925),(51.945,23.095),(52.115,23.095),(52.115,22.925),(51.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,34.145),(13.545,34.315),(13.715,34.315),(13.715,34.145),(13.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,20.205),(28.285,20.375),(28.455,20.375),(28.455,20.205),(28.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,20.545),(28.285,20.715),(28.455,20.715),(28.455,20.545),(28.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.145),(18.345,17.315),(18.515,17.315),(18.515,17.145),(18.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.145),(18.685,17.315),(18.855,17.315),(18.855,17.145),(18.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.485),(18.345,17.655),(18.515,17.655),(18.515,17.485),(18.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.485),(18.685,17.655),(18.855,17.655),(18.855,17.485),(18.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.825),(18.345,17.995),(18.515,17.995),(18.515,17.825),(18.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.825),(18.685,17.995),(18.855,17.995),(18.855,17.825),(18.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,27.685),(8.745,27.855),(8.915,27.855),(8.915,27.685),(8.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,27.345),(8.745,27.515),(8.915,27.515),(8.915,27.345),(8.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,27.005),(8.745,27.175),(8.915,27.175),(8.915,27.005),(8.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.265),(56.745,23.435),(56.915,23.435),(56.915,23.265),(56.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.605),(56.745,23.775),(56.915,23.775),(56.915,23.605),(56.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,37.545),(28.285,37.715),(28.455,37.715),(28.455,37.545),(28.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,37.205),(28.285,37.375),(28.455,37.375),(28.455,37.205),(28.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,38.905),(80.745,39.075),(80.915,39.075),(80.915,38.905),(80.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.965),(75.945,8.135),(76.115,8.135),(76.115,7.965),(75.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,24.965),(80.745,25.135),(80.915,25.135),(80.915,24.965),(80.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.545),(66.345,3.715),(66.515,3.715),(66.515,3.545),(66.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.545),(66.685,3.715),(66.855,3.715),(66.855,3.545),(66.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.205),(66.345,3.375),(66.515,3.375),(66.515,3.205),(66.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,21.905),(9.085,22.075),(9.255,22.075),(9.255,21.905),(9.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.205),(66.685,3.375),(66.855,3.375),(66.855,3.205),(66.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,22.585),(81.085,22.755),(81.255,22.755),(81.255,22.585),(81.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,22.245),(81.085,22.415),(81.255,22.415),(81.255,22.245),(81.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,32.105),(71.145,32.275),(71.315,32.275),(71.315,32.105),(71.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,32.105),(71.485,32.275),(71.655,32.275),(71.655,32.105),(71.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,32.445),(71.145,32.615),(71.315,32.615),(71.315,32.445),(71.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,32.445),(71.485,32.615),(71.655,32.615),(71.655,32.445),(71.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,32.785),(71.145,32.955),(71.315,32.955),(71.315,32.785),(71.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,32.785),(71.485,32.955),(71.655,32.955),(71.655,32.785),(71.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,38.905),(13.885,39.075),(14.055,39.075),(14.055,38.905),(13.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.885),(28.285,4.055),(28.455,4.055),(28.455,3.885),(28.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.985),(51.945,26.155),(52.115,26.155),(52.115,25.985),(51.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.965),(27.945,8.135),(28.115,8.135),(28.115,7.965),(27.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.205),(51.945,20.375),(52.115,20.375),(52.115,20.205),(51.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.545),(51.945,20.715),(52.115,20.715),(52.115,20.545),(51.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.225),(57.085,4.395),(57.255,4.395),(57.255,4.225),(57.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.565),(57.085,4.735),(57.255,4.735),(57.255,4.565),(57.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.725),(23.485,12.895),(23.655,12.895),(23.655,12.725),(23.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,38.225),(81.085,38.395),(81.255,38.395),(81.255,38.225),(81.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,38.565),(81.085,38.735),(81.255,38.735),(81.255,38.565),(81.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.865),(33.085,20.035),(33.255,20.035),(33.255,19.865),(33.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.045),(23.145,12.215),(23.315,12.215),(23.315,12.045),(23.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.685),(33.085,27.855),(33.255,27.855),(33.255,27.685),(33.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.345),(33.085,27.515),(33.255,27.515),(33.255,27.345),(33.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.005),(33.085,27.175),(33.255,27.175),(33.255,27.005),(33.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.005),(18.345,10.175),(18.515,10.175),(18.515,10.005),(18.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.005),(18.685,10.175),(18.855,10.175),(18.855,10.005),(18.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.345),(18.345,10.515),(18.515,10.515),(18.515,10.345),(18.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.345),(18.685,10.515),(18.855,10.515),(18.855,10.345),(18.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.685),(18.345,10.855),(18.515,10.855),(18.515,10.685),(18.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.685),(18.685,10.855),(18.855,10.855),(18.855,10.685),(18.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.225),(33.085,4.395),(33.255,4.395),(33.255,4.225),(33.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.565),(33.085,4.735),(33.255,4.735),(33.255,4.565),(33.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.245),(75.945,5.415),(76.115,5.415),(76.115,5.245),(75.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.585),(75.945,5.755),(76.115,5.755),(76.115,5.585),(75.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.805),(37.885,33.975),(38.055,33.975),(38.055,33.805),(37.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.125),(37.885,33.295),(38.055,33.295),(38.055,33.125),(37.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.465),(37.885,33.635),(38.055,33.635),(38.055,33.465),(37.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.245),(51.945,39.415),(52.115,39.415),(52.115,39.245),(51.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.585),(51.945,39.755),(52.115,39.755),(52.115,39.585),(51.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.845),(32.745,36.015),(32.915,36.015),(32.915,35.845),(32.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.405),(37.885,30.575),(38.055,30.575),(38.055,30.405),(37.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.745),(37.885,30.915),(38.055,30.915),(38.055,30.745),(37.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.065),(37.885,30.235),(38.055,30.235),(38.055,30.065),(37.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,20.205),(13.885,20.375),(14.055,20.375),(14.055,20.205),(13.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,20.545),(13.885,20.715),(14.055,20.715),(14.055,20.545),(13.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.965),(47.145,25.135),(47.315,25.135),(47.315,24.965),(47.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.965),(47.485,25.135),(47.655,25.135),(47.655,24.965),(47.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,39.925),(9.085,40.095),(9.255,40.095),(9.255,39.925),(9.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.265),(51.945,6.435),(52.115,6.435),(52.115,6.265),(51.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.605),(51.945,6.775),(52.115,6.775),(52.115,6.605),(51.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.945),(66.345,7.115),(66.515,7.115),(66.515,6.945),(66.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.945),(66.685,7.115),(66.855,7.115),(66.855,6.945),(66.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.185),(52.285,36.355),(52.455,36.355),(52.455,36.185),(52.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.525),(52.285,36.695),(52.455,36.695),(52.455,36.525),(52.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,23.605),(9.085,23.775),(9.255,23.775),(9.255,23.605),(9.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,23.265),(9.085,23.435),(9.255,23.435),(9.255,23.265),(9.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,29.045),(80.745,29.215),(80.915,29.215),(80.915,29.045),(80.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,29.385),(80.745,29.555),(80.915,29.555),(80.915,29.385),(80.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,29.725),(80.745,29.895),(80.915,29.895),(80.915,29.725),(80.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.905),(9.085,5.075),(9.255,5.075),(9.255,4.905),(9.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.745),(71.145,13.915),(71.315,13.915),(71.315,13.745),(71.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.745),(71.485,13.915),(71.655,13.915),(71.655,13.745),(71.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.905),(47.145,22.075),(47.315,22.075),(47.315,21.905),(47.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.905),(47.485,22.075),(47.655,22.075),(47.655,21.905),(47.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.945),(37.885,7.115),(38.055,7.115),(38.055,6.945),(37.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.865),(23.145,20.035),(23.315,20.035),(23.315,19.865),(23.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.865),(23.485,20.035),(23.655,20.035),(23.655,19.865),(23.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,21.905),(80.745,22.075),(80.915,22.075),(80.915,21.905),(80.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.845),(51.945,19.015),(52.115,19.015),(52.115,18.845),(51.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,39.925),(75.945,40.095),(76.115,40.095),(76.115,39.925),(75.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.845),(42.345,19.015),(42.515,19.015),(42.515,18.845),(42.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.845),(42.685,19.015),(42.855,19.015),(42.855,18.845),(42.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.105),(23.485,15.275),(23.655,15.275),(23.655,15.105),(23.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.885),(51.945,38.055),(52.115,38.055),(52.115,37.885),(51.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,24.965),(18.345,25.135),(18.515,25.135),(18.515,24.965),(18.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,24.965),(18.685,25.135),(18.855,25.135),(18.855,24.965),(18.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.825),(66.345,17.995),(66.515,17.995),(66.515,17.825),(66.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.405),(47.145,13.575),(47.315,13.575),(47.315,13.405),(47.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,2.865),(76.285,3.035),(76.455,3.035),(76.455,2.865),(76.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,23.945),(23.145,24.115),(23.315,24.115),(23.315,23.945),(23.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,23.945),(23.485,24.115),(23.655,24.115),(23.655,23.945),(23.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,37.545),(75.945,37.715),(76.115,37.715),(76.115,37.545),(75.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,37.205),(75.945,37.375),(76.115,37.375),(76.115,37.205),(75.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.985),(32.745,9.155),(32.915,9.155),(32.915,8.985),(32.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.045),(56.745,29.215),(56.915,29.215),(56.915,29.045),(56.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.385),(56.745,29.555),(56.915,29.555),(56.915,29.385),(56.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.725),(56.745,29.895),(56.915,29.895),(56.915,29.725),(56.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.625),(42.345,7.795),(42.515,7.795),(42.515,7.625),(42.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.625),(42.685,7.795),(42.855,7.795),(42.855,7.625),(42.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.725),(51.945,12.895),(52.115,12.895),(52.115,12.725),(51.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.385),(51.945,12.555),(52.115,12.555),(52.115,12.385),(51.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.045),(51.945,12.215),(52.115,12.215),(52.115,12.045),(51.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.045),(52.285,12.215),(52.455,12.215),(52.455,12.045),(52.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,35.165),(81.085,35.335),(81.255,35.335),(81.255,35.165),(81.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,35.505),(81.085,35.675),(81.255,35.675),(81.255,35.505),(81.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.165),(18.345,18.335),(18.515,18.335),(18.515,18.165),(18.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.165),(18.685,18.335),(18.855,18.335),(18.855,18.165),(18.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.505),(18.345,18.675),(18.515,18.675),(18.515,18.505),(18.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.505),(18.685,18.675),(18.855,18.675),(18.855,18.505),(18.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.285),(80.745,7.455),(80.915,7.455),(80.915,7.285),(80.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.745),(9.085,13.915),(9.255,13.915),(9.255,13.745),(9.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,24.285),(13.885,24.455),(14.055,24.455),(14.055,24.285),(13.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,24.625),(13.885,24.795),(14.055,24.795),(14.055,24.625),(13.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.065),(9.085,13.235),(9.255,13.235),(9.255,13.065),(9.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.405),(9.085,13.575),(9.255,13.575),(9.255,13.405),(9.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.885),(56.745,4.055),(56.915,4.055),(56.915,3.885),(56.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,27.005),(18.345,27.175),(18.515,27.175),(18.515,27.005),(18.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,27.005),(18.685,27.175),(18.855,27.175),(18.855,27.005),(18.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,27.685),(18.345,27.855),(18.515,27.855),(18.515,27.685),(18.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,27.685),(18.685,27.855),(18.855,27.855),(18.855,27.685),(18.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.185),(42.345,36.355),(42.515,36.355),(42.515,36.185),(42.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.185),(42.685,36.355),(42.855,36.355),(42.855,36.185),(42.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.525),(42.345,36.695),(42.515,36.695),(42.515,36.525),(42.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.525),(42.685,36.695),(42.855,36.695),(42.855,36.525),(42.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,27.345),(18.345,27.515),(18.515,27.515),(18.515,27.345),(18.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,27.345),(18.685,27.515),(18.855,27.515),(18.855,27.345),(18.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.085),(33.085,14.255),(33.255,14.255),(33.255,14.085),(33.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.005),(33.085,10.175),(33.255,10.175),(33.255,10.005),(33.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.345),(33.085,10.515),(33.255,10.515),(33.255,10.345),(33.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.685),(33.085,10.855),(33.255,10.855),(33.255,10.685),(33.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.885),(32.745,4.055),(32.915,4.055),(32.915,3.885),(32.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.425),(57.085,14.595),(57.255,14.595),(57.255,14.425),(57.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.945),(18.345,7.115),(18.515,7.115),(18.515,6.945),(18.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.945),(18.685,7.115),(18.855,7.115),(18.855,6.945),(18.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.965),(33.085,25.135),(33.255,25.135),(33.255,24.965),(33.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.505),(51.945,35.675),(52.115,35.675),(52.115,35.505),(51.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.165),(51.945,35.335),(52.115,35.335),(52.115,35.165),(51.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.265),(37.885,23.435),(38.055,23.435),(38.055,23.265),(37.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,38.905),(27.945,39.075),(28.115,39.075),(28.115,38.905),(27.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.605),(37.885,23.775),(38.055,23.775),(38.055,23.605),(37.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,20.885),(80.745,21.055),(80.915,21.055),(80.915,20.885),(80.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.005),(76.285,10.175),(76.455,10.175),(76.455,10.005),(76.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.625),(71.145,7.795),(71.315,7.795),(71.315,7.625),(71.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.625),(71.485,7.795),(71.655,7.795),(71.655,7.625),(71.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,39.925),(66.345,40.095),(66.515,40.095),(66.515,39.925),(66.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,39.925),(66.685,40.095),(66.855,40.095),(66.855,39.925),(66.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.205),(37.885,20.375),(38.055,20.375),(38.055,20.205),(37.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.545),(37.885,20.715),(38.055,20.715),(38.055,20.545),(37.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.625),(47.145,7.795),(47.315,7.795),(47.315,7.625),(47.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.625),(47.485,7.795),(47.655,7.795),(47.655,7.625),(47.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.645),(51.945,8.815),(52.115,8.815),(52.115,8.645),(51.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.305),(51.945,8.475),(52.115,8.475),(52.115,8.305),(51.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.625),(23.145,7.795),(23.315,7.795),(23.315,7.625),(23.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.625),(23.485,7.795),(23.655,7.795),(23.655,7.625),(23.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.225),(32.745,21.395),(32.915,21.395),(32.915,21.225),(32.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.565),(32.745,21.735),(32.915,21.735),(32.915,21.565),(32.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,25.985),(27.945,26.155),(28.115,26.155),(28.115,25.985),(27.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.765),(52.285,31.935),(52.455,31.935),(52.455,31.765),(52.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.425),(52.285,31.595),(52.455,31.595),(52.455,31.425),(52.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.085),(52.285,31.255),(52.455,31.255),(52.455,31.085),(52.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.945),(56.745,24.115),(56.915,24.115),(56.915,23.945),(56.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.285),(37.885,7.455),(38.055,7.455),(38.055,7.285),(37.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.165),(80.745,18.335),(80.915,18.335),(80.915,18.165),(80.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.505),(80.745,18.675),(80.915,18.675),(80.915,18.505),(80.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.465),(57.085,33.635),(57.255,33.635),(57.255,33.465),(57.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.805),(57.085,33.975),(57.255,33.975),(57.255,33.805),(57.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.125),(57.085,33.295),(57.255,33.295),(57.255,33.125),(57.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,24.285),(71.145,24.455),(71.315,24.455),(71.315,24.285),(71.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,24.285),(71.485,24.455),(71.655,24.455),(71.655,24.285),(71.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,24.625),(71.145,24.795),(71.315,24.795),(71.315,24.625),(71.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,24.625),(71.485,24.795),(71.655,24.795),(71.655,24.625),(71.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,36.185),(27.945,36.355),(28.115,36.355),(28.115,36.185),(27.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,36.525),(27.945,36.695),(28.115,36.695),(28.115,36.525),(27.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.665),(75.945,9.835),(76.115,9.835),(76.115,9.665),(75.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.325),(75.945,9.495),(76.115,9.495),(76.115,9.325),(75.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.885),(66.345,4.055),(66.515,4.055),(66.515,3.885),(66.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.885),(66.685,4.055),(66.855,4.055),(66.855,3.885),(66.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,25.645),(8.745,25.815),(8.915,25.815),(8.915,25.645),(8.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,25.305),(8.745,25.475),(8.915,25.475),(8.915,25.305),(8.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,23.605),(13.885,23.775),(14.055,23.775),(14.055,23.605),(13.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,23.265),(13.885,23.435),(14.055,23.435),(14.055,23.265),(13.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.905),(57.085,5.075),(57.255,5.075),(57.255,4.905),(57.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.625),(18.345,7.795),(18.515,7.795),(18.515,7.625),(18.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.625),(18.685,7.795),(18.855,7.795),(18.855,7.625),(18.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.285),(61.885,7.455),(62.055,7.455),(62.055,7.285),(61.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,21.225),(27.945,21.395),(28.115,21.395),(28.115,21.225),(27.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,21.565),(27.945,21.735),(28.115,21.735),(28.115,21.565),(27.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.945),(42.345,7.115),(42.515,7.115),(42.515,6.945),(42.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.945),(42.685,7.115),(42.855,7.115),(42.855,6.945),(42.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,23.945),(81.085,24.115),(81.255,24.115),(81.255,23.945),(81.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.625),(76.285,7.795),(76.455,7.795),(76.455,7.625),(76.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.265),(66.685,6.435),(66.855,6.435),(66.855,6.265),(66.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.065),(66.345,13.235),(66.515,13.235),(66.515,13.065),(66.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.065),(66.685,13.235),(66.855,13.235),(66.855,13.065),(66.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.405),(66.345,13.575),(66.515,13.575),(66.515,13.405),(66.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.405),(66.685,13.575),(66.855,13.575),(66.855,13.405),(66.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.745),(66.345,13.915),(66.515,13.915),(66.515,13.745),(66.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.745),(66.685,13.915),(66.855,13.915),(66.855,13.745),(66.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.905),(56.745,39.075),(56.915,39.075),(56.915,38.905),(56.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,35.165),(23.485,35.335),(23.655,35.335),(23.655,35.165),(23.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,35.165),(23.145,35.335),(23.315,35.335),(23.315,35.165),(23.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,35.505),(23.145,35.675),(23.315,35.675),(23.315,35.505),(23.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,35.505),(23.485,35.675),(23.655,35.675),(23.655,35.505),(23.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.925),(61.545,6.095),(61.715,6.095),(61.715,5.925),(61.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,40.265),(57.085,40.435),(57.255,40.435),(57.255,40.265),(57.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,40.605),(57.085,40.775),(57.255,40.775),(57.255,40.605),(57.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.145),(27.945,17.315),(28.115,17.315),(28.115,17.145),(27.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.825),(27.945,17.995),(28.115,17.995),(28.115,17.825),(27.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.485),(27.945,17.655),(28.115,17.655),(28.115,17.485),(27.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,32.785),(8.745,32.955),(8.915,32.955),(8.915,32.785),(8.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,32.105),(8.745,32.275),(8.915,32.275),(8.915,32.105),(8.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,32.445),(8.745,32.615),(8.915,32.615),(8.915,32.445),(8.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.145),(37.545,17.315),(37.715,17.315),(37.715,17.145),(37.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.485),(37.545,17.655),(37.715,17.655),(37.715,17.485),(37.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.825),(37.545,17.995),(37.715,17.995),(37.715,17.825),(37.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.345),(75.945,10.515),(76.115,10.515),(76.115,10.345),(75.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.685),(75.945,10.855),(76.115,10.855),(76.115,10.685),(75.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,39.925),(18.345,40.095),(18.515,40.095),(18.515,39.925),(18.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,39.925),(18.685,40.095),(18.855,40.095),(18.855,39.925),(18.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.005),(75.945,10.175),(76.115,10.175),(76.115,10.005),(75.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.325),(42.345,9.495),(42.515,9.495),(42.515,9.325),(42.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.325),(42.685,9.495),(42.855,9.495),(42.855,9.325),(42.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.665),(42.345,9.835),(42.515,9.835),(42.515,9.665),(42.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.665),(42.685,9.835),(42.855,9.835),(42.855,9.665),(42.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.025),(76.285,11.195),(76.455,11.195),(76.455,11.025),(76.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.365),(76.285,11.535),(76.455,11.535),(76.455,11.365),(76.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.465),(23.145,16.635),(23.315,16.635),(23.315,16.465),(23.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,27.685),(13.885,27.855),(14.055,27.855),(14.055,27.685),(13.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,27.345),(13.885,27.515),(14.055,27.515),(14.055,27.345),(13.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,27.005),(13.885,27.175),(14.055,27.175),(14.055,27.005),(13.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.465),(23.485,16.635),(23.655,16.635),(23.655,16.465),(23.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.125),(23.145,16.295),(23.315,16.295),(23.315,16.125),(23.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.125),(23.485,16.295),(23.655,16.295),(23.655,16.125),(23.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.805),(23.145,16.975),(23.315,16.975),(23.315,16.805),(23.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.805),(23.485,16.975),(23.655,16.975),(23.655,16.805),(23.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.085),(71.145,14.255),(71.315,14.255),(71.315,14.085),(71.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,24.285),(61.545,24.455),(61.715,24.455),(61.715,24.285),(61.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.085),(71.485,14.255),(71.655,14.255),(71.655,14.085),(71.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.425),(71.145,14.595),(71.315,14.595),(71.315,14.425),(71.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.425),(71.485,14.595),(71.655,14.595),(71.655,14.425),(71.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.765),(71.145,14.935),(71.315,14.935),(71.315,14.765),(71.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.765),(71.485,14.935),(71.655,14.935),(71.655,14.765),(71.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.625),(61.545,7.795),(61.715,7.795),(61.715,7.625),(61.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.005),(27.945,10.175),(28.115,10.175),(28.115,10.005),(27.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.345),(27.945,10.515),(28.115,10.515),(28.115,10.345),(27.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.685),(27.945,10.855),(28.115,10.855),(28.115,10.685),(27.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,40.605),(37.545,40.775),(37.715,40.775),(37.715,40.605),(37.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,40.265),(37.545,40.435),(37.715,40.435),(37.715,40.265),(37.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.905),(13.885,5.075),(14.055,5.075),(14.055,4.905),(13.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.565),(57.085,21.735),(57.255,21.735),(57.255,21.565),(57.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,29.045),(81.085,29.215),(81.255,29.215),(81.255,29.045),(81.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,29.385),(81.085,29.555),(81.255,29.555),(81.255,29.385),(81.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,29.725),(81.085,29.895),(81.255,29.895),(81.255,29.725),(81.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,28.025),(81.085,28.195),(81.255,28.195),(81.255,28.025),(81.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,28.365),(81.085,28.535),(81.255,28.535),(81.255,28.365),(81.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,28.705),(81.085,28.875),(81.255,28.875),(81.255,28.705),(81.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,31.765),(13.885,31.935),(14.055,31.935),(14.055,31.765),(13.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,33.805),(81.085,33.975),(81.255,33.975),(81.255,33.805),(81.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,33.125),(81.085,33.295),(81.255,33.295),(81.255,33.125),(81.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,33.465),(81.085,33.635),(81.255,33.635),(81.255,33.465),(81.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,31.425),(13.885,31.595),(14.055,31.595),(14.055,31.425),(13.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,31.085),(13.885,31.255),(14.055,31.255),(14.055,31.085),(13.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,20.205),(23.145,20.375),(23.315,20.375),(23.315,20.205),(23.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.225),(18.345,4.395),(18.515,4.395),(18.515,4.225),(18.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.225),(18.685,4.395),(18.855,4.395),(18.855,4.225),(18.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.565),(18.345,4.735),(18.515,4.735),(18.515,4.565),(18.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.565),(18.685,4.735),(18.855,4.735),(18.855,4.565),(18.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.925),(28.285,6.095),(28.455,6.095),(28.455,5.925),(28.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,28.705),(75.945,28.875),(76.115,28.875),(76.115,28.705),(75.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,31.425),(66.345,31.595),(66.515,31.595),(66.515,31.425),(66.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,31.425),(66.685,31.595),(66.855,31.595),(66.855,31.425),(66.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,31.765),(66.345,31.935),(66.515,31.935),(66.515,31.765),(66.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,31.765),(66.685,31.935),(66.855,31.935),(66.855,31.765),(66.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,31.085),(66.345,31.255),(66.515,31.255),(66.515,31.085),(66.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,31.085),(66.685,31.255),(66.855,31.255),(66.855,31.085),(66.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.145),(13.545,17.315),(13.715,17.315),(13.715,17.145),(13.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.825),(13.545,17.995),(13.715,17.995),(13.715,17.825),(13.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.485),(13.545,17.655),(13.715,17.655),(13.715,17.485),(13.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.945),(81.085,7.115),(81.255,7.115),(81.255,6.945),(81.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.805),(51.945,33.975),(52.115,33.975),(52.115,33.805),(51.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.125),(51.945,33.295),(52.115,33.295),(52.115,33.125),(51.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.465),(51.945,33.635),(52.115,33.635),(52.115,33.465),(51.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.885),(42.345,38.055),(42.515,38.055),(42.515,37.885),(42.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.885),(42.685,38.055),(42.855,38.055),(42.855,37.885),(42.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.105),(9.085,15.275),(9.255,15.275),(9.255,15.105),(9.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.525),(28.285,19.695),(28.455,19.695),(28.455,19.525),(28.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.185),(28.285,19.355),(28.455,19.355),(28.455,19.185),(28.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.305),(57.085,25.475),(57.255,25.475),(57.255,25.305),(57.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.645),(57.085,25.815),(57.255,25.815),(57.255,25.645),(57.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,2.865),(66.345,3.035),(66.515,3.035),(66.515,2.865),(66.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.885),(57.085,21.055),(57.255,21.055),(57.255,20.885),(57.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,2.865),(66.685,3.035),(66.855,3.035),(66.855,2.865),(66.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.265),(76.285,6.435),(76.455,6.435),(76.455,6.265),(76.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.605),(76.285,6.775),(76.455,6.775),(76.455,6.605),(76.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.745),(18.345,13.915),(18.515,13.915),(18.515,13.745),(18.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.745),(18.685,13.915),(18.855,13.915),(18.855,13.745),(18.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.065),(18.345,13.235),(18.515,13.235),(18.515,13.065),(18.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.065),(18.685,13.235),(18.855,13.235),(18.855,13.065),(18.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.405),(18.345,13.575),(18.515,13.575),(18.515,13.405),(18.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.405),(18.685,13.575),(18.855,13.575),(18.855,13.405),(18.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.925),(42.345,40.095),(42.515,40.095),(42.515,39.925),(42.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.925),(42.685,40.095),(42.855,40.095),(42.855,39.925),(42.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.885),(76.285,4.055),(76.455,4.055),(76.455,3.885),(76.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,33.465),(18.345,33.635),(18.515,33.635),(18.515,33.465),(18.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,33.465),(18.685,33.635),(18.855,33.635),(18.855,33.465),(18.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,33.805),(18.345,33.975),(18.515,33.975),(18.515,33.805),(18.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,33.805),(18.685,33.975),(18.855,33.975),(18.855,33.805),(18.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,33.125),(18.345,33.295),(18.515,33.295),(18.515,33.125),(18.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,33.125),(18.685,33.295),(18.855,33.295),(18.855,33.125),(18.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.645),(57.085,8.815),(57.255,8.815),(57.255,8.645),(57.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.305),(57.085,8.475),(57.255,8.475),(57.255,8.305),(57.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.225),(37.545,21.395),(37.715,21.395),(37.715,21.225),(37.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.565),(37.545,21.735),(37.715,21.735),(37.715,21.565),(37.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.685),(23.145,10.855),(23.315,10.855),(23.315,10.685),(23.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,33.805),(80.745,33.975),(80.915,33.975),(80.915,33.805),(80.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,33.125),(80.745,33.295),(80.915,33.295),(80.915,33.125),(80.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,33.465),(80.745,33.635),(80.915,33.635),(80.915,33.465),(80.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.885),(52.285,38.055),(52.455,38.055),(52.455,37.885),(52.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.745),(47.485,13.915),(47.655,13.915),(47.655,13.745),(47.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.065),(47.145,13.235),(47.315,13.235),(47.315,13.065),(47.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.225),(42.345,4.395),(42.515,4.395),(42.515,4.225),(42.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.225),(42.685,4.395),(42.855,4.395),(42.855,4.225),(42.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.565),(42.345,4.735),(42.515,4.735),(42.515,4.565),(42.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.565),(42.685,4.735),(42.855,4.735),(42.855,4.565),(42.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.345),(81.085,10.515),(81.255,10.515),(81.255,10.345),(81.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.685),(81.085,10.855),(81.255,10.855),(81.255,10.685),(81.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,37.545),(9.085,37.715),(9.255,37.715),(9.255,37.545),(9.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,25.985),(71.145,26.155),(71.315,26.155),(71.315,25.985),(71.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,25.985),(71.485,26.155),(71.655,26.155),(71.655,25.985),(71.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,37.205),(9.085,37.375),(9.255,37.375),(9.255,37.205),(9.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.005),(81.085,10.175),(81.255,10.175),(81.255,10.005),(81.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.885),(80.745,4.055),(80.915,4.055),(80.915,3.885),(80.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.145),(33.085,17.315),(33.255,17.315),(33.255,17.145),(33.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.825),(33.085,17.995),(33.255,17.995),(33.255,17.825),(33.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.485),(33.085,17.655),(33.255,17.655),(33.255,17.485),(33.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.505),(71.145,18.675),(71.315,18.675),(71.315,18.505),(71.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,24.625),(75.945,24.795),(76.115,24.795),(76.115,24.625),(75.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,24.285),(75.945,24.455),(76.115,24.455),(76.115,24.285),(75.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.505),(71.485,18.675),(71.655,18.675),(71.655,18.505),(71.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.165),(71.145,18.335),(71.315,18.335),(71.315,18.165),(71.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.165),(71.485,18.335),(71.655,18.335),(71.655,18.165),(71.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.045),(52.285,29.215),(52.455,29.215),(52.455,29.045),(52.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.385),(52.285,29.555),(52.455,29.555),(52.455,29.385),(52.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.725),(52.285,29.895),(52.455,29.895),(52.455,29.725),(52.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.205),(51.945,3.375),(52.115,3.375),(52.115,3.205),(51.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.545),(51.945,3.715),(52.115,3.715),(52.115,3.545),(51.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.245),(80.745,5.415),(80.915,5.415),(80.915,5.245),(80.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,22.585),(9.085,22.755),(9.255,22.755),(9.255,22.585),(9.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,22.245),(9.085,22.415),(9.255,22.415),(9.255,22.245),(9.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.065),(33.085,13.235),(33.255,13.235),(33.255,13.065),(33.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.405),(33.085,13.575),(33.255,13.575),(33.255,13.405),(33.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.745),(33.085,13.915),(33.255,13.915),(33.255,13.745),(33.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,30.405),(8.745,30.575),(8.915,30.575),(8.915,30.405),(8.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,30.065),(8.745,30.235),(8.915,30.235),(8.915,30.065),(8.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,30.745),(8.745,30.915),(8.915,30.915),(8.915,30.745),(8.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,21.225),(13.545,21.395),(13.715,21.395),(13.715,21.225),(13.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,21.565),(13.545,21.735),(13.715,21.735),(13.715,21.565),(13.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.345),(47.145,27.515),(47.315,27.515),(47.315,27.345),(47.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.345),(47.485,27.515),(47.655,27.515),(47.655,27.345),(47.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.005),(47.145,27.175),(47.315,27.175),(47.315,27.005),(47.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.005),(47.485,27.175),(47.655,27.175),(47.655,27.005),(47.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.685),(47.145,27.855),(47.315,27.855),(47.315,27.685),(47.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.685),(47.485,27.855),(47.655,27.855),(47.655,27.685),(47.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,23.605),(28.285,23.775),(28.455,23.775),(28.455,23.605),(28.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,23.265),(28.285,23.435),(28.455,23.435),(28.455,23.265),(28.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,32.785),(61.545,32.955),(61.715,32.955),(61.715,32.785),(61.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,32.105),(61.545,32.275),(61.715,32.275),(61.715,32.105),(61.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,32.445),(61.545,32.615),(61.715,32.615),(61.715,32.445),(61.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,22.585),(71.145,22.755),(71.315,22.755),(71.315,22.585),(71.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,22.585),(71.485,22.755),(71.655,22.755),(71.655,22.585),(71.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,22.245),(71.145,22.415),(71.315,22.415),(71.315,22.245),(71.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,22.245),(71.485,22.415),(71.655,22.415),(71.655,22.245),(71.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,24.965),(76.285,25.135),(76.455,25.135),(76.455,24.965),(76.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.225),(42.345,21.395),(42.515,21.395),(42.515,21.225),(42.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.225),(42.685,21.395),(42.855,21.395),(42.855,21.225),(42.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.565),(42.345,21.735),(42.515,21.735),(42.515,21.565),(42.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.565),(42.685,21.735),(42.855,21.735),(42.855,21.565),(42.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.025),(8.745,11.195),(8.915,11.195),(8.915,11.025),(8.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.365),(8.745,11.535),(8.915,11.535),(8.915,11.365),(8.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.705),(8.745,11.875),(8.915,11.875),(8.915,11.705),(8.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,40.605),(27.945,40.775),(28.115,40.775),(28.115,40.605),(27.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.805),(42.345,33.975),(42.515,33.975),(42.515,33.805),(42.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.805),(42.685,33.975),(42.855,33.975),(42.855,33.805),(42.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.125),(42.345,33.295),(42.515,33.295),(42.515,33.125),(42.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.125),(42.685,33.295),(42.855,33.295),(42.855,33.125),(42.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.465),(42.345,33.635),(42.515,33.635),(42.515,33.465),(42.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.465),(42.685,33.635),(42.855,33.635),(42.855,33.465),(42.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,40.265),(27.945,40.435),(28.115,40.435),(28.115,40.265),(27.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.785),(57.085,32.955),(57.255,32.955),(57.255,32.785),(57.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.105),(57.085,32.275),(57.255,32.275),(57.255,32.105),(57.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.445),(57.085,32.615),(57.255,32.615),(57.255,32.445),(57.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,38.905),(28.285,39.075),(28.455,39.075),(28.455,38.905),(28.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,38.565),(71.145,38.735),(71.315,38.735),(71.315,38.565),(71.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,38.565),(71.485,38.735),(71.655,38.735),(71.655,38.565),(71.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,38.225),(71.145,38.395),(71.315,38.395),(71.315,38.225),(71.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,38.225),(71.485,38.395),(71.655,38.395),(71.655,38.225),(71.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.925),(32.745,23.095),(32.915,23.095),(32.915,22.925),(32.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.165),(81.085,18.335),(81.255,18.335),(81.255,18.165),(81.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.505),(81.085,18.675),(81.255,18.675),(81.255,18.505),(81.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.085),(57.085,14.255),(57.255,14.255),(57.255,14.085),(57.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.105),(33.085,32.275),(33.255,32.275),(33.255,32.105),(33.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.445),(33.085,32.615),(33.255,32.615),(33.255,32.445),(33.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.785),(33.085,32.955),(33.255,32.955),(33.255,32.785),(33.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.525),(66.345,19.695),(66.515,19.695),(66.515,19.525),(66.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.525),(66.685,19.695),(66.855,19.695),(66.855,19.525),(66.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.925),(9.085,6.095),(9.255,6.095),(9.255,5.925),(9.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.185),(66.345,19.355),(66.515,19.355),(66.515,19.185),(66.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.185),(66.685,19.355),(66.855,19.355),(66.855,19.185),(66.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.185),(56.745,19.355),(56.915,19.355),(56.915,19.185),(56.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.525),(56.745,19.695),(56.915,19.695),(56.915,19.525),(56.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.905),(61.885,5.075),(62.055,5.075),(62.055,4.905),(61.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.385),(27.945,12.555),(28.115,12.555),(28.115,12.385),(27.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.725),(27.945,12.895),(28.115,12.895),(28.115,12.725),(27.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.045),(27.945,12.215),(28.115,12.215),(28.115,12.045),(27.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.625),(66.345,7.795),(66.515,7.795),(66.515,7.625),(66.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.625),(66.685,7.795),(66.855,7.795),(66.855,7.625),(66.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.085),(18.685,14.255),(18.855,14.255),(18.855,14.085),(18.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.205),(33.085,20.375),(33.255,20.375),(33.255,20.205),(33.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.545),(33.085,20.715),(33.255,20.715),(33.255,20.545),(33.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.765),(37.885,14.935),(38.055,14.935),(38.055,14.765),(37.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.085),(37.885,14.255),(38.055,14.255),(38.055,14.085),(37.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.425),(37.885,14.595),(38.055,14.595),(38.055,14.425),(37.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.225),(13.885,4.395),(14.055,4.395),(14.055,4.225),(13.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.565),(13.885,4.735),(14.055,4.735),(14.055,4.565),(13.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,37.885),(61.545,38.055),(61.715,38.055),(61.715,37.885),(61.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.725),(9.085,12.895),(9.255,12.895),(9.255,12.725),(9.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,22.925),(76.285,23.095),(76.455,23.095),(76.455,22.925),(76.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.385),(9.085,12.555),(9.255,12.555),(9.255,12.385),(9.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.045),(9.085,12.215),(9.255,12.215),(9.255,12.045),(9.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.625),(9.085,7.795),(9.255,7.795),(9.255,7.625),(9.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.125),(76.285,16.295),(76.455,16.295),(76.455,16.125),(76.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.465),(76.285,16.635),(76.455,16.635),(76.455,16.465),(76.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.805),(76.285,16.975),(76.455,16.975),(76.455,16.805),(76.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.185),(37.885,36.355),(38.055,36.355),(38.055,36.185),(37.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.525),(37.885,36.695),(38.055,36.695),(38.055,36.525),(37.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,28.365),(61.885,28.535),(62.055,28.535),(62.055,28.365),(61.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,34.145),(61.885,34.315),(62.055,34.315),(62.055,34.145),(61.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,34.485),(61.885,34.655),(62.055,34.655),(62.055,34.485),(61.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,34.825),(61.885,34.995),(62.055,34.995),(62.055,34.825),(61.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,32.445),(75.945,32.615),(76.115,32.615),(76.115,32.445),(75.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,32.785),(75.945,32.955),(76.115,32.955),(76.115,32.785),(75.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,32.105),(75.945,32.275),(76.115,32.275),(76.115,32.105),(75.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,28.025),(61.885,28.195),(62.055,28.195),(62.055,28.025),(61.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.305),(27.945,8.475),(28.115,8.475),(28.115,8.305),(27.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.645),(27.945,8.815),(28.115,8.815),(28.115,8.645),(27.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,22.585),(8.745,22.755),(8.915,22.755),(8.915,22.585),(8.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,22.245),(8.745,22.415),(8.915,22.415),(8.915,22.245),(8.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,29.725),(13.545,29.895),(13.715,29.895),(13.715,29.725),(13.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,29.385),(13.545,29.555),(13.715,29.555),(13.715,29.385),(13.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,29.045),(13.545,29.215),(13.715,29.215),(13.715,29.045),(13.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.525),(47.145,19.695),(47.315,19.695),(47.315,19.525),(47.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,23.265),(75.945,23.435),(76.115,23.435),(76.115,23.265),(75.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,23.605),(75.945,23.775),(76.115,23.775),(76.115,23.605),(75.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.925),(33.085,23.095),(33.255,23.095),(33.255,22.925),(33.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.525),(47.485,19.695),(47.655,19.695),(47.655,19.525),(47.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.185),(47.145,19.355),(47.315,19.355),(47.315,19.185),(47.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.185),(47.485,19.355),(47.655,19.355),(47.655,19.185),(47.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,31.425),(28.285,31.595),(28.455,31.595),(28.455,31.425),(28.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,31.765),(28.285,31.935),(28.455,31.935),(28.455,31.765),(28.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,31.085),(28.285,31.255),(28.455,31.255),(28.455,31.085),(28.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,20.205),(76.285,20.375),(76.455,20.375),(76.455,20.205),(76.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,20.545),(76.285,20.715),(76.455,20.715),(76.455,20.545),(76.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,35.505),(61.545,35.675),(61.715,35.675),(61.715,35.505),(61.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,35.165),(61.545,35.335),(61.715,35.335),(61.715,35.165),(61.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.685),(47.145,10.855),(47.315,10.855),(47.315,10.685),(47.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.685),(47.485,10.855),(47.655,10.855),(47.655,10.685),(47.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.005),(47.145,10.175),(47.315,10.175),(47.315,10.005),(47.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.005),(47.485,10.175),(47.655,10.175),(47.655,10.005),(47.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.345),(47.145,10.515),(47.315,10.515),(47.315,10.345),(47.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.345),(47.485,10.515),(47.655,10.515),(47.655,10.345),(47.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.985),(80.745,9.155),(80.915,9.155),(80.915,8.985),(80.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.585),(71.485,5.755),(71.655,5.755),(71.655,5.585),(71.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,36.185),(61.545,36.355),(61.715,36.355),(61.715,36.185),(61.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,36.525),(61.545,36.695),(61.715,36.695),(61.715,36.525),(61.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.585),(37.885,5.755),(38.055,5.755),(38.055,5.585),(37.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.245),(37.885,5.415),(38.055,5.415),(38.055,5.245),(37.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,34.145),(81.085,34.315),(81.255,34.315),(81.255,34.145),(81.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,34.485),(81.085,34.655),(81.255,34.655),(81.255,34.485),(81.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,34.825),(81.085,34.995),(81.255,34.995),(81.255,34.825),(81.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.005),(57.085,27.175),(57.255,27.175),(57.255,27.005),(57.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.345),(57.085,27.515),(57.255,27.515),(57.255,27.345),(57.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.685),(57.085,27.855),(57.255,27.855),(57.255,27.685),(57.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,32.785),(13.885,32.955),(14.055,32.955),(14.055,32.785),(13.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,32.105),(13.885,32.275),(14.055,32.275),(14.055,32.105),(13.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,32.445),(13.885,32.615),(14.055,32.615),(14.055,32.445),(13.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,20.885),(8.745,21.055),(8.915,21.055),(8.915,20.885),(8.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.225),(66.345,4.395),(66.515,4.395),(66.515,4.225),(66.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.225),(66.685,4.395),(66.855,4.395),(66.855,4.225),(66.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.565),(66.345,4.735),(66.515,4.735),(66.515,4.565),(66.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,40.265),(75.945,40.435),(76.115,40.435),(76.115,40.265),(75.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,40.605),(75.945,40.775),(76.115,40.775),(76.115,40.605),(75.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.565),(66.685,4.735),(66.855,4.735),(66.855,4.565),(66.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,22.245),(18.345,22.415),(18.515,22.415),(18.515,22.245),(18.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,28.705),(61.885,28.875),(62.055,28.875),(62.055,28.705),(61.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,22.245),(18.685,22.415),(18.855,22.415),(18.855,22.245),(18.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,22.585),(18.345,22.755),(18.515,22.755),(18.515,22.585),(18.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,22.585),(18.685,22.755),(18.855,22.755),(18.855,22.585),(18.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,20.885),(61.885,21.055),(62.055,21.055),(62.055,20.885),(61.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.865),(32.745,20.035),(32.915,20.035),(32.915,19.865),(32.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.045),(23.485,12.215),(23.655,12.215),(23.655,12.045),(23.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.565),(47.145,38.735),(47.315,38.735),(47.315,38.565),(47.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.565),(47.485,38.735),(47.655,38.735),(47.655,38.565),(47.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.225),(47.145,38.395),(47.315,38.395),(47.315,38.225),(47.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.225),(47.485,38.395),(47.655,38.395),(47.655,38.225),(47.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.245),(13.885,5.415),(14.055,5.415),(14.055,5.245),(13.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.585),(13.885,5.755),(14.055,5.755),(14.055,5.585),(13.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.165),(76.285,18.335),(76.455,18.335),(76.455,18.165),(76.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.505),(76.285,18.675),(76.455,18.675),(76.455,18.505),(76.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,38.565),(23.145,38.735),(23.315,38.735),(23.315,38.565),(23.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,38.565),(23.485,38.735),(23.655,38.735),(23.655,38.565),(23.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,38.225),(23.145,38.395),(23.315,38.395),(23.315,38.225),(23.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,38.225),(23.485,38.395),(23.655,38.395),(23.655,38.225),(23.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,33.125),(66.345,33.295),(66.515,33.295),(66.515,33.125),(66.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,33.125),(66.685,33.295),(66.855,33.295),(66.855,33.125),(66.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,33.465),(66.345,33.635),(66.515,33.635),(66.515,33.465),(66.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,33.465),(66.685,33.635),(66.855,33.635),(66.855,33.465),(66.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,33.805),(66.345,33.975),(66.515,33.975),(66.515,33.805),(66.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,33.805),(66.685,33.975),(66.855,33.975),(66.855,33.805),(66.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,25.305),(61.545,25.475),(61.715,25.475),(61.715,25.305),(61.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,25.645),(61.545,25.815),(61.715,25.815),(61.715,25.645),(61.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.265),(47.145,23.435),(47.315,23.435),(47.315,23.265),(47.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.265),(47.485,23.435),(47.655,23.435),(47.655,23.265),(47.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.605),(47.145,23.775),(47.315,23.775),(47.315,23.605),(47.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.605),(47.485,23.775),(47.655,23.775),(47.655,23.605),(47.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,40.265),(61.545,40.435),(61.715,40.435),(61.715,40.265),(61.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,40.605),(61.545,40.775),(61.715,40.775),(61.715,40.605),(61.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,24.965),(81.085,25.135),(81.255,25.135),(81.255,24.965),(81.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.225),(37.885,4.395),(38.055,4.395),(38.055,4.225),(37.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.565),(37.885,4.735),(38.055,4.735),(38.055,4.565),(37.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.865),(71.145,20.035),(71.315,20.035),(71.315,19.865),(71.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.865),(71.485,20.035),(71.655,20.035),(71.655,19.865),(71.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,36.865),(75.945,37.035),(76.115,37.035),(76.115,36.865),(75.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,34.145),(28.285,34.315),(28.455,34.315),(28.455,34.145),(28.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,34.485),(28.285,34.655),(28.455,34.655),(28.455,34.485),(28.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,34.825),(28.285,34.995),(28.455,34.995),(28.455,34.825),(28.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,28.025),(8.745,28.195),(8.915,28.195),(8.915,28.025),(8.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,28.365),(8.745,28.535),(8.915,28.535),(8.915,28.365),(8.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,28.705),(8.745,28.875),(8.915,28.875),(8.915,28.705),(8.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,21.225),(80.745,21.395),(80.915,21.395),(80.915,21.225),(80.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,21.565),(80.745,21.735),(80.915,21.735),(80.915,21.565),(80.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,31.425),(18.345,31.595),(18.515,31.595),(18.515,31.425),(18.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,31.425),(18.685,31.595),(18.855,31.595),(18.855,31.425),(18.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,31.765),(18.345,31.935),(18.515,31.935),(18.515,31.765),(18.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,31.765),(18.685,31.935),(18.855,31.935),(18.855,31.765),(18.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,31.085),(18.345,31.255),(18.515,31.255),(18.515,31.085),(18.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,31.085),(18.685,31.255),(18.855,31.255),(18.855,31.085),(18.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.645),(71.145,8.815),(71.315,8.815),(71.315,8.645),(71.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.645),(71.485,8.815),(71.655,8.815),(71.655,8.645),(71.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.305),(71.145,8.475),(71.315,8.475),(71.315,8.305),(71.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.865),(66.345,20.035),(66.515,20.035),(66.515,19.865),(66.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.865),(66.685,20.035),(66.855,20.035),(66.855,19.865),(66.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.305),(71.485,8.475),(71.655,8.475),(71.655,8.305),(71.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.785),(23.145,15.955),(23.315,15.955),(23.315,15.785),(23.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.685),(23.485,10.855),(23.655,10.855),(23.655,10.685),(23.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,23.945),(71.145,24.115),(71.315,24.115),(71.315,23.945),(71.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,23.945),(71.485,24.115),(71.655,24.115),(71.655,23.945),(71.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.325),(8.745,9.495),(8.915,9.495),(8.915,9.325),(8.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.665),(8.745,9.835),(8.915,9.835),(8.915,9.665),(8.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.025),(51.945,28.195),(52.115,28.195),(52.115,28.025),(51.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.365),(51.945,28.535),(52.115,28.535),(52.115,28.365),(51.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.705),(51.945,28.875),(52.115,28.875),(52.115,28.705),(51.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.485),(66.345,17.655),(66.515,17.655),(66.515,17.485),(66.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.485),(66.685,17.655),(66.855,17.655),(66.855,17.485),(66.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.245),(52.285,22.415),(52.455,22.415),(52.455,22.245),(52.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.585),(52.285,22.755),(52.455,22.755),(52.455,22.585),(52.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,32.105),(23.485,32.275),(23.655,32.275),(23.655,32.105),(23.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,32.445),(23.485,32.615),(23.655,32.615),(23.655,32.445),(23.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.305),(23.145,8.475),(23.315,8.475),(23.315,8.305),(23.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.305),(23.485,8.475),(23.655,8.475),(23.655,8.305),(23.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.645),(23.145,8.815),(23.315,8.815),(23.315,8.645),(23.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.645),(23.485,8.815),(23.655,8.815),(23.655,8.645),(23.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.265),(13.545,6.435),(13.715,6.435),(13.715,6.265),(13.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.605),(13.545,6.775),(13.715,6.775),(13.715,6.605),(13.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.865),(81.085,20.035),(81.255,20.035),(81.255,19.865),(81.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,27.005),(81.085,27.175),(81.255,27.175),(81.255,27.005),(81.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,27.345),(81.085,27.515),(81.255,27.515),(81.255,27.345),(81.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,27.685),(81.085,27.855),(81.255,27.855),(81.255,27.685),(81.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.465),(9.085,16.635),(9.255,16.635),(9.255,16.465),(9.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.805),(9.085,16.975),(9.255,16.975),(9.255,16.805),(9.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.125),(9.085,16.295),(9.255,16.295),(9.255,16.125),(9.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.025),(18.345,11.195),(18.515,11.195),(18.515,11.025),(18.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,35.845),(61.885,36.015),(62.055,36.015),(62.055,35.845),(61.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.025),(18.685,11.195),(18.855,11.195),(18.855,11.025),(18.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,24.965),(61.885,25.135),(62.055,25.135),(62.055,24.965),(61.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.965),(57.085,25.135),(57.255,25.135),(57.255,24.965),(57.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.365),(18.345,11.535),(18.515,11.535),(18.515,11.365),(18.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.365),(18.685,11.535),(18.855,11.535),(18.855,11.365),(18.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.705),(18.345,11.875),(18.515,11.875),(18.515,11.705),(18.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.705),(18.685,11.875),(18.855,11.875),(18.855,11.705),(18.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.865),(51.945,3.035),(52.115,3.035),(52.115,2.865),(51.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.845),(37.545,36.015),(37.715,36.015),(37.715,35.845),(37.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,29.045),(66.345,29.215),(66.515,29.215),(66.515,29.045),(66.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,29.045),(66.685,29.215),(66.855,29.215),(66.855,29.045),(66.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,29.385),(66.345,29.555),(66.515,29.555),(66.515,29.385),(66.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,29.385),(66.685,29.555),(66.855,29.555),(66.855,29.385),(66.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,29.725),(66.345,29.895),(66.515,29.895),(66.515,29.725),(66.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,29.725),(66.685,29.895),(66.855,29.895),(66.855,29.725),(66.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.965),(42.345,25.135),(42.515,25.135),(42.515,24.965),(42.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.965),(42.685,25.135),(42.855,25.135),(42.855,24.965),(42.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,37.885),(61.885,38.055),(62.055,38.055),(62.055,37.885),(61.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.765),(33.085,14.935),(33.255,14.935),(33.255,14.765),(33.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.145),(56.745,17.315),(56.915,17.315),(56.915,17.145),(56.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.845),(9.085,19.015),(9.255,19.015),(9.255,18.845),(9.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,38.225),(61.545,38.395),(61.715,38.395),(61.715,38.225),(61.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,38.565),(61.545,38.735),(61.715,38.735),(61.715,38.565),(61.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.485),(56.745,17.655),(56.915,17.655),(56.915,17.485),(56.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.825),(56.745,17.995),(56.915,17.995),(56.915,17.825),(56.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.845),(51.945,36.015),(52.115,36.015),(52.115,35.845),(51.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.945),(37.885,24.115),(38.055,24.115),(38.055,23.945),(37.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.185),(61.545,19.355),(61.715,19.355),(61.715,19.185),(61.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.525),(61.545,19.695),(61.715,19.695),(61.715,19.525),(61.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.185),(32.745,36.355),(32.915,36.355),(32.915,36.185),(32.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.525),(32.745,36.695),(32.915,36.695),(32.915,36.525),(32.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,31.425),(13.545,31.595),(13.715,31.595),(13.715,31.425),(13.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,31.765),(13.545,31.935),(13.715,31.935),(13.715,31.765),(13.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,31.085),(13.545,31.255),(13.715,31.255),(13.715,31.085),(13.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,28.705),(76.285,28.875),(76.455,28.875),(76.455,28.705),(76.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,30.745),(80.745,30.915),(80.915,30.915),(80.915,30.745),(80.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,29.725),(28.285,29.895),(28.455,29.895),(28.455,29.725),(28.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,29.385),(28.285,29.555),(28.455,29.555),(28.455,29.385),(28.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,29.045),(28.285,29.215),(28.455,29.215),(28.455,29.045),(28.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.905),(66.345,5.075),(66.515,5.075),(66.515,4.905),(66.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.905),(66.685,5.075),(66.855,5.075),(66.855,4.905),(66.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.925),(37.545,40.095),(37.715,40.095),(37.715,39.925),(37.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.785),(13.885,15.955),(14.055,15.955),(14.055,15.785),(13.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.445),(13.885,15.615),(14.055,15.615),(14.055,15.445),(13.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.105),(13.885,15.275),(14.055,15.275),(14.055,15.105),(13.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.705),(37.885,28.875),(38.055,28.875),(38.055,28.705),(37.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.365),(37.885,28.535),(38.055,28.535),(38.055,28.365),(37.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.025),(37.885,28.195),(38.055,28.195),(38.055,28.025),(37.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.645),(56.745,8.815),(56.915,8.815),(56.915,8.645),(56.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.305),(56.745,8.475),(56.915,8.475),(56.915,8.305),(56.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.185),(18.345,19.355),(18.515,19.355),(18.515,19.185),(18.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.185),(18.685,19.355),(18.855,19.355),(18.855,19.185),(18.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.525),(18.345,19.695),(18.515,19.695),(18.515,19.525),(18.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.525),(18.685,19.695),(18.855,19.695),(18.855,19.525),(18.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,20.205),(13.545,20.375),(13.715,20.375),(13.715,20.205),(13.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,20.545),(13.545,20.715),(13.715,20.715),(13.715,20.545),(13.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,23.945),(13.885,24.115),(14.055,24.115),(14.055,23.945),(13.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,21.905),(61.545,22.075),(61.715,22.075),(61.715,21.905),(61.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.845),(66.345,19.015),(66.515,19.015),(66.515,18.845),(66.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.845),(66.685,19.015),(66.855,19.015),(66.855,18.845),(66.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,20.885),(66.345,21.055),(66.515,21.055),(66.515,20.885),(66.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,20.885),(66.685,21.055),(66.855,21.055),(66.855,20.885),(66.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.605),(37.545,6.775),(37.715,6.775),(37.715,6.605),(37.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.265),(37.545,6.435),(37.715,6.435),(37.715,6.265),(37.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,26.665),(9.085,26.835),(9.255,26.835),(9.255,26.665),(9.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,26.325),(9.085,26.495),(9.255,26.495),(9.255,26.325),(9.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.385),(75.945,12.555),(76.115,12.555),(76.115,12.385),(75.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.725),(75.945,12.895),(76.115,12.895),(76.115,12.725),(75.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.045),(75.945,12.215),(76.115,12.215),(76.115,12.045),(75.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,37.885),(80.745,38.055),(80.915,38.055),(80.915,37.885),(80.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.425),(61.885,14.595),(62.055,14.595),(62.055,14.425),(61.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.765),(61.885,14.935),(62.055,14.935),(62.055,14.765),(61.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.085),(61.885,14.255),(62.055,14.255),(62.055,14.085),(61.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,25.645),(81.085,25.815),(81.255,25.815),(81.255,25.645),(81.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,25.305),(81.085,25.475),(81.255,25.475),(81.255,25.305),(81.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,25.645),(23.145,25.815),(23.315,25.815),(23.315,25.645),(23.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,25.645),(23.485,25.815),(23.655,25.815),(23.655,25.645),(23.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,38.905),(61.885,39.075),(62.055,39.075),(62.055,38.905),(61.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,25.305),(23.145,25.475),(23.315,25.475),(23.315,25.305),(23.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,25.305),(23.485,25.475),(23.655,25.475),(23.655,25.305),(23.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.845),(8.745,19.015),(8.915,19.015),(8.915,18.845),(8.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.845),(23.145,19.015),(23.315,19.015),(23.315,18.845),(23.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.845),(23.485,19.015),(23.655,19.015),(23.655,18.845),(23.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.165),(37.885,35.335),(38.055,35.335),(38.055,35.165),(37.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.505),(37.885,35.675),(38.055,35.675),(38.055,35.505),(37.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.925),(52.285,40.095),(52.455,40.095),(52.455,39.925),(52.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,21.905),(8.745,22.075),(8.915,22.075),(8.915,21.905),(8.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.425),(32.745,31.595),(32.915,31.595),(32.915,31.425),(32.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.765),(32.745,31.935),(32.915,31.935),(32.915,31.765),(32.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.085),(32.745,31.255),(32.915,31.255),(32.915,31.085),(32.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.125),(71.145,16.295),(71.315,16.295),(71.315,16.125),(71.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.125),(71.485,16.295),(71.655,16.295),(71.655,16.125),(71.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.465),(71.145,16.635),(71.315,16.635),(71.315,16.465),(71.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.465),(71.485,16.635),(71.655,16.635),(71.655,16.465),(71.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.805),(71.145,16.975),(71.315,16.975),(71.315,16.805),(71.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.805),(71.485,16.975),(71.655,16.975),(71.655,16.805),(71.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,33.805),(13.545,33.975),(13.715,33.975),(13.715,33.805),(13.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,33.125),(13.545,33.295),(13.715,33.295),(13.715,33.125),(13.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,33.465),(13.545,33.635),(13.715,33.635),(13.715,33.465),(13.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.405),(81.085,13.575),(81.255,13.575),(81.255,13.405),(81.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.385),(81.085,12.555),(81.255,12.555),(81.255,12.385),(81.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.745),(81.085,13.915),(81.255,13.915),(81.255,13.745),(81.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.065),(81.085,13.235),(81.255,13.235),(81.255,13.065),(81.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.725),(81.085,12.895),(81.255,12.895),(81.255,12.725),(81.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.045),(81.085,12.215),(81.255,12.215),(81.255,12.045),(81.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,24.285),(13.545,24.455),(13.715,24.455),(13.715,24.285),(13.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,24.625),(13.545,24.795),(13.715,24.795),(13.715,24.625),(13.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.865),(32.745,3.035),(32.915,3.035),(32.915,2.865),(32.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.305),(75.945,8.475),(76.115,8.475),(76.115,8.305),(75.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.645),(75.945,8.815),(76.115,8.815),(76.115,8.645),(75.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,22.925),(23.145,23.095),(23.315,23.095),(23.315,22.925),(23.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,22.925),(23.485,23.095),(23.655,23.095),(23.655,22.925),(23.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,26.665),(8.745,26.835),(8.915,26.835),(8.915,26.665),(8.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,26.325),(8.745,26.495),(8.915,26.495),(8.915,26.325),(8.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,33.805),(9.085,33.975),(9.255,33.975),(9.255,33.805),(9.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,33.125),(9.085,33.295),(9.255,33.295),(9.255,33.125),(9.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,33.465),(9.085,33.635),(9.255,33.635),(9.255,33.465),(9.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.305),(37.545,25.475),(37.715,25.475),(37.715,25.305),(37.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.645),(37.545,25.815),(37.715,25.815),(37.715,25.645),(37.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,21.225),(71.145,21.395),(71.315,21.395),(71.315,21.225),(71.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,21.225),(71.485,21.395),(71.655,21.395),(71.655,21.225),(71.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,20.205),(71.145,20.375),(71.315,20.375),(71.315,20.205),(71.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,20.205),(71.485,20.375),(71.655,20.375),(71.655,20.205),(71.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,20.545),(71.145,20.715),(71.315,20.715),(71.315,20.545),(71.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,20.545),(71.485,20.715),(71.655,20.715),(71.655,20.545),(71.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,21.565),(71.145,21.735),(71.315,21.735),(71.315,21.565),(71.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,21.565),(71.485,21.735),(71.655,21.735),(71.655,21.565),(71.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.065),(80.745,13.235),(80.915,13.235),(80.915,13.065),(80.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.865),(61.885,20.035),(62.055,20.035),(62.055,19.865),(61.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.925),(81.085,6.095),(81.255,6.095),(81.255,5.925),(81.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,28.025),(13.545,28.195),(13.715,28.195),(13.715,28.025),(13.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,28.365),(13.545,28.535),(13.715,28.535),(13.715,28.365),(13.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,28.705),(13.545,28.875),(13.715,28.875),(13.715,28.705),(13.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,26.665),(13.885,26.835),(14.055,26.835),(14.055,26.665),(13.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,26.325),(13.885,26.495),(14.055,26.495),(14.055,26.325),(13.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.845),(32.745,19.015),(32.915,19.015),(32.915,18.845),(32.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.245),(28.285,5.415),(28.455,5.415),(28.455,5.245),(28.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.585),(28.285,5.755),(28.455,5.755),(28.455,5.585),(28.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.025),(32.745,11.195),(32.915,11.195),(32.915,11.025),(32.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.365),(32.745,11.535),(32.915,11.535),(32.915,11.365),(32.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.705),(32.745,11.875),(32.915,11.875),(32.915,11.705),(32.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,21.905),(61.885,22.075),(62.055,22.075),(62.055,21.905),(61.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.145),(56.745,34.315),(56.915,34.315),(56.915,34.145),(56.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.485),(56.745,34.655),(56.915,34.655),(56.915,34.485),(56.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.825),(56.745,34.995),(56.915,34.995),(56.915,34.825),(56.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.205),(42.345,37.375),(42.515,37.375),(42.515,37.205),(42.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.205),(42.685,37.375),(42.855,37.375),(42.855,37.205),(42.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.545),(42.345,37.715),(42.515,37.715),(42.515,37.545),(42.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.545),(42.685,37.715),(42.855,37.715),(42.855,37.545),(42.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,38.905),(8.745,39.075),(8.915,39.075),(8.915,38.905),(8.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.205),(37.545,20.375),(37.715,20.375),(37.715,20.205),(37.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.545),(37.545,20.715),(37.715,20.715),(37.715,20.545),(37.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.125),(27.945,16.295),(28.115,16.295),(28.115,16.125),(27.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.465),(27.945,16.635),(28.115,16.635),(28.115,16.465),(27.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.805),(27.945,16.975),(28.115,16.975),(28.115,16.805),(27.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.145),(32.745,34.315),(32.915,34.315),(32.915,34.145),(32.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.485),(32.745,34.655),(32.915,34.655),(32.915,34.485),(32.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.825),(32.745,34.995),(32.915,34.995),(32.915,34.825),(32.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,35.845),(71.145,36.015),(71.315,36.015),(71.315,35.845),(71.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,35.845),(71.485,36.015),(71.655,36.015),(71.655,35.845),(71.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,23.265),(66.345,23.435),(66.515,23.435),(66.515,23.265),(66.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,23.265),(66.685,23.435),(66.855,23.435),(66.855,23.265),(66.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,23.605),(66.345,23.775),(66.515,23.775),(66.515,23.605),(66.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,23.605),(66.685,23.775),(66.855,23.775),(66.855,23.605),(66.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,39.245),(27.945,39.415),(28.115,39.415),(28.115,39.245),(27.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.245),(32.745,39.415),(32.915,39.415),(32.915,39.245),(32.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,39.585),(27.945,39.755),(28.115,39.755),(28.115,39.585),(27.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.585),(32.745,39.755),(32.915,39.755),(32.915,39.585),(32.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.125),(33.085,16.295),(33.255,16.295),(33.255,16.125),(33.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.465),(33.085,16.635),(33.255,16.635),(33.255,16.465),(33.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.805),(33.085,16.975),(33.255,16.975),(33.255,16.805),(33.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.865),(57.085,3.035),(57.255,3.035),(57.255,2.865),(57.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,2.865),(80.745,3.035),(80.915,3.035),(80.915,2.865),(80.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.205),(56.745,20.375),(56.915,20.375),(56.915,20.205),(56.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.545),(56.745,20.715),(56.915,20.715),(56.915,20.545),(56.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,36.185),(28.285,36.355),(28.455,36.355),(28.455,36.185),(28.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,36.525),(28.285,36.695),(28.455,36.695),(28.455,36.525),(28.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.705),(66.345,11.875),(66.515,11.875),(66.515,11.705),(66.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.705),(66.685,11.875),(66.855,11.875),(66.855,11.705),(66.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.965),(37.885,25.135),(38.055,25.135),(38.055,24.965),(37.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.365),(66.345,11.535),(66.515,11.535),(66.515,11.365),(66.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,38.565),(9.085,38.735),(9.255,38.735),(9.255,38.565),(9.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,38.225),(9.085,38.395),(9.255,38.395),(9.255,38.225),(9.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.365),(66.685,11.535),(66.855,11.535),(66.855,11.365),(66.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.025),(66.345,11.195),(66.515,11.195),(66.515,11.025),(66.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.225),(42.345,38.395),(42.515,38.395),(42.515,38.225),(42.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.225),(42.685,38.395),(42.855,38.395),(42.855,38.225),(42.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.565),(42.345,38.735),(42.515,38.735),(42.515,38.565),(42.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.565),(42.685,38.735),(42.855,38.735),(42.855,38.565),(42.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,21.225),(81.085,21.395),(81.255,21.395),(81.255,21.225),(81.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,21.565),(81.085,21.735),(81.255,21.735),(81.255,21.565),(81.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.545),(52.285,37.715),(52.455,37.715),(52.455,37.545),(52.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.205),(52.285,37.375),(52.455,37.375),(52.455,37.205),(52.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,20.205),(81.085,20.375),(81.255,20.375),(81.255,20.205),(81.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,24.965),(8.745,25.135),(8.915,25.135),(8.915,24.965),(8.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,20.545),(81.085,20.715),(81.255,20.715),(81.255,20.545),(81.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.525),(51.945,19.695),(52.115,19.695),(52.115,19.525),(51.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.185),(51.945,19.355),(52.115,19.355),(52.115,19.185),(51.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.265),(56.745,6.435),(56.915,6.435),(56.915,6.265),(56.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.605),(56.745,6.775),(56.915,6.775),(56.915,6.605),(56.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.385),(33.085,12.555),(33.255,12.555),(33.255,12.385),(33.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.725),(33.085,12.895),(33.255,12.895),(33.255,12.725),(33.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.045),(33.085,12.215),(33.255,12.215),(33.255,12.045),(33.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.265),(32.745,6.435),(32.915,6.435),(32.915,6.265),(32.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.605),(32.745,6.775),(32.915,6.775),(32.915,6.605),(32.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,37.885),(27.945,38.055),(28.115,38.055),(28.115,37.885),(27.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.205),(9.085,3.375),(9.255,3.375),(9.255,3.205),(9.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.845),(13.885,19.015),(14.055,19.015),(14.055,18.845),(13.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.845),(33.085,19.015),(33.255,19.015),(33.255,18.845),(33.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.545),(9.085,3.715),(9.255,3.715),(9.255,3.545),(9.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.265),(8.745,6.435),(8.915,6.435),(8.915,6.265),(8.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.605),(8.745,6.775),(8.915,6.775),(8.915,6.605),(8.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.745),(13.545,13.915),(13.715,13.915),(13.715,13.745),(13.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.065),(13.545,13.235),(13.715,13.235),(13.715,13.065),(13.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.405),(13.545,13.575),(13.715,13.575),(13.715,13.405),(13.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.625),(75.945,7.795),(76.115,7.795),(76.115,7.625),(75.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.865),(18.345,20.035),(18.515,20.035),(18.515,19.865),(18.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.865),(18.685,20.035),(18.855,20.035),(18.855,19.865),(18.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.885),(51.945,4.055),(52.115,4.055),(52.115,3.885),(51.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.225),(76.285,4.395),(76.455,4.395),(76.455,4.225),(76.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.565),(76.285,4.735),(76.455,4.735),(76.455,4.565),(76.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.285),(52.285,7.455),(52.455,7.455),(52.455,7.285),(52.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,24.965),(23.145,25.135),(23.315,25.135),(23.315,24.965),(23.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,24.965),(23.485,25.135),(23.655,25.135),(23.655,24.965),(23.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.625),(27.945,7.795),(28.115,7.795),(28.115,7.625),(27.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.985),(32.745,26.155),(32.915,26.155),(32.915,25.985),(32.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,23.945),(9.085,24.115),(9.255,24.115),(9.255,23.945),(9.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,28.365),(27.945,28.535),(28.115,28.535),(28.115,28.365),(27.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,28.025),(27.945,28.195),(28.115,28.195),(28.115,28.025),(27.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,28.705),(27.945,28.875),(28.115,28.875),(28.115,28.705),(27.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.225),(28.285,4.395),(28.455,4.395),(28.455,4.225),(28.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.565),(28.285,4.735),(28.455,4.735),(28.455,4.565),(28.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,25.645),(13.885,25.815),(14.055,25.815),(14.055,25.645),(13.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,25.305),(13.885,25.475),(14.055,25.475),(14.055,25.305),(13.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.665),(80.745,9.835),(80.915,9.835),(80.915,9.665),(80.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.325),(80.745,9.495),(80.915,9.495),(80.915,9.325),(80.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.625),(56.745,7.795),(56.915,7.795),(56.915,7.625),(56.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.265),(57.085,6.435),(57.255,6.435),(57.255,6.265),(57.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.605),(57.085,6.775),(57.255,6.775),(57.255,6.605),(57.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.625),(32.745,7.795),(32.915,7.795),(32.915,7.625),(32.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.845),(28.285,19.015),(28.455,19.015),(28.455,18.845),(28.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.265),(80.745,6.435),(80.915,6.435),(80.915,6.265),(80.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.605),(80.745,6.775),(80.915,6.775),(80.915,6.605),(80.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,40.265),(42.345,40.435),(42.515,40.435),(42.515,40.265),(42.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,40.265),(42.685,40.435),(42.855,40.435),(42.855,40.265),(42.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,40.605),(42.345,40.775),(42.515,40.775),(42.515,40.605),(42.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,40.605),(42.685,40.775),(42.855,40.775),(42.855,40.605),(42.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,29.725),(13.885,29.895),(14.055,29.895),(14.055,29.725),(13.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,29.385),(13.885,29.555),(14.055,29.555),(14.055,29.385),(13.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,29.045),(13.885,29.215),(14.055,29.215),(14.055,29.045),(13.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,20.885),(27.945,21.055),(28.115,21.055),(28.115,20.885),(27.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.265),(33.085,6.435),(33.255,6.435),(33.255,6.265),(33.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.605),(33.085,6.775),(33.255,6.775),(33.255,6.605),(33.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.945),(75.945,7.115),(76.115,7.115),(76.115,6.945),(75.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,33.125),(23.485,33.295),(23.655,33.295),(23.655,33.125),(23.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,33.465),(23.145,33.635),(23.315,33.635),(23.315,33.465),(23.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,33.465),(23.485,33.635),(23.655,33.635),(23.655,33.465),(23.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,33.805),(23.145,33.975),(23.315,33.975),(23.315,33.805),(23.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,33.805),(23.485,33.975),(23.655,33.975),(23.655,33.805),(23.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,33.125),(23.145,33.295),(23.315,33.295),(23.315,33.125),(23.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.285),(28.285,7.455),(28.455,7.455),(28.455,7.285),(28.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.925),(66.345,6.095),(66.515,6.095),(66.515,5.925),(66.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.925),(66.685,6.095),(66.855,6.095),(66.855,5.925),(66.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,39.245),(75.945,39.415),(76.115,39.415),(76.115,39.245),(75.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,39.585),(75.945,39.755),(76.115,39.755),(76.115,39.585),(75.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.085),(18.345,14.255),(18.515,14.255),(18.515,14.085),(18.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,35.165),(66.345,35.335),(66.515,35.335),(66.515,35.165),(66.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,35.165),(66.685,35.335),(66.855,35.335),(66.855,35.165),(66.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,35.505),(66.345,35.675),(66.515,35.675),(66.515,35.505),(66.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,35.505),(66.685,35.675),(66.855,35.675),(66.855,35.505),(66.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.565),(51.945,4.735),(52.115,4.735),(52.115,4.565),(51.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.925),(42.345,6.095),(42.515,6.095),(42.515,5.925),(42.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.925),(42.685,6.095),(42.855,6.095),(42.855,5.925),(42.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.225),(51.945,4.395),(52.115,4.395),(52.115,4.225),(51.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,36.525),(76.285,36.695),(76.455,36.695),(76.455,36.525),(76.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,36.185),(76.285,36.355),(76.455,36.355),(76.455,36.185),(76.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.945),(27.945,7.115),(28.115,7.115),(28.115,6.945),(27.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,22.925),(13.885,23.095),(14.055,23.095),(14.055,22.925),(13.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.605),(18.345,6.775),(18.515,6.775),(18.515,6.605),(18.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,26.665),(13.545,26.835),(13.715,26.835),(13.715,26.665),(13.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,26.325),(13.545,26.495),(13.715,26.495),(13.715,26.325),(13.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.045),(28.285,12.215),(28.455,12.215),(28.455,12.045),(28.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,36.865),(13.545,37.035),(13.715,37.035),(13.715,36.865),(13.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.985),(13.545,9.155),(13.715,9.155),(13.715,8.985),(13.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.425),(42.345,31.595),(42.515,31.595),(42.515,31.425),(42.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.425),(42.685,31.595),(42.855,31.595),(42.855,31.425),(42.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.765),(42.345,31.935),(42.515,31.935),(42.515,31.765),(42.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.765),(42.685,31.935),(42.855,31.935),(42.855,31.765),(42.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.085),(42.345,31.255),(42.515,31.255),(42.515,31.085),(42.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.085),(42.685,31.255),(42.855,31.255),(42.855,31.085),(42.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.845),(37.885,19.015),(38.055,19.015),(38.055,18.845),(37.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.725),(8.745,12.895),(8.915,12.895),(8.915,12.725),(8.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.385),(8.745,12.555),(8.915,12.555),(8.915,12.385),(8.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.045),(8.745,12.215),(8.915,12.215),(8.915,12.045),(8.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,22.925),(80.745,23.095),(80.915,23.095),(80.915,22.925),(80.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,25.985),(75.945,26.155),(76.115,26.155),(76.115,25.985),(75.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,40.265),(9.085,40.435),(9.255,40.435),(9.255,40.265),(9.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,40.605),(9.085,40.775),(9.255,40.775),(9.255,40.605),(9.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,30.405),(13.545,30.575),(13.715,30.575),(13.715,30.405),(13.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,30.065),(13.545,30.235),(13.715,30.235),(13.715,30.065),(13.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,30.745),(13.545,30.915),(13.715,30.915),(13.715,30.745),(13.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.965),(71.145,8.135),(71.315,8.135),(71.315,7.965),(71.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.965),(71.485,8.135),(71.655,8.135),(71.655,7.965),(71.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.905),(51.945,39.075),(52.115,39.075),(52.115,38.905),(51.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.965),(47.145,8.135),(47.315,8.135),(47.315,7.965),(47.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.965),(47.485,8.135),(47.655,8.135),(47.655,7.965),(47.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,20.885),(18.345,21.055),(18.515,21.055),(18.515,20.885),(18.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,20.885),(18.685,21.055),(18.855,21.055),(18.855,20.885),(18.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.925),(32.745,40.095),(32.915,40.095),(32.915,39.925),(32.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.325),(32.745,9.495),(32.915,9.495),(32.915,9.325),(32.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.665),(32.745,9.835),(32.915,9.835),(32.915,9.665),(32.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.845),(61.545,19.015),(61.715,19.015),(61.715,18.845),(61.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.965),(23.145,8.135),(23.315,8.135),(23.315,7.965),(23.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,34.145),(76.285,34.315),(76.455,34.315),(76.455,34.145),(76.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,34.485),(76.285,34.655),(76.455,34.655),(76.455,34.485),(76.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,34.825),(76.285,34.995),(76.455,34.995),(76.455,34.825),(76.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.965),(23.485,8.135),(23.655,8.135),(23.655,7.965),(23.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.025),(37.885,11.195),(38.055,11.195),(38.055,11.025),(37.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.365),(37.885,11.535),(38.055,11.535),(38.055,11.365),(37.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.705),(37.885,11.875),(38.055,11.875),(38.055,11.705),(37.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.885),(57.085,4.055),(57.255,4.055),(57.255,3.885),(57.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.025),(13.545,11.195),(13.715,11.195),(13.715,11.025),(13.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.365),(13.545,11.535),(13.715,11.535),(13.715,11.365),(13.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.705),(13.545,11.875),(13.715,11.875),(13.715,11.705),(13.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.745),(56.745,13.915),(56.915,13.915),(56.915,13.745),(56.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.065),(56.745,13.235),(56.915,13.235),(56.915,13.065),(56.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.885),(33.085,4.055),(33.255,4.055),(33.255,3.885),(33.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.405),(56.745,13.575),(56.915,13.575),(56.915,13.405),(56.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,21.225),(75.945,21.395),(76.115,21.395),(76.115,21.225),(75.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,21.565),(75.945,21.735),(76.115,21.735),(76.115,21.565),(75.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,22.925),(61.545,23.095),(61.715,23.095),(61.715,22.925),(61.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.025),(80.745,11.195),(80.915,11.195),(80.915,11.025),(80.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.365),(80.745,11.535),(80.915,11.535),(80.915,11.365),(80.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.705),(80.745,11.875),(80.915,11.875),(80.915,11.705),(80.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.985),(42.345,9.155),(42.515,9.155),(42.515,8.985),(42.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.985),(42.685,9.155),(42.855,9.155),(42.855,8.985),(42.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.185),(51.945,36.355),(52.115,36.355),(52.115,36.185),(51.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,35.165),(18.345,35.335),(18.515,35.335),(18.515,35.165),(18.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,35.165),(18.685,35.335),(18.855,35.335),(18.855,35.165),(18.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.525),(51.945,36.695),(52.115,36.695),(52.115,36.525),(51.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,35.505),(18.345,35.675),(18.515,35.675),(18.515,35.505),(18.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,35.505),(18.685,35.675),(18.855,35.675),(18.855,35.505),(18.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.245),(47.145,22.415),(47.315,22.415),(47.315,22.245),(47.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.245),(47.485,22.415),(47.655,22.415),(47.655,22.245),(47.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.585),(47.145,22.755),(47.315,22.755),(47.315,22.585),(47.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.585),(47.485,22.755),(47.655,22.755),(47.655,22.585),(47.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,37.885),(13.545,38.055),(13.715,38.055),(13.715,37.885),(13.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,35.165),(75.945,35.335),(76.115,35.335),(76.115,35.165),(75.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,35.505),(75.945,35.675),(76.115,35.675),(76.115,35.505),(75.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.305),(37.885,8.475),(38.055,8.475),(38.055,8.305),(37.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.645),(37.885,8.815),(38.055,8.815),(38.055,8.645),(37.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.925),(71.485,6.095),(71.655,6.095),(71.655,5.925),(71.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,40.265),(76.285,40.435),(76.455,40.435),(76.455,40.265),(76.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,40.605),(76.285,40.775),(76.455,40.775),(76.455,40.605),(76.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.145),(75.945,17.315),(76.115,17.315),(76.115,17.145),(75.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.485),(75.945,17.655),(76.115,17.655),(76.115,17.485),(75.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.825),(75.945,17.995),(76.115,17.995),(76.115,17.825),(75.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.905),(76.285,5.075),(76.455,5.075),(76.455,4.905),(76.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.925),(37.885,23.095),(38.055,23.095),(38.055,22.925),(37.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.825),(61.545,17.995),(61.715,17.995),(61.715,17.825),(61.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.785),(13.545,15.955),(13.715,15.955),(13.715,15.785),(13.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.445),(13.545,15.615),(13.715,15.615),(13.715,15.445),(13.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.105),(13.545,15.275),(13.715,15.275),(13.715,15.105),(13.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.165),(56.745,18.335),(56.915,18.335),(56.915,18.165),(56.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.505),(56.745,18.675),(56.915,18.675),(56.915,18.505),(56.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.905),(28.285,5.075),(28.455,5.075),(28.455,4.905),(28.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,32.445),(80.745,32.615),(80.915,32.615),(80.915,32.445),(80.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,32.785),(80.745,32.955),(80.915,32.955),(80.915,32.785),(80.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,32.105),(80.745,32.275),(80.915,32.275),(80.915,32.105),(80.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.805),(47.145,33.975),(47.315,33.975),(47.315,33.805),(47.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.805),(47.485,33.975),(47.655,33.975),(47.655,33.805),(47.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.125),(47.145,33.295),(47.315,33.295),(47.315,33.125),(47.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.125),(47.485,33.295),(47.655,33.295),(47.655,33.125),(47.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.465),(47.145,33.635),(47.315,33.635),(47.315,33.465),(47.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.465),(47.485,33.635),(47.655,33.635),(47.655,33.465),(47.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,33.125),(27.945,33.295),(28.115,33.295),(28.115,33.125),(27.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,33.465),(27.945,33.635),(28.115,33.635),(28.115,33.465),(27.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,33.805),(27.945,33.975),(28.115,33.975),(28.115,33.805),(27.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.385),(37.885,12.555),(38.055,12.555),(38.055,12.385),(37.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.725),(37.885,12.895),(38.055,12.895),(38.055,12.725),(37.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.785),(52.285,15.955),(52.455,15.955),(52.455,15.785),(52.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.965),(56.745,8.135),(56.915,8.135),(56.915,7.965),(56.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.905),(52.285,39.075),(52.455,39.075),(52.455,38.905),(52.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.885),(81.085,4.055),(81.255,4.055),(81.255,3.885),(81.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.085),(32.745,14.255),(32.915,14.255),(32.915,14.085),(32.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.965),(32.745,8.135),(32.915,8.135),(32.915,7.965),(32.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,22.925),(66.345,23.095),(66.515,23.095),(66.515,22.925),(66.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,22.925),(66.685,23.095),(66.855,23.095),(66.855,22.925),(66.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.165),(42.345,35.335),(42.515,35.335),(42.515,35.165),(42.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.165),(42.685,35.335),(42.855,35.335),(42.855,35.165),(42.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.505),(42.345,35.675),(42.515,35.675),(42.515,35.505),(42.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.505),(42.685,35.675),(42.855,35.675),(42.855,35.505),(42.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.865),(52.285,20.035),(52.455,20.035),(52.455,19.865),(52.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,38.225),(76.285,38.395),(76.455,38.395),(76.455,38.225),(76.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,38.565),(76.285,38.735),(76.455,38.735),(76.455,38.565),(76.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,23.605),(18.345,23.775),(18.515,23.775),(18.515,23.605),(18.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,23.605),(18.685,23.775),(18.855,23.775),(18.855,23.605),(18.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,23.265),(18.345,23.435),(18.515,23.435),(18.515,23.265),(18.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,23.265),(18.685,23.435),(18.855,23.435),(18.855,23.265),(18.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,35.845),(66.345,36.015),(66.515,36.015),(66.515,35.845),(66.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,35.845),(66.685,36.015),(66.855,36.015),(66.855,35.845),(66.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.325),(33.085,9.495),(33.255,9.495),(33.255,9.325),(33.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,29.725),(9.085,29.895),(9.255,29.895),(9.255,29.725),(9.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,29.385),(9.085,29.555),(9.255,29.555),(9.255,29.385),(9.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,29.045),(9.085,29.215),(9.255,29.215),(9.255,29.045),(9.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.185),(76.285,19.355),(76.455,19.355),(76.455,19.185),(76.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.525),(76.285,19.695),(76.455,19.695),(76.455,19.525),(76.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.865),(33.085,37.035),(33.255,37.035),(33.255,36.865),(33.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.165),(57.085,18.335),(57.255,18.335),(57.255,18.165),(57.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.505),(57.085,18.675),(57.255,18.675),(57.255,18.505),(57.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,40.605),(47.145,40.775),(47.315,40.775),(47.315,40.605),(47.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,40.605),(47.485,40.775),(47.655,40.775),(47.655,40.605),(47.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,40.265),(47.145,40.435),(47.315,40.435),(47.315,40.265),(47.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,40.265),(47.485,40.435),(47.655,40.435),(47.655,40.265),(47.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,32.785),(13.545,32.955),(13.715,32.955),(13.715,32.785),(13.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,32.105),(13.545,32.275),(13.715,32.275),(13.715,32.105),(13.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,32.445),(13.545,32.615),(13.715,32.615),(13.715,32.445),(13.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.725),(76.285,12.895),(76.455,12.895),(76.455,12.725),(76.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.625),(80.745,7.795),(80.915,7.795),(80.915,7.625),(80.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.905),(71.145,5.075),(71.315,5.075),(71.315,4.905),(71.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.145),(52.285,17.315),(52.455,17.315),(52.455,17.145),(52.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.825),(52.285,17.995),(52.455,17.995),(52.455,17.825),(52.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.485),(52.285,17.655),(52.455,17.655),(52.455,17.485),(52.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,29.045),(76.285,29.215),(76.455,29.215),(76.455,29.045),(76.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,29.385),(76.285,29.555),(76.455,29.555),(76.455,29.385),(76.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,29.725),(76.285,29.895),(76.455,29.895),(76.455,29.725),(76.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.185),(71.485,19.355),(71.655,19.355),(71.655,19.185),(71.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.005),(8.745,10.175),(8.915,10.175),(8.915,10.005),(8.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.345),(8.745,10.515),(8.915,10.515),(8.915,10.345),(8.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.685),(8.745,10.855),(8.915,10.855),(8.915,10.685),(8.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.285),(71.145,7.455),(71.315,7.455),(71.315,7.285),(71.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.285),(71.485,7.455),(71.655,7.455),(71.655,7.285),(71.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.285),(56.745,24.455),(56.915,24.455),(56.915,24.285),(56.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.625),(56.745,24.795),(56.915,24.795),(56.915,24.625),(56.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,30.405),(18.345,30.575),(18.515,30.575),(18.515,30.405),(18.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,30.405),(18.685,30.575),(18.855,30.575),(18.855,30.405),(18.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.325),(37.545,9.495),(37.715,9.495),(37.715,9.325),(37.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.665),(37.545,9.835),(37.715,9.835),(37.715,9.665),(37.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.245),(71.145,5.415),(71.315,5.415),(71.315,5.245),(71.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.245),(71.485,5.415),(71.655,5.415),(71.655,5.245),(71.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.225),(71.145,4.395),(71.315,4.395),(71.315,4.225),(71.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.225),(71.485,4.395),(71.655,4.395),(71.655,4.225),(71.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.285),(47.145,7.455),(47.315,7.455),(47.315,7.285),(47.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.285),(47.485,7.455),(47.655,7.455),(47.655,7.285),(47.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.565),(71.145,4.735),(71.315,4.735),(71.315,4.565),(71.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.565),(71.485,4.735),(71.655,4.735),(71.655,4.565),(71.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.245),(51.945,22.415),(52.115,22.415),(52.115,22.245),(51.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.585),(51.945,22.755),(52.115,22.755),(52.115,22.585),(51.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,20.885),(28.285,21.055),(28.455,21.055),(28.455,20.885),(28.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.905),(52.285,5.075),(52.455,5.075),(52.455,4.905),(52.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.725),(13.545,12.895),(13.715,12.895),(13.715,12.725),(13.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.385),(13.545,12.555),(13.715,12.555),(13.715,12.385),(13.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.045),(13.545,12.215),(13.715,12.215),(13.715,12.045),(13.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.245),(37.545,39.415),(37.715,39.415),(37.715,39.245),(37.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.585),(37.545,39.755),(37.715,39.755),(37.715,39.585),(37.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.225),(23.145,4.395),(23.315,4.395),(23.315,4.225),(23.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.225),(23.485,4.395),(23.655,4.395),(23.655,4.225),(23.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.565),(23.145,4.735),(23.315,4.735),(23.315,4.565),(23.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.565),(23.485,4.735),(23.655,4.735),(23.655,4.565),(23.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.005),(13.885,10.175),(14.055,10.175),(14.055,10.005),(13.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.345),(13.885,10.515),(14.055,10.515),(14.055,10.345),(13.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.685),(13.885,10.855),(14.055,10.855),(14.055,10.685),(13.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,23.265),(76.285,23.435),(76.455,23.435),(76.455,23.265),(76.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,23.605),(76.285,23.775),(76.455,23.775),(76.455,23.605),(76.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.685),(32.745,27.855),(32.915,27.855),(32.915,27.685),(32.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.345),(32.745,27.515),(32.915,27.515),(32.915,27.345),(32.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.005),(32.745,27.175),(32.915,27.175),(32.915,27.005),(32.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.985),(52.285,26.155),(52.455,26.155),(52.455,25.985),(52.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,21.225),(9.085,21.395),(9.255,21.395),(9.255,21.225),(9.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,21.565),(9.085,21.735),(9.255,21.735),(9.255,21.565),(9.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,22.925),(81.085,23.095),(81.255,23.095),(81.255,22.925),(81.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,35.845),(18.345,36.015),(18.515,36.015),(18.515,35.845),(18.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,35.845),(18.685,36.015),(18.855,36.015),(18.855,35.845),(18.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,34.825),(13.885,34.995),(14.055,34.995),(14.055,34.825),(13.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,34.485),(13.885,34.655),(14.055,34.655),(14.055,34.485),(13.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,34.145),(13.885,34.315),(14.055,34.315),(14.055,34.145),(13.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,37.885),(8.745,38.055),(8.915,38.055),(8.915,37.885),(8.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,38.565),(13.885,38.735),(14.055,38.735),(14.055,38.565),(13.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,38.225),(13.885,38.395),(14.055,38.395),(14.055,38.225),(13.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.545),(28.285,3.715),(28.455,3.715),(28.455,3.545),(28.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.205),(28.285,3.375),(28.455,3.375),(28.455,3.205),(28.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.665),(57.085,9.835),(57.255,9.835),(57.255,9.665),(57.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.325),(57.085,9.495),(57.255,9.495),(57.255,9.325),(57.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.045),(37.885,12.215),(38.055,12.215),(38.055,12.045),(37.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.385),(32.745,12.555),(32.915,12.555),(32.915,12.385),(32.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.725),(32.745,12.895),(32.915,12.895),(32.915,12.725),(32.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.285),(18.345,7.455),(18.515,7.455),(18.515,7.285),(18.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.285),(18.685,7.455),(18.855,7.455),(18.855,7.285),(18.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.045),(32.745,12.215),(32.915,12.215),(32.915,12.045),(32.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,38.905),(81.085,39.075),(81.255,39.075),(81.255,38.905),(81.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,29.725),(18.345,29.895),(18.515,29.895),(18.515,29.725),(18.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,29.725),(18.685,29.895),(18.855,29.895),(18.855,29.725),(18.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,29.045),(18.345,29.215),(18.515,29.215),(18.515,29.045),(18.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,37.885),(71.145,38.055),(71.315,38.055),(71.315,37.885),(71.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,37.885),(71.485,38.055),(71.655,38.055),(71.655,37.885),(71.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,29.045),(18.685,29.215),(18.855,29.215),(18.855,29.045),(18.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,29.385),(18.345,29.555),(18.515,29.555),(18.515,29.385),(18.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,29.385),(18.685,29.555),(18.855,29.555),(18.855,29.385),(18.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.925),(75.945,6.095),(76.115,6.095),(76.115,5.925),(75.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,40.265),(33.085,40.435),(33.255,40.435),(33.255,40.265),(33.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,40.605),(33.085,40.775),(33.255,40.775),(33.255,40.605),(33.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.625),(61.885,7.795),(62.055,7.795),(62.055,7.625),(61.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,37.545),(80.745,37.715),(80.915,37.715),(80.915,37.545),(80.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,37.205),(80.745,37.375),(80.915,37.375),(80.915,37.205),(80.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.165),(32.745,35.335),(32.915,35.335),(32.915,35.165),(32.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.845),(57.085,36.015),(57.255,36.015),(57.255,35.845),(57.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.505),(32.745,35.675),(32.915,35.675),(32.915,35.505),(32.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,33.805),(13.885,33.975),(14.055,33.975),(14.055,33.805),(13.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,33.125),(13.885,33.295),(14.055,33.295),(14.055,33.125),(13.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,33.465),(13.885,33.635),(14.055,33.635),(14.055,33.465),(13.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.325),(52.285,9.495),(52.455,9.495),(52.455,9.325),(52.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.665),(52.285,9.835),(52.455,9.835),(52.455,9.665),(52.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.125),(81.085,16.295),(81.255,16.295),(81.255,16.125),(81.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.465),(81.085,16.635),(81.255,16.635),(81.255,16.465),(81.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.805),(81.085,16.975),(81.255,16.975),(81.255,16.805),(81.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.865),(52.285,37.035),(52.455,37.035),(52.455,36.865),(52.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.845),(33.085,36.015),(33.255,36.015),(33.255,35.845),(33.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.185),(47.145,36.355),(47.315,36.355),(47.315,36.185),(47.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.185),(47.485,36.355),(47.655,36.355),(47.655,36.185),(47.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.525),(47.145,36.695),(47.315,36.695),(47.315,36.525),(47.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.525),(47.485,36.695),(47.655,36.695),(47.655,36.525),(47.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.145),(37.545,34.315),(37.715,34.315),(37.715,34.145),(37.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.485),(37.545,34.655),(37.715,34.655),(37.715,34.485),(37.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.825),(37.545,34.995),(37.715,34.995),(37.715,34.825),(37.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,36.185),(23.145,36.355),(23.315,36.355),(23.315,36.185),(23.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,36.185),(23.485,36.355),(23.655,36.355),(23.655,36.185),(23.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,36.525),(23.145,36.695),(23.315,36.695),(23.315,36.525),(23.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,36.525),(23.485,36.695),(23.655,36.695),(23.655,36.525),(23.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.145),(81.085,17.315),(81.255,17.315),(81.255,17.145),(81.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.485),(81.085,17.655),(81.255,17.655),(81.255,17.485),(81.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,21.225),(8.745,21.395),(8.915,21.395),(8.915,21.225),(8.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,21.565),(8.745,21.735),(8.915,21.735),(8.915,21.565),(8.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.825),(81.085,17.995),(81.255,17.995),(81.255,17.825),(81.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.225),(47.145,21.395),(47.315,21.395),(47.315,21.225),(47.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.605),(37.885,6.775),(38.055,6.775),(38.055,6.605),(37.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,2.865),(13.885,3.035),(14.055,3.035),(14.055,2.865),(13.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.265),(37.885,6.435),(38.055,6.435),(38.055,6.265),(37.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.225),(47.485,21.395),(47.655,21.395),(47.655,21.225),(47.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.505),(51.945,18.675),(52.115,18.675),(52.115,18.505),(51.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.565),(47.145,21.735),(47.315,21.735),(47.315,21.565),(47.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.565),(47.485,21.735),(47.655,21.735),(47.655,21.565),(47.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.145),(23.145,17.315),(23.315,17.315),(23.315,17.145),(23.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.145),(23.485,17.315),(23.655,17.315),(23.655,17.145),(23.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.485),(23.145,17.655),(23.315,17.655),(23.315,17.485),(23.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,35.845),(28.285,36.015),(28.455,36.015),(28.455,35.845),(28.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.485),(23.485,17.655),(23.655,17.655),(23.655,17.485),(23.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.825),(23.145,17.995),(23.315,17.995),(23.315,17.825),(23.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.825),(23.485,17.995),(23.655,17.995),(23.655,17.825),(23.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.865),(80.745,20.035),(80.915,20.035),(80.915,19.865),(80.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.945),(51.945,24.115),(52.115,24.115),(52.115,23.945),(51.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.745),(52.285,13.915),(52.455,13.915),(52.455,13.745),(52.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.065),(52.285,13.235),(52.455,13.235),(52.455,13.065),(52.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.405),(52.285,13.575),(52.455,13.575),(52.455,13.405),(52.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.705),(76.285,11.875),(76.455,11.875),(76.455,11.705),(76.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.845),(42.345,36.015),(42.515,36.015),(42.515,35.845),(42.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.845),(42.685,36.015),(42.855,36.015),(42.855,35.845),(42.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,35.845),(80.745,36.015),(80.915,36.015),(80.915,35.845),(80.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,31.085),(76.285,31.255),(76.455,31.255),(76.455,31.085),(76.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,31.765),(76.285,31.935),(76.455,31.935),(76.455,31.765),(76.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,31.425),(76.285,31.595),(76.455,31.595),(76.455,31.425),(76.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.965),(9.085,8.135),(9.255,8.135),(9.255,7.965),(9.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,37.885),(75.945,38.055),(76.115,38.055),(76.115,37.885),(75.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.025),(61.885,11.195),(62.055,11.195),(62.055,11.025),(61.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.365),(61.885,11.535),(62.055,11.535),(62.055,11.365),(61.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.705),(61.885,11.875),(62.055,11.875),(62.055,11.705),(61.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.285),(13.545,7.455),(13.715,7.455),(13.715,7.285),(13.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.865),(37.545,20.035),(37.715,20.035),(37.715,19.865),(37.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,25.985),(80.745,26.155),(80.915,26.155),(80.915,25.985),(80.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,33.125),(28.285,33.295),(28.455,33.295),(28.455,33.125),(28.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,33.465),(28.285,33.635),(28.455,33.635),(28.455,33.465),(28.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,33.805),(28.285,33.975),(28.455,33.975),(28.455,33.805),(28.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,31.765),(9.085,31.935),(9.255,31.935),(9.255,31.765),(9.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,31.425),(9.085,31.595),(9.255,31.595),(9.255,31.425),(9.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,31.085),(9.085,31.255),(9.255,31.255),(9.255,31.085),(9.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.845),(18.345,19.015),(18.515,19.015),(18.515,18.845),(18.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.845),(18.685,19.015),(18.855,19.015),(18.855,18.845),(18.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,28.025),(75.945,28.195),(76.115,28.195),(76.115,28.025),(75.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.605),(32.745,23.775),(32.915,23.775),(32.915,23.605),(32.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.265),(32.745,23.435),(32.915,23.435),(32.915,23.265),(32.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.965),(80.745,8.135),(80.915,8.135),(80.915,7.965),(80.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.205),(56.745,3.375),(56.915,3.375),(56.915,3.205),(56.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.545),(56.745,3.715),(56.915,3.715),(56.915,3.545),(56.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.745),(13.885,13.915),(14.055,13.915),(14.055,13.745),(13.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.065),(13.885,13.235),(14.055,13.235),(14.055,13.065),(13.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.405),(13.885,13.575),(14.055,13.575),(14.055,13.405),(13.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.865),(42.345,37.035),(42.515,37.035),(42.515,36.865),(42.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.865),(42.685,37.035),(42.855,37.035),(42.855,36.865),(42.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.645),(61.885,8.815),(62.055,8.815),(62.055,8.645),(61.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.305),(61.885,8.475),(62.055,8.475),(62.055,8.305),(61.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.545),(32.745,3.715),(32.915,3.715),(32.915,3.545),(32.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.205),(32.745,3.375),(32.915,3.375),(32.915,3.205),(32.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.785),(8.745,15.955),(8.915,15.955),(8.915,15.785),(8.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.445),(8.745,15.615),(8.915,15.615),(8.915,15.445),(8.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.105),(8.745,15.275),(8.915,15.275),(8.915,15.105),(8.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,38.565),(27.945,38.735),(28.115,38.735),(28.115,38.565),(27.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,38.225),(27.945,38.395),(28.115,38.395),(28.115,38.225),(27.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,36.865),(61.885,37.035),(62.055,37.035),(62.055,36.865),(61.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.565),(47.145,4.735),(47.315,4.735),(47.315,4.565),(47.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.565),(47.485,4.735),(47.655,4.735),(47.655,4.565),(47.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.225),(47.145,4.395),(47.315,4.395),(47.315,4.225),(47.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.225),(47.485,4.395),(47.655,4.395),(47.655,4.225),(47.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.205),(42.345,20.375),(42.515,20.375),(42.515,20.205),(42.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.205),(42.685,20.375),(42.855,20.375),(42.855,20.205),(42.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.545),(42.345,20.715),(42.515,20.715),(42.515,20.545),(42.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.545),(42.685,20.715),(42.855,20.715),(42.855,20.545),(42.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,39.245),(66.345,39.415),(66.515,39.415),(66.515,39.245),(66.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,39.245),(66.685,39.415),(66.855,39.415),(66.855,39.245),(66.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,39.585),(66.345,39.755),(66.515,39.755),(66.515,39.585),(66.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,39.585),(66.685,39.755),(66.855,39.755),(66.855,39.585),(66.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.465),(13.885,16.635),(14.055,16.635),(14.055,16.465),(13.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.805),(13.885,16.975),(14.055,16.975),(14.055,16.805),(13.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.125),(13.885,16.295),(14.055,16.295),(14.055,16.125),(13.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.865),(13.545,20.035),(13.715,20.035),(13.715,19.865),(13.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.445),(23.485,15.615),(23.655,15.615),(23.655,15.445),(23.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.865),(51.945,20.035),(52.115,20.035),(52.115,19.865),(51.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.985),(56.745,26.155),(56.915,26.155),(56.915,25.985),(56.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.885),(33.085,38.055),(33.255,38.055),(33.255,37.885),(33.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.225),(61.545,4.395),(61.715,4.395),(61.715,4.225),(61.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,32.785),(23.145,32.955),(23.315,32.955),(23.315,32.785),(23.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.945),(37.545,24.115),(37.715,24.115),(37.715,23.945),(37.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.385),(61.885,12.555),(62.055,12.555),(62.055,12.385),(61.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.725),(61.885,12.895),(62.055,12.895),(62.055,12.725),(61.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,39.925),(28.285,40.095),(28.455,40.095),(28.455,39.925),(28.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.045),(61.885,12.215),(62.055,12.215),(62.055,12.045),(61.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.845),(80.745,19.015),(80.915,19.015),(80.915,18.845),(80.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.105),(42.345,15.275),(42.515,15.275),(42.515,15.105),(42.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.105),(42.685,15.275),(42.855,15.275),(42.855,15.105),(42.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.445),(42.345,15.615),(42.515,15.615),(42.515,15.445),(42.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.445),(42.685,15.615),(42.855,15.615),(42.855,15.445),(42.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.785),(42.345,15.955),(42.515,15.955),(42.515,15.785),(42.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.785),(42.685,15.955),(42.855,15.955),(42.855,15.785),(42.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.665),(33.085,9.835),(33.255,9.835),(33.255,9.665),(33.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.865),(37.885,3.035),(38.055,3.035),(38.055,2.865),(37.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,24.965),(71.145,25.135),(71.315,25.135),(71.315,24.965),(71.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,24.965),(71.485,25.135),(71.655,25.135),(71.655,24.965),(71.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,27.005),(23.145,27.175),(23.315,27.175),(23.315,27.005),(23.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,27.005),(23.485,27.175),(23.655,27.175),(23.655,27.005),(23.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,27.685),(23.145,27.855),(23.315,27.855),(23.315,27.685),(23.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,27.685),(23.485,27.855),(23.655,27.855),(23.655,27.685),(23.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,27.345),(23.145,27.515),(23.315,27.515),(23.315,27.345),(23.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,27.345),(23.485,27.515),(23.655,27.515),(23.655,27.345),(23.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.765),(13.545,14.935),(13.715,14.935),(13.715,14.765),(13.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.085),(13.545,14.255),(13.715,14.255),(13.715,14.085),(13.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.425),(13.545,14.595),(13.715,14.595),(13.715,14.425),(13.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.105),(28.285,15.275),(28.455,15.275),(28.455,15.105),(28.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.445),(28.285,15.615),(28.455,15.615),(28.455,15.445),(28.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.785),(28.285,15.955),(28.455,15.955),(28.455,15.785),(28.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,37.885),(76.285,38.055),(76.455,38.055),(76.455,37.885),(76.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,39.245),(71.485,39.415),(71.655,39.415),(71.655,39.245),(71.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,39.585),(71.145,39.755),(71.315,39.755),(71.315,39.585),(71.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,39.585),(71.485,39.755),(71.655,39.755),(71.655,39.585),(71.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,39.245),(71.145,39.415),(71.315,39.415),(71.315,39.245),(71.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.945),(47.145,24.115),(47.315,24.115),(47.315,23.945),(47.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.945),(47.485,24.115),(47.655,24.115),(47.655,23.945),(47.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.645),(32.745,25.815),(32.915,25.815),(32.915,25.645),(32.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.305),(32.745,25.475),(32.915,25.475),(32.915,25.305),(32.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,38.565),(13.545,38.735),(13.715,38.735),(13.715,38.565),(13.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,38.225),(13.545,38.395),(13.715,38.395),(13.715,38.225),(13.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,34.825),(8.745,34.995),(8.915,34.995),(8.915,34.825),(8.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,34.145),(8.745,34.315),(8.915,34.315),(8.915,34.145),(8.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.245),(33.085,39.415),(33.255,39.415),(33.255,39.245),(33.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.585),(33.085,39.755),(33.255,39.755),(33.255,39.585),(33.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,34.485),(8.745,34.655),(8.915,34.655),(8.915,34.485),(8.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,2.865),(13.545,3.035),(13.715,3.035),(13.715,2.865),(13.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,21.905),(27.945,22.075),(28.115,22.075),(28.115,21.905),(27.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.025),(57.085,11.195),(57.255,11.195),(57.255,11.025),(57.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.365),(57.085,11.535),(57.255,11.535),(57.255,11.365),(57.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.705),(57.085,11.875),(57.255,11.875),(57.255,11.705),(57.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,23.945),(13.545,24.115),(13.715,24.115),(13.715,23.945),(13.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.005),(32.745,10.175),(32.915,10.175),(32.915,10.005),(32.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.345),(32.745,10.515),(32.915,10.515),(32.915,10.345),(32.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.685),(32.745,10.855),(32.915,10.855),(32.915,10.685),(32.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.785),(47.145,15.955),(47.315,15.955),(47.315,15.785),(47.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.785),(47.485,15.955),(47.655,15.955),(47.655,15.785),(47.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.445),(47.145,15.615),(47.315,15.615),(47.315,15.445),(47.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.445),(47.485,15.615),(47.655,15.615),(47.655,15.445),(47.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.105),(47.145,15.275),(47.315,15.275),(47.315,15.105),(47.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.105),(47.485,15.275),(47.655,15.275),(47.655,15.105),(47.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.425),(56.745,14.595),(56.915,14.595),(56.915,14.425),(56.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.585),(61.545,5.755),(61.715,5.755),(61.715,5.585),(61.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.245),(61.545,5.415),(61.715,5.415),(61.715,5.245),(61.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.525),(71.145,19.695),(71.315,19.695),(71.315,19.525),(71.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,21.905),(28.285,22.075),(28.455,22.075),(28.455,21.905),(28.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,2.865),(18.345,3.035),(18.515,3.035),(18.515,2.865),(18.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,2.865),(18.685,3.035),(18.855,3.035),(18.855,2.865),(18.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.765),(57.085,14.935),(57.255,14.935),(57.255,14.765),(57.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,36.185),(71.145,36.355),(71.315,36.355),(71.315,36.185),(71.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,36.185),(71.485,36.355),(71.655,36.355),(71.655,36.185),(71.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,36.525),(71.145,36.695),(71.315,36.695),(71.315,36.525),(71.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,36.525),(71.485,36.695),(71.655,36.695),(71.655,36.525),(71.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.185),(37.885,19.355),(38.055,19.355),(38.055,19.185),(37.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.525),(37.885,19.695),(38.055,19.695),(38.055,19.525),(37.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.005),(28.285,10.175),(28.455,10.175),(28.455,10.005),(28.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.965),(28.285,8.135),(28.455,8.135),(28.455,7.965),(28.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,31.085),(71.145,31.255),(71.315,31.255),(71.315,31.085),(71.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,28.025),(9.085,28.195),(9.255,28.195),(9.255,28.025),(9.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,28.365),(9.085,28.535),(9.255,28.535),(9.255,28.365),(9.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,28.705),(9.085,28.875),(9.255,28.875),(9.255,28.705),(9.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.245),(66.345,5.415),(66.515,5.415),(66.515,5.245),(66.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.245),(66.685,5.415),(66.855,5.415),(66.855,5.245),(66.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.585),(66.345,5.755),(66.515,5.755),(66.515,5.585),(66.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.585),(66.685,5.755),(66.855,5.755),(66.855,5.585),(66.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,23.265),(61.885,23.435),(62.055,23.435),(62.055,23.265),(61.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,39.245),(18.345,39.415),(18.515,39.415),(18.515,39.245),(18.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,39.245),(18.685,39.415),(18.855,39.415),(18.855,39.245),(18.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,39.585),(18.345,39.755),(18.515,39.755),(18.515,39.585),(18.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,39.585),(18.685,39.755),(18.855,39.755),(18.855,39.585),(18.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.285),(66.345,7.455),(66.515,7.455),(66.515,7.285),(66.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.285),(66.685,7.455),(66.855,7.455),(66.855,7.285),(66.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.585),(42.345,5.755),(42.515,5.755),(42.515,5.585),(42.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.585),(42.685,5.755),(42.855,5.755),(42.855,5.585),(42.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.245),(42.345,5.415),(42.515,5.415),(42.515,5.245),(42.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.245),(42.685,5.415),(42.855,5.415),(42.855,5.245),(42.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.205),(37.885,37.375),(38.055,37.375),(38.055,37.205),(37.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.545),(37.885,37.715),(38.055,37.715),(38.055,37.545),(37.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.545),(71.145,3.715),(71.315,3.715),(71.315,3.545),(71.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.925),(47.485,6.095),(47.655,6.095),(47.655,5.925),(47.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.545),(71.485,3.715),(71.655,3.715),(71.655,3.545),(71.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.205),(71.145,3.375),(71.315,3.375),(71.315,3.205),(71.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.205),(71.485,3.375),(71.655,3.375),(71.655,3.205),(71.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,39.245),(61.885,39.415),(62.055,39.415),(62.055,39.245),(61.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,39.585),(61.885,39.755),(62.055,39.755),(62.055,39.585),(61.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.665),(61.545,9.835),(61.715,9.835),(61.715,9.665),(61.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.125),(37.885,16.295),(38.055,16.295),(38.055,16.125),(37.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.465),(37.885,16.635),(38.055,16.635),(38.055,16.465),(37.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.805),(37.885,16.975),(38.055,16.975),(38.055,16.805),(37.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.325),(61.545,9.495),(61.715,9.495),(61.715,9.325),(61.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.205),(47.145,3.375),(47.315,3.375),(47.315,3.205),(47.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.205),(47.485,3.375),(47.655,3.375),(47.655,3.205),(47.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.545),(47.145,3.715),(47.315,3.715),(47.315,3.545),(47.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.285),(33.085,7.455),(33.255,7.455),(33.255,7.285),(33.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.545),(47.485,3.715),(47.655,3.715),(47.655,3.545),(47.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.545),(23.145,3.715),(23.315,3.715),(23.315,3.545),(23.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.545),(23.485,3.715),(23.655,3.715),(23.655,3.545),(23.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.205),(23.145,3.375),(23.315,3.375),(23.315,3.205),(23.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.205),(23.485,3.375),(23.655,3.375),(23.655,3.205),(23.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.285),(9.085,7.455),(9.255,7.455),(9.255,7.285),(9.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,20.885),(23.145,21.055),(23.315,21.055),(23.315,20.885),(23.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,20.885),(23.485,21.055),(23.655,21.055),(23.655,20.885),(23.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.525),(13.885,19.695),(14.055,19.695),(14.055,19.525),(13.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.185),(13.885,19.355),(14.055,19.355),(14.055,19.185),(13.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.345),(80.745,10.515),(80.915,10.515),(80.915,10.345),(80.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.685),(80.745,10.855),(80.915,10.855),(80.915,10.685),(80.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.005),(80.745,10.175),(80.915,10.175),(80.915,10.005),(80.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,39.925),(76.285,40.095),(76.455,40.095),(76.455,39.925),(76.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,31.425),(80.745,31.595),(80.915,31.595),(80.915,31.425),(80.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,31.765),(80.745,31.935),(80.915,31.935),(80.915,31.765),(80.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,31.085),(80.745,31.255),(80.915,31.255),(80.915,31.085),(80.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.565),(52.285,21.735),(52.455,21.735),(52.455,21.565),(52.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.865),(57.085,20.035),(57.255,20.035),(57.255,19.865),(57.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.945),(32.745,24.115),(32.915,24.115),(32.915,23.945),(32.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.865),(42.345,3.035),(42.515,3.035),(42.515,2.865),(42.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.865),(42.685,3.035),(42.855,3.035),(42.855,2.865),(42.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,36.525),(81.085,36.695),(81.255,36.695),(81.255,36.525),(81.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,36.185),(81.085,36.355),(81.255,36.355),(81.255,36.185),(81.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.945),(76.285,7.115),(76.455,7.115),(76.455,6.945),(76.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,25.985),(28.285,26.155),(28.455,26.155),(28.455,25.985),(28.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,33.805),(75.945,33.975),(76.115,33.975),(76.115,33.805),(75.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,33.125),(75.945,33.295),(76.115,33.295),(76.115,33.125),(75.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,33.465),(75.945,33.635),(76.115,33.635),(76.115,33.465),(75.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.865),(37.545,3.035),(37.715,3.035),(37.715,2.865),(37.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.245),(42.345,39.415),(42.515,39.415),(42.515,39.245),(42.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.245),(42.685,39.415),(42.855,39.415),(42.855,39.245),(42.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.585),(42.345,39.755),(42.515,39.755),(42.515,39.585),(42.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.585),(42.685,39.755),(42.855,39.755),(42.855,39.585),(42.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.545),(76.285,3.715),(76.455,3.715),(76.455,3.545),(76.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.205),(76.285,3.375),(76.455,3.375),(76.455,3.205),(76.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.665),(76.285,9.835),(76.455,9.835),(76.455,9.665),(76.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.985),(57.085,9.155),(57.255,9.155),(57.255,8.985),(57.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.325),(76.285,9.495),(76.455,9.495),(76.455,9.325),(76.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,20.205),(9.085,20.375),(9.255,20.375),(9.255,20.205),(9.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,20.545),(9.085,20.715),(9.255,20.715),(9.255,20.545),(9.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.285),(81.085,7.455),(81.255,7.455),(81.255,7.285),(81.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.905),(57.085,22.075),(57.255,22.075),(57.255,21.905),(57.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,36.525),(18.685,36.695),(18.855,36.695),(18.855,36.525),(18.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,36.525),(18.345,36.695),(18.515,36.695),(18.515,36.525),(18.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,36.185),(18.345,36.355),(18.515,36.355),(18.515,36.185),(18.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,36.185),(18.685,36.355),(18.855,36.355),(18.855,36.185),(18.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.325),(28.285,9.495),(28.455,9.495),(28.455,9.325),(28.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.665),(28.285,9.835),(28.455,9.835),(28.455,9.665),(28.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,35.845),(75.945,36.015),(76.115,36.015),(76.115,35.845),(75.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,25.305),(71.145,25.475),(71.315,25.475),(71.315,25.305),(71.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,25.305),(71.485,25.475),(71.655,25.475),(71.655,25.305),(71.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,25.645),(71.145,25.815),(71.315,25.815),(71.315,25.645),(71.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,25.645),(71.485,25.815),(71.655,25.815),(71.655,25.645),(71.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.225),(57.085,38.395),(57.255,38.395),(57.255,38.225),(57.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.565),(57.085,38.735),(57.255,38.735),(57.255,38.565),(57.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.545),(80.745,3.715),(80.915,3.715),(80.915,3.545),(80.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.205),(80.745,3.375),(80.915,3.375),(80.915,3.205),(80.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.845),(71.145,19.015),(71.315,19.015),(71.315,18.845),(71.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.845),(71.485,19.015),(71.655,19.015),(71.655,18.845),(71.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,40.265),(51.945,40.435),(52.115,40.435),(52.115,40.265),(51.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,40.605),(51.945,40.775),(52.115,40.775),(52.115,40.605),(51.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.405),(76.285,13.575),(76.455,13.575),(76.455,13.405),(76.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,22.925),(9.085,23.095),(9.255,23.095),(9.255,22.925),(9.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.745),(76.285,13.915),(76.455,13.915),(76.455,13.745),(76.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.065),(76.285,13.235),(76.455,13.235),(76.455,13.065),(76.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.265),(57.085,23.435),(57.255,23.435),(57.255,23.265),(57.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.605),(57.085,23.775),(57.255,23.775),(57.255,23.605),(57.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,40.265),(18.685,40.435),(18.855,40.435),(18.855,40.265),(18.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.205),(61.545,3.375),(61.715,3.375),(61.715,3.205),(61.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.545),(61.545,3.715),(61.715,3.715),(61.715,3.545),(61.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.065),(28.285,13.235),(28.455,13.235),(28.455,13.065),(28.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,22.925),(71.145,23.095),(71.315,23.095),(71.315,22.925),(71.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,22.925),(71.485,23.095),(71.655,23.095),(71.655,22.925),(71.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.405),(28.285,13.575),(28.455,13.575),(28.455,13.405),(28.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.745),(28.285,13.915),(28.455,13.915),(28.455,13.745),(28.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,38.905),(71.145,39.075),(71.315,39.075),(71.315,38.905),(71.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,38.905),(71.485,39.075),(71.655,39.075),(71.655,38.905),(71.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,29.725),(71.485,29.895),(71.655,29.895),(71.655,29.725),(71.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.845),(81.085,19.015),(81.255,19.015),(81.255,18.845),(81.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.385),(80.745,12.555),(80.915,12.555),(80.915,12.385),(80.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.725),(80.745,12.895),(80.915,12.895),(80.915,12.725),(80.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.245),(9.085,5.415),(9.255,5.415),(9.255,5.245),(9.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.585),(9.085,5.755),(9.255,5.755),(9.255,5.585),(9.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.045),(80.745,12.215),(80.915,12.215),(80.915,12.045),(80.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.385),(42.345,29.555),(42.515,29.555),(42.515,29.385),(42.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.385),(42.685,29.555),(42.855,29.555),(42.855,29.385),(42.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.725),(42.345,29.895),(42.515,29.895),(42.515,29.725),(42.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.725),(42.685,29.895),(42.855,29.895),(42.855,29.725),(42.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.045),(42.345,29.215),(42.515,29.215),(42.515,29.045),(42.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.045),(42.685,29.215),(42.855,29.215),(42.855,29.045),(42.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.385),(42.345,12.555),(42.515,12.555),(42.515,12.385),(42.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.385),(42.685,12.555),(42.855,12.555),(42.855,12.385),(42.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.365),(32.745,28.535),(32.915,28.535),(32.915,28.365),(32.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.025),(32.745,28.195),(32.915,28.195),(32.915,28.025),(32.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.705),(32.745,28.875),(32.915,28.875),(32.915,28.705),(32.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.725),(42.345,12.895),(42.515,12.895),(42.515,12.725),(42.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.725),(42.685,12.895),(42.855,12.895),(42.855,12.725),(42.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.045),(42.345,12.215),(42.515,12.215),(42.515,12.045),(42.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.885),(33.085,21.055),(33.255,21.055),(33.255,20.885),(33.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.125),(75.945,16.295),(76.115,16.295),(76.115,16.125),(75.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.465),(75.945,16.635),(76.115,16.635),(76.115,16.465),(75.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.805),(75.945,16.975),(76.115,16.975),(76.115,16.805),(75.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.865),(8.745,20.035),(8.915,20.035),(8.915,19.865),(8.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,30.405),(9.085,30.575),(9.255,30.575),(9.255,30.405),(9.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,30.065),(9.085,30.235),(9.255,30.235),(9.255,30.065),(9.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,30.745),(9.085,30.915),(9.255,30.915),(9.255,30.745),(9.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,33.465),(61.545,33.635),(61.715,33.635),(61.715,33.465),(61.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,33.805),(61.545,33.975),(61.715,33.975),(61.715,33.805),(61.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,33.125),(61.545,33.295),(61.715,33.295),(61.715,33.125),(61.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,37.205),(61.545,37.375),(61.715,37.375),(61.715,37.205),(61.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,37.545),(61.545,37.715),(61.715,37.715),(61.715,37.545),(61.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.325),(23.145,9.495),(23.315,9.495),(23.315,9.325),(23.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.325),(23.485,9.495),(23.655,9.495),(23.655,9.325),(23.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.665),(23.145,9.835),(23.315,9.835),(23.315,9.665),(23.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.665),(23.485,9.835),(23.655,9.835),(23.655,9.665),(23.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.325),(37.885,9.495),(38.055,9.495),(38.055,9.325),(37.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.665),(37.885,9.835),(38.055,9.835),(38.055,9.665),(37.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.045),(76.285,12.215),(76.455,12.215),(76.455,12.045),(76.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,22.925),(8.745,23.095),(8.915,23.095),(8.915,22.925),(8.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,20.545),(23.485,20.715),(23.655,20.715),(23.655,20.545),(23.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.005),(56.745,27.175),(56.915,27.175),(56.915,27.005),(56.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.345),(56.745,27.515),(56.915,27.515),(56.915,27.345),(56.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.685),(56.745,27.855),(56.915,27.855),(56.915,27.685),(56.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.305),(37.545,8.475),(37.715,8.475),(37.715,8.305),(37.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.645),(37.545,8.815),(37.715,8.815),(37.715,8.645),(37.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,20.885),(76.285,21.055),(76.455,21.055),(76.455,20.885),(76.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.985),(61.885,9.155),(62.055,9.155),(62.055,8.985),(61.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,30.745),(18.685,30.915),(18.855,30.915),(18.855,30.745),(18.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.505),(47.145,35.675),(47.315,35.675),(47.315,35.505),(47.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.505),(47.485,35.675),(47.655,35.675),(47.655,35.505),(47.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.165),(47.145,35.335),(47.315,35.335),(47.315,35.165),(47.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,36.865),(61.545,37.035),(61.715,37.035),(61.715,36.865),(61.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.165),(47.485,35.335),(47.655,35.335),(47.655,35.165),(47.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,25.985),(9.085,26.155),(9.255,26.155),(9.255,25.985),(9.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.925),(37.885,6.095),(38.055,6.095),(38.055,5.925),(37.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.105),(76.285,15.275),(76.455,15.275),(76.455,15.105),(76.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.445),(76.285,15.615),(76.455,15.615),(76.455,15.445),(76.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.785),(76.285,15.955),(76.455,15.955),(76.455,15.785),(76.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.745),(23.145,13.915),(23.315,13.915),(23.315,13.745),(23.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.745),(23.485,13.915),(23.655,13.915),(23.655,13.745),(23.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.065),(23.145,13.235),(23.315,13.235),(23.315,13.065),(23.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.065),(23.485,13.235),(23.655,13.235),(23.655,13.065),(23.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.085),(23.485,14.255),(23.655,14.255),(23.655,14.085),(23.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.405),(23.145,13.575),(23.315,13.575),(23.315,13.405),(23.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.405),(23.485,13.575),(23.655,13.575),(23.655,13.405),(23.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.885),(61.885,4.055),(62.055,4.055),(62.055,3.885),(61.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.885),(37.545,4.055),(37.715,4.055),(37.715,3.885),(37.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,22.925),(18.345,23.095),(18.515,23.095),(18.515,22.925),(18.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,22.925),(18.685,23.095),(18.855,23.095),(18.855,22.925),(18.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.065),(51.945,30.235),(52.115,30.235),(52.115,30.065),(51.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.405),(51.945,30.575),(52.115,30.575),(52.115,30.405),(51.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.745),(51.945,30.915),(52.115,30.915),(52.115,30.745),(51.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,28.365),(75.945,28.535),(76.115,28.535),(76.115,28.365),(75.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.785),(9.085,15.955),(9.255,15.955),(9.255,15.785),(9.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.925),(47.145,6.095),(47.315,6.095),(47.315,5.925),(47.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.645),(52.285,25.815),(52.455,25.815),(52.455,25.645),(52.285,25.645)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.785),(17.975,40.855),(19.225,40.855),(19.225,2.785),(17.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.785),(65.975,40.855),(67.225,40.855),(67.225,2.785),(65.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.785),(22.775,40.855),(24.025,40.855),(24.025,2.785),(22.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.785),(46.775,40.855),(48.025,40.855),(48.025,2.785),(46.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.785),(56.375,40.855),(57.625,40.855),(57.625,2.785),(56.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.785),(70.775,40.855),(72.025,40.855),(72.025,2.785),(70.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.785),(32.375,40.855),(33.625,40.855),(33.625,2.785),(32.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.785),(80.375,40.855),(81.625,40.855),(81.625,2.785),(80.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.785),(27.575,40.855),(28.825,40.855),(28.825,2.785),(27.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.785),(41.975,40.855),(43.225,40.855),(43.225,2.785),(41.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.785),(51.575,40.855),(52.825,40.855),(52.825,2.785),(51.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.785),(75.575,40.855),(76.825,40.855),(76.825,2.785),(75.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.785),(13.175,40.855),(14.425,40.855),(14.425,2.785),(13.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.785),(37.175,40.855),(38.425,40.855),(38.425,2.785),(37.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.785),(61.175,40.855),(62.425,40.855),(62.425,2.785),(61.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.785),(8.375,40.855),(9.625,40.855),(9.625,2.785),(8.375,2.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,2.835),(61.175,3.005),(61.345,3.005),(61.345,2.835),(61.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,2.835),(61.535,3.005),(61.705,3.005),(61.705,2.835),(61.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,2.835),(61.895,3.005),(62.065,3.005),(62.065,2.835),(61.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,2.835),(62.255,3.005),(62.425,3.005),(62.425,2.835),(62.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.195),(61.175,3.365),(61.345,3.365),(61.345,3.195),(61.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.195),(61.535,3.365),(61.705,3.365),(61.705,3.195),(61.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.195),(61.895,3.365),(62.065,3.365),(62.065,3.195),(61.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.195),(62.255,3.365),(62.425,3.365),(62.425,3.195),(62.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.555),(61.175,3.725),(61.345,3.725),(61.345,3.555),(61.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.555),(61.535,3.725),(61.705,3.725),(61.705,3.555),(61.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.555),(61.895,3.725),(62.065,3.725),(62.065,3.555),(61.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.555),(62.255,3.725),(62.425,3.725),(62.425,3.555),(62.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.915),(61.175,4.085),(61.345,4.085),(61.345,3.915),(61.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.915),(61.535,4.085),(61.705,4.085),(61.705,3.915),(61.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.915),(61.895,4.085),(62.065,4.085),(62.065,3.915),(61.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.915),(62.255,4.085),(62.425,4.085),(62.425,3.915),(62.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.275),(61.175,4.445),(61.345,4.445),(61.345,4.275),(61.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.275),(61.535,4.445),(61.705,4.445),(61.705,4.275),(61.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.275),(61.895,4.445),(62.065,4.445),(62.065,4.275),(61.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.275),(62.255,4.445),(62.425,4.445),(62.425,4.275),(62.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.635),(61.175,4.805),(61.345,4.805),(61.345,4.635),(61.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.635),(61.535,4.805),(61.705,4.805),(61.705,4.635),(61.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.635),(61.895,4.805),(62.065,4.805),(62.065,4.635),(61.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.635),(62.255,4.805),(62.425,4.805),(62.425,4.635),(62.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.995),(61.175,5.165),(61.345,5.165),(61.345,4.995),(61.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.995),(61.535,5.165),(61.705,5.165),(61.705,4.995),(61.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.995),(61.895,5.165),(62.065,5.165),(62.065,4.995),(61.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.995),(62.255,5.165),(62.425,5.165),(62.425,4.995),(62.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.355),(61.175,5.525),(61.345,5.525),(61.345,5.355),(61.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.355),(61.535,5.525),(61.705,5.525),(61.705,5.355),(61.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.355),(61.895,5.525),(62.065,5.525),(62.065,5.355),(61.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.355),(62.255,5.525),(62.425,5.525),(62.425,5.355),(62.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.715),(61.175,5.885),(61.345,5.885),(61.345,5.715),(61.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.715),(61.535,5.885),(61.705,5.885),(61.705,5.715),(61.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.715),(61.895,5.885),(62.065,5.885),(62.065,5.715),(61.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.715),(62.255,5.885),(62.425,5.885),(62.425,5.715),(62.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.075),(61.175,6.245),(61.345,6.245),(61.345,6.075),(61.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.075),(61.535,6.245),(61.705,6.245),(61.705,6.075),(61.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.075),(61.895,6.245),(62.065,6.245),(62.065,6.075),(61.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.075),(62.255,6.245),(62.425,6.245),(62.425,6.075),(62.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.435),(61.175,6.605),(61.345,6.605),(61.345,6.435),(61.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.435),(61.535,6.605),(61.705,6.605),(61.705,6.435),(61.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.435),(61.895,6.605),(62.065,6.605),(62.065,6.435),(61.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.435),(62.255,6.605),(62.425,6.605),(62.425,6.435),(62.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.795),(61.175,6.965),(61.345,6.965),(61.345,6.795),(61.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.795),(61.535,6.965),(61.705,6.965),(61.705,6.795),(61.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.795),(61.895,6.965),(62.065,6.965),(62.065,6.795),(61.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.795),(62.255,6.965),(62.425,6.965),(62.425,6.795),(62.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.155),(61.175,7.325),(61.345,7.325),(61.345,7.155),(61.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.155),(61.535,7.325),(61.705,7.325),(61.705,7.155),(61.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.155),(61.895,7.325),(62.065,7.325),(62.065,7.155),(61.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.155),(62.255,7.325),(62.425,7.325),(62.425,7.155),(62.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.515),(61.175,7.685),(61.345,7.685),(61.345,7.515),(61.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.515),(61.535,7.685),(61.705,7.685),(61.705,7.515),(61.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.515),(61.895,7.685),(62.065,7.685),(62.065,7.515),(61.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.515),(62.255,7.685),(62.425,7.685),(62.425,7.515),(62.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.875),(61.175,8.045),(61.345,8.045),(61.345,7.875),(61.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.875),(61.535,8.045),(61.705,8.045),(61.705,7.875),(61.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.875),(61.895,8.045),(62.065,8.045),(62.065,7.875),(61.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.875),(62.255,8.045),(62.425,8.045),(62.425,7.875),(62.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.235),(61.175,8.405),(61.345,8.405),(61.345,8.235),(61.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.235),(61.535,8.405),(61.705,8.405),(61.705,8.235),(61.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.235),(61.895,8.405),(62.065,8.405),(62.065,8.235),(61.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.235),(62.255,8.405),(62.425,8.405),(62.425,8.235),(62.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.595),(61.175,8.765),(61.345,8.765),(61.345,8.595),(61.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.595),(61.535,8.765),(61.705,8.765),(61.705,8.595),(61.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.595),(61.895,8.765),(62.065,8.765),(62.065,8.595),(61.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.595),(62.255,8.765),(62.425,8.765),(62.425,8.595),(62.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.955),(61.175,9.125),(61.345,9.125),(61.345,8.955),(61.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.955),(61.535,9.125),(61.705,9.125),(61.705,8.955),(61.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.955),(61.895,9.125),(62.065,9.125),(62.065,8.955),(61.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.955),(62.255,9.125),(62.425,9.125),(62.425,8.955),(62.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.315),(61.175,9.485),(61.345,9.485),(61.345,9.315),(61.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.315),(61.535,9.485),(61.705,9.485),(61.705,9.315),(61.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.315),(61.895,9.485),(62.065,9.485),(62.065,9.315),(61.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.315),(62.255,9.485),(62.425,9.485),(62.425,9.315),(62.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.675),(61.175,9.845),(61.345,9.845),(61.345,9.675),(61.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.675),(61.535,9.845),(61.705,9.845),(61.705,9.675),(61.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.675),(61.895,9.845),(62.065,9.845),(62.065,9.675),(61.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.675),(62.255,9.845),(62.425,9.845),(62.425,9.675),(62.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.035),(61.175,10.205),(61.345,10.205),(61.345,10.035),(61.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.035),(61.535,10.205),(61.705,10.205),(61.705,10.035),(61.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.035),(61.895,10.205),(62.065,10.205),(62.065,10.035),(61.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.035),(62.255,10.205),(62.425,10.205),(62.425,10.035),(62.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.395),(61.175,10.565),(61.345,10.565),(61.345,10.395),(61.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.395),(61.535,10.565),(61.705,10.565),(61.705,10.395),(61.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.395),(61.895,10.565),(62.065,10.565),(62.065,10.395),(61.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.395),(62.255,10.565),(62.425,10.565),(62.425,10.395),(62.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.755),(61.175,10.925),(61.345,10.925),(61.345,10.755),(61.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.755),(61.535,10.925),(61.705,10.925),(61.705,10.755),(61.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.755),(61.895,10.925),(62.065,10.925),(62.065,10.755),(61.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.755),(62.255,10.925),(62.425,10.925),(62.425,10.755),(62.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.115),(61.175,11.285),(61.345,11.285),(61.345,11.115),(61.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.115),(61.535,11.285),(61.705,11.285),(61.705,11.115),(61.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.115),(61.895,11.285),(62.065,11.285),(62.065,11.115),(61.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.115),(62.255,11.285),(62.425,11.285),(62.425,11.115),(62.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.475),(61.175,11.645),(61.345,11.645),(61.345,11.475),(61.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.475),(61.535,11.645),(61.705,11.645),(61.705,11.475),(61.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.475),(61.895,11.645),(62.065,11.645),(62.065,11.475),(61.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.475),(62.255,11.645),(62.425,11.645),(62.425,11.475),(62.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.835),(61.175,12.005),(61.345,12.005),(61.345,11.835),(61.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.835),(61.535,12.005),(61.705,12.005),(61.705,11.835),(61.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.835),(61.895,12.005),(62.065,12.005),(62.065,11.835),(61.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.835),(62.255,12.005),(62.425,12.005),(62.425,11.835),(62.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.195),(61.175,12.365),(61.345,12.365),(61.345,12.195),(61.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.195),(61.535,12.365),(61.705,12.365),(61.705,12.195),(61.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.195),(61.895,12.365),(62.065,12.365),(62.065,12.195),(61.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.195),(62.255,12.365),(62.425,12.365),(62.425,12.195),(62.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.555),(61.175,12.725),(61.345,12.725),(61.345,12.555),(61.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.555),(61.535,12.725),(61.705,12.725),(61.705,12.555),(61.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.555),(61.895,12.725),(62.065,12.725),(62.065,12.555),(61.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.555),(62.255,12.725),(62.425,12.725),(62.425,12.555),(62.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.915),(61.175,13.085),(61.345,13.085),(61.345,12.915),(61.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.915),(61.535,13.085),(61.705,13.085),(61.705,12.915),(61.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.915),(61.895,13.085),(62.065,13.085),(62.065,12.915),(61.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.915),(62.255,13.085),(62.425,13.085),(62.425,12.915),(62.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.275),(61.175,13.445),(61.345,13.445),(61.345,13.275),(61.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.275),(61.535,13.445),(61.705,13.445),(61.705,13.275),(61.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.275),(61.895,13.445),(62.065,13.445),(62.065,13.275),(61.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.275),(62.255,13.445),(62.425,13.445),(62.425,13.275),(62.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.635),(61.175,13.805),(61.345,13.805),(61.345,13.635),(61.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.635),(61.535,13.805),(61.705,13.805),(61.705,13.635),(61.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.635),(61.895,13.805),(62.065,13.805),(62.065,13.635),(61.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.635),(62.255,13.805),(62.425,13.805),(62.425,13.635),(62.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.995),(61.175,14.165),(61.345,14.165),(61.345,13.995),(61.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.995),(61.535,14.165),(61.705,14.165),(61.705,13.995),(61.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.995),(61.895,14.165),(62.065,14.165),(62.065,13.995),(61.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.995),(62.255,14.165),(62.425,14.165),(62.425,13.995),(62.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.355),(61.175,14.525),(61.345,14.525),(61.345,14.355),(61.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.355),(61.535,14.525),(61.705,14.525),(61.705,14.355),(61.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.355),(61.895,14.525),(62.065,14.525),(62.065,14.355),(61.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.355),(62.255,14.525),(62.425,14.525),(62.425,14.355),(62.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.715),(61.175,14.885),(61.345,14.885),(61.345,14.715),(61.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.715),(61.535,14.885),(61.705,14.885),(61.705,14.715),(61.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.715),(61.895,14.885),(62.065,14.885),(62.065,14.715),(61.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.715),(62.255,14.885),(62.425,14.885),(62.425,14.715),(62.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.075),(61.175,15.245),(61.345,15.245),(61.345,15.075),(61.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.075),(61.535,15.245),(61.705,15.245),(61.705,15.075),(61.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.075),(61.895,15.245),(62.065,15.245),(62.065,15.075),(61.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.075),(62.255,15.245),(62.425,15.245),(62.425,15.075),(62.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.435),(61.175,15.605),(61.345,15.605),(61.345,15.435),(61.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.435),(61.535,15.605),(61.705,15.605),(61.705,15.435),(61.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.435),(61.895,15.605),(62.065,15.605),(62.065,15.435),(61.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.435),(62.255,15.605),(62.425,15.605),(62.425,15.435),(62.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.795),(61.175,15.965),(61.345,15.965),(61.345,15.795),(61.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.795),(61.535,15.965),(61.705,15.965),(61.705,15.795),(61.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.795),(61.895,15.965),(62.065,15.965),(62.065,15.795),(61.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.795),(62.255,15.965),(62.425,15.965),(62.425,15.795),(62.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.155),(61.175,16.325),(61.345,16.325),(61.345,16.155),(61.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.155),(61.535,16.325),(61.705,16.325),(61.705,16.155),(61.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.155),(61.895,16.325),(62.065,16.325),(62.065,16.155),(61.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.155),(62.255,16.325),(62.425,16.325),(62.425,16.155),(62.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.515),(61.175,16.685),(61.345,16.685),(61.345,16.515),(61.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.515),(61.535,16.685),(61.705,16.685),(61.705,16.515),(61.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.515),(61.895,16.685),(62.065,16.685),(62.065,16.515),(61.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.515),(62.255,16.685),(62.425,16.685),(62.425,16.515),(62.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.875),(61.175,17.045),(61.345,17.045),(61.345,16.875),(61.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.875),(61.535,17.045),(61.705,17.045),(61.705,16.875),(61.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.875),(61.895,17.045),(62.065,17.045),(62.065,16.875),(61.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.875),(62.255,17.045),(62.425,17.045),(62.425,16.875),(62.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.235),(61.175,17.405),(61.345,17.405),(61.345,17.235),(61.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.235),(61.535,17.405),(61.705,17.405),(61.705,17.235),(61.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.235),(61.895,17.405),(62.065,17.405),(62.065,17.235),(61.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.235),(62.255,17.405),(62.425,17.405),(62.425,17.235),(62.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.595),(61.175,17.765),(61.345,17.765),(61.345,17.595),(61.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.595),(61.535,17.765),(61.705,17.765),(61.705,17.595),(61.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.595),(61.895,17.765),(62.065,17.765),(62.065,17.595),(61.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.595),(62.255,17.765),(62.425,17.765),(62.425,17.595),(62.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.955),(61.175,18.125),(61.345,18.125),(61.345,17.955),(61.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.955),(61.535,18.125),(61.705,18.125),(61.705,17.955),(61.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.955),(61.895,18.125),(62.065,18.125),(62.065,17.955),(61.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.955),(62.255,18.125),(62.425,18.125),(62.425,17.955),(62.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.315),(61.175,18.485),(61.345,18.485),(61.345,18.315),(61.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.315),(61.535,18.485),(61.705,18.485),(61.705,18.315),(61.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.315),(61.895,18.485),(62.065,18.485),(62.065,18.315),(61.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.315),(62.255,18.485),(62.425,18.485),(62.425,18.315),(62.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.675),(61.175,18.845),(61.345,18.845),(61.345,18.675),(61.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.675),(61.535,18.845),(61.705,18.845),(61.705,18.675),(61.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.675),(61.895,18.845),(62.065,18.845),(62.065,18.675),(61.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.675),(62.255,18.845),(62.425,18.845),(62.425,18.675),(62.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.035),(61.175,19.205),(61.345,19.205),(61.345,19.035),(61.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.035),(61.535,19.205),(61.705,19.205),(61.705,19.035),(61.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.035),(61.895,19.205),(62.065,19.205),(62.065,19.035),(61.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.035),(62.255,19.205),(62.425,19.205),(62.425,19.035),(62.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.395),(61.175,19.565),(61.345,19.565),(61.345,19.395),(61.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.395),(61.535,19.565),(61.705,19.565),(61.705,19.395),(61.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.395),(61.895,19.565),(62.065,19.565),(62.065,19.395),(61.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.395),(62.255,19.565),(62.425,19.565),(62.425,19.395),(62.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.755),(61.175,19.925),(61.345,19.925),(61.345,19.755),(61.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.755),(61.535,19.925),(61.705,19.925),(61.705,19.755),(61.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.755),(61.895,19.925),(62.065,19.925),(62.065,19.755),(61.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.755),(62.255,19.925),(62.425,19.925),(62.425,19.755),(62.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,20.115),(61.175,20.285),(61.345,20.285),(61.345,20.115),(61.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,20.115),(61.535,20.285),(61.705,20.285),(61.705,20.115),(61.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,20.115),(61.895,20.285),(62.065,20.285),(62.065,20.115),(61.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,20.115),(62.255,20.285),(62.425,20.285),(62.425,20.115),(62.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,20.475),(61.175,20.645),(61.345,20.645),(61.345,20.475),(61.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,20.475),(61.535,20.645),(61.705,20.645),(61.705,20.475),(61.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,20.475),(61.895,20.645),(62.065,20.645),(62.065,20.475),(61.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,20.475),(62.255,20.645),(62.425,20.645),(62.425,20.475),(62.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,20.835),(61.175,21.005),(61.345,21.005),(61.345,20.835),(61.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,20.835),(61.535,21.005),(61.705,21.005),(61.705,20.835),(61.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,20.835),(61.895,21.005),(62.065,21.005),(62.065,20.835),(61.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,20.835),(62.255,21.005),(62.425,21.005),(62.425,20.835),(62.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,21.195),(61.175,21.365),(61.345,21.365),(61.345,21.195),(61.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,21.195),(61.535,21.365),(61.705,21.365),(61.705,21.195),(61.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,21.195),(61.895,21.365),(62.065,21.365),(62.065,21.195),(61.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,21.195),(62.255,21.365),(62.425,21.365),(62.425,21.195),(62.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,21.555),(61.175,21.725),(61.345,21.725),(61.345,21.555),(61.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,21.555),(61.535,21.725),(61.705,21.725),(61.705,21.555),(61.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,21.555),(61.895,21.725),(62.065,21.725),(62.065,21.555),(61.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,21.555),(62.255,21.725),(62.425,21.725),(62.425,21.555),(62.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,21.915),(61.175,22.085),(61.345,22.085),(61.345,21.915),(61.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,21.915),(61.535,22.085),(61.705,22.085),(61.705,21.915),(61.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,21.915),(61.895,22.085),(62.065,22.085),(62.065,21.915),(61.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,21.915),(62.255,22.085),(62.425,22.085),(62.425,21.915),(62.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.275),(61.175,22.445),(61.345,22.445),(61.345,22.275),(61.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.275),(61.535,22.445),(61.705,22.445),(61.705,22.275),(61.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.275),(61.895,22.445),(62.065,22.445),(62.065,22.275),(61.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.275),(62.255,22.445),(62.425,22.445),(62.425,22.275),(62.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.635),(61.175,22.805),(61.345,22.805),(61.345,22.635),(61.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.635),(61.535,22.805),(61.705,22.805),(61.705,22.635),(61.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.635),(61.895,22.805),(62.065,22.805),(62.065,22.635),(61.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.635),(62.255,22.805),(62.425,22.805),(62.425,22.635),(62.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.995),(61.175,23.165),(61.345,23.165),(61.345,22.995),(61.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.995),(61.535,23.165),(61.705,23.165),(61.705,22.995),(61.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.995),(61.895,23.165),(62.065,23.165),(62.065,22.995),(61.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.995),(62.255,23.165),(62.425,23.165),(62.425,22.995),(62.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,23.355),(61.175,23.525),(61.345,23.525),(61.345,23.355),(61.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,23.355),(61.535,23.525),(61.705,23.525),(61.705,23.355),(61.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,23.355),(61.895,23.525),(62.065,23.525),(62.065,23.355),(61.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,23.355),(62.255,23.525),(62.425,23.525),(62.425,23.355),(62.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,23.715),(61.175,23.885),(61.345,23.885),(61.345,23.715),(61.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,23.715),(61.535,23.885),(61.705,23.885),(61.705,23.715),(61.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,23.715),(61.895,23.885),(62.065,23.885),(62.065,23.715),(61.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,23.715),(62.255,23.885),(62.425,23.885),(62.425,23.715),(62.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,24.075),(61.175,24.245),(61.345,24.245),(61.345,24.075),(61.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,24.075),(61.535,24.245),(61.705,24.245),(61.705,24.075),(61.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,24.075),(61.895,24.245),(62.065,24.245),(62.065,24.075),(61.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,24.075),(62.255,24.245),(62.425,24.245),(62.425,24.075),(62.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,24.435),(61.175,24.605),(61.345,24.605),(61.345,24.435),(61.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,24.435),(61.535,24.605),(61.705,24.605),(61.705,24.435),(61.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,24.435),(61.895,24.605),(62.065,24.605),(62.065,24.435),(61.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,24.435),(62.255,24.605),(62.425,24.605),(62.425,24.435),(62.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,24.795),(61.175,24.965),(61.345,24.965),(61.345,24.795),(61.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,24.795),(61.535,24.965),(61.705,24.965),(61.705,24.795),(61.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,24.795),(61.895,24.965),(62.065,24.965),(62.065,24.795),(61.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,24.795),(62.255,24.965),(62.425,24.965),(62.425,24.795),(62.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,25.155),(61.175,25.325),(61.345,25.325),(61.345,25.155),(61.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,25.155),(61.535,25.325),(61.705,25.325),(61.705,25.155),(61.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,25.155),(61.895,25.325),(62.065,25.325),(62.065,25.155),(61.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,25.155),(62.255,25.325),(62.425,25.325),(62.425,25.155),(62.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,25.515),(61.175,25.685),(61.345,25.685),(61.345,25.515),(61.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,25.515),(61.535,25.685),(61.705,25.685),(61.705,25.515),(61.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,25.515),(61.895,25.685),(62.065,25.685),(62.065,25.515),(61.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,25.515),(62.255,25.685),(62.425,25.685),(62.425,25.515),(62.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,25.875),(61.175,26.045),(61.345,26.045),(61.345,25.875),(61.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,25.875),(61.535,26.045),(61.705,26.045),(61.705,25.875),(61.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,25.875),(61.895,26.045),(62.065,26.045),(62.065,25.875),(61.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,25.875),(62.255,26.045),(62.425,26.045),(62.425,25.875),(62.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,26.235),(61.175,26.405),(61.345,26.405),(61.345,26.235),(61.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,26.235),(61.535,26.405),(61.705,26.405),(61.705,26.235),(61.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,26.235),(61.895,26.405),(62.065,26.405),(62.065,26.235),(61.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,26.235),(62.255,26.405),(62.425,26.405),(62.425,26.235),(62.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,26.595),(61.175,26.765),(61.345,26.765),(61.345,26.595),(61.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,26.595),(61.535,26.765),(61.705,26.765),(61.705,26.595),(61.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,26.595),(61.895,26.765),(62.065,26.765),(62.065,26.595),(61.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,26.595),(62.255,26.765),(62.425,26.765),(62.425,26.595),(62.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,26.955),(61.175,27.125),(61.345,27.125),(61.345,26.955),(61.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,26.955),(61.535,27.125),(61.705,27.125),(61.705,26.955),(61.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,26.955),(61.895,27.125),(62.065,27.125),(62.065,26.955),(61.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,26.955),(62.255,27.125),(62.425,27.125),(62.425,26.955),(62.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,27.315),(61.175,27.485),(61.345,27.485),(61.345,27.315),(61.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,27.315),(61.535,27.485),(61.705,27.485),(61.705,27.315),(61.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,27.315),(61.895,27.485),(62.065,27.485),(62.065,27.315),(61.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,27.315),(62.255,27.485),(62.425,27.485),(62.425,27.315),(62.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,27.675),(61.175,27.845),(61.345,27.845),(61.345,27.675),(61.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,27.675),(61.535,27.845),(61.705,27.845),(61.705,27.675),(61.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,27.675),(61.895,27.845),(62.065,27.845),(62.065,27.675),(61.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,27.675),(62.255,27.845),(62.425,27.845),(62.425,27.675),(62.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,28.035),(61.175,28.205),(61.345,28.205),(61.345,28.035),(61.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,28.035),(61.535,28.205),(61.705,28.205),(61.705,28.035),(61.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,28.035),(61.895,28.205),(62.065,28.205),(62.065,28.035),(61.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,28.035),(62.255,28.205),(62.425,28.205),(62.425,28.035),(62.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,28.395),(61.175,28.565),(61.345,28.565),(61.345,28.395),(61.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,28.395),(61.535,28.565),(61.705,28.565),(61.705,28.395),(61.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,28.395),(61.895,28.565),(62.065,28.565),(62.065,28.395),(61.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,28.395),(62.255,28.565),(62.425,28.565),(62.425,28.395),(62.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,28.755),(61.175,28.925),(61.345,28.925),(61.345,28.755),(61.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,28.755),(61.535,28.925),(61.705,28.925),(61.705,28.755),(61.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,28.755),(61.895,28.925),(62.065,28.925),(62.065,28.755),(61.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,28.755),(62.255,28.925),(62.425,28.925),(62.425,28.755),(62.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,29.115),(61.175,29.285),(61.345,29.285),(61.345,29.115),(61.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,29.115),(61.535,29.285),(61.705,29.285),(61.705,29.115),(61.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,29.115),(61.895,29.285),(62.065,29.285),(62.065,29.115),(61.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,29.115),(62.255,29.285),(62.425,29.285),(62.425,29.115),(62.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,29.475),(61.175,29.645),(61.345,29.645),(61.345,29.475),(61.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,29.475),(61.535,29.645),(61.705,29.645),(61.705,29.475),(61.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,29.475),(61.895,29.645),(62.065,29.645),(62.065,29.475),(61.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,29.475),(62.255,29.645),(62.425,29.645),(62.425,29.475),(62.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,29.835),(61.175,30.005),(61.345,30.005),(61.345,29.835),(61.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,29.835),(61.535,30.005),(61.705,30.005),(61.705,29.835),(61.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,29.835),(61.895,30.005),(62.065,30.005),(62.065,29.835),(61.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,29.835),(62.255,30.005),(62.425,30.005),(62.425,29.835),(62.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,30.195),(61.175,30.365),(61.345,30.365),(61.345,30.195),(61.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,30.195),(61.535,30.365),(61.705,30.365),(61.705,30.195),(61.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,30.195),(61.895,30.365),(62.065,30.365),(62.065,30.195),(61.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,30.195),(62.255,30.365),(62.425,30.365),(62.425,30.195),(62.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,30.555),(61.175,30.725),(61.345,30.725),(61.345,30.555),(61.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,30.555),(61.535,30.725),(61.705,30.725),(61.705,30.555),(61.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,30.555),(61.895,30.725),(62.065,30.725),(62.065,30.555),(61.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,30.555),(62.255,30.725),(62.425,30.725),(62.425,30.555),(62.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,30.915),(61.175,31.085),(61.345,31.085),(61.345,30.915),(61.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,30.915),(61.535,31.085),(61.705,31.085),(61.705,30.915),(61.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,30.915),(61.895,31.085),(62.065,31.085),(62.065,30.915),(61.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,30.915),(62.255,31.085),(62.425,31.085),(62.425,30.915),(62.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,31.275),(61.175,31.445),(61.345,31.445),(61.345,31.275),(61.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,31.275),(61.535,31.445),(61.705,31.445),(61.705,31.275),(61.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,31.275),(61.895,31.445),(62.065,31.445),(62.065,31.275),(61.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,31.275),(62.255,31.445),(62.425,31.445),(62.425,31.275),(62.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,31.635),(61.175,31.805),(61.345,31.805),(61.345,31.635),(61.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,31.635),(61.535,31.805),(61.705,31.805),(61.705,31.635),(61.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,31.635),(61.895,31.805),(62.065,31.805),(62.065,31.635),(61.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,31.635),(62.255,31.805),(62.425,31.805),(62.425,31.635),(62.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,31.995),(61.175,32.165),(61.345,32.165),(61.345,31.995),(61.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,31.995),(61.535,32.165),(61.705,32.165),(61.705,31.995),(61.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,31.995),(61.895,32.165),(62.065,32.165),(62.065,31.995),(61.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,31.995),(62.255,32.165),(62.425,32.165),(62.425,31.995),(62.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,32.355),(61.175,32.525),(61.345,32.525),(61.345,32.355),(61.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,32.355),(61.535,32.525),(61.705,32.525),(61.705,32.355),(61.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,32.355),(61.895,32.525),(62.065,32.525),(62.065,32.355),(61.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,32.355),(62.255,32.525),(62.425,32.525),(62.425,32.355),(62.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,32.715),(61.175,32.885),(61.345,32.885),(61.345,32.715),(61.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,32.715),(61.535,32.885),(61.705,32.885),(61.705,32.715),(61.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,32.715),(61.895,32.885),(62.065,32.885),(62.065,32.715),(61.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,32.715),(62.255,32.885),(62.425,32.885),(62.425,32.715),(62.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,33.075),(61.175,33.245),(61.345,33.245),(61.345,33.075),(61.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,33.075),(61.535,33.245),(61.705,33.245),(61.705,33.075),(61.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,33.075),(61.895,33.245),(62.065,33.245),(62.065,33.075),(61.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,33.075),(62.255,33.245),(62.425,33.245),(62.425,33.075),(62.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,33.435),(61.175,33.605),(61.345,33.605),(61.345,33.435),(61.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,33.435),(61.535,33.605),(61.705,33.605),(61.705,33.435),(61.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,33.435),(61.895,33.605),(62.065,33.605),(62.065,33.435),(61.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,33.435),(62.255,33.605),(62.425,33.605),(62.425,33.435),(62.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,33.795),(61.175,33.965),(61.345,33.965),(61.345,33.795),(61.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,33.795),(61.535,33.965),(61.705,33.965),(61.705,33.795),(61.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,33.795),(61.895,33.965),(62.065,33.965),(62.065,33.795),(61.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,33.795),(62.255,33.965),(62.425,33.965),(62.425,33.795),(62.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,34.155),(61.175,34.325),(61.345,34.325),(61.345,34.155),(61.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,34.155),(61.535,34.325),(61.705,34.325),(61.705,34.155),(61.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,34.155),(61.895,34.325),(62.065,34.325),(62.065,34.155),(61.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,34.155),(62.255,34.325),(62.425,34.325),(62.425,34.155),(62.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,34.515),(61.175,34.685),(61.345,34.685),(61.345,34.515),(61.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,34.515),(61.535,34.685),(61.705,34.685),(61.705,34.515),(61.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,34.515),(61.895,34.685),(62.065,34.685),(62.065,34.515),(61.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,34.515),(62.255,34.685),(62.425,34.685),(62.425,34.515),(62.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,34.875),(61.175,35.045),(61.345,35.045),(61.345,34.875),(61.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,34.875),(61.535,35.045),(61.705,35.045),(61.705,34.875),(61.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,34.875),(61.895,35.045),(62.065,35.045),(62.065,34.875),(61.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,34.875),(62.255,35.045),(62.425,35.045),(62.425,34.875),(62.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,35.235),(61.175,35.405),(61.345,35.405),(61.345,35.235),(61.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,35.235),(61.535,35.405),(61.705,35.405),(61.705,35.235),(61.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,35.235),(61.895,35.405),(62.065,35.405),(62.065,35.235),(61.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,35.235),(62.255,35.405),(62.425,35.405),(62.425,35.235),(62.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,35.595),(61.175,35.765),(61.345,35.765),(61.345,35.595),(61.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,35.595),(61.535,35.765),(61.705,35.765),(61.705,35.595),(61.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,35.595),(61.895,35.765),(62.065,35.765),(62.065,35.595),(61.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,35.595),(62.255,35.765),(62.425,35.765),(62.425,35.595),(62.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,35.955),(61.175,36.125),(61.345,36.125),(61.345,35.955),(61.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,35.955),(61.535,36.125),(61.705,36.125),(61.705,35.955),(61.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,35.955),(61.895,36.125),(62.065,36.125),(62.065,35.955),(61.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,35.955),(62.255,36.125),(62.425,36.125),(62.425,35.955),(62.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,36.315),(61.175,36.485),(61.345,36.485),(61.345,36.315),(61.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,36.315),(61.535,36.485),(61.705,36.485),(61.705,36.315),(61.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,36.315),(61.895,36.485),(62.065,36.485),(62.065,36.315),(61.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,36.315),(62.255,36.485),(62.425,36.485),(62.425,36.315),(62.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,36.675),(61.175,36.845),(61.345,36.845),(61.345,36.675),(61.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,36.675),(61.535,36.845),(61.705,36.845),(61.705,36.675),(61.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,36.675),(61.895,36.845),(62.065,36.845),(62.065,36.675),(61.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,36.675),(62.255,36.845),(62.425,36.845),(62.425,36.675),(62.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,37.035),(61.175,37.205),(61.345,37.205),(61.345,37.035),(61.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,37.035),(61.535,37.205),(61.705,37.205),(61.705,37.035),(61.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,37.035),(61.895,37.205),(62.065,37.205),(62.065,37.035),(61.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,37.035),(62.255,37.205),(62.425,37.205),(62.425,37.035),(62.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,37.395),(61.175,37.565),(61.345,37.565),(61.345,37.395),(61.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,37.395),(61.535,37.565),(61.705,37.565),(61.705,37.395),(61.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,37.395),(61.895,37.565),(62.065,37.565),(62.065,37.395),(61.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,37.395),(62.255,37.565),(62.425,37.565),(62.425,37.395),(62.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,37.755),(61.175,37.925),(61.345,37.925),(61.345,37.755),(61.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,37.755),(61.535,37.925),(61.705,37.925),(61.705,37.755),(61.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,37.755),(61.895,37.925),(62.065,37.925),(62.065,37.755),(61.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,37.755),(62.255,37.925),(62.425,37.925),(62.425,37.755),(62.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,38.115),(61.175,38.285),(61.345,38.285),(61.345,38.115),(61.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,38.115),(61.535,38.285),(61.705,38.285),(61.705,38.115),(61.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,38.115),(61.895,38.285),(62.065,38.285),(62.065,38.115),(61.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,38.115),(62.255,38.285),(62.425,38.285),(62.425,38.115),(62.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,38.475),(61.175,38.645),(61.345,38.645),(61.345,38.475),(61.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,38.475),(61.535,38.645),(61.705,38.645),(61.705,38.475),(61.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,38.475),(61.895,38.645),(62.065,38.645),(62.065,38.475),(61.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,38.475),(62.255,38.645),(62.425,38.645),(62.425,38.475),(62.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,38.835),(61.175,39.005),(61.345,39.005),(61.345,38.835),(61.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,38.835),(61.535,39.005),(61.705,39.005),(61.705,38.835),(61.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,38.835),(61.895,39.005),(62.065,39.005),(62.065,38.835),(61.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,38.835),(62.255,39.005),(62.425,39.005),(62.425,38.835),(62.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,39.195),(61.175,39.365),(61.345,39.365),(61.345,39.195),(61.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,39.195),(61.535,39.365),(61.705,39.365),(61.705,39.195),(61.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,39.195),(61.895,39.365),(62.065,39.365),(62.065,39.195),(61.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,39.195),(62.255,39.365),(62.425,39.365),(62.425,39.195),(62.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,39.555),(61.175,39.725),(61.345,39.725),(61.345,39.555),(61.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,39.555),(61.535,39.725),(61.705,39.725),(61.705,39.555),(61.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,39.555),(61.895,39.725),(62.065,39.725),(62.065,39.555),(61.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,39.555),(62.255,39.725),(62.425,39.725),(62.425,39.555),(62.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,39.915),(61.175,40.085),(61.345,40.085),(61.345,39.915),(61.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,39.915),(61.535,40.085),(61.705,40.085),(61.705,39.915),(61.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,39.915),(61.895,40.085),(62.065,40.085),(62.065,39.915),(61.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,39.915),(62.255,40.085),(62.425,40.085),(62.425,39.915),(62.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,40.275),(61.175,40.445),(61.345,40.445),(61.345,40.275),(61.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,40.275),(61.535,40.445),(61.705,40.445),(61.705,40.275),(61.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,40.275),(61.895,40.445),(62.065,40.445),(62.065,40.275),(61.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,40.275),(62.255,40.445),(62.425,40.445),(62.425,40.275),(62.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,40.635),(61.175,40.805),(61.345,40.805),(61.345,40.635),(61.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,40.635),(61.535,40.805),(61.705,40.805),(61.705,40.635),(61.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,40.635),(61.895,40.805),(62.065,40.805),(62.065,40.635),(61.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,40.635),(62.255,40.805),(62.425,40.805),(62.425,40.635),(62.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.835),(56.375,3.005),(56.545,3.005),(56.545,2.835),(56.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.835),(56.735,3.005),(56.905,3.005),(56.905,2.835),(56.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.835),(57.095,3.005),(57.265,3.005),(57.265,2.835),(57.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.835),(57.455,3.005),(57.625,3.005),(57.625,2.835),(57.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.195),(56.375,3.365),(56.545,3.365),(56.545,3.195),(56.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.195),(56.735,3.365),(56.905,3.365),(56.905,3.195),(56.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.195),(57.095,3.365),(57.265,3.365),(57.265,3.195),(57.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.195),(57.455,3.365),(57.625,3.365),(57.625,3.195),(57.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.555),(56.375,3.725),(56.545,3.725),(56.545,3.555),(56.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.555),(56.735,3.725),(56.905,3.725),(56.905,3.555),(56.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.555),(57.095,3.725),(57.265,3.725),(57.265,3.555),(57.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.555),(57.455,3.725),(57.625,3.725),(57.625,3.555),(57.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.915),(56.375,4.085),(56.545,4.085),(56.545,3.915),(56.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.915),(56.735,4.085),(56.905,4.085),(56.905,3.915),(56.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.915),(57.095,4.085),(57.265,4.085),(57.265,3.915),(57.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.915),(57.455,4.085),(57.625,4.085),(57.625,3.915),(57.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.275),(56.375,4.445),(56.545,4.445),(56.545,4.275),(56.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.275),(56.735,4.445),(56.905,4.445),(56.905,4.275),(56.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.275),(57.095,4.445),(57.265,4.445),(57.265,4.275),(57.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.275),(57.455,4.445),(57.625,4.445),(57.625,4.275),(57.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.635),(56.375,4.805),(56.545,4.805),(56.545,4.635),(56.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.635),(56.735,4.805),(56.905,4.805),(56.905,4.635),(56.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.635),(57.095,4.805),(57.265,4.805),(57.265,4.635),(57.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.635),(57.455,4.805),(57.625,4.805),(57.625,4.635),(57.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.995),(56.375,5.165),(56.545,5.165),(56.545,4.995),(56.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.995),(56.735,5.165),(56.905,5.165),(56.905,4.995),(56.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.995),(57.095,5.165),(57.265,5.165),(57.265,4.995),(57.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.995),(57.455,5.165),(57.625,5.165),(57.625,4.995),(57.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.355),(56.375,5.525),(56.545,5.525),(56.545,5.355),(56.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.355),(56.735,5.525),(56.905,5.525),(56.905,5.355),(56.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.355),(57.095,5.525),(57.265,5.525),(57.265,5.355),(57.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.355),(57.455,5.525),(57.625,5.525),(57.625,5.355),(57.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.715),(56.375,5.885),(56.545,5.885),(56.545,5.715),(56.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.715),(56.735,5.885),(56.905,5.885),(56.905,5.715),(56.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.715),(57.095,5.885),(57.265,5.885),(57.265,5.715),(57.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.715),(57.455,5.885),(57.625,5.885),(57.625,5.715),(57.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.075),(56.375,6.245),(56.545,6.245),(56.545,6.075),(56.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.075),(56.735,6.245),(56.905,6.245),(56.905,6.075),(56.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.075),(57.095,6.245),(57.265,6.245),(57.265,6.075),(57.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.075),(57.455,6.245),(57.625,6.245),(57.625,6.075),(57.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.435),(56.375,6.605),(56.545,6.605),(56.545,6.435),(56.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.435),(56.735,6.605),(56.905,6.605),(56.905,6.435),(56.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.435),(57.095,6.605),(57.265,6.605),(57.265,6.435),(57.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.435),(57.455,6.605),(57.625,6.605),(57.625,6.435),(57.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.795),(56.375,6.965),(56.545,6.965),(56.545,6.795),(56.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.795),(56.735,6.965),(56.905,6.965),(56.905,6.795),(56.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.795),(57.095,6.965),(57.265,6.965),(57.265,6.795),(57.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.795),(57.455,6.965),(57.625,6.965),(57.625,6.795),(57.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.155),(56.375,7.325),(56.545,7.325),(56.545,7.155),(56.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.155),(56.735,7.325),(56.905,7.325),(56.905,7.155),(56.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.155),(57.095,7.325),(57.265,7.325),(57.265,7.155),(57.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.155),(57.455,7.325),(57.625,7.325),(57.625,7.155),(57.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.515),(56.375,7.685),(56.545,7.685),(56.545,7.515),(56.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.515),(56.735,7.685),(56.905,7.685),(56.905,7.515),(56.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.515),(57.095,7.685),(57.265,7.685),(57.265,7.515),(57.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.515),(57.455,7.685),(57.625,7.685),(57.625,7.515),(57.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.875),(56.375,8.045),(56.545,8.045),(56.545,7.875),(56.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.875),(56.735,8.045),(56.905,8.045),(56.905,7.875),(56.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.875),(57.095,8.045),(57.265,8.045),(57.265,7.875),(57.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.875),(57.455,8.045),(57.625,8.045),(57.625,7.875),(57.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.235),(56.375,8.405),(56.545,8.405),(56.545,8.235),(56.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.235),(56.735,8.405),(56.905,8.405),(56.905,8.235),(56.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.235),(57.095,8.405),(57.265,8.405),(57.265,8.235),(57.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.235),(57.455,8.405),(57.625,8.405),(57.625,8.235),(57.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.595),(56.375,8.765),(56.545,8.765),(56.545,8.595),(56.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.595),(56.735,8.765),(56.905,8.765),(56.905,8.595),(56.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.595),(57.095,8.765),(57.265,8.765),(57.265,8.595),(57.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.595),(57.455,8.765),(57.625,8.765),(57.625,8.595),(57.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.955),(56.375,9.125),(56.545,9.125),(56.545,8.955),(56.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.955),(56.735,9.125),(56.905,9.125),(56.905,8.955),(56.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.955),(57.095,9.125),(57.265,9.125),(57.265,8.955),(57.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.955),(57.455,9.125),(57.625,9.125),(57.625,8.955),(57.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.315),(56.375,9.485),(56.545,9.485),(56.545,9.315),(56.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.315),(56.735,9.485),(56.905,9.485),(56.905,9.315),(56.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.315),(57.095,9.485),(57.265,9.485),(57.265,9.315),(57.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.315),(57.455,9.485),(57.625,9.485),(57.625,9.315),(57.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.675),(56.375,9.845),(56.545,9.845),(56.545,9.675),(56.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.675),(56.735,9.845),(56.905,9.845),(56.905,9.675),(56.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.675),(57.095,9.845),(57.265,9.845),(57.265,9.675),(57.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.675),(57.455,9.845),(57.625,9.845),(57.625,9.675),(57.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.035),(56.375,10.205),(56.545,10.205),(56.545,10.035),(56.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.035),(56.735,10.205),(56.905,10.205),(56.905,10.035),(56.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.035),(57.095,10.205),(57.265,10.205),(57.265,10.035),(57.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.035),(57.455,10.205),(57.625,10.205),(57.625,10.035),(57.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.395),(56.375,10.565),(56.545,10.565),(56.545,10.395),(56.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.395),(56.735,10.565),(56.905,10.565),(56.905,10.395),(56.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.395),(57.095,10.565),(57.265,10.565),(57.265,10.395),(57.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.395),(57.455,10.565),(57.625,10.565),(57.625,10.395),(57.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.755),(56.375,10.925),(56.545,10.925),(56.545,10.755),(56.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.755),(56.735,10.925),(56.905,10.925),(56.905,10.755),(56.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.755),(57.095,10.925),(57.265,10.925),(57.265,10.755),(57.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.755),(57.455,10.925),(57.625,10.925),(57.625,10.755),(57.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.115),(56.375,11.285),(56.545,11.285),(56.545,11.115),(56.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.115),(56.735,11.285),(56.905,11.285),(56.905,11.115),(56.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.115),(57.095,11.285),(57.265,11.285),(57.265,11.115),(57.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.115),(57.455,11.285),(57.625,11.285),(57.625,11.115),(57.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.475),(56.375,11.645),(56.545,11.645),(56.545,11.475),(56.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.475),(56.735,11.645),(56.905,11.645),(56.905,11.475),(56.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.475),(57.095,11.645),(57.265,11.645),(57.265,11.475),(57.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.475),(57.455,11.645),(57.625,11.645),(57.625,11.475),(57.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.835),(56.375,12.005),(56.545,12.005),(56.545,11.835),(56.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.835),(56.735,12.005),(56.905,12.005),(56.905,11.835),(56.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.835),(57.095,12.005),(57.265,12.005),(57.265,11.835),(57.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.835),(57.455,12.005),(57.625,12.005),(57.625,11.835),(57.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.195),(56.375,12.365),(56.545,12.365),(56.545,12.195),(56.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.195),(56.735,12.365),(56.905,12.365),(56.905,12.195),(56.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.195),(57.095,12.365),(57.265,12.365),(57.265,12.195),(57.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.195),(57.455,12.365),(57.625,12.365),(57.625,12.195),(57.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.555),(56.375,12.725),(56.545,12.725),(56.545,12.555),(56.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.555),(56.735,12.725),(56.905,12.725),(56.905,12.555),(56.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.555),(57.095,12.725),(57.265,12.725),(57.265,12.555),(57.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.555),(57.455,12.725),(57.625,12.725),(57.625,12.555),(57.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.915),(56.375,13.085),(56.545,13.085),(56.545,12.915),(56.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.915),(56.735,13.085),(56.905,13.085),(56.905,12.915),(56.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.915),(57.095,13.085),(57.265,13.085),(57.265,12.915),(57.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.915),(57.455,13.085),(57.625,13.085),(57.625,12.915),(57.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.275),(56.375,13.445),(56.545,13.445),(56.545,13.275),(56.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.275),(56.735,13.445),(56.905,13.445),(56.905,13.275),(56.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.275),(57.095,13.445),(57.265,13.445),(57.265,13.275),(57.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.275),(57.455,13.445),(57.625,13.445),(57.625,13.275),(57.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.635),(56.375,13.805),(56.545,13.805),(56.545,13.635),(56.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.635),(56.735,13.805),(56.905,13.805),(56.905,13.635),(56.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.635),(57.095,13.805),(57.265,13.805),(57.265,13.635),(57.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.635),(57.455,13.805),(57.625,13.805),(57.625,13.635),(57.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.995),(56.375,14.165),(56.545,14.165),(56.545,13.995),(56.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.995),(56.735,14.165),(56.905,14.165),(56.905,13.995),(56.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.995),(57.095,14.165),(57.265,14.165),(57.265,13.995),(57.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.995),(57.455,14.165),(57.625,14.165),(57.625,13.995),(57.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.355),(56.375,14.525),(56.545,14.525),(56.545,14.355),(56.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.355),(56.735,14.525),(56.905,14.525),(56.905,14.355),(56.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.355),(57.095,14.525),(57.265,14.525),(57.265,14.355),(57.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.355),(57.455,14.525),(57.625,14.525),(57.625,14.355),(57.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.715),(56.375,14.885),(56.545,14.885),(56.545,14.715),(56.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.715),(56.735,14.885),(56.905,14.885),(56.905,14.715),(56.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.715),(57.095,14.885),(57.265,14.885),(57.265,14.715),(57.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.715),(57.455,14.885),(57.625,14.885),(57.625,14.715),(57.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.075),(56.375,15.245),(56.545,15.245),(56.545,15.075),(56.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.075),(56.735,15.245),(56.905,15.245),(56.905,15.075),(56.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.075),(57.095,15.245),(57.265,15.245),(57.265,15.075),(57.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.075),(57.455,15.245),(57.625,15.245),(57.625,15.075),(57.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.435),(56.375,15.605),(56.545,15.605),(56.545,15.435),(56.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.435),(56.735,15.605),(56.905,15.605),(56.905,15.435),(56.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.435),(57.095,15.605),(57.265,15.605),(57.265,15.435),(57.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.435),(57.455,15.605),(57.625,15.605),(57.625,15.435),(57.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.795),(56.375,15.965),(56.545,15.965),(56.545,15.795),(56.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.795),(56.735,15.965),(56.905,15.965),(56.905,15.795),(56.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.795),(57.095,15.965),(57.265,15.965),(57.265,15.795),(57.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.795),(57.455,15.965),(57.625,15.965),(57.625,15.795),(57.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.155),(56.375,16.325),(56.545,16.325),(56.545,16.155),(56.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.155),(56.735,16.325),(56.905,16.325),(56.905,16.155),(56.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.155),(57.095,16.325),(57.265,16.325),(57.265,16.155),(57.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.155),(57.455,16.325),(57.625,16.325),(57.625,16.155),(57.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.515),(56.375,16.685),(56.545,16.685),(56.545,16.515),(56.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.515),(56.735,16.685),(56.905,16.685),(56.905,16.515),(56.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.515),(57.095,16.685),(57.265,16.685),(57.265,16.515),(57.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.515),(57.455,16.685),(57.625,16.685),(57.625,16.515),(57.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.875),(56.375,17.045),(56.545,17.045),(56.545,16.875),(56.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.875),(56.735,17.045),(56.905,17.045),(56.905,16.875),(56.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.875),(57.095,17.045),(57.265,17.045),(57.265,16.875),(57.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.875),(57.455,17.045),(57.625,17.045),(57.625,16.875),(57.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.235),(56.375,17.405),(56.545,17.405),(56.545,17.235),(56.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.235),(56.735,17.405),(56.905,17.405),(56.905,17.235),(56.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.235),(57.095,17.405),(57.265,17.405),(57.265,17.235),(57.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.235),(57.455,17.405),(57.625,17.405),(57.625,17.235),(57.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.595),(56.375,17.765),(56.545,17.765),(56.545,17.595),(56.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.595),(56.735,17.765),(56.905,17.765),(56.905,17.595),(56.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.595),(57.095,17.765),(57.265,17.765),(57.265,17.595),(57.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.595),(57.455,17.765),(57.625,17.765),(57.625,17.595),(57.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.955),(56.375,18.125),(56.545,18.125),(56.545,17.955),(56.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.955),(56.735,18.125),(56.905,18.125),(56.905,17.955),(56.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.955),(57.095,18.125),(57.265,18.125),(57.265,17.955),(57.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.955),(57.455,18.125),(57.625,18.125),(57.625,17.955),(57.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.315),(56.375,18.485),(56.545,18.485),(56.545,18.315),(56.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.315),(56.735,18.485),(56.905,18.485),(56.905,18.315),(56.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.315),(57.095,18.485),(57.265,18.485),(57.265,18.315),(57.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.315),(57.455,18.485),(57.625,18.485),(57.625,18.315),(57.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.675),(56.375,18.845),(56.545,18.845),(56.545,18.675),(56.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.675),(56.735,18.845),(56.905,18.845),(56.905,18.675),(56.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.675),(57.095,18.845),(57.265,18.845),(57.265,18.675),(57.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.675),(57.455,18.845),(57.625,18.845),(57.625,18.675),(57.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.035),(56.375,19.205),(56.545,19.205),(56.545,19.035),(56.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.035),(56.735,19.205),(56.905,19.205),(56.905,19.035),(56.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.035),(57.095,19.205),(57.265,19.205),(57.265,19.035),(57.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.035),(57.455,19.205),(57.625,19.205),(57.625,19.035),(57.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.395),(56.375,19.565),(56.545,19.565),(56.545,19.395),(56.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.395),(56.735,19.565),(56.905,19.565),(56.905,19.395),(56.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.395),(57.095,19.565),(57.265,19.565),(57.265,19.395),(57.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.395),(57.455,19.565),(57.625,19.565),(57.625,19.395),(57.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.755),(56.375,19.925),(56.545,19.925),(56.545,19.755),(56.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.755),(56.735,19.925),(56.905,19.925),(56.905,19.755),(56.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.755),(57.095,19.925),(57.265,19.925),(57.265,19.755),(57.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.755),(57.455,19.925),(57.625,19.925),(57.625,19.755),(57.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.115),(56.375,20.285),(56.545,20.285),(56.545,20.115),(56.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.115),(56.735,20.285),(56.905,20.285),(56.905,20.115),(56.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.115),(57.095,20.285),(57.265,20.285),(57.265,20.115),(57.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.115),(57.455,20.285),(57.625,20.285),(57.625,20.115),(57.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.475),(56.375,20.645),(56.545,20.645),(56.545,20.475),(56.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.475),(56.735,20.645),(56.905,20.645),(56.905,20.475),(56.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.475),(57.095,20.645),(57.265,20.645),(57.265,20.475),(57.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.475),(57.455,20.645),(57.625,20.645),(57.625,20.475),(57.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.835),(56.375,21.005),(56.545,21.005),(56.545,20.835),(56.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.835),(56.735,21.005),(56.905,21.005),(56.905,20.835),(56.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.835),(57.095,21.005),(57.265,21.005),(57.265,20.835),(57.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.835),(57.455,21.005),(57.625,21.005),(57.625,20.835),(57.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.195),(56.375,21.365),(56.545,21.365),(56.545,21.195),(56.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.195),(56.735,21.365),(56.905,21.365),(56.905,21.195),(56.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.195),(57.095,21.365),(57.265,21.365),(57.265,21.195),(57.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.195),(57.455,21.365),(57.625,21.365),(57.625,21.195),(57.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.555),(56.375,21.725),(56.545,21.725),(56.545,21.555),(56.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.555),(56.735,21.725),(56.905,21.725),(56.905,21.555),(56.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.555),(57.095,21.725),(57.265,21.725),(57.265,21.555),(57.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.555),(57.455,21.725),(57.625,21.725),(57.625,21.555),(57.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.915),(56.375,22.085),(56.545,22.085),(56.545,21.915),(56.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.915),(56.735,22.085),(56.905,22.085),(56.905,21.915),(56.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.915),(57.095,22.085),(57.265,22.085),(57.265,21.915),(57.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.915),(57.455,22.085),(57.625,22.085),(57.625,21.915),(57.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.275),(56.375,22.445),(56.545,22.445),(56.545,22.275),(56.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.275),(56.735,22.445),(56.905,22.445),(56.905,22.275),(56.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.275),(57.095,22.445),(57.265,22.445),(57.265,22.275),(57.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.275),(57.455,22.445),(57.625,22.445),(57.625,22.275),(57.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.635),(56.375,22.805),(56.545,22.805),(56.545,22.635),(56.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.635),(56.735,22.805),(56.905,22.805),(56.905,22.635),(56.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.635),(57.095,22.805),(57.265,22.805),(57.265,22.635),(57.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.635),(57.455,22.805),(57.625,22.805),(57.625,22.635),(57.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.995),(56.375,23.165),(56.545,23.165),(56.545,22.995),(56.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.995),(56.735,23.165),(56.905,23.165),(56.905,22.995),(56.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.995),(57.095,23.165),(57.265,23.165),(57.265,22.995),(57.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.995),(57.455,23.165),(57.625,23.165),(57.625,22.995),(57.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,23.355),(56.375,23.525),(56.545,23.525),(56.545,23.355),(56.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,23.355),(56.735,23.525),(56.905,23.525),(56.905,23.355),(56.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,23.355),(57.095,23.525),(57.265,23.525),(57.265,23.355),(57.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,23.355),(57.455,23.525),(57.625,23.525),(57.625,23.355),(57.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,23.715),(56.375,23.885),(56.545,23.885),(56.545,23.715),(56.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,23.715),(56.735,23.885),(56.905,23.885),(56.905,23.715),(56.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,23.715),(57.095,23.885),(57.265,23.885),(57.265,23.715),(57.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,23.715),(57.455,23.885),(57.625,23.885),(57.625,23.715),(57.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.075),(56.375,24.245),(56.545,24.245),(56.545,24.075),(56.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.075),(56.735,24.245),(56.905,24.245),(56.905,24.075),(56.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.075),(57.095,24.245),(57.265,24.245),(57.265,24.075),(57.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.075),(57.455,24.245),(57.625,24.245),(57.625,24.075),(57.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.435),(56.375,24.605),(56.545,24.605),(56.545,24.435),(56.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.435),(56.735,24.605),(56.905,24.605),(56.905,24.435),(56.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.435),(57.095,24.605),(57.265,24.605),(57.265,24.435),(57.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.435),(57.455,24.605),(57.625,24.605),(57.625,24.435),(57.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.795),(56.375,24.965),(56.545,24.965),(56.545,24.795),(56.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.795),(56.735,24.965),(56.905,24.965),(56.905,24.795),(56.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.795),(57.095,24.965),(57.265,24.965),(57.265,24.795),(57.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.795),(57.455,24.965),(57.625,24.965),(57.625,24.795),(57.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.155),(56.375,25.325),(56.545,25.325),(56.545,25.155),(56.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.155),(56.735,25.325),(56.905,25.325),(56.905,25.155),(56.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.155),(57.095,25.325),(57.265,25.325),(57.265,25.155),(57.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.155),(57.455,25.325),(57.625,25.325),(57.625,25.155),(57.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.515),(56.375,25.685),(56.545,25.685),(56.545,25.515),(56.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.515),(56.735,25.685),(56.905,25.685),(56.905,25.515),(56.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.515),(57.095,25.685),(57.265,25.685),(57.265,25.515),(57.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.515),(57.455,25.685),(57.625,25.685),(57.625,25.515),(57.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.875),(56.375,26.045),(56.545,26.045),(56.545,25.875),(56.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.875),(56.735,26.045),(56.905,26.045),(56.905,25.875),(56.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.875),(57.095,26.045),(57.265,26.045),(57.265,25.875),(57.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.875),(57.455,26.045),(57.625,26.045),(57.625,25.875),(57.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.235),(56.375,26.405),(56.545,26.405),(56.545,26.235),(56.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.235),(56.735,26.405),(56.905,26.405),(56.905,26.235),(56.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.235),(57.095,26.405),(57.265,26.405),(57.265,26.235),(57.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.235),(57.455,26.405),(57.625,26.405),(57.625,26.235),(57.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.595),(56.375,26.765),(56.545,26.765),(56.545,26.595),(56.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.595),(56.735,26.765),(56.905,26.765),(56.905,26.595),(56.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.595),(57.095,26.765),(57.265,26.765),(57.265,26.595),(57.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.595),(57.455,26.765),(57.625,26.765),(57.625,26.595),(57.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.955),(56.375,27.125),(56.545,27.125),(56.545,26.955),(56.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.955),(56.735,27.125),(56.905,27.125),(56.905,26.955),(56.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.955),(57.095,27.125),(57.265,27.125),(57.265,26.955),(57.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.955),(57.455,27.125),(57.625,27.125),(57.625,26.955),(57.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,27.315),(56.375,27.485),(56.545,27.485),(56.545,27.315),(56.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,27.315),(56.735,27.485),(56.905,27.485),(56.905,27.315),(56.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,27.315),(57.095,27.485),(57.265,27.485),(57.265,27.315),(57.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,27.315),(57.455,27.485),(57.625,27.485),(57.625,27.315),(57.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,27.675),(56.375,27.845),(56.545,27.845),(56.545,27.675),(56.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,27.675),(56.735,27.845),(56.905,27.845),(56.905,27.675),(56.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,27.675),(57.095,27.845),(57.265,27.845),(57.265,27.675),(57.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,27.675),(57.455,27.845),(57.625,27.845),(57.625,27.675),(57.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.035),(56.375,28.205),(56.545,28.205),(56.545,28.035),(56.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.035),(56.735,28.205),(56.905,28.205),(56.905,28.035),(56.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.035),(57.095,28.205),(57.265,28.205),(57.265,28.035),(57.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.035),(57.455,28.205),(57.625,28.205),(57.625,28.035),(57.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.395),(56.375,28.565),(56.545,28.565),(56.545,28.395),(56.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.395),(56.735,28.565),(56.905,28.565),(56.905,28.395),(56.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.395),(57.095,28.565),(57.265,28.565),(57.265,28.395),(57.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.395),(57.455,28.565),(57.625,28.565),(57.625,28.395),(57.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.755),(56.375,28.925),(56.545,28.925),(56.545,28.755),(56.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.755),(56.735,28.925),(56.905,28.925),(56.905,28.755),(56.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.755),(57.095,28.925),(57.265,28.925),(57.265,28.755),(57.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.755),(57.455,28.925),(57.625,28.925),(57.625,28.755),(57.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.115),(56.375,29.285),(56.545,29.285),(56.545,29.115),(56.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.115),(56.735,29.285),(56.905,29.285),(56.905,29.115),(56.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.115),(57.095,29.285),(57.265,29.285),(57.265,29.115),(57.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.115),(57.455,29.285),(57.625,29.285),(57.625,29.115),(57.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.475),(56.375,29.645),(56.545,29.645),(56.545,29.475),(56.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.475),(56.735,29.645),(56.905,29.645),(56.905,29.475),(56.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.475),(57.095,29.645),(57.265,29.645),(57.265,29.475),(57.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.475),(57.455,29.645),(57.625,29.645),(57.625,29.475),(57.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.835),(56.375,30.005),(56.545,30.005),(56.545,29.835),(56.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.835),(56.735,30.005),(56.905,30.005),(56.905,29.835),(56.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.835),(57.095,30.005),(57.265,30.005),(57.265,29.835),(57.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.835),(57.455,30.005),(57.625,30.005),(57.625,29.835),(57.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.195),(56.375,30.365),(56.545,30.365),(56.545,30.195),(56.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.195),(56.735,30.365),(56.905,30.365),(56.905,30.195),(56.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.195),(57.095,30.365),(57.265,30.365),(57.265,30.195),(57.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.195),(57.455,30.365),(57.625,30.365),(57.625,30.195),(57.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.555),(56.375,30.725),(56.545,30.725),(56.545,30.555),(56.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.555),(56.735,30.725),(56.905,30.725),(56.905,30.555),(56.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.555),(57.095,30.725),(57.265,30.725),(57.265,30.555),(57.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.555),(57.455,30.725),(57.625,30.725),(57.625,30.555),(57.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.915),(56.375,31.085),(56.545,31.085),(56.545,30.915),(56.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.915),(56.735,31.085),(56.905,31.085),(56.905,30.915),(56.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.915),(57.095,31.085),(57.265,31.085),(57.265,30.915),(57.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.915),(57.455,31.085),(57.625,31.085),(57.625,30.915),(57.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.275),(56.375,31.445),(56.545,31.445),(56.545,31.275),(56.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.275),(56.735,31.445),(56.905,31.445),(56.905,31.275),(56.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.275),(57.095,31.445),(57.265,31.445),(57.265,31.275),(57.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.275),(57.455,31.445),(57.625,31.445),(57.625,31.275),(57.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.635),(56.375,31.805),(56.545,31.805),(56.545,31.635),(56.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.635),(56.735,31.805),(56.905,31.805),(56.905,31.635),(56.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.635),(57.095,31.805),(57.265,31.805),(57.265,31.635),(57.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.635),(57.455,31.805),(57.625,31.805),(57.625,31.635),(57.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.995),(56.375,32.165),(56.545,32.165),(56.545,31.995),(56.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.995),(56.735,32.165),(56.905,32.165),(56.905,31.995),(56.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.995),(57.095,32.165),(57.265,32.165),(57.265,31.995),(57.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.995),(57.455,32.165),(57.625,32.165),(57.625,31.995),(57.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,32.355),(56.375,32.525),(56.545,32.525),(56.545,32.355),(56.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,32.355),(56.735,32.525),(56.905,32.525),(56.905,32.355),(56.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,32.355),(57.095,32.525),(57.265,32.525),(57.265,32.355),(57.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,32.355),(57.455,32.525),(57.625,32.525),(57.625,32.355),(57.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,32.715),(56.375,32.885),(56.545,32.885),(56.545,32.715),(56.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,32.715),(56.735,32.885),(56.905,32.885),(56.905,32.715),(56.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,32.715),(57.095,32.885),(57.265,32.885),(57.265,32.715),(57.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,32.715),(57.455,32.885),(57.625,32.885),(57.625,32.715),(57.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.075),(56.375,33.245),(56.545,33.245),(56.545,33.075),(56.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.075),(56.735,33.245),(56.905,33.245),(56.905,33.075),(56.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.075),(57.095,33.245),(57.265,33.245),(57.265,33.075),(57.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.075),(57.455,33.245),(57.625,33.245),(57.625,33.075),(57.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.435),(56.375,33.605),(56.545,33.605),(56.545,33.435),(56.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.435),(56.735,33.605),(56.905,33.605),(56.905,33.435),(56.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.435),(57.095,33.605),(57.265,33.605),(57.265,33.435),(57.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.435),(57.455,33.605),(57.625,33.605),(57.625,33.435),(57.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.795),(56.375,33.965),(56.545,33.965),(56.545,33.795),(56.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.795),(56.735,33.965),(56.905,33.965),(56.905,33.795),(56.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.795),(57.095,33.965),(57.265,33.965),(57.265,33.795),(57.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.795),(57.455,33.965),(57.625,33.965),(57.625,33.795),(57.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.155),(56.375,34.325),(56.545,34.325),(56.545,34.155),(56.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.155),(56.735,34.325),(56.905,34.325),(56.905,34.155),(56.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.155),(57.095,34.325),(57.265,34.325),(57.265,34.155),(57.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.155),(57.455,34.325),(57.625,34.325),(57.625,34.155),(57.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.515),(56.375,34.685),(56.545,34.685),(56.545,34.515),(56.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.515),(56.735,34.685),(56.905,34.685),(56.905,34.515),(56.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.515),(57.095,34.685),(57.265,34.685),(57.265,34.515),(57.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.515),(57.455,34.685),(57.625,34.685),(57.625,34.515),(57.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.875),(56.375,35.045),(56.545,35.045),(56.545,34.875),(56.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.875),(56.735,35.045),(56.905,35.045),(56.905,34.875),(56.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.875),(57.095,35.045),(57.265,35.045),(57.265,34.875),(57.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.875),(57.455,35.045),(57.625,35.045),(57.625,34.875),(57.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.235),(56.375,35.405),(56.545,35.405),(56.545,35.235),(56.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.235),(56.735,35.405),(56.905,35.405),(56.905,35.235),(56.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.235),(57.095,35.405),(57.265,35.405),(57.265,35.235),(57.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.235),(57.455,35.405),(57.625,35.405),(57.625,35.235),(57.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.595),(56.375,35.765),(56.545,35.765),(56.545,35.595),(56.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.595),(56.735,35.765),(56.905,35.765),(56.905,35.595),(56.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.595),(57.095,35.765),(57.265,35.765),(57.265,35.595),(57.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.595),(57.455,35.765),(57.625,35.765),(57.625,35.595),(57.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.955),(56.375,36.125),(56.545,36.125),(56.545,35.955),(56.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.955),(56.735,36.125),(56.905,36.125),(56.905,35.955),(56.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.955),(57.095,36.125),(57.265,36.125),(57.265,35.955),(57.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.955),(57.455,36.125),(57.625,36.125),(57.625,35.955),(57.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,36.315),(56.375,36.485),(56.545,36.485),(56.545,36.315),(56.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,36.315),(56.735,36.485),(56.905,36.485),(56.905,36.315),(56.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,36.315),(57.095,36.485),(57.265,36.485),(57.265,36.315),(57.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,36.315),(57.455,36.485),(57.625,36.485),(57.625,36.315),(57.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,36.675),(56.375,36.845),(56.545,36.845),(56.545,36.675),(56.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,36.675),(56.735,36.845),(56.905,36.845),(56.905,36.675),(56.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,36.675),(57.095,36.845),(57.265,36.845),(57.265,36.675),(57.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,36.675),(57.455,36.845),(57.625,36.845),(57.625,36.675),(57.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.035),(56.375,37.205),(56.545,37.205),(56.545,37.035),(56.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.035),(56.735,37.205),(56.905,37.205),(56.905,37.035),(56.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.035),(57.095,37.205),(57.265,37.205),(57.265,37.035),(57.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.035),(57.455,37.205),(57.625,37.205),(57.625,37.035),(57.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.395),(56.375,37.565),(56.545,37.565),(56.545,37.395),(56.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.395),(56.735,37.565),(56.905,37.565),(56.905,37.395),(56.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.395),(57.095,37.565),(57.265,37.565),(57.265,37.395),(57.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.395),(57.455,37.565),(57.625,37.565),(57.625,37.395),(57.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.755),(56.375,37.925),(56.545,37.925),(56.545,37.755),(56.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.755),(56.735,37.925),(56.905,37.925),(56.905,37.755),(56.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.755),(57.095,37.925),(57.265,37.925),(57.265,37.755),(57.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.755),(57.455,37.925),(57.625,37.925),(57.625,37.755),(57.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.115),(56.375,38.285),(56.545,38.285),(56.545,38.115),(56.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.115),(56.735,38.285),(56.905,38.285),(56.905,38.115),(56.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.115),(57.095,38.285),(57.265,38.285),(57.265,38.115),(57.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.115),(57.455,38.285),(57.625,38.285),(57.625,38.115),(57.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.475),(56.375,38.645),(56.545,38.645),(56.545,38.475),(56.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.475),(56.735,38.645),(56.905,38.645),(56.905,38.475),(56.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.475),(57.095,38.645),(57.265,38.645),(57.265,38.475),(57.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.475),(57.455,38.645),(57.625,38.645),(57.625,38.475),(57.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.835),(56.375,39.005),(56.545,39.005),(56.545,38.835),(56.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.835),(56.735,39.005),(56.905,39.005),(56.905,38.835),(56.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.835),(57.095,39.005),(57.265,39.005),(57.265,38.835),(57.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.835),(57.455,39.005),(57.625,39.005),(57.625,38.835),(57.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.195),(56.375,39.365),(56.545,39.365),(56.545,39.195),(56.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.195),(56.735,39.365),(56.905,39.365),(56.905,39.195),(56.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.195),(57.095,39.365),(57.265,39.365),(57.265,39.195),(57.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.195),(57.455,39.365),(57.625,39.365),(57.625,39.195),(57.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.555),(56.375,39.725),(56.545,39.725),(56.545,39.555),(56.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.555),(56.735,39.725),(56.905,39.725),(56.905,39.555),(56.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.555),(57.095,39.725),(57.265,39.725),(57.265,39.555),(57.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.555),(57.455,39.725),(57.625,39.725),(57.625,39.555),(57.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.915),(56.375,40.085),(56.545,40.085),(56.545,39.915),(56.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.915),(56.735,40.085),(56.905,40.085),(56.905,39.915),(56.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.915),(57.095,40.085),(57.265,40.085),(57.265,39.915),(57.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.915),(57.455,40.085),(57.625,40.085),(57.625,39.915),(57.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,40.275),(56.375,40.445),(56.545,40.445),(56.545,40.275),(56.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,40.275),(56.735,40.445),(56.905,40.445),(56.905,40.275),(56.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,40.275),(57.095,40.445),(57.265,40.445),(57.265,40.275),(57.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,40.275),(57.455,40.445),(57.625,40.445),(57.625,40.275),(57.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,40.635),(56.375,40.805),(56.545,40.805),(56.545,40.635),(56.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,40.635),(56.735,40.805),(56.905,40.805),(56.905,40.635),(56.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,40.635),(57.095,40.805),(57.265,40.805),(57.265,40.635),(57.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,40.635),(57.455,40.805),(57.625,40.805),(57.625,40.635),(57.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,2.835),(8.375,3.005),(8.545,3.005),(8.545,2.835),(8.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,2.835),(8.735,3.005),(8.905,3.005),(8.905,2.835),(8.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,2.835),(9.095,3.005),(9.265,3.005),(9.265,2.835),(9.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,2.835),(9.455,3.005),(9.625,3.005),(9.625,2.835),(9.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.195),(8.375,3.365),(8.545,3.365),(8.545,3.195),(8.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.195),(8.735,3.365),(8.905,3.365),(8.905,3.195),(8.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.195),(9.095,3.365),(9.265,3.365),(9.265,3.195),(9.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.195),(9.455,3.365),(9.625,3.365),(9.625,3.195),(9.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.555),(8.375,3.725),(8.545,3.725),(8.545,3.555),(8.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.555),(8.735,3.725),(8.905,3.725),(8.905,3.555),(8.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.555),(9.095,3.725),(9.265,3.725),(9.265,3.555),(9.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.555),(9.455,3.725),(9.625,3.725),(9.625,3.555),(9.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.915),(8.375,4.085),(8.545,4.085),(8.545,3.915),(8.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.915),(8.735,4.085),(8.905,4.085),(8.905,3.915),(8.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.915),(9.095,4.085),(9.265,4.085),(9.265,3.915),(9.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.915),(9.455,4.085),(9.625,4.085),(9.625,3.915),(9.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.275),(8.375,4.445),(8.545,4.445),(8.545,4.275),(8.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.275),(8.735,4.445),(8.905,4.445),(8.905,4.275),(8.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.275),(9.095,4.445),(9.265,4.445),(9.265,4.275),(9.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.275),(9.455,4.445),(9.625,4.445),(9.625,4.275),(9.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.635),(8.375,4.805),(8.545,4.805),(8.545,4.635),(8.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.635),(8.735,4.805),(8.905,4.805),(8.905,4.635),(8.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.635),(9.095,4.805),(9.265,4.805),(9.265,4.635),(9.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.635),(9.455,4.805),(9.625,4.805),(9.625,4.635),(9.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.995),(8.375,5.165),(8.545,5.165),(8.545,4.995),(8.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.995),(8.735,5.165),(8.905,5.165),(8.905,4.995),(8.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.995),(9.095,5.165),(9.265,5.165),(9.265,4.995),(9.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.995),(9.455,5.165),(9.625,5.165),(9.625,4.995),(9.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.355),(8.375,5.525),(8.545,5.525),(8.545,5.355),(8.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.355),(8.735,5.525),(8.905,5.525),(8.905,5.355),(8.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.355),(9.095,5.525),(9.265,5.525),(9.265,5.355),(9.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.355),(9.455,5.525),(9.625,5.525),(9.625,5.355),(9.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.715),(8.375,5.885),(8.545,5.885),(8.545,5.715),(8.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.715),(8.735,5.885),(8.905,5.885),(8.905,5.715),(8.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.715),(9.095,5.885),(9.265,5.885),(9.265,5.715),(9.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.715),(9.455,5.885),(9.625,5.885),(9.625,5.715),(9.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.075),(8.375,6.245),(8.545,6.245),(8.545,6.075),(8.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.075),(8.735,6.245),(8.905,6.245),(8.905,6.075),(8.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.075),(9.095,6.245),(9.265,6.245),(9.265,6.075),(9.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.075),(9.455,6.245),(9.625,6.245),(9.625,6.075),(9.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.435),(8.375,6.605),(8.545,6.605),(8.545,6.435),(8.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.435),(8.735,6.605),(8.905,6.605),(8.905,6.435),(8.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.435),(9.095,6.605),(9.265,6.605),(9.265,6.435),(9.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.435),(9.455,6.605),(9.625,6.605),(9.625,6.435),(9.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.795),(8.375,6.965),(8.545,6.965),(8.545,6.795),(8.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.795),(8.735,6.965),(8.905,6.965),(8.905,6.795),(8.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.795),(9.095,6.965),(9.265,6.965),(9.265,6.795),(9.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.795),(9.455,6.965),(9.625,6.965),(9.625,6.795),(9.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.155),(8.375,7.325),(8.545,7.325),(8.545,7.155),(8.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.155),(8.735,7.325),(8.905,7.325),(8.905,7.155),(8.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.155),(9.095,7.325),(9.265,7.325),(9.265,7.155),(9.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.155),(9.455,7.325),(9.625,7.325),(9.625,7.155),(9.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.515),(8.375,7.685),(8.545,7.685),(8.545,7.515),(8.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.515),(8.735,7.685),(8.905,7.685),(8.905,7.515),(8.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.515),(9.095,7.685),(9.265,7.685),(9.265,7.515),(9.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.515),(9.455,7.685),(9.625,7.685),(9.625,7.515),(9.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.875),(8.375,8.045),(8.545,8.045),(8.545,7.875),(8.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.875),(8.735,8.045),(8.905,8.045),(8.905,7.875),(8.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.875),(9.095,8.045),(9.265,8.045),(9.265,7.875),(9.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.875),(9.455,8.045),(9.625,8.045),(9.625,7.875),(9.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.235),(8.375,8.405),(8.545,8.405),(8.545,8.235),(8.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.235),(8.735,8.405),(8.905,8.405),(8.905,8.235),(8.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.235),(9.095,8.405),(9.265,8.405),(9.265,8.235),(9.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.235),(9.455,8.405),(9.625,8.405),(9.625,8.235),(9.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.595),(8.375,8.765),(8.545,8.765),(8.545,8.595),(8.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.595),(8.735,8.765),(8.905,8.765),(8.905,8.595),(8.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.595),(9.095,8.765),(9.265,8.765),(9.265,8.595),(9.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.595),(9.455,8.765),(9.625,8.765),(9.625,8.595),(9.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.955),(8.375,9.125),(8.545,9.125),(8.545,8.955),(8.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.955),(8.735,9.125),(8.905,9.125),(8.905,8.955),(8.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.955),(9.095,9.125),(9.265,9.125),(9.265,8.955),(9.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.955),(9.455,9.125),(9.625,9.125),(9.625,8.955),(9.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.315),(8.375,9.485),(8.545,9.485),(8.545,9.315),(8.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.315),(8.735,9.485),(8.905,9.485),(8.905,9.315),(8.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.315),(9.095,9.485),(9.265,9.485),(9.265,9.315),(9.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.315),(9.455,9.485),(9.625,9.485),(9.625,9.315),(9.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.675),(8.375,9.845),(8.545,9.845),(8.545,9.675),(8.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.675),(8.735,9.845),(8.905,9.845),(8.905,9.675),(8.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.675),(9.095,9.845),(9.265,9.845),(9.265,9.675),(9.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.675),(9.455,9.845),(9.625,9.845),(9.625,9.675),(9.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.035),(8.375,10.205),(8.545,10.205),(8.545,10.035),(8.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.035),(8.735,10.205),(8.905,10.205),(8.905,10.035),(8.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.035),(9.095,10.205),(9.265,10.205),(9.265,10.035),(9.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.035),(9.455,10.205),(9.625,10.205),(9.625,10.035),(9.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.395),(8.375,10.565),(8.545,10.565),(8.545,10.395),(8.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.395),(8.735,10.565),(8.905,10.565),(8.905,10.395),(8.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.395),(9.095,10.565),(9.265,10.565),(9.265,10.395),(9.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.395),(9.455,10.565),(9.625,10.565),(9.625,10.395),(9.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.755),(8.375,10.925),(8.545,10.925),(8.545,10.755),(8.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.755),(8.735,10.925),(8.905,10.925),(8.905,10.755),(8.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.755),(9.095,10.925),(9.265,10.925),(9.265,10.755),(9.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.755),(9.455,10.925),(9.625,10.925),(9.625,10.755),(9.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.115),(8.375,11.285),(8.545,11.285),(8.545,11.115),(8.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.115),(8.735,11.285),(8.905,11.285),(8.905,11.115),(8.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.115),(9.095,11.285),(9.265,11.285),(9.265,11.115),(9.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.115),(9.455,11.285),(9.625,11.285),(9.625,11.115),(9.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.475),(8.375,11.645),(8.545,11.645),(8.545,11.475),(8.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.475),(8.735,11.645),(8.905,11.645),(8.905,11.475),(8.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.475),(9.095,11.645),(9.265,11.645),(9.265,11.475),(9.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.475),(9.455,11.645),(9.625,11.645),(9.625,11.475),(9.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.835),(8.375,12.005),(8.545,12.005),(8.545,11.835),(8.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.835),(8.735,12.005),(8.905,12.005),(8.905,11.835),(8.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.835),(9.095,12.005),(9.265,12.005),(9.265,11.835),(9.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.835),(9.455,12.005),(9.625,12.005),(9.625,11.835),(9.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.195),(8.375,12.365),(8.545,12.365),(8.545,12.195),(8.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.195),(8.735,12.365),(8.905,12.365),(8.905,12.195),(8.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.195),(9.095,12.365),(9.265,12.365),(9.265,12.195),(9.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.195),(9.455,12.365),(9.625,12.365),(9.625,12.195),(9.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.555),(8.375,12.725),(8.545,12.725),(8.545,12.555),(8.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.555),(8.735,12.725),(8.905,12.725),(8.905,12.555),(8.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.555),(9.095,12.725),(9.265,12.725),(9.265,12.555),(9.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.555),(9.455,12.725),(9.625,12.725),(9.625,12.555),(9.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.915),(8.375,13.085),(8.545,13.085),(8.545,12.915),(8.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.915),(8.735,13.085),(8.905,13.085),(8.905,12.915),(8.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.915),(9.095,13.085),(9.265,13.085),(9.265,12.915),(9.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.915),(9.455,13.085),(9.625,13.085),(9.625,12.915),(9.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.275),(8.375,13.445),(8.545,13.445),(8.545,13.275),(8.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.275),(8.735,13.445),(8.905,13.445),(8.905,13.275),(8.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.275),(9.095,13.445),(9.265,13.445),(9.265,13.275),(9.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.275),(9.455,13.445),(9.625,13.445),(9.625,13.275),(9.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.635),(8.375,13.805),(8.545,13.805),(8.545,13.635),(8.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.635),(8.735,13.805),(8.905,13.805),(8.905,13.635),(8.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.635),(9.095,13.805),(9.265,13.805),(9.265,13.635),(9.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.635),(9.455,13.805),(9.625,13.805),(9.625,13.635),(9.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.995),(8.375,14.165),(8.545,14.165),(8.545,13.995),(8.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.995),(8.735,14.165),(8.905,14.165),(8.905,13.995),(8.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.995),(9.095,14.165),(9.265,14.165),(9.265,13.995),(9.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.995),(9.455,14.165),(9.625,14.165),(9.625,13.995),(9.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.355),(8.375,14.525),(8.545,14.525),(8.545,14.355),(8.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.355),(8.735,14.525),(8.905,14.525),(8.905,14.355),(8.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.355),(9.095,14.525),(9.265,14.525),(9.265,14.355),(9.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.355),(9.455,14.525),(9.625,14.525),(9.625,14.355),(9.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.715),(8.375,14.885),(8.545,14.885),(8.545,14.715),(8.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.715),(8.735,14.885),(8.905,14.885),(8.905,14.715),(8.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.715),(9.095,14.885),(9.265,14.885),(9.265,14.715),(9.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.715),(9.455,14.885),(9.625,14.885),(9.625,14.715),(9.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.075),(8.375,15.245),(8.545,15.245),(8.545,15.075),(8.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.075),(8.735,15.245),(8.905,15.245),(8.905,15.075),(8.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.075),(9.095,15.245),(9.265,15.245),(9.265,15.075),(9.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.075),(9.455,15.245),(9.625,15.245),(9.625,15.075),(9.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.435),(8.375,15.605),(8.545,15.605),(8.545,15.435),(8.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.435),(8.735,15.605),(8.905,15.605),(8.905,15.435),(8.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.435),(9.095,15.605),(9.265,15.605),(9.265,15.435),(9.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.435),(9.455,15.605),(9.625,15.605),(9.625,15.435),(9.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.795),(8.375,15.965),(8.545,15.965),(8.545,15.795),(8.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.795),(8.735,15.965),(8.905,15.965),(8.905,15.795),(8.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.795),(9.095,15.965),(9.265,15.965),(9.265,15.795),(9.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.795),(9.455,15.965),(9.625,15.965),(9.625,15.795),(9.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.155),(8.375,16.325),(8.545,16.325),(8.545,16.155),(8.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.155),(8.735,16.325),(8.905,16.325),(8.905,16.155),(8.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.155),(9.095,16.325),(9.265,16.325),(9.265,16.155),(9.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.155),(9.455,16.325),(9.625,16.325),(9.625,16.155),(9.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.515),(8.375,16.685),(8.545,16.685),(8.545,16.515),(8.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.515),(8.735,16.685),(8.905,16.685),(8.905,16.515),(8.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.515),(9.095,16.685),(9.265,16.685),(9.265,16.515),(9.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.515),(9.455,16.685),(9.625,16.685),(9.625,16.515),(9.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.875),(8.375,17.045),(8.545,17.045),(8.545,16.875),(8.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.875),(8.735,17.045),(8.905,17.045),(8.905,16.875),(8.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.875),(9.095,17.045),(9.265,17.045),(9.265,16.875),(9.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.875),(9.455,17.045),(9.625,17.045),(9.625,16.875),(9.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.235),(8.375,17.405),(8.545,17.405),(8.545,17.235),(8.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.235),(8.735,17.405),(8.905,17.405),(8.905,17.235),(8.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.235),(9.095,17.405),(9.265,17.405),(9.265,17.235),(9.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.235),(9.455,17.405),(9.625,17.405),(9.625,17.235),(9.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.595),(8.375,17.765),(8.545,17.765),(8.545,17.595),(8.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.595),(8.735,17.765),(8.905,17.765),(8.905,17.595),(8.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.595),(9.095,17.765),(9.265,17.765),(9.265,17.595),(9.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.595),(9.455,17.765),(9.625,17.765),(9.625,17.595),(9.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.955),(8.375,18.125),(8.545,18.125),(8.545,17.955),(8.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.955),(8.735,18.125),(8.905,18.125),(8.905,17.955),(8.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.955),(9.095,18.125),(9.265,18.125),(9.265,17.955),(9.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.955),(9.455,18.125),(9.625,18.125),(9.625,17.955),(9.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.315),(8.375,18.485),(8.545,18.485),(8.545,18.315),(8.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.315),(8.735,18.485),(8.905,18.485),(8.905,18.315),(8.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.315),(9.095,18.485),(9.265,18.485),(9.265,18.315),(9.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.315),(9.455,18.485),(9.625,18.485),(9.625,18.315),(9.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.675),(8.375,18.845),(8.545,18.845),(8.545,18.675),(8.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.675),(8.735,18.845),(8.905,18.845),(8.905,18.675),(8.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.675),(9.095,18.845),(9.265,18.845),(9.265,18.675),(9.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.675),(9.455,18.845),(9.625,18.845),(9.625,18.675),(9.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.035),(8.375,19.205),(8.545,19.205),(8.545,19.035),(8.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.035),(8.735,19.205),(8.905,19.205),(8.905,19.035),(8.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.035),(9.095,19.205),(9.265,19.205),(9.265,19.035),(9.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.035),(9.455,19.205),(9.625,19.205),(9.625,19.035),(9.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.395),(8.375,19.565),(8.545,19.565),(8.545,19.395),(8.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.395),(8.735,19.565),(8.905,19.565),(8.905,19.395),(8.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.395),(9.095,19.565),(9.265,19.565),(9.265,19.395),(9.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.395),(9.455,19.565),(9.625,19.565),(9.625,19.395),(9.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.755),(8.375,19.925),(8.545,19.925),(8.545,19.755),(8.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.755),(8.735,19.925),(8.905,19.925),(8.905,19.755),(8.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.755),(9.095,19.925),(9.265,19.925),(9.265,19.755),(9.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.755),(9.455,19.925),(9.625,19.925),(9.625,19.755),(9.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,20.115),(8.375,20.285),(8.545,20.285),(8.545,20.115),(8.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,20.115),(8.735,20.285),(8.905,20.285),(8.905,20.115),(8.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,20.115),(9.095,20.285),(9.265,20.285),(9.265,20.115),(9.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,20.115),(9.455,20.285),(9.625,20.285),(9.625,20.115),(9.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,20.475),(8.375,20.645),(8.545,20.645),(8.545,20.475),(8.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,20.475),(8.735,20.645),(8.905,20.645),(8.905,20.475),(8.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,20.475),(9.095,20.645),(9.265,20.645),(9.265,20.475),(9.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,20.475),(9.455,20.645),(9.625,20.645),(9.625,20.475),(9.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,20.835),(8.375,21.005),(8.545,21.005),(8.545,20.835),(8.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,20.835),(8.735,21.005),(8.905,21.005),(8.905,20.835),(8.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,20.835),(9.095,21.005),(9.265,21.005),(9.265,20.835),(9.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,20.835),(9.455,21.005),(9.625,21.005),(9.625,20.835),(9.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,21.195),(8.375,21.365),(8.545,21.365),(8.545,21.195),(8.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,21.195),(8.735,21.365),(8.905,21.365),(8.905,21.195),(8.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,21.195),(9.095,21.365),(9.265,21.365),(9.265,21.195),(9.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,21.195),(9.455,21.365),(9.625,21.365),(9.625,21.195),(9.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,21.555),(8.375,21.725),(8.545,21.725),(8.545,21.555),(8.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,21.555),(8.735,21.725),(8.905,21.725),(8.905,21.555),(8.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,21.555),(9.095,21.725),(9.265,21.725),(9.265,21.555),(9.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,21.555),(9.455,21.725),(9.625,21.725),(9.625,21.555),(9.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,21.915),(8.375,22.085),(8.545,22.085),(8.545,21.915),(8.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,21.915),(8.735,22.085),(8.905,22.085),(8.905,21.915),(8.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,21.915),(9.095,22.085),(9.265,22.085),(9.265,21.915),(9.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,21.915),(9.455,22.085),(9.625,22.085),(9.625,21.915),(9.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.275),(8.375,22.445),(8.545,22.445),(8.545,22.275),(8.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.275),(8.735,22.445),(8.905,22.445),(8.905,22.275),(8.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.275),(9.095,22.445),(9.265,22.445),(9.265,22.275),(9.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.275),(9.455,22.445),(9.625,22.445),(9.625,22.275),(9.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.635),(8.375,22.805),(8.545,22.805),(8.545,22.635),(8.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.635),(8.735,22.805),(8.905,22.805),(8.905,22.635),(8.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.635),(9.095,22.805),(9.265,22.805),(9.265,22.635),(9.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.635),(9.455,22.805),(9.625,22.805),(9.625,22.635),(9.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.995),(8.375,23.165),(8.545,23.165),(8.545,22.995),(8.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.995),(8.735,23.165),(8.905,23.165),(8.905,22.995),(8.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.995),(9.095,23.165),(9.265,23.165),(9.265,22.995),(9.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.995),(9.455,23.165),(9.625,23.165),(9.625,22.995),(9.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,23.355),(8.375,23.525),(8.545,23.525),(8.545,23.355),(8.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,23.355),(8.735,23.525),(8.905,23.525),(8.905,23.355),(8.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,23.355),(9.095,23.525),(9.265,23.525),(9.265,23.355),(9.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,23.355),(9.455,23.525),(9.625,23.525),(9.625,23.355),(9.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,23.715),(8.375,23.885),(8.545,23.885),(8.545,23.715),(8.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,23.715),(8.735,23.885),(8.905,23.885),(8.905,23.715),(8.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,23.715),(9.095,23.885),(9.265,23.885),(9.265,23.715),(9.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,23.715),(9.455,23.885),(9.625,23.885),(9.625,23.715),(9.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,24.075),(8.375,24.245),(8.545,24.245),(8.545,24.075),(8.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,24.075),(8.735,24.245),(8.905,24.245),(8.905,24.075),(8.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,24.075),(9.095,24.245),(9.265,24.245),(9.265,24.075),(9.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,24.075),(9.455,24.245),(9.625,24.245),(9.625,24.075),(9.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,24.435),(8.375,24.605),(8.545,24.605),(8.545,24.435),(8.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,24.435),(8.735,24.605),(8.905,24.605),(8.905,24.435),(8.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,24.435),(9.095,24.605),(9.265,24.605),(9.265,24.435),(9.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,24.435),(9.455,24.605),(9.625,24.605),(9.625,24.435),(9.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,24.795),(8.375,24.965),(8.545,24.965),(8.545,24.795),(8.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,24.795),(8.735,24.965),(8.905,24.965),(8.905,24.795),(8.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,24.795),(9.095,24.965),(9.265,24.965),(9.265,24.795),(9.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,24.795),(9.455,24.965),(9.625,24.965),(9.625,24.795),(9.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,25.155),(8.375,25.325),(8.545,25.325),(8.545,25.155),(8.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,25.155),(8.735,25.325),(8.905,25.325),(8.905,25.155),(8.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,25.155),(9.095,25.325),(9.265,25.325),(9.265,25.155),(9.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,25.155),(9.455,25.325),(9.625,25.325),(9.625,25.155),(9.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,25.515),(8.375,25.685),(8.545,25.685),(8.545,25.515),(8.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,25.515),(8.735,25.685),(8.905,25.685),(8.905,25.515),(8.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,25.515),(9.095,25.685),(9.265,25.685),(9.265,25.515),(9.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,25.515),(9.455,25.685),(9.625,25.685),(9.625,25.515),(9.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,25.875),(8.375,26.045),(8.545,26.045),(8.545,25.875),(8.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,25.875),(8.735,26.045),(8.905,26.045),(8.905,25.875),(8.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,25.875),(9.095,26.045),(9.265,26.045),(9.265,25.875),(9.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,25.875),(9.455,26.045),(9.625,26.045),(9.625,25.875),(9.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,26.235),(8.375,26.405),(8.545,26.405),(8.545,26.235),(8.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,26.235),(8.735,26.405),(8.905,26.405),(8.905,26.235),(8.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,26.235),(9.095,26.405),(9.265,26.405),(9.265,26.235),(9.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,26.235),(9.455,26.405),(9.625,26.405),(9.625,26.235),(9.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,26.595),(8.375,26.765),(8.545,26.765),(8.545,26.595),(8.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,26.595),(8.735,26.765),(8.905,26.765),(8.905,26.595),(8.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,26.595),(9.095,26.765),(9.265,26.765),(9.265,26.595),(9.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,26.595),(9.455,26.765),(9.625,26.765),(9.625,26.595),(9.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,26.955),(8.375,27.125),(8.545,27.125),(8.545,26.955),(8.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,26.955),(8.735,27.125),(8.905,27.125),(8.905,26.955),(8.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,26.955),(9.095,27.125),(9.265,27.125),(9.265,26.955),(9.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,26.955),(9.455,27.125),(9.625,27.125),(9.625,26.955),(9.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,27.315),(8.375,27.485),(8.545,27.485),(8.545,27.315),(8.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,27.315),(8.735,27.485),(8.905,27.485),(8.905,27.315),(8.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,27.315),(9.095,27.485),(9.265,27.485),(9.265,27.315),(9.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,27.315),(9.455,27.485),(9.625,27.485),(9.625,27.315),(9.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,27.675),(8.375,27.845),(8.545,27.845),(8.545,27.675),(8.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,27.675),(8.735,27.845),(8.905,27.845),(8.905,27.675),(8.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,27.675),(9.095,27.845),(9.265,27.845),(9.265,27.675),(9.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,27.675),(9.455,27.845),(9.625,27.845),(9.625,27.675),(9.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,28.035),(8.375,28.205),(8.545,28.205),(8.545,28.035),(8.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,28.035),(8.735,28.205),(8.905,28.205),(8.905,28.035),(8.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,28.035),(9.095,28.205),(9.265,28.205),(9.265,28.035),(9.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,28.035),(9.455,28.205),(9.625,28.205),(9.625,28.035),(9.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,28.395),(8.375,28.565),(8.545,28.565),(8.545,28.395),(8.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,28.395),(8.735,28.565),(8.905,28.565),(8.905,28.395),(8.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,28.395),(9.095,28.565),(9.265,28.565),(9.265,28.395),(9.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,28.395),(9.455,28.565),(9.625,28.565),(9.625,28.395),(9.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,28.755),(8.375,28.925),(8.545,28.925),(8.545,28.755),(8.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,28.755),(8.735,28.925),(8.905,28.925),(8.905,28.755),(8.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,28.755),(9.095,28.925),(9.265,28.925),(9.265,28.755),(9.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,28.755),(9.455,28.925),(9.625,28.925),(9.625,28.755),(9.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,29.115),(8.375,29.285),(8.545,29.285),(8.545,29.115),(8.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,29.115),(8.735,29.285),(8.905,29.285),(8.905,29.115),(8.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,29.115),(9.095,29.285),(9.265,29.285),(9.265,29.115),(9.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,29.115),(9.455,29.285),(9.625,29.285),(9.625,29.115),(9.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,29.475),(8.375,29.645),(8.545,29.645),(8.545,29.475),(8.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,29.475),(8.735,29.645),(8.905,29.645),(8.905,29.475),(8.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,29.475),(9.095,29.645),(9.265,29.645),(9.265,29.475),(9.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,29.475),(9.455,29.645),(9.625,29.645),(9.625,29.475),(9.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,29.835),(8.375,30.005),(8.545,30.005),(8.545,29.835),(8.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,29.835),(8.735,30.005),(8.905,30.005),(8.905,29.835),(8.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,29.835),(9.095,30.005),(9.265,30.005),(9.265,29.835),(9.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,29.835),(9.455,30.005),(9.625,30.005),(9.625,29.835),(9.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,30.195),(8.375,30.365),(8.545,30.365),(8.545,30.195),(8.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,30.195),(8.735,30.365),(8.905,30.365),(8.905,30.195),(8.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,30.195),(9.095,30.365),(9.265,30.365),(9.265,30.195),(9.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,30.195),(9.455,30.365),(9.625,30.365),(9.625,30.195),(9.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,30.555),(8.375,30.725),(8.545,30.725),(8.545,30.555),(8.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,30.555),(8.735,30.725),(8.905,30.725),(8.905,30.555),(8.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,30.555),(9.095,30.725),(9.265,30.725),(9.265,30.555),(9.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,30.555),(9.455,30.725),(9.625,30.725),(9.625,30.555),(9.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,30.915),(8.375,31.085),(8.545,31.085),(8.545,30.915),(8.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,30.915),(8.735,31.085),(8.905,31.085),(8.905,30.915),(8.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,30.915),(9.095,31.085),(9.265,31.085),(9.265,30.915),(9.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,30.915),(9.455,31.085),(9.625,31.085),(9.625,30.915),(9.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,31.275),(8.375,31.445),(8.545,31.445),(8.545,31.275),(8.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,31.275),(8.735,31.445),(8.905,31.445),(8.905,31.275),(8.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,31.275),(9.095,31.445),(9.265,31.445),(9.265,31.275),(9.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,31.275),(9.455,31.445),(9.625,31.445),(9.625,31.275),(9.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,31.635),(8.375,31.805),(8.545,31.805),(8.545,31.635),(8.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,31.635),(8.735,31.805),(8.905,31.805),(8.905,31.635),(8.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,31.635),(9.095,31.805),(9.265,31.805),(9.265,31.635),(9.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,31.635),(9.455,31.805),(9.625,31.805),(9.625,31.635),(9.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,31.995),(8.375,32.165),(8.545,32.165),(8.545,31.995),(8.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,31.995),(8.735,32.165),(8.905,32.165),(8.905,31.995),(8.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,31.995),(9.095,32.165),(9.265,32.165),(9.265,31.995),(9.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,31.995),(9.455,32.165),(9.625,32.165),(9.625,31.995),(9.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,32.355),(8.375,32.525),(8.545,32.525),(8.545,32.355),(8.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,32.355),(8.735,32.525),(8.905,32.525),(8.905,32.355),(8.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,32.355),(9.095,32.525),(9.265,32.525),(9.265,32.355),(9.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,32.355),(9.455,32.525),(9.625,32.525),(9.625,32.355),(9.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,32.715),(8.375,32.885),(8.545,32.885),(8.545,32.715),(8.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,32.715),(8.735,32.885),(8.905,32.885),(8.905,32.715),(8.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,32.715),(9.095,32.885),(9.265,32.885),(9.265,32.715),(9.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,32.715),(9.455,32.885),(9.625,32.885),(9.625,32.715),(9.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,33.075),(8.375,33.245),(8.545,33.245),(8.545,33.075),(8.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,33.075),(8.735,33.245),(8.905,33.245),(8.905,33.075),(8.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,33.075),(9.095,33.245),(9.265,33.245),(9.265,33.075),(9.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,33.075),(9.455,33.245),(9.625,33.245),(9.625,33.075),(9.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,33.435),(8.375,33.605),(8.545,33.605),(8.545,33.435),(8.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,33.435),(8.735,33.605),(8.905,33.605),(8.905,33.435),(8.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,33.435),(9.095,33.605),(9.265,33.605),(9.265,33.435),(9.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,33.435),(9.455,33.605),(9.625,33.605),(9.625,33.435),(9.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,33.795),(8.375,33.965),(8.545,33.965),(8.545,33.795),(8.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,33.795),(8.735,33.965),(8.905,33.965),(8.905,33.795),(8.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,33.795),(9.095,33.965),(9.265,33.965),(9.265,33.795),(9.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,33.795),(9.455,33.965),(9.625,33.965),(9.625,33.795),(9.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,34.155),(8.375,34.325),(8.545,34.325),(8.545,34.155),(8.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,34.155),(8.735,34.325),(8.905,34.325),(8.905,34.155),(8.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,34.155),(9.095,34.325),(9.265,34.325),(9.265,34.155),(9.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,34.155),(9.455,34.325),(9.625,34.325),(9.625,34.155),(9.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,34.515),(8.375,34.685),(8.545,34.685),(8.545,34.515),(8.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,34.515),(8.735,34.685),(8.905,34.685),(8.905,34.515),(8.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,34.515),(9.095,34.685),(9.265,34.685),(9.265,34.515),(9.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,34.515),(9.455,34.685),(9.625,34.685),(9.625,34.515),(9.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,34.875),(8.375,35.045),(8.545,35.045),(8.545,34.875),(8.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,34.875),(8.735,35.045),(8.905,35.045),(8.905,34.875),(8.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,34.875),(9.095,35.045),(9.265,35.045),(9.265,34.875),(9.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,34.875),(9.455,35.045),(9.625,35.045),(9.625,34.875),(9.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,35.235),(8.375,35.405),(8.545,35.405),(8.545,35.235),(8.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,35.235),(8.735,35.405),(8.905,35.405),(8.905,35.235),(8.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,35.235),(9.095,35.405),(9.265,35.405),(9.265,35.235),(9.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,35.235),(9.455,35.405),(9.625,35.405),(9.625,35.235),(9.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,35.595),(8.375,35.765),(8.545,35.765),(8.545,35.595),(8.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,35.595),(8.735,35.765),(8.905,35.765),(8.905,35.595),(8.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,35.595),(9.095,35.765),(9.265,35.765),(9.265,35.595),(9.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,35.595),(9.455,35.765),(9.625,35.765),(9.625,35.595),(9.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,35.955),(8.375,36.125),(8.545,36.125),(8.545,35.955),(8.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,35.955),(8.735,36.125),(8.905,36.125),(8.905,35.955),(8.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,35.955),(9.095,36.125),(9.265,36.125),(9.265,35.955),(9.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,35.955),(9.455,36.125),(9.625,36.125),(9.625,35.955),(9.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,36.315),(8.375,36.485),(8.545,36.485),(8.545,36.315),(8.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,36.315),(8.735,36.485),(8.905,36.485),(8.905,36.315),(8.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,36.315),(9.095,36.485),(9.265,36.485),(9.265,36.315),(9.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,36.315),(9.455,36.485),(9.625,36.485),(9.625,36.315),(9.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,36.675),(8.375,36.845),(8.545,36.845),(8.545,36.675),(8.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,36.675),(8.735,36.845),(8.905,36.845),(8.905,36.675),(8.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,36.675),(9.095,36.845),(9.265,36.845),(9.265,36.675),(9.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,36.675),(9.455,36.845),(9.625,36.845),(9.625,36.675),(9.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,37.035),(8.375,37.205),(8.545,37.205),(8.545,37.035),(8.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,37.035),(8.735,37.205),(8.905,37.205),(8.905,37.035),(8.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,37.035),(9.095,37.205),(9.265,37.205),(9.265,37.035),(9.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,37.035),(9.455,37.205),(9.625,37.205),(9.625,37.035),(9.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,37.395),(8.375,37.565),(8.545,37.565),(8.545,37.395),(8.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,37.395),(8.735,37.565),(8.905,37.565),(8.905,37.395),(8.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,37.395),(9.095,37.565),(9.265,37.565),(9.265,37.395),(9.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,37.395),(9.455,37.565),(9.625,37.565),(9.625,37.395),(9.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,37.755),(8.375,37.925),(8.545,37.925),(8.545,37.755),(8.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,37.755),(8.735,37.925),(8.905,37.925),(8.905,37.755),(8.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,37.755),(9.095,37.925),(9.265,37.925),(9.265,37.755),(9.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,37.755),(9.455,37.925),(9.625,37.925),(9.625,37.755),(9.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,38.115),(8.375,38.285),(8.545,38.285),(8.545,38.115),(8.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,38.115),(8.735,38.285),(8.905,38.285),(8.905,38.115),(8.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,38.115),(9.095,38.285),(9.265,38.285),(9.265,38.115),(9.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,38.115),(9.455,38.285),(9.625,38.285),(9.625,38.115),(9.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,38.475),(8.375,38.645),(8.545,38.645),(8.545,38.475),(8.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,38.475),(8.735,38.645),(8.905,38.645),(8.905,38.475),(8.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,38.475),(9.095,38.645),(9.265,38.645),(9.265,38.475),(9.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,38.475),(9.455,38.645),(9.625,38.645),(9.625,38.475),(9.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,38.835),(8.375,39.005),(8.545,39.005),(8.545,38.835),(8.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,38.835),(8.735,39.005),(8.905,39.005),(8.905,38.835),(8.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,38.835),(9.095,39.005),(9.265,39.005),(9.265,38.835),(9.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,38.835),(9.455,39.005),(9.625,39.005),(9.625,38.835),(9.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,39.195),(8.375,39.365),(8.545,39.365),(8.545,39.195),(8.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,39.195),(8.735,39.365),(8.905,39.365),(8.905,39.195),(8.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,39.195),(9.095,39.365),(9.265,39.365),(9.265,39.195),(9.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,39.195),(9.455,39.365),(9.625,39.365),(9.625,39.195),(9.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,39.555),(8.375,39.725),(8.545,39.725),(8.545,39.555),(8.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,39.555),(8.735,39.725),(8.905,39.725),(8.905,39.555),(8.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,39.555),(9.095,39.725),(9.265,39.725),(9.265,39.555),(9.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,39.555),(9.455,39.725),(9.625,39.725),(9.625,39.555),(9.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,39.915),(8.375,40.085),(8.545,40.085),(8.545,39.915),(8.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,39.915),(8.735,40.085),(8.905,40.085),(8.905,39.915),(8.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,39.915),(9.095,40.085),(9.265,40.085),(9.265,39.915),(9.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,39.915),(9.455,40.085),(9.625,40.085),(9.625,39.915),(9.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,40.275),(8.375,40.445),(8.545,40.445),(8.545,40.275),(8.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,40.275),(8.735,40.445),(8.905,40.445),(8.905,40.275),(8.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,40.275),(9.095,40.445),(9.265,40.445),(9.265,40.275),(9.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,40.275),(9.455,40.445),(9.625,40.445),(9.625,40.275),(9.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,40.635),(8.375,40.805),(8.545,40.805),(8.545,40.635),(8.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,40.635),(8.735,40.805),(8.905,40.805),(8.905,40.635),(8.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,40.635),(9.095,40.805),(9.265,40.805),(9.265,40.635),(9.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,40.635),(9.455,40.805),(9.625,40.805),(9.625,40.635),(9.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,2.835),(65.975,3.005),(66.145,3.005),(66.145,2.835),(65.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,2.835),(66.335,3.005),(66.505,3.005),(66.505,2.835),(66.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,2.835),(66.695,3.005),(66.865,3.005),(66.865,2.835),(66.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,2.835),(67.055,3.005),(67.225,3.005),(67.225,2.835),(67.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.195),(65.975,3.365),(66.145,3.365),(66.145,3.195),(65.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.195),(66.335,3.365),(66.505,3.365),(66.505,3.195),(66.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.195),(66.695,3.365),(66.865,3.365),(66.865,3.195),(66.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.195),(67.055,3.365),(67.225,3.365),(67.225,3.195),(67.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.555),(65.975,3.725),(66.145,3.725),(66.145,3.555),(65.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.555),(66.335,3.725),(66.505,3.725),(66.505,3.555),(66.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.555),(66.695,3.725),(66.865,3.725),(66.865,3.555),(66.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.555),(67.055,3.725),(67.225,3.725),(67.225,3.555),(67.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.915),(65.975,4.085),(66.145,4.085),(66.145,3.915),(65.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.915),(66.335,4.085),(66.505,4.085),(66.505,3.915),(66.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.915),(66.695,4.085),(66.865,4.085),(66.865,3.915),(66.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.915),(67.055,4.085),(67.225,4.085),(67.225,3.915),(67.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.275),(65.975,4.445),(66.145,4.445),(66.145,4.275),(65.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.275),(66.335,4.445),(66.505,4.445),(66.505,4.275),(66.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.275),(66.695,4.445),(66.865,4.445),(66.865,4.275),(66.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.275),(67.055,4.445),(67.225,4.445),(67.225,4.275),(67.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.635),(65.975,4.805),(66.145,4.805),(66.145,4.635),(65.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.635),(66.335,4.805),(66.505,4.805),(66.505,4.635),(66.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.635),(66.695,4.805),(66.865,4.805),(66.865,4.635),(66.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.635),(67.055,4.805),(67.225,4.805),(67.225,4.635),(67.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.995),(65.975,5.165),(66.145,5.165),(66.145,4.995),(65.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.995),(66.335,5.165),(66.505,5.165),(66.505,4.995),(66.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.995),(66.695,5.165),(66.865,5.165),(66.865,4.995),(66.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.995),(67.055,5.165),(67.225,5.165),(67.225,4.995),(67.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.355),(65.975,5.525),(66.145,5.525),(66.145,5.355),(65.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.355),(66.335,5.525),(66.505,5.525),(66.505,5.355),(66.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.355),(66.695,5.525),(66.865,5.525),(66.865,5.355),(66.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.355),(67.055,5.525),(67.225,5.525),(67.225,5.355),(67.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.715),(65.975,5.885),(66.145,5.885),(66.145,5.715),(65.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.715),(66.335,5.885),(66.505,5.885),(66.505,5.715),(66.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.715),(66.695,5.885),(66.865,5.885),(66.865,5.715),(66.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.715),(67.055,5.885),(67.225,5.885),(67.225,5.715),(67.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.075),(65.975,6.245),(66.145,6.245),(66.145,6.075),(65.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.075),(66.335,6.245),(66.505,6.245),(66.505,6.075),(66.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.075),(66.695,6.245),(66.865,6.245),(66.865,6.075),(66.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.075),(67.055,6.245),(67.225,6.245),(67.225,6.075),(67.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.435),(65.975,6.605),(66.145,6.605),(66.145,6.435),(65.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.435),(66.335,6.605),(66.505,6.605),(66.505,6.435),(66.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.435),(66.695,6.605),(66.865,6.605),(66.865,6.435),(66.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.435),(67.055,6.605),(67.225,6.605),(67.225,6.435),(67.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.795),(65.975,6.965),(66.145,6.965),(66.145,6.795),(65.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.795),(66.335,6.965),(66.505,6.965),(66.505,6.795),(66.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.795),(66.695,6.965),(66.865,6.965),(66.865,6.795),(66.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.795),(67.055,6.965),(67.225,6.965),(67.225,6.795),(67.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.155),(65.975,7.325),(66.145,7.325),(66.145,7.155),(65.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.155),(66.335,7.325),(66.505,7.325),(66.505,7.155),(66.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.155),(66.695,7.325),(66.865,7.325),(66.865,7.155),(66.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.155),(67.055,7.325),(67.225,7.325),(67.225,7.155),(67.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.515),(65.975,7.685),(66.145,7.685),(66.145,7.515),(65.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.515),(66.335,7.685),(66.505,7.685),(66.505,7.515),(66.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.515),(66.695,7.685),(66.865,7.685),(66.865,7.515),(66.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.515),(67.055,7.685),(67.225,7.685),(67.225,7.515),(67.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.875),(65.975,8.045),(66.145,8.045),(66.145,7.875),(65.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.875),(66.335,8.045),(66.505,8.045),(66.505,7.875),(66.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.875),(66.695,8.045),(66.865,8.045),(66.865,7.875),(66.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.875),(67.055,8.045),(67.225,8.045),(67.225,7.875),(67.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.235),(65.975,8.405),(66.145,8.405),(66.145,8.235),(65.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.235),(66.335,8.405),(66.505,8.405),(66.505,8.235),(66.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.235),(66.695,8.405),(66.865,8.405),(66.865,8.235),(66.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.235),(67.055,8.405),(67.225,8.405),(67.225,8.235),(67.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.595),(65.975,8.765),(66.145,8.765),(66.145,8.595),(65.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.595),(66.335,8.765),(66.505,8.765),(66.505,8.595),(66.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.595),(66.695,8.765),(66.865,8.765),(66.865,8.595),(66.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.595),(67.055,8.765),(67.225,8.765),(67.225,8.595),(67.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.955),(65.975,9.125),(66.145,9.125),(66.145,8.955),(65.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.955),(66.335,9.125),(66.505,9.125),(66.505,8.955),(66.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.955),(66.695,9.125),(66.865,9.125),(66.865,8.955),(66.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.955),(67.055,9.125),(67.225,9.125),(67.225,8.955),(67.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.315),(65.975,9.485),(66.145,9.485),(66.145,9.315),(65.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.315),(66.335,9.485),(66.505,9.485),(66.505,9.315),(66.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.315),(66.695,9.485),(66.865,9.485),(66.865,9.315),(66.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.315),(67.055,9.485),(67.225,9.485),(67.225,9.315),(67.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.675),(65.975,9.845),(66.145,9.845),(66.145,9.675),(65.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.675),(66.335,9.845),(66.505,9.845),(66.505,9.675),(66.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.675),(66.695,9.845),(66.865,9.845),(66.865,9.675),(66.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.675),(67.055,9.845),(67.225,9.845),(67.225,9.675),(67.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.035),(65.975,10.205),(66.145,10.205),(66.145,10.035),(65.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.035),(66.335,10.205),(66.505,10.205),(66.505,10.035),(66.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.035),(66.695,10.205),(66.865,10.205),(66.865,10.035),(66.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.035),(67.055,10.205),(67.225,10.205),(67.225,10.035),(67.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.395),(65.975,10.565),(66.145,10.565),(66.145,10.395),(65.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.395),(66.335,10.565),(66.505,10.565),(66.505,10.395),(66.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.395),(66.695,10.565),(66.865,10.565),(66.865,10.395),(66.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.395),(67.055,10.565),(67.225,10.565),(67.225,10.395),(67.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.755),(65.975,10.925),(66.145,10.925),(66.145,10.755),(65.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.755),(66.335,10.925),(66.505,10.925),(66.505,10.755),(66.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.755),(66.695,10.925),(66.865,10.925),(66.865,10.755),(66.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.755),(67.055,10.925),(67.225,10.925),(67.225,10.755),(67.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.115),(65.975,11.285),(66.145,11.285),(66.145,11.115),(65.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.115),(66.335,11.285),(66.505,11.285),(66.505,11.115),(66.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.115),(66.695,11.285),(66.865,11.285),(66.865,11.115),(66.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.115),(67.055,11.285),(67.225,11.285),(67.225,11.115),(67.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.475),(65.975,11.645),(66.145,11.645),(66.145,11.475),(65.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.475),(66.335,11.645),(66.505,11.645),(66.505,11.475),(66.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.475),(66.695,11.645),(66.865,11.645),(66.865,11.475),(66.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.475),(67.055,11.645),(67.225,11.645),(67.225,11.475),(67.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.835),(65.975,12.005),(66.145,12.005),(66.145,11.835),(65.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.835),(66.335,12.005),(66.505,12.005),(66.505,11.835),(66.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.835),(66.695,12.005),(66.865,12.005),(66.865,11.835),(66.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.835),(67.055,12.005),(67.225,12.005),(67.225,11.835),(67.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.195),(65.975,12.365),(66.145,12.365),(66.145,12.195),(65.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.195),(66.335,12.365),(66.505,12.365),(66.505,12.195),(66.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.195),(66.695,12.365),(66.865,12.365),(66.865,12.195),(66.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.195),(67.055,12.365),(67.225,12.365),(67.225,12.195),(67.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.555),(65.975,12.725),(66.145,12.725),(66.145,12.555),(65.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.555),(66.335,12.725),(66.505,12.725),(66.505,12.555),(66.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.555),(66.695,12.725),(66.865,12.725),(66.865,12.555),(66.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.555),(67.055,12.725),(67.225,12.725),(67.225,12.555),(67.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.915),(65.975,13.085),(66.145,13.085),(66.145,12.915),(65.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.915),(66.335,13.085),(66.505,13.085),(66.505,12.915),(66.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.915),(66.695,13.085),(66.865,13.085),(66.865,12.915),(66.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.915),(67.055,13.085),(67.225,13.085),(67.225,12.915),(67.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.275),(65.975,13.445),(66.145,13.445),(66.145,13.275),(65.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.275),(66.335,13.445),(66.505,13.445),(66.505,13.275),(66.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.275),(66.695,13.445),(66.865,13.445),(66.865,13.275),(66.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.275),(67.055,13.445),(67.225,13.445),(67.225,13.275),(67.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.635),(65.975,13.805),(66.145,13.805),(66.145,13.635),(65.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.635),(66.335,13.805),(66.505,13.805),(66.505,13.635),(66.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.635),(66.695,13.805),(66.865,13.805),(66.865,13.635),(66.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.635),(67.055,13.805),(67.225,13.805),(67.225,13.635),(67.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.995),(65.975,14.165),(66.145,14.165),(66.145,13.995),(65.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.995),(66.335,14.165),(66.505,14.165),(66.505,13.995),(66.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.995),(66.695,14.165),(66.865,14.165),(66.865,13.995),(66.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.995),(67.055,14.165),(67.225,14.165),(67.225,13.995),(67.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.355),(65.975,14.525),(66.145,14.525),(66.145,14.355),(65.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.355),(66.335,14.525),(66.505,14.525),(66.505,14.355),(66.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.355),(66.695,14.525),(66.865,14.525),(66.865,14.355),(66.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.355),(67.055,14.525),(67.225,14.525),(67.225,14.355),(67.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.715),(65.975,14.885),(66.145,14.885),(66.145,14.715),(65.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.715),(66.335,14.885),(66.505,14.885),(66.505,14.715),(66.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.715),(66.695,14.885),(66.865,14.885),(66.865,14.715),(66.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.715),(67.055,14.885),(67.225,14.885),(67.225,14.715),(67.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.075),(65.975,15.245),(66.145,15.245),(66.145,15.075),(65.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.075),(66.335,15.245),(66.505,15.245),(66.505,15.075),(66.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.075),(66.695,15.245),(66.865,15.245),(66.865,15.075),(66.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.075),(67.055,15.245),(67.225,15.245),(67.225,15.075),(67.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.435),(65.975,15.605),(66.145,15.605),(66.145,15.435),(65.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.435),(66.335,15.605),(66.505,15.605),(66.505,15.435),(66.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.435),(66.695,15.605),(66.865,15.605),(66.865,15.435),(66.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.435),(67.055,15.605),(67.225,15.605),(67.225,15.435),(67.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.795),(65.975,15.965),(66.145,15.965),(66.145,15.795),(65.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.795),(66.335,15.965),(66.505,15.965),(66.505,15.795),(66.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.795),(66.695,15.965),(66.865,15.965),(66.865,15.795),(66.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.795),(67.055,15.965),(67.225,15.965),(67.225,15.795),(67.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.155),(65.975,16.325),(66.145,16.325),(66.145,16.155),(65.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.155),(66.335,16.325),(66.505,16.325),(66.505,16.155),(66.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.155),(66.695,16.325),(66.865,16.325),(66.865,16.155),(66.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.155),(67.055,16.325),(67.225,16.325),(67.225,16.155),(67.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.515),(65.975,16.685),(66.145,16.685),(66.145,16.515),(65.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.515),(66.335,16.685),(66.505,16.685),(66.505,16.515),(66.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.515),(66.695,16.685),(66.865,16.685),(66.865,16.515),(66.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.515),(67.055,16.685),(67.225,16.685),(67.225,16.515),(67.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.875),(65.975,17.045),(66.145,17.045),(66.145,16.875),(65.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.875),(66.335,17.045),(66.505,17.045),(66.505,16.875),(66.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.875),(66.695,17.045),(66.865,17.045),(66.865,16.875),(66.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.875),(67.055,17.045),(67.225,17.045),(67.225,16.875),(67.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.235),(65.975,17.405),(66.145,17.405),(66.145,17.235),(65.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.235),(66.335,17.405),(66.505,17.405),(66.505,17.235),(66.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.235),(66.695,17.405),(66.865,17.405),(66.865,17.235),(66.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.235),(67.055,17.405),(67.225,17.405),(67.225,17.235),(67.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.595),(65.975,17.765),(66.145,17.765),(66.145,17.595),(65.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.595),(66.335,17.765),(66.505,17.765),(66.505,17.595),(66.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.595),(66.695,17.765),(66.865,17.765),(66.865,17.595),(66.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.595),(67.055,17.765),(67.225,17.765),(67.225,17.595),(67.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.955),(65.975,18.125),(66.145,18.125),(66.145,17.955),(65.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.955),(66.335,18.125),(66.505,18.125),(66.505,17.955),(66.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.955),(66.695,18.125),(66.865,18.125),(66.865,17.955),(66.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.955),(67.055,18.125),(67.225,18.125),(67.225,17.955),(67.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.315),(65.975,18.485),(66.145,18.485),(66.145,18.315),(65.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.315),(66.335,18.485),(66.505,18.485),(66.505,18.315),(66.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.315),(66.695,18.485),(66.865,18.485),(66.865,18.315),(66.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.315),(67.055,18.485),(67.225,18.485),(67.225,18.315),(67.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.675),(65.975,18.845),(66.145,18.845),(66.145,18.675),(65.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.675),(66.335,18.845),(66.505,18.845),(66.505,18.675),(66.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.675),(66.695,18.845),(66.865,18.845),(66.865,18.675),(66.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.675),(67.055,18.845),(67.225,18.845),(67.225,18.675),(67.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.035),(65.975,19.205),(66.145,19.205),(66.145,19.035),(65.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.035),(66.335,19.205),(66.505,19.205),(66.505,19.035),(66.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.035),(66.695,19.205),(66.865,19.205),(66.865,19.035),(66.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.035),(67.055,19.205),(67.225,19.205),(67.225,19.035),(67.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.395),(65.975,19.565),(66.145,19.565),(66.145,19.395),(65.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.395),(66.335,19.565),(66.505,19.565),(66.505,19.395),(66.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.395),(66.695,19.565),(66.865,19.565),(66.865,19.395),(66.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.395),(67.055,19.565),(67.225,19.565),(67.225,19.395),(67.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.755),(65.975,19.925),(66.145,19.925),(66.145,19.755),(65.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.755),(66.335,19.925),(66.505,19.925),(66.505,19.755),(66.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.755),(66.695,19.925),(66.865,19.925),(66.865,19.755),(66.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.755),(67.055,19.925),(67.225,19.925),(67.225,19.755),(67.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,20.115),(65.975,20.285),(66.145,20.285),(66.145,20.115),(65.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,20.115),(66.335,20.285),(66.505,20.285),(66.505,20.115),(66.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,20.115),(66.695,20.285),(66.865,20.285),(66.865,20.115),(66.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,20.115),(67.055,20.285),(67.225,20.285),(67.225,20.115),(67.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,20.475),(65.975,20.645),(66.145,20.645),(66.145,20.475),(65.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,20.475),(66.335,20.645),(66.505,20.645),(66.505,20.475),(66.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,20.475),(66.695,20.645),(66.865,20.645),(66.865,20.475),(66.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,20.475),(67.055,20.645),(67.225,20.645),(67.225,20.475),(67.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,20.835),(65.975,21.005),(66.145,21.005),(66.145,20.835),(65.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,20.835),(66.335,21.005),(66.505,21.005),(66.505,20.835),(66.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,20.835),(66.695,21.005),(66.865,21.005),(66.865,20.835),(66.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,20.835),(67.055,21.005),(67.225,21.005),(67.225,20.835),(67.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,21.195),(65.975,21.365),(66.145,21.365),(66.145,21.195),(65.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,21.195),(66.335,21.365),(66.505,21.365),(66.505,21.195),(66.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,21.195),(66.695,21.365),(66.865,21.365),(66.865,21.195),(66.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,21.195),(67.055,21.365),(67.225,21.365),(67.225,21.195),(67.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,21.555),(65.975,21.725),(66.145,21.725),(66.145,21.555),(65.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,21.555),(66.335,21.725),(66.505,21.725),(66.505,21.555),(66.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,21.555),(66.695,21.725),(66.865,21.725),(66.865,21.555),(66.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,21.555),(67.055,21.725),(67.225,21.725),(67.225,21.555),(67.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,21.915),(65.975,22.085),(66.145,22.085),(66.145,21.915),(65.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,21.915),(66.335,22.085),(66.505,22.085),(66.505,21.915),(66.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,21.915),(66.695,22.085),(66.865,22.085),(66.865,21.915),(66.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,21.915),(67.055,22.085),(67.225,22.085),(67.225,21.915),(67.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.275),(65.975,22.445),(66.145,22.445),(66.145,22.275),(65.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.275),(66.335,22.445),(66.505,22.445),(66.505,22.275),(66.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.275),(66.695,22.445),(66.865,22.445),(66.865,22.275),(66.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.275),(67.055,22.445),(67.225,22.445),(67.225,22.275),(67.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.635),(65.975,22.805),(66.145,22.805),(66.145,22.635),(65.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.635),(66.335,22.805),(66.505,22.805),(66.505,22.635),(66.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.635),(66.695,22.805),(66.865,22.805),(66.865,22.635),(66.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.635),(67.055,22.805),(67.225,22.805),(67.225,22.635),(67.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.995),(65.975,23.165),(66.145,23.165),(66.145,22.995),(65.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.995),(66.335,23.165),(66.505,23.165),(66.505,22.995),(66.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.995),(66.695,23.165),(66.865,23.165),(66.865,22.995),(66.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.995),(67.055,23.165),(67.225,23.165),(67.225,22.995),(67.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,23.355),(65.975,23.525),(66.145,23.525),(66.145,23.355),(65.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,23.355),(66.335,23.525),(66.505,23.525),(66.505,23.355),(66.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,23.355),(66.695,23.525),(66.865,23.525),(66.865,23.355),(66.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,23.355),(67.055,23.525),(67.225,23.525),(67.225,23.355),(67.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,23.715),(65.975,23.885),(66.145,23.885),(66.145,23.715),(65.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,23.715),(66.335,23.885),(66.505,23.885),(66.505,23.715),(66.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,23.715),(66.695,23.885),(66.865,23.885),(66.865,23.715),(66.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,23.715),(67.055,23.885),(67.225,23.885),(67.225,23.715),(67.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,24.075),(65.975,24.245),(66.145,24.245),(66.145,24.075),(65.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,24.075),(66.335,24.245),(66.505,24.245),(66.505,24.075),(66.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,24.075),(66.695,24.245),(66.865,24.245),(66.865,24.075),(66.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,24.075),(67.055,24.245),(67.225,24.245),(67.225,24.075),(67.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,24.435),(65.975,24.605),(66.145,24.605),(66.145,24.435),(65.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,24.435),(66.335,24.605),(66.505,24.605),(66.505,24.435),(66.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,24.435),(66.695,24.605),(66.865,24.605),(66.865,24.435),(66.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,24.435),(67.055,24.605),(67.225,24.605),(67.225,24.435),(67.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,24.795),(65.975,24.965),(66.145,24.965),(66.145,24.795),(65.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,24.795),(66.335,24.965),(66.505,24.965),(66.505,24.795),(66.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,24.795),(66.695,24.965),(66.865,24.965),(66.865,24.795),(66.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,24.795),(67.055,24.965),(67.225,24.965),(67.225,24.795),(67.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,25.155),(65.975,25.325),(66.145,25.325),(66.145,25.155),(65.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,25.155),(66.335,25.325),(66.505,25.325),(66.505,25.155),(66.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,25.155),(66.695,25.325),(66.865,25.325),(66.865,25.155),(66.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,25.155),(67.055,25.325),(67.225,25.325),(67.225,25.155),(67.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,25.515),(65.975,25.685),(66.145,25.685),(66.145,25.515),(65.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,25.515),(66.335,25.685),(66.505,25.685),(66.505,25.515),(66.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,25.515),(66.695,25.685),(66.865,25.685),(66.865,25.515),(66.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,25.515),(67.055,25.685),(67.225,25.685),(67.225,25.515),(67.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,25.875),(65.975,26.045),(66.145,26.045),(66.145,25.875),(65.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,25.875),(66.335,26.045),(66.505,26.045),(66.505,25.875),(66.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,25.875),(66.695,26.045),(66.865,26.045),(66.865,25.875),(66.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,25.875),(67.055,26.045),(67.225,26.045),(67.225,25.875),(67.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,26.235),(65.975,26.405),(66.145,26.405),(66.145,26.235),(65.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,26.235),(66.335,26.405),(66.505,26.405),(66.505,26.235),(66.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,26.235),(66.695,26.405),(66.865,26.405),(66.865,26.235),(66.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,26.235),(67.055,26.405),(67.225,26.405),(67.225,26.235),(67.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,26.595),(65.975,26.765),(66.145,26.765),(66.145,26.595),(65.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,26.595),(66.335,26.765),(66.505,26.765),(66.505,26.595),(66.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,26.595),(66.695,26.765),(66.865,26.765),(66.865,26.595),(66.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,26.595),(67.055,26.765),(67.225,26.765),(67.225,26.595),(67.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,26.955),(65.975,27.125),(66.145,27.125),(66.145,26.955),(65.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,26.955),(66.335,27.125),(66.505,27.125),(66.505,26.955),(66.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,26.955),(66.695,27.125),(66.865,27.125),(66.865,26.955),(66.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,26.955),(67.055,27.125),(67.225,27.125),(67.225,26.955),(67.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,27.315),(65.975,27.485),(66.145,27.485),(66.145,27.315),(65.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,27.315),(66.335,27.485),(66.505,27.485),(66.505,27.315),(66.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,27.315),(66.695,27.485),(66.865,27.485),(66.865,27.315),(66.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,27.315),(67.055,27.485),(67.225,27.485),(67.225,27.315),(67.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,27.675),(65.975,27.845),(66.145,27.845),(66.145,27.675),(65.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,27.675),(66.335,27.845),(66.505,27.845),(66.505,27.675),(66.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,27.675),(66.695,27.845),(66.865,27.845),(66.865,27.675),(66.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,27.675),(67.055,27.845),(67.225,27.845),(67.225,27.675),(67.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,28.035),(65.975,28.205),(66.145,28.205),(66.145,28.035),(65.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,28.035),(66.335,28.205),(66.505,28.205),(66.505,28.035),(66.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,28.035),(66.695,28.205),(66.865,28.205),(66.865,28.035),(66.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,28.035),(67.055,28.205),(67.225,28.205),(67.225,28.035),(67.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,28.395),(65.975,28.565),(66.145,28.565),(66.145,28.395),(65.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,28.395),(66.335,28.565),(66.505,28.565),(66.505,28.395),(66.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,28.395),(66.695,28.565),(66.865,28.565),(66.865,28.395),(66.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,28.395),(67.055,28.565),(67.225,28.565),(67.225,28.395),(67.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,28.755),(65.975,28.925),(66.145,28.925),(66.145,28.755),(65.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,28.755),(66.335,28.925),(66.505,28.925),(66.505,28.755),(66.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,28.755),(66.695,28.925),(66.865,28.925),(66.865,28.755),(66.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,28.755),(67.055,28.925),(67.225,28.925),(67.225,28.755),(67.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,29.115),(65.975,29.285),(66.145,29.285),(66.145,29.115),(65.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,29.115),(66.335,29.285),(66.505,29.285),(66.505,29.115),(66.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,29.115),(66.695,29.285),(66.865,29.285),(66.865,29.115),(66.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,29.115),(67.055,29.285),(67.225,29.285),(67.225,29.115),(67.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,29.475),(65.975,29.645),(66.145,29.645),(66.145,29.475),(65.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,29.475),(66.335,29.645),(66.505,29.645),(66.505,29.475),(66.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,29.475),(66.695,29.645),(66.865,29.645),(66.865,29.475),(66.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,29.475),(67.055,29.645),(67.225,29.645),(67.225,29.475),(67.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,29.835),(65.975,30.005),(66.145,30.005),(66.145,29.835),(65.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,29.835),(66.335,30.005),(66.505,30.005),(66.505,29.835),(66.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,29.835),(66.695,30.005),(66.865,30.005),(66.865,29.835),(66.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,29.835),(67.055,30.005),(67.225,30.005),(67.225,29.835),(67.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,30.195),(65.975,30.365),(66.145,30.365),(66.145,30.195),(65.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,30.195),(66.335,30.365),(66.505,30.365),(66.505,30.195),(66.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,30.195),(66.695,30.365),(66.865,30.365),(66.865,30.195),(66.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,30.195),(67.055,30.365),(67.225,30.365),(67.225,30.195),(67.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,30.555),(65.975,30.725),(66.145,30.725),(66.145,30.555),(65.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,30.555),(66.335,30.725),(66.505,30.725),(66.505,30.555),(66.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,30.555),(66.695,30.725),(66.865,30.725),(66.865,30.555),(66.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,30.555),(67.055,30.725),(67.225,30.725),(67.225,30.555),(67.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,30.915),(65.975,31.085),(66.145,31.085),(66.145,30.915),(65.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,30.915),(66.335,31.085),(66.505,31.085),(66.505,30.915),(66.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,30.915),(66.695,31.085),(66.865,31.085),(66.865,30.915),(66.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,30.915),(67.055,31.085),(67.225,31.085),(67.225,30.915),(67.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,31.275),(65.975,31.445),(66.145,31.445),(66.145,31.275),(65.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,31.275),(66.335,31.445),(66.505,31.445),(66.505,31.275),(66.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,31.275),(66.695,31.445),(66.865,31.445),(66.865,31.275),(66.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,31.275),(67.055,31.445),(67.225,31.445),(67.225,31.275),(67.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,31.635),(65.975,31.805),(66.145,31.805),(66.145,31.635),(65.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,31.635),(66.335,31.805),(66.505,31.805),(66.505,31.635),(66.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,31.635),(66.695,31.805),(66.865,31.805),(66.865,31.635),(66.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,31.635),(67.055,31.805),(67.225,31.805),(67.225,31.635),(67.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,31.995),(65.975,32.165),(66.145,32.165),(66.145,31.995),(65.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,31.995),(66.335,32.165),(66.505,32.165),(66.505,31.995),(66.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,31.995),(66.695,32.165),(66.865,32.165),(66.865,31.995),(66.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,31.995),(67.055,32.165),(67.225,32.165),(67.225,31.995),(67.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,32.355),(65.975,32.525),(66.145,32.525),(66.145,32.355),(65.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,32.355),(66.335,32.525),(66.505,32.525),(66.505,32.355),(66.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,32.355),(66.695,32.525),(66.865,32.525),(66.865,32.355),(66.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,32.355),(67.055,32.525),(67.225,32.525),(67.225,32.355),(67.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,32.715),(65.975,32.885),(66.145,32.885),(66.145,32.715),(65.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,32.715),(66.335,32.885),(66.505,32.885),(66.505,32.715),(66.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,32.715),(66.695,32.885),(66.865,32.885),(66.865,32.715),(66.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,32.715),(67.055,32.885),(67.225,32.885),(67.225,32.715),(67.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,33.075),(65.975,33.245),(66.145,33.245),(66.145,33.075),(65.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,33.075),(66.335,33.245),(66.505,33.245),(66.505,33.075),(66.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,33.075),(66.695,33.245),(66.865,33.245),(66.865,33.075),(66.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,33.075),(67.055,33.245),(67.225,33.245),(67.225,33.075),(67.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,33.435),(65.975,33.605),(66.145,33.605),(66.145,33.435),(65.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,33.435),(66.335,33.605),(66.505,33.605),(66.505,33.435),(66.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,33.435),(66.695,33.605),(66.865,33.605),(66.865,33.435),(66.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,33.435),(67.055,33.605),(67.225,33.605),(67.225,33.435),(67.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,33.795),(65.975,33.965),(66.145,33.965),(66.145,33.795),(65.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,33.795),(66.335,33.965),(66.505,33.965),(66.505,33.795),(66.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,33.795),(66.695,33.965),(66.865,33.965),(66.865,33.795),(66.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,33.795),(67.055,33.965),(67.225,33.965),(67.225,33.795),(67.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,34.155),(65.975,34.325),(66.145,34.325),(66.145,34.155),(65.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,34.155),(66.335,34.325),(66.505,34.325),(66.505,34.155),(66.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,34.155),(66.695,34.325),(66.865,34.325),(66.865,34.155),(66.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,34.155),(67.055,34.325),(67.225,34.325),(67.225,34.155),(67.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,34.515),(65.975,34.685),(66.145,34.685),(66.145,34.515),(65.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,34.515),(66.335,34.685),(66.505,34.685),(66.505,34.515),(66.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,34.515),(66.695,34.685),(66.865,34.685),(66.865,34.515),(66.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,34.515),(67.055,34.685),(67.225,34.685),(67.225,34.515),(67.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,34.875),(65.975,35.045),(66.145,35.045),(66.145,34.875),(65.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,34.875),(66.335,35.045),(66.505,35.045),(66.505,34.875),(66.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,34.875),(66.695,35.045),(66.865,35.045),(66.865,34.875),(66.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,34.875),(67.055,35.045),(67.225,35.045),(67.225,34.875),(67.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,35.235),(65.975,35.405),(66.145,35.405),(66.145,35.235),(65.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,35.235),(66.335,35.405),(66.505,35.405),(66.505,35.235),(66.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,35.235),(66.695,35.405),(66.865,35.405),(66.865,35.235),(66.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,35.235),(67.055,35.405),(67.225,35.405),(67.225,35.235),(67.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,35.595),(65.975,35.765),(66.145,35.765),(66.145,35.595),(65.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,35.595),(66.335,35.765),(66.505,35.765),(66.505,35.595),(66.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,35.595),(66.695,35.765),(66.865,35.765),(66.865,35.595),(66.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,35.595),(67.055,35.765),(67.225,35.765),(67.225,35.595),(67.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,35.955),(65.975,36.125),(66.145,36.125),(66.145,35.955),(65.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,35.955),(66.335,36.125),(66.505,36.125),(66.505,35.955),(66.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,35.955),(66.695,36.125),(66.865,36.125),(66.865,35.955),(66.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,35.955),(67.055,36.125),(67.225,36.125),(67.225,35.955),(67.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,36.315),(65.975,36.485),(66.145,36.485),(66.145,36.315),(65.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,36.315),(66.335,36.485),(66.505,36.485),(66.505,36.315),(66.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,36.315),(66.695,36.485),(66.865,36.485),(66.865,36.315),(66.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,36.315),(67.055,36.485),(67.225,36.485),(67.225,36.315),(67.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,36.675),(65.975,36.845),(66.145,36.845),(66.145,36.675),(65.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,36.675),(66.335,36.845),(66.505,36.845),(66.505,36.675),(66.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,36.675),(66.695,36.845),(66.865,36.845),(66.865,36.675),(66.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,36.675),(67.055,36.845),(67.225,36.845),(67.225,36.675),(67.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,37.035),(65.975,37.205),(66.145,37.205),(66.145,37.035),(65.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,37.035),(66.335,37.205),(66.505,37.205),(66.505,37.035),(66.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,37.035),(66.695,37.205),(66.865,37.205),(66.865,37.035),(66.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,37.035),(67.055,37.205),(67.225,37.205),(67.225,37.035),(67.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,37.395),(65.975,37.565),(66.145,37.565),(66.145,37.395),(65.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,37.395),(66.335,37.565),(66.505,37.565),(66.505,37.395),(66.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,37.395),(66.695,37.565),(66.865,37.565),(66.865,37.395),(66.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,37.395),(67.055,37.565),(67.225,37.565),(67.225,37.395),(67.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,37.755),(65.975,37.925),(66.145,37.925),(66.145,37.755),(65.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,37.755),(66.335,37.925),(66.505,37.925),(66.505,37.755),(66.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,37.755),(66.695,37.925),(66.865,37.925),(66.865,37.755),(66.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,37.755),(67.055,37.925),(67.225,37.925),(67.225,37.755),(67.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,38.115),(65.975,38.285),(66.145,38.285),(66.145,38.115),(65.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,38.115),(66.335,38.285),(66.505,38.285),(66.505,38.115),(66.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,38.115),(66.695,38.285),(66.865,38.285),(66.865,38.115),(66.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,38.115),(67.055,38.285),(67.225,38.285),(67.225,38.115),(67.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,38.475),(65.975,38.645),(66.145,38.645),(66.145,38.475),(65.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,38.475),(66.335,38.645),(66.505,38.645),(66.505,38.475),(66.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,38.475),(66.695,38.645),(66.865,38.645),(66.865,38.475),(66.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,38.475),(67.055,38.645),(67.225,38.645),(67.225,38.475),(67.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,38.835),(65.975,39.005),(66.145,39.005),(66.145,38.835),(65.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,38.835),(66.335,39.005),(66.505,39.005),(66.505,38.835),(66.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,38.835),(66.695,39.005),(66.865,39.005),(66.865,38.835),(66.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,38.835),(67.055,39.005),(67.225,39.005),(67.225,38.835),(67.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,39.195),(65.975,39.365),(66.145,39.365),(66.145,39.195),(65.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,39.195),(66.335,39.365),(66.505,39.365),(66.505,39.195),(66.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,39.195),(66.695,39.365),(66.865,39.365),(66.865,39.195),(66.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,39.195),(67.055,39.365),(67.225,39.365),(67.225,39.195),(67.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,39.555),(65.975,39.725),(66.145,39.725),(66.145,39.555),(65.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,39.555),(66.335,39.725),(66.505,39.725),(66.505,39.555),(66.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,39.555),(66.695,39.725),(66.865,39.725),(66.865,39.555),(66.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,39.555),(67.055,39.725),(67.225,39.725),(67.225,39.555),(67.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,39.915),(65.975,40.085),(66.145,40.085),(66.145,39.915),(65.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,39.915),(66.335,40.085),(66.505,40.085),(66.505,39.915),(66.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,39.915),(66.695,40.085),(66.865,40.085),(66.865,39.915),(66.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,39.915),(67.055,40.085),(67.225,40.085),(67.225,39.915),(67.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,40.275),(65.975,40.445),(66.145,40.445),(66.145,40.275),(65.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,40.275),(66.335,40.445),(66.505,40.445),(66.505,40.275),(66.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,40.275),(66.695,40.445),(66.865,40.445),(66.865,40.275),(66.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,40.275),(67.055,40.445),(67.225,40.445),(67.225,40.275),(67.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,40.635),(65.975,40.805),(66.145,40.805),(66.145,40.635),(65.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,40.635),(66.335,40.805),(66.505,40.805),(66.505,40.635),(66.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,40.635),(66.695,40.805),(66.865,40.805),(66.865,40.635),(66.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,40.635),(67.055,40.805),(67.225,40.805),(67.225,40.635),(67.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.835),(51.575,3.005),(51.745,3.005),(51.745,2.835),(51.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.835),(51.935,3.005),(52.105,3.005),(52.105,2.835),(51.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.835),(52.295,3.005),(52.465,3.005),(52.465,2.835),(52.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.835),(52.655,3.005),(52.825,3.005),(52.825,2.835),(52.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.195),(51.575,3.365),(51.745,3.365),(51.745,3.195),(51.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.195),(51.935,3.365),(52.105,3.365),(52.105,3.195),(51.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.195),(52.295,3.365),(52.465,3.365),(52.465,3.195),(52.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.195),(52.655,3.365),(52.825,3.365),(52.825,3.195),(52.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.555),(51.575,3.725),(51.745,3.725),(51.745,3.555),(51.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.555),(51.935,3.725),(52.105,3.725),(52.105,3.555),(51.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.555),(52.295,3.725),(52.465,3.725),(52.465,3.555),(52.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.555),(52.655,3.725),(52.825,3.725),(52.825,3.555),(52.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.915),(51.575,4.085),(51.745,4.085),(51.745,3.915),(51.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.915),(51.935,4.085),(52.105,4.085),(52.105,3.915),(51.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.915),(52.295,4.085),(52.465,4.085),(52.465,3.915),(52.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.915),(52.655,4.085),(52.825,4.085),(52.825,3.915),(52.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.275),(51.575,4.445),(51.745,4.445),(51.745,4.275),(51.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.275),(51.935,4.445),(52.105,4.445),(52.105,4.275),(51.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.275),(52.295,4.445),(52.465,4.445),(52.465,4.275),(52.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.275),(52.655,4.445),(52.825,4.445),(52.825,4.275),(52.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.635),(51.575,4.805),(51.745,4.805),(51.745,4.635),(51.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.635),(51.935,4.805),(52.105,4.805),(52.105,4.635),(51.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.635),(52.295,4.805),(52.465,4.805),(52.465,4.635),(52.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.635),(52.655,4.805),(52.825,4.805),(52.825,4.635),(52.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.995),(51.575,5.165),(51.745,5.165),(51.745,4.995),(51.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.995),(51.935,5.165),(52.105,5.165),(52.105,4.995),(51.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.995),(52.295,5.165),(52.465,5.165),(52.465,4.995),(52.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.995),(52.655,5.165),(52.825,5.165),(52.825,4.995),(52.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.355),(51.575,5.525),(51.745,5.525),(51.745,5.355),(51.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.355),(51.935,5.525),(52.105,5.525),(52.105,5.355),(51.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.355),(52.295,5.525),(52.465,5.525),(52.465,5.355),(52.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.355),(52.655,5.525),(52.825,5.525),(52.825,5.355),(52.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.715),(51.575,5.885),(51.745,5.885),(51.745,5.715),(51.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.715),(51.935,5.885),(52.105,5.885),(52.105,5.715),(51.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.715),(52.295,5.885),(52.465,5.885),(52.465,5.715),(52.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.715),(52.655,5.885),(52.825,5.885),(52.825,5.715),(52.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.075),(51.575,6.245),(51.745,6.245),(51.745,6.075),(51.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.075),(51.935,6.245),(52.105,6.245),(52.105,6.075),(51.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.075),(52.295,6.245),(52.465,6.245),(52.465,6.075),(52.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.075),(52.655,6.245),(52.825,6.245),(52.825,6.075),(52.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.435),(51.575,6.605),(51.745,6.605),(51.745,6.435),(51.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.435),(51.935,6.605),(52.105,6.605),(52.105,6.435),(51.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.435),(52.295,6.605),(52.465,6.605),(52.465,6.435),(52.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.435),(52.655,6.605),(52.825,6.605),(52.825,6.435),(52.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.795),(51.575,6.965),(51.745,6.965),(51.745,6.795),(51.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.795),(51.935,6.965),(52.105,6.965),(52.105,6.795),(51.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.795),(52.295,6.965),(52.465,6.965),(52.465,6.795),(52.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.795),(52.655,6.965),(52.825,6.965),(52.825,6.795),(52.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.155),(51.575,7.325),(51.745,7.325),(51.745,7.155),(51.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.155),(51.935,7.325),(52.105,7.325),(52.105,7.155),(51.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.155),(52.295,7.325),(52.465,7.325),(52.465,7.155),(52.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.155),(52.655,7.325),(52.825,7.325),(52.825,7.155),(52.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.515),(51.575,7.685),(51.745,7.685),(51.745,7.515),(51.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.515),(51.935,7.685),(52.105,7.685),(52.105,7.515),(51.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.515),(52.295,7.685),(52.465,7.685),(52.465,7.515),(52.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.515),(52.655,7.685),(52.825,7.685),(52.825,7.515),(52.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.875),(51.575,8.045),(51.745,8.045),(51.745,7.875),(51.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.875),(51.935,8.045),(52.105,8.045),(52.105,7.875),(51.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.875),(52.295,8.045),(52.465,8.045),(52.465,7.875),(52.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.875),(52.655,8.045),(52.825,8.045),(52.825,7.875),(52.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.235),(51.575,8.405),(51.745,8.405),(51.745,8.235),(51.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.235),(51.935,8.405),(52.105,8.405),(52.105,8.235),(51.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.235),(52.295,8.405),(52.465,8.405),(52.465,8.235),(52.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.235),(52.655,8.405),(52.825,8.405),(52.825,8.235),(52.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.595),(51.575,8.765),(51.745,8.765),(51.745,8.595),(51.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.595),(51.935,8.765),(52.105,8.765),(52.105,8.595),(51.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.595),(52.295,8.765),(52.465,8.765),(52.465,8.595),(52.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.595),(52.655,8.765),(52.825,8.765),(52.825,8.595),(52.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.955),(51.575,9.125),(51.745,9.125),(51.745,8.955),(51.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.955),(51.935,9.125),(52.105,9.125),(52.105,8.955),(51.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.955),(52.295,9.125),(52.465,9.125),(52.465,8.955),(52.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.955),(52.655,9.125),(52.825,9.125),(52.825,8.955),(52.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.315),(51.575,9.485),(51.745,9.485),(51.745,9.315),(51.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.315),(51.935,9.485),(52.105,9.485),(52.105,9.315),(51.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.315),(52.295,9.485),(52.465,9.485),(52.465,9.315),(52.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.315),(52.655,9.485),(52.825,9.485),(52.825,9.315),(52.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.675),(51.575,9.845),(51.745,9.845),(51.745,9.675),(51.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.675),(51.935,9.845),(52.105,9.845),(52.105,9.675),(51.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.675),(52.295,9.845),(52.465,9.845),(52.465,9.675),(52.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.675),(52.655,9.845),(52.825,9.845),(52.825,9.675),(52.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.035),(51.575,10.205),(51.745,10.205),(51.745,10.035),(51.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.035),(51.935,10.205),(52.105,10.205),(52.105,10.035),(51.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.035),(52.295,10.205),(52.465,10.205),(52.465,10.035),(52.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.035),(52.655,10.205),(52.825,10.205),(52.825,10.035),(52.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.395),(51.575,10.565),(51.745,10.565),(51.745,10.395),(51.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.395),(51.935,10.565),(52.105,10.565),(52.105,10.395),(51.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.395),(52.295,10.565),(52.465,10.565),(52.465,10.395),(52.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.395),(52.655,10.565),(52.825,10.565),(52.825,10.395),(52.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.755),(51.575,10.925),(51.745,10.925),(51.745,10.755),(51.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.755),(51.935,10.925),(52.105,10.925),(52.105,10.755),(51.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.755),(52.295,10.925),(52.465,10.925),(52.465,10.755),(52.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.755),(52.655,10.925),(52.825,10.925),(52.825,10.755),(52.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.115),(51.575,11.285),(51.745,11.285),(51.745,11.115),(51.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.115),(51.935,11.285),(52.105,11.285),(52.105,11.115),(51.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.115),(52.295,11.285),(52.465,11.285),(52.465,11.115),(52.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.115),(52.655,11.285),(52.825,11.285),(52.825,11.115),(52.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.475),(51.575,11.645),(51.745,11.645),(51.745,11.475),(51.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.475),(51.935,11.645),(52.105,11.645),(52.105,11.475),(51.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.475),(52.295,11.645),(52.465,11.645),(52.465,11.475),(52.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.475),(52.655,11.645),(52.825,11.645),(52.825,11.475),(52.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.835),(51.575,12.005),(51.745,12.005),(51.745,11.835),(51.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.835),(51.935,12.005),(52.105,12.005),(52.105,11.835),(51.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.835),(52.295,12.005),(52.465,12.005),(52.465,11.835),(52.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.835),(52.655,12.005),(52.825,12.005),(52.825,11.835),(52.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.195),(51.575,12.365),(51.745,12.365),(51.745,12.195),(51.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.195),(51.935,12.365),(52.105,12.365),(52.105,12.195),(51.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.195),(52.295,12.365),(52.465,12.365),(52.465,12.195),(52.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.195),(52.655,12.365),(52.825,12.365),(52.825,12.195),(52.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.555),(51.575,12.725),(51.745,12.725),(51.745,12.555),(51.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.555),(51.935,12.725),(52.105,12.725),(52.105,12.555),(51.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.555),(52.295,12.725),(52.465,12.725),(52.465,12.555),(52.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.555),(52.655,12.725),(52.825,12.725),(52.825,12.555),(52.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.915),(51.575,13.085),(51.745,13.085),(51.745,12.915),(51.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.915),(51.935,13.085),(52.105,13.085),(52.105,12.915),(51.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.915),(52.295,13.085),(52.465,13.085),(52.465,12.915),(52.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.915),(52.655,13.085),(52.825,13.085),(52.825,12.915),(52.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.275),(51.575,13.445),(51.745,13.445),(51.745,13.275),(51.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.275),(51.935,13.445),(52.105,13.445),(52.105,13.275),(51.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.275),(52.295,13.445),(52.465,13.445),(52.465,13.275),(52.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.275),(52.655,13.445),(52.825,13.445),(52.825,13.275),(52.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.635),(51.575,13.805),(51.745,13.805),(51.745,13.635),(51.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.635),(51.935,13.805),(52.105,13.805),(52.105,13.635),(51.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.635),(52.295,13.805),(52.465,13.805),(52.465,13.635),(52.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.635),(52.655,13.805),(52.825,13.805),(52.825,13.635),(52.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.995),(51.575,14.165),(51.745,14.165),(51.745,13.995),(51.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.995),(51.935,14.165),(52.105,14.165),(52.105,13.995),(51.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.995),(52.295,14.165),(52.465,14.165),(52.465,13.995),(52.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.995),(52.655,14.165),(52.825,14.165),(52.825,13.995),(52.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.355),(51.575,14.525),(51.745,14.525),(51.745,14.355),(51.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.355),(51.935,14.525),(52.105,14.525),(52.105,14.355),(51.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.355),(52.295,14.525),(52.465,14.525),(52.465,14.355),(52.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.355),(52.655,14.525),(52.825,14.525),(52.825,14.355),(52.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.715),(51.575,14.885),(51.745,14.885),(51.745,14.715),(51.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.715),(51.935,14.885),(52.105,14.885),(52.105,14.715),(51.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.715),(52.295,14.885),(52.465,14.885),(52.465,14.715),(52.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.715),(52.655,14.885),(52.825,14.885),(52.825,14.715),(52.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.075),(51.575,15.245),(51.745,15.245),(51.745,15.075),(51.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.075),(51.935,15.245),(52.105,15.245),(52.105,15.075),(51.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.075),(52.295,15.245),(52.465,15.245),(52.465,15.075),(52.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.075),(52.655,15.245),(52.825,15.245),(52.825,15.075),(52.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.435),(51.575,15.605),(51.745,15.605),(51.745,15.435),(51.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.435),(51.935,15.605),(52.105,15.605),(52.105,15.435),(51.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.435),(52.295,15.605),(52.465,15.605),(52.465,15.435),(52.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.435),(52.655,15.605),(52.825,15.605),(52.825,15.435),(52.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.795),(51.575,15.965),(51.745,15.965),(51.745,15.795),(51.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.795),(51.935,15.965),(52.105,15.965),(52.105,15.795),(51.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.795),(52.295,15.965),(52.465,15.965),(52.465,15.795),(52.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.795),(52.655,15.965),(52.825,15.965),(52.825,15.795),(52.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.155),(51.575,16.325),(51.745,16.325),(51.745,16.155),(51.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.155),(51.935,16.325),(52.105,16.325),(52.105,16.155),(51.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.155),(52.295,16.325),(52.465,16.325),(52.465,16.155),(52.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.155),(52.655,16.325),(52.825,16.325),(52.825,16.155),(52.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.515),(51.575,16.685),(51.745,16.685),(51.745,16.515),(51.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.515),(51.935,16.685),(52.105,16.685),(52.105,16.515),(51.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.515),(52.295,16.685),(52.465,16.685),(52.465,16.515),(52.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.515),(52.655,16.685),(52.825,16.685),(52.825,16.515),(52.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.875),(51.575,17.045),(51.745,17.045),(51.745,16.875),(51.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.875),(51.935,17.045),(52.105,17.045),(52.105,16.875),(51.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.875),(52.295,17.045),(52.465,17.045),(52.465,16.875),(52.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.875),(52.655,17.045),(52.825,17.045),(52.825,16.875),(52.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.235),(51.575,17.405),(51.745,17.405),(51.745,17.235),(51.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.235),(51.935,17.405),(52.105,17.405),(52.105,17.235),(51.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.235),(52.295,17.405),(52.465,17.405),(52.465,17.235),(52.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.235),(52.655,17.405),(52.825,17.405),(52.825,17.235),(52.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.595),(51.575,17.765),(51.745,17.765),(51.745,17.595),(51.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.595),(51.935,17.765),(52.105,17.765),(52.105,17.595),(51.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.595),(52.295,17.765),(52.465,17.765),(52.465,17.595),(52.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.595),(52.655,17.765),(52.825,17.765),(52.825,17.595),(52.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.955),(51.575,18.125),(51.745,18.125),(51.745,17.955),(51.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.955),(51.935,18.125),(52.105,18.125),(52.105,17.955),(51.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.955),(52.295,18.125),(52.465,18.125),(52.465,17.955),(52.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.955),(52.655,18.125),(52.825,18.125),(52.825,17.955),(52.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.315),(51.575,18.485),(51.745,18.485),(51.745,18.315),(51.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.315),(51.935,18.485),(52.105,18.485),(52.105,18.315),(51.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.315),(52.295,18.485),(52.465,18.485),(52.465,18.315),(52.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.315),(52.655,18.485),(52.825,18.485),(52.825,18.315),(52.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.675),(51.575,18.845),(51.745,18.845),(51.745,18.675),(51.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.675),(51.935,18.845),(52.105,18.845),(52.105,18.675),(51.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.675),(52.295,18.845),(52.465,18.845),(52.465,18.675),(52.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.675),(52.655,18.845),(52.825,18.845),(52.825,18.675),(52.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.035),(51.575,19.205),(51.745,19.205),(51.745,19.035),(51.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.035),(51.935,19.205),(52.105,19.205),(52.105,19.035),(51.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.035),(52.295,19.205),(52.465,19.205),(52.465,19.035),(52.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.035),(52.655,19.205),(52.825,19.205),(52.825,19.035),(52.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.395),(51.575,19.565),(51.745,19.565),(51.745,19.395),(51.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.395),(51.935,19.565),(52.105,19.565),(52.105,19.395),(51.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.395),(52.295,19.565),(52.465,19.565),(52.465,19.395),(52.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.395),(52.655,19.565),(52.825,19.565),(52.825,19.395),(52.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.755),(51.575,19.925),(51.745,19.925),(51.745,19.755),(51.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.755),(51.935,19.925),(52.105,19.925),(52.105,19.755),(51.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.755),(52.295,19.925),(52.465,19.925),(52.465,19.755),(52.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.755),(52.655,19.925),(52.825,19.925),(52.825,19.755),(52.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.115),(51.575,20.285),(51.745,20.285),(51.745,20.115),(51.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.115),(51.935,20.285),(52.105,20.285),(52.105,20.115),(51.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.115),(52.295,20.285),(52.465,20.285),(52.465,20.115),(52.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.115),(52.655,20.285),(52.825,20.285),(52.825,20.115),(52.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.475),(51.575,20.645),(51.745,20.645),(51.745,20.475),(51.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.475),(51.935,20.645),(52.105,20.645),(52.105,20.475),(51.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.475),(52.295,20.645),(52.465,20.645),(52.465,20.475),(52.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.475),(52.655,20.645),(52.825,20.645),(52.825,20.475),(52.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.835),(51.575,21.005),(51.745,21.005),(51.745,20.835),(51.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.835),(51.935,21.005),(52.105,21.005),(52.105,20.835),(51.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.835),(52.295,21.005),(52.465,21.005),(52.465,20.835),(52.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.835),(52.655,21.005),(52.825,21.005),(52.825,20.835),(52.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.195),(51.575,21.365),(51.745,21.365),(51.745,21.195),(51.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.195),(51.935,21.365),(52.105,21.365),(52.105,21.195),(51.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.195),(52.295,21.365),(52.465,21.365),(52.465,21.195),(52.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.195),(52.655,21.365),(52.825,21.365),(52.825,21.195),(52.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.555),(51.575,21.725),(51.745,21.725),(51.745,21.555),(51.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.555),(51.935,21.725),(52.105,21.725),(52.105,21.555),(51.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.555),(52.295,21.725),(52.465,21.725),(52.465,21.555),(52.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.555),(52.655,21.725),(52.825,21.725),(52.825,21.555),(52.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.915),(51.575,22.085),(51.745,22.085),(51.745,21.915),(51.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.915),(51.935,22.085),(52.105,22.085),(52.105,21.915),(51.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.915),(52.295,22.085),(52.465,22.085),(52.465,21.915),(52.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.915),(52.655,22.085),(52.825,22.085),(52.825,21.915),(52.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.275),(51.575,22.445),(51.745,22.445),(51.745,22.275),(51.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.275),(51.935,22.445),(52.105,22.445),(52.105,22.275),(51.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.275),(52.295,22.445),(52.465,22.445),(52.465,22.275),(52.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.275),(52.655,22.445),(52.825,22.445),(52.825,22.275),(52.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.635),(51.575,22.805),(51.745,22.805),(51.745,22.635),(51.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.635),(51.935,22.805),(52.105,22.805),(52.105,22.635),(51.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.635),(52.295,22.805),(52.465,22.805),(52.465,22.635),(52.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.635),(52.655,22.805),(52.825,22.805),(52.825,22.635),(52.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.995),(51.575,23.165),(51.745,23.165),(51.745,22.995),(51.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.995),(51.935,23.165),(52.105,23.165),(52.105,22.995),(51.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.995),(52.295,23.165),(52.465,23.165),(52.465,22.995),(52.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.995),(52.655,23.165),(52.825,23.165),(52.825,22.995),(52.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,23.355),(51.575,23.525),(51.745,23.525),(51.745,23.355),(51.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,23.355),(51.935,23.525),(52.105,23.525),(52.105,23.355),(51.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,23.355),(52.295,23.525),(52.465,23.525),(52.465,23.355),(52.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,23.355),(52.655,23.525),(52.825,23.525),(52.825,23.355),(52.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,23.715),(51.575,23.885),(51.745,23.885),(51.745,23.715),(51.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,23.715),(51.935,23.885),(52.105,23.885),(52.105,23.715),(51.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,23.715),(52.295,23.885),(52.465,23.885),(52.465,23.715),(52.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,23.715),(52.655,23.885),(52.825,23.885),(52.825,23.715),(52.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.075),(51.575,24.245),(51.745,24.245),(51.745,24.075),(51.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.075),(51.935,24.245),(52.105,24.245),(52.105,24.075),(51.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.075),(52.295,24.245),(52.465,24.245),(52.465,24.075),(52.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.075),(52.655,24.245),(52.825,24.245),(52.825,24.075),(52.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.435),(51.575,24.605),(51.745,24.605),(51.745,24.435),(51.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.435),(51.935,24.605),(52.105,24.605),(52.105,24.435),(51.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.435),(52.295,24.605),(52.465,24.605),(52.465,24.435),(52.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.435),(52.655,24.605),(52.825,24.605),(52.825,24.435),(52.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.795),(51.575,24.965),(51.745,24.965),(51.745,24.795),(51.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.795),(51.935,24.965),(52.105,24.965),(52.105,24.795),(51.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.795),(52.295,24.965),(52.465,24.965),(52.465,24.795),(52.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.795),(52.655,24.965),(52.825,24.965),(52.825,24.795),(52.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.155),(51.575,25.325),(51.745,25.325),(51.745,25.155),(51.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.155),(51.935,25.325),(52.105,25.325),(52.105,25.155),(51.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.155),(52.295,25.325),(52.465,25.325),(52.465,25.155),(52.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.155),(52.655,25.325),(52.825,25.325),(52.825,25.155),(52.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.515),(51.575,25.685),(51.745,25.685),(51.745,25.515),(51.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.515),(51.935,25.685),(52.105,25.685),(52.105,25.515),(51.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.515),(52.295,25.685),(52.465,25.685),(52.465,25.515),(52.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.515),(52.655,25.685),(52.825,25.685),(52.825,25.515),(52.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.875),(51.575,26.045),(51.745,26.045),(51.745,25.875),(51.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.875),(51.935,26.045),(52.105,26.045),(52.105,25.875),(51.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.875),(52.295,26.045),(52.465,26.045),(52.465,25.875),(52.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.875),(52.655,26.045),(52.825,26.045),(52.825,25.875),(52.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.235),(51.575,26.405),(51.745,26.405),(51.745,26.235),(51.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.235),(51.935,26.405),(52.105,26.405),(52.105,26.235),(51.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.235),(52.295,26.405),(52.465,26.405),(52.465,26.235),(52.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.235),(52.655,26.405),(52.825,26.405),(52.825,26.235),(52.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.595),(51.575,26.765),(51.745,26.765),(51.745,26.595),(51.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.595),(51.935,26.765),(52.105,26.765),(52.105,26.595),(51.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.595),(52.295,26.765),(52.465,26.765),(52.465,26.595),(52.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.595),(52.655,26.765),(52.825,26.765),(52.825,26.595),(52.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.955),(51.575,27.125),(51.745,27.125),(51.745,26.955),(51.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.955),(51.935,27.125),(52.105,27.125),(52.105,26.955),(51.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.955),(52.295,27.125),(52.465,27.125),(52.465,26.955),(52.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.955),(52.655,27.125),(52.825,27.125),(52.825,26.955),(52.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,27.315),(51.575,27.485),(51.745,27.485),(51.745,27.315),(51.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,27.315),(51.935,27.485),(52.105,27.485),(52.105,27.315),(51.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,27.315),(52.295,27.485),(52.465,27.485),(52.465,27.315),(52.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,27.315),(52.655,27.485),(52.825,27.485),(52.825,27.315),(52.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,27.675),(51.575,27.845),(51.745,27.845),(51.745,27.675),(51.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,27.675),(51.935,27.845),(52.105,27.845),(52.105,27.675),(51.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,27.675),(52.295,27.845),(52.465,27.845),(52.465,27.675),(52.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,27.675),(52.655,27.845),(52.825,27.845),(52.825,27.675),(52.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.035),(51.575,28.205),(51.745,28.205),(51.745,28.035),(51.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.035),(51.935,28.205),(52.105,28.205),(52.105,28.035),(51.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.035),(52.295,28.205),(52.465,28.205),(52.465,28.035),(52.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.035),(52.655,28.205),(52.825,28.205),(52.825,28.035),(52.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.395),(51.575,28.565),(51.745,28.565),(51.745,28.395),(51.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.395),(51.935,28.565),(52.105,28.565),(52.105,28.395),(51.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.395),(52.295,28.565),(52.465,28.565),(52.465,28.395),(52.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.395),(52.655,28.565),(52.825,28.565),(52.825,28.395),(52.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.755),(51.575,28.925),(51.745,28.925),(51.745,28.755),(51.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.755),(51.935,28.925),(52.105,28.925),(52.105,28.755),(51.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.755),(52.295,28.925),(52.465,28.925),(52.465,28.755),(52.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.755),(52.655,28.925),(52.825,28.925),(52.825,28.755),(52.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.115),(51.575,29.285),(51.745,29.285),(51.745,29.115),(51.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.115),(51.935,29.285),(52.105,29.285),(52.105,29.115),(51.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.115),(52.295,29.285),(52.465,29.285),(52.465,29.115),(52.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.115),(52.655,29.285),(52.825,29.285),(52.825,29.115),(52.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.475),(51.575,29.645),(51.745,29.645),(51.745,29.475),(51.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.475),(51.935,29.645),(52.105,29.645),(52.105,29.475),(51.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.475),(52.295,29.645),(52.465,29.645),(52.465,29.475),(52.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.475),(52.655,29.645),(52.825,29.645),(52.825,29.475),(52.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.835),(51.575,30.005),(51.745,30.005),(51.745,29.835),(51.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.835),(51.935,30.005),(52.105,30.005),(52.105,29.835),(51.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.835),(52.295,30.005),(52.465,30.005),(52.465,29.835),(52.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.835),(52.655,30.005),(52.825,30.005),(52.825,29.835),(52.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.195),(51.575,30.365),(51.745,30.365),(51.745,30.195),(51.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.195),(51.935,30.365),(52.105,30.365),(52.105,30.195),(51.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.195),(52.295,30.365),(52.465,30.365),(52.465,30.195),(52.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.195),(52.655,30.365),(52.825,30.365),(52.825,30.195),(52.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.555),(51.575,30.725),(51.745,30.725),(51.745,30.555),(51.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.555),(51.935,30.725),(52.105,30.725),(52.105,30.555),(51.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.555),(52.295,30.725),(52.465,30.725),(52.465,30.555),(52.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.555),(52.655,30.725),(52.825,30.725),(52.825,30.555),(52.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.915),(51.575,31.085),(51.745,31.085),(51.745,30.915),(51.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.915),(51.935,31.085),(52.105,31.085),(52.105,30.915),(51.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.915),(52.295,31.085),(52.465,31.085),(52.465,30.915),(52.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.915),(52.655,31.085),(52.825,31.085),(52.825,30.915),(52.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.275),(51.575,31.445),(51.745,31.445),(51.745,31.275),(51.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.275),(51.935,31.445),(52.105,31.445),(52.105,31.275),(51.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.275),(52.295,31.445),(52.465,31.445),(52.465,31.275),(52.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.275),(52.655,31.445),(52.825,31.445),(52.825,31.275),(52.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.635),(51.575,31.805),(51.745,31.805),(51.745,31.635),(51.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.635),(51.935,31.805),(52.105,31.805),(52.105,31.635),(51.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.635),(52.295,31.805),(52.465,31.805),(52.465,31.635),(52.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.635),(52.655,31.805),(52.825,31.805),(52.825,31.635),(52.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.995),(51.575,32.165),(51.745,32.165),(51.745,31.995),(51.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.995),(51.935,32.165),(52.105,32.165),(52.105,31.995),(51.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.995),(52.295,32.165),(52.465,32.165),(52.465,31.995),(52.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.995),(52.655,32.165),(52.825,32.165),(52.825,31.995),(52.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,32.355),(51.575,32.525),(51.745,32.525),(51.745,32.355),(51.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,32.355),(51.935,32.525),(52.105,32.525),(52.105,32.355),(51.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,32.355),(52.295,32.525),(52.465,32.525),(52.465,32.355),(52.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,32.355),(52.655,32.525),(52.825,32.525),(52.825,32.355),(52.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,32.715),(51.575,32.885),(51.745,32.885),(51.745,32.715),(51.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,32.715),(51.935,32.885),(52.105,32.885),(52.105,32.715),(51.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,32.715),(52.295,32.885),(52.465,32.885),(52.465,32.715),(52.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,32.715),(52.655,32.885),(52.825,32.885),(52.825,32.715),(52.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.075),(51.575,33.245),(51.745,33.245),(51.745,33.075),(51.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.075),(51.935,33.245),(52.105,33.245),(52.105,33.075),(51.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.075),(52.295,33.245),(52.465,33.245),(52.465,33.075),(52.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.075),(52.655,33.245),(52.825,33.245),(52.825,33.075),(52.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.435),(51.575,33.605),(51.745,33.605),(51.745,33.435),(51.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.435),(51.935,33.605),(52.105,33.605),(52.105,33.435),(51.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.435),(52.295,33.605),(52.465,33.605),(52.465,33.435),(52.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.435),(52.655,33.605),(52.825,33.605),(52.825,33.435),(52.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.795),(51.575,33.965),(51.745,33.965),(51.745,33.795),(51.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.795),(51.935,33.965),(52.105,33.965),(52.105,33.795),(51.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.795),(52.295,33.965),(52.465,33.965),(52.465,33.795),(52.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.795),(52.655,33.965),(52.825,33.965),(52.825,33.795),(52.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.155),(51.575,34.325),(51.745,34.325),(51.745,34.155),(51.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.155),(51.935,34.325),(52.105,34.325),(52.105,34.155),(51.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.155),(52.295,34.325),(52.465,34.325),(52.465,34.155),(52.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.155),(52.655,34.325),(52.825,34.325),(52.825,34.155),(52.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.515),(51.575,34.685),(51.745,34.685),(51.745,34.515),(51.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.515),(51.935,34.685),(52.105,34.685),(52.105,34.515),(51.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.515),(52.295,34.685),(52.465,34.685),(52.465,34.515),(52.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.515),(52.655,34.685),(52.825,34.685),(52.825,34.515),(52.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.875),(51.575,35.045),(51.745,35.045),(51.745,34.875),(51.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.875),(51.935,35.045),(52.105,35.045),(52.105,34.875),(51.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.875),(52.295,35.045),(52.465,35.045),(52.465,34.875),(52.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.875),(52.655,35.045),(52.825,35.045),(52.825,34.875),(52.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.235),(51.575,35.405),(51.745,35.405),(51.745,35.235),(51.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.235),(51.935,35.405),(52.105,35.405),(52.105,35.235),(51.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.235),(52.295,35.405),(52.465,35.405),(52.465,35.235),(52.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.235),(52.655,35.405),(52.825,35.405),(52.825,35.235),(52.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.595),(51.575,35.765),(51.745,35.765),(51.745,35.595),(51.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.595),(51.935,35.765),(52.105,35.765),(52.105,35.595),(51.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.595),(52.295,35.765),(52.465,35.765),(52.465,35.595),(52.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.595),(52.655,35.765),(52.825,35.765),(52.825,35.595),(52.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.955),(51.575,36.125),(51.745,36.125),(51.745,35.955),(51.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.955),(51.935,36.125),(52.105,36.125),(52.105,35.955),(51.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.955),(52.295,36.125),(52.465,36.125),(52.465,35.955),(52.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.955),(52.655,36.125),(52.825,36.125),(52.825,35.955),(52.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,36.315),(51.575,36.485),(51.745,36.485),(51.745,36.315),(51.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,36.315),(51.935,36.485),(52.105,36.485),(52.105,36.315),(51.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,36.315),(52.295,36.485),(52.465,36.485),(52.465,36.315),(52.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,36.315),(52.655,36.485),(52.825,36.485),(52.825,36.315),(52.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,36.675),(51.575,36.845),(51.745,36.845),(51.745,36.675),(51.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,36.675),(51.935,36.845),(52.105,36.845),(52.105,36.675),(51.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,36.675),(52.295,36.845),(52.465,36.845),(52.465,36.675),(52.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,36.675),(52.655,36.845),(52.825,36.845),(52.825,36.675),(52.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.035),(51.575,37.205),(51.745,37.205),(51.745,37.035),(51.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.035),(51.935,37.205),(52.105,37.205),(52.105,37.035),(51.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.035),(52.295,37.205),(52.465,37.205),(52.465,37.035),(52.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.035),(52.655,37.205),(52.825,37.205),(52.825,37.035),(52.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.395),(51.575,37.565),(51.745,37.565),(51.745,37.395),(51.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.395),(51.935,37.565),(52.105,37.565),(52.105,37.395),(51.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.395),(52.295,37.565),(52.465,37.565),(52.465,37.395),(52.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.395),(52.655,37.565),(52.825,37.565),(52.825,37.395),(52.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.755),(51.575,37.925),(51.745,37.925),(51.745,37.755),(51.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.755),(51.935,37.925),(52.105,37.925),(52.105,37.755),(51.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.755),(52.295,37.925),(52.465,37.925),(52.465,37.755),(52.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.755),(52.655,37.925),(52.825,37.925),(52.825,37.755),(52.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.115),(51.575,38.285),(51.745,38.285),(51.745,38.115),(51.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.115),(51.935,38.285),(52.105,38.285),(52.105,38.115),(51.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.115),(52.295,38.285),(52.465,38.285),(52.465,38.115),(52.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.115),(52.655,38.285),(52.825,38.285),(52.825,38.115),(52.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.475),(51.575,38.645),(51.745,38.645),(51.745,38.475),(51.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.475),(51.935,38.645),(52.105,38.645),(52.105,38.475),(51.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.475),(52.295,38.645),(52.465,38.645),(52.465,38.475),(52.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.475),(52.655,38.645),(52.825,38.645),(52.825,38.475),(52.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.835),(51.575,39.005),(51.745,39.005),(51.745,38.835),(51.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.835),(51.935,39.005),(52.105,39.005),(52.105,38.835),(51.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.835),(52.295,39.005),(52.465,39.005),(52.465,38.835),(52.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.835),(52.655,39.005),(52.825,39.005),(52.825,38.835),(52.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.195),(51.575,39.365),(51.745,39.365),(51.745,39.195),(51.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.195),(51.935,39.365),(52.105,39.365),(52.105,39.195),(51.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.195),(52.295,39.365),(52.465,39.365),(52.465,39.195),(52.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.195),(52.655,39.365),(52.825,39.365),(52.825,39.195),(52.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.555),(51.575,39.725),(51.745,39.725),(51.745,39.555),(51.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.555),(51.935,39.725),(52.105,39.725),(52.105,39.555),(51.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.555),(52.295,39.725),(52.465,39.725),(52.465,39.555),(52.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.555),(52.655,39.725),(52.825,39.725),(52.825,39.555),(52.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.915),(51.575,40.085),(51.745,40.085),(51.745,39.915),(51.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.915),(51.935,40.085),(52.105,40.085),(52.105,39.915),(51.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.915),(52.295,40.085),(52.465,40.085),(52.465,39.915),(52.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.915),(52.655,40.085),(52.825,40.085),(52.825,39.915),(52.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,40.275),(51.575,40.445),(51.745,40.445),(51.745,40.275),(51.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,40.275),(51.935,40.445),(52.105,40.445),(52.105,40.275),(51.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,40.275),(52.295,40.445),(52.465,40.445),(52.465,40.275),(52.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,40.275),(52.655,40.445),(52.825,40.445),(52.825,40.275),(52.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,40.635),(51.575,40.805),(51.745,40.805),(51.745,40.635),(51.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,40.635),(51.935,40.805),(52.105,40.805),(52.105,40.635),(51.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,40.635),(52.295,40.805),(52.465,40.805),(52.465,40.635),(52.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,40.635),(52.655,40.805),(52.825,40.805),(52.825,40.635),(52.655,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,2.835),(22.775,3.005),(22.945,3.005),(22.945,2.835),(22.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,2.835),(23.135,3.005),(23.305,3.005),(23.305,2.835),(23.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,2.835),(23.495,3.005),(23.665,3.005),(23.665,2.835),(23.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,2.835),(23.855,3.005),(24.025,3.005),(24.025,2.835),(23.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.195),(22.775,3.365),(22.945,3.365),(22.945,3.195),(22.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.195),(23.135,3.365),(23.305,3.365),(23.305,3.195),(23.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.195),(23.495,3.365),(23.665,3.365),(23.665,3.195),(23.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.195),(23.855,3.365),(24.025,3.365),(24.025,3.195),(23.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.555),(22.775,3.725),(22.945,3.725),(22.945,3.555),(22.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.555),(23.135,3.725),(23.305,3.725),(23.305,3.555),(23.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.555),(23.495,3.725),(23.665,3.725),(23.665,3.555),(23.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.555),(23.855,3.725),(24.025,3.725),(24.025,3.555),(23.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.915),(22.775,4.085),(22.945,4.085),(22.945,3.915),(22.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.915),(23.135,4.085),(23.305,4.085),(23.305,3.915),(23.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.915),(23.495,4.085),(23.665,4.085),(23.665,3.915),(23.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.915),(23.855,4.085),(24.025,4.085),(24.025,3.915),(23.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.275),(22.775,4.445),(22.945,4.445),(22.945,4.275),(22.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.275),(23.135,4.445),(23.305,4.445),(23.305,4.275),(23.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.275),(23.495,4.445),(23.665,4.445),(23.665,4.275),(23.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.275),(23.855,4.445),(24.025,4.445),(24.025,4.275),(23.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.635),(22.775,4.805),(22.945,4.805),(22.945,4.635),(22.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.635),(23.135,4.805),(23.305,4.805),(23.305,4.635),(23.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.635),(23.495,4.805),(23.665,4.805),(23.665,4.635),(23.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.635),(23.855,4.805),(24.025,4.805),(24.025,4.635),(23.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.995),(22.775,5.165),(22.945,5.165),(22.945,4.995),(22.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.995),(23.135,5.165),(23.305,5.165),(23.305,4.995),(23.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.995),(23.495,5.165),(23.665,5.165),(23.665,4.995),(23.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.995),(23.855,5.165),(24.025,5.165),(24.025,4.995),(23.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.355),(22.775,5.525),(22.945,5.525),(22.945,5.355),(22.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.355),(23.135,5.525),(23.305,5.525),(23.305,5.355),(23.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.355),(23.495,5.525),(23.665,5.525),(23.665,5.355),(23.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.355),(23.855,5.525),(24.025,5.525),(24.025,5.355),(23.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.715),(22.775,5.885),(22.945,5.885),(22.945,5.715),(22.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.715),(23.135,5.885),(23.305,5.885),(23.305,5.715),(23.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.715),(23.495,5.885),(23.665,5.885),(23.665,5.715),(23.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.715),(23.855,5.885),(24.025,5.885),(24.025,5.715),(23.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.075),(22.775,6.245),(22.945,6.245),(22.945,6.075),(22.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.075),(23.135,6.245),(23.305,6.245),(23.305,6.075),(23.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.075),(23.495,6.245),(23.665,6.245),(23.665,6.075),(23.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.075),(23.855,6.245),(24.025,6.245),(24.025,6.075),(23.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.435),(22.775,6.605),(22.945,6.605),(22.945,6.435),(22.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.435),(23.135,6.605),(23.305,6.605),(23.305,6.435),(23.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.435),(23.495,6.605),(23.665,6.605),(23.665,6.435),(23.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.435),(23.855,6.605),(24.025,6.605),(24.025,6.435),(23.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.795),(22.775,6.965),(22.945,6.965),(22.945,6.795),(22.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.795),(23.135,6.965),(23.305,6.965),(23.305,6.795),(23.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.795),(23.495,6.965),(23.665,6.965),(23.665,6.795),(23.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.795),(23.855,6.965),(24.025,6.965),(24.025,6.795),(23.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.155),(22.775,7.325),(22.945,7.325),(22.945,7.155),(22.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.155),(23.135,7.325),(23.305,7.325),(23.305,7.155),(23.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.155),(23.495,7.325),(23.665,7.325),(23.665,7.155),(23.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.155),(23.855,7.325),(24.025,7.325),(24.025,7.155),(23.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.515),(22.775,7.685),(22.945,7.685),(22.945,7.515),(22.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.515),(23.135,7.685),(23.305,7.685),(23.305,7.515),(23.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.515),(23.495,7.685),(23.665,7.685),(23.665,7.515),(23.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.515),(23.855,7.685),(24.025,7.685),(24.025,7.515),(23.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.875),(22.775,8.045),(22.945,8.045),(22.945,7.875),(22.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.875),(23.135,8.045),(23.305,8.045),(23.305,7.875),(23.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.875),(23.495,8.045),(23.665,8.045),(23.665,7.875),(23.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.875),(23.855,8.045),(24.025,8.045),(24.025,7.875),(23.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.235),(22.775,8.405),(22.945,8.405),(22.945,8.235),(22.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.235),(23.135,8.405),(23.305,8.405),(23.305,8.235),(23.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.235),(23.495,8.405),(23.665,8.405),(23.665,8.235),(23.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.235),(23.855,8.405),(24.025,8.405),(24.025,8.235),(23.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.595),(22.775,8.765),(22.945,8.765),(22.945,8.595),(22.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.595),(23.135,8.765),(23.305,8.765),(23.305,8.595),(23.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.595),(23.495,8.765),(23.665,8.765),(23.665,8.595),(23.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.595),(23.855,8.765),(24.025,8.765),(24.025,8.595),(23.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.955),(22.775,9.125),(22.945,9.125),(22.945,8.955),(22.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.955),(23.135,9.125),(23.305,9.125),(23.305,8.955),(23.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.955),(23.495,9.125),(23.665,9.125),(23.665,8.955),(23.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.955),(23.855,9.125),(24.025,9.125),(24.025,8.955),(23.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.315),(22.775,9.485),(22.945,9.485),(22.945,9.315),(22.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.315),(23.135,9.485),(23.305,9.485),(23.305,9.315),(23.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.315),(23.495,9.485),(23.665,9.485),(23.665,9.315),(23.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.315),(23.855,9.485),(24.025,9.485),(24.025,9.315),(23.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.675),(22.775,9.845),(22.945,9.845),(22.945,9.675),(22.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.675),(23.135,9.845),(23.305,9.845),(23.305,9.675),(23.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.675),(23.495,9.845),(23.665,9.845),(23.665,9.675),(23.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.675),(23.855,9.845),(24.025,9.845),(24.025,9.675),(23.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.035),(22.775,10.205),(22.945,10.205),(22.945,10.035),(22.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.035),(23.135,10.205),(23.305,10.205),(23.305,10.035),(23.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.035),(23.495,10.205),(23.665,10.205),(23.665,10.035),(23.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.035),(23.855,10.205),(24.025,10.205),(24.025,10.035),(23.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.395),(22.775,10.565),(22.945,10.565),(22.945,10.395),(22.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.395),(23.135,10.565),(23.305,10.565),(23.305,10.395),(23.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.395),(23.495,10.565),(23.665,10.565),(23.665,10.395),(23.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.395),(23.855,10.565),(24.025,10.565),(24.025,10.395),(23.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.755),(22.775,10.925),(22.945,10.925),(22.945,10.755),(22.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.755),(23.135,10.925),(23.305,10.925),(23.305,10.755),(23.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.755),(23.495,10.925),(23.665,10.925),(23.665,10.755),(23.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.755),(23.855,10.925),(24.025,10.925),(24.025,10.755),(23.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.115),(22.775,11.285),(22.945,11.285),(22.945,11.115),(22.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.115),(23.135,11.285),(23.305,11.285),(23.305,11.115),(23.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.115),(23.495,11.285),(23.665,11.285),(23.665,11.115),(23.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.115),(23.855,11.285),(24.025,11.285),(24.025,11.115),(23.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.475),(22.775,11.645),(22.945,11.645),(22.945,11.475),(22.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.475),(23.135,11.645),(23.305,11.645),(23.305,11.475),(23.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.475),(23.495,11.645),(23.665,11.645),(23.665,11.475),(23.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.475),(23.855,11.645),(24.025,11.645),(24.025,11.475),(23.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.835),(22.775,12.005),(22.945,12.005),(22.945,11.835),(22.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.835),(23.135,12.005),(23.305,12.005),(23.305,11.835),(23.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.835),(23.495,12.005),(23.665,12.005),(23.665,11.835),(23.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.835),(23.855,12.005),(24.025,12.005),(24.025,11.835),(23.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.195),(22.775,12.365),(22.945,12.365),(22.945,12.195),(22.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.195),(23.135,12.365),(23.305,12.365),(23.305,12.195),(23.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.195),(23.495,12.365),(23.665,12.365),(23.665,12.195),(23.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.195),(23.855,12.365),(24.025,12.365),(24.025,12.195),(23.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.555),(22.775,12.725),(22.945,12.725),(22.945,12.555),(22.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.555),(23.135,12.725),(23.305,12.725),(23.305,12.555),(23.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.555),(23.495,12.725),(23.665,12.725),(23.665,12.555),(23.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.555),(23.855,12.725),(24.025,12.725),(24.025,12.555),(23.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.915),(22.775,13.085),(22.945,13.085),(22.945,12.915),(22.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.915),(23.135,13.085),(23.305,13.085),(23.305,12.915),(23.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.915),(23.495,13.085),(23.665,13.085),(23.665,12.915),(23.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.915),(23.855,13.085),(24.025,13.085),(24.025,12.915),(23.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.275),(22.775,13.445),(22.945,13.445),(22.945,13.275),(22.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.275),(23.135,13.445),(23.305,13.445),(23.305,13.275),(23.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.275),(23.495,13.445),(23.665,13.445),(23.665,13.275),(23.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.275),(23.855,13.445),(24.025,13.445),(24.025,13.275),(23.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.635),(22.775,13.805),(22.945,13.805),(22.945,13.635),(22.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.635),(23.135,13.805),(23.305,13.805),(23.305,13.635),(23.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.635),(23.495,13.805),(23.665,13.805),(23.665,13.635),(23.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.635),(23.855,13.805),(24.025,13.805),(24.025,13.635),(23.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.995),(22.775,14.165),(22.945,14.165),(22.945,13.995),(22.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.995),(23.135,14.165),(23.305,14.165),(23.305,13.995),(23.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.995),(23.495,14.165),(23.665,14.165),(23.665,13.995),(23.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.995),(23.855,14.165),(24.025,14.165),(24.025,13.995),(23.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.355),(22.775,14.525),(22.945,14.525),(22.945,14.355),(22.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.355),(23.135,14.525),(23.305,14.525),(23.305,14.355),(23.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.355),(23.495,14.525),(23.665,14.525),(23.665,14.355),(23.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.355),(23.855,14.525),(24.025,14.525),(24.025,14.355),(23.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.715),(22.775,14.885),(22.945,14.885),(22.945,14.715),(22.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.715),(23.135,14.885),(23.305,14.885),(23.305,14.715),(23.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.715),(23.495,14.885),(23.665,14.885),(23.665,14.715),(23.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.715),(23.855,14.885),(24.025,14.885),(24.025,14.715),(23.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.075),(22.775,15.245),(22.945,15.245),(22.945,15.075),(22.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.075),(23.135,15.245),(23.305,15.245),(23.305,15.075),(23.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.075),(23.495,15.245),(23.665,15.245),(23.665,15.075),(23.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.075),(23.855,15.245),(24.025,15.245),(24.025,15.075),(23.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.435),(22.775,15.605),(22.945,15.605),(22.945,15.435),(22.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.435),(23.135,15.605),(23.305,15.605),(23.305,15.435),(23.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.435),(23.495,15.605),(23.665,15.605),(23.665,15.435),(23.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.435),(23.855,15.605),(24.025,15.605),(24.025,15.435),(23.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.795),(22.775,15.965),(22.945,15.965),(22.945,15.795),(22.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.795),(23.135,15.965),(23.305,15.965),(23.305,15.795),(23.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.795),(23.495,15.965),(23.665,15.965),(23.665,15.795),(23.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.795),(23.855,15.965),(24.025,15.965),(24.025,15.795),(23.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.155),(22.775,16.325),(22.945,16.325),(22.945,16.155),(22.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.155),(23.135,16.325),(23.305,16.325),(23.305,16.155),(23.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.155),(23.495,16.325),(23.665,16.325),(23.665,16.155),(23.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.155),(23.855,16.325),(24.025,16.325),(24.025,16.155),(23.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.515),(22.775,16.685),(22.945,16.685),(22.945,16.515),(22.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.515),(23.135,16.685),(23.305,16.685),(23.305,16.515),(23.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.515),(23.495,16.685),(23.665,16.685),(23.665,16.515),(23.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.515),(23.855,16.685),(24.025,16.685),(24.025,16.515),(23.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.875),(22.775,17.045),(22.945,17.045),(22.945,16.875),(22.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.875),(23.135,17.045),(23.305,17.045),(23.305,16.875),(23.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.875),(23.495,17.045),(23.665,17.045),(23.665,16.875),(23.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.875),(23.855,17.045),(24.025,17.045),(24.025,16.875),(23.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.235),(22.775,17.405),(22.945,17.405),(22.945,17.235),(22.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.235),(23.135,17.405),(23.305,17.405),(23.305,17.235),(23.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.235),(23.495,17.405),(23.665,17.405),(23.665,17.235),(23.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.235),(23.855,17.405),(24.025,17.405),(24.025,17.235),(23.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.595),(22.775,17.765),(22.945,17.765),(22.945,17.595),(22.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.595),(23.135,17.765),(23.305,17.765),(23.305,17.595),(23.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.595),(23.495,17.765),(23.665,17.765),(23.665,17.595),(23.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.595),(23.855,17.765),(24.025,17.765),(24.025,17.595),(23.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.955),(22.775,18.125),(22.945,18.125),(22.945,17.955),(22.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.955),(23.135,18.125),(23.305,18.125),(23.305,17.955),(23.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.955),(23.495,18.125),(23.665,18.125),(23.665,17.955),(23.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.955),(23.855,18.125),(24.025,18.125),(24.025,17.955),(23.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.315),(22.775,18.485),(22.945,18.485),(22.945,18.315),(22.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.315),(23.135,18.485),(23.305,18.485),(23.305,18.315),(23.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.315),(23.495,18.485),(23.665,18.485),(23.665,18.315),(23.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.315),(23.855,18.485),(24.025,18.485),(24.025,18.315),(23.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.675),(22.775,18.845),(22.945,18.845),(22.945,18.675),(22.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.675),(23.135,18.845),(23.305,18.845),(23.305,18.675),(23.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.675),(23.495,18.845),(23.665,18.845),(23.665,18.675),(23.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.675),(23.855,18.845),(24.025,18.845),(24.025,18.675),(23.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.035),(22.775,19.205),(22.945,19.205),(22.945,19.035),(22.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.035),(23.135,19.205),(23.305,19.205),(23.305,19.035),(23.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.035),(23.495,19.205),(23.665,19.205),(23.665,19.035),(23.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.035),(23.855,19.205),(24.025,19.205),(24.025,19.035),(23.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.395),(22.775,19.565),(22.945,19.565),(22.945,19.395),(22.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.395),(23.135,19.565),(23.305,19.565),(23.305,19.395),(23.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.395),(23.495,19.565),(23.665,19.565),(23.665,19.395),(23.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.395),(23.855,19.565),(24.025,19.565),(24.025,19.395),(23.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.755),(22.775,19.925),(22.945,19.925),(22.945,19.755),(22.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.755),(23.135,19.925),(23.305,19.925),(23.305,19.755),(23.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.755),(23.495,19.925),(23.665,19.925),(23.665,19.755),(23.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.755),(23.855,19.925),(24.025,19.925),(24.025,19.755),(23.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,20.115),(22.775,20.285),(22.945,20.285),(22.945,20.115),(22.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,20.115),(23.135,20.285),(23.305,20.285),(23.305,20.115),(23.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,20.115),(23.495,20.285),(23.665,20.285),(23.665,20.115),(23.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,20.115),(23.855,20.285),(24.025,20.285),(24.025,20.115),(23.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,20.475),(22.775,20.645),(22.945,20.645),(22.945,20.475),(22.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,20.475),(23.135,20.645),(23.305,20.645),(23.305,20.475),(23.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,20.475),(23.495,20.645),(23.665,20.645),(23.665,20.475),(23.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,20.475),(23.855,20.645),(24.025,20.645),(24.025,20.475),(23.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,20.835),(22.775,21.005),(22.945,21.005),(22.945,20.835),(22.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,20.835),(23.135,21.005),(23.305,21.005),(23.305,20.835),(23.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,20.835),(23.495,21.005),(23.665,21.005),(23.665,20.835),(23.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,20.835),(23.855,21.005),(24.025,21.005),(24.025,20.835),(23.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,21.195),(22.775,21.365),(22.945,21.365),(22.945,21.195),(22.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,21.195),(23.135,21.365),(23.305,21.365),(23.305,21.195),(23.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,21.195),(23.495,21.365),(23.665,21.365),(23.665,21.195),(23.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,21.195),(23.855,21.365),(24.025,21.365),(24.025,21.195),(23.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,21.555),(22.775,21.725),(22.945,21.725),(22.945,21.555),(22.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,21.555),(23.135,21.725),(23.305,21.725),(23.305,21.555),(23.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,21.555),(23.495,21.725),(23.665,21.725),(23.665,21.555),(23.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,21.555),(23.855,21.725),(24.025,21.725),(24.025,21.555),(23.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,21.915),(22.775,22.085),(22.945,22.085),(22.945,21.915),(22.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,21.915),(23.135,22.085),(23.305,22.085),(23.305,21.915),(23.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,21.915),(23.495,22.085),(23.665,22.085),(23.665,21.915),(23.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,21.915),(23.855,22.085),(24.025,22.085),(24.025,21.915),(23.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.275),(22.775,22.445),(22.945,22.445),(22.945,22.275),(22.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.275),(23.135,22.445),(23.305,22.445),(23.305,22.275),(23.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.275),(23.495,22.445),(23.665,22.445),(23.665,22.275),(23.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.275),(23.855,22.445),(24.025,22.445),(24.025,22.275),(23.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.635),(22.775,22.805),(22.945,22.805),(22.945,22.635),(22.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.635),(23.135,22.805),(23.305,22.805),(23.305,22.635),(23.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.635),(23.495,22.805),(23.665,22.805),(23.665,22.635),(23.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.635),(23.855,22.805),(24.025,22.805),(24.025,22.635),(23.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.995),(22.775,23.165),(22.945,23.165),(22.945,22.995),(22.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.995),(23.135,23.165),(23.305,23.165),(23.305,22.995),(23.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.995),(23.495,23.165),(23.665,23.165),(23.665,22.995),(23.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.995),(23.855,23.165),(24.025,23.165),(24.025,22.995),(23.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,23.355),(22.775,23.525),(22.945,23.525),(22.945,23.355),(22.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,23.355),(23.135,23.525),(23.305,23.525),(23.305,23.355),(23.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,23.355),(23.495,23.525),(23.665,23.525),(23.665,23.355),(23.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,23.355),(23.855,23.525),(24.025,23.525),(24.025,23.355),(23.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,23.715),(22.775,23.885),(22.945,23.885),(22.945,23.715),(22.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,23.715),(23.135,23.885),(23.305,23.885),(23.305,23.715),(23.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,23.715),(23.495,23.885),(23.665,23.885),(23.665,23.715),(23.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,23.715),(23.855,23.885),(24.025,23.885),(24.025,23.715),(23.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,24.075),(22.775,24.245),(22.945,24.245),(22.945,24.075),(22.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,24.075),(23.135,24.245),(23.305,24.245),(23.305,24.075),(23.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,24.075),(23.495,24.245),(23.665,24.245),(23.665,24.075),(23.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,24.075),(23.855,24.245),(24.025,24.245),(24.025,24.075),(23.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,24.435),(22.775,24.605),(22.945,24.605),(22.945,24.435),(22.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,24.435),(23.135,24.605),(23.305,24.605),(23.305,24.435),(23.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,24.435),(23.495,24.605),(23.665,24.605),(23.665,24.435),(23.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,24.435),(23.855,24.605),(24.025,24.605),(24.025,24.435),(23.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,24.795),(22.775,24.965),(22.945,24.965),(22.945,24.795),(22.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,24.795),(23.135,24.965),(23.305,24.965),(23.305,24.795),(23.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,24.795),(23.495,24.965),(23.665,24.965),(23.665,24.795),(23.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,24.795),(23.855,24.965),(24.025,24.965),(24.025,24.795),(23.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,25.155),(22.775,25.325),(22.945,25.325),(22.945,25.155),(22.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,25.155),(23.135,25.325),(23.305,25.325),(23.305,25.155),(23.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,25.155),(23.495,25.325),(23.665,25.325),(23.665,25.155),(23.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,25.155),(23.855,25.325),(24.025,25.325),(24.025,25.155),(23.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,25.515),(22.775,25.685),(22.945,25.685),(22.945,25.515),(22.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,25.515),(23.135,25.685),(23.305,25.685),(23.305,25.515),(23.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,25.515),(23.495,25.685),(23.665,25.685),(23.665,25.515),(23.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,25.515),(23.855,25.685),(24.025,25.685),(24.025,25.515),(23.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,25.875),(22.775,26.045),(22.945,26.045),(22.945,25.875),(22.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,25.875),(23.135,26.045),(23.305,26.045),(23.305,25.875),(23.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,25.875),(23.495,26.045),(23.665,26.045),(23.665,25.875),(23.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,25.875),(23.855,26.045),(24.025,26.045),(24.025,25.875),(23.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,26.235),(22.775,26.405),(22.945,26.405),(22.945,26.235),(22.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,26.235),(23.135,26.405),(23.305,26.405),(23.305,26.235),(23.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,26.235),(23.495,26.405),(23.665,26.405),(23.665,26.235),(23.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,26.235),(23.855,26.405),(24.025,26.405),(24.025,26.235),(23.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,26.595),(22.775,26.765),(22.945,26.765),(22.945,26.595),(22.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,26.595),(23.135,26.765),(23.305,26.765),(23.305,26.595),(23.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,26.595),(23.495,26.765),(23.665,26.765),(23.665,26.595),(23.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,26.595),(23.855,26.765),(24.025,26.765),(24.025,26.595),(23.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,26.955),(22.775,27.125),(22.945,27.125),(22.945,26.955),(22.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,26.955),(23.135,27.125),(23.305,27.125),(23.305,26.955),(23.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,26.955),(23.495,27.125),(23.665,27.125),(23.665,26.955),(23.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,26.955),(23.855,27.125),(24.025,27.125),(24.025,26.955),(23.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,27.315),(22.775,27.485),(22.945,27.485),(22.945,27.315),(22.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,27.315),(23.135,27.485),(23.305,27.485),(23.305,27.315),(23.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,27.315),(23.495,27.485),(23.665,27.485),(23.665,27.315),(23.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,27.315),(23.855,27.485),(24.025,27.485),(24.025,27.315),(23.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,27.675),(22.775,27.845),(22.945,27.845),(22.945,27.675),(22.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,27.675),(23.135,27.845),(23.305,27.845),(23.305,27.675),(23.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,27.675),(23.495,27.845),(23.665,27.845),(23.665,27.675),(23.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,27.675),(23.855,27.845),(24.025,27.845),(24.025,27.675),(23.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,28.035),(22.775,28.205),(22.945,28.205),(22.945,28.035),(22.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,28.035),(23.135,28.205),(23.305,28.205),(23.305,28.035),(23.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,28.035),(23.495,28.205),(23.665,28.205),(23.665,28.035),(23.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,28.035),(23.855,28.205),(24.025,28.205),(24.025,28.035),(23.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,28.395),(22.775,28.565),(22.945,28.565),(22.945,28.395),(22.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,28.395),(23.135,28.565),(23.305,28.565),(23.305,28.395),(23.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,28.395),(23.495,28.565),(23.665,28.565),(23.665,28.395),(23.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,28.395),(23.855,28.565),(24.025,28.565),(24.025,28.395),(23.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,28.755),(22.775,28.925),(22.945,28.925),(22.945,28.755),(22.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,28.755),(23.135,28.925),(23.305,28.925),(23.305,28.755),(23.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,28.755),(23.495,28.925),(23.665,28.925),(23.665,28.755),(23.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,28.755),(23.855,28.925),(24.025,28.925),(24.025,28.755),(23.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,29.115),(22.775,29.285),(22.945,29.285),(22.945,29.115),(22.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,29.115),(23.135,29.285),(23.305,29.285),(23.305,29.115),(23.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,29.115),(23.495,29.285),(23.665,29.285),(23.665,29.115),(23.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,29.115),(23.855,29.285),(24.025,29.285),(24.025,29.115),(23.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,29.475),(22.775,29.645),(22.945,29.645),(22.945,29.475),(22.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,29.475),(23.135,29.645),(23.305,29.645),(23.305,29.475),(23.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,29.475),(23.495,29.645),(23.665,29.645),(23.665,29.475),(23.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,29.475),(23.855,29.645),(24.025,29.645),(24.025,29.475),(23.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,29.835),(22.775,30.005),(22.945,30.005),(22.945,29.835),(22.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,29.835),(23.135,30.005),(23.305,30.005),(23.305,29.835),(23.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,29.835),(23.495,30.005),(23.665,30.005),(23.665,29.835),(23.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,29.835),(23.855,30.005),(24.025,30.005),(24.025,29.835),(23.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,30.195),(22.775,30.365),(22.945,30.365),(22.945,30.195),(22.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,30.195),(23.135,30.365),(23.305,30.365),(23.305,30.195),(23.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,30.195),(23.495,30.365),(23.665,30.365),(23.665,30.195),(23.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,30.195),(23.855,30.365),(24.025,30.365),(24.025,30.195),(23.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,30.555),(22.775,30.725),(22.945,30.725),(22.945,30.555),(22.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,30.555),(23.135,30.725),(23.305,30.725),(23.305,30.555),(23.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,30.555),(23.495,30.725),(23.665,30.725),(23.665,30.555),(23.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,30.555),(23.855,30.725),(24.025,30.725),(24.025,30.555),(23.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,30.915),(22.775,31.085),(22.945,31.085),(22.945,30.915),(22.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,30.915),(23.135,31.085),(23.305,31.085),(23.305,30.915),(23.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,30.915),(23.495,31.085),(23.665,31.085),(23.665,30.915),(23.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,30.915),(23.855,31.085),(24.025,31.085),(24.025,30.915),(23.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,31.275),(22.775,31.445),(22.945,31.445),(22.945,31.275),(22.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,31.275),(23.135,31.445),(23.305,31.445),(23.305,31.275),(23.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,31.275),(23.495,31.445),(23.665,31.445),(23.665,31.275),(23.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,31.275),(23.855,31.445),(24.025,31.445),(24.025,31.275),(23.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,31.635),(22.775,31.805),(22.945,31.805),(22.945,31.635),(22.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,31.635),(23.135,31.805),(23.305,31.805),(23.305,31.635),(23.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,31.635),(23.495,31.805),(23.665,31.805),(23.665,31.635),(23.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,31.635),(23.855,31.805),(24.025,31.805),(24.025,31.635),(23.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,31.995),(22.775,32.165),(22.945,32.165),(22.945,31.995),(22.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,31.995),(23.135,32.165),(23.305,32.165),(23.305,31.995),(23.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,31.995),(23.495,32.165),(23.665,32.165),(23.665,31.995),(23.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,31.995),(23.855,32.165),(24.025,32.165),(24.025,31.995),(23.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,32.355),(22.775,32.525),(22.945,32.525),(22.945,32.355),(22.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,32.355),(23.135,32.525),(23.305,32.525),(23.305,32.355),(23.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,32.355),(23.495,32.525),(23.665,32.525),(23.665,32.355),(23.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,32.355),(23.855,32.525),(24.025,32.525),(24.025,32.355),(23.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,32.715),(22.775,32.885),(22.945,32.885),(22.945,32.715),(22.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,32.715),(23.135,32.885),(23.305,32.885),(23.305,32.715),(23.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,32.715),(23.495,32.885),(23.665,32.885),(23.665,32.715),(23.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,32.715),(23.855,32.885),(24.025,32.885),(24.025,32.715),(23.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,33.075),(22.775,33.245),(22.945,33.245),(22.945,33.075),(22.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,33.075),(23.135,33.245),(23.305,33.245),(23.305,33.075),(23.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,33.075),(23.495,33.245),(23.665,33.245),(23.665,33.075),(23.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,33.075),(23.855,33.245),(24.025,33.245),(24.025,33.075),(23.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,33.435),(22.775,33.605),(22.945,33.605),(22.945,33.435),(22.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,33.435),(23.135,33.605),(23.305,33.605),(23.305,33.435),(23.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,33.435),(23.495,33.605),(23.665,33.605),(23.665,33.435),(23.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,33.435),(23.855,33.605),(24.025,33.605),(24.025,33.435),(23.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,33.795),(22.775,33.965),(22.945,33.965),(22.945,33.795),(22.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,33.795),(23.135,33.965),(23.305,33.965),(23.305,33.795),(23.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,33.795),(23.495,33.965),(23.665,33.965),(23.665,33.795),(23.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,33.795),(23.855,33.965),(24.025,33.965),(24.025,33.795),(23.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,34.155),(22.775,34.325),(22.945,34.325),(22.945,34.155),(22.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,34.155),(23.135,34.325),(23.305,34.325),(23.305,34.155),(23.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,34.155),(23.495,34.325),(23.665,34.325),(23.665,34.155),(23.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,34.155),(23.855,34.325),(24.025,34.325),(24.025,34.155),(23.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,34.515),(22.775,34.685),(22.945,34.685),(22.945,34.515),(22.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,34.515),(23.135,34.685),(23.305,34.685),(23.305,34.515),(23.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,34.515),(23.495,34.685),(23.665,34.685),(23.665,34.515),(23.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,34.515),(23.855,34.685),(24.025,34.685),(24.025,34.515),(23.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,34.875),(22.775,35.045),(22.945,35.045),(22.945,34.875),(22.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,34.875),(23.135,35.045),(23.305,35.045),(23.305,34.875),(23.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,34.875),(23.495,35.045),(23.665,35.045),(23.665,34.875),(23.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,34.875),(23.855,35.045),(24.025,35.045),(24.025,34.875),(23.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,35.235),(22.775,35.405),(22.945,35.405),(22.945,35.235),(22.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,35.235),(23.135,35.405),(23.305,35.405),(23.305,35.235),(23.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,35.235),(23.495,35.405),(23.665,35.405),(23.665,35.235),(23.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,35.235),(23.855,35.405),(24.025,35.405),(24.025,35.235),(23.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,35.595),(22.775,35.765),(22.945,35.765),(22.945,35.595),(22.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,35.595),(23.135,35.765),(23.305,35.765),(23.305,35.595),(23.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,35.595),(23.495,35.765),(23.665,35.765),(23.665,35.595),(23.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,35.595),(23.855,35.765),(24.025,35.765),(24.025,35.595),(23.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,35.955),(22.775,36.125),(22.945,36.125),(22.945,35.955),(22.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,35.955),(23.135,36.125),(23.305,36.125),(23.305,35.955),(23.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,35.955),(23.495,36.125),(23.665,36.125),(23.665,35.955),(23.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,35.955),(23.855,36.125),(24.025,36.125),(24.025,35.955),(23.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,36.315),(22.775,36.485),(22.945,36.485),(22.945,36.315),(22.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,36.315),(23.135,36.485),(23.305,36.485),(23.305,36.315),(23.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,36.315),(23.495,36.485),(23.665,36.485),(23.665,36.315),(23.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,36.315),(23.855,36.485),(24.025,36.485),(24.025,36.315),(23.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,36.675),(22.775,36.845),(22.945,36.845),(22.945,36.675),(22.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,36.675),(23.135,36.845),(23.305,36.845),(23.305,36.675),(23.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,36.675),(23.495,36.845),(23.665,36.845),(23.665,36.675),(23.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,36.675),(23.855,36.845),(24.025,36.845),(24.025,36.675),(23.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,37.035),(22.775,37.205),(22.945,37.205),(22.945,37.035),(22.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,37.035),(23.135,37.205),(23.305,37.205),(23.305,37.035),(23.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,37.035),(23.495,37.205),(23.665,37.205),(23.665,37.035),(23.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,37.035),(23.855,37.205),(24.025,37.205),(24.025,37.035),(23.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,37.395),(22.775,37.565),(22.945,37.565),(22.945,37.395),(22.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,37.395),(23.135,37.565),(23.305,37.565),(23.305,37.395),(23.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,37.395),(23.495,37.565),(23.665,37.565),(23.665,37.395),(23.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,37.395),(23.855,37.565),(24.025,37.565),(24.025,37.395),(23.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,37.755),(22.775,37.925),(22.945,37.925),(22.945,37.755),(22.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,37.755),(23.135,37.925),(23.305,37.925),(23.305,37.755),(23.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,37.755),(23.495,37.925),(23.665,37.925),(23.665,37.755),(23.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,37.755),(23.855,37.925),(24.025,37.925),(24.025,37.755),(23.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,38.115),(22.775,38.285),(22.945,38.285),(22.945,38.115),(22.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,38.115),(23.135,38.285),(23.305,38.285),(23.305,38.115),(23.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,38.115),(23.495,38.285),(23.665,38.285),(23.665,38.115),(23.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,38.115),(23.855,38.285),(24.025,38.285),(24.025,38.115),(23.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,38.475),(22.775,38.645),(22.945,38.645),(22.945,38.475),(22.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,38.475),(23.135,38.645),(23.305,38.645),(23.305,38.475),(23.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,38.475),(23.495,38.645),(23.665,38.645),(23.665,38.475),(23.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,38.475),(23.855,38.645),(24.025,38.645),(24.025,38.475),(23.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,38.835),(22.775,39.005),(22.945,39.005),(22.945,38.835),(22.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,38.835),(23.135,39.005),(23.305,39.005),(23.305,38.835),(23.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,38.835),(23.495,39.005),(23.665,39.005),(23.665,38.835),(23.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,38.835),(23.855,39.005),(24.025,39.005),(24.025,38.835),(23.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,39.195),(22.775,39.365),(22.945,39.365),(22.945,39.195),(22.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,39.195),(23.135,39.365),(23.305,39.365),(23.305,39.195),(23.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,39.195),(23.495,39.365),(23.665,39.365),(23.665,39.195),(23.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,39.195),(23.855,39.365),(24.025,39.365),(24.025,39.195),(23.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,39.555),(22.775,39.725),(22.945,39.725),(22.945,39.555),(22.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,39.555),(23.135,39.725),(23.305,39.725),(23.305,39.555),(23.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,39.555),(23.495,39.725),(23.665,39.725),(23.665,39.555),(23.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,39.555),(23.855,39.725),(24.025,39.725),(24.025,39.555),(23.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,39.915),(22.775,40.085),(22.945,40.085),(22.945,39.915),(22.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,39.915),(23.135,40.085),(23.305,40.085),(23.305,39.915),(23.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,39.915),(23.495,40.085),(23.665,40.085),(23.665,39.915),(23.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,39.915),(23.855,40.085),(24.025,40.085),(24.025,39.915),(23.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,40.275),(22.775,40.445),(22.945,40.445),(22.945,40.275),(22.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,40.275),(23.135,40.445),(23.305,40.445),(23.305,40.275),(23.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,40.275),(23.495,40.445),(23.665,40.445),(23.665,40.275),(23.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,40.275),(23.855,40.445),(24.025,40.445),(24.025,40.275),(23.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,40.635),(22.775,40.805),(22.945,40.805),(22.945,40.635),(22.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,40.635),(23.135,40.805),(23.305,40.805),(23.305,40.635),(23.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,40.635),(23.495,40.805),(23.665,40.805),(23.665,40.635),(23.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,40.635),(23.855,40.805),(24.025,40.805),(24.025,40.635),(23.855,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.835),(46.775,3.005),(46.945,3.005),(46.945,2.835),(46.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.835),(47.135,3.005),(47.305,3.005),(47.305,2.835),(47.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.835),(47.495,3.005),(47.665,3.005),(47.665,2.835),(47.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.835),(47.855,3.005),(48.025,3.005),(48.025,2.835),(47.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.195),(46.775,3.365),(46.945,3.365),(46.945,3.195),(46.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.195),(47.135,3.365),(47.305,3.365),(47.305,3.195),(47.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.195),(47.495,3.365),(47.665,3.365),(47.665,3.195),(47.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.195),(47.855,3.365),(48.025,3.365),(48.025,3.195),(47.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.555),(46.775,3.725),(46.945,3.725),(46.945,3.555),(46.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.555),(47.135,3.725),(47.305,3.725),(47.305,3.555),(47.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.555),(47.495,3.725),(47.665,3.725),(47.665,3.555),(47.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.555),(47.855,3.725),(48.025,3.725),(48.025,3.555),(47.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.915),(46.775,4.085),(46.945,4.085),(46.945,3.915),(46.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.915),(47.135,4.085),(47.305,4.085),(47.305,3.915),(47.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.915),(47.495,4.085),(47.665,4.085),(47.665,3.915),(47.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.915),(47.855,4.085),(48.025,4.085),(48.025,3.915),(47.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.275),(46.775,4.445),(46.945,4.445),(46.945,4.275),(46.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.275),(47.135,4.445),(47.305,4.445),(47.305,4.275),(47.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.275),(47.495,4.445),(47.665,4.445),(47.665,4.275),(47.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.275),(47.855,4.445),(48.025,4.445),(48.025,4.275),(47.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.635),(46.775,4.805),(46.945,4.805),(46.945,4.635),(46.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.635),(47.135,4.805),(47.305,4.805),(47.305,4.635),(47.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.635),(47.495,4.805),(47.665,4.805),(47.665,4.635),(47.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.635),(47.855,4.805),(48.025,4.805),(48.025,4.635),(47.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.995),(46.775,5.165),(46.945,5.165),(46.945,4.995),(46.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.995),(47.135,5.165),(47.305,5.165),(47.305,4.995),(47.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.995),(47.495,5.165),(47.665,5.165),(47.665,4.995),(47.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.995),(47.855,5.165),(48.025,5.165),(48.025,4.995),(47.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.355),(46.775,5.525),(46.945,5.525),(46.945,5.355),(46.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.355),(47.135,5.525),(47.305,5.525),(47.305,5.355),(47.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.355),(47.495,5.525),(47.665,5.525),(47.665,5.355),(47.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.355),(47.855,5.525),(48.025,5.525),(48.025,5.355),(47.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.715),(46.775,5.885),(46.945,5.885),(46.945,5.715),(46.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.715),(47.135,5.885),(47.305,5.885),(47.305,5.715),(47.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.715),(47.495,5.885),(47.665,5.885),(47.665,5.715),(47.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.715),(47.855,5.885),(48.025,5.885),(48.025,5.715),(47.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.075),(46.775,6.245),(46.945,6.245),(46.945,6.075),(46.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.075),(47.135,6.245),(47.305,6.245),(47.305,6.075),(47.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.075),(47.495,6.245),(47.665,6.245),(47.665,6.075),(47.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.075),(47.855,6.245),(48.025,6.245),(48.025,6.075),(47.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.435),(46.775,6.605),(46.945,6.605),(46.945,6.435),(46.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.435),(47.135,6.605),(47.305,6.605),(47.305,6.435),(47.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.435),(47.495,6.605),(47.665,6.605),(47.665,6.435),(47.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.435),(47.855,6.605),(48.025,6.605),(48.025,6.435),(47.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.795),(46.775,6.965),(46.945,6.965),(46.945,6.795),(46.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.795),(47.135,6.965),(47.305,6.965),(47.305,6.795),(47.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.795),(47.495,6.965),(47.665,6.965),(47.665,6.795),(47.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.795),(47.855,6.965),(48.025,6.965),(48.025,6.795),(47.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.155),(46.775,7.325),(46.945,7.325),(46.945,7.155),(46.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.155),(47.135,7.325),(47.305,7.325),(47.305,7.155),(47.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.155),(47.495,7.325),(47.665,7.325),(47.665,7.155),(47.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.155),(47.855,7.325),(48.025,7.325),(48.025,7.155),(47.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.515),(46.775,7.685),(46.945,7.685),(46.945,7.515),(46.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.515),(47.135,7.685),(47.305,7.685),(47.305,7.515),(47.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.515),(47.495,7.685),(47.665,7.685),(47.665,7.515),(47.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.515),(47.855,7.685),(48.025,7.685),(48.025,7.515),(47.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.875),(46.775,8.045),(46.945,8.045),(46.945,7.875),(46.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.875),(47.135,8.045),(47.305,8.045),(47.305,7.875),(47.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.875),(47.495,8.045),(47.665,8.045),(47.665,7.875),(47.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.875),(47.855,8.045),(48.025,8.045),(48.025,7.875),(47.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.235),(46.775,8.405),(46.945,8.405),(46.945,8.235),(46.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.235),(47.135,8.405),(47.305,8.405),(47.305,8.235),(47.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.235),(47.495,8.405),(47.665,8.405),(47.665,8.235),(47.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.235),(47.855,8.405),(48.025,8.405),(48.025,8.235),(47.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.595),(46.775,8.765),(46.945,8.765),(46.945,8.595),(46.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.595),(47.135,8.765),(47.305,8.765),(47.305,8.595),(47.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.595),(47.495,8.765),(47.665,8.765),(47.665,8.595),(47.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.595),(47.855,8.765),(48.025,8.765),(48.025,8.595),(47.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.955),(46.775,9.125),(46.945,9.125),(46.945,8.955),(46.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.955),(47.135,9.125),(47.305,9.125),(47.305,8.955),(47.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.955),(47.495,9.125),(47.665,9.125),(47.665,8.955),(47.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.955),(47.855,9.125),(48.025,9.125),(48.025,8.955),(47.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.315),(46.775,9.485),(46.945,9.485),(46.945,9.315),(46.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.315),(47.135,9.485),(47.305,9.485),(47.305,9.315),(47.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.315),(47.495,9.485),(47.665,9.485),(47.665,9.315),(47.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.315),(47.855,9.485),(48.025,9.485),(48.025,9.315),(47.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.675),(46.775,9.845),(46.945,9.845),(46.945,9.675),(46.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.675),(47.135,9.845),(47.305,9.845),(47.305,9.675),(47.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.675),(47.495,9.845),(47.665,9.845),(47.665,9.675),(47.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.675),(47.855,9.845),(48.025,9.845),(48.025,9.675),(47.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.035),(46.775,10.205),(46.945,10.205),(46.945,10.035),(46.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.035),(47.135,10.205),(47.305,10.205),(47.305,10.035),(47.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.035),(47.495,10.205),(47.665,10.205),(47.665,10.035),(47.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.035),(47.855,10.205),(48.025,10.205),(48.025,10.035),(47.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.395),(46.775,10.565),(46.945,10.565),(46.945,10.395),(46.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.395),(47.135,10.565),(47.305,10.565),(47.305,10.395),(47.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.395),(47.495,10.565),(47.665,10.565),(47.665,10.395),(47.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.395),(47.855,10.565),(48.025,10.565),(48.025,10.395),(47.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.755),(46.775,10.925),(46.945,10.925),(46.945,10.755),(46.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.755),(47.135,10.925),(47.305,10.925),(47.305,10.755),(47.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.755),(47.495,10.925),(47.665,10.925),(47.665,10.755),(47.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.755),(47.855,10.925),(48.025,10.925),(48.025,10.755),(47.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.115),(46.775,11.285),(46.945,11.285),(46.945,11.115),(46.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.115),(47.135,11.285),(47.305,11.285),(47.305,11.115),(47.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.115),(47.495,11.285),(47.665,11.285),(47.665,11.115),(47.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.115),(47.855,11.285),(48.025,11.285),(48.025,11.115),(47.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.475),(46.775,11.645),(46.945,11.645),(46.945,11.475),(46.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.475),(47.135,11.645),(47.305,11.645),(47.305,11.475),(47.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.475),(47.495,11.645),(47.665,11.645),(47.665,11.475),(47.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.475),(47.855,11.645),(48.025,11.645),(48.025,11.475),(47.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.835),(46.775,12.005),(46.945,12.005),(46.945,11.835),(46.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.835),(47.135,12.005),(47.305,12.005),(47.305,11.835),(47.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.835),(47.495,12.005),(47.665,12.005),(47.665,11.835),(47.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.835),(47.855,12.005),(48.025,12.005),(48.025,11.835),(47.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.195),(46.775,12.365),(46.945,12.365),(46.945,12.195),(46.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.195),(47.135,12.365),(47.305,12.365),(47.305,12.195),(47.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.195),(47.495,12.365),(47.665,12.365),(47.665,12.195),(47.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.195),(47.855,12.365),(48.025,12.365),(48.025,12.195),(47.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.555),(46.775,12.725),(46.945,12.725),(46.945,12.555),(46.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.555),(47.135,12.725),(47.305,12.725),(47.305,12.555),(47.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.555),(47.495,12.725),(47.665,12.725),(47.665,12.555),(47.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.555),(47.855,12.725),(48.025,12.725),(48.025,12.555),(47.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.915),(46.775,13.085),(46.945,13.085),(46.945,12.915),(46.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.915),(47.135,13.085),(47.305,13.085),(47.305,12.915),(47.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.915),(47.495,13.085),(47.665,13.085),(47.665,12.915),(47.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.915),(47.855,13.085),(48.025,13.085),(48.025,12.915),(47.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.275),(46.775,13.445),(46.945,13.445),(46.945,13.275),(46.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.275),(47.135,13.445),(47.305,13.445),(47.305,13.275),(47.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.275),(47.495,13.445),(47.665,13.445),(47.665,13.275),(47.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.275),(47.855,13.445),(48.025,13.445),(48.025,13.275),(47.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.635),(46.775,13.805),(46.945,13.805),(46.945,13.635),(46.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.635),(47.135,13.805),(47.305,13.805),(47.305,13.635),(47.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.635),(47.495,13.805),(47.665,13.805),(47.665,13.635),(47.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.635),(47.855,13.805),(48.025,13.805),(48.025,13.635),(47.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.995),(46.775,14.165),(46.945,14.165),(46.945,13.995),(46.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.995),(47.135,14.165),(47.305,14.165),(47.305,13.995),(47.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.995),(47.495,14.165),(47.665,14.165),(47.665,13.995),(47.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.995),(47.855,14.165),(48.025,14.165),(48.025,13.995),(47.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.355),(46.775,14.525),(46.945,14.525),(46.945,14.355),(46.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.355),(47.135,14.525),(47.305,14.525),(47.305,14.355),(47.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.355),(47.495,14.525),(47.665,14.525),(47.665,14.355),(47.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.355),(47.855,14.525),(48.025,14.525),(48.025,14.355),(47.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.715),(46.775,14.885),(46.945,14.885),(46.945,14.715),(46.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.715),(47.135,14.885),(47.305,14.885),(47.305,14.715),(47.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.715),(47.495,14.885),(47.665,14.885),(47.665,14.715),(47.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.715),(47.855,14.885),(48.025,14.885),(48.025,14.715),(47.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.075),(46.775,15.245),(46.945,15.245),(46.945,15.075),(46.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.075),(47.135,15.245),(47.305,15.245),(47.305,15.075),(47.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.075),(47.495,15.245),(47.665,15.245),(47.665,15.075),(47.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.075),(47.855,15.245),(48.025,15.245),(48.025,15.075),(47.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.435),(46.775,15.605),(46.945,15.605),(46.945,15.435),(46.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.435),(47.135,15.605),(47.305,15.605),(47.305,15.435),(47.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.435),(47.495,15.605),(47.665,15.605),(47.665,15.435),(47.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.435),(47.855,15.605),(48.025,15.605),(48.025,15.435),(47.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.795),(46.775,15.965),(46.945,15.965),(46.945,15.795),(46.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.795),(47.135,15.965),(47.305,15.965),(47.305,15.795),(47.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.795),(47.495,15.965),(47.665,15.965),(47.665,15.795),(47.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.795),(47.855,15.965),(48.025,15.965),(48.025,15.795),(47.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.155),(46.775,16.325),(46.945,16.325),(46.945,16.155),(46.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.155),(47.135,16.325),(47.305,16.325),(47.305,16.155),(47.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.155),(47.495,16.325),(47.665,16.325),(47.665,16.155),(47.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.155),(47.855,16.325),(48.025,16.325),(48.025,16.155),(47.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.515),(46.775,16.685),(46.945,16.685),(46.945,16.515),(46.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.515),(47.135,16.685),(47.305,16.685),(47.305,16.515),(47.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.515),(47.495,16.685),(47.665,16.685),(47.665,16.515),(47.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.515),(47.855,16.685),(48.025,16.685),(48.025,16.515),(47.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.875),(46.775,17.045),(46.945,17.045),(46.945,16.875),(46.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.875),(47.135,17.045),(47.305,17.045),(47.305,16.875),(47.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.875),(47.495,17.045),(47.665,17.045),(47.665,16.875),(47.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.875),(47.855,17.045),(48.025,17.045),(48.025,16.875),(47.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.235),(46.775,17.405),(46.945,17.405),(46.945,17.235),(46.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.235),(47.135,17.405),(47.305,17.405),(47.305,17.235),(47.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.235),(47.495,17.405),(47.665,17.405),(47.665,17.235),(47.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.235),(47.855,17.405),(48.025,17.405),(48.025,17.235),(47.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.595),(46.775,17.765),(46.945,17.765),(46.945,17.595),(46.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.595),(47.135,17.765),(47.305,17.765),(47.305,17.595),(47.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.595),(47.495,17.765),(47.665,17.765),(47.665,17.595),(47.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.595),(47.855,17.765),(48.025,17.765),(48.025,17.595),(47.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.955),(46.775,18.125),(46.945,18.125),(46.945,17.955),(46.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.955),(47.135,18.125),(47.305,18.125),(47.305,17.955),(47.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.955),(47.495,18.125),(47.665,18.125),(47.665,17.955),(47.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.955),(47.855,18.125),(48.025,18.125),(48.025,17.955),(47.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.315),(46.775,18.485),(46.945,18.485),(46.945,18.315),(46.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.315),(47.135,18.485),(47.305,18.485),(47.305,18.315),(47.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.315),(47.495,18.485),(47.665,18.485),(47.665,18.315),(47.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.315),(47.855,18.485),(48.025,18.485),(48.025,18.315),(47.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.675),(46.775,18.845),(46.945,18.845),(46.945,18.675),(46.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.675),(47.135,18.845),(47.305,18.845),(47.305,18.675),(47.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.675),(47.495,18.845),(47.665,18.845),(47.665,18.675),(47.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.675),(47.855,18.845),(48.025,18.845),(48.025,18.675),(47.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.035),(46.775,19.205),(46.945,19.205),(46.945,19.035),(46.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.035),(47.135,19.205),(47.305,19.205),(47.305,19.035),(47.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.035),(47.495,19.205),(47.665,19.205),(47.665,19.035),(47.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.035),(47.855,19.205),(48.025,19.205),(48.025,19.035),(47.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.395),(46.775,19.565),(46.945,19.565),(46.945,19.395),(46.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.395),(47.135,19.565),(47.305,19.565),(47.305,19.395),(47.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.395),(47.495,19.565),(47.665,19.565),(47.665,19.395),(47.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.395),(47.855,19.565),(48.025,19.565),(48.025,19.395),(47.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.755),(46.775,19.925),(46.945,19.925),(46.945,19.755),(46.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.755),(47.135,19.925),(47.305,19.925),(47.305,19.755),(47.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.755),(47.495,19.925),(47.665,19.925),(47.665,19.755),(47.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.755),(47.855,19.925),(48.025,19.925),(48.025,19.755),(47.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.115),(46.775,20.285),(46.945,20.285),(46.945,20.115),(46.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.115),(47.135,20.285),(47.305,20.285),(47.305,20.115),(47.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.115),(47.495,20.285),(47.665,20.285),(47.665,20.115),(47.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.115),(47.855,20.285),(48.025,20.285),(48.025,20.115),(47.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.475),(46.775,20.645),(46.945,20.645),(46.945,20.475),(46.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.475),(47.135,20.645),(47.305,20.645),(47.305,20.475),(47.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.475),(47.495,20.645),(47.665,20.645),(47.665,20.475),(47.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.475),(47.855,20.645),(48.025,20.645),(48.025,20.475),(47.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.835),(46.775,21.005),(46.945,21.005),(46.945,20.835),(46.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.835),(47.135,21.005),(47.305,21.005),(47.305,20.835),(47.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.835),(47.495,21.005),(47.665,21.005),(47.665,20.835),(47.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.835),(47.855,21.005),(48.025,21.005),(48.025,20.835),(47.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.195),(46.775,21.365),(46.945,21.365),(46.945,21.195),(46.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.195),(47.135,21.365),(47.305,21.365),(47.305,21.195),(47.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.195),(47.495,21.365),(47.665,21.365),(47.665,21.195),(47.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.195),(47.855,21.365),(48.025,21.365),(48.025,21.195),(47.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.555),(46.775,21.725),(46.945,21.725),(46.945,21.555),(46.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.555),(47.135,21.725),(47.305,21.725),(47.305,21.555),(47.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.555),(47.495,21.725),(47.665,21.725),(47.665,21.555),(47.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.555),(47.855,21.725),(48.025,21.725),(48.025,21.555),(47.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.915),(46.775,22.085),(46.945,22.085),(46.945,21.915),(46.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.915),(47.135,22.085),(47.305,22.085),(47.305,21.915),(47.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.915),(47.495,22.085),(47.665,22.085),(47.665,21.915),(47.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.915),(47.855,22.085),(48.025,22.085),(48.025,21.915),(47.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.275),(46.775,22.445),(46.945,22.445),(46.945,22.275),(46.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.275),(47.135,22.445),(47.305,22.445),(47.305,22.275),(47.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.275),(47.495,22.445),(47.665,22.445),(47.665,22.275),(47.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.275),(47.855,22.445),(48.025,22.445),(48.025,22.275),(47.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.635),(46.775,22.805),(46.945,22.805),(46.945,22.635),(46.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.635),(47.135,22.805),(47.305,22.805),(47.305,22.635),(47.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.635),(47.495,22.805),(47.665,22.805),(47.665,22.635),(47.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.635),(47.855,22.805),(48.025,22.805),(48.025,22.635),(47.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.995),(46.775,23.165),(46.945,23.165),(46.945,22.995),(46.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.995),(47.135,23.165),(47.305,23.165),(47.305,22.995),(47.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.995),(47.495,23.165),(47.665,23.165),(47.665,22.995),(47.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.995),(47.855,23.165),(48.025,23.165),(48.025,22.995),(47.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,23.355),(46.775,23.525),(46.945,23.525),(46.945,23.355),(46.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,23.355),(47.135,23.525),(47.305,23.525),(47.305,23.355),(47.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,23.355),(47.495,23.525),(47.665,23.525),(47.665,23.355),(47.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,23.355),(47.855,23.525),(48.025,23.525),(48.025,23.355),(47.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,23.715),(46.775,23.885),(46.945,23.885),(46.945,23.715),(46.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,23.715),(47.135,23.885),(47.305,23.885),(47.305,23.715),(47.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,23.715),(47.495,23.885),(47.665,23.885),(47.665,23.715),(47.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,23.715),(47.855,23.885),(48.025,23.885),(48.025,23.715),(47.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.075),(46.775,24.245),(46.945,24.245),(46.945,24.075),(46.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.075),(47.135,24.245),(47.305,24.245),(47.305,24.075),(47.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.075),(47.495,24.245),(47.665,24.245),(47.665,24.075),(47.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.075),(47.855,24.245),(48.025,24.245),(48.025,24.075),(47.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.435),(46.775,24.605),(46.945,24.605),(46.945,24.435),(46.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.435),(47.135,24.605),(47.305,24.605),(47.305,24.435),(47.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.435),(47.495,24.605),(47.665,24.605),(47.665,24.435),(47.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.435),(47.855,24.605),(48.025,24.605),(48.025,24.435),(47.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.795),(46.775,24.965),(46.945,24.965),(46.945,24.795),(46.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.795),(47.135,24.965),(47.305,24.965),(47.305,24.795),(47.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.795),(47.495,24.965),(47.665,24.965),(47.665,24.795),(47.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.795),(47.855,24.965),(48.025,24.965),(48.025,24.795),(47.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.155),(46.775,25.325),(46.945,25.325),(46.945,25.155),(46.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.155),(47.135,25.325),(47.305,25.325),(47.305,25.155),(47.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.155),(47.495,25.325),(47.665,25.325),(47.665,25.155),(47.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.155),(47.855,25.325),(48.025,25.325),(48.025,25.155),(47.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.515),(46.775,25.685),(46.945,25.685),(46.945,25.515),(46.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.515),(47.135,25.685),(47.305,25.685),(47.305,25.515),(47.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.515),(47.495,25.685),(47.665,25.685),(47.665,25.515),(47.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.515),(47.855,25.685),(48.025,25.685),(48.025,25.515),(47.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.875),(46.775,26.045),(46.945,26.045),(46.945,25.875),(46.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.875),(47.135,26.045),(47.305,26.045),(47.305,25.875),(47.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.875),(47.495,26.045),(47.665,26.045),(47.665,25.875),(47.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.875),(47.855,26.045),(48.025,26.045),(48.025,25.875),(47.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.235),(46.775,26.405),(46.945,26.405),(46.945,26.235),(46.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.235),(47.135,26.405),(47.305,26.405),(47.305,26.235),(47.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.235),(47.495,26.405),(47.665,26.405),(47.665,26.235),(47.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.235),(47.855,26.405),(48.025,26.405),(48.025,26.235),(47.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.595),(46.775,26.765),(46.945,26.765),(46.945,26.595),(46.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.595),(47.135,26.765),(47.305,26.765),(47.305,26.595),(47.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.595),(47.495,26.765),(47.665,26.765),(47.665,26.595),(47.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.595),(47.855,26.765),(48.025,26.765),(48.025,26.595),(47.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.955),(46.775,27.125),(46.945,27.125),(46.945,26.955),(46.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.955),(47.135,27.125),(47.305,27.125),(47.305,26.955),(47.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.955),(47.495,27.125),(47.665,27.125),(47.665,26.955),(47.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.955),(47.855,27.125),(48.025,27.125),(48.025,26.955),(47.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,27.315),(46.775,27.485),(46.945,27.485),(46.945,27.315),(46.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,27.315),(47.135,27.485),(47.305,27.485),(47.305,27.315),(47.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,27.315),(47.495,27.485),(47.665,27.485),(47.665,27.315),(47.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,27.315),(47.855,27.485),(48.025,27.485),(48.025,27.315),(47.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,27.675),(46.775,27.845),(46.945,27.845),(46.945,27.675),(46.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,27.675),(47.135,27.845),(47.305,27.845),(47.305,27.675),(47.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,27.675),(47.495,27.845),(47.665,27.845),(47.665,27.675),(47.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,27.675),(47.855,27.845),(48.025,27.845),(48.025,27.675),(47.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.035),(46.775,28.205),(46.945,28.205),(46.945,28.035),(46.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.035),(47.135,28.205),(47.305,28.205),(47.305,28.035),(47.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.035),(47.495,28.205),(47.665,28.205),(47.665,28.035),(47.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.035),(47.855,28.205),(48.025,28.205),(48.025,28.035),(47.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.395),(46.775,28.565),(46.945,28.565),(46.945,28.395),(46.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.395),(47.135,28.565),(47.305,28.565),(47.305,28.395),(47.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.395),(47.495,28.565),(47.665,28.565),(47.665,28.395),(47.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.395),(47.855,28.565),(48.025,28.565),(48.025,28.395),(47.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.755),(46.775,28.925),(46.945,28.925),(46.945,28.755),(46.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.755),(47.135,28.925),(47.305,28.925),(47.305,28.755),(47.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.755),(47.495,28.925),(47.665,28.925),(47.665,28.755),(47.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.755),(47.855,28.925),(48.025,28.925),(48.025,28.755),(47.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.115),(46.775,29.285),(46.945,29.285),(46.945,29.115),(46.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.115),(47.135,29.285),(47.305,29.285),(47.305,29.115),(47.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.115),(47.495,29.285),(47.665,29.285),(47.665,29.115),(47.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.115),(47.855,29.285),(48.025,29.285),(48.025,29.115),(47.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.475),(46.775,29.645),(46.945,29.645),(46.945,29.475),(46.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.475),(47.135,29.645),(47.305,29.645),(47.305,29.475),(47.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.475),(47.495,29.645),(47.665,29.645),(47.665,29.475),(47.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.475),(47.855,29.645),(48.025,29.645),(48.025,29.475),(47.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.835),(46.775,30.005),(46.945,30.005),(46.945,29.835),(46.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.835),(47.135,30.005),(47.305,30.005),(47.305,29.835),(47.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.835),(47.495,30.005),(47.665,30.005),(47.665,29.835),(47.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.835),(47.855,30.005),(48.025,30.005),(48.025,29.835),(47.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.195),(46.775,30.365),(46.945,30.365),(46.945,30.195),(46.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.195),(47.135,30.365),(47.305,30.365),(47.305,30.195),(47.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.195),(47.495,30.365),(47.665,30.365),(47.665,30.195),(47.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.195),(47.855,30.365),(48.025,30.365),(48.025,30.195),(47.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.555),(46.775,30.725),(46.945,30.725),(46.945,30.555),(46.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.555),(47.135,30.725),(47.305,30.725),(47.305,30.555),(47.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.555),(47.495,30.725),(47.665,30.725),(47.665,30.555),(47.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.555),(47.855,30.725),(48.025,30.725),(48.025,30.555),(47.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.915),(46.775,31.085),(46.945,31.085),(46.945,30.915),(46.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.915),(47.135,31.085),(47.305,31.085),(47.305,30.915),(47.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.915),(47.495,31.085),(47.665,31.085),(47.665,30.915),(47.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.915),(47.855,31.085),(48.025,31.085),(48.025,30.915),(47.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.275),(46.775,31.445),(46.945,31.445),(46.945,31.275),(46.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.275),(47.135,31.445),(47.305,31.445),(47.305,31.275),(47.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.275),(47.495,31.445),(47.665,31.445),(47.665,31.275),(47.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.275),(47.855,31.445),(48.025,31.445),(48.025,31.275),(47.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.635),(46.775,31.805),(46.945,31.805),(46.945,31.635),(46.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.635),(47.135,31.805),(47.305,31.805),(47.305,31.635),(47.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.635),(47.495,31.805),(47.665,31.805),(47.665,31.635),(47.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.635),(47.855,31.805),(48.025,31.805),(48.025,31.635),(47.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.995),(46.775,32.165),(46.945,32.165),(46.945,31.995),(46.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.995),(47.135,32.165),(47.305,32.165),(47.305,31.995),(47.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.995),(47.495,32.165),(47.665,32.165),(47.665,31.995),(47.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.995),(47.855,32.165),(48.025,32.165),(48.025,31.995),(47.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,32.355),(46.775,32.525),(46.945,32.525),(46.945,32.355),(46.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,32.355),(47.135,32.525),(47.305,32.525),(47.305,32.355),(47.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,32.355),(47.495,32.525),(47.665,32.525),(47.665,32.355),(47.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,32.355),(47.855,32.525),(48.025,32.525),(48.025,32.355),(47.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,32.715),(46.775,32.885),(46.945,32.885),(46.945,32.715),(46.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,32.715),(47.135,32.885),(47.305,32.885),(47.305,32.715),(47.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,32.715),(47.495,32.885),(47.665,32.885),(47.665,32.715),(47.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,32.715),(47.855,32.885),(48.025,32.885),(48.025,32.715),(47.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.075),(46.775,33.245),(46.945,33.245),(46.945,33.075),(46.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.075),(47.135,33.245),(47.305,33.245),(47.305,33.075),(47.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.075),(47.495,33.245),(47.665,33.245),(47.665,33.075),(47.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.075),(47.855,33.245),(48.025,33.245),(48.025,33.075),(47.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.435),(46.775,33.605),(46.945,33.605),(46.945,33.435),(46.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.435),(47.135,33.605),(47.305,33.605),(47.305,33.435),(47.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.435),(47.495,33.605),(47.665,33.605),(47.665,33.435),(47.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.435),(47.855,33.605),(48.025,33.605),(48.025,33.435),(47.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.795),(46.775,33.965),(46.945,33.965),(46.945,33.795),(46.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.795),(47.135,33.965),(47.305,33.965),(47.305,33.795),(47.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.795),(47.495,33.965),(47.665,33.965),(47.665,33.795),(47.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.795),(47.855,33.965),(48.025,33.965),(48.025,33.795),(47.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.155),(46.775,34.325),(46.945,34.325),(46.945,34.155),(46.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.155),(47.135,34.325),(47.305,34.325),(47.305,34.155),(47.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.155),(47.495,34.325),(47.665,34.325),(47.665,34.155),(47.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.155),(47.855,34.325),(48.025,34.325),(48.025,34.155),(47.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.515),(46.775,34.685),(46.945,34.685),(46.945,34.515),(46.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.515),(47.135,34.685),(47.305,34.685),(47.305,34.515),(47.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.515),(47.495,34.685),(47.665,34.685),(47.665,34.515),(47.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.515),(47.855,34.685),(48.025,34.685),(48.025,34.515),(47.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.875),(46.775,35.045),(46.945,35.045),(46.945,34.875),(46.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.875),(47.135,35.045),(47.305,35.045),(47.305,34.875),(47.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.875),(47.495,35.045),(47.665,35.045),(47.665,34.875),(47.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.875),(47.855,35.045),(48.025,35.045),(48.025,34.875),(47.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.235),(46.775,35.405),(46.945,35.405),(46.945,35.235),(46.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.235),(47.135,35.405),(47.305,35.405),(47.305,35.235),(47.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.235),(47.495,35.405),(47.665,35.405),(47.665,35.235),(47.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.235),(47.855,35.405),(48.025,35.405),(48.025,35.235),(47.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.595),(46.775,35.765),(46.945,35.765),(46.945,35.595),(46.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.595),(47.135,35.765),(47.305,35.765),(47.305,35.595),(47.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.595),(47.495,35.765),(47.665,35.765),(47.665,35.595),(47.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.595),(47.855,35.765),(48.025,35.765),(48.025,35.595),(47.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.955),(46.775,36.125),(46.945,36.125),(46.945,35.955),(46.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.955),(47.135,36.125),(47.305,36.125),(47.305,35.955),(47.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.955),(47.495,36.125),(47.665,36.125),(47.665,35.955),(47.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.955),(47.855,36.125),(48.025,36.125),(48.025,35.955),(47.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,36.315),(46.775,36.485),(46.945,36.485),(46.945,36.315),(46.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,36.315),(47.135,36.485),(47.305,36.485),(47.305,36.315),(47.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,36.315),(47.495,36.485),(47.665,36.485),(47.665,36.315),(47.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,36.315),(47.855,36.485),(48.025,36.485),(48.025,36.315),(47.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,36.675),(46.775,36.845),(46.945,36.845),(46.945,36.675),(46.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,36.675),(47.135,36.845),(47.305,36.845),(47.305,36.675),(47.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,36.675),(47.495,36.845),(47.665,36.845),(47.665,36.675),(47.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,36.675),(47.855,36.845),(48.025,36.845),(48.025,36.675),(47.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.035),(46.775,37.205),(46.945,37.205),(46.945,37.035),(46.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.035),(47.135,37.205),(47.305,37.205),(47.305,37.035),(47.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.035),(47.495,37.205),(47.665,37.205),(47.665,37.035),(47.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.035),(47.855,37.205),(48.025,37.205),(48.025,37.035),(47.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.395),(46.775,37.565),(46.945,37.565),(46.945,37.395),(46.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.395),(47.135,37.565),(47.305,37.565),(47.305,37.395),(47.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.395),(47.495,37.565),(47.665,37.565),(47.665,37.395),(47.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.395),(47.855,37.565),(48.025,37.565),(48.025,37.395),(47.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.755),(46.775,37.925),(46.945,37.925),(46.945,37.755),(46.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.755),(47.135,37.925),(47.305,37.925),(47.305,37.755),(47.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.755),(47.495,37.925),(47.665,37.925),(47.665,37.755),(47.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.755),(47.855,37.925),(48.025,37.925),(48.025,37.755),(47.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.115),(46.775,38.285),(46.945,38.285),(46.945,38.115),(46.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.115),(47.135,38.285),(47.305,38.285),(47.305,38.115),(47.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.115),(47.495,38.285),(47.665,38.285),(47.665,38.115),(47.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.115),(47.855,38.285),(48.025,38.285),(48.025,38.115),(47.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.475),(46.775,38.645),(46.945,38.645),(46.945,38.475),(46.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.475),(47.135,38.645),(47.305,38.645),(47.305,38.475),(47.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.475),(47.495,38.645),(47.665,38.645),(47.665,38.475),(47.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.475),(47.855,38.645),(48.025,38.645),(48.025,38.475),(47.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.835),(46.775,39.005),(46.945,39.005),(46.945,38.835),(46.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.835),(47.135,39.005),(47.305,39.005),(47.305,38.835),(47.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.835),(47.495,39.005),(47.665,39.005),(47.665,38.835),(47.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.835),(47.855,39.005),(48.025,39.005),(48.025,38.835),(47.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.195),(46.775,39.365),(46.945,39.365),(46.945,39.195),(46.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.195),(47.135,39.365),(47.305,39.365),(47.305,39.195),(47.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.195),(47.495,39.365),(47.665,39.365),(47.665,39.195),(47.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.195),(47.855,39.365),(48.025,39.365),(48.025,39.195),(47.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.555),(46.775,39.725),(46.945,39.725),(46.945,39.555),(46.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.555),(47.135,39.725),(47.305,39.725),(47.305,39.555),(47.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.555),(47.495,39.725),(47.665,39.725),(47.665,39.555),(47.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.555),(47.855,39.725),(48.025,39.725),(48.025,39.555),(47.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.915),(46.775,40.085),(46.945,40.085),(46.945,39.915),(46.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.915),(47.135,40.085),(47.305,40.085),(47.305,39.915),(47.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.915),(47.495,40.085),(47.665,40.085),(47.665,39.915),(47.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.915),(47.855,40.085),(48.025,40.085),(48.025,39.915),(47.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,40.275),(46.775,40.445),(46.945,40.445),(46.945,40.275),(46.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,40.275),(47.135,40.445),(47.305,40.445),(47.305,40.275),(47.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,40.275),(47.495,40.445),(47.665,40.445),(47.665,40.275),(47.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,40.275),(47.855,40.445),(48.025,40.445),(48.025,40.275),(47.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,40.635),(46.775,40.805),(46.945,40.805),(46.945,40.635),(46.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,40.635),(47.135,40.805),(47.305,40.805),(47.305,40.635),(47.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,40.635),(47.495,40.805),(47.665,40.805),(47.665,40.635),(47.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,40.635),(47.855,40.805),(48.025,40.805),(48.025,40.635),(47.855,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,2.835),(75.575,3.005),(75.745,3.005),(75.745,2.835),(75.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,2.835),(75.935,3.005),(76.105,3.005),(76.105,2.835),(75.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,2.835),(76.295,3.005),(76.465,3.005),(76.465,2.835),(76.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,2.835),(76.655,3.005),(76.825,3.005),(76.825,2.835),(76.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.195),(75.575,3.365),(75.745,3.365),(75.745,3.195),(75.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.195),(75.935,3.365),(76.105,3.365),(76.105,3.195),(75.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.195),(76.295,3.365),(76.465,3.365),(76.465,3.195),(76.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.195),(76.655,3.365),(76.825,3.365),(76.825,3.195),(76.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.555),(75.575,3.725),(75.745,3.725),(75.745,3.555),(75.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.555),(75.935,3.725),(76.105,3.725),(76.105,3.555),(75.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.555),(76.295,3.725),(76.465,3.725),(76.465,3.555),(76.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.555),(76.655,3.725),(76.825,3.725),(76.825,3.555),(76.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.915),(75.575,4.085),(75.745,4.085),(75.745,3.915),(75.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.915),(75.935,4.085),(76.105,4.085),(76.105,3.915),(75.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.915),(76.295,4.085),(76.465,4.085),(76.465,3.915),(76.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.915),(76.655,4.085),(76.825,4.085),(76.825,3.915),(76.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.275),(75.575,4.445),(75.745,4.445),(75.745,4.275),(75.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.275),(75.935,4.445),(76.105,4.445),(76.105,4.275),(75.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.275),(76.295,4.445),(76.465,4.445),(76.465,4.275),(76.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.275),(76.655,4.445),(76.825,4.445),(76.825,4.275),(76.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.635),(75.575,4.805),(75.745,4.805),(75.745,4.635),(75.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.635),(75.935,4.805),(76.105,4.805),(76.105,4.635),(75.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.635),(76.295,4.805),(76.465,4.805),(76.465,4.635),(76.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.635),(76.655,4.805),(76.825,4.805),(76.825,4.635),(76.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.995),(75.575,5.165),(75.745,5.165),(75.745,4.995),(75.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.995),(75.935,5.165),(76.105,5.165),(76.105,4.995),(75.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.995),(76.295,5.165),(76.465,5.165),(76.465,4.995),(76.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.995),(76.655,5.165),(76.825,5.165),(76.825,4.995),(76.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.355),(75.575,5.525),(75.745,5.525),(75.745,5.355),(75.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.355),(75.935,5.525),(76.105,5.525),(76.105,5.355),(75.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.355),(76.295,5.525),(76.465,5.525),(76.465,5.355),(76.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.355),(76.655,5.525),(76.825,5.525),(76.825,5.355),(76.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.715),(75.575,5.885),(75.745,5.885),(75.745,5.715),(75.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.715),(75.935,5.885),(76.105,5.885),(76.105,5.715),(75.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.715),(76.295,5.885),(76.465,5.885),(76.465,5.715),(76.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.715),(76.655,5.885),(76.825,5.885),(76.825,5.715),(76.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.075),(75.575,6.245),(75.745,6.245),(75.745,6.075),(75.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.075),(75.935,6.245),(76.105,6.245),(76.105,6.075),(75.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.075),(76.295,6.245),(76.465,6.245),(76.465,6.075),(76.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.075),(76.655,6.245),(76.825,6.245),(76.825,6.075),(76.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.435),(75.575,6.605),(75.745,6.605),(75.745,6.435),(75.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.435),(75.935,6.605),(76.105,6.605),(76.105,6.435),(75.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.435),(76.295,6.605),(76.465,6.605),(76.465,6.435),(76.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.435),(76.655,6.605),(76.825,6.605),(76.825,6.435),(76.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.795),(75.575,6.965),(75.745,6.965),(75.745,6.795),(75.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.795),(75.935,6.965),(76.105,6.965),(76.105,6.795),(75.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.795),(76.295,6.965),(76.465,6.965),(76.465,6.795),(76.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.795),(76.655,6.965),(76.825,6.965),(76.825,6.795),(76.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.155),(75.575,7.325),(75.745,7.325),(75.745,7.155),(75.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.155),(75.935,7.325),(76.105,7.325),(76.105,7.155),(75.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.155),(76.295,7.325),(76.465,7.325),(76.465,7.155),(76.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.155),(76.655,7.325),(76.825,7.325),(76.825,7.155),(76.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.515),(75.575,7.685),(75.745,7.685),(75.745,7.515),(75.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.515),(75.935,7.685),(76.105,7.685),(76.105,7.515),(75.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.515),(76.295,7.685),(76.465,7.685),(76.465,7.515),(76.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.515),(76.655,7.685),(76.825,7.685),(76.825,7.515),(76.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.875),(75.575,8.045),(75.745,8.045),(75.745,7.875),(75.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.875),(75.935,8.045),(76.105,8.045),(76.105,7.875),(75.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.875),(76.295,8.045),(76.465,8.045),(76.465,7.875),(76.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.875),(76.655,8.045),(76.825,8.045),(76.825,7.875),(76.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.235),(75.575,8.405),(75.745,8.405),(75.745,8.235),(75.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.235),(75.935,8.405),(76.105,8.405),(76.105,8.235),(75.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.235),(76.295,8.405),(76.465,8.405),(76.465,8.235),(76.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.235),(76.655,8.405),(76.825,8.405),(76.825,8.235),(76.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.595),(75.575,8.765),(75.745,8.765),(75.745,8.595),(75.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.595),(75.935,8.765),(76.105,8.765),(76.105,8.595),(75.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.595),(76.295,8.765),(76.465,8.765),(76.465,8.595),(76.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.595),(76.655,8.765),(76.825,8.765),(76.825,8.595),(76.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.955),(75.575,9.125),(75.745,9.125),(75.745,8.955),(75.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.955),(75.935,9.125),(76.105,9.125),(76.105,8.955),(75.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.955),(76.295,9.125),(76.465,9.125),(76.465,8.955),(76.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.955),(76.655,9.125),(76.825,9.125),(76.825,8.955),(76.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.315),(75.575,9.485),(75.745,9.485),(75.745,9.315),(75.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.315),(75.935,9.485),(76.105,9.485),(76.105,9.315),(75.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.315),(76.295,9.485),(76.465,9.485),(76.465,9.315),(76.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.315),(76.655,9.485),(76.825,9.485),(76.825,9.315),(76.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.675),(75.575,9.845),(75.745,9.845),(75.745,9.675),(75.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.675),(75.935,9.845),(76.105,9.845),(76.105,9.675),(75.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.675),(76.295,9.845),(76.465,9.845),(76.465,9.675),(76.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.675),(76.655,9.845),(76.825,9.845),(76.825,9.675),(76.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.035),(75.575,10.205),(75.745,10.205),(75.745,10.035),(75.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.035),(75.935,10.205),(76.105,10.205),(76.105,10.035),(75.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.035),(76.295,10.205),(76.465,10.205),(76.465,10.035),(76.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.035),(76.655,10.205),(76.825,10.205),(76.825,10.035),(76.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.395),(75.575,10.565),(75.745,10.565),(75.745,10.395),(75.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.395),(75.935,10.565),(76.105,10.565),(76.105,10.395),(75.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.395),(76.295,10.565),(76.465,10.565),(76.465,10.395),(76.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.395),(76.655,10.565),(76.825,10.565),(76.825,10.395),(76.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.755),(75.575,10.925),(75.745,10.925),(75.745,10.755),(75.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.755),(75.935,10.925),(76.105,10.925),(76.105,10.755),(75.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.755),(76.295,10.925),(76.465,10.925),(76.465,10.755),(76.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.755),(76.655,10.925),(76.825,10.925),(76.825,10.755),(76.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.115),(75.575,11.285),(75.745,11.285),(75.745,11.115),(75.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.115),(75.935,11.285),(76.105,11.285),(76.105,11.115),(75.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.115),(76.295,11.285),(76.465,11.285),(76.465,11.115),(76.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.115),(76.655,11.285),(76.825,11.285),(76.825,11.115),(76.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.475),(75.575,11.645),(75.745,11.645),(75.745,11.475),(75.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.475),(75.935,11.645),(76.105,11.645),(76.105,11.475),(75.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.475),(76.295,11.645),(76.465,11.645),(76.465,11.475),(76.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.475),(76.655,11.645),(76.825,11.645),(76.825,11.475),(76.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.835),(75.575,12.005),(75.745,12.005),(75.745,11.835),(75.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.835),(75.935,12.005),(76.105,12.005),(76.105,11.835),(75.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.835),(76.295,12.005),(76.465,12.005),(76.465,11.835),(76.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.835),(76.655,12.005),(76.825,12.005),(76.825,11.835),(76.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.195),(75.575,12.365),(75.745,12.365),(75.745,12.195),(75.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.195),(75.935,12.365),(76.105,12.365),(76.105,12.195),(75.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.195),(76.295,12.365),(76.465,12.365),(76.465,12.195),(76.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.195),(76.655,12.365),(76.825,12.365),(76.825,12.195),(76.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.555),(75.575,12.725),(75.745,12.725),(75.745,12.555),(75.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.555),(75.935,12.725),(76.105,12.725),(76.105,12.555),(75.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.555),(76.295,12.725),(76.465,12.725),(76.465,12.555),(76.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.555),(76.655,12.725),(76.825,12.725),(76.825,12.555),(76.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.915),(75.575,13.085),(75.745,13.085),(75.745,12.915),(75.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.915),(75.935,13.085),(76.105,13.085),(76.105,12.915),(75.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.915),(76.295,13.085),(76.465,13.085),(76.465,12.915),(76.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.915),(76.655,13.085),(76.825,13.085),(76.825,12.915),(76.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.275),(75.575,13.445),(75.745,13.445),(75.745,13.275),(75.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.275),(75.935,13.445),(76.105,13.445),(76.105,13.275),(75.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.275),(76.295,13.445),(76.465,13.445),(76.465,13.275),(76.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.275),(76.655,13.445),(76.825,13.445),(76.825,13.275),(76.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.635),(75.575,13.805),(75.745,13.805),(75.745,13.635),(75.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.635),(75.935,13.805),(76.105,13.805),(76.105,13.635),(75.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.635),(76.295,13.805),(76.465,13.805),(76.465,13.635),(76.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.635),(76.655,13.805),(76.825,13.805),(76.825,13.635),(76.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.995),(75.575,14.165),(75.745,14.165),(75.745,13.995),(75.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.995),(75.935,14.165),(76.105,14.165),(76.105,13.995),(75.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.995),(76.295,14.165),(76.465,14.165),(76.465,13.995),(76.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.995),(76.655,14.165),(76.825,14.165),(76.825,13.995),(76.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.355),(75.575,14.525),(75.745,14.525),(75.745,14.355),(75.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.355),(75.935,14.525),(76.105,14.525),(76.105,14.355),(75.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.355),(76.295,14.525),(76.465,14.525),(76.465,14.355),(76.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.355),(76.655,14.525),(76.825,14.525),(76.825,14.355),(76.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.715),(75.575,14.885),(75.745,14.885),(75.745,14.715),(75.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.715),(75.935,14.885),(76.105,14.885),(76.105,14.715),(75.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.715),(76.295,14.885),(76.465,14.885),(76.465,14.715),(76.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.715),(76.655,14.885),(76.825,14.885),(76.825,14.715),(76.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.075),(75.575,15.245),(75.745,15.245),(75.745,15.075),(75.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.075),(75.935,15.245),(76.105,15.245),(76.105,15.075),(75.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.075),(76.295,15.245),(76.465,15.245),(76.465,15.075),(76.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.075),(76.655,15.245),(76.825,15.245),(76.825,15.075),(76.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.435),(75.575,15.605),(75.745,15.605),(75.745,15.435),(75.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.435),(75.935,15.605),(76.105,15.605),(76.105,15.435),(75.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.435),(76.295,15.605),(76.465,15.605),(76.465,15.435),(76.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.435),(76.655,15.605),(76.825,15.605),(76.825,15.435),(76.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.795),(75.575,15.965),(75.745,15.965),(75.745,15.795),(75.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.795),(75.935,15.965),(76.105,15.965),(76.105,15.795),(75.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.795),(76.295,15.965),(76.465,15.965),(76.465,15.795),(76.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.795),(76.655,15.965),(76.825,15.965),(76.825,15.795),(76.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.155),(75.575,16.325),(75.745,16.325),(75.745,16.155),(75.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.155),(75.935,16.325),(76.105,16.325),(76.105,16.155),(75.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.155),(76.295,16.325),(76.465,16.325),(76.465,16.155),(76.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.155),(76.655,16.325),(76.825,16.325),(76.825,16.155),(76.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.515),(75.575,16.685),(75.745,16.685),(75.745,16.515),(75.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.515),(75.935,16.685),(76.105,16.685),(76.105,16.515),(75.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.515),(76.295,16.685),(76.465,16.685),(76.465,16.515),(76.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.515),(76.655,16.685),(76.825,16.685),(76.825,16.515),(76.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.875),(75.575,17.045),(75.745,17.045),(75.745,16.875),(75.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.875),(75.935,17.045),(76.105,17.045),(76.105,16.875),(75.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.875),(76.295,17.045),(76.465,17.045),(76.465,16.875),(76.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.875),(76.655,17.045),(76.825,17.045),(76.825,16.875),(76.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.235),(75.575,17.405),(75.745,17.405),(75.745,17.235),(75.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.235),(75.935,17.405),(76.105,17.405),(76.105,17.235),(75.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.235),(76.295,17.405),(76.465,17.405),(76.465,17.235),(76.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.235),(76.655,17.405),(76.825,17.405),(76.825,17.235),(76.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.595),(75.575,17.765),(75.745,17.765),(75.745,17.595),(75.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.595),(75.935,17.765),(76.105,17.765),(76.105,17.595),(75.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.595),(76.295,17.765),(76.465,17.765),(76.465,17.595),(76.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.595),(76.655,17.765),(76.825,17.765),(76.825,17.595),(76.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.955),(75.575,18.125),(75.745,18.125),(75.745,17.955),(75.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.955),(75.935,18.125),(76.105,18.125),(76.105,17.955),(75.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.955),(76.295,18.125),(76.465,18.125),(76.465,17.955),(76.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.955),(76.655,18.125),(76.825,18.125),(76.825,17.955),(76.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.315),(75.575,18.485),(75.745,18.485),(75.745,18.315),(75.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.315),(75.935,18.485),(76.105,18.485),(76.105,18.315),(75.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.315),(76.295,18.485),(76.465,18.485),(76.465,18.315),(76.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.315),(76.655,18.485),(76.825,18.485),(76.825,18.315),(76.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.675),(75.575,18.845),(75.745,18.845),(75.745,18.675),(75.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.675),(75.935,18.845),(76.105,18.845),(76.105,18.675),(75.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.675),(76.295,18.845),(76.465,18.845),(76.465,18.675),(76.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.675),(76.655,18.845),(76.825,18.845),(76.825,18.675),(76.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.035),(75.575,19.205),(75.745,19.205),(75.745,19.035),(75.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.035),(75.935,19.205),(76.105,19.205),(76.105,19.035),(75.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.035),(76.295,19.205),(76.465,19.205),(76.465,19.035),(76.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.035),(76.655,19.205),(76.825,19.205),(76.825,19.035),(76.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.395),(75.575,19.565),(75.745,19.565),(75.745,19.395),(75.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.395),(75.935,19.565),(76.105,19.565),(76.105,19.395),(75.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.395),(76.295,19.565),(76.465,19.565),(76.465,19.395),(76.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.395),(76.655,19.565),(76.825,19.565),(76.825,19.395),(76.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.755),(75.575,19.925),(75.745,19.925),(75.745,19.755),(75.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.755),(75.935,19.925),(76.105,19.925),(76.105,19.755),(75.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.755),(76.295,19.925),(76.465,19.925),(76.465,19.755),(76.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.755),(76.655,19.925),(76.825,19.925),(76.825,19.755),(76.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,20.115),(75.575,20.285),(75.745,20.285),(75.745,20.115),(75.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,20.115),(75.935,20.285),(76.105,20.285),(76.105,20.115),(75.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,20.115),(76.295,20.285),(76.465,20.285),(76.465,20.115),(76.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,20.115),(76.655,20.285),(76.825,20.285),(76.825,20.115),(76.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,20.475),(75.575,20.645),(75.745,20.645),(75.745,20.475),(75.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,20.475),(75.935,20.645),(76.105,20.645),(76.105,20.475),(75.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,20.475),(76.295,20.645),(76.465,20.645),(76.465,20.475),(76.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,20.475),(76.655,20.645),(76.825,20.645),(76.825,20.475),(76.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,20.835),(75.575,21.005),(75.745,21.005),(75.745,20.835),(75.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,20.835),(75.935,21.005),(76.105,21.005),(76.105,20.835),(75.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,20.835),(76.295,21.005),(76.465,21.005),(76.465,20.835),(76.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,20.835),(76.655,21.005),(76.825,21.005),(76.825,20.835),(76.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,21.195),(75.575,21.365),(75.745,21.365),(75.745,21.195),(75.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,21.195),(75.935,21.365),(76.105,21.365),(76.105,21.195),(75.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,21.195),(76.295,21.365),(76.465,21.365),(76.465,21.195),(76.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,21.195),(76.655,21.365),(76.825,21.365),(76.825,21.195),(76.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,21.555),(75.575,21.725),(75.745,21.725),(75.745,21.555),(75.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,21.555),(75.935,21.725),(76.105,21.725),(76.105,21.555),(75.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,21.555),(76.295,21.725),(76.465,21.725),(76.465,21.555),(76.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,21.555),(76.655,21.725),(76.825,21.725),(76.825,21.555),(76.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,21.915),(75.575,22.085),(75.745,22.085),(75.745,21.915),(75.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,21.915),(75.935,22.085),(76.105,22.085),(76.105,21.915),(75.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,21.915),(76.295,22.085),(76.465,22.085),(76.465,21.915),(76.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,21.915),(76.655,22.085),(76.825,22.085),(76.825,21.915),(76.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.275),(75.575,22.445),(75.745,22.445),(75.745,22.275),(75.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.275),(75.935,22.445),(76.105,22.445),(76.105,22.275),(75.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.275),(76.295,22.445),(76.465,22.445),(76.465,22.275),(76.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.275),(76.655,22.445),(76.825,22.445),(76.825,22.275),(76.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.635),(75.575,22.805),(75.745,22.805),(75.745,22.635),(75.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.635),(75.935,22.805),(76.105,22.805),(76.105,22.635),(75.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.635),(76.295,22.805),(76.465,22.805),(76.465,22.635),(76.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.635),(76.655,22.805),(76.825,22.805),(76.825,22.635),(76.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.995),(75.575,23.165),(75.745,23.165),(75.745,22.995),(75.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.995),(75.935,23.165),(76.105,23.165),(76.105,22.995),(75.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.995),(76.295,23.165),(76.465,23.165),(76.465,22.995),(76.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.995),(76.655,23.165),(76.825,23.165),(76.825,22.995),(76.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,23.355),(75.575,23.525),(75.745,23.525),(75.745,23.355),(75.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,23.355),(75.935,23.525),(76.105,23.525),(76.105,23.355),(75.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,23.355),(76.295,23.525),(76.465,23.525),(76.465,23.355),(76.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,23.355),(76.655,23.525),(76.825,23.525),(76.825,23.355),(76.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,23.715),(75.575,23.885),(75.745,23.885),(75.745,23.715),(75.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,23.715),(75.935,23.885),(76.105,23.885),(76.105,23.715),(75.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,23.715),(76.295,23.885),(76.465,23.885),(76.465,23.715),(76.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,23.715),(76.655,23.885),(76.825,23.885),(76.825,23.715),(76.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,24.075),(75.575,24.245),(75.745,24.245),(75.745,24.075),(75.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,24.075),(75.935,24.245),(76.105,24.245),(76.105,24.075),(75.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,24.075),(76.295,24.245),(76.465,24.245),(76.465,24.075),(76.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,24.075),(76.655,24.245),(76.825,24.245),(76.825,24.075),(76.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,24.435),(75.575,24.605),(75.745,24.605),(75.745,24.435),(75.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,24.435),(75.935,24.605),(76.105,24.605),(76.105,24.435),(75.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,24.435),(76.295,24.605),(76.465,24.605),(76.465,24.435),(76.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,24.435),(76.655,24.605),(76.825,24.605),(76.825,24.435),(76.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,24.795),(75.575,24.965),(75.745,24.965),(75.745,24.795),(75.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,24.795),(75.935,24.965),(76.105,24.965),(76.105,24.795),(75.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,24.795),(76.295,24.965),(76.465,24.965),(76.465,24.795),(76.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,24.795),(76.655,24.965),(76.825,24.965),(76.825,24.795),(76.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,25.155),(75.575,25.325),(75.745,25.325),(75.745,25.155),(75.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,25.155),(75.935,25.325),(76.105,25.325),(76.105,25.155),(75.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,25.155),(76.295,25.325),(76.465,25.325),(76.465,25.155),(76.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,25.155),(76.655,25.325),(76.825,25.325),(76.825,25.155),(76.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,25.515),(75.575,25.685),(75.745,25.685),(75.745,25.515),(75.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,25.515),(75.935,25.685),(76.105,25.685),(76.105,25.515),(75.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,25.515),(76.295,25.685),(76.465,25.685),(76.465,25.515),(76.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,25.515),(76.655,25.685),(76.825,25.685),(76.825,25.515),(76.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,25.875),(75.575,26.045),(75.745,26.045),(75.745,25.875),(75.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,25.875),(75.935,26.045),(76.105,26.045),(76.105,25.875),(75.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,25.875),(76.295,26.045),(76.465,26.045),(76.465,25.875),(76.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,25.875),(76.655,26.045),(76.825,26.045),(76.825,25.875),(76.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,26.235),(75.575,26.405),(75.745,26.405),(75.745,26.235),(75.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,26.235),(75.935,26.405),(76.105,26.405),(76.105,26.235),(75.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,26.235),(76.295,26.405),(76.465,26.405),(76.465,26.235),(76.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,26.235),(76.655,26.405),(76.825,26.405),(76.825,26.235),(76.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,26.595),(75.575,26.765),(75.745,26.765),(75.745,26.595),(75.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,26.595),(75.935,26.765),(76.105,26.765),(76.105,26.595),(75.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,26.595),(76.295,26.765),(76.465,26.765),(76.465,26.595),(76.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,26.595),(76.655,26.765),(76.825,26.765),(76.825,26.595),(76.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,26.955),(75.575,27.125),(75.745,27.125),(75.745,26.955),(75.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,26.955),(75.935,27.125),(76.105,27.125),(76.105,26.955),(75.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,26.955),(76.295,27.125),(76.465,27.125),(76.465,26.955),(76.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,26.955),(76.655,27.125),(76.825,27.125),(76.825,26.955),(76.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,27.315),(75.575,27.485),(75.745,27.485),(75.745,27.315),(75.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,27.315),(75.935,27.485),(76.105,27.485),(76.105,27.315),(75.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,27.315),(76.295,27.485),(76.465,27.485),(76.465,27.315),(76.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,27.315),(76.655,27.485),(76.825,27.485),(76.825,27.315),(76.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,27.675),(75.575,27.845),(75.745,27.845),(75.745,27.675),(75.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,27.675),(75.935,27.845),(76.105,27.845),(76.105,27.675),(75.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,27.675),(76.295,27.845),(76.465,27.845),(76.465,27.675),(76.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,27.675),(76.655,27.845),(76.825,27.845),(76.825,27.675),(76.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,28.035),(75.575,28.205),(75.745,28.205),(75.745,28.035),(75.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,28.035),(75.935,28.205),(76.105,28.205),(76.105,28.035),(75.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,28.035),(76.295,28.205),(76.465,28.205),(76.465,28.035),(76.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,28.035),(76.655,28.205),(76.825,28.205),(76.825,28.035),(76.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,28.395),(75.575,28.565),(75.745,28.565),(75.745,28.395),(75.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,28.395),(75.935,28.565),(76.105,28.565),(76.105,28.395),(75.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,28.395),(76.295,28.565),(76.465,28.565),(76.465,28.395),(76.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,28.395),(76.655,28.565),(76.825,28.565),(76.825,28.395),(76.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,28.755),(75.575,28.925),(75.745,28.925),(75.745,28.755),(75.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,28.755),(75.935,28.925),(76.105,28.925),(76.105,28.755),(75.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,28.755),(76.295,28.925),(76.465,28.925),(76.465,28.755),(76.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,28.755),(76.655,28.925),(76.825,28.925),(76.825,28.755),(76.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,29.115),(75.575,29.285),(75.745,29.285),(75.745,29.115),(75.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,29.115),(75.935,29.285),(76.105,29.285),(76.105,29.115),(75.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,29.115),(76.295,29.285),(76.465,29.285),(76.465,29.115),(76.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,29.115),(76.655,29.285),(76.825,29.285),(76.825,29.115),(76.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,29.475),(75.575,29.645),(75.745,29.645),(75.745,29.475),(75.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,29.475),(75.935,29.645),(76.105,29.645),(76.105,29.475),(75.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,29.475),(76.295,29.645),(76.465,29.645),(76.465,29.475),(76.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,29.475),(76.655,29.645),(76.825,29.645),(76.825,29.475),(76.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,29.835),(75.575,30.005),(75.745,30.005),(75.745,29.835),(75.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,29.835),(75.935,30.005),(76.105,30.005),(76.105,29.835),(75.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,29.835),(76.295,30.005),(76.465,30.005),(76.465,29.835),(76.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,29.835),(76.655,30.005),(76.825,30.005),(76.825,29.835),(76.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,30.195),(75.575,30.365),(75.745,30.365),(75.745,30.195),(75.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,30.195),(75.935,30.365),(76.105,30.365),(76.105,30.195),(75.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,30.195),(76.295,30.365),(76.465,30.365),(76.465,30.195),(76.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,30.195),(76.655,30.365),(76.825,30.365),(76.825,30.195),(76.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,30.555),(75.575,30.725),(75.745,30.725),(75.745,30.555),(75.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,30.555),(75.935,30.725),(76.105,30.725),(76.105,30.555),(75.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,30.555),(76.295,30.725),(76.465,30.725),(76.465,30.555),(76.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,30.555),(76.655,30.725),(76.825,30.725),(76.825,30.555),(76.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,30.915),(75.575,31.085),(75.745,31.085),(75.745,30.915),(75.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,30.915),(75.935,31.085),(76.105,31.085),(76.105,30.915),(75.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,30.915),(76.295,31.085),(76.465,31.085),(76.465,30.915),(76.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,30.915),(76.655,31.085),(76.825,31.085),(76.825,30.915),(76.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,31.275),(75.575,31.445),(75.745,31.445),(75.745,31.275),(75.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,31.275),(75.935,31.445),(76.105,31.445),(76.105,31.275),(75.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,31.275),(76.295,31.445),(76.465,31.445),(76.465,31.275),(76.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,31.275),(76.655,31.445),(76.825,31.445),(76.825,31.275),(76.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,31.635),(75.575,31.805),(75.745,31.805),(75.745,31.635),(75.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,31.635),(75.935,31.805),(76.105,31.805),(76.105,31.635),(75.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,31.635),(76.295,31.805),(76.465,31.805),(76.465,31.635),(76.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,31.635),(76.655,31.805),(76.825,31.805),(76.825,31.635),(76.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,31.995),(75.575,32.165),(75.745,32.165),(75.745,31.995),(75.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,31.995),(75.935,32.165),(76.105,32.165),(76.105,31.995),(75.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,31.995),(76.295,32.165),(76.465,32.165),(76.465,31.995),(76.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,31.995),(76.655,32.165),(76.825,32.165),(76.825,31.995),(76.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,32.355),(75.575,32.525),(75.745,32.525),(75.745,32.355),(75.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,32.355),(75.935,32.525),(76.105,32.525),(76.105,32.355),(75.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,32.355),(76.295,32.525),(76.465,32.525),(76.465,32.355),(76.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,32.355),(76.655,32.525),(76.825,32.525),(76.825,32.355),(76.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,32.715),(75.575,32.885),(75.745,32.885),(75.745,32.715),(75.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,32.715),(75.935,32.885),(76.105,32.885),(76.105,32.715),(75.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,32.715),(76.295,32.885),(76.465,32.885),(76.465,32.715),(76.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,32.715),(76.655,32.885),(76.825,32.885),(76.825,32.715),(76.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,33.075),(75.575,33.245),(75.745,33.245),(75.745,33.075),(75.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,33.075),(75.935,33.245),(76.105,33.245),(76.105,33.075),(75.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,33.075),(76.295,33.245),(76.465,33.245),(76.465,33.075),(76.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,33.075),(76.655,33.245),(76.825,33.245),(76.825,33.075),(76.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,33.435),(75.575,33.605),(75.745,33.605),(75.745,33.435),(75.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,33.435),(75.935,33.605),(76.105,33.605),(76.105,33.435),(75.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,33.435),(76.295,33.605),(76.465,33.605),(76.465,33.435),(76.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,33.435),(76.655,33.605),(76.825,33.605),(76.825,33.435),(76.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,33.795),(75.575,33.965),(75.745,33.965),(75.745,33.795),(75.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,33.795),(75.935,33.965),(76.105,33.965),(76.105,33.795),(75.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,33.795),(76.295,33.965),(76.465,33.965),(76.465,33.795),(76.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,33.795),(76.655,33.965),(76.825,33.965),(76.825,33.795),(76.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,34.155),(75.575,34.325),(75.745,34.325),(75.745,34.155),(75.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,34.155),(75.935,34.325),(76.105,34.325),(76.105,34.155),(75.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,34.155),(76.295,34.325),(76.465,34.325),(76.465,34.155),(76.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,34.155),(76.655,34.325),(76.825,34.325),(76.825,34.155),(76.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,34.515),(75.575,34.685),(75.745,34.685),(75.745,34.515),(75.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,34.515),(75.935,34.685),(76.105,34.685),(76.105,34.515),(75.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,34.515),(76.295,34.685),(76.465,34.685),(76.465,34.515),(76.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,34.515),(76.655,34.685),(76.825,34.685),(76.825,34.515),(76.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,34.875),(75.575,35.045),(75.745,35.045),(75.745,34.875),(75.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,34.875),(75.935,35.045),(76.105,35.045),(76.105,34.875),(75.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,34.875),(76.295,35.045),(76.465,35.045),(76.465,34.875),(76.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,34.875),(76.655,35.045),(76.825,35.045),(76.825,34.875),(76.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,35.235),(75.575,35.405),(75.745,35.405),(75.745,35.235),(75.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,35.235),(75.935,35.405),(76.105,35.405),(76.105,35.235),(75.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,35.235),(76.295,35.405),(76.465,35.405),(76.465,35.235),(76.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,35.235),(76.655,35.405),(76.825,35.405),(76.825,35.235),(76.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,35.595),(75.575,35.765),(75.745,35.765),(75.745,35.595),(75.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,35.595),(75.935,35.765),(76.105,35.765),(76.105,35.595),(75.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,35.595),(76.295,35.765),(76.465,35.765),(76.465,35.595),(76.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,35.595),(76.655,35.765),(76.825,35.765),(76.825,35.595),(76.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,35.955),(75.575,36.125),(75.745,36.125),(75.745,35.955),(75.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,35.955),(75.935,36.125),(76.105,36.125),(76.105,35.955),(75.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,35.955),(76.295,36.125),(76.465,36.125),(76.465,35.955),(76.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,35.955),(76.655,36.125),(76.825,36.125),(76.825,35.955),(76.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,36.315),(75.575,36.485),(75.745,36.485),(75.745,36.315),(75.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,36.315),(75.935,36.485),(76.105,36.485),(76.105,36.315),(75.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,36.315),(76.295,36.485),(76.465,36.485),(76.465,36.315),(76.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,36.315),(76.655,36.485),(76.825,36.485),(76.825,36.315),(76.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,36.675),(75.575,36.845),(75.745,36.845),(75.745,36.675),(75.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,36.675),(75.935,36.845),(76.105,36.845),(76.105,36.675),(75.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,36.675),(76.295,36.845),(76.465,36.845),(76.465,36.675),(76.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,36.675),(76.655,36.845),(76.825,36.845),(76.825,36.675),(76.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,37.035),(75.575,37.205),(75.745,37.205),(75.745,37.035),(75.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,37.035),(75.935,37.205),(76.105,37.205),(76.105,37.035),(75.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,37.035),(76.295,37.205),(76.465,37.205),(76.465,37.035),(76.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,37.035),(76.655,37.205),(76.825,37.205),(76.825,37.035),(76.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,37.395),(75.575,37.565),(75.745,37.565),(75.745,37.395),(75.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,37.395),(75.935,37.565),(76.105,37.565),(76.105,37.395),(75.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,37.395),(76.295,37.565),(76.465,37.565),(76.465,37.395),(76.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,37.395),(76.655,37.565),(76.825,37.565),(76.825,37.395),(76.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,37.755),(75.575,37.925),(75.745,37.925),(75.745,37.755),(75.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,37.755),(75.935,37.925),(76.105,37.925),(76.105,37.755),(75.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,37.755),(76.295,37.925),(76.465,37.925),(76.465,37.755),(76.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,37.755),(76.655,37.925),(76.825,37.925),(76.825,37.755),(76.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,38.115),(75.575,38.285),(75.745,38.285),(75.745,38.115),(75.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,38.115),(75.935,38.285),(76.105,38.285),(76.105,38.115),(75.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,38.115),(76.295,38.285),(76.465,38.285),(76.465,38.115),(76.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,38.115),(76.655,38.285),(76.825,38.285),(76.825,38.115),(76.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,38.475),(75.575,38.645),(75.745,38.645),(75.745,38.475),(75.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,38.475),(75.935,38.645),(76.105,38.645),(76.105,38.475),(75.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,38.475),(76.295,38.645),(76.465,38.645),(76.465,38.475),(76.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,38.475),(76.655,38.645),(76.825,38.645),(76.825,38.475),(76.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,38.835),(75.575,39.005),(75.745,39.005),(75.745,38.835),(75.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,38.835),(75.935,39.005),(76.105,39.005),(76.105,38.835),(75.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,38.835),(76.295,39.005),(76.465,39.005),(76.465,38.835),(76.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,38.835),(76.655,39.005),(76.825,39.005),(76.825,38.835),(76.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,39.195),(75.575,39.365),(75.745,39.365),(75.745,39.195),(75.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,39.195),(75.935,39.365),(76.105,39.365),(76.105,39.195),(75.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,39.195),(76.295,39.365),(76.465,39.365),(76.465,39.195),(76.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,39.195),(76.655,39.365),(76.825,39.365),(76.825,39.195),(76.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,39.555),(75.575,39.725),(75.745,39.725),(75.745,39.555),(75.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,39.555),(75.935,39.725),(76.105,39.725),(76.105,39.555),(75.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,39.555),(76.295,39.725),(76.465,39.725),(76.465,39.555),(76.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,39.555),(76.655,39.725),(76.825,39.725),(76.825,39.555),(76.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,39.915),(75.575,40.085),(75.745,40.085),(75.745,39.915),(75.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,39.915),(75.935,40.085),(76.105,40.085),(76.105,39.915),(75.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,39.915),(76.295,40.085),(76.465,40.085),(76.465,39.915),(76.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,39.915),(76.655,40.085),(76.825,40.085),(76.825,39.915),(76.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,40.275),(75.575,40.445),(75.745,40.445),(75.745,40.275),(75.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,40.275),(75.935,40.445),(76.105,40.445),(76.105,40.275),(75.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,40.275),(76.295,40.445),(76.465,40.445),(76.465,40.275),(76.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,40.275),(76.655,40.445),(76.825,40.445),(76.825,40.275),(76.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,40.635),(75.575,40.805),(75.745,40.805),(75.745,40.635),(75.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,40.635),(75.935,40.805),(76.105,40.805),(76.105,40.635),(75.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,40.635),(76.295,40.805),(76.465,40.805),(76.465,40.635),(76.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,40.635),(76.655,40.805),(76.825,40.805),(76.825,40.635),(76.655,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.835),(37.175,3.005),(37.345,3.005),(37.345,2.835),(37.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.835),(37.535,3.005),(37.705,3.005),(37.705,2.835),(37.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.835),(37.895,3.005),(38.065,3.005),(38.065,2.835),(37.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.835),(38.255,3.005),(38.425,3.005),(38.425,2.835),(38.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.195),(37.175,3.365),(37.345,3.365),(37.345,3.195),(37.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.195),(37.535,3.365),(37.705,3.365),(37.705,3.195),(37.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.195),(37.895,3.365),(38.065,3.365),(38.065,3.195),(37.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.195),(38.255,3.365),(38.425,3.365),(38.425,3.195),(38.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.555),(37.175,3.725),(37.345,3.725),(37.345,3.555),(37.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.555),(37.535,3.725),(37.705,3.725),(37.705,3.555),(37.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.555),(37.895,3.725),(38.065,3.725),(38.065,3.555),(37.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.555),(38.255,3.725),(38.425,3.725),(38.425,3.555),(38.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.915),(37.175,4.085),(37.345,4.085),(37.345,3.915),(37.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.915),(37.535,4.085),(37.705,4.085),(37.705,3.915),(37.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.915),(37.895,4.085),(38.065,4.085),(38.065,3.915),(37.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.915),(38.255,4.085),(38.425,4.085),(38.425,3.915),(38.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.275),(37.175,4.445),(37.345,4.445),(37.345,4.275),(37.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.275),(37.535,4.445),(37.705,4.445),(37.705,4.275),(37.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.275),(37.895,4.445),(38.065,4.445),(38.065,4.275),(37.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.275),(38.255,4.445),(38.425,4.445),(38.425,4.275),(38.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.635),(37.175,4.805),(37.345,4.805),(37.345,4.635),(37.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.635),(37.535,4.805),(37.705,4.805),(37.705,4.635),(37.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.635),(37.895,4.805),(38.065,4.805),(38.065,4.635),(37.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.635),(38.255,4.805),(38.425,4.805),(38.425,4.635),(38.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.995),(37.175,5.165),(37.345,5.165),(37.345,4.995),(37.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.995),(37.535,5.165),(37.705,5.165),(37.705,4.995),(37.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.995),(37.895,5.165),(38.065,5.165),(38.065,4.995),(37.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.995),(38.255,5.165),(38.425,5.165),(38.425,4.995),(38.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.355),(37.175,5.525),(37.345,5.525),(37.345,5.355),(37.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.355),(37.535,5.525),(37.705,5.525),(37.705,5.355),(37.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.355),(37.895,5.525),(38.065,5.525),(38.065,5.355),(37.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.355),(38.255,5.525),(38.425,5.525),(38.425,5.355),(38.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.715),(37.175,5.885),(37.345,5.885),(37.345,5.715),(37.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.715),(37.535,5.885),(37.705,5.885),(37.705,5.715),(37.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.715),(37.895,5.885),(38.065,5.885),(38.065,5.715),(37.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.715),(38.255,5.885),(38.425,5.885),(38.425,5.715),(38.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.075),(37.175,6.245),(37.345,6.245),(37.345,6.075),(37.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.075),(37.535,6.245),(37.705,6.245),(37.705,6.075),(37.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.075),(37.895,6.245),(38.065,6.245),(38.065,6.075),(37.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.075),(38.255,6.245),(38.425,6.245),(38.425,6.075),(38.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.435),(37.175,6.605),(37.345,6.605),(37.345,6.435),(37.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.435),(37.535,6.605),(37.705,6.605),(37.705,6.435),(37.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.435),(37.895,6.605),(38.065,6.605),(38.065,6.435),(37.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.435),(38.255,6.605),(38.425,6.605),(38.425,6.435),(38.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.795),(37.175,6.965),(37.345,6.965),(37.345,6.795),(37.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.795),(37.535,6.965),(37.705,6.965),(37.705,6.795),(37.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.795),(37.895,6.965),(38.065,6.965),(38.065,6.795),(37.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.795),(38.255,6.965),(38.425,6.965),(38.425,6.795),(38.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.155),(37.175,7.325),(37.345,7.325),(37.345,7.155),(37.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.155),(37.535,7.325),(37.705,7.325),(37.705,7.155),(37.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.155),(37.895,7.325),(38.065,7.325),(38.065,7.155),(37.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.155),(38.255,7.325),(38.425,7.325),(38.425,7.155),(38.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.515),(37.175,7.685),(37.345,7.685),(37.345,7.515),(37.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.515),(37.535,7.685),(37.705,7.685),(37.705,7.515),(37.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.515),(37.895,7.685),(38.065,7.685),(38.065,7.515),(37.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.515),(38.255,7.685),(38.425,7.685),(38.425,7.515),(38.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.875),(37.175,8.045),(37.345,8.045),(37.345,7.875),(37.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.875),(37.535,8.045),(37.705,8.045),(37.705,7.875),(37.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.875),(37.895,8.045),(38.065,8.045),(38.065,7.875),(37.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.875),(38.255,8.045),(38.425,8.045),(38.425,7.875),(38.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.235),(37.175,8.405),(37.345,8.405),(37.345,8.235),(37.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.235),(37.535,8.405),(37.705,8.405),(37.705,8.235),(37.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.235),(37.895,8.405),(38.065,8.405),(38.065,8.235),(37.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.235),(38.255,8.405),(38.425,8.405),(38.425,8.235),(38.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.595),(37.175,8.765),(37.345,8.765),(37.345,8.595),(37.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.595),(37.535,8.765),(37.705,8.765),(37.705,8.595),(37.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.595),(37.895,8.765),(38.065,8.765),(38.065,8.595),(37.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.595),(38.255,8.765),(38.425,8.765),(38.425,8.595),(38.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.955),(37.175,9.125),(37.345,9.125),(37.345,8.955),(37.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.955),(37.535,9.125),(37.705,9.125),(37.705,8.955),(37.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.955),(37.895,9.125),(38.065,9.125),(38.065,8.955),(37.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.955),(38.255,9.125),(38.425,9.125),(38.425,8.955),(38.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.315),(37.175,9.485),(37.345,9.485),(37.345,9.315),(37.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.315),(37.535,9.485),(37.705,9.485),(37.705,9.315),(37.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.315),(37.895,9.485),(38.065,9.485),(38.065,9.315),(37.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.315),(38.255,9.485),(38.425,9.485),(38.425,9.315),(38.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.675),(37.175,9.845),(37.345,9.845),(37.345,9.675),(37.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.675),(37.535,9.845),(37.705,9.845),(37.705,9.675),(37.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.675),(37.895,9.845),(38.065,9.845),(38.065,9.675),(37.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.675),(38.255,9.845),(38.425,9.845),(38.425,9.675),(38.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.035),(37.175,10.205),(37.345,10.205),(37.345,10.035),(37.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.035),(37.535,10.205),(37.705,10.205),(37.705,10.035),(37.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.035),(37.895,10.205),(38.065,10.205),(38.065,10.035),(37.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.035),(38.255,10.205),(38.425,10.205),(38.425,10.035),(38.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.395),(37.175,10.565),(37.345,10.565),(37.345,10.395),(37.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.395),(37.535,10.565),(37.705,10.565),(37.705,10.395),(37.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.395),(37.895,10.565),(38.065,10.565),(38.065,10.395),(37.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.395),(38.255,10.565),(38.425,10.565),(38.425,10.395),(38.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.755),(37.175,10.925),(37.345,10.925),(37.345,10.755),(37.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.755),(37.535,10.925),(37.705,10.925),(37.705,10.755),(37.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.755),(37.895,10.925),(38.065,10.925),(38.065,10.755),(37.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.755),(38.255,10.925),(38.425,10.925),(38.425,10.755),(38.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.115),(37.175,11.285),(37.345,11.285),(37.345,11.115),(37.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.115),(37.535,11.285),(37.705,11.285),(37.705,11.115),(37.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.115),(37.895,11.285),(38.065,11.285),(38.065,11.115),(37.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.115),(38.255,11.285),(38.425,11.285),(38.425,11.115),(38.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.475),(37.175,11.645),(37.345,11.645),(37.345,11.475),(37.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.475),(37.535,11.645),(37.705,11.645),(37.705,11.475),(37.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.475),(37.895,11.645),(38.065,11.645),(38.065,11.475),(37.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.475),(38.255,11.645),(38.425,11.645),(38.425,11.475),(38.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.835),(37.175,12.005),(37.345,12.005),(37.345,11.835),(37.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.835),(37.535,12.005),(37.705,12.005),(37.705,11.835),(37.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.835),(37.895,12.005),(38.065,12.005),(38.065,11.835),(37.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.835),(38.255,12.005),(38.425,12.005),(38.425,11.835),(38.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.195),(37.175,12.365),(37.345,12.365),(37.345,12.195),(37.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.195),(37.535,12.365),(37.705,12.365),(37.705,12.195),(37.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.195),(37.895,12.365),(38.065,12.365),(38.065,12.195),(37.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.195),(38.255,12.365),(38.425,12.365),(38.425,12.195),(38.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.555),(37.175,12.725),(37.345,12.725),(37.345,12.555),(37.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.555),(37.535,12.725),(37.705,12.725),(37.705,12.555),(37.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.555),(37.895,12.725),(38.065,12.725),(38.065,12.555),(37.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.555),(38.255,12.725),(38.425,12.725),(38.425,12.555),(38.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.915),(37.175,13.085),(37.345,13.085),(37.345,12.915),(37.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.915),(37.535,13.085),(37.705,13.085),(37.705,12.915),(37.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.915),(37.895,13.085),(38.065,13.085),(38.065,12.915),(37.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.915),(38.255,13.085),(38.425,13.085),(38.425,12.915),(38.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.275),(37.175,13.445),(37.345,13.445),(37.345,13.275),(37.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.275),(37.535,13.445),(37.705,13.445),(37.705,13.275),(37.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.275),(37.895,13.445),(38.065,13.445),(38.065,13.275),(37.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.275),(38.255,13.445),(38.425,13.445),(38.425,13.275),(38.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.635),(37.175,13.805),(37.345,13.805),(37.345,13.635),(37.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.635),(37.535,13.805),(37.705,13.805),(37.705,13.635),(37.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.635),(37.895,13.805),(38.065,13.805),(38.065,13.635),(37.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.635),(38.255,13.805),(38.425,13.805),(38.425,13.635),(38.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.995),(37.175,14.165),(37.345,14.165),(37.345,13.995),(37.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.995),(37.535,14.165),(37.705,14.165),(37.705,13.995),(37.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.995),(37.895,14.165),(38.065,14.165),(38.065,13.995),(37.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.995),(38.255,14.165),(38.425,14.165),(38.425,13.995),(38.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.355),(37.175,14.525),(37.345,14.525),(37.345,14.355),(37.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.355),(37.535,14.525),(37.705,14.525),(37.705,14.355),(37.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.355),(37.895,14.525),(38.065,14.525),(38.065,14.355),(37.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.355),(38.255,14.525),(38.425,14.525),(38.425,14.355),(38.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.715),(37.175,14.885),(37.345,14.885),(37.345,14.715),(37.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.715),(37.535,14.885),(37.705,14.885),(37.705,14.715),(37.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.715),(37.895,14.885),(38.065,14.885),(38.065,14.715),(37.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.715),(38.255,14.885),(38.425,14.885),(38.425,14.715),(38.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.075),(37.175,15.245),(37.345,15.245),(37.345,15.075),(37.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.075),(37.535,15.245),(37.705,15.245),(37.705,15.075),(37.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.075),(37.895,15.245),(38.065,15.245),(38.065,15.075),(37.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.075),(38.255,15.245),(38.425,15.245),(38.425,15.075),(38.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.435),(37.175,15.605),(37.345,15.605),(37.345,15.435),(37.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.435),(37.535,15.605),(37.705,15.605),(37.705,15.435),(37.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.435),(37.895,15.605),(38.065,15.605),(38.065,15.435),(37.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.435),(38.255,15.605),(38.425,15.605),(38.425,15.435),(38.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.795),(37.175,15.965),(37.345,15.965),(37.345,15.795),(37.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.795),(37.535,15.965),(37.705,15.965),(37.705,15.795),(37.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.795),(37.895,15.965),(38.065,15.965),(38.065,15.795),(37.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.795),(38.255,15.965),(38.425,15.965),(38.425,15.795),(38.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.155),(37.175,16.325),(37.345,16.325),(37.345,16.155),(37.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.155),(37.535,16.325),(37.705,16.325),(37.705,16.155),(37.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.155),(37.895,16.325),(38.065,16.325),(38.065,16.155),(37.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.155),(38.255,16.325),(38.425,16.325),(38.425,16.155),(38.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.515),(37.175,16.685),(37.345,16.685),(37.345,16.515),(37.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.515),(37.535,16.685),(37.705,16.685),(37.705,16.515),(37.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.515),(37.895,16.685),(38.065,16.685),(38.065,16.515),(37.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.515),(38.255,16.685),(38.425,16.685),(38.425,16.515),(38.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.875),(37.175,17.045),(37.345,17.045),(37.345,16.875),(37.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.875),(37.535,17.045),(37.705,17.045),(37.705,16.875),(37.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.875),(37.895,17.045),(38.065,17.045),(38.065,16.875),(37.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.875),(38.255,17.045),(38.425,17.045),(38.425,16.875),(38.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.235),(37.175,17.405),(37.345,17.405),(37.345,17.235),(37.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.235),(37.535,17.405),(37.705,17.405),(37.705,17.235),(37.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.235),(37.895,17.405),(38.065,17.405),(38.065,17.235),(37.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.235),(38.255,17.405),(38.425,17.405),(38.425,17.235),(38.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.595),(37.175,17.765),(37.345,17.765),(37.345,17.595),(37.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.595),(37.535,17.765),(37.705,17.765),(37.705,17.595),(37.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.595),(37.895,17.765),(38.065,17.765),(38.065,17.595),(37.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.595),(38.255,17.765),(38.425,17.765),(38.425,17.595),(38.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.955),(37.175,18.125),(37.345,18.125),(37.345,17.955),(37.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.955),(37.535,18.125),(37.705,18.125),(37.705,17.955),(37.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.955),(37.895,18.125),(38.065,18.125),(38.065,17.955),(37.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.955),(38.255,18.125),(38.425,18.125),(38.425,17.955),(38.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.315),(37.175,18.485),(37.345,18.485),(37.345,18.315),(37.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.315),(37.535,18.485),(37.705,18.485),(37.705,18.315),(37.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.315),(37.895,18.485),(38.065,18.485),(38.065,18.315),(37.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.315),(38.255,18.485),(38.425,18.485),(38.425,18.315),(38.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.675),(37.175,18.845),(37.345,18.845),(37.345,18.675),(37.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.675),(37.535,18.845),(37.705,18.845),(37.705,18.675),(37.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.675),(37.895,18.845),(38.065,18.845),(38.065,18.675),(37.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.675),(38.255,18.845),(38.425,18.845),(38.425,18.675),(38.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.035),(37.175,19.205),(37.345,19.205),(37.345,19.035),(37.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.035),(37.535,19.205),(37.705,19.205),(37.705,19.035),(37.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.035),(37.895,19.205),(38.065,19.205),(38.065,19.035),(37.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.035),(38.255,19.205),(38.425,19.205),(38.425,19.035),(38.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.395),(37.175,19.565),(37.345,19.565),(37.345,19.395),(37.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.395),(37.535,19.565),(37.705,19.565),(37.705,19.395),(37.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.395),(37.895,19.565),(38.065,19.565),(38.065,19.395),(37.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.395),(38.255,19.565),(38.425,19.565),(38.425,19.395),(38.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.755),(37.175,19.925),(37.345,19.925),(37.345,19.755),(37.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.755),(37.535,19.925),(37.705,19.925),(37.705,19.755),(37.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.755),(37.895,19.925),(38.065,19.925),(38.065,19.755),(37.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.755),(38.255,19.925),(38.425,19.925),(38.425,19.755),(38.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.115),(37.175,20.285),(37.345,20.285),(37.345,20.115),(37.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.115),(37.535,20.285),(37.705,20.285),(37.705,20.115),(37.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.115),(37.895,20.285),(38.065,20.285),(38.065,20.115),(37.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.115),(38.255,20.285),(38.425,20.285),(38.425,20.115),(38.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.475),(37.175,20.645),(37.345,20.645),(37.345,20.475),(37.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.475),(37.535,20.645),(37.705,20.645),(37.705,20.475),(37.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.475),(37.895,20.645),(38.065,20.645),(38.065,20.475),(37.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.475),(38.255,20.645),(38.425,20.645),(38.425,20.475),(38.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.835),(37.175,21.005),(37.345,21.005),(37.345,20.835),(37.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.835),(37.535,21.005),(37.705,21.005),(37.705,20.835),(37.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.835),(37.895,21.005),(38.065,21.005),(38.065,20.835),(37.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.835),(38.255,21.005),(38.425,21.005),(38.425,20.835),(38.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.195),(37.175,21.365),(37.345,21.365),(37.345,21.195),(37.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.195),(37.535,21.365),(37.705,21.365),(37.705,21.195),(37.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.195),(37.895,21.365),(38.065,21.365),(38.065,21.195),(37.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.195),(38.255,21.365),(38.425,21.365),(38.425,21.195),(38.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.555),(37.175,21.725),(37.345,21.725),(37.345,21.555),(37.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.555),(37.535,21.725),(37.705,21.725),(37.705,21.555),(37.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.555),(37.895,21.725),(38.065,21.725),(38.065,21.555),(37.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.555),(38.255,21.725),(38.425,21.725),(38.425,21.555),(38.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.915),(37.175,22.085),(37.345,22.085),(37.345,21.915),(37.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.915),(37.535,22.085),(37.705,22.085),(37.705,21.915),(37.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.915),(37.895,22.085),(38.065,22.085),(38.065,21.915),(37.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.915),(38.255,22.085),(38.425,22.085),(38.425,21.915),(38.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.275),(37.175,22.445),(37.345,22.445),(37.345,22.275),(37.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.275),(37.535,22.445),(37.705,22.445),(37.705,22.275),(37.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.275),(37.895,22.445),(38.065,22.445),(38.065,22.275),(37.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.275),(38.255,22.445),(38.425,22.445),(38.425,22.275),(38.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.635),(37.175,22.805),(37.345,22.805),(37.345,22.635),(37.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.635),(37.535,22.805),(37.705,22.805),(37.705,22.635),(37.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.635),(37.895,22.805),(38.065,22.805),(38.065,22.635),(37.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.635),(38.255,22.805),(38.425,22.805),(38.425,22.635),(38.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.995),(37.175,23.165),(37.345,23.165),(37.345,22.995),(37.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.995),(37.535,23.165),(37.705,23.165),(37.705,22.995),(37.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.995),(37.895,23.165),(38.065,23.165),(38.065,22.995),(37.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.995),(38.255,23.165),(38.425,23.165),(38.425,22.995),(38.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,23.355),(37.175,23.525),(37.345,23.525),(37.345,23.355),(37.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,23.355),(37.535,23.525),(37.705,23.525),(37.705,23.355),(37.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,23.355),(37.895,23.525),(38.065,23.525),(38.065,23.355),(37.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,23.355),(38.255,23.525),(38.425,23.525),(38.425,23.355),(38.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,23.715),(37.175,23.885),(37.345,23.885),(37.345,23.715),(37.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,23.715),(37.535,23.885),(37.705,23.885),(37.705,23.715),(37.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,23.715),(37.895,23.885),(38.065,23.885),(38.065,23.715),(37.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,23.715),(38.255,23.885),(38.425,23.885),(38.425,23.715),(38.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.075),(37.175,24.245),(37.345,24.245),(37.345,24.075),(37.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.075),(37.535,24.245),(37.705,24.245),(37.705,24.075),(37.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.075),(37.895,24.245),(38.065,24.245),(38.065,24.075),(37.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.075),(38.255,24.245),(38.425,24.245),(38.425,24.075),(38.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.435),(37.175,24.605),(37.345,24.605),(37.345,24.435),(37.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.435),(37.535,24.605),(37.705,24.605),(37.705,24.435),(37.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.435),(37.895,24.605),(38.065,24.605),(38.065,24.435),(37.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.435),(38.255,24.605),(38.425,24.605),(38.425,24.435),(38.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.795),(37.175,24.965),(37.345,24.965),(37.345,24.795),(37.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.795),(37.535,24.965),(37.705,24.965),(37.705,24.795),(37.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.795),(37.895,24.965),(38.065,24.965),(38.065,24.795),(37.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.795),(38.255,24.965),(38.425,24.965),(38.425,24.795),(38.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.155),(37.175,25.325),(37.345,25.325),(37.345,25.155),(37.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.155),(37.535,25.325),(37.705,25.325),(37.705,25.155),(37.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.155),(37.895,25.325),(38.065,25.325),(38.065,25.155),(37.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.155),(38.255,25.325),(38.425,25.325),(38.425,25.155),(38.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.515),(37.175,25.685),(37.345,25.685),(37.345,25.515),(37.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.515),(37.535,25.685),(37.705,25.685),(37.705,25.515),(37.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.515),(37.895,25.685),(38.065,25.685),(38.065,25.515),(37.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.515),(38.255,25.685),(38.425,25.685),(38.425,25.515),(38.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.875),(37.175,26.045),(37.345,26.045),(37.345,25.875),(37.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.875),(37.535,26.045),(37.705,26.045),(37.705,25.875),(37.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.875),(37.895,26.045),(38.065,26.045),(38.065,25.875),(37.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.875),(38.255,26.045),(38.425,26.045),(38.425,25.875),(38.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.235),(37.175,26.405),(37.345,26.405),(37.345,26.235),(37.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.235),(37.535,26.405),(37.705,26.405),(37.705,26.235),(37.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.235),(37.895,26.405),(38.065,26.405),(38.065,26.235),(37.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.235),(38.255,26.405),(38.425,26.405),(38.425,26.235),(38.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.595),(37.175,26.765),(37.345,26.765),(37.345,26.595),(37.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.595),(37.535,26.765),(37.705,26.765),(37.705,26.595),(37.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.595),(37.895,26.765),(38.065,26.765),(38.065,26.595),(37.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.595),(38.255,26.765),(38.425,26.765),(38.425,26.595),(38.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.955),(37.175,27.125),(37.345,27.125),(37.345,26.955),(37.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.955),(37.535,27.125),(37.705,27.125),(37.705,26.955),(37.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.955),(37.895,27.125),(38.065,27.125),(38.065,26.955),(37.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.955),(38.255,27.125),(38.425,27.125),(38.425,26.955),(38.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,27.315),(37.175,27.485),(37.345,27.485),(37.345,27.315),(37.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,27.315),(37.535,27.485),(37.705,27.485),(37.705,27.315),(37.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,27.315),(37.895,27.485),(38.065,27.485),(38.065,27.315),(37.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,27.315),(38.255,27.485),(38.425,27.485),(38.425,27.315),(38.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,27.675),(37.175,27.845),(37.345,27.845),(37.345,27.675),(37.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,27.675),(37.535,27.845),(37.705,27.845),(37.705,27.675),(37.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,27.675),(37.895,27.845),(38.065,27.845),(38.065,27.675),(37.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,27.675),(38.255,27.845),(38.425,27.845),(38.425,27.675),(38.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.035),(37.175,28.205),(37.345,28.205),(37.345,28.035),(37.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.035),(37.535,28.205),(37.705,28.205),(37.705,28.035),(37.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.035),(37.895,28.205),(38.065,28.205),(38.065,28.035),(37.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.035),(38.255,28.205),(38.425,28.205),(38.425,28.035),(38.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.395),(37.175,28.565),(37.345,28.565),(37.345,28.395),(37.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.395),(37.535,28.565),(37.705,28.565),(37.705,28.395),(37.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.395),(37.895,28.565),(38.065,28.565),(38.065,28.395),(37.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.395),(38.255,28.565),(38.425,28.565),(38.425,28.395),(38.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.755),(37.175,28.925),(37.345,28.925),(37.345,28.755),(37.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.755),(37.535,28.925),(37.705,28.925),(37.705,28.755),(37.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.755),(37.895,28.925),(38.065,28.925),(38.065,28.755),(37.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.755),(38.255,28.925),(38.425,28.925),(38.425,28.755),(38.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.115),(37.175,29.285),(37.345,29.285),(37.345,29.115),(37.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.115),(37.535,29.285),(37.705,29.285),(37.705,29.115),(37.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.115),(37.895,29.285),(38.065,29.285),(38.065,29.115),(37.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.115),(38.255,29.285),(38.425,29.285),(38.425,29.115),(38.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.475),(37.175,29.645),(37.345,29.645),(37.345,29.475),(37.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.475),(37.535,29.645),(37.705,29.645),(37.705,29.475),(37.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.475),(37.895,29.645),(38.065,29.645),(38.065,29.475),(37.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.475),(38.255,29.645),(38.425,29.645),(38.425,29.475),(38.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.835),(37.175,30.005),(37.345,30.005),(37.345,29.835),(37.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.835),(37.535,30.005),(37.705,30.005),(37.705,29.835),(37.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.835),(37.895,30.005),(38.065,30.005),(38.065,29.835),(37.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.835),(38.255,30.005),(38.425,30.005),(38.425,29.835),(38.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.195),(37.175,30.365),(37.345,30.365),(37.345,30.195),(37.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.195),(37.535,30.365),(37.705,30.365),(37.705,30.195),(37.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.195),(37.895,30.365),(38.065,30.365),(38.065,30.195),(37.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.195),(38.255,30.365),(38.425,30.365),(38.425,30.195),(38.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.555),(37.175,30.725),(37.345,30.725),(37.345,30.555),(37.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.555),(37.535,30.725),(37.705,30.725),(37.705,30.555),(37.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.555),(37.895,30.725),(38.065,30.725),(38.065,30.555),(37.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.555),(38.255,30.725),(38.425,30.725),(38.425,30.555),(38.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.915),(37.175,31.085),(37.345,31.085),(37.345,30.915),(37.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.915),(37.535,31.085),(37.705,31.085),(37.705,30.915),(37.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.915),(37.895,31.085),(38.065,31.085),(38.065,30.915),(37.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.915),(38.255,31.085),(38.425,31.085),(38.425,30.915),(38.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.275),(37.175,31.445),(37.345,31.445),(37.345,31.275),(37.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.275),(37.535,31.445),(37.705,31.445),(37.705,31.275),(37.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.275),(37.895,31.445),(38.065,31.445),(38.065,31.275),(37.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.275),(38.255,31.445),(38.425,31.445),(38.425,31.275),(38.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.635),(37.175,31.805),(37.345,31.805),(37.345,31.635),(37.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.635),(37.535,31.805),(37.705,31.805),(37.705,31.635),(37.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.635),(37.895,31.805),(38.065,31.805),(38.065,31.635),(37.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.635),(38.255,31.805),(38.425,31.805),(38.425,31.635),(38.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.995),(37.175,32.165),(37.345,32.165),(37.345,31.995),(37.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.995),(37.535,32.165),(37.705,32.165),(37.705,31.995),(37.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.995),(37.895,32.165),(38.065,32.165),(38.065,31.995),(37.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.995),(38.255,32.165),(38.425,32.165),(38.425,31.995),(38.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,32.355),(37.175,32.525),(37.345,32.525),(37.345,32.355),(37.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,32.355),(37.535,32.525),(37.705,32.525),(37.705,32.355),(37.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,32.355),(37.895,32.525),(38.065,32.525),(38.065,32.355),(37.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,32.355),(38.255,32.525),(38.425,32.525),(38.425,32.355),(38.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,32.715),(37.175,32.885),(37.345,32.885),(37.345,32.715),(37.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,32.715),(37.535,32.885),(37.705,32.885),(37.705,32.715),(37.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,32.715),(37.895,32.885),(38.065,32.885),(38.065,32.715),(37.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,32.715),(38.255,32.885),(38.425,32.885),(38.425,32.715),(38.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.075),(37.175,33.245),(37.345,33.245),(37.345,33.075),(37.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.075),(37.535,33.245),(37.705,33.245),(37.705,33.075),(37.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.075),(37.895,33.245),(38.065,33.245),(38.065,33.075),(37.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.075),(38.255,33.245),(38.425,33.245),(38.425,33.075),(38.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.435),(37.175,33.605),(37.345,33.605),(37.345,33.435),(37.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.435),(37.535,33.605),(37.705,33.605),(37.705,33.435),(37.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.435),(37.895,33.605),(38.065,33.605),(38.065,33.435),(37.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.435),(38.255,33.605),(38.425,33.605),(38.425,33.435),(38.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.795),(37.175,33.965),(37.345,33.965),(37.345,33.795),(37.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.795),(37.535,33.965),(37.705,33.965),(37.705,33.795),(37.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.795),(37.895,33.965),(38.065,33.965),(38.065,33.795),(37.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.795),(38.255,33.965),(38.425,33.965),(38.425,33.795),(38.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.155),(37.175,34.325),(37.345,34.325),(37.345,34.155),(37.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.155),(37.535,34.325),(37.705,34.325),(37.705,34.155),(37.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.155),(37.895,34.325),(38.065,34.325),(38.065,34.155),(37.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.155),(38.255,34.325),(38.425,34.325),(38.425,34.155),(38.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.515),(37.175,34.685),(37.345,34.685),(37.345,34.515),(37.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.515),(37.535,34.685),(37.705,34.685),(37.705,34.515),(37.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.515),(37.895,34.685),(38.065,34.685),(38.065,34.515),(37.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.515),(38.255,34.685),(38.425,34.685),(38.425,34.515),(38.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.875),(37.175,35.045),(37.345,35.045),(37.345,34.875),(37.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.875),(37.535,35.045),(37.705,35.045),(37.705,34.875),(37.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.875),(37.895,35.045),(38.065,35.045),(38.065,34.875),(37.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.875),(38.255,35.045),(38.425,35.045),(38.425,34.875),(38.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.235),(37.175,35.405),(37.345,35.405),(37.345,35.235),(37.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.235),(37.535,35.405),(37.705,35.405),(37.705,35.235),(37.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.235),(37.895,35.405),(38.065,35.405),(38.065,35.235),(37.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.235),(38.255,35.405),(38.425,35.405),(38.425,35.235),(38.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.595),(37.175,35.765),(37.345,35.765),(37.345,35.595),(37.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.595),(37.535,35.765),(37.705,35.765),(37.705,35.595),(37.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.595),(37.895,35.765),(38.065,35.765),(38.065,35.595),(37.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.595),(38.255,35.765),(38.425,35.765),(38.425,35.595),(38.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.955),(37.175,36.125),(37.345,36.125),(37.345,35.955),(37.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.955),(37.535,36.125),(37.705,36.125),(37.705,35.955),(37.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.955),(37.895,36.125),(38.065,36.125),(38.065,35.955),(37.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.955),(38.255,36.125),(38.425,36.125),(38.425,35.955),(38.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,36.315),(37.175,36.485),(37.345,36.485),(37.345,36.315),(37.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,36.315),(37.535,36.485),(37.705,36.485),(37.705,36.315),(37.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,36.315),(37.895,36.485),(38.065,36.485),(38.065,36.315),(37.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,36.315),(38.255,36.485),(38.425,36.485),(38.425,36.315),(38.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,36.675),(37.175,36.845),(37.345,36.845),(37.345,36.675),(37.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,36.675),(37.535,36.845),(37.705,36.845),(37.705,36.675),(37.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,36.675),(37.895,36.845),(38.065,36.845),(38.065,36.675),(37.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,36.675),(38.255,36.845),(38.425,36.845),(38.425,36.675),(38.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.035),(37.175,37.205),(37.345,37.205),(37.345,37.035),(37.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.035),(37.535,37.205),(37.705,37.205),(37.705,37.035),(37.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.035),(37.895,37.205),(38.065,37.205),(38.065,37.035),(37.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.035),(38.255,37.205),(38.425,37.205),(38.425,37.035),(38.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.395),(37.175,37.565),(37.345,37.565),(37.345,37.395),(37.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.395),(37.535,37.565),(37.705,37.565),(37.705,37.395),(37.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.395),(37.895,37.565),(38.065,37.565),(38.065,37.395),(37.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.395),(38.255,37.565),(38.425,37.565),(38.425,37.395),(38.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.755),(37.175,37.925),(37.345,37.925),(37.345,37.755),(37.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.755),(37.535,37.925),(37.705,37.925),(37.705,37.755),(37.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.755),(37.895,37.925),(38.065,37.925),(38.065,37.755),(37.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.755),(38.255,37.925),(38.425,37.925),(38.425,37.755),(38.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.115),(37.175,38.285),(37.345,38.285),(37.345,38.115),(37.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.115),(37.535,38.285),(37.705,38.285),(37.705,38.115),(37.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.115),(37.895,38.285),(38.065,38.285),(38.065,38.115),(37.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.115),(38.255,38.285),(38.425,38.285),(38.425,38.115),(38.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.475),(37.175,38.645),(37.345,38.645),(37.345,38.475),(37.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.475),(37.535,38.645),(37.705,38.645),(37.705,38.475),(37.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.475),(37.895,38.645),(38.065,38.645),(38.065,38.475),(37.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.475),(38.255,38.645),(38.425,38.645),(38.425,38.475),(38.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.835),(37.175,39.005),(37.345,39.005),(37.345,38.835),(37.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.835),(37.535,39.005),(37.705,39.005),(37.705,38.835),(37.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.835),(37.895,39.005),(38.065,39.005),(38.065,38.835),(37.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.835),(38.255,39.005),(38.425,39.005),(38.425,38.835),(38.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.195),(37.175,39.365),(37.345,39.365),(37.345,39.195),(37.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.195),(37.535,39.365),(37.705,39.365),(37.705,39.195),(37.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.195),(37.895,39.365),(38.065,39.365),(38.065,39.195),(37.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.195),(38.255,39.365),(38.425,39.365),(38.425,39.195),(38.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.555),(37.175,39.725),(37.345,39.725),(37.345,39.555),(37.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.555),(37.535,39.725),(37.705,39.725),(37.705,39.555),(37.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.555),(37.895,39.725),(38.065,39.725),(38.065,39.555),(37.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.555),(38.255,39.725),(38.425,39.725),(38.425,39.555),(38.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.915),(37.175,40.085),(37.345,40.085),(37.345,39.915),(37.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.915),(37.535,40.085),(37.705,40.085),(37.705,39.915),(37.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.915),(37.895,40.085),(38.065,40.085),(38.065,39.915),(37.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.915),(38.255,40.085),(38.425,40.085),(38.425,39.915),(38.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,40.275),(37.175,40.445),(37.345,40.445),(37.345,40.275),(37.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,40.275),(37.535,40.445),(37.705,40.445),(37.705,40.275),(37.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,40.275),(37.895,40.445),(38.065,40.445),(38.065,40.275),(37.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,40.275),(38.255,40.445),(38.425,40.445),(38.425,40.275),(38.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,40.635),(37.175,40.805),(37.345,40.805),(37.345,40.635),(37.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,40.635),(37.535,40.805),(37.705,40.805),(37.705,40.635),(37.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,40.635),(37.895,40.805),(38.065,40.805),(38.065,40.635),(37.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,40.635),(38.255,40.805),(38.425,40.805),(38.425,40.635),(38.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,2.835),(17.975,3.005),(18.145,3.005),(18.145,2.835),(17.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,2.835),(18.335,3.005),(18.505,3.005),(18.505,2.835),(18.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,2.835),(18.695,3.005),(18.865,3.005),(18.865,2.835),(18.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,2.835),(19.055,3.005),(19.225,3.005),(19.225,2.835),(19.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.195),(17.975,3.365),(18.145,3.365),(18.145,3.195),(17.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.195),(18.335,3.365),(18.505,3.365),(18.505,3.195),(18.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.195),(18.695,3.365),(18.865,3.365),(18.865,3.195),(18.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.195),(19.055,3.365),(19.225,3.365),(19.225,3.195),(19.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.555),(17.975,3.725),(18.145,3.725),(18.145,3.555),(17.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.555),(18.335,3.725),(18.505,3.725),(18.505,3.555),(18.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.555),(18.695,3.725),(18.865,3.725),(18.865,3.555),(18.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.555),(19.055,3.725),(19.225,3.725),(19.225,3.555),(19.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.915),(17.975,4.085),(18.145,4.085),(18.145,3.915),(17.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.915),(18.335,4.085),(18.505,4.085),(18.505,3.915),(18.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.915),(18.695,4.085),(18.865,4.085),(18.865,3.915),(18.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.915),(19.055,4.085),(19.225,4.085),(19.225,3.915),(19.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.275),(17.975,4.445),(18.145,4.445),(18.145,4.275),(17.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.275),(18.335,4.445),(18.505,4.445),(18.505,4.275),(18.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.275),(18.695,4.445),(18.865,4.445),(18.865,4.275),(18.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.275),(19.055,4.445),(19.225,4.445),(19.225,4.275),(19.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.635),(17.975,4.805),(18.145,4.805),(18.145,4.635),(17.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.635),(18.335,4.805),(18.505,4.805),(18.505,4.635),(18.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.635),(18.695,4.805),(18.865,4.805),(18.865,4.635),(18.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.635),(19.055,4.805),(19.225,4.805),(19.225,4.635),(19.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.995),(17.975,5.165),(18.145,5.165),(18.145,4.995),(17.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.995),(18.335,5.165),(18.505,5.165),(18.505,4.995),(18.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.995),(18.695,5.165),(18.865,5.165),(18.865,4.995),(18.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.995),(19.055,5.165),(19.225,5.165),(19.225,4.995),(19.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.355),(17.975,5.525),(18.145,5.525),(18.145,5.355),(17.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.355),(18.335,5.525),(18.505,5.525),(18.505,5.355),(18.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.355),(18.695,5.525),(18.865,5.525),(18.865,5.355),(18.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.355),(19.055,5.525),(19.225,5.525),(19.225,5.355),(19.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.715),(17.975,5.885),(18.145,5.885),(18.145,5.715),(17.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.715),(18.335,5.885),(18.505,5.885),(18.505,5.715),(18.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.715),(18.695,5.885),(18.865,5.885),(18.865,5.715),(18.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.715),(19.055,5.885),(19.225,5.885),(19.225,5.715),(19.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.075),(17.975,6.245),(18.145,6.245),(18.145,6.075),(17.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.075),(18.335,6.245),(18.505,6.245),(18.505,6.075),(18.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.075),(18.695,6.245),(18.865,6.245),(18.865,6.075),(18.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.075),(19.055,6.245),(19.225,6.245),(19.225,6.075),(19.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.435),(17.975,6.605),(18.145,6.605),(18.145,6.435),(17.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.435),(18.335,6.605),(18.505,6.605),(18.505,6.435),(18.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.435),(18.695,6.605),(18.865,6.605),(18.865,6.435),(18.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.435),(19.055,6.605),(19.225,6.605),(19.225,6.435),(19.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.795),(17.975,6.965),(18.145,6.965),(18.145,6.795),(17.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.795),(18.335,6.965),(18.505,6.965),(18.505,6.795),(18.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.795),(18.695,6.965),(18.865,6.965),(18.865,6.795),(18.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.795),(19.055,6.965),(19.225,6.965),(19.225,6.795),(19.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.155),(17.975,7.325),(18.145,7.325),(18.145,7.155),(17.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.155),(18.335,7.325),(18.505,7.325),(18.505,7.155),(18.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.155),(18.695,7.325),(18.865,7.325),(18.865,7.155),(18.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.155),(19.055,7.325),(19.225,7.325),(19.225,7.155),(19.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.515),(17.975,7.685),(18.145,7.685),(18.145,7.515),(17.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.515),(18.335,7.685),(18.505,7.685),(18.505,7.515),(18.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.515),(18.695,7.685),(18.865,7.685),(18.865,7.515),(18.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.515),(19.055,7.685),(19.225,7.685),(19.225,7.515),(19.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.875),(17.975,8.045),(18.145,8.045),(18.145,7.875),(17.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.875),(18.335,8.045),(18.505,8.045),(18.505,7.875),(18.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.875),(18.695,8.045),(18.865,8.045),(18.865,7.875),(18.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.875),(19.055,8.045),(19.225,8.045),(19.225,7.875),(19.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.235),(17.975,8.405),(18.145,8.405),(18.145,8.235),(17.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.235),(18.335,8.405),(18.505,8.405),(18.505,8.235),(18.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.235),(18.695,8.405),(18.865,8.405),(18.865,8.235),(18.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.235),(19.055,8.405),(19.225,8.405),(19.225,8.235),(19.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.595),(17.975,8.765),(18.145,8.765),(18.145,8.595),(17.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.595),(18.335,8.765),(18.505,8.765),(18.505,8.595),(18.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.595),(18.695,8.765),(18.865,8.765),(18.865,8.595),(18.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.595),(19.055,8.765),(19.225,8.765),(19.225,8.595),(19.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.955),(17.975,9.125),(18.145,9.125),(18.145,8.955),(17.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.955),(18.335,9.125),(18.505,9.125),(18.505,8.955),(18.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.955),(18.695,9.125),(18.865,9.125),(18.865,8.955),(18.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.955),(19.055,9.125),(19.225,9.125),(19.225,8.955),(19.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.315),(17.975,9.485),(18.145,9.485),(18.145,9.315),(17.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.315),(18.335,9.485),(18.505,9.485),(18.505,9.315),(18.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.315),(18.695,9.485),(18.865,9.485),(18.865,9.315),(18.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.315),(19.055,9.485),(19.225,9.485),(19.225,9.315),(19.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.675),(17.975,9.845),(18.145,9.845),(18.145,9.675),(17.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.675),(18.335,9.845),(18.505,9.845),(18.505,9.675),(18.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.675),(18.695,9.845),(18.865,9.845),(18.865,9.675),(18.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.675),(19.055,9.845),(19.225,9.845),(19.225,9.675),(19.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.035),(17.975,10.205),(18.145,10.205),(18.145,10.035),(17.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.035),(18.335,10.205),(18.505,10.205),(18.505,10.035),(18.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.035),(18.695,10.205),(18.865,10.205),(18.865,10.035),(18.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.035),(19.055,10.205),(19.225,10.205),(19.225,10.035),(19.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.395),(17.975,10.565),(18.145,10.565),(18.145,10.395),(17.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.395),(18.335,10.565),(18.505,10.565),(18.505,10.395),(18.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.395),(18.695,10.565),(18.865,10.565),(18.865,10.395),(18.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.395),(19.055,10.565),(19.225,10.565),(19.225,10.395),(19.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.755),(17.975,10.925),(18.145,10.925),(18.145,10.755),(17.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.755),(18.335,10.925),(18.505,10.925),(18.505,10.755),(18.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.755),(18.695,10.925),(18.865,10.925),(18.865,10.755),(18.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.755),(19.055,10.925),(19.225,10.925),(19.225,10.755),(19.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.115),(17.975,11.285),(18.145,11.285),(18.145,11.115),(17.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.115),(18.335,11.285),(18.505,11.285),(18.505,11.115),(18.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.115),(18.695,11.285),(18.865,11.285),(18.865,11.115),(18.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.115),(19.055,11.285),(19.225,11.285),(19.225,11.115),(19.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.475),(17.975,11.645),(18.145,11.645),(18.145,11.475),(17.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.475),(18.335,11.645),(18.505,11.645),(18.505,11.475),(18.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.475),(18.695,11.645),(18.865,11.645),(18.865,11.475),(18.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.475),(19.055,11.645),(19.225,11.645),(19.225,11.475),(19.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.835),(17.975,12.005),(18.145,12.005),(18.145,11.835),(17.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.835),(18.335,12.005),(18.505,12.005),(18.505,11.835),(18.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.835),(18.695,12.005),(18.865,12.005),(18.865,11.835),(18.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.835),(19.055,12.005),(19.225,12.005),(19.225,11.835),(19.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.195),(17.975,12.365),(18.145,12.365),(18.145,12.195),(17.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.195),(18.335,12.365),(18.505,12.365),(18.505,12.195),(18.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.195),(18.695,12.365),(18.865,12.365),(18.865,12.195),(18.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.195),(19.055,12.365),(19.225,12.365),(19.225,12.195),(19.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.555),(17.975,12.725),(18.145,12.725),(18.145,12.555),(17.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.555),(18.335,12.725),(18.505,12.725),(18.505,12.555),(18.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.555),(18.695,12.725),(18.865,12.725),(18.865,12.555),(18.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.555),(19.055,12.725),(19.225,12.725),(19.225,12.555),(19.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.915),(17.975,13.085),(18.145,13.085),(18.145,12.915),(17.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.915),(18.335,13.085),(18.505,13.085),(18.505,12.915),(18.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.915),(18.695,13.085),(18.865,13.085),(18.865,12.915),(18.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.915),(19.055,13.085),(19.225,13.085),(19.225,12.915),(19.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.275),(17.975,13.445),(18.145,13.445),(18.145,13.275),(17.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.275),(18.335,13.445),(18.505,13.445),(18.505,13.275),(18.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.275),(18.695,13.445),(18.865,13.445),(18.865,13.275),(18.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.275),(19.055,13.445),(19.225,13.445),(19.225,13.275),(19.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.635),(17.975,13.805),(18.145,13.805),(18.145,13.635),(17.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.635),(18.335,13.805),(18.505,13.805),(18.505,13.635),(18.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.635),(18.695,13.805),(18.865,13.805),(18.865,13.635),(18.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.635),(19.055,13.805),(19.225,13.805),(19.225,13.635),(19.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.995),(17.975,14.165),(18.145,14.165),(18.145,13.995),(17.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.995),(18.335,14.165),(18.505,14.165),(18.505,13.995),(18.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.995),(18.695,14.165),(18.865,14.165),(18.865,13.995),(18.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.995),(19.055,14.165),(19.225,14.165),(19.225,13.995),(19.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.355),(17.975,14.525),(18.145,14.525),(18.145,14.355),(17.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.355),(18.335,14.525),(18.505,14.525),(18.505,14.355),(18.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.355),(18.695,14.525),(18.865,14.525),(18.865,14.355),(18.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.355),(19.055,14.525),(19.225,14.525),(19.225,14.355),(19.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.715),(17.975,14.885),(18.145,14.885),(18.145,14.715),(17.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.715),(18.335,14.885),(18.505,14.885),(18.505,14.715),(18.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.715),(18.695,14.885),(18.865,14.885),(18.865,14.715),(18.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.715),(19.055,14.885),(19.225,14.885),(19.225,14.715),(19.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.075),(17.975,15.245),(18.145,15.245),(18.145,15.075),(17.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.075),(18.335,15.245),(18.505,15.245),(18.505,15.075),(18.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.075),(18.695,15.245),(18.865,15.245),(18.865,15.075),(18.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.075),(19.055,15.245),(19.225,15.245),(19.225,15.075),(19.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.435),(17.975,15.605),(18.145,15.605),(18.145,15.435),(17.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.435),(18.335,15.605),(18.505,15.605),(18.505,15.435),(18.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.435),(18.695,15.605),(18.865,15.605),(18.865,15.435),(18.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.435),(19.055,15.605),(19.225,15.605),(19.225,15.435),(19.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.795),(17.975,15.965),(18.145,15.965),(18.145,15.795),(17.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.795),(18.335,15.965),(18.505,15.965),(18.505,15.795),(18.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.795),(18.695,15.965),(18.865,15.965),(18.865,15.795),(18.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.795),(19.055,15.965),(19.225,15.965),(19.225,15.795),(19.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.155),(17.975,16.325),(18.145,16.325),(18.145,16.155),(17.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.155),(18.335,16.325),(18.505,16.325),(18.505,16.155),(18.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.155),(18.695,16.325),(18.865,16.325),(18.865,16.155),(18.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.155),(19.055,16.325),(19.225,16.325),(19.225,16.155),(19.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.515),(17.975,16.685),(18.145,16.685),(18.145,16.515),(17.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.515),(18.335,16.685),(18.505,16.685),(18.505,16.515),(18.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.515),(18.695,16.685),(18.865,16.685),(18.865,16.515),(18.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.515),(19.055,16.685),(19.225,16.685),(19.225,16.515),(19.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.875),(17.975,17.045),(18.145,17.045),(18.145,16.875),(17.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.875),(18.335,17.045),(18.505,17.045),(18.505,16.875),(18.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.875),(18.695,17.045),(18.865,17.045),(18.865,16.875),(18.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.875),(19.055,17.045),(19.225,17.045),(19.225,16.875),(19.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.235),(17.975,17.405),(18.145,17.405),(18.145,17.235),(17.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.235),(18.335,17.405),(18.505,17.405),(18.505,17.235),(18.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.235),(18.695,17.405),(18.865,17.405),(18.865,17.235),(18.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.235),(19.055,17.405),(19.225,17.405),(19.225,17.235),(19.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.595),(17.975,17.765),(18.145,17.765),(18.145,17.595),(17.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.595),(18.335,17.765),(18.505,17.765),(18.505,17.595),(18.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.595),(18.695,17.765),(18.865,17.765),(18.865,17.595),(18.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.595),(19.055,17.765),(19.225,17.765),(19.225,17.595),(19.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.955),(17.975,18.125),(18.145,18.125),(18.145,17.955),(17.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.955),(18.335,18.125),(18.505,18.125),(18.505,17.955),(18.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.955),(18.695,18.125),(18.865,18.125),(18.865,17.955),(18.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.955),(19.055,18.125),(19.225,18.125),(19.225,17.955),(19.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.315),(17.975,18.485),(18.145,18.485),(18.145,18.315),(17.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.315),(18.335,18.485),(18.505,18.485),(18.505,18.315),(18.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.315),(18.695,18.485),(18.865,18.485),(18.865,18.315),(18.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.315),(19.055,18.485),(19.225,18.485),(19.225,18.315),(19.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.675),(17.975,18.845),(18.145,18.845),(18.145,18.675),(17.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.675),(18.335,18.845),(18.505,18.845),(18.505,18.675),(18.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.675),(18.695,18.845),(18.865,18.845),(18.865,18.675),(18.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.675),(19.055,18.845),(19.225,18.845),(19.225,18.675),(19.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.035),(17.975,19.205),(18.145,19.205),(18.145,19.035),(17.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.035),(18.335,19.205),(18.505,19.205),(18.505,19.035),(18.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.035),(18.695,19.205),(18.865,19.205),(18.865,19.035),(18.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.035),(19.055,19.205),(19.225,19.205),(19.225,19.035),(19.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.395),(17.975,19.565),(18.145,19.565),(18.145,19.395),(17.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.395),(18.335,19.565),(18.505,19.565),(18.505,19.395),(18.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.395),(18.695,19.565),(18.865,19.565),(18.865,19.395),(18.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.395),(19.055,19.565),(19.225,19.565),(19.225,19.395),(19.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.755),(17.975,19.925),(18.145,19.925),(18.145,19.755),(17.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.755),(18.335,19.925),(18.505,19.925),(18.505,19.755),(18.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.755),(18.695,19.925),(18.865,19.925),(18.865,19.755),(18.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.755),(19.055,19.925),(19.225,19.925),(19.225,19.755),(19.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,20.115),(17.975,20.285),(18.145,20.285),(18.145,20.115),(17.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,20.115),(18.335,20.285),(18.505,20.285),(18.505,20.115),(18.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,20.115),(18.695,20.285),(18.865,20.285),(18.865,20.115),(18.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,20.115),(19.055,20.285),(19.225,20.285),(19.225,20.115),(19.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,20.475),(17.975,20.645),(18.145,20.645),(18.145,20.475),(17.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,20.475),(18.335,20.645),(18.505,20.645),(18.505,20.475),(18.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,20.475),(18.695,20.645),(18.865,20.645),(18.865,20.475),(18.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,20.475),(19.055,20.645),(19.225,20.645),(19.225,20.475),(19.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,20.835),(17.975,21.005),(18.145,21.005),(18.145,20.835),(17.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,20.835),(18.335,21.005),(18.505,21.005),(18.505,20.835),(18.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,20.835),(18.695,21.005),(18.865,21.005),(18.865,20.835),(18.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,20.835),(19.055,21.005),(19.225,21.005),(19.225,20.835),(19.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,21.195),(17.975,21.365),(18.145,21.365),(18.145,21.195),(17.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,21.195),(18.335,21.365),(18.505,21.365),(18.505,21.195),(18.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,21.195),(18.695,21.365),(18.865,21.365),(18.865,21.195),(18.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,21.195),(19.055,21.365),(19.225,21.365),(19.225,21.195),(19.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,21.555),(17.975,21.725),(18.145,21.725),(18.145,21.555),(17.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,21.555),(18.335,21.725),(18.505,21.725),(18.505,21.555),(18.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,21.555),(18.695,21.725),(18.865,21.725),(18.865,21.555),(18.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,21.555),(19.055,21.725),(19.225,21.725),(19.225,21.555),(19.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,21.915),(17.975,22.085),(18.145,22.085),(18.145,21.915),(17.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,21.915),(18.335,22.085),(18.505,22.085),(18.505,21.915),(18.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,21.915),(18.695,22.085),(18.865,22.085),(18.865,21.915),(18.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,21.915),(19.055,22.085),(19.225,22.085),(19.225,21.915),(19.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.275),(17.975,22.445),(18.145,22.445),(18.145,22.275),(17.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.275),(18.335,22.445),(18.505,22.445),(18.505,22.275),(18.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.275),(18.695,22.445),(18.865,22.445),(18.865,22.275),(18.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.275),(19.055,22.445),(19.225,22.445),(19.225,22.275),(19.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.635),(17.975,22.805),(18.145,22.805),(18.145,22.635),(17.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.635),(18.335,22.805),(18.505,22.805),(18.505,22.635),(18.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.635),(18.695,22.805),(18.865,22.805),(18.865,22.635),(18.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.635),(19.055,22.805),(19.225,22.805),(19.225,22.635),(19.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.995),(17.975,23.165),(18.145,23.165),(18.145,22.995),(17.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.995),(18.335,23.165),(18.505,23.165),(18.505,22.995),(18.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.995),(18.695,23.165),(18.865,23.165),(18.865,22.995),(18.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.995),(19.055,23.165),(19.225,23.165),(19.225,22.995),(19.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,23.355),(17.975,23.525),(18.145,23.525),(18.145,23.355),(17.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,23.355),(18.335,23.525),(18.505,23.525),(18.505,23.355),(18.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,23.355),(18.695,23.525),(18.865,23.525),(18.865,23.355),(18.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,23.355),(19.055,23.525),(19.225,23.525),(19.225,23.355),(19.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,23.715),(17.975,23.885),(18.145,23.885),(18.145,23.715),(17.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,23.715),(18.335,23.885),(18.505,23.885),(18.505,23.715),(18.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,23.715),(18.695,23.885),(18.865,23.885),(18.865,23.715),(18.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,23.715),(19.055,23.885),(19.225,23.885),(19.225,23.715),(19.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,24.075),(17.975,24.245),(18.145,24.245),(18.145,24.075),(17.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,24.075),(18.335,24.245),(18.505,24.245),(18.505,24.075),(18.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,24.075),(18.695,24.245),(18.865,24.245),(18.865,24.075),(18.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,24.075),(19.055,24.245),(19.225,24.245),(19.225,24.075),(19.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,24.435),(17.975,24.605),(18.145,24.605),(18.145,24.435),(17.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,24.435),(18.335,24.605),(18.505,24.605),(18.505,24.435),(18.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,24.435),(18.695,24.605),(18.865,24.605),(18.865,24.435),(18.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,24.435),(19.055,24.605),(19.225,24.605),(19.225,24.435),(19.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,24.795),(17.975,24.965),(18.145,24.965),(18.145,24.795),(17.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,24.795),(18.335,24.965),(18.505,24.965),(18.505,24.795),(18.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,24.795),(18.695,24.965),(18.865,24.965),(18.865,24.795),(18.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,24.795),(19.055,24.965),(19.225,24.965),(19.225,24.795),(19.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,25.155),(17.975,25.325),(18.145,25.325),(18.145,25.155),(17.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,25.155),(18.335,25.325),(18.505,25.325),(18.505,25.155),(18.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,25.155),(18.695,25.325),(18.865,25.325),(18.865,25.155),(18.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,25.155),(19.055,25.325),(19.225,25.325),(19.225,25.155),(19.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,25.515),(17.975,25.685),(18.145,25.685),(18.145,25.515),(17.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,25.515),(18.335,25.685),(18.505,25.685),(18.505,25.515),(18.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,25.515),(18.695,25.685),(18.865,25.685),(18.865,25.515),(18.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,25.515),(19.055,25.685),(19.225,25.685),(19.225,25.515),(19.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,25.875),(17.975,26.045),(18.145,26.045),(18.145,25.875),(17.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,25.875),(18.335,26.045),(18.505,26.045),(18.505,25.875),(18.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,25.875),(18.695,26.045),(18.865,26.045),(18.865,25.875),(18.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,25.875),(19.055,26.045),(19.225,26.045),(19.225,25.875),(19.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,26.235),(17.975,26.405),(18.145,26.405),(18.145,26.235),(17.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,26.235),(18.335,26.405),(18.505,26.405),(18.505,26.235),(18.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,26.235),(18.695,26.405),(18.865,26.405),(18.865,26.235),(18.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,26.235),(19.055,26.405),(19.225,26.405),(19.225,26.235),(19.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,26.595),(17.975,26.765),(18.145,26.765),(18.145,26.595),(17.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,26.595),(18.335,26.765),(18.505,26.765),(18.505,26.595),(18.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,26.595),(18.695,26.765),(18.865,26.765),(18.865,26.595),(18.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,26.595),(19.055,26.765),(19.225,26.765),(19.225,26.595),(19.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,26.955),(17.975,27.125),(18.145,27.125),(18.145,26.955),(17.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,26.955),(18.335,27.125),(18.505,27.125),(18.505,26.955),(18.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,26.955),(18.695,27.125),(18.865,27.125),(18.865,26.955),(18.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,26.955),(19.055,27.125),(19.225,27.125),(19.225,26.955),(19.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,27.315),(17.975,27.485),(18.145,27.485),(18.145,27.315),(17.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,27.315),(18.335,27.485),(18.505,27.485),(18.505,27.315),(18.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,27.315),(18.695,27.485),(18.865,27.485),(18.865,27.315),(18.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,27.315),(19.055,27.485),(19.225,27.485),(19.225,27.315),(19.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,27.675),(17.975,27.845),(18.145,27.845),(18.145,27.675),(17.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,27.675),(18.335,27.845),(18.505,27.845),(18.505,27.675),(18.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,27.675),(18.695,27.845),(18.865,27.845),(18.865,27.675),(18.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,27.675),(19.055,27.845),(19.225,27.845),(19.225,27.675),(19.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,28.035),(17.975,28.205),(18.145,28.205),(18.145,28.035),(17.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,28.035),(18.335,28.205),(18.505,28.205),(18.505,28.035),(18.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,28.035),(18.695,28.205),(18.865,28.205),(18.865,28.035),(18.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,28.035),(19.055,28.205),(19.225,28.205),(19.225,28.035),(19.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,28.395),(17.975,28.565),(18.145,28.565),(18.145,28.395),(17.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,28.395),(18.335,28.565),(18.505,28.565),(18.505,28.395),(18.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,28.395),(18.695,28.565),(18.865,28.565),(18.865,28.395),(18.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,28.395),(19.055,28.565),(19.225,28.565),(19.225,28.395),(19.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,28.755),(17.975,28.925),(18.145,28.925),(18.145,28.755),(17.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,28.755),(18.335,28.925),(18.505,28.925),(18.505,28.755),(18.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,28.755),(18.695,28.925),(18.865,28.925),(18.865,28.755),(18.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,28.755),(19.055,28.925),(19.225,28.925),(19.225,28.755),(19.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,29.115),(17.975,29.285),(18.145,29.285),(18.145,29.115),(17.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,29.115),(18.335,29.285),(18.505,29.285),(18.505,29.115),(18.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,29.115),(18.695,29.285),(18.865,29.285),(18.865,29.115),(18.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,29.115),(19.055,29.285),(19.225,29.285),(19.225,29.115),(19.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,29.475),(17.975,29.645),(18.145,29.645),(18.145,29.475),(17.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,29.475),(18.335,29.645),(18.505,29.645),(18.505,29.475),(18.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,29.475),(18.695,29.645),(18.865,29.645),(18.865,29.475),(18.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,29.475),(19.055,29.645),(19.225,29.645),(19.225,29.475),(19.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,29.835),(17.975,30.005),(18.145,30.005),(18.145,29.835),(17.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,29.835),(18.335,30.005),(18.505,30.005),(18.505,29.835),(18.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,29.835),(18.695,30.005),(18.865,30.005),(18.865,29.835),(18.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,29.835),(19.055,30.005),(19.225,30.005),(19.225,29.835),(19.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,30.195),(17.975,30.365),(18.145,30.365),(18.145,30.195),(17.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,30.195),(18.335,30.365),(18.505,30.365),(18.505,30.195),(18.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,30.195),(18.695,30.365),(18.865,30.365),(18.865,30.195),(18.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,30.195),(19.055,30.365),(19.225,30.365),(19.225,30.195),(19.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,30.555),(17.975,30.725),(18.145,30.725),(18.145,30.555),(17.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,30.555),(18.335,30.725),(18.505,30.725),(18.505,30.555),(18.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,30.555),(18.695,30.725),(18.865,30.725),(18.865,30.555),(18.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,30.555),(19.055,30.725),(19.225,30.725),(19.225,30.555),(19.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,30.915),(17.975,31.085),(18.145,31.085),(18.145,30.915),(17.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,30.915),(18.335,31.085),(18.505,31.085),(18.505,30.915),(18.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,30.915),(18.695,31.085),(18.865,31.085),(18.865,30.915),(18.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,30.915),(19.055,31.085),(19.225,31.085),(19.225,30.915),(19.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,31.275),(17.975,31.445),(18.145,31.445),(18.145,31.275),(17.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,31.275),(18.335,31.445),(18.505,31.445),(18.505,31.275),(18.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,31.275),(18.695,31.445),(18.865,31.445),(18.865,31.275),(18.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,31.275),(19.055,31.445),(19.225,31.445),(19.225,31.275),(19.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,31.635),(17.975,31.805),(18.145,31.805),(18.145,31.635),(17.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,31.635),(18.335,31.805),(18.505,31.805),(18.505,31.635),(18.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,31.635),(18.695,31.805),(18.865,31.805),(18.865,31.635),(18.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,31.635),(19.055,31.805),(19.225,31.805),(19.225,31.635),(19.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,31.995),(17.975,32.165),(18.145,32.165),(18.145,31.995),(17.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,31.995),(18.335,32.165),(18.505,32.165),(18.505,31.995),(18.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,31.995),(18.695,32.165),(18.865,32.165),(18.865,31.995),(18.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,31.995),(19.055,32.165),(19.225,32.165),(19.225,31.995),(19.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,32.355),(17.975,32.525),(18.145,32.525),(18.145,32.355),(17.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,32.355),(18.335,32.525),(18.505,32.525),(18.505,32.355),(18.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,32.355),(18.695,32.525),(18.865,32.525),(18.865,32.355),(18.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,32.355),(19.055,32.525),(19.225,32.525),(19.225,32.355),(19.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,32.715),(17.975,32.885),(18.145,32.885),(18.145,32.715),(17.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,32.715),(18.335,32.885),(18.505,32.885),(18.505,32.715),(18.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,32.715),(18.695,32.885),(18.865,32.885),(18.865,32.715),(18.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,32.715),(19.055,32.885),(19.225,32.885),(19.225,32.715),(19.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,33.075),(17.975,33.245),(18.145,33.245),(18.145,33.075),(17.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,33.075),(18.335,33.245),(18.505,33.245),(18.505,33.075),(18.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,33.075),(18.695,33.245),(18.865,33.245),(18.865,33.075),(18.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,33.075),(19.055,33.245),(19.225,33.245),(19.225,33.075),(19.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,33.435),(17.975,33.605),(18.145,33.605),(18.145,33.435),(17.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,33.435),(18.335,33.605),(18.505,33.605),(18.505,33.435),(18.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,33.435),(18.695,33.605),(18.865,33.605),(18.865,33.435),(18.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,33.435),(19.055,33.605),(19.225,33.605),(19.225,33.435),(19.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,33.795),(17.975,33.965),(18.145,33.965),(18.145,33.795),(17.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,33.795),(18.335,33.965),(18.505,33.965),(18.505,33.795),(18.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,33.795),(18.695,33.965),(18.865,33.965),(18.865,33.795),(18.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,33.795),(19.055,33.965),(19.225,33.965),(19.225,33.795),(19.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,34.155),(17.975,34.325),(18.145,34.325),(18.145,34.155),(17.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,34.155),(18.335,34.325),(18.505,34.325),(18.505,34.155),(18.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,34.155),(18.695,34.325),(18.865,34.325),(18.865,34.155),(18.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,34.155),(19.055,34.325),(19.225,34.325),(19.225,34.155),(19.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,34.515),(17.975,34.685),(18.145,34.685),(18.145,34.515),(17.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,34.515),(18.335,34.685),(18.505,34.685),(18.505,34.515),(18.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,34.515),(18.695,34.685),(18.865,34.685),(18.865,34.515),(18.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,34.515),(19.055,34.685),(19.225,34.685),(19.225,34.515),(19.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,34.875),(17.975,35.045),(18.145,35.045),(18.145,34.875),(17.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,34.875),(18.335,35.045),(18.505,35.045),(18.505,34.875),(18.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,34.875),(18.695,35.045),(18.865,35.045),(18.865,34.875),(18.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,34.875),(19.055,35.045),(19.225,35.045),(19.225,34.875),(19.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,35.235),(17.975,35.405),(18.145,35.405),(18.145,35.235),(17.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,35.235),(18.335,35.405),(18.505,35.405),(18.505,35.235),(18.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,35.235),(18.695,35.405),(18.865,35.405),(18.865,35.235),(18.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,35.235),(19.055,35.405),(19.225,35.405),(19.225,35.235),(19.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,35.595),(17.975,35.765),(18.145,35.765),(18.145,35.595),(17.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,35.595),(18.335,35.765),(18.505,35.765),(18.505,35.595),(18.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,35.595),(18.695,35.765),(18.865,35.765),(18.865,35.595),(18.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,35.595),(19.055,35.765),(19.225,35.765),(19.225,35.595),(19.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,35.955),(17.975,36.125),(18.145,36.125),(18.145,35.955),(17.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,35.955),(18.335,36.125),(18.505,36.125),(18.505,35.955),(18.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,35.955),(18.695,36.125),(18.865,36.125),(18.865,35.955),(18.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,35.955),(19.055,36.125),(19.225,36.125),(19.225,35.955),(19.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,36.315),(17.975,36.485),(18.145,36.485),(18.145,36.315),(17.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,36.315),(18.335,36.485),(18.505,36.485),(18.505,36.315),(18.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,36.315),(18.695,36.485),(18.865,36.485),(18.865,36.315),(18.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,36.315),(19.055,36.485),(19.225,36.485),(19.225,36.315),(19.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,36.675),(17.975,36.845),(18.145,36.845),(18.145,36.675),(17.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,36.675),(18.335,36.845),(18.505,36.845),(18.505,36.675),(18.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,36.675),(18.695,36.845),(18.865,36.845),(18.865,36.675),(18.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,36.675),(19.055,36.845),(19.225,36.845),(19.225,36.675),(19.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,37.035),(17.975,37.205),(18.145,37.205),(18.145,37.035),(17.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,37.035),(18.335,37.205),(18.505,37.205),(18.505,37.035),(18.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,37.035),(18.695,37.205),(18.865,37.205),(18.865,37.035),(18.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,37.035),(19.055,37.205),(19.225,37.205),(19.225,37.035),(19.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,37.395),(17.975,37.565),(18.145,37.565),(18.145,37.395),(17.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,37.395),(18.335,37.565),(18.505,37.565),(18.505,37.395),(18.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,37.395),(18.695,37.565),(18.865,37.565),(18.865,37.395),(18.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,37.395),(19.055,37.565),(19.225,37.565),(19.225,37.395),(19.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,37.755),(17.975,37.925),(18.145,37.925),(18.145,37.755),(17.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,37.755),(18.335,37.925),(18.505,37.925),(18.505,37.755),(18.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,37.755),(18.695,37.925),(18.865,37.925),(18.865,37.755),(18.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,37.755),(19.055,37.925),(19.225,37.925),(19.225,37.755),(19.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,38.115),(17.975,38.285),(18.145,38.285),(18.145,38.115),(17.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,38.115),(18.335,38.285),(18.505,38.285),(18.505,38.115),(18.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,38.115),(18.695,38.285),(18.865,38.285),(18.865,38.115),(18.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,38.115),(19.055,38.285),(19.225,38.285),(19.225,38.115),(19.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,38.475),(17.975,38.645),(18.145,38.645),(18.145,38.475),(17.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,38.475),(18.335,38.645),(18.505,38.645),(18.505,38.475),(18.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,38.475),(18.695,38.645),(18.865,38.645),(18.865,38.475),(18.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,38.475),(19.055,38.645),(19.225,38.645),(19.225,38.475),(19.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,38.835),(17.975,39.005),(18.145,39.005),(18.145,38.835),(17.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,38.835),(18.335,39.005),(18.505,39.005),(18.505,38.835),(18.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,38.835),(18.695,39.005),(18.865,39.005),(18.865,38.835),(18.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,38.835),(19.055,39.005),(19.225,39.005),(19.225,38.835),(19.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,39.195),(17.975,39.365),(18.145,39.365),(18.145,39.195),(17.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,39.195),(18.335,39.365),(18.505,39.365),(18.505,39.195),(18.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,39.195),(18.695,39.365),(18.865,39.365),(18.865,39.195),(18.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,39.195),(19.055,39.365),(19.225,39.365),(19.225,39.195),(19.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,39.555),(17.975,39.725),(18.145,39.725),(18.145,39.555),(17.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,39.555),(18.335,39.725),(18.505,39.725),(18.505,39.555),(18.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,39.555),(18.695,39.725),(18.865,39.725),(18.865,39.555),(18.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,39.555),(19.055,39.725),(19.225,39.725),(19.225,39.555),(19.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,39.915),(17.975,40.085),(18.145,40.085),(18.145,39.915),(17.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,39.915),(18.335,40.085),(18.505,40.085),(18.505,39.915),(18.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,39.915),(18.695,40.085),(18.865,40.085),(18.865,39.915),(18.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,39.915),(19.055,40.085),(19.225,40.085),(19.225,39.915),(19.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,40.275),(17.975,40.445),(18.145,40.445),(18.145,40.275),(17.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,40.275),(18.335,40.445),(18.505,40.445),(18.505,40.275),(18.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,40.275),(18.695,40.445),(18.865,40.445),(18.865,40.275),(18.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,40.275),(19.055,40.445),(19.225,40.445),(19.225,40.275),(19.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,40.635),(17.975,40.805),(18.145,40.805),(18.145,40.635),(17.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,40.635),(18.335,40.805),(18.505,40.805),(18.505,40.635),(18.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,40.635),(18.695,40.805),(18.865,40.805),(18.865,40.635),(18.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,40.635),(19.055,40.805),(19.225,40.805),(19.225,40.635),(19.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.835),(32.375,3.005),(32.545,3.005),(32.545,2.835),(32.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.835),(32.735,3.005),(32.905,3.005),(32.905,2.835),(32.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.835),(33.095,3.005),(33.265,3.005),(33.265,2.835),(33.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.835),(33.455,3.005),(33.625,3.005),(33.625,2.835),(33.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.195),(32.375,3.365),(32.545,3.365),(32.545,3.195),(32.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.195),(32.735,3.365),(32.905,3.365),(32.905,3.195),(32.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.195),(33.095,3.365),(33.265,3.365),(33.265,3.195),(33.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.195),(33.455,3.365),(33.625,3.365),(33.625,3.195),(33.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.555),(32.375,3.725),(32.545,3.725),(32.545,3.555),(32.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.555),(32.735,3.725),(32.905,3.725),(32.905,3.555),(32.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.555),(33.095,3.725),(33.265,3.725),(33.265,3.555),(33.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.555),(33.455,3.725),(33.625,3.725),(33.625,3.555),(33.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.915),(32.375,4.085),(32.545,4.085),(32.545,3.915),(32.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.915),(32.735,4.085),(32.905,4.085),(32.905,3.915),(32.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.915),(33.095,4.085),(33.265,4.085),(33.265,3.915),(33.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.915),(33.455,4.085),(33.625,4.085),(33.625,3.915),(33.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.275),(32.375,4.445),(32.545,4.445),(32.545,4.275),(32.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.275),(32.735,4.445),(32.905,4.445),(32.905,4.275),(32.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.275),(33.095,4.445),(33.265,4.445),(33.265,4.275),(33.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.275),(33.455,4.445),(33.625,4.445),(33.625,4.275),(33.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.635),(32.375,4.805),(32.545,4.805),(32.545,4.635),(32.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.635),(32.735,4.805),(32.905,4.805),(32.905,4.635),(32.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.635),(33.095,4.805),(33.265,4.805),(33.265,4.635),(33.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.635),(33.455,4.805),(33.625,4.805),(33.625,4.635),(33.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.995),(32.375,5.165),(32.545,5.165),(32.545,4.995),(32.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.995),(32.735,5.165),(32.905,5.165),(32.905,4.995),(32.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.995),(33.095,5.165),(33.265,5.165),(33.265,4.995),(33.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.995),(33.455,5.165),(33.625,5.165),(33.625,4.995),(33.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.355),(32.375,5.525),(32.545,5.525),(32.545,5.355),(32.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.355),(32.735,5.525),(32.905,5.525),(32.905,5.355),(32.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.355),(33.095,5.525),(33.265,5.525),(33.265,5.355),(33.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.355),(33.455,5.525),(33.625,5.525),(33.625,5.355),(33.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.715),(32.375,5.885),(32.545,5.885),(32.545,5.715),(32.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.715),(32.735,5.885),(32.905,5.885),(32.905,5.715),(32.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.715),(33.095,5.885),(33.265,5.885),(33.265,5.715),(33.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.715),(33.455,5.885),(33.625,5.885),(33.625,5.715),(33.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.075),(32.375,6.245),(32.545,6.245),(32.545,6.075),(32.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.075),(32.735,6.245),(32.905,6.245),(32.905,6.075),(32.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.075),(33.095,6.245),(33.265,6.245),(33.265,6.075),(33.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.075),(33.455,6.245),(33.625,6.245),(33.625,6.075),(33.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.435),(32.375,6.605),(32.545,6.605),(32.545,6.435),(32.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.435),(32.735,6.605),(32.905,6.605),(32.905,6.435),(32.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.435),(33.095,6.605),(33.265,6.605),(33.265,6.435),(33.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.435),(33.455,6.605),(33.625,6.605),(33.625,6.435),(33.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.795),(32.375,6.965),(32.545,6.965),(32.545,6.795),(32.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.795),(32.735,6.965),(32.905,6.965),(32.905,6.795),(32.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.795),(33.095,6.965),(33.265,6.965),(33.265,6.795),(33.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.795),(33.455,6.965),(33.625,6.965),(33.625,6.795),(33.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.155),(32.375,7.325),(32.545,7.325),(32.545,7.155),(32.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.155),(32.735,7.325),(32.905,7.325),(32.905,7.155),(32.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.155),(33.095,7.325),(33.265,7.325),(33.265,7.155),(33.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.155),(33.455,7.325),(33.625,7.325),(33.625,7.155),(33.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.515),(32.375,7.685),(32.545,7.685),(32.545,7.515),(32.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.515),(32.735,7.685),(32.905,7.685),(32.905,7.515),(32.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.515),(33.095,7.685),(33.265,7.685),(33.265,7.515),(33.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.515),(33.455,7.685),(33.625,7.685),(33.625,7.515),(33.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.875),(32.375,8.045),(32.545,8.045),(32.545,7.875),(32.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.875),(32.735,8.045),(32.905,8.045),(32.905,7.875),(32.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.875),(33.095,8.045),(33.265,8.045),(33.265,7.875),(33.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.875),(33.455,8.045),(33.625,8.045),(33.625,7.875),(33.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.235),(32.375,8.405),(32.545,8.405),(32.545,8.235),(32.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.235),(32.735,8.405),(32.905,8.405),(32.905,8.235),(32.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.235),(33.095,8.405),(33.265,8.405),(33.265,8.235),(33.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.235),(33.455,8.405),(33.625,8.405),(33.625,8.235),(33.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.595),(32.375,8.765),(32.545,8.765),(32.545,8.595),(32.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.595),(32.735,8.765),(32.905,8.765),(32.905,8.595),(32.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.595),(33.095,8.765),(33.265,8.765),(33.265,8.595),(33.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.595),(33.455,8.765),(33.625,8.765),(33.625,8.595),(33.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.955),(32.375,9.125),(32.545,9.125),(32.545,8.955),(32.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.955),(32.735,9.125),(32.905,9.125),(32.905,8.955),(32.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.955),(33.095,9.125),(33.265,9.125),(33.265,8.955),(33.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.955),(33.455,9.125),(33.625,9.125),(33.625,8.955),(33.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.315),(32.375,9.485),(32.545,9.485),(32.545,9.315),(32.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.315),(32.735,9.485),(32.905,9.485),(32.905,9.315),(32.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.315),(33.095,9.485),(33.265,9.485),(33.265,9.315),(33.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.315),(33.455,9.485),(33.625,9.485),(33.625,9.315),(33.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.675),(32.375,9.845),(32.545,9.845),(32.545,9.675),(32.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.675),(32.735,9.845),(32.905,9.845),(32.905,9.675),(32.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.675),(33.095,9.845),(33.265,9.845),(33.265,9.675),(33.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.675),(33.455,9.845),(33.625,9.845),(33.625,9.675),(33.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.035),(32.375,10.205),(32.545,10.205),(32.545,10.035),(32.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.035),(32.735,10.205),(32.905,10.205),(32.905,10.035),(32.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.035),(33.095,10.205),(33.265,10.205),(33.265,10.035),(33.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.035),(33.455,10.205),(33.625,10.205),(33.625,10.035),(33.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.395),(32.375,10.565),(32.545,10.565),(32.545,10.395),(32.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.395),(32.735,10.565),(32.905,10.565),(32.905,10.395),(32.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.395),(33.095,10.565),(33.265,10.565),(33.265,10.395),(33.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.395),(33.455,10.565),(33.625,10.565),(33.625,10.395),(33.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.755),(32.375,10.925),(32.545,10.925),(32.545,10.755),(32.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.755),(32.735,10.925),(32.905,10.925),(32.905,10.755),(32.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.755),(33.095,10.925),(33.265,10.925),(33.265,10.755),(33.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.755),(33.455,10.925),(33.625,10.925),(33.625,10.755),(33.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.115),(32.375,11.285),(32.545,11.285),(32.545,11.115),(32.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.115),(32.735,11.285),(32.905,11.285),(32.905,11.115),(32.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.115),(33.095,11.285),(33.265,11.285),(33.265,11.115),(33.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.115),(33.455,11.285),(33.625,11.285),(33.625,11.115),(33.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.475),(32.375,11.645),(32.545,11.645),(32.545,11.475),(32.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.475),(32.735,11.645),(32.905,11.645),(32.905,11.475),(32.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.475),(33.095,11.645),(33.265,11.645),(33.265,11.475),(33.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.475),(33.455,11.645),(33.625,11.645),(33.625,11.475),(33.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.835),(32.375,12.005),(32.545,12.005),(32.545,11.835),(32.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.835),(32.735,12.005),(32.905,12.005),(32.905,11.835),(32.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.835),(33.095,12.005),(33.265,12.005),(33.265,11.835),(33.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.835),(33.455,12.005),(33.625,12.005),(33.625,11.835),(33.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.195),(32.375,12.365),(32.545,12.365),(32.545,12.195),(32.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.195),(32.735,12.365),(32.905,12.365),(32.905,12.195),(32.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.195),(33.095,12.365),(33.265,12.365),(33.265,12.195),(33.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.195),(33.455,12.365),(33.625,12.365),(33.625,12.195),(33.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.555),(32.375,12.725),(32.545,12.725),(32.545,12.555),(32.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.555),(32.735,12.725),(32.905,12.725),(32.905,12.555),(32.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.555),(33.095,12.725),(33.265,12.725),(33.265,12.555),(33.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.555),(33.455,12.725),(33.625,12.725),(33.625,12.555),(33.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.915),(32.375,13.085),(32.545,13.085),(32.545,12.915),(32.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.915),(32.735,13.085),(32.905,13.085),(32.905,12.915),(32.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.915),(33.095,13.085),(33.265,13.085),(33.265,12.915),(33.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.915),(33.455,13.085),(33.625,13.085),(33.625,12.915),(33.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.275),(32.375,13.445),(32.545,13.445),(32.545,13.275),(32.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.275),(32.735,13.445),(32.905,13.445),(32.905,13.275),(32.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.275),(33.095,13.445),(33.265,13.445),(33.265,13.275),(33.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.275),(33.455,13.445),(33.625,13.445),(33.625,13.275),(33.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.635),(32.375,13.805),(32.545,13.805),(32.545,13.635),(32.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.635),(32.735,13.805),(32.905,13.805),(32.905,13.635),(32.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.635),(33.095,13.805),(33.265,13.805),(33.265,13.635),(33.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.635),(33.455,13.805),(33.625,13.805),(33.625,13.635),(33.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.995),(32.375,14.165),(32.545,14.165),(32.545,13.995),(32.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.995),(32.735,14.165),(32.905,14.165),(32.905,13.995),(32.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.995),(33.095,14.165),(33.265,14.165),(33.265,13.995),(33.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.995),(33.455,14.165),(33.625,14.165),(33.625,13.995),(33.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.355),(32.375,14.525),(32.545,14.525),(32.545,14.355),(32.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.355),(32.735,14.525),(32.905,14.525),(32.905,14.355),(32.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.355),(33.095,14.525),(33.265,14.525),(33.265,14.355),(33.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.355),(33.455,14.525),(33.625,14.525),(33.625,14.355),(33.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.715),(32.375,14.885),(32.545,14.885),(32.545,14.715),(32.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.715),(32.735,14.885),(32.905,14.885),(32.905,14.715),(32.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.715),(33.095,14.885),(33.265,14.885),(33.265,14.715),(33.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.715),(33.455,14.885),(33.625,14.885),(33.625,14.715),(33.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.075),(32.375,15.245),(32.545,15.245),(32.545,15.075),(32.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.075),(32.735,15.245),(32.905,15.245),(32.905,15.075),(32.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.075),(33.095,15.245),(33.265,15.245),(33.265,15.075),(33.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.075),(33.455,15.245),(33.625,15.245),(33.625,15.075),(33.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.435),(32.375,15.605),(32.545,15.605),(32.545,15.435),(32.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.435),(32.735,15.605),(32.905,15.605),(32.905,15.435),(32.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.435),(33.095,15.605),(33.265,15.605),(33.265,15.435),(33.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.435),(33.455,15.605),(33.625,15.605),(33.625,15.435),(33.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.795),(32.375,15.965),(32.545,15.965),(32.545,15.795),(32.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.795),(32.735,15.965),(32.905,15.965),(32.905,15.795),(32.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.795),(33.095,15.965),(33.265,15.965),(33.265,15.795),(33.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.795),(33.455,15.965),(33.625,15.965),(33.625,15.795),(33.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.155),(32.375,16.325),(32.545,16.325),(32.545,16.155),(32.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.155),(32.735,16.325),(32.905,16.325),(32.905,16.155),(32.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.155),(33.095,16.325),(33.265,16.325),(33.265,16.155),(33.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.155),(33.455,16.325),(33.625,16.325),(33.625,16.155),(33.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.515),(32.375,16.685),(32.545,16.685),(32.545,16.515),(32.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.515),(32.735,16.685),(32.905,16.685),(32.905,16.515),(32.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.515),(33.095,16.685),(33.265,16.685),(33.265,16.515),(33.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.515),(33.455,16.685),(33.625,16.685),(33.625,16.515),(33.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.875),(32.375,17.045),(32.545,17.045),(32.545,16.875),(32.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.875),(32.735,17.045),(32.905,17.045),(32.905,16.875),(32.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.875),(33.095,17.045),(33.265,17.045),(33.265,16.875),(33.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.875),(33.455,17.045),(33.625,17.045),(33.625,16.875),(33.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.235),(32.375,17.405),(32.545,17.405),(32.545,17.235),(32.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.235),(32.735,17.405),(32.905,17.405),(32.905,17.235),(32.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.235),(33.095,17.405),(33.265,17.405),(33.265,17.235),(33.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.235),(33.455,17.405),(33.625,17.405),(33.625,17.235),(33.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.595),(32.375,17.765),(32.545,17.765),(32.545,17.595),(32.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.595),(32.735,17.765),(32.905,17.765),(32.905,17.595),(32.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.595),(33.095,17.765),(33.265,17.765),(33.265,17.595),(33.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.595),(33.455,17.765),(33.625,17.765),(33.625,17.595),(33.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.955),(32.375,18.125),(32.545,18.125),(32.545,17.955),(32.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.955),(32.735,18.125),(32.905,18.125),(32.905,17.955),(32.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.955),(33.095,18.125),(33.265,18.125),(33.265,17.955),(33.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.955),(33.455,18.125),(33.625,18.125),(33.625,17.955),(33.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.315),(32.375,18.485),(32.545,18.485),(32.545,18.315),(32.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.315),(32.735,18.485),(32.905,18.485),(32.905,18.315),(32.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.315),(33.095,18.485),(33.265,18.485),(33.265,18.315),(33.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.315),(33.455,18.485),(33.625,18.485),(33.625,18.315),(33.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.675),(32.375,18.845),(32.545,18.845),(32.545,18.675),(32.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.675),(32.735,18.845),(32.905,18.845),(32.905,18.675),(32.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.675),(33.095,18.845),(33.265,18.845),(33.265,18.675),(33.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.675),(33.455,18.845),(33.625,18.845),(33.625,18.675),(33.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.035),(32.375,19.205),(32.545,19.205),(32.545,19.035),(32.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.035),(32.735,19.205),(32.905,19.205),(32.905,19.035),(32.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.035),(33.095,19.205),(33.265,19.205),(33.265,19.035),(33.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.035),(33.455,19.205),(33.625,19.205),(33.625,19.035),(33.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.395),(32.375,19.565),(32.545,19.565),(32.545,19.395),(32.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.395),(32.735,19.565),(32.905,19.565),(32.905,19.395),(32.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.395),(33.095,19.565),(33.265,19.565),(33.265,19.395),(33.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.395),(33.455,19.565),(33.625,19.565),(33.625,19.395),(33.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.755),(32.375,19.925),(32.545,19.925),(32.545,19.755),(32.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.755),(32.735,19.925),(32.905,19.925),(32.905,19.755),(32.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.755),(33.095,19.925),(33.265,19.925),(33.265,19.755),(33.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.755),(33.455,19.925),(33.625,19.925),(33.625,19.755),(33.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.115),(32.375,20.285),(32.545,20.285),(32.545,20.115),(32.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.115),(32.735,20.285),(32.905,20.285),(32.905,20.115),(32.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.115),(33.095,20.285),(33.265,20.285),(33.265,20.115),(33.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.115),(33.455,20.285),(33.625,20.285),(33.625,20.115),(33.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.475),(32.375,20.645),(32.545,20.645),(32.545,20.475),(32.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.475),(32.735,20.645),(32.905,20.645),(32.905,20.475),(32.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.475),(33.095,20.645),(33.265,20.645),(33.265,20.475),(33.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.475),(33.455,20.645),(33.625,20.645),(33.625,20.475),(33.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.835),(32.375,21.005),(32.545,21.005),(32.545,20.835),(32.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.835),(32.735,21.005),(32.905,21.005),(32.905,20.835),(32.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.835),(33.095,21.005),(33.265,21.005),(33.265,20.835),(33.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.835),(33.455,21.005),(33.625,21.005),(33.625,20.835),(33.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.195),(32.375,21.365),(32.545,21.365),(32.545,21.195),(32.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.195),(32.735,21.365),(32.905,21.365),(32.905,21.195),(32.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.195),(33.095,21.365),(33.265,21.365),(33.265,21.195),(33.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.195),(33.455,21.365),(33.625,21.365),(33.625,21.195),(33.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.555),(32.375,21.725),(32.545,21.725),(32.545,21.555),(32.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.555),(32.735,21.725),(32.905,21.725),(32.905,21.555),(32.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.555),(33.095,21.725),(33.265,21.725),(33.265,21.555),(33.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.555),(33.455,21.725),(33.625,21.725),(33.625,21.555),(33.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.915),(32.375,22.085),(32.545,22.085),(32.545,21.915),(32.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.915),(32.735,22.085),(32.905,22.085),(32.905,21.915),(32.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.915),(33.095,22.085),(33.265,22.085),(33.265,21.915),(33.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.915),(33.455,22.085),(33.625,22.085),(33.625,21.915),(33.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.275),(32.375,22.445),(32.545,22.445),(32.545,22.275),(32.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.275),(32.735,22.445),(32.905,22.445),(32.905,22.275),(32.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.275),(33.095,22.445),(33.265,22.445),(33.265,22.275),(33.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.275),(33.455,22.445),(33.625,22.445),(33.625,22.275),(33.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.635),(32.375,22.805),(32.545,22.805),(32.545,22.635),(32.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.635),(32.735,22.805),(32.905,22.805),(32.905,22.635),(32.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.635),(33.095,22.805),(33.265,22.805),(33.265,22.635),(33.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.635),(33.455,22.805),(33.625,22.805),(33.625,22.635),(33.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.995),(32.375,23.165),(32.545,23.165),(32.545,22.995),(32.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.995),(32.735,23.165),(32.905,23.165),(32.905,22.995),(32.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.995),(33.095,23.165),(33.265,23.165),(33.265,22.995),(33.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.995),(33.455,23.165),(33.625,23.165),(33.625,22.995),(33.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,23.355),(32.375,23.525),(32.545,23.525),(32.545,23.355),(32.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,23.355),(32.735,23.525),(32.905,23.525),(32.905,23.355),(32.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,23.355),(33.095,23.525),(33.265,23.525),(33.265,23.355),(33.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,23.355),(33.455,23.525),(33.625,23.525),(33.625,23.355),(33.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,23.715),(32.375,23.885),(32.545,23.885),(32.545,23.715),(32.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,23.715),(32.735,23.885),(32.905,23.885),(32.905,23.715),(32.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,23.715),(33.095,23.885),(33.265,23.885),(33.265,23.715),(33.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,23.715),(33.455,23.885),(33.625,23.885),(33.625,23.715),(33.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.075),(32.375,24.245),(32.545,24.245),(32.545,24.075),(32.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.075),(32.735,24.245),(32.905,24.245),(32.905,24.075),(32.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.075),(33.095,24.245),(33.265,24.245),(33.265,24.075),(33.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.075),(33.455,24.245),(33.625,24.245),(33.625,24.075),(33.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.435),(32.375,24.605),(32.545,24.605),(32.545,24.435),(32.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.435),(32.735,24.605),(32.905,24.605),(32.905,24.435),(32.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.435),(33.095,24.605),(33.265,24.605),(33.265,24.435),(33.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.435),(33.455,24.605),(33.625,24.605),(33.625,24.435),(33.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.795),(32.375,24.965),(32.545,24.965),(32.545,24.795),(32.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.795),(32.735,24.965),(32.905,24.965),(32.905,24.795),(32.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.795),(33.095,24.965),(33.265,24.965),(33.265,24.795),(33.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.795),(33.455,24.965),(33.625,24.965),(33.625,24.795),(33.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.155),(32.375,25.325),(32.545,25.325),(32.545,25.155),(32.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.155),(32.735,25.325),(32.905,25.325),(32.905,25.155),(32.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.155),(33.095,25.325),(33.265,25.325),(33.265,25.155),(33.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.155),(33.455,25.325),(33.625,25.325),(33.625,25.155),(33.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.515),(32.375,25.685),(32.545,25.685),(32.545,25.515),(32.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.515),(32.735,25.685),(32.905,25.685),(32.905,25.515),(32.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.515),(33.095,25.685),(33.265,25.685),(33.265,25.515),(33.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.515),(33.455,25.685),(33.625,25.685),(33.625,25.515),(33.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.875),(32.375,26.045),(32.545,26.045),(32.545,25.875),(32.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.875),(32.735,26.045),(32.905,26.045),(32.905,25.875),(32.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.875),(33.095,26.045),(33.265,26.045),(33.265,25.875),(33.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.875),(33.455,26.045),(33.625,26.045),(33.625,25.875),(33.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.235),(32.375,26.405),(32.545,26.405),(32.545,26.235),(32.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.235),(32.735,26.405),(32.905,26.405),(32.905,26.235),(32.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.235),(33.095,26.405),(33.265,26.405),(33.265,26.235),(33.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.235),(33.455,26.405),(33.625,26.405),(33.625,26.235),(33.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.595),(32.375,26.765),(32.545,26.765),(32.545,26.595),(32.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.595),(32.735,26.765),(32.905,26.765),(32.905,26.595),(32.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.595),(33.095,26.765),(33.265,26.765),(33.265,26.595),(33.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.595),(33.455,26.765),(33.625,26.765),(33.625,26.595),(33.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.955),(32.375,27.125),(32.545,27.125),(32.545,26.955),(32.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.955),(32.735,27.125),(32.905,27.125),(32.905,26.955),(32.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.955),(33.095,27.125),(33.265,27.125),(33.265,26.955),(33.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.955),(33.455,27.125),(33.625,27.125),(33.625,26.955),(33.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,27.315),(32.375,27.485),(32.545,27.485),(32.545,27.315),(32.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,27.315),(32.735,27.485),(32.905,27.485),(32.905,27.315),(32.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,27.315),(33.095,27.485),(33.265,27.485),(33.265,27.315),(33.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,27.315),(33.455,27.485),(33.625,27.485),(33.625,27.315),(33.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,27.675),(32.375,27.845),(32.545,27.845),(32.545,27.675),(32.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,27.675),(32.735,27.845),(32.905,27.845),(32.905,27.675),(32.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,27.675),(33.095,27.845),(33.265,27.845),(33.265,27.675),(33.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,27.675),(33.455,27.845),(33.625,27.845),(33.625,27.675),(33.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.035),(32.375,28.205),(32.545,28.205),(32.545,28.035),(32.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.035),(32.735,28.205),(32.905,28.205),(32.905,28.035),(32.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.035),(33.095,28.205),(33.265,28.205),(33.265,28.035),(33.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.035),(33.455,28.205),(33.625,28.205),(33.625,28.035),(33.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.395),(32.375,28.565),(32.545,28.565),(32.545,28.395),(32.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.395),(32.735,28.565),(32.905,28.565),(32.905,28.395),(32.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.395),(33.095,28.565),(33.265,28.565),(33.265,28.395),(33.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.395),(33.455,28.565),(33.625,28.565),(33.625,28.395),(33.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.755),(32.375,28.925),(32.545,28.925),(32.545,28.755),(32.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.755),(32.735,28.925),(32.905,28.925),(32.905,28.755),(32.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.755),(33.095,28.925),(33.265,28.925),(33.265,28.755),(33.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.755),(33.455,28.925),(33.625,28.925),(33.625,28.755),(33.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.115),(32.375,29.285),(32.545,29.285),(32.545,29.115),(32.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.115),(32.735,29.285),(32.905,29.285),(32.905,29.115),(32.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.115),(33.095,29.285),(33.265,29.285),(33.265,29.115),(33.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.115),(33.455,29.285),(33.625,29.285),(33.625,29.115),(33.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.475),(32.375,29.645),(32.545,29.645),(32.545,29.475),(32.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.475),(32.735,29.645),(32.905,29.645),(32.905,29.475),(32.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.475),(33.095,29.645),(33.265,29.645),(33.265,29.475),(33.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.475),(33.455,29.645),(33.625,29.645),(33.625,29.475),(33.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.835),(32.375,30.005),(32.545,30.005),(32.545,29.835),(32.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.835),(32.735,30.005),(32.905,30.005),(32.905,29.835),(32.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.835),(33.095,30.005),(33.265,30.005),(33.265,29.835),(33.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.835),(33.455,30.005),(33.625,30.005),(33.625,29.835),(33.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.195),(32.375,30.365),(32.545,30.365),(32.545,30.195),(32.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.195),(32.735,30.365),(32.905,30.365),(32.905,30.195),(32.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.195),(33.095,30.365),(33.265,30.365),(33.265,30.195),(33.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.195),(33.455,30.365),(33.625,30.365),(33.625,30.195),(33.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.555),(32.375,30.725),(32.545,30.725),(32.545,30.555),(32.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.555),(32.735,30.725),(32.905,30.725),(32.905,30.555),(32.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.555),(33.095,30.725),(33.265,30.725),(33.265,30.555),(33.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.555),(33.455,30.725),(33.625,30.725),(33.625,30.555),(33.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.915),(32.375,31.085),(32.545,31.085),(32.545,30.915),(32.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.915),(32.735,31.085),(32.905,31.085),(32.905,30.915),(32.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.915),(33.095,31.085),(33.265,31.085),(33.265,30.915),(33.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.915),(33.455,31.085),(33.625,31.085),(33.625,30.915),(33.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.275),(32.375,31.445),(32.545,31.445),(32.545,31.275),(32.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.275),(32.735,31.445),(32.905,31.445),(32.905,31.275),(32.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.275),(33.095,31.445),(33.265,31.445),(33.265,31.275),(33.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.275),(33.455,31.445),(33.625,31.445),(33.625,31.275),(33.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.635),(32.375,31.805),(32.545,31.805),(32.545,31.635),(32.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.635),(32.735,31.805),(32.905,31.805),(32.905,31.635),(32.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.635),(33.095,31.805),(33.265,31.805),(33.265,31.635),(33.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.635),(33.455,31.805),(33.625,31.805),(33.625,31.635),(33.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.995),(32.375,32.165),(32.545,32.165),(32.545,31.995),(32.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.995),(32.735,32.165),(32.905,32.165),(32.905,31.995),(32.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.995),(33.095,32.165),(33.265,32.165),(33.265,31.995),(33.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.995),(33.455,32.165),(33.625,32.165),(33.625,31.995),(33.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,32.355),(32.375,32.525),(32.545,32.525),(32.545,32.355),(32.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,32.355),(32.735,32.525),(32.905,32.525),(32.905,32.355),(32.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,32.355),(33.095,32.525),(33.265,32.525),(33.265,32.355),(33.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,32.355),(33.455,32.525),(33.625,32.525),(33.625,32.355),(33.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,32.715),(32.375,32.885),(32.545,32.885),(32.545,32.715),(32.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,32.715),(32.735,32.885),(32.905,32.885),(32.905,32.715),(32.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,32.715),(33.095,32.885),(33.265,32.885),(33.265,32.715),(33.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,32.715),(33.455,32.885),(33.625,32.885),(33.625,32.715),(33.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.075),(32.375,33.245),(32.545,33.245),(32.545,33.075),(32.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.075),(32.735,33.245),(32.905,33.245),(32.905,33.075),(32.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.075),(33.095,33.245),(33.265,33.245),(33.265,33.075),(33.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.075),(33.455,33.245),(33.625,33.245),(33.625,33.075),(33.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.435),(32.375,33.605),(32.545,33.605),(32.545,33.435),(32.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.435),(32.735,33.605),(32.905,33.605),(32.905,33.435),(32.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.435),(33.095,33.605),(33.265,33.605),(33.265,33.435),(33.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.435),(33.455,33.605),(33.625,33.605),(33.625,33.435),(33.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.795),(32.375,33.965),(32.545,33.965),(32.545,33.795),(32.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.795),(32.735,33.965),(32.905,33.965),(32.905,33.795),(32.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.795),(33.095,33.965),(33.265,33.965),(33.265,33.795),(33.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.795),(33.455,33.965),(33.625,33.965),(33.625,33.795),(33.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.155),(32.375,34.325),(32.545,34.325),(32.545,34.155),(32.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.155),(32.735,34.325),(32.905,34.325),(32.905,34.155),(32.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.155),(33.095,34.325),(33.265,34.325),(33.265,34.155),(33.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.155),(33.455,34.325),(33.625,34.325),(33.625,34.155),(33.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.515),(32.375,34.685),(32.545,34.685),(32.545,34.515),(32.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.515),(32.735,34.685),(32.905,34.685),(32.905,34.515),(32.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.515),(33.095,34.685),(33.265,34.685),(33.265,34.515),(33.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.515),(33.455,34.685),(33.625,34.685),(33.625,34.515),(33.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.875),(32.375,35.045),(32.545,35.045),(32.545,34.875),(32.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.875),(32.735,35.045),(32.905,35.045),(32.905,34.875),(32.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.875),(33.095,35.045),(33.265,35.045),(33.265,34.875),(33.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.875),(33.455,35.045),(33.625,35.045),(33.625,34.875),(33.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.235),(32.375,35.405),(32.545,35.405),(32.545,35.235),(32.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.235),(32.735,35.405),(32.905,35.405),(32.905,35.235),(32.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.235),(33.095,35.405),(33.265,35.405),(33.265,35.235),(33.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.235),(33.455,35.405),(33.625,35.405),(33.625,35.235),(33.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.595),(32.375,35.765),(32.545,35.765),(32.545,35.595),(32.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.595),(32.735,35.765),(32.905,35.765),(32.905,35.595),(32.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.595),(33.095,35.765),(33.265,35.765),(33.265,35.595),(33.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.595),(33.455,35.765),(33.625,35.765),(33.625,35.595),(33.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.955),(32.375,36.125),(32.545,36.125),(32.545,35.955),(32.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.955),(32.735,36.125),(32.905,36.125),(32.905,35.955),(32.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.955),(33.095,36.125),(33.265,36.125),(33.265,35.955),(33.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.955),(33.455,36.125),(33.625,36.125),(33.625,35.955),(33.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,36.315),(32.375,36.485),(32.545,36.485),(32.545,36.315),(32.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,36.315),(32.735,36.485),(32.905,36.485),(32.905,36.315),(32.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,36.315),(33.095,36.485),(33.265,36.485),(33.265,36.315),(33.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,36.315),(33.455,36.485),(33.625,36.485),(33.625,36.315),(33.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,36.675),(32.375,36.845),(32.545,36.845),(32.545,36.675),(32.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,36.675),(32.735,36.845),(32.905,36.845),(32.905,36.675),(32.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,36.675),(33.095,36.845),(33.265,36.845),(33.265,36.675),(33.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,36.675),(33.455,36.845),(33.625,36.845),(33.625,36.675),(33.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.035),(32.375,37.205),(32.545,37.205),(32.545,37.035),(32.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.035),(32.735,37.205),(32.905,37.205),(32.905,37.035),(32.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.035),(33.095,37.205),(33.265,37.205),(33.265,37.035),(33.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.035),(33.455,37.205),(33.625,37.205),(33.625,37.035),(33.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.395),(32.375,37.565),(32.545,37.565),(32.545,37.395),(32.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.395),(32.735,37.565),(32.905,37.565),(32.905,37.395),(32.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.395),(33.095,37.565),(33.265,37.565),(33.265,37.395),(33.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.395),(33.455,37.565),(33.625,37.565),(33.625,37.395),(33.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.755),(32.375,37.925),(32.545,37.925),(32.545,37.755),(32.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.755),(32.735,37.925),(32.905,37.925),(32.905,37.755),(32.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.755),(33.095,37.925),(33.265,37.925),(33.265,37.755),(33.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.755),(33.455,37.925),(33.625,37.925),(33.625,37.755),(33.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.115),(32.375,38.285),(32.545,38.285),(32.545,38.115),(32.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.115),(32.735,38.285),(32.905,38.285),(32.905,38.115),(32.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.115),(33.095,38.285),(33.265,38.285),(33.265,38.115),(33.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.115),(33.455,38.285),(33.625,38.285),(33.625,38.115),(33.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.475),(32.375,38.645),(32.545,38.645),(32.545,38.475),(32.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.475),(32.735,38.645),(32.905,38.645),(32.905,38.475),(32.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.475),(33.095,38.645),(33.265,38.645),(33.265,38.475),(33.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.475),(33.455,38.645),(33.625,38.645),(33.625,38.475),(33.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.835),(32.375,39.005),(32.545,39.005),(32.545,38.835),(32.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.835),(32.735,39.005),(32.905,39.005),(32.905,38.835),(32.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.835),(33.095,39.005),(33.265,39.005),(33.265,38.835),(33.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.835),(33.455,39.005),(33.625,39.005),(33.625,38.835),(33.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.195),(32.375,39.365),(32.545,39.365),(32.545,39.195),(32.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.195),(32.735,39.365),(32.905,39.365),(32.905,39.195),(32.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.195),(33.095,39.365),(33.265,39.365),(33.265,39.195),(33.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.195),(33.455,39.365),(33.625,39.365),(33.625,39.195),(33.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.555),(32.375,39.725),(32.545,39.725),(32.545,39.555),(32.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.555),(32.735,39.725),(32.905,39.725),(32.905,39.555),(32.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.555),(33.095,39.725),(33.265,39.725),(33.265,39.555),(33.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.555),(33.455,39.725),(33.625,39.725),(33.625,39.555),(33.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.915),(32.375,40.085),(32.545,40.085),(32.545,39.915),(32.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.915),(32.735,40.085),(32.905,40.085),(32.905,39.915),(32.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.915),(33.095,40.085),(33.265,40.085),(33.265,39.915),(33.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.915),(33.455,40.085),(33.625,40.085),(33.625,39.915),(33.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,40.275),(32.375,40.445),(32.545,40.445),(32.545,40.275),(32.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,40.275),(32.735,40.445),(32.905,40.445),(32.905,40.275),(32.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,40.275),(33.095,40.445),(33.265,40.445),(33.265,40.275),(33.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,40.275),(33.455,40.445),(33.625,40.445),(33.625,40.275),(33.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,40.635),(32.375,40.805),(32.545,40.805),(32.545,40.635),(32.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,40.635),(32.735,40.805),(32.905,40.805),(32.905,40.635),(32.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,40.635),(33.095,40.805),(33.265,40.805),(33.265,40.635),(33.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,40.635),(33.455,40.805),(33.625,40.805),(33.625,40.635),(33.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,2.835),(13.175,3.005),(13.345,3.005),(13.345,2.835),(13.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,2.835),(13.535,3.005),(13.705,3.005),(13.705,2.835),(13.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,2.835),(13.895,3.005),(14.065,3.005),(14.065,2.835),(13.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,2.835),(14.255,3.005),(14.425,3.005),(14.425,2.835),(14.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.195),(13.175,3.365),(13.345,3.365),(13.345,3.195),(13.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.195),(13.535,3.365),(13.705,3.365),(13.705,3.195),(13.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.195),(13.895,3.365),(14.065,3.365),(14.065,3.195),(13.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.195),(14.255,3.365),(14.425,3.365),(14.425,3.195),(14.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.555),(13.175,3.725),(13.345,3.725),(13.345,3.555),(13.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.555),(13.535,3.725),(13.705,3.725),(13.705,3.555),(13.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.555),(13.895,3.725),(14.065,3.725),(14.065,3.555),(13.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.555),(14.255,3.725),(14.425,3.725),(14.425,3.555),(14.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.915),(13.175,4.085),(13.345,4.085),(13.345,3.915),(13.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.915),(13.535,4.085),(13.705,4.085),(13.705,3.915),(13.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.915),(13.895,4.085),(14.065,4.085),(14.065,3.915),(13.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.915),(14.255,4.085),(14.425,4.085),(14.425,3.915),(14.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.275),(13.175,4.445),(13.345,4.445),(13.345,4.275),(13.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.275),(13.535,4.445),(13.705,4.445),(13.705,4.275),(13.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.275),(13.895,4.445),(14.065,4.445),(14.065,4.275),(13.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.275),(14.255,4.445),(14.425,4.445),(14.425,4.275),(14.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.635),(13.175,4.805),(13.345,4.805),(13.345,4.635),(13.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.635),(13.535,4.805),(13.705,4.805),(13.705,4.635),(13.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.635),(13.895,4.805),(14.065,4.805),(14.065,4.635),(13.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.635),(14.255,4.805),(14.425,4.805),(14.425,4.635),(14.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.995),(13.175,5.165),(13.345,5.165),(13.345,4.995),(13.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.995),(13.535,5.165),(13.705,5.165),(13.705,4.995),(13.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.995),(13.895,5.165),(14.065,5.165),(14.065,4.995),(13.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.995),(14.255,5.165),(14.425,5.165),(14.425,4.995),(14.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.355),(13.175,5.525),(13.345,5.525),(13.345,5.355),(13.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.355),(13.535,5.525),(13.705,5.525),(13.705,5.355),(13.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.355),(13.895,5.525),(14.065,5.525),(14.065,5.355),(13.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.355),(14.255,5.525),(14.425,5.525),(14.425,5.355),(14.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.715),(13.175,5.885),(13.345,5.885),(13.345,5.715),(13.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.715),(13.535,5.885),(13.705,5.885),(13.705,5.715),(13.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.715),(13.895,5.885),(14.065,5.885),(14.065,5.715),(13.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.715),(14.255,5.885),(14.425,5.885),(14.425,5.715),(14.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.075),(13.175,6.245),(13.345,6.245),(13.345,6.075),(13.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.075),(13.535,6.245),(13.705,6.245),(13.705,6.075),(13.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.075),(13.895,6.245),(14.065,6.245),(14.065,6.075),(13.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.075),(14.255,6.245),(14.425,6.245),(14.425,6.075),(14.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.435),(13.175,6.605),(13.345,6.605),(13.345,6.435),(13.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.435),(13.535,6.605),(13.705,6.605),(13.705,6.435),(13.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.435),(13.895,6.605),(14.065,6.605),(14.065,6.435),(13.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.435),(14.255,6.605),(14.425,6.605),(14.425,6.435),(14.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.795),(13.175,6.965),(13.345,6.965),(13.345,6.795),(13.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.795),(13.535,6.965),(13.705,6.965),(13.705,6.795),(13.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.795),(13.895,6.965),(14.065,6.965),(14.065,6.795),(13.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.795),(14.255,6.965),(14.425,6.965),(14.425,6.795),(14.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.155),(13.175,7.325),(13.345,7.325),(13.345,7.155),(13.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.155),(13.535,7.325),(13.705,7.325),(13.705,7.155),(13.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.155),(13.895,7.325),(14.065,7.325),(14.065,7.155),(13.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.155),(14.255,7.325),(14.425,7.325),(14.425,7.155),(14.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.515),(13.175,7.685),(13.345,7.685),(13.345,7.515),(13.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.515),(13.535,7.685),(13.705,7.685),(13.705,7.515),(13.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.515),(13.895,7.685),(14.065,7.685),(14.065,7.515),(13.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.515),(14.255,7.685),(14.425,7.685),(14.425,7.515),(14.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.875),(13.175,8.045),(13.345,8.045),(13.345,7.875),(13.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.875),(13.535,8.045),(13.705,8.045),(13.705,7.875),(13.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.875),(13.895,8.045),(14.065,8.045),(14.065,7.875),(13.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.875),(14.255,8.045),(14.425,8.045),(14.425,7.875),(14.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.235),(13.175,8.405),(13.345,8.405),(13.345,8.235),(13.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.235),(13.535,8.405),(13.705,8.405),(13.705,8.235),(13.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.235),(13.895,8.405),(14.065,8.405),(14.065,8.235),(13.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.235),(14.255,8.405),(14.425,8.405),(14.425,8.235),(14.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.595),(13.175,8.765),(13.345,8.765),(13.345,8.595),(13.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.595),(13.535,8.765),(13.705,8.765),(13.705,8.595),(13.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.595),(13.895,8.765),(14.065,8.765),(14.065,8.595),(13.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.595),(14.255,8.765),(14.425,8.765),(14.425,8.595),(14.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.955),(13.175,9.125),(13.345,9.125),(13.345,8.955),(13.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.955),(13.535,9.125),(13.705,9.125),(13.705,8.955),(13.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.955),(13.895,9.125),(14.065,9.125),(14.065,8.955),(13.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.955),(14.255,9.125),(14.425,9.125),(14.425,8.955),(14.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.315),(13.175,9.485),(13.345,9.485),(13.345,9.315),(13.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.315),(13.535,9.485),(13.705,9.485),(13.705,9.315),(13.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.315),(13.895,9.485),(14.065,9.485),(14.065,9.315),(13.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.315),(14.255,9.485),(14.425,9.485),(14.425,9.315),(14.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.675),(13.175,9.845),(13.345,9.845),(13.345,9.675),(13.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.675),(13.535,9.845),(13.705,9.845),(13.705,9.675),(13.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.675),(13.895,9.845),(14.065,9.845),(14.065,9.675),(13.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.675),(14.255,9.845),(14.425,9.845),(14.425,9.675),(14.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.035),(13.175,10.205),(13.345,10.205),(13.345,10.035),(13.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.035),(13.535,10.205),(13.705,10.205),(13.705,10.035),(13.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.035),(13.895,10.205),(14.065,10.205),(14.065,10.035),(13.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.035),(14.255,10.205),(14.425,10.205),(14.425,10.035),(14.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.395),(13.175,10.565),(13.345,10.565),(13.345,10.395),(13.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.395),(13.535,10.565),(13.705,10.565),(13.705,10.395),(13.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.395),(13.895,10.565),(14.065,10.565),(14.065,10.395),(13.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.395),(14.255,10.565),(14.425,10.565),(14.425,10.395),(14.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.755),(13.175,10.925),(13.345,10.925),(13.345,10.755),(13.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.755),(13.535,10.925),(13.705,10.925),(13.705,10.755),(13.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.755),(13.895,10.925),(14.065,10.925),(14.065,10.755),(13.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.755),(14.255,10.925),(14.425,10.925),(14.425,10.755),(14.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.115),(13.175,11.285),(13.345,11.285),(13.345,11.115),(13.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.115),(13.535,11.285),(13.705,11.285),(13.705,11.115),(13.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.115),(13.895,11.285),(14.065,11.285),(14.065,11.115),(13.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.115),(14.255,11.285),(14.425,11.285),(14.425,11.115),(14.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.475),(13.175,11.645),(13.345,11.645),(13.345,11.475),(13.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.475),(13.535,11.645),(13.705,11.645),(13.705,11.475),(13.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.475),(13.895,11.645),(14.065,11.645),(14.065,11.475),(13.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.475),(14.255,11.645),(14.425,11.645),(14.425,11.475),(14.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.835),(13.175,12.005),(13.345,12.005),(13.345,11.835),(13.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.835),(13.535,12.005),(13.705,12.005),(13.705,11.835),(13.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.835),(13.895,12.005),(14.065,12.005),(14.065,11.835),(13.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.835),(14.255,12.005),(14.425,12.005),(14.425,11.835),(14.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.195),(13.175,12.365),(13.345,12.365),(13.345,12.195),(13.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.195),(13.535,12.365),(13.705,12.365),(13.705,12.195),(13.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.195),(13.895,12.365),(14.065,12.365),(14.065,12.195),(13.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.195),(14.255,12.365),(14.425,12.365),(14.425,12.195),(14.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.555),(13.175,12.725),(13.345,12.725),(13.345,12.555),(13.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.555),(13.535,12.725),(13.705,12.725),(13.705,12.555),(13.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.555),(13.895,12.725),(14.065,12.725),(14.065,12.555),(13.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.555),(14.255,12.725),(14.425,12.725),(14.425,12.555),(14.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.915),(13.175,13.085),(13.345,13.085),(13.345,12.915),(13.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.915),(13.535,13.085),(13.705,13.085),(13.705,12.915),(13.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.915),(13.895,13.085),(14.065,13.085),(14.065,12.915),(13.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.915),(14.255,13.085),(14.425,13.085),(14.425,12.915),(14.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.275),(13.175,13.445),(13.345,13.445),(13.345,13.275),(13.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.275),(13.535,13.445),(13.705,13.445),(13.705,13.275),(13.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.275),(13.895,13.445),(14.065,13.445),(14.065,13.275),(13.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.275),(14.255,13.445),(14.425,13.445),(14.425,13.275),(14.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.635),(13.175,13.805),(13.345,13.805),(13.345,13.635),(13.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.635),(13.535,13.805),(13.705,13.805),(13.705,13.635),(13.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.635),(13.895,13.805),(14.065,13.805),(14.065,13.635),(13.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.635),(14.255,13.805),(14.425,13.805),(14.425,13.635),(14.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.995),(13.175,14.165),(13.345,14.165),(13.345,13.995),(13.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.995),(13.535,14.165),(13.705,14.165),(13.705,13.995),(13.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.995),(13.895,14.165),(14.065,14.165),(14.065,13.995),(13.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.995),(14.255,14.165),(14.425,14.165),(14.425,13.995),(14.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.355),(13.175,14.525),(13.345,14.525),(13.345,14.355),(13.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.355),(13.535,14.525),(13.705,14.525),(13.705,14.355),(13.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.355),(13.895,14.525),(14.065,14.525),(14.065,14.355),(13.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.355),(14.255,14.525),(14.425,14.525),(14.425,14.355),(14.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.715),(13.175,14.885),(13.345,14.885),(13.345,14.715),(13.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.715),(13.535,14.885),(13.705,14.885),(13.705,14.715),(13.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.715),(13.895,14.885),(14.065,14.885),(14.065,14.715),(13.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.715),(14.255,14.885),(14.425,14.885),(14.425,14.715),(14.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.075),(13.175,15.245),(13.345,15.245),(13.345,15.075),(13.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.075),(13.535,15.245),(13.705,15.245),(13.705,15.075),(13.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.075),(13.895,15.245),(14.065,15.245),(14.065,15.075),(13.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.075),(14.255,15.245),(14.425,15.245),(14.425,15.075),(14.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.435),(13.175,15.605),(13.345,15.605),(13.345,15.435),(13.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.435),(13.535,15.605),(13.705,15.605),(13.705,15.435),(13.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.435),(13.895,15.605),(14.065,15.605),(14.065,15.435),(13.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.435),(14.255,15.605),(14.425,15.605),(14.425,15.435),(14.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.795),(13.175,15.965),(13.345,15.965),(13.345,15.795),(13.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.795),(13.535,15.965),(13.705,15.965),(13.705,15.795),(13.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.795),(13.895,15.965),(14.065,15.965),(14.065,15.795),(13.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.795),(14.255,15.965),(14.425,15.965),(14.425,15.795),(14.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.155),(13.175,16.325),(13.345,16.325),(13.345,16.155),(13.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.155),(13.535,16.325),(13.705,16.325),(13.705,16.155),(13.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.155),(13.895,16.325),(14.065,16.325),(14.065,16.155),(13.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.155),(14.255,16.325),(14.425,16.325),(14.425,16.155),(14.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.515),(13.175,16.685),(13.345,16.685),(13.345,16.515),(13.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.515),(13.535,16.685),(13.705,16.685),(13.705,16.515),(13.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.515),(13.895,16.685),(14.065,16.685),(14.065,16.515),(13.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.515),(14.255,16.685),(14.425,16.685),(14.425,16.515),(14.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.875),(13.175,17.045),(13.345,17.045),(13.345,16.875),(13.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.875),(13.535,17.045),(13.705,17.045),(13.705,16.875),(13.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.875),(13.895,17.045),(14.065,17.045),(14.065,16.875),(13.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.875),(14.255,17.045),(14.425,17.045),(14.425,16.875),(14.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.235),(13.175,17.405),(13.345,17.405),(13.345,17.235),(13.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.235),(13.535,17.405),(13.705,17.405),(13.705,17.235),(13.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.235),(13.895,17.405),(14.065,17.405),(14.065,17.235),(13.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.235),(14.255,17.405),(14.425,17.405),(14.425,17.235),(14.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.595),(13.175,17.765),(13.345,17.765),(13.345,17.595),(13.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.595),(13.535,17.765),(13.705,17.765),(13.705,17.595),(13.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.595),(13.895,17.765),(14.065,17.765),(14.065,17.595),(13.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.595),(14.255,17.765),(14.425,17.765),(14.425,17.595),(14.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.955),(13.175,18.125),(13.345,18.125),(13.345,17.955),(13.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.955),(13.535,18.125),(13.705,18.125),(13.705,17.955),(13.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.955),(13.895,18.125),(14.065,18.125),(14.065,17.955),(13.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.955),(14.255,18.125),(14.425,18.125),(14.425,17.955),(14.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.315),(13.175,18.485),(13.345,18.485),(13.345,18.315),(13.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.315),(13.535,18.485),(13.705,18.485),(13.705,18.315),(13.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.315),(13.895,18.485),(14.065,18.485),(14.065,18.315),(13.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.315),(14.255,18.485),(14.425,18.485),(14.425,18.315),(14.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.675),(13.175,18.845),(13.345,18.845),(13.345,18.675),(13.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.675),(13.535,18.845),(13.705,18.845),(13.705,18.675),(13.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.675),(13.895,18.845),(14.065,18.845),(14.065,18.675),(13.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.675),(14.255,18.845),(14.425,18.845),(14.425,18.675),(14.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.035),(13.175,19.205),(13.345,19.205),(13.345,19.035),(13.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.035),(13.535,19.205),(13.705,19.205),(13.705,19.035),(13.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.035),(13.895,19.205),(14.065,19.205),(14.065,19.035),(13.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.035),(14.255,19.205),(14.425,19.205),(14.425,19.035),(14.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.395),(13.175,19.565),(13.345,19.565),(13.345,19.395),(13.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.395),(13.535,19.565),(13.705,19.565),(13.705,19.395),(13.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.395),(13.895,19.565),(14.065,19.565),(14.065,19.395),(13.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.395),(14.255,19.565),(14.425,19.565),(14.425,19.395),(14.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.755),(13.175,19.925),(13.345,19.925),(13.345,19.755),(13.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.755),(13.535,19.925),(13.705,19.925),(13.705,19.755),(13.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.755),(13.895,19.925),(14.065,19.925),(14.065,19.755),(13.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.755),(14.255,19.925),(14.425,19.925),(14.425,19.755),(14.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,20.115),(13.175,20.285),(13.345,20.285),(13.345,20.115),(13.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,20.115),(13.535,20.285),(13.705,20.285),(13.705,20.115),(13.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,20.115),(13.895,20.285),(14.065,20.285),(14.065,20.115),(13.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,20.115),(14.255,20.285),(14.425,20.285),(14.425,20.115),(14.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,20.475),(13.175,20.645),(13.345,20.645),(13.345,20.475),(13.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,20.475),(13.535,20.645),(13.705,20.645),(13.705,20.475),(13.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,20.475),(13.895,20.645),(14.065,20.645),(14.065,20.475),(13.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,20.475),(14.255,20.645),(14.425,20.645),(14.425,20.475),(14.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,20.835),(13.175,21.005),(13.345,21.005),(13.345,20.835),(13.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,20.835),(13.535,21.005),(13.705,21.005),(13.705,20.835),(13.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,20.835),(13.895,21.005),(14.065,21.005),(14.065,20.835),(13.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,20.835),(14.255,21.005),(14.425,21.005),(14.425,20.835),(14.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,21.195),(13.175,21.365),(13.345,21.365),(13.345,21.195),(13.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,21.195),(13.535,21.365),(13.705,21.365),(13.705,21.195),(13.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,21.195),(13.895,21.365),(14.065,21.365),(14.065,21.195),(13.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,21.195),(14.255,21.365),(14.425,21.365),(14.425,21.195),(14.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,21.555),(13.175,21.725),(13.345,21.725),(13.345,21.555),(13.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,21.555),(13.535,21.725),(13.705,21.725),(13.705,21.555),(13.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,21.555),(13.895,21.725),(14.065,21.725),(14.065,21.555),(13.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,21.555),(14.255,21.725),(14.425,21.725),(14.425,21.555),(14.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,21.915),(13.175,22.085),(13.345,22.085),(13.345,21.915),(13.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,21.915),(13.535,22.085),(13.705,22.085),(13.705,21.915),(13.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,21.915),(13.895,22.085),(14.065,22.085),(14.065,21.915),(13.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,21.915),(14.255,22.085),(14.425,22.085),(14.425,21.915),(14.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.275),(13.175,22.445),(13.345,22.445),(13.345,22.275),(13.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.275),(13.535,22.445),(13.705,22.445),(13.705,22.275),(13.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.275),(13.895,22.445),(14.065,22.445),(14.065,22.275),(13.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.275),(14.255,22.445),(14.425,22.445),(14.425,22.275),(14.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.635),(13.175,22.805),(13.345,22.805),(13.345,22.635),(13.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.635),(13.535,22.805),(13.705,22.805),(13.705,22.635),(13.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.635),(13.895,22.805),(14.065,22.805),(14.065,22.635),(13.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.635),(14.255,22.805),(14.425,22.805),(14.425,22.635),(14.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.995),(13.175,23.165),(13.345,23.165),(13.345,22.995),(13.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.995),(13.535,23.165),(13.705,23.165),(13.705,22.995),(13.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.995),(13.895,23.165),(14.065,23.165),(14.065,22.995),(13.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.995),(14.255,23.165),(14.425,23.165),(14.425,22.995),(14.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,23.355),(13.175,23.525),(13.345,23.525),(13.345,23.355),(13.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,23.355),(13.535,23.525),(13.705,23.525),(13.705,23.355),(13.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,23.355),(13.895,23.525),(14.065,23.525),(14.065,23.355),(13.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,23.355),(14.255,23.525),(14.425,23.525),(14.425,23.355),(14.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,23.715),(13.175,23.885),(13.345,23.885),(13.345,23.715),(13.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,23.715),(13.535,23.885),(13.705,23.885),(13.705,23.715),(13.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,23.715),(13.895,23.885),(14.065,23.885),(14.065,23.715),(13.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,23.715),(14.255,23.885),(14.425,23.885),(14.425,23.715),(14.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,24.075),(13.175,24.245),(13.345,24.245),(13.345,24.075),(13.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,24.075),(13.535,24.245),(13.705,24.245),(13.705,24.075),(13.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,24.075),(13.895,24.245),(14.065,24.245),(14.065,24.075),(13.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,24.075),(14.255,24.245),(14.425,24.245),(14.425,24.075),(14.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,24.435),(13.175,24.605),(13.345,24.605),(13.345,24.435),(13.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,24.435),(13.535,24.605),(13.705,24.605),(13.705,24.435),(13.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,24.435),(13.895,24.605),(14.065,24.605),(14.065,24.435),(13.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,24.435),(14.255,24.605),(14.425,24.605),(14.425,24.435),(14.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,24.795),(13.175,24.965),(13.345,24.965),(13.345,24.795),(13.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,24.795),(13.535,24.965),(13.705,24.965),(13.705,24.795),(13.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,24.795),(13.895,24.965),(14.065,24.965),(14.065,24.795),(13.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,24.795),(14.255,24.965),(14.425,24.965),(14.425,24.795),(14.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,25.155),(13.175,25.325),(13.345,25.325),(13.345,25.155),(13.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,25.155),(13.535,25.325),(13.705,25.325),(13.705,25.155),(13.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,25.155),(13.895,25.325),(14.065,25.325),(14.065,25.155),(13.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,25.155),(14.255,25.325),(14.425,25.325),(14.425,25.155),(14.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,25.515),(13.175,25.685),(13.345,25.685),(13.345,25.515),(13.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,25.515),(13.535,25.685),(13.705,25.685),(13.705,25.515),(13.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,25.515),(13.895,25.685),(14.065,25.685),(14.065,25.515),(13.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,25.515),(14.255,25.685),(14.425,25.685),(14.425,25.515),(14.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,25.875),(13.175,26.045),(13.345,26.045),(13.345,25.875),(13.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,25.875),(13.535,26.045),(13.705,26.045),(13.705,25.875),(13.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,25.875),(13.895,26.045),(14.065,26.045),(14.065,25.875),(13.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,25.875),(14.255,26.045),(14.425,26.045),(14.425,25.875),(14.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,26.235),(13.175,26.405),(13.345,26.405),(13.345,26.235),(13.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,26.235),(13.535,26.405),(13.705,26.405),(13.705,26.235),(13.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,26.235),(13.895,26.405),(14.065,26.405),(14.065,26.235),(13.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,26.235),(14.255,26.405),(14.425,26.405),(14.425,26.235),(14.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,26.595),(13.175,26.765),(13.345,26.765),(13.345,26.595),(13.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,26.595),(13.535,26.765),(13.705,26.765),(13.705,26.595),(13.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,26.595),(13.895,26.765),(14.065,26.765),(14.065,26.595),(13.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,26.595),(14.255,26.765),(14.425,26.765),(14.425,26.595),(14.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,26.955),(13.175,27.125),(13.345,27.125),(13.345,26.955),(13.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,26.955),(13.535,27.125),(13.705,27.125),(13.705,26.955),(13.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,26.955),(13.895,27.125),(14.065,27.125),(14.065,26.955),(13.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,26.955),(14.255,27.125),(14.425,27.125),(14.425,26.955),(14.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,27.315),(13.175,27.485),(13.345,27.485),(13.345,27.315),(13.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,27.315),(13.535,27.485),(13.705,27.485),(13.705,27.315),(13.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,27.315),(13.895,27.485),(14.065,27.485),(14.065,27.315),(13.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,27.315),(14.255,27.485),(14.425,27.485),(14.425,27.315),(14.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,27.675),(13.175,27.845),(13.345,27.845),(13.345,27.675),(13.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,27.675),(13.535,27.845),(13.705,27.845),(13.705,27.675),(13.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,27.675),(13.895,27.845),(14.065,27.845),(14.065,27.675),(13.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,27.675),(14.255,27.845),(14.425,27.845),(14.425,27.675),(14.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,28.035),(13.175,28.205),(13.345,28.205),(13.345,28.035),(13.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,28.035),(13.535,28.205),(13.705,28.205),(13.705,28.035),(13.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,28.035),(13.895,28.205),(14.065,28.205),(14.065,28.035),(13.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,28.035),(14.255,28.205),(14.425,28.205),(14.425,28.035),(14.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,28.395),(13.175,28.565),(13.345,28.565),(13.345,28.395),(13.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,28.395),(13.535,28.565),(13.705,28.565),(13.705,28.395),(13.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,28.395),(13.895,28.565),(14.065,28.565),(14.065,28.395),(13.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,28.395),(14.255,28.565),(14.425,28.565),(14.425,28.395),(14.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,28.755),(13.175,28.925),(13.345,28.925),(13.345,28.755),(13.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,28.755),(13.535,28.925),(13.705,28.925),(13.705,28.755),(13.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,28.755),(13.895,28.925),(14.065,28.925),(14.065,28.755),(13.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,28.755),(14.255,28.925),(14.425,28.925),(14.425,28.755),(14.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,29.115),(13.175,29.285),(13.345,29.285),(13.345,29.115),(13.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,29.115),(13.535,29.285),(13.705,29.285),(13.705,29.115),(13.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,29.115),(13.895,29.285),(14.065,29.285),(14.065,29.115),(13.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,29.115),(14.255,29.285),(14.425,29.285),(14.425,29.115),(14.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,29.475),(13.175,29.645),(13.345,29.645),(13.345,29.475),(13.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,29.475),(13.535,29.645),(13.705,29.645),(13.705,29.475),(13.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,29.475),(13.895,29.645),(14.065,29.645),(14.065,29.475),(13.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,29.475),(14.255,29.645),(14.425,29.645),(14.425,29.475),(14.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,29.835),(13.175,30.005),(13.345,30.005),(13.345,29.835),(13.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,29.835),(13.535,30.005),(13.705,30.005),(13.705,29.835),(13.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,29.835),(13.895,30.005),(14.065,30.005),(14.065,29.835),(13.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,29.835),(14.255,30.005),(14.425,30.005),(14.425,29.835),(14.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,30.195),(13.175,30.365),(13.345,30.365),(13.345,30.195),(13.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,30.195),(13.535,30.365),(13.705,30.365),(13.705,30.195),(13.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,30.195),(13.895,30.365),(14.065,30.365),(14.065,30.195),(13.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,30.195),(14.255,30.365),(14.425,30.365),(14.425,30.195),(14.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,30.555),(13.175,30.725),(13.345,30.725),(13.345,30.555),(13.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,30.555),(13.535,30.725),(13.705,30.725),(13.705,30.555),(13.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,30.555),(13.895,30.725),(14.065,30.725),(14.065,30.555),(13.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,30.555),(14.255,30.725),(14.425,30.725),(14.425,30.555),(14.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,30.915),(13.175,31.085),(13.345,31.085),(13.345,30.915),(13.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,30.915),(13.535,31.085),(13.705,31.085),(13.705,30.915),(13.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,30.915),(13.895,31.085),(14.065,31.085),(14.065,30.915),(13.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,30.915),(14.255,31.085),(14.425,31.085),(14.425,30.915),(14.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,31.275),(13.175,31.445),(13.345,31.445),(13.345,31.275),(13.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,31.275),(13.535,31.445),(13.705,31.445),(13.705,31.275),(13.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,31.275),(13.895,31.445),(14.065,31.445),(14.065,31.275),(13.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,31.275),(14.255,31.445),(14.425,31.445),(14.425,31.275),(14.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,31.635),(13.175,31.805),(13.345,31.805),(13.345,31.635),(13.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,31.635),(13.535,31.805),(13.705,31.805),(13.705,31.635),(13.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,31.635),(13.895,31.805),(14.065,31.805),(14.065,31.635),(13.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,31.635),(14.255,31.805),(14.425,31.805),(14.425,31.635),(14.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,31.995),(13.175,32.165),(13.345,32.165),(13.345,31.995),(13.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,31.995),(13.535,32.165),(13.705,32.165),(13.705,31.995),(13.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,31.995),(13.895,32.165),(14.065,32.165),(14.065,31.995),(13.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,31.995),(14.255,32.165),(14.425,32.165),(14.425,31.995),(14.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,32.355),(13.175,32.525),(13.345,32.525),(13.345,32.355),(13.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,32.355),(13.535,32.525),(13.705,32.525),(13.705,32.355),(13.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,32.355),(13.895,32.525),(14.065,32.525),(14.065,32.355),(13.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,32.355),(14.255,32.525),(14.425,32.525),(14.425,32.355),(14.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,32.715),(13.175,32.885),(13.345,32.885),(13.345,32.715),(13.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,32.715),(13.535,32.885),(13.705,32.885),(13.705,32.715),(13.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,32.715),(13.895,32.885),(14.065,32.885),(14.065,32.715),(13.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,32.715),(14.255,32.885),(14.425,32.885),(14.425,32.715),(14.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,33.075),(13.175,33.245),(13.345,33.245),(13.345,33.075),(13.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,33.075),(13.535,33.245),(13.705,33.245),(13.705,33.075),(13.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,33.075),(13.895,33.245),(14.065,33.245),(14.065,33.075),(13.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,33.075),(14.255,33.245),(14.425,33.245),(14.425,33.075),(14.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,33.435),(13.175,33.605),(13.345,33.605),(13.345,33.435),(13.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,33.435),(13.535,33.605),(13.705,33.605),(13.705,33.435),(13.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,33.435),(13.895,33.605),(14.065,33.605),(14.065,33.435),(13.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,33.435),(14.255,33.605),(14.425,33.605),(14.425,33.435),(14.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,33.795),(13.175,33.965),(13.345,33.965),(13.345,33.795),(13.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,33.795),(13.535,33.965),(13.705,33.965),(13.705,33.795),(13.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,33.795),(13.895,33.965),(14.065,33.965),(14.065,33.795),(13.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,33.795),(14.255,33.965),(14.425,33.965),(14.425,33.795),(14.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,34.155),(13.175,34.325),(13.345,34.325),(13.345,34.155),(13.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,34.155),(13.535,34.325),(13.705,34.325),(13.705,34.155),(13.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,34.155),(13.895,34.325),(14.065,34.325),(14.065,34.155),(13.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,34.155),(14.255,34.325),(14.425,34.325),(14.425,34.155),(14.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,34.515),(13.175,34.685),(13.345,34.685),(13.345,34.515),(13.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,34.515),(13.535,34.685),(13.705,34.685),(13.705,34.515),(13.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,34.515),(13.895,34.685),(14.065,34.685),(14.065,34.515),(13.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,34.515),(14.255,34.685),(14.425,34.685),(14.425,34.515),(14.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,34.875),(13.175,35.045),(13.345,35.045),(13.345,34.875),(13.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,34.875),(13.535,35.045),(13.705,35.045),(13.705,34.875),(13.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,34.875),(13.895,35.045),(14.065,35.045),(14.065,34.875),(13.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,34.875),(14.255,35.045),(14.425,35.045),(14.425,34.875),(14.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,35.235),(13.175,35.405),(13.345,35.405),(13.345,35.235),(13.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,35.235),(13.535,35.405),(13.705,35.405),(13.705,35.235),(13.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,35.235),(13.895,35.405),(14.065,35.405),(14.065,35.235),(13.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,35.235),(14.255,35.405),(14.425,35.405),(14.425,35.235),(14.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,35.595),(13.175,35.765),(13.345,35.765),(13.345,35.595),(13.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,35.595),(13.535,35.765),(13.705,35.765),(13.705,35.595),(13.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,35.595),(13.895,35.765),(14.065,35.765),(14.065,35.595),(13.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,35.595),(14.255,35.765),(14.425,35.765),(14.425,35.595),(14.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,35.955),(13.175,36.125),(13.345,36.125),(13.345,35.955),(13.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,35.955),(13.535,36.125),(13.705,36.125),(13.705,35.955),(13.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,35.955),(13.895,36.125),(14.065,36.125),(14.065,35.955),(13.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,35.955),(14.255,36.125),(14.425,36.125),(14.425,35.955),(14.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,36.315),(13.175,36.485),(13.345,36.485),(13.345,36.315),(13.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,36.315),(13.535,36.485),(13.705,36.485),(13.705,36.315),(13.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,36.315),(13.895,36.485),(14.065,36.485),(14.065,36.315),(13.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,36.315),(14.255,36.485),(14.425,36.485),(14.425,36.315),(14.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,36.675),(13.175,36.845),(13.345,36.845),(13.345,36.675),(13.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,36.675),(13.535,36.845),(13.705,36.845),(13.705,36.675),(13.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,36.675),(13.895,36.845),(14.065,36.845),(14.065,36.675),(13.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,36.675),(14.255,36.845),(14.425,36.845),(14.425,36.675),(14.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,37.035),(13.175,37.205),(13.345,37.205),(13.345,37.035),(13.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,37.035),(13.535,37.205),(13.705,37.205),(13.705,37.035),(13.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,37.035),(13.895,37.205),(14.065,37.205),(14.065,37.035),(13.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,37.035),(14.255,37.205),(14.425,37.205),(14.425,37.035),(14.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,37.395),(13.175,37.565),(13.345,37.565),(13.345,37.395),(13.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,37.395),(13.535,37.565),(13.705,37.565),(13.705,37.395),(13.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,37.395),(13.895,37.565),(14.065,37.565),(14.065,37.395),(13.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,37.395),(14.255,37.565),(14.425,37.565),(14.425,37.395),(14.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,37.755),(13.175,37.925),(13.345,37.925),(13.345,37.755),(13.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,37.755),(13.535,37.925),(13.705,37.925),(13.705,37.755),(13.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,37.755),(13.895,37.925),(14.065,37.925),(14.065,37.755),(13.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,37.755),(14.255,37.925),(14.425,37.925),(14.425,37.755),(14.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,38.115),(13.175,38.285),(13.345,38.285),(13.345,38.115),(13.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,38.115),(13.535,38.285),(13.705,38.285),(13.705,38.115),(13.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,38.115),(13.895,38.285),(14.065,38.285),(14.065,38.115),(13.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,38.115),(14.255,38.285),(14.425,38.285),(14.425,38.115),(14.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,38.475),(13.175,38.645),(13.345,38.645),(13.345,38.475),(13.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,38.475),(13.535,38.645),(13.705,38.645),(13.705,38.475),(13.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,38.475),(13.895,38.645),(14.065,38.645),(14.065,38.475),(13.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,38.475),(14.255,38.645),(14.425,38.645),(14.425,38.475),(14.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,38.835),(13.175,39.005),(13.345,39.005),(13.345,38.835),(13.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,38.835),(13.535,39.005),(13.705,39.005),(13.705,38.835),(13.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,38.835),(13.895,39.005),(14.065,39.005),(14.065,38.835),(13.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,38.835),(14.255,39.005),(14.425,39.005),(14.425,38.835),(14.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,39.195),(13.175,39.365),(13.345,39.365),(13.345,39.195),(13.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,39.195),(13.535,39.365),(13.705,39.365),(13.705,39.195),(13.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,39.195),(13.895,39.365),(14.065,39.365),(14.065,39.195),(13.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,39.195),(14.255,39.365),(14.425,39.365),(14.425,39.195),(14.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,39.555),(13.175,39.725),(13.345,39.725),(13.345,39.555),(13.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,39.555),(13.535,39.725),(13.705,39.725),(13.705,39.555),(13.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,39.555),(13.895,39.725),(14.065,39.725),(14.065,39.555),(13.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,39.555),(14.255,39.725),(14.425,39.725),(14.425,39.555),(14.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,39.915),(13.175,40.085),(13.345,40.085),(13.345,39.915),(13.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,39.915),(13.535,40.085),(13.705,40.085),(13.705,39.915),(13.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,39.915),(13.895,40.085),(14.065,40.085),(14.065,39.915),(13.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,39.915),(14.255,40.085),(14.425,40.085),(14.425,39.915),(14.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,40.275),(13.175,40.445),(13.345,40.445),(13.345,40.275),(13.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,40.275),(13.535,40.445),(13.705,40.445),(13.705,40.275),(13.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,40.275),(13.895,40.445),(14.065,40.445),(14.065,40.275),(13.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,40.275),(14.255,40.445),(14.425,40.445),(14.425,40.275),(14.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,40.635),(13.175,40.805),(13.345,40.805),(13.345,40.635),(13.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,40.635),(13.535,40.805),(13.705,40.805),(13.705,40.635),(13.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,40.635),(13.895,40.805),(14.065,40.805),(14.065,40.635),(13.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,40.635),(14.255,40.805),(14.425,40.805),(14.425,40.635),(14.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,2.835),(27.575,3.005),(27.745,3.005),(27.745,2.835),(27.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,2.835),(27.935,3.005),(28.105,3.005),(28.105,2.835),(27.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,2.835),(28.295,3.005),(28.465,3.005),(28.465,2.835),(28.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,2.835),(28.655,3.005),(28.825,3.005),(28.825,2.835),(28.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.195),(27.575,3.365),(27.745,3.365),(27.745,3.195),(27.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.195),(27.935,3.365),(28.105,3.365),(28.105,3.195),(27.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.195),(28.295,3.365),(28.465,3.365),(28.465,3.195),(28.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.195),(28.655,3.365),(28.825,3.365),(28.825,3.195),(28.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.555),(27.575,3.725),(27.745,3.725),(27.745,3.555),(27.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.555),(27.935,3.725),(28.105,3.725),(28.105,3.555),(27.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.555),(28.295,3.725),(28.465,3.725),(28.465,3.555),(28.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.555),(28.655,3.725),(28.825,3.725),(28.825,3.555),(28.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.915),(27.575,4.085),(27.745,4.085),(27.745,3.915),(27.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.915),(27.935,4.085),(28.105,4.085),(28.105,3.915),(27.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.915),(28.295,4.085),(28.465,4.085),(28.465,3.915),(28.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.915),(28.655,4.085),(28.825,4.085),(28.825,3.915),(28.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.275),(27.575,4.445),(27.745,4.445),(27.745,4.275),(27.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.275),(27.935,4.445),(28.105,4.445),(28.105,4.275),(27.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.275),(28.295,4.445),(28.465,4.445),(28.465,4.275),(28.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.275),(28.655,4.445),(28.825,4.445),(28.825,4.275),(28.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.635),(27.575,4.805),(27.745,4.805),(27.745,4.635),(27.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.635),(27.935,4.805),(28.105,4.805),(28.105,4.635),(27.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.635),(28.295,4.805),(28.465,4.805),(28.465,4.635),(28.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.635),(28.655,4.805),(28.825,4.805),(28.825,4.635),(28.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.995),(27.575,5.165),(27.745,5.165),(27.745,4.995),(27.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.995),(27.935,5.165),(28.105,5.165),(28.105,4.995),(27.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.995),(28.295,5.165),(28.465,5.165),(28.465,4.995),(28.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.995),(28.655,5.165),(28.825,5.165),(28.825,4.995),(28.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.355),(27.575,5.525),(27.745,5.525),(27.745,5.355),(27.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.355),(27.935,5.525),(28.105,5.525),(28.105,5.355),(27.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.355),(28.295,5.525),(28.465,5.525),(28.465,5.355),(28.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.355),(28.655,5.525),(28.825,5.525),(28.825,5.355),(28.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.715),(27.575,5.885),(27.745,5.885),(27.745,5.715),(27.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.715),(27.935,5.885),(28.105,5.885),(28.105,5.715),(27.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.715),(28.295,5.885),(28.465,5.885),(28.465,5.715),(28.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.715),(28.655,5.885),(28.825,5.885),(28.825,5.715),(28.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.075),(27.575,6.245),(27.745,6.245),(27.745,6.075),(27.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.075),(27.935,6.245),(28.105,6.245),(28.105,6.075),(27.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.075),(28.295,6.245),(28.465,6.245),(28.465,6.075),(28.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.075),(28.655,6.245),(28.825,6.245),(28.825,6.075),(28.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.435),(27.575,6.605),(27.745,6.605),(27.745,6.435),(27.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.435),(27.935,6.605),(28.105,6.605),(28.105,6.435),(27.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.435),(28.295,6.605),(28.465,6.605),(28.465,6.435),(28.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.435),(28.655,6.605),(28.825,6.605),(28.825,6.435),(28.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.795),(27.575,6.965),(27.745,6.965),(27.745,6.795),(27.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.795),(27.935,6.965),(28.105,6.965),(28.105,6.795),(27.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.795),(28.295,6.965),(28.465,6.965),(28.465,6.795),(28.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.795),(28.655,6.965),(28.825,6.965),(28.825,6.795),(28.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.155),(27.575,7.325),(27.745,7.325),(27.745,7.155),(27.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.155),(27.935,7.325),(28.105,7.325),(28.105,7.155),(27.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.155),(28.295,7.325),(28.465,7.325),(28.465,7.155),(28.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.155),(28.655,7.325),(28.825,7.325),(28.825,7.155),(28.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.515),(27.575,7.685),(27.745,7.685),(27.745,7.515),(27.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.515),(27.935,7.685),(28.105,7.685),(28.105,7.515),(27.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.515),(28.295,7.685),(28.465,7.685),(28.465,7.515),(28.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.515),(28.655,7.685),(28.825,7.685),(28.825,7.515),(28.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.875),(27.575,8.045),(27.745,8.045),(27.745,7.875),(27.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.875),(27.935,8.045),(28.105,8.045),(28.105,7.875),(27.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.875),(28.295,8.045),(28.465,8.045),(28.465,7.875),(28.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.875),(28.655,8.045),(28.825,8.045),(28.825,7.875),(28.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.235),(27.575,8.405),(27.745,8.405),(27.745,8.235),(27.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.235),(27.935,8.405),(28.105,8.405),(28.105,8.235),(27.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.235),(28.295,8.405),(28.465,8.405),(28.465,8.235),(28.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.235),(28.655,8.405),(28.825,8.405),(28.825,8.235),(28.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.595),(27.575,8.765),(27.745,8.765),(27.745,8.595),(27.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.595),(27.935,8.765),(28.105,8.765),(28.105,8.595),(27.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.595),(28.295,8.765),(28.465,8.765),(28.465,8.595),(28.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.595),(28.655,8.765),(28.825,8.765),(28.825,8.595),(28.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.955),(27.575,9.125),(27.745,9.125),(27.745,8.955),(27.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.955),(27.935,9.125),(28.105,9.125),(28.105,8.955),(27.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.955),(28.295,9.125),(28.465,9.125),(28.465,8.955),(28.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.955),(28.655,9.125),(28.825,9.125),(28.825,8.955),(28.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.315),(27.575,9.485),(27.745,9.485),(27.745,9.315),(27.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.315),(27.935,9.485),(28.105,9.485),(28.105,9.315),(27.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.315),(28.295,9.485),(28.465,9.485),(28.465,9.315),(28.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.315),(28.655,9.485),(28.825,9.485),(28.825,9.315),(28.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.675),(27.575,9.845),(27.745,9.845),(27.745,9.675),(27.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.675),(27.935,9.845),(28.105,9.845),(28.105,9.675),(27.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.675),(28.295,9.845),(28.465,9.845),(28.465,9.675),(28.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.675),(28.655,9.845),(28.825,9.845),(28.825,9.675),(28.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.035),(27.575,10.205),(27.745,10.205),(27.745,10.035),(27.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.035),(27.935,10.205),(28.105,10.205),(28.105,10.035),(27.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.035),(28.295,10.205),(28.465,10.205),(28.465,10.035),(28.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.035),(28.655,10.205),(28.825,10.205),(28.825,10.035),(28.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.395),(27.575,10.565),(27.745,10.565),(27.745,10.395),(27.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.395),(27.935,10.565),(28.105,10.565),(28.105,10.395),(27.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.395),(28.295,10.565),(28.465,10.565),(28.465,10.395),(28.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.395),(28.655,10.565),(28.825,10.565),(28.825,10.395),(28.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.755),(27.575,10.925),(27.745,10.925),(27.745,10.755),(27.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.755),(27.935,10.925),(28.105,10.925),(28.105,10.755),(27.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.755),(28.295,10.925),(28.465,10.925),(28.465,10.755),(28.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.755),(28.655,10.925),(28.825,10.925),(28.825,10.755),(28.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.115),(27.575,11.285),(27.745,11.285),(27.745,11.115),(27.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.115),(27.935,11.285),(28.105,11.285),(28.105,11.115),(27.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.115),(28.295,11.285),(28.465,11.285),(28.465,11.115),(28.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.115),(28.655,11.285),(28.825,11.285),(28.825,11.115),(28.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.475),(27.575,11.645),(27.745,11.645),(27.745,11.475),(27.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.475),(27.935,11.645),(28.105,11.645),(28.105,11.475),(27.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.475),(28.295,11.645),(28.465,11.645),(28.465,11.475),(28.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.475),(28.655,11.645),(28.825,11.645),(28.825,11.475),(28.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.835),(27.575,12.005),(27.745,12.005),(27.745,11.835),(27.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.835),(27.935,12.005),(28.105,12.005),(28.105,11.835),(27.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.835),(28.295,12.005),(28.465,12.005),(28.465,11.835),(28.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.835),(28.655,12.005),(28.825,12.005),(28.825,11.835),(28.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.195),(27.575,12.365),(27.745,12.365),(27.745,12.195),(27.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.195),(27.935,12.365),(28.105,12.365),(28.105,12.195),(27.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.195),(28.295,12.365),(28.465,12.365),(28.465,12.195),(28.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.195),(28.655,12.365),(28.825,12.365),(28.825,12.195),(28.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.555),(27.575,12.725),(27.745,12.725),(27.745,12.555),(27.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.555),(27.935,12.725),(28.105,12.725),(28.105,12.555),(27.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.555),(28.295,12.725),(28.465,12.725),(28.465,12.555),(28.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.555),(28.655,12.725),(28.825,12.725),(28.825,12.555),(28.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.915),(27.575,13.085),(27.745,13.085),(27.745,12.915),(27.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.915),(27.935,13.085),(28.105,13.085),(28.105,12.915),(27.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.915),(28.295,13.085),(28.465,13.085),(28.465,12.915),(28.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.915),(28.655,13.085),(28.825,13.085),(28.825,12.915),(28.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.275),(27.575,13.445),(27.745,13.445),(27.745,13.275),(27.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.275),(27.935,13.445),(28.105,13.445),(28.105,13.275),(27.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.275),(28.295,13.445),(28.465,13.445),(28.465,13.275),(28.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.275),(28.655,13.445),(28.825,13.445),(28.825,13.275),(28.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.635),(27.575,13.805),(27.745,13.805),(27.745,13.635),(27.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.635),(27.935,13.805),(28.105,13.805),(28.105,13.635),(27.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.635),(28.295,13.805),(28.465,13.805),(28.465,13.635),(28.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.635),(28.655,13.805),(28.825,13.805),(28.825,13.635),(28.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.995),(27.575,14.165),(27.745,14.165),(27.745,13.995),(27.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.995),(27.935,14.165),(28.105,14.165),(28.105,13.995),(27.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.995),(28.295,14.165),(28.465,14.165),(28.465,13.995),(28.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.995),(28.655,14.165),(28.825,14.165),(28.825,13.995),(28.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.355),(27.575,14.525),(27.745,14.525),(27.745,14.355),(27.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.355),(27.935,14.525),(28.105,14.525),(28.105,14.355),(27.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.355),(28.295,14.525),(28.465,14.525),(28.465,14.355),(28.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.355),(28.655,14.525),(28.825,14.525),(28.825,14.355),(28.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.715),(27.575,14.885),(27.745,14.885),(27.745,14.715),(27.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.715),(27.935,14.885),(28.105,14.885),(28.105,14.715),(27.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.715),(28.295,14.885),(28.465,14.885),(28.465,14.715),(28.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.715),(28.655,14.885),(28.825,14.885),(28.825,14.715),(28.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.075),(27.575,15.245),(27.745,15.245),(27.745,15.075),(27.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.075),(27.935,15.245),(28.105,15.245),(28.105,15.075),(27.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.075),(28.295,15.245),(28.465,15.245),(28.465,15.075),(28.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.075),(28.655,15.245),(28.825,15.245),(28.825,15.075),(28.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.435),(27.575,15.605),(27.745,15.605),(27.745,15.435),(27.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.435),(27.935,15.605),(28.105,15.605),(28.105,15.435),(27.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.435),(28.295,15.605),(28.465,15.605),(28.465,15.435),(28.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.435),(28.655,15.605),(28.825,15.605),(28.825,15.435),(28.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.795),(27.575,15.965),(27.745,15.965),(27.745,15.795),(27.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.795),(27.935,15.965),(28.105,15.965),(28.105,15.795),(27.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.795),(28.295,15.965),(28.465,15.965),(28.465,15.795),(28.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.795),(28.655,15.965),(28.825,15.965),(28.825,15.795),(28.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.155),(27.575,16.325),(27.745,16.325),(27.745,16.155),(27.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.155),(27.935,16.325),(28.105,16.325),(28.105,16.155),(27.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.155),(28.295,16.325),(28.465,16.325),(28.465,16.155),(28.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.155),(28.655,16.325),(28.825,16.325),(28.825,16.155),(28.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.515),(27.575,16.685),(27.745,16.685),(27.745,16.515),(27.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.515),(27.935,16.685),(28.105,16.685),(28.105,16.515),(27.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.515),(28.295,16.685),(28.465,16.685),(28.465,16.515),(28.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.515),(28.655,16.685),(28.825,16.685),(28.825,16.515),(28.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.875),(27.575,17.045),(27.745,17.045),(27.745,16.875),(27.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.875),(27.935,17.045),(28.105,17.045),(28.105,16.875),(27.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.875),(28.295,17.045),(28.465,17.045),(28.465,16.875),(28.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.875),(28.655,17.045),(28.825,17.045),(28.825,16.875),(28.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.235),(27.575,17.405),(27.745,17.405),(27.745,17.235),(27.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.235),(27.935,17.405),(28.105,17.405),(28.105,17.235),(27.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.235),(28.295,17.405),(28.465,17.405),(28.465,17.235),(28.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.235),(28.655,17.405),(28.825,17.405),(28.825,17.235),(28.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.595),(27.575,17.765),(27.745,17.765),(27.745,17.595),(27.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.595),(27.935,17.765),(28.105,17.765),(28.105,17.595),(27.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.595),(28.295,17.765),(28.465,17.765),(28.465,17.595),(28.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.595),(28.655,17.765),(28.825,17.765),(28.825,17.595),(28.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.955),(27.575,18.125),(27.745,18.125),(27.745,17.955),(27.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.955),(27.935,18.125),(28.105,18.125),(28.105,17.955),(27.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.955),(28.295,18.125),(28.465,18.125),(28.465,17.955),(28.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.955),(28.655,18.125),(28.825,18.125),(28.825,17.955),(28.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.315),(27.575,18.485),(27.745,18.485),(27.745,18.315),(27.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.315),(27.935,18.485),(28.105,18.485),(28.105,18.315),(27.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.315),(28.295,18.485),(28.465,18.485),(28.465,18.315),(28.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.315),(28.655,18.485),(28.825,18.485),(28.825,18.315),(28.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.675),(27.575,18.845),(27.745,18.845),(27.745,18.675),(27.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.675),(27.935,18.845),(28.105,18.845),(28.105,18.675),(27.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.675),(28.295,18.845),(28.465,18.845),(28.465,18.675),(28.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.675),(28.655,18.845),(28.825,18.845),(28.825,18.675),(28.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.035),(27.575,19.205),(27.745,19.205),(27.745,19.035),(27.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.035),(27.935,19.205),(28.105,19.205),(28.105,19.035),(27.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.035),(28.295,19.205),(28.465,19.205),(28.465,19.035),(28.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.035),(28.655,19.205),(28.825,19.205),(28.825,19.035),(28.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.395),(27.575,19.565),(27.745,19.565),(27.745,19.395),(27.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.395),(27.935,19.565),(28.105,19.565),(28.105,19.395),(27.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.395),(28.295,19.565),(28.465,19.565),(28.465,19.395),(28.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.395),(28.655,19.565),(28.825,19.565),(28.825,19.395),(28.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.755),(27.575,19.925),(27.745,19.925),(27.745,19.755),(27.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.755),(27.935,19.925),(28.105,19.925),(28.105,19.755),(27.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.755),(28.295,19.925),(28.465,19.925),(28.465,19.755),(28.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.755),(28.655,19.925),(28.825,19.925),(28.825,19.755),(28.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,20.115),(27.575,20.285),(27.745,20.285),(27.745,20.115),(27.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,20.115),(27.935,20.285),(28.105,20.285),(28.105,20.115),(27.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,20.115),(28.295,20.285),(28.465,20.285),(28.465,20.115),(28.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,20.115),(28.655,20.285),(28.825,20.285),(28.825,20.115),(28.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,20.475),(27.575,20.645),(27.745,20.645),(27.745,20.475),(27.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,20.475),(27.935,20.645),(28.105,20.645),(28.105,20.475),(27.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,20.475),(28.295,20.645),(28.465,20.645),(28.465,20.475),(28.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,20.475),(28.655,20.645),(28.825,20.645),(28.825,20.475),(28.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,20.835),(27.575,21.005),(27.745,21.005),(27.745,20.835),(27.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,20.835),(27.935,21.005),(28.105,21.005),(28.105,20.835),(27.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,20.835),(28.295,21.005),(28.465,21.005),(28.465,20.835),(28.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,20.835),(28.655,21.005),(28.825,21.005),(28.825,20.835),(28.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,21.195),(27.575,21.365),(27.745,21.365),(27.745,21.195),(27.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,21.195),(27.935,21.365),(28.105,21.365),(28.105,21.195),(27.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,21.195),(28.295,21.365),(28.465,21.365),(28.465,21.195),(28.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,21.195),(28.655,21.365),(28.825,21.365),(28.825,21.195),(28.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,21.555),(27.575,21.725),(27.745,21.725),(27.745,21.555),(27.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,21.555),(27.935,21.725),(28.105,21.725),(28.105,21.555),(27.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,21.555),(28.295,21.725),(28.465,21.725),(28.465,21.555),(28.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,21.555),(28.655,21.725),(28.825,21.725),(28.825,21.555),(28.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,21.915),(27.575,22.085),(27.745,22.085),(27.745,21.915),(27.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,21.915),(27.935,22.085),(28.105,22.085),(28.105,21.915),(27.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,21.915),(28.295,22.085),(28.465,22.085),(28.465,21.915),(28.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,21.915),(28.655,22.085),(28.825,22.085),(28.825,21.915),(28.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.275),(27.575,22.445),(27.745,22.445),(27.745,22.275),(27.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.275),(27.935,22.445),(28.105,22.445),(28.105,22.275),(27.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.275),(28.295,22.445),(28.465,22.445),(28.465,22.275),(28.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.275),(28.655,22.445),(28.825,22.445),(28.825,22.275),(28.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.635),(27.575,22.805),(27.745,22.805),(27.745,22.635),(27.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.635),(27.935,22.805),(28.105,22.805),(28.105,22.635),(27.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.635),(28.295,22.805),(28.465,22.805),(28.465,22.635),(28.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.635),(28.655,22.805),(28.825,22.805),(28.825,22.635),(28.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.995),(27.575,23.165),(27.745,23.165),(27.745,22.995),(27.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.995),(27.935,23.165),(28.105,23.165),(28.105,22.995),(27.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.995),(28.295,23.165),(28.465,23.165),(28.465,22.995),(28.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.995),(28.655,23.165),(28.825,23.165),(28.825,22.995),(28.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,23.355),(27.575,23.525),(27.745,23.525),(27.745,23.355),(27.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,23.355),(27.935,23.525),(28.105,23.525),(28.105,23.355),(27.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,23.355),(28.295,23.525),(28.465,23.525),(28.465,23.355),(28.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,23.355),(28.655,23.525),(28.825,23.525),(28.825,23.355),(28.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,23.715),(27.575,23.885),(27.745,23.885),(27.745,23.715),(27.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,23.715),(27.935,23.885),(28.105,23.885),(28.105,23.715),(27.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,23.715),(28.295,23.885),(28.465,23.885),(28.465,23.715),(28.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,23.715),(28.655,23.885),(28.825,23.885),(28.825,23.715),(28.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,24.075),(27.575,24.245),(27.745,24.245),(27.745,24.075),(27.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,24.075),(27.935,24.245),(28.105,24.245),(28.105,24.075),(27.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,24.075),(28.295,24.245),(28.465,24.245),(28.465,24.075),(28.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,24.075),(28.655,24.245),(28.825,24.245),(28.825,24.075),(28.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,24.435),(27.575,24.605),(27.745,24.605),(27.745,24.435),(27.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,24.435),(27.935,24.605),(28.105,24.605),(28.105,24.435),(27.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,24.435),(28.295,24.605),(28.465,24.605),(28.465,24.435),(28.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,24.435),(28.655,24.605),(28.825,24.605),(28.825,24.435),(28.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,24.795),(27.575,24.965),(27.745,24.965),(27.745,24.795),(27.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,24.795),(27.935,24.965),(28.105,24.965),(28.105,24.795),(27.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,24.795),(28.295,24.965),(28.465,24.965),(28.465,24.795),(28.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,24.795),(28.655,24.965),(28.825,24.965),(28.825,24.795),(28.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,25.155),(27.575,25.325),(27.745,25.325),(27.745,25.155),(27.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,25.155),(27.935,25.325),(28.105,25.325),(28.105,25.155),(27.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,25.155),(28.295,25.325),(28.465,25.325),(28.465,25.155),(28.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,25.155),(28.655,25.325),(28.825,25.325),(28.825,25.155),(28.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,25.515),(27.575,25.685),(27.745,25.685),(27.745,25.515),(27.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,25.515),(27.935,25.685),(28.105,25.685),(28.105,25.515),(27.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,25.515),(28.295,25.685),(28.465,25.685),(28.465,25.515),(28.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,25.515),(28.655,25.685),(28.825,25.685),(28.825,25.515),(28.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,25.875),(27.575,26.045),(27.745,26.045),(27.745,25.875),(27.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,25.875),(27.935,26.045),(28.105,26.045),(28.105,25.875),(27.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,25.875),(28.295,26.045),(28.465,26.045),(28.465,25.875),(28.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,25.875),(28.655,26.045),(28.825,26.045),(28.825,25.875),(28.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,26.235),(27.575,26.405),(27.745,26.405),(27.745,26.235),(27.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,26.235),(27.935,26.405),(28.105,26.405),(28.105,26.235),(27.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,26.235),(28.295,26.405),(28.465,26.405),(28.465,26.235),(28.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,26.235),(28.655,26.405),(28.825,26.405),(28.825,26.235),(28.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,26.595),(27.575,26.765),(27.745,26.765),(27.745,26.595),(27.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,26.595),(27.935,26.765),(28.105,26.765),(28.105,26.595),(27.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,26.595),(28.295,26.765),(28.465,26.765),(28.465,26.595),(28.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,26.595),(28.655,26.765),(28.825,26.765),(28.825,26.595),(28.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,26.955),(27.575,27.125),(27.745,27.125),(27.745,26.955),(27.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,26.955),(27.935,27.125),(28.105,27.125),(28.105,26.955),(27.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,26.955),(28.295,27.125),(28.465,27.125),(28.465,26.955),(28.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,26.955),(28.655,27.125),(28.825,27.125),(28.825,26.955),(28.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,27.315),(27.575,27.485),(27.745,27.485),(27.745,27.315),(27.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,27.315),(27.935,27.485),(28.105,27.485),(28.105,27.315),(27.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,27.315),(28.295,27.485),(28.465,27.485),(28.465,27.315),(28.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,27.315),(28.655,27.485),(28.825,27.485),(28.825,27.315),(28.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,27.675),(27.575,27.845),(27.745,27.845),(27.745,27.675),(27.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,27.675),(27.935,27.845),(28.105,27.845),(28.105,27.675),(27.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,27.675),(28.295,27.845),(28.465,27.845),(28.465,27.675),(28.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,27.675),(28.655,27.845),(28.825,27.845),(28.825,27.675),(28.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,28.035),(27.575,28.205),(27.745,28.205),(27.745,28.035),(27.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,28.035),(27.935,28.205),(28.105,28.205),(28.105,28.035),(27.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,28.035),(28.295,28.205),(28.465,28.205),(28.465,28.035),(28.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,28.035),(28.655,28.205),(28.825,28.205),(28.825,28.035),(28.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,28.395),(27.575,28.565),(27.745,28.565),(27.745,28.395),(27.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,28.395),(27.935,28.565),(28.105,28.565),(28.105,28.395),(27.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,28.395),(28.295,28.565),(28.465,28.565),(28.465,28.395),(28.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,28.395),(28.655,28.565),(28.825,28.565),(28.825,28.395),(28.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,28.755),(27.575,28.925),(27.745,28.925),(27.745,28.755),(27.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,28.755),(27.935,28.925),(28.105,28.925),(28.105,28.755),(27.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,28.755),(28.295,28.925),(28.465,28.925),(28.465,28.755),(28.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,28.755),(28.655,28.925),(28.825,28.925),(28.825,28.755),(28.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,29.115),(27.575,29.285),(27.745,29.285),(27.745,29.115),(27.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,29.115),(27.935,29.285),(28.105,29.285),(28.105,29.115),(27.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,29.115),(28.295,29.285),(28.465,29.285),(28.465,29.115),(28.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,29.115),(28.655,29.285),(28.825,29.285),(28.825,29.115),(28.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,29.475),(27.575,29.645),(27.745,29.645),(27.745,29.475),(27.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,29.475),(27.935,29.645),(28.105,29.645),(28.105,29.475),(27.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,29.475),(28.295,29.645),(28.465,29.645),(28.465,29.475),(28.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,29.475),(28.655,29.645),(28.825,29.645),(28.825,29.475),(28.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,29.835),(27.575,30.005),(27.745,30.005),(27.745,29.835),(27.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,29.835),(27.935,30.005),(28.105,30.005),(28.105,29.835),(27.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,29.835),(28.295,30.005),(28.465,30.005),(28.465,29.835),(28.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,29.835),(28.655,30.005),(28.825,30.005),(28.825,29.835),(28.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,30.195),(27.575,30.365),(27.745,30.365),(27.745,30.195),(27.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,30.195),(27.935,30.365),(28.105,30.365),(28.105,30.195),(27.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,30.195),(28.295,30.365),(28.465,30.365),(28.465,30.195),(28.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,30.195),(28.655,30.365),(28.825,30.365),(28.825,30.195),(28.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,30.555),(27.575,30.725),(27.745,30.725),(27.745,30.555),(27.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,30.555),(27.935,30.725),(28.105,30.725),(28.105,30.555),(27.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,30.555),(28.295,30.725),(28.465,30.725),(28.465,30.555),(28.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,30.555),(28.655,30.725),(28.825,30.725),(28.825,30.555),(28.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,30.915),(27.575,31.085),(27.745,31.085),(27.745,30.915),(27.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,30.915),(27.935,31.085),(28.105,31.085),(28.105,30.915),(27.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,30.915),(28.295,31.085),(28.465,31.085),(28.465,30.915),(28.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,30.915),(28.655,31.085),(28.825,31.085),(28.825,30.915),(28.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,31.275),(27.575,31.445),(27.745,31.445),(27.745,31.275),(27.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,31.275),(27.935,31.445),(28.105,31.445),(28.105,31.275),(27.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,31.275),(28.295,31.445),(28.465,31.445),(28.465,31.275),(28.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,31.275),(28.655,31.445),(28.825,31.445),(28.825,31.275),(28.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,31.635),(27.575,31.805),(27.745,31.805),(27.745,31.635),(27.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,31.635),(27.935,31.805),(28.105,31.805),(28.105,31.635),(27.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,31.635),(28.295,31.805),(28.465,31.805),(28.465,31.635),(28.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,31.635),(28.655,31.805),(28.825,31.805),(28.825,31.635),(28.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,31.995),(27.575,32.165),(27.745,32.165),(27.745,31.995),(27.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,31.995),(27.935,32.165),(28.105,32.165),(28.105,31.995),(27.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,31.995),(28.295,32.165),(28.465,32.165),(28.465,31.995),(28.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,31.995),(28.655,32.165),(28.825,32.165),(28.825,31.995),(28.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,32.355),(27.575,32.525),(27.745,32.525),(27.745,32.355),(27.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,32.355),(27.935,32.525),(28.105,32.525),(28.105,32.355),(27.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,32.355),(28.295,32.525),(28.465,32.525),(28.465,32.355),(28.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,32.355),(28.655,32.525),(28.825,32.525),(28.825,32.355),(28.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,32.715),(27.575,32.885),(27.745,32.885),(27.745,32.715),(27.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,32.715),(27.935,32.885),(28.105,32.885),(28.105,32.715),(27.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,32.715),(28.295,32.885),(28.465,32.885),(28.465,32.715),(28.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,32.715),(28.655,32.885),(28.825,32.885),(28.825,32.715),(28.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,33.075),(27.575,33.245),(27.745,33.245),(27.745,33.075),(27.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,33.075),(27.935,33.245),(28.105,33.245),(28.105,33.075),(27.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,33.075),(28.295,33.245),(28.465,33.245),(28.465,33.075),(28.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,33.075),(28.655,33.245),(28.825,33.245),(28.825,33.075),(28.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,33.435),(27.575,33.605),(27.745,33.605),(27.745,33.435),(27.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,33.435),(27.935,33.605),(28.105,33.605),(28.105,33.435),(27.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,33.435),(28.295,33.605),(28.465,33.605),(28.465,33.435),(28.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,33.435),(28.655,33.605),(28.825,33.605),(28.825,33.435),(28.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,33.795),(27.575,33.965),(27.745,33.965),(27.745,33.795),(27.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,33.795),(27.935,33.965),(28.105,33.965),(28.105,33.795),(27.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,33.795),(28.295,33.965),(28.465,33.965),(28.465,33.795),(28.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,33.795),(28.655,33.965),(28.825,33.965),(28.825,33.795),(28.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,34.155),(27.575,34.325),(27.745,34.325),(27.745,34.155),(27.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,34.155),(27.935,34.325),(28.105,34.325),(28.105,34.155),(27.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,34.155),(28.295,34.325),(28.465,34.325),(28.465,34.155),(28.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,34.155),(28.655,34.325),(28.825,34.325),(28.825,34.155),(28.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,34.515),(27.575,34.685),(27.745,34.685),(27.745,34.515),(27.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,34.515),(27.935,34.685),(28.105,34.685),(28.105,34.515),(27.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,34.515),(28.295,34.685),(28.465,34.685),(28.465,34.515),(28.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,34.515),(28.655,34.685),(28.825,34.685),(28.825,34.515),(28.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,34.875),(27.575,35.045),(27.745,35.045),(27.745,34.875),(27.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,34.875),(27.935,35.045),(28.105,35.045),(28.105,34.875),(27.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,34.875),(28.295,35.045),(28.465,35.045),(28.465,34.875),(28.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,34.875),(28.655,35.045),(28.825,35.045),(28.825,34.875),(28.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,35.235),(27.575,35.405),(27.745,35.405),(27.745,35.235),(27.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,35.235),(27.935,35.405),(28.105,35.405),(28.105,35.235),(27.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,35.235),(28.295,35.405),(28.465,35.405),(28.465,35.235),(28.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,35.235),(28.655,35.405),(28.825,35.405),(28.825,35.235),(28.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,35.595),(27.575,35.765),(27.745,35.765),(27.745,35.595),(27.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,35.595),(27.935,35.765),(28.105,35.765),(28.105,35.595),(27.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,35.595),(28.295,35.765),(28.465,35.765),(28.465,35.595),(28.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,35.595),(28.655,35.765),(28.825,35.765),(28.825,35.595),(28.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,35.955),(27.575,36.125),(27.745,36.125),(27.745,35.955),(27.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,35.955),(27.935,36.125),(28.105,36.125),(28.105,35.955),(27.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,35.955),(28.295,36.125),(28.465,36.125),(28.465,35.955),(28.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,35.955),(28.655,36.125),(28.825,36.125),(28.825,35.955),(28.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,36.315),(27.575,36.485),(27.745,36.485),(27.745,36.315),(27.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,36.315),(27.935,36.485),(28.105,36.485),(28.105,36.315),(27.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,36.315),(28.295,36.485),(28.465,36.485),(28.465,36.315),(28.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,36.315),(28.655,36.485),(28.825,36.485),(28.825,36.315),(28.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,36.675),(27.575,36.845),(27.745,36.845),(27.745,36.675),(27.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,36.675),(27.935,36.845),(28.105,36.845),(28.105,36.675),(27.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,36.675),(28.295,36.845),(28.465,36.845),(28.465,36.675),(28.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,36.675),(28.655,36.845),(28.825,36.845),(28.825,36.675),(28.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,37.035),(27.575,37.205),(27.745,37.205),(27.745,37.035),(27.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,37.035),(27.935,37.205),(28.105,37.205),(28.105,37.035),(27.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,37.035),(28.295,37.205),(28.465,37.205),(28.465,37.035),(28.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,37.035),(28.655,37.205),(28.825,37.205),(28.825,37.035),(28.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,37.395),(27.575,37.565),(27.745,37.565),(27.745,37.395),(27.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,37.395),(27.935,37.565),(28.105,37.565),(28.105,37.395),(27.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,37.395),(28.295,37.565),(28.465,37.565),(28.465,37.395),(28.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,37.395),(28.655,37.565),(28.825,37.565),(28.825,37.395),(28.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,37.755),(27.575,37.925),(27.745,37.925),(27.745,37.755),(27.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,37.755),(27.935,37.925),(28.105,37.925),(28.105,37.755),(27.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,37.755),(28.295,37.925),(28.465,37.925),(28.465,37.755),(28.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,37.755),(28.655,37.925),(28.825,37.925),(28.825,37.755),(28.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,38.115),(27.575,38.285),(27.745,38.285),(27.745,38.115),(27.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,38.115),(27.935,38.285),(28.105,38.285),(28.105,38.115),(27.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,38.115),(28.295,38.285),(28.465,38.285),(28.465,38.115),(28.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,38.115),(28.655,38.285),(28.825,38.285),(28.825,38.115),(28.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,38.475),(27.575,38.645),(27.745,38.645),(27.745,38.475),(27.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,38.475),(27.935,38.645),(28.105,38.645),(28.105,38.475),(27.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,38.475),(28.295,38.645),(28.465,38.645),(28.465,38.475),(28.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,38.475),(28.655,38.645),(28.825,38.645),(28.825,38.475),(28.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,38.835),(27.575,39.005),(27.745,39.005),(27.745,38.835),(27.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,38.835),(27.935,39.005),(28.105,39.005),(28.105,38.835),(27.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,38.835),(28.295,39.005),(28.465,39.005),(28.465,38.835),(28.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,38.835),(28.655,39.005),(28.825,39.005),(28.825,38.835),(28.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,39.195),(27.575,39.365),(27.745,39.365),(27.745,39.195),(27.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,39.195),(27.935,39.365),(28.105,39.365),(28.105,39.195),(27.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,39.195),(28.295,39.365),(28.465,39.365),(28.465,39.195),(28.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,39.195),(28.655,39.365),(28.825,39.365),(28.825,39.195),(28.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,39.555),(27.575,39.725),(27.745,39.725),(27.745,39.555),(27.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,39.555),(27.935,39.725),(28.105,39.725),(28.105,39.555),(27.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,39.555),(28.295,39.725),(28.465,39.725),(28.465,39.555),(28.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,39.555),(28.655,39.725),(28.825,39.725),(28.825,39.555),(28.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,39.915),(27.575,40.085),(27.745,40.085),(27.745,39.915),(27.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,39.915),(27.935,40.085),(28.105,40.085),(28.105,39.915),(27.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,39.915),(28.295,40.085),(28.465,40.085),(28.465,39.915),(28.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,39.915),(28.655,40.085),(28.825,40.085),(28.825,39.915),(28.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,40.275),(27.575,40.445),(27.745,40.445),(27.745,40.275),(27.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,40.275),(27.935,40.445),(28.105,40.445),(28.105,40.275),(27.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,40.275),(28.295,40.445),(28.465,40.445),(28.465,40.275),(28.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,40.275),(28.655,40.445),(28.825,40.445),(28.825,40.275),(28.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,40.635),(27.575,40.805),(27.745,40.805),(27.745,40.635),(27.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,40.635),(27.935,40.805),(28.105,40.805),(28.105,40.635),(27.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,40.635),(28.295,40.805),(28.465,40.805),(28.465,40.635),(28.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,40.635),(28.655,40.805),(28.825,40.805),(28.825,40.635),(28.655,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,2.835),(80.375,3.005),(80.545,3.005),(80.545,2.835),(80.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,2.835),(80.735,3.005),(80.905,3.005),(80.905,2.835),(80.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,2.835),(81.095,3.005),(81.265,3.005),(81.265,2.835),(81.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,2.835),(81.455,3.005),(81.625,3.005),(81.625,2.835),(81.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.195),(80.375,3.365),(80.545,3.365),(80.545,3.195),(80.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.195),(80.735,3.365),(80.905,3.365),(80.905,3.195),(80.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.195),(81.095,3.365),(81.265,3.365),(81.265,3.195),(81.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.195),(81.455,3.365),(81.625,3.365),(81.625,3.195),(81.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.555),(80.375,3.725),(80.545,3.725),(80.545,3.555),(80.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.555),(80.735,3.725),(80.905,3.725),(80.905,3.555),(80.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.555),(81.095,3.725),(81.265,3.725),(81.265,3.555),(81.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.555),(81.455,3.725),(81.625,3.725),(81.625,3.555),(81.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.915),(80.375,4.085),(80.545,4.085),(80.545,3.915),(80.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.915),(80.735,4.085),(80.905,4.085),(80.905,3.915),(80.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.915),(81.095,4.085),(81.265,4.085),(81.265,3.915),(81.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.915),(81.455,4.085),(81.625,4.085),(81.625,3.915),(81.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.275),(80.375,4.445),(80.545,4.445),(80.545,4.275),(80.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.275),(80.735,4.445),(80.905,4.445),(80.905,4.275),(80.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.275),(81.095,4.445),(81.265,4.445),(81.265,4.275),(81.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.275),(81.455,4.445),(81.625,4.445),(81.625,4.275),(81.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.635),(80.375,4.805),(80.545,4.805),(80.545,4.635),(80.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.635),(80.735,4.805),(80.905,4.805),(80.905,4.635),(80.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.635),(81.095,4.805),(81.265,4.805),(81.265,4.635),(81.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.635),(81.455,4.805),(81.625,4.805),(81.625,4.635),(81.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.995),(80.375,5.165),(80.545,5.165),(80.545,4.995),(80.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.995),(80.735,5.165),(80.905,5.165),(80.905,4.995),(80.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.995),(81.095,5.165),(81.265,5.165),(81.265,4.995),(81.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.995),(81.455,5.165),(81.625,5.165),(81.625,4.995),(81.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.355),(80.375,5.525),(80.545,5.525),(80.545,5.355),(80.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.355),(80.735,5.525),(80.905,5.525),(80.905,5.355),(80.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.355),(81.095,5.525),(81.265,5.525),(81.265,5.355),(81.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.355),(81.455,5.525),(81.625,5.525),(81.625,5.355),(81.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.715),(80.375,5.885),(80.545,5.885),(80.545,5.715),(80.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.715),(80.735,5.885),(80.905,5.885),(80.905,5.715),(80.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.715),(81.095,5.885),(81.265,5.885),(81.265,5.715),(81.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.715),(81.455,5.885),(81.625,5.885),(81.625,5.715),(81.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.075),(80.375,6.245),(80.545,6.245),(80.545,6.075),(80.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.075),(80.735,6.245),(80.905,6.245),(80.905,6.075),(80.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.075),(81.095,6.245),(81.265,6.245),(81.265,6.075),(81.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.075),(81.455,6.245),(81.625,6.245),(81.625,6.075),(81.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.435),(80.375,6.605),(80.545,6.605),(80.545,6.435),(80.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.435),(80.735,6.605),(80.905,6.605),(80.905,6.435),(80.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.435),(81.095,6.605),(81.265,6.605),(81.265,6.435),(81.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.435),(81.455,6.605),(81.625,6.605),(81.625,6.435),(81.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.795),(80.375,6.965),(80.545,6.965),(80.545,6.795),(80.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.795),(80.735,6.965),(80.905,6.965),(80.905,6.795),(80.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.795),(81.095,6.965),(81.265,6.965),(81.265,6.795),(81.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.795),(81.455,6.965),(81.625,6.965),(81.625,6.795),(81.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.155),(80.375,7.325),(80.545,7.325),(80.545,7.155),(80.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.155),(80.735,7.325),(80.905,7.325),(80.905,7.155),(80.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.155),(81.095,7.325),(81.265,7.325),(81.265,7.155),(81.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.155),(81.455,7.325),(81.625,7.325),(81.625,7.155),(81.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.515),(80.375,7.685),(80.545,7.685),(80.545,7.515),(80.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.515),(80.735,7.685),(80.905,7.685),(80.905,7.515),(80.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.515),(81.095,7.685),(81.265,7.685),(81.265,7.515),(81.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.515),(81.455,7.685),(81.625,7.685),(81.625,7.515),(81.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.875),(80.375,8.045),(80.545,8.045),(80.545,7.875),(80.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.875),(80.735,8.045),(80.905,8.045),(80.905,7.875),(80.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.875),(81.095,8.045),(81.265,8.045),(81.265,7.875),(81.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.875),(81.455,8.045),(81.625,8.045),(81.625,7.875),(81.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.235),(80.375,8.405),(80.545,8.405),(80.545,8.235),(80.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.235),(80.735,8.405),(80.905,8.405),(80.905,8.235),(80.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.235),(81.095,8.405),(81.265,8.405),(81.265,8.235),(81.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.235),(81.455,8.405),(81.625,8.405),(81.625,8.235),(81.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.595),(80.375,8.765),(80.545,8.765),(80.545,8.595),(80.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.595),(80.735,8.765),(80.905,8.765),(80.905,8.595),(80.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.595),(81.095,8.765),(81.265,8.765),(81.265,8.595),(81.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.595),(81.455,8.765),(81.625,8.765),(81.625,8.595),(81.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.955),(80.375,9.125),(80.545,9.125),(80.545,8.955),(80.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.955),(80.735,9.125),(80.905,9.125),(80.905,8.955),(80.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.955),(81.095,9.125),(81.265,9.125),(81.265,8.955),(81.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.955),(81.455,9.125),(81.625,9.125),(81.625,8.955),(81.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.315),(80.375,9.485),(80.545,9.485),(80.545,9.315),(80.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.315),(80.735,9.485),(80.905,9.485),(80.905,9.315),(80.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.315),(81.095,9.485),(81.265,9.485),(81.265,9.315),(81.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.315),(81.455,9.485),(81.625,9.485),(81.625,9.315),(81.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.675),(80.375,9.845),(80.545,9.845),(80.545,9.675),(80.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.675),(80.735,9.845),(80.905,9.845),(80.905,9.675),(80.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.675),(81.095,9.845),(81.265,9.845),(81.265,9.675),(81.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.675),(81.455,9.845),(81.625,9.845),(81.625,9.675),(81.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.035),(80.375,10.205),(80.545,10.205),(80.545,10.035),(80.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.035),(80.735,10.205),(80.905,10.205),(80.905,10.035),(80.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.035),(81.095,10.205),(81.265,10.205),(81.265,10.035),(81.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.035),(81.455,10.205),(81.625,10.205),(81.625,10.035),(81.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.395),(80.375,10.565),(80.545,10.565),(80.545,10.395),(80.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.395),(80.735,10.565),(80.905,10.565),(80.905,10.395),(80.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.395),(81.095,10.565),(81.265,10.565),(81.265,10.395),(81.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.395),(81.455,10.565),(81.625,10.565),(81.625,10.395),(81.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.755),(80.375,10.925),(80.545,10.925),(80.545,10.755),(80.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.755),(80.735,10.925),(80.905,10.925),(80.905,10.755),(80.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.755),(81.095,10.925),(81.265,10.925),(81.265,10.755),(81.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.755),(81.455,10.925),(81.625,10.925),(81.625,10.755),(81.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.115),(80.375,11.285),(80.545,11.285),(80.545,11.115),(80.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.115),(80.735,11.285),(80.905,11.285),(80.905,11.115),(80.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.115),(81.095,11.285),(81.265,11.285),(81.265,11.115),(81.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.115),(81.455,11.285),(81.625,11.285),(81.625,11.115),(81.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.475),(80.375,11.645),(80.545,11.645),(80.545,11.475),(80.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.475),(80.735,11.645),(80.905,11.645),(80.905,11.475),(80.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.475),(81.095,11.645),(81.265,11.645),(81.265,11.475),(81.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.475),(81.455,11.645),(81.625,11.645),(81.625,11.475),(81.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.835),(80.375,12.005),(80.545,12.005),(80.545,11.835),(80.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.835),(80.735,12.005),(80.905,12.005),(80.905,11.835),(80.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.835),(81.095,12.005),(81.265,12.005),(81.265,11.835),(81.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.835),(81.455,12.005),(81.625,12.005),(81.625,11.835),(81.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.195),(80.375,12.365),(80.545,12.365),(80.545,12.195),(80.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.195),(80.735,12.365),(80.905,12.365),(80.905,12.195),(80.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.195),(81.095,12.365),(81.265,12.365),(81.265,12.195),(81.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.195),(81.455,12.365),(81.625,12.365),(81.625,12.195),(81.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.555),(80.375,12.725),(80.545,12.725),(80.545,12.555),(80.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.555),(80.735,12.725),(80.905,12.725),(80.905,12.555),(80.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.555),(81.095,12.725),(81.265,12.725),(81.265,12.555),(81.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.555),(81.455,12.725),(81.625,12.725),(81.625,12.555),(81.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.915),(80.375,13.085),(80.545,13.085),(80.545,12.915),(80.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.915),(80.735,13.085),(80.905,13.085),(80.905,12.915),(80.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.915),(81.095,13.085),(81.265,13.085),(81.265,12.915),(81.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.915),(81.455,13.085),(81.625,13.085),(81.625,12.915),(81.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.275),(80.375,13.445),(80.545,13.445),(80.545,13.275),(80.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.275),(80.735,13.445),(80.905,13.445),(80.905,13.275),(80.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.275),(81.095,13.445),(81.265,13.445),(81.265,13.275),(81.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.275),(81.455,13.445),(81.625,13.445),(81.625,13.275),(81.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.635),(80.375,13.805),(80.545,13.805),(80.545,13.635),(80.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.635),(80.735,13.805),(80.905,13.805),(80.905,13.635),(80.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.635),(81.095,13.805),(81.265,13.805),(81.265,13.635),(81.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.635),(81.455,13.805),(81.625,13.805),(81.625,13.635),(81.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.995),(80.375,14.165),(80.545,14.165),(80.545,13.995),(80.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.995),(80.735,14.165),(80.905,14.165),(80.905,13.995),(80.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.995),(81.095,14.165),(81.265,14.165),(81.265,13.995),(81.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.995),(81.455,14.165),(81.625,14.165),(81.625,13.995),(81.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.355),(80.375,14.525),(80.545,14.525),(80.545,14.355),(80.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.355),(80.735,14.525),(80.905,14.525),(80.905,14.355),(80.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.355),(81.095,14.525),(81.265,14.525),(81.265,14.355),(81.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.355),(81.455,14.525),(81.625,14.525),(81.625,14.355),(81.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.715),(80.375,14.885),(80.545,14.885),(80.545,14.715),(80.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.715),(80.735,14.885),(80.905,14.885),(80.905,14.715),(80.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.715),(81.095,14.885),(81.265,14.885),(81.265,14.715),(81.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.715),(81.455,14.885),(81.625,14.885),(81.625,14.715),(81.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.075),(80.375,15.245),(80.545,15.245),(80.545,15.075),(80.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.075),(80.735,15.245),(80.905,15.245),(80.905,15.075),(80.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.075),(81.095,15.245),(81.265,15.245),(81.265,15.075),(81.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.075),(81.455,15.245),(81.625,15.245),(81.625,15.075),(81.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.435),(80.375,15.605),(80.545,15.605),(80.545,15.435),(80.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.435),(80.735,15.605),(80.905,15.605),(80.905,15.435),(80.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.435),(81.095,15.605),(81.265,15.605),(81.265,15.435),(81.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.435),(81.455,15.605),(81.625,15.605),(81.625,15.435),(81.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.795),(80.375,15.965),(80.545,15.965),(80.545,15.795),(80.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.795),(80.735,15.965),(80.905,15.965),(80.905,15.795),(80.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.795),(81.095,15.965),(81.265,15.965),(81.265,15.795),(81.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.795),(81.455,15.965),(81.625,15.965),(81.625,15.795),(81.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.155),(80.375,16.325),(80.545,16.325),(80.545,16.155),(80.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.155),(80.735,16.325),(80.905,16.325),(80.905,16.155),(80.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.155),(81.095,16.325),(81.265,16.325),(81.265,16.155),(81.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.155),(81.455,16.325),(81.625,16.325),(81.625,16.155),(81.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.515),(80.375,16.685),(80.545,16.685),(80.545,16.515),(80.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.515),(80.735,16.685),(80.905,16.685),(80.905,16.515),(80.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.515),(81.095,16.685),(81.265,16.685),(81.265,16.515),(81.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.515),(81.455,16.685),(81.625,16.685),(81.625,16.515),(81.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.875),(80.375,17.045),(80.545,17.045),(80.545,16.875),(80.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.875),(80.735,17.045),(80.905,17.045),(80.905,16.875),(80.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.875),(81.095,17.045),(81.265,17.045),(81.265,16.875),(81.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.875),(81.455,17.045),(81.625,17.045),(81.625,16.875),(81.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.235),(80.375,17.405),(80.545,17.405),(80.545,17.235),(80.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.235),(80.735,17.405),(80.905,17.405),(80.905,17.235),(80.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.235),(81.095,17.405),(81.265,17.405),(81.265,17.235),(81.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.235),(81.455,17.405),(81.625,17.405),(81.625,17.235),(81.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.595),(80.375,17.765),(80.545,17.765),(80.545,17.595),(80.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.595),(80.735,17.765),(80.905,17.765),(80.905,17.595),(80.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.595),(81.095,17.765),(81.265,17.765),(81.265,17.595),(81.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.595),(81.455,17.765),(81.625,17.765),(81.625,17.595),(81.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.955),(80.375,18.125),(80.545,18.125),(80.545,17.955),(80.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.955),(80.735,18.125),(80.905,18.125),(80.905,17.955),(80.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.955),(81.095,18.125),(81.265,18.125),(81.265,17.955),(81.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.955),(81.455,18.125),(81.625,18.125),(81.625,17.955),(81.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.315),(80.375,18.485),(80.545,18.485),(80.545,18.315),(80.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.315),(80.735,18.485),(80.905,18.485),(80.905,18.315),(80.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.315),(81.095,18.485),(81.265,18.485),(81.265,18.315),(81.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.315),(81.455,18.485),(81.625,18.485),(81.625,18.315),(81.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.675),(80.375,18.845),(80.545,18.845),(80.545,18.675),(80.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.675),(80.735,18.845),(80.905,18.845),(80.905,18.675),(80.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.675),(81.095,18.845),(81.265,18.845),(81.265,18.675),(81.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.675),(81.455,18.845),(81.625,18.845),(81.625,18.675),(81.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.035),(80.375,19.205),(80.545,19.205),(80.545,19.035),(80.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.035),(80.735,19.205),(80.905,19.205),(80.905,19.035),(80.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.035),(81.095,19.205),(81.265,19.205),(81.265,19.035),(81.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.035),(81.455,19.205),(81.625,19.205),(81.625,19.035),(81.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.395),(80.375,19.565),(80.545,19.565),(80.545,19.395),(80.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.395),(80.735,19.565),(80.905,19.565),(80.905,19.395),(80.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.395),(81.095,19.565),(81.265,19.565),(81.265,19.395),(81.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.395),(81.455,19.565),(81.625,19.565),(81.625,19.395),(81.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.755),(80.375,19.925),(80.545,19.925),(80.545,19.755),(80.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.755),(80.735,19.925),(80.905,19.925),(80.905,19.755),(80.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.755),(81.095,19.925),(81.265,19.925),(81.265,19.755),(81.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.755),(81.455,19.925),(81.625,19.925),(81.625,19.755),(81.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,20.115),(80.375,20.285),(80.545,20.285),(80.545,20.115),(80.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,20.115),(80.735,20.285),(80.905,20.285),(80.905,20.115),(80.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,20.115),(81.095,20.285),(81.265,20.285),(81.265,20.115),(81.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,20.115),(81.455,20.285),(81.625,20.285),(81.625,20.115),(81.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,20.475),(80.375,20.645),(80.545,20.645),(80.545,20.475),(80.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,20.475),(80.735,20.645),(80.905,20.645),(80.905,20.475),(80.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,20.475),(81.095,20.645),(81.265,20.645),(81.265,20.475),(81.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,20.475),(81.455,20.645),(81.625,20.645),(81.625,20.475),(81.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,20.835),(80.375,21.005),(80.545,21.005),(80.545,20.835),(80.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,20.835),(80.735,21.005),(80.905,21.005),(80.905,20.835),(80.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,20.835),(81.095,21.005),(81.265,21.005),(81.265,20.835),(81.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,20.835),(81.455,21.005),(81.625,21.005),(81.625,20.835),(81.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,21.195),(80.375,21.365),(80.545,21.365),(80.545,21.195),(80.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,21.195),(80.735,21.365),(80.905,21.365),(80.905,21.195),(80.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,21.195),(81.095,21.365),(81.265,21.365),(81.265,21.195),(81.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,21.195),(81.455,21.365),(81.625,21.365),(81.625,21.195),(81.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,21.555),(80.375,21.725),(80.545,21.725),(80.545,21.555),(80.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,21.555),(80.735,21.725),(80.905,21.725),(80.905,21.555),(80.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,21.555),(81.095,21.725),(81.265,21.725),(81.265,21.555),(81.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,21.555),(81.455,21.725),(81.625,21.725),(81.625,21.555),(81.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,21.915),(80.375,22.085),(80.545,22.085),(80.545,21.915),(80.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,21.915),(80.735,22.085),(80.905,22.085),(80.905,21.915),(80.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,21.915),(81.095,22.085),(81.265,22.085),(81.265,21.915),(81.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,21.915),(81.455,22.085),(81.625,22.085),(81.625,21.915),(81.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.275),(80.375,22.445),(80.545,22.445),(80.545,22.275),(80.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.275),(80.735,22.445),(80.905,22.445),(80.905,22.275),(80.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.275),(81.095,22.445),(81.265,22.445),(81.265,22.275),(81.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.275),(81.455,22.445),(81.625,22.445),(81.625,22.275),(81.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.635),(80.375,22.805),(80.545,22.805),(80.545,22.635),(80.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.635),(80.735,22.805),(80.905,22.805),(80.905,22.635),(80.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.635),(81.095,22.805),(81.265,22.805),(81.265,22.635),(81.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.635),(81.455,22.805),(81.625,22.805),(81.625,22.635),(81.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.995),(80.375,23.165),(80.545,23.165),(80.545,22.995),(80.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.995),(80.735,23.165),(80.905,23.165),(80.905,22.995),(80.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.995),(81.095,23.165),(81.265,23.165),(81.265,22.995),(81.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.995),(81.455,23.165),(81.625,23.165),(81.625,22.995),(81.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,23.355),(80.375,23.525),(80.545,23.525),(80.545,23.355),(80.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,23.355),(80.735,23.525),(80.905,23.525),(80.905,23.355),(80.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,23.355),(81.095,23.525),(81.265,23.525),(81.265,23.355),(81.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,23.355),(81.455,23.525),(81.625,23.525),(81.625,23.355),(81.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,23.715),(80.375,23.885),(80.545,23.885),(80.545,23.715),(80.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,23.715),(80.735,23.885),(80.905,23.885),(80.905,23.715),(80.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,23.715),(81.095,23.885),(81.265,23.885),(81.265,23.715),(81.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,23.715),(81.455,23.885),(81.625,23.885),(81.625,23.715),(81.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,24.075),(80.375,24.245),(80.545,24.245),(80.545,24.075),(80.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,24.075),(80.735,24.245),(80.905,24.245),(80.905,24.075),(80.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,24.075),(81.095,24.245),(81.265,24.245),(81.265,24.075),(81.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,24.075),(81.455,24.245),(81.625,24.245),(81.625,24.075),(81.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,24.435),(80.375,24.605),(80.545,24.605),(80.545,24.435),(80.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,24.435),(80.735,24.605),(80.905,24.605),(80.905,24.435),(80.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,24.435),(81.095,24.605),(81.265,24.605),(81.265,24.435),(81.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,24.435),(81.455,24.605),(81.625,24.605),(81.625,24.435),(81.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,24.795),(80.375,24.965),(80.545,24.965),(80.545,24.795),(80.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,24.795),(80.735,24.965),(80.905,24.965),(80.905,24.795),(80.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,24.795),(81.095,24.965),(81.265,24.965),(81.265,24.795),(81.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,24.795),(81.455,24.965),(81.625,24.965),(81.625,24.795),(81.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,25.155),(80.375,25.325),(80.545,25.325),(80.545,25.155),(80.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,25.155),(80.735,25.325),(80.905,25.325),(80.905,25.155),(80.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,25.155),(81.095,25.325),(81.265,25.325),(81.265,25.155),(81.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,25.155),(81.455,25.325),(81.625,25.325),(81.625,25.155),(81.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,25.515),(80.375,25.685),(80.545,25.685),(80.545,25.515),(80.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,25.515),(80.735,25.685),(80.905,25.685),(80.905,25.515),(80.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,25.515),(81.095,25.685),(81.265,25.685),(81.265,25.515),(81.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,25.515),(81.455,25.685),(81.625,25.685),(81.625,25.515),(81.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,25.875),(80.375,26.045),(80.545,26.045),(80.545,25.875),(80.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,25.875),(80.735,26.045),(80.905,26.045),(80.905,25.875),(80.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,25.875),(81.095,26.045),(81.265,26.045),(81.265,25.875),(81.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,25.875),(81.455,26.045),(81.625,26.045),(81.625,25.875),(81.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,26.235),(80.375,26.405),(80.545,26.405),(80.545,26.235),(80.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,26.235),(80.735,26.405),(80.905,26.405),(80.905,26.235),(80.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,26.235),(81.095,26.405),(81.265,26.405),(81.265,26.235),(81.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,26.235),(81.455,26.405),(81.625,26.405),(81.625,26.235),(81.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,26.595),(80.375,26.765),(80.545,26.765),(80.545,26.595),(80.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,26.595),(80.735,26.765),(80.905,26.765),(80.905,26.595),(80.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,26.595),(81.095,26.765),(81.265,26.765),(81.265,26.595),(81.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,26.595),(81.455,26.765),(81.625,26.765),(81.625,26.595),(81.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,26.955),(80.375,27.125),(80.545,27.125),(80.545,26.955),(80.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,26.955),(80.735,27.125),(80.905,27.125),(80.905,26.955),(80.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,26.955),(81.095,27.125),(81.265,27.125),(81.265,26.955),(81.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,26.955),(81.455,27.125),(81.625,27.125),(81.625,26.955),(81.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,27.315),(80.375,27.485),(80.545,27.485),(80.545,27.315),(80.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,27.315),(80.735,27.485),(80.905,27.485),(80.905,27.315),(80.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,27.315),(81.095,27.485),(81.265,27.485),(81.265,27.315),(81.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,27.315),(81.455,27.485),(81.625,27.485),(81.625,27.315),(81.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,27.675),(80.375,27.845),(80.545,27.845),(80.545,27.675),(80.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,27.675),(80.735,27.845),(80.905,27.845),(80.905,27.675),(80.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,27.675),(81.095,27.845),(81.265,27.845),(81.265,27.675),(81.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,27.675),(81.455,27.845),(81.625,27.845),(81.625,27.675),(81.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,28.035),(80.375,28.205),(80.545,28.205),(80.545,28.035),(80.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,28.035),(80.735,28.205),(80.905,28.205),(80.905,28.035),(80.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,28.035),(81.095,28.205),(81.265,28.205),(81.265,28.035),(81.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,28.035),(81.455,28.205),(81.625,28.205),(81.625,28.035),(81.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,28.395),(80.375,28.565),(80.545,28.565),(80.545,28.395),(80.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,28.395),(80.735,28.565),(80.905,28.565),(80.905,28.395),(80.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,28.395),(81.095,28.565),(81.265,28.565),(81.265,28.395),(81.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,28.395),(81.455,28.565),(81.625,28.565),(81.625,28.395),(81.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,28.755),(80.375,28.925),(80.545,28.925),(80.545,28.755),(80.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,28.755),(80.735,28.925),(80.905,28.925),(80.905,28.755),(80.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,28.755),(81.095,28.925),(81.265,28.925),(81.265,28.755),(81.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,28.755),(81.455,28.925),(81.625,28.925),(81.625,28.755),(81.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,29.115),(80.375,29.285),(80.545,29.285),(80.545,29.115),(80.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,29.115),(80.735,29.285),(80.905,29.285),(80.905,29.115),(80.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,29.115),(81.095,29.285),(81.265,29.285),(81.265,29.115),(81.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,29.115),(81.455,29.285),(81.625,29.285),(81.625,29.115),(81.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,29.475),(80.375,29.645),(80.545,29.645),(80.545,29.475),(80.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,29.475),(80.735,29.645),(80.905,29.645),(80.905,29.475),(80.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,29.475),(81.095,29.645),(81.265,29.645),(81.265,29.475),(81.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,29.475),(81.455,29.645),(81.625,29.645),(81.625,29.475),(81.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,29.835),(80.375,30.005),(80.545,30.005),(80.545,29.835),(80.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,29.835),(80.735,30.005),(80.905,30.005),(80.905,29.835),(80.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,29.835),(81.095,30.005),(81.265,30.005),(81.265,29.835),(81.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,29.835),(81.455,30.005),(81.625,30.005),(81.625,29.835),(81.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,30.195),(80.375,30.365),(80.545,30.365),(80.545,30.195),(80.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,30.195),(80.735,30.365),(80.905,30.365),(80.905,30.195),(80.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,30.195),(81.095,30.365),(81.265,30.365),(81.265,30.195),(81.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,30.195),(81.455,30.365),(81.625,30.365),(81.625,30.195),(81.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,30.555),(80.375,30.725),(80.545,30.725),(80.545,30.555),(80.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,30.555),(80.735,30.725),(80.905,30.725),(80.905,30.555),(80.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,30.555),(81.095,30.725),(81.265,30.725),(81.265,30.555),(81.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,30.555),(81.455,30.725),(81.625,30.725),(81.625,30.555),(81.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,30.915),(80.375,31.085),(80.545,31.085),(80.545,30.915),(80.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,30.915),(80.735,31.085),(80.905,31.085),(80.905,30.915),(80.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,30.915),(81.095,31.085),(81.265,31.085),(81.265,30.915),(81.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,30.915),(81.455,31.085),(81.625,31.085),(81.625,30.915),(81.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,31.275),(80.375,31.445),(80.545,31.445),(80.545,31.275),(80.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,31.275),(80.735,31.445),(80.905,31.445),(80.905,31.275),(80.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,31.275),(81.095,31.445),(81.265,31.445),(81.265,31.275),(81.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,31.275),(81.455,31.445),(81.625,31.445),(81.625,31.275),(81.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,31.635),(80.375,31.805),(80.545,31.805),(80.545,31.635),(80.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,31.635),(80.735,31.805),(80.905,31.805),(80.905,31.635),(80.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,31.635),(81.095,31.805),(81.265,31.805),(81.265,31.635),(81.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,31.635),(81.455,31.805),(81.625,31.805),(81.625,31.635),(81.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,31.995),(80.375,32.165),(80.545,32.165),(80.545,31.995),(80.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,31.995),(80.735,32.165),(80.905,32.165),(80.905,31.995),(80.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,31.995),(81.095,32.165),(81.265,32.165),(81.265,31.995),(81.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,31.995),(81.455,32.165),(81.625,32.165),(81.625,31.995),(81.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,32.355),(80.375,32.525),(80.545,32.525),(80.545,32.355),(80.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,32.355),(80.735,32.525),(80.905,32.525),(80.905,32.355),(80.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,32.355),(81.095,32.525),(81.265,32.525),(81.265,32.355),(81.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,32.355),(81.455,32.525),(81.625,32.525),(81.625,32.355),(81.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,32.715),(80.375,32.885),(80.545,32.885),(80.545,32.715),(80.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,32.715),(80.735,32.885),(80.905,32.885),(80.905,32.715),(80.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,32.715),(81.095,32.885),(81.265,32.885),(81.265,32.715),(81.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,32.715),(81.455,32.885),(81.625,32.885),(81.625,32.715),(81.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,33.075),(80.375,33.245),(80.545,33.245),(80.545,33.075),(80.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,33.075),(80.735,33.245),(80.905,33.245),(80.905,33.075),(80.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,33.075),(81.095,33.245),(81.265,33.245),(81.265,33.075),(81.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,33.075),(81.455,33.245),(81.625,33.245),(81.625,33.075),(81.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,33.435),(80.375,33.605),(80.545,33.605),(80.545,33.435),(80.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,33.435),(80.735,33.605),(80.905,33.605),(80.905,33.435),(80.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,33.435),(81.095,33.605),(81.265,33.605),(81.265,33.435),(81.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,33.435),(81.455,33.605),(81.625,33.605),(81.625,33.435),(81.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,33.795),(80.375,33.965),(80.545,33.965),(80.545,33.795),(80.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,33.795),(80.735,33.965),(80.905,33.965),(80.905,33.795),(80.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,33.795),(81.095,33.965),(81.265,33.965),(81.265,33.795),(81.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,33.795),(81.455,33.965),(81.625,33.965),(81.625,33.795),(81.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,34.155),(80.375,34.325),(80.545,34.325),(80.545,34.155),(80.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,34.155),(80.735,34.325),(80.905,34.325),(80.905,34.155),(80.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,34.155),(81.095,34.325),(81.265,34.325),(81.265,34.155),(81.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,34.155),(81.455,34.325),(81.625,34.325),(81.625,34.155),(81.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,34.515),(80.375,34.685),(80.545,34.685),(80.545,34.515),(80.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,34.515),(80.735,34.685),(80.905,34.685),(80.905,34.515),(80.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,34.515),(81.095,34.685),(81.265,34.685),(81.265,34.515),(81.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,34.515),(81.455,34.685),(81.625,34.685),(81.625,34.515),(81.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,34.875),(80.375,35.045),(80.545,35.045),(80.545,34.875),(80.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,34.875),(80.735,35.045),(80.905,35.045),(80.905,34.875),(80.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,34.875),(81.095,35.045),(81.265,35.045),(81.265,34.875),(81.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,34.875),(81.455,35.045),(81.625,35.045),(81.625,34.875),(81.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,35.235),(80.375,35.405),(80.545,35.405),(80.545,35.235),(80.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,35.235),(80.735,35.405),(80.905,35.405),(80.905,35.235),(80.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,35.235),(81.095,35.405),(81.265,35.405),(81.265,35.235),(81.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,35.235),(81.455,35.405),(81.625,35.405),(81.625,35.235),(81.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,35.595),(80.375,35.765),(80.545,35.765),(80.545,35.595),(80.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,35.595),(80.735,35.765),(80.905,35.765),(80.905,35.595),(80.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,35.595),(81.095,35.765),(81.265,35.765),(81.265,35.595),(81.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,35.595),(81.455,35.765),(81.625,35.765),(81.625,35.595),(81.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,35.955),(80.375,36.125),(80.545,36.125),(80.545,35.955),(80.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,35.955),(80.735,36.125),(80.905,36.125),(80.905,35.955),(80.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,35.955),(81.095,36.125),(81.265,36.125),(81.265,35.955),(81.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,35.955),(81.455,36.125),(81.625,36.125),(81.625,35.955),(81.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,36.315),(80.375,36.485),(80.545,36.485),(80.545,36.315),(80.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,36.315),(80.735,36.485),(80.905,36.485),(80.905,36.315),(80.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,36.315),(81.095,36.485),(81.265,36.485),(81.265,36.315),(81.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,36.315),(81.455,36.485),(81.625,36.485),(81.625,36.315),(81.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,36.675),(80.375,36.845),(80.545,36.845),(80.545,36.675),(80.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,36.675),(80.735,36.845),(80.905,36.845),(80.905,36.675),(80.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,36.675),(81.095,36.845),(81.265,36.845),(81.265,36.675),(81.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,36.675),(81.455,36.845),(81.625,36.845),(81.625,36.675),(81.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,37.035),(80.375,37.205),(80.545,37.205),(80.545,37.035),(80.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,37.035),(80.735,37.205),(80.905,37.205),(80.905,37.035),(80.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,37.035),(81.095,37.205),(81.265,37.205),(81.265,37.035),(81.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,37.035),(81.455,37.205),(81.625,37.205),(81.625,37.035),(81.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,37.395),(80.375,37.565),(80.545,37.565),(80.545,37.395),(80.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,37.395),(80.735,37.565),(80.905,37.565),(80.905,37.395),(80.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,37.395),(81.095,37.565),(81.265,37.565),(81.265,37.395),(81.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,37.395),(81.455,37.565),(81.625,37.565),(81.625,37.395),(81.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,37.755),(80.375,37.925),(80.545,37.925),(80.545,37.755),(80.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,37.755),(80.735,37.925),(80.905,37.925),(80.905,37.755),(80.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,37.755),(81.095,37.925),(81.265,37.925),(81.265,37.755),(81.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,37.755),(81.455,37.925),(81.625,37.925),(81.625,37.755),(81.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,38.115),(80.375,38.285),(80.545,38.285),(80.545,38.115),(80.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,38.115),(80.735,38.285),(80.905,38.285),(80.905,38.115),(80.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,38.115),(81.095,38.285),(81.265,38.285),(81.265,38.115),(81.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,38.115),(81.455,38.285),(81.625,38.285),(81.625,38.115),(81.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,38.475),(80.375,38.645),(80.545,38.645),(80.545,38.475),(80.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,38.475),(80.735,38.645),(80.905,38.645),(80.905,38.475),(80.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,38.475),(81.095,38.645),(81.265,38.645),(81.265,38.475),(81.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,38.475),(81.455,38.645),(81.625,38.645),(81.625,38.475),(81.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,38.835),(80.375,39.005),(80.545,39.005),(80.545,38.835),(80.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,38.835),(80.735,39.005),(80.905,39.005),(80.905,38.835),(80.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,38.835),(81.095,39.005),(81.265,39.005),(81.265,38.835),(81.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,38.835),(81.455,39.005),(81.625,39.005),(81.625,38.835),(81.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,39.195),(80.375,39.365),(80.545,39.365),(80.545,39.195),(80.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,39.195),(80.735,39.365),(80.905,39.365),(80.905,39.195),(80.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,39.195),(81.095,39.365),(81.265,39.365),(81.265,39.195),(81.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,39.195),(81.455,39.365),(81.625,39.365),(81.625,39.195),(81.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,39.555),(80.375,39.725),(80.545,39.725),(80.545,39.555),(80.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,39.555),(80.735,39.725),(80.905,39.725),(80.905,39.555),(80.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,39.555),(81.095,39.725),(81.265,39.725),(81.265,39.555),(81.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,39.555),(81.455,39.725),(81.625,39.725),(81.625,39.555),(81.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,39.915),(80.375,40.085),(80.545,40.085),(80.545,39.915),(80.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,39.915),(80.735,40.085),(80.905,40.085),(80.905,39.915),(80.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,39.915),(81.095,40.085),(81.265,40.085),(81.265,39.915),(81.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,39.915),(81.455,40.085),(81.625,40.085),(81.625,39.915),(81.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,40.275),(80.375,40.445),(80.545,40.445),(80.545,40.275),(80.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,40.275),(80.735,40.445),(80.905,40.445),(80.905,40.275),(80.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,40.275),(81.095,40.445),(81.265,40.445),(81.265,40.275),(81.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,40.275),(81.455,40.445),(81.625,40.445),(81.625,40.275),(81.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,40.635),(80.375,40.805),(80.545,40.805),(80.545,40.635),(80.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,40.635),(80.735,40.805),(80.905,40.805),(80.905,40.635),(80.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,40.635),(81.095,40.805),(81.265,40.805),(81.265,40.635),(81.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,40.635),(81.455,40.805),(81.625,40.805),(81.625,40.635),(81.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.835),(41.975,3.005),(42.145,3.005),(42.145,2.835),(41.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.835),(42.335,3.005),(42.505,3.005),(42.505,2.835),(42.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.835),(42.695,3.005),(42.865,3.005),(42.865,2.835),(42.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.835),(43.055,3.005),(43.225,3.005),(43.225,2.835),(43.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.195),(41.975,3.365),(42.145,3.365),(42.145,3.195),(41.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.195),(42.335,3.365),(42.505,3.365),(42.505,3.195),(42.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.195),(42.695,3.365),(42.865,3.365),(42.865,3.195),(42.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.195),(43.055,3.365),(43.225,3.365),(43.225,3.195),(43.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.555),(41.975,3.725),(42.145,3.725),(42.145,3.555),(41.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.555),(42.335,3.725),(42.505,3.725),(42.505,3.555),(42.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.555),(42.695,3.725),(42.865,3.725),(42.865,3.555),(42.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.555),(43.055,3.725),(43.225,3.725),(43.225,3.555),(43.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.915),(41.975,4.085),(42.145,4.085),(42.145,3.915),(41.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.915),(42.335,4.085),(42.505,4.085),(42.505,3.915),(42.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.915),(42.695,4.085),(42.865,4.085),(42.865,3.915),(42.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.915),(43.055,4.085),(43.225,4.085),(43.225,3.915),(43.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.275),(41.975,4.445),(42.145,4.445),(42.145,4.275),(41.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.275),(42.335,4.445),(42.505,4.445),(42.505,4.275),(42.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.275),(42.695,4.445),(42.865,4.445),(42.865,4.275),(42.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.275),(43.055,4.445),(43.225,4.445),(43.225,4.275),(43.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.635),(41.975,4.805),(42.145,4.805),(42.145,4.635),(41.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.635),(42.335,4.805),(42.505,4.805),(42.505,4.635),(42.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.635),(42.695,4.805),(42.865,4.805),(42.865,4.635),(42.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.635),(43.055,4.805),(43.225,4.805),(43.225,4.635),(43.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.995),(41.975,5.165),(42.145,5.165),(42.145,4.995),(41.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.995),(42.335,5.165),(42.505,5.165),(42.505,4.995),(42.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.995),(42.695,5.165),(42.865,5.165),(42.865,4.995),(42.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.995),(43.055,5.165),(43.225,5.165),(43.225,4.995),(43.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.355),(41.975,5.525),(42.145,5.525),(42.145,5.355),(41.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.355),(42.335,5.525),(42.505,5.525),(42.505,5.355),(42.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.355),(42.695,5.525),(42.865,5.525),(42.865,5.355),(42.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.355),(43.055,5.525),(43.225,5.525),(43.225,5.355),(43.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.715),(41.975,5.885),(42.145,5.885),(42.145,5.715),(41.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.715),(42.335,5.885),(42.505,5.885),(42.505,5.715),(42.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.715),(42.695,5.885),(42.865,5.885),(42.865,5.715),(42.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.715),(43.055,5.885),(43.225,5.885),(43.225,5.715),(43.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.075),(41.975,6.245),(42.145,6.245),(42.145,6.075),(41.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.075),(42.335,6.245),(42.505,6.245),(42.505,6.075),(42.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.075),(42.695,6.245),(42.865,6.245),(42.865,6.075),(42.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.075),(43.055,6.245),(43.225,6.245),(43.225,6.075),(43.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.435),(41.975,6.605),(42.145,6.605),(42.145,6.435),(41.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.435),(42.335,6.605),(42.505,6.605),(42.505,6.435),(42.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.435),(42.695,6.605),(42.865,6.605),(42.865,6.435),(42.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.435),(43.055,6.605),(43.225,6.605),(43.225,6.435),(43.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.795),(41.975,6.965),(42.145,6.965),(42.145,6.795),(41.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.795),(42.335,6.965),(42.505,6.965),(42.505,6.795),(42.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.795),(42.695,6.965),(42.865,6.965),(42.865,6.795),(42.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.795),(43.055,6.965),(43.225,6.965),(43.225,6.795),(43.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.155),(41.975,7.325),(42.145,7.325),(42.145,7.155),(41.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.155),(42.335,7.325),(42.505,7.325),(42.505,7.155),(42.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.155),(42.695,7.325),(42.865,7.325),(42.865,7.155),(42.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.155),(43.055,7.325),(43.225,7.325),(43.225,7.155),(43.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.515),(41.975,7.685),(42.145,7.685),(42.145,7.515),(41.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.515),(42.335,7.685),(42.505,7.685),(42.505,7.515),(42.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.515),(42.695,7.685),(42.865,7.685),(42.865,7.515),(42.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.515),(43.055,7.685),(43.225,7.685),(43.225,7.515),(43.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.875),(41.975,8.045),(42.145,8.045),(42.145,7.875),(41.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.875),(42.335,8.045),(42.505,8.045),(42.505,7.875),(42.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.875),(42.695,8.045),(42.865,8.045),(42.865,7.875),(42.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.875),(43.055,8.045),(43.225,8.045),(43.225,7.875),(43.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.235),(41.975,8.405),(42.145,8.405),(42.145,8.235),(41.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.235),(42.335,8.405),(42.505,8.405),(42.505,8.235),(42.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.235),(42.695,8.405),(42.865,8.405),(42.865,8.235),(42.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.235),(43.055,8.405),(43.225,8.405),(43.225,8.235),(43.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.595),(41.975,8.765),(42.145,8.765),(42.145,8.595),(41.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.595),(42.335,8.765),(42.505,8.765),(42.505,8.595),(42.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.595),(42.695,8.765),(42.865,8.765),(42.865,8.595),(42.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.595),(43.055,8.765),(43.225,8.765),(43.225,8.595),(43.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.955),(41.975,9.125),(42.145,9.125),(42.145,8.955),(41.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.955),(42.335,9.125),(42.505,9.125),(42.505,8.955),(42.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.955),(42.695,9.125),(42.865,9.125),(42.865,8.955),(42.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.955),(43.055,9.125),(43.225,9.125),(43.225,8.955),(43.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.315),(41.975,9.485),(42.145,9.485),(42.145,9.315),(41.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.315),(42.335,9.485),(42.505,9.485),(42.505,9.315),(42.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.315),(42.695,9.485),(42.865,9.485),(42.865,9.315),(42.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.315),(43.055,9.485),(43.225,9.485),(43.225,9.315),(43.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.675),(41.975,9.845),(42.145,9.845),(42.145,9.675),(41.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.675),(42.335,9.845),(42.505,9.845),(42.505,9.675),(42.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.675),(42.695,9.845),(42.865,9.845),(42.865,9.675),(42.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.675),(43.055,9.845),(43.225,9.845),(43.225,9.675),(43.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.035),(41.975,10.205),(42.145,10.205),(42.145,10.035),(41.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.035),(42.335,10.205),(42.505,10.205),(42.505,10.035),(42.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.035),(42.695,10.205),(42.865,10.205),(42.865,10.035),(42.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.035),(43.055,10.205),(43.225,10.205),(43.225,10.035),(43.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.395),(41.975,10.565),(42.145,10.565),(42.145,10.395),(41.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.395),(42.335,10.565),(42.505,10.565),(42.505,10.395),(42.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.395),(42.695,10.565),(42.865,10.565),(42.865,10.395),(42.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.395),(43.055,10.565),(43.225,10.565),(43.225,10.395),(43.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.755),(41.975,10.925),(42.145,10.925),(42.145,10.755),(41.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.755),(42.335,10.925),(42.505,10.925),(42.505,10.755),(42.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.755),(42.695,10.925),(42.865,10.925),(42.865,10.755),(42.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.755),(43.055,10.925),(43.225,10.925),(43.225,10.755),(43.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.115),(41.975,11.285),(42.145,11.285),(42.145,11.115),(41.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.115),(42.335,11.285),(42.505,11.285),(42.505,11.115),(42.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.115),(42.695,11.285),(42.865,11.285),(42.865,11.115),(42.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.115),(43.055,11.285),(43.225,11.285),(43.225,11.115),(43.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.475),(41.975,11.645),(42.145,11.645),(42.145,11.475),(41.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.475),(42.335,11.645),(42.505,11.645),(42.505,11.475),(42.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.475),(42.695,11.645),(42.865,11.645),(42.865,11.475),(42.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.475),(43.055,11.645),(43.225,11.645),(43.225,11.475),(43.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.835),(41.975,12.005),(42.145,12.005),(42.145,11.835),(41.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.835),(42.335,12.005),(42.505,12.005),(42.505,11.835),(42.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.835),(42.695,12.005),(42.865,12.005),(42.865,11.835),(42.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.835),(43.055,12.005),(43.225,12.005),(43.225,11.835),(43.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.195),(41.975,12.365),(42.145,12.365),(42.145,12.195),(41.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.195),(42.335,12.365),(42.505,12.365),(42.505,12.195),(42.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.195),(42.695,12.365),(42.865,12.365),(42.865,12.195),(42.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.195),(43.055,12.365),(43.225,12.365),(43.225,12.195),(43.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.555),(41.975,12.725),(42.145,12.725),(42.145,12.555),(41.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.555),(42.335,12.725),(42.505,12.725),(42.505,12.555),(42.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.555),(42.695,12.725),(42.865,12.725),(42.865,12.555),(42.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.555),(43.055,12.725),(43.225,12.725),(43.225,12.555),(43.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.915),(41.975,13.085),(42.145,13.085),(42.145,12.915),(41.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.915),(42.335,13.085),(42.505,13.085),(42.505,12.915),(42.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.915),(42.695,13.085),(42.865,13.085),(42.865,12.915),(42.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.915),(43.055,13.085),(43.225,13.085),(43.225,12.915),(43.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.275),(41.975,13.445),(42.145,13.445),(42.145,13.275),(41.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.275),(42.335,13.445),(42.505,13.445),(42.505,13.275),(42.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.275),(42.695,13.445),(42.865,13.445),(42.865,13.275),(42.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.275),(43.055,13.445),(43.225,13.445),(43.225,13.275),(43.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.635),(41.975,13.805),(42.145,13.805),(42.145,13.635),(41.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.635),(42.335,13.805),(42.505,13.805),(42.505,13.635),(42.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.635),(42.695,13.805),(42.865,13.805),(42.865,13.635),(42.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.635),(43.055,13.805),(43.225,13.805),(43.225,13.635),(43.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.995),(41.975,14.165),(42.145,14.165),(42.145,13.995),(41.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.995),(42.335,14.165),(42.505,14.165),(42.505,13.995),(42.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.995),(42.695,14.165),(42.865,14.165),(42.865,13.995),(42.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.995),(43.055,14.165),(43.225,14.165),(43.225,13.995),(43.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.355),(41.975,14.525),(42.145,14.525),(42.145,14.355),(41.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.355),(42.335,14.525),(42.505,14.525),(42.505,14.355),(42.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.355),(42.695,14.525),(42.865,14.525),(42.865,14.355),(42.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.355),(43.055,14.525),(43.225,14.525),(43.225,14.355),(43.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.715),(41.975,14.885),(42.145,14.885),(42.145,14.715),(41.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.715),(42.335,14.885),(42.505,14.885),(42.505,14.715),(42.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.715),(42.695,14.885),(42.865,14.885),(42.865,14.715),(42.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.715),(43.055,14.885),(43.225,14.885),(43.225,14.715),(43.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.075),(41.975,15.245),(42.145,15.245),(42.145,15.075),(41.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.075),(42.335,15.245),(42.505,15.245),(42.505,15.075),(42.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.075),(42.695,15.245),(42.865,15.245),(42.865,15.075),(42.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.075),(43.055,15.245),(43.225,15.245),(43.225,15.075),(43.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.435),(41.975,15.605),(42.145,15.605),(42.145,15.435),(41.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.435),(42.335,15.605),(42.505,15.605),(42.505,15.435),(42.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.435),(42.695,15.605),(42.865,15.605),(42.865,15.435),(42.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.435),(43.055,15.605),(43.225,15.605),(43.225,15.435),(43.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.795),(41.975,15.965),(42.145,15.965),(42.145,15.795),(41.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.795),(42.335,15.965),(42.505,15.965),(42.505,15.795),(42.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.795),(42.695,15.965),(42.865,15.965),(42.865,15.795),(42.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.795),(43.055,15.965),(43.225,15.965),(43.225,15.795),(43.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.155),(41.975,16.325),(42.145,16.325),(42.145,16.155),(41.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.155),(42.335,16.325),(42.505,16.325),(42.505,16.155),(42.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.155),(42.695,16.325),(42.865,16.325),(42.865,16.155),(42.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.155),(43.055,16.325),(43.225,16.325),(43.225,16.155),(43.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.515),(41.975,16.685),(42.145,16.685),(42.145,16.515),(41.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.515),(42.335,16.685),(42.505,16.685),(42.505,16.515),(42.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.515),(42.695,16.685),(42.865,16.685),(42.865,16.515),(42.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.515),(43.055,16.685),(43.225,16.685),(43.225,16.515),(43.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.875),(41.975,17.045),(42.145,17.045),(42.145,16.875),(41.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.875),(42.335,17.045),(42.505,17.045),(42.505,16.875),(42.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.875),(42.695,17.045),(42.865,17.045),(42.865,16.875),(42.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.875),(43.055,17.045),(43.225,17.045),(43.225,16.875),(43.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.235),(41.975,17.405),(42.145,17.405),(42.145,17.235),(41.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.235),(42.335,17.405),(42.505,17.405),(42.505,17.235),(42.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.235),(42.695,17.405),(42.865,17.405),(42.865,17.235),(42.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.235),(43.055,17.405),(43.225,17.405),(43.225,17.235),(43.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.595),(41.975,17.765),(42.145,17.765),(42.145,17.595),(41.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.595),(42.335,17.765),(42.505,17.765),(42.505,17.595),(42.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.595),(42.695,17.765),(42.865,17.765),(42.865,17.595),(42.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.595),(43.055,17.765),(43.225,17.765),(43.225,17.595),(43.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.955),(41.975,18.125),(42.145,18.125),(42.145,17.955),(41.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.955),(42.335,18.125),(42.505,18.125),(42.505,17.955),(42.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.955),(42.695,18.125),(42.865,18.125),(42.865,17.955),(42.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.955),(43.055,18.125),(43.225,18.125),(43.225,17.955),(43.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.315),(41.975,18.485),(42.145,18.485),(42.145,18.315),(41.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.315),(42.335,18.485),(42.505,18.485),(42.505,18.315),(42.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.315),(42.695,18.485),(42.865,18.485),(42.865,18.315),(42.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.315),(43.055,18.485),(43.225,18.485),(43.225,18.315),(43.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.675),(41.975,18.845),(42.145,18.845),(42.145,18.675),(41.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.675),(42.335,18.845),(42.505,18.845),(42.505,18.675),(42.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.675),(42.695,18.845),(42.865,18.845),(42.865,18.675),(42.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.675),(43.055,18.845),(43.225,18.845),(43.225,18.675),(43.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.035),(41.975,19.205),(42.145,19.205),(42.145,19.035),(41.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.035),(42.335,19.205),(42.505,19.205),(42.505,19.035),(42.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.035),(42.695,19.205),(42.865,19.205),(42.865,19.035),(42.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.035),(43.055,19.205),(43.225,19.205),(43.225,19.035),(43.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.395),(41.975,19.565),(42.145,19.565),(42.145,19.395),(41.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.395),(42.335,19.565),(42.505,19.565),(42.505,19.395),(42.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.395),(42.695,19.565),(42.865,19.565),(42.865,19.395),(42.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.395),(43.055,19.565),(43.225,19.565),(43.225,19.395),(43.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.755),(41.975,19.925),(42.145,19.925),(42.145,19.755),(41.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.755),(42.335,19.925),(42.505,19.925),(42.505,19.755),(42.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.755),(42.695,19.925),(42.865,19.925),(42.865,19.755),(42.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.755),(43.055,19.925),(43.225,19.925),(43.225,19.755),(43.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.115),(41.975,20.285),(42.145,20.285),(42.145,20.115),(41.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.115),(42.335,20.285),(42.505,20.285),(42.505,20.115),(42.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.115),(42.695,20.285),(42.865,20.285),(42.865,20.115),(42.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.115),(43.055,20.285),(43.225,20.285),(43.225,20.115),(43.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.475),(41.975,20.645),(42.145,20.645),(42.145,20.475),(41.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.475),(42.335,20.645),(42.505,20.645),(42.505,20.475),(42.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.475),(42.695,20.645),(42.865,20.645),(42.865,20.475),(42.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.475),(43.055,20.645),(43.225,20.645),(43.225,20.475),(43.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.835),(41.975,21.005),(42.145,21.005),(42.145,20.835),(41.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.835),(42.335,21.005),(42.505,21.005),(42.505,20.835),(42.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.835),(42.695,21.005),(42.865,21.005),(42.865,20.835),(42.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.835),(43.055,21.005),(43.225,21.005),(43.225,20.835),(43.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.195),(41.975,21.365),(42.145,21.365),(42.145,21.195),(41.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.195),(42.335,21.365),(42.505,21.365),(42.505,21.195),(42.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.195),(42.695,21.365),(42.865,21.365),(42.865,21.195),(42.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.195),(43.055,21.365),(43.225,21.365),(43.225,21.195),(43.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.555),(41.975,21.725),(42.145,21.725),(42.145,21.555),(41.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.555),(42.335,21.725),(42.505,21.725),(42.505,21.555),(42.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.555),(42.695,21.725),(42.865,21.725),(42.865,21.555),(42.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.555),(43.055,21.725),(43.225,21.725),(43.225,21.555),(43.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.915),(41.975,22.085),(42.145,22.085),(42.145,21.915),(41.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.915),(42.335,22.085),(42.505,22.085),(42.505,21.915),(42.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.915),(42.695,22.085),(42.865,22.085),(42.865,21.915),(42.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.915),(43.055,22.085),(43.225,22.085),(43.225,21.915),(43.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.275),(41.975,22.445),(42.145,22.445),(42.145,22.275),(41.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.275),(42.335,22.445),(42.505,22.445),(42.505,22.275),(42.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.275),(42.695,22.445),(42.865,22.445),(42.865,22.275),(42.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.275),(43.055,22.445),(43.225,22.445),(43.225,22.275),(43.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.635),(41.975,22.805),(42.145,22.805),(42.145,22.635),(41.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.635),(42.335,22.805),(42.505,22.805),(42.505,22.635),(42.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.635),(42.695,22.805),(42.865,22.805),(42.865,22.635),(42.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.635),(43.055,22.805),(43.225,22.805),(43.225,22.635),(43.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.995),(41.975,23.165),(42.145,23.165),(42.145,22.995),(41.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.995),(42.335,23.165),(42.505,23.165),(42.505,22.995),(42.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.995),(42.695,23.165),(42.865,23.165),(42.865,22.995),(42.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.995),(43.055,23.165),(43.225,23.165),(43.225,22.995),(43.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,23.355),(41.975,23.525),(42.145,23.525),(42.145,23.355),(41.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,23.355),(42.335,23.525),(42.505,23.525),(42.505,23.355),(42.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,23.355),(42.695,23.525),(42.865,23.525),(42.865,23.355),(42.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,23.355),(43.055,23.525),(43.225,23.525),(43.225,23.355),(43.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,23.715),(41.975,23.885),(42.145,23.885),(42.145,23.715),(41.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,23.715),(42.335,23.885),(42.505,23.885),(42.505,23.715),(42.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,23.715),(42.695,23.885),(42.865,23.885),(42.865,23.715),(42.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,23.715),(43.055,23.885),(43.225,23.885),(43.225,23.715),(43.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.075),(41.975,24.245),(42.145,24.245),(42.145,24.075),(41.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.075),(42.335,24.245),(42.505,24.245),(42.505,24.075),(42.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.075),(42.695,24.245),(42.865,24.245),(42.865,24.075),(42.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.075),(43.055,24.245),(43.225,24.245),(43.225,24.075),(43.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.435),(41.975,24.605),(42.145,24.605),(42.145,24.435),(41.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.435),(42.335,24.605),(42.505,24.605),(42.505,24.435),(42.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.435),(42.695,24.605),(42.865,24.605),(42.865,24.435),(42.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.435),(43.055,24.605),(43.225,24.605),(43.225,24.435),(43.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.795),(41.975,24.965),(42.145,24.965),(42.145,24.795),(41.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.795),(42.335,24.965),(42.505,24.965),(42.505,24.795),(42.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.795),(42.695,24.965),(42.865,24.965),(42.865,24.795),(42.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.795),(43.055,24.965),(43.225,24.965),(43.225,24.795),(43.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.155),(41.975,25.325),(42.145,25.325),(42.145,25.155),(41.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.155),(42.335,25.325),(42.505,25.325),(42.505,25.155),(42.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.155),(42.695,25.325),(42.865,25.325),(42.865,25.155),(42.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.155),(43.055,25.325),(43.225,25.325),(43.225,25.155),(43.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.515),(41.975,25.685),(42.145,25.685),(42.145,25.515),(41.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.515),(42.335,25.685),(42.505,25.685),(42.505,25.515),(42.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.515),(42.695,25.685),(42.865,25.685),(42.865,25.515),(42.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.515),(43.055,25.685),(43.225,25.685),(43.225,25.515),(43.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.875),(41.975,26.045),(42.145,26.045),(42.145,25.875),(41.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.875),(42.335,26.045),(42.505,26.045),(42.505,25.875),(42.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.875),(42.695,26.045),(42.865,26.045),(42.865,25.875),(42.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.875),(43.055,26.045),(43.225,26.045),(43.225,25.875),(43.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.235),(41.975,26.405),(42.145,26.405),(42.145,26.235),(41.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.235),(42.335,26.405),(42.505,26.405),(42.505,26.235),(42.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.235),(42.695,26.405),(42.865,26.405),(42.865,26.235),(42.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.235),(43.055,26.405),(43.225,26.405),(43.225,26.235),(43.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.595),(41.975,26.765),(42.145,26.765),(42.145,26.595),(41.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.595),(42.335,26.765),(42.505,26.765),(42.505,26.595),(42.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.595),(42.695,26.765),(42.865,26.765),(42.865,26.595),(42.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.595),(43.055,26.765),(43.225,26.765),(43.225,26.595),(43.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.955),(41.975,27.125),(42.145,27.125),(42.145,26.955),(41.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.955),(42.335,27.125),(42.505,27.125),(42.505,26.955),(42.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.955),(42.695,27.125),(42.865,27.125),(42.865,26.955),(42.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.955),(43.055,27.125),(43.225,27.125),(43.225,26.955),(43.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,27.315),(41.975,27.485),(42.145,27.485),(42.145,27.315),(41.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,27.315),(42.335,27.485),(42.505,27.485),(42.505,27.315),(42.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,27.315),(42.695,27.485),(42.865,27.485),(42.865,27.315),(42.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,27.315),(43.055,27.485),(43.225,27.485),(43.225,27.315),(43.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,27.675),(41.975,27.845),(42.145,27.845),(42.145,27.675),(41.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,27.675),(42.335,27.845),(42.505,27.845),(42.505,27.675),(42.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,27.675),(42.695,27.845),(42.865,27.845),(42.865,27.675),(42.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,27.675),(43.055,27.845),(43.225,27.845),(43.225,27.675),(43.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.035),(41.975,28.205),(42.145,28.205),(42.145,28.035),(41.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.035),(42.335,28.205),(42.505,28.205),(42.505,28.035),(42.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.035),(42.695,28.205),(42.865,28.205),(42.865,28.035),(42.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.035),(43.055,28.205),(43.225,28.205),(43.225,28.035),(43.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.395),(41.975,28.565),(42.145,28.565),(42.145,28.395),(41.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.395),(42.335,28.565),(42.505,28.565),(42.505,28.395),(42.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.395),(42.695,28.565),(42.865,28.565),(42.865,28.395),(42.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.395),(43.055,28.565),(43.225,28.565),(43.225,28.395),(43.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.755),(41.975,28.925),(42.145,28.925),(42.145,28.755),(41.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.755),(42.335,28.925),(42.505,28.925),(42.505,28.755),(42.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.755),(42.695,28.925),(42.865,28.925),(42.865,28.755),(42.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.755),(43.055,28.925),(43.225,28.925),(43.225,28.755),(43.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.115),(41.975,29.285),(42.145,29.285),(42.145,29.115),(41.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.115),(42.335,29.285),(42.505,29.285),(42.505,29.115),(42.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.115),(42.695,29.285),(42.865,29.285),(42.865,29.115),(42.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.115),(43.055,29.285),(43.225,29.285),(43.225,29.115),(43.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.475),(41.975,29.645),(42.145,29.645),(42.145,29.475),(41.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.475),(42.335,29.645),(42.505,29.645),(42.505,29.475),(42.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.475),(42.695,29.645),(42.865,29.645),(42.865,29.475),(42.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.475),(43.055,29.645),(43.225,29.645),(43.225,29.475),(43.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.835),(41.975,30.005),(42.145,30.005),(42.145,29.835),(41.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.835),(42.335,30.005),(42.505,30.005),(42.505,29.835),(42.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.835),(42.695,30.005),(42.865,30.005),(42.865,29.835),(42.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.835),(43.055,30.005),(43.225,30.005),(43.225,29.835),(43.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.195),(41.975,30.365),(42.145,30.365),(42.145,30.195),(41.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.195),(42.335,30.365),(42.505,30.365),(42.505,30.195),(42.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.195),(42.695,30.365),(42.865,30.365),(42.865,30.195),(42.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.195),(43.055,30.365),(43.225,30.365),(43.225,30.195),(43.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.555),(41.975,30.725),(42.145,30.725),(42.145,30.555),(41.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.555),(42.335,30.725),(42.505,30.725),(42.505,30.555),(42.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.555),(42.695,30.725),(42.865,30.725),(42.865,30.555),(42.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.555),(43.055,30.725),(43.225,30.725),(43.225,30.555),(43.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.915),(41.975,31.085),(42.145,31.085),(42.145,30.915),(41.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.915),(42.335,31.085),(42.505,31.085),(42.505,30.915),(42.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.915),(42.695,31.085),(42.865,31.085),(42.865,30.915),(42.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.915),(43.055,31.085),(43.225,31.085),(43.225,30.915),(43.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.275),(41.975,31.445),(42.145,31.445),(42.145,31.275),(41.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.275),(42.335,31.445),(42.505,31.445),(42.505,31.275),(42.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.275),(42.695,31.445),(42.865,31.445),(42.865,31.275),(42.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.275),(43.055,31.445),(43.225,31.445),(43.225,31.275),(43.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.635),(41.975,31.805),(42.145,31.805),(42.145,31.635),(41.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.635),(42.335,31.805),(42.505,31.805),(42.505,31.635),(42.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.635),(42.695,31.805),(42.865,31.805),(42.865,31.635),(42.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.635),(43.055,31.805),(43.225,31.805),(43.225,31.635),(43.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.995),(41.975,32.165),(42.145,32.165),(42.145,31.995),(41.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.995),(42.335,32.165),(42.505,32.165),(42.505,31.995),(42.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.995),(42.695,32.165),(42.865,32.165),(42.865,31.995),(42.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.995),(43.055,32.165),(43.225,32.165),(43.225,31.995),(43.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,32.355),(41.975,32.525),(42.145,32.525),(42.145,32.355),(41.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,32.355),(42.335,32.525),(42.505,32.525),(42.505,32.355),(42.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,32.355),(42.695,32.525),(42.865,32.525),(42.865,32.355),(42.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,32.355),(43.055,32.525),(43.225,32.525),(43.225,32.355),(43.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,32.715),(41.975,32.885),(42.145,32.885),(42.145,32.715),(41.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,32.715),(42.335,32.885),(42.505,32.885),(42.505,32.715),(42.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,32.715),(42.695,32.885),(42.865,32.885),(42.865,32.715),(42.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,32.715),(43.055,32.885),(43.225,32.885),(43.225,32.715),(43.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.075),(41.975,33.245),(42.145,33.245),(42.145,33.075),(41.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.075),(42.335,33.245),(42.505,33.245),(42.505,33.075),(42.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.075),(42.695,33.245),(42.865,33.245),(42.865,33.075),(42.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.075),(43.055,33.245),(43.225,33.245),(43.225,33.075),(43.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.435),(41.975,33.605),(42.145,33.605),(42.145,33.435),(41.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.435),(42.335,33.605),(42.505,33.605),(42.505,33.435),(42.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.435),(42.695,33.605),(42.865,33.605),(42.865,33.435),(42.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.435),(43.055,33.605),(43.225,33.605),(43.225,33.435),(43.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.795),(41.975,33.965),(42.145,33.965),(42.145,33.795),(41.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.795),(42.335,33.965),(42.505,33.965),(42.505,33.795),(42.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.795),(42.695,33.965),(42.865,33.965),(42.865,33.795),(42.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.795),(43.055,33.965),(43.225,33.965),(43.225,33.795),(43.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.155),(41.975,34.325),(42.145,34.325),(42.145,34.155),(41.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.155),(42.335,34.325),(42.505,34.325),(42.505,34.155),(42.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.155),(42.695,34.325),(42.865,34.325),(42.865,34.155),(42.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.155),(43.055,34.325),(43.225,34.325),(43.225,34.155),(43.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.515),(41.975,34.685),(42.145,34.685),(42.145,34.515),(41.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.515),(42.335,34.685),(42.505,34.685),(42.505,34.515),(42.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.515),(42.695,34.685),(42.865,34.685),(42.865,34.515),(42.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.515),(43.055,34.685),(43.225,34.685),(43.225,34.515),(43.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.875),(41.975,35.045),(42.145,35.045),(42.145,34.875),(41.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.875),(42.335,35.045),(42.505,35.045),(42.505,34.875),(42.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.875),(42.695,35.045),(42.865,35.045),(42.865,34.875),(42.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.875),(43.055,35.045),(43.225,35.045),(43.225,34.875),(43.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.235),(41.975,35.405),(42.145,35.405),(42.145,35.235),(41.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.235),(42.335,35.405),(42.505,35.405),(42.505,35.235),(42.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.235),(42.695,35.405),(42.865,35.405),(42.865,35.235),(42.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.235),(43.055,35.405),(43.225,35.405),(43.225,35.235),(43.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.595),(41.975,35.765),(42.145,35.765),(42.145,35.595),(41.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.595),(42.335,35.765),(42.505,35.765),(42.505,35.595),(42.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.595),(42.695,35.765),(42.865,35.765),(42.865,35.595),(42.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.595),(43.055,35.765),(43.225,35.765),(43.225,35.595),(43.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.955),(41.975,36.125),(42.145,36.125),(42.145,35.955),(41.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.955),(42.335,36.125),(42.505,36.125),(42.505,35.955),(42.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.955),(42.695,36.125),(42.865,36.125),(42.865,35.955),(42.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.955),(43.055,36.125),(43.225,36.125),(43.225,35.955),(43.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,36.315),(41.975,36.485),(42.145,36.485),(42.145,36.315),(41.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,36.315),(42.335,36.485),(42.505,36.485),(42.505,36.315),(42.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,36.315),(42.695,36.485),(42.865,36.485),(42.865,36.315),(42.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,36.315),(43.055,36.485),(43.225,36.485),(43.225,36.315),(43.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,36.675),(41.975,36.845),(42.145,36.845),(42.145,36.675),(41.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,36.675),(42.335,36.845),(42.505,36.845),(42.505,36.675),(42.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,36.675),(42.695,36.845),(42.865,36.845),(42.865,36.675),(42.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,36.675),(43.055,36.845),(43.225,36.845),(43.225,36.675),(43.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.035),(41.975,37.205),(42.145,37.205),(42.145,37.035),(41.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.035),(42.335,37.205),(42.505,37.205),(42.505,37.035),(42.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.035),(42.695,37.205),(42.865,37.205),(42.865,37.035),(42.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.035),(43.055,37.205),(43.225,37.205),(43.225,37.035),(43.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.395),(41.975,37.565),(42.145,37.565),(42.145,37.395),(41.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.395),(42.335,37.565),(42.505,37.565),(42.505,37.395),(42.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.395),(42.695,37.565),(42.865,37.565),(42.865,37.395),(42.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.395),(43.055,37.565),(43.225,37.565),(43.225,37.395),(43.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.755),(41.975,37.925),(42.145,37.925),(42.145,37.755),(41.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.755),(42.335,37.925),(42.505,37.925),(42.505,37.755),(42.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.755),(42.695,37.925),(42.865,37.925),(42.865,37.755),(42.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.755),(43.055,37.925),(43.225,37.925),(43.225,37.755),(43.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.115),(41.975,38.285),(42.145,38.285),(42.145,38.115),(41.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.115),(42.335,38.285),(42.505,38.285),(42.505,38.115),(42.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.115),(42.695,38.285),(42.865,38.285),(42.865,38.115),(42.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.115),(43.055,38.285),(43.225,38.285),(43.225,38.115),(43.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.475),(41.975,38.645),(42.145,38.645),(42.145,38.475),(41.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.475),(42.335,38.645),(42.505,38.645),(42.505,38.475),(42.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.475),(42.695,38.645),(42.865,38.645),(42.865,38.475),(42.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.475),(43.055,38.645),(43.225,38.645),(43.225,38.475),(43.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.835),(41.975,39.005),(42.145,39.005),(42.145,38.835),(41.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.835),(42.335,39.005),(42.505,39.005),(42.505,38.835),(42.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.835),(42.695,39.005),(42.865,39.005),(42.865,38.835),(42.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.835),(43.055,39.005),(43.225,39.005),(43.225,38.835),(43.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.195),(41.975,39.365),(42.145,39.365),(42.145,39.195),(41.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.195),(42.335,39.365),(42.505,39.365),(42.505,39.195),(42.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.195),(42.695,39.365),(42.865,39.365),(42.865,39.195),(42.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.195),(43.055,39.365),(43.225,39.365),(43.225,39.195),(43.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.555),(41.975,39.725),(42.145,39.725),(42.145,39.555),(41.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.555),(42.335,39.725),(42.505,39.725),(42.505,39.555),(42.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.555),(42.695,39.725),(42.865,39.725),(42.865,39.555),(42.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.555),(43.055,39.725),(43.225,39.725),(43.225,39.555),(43.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.915),(41.975,40.085),(42.145,40.085),(42.145,39.915),(41.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.915),(42.335,40.085),(42.505,40.085),(42.505,39.915),(42.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.915),(42.695,40.085),(42.865,40.085),(42.865,39.915),(42.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.915),(43.055,40.085),(43.225,40.085),(43.225,39.915),(43.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,40.275),(41.975,40.445),(42.145,40.445),(42.145,40.275),(41.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,40.275),(42.335,40.445),(42.505,40.445),(42.505,40.275),(42.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,40.275),(42.695,40.445),(42.865,40.445),(42.865,40.275),(42.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,40.275),(43.055,40.445),(43.225,40.445),(43.225,40.275),(43.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,40.635),(41.975,40.805),(42.145,40.805),(42.145,40.635),(41.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,40.635),(42.335,40.805),(42.505,40.805),(42.505,40.635),(42.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,40.635),(42.695,40.805),(42.865,40.805),(42.865,40.635),(42.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,40.635),(43.055,40.805),(43.225,40.805),(43.225,40.635),(43.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,2.835),(70.775,3.005),(70.945,3.005),(70.945,2.835),(70.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,2.835),(71.135,3.005),(71.305,3.005),(71.305,2.835),(71.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,2.835),(71.495,3.005),(71.665,3.005),(71.665,2.835),(71.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,2.835),(71.855,3.005),(72.025,3.005),(72.025,2.835),(71.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.195),(70.775,3.365),(70.945,3.365),(70.945,3.195),(70.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.195),(71.135,3.365),(71.305,3.365),(71.305,3.195),(71.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.195),(71.495,3.365),(71.665,3.365),(71.665,3.195),(71.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.195),(71.855,3.365),(72.025,3.365),(72.025,3.195),(71.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.555),(70.775,3.725),(70.945,3.725),(70.945,3.555),(70.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.555),(71.135,3.725),(71.305,3.725),(71.305,3.555),(71.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.555),(71.495,3.725),(71.665,3.725),(71.665,3.555),(71.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.555),(71.855,3.725),(72.025,3.725),(72.025,3.555),(71.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.915),(70.775,4.085),(70.945,4.085),(70.945,3.915),(70.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.915),(71.135,4.085),(71.305,4.085),(71.305,3.915),(71.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.915),(71.495,4.085),(71.665,4.085),(71.665,3.915),(71.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.915),(71.855,4.085),(72.025,4.085),(72.025,3.915),(71.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.275),(70.775,4.445),(70.945,4.445),(70.945,4.275),(70.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.275),(71.135,4.445),(71.305,4.445),(71.305,4.275),(71.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.275),(71.495,4.445),(71.665,4.445),(71.665,4.275),(71.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.275),(71.855,4.445),(72.025,4.445),(72.025,4.275),(71.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.635),(70.775,4.805),(70.945,4.805),(70.945,4.635),(70.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.635),(71.135,4.805),(71.305,4.805),(71.305,4.635),(71.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.635),(71.495,4.805),(71.665,4.805),(71.665,4.635),(71.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.635),(71.855,4.805),(72.025,4.805),(72.025,4.635),(71.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.995),(70.775,5.165),(70.945,5.165),(70.945,4.995),(70.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.995),(71.135,5.165),(71.305,5.165),(71.305,4.995),(71.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.995),(71.495,5.165),(71.665,5.165),(71.665,4.995),(71.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.995),(71.855,5.165),(72.025,5.165),(72.025,4.995),(71.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.355),(70.775,5.525),(70.945,5.525),(70.945,5.355),(70.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.355),(71.135,5.525),(71.305,5.525),(71.305,5.355),(71.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.355),(71.495,5.525),(71.665,5.525),(71.665,5.355),(71.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.355),(71.855,5.525),(72.025,5.525),(72.025,5.355),(71.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.715),(70.775,5.885),(70.945,5.885),(70.945,5.715),(70.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.715),(71.135,5.885),(71.305,5.885),(71.305,5.715),(71.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.715),(71.495,5.885),(71.665,5.885),(71.665,5.715),(71.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.715),(71.855,5.885),(72.025,5.885),(72.025,5.715),(71.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.075),(70.775,6.245),(70.945,6.245),(70.945,6.075),(70.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.075),(71.135,6.245),(71.305,6.245),(71.305,6.075),(71.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.075),(71.495,6.245),(71.665,6.245),(71.665,6.075),(71.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.075),(71.855,6.245),(72.025,6.245),(72.025,6.075),(71.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.435),(70.775,6.605),(70.945,6.605),(70.945,6.435),(70.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.435),(71.135,6.605),(71.305,6.605),(71.305,6.435),(71.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.435),(71.495,6.605),(71.665,6.605),(71.665,6.435),(71.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.435),(71.855,6.605),(72.025,6.605),(72.025,6.435),(71.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.795),(70.775,6.965),(70.945,6.965),(70.945,6.795),(70.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.795),(71.135,6.965),(71.305,6.965),(71.305,6.795),(71.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.795),(71.495,6.965),(71.665,6.965),(71.665,6.795),(71.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.795),(71.855,6.965),(72.025,6.965),(72.025,6.795),(71.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.155),(70.775,7.325),(70.945,7.325),(70.945,7.155),(70.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.155),(71.135,7.325),(71.305,7.325),(71.305,7.155),(71.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.155),(71.495,7.325),(71.665,7.325),(71.665,7.155),(71.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.155),(71.855,7.325),(72.025,7.325),(72.025,7.155),(71.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.515),(70.775,7.685),(70.945,7.685),(70.945,7.515),(70.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.515),(71.135,7.685),(71.305,7.685),(71.305,7.515),(71.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.515),(71.495,7.685),(71.665,7.685),(71.665,7.515),(71.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.515),(71.855,7.685),(72.025,7.685),(72.025,7.515),(71.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.875),(70.775,8.045),(70.945,8.045),(70.945,7.875),(70.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.875),(71.135,8.045),(71.305,8.045),(71.305,7.875),(71.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.875),(71.495,8.045),(71.665,8.045),(71.665,7.875),(71.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.875),(71.855,8.045),(72.025,8.045),(72.025,7.875),(71.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.235),(70.775,8.405),(70.945,8.405),(70.945,8.235),(70.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.235),(71.135,8.405),(71.305,8.405),(71.305,8.235),(71.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.235),(71.495,8.405),(71.665,8.405),(71.665,8.235),(71.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.235),(71.855,8.405),(72.025,8.405),(72.025,8.235),(71.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.595),(70.775,8.765),(70.945,8.765),(70.945,8.595),(70.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.595),(71.135,8.765),(71.305,8.765),(71.305,8.595),(71.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.595),(71.495,8.765),(71.665,8.765),(71.665,8.595),(71.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.595),(71.855,8.765),(72.025,8.765),(72.025,8.595),(71.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.955),(70.775,9.125),(70.945,9.125),(70.945,8.955),(70.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.955),(71.135,9.125),(71.305,9.125),(71.305,8.955),(71.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.955),(71.495,9.125),(71.665,9.125),(71.665,8.955),(71.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.955),(71.855,9.125),(72.025,9.125),(72.025,8.955),(71.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.315),(70.775,9.485),(70.945,9.485),(70.945,9.315),(70.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.315),(71.135,9.485),(71.305,9.485),(71.305,9.315),(71.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.315),(71.495,9.485),(71.665,9.485),(71.665,9.315),(71.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.315),(71.855,9.485),(72.025,9.485),(72.025,9.315),(71.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.675),(70.775,9.845),(70.945,9.845),(70.945,9.675),(70.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.675),(71.135,9.845),(71.305,9.845),(71.305,9.675),(71.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.675),(71.495,9.845),(71.665,9.845),(71.665,9.675),(71.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.675),(71.855,9.845),(72.025,9.845),(72.025,9.675),(71.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.035),(70.775,10.205),(70.945,10.205),(70.945,10.035),(70.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.035),(71.135,10.205),(71.305,10.205),(71.305,10.035),(71.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.035),(71.495,10.205),(71.665,10.205),(71.665,10.035),(71.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.035),(71.855,10.205),(72.025,10.205),(72.025,10.035),(71.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.395),(70.775,10.565),(70.945,10.565),(70.945,10.395),(70.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.395),(71.135,10.565),(71.305,10.565),(71.305,10.395),(71.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.395),(71.495,10.565),(71.665,10.565),(71.665,10.395),(71.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.395),(71.855,10.565),(72.025,10.565),(72.025,10.395),(71.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.755),(70.775,10.925),(70.945,10.925),(70.945,10.755),(70.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.755),(71.135,10.925),(71.305,10.925),(71.305,10.755),(71.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.755),(71.495,10.925),(71.665,10.925),(71.665,10.755),(71.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.755),(71.855,10.925),(72.025,10.925),(72.025,10.755),(71.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.115),(70.775,11.285),(70.945,11.285),(70.945,11.115),(70.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.115),(71.135,11.285),(71.305,11.285),(71.305,11.115),(71.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.115),(71.495,11.285),(71.665,11.285),(71.665,11.115),(71.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.115),(71.855,11.285),(72.025,11.285),(72.025,11.115),(71.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.475),(70.775,11.645),(70.945,11.645),(70.945,11.475),(70.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.475),(71.135,11.645),(71.305,11.645),(71.305,11.475),(71.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.475),(71.495,11.645),(71.665,11.645),(71.665,11.475),(71.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.475),(71.855,11.645),(72.025,11.645),(72.025,11.475),(71.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.835),(70.775,12.005),(70.945,12.005),(70.945,11.835),(70.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.835),(71.135,12.005),(71.305,12.005),(71.305,11.835),(71.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.835),(71.495,12.005),(71.665,12.005),(71.665,11.835),(71.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.835),(71.855,12.005),(72.025,12.005),(72.025,11.835),(71.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.195),(70.775,12.365),(70.945,12.365),(70.945,12.195),(70.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.195),(71.135,12.365),(71.305,12.365),(71.305,12.195),(71.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.195),(71.495,12.365),(71.665,12.365),(71.665,12.195),(71.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.195),(71.855,12.365),(72.025,12.365),(72.025,12.195),(71.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.555),(70.775,12.725),(70.945,12.725),(70.945,12.555),(70.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.555),(71.135,12.725),(71.305,12.725),(71.305,12.555),(71.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.555),(71.495,12.725),(71.665,12.725),(71.665,12.555),(71.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.555),(71.855,12.725),(72.025,12.725),(72.025,12.555),(71.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.915),(70.775,13.085),(70.945,13.085),(70.945,12.915),(70.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.915),(71.135,13.085),(71.305,13.085),(71.305,12.915),(71.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.915),(71.495,13.085),(71.665,13.085),(71.665,12.915),(71.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.915),(71.855,13.085),(72.025,13.085),(72.025,12.915),(71.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.275),(70.775,13.445),(70.945,13.445),(70.945,13.275),(70.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.275),(71.135,13.445),(71.305,13.445),(71.305,13.275),(71.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.275),(71.495,13.445),(71.665,13.445),(71.665,13.275),(71.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.275),(71.855,13.445),(72.025,13.445),(72.025,13.275),(71.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.635),(70.775,13.805),(70.945,13.805),(70.945,13.635),(70.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.635),(71.135,13.805),(71.305,13.805),(71.305,13.635),(71.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.635),(71.495,13.805),(71.665,13.805),(71.665,13.635),(71.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.635),(71.855,13.805),(72.025,13.805),(72.025,13.635),(71.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.995),(70.775,14.165),(70.945,14.165),(70.945,13.995),(70.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.995),(71.135,14.165),(71.305,14.165),(71.305,13.995),(71.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.995),(71.495,14.165),(71.665,14.165),(71.665,13.995),(71.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.995),(71.855,14.165),(72.025,14.165),(72.025,13.995),(71.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.355),(70.775,14.525),(70.945,14.525),(70.945,14.355),(70.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.355),(71.135,14.525),(71.305,14.525),(71.305,14.355),(71.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.355),(71.495,14.525),(71.665,14.525),(71.665,14.355),(71.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.355),(71.855,14.525),(72.025,14.525),(72.025,14.355),(71.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.715),(70.775,14.885),(70.945,14.885),(70.945,14.715),(70.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.715),(71.135,14.885),(71.305,14.885),(71.305,14.715),(71.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.715),(71.495,14.885),(71.665,14.885),(71.665,14.715),(71.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.715),(71.855,14.885),(72.025,14.885),(72.025,14.715),(71.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.075),(70.775,15.245),(70.945,15.245),(70.945,15.075),(70.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.075),(71.135,15.245),(71.305,15.245),(71.305,15.075),(71.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.075),(71.495,15.245),(71.665,15.245),(71.665,15.075),(71.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.075),(71.855,15.245),(72.025,15.245),(72.025,15.075),(71.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.435),(70.775,15.605),(70.945,15.605),(70.945,15.435),(70.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.435),(71.135,15.605),(71.305,15.605),(71.305,15.435),(71.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.435),(71.495,15.605),(71.665,15.605),(71.665,15.435),(71.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.435),(71.855,15.605),(72.025,15.605),(72.025,15.435),(71.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.795),(70.775,15.965),(70.945,15.965),(70.945,15.795),(70.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.795),(71.135,15.965),(71.305,15.965),(71.305,15.795),(71.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.795),(71.495,15.965),(71.665,15.965),(71.665,15.795),(71.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.795),(71.855,15.965),(72.025,15.965),(72.025,15.795),(71.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.155),(70.775,16.325),(70.945,16.325),(70.945,16.155),(70.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.155),(71.135,16.325),(71.305,16.325),(71.305,16.155),(71.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.155),(71.495,16.325),(71.665,16.325),(71.665,16.155),(71.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.155),(71.855,16.325),(72.025,16.325),(72.025,16.155),(71.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.515),(70.775,16.685),(70.945,16.685),(70.945,16.515),(70.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.515),(71.135,16.685),(71.305,16.685),(71.305,16.515),(71.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.515),(71.495,16.685),(71.665,16.685),(71.665,16.515),(71.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.515),(71.855,16.685),(72.025,16.685),(72.025,16.515),(71.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.875),(70.775,17.045),(70.945,17.045),(70.945,16.875),(70.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.875),(71.135,17.045),(71.305,17.045),(71.305,16.875),(71.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.875),(71.495,17.045),(71.665,17.045),(71.665,16.875),(71.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.875),(71.855,17.045),(72.025,17.045),(72.025,16.875),(71.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.235),(70.775,17.405),(70.945,17.405),(70.945,17.235),(70.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.235),(71.135,17.405),(71.305,17.405),(71.305,17.235),(71.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.235),(71.495,17.405),(71.665,17.405),(71.665,17.235),(71.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.235),(71.855,17.405),(72.025,17.405),(72.025,17.235),(71.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.595),(70.775,17.765),(70.945,17.765),(70.945,17.595),(70.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.595),(71.135,17.765),(71.305,17.765),(71.305,17.595),(71.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.595),(71.495,17.765),(71.665,17.765),(71.665,17.595),(71.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.595),(71.855,17.765),(72.025,17.765),(72.025,17.595),(71.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.955),(70.775,18.125),(70.945,18.125),(70.945,17.955),(70.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.955),(71.135,18.125),(71.305,18.125),(71.305,17.955),(71.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.955),(71.495,18.125),(71.665,18.125),(71.665,17.955),(71.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.955),(71.855,18.125),(72.025,18.125),(72.025,17.955),(71.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.315),(70.775,18.485),(70.945,18.485),(70.945,18.315),(70.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.315),(71.135,18.485),(71.305,18.485),(71.305,18.315),(71.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.315),(71.495,18.485),(71.665,18.485),(71.665,18.315),(71.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.315),(71.855,18.485),(72.025,18.485),(72.025,18.315),(71.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.675),(70.775,18.845),(70.945,18.845),(70.945,18.675),(70.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.675),(71.135,18.845),(71.305,18.845),(71.305,18.675),(71.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.675),(71.495,18.845),(71.665,18.845),(71.665,18.675),(71.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.675),(71.855,18.845),(72.025,18.845),(72.025,18.675),(71.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.035),(70.775,19.205),(70.945,19.205),(70.945,19.035),(70.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.035),(71.135,19.205),(71.305,19.205),(71.305,19.035),(71.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.035),(71.495,19.205),(71.665,19.205),(71.665,19.035),(71.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.035),(71.855,19.205),(72.025,19.205),(72.025,19.035),(71.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.395),(70.775,19.565),(70.945,19.565),(70.945,19.395),(70.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.395),(71.135,19.565),(71.305,19.565),(71.305,19.395),(71.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.395),(71.495,19.565),(71.665,19.565),(71.665,19.395),(71.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.395),(71.855,19.565),(72.025,19.565),(72.025,19.395),(71.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.755),(70.775,19.925),(70.945,19.925),(70.945,19.755),(70.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.755),(71.135,19.925),(71.305,19.925),(71.305,19.755),(71.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.755),(71.495,19.925),(71.665,19.925),(71.665,19.755),(71.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.755),(71.855,19.925),(72.025,19.925),(72.025,19.755),(71.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,20.115),(70.775,20.285),(70.945,20.285),(70.945,20.115),(70.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,20.115),(71.135,20.285),(71.305,20.285),(71.305,20.115),(71.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,20.115),(71.495,20.285),(71.665,20.285),(71.665,20.115),(71.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,20.115),(71.855,20.285),(72.025,20.285),(72.025,20.115),(71.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,20.475),(70.775,20.645),(70.945,20.645),(70.945,20.475),(70.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,20.475),(71.135,20.645),(71.305,20.645),(71.305,20.475),(71.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,20.475),(71.495,20.645),(71.665,20.645),(71.665,20.475),(71.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,20.475),(71.855,20.645),(72.025,20.645),(72.025,20.475),(71.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,20.835),(70.775,21.005),(70.945,21.005),(70.945,20.835),(70.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,20.835),(71.135,21.005),(71.305,21.005),(71.305,20.835),(71.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,20.835),(71.495,21.005),(71.665,21.005),(71.665,20.835),(71.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,20.835),(71.855,21.005),(72.025,21.005),(72.025,20.835),(71.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,21.195),(70.775,21.365),(70.945,21.365),(70.945,21.195),(70.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,21.195),(71.135,21.365),(71.305,21.365),(71.305,21.195),(71.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,21.195),(71.495,21.365),(71.665,21.365),(71.665,21.195),(71.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,21.195),(71.855,21.365),(72.025,21.365),(72.025,21.195),(71.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,21.555),(70.775,21.725),(70.945,21.725),(70.945,21.555),(70.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,21.555),(71.135,21.725),(71.305,21.725),(71.305,21.555),(71.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,21.555),(71.495,21.725),(71.665,21.725),(71.665,21.555),(71.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,21.555),(71.855,21.725),(72.025,21.725),(72.025,21.555),(71.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,21.915),(70.775,22.085),(70.945,22.085),(70.945,21.915),(70.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,21.915),(71.135,22.085),(71.305,22.085),(71.305,21.915),(71.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,21.915),(71.495,22.085),(71.665,22.085),(71.665,21.915),(71.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,21.915),(71.855,22.085),(72.025,22.085),(72.025,21.915),(71.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.275),(70.775,22.445),(70.945,22.445),(70.945,22.275),(70.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.275),(71.135,22.445),(71.305,22.445),(71.305,22.275),(71.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.275),(71.495,22.445),(71.665,22.445),(71.665,22.275),(71.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.275),(71.855,22.445),(72.025,22.445),(72.025,22.275),(71.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.635),(70.775,22.805),(70.945,22.805),(70.945,22.635),(70.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.635),(71.135,22.805),(71.305,22.805),(71.305,22.635),(71.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.635),(71.495,22.805),(71.665,22.805),(71.665,22.635),(71.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.635),(71.855,22.805),(72.025,22.805),(72.025,22.635),(71.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.995),(70.775,23.165),(70.945,23.165),(70.945,22.995),(70.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.995),(71.135,23.165),(71.305,23.165),(71.305,22.995),(71.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.995),(71.495,23.165),(71.665,23.165),(71.665,22.995),(71.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.995),(71.855,23.165),(72.025,23.165),(72.025,22.995),(71.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,23.355),(70.775,23.525),(70.945,23.525),(70.945,23.355),(70.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,23.355),(71.135,23.525),(71.305,23.525),(71.305,23.355),(71.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,23.355),(71.495,23.525),(71.665,23.525),(71.665,23.355),(71.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,23.355),(71.855,23.525),(72.025,23.525),(72.025,23.355),(71.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,23.715),(70.775,23.885),(70.945,23.885),(70.945,23.715),(70.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,23.715),(71.135,23.885),(71.305,23.885),(71.305,23.715),(71.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,23.715),(71.495,23.885),(71.665,23.885),(71.665,23.715),(71.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,23.715),(71.855,23.885),(72.025,23.885),(72.025,23.715),(71.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,24.075),(70.775,24.245),(70.945,24.245),(70.945,24.075),(70.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,24.075),(71.135,24.245),(71.305,24.245),(71.305,24.075),(71.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,24.075),(71.495,24.245),(71.665,24.245),(71.665,24.075),(71.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,24.075),(71.855,24.245),(72.025,24.245),(72.025,24.075),(71.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,24.435),(70.775,24.605),(70.945,24.605),(70.945,24.435),(70.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,24.435),(71.135,24.605),(71.305,24.605),(71.305,24.435),(71.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,24.435),(71.495,24.605),(71.665,24.605),(71.665,24.435),(71.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,24.435),(71.855,24.605),(72.025,24.605),(72.025,24.435),(71.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,24.795),(70.775,24.965),(70.945,24.965),(70.945,24.795),(70.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,24.795),(71.135,24.965),(71.305,24.965),(71.305,24.795),(71.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,24.795),(71.495,24.965),(71.665,24.965),(71.665,24.795),(71.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,24.795),(71.855,24.965),(72.025,24.965),(72.025,24.795),(71.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,25.155),(70.775,25.325),(70.945,25.325),(70.945,25.155),(70.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,25.155),(71.135,25.325),(71.305,25.325),(71.305,25.155),(71.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,25.155),(71.495,25.325),(71.665,25.325),(71.665,25.155),(71.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,25.155),(71.855,25.325),(72.025,25.325),(72.025,25.155),(71.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,25.515),(70.775,25.685),(70.945,25.685),(70.945,25.515),(70.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,25.515),(71.135,25.685),(71.305,25.685),(71.305,25.515),(71.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,25.515),(71.495,25.685),(71.665,25.685),(71.665,25.515),(71.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,25.515),(71.855,25.685),(72.025,25.685),(72.025,25.515),(71.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,25.875),(70.775,26.045),(70.945,26.045),(70.945,25.875),(70.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,25.875),(71.135,26.045),(71.305,26.045),(71.305,25.875),(71.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,25.875),(71.495,26.045),(71.665,26.045),(71.665,25.875),(71.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,25.875),(71.855,26.045),(72.025,26.045),(72.025,25.875),(71.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,26.235),(70.775,26.405),(70.945,26.405),(70.945,26.235),(70.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,26.235),(71.135,26.405),(71.305,26.405),(71.305,26.235),(71.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,26.235),(71.495,26.405),(71.665,26.405),(71.665,26.235),(71.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,26.235),(71.855,26.405),(72.025,26.405),(72.025,26.235),(71.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,26.595),(70.775,26.765),(70.945,26.765),(70.945,26.595),(70.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,26.595),(71.135,26.765),(71.305,26.765),(71.305,26.595),(71.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,26.595),(71.495,26.765),(71.665,26.765),(71.665,26.595),(71.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,26.595),(71.855,26.765),(72.025,26.765),(72.025,26.595),(71.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,26.955),(70.775,27.125),(70.945,27.125),(70.945,26.955),(70.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,26.955),(71.135,27.125),(71.305,27.125),(71.305,26.955),(71.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,26.955),(71.495,27.125),(71.665,27.125),(71.665,26.955),(71.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,26.955),(71.855,27.125),(72.025,27.125),(72.025,26.955),(71.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,27.315),(70.775,27.485),(70.945,27.485),(70.945,27.315),(70.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,27.315),(71.135,27.485),(71.305,27.485),(71.305,27.315),(71.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,27.315),(71.495,27.485),(71.665,27.485),(71.665,27.315),(71.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,27.315),(71.855,27.485),(72.025,27.485),(72.025,27.315),(71.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,27.675),(70.775,27.845),(70.945,27.845),(70.945,27.675),(70.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,27.675),(71.135,27.845),(71.305,27.845),(71.305,27.675),(71.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,27.675),(71.495,27.845),(71.665,27.845),(71.665,27.675),(71.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,27.675),(71.855,27.845),(72.025,27.845),(72.025,27.675),(71.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,28.035),(70.775,28.205),(70.945,28.205),(70.945,28.035),(70.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,28.035),(71.135,28.205),(71.305,28.205),(71.305,28.035),(71.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,28.035),(71.495,28.205),(71.665,28.205),(71.665,28.035),(71.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,28.035),(71.855,28.205),(72.025,28.205),(72.025,28.035),(71.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,28.395),(70.775,28.565),(70.945,28.565),(70.945,28.395),(70.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,28.395),(71.135,28.565),(71.305,28.565),(71.305,28.395),(71.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,28.395),(71.495,28.565),(71.665,28.565),(71.665,28.395),(71.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,28.395),(71.855,28.565),(72.025,28.565),(72.025,28.395),(71.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,28.755),(70.775,28.925),(70.945,28.925),(70.945,28.755),(70.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,28.755),(71.135,28.925),(71.305,28.925),(71.305,28.755),(71.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,28.755),(71.495,28.925),(71.665,28.925),(71.665,28.755),(71.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,28.755),(71.855,28.925),(72.025,28.925),(72.025,28.755),(71.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,29.115),(70.775,29.285),(70.945,29.285),(70.945,29.115),(70.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,29.115),(71.135,29.285),(71.305,29.285),(71.305,29.115),(71.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,29.115),(71.495,29.285),(71.665,29.285),(71.665,29.115),(71.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,29.115),(71.855,29.285),(72.025,29.285),(72.025,29.115),(71.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,29.475),(70.775,29.645),(70.945,29.645),(70.945,29.475),(70.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,29.475),(71.135,29.645),(71.305,29.645),(71.305,29.475),(71.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,29.475),(71.495,29.645),(71.665,29.645),(71.665,29.475),(71.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,29.475),(71.855,29.645),(72.025,29.645),(72.025,29.475),(71.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,29.835),(70.775,30.005),(70.945,30.005),(70.945,29.835),(70.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,29.835),(71.135,30.005),(71.305,30.005),(71.305,29.835),(71.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,29.835),(71.495,30.005),(71.665,30.005),(71.665,29.835),(71.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,29.835),(71.855,30.005),(72.025,30.005),(72.025,29.835),(71.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,30.195),(70.775,30.365),(70.945,30.365),(70.945,30.195),(70.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,30.195),(71.135,30.365),(71.305,30.365),(71.305,30.195),(71.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,30.195),(71.495,30.365),(71.665,30.365),(71.665,30.195),(71.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,30.195),(71.855,30.365),(72.025,30.365),(72.025,30.195),(71.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,30.555),(70.775,30.725),(70.945,30.725),(70.945,30.555),(70.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,30.555),(71.135,30.725),(71.305,30.725),(71.305,30.555),(71.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,30.555),(71.495,30.725),(71.665,30.725),(71.665,30.555),(71.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,30.555),(71.855,30.725),(72.025,30.725),(72.025,30.555),(71.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,30.915),(70.775,31.085),(70.945,31.085),(70.945,30.915),(70.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,30.915),(71.135,31.085),(71.305,31.085),(71.305,30.915),(71.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,30.915),(71.495,31.085),(71.665,31.085),(71.665,30.915),(71.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,30.915),(71.855,31.085),(72.025,31.085),(72.025,30.915),(71.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,31.275),(70.775,31.445),(70.945,31.445),(70.945,31.275),(70.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,31.275),(71.135,31.445),(71.305,31.445),(71.305,31.275),(71.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,31.275),(71.495,31.445),(71.665,31.445),(71.665,31.275),(71.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,31.275),(71.855,31.445),(72.025,31.445),(72.025,31.275),(71.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,31.635),(70.775,31.805),(70.945,31.805),(70.945,31.635),(70.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,31.635),(71.135,31.805),(71.305,31.805),(71.305,31.635),(71.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,31.635),(71.495,31.805),(71.665,31.805),(71.665,31.635),(71.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,31.635),(71.855,31.805),(72.025,31.805),(72.025,31.635),(71.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,31.995),(70.775,32.165),(70.945,32.165),(70.945,31.995),(70.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,31.995),(71.135,32.165),(71.305,32.165),(71.305,31.995),(71.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,31.995),(71.495,32.165),(71.665,32.165),(71.665,31.995),(71.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,31.995),(71.855,32.165),(72.025,32.165),(72.025,31.995),(71.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,32.355),(70.775,32.525),(70.945,32.525),(70.945,32.355),(70.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,32.355),(71.135,32.525),(71.305,32.525),(71.305,32.355),(71.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,32.355),(71.495,32.525),(71.665,32.525),(71.665,32.355),(71.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,32.355),(71.855,32.525),(72.025,32.525),(72.025,32.355),(71.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,32.715),(70.775,32.885),(70.945,32.885),(70.945,32.715),(70.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,32.715),(71.135,32.885),(71.305,32.885),(71.305,32.715),(71.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,32.715),(71.495,32.885),(71.665,32.885),(71.665,32.715),(71.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,32.715),(71.855,32.885),(72.025,32.885),(72.025,32.715),(71.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,33.075),(70.775,33.245),(70.945,33.245),(70.945,33.075),(70.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,33.075),(71.135,33.245),(71.305,33.245),(71.305,33.075),(71.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,33.075),(71.495,33.245),(71.665,33.245),(71.665,33.075),(71.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,33.075),(71.855,33.245),(72.025,33.245),(72.025,33.075),(71.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,33.435),(70.775,33.605),(70.945,33.605),(70.945,33.435),(70.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,33.435),(71.135,33.605),(71.305,33.605),(71.305,33.435),(71.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,33.435),(71.495,33.605),(71.665,33.605),(71.665,33.435),(71.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,33.435),(71.855,33.605),(72.025,33.605),(72.025,33.435),(71.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,33.795),(70.775,33.965),(70.945,33.965),(70.945,33.795),(70.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,33.795),(71.135,33.965),(71.305,33.965),(71.305,33.795),(71.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,33.795),(71.495,33.965),(71.665,33.965),(71.665,33.795),(71.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,33.795),(71.855,33.965),(72.025,33.965),(72.025,33.795),(71.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,34.155),(70.775,34.325),(70.945,34.325),(70.945,34.155),(70.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,34.155),(71.135,34.325),(71.305,34.325),(71.305,34.155),(71.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,34.155),(71.495,34.325),(71.665,34.325),(71.665,34.155),(71.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,34.155),(71.855,34.325),(72.025,34.325),(72.025,34.155),(71.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,34.515),(70.775,34.685),(70.945,34.685),(70.945,34.515),(70.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,34.515),(71.135,34.685),(71.305,34.685),(71.305,34.515),(71.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,34.515),(71.495,34.685),(71.665,34.685),(71.665,34.515),(71.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,34.515),(71.855,34.685),(72.025,34.685),(72.025,34.515),(71.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,34.875),(70.775,35.045),(70.945,35.045),(70.945,34.875),(70.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,34.875),(71.135,35.045),(71.305,35.045),(71.305,34.875),(71.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,34.875),(71.495,35.045),(71.665,35.045),(71.665,34.875),(71.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,34.875),(71.855,35.045),(72.025,35.045),(72.025,34.875),(71.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,35.235),(70.775,35.405),(70.945,35.405),(70.945,35.235),(70.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,35.235),(71.135,35.405),(71.305,35.405),(71.305,35.235),(71.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,35.235),(71.495,35.405),(71.665,35.405),(71.665,35.235),(71.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,35.235),(71.855,35.405),(72.025,35.405),(72.025,35.235),(71.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,35.595),(70.775,35.765),(70.945,35.765),(70.945,35.595),(70.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,35.595),(71.135,35.765),(71.305,35.765),(71.305,35.595),(71.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,35.595),(71.495,35.765),(71.665,35.765),(71.665,35.595),(71.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,35.595),(71.855,35.765),(72.025,35.765),(72.025,35.595),(71.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,35.955),(70.775,36.125),(70.945,36.125),(70.945,35.955),(70.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,35.955),(71.135,36.125),(71.305,36.125),(71.305,35.955),(71.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,35.955),(71.495,36.125),(71.665,36.125),(71.665,35.955),(71.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,35.955),(71.855,36.125),(72.025,36.125),(72.025,35.955),(71.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,36.315),(70.775,36.485),(70.945,36.485),(70.945,36.315),(70.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,36.315),(71.135,36.485),(71.305,36.485),(71.305,36.315),(71.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,36.315),(71.495,36.485),(71.665,36.485),(71.665,36.315),(71.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,36.315),(71.855,36.485),(72.025,36.485),(72.025,36.315),(71.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,36.675),(70.775,36.845),(70.945,36.845),(70.945,36.675),(70.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,36.675),(71.135,36.845),(71.305,36.845),(71.305,36.675),(71.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,36.675),(71.495,36.845),(71.665,36.845),(71.665,36.675),(71.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,36.675),(71.855,36.845),(72.025,36.845),(72.025,36.675),(71.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,37.035),(70.775,37.205),(70.945,37.205),(70.945,37.035),(70.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,37.035),(71.135,37.205),(71.305,37.205),(71.305,37.035),(71.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,37.035),(71.495,37.205),(71.665,37.205),(71.665,37.035),(71.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,37.035),(71.855,37.205),(72.025,37.205),(72.025,37.035),(71.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,37.395),(70.775,37.565),(70.945,37.565),(70.945,37.395),(70.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,37.395),(71.135,37.565),(71.305,37.565),(71.305,37.395),(71.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,37.395),(71.495,37.565),(71.665,37.565),(71.665,37.395),(71.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,37.395),(71.855,37.565),(72.025,37.565),(72.025,37.395),(71.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,37.755),(70.775,37.925),(70.945,37.925),(70.945,37.755),(70.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,37.755),(71.135,37.925),(71.305,37.925),(71.305,37.755),(71.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,37.755),(71.495,37.925),(71.665,37.925),(71.665,37.755),(71.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,37.755),(71.855,37.925),(72.025,37.925),(72.025,37.755),(71.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,38.115),(70.775,38.285),(70.945,38.285),(70.945,38.115),(70.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,38.115),(71.135,38.285),(71.305,38.285),(71.305,38.115),(71.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,38.115),(71.495,38.285),(71.665,38.285),(71.665,38.115),(71.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,38.115),(71.855,38.285),(72.025,38.285),(72.025,38.115),(71.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,38.475),(70.775,38.645),(70.945,38.645),(70.945,38.475),(70.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,38.475),(71.135,38.645),(71.305,38.645),(71.305,38.475),(71.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,38.475),(71.495,38.645),(71.665,38.645),(71.665,38.475),(71.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,38.475),(71.855,38.645),(72.025,38.645),(72.025,38.475),(71.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,38.835),(70.775,39.005),(70.945,39.005),(70.945,38.835),(70.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,38.835),(71.135,39.005),(71.305,39.005),(71.305,38.835),(71.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,38.835),(71.495,39.005),(71.665,39.005),(71.665,38.835),(71.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,38.835),(71.855,39.005),(72.025,39.005),(72.025,38.835),(71.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,39.195),(70.775,39.365),(70.945,39.365),(70.945,39.195),(70.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,39.195),(71.135,39.365),(71.305,39.365),(71.305,39.195),(71.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,39.195),(71.495,39.365),(71.665,39.365),(71.665,39.195),(71.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,39.195),(71.855,39.365),(72.025,39.365),(72.025,39.195),(71.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,39.555),(70.775,39.725),(70.945,39.725),(70.945,39.555),(70.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,39.555),(71.135,39.725),(71.305,39.725),(71.305,39.555),(71.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,39.555),(71.495,39.725),(71.665,39.725),(71.665,39.555),(71.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,39.555),(71.855,39.725),(72.025,39.725),(72.025,39.555),(71.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,39.915),(70.775,40.085),(70.945,40.085),(70.945,39.915),(70.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,39.915),(71.135,40.085),(71.305,40.085),(71.305,39.915),(71.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,39.915),(71.495,40.085),(71.665,40.085),(71.665,39.915),(71.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,39.915),(71.855,40.085),(72.025,40.085),(72.025,39.915),(71.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,40.275),(70.775,40.445),(70.945,40.445),(70.945,40.275),(70.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,40.275),(71.135,40.445),(71.305,40.445),(71.305,40.275),(71.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,40.275),(71.495,40.445),(71.665,40.445),(71.665,40.275),(71.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,40.275),(71.855,40.445),(72.025,40.445),(72.025,40.275),(71.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,40.635),(70.775,40.805),(70.945,40.805),(70.945,40.635),(70.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,40.635),(71.135,40.805),(71.305,40.805),(71.305,40.635),(71.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,40.635),(71.495,40.805),(71.665,40.805),(71.665,40.635),(71.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,40.635),(71.855,40.805),(72.025,40.805),(72.025,40.635),(71.855,40.635)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.775),(32.345,43.64),(33.655,43.64),(33.655,2.775),(32.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.775),(22.745,43.64),(24.055,43.64),(24.055,2.775),(22.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.775),(46.745,43.64),(48.055,43.64),(48.055,2.775),(46.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.775),(17.945,43.64),(19.255,43.64),(19.255,2.775),(17.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.775),(27.545,43.64),(28.855,43.64),(28.855,2.775),(27.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.775),(51.545,43.64),(52.855,43.64),(52.855,2.775),(51.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.775),(56.345,43.64),(57.655,43.64),(57.655,2.775),(56.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.775),(65.945,43.64),(67.255,43.64),(67.255,2.775),(65.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.775),(13.145,43.64),(14.455,43.64),(14.455,2.775),(13.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.775),(37.145,43.64),(38.455,43.64),(38.455,2.775),(37.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.775),(61.145,43.64),(62.455,43.64),(62.455,2.775),(61.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.775),(75.545,43.64),(76.855,43.64),(76.855,2.775),(75.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.775),(80.345,43.64),(81.655,43.64),(81.655,2.775),(80.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.775),(70.745,43.64),(72.055,43.64),(72.055,2.775),(70.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.775),(8.345,43.64),(9.655,43.64),(9.655,2.775),(8.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.775),(41.945,43.64),(43.255,43.64),(43.255,2.775),(41.945,2.775)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(23.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(23.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(18.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(18.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(28.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(28.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(66.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(66.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(13.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(13.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(61.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(61.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(76.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(76.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(81.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(81.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(71.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(71.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(9.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(9.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['gate']
        createRL(
            tech, net, 'poly',
            ((9.93,2.23),(9.93,2.56),(9.765,2.56),(9.765,41.08),(9.93,41.08),(9.93,41.41),(10.2,41.41),(10.2,41.08),(10.365,41.08),(10.365,2.56),(10.2,2.56),(10.2,2.23),(9.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,2.23),(12.6,2.56),(12.435,2.56),(12.435,41.08),(12.6,41.08),(12.6,41.41),(12.87,41.41),(12.87,41.08),(13.035,41.08),(13.035,2.56),(12.87,2.56),(12.87,2.23),(12.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,2.23),(7.8,2.56),(7.635,2.56),(7.635,41.08),(7.8,41.08),(7.8,41.41),(8.07,41.41),(8.07,41.08),(8.235,41.08),(8.235,2.56),(8.07,2.56),(8.07,2.23),(7.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,2.23),(14.73,2.56),(14.565,2.56),(14.565,41.08),(14.73,41.08),(14.73,41.41),(15.0,41.41),(15.0,41.08),(15.165,41.08),(15.165,2.56),(15.0,2.56),(15.0,2.23),(14.73,2.23)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,41.16),(14.78,41.33),(14.95,41.33),(14.95,41.16),(14.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,2.31),(9.98,2.48),(10.15,2.48),(10.15,2.31),(9.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,2.31),(14.78,2.48),(14.95,2.48),(14.95,2.31),(14.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,41.16),(9.98,41.33),(10.15,41.33),(10.15,41.16),(9.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,41.16),(7.85,41.33),(8.02,41.33),(8.02,41.16),(7.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,2.31),(12.65,2.48),(12.82,2.48),(12.82,2.31),(12.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,2.31),(7.85,2.48),(8.02,2.48),(8.02,2.31),(7.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((4.07,40.29),(4.07,40.46),(4.24,40.46),(4.24,40.29),(4.07,40.29)),
        )
        createRL(
            tech, net, 'licon',
            ((4.07,40.63),(4.07,40.8),(4.24,40.8),(4.24,40.63),(4.07,40.63)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,41.16),(12.65,41.33),(12.82,41.33),(12.82,41.16),(12.65,41.16)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.23),(7.85,41.24),(4.24,41.24),(4.24,40.21),(4.07,40.21),(4.07,41.41),(14.95,41.41),(14.95,2.23),(14.78,2.23),(14.78,41.24),(12.82,41.24),(12.82,2.23),(12.65,2.23),(12.65,41.24),(10.15,41.24),(10.15,2.23),(9.98,2.23),(9.98,41.24),(8.02,41.24),(8.02,2.23),(7.85,2.23)),
        )
        createRL(
            tech, net, 'difftap',
            ((4.03,40.17),(4.03,40.92),(4.28,40.92),(4.28,40.17),(4.03,40.17)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,40.365),(4.07,40.535),(4.24,40.535),(4.24,40.365),(4.07,40.365)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,40.725),(4.07,40.895),(4.24,40.895),(4.24,40.725),(4.07,40.725)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,41.085),(4.07,41.255),(4.24,41.255),(4.24,41.085),(4.07,41.085)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,40.305),(4.04,43.64),(4.27,43.64),(4.27,40.305),(4.04,40.305)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(4.155), u(0.23), u(40.305), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(4.155), u(0.23), u(40.305), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['off']
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.165,2.56),(48.165,41.08),(48.33,41.08),(48.33,41.41),(48.6,41.41),(48.6,41.08),(48.765,41.08),(48.765,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,2.23),(67.53,2.56),(67.365,2.56),(67.365,41.08),(67.53,41.08),(67.53,41.41),(67.8,41.41),(67.8,41.08),(67.965,41.08),(67.965,2.56),(67.8,2.56),(67.8,2.23),(67.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(57.765,2.56),(57.765,41.08),(57.93,41.08),(57.93,41.41),(58.2,41.41),(58.2,41.08),(58.365,41.08),(58.365,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,2.23),(22.2,2.56),(22.035,2.56),(22.035,41.08),(22.2,41.08),(22.2,41.41),(22.47,41.41),(22.47,41.08),(22.635,41.08),(22.635,2.56),(22.47,2.56),(22.47,2.23),(22.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,2.23),(70.2,2.56),(70.035,2.56),(70.035,41.08),(70.2,41.08),(70.2,41.41),(70.47,41.41),(70.47,41.08),(70.635,41.08),(70.635,2.56),(70.47,2.56),(70.47,2.23),(70.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(52.965,2.56),(52.965,41.08),(53.13,41.08),(53.13,41.41),(53.4,41.41),(53.4,41.08),(53.565,41.08),(53.565,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,2.23),(62.73,2.56),(62.565,2.56),(62.565,41.08),(62.73,41.08),(62.73,41.41),(63.0,41.41),(63.0,41.08),(63.165,41.08),(63.165,2.56),(63.0,2.56),(63.0,2.23),(62.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,2.23),(27.0,2.56),(26.835,2.56),(26.835,41.08),(27.0,41.08),(27.0,41.41),(27.27,41.41),(27.27,41.08),(27.435,41.08),(27.435,2.56),(27.27,2.56),(27.27,2.23),(27.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,2.23),(81.93,2.56),(81.765,2.56),(81.765,41.08),(81.93,41.08),(81.93,41.41),(82.2,41.41),(82.2,41.08),(82.365,41.08),(82.365,2.56),(82.2,2.56),(82.2,2.23),(81.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(50.835,2.56),(50.835,41.08),(51.0,41.08),(51.0,41.41),(51.27,41.41),(51.27,41.08),(51.435,41.08),(51.435,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.365,2.56),(43.365,41.08),(43.53,41.08),(43.53,41.41),(43.8,41.41),(43.8,41.08),(43.965,41.08),(43.965,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,2.23),(75.0,2.56),(74.835,2.56),(74.835,41.08),(75.0,41.08),(75.0,41.41),(75.27,41.41),(75.27,41.08),(75.435,41.08),(75.435,2.56),(75.27,2.56),(75.27,2.23),(75.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.235,2.56),(41.235,41.08),(41.4,41.08),(41.4,41.41),(41.67,41.41),(41.67,41.08),(41.835,41.08),(41.835,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,2.23),(17.4,2.56),(17.235,2.56),(17.235,41.08),(17.4,41.08),(17.4,41.41),(17.67,41.41),(17.67,41.08),(17.835,41.08),(17.835,2.56),(17.67,2.56),(17.67,2.23),(17.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,2.23),(24.33,2.56),(24.165,2.56),(24.165,41.08),(24.33,41.08),(24.33,41.41),(24.6,41.41),(24.6,41.08),(24.765,41.08),(24.765,2.56),(24.6,2.56),(24.6,2.23),(24.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,2.23),(60.6,2.56),(60.435,2.56),(60.435,41.08),(60.6,41.08),(60.6,41.41),(60.87,41.41),(60.87,41.08),(61.035,41.08),(61.035,2.56),(60.87,2.56),(60.87,2.23),(60.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(31.635,2.56),(31.635,41.08),(31.8,41.08),(31.8,41.41),(32.07,41.41),(32.07,41.08),(32.235,41.08),(32.235,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,2.23),(77.13,2.56),(76.965,2.56),(76.965,41.08),(77.13,41.08),(77.13,41.41),(77.4,41.41),(77.4,41.08),(77.565,41.08),(77.565,2.56),(77.4,2.56),(77.4,2.23),(77.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,2.23),(72.33,2.56),(72.165,2.56),(72.165,41.08),(72.33,41.08),(72.33,41.41),(72.6,41.41),(72.6,41.08),(72.765,41.08),(72.765,2.56),(72.6,2.56),(72.6,2.23),(72.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(33.765,2.56),(33.765,41.08),(33.93,41.08),(33.93,41.41),(34.2,41.41),(34.2,41.08),(34.365,41.08),(34.365,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,2.23),(29.13,2.56),(28.965,2.56),(28.965,41.08),(29.13,41.08),(29.13,41.41),(29.4,41.41),(29.4,41.08),(29.565,41.08),(29.565,2.56),(29.4,2.56),(29.4,2.23),(29.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,2.23),(79.8,2.56),(79.635,2.56),(79.635,41.08),(79.8,41.08),(79.8,41.41),(80.07,41.41),(80.07,41.08),(80.235,41.08),(80.235,2.56),(80.07,2.56),(80.07,2.23),(79.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(55.635,2.56),(55.635,41.08),(55.8,41.08),(55.8,41.41),(56.07,41.41),(56.07,41.08),(56.235,41.08),(56.235,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.985),(85.68,22.28),(86.01,22.28),(86.01,21.985),(85.68,21.985)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.035,2.56),(46.035,41.08),(46.2,41.08),(46.2,41.41),(46.47,41.41),(46.47,41.08),(46.635,41.08),(46.635,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,2.23),(19.53,2.56),(19.365,2.56),(19.365,41.08),(19.53,41.08),(19.53,41.41),(19.8,41.41),(19.8,41.08),(19.965,41.08),(19.965,2.56),(19.8,2.56),(19.8,2.23),(19.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,2.23),(65.4,2.56),(65.235,2.56),(65.235,41.08),(65.4,41.08),(65.4,41.41),(65.67,41.41),(65.67,41.08),(65.835,41.08),(65.835,2.56),(65.67,2.56),(65.67,2.23),(65.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.435,2.56),(36.435,41.08),(36.6,41.08),(36.6,41.41),(36.87,41.41),(36.87,41.08),(37.035,41.08),(37.035,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(38.565,2.56),(38.565,41.08),(38.73,41.08),(38.73,41.41),(39.0,41.41),(39.0,41.08),(39.165,41.08),(39.165,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,2.31),(17.45,2.48),(17.62,2.48),(17.62,2.31),(17.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,41.16),(46.25,41.33),(46.42,41.33),(46.42,41.16),(46.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,41.16),(29.18,41.33),(29.35,41.33),(29.35,41.16),(29.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,41.16),(67.58,41.33),(67.75,41.33),(67.75,41.16),(67.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,41.16),(31.85,41.33),(32.02,41.33),(32.02,41.16),(31.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,41.16),(22.25,41.33),(22.42,41.33),(22.42,41.16),(22.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,2.31),(81.98,2.48),(82.15,2.48),(82.15,2.31),(81.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,41.16),(24.38,41.33),(24.55,41.33),(24.55,41.16),(24.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,2.31),(27.05,2.48),(27.22,2.48),(27.22,2.31),(27.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,41.16),(60.65,41.33),(60.82,41.33),(60.82,41.16),(60.65,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,41.16),(19.58,41.33),(19.75,41.33),(19.75,41.16),(19.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,41.16),(43.58,41.33),(43.75,41.33),(43.75,41.16),(43.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,2.31),(62.78,2.48),(62.95,2.48),(62.95,2.31),(62.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,41.16),(48.38,41.33),(48.55,41.33),(48.55,41.16),(48.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,22.03),(85.76,22.2),(85.93,22.2),(85.93,22.03),(85.76,22.03)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,41.16),(51.05,41.33),(51.22,41.33),(51.22,41.16),(51.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,41.16),(72.38,41.33),(72.55,41.33),(72.55,41.16),(72.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,41.16),(75.05,41.33),(75.22,41.33),(75.22,41.16),(75.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,41.16),(65.45,41.33),(65.62,41.33),(65.62,41.16),(65.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,41.16),(79.85,41.33),(80.02,41.33),(80.02,41.16),(79.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,2.31),(75.05,2.48),(75.22,2.48),(75.22,2.31),(75.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,2.31),(77.18,2.48),(77.35,2.48),(77.35,2.31),(77.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,41.16),(41.45,41.33),(41.62,41.33),(41.62,41.16),(41.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,2.31),(65.45,2.48),(65.62,2.48),(65.62,2.31),(65.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,41.16),(62.78,41.33),(62.95,41.33),(62.95,41.16),(62.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,41.16),(27.05,41.33),(27.22,41.33),(27.22,41.16),(27.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,2.31),(72.38,2.48),(72.55,2.48),(72.55,2.31),(72.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,41.16),(55.85,41.33),(56.02,41.33),(56.02,41.16),(55.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,2.31),(60.65,2.48),(60.82,2.48),(60.82,2.31),(60.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,2.31),(70.25,2.48),(70.42,2.48),(70.42,2.31),(70.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,2.31),(29.18,2.48),(29.35,2.48),(29.35,2.31),(29.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,2.31),(67.58,2.48),(67.75,2.48),(67.75,2.31),(67.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,2.31),(79.85,2.48),(80.02,2.48),(80.02,2.31),(79.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,41.16),(57.98,41.33),(58.15,41.33),(58.15,41.16),(57.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,41.16),(36.65,41.33),(36.82,41.33),(36.82,41.16),(36.65,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,41.16),(53.18,41.33),(53.35,41.33),(53.35,41.16),(53.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,41.16),(77.18,41.33),(77.35,41.33),(77.35,41.16),(77.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,41.16),(33.98,41.33),(34.15,41.33),(34.15,41.16),(33.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,2.31),(24.38,2.48),(24.55,2.48),(24.55,2.31),(24.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,41.16),(81.98,41.33),(82.15,41.33),(82.15,41.16),(81.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,41.16),(17.45,41.33),(17.62,41.33),(17.62,41.16),(17.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,41.16),(38.78,41.33),(38.95,41.33),(38.95,41.16),(38.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,41.16),(70.25,41.33),(70.42,41.33),(70.42,41.16),(70.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,2.31),(22.25,2.48),(22.42,2.48),(22.42,2.31),(22.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,2.31),(19.58,2.48),(19.75,2.48),(19.75,2.31),(19.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,21.95),(85.76,41.41),(85.93,41.41),(85.93,21.95),(85.76,21.95)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.23),(17.45,41.41),(82.15,41.41),(82.15,2.23),(81.98,2.23),(81.98,41.24),(80.02,41.24),(80.02,2.23),(79.85,2.23),(79.85,41.24),(77.35,41.24),(77.35,2.23),(77.18,2.23),(77.18,41.24),(75.22,41.24),(75.22,2.23),(75.05,2.23),(75.05,41.24),(72.55,41.24),(72.55,2.23),(72.38,2.23),(72.38,41.24),(70.42,41.24),(70.42,2.23),(70.25,2.23),(70.25,41.24),(67.75,41.24),(67.75,2.23),(67.58,2.23),(67.58,41.24),(65.62,41.24),(65.62,2.23),(65.45,2.23),(65.45,41.24),(62.95,41.24),(62.95,2.23),(62.78,2.23),(62.78,41.24),(60.82,41.24),(60.82,2.23),(60.65,2.23),(60.65,41.24),(58.15,41.24),(58.15,2.23),(57.98,2.23),(57.98,41.24),(56.02,41.24),(56.02,2.23),(55.85,2.23),(55.85,41.24),(53.35,41.24),(53.35,2.23),(53.18,2.23),(53.18,41.24),(51.22,41.24),(51.22,2.23),(51.05,2.23),(51.05,41.24),(48.55,41.24),(48.55,2.23),(48.38,2.23),(48.38,41.24),(46.42,41.24),(46.42,2.23),(46.25,2.23),(46.25,41.24),(43.75,41.24),(43.75,2.23),(43.58,2.23),(43.58,41.24),(41.62,41.24),(41.62,2.23),(41.45,2.23),(41.45,41.24),(38.95,41.24),(38.95,2.23),(38.78,2.23),(38.78,41.24),(36.82,41.24),(36.82,2.23),(36.65,2.23),(36.65,41.24),(34.15,41.24),(34.15,2.23),(33.98,2.23),(33.98,41.24),(32.02,41.24),(32.02,2.23),(31.85,2.23),(31.85,41.24),(29.35,41.24),(29.35,2.23),(29.18,2.23),(29.18,41.24),(27.22,41.24),(27.22,2.23),(27.05,2.23),(27.05,41.24),(24.55,41.24),(24.55,2.23),(24.38,2.23),(24.38,41.24),(22.42,41.24),(22.42,2.23),(22.25,2.23),(22.25,41.24),(19.75,41.24),(19.75,2.23),(19.58,2.23),(19.58,41.24),(17.62,41.24),(17.62,2.23),(17.45,2.23)),
        )
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        nets['gate'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_P18000W8728HFF']
        except:
            subcell = af.getCell('GuardRing_P18000W8728HFF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_N17368W8096HTF']
        except:
            subcell = af.getCell('GuardRing_N17368W8096HTF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Filler200']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.0), u(188),
        ))
        nets = {
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(1.0,152.0),(1.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(1.0,10.57),(1.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(1.0,22.34),(1.0,11.77),(0.0,11.77)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(1.0,152.0),(1.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(1.0,10.57),(1.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(1.0,22.34),(1.0,11.77),(0.0,11.77)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(1.0,152.0),(1.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(1.0,10.57),(1.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(1.0,22.34),(1.0,11.77),(0.0,11.77)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(1.0,9.17),(1.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(1.0,20.94),(1.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(1.0,150.6),(1.0,143.4),(0.0,143.4)),
        )
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(0.5), u(1.0), u(1.4), u(9.17),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(0.5), u(1.0), u(1.4), u(9.17),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(0.5), u(1.0), u(13.17), u(20.94),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(0.5), u(1.0), u(13.17), u(20.94),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(0.5), u(1.0), u(143.4), u(150.6),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(0.5), u(1.0), u(143.4), u(150.6),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(1.0,118.08),(1.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(1.0,133.04),(1.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(1.0,103.14),(1.0,89.4),(0.0,89.4)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(1.0,118.08),(1.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(1.0,133.04),(1.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(1.0,103.14),(1.0,89.4),(0.0,89.4)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(1.0,118.08),(1.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(1.0,133.04),(1.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(1.0,103.14),(1.0,89.4),(0.0,89.4)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(1.0,101.74),(1.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(1.0,131.64),(1.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(1.0,116.68),(1.0,105.74),(0.0,105.74)),
        )
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(0.5), u(1.0), u(90.8), u(101.74),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(0.5), u(1.0), u(90.8), u(101.74),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(0.5), u(1.0), u(120.7), u(131.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(0.5), u(1.0), u(120.7), u(131.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(0.5), u(1.0), u(105.74), u(116.68),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(0.5), u(1.0), u(105.74), u(116.68),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(1.0,172.4),(1.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(1.0,188.0),(1.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(1.0,188.0),(1.0,176.0),(0.0,176.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(176.0), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(176.0), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(1.0,188.0),(1.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(0.5), u(1.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(0.5), u(1.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(1.0,172.4),(1.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(0.5), u(1.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(0.5), u(1.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(1.0,170.0),(1.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(0.5), u(1.0), u(158.0), u(170.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(0.5), u(1.0), u(158.0), u(170.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['BulkConn_200WNoUp']
        except:
            subcell = af.getCell('BulkConn_200WNoUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_400WNoUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.08499999999998), u(2.0), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(2.0,0.125),(2.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(2.18,0.42),(2.18,-0.42),(-0.18,-0.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(2.125,0.25),(2.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(2.125,14.25),(2.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(2.125,8.75),(2.125,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(2.125,-6.18),(2.125,-30.085),(-0.125,-30.085)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(2.0,8.625),(2.0,8.375),(0.0,8.375)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(2.0,14.125),(2.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(2.18,14.42),(2.18,13.58),(-0.18,13.58)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(2.0,-6.305),(2.0,-29.96),(0.0,-29.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['Filler400']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(188),
        ))
        nets = {
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(2.0,22.34),(2.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(2.0,10.57),(2.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(2.0,152.0),(2.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(2.0,22.34),(2.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(2.0,10.57),(2.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(2.0,152.0),(2.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(2.0,22.34),(2.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(2.0,10.57),(2.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(2.0,152.0),(2.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(2.0,150.6),(2.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(2.0,20.94),(2.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(2.0,9.17),(2.0,1.4),(0.0,1.4)),
        )
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(1.0), u(2.0), u(143.4), u(150.6),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(1.0), u(2.0), u(143.4), u(150.6),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(1.0), u(2.0), u(13.17), u(20.94),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(1.0), u(2.0), u(13.17), u(20.94),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(1.0), u(2.0), u(1.4), u(9.17),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(1.0), u(2.0), u(1.4), u(9.17),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(2.0,103.14),(2.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(2.0,133.04),(2.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(2.0,118.08),(2.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(2.0,103.14),(2.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(2.0,133.04),(2.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(2.0,118.08),(2.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(2.0,103.14),(2.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(2.0,133.04),(2.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(2.0,118.08),(2.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(2.0,116.68),(2.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(2.0,131.64),(2.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(2.0,101.74),(2.0,90.8),(0.0,90.8)),
        )
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(1.0), u(2.0), u(105.74), u(116.68),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(1.0), u(2.0), u(105.74), u(116.68),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(1.0), u(2.0), u(120.7), u(131.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(1.0), u(2.0), u(120.7), u(131.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(1.0), u(2.0), u(90.8), u(101.74),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(1.0), u(2.0), u(90.8), u(101.74),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(2.0,172.4),(2.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(2.0,188.0),(2.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(2.0,188.0),(2.0,176.0),(0.0,176.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(176.0), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(176.0), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(2.0,188.0),(2.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(1.0), u(2.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(1.0), u(2.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(2.0,172.4),(2.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(1.0), u(2.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(1.0), u(2.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(2.0,170.0),(2.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(1.0), u(2.0), u(158.0), u(170.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(1.0), u(2.0), u(158.0), u(170.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['BulkConn_400WNoUp']
        except:
            subcell = af.getCell('BulkConn_400WNoUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_1000WNoUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.08499999999998), u(5.0), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(5.0,0.125),(5.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(5.18,0.42),(5.18,-0.42),(-0.18,-0.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(5.125,0.25),(5.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(5.125,14.25),(5.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(5.125,8.75),(5.125,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(5.125,-6.18),(5.125,-30.085),(-0.125,-30.085)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(5.0,8.625),(5.0,8.375),(0.0,8.375)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(5.0,14.125),(5.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(5.18,14.42),(5.18,13.58),(-0.18,13.58)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(5.0,-6.305),(5.0,-29.96),(0.0,-29.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['Filler1000']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(5.0), u(188),
        ))
        nets = {
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(5.0,10.57),(5.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(5.0,22.34),(5.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(5.0,152.0),(5.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(5.0,10.57),(5.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(5.0,22.34),(5.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(5.0,152.0),(5.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(5.0,10.57),(5.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(5.0,22.34),(5.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(5.0,152.0),(5.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(142.0), u(152.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(142.0), u(152.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(5.0,150.6),(5.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(5.0,9.17),(5.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(5.0,20.94),(5.0,13.17),(0.0,13.17)),
        )
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(2.5), u(5.0), u(143.4), u(150.6),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(2.5), u(5.0), u(143.4), u(150.6),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(2.5), u(5.0), u(1.4), u(9.17),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(2.5), u(5.0), u(1.4), u(9.17),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(2.5), u(5.0), u(13.17), u(20.94),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(2.5), u(5.0), u(13.17), u(20.94),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(5.0,103.14),(5.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(5.0,133.04),(5.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(5.0,118.08),(5.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(5.0,103.14),(5.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(5.0,133.04),(5.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(5.0,118.08),(5.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(5.0,103.14),(5.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(5.0,133.04),(5.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(5.0,118.08),(5.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(5.0,131.64),(5.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(5.0,116.68),(5.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(5.0,101.74),(5.0,90.8),(0.0,90.8)),
        )
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(2.5), u(5.0), u(120.7), u(131.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(2.5), u(5.0), u(120.7), u(131.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(2.5), u(5.0), u(105.74), u(116.68),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(2.5), u(5.0), u(105.74), u(116.68),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(2.5), u(5.0), u(90.8), u(101.74),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(2.5), u(5.0), u(90.8), u(101.74),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(5.0,172.4),(5.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(5.0,188.0),(5.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(5.0,188.0),(5.0,176.0),(0.0,176.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(176.0), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(176.0), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(5.0,188.0),(5.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(2.5), u(5.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(2.5), u(5.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(5.0,172.4),(5.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(2.5), u(5.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(2.5), u(5.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(5.0,170.0),(5.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(2.5), u(5.0), u(158.0), u(170.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(2.5), u(5.0), u(158.0), u(170.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['BulkConn_1000WNoUp']
        except:
            subcell = af.getCell('BulkConn_1000WNoUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_2000WNoUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.08499999999998), u(10.0), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(10.0,0.125),(10.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(10.18,0.42),(10.18,-0.42),(-0.18,-0.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(10.125,0.25),(10.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(10.125,14.25),(10.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(10.125,-6.18),(10.125,-30.085),(-0.125,-30.085)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(10.125,8.75),(10.125,8.25),(-0.125,8.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(10.0,8.625),(10.0,8.375),(0.0,8.375)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(10.0,14.125),(10.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(10.18,14.42),(10.18,13.58),(-0.18,13.58)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(10.0,-6.305),(10.0,-29.96),(0.0,-29.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['Filler2000']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(10.0), u(188),
        ))
        nets = {
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(10.0,22.34),(10.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(10.0,10.57),(10.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(10.0,152.0),(10.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(10.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(10.0,22.34),(10.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(10.0,10.57),(10.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(10.0,152.0),(10.0,142.0),(0.0,142.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(10.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(10.0,22.34),(10.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(10.0,10.57),(10.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(10.0,152.0),(10.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(10.0,150.6),(10.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(10.0,20.94),(10.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(10.0,9.17),(10.0,1.4),(0.0,1.4)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(11.77), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(11.77), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(0.0), u(10.57),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(0.0), u(10.57),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(10.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(10.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(10.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(10.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(10.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(10.0,103.14),(10.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(10.0,133.04),(10.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(10.0,118.08),(10.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(10.0,103.14),(10.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(10.0,133.04),(10.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(10.0,118.08),(10.0,104.34),(0.0,104.34)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(10.0,103.14),(10.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(10.0,133.04),(10.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(10.0,118.08),(10.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(10.0,116.68),(10.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(10.0,131.64),(10.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(10.0,101.74),(10.0,90.8),(0.0,90.8)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(89.4), u(103.14),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(89.4), u(103.14),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(119.3), u(133.04),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(119.3), u(133.04),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(104.34), u(118.08),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(104.34), u(118.08),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(5.0), u(10.0), u(105.74), u(116.68),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(5.0), u(10.0), u(105.74), u(116.68),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(5.0), u(10.0), u(120.7), u(131.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(5.0), u(10.0), u(120.7), u(131.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m5.pin'),
            u(5.0), u(10.0), u(90.8), u(101.74),
        )
        pin = Vertical.create(
            net, tech.getLayer('m5'),
            u(5.0), u(10.0), u(90.8), u(101.74),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(10.0,172.4),(10.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(10.0,188.0),(10.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(10.0,188.0),(10.0,176.0),(0.0,176.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(176.0), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(176.0), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(10.0,188.0),(10.0,173.6),(0.0,173.6)),
        )
        Vertical.create(
            net, tech.getLayer('m2.pin'),
            u(5.0), u(10.0), u(173.6), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m2'),
            u(5.0), u(10.0), u(173.6), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(10.0,172.4),(10.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m4.pin'),
            u(5.0), u(10.0), u(158.0), u(172.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('m4'),
            u(5.0), u(10.0), u(158.0), u(172.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(10.0,170.0),(10.0,158.0),(0.0,158.0)),
        )
        Vertical.create(
            net, tech.getLayer('m3.pin'),
            u(5.0), u(10.0), u(158.0), u(170.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m3'),
            u(5.0), u(10.0), u(158.0), u(170.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['BulkConn_2000WNoUp']
        except:
            subcell = af.getCell('BulkConn_2000WNoUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_4000WNoUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.08499999999998), u(20.0), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(20.0,0.125),(20.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(20.18,0.42),(20.18,-0.42),(-0.18,-0.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(20.125,14.25),(20.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(20.125,0.25),(20.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(20.125,8.75),(20.125,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(20.125,-6.18),(20.125,-30.085),(-0.125,-30.085)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(20.0,8.625),(20.0,8.375),(0.0,8.375)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(20.0,14.125),(20.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(20.18,14.42),(20.18,13.58),(-0.18,13.58)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(20.0,-6.305),(20.0,-29.96),(0.0,-29.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['Filler4000']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(20.0), u(188),
        ))
        nets = {
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(20.0,152.0),(20.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(20.0,10.57),(20.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(20.0,22.34),(20.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,13.755),(1.9,13.955),(2.1,13.955),(2.1,13.755),(1.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,13.755),(3.5,13.955),(3.7,13.955),(3.7,13.755),(3.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,13.755),(5.1,13.955),(5.3,13.955),(5.3,13.755),(5.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,13.755),(6.7,13.955),(6.9,13.955),(6.9,13.755),(6.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,13.755),(8.3,13.955),(8.5,13.955),(8.5,13.755),(8.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,13.755),(9.9,13.955),(10.1,13.955),(10.1,13.755),(9.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,13.755),(11.5,13.955),(11.7,13.955),(11.7,13.755),(11.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,13.755),(13.1,13.955),(13.3,13.955),(13.3,13.755),(13.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,13.755),(14.7,13.955),(14.9,13.955),(14.9,13.755),(14.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,13.755),(16.3,13.955),(16.5,13.955),(16.5,13.755),(16.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,13.755),(17.9,13.955),(18.1,13.955),(18.1,13.755),(17.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,15.355),(1.9,15.555),(2.1,15.555),(2.1,15.355),(1.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,15.355),(3.5,15.555),(3.7,15.555),(3.7,15.355),(3.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,15.355),(5.1,15.555),(5.3,15.555),(5.3,15.355),(5.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,15.355),(6.7,15.555),(6.9,15.555),(6.9,15.355),(6.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,15.355),(8.3,15.555),(8.5,15.555),(8.5,15.355),(8.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,15.355),(9.9,15.555),(10.1,15.555),(10.1,15.355),(9.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,15.355),(11.5,15.555),(11.7,15.555),(11.7,15.355),(11.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,15.355),(13.1,15.555),(13.3,15.555),(13.3,15.355),(13.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,15.355),(14.7,15.555),(14.9,15.555),(14.9,15.355),(14.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,15.355),(16.3,15.555),(16.5,15.555),(16.5,15.355),(16.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,15.355),(17.9,15.555),(18.1,15.555),(18.1,15.355),(17.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,16.955),(1.9,17.155),(2.1,17.155),(2.1,16.955),(1.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,16.955),(3.5,17.155),(3.7,17.155),(3.7,16.955),(3.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,16.955),(5.1,17.155),(5.3,17.155),(5.3,16.955),(5.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,16.955),(6.7,17.155),(6.9,17.155),(6.9,16.955),(6.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,16.955),(8.3,17.155),(8.5,17.155),(8.5,16.955),(8.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,16.955),(9.9,17.155),(10.1,17.155),(10.1,16.955),(9.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,16.955),(11.5,17.155),(11.7,17.155),(11.7,16.955),(11.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,16.955),(13.1,17.155),(13.3,17.155),(13.3,16.955),(13.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,16.955),(14.7,17.155),(14.9,17.155),(14.9,16.955),(14.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,16.955),(16.3,17.155),(16.5,17.155),(16.5,16.955),(16.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,16.955),(17.9,17.155),(18.1,17.155),(18.1,16.955),(17.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,18.555),(1.9,18.755),(2.1,18.755),(2.1,18.555),(1.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,18.555),(3.5,18.755),(3.7,18.755),(3.7,18.555),(3.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,18.555),(5.1,18.755),(5.3,18.755),(5.3,18.555),(5.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,18.555),(6.7,18.755),(6.9,18.755),(6.9,18.555),(6.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,18.555),(8.3,18.755),(8.5,18.755),(8.5,18.555),(8.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,18.555),(9.9,18.755),(10.1,18.755),(10.1,18.555),(9.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,18.555),(11.5,18.755),(11.7,18.755),(11.7,18.555),(11.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,18.555),(13.1,18.755),(13.3,18.755),(13.3,18.555),(13.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,18.555),(14.7,18.755),(14.9,18.755),(14.9,18.555),(14.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,18.555),(16.3,18.755),(16.5,18.755),(16.5,18.555),(16.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,18.555),(17.9,18.755),(18.1,18.755),(18.1,18.555),(17.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,20.155),(1.9,20.355),(2.1,20.355),(2.1,20.155),(1.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,20.155),(3.5,20.355),(3.7,20.355),(3.7,20.155),(3.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,20.155),(5.1,20.355),(5.3,20.355),(5.3,20.155),(5.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,20.155),(6.7,20.355),(6.9,20.355),(6.9,20.155),(6.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,20.155),(8.3,20.355),(8.5,20.355),(8.5,20.155),(8.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,20.155),(9.9,20.355),(10.1,20.355),(10.1,20.155),(9.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,20.155),(11.5,20.355),(11.7,20.355),(11.7,20.155),(11.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,20.155),(13.1,20.355),(13.3,20.355),(13.3,20.155),(13.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,20.155),(14.7,20.355),(14.9,20.355),(14.9,20.155),(14.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,20.155),(16.3,20.355),(16.5,20.355),(16.5,20.155),(16.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,20.155),(17.9,20.355),(18.1,20.355),(18.1,20.155),(17.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,1.985),(1.9,2.185),(2.1,2.185),(2.1,1.985),(1.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,1.985),(3.5,2.185),(3.7,2.185),(3.7,1.985),(3.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,1.985),(5.1,2.185),(5.3,2.185),(5.3,1.985),(5.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,1.985),(6.7,2.185),(6.9,2.185),(6.9,1.985),(6.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,1.985),(8.3,2.185),(8.5,2.185),(8.5,1.985),(8.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,1.985),(9.9,2.185),(10.1,2.185),(10.1,1.985),(9.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,1.985),(11.5,2.185),(11.7,2.185),(11.7,1.985),(11.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,1.985),(13.1,2.185),(13.3,2.185),(13.3,1.985),(13.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,1.985),(14.7,2.185),(14.9,2.185),(14.9,1.985),(14.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,1.985),(16.3,2.185),(16.5,2.185),(16.5,1.985),(16.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,1.985),(17.9,2.185),(18.1,2.185),(18.1,1.985),(17.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,3.585),(1.9,3.785),(2.1,3.785),(2.1,3.585),(1.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,3.585),(3.5,3.785),(3.7,3.785),(3.7,3.585),(3.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,3.585),(5.1,3.785),(5.3,3.785),(5.3,3.585),(5.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,3.585),(6.7,3.785),(6.9,3.785),(6.9,3.585),(6.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,3.585),(8.3,3.785),(8.5,3.785),(8.5,3.585),(8.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,3.585),(9.9,3.785),(10.1,3.785),(10.1,3.585),(9.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,3.585),(11.5,3.785),(11.7,3.785),(11.7,3.585),(11.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,3.585),(13.1,3.785),(13.3,3.785),(13.3,3.585),(13.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,3.585),(14.7,3.785),(14.9,3.785),(14.9,3.585),(14.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,3.585),(16.3,3.785),(16.5,3.785),(16.5,3.585),(16.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,3.585),(17.9,3.785),(18.1,3.785),(18.1,3.585),(17.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,5.185),(1.9,5.385),(2.1,5.385),(2.1,5.185),(1.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,5.185),(3.5,5.385),(3.7,5.385),(3.7,5.185),(3.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,5.185),(5.1,5.385),(5.3,5.385),(5.3,5.185),(5.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,5.185),(6.7,5.385),(6.9,5.385),(6.9,5.185),(6.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,5.185),(8.3,5.385),(8.5,5.385),(8.5,5.185),(8.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,5.185),(9.9,5.385),(10.1,5.385),(10.1,5.185),(9.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,5.185),(11.5,5.385),(11.7,5.385),(11.7,5.185),(11.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,5.185),(13.1,5.385),(13.3,5.385),(13.3,5.185),(13.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,5.185),(14.7,5.385),(14.9,5.385),(14.9,5.185),(14.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,5.185),(16.3,5.385),(16.5,5.385),(16.5,5.185),(16.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,5.185),(17.9,5.385),(18.1,5.385),(18.1,5.185),(17.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,6.785),(1.9,6.985),(2.1,6.985),(2.1,6.785),(1.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,6.785),(3.5,6.985),(3.7,6.985),(3.7,6.785),(3.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,6.785),(5.1,6.985),(5.3,6.985),(5.3,6.785),(5.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,6.785),(6.7,6.985),(6.9,6.985),(6.9,6.785),(6.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,6.785),(8.3,6.985),(8.5,6.985),(8.5,6.785),(8.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,6.785),(9.9,6.985),(10.1,6.985),(10.1,6.785),(9.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,6.785),(11.5,6.985),(11.7,6.985),(11.7,6.785),(11.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,6.785),(13.1,6.985),(13.3,6.985),(13.3,6.785),(13.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,6.785),(14.7,6.985),(14.9,6.985),(14.9,6.785),(14.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,6.785),(16.3,6.985),(16.5,6.985),(16.5,6.785),(16.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,6.785),(17.9,6.985),(18.1,6.985),(18.1,6.785),(17.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,8.385),(1.9,8.585),(2.1,8.585),(2.1,8.385),(1.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,8.385),(3.5,8.585),(3.7,8.585),(3.7,8.385),(3.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,8.385),(5.1,8.585),(5.3,8.585),(5.3,8.385),(5.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,8.385),(6.7,8.585),(6.9,8.585),(6.9,8.385),(6.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,8.385),(8.3,8.585),(8.5,8.585),(8.5,8.385),(8.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,8.385),(9.9,8.585),(10.1,8.585),(10.1,8.385),(9.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,8.385),(11.5,8.585),(11.7,8.585),(11.7,8.385),(11.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,8.385),(13.1,8.585),(13.3,8.585),(13.3,8.385),(13.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,8.385),(14.7,8.585),(14.9,8.585),(14.9,8.385),(14.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,8.385),(16.3,8.585),(16.5,8.585),(16.5,8.385),(16.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,8.385),(17.9,8.585),(18.1,8.585),(18.1,8.385),(17.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,143.7),(1.9,143.9),(2.1,143.9),(2.1,143.7),(1.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,143.7),(3.5,143.9),(3.7,143.9),(3.7,143.7),(3.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,143.7),(5.1,143.9),(5.3,143.9),(5.3,143.7),(5.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,143.7),(6.7,143.9),(6.9,143.9),(6.9,143.7),(6.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,143.7),(8.3,143.9),(8.5,143.9),(8.5,143.7),(8.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,143.7),(9.9,143.9),(10.1,143.9),(10.1,143.7),(9.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,143.7),(11.5,143.9),(11.7,143.9),(11.7,143.7),(11.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,143.7),(13.1,143.9),(13.3,143.9),(13.3,143.7),(13.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,143.7),(14.7,143.9),(14.9,143.9),(14.9,143.7),(14.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,143.7),(16.3,143.9),(16.5,143.9),(16.5,143.7),(16.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,143.7),(17.9,143.9),(18.1,143.9),(18.1,143.7),(17.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,145.3),(1.9,145.5),(2.1,145.5),(2.1,145.3),(1.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,145.3),(3.5,145.5),(3.7,145.5),(3.7,145.3),(3.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,145.3),(5.1,145.5),(5.3,145.5),(5.3,145.3),(5.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,145.3),(6.7,145.5),(6.9,145.5),(6.9,145.3),(6.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,145.3),(8.3,145.5),(8.5,145.5),(8.5,145.3),(8.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,145.3),(9.9,145.5),(10.1,145.5),(10.1,145.3),(9.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,145.3),(11.5,145.5),(11.7,145.5),(11.7,145.3),(11.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,145.3),(13.1,145.5),(13.3,145.5),(13.3,145.3),(13.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,145.3),(14.7,145.5),(14.9,145.5),(14.9,145.3),(14.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,145.3),(16.3,145.5),(16.5,145.5),(16.5,145.3),(16.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,145.3),(17.9,145.5),(18.1,145.5),(18.1,145.3),(17.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,146.9),(1.9,147.1),(2.1,147.1),(2.1,146.9),(1.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,146.9),(3.5,147.1),(3.7,147.1),(3.7,146.9),(3.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,146.9),(5.1,147.1),(5.3,147.1),(5.3,146.9),(5.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,146.9),(6.7,147.1),(6.9,147.1),(6.9,146.9),(6.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,146.9),(8.3,147.1),(8.5,147.1),(8.5,146.9),(8.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,146.9),(9.9,147.1),(10.1,147.1),(10.1,146.9),(9.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,146.9),(11.5,147.1),(11.7,147.1),(11.7,146.9),(11.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,146.9),(13.1,147.1),(13.3,147.1),(13.3,146.9),(13.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,146.9),(14.7,147.1),(14.9,147.1),(14.9,146.9),(14.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,146.9),(16.3,147.1),(16.5,147.1),(16.5,146.9),(16.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,146.9),(17.9,147.1),(18.1,147.1),(18.1,146.9),(17.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,148.5),(1.9,148.7),(2.1,148.7),(2.1,148.5),(1.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,148.5),(3.5,148.7),(3.7,148.7),(3.7,148.5),(3.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,148.5),(5.1,148.7),(5.3,148.7),(5.3,148.5),(5.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,148.5),(6.7,148.7),(6.9,148.7),(6.9,148.5),(6.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,148.5),(8.3,148.7),(8.5,148.7),(8.5,148.5),(8.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,148.5),(9.9,148.7),(10.1,148.7),(10.1,148.5),(9.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,148.5),(11.5,148.7),(11.7,148.7),(11.7,148.5),(11.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,148.5),(13.1,148.7),(13.3,148.7),(13.3,148.5),(13.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,148.5),(14.7,148.7),(14.9,148.7),(14.9,148.5),(14.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,148.5),(16.3,148.7),(16.5,148.7),(16.5,148.5),(16.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,148.5),(17.9,148.7),(18.1,148.7),(18.1,148.5),(17.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,150.1),(1.9,150.3),(2.1,150.3),(2.1,150.1),(1.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,150.1),(3.5,150.3),(3.7,150.3),(3.7,150.1),(3.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,150.1),(5.1,150.3),(5.3,150.3),(5.3,150.1),(5.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,150.1),(6.7,150.3),(6.9,150.3),(6.9,150.1),(6.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,150.1),(8.3,150.3),(8.5,150.3),(8.5,150.1),(8.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,150.1),(9.9,150.3),(10.1,150.3),(10.1,150.1),(9.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,150.1),(11.5,150.3),(11.7,150.3),(11.7,150.1),(11.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,150.1),(13.1,150.3),(13.3,150.3),(13.3,150.1),(13.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,150.1),(14.7,150.3),(14.9,150.3),(14.9,150.1),(14.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,150.1),(16.3,150.3),(16.5,150.3),(16.5,150.1),(16.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,150.1),(17.9,150.3),(18.1,150.3),(18.1,150.1),(17.9,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(20.0,152.0),(20.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(20.0,10.57),(20.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(20.0,22.34),(20.0,11.77),(0.0,11.77)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.9,13.755),(1.9,13.955),(2.1,13.955),(2.1,13.755),(1.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,13.755),(3.5,13.955),(3.7,13.955),(3.7,13.755),(3.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,13.755),(5.1,13.955),(5.3,13.955),(5.3,13.755),(5.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,13.755),(6.7,13.955),(6.9,13.955),(6.9,13.755),(6.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,13.755),(8.3,13.955),(8.5,13.955),(8.5,13.755),(8.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,13.755),(9.9,13.955),(10.1,13.955),(10.1,13.755),(9.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,13.755),(11.5,13.955),(11.7,13.955),(11.7,13.755),(11.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,13.755),(13.1,13.955),(13.3,13.955),(13.3,13.755),(13.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,13.755),(14.7,13.955),(14.9,13.955),(14.9,13.755),(14.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,13.755),(16.3,13.955),(16.5,13.955),(16.5,13.755),(16.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,13.755),(17.9,13.955),(18.1,13.955),(18.1,13.755),(17.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,15.355),(1.9,15.555),(2.1,15.555),(2.1,15.355),(1.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,15.355),(3.5,15.555),(3.7,15.555),(3.7,15.355),(3.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,15.355),(5.1,15.555),(5.3,15.555),(5.3,15.355),(5.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,15.355),(6.7,15.555),(6.9,15.555),(6.9,15.355),(6.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,15.355),(8.3,15.555),(8.5,15.555),(8.5,15.355),(8.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,15.355),(9.9,15.555),(10.1,15.555),(10.1,15.355),(9.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,15.355),(11.5,15.555),(11.7,15.555),(11.7,15.355),(11.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,15.355),(13.1,15.555),(13.3,15.555),(13.3,15.355),(13.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,15.355),(14.7,15.555),(14.9,15.555),(14.9,15.355),(14.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,15.355),(16.3,15.555),(16.5,15.555),(16.5,15.355),(16.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,15.355),(17.9,15.555),(18.1,15.555),(18.1,15.355),(17.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,16.955),(1.9,17.155),(2.1,17.155),(2.1,16.955),(1.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,16.955),(3.5,17.155),(3.7,17.155),(3.7,16.955),(3.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,16.955),(5.1,17.155),(5.3,17.155),(5.3,16.955),(5.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,16.955),(6.7,17.155),(6.9,17.155),(6.9,16.955),(6.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,16.955),(8.3,17.155),(8.5,17.155),(8.5,16.955),(8.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,16.955),(9.9,17.155),(10.1,17.155),(10.1,16.955),(9.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,16.955),(11.5,17.155),(11.7,17.155),(11.7,16.955),(11.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,16.955),(13.1,17.155),(13.3,17.155),(13.3,16.955),(13.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,16.955),(14.7,17.155),(14.9,17.155),(14.9,16.955),(14.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,16.955),(16.3,17.155),(16.5,17.155),(16.5,16.955),(16.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,16.955),(17.9,17.155),(18.1,17.155),(18.1,16.955),(17.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,18.555),(1.9,18.755),(2.1,18.755),(2.1,18.555),(1.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,18.555),(3.5,18.755),(3.7,18.755),(3.7,18.555),(3.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,18.555),(5.1,18.755),(5.3,18.755),(5.3,18.555),(5.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,18.555),(6.7,18.755),(6.9,18.755),(6.9,18.555),(6.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,18.555),(8.3,18.755),(8.5,18.755),(8.5,18.555),(8.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,18.555),(9.9,18.755),(10.1,18.755),(10.1,18.555),(9.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,18.555),(11.5,18.755),(11.7,18.755),(11.7,18.555),(11.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,18.555),(13.1,18.755),(13.3,18.755),(13.3,18.555),(13.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,18.555),(14.7,18.755),(14.9,18.755),(14.9,18.555),(14.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,18.555),(16.3,18.755),(16.5,18.755),(16.5,18.555),(16.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,18.555),(17.9,18.755),(18.1,18.755),(18.1,18.555),(17.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,20.155),(1.9,20.355),(2.1,20.355),(2.1,20.155),(1.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,20.155),(3.5,20.355),(3.7,20.355),(3.7,20.155),(3.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,20.155),(5.1,20.355),(5.3,20.355),(5.3,20.155),(5.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,20.155),(6.7,20.355),(6.9,20.355),(6.9,20.155),(6.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,20.155),(8.3,20.355),(8.5,20.355),(8.5,20.155),(8.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,20.155),(9.9,20.355),(10.1,20.355),(10.1,20.155),(9.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,20.155),(11.5,20.355),(11.7,20.355),(11.7,20.155),(11.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,20.155),(13.1,20.355),(13.3,20.355),(13.3,20.155),(13.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,20.155),(14.7,20.355),(14.9,20.355),(14.9,20.155),(14.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,20.155),(16.3,20.355),(16.5,20.355),(16.5,20.155),(16.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,20.155),(17.9,20.355),(18.1,20.355),(18.1,20.155),(17.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,1.985),(1.9,2.185),(2.1,2.185),(2.1,1.985),(1.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,1.985),(3.5,2.185),(3.7,2.185),(3.7,1.985),(3.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,1.985),(5.1,2.185),(5.3,2.185),(5.3,1.985),(5.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,1.985),(6.7,2.185),(6.9,2.185),(6.9,1.985),(6.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,1.985),(8.3,2.185),(8.5,2.185),(8.5,1.985),(8.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,1.985),(9.9,2.185),(10.1,2.185),(10.1,1.985),(9.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,1.985),(11.5,2.185),(11.7,2.185),(11.7,1.985),(11.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,1.985),(13.1,2.185),(13.3,2.185),(13.3,1.985),(13.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,1.985),(14.7,2.185),(14.9,2.185),(14.9,1.985),(14.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,1.985),(16.3,2.185),(16.5,2.185),(16.5,1.985),(16.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,1.985),(17.9,2.185),(18.1,2.185),(18.1,1.985),(17.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,3.585),(1.9,3.785),(2.1,3.785),(2.1,3.585),(1.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,3.585),(3.5,3.785),(3.7,3.785),(3.7,3.585),(3.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,3.585),(5.1,3.785),(5.3,3.785),(5.3,3.585),(5.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,3.585),(6.7,3.785),(6.9,3.785),(6.9,3.585),(6.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,3.585),(8.3,3.785),(8.5,3.785),(8.5,3.585),(8.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,3.585),(9.9,3.785),(10.1,3.785),(10.1,3.585),(9.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,3.585),(11.5,3.785),(11.7,3.785),(11.7,3.585),(11.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,3.585),(13.1,3.785),(13.3,3.785),(13.3,3.585),(13.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,3.585),(14.7,3.785),(14.9,3.785),(14.9,3.585),(14.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,3.585),(16.3,3.785),(16.5,3.785),(16.5,3.585),(16.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,3.585),(17.9,3.785),(18.1,3.785),(18.1,3.585),(17.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,5.185),(1.9,5.385),(2.1,5.385),(2.1,5.185),(1.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,5.185),(3.5,5.385),(3.7,5.385),(3.7,5.185),(3.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,5.185),(5.1,5.385),(5.3,5.385),(5.3,5.185),(5.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,5.185),(6.7,5.385),(6.9,5.385),(6.9,5.185),(6.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,5.185),(8.3,5.385),(8.5,5.385),(8.5,5.185),(8.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,5.185),(9.9,5.385),(10.1,5.385),(10.1,5.185),(9.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,5.185),(11.5,5.385),(11.7,5.385),(11.7,5.185),(11.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,5.185),(13.1,5.385),(13.3,5.385),(13.3,5.185),(13.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,5.185),(14.7,5.385),(14.9,5.385),(14.9,5.185),(14.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,5.185),(16.3,5.385),(16.5,5.385),(16.5,5.185),(16.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,5.185),(17.9,5.385),(18.1,5.385),(18.1,5.185),(17.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,6.785),(1.9,6.985),(2.1,6.985),(2.1,6.785),(1.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,6.785),(3.5,6.985),(3.7,6.985),(3.7,6.785),(3.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,6.785),(5.1,6.985),(5.3,6.985),(5.3,6.785),(5.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,6.785),(6.7,6.985),(6.9,6.985),(6.9,6.785),(6.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,6.785),(8.3,6.985),(8.5,6.985),(8.5,6.785),(8.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,6.785),(9.9,6.985),(10.1,6.985),(10.1,6.785),(9.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,6.785),(11.5,6.985),(11.7,6.985),(11.7,6.785),(11.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,6.785),(13.1,6.985),(13.3,6.985),(13.3,6.785),(13.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,6.785),(14.7,6.985),(14.9,6.985),(14.9,6.785),(14.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,6.785),(16.3,6.985),(16.5,6.985),(16.5,6.785),(16.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,6.785),(17.9,6.985),(18.1,6.985),(18.1,6.785),(17.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,8.385),(1.9,8.585),(2.1,8.585),(2.1,8.385),(1.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,8.385),(3.5,8.585),(3.7,8.585),(3.7,8.385),(3.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,8.385),(5.1,8.585),(5.3,8.585),(5.3,8.385),(5.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,8.385),(6.7,8.585),(6.9,8.585),(6.9,8.385),(6.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,8.385),(8.3,8.585),(8.5,8.585),(8.5,8.385),(8.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,8.385),(9.9,8.585),(10.1,8.585),(10.1,8.385),(9.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,8.385),(11.5,8.585),(11.7,8.585),(11.7,8.385),(11.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,8.385),(13.1,8.585),(13.3,8.585),(13.3,8.385),(13.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,8.385),(14.7,8.585),(14.9,8.585),(14.9,8.385),(14.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,8.385),(16.3,8.585),(16.5,8.585),(16.5,8.385),(16.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,8.385),(17.9,8.585),(18.1,8.585),(18.1,8.385),(17.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,143.7),(1.9,143.9),(2.1,143.9),(2.1,143.7),(1.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,143.7),(3.5,143.9),(3.7,143.9),(3.7,143.7),(3.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,143.7),(5.1,143.9),(5.3,143.9),(5.3,143.7),(5.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,143.7),(6.7,143.9),(6.9,143.9),(6.9,143.7),(6.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,143.7),(8.3,143.9),(8.5,143.9),(8.5,143.7),(8.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,143.7),(9.9,143.9),(10.1,143.9),(10.1,143.7),(9.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,143.7),(11.5,143.9),(11.7,143.9),(11.7,143.7),(11.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,143.7),(13.1,143.9),(13.3,143.9),(13.3,143.7),(13.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,143.7),(14.7,143.9),(14.9,143.9),(14.9,143.7),(14.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,143.7),(16.3,143.9),(16.5,143.9),(16.5,143.7),(16.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,143.7),(17.9,143.9),(18.1,143.9),(18.1,143.7),(17.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,145.3),(1.9,145.5),(2.1,145.5),(2.1,145.3),(1.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,145.3),(3.5,145.5),(3.7,145.5),(3.7,145.3),(3.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,145.3),(5.1,145.5),(5.3,145.5),(5.3,145.3),(5.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,145.3),(6.7,145.5),(6.9,145.5),(6.9,145.3),(6.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,145.3),(8.3,145.5),(8.5,145.5),(8.5,145.3),(8.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,145.3),(9.9,145.5),(10.1,145.5),(10.1,145.3),(9.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,145.3),(11.5,145.5),(11.7,145.5),(11.7,145.3),(11.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,145.3),(13.1,145.5),(13.3,145.5),(13.3,145.3),(13.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,145.3),(14.7,145.5),(14.9,145.5),(14.9,145.3),(14.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,145.3),(16.3,145.5),(16.5,145.5),(16.5,145.3),(16.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,145.3),(17.9,145.5),(18.1,145.5),(18.1,145.3),(17.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,146.9),(1.9,147.1),(2.1,147.1),(2.1,146.9),(1.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,146.9),(3.5,147.1),(3.7,147.1),(3.7,146.9),(3.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,146.9),(5.1,147.1),(5.3,147.1),(5.3,146.9),(5.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,146.9),(6.7,147.1),(6.9,147.1),(6.9,146.9),(6.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,146.9),(8.3,147.1),(8.5,147.1),(8.5,146.9),(8.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,146.9),(9.9,147.1),(10.1,147.1),(10.1,146.9),(9.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,146.9),(11.5,147.1),(11.7,147.1),(11.7,146.9),(11.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,146.9),(13.1,147.1),(13.3,147.1),(13.3,146.9),(13.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,146.9),(14.7,147.1),(14.9,147.1),(14.9,146.9),(14.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,146.9),(16.3,147.1),(16.5,147.1),(16.5,146.9),(16.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,146.9),(17.9,147.1),(18.1,147.1),(18.1,146.9),(17.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,148.5),(1.9,148.7),(2.1,148.7),(2.1,148.5),(1.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,148.5),(3.5,148.7),(3.7,148.7),(3.7,148.5),(3.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,148.5),(5.1,148.7),(5.3,148.7),(5.3,148.5),(5.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,148.5),(6.7,148.7),(6.9,148.7),(6.9,148.5),(6.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,148.5),(8.3,148.7),(8.5,148.7),(8.5,148.5),(8.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,148.5),(9.9,148.7),(10.1,148.7),(10.1,148.5),(9.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,148.5),(11.5,148.7),(11.7,148.7),(11.7,148.5),(11.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,148.5),(13.1,148.7),(13.3,148.7),(13.3,148.5),(13.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,148.5),(14.7,148.7),(14.9,148.7),(14.9,148.5),(14.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,148.5),(16.3,148.7),(16.5,148.7),(16.5,148.5),(16.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,148.5),(17.9,148.7),(18.1,148.7),(18.1,148.5),(17.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,150.1),(1.9,150.3),(2.1,150.3),(2.1,150.1),(1.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,150.1),(3.5,150.3),(3.7,150.3),(3.7,150.1),(3.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,150.1),(5.1,150.3),(5.3,150.3),(5.3,150.1),(5.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,150.1),(6.7,150.3),(6.9,150.3),(6.9,150.1),(6.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,150.1),(8.3,150.3),(8.5,150.3),(8.5,150.1),(8.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,150.1),(9.9,150.3),(10.1,150.3),(10.1,150.1),(9.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,150.1),(11.5,150.3),(11.7,150.3),(11.7,150.1),(11.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,150.1),(13.1,150.3),(13.3,150.3),(13.3,150.1),(13.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,150.1),(14.7,150.3),(14.9,150.3),(14.9,150.1),(14.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,150.1),(16.3,150.3),(16.5,150.3),(16.5,150.1),(16.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,150.1),(17.9,150.3),(18.1,150.3),(18.1,150.1),(17.9,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(20.0,152.0),(20.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(20.0,10.57),(20.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(20.0,22.34),(20.0,11.77),(0.0,11.77)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((0.8,14.255),(0.8,15.055),(1.6,15.055),(1.6,14.255),(0.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,14.255),(2.4,15.055),(3.2,15.055),(3.2,14.255),(2.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,14.255),(4.0,15.055),(4.8,15.055),(4.8,14.255),(4.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,14.255),(5.6,15.055),(6.4,15.055),(6.4,14.255),(5.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,14.255),(7.2,15.055),(8.0,15.055),(8.0,14.255),(7.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,14.255),(8.8,15.055),(9.6,15.055),(9.6,14.255),(8.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,14.255),(10.4,15.055),(11.2,15.055),(11.2,14.255),(10.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,14.255),(12.0,15.055),(12.8,15.055),(12.8,14.255),(12.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,14.255),(13.6,15.055),(14.4,15.055),(14.4,14.255),(13.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,14.255),(15.2,15.055),(16.0,15.055),(16.0,14.255),(15.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,14.255),(16.8,15.055),(17.6,15.055),(17.6,14.255),(16.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,14.255),(18.4,15.055),(19.2,15.055),(19.2,14.255),(18.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,15.855),(0.8,16.655),(1.6,16.655),(1.6,15.855),(0.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,15.855),(2.4,16.655),(3.2,16.655),(3.2,15.855),(2.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,15.855),(4.0,16.655),(4.8,16.655),(4.8,15.855),(4.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,15.855),(5.6,16.655),(6.4,16.655),(6.4,15.855),(5.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,15.855),(7.2,16.655),(8.0,16.655),(8.0,15.855),(7.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,15.855),(8.8,16.655),(9.6,16.655),(9.6,15.855),(8.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,15.855),(10.4,16.655),(11.2,16.655),(11.2,15.855),(10.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,15.855),(12.0,16.655),(12.8,16.655),(12.8,15.855),(12.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,15.855),(13.6,16.655),(14.4,16.655),(14.4,15.855),(13.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,15.855),(15.2,16.655),(16.0,16.655),(16.0,15.855),(15.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,15.855),(16.8,16.655),(17.6,16.655),(17.6,15.855),(16.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,15.855),(18.4,16.655),(19.2,16.655),(19.2,15.855),(18.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,17.455),(0.8,18.255),(1.6,18.255),(1.6,17.455),(0.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,17.455),(2.4,18.255),(3.2,18.255),(3.2,17.455),(2.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,17.455),(4.0,18.255),(4.8,18.255),(4.8,17.455),(4.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,17.455),(5.6,18.255),(6.4,18.255),(6.4,17.455),(5.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,17.455),(7.2,18.255),(8.0,18.255),(8.0,17.455),(7.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,17.455),(8.8,18.255),(9.6,18.255),(9.6,17.455),(8.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,17.455),(10.4,18.255),(11.2,18.255),(11.2,17.455),(10.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,17.455),(12.0,18.255),(12.8,18.255),(12.8,17.455),(12.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,17.455),(13.6,18.255),(14.4,18.255),(14.4,17.455),(13.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,17.455),(15.2,18.255),(16.0,18.255),(16.0,17.455),(15.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,17.455),(16.8,18.255),(17.6,18.255),(17.6,17.455),(16.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,17.455),(18.4,18.255),(19.2,18.255),(19.2,17.455),(18.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,19.055),(0.8,19.855),(1.6,19.855),(1.6,19.055),(0.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,19.055),(2.4,19.855),(3.2,19.855),(3.2,19.055),(2.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,19.055),(4.0,19.855),(4.8,19.855),(4.8,19.055),(4.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,19.055),(5.6,19.855),(6.4,19.855),(6.4,19.055),(5.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,19.055),(7.2,19.855),(8.0,19.855),(8.0,19.055),(7.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,19.055),(8.8,19.855),(9.6,19.855),(9.6,19.055),(8.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,19.055),(10.4,19.855),(11.2,19.855),(11.2,19.055),(10.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,19.055),(12.0,19.855),(12.8,19.855),(12.8,19.055),(12.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,19.055),(13.6,19.855),(14.4,19.855),(14.4,19.055),(13.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,19.055),(15.2,19.855),(16.0,19.855),(16.0,19.055),(15.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,19.055),(16.8,19.855),(17.6,19.855),(17.6,19.055),(16.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,19.055),(18.4,19.855),(19.2,19.855),(19.2,19.055),(18.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,145.0),(0.8,145.8),(1.6,145.8),(1.6,145.0),(0.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,145.0),(2.4,145.8),(3.2,145.8),(3.2,145.0),(2.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,145.0),(4.0,145.8),(4.8,145.8),(4.8,145.0),(4.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,145.0),(5.6,145.8),(6.4,145.8),(6.4,145.0),(5.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,145.0),(7.2,145.8),(8.0,145.8),(8.0,145.0),(7.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,145.0),(8.8,145.8),(9.6,145.8),(9.6,145.0),(8.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,145.0),(10.4,145.8),(11.2,145.8),(11.2,145.0),(10.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,145.0),(12.0,145.8),(12.8,145.8),(12.8,145.0),(12.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,145.0),(13.6,145.8),(14.4,145.8),(14.4,145.0),(13.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,145.0),(15.2,145.8),(16.0,145.8),(16.0,145.0),(15.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,145.0),(16.8,145.8),(17.6,145.8),(17.6,145.0),(16.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,145.0),(18.4,145.8),(19.2,145.8),(19.2,145.0),(18.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,146.6),(0.8,147.4),(1.6,147.4),(1.6,146.6),(0.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,146.6),(2.4,147.4),(3.2,147.4),(3.2,146.6),(2.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,146.6),(4.0,147.4),(4.8,147.4),(4.8,146.6),(4.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,146.6),(5.6,147.4),(6.4,147.4),(6.4,146.6),(5.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,146.6),(7.2,147.4),(8.0,147.4),(8.0,146.6),(7.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,146.6),(8.8,147.4),(9.6,147.4),(9.6,146.6),(8.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,146.6),(10.4,147.4),(11.2,147.4),(11.2,146.6),(10.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,146.6),(12.0,147.4),(12.8,147.4),(12.8,146.6),(12.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,146.6),(13.6,147.4),(14.4,147.4),(14.4,146.6),(13.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,146.6),(15.2,147.4),(16.0,147.4),(16.0,146.6),(15.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,146.6),(16.8,147.4),(17.6,147.4),(17.6,146.6),(16.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,146.6),(18.4,147.4),(19.2,147.4),(19.2,146.6),(18.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,148.2),(0.8,149.0),(1.6,149.0),(1.6,148.2),(0.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,148.2),(2.4,149.0),(3.2,149.0),(3.2,148.2),(2.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,148.2),(4.0,149.0),(4.8,149.0),(4.8,148.2),(4.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,148.2),(5.6,149.0),(6.4,149.0),(6.4,148.2),(5.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,148.2),(7.2,149.0),(8.0,149.0),(8.0,148.2),(7.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,148.2),(8.8,149.0),(9.6,149.0),(9.6,148.2),(8.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,148.2),(10.4,149.0),(11.2,149.0),(11.2,148.2),(10.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,148.2),(12.0,149.0),(12.8,149.0),(12.8,148.2),(12.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,148.2),(13.6,149.0),(14.4,149.0),(14.4,148.2),(13.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,148.2),(15.2,149.0),(16.0,149.0),(16.0,148.2),(15.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,148.2),(16.8,149.0),(17.6,149.0),(17.6,148.2),(16.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,148.2),(18.4,149.0),(19.2,149.0),(19.2,148.2),(18.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,2.485),(0.8,3.285),(1.6,3.285),(1.6,2.485),(0.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,2.485),(2.4,3.285),(3.2,3.285),(3.2,2.485),(2.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,2.485),(4.0,3.285),(4.8,3.285),(4.8,2.485),(4.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,2.485),(5.6,3.285),(6.4,3.285),(6.4,2.485),(5.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,2.485),(7.2,3.285),(8.0,3.285),(8.0,2.485),(7.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,2.485),(8.8,3.285),(9.6,3.285),(9.6,2.485),(8.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,2.485),(10.4,3.285),(11.2,3.285),(11.2,2.485),(10.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,2.485),(12.0,3.285),(12.8,3.285),(12.8,2.485),(12.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,2.485),(13.6,3.285),(14.4,3.285),(14.4,2.485),(13.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,2.485),(15.2,3.285),(16.0,3.285),(16.0,2.485),(15.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,2.485),(16.8,3.285),(17.6,3.285),(17.6,2.485),(16.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,2.485),(18.4,3.285),(19.2,3.285),(19.2,2.485),(18.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,4.085),(0.8,4.885),(1.6,4.885),(1.6,4.085),(0.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,4.085),(2.4,4.885),(3.2,4.885),(3.2,4.085),(2.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,4.085),(4.0,4.885),(4.8,4.885),(4.8,4.085),(4.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,4.085),(5.6,4.885),(6.4,4.885),(6.4,4.085),(5.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,4.085),(7.2,4.885),(8.0,4.885),(8.0,4.085),(7.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,4.085),(8.8,4.885),(9.6,4.885),(9.6,4.085),(8.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,4.085),(10.4,4.885),(11.2,4.885),(11.2,4.085),(10.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,4.085),(12.0,4.885),(12.8,4.885),(12.8,4.085),(12.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,4.085),(13.6,4.885),(14.4,4.885),(14.4,4.085),(13.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,4.085),(15.2,4.885),(16.0,4.885),(16.0,4.085),(15.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,4.085),(16.8,4.885),(17.6,4.885),(17.6,4.085),(16.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,4.085),(18.4,4.885),(19.2,4.885),(19.2,4.085),(18.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,5.685),(0.8,6.485),(1.6,6.485),(1.6,5.685),(0.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,5.685),(2.4,6.485),(3.2,6.485),(3.2,5.685),(2.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,5.685),(4.0,6.485),(4.8,6.485),(4.8,5.685),(4.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,5.685),(5.6,6.485),(6.4,6.485),(6.4,5.685),(5.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,5.685),(7.2,6.485),(8.0,6.485),(8.0,5.685),(7.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,5.685),(8.8,6.485),(9.6,6.485),(9.6,5.685),(8.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,5.685),(10.4,6.485),(11.2,6.485),(11.2,5.685),(10.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,5.685),(12.0,6.485),(12.8,6.485),(12.8,5.685),(12.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,5.685),(13.6,6.485),(14.4,6.485),(14.4,5.685),(13.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,5.685),(15.2,6.485),(16.0,6.485),(16.0,5.685),(15.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,5.685),(16.8,6.485),(17.6,6.485),(17.6,5.685),(16.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,5.685),(18.4,6.485),(19.2,6.485),(19.2,5.685),(18.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,7.285),(0.8,8.085),(1.6,8.085),(1.6,7.285),(0.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,7.285),(2.4,8.085),(3.2,8.085),(3.2,7.285),(2.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,7.285),(4.0,8.085),(4.8,8.085),(4.8,7.285),(4.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,7.285),(5.6,8.085),(6.4,8.085),(6.4,7.285),(5.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,7.285),(7.2,8.085),(8.0,8.085),(8.0,7.285),(7.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,7.285),(8.8,8.085),(9.6,8.085),(9.6,7.285),(8.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,7.285),(10.4,8.085),(11.2,8.085),(11.2,7.285),(10.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,7.285),(12.0,8.085),(12.8,8.085),(12.8,7.285),(12.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,7.285),(13.6,8.085),(14.4,8.085),(14.4,7.285),(13.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,7.285),(15.2,8.085),(16.0,8.085),(16.0,7.285),(15.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,7.285),(16.8,8.085),(17.6,8.085),(17.6,7.285),(16.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,7.285),(18.4,8.085),(19.2,8.085),(19.2,7.285),(18.4,7.285)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(20.0,20.94),(20.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(20.0,9.17),(20.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(20.0,150.6),(20.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(20.0,118.08),(20.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(20.0,133.04),(20.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(20.0,103.14),(20.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,91.37),(1.9,91.57),(2.1,91.57),(2.1,91.37),(1.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,91.37),(3.5,91.57),(3.7,91.57),(3.7,91.37),(3.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,91.37),(5.1,91.57),(5.3,91.57),(5.3,91.37),(5.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,91.37),(6.7,91.57),(6.9,91.57),(6.9,91.37),(6.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,91.37),(8.3,91.57),(8.5,91.57),(8.5,91.37),(8.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,91.37),(9.9,91.57),(10.1,91.57),(10.1,91.37),(9.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,91.37),(11.5,91.57),(11.7,91.57),(11.7,91.37),(11.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,91.37),(13.1,91.57),(13.3,91.57),(13.3,91.37),(13.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,91.37),(14.7,91.57),(14.9,91.57),(14.9,91.37),(14.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,91.37),(16.3,91.57),(16.5,91.57),(16.5,91.37),(16.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,91.37),(17.9,91.57),(18.1,91.57),(18.1,91.37),(17.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,92.97),(1.9,93.17),(2.1,93.17),(2.1,92.97),(1.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,92.97),(3.5,93.17),(3.7,93.17),(3.7,92.97),(3.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,92.97),(5.1,93.17),(5.3,93.17),(5.3,92.97),(5.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,92.97),(6.7,93.17),(6.9,93.17),(6.9,92.97),(6.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,92.97),(8.3,93.17),(8.5,93.17),(8.5,92.97),(8.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,92.97),(9.9,93.17),(10.1,93.17),(10.1,92.97),(9.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,92.97),(11.5,93.17),(11.7,93.17),(11.7,92.97),(11.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,92.97),(13.1,93.17),(13.3,93.17),(13.3,92.97),(13.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,92.97),(14.7,93.17),(14.9,93.17),(14.9,92.97),(14.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,92.97),(16.3,93.17),(16.5,93.17),(16.5,92.97),(16.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,92.97),(17.9,93.17),(18.1,93.17),(18.1,92.97),(17.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,94.57),(1.9,94.77),(2.1,94.77),(2.1,94.57),(1.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,94.57),(3.5,94.77),(3.7,94.77),(3.7,94.57),(3.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,94.57),(5.1,94.77),(5.3,94.77),(5.3,94.57),(5.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,94.57),(6.7,94.77),(6.9,94.77),(6.9,94.57),(6.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,94.57),(8.3,94.77),(8.5,94.77),(8.5,94.57),(8.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,94.57),(9.9,94.77),(10.1,94.77),(10.1,94.57),(9.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,94.57),(11.5,94.77),(11.7,94.77),(11.7,94.57),(11.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,94.57),(13.1,94.77),(13.3,94.77),(13.3,94.57),(13.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,94.57),(14.7,94.77),(14.9,94.77),(14.9,94.57),(14.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,94.57),(16.3,94.77),(16.5,94.77),(16.5,94.57),(16.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,94.57),(17.9,94.77),(18.1,94.77),(18.1,94.57),(17.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,96.17),(1.9,96.37),(2.1,96.37),(2.1,96.17),(1.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,96.17),(3.5,96.37),(3.7,96.37),(3.7,96.17),(3.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,96.17),(5.1,96.37),(5.3,96.37),(5.3,96.17),(5.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,96.17),(6.7,96.37),(6.9,96.37),(6.9,96.17),(6.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,96.17),(8.3,96.37),(8.5,96.37),(8.5,96.17),(8.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,96.17),(9.9,96.37),(10.1,96.37),(10.1,96.17),(9.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,96.17),(11.5,96.37),(11.7,96.37),(11.7,96.17),(11.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,96.17),(13.1,96.37),(13.3,96.37),(13.3,96.17),(13.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,96.17),(14.7,96.37),(14.9,96.37),(14.9,96.17),(14.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,96.17),(16.3,96.37),(16.5,96.37),(16.5,96.17),(16.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,96.17),(17.9,96.37),(18.1,96.37),(18.1,96.17),(17.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,97.77),(1.9,97.97),(2.1,97.97),(2.1,97.77),(1.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,97.77),(3.5,97.97),(3.7,97.97),(3.7,97.77),(3.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,97.77),(5.1,97.97),(5.3,97.97),(5.3,97.77),(5.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,97.77),(6.7,97.97),(6.9,97.97),(6.9,97.77),(6.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,97.77),(8.3,97.97),(8.5,97.97),(8.5,97.77),(8.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,97.77),(9.9,97.97),(10.1,97.97),(10.1,97.77),(9.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,97.77),(11.5,97.97),(11.7,97.97),(11.7,97.77),(11.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,97.77),(13.1,97.97),(13.3,97.97),(13.3,97.77),(13.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,97.77),(14.7,97.97),(14.9,97.97),(14.9,97.77),(14.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,97.77),(16.3,97.97),(16.5,97.97),(16.5,97.77),(16.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,97.77),(17.9,97.97),(18.1,97.97),(18.1,97.77),(17.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,99.37),(1.9,99.57),(2.1,99.57),(2.1,99.37),(1.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,99.37),(3.5,99.57),(3.7,99.57),(3.7,99.37),(3.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,99.37),(5.1,99.57),(5.3,99.57),(5.3,99.37),(5.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,99.37),(6.7,99.57),(6.9,99.57),(6.9,99.37),(6.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,99.37),(8.3,99.57),(8.5,99.57),(8.5,99.37),(8.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,99.37),(9.9,99.57),(10.1,99.57),(10.1,99.37),(9.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,99.37),(11.5,99.57),(11.7,99.57),(11.7,99.37),(11.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,99.37),(13.1,99.57),(13.3,99.57),(13.3,99.37),(13.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,99.37),(14.7,99.57),(14.9,99.57),(14.9,99.37),(14.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,99.37),(16.3,99.57),(16.5,99.57),(16.5,99.37),(16.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,99.37),(17.9,99.57),(18.1,99.57),(18.1,99.37),(17.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,100.97),(1.9,101.17),(2.1,101.17),(2.1,100.97),(1.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,100.97),(3.5,101.17),(3.7,101.17),(3.7,100.97),(3.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,100.97),(5.1,101.17),(5.3,101.17),(5.3,100.97),(5.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,100.97),(6.7,101.17),(6.9,101.17),(6.9,100.97),(6.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,100.97),(8.3,101.17),(8.5,101.17),(8.5,100.97),(8.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,100.97),(9.9,101.17),(10.1,101.17),(10.1,100.97),(9.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,100.97),(11.5,101.17),(11.7,101.17),(11.7,100.97),(11.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,100.97),(13.1,101.17),(13.3,101.17),(13.3,100.97),(13.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,100.97),(14.7,101.17),(14.9,101.17),(14.9,100.97),(14.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,100.97),(16.3,101.17),(16.5,101.17),(16.5,100.97),(16.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,100.97),(17.9,101.17),(18.1,101.17),(18.1,100.97),(17.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,121.27),(1.9,121.47),(2.1,121.47),(2.1,121.27),(1.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,121.27),(3.5,121.47),(3.7,121.47),(3.7,121.27),(3.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,121.27),(5.1,121.47),(5.3,121.47),(5.3,121.27),(5.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,121.27),(6.7,121.47),(6.9,121.47),(6.9,121.27),(6.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,121.27),(8.3,121.47),(8.5,121.47),(8.5,121.27),(8.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,121.27),(9.9,121.47),(10.1,121.47),(10.1,121.27),(9.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,121.27),(11.5,121.47),(11.7,121.47),(11.7,121.27),(11.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,121.27),(13.1,121.47),(13.3,121.47),(13.3,121.27),(13.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,121.27),(14.7,121.47),(14.9,121.47),(14.9,121.27),(14.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,121.27),(16.3,121.47),(16.5,121.47),(16.5,121.27),(16.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,121.27),(17.9,121.47),(18.1,121.47),(18.1,121.27),(17.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,122.87),(1.9,123.07),(2.1,123.07),(2.1,122.87),(1.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,122.87),(3.5,123.07),(3.7,123.07),(3.7,122.87),(3.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,122.87),(5.1,123.07),(5.3,123.07),(5.3,122.87),(5.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,122.87),(6.7,123.07),(6.9,123.07),(6.9,122.87),(6.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,122.87),(8.3,123.07),(8.5,123.07),(8.5,122.87),(8.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,122.87),(9.9,123.07),(10.1,123.07),(10.1,122.87),(9.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,122.87),(11.5,123.07),(11.7,123.07),(11.7,122.87),(11.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,122.87),(13.1,123.07),(13.3,123.07),(13.3,122.87),(13.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,122.87),(14.7,123.07),(14.9,123.07),(14.9,122.87),(14.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,122.87),(16.3,123.07),(16.5,123.07),(16.5,122.87),(16.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,122.87),(17.9,123.07),(18.1,123.07),(18.1,122.87),(17.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,124.47),(1.9,124.67),(2.1,124.67),(2.1,124.47),(1.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,124.47),(3.5,124.67),(3.7,124.67),(3.7,124.47),(3.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,124.47),(5.1,124.67),(5.3,124.67),(5.3,124.47),(5.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,124.47),(6.7,124.67),(6.9,124.67),(6.9,124.47),(6.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,124.47),(8.3,124.67),(8.5,124.67),(8.5,124.47),(8.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,124.47),(9.9,124.67),(10.1,124.67),(10.1,124.47),(9.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,124.47),(11.5,124.67),(11.7,124.67),(11.7,124.47),(11.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,124.47),(13.1,124.67),(13.3,124.67),(13.3,124.47),(13.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,124.47),(14.7,124.67),(14.9,124.67),(14.9,124.47),(14.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,124.47),(16.3,124.67),(16.5,124.67),(16.5,124.47),(16.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,124.47),(17.9,124.67),(18.1,124.67),(18.1,124.47),(17.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,126.07),(1.9,126.27),(2.1,126.27),(2.1,126.07),(1.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,126.07),(3.5,126.27),(3.7,126.27),(3.7,126.07),(3.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,126.07),(5.1,126.27),(5.3,126.27),(5.3,126.07),(5.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,126.07),(6.7,126.27),(6.9,126.27),(6.9,126.07),(6.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,126.07),(8.3,126.27),(8.5,126.27),(8.5,126.07),(8.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,126.07),(9.9,126.27),(10.1,126.27),(10.1,126.07),(9.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,126.07),(11.5,126.27),(11.7,126.27),(11.7,126.07),(11.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,126.07),(13.1,126.27),(13.3,126.27),(13.3,126.07),(13.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,126.07),(14.7,126.27),(14.9,126.27),(14.9,126.07),(14.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,126.07),(16.3,126.27),(16.5,126.27),(16.5,126.07),(16.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,126.07),(17.9,126.27),(18.1,126.27),(18.1,126.07),(17.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,127.67),(1.9,127.87),(2.1,127.87),(2.1,127.67),(1.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,127.67),(3.5,127.87),(3.7,127.87),(3.7,127.67),(3.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,127.67),(5.1,127.87),(5.3,127.87),(5.3,127.67),(5.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,127.67),(6.7,127.87),(6.9,127.87),(6.9,127.67),(6.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,127.67),(8.3,127.87),(8.5,127.87),(8.5,127.67),(8.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,127.67),(9.9,127.87),(10.1,127.87),(10.1,127.67),(9.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,127.67),(11.5,127.87),(11.7,127.87),(11.7,127.67),(11.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,127.67),(13.1,127.87),(13.3,127.87),(13.3,127.67),(13.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,127.67),(14.7,127.87),(14.9,127.87),(14.9,127.67),(14.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,127.67),(16.3,127.87),(16.5,127.87),(16.5,127.67),(16.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,127.67),(17.9,127.87),(18.1,127.87),(18.1,127.67),(17.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,129.27),(1.9,129.47),(2.1,129.47),(2.1,129.27),(1.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,129.27),(3.5,129.47),(3.7,129.47),(3.7,129.27),(3.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,129.27),(5.1,129.47),(5.3,129.47),(5.3,129.27),(5.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,129.27),(6.7,129.47),(6.9,129.47),(6.9,129.27),(6.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,129.27),(8.3,129.47),(8.5,129.47),(8.5,129.27),(8.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,129.27),(9.9,129.47),(10.1,129.47),(10.1,129.27),(9.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,129.27),(11.5,129.47),(11.7,129.47),(11.7,129.27),(11.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,129.27),(13.1,129.47),(13.3,129.47),(13.3,129.27),(13.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,129.27),(14.7,129.47),(14.9,129.47),(14.9,129.27),(14.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,129.27),(16.3,129.47),(16.5,129.47),(16.5,129.27),(16.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,129.27),(17.9,129.47),(18.1,129.47),(18.1,129.27),(17.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,130.87),(1.9,131.07),(2.1,131.07),(2.1,130.87),(1.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,130.87),(3.5,131.07),(3.7,131.07),(3.7,130.87),(3.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,130.87),(5.1,131.07),(5.3,131.07),(5.3,130.87),(5.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,130.87),(6.7,131.07),(6.9,131.07),(6.9,130.87),(6.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,130.87),(8.3,131.07),(8.5,131.07),(8.5,130.87),(8.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,130.87),(9.9,131.07),(10.1,131.07),(10.1,130.87),(9.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,130.87),(11.5,131.07),(11.7,131.07),(11.7,130.87),(11.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,130.87),(13.1,131.07),(13.3,131.07),(13.3,130.87),(13.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,130.87),(14.7,131.07),(14.9,131.07),(14.9,130.87),(14.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,130.87),(16.3,131.07),(16.5,131.07),(16.5,130.87),(16.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,130.87),(17.9,131.07),(18.1,131.07),(18.1,130.87),(17.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,106.31),(1.9,106.51),(2.1,106.51),(2.1,106.31),(1.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,106.31),(3.5,106.51),(3.7,106.51),(3.7,106.31),(3.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,106.31),(5.1,106.51),(5.3,106.51),(5.3,106.31),(5.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,106.31),(6.7,106.51),(6.9,106.51),(6.9,106.31),(6.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,106.31),(8.3,106.51),(8.5,106.51),(8.5,106.31),(8.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,106.31),(9.9,106.51),(10.1,106.51),(10.1,106.31),(9.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,106.31),(11.5,106.51),(11.7,106.51),(11.7,106.31),(11.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,106.31),(13.1,106.51),(13.3,106.51),(13.3,106.31),(13.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,106.31),(14.7,106.51),(14.9,106.51),(14.9,106.31),(14.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,106.31),(16.3,106.51),(16.5,106.51),(16.5,106.31),(16.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,106.31),(17.9,106.51),(18.1,106.51),(18.1,106.31),(17.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,107.91),(1.9,108.11),(2.1,108.11),(2.1,107.91),(1.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,107.91),(3.5,108.11),(3.7,108.11),(3.7,107.91),(3.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,107.91),(5.1,108.11),(5.3,108.11),(5.3,107.91),(5.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,107.91),(6.7,108.11),(6.9,108.11),(6.9,107.91),(6.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,107.91),(8.3,108.11),(8.5,108.11),(8.5,107.91),(8.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,107.91),(9.9,108.11),(10.1,108.11),(10.1,107.91),(9.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,107.91),(11.5,108.11),(11.7,108.11),(11.7,107.91),(11.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,107.91),(13.1,108.11),(13.3,108.11),(13.3,107.91),(13.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,107.91),(14.7,108.11),(14.9,108.11),(14.9,107.91),(14.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,107.91),(16.3,108.11),(16.5,108.11),(16.5,107.91),(16.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,107.91),(17.9,108.11),(18.1,108.11),(18.1,107.91),(17.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,109.51),(1.9,109.71),(2.1,109.71),(2.1,109.51),(1.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,109.51),(3.5,109.71),(3.7,109.71),(3.7,109.51),(3.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,109.51),(5.1,109.71),(5.3,109.71),(5.3,109.51),(5.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,109.51),(6.7,109.71),(6.9,109.71),(6.9,109.51),(6.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,109.51),(8.3,109.71),(8.5,109.71),(8.5,109.51),(8.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,109.51),(9.9,109.71),(10.1,109.71),(10.1,109.51),(9.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,109.51),(11.5,109.71),(11.7,109.71),(11.7,109.51),(11.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,109.51),(13.1,109.71),(13.3,109.71),(13.3,109.51),(13.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,109.51),(14.7,109.71),(14.9,109.71),(14.9,109.51),(14.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,109.51),(16.3,109.71),(16.5,109.71),(16.5,109.51),(16.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,109.51),(17.9,109.71),(18.1,109.71),(18.1,109.51),(17.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,111.11),(1.9,111.31),(2.1,111.31),(2.1,111.11),(1.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,111.11),(3.5,111.31),(3.7,111.31),(3.7,111.11),(3.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,111.11),(5.1,111.31),(5.3,111.31),(5.3,111.11),(5.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,111.11),(6.7,111.31),(6.9,111.31),(6.9,111.11),(6.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,111.11),(8.3,111.31),(8.5,111.31),(8.5,111.11),(8.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,111.11),(9.9,111.31),(10.1,111.31),(10.1,111.11),(9.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,111.11),(11.5,111.31),(11.7,111.31),(11.7,111.11),(11.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,111.11),(13.1,111.31),(13.3,111.31),(13.3,111.11),(13.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,111.11),(14.7,111.31),(14.9,111.31),(14.9,111.11),(14.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,111.11),(16.3,111.31),(16.5,111.31),(16.5,111.11),(16.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,111.11),(17.9,111.31),(18.1,111.31),(18.1,111.11),(17.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,112.71),(1.9,112.91),(2.1,112.91),(2.1,112.71),(1.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,112.71),(3.5,112.91),(3.7,112.91),(3.7,112.71),(3.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,112.71),(5.1,112.91),(5.3,112.91),(5.3,112.71),(5.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,112.71),(6.7,112.91),(6.9,112.91),(6.9,112.71),(6.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,112.71),(8.3,112.91),(8.5,112.91),(8.5,112.71),(8.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,112.71),(9.9,112.91),(10.1,112.91),(10.1,112.71),(9.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,112.71),(11.5,112.91),(11.7,112.91),(11.7,112.71),(11.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,112.71),(13.1,112.91),(13.3,112.91),(13.3,112.71),(13.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,112.71),(14.7,112.91),(14.9,112.91),(14.9,112.71),(14.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,112.71),(16.3,112.91),(16.5,112.91),(16.5,112.71),(16.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,112.71),(17.9,112.91),(18.1,112.91),(18.1,112.71),(17.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,114.31),(1.9,114.51),(2.1,114.51),(2.1,114.31),(1.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,114.31),(3.5,114.51),(3.7,114.51),(3.7,114.31),(3.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,114.31),(5.1,114.51),(5.3,114.51),(5.3,114.31),(5.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,114.31),(6.7,114.51),(6.9,114.51),(6.9,114.31),(6.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,114.31),(8.3,114.51),(8.5,114.51),(8.5,114.31),(8.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,114.31),(9.9,114.51),(10.1,114.51),(10.1,114.31),(9.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,114.31),(11.5,114.51),(11.7,114.51),(11.7,114.31),(11.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,114.31),(13.1,114.51),(13.3,114.51),(13.3,114.31),(13.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,114.31),(14.7,114.51),(14.9,114.51),(14.9,114.31),(14.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,114.31),(16.3,114.51),(16.5,114.51),(16.5,114.31),(16.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,114.31),(17.9,114.51),(18.1,114.51),(18.1,114.31),(17.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.9,115.91),(1.9,116.11),(2.1,116.11),(2.1,115.91),(1.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.5,115.91),(3.5,116.11),(3.7,116.11),(3.7,115.91),(3.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((5.1,115.91),(5.1,116.11),(5.3,116.11),(5.3,115.91),(5.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.7,115.91),(6.7,116.11),(6.9,116.11),(6.9,115.91),(6.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.3,115.91),(8.3,116.11),(8.5,116.11),(8.5,115.91),(8.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.9,115.91),(9.9,116.11),(10.1,116.11),(10.1,115.91),(9.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.5,115.91),(11.5,116.11),(11.7,116.11),(11.7,115.91),(11.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((13.1,115.91),(13.1,116.11),(13.3,116.11),(13.3,115.91),(13.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.7,115.91),(14.7,116.11),(14.9,116.11),(14.9,115.91),(14.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.3,115.91),(16.3,116.11),(16.5,116.11),(16.5,115.91),(16.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.9,115.91),(17.9,116.11),(18.1,116.11),(18.1,115.91),(17.9,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(20.0,118.08),(20.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(20.0,133.04),(20.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(20.0,103.14),(20.0,89.4),(0.0,89.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.9,91.37),(1.9,91.57),(2.1,91.57),(2.1,91.37),(1.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,91.37),(3.5,91.57),(3.7,91.57),(3.7,91.37),(3.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,91.37),(5.1,91.57),(5.3,91.57),(5.3,91.37),(5.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,91.37),(6.7,91.57),(6.9,91.57),(6.9,91.37),(6.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,91.37),(8.3,91.57),(8.5,91.57),(8.5,91.37),(8.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,91.37),(9.9,91.57),(10.1,91.57),(10.1,91.37),(9.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,91.37),(11.5,91.57),(11.7,91.57),(11.7,91.37),(11.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,91.37),(13.1,91.57),(13.3,91.57),(13.3,91.37),(13.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,91.37),(14.7,91.57),(14.9,91.57),(14.9,91.37),(14.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,91.37),(16.3,91.57),(16.5,91.57),(16.5,91.37),(16.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,91.37),(17.9,91.57),(18.1,91.57),(18.1,91.37),(17.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,92.97),(1.9,93.17),(2.1,93.17),(2.1,92.97),(1.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,92.97),(3.5,93.17),(3.7,93.17),(3.7,92.97),(3.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,92.97),(5.1,93.17),(5.3,93.17),(5.3,92.97),(5.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,92.97),(6.7,93.17),(6.9,93.17),(6.9,92.97),(6.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,92.97),(8.3,93.17),(8.5,93.17),(8.5,92.97),(8.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,92.97),(9.9,93.17),(10.1,93.17),(10.1,92.97),(9.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,92.97),(11.5,93.17),(11.7,93.17),(11.7,92.97),(11.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,92.97),(13.1,93.17),(13.3,93.17),(13.3,92.97),(13.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,92.97),(14.7,93.17),(14.9,93.17),(14.9,92.97),(14.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,92.97),(16.3,93.17),(16.5,93.17),(16.5,92.97),(16.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,92.97),(17.9,93.17),(18.1,93.17),(18.1,92.97),(17.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,94.57),(1.9,94.77),(2.1,94.77),(2.1,94.57),(1.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,94.57),(3.5,94.77),(3.7,94.77),(3.7,94.57),(3.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,94.57),(5.1,94.77),(5.3,94.77),(5.3,94.57),(5.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,94.57),(6.7,94.77),(6.9,94.77),(6.9,94.57),(6.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,94.57),(8.3,94.77),(8.5,94.77),(8.5,94.57),(8.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,94.57),(9.9,94.77),(10.1,94.77),(10.1,94.57),(9.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,94.57),(11.5,94.77),(11.7,94.77),(11.7,94.57),(11.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,94.57),(13.1,94.77),(13.3,94.77),(13.3,94.57),(13.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,94.57),(14.7,94.77),(14.9,94.77),(14.9,94.57),(14.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,94.57),(16.3,94.77),(16.5,94.77),(16.5,94.57),(16.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,94.57),(17.9,94.77),(18.1,94.77),(18.1,94.57),(17.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,96.17),(1.9,96.37),(2.1,96.37),(2.1,96.17),(1.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,96.17),(3.5,96.37),(3.7,96.37),(3.7,96.17),(3.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,96.17),(5.1,96.37),(5.3,96.37),(5.3,96.17),(5.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,96.17),(6.7,96.37),(6.9,96.37),(6.9,96.17),(6.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,96.17),(8.3,96.37),(8.5,96.37),(8.5,96.17),(8.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,96.17),(9.9,96.37),(10.1,96.37),(10.1,96.17),(9.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,96.17),(11.5,96.37),(11.7,96.37),(11.7,96.17),(11.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,96.17),(13.1,96.37),(13.3,96.37),(13.3,96.17),(13.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,96.17),(14.7,96.37),(14.9,96.37),(14.9,96.17),(14.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,96.17),(16.3,96.37),(16.5,96.37),(16.5,96.17),(16.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,96.17),(17.9,96.37),(18.1,96.37),(18.1,96.17),(17.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,97.77),(1.9,97.97),(2.1,97.97),(2.1,97.77),(1.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,97.77),(3.5,97.97),(3.7,97.97),(3.7,97.77),(3.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,97.77),(5.1,97.97),(5.3,97.97),(5.3,97.77),(5.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,97.77),(6.7,97.97),(6.9,97.97),(6.9,97.77),(6.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,97.77),(8.3,97.97),(8.5,97.97),(8.5,97.77),(8.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,97.77),(9.9,97.97),(10.1,97.97),(10.1,97.77),(9.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,97.77),(11.5,97.97),(11.7,97.97),(11.7,97.77),(11.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,97.77),(13.1,97.97),(13.3,97.97),(13.3,97.77),(13.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,97.77),(14.7,97.97),(14.9,97.97),(14.9,97.77),(14.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,97.77),(16.3,97.97),(16.5,97.97),(16.5,97.77),(16.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,97.77),(17.9,97.97),(18.1,97.97),(18.1,97.77),(17.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,99.37),(1.9,99.57),(2.1,99.57),(2.1,99.37),(1.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,99.37),(3.5,99.57),(3.7,99.57),(3.7,99.37),(3.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,99.37),(5.1,99.57),(5.3,99.57),(5.3,99.37),(5.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,99.37),(6.7,99.57),(6.9,99.57),(6.9,99.37),(6.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,99.37),(8.3,99.57),(8.5,99.57),(8.5,99.37),(8.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,99.37),(9.9,99.57),(10.1,99.57),(10.1,99.37),(9.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,99.37),(11.5,99.57),(11.7,99.57),(11.7,99.37),(11.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,99.37),(13.1,99.57),(13.3,99.57),(13.3,99.37),(13.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,99.37),(14.7,99.57),(14.9,99.57),(14.9,99.37),(14.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,99.37),(16.3,99.57),(16.5,99.57),(16.5,99.37),(16.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,99.37),(17.9,99.57),(18.1,99.57),(18.1,99.37),(17.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,100.97),(1.9,101.17),(2.1,101.17),(2.1,100.97),(1.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,100.97),(3.5,101.17),(3.7,101.17),(3.7,100.97),(3.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,100.97),(5.1,101.17),(5.3,101.17),(5.3,100.97),(5.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,100.97),(6.7,101.17),(6.9,101.17),(6.9,100.97),(6.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,100.97),(8.3,101.17),(8.5,101.17),(8.5,100.97),(8.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,100.97),(9.9,101.17),(10.1,101.17),(10.1,100.97),(9.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,100.97),(11.5,101.17),(11.7,101.17),(11.7,100.97),(11.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,100.97),(13.1,101.17),(13.3,101.17),(13.3,100.97),(13.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,100.97),(14.7,101.17),(14.9,101.17),(14.9,100.97),(14.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,100.97),(16.3,101.17),(16.5,101.17),(16.5,100.97),(16.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,100.97),(17.9,101.17),(18.1,101.17),(18.1,100.97),(17.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,121.27),(1.9,121.47),(2.1,121.47),(2.1,121.27),(1.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,121.27),(3.5,121.47),(3.7,121.47),(3.7,121.27),(3.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,121.27),(5.1,121.47),(5.3,121.47),(5.3,121.27),(5.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,121.27),(6.7,121.47),(6.9,121.47),(6.9,121.27),(6.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,121.27),(8.3,121.47),(8.5,121.47),(8.5,121.27),(8.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,121.27),(9.9,121.47),(10.1,121.47),(10.1,121.27),(9.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,121.27),(11.5,121.47),(11.7,121.47),(11.7,121.27),(11.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,121.27),(13.1,121.47),(13.3,121.47),(13.3,121.27),(13.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,121.27),(14.7,121.47),(14.9,121.47),(14.9,121.27),(14.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,121.27),(16.3,121.47),(16.5,121.47),(16.5,121.27),(16.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,121.27),(17.9,121.47),(18.1,121.47),(18.1,121.27),(17.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,122.87),(1.9,123.07),(2.1,123.07),(2.1,122.87),(1.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,122.87),(3.5,123.07),(3.7,123.07),(3.7,122.87),(3.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,122.87),(5.1,123.07),(5.3,123.07),(5.3,122.87),(5.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,122.87),(6.7,123.07),(6.9,123.07),(6.9,122.87),(6.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,122.87),(8.3,123.07),(8.5,123.07),(8.5,122.87),(8.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,122.87),(9.9,123.07),(10.1,123.07),(10.1,122.87),(9.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,122.87),(11.5,123.07),(11.7,123.07),(11.7,122.87),(11.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,122.87),(13.1,123.07),(13.3,123.07),(13.3,122.87),(13.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,122.87),(14.7,123.07),(14.9,123.07),(14.9,122.87),(14.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,122.87),(16.3,123.07),(16.5,123.07),(16.5,122.87),(16.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,122.87),(17.9,123.07),(18.1,123.07),(18.1,122.87),(17.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,124.47),(1.9,124.67),(2.1,124.67),(2.1,124.47),(1.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,124.47),(3.5,124.67),(3.7,124.67),(3.7,124.47),(3.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,124.47),(5.1,124.67),(5.3,124.67),(5.3,124.47),(5.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,124.47),(6.7,124.67),(6.9,124.67),(6.9,124.47),(6.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,124.47),(8.3,124.67),(8.5,124.67),(8.5,124.47),(8.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,124.47),(9.9,124.67),(10.1,124.67),(10.1,124.47),(9.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,124.47),(11.5,124.67),(11.7,124.67),(11.7,124.47),(11.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,124.47),(13.1,124.67),(13.3,124.67),(13.3,124.47),(13.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,124.47),(14.7,124.67),(14.9,124.67),(14.9,124.47),(14.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,124.47),(16.3,124.67),(16.5,124.67),(16.5,124.47),(16.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,124.47),(17.9,124.67),(18.1,124.67),(18.1,124.47),(17.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,126.07),(1.9,126.27),(2.1,126.27),(2.1,126.07),(1.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,126.07),(3.5,126.27),(3.7,126.27),(3.7,126.07),(3.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,126.07),(5.1,126.27),(5.3,126.27),(5.3,126.07),(5.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,126.07),(6.7,126.27),(6.9,126.27),(6.9,126.07),(6.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,126.07),(8.3,126.27),(8.5,126.27),(8.5,126.07),(8.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,126.07),(9.9,126.27),(10.1,126.27),(10.1,126.07),(9.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,126.07),(11.5,126.27),(11.7,126.27),(11.7,126.07),(11.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,126.07),(13.1,126.27),(13.3,126.27),(13.3,126.07),(13.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,126.07),(14.7,126.27),(14.9,126.27),(14.9,126.07),(14.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,126.07),(16.3,126.27),(16.5,126.27),(16.5,126.07),(16.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,126.07),(17.9,126.27),(18.1,126.27),(18.1,126.07),(17.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,127.67),(1.9,127.87),(2.1,127.87),(2.1,127.67),(1.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,127.67),(3.5,127.87),(3.7,127.87),(3.7,127.67),(3.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,127.67),(5.1,127.87),(5.3,127.87),(5.3,127.67),(5.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,127.67),(6.7,127.87),(6.9,127.87),(6.9,127.67),(6.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,127.67),(8.3,127.87),(8.5,127.87),(8.5,127.67),(8.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,127.67),(9.9,127.87),(10.1,127.87),(10.1,127.67),(9.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,127.67),(11.5,127.87),(11.7,127.87),(11.7,127.67),(11.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,127.67),(13.1,127.87),(13.3,127.87),(13.3,127.67),(13.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,127.67),(14.7,127.87),(14.9,127.87),(14.9,127.67),(14.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,127.67),(16.3,127.87),(16.5,127.87),(16.5,127.67),(16.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,127.67),(17.9,127.87),(18.1,127.87),(18.1,127.67),(17.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,129.27),(1.9,129.47),(2.1,129.47),(2.1,129.27),(1.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,129.27),(3.5,129.47),(3.7,129.47),(3.7,129.27),(3.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,129.27),(5.1,129.47),(5.3,129.47),(5.3,129.27),(5.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,129.27),(6.7,129.47),(6.9,129.47),(6.9,129.27),(6.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,129.27),(8.3,129.47),(8.5,129.47),(8.5,129.27),(8.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,129.27),(9.9,129.47),(10.1,129.47),(10.1,129.27),(9.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,129.27),(11.5,129.47),(11.7,129.47),(11.7,129.27),(11.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,129.27),(13.1,129.47),(13.3,129.47),(13.3,129.27),(13.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,129.27),(14.7,129.47),(14.9,129.47),(14.9,129.27),(14.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,129.27),(16.3,129.47),(16.5,129.47),(16.5,129.27),(16.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,129.27),(17.9,129.47),(18.1,129.47),(18.1,129.27),(17.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,130.87),(1.9,131.07),(2.1,131.07),(2.1,130.87),(1.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,130.87),(3.5,131.07),(3.7,131.07),(3.7,130.87),(3.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,130.87),(5.1,131.07),(5.3,131.07),(5.3,130.87),(5.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,130.87),(6.7,131.07),(6.9,131.07),(6.9,130.87),(6.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,130.87),(8.3,131.07),(8.5,131.07),(8.5,130.87),(8.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,130.87),(9.9,131.07),(10.1,131.07),(10.1,130.87),(9.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,130.87),(11.5,131.07),(11.7,131.07),(11.7,130.87),(11.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,130.87),(13.1,131.07),(13.3,131.07),(13.3,130.87),(13.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,130.87),(14.7,131.07),(14.9,131.07),(14.9,130.87),(14.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,130.87),(16.3,131.07),(16.5,131.07),(16.5,130.87),(16.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,130.87),(17.9,131.07),(18.1,131.07),(18.1,130.87),(17.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,106.31),(1.9,106.51),(2.1,106.51),(2.1,106.31),(1.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,106.31),(3.5,106.51),(3.7,106.51),(3.7,106.31),(3.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,106.31),(5.1,106.51),(5.3,106.51),(5.3,106.31),(5.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,106.31),(6.7,106.51),(6.9,106.51),(6.9,106.31),(6.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,106.31),(8.3,106.51),(8.5,106.51),(8.5,106.31),(8.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,106.31),(9.9,106.51),(10.1,106.51),(10.1,106.31),(9.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,106.31),(11.5,106.51),(11.7,106.51),(11.7,106.31),(11.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,106.31),(13.1,106.51),(13.3,106.51),(13.3,106.31),(13.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,106.31),(14.7,106.51),(14.9,106.51),(14.9,106.31),(14.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,106.31),(16.3,106.51),(16.5,106.51),(16.5,106.31),(16.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,106.31),(17.9,106.51),(18.1,106.51),(18.1,106.31),(17.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,107.91),(1.9,108.11),(2.1,108.11),(2.1,107.91),(1.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,107.91),(3.5,108.11),(3.7,108.11),(3.7,107.91),(3.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,107.91),(5.1,108.11),(5.3,108.11),(5.3,107.91),(5.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,107.91),(6.7,108.11),(6.9,108.11),(6.9,107.91),(6.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,107.91),(8.3,108.11),(8.5,108.11),(8.5,107.91),(8.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,107.91),(9.9,108.11),(10.1,108.11),(10.1,107.91),(9.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,107.91),(11.5,108.11),(11.7,108.11),(11.7,107.91),(11.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,107.91),(13.1,108.11),(13.3,108.11),(13.3,107.91),(13.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,107.91),(14.7,108.11),(14.9,108.11),(14.9,107.91),(14.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,107.91),(16.3,108.11),(16.5,108.11),(16.5,107.91),(16.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,107.91),(17.9,108.11),(18.1,108.11),(18.1,107.91),(17.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,109.51),(1.9,109.71),(2.1,109.71),(2.1,109.51),(1.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,109.51),(3.5,109.71),(3.7,109.71),(3.7,109.51),(3.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,109.51),(5.1,109.71),(5.3,109.71),(5.3,109.51),(5.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,109.51),(6.7,109.71),(6.9,109.71),(6.9,109.51),(6.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,109.51),(8.3,109.71),(8.5,109.71),(8.5,109.51),(8.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,109.51),(9.9,109.71),(10.1,109.71),(10.1,109.51),(9.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,109.51),(11.5,109.71),(11.7,109.71),(11.7,109.51),(11.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,109.51),(13.1,109.71),(13.3,109.71),(13.3,109.51),(13.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,109.51),(14.7,109.71),(14.9,109.71),(14.9,109.51),(14.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,109.51),(16.3,109.71),(16.5,109.71),(16.5,109.51),(16.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,109.51),(17.9,109.71),(18.1,109.71),(18.1,109.51),(17.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,111.11),(1.9,111.31),(2.1,111.31),(2.1,111.11),(1.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,111.11),(3.5,111.31),(3.7,111.31),(3.7,111.11),(3.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,111.11),(5.1,111.31),(5.3,111.31),(5.3,111.11),(5.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,111.11),(6.7,111.31),(6.9,111.31),(6.9,111.11),(6.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,111.11),(8.3,111.31),(8.5,111.31),(8.5,111.11),(8.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,111.11),(9.9,111.31),(10.1,111.31),(10.1,111.11),(9.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,111.11),(11.5,111.31),(11.7,111.31),(11.7,111.11),(11.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,111.11),(13.1,111.31),(13.3,111.31),(13.3,111.11),(13.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,111.11),(14.7,111.31),(14.9,111.31),(14.9,111.11),(14.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,111.11),(16.3,111.31),(16.5,111.31),(16.5,111.11),(16.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,111.11),(17.9,111.31),(18.1,111.31),(18.1,111.11),(17.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,112.71),(1.9,112.91),(2.1,112.91),(2.1,112.71),(1.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,112.71),(3.5,112.91),(3.7,112.91),(3.7,112.71),(3.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,112.71),(5.1,112.91),(5.3,112.91),(5.3,112.71),(5.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,112.71),(6.7,112.91),(6.9,112.91),(6.9,112.71),(6.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,112.71),(8.3,112.91),(8.5,112.91),(8.5,112.71),(8.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,112.71),(9.9,112.91),(10.1,112.91),(10.1,112.71),(9.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,112.71),(11.5,112.91),(11.7,112.91),(11.7,112.71),(11.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,112.71),(13.1,112.91),(13.3,112.91),(13.3,112.71),(13.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,112.71),(14.7,112.91),(14.9,112.91),(14.9,112.71),(14.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,112.71),(16.3,112.91),(16.5,112.91),(16.5,112.71),(16.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,112.71),(17.9,112.91),(18.1,112.91),(18.1,112.71),(17.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,114.31),(1.9,114.51),(2.1,114.51),(2.1,114.31),(1.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,114.31),(3.5,114.51),(3.7,114.51),(3.7,114.31),(3.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,114.31),(5.1,114.51),(5.3,114.51),(5.3,114.31),(5.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,114.31),(6.7,114.51),(6.9,114.51),(6.9,114.31),(6.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,114.31),(8.3,114.51),(8.5,114.51),(8.5,114.31),(8.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,114.31),(9.9,114.51),(10.1,114.51),(10.1,114.31),(9.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,114.31),(11.5,114.51),(11.7,114.51),(11.7,114.31),(11.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,114.31),(13.1,114.51),(13.3,114.51),(13.3,114.31),(13.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,114.31),(14.7,114.51),(14.9,114.51),(14.9,114.31),(14.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,114.31),(16.3,114.51),(16.5,114.51),(16.5,114.31),(16.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,114.31),(17.9,114.51),(18.1,114.51),(18.1,114.31),(17.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,115.91),(1.9,116.11),(2.1,116.11),(2.1,115.91),(1.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,115.91),(3.5,116.11),(3.7,116.11),(3.7,115.91),(3.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,115.91),(5.1,116.11),(5.3,116.11),(5.3,115.91),(5.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,115.91),(6.7,116.11),(6.9,116.11),(6.9,115.91),(6.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,115.91),(8.3,116.11),(8.5,116.11),(8.5,115.91),(8.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,115.91),(9.9,116.11),(10.1,116.11),(10.1,115.91),(9.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,115.91),(11.5,116.11),(11.7,116.11),(11.7,115.91),(11.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,115.91),(13.1,116.11),(13.3,116.11),(13.3,115.91),(13.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,115.91),(14.7,116.11),(14.9,116.11),(14.9,115.91),(14.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,115.91),(16.3,116.11),(16.5,116.11),(16.5,115.91),(16.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,115.91),(17.9,116.11),(18.1,116.11),(18.1,115.91),(17.9,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(20.0,118.08),(20.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(20.0,133.04),(20.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(20.0,103.14),(20.0,89.4),(0.0,89.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((0.8,106.81),(0.8,107.61),(1.6,107.61),(1.6,106.81),(0.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,106.81),(2.4,107.61),(3.2,107.61),(3.2,106.81),(2.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,106.81),(4.0,107.61),(4.8,107.61),(4.8,106.81),(4.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,106.81),(5.6,107.61),(6.4,107.61),(6.4,106.81),(5.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,106.81),(7.2,107.61),(8.0,107.61),(8.0,106.81),(7.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,106.81),(8.8,107.61),(9.6,107.61),(9.6,106.81),(8.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,106.81),(10.4,107.61),(11.2,107.61),(11.2,106.81),(10.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,106.81),(12.0,107.61),(12.8,107.61),(12.8,106.81),(12.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,106.81),(13.6,107.61),(14.4,107.61),(14.4,106.81),(13.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,106.81),(15.2,107.61),(16.0,107.61),(16.0,106.81),(15.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,106.81),(16.8,107.61),(17.6,107.61),(17.6,106.81),(16.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,106.81),(18.4,107.61),(19.2,107.61),(19.2,106.81),(18.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,108.41),(0.8,109.21),(1.6,109.21),(1.6,108.41),(0.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,108.41),(2.4,109.21),(3.2,109.21),(3.2,108.41),(2.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,108.41),(4.0,109.21),(4.8,109.21),(4.8,108.41),(4.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,108.41),(5.6,109.21),(6.4,109.21),(6.4,108.41),(5.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,108.41),(7.2,109.21),(8.0,109.21),(8.0,108.41),(7.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,108.41),(8.8,109.21),(9.6,109.21),(9.6,108.41),(8.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,108.41),(10.4,109.21),(11.2,109.21),(11.2,108.41),(10.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,108.41),(12.0,109.21),(12.8,109.21),(12.8,108.41),(12.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,108.41),(13.6,109.21),(14.4,109.21),(14.4,108.41),(13.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,108.41),(15.2,109.21),(16.0,109.21),(16.0,108.41),(15.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,108.41),(16.8,109.21),(17.6,109.21),(17.6,108.41),(16.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,108.41),(18.4,109.21),(19.2,109.21),(19.2,108.41),(18.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,110.01),(0.8,110.81),(1.6,110.81),(1.6,110.01),(0.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,110.01),(2.4,110.81),(3.2,110.81),(3.2,110.01),(2.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,110.01),(4.0,110.81),(4.8,110.81),(4.8,110.01),(4.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,110.01),(5.6,110.81),(6.4,110.81),(6.4,110.01),(5.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,110.01),(7.2,110.81),(8.0,110.81),(8.0,110.01),(7.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,110.01),(8.8,110.81),(9.6,110.81),(9.6,110.01),(8.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,110.01),(10.4,110.81),(11.2,110.81),(11.2,110.01),(10.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,110.01),(12.0,110.81),(12.8,110.81),(12.8,110.01),(12.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,110.01),(13.6,110.81),(14.4,110.81),(14.4,110.01),(13.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,110.01),(15.2,110.81),(16.0,110.81),(16.0,110.01),(15.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,110.01),(16.8,110.81),(17.6,110.81),(17.6,110.01),(16.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,110.01),(18.4,110.81),(19.2,110.81),(19.2,110.01),(18.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,111.61),(0.8,112.41),(1.6,112.41),(1.6,111.61),(0.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,111.61),(2.4,112.41),(3.2,112.41),(3.2,111.61),(2.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,111.61),(4.0,112.41),(4.8,112.41),(4.8,111.61),(4.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,111.61),(5.6,112.41),(6.4,112.41),(6.4,111.61),(5.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,111.61),(7.2,112.41),(8.0,112.41),(8.0,111.61),(7.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,111.61),(8.8,112.41),(9.6,112.41),(9.6,111.61),(8.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,111.61),(10.4,112.41),(11.2,112.41),(11.2,111.61),(10.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,111.61),(12.0,112.41),(12.8,112.41),(12.8,111.61),(12.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,111.61),(13.6,112.41),(14.4,112.41),(14.4,111.61),(13.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,111.61),(15.2,112.41),(16.0,112.41),(16.0,111.61),(15.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,111.61),(16.8,112.41),(17.6,112.41),(17.6,111.61),(16.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,111.61),(18.4,112.41),(19.2,112.41),(19.2,111.61),(18.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,113.21),(0.8,114.01),(1.6,114.01),(1.6,113.21),(0.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,113.21),(2.4,114.01),(3.2,114.01),(3.2,113.21),(2.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,113.21),(4.0,114.01),(4.8,114.01),(4.8,113.21),(4.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,113.21),(5.6,114.01),(6.4,114.01),(6.4,113.21),(5.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,113.21),(7.2,114.01),(8.0,114.01),(8.0,113.21),(7.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,113.21),(8.8,114.01),(9.6,114.01),(9.6,113.21),(8.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,113.21),(10.4,114.01),(11.2,114.01),(11.2,113.21),(10.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,113.21),(12.0,114.01),(12.8,114.01),(12.8,113.21),(12.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,113.21),(13.6,114.01),(14.4,114.01),(14.4,113.21),(13.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,113.21),(15.2,114.01),(16.0,114.01),(16.0,113.21),(15.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,113.21),(16.8,114.01),(17.6,114.01),(17.6,113.21),(16.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,113.21),(18.4,114.01),(19.2,114.01),(19.2,113.21),(18.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,114.81),(0.8,115.61),(1.6,115.61),(1.6,114.81),(0.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,114.81),(2.4,115.61),(3.2,115.61),(3.2,114.81),(2.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,114.81),(4.0,115.61),(4.8,115.61),(4.8,114.81),(4.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,114.81),(5.6,115.61),(6.4,115.61),(6.4,114.81),(5.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,114.81),(7.2,115.61),(8.0,115.61),(8.0,114.81),(7.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,114.81),(8.8,115.61),(9.6,115.61),(9.6,114.81),(8.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,114.81),(10.4,115.61),(11.2,115.61),(11.2,114.81),(10.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,114.81),(12.0,115.61),(12.8,115.61),(12.8,114.81),(12.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,114.81),(13.6,115.61),(14.4,115.61),(14.4,114.81),(13.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,114.81),(15.2,115.61),(16.0,115.61),(16.0,114.81),(15.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,114.81),(16.8,115.61),(17.6,115.61),(17.6,114.81),(16.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,114.81),(18.4,115.61),(19.2,115.61),(19.2,114.81),(18.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,91.87),(0.8,92.67),(1.6,92.67),(1.6,91.87),(0.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,91.87),(2.4,92.67),(3.2,92.67),(3.2,91.87),(2.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,91.87),(4.0,92.67),(4.8,92.67),(4.8,91.87),(4.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,91.87),(5.6,92.67),(6.4,92.67),(6.4,91.87),(5.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,91.87),(7.2,92.67),(8.0,92.67),(8.0,91.87),(7.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,91.87),(8.8,92.67),(9.6,92.67),(9.6,91.87),(8.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,91.87),(10.4,92.67),(11.2,92.67),(11.2,91.87),(10.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,91.87),(12.0,92.67),(12.8,92.67),(12.8,91.87),(12.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,91.87),(13.6,92.67),(14.4,92.67),(14.4,91.87),(13.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,91.87),(15.2,92.67),(16.0,92.67),(16.0,91.87),(15.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,91.87),(16.8,92.67),(17.6,92.67),(17.6,91.87),(16.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,91.87),(18.4,92.67),(19.2,92.67),(19.2,91.87),(18.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,93.47),(0.8,94.27),(1.6,94.27),(1.6,93.47),(0.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,93.47),(2.4,94.27),(3.2,94.27),(3.2,93.47),(2.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,93.47),(4.0,94.27),(4.8,94.27),(4.8,93.47),(4.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,93.47),(5.6,94.27),(6.4,94.27),(6.4,93.47),(5.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,93.47),(7.2,94.27),(8.0,94.27),(8.0,93.47),(7.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,93.47),(8.8,94.27),(9.6,94.27),(9.6,93.47),(8.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,93.47),(10.4,94.27),(11.2,94.27),(11.2,93.47),(10.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,93.47),(12.0,94.27),(12.8,94.27),(12.8,93.47),(12.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,93.47),(13.6,94.27),(14.4,94.27),(14.4,93.47),(13.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,93.47),(15.2,94.27),(16.0,94.27),(16.0,93.47),(15.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,93.47),(16.8,94.27),(17.6,94.27),(17.6,93.47),(16.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,93.47),(18.4,94.27),(19.2,94.27),(19.2,93.47),(18.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,95.07),(0.8,95.87),(1.6,95.87),(1.6,95.07),(0.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,95.07),(2.4,95.87),(3.2,95.87),(3.2,95.07),(2.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,95.07),(4.0,95.87),(4.8,95.87),(4.8,95.07),(4.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,95.07),(5.6,95.87),(6.4,95.87),(6.4,95.07),(5.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,95.07),(7.2,95.87),(8.0,95.87),(8.0,95.07),(7.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,95.07),(8.8,95.87),(9.6,95.87),(9.6,95.07),(8.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,95.07),(10.4,95.87),(11.2,95.87),(11.2,95.07),(10.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,95.07),(12.0,95.87),(12.8,95.87),(12.8,95.07),(12.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,95.07),(13.6,95.87),(14.4,95.87),(14.4,95.07),(13.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,95.07),(15.2,95.87),(16.0,95.87),(16.0,95.07),(15.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,95.07),(16.8,95.87),(17.6,95.87),(17.6,95.07),(16.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,95.07),(18.4,95.87),(19.2,95.87),(19.2,95.07),(18.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,96.67),(0.8,97.47),(1.6,97.47),(1.6,96.67),(0.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,96.67),(2.4,97.47),(3.2,97.47),(3.2,96.67),(2.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,96.67),(4.0,97.47),(4.8,97.47),(4.8,96.67),(4.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,96.67),(5.6,97.47),(6.4,97.47),(6.4,96.67),(5.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,96.67),(7.2,97.47),(8.0,97.47),(8.0,96.67),(7.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,96.67),(8.8,97.47),(9.6,97.47),(9.6,96.67),(8.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,96.67),(10.4,97.47),(11.2,97.47),(11.2,96.67),(10.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,96.67),(12.0,97.47),(12.8,97.47),(12.8,96.67),(12.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,96.67),(13.6,97.47),(14.4,97.47),(14.4,96.67),(13.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,96.67),(15.2,97.47),(16.0,97.47),(16.0,96.67),(15.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,96.67),(16.8,97.47),(17.6,97.47),(17.6,96.67),(16.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,96.67),(18.4,97.47),(19.2,97.47),(19.2,96.67),(18.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,98.27),(0.8,99.07),(1.6,99.07),(1.6,98.27),(0.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,98.27),(2.4,99.07),(3.2,99.07),(3.2,98.27),(2.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,98.27),(4.0,99.07),(4.8,99.07),(4.8,98.27),(4.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,98.27),(5.6,99.07),(6.4,99.07),(6.4,98.27),(5.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,98.27),(7.2,99.07),(8.0,99.07),(8.0,98.27),(7.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,98.27),(8.8,99.07),(9.6,99.07),(9.6,98.27),(8.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,98.27),(10.4,99.07),(11.2,99.07),(11.2,98.27),(10.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,98.27),(12.0,99.07),(12.8,99.07),(12.8,98.27),(12.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,98.27),(13.6,99.07),(14.4,99.07),(14.4,98.27),(13.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,98.27),(15.2,99.07),(16.0,99.07),(16.0,98.27),(15.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,98.27),(16.8,99.07),(17.6,99.07),(17.6,98.27),(16.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,98.27),(18.4,99.07),(19.2,99.07),(19.2,98.27),(18.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,99.87),(0.8,100.67),(1.6,100.67),(1.6,99.87),(0.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,99.87),(2.4,100.67),(3.2,100.67),(3.2,99.87),(2.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,99.87),(4.0,100.67),(4.8,100.67),(4.8,99.87),(4.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,99.87),(5.6,100.67),(6.4,100.67),(6.4,99.87),(5.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,99.87),(7.2,100.67),(8.0,100.67),(8.0,99.87),(7.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,99.87),(8.8,100.67),(9.6,100.67),(9.6,99.87),(8.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,99.87),(10.4,100.67),(11.2,100.67),(11.2,99.87),(10.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,99.87),(12.0,100.67),(12.8,100.67),(12.8,99.87),(12.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,99.87),(13.6,100.67),(14.4,100.67),(14.4,99.87),(13.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,99.87),(15.2,100.67),(16.0,100.67),(16.0,99.87),(15.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,99.87),(16.8,100.67),(17.6,100.67),(17.6,99.87),(16.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,99.87),(18.4,100.67),(19.2,100.67),(19.2,99.87),(18.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,121.77),(0.8,122.57),(1.6,122.57),(1.6,121.77),(0.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,121.77),(2.4,122.57),(3.2,122.57),(3.2,121.77),(2.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,121.77),(4.0,122.57),(4.8,122.57),(4.8,121.77),(4.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,121.77),(5.6,122.57),(6.4,122.57),(6.4,121.77),(5.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,121.77),(7.2,122.57),(8.0,122.57),(8.0,121.77),(7.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,121.77),(8.8,122.57),(9.6,122.57),(9.6,121.77),(8.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,121.77),(10.4,122.57),(11.2,122.57),(11.2,121.77),(10.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,121.77),(12.0,122.57),(12.8,122.57),(12.8,121.77),(12.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,121.77),(13.6,122.57),(14.4,122.57),(14.4,121.77),(13.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,121.77),(15.2,122.57),(16.0,122.57),(16.0,121.77),(15.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,121.77),(16.8,122.57),(17.6,122.57),(17.6,121.77),(16.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,121.77),(18.4,122.57),(19.2,122.57),(19.2,121.77),(18.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,123.37),(0.8,124.17),(1.6,124.17),(1.6,123.37),(0.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,123.37),(2.4,124.17),(3.2,124.17),(3.2,123.37),(2.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,123.37),(4.0,124.17),(4.8,124.17),(4.8,123.37),(4.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,123.37),(5.6,124.17),(6.4,124.17),(6.4,123.37),(5.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,123.37),(7.2,124.17),(8.0,124.17),(8.0,123.37),(7.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,123.37),(8.8,124.17),(9.6,124.17),(9.6,123.37),(8.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,123.37),(10.4,124.17),(11.2,124.17),(11.2,123.37),(10.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,123.37),(12.0,124.17),(12.8,124.17),(12.8,123.37),(12.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,123.37),(13.6,124.17),(14.4,124.17),(14.4,123.37),(13.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,123.37),(15.2,124.17),(16.0,124.17),(16.0,123.37),(15.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,123.37),(16.8,124.17),(17.6,124.17),(17.6,123.37),(16.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,123.37),(18.4,124.17),(19.2,124.17),(19.2,123.37),(18.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,124.97),(0.8,125.77),(1.6,125.77),(1.6,124.97),(0.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,124.97),(2.4,125.77),(3.2,125.77),(3.2,124.97),(2.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,124.97),(4.0,125.77),(4.8,125.77),(4.8,124.97),(4.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,124.97),(5.6,125.77),(6.4,125.77),(6.4,124.97),(5.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,124.97),(7.2,125.77),(8.0,125.77),(8.0,124.97),(7.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,124.97),(8.8,125.77),(9.6,125.77),(9.6,124.97),(8.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,124.97),(10.4,125.77),(11.2,125.77),(11.2,124.97),(10.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,124.97),(12.0,125.77),(12.8,125.77),(12.8,124.97),(12.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,124.97),(13.6,125.77),(14.4,125.77),(14.4,124.97),(13.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,124.97),(15.2,125.77),(16.0,125.77),(16.0,124.97),(15.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,124.97),(16.8,125.77),(17.6,125.77),(17.6,124.97),(16.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,124.97),(18.4,125.77),(19.2,125.77),(19.2,124.97),(18.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,126.57),(0.8,127.37),(1.6,127.37),(1.6,126.57),(0.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,126.57),(2.4,127.37),(3.2,127.37),(3.2,126.57),(2.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,126.57),(4.0,127.37),(4.8,127.37),(4.8,126.57),(4.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,126.57),(5.6,127.37),(6.4,127.37),(6.4,126.57),(5.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,126.57),(7.2,127.37),(8.0,127.37),(8.0,126.57),(7.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,126.57),(8.8,127.37),(9.6,127.37),(9.6,126.57),(8.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,126.57),(10.4,127.37),(11.2,127.37),(11.2,126.57),(10.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,126.57),(12.0,127.37),(12.8,127.37),(12.8,126.57),(12.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,126.57),(13.6,127.37),(14.4,127.37),(14.4,126.57),(13.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,126.57),(15.2,127.37),(16.0,127.37),(16.0,126.57),(15.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,126.57),(16.8,127.37),(17.6,127.37),(17.6,126.57),(16.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,126.57),(18.4,127.37),(19.2,127.37),(19.2,126.57),(18.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,128.17),(0.8,128.97),(1.6,128.97),(1.6,128.17),(0.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,128.17),(2.4,128.97),(3.2,128.97),(3.2,128.17),(2.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,128.17),(4.0,128.97),(4.8,128.97),(4.8,128.17),(4.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,128.17),(5.6,128.97),(6.4,128.97),(6.4,128.17),(5.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,128.17),(7.2,128.97),(8.0,128.97),(8.0,128.17),(7.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,128.17),(8.8,128.97),(9.6,128.97),(9.6,128.17),(8.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,128.17),(10.4,128.97),(11.2,128.97),(11.2,128.17),(10.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,128.17),(12.0,128.97),(12.8,128.97),(12.8,128.17),(12.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,128.17),(13.6,128.97),(14.4,128.97),(14.4,128.17),(13.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,128.17),(15.2,128.97),(16.0,128.97),(16.0,128.17),(15.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,128.17),(16.8,128.97),(17.6,128.97),(17.6,128.17),(16.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,128.17),(18.4,128.97),(19.2,128.97),(19.2,128.17),(18.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((0.8,129.77),(0.8,130.57),(1.6,130.57),(1.6,129.77),(0.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((2.4,129.77),(2.4,130.57),(3.2,130.57),(3.2,129.77),(2.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.0,129.77),(4.0,130.57),(4.8,130.57),(4.8,129.77),(4.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((5.6,129.77),(5.6,130.57),(6.4,130.57),(6.4,129.77),(5.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.2,129.77),(7.2,130.57),(8.0,130.57),(8.0,129.77),(7.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((8.8,129.77),(8.8,130.57),(9.6,130.57),(9.6,129.77),(8.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((10.4,129.77),(10.4,130.57),(11.2,130.57),(11.2,129.77),(10.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.0,129.77),(12.0,130.57),(12.8,130.57),(12.8,129.77),(12.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((13.6,129.77),(13.6,130.57),(14.4,130.57),(14.4,129.77),(13.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.2,129.77),(15.2,130.57),(16.0,130.57),(16.0,129.77),(15.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((16.8,129.77),(16.8,130.57),(17.6,130.57),(17.6,129.77),(16.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((18.4,129.77),(18.4,130.57),(19.2,130.57),(19.2,129.77),(18.4,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(20.0,101.74),(20.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(20.0,131.64),(20.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(20.0,116.68),(20.0,105.74),(0.0,105.74)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(20.0,172.4),(20.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(20.0,188.0),(20.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.0),(0.0,176.0),(0.0,188.0),(20.0,188.0),(20.0,176.0),(9.395,176.0),(9.395,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.4,171.31),(1.4,171.51),(1.6,171.51),(1.6,171.31),(1.4,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.8,171.31),(1.8,171.51),(2.0,171.51),(2.0,171.31),(1.8,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.2,171.31),(2.2,171.51),(2.4,171.51),(2.4,171.31),(2.2,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.6,171.31),(2.6,171.51),(2.8,171.51),(2.8,171.31),(2.6,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.0,171.31),(3.0,171.51),(3.2,171.51),(3.2,171.31),(3.0,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.4,171.31),(3.4,171.51),(3.6,171.51),(3.6,171.31),(3.4,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.8,171.31),(3.8,171.51),(4.0,171.51),(4.0,171.31),(3.8,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.2,171.31),(4.2,171.51),(4.4,171.51),(4.4,171.31),(4.2,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.6,171.31),(4.6,171.51),(4.8,171.51),(4.8,171.31),(4.6,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.0,171.31),(5.0,171.51),(5.2,171.51),(5.2,171.31),(5.0,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.4,171.31),(5.4,171.51),(5.6,171.51),(5.6,171.31),(5.4,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.8,171.31),(5.8,171.51),(6.0,171.51),(6.0,171.31),(5.8,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.2,171.31),(6.2,171.51),(6.4,171.51),(6.4,171.31),(6.2,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.6,171.31),(6.6,171.51),(6.8,171.51),(6.8,171.31),(6.6,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.0,171.31),(7.0,171.51),(7.2,171.51),(7.2,171.31),(7.0,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.4,171.31),(7.4,171.51),(7.6,171.51),(7.6,171.31),(7.4,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.8,171.31),(7.8,171.51),(8.0,171.51),(8.0,171.31),(7.8,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.2,171.31),(8.2,171.51),(8.4,171.51),(8.4,171.31),(8.2,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.6,171.31),(8.6,171.51),(8.8,171.51),(8.8,171.31),(8.6,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.0,171.31),(9.0,171.51),(9.2,171.51),(9.2,171.31),(9.0,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.4,171.71),(1.4,171.91),(1.6,171.91),(1.6,171.71),(1.4,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.8,171.71),(1.8,171.91),(2.0,171.91),(2.0,171.71),(1.8,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.2,171.71),(2.2,171.91),(2.4,171.91),(2.4,171.71),(2.2,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.6,171.71),(2.6,171.91),(2.8,171.91),(2.8,171.71),(2.6,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.0,171.71),(3.0,171.91),(3.2,171.91),(3.2,171.71),(3.0,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.4,171.71),(3.4,171.91),(3.6,171.91),(3.6,171.71),(3.4,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.8,171.71),(3.8,171.91),(4.0,171.91),(4.0,171.71),(3.8,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.2,171.71),(4.2,171.91),(4.4,171.91),(4.4,171.71),(4.2,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.6,171.71),(4.6,171.91),(4.8,171.91),(4.8,171.71),(4.6,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.0,171.71),(5.0,171.91),(5.2,171.91),(5.2,171.71),(5.0,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.4,171.71),(5.4,171.91),(5.6,171.91),(5.6,171.71),(5.4,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.8,171.71),(5.8,171.91),(6.0,171.91),(6.0,171.71),(5.8,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.2,171.71),(6.2,171.91),(6.4,171.91),(6.4,171.71),(6.2,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.6,171.71),(6.6,171.91),(6.8,171.91),(6.8,171.71),(6.6,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.0,171.71),(7.0,171.91),(7.2,171.91),(7.2,171.71),(7.0,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.4,171.71),(7.4,171.91),(7.6,171.91),(7.6,171.71),(7.4,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.8,171.71),(7.8,171.91),(8.0,171.91),(8.0,171.71),(7.8,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.2,171.71),(8.2,171.91),(8.4,171.91),(8.4,171.71),(8.2,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.6,171.71),(8.6,171.91),(8.8,171.91),(8.8,171.71),(8.6,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.0,171.71),(9.0,171.91),(9.2,171.91),(9.2,171.71),(9.0,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.4,172.11),(1.4,172.31),(1.6,172.31),(1.6,172.11),(1.4,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.8,172.11),(1.8,172.31),(2.0,172.31),(2.0,172.11),(1.8,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.2,172.11),(2.2,172.31),(2.4,172.31),(2.4,172.11),(2.2,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.6,172.11),(2.6,172.31),(2.8,172.31),(2.8,172.11),(2.6,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.0,172.11),(3.0,172.31),(3.2,172.31),(3.2,172.11),(3.0,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.4,172.11),(3.4,172.31),(3.6,172.31),(3.6,172.11),(3.4,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.8,172.11),(3.8,172.31),(4.0,172.31),(4.0,172.11),(3.8,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.2,172.11),(4.2,172.31),(4.4,172.31),(4.4,172.11),(4.2,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.6,172.11),(4.6,172.31),(4.8,172.31),(4.8,172.11),(4.6,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.0,172.11),(5.0,172.31),(5.2,172.31),(5.2,172.11),(5.0,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.4,172.11),(5.4,172.31),(5.6,172.31),(5.6,172.11),(5.4,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.8,172.11),(5.8,172.31),(6.0,172.31),(6.0,172.11),(5.8,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.2,172.11),(6.2,172.31),(6.4,172.31),(6.4,172.11),(6.2,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.6,172.11),(6.6,172.31),(6.8,172.31),(6.8,172.11),(6.6,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.0,172.11),(7.0,172.31),(7.2,172.31),(7.2,172.11),(7.0,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.4,172.11),(7.4,172.31),(7.6,172.31),(7.6,172.11),(7.4,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.8,172.11),(7.8,172.31),(8.0,172.31),(8.0,172.11),(7.8,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.2,172.11),(8.2,172.31),(8.4,172.31),(8.4,172.11),(8.2,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.6,172.11),(8.6,172.31),(8.8,172.31),(8.8,172.11),(8.6,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.0,172.11),(9.0,172.31),(9.2,172.31),(9.2,172.11),(9.0,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,177.9),(1.9,178.1),(2.1,178.1),(2.1,177.9),(1.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,177.9),(3.5,178.1),(3.7,178.1),(3.7,177.9),(3.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,177.9),(5.1,178.1),(5.3,178.1),(5.3,177.9),(5.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,177.9),(6.7,178.1),(6.9,178.1),(6.9,177.9),(6.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,177.9),(8.3,178.1),(8.5,178.1),(8.5,177.9),(8.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,177.9),(9.9,178.1),(10.1,178.1),(10.1,177.9),(9.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,177.9),(11.5,178.1),(11.7,178.1),(11.7,177.9),(11.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,177.9),(13.1,178.1),(13.3,178.1),(13.3,177.9),(13.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,177.9),(14.7,178.1),(14.9,178.1),(14.9,177.9),(14.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,177.9),(16.3,178.1),(16.5,178.1),(16.5,177.9),(16.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,177.9),(17.9,178.1),(18.1,178.1),(18.1,177.9),(17.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,179.5),(1.9,179.7),(2.1,179.7),(2.1,179.5),(1.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,179.5),(3.5,179.7),(3.7,179.7),(3.7,179.5),(3.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,179.5),(5.1,179.7),(5.3,179.7),(5.3,179.5),(5.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,179.5),(6.7,179.7),(6.9,179.7),(6.9,179.5),(6.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,179.5),(8.3,179.7),(8.5,179.7),(8.5,179.5),(8.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,179.5),(9.9,179.7),(10.1,179.7),(10.1,179.5),(9.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,179.5),(11.5,179.7),(11.7,179.7),(11.7,179.5),(11.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,179.5),(13.1,179.7),(13.3,179.7),(13.3,179.5),(13.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,179.5),(14.7,179.7),(14.9,179.7),(14.9,179.5),(14.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,179.5),(16.3,179.7),(16.5,179.7),(16.5,179.5),(16.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,179.5),(17.9,179.7),(18.1,179.7),(18.1,179.5),(17.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,181.1),(1.9,181.3),(2.1,181.3),(2.1,181.1),(1.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,181.1),(3.5,181.3),(3.7,181.3),(3.7,181.1),(3.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,181.1),(5.1,181.3),(5.3,181.3),(5.3,181.1),(5.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,181.1),(6.7,181.3),(6.9,181.3),(6.9,181.1),(6.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,181.1),(8.3,181.3),(8.5,181.3),(8.5,181.1),(8.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,181.1),(9.9,181.3),(10.1,181.3),(10.1,181.1),(9.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,181.1),(11.5,181.3),(11.7,181.3),(11.7,181.1),(11.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,181.1),(13.1,181.3),(13.3,181.3),(13.3,181.1),(13.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,181.1),(14.7,181.3),(14.9,181.3),(14.9,181.1),(14.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,181.1),(16.3,181.3),(16.5,181.3),(16.5,181.1),(16.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,181.1),(17.9,181.3),(18.1,181.3),(18.1,181.1),(17.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,182.7),(1.9,182.9),(2.1,182.9),(2.1,182.7),(1.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,182.7),(3.5,182.9),(3.7,182.9),(3.7,182.7),(3.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,182.7),(5.1,182.9),(5.3,182.9),(5.3,182.7),(5.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,182.7),(6.7,182.9),(6.9,182.9),(6.9,182.7),(6.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,182.7),(8.3,182.9),(8.5,182.9),(8.5,182.7),(8.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,182.7),(9.9,182.9),(10.1,182.9),(10.1,182.7),(9.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,182.7),(11.5,182.9),(11.7,182.9),(11.7,182.7),(11.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,182.7),(13.1,182.9),(13.3,182.9),(13.3,182.7),(13.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,182.7),(14.7,182.9),(14.9,182.9),(14.9,182.7),(14.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,182.7),(16.3,182.9),(16.5,182.9),(16.5,182.7),(16.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,182.7),(17.9,182.9),(18.1,182.9),(18.1,182.7),(17.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,184.3),(1.9,184.5),(2.1,184.5),(2.1,184.3),(1.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,184.3),(3.5,184.5),(3.7,184.5),(3.7,184.3),(3.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,184.3),(5.1,184.5),(5.3,184.5),(5.3,184.3),(5.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,184.3),(6.7,184.5),(6.9,184.5),(6.9,184.3),(6.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,184.3),(8.3,184.5),(8.5,184.5),(8.5,184.3),(8.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,184.3),(9.9,184.5),(10.1,184.5),(10.1,184.3),(9.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,184.3),(11.5,184.5),(11.7,184.5),(11.7,184.3),(11.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,184.3),(13.1,184.5),(13.3,184.5),(13.3,184.3),(13.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,184.3),(14.7,184.5),(14.9,184.5),(14.9,184.3),(14.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,184.3),(16.3,184.5),(16.5,184.5),(16.5,184.3),(16.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,184.3),(17.9,184.5),(18.1,184.5),(18.1,184.3),(17.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,185.9),(1.9,186.1),(2.1,186.1),(2.1,185.9),(1.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,185.9),(3.5,186.1),(3.7,186.1),(3.7,185.9),(3.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,185.9),(5.1,186.1),(5.3,186.1),(5.3,185.9),(5.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,185.9),(6.7,186.1),(6.9,186.1),(6.9,185.9),(6.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,185.9),(8.3,186.1),(8.5,186.1),(8.5,185.9),(8.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,185.9),(9.9,186.1),(10.1,186.1),(10.1,185.9),(9.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,185.9),(11.5,186.1),(11.7,186.1),(11.7,185.9),(11.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,185.9),(13.1,186.1),(13.3,186.1),(13.3,185.9),(13.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,185.9),(14.7,186.1),(14.9,186.1),(14.9,185.9),(14.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,185.9),(16.3,186.1),(16.5,186.1),(16.5,185.9),(16.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,185.9),(17.9,186.1),(18.1,186.1),(18.1,185.9),(17.9,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(20.0,188.0),(20.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(20.0,172.4),(20.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(10.6,170.0),(10.6,174.78),(18.795,174.78),(18.795,170.0),(20.0,170.0),(20.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(20.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(20.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((10.8,173.69),(10.8,173.89),(11.0,173.89),(11.0,173.69),(10.8,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((11.2,173.69),(11.2,173.89),(11.4,173.89),(11.4,173.69),(11.2,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((11.6,173.69),(11.6,173.89),(11.8,173.89),(11.8,173.69),(11.6,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((12.0,173.69),(12.0,173.89),(12.2,173.89),(12.2,173.69),(12.0,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((12.4,173.69),(12.4,173.89),(12.6,173.89),(12.6,173.69),(12.4,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((12.8,173.69),(12.8,173.89),(13.0,173.89),(13.0,173.69),(12.8,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((13.2,173.69),(13.2,173.89),(13.4,173.89),(13.4,173.69),(13.2,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((13.6,173.69),(13.6,173.89),(13.8,173.89),(13.8,173.69),(13.6,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((14.0,173.69),(14.0,173.89),(14.2,173.89),(14.2,173.69),(14.0,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((14.4,173.69),(14.4,173.89),(14.6,173.89),(14.6,173.69),(14.4,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((14.8,173.69),(14.8,173.89),(15.0,173.89),(15.0,173.69),(14.8,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((15.2,173.69),(15.2,173.89),(15.4,173.89),(15.4,173.69),(15.2,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((15.6,173.69),(15.6,173.89),(15.8,173.89),(15.8,173.69),(15.6,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((16.0,173.69),(16.0,173.89),(16.2,173.89),(16.2,173.69),(16.0,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((16.4,173.69),(16.4,173.89),(16.6,173.89),(16.6,173.69),(16.4,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((16.8,173.69),(16.8,173.89),(17.0,173.89),(17.0,173.69),(16.8,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((17.2,173.69),(17.2,173.89),(17.4,173.89),(17.4,173.69),(17.2,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((17.6,173.69),(17.6,173.89),(17.8,173.89),(17.8,173.69),(17.6,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((18.0,173.69),(18.0,173.89),(18.2,173.89),(18.2,173.69),(18.0,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((18.4,173.69),(18.4,173.89),(18.6,173.89),(18.6,173.69),(18.4,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((10.8,174.09),(10.8,174.29),(11.0,174.29),(11.0,174.09),(10.8,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((11.2,174.09),(11.2,174.29),(11.4,174.29),(11.4,174.09),(11.2,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((11.6,174.09),(11.6,174.29),(11.8,174.29),(11.8,174.09),(11.6,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((12.0,174.09),(12.0,174.29),(12.2,174.29),(12.2,174.09),(12.0,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((12.4,174.09),(12.4,174.29),(12.6,174.29),(12.6,174.09),(12.4,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((12.8,174.09),(12.8,174.29),(13.0,174.29),(13.0,174.09),(12.8,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((13.2,174.09),(13.2,174.29),(13.4,174.29),(13.4,174.09),(13.2,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((13.6,174.09),(13.6,174.29),(13.8,174.29),(13.8,174.09),(13.6,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((14.0,174.09),(14.0,174.29),(14.2,174.29),(14.2,174.09),(14.0,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((14.4,174.09),(14.4,174.29),(14.6,174.29),(14.6,174.09),(14.4,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((14.8,174.09),(14.8,174.29),(15.0,174.29),(15.0,174.09),(14.8,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((15.2,174.09),(15.2,174.29),(15.4,174.29),(15.4,174.09),(15.2,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((15.6,174.09),(15.6,174.29),(15.8,174.29),(15.8,174.09),(15.6,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((16.0,174.09),(16.0,174.29),(16.2,174.29),(16.2,174.09),(16.0,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((16.4,174.09),(16.4,174.29),(16.6,174.29),(16.6,174.09),(16.4,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((16.8,174.09),(16.8,174.29),(17.0,174.29),(17.0,174.09),(16.8,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((17.2,174.09),(17.2,174.29),(17.4,174.29),(17.4,174.09),(17.2,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((17.6,174.09),(17.6,174.29),(17.8,174.29),(17.8,174.09),(17.6,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((18.0,174.09),(18.0,174.29),(18.2,174.29),(18.2,174.09),(18.0,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((18.4,174.09),(18.4,174.29),(18.6,174.29),(18.6,174.09),(18.4,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((10.8,174.49),(10.8,174.69),(11.0,174.69),(11.0,174.49),(10.8,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((11.2,174.49),(11.2,174.69),(11.4,174.69),(11.4,174.49),(11.2,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((11.6,174.49),(11.6,174.69),(11.8,174.69),(11.8,174.49),(11.6,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((12.0,174.49),(12.0,174.69),(12.2,174.69),(12.2,174.49),(12.0,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((12.4,174.49),(12.4,174.69),(12.6,174.69),(12.6,174.49),(12.4,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((12.8,174.49),(12.8,174.69),(13.0,174.69),(13.0,174.49),(12.8,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((13.2,174.49),(13.2,174.69),(13.4,174.69),(13.4,174.49),(13.2,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((13.6,174.49),(13.6,174.69),(13.8,174.69),(13.8,174.49),(13.6,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((14.0,174.49),(14.0,174.69),(14.2,174.69),(14.2,174.49),(14.0,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((14.4,174.49),(14.4,174.69),(14.6,174.69),(14.6,174.49),(14.4,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((14.8,174.49),(14.8,174.69),(15.0,174.69),(15.0,174.49),(14.8,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((15.2,174.49),(15.2,174.69),(15.4,174.69),(15.4,174.49),(15.2,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((15.6,174.49),(15.6,174.69),(15.8,174.69),(15.8,174.49),(15.6,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((16.0,174.49),(16.0,174.69),(16.2,174.69),(16.2,174.49),(16.0,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((16.4,174.49),(16.4,174.69),(16.6,174.69),(16.6,174.49),(16.4,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((16.8,174.49),(16.8,174.69),(17.0,174.69),(17.0,174.49),(16.8,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((17.2,174.49),(17.2,174.69),(17.4,174.69),(17.4,174.49),(17.2,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((17.6,174.49),(17.6,174.69),(17.8,174.69),(17.8,174.49),(17.6,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((18.0,174.49),(18.0,174.69),(18.2,174.69),(18.2,174.49),(18.0,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((18.4,174.49),(18.4,174.69),(18.6,174.69),(18.6,174.49),(18.4,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,159.9),(1.9,160.1),(2.1,160.1),(2.1,159.9),(1.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,159.9),(3.5,160.1),(3.7,160.1),(3.7,159.9),(3.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,159.9),(5.1,160.1),(5.3,160.1),(5.3,159.9),(5.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,159.9),(6.7,160.1),(6.9,160.1),(6.9,159.9),(6.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,159.9),(8.3,160.1),(8.5,160.1),(8.5,159.9),(8.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,159.9),(9.9,160.1),(10.1,160.1),(10.1,159.9),(9.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,159.9),(11.5,160.1),(11.7,160.1),(11.7,159.9),(11.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,159.9),(13.1,160.1),(13.3,160.1),(13.3,159.9),(13.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,159.9),(14.7,160.1),(14.9,160.1),(14.9,159.9),(14.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,159.9),(16.3,160.1),(16.5,160.1),(16.5,159.9),(16.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,159.9),(17.9,160.1),(18.1,160.1),(18.1,159.9),(17.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,161.5),(1.9,161.7),(2.1,161.7),(2.1,161.5),(1.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,161.5),(3.5,161.7),(3.7,161.7),(3.7,161.5),(3.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,161.5),(5.1,161.7),(5.3,161.7),(5.3,161.5),(5.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,161.5),(6.7,161.7),(6.9,161.7),(6.9,161.5),(6.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,161.5),(8.3,161.7),(8.5,161.7),(8.5,161.5),(8.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,161.5),(9.9,161.7),(10.1,161.7),(10.1,161.5),(9.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,161.5),(11.5,161.7),(11.7,161.7),(11.7,161.5),(11.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,161.5),(13.1,161.7),(13.3,161.7),(13.3,161.5),(13.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,161.5),(14.7,161.7),(14.9,161.7),(14.9,161.5),(14.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,161.5),(16.3,161.7),(16.5,161.7),(16.5,161.5),(16.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,161.5),(17.9,161.7),(18.1,161.7),(18.1,161.5),(17.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,163.1),(1.9,163.3),(2.1,163.3),(2.1,163.1),(1.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,163.1),(3.5,163.3),(3.7,163.3),(3.7,163.1),(3.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,163.1),(5.1,163.3),(5.3,163.3),(5.3,163.1),(5.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,163.1),(6.7,163.3),(6.9,163.3),(6.9,163.1),(6.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,163.1),(8.3,163.3),(8.5,163.3),(8.5,163.1),(8.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,163.1),(9.9,163.3),(10.1,163.3),(10.1,163.1),(9.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,163.1),(11.5,163.3),(11.7,163.3),(11.7,163.1),(11.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,163.1),(13.1,163.3),(13.3,163.3),(13.3,163.1),(13.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,163.1),(14.7,163.3),(14.9,163.3),(14.9,163.1),(14.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,163.1),(16.3,163.3),(16.5,163.3),(16.5,163.1),(16.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,163.1),(17.9,163.3),(18.1,163.3),(18.1,163.1),(17.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,164.7),(1.9,164.9),(2.1,164.9),(2.1,164.7),(1.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,164.7),(3.5,164.9),(3.7,164.9),(3.7,164.7),(3.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,164.7),(5.1,164.9),(5.3,164.9),(5.3,164.7),(5.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,164.7),(6.7,164.9),(6.9,164.9),(6.9,164.7),(6.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,164.7),(8.3,164.9),(8.5,164.9),(8.5,164.7),(8.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,164.7),(9.9,164.9),(10.1,164.9),(10.1,164.7),(9.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,164.7),(11.5,164.9),(11.7,164.9),(11.7,164.7),(11.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,164.7),(13.1,164.9),(13.3,164.9),(13.3,164.7),(13.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,164.7),(14.7,164.9),(14.9,164.9),(14.9,164.7),(14.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,164.7),(16.3,164.9),(16.5,164.9),(16.5,164.7),(16.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,164.7),(17.9,164.9),(18.1,164.9),(18.1,164.7),(17.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,166.3),(1.9,166.5),(2.1,166.5),(2.1,166.3),(1.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,166.3),(3.5,166.5),(3.7,166.5),(3.7,166.3),(3.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,166.3),(5.1,166.5),(5.3,166.5),(5.3,166.3),(5.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,166.3),(6.7,166.5),(6.9,166.5),(6.9,166.3),(6.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,166.3),(8.3,166.5),(8.5,166.5),(8.5,166.3),(8.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,166.3),(9.9,166.5),(10.1,166.5),(10.1,166.3),(9.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,166.3),(11.5,166.5),(11.7,166.5),(11.7,166.3),(11.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,166.3),(13.1,166.5),(13.3,166.5),(13.3,166.3),(13.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,166.3),(14.7,166.5),(14.9,166.5),(14.9,166.3),(14.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,166.3),(16.3,166.5),(16.5,166.5),(16.5,166.3),(16.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,166.3),(17.9,166.5),(18.1,166.5),(18.1,166.3),(17.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.9,167.9),(1.9,168.1),(2.1,168.1),(2.1,167.9),(1.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.5,167.9),(3.5,168.1),(3.7,168.1),(3.7,167.9),(3.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((5.1,167.9),(5.1,168.1),(5.3,168.1),(5.3,167.9),(5.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.7,167.9),(6.7,168.1),(6.9,168.1),(6.9,167.9),(6.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.3,167.9),(8.3,168.1),(8.5,168.1),(8.5,167.9),(8.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.9,167.9),(9.9,168.1),(10.1,168.1),(10.1,167.9),(9.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.5,167.9),(11.5,168.1),(11.7,168.1),(11.7,167.9),(11.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((13.1,167.9),(13.1,168.1),(13.3,168.1),(13.3,167.9),(13.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.7,167.9),(14.7,168.1),(14.9,168.1),(14.9,167.9),(14.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.3,167.9),(16.3,168.1),(16.5,168.1),(16.5,167.9),(16.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.9,167.9),(17.9,168.1),(18.1,168.1),(18.1,167.9),(17.9,167.9)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['BulkConn_4000WNoUp']
        except:
            subcell = af.getCell('BulkConn_4000WNoUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_10000WNoUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.08499999999998), u(50.0), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(50.0,0.125),(50.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(50.18,0.42),(50.18,-0.42),(-0.18,-0.42)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(50.125,0.25),(50.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(50.125,14.25),(50.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(50.125,-6.18),(50.125,-30.085),(-0.125,-30.085)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(50.125,8.75),(50.125,8.25),(-0.125,8.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(50.0,8.625),(50.0,8.375),(0.0,8.375)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(50.0,14.125),(50.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(50.18,14.42),(50.18,13.58),(-0.18,13.58)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(50.0,-6.305),(50.0,-29.96),(0.0,-29.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['Filler10000']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(50.0), u(188),
        ))
        nets = {
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(50.0,22.34),(50.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(50.0,10.57),(50.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(50.0,152.0),(50.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(50.0,22.34),(50.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(50.0,10.57),(50.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(50.0,152.0),(50.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(50.0,22.34),(50.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(50.0,10.57),(50.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(50.0,152.0),(50.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(50.0,150.6),(50.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(50.0,20.94),(50.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(50.0,9.17),(50.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(50.0,133.04),(50.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(50.0,103.14),(50.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(50.0,118.08),(50.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(50.0,133.04),(50.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(50.0,103.14),(50.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(50.0,118.08),(50.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(50.0,133.04),(50.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(50.0,103.14),(50.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(50.0,118.08),(50.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(50.0,116.68),(50.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(50.0,131.64),(50.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(50.0,101.74),(50.0,90.8),(0.0,90.8)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(50.0,172.4),(50.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(50.0,188.0),(50.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.0),(0.0,176.0),(0.0,188.0),(50.0,188.0),(50.0,176.0),(24.4,176.0),(24.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(50.0,188.0),(50.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(50.0,172.4),(50.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(25.6,170.0),(25.6,174.78),(48.8,174.78),(48.8,170.0),(50.0,170.0),(50.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(50.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(50.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((25.7,173.69),(25.7,173.89),(25.9,173.89),(25.9,173.69),(25.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,173.69),(26.1,173.89),(26.3,173.89),(26.3,173.69),(26.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,173.69),(26.5,173.89),(26.7,173.89),(26.7,173.69),(26.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,173.69),(26.9,173.89),(27.1,173.89),(27.1,173.69),(26.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,173.69),(27.3,173.89),(27.5,173.89),(27.5,173.69),(27.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,173.69),(27.7,173.89),(27.9,173.89),(27.9,173.69),(27.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,173.69),(28.1,173.89),(28.3,173.89),(28.3,173.69),(28.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,173.69),(28.5,173.89),(28.7,173.89),(28.7,173.69),(28.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,173.69),(28.9,173.89),(29.1,173.89),(29.1,173.69),(28.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,173.69),(29.3,173.89),(29.5,173.89),(29.5,173.69),(29.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,173.69),(29.7,173.89),(29.9,173.89),(29.9,173.69),(29.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,173.69),(30.1,173.89),(30.3,173.89),(30.3,173.69),(30.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,173.69),(30.5,173.89),(30.7,173.89),(30.7,173.69),(30.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,173.69),(30.9,173.89),(31.1,173.89),(31.1,173.69),(30.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,173.69),(31.3,173.89),(31.5,173.89),(31.5,173.69),(31.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,173.69),(31.7,173.89),(31.9,173.89),(31.9,173.69),(31.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,173.69),(32.1,173.89),(32.3,173.89),(32.3,173.69),(32.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,173.69),(32.5,173.89),(32.7,173.89),(32.7,173.69),(32.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,173.69),(32.9,173.89),(33.1,173.89),(33.1,173.69),(32.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,173.69),(33.3,173.89),(33.5,173.89),(33.5,173.69),(33.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,173.69),(33.7,173.89),(33.9,173.89),(33.9,173.69),(33.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,173.69),(34.1,173.89),(34.3,173.89),(34.3,173.69),(34.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,173.69),(34.5,173.89),(34.7,173.89),(34.7,173.69),(34.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,173.69),(34.9,173.89),(35.1,173.89),(35.1,173.69),(34.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,173.69),(35.3,173.89),(35.5,173.89),(35.5,173.69),(35.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,173.69),(35.7,173.89),(35.9,173.89),(35.9,173.69),(35.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,173.69),(36.1,173.89),(36.3,173.89),(36.3,173.69),(36.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,173.69),(36.5,173.89),(36.7,173.89),(36.7,173.69),(36.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,173.69),(36.9,173.89),(37.1,173.89),(37.1,173.69),(36.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,173.69),(37.3,173.89),(37.5,173.89),(37.5,173.69),(37.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,173.69),(37.7,173.89),(37.9,173.89),(37.9,173.69),(37.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,173.69),(38.1,173.89),(38.3,173.89),(38.3,173.69),(38.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,173.69),(38.5,173.89),(38.7,173.89),(38.7,173.69),(38.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,173.69),(38.9,173.89),(39.1,173.89),(39.1,173.69),(38.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,173.69),(39.3,173.89),(39.5,173.89),(39.5,173.69),(39.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,173.69),(39.7,173.89),(39.9,173.89),(39.9,173.69),(39.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,173.69),(40.1,173.89),(40.3,173.89),(40.3,173.69),(40.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,173.69),(40.5,173.89),(40.7,173.89),(40.7,173.69),(40.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,173.69),(40.9,173.89),(41.1,173.89),(41.1,173.69),(40.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,173.69),(41.3,173.89),(41.5,173.89),(41.5,173.69),(41.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,173.69),(41.7,173.89),(41.9,173.89),(41.9,173.69),(41.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,173.69),(42.1,173.89),(42.3,173.89),(42.3,173.69),(42.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,173.69),(42.5,173.89),(42.7,173.89),(42.7,173.69),(42.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,173.69),(42.9,173.89),(43.1,173.89),(43.1,173.69),(42.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,173.69),(43.3,173.89),(43.5,173.89),(43.5,173.69),(43.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,173.69),(43.7,173.89),(43.9,173.89),(43.9,173.69),(43.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,173.69),(44.1,173.89),(44.3,173.89),(44.3,173.69),(44.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((44.5,173.69),(44.5,173.89),(44.7,173.89),(44.7,173.69),(44.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,173.69),(44.9,173.89),(45.1,173.89),(45.1,173.69),(44.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.3,173.69),(45.3,173.89),(45.5,173.89),(45.5,173.69),(45.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,174.09),(25.7,174.29),(25.9,174.29),(25.9,174.09),(25.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,174.09),(26.1,174.29),(26.3,174.29),(26.3,174.09),(26.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,174.09),(26.5,174.29),(26.7,174.29),(26.7,174.09),(26.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,174.09),(26.9,174.29),(27.1,174.29),(27.1,174.09),(26.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,174.09),(27.3,174.29),(27.5,174.29),(27.5,174.09),(27.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,174.09),(27.7,174.29),(27.9,174.29),(27.9,174.09),(27.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,174.09),(28.1,174.29),(28.3,174.29),(28.3,174.09),(28.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,174.09),(28.5,174.29),(28.7,174.29),(28.7,174.09),(28.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,174.09),(28.9,174.29),(29.1,174.29),(29.1,174.09),(28.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,174.09),(29.3,174.29),(29.5,174.29),(29.5,174.09),(29.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,174.09),(29.7,174.29),(29.9,174.29),(29.9,174.09),(29.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,174.09),(30.1,174.29),(30.3,174.29),(30.3,174.09),(30.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,174.09),(30.5,174.29),(30.7,174.29),(30.7,174.09),(30.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,174.09),(30.9,174.29),(31.1,174.29),(31.1,174.09),(30.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,174.09),(31.3,174.29),(31.5,174.29),(31.5,174.09),(31.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,174.09),(31.7,174.29),(31.9,174.29),(31.9,174.09),(31.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,174.09),(32.1,174.29),(32.3,174.29),(32.3,174.09),(32.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,174.09),(32.5,174.29),(32.7,174.29),(32.7,174.09),(32.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,174.09),(32.9,174.29),(33.1,174.29),(33.1,174.09),(32.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,174.09),(33.3,174.29),(33.5,174.29),(33.5,174.09),(33.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,174.09),(33.7,174.29),(33.9,174.29),(33.9,174.09),(33.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,174.09),(34.1,174.29),(34.3,174.29),(34.3,174.09),(34.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,174.09),(34.5,174.29),(34.7,174.29),(34.7,174.09),(34.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,174.09),(34.9,174.29),(35.1,174.29),(35.1,174.09),(34.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,174.09),(35.3,174.29),(35.5,174.29),(35.5,174.09),(35.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,174.09),(35.7,174.29),(35.9,174.29),(35.9,174.09),(35.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,174.09),(36.1,174.29),(36.3,174.29),(36.3,174.09),(36.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,174.09),(36.5,174.29),(36.7,174.29),(36.7,174.09),(36.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,174.09),(36.9,174.29),(37.1,174.29),(37.1,174.09),(36.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,174.09),(37.3,174.29),(37.5,174.29),(37.5,174.09),(37.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,174.09),(37.7,174.29),(37.9,174.29),(37.9,174.09),(37.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,174.09),(38.1,174.29),(38.3,174.29),(38.3,174.09),(38.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,174.09),(38.5,174.29),(38.7,174.29),(38.7,174.09),(38.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,174.09),(38.9,174.29),(39.1,174.29),(39.1,174.09),(38.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,174.09),(39.3,174.29),(39.5,174.29),(39.5,174.09),(39.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,174.09),(39.7,174.29),(39.9,174.29),(39.9,174.09),(39.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,174.09),(40.1,174.29),(40.3,174.29),(40.3,174.09),(40.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,174.09),(40.5,174.29),(40.7,174.29),(40.7,174.09),(40.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,174.09),(40.9,174.29),(41.1,174.29),(41.1,174.09),(40.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,174.09),(41.3,174.29),(41.5,174.29),(41.5,174.09),(41.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,174.09),(41.7,174.29),(41.9,174.29),(41.9,174.09),(41.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,174.09),(42.1,174.29),(42.3,174.29),(42.3,174.09),(42.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,174.09),(42.5,174.29),(42.7,174.29),(42.7,174.09),(42.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,174.09),(42.9,174.29),(43.1,174.29),(43.1,174.09),(42.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,174.09),(43.3,174.29),(43.5,174.29),(43.5,174.09),(43.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,174.09),(43.7,174.29),(43.9,174.29),(43.9,174.09),(43.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,174.09),(44.1,174.29),(44.3,174.29),(44.3,174.09),(44.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((44.5,174.09),(44.5,174.29),(44.7,174.29),(44.7,174.09),(44.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,174.09),(44.9,174.29),(45.1,174.29),(45.1,174.09),(44.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.3,174.09),(45.3,174.29),(45.5,174.29),(45.5,174.09),(45.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,174.49),(25.7,174.69),(25.9,174.69),(25.9,174.49),(25.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,174.49),(26.1,174.69),(26.3,174.69),(26.3,174.49),(26.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,174.49),(26.5,174.69),(26.7,174.69),(26.7,174.49),(26.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,174.49),(26.9,174.69),(27.1,174.69),(27.1,174.49),(26.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,174.49),(27.3,174.69),(27.5,174.69),(27.5,174.49),(27.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,174.49),(27.7,174.69),(27.9,174.69),(27.9,174.49),(27.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,174.49),(28.1,174.69),(28.3,174.69),(28.3,174.49),(28.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,174.49),(28.5,174.69),(28.7,174.69),(28.7,174.49),(28.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,174.49),(28.9,174.69),(29.1,174.69),(29.1,174.49),(28.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,174.49),(29.3,174.69),(29.5,174.69),(29.5,174.49),(29.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,174.49),(29.7,174.69),(29.9,174.69),(29.9,174.49),(29.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,174.49),(30.1,174.69),(30.3,174.69),(30.3,174.49),(30.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,174.49),(30.5,174.69),(30.7,174.69),(30.7,174.49),(30.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,174.49),(30.9,174.69),(31.1,174.69),(31.1,174.49),(30.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,174.49),(31.3,174.69),(31.5,174.69),(31.5,174.49),(31.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,174.49),(31.7,174.69),(31.9,174.69),(31.9,174.49),(31.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,174.49),(32.1,174.69),(32.3,174.69),(32.3,174.49),(32.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,174.49),(32.5,174.69),(32.7,174.69),(32.7,174.49),(32.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,174.49),(32.9,174.69),(33.1,174.69),(33.1,174.49),(32.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,174.49),(33.3,174.69),(33.5,174.69),(33.5,174.49),(33.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,174.49),(33.7,174.69),(33.9,174.69),(33.9,174.49),(33.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,174.49),(34.1,174.69),(34.3,174.69),(34.3,174.49),(34.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,174.49),(34.5,174.69),(34.7,174.69),(34.7,174.49),(34.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,174.49),(34.9,174.69),(35.1,174.69),(35.1,174.49),(34.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,174.49),(35.3,174.69),(35.5,174.69),(35.5,174.49),(35.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,174.49),(35.7,174.69),(35.9,174.69),(35.9,174.49),(35.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,174.49),(36.1,174.69),(36.3,174.69),(36.3,174.49),(36.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,174.49),(36.5,174.69),(36.7,174.69),(36.7,174.49),(36.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,174.49),(36.9,174.69),(37.1,174.69),(37.1,174.49),(36.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,174.49),(37.3,174.69),(37.5,174.69),(37.5,174.49),(37.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,174.49),(37.7,174.69),(37.9,174.69),(37.9,174.49),(37.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,174.49),(38.1,174.69),(38.3,174.69),(38.3,174.49),(38.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,174.49),(38.5,174.69),(38.7,174.69),(38.7,174.49),(38.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,174.49),(38.9,174.69),(39.1,174.69),(39.1,174.49),(38.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,174.49),(39.3,174.69),(39.5,174.69),(39.5,174.49),(39.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,174.49),(39.7,174.69),(39.9,174.69),(39.9,174.49),(39.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,174.49),(40.1,174.69),(40.3,174.69),(40.3,174.49),(40.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,174.49),(40.5,174.69),(40.7,174.69),(40.7,174.49),(40.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,174.49),(40.9,174.69),(41.1,174.69),(41.1,174.49),(40.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,174.49),(41.3,174.69),(41.5,174.69),(41.5,174.49),(41.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,174.49),(41.7,174.69),(41.9,174.69),(41.9,174.49),(41.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,174.49),(42.1,174.69),(42.3,174.69),(42.3,174.49),(42.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,174.49),(42.5,174.69),(42.7,174.69),(42.7,174.49),(42.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,174.49),(42.9,174.69),(43.1,174.69),(43.1,174.49),(42.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,174.49),(43.3,174.69),(43.5,174.69),(43.5,174.49),(43.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,174.49),(43.7,174.69),(43.9,174.69),(43.9,174.49),(43.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,174.49),(44.1,174.69),(44.3,174.69),(44.3,174.49),(44.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((44.5,174.49),(44.5,174.69),(44.7,174.69),(44.7,174.49),(44.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,174.49),(44.9,174.69),(45.1,174.69),(45.1,174.49),(44.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((45.3,174.49),(45.3,174.69),(45.5,174.69),(45.5,174.49),(45.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['BulkConn_10000WNoUp']
        except:
            subcell = af.getCell('BulkConn_10000WNoUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
    # Export failed for cell 'Corner'
    cell = new_cells['IOPadVss']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.115,88.03),(40.115,88.2),(40.285,88.2),(40.285,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,88.03),(73.715,88.2),(73.885,88.2),(73.885,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,88.03),(25.715,88.2),(25.885,88.2),(25.885,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,88.03),(54.515,88.2),(54.685,88.2),(54.685,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,88.03),(6.77,88.2),(6.94,88.2),(6.94,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,88.03),(35.315,88.2),(35.485,88.2),(35.485,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,88.03),(11.315,88.2),(11.485,88.2),(11.485,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,88.03),(64.115,88.2),(64.285,88.2),(64.285,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,88.03),(83.06,88.2),(83.23,88.2),(83.23,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,88.03),(59.315,88.2),(59.485,88.2),(59.485,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,88.03),(20.915,88.2),(21.085,88.2),(21.085,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,88.03),(85.58,88.2),(86.11,88.2),(86.11,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,88.03),(44.915,88.2),(45.085,88.2),(45.085,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,88.03),(49.715,88.2),(49.885,88.2),(49.885,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,88.03),(68.915,88.2),(69.085,88.2),(69.085,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,88.03),(16.115,88.2),(16.285,88.2),(16.285,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,88.03),(30.515,88.2),(30.685,88.2),(30.685,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,88.03),(78.515,88.2),(78.685,88.2),(78.685,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,88.03),(85.58,88.2),(85.75,88.2),(85.75,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,88.03),(85.94,88.2),(86.11,88.2),(86.11,88.03),(85.94,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,88.03),(40.115,88.2),(40.285,88.2),(40.285,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,88.03),(73.715,88.2),(73.885,88.2),(73.885,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,88.03),(25.715,88.2),(25.885,88.2),(25.885,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,88.03),(6.77,88.2),(6.94,88.2),(6.94,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,88.03),(54.515,88.2),(54.685,88.2),(54.685,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,88.03),(35.315,88.2),(35.485,88.2),(35.485,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,88.03),(11.315,88.2),(11.485,88.2),(11.485,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,88.03),(64.115,88.2),(64.285,88.2),(64.285,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,88.03),(83.06,88.2),(83.23,88.2),(83.23,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,88.03),(59.315,88.2),(59.485,88.2),(59.485,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,88.03),(20.915,88.2),(21.085,88.2),(21.085,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,88.03),(44.915,88.2),(45.085,88.2),(45.085,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,88.03),(68.915,88.2),(69.085,88.2),(69.085,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,88.03),(49.715,88.2),(49.885,88.2),(49.885,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,88.03),(16.115,88.2),(16.285,88.2),(16.285,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,88.03),(30.515,88.2),(30.685,88.2),(30.685,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,88.03),(78.515,88.2),(78.685,88.2),(78.685,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,91.365),(16.315,91.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,88.3),(16.315,88.3),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,130.265),(11.515,130.265),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,133.04),(25.915,133.04),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,131.365),(78.715,131.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,130.265),(35.515,130.265),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,130.265),(69.115,130.265),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,88.3),(45.115,88.3),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,131.365),(83.26,131.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,132.98),(83.275,132.98),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,91.365),(83.26,91.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,133.04),(59.515,133.04),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,130.265),(21.115,130.265),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,131.365),(73.915,131.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,88.3),(69.115,88.3),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,132.98),(73.93,132.98),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,131.365),(54.715,131.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,91.365),(73.915,91.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,88.3),(11.515,88.3),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,130.265),(16.315,130.265),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,88.3),(21.115,88.3),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,132.98),(16.33,132.98),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,131.365),(6.97,131.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,88.3),(35.515,88.3),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,133.04),(49.915,133.04),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,130.265),(45.115,130.265),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,132.98),(30.73,132.98),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,131.365),(11.515,131.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,132.98),(11.53,132.98),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,130.265),(25.915,130.265),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,132.98),(78.73,132.98),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,131.365),(35.515,131.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,91.365),(49.915,91.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,133.04),(69.115,133.04),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,91.365),(45.115,91.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,132.98),(35.53,132.98),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,130.265),(40.315,130.265),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,133.04),(83.26,133.04),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,88.3),(83.26,88.3),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,132.98),(40.33,132.98),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,130.265),(59.515,130.265),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,133.04),(21.115,133.04),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,91.365),(69.115,91.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,133.04),(73.915,133.04),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,132.98),(54.73,132.98),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,91.365),(25.915,91.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,88.3),(73.915,88.3),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,131.365),(16.315,131.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,91.365),(21.115,91.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,91.365),(59.515,91.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,133.04),(16.315,133.04),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,132.98),(6.985,132.98),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,130.265),(64.315,130.265),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,133.04),(45.115,133.04),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,130.265),(49.915,130.265),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,132.98),(64.33,132.98),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,91.365),(86.14,91.365),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,133.04),(30.715,133.04),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,91.365),(64.315,91.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,130.265),(30.715,130.265),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,88.3),(64.315,88.3),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,133.04),(11.515,133.04),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,131.365),(25.915,131.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,132.98),(25.93,132.98),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,91.365),(54.715,91.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,88.3),(54.715,88.3),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,132.98),(69.13,132.98),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,88.3),(49.915,88.3),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,133.04),(78.715,133.04),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,130.265),(78.715,130.265),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,133.04),(35.515,133.04),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,131.365),(69.115,131.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,131.365),(40.315,131.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,130.265),(83.26,130.265),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,91.365),(40.315,91.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,133.04),(40.315,133.04),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,91.365),(6.97,91.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,88.3),(40.315,88.3),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,131.365),(59.515,131.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,88.3),(6.97,88.3),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,132.98),(59.53,132.98),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,132.98),(21.13,132.98),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,131.365),(21.115,131.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,91.365),(78.715,91.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,130.265),(73.915,130.265),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,88.3),(78.715,88.3),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,133.04),(54.715,133.04),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,88.3),(25.915,88.3),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,130.265),(54.715,130.265),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,91.365),(11.515,91.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,88.3),(59.515,88.3),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,133.04),(6.97,133.04),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,130.265),(6.97,130.265),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,131.365),(64.315,131.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,91.365),(35.515,91.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,132.98),(45.13,132.98),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,131.365),(49.915,131.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,133.04),(64.315,133.04),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,131.365),(45.115,131.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,91.365),(30.715,91.365),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,132.98),(49.93,132.98),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,88.3),(30.715,88.3),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,131.365),(30.715,131.365),(30.715,87.93),(30.485,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((13.19,158.16),(13.19,172.24),(14.41,172.24),(14.41,158.16),(13.19,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((61.19,158.16),(61.19,172.24),(62.41,172.24),(62.41,158.16),(61.19,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((17.99,158.16),(17.99,172.24),(19.21,172.24),(19.21,158.16),(17.99,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((37.19,158.16),(37.19,172.24),(38.41,172.24),(38.41,158.16),(37.19,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((41.99,158.16),(41.99,172.24),(43.21,172.24),(43.21,158.16),(41.99,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((22.79,158.16),(22.79,172.24),(24.01,172.24),(24.01,158.16),(22.79,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm2',
            ((80.39,158.16),(80.39,172.24),(81.61,172.24),(81.61,158.16),(80.39,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((70.79,158.16),(70.79,172.24),(72.01,172.24),(72.01,158.16),(70.79,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((75.59,158.16),(75.59,172.24),(76.81,172.24),(76.81,158.16),(75.59,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((27.59,158.16),(27.59,172.24),(28.81,172.24),(28.81,158.16),(27.59,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((32.39,158.16),(32.39,172.24),(33.61,172.24),(33.61,158.16),(32.39,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((46.79,158.16),(46.79,172.24),(48.01,172.24),(48.01,158.16),(46.79,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((51.59,158.16),(51.59,172.24),(52.81,172.24),(52.81,158.16),(51.59,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((56.39,158.16),(56.39,172.24),(57.61,172.24),(57.61,158.16),(56.39,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((65.99,158.16),(65.99,172.24),(67.21,172.24),(67.21,158.16),(65.99,158.16)),
        )
        createRL(
            tech, net, 'm2',
            ((8.39,158.16),(8.39,172.24),(9.61,172.24),(9.61,158.16),(8.39,158.16)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,172.4),(72.055,172.4),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,172.4),(57.655,172.4),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,172.4),(76.855,172.4),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,172.4),(43.255,172.4),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,158.0),(17.945,172.4),(19.255,172.4),(19.255,158.0),(17.945,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,172.4),(38.455,172.4),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,158.0),(8.345,172.4),(9.655,172.4),(9.655,158.0),(8.345,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,172.4),(19.255,172.4),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,158.0),(61.145,172.4),(62.455,172.4),(62.455,158.0),(61.145,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,158.0),(46.745,172.4),(48.055,172.4),(48.055,158.0),(46.745,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,158.0),(80.345,172.4),(81.655,172.4),(81.655,158.0),(80.345,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,158.0),(32.345,172.4),(33.655,172.4),(33.655,158.0),(32.345,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,158.0),(51.545,172.4),(52.855,172.4),(52.855,158.0),(51.545,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,172.4),(81.655,172.4),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,172.4),(33.655,172.4),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,158.0),(56.345,172.4),(57.655,172.4),(57.655,158.0),(56.345,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,172.4),(48.055,172.4),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,158.0),(13.145,172.4),(14.455,172.4),(14.455,158.0),(13.145,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,172.4),(52.855,172.4),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,158.0),(41.945,172.4),(43.255,172.4),(43.255,158.0),(41.945,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,158.0),(22.745,172.4),(24.055,172.4),(24.055,158.0),(22.745,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,158.0),(27.545,172.4),(28.855,172.4),(28.855,158.0),(27.545,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,158.0),(65.945,172.4),(67.255,172.4),(67.255,158.0),(65.945,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,172.4),(62.455,172.4),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,172.4),(67.255,172.4),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,172.4),(24.055,172.4),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,172.4),(9.655,172.4),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,158.0),(37.145,172.4),(38.455,172.4),(38.455,158.0),(37.145,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,172.4),(28.855,172.4),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,158.0),(70.745,172.4),(72.055,172.4),(72.055,158.0),(70.745,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,158.0),(75.545,172.4),(76.855,172.4),(76.855,158.0),(75.545,158.0)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,172.4),(14.455,172.4),(14.455,86.32),(13.145,86.32)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,158.245),(37.245,158.395),(37.395,158.395),(37.395,158.245),(37.245,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,158.245),(37.565,158.395),(37.715,158.395),(37.715,158.245),(37.565,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,158.245),(37.885,158.395),(38.035,158.395),(38.035,158.245),(37.885,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,158.245),(38.205,158.395),(38.355,158.395),(38.355,158.245),(38.205,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,158.565),(37.245,158.715),(37.395,158.715),(37.395,158.565),(37.245,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,158.565),(37.565,158.715),(37.715,158.715),(37.715,158.565),(37.565,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,158.565),(37.885,158.715),(38.035,158.715),(38.035,158.565),(37.885,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,158.565),(38.205,158.715),(38.355,158.715),(38.355,158.565),(38.205,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,158.885),(37.245,159.035),(37.395,159.035),(37.395,158.885),(37.245,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,158.885),(37.565,159.035),(37.715,159.035),(37.715,158.885),(37.565,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,158.885),(37.885,159.035),(38.035,159.035),(38.035,158.885),(37.885,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,158.885),(38.205,159.035),(38.355,159.035),(38.355,158.885),(38.205,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,159.205),(37.245,159.355),(37.395,159.355),(37.395,159.205),(37.245,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,159.205),(37.565,159.355),(37.715,159.355),(37.715,159.205),(37.565,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,159.205),(37.885,159.355),(38.035,159.355),(38.035,159.205),(37.885,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,159.205),(38.205,159.355),(38.355,159.355),(38.355,159.205),(38.205,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,159.525),(37.245,159.675),(37.395,159.675),(37.395,159.525),(37.245,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,159.525),(37.565,159.675),(37.715,159.675),(37.715,159.525),(37.565,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,159.525),(37.885,159.675),(38.035,159.675),(38.035,159.525),(37.885,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,159.525),(38.205,159.675),(38.355,159.675),(38.355,159.525),(38.205,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,159.845),(37.245,159.995),(37.395,159.995),(37.395,159.845),(37.245,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,159.845),(37.565,159.995),(37.715,159.995),(37.715,159.845),(37.565,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,159.845),(37.885,159.995),(38.035,159.995),(38.035,159.845),(37.885,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,159.845),(38.205,159.995),(38.355,159.995),(38.355,159.845),(38.205,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,160.165),(37.245,160.315),(37.395,160.315),(37.395,160.165),(37.245,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,160.165),(37.565,160.315),(37.715,160.315),(37.715,160.165),(37.565,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,160.165),(37.885,160.315),(38.035,160.315),(38.035,160.165),(37.885,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,160.165),(38.205,160.315),(38.355,160.315),(38.355,160.165),(38.205,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,160.485),(37.245,160.635),(37.395,160.635),(37.395,160.485),(37.245,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,160.485),(37.565,160.635),(37.715,160.635),(37.715,160.485),(37.565,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,160.485),(37.885,160.635),(38.035,160.635),(38.035,160.485),(37.885,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,160.485),(38.205,160.635),(38.355,160.635),(38.355,160.485),(38.205,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,160.805),(37.245,160.955),(37.395,160.955),(37.395,160.805),(37.245,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,160.805),(37.565,160.955),(37.715,160.955),(37.715,160.805),(37.565,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,160.805),(37.885,160.955),(38.035,160.955),(38.035,160.805),(37.885,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,160.805),(38.205,160.955),(38.355,160.955),(38.355,160.805),(38.205,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,161.125),(37.245,161.275),(37.395,161.275),(37.395,161.125),(37.245,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,161.125),(37.565,161.275),(37.715,161.275),(37.715,161.125),(37.565,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,161.125),(37.885,161.275),(38.035,161.275),(38.035,161.125),(37.885,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,161.125),(38.205,161.275),(38.355,161.275),(38.355,161.125),(38.205,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,161.445),(37.245,161.595),(37.395,161.595),(37.395,161.445),(37.245,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,161.445),(37.565,161.595),(37.715,161.595),(37.715,161.445),(37.565,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,161.445),(37.885,161.595),(38.035,161.595),(38.035,161.445),(37.885,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,161.445),(38.205,161.595),(38.355,161.595),(38.355,161.445),(38.205,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,161.765),(37.245,161.915),(37.395,161.915),(37.395,161.765),(37.245,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,161.765),(37.565,161.915),(37.715,161.915),(37.715,161.765),(37.565,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,161.765),(37.885,161.915),(38.035,161.915),(38.035,161.765),(37.885,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,161.765),(38.205,161.915),(38.355,161.915),(38.355,161.765),(38.205,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,162.085),(37.245,162.235),(37.395,162.235),(37.395,162.085),(37.245,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,162.085),(37.565,162.235),(37.715,162.235),(37.715,162.085),(37.565,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,162.085),(37.885,162.235),(38.035,162.235),(38.035,162.085),(37.885,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,162.085),(38.205,162.235),(38.355,162.235),(38.355,162.085),(38.205,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,162.405),(37.245,162.555),(37.395,162.555),(37.395,162.405),(37.245,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,162.405),(37.565,162.555),(37.715,162.555),(37.715,162.405),(37.565,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,162.405),(37.885,162.555),(38.035,162.555),(38.035,162.405),(37.885,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,162.405),(38.205,162.555),(38.355,162.555),(38.355,162.405),(38.205,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,162.725),(37.245,162.875),(37.395,162.875),(37.395,162.725),(37.245,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,162.725),(37.565,162.875),(37.715,162.875),(37.715,162.725),(37.565,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,162.725),(37.885,162.875),(38.035,162.875),(38.035,162.725),(37.885,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,162.725),(38.205,162.875),(38.355,162.875),(38.355,162.725),(38.205,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,163.045),(37.245,163.195),(37.395,163.195),(37.395,163.045),(37.245,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,163.045),(37.565,163.195),(37.715,163.195),(37.715,163.045),(37.565,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,163.045),(37.885,163.195),(38.035,163.195),(38.035,163.045),(37.885,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,163.045),(38.205,163.195),(38.355,163.195),(38.355,163.045),(38.205,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,163.365),(37.245,163.515),(37.395,163.515),(37.395,163.365),(37.245,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,163.365),(37.565,163.515),(37.715,163.515),(37.715,163.365),(37.565,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,163.365),(37.885,163.515),(38.035,163.515),(38.035,163.365),(37.885,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,163.365),(38.205,163.515),(38.355,163.515),(38.355,163.365),(38.205,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,163.685),(37.245,163.835),(37.395,163.835),(37.395,163.685),(37.245,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,163.685),(37.565,163.835),(37.715,163.835),(37.715,163.685),(37.565,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,163.685),(37.885,163.835),(38.035,163.835),(38.035,163.685),(37.885,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,163.685),(38.205,163.835),(38.355,163.835),(38.355,163.685),(38.205,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,164.005),(37.245,164.155),(37.395,164.155),(37.395,164.005),(37.245,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,164.005),(37.565,164.155),(37.715,164.155),(37.715,164.005),(37.565,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,164.005),(37.885,164.155),(38.035,164.155),(38.035,164.005),(37.885,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,164.005),(38.205,164.155),(38.355,164.155),(38.355,164.005),(38.205,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,164.325),(37.245,164.475),(37.395,164.475),(37.395,164.325),(37.245,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,164.325),(37.565,164.475),(37.715,164.475),(37.715,164.325),(37.565,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,164.325),(37.885,164.475),(38.035,164.475),(38.035,164.325),(37.885,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,164.325),(38.205,164.475),(38.355,164.475),(38.355,164.325),(38.205,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,164.645),(37.245,164.795),(37.395,164.795),(37.395,164.645),(37.245,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,164.645),(37.565,164.795),(37.715,164.795),(37.715,164.645),(37.565,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,164.645),(37.885,164.795),(38.035,164.795),(38.035,164.645),(37.885,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,164.645),(38.205,164.795),(38.355,164.795),(38.355,164.645),(38.205,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,164.965),(37.245,165.115),(37.395,165.115),(37.395,164.965),(37.245,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,164.965),(37.565,165.115),(37.715,165.115),(37.715,164.965),(37.565,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,164.965),(37.885,165.115),(38.035,165.115),(38.035,164.965),(37.885,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,164.965),(38.205,165.115),(38.355,165.115),(38.355,164.965),(38.205,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,165.285),(37.245,165.435),(37.395,165.435),(37.395,165.285),(37.245,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,165.285),(37.565,165.435),(37.715,165.435),(37.715,165.285),(37.565,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,165.285),(37.885,165.435),(38.035,165.435),(38.035,165.285),(37.885,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,165.285),(38.205,165.435),(38.355,165.435),(38.355,165.285),(38.205,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,165.605),(37.245,165.755),(37.395,165.755),(37.395,165.605),(37.245,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,165.605),(37.565,165.755),(37.715,165.755),(37.715,165.605),(37.565,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,165.605),(37.885,165.755),(38.035,165.755),(38.035,165.605),(37.885,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,165.605),(38.205,165.755),(38.355,165.755),(38.355,165.605),(38.205,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,165.925),(37.245,166.075),(37.395,166.075),(37.395,165.925),(37.245,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,165.925),(37.565,166.075),(37.715,166.075),(37.715,165.925),(37.565,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,165.925),(37.885,166.075),(38.035,166.075),(38.035,165.925),(37.885,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,165.925),(38.205,166.075),(38.355,166.075),(38.355,165.925),(38.205,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,166.245),(37.245,166.395),(37.395,166.395),(37.395,166.245),(37.245,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,166.245),(37.565,166.395),(37.715,166.395),(37.715,166.245),(37.565,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,166.245),(37.885,166.395),(38.035,166.395),(38.035,166.245),(37.885,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,166.245),(38.205,166.395),(38.355,166.395),(38.355,166.245),(38.205,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,166.565),(37.245,166.715),(37.395,166.715),(37.395,166.565),(37.245,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,166.565),(37.565,166.715),(37.715,166.715),(37.715,166.565),(37.565,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,166.565),(37.885,166.715),(38.035,166.715),(38.035,166.565),(37.885,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,166.565),(38.205,166.715),(38.355,166.715),(38.355,166.565),(38.205,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,166.885),(37.245,167.035),(37.395,167.035),(37.395,166.885),(37.245,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,166.885),(37.565,167.035),(37.715,167.035),(37.715,166.885),(37.565,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,166.885),(37.885,167.035),(38.035,167.035),(38.035,166.885),(37.885,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,166.885),(38.205,167.035),(38.355,167.035),(38.355,166.885),(38.205,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,167.205),(37.245,167.355),(37.395,167.355),(37.395,167.205),(37.245,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,167.205),(37.565,167.355),(37.715,167.355),(37.715,167.205),(37.565,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,167.205),(37.885,167.355),(38.035,167.355),(38.035,167.205),(37.885,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,167.205),(38.205,167.355),(38.355,167.355),(38.355,167.205),(38.205,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,167.525),(37.245,167.675),(37.395,167.675),(37.395,167.525),(37.245,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,167.525),(37.565,167.675),(37.715,167.675),(37.715,167.525),(37.565,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,167.525),(37.885,167.675),(38.035,167.675),(38.035,167.525),(37.885,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,167.525),(38.205,167.675),(38.355,167.675),(38.355,167.525),(38.205,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,167.845),(37.245,167.995),(37.395,167.995),(37.395,167.845),(37.245,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,167.845),(37.565,167.995),(37.715,167.995),(37.715,167.845),(37.565,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,167.845),(37.885,167.995),(38.035,167.995),(38.035,167.845),(37.885,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,167.845),(38.205,167.995),(38.355,167.995),(38.355,167.845),(38.205,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,168.165),(37.245,168.315),(37.395,168.315),(37.395,168.165),(37.245,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,168.165),(37.565,168.315),(37.715,168.315),(37.715,168.165),(37.565,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,168.165),(37.885,168.315),(38.035,168.315),(38.035,168.165),(37.885,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,168.165),(38.205,168.315),(38.355,168.315),(38.355,168.165),(38.205,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,168.485),(37.245,168.635),(37.395,168.635),(37.395,168.485),(37.245,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,168.485),(37.565,168.635),(37.715,168.635),(37.715,168.485),(37.565,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,168.485),(37.885,168.635),(38.035,168.635),(38.035,168.485),(37.885,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,168.485),(38.205,168.635),(38.355,168.635),(38.355,168.485),(38.205,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,168.805),(37.245,168.955),(37.395,168.955),(37.395,168.805),(37.245,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,168.805),(37.565,168.955),(37.715,168.955),(37.715,168.805),(37.565,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,168.805),(37.885,168.955),(38.035,168.955),(38.035,168.805),(37.885,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,168.805),(38.205,168.955),(38.355,168.955),(38.355,168.805),(38.205,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,169.125),(37.245,169.275),(37.395,169.275),(37.395,169.125),(37.245,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,169.125),(37.565,169.275),(37.715,169.275),(37.715,169.125),(37.565,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,169.125),(37.885,169.275),(38.035,169.275),(38.035,169.125),(37.885,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,169.125),(38.205,169.275),(38.355,169.275),(38.355,169.125),(38.205,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,169.445),(37.245,169.595),(37.395,169.595),(37.395,169.445),(37.245,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,169.445),(37.565,169.595),(37.715,169.595),(37.715,169.445),(37.565,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,169.445),(37.885,169.595),(38.035,169.595),(38.035,169.445),(37.885,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,169.445),(38.205,169.595),(38.355,169.595),(38.355,169.445),(38.205,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,169.765),(37.245,169.915),(37.395,169.915),(37.395,169.765),(37.245,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,169.765),(37.565,169.915),(37.715,169.915),(37.715,169.765),(37.565,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,169.765),(37.885,169.915),(38.035,169.915),(38.035,169.765),(37.885,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,169.765),(38.205,169.915),(38.355,169.915),(38.355,169.765),(38.205,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,170.085),(37.245,170.235),(37.395,170.235),(37.395,170.085),(37.245,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,170.085),(37.565,170.235),(37.715,170.235),(37.715,170.085),(37.565,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,170.085),(37.885,170.235),(38.035,170.235),(38.035,170.085),(37.885,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,170.085),(38.205,170.235),(38.355,170.235),(38.355,170.085),(38.205,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,170.405),(37.245,170.555),(37.395,170.555),(37.395,170.405),(37.245,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,170.405),(37.565,170.555),(37.715,170.555),(37.715,170.405),(37.565,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,170.405),(37.885,170.555),(38.035,170.555),(38.035,170.405),(37.885,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,170.405),(38.205,170.555),(38.355,170.555),(38.355,170.405),(38.205,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,170.725),(37.245,170.875),(37.395,170.875),(37.395,170.725),(37.245,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,170.725),(37.565,170.875),(37.715,170.875),(37.715,170.725),(37.565,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,170.725),(37.885,170.875),(38.035,170.875),(38.035,170.725),(37.885,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,170.725),(38.205,170.875),(38.355,170.875),(38.355,170.725),(38.205,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,171.045),(37.245,171.195),(37.395,171.195),(37.395,171.045),(37.245,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,171.045),(37.565,171.195),(37.715,171.195),(37.715,171.045),(37.565,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,171.045),(37.885,171.195),(38.035,171.195),(38.035,171.045),(37.885,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,171.045),(38.205,171.195),(38.355,171.195),(38.355,171.045),(38.205,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,171.365),(37.245,171.515),(37.395,171.515),(37.395,171.365),(37.245,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,171.365),(37.565,171.515),(37.715,171.515),(37.715,171.365),(37.565,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,171.365),(37.885,171.515),(38.035,171.515),(38.035,171.365),(37.885,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,171.365),(38.205,171.515),(38.355,171.515),(38.355,171.365),(38.205,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,171.685),(37.245,171.835),(37.395,171.835),(37.395,171.685),(37.245,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,171.685),(37.565,171.835),(37.715,171.835),(37.715,171.685),(37.565,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,171.685),(37.885,171.835),(38.035,171.835),(38.035,171.685),(37.885,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,171.685),(38.205,171.835),(38.355,171.835),(38.355,171.685),(38.205,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,172.005),(37.245,172.155),(37.395,172.155),(37.395,172.005),(37.245,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,172.005),(37.565,172.155),(37.715,172.155),(37.715,172.005),(37.565,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,172.005),(37.885,172.155),(38.035,172.155),(38.035,172.005),(37.885,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,172.005),(38.205,172.155),(38.355,172.155),(38.355,172.005),(38.205,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,158.245),(8.445,158.395),(8.595,158.395),(8.595,158.245),(8.445,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,158.245),(8.765,158.395),(8.915,158.395),(8.915,158.245),(8.765,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,158.245),(9.085,158.395),(9.235,158.395),(9.235,158.245),(9.085,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,158.245),(9.405,158.395),(9.555,158.395),(9.555,158.245),(9.405,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,158.565),(8.445,158.715),(8.595,158.715),(8.595,158.565),(8.445,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,158.565),(8.765,158.715),(8.915,158.715),(8.915,158.565),(8.765,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,158.565),(9.085,158.715),(9.235,158.715),(9.235,158.565),(9.085,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,158.565),(9.405,158.715),(9.555,158.715),(9.555,158.565),(9.405,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,158.885),(8.445,159.035),(8.595,159.035),(8.595,158.885),(8.445,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,158.885),(8.765,159.035),(8.915,159.035),(8.915,158.885),(8.765,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,158.885),(9.085,159.035),(9.235,159.035),(9.235,158.885),(9.085,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,158.885),(9.405,159.035),(9.555,159.035),(9.555,158.885),(9.405,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,159.205),(8.445,159.355),(8.595,159.355),(8.595,159.205),(8.445,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,159.205),(8.765,159.355),(8.915,159.355),(8.915,159.205),(8.765,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,159.205),(9.085,159.355),(9.235,159.355),(9.235,159.205),(9.085,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,159.205),(9.405,159.355),(9.555,159.355),(9.555,159.205),(9.405,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,159.525),(8.445,159.675),(8.595,159.675),(8.595,159.525),(8.445,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,159.525),(8.765,159.675),(8.915,159.675),(8.915,159.525),(8.765,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,159.525),(9.085,159.675),(9.235,159.675),(9.235,159.525),(9.085,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,159.525),(9.405,159.675),(9.555,159.675),(9.555,159.525),(9.405,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,159.845),(8.445,159.995),(8.595,159.995),(8.595,159.845),(8.445,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,159.845),(8.765,159.995),(8.915,159.995),(8.915,159.845),(8.765,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,159.845),(9.085,159.995),(9.235,159.995),(9.235,159.845),(9.085,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,159.845),(9.405,159.995),(9.555,159.995),(9.555,159.845),(9.405,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,160.165),(8.445,160.315),(8.595,160.315),(8.595,160.165),(8.445,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,160.165),(8.765,160.315),(8.915,160.315),(8.915,160.165),(8.765,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,160.165),(9.085,160.315),(9.235,160.315),(9.235,160.165),(9.085,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,160.165),(9.405,160.315),(9.555,160.315),(9.555,160.165),(9.405,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,160.485),(8.445,160.635),(8.595,160.635),(8.595,160.485),(8.445,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,160.485),(8.765,160.635),(8.915,160.635),(8.915,160.485),(8.765,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,160.485),(9.085,160.635),(9.235,160.635),(9.235,160.485),(9.085,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,160.485),(9.405,160.635),(9.555,160.635),(9.555,160.485),(9.405,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,160.805),(8.445,160.955),(8.595,160.955),(8.595,160.805),(8.445,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,160.805),(8.765,160.955),(8.915,160.955),(8.915,160.805),(8.765,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,160.805),(9.085,160.955),(9.235,160.955),(9.235,160.805),(9.085,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,160.805),(9.405,160.955),(9.555,160.955),(9.555,160.805),(9.405,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,161.125),(8.445,161.275),(8.595,161.275),(8.595,161.125),(8.445,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,161.125),(8.765,161.275),(8.915,161.275),(8.915,161.125),(8.765,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,161.125),(9.085,161.275),(9.235,161.275),(9.235,161.125),(9.085,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,161.125),(9.405,161.275),(9.555,161.275),(9.555,161.125),(9.405,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,161.445),(8.445,161.595),(8.595,161.595),(8.595,161.445),(8.445,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,161.445),(8.765,161.595),(8.915,161.595),(8.915,161.445),(8.765,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,161.445),(9.085,161.595),(9.235,161.595),(9.235,161.445),(9.085,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,161.445),(9.405,161.595),(9.555,161.595),(9.555,161.445),(9.405,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,161.765),(8.445,161.915),(8.595,161.915),(8.595,161.765),(8.445,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,161.765),(8.765,161.915),(8.915,161.915),(8.915,161.765),(8.765,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,161.765),(9.085,161.915),(9.235,161.915),(9.235,161.765),(9.085,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,161.765),(9.405,161.915),(9.555,161.915),(9.555,161.765),(9.405,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,162.085),(8.445,162.235),(8.595,162.235),(8.595,162.085),(8.445,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,162.085),(8.765,162.235),(8.915,162.235),(8.915,162.085),(8.765,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,162.085),(9.085,162.235),(9.235,162.235),(9.235,162.085),(9.085,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,162.085),(9.405,162.235),(9.555,162.235),(9.555,162.085),(9.405,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,162.405),(8.445,162.555),(8.595,162.555),(8.595,162.405),(8.445,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,162.405),(8.765,162.555),(8.915,162.555),(8.915,162.405),(8.765,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,162.405),(9.085,162.555),(9.235,162.555),(9.235,162.405),(9.085,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,162.405),(9.405,162.555),(9.555,162.555),(9.555,162.405),(9.405,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,162.725),(8.445,162.875),(8.595,162.875),(8.595,162.725),(8.445,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,162.725),(8.765,162.875),(8.915,162.875),(8.915,162.725),(8.765,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,162.725),(9.085,162.875),(9.235,162.875),(9.235,162.725),(9.085,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,162.725),(9.405,162.875),(9.555,162.875),(9.555,162.725),(9.405,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,163.045),(8.445,163.195),(8.595,163.195),(8.595,163.045),(8.445,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,163.045),(8.765,163.195),(8.915,163.195),(8.915,163.045),(8.765,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,163.045),(9.085,163.195),(9.235,163.195),(9.235,163.045),(9.085,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,163.045),(9.405,163.195),(9.555,163.195),(9.555,163.045),(9.405,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,163.365),(8.445,163.515),(8.595,163.515),(8.595,163.365),(8.445,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,163.365),(8.765,163.515),(8.915,163.515),(8.915,163.365),(8.765,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,163.365),(9.085,163.515),(9.235,163.515),(9.235,163.365),(9.085,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,163.365),(9.405,163.515),(9.555,163.515),(9.555,163.365),(9.405,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,163.685),(8.445,163.835),(8.595,163.835),(8.595,163.685),(8.445,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,163.685),(8.765,163.835),(8.915,163.835),(8.915,163.685),(8.765,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,163.685),(9.085,163.835),(9.235,163.835),(9.235,163.685),(9.085,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,163.685),(9.405,163.835),(9.555,163.835),(9.555,163.685),(9.405,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,164.005),(8.445,164.155),(8.595,164.155),(8.595,164.005),(8.445,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,164.005),(8.765,164.155),(8.915,164.155),(8.915,164.005),(8.765,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,164.005),(9.085,164.155),(9.235,164.155),(9.235,164.005),(9.085,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,164.005),(9.405,164.155),(9.555,164.155),(9.555,164.005),(9.405,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,164.325),(8.445,164.475),(8.595,164.475),(8.595,164.325),(8.445,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,164.325),(8.765,164.475),(8.915,164.475),(8.915,164.325),(8.765,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,164.325),(9.085,164.475),(9.235,164.475),(9.235,164.325),(9.085,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,164.325),(9.405,164.475),(9.555,164.475),(9.555,164.325),(9.405,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,164.645),(8.445,164.795),(8.595,164.795),(8.595,164.645),(8.445,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,164.645),(8.765,164.795),(8.915,164.795),(8.915,164.645),(8.765,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,164.645),(9.085,164.795),(9.235,164.795),(9.235,164.645),(9.085,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,164.645),(9.405,164.795),(9.555,164.795),(9.555,164.645),(9.405,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,164.965),(8.445,165.115),(8.595,165.115),(8.595,164.965),(8.445,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,164.965),(8.765,165.115),(8.915,165.115),(8.915,164.965),(8.765,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,164.965),(9.085,165.115),(9.235,165.115),(9.235,164.965),(9.085,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,164.965),(9.405,165.115),(9.555,165.115),(9.555,164.965),(9.405,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,165.285),(8.445,165.435),(8.595,165.435),(8.595,165.285),(8.445,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,165.285),(8.765,165.435),(8.915,165.435),(8.915,165.285),(8.765,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,165.285),(9.085,165.435),(9.235,165.435),(9.235,165.285),(9.085,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,165.285),(9.405,165.435),(9.555,165.435),(9.555,165.285),(9.405,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,165.605),(8.445,165.755),(8.595,165.755),(8.595,165.605),(8.445,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,165.605),(8.765,165.755),(8.915,165.755),(8.915,165.605),(8.765,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,165.605),(9.085,165.755),(9.235,165.755),(9.235,165.605),(9.085,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,165.605),(9.405,165.755),(9.555,165.755),(9.555,165.605),(9.405,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,165.925),(8.445,166.075),(8.595,166.075),(8.595,165.925),(8.445,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,165.925),(8.765,166.075),(8.915,166.075),(8.915,165.925),(8.765,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,165.925),(9.085,166.075),(9.235,166.075),(9.235,165.925),(9.085,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,165.925),(9.405,166.075),(9.555,166.075),(9.555,165.925),(9.405,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,166.245),(8.445,166.395),(8.595,166.395),(8.595,166.245),(8.445,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,166.245),(8.765,166.395),(8.915,166.395),(8.915,166.245),(8.765,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,166.245),(9.085,166.395),(9.235,166.395),(9.235,166.245),(9.085,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,166.245),(9.405,166.395),(9.555,166.395),(9.555,166.245),(9.405,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,166.565),(8.445,166.715),(8.595,166.715),(8.595,166.565),(8.445,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,166.565),(8.765,166.715),(8.915,166.715),(8.915,166.565),(8.765,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,166.565),(9.085,166.715),(9.235,166.715),(9.235,166.565),(9.085,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,166.565),(9.405,166.715),(9.555,166.715),(9.555,166.565),(9.405,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,166.885),(8.445,167.035),(8.595,167.035),(8.595,166.885),(8.445,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,166.885),(8.765,167.035),(8.915,167.035),(8.915,166.885),(8.765,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,166.885),(9.085,167.035),(9.235,167.035),(9.235,166.885),(9.085,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,166.885),(9.405,167.035),(9.555,167.035),(9.555,166.885),(9.405,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,167.205),(8.445,167.355),(8.595,167.355),(8.595,167.205),(8.445,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,167.205),(8.765,167.355),(8.915,167.355),(8.915,167.205),(8.765,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,167.205),(9.085,167.355),(9.235,167.355),(9.235,167.205),(9.085,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,167.205),(9.405,167.355),(9.555,167.355),(9.555,167.205),(9.405,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,167.525),(8.445,167.675),(8.595,167.675),(8.595,167.525),(8.445,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,167.525),(8.765,167.675),(8.915,167.675),(8.915,167.525),(8.765,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,167.525),(9.085,167.675),(9.235,167.675),(9.235,167.525),(9.085,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,167.525),(9.405,167.675),(9.555,167.675),(9.555,167.525),(9.405,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,167.845),(8.445,167.995),(8.595,167.995),(8.595,167.845),(8.445,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,167.845),(8.765,167.995),(8.915,167.995),(8.915,167.845),(8.765,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,167.845),(9.085,167.995),(9.235,167.995),(9.235,167.845),(9.085,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,167.845),(9.405,167.995),(9.555,167.995),(9.555,167.845),(9.405,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,168.165),(8.445,168.315),(8.595,168.315),(8.595,168.165),(8.445,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,168.165),(8.765,168.315),(8.915,168.315),(8.915,168.165),(8.765,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,168.165),(9.085,168.315),(9.235,168.315),(9.235,168.165),(9.085,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,168.165),(9.405,168.315),(9.555,168.315),(9.555,168.165),(9.405,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,168.485),(8.445,168.635),(8.595,168.635),(8.595,168.485),(8.445,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,168.485),(8.765,168.635),(8.915,168.635),(8.915,168.485),(8.765,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,168.485),(9.085,168.635),(9.235,168.635),(9.235,168.485),(9.085,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,168.485),(9.405,168.635),(9.555,168.635),(9.555,168.485),(9.405,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,168.805),(8.445,168.955),(8.595,168.955),(8.595,168.805),(8.445,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,168.805),(8.765,168.955),(8.915,168.955),(8.915,168.805),(8.765,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,168.805),(9.085,168.955),(9.235,168.955),(9.235,168.805),(9.085,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,168.805),(9.405,168.955),(9.555,168.955),(9.555,168.805),(9.405,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,169.125),(8.445,169.275),(8.595,169.275),(8.595,169.125),(8.445,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,169.125),(8.765,169.275),(8.915,169.275),(8.915,169.125),(8.765,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,169.125),(9.085,169.275),(9.235,169.275),(9.235,169.125),(9.085,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,169.125),(9.405,169.275),(9.555,169.275),(9.555,169.125),(9.405,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,169.445),(8.445,169.595),(8.595,169.595),(8.595,169.445),(8.445,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,169.445),(8.765,169.595),(8.915,169.595),(8.915,169.445),(8.765,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,169.445),(9.085,169.595),(9.235,169.595),(9.235,169.445),(9.085,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,169.445),(9.405,169.595),(9.555,169.595),(9.555,169.445),(9.405,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,169.765),(8.445,169.915),(8.595,169.915),(8.595,169.765),(8.445,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,169.765),(8.765,169.915),(8.915,169.915),(8.915,169.765),(8.765,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,169.765),(9.085,169.915),(9.235,169.915),(9.235,169.765),(9.085,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,169.765),(9.405,169.915),(9.555,169.915),(9.555,169.765),(9.405,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,170.085),(8.445,170.235),(8.595,170.235),(8.595,170.085),(8.445,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,170.085),(8.765,170.235),(8.915,170.235),(8.915,170.085),(8.765,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,170.085),(9.085,170.235),(9.235,170.235),(9.235,170.085),(9.085,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,170.085),(9.405,170.235),(9.555,170.235),(9.555,170.085),(9.405,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,170.405),(8.445,170.555),(8.595,170.555),(8.595,170.405),(8.445,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,170.405),(8.765,170.555),(8.915,170.555),(8.915,170.405),(8.765,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,170.405),(9.085,170.555),(9.235,170.555),(9.235,170.405),(9.085,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,170.405),(9.405,170.555),(9.555,170.555),(9.555,170.405),(9.405,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,170.725),(8.445,170.875),(8.595,170.875),(8.595,170.725),(8.445,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,170.725),(8.765,170.875),(8.915,170.875),(8.915,170.725),(8.765,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,170.725),(9.085,170.875),(9.235,170.875),(9.235,170.725),(9.085,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,170.725),(9.405,170.875),(9.555,170.875),(9.555,170.725),(9.405,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,171.045),(8.445,171.195),(8.595,171.195),(8.595,171.045),(8.445,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,171.045),(8.765,171.195),(8.915,171.195),(8.915,171.045),(8.765,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,171.045),(9.085,171.195),(9.235,171.195),(9.235,171.045),(9.085,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,171.045),(9.405,171.195),(9.555,171.195),(9.555,171.045),(9.405,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,171.365),(8.445,171.515),(8.595,171.515),(8.595,171.365),(8.445,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,171.365),(8.765,171.515),(8.915,171.515),(8.915,171.365),(8.765,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,171.365),(9.085,171.515),(9.235,171.515),(9.235,171.365),(9.085,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,171.365),(9.405,171.515),(9.555,171.515),(9.555,171.365),(9.405,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,171.685),(8.445,171.835),(8.595,171.835),(8.595,171.685),(8.445,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,171.685),(8.765,171.835),(8.915,171.835),(8.915,171.685),(8.765,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,171.685),(9.085,171.835),(9.235,171.835),(9.235,171.685),(9.085,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,171.685),(9.405,171.835),(9.555,171.835),(9.555,171.685),(9.405,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,172.005),(8.445,172.155),(8.595,172.155),(8.595,172.005),(8.445,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,172.005),(8.765,172.155),(8.915,172.155),(8.915,172.005),(8.765,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,172.005),(9.085,172.155),(9.235,172.155),(9.235,172.005),(9.085,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,172.005),(9.405,172.155),(9.555,172.155),(9.555,172.005),(9.405,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,158.245),(70.845,158.395),(70.995,158.395),(70.995,158.245),(70.845,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,158.245),(71.165,158.395),(71.315,158.395),(71.315,158.245),(71.165,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,158.245),(71.485,158.395),(71.635,158.395),(71.635,158.245),(71.485,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,158.245),(71.805,158.395),(71.955,158.395),(71.955,158.245),(71.805,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,158.565),(70.845,158.715),(70.995,158.715),(70.995,158.565),(70.845,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,158.565),(71.165,158.715),(71.315,158.715),(71.315,158.565),(71.165,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,158.565),(71.485,158.715),(71.635,158.715),(71.635,158.565),(71.485,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,158.565),(71.805,158.715),(71.955,158.715),(71.955,158.565),(71.805,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,158.885),(70.845,159.035),(70.995,159.035),(70.995,158.885),(70.845,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,158.885),(71.165,159.035),(71.315,159.035),(71.315,158.885),(71.165,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,158.885),(71.485,159.035),(71.635,159.035),(71.635,158.885),(71.485,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,158.885),(71.805,159.035),(71.955,159.035),(71.955,158.885),(71.805,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,159.205),(70.845,159.355),(70.995,159.355),(70.995,159.205),(70.845,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,159.205),(71.165,159.355),(71.315,159.355),(71.315,159.205),(71.165,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,159.205),(71.485,159.355),(71.635,159.355),(71.635,159.205),(71.485,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,159.205),(71.805,159.355),(71.955,159.355),(71.955,159.205),(71.805,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,159.525),(70.845,159.675),(70.995,159.675),(70.995,159.525),(70.845,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,159.525),(71.165,159.675),(71.315,159.675),(71.315,159.525),(71.165,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,159.525),(71.485,159.675),(71.635,159.675),(71.635,159.525),(71.485,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,159.525),(71.805,159.675),(71.955,159.675),(71.955,159.525),(71.805,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,159.845),(70.845,159.995),(70.995,159.995),(70.995,159.845),(70.845,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,159.845),(71.165,159.995),(71.315,159.995),(71.315,159.845),(71.165,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,159.845),(71.485,159.995),(71.635,159.995),(71.635,159.845),(71.485,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,159.845),(71.805,159.995),(71.955,159.995),(71.955,159.845),(71.805,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,160.165),(70.845,160.315),(70.995,160.315),(70.995,160.165),(70.845,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,160.165),(71.165,160.315),(71.315,160.315),(71.315,160.165),(71.165,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,160.165),(71.485,160.315),(71.635,160.315),(71.635,160.165),(71.485,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,160.165),(71.805,160.315),(71.955,160.315),(71.955,160.165),(71.805,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,160.485),(70.845,160.635),(70.995,160.635),(70.995,160.485),(70.845,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,160.485),(71.165,160.635),(71.315,160.635),(71.315,160.485),(71.165,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,160.485),(71.485,160.635),(71.635,160.635),(71.635,160.485),(71.485,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,160.485),(71.805,160.635),(71.955,160.635),(71.955,160.485),(71.805,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,160.805),(70.845,160.955),(70.995,160.955),(70.995,160.805),(70.845,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,160.805),(71.165,160.955),(71.315,160.955),(71.315,160.805),(71.165,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,160.805),(71.485,160.955),(71.635,160.955),(71.635,160.805),(71.485,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,160.805),(71.805,160.955),(71.955,160.955),(71.955,160.805),(71.805,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,161.125),(70.845,161.275),(70.995,161.275),(70.995,161.125),(70.845,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,161.125),(71.165,161.275),(71.315,161.275),(71.315,161.125),(71.165,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,161.125),(71.485,161.275),(71.635,161.275),(71.635,161.125),(71.485,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,161.125),(71.805,161.275),(71.955,161.275),(71.955,161.125),(71.805,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,161.445),(70.845,161.595),(70.995,161.595),(70.995,161.445),(70.845,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,161.445),(71.165,161.595),(71.315,161.595),(71.315,161.445),(71.165,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,161.445),(71.485,161.595),(71.635,161.595),(71.635,161.445),(71.485,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,161.445),(71.805,161.595),(71.955,161.595),(71.955,161.445),(71.805,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,161.765),(70.845,161.915),(70.995,161.915),(70.995,161.765),(70.845,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,161.765),(71.165,161.915),(71.315,161.915),(71.315,161.765),(71.165,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,161.765),(71.485,161.915),(71.635,161.915),(71.635,161.765),(71.485,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,161.765),(71.805,161.915),(71.955,161.915),(71.955,161.765),(71.805,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,162.085),(70.845,162.235),(70.995,162.235),(70.995,162.085),(70.845,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,162.085),(71.165,162.235),(71.315,162.235),(71.315,162.085),(71.165,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,162.085),(71.485,162.235),(71.635,162.235),(71.635,162.085),(71.485,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,162.085),(71.805,162.235),(71.955,162.235),(71.955,162.085),(71.805,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,162.405),(70.845,162.555),(70.995,162.555),(70.995,162.405),(70.845,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,162.405),(71.165,162.555),(71.315,162.555),(71.315,162.405),(71.165,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,162.405),(71.485,162.555),(71.635,162.555),(71.635,162.405),(71.485,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,162.405),(71.805,162.555),(71.955,162.555),(71.955,162.405),(71.805,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,162.725),(70.845,162.875),(70.995,162.875),(70.995,162.725),(70.845,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,162.725),(71.165,162.875),(71.315,162.875),(71.315,162.725),(71.165,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,162.725),(71.485,162.875),(71.635,162.875),(71.635,162.725),(71.485,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,162.725),(71.805,162.875),(71.955,162.875),(71.955,162.725),(71.805,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,163.045),(70.845,163.195),(70.995,163.195),(70.995,163.045),(70.845,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,163.045),(71.165,163.195),(71.315,163.195),(71.315,163.045),(71.165,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,163.045),(71.485,163.195),(71.635,163.195),(71.635,163.045),(71.485,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,163.045),(71.805,163.195),(71.955,163.195),(71.955,163.045),(71.805,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,163.365),(70.845,163.515),(70.995,163.515),(70.995,163.365),(70.845,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,163.365),(71.165,163.515),(71.315,163.515),(71.315,163.365),(71.165,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,163.365),(71.485,163.515),(71.635,163.515),(71.635,163.365),(71.485,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,163.365),(71.805,163.515),(71.955,163.515),(71.955,163.365),(71.805,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,163.685),(70.845,163.835),(70.995,163.835),(70.995,163.685),(70.845,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,163.685),(71.165,163.835),(71.315,163.835),(71.315,163.685),(71.165,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,163.685),(71.485,163.835),(71.635,163.835),(71.635,163.685),(71.485,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,163.685),(71.805,163.835),(71.955,163.835),(71.955,163.685),(71.805,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,164.005),(70.845,164.155),(70.995,164.155),(70.995,164.005),(70.845,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,164.005),(71.165,164.155),(71.315,164.155),(71.315,164.005),(71.165,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,164.005),(71.485,164.155),(71.635,164.155),(71.635,164.005),(71.485,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,164.005),(71.805,164.155),(71.955,164.155),(71.955,164.005),(71.805,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,164.325),(70.845,164.475),(70.995,164.475),(70.995,164.325),(70.845,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,164.325),(71.165,164.475),(71.315,164.475),(71.315,164.325),(71.165,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,164.325),(71.485,164.475),(71.635,164.475),(71.635,164.325),(71.485,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,164.325),(71.805,164.475),(71.955,164.475),(71.955,164.325),(71.805,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,164.645),(70.845,164.795),(70.995,164.795),(70.995,164.645),(70.845,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,164.645),(71.165,164.795),(71.315,164.795),(71.315,164.645),(71.165,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,164.645),(71.485,164.795),(71.635,164.795),(71.635,164.645),(71.485,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,164.645),(71.805,164.795),(71.955,164.795),(71.955,164.645),(71.805,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,164.965),(70.845,165.115),(70.995,165.115),(70.995,164.965),(70.845,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,164.965),(71.165,165.115),(71.315,165.115),(71.315,164.965),(71.165,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,164.965),(71.485,165.115),(71.635,165.115),(71.635,164.965),(71.485,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,164.965),(71.805,165.115),(71.955,165.115),(71.955,164.965),(71.805,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,165.285),(70.845,165.435),(70.995,165.435),(70.995,165.285),(70.845,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,165.285),(71.165,165.435),(71.315,165.435),(71.315,165.285),(71.165,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,165.285),(71.485,165.435),(71.635,165.435),(71.635,165.285),(71.485,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,165.285),(71.805,165.435),(71.955,165.435),(71.955,165.285),(71.805,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,165.605),(70.845,165.755),(70.995,165.755),(70.995,165.605),(70.845,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,165.605),(71.165,165.755),(71.315,165.755),(71.315,165.605),(71.165,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,165.605),(71.485,165.755),(71.635,165.755),(71.635,165.605),(71.485,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,165.605),(71.805,165.755),(71.955,165.755),(71.955,165.605),(71.805,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,165.925),(70.845,166.075),(70.995,166.075),(70.995,165.925),(70.845,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,165.925),(71.165,166.075),(71.315,166.075),(71.315,165.925),(71.165,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,165.925),(71.485,166.075),(71.635,166.075),(71.635,165.925),(71.485,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,165.925),(71.805,166.075),(71.955,166.075),(71.955,165.925),(71.805,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,166.245),(70.845,166.395),(70.995,166.395),(70.995,166.245),(70.845,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,166.245),(71.165,166.395),(71.315,166.395),(71.315,166.245),(71.165,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,166.245),(71.485,166.395),(71.635,166.395),(71.635,166.245),(71.485,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,166.245),(71.805,166.395),(71.955,166.395),(71.955,166.245),(71.805,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,166.565),(70.845,166.715),(70.995,166.715),(70.995,166.565),(70.845,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,166.565),(71.165,166.715),(71.315,166.715),(71.315,166.565),(71.165,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,166.565),(71.485,166.715),(71.635,166.715),(71.635,166.565),(71.485,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,166.565),(71.805,166.715),(71.955,166.715),(71.955,166.565),(71.805,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,166.885),(70.845,167.035),(70.995,167.035),(70.995,166.885),(70.845,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,166.885),(71.165,167.035),(71.315,167.035),(71.315,166.885),(71.165,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,166.885),(71.485,167.035),(71.635,167.035),(71.635,166.885),(71.485,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,166.885),(71.805,167.035),(71.955,167.035),(71.955,166.885),(71.805,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,167.205),(70.845,167.355),(70.995,167.355),(70.995,167.205),(70.845,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,167.205),(71.165,167.355),(71.315,167.355),(71.315,167.205),(71.165,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,167.205),(71.485,167.355),(71.635,167.355),(71.635,167.205),(71.485,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,167.205),(71.805,167.355),(71.955,167.355),(71.955,167.205),(71.805,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,167.525),(70.845,167.675),(70.995,167.675),(70.995,167.525),(70.845,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,167.525),(71.165,167.675),(71.315,167.675),(71.315,167.525),(71.165,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,167.525),(71.485,167.675),(71.635,167.675),(71.635,167.525),(71.485,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,167.525),(71.805,167.675),(71.955,167.675),(71.955,167.525),(71.805,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,167.845),(70.845,167.995),(70.995,167.995),(70.995,167.845),(70.845,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,167.845),(71.165,167.995),(71.315,167.995),(71.315,167.845),(71.165,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,167.845),(71.485,167.995),(71.635,167.995),(71.635,167.845),(71.485,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,167.845),(71.805,167.995),(71.955,167.995),(71.955,167.845),(71.805,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,168.165),(70.845,168.315),(70.995,168.315),(70.995,168.165),(70.845,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,168.165),(71.165,168.315),(71.315,168.315),(71.315,168.165),(71.165,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,168.165),(71.485,168.315),(71.635,168.315),(71.635,168.165),(71.485,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,168.165),(71.805,168.315),(71.955,168.315),(71.955,168.165),(71.805,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,168.485),(70.845,168.635),(70.995,168.635),(70.995,168.485),(70.845,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,168.485),(71.165,168.635),(71.315,168.635),(71.315,168.485),(71.165,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,168.485),(71.485,168.635),(71.635,168.635),(71.635,168.485),(71.485,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,168.485),(71.805,168.635),(71.955,168.635),(71.955,168.485),(71.805,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,168.805),(70.845,168.955),(70.995,168.955),(70.995,168.805),(70.845,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,168.805),(71.165,168.955),(71.315,168.955),(71.315,168.805),(71.165,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,168.805),(71.485,168.955),(71.635,168.955),(71.635,168.805),(71.485,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,168.805),(71.805,168.955),(71.955,168.955),(71.955,168.805),(71.805,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,169.125),(70.845,169.275),(70.995,169.275),(70.995,169.125),(70.845,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,169.125),(71.165,169.275),(71.315,169.275),(71.315,169.125),(71.165,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,169.125),(71.485,169.275),(71.635,169.275),(71.635,169.125),(71.485,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,169.125),(71.805,169.275),(71.955,169.275),(71.955,169.125),(71.805,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,169.445),(70.845,169.595),(70.995,169.595),(70.995,169.445),(70.845,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,169.445),(71.165,169.595),(71.315,169.595),(71.315,169.445),(71.165,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,169.445),(71.485,169.595),(71.635,169.595),(71.635,169.445),(71.485,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,169.445),(71.805,169.595),(71.955,169.595),(71.955,169.445),(71.805,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,169.765),(70.845,169.915),(70.995,169.915),(70.995,169.765),(70.845,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,169.765),(71.165,169.915),(71.315,169.915),(71.315,169.765),(71.165,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,169.765),(71.485,169.915),(71.635,169.915),(71.635,169.765),(71.485,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,169.765),(71.805,169.915),(71.955,169.915),(71.955,169.765),(71.805,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,170.085),(70.845,170.235),(70.995,170.235),(70.995,170.085),(70.845,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,170.085),(71.165,170.235),(71.315,170.235),(71.315,170.085),(71.165,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,170.085),(71.485,170.235),(71.635,170.235),(71.635,170.085),(71.485,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,170.085),(71.805,170.235),(71.955,170.235),(71.955,170.085),(71.805,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,170.405),(70.845,170.555),(70.995,170.555),(70.995,170.405),(70.845,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,170.405),(71.165,170.555),(71.315,170.555),(71.315,170.405),(71.165,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,170.405),(71.485,170.555),(71.635,170.555),(71.635,170.405),(71.485,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,170.405),(71.805,170.555),(71.955,170.555),(71.955,170.405),(71.805,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,170.725),(70.845,170.875),(70.995,170.875),(70.995,170.725),(70.845,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,170.725),(71.165,170.875),(71.315,170.875),(71.315,170.725),(71.165,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,170.725),(71.485,170.875),(71.635,170.875),(71.635,170.725),(71.485,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,170.725),(71.805,170.875),(71.955,170.875),(71.955,170.725),(71.805,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,171.045),(70.845,171.195),(70.995,171.195),(70.995,171.045),(70.845,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,171.045),(71.165,171.195),(71.315,171.195),(71.315,171.045),(71.165,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,171.045),(71.485,171.195),(71.635,171.195),(71.635,171.045),(71.485,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,171.045),(71.805,171.195),(71.955,171.195),(71.955,171.045),(71.805,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,171.365),(70.845,171.515),(70.995,171.515),(70.995,171.365),(70.845,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,171.365),(71.165,171.515),(71.315,171.515),(71.315,171.365),(71.165,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,171.365),(71.485,171.515),(71.635,171.515),(71.635,171.365),(71.485,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,171.365),(71.805,171.515),(71.955,171.515),(71.955,171.365),(71.805,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,171.685),(70.845,171.835),(70.995,171.835),(70.995,171.685),(70.845,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,171.685),(71.165,171.835),(71.315,171.835),(71.315,171.685),(71.165,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,171.685),(71.485,171.835),(71.635,171.835),(71.635,171.685),(71.485,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,171.685),(71.805,171.835),(71.955,171.835),(71.955,171.685),(71.805,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,172.005),(70.845,172.155),(70.995,172.155),(70.995,172.005),(70.845,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,172.005),(71.165,172.155),(71.315,172.155),(71.315,172.005),(71.165,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,172.005),(71.485,172.155),(71.635,172.155),(71.635,172.005),(71.485,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,172.005),(71.805,172.155),(71.955,172.155),(71.955,172.005),(71.805,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,158.245),(18.045,158.395),(18.195,158.395),(18.195,158.245),(18.045,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,158.245),(18.365,158.395),(18.515,158.395),(18.515,158.245),(18.365,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,158.245),(18.685,158.395),(18.835,158.395),(18.835,158.245),(18.685,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,158.245),(19.005,158.395),(19.155,158.395),(19.155,158.245),(19.005,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,158.565),(18.045,158.715),(18.195,158.715),(18.195,158.565),(18.045,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,158.565),(18.365,158.715),(18.515,158.715),(18.515,158.565),(18.365,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,158.565),(18.685,158.715),(18.835,158.715),(18.835,158.565),(18.685,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,158.565),(19.005,158.715),(19.155,158.715),(19.155,158.565),(19.005,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,158.885),(18.045,159.035),(18.195,159.035),(18.195,158.885),(18.045,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,158.885),(18.365,159.035),(18.515,159.035),(18.515,158.885),(18.365,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,158.885),(18.685,159.035),(18.835,159.035),(18.835,158.885),(18.685,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,158.885),(19.005,159.035),(19.155,159.035),(19.155,158.885),(19.005,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,159.205),(18.045,159.355),(18.195,159.355),(18.195,159.205),(18.045,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,159.205),(18.365,159.355),(18.515,159.355),(18.515,159.205),(18.365,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,159.205),(18.685,159.355),(18.835,159.355),(18.835,159.205),(18.685,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,159.205),(19.005,159.355),(19.155,159.355),(19.155,159.205),(19.005,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,159.525),(18.045,159.675),(18.195,159.675),(18.195,159.525),(18.045,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,159.525),(18.365,159.675),(18.515,159.675),(18.515,159.525),(18.365,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,159.525),(18.685,159.675),(18.835,159.675),(18.835,159.525),(18.685,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,159.525),(19.005,159.675),(19.155,159.675),(19.155,159.525),(19.005,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,159.845),(18.045,159.995),(18.195,159.995),(18.195,159.845),(18.045,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,159.845),(18.365,159.995),(18.515,159.995),(18.515,159.845),(18.365,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,159.845),(18.685,159.995),(18.835,159.995),(18.835,159.845),(18.685,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,159.845),(19.005,159.995),(19.155,159.995),(19.155,159.845),(19.005,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,160.165),(18.045,160.315),(18.195,160.315),(18.195,160.165),(18.045,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,160.165),(18.365,160.315),(18.515,160.315),(18.515,160.165),(18.365,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,160.165),(18.685,160.315),(18.835,160.315),(18.835,160.165),(18.685,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,160.165),(19.005,160.315),(19.155,160.315),(19.155,160.165),(19.005,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,160.485),(18.045,160.635),(18.195,160.635),(18.195,160.485),(18.045,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,160.485),(18.365,160.635),(18.515,160.635),(18.515,160.485),(18.365,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,160.485),(18.685,160.635),(18.835,160.635),(18.835,160.485),(18.685,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,160.485),(19.005,160.635),(19.155,160.635),(19.155,160.485),(19.005,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,160.805),(18.045,160.955),(18.195,160.955),(18.195,160.805),(18.045,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,160.805),(18.365,160.955),(18.515,160.955),(18.515,160.805),(18.365,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,160.805),(18.685,160.955),(18.835,160.955),(18.835,160.805),(18.685,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,160.805),(19.005,160.955),(19.155,160.955),(19.155,160.805),(19.005,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,161.125),(18.045,161.275),(18.195,161.275),(18.195,161.125),(18.045,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,161.125),(18.365,161.275),(18.515,161.275),(18.515,161.125),(18.365,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,161.125),(18.685,161.275),(18.835,161.275),(18.835,161.125),(18.685,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,161.125),(19.005,161.275),(19.155,161.275),(19.155,161.125),(19.005,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,161.445),(18.045,161.595),(18.195,161.595),(18.195,161.445),(18.045,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,161.445),(18.365,161.595),(18.515,161.595),(18.515,161.445),(18.365,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,161.445),(18.685,161.595),(18.835,161.595),(18.835,161.445),(18.685,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,161.445),(19.005,161.595),(19.155,161.595),(19.155,161.445),(19.005,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,161.765),(18.045,161.915),(18.195,161.915),(18.195,161.765),(18.045,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,161.765),(18.365,161.915),(18.515,161.915),(18.515,161.765),(18.365,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,161.765),(18.685,161.915),(18.835,161.915),(18.835,161.765),(18.685,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,161.765),(19.005,161.915),(19.155,161.915),(19.155,161.765),(19.005,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,162.085),(18.045,162.235),(18.195,162.235),(18.195,162.085),(18.045,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,162.085),(18.365,162.235),(18.515,162.235),(18.515,162.085),(18.365,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,162.085),(18.685,162.235),(18.835,162.235),(18.835,162.085),(18.685,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,162.085),(19.005,162.235),(19.155,162.235),(19.155,162.085),(19.005,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,162.405),(18.045,162.555),(18.195,162.555),(18.195,162.405),(18.045,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,162.405),(18.365,162.555),(18.515,162.555),(18.515,162.405),(18.365,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,162.405),(18.685,162.555),(18.835,162.555),(18.835,162.405),(18.685,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,162.405),(19.005,162.555),(19.155,162.555),(19.155,162.405),(19.005,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,162.725),(18.045,162.875),(18.195,162.875),(18.195,162.725),(18.045,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,162.725),(18.365,162.875),(18.515,162.875),(18.515,162.725),(18.365,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,162.725),(18.685,162.875),(18.835,162.875),(18.835,162.725),(18.685,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,162.725),(19.005,162.875),(19.155,162.875),(19.155,162.725),(19.005,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,163.045),(18.045,163.195),(18.195,163.195),(18.195,163.045),(18.045,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,163.045),(18.365,163.195),(18.515,163.195),(18.515,163.045),(18.365,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,163.045),(18.685,163.195),(18.835,163.195),(18.835,163.045),(18.685,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,163.045),(19.005,163.195),(19.155,163.195),(19.155,163.045),(19.005,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,163.365),(18.045,163.515),(18.195,163.515),(18.195,163.365),(18.045,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,163.365),(18.365,163.515),(18.515,163.515),(18.515,163.365),(18.365,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,163.365),(18.685,163.515),(18.835,163.515),(18.835,163.365),(18.685,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,163.365),(19.005,163.515),(19.155,163.515),(19.155,163.365),(19.005,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,163.685),(18.045,163.835),(18.195,163.835),(18.195,163.685),(18.045,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,163.685),(18.365,163.835),(18.515,163.835),(18.515,163.685),(18.365,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,163.685),(18.685,163.835),(18.835,163.835),(18.835,163.685),(18.685,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,163.685),(19.005,163.835),(19.155,163.835),(19.155,163.685),(19.005,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,164.005),(18.045,164.155),(18.195,164.155),(18.195,164.005),(18.045,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,164.005),(18.365,164.155),(18.515,164.155),(18.515,164.005),(18.365,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,164.005),(18.685,164.155),(18.835,164.155),(18.835,164.005),(18.685,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,164.005),(19.005,164.155),(19.155,164.155),(19.155,164.005),(19.005,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,164.325),(18.045,164.475),(18.195,164.475),(18.195,164.325),(18.045,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,164.325),(18.365,164.475),(18.515,164.475),(18.515,164.325),(18.365,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,164.325),(18.685,164.475),(18.835,164.475),(18.835,164.325),(18.685,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,164.325),(19.005,164.475),(19.155,164.475),(19.155,164.325),(19.005,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,164.645),(18.045,164.795),(18.195,164.795),(18.195,164.645),(18.045,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,164.645),(18.365,164.795),(18.515,164.795),(18.515,164.645),(18.365,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,164.645),(18.685,164.795),(18.835,164.795),(18.835,164.645),(18.685,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,164.645),(19.005,164.795),(19.155,164.795),(19.155,164.645),(19.005,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,164.965),(18.045,165.115),(18.195,165.115),(18.195,164.965),(18.045,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,164.965),(18.365,165.115),(18.515,165.115),(18.515,164.965),(18.365,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,164.965),(18.685,165.115),(18.835,165.115),(18.835,164.965),(18.685,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,164.965),(19.005,165.115),(19.155,165.115),(19.155,164.965),(19.005,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,165.285),(18.045,165.435),(18.195,165.435),(18.195,165.285),(18.045,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,165.285),(18.365,165.435),(18.515,165.435),(18.515,165.285),(18.365,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,165.285),(18.685,165.435),(18.835,165.435),(18.835,165.285),(18.685,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,165.285),(19.005,165.435),(19.155,165.435),(19.155,165.285),(19.005,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,165.605),(18.045,165.755),(18.195,165.755),(18.195,165.605),(18.045,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,165.605),(18.365,165.755),(18.515,165.755),(18.515,165.605),(18.365,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,165.605),(18.685,165.755),(18.835,165.755),(18.835,165.605),(18.685,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,165.605),(19.005,165.755),(19.155,165.755),(19.155,165.605),(19.005,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,165.925),(18.045,166.075),(18.195,166.075),(18.195,165.925),(18.045,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,165.925),(18.365,166.075),(18.515,166.075),(18.515,165.925),(18.365,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,165.925),(18.685,166.075),(18.835,166.075),(18.835,165.925),(18.685,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,165.925),(19.005,166.075),(19.155,166.075),(19.155,165.925),(19.005,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,166.245),(18.045,166.395),(18.195,166.395),(18.195,166.245),(18.045,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,166.245),(18.365,166.395),(18.515,166.395),(18.515,166.245),(18.365,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,166.245),(18.685,166.395),(18.835,166.395),(18.835,166.245),(18.685,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,166.245),(19.005,166.395),(19.155,166.395),(19.155,166.245),(19.005,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,166.565),(18.045,166.715),(18.195,166.715),(18.195,166.565),(18.045,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,166.565),(18.365,166.715),(18.515,166.715),(18.515,166.565),(18.365,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,166.565),(18.685,166.715),(18.835,166.715),(18.835,166.565),(18.685,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,166.565),(19.005,166.715),(19.155,166.715),(19.155,166.565),(19.005,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,166.885),(18.045,167.035),(18.195,167.035),(18.195,166.885),(18.045,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,166.885),(18.365,167.035),(18.515,167.035),(18.515,166.885),(18.365,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,166.885),(18.685,167.035),(18.835,167.035),(18.835,166.885),(18.685,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,166.885),(19.005,167.035),(19.155,167.035),(19.155,166.885),(19.005,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,167.205),(18.045,167.355),(18.195,167.355),(18.195,167.205),(18.045,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,167.205),(18.365,167.355),(18.515,167.355),(18.515,167.205),(18.365,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,167.205),(18.685,167.355),(18.835,167.355),(18.835,167.205),(18.685,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,167.205),(19.005,167.355),(19.155,167.355),(19.155,167.205),(19.005,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,167.525),(18.045,167.675),(18.195,167.675),(18.195,167.525),(18.045,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,167.525),(18.365,167.675),(18.515,167.675),(18.515,167.525),(18.365,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,167.525),(18.685,167.675),(18.835,167.675),(18.835,167.525),(18.685,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,167.525),(19.005,167.675),(19.155,167.675),(19.155,167.525),(19.005,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,167.845),(18.045,167.995),(18.195,167.995),(18.195,167.845),(18.045,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,167.845),(18.365,167.995),(18.515,167.995),(18.515,167.845),(18.365,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,167.845),(18.685,167.995),(18.835,167.995),(18.835,167.845),(18.685,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,167.845),(19.005,167.995),(19.155,167.995),(19.155,167.845),(19.005,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,168.165),(18.045,168.315),(18.195,168.315),(18.195,168.165),(18.045,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,168.165),(18.365,168.315),(18.515,168.315),(18.515,168.165),(18.365,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,168.165),(18.685,168.315),(18.835,168.315),(18.835,168.165),(18.685,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,168.165),(19.005,168.315),(19.155,168.315),(19.155,168.165),(19.005,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,168.485),(18.045,168.635),(18.195,168.635),(18.195,168.485),(18.045,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,168.485),(18.365,168.635),(18.515,168.635),(18.515,168.485),(18.365,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,168.485),(18.685,168.635),(18.835,168.635),(18.835,168.485),(18.685,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,168.485),(19.005,168.635),(19.155,168.635),(19.155,168.485),(19.005,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,168.805),(18.045,168.955),(18.195,168.955),(18.195,168.805),(18.045,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,168.805),(18.365,168.955),(18.515,168.955),(18.515,168.805),(18.365,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,168.805),(18.685,168.955),(18.835,168.955),(18.835,168.805),(18.685,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,168.805),(19.005,168.955),(19.155,168.955),(19.155,168.805),(19.005,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,169.125),(18.045,169.275),(18.195,169.275),(18.195,169.125),(18.045,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,169.125),(18.365,169.275),(18.515,169.275),(18.515,169.125),(18.365,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,169.125),(18.685,169.275),(18.835,169.275),(18.835,169.125),(18.685,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,169.125),(19.005,169.275),(19.155,169.275),(19.155,169.125),(19.005,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,169.445),(18.045,169.595),(18.195,169.595),(18.195,169.445),(18.045,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,169.445),(18.365,169.595),(18.515,169.595),(18.515,169.445),(18.365,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,169.445),(18.685,169.595),(18.835,169.595),(18.835,169.445),(18.685,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,169.445),(19.005,169.595),(19.155,169.595),(19.155,169.445),(19.005,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,169.765),(18.045,169.915),(18.195,169.915),(18.195,169.765),(18.045,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,169.765),(18.365,169.915),(18.515,169.915),(18.515,169.765),(18.365,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,169.765),(18.685,169.915),(18.835,169.915),(18.835,169.765),(18.685,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,169.765),(19.005,169.915),(19.155,169.915),(19.155,169.765),(19.005,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,170.085),(18.045,170.235),(18.195,170.235),(18.195,170.085),(18.045,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,170.085),(18.365,170.235),(18.515,170.235),(18.515,170.085),(18.365,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,170.085),(18.685,170.235),(18.835,170.235),(18.835,170.085),(18.685,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,170.085),(19.005,170.235),(19.155,170.235),(19.155,170.085),(19.005,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,170.405),(18.045,170.555),(18.195,170.555),(18.195,170.405),(18.045,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,170.405),(18.365,170.555),(18.515,170.555),(18.515,170.405),(18.365,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,170.405),(18.685,170.555),(18.835,170.555),(18.835,170.405),(18.685,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,170.405),(19.005,170.555),(19.155,170.555),(19.155,170.405),(19.005,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,170.725),(18.045,170.875),(18.195,170.875),(18.195,170.725),(18.045,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,170.725),(18.365,170.875),(18.515,170.875),(18.515,170.725),(18.365,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,170.725),(18.685,170.875),(18.835,170.875),(18.835,170.725),(18.685,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,170.725),(19.005,170.875),(19.155,170.875),(19.155,170.725),(19.005,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,171.045),(18.045,171.195),(18.195,171.195),(18.195,171.045),(18.045,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,171.045),(18.365,171.195),(18.515,171.195),(18.515,171.045),(18.365,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,171.045),(18.685,171.195),(18.835,171.195),(18.835,171.045),(18.685,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,171.045),(19.005,171.195),(19.155,171.195),(19.155,171.045),(19.005,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,171.365),(18.045,171.515),(18.195,171.515),(18.195,171.365),(18.045,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,171.365),(18.365,171.515),(18.515,171.515),(18.515,171.365),(18.365,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,171.365),(18.685,171.515),(18.835,171.515),(18.835,171.365),(18.685,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,171.365),(19.005,171.515),(19.155,171.515),(19.155,171.365),(19.005,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,171.685),(18.045,171.835),(18.195,171.835),(18.195,171.685),(18.045,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,171.685),(18.365,171.835),(18.515,171.835),(18.515,171.685),(18.365,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,171.685),(18.685,171.835),(18.835,171.835),(18.835,171.685),(18.685,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,171.685),(19.005,171.835),(19.155,171.835),(19.155,171.685),(19.005,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,172.005),(18.045,172.155),(18.195,172.155),(18.195,172.005),(18.045,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,172.005),(18.365,172.155),(18.515,172.155),(18.515,172.005),(18.365,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,172.005),(18.685,172.155),(18.835,172.155),(18.835,172.005),(18.685,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,172.005),(19.005,172.155),(19.155,172.155),(19.155,172.005),(19.005,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,158.245),(56.445,158.395),(56.595,158.395),(56.595,158.245),(56.445,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,158.245),(56.765,158.395),(56.915,158.395),(56.915,158.245),(56.765,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,158.245),(57.085,158.395),(57.235,158.395),(57.235,158.245),(57.085,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,158.245),(57.405,158.395),(57.555,158.395),(57.555,158.245),(57.405,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,158.565),(56.445,158.715),(56.595,158.715),(56.595,158.565),(56.445,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,158.565),(56.765,158.715),(56.915,158.715),(56.915,158.565),(56.765,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,158.565),(57.085,158.715),(57.235,158.715),(57.235,158.565),(57.085,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,158.565),(57.405,158.715),(57.555,158.715),(57.555,158.565),(57.405,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,158.885),(56.445,159.035),(56.595,159.035),(56.595,158.885),(56.445,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,158.885),(56.765,159.035),(56.915,159.035),(56.915,158.885),(56.765,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,158.885),(57.085,159.035),(57.235,159.035),(57.235,158.885),(57.085,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,158.885),(57.405,159.035),(57.555,159.035),(57.555,158.885),(57.405,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,159.205),(56.445,159.355),(56.595,159.355),(56.595,159.205),(56.445,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,159.205),(56.765,159.355),(56.915,159.355),(56.915,159.205),(56.765,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,159.205),(57.085,159.355),(57.235,159.355),(57.235,159.205),(57.085,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,159.205),(57.405,159.355),(57.555,159.355),(57.555,159.205),(57.405,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,159.525),(56.445,159.675),(56.595,159.675),(56.595,159.525),(56.445,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,159.525),(56.765,159.675),(56.915,159.675),(56.915,159.525),(56.765,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,159.525),(57.085,159.675),(57.235,159.675),(57.235,159.525),(57.085,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,159.525),(57.405,159.675),(57.555,159.675),(57.555,159.525),(57.405,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,159.845),(56.445,159.995),(56.595,159.995),(56.595,159.845),(56.445,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,159.845),(56.765,159.995),(56.915,159.995),(56.915,159.845),(56.765,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,159.845),(57.085,159.995),(57.235,159.995),(57.235,159.845),(57.085,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,159.845),(57.405,159.995),(57.555,159.995),(57.555,159.845),(57.405,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,160.165),(56.445,160.315),(56.595,160.315),(56.595,160.165),(56.445,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,160.165),(56.765,160.315),(56.915,160.315),(56.915,160.165),(56.765,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,160.165),(57.085,160.315),(57.235,160.315),(57.235,160.165),(57.085,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,160.165),(57.405,160.315),(57.555,160.315),(57.555,160.165),(57.405,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,160.485),(56.445,160.635),(56.595,160.635),(56.595,160.485),(56.445,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,160.485),(56.765,160.635),(56.915,160.635),(56.915,160.485),(56.765,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,160.485),(57.085,160.635),(57.235,160.635),(57.235,160.485),(57.085,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,160.485),(57.405,160.635),(57.555,160.635),(57.555,160.485),(57.405,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,160.805),(56.445,160.955),(56.595,160.955),(56.595,160.805),(56.445,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,160.805),(56.765,160.955),(56.915,160.955),(56.915,160.805),(56.765,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,160.805),(57.085,160.955),(57.235,160.955),(57.235,160.805),(57.085,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,160.805),(57.405,160.955),(57.555,160.955),(57.555,160.805),(57.405,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,161.125),(56.445,161.275),(56.595,161.275),(56.595,161.125),(56.445,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,161.125),(56.765,161.275),(56.915,161.275),(56.915,161.125),(56.765,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,161.125),(57.085,161.275),(57.235,161.275),(57.235,161.125),(57.085,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,161.125),(57.405,161.275),(57.555,161.275),(57.555,161.125),(57.405,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,161.445),(56.445,161.595),(56.595,161.595),(56.595,161.445),(56.445,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,161.445),(56.765,161.595),(56.915,161.595),(56.915,161.445),(56.765,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,161.445),(57.085,161.595),(57.235,161.595),(57.235,161.445),(57.085,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,161.445),(57.405,161.595),(57.555,161.595),(57.555,161.445),(57.405,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,161.765),(56.445,161.915),(56.595,161.915),(56.595,161.765),(56.445,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,161.765),(56.765,161.915),(56.915,161.915),(56.915,161.765),(56.765,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,161.765),(57.085,161.915),(57.235,161.915),(57.235,161.765),(57.085,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,161.765),(57.405,161.915),(57.555,161.915),(57.555,161.765),(57.405,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,162.085),(56.445,162.235),(56.595,162.235),(56.595,162.085),(56.445,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,162.085),(56.765,162.235),(56.915,162.235),(56.915,162.085),(56.765,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,162.085),(57.085,162.235),(57.235,162.235),(57.235,162.085),(57.085,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,162.085),(57.405,162.235),(57.555,162.235),(57.555,162.085),(57.405,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,162.405),(56.445,162.555),(56.595,162.555),(56.595,162.405),(56.445,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,162.405),(56.765,162.555),(56.915,162.555),(56.915,162.405),(56.765,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,162.405),(57.085,162.555),(57.235,162.555),(57.235,162.405),(57.085,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,162.405),(57.405,162.555),(57.555,162.555),(57.555,162.405),(57.405,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,162.725),(56.445,162.875),(56.595,162.875),(56.595,162.725),(56.445,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,162.725),(56.765,162.875),(56.915,162.875),(56.915,162.725),(56.765,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,162.725),(57.085,162.875),(57.235,162.875),(57.235,162.725),(57.085,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,162.725),(57.405,162.875),(57.555,162.875),(57.555,162.725),(57.405,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,163.045),(56.445,163.195),(56.595,163.195),(56.595,163.045),(56.445,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,163.045),(56.765,163.195),(56.915,163.195),(56.915,163.045),(56.765,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,163.045),(57.085,163.195),(57.235,163.195),(57.235,163.045),(57.085,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,163.045),(57.405,163.195),(57.555,163.195),(57.555,163.045),(57.405,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,163.365),(56.445,163.515),(56.595,163.515),(56.595,163.365),(56.445,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,163.365),(56.765,163.515),(56.915,163.515),(56.915,163.365),(56.765,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,163.365),(57.085,163.515),(57.235,163.515),(57.235,163.365),(57.085,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,163.365),(57.405,163.515),(57.555,163.515),(57.555,163.365),(57.405,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,163.685),(56.445,163.835),(56.595,163.835),(56.595,163.685),(56.445,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,163.685),(56.765,163.835),(56.915,163.835),(56.915,163.685),(56.765,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,163.685),(57.085,163.835),(57.235,163.835),(57.235,163.685),(57.085,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,163.685),(57.405,163.835),(57.555,163.835),(57.555,163.685),(57.405,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,164.005),(56.445,164.155),(56.595,164.155),(56.595,164.005),(56.445,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,164.005),(56.765,164.155),(56.915,164.155),(56.915,164.005),(56.765,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,164.005),(57.085,164.155),(57.235,164.155),(57.235,164.005),(57.085,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,164.005),(57.405,164.155),(57.555,164.155),(57.555,164.005),(57.405,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,164.325),(56.445,164.475),(56.595,164.475),(56.595,164.325),(56.445,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,164.325),(56.765,164.475),(56.915,164.475),(56.915,164.325),(56.765,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,164.325),(57.085,164.475),(57.235,164.475),(57.235,164.325),(57.085,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,164.325),(57.405,164.475),(57.555,164.475),(57.555,164.325),(57.405,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,164.645),(56.445,164.795),(56.595,164.795),(56.595,164.645),(56.445,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,164.645),(56.765,164.795),(56.915,164.795),(56.915,164.645),(56.765,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,164.645),(57.085,164.795),(57.235,164.795),(57.235,164.645),(57.085,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,164.645),(57.405,164.795),(57.555,164.795),(57.555,164.645),(57.405,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,164.965),(56.445,165.115),(56.595,165.115),(56.595,164.965),(56.445,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,164.965),(56.765,165.115),(56.915,165.115),(56.915,164.965),(56.765,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,164.965),(57.085,165.115),(57.235,165.115),(57.235,164.965),(57.085,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,164.965),(57.405,165.115),(57.555,165.115),(57.555,164.965),(57.405,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,165.285),(56.445,165.435),(56.595,165.435),(56.595,165.285),(56.445,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,165.285),(56.765,165.435),(56.915,165.435),(56.915,165.285),(56.765,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,165.285),(57.085,165.435),(57.235,165.435),(57.235,165.285),(57.085,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,165.285),(57.405,165.435),(57.555,165.435),(57.555,165.285),(57.405,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,165.605),(56.445,165.755),(56.595,165.755),(56.595,165.605),(56.445,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,165.605),(56.765,165.755),(56.915,165.755),(56.915,165.605),(56.765,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,165.605),(57.085,165.755),(57.235,165.755),(57.235,165.605),(57.085,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,165.605),(57.405,165.755),(57.555,165.755),(57.555,165.605),(57.405,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,165.925),(56.445,166.075),(56.595,166.075),(56.595,165.925),(56.445,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,165.925),(56.765,166.075),(56.915,166.075),(56.915,165.925),(56.765,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,165.925),(57.085,166.075),(57.235,166.075),(57.235,165.925),(57.085,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,165.925),(57.405,166.075),(57.555,166.075),(57.555,165.925),(57.405,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,166.245),(56.445,166.395),(56.595,166.395),(56.595,166.245),(56.445,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,166.245),(56.765,166.395),(56.915,166.395),(56.915,166.245),(56.765,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,166.245),(57.085,166.395),(57.235,166.395),(57.235,166.245),(57.085,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,166.245),(57.405,166.395),(57.555,166.395),(57.555,166.245),(57.405,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,166.565),(56.445,166.715),(56.595,166.715),(56.595,166.565),(56.445,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,166.565),(56.765,166.715),(56.915,166.715),(56.915,166.565),(56.765,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,166.565),(57.085,166.715),(57.235,166.715),(57.235,166.565),(57.085,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,166.565),(57.405,166.715),(57.555,166.715),(57.555,166.565),(57.405,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,166.885),(56.445,167.035),(56.595,167.035),(56.595,166.885),(56.445,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,166.885),(56.765,167.035),(56.915,167.035),(56.915,166.885),(56.765,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,166.885),(57.085,167.035),(57.235,167.035),(57.235,166.885),(57.085,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,166.885),(57.405,167.035),(57.555,167.035),(57.555,166.885),(57.405,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,167.205),(56.445,167.355),(56.595,167.355),(56.595,167.205),(56.445,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,167.205),(56.765,167.355),(56.915,167.355),(56.915,167.205),(56.765,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,167.205),(57.085,167.355),(57.235,167.355),(57.235,167.205),(57.085,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,167.205),(57.405,167.355),(57.555,167.355),(57.555,167.205),(57.405,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,167.525),(56.445,167.675),(56.595,167.675),(56.595,167.525),(56.445,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,167.525),(56.765,167.675),(56.915,167.675),(56.915,167.525),(56.765,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,167.525),(57.085,167.675),(57.235,167.675),(57.235,167.525),(57.085,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,167.525),(57.405,167.675),(57.555,167.675),(57.555,167.525),(57.405,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,167.845),(56.445,167.995),(56.595,167.995),(56.595,167.845),(56.445,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,167.845),(56.765,167.995),(56.915,167.995),(56.915,167.845),(56.765,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,167.845),(57.085,167.995),(57.235,167.995),(57.235,167.845),(57.085,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,167.845),(57.405,167.995),(57.555,167.995),(57.555,167.845),(57.405,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,168.165),(56.445,168.315),(56.595,168.315),(56.595,168.165),(56.445,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,168.165),(56.765,168.315),(56.915,168.315),(56.915,168.165),(56.765,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,168.165),(57.085,168.315),(57.235,168.315),(57.235,168.165),(57.085,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,168.165),(57.405,168.315),(57.555,168.315),(57.555,168.165),(57.405,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,168.485),(56.445,168.635),(56.595,168.635),(56.595,168.485),(56.445,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,168.485),(56.765,168.635),(56.915,168.635),(56.915,168.485),(56.765,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,168.485),(57.085,168.635),(57.235,168.635),(57.235,168.485),(57.085,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,168.485),(57.405,168.635),(57.555,168.635),(57.555,168.485),(57.405,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,168.805),(56.445,168.955),(56.595,168.955),(56.595,168.805),(56.445,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,168.805),(56.765,168.955),(56.915,168.955),(56.915,168.805),(56.765,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,168.805),(57.085,168.955),(57.235,168.955),(57.235,168.805),(57.085,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,168.805),(57.405,168.955),(57.555,168.955),(57.555,168.805),(57.405,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,169.125),(56.445,169.275),(56.595,169.275),(56.595,169.125),(56.445,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,169.125),(56.765,169.275),(56.915,169.275),(56.915,169.125),(56.765,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,169.125),(57.085,169.275),(57.235,169.275),(57.235,169.125),(57.085,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,169.125),(57.405,169.275),(57.555,169.275),(57.555,169.125),(57.405,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,169.445),(56.445,169.595),(56.595,169.595),(56.595,169.445),(56.445,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,169.445),(56.765,169.595),(56.915,169.595),(56.915,169.445),(56.765,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,169.445),(57.085,169.595),(57.235,169.595),(57.235,169.445),(57.085,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,169.445),(57.405,169.595),(57.555,169.595),(57.555,169.445),(57.405,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,169.765),(56.445,169.915),(56.595,169.915),(56.595,169.765),(56.445,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,169.765),(56.765,169.915),(56.915,169.915),(56.915,169.765),(56.765,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,169.765),(57.085,169.915),(57.235,169.915),(57.235,169.765),(57.085,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,169.765),(57.405,169.915),(57.555,169.915),(57.555,169.765),(57.405,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,170.085),(56.445,170.235),(56.595,170.235),(56.595,170.085),(56.445,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,170.085),(56.765,170.235),(56.915,170.235),(56.915,170.085),(56.765,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,170.085),(57.085,170.235),(57.235,170.235),(57.235,170.085),(57.085,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,170.085),(57.405,170.235),(57.555,170.235),(57.555,170.085),(57.405,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,170.405),(56.445,170.555),(56.595,170.555),(56.595,170.405),(56.445,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,170.405),(56.765,170.555),(56.915,170.555),(56.915,170.405),(56.765,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,170.405),(57.085,170.555),(57.235,170.555),(57.235,170.405),(57.085,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,170.405),(57.405,170.555),(57.555,170.555),(57.555,170.405),(57.405,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,170.725),(56.445,170.875),(56.595,170.875),(56.595,170.725),(56.445,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,170.725),(56.765,170.875),(56.915,170.875),(56.915,170.725),(56.765,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,170.725),(57.085,170.875),(57.235,170.875),(57.235,170.725),(57.085,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,170.725),(57.405,170.875),(57.555,170.875),(57.555,170.725),(57.405,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,171.045),(56.445,171.195),(56.595,171.195),(56.595,171.045),(56.445,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,171.045),(56.765,171.195),(56.915,171.195),(56.915,171.045),(56.765,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,171.045),(57.085,171.195),(57.235,171.195),(57.235,171.045),(57.085,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,171.045),(57.405,171.195),(57.555,171.195),(57.555,171.045),(57.405,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,171.365),(56.445,171.515),(56.595,171.515),(56.595,171.365),(56.445,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,171.365),(56.765,171.515),(56.915,171.515),(56.915,171.365),(56.765,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,171.365),(57.085,171.515),(57.235,171.515),(57.235,171.365),(57.085,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,171.365),(57.405,171.515),(57.555,171.515),(57.555,171.365),(57.405,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,171.685),(56.445,171.835),(56.595,171.835),(56.595,171.685),(56.445,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,171.685),(56.765,171.835),(56.915,171.835),(56.915,171.685),(56.765,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,171.685),(57.085,171.835),(57.235,171.835),(57.235,171.685),(57.085,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,171.685),(57.405,171.835),(57.555,171.835),(57.555,171.685),(57.405,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,172.005),(56.445,172.155),(56.595,172.155),(56.595,172.005),(56.445,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,172.005),(56.765,172.155),(56.915,172.155),(56.915,172.005),(56.765,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,172.005),(57.085,172.155),(57.235,172.155),(57.235,172.005),(57.085,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,172.005),(57.405,172.155),(57.555,172.155),(57.555,172.005),(57.405,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,158.245),(66.045,158.395),(66.195,158.395),(66.195,158.245),(66.045,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,158.245),(66.365,158.395),(66.515,158.395),(66.515,158.245),(66.365,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,158.245),(66.685,158.395),(66.835,158.395),(66.835,158.245),(66.685,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,158.245),(67.005,158.395),(67.155,158.395),(67.155,158.245),(67.005,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,158.565),(66.045,158.715),(66.195,158.715),(66.195,158.565),(66.045,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,158.565),(66.365,158.715),(66.515,158.715),(66.515,158.565),(66.365,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,158.565),(66.685,158.715),(66.835,158.715),(66.835,158.565),(66.685,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,158.565),(67.005,158.715),(67.155,158.715),(67.155,158.565),(67.005,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,158.885),(66.045,159.035),(66.195,159.035),(66.195,158.885),(66.045,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,158.885),(66.365,159.035),(66.515,159.035),(66.515,158.885),(66.365,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,158.885),(66.685,159.035),(66.835,159.035),(66.835,158.885),(66.685,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,158.885),(67.005,159.035),(67.155,159.035),(67.155,158.885),(67.005,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,159.205),(66.045,159.355),(66.195,159.355),(66.195,159.205),(66.045,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,159.205),(66.365,159.355),(66.515,159.355),(66.515,159.205),(66.365,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,159.205),(66.685,159.355),(66.835,159.355),(66.835,159.205),(66.685,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,159.205),(67.005,159.355),(67.155,159.355),(67.155,159.205),(67.005,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,159.525),(66.045,159.675),(66.195,159.675),(66.195,159.525),(66.045,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,159.525),(66.365,159.675),(66.515,159.675),(66.515,159.525),(66.365,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,159.525),(66.685,159.675),(66.835,159.675),(66.835,159.525),(66.685,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,159.525),(67.005,159.675),(67.155,159.675),(67.155,159.525),(67.005,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,159.845),(66.045,159.995),(66.195,159.995),(66.195,159.845),(66.045,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,159.845),(66.365,159.995),(66.515,159.995),(66.515,159.845),(66.365,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,159.845),(66.685,159.995),(66.835,159.995),(66.835,159.845),(66.685,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,159.845),(67.005,159.995),(67.155,159.995),(67.155,159.845),(67.005,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,160.165),(66.045,160.315),(66.195,160.315),(66.195,160.165),(66.045,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,160.165),(66.365,160.315),(66.515,160.315),(66.515,160.165),(66.365,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,160.165),(66.685,160.315),(66.835,160.315),(66.835,160.165),(66.685,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,160.165),(67.005,160.315),(67.155,160.315),(67.155,160.165),(67.005,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,160.485),(66.045,160.635),(66.195,160.635),(66.195,160.485),(66.045,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,160.485),(66.365,160.635),(66.515,160.635),(66.515,160.485),(66.365,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,160.485),(66.685,160.635),(66.835,160.635),(66.835,160.485),(66.685,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,160.485),(67.005,160.635),(67.155,160.635),(67.155,160.485),(67.005,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,160.805),(66.045,160.955),(66.195,160.955),(66.195,160.805),(66.045,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,160.805),(66.365,160.955),(66.515,160.955),(66.515,160.805),(66.365,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,160.805),(66.685,160.955),(66.835,160.955),(66.835,160.805),(66.685,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,160.805),(67.005,160.955),(67.155,160.955),(67.155,160.805),(67.005,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,161.125),(66.045,161.275),(66.195,161.275),(66.195,161.125),(66.045,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,161.125),(66.365,161.275),(66.515,161.275),(66.515,161.125),(66.365,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,161.125),(66.685,161.275),(66.835,161.275),(66.835,161.125),(66.685,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,161.125),(67.005,161.275),(67.155,161.275),(67.155,161.125),(67.005,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,161.445),(66.045,161.595),(66.195,161.595),(66.195,161.445),(66.045,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,161.445),(66.365,161.595),(66.515,161.595),(66.515,161.445),(66.365,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,161.445),(66.685,161.595),(66.835,161.595),(66.835,161.445),(66.685,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,161.445),(67.005,161.595),(67.155,161.595),(67.155,161.445),(67.005,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,161.765),(66.045,161.915),(66.195,161.915),(66.195,161.765),(66.045,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,161.765),(66.365,161.915),(66.515,161.915),(66.515,161.765),(66.365,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,161.765),(66.685,161.915),(66.835,161.915),(66.835,161.765),(66.685,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,161.765),(67.005,161.915),(67.155,161.915),(67.155,161.765),(67.005,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,162.085),(66.045,162.235),(66.195,162.235),(66.195,162.085),(66.045,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,162.085),(66.365,162.235),(66.515,162.235),(66.515,162.085),(66.365,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,162.085),(66.685,162.235),(66.835,162.235),(66.835,162.085),(66.685,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,162.085),(67.005,162.235),(67.155,162.235),(67.155,162.085),(67.005,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,162.405),(66.045,162.555),(66.195,162.555),(66.195,162.405),(66.045,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,162.405),(66.365,162.555),(66.515,162.555),(66.515,162.405),(66.365,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,162.405),(66.685,162.555),(66.835,162.555),(66.835,162.405),(66.685,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,162.405),(67.005,162.555),(67.155,162.555),(67.155,162.405),(67.005,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,162.725),(66.045,162.875),(66.195,162.875),(66.195,162.725),(66.045,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,162.725),(66.365,162.875),(66.515,162.875),(66.515,162.725),(66.365,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,162.725),(66.685,162.875),(66.835,162.875),(66.835,162.725),(66.685,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,162.725),(67.005,162.875),(67.155,162.875),(67.155,162.725),(67.005,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,163.045),(66.045,163.195),(66.195,163.195),(66.195,163.045),(66.045,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,163.045),(66.365,163.195),(66.515,163.195),(66.515,163.045),(66.365,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,163.045),(66.685,163.195),(66.835,163.195),(66.835,163.045),(66.685,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,163.045),(67.005,163.195),(67.155,163.195),(67.155,163.045),(67.005,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,163.365),(66.045,163.515),(66.195,163.515),(66.195,163.365),(66.045,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,163.365),(66.365,163.515),(66.515,163.515),(66.515,163.365),(66.365,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,163.365),(66.685,163.515),(66.835,163.515),(66.835,163.365),(66.685,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,163.365),(67.005,163.515),(67.155,163.515),(67.155,163.365),(67.005,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,163.685),(66.045,163.835),(66.195,163.835),(66.195,163.685),(66.045,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,163.685),(66.365,163.835),(66.515,163.835),(66.515,163.685),(66.365,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,163.685),(66.685,163.835),(66.835,163.835),(66.835,163.685),(66.685,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,163.685),(67.005,163.835),(67.155,163.835),(67.155,163.685),(67.005,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,164.005),(66.045,164.155),(66.195,164.155),(66.195,164.005),(66.045,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,164.005),(66.365,164.155),(66.515,164.155),(66.515,164.005),(66.365,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,164.005),(66.685,164.155),(66.835,164.155),(66.835,164.005),(66.685,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,164.005),(67.005,164.155),(67.155,164.155),(67.155,164.005),(67.005,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,164.325),(66.045,164.475),(66.195,164.475),(66.195,164.325),(66.045,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,164.325),(66.365,164.475),(66.515,164.475),(66.515,164.325),(66.365,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,164.325),(66.685,164.475),(66.835,164.475),(66.835,164.325),(66.685,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,164.325),(67.005,164.475),(67.155,164.475),(67.155,164.325),(67.005,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,164.645),(66.045,164.795),(66.195,164.795),(66.195,164.645),(66.045,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,164.645),(66.365,164.795),(66.515,164.795),(66.515,164.645),(66.365,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,164.645),(66.685,164.795),(66.835,164.795),(66.835,164.645),(66.685,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,164.645),(67.005,164.795),(67.155,164.795),(67.155,164.645),(67.005,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,164.965),(66.045,165.115),(66.195,165.115),(66.195,164.965),(66.045,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,164.965),(66.365,165.115),(66.515,165.115),(66.515,164.965),(66.365,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,164.965),(66.685,165.115),(66.835,165.115),(66.835,164.965),(66.685,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,164.965),(67.005,165.115),(67.155,165.115),(67.155,164.965),(67.005,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,165.285),(66.045,165.435),(66.195,165.435),(66.195,165.285),(66.045,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,165.285),(66.365,165.435),(66.515,165.435),(66.515,165.285),(66.365,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,165.285),(66.685,165.435),(66.835,165.435),(66.835,165.285),(66.685,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,165.285),(67.005,165.435),(67.155,165.435),(67.155,165.285),(67.005,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,165.605),(66.045,165.755),(66.195,165.755),(66.195,165.605),(66.045,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,165.605),(66.365,165.755),(66.515,165.755),(66.515,165.605),(66.365,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,165.605),(66.685,165.755),(66.835,165.755),(66.835,165.605),(66.685,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,165.605),(67.005,165.755),(67.155,165.755),(67.155,165.605),(67.005,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,165.925),(66.045,166.075),(66.195,166.075),(66.195,165.925),(66.045,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,165.925),(66.365,166.075),(66.515,166.075),(66.515,165.925),(66.365,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,165.925),(66.685,166.075),(66.835,166.075),(66.835,165.925),(66.685,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,165.925),(67.005,166.075),(67.155,166.075),(67.155,165.925),(67.005,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,166.245),(66.045,166.395),(66.195,166.395),(66.195,166.245),(66.045,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,166.245),(66.365,166.395),(66.515,166.395),(66.515,166.245),(66.365,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,166.245),(66.685,166.395),(66.835,166.395),(66.835,166.245),(66.685,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,166.245),(67.005,166.395),(67.155,166.395),(67.155,166.245),(67.005,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,166.565),(66.045,166.715),(66.195,166.715),(66.195,166.565),(66.045,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,166.565),(66.365,166.715),(66.515,166.715),(66.515,166.565),(66.365,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,166.565),(66.685,166.715),(66.835,166.715),(66.835,166.565),(66.685,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,166.565),(67.005,166.715),(67.155,166.715),(67.155,166.565),(67.005,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,166.885),(66.045,167.035),(66.195,167.035),(66.195,166.885),(66.045,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,166.885),(66.365,167.035),(66.515,167.035),(66.515,166.885),(66.365,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,166.885),(66.685,167.035),(66.835,167.035),(66.835,166.885),(66.685,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,166.885),(67.005,167.035),(67.155,167.035),(67.155,166.885),(67.005,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,167.205),(66.045,167.355),(66.195,167.355),(66.195,167.205),(66.045,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,167.205),(66.365,167.355),(66.515,167.355),(66.515,167.205),(66.365,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,167.205),(66.685,167.355),(66.835,167.355),(66.835,167.205),(66.685,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,167.205),(67.005,167.355),(67.155,167.355),(67.155,167.205),(67.005,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,167.525),(66.045,167.675),(66.195,167.675),(66.195,167.525),(66.045,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,167.525),(66.365,167.675),(66.515,167.675),(66.515,167.525),(66.365,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,167.525),(66.685,167.675),(66.835,167.675),(66.835,167.525),(66.685,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,167.525),(67.005,167.675),(67.155,167.675),(67.155,167.525),(67.005,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,167.845),(66.045,167.995),(66.195,167.995),(66.195,167.845),(66.045,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,167.845),(66.365,167.995),(66.515,167.995),(66.515,167.845),(66.365,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,167.845),(66.685,167.995),(66.835,167.995),(66.835,167.845),(66.685,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,167.845),(67.005,167.995),(67.155,167.995),(67.155,167.845),(67.005,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,168.165),(66.045,168.315),(66.195,168.315),(66.195,168.165),(66.045,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,168.165),(66.365,168.315),(66.515,168.315),(66.515,168.165),(66.365,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,168.165),(66.685,168.315),(66.835,168.315),(66.835,168.165),(66.685,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,168.165),(67.005,168.315),(67.155,168.315),(67.155,168.165),(67.005,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,168.485),(66.045,168.635),(66.195,168.635),(66.195,168.485),(66.045,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,168.485),(66.365,168.635),(66.515,168.635),(66.515,168.485),(66.365,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,168.485),(66.685,168.635),(66.835,168.635),(66.835,168.485),(66.685,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,168.485),(67.005,168.635),(67.155,168.635),(67.155,168.485),(67.005,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,168.805),(66.045,168.955),(66.195,168.955),(66.195,168.805),(66.045,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,168.805),(66.365,168.955),(66.515,168.955),(66.515,168.805),(66.365,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,168.805),(66.685,168.955),(66.835,168.955),(66.835,168.805),(66.685,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,168.805),(67.005,168.955),(67.155,168.955),(67.155,168.805),(67.005,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,169.125),(66.045,169.275),(66.195,169.275),(66.195,169.125),(66.045,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,169.125),(66.365,169.275),(66.515,169.275),(66.515,169.125),(66.365,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,169.125),(66.685,169.275),(66.835,169.275),(66.835,169.125),(66.685,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,169.125),(67.005,169.275),(67.155,169.275),(67.155,169.125),(67.005,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,169.445),(66.045,169.595),(66.195,169.595),(66.195,169.445),(66.045,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,169.445),(66.365,169.595),(66.515,169.595),(66.515,169.445),(66.365,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,169.445),(66.685,169.595),(66.835,169.595),(66.835,169.445),(66.685,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,169.445),(67.005,169.595),(67.155,169.595),(67.155,169.445),(67.005,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,169.765),(66.045,169.915),(66.195,169.915),(66.195,169.765),(66.045,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,169.765),(66.365,169.915),(66.515,169.915),(66.515,169.765),(66.365,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,169.765),(66.685,169.915),(66.835,169.915),(66.835,169.765),(66.685,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,169.765),(67.005,169.915),(67.155,169.915),(67.155,169.765),(67.005,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,170.085),(66.045,170.235),(66.195,170.235),(66.195,170.085),(66.045,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,170.085),(66.365,170.235),(66.515,170.235),(66.515,170.085),(66.365,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,170.085),(66.685,170.235),(66.835,170.235),(66.835,170.085),(66.685,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,170.085),(67.005,170.235),(67.155,170.235),(67.155,170.085),(67.005,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,170.405),(66.045,170.555),(66.195,170.555),(66.195,170.405),(66.045,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,170.405),(66.365,170.555),(66.515,170.555),(66.515,170.405),(66.365,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,170.405),(66.685,170.555),(66.835,170.555),(66.835,170.405),(66.685,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,170.405),(67.005,170.555),(67.155,170.555),(67.155,170.405),(67.005,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,170.725),(66.045,170.875),(66.195,170.875),(66.195,170.725),(66.045,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,170.725),(66.365,170.875),(66.515,170.875),(66.515,170.725),(66.365,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,170.725),(66.685,170.875),(66.835,170.875),(66.835,170.725),(66.685,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,170.725),(67.005,170.875),(67.155,170.875),(67.155,170.725),(67.005,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,171.045),(66.045,171.195),(66.195,171.195),(66.195,171.045),(66.045,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,171.045),(66.365,171.195),(66.515,171.195),(66.515,171.045),(66.365,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,171.045),(66.685,171.195),(66.835,171.195),(66.835,171.045),(66.685,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,171.045),(67.005,171.195),(67.155,171.195),(67.155,171.045),(67.005,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,171.365),(66.045,171.515),(66.195,171.515),(66.195,171.365),(66.045,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,171.365),(66.365,171.515),(66.515,171.515),(66.515,171.365),(66.365,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,171.365),(66.685,171.515),(66.835,171.515),(66.835,171.365),(66.685,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,171.365),(67.005,171.515),(67.155,171.515),(67.155,171.365),(67.005,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,171.685),(66.045,171.835),(66.195,171.835),(66.195,171.685),(66.045,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,171.685),(66.365,171.835),(66.515,171.835),(66.515,171.685),(66.365,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,171.685),(66.685,171.835),(66.835,171.835),(66.835,171.685),(66.685,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,171.685),(67.005,171.835),(67.155,171.835),(67.155,171.685),(67.005,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,172.005),(66.045,172.155),(66.195,172.155),(66.195,172.005),(66.045,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,172.005),(66.365,172.155),(66.515,172.155),(66.515,172.005),(66.365,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,172.005),(66.685,172.155),(66.835,172.155),(66.835,172.005),(66.685,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,172.005),(67.005,172.155),(67.155,172.155),(67.155,172.005),(67.005,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,158.245),(22.845,158.395),(22.995,158.395),(22.995,158.245),(22.845,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,158.245),(23.165,158.395),(23.315,158.395),(23.315,158.245),(23.165,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,158.245),(23.485,158.395),(23.635,158.395),(23.635,158.245),(23.485,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,158.245),(23.805,158.395),(23.955,158.395),(23.955,158.245),(23.805,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,158.565),(22.845,158.715),(22.995,158.715),(22.995,158.565),(22.845,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,158.565),(23.165,158.715),(23.315,158.715),(23.315,158.565),(23.165,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,158.565),(23.485,158.715),(23.635,158.715),(23.635,158.565),(23.485,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,158.565),(23.805,158.715),(23.955,158.715),(23.955,158.565),(23.805,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,158.885),(22.845,159.035),(22.995,159.035),(22.995,158.885),(22.845,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,158.885),(23.165,159.035),(23.315,159.035),(23.315,158.885),(23.165,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,158.885),(23.485,159.035),(23.635,159.035),(23.635,158.885),(23.485,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,158.885),(23.805,159.035),(23.955,159.035),(23.955,158.885),(23.805,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,159.205),(22.845,159.355),(22.995,159.355),(22.995,159.205),(22.845,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,159.205),(23.165,159.355),(23.315,159.355),(23.315,159.205),(23.165,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,159.205),(23.485,159.355),(23.635,159.355),(23.635,159.205),(23.485,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,159.205),(23.805,159.355),(23.955,159.355),(23.955,159.205),(23.805,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,159.525),(22.845,159.675),(22.995,159.675),(22.995,159.525),(22.845,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,159.525),(23.165,159.675),(23.315,159.675),(23.315,159.525),(23.165,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,159.525),(23.485,159.675),(23.635,159.675),(23.635,159.525),(23.485,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,159.525),(23.805,159.675),(23.955,159.675),(23.955,159.525),(23.805,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,159.845),(22.845,159.995),(22.995,159.995),(22.995,159.845),(22.845,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,159.845),(23.165,159.995),(23.315,159.995),(23.315,159.845),(23.165,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,159.845),(23.485,159.995),(23.635,159.995),(23.635,159.845),(23.485,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,159.845),(23.805,159.995),(23.955,159.995),(23.955,159.845),(23.805,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,160.165),(22.845,160.315),(22.995,160.315),(22.995,160.165),(22.845,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,160.165),(23.165,160.315),(23.315,160.315),(23.315,160.165),(23.165,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,160.165),(23.485,160.315),(23.635,160.315),(23.635,160.165),(23.485,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,160.165),(23.805,160.315),(23.955,160.315),(23.955,160.165),(23.805,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,160.485),(22.845,160.635),(22.995,160.635),(22.995,160.485),(22.845,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,160.485),(23.165,160.635),(23.315,160.635),(23.315,160.485),(23.165,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,160.485),(23.485,160.635),(23.635,160.635),(23.635,160.485),(23.485,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,160.485),(23.805,160.635),(23.955,160.635),(23.955,160.485),(23.805,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,160.805),(22.845,160.955),(22.995,160.955),(22.995,160.805),(22.845,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,160.805),(23.165,160.955),(23.315,160.955),(23.315,160.805),(23.165,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,160.805),(23.485,160.955),(23.635,160.955),(23.635,160.805),(23.485,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,160.805),(23.805,160.955),(23.955,160.955),(23.955,160.805),(23.805,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,161.125),(22.845,161.275),(22.995,161.275),(22.995,161.125),(22.845,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,161.125),(23.165,161.275),(23.315,161.275),(23.315,161.125),(23.165,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,161.125),(23.485,161.275),(23.635,161.275),(23.635,161.125),(23.485,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,161.125),(23.805,161.275),(23.955,161.275),(23.955,161.125),(23.805,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,161.445),(22.845,161.595),(22.995,161.595),(22.995,161.445),(22.845,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,161.445),(23.165,161.595),(23.315,161.595),(23.315,161.445),(23.165,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,161.445),(23.485,161.595),(23.635,161.595),(23.635,161.445),(23.485,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,161.445),(23.805,161.595),(23.955,161.595),(23.955,161.445),(23.805,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,161.765),(22.845,161.915),(22.995,161.915),(22.995,161.765),(22.845,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,161.765),(23.165,161.915),(23.315,161.915),(23.315,161.765),(23.165,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,161.765),(23.485,161.915),(23.635,161.915),(23.635,161.765),(23.485,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,161.765),(23.805,161.915),(23.955,161.915),(23.955,161.765),(23.805,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,162.085),(22.845,162.235),(22.995,162.235),(22.995,162.085),(22.845,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,162.085),(23.165,162.235),(23.315,162.235),(23.315,162.085),(23.165,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,162.085),(23.485,162.235),(23.635,162.235),(23.635,162.085),(23.485,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,162.085),(23.805,162.235),(23.955,162.235),(23.955,162.085),(23.805,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,162.405),(22.845,162.555),(22.995,162.555),(22.995,162.405),(22.845,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,162.405),(23.165,162.555),(23.315,162.555),(23.315,162.405),(23.165,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,162.405),(23.485,162.555),(23.635,162.555),(23.635,162.405),(23.485,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,162.405),(23.805,162.555),(23.955,162.555),(23.955,162.405),(23.805,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,162.725),(22.845,162.875),(22.995,162.875),(22.995,162.725),(22.845,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,162.725),(23.165,162.875),(23.315,162.875),(23.315,162.725),(23.165,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,162.725),(23.485,162.875),(23.635,162.875),(23.635,162.725),(23.485,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,162.725),(23.805,162.875),(23.955,162.875),(23.955,162.725),(23.805,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,163.045),(22.845,163.195),(22.995,163.195),(22.995,163.045),(22.845,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,163.045),(23.165,163.195),(23.315,163.195),(23.315,163.045),(23.165,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,163.045),(23.485,163.195),(23.635,163.195),(23.635,163.045),(23.485,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,163.045),(23.805,163.195),(23.955,163.195),(23.955,163.045),(23.805,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,163.365),(22.845,163.515),(22.995,163.515),(22.995,163.365),(22.845,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,163.365),(23.165,163.515),(23.315,163.515),(23.315,163.365),(23.165,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,163.365),(23.485,163.515),(23.635,163.515),(23.635,163.365),(23.485,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,163.365),(23.805,163.515),(23.955,163.515),(23.955,163.365),(23.805,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,163.685),(22.845,163.835),(22.995,163.835),(22.995,163.685),(22.845,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,163.685),(23.165,163.835),(23.315,163.835),(23.315,163.685),(23.165,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,163.685),(23.485,163.835),(23.635,163.835),(23.635,163.685),(23.485,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,163.685),(23.805,163.835),(23.955,163.835),(23.955,163.685),(23.805,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,164.005),(22.845,164.155),(22.995,164.155),(22.995,164.005),(22.845,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,164.005),(23.165,164.155),(23.315,164.155),(23.315,164.005),(23.165,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,164.005),(23.485,164.155),(23.635,164.155),(23.635,164.005),(23.485,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,164.005),(23.805,164.155),(23.955,164.155),(23.955,164.005),(23.805,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,164.325),(22.845,164.475),(22.995,164.475),(22.995,164.325),(22.845,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,164.325),(23.165,164.475),(23.315,164.475),(23.315,164.325),(23.165,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,164.325),(23.485,164.475),(23.635,164.475),(23.635,164.325),(23.485,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,164.325),(23.805,164.475),(23.955,164.475),(23.955,164.325),(23.805,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,164.645),(22.845,164.795),(22.995,164.795),(22.995,164.645),(22.845,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,164.645),(23.165,164.795),(23.315,164.795),(23.315,164.645),(23.165,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,164.645),(23.485,164.795),(23.635,164.795),(23.635,164.645),(23.485,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,164.645),(23.805,164.795),(23.955,164.795),(23.955,164.645),(23.805,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,164.965),(22.845,165.115),(22.995,165.115),(22.995,164.965),(22.845,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,164.965),(23.165,165.115),(23.315,165.115),(23.315,164.965),(23.165,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,164.965),(23.485,165.115),(23.635,165.115),(23.635,164.965),(23.485,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,164.965),(23.805,165.115),(23.955,165.115),(23.955,164.965),(23.805,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,165.285),(22.845,165.435),(22.995,165.435),(22.995,165.285),(22.845,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,165.285),(23.165,165.435),(23.315,165.435),(23.315,165.285),(23.165,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,165.285),(23.485,165.435),(23.635,165.435),(23.635,165.285),(23.485,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,165.285),(23.805,165.435),(23.955,165.435),(23.955,165.285),(23.805,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,165.605),(22.845,165.755),(22.995,165.755),(22.995,165.605),(22.845,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,165.605),(23.165,165.755),(23.315,165.755),(23.315,165.605),(23.165,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,165.605),(23.485,165.755),(23.635,165.755),(23.635,165.605),(23.485,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,165.605),(23.805,165.755),(23.955,165.755),(23.955,165.605),(23.805,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,165.925),(22.845,166.075),(22.995,166.075),(22.995,165.925),(22.845,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,165.925),(23.165,166.075),(23.315,166.075),(23.315,165.925),(23.165,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,165.925),(23.485,166.075),(23.635,166.075),(23.635,165.925),(23.485,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,165.925),(23.805,166.075),(23.955,166.075),(23.955,165.925),(23.805,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,166.245),(22.845,166.395),(22.995,166.395),(22.995,166.245),(22.845,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,166.245),(23.165,166.395),(23.315,166.395),(23.315,166.245),(23.165,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,166.245),(23.485,166.395),(23.635,166.395),(23.635,166.245),(23.485,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,166.245),(23.805,166.395),(23.955,166.395),(23.955,166.245),(23.805,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,166.565),(22.845,166.715),(22.995,166.715),(22.995,166.565),(22.845,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,166.565),(23.165,166.715),(23.315,166.715),(23.315,166.565),(23.165,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,166.565),(23.485,166.715),(23.635,166.715),(23.635,166.565),(23.485,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,166.565),(23.805,166.715),(23.955,166.715),(23.955,166.565),(23.805,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,166.885),(22.845,167.035),(22.995,167.035),(22.995,166.885),(22.845,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,166.885),(23.165,167.035),(23.315,167.035),(23.315,166.885),(23.165,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,166.885),(23.485,167.035),(23.635,167.035),(23.635,166.885),(23.485,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,166.885),(23.805,167.035),(23.955,167.035),(23.955,166.885),(23.805,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,167.205),(22.845,167.355),(22.995,167.355),(22.995,167.205),(22.845,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,167.205),(23.165,167.355),(23.315,167.355),(23.315,167.205),(23.165,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,167.205),(23.485,167.355),(23.635,167.355),(23.635,167.205),(23.485,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,167.205),(23.805,167.355),(23.955,167.355),(23.955,167.205),(23.805,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,167.525),(22.845,167.675),(22.995,167.675),(22.995,167.525),(22.845,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,167.525),(23.165,167.675),(23.315,167.675),(23.315,167.525),(23.165,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,167.525),(23.485,167.675),(23.635,167.675),(23.635,167.525),(23.485,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,167.525),(23.805,167.675),(23.955,167.675),(23.955,167.525),(23.805,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,167.845),(22.845,167.995),(22.995,167.995),(22.995,167.845),(22.845,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,167.845),(23.165,167.995),(23.315,167.995),(23.315,167.845),(23.165,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,167.845),(23.485,167.995),(23.635,167.995),(23.635,167.845),(23.485,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,167.845),(23.805,167.995),(23.955,167.995),(23.955,167.845),(23.805,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,168.165),(22.845,168.315),(22.995,168.315),(22.995,168.165),(22.845,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,168.165),(23.165,168.315),(23.315,168.315),(23.315,168.165),(23.165,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,168.165),(23.485,168.315),(23.635,168.315),(23.635,168.165),(23.485,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,168.165),(23.805,168.315),(23.955,168.315),(23.955,168.165),(23.805,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,168.485),(22.845,168.635),(22.995,168.635),(22.995,168.485),(22.845,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,168.485),(23.165,168.635),(23.315,168.635),(23.315,168.485),(23.165,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,168.485),(23.485,168.635),(23.635,168.635),(23.635,168.485),(23.485,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,168.485),(23.805,168.635),(23.955,168.635),(23.955,168.485),(23.805,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,168.805),(22.845,168.955),(22.995,168.955),(22.995,168.805),(22.845,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,168.805),(23.165,168.955),(23.315,168.955),(23.315,168.805),(23.165,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,168.805),(23.485,168.955),(23.635,168.955),(23.635,168.805),(23.485,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,168.805),(23.805,168.955),(23.955,168.955),(23.955,168.805),(23.805,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,169.125),(22.845,169.275),(22.995,169.275),(22.995,169.125),(22.845,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,169.125),(23.165,169.275),(23.315,169.275),(23.315,169.125),(23.165,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,169.125),(23.485,169.275),(23.635,169.275),(23.635,169.125),(23.485,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,169.125),(23.805,169.275),(23.955,169.275),(23.955,169.125),(23.805,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,169.445),(22.845,169.595),(22.995,169.595),(22.995,169.445),(22.845,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,169.445),(23.165,169.595),(23.315,169.595),(23.315,169.445),(23.165,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,169.445),(23.485,169.595),(23.635,169.595),(23.635,169.445),(23.485,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,169.445),(23.805,169.595),(23.955,169.595),(23.955,169.445),(23.805,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,169.765),(22.845,169.915),(22.995,169.915),(22.995,169.765),(22.845,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,169.765),(23.165,169.915),(23.315,169.915),(23.315,169.765),(23.165,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,169.765),(23.485,169.915),(23.635,169.915),(23.635,169.765),(23.485,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,169.765),(23.805,169.915),(23.955,169.915),(23.955,169.765),(23.805,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,170.085),(22.845,170.235),(22.995,170.235),(22.995,170.085),(22.845,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,170.085),(23.165,170.235),(23.315,170.235),(23.315,170.085),(23.165,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,170.085),(23.485,170.235),(23.635,170.235),(23.635,170.085),(23.485,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,170.085),(23.805,170.235),(23.955,170.235),(23.955,170.085),(23.805,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,170.405),(22.845,170.555),(22.995,170.555),(22.995,170.405),(22.845,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,170.405),(23.165,170.555),(23.315,170.555),(23.315,170.405),(23.165,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,170.405),(23.485,170.555),(23.635,170.555),(23.635,170.405),(23.485,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,170.405),(23.805,170.555),(23.955,170.555),(23.955,170.405),(23.805,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,170.725),(22.845,170.875),(22.995,170.875),(22.995,170.725),(22.845,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,170.725),(23.165,170.875),(23.315,170.875),(23.315,170.725),(23.165,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,170.725),(23.485,170.875),(23.635,170.875),(23.635,170.725),(23.485,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,170.725),(23.805,170.875),(23.955,170.875),(23.955,170.725),(23.805,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,171.045),(22.845,171.195),(22.995,171.195),(22.995,171.045),(22.845,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,171.045),(23.165,171.195),(23.315,171.195),(23.315,171.045),(23.165,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,171.045),(23.485,171.195),(23.635,171.195),(23.635,171.045),(23.485,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,171.045),(23.805,171.195),(23.955,171.195),(23.955,171.045),(23.805,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,171.365),(22.845,171.515),(22.995,171.515),(22.995,171.365),(22.845,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,171.365),(23.165,171.515),(23.315,171.515),(23.315,171.365),(23.165,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,171.365),(23.485,171.515),(23.635,171.515),(23.635,171.365),(23.485,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,171.365),(23.805,171.515),(23.955,171.515),(23.955,171.365),(23.805,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,171.685),(22.845,171.835),(22.995,171.835),(22.995,171.685),(22.845,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,171.685),(23.165,171.835),(23.315,171.835),(23.315,171.685),(23.165,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,171.685),(23.485,171.835),(23.635,171.835),(23.635,171.685),(23.485,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,171.685),(23.805,171.835),(23.955,171.835),(23.955,171.685),(23.805,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,172.005),(22.845,172.155),(22.995,172.155),(22.995,172.005),(22.845,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,172.005),(23.165,172.155),(23.315,172.155),(23.315,172.005),(23.165,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,172.005),(23.485,172.155),(23.635,172.155),(23.635,172.005),(23.485,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,172.005),(23.805,172.155),(23.955,172.155),(23.955,172.005),(23.805,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,158.245),(80.445,158.395),(80.595,158.395),(80.595,158.245),(80.445,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,158.245),(80.765,158.395),(80.915,158.395),(80.915,158.245),(80.765,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,158.245),(81.085,158.395),(81.235,158.395),(81.235,158.245),(81.085,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,158.245),(81.405,158.395),(81.555,158.395),(81.555,158.245),(81.405,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,158.565),(80.445,158.715),(80.595,158.715),(80.595,158.565),(80.445,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,158.565),(80.765,158.715),(80.915,158.715),(80.915,158.565),(80.765,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,158.565),(81.085,158.715),(81.235,158.715),(81.235,158.565),(81.085,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,158.565),(81.405,158.715),(81.555,158.715),(81.555,158.565),(81.405,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,158.885),(80.445,159.035),(80.595,159.035),(80.595,158.885),(80.445,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,158.885),(80.765,159.035),(80.915,159.035),(80.915,158.885),(80.765,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,158.885),(81.085,159.035),(81.235,159.035),(81.235,158.885),(81.085,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,158.885),(81.405,159.035),(81.555,159.035),(81.555,158.885),(81.405,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,159.205),(80.445,159.355),(80.595,159.355),(80.595,159.205),(80.445,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,159.205),(80.765,159.355),(80.915,159.355),(80.915,159.205),(80.765,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,159.205),(81.085,159.355),(81.235,159.355),(81.235,159.205),(81.085,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,159.205),(81.405,159.355),(81.555,159.355),(81.555,159.205),(81.405,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,159.525),(80.445,159.675),(80.595,159.675),(80.595,159.525),(80.445,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,159.525),(80.765,159.675),(80.915,159.675),(80.915,159.525),(80.765,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,159.525),(81.085,159.675),(81.235,159.675),(81.235,159.525),(81.085,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,159.525),(81.405,159.675),(81.555,159.675),(81.555,159.525),(81.405,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,159.845),(80.445,159.995),(80.595,159.995),(80.595,159.845),(80.445,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,159.845),(80.765,159.995),(80.915,159.995),(80.915,159.845),(80.765,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,159.845),(81.085,159.995),(81.235,159.995),(81.235,159.845),(81.085,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,159.845),(81.405,159.995),(81.555,159.995),(81.555,159.845),(81.405,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,160.165),(80.445,160.315),(80.595,160.315),(80.595,160.165),(80.445,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,160.165),(80.765,160.315),(80.915,160.315),(80.915,160.165),(80.765,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,160.165),(81.085,160.315),(81.235,160.315),(81.235,160.165),(81.085,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,160.165),(81.405,160.315),(81.555,160.315),(81.555,160.165),(81.405,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,160.485),(80.445,160.635),(80.595,160.635),(80.595,160.485),(80.445,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,160.485),(80.765,160.635),(80.915,160.635),(80.915,160.485),(80.765,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,160.485),(81.085,160.635),(81.235,160.635),(81.235,160.485),(81.085,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,160.485),(81.405,160.635),(81.555,160.635),(81.555,160.485),(81.405,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,160.805),(80.445,160.955),(80.595,160.955),(80.595,160.805),(80.445,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,160.805),(80.765,160.955),(80.915,160.955),(80.915,160.805),(80.765,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,160.805),(81.085,160.955),(81.235,160.955),(81.235,160.805),(81.085,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,160.805),(81.405,160.955),(81.555,160.955),(81.555,160.805),(81.405,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,161.125),(80.445,161.275),(80.595,161.275),(80.595,161.125),(80.445,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,161.125),(80.765,161.275),(80.915,161.275),(80.915,161.125),(80.765,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,161.125),(81.085,161.275),(81.235,161.275),(81.235,161.125),(81.085,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,161.125),(81.405,161.275),(81.555,161.275),(81.555,161.125),(81.405,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,161.445),(80.445,161.595),(80.595,161.595),(80.595,161.445),(80.445,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,161.445),(80.765,161.595),(80.915,161.595),(80.915,161.445),(80.765,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,161.445),(81.085,161.595),(81.235,161.595),(81.235,161.445),(81.085,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,161.445),(81.405,161.595),(81.555,161.595),(81.555,161.445),(81.405,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,161.765),(80.445,161.915),(80.595,161.915),(80.595,161.765),(80.445,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,161.765),(80.765,161.915),(80.915,161.915),(80.915,161.765),(80.765,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,161.765),(81.085,161.915),(81.235,161.915),(81.235,161.765),(81.085,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,161.765),(81.405,161.915),(81.555,161.915),(81.555,161.765),(81.405,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,162.085),(80.445,162.235),(80.595,162.235),(80.595,162.085),(80.445,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,162.085),(80.765,162.235),(80.915,162.235),(80.915,162.085),(80.765,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,162.085),(81.085,162.235),(81.235,162.235),(81.235,162.085),(81.085,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,162.085),(81.405,162.235),(81.555,162.235),(81.555,162.085),(81.405,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,162.405),(80.445,162.555),(80.595,162.555),(80.595,162.405),(80.445,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,162.405),(80.765,162.555),(80.915,162.555),(80.915,162.405),(80.765,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,162.405),(81.085,162.555),(81.235,162.555),(81.235,162.405),(81.085,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,162.405),(81.405,162.555),(81.555,162.555),(81.555,162.405),(81.405,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,162.725),(80.445,162.875),(80.595,162.875),(80.595,162.725),(80.445,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,162.725),(80.765,162.875),(80.915,162.875),(80.915,162.725),(80.765,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,162.725),(81.085,162.875),(81.235,162.875),(81.235,162.725),(81.085,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,162.725),(81.405,162.875),(81.555,162.875),(81.555,162.725),(81.405,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,163.045),(80.445,163.195),(80.595,163.195),(80.595,163.045),(80.445,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,163.045),(80.765,163.195),(80.915,163.195),(80.915,163.045),(80.765,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,163.045),(81.085,163.195),(81.235,163.195),(81.235,163.045),(81.085,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,163.045),(81.405,163.195),(81.555,163.195),(81.555,163.045),(81.405,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,163.365),(80.445,163.515),(80.595,163.515),(80.595,163.365),(80.445,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,163.365),(80.765,163.515),(80.915,163.515),(80.915,163.365),(80.765,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,163.365),(81.085,163.515),(81.235,163.515),(81.235,163.365),(81.085,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,163.365),(81.405,163.515),(81.555,163.515),(81.555,163.365),(81.405,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,163.685),(80.445,163.835),(80.595,163.835),(80.595,163.685),(80.445,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,163.685),(80.765,163.835),(80.915,163.835),(80.915,163.685),(80.765,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,163.685),(81.085,163.835),(81.235,163.835),(81.235,163.685),(81.085,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,163.685),(81.405,163.835),(81.555,163.835),(81.555,163.685),(81.405,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,164.005),(80.445,164.155),(80.595,164.155),(80.595,164.005),(80.445,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,164.005),(80.765,164.155),(80.915,164.155),(80.915,164.005),(80.765,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,164.005),(81.085,164.155),(81.235,164.155),(81.235,164.005),(81.085,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,164.005),(81.405,164.155),(81.555,164.155),(81.555,164.005),(81.405,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,164.325),(80.445,164.475),(80.595,164.475),(80.595,164.325),(80.445,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,164.325),(80.765,164.475),(80.915,164.475),(80.915,164.325),(80.765,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,164.325),(81.085,164.475),(81.235,164.475),(81.235,164.325),(81.085,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,164.325),(81.405,164.475),(81.555,164.475),(81.555,164.325),(81.405,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,164.645),(80.445,164.795),(80.595,164.795),(80.595,164.645),(80.445,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,164.645),(80.765,164.795),(80.915,164.795),(80.915,164.645),(80.765,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,164.645),(81.085,164.795),(81.235,164.795),(81.235,164.645),(81.085,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,164.645),(81.405,164.795),(81.555,164.795),(81.555,164.645),(81.405,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,164.965),(80.445,165.115),(80.595,165.115),(80.595,164.965),(80.445,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,164.965),(80.765,165.115),(80.915,165.115),(80.915,164.965),(80.765,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,164.965),(81.085,165.115),(81.235,165.115),(81.235,164.965),(81.085,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,164.965),(81.405,165.115),(81.555,165.115),(81.555,164.965),(81.405,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,165.285),(80.445,165.435),(80.595,165.435),(80.595,165.285),(80.445,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,165.285),(80.765,165.435),(80.915,165.435),(80.915,165.285),(80.765,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,165.285),(81.085,165.435),(81.235,165.435),(81.235,165.285),(81.085,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,165.285),(81.405,165.435),(81.555,165.435),(81.555,165.285),(81.405,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,165.605),(80.445,165.755),(80.595,165.755),(80.595,165.605),(80.445,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,165.605),(80.765,165.755),(80.915,165.755),(80.915,165.605),(80.765,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,165.605),(81.085,165.755),(81.235,165.755),(81.235,165.605),(81.085,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,165.605),(81.405,165.755),(81.555,165.755),(81.555,165.605),(81.405,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,165.925),(80.445,166.075),(80.595,166.075),(80.595,165.925),(80.445,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,165.925),(80.765,166.075),(80.915,166.075),(80.915,165.925),(80.765,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,165.925),(81.085,166.075),(81.235,166.075),(81.235,165.925),(81.085,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,165.925),(81.405,166.075),(81.555,166.075),(81.555,165.925),(81.405,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,166.245),(80.445,166.395),(80.595,166.395),(80.595,166.245),(80.445,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,166.245),(80.765,166.395),(80.915,166.395),(80.915,166.245),(80.765,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,166.245),(81.085,166.395),(81.235,166.395),(81.235,166.245),(81.085,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,166.245),(81.405,166.395),(81.555,166.395),(81.555,166.245),(81.405,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,166.565),(80.445,166.715),(80.595,166.715),(80.595,166.565),(80.445,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,166.565),(80.765,166.715),(80.915,166.715),(80.915,166.565),(80.765,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,166.565),(81.085,166.715),(81.235,166.715),(81.235,166.565),(81.085,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,166.565),(81.405,166.715),(81.555,166.715),(81.555,166.565),(81.405,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,166.885),(80.445,167.035),(80.595,167.035),(80.595,166.885),(80.445,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,166.885),(80.765,167.035),(80.915,167.035),(80.915,166.885),(80.765,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,166.885),(81.085,167.035),(81.235,167.035),(81.235,166.885),(81.085,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,166.885),(81.405,167.035),(81.555,167.035),(81.555,166.885),(81.405,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,167.205),(80.445,167.355),(80.595,167.355),(80.595,167.205),(80.445,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,167.205),(80.765,167.355),(80.915,167.355),(80.915,167.205),(80.765,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,167.205),(81.085,167.355),(81.235,167.355),(81.235,167.205),(81.085,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,167.205),(81.405,167.355),(81.555,167.355),(81.555,167.205),(81.405,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,167.525),(80.445,167.675),(80.595,167.675),(80.595,167.525),(80.445,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,167.525),(80.765,167.675),(80.915,167.675),(80.915,167.525),(80.765,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,167.525),(81.085,167.675),(81.235,167.675),(81.235,167.525),(81.085,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,167.525),(81.405,167.675),(81.555,167.675),(81.555,167.525),(81.405,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,167.845),(80.445,167.995),(80.595,167.995),(80.595,167.845),(80.445,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,167.845),(80.765,167.995),(80.915,167.995),(80.915,167.845),(80.765,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,167.845),(81.085,167.995),(81.235,167.995),(81.235,167.845),(81.085,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,167.845),(81.405,167.995),(81.555,167.995),(81.555,167.845),(81.405,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,168.165),(80.445,168.315),(80.595,168.315),(80.595,168.165),(80.445,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,168.165),(80.765,168.315),(80.915,168.315),(80.915,168.165),(80.765,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,168.165),(81.085,168.315),(81.235,168.315),(81.235,168.165),(81.085,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,168.165),(81.405,168.315),(81.555,168.315),(81.555,168.165),(81.405,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,168.485),(80.445,168.635),(80.595,168.635),(80.595,168.485),(80.445,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,168.485),(80.765,168.635),(80.915,168.635),(80.915,168.485),(80.765,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,168.485),(81.085,168.635),(81.235,168.635),(81.235,168.485),(81.085,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,168.485),(81.405,168.635),(81.555,168.635),(81.555,168.485),(81.405,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,168.805),(80.445,168.955),(80.595,168.955),(80.595,168.805),(80.445,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,168.805),(80.765,168.955),(80.915,168.955),(80.915,168.805),(80.765,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,168.805),(81.085,168.955),(81.235,168.955),(81.235,168.805),(81.085,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,168.805),(81.405,168.955),(81.555,168.955),(81.555,168.805),(81.405,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,169.125),(80.445,169.275),(80.595,169.275),(80.595,169.125),(80.445,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,169.125),(80.765,169.275),(80.915,169.275),(80.915,169.125),(80.765,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,169.125),(81.085,169.275),(81.235,169.275),(81.235,169.125),(81.085,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,169.125),(81.405,169.275),(81.555,169.275),(81.555,169.125),(81.405,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,169.445),(80.445,169.595),(80.595,169.595),(80.595,169.445),(80.445,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,169.445),(80.765,169.595),(80.915,169.595),(80.915,169.445),(80.765,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,169.445),(81.085,169.595),(81.235,169.595),(81.235,169.445),(81.085,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,169.445),(81.405,169.595),(81.555,169.595),(81.555,169.445),(81.405,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,169.765),(80.445,169.915),(80.595,169.915),(80.595,169.765),(80.445,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,169.765),(80.765,169.915),(80.915,169.915),(80.915,169.765),(80.765,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,169.765),(81.085,169.915),(81.235,169.915),(81.235,169.765),(81.085,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,169.765),(81.405,169.915),(81.555,169.915),(81.555,169.765),(81.405,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,170.085),(80.445,170.235),(80.595,170.235),(80.595,170.085),(80.445,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,170.085),(80.765,170.235),(80.915,170.235),(80.915,170.085),(80.765,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,170.085),(81.085,170.235),(81.235,170.235),(81.235,170.085),(81.085,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,170.085),(81.405,170.235),(81.555,170.235),(81.555,170.085),(81.405,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,170.405),(80.445,170.555),(80.595,170.555),(80.595,170.405),(80.445,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,170.405),(80.765,170.555),(80.915,170.555),(80.915,170.405),(80.765,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,170.405),(81.085,170.555),(81.235,170.555),(81.235,170.405),(81.085,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,170.405),(81.405,170.555),(81.555,170.555),(81.555,170.405),(81.405,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,170.725),(80.445,170.875),(80.595,170.875),(80.595,170.725),(80.445,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,170.725),(80.765,170.875),(80.915,170.875),(80.915,170.725),(80.765,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,170.725),(81.085,170.875),(81.235,170.875),(81.235,170.725),(81.085,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,170.725),(81.405,170.875),(81.555,170.875),(81.555,170.725),(81.405,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,171.045),(80.445,171.195),(80.595,171.195),(80.595,171.045),(80.445,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,171.045),(80.765,171.195),(80.915,171.195),(80.915,171.045),(80.765,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,171.045),(81.085,171.195),(81.235,171.195),(81.235,171.045),(81.085,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,171.045),(81.405,171.195),(81.555,171.195),(81.555,171.045),(81.405,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,171.365),(80.445,171.515),(80.595,171.515),(80.595,171.365),(80.445,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,171.365),(80.765,171.515),(80.915,171.515),(80.915,171.365),(80.765,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,171.365),(81.085,171.515),(81.235,171.515),(81.235,171.365),(81.085,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,171.365),(81.405,171.515),(81.555,171.515),(81.555,171.365),(81.405,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,171.685),(80.445,171.835),(80.595,171.835),(80.595,171.685),(80.445,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,171.685),(80.765,171.835),(80.915,171.835),(80.915,171.685),(80.765,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,171.685),(81.085,171.835),(81.235,171.835),(81.235,171.685),(81.085,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,171.685),(81.405,171.835),(81.555,171.835),(81.555,171.685),(81.405,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,172.005),(80.445,172.155),(80.595,172.155),(80.595,172.005),(80.445,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,172.005),(80.765,172.155),(80.915,172.155),(80.915,172.005),(80.765,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,172.005),(81.085,172.155),(81.235,172.155),(81.235,172.005),(81.085,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,172.005),(81.405,172.155),(81.555,172.155),(81.555,172.005),(81.405,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,158.245),(32.445,158.395),(32.595,158.395),(32.595,158.245),(32.445,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,158.245),(32.765,158.395),(32.915,158.395),(32.915,158.245),(32.765,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,158.245),(33.085,158.395),(33.235,158.395),(33.235,158.245),(33.085,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,158.245),(33.405,158.395),(33.555,158.395),(33.555,158.245),(33.405,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,158.565),(32.445,158.715),(32.595,158.715),(32.595,158.565),(32.445,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,158.565),(32.765,158.715),(32.915,158.715),(32.915,158.565),(32.765,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,158.565),(33.085,158.715),(33.235,158.715),(33.235,158.565),(33.085,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,158.565),(33.405,158.715),(33.555,158.715),(33.555,158.565),(33.405,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,158.885),(32.445,159.035),(32.595,159.035),(32.595,158.885),(32.445,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,158.885),(32.765,159.035),(32.915,159.035),(32.915,158.885),(32.765,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,158.885),(33.085,159.035),(33.235,159.035),(33.235,158.885),(33.085,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,158.885),(33.405,159.035),(33.555,159.035),(33.555,158.885),(33.405,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,159.205),(32.445,159.355),(32.595,159.355),(32.595,159.205),(32.445,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,159.205),(32.765,159.355),(32.915,159.355),(32.915,159.205),(32.765,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,159.205),(33.085,159.355),(33.235,159.355),(33.235,159.205),(33.085,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,159.205),(33.405,159.355),(33.555,159.355),(33.555,159.205),(33.405,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,159.525),(32.445,159.675),(32.595,159.675),(32.595,159.525),(32.445,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,159.525),(32.765,159.675),(32.915,159.675),(32.915,159.525),(32.765,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,159.525),(33.085,159.675),(33.235,159.675),(33.235,159.525),(33.085,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,159.525),(33.405,159.675),(33.555,159.675),(33.555,159.525),(33.405,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,159.845),(32.445,159.995),(32.595,159.995),(32.595,159.845),(32.445,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,159.845),(32.765,159.995),(32.915,159.995),(32.915,159.845),(32.765,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,159.845),(33.085,159.995),(33.235,159.995),(33.235,159.845),(33.085,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,159.845),(33.405,159.995),(33.555,159.995),(33.555,159.845),(33.405,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,160.165),(32.445,160.315),(32.595,160.315),(32.595,160.165),(32.445,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,160.165),(32.765,160.315),(32.915,160.315),(32.915,160.165),(32.765,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,160.165),(33.085,160.315),(33.235,160.315),(33.235,160.165),(33.085,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,160.165),(33.405,160.315),(33.555,160.315),(33.555,160.165),(33.405,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,160.485),(32.445,160.635),(32.595,160.635),(32.595,160.485),(32.445,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,160.485),(32.765,160.635),(32.915,160.635),(32.915,160.485),(32.765,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,160.485),(33.085,160.635),(33.235,160.635),(33.235,160.485),(33.085,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,160.485),(33.405,160.635),(33.555,160.635),(33.555,160.485),(33.405,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,160.805),(32.445,160.955),(32.595,160.955),(32.595,160.805),(32.445,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,160.805),(32.765,160.955),(32.915,160.955),(32.915,160.805),(32.765,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,160.805),(33.085,160.955),(33.235,160.955),(33.235,160.805),(33.085,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,160.805),(33.405,160.955),(33.555,160.955),(33.555,160.805),(33.405,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,161.125),(32.445,161.275),(32.595,161.275),(32.595,161.125),(32.445,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,161.125),(32.765,161.275),(32.915,161.275),(32.915,161.125),(32.765,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,161.125),(33.085,161.275),(33.235,161.275),(33.235,161.125),(33.085,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,161.125),(33.405,161.275),(33.555,161.275),(33.555,161.125),(33.405,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,161.445),(32.445,161.595),(32.595,161.595),(32.595,161.445),(32.445,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,161.445),(32.765,161.595),(32.915,161.595),(32.915,161.445),(32.765,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,161.445),(33.085,161.595),(33.235,161.595),(33.235,161.445),(33.085,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,161.445),(33.405,161.595),(33.555,161.595),(33.555,161.445),(33.405,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,161.765),(32.445,161.915),(32.595,161.915),(32.595,161.765),(32.445,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,161.765),(32.765,161.915),(32.915,161.915),(32.915,161.765),(32.765,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,161.765),(33.085,161.915),(33.235,161.915),(33.235,161.765),(33.085,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,161.765),(33.405,161.915),(33.555,161.915),(33.555,161.765),(33.405,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,162.085),(32.445,162.235),(32.595,162.235),(32.595,162.085),(32.445,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,162.085),(32.765,162.235),(32.915,162.235),(32.915,162.085),(32.765,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,162.085),(33.085,162.235),(33.235,162.235),(33.235,162.085),(33.085,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,162.085),(33.405,162.235),(33.555,162.235),(33.555,162.085),(33.405,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,162.405),(32.445,162.555),(32.595,162.555),(32.595,162.405),(32.445,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,162.405),(32.765,162.555),(32.915,162.555),(32.915,162.405),(32.765,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,162.405),(33.085,162.555),(33.235,162.555),(33.235,162.405),(33.085,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,162.405),(33.405,162.555),(33.555,162.555),(33.555,162.405),(33.405,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,162.725),(32.445,162.875),(32.595,162.875),(32.595,162.725),(32.445,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,162.725),(32.765,162.875),(32.915,162.875),(32.915,162.725),(32.765,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,162.725),(33.085,162.875),(33.235,162.875),(33.235,162.725),(33.085,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,162.725),(33.405,162.875),(33.555,162.875),(33.555,162.725),(33.405,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,163.045),(32.445,163.195),(32.595,163.195),(32.595,163.045),(32.445,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,163.045),(32.765,163.195),(32.915,163.195),(32.915,163.045),(32.765,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,163.045),(33.085,163.195),(33.235,163.195),(33.235,163.045),(33.085,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,163.045),(33.405,163.195),(33.555,163.195),(33.555,163.045),(33.405,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,163.365),(32.445,163.515),(32.595,163.515),(32.595,163.365),(32.445,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,163.365),(32.765,163.515),(32.915,163.515),(32.915,163.365),(32.765,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,163.365),(33.085,163.515),(33.235,163.515),(33.235,163.365),(33.085,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,163.365),(33.405,163.515),(33.555,163.515),(33.555,163.365),(33.405,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,163.685),(32.445,163.835),(32.595,163.835),(32.595,163.685),(32.445,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,163.685),(32.765,163.835),(32.915,163.835),(32.915,163.685),(32.765,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,163.685),(33.085,163.835),(33.235,163.835),(33.235,163.685),(33.085,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,163.685),(33.405,163.835),(33.555,163.835),(33.555,163.685),(33.405,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,164.005),(32.445,164.155),(32.595,164.155),(32.595,164.005),(32.445,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,164.005),(32.765,164.155),(32.915,164.155),(32.915,164.005),(32.765,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,164.005),(33.085,164.155),(33.235,164.155),(33.235,164.005),(33.085,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,164.005),(33.405,164.155),(33.555,164.155),(33.555,164.005),(33.405,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,164.325),(32.445,164.475),(32.595,164.475),(32.595,164.325),(32.445,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,164.325),(32.765,164.475),(32.915,164.475),(32.915,164.325),(32.765,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,164.325),(33.085,164.475),(33.235,164.475),(33.235,164.325),(33.085,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,164.325),(33.405,164.475),(33.555,164.475),(33.555,164.325),(33.405,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,164.645),(32.445,164.795),(32.595,164.795),(32.595,164.645),(32.445,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,164.645),(32.765,164.795),(32.915,164.795),(32.915,164.645),(32.765,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,164.645),(33.085,164.795),(33.235,164.795),(33.235,164.645),(33.085,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,164.645),(33.405,164.795),(33.555,164.795),(33.555,164.645),(33.405,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,164.965),(32.445,165.115),(32.595,165.115),(32.595,164.965),(32.445,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,164.965),(32.765,165.115),(32.915,165.115),(32.915,164.965),(32.765,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,164.965),(33.085,165.115),(33.235,165.115),(33.235,164.965),(33.085,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,164.965),(33.405,165.115),(33.555,165.115),(33.555,164.965),(33.405,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,165.285),(32.445,165.435),(32.595,165.435),(32.595,165.285),(32.445,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,165.285),(32.765,165.435),(32.915,165.435),(32.915,165.285),(32.765,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,165.285),(33.085,165.435),(33.235,165.435),(33.235,165.285),(33.085,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,165.285),(33.405,165.435),(33.555,165.435),(33.555,165.285),(33.405,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,165.605),(32.445,165.755),(32.595,165.755),(32.595,165.605),(32.445,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,165.605),(32.765,165.755),(32.915,165.755),(32.915,165.605),(32.765,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,165.605),(33.085,165.755),(33.235,165.755),(33.235,165.605),(33.085,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,165.605),(33.405,165.755),(33.555,165.755),(33.555,165.605),(33.405,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,165.925),(32.445,166.075),(32.595,166.075),(32.595,165.925),(32.445,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,165.925),(32.765,166.075),(32.915,166.075),(32.915,165.925),(32.765,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,165.925),(33.085,166.075),(33.235,166.075),(33.235,165.925),(33.085,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,165.925),(33.405,166.075),(33.555,166.075),(33.555,165.925),(33.405,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,166.245),(32.445,166.395),(32.595,166.395),(32.595,166.245),(32.445,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,166.245),(32.765,166.395),(32.915,166.395),(32.915,166.245),(32.765,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,166.245),(33.085,166.395),(33.235,166.395),(33.235,166.245),(33.085,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,166.245),(33.405,166.395),(33.555,166.395),(33.555,166.245),(33.405,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,166.565),(32.445,166.715),(32.595,166.715),(32.595,166.565),(32.445,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,166.565),(32.765,166.715),(32.915,166.715),(32.915,166.565),(32.765,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,166.565),(33.085,166.715),(33.235,166.715),(33.235,166.565),(33.085,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,166.565),(33.405,166.715),(33.555,166.715),(33.555,166.565),(33.405,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,166.885),(32.445,167.035),(32.595,167.035),(32.595,166.885),(32.445,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,166.885),(32.765,167.035),(32.915,167.035),(32.915,166.885),(32.765,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,166.885),(33.085,167.035),(33.235,167.035),(33.235,166.885),(33.085,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,166.885),(33.405,167.035),(33.555,167.035),(33.555,166.885),(33.405,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,167.205),(32.445,167.355),(32.595,167.355),(32.595,167.205),(32.445,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,167.205),(32.765,167.355),(32.915,167.355),(32.915,167.205),(32.765,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,167.205),(33.085,167.355),(33.235,167.355),(33.235,167.205),(33.085,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,167.205),(33.405,167.355),(33.555,167.355),(33.555,167.205),(33.405,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,167.525),(32.445,167.675),(32.595,167.675),(32.595,167.525),(32.445,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,167.525),(32.765,167.675),(32.915,167.675),(32.915,167.525),(32.765,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,167.525),(33.085,167.675),(33.235,167.675),(33.235,167.525),(33.085,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,167.525),(33.405,167.675),(33.555,167.675),(33.555,167.525),(33.405,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,167.845),(32.445,167.995),(32.595,167.995),(32.595,167.845),(32.445,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,167.845),(32.765,167.995),(32.915,167.995),(32.915,167.845),(32.765,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,167.845),(33.085,167.995),(33.235,167.995),(33.235,167.845),(33.085,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,167.845),(33.405,167.995),(33.555,167.995),(33.555,167.845),(33.405,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,168.165),(32.445,168.315),(32.595,168.315),(32.595,168.165),(32.445,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,168.165),(32.765,168.315),(32.915,168.315),(32.915,168.165),(32.765,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,168.165),(33.085,168.315),(33.235,168.315),(33.235,168.165),(33.085,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,168.165),(33.405,168.315),(33.555,168.315),(33.555,168.165),(33.405,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,168.485),(32.445,168.635),(32.595,168.635),(32.595,168.485),(32.445,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,168.485),(32.765,168.635),(32.915,168.635),(32.915,168.485),(32.765,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,168.485),(33.085,168.635),(33.235,168.635),(33.235,168.485),(33.085,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,168.485),(33.405,168.635),(33.555,168.635),(33.555,168.485),(33.405,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,168.805),(32.445,168.955),(32.595,168.955),(32.595,168.805),(32.445,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,168.805),(32.765,168.955),(32.915,168.955),(32.915,168.805),(32.765,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,168.805),(33.085,168.955),(33.235,168.955),(33.235,168.805),(33.085,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,168.805),(33.405,168.955),(33.555,168.955),(33.555,168.805),(33.405,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,169.125),(32.445,169.275),(32.595,169.275),(32.595,169.125),(32.445,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,169.125),(32.765,169.275),(32.915,169.275),(32.915,169.125),(32.765,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,169.125),(33.085,169.275),(33.235,169.275),(33.235,169.125),(33.085,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,169.125),(33.405,169.275),(33.555,169.275),(33.555,169.125),(33.405,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,169.445),(32.445,169.595),(32.595,169.595),(32.595,169.445),(32.445,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,169.445),(32.765,169.595),(32.915,169.595),(32.915,169.445),(32.765,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,169.445),(33.085,169.595),(33.235,169.595),(33.235,169.445),(33.085,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,169.445),(33.405,169.595),(33.555,169.595),(33.555,169.445),(33.405,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,169.765),(32.445,169.915),(32.595,169.915),(32.595,169.765),(32.445,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,169.765),(32.765,169.915),(32.915,169.915),(32.915,169.765),(32.765,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,169.765),(33.085,169.915),(33.235,169.915),(33.235,169.765),(33.085,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,169.765),(33.405,169.915),(33.555,169.915),(33.555,169.765),(33.405,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,170.085),(32.445,170.235),(32.595,170.235),(32.595,170.085),(32.445,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,170.085),(32.765,170.235),(32.915,170.235),(32.915,170.085),(32.765,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,170.085),(33.085,170.235),(33.235,170.235),(33.235,170.085),(33.085,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,170.085),(33.405,170.235),(33.555,170.235),(33.555,170.085),(33.405,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,170.405),(32.445,170.555),(32.595,170.555),(32.595,170.405),(32.445,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,170.405),(32.765,170.555),(32.915,170.555),(32.915,170.405),(32.765,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,170.405),(33.085,170.555),(33.235,170.555),(33.235,170.405),(33.085,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,170.405),(33.405,170.555),(33.555,170.555),(33.555,170.405),(33.405,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,170.725),(32.445,170.875),(32.595,170.875),(32.595,170.725),(32.445,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,170.725),(32.765,170.875),(32.915,170.875),(32.915,170.725),(32.765,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,170.725),(33.085,170.875),(33.235,170.875),(33.235,170.725),(33.085,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,170.725),(33.405,170.875),(33.555,170.875),(33.555,170.725),(33.405,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,171.045),(32.445,171.195),(32.595,171.195),(32.595,171.045),(32.445,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,171.045),(32.765,171.195),(32.915,171.195),(32.915,171.045),(32.765,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,171.045),(33.085,171.195),(33.235,171.195),(33.235,171.045),(33.085,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,171.045),(33.405,171.195),(33.555,171.195),(33.555,171.045),(33.405,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,171.365),(32.445,171.515),(32.595,171.515),(32.595,171.365),(32.445,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,171.365),(32.765,171.515),(32.915,171.515),(32.915,171.365),(32.765,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,171.365),(33.085,171.515),(33.235,171.515),(33.235,171.365),(33.085,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,171.365),(33.405,171.515),(33.555,171.515),(33.555,171.365),(33.405,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,171.685),(32.445,171.835),(32.595,171.835),(32.595,171.685),(32.445,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,171.685),(32.765,171.835),(32.915,171.835),(32.915,171.685),(32.765,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,171.685),(33.085,171.835),(33.235,171.835),(33.235,171.685),(33.085,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,171.685),(33.405,171.835),(33.555,171.835),(33.555,171.685),(33.405,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,172.005),(32.445,172.155),(32.595,172.155),(32.595,172.005),(32.445,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,172.005),(32.765,172.155),(32.915,172.155),(32.915,172.005),(32.765,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,172.005),(33.085,172.155),(33.235,172.155),(33.235,172.005),(33.085,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,172.005),(33.405,172.155),(33.555,172.155),(33.555,172.005),(33.405,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,158.245),(27.645,158.395),(27.795,158.395),(27.795,158.245),(27.645,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,158.245),(27.965,158.395),(28.115,158.395),(28.115,158.245),(27.965,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,158.245),(28.285,158.395),(28.435,158.395),(28.435,158.245),(28.285,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,158.245),(28.605,158.395),(28.755,158.395),(28.755,158.245),(28.605,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,158.565),(27.645,158.715),(27.795,158.715),(27.795,158.565),(27.645,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,158.565),(27.965,158.715),(28.115,158.715),(28.115,158.565),(27.965,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,158.565),(28.285,158.715),(28.435,158.715),(28.435,158.565),(28.285,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,158.565),(28.605,158.715),(28.755,158.715),(28.755,158.565),(28.605,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,158.885),(27.645,159.035),(27.795,159.035),(27.795,158.885),(27.645,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,158.885),(27.965,159.035),(28.115,159.035),(28.115,158.885),(27.965,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,158.885),(28.285,159.035),(28.435,159.035),(28.435,158.885),(28.285,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,158.885),(28.605,159.035),(28.755,159.035),(28.755,158.885),(28.605,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,159.205),(27.645,159.355),(27.795,159.355),(27.795,159.205),(27.645,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,159.205),(27.965,159.355),(28.115,159.355),(28.115,159.205),(27.965,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,159.205),(28.285,159.355),(28.435,159.355),(28.435,159.205),(28.285,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,159.205),(28.605,159.355),(28.755,159.355),(28.755,159.205),(28.605,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,159.525),(27.645,159.675),(27.795,159.675),(27.795,159.525),(27.645,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,159.525),(27.965,159.675),(28.115,159.675),(28.115,159.525),(27.965,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,159.525),(28.285,159.675),(28.435,159.675),(28.435,159.525),(28.285,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,159.525),(28.605,159.675),(28.755,159.675),(28.755,159.525),(28.605,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,159.845),(27.645,159.995),(27.795,159.995),(27.795,159.845),(27.645,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,159.845),(27.965,159.995),(28.115,159.995),(28.115,159.845),(27.965,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,159.845),(28.285,159.995),(28.435,159.995),(28.435,159.845),(28.285,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,159.845),(28.605,159.995),(28.755,159.995),(28.755,159.845),(28.605,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,160.165),(27.645,160.315),(27.795,160.315),(27.795,160.165),(27.645,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,160.165),(27.965,160.315),(28.115,160.315),(28.115,160.165),(27.965,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,160.165),(28.285,160.315),(28.435,160.315),(28.435,160.165),(28.285,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,160.165),(28.605,160.315),(28.755,160.315),(28.755,160.165),(28.605,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,160.485),(27.645,160.635),(27.795,160.635),(27.795,160.485),(27.645,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,160.485),(27.965,160.635),(28.115,160.635),(28.115,160.485),(27.965,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,160.485),(28.285,160.635),(28.435,160.635),(28.435,160.485),(28.285,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,160.485),(28.605,160.635),(28.755,160.635),(28.755,160.485),(28.605,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,160.805),(27.645,160.955),(27.795,160.955),(27.795,160.805),(27.645,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,160.805),(27.965,160.955),(28.115,160.955),(28.115,160.805),(27.965,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,160.805),(28.285,160.955),(28.435,160.955),(28.435,160.805),(28.285,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,160.805),(28.605,160.955),(28.755,160.955),(28.755,160.805),(28.605,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,161.125),(27.645,161.275),(27.795,161.275),(27.795,161.125),(27.645,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,161.125),(27.965,161.275),(28.115,161.275),(28.115,161.125),(27.965,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,161.125),(28.285,161.275),(28.435,161.275),(28.435,161.125),(28.285,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,161.125),(28.605,161.275),(28.755,161.275),(28.755,161.125),(28.605,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,161.445),(27.645,161.595),(27.795,161.595),(27.795,161.445),(27.645,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,161.445),(27.965,161.595),(28.115,161.595),(28.115,161.445),(27.965,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,161.445),(28.285,161.595),(28.435,161.595),(28.435,161.445),(28.285,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,161.445),(28.605,161.595),(28.755,161.595),(28.755,161.445),(28.605,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,161.765),(27.645,161.915),(27.795,161.915),(27.795,161.765),(27.645,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,161.765),(27.965,161.915),(28.115,161.915),(28.115,161.765),(27.965,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,161.765),(28.285,161.915),(28.435,161.915),(28.435,161.765),(28.285,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,161.765),(28.605,161.915),(28.755,161.915),(28.755,161.765),(28.605,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,162.085),(27.645,162.235),(27.795,162.235),(27.795,162.085),(27.645,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,162.085),(27.965,162.235),(28.115,162.235),(28.115,162.085),(27.965,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,162.085),(28.285,162.235),(28.435,162.235),(28.435,162.085),(28.285,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,162.085),(28.605,162.235),(28.755,162.235),(28.755,162.085),(28.605,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,162.405),(27.645,162.555),(27.795,162.555),(27.795,162.405),(27.645,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,162.405),(27.965,162.555),(28.115,162.555),(28.115,162.405),(27.965,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,162.405),(28.285,162.555),(28.435,162.555),(28.435,162.405),(28.285,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,162.405),(28.605,162.555),(28.755,162.555),(28.755,162.405),(28.605,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,162.725),(27.645,162.875),(27.795,162.875),(27.795,162.725),(27.645,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,162.725),(27.965,162.875),(28.115,162.875),(28.115,162.725),(27.965,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,162.725),(28.285,162.875),(28.435,162.875),(28.435,162.725),(28.285,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,162.725),(28.605,162.875),(28.755,162.875),(28.755,162.725),(28.605,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,163.045),(27.645,163.195),(27.795,163.195),(27.795,163.045),(27.645,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,163.045),(27.965,163.195),(28.115,163.195),(28.115,163.045),(27.965,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,163.045),(28.285,163.195),(28.435,163.195),(28.435,163.045),(28.285,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,163.045),(28.605,163.195),(28.755,163.195),(28.755,163.045),(28.605,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,163.365),(27.645,163.515),(27.795,163.515),(27.795,163.365),(27.645,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,163.365),(27.965,163.515),(28.115,163.515),(28.115,163.365),(27.965,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,163.365),(28.285,163.515),(28.435,163.515),(28.435,163.365),(28.285,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,163.365),(28.605,163.515),(28.755,163.515),(28.755,163.365),(28.605,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,163.685),(27.645,163.835),(27.795,163.835),(27.795,163.685),(27.645,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,163.685),(27.965,163.835),(28.115,163.835),(28.115,163.685),(27.965,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,163.685),(28.285,163.835),(28.435,163.835),(28.435,163.685),(28.285,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,163.685),(28.605,163.835),(28.755,163.835),(28.755,163.685),(28.605,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,164.005),(27.645,164.155),(27.795,164.155),(27.795,164.005),(27.645,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,164.005),(27.965,164.155),(28.115,164.155),(28.115,164.005),(27.965,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,164.005),(28.285,164.155),(28.435,164.155),(28.435,164.005),(28.285,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,164.005),(28.605,164.155),(28.755,164.155),(28.755,164.005),(28.605,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,164.325),(27.645,164.475),(27.795,164.475),(27.795,164.325),(27.645,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,164.325),(27.965,164.475),(28.115,164.475),(28.115,164.325),(27.965,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,164.325),(28.285,164.475),(28.435,164.475),(28.435,164.325),(28.285,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,164.325),(28.605,164.475),(28.755,164.475),(28.755,164.325),(28.605,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,164.645),(27.645,164.795),(27.795,164.795),(27.795,164.645),(27.645,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,164.645),(27.965,164.795),(28.115,164.795),(28.115,164.645),(27.965,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,164.645),(28.285,164.795),(28.435,164.795),(28.435,164.645),(28.285,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,164.645),(28.605,164.795),(28.755,164.795),(28.755,164.645),(28.605,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,164.965),(27.645,165.115),(27.795,165.115),(27.795,164.965),(27.645,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,164.965),(27.965,165.115),(28.115,165.115),(28.115,164.965),(27.965,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,164.965),(28.285,165.115),(28.435,165.115),(28.435,164.965),(28.285,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,164.965),(28.605,165.115),(28.755,165.115),(28.755,164.965),(28.605,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,165.285),(27.645,165.435),(27.795,165.435),(27.795,165.285),(27.645,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,165.285),(27.965,165.435),(28.115,165.435),(28.115,165.285),(27.965,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,165.285),(28.285,165.435),(28.435,165.435),(28.435,165.285),(28.285,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,165.285),(28.605,165.435),(28.755,165.435),(28.755,165.285),(28.605,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,165.605),(27.645,165.755),(27.795,165.755),(27.795,165.605),(27.645,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,165.605),(27.965,165.755),(28.115,165.755),(28.115,165.605),(27.965,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,165.605),(28.285,165.755),(28.435,165.755),(28.435,165.605),(28.285,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,165.605),(28.605,165.755),(28.755,165.755),(28.755,165.605),(28.605,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,165.925),(27.645,166.075),(27.795,166.075),(27.795,165.925),(27.645,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,165.925),(27.965,166.075),(28.115,166.075),(28.115,165.925),(27.965,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,165.925),(28.285,166.075),(28.435,166.075),(28.435,165.925),(28.285,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,165.925),(28.605,166.075),(28.755,166.075),(28.755,165.925),(28.605,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,166.245),(27.645,166.395),(27.795,166.395),(27.795,166.245),(27.645,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,166.245),(27.965,166.395),(28.115,166.395),(28.115,166.245),(27.965,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,166.245),(28.285,166.395),(28.435,166.395),(28.435,166.245),(28.285,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,166.245),(28.605,166.395),(28.755,166.395),(28.755,166.245),(28.605,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,166.565),(27.645,166.715),(27.795,166.715),(27.795,166.565),(27.645,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,166.565),(27.965,166.715),(28.115,166.715),(28.115,166.565),(27.965,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,166.565),(28.285,166.715),(28.435,166.715),(28.435,166.565),(28.285,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,166.565),(28.605,166.715),(28.755,166.715),(28.755,166.565),(28.605,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,166.885),(27.645,167.035),(27.795,167.035),(27.795,166.885),(27.645,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,166.885),(27.965,167.035),(28.115,167.035),(28.115,166.885),(27.965,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,166.885),(28.285,167.035),(28.435,167.035),(28.435,166.885),(28.285,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,166.885),(28.605,167.035),(28.755,167.035),(28.755,166.885),(28.605,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,167.205),(27.645,167.355),(27.795,167.355),(27.795,167.205),(27.645,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,167.205),(27.965,167.355),(28.115,167.355),(28.115,167.205),(27.965,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,167.205),(28.285,167.355),(28.435,167.355),(28.435,167.205),(28.285,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,167.205),(28.605,167.355),(28.755,167.355),(28.755,167.205),(28.605,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,167.525),(27.645,167.675),(27.795,167.675),(27.795,167.525),(27.645,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,167.525),(27.965,167.675),(28.115,167.675),(28.115,167.525),(27.965,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,167.525),(28.285,167.675),(28.435,167.675),(28.435,167.525),(28.285,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,167.525),(28.605,167.675),(28.755,167.675),(28.755,167.525),(28.605,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,167.845),(27.645,167.995),(27.795,167.995),(27.795,167.845),(27.645,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,167.845),(27.965,167.995),(28.115,167.995),(28.115,167.845),(27.965,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,167.845),(28.285,167.995),(28.435,167.995),(28.435,167.845),(28.285,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,167.845),(28.605,167.995),(28.755,167.995),(28.755,167.845),(28.605,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,168.165),(27.645,168.315),(27.795,168.315),(27.795,168.165),(27.645,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,168.165),(27.965,168.315),(28.115,168.315),(28.115,168.165),(27.965,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,168.165),(28.285,168.315),(28.435,168.315),(28.435,168.165),(28.285,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,168.165),(28.605,168.315),(28.755,168.315),(28.755,168.165),(28.605,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,168.485),(27.645,168.635),(27.795,168.635),(27.795,168.485),(27.645,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,168.485),(27.965,168.635),(28.115,168.635),(28.115,168.485),(27.965,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,168.485),(28.285,168.635),(28.435,168.635),(28.435,168.485),(28.285,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,168.485),(28.605,168.635),(28.755,168.635),(28.755,168.485),(28.605,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,168.805),(27.645,168.955),(27.795,168.955),(27.795,168.805),(27.645,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,168.805),(27.965,168.955),(28.115,168.955),(28.115,168.805),(27.965,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,168.805),(28.285,168.955),(28.435,168.955),(28.435,168.805),(28.285,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,168.805),(28.605,168.955),(28.755,168.955),(28.755,168.805),(28.605,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,169.125),(27.645,169.275),(27.795,169.275),(27.795,169.125),(27.645,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,169.125),(27.965,169.275),(28.115,169.275),(28.115,169.125),(27.965,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,169.125),(28.285,169.275),(28.435,169.275),(28.435,169.125),(28.285,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,169.125),(28.605,169.275),(28.755,169.275),(28.755,169.125),(28.605,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,169.445),(27.645,169.595),(27.795,169.595),(27.795,169.445),(27.645,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,169.445),(27.965,169.595),(28.115,169.595),(28.115,169.445),(27.965,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,169.445),(28.285,169.595),(28.435,169.595),(28.435,169.445),(28.285,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,169.445),(28.605,169.595),(28.755,169.595),(28.755,169.445),(28.605,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,169.765),(27.645,169.915),(27.795,169.915),(27.795,169.765),(27.645,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,169.765),(27.965,169.915),(28.115,169.915),(28.115,169.765),(27.965,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,169.765),(28.285,169.915),(28.435,169.915),(28.435,169.765),(28.285,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,169.765),(28.605,169.915),(28.755,169.915),(28.755,169.765),(28.605,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,170.085),(27.645,170.235),(27.795,170.235),(27.795,170.085),(27.645,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,170.085),(27.965,170.235),(28.115,170.235),(28.115,170.085),(27.965,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,170.085),(28.285,170.235),(28.435,170.235),(28.435,170.085),(28.285,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,170.085),(28.605,170.235),(28.755,170.235),(28.755,170.085),(28.605,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,170.405),(27.645,170.555),(27.795,170.555),(27.795,170.405),(27.645,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,170.405),(27.965,170.555),(28.115,170.555),(28.115,170.405),(27.965,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,170.405),(28.285,170.555),(28.435,170.555),(28.435,170.405),(28.285,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,170.405),(28.605,170.555),(28.755,170.555),(28.755,170.405),(28.605,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,170.725),(27.645,170.875),(27.795,170.875),(27.795,170.725),(27.645,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,170.725),(27.965,170.875),(28.115,170.875),(28.115,170.725),(27.965,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,170.725),(28.285,170.875),(28.435,170.875),(28.435,170.725),(28.285,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,170.725),(28.605,170.875),(28.755,170.875),(28.755,170.725),(28.605,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,171.045),(27.645,171.195),(27.795,171.195),(27.795,171.045),(27.645,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,171.045),(27.965,171.195),(28.115,171.195),(28.115,171.045),(27.965,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,171.045),(28.285,171.195),(28.435,171.195),(28.435,171.045),(28.285,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,171.045),(28.605,171.195),(28.755,171.195),(28.755,171.045),(28.605,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,171.365),(27.645,171.515),(27.795,171.515),(27.795,171.365),(27.645,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,171.365),(27.965,171.515),(28.115,171.515),(28.115,171.365),(27.965,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,171.365),(28.285,171.515),(28.435,171.515),(28.435,171.365),(28.285,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,171.365),(28.605,171.515),(28.755,171.515),(28.755,171.365),(28.605,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,171.685),(27.645,171.835),(27.795,171.835),(27.795,171.685),(27.645,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,171.685),(27.965,171.835),(28.115,171.835),(28.115,171.685),(27.965,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,171.685),(28.285,171.835),(28.435,171.835),(28.435,171.685),(28.285,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,171.685),(28.605,171.835),(28.755,171.835),(28.755,171.685),(28.605,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,172.005),(27.645,172.155),(27.795,172.155),(27.795,172.005),(27.645,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,172.005),(27.965,172.155),(28.115,172.155),(28.115,172.005),(27.965,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,172.005),(28.285,172.155),(28.435,172.155),(28.435,172.005),(28.285,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,172.005),(28.605,172.155),(28.755,172.155),(28.755,172.005),(28.605,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,158.245),(13.245,158.395),(13.395,158.395),(13.395,158.245),(13.245,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,158.245),(13.565,158.395),(13.715,158.395),(13.715,158.245),(13.565,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,158.245),(13.885,158.395),(14.035,158.395),(14.035,158.245),(13.885,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,158.245),(14.205,158.395),(14.355,158.395),(14.355,158.245),(14.205,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,158.565),(13.245,158.715),(13.395,158.715),(13.395,158.565),(13.245,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,158.565),(13.565,158.715),(13.715,158.715),(13.715,158.565),(13.565,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,158.565),(13.885,158.715),(14.035,158.715),(14.035,158.565),(13.885,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,158.565),(14.205,158.715),(14.355,158.715),(14.355,158.565),(14.205,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,158.885),(13.245,159.035),(13.395,159.035),(13.395,158.885),(13.245,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,158.885),(13.565,159.035),(13.715,159.035),(13.715,158.885),(13.565,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,158.885),(13.885,159.035),(14.035,159.035),(14.035,158.885),(13.885,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,158.885),(14.205,159.035),(14.355,159.035),(14.355,158.885),(14.205,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,159.205),(13.245,159.355),(13.395,159.355),(13.395,159.205),(13.245,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,159.205),(13.565,159.355),(13.715,159.355),(13.715,159.205),(13.565,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,159.205),(13.885,159.355),(14.035,159.355),(14.035,159.205),(13.885,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,159.205),(14.205,159.355),(14.355,159.355),(14.355,159.205),(14.205,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,159.525),(13.245,159.675),(13.395,159.675),(13.395,159.525),(13.245,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,159.525),(13.565,159.675),(13.715,159.675),(13.715,159.525),(13.565,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,159.525),(13.885,159.675),(14.035,159.675),(14.035,159.525),(13.885,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,159.525),(14.205,159.675),(14.355,159.675),(14.355,159.525),(14.205,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,159.845),(13.245,159.995),(13.395,159.995),(13.395,159.845),(13.245,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,159.845),(13.565,159.995),(13.715,159.995),(13.715,159.845),(13.565,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,159.845),(13.885,159.995),(14.035,159.995),(14.035,159.845),(13.885,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,159.845),(14.205,159.995),(14.355,159.995),(14.355,159.845),(14.205,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,160.165),(13.245,160.315),(13.395,160.315),(13.395,160.165),(13.245,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,160.165),(13.565,160.315),(13.715,160.315),(13.715,160.165),(13.565,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,160.165),(13.885,160.315),(14.035,160.315),(14.035,160.165),(13.885,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,160.165),(14.205,160.315),(14.355,160.315),(14.355,160.165),(14.205,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,160.485),(13.245,160.635),(13.395,160.635),(13.395,160.485),(13.245,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,160.485),(13.565,160.635),(13.715,160.635),(13.715,160.485),(13.565,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,160.485),(13.885,160.635),(14.035,160.635),(14.035,160.485),(13.885,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,160.485),(14.205,160.635),(14.355,160.635),(14.355,160.485),(14.205,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,160.805),(13.245,160.955),(13.395,160.955),(13.395,160.805),(13.245,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,160.805),(13.565,160.955),(13.715,160.955),(13.715,160.805),(13.565,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,160.805),(13.885,160.955),(14.035,160.955),(14.035,160.805),(13.885,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,160.805),(14.205,160.955),(14.355,160.955),(14.355,160.805),(14.205,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,161.125),(13.245,161.275),(13.395,161.275),(13.395,161.125),(13.245,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,161.125),(13.565,161.275),(13.715,161.275),(13.715,161.125),(13.565,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,161.125),(13.885,161.275),(14.035,161.275),(14.035,161.125),(13.885,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,161.125),(14.205,161.275),(14.355,161.275),(14.355,161.125),(14.205,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,161.445),(13.245,161.595),(13.395,161.595),(13.395,161.445),(13.245,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,161.445),(13.565,161.595),(13.715,161.595),(13.715,161.445),(13.565,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,161.445),(13.885,161.595),(14.035,161.595),(14.035,161.445),(13.885,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,161.445),(14.205,161.595),(14.355,161.595),(14.355,161.445),(14.205,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,161.765),(13.245,161.915),(13.395,161.915),(13.395,161.765),(13.245,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,161.765),(13.565,161.915),(13.715,161.915),(13.715,161.765),(13.565,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,161.765),(13.885,161.915),(14.035,161.915),(14.035,161.765),(13.885,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,161.765),(14.205,161.915),(14.355,161.915),(14.355,161.765),(14.205,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,162.085),(13.245,162.235),(13.395,162.235),(13.395,162.085),(13.245,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,162.085),(13.565,162.235),(13.715,162.235),(13.715,162.085),(13.565,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,162.085),(13.885,162.235),(14.035,162.235),(14.035,162.085),(13.885,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,162.085),(14.205,162.235),(14.355,162.235),(14.355,162.085),(14.205,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,162.405),(13.245,162.555),(13.395,162.555),(13.395,162.405),(13.245,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,162.405),(13.565,162.555),(13.715,162.555),(13.715,162.405),(13.565,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,162.405),(13.885,162.555),(14.035,162.555),(14.035,162.405),(13.885,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,162.405),(14.205,162.555),(14.355,162.555),(14.355,162.405),(14.205,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,162.725),(13.245,162.875),(13.395,162.875),(13.395,162.725),(13.245,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,162.725),(13.565,162.875),(13.715,162.875),(13.715,162.725),(13.565,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,162.725),(13.885,162.875),(14.035,162.875),(14.035,162.725),(13.885,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,162.725),(14.205,162.875),(14.355,162.875),(14.355,162.725),(14.205,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,163.045),(13.245,163.195),(13.395,163.195),(13.395,163.045),(13.245,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,163.045),(13.565,163.195),(13.715,163.195),(13.715,163.045),(13.565,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,163.045),(13.885,163.195),(14.035,163.195),(14.035,163.045),(13.885,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,163.045),(14.205,163.195),(14.355,163.195),(14.355,163.045),(14.205,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,163.365),(13.245,163.515),(13.395,163.515),(13.395,163.365),(13.245,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,163.365),(13.565,163.515),(13.715,163.515),(13.715,163.365),(13.565,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,163.365),(13.885,163.515),(14.035,163.515),(14.035,163.365),(13.885,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,163.365),(14.205,163.515),(14.355,163.515),(14.355,163.365),(14.205,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,163.685),(13.245,163.835),(13.395,163.835),(13.395,163.685),(13.245,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,163.685),(13.565,163.835),(13.715,163.835),(13.715,163.685),(13.565,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,163.685),(13.885,163.835),(14.035,163.835),(14.035,163.685),(13.885,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,163.685),(14.205,163.835),(14.355,163.835),(14.355,163.685),(14.205,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,164.005),(13.245,164.155),(13.395,164.155),(13.395,164.005),(13.245,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,164.005),(13.565,164.155),(13.715,164.155),(13.715,164.005),(13.565,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,164.005),(13.885,164.155),(14.035,164.155),(14.035,164.005),(13.885,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,164.005),(14.205,164.155),(14.355,164.155),(14.355,164.005),(14.205,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,164.325),(13.245,164.475),(13.395,164.475),(13.395,164.325),(13.245,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,164.325),(13.565,164.475),(13.715,164.475),(13.715,164.325),(13.565,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,164.325),(13.885,164.475),(14.035,164.475),(14.035,164.325),(13.885,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,164.325),(14.205,164.475),(14.355,164.475),(14.355,164.325),(14.205,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,164.645),(13.245,164.795),(13.395,164.795),(13.395,164.645),(13.245,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,164.645),(13.565,164.795),(13.715,164.795),(13.715,164.645),(13.565,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,164.645),(13.885,164.795),(14.035,164.795),(14.035,164.645),(13.885,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,164.645),(14.205,164.795),(14.355,164.795),(14.355,164.645),(14.205,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,164.965),(13.245,165.115),(13.395,165.115),(13.395,164.965),(13.245,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,164.965),(13.565,165.115),(13.715,165.115),(13.715,164.965),(13.565,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,164.965),(13.885,165.115),(14.035,165.115),(14.035,164.965),(13.885,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,164.965),(14.205,165.115),(14.355,165.115),(14.355,164.965),(14.205,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,165.285),(13.245,165.435),(13.395,165.435),(13.395,165.285),(13.245,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,165.285),(13.565,165.435),(13.715,165.435),(13.715,165.285),(13.565,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,165.285),(13.885,165.435),(14.035,165.435),(14.035,165.285),(13.885,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,165.285),(14.205,165.435),(14.355,165.435),(14.355,165.285),(14.205,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,165.605),(13.245,165.755),(13.395,165.755),(13.395,165.605),(13.245,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,165.605),(13.565,165.755),(13.715,165.755),(13.715,165.605),(13.565,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,165.605),(13.885,165.755),(14.035,165.755),(14.035,165.605),(13.885,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,165.605),(14.205,165.755),(14.355,165.755),(14.355,165.605),(14.205,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,165.925),(13.245,166.075),(13.395,166.075),(13.395,165.925),(13.245,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,165.925),(13.565,166.075),(13.715,166.075),(13.715,165.925),(13.565,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,165.925),(13.885,166.075),(14.035,166.075),(14.035,165.925),(13.885,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,165.925),(14.205,166.075),(14.355,166.075),(14.355,165.925),(14.205,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,166.245),(13.245,166.395),(13.395,166.395),(13.395,166.245),(13.245,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,166.245),(13.565,166.395),(13.715,166.395),(13.715,166.245),(13.565,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,166.245),(13.885,166.395),(14.035,166.395),(14.035,166.245),(13.885,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,166.245),(14.205,166.395),(14.355,166.395),(14.355,166.245),(14.205,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,166.565),(13.245,166.715),(13.395,166.715),(13.395,166.565),(13.245,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,166.565),(13.565,166.715),(13.715,166.715),(13.715,166.565),(13.565,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,166.565),(13.885,166.715),(14.035,166.715),(14.035,166.565),(13.885,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,166.565),(14.205,166.715),(14.355,166.715),(14.355,166.565),(14.205,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,166.885),(13.245,167.035),(13.395,167.035),(13.395,166.885),(13.245,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,166.885),(13.565,167.035),(13.715,167.035),(13.715,166.885),(13.565,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,166.885),(13.885,167.035),(14.035,167.035),(14.035,166.885),(13.885,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,166.885),(14.205,167.035),(14.355,167.035),(14.355,166.885),(14.205,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,167.205),(13.245,167.355),(13.395,167.355),(13.395,167.205),(13.245,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,167.205),(13.565,167.355),(13.715,167.355),(13.715,167.205),(13.565,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,167.205),(13.885,167.355),(14.035,167.355),(14.035,167.205),(13.885,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,167.205),(14.205,167.355),(14.355,167.355),(14.355,167.205),(14.205,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,167.525),(13.245,167.675),(13.395,167.675),(13.395,167.525),(13.245,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,167.525),(13.565,167.675),(13.715,167.675),(13.715,167.525),(13.565,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,167.525),(13.885,167.675),(14.035,167.675),(14.035,167.525),(13.885,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,167.525),(14.205,167.675),(14.355,167.675),(14.355,167.525),(14.205,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,167.845),(13.245,167.995),(13.395,167.995),(13.395,167.845),(13.245,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,167.845),(13.565,167.995),(13.715,167.995),(13.715,167.845),(13.565,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,167.845),(13.885,167.995),(14.035,167.995),(14.035,167.845),(13.885,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,167.845),(14.205,167.995),(14.355,167.995),(14.355,167.845),(14.205,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,168.165),(13.245,168.315),(13.395,168.315),(13.395,168.165),(13.245,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,168.165),(13.565,168.315),(13.715,168.315),(13.715,168.165),(13.565,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,168.165),(13.885,168.315),(14.035,168.315),(14.035,168.165),(13.885,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,168.165),(14.205,168.315),(14.355,168.315),(14.355,168.165),(14.205,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,168.485),(13.245,168.635),(13.395,168.635),(13.395,168.485),(13.245,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,168.485),(13.565,168.635),(13.715,168.635),(13.715,168.485),(13.565,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,168.485),(13.885,168.635),(14.035,168.635),(14.035,168.485),(13.885,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,168.485),(14.205,168.635),(14.355,168.635),(14.355,168.485),(14.205,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,168.805),(13.245,168.955),(13.395,168.955),(13.395,168.805),(13.245,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,168.805),(13.565,168.955),(13.715,168.955),(13.715,168.805),(13.565,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,168.805),(13.885,168.955),(14.035,168.955),(14.035,168.805),(13.885,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,168.805),(14.205,168.955),(14.355,168.955),(14.355,168.805),(14.205,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,169.125),(13.245,169.275),(13.395,169.275),(13.395,169.125),(13.245,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,169.125),(13.565,169.275),(13.715,169.275),(13.715,169.125),(13.565,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,169.125),(13.885,169.275),(14.035,169.275),(14.035,169.125),(13.885,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,169.125),(14.205,169.275),(14.355,169.275),(14.355,169.125),(14.205,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,169.445),(13.245,169.595),(13.395,169.595),(13.395,169.445),(13.245,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,169.445),(13.565,169.595),(13.715,169.595),(13.715,169.445),(13.565,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,169.445),(13.885,169.595),(14.035,169.595),(14.035,169.445),(13.885,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,169.445),(14.205,169.595),(14.355,169.595),(14.355,169.445),(14.205,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,169.765),(13.245,169.915),(13.395,169.915),(13.395,169.765),(13.245,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,169.765),(13.565,169.915),(13.715,169.915),(13.715,169.765),(13.565,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,169.765),(13.885,169.915),(14.035,169.915),(14.035,169.765),(13.885,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,169.765),(14.205,169.915),(14.355,169.915),(14.355,169.765),(14.205,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,170.085),(13.245,170.235),(13.395,170.235),(13.395,170.085),(13.245,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,170.085),(13.565,170.235),(13.715,170.235),(13.715,170.085),(13.565,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,170.085),(13.885,170.235),(14.035,170.235),(14.035,170.085),(13.885,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,170.085),(14.205,170.235),(14.355,170.235),(14.355,170.085),(14.205,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,170.405),(13.245,170.555),(13.395,170.555),(13.395,170.405),(13.245,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,170.405),(13.565,170.555),(13.715,170.555),(13.715,170.405),(13.565,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,170.405),(13.885,170.555),(14.035,170.555),(14.035,170.405),(13.885,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,170.405),(14.205,170.555),(14.355,170.555),(14.355,170.405),(14.205,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,170.725),(13.245,170.875),(13.395,170.875),(13.395,170.725),(13.245,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,170.725),(13.565,170.875),(13.715,170.875),(13.715,170.725),(13.565,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,170.725),(13.885,170.875),(14.035,170.875),(14.035,170.725),(13.885,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,170.725),(14.205,170.875),(14.355,170.875),(14.355,170.725),(14.205,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,171.045),(13.245,171.195),(13.395,171.195),(13.395,171.045),(13.245,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,171.045),(13.565,171.195),(13.715,171.195),(13.715,171.045),(13.565,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,171.045),(13.885,171.195),(14.035,171.195),(14.035,171.045),(13.885,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,171.045),(14.205,171.195),(14.355,171.195),(14.355,171.045),(14.205,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,171.365),(13.245,171.515),(13.395,171.515),(13.395,171.365),(13.245,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,171.365),(13.565,171.515),(13.715,171.515),(13.715,171.365),(13.565,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,171.365),(13.885,171.515),(14.035,171.515),(14.035,171.365),(13.885,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,171.365),(14.205,171.515),(14.355,171.515),(14.355,171.365),(14.205,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,171.685),(13.245,171.835),(13.395,171.835),(13.395,171.685),(13.245,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,171.685),(13.565,171.835),(13.715,171.835),(13.715,171.685),(13.565,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,171.685),(13.885,171.835),(14.035,171.835),(14.035,171.685),(13.885,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,171.685),(14.205,171.835),(14.355,171.835),(14.355,171.685),(14.205,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,172.005),(13.245,172.155),(13.395,172.155),(13.395,172.005),(13.245,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,172.005),(13.565,172.155),(13.715,172.155),(13.715,172.005),(13.565,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,172.005),(13.885,172.155),(14.035,172.155),(14.035,172.005),(13.885,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,172.005),(14.205,172.155),(14.355,172.155),(14.355,172.005),(14.205,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,158.245),(75.645,158.395),(75.795,158.395),(75.795,158.245),(75.645,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,158.245),(75.965,158.395),(76.115,158.395),(76.115,158.245),(75.965,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,158.245),(76.285,158.395),(76.435,158.395),(76.435,158.245),(76.285,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,158.245),(76.605,158.395),(76.755,158.395),(76.755,158.245),(76.605,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,158.565),(75.645,158.715),(75.795,158.715),(75.795,158.565),(75.645,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,158.565),(75.965,158.715),(76.115,158.715),(76.115,158.565),(75.965,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,158.565),(76.285,158.715),(76.435,158.715),(76.435,158.565),(76.285,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,158.565),(76.605,158.715),(76.755,158.715),(76.755,158.565),(76.605,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,158.885),(75.645,159.035),(75.795,159.035),(75.795,158.885),(75.645,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,158.885),(75.965,159.035),(76.115,159.035),(76.115,158.885),(75.965,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,158.885),(76.285,159.035),(76.435,159.035),(76.435,158.885),(76.285,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,158.885),(76.605,159.035),(76.755,159.035),(76.755,158.885),(76.605,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,159.205),(75.645,159.355),(75.795,159.355),(75.795,159.205),(75.645,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,159.205),(75.965,159.355),(76.115,159.355),(76.115,159.205),(75.965,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,159.205),(76.285,159.355),(76.435,159.355),(76.435,159.205),(76.285,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,159.205),(76.605,159.355),(76.755,159.355),(76.755,159.205),(76.605,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,159.525),(75.645,159.675),(75.795,159.675),(75.795,159.525),(75.645,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,159.525),(75.965,159.675),(76.115,159.675),(76.115,159.525),(75.965,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,159.525),(76.285,159.675),(76.435,159.675),(76.435,159.525),(76.285,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,159.525),(76.605,159.675),(76.755,159.675),(76.755,159.525),(76.605,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,159.845),(75.645,159.995),(75.795,159.995),(75.795,159.845),(75.645,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,159.845),(75.965,159.995),(76.115,159.995),(76.115,159.845),(75.965,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,159.845),(76.285,159.995),(76.435,159.995),(76.435,159.845),(76.285,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,159.845),(76.605,159.995),(76.755,159.995),(76.755,159.845),(76.605,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,160.165),(75.645,160.315),(75.795,160.315),(75.795,160.165),(75.645,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,160.165),(75.965,160.315),(76.115,160.315),(76.115,160.165),(75.965,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,160.165),(76.285,160.315),(76.435,160.315),(76.435,160.165),(76.285,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,160.165),(76.605,160.315),(76.755,160.315),(76.755,160.165),(76.605,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,160.485),(75.645,160.635),(75.795,160.635),(75.795,160.485),(75.645,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,160.485),(75.965,160.635),(76.115,160.635),(76.115,160.485),(75.965,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,160.485),(76.285,160.635),(76.435,160.635),(76.435,160.485),(76.285,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,160.485),(76.605,160.635),(76.755,160.635),(76.755,160.485),(76.605,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,160.805),(75.645,160.955),(75.795,160.955),(75.795,160.805),(75.645,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,160.805),(75.965,160.955),(76.115,160.955),(76.115,160.805),(75.965,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,160.805),(76.285,160.955),(76.435,160.955),(76.435,160.805),(76.285,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,160.805),(76.605,160.955),(76.755,160.955),(76.755,160.805),(76.605,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,161.125),(75.645,161.275),(75.795,161.275),(75.795,161.125),(75.645,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,161.125),(75.965,161.275),(76.115,161.275),(76.115,161.125),(75.965,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,161.125),(76.285,161.275),(76.435,161.275),(76.435,161.125),(76.285,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,161.125),(76.605,161.275),(76.755,161.275),(76.755,161.125),(76.605,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,161.445),(75.645,161.595),(75.795,161.595),(75.795,161.445),(75.645,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,161.445),(75.965,161.595),(76.115,161.595),(76.115,161.445),(75.965,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,161.445),(76.285,161.595),(76.435,161.595),(76.435,161.445),(76.285,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,161.445),(76.605,161.595),(76.755,161.595),(76.755,161.445),(76.605,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,161.765),(75.645,161.915),(75.795,161.915),(75.795,161.765),(75.645,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,161.765),(75.965,161.915),(76.115,161.915),(76.115,161.765),(75.965,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,161.765),(76.285,161.915),(76.435,161.915),(76.435,161.765),(76.285,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,161.765),(76.605,161.915),(76.755,161.915),(76.755,161.765),(76.605,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,162.085),(75.645,162.235),(75.795,162.235),(75.795,162.085),(75.645,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,162.085),(75.965,162.235),(76.115,162.235),(76.115,162.085),(75.965,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,162.085),(76.285,162.235),(76.435,162.235),(76.435,162.085),(76.285,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,162.085),(76.605,162.235),(76.755,162.235),(76.755,162.085),(76.605,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,162.405),(75.645,162.555),(75.795,162.555),(75.795,162.405),(75.645,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,162.405),(75.965,162.555),(76.115,162.555),(76.115,162.405),(75.965,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,162.405),(76.285,162.555),(76.435,162.555),(76.435,162.405),(76.285,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,162.405),(76.605,162.555),(76.755,162.555),(76.755,162.405),(76.605,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,162.725),(75.645,162.875),(75.795,162.875),(75.795,162.725),(75.645,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,162.725),(75.965,162.875),(76.115,162.875),(76.115,162.725),(75.965,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,162.725),(76.285,162.875),(76.435,162.875),(76.435,162.725),(76.285,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,162.725),(76.605,162.875),(76.755,162.875),(76.755,162.725),(76.605,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,163.045),(75.645,163.195),(75.795,163.195),(75.795,163.045),(75.645,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,163.045),(75.965,163.195),(76.115,163.195),(76.115,163.045),(75.965,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,163.045),(76.285,163.195),(76.435,163.195),(76.435,163.045),(76.285,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,163.045),(76.605,163.195),(76.755,163.195),(76.755,163.045),(76.605,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,163.365),(75.645,163.515),(75.795,163.515),(75.795,163.365),(75.645,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,163.365),(75.965,163.515),(76.115,163.515),(76.115,163.365),(75.965,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,163.365),(76.285,163.515),(76.435,163.515),(76.435,163.365),(76.285,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,163.365),(76.605,163.515),(76.755,163.515),(76.755,163.365),(76.605,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,163.685),(75.645,163.835),(75.795,163.835),(75.795,163.685),(75.645,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,163.685),(75.965,163.835),(76.115,163.835),(76.115,163.685),(75.965,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,163.685),(76.285,163.835),(76.435,163.835),(76.435,163.685),(76.285,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,163.685),(76.605,163.835),(76.755,163.835),(76.755,163.685),(76.605,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,164.005),(75.645,164.155),(75.795,164.155),(75.795,164.005),(75.645,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,164.005),(75.965,164.155),(76.115,164.155),(76.115,164.005),(75.965,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,164.005),(76.285,164.155),(76.435,164.155),(76.435,164.005),(76.285,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,164.005),(76.605,164.155),(76.755,164.155),(76.755,164.005),(76.605,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,164.325),(75.645,164.475),(75.795,164.475),(75.795,164.325),(75.645,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,164.325),(75.965,164.475),(76.115,164.475),(76.115,164.325),(75.965,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,164.325),(76.285,164.475),(76.435,164.475),(76.435,164.325),(76.285,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,164.325),(76.605,164.475),(76.755,164.475),(76.755,164.325),(76.605,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,164.645),(75.645,164.795),(75.795,164.795),(75.795,164.645),(75.645,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,164.645),(75.965,164.795),(76.115,164.795),(76.115,164.645),(75.965,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,164.645),(76.285,164.795),(76.435,164.795),(76.435,164.645),(76.285,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,164.645),(76.605,164.795),(76.755,164.795),(76.755,164.645),(76.605,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,164.965),(75.645,165.115),(75.795,165.115),(75.795,164.965),(75.645,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,164.965),(75.965,165.115),(76.115,165.115),(76.115,164.965),(75.965,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,164.965),(76.285,165.115),(76.435,165.115),(76.435,164.965),(76.285,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,164.965),(76.605,165.115),(76.755,165.115),(76.755,164.965),(76.605,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,165.285),(75.645,165.435),(75.795,165.435),(75.795,165.285),(75.645,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,165.285),(75.965,165.435),(76.115,165.435),(76.115,165.285),(75.965,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,165.285),(76.285,165.435),(76.435,165.435),(76.435,165.285),(76.285,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,165.285),(76.605,165.435),(76.755,165.435),(76.755,165.285),(76.605,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,165.605),(75.645,165.755),(75.795,165.755),(75.795,165.605),(75.645,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,165.605),(75.965,165.755),(76.115,165.755),(76.115,165.605),(75.965,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,165.605),(76.285,165.755),(76.435,165.755),(76.435,165.605),(76.285,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,165.605),(76.605,165.755),(76.755,165.755),(76.755,165.605),(76.605,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,165.925),(75.645,166.075),(75.795,166.075),(75.795,165.925),(75.645,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,165.925),(75.965,166.075),(76.115,166.075),(76.115,165.925),(75.965,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,165.925),(76.285,166.075),(76.435,166.075),(76.435,165.925),(76.285,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,165.925),(76.605,166.075),(76.755,166.075),(76.755,165.925),(76.605,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,166.245),(75.645,166.395),(75.795,166.395),(75.795,166.245),(75.645,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,166.245),(75.965,166.395),(76.115,166.395),(76.115,166.245),(75.965,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,166.245),(76.285,166.395),(76.435,166.395),(76.435,166.245),(76.285,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,166.245),(76.605,166.395),(76.755,166.395),(76.755,166.245),(76.605,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,166.565),(75.645,166.715),(75.795,166.715),(75.795,166.565),(75.645,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,166.565),(75.965,166.715),(76.115,166.715),(76.115,166.565),(75.965,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,166.565),(76.285,166.715),(76.435,166.715),(76.435,166.565),(76.285,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,166.565),(76.605,166.715),(76.755,166.715),(76.755,166.565),(76.605,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,166.885),(75.645,167.035),(75.795,167.035),(75.795,166.885),(75.645,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,166.885),(75.965,167.035),(76.115,167.035),(76.115,166.885),(75.965,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,166.885),(76.285,167.035),(76.435,167.035),(76.435,166.885),(76.285,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,166.885),(76.605,167.035),(76.755,167.035),(76.755,166.885),(76.605,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,167.205),(75.645,167.355),(75.795,167.355),(75.795,167.205),(75.645,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,167.205),(75.965,167.355),(76.115,167.355),(76.115,167.205),(75.965,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,167.205),(76.285,167.355),(76.435,167.355),(76.435,167.205),(76.285,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,167.205),(76.605,167.355),(76.755,167.355),(76.755,167.205),(76.605,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,167.525),(75.645,167.675),(75.795,167.675),(75.795,167.525),(75.645,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,167.525),(75.965,167.675),(76.115,167.675),(76.115,167.525),(75.965,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,167.525),(76.285,167.675),(76.435,167.675),(76.435,167.525),(76.285,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,167.525),(76.605,167.675),(76.755,167.675),(76.755,167.525),(76.605,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,167.845),(75.645,167.995),(75.795,167.995),(75.795,167.845),(75.645,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,167.845),(75.965,167.995),(76.115,167.995),(76.115,167.845),(75.965,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,167.845),(76.285,167.995),(76.435,167.995),(76.435,167.845),(76.285,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,167.845),(76.605,167.995),(76.755,167.995),(76.755,167.845),(76.605,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,168.165),(75.645,168.315),(75.795,168.315),(75.795,168.165),(75.645,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,168.165),(75.965,168.315),(76.115,168.315),(76.115,168.165),(75.965,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,168.165),(76.285,168.315),(76.435,168.315),(76.435,168.165),(76.285,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,168.165),(76.605,168.315),(76.755,168.315),(76.755,168.165),(76.605,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,168.485),(75.645,168.635),(75.795,168.635),(75.795,168.485),(75.645,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,168.485),(75.965,168.635),(76.115,168.635),(76.115,168.485),(75.965,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,168.485),(76.285,168.635),(76.435,168.635),(76.435,168.485),(76.285,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,168.485),(76.605,168.635),(76.755,168.635),(76.755,168.485),(76.605,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,168.805),(75.645,168.955),(75.795,168.955),(75.795,168.805),(75.645,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,168.805),(75.965,168.955),(76.115,168.955),(76.115,168.805),(75.965,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,168.805),(76.285,168.955),(76.435,168.955),(76.435,168.805),(76.285,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,168.805),(76.605,168.955),(76.755,168.955),(76.755,168.805),(76.605,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,169.125),(75.645,169.275),(75.795,169.275),(75.795,169.125),(75.645,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,169.125),(75.965,169.275),(76.115,169.275),(76.115,169.125),(75.965,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,169.125),(76.285,169.275),(76.435,169.275),(76.435,169.125),(76.285,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,169.125),(76.605,169.275),(76.755,169.275),(76.755,169.125),(76.605,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,169.445),(75.645,169.595),(75.795,169.595),(75.795,169.445),(75.645,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,169.445),(75.965,169.595),(76.115,169.595),(76.115,169.445),(75.965,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,169.445),(76.285,169.595),(76.435,169.595),(76.435,169.445),(76.285,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,169.445),(76.605,169.595),(76.755,169.595),(76.755,169.445),(76.605,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,169.765),(75.645,169.915),(75.795,169.915),(75.795,169.765),(75.645,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,169.765),(75.965,169.915),(76.115,169.915),(76.115,169.765),(75.965,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,169.765),(76.285,169.915),(76.435,169.915),(76.435,169.765),(76.285,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,169.765),(76.605,169.915),(76.755,169.915),(76.755,169.765),(76.605,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,170.085),(75.645,170.235),(75.795,170.235),(75.795,170.085),(75.645,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,170.085),(75.965,170.235),(76.115,170.235),(76.115,170.085),(75.965,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,170.085),(76.285,170.235),(76.435,170.235),(76.435,170.085),(76.285,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,170.085),(76.605,170.235),(76.755,170.235),(76.755,170.085),(76.605,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,170.405),(75.645,170.555),(75.795,170.555),(75.795,170.405),(75.645,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,170.405),(75.965,170.555),(76.115,170.555),(76.115,170.405),(75.965,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,170.405),(76.285,170.555),(76.435,170.555),(76.435,170.405),(76.285,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,170.405),(76.605,170.555),(76.755,170.555),(76.755,170.405),(76.605,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,170.725),(75.645,170.875),(75.795,170.875),(75.795,170.725),(75.645,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,170.725),(75.965,170.875),(76.115,170.875),(76.115,170.725),(75.965,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,170.725),(76.285,170.875),(76.435,170.875),(76.435,170.725),(76.285,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,170.725),(76.605,170.875),(76.755,170.875),(76.755,170.725),(76.605,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,171.045),(75.645,171.195),(75.795,171.195),(75.795,171.045),(75.645,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,171.045),(75.965,171.195),(76.115,171.195),(76.115,171.045),(75.965,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,171.045),(76.285,171.195),(76.435,171.195),(76.435,171.045),(76.285,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,171.045),(76.605,171.195),(76.755,171.195),(76.755,171.045),(76.605,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,171.365),(75.645,171.515),(75.795,171.515),(75.795,171.365),(75.645,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,171.365),(75.965,171.515),(76.115,171.515),(76.115,171.365),(75.965,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,171.365),(76.285,171.515),(76.435,171.515),(76.435,171.365),(76.285,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,171.365),(76.605,171.515),(76.755,171.515),(76.755,171.365),(76.605,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,171.685),(75.645,171.835),(75.795,171.835),(75.795,171.685),(75.645,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,171.685),(75.965,171.835),(76.115,171.835),(76.115,171.685),(75.965,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,171.685),(76.285,171.835),(76.435,171.835),(76.435,171.685),(76.285,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,171.685),(76.605,171.835),(76.755,171.835),(76.755,171.685),(76.605,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,172.005),(75.645,172.155),(75.795,172.155),(75.795,172.005),(75.645,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,172.005),(75.965,172.155),(76.115,172.155),(76.115,172.005),(75.965,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,172.005),(76.285,172.155),(76.435,172.155),(76.435,172.005),(76.285,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,172.005),(76.605,172.155),(76.755,172.155),(76.755,172.005),(76.605,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,158.245),(61.245,158.395),(61.395,158.395),(61.395,158.245),(61.245,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,158.245),(61.565,158.395),(61.715,158.395),(61.715,158.245),(61.565,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,158.245),(61.885,158.395),(62.035,158.395),(62.035,158.245),(61.885,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,158.245),(62.205,158.395),(62.355,158.395),(62.355,158.245),(62.205,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,158.565),(61.245,158.715),(61.395,158.715),(61.395,158.565),(61.245,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,158.565),(61.565,158.715),(61.715,158.715),(61.715,158.565),(61.565,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,158.565),(61.885,158.715),(62.035,158.715),(62.035,158.565),(61.885,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,158.565),(62.205,158.715),(62.355,158.715),(62.355,158.565),(62.205,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,158.885),(61.245,159.035),(61.395,159.035),(61.395,158.885),(61.245,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,158.885),(61.565,159.035),(61.715,159.035),(61.715,158.885),(61.565,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,158.885),(61.885,159.035),(62.035,159.035),(62.035,158.885),(61.885,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,158.885),(62.205,159.035),(62.355,159.035),(62.355,158.885),(62.205,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,159.205),(61.245,159.355),(61.395,159.355),(61.395,159.205),(61.245,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,159.205),(61.565,159.355),(61.715,159.355),(61.715,159.205),(61.565,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,159.205),(61.885,159.355),(62.035,159.355),(62.035,159.205),(61.885,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,159.205),(62.205,159.355),(62.355,159.355),(62.355,159.205),(62.205,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,159.525),(61.245,159.675),(61.395,159.675),(61.395,159.525),(61.245,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,159.525),(61.565,159.675),(61.715,159.675),(61.715,159.525),(61.565,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,159.525),(61.885,159.675),(62.035,159.675),(62.035,159.525),(61.885,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,159.525),(62.205,159.675),(62.355,159.675),(62.355,159.525),(62.205,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,159.845),(61.245,159.995),(61.395,159.995),(61.395,159.845),(61.245,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,159.845),(61.565,159.995),(61.715,159.995),(61.715,159.845),(61.565,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,159.845),(61.885,159.995),(62.035,159.995),(62.035,159.845),(61.885,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,159.845),(62.205,159.995),(62.355,159.995),(62.355,159.845),(62.205,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,160.165),(61.245,160.315),(61.395,160.315),(61.395,160.165),(61.245,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,160.165),(61.565,160.315),(61.715,160.315),(61.715,160.165),(61.565,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,160.165),(61.885,160.315),(62.035,160.315),(62.035,160.165),(61.885,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,160.165),(62.205,160.315),(62.355,160.315),(62.355,160.165),(62.205,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,160.485),(61.245,160.635),(61.395,160.635),(61.395,160.485),(61.245,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,160.485),(61.565,160.635),(61.715,160.635),(61.715,160.485),(61.565,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,160.485),(61.885,160.635),(62.035,160.635),(62.035,160.485),(61.885,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,160.485),(62.205,160.635),(62.355,160.635),(62.355,160.485),(62.205,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,160.805),(61.245,160.955),(61.395,160.955),(61.395,160.805),(61.245,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,160.805),(61.565,160.955),(61.715,160.955),(61.715,160.805),(61.565,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,160.805),(61.885,160.955),(62.035,160.955),(62.035,160.805),(61.885,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,160.805),(62.205,160.955),(62.355,160.955),(62.355,160.805),(62.205,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,161.125),(61.245,161.275),(61.395,161.275),(61.395,161.125),(61.245,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,161.125),(61.565,161.275),(61.715,161.275),(61.715,161.125),(61.565,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,161.125),(61.885,161.275),(62.035,161.275),(62.035,161.125),(61.885,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,161.125),(62.205,161.275),(62.355,161.275),(62.355,161.125),(62.205,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,161.445),(61.245,161.595),(61.395,161.595),(61.395,161.445),(61.245,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,161.445),(61.565,161.595),(61.715,161.595),(61.715,161.445),(61.565,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,161.445),(61.885,161.595),(62.035,161.595),(62.035,161.445),(61.885,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,161.445),(62.205,161.595),(62.355,161.595),(62.355,161.445),(62.205,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,161.765),(61.245,161.915),(61.395,161.915),(61.395,161.765),(61.245,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,161.765),(61.565,161.915),(61.715,161.915),(61.715,161.765),(61.565,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,161.765),(61.885,161.915),(62.035,161.915),(62.035,161.765),(61.885,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,161.765),(62.205,161.915),(62.355,161.915),(62.355,161.765),(62.205,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,162.085),(61.245,162.235),(61.395,162.235),(61.395,162.085),(61.245,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,162.085),(61.565,162.235),(61.715,162.235),(61.715,162.085),(61.565,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,162.085),(61.885,162.235),(62.035,162.235),(62.035,162.085),(61.885,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,162.085),(62.205,162.235),(62.355,162.235),(62.355,162.085),(62.205,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,162.405),(61.245,162.555),(61.395,162.555),(61.395,162.405),(61.245,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,162.405),(61.565,162.555),(61.715,162.555),(61.715,162.405),(61.565,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,162.405),(61.885,162.555),(62.035,162.555),(62.035,162.405),(61.885,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,162.405),(62.205,162.555),(62.355,162.555),(62.355,162.405),(62.205,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,162.725),(61.245,162.875),(61.395,162.875),(61.395,162.725),(61.245,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,162.725),(61.565,162.875),(61.715,162.875),(61.715,162.725),(61.565,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,162.725),(61.885,162.875),(62.035,162.875),(62.035,162.725),(61.885,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,162.725),(62.205,162.875),(62.355,162.875),(62.355,162.725),(62.205,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,163.045),(61.245,163.195),(61.395,163.195),(61.395,163.045),(61.245,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,163.045),(61.565,163.195),(61.715,163.195),(61.715,163.045),(61.565,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,163.045),(61.885,163.195),(62.035,163.195),(62.035,163.045),(61.885,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,163.045),(62.205,163.195),(62.355,163.195),(62.355,163.045),(62.205,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,163.365),(61.245,163.515),(61.395,163.515),(61.395,163.365),(61.245,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,163.365),(61.565,163.515),(61.715,163.515),(61.715,163.365),(61.565,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,163.365),(61.885,163.515),(62.035,163.515),(62.035,163.365),(61.885,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,163.365),(62.205,163.515),(62.355,163.515),(62.355,163.365),(62.205,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,163.685),(61.245,163.835),(61.395,163.835),(61.395,163.685),(61.245,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,163.685),(61.565,163.835),(61.715,163.835),(61.715,163.685),(61.565,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,163.685),(61.885,163.835),(62.035,163.835),(62.035,163.685),(61.885,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,163.685),(62.205,163.835),(62.355,163.835),(62.355,163.685),(62.205,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,164.005),(61.245,164.155),(61.395,164.155),(61.395,164.005),(61.245,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,164.005),(61.565,164.155),(61.715,164.155),(61.715,164.005),(61.565,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,164.005),(61.885,164.155),(62.035,164.155),(62.035,164.005),(61.885,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,164.005),(62.205,164.155),(62.355,164.155),(62.355,164.005),(62.205,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,164.325),(61.245,164.475),(61.395,164.475),(61.395,164.325),(61.245,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,164.325),(61.565,164.475),(61.715,164.475),(61.715,164.325),(61.565,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,164.325),(61.885,164.475),(62.035,164.475),(62.035,164.325),(61.885,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,164.325),(62.205,164.475),(62.355,164.475),(62.355,164.325),(62.205,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,164.645),(61.245,164.795),(61.395,164.795),(61.395,164.645),(61.245,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,164.645),(61.565,164.795),(61.715,164.795),(61.715,164.645),(61.565,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,164.645),(61.885,164.795),(62.035,164.795),(62.035,164.645),(61.885,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,164.645),(62.205,164.795),(62.355,164.795),(62.355,164.645),(62.205,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,164.965),(61.245,165.115),(61.395,165.115),(61.395,164.965),(61.245,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,164.965),(61.565,165.115),(61.715,165.115),(61.715,164.965),(61.565,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,164.965),(61.885,165.115),(62.035,165.115),(62.035,164.965),(61.885,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,164.965),(62.205,165.115),(62.355,165.115),(62.355,164.965),(62.205,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,165.285),(61.245,165.435),(61.395,165.435),(61.395,165.285),(61.245,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,165.285),(61.565,165.435),(61.715,165.435),(61.715,165.285),(61.565,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,165.285),(61.885,165.435),(62.035,165.435),(62.035,165.285),(61.885,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,165.285),(62.205,165.435),(62.355,165.435),(62.355,165.285),(62.205,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,165.605),(61.245,165.755),(61.395,165.755),(61.395,165.605),(61.245,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,165.605),(61.565,165.755),(61.715,165.755),(61.715,165.605),(61.565,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,165.605),(61.885,165.755),(62.035,165.755),(62.035,165.605),(61.885,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,165.605),(62.205,165.755),(62.355,165.755),(62.355,165.605),(62.205,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,165.925),(61.245,166.075),(61.395,166.075),(61.395,165.925),(61.245,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,165.925),(61.565,166.075),(61.715,166.075),(61.715,165.925),(61.565,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,165.925),(61.885,166.075),(62.035,166.075),(62.035,165.925),(61.885,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,165.925),(62.205,166.075),(62.355,166.075),(62.355,165.925),(62.205,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,166.245),(61.245,166.395),(61.395,166.395),(61.395,166.245),(61.245,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,166.245),(61.565,166.395),(61.715,166.395),(61.715,166.245),(61.565,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,166.245),(61.885,166.395),(62.035,166.395),(62.035,166.245),(61.885,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,166.245),(62.205,166.395),(62.355,166.395),(62.355,166.245),(62.205,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,166.565),(61.245,166.715),(61.395,166.715),(61.395,166.565),(61.245,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,166.565),(61.565,166.715),(61.715,166.715),(61.715,166.565),(61.565,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,166.565),(61.885,166.715),(62.035,166.715),(62.035,166.565),(61.885,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,166.565),(62.205,166.715),(62.355,166.715),(62.355,166.565),(62.205,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,166.885),(61.245,167.035),(61.395,167.035),(61.395,166.885),(61.245,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,166.885),(61.565,167.035),(61.715,167.035),(61.715,166.885),(61.565,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,166.885),(61.885,167.035),(62.035,167.035),(62.035,166.885),(61.885,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,166.885),(62.205,167.035),(62.355,167.035),(62.355,166.885),(62.205,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,167.205),(61.245,167.355),(61.395,167.355),(61.395,167.205),(61.245,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,167.205),(61.565,167.355),(61.715,167.355),(61.715,167.205),(61.565,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,167.205),(61.885,167.355),(62.035,167.355),(62.035,167.205),(61.885,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,167.205),(62.205,167.355),(62.355,167.355),(62.355,167.205),(62.205,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,167.525),(61.245,167.675),(61.395,167.675),(61.395,167.525),(61.245,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,167.525),(61.565,167.675),(61.715,167.675),(61.715,167.525),(61.565,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,167.525),(61.885,167.675),(62.035,167.675),(62.035,167.525),(61.885,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,167.525),(62.205,167.675),(62.355,167.675),(62.355,167.525),(62.205,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,167.845),(61.245,167.995),(61.395,167.995),(61.395,167.845),(61.245,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,167.845),(61.565,167.995),(61.715,167.995),(61.715,167.845),(61.565,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,167.845),(61.885,167.995),(62.035,167.995),(62.035,167.845),(61.885,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,167.845),(62.205,167.995),(62.355,167.995),(62.355,167.845),(62.205,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,168.165),(61.245,168.315),(61.395,168.315),(61.395,168.165),(61.245,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,168.165),(61.565,168.315),(61.715,168.315),(61.715,168.165),(61.565,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,168.165),(61.885,168.315),(62.035,168.315),(62.035,168.165),(61.885,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,168.165),(62.205,168.315),(62.355,168.315),(62.355,168.165),(62.205,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,168.485),(61.245,168.635),(61.395,168.635),(61.395,168.485),(61.245,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,168.485),(61.565,168.635),(61.715,168.635),(61.715,168.485),(61.565,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,168.485),(61.885,168.635),(62.035,168.635),(62.035,168.485),(61.885,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,168.485),(62.205,168.635),(62.355,168.635),(62.355,168.485),(62.205,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,168.805),(61.245,168.955),(61.395,168.955),(61.395,168.805),(61.245,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,168.805),(61.565,168.955),(61.715,168.955),(61.715,168.805),(61.565,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,168.805),(61.885,168.955),(62.035,168.955),(62.035,168.805),(61.885,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,168.805),(62.205,168.955),(62.355,168.955),(62.355,168.805),(62.205,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,169.125),(61.245,169.275),(61.395,169.275),(61.395,169.125),(61.245,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,169.125),(61.565,169.275),(61.715,169.275),(61.715,169.125),(61.565,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,169.125),(61.885,169.275),(62.035,169.275),(62.035,169.125),(61.885,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,169.125),(62.205,169.275),(62.355,169.275),(62.355,169.125),(62.205,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,169.445),(61.245,169.595),(61.395,169.595),(61.395,169.445),(61.245,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,169.445),(61.565,169.595),(61.715,169.595),(61.715,169.445),(61.565,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,169.445),(61.885,169.595),(62.035,169.595),(62.035,169.445),(61.885,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,169.445),(62.205,169.595),(62.355,169.595),(62.355,169.445),(62.205,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,169.765),(61.245,169.915),(61.395,169.915),(61.395,169.765),(61.245,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,169.765),(61.565,169.915),(61.715,169.915),(61.715,169.765),(61.565,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,169.765),(61.885,169.915),(62.035,169.915),(62.035,169.765),(61.885,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,169.765),(62.205,169.915),(62.355,169.915),(62.355,169.765),(62.205,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,170.085),(61.245,170.235),(61.395,170.235),(61.395,170.085),(61.245,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,170.085),(61.565,170.235),(61.715,170.235),(61.715,170.085),(61.565,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,170.085),(61.885,170.235),(62.035,170.235),(62.035,170.085),(61.885,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,170.085),(62.205,170.235),(62.355,170.235),(62.355,170.085),(62.205,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,170.405),(61.245,170.555),(61.395,170.555),(61.395,170.405),(61.245,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,170.405),(61.565,170.555),(61.715,170.555),(61.715,170.405),(61.565,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,170.405),(61.885,170.555),(62.035,170.555),(62.035,170.405),(61.885,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,170.405),(62.205,170.555),(62.355,170.555),(62.355,170.405),(62.205,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,170.725),(61.245,170.875),(61.395,170.875),(61.395,170.725),(61.245,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,170.725),(61.565,170.875),(61.715,170.875),(61.715,170.725),(61.565,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,170.725),(61.885,170.875),(62.035,170.875),(62.035,170.725),(61.885,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,170.725),(62.205,170.875),(62.355,170.875),(62.355,170.725),(62.205,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,171.045),(61.245,171.195),(61.395,171.195),(61.395,171.045),(61.245,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,171.045),(61.565,171.195),(61.715,171.195),(61.715,171.045),(61.565,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,171.045),(61.885,171.195),(62.035,171.195),(62.035,171.045),(61.885,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,171.045),(62.205,171.195),(62.355,171.195),(62.355,171.045),(62.205,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,171.365),(61.245,171.515),(61.395,171.515),(61.395,171.365),(61.245,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,171.365),(61.565,171.515),(61.715,171.515),(61.715,171.365),(61.565,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,171.365),(61.885,171.515),(62.035,171.515),(62.035,171.365),(61.885,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,171.365),(62.205,171.515),(62.355,171.515),(62.355,171.365),(62.205,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,171.685),(61.245,171.835),(61.395,171.835),(61.395,171.685),(61.245,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,171.685),(61.565,171.835),(61.715,171.835),(61.715,171.685),(61.565,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,171.685),(61.885,171.835),(62.035,171.835),(62.035,171.685),(61.885,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,171.685),(62.205,171.835),(62.355,171.835),(62.355,171.685),(62.205,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,172.005),(61.245,172.155),(61.395,172.155),(61.395,172.005),(61.245,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,172.005),(61.565,172.155),(61.715,172.155),(61.715,172.005),(61.565,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,172.005),(61.885,172.155),(62.035,172.155),(62.035,172.005),(61.885,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,172.005),(62.205,172.155),(62.355,172.155),(62.355,172.005),(62.205,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,158.245),(42.045,158.395),(42.195,158.395),(42.195,158.245),(42.045,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,158.245),(42.365,158.395),(42.515,158.395),(42.515,158.245),(42.365,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,158.245),(42.685,158.395),(42.835,158.395),(42.835,158.245),(42.685,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,158.245),(43.005,158.395),(43.155,158.395),(43.155,158.245),(43.005,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,158.565),(42.045,158.715),(42.195,158.715),(42.195,158.565),(42.045,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,158.565),(42.365,158.715),(42.515,158.715),(42.515,158.565),(42.365,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,158.565),(42.685,158.715),(42.835,158.715),(42.835,158.565),(42.685,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,158.565),(43.005,158.715),(43.155,158.715),(43.155,158.565),(43.005,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,158.885),(42.045,159.035),(42.195,159.035),(42.195,158.885),(42.045,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,158.885),(42.365,159.035),(42.515,159.035),(42.515,158.885),(42.365,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,158.885),(42.685,159.035),(42.835,159.035),(42.835,158.885),(42.685,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,158.885),(43.005,159.035),(43.155,159.035),(43.155,158.885),(43.005,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,159.205),(42.045,159.355),(42.195,159.355),(42.195,159.205),(42.045,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,159.205),(42.365,159.355),(42.515,159.355),(42.515,159.205),(42.365,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,159.205),(42.685,159.355),(42.835,159.355),(42.835,159.205),(42.685,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,159.205),(43.005,159.355),(43.155,159.355),(43.155,159.205),(43.005,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,159.525),(42.045,159.675),(42.195,159.675),(42.195,159.525),(42.045,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,159.525),(42.365,159.675),(42.515,159.675),(42.515,159.525),(42.365,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,159.525),(42.685,159.675),(42.835,159.675),(42.835,159.525),(42.685,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,159.525),(43.005,159.675),(43.155,159.675),(43.155,159.525),(43.005,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,159.845),(42.045,159.995),(42.195,159.995),(42.195,159.845),(42.045,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,159.845),(42.365,159.995),(42.515,159.995),(42.515,159.845),(42.365,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,159.845),(42.685,159.995),(42.835,159.995),(42.835,159.845),(42.685,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,159.845),(43.005,159.995),(43.155,159.995),(43.155,159.845),(43.005,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,160.165),(42.045,160.315),(42.195,160.315),(42.195,160.165),(42.045,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,160.165),(42.365,160.315),(42.515,160.315),(42.515,160.165),(42.365,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,160.165),(42.685,160.315),(42.835,160.315),(42.835,160.165),(42.685,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,160.165),(43.005,160.315),(43.155,160.315),(43.155,160.165),(43.005,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,160.485),(42.045,160.635),(42.195,160.635),(42.195,160.485),(42.045,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,160.485),(42.365,160.635),(42.515,160.635),(42.515,160.485),(42.365,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,160.485),(42.685,160.635),(42.835,160.635),(42.835,160.485),(42.685,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,160.485),(43.005,160.635),(43.155,160.635),(43.155,160.485),(43.005,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,160.805),(42.045,160.955),(42.195,160.955),(42.195,160.805),(42.045,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,160.805),(42.365,160.955),(42.515,160.955),(42.515,160.805),(42.365,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,160.805),(42.685,160.955),(42.835,160.955),(42.835,160.805),(42.685,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,160.805),(43.005,160.955),(43.155,160.955),(43.155,160.805),(43.005,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,161.125),(42.045,161.275),(42.195,161.275),(42.195,161.125),(42.045,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,161.125),(42.365,161.275),(42.515,161.275),(42.515,161.125),(42.365,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,161.125),(42.685,161.275),(42.835,161.275),(42.835,161.125),(42.685,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,161.125),(43.005,161.275),(43.155,161.275),(43.155,161.125),(43.005,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,161.445),(42.045,161.595),(42.195,161.595),(42.195,161.445),(42.045,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,161.445),(42.365,161.595),(42.515,161.595),(42.515,161.445),(42.365,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,161.445),(42.685,161.595),(42.835,161.595),(42.835,161.445),(42.685,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,161.445),(43.005,161.595),(43.155,161.595),(43.155,161.445),(43.005,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,161.765),(42.045,161.915),(42.195,161.915),(42.195,161.765),(42.045,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,161.765),(42.365,161.915),(42.515,161.915),(42.515,161.765),(42.365,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,161.765),(42.685,161.915),(42.835,161.915),(42.835,161.765),(42.685,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,161.765),(43.005,161.915),(43.155,161.915),(43.155,161.765),(43.005,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,162.085),(42.045,162.235),(42.195,162.235),(42.195,162.085),(42.045,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,162.085),(42.365,162.235),(42.515,162.235),(42.515,162.085),(42.365,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,162.085),(42.685,162.235),(42.835,162.235),(42.835,162.085),(42.685,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,162.085),(43.005,162.235),(43.155,162.235),(43.155,162.085),(43.005,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,162.405),(42.045,162.555),(42.195,162.555),(42.195,162.405),(42.045,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,162.405),(42.365,162.555),(42.515,162.555),(42.515,162.405),(42.365,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,162.405),(42.685,162.555),(42.835,162.555),(42.835,162.405),(42.685,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,162.405),(43.005,162.555),(43.155,162.555),(43.155,162.405),(43.005,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,162.725),(42.045,162.875),(42.195,162.875),(42.195,162.725),(42.045,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,162.725),(42.365,162.875),(42.515,162.875),(42.515,162.725),(42.365,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,162.725),(42.685,162.875),(42.835,162.875),(42.835,162.725),(42.685,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,162.725),(43.005,162.875),(43.155,162.875),(43.155,162.725),(43.005,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,163.045),(42.045,163.195),(42.195,163.195),(42.195,163.045),(42.045,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,163.045),(42.365,163.195),(42.515,163.195),(42.515,163.045),(42.365,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,163.045),(42.685,163.195),(42.835,163.195),(42.835,163.045),(42.685,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,163.045),(43.005,163.195),(43.155,163.195),(43.155,163.045),(43.005,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,163.365),(42.045,163.515),(42.195,163.515),(42.195,163.365),(42.045,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,163.365),(42.365,163.515),(42.515,163.515),(42.515,163.365),(42.365,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,163.365),(42.685,163.515),(42.835,163.515),(42.835,163.365),(42.685,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,163.365),(43.005,163.515),(43.155,163.515),(43.155,163.365),(43.005,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,163.685),(42.045,163.835),(42.195,163.835),(42.195,163.685),(42.045,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,163.685),(42.365,163.835),(42.515,163.835),(42.515,163.685),(42.365,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,163.685),(42.685,163.835),(42.835,163.835),(42.835,163.685),(42.685,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,163.685),(43.005,163.835),(43.155,163.835),(43.155,163.685),(43.005,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,164.005),(42.045,164.155),(42.195,164.155),(42.195,164.005),(42.045,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,164.005),(42.365,164.155),(42.515,164.155),(42.515,164.005),(42.365,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,164.005),(42.685,164.155),(42.835,164.155),(42.835,164.005),(42.685,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,164.005),(43.005,164.155),(43.155,164.155),(43.155,164.005),(43.005,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,164.325),(42.045,164.475),(42.195,164.475),(42.195,164.325),(42.045,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,164.325),(42.365,164.475),(42.515,164.475),(42.515,164.325),(42.365,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,164.325),(42.685,164.475),(42.835,164.475),(42.835,164.325),(42.685,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,164.325),(43.005,164.475),(43.155,164.475),(43.155,164.325),(43.005,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,164.645),(42.045,164.795),(42.195,164.795),(42.195,164.645),(42.045,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,164.645),(42.365,164.795),(42.515,164.795),(42.515,164.645),(42.365,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,164.645),(42.685,164.795),(42.835,164.795),(42.835,164.645),(42.685,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,164.645),(43.005,164.795),(43.155,164.795),(43.155,164.645),(43.005,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,164.965),(42.045,165.115),(42.195,165.115),(42.195,164.965),(42.045,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,164.965),(42.365,165.115),(42.515,165.115),(42.515,164.965),(42.365,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,164.965),(42.685,165.115),(42.835,165.115),(42.835,164.965),(42.685,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,164.965),(43.005,165.115),(43.155,165.115),(43.155,164.965),(43.005,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,165.285),(42.045,165.435),(42.195,165.435),(42.195,165.285),(42.045,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,165.285),(42.365,165.435),(42.515,165.435),(42.515,165.285),(42.365,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,165.285),(42.685,165.435),(42.835,165.435),(42.835,165.285),(42.685,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,165.285),(43.005,165.435),(43.155,165.435),(43.155,165.285),(43.005,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,165.605),(42.045,165.755),(42.195,165.755),(42.195,165.605),(42.045,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,165.605),(42.365,165.755),(42.515,165.755),(42.515,165.605),(42.365,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,165.605),(42.685,165.755),(42.835,165.755),(42.835,165.605),(42.685,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,165.605),(43.005,165.755),(43.155,165.755),(43.155,165.605),(43.005,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,165.925),(42.045,166.075),(42.195,166.075),(42.195,165.925),(42.045,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,165.925),(42.365,166.075),(42.515,166.075),(42.515,165.925),(42.365,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,165.925),(42.685,166.075),(42.835,166.075),(42.835,165.925),(42.685,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,165.925),(43.005,166.075),(43.155,166.075),(43.155,165.925),(43.005,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,166.245),(42.045,166.395),(42.195,166.395),(42.195,166.245),(42.045,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,166.245),(42.365,166.395),(42.515,166.395),(42.515,166.245),(42.365,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,166.245),(42.685,166.395),(42.835,166.395),(42.835,166.245),(42.685,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,166.245),(43.005,166.395),(43.155,166.395),(43.155,166.245),(43.005,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,166.565),(42.045,166.715),(42.195,166.715),(42.195,166.565),(42.045,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,166.565),(42.365,166.715),(42.515,166.715),(42.515,166.565),(42.365,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,166.565),(42.685,166.715),(42.835,166.715),(42.835,166.565),(42.685,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,166.565),(43.005,166.715),(43.155,166.715),(43.155,166.565),(43.005,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,166.885),(42.045,167.035),(42.195,167.035),(42.195,166.885),(42.045,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,166.885),(42.365,167.035),(42.515,167.035),(42.515,166.885),(42.365,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,166.885),(42.685,167.035),(42.835,167.035),(42.835,166.885),(42.685,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,166.885),(43.005,167.035),(43.155,167.035),(43.155,166.885),(43.005,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,167.205),(42.045,167.355),(42.195,167.355),(42.195,167.205),(42.045,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,167.205),(42.365,167.355),(42.515,167.355),(42.515,167.205),(42.365,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,167.205),(42.685,167.355),(42.835,167.355),(42.835,167.205),(42.685,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,167.205),(43.005,167.355),(43.155,167.355),(43.155,167.205),(43.005,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,167.525),(42.045,167.675),(42.195,167.675),(42.195,167.525),(42.045,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,167.525),(42.365,167.675),(42.515,167.675),(42.515,167.525),(42.365,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,167.525),(42.685,167.675),(42.835,167.675),(42.835,167.525),(42.685,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,167.525),(43.005,167.675),(43.155,167.675),(43.155,167.525),(43.005,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,167.845),(42.045,167.995),(42.195,167.995),(42.195,167.845),(42.045,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,167.845),(42.365,167.995),(42.515,167.995),(42.515,167.845),(42.365,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,167.845),(42.685,167.995),(42.835,167.995),(42.835,167.845),(42.685,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,167.845),(43.005,167.995),(43.155,167.995),(43.155,167.845),(43.005,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,168.165),(42.045,168.315),(42.195,168.315),(42.195,168.165),(42.045,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,168.165),(42.365,168.315),(42.515,168.315),(42.515,168.165),(42.365,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,168.165),(42.685,168.315),(42.835,168.315),(42.835,168.165),(42.685,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,168.165),(43.005,168.315),(43.155,168.315),(43.155,168.165),(43.005,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,168.485),(42.045,168.635),(42.195,168.635),(42.195,168.485),(42.045,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,168.485),(42.365,168.635),(42.515,168.635),(42.515,168.485),(42.365,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,168.485),(42.685,168.635),(42.835,168.635),(42.835,168.485),(42.685,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,168.485),(43.005,168.635),(43.155,168.635),(43.155,168.485),(43.005,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,168.805),(42.045,168.955),(42.195,168.955),(42.195,168.805),(42.045,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,168.805),(42.365,168.955),(42.515,168.955),(42.515,168.805),(42.365,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,168.805),(42.685,168.955),(42.835,168.955),(42.835,168.805),(42.685,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,168.805),(43.005,168.955),(43.155,168.955),(43.155,168.805),(43.005,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,169.125),(42.045,169.275),(42.195,169.275),(42.195,169.125),(42.045,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,169.125),(42.365,169.275),(42.515,169.275),(42.515,169.125),(42.365,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,169.125),(42.685,169.275),(42.835,169.275),(42.835,169.125),(42.685,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,169.125),(43.005,169.275),(43.155,169.275),(43.155,169.125),(43.005,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,169.445),(42.045,169.595),(42.195,169.595),(42.195,169.445),(42.045,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,169.445),(42.365,169.595),(42.515,169.595),(42.515,169.445),(42.365,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,169.445),(42.685,169.595),(42.835,169.595),(42.835,169.445),(42.685,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,169.445),(43.005,169.595),(43.155,169.595),(43.155,169.445),(43.005,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,169.765),(42.045,169.915),(42.195,169.915),(42.195,169.765),(42.045,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,169.765),(42.365,169.915),(42.515,169.915),(42.515,169.765),(42.365,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,169.765),(42.685,169.915),(42.835,169.915),(42.835,169.765),(42.685,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,169.765),(43.005,169.915),(43.155,169.915),(43.155,169.765),(43.005,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,170.085),(42.045,170.235),(42.195,170.235),(42.195,170.085),(42.045,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,170.085),(42.365,170.235),(42.515,170.235),(42.515,170.085),(42.365,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,170.085),(42.685,170.235),(42.835,170.235),(42.835,170.085),(42.685,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,170.085),(43.005,170.235),(43.155,170.235),(43.155,170.085),(43.005,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,170.405),(42.045,170.555),(42.195,170.555),(42.195,170.405),(42.045,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,170.405),(42.365,170.555),(42.515,170.555),(42.515,170.405),(42.365,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,170.405),(42.685,170.555),(42.835,170.555),(42.835,170.405),(42.685,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,170.405),(43.005,170.555),(43.155,170.555),(43.155,170.405),(43.005,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,170.725),(42.045,170.875),(42.195,170.875),(42.195,170.725),(42.045,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,170.725),(42.365,170.875),(42.515,170.875),(42.515,170.725),(42.365,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,170.725),(42.685,170.875),(42.835,170.875),(42.835,170.725),(42.685,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,170.725),(43.005,170.875),(43.155,170.875),(43.155,170.725),(43.005,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,171.045),(42.045,171.195),(42.195,171.195),(42.195,171.045),(42.045,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,171.045),(42.365,171.195),(42.515,171.195),(42.515,171.045),(42.365,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,171.045),(42.685,171.195),(42.835,171.195),(42.835,171.045),(42.685,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,171.045),(43.005,171.195),(43.155,171.195),(43.155,171.045),(43.005,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,171.365),(42.045,171.515),(42.195,171.515),(42.195,171.365),(42.045,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,171.365),(42.365,171.515),(42.515,171.515),(42.515,171.365),(42.365,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,171.365),(42.685,171.515),(42.835,171.515),(42.835,171.365),(42.685,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,171.365),(43.005,171.515),(43.155,171.515),(43.155,171.365),(43.005,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,171.685),(42.045,171.835),(42.195,171.835),(42.195,171.685),(42.045,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,171.685),(42.365,171.835),(42.515,171.835),(42.515,171.685),(42.365,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,171.685),(42.685,171.835),(42.835,171.835),(42.835,171.685),(42.685,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,171.685),(43.005,171.835),(43.155,171.835),(43.155,171.685),(43.005,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,172.005),(42.045,172.155),(42.195,172.155),(42.195,172.005),(42.045,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,172.005),(42.365,172.155),(42.515,172.155),(42.515,172.005),(42.365,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,172.005),(42.685,172.155),(42.835,172.155),(42.835,172.005),(42.685,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,172.005),(43.005,172.155),(43.155,172.155),(43.155,172.005),(43.005,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,158.245),(51.645,158.395),(51.795,158.395),(51.795,158.245),(51.645,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,158.245),(51.965,158.395),(52.115,158.395),(52.115,158.245),(51.965,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,158.245),(52.285,158.395),(52.435,158.395),(52.435,158.245),(52.285,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,158.245),(52.605,158.395),(52.755,158.395),(52.755,158.245),(52.605,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,158.565),(51.645,158.715),(51.795,158.715),(51.795,158.565),(51.645,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,158.565),(51.965,158.715),(52.115,158.715),(52.115,158.565),(51.965,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,158.565),(52.285,158.715),(52.435,158.715),(52.435,158.565),(52.285,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,158.565),(52.605,158.715),(52.755,158.715),(52.755,158.565),(52.605,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,158.885),(51.645,159.035),(51.795,159.035),(51.795,158.885),(51.645,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,158.885),(51.965,159.035),(52.115,159.035),(52.115,158.885),(51.965,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,158.885),(52.285,159.035),(52.435,159.035),(52.435,158.885),(52.285,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,158.885),(52.605,159.035),(52.755,159.035),(52.755,158.885),(52.605,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,159.205),(51.645,159.355),(51.795,159.355),(51.795,159.205),(51.645,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,159.205),(51.965,159.355),(52.115,159.355),(52.115,159.205),(51.965,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,159.205),(52.285,159.355),(52.435,159.355),(52.435,159.205),(52.285,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,159.205),(52.605,159.355),(52.755,159.355),(52.755,159.205),(52.605,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,159.525),(51.645,159.675),(51.795,159.675),(51.795,159.525),(51.645,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,159.525),(51.965,159.675),(52.115,159.675),(52.115,159.525),(51.965,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,159.525),(52.285,159.675),(52.435,159.675),(52.435,159.525),(52.285,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,159.525),(52.605,159.675),(52.755,159.675),(52.755,159.525),(52.605,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,159.845),(51.645,159.995),(51.795,159.995),(51.795,159.845),(51.645,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,159.845),(51.965,159.995),(52.115,159.995),(52.115,159.845),(51.965,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,159.845),(52.285,159.995),(52.435,159.995),(52.435,159.845),(52.285,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,159.845),(52.605,159.995),(52.755,159.995),(52.755,159.845),(52.605,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,160.165),(51.645,160.315),(51.795,160.315),(51.795,160.165),(51.645,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,160.165),(51.965,160.315),(52.115,160.315),(52.115,160.165),(51.965,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,160.165),(52.285,160.315),(52.435,160.315),(52.435,160.165),(52.285,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,160.165),(52.605,160.315),(52.755,160.315),(52.755,160.165),(52.605,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,160.485),(51.645,160.635),(51.795,160.635),(51.795,160.485),(51.645,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,160.485),(51.965,160.635),(52.115,160.635),(52.115,160.485),(51.965,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,160.485),(52.285,160.635),(52.435,160.635),(52.435,160.485),(52.285,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,160.485),(52.605,160.635),(52.755,160.635),(52.755,160.485),(52.605,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,160.805),(51.645,160.955),(51.795,160.955),(51.795,160.805),(51.645,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,160.805),(51.965,160.955),(52.115,160.955),(52.115,160.805),(51.965,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,160.805),(52.285,160.955),(52.435,160.955),(52.435,160.805),(52.285,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,160.805),(52.605,160.955),(52.755,160.955),(52.755,160.805),(52.605,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,161.125),(51.645,161.275),(51.795,161.275),(51.795,161.125),(51.645,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,161.125),(51.965,161.275),(52.115,161.275),(52.115,161.125),(51.965,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,161.125),(52.285,161.275),(52.435,161.275),(52.435,161.125),(52.285,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,161.125),(52.605,161.275),(52.755,161.275),(52.755,161.125),(52.605,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,161.445),(51.645,161.595),(51.795,161.595),(51.795,161.445),(51.645,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,161.445),(51.965,161.595),(52.115,161.595),(52.115,161.445),(51.965,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,161.445),(52.285,161.595),(52.435,161.595),(52.435,161.445),(52.285,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,161.445),(52.605,161.595),(52.755,161.595),(52.755,161.445),(52.605,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,161.765),(51.645,161.915),(51.795,161.915),(51.795,161.765),(51.645,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,161.765),(51.965,161.915),(52.115,161.915),(52.115,161.765),(51.965,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,161.765),(52.285,161.915),(52.435,161.915),(52.435,161.765),(52.285,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,161.765),(52.605,161.915),(52.755,161.915),(52.755,161.765),(52.605,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,162.085),(51.645,162.235),(51.795,162.235),(51.795,162.085),(51.645,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,162.085),(51.965,162.235),(52.115,162.235),(52.115,162.085),(51.965,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,162.085),(52.285,162.235),(52.435,162.235),(52.435,162.085),(52.285,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,162.085),(52.605,162.235),(52.755,162.235),(52.755,162.085),(52.605,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,162.405),(51.645,162.555),(51.795,162.555),(51.795,162.405),(51.645,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,162.405),(51.965,162.555),(52.115,162.555),(52.115,162.405),(51.965,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,162.405),(52.285,162.555),(52.435,162.555),(52.435,162.405),(52.285,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,162.405),(52.605,162.555),(52.755,162.555),(52.755,162.405),(52.605,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,162.725),(51.645,162.875),(51.795,162.875),(51.795,162.725),(51.645,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,162.725),(51.965,162.875),(52.115,162.875),(52.115,162.725),(51.965,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,162.725),(52.285,162.875),(52.435,162.875),(52.435,162.725),(52.285,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,162.725),(52.605,162.875),(52.755,162.875),(52.755,162.725),(52.605,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,163.045),(51.645,163.195),(51.795,163.195),(51.795,163.045),(51.645,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,163.045),(51.965,163.195),(52.115,163.195),(52.115,163.045),(51.965,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,163.045),(52.285,163.195),(52.435,163.195),(52.435,163.045),(52.285,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,163.045),(52.605,163.195),(52.755,163.195),(52.755,163.045),(52.605,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,163.365),(51.645,163.515),(51.795,163.515),(51.795,163.365),(51.645,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,163.365),(51.965,163.515),(52.115,163.515),(52.115,163.365),(51.965,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,163.365),(52.285,163.515),(52.435,163.515),(52.435,163.365),(52.285,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,163.365),(52.605,163.515),(52.755,163.515),(52.755,163.365),(52.605,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,163.685),(51.645,163.835),(51.795,163.835),(51.795,163.685),(51.645,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,163.685),(51.965,163.835),(52.115,163.835),(52.115,163.685),(51.965,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,163.685),(52.285,163.835),(52.435,163.835),(52.435,163.685),(52.285,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,163.685),(52.605,163.835),(52.755,163.835),(52.755,163.685),(52.605,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,164.005),(51.645,164.155),(51.795,164.155),(51.795,164.005),(51.645,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,164.005),(51.965,164.155),(52.115,164.155),(52.115,164.005),(51.965,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,164.005),(52.285,164.155),(52.435,164.155),(52.435,164.005),(52.285,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,164.005),(52.605,164.155),(52.755,164.155),(52.755,164.005),(52.605,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,164.325),(51.645,164.475),(51.795,164.475),(51.795,164.325),(51.645,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,164.325),(51.965,164.475),(52.115,164.475),(52.115,164.325),(51.965,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,164.325),(52.285,164.475),(52.435,164.475),(52.435,164.325),(52.285,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,164.325),(52.605,164.475),(52.755,164.475),(52.755,164.325),(52.605,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,164.645),(51.645,164.795),(51.795,164.795),(51.795,164.645),(51.645,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,164.645),(51.965,164.795),(52.115,164.795),(52.115,164.645),(51.965,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,164.645),(52.285,164.795),(52.435,164.795),(52.435,164.645),(52.285,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,164.645),(52.605,164.795),(52.755,164.795),(52.755,164.645),(52.605,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,164.965),(51.645,165.115),(51.795,165.115),(51.795,164.965),(51.645,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,164.965),(51.965,165.115),(52.115,165.115),(52.115,164.965),(51.965,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,164.965),(52.285,165.115),(52.435,165.115),(52.435,164.965),(52.285,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,164.965),(52.605,165.115),(52.755,165.115),(52.755,164.965),(52.605,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,165.285),(51.645,165.435),(51.795,165.435),(51.795,165.285),(51.645,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,165.285),(51.965,165.435),(52.115,165.435),(52.115,165.285),(51.965,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,165.285),(52.285,165.435),(52.435,165.435),(52.435,165.285),(52.285,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,165.285),(52.605,165.435),(52.755,165.435),(52.755,165.285),(52.605,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,165.605),(51.645,165.755),(51.795,165.755),(51.795,165.605),(51.645,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,165.605),(51.965,165.755),(52.115,165.755),(52.115,165.605),(51.965,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,165.605),(52.285,165.755),(52.435,165.755),(52.435,165.605),(52.285,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,165.605),(52.605,165.755),(52.755,165.755),(52.755,165.605),(52.605,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,165.925),(51.645,166.075),(51.795,166.075),(51.795,165.925),(51.645,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,165.925),(51.965,166.075),(52.115,166.075),(52.115,165.925),(51.965,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,165.925),(52.285,166.075),(52.435,166.075),(52.435,165.925),(52.285,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,165.925),(52.605,166.075),(52.755,166.075),(52.755,165.925),(52.605,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,166.245),(51.645,166.395),(51.795,166.395),(51.795,166.245),(51.645,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,166.245),(51.965,166.395),(52.115,166.395),(52.115,166.245),(51.965,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,166.245),(52.285,166.395),(52.435,166.395),(52.435,166.245),(52.285,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,166.245),(52.605,166.395),(52.755,166.395),(52.755,166.245),(52.605,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,166.565),(51.645,166.715),(51.795,166.715),(51.795,166.565),(51.645,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,166.565),(51.965,166.715),(52.115,166.715),(52.115,166.565),(51.965,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,166.565),(52.285,166.715),(52.435,166.715),(52.435,166.565),(52.285,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,166.565),(52.605,166.715),(52.755,166.715),(52.755,166.565),(52.605,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,166.885),(51.645,167.035),(51.795,167.035),(51.795,166.885),(51.645,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,166.885),(51.965,167.035),(52.115,167.035),(52.115,166.885),(51.965,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,166.885),(52.285,167.035),(52.435,167.035),(52.435,166.885),(52.285,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,166.885),(52.605,167.035),(52.755,167.035),(52.755,166.885),(52.605,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,167.205),(51.645,167.355),(51.795,167.355),(51.795,167.205),(51.645,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,167.205),(51.965,167.355),(52.115,167.355),(52.115,167.205),(51.965,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,167.205),(52.285,167.355),(52.435,167.355),(52.435,167.205),(52.285,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,167.205),(52.605,167.355),(52.755,167.355),(52.755,167.205),(52.605,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,167.525),(51.645,167.675),(51.795,167.675),(51.795,167.525),(51.645,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,167.525),(51.965,167.675),(52.115,167.675),(52.115,167.525),(51.965,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,167.525),(52.285,167.675),(52.435,167.675),(52.435,167.525),(52.285,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,167.525),(52.605,167.675),(52.755,167.675),(52.755,167.525),(52.605,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,167.845),(51.645,167.995),(51.795,167.995),(51.795,167.845),(51.645,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,167.845),(51.965,167.995),(52.115,167.995),(52.115,167.845),(51.965,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,167.845),(52.285,167.995),(52.435,167.995),(52.435,167.845),(52.285,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,167.845),(52.605,167.995),(52.755,167.995),(52.755,167.845),(52.605,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,168.165),(51.645,168.315),(51.795,168.315),(51.795,168.165),(51.645,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,168.165),(51.965,168.315),(52.115,168.315),(52.115,168.165),(51.965,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,168.165),(52.285,168.315),(52.435,168.315),(52.435,168.165),(52.285,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,168.165),(52.605,168.315),(52.755,168.315),(52.755,168.165),(52.605,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,168.485),(51.645,168.635),(51.795,168.635),(51.795,168.485),(51.645,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,168.485),(51.965,168.635),(52.115,168.635),(52.115,168.485),(51.965,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,168.485),(52.285,168.635),(52.435,168.635),(52.435,168.485),(52.285,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,168.485),(52.605,168.635),(52.755,168.635),(52.755,168.485),(52.605,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,168.805),(51.645,168.955),(51.795,168.955),(51.795,168.805),(51.645,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,168.805),(51.965,168.955),(52.115,168.955),(52.115,168.805),(51.965,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,168.805),(52.285,168.955),(52.435,168.955),(52.435,168.805),(52.285,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,168.805),(52.605,168.955),(52.755,168.955),(52.755,168.805),(52.605,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,169.125),(51.645,169.275),(51.795,169.275),(51.795,169.125),(51.645,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,169.125),(51.965,169.275),(52.115,169.275),(52.115,169.125),(51.965,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,169.125),(52.285,169.275),(52.435,169.275),(52.435,169.125),(52.285,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,169.125),(52.605,169.275),(52.755,169.275),(52.755,169.125),(52.605,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,169.445),(51.645,169.595),(51.795,169.595),(51.795,169.445),(51.645,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,169.445),(51.965,169.595),(52.115,169.595),(52.115,169.445),(51.965,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,169.445),(52.285,169.595),(52.435,169.595),(52.435,169.445),(52.285,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,169.445),(52.605,169.595),(52.755,169.595),(52.755,169.445),(52.605,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,169.765),(51.645,169.915),(51.795,169.915),(51.795,169.765),(51.645,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,169.765),(51.965,169.915),(52.115,169.915),(52.115,169.765),(51.965,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,169.765),(52.285,169.915),(52.435,169.915),(52.435,169.765),(52.285,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,169.765),(52.605,169.915),(52.755,169.915),(52.755,169.765),(52.605,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,170.085),(51.645,170.235),(51.795,170.235),(51.795,170.085),(51.645,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,170.085),(51.965,170.235),(52.115,170.235),(52.115,170.085),(51.965,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,170.085),(52.285,170.235),(52.435,170.235),(52.435,170.085),(52.285,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,170.085),(52.605,170.235),(52.755,170.235),(52.755,170.085),(52.605,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,170.405),(51.645,170.555),(51.795,170.555),(51.795,170.405),(51.645,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,170.405),(51.965,170.555),(52.115,170.555),(52.115,170.405),(51.965,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,170.405),(52.285,170.555),(52.435,170.555),(52.435,170.405),(52.285,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,170.405),(52.605,170.555),(52.755,170.555),(52.755,170.405),(52.605,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,170.725),(51.645,170.875),(51.795,170.875),(51.795,170.725),(51.645,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,170.725),(51.965,170.875),(52.115,170.875),(52.115,170.725),(51.965,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,170.725),(52.285,170.875),(52.435,170.875),(52.435,170.725),(52.285,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,170.725),(52.605,170.875),(52.755,170.875),(52.755,170.725),(52.605,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,171.045),(51.645,171.195),(51.795,171.195),(51.795,171.045),(51.645,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,171.045),(51.965,171.195),(52.115,171.195),(52.115,171.045),(51.965,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,171.045),(52.285,171.195),(52.435,171.195),(52.435,171.045),(52.285,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,171.045),(52.605,171.195),(52.755,171.195),(52.755,171.045),(52.605,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,171.365),(51.645,171.515),(51.795,171.515),(51.795,171.365),(51.645,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,171.365),(51.965,171.515),(52.115,171.515),(52.115,171.365),(51.965,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,171.365),(52.285,171.515),(52.435,171.515),(52.435,171.365),(52.285,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,171.365),(52.605,171.515),(52.755,171.515),(52.755,171.365),(52.605,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,171.685),(51.645,171.835),(51.795,171.835),(51.795,171.685),(51.645,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,171.685),(51.965,171.835),(52.115,171.835),(52.115,171.685),(51.965,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,171.685),(52.285,171.835),(52.435,171.835),(52.435,171.685),(52.285,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,171.685),(52.605,171.835),(52.755,171.835),(52.755,171.685),(52.605,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,172.005),(51.645,172.155),(51.795,172.155),(51.795,172.005),(51.645,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,172.005),(51.965,172.155),(52.115,172.155),(52.115,172.005),(51.965,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,172.005),(52.285,172.155),(52.435,172.155),(52.435,172.005),(52.285,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,172.005),(52.605,172.155),(52.755,172.155),(52.755,172.005),(52.605,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,158.245),(46.845,158.395),(46.995,158.395),(46.995,158.245),(46.845,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,158.245),(47.165,158.395),(47.315,158.395),(47.315,158.245),(47.165,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,158.245),(47.485,158.395),(47.635,158.395),(47.635,158.245),(47.485,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,158.245),(47.805,158.395),(47.955,158.395),(47.955,158.245),(47.805,158.245)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,158.565),(46.845,158.715),(46.995,158.715),(46.995,158.565),(46.845,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,158.565),(47.165,158.715),(47.315,158.715),(47.315,158.565),(47.165,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,158.565),(47.485,158.715),(47.635,158.715),(47.635,158.565),(47.485,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,158.565),(47.805,158.715),(47.955,158.715),(47.955,158.565),(47.805,158.565)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,158.885),(46.845,159.035),(46.995,159.035),(46.995,158.885),(46.845,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,158.885),(47.165,159.035),(47.315,159.035),(47.315,158.885),(47.165,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,158.885),(47.485,159.035),(47.635,159.035),(47.635,158.885),(47.485,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,158.885),(47.805,159.035),(47.955,159.035),(47.955,158.885),(47.805,158.885)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,159.205),(46.845,159.355),(46.995,159.355),(46.995,159.205),(46.845,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,159.205),(47.165,159.355),(47.315,159.355),(47.315,159.205),(47.165,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,159.205),(47.485,159.355),(47.635,159.355),(47.635,159.205),(47.485,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,159.205),(47.805,159.355),(47.955,159.355),(47.955,159.205),(47.805,159.205)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,159.525),(46.845,159.675),(46.995,159.675),(46.995,159.525),(46.845,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,159.525),(47.165,159.675),(47.315,159.675),(47.315,159.525),(47.165,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,159.525),(47.485,159.675),(47.635,159.675),(47.635,159.525),(47.485,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,159.525),(47.805,159.675),(47.955,159.675),(47.955,159.525),(47.805,159.525)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,159.845),(46.845,159.995),(46.995,159.995),(46.995,159.845),(46.845,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,159.845),(47.165,159.995),(47.315,159.995),(47.315,159.845),(47.165,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,159.845),(47.485,159.995),(47.635,159.995),(47.635,159.845),(47.485,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,159.845),(47.805,159.995),(47.955,159.995),(47.955,159.845),(47.805,159.845)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,160.165),(46.845,160.315),(46.995,160.315),(46.995,160.165),(46.845,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,160.165),(47.165,160.315),(47.315,160.315),(47.315,160.165),(47.165,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,160.165),(47.485,160.315),(47.635,160.315),(47.635,160.165),(47.485,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,160.165),(47.805,160.315),(47.955,160.315),(47.955,160.165),(47.805,160.165)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,160.485),(46.845,160.635),(46.995,160.635),(46.995,160.485),(46.845,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,160.485),(47.165,160.635),(47.315,160.635),(47.315,160.485),(47.165,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,160.485),(47.485,160.635),(47.635,160.635),(47.635,160.485),(47.485,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,160.485),(47.805,160.635),(47.955,160.635),(47.955,160.485),(47.805,160.485)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,160.805),(46.845,160.955),(46.995,160.955),(46.995,160.805),(46.845,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,160.805),(47.165,160.955),(47.315,160.955),(47.315,160.805),(47.165,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,160.805),(47.485,160.955),(47.635,160.955),(47.635,160.805),(47.485,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,160.805),(47.805,160.955),(47.955,160.955),(47.955,160.805),(47.805,160.805)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,161.125),(46.845,161.275),(46.995,161.275),(46.995,161.125),(46.845,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,161.125),(47.165,161.275),(47.315,161.275),(47.315,161.125),(47.165,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,161.125),(47.485,161.275),(47.635,161.275),(47.635,161.125),(47.485,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,161.125),(47.805,161.275),(47.955,161.275),(47.955,161.125),(47.805,161.125)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,161.445),(46.845,161.595),(46.995,161.595),(46.995,161.445),(46.845,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,161.445),(47.165,161.595),(47.315,161.595),(47.315,161.445),(47.165,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,161.445),(47.485,161.595),(47.635,161.595),(47.635,161.445),(47.485,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,161.445),(47.805,161.595),(47.955,161.595),(47.955,161.445),(47.805,161.445)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,161.765),(46.845,161.915),(46.995,161.915),(46.995,161.765),(46.845,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,161.765),(47.165,161.915),(47.315,161.915),(47.315,161.765),(47.165,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,161.765),(47.485,161.915),(47.635,161.915),(47.635,161.765),(47.485,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,161.765),(47.805,161.915),(47.955,161.915),(47.955,161.765),(47.805,161.765)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,162.085),(46.845,162.235),(46.995,162.235),(46.995,162.085),(46.845,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,162.085),(47.165,162.235),(47.315,162.235),(47.315,162.085),(47.165,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,162.085),(47.485,162.235),(47.635,162.235),(47.635,162.085),(47.485,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,162.085),(47.805,162.235),(47.955,162.235),(47.955,162.085),(47.805,162.085)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,162.405),(46.845,162.555),(46.995,162.555),(46.995,162.405),(46.845,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,162.405),(47.165,162.555),(47.315,162.555),(47.315,162.405),(47.165,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,162.405),(47.485,162.555),(47.635,162.555),(47.635,162.405),(47.485,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,162.405),(47.805,162.555),(47.955,162.555),(47.955,162.405),(47.805,162.405)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,162.725),(46.845,162.875),(46.995,162.875),(46.995,162.725),(46.845,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,162.725),(47.165,162.875),(47.315,162.875),(47.315,162.725),(47.165,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,162.725),(47.485,162.875),(47.635,162.875),(47.635,162.725),(47.485,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,162.725),(47.805,162.875),(47.955,162.875),(47.955,162.725),(47.805,162.725)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,163.045),(46.845,163.195),(46.995,163.195),(46.995,163.045),(46.845,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,163.045),(47.165,163.195),(47.315,163.195),(47.315,163.045),(47.165,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,163.045),(47.485,163.195),(47.635,163.195),(47.635,163.045),(47.485,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,163.045),(47.805,163.195),(47.955,163.195),(47.955,163.045),(47.805,163.045)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,163.365),(46.845,163.515),(46.995,163.515),(46.995,163.365),(46.845,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,163.365),(47.165,163.515),(47.315,163.515),(47.315,163.365),(47.165,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,163.365),(47.485,163.515),(47.635,163.515),(47.635,163.365),(47.485,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,163.365),(47.805,163.515),(47.955,163.515),(47.955,163.365),(47.805,163.365)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,163.685),(46.845,163.835),(46.995,163.835),(46.995,163.685),(46.845,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,163.685),(47.165,163.835),(47.315,163.835),(47.315,163.685),(47.165,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,163.685),(47.485,163.835),(47.635,163.835),(47.635,163.685),(47.485,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,163.685),(47.805,163.835),(47.955,163.835),(47.955,163.685),(47.805,163.685)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,164.005),(46.845,164.155),(46.995,164.155),(46.995,164.005),(46.845,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,164.005),(47.165,164.155),(47.315,164.155),(47.315,164.005),(47.165,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,164.005),(47.485,164.155),(47.635,164.155),(47.635,164.005),(47.485,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,164.005),(47.805,164.155),(47.955,164.155),(47.955,164.005),(47.805,164.005)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,164.325),(46.845,164.475),(46.995,164.475),(46.995,164.325),(46.845,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,164.325),(47.165,164.475),(47.315,164.475),(47.315,164.325),(47.165,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,164.325),(47.485,164.475),(47.635,164.475),(47.635,164.325),(47.485,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,164.325),(47.805,164.475),(47.955,164.475),(47.955,164.325),(47.805,164.325)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,164.645),(46.845,164.795),(46.995,164.795),(46.995,164.645),(46.845,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,164.645),(47.165,164.795),(47.315,164.795),(47.315,164.645),(47.165,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,164.645),(47.485,164.795),(47.635,164.795),(47.635,164.645),(47.485,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,164.645),(47.805,164.795),(47.955,164.795),(47.955,164.645),(47.805,164.645)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,164.965),(46.845,165.115),(46.995,165.115),(46.995,164.965),(46.845,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,164.965),(47.165,165.115),(47.315,165.115),(47.315,164.965),(47.165,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,164.965),(47.485,165.115),(47.635,165.115),(47.635,164.965),(47.485,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,164.965),(47.805,165.115),(47.955,165.115),(47.955,164.965),(47.805,164.965)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,165.285),(46.845,165.435),(46.995,165.435),(46.995,165.285),(46.845,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,165.285),(47.165,165.435),(47.315,165.435),(47.315,165.285),(47.165,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,165.285),(47.485,165.435),(47.635,165.435),(47.635,165.285),(47.485,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,165.285),(47.805,165.435),(47.955,165.435),(47.955,165.285),(47.805,165.285)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,165.605),(46.845,165.755),(46.995,165.755),(46.995,165.605),(46.845,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,165.605),(47.165,165.755),(47.315,165.755),(47.315,165.605),(47.165,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,165.605),(47.485,165.755),(47.635,165.755),(47.635,165.605),(47.485,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,165.605),(47.805,165.755),(47.955,165.755),(47.955,165.605),(47.805,165.605)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,165.925),(46.845,166.075),(46.995,166.075),(46.995,165.925),(46.845,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,165.925),(47.165,166.075),(47.315,166.075),(47.315,165.925),(47.165,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,165.925),(47.485,166.075),(47.635,166.075),(47.635,165.925),(47.485,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,165.925),(47.805,166.075),(47.955,166.075),(47.955,165.925),(47.805,165.925)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,166.245),(46.845,166.395),(46.995,166.395),(46.995,166.245),(46.845,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,166.245),(47.165,166.395),(47.315,166.395),(47.315,166.245),(47.165,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,166.245),(47.485,166.395),(47.635,166.395),(47.635,166.245),(47.485,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,166.245),(47.805,166.395),(47.955,166.395),(47.955,166.245),(47.805,166.245)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,166.565),(46.845,166.715),(46.995,166.715),(46.995,166.565),(46.845,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,166.565),(47.165,166.715),(47.315,166.715),(47.315,166.565),(47.165,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,166.565),(47.485,166.715),(47.635,166.715),(47.635,166.565),(47.485,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,166.565),(47.805,166.715),(47.955,166.715),(47.955,166.565),(47.805,166.565)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,166.885),(46.845,167.035),(46.995,167.035),(46.995,166.885),(46.845,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,166.885),(47.165,167.035),(47.315,167.035),(47.315,166.885),(47.165,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,166.885),(47.485,167.035),(47.635,167.035),(47.635,166.885),(47.485,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,166.885),(47.805,167.035),(47.955,167.035),(47.955,166.885),(47.805,166.885)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,167.205),(46.845,167.355),(46.995,167.355),(46.995,167.205),(46.845,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,167.205),(47.165,167.355),(47.315,167.355),(47.315,167.205),(47.165,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,167.205),(47.485,167.355),(47.635,167.355),(47.635,167.205),(47.485,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,167.205),(47.805,167.355),(47.955,167.355),(47.955,167.205),(47.805,167.205)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,167.525),(46.845,167.675),(46.995,167.675),(46.995,167.525),(46.845,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,167.525),(47.165,167.675),(47.315,167.675),(47.315,167.525),(47.165,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,167.525),(47.485,167.675),(47.635,167.675),(47.635,167.525),(47.485,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,167.525),(47.805,167.675),(47.955,167.675),(47.955,167.525),(47.805,167.525)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,167.845),(46.845,167.995),(46.995,167.995),(46.995,167.845),(46.845,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,167.845),(47.165,167.995),(47.315,167.995),(47.315,167.845),(47.165,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,167.845),(47.485,167.995),(47.635,167.995),(47.635,167.845),(47.485,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,167.845),(47.805,167.995),(47.955,167.995),(47.955,167.845),(47.805,167.845)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,168.165),(46.845,168.315),(46.995,168.315),(46.995,168.165),(46.845,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,168.165),(47.165,168.315),(47.315,168.315),(47.315,168.165),(47.165,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,168.165),(47.485,168.315),(47.635,168.315),(47.635,168.165),(47.485,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,168.165),(47.805,168.315),(47.955,168.315),(47.955,168.165),(47.805,168.165)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,168.485),(46.845,168.635),(46.995,168.635),(46.995,168.485),(46.845,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,168.485),(47.165,168.635),(47.315,168.635),(47.315,168.485),(47.165,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,168.485),(47.485,168.635),(47.635,168.635),(47.635,168.485),(47.485,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,168.485),(47.805,168.635),(47.955,168.635),(47.955,168.485),(47.805,168.485)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,168.805),(46.845,168.955),(46.995,168.955),(46.995,168.805),(46.845,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,168.805),(47.165,168.955),(47.315,168.955),(47.315,168.805),(47.165,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,168.805),(47.485,168.955),(47.635,168.955),(47.635,168.805),(47.485,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,168.805),(47.805,168.955),(47.955,168.955),(47.955,168.805),(47.805,168.805)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,169.125),(46.845,169.275),(46.995,169.275),(46.995,169.125),(46.845,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,169.125),(47.165,169.275),(47.315,169.275),(47.315,169.125),(47.165,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,169.125),(47.485,169.275),(47.635,169.275),(47.635,169.125),(47.485,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,169.125),(47.805,169.275),(47.955,169.275),(47.955,169.125),(47.805,169.125)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,169.445),(46.845,169.595),(46.995,169.595),(46.995,169.445),(46.845,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,169.445),(47.165,169.595),(47.315,169.595),(47.315,169.445),(47.165,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,169.445),(47.485,169.595),(47.635,169.595),(47.635,169.445),(47.485,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,169.445),(47.805,169.595),(47.955,169.595),(47.955,169.445),(47.805,169.445)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,169.765),(46.845,169.915),(46.995,169.915),(46.995,169.765),(46.845,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,169.765),(47.165,169.915),(47.315,169.915),(47.315,169.765),(47.165,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,169.765),(47.485,169.915),(47.635,169.915),(47.635,169.765),(47.485,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,169.765),(47.805,169.915),(47.955,169.915),(47.955,169.765),(47.805,169.765)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,170.085),(46.845,170.235),(46.995,170.235),(46.995,170.085),(46.845,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,170.085),(47.165,170.235),(47.315,170.235),(47.315,170.085),(47.165,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,170.085),(47.485,170.235),(47.635,170.235),(47.635,170.085),(47.485,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,170.085),(47.805,170.235),(47.955,170.235),(47.955,170.085),(47.805,170.085)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,170.405),(46.845,170.555),(46.995,170.555),(46.995,170.405),(46.845,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,170.405),(47.165,170.555),(47.315,170.555),(47.315,170.405),(47.165,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,170.405),(47.485,170.555),(47.635,170.555),(47.635,170.405),(47.485,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,170.405),(47.805,170.555),(47.955,170.555),(47.955,170.405),(47.805,170.405)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,170.725),(46.845,170.875),(46.995,170.875),(46.995,170.725),(46.845,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,170.725),(47.165,170.875),(47.315,170.875),(47.315,170.725),(47.165,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,170.725),(47.485,170.875),(47.635,170.875),(47.635,170.725),(47.485,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,170.725),(47.805,170.875),(47.955,170.875),(47.955,170.725),(47.805,170.725)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,171.045),(46.845,171.195),(46.995,171.195),(46.995,171.045),(46.845,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,171.045),(47.165,171.195),(47.315,171.195),(47.315,171.045),(47.165,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,171.045),(47.485,171.195),(47.635,171.195),(47.635,171.045),(47.485,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,171.045),(47.805,171.195),(47.955,171.195),(47.955,171.045),(47.805,171.045)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,171.365),(46.845,171.515),(46.995,171.515),(46.995,171.365),(46.845,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,171.365),(47.165,171.515),(47.315,171.515),(47.315,171.365),(47.165,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,171.365),(47.485,171.515),(47.635,171.515),(47.635,171.365),(47.485,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,171.365),(47.805,171.515),(47.955,171.515),(47.955,171.365),(47.805,171.365)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,171.685),(46.845,171.835),(46.995,171.835),(46.995,171.685),(46.845,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,171.685),(47.165,171.835),(47.315,171.835),(47.315,171.685),(47.165,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,171.685),(47.485,171.835),(47.635,171.835),(47.635,171.685),(47.485,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,171.685),(47.805,171.835),(47.955,171.835),(47.955,171.685),(47.805,171.685)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,172.005),(46.845,172.155),(46.995,172.155),(46.995,172.005),(46.845,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,172.005),(47.165,172.155),(47.315,172.155),(47.315,172.005),(47.165,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,172.005),(47.485,172.155),(47.635,172.155),(47.635,172.005),(47.485,172.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,172.005),(47.805,172.155),(47.955,172.155),(47.955,172.005),(47.805,172.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N0D']
        except:
            subcell = af.getCell('Clamp_N32N0D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N0D']
        except:
            subcell = af.getCell('Clamp_P32N0D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Pad_15800W12000H']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-40.5), u(-31.0), u(40.5), u(31.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['pad']
        createRL(
            tech, net, 'm5',
            ((-40.5,-31.0),(-40.5,31.0),(40.5,31.0),(40.5,-31.0),(-40.5,-31.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(0.0), u(62.0), u(-40.5), u(40.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(0.0), u(62.0), u(-40.5), u(40.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'pad',
            ((-39.5,-30.0),(-39.5,30.0),(39.5,30.0),(39.5,-30.0),(-39.5,-30.0)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-6.475),(12.725,-6.325),(12.875,-6.325),(12.875,-6.475),(12.725,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,6.325),(12.725,6.475),(12.875,6.475),(12.875,6.325),(12.725,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-3.275),(-1.675,-3.125),(-1.525,-3.125),(-1.525,-3.275),(-1.675,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,3.125),(1.525,3.275),(1.675,3.275),(1.675,3.125),(1.525,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-9.675),(23.925,-9.525),(24.075,-9.525),(24.075,-9.675),(23.925,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,11.125),(23.925,11.275),(24.075,11.275),(24.075,11.125),(23.925,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,6.325),(-19.275,6.475),(-19.125,6.475),(-19.125,6.325),(-19.275,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-20.875),(-17.675,-20.725),(-17.525,-20.725),(-17.525,-20.875),(-17.675,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-20.875),(17.525,-20.725),(17.675,-20.725),(17.675,-20.875),(17.525,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,6.325),(19.125,6.475),(19.275,6.475),(19.275,6.325),(19.125,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,11.125),(-8.075,11.275),(-7.925,11.275),(-7.925,11.125),(-8.075,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-11.275),(-16.075,-11.125),(-15.925,-11.125),(-15.925,-11.275),(-16.075,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-12.875),(-20.875,-12.725),(-20.725,-12.725),(-20.725,-12.875),(-20.875,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,12.725),(20.725,12.875),(20.875,12.875),(20.875,12.725),(20.725,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-19.275),(-22.475,-19.125),(-22.325,-19.125),(-22.325,-19.275),(-22.475,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,7.925),(-22.475,8.075),(-22.325,8.075),(-22.325,7.925),(-22.475,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,15.925),(11.125,16.075),(11.275,16.075),(11.275,15.925),(11.125,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,19.125),(-22.475,19.275),(-22.325,19.275),(-22.325,19.125),(-22.475,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,1.525),(-8.075,1.675),(-7.925,1.675),(-7.925,1.525),(-8.075,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,3.125),(-27.275,3.275),(-27.125,3.275),(-27.125,3.125),(-27.275,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-1.675),(-30.475,-1.525),(-30.325,-1.525),(-30.325,-1.675),(-30.475,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,1.525),(-30.475,1.675),(-30.325,1.675),(-30.325,1.525),(-30.475,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-3.275),(27.125,-3.125),(27.275,-3.125),(27.275,-3.275),(27.125,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-6.475),(31.925,-6.325),(32.075,-6.325),(32.075,-6.475),(31.925,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-3.275),(14.325,-3.125),(14.475,-3.125),(14.475,-3.275),(14.325,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,3.125),(14.325,3.275),(14.475,3.275),(14.475,3.125),(14.325,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-17.675),(-1.675,-17.525),(-1.525,-17.525),(-1.525,-17.675),(-1.675,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,17.525),(1.525,17.675),(1.675,17.675),(1.675,17.525),(1.525,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,4.725),(31.925,4.875),(32.075,4.875),(32.075,4.725),(31.925,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,7.925),(20.725,8.075),(20.875,8.075),(20.875,7.925),(20.725,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,11.125),(-1.675,11.275),(-1.525,11.275),(-1.525,11.125),(-1.675,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-11.275),(1.525,-11.125),(1.675,-11.125),(1.675,-11.275),(1.525,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-17.675),(23.925,-17.525),(24.075,-17.525),(24.075,-17.675),(23.925,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-8.075),(7.925,-7.925),(8.075,-7.925),(8.075,-8.075),(7.925,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-4.875),(-11.275,-4.725),(-11.125,-4.725),(-11.125,-4.875),(-11.275,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-25.675),(-16.075,-25.525),(-15.925,-25.525),(-15.925,-25.675),(-16.075,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-4.875),(11.125,-4.725),(11.275,-4.725),(11.275,-4.875),(11.125,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-8.075),(-22.475,-7.925),(-22.325,-7.925),(-22.325,-8.075),(-22.475,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-12.875),(-8.075,-12.725),(-7.925,-12.725),(-7.925,-12.875),(-8.075,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-8.075),(22.325,-7.925),(22.475,-7.925),(22.475,-8.075),(22.325,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-1.675),(-17.675,-1.525),(-17.525,-1.525),(-17.525,-1.675),(-17.675,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,1.525),(17.525,1.675),(17.675,1.675),(17.675,1.525),(17.525,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-16.075),(-25.675,-15.925),(-25.525,-15.925),(-25.525,-16.075),(-25.675,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,20.725),(-11.275,20.875),(-11.125,20.875),(-11.125,20.725),(-11.275,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,20.725),(11.125,20.875),(11.275,20.875),(11.275,20.725),(11.125,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-16.075),(25.525,-15.925),(25.675,-15.925),(25.675,-16.075),(25.525,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,4.725),(-1.675,4.875),(-1.525,4.875),(-1.525,4.725),(-1.675,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,4.725),(1.525,4.875),(1.675,4.875),(1.675,4.725),(1.525,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,4.725),(-4.875,4.875),(-4.725,4.875),(-4.725,4.725),(-4.875,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-4.875),(4.725,-4.725),(4.875,-4.725),(4.875,-4.875),(4.725,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,4.725),(-22.475,4.875),(-22.325,4.875),(-22.325,4.725),(-22.475,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,4.725),(22.325,4.875),(22.475,4.875),(22.475,4.725),(22.325,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-9.675),(-32.075,-9.525),(-31.925,-9.525),(-31.925,-9.675),(-32.075,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,15.925),(-25.675,16.075),(-25.525,16.075),(-25.525,15.925),(-25.675,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-11.275),(-25.675,-11.125),(-25.525,-11.125),(-25.525,-11.275),(-25.675,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-9.675),(15.925,-9.525),(16.075,-9.525),(16.075,-9.675),(15.925,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,11.125),(15.925,11.275),(16.075,11.275),(16.075,11.125),(15.925,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,11.125),(25.525,11.275),(25.675,11.275),(25.675,11.125),(25.525,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-1.675),(12.725,-1.525),(12.875,-1.525),(12.875,-1.675),(12.725,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,1.525),(12.725,1.675),(12.875,1.675),(12.875,1.525),(12.725,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-0.075),(23.925,0.075),(24.075,0.075),(24.075,-0.075),(23.925,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-17.675),(-6.475,-17.525),(-6.325,-17.525),(-6.325,-17.675),(-6.475,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,17.525),(-6.475,17.675),(-6.325,17.675),(-6.325,17.525),(-6.475,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-1.675),(23.925,-1.525),(24.075,-1.525),(24.075,-1.675),(23.925,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-4.875),(-25.675,-4.725),(-25.525,-4.725),(-25.525,-4.875),(-25.675,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-0.075),(-25.675,0.075),(-25.525,0.075),(-25.525,-0.075),(-25.675,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-0.075),(25.525,0.075),(25.675,0.075),(25.675,-0.075),(25.525,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-4.875),(25.525,-4.725),(25.675,-4.725),(25.675,-4.875),(25.525,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,15.925),(3.125,16.075),(3.275,16.075),(3.275,15.925),(3.125,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-16.075),(-12.875,-15.925),(-12.725,-15.925),(-12.725,-16.075),(-12.875,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-16.075),(12.725,-15.925),(12.875,-15.925),(12.875,-16.075),(12.725,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-6.475),(-20.875,-6.325),(-20.725,-6.325),(-20.725,-6.475),(-20.875,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-17.675),(-3.275,-17.525),(-3.125,-17.525),(-3.125,-17.675),(-3.275,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-14.475),(-8.075,-14.325),(-7.925,-14.325),(-7.925,-14.475),(-8.075,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,14.325),(-14.475,14.475),(-14.325,14.475),(-14.325,14.325),(-14.475,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,6.325),(-20.875,6.475),(-20.725,6.475),(-20.725,6.325),(-20.875,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,17.525),(3.125,17.675),(3.275,17.675),(3.275,17.525),(3.125,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-6.475),(7.925,-6.325),(8.075,-6.325),(8.075,-6.475),(7.925,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,4.725),(7.925,4.875),(8.075,4.875),(8.075,4.725),(7.925,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-14.475),(14.325,-14.325),(14.475,-14.325),(14.475,-14.475),(14.325,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,4.725),(-11.275,4.875),(-11.125,4.875),(-11.125,4.725),(-11.275,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,4.725),(11.125,4.875),(11.275,4.875),(11.275,4.725),(11.125,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-6.475),(-14.475,-6.325),(-14.325,-6.325),(-14.325,-6.475),(-14.475,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,6.325),(14.325,6.475),(14.475,6.475),(14.475,6.325),(14.325,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-14.475),(27.125,-14.325),(27.275,-14.325),(27.275,-14.475),(27.125,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-14.475),(-27.275,-14.325),(-27.125,-14.325),(-27.125,-14.475),(-27.275,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-22.475),(-19.275,-22.325),(-19.125,-22.325),(-19.125,-22.475),(-19.275,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,4.725),(-28.875,4.875),(-28.725,4.875),(-28.725,4.725),(-28.875,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,23.925),(6.325,24.075),(6.475,24.075),(6.475,23.925),(6.325,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,9.525),(-25.675,9.675),(-25.525,9.675),(-25.525,9.525),(-25.675,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-19.275),(-11.275,-19.125),(-11.125,-19.125),(-11.125,-19.275),(-11.275,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,19.125),(11.125,19.275),(11.275,19.275),(11.275,19.125),(11.125,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-22.475),(19.125,-22.325),(19.275,-22.325),(19.275,-22.475),(19.125,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,6.325),(-9.675,6.475),(-9.525,6.475),(-9.525,6.325),(-9.675,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,6.325),(9.525,6.475),(9.675,6.475),(9.675,6.325),(9.525,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-9.675),(25.525,-9.525),(25.675,-9.525),(25.675,-9.675),(25.525,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-9.675),(-0.075,-9.525),(0.075,-9.525),(0.075,-9.675),(-0.075,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-8.075),(-19.275,-7.925),(-19.125,-7.925),(-19.125,-8.075),(-19.275,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,9.525),(-0.075,9.675),(0.075,9.675),(0.075,9.525),(-0.075,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,1.525),(-32.075,1.675),(-31.925,1.675),(-31.925,1.525),(-32.075,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,7.925),(-3.275,8.075),(-3.125,8.075),(-3.125,7.925),(-3.275,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-8.075),(19.125,-7.925),(19.275,-7.925),(19.275,-8.075),(19.125,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-22.475),(-9.675,-22.325),(-9.525,-22.325),(-9.525,-22.475),(-9.675,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-22.475),(9.525,-22.325),(9.675,-22.325),(9.675,-22.475),(9.525,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-19.275),(4.725,-19.125),(4.875,-19.125),(4.875,-19.275),(4.725,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,19.125),(4.725,19.275),(4.875,19.275),(4.875,19.125),(4.725,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,-6.475),(-35.275,-6.325),(-35.125,-6.325),(-35.125,-6.475),(-35.275,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,12.725),(-25.675,12.875),(-25.525,12.875),(-25.525,12.725),(-25.675,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,12.725),(25.525,12.875),(25.675,12.875),(25.675,12.725),(25.525,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,-6.475),(35.125,-6.325),(35.275,-6.325),(35.275,-6.475),(35.125,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,7.925),(-24.075,8.075),(-23.925,8.075),(-23.925,7.925),(-24.075,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-3.275),(-19.275,-3.125),(-19.125,-3.125),(-19.125,-3.275),(-19.275,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-27.275),(-0.075,-27.125),(0.075,-27.125),(0.075,-27.275),(-0.075,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,27.125),(-0.075,27.275),(0.075,27.275),(0.075,27.125),(-0.075,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-27.275),(7.925,-27.125),(8.075,-27.125),(8.075,-27.275),(7.925,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,3.125),(19.125,3.275),(19.275,3.275),(19.275,3.125),(19.125,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-20.875),(-1.675,-20.725),(-1.525,-20.725),(-1.525,-20.875),(-1.675,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-20.875),(1.525,-20.725),(1.675,-20.725),(1.675,-20.875),(1.525,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,27.125),(-11.275,27.275),(-11.125,27.275),(-11.125,27.125),(-11.275,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,22.325),(-8.075,22.475),(-7.925,22.475),(-7.925,22.325),(-8.075,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,1.525),(7.925,1.675),(8.075,1.675),(8.075,1.525),(7.925,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-27.275),(11.125,-27.125),(11.275,-27.125),(11.275,-27.275),(11.125,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-17.675),(22.325,-17.525),(22.475,-17.525),(22.475,-17.675),(22.325,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,17.525),(22.325,17.675),(22.475,17.675),(22.475,17.525),(22.325,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-22.475),(-14.475,-22.325),(-14.325,-22.325),(-14.325,-22.475),(-14.475,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-8.075),(-8.075,-7.925),(-7.925,-7.925),(-7.925,-8.075),(-8.075,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,22.325),(14.325,22.475),(14.475,22.475),(14.475,22.325),(14.325,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-19.275),(-0.075,-19.125),(0.075,-19.125),(0.075,-19.275),(-0.075,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,19.125),(-0.075,19.275),(0.075,19.275),(0.075,19.125),(-0.075,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-16.075),(-4.875,-15.925),(-4.725,-15.925),(-4.725,-16.075),(-4.875,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-1.675),(-14.475,-1.525),(-14.325,-1.525),(-14.325,-1.675),(-14.475,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,1.525),(-14.475,1.675),(-14.325,1.675),(-14.325,1.525),(-14.475,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,17.525),(-19.275,17.675),(-19.125,17.675),(-19.125,17.525),(-19.275,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-16.075),(4.725,-15.925),(4.875,-15.925),(4.875,-16.075),(4.725,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-17.675),(19.125,-17.525),(19.275,-17.525),(19.275,-17.675),(19.125,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,22.325),(-19.275,22.475),(-19.125,22.475),(-19.125,22.325),(-19.275,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,7.925),(-27.275,8.075),(-27.125,8.075),(-27.125,7.925),(-27.275,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-3.275),(-8.075,-3.125),(-7.925,-3.125),(-7.925,-3.275),(-8.075,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,22.325),(19.125,22.475),(19.275,22.475),(19.275,22.325),(19.125,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,15.925),(-20.875,16.075),(-20.725,16.075),(-20.725,15.925),(-20.875,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-6.475),(-9.675,-6.325),(-9.525,-6.325),(-9.525,-6.475),(-9.675,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-17.675),(-16.075,-17.525),(-15.925,-17.525),(-15.925,-17.675),(-16.075,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-6.475),(9.525,-6.325),(9.675,-6.325),(9.675,-6.475),(9.525,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-14.475),(-19.275,-14.325),(-19.125,-14.325),(-19.125,-14.475),(-19.275,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-14.475),(19.125,-14.325),(19.275,-14.325),(19.275,-14.475),(19.125,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-16.075),(23.925,-15.925),(24.075,-15.925),(24.075,-16.075),(23.925,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-4.875),(23.925,-4.725),(24.075,-4.725),(24.075,-4.875),(23.925,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-1.675),(-25.675,-1.525),(-25.525,-1.525),(-25.525,-1.675),(-25.675,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,17.525),(-9.675,17.675),(-9.525,17.675),(-9.525,17.525),(-9.675,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-11.275),(7.925,-11.125),(8.075,-11.125),(8.075,-11.275),(7.925,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-17.675),(9.525,-17.525),(9.675,-17.525),(9.675,-17.675),(9.525,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,1.525),(25.525,1.675),(25.675,1.675),(25.675,1.525),(25.525,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,3.125),(-17.675,3.275),(-17.525,3.275),(-17.525,3.125),(-17.675,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,4.725),(-24.075,4.875),(-23.925,4.875),(-23.925,4.725),(-24.075,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-3.275),(17.525,-3.125),(17.675,-3.125),(17.675,-3.275),(17.525,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,7.925),(7.925,8.075),(8.075,8.075),(8.075,7.925),(7.925,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-27.275),(6.325,-27.125),(6.475,-27.125),(6.475,-27.275),(6.325,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,27.125),(6.325,27.275),(6.475,27.275),(6.475,27.125),(6.325,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,11.125),(-11.275,11.275),(-11.125,11.275),(-11.125,11.125),(-11.275,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-11.275),(11.125,-11.125),(11.275,-11.125),(11.275,-11.275),(11.125,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-1.675),(-4.875,-1.525),(-4.725,-1.525),(-4.725,-1.675),(-4.875,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,1.525),(-4.875,1.675),(-4.725,1.675),(-4.725,1.525),(-4.875,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,7.925),(14.325,8.075),(14.475,8.075),(14.475,7.925),(14.325,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,7.925),(-25.675,8.075),(-25.525,8.075),(-25.525,7.925),(-25.675,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,15.925),(17.525,16.075),(17.675,16.075),(17.675,15.925),(17.525,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-19.275),(-9.675,-19.125),(-9.525,-19.125),(-9.525,-19.275),(-9.675,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,19.125),(9.525,19.275),(9.675,19.275),(9.675,19.125),(9.525,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-19.275),(-12.875,-19.125),(-12.725,-19.125),(-12.725,-19.275),(-12.875,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,19.125),(-12.875,19.275),(-12.725,19.275),(-12.725,19.125),(-12.875,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-25.675),(-9.675,-25.525),(-9.525,-25.525),(-9.525,-25.675),(-9.675,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,25.525),(9.525,25.675),(9.675,25.675),(9.675,25.525),(9.525,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,-4.875),(-35.275,-4.725),(-35.125,-4.725),(-35.125,-4.875),(-35.275,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,-4.875),(35.125,-4.725),(35.275,-4.725),(35.275,-4.875),(35.125,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,9.525),(-11.275,9.675),(-11.125,9.675),(-11.125,9.525),(-11.275,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-9.675),(11.125,-9.525),(11.275,-9.525),(11.275,-9.675),(11.125,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,14.325),(-11.275,14.475),(-11.125,14.475),(-11.125,14.325),(-11.275,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,14.325),(11.125,14.475),(11.275,14.475),(11.275,14.325),(11.125,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-22.475),(-0.075,-22.325),(0.075,-22.325),(0.075,-22.475),(-0.075,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,22.325),(-0.075,22.475),(0.075,22.475),(0.075,22.325),(-0.075,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,17.525),(-17.675,17.675),(-17.525,17.675),(-17.525,17.525),(-17.675,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,27.125),(-3.275,27.275),(-3.125,27.275),(-3.125,27.125),(-3.275,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-27.275),(3.125,-27.125),(3.275,-27.125),(3.275,-27.275),(3.125,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-17.675),(17.525,-17.525),(17.675,-17.525),(17.675,-17.675),(17.525,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,6.325),(31.925,6.475),(32.075,6.475),(32.075,6.325),(31.925,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-9.675),(6.325,-9.525),(6.475,-9.525),(6.475,-9.675),(6.325,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,9.525),(6.325,9.675),(6.475,9.675),(6.475,9.525),(6.325,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-3.275),(-20.875,-3.125),(-20.725,-3.125),(-20.725,-3.275),(-20.875,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,3.125),(-20.875,3.275),(-20.725,3.275),(-20.725,3.125),(-20.875,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,6.325),(-16.075,6.475),(-15.925,6.475),(-15.925,6.325),(-16.075,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-8.075),(-9.675,-7.925),(-9.525,-7.925),(-9.525,-8.075),(-9.675,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-8.075),(9.525,-7.925),(9.675,-7.925),(9.675,-8.075),(9.525,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,-3.275),(-33.675,-3.125),(-33.525,-3.125),(-33.525,-3.275),(-33.675,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-1.675),(-11.275,-1.525),(-11.125,-1.525),(-11.125,-1.675),(-11.275,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-24.075),(-16.075,-23.925),(-15.925,-23.925),(-15.925,-24.075),(-16.075,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-20.875),(-8.075,-20.725),(-7.925,-20.725),(-7.925,-20.875),(-8.075,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,1.525),(11.125,1.675),(11.275,1.675),(11.275,1.525),(11.125,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-25.675),(15.925,-25.525),(16.075,-25.525),(16.075,-25.675),(15.925,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-11.275),(6.325,-11.125),(6.475,-11.125),(6.475,-11.275),(6.325,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,11.125),(6.325,11.275),(6.475,11.275),(6.475,11.125),(6.325,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,3.125),(33.525,3.275),(33.675,3.275),(33.675,3.125),(33.525,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,-1.675),(36.725,-1.525),(36.875,-1.525),(36.875,-1.675),(36.725,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,1.525),(36.725,1.675),(36.875,1.675),(36.875,1.525),(36.725,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,20.725),(-19.275,20.875),(-19.125,20.875),(-19.125,20.725),(-19.275,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,20.725),(19.125,20.875),(19.275,20.875),(19.275,20.725),(19.125,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-1.675),(6.325,-1.525),(6.475,-1.525),(6.475,-1.675),(6.325,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,1.525),(6.325,1.675),(6.475,1.675),(6.475,1.525),(6.325,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-3.275),(-9.675,-3.125),(-9.525,-3.125),(-9.525,-3.275),(-9.675,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,3.125),(9.525,3.275),(9.675,3.275),(9.675,3.125),(9.525,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-19.275),(-16.075,-19.125),(-15.925,-19.125),(-15.925,-19.275),(-16.075,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-4.875),(-4.875,-4.725),(-4.725,-4.725),(-4.725,-4.875),(-4.875,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,4.725),(4.725,4.875),(4.875,4.875),(4.875,4.725),(4.725,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-16.075),(15.925,-15.925),(16.075,-15.925),(16.075,-16.075),(15.925,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,19.125),(-8.075,19.275),(-7.925,19.275),(-7.925,19.125),(-8.075,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-8.075),(-32.075,-7.925),(-31.925,-7.925),(-31.925,-8.075),(-32.075,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,6.325),(-22.475,6.475),(-22.325,6.475),(-22.325,6.325),(-22.475,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-6.475),(22.325,-6.325),(22.475,-6.325),(22.475,-6.475),(22.325,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,1.525),(-16.075,1.675),(-15.925,1.675),(-15.925,1.525),(-16.075,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,23.925),(11.125,24.075),(11.275,24.075),(11.275,23.925),(11.125,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,15.925),(-22.475,16.075),(-22.325,16.075),(-22.325,15.925),(-22.475,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,11.125),(-3.275,11.275),(-3.125,11.275),(-3.125,11.125),(-3.275,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-11.275),(3.125,-11.125),(3.275,-11.125),(3.275,-11.275),(3.125,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-1.675),(20.725,-1.525),(20.875,-1.525),(20.875,-1.675),(20.725,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,1.525),(20.725,1.675),(20.875,1.675),(20.875,1.525),(20.725,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,4.725),(-35.275,4.875),(-35.125,4.875),(-35.125,4.725),(-35.275,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,4.725),(35.125,4.875),(35.275,4.875),(35.275,4.725),(35.125,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-3.275),(12.725,-3.125),(12.875,-3.125),(12.875,-3.275),(12.725,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,3.125),(12.725,3.275),(12.875,3.275),(12.875,3.125),(12.725,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-3.275),(-32.075,-3.125),(-31.925,-3.125),(-31.925,-3.275),(-32.075,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-19.275),(-6.475,-19.125),(-6.325,-19.125),(-6.325,-19.275),(-6.475,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,19.125),(-6.475,19.275),(-6.325,19.275),(-6.325,19.125),(-6.475,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,9.525),(-3.275,9.675),(-3.125,9.675),(-3.125,9.525),(-3.275,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-22.475),(-8.075,-22.325),(-7.925,-22.325),(-7.925,-22.475),(-8.075,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-16.075),(-6.475,-15.925),(-6.325,-15.925),(-6.325,-16.075),(-6.475,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-9.675),(3.125,-9.525),(3.275,-9.525),(3.275,-9.675),(3.125,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,14.325),(-3.275,14.475),(-3.125,14.475),(-3.125,14.325),(-3.275,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,14.325),(3.125,14.475),(3.275,14.475),(3.275,14.325),(3.125,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-16.075),(6.325,-15.925),(6.475,-15.925),(6.475,-16.075),(6.325,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,7.925),(19.125,8.075),(19.275,8.075),(19.275,7.925),(19.125,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,9.525),(23.925,9.675),(24.075,9.675),(24.075,9.525),(23.925,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,6.325),(7.925,6.475),(8.075,6.475),(8.075,6.325),(7.925,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,23.925),(9.525,24.075),(9.675,24.075),(9.675,23.925),(9.525,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-27.275),(-1.675,-27.125),(-1.525,-27.125),(-1.525,-27.275),(-1.675,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,27.125),(1.525,27.275),(1.675,27.275),(1.675,27.125),(1.525,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-17.675),(7.925,-17.525),(8.075,-17.525),(8.075,-17.675),(7.925,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,19.125),(7.925,19.275),(8.075,19.275),(8.075,19.125),(7.925,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-11.275),(-30.475,-11.125),(-30.325,-11.125),(-30.325,-11.275),(-30.475,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,11.125),(-30.475,11.275),(-30.325,11.275),(-30.325,11.125),(-30.475,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-4.875),(-28.875,-4.725),(-28.725,-4.725),(-28.725,-4.875),(-28.875,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-19.275),(-19.275,-19.125),(-19.125,-19.125),(-19.125,-19.275),(-19.275,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,12.725),(-6.475,12.875),(-6.325,12.875),(-6.325,12.725),(-6.475,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-11.275),(-0.075,-11.125),(0.075,-11.125),(0.075,-11.275),(-0.075,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,11.125),(-0.075,11.275),(0.075,11.275),(0.075,11.125),(-0.075,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,3.125),(-8.075,3.275),(-7.925,3.275),(-7.925,3.125),(-8.075,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-20.875),(-0.075,-20.725),(0.075,-20.725),(0.075,-20.875),(-0.075,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,20.725),(-0.075,20.875),(0.075,20.875),(0.075,20.725),(-0.075,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,1.525),(-27.275,1.675),(-27.125,1.675),(-27.125,1.525),(-27.275,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,12.725),(6.325,12.875),(6.475,12.875),(6.475,12.725),(6.325,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-1.675),(27.125,-1.525),(27.275,-1.525),(27.275,-1.675),(27.125,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,4.725),(-9.675,4.875),(-9.525,4.875),(-9.525,4.725),(-9.675,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,17.525),(-16.075,17.675),(-15.925,17.675),(-15.925,17.525),(-16.075,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-0.075),(-20.875,0.075),(-20.725,0.075),(-20.725,-0.075),(-20.875,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-27.275),(-8.075,-27.125),(-7.925,-27.125),(-7.925,-27.275),(-8.075,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,4.725),(9.525,4.875),(9.675,4.875),(9.675,4.725),(9.525,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-0.075),(-32.075,0.075),(-31.925,0.075),(-31.925,-0.075),(-32.075,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-0.075),(20.725,0.075),(20.875,0.075),(20.875,-0.075),(20.725,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-4.875),(-16.075,-4.725),(-15.925,-4.725),(-15.925,-4.875),(-16.075,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-14.475),(-6.475,-14.325),(-6.325,-14.325),(-6.325,-14.475),(-6.475,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,14.325),(6.325,14.475),(6.475,14.475),(6.475,14.325),(6.325,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,15.925),(-24.075,16.075),(-23.925,16.075),(-23.925,15.925),(-24.075,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-3.275),(-0.075,-3.125),(0.075,-3.125),(0.075,-3.275),(-0.075,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,3.125),(-0.075,3.275),(0.075,3.275),(0.075,3.125),(-0.075,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-17.675),(-24.075,-17.525),(-23.925,-17.525),(-23.925,-17.675),(-24.075,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,23.925),(17.525,24.075),(17.675,24.075),(17.675,23.925),(17.525,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,3.125),(-1.675,3.275),(-1.525,3.275),(-1.525,3.125),(-1.675,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-3.275),(1.525,-3.125),(1.675,-3.125),(1.675,-3.275),(1.525,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,15.925),(23.925,16.075),(24.075,16.075),(24.075,15.925),(23.925,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,25.525),(-1.675,25.675),(-1.525,25.675),(-1.525,25.525),(-1.675,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-25.675),(1.525,-25.525),(1.675,-25.525),(1.675,-25.675),(1.525,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,1.525),(15.925,1.675),(16.075,1.675),(16.075,1.525),(15.925,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,6.325),(-33.675,6.475),(-33.525,6.475),(-33.525,6.325),(-33.675,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-9.675),(-8.075,-9.525),(-7.925,-9.525),(-7.925,-9.675),(-8.075,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-0.075),(7.925,0.075),(8.075,0.075),(8.075,-0.075),(7.925,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,6.325),(33.525,6.475),(33.675,6.475),(33.675,6.325),(33.525,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-1.675),(7.925,-1.525),(8.075,-1.525),(8.075,-1.675),(7.925,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,3.125),(7.925,3.275),(8.075,3.275),(8.075,3.125),(7.925,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,15.925),(-11.275,16.075),(-11.125,16.075),(-11.125,15.925),(-11.275,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-20.875),(12.725,-20.725),(12.875,-20.725),(12.875,-20.875),(12.725,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-1.675),(30.325,-1.525),(30.475,-1.525),(30.475,-1.675),(30.325,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,1.525),(30.325,1.675),(30.475,1.675),(30.475,1.525),(30.325,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-16.075),(-24.075,-15.925),(-23.925,-15.925),(-23.925,-16.075),(-24.075,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,7.925),(31.925,8.075),(32.075,8.075),(32.075,7.925),(31.925,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-8.075),(-0.075,-7.925),(0.075,-7.925),(0.075,-8.075),(-0.075,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-3.275),(-14.475,-3.125),(-14.325,-3.125),(-14.325,-3.275),(-14.475,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,3.125),(-14.475,3.275),(-14.325,3.275),(-14.325,3.125),(-14.475,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-11.275),(-27.275,-11.125),(-27.125,-11.125),(-27.125,-11.275),(-27.275,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-0.075),(-16.075,0.075),(-15.925,0.075),(-15.925,-0.075),(-16.075,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-12.875),(7.925,-12.725),(8.075,-12.725),(8.075,-12.875),(7.925,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,7.925),(-20.875,8.075),(-20.725,8.075),(-20.725,7.925),(-20.875,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,9.525),(15.925,9.675),(16.075,9.675),(16.075,9.525),(15.925,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,11.125),(27.125,11.275),(27.275,11.275),(27.275,11.125),(27.125,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-6.475),(-16.075,-6.325),(-15.925,-6.325),(-15.925,-6.475),(-16.075,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-22.475),(-3.275,-22.325),(-3.125,-22.325),(-3.125,-22.475),(-3.275,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-22.475),(3.125,-22.325),(3.275,-22.325),(3.275,-22.475),(3.125,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-4.875),(22.325,-4.725),(22.475,-4.725),(22.475,-4.875),(22.325,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,25.525),(-12.875,25.675),(-12.725,25.675),(-12.725,25.525),(-12.875,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-25.675),(-12.875,-25.525),(-12.725,-25.525),(-12.725,-25.675),(-12.875,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-1.675),(-24.075,-1.525),(-23.925,-1.525),(-23.925,-1.675),(-24.075,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-4.875),(-22.475,-4.725),(-22.325,-4.725),(-22.325,-4.875),(-22.475,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-9.675),(-27.275,-9.525),(-27.125,-9.525),(-27.125,-9.675),(-27.275,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,9.525),(27.125,9.675),(27.275,9.675),(27.275,9.525),(27.125,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-0.075),(-4.875,0.075),(-4.725,0.075),(-4.725,-0.075),(-4.875,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-6.475),(-0.075,-6.325),(0.075,-6.325),(0.075,-6.475),(-0.075,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,6.325),(-0.075,6.475),(0.075,6.475),(0.075,6.325),(-0.075,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-0.075),(4.725,0.075),(4.875,0.075),(4.875,-0.075),(4.725,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-9.675),(-22.475,-9.525),(-22.325,-9.525),(-22.325,-9.675),(-22.475,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,9.525),(-22.475,9.675),(-22.325,9.675),(-22.325,9.525),(-22.475,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-14.475),(-20.875,-14.325),(-20.725,-14.325),(-20.725,-14.475),(-20.875,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,14.325),(-20.875,14.475),(-20.725,14.475),(-20.725,14.325),(-20.875,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-19.275),(-20.875,-19.125),(-20.725,-19.125),(-20.725,-19.275),(-20.875,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,19.125),(-20.875,19.275),(-20.725,19.275),(-20.725,19.125),(-20.875,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-0.075),(-30.475,0.075),(-30.325,0.075),(-30.325,-0.075),(-30.475,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-0.075),(30.325,0.075),(30.475,0.075),(30.475,-0.075),(30.325,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,-6.475),(-33.675,-6.325),(-33.525,-6.325),(-33.525,-6.475),(-33.675,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-0.075),(-27.275,0.075),(-27.125,0.075),(-27.125,-0.075),(-27.275,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-22.475),(4.725,-22.325),(4.875,-22.325),(4.875,-22.475),(4.725,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-24.075),(-12.875,-23.925),(-12.725,-23.925),(-12.725,-24.075),(-12.875,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-24.075),(12.725,-23.925),(12.875,-23.925),(12.875,-24.075),(12.725,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-11.275),(25.525,-11.125),(25.675,-11.125),(25.675,-11.275),(25.525,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,11.125),(-25.675,11.275),(-25.525,11.275),(-25.525,11.125),(-25.675,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-0.075),(27.125,0.075),(27.275,0.075),(27.275,-0.075),(27.125,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,15.925),(15.925,16.075),(16.075,16.075),(16.075,15.925),(15.925,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,22.325),(4.725,22.475),(4.875,22.475),(4.875,22.325),(4.725,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,3.125),(-32.075,3.275),(-31.925,3.275),(-31.925,3.125),(-32.075,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-17.675),(6.325,-17.525),(6.475,-17.525),(6.475,-17.675),(6.325,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,17.525),(6.325,17.675),(6.475,17.675),(6.475,17.525),(6.325,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-11.275),(28.725,-11.125),(28.875,-11.125),(28.875,-11.275),(28.725,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-16.075),(-19.275,-15.925),(-19.125,-15.925),(-19.125,-16.075),(-19.275,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-12.875),(-17.675,-12.725),(-17.525,-12.725),(-17.525,-12.875),(-17.675,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-6.475),(-3.275,-6.325),(-3.125,-6.325),(-3.125,-6.475),(-3.275,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,15.925),(-3.275,16.075),(-3.125,16.075),(-3.125,15.925),(-3.275,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-6.475),(3.125,-6.325),(3.275,-6.325),(3.275,-6.475),(3.125,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-12.875),(17.525,-12.725),(17.675,-12.725),(17.675,-12.875),(17.525,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-16.075),(19.125,-15.925),(19.275,-15.925),(19.275,-16.075),(19.125,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-9.675),(-12.875,-9.525),(-12.725,-9.525),(-12.725,-9.675),(-12.875,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,9.525),(-12.875,9.675),(-12.725,9.675),(-12.725,9.525),(-12.875,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-1.675),(-19.275,-1.525),(-19.125,-1.525),(-19.125,-1.675),(-19.275,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,12.725),(-8.075,12.875),(-7.925,12.875),(-7.925,12.725),(-8.075,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,17.525),(-3.275,17.675),(-3.125,17.675),(-3.125,17.525),(-3.275,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-17.675),(3.125,-17.525),(3.275,-17.525),(3.275,-17.675),(3.125,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-12.875),(-9.675,-12.725),(-9.525,-12.725),(-9.525,-12.875),(-9.675,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,22.325),(-3.275,22.475),(-3.125,22.475),(-3.125,22.325),(-3.275,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,22.325),(3.125,22.475),(3.275,22.475),(3.275,22.325),(3.125,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-25.675),(7.925,-25.525),(8.075,-25.525),(8.075,-25.675),(7.925,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-11.275),(-19.275,-11.125),(-19.125,-11.125),(-19.125,-11.275),(-19.275,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,27.125),(7.925,27.275),(8.075,27.275),(8.075,27.125),(7.925,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-12.875),(9.525,-12.725),(9.675,-12.725),(9.675,-12.875),(9.525,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,11.125),(19.125,11.275),(19.275,11.275),(19.275,11.125),(19.125,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,14.325),(23.925,14.475),(24.075,14.475),(24.075,14.325),(23.925,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-11.275),(-12.875,-11.125),(-12.725,-11.125),(-12.725,-11.275),(-12.875,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,11.125),(-12.875,11.275),(-12.725,11.275),(-12.725,11.125),(-12.875,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,-3.275),(36.725,-3.125),(36.875,-3.125),(36.875,-3.275),(36.725,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,3.125),(36.725,3.275),(36.875,3.275),(36.875,3.125),(36.725,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,23.925),(-6.475,24.075),(-6.325,24.075),(-6.325,23.925),(-6.475,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,1.525),(9.525,1.675),(9.675,1.675),(9.675,1.525),(9.525,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,19.125),(-11.275,19.275),(-11.125,19.275),(-11.125,19.125),(-11.275,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-1.675),(-9.675,-1.525),(-9.525,-1.525),(-9.525,-1.675),(-9.675,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,14.325),(-8.075,14.475),(-7.925,14.475),(-7.925,14.325),(-8.075,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-25.675),(-4.875,-25.525),(-4.725,-25.525),(-4.725,-25.675),(-4.875,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,25.525),(-4.875,25.675),(-4.725,25.675),(-4.725,25.525),(-4.875,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-8.075),(-12.875,-7.925),(-12.725,-7.925),(-12.725,-8.075),(-12.875,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-16.075),(-1.675,-15.925),(-1.525,-15.925),(-1.525,-16.075),(-1.675,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-16.075),(1.525,-15.925),(1.675,-15.925),(1.675,-16.075),(1.525,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-9.675),(-19.275,-9.525),(-19.125,-9.525),(-19.125,-9.675),(-19.275,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-6.475),(4.725,-6.325),(4.875,-6.325),(4.875,-6.475),(4.725,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,6.325),(4.725,6.475),(4.875,6.475),(4.875,6.325),(4.725,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-8.075),(12.725,-7.925),(12.875,-7.925),(12.875,-8.075),(12.725,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,9.525),(19.125,9.675),(19.275,9.675),(19.275,9.525),(19.125,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,-8.075),(-33.675,-7.925),(-33.525,-7.925),(-33.525,-8.075),(-33.675,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,14.325),(-17.675,14.475),(-17.525,14.475),(-17.525,14.325),(-17.675,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,22.325),(-1.675,22.475),(-1.525,22.475),(-1.525,22.325),(-1.675,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,22.325),(1.525,22.475),(1.675,22.475),(1.675,22.325),(1.525,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,14.325),(17.525,14.475),(17.675,14.475),(17.675,14.325),(17.525,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-11.275),(-1.675,-11.125),(-1.525,-11.125),(-1.525,-11.275),(-1.675,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,11.125),(1.525,11.275),(1.675,11.275),(1.675,11.125),(1.525,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,-8.075),(33.525,-7.925),(33.675,-7.925),(33.675,-8.075),(33.525,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-6.475),(-27.275,-6.325),(-27.125,-6.325),(-27.125,-6.475),(-27.275,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,17.525),(-24.075,17.675),(-23.925,17.675),(-23.925,17.525),(-24.075,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-6.475),(27.125,-6.325),(27.275,-6.325),(27.275,-6.475),(27.125,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,3.125),(-19.275,3.275),(-19.125,3.275),(-19.125,3.125),(-19.275,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-3.275),(19.125,-3.125),(19.275,-3.125),(19.275,-3.275),(19.125,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,14.325),(-9.675,14.475),(-9.525,14.475),(-9.525,14.325),(-9.675,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,14.325),(9.525,14.475),(9.675,14.475),(9.675,14.325),(9.525,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-4.875),(-0.075,-4.725),(0.075,-4.725),(0.075,-4.875),(-0.075,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,4.725),(-0.075,4.875),(0.075,4.875),(0.075,4.725),(-0.075,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-24.075),(-6.475,-23.925),(-6.325,-23.925),(-6.325,-24.075),(-6.475,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-24.075),(6.325,-23.925),(6.475,-23.925),(6.475,-24.075),(6.325,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-17.675),(15.925,-17.525),(16.075,-17.525),(16.075,-17.675),(15.925,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-16.075),(-16.075,-15.925),(-15.925,-15.925),(-15.925,-16.075),(-16.075,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,19.125),(15.925,19.275),(16.075,19.275),(16.075,19.125),(15.925,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-11.275),(20.725,-11.125),(20.875,-11.125),(20.875,-11.275),(20.725,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,9.525),(-24.075,9.675),(-23.925,9.675),(-23.925,9.525),(-24.075,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,11.125),(20.725,11.275),(20.875,11.275),(20.875,11.125),(20.725,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-19.275),(7.925,-19.125),(8.075,-19.125),(8.075,-19.275),(7.925,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-9.675),(-4.875,-9.525),(-4.725,-9.525),(-4.725,-9.675),(-4.875,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,9.525),(-4.875,9.675),(-4.725,9.675),(-4.725,9.525),(-4.875,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-4.875),(-3.275,-4.725),(-3.125,-4.725),(-3.125,-4.875),(-3.275,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-4.875),(3.125,-4.725),(3.275,-4.725),(3.275,-4.875),(3.125,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-1.675),(14.325,-1.525),(14.475,-1.525),(14.475,-1.675),(14.325,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,1.525),(14.325,1.675),(14.475,1.675),(14.475,1.525),(14.325,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-27.275),(-9.675,-27.125),(-9.525,-27.125),(-9.525,-27.275),(-9.675,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,27.125),(9.525,27.275),(9.675,27.275),(9.675,27.125),(9.525,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,7.925),(17.525,8.075),(17.675,8.075),(17.675,7.925),(17.525,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-6.475),(28.725,-6.325),(28.875,-6.325),(28.875,-6.475),(28.725,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,6.325),(28.725,6.475),(28.875,6.475),(28.875,6.325),(28.725,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,9.525),(-1.675,9.675),(-1.525,9.675),(-1.525,9.525),(-1.675,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-9.675),(1.525,-9.525),(1.675,-9.525),(1.675,-9.675),(1.525,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,20.725),(-3.275,20.875),(-3.125,20.875),(-3.125,20.725),(-3.275,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,11.125),(-24.075,11.275),(-23.925,11.275),(-23.925,11.125),(-24.075,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,20.725),(3.125,20.875),(3.275,20.875),(3.275,20.725),(3.125,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,14.325),(15.925,14.475),(16.075,14.475),(16.075,14.325),(15.925,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-1.675),(31.925,-1.525),(32.075,-1.525),(32.075,-1.675),(31.925,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-11.275),(-4.875,-11.125),(-4.725,-11.125),(-4.725,-11.275),(-4.875,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,11.125),(-4.875,11.275),(-4.725,11.275),(-4.725,11.125),(-4.875,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,3.125),(31.925,3.275),(32.075,3.275),(32.075,3.125),(31.925,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,1.525),(-25.675,1.675),(-25.525,1.675),(-25.525,1.525),(-25.675,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-1.675),(25.525,-1.525),(25.675,-1.525),(25.675,-1.675),(25.525,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-14.475),(-17.675,-14.325),(-17.525,-14.325),(-17.525,-14.475),(-17.675,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-14.475),(17.525,-14.325),(17.675,-14.325),(17.675,-14.475),(17.525,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-9.675),(-14.475,-9.525),(-14.325,-9.525),(-14.325,-9.675),(-14.475,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,9.525),(-14.475,9.675),(-14.325,9.675),(-14.325,9.525),(-14.475,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-0.075),(28.725,0.075),(28.875,0.075),(28.875,-0.075),(28.725,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-0.075),(-28.875,0.075),(-28.725,0.075),(-28.725,-0.075),(-28.875,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,7.925),(-14.475,8.075),(-14.325,8.075),(-14.325,7.925),(-14.475,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,25.525),(15.925,25.675),(16.075,25.675),(16.075,25.525),(15.925,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-27.275),(-6.475,-27.125),(-6.325,-27.125),(-6.325,-27.275),(-6.475,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,27.125),(-6.475,27.275),(-6.325,27.275),(-6.325,27.125),(-6.475,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,1.525),(-1.675,1.675),(-1.525,1.675),(-1.525,1.525),(-1.675,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-1.675),(1.525,-1.525),(1.675,-1.525),(1.675,-1.675),(1.525,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-14.475),(-9.675,-14.325),(-9.525,-14.325),(-9.525,-14.475),(-9.675,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,15.925),(-17.675,16.075),(-17.525,16.075),(-17.525,15.925),(-17.675,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-1.675),(4.725,-1.525),(4.875,-1.525),(4.875,-1.675),(4.725,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,1.525),(4.725,1.675),(4.875,1.675),(4.875,1.525),(4.725,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,19.125),(-9.675,19.275),(-9.525,19.275),(-9.525,19.125),(-9.675,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-19.275),(9.525,-19.125),(9.675,-19.125),(9.675,-19.275),(9.525,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-14.475),(9.525,-14.325),(9.675,-14.325),(9.675,-14.475),(9.525,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-0.075),(15.925,0.075),(16.075,0.075),(16.075,-0.075),(15.925,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-8.075),(23.925,-7.925),(24.075,-7.925),(24.075,-8.075),(23.925,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,4.725),(-33.675,4.875),(-33.525,4.875),(-33.525,4.725),(-33.675,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,4.725),(33.525,4.875),(33.675,4.875),(33.675,4.725),(33.525,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,20.725),(-12.875,20.875),(-12.725,20.875),(-12.725,20.725),(-12.875,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-3.275),(6.325,-3.125),(6.475,-3.125),(6.475,-3.275),(6.325,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,25.525),(-9.675,25.675),(-9.525,25.675),(-9.525,25.525),(-9.675,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,3.125),(6.325,3.275),(6.475,3.275),(6.475,3.125),(6.325,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-3.275),(7.925,-3.125),(8.075,-3.125),(8.075,-3.275),(7.925,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-25.675),(9.525,-25.525),(9.675,-25.525),(9.675,-25.675),(9.525,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-4.875),(-27.275,-4.725),(-27.125,-4.725),(-27.125,-4.875),(-27.275,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-4.875),(27.125,-4.725),(27.275,-4.725),(27.275,-4.875),(27.125,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-12.875),(-24.075,-12.725),(-23.925,-12.725),(-23.925,-12.875),(-24.075,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,23.925),(12.725,24.075),(12.875,24.075),(12.875,23.925),(12.725,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,4.725),(-3.275,4.875),(-3.125,4.875),(-3.125,4.725),(-3.275,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,4.725),(3.125,4.875),(3.275,4.875),(3.275,4.725),(3.125,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-8.075),(-14.475,-7.925),(-14.325,-7.925),(-14.325,-8.075),(-14.475,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-8.075),(14.325,-7.925),(14.475,-7.925),(14.475,-8.075),(14.325,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-12.875),(-1.675,-12.725),(-1.525,-12.725),(-1.525,-12.875),(-1.675,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-12.875),(1.525,-12.725),(1.675,-12.725),(1.675,-12.875),(1.525,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,4.725),(-20.875,4.875),(-20.725,4.875),(-20.725,4.725),(-20.875,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-4.875),(20.725,-4.725),(20.875,-4.725),(20.875,-4.875),(20.725,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,23.925),(-8.075,24.075),(-7.925,24.075),(-7.925,23.925),(-8.075,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-19.275),(-3.275,-19.125),(-3.125,-19.125),(-3.125,-19.275),(-3.275,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,19.125),(3.125,19.275),(3.275,19.275),(3.275,19.125),(3.125,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,3.125),(-33.675,3.275),(-33.525,3.275),(-33.525,3.125),(-33.675,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,-3.275),(33.525,-3.125),(33.675,-3.125),(33.675,-3.275),(33.525,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-22.475),(-6.475,-22.325),(-6.325,-22.325),(-6.325,-22.475),(-6.475,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,23.925),(-0.075,24.075),(0.075,24.075),(0.075,23.925),(-0.075,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,6.325),(-11.275,6.475),(-11.125,6.475),(-11.125,6.325),(-11.275,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,22.325),(6.325,22.475),(6.475,22.475),(6.475,22.325),(6.325,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-11.275),(-6.475,-11.125),(-6.325,-11.125),(-6.325,-11.275),(-6.475,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-4.875),(28.725,-4.725),(28.875,-4.725),(28.875,-4.875),(28.725,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,11.125),(-6.475,11.275),(-6.325,11.275),(-6.325,11.125),(-6.475,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,6.325),(11.125,6.475),(11.275,6.475),(11.275,6.325),(11.125,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,4.725),(-14.475,4.875),(-14.325,4.875),(-14.325,4.725),(-14.475,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-24.075),(-1.675,-23.925),(-1.525,-23.925),(-1.525,-24.075),(-1.675,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-24.075),(1.525,-23.925),(1.675,-23.925),(1.675,-24.075),(1.525,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,4.725),(14.325,4.875),(14.475,4.875),(14.475,4.725),(14.325,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-1.675),(28.725,-1.525),(28.875,-1.525),(28.875,-1.675),(28.725,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,1.525),(28.725,1.675),(28.875,1.675),(28.875,1.525),(28.725,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,3.125),(-9.675,3.275),(-9.525,3.275),(-9.525,3.125),(-9.675,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-3.275),(9.525,-3.125),(9.675,-3.125),(9.675,-3.275),(9.525,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,15.925),(19.125,16.075),(19.275,16.075),(19.275,15.925),(19.125,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-22.475),(-17.675,-22.325),(-17.525,-22.325),(-17.525,-22.475),(-17.675,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-17.675),(-8.075,-17.525),(-7.925,-17.525),(-7.925,-17.675),(-8.075,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-22.475),(17.525,-22.325),(17.675,-22.325),(17.675,-22.475),(17.525,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-14.475),(-24.075,-14.325),(-23.925,-14.325),(-23.925,-14.475),(-24.075,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,23.925),(-11.275,24.075),(-11.125,24.075),(-11.125,23.925),(-11.275,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-6.475),(23.925,-6.325),(24.075,-6.325),(24.075,-6.475),(23.925,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,1.525),(19.125,1.675),(19.275,1.675),(19.275,1.525),(19.125,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,4.725),(23.925,4.875),(24.075,4.875),(24.075,4.725),(23.925,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,7.925),(12.725,8.075),(12.875,8.075),(12.875,7.925),(12.725,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,4.725),(-27.275,4.875),(-27.125,4.875),(-27.125,4.725),(-27.275,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,4.725),(27.125,4.875),(27.275,4.875),(27.275,4.725),(27.125,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-12.875),(-6.475,-12.725),(-6.325,-12.725),(-6.325,-12.875),(-6.475,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-12.875),(6.325,-12.725),(6.475,-12.725),(6.475,-12.875),(6.325,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,6.325),(-25.675,6.475),(-25.525,6.475),(-25.525,6.325),(-25.675,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,6.325),(25.525,6.475),(25.675,6.475),(25.675,6.325),(25.525,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-22.475),(-12.875,-22.325),(-12.725,-22.325),(-12.725,-22.475),(-12.875,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,22.325),(-12.875,22.475),(-12.725,22.475),(-12.725,22.325),(-12.875,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,20.725),(-8.075,20.875),(-7.925,20.875),(-7.925,20.725),(-8.075,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-6.475),(-6.475,-6.325),(-6.325,-6.325),(-6.325,-6.475),(-6.475,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,6.325),(6.325,6.475),(6.475,6.475),(6.475,6.325),(6.325,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-0.075),(-17.675,0.075),(-17.525,0.075),(-17.525,-0.075),(-17.675,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,7.925),(-19.275,8.075),(-19.125,8.075),(-19.125,7.925),(-19.275,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,9.525),(-16.075,9.675),(-15.925,9.675),(-15.925,9.525),(-16.075,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-19.275),(14.325,-19.125),(14.475,-19.125),(14.475,-19.275),(14.325,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,19.125),(14.325,19.275),(14.475,19.275),(14.475,19.125),(14.325,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-0.075),(17.525,0.075),(17.675,0.075),(17.675,-0.075),(17.525,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,20.725),(-14.475,20.875),(-14.325,20.875),(-14.325,20.725),(-14.475,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,20.725),(14.325,20.875),(14.475,20.875),(14.475,20.725),(14.325,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,6.325),(-1.675,6.475),(-1.525,6.475),(-1.525,6.325),(-1.675,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,23.925),(-9.675,24.075),(-9.525,24.075),(-9.525,23.925),(-9.675,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,6.325),(1.525,6.475),(1.675,6.475),(1.675,6.325),(1.525,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-4.875),(15.925,-4.725),(16.075,-4.725),(16.075,-4.875),(15.925,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,-3.275),(-35.275,-3.125),(-35.125,-3.125),(-35.125,-3.275),(-35.275,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,19.125),(-19.275,19.275),(-19.125,19.275),(-19.125,19.125),(-19.275,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-19.275),(19.125,-19.125),(19.275,-19.125),(19.275,-19.275),(19.125,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,3.125),(35.125,3.275),(35.275,3.275),(35.275,3.125),(35.125,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,11.125),(-16.075,11.275),(-15.925,11.275),(-15.925,11.125),(-16.075,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-1.675),(-8.075,-1.525),(-7.925,-1.525),(-7.925,-1.675),(-8.075,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-24.075),(-11.275,-23.925),(-11.125,-23.925),(-11.125,-24.075),(-11.275,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-24.075),(11.125,-23.925),(11.275,-23.925),(11.275,-24.075),(11.125,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-3.275),(30.325,-3.125),(30.475,-3.125),(30.475,-3.275),(30.325,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,3.125),(30.325,3.275),(30.475,3.275),(30.475,3.125),(30.325,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,7.925),(-16.075,8.075),(-15.925,8.075),(-15.925,7.925),(-16.075,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,1.525),(23.925,1.675),(24.075,1.675),(24.075,1.525),(23.925,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-8.075),(-24.075,-7.925),(-23.925,-7.925),(-23.925,-8.075),(-24.075,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-19.275),(-4.875,-19.125),(-4.725,-19.125),(-4.725,-19.275),(-4.875,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,19.125),(-4.875,19.275),(-4.725,19.275),(-4.725,19.125),(-4.875,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-14.475),(-1.675,-14.325),(-1.525,-14.325),(-1.525,-14.475),(-1.675,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-16.075),(-20.875,-15.925),(-20.725,-15.925),(-20.725,-16.075),(-20.875,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,23.925),(-17.675,24.075),(-17.525,24.075),(-17.525,23.925),(-17.675,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-6.475),(-12.875,-6.325),(-12.725,-6.325),(-12.725,-6.475),(-12.875,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-19.275),(-17.675,-19.125),(-17.525,-19.125),(-17.525,-19.275),(-17.675,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,6.325),(-12.875,6.475),(-12.725,6.475),(-12.725,6.325),(-12.875,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-14.475),(1.525,-14.325),(1.675,-14.325),(1.675,-14.475),(1.525,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,19.125),(17.525,19.275),(17.675,19.275),(17.675,19.125),(17.525,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-16.075),(20.725,-15.925),(20.875,-15.925),(20.875,-16.075),(20.725,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-3.275),(-24.075,-3.125),(-23.925,-3.125),(-23.925,-3.275),(-24.075,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,25.525),(-16.075,25.675),(-15.925,25.675),(-15.925,25.525),(-16.075,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-17.675),(-12.875,-17.525),(-12.725,-17.525),(-12.725,-17.675),(-12.875,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,17.525),(-12.875,17.675),(-12.725,17.675),(-12.725,17.525),(-12.875,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-6.475),(-25.675,-6.325),(-25.525,-6.325),(-25.525,-6.475),(-25.675,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-6.475),(25.525,-6.325),(25.675,-6.325),(25.675,-6.475),(25.525,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-14.475),(12.725,-14.325),(12.875,-14.325),(12.875,-14.475),(12.725,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,14.325),(12.725,14.475),(12.875,14.475),(12.875,14.325),(12.725,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-12.875),(-16.075,-12.725),(-15.925,-12.725),(-15.925,-12.875),(-16.075,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-19.275),(15.925,-19.125),(16.075,-19.125),(16.075,-19.275),(15.925,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-11.275),(23.925,-11.125),(24.075,-11.125),(24.075,-11.275),(23.925,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-1.675),(-3.275,-1.525),(-3.125,-1.525),(-3.125,-1.675),(-3.275,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,1.525),(3.125,1.675),(3.275,1.675),(3.275,1.525),(3.125,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-8.075),(-11.275,-7.925),(-11.125,-7.925),(-11.125,-8.075),(-11.275,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-8.075),(11.125,-7.925),(11.275,-7.925),(11.275,-8.075),(11.125,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,7.925),(23.925,8.075),(24.075,8.075),(24.075,7.925),(23.925,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,11.125),(-27.275,11.275),(-27.125,11.275),(-27.125,11.125),(-27.275,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-11.275),(27.125,-11.125),(27.275,-11.125),(27.275,-11.275),(27.125,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,4.725),(-16.075,4.875),(-15.925,4.875),(-15.925,4.725),(-16.075,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,7.925),(6.325,8.075),(6.475,8.075),(6.475,7.925),(6.325,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-3.275),(-11.275,-3.125),(-11.125,-3.125),(-11.125,-3.275),(-11.275,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-0.075),(-24.075,0.075),(-23.925,0.075),(-23.925,-0.075),(-24.075,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,3.125),(11.125,3.275),(11.275,3.275),(11.275,3.125),(11.125,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-25.675),(12.725,-25.525),(12.875,-25.525),(12.875,-25.675),(12.725,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,25.525),(12.725,25.675),(12.875,25.675),(12.875,25.525),(12.725,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-3.275),(31.925,-3.125),(32.075,-3.125),(32.075,-3.275),(31.925,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,9.525),(-27.275,9.675),(-27.125,9.675),(-27.125,9.525),(-27.275,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-9.675),(27.125,-9.525),(27.275,-9.525),(27.275,-9.675),(27.125,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,15.925),(-0.075,16.075),(0.075,16.075),(0.075,15.925),(-0.075,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,14.325),(-27.275,14.475),(-27.125,14.475),(-27.125,14.325),(-27.275,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-4.875),(-17.675,-4.725),(-17.525,-4.725),(-17.525,-4.875),(-17.675,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,-0.075),(-36.875,0.075),(-36.725,0.075),(-36.725,-0.075),(-36.875,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,23.925),(3.125,24.075),(3.275,24.075),(3.275,23.925),(3.125,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-4.875),(17.525,-4.725),(17.675,-4.725),(17.675,-4.875),(17.525,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,25.525),(7.925,25.675),(8.075,25.675),(8.075,25.525),(7.925,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,14.325),(27.125,14.475),(27.275,14.475),(27.275,14.325),(27.125,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,-0.075),(36.725,0.075),(36.875,0.075),(36.875,-0.075),(36.725,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-12.875),(-11.275,-12.725),(-11.125,-12.725),(-11.125,-12.875),(-11.275,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-12.875),(11.125,-12.725),(11.275,-12.725),(11.275,-12.875),(11.125,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-9.675),(22.325,-9.525),(22.475,-9.525),(22.475,-9.675),(22.325,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,9.525),(22.325,9.675),(22.475,9.675),(22.475,9.525),(22.325,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,4.725),(28.725,4.875),(28.875,4.875),(28.875,4.725),(28.725,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-14.475),(-16.075,-14.325),(-15.925,-14.325),(-15.925,-14.475),(-16.075,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-6.475),(-30.475,-6.325),(-30.325,-6.325),(-30.325,-6.475),(-30.475,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-3.275),(4.725,-3.125),(4.875,-3.125),(4.875,-3.275),(4.725,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,3.125),(4.725,3.275),(4.875,3.275),(4.875,3.125),(4.725,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,17.525),(-8.075,17.675),(-7.925,17.675),(-7.925,17.525),(-8.075,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,20.725),(-20.875,20.875),(-20.725,20.875),(-20.725,20.725),(-20.875,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-20.875),(-12.875,-20.725),(-12.725,-20.725),(-12.725,-20.875),(-12.875,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,20.725),(12.725,20.875),(12.875,20.875),(12.875,20.725),(12.725,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-20.875),(20.725,-20.725),(20.875,-20.725),(20.875,-20.875),(20.725,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,6.325),(30.325,6.475),(30.475,6.475),(30.475,6.325),(30.325,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-8.075),(-25.675,-7.925),(-25.525,-7.925),(-25.525,-8.075),(-25.675,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-22.475),(-1.675,-22.325),(-1.525,-22.325),(-1.525,-22.475),(-1.675,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-22.475),(1.525,-22.325),(1.675,-22.325),(1.675,-22.475),(1.525,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-8.075),(25.525,-7.925),(25.675,-7.925),(25.675,-8.075),(25.525,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,7.925),(-0.075,8.075),(0.075,8.075),(0.075,7.925),(-0.075,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,6.325),(-35.275,6.475),(-35.125,6.475),(-35.125,6.325),(-35.275,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,6.325),(35.125,6.475),(35.275,6.475),(35.275,6.325),(35.125,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-11.275),(22.325,-11.125),(22.475,-11.125),(22.475,-11.275),(22.325,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,11.125),(22.325,11.275),(22.475,11.275),(22.475,11.125),(22.325,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,6.325),(-8.075,6.475),(-7.925,6.475),(-7.925,6.325),(-8.075,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-8.075),(-1.675,-7.925),(-1.525,-7.925),(-1.525,-8.075),(-1.675,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-8.075),(1.525,-7.925),(1.675,-7.925),(1.675,-8.075),(1.525,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-1.675),(-32.075,-1.525),(-31.925,-1.525),(-31.925,-1.675),(-32.075,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-14.475),(4.725,-14.325),(4.875,-14.325),(4.875,-14.475),(4.725,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,14.325),(4.725,14.475),(4.875,14.475),(4.875,14.325),(4.725,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-3.275),(-25.675,-3.125),(-25.525,-3.125),(-25.525,-3.275),(-25.675,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,3.125),(25.525,3.275),(25.675,3.275),(25.675,3.125),(25.525,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-4.875),(-20.875,-4.725),(-20.725,-4.725),(-20.725,-4.875),(-20.875,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,4.725),(20.725,4.875),(20.875,4.875),(20.875,4.725),(20.725,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-11.275),(15.925,-11.125),(16.075,-11.125),(16.075,-11.275),(15.925,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-9.675),(12.725,-9.525),(12.875,-9.525),(12.875,-9.675),(12.725,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,9.525),(12.725,9.675),(12.875,9.675),(12.875,9.525),(12.725,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,15.925),(9.525,16.075),(9.675,16.075),(9.675,15.925),(9.525,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-17.675),(-14.475,-17.525),(-14.325,-17.525),(-14.325,-17.675),(-14.475,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,17.525),(-14.475,17.675),(-14.325,17.675),(-14.325,17.525),(-14.475,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,1.525),(-19.275,1.675),(-19.125,1.675),(-19.125,1.525),(-19.275,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-1.675),(19.125,-1.525),(19.275,-1.525),(19.275,-1.675),(19.125,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,1.525),(-33.675,1.675),(-33.525,1.675),(-33.525,1.525),(-33.675,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,11.125),(-19.275,11.275),(-19.125,11.275),(-19.125,11.125),(-19.275,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-25.675),(-1.675,-25.525),(-1.525,-25.525),(-1.525,-25.675),(-1.675,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,25.525),(1.525,25.675),(1.675,25.675),(1.675,25.525),(1.525,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-11.275),(19.125,-11.125),(19.275,-11.125),(19.275,-11.275),(19.125,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,-1.675),(33.525,-1.525),(33.675,-1.525),(33.675,-1.675),(33.525,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,6.325),(-14.475,6.475),(-14.325,6.475),(-14.325,6.325),(-14.475,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-6.475),(14.325,-6.325),(14.475,-6.325),(14.475,-6.475),(14.325,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-3.275),(28.725,-3.125),(28.875,-3.125),(28.875,-3.275),(28.725,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-14.475),(7.925,-14.325),(8.075,-14.325),(8.075,-14.475),(7.925,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,12.725),(-12.875,12.875),(-12.725,12.875),(-12.725,12.725),(-12.875,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,12.725),(7.925,12.875),(8.075,12.875),(8.075,12.725),(7.925,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,1.525),(-9.675,1.675),(-9.525,1.675),(-9.525,1.525),(-9.675,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-1.675),(9.525,-1.525),(9.675,-1.525),(9.675,-1.675),(9.525,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-25.675),(4.725,-25.525),(4.875,-25.525),(4.875,-25.675),(4.725,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,25.525),(4.725,25.675),(4.875,25.675),(4.875,25.525),(4.725,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,12.725),(-11.275,12.875),(-11.125,12.875),(-11.125,12.725),(-11.275,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,12.725),(11.125,12.875),(11.275,12.875),(11.275,12.725),(11.125,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-12.875),(12.725,-12.725),(12.875,-12.725),(12.875,-12.875),(12.725,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,9.525),(-19.275,9.675),(-19.125,9.675),(-19.125,9.525),(-19.275,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-16.075),(-22.475,-15.925),(-22.325,-15.925),(-22.325,-16.075),(-22.475,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-9.675),(19.125,-9.525),(19.275,-9.525),(19.275,-9.675),(19.125,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-16.075),(22.325,-15.925),(22.475,-15.925),(22.475,-16.075),(22.325,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,14.325),(-19.275,14.475),(-19.125,14.475),(-19.125,14.325),(-19.275,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,14.325),(19.125,14.475),(19.275,14.475),(19.275,14.325),(19.125,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,23.925),(14.325,24.075),(14.475,24.075),(14.475,23.925),(14.325,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-9.675),(-17.675,-9.525),(-17.525,-9.525),(-17.525,-9.675),(-17.675,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,9.525),(17.525,9.675),(17.675,9.675),(17.675,9.525),(17.525,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,15.925),(12.725,16.075),(12.875,16.075),(12.875,15.925),(12.725,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-12.875),(-3.275,-12.725),(-3.125,-12.725),(-3.125,-12.875),(-3.275,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-12.875),(3.125,-12.725),(3.275,-12.725),(3.275,-12.875),(3.125,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,6.325),(23.925,6.475),(24.075,6.475),(24.075,6.325),(23.925,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-3.275),(-12.875,-3.125),(-12.725,-3.125),(-12.725,-3.275),(-12.875,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,3.125),(-12.875,3.275),(-12.725,3.275),(-12.725,3.125),(-12.875,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-9.675),(-9.675,-9.525),(-9.525,-9.525),(-9.525,-9.675),(-9.675,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,9.525),(9.525,9.675),(9.675,9.675),(9.675,9.525),(9.525,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,12.725),(-22.475,12.875),(-22.325,12.875),(-22.325,12.725),(-22.475,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,12.725),(22.325,12.875),(22.475,12.875),(22.475,12.725),(22.325,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,3.125),(-24.075,3.275),(-23.925,3.275),(-23.925,3.125),(-24.075,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,23.925),(-1.675,24.075),(-1.525,24.075),(-1.525,23.925),(-1.675,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-25.675),(-11.275,-25.525),(-11.125,-25.525),(-11.125,-25.675),(-11.275,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-19.275),(-1.675,-19.125),(-1.525,-19.125),(-1.525,-19.275),(-1.675,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,19.125),(1.525,19.275),(1.675,19.275),(1.675,19.125),(1.525,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,25.525),(11.125,25.675),(11.275,25.675),(11.275,25.525),(11.125,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,4.725),(-25.675,4.875),(-25.525,4.875),(-25.525,4.725),(-25.675,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,4.725),(25.525,4.875),(25.675,4.875),(25.675,4.725),(25.525,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-9.675),(31.925,-9.525),(32.075,-9.525),(32.075,-9.675),(31.925,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,7.925),(30.325,8.075),(30.475,8.075),(30.475,7.925),(30.325,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,17.525),(23.925,17.675),(24.075,17.675),(24.075,17.525),(23.925,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-25.675),(-6.475,-25.525),(-6.325,-25.525),(-6.325,-25.675),(-6.475,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,25.525),(-6.475,25.675),(-6.325,25.675),(-6.325,25.525),(-6.475,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-14.475),(-22.475,-14.325),(-22.325,-14.325),(-22.325,-14.475),(-22.475,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,22.325),(-14.475,22.475),(-14.325,22.475),(-14.325,22.325),(-14.475,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-22.475),(14.325,-22.325),(14.475,-22.325),(14.475,-22.475),(14.325,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,14.325),(22.325,14.475),(22.475,14.475),(22.475,14.325),(22.325,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,22.325),(-16.075,22.475),(-15.925,22.475),(-15.925,22.325),(-16.075,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-9.675),(4.725,-9.525),(4.875,-9.525),(4.875,-9.675),(4.725,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,9.525),(4.725,9.675),(4.875,9.675),(4.875,9.525),(4.725,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,7.925),(-17.675,8.075),(-17.525,8.075),(-17.525,7.925),(-17.675,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,27.125),(-9.675,27.275),(-9.525,27.275),(-9.525,27.125),(-9.675,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-4.875),(-8.075,-4.725),(-7.925,-4.725),(-7.925,-4.875),(-8.075,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-27.275),(9.525,-27.125),(9.675,-27.125),(9.675,-27.275),(9.525,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-9.675),(-24.075,-9.525),(-23.925,-9.525),(-23.925,-9.675),(-24.075,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,3.125),(23.925,3.275),(24.075,3.275),(24.075,3.125),(23.925,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-27.275),(12.725,-27.125),(12.875,-27.125),(12.875,-27.275),(12.725,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,27.125),(12.725,27.275),(12.875,27.275),(12.875,27.125),(12.725,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,12.725),(-4.875,12.875),(-4.725,12.875),(-4.725,12.725),(-4.875,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-14.475),(-0.075,-14.325),(0.075,-14.325),(0.075,-14.475),(-0.075,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,14.325),(-0.075,14.475),(0.075,14.475),(0.075,14.325),(-0.075,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,6.325),(-32.075,6.475),(-31.925,6.475),(-31.925,6.325),(-32.075,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-12.875),(4.725,-12.725),(4.875,-12.725),(4.875,-12.875),(4.725,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,12.725),(-3.275,12.875),(-3.125,12.875),(-3.125,12.725),(-3.275,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-24.075),(-4.875,-23.925),(-4.725,-23.925),(-4.725,-24.075),(-4.875,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,12.725),(3.125,12.875),(3.275,12.875),(3.275,12.725),(3.125,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-24.075),(4.725,-23.925),(4.875,-23.925),(4.875,-24.075),(4.725,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-9.675),(14.325,-9.525),(14.475,-9.525),(14.475,-9.675),(14.325,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,9.525),(14.325,9.675),(14.475,9.675),(14.475,9.525),(14.325,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,-0.075),(-33.675,0.075),(-33.525,0.075),(-33.525,-0.075),(-33.675,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-4.875),(-1.675,-4.725),(-1.525,-4.725),(-1.525,-4.875),(-1.675,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-4.875),(1.525,-4.725),(1.675,-4.725),(1.675,-4.875),(1.525,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,7.925),(11.125,8.075),(11.275,8.075),(11.275,7.925),(11.125,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-12.875),(23.925,-12.725),(24.075,-12.725),(24.075,-12.875),(23.925,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,-0.075),(33.525,0.075),(33.675,0.075),(33.675,-0.075),(33.525,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-17.675),(-20.875,-17.525),(-20.725,-17.525),(-20.725,-17.675),(-20.875,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,17.525),(-20.875,17.675),(-20.725,17.675),(-20.725,17.525),(-20.875,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,15.925),(4.725,16.075),(4.875,16.075),(4.875,15.925),(4.725,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-3.275),(-6.475,-3.125),(-6.325,-3.125),(-6.325,-3.275),(-6.475,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,3.125),(-6.475,3.275),(-6.325,3.275),(-6.325,3.125),(-6.475,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-11.275),(14.325,-11.125),(14.475,-11.125),(14.475,-11.275),(14.325,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,11.125),(14.325,11.275),(14.475,11.275),(14.475,11.125),(14.325,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,7.925),(33.525,8.075),(33.675,8.075),(33.675,7.925),(33.525,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-25.675),(-3.275,-25.525),(-3.125,-25.525),(-3.125,-25.675),(-3.275,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-6.475),(-8.075,-6.325),(-7.925,-6.325),(-7.925,-6.475),(-8.075,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,25.525),(3.125,25.675),(3.275,25.675),(3.275,25.525),(3.125,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-0.075),(-12.875,0.075),(-12.725,0.075),(-12.725,-0.075),(-12.875,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-0.075),(12.725,0.075),(12.875,0.075),(12.875,-0.075),(12.725,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-4.875),(-14.475,-4.725),(-14.325,-4.725),(-14.325,-4.875),(-14.475,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,23.925),(-12.875,24.075),(-12.725,24.075),(-12.725,23.925),(-12.875,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-4.875),(14.325,-4.725),(14.475,-4.725),(14.475,-4.875),(14.325,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-1.675),(-16.075,-1.525),(-15.925,-1.525),(-15.925,-1.675),(-16.075,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,7.925),(9.525,8.075),(9.675,8.075),(9.675,7.925),(9.525,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,19.125),(-3.275,19.275),(-3.125,19.275),(-3.125,19.125),(-3.275,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-19.275),(3.125,-19.125),(3.275,-19.125),(3.275,-19.275),(3.125,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-8.075),(-4.875,-7.925),(-4.725,-7.925),(-4.725,-8.075),(-4.875,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-8.075),(4.725,-7.925),(4.875,-7.925),(4.875,-8.075),(4.725,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-11.275),(-8.075,-11.125),(-7.925,-11.125),(-7.925,-11.275),(-8.075,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,11.125),(4.725,11.275),(4.875,11.275),(4.875,11.125),(4.725,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-16.075),(-14.475,-15.925),(-14.325,-15.925),(-14.325,-16.075),(-14.475,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-20.875),(-16.075,-20.725),(-15.925,-20.725),(-15.925,-20.875),(-16.075,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-27.275),(4.725,-27.125),(4.875,-27.125),(4.875,-27.275),(4.725,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-6.475),(-19.275,-6.325),(-19.125,-6.325),(-19.125,-6.475),(-19.275,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,15.925),(-19.275,16.075),(-19.125,16.075),(-19.125,15.925),(-19.275,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-20.875),(-20.875,-20.725),(-20.725,-20.725),(-20.725,-20.875),(-20.875,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,27.125),(4.725,27.275),(4.875,27.275),(4.875,27.125),(4.725,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-27.275),(14.325,-27.125),(14.475,-27.125),(14.475,-27.275),(14.325,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-16.075),(14.325,-15.925),(14.475,-15.925),(14.475,-16.075),(14.325,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-9.675),(-28.875,-9.525),(-28.725,-9.525),(-28.725,-9.675),(-28.875,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,9.525),(-28.875,9.675),(-28.725,9.675),(-28.725,9.525),(-28.875,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,27.125),(14.325,27.275),(14.475,27.275),(14.475,27.125),(14.325,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-6.475),(19.125,-6.325),(19.275,-6.325),(19.275,-6.475),(19.125,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,20.725),(20.725,20.875),(20.875,20.875),(20.875,20.725),(20.725,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,-1.675),(-35.275,-1.525),(-35.125,-1.525),(-35.125,-1.675),(-35.275,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,12.725),(-24.075,12.875),(-23.925,12.875),(-23.925,12.725),(-24.075,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,1.525),(35.125,1.675),(35.275,1.675),(35.275,1.525),(35.125,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-12.875),(-25.675,-12.725),(-25.525,-12.725),(-25.525,-12.875),(-25.675,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-12.875),(15.925,-12.725),(16.075,-12.725),(16.075,-12.875),(15.925,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-12.875),(25.525,-12.725),(25.675,-12.725),(25.675,-12.875),(25.525,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-9.675),(-1.675,-9.525),(-1.525,-9.525),(-1.525,-9.675),(-1.675,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,9.525),(1.525,9.675),(1.675,9.675),(1.675,9.525),(1.525,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-20.875),(-14.475,-20.725),(-14.325,-20.725),(-14.325,-20.875),(-14.475,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,12.725),(-14.475,12.875),(-14.325,12.875),(-14.325,12.725),(-14.475,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,7.925),(-12.875,8.075),(-12.725,8.075),(-12.725,7.925),(-12.875,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,27.125),(-8.075,27.275),(-7.925,27.275),(-7.925,27.125),(-8.075,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-20.875),(14.325,-20.725),(14.475,-20.725),(14.475,-20.875),(14.325,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,12.725),(14.325,12.875),(14.475,12.875),(14.475,12.725),(14.325,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-4.875),(-32.075,-4.725),(-31.925,-4.725),(-31.925,-4.875),(-32.075,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-11.275),(-28.875,-11.125),(-28.725,-11.125),(-28.725,-11.275),(-28.875,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,11.125),(-28.875,11.275),(-28.725,11.275),(-28.725,11.125),(-28.875,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,14.325),(-24.075,14.475),(-23.925,14.475),(-23.925,14.325),(-24.075,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-0.075),(-11.275,0.075),(-11.125,0.075),(-11.125,-0.075),(-11.275,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-8.075),(-28.875,-7.925),(-28.725,-7.925),(-28.725,-8.075),(-28.875,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-0.075),(11.125,0.075),(11.275,0.075),(11.275,-0.075),(11.125,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-6.475),(20.725,-6.325),(20.875,-6.325),(20.875,-6.475),(20.725,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,6.325),(20.725,6.475),(20.875,6.475),(20.875,6.325),(20.725,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-8.075),(28.725,-7.925),(28.875,-7.925),(28.875,-8.075),(28.725,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-14.475),(-14.475,-14.325),(-14.325,-14.325),(-14.325,-14.475),(-14.475,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,14.325),(14.325,14.475),(14.475,14.475),(14.475,14.325),(14.325,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-19.275),(-14.475,-19.125),(-14.325,-19.125),(-14.325,-19.275),(-14.475,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,19.125),(-14.475,19.275),(-14.325,19.275),(-14.325,19.125),(-14.475,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-1.675),(-1.675,-1.525),(-1.525,-1.525),(-1.525,-1.675),(-1.675,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,1.525),(1.525,1.675),(1.675,1.675),(1.675,1.525),(1.525,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,15.925),(6.325,16.075),(6.475,16.075),(6.475,15.925),(6.325,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-22.475),(-16.075,-22.325),(-15.925,-22.325),(-15.925,-22.475),(-16.075,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,-3.275),(-36.875,-3.125),(-36.725,-3.125),(-36.725,-3.275),(-36.875,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,3.125),(-36.875,3.275),(-36.725,3.275),(-36.725,3.125),(-36.875,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-12.875),(-12.875,-12.725),(-12.725,-12.725),(-12.725,-12.875),(-12.875,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-24.075),(7.925,-23.925),(8.075,-23.925),(8.075,-24.075),(7.925,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,3.125),(-35.275,3.275),(-35.125,3.275),(-35.125,3.125),(-35.275,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-0.075),(-8.075,0.075),(-7.925,0.075),(-7.925,-0.075),(-8.075,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,12.725),(12.725,12.875),(12.875,12.875),(12.875,12.725),(12.725,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,-3.275),(35.125,-3.125),(35.275,-3.125),(35.275,-3.275),(35.125,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,14.325),(-25.675,14.475),(-25.525,14.475),(-25.525,14.325),(-25.675,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-9.675),(-16.075,-9.525),(-15.925,-9.525),(-15.925,-9.675),(-16.075,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-20.875),(-11.275,-20.725),(-11.125,-20.725),(-11.125,-20.875),(-11.275,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,7.925),(-1.675,8.075),(-1.525,8.075),(-1.525,7.925),(-1.675,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-20.875),(11.125,-20.725),(11.275,-20.725),(11.275,-20.875),(11.125,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,14.325),(25.525,14.475),(25.675,14.475),(25.675,14.325),(25.525,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-3.275),(-30.475,-3.125),(-30.325,-3.125),(-30.325,-3.275),(-30.475,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,3.125),(-30.475,3.275),(-30.325,3.275),(-30.325,3.125),(-30.475,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,-6.475),(-32.075,-6.325),(-31.925,-6.325),(-31.925,-6.475),(-32.075,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,14.325),(-6.475,14.475),(-6.325,14.475),(-6.325,14.325),(-6.475,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-14.475),(6.325,-14.325),(6.475,-14.325),(6.475,-14.475),(6.325,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,20.725),(-4.875,20.875),(-4.725,20.875),(-4.725,20.725),(-4.875,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-20.875),(4.725,-20.725),(4.875,-20.725),(4.875,-20.875),(4.725,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-8.075),(15.925,-7.925),(16.075,-7.925),(16.075,-8.075),(15.925,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-9.675),(-20.875,-9.525),(-20.725,-9.525),(-20.725,-9.675),(-20.875,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,9.525),(-20.875,9.675),(-20.725,9.675),(-20.725,9.525),(-20.875,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-4.875),(-19.275,-4.725),(-19.125,-4.725),(-19.125,-4.875),(-19.275,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-4.875),(19.125,-4.725),(19.275,-4.725),(19.275,-4.875),(19.125,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,19.125),(-17.675,19.275),(-17.525,19.275),(-17.525,19.125),(-17.675,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-19.275),(17.525,-19.125),(17.675,-19.125),(17.675,-19.275),(17.525,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,15.925),(-16.075,16.075),(-15.925,16.075),(-15.925,15.925),(-16.075,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-1.675),(-28.875,-1.525),(-28.725,-1.525),(-28.725,-1.675),(-28.875,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,1.525),(-28.875,1.675),(-28.725,1.675),(-28.725,1.525),(-28.875,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,23.925),(4.725,24.075),(4.875,24.075),(4.875,23.925),(4.725,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-17.675),(12.725,-17.525),(12.875,-17.525),(12.875,-17.675),(12.725,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,17.525),(12.725,17.675),(12.875,17.675),(12.875,17.525),(12.725,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-11.275),(-20.875,-11.125),(-20.725,-11.125),(-20.725,-11.275),(-20.875,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,11.125),(-20.875,11.275),(-20.725,11.275),(-20.725,11.125),(-20.875,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,1.525),(-3.275,1.675),(-3.125,1.675),(-3.125,1.525),(-3.275,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-1.675),(3.125,-1.525),(3.275,-1.525),(3.275,-1.675),(3.125,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-9.675),(7.925,-9.525),(8.075,-9.525),(8.075,-9.675),(7.925,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,11.125),(7.925,11.275),(8.075,11.275),(8.075,11.125),(7.925,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,6.325),(-3.275,6.475),(-3.125,6.475),(-3.125,6.325),(-3.275,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,6.325),(3.125,6.475),(3.275,6.475),(3.275,6.325),(3.125,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-22.475),(7.925,-22.325),(8.075,-22.325),(8.075,-22.475),(7.925,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,20.725),(7.925,20.875),(8.075,20.875),(8.075,20.725),(7.925,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-14.475),(-25.675,-14.325),(-25.525,-14.325),(-25.525,-14.475),(-25.675,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-14.475),(25.525,-14.325),(25.675,-14.325),(25.675,-14.475),(25.525,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-0.075),(-0.075,0.075),(0.075,0.075),(0.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-3.275),(22.325,-3.125),(22.475,-3.125),(22.475,-3.275),(22.325,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,3.125),(22.325,3.275),(22.475,3.275),(22.475,3.125),(22.325,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-12.875),(-4.875,-12.725),(-4.725,-12.725),(-4.725,-12.875),(-4.875,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,7.925),(-6.475,8.075),(-6.325,8.075),(-6.325,7.925),(-6.475,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,3.125),(-11.275,3.275),(-11.125,3.275),(-11.125,3.125),(-11.275,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,12.725),(4.725,12.875),(4.875,12.875),(4.875,12.725),(4.725,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,20.725),(-6.475,20.875),(-6.325,20.875),(-6.325,20.725),(-6.475,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,20.725),(6.325,20.875),(6.475,20.875),(6.475,20.725),(6.325,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,22.325),(-9.675,22.475),(-9.525,22.475),(-9.525,22.325),(-9.675,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,22.325),(9.525,22.475),(9.675,22.475),(9.675,22.325),(9.525,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-3.275),(11.125,-3.125),(11.275,-3.125),(11.275,-3.275),(11.125,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-3.275),(23.925,-3.125),(24.075,-3.125),(24.075,-3.275),(23.925,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-0.075),(-1.675,0.075),(-1.525,0.075),(-1.525,-0.075),(-1.675,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,23.925),(-3.275,24.075),(-3.125,24.075),(-3.125,23.925),(-3.275,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-0.075),(1.525,0.075),(1.675,0.075),(1.675,-0.075),(1.525,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-6.475),(15.925,-6.325),(16.075,-6.325),(16.075,-6.475),(15.925,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,4.725),(15.925,4.875),(16.075,4.875),(16.075,4.725),(15.925,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,7.925),(4.725,8.075),(4.875,8.075),(4.875,7.925),(4.725,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,4.725),(-19.275,4.875),(-19.125,4.875),(-19.125,4.725),(-19.275,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,4.725),(19.125,4.875),(19.275,4.875),(19.275,4.725),(19.125,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,12.725),(-16.075,12.875),(-15.925,12.875),(-15.925,12.725),(-16.075,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-20.875),(-9.675,-20.725),(-9.525,-20.725),(-9.525,-20.875),(-9.675,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-20.875),(9.525,-20.725),(9.675,-20.725),(9.675,-20.875),(9.525,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,4.725),(-36.875,4.875),(-36.725,4.875),(-36.725,4.725),(-36.875,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,-4.875),(36.725,-4.725),(36.875,-4.725),(36.875,-4.875),(36.725,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-16.075),(-17.675,-15.925),(-17.525,-15.925),(-17.525,-16.075),(-17.675,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-16.075),(17.525,-15.925),(17.675,-15.925),(17.675,-16.075),(17.525,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-22.475),(-4.875,-22.325),(-4.725,-22.325),(-4.725,-22.475),(-4.875,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,22.325),(-4.875,22.475),(-4.725,22.475),(-4.725,22.325),(-4.875,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-8.075),(-6.475,-7.925),(-6.325,-7.925),(-6.325,-8.075),(-6.475,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-8.075),(6.325,-7.925),(6.475,-7.925),(6.475,-8.075),(6.325,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,6.325),(-27.275,6.475),(-27.125,6.475),(-27.125,6.325),(-27.275,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,6.325),(27.125,6.475),(27.275,6.475),(27.275,6.325),(27.125,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-11.275),(-22.475,-11.125),(-22.325,-11.125),(-22.325,-11.275),(-22.475,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,11.125),(-22.475,11.275),(-22.325,11.275),(-22.325,11.125),(-22.475,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,14.325),(-16.075,14.475),(-15.925,14.475),(-15.925,14.325),(-16.075,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,17.525),(7.925,17.675),(8.075,17.675),(8.075,17.525),(7.925,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-16.075),(-9.675,-15.925),(-9.525,-15.925),(-9.525,-16.075),(-9.675,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,22.325),(-17.675,22.475),(-17.525,22.475),(-17.525,22.325),(-17.675,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-16.075),(9.525,-15.925),(9.675,-15.925),(9.675,-16.075),(9.525,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,22.325),(17.525,22.475),(17.675,22.475),(17.675,22.325),(17.525,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,1.525),(31.925,1.675),(32.075,1.675),(32.075,1.525),(31.925,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,3.125),(-25.675,3.275),(-25.525,3.275),(-25.525,3.125),(-25.675,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-11.275),(-17.675,-11.125),(-17.525,-11.125),(-17.525,-11.275),(-17.675,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-24.075),(-8.075,-23.925),(-7.925,-23.925),(-7.925,-24.075),(-8.075,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,11.125),(17.525,11.275),(17.675,11.275),(17.675,11.125),(17.525,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,-3.275),(25.525,-3.125),(25.675,-3.125),(25.675,-3.275),(25.525,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,4.725),(-6.475,4.875),(-6.325,4.875),(-6.325,4.725),(-6.475,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,4.725),(6.325,4.875),(6.475,4.875),(6.475,4.725),(6.325,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,15.925),(-9.675,16.075),(-9.525,16.075),(-9.525,15.925),(-9.675,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-17.675),(14.325,-17.525),(14.475,-17.525),(14.475,-17.675),(14.325,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,17.525),(14.325,17.675),(14.475,17.675),(14.475,17.525),(14.325,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-11.275),(-9.675,-11.125),(-9.525,-11.125),(-9.525,-11.275),(-9.675,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,11.125),(9.525,11.275),(9.675,11.275),(9.675,11.125),(9.525,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-24.075),(-3.275,-23.925),(-3.125,-23.925),(-3.125,-24.075),(-3.275,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-24.075),(3.125,-23.925),(3.275,-23.925),(3.275,-24.075),(3.125,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-19.275),(-8.075,-19.125),(-7.925,-19.125),(-7.925,-19.275),(-8.075,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-16.075),(-0.075,-15.925),(0.075,-15.925),(0.075,-16.075),(-0.075,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,9.525),(31.925,9.675),(32.075,9.675),(32.075,9.525),(31.925,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,7.925),(28.725,8.075),(28.875,8.075),(28.875,7.925),(28.725,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,15.925),(1.525,16.075),(1.675,16.075),(1.675,15.925),(1.525,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-4.875),(-9.675,-4.725),(-9.525,-4.725),(-9.525,-4.875),(-9.675,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-4.875),(9.525,-4.725),(9.675,-4.725),(9.675,-4.875),(9.525,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-12.875),(-22.475,-12.725),(-22.325,-12.725),(-22.325,-12.875),(-22.475,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-12.875),(22.325,-12.725),(22.475,-12.725),(22.475,-12.875),(22.325,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-25.675),(-14.475,-25.525),(-14.325,-25.525),(-14.325,-25.675),(-14.475,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,25.525),(-14.475,25.675),(-14.325,25.675),(-14.325,25.525),(-14.475,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-6.475),(-4.875,-6.325),(-4.725,-6.325),(-4.725,-6.475),(-4.875,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,6.325),(-4.875,6.475),(-4.725,6.475),(-4.725,6.325),(-4.875,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-6.475),(-22.475,-6.325),(-22.325,-6.325),(-22.325,-6.475),(-22.475,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-19.275),(11.125,-19.125),(11.275,-19.125),(11.275,-19.275),(11.125,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,23.925),(7.925,24.075),(8.075,24.075),(8.075,23.925),(7.925,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,6.325),(22.325,6.475),(22.475,6.475),(22.475,6.325),(22.325,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,23.925),(-14.475,24.075),(-14.325,24.075),(-14.325,23.925),(-14.475,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,9.525),(-17.675,9.675),(-17.525,9.675),(-17.525,9.525),(-17.675,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,17.525),(-1.675,17.675),(-1.525,17.675),(-1.525,17.525),(-1.675,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-17.675),(-4.875,-17.525),(-4.725,-17.525),(-4.725,-17.675),(-4.875,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,15.925),(-12.875,16.075),(-12.725,16.075),(-12.725,15.925),(-12.875,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,17.525),(-4.875,17.675),(-4.725,17.675),(-4.725,17.525),(-4.875,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-17.675),(1.525,-17.525),(1.675,-17.525),(1.675,-17.675),(1.525,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-9.675),(17.525,-9.525),(17.675,-9.525),(17.675,-9.675),(17.525,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-14.475),(-11.275,-14.325),(-11.125,-14.325),(-11.125,-14.475),(-11.275,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-14.475),(11.125,-14.325),(11.275,-14.325),(11.275,-14.475),(11.125,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,4.725),(-12.875,4.875),(-12.725,4.875),(-12.725,4.725),(-12.875,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-4.875),(12.725,-4.725),(12.875,-4.725),(12.875,-4.875),(12.725,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,9.525),(-9.675,9.675),(-9.525,9.675),(-9.525,9.525),(-9.675,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-9.675),(9.525,-9.525),(9.675,-9.525),(9.675,-9.675),(9.525,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-4.875),(31.925,-4.725),(32.075,-4.725),(32.075,-4.875),(31.925,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-0.075),(-19.275,0.075),(-19.125,0.075),(-19.125,-0.075),(-19.275,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-0.075),(19.125,0.075),(19.275,0.075),(19.275,-0.075),(19.125,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-9.675),(-30.475,-9.525),(-30.325,-9.525),(-30.325,-9.675),(-30.475,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,9.525),(-30.475,9.675),(-30.325,9.675),(-30.325,9.525),(-30.475,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,25.525),(-11.275,25.675),(-11.125,25.675),(-11.125,25.525),(-11.275,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,19.125),(-1.675,19.275),(-1.525,19.275),(-1.525,19.125),(-1.675,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-19.275),(1.525,-19.125),(1.675,-19.125),(1.675,-19.275),(1.525,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-8.075),(-3.275,-7.925),(-3.125,-7.925),(-3.125,-8.075),(-3.275,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,12.725),(-17.675,12.875),(-17.525,12.875),(-17.525,12.725),(-17.675,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-8.075),(3.125,-7.925),(3.275,-7.925),(3.275,-8.075),(3.125,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-25.675),(11.125,-25.525),(11.275,-25.525),(11.275,-25.675),(11.125,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,7.925),(-30.475,8.075),(-30.325,8.075),(-30.325,7.925),(-30.475,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,1.525),(-17.675,1.675),(-17.525,1.675),(-17.525,1.525),(-17.675,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,7.925),(15.925,8.075),(16.075,8.075),(16.075,7.925),(15.925,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-1.675),(17.525,-1.525),(17.675,-1.525),(17.675,-1.675),(17.525,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,12.725),(17.525,12.875),(17.675,12.875),(17.675,12.725),(17.525,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-25.675),(6.325,-25.525),(6.475,-25.525),(6.475,-25.675),(6.325,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,25.525),(6.325,25.675),(6.475,25.675),(6.475,25.525),(6.325,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-24.075),(-14.475,-23.925),(-14.325,-23.925),(-14.325,-24.075),(-14.475,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-24.075),(14.325,-23.925),(14.475,-23.925),(14.475,-24.075),(14.325,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,12.725),(-9.675,12.875),(-9.525,12.875),(-9.525,12.725),(-9.675,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-20.875),(7.925,-20.725),(8.075,-20.725),(8.075,-20.875),(7.925,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,12.725),(9.525,12.875),(9.675,12.875),(9.675,12.725),(9.525,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-24.075),(15.925,-23.925),(16.075,-23.925),(16.075,-24.075),(15.925,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,7.925),(-8.075,8.075),(-7.925,8.075),(-7.925,7.925),(-8.075,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-3.275),(-3.275,-3.125),(-3.125,-3.125),(-3.125,-3.275),(-3.275,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,3.125),(3.125,3.275),(3.275,3.275),(3.275,3.125),(3.125,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-24.075),(-9.675,-23.925),(-9.525,-23.925),(-9.525,-24.075),(-9.675,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-20.875),(-19.275,-20.725),(-19.125,-20.725),(-19.125,-20.875),(-19.275,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-24.075),(9.525,-23.925),(9.675,-23.925),(9.675,-24.075),(9.525,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-6.475),(-28.875,-6.325),(-28.725,-6.325),(-28.725,-6.475),(-28.875,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,6.325),(-28.875,6.475),(-28.725,6.475),(-28.725,6.325),(-28.875,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-17.675),(-11.275,-17.525),(-11.125,-17.525),(-11.125,-17.675),(-11.275,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,17.525),(11.125,17.675),(11.275,17.675),(11.275,17.525),(11.125,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-8.075),(-16.075,-7.925),(-15.925,-7.925),(-15.925,-8.075),(-16.075,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-20.875),(19.125,-20.725),(19.275,-20.725),(19.275,-20.875),(19.125,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,11.125),(28.725,11.275),(28.875,11.275),(28.875,11.125),(28.725,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-24.075),(-0.075,-23.925),(0.075,-23.925),(0.075,-24.075),(-0.075,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-1.675),(-22.475,-1.525),(-22.325,-1.525),(-22.325,-1.675),(-22.475,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,1.525),(-22.475,1.675),(-22.325,1.675),(-22.325,1.525),(-22.475,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-8.075),(-30.475,-7.925),(-30.325,-7.925),(-30.325,-8.075),(-30.475,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-1.675),(-0.075,-1.525),(0.075,-1.525),(0.075,-1.675),(-0.075,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,1.525),(-0.075,1.675),(0.075,1.675),(0.075,1.525),(-0.075,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-8.075),(30.325,-7.925),(30.475,-7.925),(30.475,-8.075),(30.325,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,-3.275),(-16.075,-3.125),(-15.925,-3.125),(-15.925,-3.275),(-16.075,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-20.875),(-4.875,-20.725),(-4.725,-20.725),(-4.725,-20.875),(-4.875,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,20.725),(4.725,20.875),(4.875,20.875),(4.875,20.725),(4.725,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-8.075),(-27.275,-7.925),(-27.125,-7.925),(-27.125,-8.075),(-27.275,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-8.075),(27.125,-7.925),(27.275,-7.925),(27.275,-8.075),(27.125,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,7.925),(-11.275,8.075),(-11.125,8.075),(-11.125,7.925),(-11.275,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,-1.675),(-33.675,-1.525),(-33.525,-1.525),(-33.525,-1.675),(-33.675,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,1.525),(33.525,1.675),(33.675,1.675),(33.675,1.525),(33.525,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,4.725),(-30.475,4.875),(-30.325,4.875),(-30.325,4.725),(-30.475,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-24.075),(-17.675,-23.925),(-17.525,-23.925),(-17.525,-24.075),(-17.675,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,15.925),(-4.875,16.075),(-4.725,16.075),(-4.725,15.925),(-4.875,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-24.075),(17.525,-23.925),(17.675,-23.925),(17.675,-24.075),(17.525,-24.075)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-17.675),(20.725,-17.525),(20.875,-17.525),(20.875,-17.675),(20.725,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,17.525),(20.725,17.675),(20.875,17.675),(20.875,17.525),(20.725,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,4.725),(30.325,4.875),(30.475,4.875),(30.475,4.725),(30.325,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-19.275),(12.725,-19.125),(12.875,-19.125),(12.875,-19.275),(12.725,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,19.125),(12.725,19.275),(12.875,19.275),(12.875,19.125),(12.725,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-14.475),(-3.275,-14.325),(-3.125,-14.325),(-3.125,-14.475),(-3.275,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-14.475),(3.125,-14.325),(3.275,-14.325),(3.275,-14.475),(3.125,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,19.125),(22.325,19.275),(22.475,19.275),(22.475,19.125),(22.325,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,7.925),(22.325,8.075),(22.475,8.075),(22.475,7.925),(22.325,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-11.275),(-14.475,-11.125),(-14.325,-11.125),(-14.325,-11.275),(-14.475,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,11.125),(-14.475,11.275),(-14.325,11.275),(-14.325,11.125),(-14.475,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-3.275),(-27.275,-3.125),(-27.125,-3.125),(-27.125,-3.275),(-27.275,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-16.075),(7.925,-15.925),(8.075,-15.925),(8.075,-16.075),(7.925,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,-4.875),(7.925,-4.725),(8.075,-4.725),(8.075,-4.875),(7.925,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-19.275),(22.325,-19.125),(22.475,-19.125),(22.475,-19.275),(22.325,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,-0.075),(-35.275,0.075),(-35.125,0.075),(-35.125,-0.075),(-35.275,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,7.925),(-33.675,8.075),(-33.525,8.075),(-33.525,7.925),(-33.675,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-12.875),(-0.075,-12.725),(0.075,-12.725),(0.075,-12.875),(-0.075,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,12.725),(-0.075,12.875),(0.075,12.875),(0.075,12.725),(-0.075,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,25.525),(-3.275,25.675),(-3.125,25.675),(-3.125,25.525),(-3.275,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,4.725),(-8.075,4.875),(-7.925,4.875),(-7.925,4.725),(-8.075,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-25.675),(3.125,-25.525),(3.275,-25.525),(3.275,-25.675),(3.125,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,-0.075),(35.125,0.075),(35.275,0.075),(35.275,-0.075),(35.125,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-22.475),(15.925,-22.325),(16.075,-22.325),(16.075,-22.475),(15.925,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,20.725),(15.925,20.875),(16.075,20.875),(16.075,20.725),(15.925,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,19.125),(19.125,19.275),(19.275,19.275),(19.275,19.125),(19.125,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-12.875),(-27.275,-12.725),(-27.125,-12.725),(-27.125,-12.875),(-27.275,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,7.925),(-9.675,8.075),(-9.525,8.075),(-9.525,7.925),(-9.675,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,22.325),(7.925,22.475),(8.075,22.475),(8.075,22.325),(7.925,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,-12.875),(27.125,-12.725),(27.275,-12.725),(27.275,-12.875),(27.125,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-17.675),(-0.075,-17.525),(0.075,-17.525),(0.075,-17.675),(-0.075,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,17.525),(-0.075,17.675),(0.075,17.675),(0.075,17.525),(-0.075,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-3.275),(20.725,-3.125),(20.875,-3.125),(20.875,-3.275),(20.725,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,3.125),(20.725,3.275),(20.875,3.275),(20.875,3.125),(20.725,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,-6.475),(33.525,-6.325),(33.675,-6.325),(33.675,-6.475),(33.525,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,23.925),(1.525,24.075),(1.675,24.075),(1.675,23.925),(1.525,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,22.325),(-6.475,22.475),(-6.325,22.475),(-6.325,22.325),(-6.475,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-22.475),(6.325,-22.325),(6.475,-22.325),(6.475,-22.475),(6.325,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,20.725),(-9.675,20.875),(-9.525,20.875),(-9.525,20.725),(-9.675,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,9.525),(-32.075,9.675),(-31.925,9.675),(-31.925,9.525),(-32.075,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,20.725),(9.525,20.875),(9.675,20.875),(9.675,20.725),(9.525,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,23.925),(-16.075,24.075),(-15.925,24.075),(-15.925,23.925),(-16.075,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,6.325),(-24.075,6.475),(-23.925,6.475),(-23.925,6.325),(-24.075,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-12.875),(-14.475,-12.725),(-14.325,-12.725),(-14.325,-12.875),(-14.475,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-12.875),(14.325,-12.725),(14.475,-12.725),(14.475,-12.875),(14.325,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,6.325),(-17.675,6.475),(-17.525,6.475),(-17.525,6.325),(-17.675,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,6.325),(15.925,6.475),(16.075,6.475),(16.075,6.325),(15.925,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,6.325),(17.525,6.475),(17.675,6.475),(17.675,6.325),(17.525,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-14.475),(20.725,-14.325),(20.875,-14.325),(20.875,-14.475),(20.725,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,14.325),(20.725,14.475),(20.875,14.475),(20.875,14.325),(20.725,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-3.275),(-4.875,-3.125),(-4.725,-3.125),(-4.725,-3.275),(-4.875,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,3.125),(-4.875,3.275),(-4.725,3.275),(-4.725,3.125),(-4.875,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,-4.875),(-36.875,-4.725),(-36.725,-4.725),(-36.725,-4.875),(-36.875,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-27.275),(-14.475,-27.125),(-14.325,-27.125),(-14.325,-27.275),(-14.475,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,27.125),(-14.475,27.275),(-14.325,27.275),(-14.325,27.125),(-14.475,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((36.725,4.725),(36.725,4.875),(36.875,4.875),(36.875,4.725),(36.725,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-9.675),(28.725,-9.525),(28.875,-9.525),(28.875,-9.675),(28.725,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,9.525),(28.725,9.675),(28.875,9.675),(28.875,9.525),(28.725,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,15.925),(25.525,16.075),(25.675,16.075),(25.675,15.925),(25.525,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-35.275,1.525),(-35.275,1.675),(-35.125,1.675),(-35.125,1.525),(-35.275,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((35.125,-1.675),(35.125,-1.525),(35.275,-1.525),(35.275,-1.675),(35.125,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,7.925),(-32.075,8.075),(-31.925,8.075),(-31.925,7.925),(-32.075,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,17.525),(15.925,17.675),(16.075,17.675),(16.075,17.525),(15.925,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-1.675),(-12.875,-1.525),(-12.725,-1.525),(-12.725,-1.675),(-12.875,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,1.525),(-12.875,1.675),(-12.725,1.675),(-12.725,1.525),(-12.875,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-25.675),(-8.075,-25.525),(-7.925,-25.525),(-7.925,-25.675),(-8.075,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,20.725),(-17.675,20.875),(-17.525,20.875),(-17.525,20.725),(-17.675,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,1.525),(-24.075,1.675),(-23.925,1.675),(-23.925,1.525),(-24.075,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,12.725),(-28.875,12.875),(-28.725,12.875),(-28.725,12.725),(-28.875,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,20.725),(17.525,20.875),(17.675,20.875),(17.675,20.725),(17.525,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,-14.475),(23.925,-14.325),(24.075,-14.325),(24.075,-14.475),(23.925,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((23.925,12.725),(23.925,12.875),(24.075,12.875),(24.075,12.725),(23.925,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,-12.875),(28.725,-12.725),(28.875,-12.725),(28.875,-12.875),(28.725,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,12.725),(-27.275,12.875),(-27.125,12.875),(-27.125,12.725),(-27.275,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,12.725),(27.125,12.875),(27.275,12.875),(27.275,12.725),(27.125,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,6.325),(-6.475,6.475),(-6.325,6.475),(-6.325,6.325),(-6.475,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-6.475),(6.325,-6.325),(6.475,-6.325),(6.475,-6.475),(6.325,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,12.725),(-1.675,12.875),(-1.525,12.875),(-1.525,12.725),(-1.675,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,12.725),(1.525,12.875),(1.675,12.875),(1.675,12.725),(1.525,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,15.925),(-6.475,16.075),(-6.325,16.075),(-6.325,15.925),(-6.475,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-12.875),(-19.275,-12.725),(-19.125,-12.725),(-19.125,-12.875),(-19.275,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,-12.875),(19.125,-12.725),(19.275,-12.725),(19.275,-12.875),(19.125,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,20.725),(-16.075,20.875),(-15.925,20.875),(-15.925,20.725),(-16.075,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-3.275),(-28.875,-3.125),(-28.725,-3.125),(-28.725,-3.275),(-28.875,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,3.125),(-28.875,3.275),(-28.725,3.275),(-28.725,3.125),(-28.875,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-1.675),(15.925,-1.525),(16.075,-1.525),(16.075,-1.675),(15.925,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,3.125),(15.925,3.275),(16.075,3.275),(16.075,3.125),(15.925,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-25.675,-9.675),(-25.675,-9.525),(-25.525,-9.525),(-25.525,-9.675),(-25.675,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,9.525),(25.525,9.675),(25.675,9.675),(25.675,9.525),(25.525,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-6.475),(-17.675,-6.325),(-17.525,-6.325),(-17.525,-6.475),(-17.675,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-6.475),(17.525,-6.325),(17.675,-6.325),(17.675,-6.475),(17.525,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,23.925),(15.925,24.075),(16.075,24.075),(16.075,23.925),(15.925,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,7.925),(3.125,8.075),(3.275,8.075),(3.275,7.925),(3.125,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,9.525),(7.925,9.675),(8.075,9.675),(8.075,9.525),(7.925,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,3.125),(-16.075,3.275),(-15.925,3.275),(-15.925,3.125),(-16.075,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-0.075),(31.925,0.075),(32.075,0.075),(32.075,-0.075),(31.925,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-32.075,4.725),(-32.075,4.875),(-31.925,4.875),(-31.925,4.725),(-32.075,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-4.875),(-12.875,-4.725),(-12.725,-4.725),(-12.725,-4.875),(-12.875,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,4.725),(12.725,4.875),(12.875,4.875),(12.875,4.725),(12.725,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-9.675),(20.725,-9.525),(20.875,-9.525),(20.875,-9.675),(20.725,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,9.525),(20.725,9.675),(20.875,9.675),(20.875,9.525),(20.725,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,1.525),(-11.275,1.675),(-11.125,1.675),(-11.125,1.525),(-11.275,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-4.875),(-24.075,-4.725),(-23.925,-4.725),(-23.925,-4.875),(-24.075,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-1.675),(11.125,-1.525),(11.275,-1.525),(11.275,-1.675),(11.125,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-33.675,-4.875),(-33.675,-4.725),(-33.525,-4.725),(-33.525,-4.875),(-33.675,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((33.525,-4.875),(33.525,-4.725),(33.675,-4.725),(33.675,-4.875),(33.525,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-27.275),(-11.275,-27.125),(-11.125,-27.125),(-11.125,-27.275),(-11.275,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,27.125),(11.125,27.275),(11.275,27.275),(11.275,27.125),(11.125,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,23.925),(-4.875,24.075),(-4.725,24.075),(-4.725,23.925),(-4.875,23.925)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-17.675),(-22.475,-17.525),(-22.325,-17.525),(-22.325,-17.675),(-22.475,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,17.525),(-22.475,17.675),(-22.325,17.675),(-22.325,17.525),(-22.475,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-14.475),(-12.875,-14.325),(-12.725,-14.325),(-12.725,-14.475),(-12.875,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,14.325),(-12.875,14.475),(-12.725,14.475),(-12.725,14.325),(-12.875,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-20.875),(15.925,-20.725),(16.075,-20.725),(16.075,-20.875),(15.925,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,12.725),(-20.875,12.875),(-20.725,12.875),(-20.725,12.725),(-20.875,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-14.475),(15.925,-14.325),(16.075,-14.325),(16.075,-14.475),(15.925,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,15.925),(-8.075,16.075),(-7.925,16.075),(-7.925,15.925),(-8.075,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,12.725),(15.925,12.875),(16.075,12.875),(16.075,12.725),(15.925,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-20.875),(-6.475,-20.725),(-6.325,-20.725),(-6.325,-20.875),(-6.475,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-20.875),(6.325,-20.725),(6.475,-20.725),(6.475,-20.875),(6.325,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,12.725),(-19.275,12.875),(-19.125,12.875),(-19.125,12.725),(-19.275,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,12.725),(19.125,12.875),(19.275,12.875),(19.275,12.725),(19.125,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-12.875),(20.725,-12.725),(20.875,-12.725),(20.875,-12.875),(20.725,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((-19.275,-17.675),(-19.275,-17.525),(-19.125,-17.525),(-19.125,-17.675),(-19.275,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((19.125,17.525),(19.125,17.675),(19.275,17.675),(19.275,17.525),(19.125,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,15.925),(7.925,16.075),(8.075,16.075),(8.075,15.925),(7.925,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,7.925),(27.125,8.075),(27.275,8.075),(27.275,7.925),(27.125,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-8.075),(-17.675,-7.925),(-17.525,-7.925),(-17.525,-8.075),(-17.675,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,14.325),(-1.675,14.475),(-1.525,14.475),(-1.525,14.325),(-1.675,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-16.075,19.125),(-16.075,19.275),(-15.925,19.275),(-15.925,19.125),(-16.075,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,14.325),(1.525,14.475),(1.675,14.475),(1.675,14.325),(1.525,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-8.075),(17.525,-7.925),(17.675,-7.925),(17.675,-8.075),(17.525,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,15.925),(20.725,16.075),(20.875,16.075),(20.875,15.925),(20.725,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,-27.275),(-12.875,-27.125),(-12.725,-27.125),(-12.725,-27.275),(-12.875,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-12.875,27.125),(-12.875,27.275),(-12.725,27.275),(-12.725,27.125),(-12.875,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-16.075),(-11.275,-15.925),(-11.125,-15.925),(-11.125,-16.075),(-11.275,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-16.075),(11.125,-15.925),(11.275,-15.925),(11.275,-16.075),(11.125,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-3.275),(-22.475,-3.125),(-22.325,-3.125),(-22.325,-3.275),(-22.475,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,3.125),(-22.475,3.275),(-22.325,3.275),(-22.325,3.125),(-22.475,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,15.925),(-14.475,16.075),(-14.325,16.075),(-14.325,15.925),(-14.475,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-17.675),(-9.675,-17.525),(-9.525,-17.525),(-9.525,-17.675),(-9.675,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,17.525),(9.525,17.675),(9.675,17.675),(9.675,17.525),(9.525,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-3.275),(-17.675,-3.125),(-17.525,-3.125),(-17.525,-3.275),(-17.675,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-6.475),(-24.075,-6.325),(-23.925,-6.325),(-23.925,-6.475),(-24.075,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,-16.075),(-8.075,-15.925),(-7.925,-15.925),(-7.925,-16.075),(-8.075,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,3.125),(17.525,3.275),(17.675,3.275),(17.675,3.125),(17.525,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-11.275),(-11.275,-11.125),(-11.125,-11.125),(-11.125,-11.275),(-11.275,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,11.125),(11.125,11.275),(11.275,11.275),(11.275,11.125),(11.125,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,7.925),(-4.875,8.075),(-4.725,8.075),(-4.725,7.925),(-4.875,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((25.525,7.925),(25.525,8.075),(25.675,8.075),(25.675,7.925),(25.525,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,27.125),(-1.675,27.275),(-1.525,27.275),(-1.525,27.125),(-1.675,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-27.275),(1.525,-27.125),(1.675,-27.125),(1.675,-27.275),(1.525,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,6.325),(-30.475,6.475),(-30.325,6.475),(-30.325,6.325),(-30.475,6.325)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-19.275),(20.725,-19.125),(20.875,-19.125),(20.875,-19.275),(20.725,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,-0.075),(-9.675,0.075),(-9.525,0.075),(-9.525,-0.075),(-9.675,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-0.075),(9.525,0.075),(9.675,0.075),(9.675,-0.075),(9.525,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,19.125),(20.725,19.275),(20.875,19.275),(20.875,19.125),(20.725,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-6.475),(30.325,-6.325),(30.475,-6.325),(30.475,-6.475),(30.325,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((-14.475,-0.075),(-14.475,0.075),(-14.325,0.075),(-14.325,-0.075),(-14.475,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-4.875),(-6.475,-4.725),(-6.325,-4.725),(-6.325,-4.875),(-6.475,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-0.075),(-3.275,0.075),(-3.125,0.075),(-3.125,-0.075),(-3.275,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-8.075),(-20.875,-7.925),(-20.725,-7.925),(-20.725,-8.075),(-20.875,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,7.925),(1.525,8.075),(1.675,8.075),(1.675,7.925),(1.525,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-0.075),(3.125,0.075),(3.275,0.075),(3.275,-0.075),(3.125,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-9.675),(-11.275,-9.525),(-11.125,-9.525),(-11.125,-9.675),(-11.275,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-4.875),(6.325,-4.725),(6.475,-4.725),(6.475,-4.875),(6.325,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,9.525),(11.125,9.675),(11.275,9.675),(11.275,9.525),(11.125,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-0.075),(14.325,0.075),(14.475,0.075),(14.475,-0.075),(14.325,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((20.725,-8.075),(20.725,-7.925),(20.875,-7.925),(20.875,-8.075),(20.725,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-24.075,-11.275),(-24.075,-11.125),(-23.925,-11.125),(-23.925,-11.275),(-24.075,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,-17.675),(-17.675,-17.525),(-17.525,-17.525),(-17.525,-17.675),(-17.675,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-27.275),(-3.275,-27.125),(-3.125,-27.125),(-3.125,-27.275),(-3.275,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-0.075),(22.325,0.075),(22.475,0.075),(22.475,-0.075),(22.325,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,-0.075),(-22.475,0.075),(-22.325,0.075),(-22.325,-0.075),(-22.475,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,27.125),(3.125,27.275),(3.275,27.275),(3.275,27.125),(3.125,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,17.525),(17.525,17.675),(17.675,17.675),(17.675,17.525),(17.525,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,22.325),(15.925,22.475),(16.075,22.475),(16.075,22.325),(15.925,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-9.675),(-6.475,-9.525),(-6.325,-9.525),(-6.325,-9.675),(-6.475,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,9.525),(-6.475,9.675),(-6.325,9.675),(-6.325,9.525),(-6.475,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,11.125),(-17.675,11.275),(-17.525,11.275),(-17.525,11.125),(-17.675,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-14.475),(-4.875,-14.325),(-4.725,-14.325),(-4.725,-14.475),(-4.875,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,14.325),(-4.875,14.475),(-4.725,14.475),(-4.725,14.325),(-4.875,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,-11.275),(17.525,-11.125),(17.675,-11.125),(17.675,-11.275),(17.525,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,20.725),(-1.675,20.875),(-1.525,20.875),(-1.525,20.725),(-1.675,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,20.725),(1.525,20.875),(1.675,20.875),(1.675,20.725),(1.525,20.725)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-20.875),(-3.275,-20.725),(-3.125,-20.725),(-3.125,-20.875),(-3.275,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-20.875),(3.125,-20.725),(3.275,-20.725),(3.275,-20.875),(3.125,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((-9.675,11.125),(-9.675,11.275),(-9.525,11.275),(-9.525,11.125),(-9.675,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.525,-11.275),(9.525,-11.125),(9.675,-11.125),(9.675,-11.275),(9.525,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,-1.675),(-36.875,-1.525),(-36.725,-1.525),(-36.725,-1.675),(-36.875,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-36.875,1.525),(-36.875,1.675),(-36.725,1.675),(-36.725,1.525),(-36.875,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,7.925),(-28.875,8.075),(-28.725,8.075),(-28.725,7.925),(-28.875,7.925)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,15.925),(-1.675,16.075),(-1.525,16.075),(-1.525,15.925),(-1.675,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-1.675),(-6.475,-1.525),(-6.325,-1.525),(-6.325,-1.675),(-6.475,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,1.525),(-6.475,1.675),(-6.325,1.675),(-6.325,1.525),(-6.475,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,-27.275),(-4.875,-27.125),(-4.725,-27.125),(-4.725,-27.275),(-4.875,-27.275)),
        )
        createRL(
            tech, net, 'via',
            ((-4.875,27.125),(-4.875,27.275),(-4.725,27.275),(-4.725,27.125),(-4.875,27.125)),
        )
        createRL(
            tech, net, 'via',
            ((-17.675,4.725),(-17.675,4.875),(-17.525,4.875),(-17.525,4.725),(-17.675,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-22.475),(-11.275,-22.325),(-11.125,-22.325),(-11.125,-22.475),(-11.275,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-16.075),(-3.275,-15.925),(-3.125,-15.925),(-3.125,-16.075),(-3.275,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-16.075),(3.125,-15.925),(3.275,-15.925),(3.275,-16.075),(3.125,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-22.475),(11.125,-22.325),(11.275,-22.325),(11.275,-22.475),(11.125,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-11.275),(12.725,-11.125),(12.875,-11.125),(12.875,-11.275),(12.725,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,11.125),(12.725,11.275),(12.875,11.275),(12.875,11.125),(12.725,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((17.525,4.725),(17.525,4.875),(17.675,4.875),(17.675,4.725),(17.525,4.725)),
        )
        createRL(
            tech, net, 'via',
            ((-1.675,-6.475),(-1.675,-6.325),(-1.525,-6.325),(-1.525,-6.475),(-1.675,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((1.525,-6.475),(1.525,-6.325),(1.675,-6.325),(1.675,-6.475),(1.525,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,-25.675),(14.325,-25.525),(14.475,-25.525),(14.475,-25.675),(14.325,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,25.525),(14.325,25.675),(14.475,25.675),(14.475,25.525),(14.325,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,15.925),(22.325,16.075),(22.475,16.075),(22.475,15.925),(22.325,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-11.275),(-3.275,-11.125),(-3.125,-11.125),(-3.125,-11.275),(-3.275,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,11.125),(3.125,11.275),(3.275,11.275),(3.275,11.125),(3.125,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,-1.675),(-20.875,-1.525),(-20.725,-1.525),(-20.725,-1.675),(-20.875,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-20.875,1.525),(-20.875,1.675),(-20.725,1.675),(-20.725,1.525),(-20.875,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-17.675),(4.725,-17.525),(4.875,-17.525),(4.875,-17.675),(4.725,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,17.525),(4.725,17.675),(4.875,17.675),(4.875,17.525),(4.725,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((7.925,14.325),(7.925,14.475),(8.075,14.475),(8.075,14.325),(7.925,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,25.525),(-8.075,25.675),(-7.925,25.675),(-7.925,25.525),(-8.075,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((-28.875,-12.875),(-28.875,-12.725),(-28.725,-12.725),(-28.725,-12.875),(-28.875,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-19.275),(6.325,-19.125),(6.475,-19.125),(6.475,-19.275),(6.325,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,19.125),(6.325,19.275),(6.475,19.275),(6.475,19.125),(6.325,19.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,12.725),(28.725,12.875),(28.875,12.875),(28.875,12.725),(28.725,12.725)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,-22.475),(12.725,-22.325),(12.875,-22.325),(12.875,-22.475),(12.725,-22.475)),
        )
        createRL(
            tech, net, 'via',
            ((12.725,22.325),(12.725,22.475),(12.875,22.475),(12.875,22.325),(12.725,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,-9.675),(-3.275,-9.525),(-3.125,-9.525),(-3.125,-9.675),(-3.275,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,9.525),(3.125,9.675),(3.275,9.675),(3.275,9.525),(3.125,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,-25.675),(-0.075,-25.525),(0.075,-25.525),(0.075,-25.675),(-0.075,-25.675)),
        )
        createRL(
            tech, net, 'via',
            ((-0.075,25.525),(-0.075,25.675),(0.075,25.675),(0.075,25.525),(-0.075,25.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,3.125),(27.125,3.275),(27.275,3.275),(27.275,3.125),(27.125,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-9.675),(30.325,-9.525),(30.475,-9.525),(30.475,-9.675),(30.325,-9.675)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,9.525),(30.325,9.675),(30.475,9.675),(30.475,9.525),(30.325,9.525)),
        )
        createRL(
            tech, net, 'via',
            ((-6.475,-0.075),(-6.475,0.075),(-6.325,0.075),(-6.325,-0.075),(-6.475,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((6.325,-0.075),(6.325,0.075),(6.475,0.075),(6.475,-0.075),(6.325,-0.075)),
        )
        createRL(
            tech, net, 'via',
            ((28.725,3.125),(28.725,3.275),(28.875,3.275),(28.875,3.125),(28.725,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((-22.475,14.325),(-22.475,14.475),(-22.325,14.475),(-22.325,14.325),(-22.475,14.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.325,15.925),(14.325,16.075),(14.475,16.075),(14.475,15.925),(14.325,15.925)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-14.475),(22.325,-14.325),(22.475,-14.325),(22.475,-14.475),(22.325,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,-6.475),(-11.275,-6.325),(-11.125,-6.325),(-11.125,-6.475),(-11.275,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-6.475),(11.125,-6.325),(11.275,-6.325),(11.275,-6.475),(11.125,-6.475)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-11.275),(30.325,-11.125),(30.475,-11.125),(30.475,-11.275),(30.325,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,11.125),(30.325,11.275),(30.475,11.275),(30.475,11.125),(30.325,11.125)),
        )
        createRL(
            tech, net, 'via',
            ((-3.275,3.125),(-3.275,3.275),(-3.125,3.275),(-3.125,3.125),(-3.275,3.125)),
        )
        createRL(
            tech, net, 'via',
            ((3.125,-3.275),(3.125,-3.125),(3.275,-3.125),(3.275,-3.275),(3.125,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((15.925,-3.275),(15.925,-3.125),(16.075,-3.125),(16.075,-3.275),(15.925,-3.275)),
        )
        createRL(
            tech, net, 'via',
            ((31.925,-8.075),(31.925,-7.925),(32.075,-7.925),(32.075,-8.075),(31.925,-8.075)),
        )
        createRL(
            tech, net, 'via',
            ((-27.275,-1.675),(-27.275,-1.525),(-27.125,-1.525),(-27.125,-1.675),(-27.275,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,17.525),(-11.275,17.675),(-11.125,17.675),(-11.125,17.525),(-11.275,17.525)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,-17.675),(11.125,-17.525),(11.275,-17.525),(11.275,-17.675),(11.125,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((27.125,1.525),(27.125,1.675),(27.275,1.675),(27.275,1.525),(27.125,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((-11.275,22.325),(-11.275,22.475),(-11.125,22.475),(-11.125,22.325),(-11.275,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((11.125,22.325),(11.125,22.475),(11.275,22.475),(11.275,22.325),(11.125,22.325)),
        )
        createRL(
            tech, net, 'via',
            ((-30.475,-4.875),(-30.475,-4.725),(-30.325,-4.725),(-30.325,-4.875),(-30.475,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((30.325,-4.875),(30.325,-4.725),(30.475,-4.725),(30.475,-4.875),(30.325,-4.875)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,-1.675),(22.325,-1.525),(22.475,-1.525),(22.475,-1.675),(22.325,-1.675)),
        )
        createRL(
            tech, net, 'via',
            ((22.325,1.525),(22.325,1.675),(22.475,1.675),(22.475,1.525),(22.325,1.525)),
        )
        createRL(
            tech, net, 'via',
            ((4.725,-11.275),(4.725,-11.125),(4.875,-11.125),(4.875,-11.275),(4.725,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((-8.075,9.525),(-8.075,9.675),(-7.925,9.675),(-7.925,9.525),(-8.075,9.525)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-15.3),(18.3,-15.1),(18.5,-15.1),(18.5,-15.3),(18.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,15.1),(18.3,15.3),(18.5,15.3),(18.5,15.1),(18.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-16.9),(-20.1,-16.7),(-19.9,-16.7),(-19.9,-16.9),(-20.1,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-4.1),(-8.9,-3.9),(-8.7,-3.9),(-8.7,-4.1),(-8.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-13.7),(-2.5,-13.5),(-2.3,-13.5),(-2.3,-13.7),(-2.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,13.5),(-2.5,13.7),(-2.3,13.7),(-2.3,13.5),(-2.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-8.9),(-26.5,-8.7),(-26.3,-8.7),(-26.3,-8.9),(-26.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-13.7),(-8.9,-13.5),(-8.7,-13.5),(-8.7,-13.7),(-8.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,13.5),(-8.9,13.7),(-8.7,13.7),(-8.7,13.5),(-8.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-8.9),(26.3,-8.7),(26.5,-8.7),(26.5,-8.9),(26.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-15.3),(10.3,-15.1),(10.5,-15.1),(10.5,-15.3),(10.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,15.1),(10.3,15.3),(10.5,15.3),(10.5,15.1),(10.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,8.7),(16.7,8.9),(16.9,8.9),(16.9,8.7),(16.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-2.5),(27.9,-2.3),(28.1,-2.3),(28.1,-2.5),(27.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,19.9),(3.9,20.1),(4.1,20.1),(4.1,19.9),(3.9,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-5.7),(-4.1,-5.5),(-3.9,-5.5),(-3.9,-5.7),(-4.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,5.5),(-34.5,5.7),(-34.3,5.7),(-34.3,5.5),(-34.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,-5.7),(-34.5,-5.5),(-34.3,-5.5),(-34.3,-5.7),(-34.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-8.9),(-2.5,-8.7),(-2.3,-8.7),(-2.3,-8.9),(-2.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-8.9),(2.3,-8.7),(2.5,-8.7),(2.5,-8.9),(2.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-2.5),(-23.3,-2.3),(-23.1,-2.3),(-23.1,-2.5),(-23.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,26.3),(-15.3,26.5),(-15.1,26.5),(-15.1,26.3),(-15.3,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,8.7),(8.7,8.9),(8.9,8.9),(8.9,8.7),(8.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,26.3),(15.1,26.5),(15.3,26.5),(15.3,26.3),(15.1,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-2.5),(23.1,-2.3),(23.3,-2.3),(23.3,-2.5),(23.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,16.7),(-4.1,16.9),(-3.9,16.9),(-3.9,16.7),(-4.1,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-15.3),(-8.9,-15.1),(-8.7,-15.1),(-8.7,-15.3),(-8.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,15.1),(-8.9,15.3),(-8.7,15.3),(-8.7,15.1),(-8.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-5.7),(-5.7,-5.5),(-5.5,-5.5),(-5.5,-5.7),(-5.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,5.5),(5.5,5.7),(5.7,5.7),(5.7,5.5),(5.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-20.1),(-12.1,-19.9),(-11.9,-19.9),(-11.9,-20.1),(-12.1,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-0.9),(-7.3,-0.7),(-7.1,-0.7),(-7.1,-0.9),(-7.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,11.9),(-29.7,12.1),(-29.5,12.1),(-29.5,11.9),(-29.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,0.7),(-7.3,0.9),(-7.1,0.9),(-7.1,0.7),(-7.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-18.5),(-0.9,-18.3),(-0.7,-18.3),(-0.7,-18.5),(-0.9,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,18.3),(-0.9,18.5),(-0.7,18.5),(-0.7,18.3),(-0.9,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-18.5),(0.7,-18.3),(0.9,-18.3),(0.9,-18.5),(0.7,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-5.7),(-0.9,-5.5),(-0.7,-5.5),(-0.7,-5.7),(-0.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,5.5),(-0.9,5.7),(-0.7,5.7),(-0.7,5.5),(-0.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-5.7),(0.7,-5.5),(0.9,-5.5),(0.9,-5.7),(0.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-7.3),(-20.1,-7.1),(-19.9,-7.1),(-19.9,-7.3),(-20.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-16.9),(-24.9,-16.7),(-24.7,-16.7),(-24.7,-16.9),(-24.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-0.9),(-24.9,-0.7),(-24.7,-0.7),(-24.7,-0.9),(-24.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,0.7),(-24.9,0.9),(-24.7,0.9),(-24.7,0.7),(-24.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,11.9),(-15.3,12.1),(-15.1,12.1),(-15.1,11.9),(-15.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,5.5),(0.7,5.7),(0.9,5.7),(0.9,5.5),(0.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,19.9),(-0.9,20.1),(-0.7,20.1),(-0.7,19.9),(-0.9,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,19.9),(0.7,20.1),(0.9,20.1),(0.9,19.9),(0.7,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-0.9),(8.7,-0.7),(8.9,-0.7),(8.9,-0.9),(8.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,0.7),(8.7,0.9),(8.9,0.9),(8.9,0.7),(8.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,3.9),(13.5,4.1),(13.7,4.1),(13.7,3.9),(13.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,7.1),(-15.3,7.3),(-15.1,7.3),(-15.1,7.1),(-15.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-7.3),(15.1,-7.1),(15.3,-7.1),(15.3,-7.3),(15.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,3.9),(3.9,4.1),(4.1,4.1),(4.1,3.9),(3.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-8.9),(16.7,-8.7),(16.9,-8.7),(16.9,-8.9),(16.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-4.1),(-20.1,-3.9),(-19.9,-3.9),(-19.9,-4.1),(-20.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-8.9),(-15.3,-8.7),(-15.1,-8.7),(-15.1,-8.9),(-15.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-5.7),(-28.1,-5.5),(-27.9,-5.5),(-27.9,-5.7),(-28.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-8.9),(15.1,-8.7),(15.3,-8.7),(15.3,-8.9),(15.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-4.1),(-0.9,-3.9),(-0.7,-3.9),(-0.7,-4.1),(-0.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-4.1),(0.7,-3.9),(0.9,-3.9),(0.9,-4.1),(0.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-12.1),(-13.7,-11.9),(-13.5,-11.9),(-13.5,-12.1),(-13.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-12.1),(13.5,-11.9),(13.7,-11.9),(13.7,-12.1),(13.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,3.9),(16.7,4.1),(16.9,4.1),(16.9,3.9),(16.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-10.5),(-0.9,-10.3),(-0.7,-10.3),(-0.7,-10.5),(-0.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,10.3),(-0.9,10.5),(-0.7,10.5),(-0.7,10.3),(-0.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-5.7),(-29.7,-5.5),(-29.5,-5.5),(-29.5,-5.7),(-29.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-15.3),(-15.3,-15.1),(-15.1,-15.1),(-15.1,-15.3),(-15.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-10.5),(0.7,-10.3),(0.9,-10.3),(0.9,-10.5),(0.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,10.3),(0.7,10.5),(0.9,10.5),(0.9,10.3),(0.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,18.3),(-7.3,18.5),(-7.1,18.5),(-7.1,18.3),(-7.3,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,18.3),(7.1,18.5),(7.3,18.5),(7.3,18.3),(7.1,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-21.7),(10.3,-21.5),(10.5,-21.5),(10.5,-21.7),(10.3,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,21.5),(10.3,21.7),(10.5,21.7),(10.5,21.5),(10.3,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-26.5),(11.9,-26.3),(12.1,-26.3),(12.1,-26.5),(11.9,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,24.7),(11.9,24.9),(12.1,24.9),(12.1,24.7),(11.9,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,16.7),(16.7,16.9),(16.9,16.9),(16.9,16.7),(16.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-0.9),(19.9,-0.7),(20.1,-0.7),(20.1,-0.9),(19.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,0.7),(19.9,0.9),(20.1,0.9),(20.1,0.7),(19.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-20.1),(-16.9,-19.9),(-16.7,-19.9),(-16.7,-20.1),(-16.9,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,5.5),(27.9,5.7),(28.1,5.7),(28.1,5.5),(27.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-13.7),(-15.3,-13.5),(-15.1,-13.5),(-15.1,-13.7),(-15.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,5.5),(-7.3,5.7),(-7.1,5.7),(-7.1,5.5),(-7.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-5.7),(7.1,-5.5),(7.3,-5.5),(7.3,-5.7),(7.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,13.5),(15.1,13.7),(15.3,13.7),(15.3,13.5),(15.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,24.7),(-13.7,24.9),(-13.5,24.9),(-13.5,24.7),(-13.7,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,24.7),(13.5,24.9),(13.7,24.9),(13.7,24.7),(13.5,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,3.9),(27.9,4.1),(28.1,4.1),(28.1,3.9),(27.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-20.1),(-10.5,-19.9),(-10.3,-19.9),(-10.3,-20.1),(-10.5,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-7.3),(8.7,-7.1),(8.9,-7.1),(8.9,-7.3),(8.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,7.1),(8.7,7.3),(8.9,7.3),(8.9,7.1),(8.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-20.1),(10.3,-19.9),(10.5,-19.9),(10.5,-20.1),(10.3,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,11.9),(-21.7,12.1),(-21.5,12.1),(-21.5,11.9),(-21.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-26.5),(8.7,-26.3),(8.9,-26.3),(8.9,-26.5),(8.7,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,26.3),(8.7,26.5),(8.9,26.5),(8.9,26.3),(8.7,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,-4.1),(-32.9,-3.9),(-32.7,-3.9),(-32.7,-4.1),(-32.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,18.3),(3.9,18.5),(4.1,18.5),(4.1,18.3),(3.9,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,3.9),(-12.1,4.1),(-11.9,4.1),(-11.9,3.9),(-12.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-5.7),(10.3,-5.5),(10.5,-5.5),(10.5,-5.7),(10.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,5.5),(10.3,5.7),(10.5,5.7),(10.5,5.5),(10.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,2.3),(-7.3,2.5),(-7.1,2.5),(-7.1,2.3),(-7.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-24.9),(-5.7,-24.7),(-5.5,-24.7),(-5.5,-24.9),(-5.7,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-24.9),(5.5,-24.7),(5.7,-24.7),(5.7,-24.9),(5.5,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,2.3),(7.1,2.5),(7.3,2.5),(7.3,2.3),(7.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-12.1),(11.9,-11.9),(12.1,-11.9),(12.1,-12.1),(11.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-8.9),(11.9,-8.7),(12.1,-8.7),(12.1,-8.9),(11.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,11.9),(18.3,12.1),(18.5,12.1),(18.5,11.9),(18.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,3.9),(-26.5,4.1),(-26.3,4.1),(-26.3,3.9),(-26.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,-5.7),(32.7,-5.5),(32.9,-5.5),(32.9,-5.7),(32.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,5.5),(32.7,5.7),(32.9,5.7),(32.9,5.5),(32.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,-4.1),(-34.5,-3.9),(-34.3,-3.9),(-34.3,-4.1),(-34.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,-4.1),(34.3,-3.9),(34.5,-3.9),(34.5,-4.1),(34.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-12.1),(-5.7,-11.9),(-5.5,-11.9),(-5.5,-12.1),(-5.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-12.1),(5.5,-11.9),(5.7,-11.9),(5.7,-12.1),(5.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,11.9),(10.3,12.1),(10.5,12.1),(10.5,11.9),(10.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,3.9),(-2.5,4.1),(-2.3,4.1),(-2.3,3.9),(-2.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,2.3),(-4.1,2.5),(-3.9,2.5),(-3.9,2.3),(-4.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,8.7),(-13.7,8.9),(-13.5,8.9),(-13.5,8.7),(-13.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,8.7),(13.5,8.9),(13.7,8.9),(13.7,8.7),(13.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-7.3),(26.3,-7.1),(26.5,-7.1),(26.5,-7.3),(26.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,7.1),(26.3,7.3),(26.5,7.3),(26.5,7.1),(26.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,5.5),(-4.1,5.7),(-3.9,5.7),(-3.9,5.5),(-4.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-26.5),(3.9,-26.3),(4.1,-26.3),(4.1,-26.5),(3.9,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-4.1),(-10.5,-3.9),(-10.3,-3.9),(-10.3,-4.1),(-10.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,24.7),(3.9,24.9),(4.1,24.9),(4.1,24.7),(3.9,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-0.9),(-23.3,-0.7),(-23.1,-0.7),(-23.1,-0.9),(-23.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,0.7),(-23.3,0.9),(-23.1,0.9),(-23.1,0.7),(-23.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-0.9),(23.1,-0.7),(23.3,-0.7),(23.3,-0.9),(23.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,0.7),(23.1,0.9),(23.3,0.9),(23.3,0.7),(23.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-4.1),(10.3,-3.9),(10.5,-3.9),(10.5,-4.1),(10.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,2.3),(3.9,2.5),(4.1,2.5),(4.1,2.3),(3.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-0.9),(7.1,-0.7),(7.3,-0.7),(7.3,-0.9),(7.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-7.3),(2.3,-7.1),(2.5,-7.1),(2.5,-7.3),(2.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,7.1),(2.3,7.3),(2.5,7.3),(2.5,7.1),(2.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,7.1),(-5.7,7.3),(-5.5,7.3),(-5.5,7.1),(-5.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-0.9),(-12.1,-0.7),(-11.9,-0.7),(-11.9,-0.9),(-12.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,0.7),(-12.1,0.9),(-11.9,0.9),(-11.9,0.7),(-12.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-7.3),(5.5,-7.1),(5.7,-7.1),(5.7,-7.3),(5.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,15.1),(15.1,15.3),(15.3,15.3),(15.3,15.1),(15.1,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-0.9),(24.7,-0.7),(24.9,-0.7),(24.9,-0.9),(24.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-18.5),(-8.9,-18.3),(-8.7,-18.3),(-8.7,-18.5),(-8.9,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,18.3),(-8.9,18.5),(-8.7,18.5),(-8.7,18.3),(-8.9,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-8.9),(-5.7,-8.7),(-5.5,-8.7),(-5.5,-8.9),(-5.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,24.7),(-5.7,24.9),(-5.5,24.9),(-5.5,24.7),(-5.7,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-16.9),(-16.9,-16.7),(-16.7,-16.7),(-16.7,-16.9),(-16.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-16.9),(-0.9,-16.7),(-0.7,-16.7),(-0.7,-16.9),(-0.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,21.5),(-15.3,21.7),(-15.1,21.7),(-15.1,21.5),(-15.3,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-16.9),(0.7,-16.7),(0.9,-16.7),(0.9,-16.9),(0.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-8.9),(5.5,-8.7),(5.7,-8.7),(5.7,-8.9),(5.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,24.7),(5.5,24.9),(5.7,24.9),(5.7,24.7),(5.5,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-21.7),(15.1,-21.5),(15.3,-21.5),(15.3,-21.7),(15.1,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,7.1),(-20.1,7.3),(-19.9,7.3),(-19.9,7.1),(-20.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-18.5),(-23.3,-18.3),(-23.1,-18.3),(-23.1,-18.5),(-23.3,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-18.5),(23.1,-18.3),(23.3,-18.3),(23.3,-18.5),(23.1,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,10.3),(-26.5,10.5),(-26.3,10.5),(-26.3,10.3),(-26.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-10.5),(26.3,-10.3),(26.5,-10.3),(26.5,-10.5),(26.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,2.3),(-28.1,2.5),(-27.9,2.5),(-27.9,2.3),(-28.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-21.7),(-8.9,-21.5),(-8.7,-21.5),(-8.7,-21.7),(-8.9,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,21.5),(-8.9,21.7),(-8.7,21.7),(-8.7,21.5),(-8.9,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-20.1),(-7.3,-19.9),(-7.1,-19.9),(-7.1,-20.1),(-7.3,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,5.5),(-28.1,5.7),(-27.9,5.7),(-27.9,5.5),(-28.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-20.1),(7.1,-19.9),(7.3,-19.9),(7.3,-20.1),(7.1,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-15.3),(19.9,-15.1),(20.1,-15.1),(20.1,-15.3),(19.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,5.5),(-31.3,5.7),(-31.1,5.7),(-31.1,5.5),(-31.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-5.7),(31.1,-5.5),(31.3,-5.5),(31.3,-5.7),(31.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-2.5),(-26.5,-2.3),(-26.3,-2.3),(-26.3,-2.5),(-26.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,11.9),(-24.9,12.1),(-24.7,12.1),(-24.7,11.9),(-24.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,2.3),(26.3,2.5),(26.5,2.5),(26.5,2.3),(26.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,2.3),(27.9,2.5),(28.1,2.5),(28.1,2.3),(27.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-21.7),(-18.5,-21.5),(-18.3,-21.5),(-18.3,-21.7),(-18.5,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,21.5),(-18.5,21.7),(-18.3,21.7),(-18.3,21.5),(-18.5,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,3.9),(-23.3,4.1),(-23.1,4.1),(-23.1,3.9),(-23.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,-7.3),(-34.5,-7.1),(-34.3,-7.1),(-34.3,-7.3),(-34.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,7.1),(-34.5,7.3),(-34.3,7.3),(-34.3,7.1),(-34.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,7.1),(-29.7,7.3),(-29.5,7.3),(-29.5,7.1),(-29.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-7.3),(29.5,-7.1),(29.7,-7.1),(29.7,-7.3),(29.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-2.5),(-2.5,-2.3),(-2.3,-2.3),(-2.3,-2.5),(-2.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,2.3),(2.3,2.5),(2.5,2.5),(2.5,2.3),(2.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-12.1),(3.9,-11.9),(4.1,-11.9),(4.1,-12.1),(3.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,3.9),(-0.9,4.1),(-0.7,4.1),(-0.7,3.9),(-0.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-2.5),(-8.9,-2.3),(-8.7,-2.3),(-8.7,-2.5),(-8.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,2.3),(-8.9,2.5),(-8.7,2.5),(-8.7,2.3),(-8.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,3.9),(0.7,4.1),(0.9,4.1),(0.9,3.9),(0.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-8.9),(-29.7,-8.7),(-29.5,-8.7),(-29.5,-8.9),(-29.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,8.7),(-5.7,8.9),(-5.5,8.9),(-5.5,8.7),(-5.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,16.7),(-16.9,16.9),(-16.7,16.9),(-16.7,16.7),(-16.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,8.7),(5.5,8.9),(5.7,8.9),(5.7,8.7),(5.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-8.9),(29.5,-8.7),(29.7,-8.7),(29.7,-8.9),(29.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-24.9),(-12.1,-24.7),(-11.9,-24.7),(-11.9,-24.9),(-12.1,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-20.1),(-20.1,-19.9),(-19.9,-19.9),(-19.9,-20.1),(-20.1,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,2.3),(-21.7,2.5),(-21.5,2.5),(-21.5,2.3),(-21.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,2.3),(21.5,2.5),(21.7,2.5),(21.7,2.3),(21.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,19.9),(10.3,20.1),(10.5,20.1),(10.5,19.9),(10.3,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-7.3),(-7.3,-7.1),(-7.1,-7.1),(-7.1,-7.3),(-7.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,7.1),(7.1,7.3),(7.3,7.3),(7.3,7.1),(7.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,2.3),(-31.3,2.5),(-31.1,2.5),(-31.1,2.3),(-31.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,2.3),(31.1,2.5),(31.3,2.5),(31.3,2.3),(31.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-5.7),(3.9,-5.5),(4.1,-5.5),(4.1,-5.7),(3.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,7.1),(3.9,7.3),(4.1,7.3),(4.1,7.1),(3.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-13.7),(-12.1,-13.5),(-11.9,-13.5),(-11.9,-13.7),(-12.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,19.9),(-5.7,20.1),(-5.5,20.1),(-5.5,19.9),(-5.7,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-4.1),(-7.3,-3.9),(-7.1,-3.9),(-7.1,-4.1),(-7.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-4.1),(7.1,-3.9),(7.3,-3.9),(7.3,-4.1),(7.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-13.7),(-13.7,-13.5),(-13.5,-13.5),(-13.5,-13.7),(-13.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,13.5),(13.5,13.7),(13.7,13.7),(13.7,13.5),(13.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-13.7),(16.7,-13.5),(16.9,-13.5),(16.9,-13.7),(16.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,13.5),(16.7,13.7),(16.9,13.7),(16.9,13.5),(16.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-10.5),(-7.3,-10.3),(-7.1,-10.3),(-7.1,-10.5),(-7.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-15.3),(-12.1,-15.1),(-11.9,-15.1),(-11.9,-15.3),(-12.1,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-10.5),(7.1,-10.3),(7.3,-10.3),(7.3,-10.5),(7.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-5.7),(-23.3,-5.5),(-23.1,-5.5),(-23.1,-5.7),(-23.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,5.5),(23.1,5.7),(23.3,5.7),(23.3,5.5),(23.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-18.5),(-13.7,-18.3),(-13.5,-18.3),(-13.5,-18.5),(-13.7,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-18.5),(13.5,-18.3),(13.7,-18.3),(13.7,-18.5),(13.5,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,19.9),(18.3,20.1),(18.5,20.1),(18.5,19.9),(18.3,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,26.3),(-12.1,26.5),(-11.9,26.5),(-11.9,26.3),(-12.1,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-13.7),(8.7,-13.5),(8.9,-13.5),(8.9,-13.7),(8.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,13.5),(8.7,13.7),(8.9,13.7),(8.9,13.5),(8.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-8.9),(-12.1,-8.7),(-11.9,-8.7),(-11.9,-8.9),(-12.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-12.1),(-12.1,-11.9),(-11.9,-11.9),(-11.9,-12.1),(-12.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-16.9),(-7.3,-16.7),(-7.1,-16.7),(-7.1,-16.9),(-7.3,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-16.9),(7.1,-16.7),(7.3,-16.7),(7.3,-16.9),(7.1,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-18.5),(16.7,-18.3),(16.9,-18.3),(16.9,-18.5),(16.7,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,18.3),(16.7,18.5),(16.9,18.5),(16.9,18.3),(16.7,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,15.1),(-23.3,15.3),(-23.1,15.3),(-23.1,15.1),(-23.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-15.3),(23.1,-15.1),(23.3,-15.1),(23.3,-15.3),(23.1,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-5.7),(-16.9,-5.5),(-16.7,-5.5),(-16.7,-5.7),(-16.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,5.5),(-16.9,5.7),(-16.7,5.7),(-16.7,5.5),(-16.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,11.9),(11.9,12.1),(12.1,12.1),(12.1,11.9),(11.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,3.9),(-36.1,4.1),(-35.9,4.1),(-35.9,3.9),(-36.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-24.9),(-8.9,-24.7),(-8.7,-24.7),(-8.7,-24.9),(-8.9,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-5.7),(27.9,-5.5),(28.1,-5.5),(28.1,-5.7),(27.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,7.1),(27.9,7.3),(28.1,7.3),(28.1,7.1),(27.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-2.5),(-4.1,-2.3),(-3.9,-2.3),(-3.9,-2.5),(-4.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-2.5),(-21.7,-2.3),(-21.5,-2.3),(-21.5,-2.5),(-21.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,24.7),(-7.3,24.9),(-7.1,24.9),(-7.1,24.7),(-7.3,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-5.7),(-26.5,-5.5),(-26.3,-5.5),(-26.3,-5.7),(-26.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,5.5),(-26.5,5.7),(-26.3,5.7),(-26.3,5.5),(-26.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,24.7),(7.1,24.9),(7.3,24.9),(7.3,24.7),(7.1,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-2.5),(21.5,-2.3),(21.7,-2.3),(21.7,-2.5),(21.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-0.9),(-26.5,-0.7),(-26.3,-0.7),(-26.3,-0.9),(-26.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,0.7),(-26.5,0.9),(-26.3,0.9),(-26.3,0.7),(-26.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-0.9),(26.3,-0.7),(26.5,-0.7),(26.5,-0.9),(26.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,0.7),(26.3,0.9),(26.5,0.9),(26.5,0.7),(26.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,13.5),(-23.3,13.7),(-23.1,13.7),(-23.1,13.5),(-23.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-13.7),(23.1,-13.5),(23.3,-13.5),(23.3,-13.7),(23.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,-4.1),(32.7,-3.9),(32.9,-3.9),(32.9,-4.1),(32.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-5.7),(-2.5,-5.5),(-2.3,-5.5),(-2.3,-5.7),(-2.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,5.5),(-2.5,5.7),(-2.3,5.7),(-2.3,5.5),(-2.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-0.9),(-8.9,-0.7),(-8.7,-0.7),(-8.7,-0.9),(-8.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,0.7),(-8.9,0.9),(-8.7,0.9),(-8.7,0.7),(-8.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-23.3),(-13.7,-23.1),(-13.5,-23.1),(-13.5,-23.3),(-13.7,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,23.1),(13.5,23.3),(13.7,23.3),(13.7,23.1),(13.5,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-13.7),(-4.1,-13.5),(-3.9,-13.5),(-3.9,-13.7),(-4.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-4.1),(8.7,-3.9),(8.9,-3.9),(8.9,-4.1),(8.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-23.3),(-15.3,-23.1),(-15.1,-23.1),(-15.1,-23.3),(-15.3,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,21.5),(-5.7,21.7),(-5.5,21.7),(-5.5,21.5),(-5.7,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-21.7),(5.5,-21.5),(5.7,-21.5),(5.7,-21.7),(5.5,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,23.1),(15.1,23.3),(15.3,23.3),(15.3,23.1),(15.1,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-7.3),(-8.9,-7.1),(-8.7,-7.1),(-8.7,-7.3),(-8.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-20.1),(-13.7,-19.9),(-13.5,-19.9),(-13.5,-20.1),(-13.7,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,7.1),(-8.9,7.3),(-8.7,7.3),(-8.7,7.1),(-8.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-20.1),(13.5,-19.9),(13.7,-19.9),(13.7,-20.1),(13.5,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,-2.5),(-32.9,-2.3),(-32.7,-2.3),(-32.7,-2.5),(-32.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,2.3),(-32.9,2.5),(-32.7,2.5),(-32.7,2.3),(-32.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-13.7),(-5.7,-13.5),(-5.5,-13.5),(-5.5,-13.7),(-5.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,13.5),(5.5,13.7),(5.7,13.7),(5.7,13.5),(5.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-15.3),(-4.1,-15.1),(-3.9,-15.1),(-3.9,-15.3),(-4.1,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-15.3),(-18.5,-15.1),(-18.3,-15.1),(-18.3,-15.3),(-18.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,15.1),(-18.5,15.3),(-18.3,15.3),(-18.3,15.1),(-18.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-7.3),(-21.7,-7.1),(-21.5,-7.1),(-21.5,-7.3),(-21.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-2.5),(-28.1,-2.3),(-27.9,-2.3),(-27.9,-2.5),(-28.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-8.9),(-8.9,-8.7),(-8.7,-8.7),(-8.7,-8.9),(-8.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,11.9),(-16.9,12.1),(-16.7,12.1),(-16.7,11.9),(-16.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,7.1),(21.5,7.3),(21.7,7.3),(21.7,7.1),(21.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,-7.3),(32.7,-7.1),(32.9,-7.1),(32.9,-7.3),(32.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-13.7),(2.3,-13.5),(2.5,-13.5),(2.5,-13.7),(2.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,13.5),(2.3,13.7),(2.5,13.7),(2.5,13.5),(2.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-7.3),(-31.3,-7.1),(-31.1,-7.1),(-31.1,-7.3),(-31.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,7.1),(31.1,7.3),(31.3,7.3),(31.3,7.1),(31.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,7.1),(32.7,7.3),(32.9,7.3),(32.9,7.1),(32.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,26.3),(-4.1,26.5),(-3.9,26.5),(-3.9,26.3),(-4.1,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-16.9),(19.9,-16.7),(20.1,-16.7),(20.1,-16.9),(19.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-15.3),(-10.5,-15.1),(-10.3,-15.1),(-10.3,-15.3),(-10.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,15.1),(-10.5,15.3),(-10.3,15.3),(-10.3,15.1),(-10.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-0.9),(3.9,-0.7),(4.1,-0.7),(4.1,-0.9),(3.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,0.7),(3.9,0.9),(4.1,0.9),(4.1,0.7),(3.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-12.1),(-4.1,-11.9),(-3.9,-11.9),(-3.9,-12.1),(-4.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-4.1),(-21.7,-3.9),(-21.5,-3.9),(-21.5,-4.1),(-21.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-4.1),(21.5,-3.9),(21.7,-3.9),(21.7,-4.1),(21.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-21.7),(-2.5,-21.5),(-2.3,-21.5),(-2.3,-21.7),(-2.5,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,21.5),(-2.5,21.7),(-2.3,21.7),(-2.3,21.5),(-2.5,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,-5.7),(34.3,-5.5),(34.5,-5.5),(34.5,-5.7),(34.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,5.5),(34.3,5.7),(34.5,5.7),(34.5,5.5),(34.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-4.1),(-31.3,-3.9),(-31.1,-3.9),(-31.1,-4.1),(-31.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-0.9),(-29.7,-0.7),(-29.5,-0.7),(-29.5,-0.9),(-29.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,0.7),(-29.7,0.9),(-29.5,0.9),(-29.5,0.7),(-29.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-0.9),(29.5,-0.7),(29.7,-0.7),(29.7,-0.9),(29.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,0.7),(29.5,0.9),(29.7,0.9),(29.7,0.7),(29.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,5.5),(29.5,5.7),(29.7,5.7),(29.7,5.5),(29.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,11.9),(3.9,12.1),(4.1,12.1),(4.1,11.9),(3.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,2.3),(-34.5,2.5),(-34.3,2.5),(-34.3,2.3),(-34.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,-2.5),(34.3,-2.3),(34.5,-2.3),(34.5,-2.5),(34.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-4.1),(31.1,-3.9),(31.3,-3.9),(31.3,-4.1),(31.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-2.5),(24.7,-2.3),(24.9,-2.3),(24.9,-2.5),(24.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,2.3),(24.7,2.5),(24.9,2.5),(24.9,2.3),(24.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,5.5),(-5.7,5.7),(-5.5,5.7),(-5.5,5.5),(-5.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-5.7),(5.5,-5.5),(5.7,-5.5),(5.7,-5.7),(5.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-2.5),(10.3,-2.3),(10.5,-2.3),(10.5,-2.5),(10.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,2.3),(-10.5,2.5),(-10.3,2.5),(-10.3,2.3),(-10.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,16.7),(-24.9,16.9),(-24.7,16.9),(-24.7,16.7),(-24.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,10.3),(11.9,10.5),(12.1,10.5),(12.1,10.3),(11.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,3.9),(-13.7,4.1),(-13.5,4.1),(-13.5,3.9),(-13.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,3.9),(15.1,4.1),(15.3,4.1),(15.3,3.9),(15.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,8.7),(32.7,8.9),(32.9,8.9),(32.9,8.7),(32.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,26.3),(-13.7,26.5),(-13.5,26.5),(-13.5,26.3),(-13.7,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,26.3),(13.5,26.5),(13.7,26.5),(13.7,26.3),(13.5,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,13.5),(0.7,13.7),(0.9,13.7),(0.9,13.5),(0.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-13.7),(0.7,-13.5),(0.9,-13.5),(0.9,-13.7),(0.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-16.9),(-13.7,-16.7),(-13.5,-16.7),(-13.5,-16.9),(-13.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,16.7),(-13.7,16.9),(-13.5,16.9),(-13.5,16.7),(-13.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,8.7),(-24.9,8.9),(-24.7,8.9),(-24.7,8.7),(-24.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-24.9),(8.7,-24.7),(8.9,-24.7),(8.9,-24.9),(8.7,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,16.7),(13.5,16.9),(13.7,16.9),(13.7,16.7),(13.5,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-4.1),(19.9,-3.9),(20.1,-3.9),(20.1,-4.1),(19.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-23.3),(-16.9,-23.1),(-16.7,-23.1),(-16.7,-23.3),(-16.9,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,23.1),(-16.9,23.3),(-16.7,23.3),(-16.7,23.1),(-16.9,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-16.9),(13.5,-16.7),(13.7,-16.7),(13.7,-16.9),(13.5,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,19.9),(2.3,20.1),(2.5,20.1),(2.5,19.9),(2.3,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,5.5),(-29.7,5.7),(-29.5,5.7),(-29.5,5.5),(-29.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,15.1),(-15.3,15.3),(-15.1,15.3),(-15.1,15.1),(-15.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-15.3),(15.1,-15.1),(15.3,-15.1),(15.3,-15.3),(15.1,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-5.7),(24.7,-5.5),(24.9,-5.5),(24.9,-5.7),(24.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,5.5),(24.7,5.7),(24.9,5.7),(24.9,5.5),(24.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-5.7),(29.5,-5.5),(29.7,-5.5),(29.7,-5.7),(29.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-12.1),(-0.9,-11.9),(-0.7,-11.9),(-0.7,-12.1),(-0.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-10.5),(-24.9,-10.3),(-24.7,-10.3),(-24.7,-10.5),(-24.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,10.3),(-24.9,10.5),(-24.7,10.5),(-24.7,10.3),(-24.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-12.1),(0.7,-11.9),(0.9,-11.9),(0.9,-12.1),(0.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,13.5),(-15.3,13.7),(-15.1,13.7),(-15.1,13.5),(-15.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-13.7),(15.1,-13.5),(15.3,-13.5),(15.3,-13.7),(15.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,-7.3),(-32.9,-7.1),(-32.7,-7.1),(-32.7,-7.3),(-32.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,7.1),(-32.9,7.3),(-32.7,7.3),(-32.7,7.1),(-32.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,3.9),(18.3,4.1),(18.5,4.1),(18.5,3.9),(18.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-7.3),(3.9,-7.1),(4.1,-7.1),(4.1,-7.3),(3.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-24.9),(-10.5,-24.7),(-10.3,-24.7),(-10.3,-24.9),(-10.5,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-24.9),(10.3,-24.7),(10.5,-24.7),(10.5,-24.9),(10.3,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-18.5),(11.9,-18.3),(12.1,-18.3),(12.1,-18.5),(11.9,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,-8.9),(-32.9,-8.7),(-32.7,-8.7),(-32.7,-8.9),(-32.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,16.7),(11.9,16.9),(12.1,16.9),(12.1,16.7),(11.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,19.9),(15.1,20.1),(15.3,20.1),(15.3,19.9),(15.1,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,-8.9),(32.7,-8.7),(32.9,-8.7),(32.9,-8.9),(32.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,-0.9),(35.9,-0.7),(36.1,-0.7),(36.1,-0.9),(35.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,0.7),(35.9,0.9),(36.1,0.9),(36.1,0.7),(35.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,10.3),(-13.7,10.5),(-13.5,10.5),(-13.5,10.3),(-13.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,10.3),(13.5,10.5),(13.7,10.5),(13.7,10.3),(13.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-12.1),(-23.3,-11.9),(-23.1,-11.9),(-23.1,-12.1),(-23.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-18.5),(-7.3,-18.3),(-7.1,-18.3),(-7.1,-18.5),(-7.3,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-18.5),(7.1,-18.3),(7.3,-18.3),(7.3,-18.5),(7.1,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-8.9),(8.7,-8.7),(8.9,-8.7),(8.9,-8.9),(8.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-12.1),(23.1,-11.9),(23.3,-11.9),(23.3,-12.1),(23.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-23.3),(-0.9,-23.1),(-0.7,-23.1),(-0.7,-23.3),(-0.9,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,23.1),(-0.9,23.3),(-0.7,23.3),(-0.7,23.1),(-0.9,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-18.5),(-21.7,-18.3),(-21.5,-18.3),(-21.5,-18.5),(-21.7,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-23.3),(0.7,-23.1),(0.9,-23.1),(0.9,-23.3),(0.7,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,23.1),(0.7,23.3),(0.9,23.3),(0.9,23.1),(0.7,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-18.5),(21.5,-18.3),(21.7,-18.3),(21.7,-18.5),(21.5,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,10.3),(3.9,10.5),(4.1,10.5),(4.1,10.3),(3.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-2.5),(19.9,-2.3),(20.1,-2.3),(20.1,-2.5),(19.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-26.5),(-12.1,-26.3),(-11.9,-26.3),(-11.9,-26.5),(-12.1,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-13.7),(11.9,-13.5),(12.1,-13.5),(12.1,-13.7),(11.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,15.1),(11.9,15.3),(12.1,15.3),(12.1,15.1),(11.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,26.3),(-5.7,26.5),(-5.5,26.5),(-5.5,26.3),(-5.7,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,26.3),(5.5,26.5),(5.7,26.5),(5.7,26.3),(5.5,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,3.9),(8.7,4.1),(8.9,4.1),(8.9,3.9),(8.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,11.9),(-18.5,12.1),(-18.3,12.1),(-18.3,11.9),(-18.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-16.9),(-5.7,-16.7),(-5.5,-16.7),(-5.5,-16.9),(-5.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-16.9),(5.5,-16.7),(5.7,-16.7),(5.7,-16.9),(5.5,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,-0.9),(-36.1,-0.7),(-35.9,-0.7),(-35.9,-0.9),(-36.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,0.7),(-36.1,0.9),(-35.9,0.9),(-35.9,0.7),(-36.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,15.1),(-20.1,15.3),(-19.9,15.3),(-19.9,15.1),(-20.1,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,11.9),(-10.5,12.1),(-10.3,12.1),(-10.3,11.9),(-10.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-7.3),(27.9,-7.1),(28.1,-7.1),(28.1,-7.3),(27.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-7.3),(-26.5,-7.1),(-26.3,-7.1),(-26.3,-7.3),(-26.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,7.1),(-26.5,7.3),(-26.3,7.3),(-26.3,7.1),(-26.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-20.1),(-4.1,-19.9),(-3.9,-19.9),(-3.9,-20.1),(-4.1,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,3.9),(-8.9,4.1),(-8.7,4.1),(-8.7,3.9),(-8.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,24.7),(-2.5,24.9),(-2.3,24.9),(-2.3,24.7),(-2.5,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,24.7),(2.3,24.9),(2.5,24.9),(2.5,24.7),(2.3,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-7.3),(-2.5,-7.1),(-2.3,-7.1),(-2.3,-7.3),(-2.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,7.1),(-2.5,7.3),(-2.3,7.3),(-2.3,7.1),(-2.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-12.1),(-18.5,-11.9),(-18.3,-11.9),(-18.3,-12.1),(-18.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-26.5),(-10.5,-26.3),(-10.3,-26.3),(-10.3,-26.5),(-10.5,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,26.3),(10.3,26.5),(10.5,26.5),(10.5,26.3),(10.3,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-10.5),(-13.7,-10.3),(-13.5,-10.3),(-13.5,-10.5),(-13.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-10.5),(13.5,-10.3),(13.7,-10.3),(13.7,-10.5),(13.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-12.1),(18.3,-11.9),(18.5,-11.9),(18.5,-12.1),(18.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-4.1),(-24.9,-3.9),(-24.7,-3.9),(-24.7,-4.1),(-24.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,3.9),(5.5,4.1),(5.7,4.1),(5.7,3.9),(5.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-13.7),(-24.9,-13.5),(-24.7,-13.5),(-24.7,-13.7),(-24.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,13.5),(-24.9,13.7),(-24.7,13.7),(-24.7,13.5),(-24.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-15.3),(26.3,-15.1),(26.5,-15.1),(26.5,-15.3),(26.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,15.1),(26.3,15.3),(26.5,15.3),(26.5,15.1),(26.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-10.5),(-12.1,-10.3),(-11.9,-10.3),(-11.9,-10.5),(-12.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-12.1),(-10.5,-11.9),(-10.3,-11.9),(-10.3,-12.1),(-10.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-20.1),(-21.7,-19.9),(-21.5,-19.9),(-21.5,-20.1),(-21.7,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,10.3),(-5.7,10.5),(-5.5,10.5),(-5.5,10.3),(-5.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-5.7),(-20.1,-5.5),(-19.9,-5.5),(-19.9,-5.7),(-20.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,10.3),(5.5,10.5),(5.7,10.5),(5.7,10.3),(5.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-12.1),(10.3,-11.9),(10.5,-11.9),(10.5,-12.1),(10.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-20.1),(21.5,-19.9),(21.7,-19.9),(21.7,-20.1),(21.5,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,5.5),(3.9,5.7),(4.1,5.7),(4.1,5.5),(3.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,8.7),(-18.5,8.9),(-18.3,8.9),(-18.3,8.7),(-18.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,8.7),(18.3,8.9),(18.5,8.9),(18.5,8.7),(18.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,8.7),(24.7,8.9),(24.9,8.9),(24.9,8.7),(24.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-15.3),(-24.9,-15.1),(-24.7,-15.1),(-24.7,-15.3),(-24.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,15.1),(-24.9,15.3),(-24.7,15.3),(-24.7,15.1),(-24.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-5.7),(-21.7,-5.5),(-21.5,-5.5),(-21.5,-5.7),(-21.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,5.5),(21.5,5.7),(21.7,5.7),(21.7,5.5),(21.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,8.7),(-10.5,8.9),(-10.3,8.9),(-10.3,8.7),(-10.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,8.7),(10.3,8.9),(10.5,8.9),(10.5,8.7),(10.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-2.5),(-15.3,-2.3),(-15.1,-2.3),(-15.1,-2.5),(-15.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-2.5),(15.1,-2.3),(15.3,-2.3),(15.3,-2.5),(15.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,8.7),(-16.9,8.9),(-16.7,8.9),(-16.7,8.7),(-16.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,8.7),(-0.9,8.9),(-0.7,8.9),(-0.7,8.7),(-0.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,8.7),(0.7,8.9),(0.9,8.9),(0.9,8.7),(0.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-26.5),(-4.1,-26.3),(-3.9,-26.3),(-3.9,-26.5),(-4.1,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-10.5),(-18.5,-10.3),(-18.3,-10.3),(-18.3,-10.5),(-18.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,10.3),(18.3,10.5),(18.5,10.5),(18.5,10.3),(18.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-13.7),(3.9,-13.5),(4.1,-13.5),(4.1,-13.7),(3.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,15.1),(3.9,15.3),(4.1,15.3),(4.1,15.1),(3.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-21.7),(18.3,-21.5),(18.5,-21.5),(18.5,-21.7),(18.3,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,21.5),(18.3,21.7),(18.5,21.7),(18.5,21.5),(18.3,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,5.5),(19.9,5.7),(20.1,5.7),(20.1,5.5),(19.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-15.3),(-13.7,-15.1),(-13.5,-15.1),(-13.5,-15.3),(-13.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,15.1),(13.5,15.3),(13.7,15.3),(13.7,15.1),(13.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-10.5),(-10.5,-10.3),(-10.3,-10.3),(-10.3,-10.5),(-10.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,10.3),(10.3,10.5),(10.5,10.5),(10.5,10.3),(10.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,3.9),(29.5,4.1),(29.7,4.1),(29.7,3.9),(29.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-10.5),(-16.9,-10.3),(-16.7,-10.3),(-16.7,-10.5),(-16.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,10.3),(-16.9,10.5),(-16.7,10.5),(-16.7,10.3),(-16.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-0.9),(-10.5,-0.7),(-10.3,-0.7),(-10.3,-0.9),(-10.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,0.7),(-10.5,0.9),(-10.3,0.9),(-10.3,0.7),(-10.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-0.9),(10.3,-0.7),(10.5,-0.7),(10.5,-0.9),(10.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,0.7),(10.3,0.9),(10.5,0.9),(10.5,0.7),(10.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,3.9),(19.9,4.1),(20.1,4.1),(20.1,3.9),(19.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,-4.1),(-36.1,-3.9),(-35.9,-3.9),(-35.9,-4.1),(-36.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,19.9),(-10.5,20.1),(-10.3,20.1),(-10.3,19.9),(-10.5,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,7.1),(-7.3,7.3),(-7.1,7.3),(-7.1,7.1),(-7.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,3.9),(-4.1,4.1),(-3.9,4.1),(-3.9,3.9),(-4.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-7.3),(7.1,-7.1),(7.3,-7.1),(7.3,-7.3),(7.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-23.3),(-12.1,-23.1),(-11.9,-23.1),(-11.9,-23.3),(-12.1,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-20.1),(-18.5,-19.9),(-18.3,-19.9),(-18.3,-20.1),(-18.5,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-20.1),(18.3,-19.9),(18.5,-19.9),(18.5,-20.1),(18.3,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-12.1),(-29.7,-11.9),(-29.5,-11.9),(-29.5,-12.1),(-29.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-8.9),(7.1,-8.7),(7.3,-8.7),(7.3,-8.9),(7.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,19.9),(-16.9,20.1),(-16.7,20.1),(-16.7,19.9),(-16.9,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-8.9),(-7.3,-8.7),(-7.1,-8.7),(-7.1,-8.9),(-7.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-10.5),(-5.7,-10.3),(-5.5,-10.3),(-5.5,-10.5),(-5.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,11.9),(-0.9,12.1),(-0.7,12.1),(-0.7,11.9),(-0.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,11.9),(0.7,12.1),(0.9,12.1),(0.9,11.9),(0.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-10.5),(5.5,-10.3),(5.7,-10.3),(5.7,-10.5),(5.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-12.1),(-15.3,-11.9),(-15.1,-11.9),(-15.1,-12.1),(-15.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-12.1),(15.1,-11.9),(15.3,-11.9),(15.3,-12.1),(15.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-8.9),(3.9,-8.7),(4.1,-8.7),(4.1,-8.9),(3.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,24.7),(-16.9,24.9),(-16.7,24.9),(-16.7,24.7),(-16.9,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-23.3),(10.3,-23.1),(10.5,-23.1),(10.5,-23.3),(10.3,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,23.1),(10.3,23.3),(10.5,23.3),(10.5,23.1),(10.3,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-10.5),(-4.1,-10.3),(-3.9,-10.3),(-3.9,-10.5),(-4.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,10.3),(-2.5,10.5),(-2.3,10.5),(-2.3,10.3),(-2.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-10.5),(2.3,-10.3),(2.5,-10.3),(2.5,-10.5),(2.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,24.7),(-15.3,24.9),(-15.1,24.9),(-15.1,24.7),(-15.3,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,24.7),(15.1,24.9),(15.3,24.9),(15.3,24.7),(15.1,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,13.5),(-13.7,13.7),(-13.5,13.7),(-13.5,13.5),(-13.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-13.7),(13.5,-13.5),(13.7,-13.5),(13.7,-13.7),(13.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,10.3),(-31.3,10.5),(-31.1,10.5),(-31.1,10.3),(-31.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,16.7),(-21.7,16.9),(-21.5,16.9),(-21.5,16.7),(-21.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,16.7),(21.5,16.9),(21.7,16.9),(21.7,16.7),(21.5,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,10.3),(31.1,10.5),(31.3,10.5),(31.3,10.3),(31.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,5.5),(-23.3,5.7),(-23.1,5.7),(-23.1,5.5),(-23.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-5.7),(23.1,-5.5),(23.3,-5.5),(23.3,-5.7),(23.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,3.9),(-32.9,4.1),(-32.7,4.1),(-32.7,3.9),(-32.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,19.9),(-18.5,20.1),(-18.3,20.1),(-18.3,19.9),(-18.5,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,11.9),(7.1,12.1),(7.3,12.1),(7.3,11.9),(7.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-7.3),(24.7,-7.1),(24.9,-7.1),(24.9,-7.3),(24.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,7.1),(24.7,7.3),(24.9,7.3),(24.9,7.1),(24.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,8.7),(-31.3,8.9),(-31.1,8.9),(-31.1,8.7),(-31.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,8.7),(31.1,8.9),(31.3,8.9),(31.3,8.7),(31.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,3.9),(-28.1,4.1),(-27.9,4.1),(-27.9,3.9),(-28.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-24.9),(-2.5,-24.7),(-2.3,-24.7),(-2.3,-24.9),(-2.5,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-24.9),(2.3,-24.7),(2.5,-24.7),(2.5,-24.9),(2.3,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-0.9),(13.5,-0.7),(13.7,-0.7),(13.7,-0.9),(13.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-0.9),(-13.7,-0.7),(-13.5,-0.7),(-13.5,-0.9),(-13.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,0.7),(-13.7,0.9),(-13.5,0.9),(-13.5,0.7),(-13.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-7.3),(-12.1,-7.1),(-11.9,-7.1),(-11.9,-7.3),(-12.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-15.3),(-5.7,-15.1),(-5.5,-15.1),(-5.5,-15.3),(-5.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,15.1),(5.5,15.3),(5.7,15.3),(5.7,15.1),(5.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-7.3),(-0.9,-7.1),(-0.7,-7.1),(-0.7,-7.3),(-0.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,7.1),(-0.9,7.3),(-0.7,7.3),(-0.7,7.1),(-0.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-7.3),(0.7,-7.1),(0.9,-7.1),(0.9,-7.3),(0.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,7.1),(0.7,7.3),(0.9,7.3),(0.9,7.1),(0.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-13.7),(-18.5,-13.5),(-18.3,-13.5),(-18.3,-13.7),(-18.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,13.5),(-18.5,13.7),(-18.3,13.7),(-18.3,13.5),(-18.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-5.7),(26.3,-5.5),(26.5,-5.5),(26.5,-5.7),(26.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,18.3),(-12.1,18.5),(-11.9,18.5),(-11.9,18.3),(-12.1,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,5.5),(26.3,5.7),(26.5,5.7),(26.5,5.5),(26.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,2.3),(23.1,2.5),(23.3,2.5),(23.3,2.3),(23.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,16.7),(19.9,16.9),(20.1,16.9),(20.1,16.7),(19.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,2.3),(-23.3,2.5),(-23.1,2.5),(-23.1,2.3),(-23.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,21.5),(-12.1,21.7),(-11.9,21.7),(-11.9,21.5),(-12.1,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-24.9),(-0.9,-24.7),(-0.7,-24.7),(-0.7,-24.9),(-0.9,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-24.9),(0.7,-24.7),(0.9,-24.7),(0.9,-24.9),(0.7,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-4.1),(-12.1,-3.9),(-11.9,-3.9),(-11.9,-4.1),(-12.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-18.5),(19.9,-18.3),(20.1,-18.3),(20.1,-18.5),(19.9,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-18.5),(-10.5,-18.3),(-10.3,-18.3),(-10.3,-18.5),(-10.5,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,26.3),(-2.5,26.5),(-2.3,26.5),(-2.3,26.3),(-2.5,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-26.5),(2.3,-26.3),(2.5,-26.3),(2.5,-26.5),(2.3,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,18.3),(10.3,18.5),(10.5,18.5),(10.5,18.3),(10.3,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-13.7),(-10.5,-13.5),(-10.3,-13.5),(-10.3,-13.7),(-10.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,13.5),(-10.5,13.7),(-10.3,13.7),(-10.3,13.5),(-10.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-5.7),(2.3,-5.5),(2.5,-5.5),(2.5,-5.7),(2.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,5.5),(2.3,5.7),(2.5,5.7),(2.5,5.5),(2.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-8.9),(-18.5,-8.7),(-18.3,-8.7),(-18.3,-8.9),(-18.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-13.7),(-16.9,-13.5),(-16.7,-13.5),(-16.7,-13.7),(-16.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,13.5),(-16.9,13.7),(-16.7,13.7),(-16.7,13.5),(-16.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-8.9),(18.3,-8.7),(18.5,-8.7),(18.5,-8.9),(18.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,16.7),(-8.9,16.9),(-8.7,16.9),(-8.7,16.7),(-8.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,23.1),(-13.7,23.3),(-13.5,23.3),(-13.5,23.1),(-13.7,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-23.3),(13.5,-23.1),(13.7,-23.1),(13.7,-23.3),(13.5,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-12.1),(-21.7,-11.9),(-21.5,-11.9),(-21.5,-12.1),(-21.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-12.1),(21.5,-11.9),(21.7,-11.9),(21.7,-12.1),(21.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,11.9),(26.3,12.1),(26.5,12.1),(26.5,11.9),(26.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,23.1),(-15.3,23.3),(-15.1,23.3),(-15.1,23.1),(-15.3,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,2.3),(-20.1,2.5),(-19.9,2.5),(-19.9,2.3),(-20.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-23.3),(15.1,-23.1),(15.3,-23.1),(15.3,-23.3),(15.1,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,8.7),(-29.7,8.9),(-29.5,8.9),(-29.5,8.7),(-29.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,5.5),(-20.1,5.7),(-19.9,5.7),(-19.9,5.5),(-20.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,8.7),(29.5,8.9),(29.7,8.9),(29.7,8.7),(29.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-4.1),(-26.5,-3.9),(-26.3,-3.9),(-26.3,-4.1),(-26.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-15.3),(-16.9,-15.1),(-16.7,-15.1),(-16.7,-15.3),(-16.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,15.1),(-16.9,15.3),(-16.7,15.3),(-16.7,15.1),(-16.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-24.9),(-15.3,-24.7),(-15.1,-24.7),(-15.1,-24.9),(-15.3,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-24.9),(15.1,-24.7),(15.3,-24.7),(15.3,-24.9),(15.1,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-12.1),(16.7,-11.9),(16.9,-11.9),(16.9,-12.1),(16.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,2.3),(19.9,2.5),(20.1,2.5),(20.1,2.3),(19.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,13.5),(-5.7,13.7),(-5.5,13.7),(-5.5,13.5),(-5.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-13.7),(5.5,-13.5),(5.7,-13.5),(5.7,-13.7),(5.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-4.1),(26.3,-3.9),(26.5,-3.9),(26.5,-4.1),(26.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,7.1),(-21.7,7.3),(-21.5,7.3),(-21.5,7.1),(-21.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-7.3),(21.5,-7.1),(21.7,-7.1),(21.7,-7.3),(21.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-18.5),(-18.5,-18.3),(-18.3,-18.3),(-18.3,-18.5),(-18.5,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,18.3),(18.3,18.5),(18.5,18.5),(18.5,18.3),(18.3,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-4.1),(-2.5,-3.9),(-2.3,-3.9),(-2.3,-4.1),(-2.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-12.1),(8.7,-11.9),(8.9,-11.9),(8.9,-12.1),(8.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-4.1),(2.3,-3.9),(2.5,-3.9),(2.5,-4.1),(2.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,7.1),(-31.3,7.3),(-31.1,7.3),(-31.1,7.1),(-31.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-7.3),(31.1,-7.1),(31.3,-7.1),(31.3,-7.3),(31.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-8.9),(-21.7,-8.7),(-21.5,-8.7),(-21.5,-8.9),(-21.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-10.5),(11.9,-10.3),(12.1,-10.3),(12.1,-10.5),(11.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,8.7),(11.9,8.9),(12.1,8.9),(12.1,8.7),(11.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-8.9),(21.5,-8.7),(21.7,-8.7),(21.7,-8.9),(21.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-24.9),(-4.1,-24.7),(-3.9,-24.7),(-3.9,-24.9),(-4.1,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-8.9),(-31.3,-8.7),(-31.1,-8.7),(-31.1,-8.9),(-31.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-8.9),(31.1,-8.7),(31.3,-8.7),(31.3,-8.9),(31.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-21.7),(2.3,-21.5),(2.5,-21.5),(2.5,-21.7),(2.3,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,21.5),(2.3,21.7),(2.5,21.7),(2.5,21.5),(2.3,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-21.7),(-7.3,-21.5),(-7.1,-21.5),(-7.1,-21.7),(-7.3,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,21.5),(7.1,21.7),(7.3,21.7),(7.3,21.5),(7.1,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,3.9),(32.7,4.1),(32.9,4.1),(32.9,3.9),(32.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-10.5),(16.7,-10.3),(16.9,-10.3),(16.9,-10.5),(16.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,10.3),(16.7,10.5),(16.9,10.5),(16.9,10.3),(16.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-12.1),(19.9,-11.9),(20.1,-11.9),(20.1,-12.1),(19.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,0.7),(24.7,0.9),(24.9,0.9),(24.9,0.7),(24.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,23.1),(-12.1,23.3),(-11.9,23.3),(-11.9,23.1),(-12.1,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-10.5),(8.7,-10.3),(8.9,-10.3),(8.9,-10.5),(8.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,10.3),(8.7,10.5),(8.9,10.5),(8.9,10.3),(8.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-20.1),(-2.5,-19.9),(-2.3,-19.9),(-2.3,-20.1),(-2.5,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-20.1),(2.3,-19.9),(2.5,-19.9),(2.5,-20.1),(2.3,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-21.7),(11.9,-21.5),(12.1,-21.5),(12.1,-21.7),(11.9,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,16.7),(-15.3,16.9),(-15.1,16.9),(-15.1,16.7),(-15.3,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-18.5),(-5.7,-18.3),(-5.5,-18.3),(-5.5,-18.5),(-5.7,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-2.5),(-24.9,-2.3),(-24.7,-2.3),(-24.7,-2.5),(-24.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,2.3),(-24.9,2.5),(-24.7,2.5),(-24.7,2.3),(-24.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-18.5),(5.5,-18.3),(5.7,-18.3),(5.7,-18.5),(5.5,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,23.1),(11.9,23.3),(12.1,23.3),(12.1,23.1),(11.9,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,16.7),(15.1,16.9),(15.3,16.9),(15.3,16.7),(15.1,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,8.7),(-21.7,8.9),(-21.5,8.9),(-21.5,8.7),(-21.7,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,8.7),(21.5,8.9),(21.7,8.9),(21.7,8.7),(21.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,3.9),(-15.3,4.1),(-15.1,4.1),(-15.1,3.9),(-15.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-8.9),(-4.1,-8.7),(-3.9,-8.7),(-3.9,-8.9),(-4.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,11.9),(13.5,12.1),(13.7,12.1),(13.7,11.9),(13.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-7.3),(-23.3,-7.1),(-23.1,-7.1),(-23.1,-7.3),(-23.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,7.1),(23.1,7.3),(23.3,7.3),(23.3,7.1),(23.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-0.9),(-20.1,-0.7),(-19.9,-0.7),(-19.9,-0.9),(-20.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,0.7),(-20.1,0.9),(-19.9,0.9),(-19.9,0.7),(-20.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-5.7),(19.9,-5.5),(20.1,-5.5),(20.1,-5.7),(19.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,7.1),(19.9,7.3),(20.1,7.3),(20.1,7.1),(19.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-13.7),(-28.1,-13.5),(-27.9,-13.5),(-27.9,-13.7),(-28.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-12.1),(-8.9,-11.9),(-8.7,-11.9),(-8.7,-12.1),(-8.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,19.9),(-2.5,20.1),(-2.3,20.1),(-2.3,19.9),(-2.5,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-4.1),(-23.3,-3.9),(-23.1,-3.9),(-23.1,-4.1),(-23.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-4.1),(23.1,-3.9),(23.3,-3.9),(23.3,-4.1),(23.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-10.5),(3.9,-10.3),(4.1,-10.3),(4.1,-10.5),(3.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,8.7),(3.9,8.9),(4.1,8.9),(4.1,8.7),(3.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,18.3),(13.5,18.5),(13.7,18.5),(13.7,18.3),(13.5,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,18.3),(-13.7,18.5),(-13.5,18.5),(-13.5,18.3),(-13.7,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,7.1),(-12.1,7.3),(-11.9,7.3),(-11.9,7.1),(-12.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-2.5),(-0.9,-2.3),(-0.7,-2.3),(-0.7,-2.5),(-0.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,2.3),(-0.9,2.5),(-0.7,2.5),(-0.7,2.3),(-0.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,13.5),(11.9,13.7),(12.1,13.7),(12.1,13.5),(11.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-2.5),(0.7,-2.3),(0.9,-2.3),(0.9,-2.5),(0.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,2.3),(0.7,2.5),(0.9,2.5),(0.9,2.3),(0.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-16.9),(-2.5,-16.7),(-2.3,-16.7),(-2.3,-16.9),(-2.5,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-16.9),(2.3,-16.7),(2.5,-16.7),(2.5,-16.9),(2.3,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-10.5),(-23.3,-10.3),(-23.1,-10.3),(-23.1,-10.5),(-23.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-23.3),(2.3,-23.1),(2.5,-23.1),(2.5,-23.3),(2.3,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,23.1),(2.3,23.3),(2.5,23.3),(2.5,23.1),(2.3,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-23.3),(-5.7,-23.1),(-5.5,-23.1),(-5.5,-23.3),(-5.7,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-18.5),(-12.1,-18.3),(-11.9,-18.3),(-11.9,-18.5),(-12.1,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,23.1),(5.5,23.3),(5.7,23.3),(5.7,23.1),(5.5,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-10.5),(23.1,-10.3),(23.3,-10.3),(23.3,-10.5),(23.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,3.9),(-18.5,4.1),(-18.3,4.1),(-18.3,3.9),(-18.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-13.7),(24.7,-13.5),(24.9,-13.5),(24.9,-13.7),(24.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,13.5),(24.7,13.7),(24.9,13.7),(24.9,13.5),(24.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,0.7),(27.9,0.9),(28.1,0.9),(28.1,0.7),(27.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,19.9),(-15.3,20.1),(-15.1,20.1),(-15.1,19.9),(-15.3,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-0.9),(27.9,-0.7),(28.1,-0.7),(28.1,-0.9),(27.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-5.7),(-15.3,-5.5),(-15.1,-5.5),(-15.1,-5.7),(-15.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-8.9),(-28.1,-8.7),(-27.9,-8.7),(-27.9,-8.9),(-28.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-12.1),(-28.1,-11.9),(-27.9,-11.9),(-27.9,-12.1),(-28.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-20.1),(-5.7,-19.9),(-5.5,-19.9),(-5.5,-20.1),(-5.7,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-16.9),(-23.3,-16.7),(-23.1,-16.7),(-23.1,-16.9),(-23.3,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-20.1),(5.5,-19.9),(5.7,-19.9),(5.7,-20.1),(5.5,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,5.5),(15.1,5.7),(15.3,5.7),(15.3,5.5),(15.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-16.9),(23.1,-16.7),(23.3,-16.7),(23.3,-16.9),(23.1,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,11.9),(27.9,12.1),(28.1,12.1),(28.1,11.9),(27.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-7.3),(18.3,-7.1),(18.5,-7.1),(18.5,-7.3),(18.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,7.1),(18.3,7.3),(18.5,7.3),(18.5,7.1),(18.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-2.5),(-20.1,-2.3),(-19.9,-2.3),(-19.9,-2.5),(-20.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-23.3),(18.3,-23.1),(18.5,-23.1),(18.5,-23.3),(18.3,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,11.9),(-12.1,12.1),(-11.9,12.1),(-11.9,11.9),(-12.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-5.7),(-8.9,-5.5),(-8.7,-5.5),(-8.7,-5.7),(-8.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,5.5),(-8.9,5.7),(-8.7,5.7),(-8.7,5.5),(-8.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-16.9),(16.7,-16.7),(16.9,-16.7),(16.9,-16.9),(16.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,-0.9),(32.7,-0.7),(32.9,-0.7),(32.9,-0.9),(32.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,0.7),(32.7,0.9),(32.9,0.9),(32.9,0.7),(32.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,24.7),(-12.1,24.9),(-11.9,24.9),(-11.9,24.7),(-12.1,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,2.3),(-13.7,2.5),(-13.5,2.5),(-13.5,2.3),(-13.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,11.9),(5.5,12.1),(5.7,12.1),(5.7,11.9),(5.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,2.3),(13.5,2.5),(13.7,2.5),(13.7,2.3),(13.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-16.9),(8.7,-16.7),(8.9,-16.7),(8.9,-16.9),(8.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-18.5),(-2.5,-18.3),(-2.3,-18.3),(-2.3,-18.5),(-2.5,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,18.3),(2.3,18.5),(2.5,18.5),(2.5,18.3),(2.3,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,11.9),(16.7,12.1),(16.9,12.1),(16.9,11.9),(16.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-4.1),(24.7,-3.9),(24.9,-3.9),(24.9,-4.1),(24.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-13.7),(-20.1,-13.5),(-19.9,-13.5),(-19.9,-13.7),(-20.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,18.3),(-20.1,18.5),(-19.9,18.5),(-19.9,18.3),(-20.1,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,26.3),(-7.3,26.5),(-7.1,26.5),(-7.1,26.3),(-7.3,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,21.5),(-20.1,21.7),(-19.9,21.7),(-19.9,21.5),(-20.1,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,26.3),(7.1,26.5),(7.3,26.5),(7.3,26.3),(7.1,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,24.7),(16.7,24.9),(16.9,24.9),(16.9,24.7),(16.7,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-7.3),(-24.9,-7.1),(-24.7,-7.1),(-24.7,-7.3),(-24.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,7.1),(-24.9,7.3),(-24.7,7.3),(-24.7,7.1),(-24.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,11.9),(8.7,12.1),(8.9,12.1),(8.9,11.9),(8.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,3.9),(10.3,4.1),(10.5,4.1),(10.5,3.9),(10.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-13.7),(-21.7,-13.5),(-21.5,-13.5),(-21.5,-13.7),(-21.7,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,13.5),(3.9,13.7),(4.1,13.7),(4.1,13.5),(3.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,13.5),(21.5,13.7),(21.7,13.7),(21.7,13.5),(21.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-15.3),(-20.1,-15.1),(-19.9,-15.1),(-19.9,-15.3),(-20.1,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-8.9),(-24.9,-8.7),(-24.7,-8.7),(-24.7,-8.9),(-24.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-2.5),(-18.5,-2.3),(-18.3,-2.3),(-18.3,-2.5),(-18.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,2.3),(18.3,2.5),(18.5,2.5),(18.5,2.3),(18.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,3.9),(-5.7,4.1),(-5.5,4.1),(-5.5,3.9),(-5.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-13.7),(-0.9,-13.5),(-0.7,-13.5),(-0.7,-13.7),(-0.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-21.7),(8.7,-21.5),(8.9,-21.5),(8.9,-21.7),(8.7,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,21.5),(8.7,21.7),(8.9,21.7),(8.9,21.5),(8.7,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-15.3),(-26.5,-15.1),(-26.3,-15.1),(-26.3,-15.3),(-26.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,15.1),(-26.5,15.3),(-26.3,15.3),(-26.3,15.1),(-26.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,8.7),(-12.1,8.9),(-11.9,8.9),(-11.9,8.7),(-12.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-12.1),(-20.1,-11.9),(-19.9,-11.9),(-19.9,-12.1),(-20.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-26.5),(-8.9,-26.3),(-8.7,-26.3),(-8.7,-26.5),(-8.9,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,26.3),(-8.9,26.5),(-8.7,26.5),(-8.7,26.3),(-8.9,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,16.7),(-5.7,16.9),(-5.5,16.9),(-5.5,16.7),(-5.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,16.7),(5.5,16.9),(5.7,16.9),(5.7,16.7),(5.5,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,19.9),(7.1,20.1),(7.3,20.1),(7.3,19.9),(7.1,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,11.9),(19.9,12.1),(20.1,12.1),(20.1,11.9),(19.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-2.5),(-13.7,-2.3),(-13.5,-2.3),(-13.5,-2.5),(-13.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-2.5),(13.5,-2.3),(13.7,-2.3),(13.7,-2.5),(13.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,11.9),(-4.1,12.1),(-3.9,12.1),(-3.9,11.9),(-4.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,5.5),(-21.7,5.7),(-21.5,5.7),(-21.5,5.5),(-21.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,10.3),(-12.1,10.5),(-11.9,10.5),(-11.9,10.3),(-12.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-5.7),(21.5,-5.5),(21.7,-5.5),(21.7,-5.7),(21.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,10.3),(-7.3,10.5),(-7.1,10.5),(-7.1,10.3),(-7.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,13.5),(-12.1,13.7),(-11.9,13.7),(-11.9,13.5),(-12.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,10.3),(7.1,10.5),(7.3,10.5),(7.3,10.3),(7.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-24.9),(16.7,-24.7),(16.9,-24.7),(16.9,-24.9),(16.7,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,24.7),(-4.1,24.9),(-3.9,24.9),(-3.9,24.7),(-4.1,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,2.3),(-26.5,2.5),(-26.3,2.5),(-26.3,2.3),(-26.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-2.5),(26.3,-2.3),(26.5,-2.3),(26.5,-2.5),(26.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,16.7),(-23.3,16.9),(-23.1,16.9),(-23.1,16.7),(-23.3,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,16.7),(23.1,16.9),(23.3,16.9),(23.3,16.7),(23.1,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-21.7),(-16.9,-21.5),(-16.7,-21.5),(-16.7,-21.7),(-16.9,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,21.5),(-16.9,21.7),(-16.7,21.7),(-16.7,21.5),(-16.9,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-21.7),(16.7,-21.5),(16.9,-21.5),(16.9,-21.7),(16.7,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,21.5),(16.7,21.7),(16.9,21.7),(16.9,21.5),(16.7,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,16.7),(24.7,16.9),(24.9,16.9),(24.9,16.7),(24.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,15.1),(-13.7,15.3),(-13.5,15.3),(-13.5,15.1),(-13.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-15.3),(13.5,-15.1),(13.7,-15.1),(13.7,-15.3),(13.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,2.3),(-2.5,2.5),(-2.3,2.5),(-2.3,2.3),(-2.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-2.5),(2.3,-2.3),(2.5,-2.3),(2.5,-2.5),(2.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,8.7),(-7.3,8.9),(-7.1,8.9),(-7.1,8.7),(-7.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,3.9),(-29.7,4.1),(-29.5,4.1),(-29.5,3.9),(-29.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,18.3),(0.7,18.5),(0.9,18.5),(0.9,18.3),(0.7,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,8.7),(7.1,8.9),(7.3,8.9),(7.3,8.7),(7.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,10.3),(27.9,10.5),(28.1,10.5),(28.1,10.3),(27.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-10.5),(-15.3,-10.3),(-15.1,-10.3),(-15.1,-10.5),(-15.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-18.5),(3.9,-18.3),(4.1,-18.3),(4.1,-18.5),(3.9,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,16.7),(3.9,16.9),(4.1,16.9),(4.1,16.7),(3.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-10.5),(15.1,-10.3),(15.3,-10.3),(15.3,-10.5),(15.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,-5.7),(-32.9,-5.5),(-32.7,-5.5),(-32.7,-5.7),(-32.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,5.5),(-32.9,5.7),(-32.7,5.7),(-32.7,5.5),(-32.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,3.9),(7.1,4.1),(7.3,4.1),(7.3,3.9),(7.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-15.3),(2.3,-15.1),(2.5,-15.1),(2.5,-15.3),(2.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,15.1),(2.3,15.3),(2.5,15.3),(2.5,15.1),(2.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-7.3),(-13.7,-7.1),(-13.5,-7.1),(-13.5,-7.3),(-13.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,7.1),(13.5,7.3),(13.7,7.3),(13.7,7.1),(13.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-21.7),(19.9,-21.5),(20.1,-21.5),(20.1,-21.7),(19.9,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-16.9),(-15.3,-16.7),(-15.1,-16.7),(-15.1,-16.9),(-15.3,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-16.9),(15.1,-16.7),(15.3,-16.7),(15.3,-16.9),(15.1,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-23.3),(11.9,-23.1),(12.1,-23.1),(12.1,-23.3),(11.9,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-23.3),(-10.5,-23.1),(-10.3,-23.1),(-10.3,-23.3),(-10.5,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,23.1),(-10.5,23.3),(-10.3,23.3),(-10.3,23.1),(-10.5,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,8.7),(-4.1,8.9),(-3.9,8.9),(-3.9,8.7),(-4.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-4.1),(-13.7,-3.9),(-13.5,-3.9),(-13.5,-4.1),(-13.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-4.1),(13.5,-3.9),(13.7,-3.9),(13.7,-4.1),(13.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-5.7),(-18.5,-5.5),(-18.3,-5.5),(-18.3,-5.7),(-18.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,5.5),(-18.5,5.7),(-18.3,5.7),(-18.3,5.5),(-18.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,0.7),(-34.5,0.9),(-34.3,0.9),(-34.3,0.7),(-34.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,-0.9),(-34.5,-0.7),(-34.3,-0.7),(-34.3,-0.9),(-34.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,0.7),(7.1,0.9),(7.3,0.9),(7.3,0.7),(7.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,-0.9),(34.3,-0.7),(34.5,-0.7),(34.5,-0.9),(34.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-20.1),(11.9,-19.9),(12.1,-19.9),(12.1,-20.1),(11.9,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,0.7),(34.3,0.9),(34.5,0.9),(34.5,0.7),(34.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-20.1),(-8.9,-19.9),(-8.7,-19.9),(-8.7,-20.1),(-8.9,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,10.3),(-4.1,10.5),(-3.9,10.5),(-3.9,10.3),(-4.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-7.3),(19.9,-7.1),(20.1,-7.1),(20.1,-7.3),(19.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,13.5),(-4.1,13.7),(-3.9,13.7),(-3.9,13.5),(-4.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,11.9),(-7.3,12.1),(-7.1,12.1),(-7.1,11.9),(-7.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-0.9),(-16.9,-0.7),(-16.7,-0.7),(-16.7,-0.9),(-16.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,0.7),(-16.9,0.9),(-16.7,0.9),(-16.7,0.7),(-16.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-0.9),(-0.9,-0.7),(-0.7,-0.7),(-0.7,-0.9),(-0.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,0.7),(-0.9,0.9),(-0.7,0.9),(-0.7,0.7),(-0.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-0.9),(0.7,-0.7),(0.9,-0.7),(0.9,-0.9),(0.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,0.7),(0.7,0.9),(0.9,0.9),(0.9,0.7),(0.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,10.3),(-29.7,10.5),(-29.5,10.5),(-29.5,10.3),(-29.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,18.3),(-21.7,18.5),(-21.5,18.5),(-21.5,18.3),(-21.7,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-15.3),(16.7,-15.1),(16.9,-15.1),(16.9,-15.3),(16.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,15.1),(16.7,15.3),(16.9,15.3),(16.9,15.1),(16.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,18.3),(21.5,18.5),(21.7,18.5),(21.7,18.3),(21.5,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,10.3),(29.5,10.5),(29.7,10.5),(29.7,10.3),(29.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-8.9),(24.7,-8.7),(24.9,-8.7),(24.9,-8.9),(24.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-23.3),(-18.5,-23.1),(-18.3,-23.1),(-18.3,-23.3),(-18.5,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,23.1),(-18.5,23.3),(-18.3,23.3),(-18.3,23.1),(-18.5,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,15.1),(-5.7,15.3),(-5.5,15.3),(-5.5,15.1),(-5.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-18.5),(-20.1,-18.3),(-19.9,-18.3),(-19.9,-18.5),(-20.1,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-16.9),(-12.1,-16.7),(-11.9,-16.7),(-11.9,-16.9),(-12.1,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-15.3),(5.5,-15.1),(5.7,-15.1),(5.7,-15.3),(5.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-15.3),(8.7,-15.1),(8.9,-15.1),(8.9,-15.3),(8.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,15.1),(8.7,15.3),(8.9,15.3),(8.9,15.1),(8.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-13.7),(18.3,-13.5),(18.5,-13.5),(18.5,-13.7),(18.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,13.5),(18.3,13.7),(18.5,13.7),(18.5,13.5),(18.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,10.3),(19.9,10.5),(20.1,10.5),(20.1,10.3),(19.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-13.7),(27.9,-13.5),(28.1,-13.5),(28.1,-13.7),(27.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,3.9),(24.7,4.1),(24.9,4.1),(24.9,3.9),(24.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-13.7),(10.3,-13.5),(10.5,-13.5),(10.5,-13.7),(10.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,13.5),(10.3,13.7),(10.5,13.7),(10.5,13.5),(10.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-15.3),(-7.3,-15.1),(-7.1,-15.1),(-7.1,-15.3),(-7.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,15.1),(7.1,15.3),(7.3,15.3),(7.3,15.1),(7.1,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-16.9),(-21.7,-16.7),(-21.5,-16.7),(-21.5,-16.9),(-21.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-16.9),(21.5,-16.7),(21.7,-16.7),(21.7,-16.9),(21.5,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-4.1),(11.9,-3.9),(12.1,-3.9),(12.1,-4.1),(11.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,19.9),(13.5,20.1),(13.7,20.1),(13.7,19.9),(13.5,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,11.9),(-26.5,12.1),(-26.3,12.1),(-26.3,11.9),(-26.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,16.7),(-0.9,16.9),(-0.7,16.9),(-0.7,16.7),(-0.9,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,16.7),(0.7,16.9),(0.9,16.9),(0.9,16.7),(0.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-13.7),(-7.3,-13.5),(-7.1,-13.5),(-7.1,-13.7),(-7.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,13.5),(7.1,13.7),(7.3,13.7),(7.3,13.5),(7.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,3.9),(-24.9,4.1),(-24.7,4.1),(-24.7,3.9),(-24.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-2.5),(16.7,-2.3),(16.9,-2.3),(16.9,-2.5),(16.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,2.3),(16.7,2.5),(16.9,2.5),(16.9,2.3),(16.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-0.9),(-4.1,-0.7),(-3.9,-0.7),(-3.9,-0.9),(-4.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,0.7),(-4.1,0.9),(-3.9,0.9),(-3.9,0.7),(-4.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-10.5),(-29.7,-10.3),(-29.5,-10.3),(-29.5,-10.5),(-29.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,3.9),(21.5,4.1),(21.7,4.1),(21.7,3.9),(21.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-10.5),(29.5,-10.3),(29.7,-10.3),(29.7,-10.5),(29.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,3.9),(31.1,4.1),(31.3,4.1),(31.3,3.9),(31.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-10.5),(-28.1,-10.3),(-27.9,-10.3),(-27.9,-10.5),(-28.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-12.1),(-26.5,-11.9),(-26.3,-11.9),(-26.3,-12.1),(-26.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-12.1),(26.3,-11.9),(26.5,-11.9),(26.5,-12.1),(26.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,10.3),(-21.7,10.5),(-21.5,10.5),(-21.5,10.3),(-21.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-4.1),(-16.9,-3.9),(-16.7,-3.9),(-16.7,-4.1),(-16.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,10.3),(21.5,10.5),(21.7,10.5),(21.7,10.3),(21.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-23.3),(-4.1,-23.1),(-3.9,-23.1),(-3.9,-23.3),(-4.1,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,21.5),(-7.3,21.7),(-7.1,21.7),(-7.1,21.5),(-7.3,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-16.9),(-4.1,-16.7),(-3.9,-16.7),(-3.9,-16.9),(-4.1,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-21.7),(7.1,-21.5),(7.3,-21.5),(7.3,-21.7),(7.1,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,8.7),(-26.5,8.9),(-26.3,8.9),(-26.3,8.7),(-26.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-8.9),(-10.5,-8.7),(-10.3,-8.7),(-10.3,-8.9),(-10.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-8.9),(10.3,-8.7),(10.5,-8.7),(10.5,-8.9),(10.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-2.5),(11.9,-2.3),(12.1,-2.3),(12.1,-2.5),(11.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-0.9),(11.9,-0.7),(12.1,-0.7),(12.1,-0.9),(11.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,0.7),(11.9,0.9),(12.1,0.9),(12.1,0.7),(11.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,8.7),(26.3,8.9),(26.5,8.9),(26.5,8.7),(26.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-13.7),(19.9,-13.5),(20.1,-13.5),(20.1,-13.7),(19.9,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-23.3),(8.7,-23.1),(8.9,-23.1),(8.9,-23.3),(8.7,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,23.1),(8.7,23.3),(8.9,23.3),(8.9,23.1),(8.7,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,15.1),(19.9,15.3),(20.1,15.3),(20.1,15.1),(19.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-21.7),(-12.1,-21.5),(-11.9,-21.5),(-11.9,-21.7),(-12.1,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-12.1),(27.9,-11.9),(28.1,-11.9),(28.1,-12.1),(27.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,11.9),(2.3,12.1),(2.5,12.1),(2.5,11.9),(2.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,19.9),(-12.1,20.1),(-11.9,20.1),(-11.9,19.9),(-12.1,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,5.5),(35.9,5.7),(36.1,5.7),(36.1,5.5),(35.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-5.7),(16.7,-5.5),(16.9,-5.5),(16.9,-5.7),(16.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,5.5),(16.7,5.7),(16.9,5.7),(16.9,5.5),(16.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-2.5),(-7.3,-2.3),(-7.1,-2.3),(-7.1,-2.5),(-7.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-2.5),(7.1,-2.3),(7.3,-2.3),(7.3,-2.5),(7.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-10.5),(-26.5,-10.3),(-26.3,-10.3),(-26.3,-10.5),(-26.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,10.3),(26.3,10.5),(26.5,10.5),(26.5,10.3),(26.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-0.9),(-15.3,-0.7),(-15.1,-0.7),(-15.1,-0.9),(-15.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,0.7),(-15.3,0.9),(-15.1,0.9),(-15.1,0.7),(-15.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-0.9),(15.1,-0.7),(15.3,-0.7),(15.3,-0.9),(15.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,3.9),(34.3,4.1),(34.5,4.1),(34.5,3.9),(34.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,0.7),(15.1,0.9),(15.3,0.9),(15.3,0.7),(15.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-21.7),(-13.7,-21.5),(-13.5,-21.5),(-13.5,-21.7),(-13.7,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,21.5),(13.5,21.7),(13.7,21.7),(13.7,21.5),(13.5,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,3.9),(35.9,4.1),(36.1,4.1),(36.1,3.9),(35.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-24.9),(11.9,-24.7),(12.1,-24.7),(12.1,-24.9),(11.9,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,11.9),(-13.7,12.1),(-13.5,12.1),(-13.5,11.9),(-13.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,3.9),(-20.1,4.1),(-19.9,4.1),(-19.9,3.9),(-20.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,7.1),(-23.3,7.3),(-23.1,7.3),(-23.1,7.1),(-23.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,21.5),(11.9,21.7),(12.1,21.7),(12.1,21.5),(11.9,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-0.9),(-2.5,-0.7),(-2.3,-0.7),(-2.3,-0.9),(-2.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,0.7),(-2.5,0.9),(-2.3,0.9),(-2.3,0.7),(-2.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-7.3),(-4.1,-7.1),(-3.9,-7.1),(-3.9,-7.3),(-4.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-0.9),(-5.7,-0.7),(-5.5,-0.7),(-5.5,-0.9),(-5.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,0.7),(-5.7,0.9),(-5.5,0.9),(-5.5,0.7),(-5.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-16.9),(-8.9,-16.7),(-8.7,-16.7),(-8.7,-16.9),(-8.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-0.9),(2.3,-0.7),(2.5,-0.7),(2.5,-0.9),(2.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,0.7),(2.3,0.9),(2.5,0.9),(2.5,0.7),(2.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-0.9),(5.5,-0.7),(5.7,-0.7),(5.7,-0.9),(5.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,0.7),(5.5,0.9),(5.7,0.9),(5.7,0.7),(5.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-23.3),(16.7,-23.1),(16.9,-23.1),(16.9,-23.3),(16.7,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-8.9),(-23.3,-8.7),(-23.1,-8.7),(-23.1,-8.9),(-23.3,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-10.5),(-21.7,-10.3),(-21.5,-10.3),(-21.5,-10.5),(-21.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,23.1),(16.7,23.3),(16.9,23.3),(16.9,23.1),(16.7,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,18.3),(-4.1,18.5),(-3.9,18.5),(-3.9,18.3),(-4.1,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-10.5),(21.5,-10.3),(21.7,-10.3),(21.7,-10.5),(21.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-8.9),(23.1,-8.7),(23.3,-8.7),(23.3,-8.9),(23.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,19.9),(11.9,20.1),(12.1,20.1),(12.1,19.9),(11.9,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,21.5),(-4.1,21.7),(-3.9,21.7),(-3.9,21.5),(-4.1,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-8.9),(19.9,-8.7),(20.1,-8.7),(20.1,-8.9),(19.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-8.9),(27.9,-8.7),(28.1,-8.7),(28.1,-8.9),(27.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-10.5),(-20.1,-10.3),(-19.9,-10.3),(-19.9,-10.5),(-20.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-4.1),(-4.1,-3.9),(-3.9,-3.9),(-3.9,-4.1),(-4.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-5.7),(-12.1,-5.5),(-11.9,-5.5),(-11.9,-5.7),(-12.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-23.3),(-2.5,-23.1),(-2.3,-23.1),(-2.3,-23.3),(-2.5,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,23.1),(-2.5,23.3),(-2.3,23.3),(-2.3,23.1),(-2.5,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,23.1),(-5.7,23.3),(-5.5,23.3),(-5.5,23.1),(-5.7,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,16.7),(-12.1,16.9),(-11.9,16.9),(-11.9,16.7),(-12.1,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-23.3),(5.5,-23.1),(5.7,-23.1),(5.7,-23.3),(5.5,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-5.7),(-13.7,-5.5),(-13.5,-5.5),(-13.5,-5.7),(-13.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,5.5),(13.5,5.7),(13.7,5.7),(13.7,5.5),(13.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,16.7),(-10.5,16.9),(-10.3,16.9),(-10.3,16.7),(-10.5,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,16.7),(10.3,16.9),(10.5,16.9),(10.5,16.7),(10.3,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,11.9),(23.1,12.1),(23.3,12.1),(23.3,11.9),(23.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,5.5),(-15.3,5.7),(-15.1,5.7),(-15.1,5.5),(-15.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-5.7),(15.1,-5.5),(15.3,-5.5),(15.3,-5.7),(15.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,5.5),(11.9,5.7),(12.1,5.7),(12.1,5.5),(11.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-7.3),(-28.1,-7.1),(-27.9,-7.1),(-27.9,-7.3),(-28.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-7.3),(-18.5,-7.1),(-18.3,-7.1),(-18.3,-7.3),(-18.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,7.1),(-18.5,7.3),(-18.3,7.3),(-18.3,7.1),(-18.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-15.3),(-21.7,-15.1),(-21.5,-15.1),(-21.5,-15.3),(-21.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-20.1),(19.9,-19.9),(20.1,-19.9),(20.1,-20.1),(19.9,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,15.1),(21.5,15.3),(21.7,15.3),(21.7,15.1),(21.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,3.9),(11.9,4.1),(12.1,4.1),(12.1,3.9),(11.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-18.5),(-15.3,-18.3),(-15.1,-18.3),(-15.1,-18.5),(-15.3,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-18.5),(15.1,-18.3),(15.3,-18.3),(15.3,-18.5),(15.1,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-4.1),(-28.1,-3.9),(-27.9,-3.9),(-27.9,-4.1),(-28.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,16.7),(-7.3,16.9),(-7.1,16.9),(-7.1,16.7),(-7.3,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,11.9),(-5.7,12.1),(-5.5,12.1),(-5.5,11.9),(-5.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,13.5),(-26.5,13.7),(-26.3,13.7),(-26.3,13.5),(-26.5,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-26.5,-13.7),(-26.5,-13.5),(-26.3,-13.5),(-26.3,-13.7),(-26.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,16.7),(7.1,16.9),(7.3,16.9),(7.3,16.7),(7.1,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,16.7),(-18.5,16.9),(-18.3,16.9),(-18.3,16.7),(-18.5,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,16.7),(18.3,16.9),(18.5,16.9),(18.5,16.7),(18.3,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,2.3),(-15.3,2.5),(-15.1,2.5),(-15.1,2.3),(-15.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,2.3),(15.1,2.5),(15.3,2.5),(15.3,2.3),(15.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,-4.1),(35.9,-3.9),(36.1,-3.9),(36.1,-4.1),(35.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,16.7),(8.7,16.9),(8.9,16.9),(8.9,16.7),(8.7,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,2.3),(-36.1,2.5),(-35.9,2.5),(-35.9,2.3),(-36.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-15.3),(11.9,-15.1),(12.1,-15.1),(12.1,-15.3),(11.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-2.5),(-31.3,-2.3),(-31.1,-2.3),(-31.1,-2.5),(-31.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-2.5),(31.1,-2.3),(31.3,-2.3),(31.3,-2.5),(31.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,8.7),(-32.9,8.9),(-32.7,8.9),(-32.7,8.7),(-32.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,23.1),(-4.1,23.3),(-3.9,23.3),(-3.9,23.1),(-4.1,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,3.9),(-10.5,4.1),(-10.3,4.1),(-10.3,3.9),(-10.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,13.5),(-21.7,13.7),(-21.5,13.7),(-21.5,13.5),(-21.7,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-23.3),(-7.3,-23.1),(-7.1,-23.1),(-7.1,-23.3),(-7.3,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,23.1),(7.1,23.3),(7.3,23.3),(7.3,23.1),(7.1,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-13.7),(21.5,-13.5),(21.7,-13.5),(21.7,-13.7),(21.5,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-21.7),(3.9,-21.5),(4.1,-21.5),(4.1,-21.7),(3.9,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,23.1),(3.9,23.3),(4.1,23.3),(4.1,23.1),(3.9,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,26.3),(-10.5,26.5),(-10.3,26.5),(-10.3,26.3),(-10.5,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-26.5),(10.3,-26.3),(10.5,-26.3),(10.5,-26.5),(10.3,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,23.1),(18.3,23.3),(18.5,23.3),(18.5,23.1),(18.3,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,19.9),(21.5,20.1),(21.7,20.1),(21.7,19.9),(21.5,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-12.1),(24.7,-11.9),(24.9,-11.9),(24.9,-12.1),(24.7,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-10.5),(27.9,-10.3),(28.1,-10.3),(28.1,-10.5),(27.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,-0.9),(-32.9,-0.7),(-32.7,-0.7),(-32.7,-0.9),(-32.9,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-32.9,0.7),(-32.9,0.9),(-32.7,0.9),(-32.7,0.7),(-32.9,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-7.3),(10.3,-7.1),(10.5,-7.1),(10.5,-7.3),(10.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,7.1),(10.3,7.3),(10.5,7.3),(10.5,7.1),(10.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-0.9),(16.7,-0.7),(16.9,-0.7),(16.9,-0.9),(16.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,0.7),(16.7,0.9),(16.9,0.9),(16.9,0.7),(16.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,8.7),(27.9,8.9),(28.1,8.9),(28.1,8.7),(27.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,18.3),(11.9,18.5),(12.1,18.5),(12.1,18.3),(11.9,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,-0.9),(-21.7,-0.7),(-21.5,-0.7),(-21.5,-0.9),(-21.7,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,0.7),(-21.7,0.9),(-21.5,0.9),(-21.5,0.7),(-21.7,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,18.3),(-15.3,18.5),(-15.1,18.5),(-15.1,18.3),(-15.3,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-26.5),(-7.3,-26.3),(-7.1,-26.3),(-7.1,-26.5),(-7.3,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,19.9),(-7.3,20.1),(-7.1,20.1),(-7.1,19.9),(-7.3,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-26.5),(7.1,-26.3),(7.3,-26.3),(7.3,-26.5),(7.1,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,18.3),(15.1,18.5),(15.3,18.5),(15.3,18.3),(15.1,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-0.9),(21.5,-0.7),(21.7,-0.7),(21.7,-0.9),(21.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,0.7),(21.5,0.9),(21.7,0.9),(21.7,0.7),(21.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-24.9),(-13.7,-24.7),(-13.5,-24.7),(-13.5,-24.9),(-13.7,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-24.9),(13.5,-24.7),(13.7,-24.7),(13.7,-24.9),(13.5,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,-2.5),(35.9,-2.3),(36.1,-2.3),(36.1,-2.5),(35.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,10.3),(-18.5,10.5),(-18.3,10.5),(-18.3,10.3),(-18.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-10.5),(18.3,-10.3),(18.5,-10.3),(18.5,-10.5),(18.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,18.3),(-5.7,18.5),(-5.5,18.5),(-5.5,18.3),(-5.7,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,7.1),(-4.1,7.3),(-3.9,7.3),(-3.9,7.1),(-4.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,18.3),(5.5,18.5),(5.7,18.5),(5.7,18.3),(5.5,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-10.5),(24.7,-10.3),(24.9,-10.3),(24.9,-10.5),(24.7,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,10.3),(24.7,10.5),(24.9,10.5),(24.9,10.3),(24.7,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-18.5),(-4.1,-18.3),(-3.9,-18.3),(-3.9,-18.5),(-4.1,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,-2.5),(-34.5,-2.3),(-34.3,-2.3),(-34.3,-2.5),(-34.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,10.3),(-10.5,10.5),(-10.3,10.5),(-10.3,10.3),(-10.5,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-10.5),(10.3,-10.3),(10.5,-10.3),(10.5,-10.5),(10.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,2.3),(34.3,2.5),(34.5,2.5),(34.5,2.3),(34.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,13.5),(-0.9,13.7),(-0.7,13.7),(-0.7,13.5),(-0.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-15.3),(3.9,-15.1),(4.1,-15.1),(4.1,-15.3),(3.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,2.3),(-12.1,2.5),(-11.9,2.5),(-11.9,2.3),(-12.1,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,5.5),(-12.1,5.7),(-11.9,5.7),(-11.9,5.5),(-12.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-8.9),(-20.1,-8.7),(-19.9,-8.7),(-19.9,-8.9),(-20.1,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-2.5),(-10.5,-2.3),(-10.3,-2.3),(-10.3,-2.5),(-10.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,11.9),(-8.9,12.1),(-8.7,12.1),(-8.7,11.9),(-8.9,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,2.3),(10.3,2.5),(10.5,2.5),(10.5,2.3),(10.3,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,-21.7),(-20.1,-21.5),(-19.9,-21.5),(-19.9,-21.7),(-20.1,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-2.5),(-16.9,-2.3),(-16.7,-2.3),(-16.7,-2.5),(-16.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,2.3),(-16.9,2.5),(-16.7,2.5),(-16.7,2.3),(-16.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,19.9),(-20.1,20.1),(-19.9,20.1),(-19.9,19.9),(-20.1,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,2.3),(11.9,2.5),(12.1,2.5),(12.1,2.3),(11.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,11.9),(29.5,12.1),(29.7,12.1),(29.7,11.9),(29.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,3.9),(-7.3,4.1),(-7.1,4.1),(-7.1,3.9),(-7.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,11.9),(15.1,12.1),(15.3,12.1),(15.3,11.9),(15.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-15.3),(-2.5,-15.1),(-2.3,-15.1),(-2.3,-15.3),(-2.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,15.1),(-2.5,15.3),(-2.3,15.3),(-2.3,15.1),(-2.5,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,7.1),(-13.7,7.3),(-13.5,7.3),(-13.5,7.1),(-13.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-7.3),(13.5,-7.1),(13.7,-7.1),(13.7,-7.3),(13.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-7.3),(16.7,-7.1),(16.9,-7.1),(16.9,-7.3),(16.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,7.1),(16.7,7.3),(16.9,7.3),(16.9,7.1),(16.7,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,-5.7),(35.9,-5.5),(36.1,-5.5),(36.1,-5.7),(35.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-12.1),(-24.9,-11.9),(-24.7,-11.9),(-24.7,-12.1),(-24.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-20.1),(8.7,-19.9),(8.9,-19.9),(8.9,-20.1),(8.7,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-7.3),(-15.3,-7.1),(-15.1,-7.1),(-15.1,-7.3),(-15.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,7.1),(15.1,7.3),(15.3,7.3),(15.3,7.1),(15.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-8.9),(-13.7,-8.7),(-13.5,-8.7),(-13.5,-8.9),(-13.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-8.9),(13.5,-8.7),(13.7,-8.7),(13.7,-8.9),(13.5,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,-10.5),(19.9,-10.3),(20.1,-10.3),(20.1,-10.5),(19.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,8.7),(19.9,8.9),(20.1,8.9),(20.1,8.7),(19.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-23.3),(-8.9,-23.1),(-8.7,-23.1),(-8.7,-23.3),(-8.9,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,23.1),(-8.9,23.3),(-8.7,23.3),(-8.7,23.1),(-8.9,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,2.3),(-5.7,2.5),(-5.5,2.5),(-5.5,2.3),(-5.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,-5.7),(-36.1,-5.5),(-35.9,-5.5),(-35.9,-5.7),(-36.1,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,7.1),(-28.1,7.3),(-27.9,7.3),(-27.9,7.1),(-28.1,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,2.3),(5.5,2.5),(5.7,2.5),(5.7,2.3),(5.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-5.7),(18.3,-5.5),(18.5,-5.5),(18.5,-5.7),(18.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,5.5),(18.3,5.7),(18.5,5.7),(18.5,5.5),(18.3,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,21.5),(19.9,21.7),(20.1,21.7),(20.1,21.5),(19.9,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-4.1),(-15.3,-3.9),(-15.1,-3.9),(-15.1,-4.1),(-15.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-4.1),(15.1,-3.9),(15.3,-3.9),(15.3,-4.1),(15.1,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,13.5),(27.9,13.7),(28.1,13.7),(28.1,13.5),(27.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-21.7),(-10.5,-21.5),(-10.3,-21.5),(-10.3,-21.7),(-10.5,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,21.5),(-10.5,21.7),(-10.3,21.7),(-10.3,21.5),(-10.5,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,19.9),(19.9,20.1),(20.1,20.1),(20.1,19.9),(19.9,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-20.1),(16.7,-19.9),(16.9,-19.9),(16.9,-20.1),(16.7,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-18.5),(-16.9,-18.3),(-16.7,-18.3),(-16.7,-18.5),(-16.9,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,18.3),(-16.9,18.5),(-16.7,18.5),(-16.7,18.3),(-16.9,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,-7.3),(23.1,-7.1),(23.3,-7.1),(23.3,-7.3),(23.1,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,16.7),(-2.5,16.9),(-2.3,16.9),(-2.3,16.7),(-2.5,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,16.7),(2.3,16.9),(2.5,16.9),(2.5,16.7),(2.3,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-5.7),(-7.3,-5.5),(-7.1,-5.5),(-7.1,-5.7),(-7.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-4.1),(-18.5,-3.9),(-18.3,-3.9),(-18.3,-4.1),(-18.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-4.1),(18.3,-3.9),(18.5,-3.9),(18.5,-4.1),(18.3,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,-2.5),(-36.1,-2.3),(-35.9,-2.3),(-35.9,-2.5),(-36.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,16.7),(-20.1,16.9),(-19.9,16.9),(-19.9,16.7),(-20.1,16.7)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,5.5),(7.1,5.7),(7.3,5.7),(7.3,5.5),(7.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-0.9),(-31.3,-0.7),(-31.1,-0.7),(-31.1,-0.9),(-31.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,0.7),(-31.3,0.9),(-31.1,0.9),(-31.1,0.7),(-31.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-0.9),(31.1,-0.7),(31.3,-0.7),(31.3,-0.9),(31.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,0.7),(31.1,0.9),(31.3,0.9),(31.3,0.7),(31.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,11.9),(-28.1,12.1),(-27.9,12.1),(-27.9,11.9),(-28.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,-5.7),(-24.9,-5.5),(-24.7,-5.5),(-24.7,-5.7),(-24.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-24.9,5.5),(-24.9,5.7),(-24.7,5.7),(-24.7,5.5),(-24.9,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-16.9),(11.9,-16.7),(12.1,-16.7),(12.1,-16.9),(11.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,18.3),(-10.5,18.5),(-10.3,18.5),(-10.3,18.3),(-10.5,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-18.5),(10.3,-18.3),(10.5,-18.3),(10.5,-18.5),(10.3,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,2.3),(29.5,2.5),(29.7,2.5),(29.7,2.3),(29.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,2.3),(-29.7,2.5),(-29.5,2.5),(-29.5,2.3),(-29.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,11.9),(21.5,12.1),(21.7,12.1),(21.7,11.9),(21.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,15.1),(-7.3,15.3),(-7.1,15.3),(-7.1,15.1),(-7.3,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-15.3),(7.1,-15.1),(7.3,-15.1),(7.3,-15.3),(7.1,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-0.9),(-18.5,-0.7),(-18.3,-0.7),(-18.3,-0.9),(-18.5,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,0.7),(-18.5,0.9),(-18.3,0.9),(-18.3,0.7),(-18.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-20.1),(-15.3,-19.9),(-15.1,-19.9),(-15.1,-20.1),(-15.3,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-20.1),(15.1,-19.9),(15.3,-19.9),(15.3,-20.1),(15.1,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-0.9),(18.3,-0.7),(18.5,-0.7),(18.5,-0.9),(18.3,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,0.7),(18.3,0.9),(18.5,0.9),(18.5,0.7),(18.3,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-16.9),(24.7,-16.7),(24.9,-16.7),(24.9,-16.9),(24.7,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-5.7),(11.9,-5.5),(12.1,-5.5),(12.1,-5.7),(11.9,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,7.1),(11.9,7.3),(12.1,7.3),(12.1,7.1),(11.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-2.5),(-5.7,-2.3),(-5.5,-2.3),(-5.5,-2.5),(-5.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,19.9),(-13.7,20.1),(-13.5,20.1),(-13.5,19.9),(-13.7,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-5.7),(-10.5,-5.5),(-10.3,-5.5),(-10.3,-5.7),(-10.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,5.5),(-10.5,5.7),(-10.3,5.7),(-10.3,5.5),(-10.5,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-2.5),(5.5,-2.3),(5.7,-2.3),(5.7,-2.5),(5.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,26.3),(11.9,26.5),(12.1,26.5),(12.1,26.3),(11.9,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,13.5),(-7.3,13.7),(-7.1,13.7),(-7.1,13.5),(-7.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-13.7),(7.1,-13.5),(7.3,-13.5),(7.3,-13.7),(7.1,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,11.9),(24.7,12.1),(24.9,12.1),(24.9,11.9),(24.7,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,3.9),(26.3,4.1),(26.5,4.1),(26.5,3.9),(26.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,13.5),(19.9,13.7),(20.1,13.7),(20.1,13.5),(19.9,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,18.3),(-18.5,18.5),(-18.3,18.5),(-18.3,18.3),(-18.5,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-7.3),(-16.9,-7.1),(-16.7,-7.1),(-16.7,-7.3),(-16.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,7.1),(-16.9,7.3),(-16.7,7.3),(-16.7,7.1),(-16.9,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,3.9),(-21.7,4.1),(-21.5,4.1),(-21.5,3.9),(-21.7,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-18.5),(18.3,-18.3),(18.5,-18.3),(18.5,-18.5),(18.3,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,3.9),(2.3,4.1),(2.5,4.1),(2.5,3.9),(2.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-18.5),(8.7,-18.3),(8.9,-18.3),(8.9,-18.5),(8.7,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,18.3),(8.7,18.5),(8.9,18.5),(8.9,18.3),(8.7,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,18.3),(-23.3,18.5),(-23.1,18.5),(-23.1,18.3),(-23.3,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,3.9),(-31.3,4.1),(-31.1,4.1),(-31.1,3.9),(-31.3,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-8.9),(-16.9,-8.7),(-16.7,-8.7),(-16.7,-8.9),(-16.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-8.9),(-0.9,-8.7),(-0.7,-8.7),(-0.7,-8.9),(-0.9,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,24.7),(-0.9,24.9),(-0.7,24.9),(-0.7,24.7),(-0.9,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,8.7),(-28.1,8.9),(-27.9,8.9),(-27.9,8.7),(-28.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-8.9),(0.7,-8.7),(0.9,-8.7),(0.9,-8.9),(0.7,-8.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,24.7),(0.7,24.9),(0.9,24.9),(0.9,24.7),(0.7,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,18.3),(23.1,18.5),(23.3,18.5),(23.3,18.3),(23.1,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,0.7),(13.5,0.9),(13.7,0.9),(13.7,0.7),(13.5,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-7.3),(-5.7,-7.1),(-5.5,-7.1),(-5.5,-7.3),(-5.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,-2.5),(-12.1,-2.3),(-11.9,-2.3),(-11.9,-2.5),(-12.1,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,7.1),(5.5,7.3),(5.7,7.3),(5.7,7.1),(5.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-2.5),(-29.7,-2.3),(-29.5,-2.3),(-29.5,-2.5),(-29.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-2.5),(29.5,-2.3),(29.7,-2.3),(29.7,-2.5),(29.5,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,11.9),(-20.1,12.1),(-19.9,12.1),(-19.9,11.9),(-20.1,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-23.3),(3.9,-23.1),(4.1,-23.1),(4.1,-23.3),(3.9,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,10.3),(-28.1,10.5),(-27.9,10.5),(-27.9,10.3),(-28.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,10.3),(-23.3,10.5),(-23.1,10.5),(-23.1,10.3),(-23.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-16.9),(3.9,-16.7),(4.1,-16.7),(4.1,-16.9),(3.9,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,13.5),(-28.1,13.7),(-27.9,13.7),(-27.9,13.5),(-28.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,10.3),(23.1,10.5),(23.3,10.5),(23.3,10.3),(23.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-21.7),(-15.3,-21.5),(-15.1,-21.5),(-15.1,-21.7),(-15.3,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,21.5),(15.1,21.7),(15.3,21.7),(15.3,21.5),(15.1,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-4.1),(-5.7,-3.9),(-5.5,-3.9),(-5.5,-4.1),(-5.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-4.1),(5.5,-3.9),(5.7,-3.9),(5.7,-4.1),(5.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-12.1),(-16.9,-11.9),(-16.7,-11.9),(-16.7,-12.1),(-16.9,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.9,18.3),(19.9,18.5),(20.1,18.5),(20.1,18.3),(19.9,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,11.9),(-2.5,12.1),(-2.3,12.1),(-2.3,11.9),(-2.5,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,-2.5),(32.7,-2.3),(32.9,-2.3),(32.9,-2.5),(32.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.7,2.3),(32.7,2.5),(32.9,2.5),(32.9,2.3),(32.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,-16.9),(-18.5,-16.7),(-18.3,-16.7),(-18.3,-16.9),(-18.5,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-16.9),(18.3,-16.7),(18.5,-16.7),(18.5,-16.9),(18.3,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-20.1),(3.9,-19.9),(4.1,-19.9),(4.1,-20.1),(3.9,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,24.7),(-8.9,24.9),(-8.7,24.9),(-8.7,24.7),(-8.9,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,8.7),(-23.3,8.9),(-23.1,8.9),(-23.1,8.7),(-23.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,26.3),(3.9,26.5),(4.1,26.5),(4.1,26.3),(3.9,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,8.7),(23.1,8.9),(23.3,8.9),(23.3,8.7),(23.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-34.5,3.9),(-34.5,4.1),(-34.3,4.1),(-34.3,3.9),(-34.5,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-2.5),(8.7,-2.3),(8.9,-2.3),(8.9,-2.5),(8.7,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,2.3),(8.7,2.5),(8.9,2.5),(8.9,2.3),(8.7,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,21.5),(-13.7,21.7),(-13.5,21.7),(-13.5,21.5),(-13.7,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-21.7),(13.5,-21.5),(13.7,-21.5),(13.7,-21.7),(13.5,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-16.9),(-10.5,-16.7),(-10.3,-16.7),(-10.3,-16.9),(-10.5,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,-16.9),(10.3,-16.7),(10.5,-16.7),(10.5,-16.9),(10.3,-16.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-36.1,5.5),(-36.1,5.7),(-35.9,5.7),(-35.9,5.5),(-36.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,-24.9),(-16.9,-24.7),(-16.7,-24.7),(-16.7,-24.9),(-16.9,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-5.7),(-31.3,-5.5),(-31.1,-5.5),(-31.1,-5.7),(-31.3,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,5.5),(31.1,5.7),(31.3,5.7),(31.3,5.5),(31.1,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,19.9),(8.7,20.1),(8.9,20.1),(8.9,19.9),(8.7,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.9,2.3),(35.9,2.5),(36.1,2.5),(36.1,2.3),(35.9,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-21.7),(-0.9,-21.5),(-0.7,-21.5),(-0.7,-21.7),(-0.9,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,21.5),(-0.9,21.7),(-0.7,21.7),(-0.7,21.5),(-0.9,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-21.7),(0.7,-21.5),(0.9,-21.5),(0.9,-21.7),(0.7,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,3.9),(23.1,4.1),(23.3,4.1),(23.3,3.9),(23.1,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,21.5),(0.7,21.7),(0.9,21.7),(0.9,21.5),(0.7,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,-7.3),(34.3,-7.1),(34.5,-7.1),(34.5,-7.3),(34.3,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((34.3,7.1),(34.3,7.3),(34.5,7.3),(34.5,7.1),(34.3,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-7.3),(-29.7,-7.1),(-29.5,-7.1),(-29.5,-7.3),(-29.7,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-12.1),(-2.5,-11.9),(-2.3,-11.9),(-2.3,-12.1),(-2.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-12.1),(2.3,-11.9),(2.5,-11.9),(2.5,-12.1),(2.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,7.1),(29.5,7.3),(29.7,7.3),(29.7,7.1),(29.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,8.7),(-20.1,8.9),(-19.9,8.9),(-19.9,8.7),(-20.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-29.7,-4.1),(-29.7,-3.9),(-29.5,-3.9),(-29.5,-4.1),(-29.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-4.1),(29.5,-3.9),(29.7,-3.9),(29.7,-4.1),(29.5,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,19.9),(-8.9,20.1),(-8.7,20.1),(-8.7,19.9),(-8.9,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-20.1),(-0.9,-19.9),(-0.7,-19.9),(-0.7,-20.1),(-0.9,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-20.1),(0.7,-19.9),(0.9,-19.9),(0.9,-20.1),(0.7,-20.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,8.7),(-2.5,8.9),(-2.3,8.9),(-2.3,8.7),(-2.5,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,8.7),(2.3,8.9),(2.5,8.9),(2.5,8.7),(2.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,8.7),(-8.9,8.9),(-8.7,8.9),(-8.7,8.7),(-8.9,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-4.1),(3.9,-3.9),(4.1,-3.9),(4.1,-4.1),(3.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,-0.9),(-28.1,-0.7),(-27.9,-0.7),(-27.9,-0.9),(-28.1,-0.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-28.1,0.7),(-28.1,0.9),(-27.9,0.9),(-27.9,0.7),(-28.1,0.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,19.9),(16.7,20.1),(16.9,20.1),(16.9,19.9),(16.7,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-26.5),(13.5,-26.3),(13.7,-26.3),(13.7,-26.5),(13.5,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,-26.5),(-13.7,-26.3),(-13.5,-26.3),(-13.5,-26.5),(-13.7,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-12.1,15.1),(-12.1,15.3),(-11.9,15.3),(-11.9,15.1),(-12.1,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-26.5),(-0.9,-26.3),(-0.7,-26.3),(-0.7,-26.5),(-0.9,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((13.5,-5.7),(13.5,-5.5),(13.7,-5.5),(13.7,-5.7),(13.5,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,26.3),(-0.9,26.5),(-0.7,26.5),(-0.7,26.3),(-0.9,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-13.7,5.5),(-13.7,5.7),(-13.5,5.7),(-13.5,5.5),(-13.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,10.3),(-20.1,10.5),(-19.9,10.5),(-19.9,10.3),(-20.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-26.5),(0.7,-26.3),(0.9,-26.3),(0.9,-26.5),(0.7,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,26.3),(0.7,26.5),(0.9,26.5),(0.9,26.3),(0.7,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,19.9),(5.5,20.1),(5.7,20.1),(5.7,19.9),(5.5,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,11.9),(-23.3,12.1),(-23.1,12.1),(-23.1,11.9),(-23.3,11.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-20.1,13.5),(-20.1,13.7),(-19.9,13.7),(-19.9,13.5),(-20.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,-5.7),(8.7,-5.5),(8.9,-5.5),(8.9,-5.7),(8.7,-5.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,5.5),(8.7,5.7),(8.9,5.7),(8.9,5.5),(8.7,5.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-10.5),(-2.5,-10.3),(-2.3,-10.3),(-2.3,-10.5),(-2.5,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,10.3),(2.3,10.5),(2.5,10.5),(2.5,10.3),(2.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.7,-4.1),(16.7,-3.9),(16.9,-3.9),(16.9,-4.1),(16.7,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,-10.5),(-8.9,-10.3),(-8.7,-10.3),(-8.7,-10.5),(-8.9,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-8.9,10.3),(-8.9,10.5),(-8.7,10.5),(-8.7,10.3),(-8.9,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,15.1),(-21.7,15.3),(-21.5,15.3),(-21.5,15.1),(-21.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((21.5,-15.3),(21.5,-15.1),(21.7,-15.1),(21.7,-15.3),(21.5,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,-15.3),(24.7,-15.1),(24.9,-15.1),(24.9,-15.3),(24.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.7,15.1),(24.7,15.3),(24.9,15.3),(24.9,15.1),(24.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,24.7),(-10.5,24.9),(-10.3,24.9),(-10.3,24.7),(-10.5,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((10.3,24.7),(10.3,24.9),(10.5,24.9),(10.5,24.7),(10.3,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,-15.3),(-0.9,-15.1),(-0.7,-15.1),(-0.7,-15.3),(-0.9,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-0.9,15.1),(-0.9,15.3),(-0.7,15.3),(-0.7,15.1),(-0.9,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,-15.3),(0.7,-15.1),(0.9,-15.1),(0.9,-15.3),(0.7,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((0.7,15.1),(0.7,15.3),(0.9,15.3),(0.9,15.1),(0.7,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,-13.7),(26.3,-13.5),(26.5,-13.5),(26.5,-13.7),(26.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((26.3,13.5),(26.3,13.7),(26.5,13.7),(26.5,13.5),(26.3,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-15.3),(-23.3,-15.1),(-23.1,-15.1),(-23.1,-15.3),(-23.3,-15.3)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,15.1),(23.1,15.3),(23.3,15.3),(23.3,15.1),(23.1,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-12.1),(-7.3,-11.9),(-7.1,-11.9),(-7.1,-12.1),(-7.3,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-12.1),(7.1,-11.9),(7.3,-11.9),(7.3,-12.1),(7.1,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((29.5,-12.1),(29.5,-11.9),(29.7,-11.9),(29.7,-12.1),(29.5,-12.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.9,-4.1),(27.9,-3.9),(28.1,-3.9),(28.1,-4.1),(27.9,-4.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,18.3),(-2.5,18.5),(-2.3,18.5),(-2.3,18.3),(-2.5,18.3)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,-18.5),(2.3,-18.3),(2.5,-18.3),(2.5,-18.5),(2.3,-18.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,-26.5),(-15.3,-26.3),(-15.1,-26.3),(-15.1,-26.5),(-15.3,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-2.5),(3.9,-2.3),(4.1,-2.3),(4.1,-2.5),(3.9,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,-26.5),(15.1,-26.3),(15.3,-26.3),(15.3,-26.5),(15.1,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-23.3,-13.7),(-23.3,-13.5),(-23.1,-13.5),(-23.1,-13.7),(-23.3,-13.7)),
        )
        createRL(
            tech, net, 'via2',
            ((23.1,13.5),(23.1,13.7),(23.3,13.7),(23.3,13.5),(23.1,13.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-2.5,-26.5),(-2.5,-26.3),(-2.3,-26.3),(-2.3,-26.5),(-2.5,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((2.3,26.3),(2.3,26.5),(2.5,26.5),(2.5,26.3),(2.3,26.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,-21.7),(-4.1,-21.5),(-3.9,-21.5),(-3.9,-21.7),(-4.1,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,19.9),(-4.1,20.1),(-3.9,20.1),(-3.9,19.9),(-4.1,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,23.1),(-7.3,23.3),(-7.1,23.3),(-7.1,23.1),(-7.3,23.1)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-23.3),(7.1,-23.1),(7.3,-23.1),(7.3,-23.3),(7.1,-23.3)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,8.7),(15.1,8.9),(15.3,8.9),(15.3,8.7),(15.1,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,10.3),(-15.3,10.5),(-15.1,10.5),(-15.1,10.3),(-15.3,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((15.1,10.3),(15.1,10.5),(15.3,10.5),(15.3,10.3),(15.1,10.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.7,24.7),(8.7,24.9),(8.9,24.9),(8.9,24.7),(8.7,24.7)),
        )
        createRL(
            tech, net, 'via2',
            ((-18.5,2.3),(-18.5,2.5),(-18.3,2.5),(-18.3,2.3),(-18.5,2.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-16.9,3.9),(-16.9,4.1),(-16.7,4.1),(-16.7,3.9),(-16.9,3.9)),
        )
        createRL(
            tech, net, 'via2',
            ((18.3,-2.5),(18.3,-2.3),(18.5,-2.3),(18.5,-2.5),(18.3,-2.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-4.1,15.1),(-4.1,15.3),(-3.9,15.3),(-3.9,15.1),(-4.1,15.1)),
        )
        createRL(
            tech, net, 'via2',
            ((-7.3,-24.9),(-7.3,-24.7),(-7.1,-24.7),(-7.1,-24.9),(-7.3,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-21.7,19.9),(-21.7,20.1),(-21.5,20.1),(-21.5,19.9),(-21.7,19.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-26.5),(-5.7,-26.3),(-5.5,-26.3),(-5.5,-26.5),(-5.7,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,-26.5),(5.5,-26.3),(5.7,-26.3),(5.7,-26.5),(5.5,-26.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-5.7,-21.7),(-5.7,-21.5),(-5.5,-21.5),(-5.5,-21.7),(-5.7,-21.7)),
        )
        createRL(
            tech, net, 'via2',
            ((5.5,21.5),(5.5,21.7),(5.7,21.7),(5.7,21.5),(5.5,21.5)),
        )
        createRL(
            tech, net, 'via2',
            ((7.1,-24.9),(7.1,-24.7),(7.3,-24.7),(7.3,-24.9),(7.1,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,-24.9),(3.9,-24.7),(4.1,-24.7),(4.1,-24.9),(3.9,-24.9)),
        )
        createRL(
            tech, net, 'via2',
            ((-31.3,-10.5),(-31.3,-10.3),(-31.1,-10.3),(-31.1,-10.5),(-31.3,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,-7.3),(-10.5,-7.1),(-10.3,-7.1),(-10.3,-7.3),(-10.5,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((-10.5,7.1),(-10.5,7.3),(-10.3,7.3),(-10.3,7.1),(-10.5,7.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.9,-7.3),(11.9,-7.1),(12.1,-7.1),(12.1,-7.3),(11.9,-7.3)),
        )
        createRL(
            tech, net, 'via2',
            ((31.1,-10.5),(31.1,-10.3),(31.3,-10.3),(31.3,-10.5),(31.1,-10.5)),
        )
        createRL(
            tech, net, 'via2',
            ((-15.3,8.7),(-15.3,8.9),(-15.1,8.9),(-15.1,8.7),(-15.3,8.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.9,21.5),(3.9,21.7),(4.1,21.7),(4.1,21.5),(3.9,21.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-6.5),(12.7,-6.3),(12.9,-6.3),(12.9,-6.5),(12.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,6.3),(12.7,6.5),(12.9,6.5),(12.9,6.3),(12.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,1.5),(-19.3,1.7),(-19.1,1.7),(-19.1,1.5),(-19.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-1.7),(19.1,-1.5),(19.3,-1.5),(19.3,-1.7),(19.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-9.7),(23.9,-9.5),(24.1,-9.5),(24.1,-9.7),(23.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,11.1),(23.9,11.3),(24.1,11.3),(24.1,11.1),(23.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,6.3),(-19.3,6.5),(-19.1,6.5),(-19.1,6.3),(-19.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-20.9),(-17.7,-20.7),(-17.5,-20.7),(-17.5,-20.9),(-17.7,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-20.9),(17.5,-20.7),(17.7,-20.7),(17.7,-20.9),(17.5,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,6.3),(19.1,6.5),(19.3,6.5),(19.3,6.3),(19.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,11.1),(-8.1,11.3),(-7.9,11.3),(-7.9,11.1),(-8.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-0.1),(-9.7,0.1),(-9.5,0.1),(-9.5,-0.1),(-9.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,15.9),(11.1,16.1),(11.3,16.1),(11.3,15.9),(11.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-12.9),(-20.9,-12.7),(-20.7,-12.7),(-20.7,-12.9),(-20.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,12.7),(20.7,12.9),(20.9,12.9),(20.9,12.7),(20.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-19.3),(-22.5,-19.1),(-22.3,-19.1),(-22.3,-19.3),(-22.5,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,19.1),(-22.5,19.3),(-22.3,19.3),(-22.3,19.1),(-22.5,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,7.9),(-22.5,8.1),(-22.3,8.1),(-22.3,7.9),(-22.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,3.1),(-27.3,3.3),(-27.1,3.3),(-27.1,3.1),(-27.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-0.1),(9.5,0.1),(9.7,0.1),(9.7,-0.1),(9.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-11.3),(-16.1,-11.1),(-15.9,-11.1),(-15.9,-11.3),(-16.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-3.3),(27.1,-3.1),(27.3,-3.1),(27.3,-3.3),(27.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-6.5),(31.9,-6.3),(32.1,-6.3),(32.1,-6.5),(31.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-3.3),(14.3,-3.1),(14.5,-3.1),(14.5,-3.3),(14.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,3.1),(14.3,3.3),(14.5,3.3),(14.5,3.1),(14.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-17.7),(-1.7,-17.5),(-1.5,-17.5),(-1.5,-17.7),(-1.7,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,17.5),(1.5,17.7),(1.7,17.7),(1.7,17.5),(1.5,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,4.7),(31.9,4.9),(32.1,4.9),(32.1,4.7),(31.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,7.9),(20.7,8.1),(20.9,8.1),(20.9,7.9),(20.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-17.7),(23.9,-17.5),(24.1,-17.5),(24.1,-17.7),(23.9,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-8.1),(7.9,-7.9),(8.1,-7.9),(8.1,-8.1),(7.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-4.9),(-11.3,-4.7),(-11.1,-4.7),(-11.1,-4.9),(-11.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-25.7),(-16.1,-25.5),(-15.9,-25.5),(-15.9,-25.7),(-16.1,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-4.9),(11.1,-4.7),(11.3,-4.7),(11.3,-4.9),(11.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-8.1),(-22.5,-7.9),(-22.3,-7.9),(-22.3,-8.1),(-22.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-12.9),(-8.1,-12.7),(-7.9,-12.7),(-7.9,-12.9),(-8.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-8.1),(22.3,-7.9),(22.5,-7.9),(22.5,-8.1),(22.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-0.1),(-1.7,0.1),(-1.5,0.1),(-1.5,-0.1),(-1.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-16.1),(-0.1,-15.9),(0.1,-15.9),(0.1,-16.1),(-0.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-0.1),(1.5,0.1),(1.7,0.1),(1.7,-0.1),(1.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-1.7),(-17.7,-1.5),(-17.5,-1.5),(-17.5,-1.7),(-17.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,1.5),(17.5,1.7),(17.7,1.7),(17.7,1.5),(17.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-16.1),(-25.7,-15.9),(-25.5,-15.9),(-25.5,-16.1),(-25.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,20.7),(-11.3,20.9),(-11.1,20.9),(-11.1,20.7),(-11.3,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,20.7),(11.1,20.9),(11.3,20.9),(11.3,20.7),(11.1,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-16.1),(25.5,-15.9),(25.7,-15.9),(25.7,-16.1),(25.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,4.7),(-4.9,4.9),(-4.7,4.9),(-4.7,4.7),(-4.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-4.9),(4.7,-4.7),(4.9,-4.7),(4.9,-4.9),(4.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,4.7),(-22.5,4.9),(-22.3,4.9),(-22.3,4.7),(-22.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,4.7),(22.3,4.9),(22.5,4.9),(22.5,4.7),(22.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,-0.1),(-35.3,0.1),(-35.1,0.1),(-35.1,-0.1),(-35.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-9.7),(-32.1,-9.5),(-31.9,-9.5),(-31.9,-9.7),(-32.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,15.9),(-25.7,16.1),(-25.5,16.1),(-25.5,15.9),(-25.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,-0.1),(35.1,0.1),(35.3,0.1),(35.3,-0.1),(35.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-11.3),(-25.7,-11.1),(-25.5,-11.1),(-25.5,-11.3),(-25.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-9.7),(15.9,-9.5),(16.1,-9.5),(16.1,-9.7),(15.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,11.1),(15.9,11.3),(16.1,11.3),(16.1,11.1),(15.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,11.1),(25.5,11.3),(25.7,11.3),(25.7,11.1),(25.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-1.7),(12.7,-1.5),(12.9,-1.5),(12.9,-1.7),(12.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,1.5),(12.7,1.7),(12.9,1.7),(12.9,1.5),(12.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-17.7),(-6.5,-17.5),(-6.3,-17.5),(-6.3,-17.7),(-6.5,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,17.5),(-6.5,17.7),(-6.3,17.7),(-6.3,17.5),(-6.5,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-0.1),(-0.1,0.1),(0.1,0.1),(0.1,-0.1),(-0.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-4.9),(-25.7,-4.7),(-25.5,-4.7),(-25.5,-4.9),(-25.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-4.9),(25.5,-4.7),(25.7,-4.7),(25.7,-4.9),(25.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,15.9),(3.1,16.1),(3.3,16.1),(3.3,15.9),(3.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-3.3),(-0.1,-3.1),(0.1,-3.1),(0.1,-3.3),(-0.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,3.1),(-0.1,3.3),(0.1,3.3),(0.1,3.1),(-0.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-0.1),(-19.3,0.1),(-19.1,0.1),(-19.1,-0.1),(-19.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-16.1),(-12.9,-15.9),(-12.7,-15.9),(-12.7,-16.1),(-12.9,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-6.5),(-20.9,-6.3),(-20.7,-6.3),(-20.7,-6.5),(-20.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,6.3),(-20.9,6.5),(-20.7,6.5),(-20.7,6.3),(-20.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-17.7),(-3.3,-17.5),(-3.1,-17.5),(-3.1,-17.7),(-3.3,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-14.5),(-8.1,-14.3),(-7.9,-14.3),(-7.9,-14.5),(-8.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,14.3),(-14.5,14.5),(-14.3,14.5),(-14.3,14.3),(-14.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,17.5),(3.1,17.7),(3.3,17.7),(3.3,17.5),(3.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-4.9),(-1.7,-4.7),(-1.5,-4.7),(-1.5,-4.9),(-1.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-4.9),(1.5,-4.7),(1.7,-4.7),(1.7,-4.9),(1.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,-0.1),(-36.9,0.1),(-36.7,0.1),(-36.7,-0.1),(-36.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-14.5),(14.3,-14.3),(14.5,-14.3),(14.5,-14.5),(14.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-6.5),(7.9,-6.3),(8.1,-6.3),(8.1,-6.5),(7.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,4.7),(7.9,4.9),(8.1,4.9),(8.1,4.7),(7.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,-0.1),(36.7,0.1),(36.9,0.1),(36.9,-0.1),(36.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,4.7),(-11.3,4.9),(-11.1,4.9),(-11.1,4.7),(-11.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,4.7),(11.1,4.9),(11.3,4.9),(11.3,4.7),(11.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-6.5),(-14.5,-6.3),(-14.3,-6.3),(-14.3,-6.5),(-14.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,6.3),(14.3,6.5),(14.5,6.5),(14.5,6.3),(14.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-14.5),(-27.3,-14.3),(-27.1,-14.3),(-27.1,-14.5),(-27.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-22.5),(-19.3,-22.3),(-19.1,-22.3),(-19.1,-22.5),(-19.3,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,4.7),(-28.9,4.9),(-28.7,4.9),(-28.7,4.7),(-28.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,23.9),(6.3,24.1),(6.5,24.1),(6.5,23.9),(6.3,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,9.5),(-25.7,9.7),(-25.5,9.7),(-25.5,9.5),(-25.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-19.3),(-11.3,-19.1),(-11.1,-19.1),(-11.1,-19.3),(-11.3,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-0.1),(-8.1,0.1),(-7.9,0.1),(-7.9,-0.1),(-8.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,19.1),(11.1,19.3),(11.3,19.3),(11.3,19.1),(11.1,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,6.3),(-9.7,6.5),(-9.5,6.5),(-9.5,6.3),(-9.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,6.3),(9.5,6.5),(9.7,6.5),(9.7,6.3),(9.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-9.7),(25.5,-9.5),(25.7,-9.5),(25.7,-9.7),(25.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-4.9),(28.7,-4.7),(28.9,-4.7),(28.9,-4.9),(28.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-8.1),(-19.3,-7.9),(-19.1,-7.9),(-19.1,-8.1),(-19.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-8.1),(19.1,-7.9),(19.3,-7.9),(19.3,-8.1),(19.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,7.9),(-3.3,8.1),(-3.1,8.1),(-3.1,7.9),(-3.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-0.1),(-32.1,0.1),(-31.9,0.1),(-31.9,-0.1),(-32.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-22.5),(-9.7,-22.3),(-9.5,-22.3),(-9.5,-22.5),(-9.7,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-1.7),(-16.1,-1.5),(-15.9,-1.5),(-15.9,-1.7),(-16.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-22.5),(9.5,-22.3),(9.7,-22.3),(9.7,-22.5),(9.5,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-19.3),(4.7,-19.1),(4.9,-19.1),(4.9,-19.3),(4.7,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,19.1),(4.7,19.3),(4.9,19.3),(4.9,19.1),(4.7,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,-6.5),(-35.3,-6.3),(-35.1,-6.3),(-35.1,-6.5),(-35.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,12.7),(-25.7,12.9),(-25.5,12.9),(-25.5,12.7),(-25.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,12.7),(25.5,12.9),(25.7,12.9),(25.7,12.7),(25.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,-6.5),(35.1,-6.3),(35.3,-6.3),(35.3,-6.5),(35.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,7.9),(-24.1,8.1),(-23.9,8.1),(-23.9,7.9),(-24.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-3.3),(-19.3,-3.1),(-19.1,-3.1),(-19.1,-3.3),(-19.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-27.3),(7.9,-27.1),(8.1,-27.1),(8.1,-27.3),(7.9,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,3.1),(19.1,3.3),(19.3,3.3),(19.3,3.1),(19.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-22.5),(19.1,-22.3),(19.3,-22.3),(19.3,-22.5),(19.1,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-20.9),(-1.7,-20.7),(-1.5,-20.7),(-1.5,-20.9),(-1.7,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-20.9),(1.5,-20.7),(1.7,-20.7),(1.7,-20.9),(1.5,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,27.1),(-11.3,27.3),(-11.1,27.3),(-11.1,27.1),(-11.3,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,22.3),(-8.1,22.5),(-7.9,22.5),(-7.9,22.3),(-8.1,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,1.5),(7.9,1.7),(8.1,1.7),(8.1,1.5),(7.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-27.3),(11.1,-27.1),(11.3,-27.1),(11.3,-27.3),(11.1,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-0.1),(7.9,0.1),(8.1,0.1),(8.1,-0.1),(7.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-17.7),(22.3,-17.5),(22.5,-17.5),(22.5,-17.7),(22.3,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,17.5),(22.3,17.7),(22.5,17.7),(22.5,17.5),(22.3,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-22.5),(-14.5,-22.3),(-14.3,-22.3),(-14.3,-22.5),(-14.5,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-8.1),(-8.1,-7.9),(-7.9,-7.9),(-7.9,-8.1),(-8.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,22.3),(14.3,22.5),(14.5,22.5),(14.5,22.3),(14.3,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-16.1),(-4.9,-15.9),(-4.7,-15.9),(-4.7,-16.1),(-4.9,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-1.7),(-14.5,-1.5),(-14.3,-1.5),(-14.3,-1.7),(-14.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,1.5),(-14.5,1.7),(-14.3,1.7),(-14.3,1.5),(-14.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,-1.7),(-35.3,-1.5),(-35.1,-1.5),(-35.1,-1.7),(-35.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,17.5),(-19.3,17.7),(-19.1,17.7),(-19.1,17.5),(-19.3,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-16.1),(4.7,-15.9),(4.9,-15.9),(4.9,-16.1),(4.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-17.7),(19.1,-17.5),(19.3,-17.5),(19.3,-17.7),(19.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,22.3),(-19.3,22.5),(-19.1,22.5),(-19.1,22.3),(-19.3,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,7.9),(-27.3,8.1),(-27.1,8.1),(-27.1,7.9),(-27.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-3.3),(-8.1,-3.1),(-7.9,-3.1),(-7.9,-3.3),(-8.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,22.3),(19.1,22.5),(19.3,22.5),(19.3,22.3),(19.1,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-9.7),(-1.7,-9.5),(-1.5,-9.5),(-1.5,-9.7),(-1.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,9.5),(1.5,9.7),(1.7,9.7),(1.7,9.5),(1.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,15.9),(-20.9,16.1),(-20.7,16.1),(-20.7,15.9),(-20.9,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-6.5),(-9.7,-6.3),(-9.5,-6.3),(-9.5,-6.5),(-9.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-17.7),(-16.1,-17.5),(-15.9,-17.5),(-15.9,-17.7),(-16.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-6.5),(9.5,-6.3),(9.7,-6.3),(9.7,-6.5),(9.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-14.5),(-19.3,-14.3),(-19.1,-14.3),(-19.1,-14.5),(-19.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-14.5),(19.1,-14.3),(19.3,-14.3),(19.3,-14.5),(19.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-16.1),(23.9,-15.9),(24.1,-15.9),(24.1,-16.1),(23.9,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-4.9),(23.9,-4.7),(24.1,-4.7),(24.1,-4.9),(23.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,17.5),(-9.7,17.7),(-9.5,17.7),(-9.5,17.5),(-9.7,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-11.3),(7.9,-11.1),(8.1,-11.1),(8.1,-11.3),(7.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-17.7),(9.5,-17.5),(9.7,-17.5),(9.7,-17.7),(9.5,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,3.1),(-17.7,3.3),(-17.5,3.3),(-17.5,3.1),(-17.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,4.7),(-24.1,4.9),(-23.9,4.9),(-23.9,4.7),(-24.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-3.3),(17.5,-3.1),(17.7,-3.1),(17.7,-3.3),(17.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,7.9),(7.9,8.1),(8.1,8.1),(8.1,7.9),(7.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-27.3),(6.3,-27.1),(6.5,-27.1),(6.5,-27.3),(6.3,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,27.1),(6.3,27.3),(6.5,27.3),(6.5,27.1),(6.3,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,11.1),(-11.3,11.3),(-11.1,11.3),(-11.1,11.1),(-11.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-11.3),(11.1,-11.1),(11.3,-11.1),(11.3,-11.3),(11.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-1.7),(-4.9,-1.5),(-4.7,-1.5),(-4.7,-1.7),(-4.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,1.5),(-4.9,1.7),(-4.7,1.7),(-4.7,1.5),(-4.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,7.9),(14.3,8.1),(14.5,8.1),(14.5,7.9),(14.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,7.9),(-25.7,8.1),(-25.5,8.1),(-25.5,7.9),(-25.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,15.9),(17.5,16.1),(17.7,16.1),(17.7,15.9),(17.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-19.3),(-9.7,-19.1),(-9.5,-19.1),(-9.5,-19.3),(-9.7,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,19.1),(9.5,19.3),(9.7,19.3),(9.7,19.1),(9.5,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-19.3),(-12.9,-19.1),(-12.7,-19.1),(-12.7,-19.3),(-12.9,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,19.1),(-12.9,19.3),(-12.7,19.3),(-12.7,19.1),(-12.9,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-25.7),(-9.7,-25.5),(-9.5,-25.5),(-9.5,-25.7),(-9.7,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,25.5),(9.5,25.7),(9.7,25.7),(9.7,25.5),(9.5,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,-4.9),(-35.3,-4.7),(-35.1,-4.7),(-35.1,-4.9),(-35.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,7.9),(-1.7,8.1),(-1.5,8.1),(-1.5,7.9),(-1.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,-4.9),(35.1,-4.7),(35.3,-4.7),(35.3,-4.9),(35.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,9.5),(-11.3,9.7),(-11.1,9.7),(-11.1,9.5),(-11.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-9.7),(11.1,-9.5),(11.3,-9.5),(11.3,-9.7),(11.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,14.3),(-11.3,14.5),(-11.1,14.5),(-11.1,14.3),(-11.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,14.3),(11.1,14.5),(11.3,14.5),(11.3,14.3),(11.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,17.5),(-17.7,17.7),(-17.5,17.7),(-17.5,17.5),(-17.7,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,27.1),(-3.3,27.3),(-3.1,27.3),(-3.1,27.1),(-3.3,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-27.3),(3.1,-27.1),(3.3,-27.1),(3.3,-27.3),(3.1,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-17.7),(17.5,-17.5),(17.7,-17.5),(17.7,-17.7),(17.5,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,6.3),(31.9,6.5),(32.1,6.5),(32.1,6.3),(31.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-9.7),(6.3,-9.5),(6.5,-9.5),(6.5,-9.7),(6.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,9.5),(6.3,9.7),(6.5,9.7),(6.5,9.5),(6.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-3.3),(-20.9,-3.1),(-20.7,-3.1),(-20.7,-3.3),(-20.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,3.1),(-20.9,3.3),(-20.7,3.3),(-20.7,3.1),(-20.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,6.3),(-16.1,6.5),(-15.9,6.5),(-15.9,6.3),(-16.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-8.1),(-9.7,-7.9),(-9.5,-7.9),(-9.5,-8.1),(-9.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-8.1),(9.5,-7.9),(9.7,-7.9),(9.7,-8.1),(9.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,-3.3),(-33.7,-3.1),(-33.5,-3.1),(-33.5,-3.3),(-33.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-1.7),(-11.3,-1.5),(-11.1,-1.5),(-11.1,-1.7),(-11.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-24.1),(-16.1,-23.9),(-15.9,-23.9),(-15.9,-24.1),(-16.1,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-20.9),(-8.1,-20.7),(-7.9,-20.7),(-7.9,-20.9),(-8.1,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,1.5),(11.1,1.7),(11.3,1.7),(11.3,1.5),(11.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-25.7),(15.9,-25.5),(16.1,-25.5),(16.1,-25.7),(15.9,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-11.3),(6.3,-11.1),(6.5,-11.1),(6.5,-11.3),(6.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,11.1),(6.3,11.3),(6.5,11.3),(6.5,11.1),(6.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,3.1),(33.5,3.3),(33.7,3.3),(33.7,3.1),(33.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-1.7),(-28.9,-1.5),(-28.7,-1.5),(-28.7,-1.7),(-28.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,1.5),(-28.9,1.7),(-28.7,1.7),(-28.7,1.5),(-28.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,20.7),(-19.3,20.9),(-19.1,20.9),(-19.1,20.7),(-19.3,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,20.7),(19.1,20.9),(19.3,20.9),(19.3,20.7),(19.1,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,-1.7),(36.7,-1.5),(36.9,-1.5),(36.9,-1.7),(36.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,1.5),(36.7,1.7),(36.9,1.7),(36.9,1.5),(36.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-3.3),(-9.7,-3.1),(-9.5,-3.1),(-9.5,-3.3),(-9.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,3.1),(9.5,3.3),(9.7,3.3),(9.7,3.1),(9.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-19.3),(-16.1,-19.1),(-15.9,-19.1),(-15.9,-19.3),(-16.1,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-4.9),(-4.9,-4.7),(-4.7,-4.7),(-4.7,-4.9),(-4.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,4.7),(4.7,4.9),(4.9,4.9),(4.9,4.7),(4.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-16.1),(15.9,-15.9),(16.1,-15.9),(16.1,-16.1),(15.9,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,19.1),(-8.1,19.3),(-7.9,19.3),(-7.9,19.1),(-8.1,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-8.1),(-32.1,-7.9),(-31.9,-7.9),(-31.9,-8.1),(-32.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,6.3),(-22.5,6.5),(-22.3,6.5),(-22.3,6.3),(-22.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-6.5),(22.3,-6.3),(22.5,-6.3),(22.5,-6.5),(22.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,1.5),(-16.1,1.7),(-15.9,1.7),(-15.9,1.5),(-16.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,23.9),(11.1,24.1),(11.3,24.1),(11.3,23.9),(11.1,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,15.9),(-22.5,16.1),(-22.3,16.1),(-22.3,15.9),(-22.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,11.1),(-3.3,11.3),(-3.1,11.3),(-3.1,11.1),(-3.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-0.1),(-16.1,0.1),(-15.9,0.1),(-15.9,-0.1),(-16.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-11.3),(3.1,-11.1),(3.3,-11.1),(3.3,-11.3),(3.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,4.7),(-35.3,4.9),(-35.1,4.9),(-35.1,4.7),(-35.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,4.7),(35.1,4.9),(35.3,4.9),(35.3,4.7),(35.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-3.3),(12.7,-3.1),(12.9,-3.1),(12.9,-3.3),(12.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,3.1),(12.7,3.3),(12.9,3.3),(12.9,3.1),(12.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-3.3),(-32.1,-3.1),(-31.9,-3.1),(-31.9,-3.3),(-32.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-19.3),(-6.5,-19.1),(-6.3,-19.1),(-6.3,-19.3),(-6.5,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,19.1),(-6.5,19.3),(-6.3,19.3),(-6.3,19.1),(-6.5,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-27.3),(-0.1,-27.1),(0.1,-27.1),(0.1,-27.3),(-0.1,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,27.1),(-0.1,27.3),(0.1,27.3),(0.1,27.1),(-0.1,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,9.5),(-3.3,9.7),(-3.1,9.7),(-3.1,9.5),(-3.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-22.5),(-8.1,-22.3),(-7.9,-22.3),(-7.9,-22.5),(-8.1,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-16.1),(-6.5,-15.9),(-6.3,-15.9),(-6.3,-16.1),(-6.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-25.7),(-0.1,-25.5),(0.1,-25.5),(0.1,-25.7),(-0.1,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,14.3),(-3.3,14.5),(-3.1,14.5),(-3.1,14.3),(-3.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,25.5),(-0.1,25.7),(0.1,25.7),(0.1,25.5),(-0.1,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-9.7),(3.1,-9.5),(3.3,-9.5),(3.3,-9.7),(3.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,14.3),(3.1,14.5),(3.3,14.5),(3.3,14.3),(3.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-16.1),(6.3,-15.9),(6.5,-15.9),(6.5,-16.1),(6.3,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,7.9),(19.1,8.1),(19.3,8.1),(19.3,7.9),(19.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,9.5),(23.9,9.7),(24.1,9.7),(24.1,9.5),(23.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,6.3),(7.9,6.5),(8.1,6.5),(8.1,6.3),(7.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,23.9),(9.5,24.1),(9.7,24.1),(9.7,23.9),(9.5,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-17.7),(7.9,-17.5),(8.1,-17.5),(8.1,-17.7),(7.9,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,19.1),(7.9,19.3),(8.1,19.3),(8.1,19.1),(7.9,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-11.3),(-30.5,-11.1),(-30.3,-11.1),(-30.3,-11.3),(-30.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,11.1),(-30.5,11.3),(-30.3,11.3),(-30.3,11.1),(-30.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-4.9),(-28.9,-4.7),(-28.7,-4.7),(-28.7,-4.9),(-28.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-19.3),(-19.3,-19.1),(-19.1,-19.1),(-19.1,-19.3),(-19.3,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,12.7),(-6.5,12.9),(-6.3,12.9),(-6.3,12.7),(-6.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,12.7),(6.3,12.9),(6.5,12.9),(6.5,12.7),(6.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,19.1),(19.1,19.3),(19.3,19.3),(19.3,19.1),(19.1,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,3.1),(-8.1,3.3),(-7.9,3.3),(-7.9,3.1),(-8.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,4.7),(28.7,4.9),(28.9,4.9),(28.9,4.7),(28.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,4.7),(-9.7,4.9),(-9.5,4.9),(-9.5,4.7),(-9.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,17.5),(-16.1,17.7),(-15.9,17.7),(-15.9,17.5),(-16.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-27.3),(-8.1,-27.1),(-7.9,-27.1),(-7.9,-27.3),(-8.1,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-22.5),(-0.1,-22.3),(0.1,-22.3),(0.1,-22.5),(-0.1,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,22.3),(-0.1,22.5),(0.1,22.5),(0.1,22.3),(-0.1,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,4.7),(9.5,4.9),(9.7,4.9),(9.7,4.7),(9.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,1.5),(31.9,1.7),(32.1,1.7),(32.1,1.5),(31.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-4.9),(-16.1,-4.7),(-15.9,-4.7),(-15.9,-4.9),(-16.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-14.5),(-6.5,-14.3),(-6.3,-14.3),(-6.3,-14.5),(-6.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,14.3),(6.3,14.5),(6.5,14.5),(6.5,14.3),(6.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,15.9),(-24.1,16.1),(-23.9,16.1),(-23.9,15.9),(-24.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-17.7),(-24.1,-17.5),(-23.9,-17.5),(-23.9,-17.7),(-24.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,23.9),(17.5,24.1),(17.7,24.1),(17.7,23.9),(17.5,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,23.9),(-0.1,24.1),(0.1,24.1),(0.1,23.9),(-0.1,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,15.9),(23.9,16.1),(24.1,16.1),(24.1,15.9),(23.9,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,6.3),(-33.7,6.5),(-33.5,6.5),(-33.5,6.3),(-33.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-9.7),(-8.1,-9.5),(-7.9,-9.5),(-7.9,-9.7),(-8.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,6.3),(33.5,6.5),(33.7,6.5),(33.7,6.3),(33.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-1.7),(7.9,-1.5),(8.1,-1.5),(8.1,-1.7),(7.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,3.1),(7.9,3.3),(8.1,3.3),(8.1,3.1),(7.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,15.9),(-11.3,16.1),(-11.1,16.1),(-11.1,15.9),(-11.3,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-16.1),(-24.1,-15.9),(-23.9,-15.9),(-23.9,-16.1),(-24.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,7.9),(31.9,8.1),(32.1,8.1),(32.1,7.9),(31.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-12.9),(7.9,-12.7),(8.1,-12.7),(8.1,-12.9),(7.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-3.3),(-14.5,-3.1),(-14.3,-3.1),(-14.3,-3.3),(-14.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,3.1),(-14.5,3.3),(-14.3,3.3),(-14.3,3.1),(-14.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-11.3),(-27.3,-11.1),(-27.1,-11.1),(-27.1,-11.3),(-27.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,17.5),(-1.7,17.7),(-1.5,17.7),(-1.5,17.5),(-1.7,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-17.7),(1.5,-17.5),(1.7,-17.5),(1.7,-17.7),(1.5,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,7.9),(-20.9,8.1),(-20.7,8.1),(-20.7,7.9),(-20.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,9.5),(15.9,9.7),(16.1,9.7),(16.1,9.5),(15.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,11.1),(27.1,11.3),(27.3,11.3),(27.3,11.1),(27.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-6.5),(-16.1,-6.3),(-15.9,-6.3),(-15.9,-6.5),(-16.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-22.5),(-3.3,-22.3),(-3.1,-22.3),(-3.1,-22.5),(-3.3,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-22.5),(3.1,-22.3),(3.3,-22.3),(3.3,-22.5),(3.1,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-25.7),(-12.9,-25.5),(-12.7,-25.5),(-12.7,-25.7),(-12.9,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-4.9),(-22.5,-4.7),(-22.3,-4.7),(-22.3,-4.9),(-22.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-4.9),(22.3,-4.7),(22.5,-4.7),(22.5,-4.9),(22.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,25.5),(-12.9,25.7),(-12.7,25.7),(-12.7,25.5),(-12.9,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-9.7),(-27.3,-9.5),(-27.1,-9.5),(-27.1,-9.7),(-27.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,9.5),(27.1,9.7),(27.3,9.7),(27.3,9.5),(27.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,1.5),(-17.7,1.7),(-17.5,1.7),(-17.5,1.5),(-17.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-1.7),(17.5,-1.5),(17.7,-1.5),(17.7,-1.7),(17.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-9.7),(-22.5,-9.5),(-22.3,-9.5),(-22.3,-9.7),(-22.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,9.5),(-22.5,9.7),(-22.3,9.7),(-22.3,9.5),(-22.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-14.5),(-20.9,-14.3),(-20.7,-14.3),(-20.7,-14.5),(-20.9,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,14.3),(-20.9,14.5),(-20.7,14.5),(-20.7,14.3),(-20.9,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-19.3),(-20.9,-19.1),(-20.7,-19.1),(-20.7,-19.3),(-20.9,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,19.1),(-20.9,19.3),(-20.7,19.3),(-20.7,19.1),(-20.9,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,-6.5),(-33.7,-6.3),(-33.5,-6.3),(-33.5,-6.5),(-33.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-24.1),(-12.9,-23.9),(-12.7,-23.9),(-12.7,-24.1),(-12.9,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-22.5),(4.7,-22.3),(4.9,-22.3),(4.9,-22.5),(4.7,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,22.3),(4.7,22.5),(4.9,22.5),(4.9,22.3),(4.7,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,11.1),(-25.7,11.3),(-25.5,11.3),(-25.5,11.1),(-25.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-24.1),(12.7,-23.9),(12.9,-23.9),(12.9,-24.1),(12.7,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,-6.5),(33.5,-6.3),(33.7,-6.3),(33.7,-6.5),(33.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-11.3),(25.5,-11.1),(25.7,-11.1),(25.7,-11.3),(25.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,15.9),(15.9,16.1),(16.1,16.1),(16.1,15.9),(15.9,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,3.1),(-32.1,3.3),(-31.9,3.3),(-31.9,3.1),(-32.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-17.7),(6.3,-17.5),(6.5,-17.5),(6.5,-17.7),(6.3,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,17.5),(6.3,17.7),(6.5,17.7),(6.5,17.5),(6.3,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,11.1),(28.7,11.3),(28.9,11.3),(28.9,11.1),(28.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-17.7),(-0.1,-17.5),(0.1,-17.5),(0.1,-17.7),(-0.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-16.1),(-19.3,-15.9),(-19.1,-15.9),(-19.1,-16.1),(-19.3,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-12.9),(-17.7,-12.7),(-17.5,-12.7),(-17.5,-12.9),(-17.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-6.5),(-3.3,-6.3),(-3.1,-6.3),(-3.1,-6.5),(-3.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,15.9),(-3.3,16.1),(-3.1,16.1),(-3.1,15.9),(-3.3,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,17.5),(-0.1,17.7),(0.1,17.7),(0.1,17.5),(-0.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-6.5),(3.1,-6.3),(3.3,-6.3),(3.3,-6.5),(3.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-12.9),(17.5,-12.7),(17.7,-12.7),(17.7,-12.9),(17.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-9.7),(-12.9,-9.5),(-12.7,-9.5),(-12.7,-9.7),(-12.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,9.5),(-12.9,9.7),(-12.7,9.7),(-12.7,9.5),(-12.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,17.5),(-3.3,17.7),(-3.1,17.7),(-3.1,17.5),(-3.3,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,27.1),(7.9,27.3),(8.1,27.3),(8.1,27.1),(7.9,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-25.7),(7.9,-25.5),(8.1,-25.5),(8.1,-25.7),(7.9,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,12.7),(-8.1,12.9),(-7.9,12.9),(-7.9,12.7),(-8.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-12.9),(-9.7,-12.7),(-9.5,-12.7),(-9.5,-12.9),(-9.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-12.9),(9.5,-12.7),(9.7,-12.7),(9.7,-12.9),(9.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,22.3),(-3.3,22.5),(-3.1,22.5),(-3.1,22.3),(-3.3,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-17.7),(3.1,-17.5),(3.3,-17.5),(3.3,-17.7),(3.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,-1.7),(-33.7,-1.5),(-33.5,-1.5),(-33.5,-1.7),(-33.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-11.3),(-19.3,-11.1),(-19.1,-11.1),(-19.1,-11.3),(-19.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,11.1),(19.1,11.3),(19.3,11.3),(19.3,11.1),(19.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,1.5),(33.5,1.7),(33.7,1.7),(33.7,1.5),(33.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,22.3),(3.1,22.5),(3.3,22.5),(3.3,22.3),(3.1,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,14.3),(23.9,14.5),(24.1,14.5),(24.1,14.3),(23.9,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-11.3),(-12.9,-11.1),(-12.7,-11.1),(-12.7,-11.3),(-12.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,11.1),(-12.9,11.3),(-12.7,11.3),(-12.7,11.1),(-12.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,-3.3),(36.7,-3.1),(36.9,-3.1),(36.9,-3.3),(36.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,3.1),(36.7,3.3),(36.9,3.3),(36.9,3.1),(36.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,23.9),(-6.5,24.1),(-6.3,24.1),(-6.3,23.9),(-6.5,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,19.1),(-11.3,19.3),(-11.1,19.3),(-11.1,19.1),(-11.3,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-1.7),(-9.7,-1.5),(-9.5,-1.5),(-9.5,-1.7),(-9.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,14.3),(-8.1,14.5),(-7.9,14.5),(-7.9,14.3),(-8.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-25.7),(-4.9,-25.5),(-4.7,-25.5),(-4.7,-25.7),(-4.9,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,25.5),(-4.9,25.7),(-4.7,25.7),(-4.7,25.5),(-4.9,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-8.1),(-12.9,-7.9),(-12.7,-7.9),(-12.7,-8.1),(-12.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-16.1),(-1.7,-15.9),(-1.5,-15.9),(-1.5,-16.1),(-1.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-11.3),(-0.1,-11.1),(0.1,-11.1),(0.1,-11.3),(-0.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-9.7),(-19.3,-9.5),(-19.1,-9.5),(-19.1,-9.7),(-19.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,11.1),(-0.1,11.3),(0.1,11.3),(0.1,11.1),(-0.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-9.7),(-0.1,-9.5),(0.1,-9.5),(0.1,-9.7),(-0.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,9.5),(-0.1,9.7),(0.1,9.7),(0.1,9.5),(-0.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-16.1),(1.5,-15.9),(1.7,-15.9),(1.7,-16.1),(1.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-6.5),(4.7,-6.3),(4.9,-6.3),(4.9,-6.5),(4.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,6.3),(4.7,6.5),(4.9,6.5),(4.9,6.3),(4.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,9.5),(19.1,9.7),(19.3,9.7),(19.3,9.5),(19.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,-8.1),(-33.7,-7.9),(-33.5,-7.9),(-33.5,-8.1),(-33.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,14.3),(-17.7,14.5),(-17.5,14.5),(-17.5,14.3),(-17.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,14.3),(17.5,14.5),(17.7,14.5),(17.7,14.3),(17.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,-8.1),(33.5,-7.9),(33.7,-7.9),(33.7,-8.1),(33.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-11.3),(-1.7,-11.1),(-1.5,-11.1),(-1.5,-11.3),(-1.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,11.1),(1.5,11.3),(1.7,11.3),(1.7,11.1),(1.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-6.5),(-27.3,-6.3),(-27.1,-6.3),(-27.1,-6.5),(-27.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,17.5),(-24.1,17.7),(-23.9,17.7),(-23.9,17.5),(-24.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-6.5),(27.1,-6.3),(27.3,-6.3),(27.3,-6.5),(27.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,3.1),(-19.3,3.3),(-19.1,3.3),(-19.1,3.1),(-19.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-3.3),(19.1,-3.1),(19.3,-3.1),(19.3,-3.3),(19.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,14.3),(-9.7,14.5),(-9.5,14.5),(-9.5,14.3),(-9.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,23.9),(1.5,24.1),(1.7,24.1),(1.7,23.9),(1.5,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,14.3),(9.5,14.5),(9.7,14.5),(9.7,14.3),(9.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-24.1),(-6.5,-23.9),(-6.3,-23.9),(-6.3,-24.1),(-6.5,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-24.1),(6.3,-23.9),(6.5,-23.9),(6.5,-24.1),(6.3,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-6.5),(-0.1,-6.3),(0.1,-6.3),(0.1,-6.5),(-0.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,6.3),(-0.1,6.5),(0.1,6.5),(0.1,6.3),(-0.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-17.7),(15.9,-17.5),(16.1,-17.5),(16.1,-17.7),(15.9,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-16.1),(-16.1,-15.9),(-15.9,-15.9),(-15.9,-16.1),(-16.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,19.1),(15.9,19.3),(16.1,19.3),(16.1,19.1),(15.9,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-11.3),(20.7,-11.1),(20.9,-11.1),(20.9,-11.3),(20.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,9.5),(-24.1,9.7),(-23.9,9.7),(-23.9,9.5),(-24.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,11.1),(20.7,11.3),(20.9,11.3),(20.9,11.1),(20.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-19.3),(7.9,-19.1),(8.1,-19.1),(8.1,-19.3),(7.9,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-9.7),(-4.9,-9.5),(-4.7,-9.5),(-4.7,-9.7),(-4.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,9.5),(-4.9,9.7),(-4.7,9.7),(-4.7,9.5),(-4.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-4.9),(-3.3,-4.7),(-3.1,-4.7),(-3.1,-4.9),(-3.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-4.9),(3.1,-4.7),(3.3,-4.7),(3.3,-4.9),(3.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-1.7),(14.3,-1.5),(14.5,-1.5),(14.5,-1.7),(14.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,1.5),(14.3,1.7),(14.5,1.7),(14.5,1.5),(14.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,1.5),(-35.3,1.7),(-35.1,1.7),(-35.1,1.5),(-35.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-27.3),(-9.7,-27.1),(-9.5,-27.1),(-9.5,-27.3),(-9.7,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,27.1),(9.5,27.3),(9.7,27.3),(9.7,27.1),(9.5,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,7.9),(-0.1,8.1),(0.1,8.1),(0.1,7.9),(-0.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,7.9),(17.5,8.1),(17.7,8.1),(17.7,7.9),(17.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-24.1),(-0.1,-23.9),(0.1,-23.9),(0.1,-24.1),(-0.1,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-6.5),(28.7,-6.3),(28.9,-6.3),(28.9,-6.5),(28.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,6.3),(28.7,6.5),(28.9,6.5),(28.9,6.3),(28.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,9.5),(-1.7,9.7),(-1.5,9.7),(-1.5,9.5),(-1.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-9.7),(1.5,-9.5),(1.7,-9.5),(1.7,-9.7),(1.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,20.7),(-3.3,20.9),(-3.1,20.9),(-3.1,20.7),(-3.3,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,11.1),(-24.1,11.3),(-23.9,11.3),(-23.9,11.1),(-24.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,20.7),(3.1,20.9),(3.3,20.9),(3.3,20.7),(3.1,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,14.3),(15.9,14.5),(16.1,14.5),(16.1,14.3),(15.9,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-1.7),(31.9,-1.5),(32.1,-1.5),(32.1,-1.7),(31.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-11.3),(-4.9,-11.1),(-4.7,-11.1),(-4.7,-11.3),(-4.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,11.1),(-4.9,11.3),(-4.7,11.3),(-4.7,11.1),(-4.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,3.1),(31.9,3.3),(32.1,3.3),(32.1,3.1),(31.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-14.5),(-17.7,-14.3),(-17.5,-14.3),(-17.5,-14.5),(-17.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-14.5),(17.5,-14.3),(17.7,-14.3),(17.7,-14.5),(17.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-9.7),(-14.5,-9.5),(-14.3,-9.5),(-14.3,-9.7),(-14.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,9.5),(-14.5,9.7),(-14.3,9.7),(-14.3,9.5),(-14.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,12.7),(-1.7,12.9),(-1.5,12.9),(-1.5,12.7),(-1.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,12.7),(1.5,12.9),(1.7,12.9),(1.7,12.7),(1.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-27.3),(-6.5,-27.1),(-6.3,-27.1),(-6.3,-27.3),(-6.5,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,7.9),(-14.5,8.1),(-14.3,8.1),(-14.3,7.9),(-14.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,27.1),(-6.5,27.3),(-6.3,27.3),(-6.3,27.1),(-6.5,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,25.5),(15.9,25.7),(16.1,25.7),(16.1,25.5),(15.9,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-1.7),(4.7,-1.5),(4.9,-1.5),(4.9,-1.7),(4.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,1.5),(4.7,1.7),(4.9,1.7),(4.9,1.5),(4.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-14.5),(-9.7,-14.3),(-9.5,-14.3),(-9.5,-14.5),(-9.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,15.9),(-17.7,16.1),(-17.5,16.1),(-17.5,15.9),(-17.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-14.5),(9.5,-14.3),(9.7,-14.3),(9.7,-14.5),(9.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,19.1),(-9.7,19.3),(-9.5,19.3),(-9.5,19.1),(-9.7,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-19.3),(9.5,-19.1),(9.7,-19.1),(9.7,-19.3),(9.5,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,4.7),(-33.7,4.9),(-33.5,4.9),(-33.5,4.7),(-33.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,4.7),(33.5,4.9),(33.7,4.9),(33.7,4.7),(33.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,20.7),(-12.9,20.9),(-12.7,20.9),(-12.7,20.7),(-12.9,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-3.3),(6.3,-3.1),(6.5,-3.1),(6.5,-3.3),(6.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,25.5),(-9.7,25.7),(-9.5,25.7),(-9.5,25.5),(-9.7,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,3.1),(6.3,3.3),(6.5,3.3),(6.5,3.1),(6.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-3.3),(7.9,-3.1),(8.1,-3.1),(8.1,-3.3),(7.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-25.7),(9.5,-25.5),(9.7,-25.5),(9.7,-25.7),(9.5,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-4.9),(-27.3,-4.7),(-27.1,-4.7),(-27.1,-4.9),(-27.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-20.9),(12.7,-20.7),(12.9,-20.7),(12.9,-20.9),(12.7,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-8.1),(23.9,-7.9),(24.1,-7.9),(24.1,-8.1),(23.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-4.9),(27.1,-4.7),(27.3,-4.7),(27.3,-4.9),(27.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-12.9),(-24.1,-12.7),(-23.9,-12.7),(-23.9,-12.9),(-24.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-0.1),(-20.9,0.1),(-20.7,0.1),(-20.7,-0.1),(-20.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-0.1),(20.7,0.1),(20.9,0.1),(20.9,-0.1),(20.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,23.9),(12.7,24.1),(12.9,24.1),(12.9,23.9),(12.7,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,4.7),(-3.3,4.9),(-3.1,4.9),(-3.1,4.7),(-3.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,4.7),(3.1,4.9),(3.3,4.9),(3.3,4.7),(3.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-8.1),(-14.5,-7.9),(-14.3,-7.9),(-14.3,-8.1),(-14.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-8.1),(14.3,-7.9),(14.5,-7.9),(14.5,-8.1),(14.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,4.7),(-20.9,4.9),(-20.7,4.9),(-20.7,4.7),(-20.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-4.9),(20.7,-4.7),(20.9,-4.7),(20.9,-4.9),(20.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,23.9),(-8.1,24.1),(-7.9,24.1),(-7.9,23.9),(-8.1,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-19.3),(-3.3,-19.1),(-3.1,-19.1),(-3.1,-19.3),(-3.3,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,19.1),(3.1,19.3),(3.3,19.3),(3.3,19.1),(3.1,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,3.1),(-33.7,3.3),(-33.5,3.3),(-33.5,3.1),(-33.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,1.5),(-11.3,1.7),(-11.1,1.7),(-11.1,1.5),(-11.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-22.5),(-6.5,-22.3),(-6.3,-22.3),(-6.3,-22.5),(-6.5,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,22.3),(6.3,22.5),(6.5,22.5),(6.5,22.3),(6.3,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,6.3),(-11.3,6.5),(-11.1,6.5),(-11.1,6.3),(-11.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-1.7),(11.1,-1.5),(11.3,-1.5),(11.3,-1.7),(11.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-11.3),(-6.5,-11.1),(-6.3,-11.1),(-6.3,-11.3),(-6.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,11.1),(-6.5,11.3),(-6.3,11.3),(-6.3,11.1),(-6.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,6.3),(11.1,6.5),(11.3,6.5),(11.3,6.3),(11.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,-3.3),(33.5,-3.1),(33.7,-3.1),(33.7,-3.3),(33.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,4.7),(-14.5,4.9),(-14.3,4.9),(-14.3,4.7),(-14.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,4.7),(14.3,4.9),(14.5,4.9),(14.5,4.7),(14.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-1.7),(28.7,-1.5),(28.9,-1.5),(28.9,-1.7),(28.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,1.5),(28.7,1.7),(28.9,1.7),(28.9,1.5),(28.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,3.1),(-9.7,3.3),(-9.5,3.3),(-9.5,3.1),(-9.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-3.3),(9.5,-3.1),(9.7,-3.1),(9.7,-3.3),(9.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,15.9),(19.1,16.1),(19.3,16.1),(19.3,15.9),(19.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-22.5),(-17.7,-22.3),(-17.5,-22.3),(-17.5,-22.5),(-17.7,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-17.7),(-8.1,-17.5),(-7.9,-17.5),(-7.9,-17.7),(-8.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-22.5),(17.5,-22.3),(17.7,-22.3),(17.7,-22.5),(17.5,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-14.5),(-24.1,-14.3),(-23.9,-14.3),(-23.9,-14.5),(-24.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,23.9),(-11.3,24.1),(-11.1,24.1),(-11.1,23.9),(-11.3,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-6.5),(23.9,-6.3),(24.1,-6.3),(24.1,-6.5),(23.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,4.7),(23.9,4.9),(24.1,4.9),(24.1,4.7),(23.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,7.9),(12.7,8.1),(12.9,8.1),(12.9,7.9),(12.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,4.7),(-27.3,4.9),(-27.1,4.9),(-27.1,4.7),(-27.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,4.7),(27.1,4.9),(27.3,4.9),(27.3,4.7),(27.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-12.9),(-6.5,-12.7),(-6.3,-12.7),(-6.3,-12.9),(-6.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-12.9),(6.3,-12.7),(6.5,-12.7),(6.5,-12.9),(6.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,6.3),(-25.7,6.5),(-25.5,6.5),(-25.5,6.3),(-25.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,6.3),(25.5,6.5),(25.7,6.5),(25.7,6.3),(25.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-22.5),(-12.9,-22.3),(-12.7,-22.3),(-12.7,-22.5),(-12.9,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,22.3),(-12.9,22.5),(-12.7,22.5),(-12.7,22.3),(-12.9,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,20.7),(-8.1,20.9),(-7.9,20.9),(-7.9,20.7),(-8.1,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-6.5),(-6.5,-6.3),(-6.3,-6.3),(-6.3,-6.5),(-6.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,6.3),(6.3,6.5),(6.5,6.5),(6.5,6.3),(6.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,7.9),(-19.3,8.1),(-19.1,8.1),(-19.1,7.9),(-19.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,9.5),(-16.1,9.7),(-15.9,9.7),(-15.9,9.5),(-16.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-19.3),(14.3,-19.1),(14.5,-19.1),(14.5,-19.3),(14.3,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,19.1),(14.3,19.3),(14.5,19.3),(14.5,19.1),(14.3,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,20.7),(-14.5,20.9),(-14.3,20.9),(-14.3,20.7),(-14.5,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-0.1),(-6.5,0.1),(-6.3,0.1),(-6.3,-0.1),(-6.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,6.3),(-1.7,6.5),(-1.5,6.5),(-1.5,6.3),(-1.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,23.9),(-9.7,24.1),(-9.5,24.1),(-9.5,23.9),(-9.7,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,6.3),(1.5,6.5),(1.7,6.5),(1.7,6.3),(1.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-0.1),(6.3,0.1),(6.5,0.1),(6.5,-0.1),(6.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,20.7),(14.3,20.9),(14.5,20.9),(14.5,20.7),(14.3,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-4.9),(15.9,-4.7),(16.1,-4.7),(16.1,-4.9),(15.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,-3.3),(-35.3,-3.1),(-35.1,-3.1),(-35.1,-3.3),(-35.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,19.1),(-19.3,19.3),(-19.1,19.3),(-19.1,19.1),(-19.3,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-19.3),(19.1,-19.1),(19.3,-19.1),(19.3,-19.3),(19.1,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,3.1),(35.1,3.3),(35.3,3.3),(35.3,3.1),(35.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,11.1),(-16.1,11.3),(-15.9,11.3),(-15.9,11.1),(-16.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-1.7),(-8.1,-1.5),(-7.9,-1.5),(-7.9,-1.7),(-8.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-24.1),(-11.3,-23.9),(-11.1,-23.9),(-11.1,-24.1),(-11.3,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-24.1),(11.1,-23.9),(11.3,-23.9),(11.3,-24.1),(11.1,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-3.3),(30.3,-3.1),(30.5,-3.1),(30.5,-3.3),(30.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,3.1),(30.3,3.3),(30.5,3.3),(30.5,3.1),(30.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,7.9),(-16.1,8.1),(-15.9,8.1),(-15.9,7.9),(-16.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,1.5),(23.9,1.7),(24.1,1.7),(24.1,1.5),(23.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-8.1),(-24.1,-7.9),(-23.9,-7.9),(-23.9,-8.1),(-24.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-19.3),(-4.9,-19.1),(-4.7,-19.1),(-4.7,-19.3),(-4.9,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,19.1),(-4.9,19.3),(-4.7,19.3),(-4.7,19.1),(-4.9,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-16.1),(-20.9,-15.9),(-20.7,-15.9),(-20.7,-16.1),(-20.9,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,23.9),(-17.7,24.1),(-17.5,24.1),(-17.5,23.9),(-17.7,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-6.5),(-12.9,-6.3),(-12.7,-6.3),(-12.7,-6.5),(-12.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-19.3),(-17.7,-19.1),(-17.5,-19.1),(-17.5,-19.3),(-17.7,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,6.3),(-12.9,6.5),(-12.7,6.5),(-12.7,6.3),(-12.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,19.1),(17.5,19.3),(17.7,19.3),(17.7,19.1),(17.5,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-16.1),(20.7,-15.9),(20.9,-15.9),(20.9,-16.1),(20.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-3.3),(-24.1,-3.1),(-23.9,-3.1),(-23.9,-3.3),(-24.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,25.5),(-16.1,25.7),(-15.9,25.7),(-15.9,25.5),(-16.1,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-17.7),(-12.9,-17.5),(-12.7,-17.5),(-12.7,-17.7),(-12.9,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,17.5),(-12.9,17.7),(-12.7,17.7),(-12.7,17.5),(-12.9,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-6.5),(-25.7,-6.3),(-25.5,-6.3),(-25.5,-6.5),(-25.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-6.5),(25.5,-6.3),(25.7,-6.3),(25.7,-6.5),(25.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-1.7),(-6.5,-1.5),(-6.3,-1.5),(-6.3,-1.7),(-6.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,1.5),(-6.5,1.7),(-6.3,1.7),(-6.3,1.5),(-6.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-14.5),(12.7,-14.3),(12.9,-14.3),(12.9,-14.5),(12.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-12.9),(-16.1,-12.7),(-15.9,-12.7),(-15.9,-12.9),(-16.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,14.3),(12.7,14.5),(12.9,14.5),(12.9,14.3),(12.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-19.3),(15.9,-19.1),(16.1,-19.1),(16.1,-19.3),(15.9,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-11.3),(23.9,-11.1),(24.1,-11.1),(24.1,-11.3),(23.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-6.5),(-1.7,-6.3),(-1.5,-6.3),(-1.5,-6.5),(-1.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-6.5),(1.5,-6.3),(1.7,-6.3),(1.7,-6.5),(1.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-1.7),(-3.3,-1.5),(-3.1,-1.5),(-3.1,-1.7),(-3.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,1.5),(3.1,1.7),(3.3,1.7),(3.3,1.5),(3.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-8.1),(-11.3,-7.9),(-11.1,-7.9),(-11.1,-8.1),(-11.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-8.1),(11.1,-7.9),(11.3,-7.9),(11.3,-8.1),(11.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,7.9),(23.9,8.1),(24.1,8.1),(24.1,7.9),(23.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,11.1),(-27.3,11.3),(-27.1,11.3),(-27.1,11.1),(-27.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-11.3),(27.1,-11.1),(27.3,-11.1),(27.3,-11.3),(27.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-1.7),(-20.9,-1.5),(-20.7,-1.5),(-20.7,-1.7),(-20.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,1.5),(-20.9,1.7),(-20.7,1.7),(-20.7,1.5),(-20.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,4.7),(-16.1,4.9),(-15.9,4.9),(-15.9,4.7),(-16.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,7.9),(6.3,8.1),(6.5,8.1),(6.5,7.9),(6.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-3.3),(-11.3,-3.1),(-11.1,-3.1),(-11.1,-3.3),(-11.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,3.1),(11.1,3.3),(11.3,3.3),(11.3,3.1),(11.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-25.7),(12.7,-25.5),(12.9,-25.5),(12.9,-25.7),(12.7,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-8.1),(12.7,-7.9),(12.9,-7.9),(12.9,-8.1),(12.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,25.5),(12.7,25.7),(12.9,25.7),(12.9,25.5),(12.7,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-3.3),(31.9,-3.1),(32.1,-3.1),(32.1,-3.3),(31.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,9.5),(-27.3,9.7),(-27.1,9.7),(-27.1,9.5),(-27.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-9.7),(27.1,-9.5),(27.3,-9.5),(27.3,-9.7),(27.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,14.3),(-27.3,14.5),(-27.1,14.5),(-27.1,14.3),(-27.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-4.9),(-17.7,-4.7),(-17.5,-4.7),(-17.5,-4.9),(-17.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,23.9),(3.1,24.1),(3.3,24.1),(3.3,23.9),(3.1,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-4.9),(17.5,-4.7),(17.7,-4.7),(17.7,-4.9),(17.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,14.3),(27.1,14.5),(27.3,14.5),(27.3,14.3),(27.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,25.5),(7.9,25.7),(8.1,25.7),(8.1,25.5),(7.9,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-12.9),(-11.3,-12.7),(-11.1,-12.7),(-11.1,-12.9),(-11.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-12.9),(11.1,-12.7),(11.3,-12.7),(11.3,-12.9),(11.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-0.1),(15.9,0.1),(16.1,0.1),(16.1,-0.1),(15.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-9.7),(22.3,-9.5),(22.5,-9.5),(22.5,-9.7),(22.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,9.5),(22.3,9.7),(22.5,9.7),(22.5,9.5),(22.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-14.5),(-16.1,-14.3),(-15.9,-14.3),(-15.9,-14.5),(-16.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-6.5),(-30.5,-6.3),(-30.3,-6.3),(-30.3,-6.5),(-30.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-3.3),(4.7,-3.1),(4.9,-3.1),(4.9,-3.3),(4.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,3.1),(4.7,3.3),(4.9,3.3),(4.9,3.1),(4.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,17.5),(-8.1,17.7),(-7.9,17.7),(-7.9,17.5),(-8.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,20.7),(-20.9,20.9),(-20.7,20.9),(-20.7,20.7),(-20.9,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-20.9),(-12.9,-20.7),(-12.7,-20.7),(-12.7,-20.9),(-12.9,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,20.7),(12.7,20.9),(12.9,20.9),(12.9,20.7),(12.7,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-20.9),(20.7,-20.7),(20.9,-20.7),(20.9,-20.9),(20.7,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,6.3),(30.3,6.5),(30.5,6.5),(30.5,6.3),(30.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-8.1),(-25.7,-7.9),(-25.5,-7.9),(-25.5,-8.1),(-25.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-22.5),(-1.7,-22.3),(-1.5,-22.3),(-1.5,-22.5),(-1.7,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-22.5),(1.5,-22.3),(1.7,-22.3),(1.7,-22.5),(1.5,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-8.1),(25.5,-7.9),(25.7,-7.9),(25.7,-8.1),(25.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-1.7),(-27.3,-1.5),(-27.1,-1.5),(-27.1,-1.7),(-27.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,1.5),(27.1,1.7),(27.3,1.7),(27.3,1.5),(27.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,6.3),(-35.3,6.5),(-35.1,6.5),(-35.1,6.3),(-35.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,6.3),(35.1,6.5),(35.3,6.5),(35.3,6.3),(35.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-11.3),(22.3,-11.1),(22.5,-11.1),(22.5,-11.3),(22.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,11.1),(22.3,11.3),(22.5,11.3),(22.5,11.1),(22.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,6.3),(-8.1,6.5),(-7.9,6.5),(-7.9,6.3),(-8.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-8.1),(-1.7,-7.9),(-1.5,-7.9),(-1.5,-8.1),(-1.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-8.1),(1.5,-7.9),(1.7,-7.9),(1.7,-8.1),(1.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-1.7),(-32.1,-1.5),(-31.9,-1.5),(-31.9,-1.7),(-32.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-14.5),(4.7,-14.3),(4.9,-14.3),(4.9,-14.5),(4.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,14.3),(4.7,14.5),(4.9,14.5),(4.9,14.3),(4.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-3.3),(-25.7,-3.1),(-25.5,-3.1),(-25.5,-3.3),(-25.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-0.1),(19.1,0.1),(19.3,0.1),(19.3,-0.1),(19.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,3.1),(25.5,3.3),(25.7,3.3),(25.7,3.1),(25.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-4.9),(-20.9,-4.7),(-20.7,-4.7),(-20.7,-4.9),(-20.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,4.7),(20.7,4.9),(20.9,4.9),(20.9,4.7),(20.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-11.3),(15.9,-11.1),(16.1,-11.1),(16.1,-11.3),(15.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-9.7),(12.7,-9.5),(12.9,-9.5),(12.9,-9.7),(12.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,9.5),(12.7,9.7),(12.9,9.7),(12.9,9.5),(12.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,15.9),(9.5,16.1),(9.7,16.1),(9.7,15.9),(9.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-17.7),(-14.5,-17.5),(-14.3,-17.5),(-14.3,-17.7),(-14.5,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,17.5),(-14.5,17.7),(-14.3,17.7),(-14.3,17.5),(-14.5,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-3.3),(-1.7,-3.1),(-1.5,-3.1),(-1.5,-3.3),(-1.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,3.1),(1.5,3.3),(1.7,3.3),(1.7,3.1),(1.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-14.5),(27.1,-14.3),(27.3,-14.3),(27.3,-14.5),(27.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,1.5),(-33.7,1.7),(-33.5,1.7),(-33.5,1.5),(-33.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,11.1),(-19.3,11.3),(-19.1,11.3),(-19.1,11.1),(-19.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-25.7),(-1.7,-25.5),(-1.5,-25.5),(-1.5,-25.7),(-1.7,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,25.5),(1.5,25.7),(1.7,25.7),(1.7,25.5),(1.5,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-11.3),(19.1,-11.1),(19.3,-11.1),(19.3,-11.3),(19.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,-1.7),(33.5,-1.5),(33.7,-1.5),(33.7,-1.7),(33.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,-1.7),(35.1,-1.5),(35.3,-1.5),(35.3,-1.7),(35.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,6.3),(-14.5,6.5),(-14.3,6.5),(-14.3,6.3),(-14.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-6.5),(14.3,-6.3),(14.5,-6.3),(14.5,-6.5),(14.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-3.3),(28.7,-3.1),(28.9,-3.1),(28.9,-3.3),(28.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,1.5),(-8.1,1.7),(-7.9,1.7),(-7.9,1.5),(-8.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,12.7),(-12.9,12.9),(-12.7,12.9),(-12.7,12.7),(-12.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-14.5),(7.9,-14.3),(8.1,-14.3),(8.1,-14.5),(7.9,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,1.5),(-9.7,1.7),(-9.5,1.7),(-9.5,1.5),(-9.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,12.7),(7.9,12.9),(8.1,12.9),(8.1,12.7),(7.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-25.7),(4.7,-25.5),(4.9,-25.5),(4.9,-25.7),(4.7,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,25.5),(4.7,25.7),(4.9,25.7),(4.9,25.5),(4.7,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,12.7),(-11.3,12.9),(-11.1,12.9),(-11.1,12.7),(-11.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-1.7),(9.5,-1.5),(9.7,-1.5),(9.7,-1.7),(9.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-1.7),(-30.5,-1.5),(-30.3,-1.5),(-30.3,-1.7),(-30.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,1.5),(-30.5,1.7),(-30.3,1.7),(-30.3,1.5),(-30.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,9.5),(-19.3,9.7),(-19.1,9.7),(-19.1,9.5),(-19.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-16.1),(-22.5,-15.9),(-22.3,-15.9),(-22.3,-16.1),(-22.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-20.9),(-0.1,-20.7),(0.1,-20.7),(0.1,-20.9),(-0.1,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,20.7),(-0.1,20.9),(0.1,20.9),(0.1,20.7),(-0.1,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,14.3),(-19.3,14.5),(-19.1,14.5),(-19.1,14.3),(-19.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-16.1),(19.1,-15.9),(19.3,-15.9),(19.3,-16.1),(19.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-9.7),(19.1,-9.5),(19.3,-9.5),(19.3,-9.7),(19.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,23.9),(14.3,24.1),(14.5,24.1),(14.5,23.9),(14.3,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-9.7),(-17.7,-9.5),(-17.5,-9.5),(-17.5,-9.7),(-17.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,9.5),(17.5,9.7),(17.7,9.7),(17.7,9.5),(17.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,14.3),(19.1,14.5),(19.3,14.5),(19.3,14.3),(19.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,15.9),(12.7,16.1),(12.9,16.1),(12.9,15.9),(12.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-12.9),(-3.3,-12.7),(-3.1,-12.7),(-3.1,-12.9),(-3.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-12.9),(3.1,-12.7),(3.3,-12.7),(3.3,-12.9),(3.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,6.3),(23.9,6.5),(24.1,6.5),(24.1,6.3),(23.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,11.1),(-1.7,11.3),(-1.5,11.3),(-1.5,11.1),(-1.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-11.3),(1.5,-11.1),(1.7,-11.1),(1.7,-11.3),(1.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-3.3),(-12.9,-3.1),(-12.7,-3.1),(-12.7,-3.3),(-12.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,3.1),(-12.9,3.3),(-12.7,3.3),(-12.7,3.1),(-12.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-9.7),(-9.7,-9.5),(-9.5,-9.5),(-9.5,-9.7),(-9.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,9.5),(9.5,9.7),(9.7,9.7),(9.7,9.5),(9.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,12.7),(-22.5,12.9),(-22.3,12.9),(-22.3,12.7),(-22.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,12.7),(22.3,12.9),(22.5,12.9),(22.5,12.7),(22.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,3.1),(-24.1,3.3),(-23.9,3.3),(-23.9,3.1),(-24.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,23.9),(-1.7,24.1),(-1.5,24.1),(-1.5,23.9),(-1.7,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-25.7),(-11.3,-25.5),(-11.1,-25.5),(-11.1,-25.7),(-11.3,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-19.3),(-1.7,-19.1),(-1.5,-19.1),(-1.5,-19.3),(-1.7,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,19.1),(1.5,19.3),(1.7,19.3),(1.7,19.1),(1.5,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,25.5),(11.1,25.7),(11.3,25.7),(11.3,25.5),(11.1,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,-0.1),(-33.7,0.1),(-33.5,0.1),(-33.5,-0.1),(-33.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,4.7),(-25.7,4.9),(-25.5,4.9),(-25.5,4.7),(-25.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-0.1),(-4.9,0.1),(-4.7,0.1),(-4.7,-0.1),(-4.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-0.1),(4.7,0.1),(4.9,0.1),(4.9,-0.1),(4.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,4.7),(25.5,4.9),(25.7,4.9),(25.7,4.7),(25.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,17.5),(23.9,17.7),(24.1,17.7),(24.1,17.5),(23.9,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,7.9),(30.3,8.1),(30.5,8.1),(30.5,7.9),(30.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,-0.1),(33.5,0.1),(33.7,0.1),(33.7,-0.1),(33.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-25.7),(-6.5,-25.5),(-6.3,-25.5),(-6.3,-25.7),(-6.5,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,25.5),(-6.5,25.7),(-6.3,25.7),(-6.3,25.5),(-6.5,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-14.5),(-22.5,-14.3),(-22.3,-14.3),(-22.3,-14.5),(-22.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,22.3),(-14.5,22.5),(-14.3,22.5),(-14.3,22.3),(-14.5,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,4.7),(-1.7,4.9),(-1.5,4.9),(-1.5,4.7),(-1.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,4.7),(1.5,4.9),(1.7,4.9),(1.7,4.7),(1.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-22.5),(14.3,-22.3),(14.5,-22.3),(14.5,-22.5),(14.3,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,14.3),(22.3,14.5),(22.5,14.5),(22.5,14.3),(22.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,22.3),(-16.1,22.5),(-15.9,22.5),(-15.9,22.3),(-16.1,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-9.7),(4.7,-9.5),(4.9,-9.5),(4.9,-9.7),(4.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,9.5),(4.7,9.7),(4.9,9.7),(4.9,9.5),(4.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,7.9),(-17.7,8.1),(-17.5,8.1),(-17.5,7.9),(-17.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,27.1),(-9.7,27.3),(-9.5,27.3),(-9.5,27.1),(-9.7,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-4.9),(-8.1,-4.7),(-7.9,-4.7),(-7.9,-4.9),(-8.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-27.3),(9.5,-27.1),(9.7,-27.1),(9.7,-27.3),(9.5,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-9.7),(-24.1,-9.5),(-23.9,-9.5),(-23.9,-9.7),(-24.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-1.7),(23.9,-1.5),(24.1,-1.5),(24.1,-1.7),(23.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-27.3),(12.7,-27.1),(12.9,-27.1),(12.9,-27.3),(12.7,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,27.1),(12.7,27.3),(12.9,27.3),(12.9,27.1),(12.7,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,3.1),(23.9,3.3),(24.1,3.3),(24.1,3.1),(23.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,12.7),(-4.9,12.9),(-4.7,12.9),(-4.7,12.7),(-4.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-12.9),(4.7,-12.7),(4.9,-12.7),(4.9,-12.9),(4.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,6.3),(-32.1,6.5),(-31.9,6.5),(-31.9,6.3),(-32.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,12.7),(-3.3,12.9),(-3.1,12.9),(-3.1,12.7),(-3.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-24.1),(-4.9,-23.9),(-4.7,-23.9),(-4.7,-24.1),(-4.9,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,12.7),(3.1,12.9),(3.3,12.9),(3.3,12.7),(3.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-24.1),(4.7,-23.9),(4.9,-23.9),(4.9,-24.1),(4.7,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-9.7),(14.3,-9.5),(14.5,-9.5),(14.5,-9.7),(14.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,9.5),(14.3,9.7),(14.5,9.7),(14.5,9.5),(14.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,15.9),(-0.1,16.1),(0.1,16.1),(0.1,15.9),(-0.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,7.9),(11.1,8.1),(11.3,8.1),(11.3,7.9),(11.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-12.9),(23.9,-12.7),(24.1,-12.7),(24.1,-12.9),(23.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-17.7),(-20.9,-17.5),(-20.7,-17.5),(-20.7,-17.7),(-20.9,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,17.5),(-20.9,17.7),(-20.7,17.7),(-20.7,17.5),(-20.9,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,15.9),(4.7,16.1),(4.9,16.1),(4.9,15.9),(4.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-3.3),(-6.5,-3.1),(-6.3,-3.1),(-6.3,-3.3),(-6.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,3.1),(-6.5,3.3),(-6.3,3.3),(-6.3,3.1),(-6.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-11.3),(14.3,-11.1),(14.5,-11.1),(14.5,-11.3),(14.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,11.1),(14.3,11.3),(14.5,11.3),(14.5,11.1),(14.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,7.9),(33.5,8.1),(33.7,8.1),(33.7,7.9),(33.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-25.7),(-3.3,-25.5),(-3.1,-25.5),(-3.1,-25.7),(-3.3,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-6.5),(-8.1,-6.3),(-7.9,-6.3),(-7.9,-6.5),(-8.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,25.5),(3.1,25.7),(3.3,25.7),(3.3,25.5),(3.1,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,1.5),(-32.1,1.7),(-31.9,1.7),(-31.9,1.5),(-32.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-4.9),(-14.5,-4.7),(-14.3,-4.7),(-14.3,-4.9),(-14.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,23.9),(-12.9,24.1),(-12.7,24.1),(-12.7,23.9),(-12.9,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-4.9),(14.3,-4.7),(14.5,-4.7),(14.5,-4.9),(14.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,7.9),(9.5,8.1),(9.7,8.1),(9.7,7.9),(9.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,19.1),(-3.3,19.3),(-3.1,19.3),(-3.1,19.1),(-3.3,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-0.1),(-24.1,0.1),(-23.9,0.1),(-23.9,-0.1),(-24.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-19.3),(3.1,-19.1),(3.3,-19.1),(3.3,-19.3),(3.1,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-9.7),(31.9,-9.5),(32.1,-9.5),(32.1,-9.7),(31.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-8.1),(-4.9,-7.9),(-4.7,-7.9),(-4.7,-8.1),(-4.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-8.1),(4.7,-7.9),(4.9,-7.9),(4.9,-8.1),(4.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-11.3),(-8.1,-11.1),(-7.9,-11.1),(-7.9,-11.3),(-8.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-20.9),(-16.1,-20.7),(-15.9,-20.7),(-15.9,-20.9),(-16.1,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-16.1),(-14.5,-15.9),(-14.3,-15.9),(-14.3,-16.1),(-14.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-27.3),(4.7,-27.1),(4.9,-27.1),(4.9,-27.3),(4.7,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-6.5),(-19.3,-6.3),(-19.1,-6.3),(-19.1,-6.5),(-19.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,15.9),(-19.3,16.1),(-19.1,16.1),(-19.1,15.9),(-19.3,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-20.9),(-20.9,-20.7),(-20.7,-20.7),(-20.7,-20.9),(-20.9,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,27.1),(4.7,27.3),(4.9,27.3),(4.9,27.1),(4.7,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-27.3),(14.3,-27.1),(14.5,-27.1),(14.5,-27.3),(14.3,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-16.1),(14.3,-15.9),(14.5,-15.9),(14.5,-16.1),(14.3,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-9.7),(-28.9,-9.5),(-28.7,-9.5),(-28.7,-9.7),(-28.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,9.5),(-28.9,9.7),(-28.7,9.7),(-28.7,9.5),(-28.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,27.1),(14.3,27.3),(14.5,27.3),(14.5,27.1),(14.3,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-6.5),(19.1,-6.3),(19.3,-6.3),(19.3,-6.5),(19.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,20.7),(20.7,20.9),(20.9,20.9),(20.9,20.7),(20.7,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,12.7),(-24.1,12.9),(-23.9,12.9),(-23.9,12.7),(-24.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-12.9),(-25.7,-12.7),(-25.5,-12.7),(-25.5,-12.9),(-25.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-12.9),(15.9,-12.7),(16.1,-12.7),(16.1,-12.9),(15.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-12.9),(25.5,-12.7),(25.7,-12.7),(25.7,-12.9),(25.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-20.9),(-14.5,-20.7),(-14.3,-20.7),(-14.3,-20.9),(-14.5,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,12.7),(-14.5,12.9),(-14.3,12.9),(-14.3,12.7),(-14.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,7.9),(-12.9,8.1),(-12.7,8.1),(-12.7,7.9),(-12.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,27.1),(-8.1,27.3),(-7.9,27.3),(-7.9,27.1),(-8.1,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-20.9),(14.3,-20.7),(14.5,-20.7),(14.5,-20.9),(14.3,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,12.7),(14.3,12.9),(14.5,12.9),(14.5,12.7),(14.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-0.1),(23.9,0.1),(24.1,0.1),(24.1,-0.1),(23.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-4.9),(-32.1,-4.7),(-31.9,-4.7),(-31.9,-4.9),(-32.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-11.3),(-28.9,-11.1),(-28.7,-11.1),(-28.7,-11.3),(-28.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,11.1),(-28.9,11.3),(-28.7,11.3),(-28.7,11.1),(-28.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-1.7),(-25.7,-1.5),(-25.5,-1.5),(-25.5,-1.7),(-25.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,14.3),(-24.1,14.5),(-23.9,14.5),(-23.9,14.3),(-24.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,1.5),(25.5,1.7),(25.7,1.7),(25.7,1.5),(25.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-8.1),(-28.9,-7.9),(-28.7,-7.9),(-28.7,-8.1),(-28.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-4.9),(-0.1,-4.7),(0.1,-4.7),(0.1,-4.9),(-0.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,4.7),(-0.1,4.9),(0.1,4.9),(0.1,4.7),(-0.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-6.5),(20.7,-6.3),(20.9,-6.3),(20.9,-6.5),(20.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,6.3),(20.7,6.5),(20.9,6.5),(20.9,6.3),(20.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-14.5),(-14.5,-14.3),(-14.3,-14.3),(-14.3,-14.5),(-14.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,14.3),(14.3,14.5),(14.5,14.5),(14.5,14.3),(14.3,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-11.3),(28.7,-11.1),(28.9,-11.1),(28.9,-11.3),(28.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-8.1),(28.7,-7.9),(28.9,-7.9),(28.9,-8.1),(28.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-19.3),(-14.5,-19.1),(-14.3,-19.1),(-14.3,-19.3),(-14.5,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,19.1),(-14.5,19.3),(-14.3,19.3),(-14.3,19.1),(-14.5,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-1.7),(-1.7,-1.5),(-1.5,-1.5),(-1.5,-1.7),(-1.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,1.5),(1.5,1.7),(1.7,1.7),(1.7,1.5),(1.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,15.9),(6.3,16.1),(6.5,16.1),(6.5,15.9),(6.3,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-16.1),(12.7,-15.9),(12.9,-15.9),(12.9,-16.1),(12.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-22.5),(-16.1,-22.3),(-15.9,-22.3),(-15.9,-22.5),(-16.1,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,-3.3),(-36.9,-3.1),(-36.7,-3.1),(-36.7,-3.3),(-36.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,3.1),(-36.9,3.3),(-36.7,3.3),(-36.7,3.1),(-36.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-12.9),(-12.9,-12.7),(-12.7,-12.7),(-12.7,-12.9),(-12.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-24.1),(7.9,-23.9),(8.1,-23.9),(8.1,-24.1),(7.9,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-35.3,3.1),(-35.3,3.3),(-35.1,3.3),(-35.1,3.1),(-35.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,12.7),(12.7,12.9),(12.9,12.9),(12.9,12.7),(12.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,-3.3),(35.1,-3.1),(35.3,-3.1),(35.3,-3.3),(35.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-16.1),(22.3,-15.9),(22.5,-15.9),(22.5,-16.1),(22.3,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,14.3),(-25.7,14.5),(-25.5,14.5),(-25.5,14.3),(-25.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-9.7),(-16.1,-9.5),(-15.9,-9.5),(-15.9,-9.7),(-16.1,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-20.9),(-11.3,-20.7),(-11.1,-20.7),(-11.1,-20.9),(-11.3,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-20.9),(11.1,-20.7),(11.3,-20.7),(11.3,-20.9),(11.1,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,14.3),(25.5,14.5),(25.7,14.5),(25.7,14.3),(25.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-3.3),(-30.5,-3.1),(-30.3,-3.1),(-30.3,-3.3),(-30.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,3.1),(-30.5,3.3),(-30.3,3.3),(-30.3,3.1),(-30.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,-6.5),(-32.1,-6.3),(-31.9,-6.3),(-31.9,-6.5),(-32.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,14.3),(-6.5,14.5),(-6.3,14.5),(-6.3,14.3),(-6.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-14.5),(6.3,-14.3),(6.5,-14.3),(6.5,-14.5),(6.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,20.7),(-4.9,20.9),(-4.7,20.9),(-4.7,20.7),(-4.9,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-20.9),(4.7,-20.7),(4.9,-20.7),(4.9,-20.9),(4.7,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-8.1),(15.9,-7.9),(16.1,-7.9),(16.1,-8.1),(15.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-9.7),(-20.9,-9.5),(-20.7,-9.5),(-20.7,-9.7),(-20.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,9.5),(-20.9,9.7),(-20.7,9.7),(-20.7,9.5),(-20.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-4.9),(-19.3,-4.7),(-19.1,-4.7),(-19.1,-4.9),(-19.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-4.9),(19.1,-4.7),(19.3,-4.7),(19.3,-4.9),(19.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,19.1),(-17.7,19.3),(-17.5,19.3),(-17.5,19.1),(-17.7,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-19.3),(17.5,-19.1),(17.7,-19.1),(17.7,-19.3),(17.5,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,15.9),(-16.1,16.1),(-15.9,16.1),(-15.9,15.9),(-16.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-17.7),(12.7,-17.5),(12.9,-17.5),(12.9,-17.7),(12.7,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,23.9),(4.7,24.1),(4.9,24.1),(4.9,23.9),(4.7,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,17.5),(12.7,17.7),(12.9,17.7),(12.9,17.5),(12.7,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-1.7),(6.3,-1.5),(6.5,-1.5),(6.5,-1.7),(6.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,1.5),(6.3,1.7),(6.5,1.7),(6.5,1.5),(6.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-11.3),(-20.9,-11.1),(-20.7,-11.1),(-20.7,-11.3),(-20.9,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,11.1),(-20.9,11.3),(-20.7,11.3),(-20.7,11.1),(-20.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,1.5),(-3.3,1.7),(-3.1,1.7),(-3.1,1.5),(-3.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-1.7),(3.1,-1.5),(3.3,-1.5),(3.3,-1.7),(3.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-9.7),(7.9,-9.5),(8.1,-9.5),(8.1,-9.7),(7.9,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,11.1),(7.9,11.3),(8.1,11.3),(8.1,11.1),(7.9,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,6.3),(-3.3,6.5),(-3.1,6.5),(-3.1,6.3),(-3.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,6.3),(3.1,6.5),(3.3,6.5),(3.3,6.3),(3.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-22.5),(7.9,-22.3),(8.1,-22.3),(8.1,-22.5),(7.9,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,20.7),(7.9,20.9),(8.1,20.9),(8.1,20.7),(7.9,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-1.7),(20.7,-1.5),(20.9,-1.5),(20.9,-1.7),(20.7,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,1.5),(20.7,1.7),(20.9,1.7),(20.9,1.5),(20.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-14.5),(-25.7,-14.3),(-25.5,-14.3),(-25.5,-14.5),(-25.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-14.5),(25.5,-14.3),(25.7,-14.3),(25.7,-14.5),(25.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-3.3),(22.3,-3.1),(22.5,-3.1),(22.5,-3.3),(22.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,15.9),(14.3,16.1),(14.5,16.1),(14.5,15.9),(14.3,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-3.3),(11.1,-3.1),(11.3,-3.1),(11.3,-3.3),(11.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,3.1),(22.3,3.3),(22.5,3.3),(22.5,3.1),(22.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-12.9),(-4.9,-12.7),(-4.7,-12.7),(-4.7,-12.9),(-4.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,7.9),(-6.5,8.1),(-6.3,8.1),(-6.3,7.9),(-6.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,3.1),(-11.3,3.3),(-11.1,3.3),(-11.1,3.1),(-11.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,12.7),(4.7,12.9),(4.9,12.9),(4.9,12.7),(4.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,20.7),(-6.5,20.9),(-6.3,20.9),(-6.3,20.7),(-6.5,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,20.7),(6.3,20.9),(6.5,20.9),(6.5,20.7),(6.3,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-0.1),(-11.3,0.1),(-11.1,0.1),(-11.1,-0.1),(-11.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,22.3),(-9.7,22.5),(-9.5,22.5),(-9.5,22.3),(-9.7,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,22.3),(9.5,22.5),(9.7,22.5),(9.7,22.3),(9.5,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-0.1),(11.1,0.1),(11.3,0.1),(11.3,-0.1),(11.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,23.9),(-3.3,24.1),(-3.1,24.1),(-3.1,23.9),(-3.3,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-0.1),(-28.9,0.1),(-28.7,0.1),(-28.7,-0.1),(-28.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-6.5),(15.9,-6.3),(16.1,-6.3),(16.1,-6.5),(15.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,4.7),(15.9,4.9),(16.1,4.9),(16.1,4.7),(15.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-0.1),(28.7,0.1),(28.9,0.1),(28.9,-0.1),(28.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,7.9),(4.7,8.1),(4.9,8.1),(4.9,7.9),(4.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,4.7),(-19.3,4.9),(-19.1,4.9),(-19.1,4.7),(-19.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,4.7),(19.1,4.9),(19.3,4.9),(19.3,4.7),(19.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-27.3),(-1.7,-27.1),(-1.5,-27.1),(-1.5,-27.3),(-1.7,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,12.7),(-16.1,12.9),(-15.9,12.9),(-15.9,12.7),(-16.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,27.1),(1.5,27.3),(1.7,27.3),(1.7,27.1),(1.5,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-20.9),(-9.7,-20.7),(-9.5,-20.7),(-9.5,-20.9),(-9.7,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-20.9),(9.5,-20.7),(9.7,-20.7),(9.7,-20.9),(9.5,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,4.7),(-36.9,4.9),(-36.7,4.9),(-36.7,4.7),(-36.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,-4.9),(36.7,-4.7),(36.9,-4.7),(36.9,-4.9),(36.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-16.1),(-17.7,-15.9),(-17.5,-15.9),(-17.5,-16.1),(-17.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-0.1),(-27.3,0.1),(-27.1,0.1),(-27.1,-0.1),(-27.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-16.1),(17.5,-15.9),(17.7,-15.9),(17.7,-16.1),(17.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-22.5),(-4.9,-22.3),(-4.7,-22.3),(-4.7,-22.5),(-4.9,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,22.3),(-4.9,22.5),(-4.7,22.5),(-4.7,22.3),(-4.9,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,1.5),(-27.3,1.7),(-27.1,1.7),(-27.1,1.5),(-27.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-8.1),(-6.5,-7.9),(-6.3,-7.9),(-6.3,-8.1),(-6.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-8.1),(6.3,-7.9),(6.5,-7.9),(6.5,-8.1),(6.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-1.7),(27.1,-1.5),(27.3,-1.5),(27.3,-1.7),(27.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,6.3),(-27.3,6.5),(-27.1,6.5),(-27.1,6.3),(-27.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-0.1),(27.1,0.1),(27.3,0.1),(27.3,-0.1),(27.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-11.3),(-22.5,-11.1),(-22.3,-11.1),(-22.3,-11.3),(-22.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,11.1),(-22.5,11.3),(-22.3,11.3),(-22.3,11.1),(-22.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,6.3),(27.1,6.5),(27.3,6.5),(27.3,6.3),(27.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,14.3),(-16.1,14.5),(-15.9,14.5),(-15.9,14.3),(-16.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,17.5),(7.9,17.7),(8.1,17.7),(8.1,17.5),(7.9,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-16.1),(-9.7,-15.9),(-9.5,-15.9),(-9.5,-16.1),(-9.7,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,22.3),(-17.7,22.5),(-17.5,22.5),(-17.5,22.3),(-17.7,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-16.1),(9.5,-15.9),(9.7,-15.9),(9.7,-16.1),(9.5,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,22.3),(17.5,22.5),(17.7,22.5),(17.7,22.3),(17.5,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,3.1),(-25.7,3.3),(-25.5,3.3),(-25.5,3.1),(-25.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-11.3),(-17.7,-11.1),(-17.5,-11.1),(-17.5,-11.3),(-17.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-24.1),(-8.1,-23.9),(-7.9,-23.9),(-7.9,-24.1),(-8.1,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,11.1),(17.5,11.3),(17.7,11.3),(17.7,11.1),(17.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-0.1),(-25.7,0.1),(-25.5,0.1),(-25.5,-0.1),(-25.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-3.3),(25.5,-3.1),(25.7,-3.1),(25.7,-3.3),(25.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-0.1),(25.5,0.1),(25.7,0.1),(25.7,-0.1),(25.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,4.7),(-6.5,4.9),(-6.3,4.9),(-6.3,4.7),(-6.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,4.7),(6.3,4.9),(6.5,4.9),(6.5,4.7),(6.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,15.9),(-9.7,16.1),(-9.5,16.1),(-9.5,15.9),(-9.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-17.7),(14.3,-17.5),(14.5,-17.5),(14.5,-17.7),(14.3,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,17.5),(14.3,17.7),(14.5,17.7),(14.5,17.5),(14.3,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-11.3),(-9.7,-11.1),(-9.5,-11.1),(-9.5,-11.3),(-9.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,3.1),(-1.7,3.3),(-1.5,3.3),(-1.5,3.1),(-1.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-3.3),(1.5,-3.1),(1.7,-3.1),(1.7,-3.3),(1.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-24.1),(-3.3,-23.9),(-3.1,-23.9),(-3.1,-24.1),(-3.3,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-24.1),(3.1,-23.9),(3.3,-23.9),(3.3,-24.1),(3.1,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-19.3),(-8.1,-19.1),(-7.9,-19.1),(-7.9,-19.3),(-8.1,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,11.1),(9.5,11.3),(9.7,11.3),(9.7,11.1),(9.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,25.5),(-1.7,25.7),(-1.5,25.7),(-1.5,25.5),(-1.7,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-25.7),(1.5,-25.5),(1.7,-25.5),(1.7,-25.7),(1.5,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,1.5),(15.9,1.7),(16.1,1.7),(16.1,1.5),(15.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,7.9),(28.7,8.1),(28.9,8.1),(28.9,7.9),(28.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,9.5),(31.9,9.7),(32.1,9.7),(32.1,9.5),(31.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,15.9),(1.5,16.1),(1.7,16.1),(1.7,15.9),(1.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-4.9),(-9.7,-4.7),(-9.5,-4.7),(-9.5,-4.9),(-9.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-4.9),(9.5,-4.7),(9.7,-4.7),(9.7,-4.9),(9.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-0.1),(-30.5,0.1),(-30.3,0.1),(-30.3,-0.1),(-30.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-12.9),(-22.5,-12.7),(-22.3,-12.7),(-22.3,-12.9),(-22.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-12.9),(22.3,-12.7),(22.5,-12.7),(22.5,-12.9),(22.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-0.1),(30.3,0.1),(30.5,0.1),(30.5,-0.1),(30.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,1.5),(30.3,1.7),(30.5,1.7),(30.5,1.5),(30.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-25.7),(-14.5,-25.5),(-14.3,-25.5),(-14.3,-25.7),(-14.5,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,25.5),(-14.5,25.7),(-14.3,25.7),(-14.3,25.5),(-14.5,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-6.5),(-4.9,-6.3),(-4.7,-6.3),(-4.7,-6.5),(-4.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,6.3),(-4.9,6.5),(-4.7,6.5),(-4.7,6.3),(-4.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-6.5),(-22.5,-6.3),(-22.3,-6.3),(-22.3,-6.5),(-22.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-19.3),(11.1,-19.1),(11.3,-19.1),(11.3,-19.3),(11.1,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,23.9),(7.9,24.1),(8.1,24.1),(8.1,23.9),(7.9,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,6.3),(22.3,6.5),(22.5,6.5),(22.5,6.3),(22.3,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-1.7),(30.3,-1.5),(30.5,-1.5),(30.5,-1.7),(30.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,23.9),(-14.5,24.1),(-14.3,24.1),(-14.3,23.9),(-14.5,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,9.5),(-17.7,9.7),(-17.5,9.7),(-17.5,9.5),(-17.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-9.7),(17.5,-9.5),(17.7,-9.5),(17.7,-9.7),(17.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-17.7),(-4.9,-17.5),(-4.7,-17.5),(-4.7,-17.7),(-4.9,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,15.9),(-12.9,16.1),(-12.7,16.1),(-12.7,15.9),(-12.9,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,17.5),(-4.9,17.7),(-4.7,17.7),(-4.7,17.5),(-4.9,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-1.7),(-0.1,-1.5),(0.1,-1.5),(0.1,-1.7),(-0.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,1.5),(-0.1,1.7),(0.1,1.7),(0.1,1.5),(-0.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-14.5),(-11.3,-14.3),(-11.1,-14.3),(-11.1,-14.5),(-11.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-14.5),(11.1,-14.3),(11.3,-14.3),(11.3,-14.5),(11.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,4.7),(-12.9,4.9),(-12.7,4.9),(-12.7,4.7),(-12.9,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-4.9),(12.7,-4.7),(12.9,-4.7),(12.9,-4.9),(12.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,9.5),(-9.7,9.7),(-9.5,9.7),(-9.5,9.5),(-9.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-9.7),(9.5,-9.5),(9.7,-9.5),(9.7,-9.7),(9.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-4.9),(31.9,-4.7),(32.1,-4.7),(32.1,-4.9),(31.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-1.7),(-24.1,-1.5),(-23.9,-1.5),(-23.9,-1.7),(-24.1,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-9.7),(-30.5,-9.5),(-30.3,-9.5),(-30.3,-9.7),(-30.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,9.5),(-30.5,9.7),(-30.3,9.7),(-30.3,9.5),(-30.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,25.5),(-11.3,25.7),(-11.1,25.7),(-11.1,25.5),(-11.3,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,19.1),(-1.7,19.3),(-1.5,19.3),(-1.5,19.1),(-1.7,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-19.3),(1.5,-19.1),(1.7,-19.1),(1.7,-19.3),(1.5,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-8.1),(-3.3,-7.9),(-3.1,-7.9),(-3.1,-8.1),(-3.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,12.7),(-17.7,12.9),(-17.5,12.9),(-17.5,12.7),(-17.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-8.1),(3.1,-7.9),(3.3,-7.9),(3.3,-8.1),(3.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-25.7),(11.1,-25.5),(11.3,-25.5),(11.3,-25.7),(11.1,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,7.9),(-30.5,8.1),(-30.3,8.1),(-30.3,7.9),(-30.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,7.9),(15.9,8.1),(16.1,8.1),(16.1,7.9),(15.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,12.7),(17.5,12.9),(17.7,12.9),(17.7,12.7),(17.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,12.7),(11.1,12.9),(11.3,12.9),(11.3,12.7),(11.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-25.7),(6.3,-25.5),(6.5,-25.5),(6.5,-25.7),(6.3,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,25.5),(6.3,25.7),(6.5,25.7),(6.5,25.5),(6.3,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-24.1),(-14.5,-23.9),(-14.3,-23.9),(-14.3,-24.1),(-14.5,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-24.1),(14.3,-23.9),(14.5,-23.9),(14.5,-24.1),(14.3,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,12.7),(-9.7,12.9),(-9.5,12.9),(-9.5,12.7),(-9.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-20.9),(7.9,-20.7),(8.1,-20.7),(8.1,-20.9),(7.9,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,12.7),(9.5,12.9),(9.7,12.9),(9.7,12.7),(9.5,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-24.1),(15.9,-23.9),(16.1,-23.9),(16.1,-24.1),(15.9,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,7.9),(-8.1,8.1),(-7.9,8.1),(-7.9,7.9),(-8.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-3.3),(-3.3,-3.1),(-3.1,-3.1),(-3.1,-3.3),(-3.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,3.1),(3.1,3.3),(3.3,3.3),(3.3,3.1),(3.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-24.1),(-9.7,-23.9),(-9.5,-23.9),(-9.5,-24.1),(-9.7,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-20.9),(-19.3,-20.7),(-19.1,-20.7),(-19.1,-20.9),(-19.3,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-24.1),(9.5,-23.9),(9.7,-23.9),(9.7,-24.1),(9.5,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-6.5),(-28.9,-6.3),(-28.7,-6.3),(-28.7,-6.5),(-28.9,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,6.3),(-28.9,6.5),(-28.7,6.5),(-28.7,6.3),(-28.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-17.7),(-11.3,-17.5),(-11.1,-17.5),(-11.1,-17.7),(-11.3,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,17.5),(11.1,17.7),(11.3,17.7),(11.3,17.5),(11.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-8.1),(-16.1,-7.9),(-15.9,-7.9),(-15.9,-8.1),(-16.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-20.9),(19.1,-20.7),(19.3,-20.7),(19.3,-20.9),(19.1,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-1.7),(-22.5,-1.5),(-22.3,-1.5),(-22.3,-1.7),(-22.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,1.5),(-22.5,1.7),(-22.3,1.7),(-22.3,1.5),(-22.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-8.1),(-30.5,-7.9),(-30.3,-7.9),(-30.3,-8.1),(-30.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-8.1),(30.3,-7.9),(30.5,-7.9),(30.5,-8.1),(30.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,-3.3),(-16.1,-3.1),(-15.9,-3.1),(-15.9,-3.3),(-16.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-20.9),(-4.9,-20.7),(-4.7,-20.7),(-4.7,-20.9),(-4.9,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,20.7),(4.7,20.9),(4.9,20.9),(4.9,20.7),(4.7,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-1.7),(-19.3,-1.5),(-19.1,-1.5),(-19.1,-1.7),(-19.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,1.5),(19.1,1.7),(19.3,1.7),(19.3,1.5),(19.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-8.1),(-27.3,-7.9),(-27.1,-7.9),(-27.1,-8.1),(-27.3,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-8.1),(27.1,-7.9),(27.3,-7.9),(27.3,-8.1),(27.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,7.9),(-11.3,8.1),(-11.1,8.1),(-11.1,7.9),(-11.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,4.7),(-30.5,4.9),(-30.3,4.9),(-30.3,4.7),(-30.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-24.1),(-17.7,-23.9),(-17.5,-23.9),(-17.5,-24.1),(-17.7,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,15.9),(-4.9,16.1),(-4.7,16.1),(-4.7,15.9),(-4.9,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-24.1),(17.5,-23.9),(17.7,-23.9),(17.7,-24.1),(17.5,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-17.7),(20.7,-17.5),(20.9,-17.5),(20.9,-17.7),(20.7,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,17.5),(20.7,17.7),(20.9,17.7),(20.9,17.5),(20.7,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,4.7),(30.3,4.9),(30.5,4.9),(30.5,4.7),(30.3,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-19.3),(12.7,-19.1),(12.9,-19.1),(12.9,-19.3),(12.7,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,19.1),(12.7,19.3),(12.9,19.3),(12.9,19.1),(12.7,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-14.5),(-3.3,-14.3),(-3.1,-14.3),(-3.1,-14.5),(-3.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-14.5),(3.1,-14.3),(3.3,-14.3),(3.3,-14.5),(3.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,19.1),(22.3,19.3),(22.5,19.3),(22.5,19.1),(22.3,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,7.9),(22.3,8.1),(22.5,8.1),(22.5,7.9),(22.3,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,3.1),(27.1,3.3),(27.3,3.3),(27.3,3.1),(27.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-11.3),(-14.5,-11.1),(-14.3,-11.1),(-14.3,-11.3),(-14.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,11.1),(-14.5,11.3),(-14.3,11.3),(-14.3,11.1),(-14.5,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-3.3),(-27.3,-3.1),(-27.1,-3.1),(-27.1,-3.3),(-27.3,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-16.1),(7.9,-15.9),(8.1,-15.9),(8.1,-16.1),(7.9,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,-4.9),(7.9,-4.7),(8.1,-4.7),(8.1,-4.9),(7.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-19.3),(22.3,-19.1),(22.5,-19.1),(22.5,-19.3),(22.3,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-0.1),(-3.3,0.1),(-3.1,0.1),(-3.1,-0.1),(-3.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,7.9),(-33.7,8.1),(-33.5,8.1),(-33.5,7.9),(-33.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-0.1),(3.1,0.1),(3.3,0.1),(3.3,-0.1),(3.1,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,1.5),(9.5,1.7),(9.7,1.7),(9.7,1.5),(9.5,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,25.5),(-3.3,25.7),(-3.1,25.7),(-3.1,25.5),(-3.3,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,4.7),(-8.1,4.9),(-7.9,4.9),(-7.9,4.7),(-8.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-25.7),(3.1,-25.5),(3.3,-25.5),(3.3,-25.7),(3.1,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-8.1),(-0.1,-7.9),(0.1,-7.9),(0.1,-8.1),(-0.1,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-22.5),(15.9,-22.3),(16.1,-22.3),(16.1,-22.5),(15.9,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,20.7),(15.9,20.9),(16.1,20.9),(16.1,20.7),(15.9,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-0.1),(-22.5,0.1),(-22.3,0.1),(-22.3,-0.1),(-22.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-0.1),(22.3,0.1),(22.5,0.1),(22.5,-0.1),(22.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,-12.9),(-27.3,-12.7),(-27.1,-12.7),(-27.1,-12.9),(-27.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,7.9),(-9.7,8.1),(-9.5,8.1),(-9.5,7.9),(-9.7,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,22.3),(-1.7,22.5),(-1.5,22.5),(-1.5,22.3),(-1.7,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,22.3),(1.5,22.5),(1.7,22.5),(1.7,22.3),(1.5,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,22.3),(7.9,22.5),(8.1,22.5),(8.1,22.3),(7.9,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,-12.9),(27.1,-12.7),(27.3,-12.7),(27.3,-12.9),(27.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-3.3),(20.7,-3.1),(20.9,-3.1),(20.9,-3.3),(20.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,3.1),(20.7,3.3),(20.9,3.3),(20.9,3.1),(20.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.1,1.5),(35.1,1.7),(35.3,1.7),(35.3,1.5),(35.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,22.3),(-6.5,22.5),(-6.3,22.5),(-6.3,22.3),(-6.5,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-22.5),(6.3,-22.3),(6.5,-22.3),(6.5,-22.5),(6.3,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,20.7),(-9.7,20.9),(-9.5,20.9),(-9.5,20.7),(-9.7,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,9.5),(-32.1,9.7),(-31.9,9.7),(-31.9,9.5),(-32.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,20.7),(9.5,20.9),(9.7,20.9),(9.7,20.7),(9.5,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,23.9),(-16.1,24.1),(-15.9,24.1),(-15.9,23.9),(-16.1,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,6.3),(-24.1,6.5),(-23.9,6.5),(-23.9,6.3),(-24.1,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-12.9),(-14.5,-12.7),(-14.3,-12.7),(-14.3,-12.9),(-14.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-12.9),(14.3,-12.7),(14.5,-12.7),(14.5,-12.9),(14.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,6.3),(-17.7,6.5),(-17.5,6.5),(-17.5,6.3),(-17.7,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,6.3),(15.9,6.5),(16.1,6.5),(16.1,6.3),(15.9,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,6.3),(17.5,6.5),(17.7,6.5),(17.7,6.3),(17.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-14.5),(20.7,-14.3),(20.9,-14.3),(20.9,-14.5),(20.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,14.3),(20.7,14.5),(20.9,14.5),(20.9,14.3),(20.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-3.3),(-4.9,-3.1),(-4.7,-3.1),(-4.7,-3.3),(-4.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,3.1),(-4.9,3.3),(-4.7,3.3),(-4.7,3.1),(-4.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,-4.9),(-36.9,-4.7),(-36.7,-4.7),(-36.7,-4.9),(-36.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-27.3),(-14.5,-27.1),(-14.3,-27.1),(-14.3,-27.3),(-14.5,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,27.1),(-14.5,27.3),(-14.3,27.3),(-14.3,27.1),(-14.5,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.7,4.7),(36.7,4.9),(36.9,4.9),(36.9,4.7),(36.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,-0.1),(-14.5,0.1),(-14.3,0.1),(-14.3,-0.1),(-14.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-0.1),(14.3,0.1),(14.5,0.1),(14.5,-0.1),(14.3,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-9.7),(28.7,-9.5),(28.9,-9.5),(28.9,-9.7),(28.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,15.9),(25.5,16.1),(25.7,16.1),(25.7,15.9),(25.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,9.5),(28.7,9.7),(28.9,9.7),(28.9,9.5),(28.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,7.9),(-32.1,8.1),(-31.9,8.1),(-31.9,7.9),(-32.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,17.5),(15.9,17.7),(16.1,17.7),(16.1,17.5),(15.9,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-1.7),(-12.9,-1.5),(-12.7,-1.5),(-12.7,-1.7),(-12.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,1.5),(-12.9,1.7),(-12.7,1.7),(-12.7,1.5),(-12.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-25.7),(-8.1,-25.5),(-7.9,-25.5),(-7.9,-25.7),(-8.1,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,20.7),(-17.7,20.9),(-17.5,20.9),(-17.5,20.7),(-17.7,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,1.5),(-24.1,1.7),(-23.9,1.7),(-23.9,1.5),(-24.1,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,12.7),(-28.9,12.9),(-28.7,12.9),(-28.7,12.7),(-28.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,20.7),(17.5,20.9),(17.7,20.9),(17.7,20.7),(17.5,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,1.5),(-25.7,1.7),(-25.5,1.7),(-25.5,1.5),(-25.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-14.5),(23.9,-14.3),(24.1,-14.3),(24.1,-14.5),(23.9,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,12.7),(23.9,12.9),(24.1,12.9),(24.1,12.7),(23.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,-1.7),(25.5,-1.5),(25.7,-1.5),(25.7,-1.7),(25.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-27.3,12.7),(-27.3,12.9),(-27.1,12.9),(-27.1,12.7),(-27.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,12.7),(27.1,12.9),(27.3,12.9),(27.3,12.7),(27.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,-12.9),(28.7,-12.7),(28.9,-12.7),(28.9,-12.9),(28.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,6.3),(-6.5,6.5),(-6.3,6.5),(-6.3,6.3),(-6.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-6.5),(6.3,-6.3),(6.5,-6.3),(6.5,-6.5),(6.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,15.9),(-6.5,16.1),(-6.3,16.1),(-6.3,15.9),(-6.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,1.5),(-1.7,1.7),(-1.5,1.7),(-1.5,1.5),(-1.7,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-1.7),(1.5,-1.5),(1.7,-1.5),(1.7,-1.7),(1.5,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-12.9),(-19.3,-12.7),(-19.1,-12.7),(-19.1,-12.9),(-19.3,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,-12.9),(19.1,-12.7),(19.3,-12.7),(19.3,-12.9),(19.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,20.7),(-16.1,20.9),(-15.9,20.9),(-15.9,20.7),(-16.1,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-3.3),(-28.9,-3.1),(-28.7,-3.1),(-28.7,-3.3),(-28.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,3.1),(-28.9,3.3),(-28.7,3.3),(-28.7,3.1),(-28.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-1.7),(15.9,-1.5),(16.1,-1.5),(16.1,-1.7),(15.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,3.1),(15.9,3.3),(16.1,3.3),(16.1,3.1),(15.9,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-25.7,-9.7),(-25.7,-9.5),(-25.5,-9.5),(-25.5,-9.7),(-25.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,9.5),(25.5,9.7),(25.7,9.7),(25.7,9.5),(25.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-6.5),(-17.7,-6.3),(-17.5,-6.3),(-17.5,-6.5),(-17.7,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-6.5),(17.5,-6.3),(17.7,-6.3),(17.7,-6.5),(17.5,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-12.9),(-0.1,-12.7),(0.1,-12.7),(0.1,-12.9),(-0.1,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,12.7),(-0.1,12.9),(0.1,12.9),(0.1,12.7),(-0.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,23.9),(15.9,24.1),(16.1,24.1),(16.1,23.9),(15.9,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,7.9),(3.1,8.1),(3.3,8.1),(3.3,7.9),(3.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,9.5),(7.9,9.7),(8.1,9.7),(8.1,9.5),(7.9,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,3.1),(-16.1,3.3),(-15.9,3.3),(-15.9,3.1),(-16.1,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-32.1,4.7),(-32.1,4.9),(-31.9,4.9),(-31.9,4.7),(-32.1,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-12.9),(-1.7,-12.7),(-1.5,-12.7),(-1.5,-12.9),(-1.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-12.9),(1.5,-12.7),(1.7,-12.7),(1.7,-12.9),(1.5,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-4.9),(-12.9,-4.7),(-12.7,-4.7),(-12.7,-4.9),(-12.9,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-14.5),(-0.1,-14.3),(0.1,-14.3),(0.1,-14.5),(-0.1,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,14.3),(-0.1,14.5),(0.1,14.5),(0.1,14.3),(-0.1,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,4.7),(12.7,4.9),(12.9,4.9),(12.9,4.7),(12.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-9.7),(20.7,-9.5),(20.9,-9.5),(20.9,-9.7),(20.7,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,9.5),(20.7,9.7),(20.9,9.7),(20.9,9.5),(20.7,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-4.9),(-24.1,-4.7),(-23.9,-4.7),(-23.9,-4.9),(-24.1,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-33.7,-4.9),(-33.7,-4.7),(-33.5,-4.7),(-33.5,-4.9),(-33.7,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.5,-4.9),(33.5,-4.7),(33.7,-4.7),(33.7,-4.9),(33.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-27.3),(-11.3,-27.1),(-11.1,-27.1),(-11.1,-27.3),(-11.3,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,27.1),(11.1,27.3),(11.3,27.3),(11.3,27.1),(11.1,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,23.9),(-4.9,24.1),(-4.7,24.1),(-4.7,23.9),(-4.9,23.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-24.1),(-1.7,-23.9),(-1.5,-23.9),(-1.5,-24.1),(-1.7,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-24.1),(1.5,-23.9),(1.7,-23.9),(1.7,-24.1),(1.5,-24.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-17.7),(-22.5,-17.5),(-22.3,-17.5),(-22.3,-17.7),(-22.5,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,17.5),(-22.5,17.7),(-22.3,17.7),(-22.3,17.5),(-22.5,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-14.5),(-12.9,-14.3),(-12.7,-14.3),(-12.7,-14.5),(-12.9,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,14.3),(-12.9,14.5),(-12.7,14.5),(-12.7,14.3),(-12.9,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-20.9),(15.9,-20.7),(16.1,-20.7),(16.1,-20.9),(15.9,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,12.7),(-20.9,12.9),(-20.7,12.9),(-20.7,12.7),(-20.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-14.5),(15.9,-14.3),(16.1,-14.3),(16.1,-14.5),(15.9,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,15.9),(-8.1,16.1),(-7.9,16.1),(-7.9,15.9),(-8.1,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,12.7),(15.9,12.9),(16.1,12.9),(16.1,12.7),(15.9,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-20.9),(-6.5,-20.7),(-6.3,-20.7),(-6.3,-20.9),(-6.5,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-20.9),(6.3,-20.7),(6.5,-20.7),(6.5,-20.9),(6.3,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,12.7),(-19.3,12.9),(-19.1,12.9),(-19.1,12.7),(-19.3,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,12.7),(19.1,12.9),(19.3,12.9),(19.3,12.7),(19.1,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-12.9),(20.7,-12.7),(20.9,-12.7),(20.9,-12.9),(20.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-19.3,-17.7),(-19.3,-17.5),(-19.1,-17.5),(-19.1,-17.7),(-19.3,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.1,17.5),(19.1,17.7),(19.3,17.7),(19.3,17.5),(19.1,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,15.9),(7.9,16.1),(8.1,16.1),(8.1,15.9),(7.9,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.1,7.9),(27.1,8.1),(27.3,8.1),(27.3,7.9),(27.1,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-8.1),(-17.7,-7.9),(-17.5,-7.9),(-17.5,-8.1),(-17.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,14.3),(-1.7,14.5),(-1.5,14.5),(-1.5,14.3),(-1.7,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-16.1,19.1),(-16.1,19.3),(-15.9,19.3),(-15.9,19.1),(-16.1,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,14.3),(1.5,14.5),(1.7,14.5),(1.7,14.3),(1.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-8.1),(17.5,-7.9),(17.7,-7.9),(17.7,-8.1),(17.5,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,15.9),(20.7,16.1),(20.9,16.1),(20.9,15.9),(20.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-27.3),(-12.9,-27.1),(-12.7,-27.1),(-12.7,-27.3),(-12.9,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,27.1),(-12.9,27.3),(-12.7,27.3),(-12.7,27.1),(-12.9,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-16.1),(-11.3,-15.9),(-11.1,-15.9),(-11.1,-16.1),(-11.3,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-16.1),(11.1,-15.9),(11.3,-15.9),(11.3,-16.1),(11.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,-3.3),(-22.5,-3.1),(-22.3,-3.1),(-22.3,-3.3),(-22.5,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,3.1),(-22.5,3.3),(-22.3,3.3),(-22.3,3.1),(-22.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-14.5,15.9),(-14.5,16.1),(-14.3,16.1),(-14.3,15.9),(-14.5,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,-17.7),(-9.7,-17.5),(-9.5,-17.5),(-9.5,-17.7),(-9.7,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,17.5),(9.5,17.7),(9.7,17.7),(9.7,17.5),(9.5,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-3.3),(-17.7,-3.1),(-17.5,-3.1),(-17.5,-3.3),(-17.7,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-6.5),(-24.1,-6.3),(-23.9,-6.3),(-23.9,-6.5),(-24.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,-16.1),(-8.1,-15.9),(-7.9,-15.9),(-7.9,-16.1),(-8.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,3.1),(17.5,3.3),(17.7,3.3),(17.7,3.1),(17.5,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-11.3),(-11.3,-11.1),(-11.1,-11.1),(-11.1,-11.3),(-11.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,11.1),(11.1,11.3),(11.3,11.3),(11.3,11.1),(11.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,7.9),(-4.9,8.1),(-4.7,8.1),(-4.7,7.9),(-4.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.5,7.9),(25.5,8.1),(25.7,8.1),(25.7,7.9),(25.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,27.1),(-1.7,27.3),(-1.5,27.3),(-1.5,27.1),(-1.7,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-27.3),(1.5,-27.1),(1.7,-27.1),(1.7,-27.3),(1.5,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,6.3),(-30.5,6.5),(-30.3,6.5),(-30.3,6.3),(-30.5,6.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-19.3),(20.7,-19.1),(20.9,-19.1),(20.9,-19.3),(20.7,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,19.1),(20.7,19.3),(20.9,19.3),(20.9,19.1),(20.7,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-6.5),(30.3,-6.3),(30.5,-6.3),(30.5,-6.5),(30.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-4.9),(-6.5,-4.7),(-6.3,-4.7),(-6.3,-4.9),(-6.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-4.9),(6.3,-4.7),(6.5,-4.7),(6.5,-4.9),(6.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-20.9,-8.1),(-20.9,-7.9),(-20.7,-7.9),(-20.7,-8.1),(-20.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,7.9),(1.5,8.1),(1.7,8.1),(1.7,7.9),(1.5,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.7,-8.1),(20.7,-7.9),(20.9,-7.9),(20.9,-8.1),(20.7,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-9.7),(-11.3,-9.5),(-11.1,-9.5),(-11.1,-9.7),(-11.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,9.5),(11.1,9.7),(11.3,9.7),(11.3,9.5),(11.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-12.9),(12.7,-12.7),(12.9,-12.7),(12.9,-12.9),(12.7,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-24.1,-11.3),(-24.1,-11.1),(-23.9,-11.1),(-23.9,-11.3),(-24.1,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-17.7),(-17.7,-17.5),(-17.5,-17.5),(-17.5,-17.7),(-17.7,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-27.3),(-3.3,-27.1),(-3.1,-27.1),(-3.1,-27.3),(-3.3,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,27.1),(3.1,27.3),(3.3,27.3),(3.3,27.1),(3.1,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,17.5),(17.5,17.7),(17.7,17.7),(17.7,17.5),(17.5,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,22.3),(15.9,22.5),(16.1,22.5),(16.1,22.3),(15.9,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,-9.7),(-6.5,-9.5),(-6.3,-9.5),(-6.3,-9.7),(-6.5,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-6.5,9.5),(-6.5,9.7),(-6.3,9.7),(-6.3,9.5),(-6.5,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,11.1),(-17.7,11.3),(-17.5,11.3),(-17.5,11.1),(-17.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-14.5),(-4.9,-14.3),(-4.7,-14.3),(-4.7,-14.5),(-4.9,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,14.3),(-4.9,14.5),(-4.7,14.5),(-4.7,14.3),(-4.9,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-11.3),(17.5,-11.1),(17.7,-11.1),(17.7,-11.3),(17.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,20.7),(-1.7,20.9),(-1.5,20.9),(-1.5,20.7),(-1.7,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,20.7),(1.5,20.9),(1.7,20.9),(1.7,20.7),(1.5,20.7)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-0.1),(31.9,0.1),(32.1,0.1),(32.1,-0.1),(31.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-20.9),(-3.3,-20.7),(-3.1,-20.7),(-3.1,-20.9),(-3.3,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,-14.5),(-1.7,-14.3),(-1.5,-14.3),(-1.5,-14.5),(-1.7,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.5,-14.5),(1.5,-14.3),(1.7,-14.3),(1.7,-14.5),(1.5,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-20.9),(3.1,-20.7),(3.3,-20.7),(3.3,-20.9),(3.1,-20.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-9.7,11.1),(-9.7,11.3),(-9.5,11.3),(-9.5,11.1),(-9.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.5,-11.3),(9.5,-11.1),(9.7,-11.1),(9.7,-11.3),(9.5,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,-0.1),(-17.7,0.1),(-17.5,0.1),(-17.5,-0.1),(-17.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,-0.1),(17.5,0.1),(17.7,0.1),(17.7,-0.1),(17.5,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,-1.7),(-36.9,-1.5),(-36.7,-1.5),(-36.7,-1.7),(-36.9,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-36.9,1.5),(-36.9,1.7),(-36.7,1.7),(-36.7,1.5),(-36.9,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,7.9),(-28.9,8.1),(-28.7,8.1),(-28.7,7.9),(-28.9,7.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-1.7,15.9),(-1.7,16.1),(-1.5,16.1),(-1.5,15.9),(-1.7,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,3.1),(28.7,3.3),(28.9,3.3),(28.9,3.1),(28.7,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,11.1),(12.7,11.3),(12.9,11.3),(12.9,11.1),(12.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,-27.3),(-4.9,-27.1),(-4.7,-27.1),(-4.7,-27.3),(-4.9,-27.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.5,4.7),(17.5,4.9),(17.7,4.9),(17.7,4.7),(17.5,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-4.9,27.1),(-4.9,27.3),(-4.7,27.3),(-4.7,27.1),(-4.9,27.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-17.7,4.7),(-17.7,4.9),(-17.5,4.9),(-17.5,4.7),(-17.7,4.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-22.5),(-11.3,-22.3),(-11.1,-22.3),(-11.1,-22.5),(-11.3,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-16.1),(-3.3,-15.9),(-3.1,-15.9),(-3.1,-16.1),(-3.3,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-16.1),(3.1,-15.9),(3.3,-15.9),(3.3,-16.1),(3.1,-16.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-22.5),(11.1,-22.3),(11.3,-22.3),(11.3,-22.5),(11.1,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-11.3),(12.7,-11.1),(12.9,-11.1),(12.9,-11.3),(12.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,-19.3),(-0.1,-19.1),(0.1,-19.1),(0.1,-19.3),(-0.1,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-0.1,19.1),(-0.1,19.3),(0.1,19.3),(0.1,19.1),(-0.1,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((23.9,-3.3),(23.9,-3.1),(24.1,-3.1),(24.1,-3.3),(23.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,-25.7),(14.3,-25.5),(14.5,-25.5),(14.5,-25.7),(14.3,-25.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.3,25.5),(14.3,25.7),(14.5,25.7),(14.5,25.5),(14.3,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,15.9),(22.3,16.1),(22.5,16.1),(22.5,15.9),(22.3,15.9)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-11.3),(-3.3,-11.1),(-3.1,-11.1),(-3.1,-11.3),(-3.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,11.1),(3.1,11.3),(3.3,11.3),(3.3,11.1),(3.1,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-17.7),(4.7,-17.5),(4.9,-17.5),(4.9,-17.7),(4.7,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,17.5),(4.7,17.7),(4.9,17.7),(4.9,17.5),(4.7,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((7.9,14.3),(7.9,14.5),(8.1,14.5),(8.1,14.3),(7.9,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,25.5),(-8.1,25.7),(-7.9,25.7),(-7.9,25.5),(-8.1,25.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-28.9,-12.9),(-28.9,-12.7),(-28.7,-12.7),(-28.7,-12.9),(-28.9,-12.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,-19.3),(6.3,-19.1),(6.5,-19.1),(6.5,-19.3),(6.3,-19.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.3,19.1),(6.3,19.3),(6.5,19.3),(6.5,19.1),(6.3,19.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.7,12.7),(28.7,12.9),(28.9,12.9),(28.9,12.7),(28.7,12.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-22.5),(12.7,-22.3),(12.9,-22.3),(12.9,-22.5),(12.7,-22.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,22.3),(12.7,22.5),(12.9,22.5),(12.9,22.3),(12.7,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,-9.7),(-3.3,-9.5),(-3.1,-9.5),(-3.1,-9.7),(-3.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,9.5),(3.1,9.7),(3.3,9.7),(3.3,9.5),(3.1,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-9.7),(30.3,-9.5),(30.5,-9.5),(30.5,-9.7),(30.3,-9.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,9.5),(30.3,9.7),(30.5,9.7),(30.5,9.5),(30.3,9.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,11.1),(4.7,11.3),(4.9,11.3),(4.9,11.1),(4.7,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-22.5,14.3),(-22.5,14.5),(-22.3,14.5),(-22.3,14.3),(-22.5,14.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-14.5),(22.3,-14.3),(22.5,-14.3),(22.5,-14.5),(22.3,-14.5)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,-6.5),(-11.3,-6.3),(-11.1,-6.3),(-11.1,-6.5),(-11.3,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-6.5),(11.1,-6.3),(11.3,-6.3),(11.3,-6.5),(11.1,-6.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-11.3),(30.3,-11.1),(30.5,-11.1),(30.5,-11.3),(30.3,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,11.1),(30.3,11.3),(30.5,11.3),(30.5,11.1),(30.3,11.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-3.3,3.1),(-3.3,3.3),(-3.1,3.3),(-3.1,3.1),(-3.3,3.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.1,-3.3),(3.1,-3.1),(3.3,-3.1),(3.3,-3.3),(3.1,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((15.9,-3.3),(15.9,-3.1),(16.1,-3.1),(16.1,-3.3),(15.9,-3.3)),
        )
        createRL(
            tech, net, 'via3',
            ((31.9,-8.1),(31.9,-7.9),(32.1,-7.9),(32.1,-8.1),(31.9,-8.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,17.5),(-11.3,17.7),(-11.1,17.7),(-11.1,17.5),(-11.3,17.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,-17.7),(11.1,-17.5),(11.3,-17.5),(11.3,-17.7),(11.1,-17.7)),
        )
        createRL(
            tech, net, 'via3',
            ((-11.3,22.3),(-11.3,22.5),(-11.1,22.5),(-11.1,22.3),(-11.3,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.1,22.3),(11.1,22.5),(11.3,22.5),(11.3,22.3),(11.1,22.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-12.9,-0.1),(-12.9,0.1),(-12.7,0.1),(-12.7,-0.1),(-12.9,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.7,-0.1),(12.7,0.1),(12.9,0.1),(12.9,-0.1),(12.7,-0.1)),
        )
        createRL(
            tech, net, 'via3',
            ((-30.5,-4.9),(-30.5,-4.7),(-30.3,-4.7),(-30.3,-4.9),(-30.5,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.3,-4.9),(30.3,-4.7),(30.5,-4.7),(30.5,-4.9),(30.3,-4.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,-1.7),(22.3,-1.5),(22.5,-1.5),(22.5,-1.7),(22.3,-1.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.3,1.5),(22.3,1.7),(22.5,1.7),(22.5,1.5),(22.3,1.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.7,-11.3),(4.7,-11.1),(4.9,-11.1),(4.9,-11.3),(4.7,-11.3)),
        )
        createRL(
            tech, net, 'via3',
            ((-8.1,9.5),(-8.1,9.7),(-7.9,9.7),(-7.9,9.5),(-8.1,9.5)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,2.0),(0.4,2.8),(1.2,2.8),(1.2,2.0),(0.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,14.8),(10.0,15.6),(10.8,15.6),(10.8,14.8),(10.0,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,11.6),(-14.0,12.4),(-13.2,12.4),(-13.2,11.6),(-14.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,13.2),(-23.6,14.0),(-22.8,14.0),(-22.8,13.2),(-23.6,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,13.2),(-2.8,14.0),(-2.0,14.0),(-2.0,13.2),(-2.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-1.2),(-25.2,-0.4),(-24.4,-0.4),(-24.4,-1.2),(-25.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,0.4),(29.2,1.2),(30.0,1.2),(30.0,0.4),(29.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-7.6),(10.0,-6.8),(10.8,-6.8),(10.8,-7.6),(10.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-2.8),(27.6,-2.0),(28.4,-2.0),(28.4,-2.8),(27.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,14.8),(6.8,15.6),(7.6,15.6),(7.6,14.8),(6.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,3.6),(-25.2,4.4),(-24.4,4.4),(-24.4,3.6),(-25.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,19.6),(3.6,20.4),(4.4,20.4),(4.4,19.6),(3.6,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,16.4),(-2.8,17.2),(-2.0,17.2),(-2.0,16.4),(-2.8,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,2.0),(-4.4,2.8),(-3.6,2.8),(-3.6,2.0),(-4.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-17.2),(13.2,-16.4),(14.0,-16.4),(14.0,-17.2),(13.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-2.8),(30.8,-2.0),(31.6,-2.0),(31.6,-2.8),(30.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,5.2),(-34.8,6.0),(-34.0,6.0),(-34.0,5.2),(-34.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-1.2),(-7.6,-0.4),(-6.8,-0.4),(-6.8,-1.2),(-7.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-12.4),(-15.6,-11.6),(-14.8,-11.6),(-14.8,-12.4),(-15.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,22.8),(-14.0,23.6),(-13.2,23.6),(-13.2,22.8),(-14.0,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-7.6),(18.0,-6.8),(18.8,-6.8),(18.8,-7.6),(18.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,5.2),(10.0,6.0),(10.8,6.0),(10.8,5.2),(10.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-22.0),(6.8,-21.2),(7.6,-21.2),(7.6,-22.0),(6.8,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,5.2),(5.2,6.0),(6.0,6.0),(6.0,5.2),(5.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-17.2),(-22.0,-16.4),(-21.2,-16.4),(-21.2,-17.2),(-22.0,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,18.0),(6.8,18.8),(7.6,18.8),(7.6,18.0),(6.8,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-2.8),(-1.2,-2.0),(-0.4,-2.0),(-0.4,-2.8),(-1.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,3.6),(8.4,4.4),(9.2,4.4),(9.2,3.6),(8.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-20.4),(-12.4,-19.6),(-11.6,-19.6),(-11.6,-20.4),(-12.4,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,0.4),(27.6,1.2),(28.4,1.2),(28.4,0.4),(27.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,-1.2),(-34.8,-0.4),(-34.0,-0.4),(-34.0,-1.2),(-34.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,10.0),(6.8,10.8),(7.6,10.8),(7.6,10.0),(6.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-9.2),(24.4,-8.4),(25.2,-8.4),(25.2,-9.2),(24.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,5.2),(3.6,6.0),(4.4,6.0),(4.4,5.2),(3.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,6.8),(-30.0,7.6),(-29.2,7.6),(-29.2,6.8),(-30.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-20.4),(-17.2,-19.6),(-16.4,-19.6),(-16.4,-20.4),(-17.2,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-17.2),(-1.2,-16.4),(-0.4,-16.4),(-0.4,-17.2),(-1.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-26.8),(6.8,-26.0),(7.6,-26.0),(7.6,-26.8),(6.8,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,3.6),(13.2,4.4),(14.0,4.4),(14.0,3.6),(13.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-23.6),(-14.0,-22.8),(-13.2,-22.8),(-13.2,-23.6),(-14.0,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,14.8),(-26.8,15.6),(-26.0,15.6),(-26.0,14.8),(-26.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-6.0),(-23.6,-5.2),(-22.8,-5.2),(-22.8,-6.0),(-23.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-14.0),(26.0,-13.2),(26.8,-13.2),(26.8,-14.0),(26.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-9.2),(-22.0,-8.4),(-21.2,-8.4),(-21.2,-9.2),(-22.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,3.6),(3.6,4.4),(4.4,4.4),(4.4,3.6),(3.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,8.4),(-6.0,9.2),(-5.2,9.2),(-5.2,8.4),(-6.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,8.4),(6.8,9.2),(7.6,9.2),(7.6,8.4),(6.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-4.4),(-20.4,-3.6),(-19.6,-3.6),(-19.6,-4.4),(-20.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,16.4),(0.4,17.2),(1.2,17.2),(1.2,16.4),(0.4,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,2.0),(-28.4,2.8),(-27.6,2.8),(-27.6,2.0),(-28.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-6.0),(-26.8,-5.2),(-26.0,-5.2),(-26.0,-6.0),(-26.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,6.8),(26.0,7.6),(26.8,7.6),(26.8,6.8),(26.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,-6.0),(32.4,-5.2),(33.2,-5.2),(33.2,-6.0),(32.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,2.0),(-31.6,2.8),(-30.8,2.8),(-30.8,2.0),(-31.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,10.0),(11.6,10.8),(12.4,10.8),(12.4,10.0),(11.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-12.4),(13.2,-11.6),(14.0,-11.6),(14.0,-12.4),(13.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-1.2),(-1.2,-0.4),(-0.4,-0.4),(-0.4,-1.2),(-1.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-6.0),(6.8,-5.2),(7.6,-5.2),(7.6,-6.0),(6.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-7.6),(-30.0,-6.8),(-29.2,-6.8),(-29.2,-7.6),(-30.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-17.2),(-15.6,-16.4),(-14.8,-16.4),(-14.8,-17.2),(-15.6,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,14.8),(-20.4,15.6),(-19.6,15.6),(-19.6,14.8),(-20.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-6.0),(-2.8,-5.2),(-2.0,-5.2),(-2.0,-6.0),(-2.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-6.0),(8.4,-5.2),(9.2,-5.2),(9.2,-6.0),(8.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-26.8),(11.6,-26.0),(12.4,-26.0),(12.4,-26.8),(11.6,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,19.6),(-1.2,20.4),(-0.4,20.4),(-0.4,19.6),(-1.2,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,0.4),(-4.4,1.2),(-3.6,1.2),(-3.6,0.4),(-4.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-22.0),(-20.4,-21.2),(-19.6,-21.2),(-19.6,-22.0),(-20.4,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,0.4),(5.2,1.2),(6.0,1.2),(6.0,0.4),(5.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,22.8),(10.0,23.6),(10.8,23.6),(10.8,22.8),(10.0,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,14.8),(-15.6,15.6),(-14.8,15.6),(-14.8,14.8),(-15.6,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-15.6),(-26.8,-14.8),(-26.0,-14.8),(-26.0,-15.6),(-26.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,5.2),(16.4,6.0),(17.2,6.0),(17.2,5.2),(16.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,14.8),(19.6,15.6),(20.4,15.6),(20.4,14.8),(19.6,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,5.2),(27.6,6.0),(28.4,6.0),(28.4,5.2),(27.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-4.4),(-17.2,-3.6),(-16.4,-3.6),(-16.4,-4.4),(-17.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-23.6),(3.6,-22.8),(4.4,-22.8),(4.4,-23.6),(3.6,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,5.2),(30.8,6.0),(31.6,6.0),(31.6,5.2),(30.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-1.2),(27.6,-0.4),(28.4,-0.4),(28.4,-1.2),(27.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,3.6),(27.6,4.4),(28.4,4.4),(28.4,3.6),(27.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-20.4),(-10.8,-19.6),(-10.0,-19.6),(-10.0,-20.4),(-10.8,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,18.0),(3.6,18.8),(4.4,18.8),(4.4,18.0),(3.6,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-20.4),(-6.0,-19.6),(-5.2,-19.6),(-5.2,-20.4),(-6.0,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-20.4),(6.8,-19.6),(7.6,-19.6),(7.6,-20.4),(6.8,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-9.2),(26.0,-8.4),(26.8,-8.4),(26.8,-9.2),(26.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,21.2),(-9.2,22.0),(-8.4,22.0),(-8.4,21.2),(-9.2,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,3.6),(-12.4,4.4),(-11.6,4.4),(-11.6,3.6),(-12.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,6.8),(13.2,7.6),(14.0,7.6),(14.0,6.8),(13.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-15.6),(-15.6,-14.8),(-14.8,-14.8),(-14.8,-15.6),(-15.6,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-14.0),(-1.2,-13.2),(-0.4,-13.2),(-0.4,-14.0),(-1.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-22.0),(-2.8,-21.2),(-2.0,-21.2),(-2.0,-22.0),(-2.8,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-12.4),(10.0,-11.6),(10.8,-11.6),(10.8,-12.4),(10.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-22.0),(13.2,-21.2),(14.0,-21.2),(14.0,-22.0),(13.2,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-15.6),(24.4,-14.8),(25.2,-14.8),(25.2,-15.6),(24.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,3.6),(-1.2,4.4),(-0.4,4.4),(-0.4,3.6),(-1.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-12.4),(11.6,-11.6),(12.4,-11.6),(12.4,-12.4),(11.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-6.0),(3.6,-5.2),(4.4,-5.2),(4.4,-6.0),(3.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-14.0),(-12.4,-13.2),(-11.6,-13.2),(-11.6,-14.0),(-12.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,5.2),(0.4,6.0),(1.2,6.0),(1.2,5.2),(0.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,13.2),(-15.6,14.0),(-14.8,14.0),(-14.8,13.2),(-15.6,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-12.4),(-30.0,-11.6),(-29.2,-11.6),(-29.2,-12.4),(-30.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,11.6),(18.0,12.4),(18.8,12.4),(18.8,11.6),(18.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-25.2),(-7.6,-24.4),(-6.8,-24.4),(-6.8,-25.2),(-7.6,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-7.6),(22.8,-6.8),(23.6,-6.8),(23.6,-7.6),(22.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-6.0),(2.0,-5.2),(2.8,-5.2),(2.8,-6.0),(2.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-1.2),(18.0,-0.4),(18.8,-0.4),(18.8,-1.2),(18.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,3.6),(-26.8,4.4),(-26.0,4.4),(-26.0,3.6),(-26.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-14.0),(-17.2,-13.2),(-16.4,-13.2),(-16.4,-14.0),(-17.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,10.0),(3.6,10.8),(4.4,10.8),(4.4,10.0),(3.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,-4.4),(-34.8,-3.6),(-34.0,-3.6),(-34.0,-4.4),(-34.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,-4.4),(34.0,-3.6),(34.8,-3.6),(34.8,-4.4),(34.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-12.4),(5.2,-11.6),(6.0,-11.6),(6.0,-12.4),(5.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-25.2),(-17.2,-24.4),(-16.4,-24.4),(-16.4,-25.2),(-17.2,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-25.2),(13.2,-24.4),(14.0,-24.4),(14.0,-25.2),(13.2,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,3.6),(-2.8,4.4),(-2.0,4.4),(-2.0,3.6),(-2.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-17.2),(16.4,-16.4),(17.2,-16.4),(17.2,-17.2),(16.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,-9.2),(32.4,-8.4),(33.2,-8.4),(33.2,-9.2),(32.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,26.0),(-14.0,26.8),(-13.2,26.8),(-13.2,26.0),(-14.0,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,5.2),(-4.4,6.0),(-3.6,6.0),(-3.6,5.2),(-4.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-26.8),(3.6,-26.0),(4.4,-26.0),(4.4,-26.8),(3.6,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,3.6),(-23.6,4.4),(-22.8,4.4),(-22.8,3.6),(-23.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,5.2),(-22.0,6.0),(-21.2,6.0),(-21.2,5.2),(-22.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,8.4),(-2.8,9.2),(-2.0,9.2),(-2.0,8.4),(-2.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-23.6),(-10.8,-22.8),(-10.0,-22.8),(-10.0,-23.6),(-10.8,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-4.4),(-10.8,-3.6),(-10.0,-3.6),(-10.0,-4.4),(-10.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,16.4),(-25.2,17.2),(-24.4,17.2),(-24.4,16.4),(-25.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,14.8),(-17.2,15.6),(-16.4,15.6),(-16.4,14.8),(-17.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,5.2),(-9.2,6.0),(-8.4,6.0),(-8.4,5.2),(-9.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,2.0),(-34.8,2.8),(-34.0,2.8),(-34.0,2.0),(-34.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,3.6),(-22.0,4.4),(-21.2,4.4),(-21.2,3.6),(-22.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-18.8),(-6.0,-18.0),(-5.2,-18.0),(-5.2,-18.8),(-6.0,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-9.2),(-2.8,-8.4),(-2.0,-8.4),(-2.0,-9.2),(-2.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-25.2),(0.4,-24.4),(1.2,-24.4),(1.2,-25.2),(0.4,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-17.2),(2.0,-16.4),(2.8,-16.4),(2.8,-17.2),(2.0,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-4.4),(-7.6,-3.6),(-6.8,-3.6),(-6.8,-4.4),(-7.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-6.0),(13.2,-5.2),(14.0,-5.2),(14.0,-6.0),(13.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-1.2),(-22.0,-0.4),(-21.2,-0.4),(-21.2,-1.2),(-22.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-6.0),(27.6,-5.2),(28.4,-5.2),(28.4,-6.0),(27.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,8.4),(-23.6,9.2),(-22.8,9.2),(-22.8,8.4),(-23.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,8.4),(24.4,9.2),(25.2,9.2),(25.2,8.4),(24.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,16.4),(11.6,17.2),(12.4,17.2),(12.4,16.4),(11.6,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-6.0),(30.8,-5.2),(31.6,-5.2),(31.6,-6.0),(30.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,0.4),(3.6,1.2),(4.4,1.2),(4.4,0.4),(3.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,22.8),(-10.8,23.6),(-10.0,23.6),(-10.0,22.8),(-10.8,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-18.8),(-7.6,-18.0),(-6.8,-18.0),(-6.8,-18.8),(-7.6,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-9.2),(-14.0,-8.4),(-13.2,-8.4),(-13.2,-9.2),(-14.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-15.6),(-17.2,-14.8),(-16.4,-14.8),(-16.4,-15.6),(-17.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,10.0),(-17.2,10.8),(-16.4,10.8),(-16.4,10.0),(-17.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,22.8),(0.4,23.6),(1.2,23.6),(1.2,22.8),(0.4,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,24.4),(-10.8,25.2),(-10.0,25.2),(-10.0,24.4),(-10.8,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-23.6),(-18.8,-22.8),(-18.0,-22.8),(-18.0,-23.6),(-18.8,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,16.4),(10.0,17.2),(10.8,17.2),(10.8,16.4),(10.0,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-10.8),(26.0,-10.0),(26.8,-10.0),(26.8,-10.8),(26.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-4.4),(-14.0,-3.6),(-13.2,-3.6),(-13.2,-4.4),(-14.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-4.4),(14.8,-3.6),(15.6,-3.6),(15.6,-4.4),(14.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,2.0),(5.2,2.8),(6.0,2.8),(6.0,2.0),(5.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,5.2),(-28.4,6.0),(-27.6,6.0),(-27.6,5.2),(-28.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,22.8),(6.8,23.6),(7.6,23.6),(7.6,22.8),(6.8,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-12.4),(3.6,-11.6),(4.4,-11.6),(4.4,-12.4),(3.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-2.8),(-26.8,-2.0),(-26.0,-2.0),(-26.0,-2.8),(-26.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-14.0),(-4.4,-13.2),(-3.6,-13.2),(-3.6,-14.0),(-4.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-17.2),(21.2,-16.4),(22.0,-16.4),(22.0,-17.2),(21.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,21.2),(-18.8,22.0),(-18.0,22.0),(-18.0,21.2),(-18.8,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,8.4),(-17.2,9.2),(-16.4,9.2),(-16.4,8.4),(-17.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,10.0),(-22.0,10.8),(-21.2,10.8),(-21.2,10.0),(-22.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,5.2),(-33.2,6.0),(-32.4,6.0),(-32.4,5.2),(-33.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-25.2),(-10.8,-24.4),(-10.0,-24.4),(-10.0,-25.2),(-10.8,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-14.0),(-9.2,-13.2),(-8.4,-13.2),(-8.4,-14.0),(-9.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,18.0),(8.4,18.8),(9.2,18.8),(9.2,18.0),(8.4,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-2.8),(-2.8,-2.0),(-2.0,-2.0),(-2.0,-2.8),(-2.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-25.2),(-9.2,-24.4),(-8.4,-24.4),(-8.4,-25.2),(-9.2,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-25.2),(5.2,-24.4),(6.0,-24.4),(6.0,-25.2),(5.2,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,6.8),(-34.8,7.6),(-34.0,7.6),(-34.0,6.8),(-34.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-12.4),(24.4,-11.6),(25.2,-11.6),(25.2,-12.4),(24.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,-6.0),(34.0,-5.2),(34.8,-5.2),(34.8,-6.0),(34.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-23.6),(-7.6,-22.8),(-6.8,-22.8),(-6.8,-23.6),(-7.6,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-18.8),(-17.2,-18.0),(-16.4,-18.0),(-16.4,-18.8),(-17.2,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-26.8),(-1.2,-26.0),(-0.4,-26.0),(-0.4,-26.8),(-1.2,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-20.4),(-20.4,-19.6),(-19.6,-19.6),(-19.6,-20.4),(-20.4,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,14.8),(-9.2,15.6),(-8.4,15.6),(-8.4,14.8),(-9.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,6.8),(-10.8,7.6),(-10.0,7.6),(-10.0,6.8),(-10.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-2.8),(-7.6,-2.0),(-6.8,-2.0),(-6.8,-2.8),(-7.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-25.2),(-14.0,-24.4),(-13.2,-24.4),(-13.2,-25.2),(-14.0,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,0.4),(-14.0,1.2),(-13.2,1.2),(-13.2,0.4),(-14.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,0.4),(14.8,1.2),(15.6,1.2),(15.6,0.4),(14.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-7.6),(11.6,-6.8),(12.4,-6.8),(12.4,-7.6),(11.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,10.0),(10.0,10.8),(10.8,10.8),(10.8,10.0),(10.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-2.8),(-25.2,-2.0),(-24.4,-2.0),(-24.4,-2.8),(-25.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,16.4),(-6.0,17.2),(-5.2,17.2),(-5.2,16.4),(-6.0,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,16.4),(6.8,17.2),(7.6,17.2),(7.6,16.4),(6.8,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,18.0),(16.4,18.8),(17.2,18.8),(17.2,18.0),(16.4,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,6.8),(-23.6,7.6),(-22.8,7.6),(-22.8,6.8),(-23.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-7.6),(29.2,-6.8),(30.0,-6.8),(30.0,-7.6),(29.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-2.8),(-14.0,-2.0),(-13.2,-2.0),(-13.2,-2.8),(-14.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,13.2),(13.2,14.0),(14.0,14.0),(14.0,13.2),(13.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-10.8),(16.4,-10.0),(17.2,-10.0),(17.2,-10.8),(16.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-20.4),(-15.6,-19.6),(-14.8,-19.6),(-14.8,-20.4),(-15.6,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,21.2),(-1.2,22.0),(-0.4,22.0),(-0.4,21.2),(-1.2,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-15.6),(-9.2,-14.8),(-8.4,-14.8),(-8.4,-15.6),(-9.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,10.0),(-9.2,10.8),(-8.4,10.8),(-8.4,10.0),(-9.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,22.8),(2.0,23.6),(2.8,23.6),(2.8,22.8),(2.0,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,3.6),(32.4,4.4),(33.2,4.4),(33.2,3.6),(32.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,19.6),(6.8,20.4),(7.6,20.4),(7.6,19.6),(6.8,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-18.8),(13.2,-18.0),(14.0,-18.0),(14.0,-18.8),(13.2,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-9.2),(27.6,-8.4),(28.4,-8.4),(28.4,-9.2),(27.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,19.6),(18.0,20.4),(18.8,20.4),(18.8,19.6),(18.0,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-1.2),(-10.8,-0.4),(-10.0,-0.4),(-10.0,-1.2),(-10.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,26.0),(-12.4,26.8),(-11.6,26.8),(-11.6,26.0),(-12.4,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-10.8),(8.4,-10.0),(9.2,-10.0),(9.2,-10.8),(8.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-7.6),(-7.6,-6.8),(-6.8,-6.8),(-6.8,-7.6),(-7.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,5.2),(29.2,6.0),(30.0,6.0),(30.0,5.2),(29.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-1.2),(-12.4,-0.4),(-11.6,-0.4),(-11.6,-1.2),(-12.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,26.0),(0.4,26.8),(1.2,26.8),(1.2,26.0),(0.4,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-12.4),(-12.4,-11.6),(-11.6,-11.6),(-11.6,-12.4),(-12.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,0.4),(2.0,1.2),(2.8,1.2),(2.8,0.4),(2.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,8.4),(-9.2,9.2),(-8.4,9.2),(-8.4,8.4),(-9.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-14.0),(22.8,-13.2),(23.6,-13.2),(23.6,-14.0),(22.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,3.6),(-36.4,4.4),(-35.6,4.4),(-35.6,3.6),(-36.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-4.4),(-31.6,-3.6),(-30.8,-3.6),(-30.8,-4.4),(-31.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-4.4),(2.0,-3.6),(2.8,-3.6),(2.8,-4.4),(2.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,11.6),(11.6,12.4),(12.4,12.4),(12.4,11.6),(11.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,26.0),(6.8,26.8),(7.6,26.8),(7.6,26.0),(6.8,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,6.8),(14.8,7.6),(15.6,7.6),(15.6,6.8),(14.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-2.8),(-4.4,-2.0),(-3.6,-2.0),(-3.6,-2.8),(-4.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,10.0),(-18.8,10.8),(-18.0,10.8),(-18.0,10.0),(-18.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-2.8),(21.2,-2.0),(22.0,-2.0),(22.0,-2.8),(21.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,5.2),(-7.6,6.0),(-6.8,6.0),(-6.8,5.2),(-7.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,5.2),(-26.8,6.0),(-26.0,6.0),(-26.0,5.2),(-26.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-14.0),(-7.6,-13.2),(-6.8,-13.2),(-6.8,-14.0),(-7.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-20.4),(8.4,-19.6),(9.2,-19.6),(9.2,-20.4),(8.4,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-17.2),(-6.0,-16.4),(-5.2,-16.4),(-5.2,-17.2),(-6.0,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,10.0),(-10.8,10.8),(-10.0,10.8),(-10.0,10.0),(-10.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-7.6),(-20.4,-6.8),(-19.6,-6.8),(-19.6,-7.6),(-20.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,18.0),(-17.2,18.8),(-16.4,18.8),(-16.4,18.0),(-17.2,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,5.2),(-2.8,6.0),(-2.0,6.0),(-2.0,5.2),(-2.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-10.8),(0.4,-10.0),(1.2,-10.0),(1.2,-10.8),(0.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,22.8),(-12.4,23.6),(-11.6,23.6),(-11.6,22.8),(-12.4,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,5.2),(-1.2,6.0),(-0.4,6.0),(-0.4,5.2),(-1.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,11.6),(-25.2,12.4),(-24.4,12.4),(-24.4,11.6),(-25.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,24.4),(0.4,25.2),(1.2,25.2),(1.2,24.4),(0.4,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,8.4),(-15.6,9.2),(-14.8,9.2),(-14.8,8.4),(-15.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,16.4),(8.4,17.2),(9.2,17.2),(9.2,16.4),(8.4,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-9.2),(2.0,-8.4),(2.8,-8.4),(2.8,-9.2),(2.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,2.0),(14.8,2.8),(15.6,2.8),(15.6,2.0),(14.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,0.4),(-18.8,1.2),(-18.0,1.2),(-18.0,0.4),(-18.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,0.4),(18.0,1.2),(18.8,1.2),(18.8,0.4),(18.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-20.4),(13.2,-19.6),(14.0,-19.6),(14.0,-20.4),(13.2,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,6.8),(3.6,7.6),(4.4,7.6),(4.4,6.8),(3.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,13.2),(5.2,14.0),(6.0,14.0),(6.0,13.2),(5.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-22.0),(0.4,-21.2),(1.2,-21.2),(1.2,-22.0),(0.4,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-20.4),(16.4,-19.6),(17.2,-19.6),(17.2,-20.4),(16.4,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,14.8),(21.2,15.6),(22.0,15.6),(22.0,14.8),(21.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-2.8),(-28.4,-2.0),(-27.6,-2.0),(-27.6,-2.8),(-28.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-23.6),(-2.8,-22.8),(-2.0,-22.8),(-2.0,-23.6),(-2.8,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,19.6),(-22.0,20.4),(-21.2,20.4),(-21.2,19.6),(-22.0,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-9.2),(19.6,-8.4),(20.4,-8.4),(20.4,-9.2),(19.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,10.0),(-14.0,10.8),(-13.2,10.8),(-13.2,10.0),(-14.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-2.8),(-31.6,-2.0),(-30.8,-2.0),(-30.8,-2.8),(-31.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,26.0),(-4.4,26.8),(-3.6,26.8),(-3.6,26.0),(-4.4,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,2.0),(8.4,2.8),(9.2,2.8),(9.2,2.0),(8.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,26.0),(2.0,26.8),(2.8,26.8),(2.8,26.0),(2.0,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-22.0),(-4.4,-21.2),(-3.6,-21.2),(-3.6,-22.0),(-4.4,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-12.4),(-4.4,-11.6),(-3.6,-11.6),(-3.6,-12.4),(-4.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,3.6),(14.8,4.4),(15.6,4.4),(15.6,3.6),(14.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-26.8),(14.8,-26.0),(15.6,-26.0),(15.6,-26.8),(14.8,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,21.2),(-2.8,22.0),(-2.0,22.0),(-2.0,21.2),(-2.8,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,5.2),(34.0,6.0),(34.8,6.0),(34.8,5.2),(34.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-25.2),(10.0,-24.4),(10.8,-24.4),(10.8,-25.2),(10.0,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-4.4),(21.2,-3.6),(22.0,-3.6),(22.0,-4.4),(21.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,6.8),(-12.4,7.6),(-11.6,7.6),(-11.6,6.8),(-12.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,11.6),(3.6,12.4),(4.4,12.4),(4.4,11.6),(3.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-14.0),(11.6,-13.2),(12.4,-13.2),(12.4,-14.0),(11.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,2.0),(35.6,2.8),(36.4,2.8),(36.4,2.0),(35.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,-2.8),(34.0,-2.0),(34.8,-2.0),(34.8,-2.8),(34.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-7.6),(-18.8,-6.8),(-18.0,-6.8),(-18.0,-7.6),(-18.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,24.4),(13.2,25.2),(14.0,25.2),(14.0,24.4),(13.2,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-15.6),(10.0,-14.8),(10.8,-14.8),(10.8,-15.6),(10.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-17.2),(22.8,-16.4),(23.6,-16.4),(23.6,-17.2),(22.8,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-17.2),(-12.4,-16.4),(-11.6,-16.4),(-11.6,-17.2),(-12.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,21.2),(-15.6,22.0),(-14.8,22.0),(-14.8,21.2),(-15.6,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,22.8),(-9.2,23.6),(-8.4,23.6),(-8.4,22.8),(-9.2,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,6.8),(27.6,7.6),(28.4,7.6),(28.4,6.8),(27.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-10.8),(30.8,-10.0),(31.6,-10.0),(31.6,-10.8),(30.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,16.4),(19.6,17.2),(20.4,17.2),(20.4,16.4),(19.6,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-17.2),(-18.8,-16.4),(-18.0,-16.4),(-18.0,-17.2),(-18.8,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-15.6),(6.8,-14.8),(7.6,-14.8),(7.6,-15.6),(6.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-7.6),(-31.6,-6.8),(-30.8,-6.8),(-30.8,-7.6),(-31.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-7.6),(-1.2,-6.8),(-0.4,-6.8),(-0.4,-7.6),(-1.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,2.0),(-1.2,2.8),(-0.4,2.8),(-0.4,2.0),(-1.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,13.2),(10.0,14.0),(10.8,14.0),(10.8,13.2),(10.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-23.6),(13.2,-22.8),(14.0,-22.8),(14.0,-23.6),(13.2,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,0.4),(-12.4,1.2),(-11.6,1.2),(-11.6,0.4),(-12.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-14.0),(21.2,-13.2),(22.0,-13.2),(22.0,-14.0),(21.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-9.2),(22.8,-8.4),(23.6,-8.4),(23.6,-9.2),(22.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-22.0),(-17.2,-21.2),(-16.4,-21.2),(-16.4,-22.0),(-17.2,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,19.6),(10.0,20.4),(10.8,20.4),(10.8,19.6),(10.0,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,13.2),(-6.0,14.0),(-5.2,14.0),(-5.2,13.2),(-6.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,0.4),(13.2,1.2),(14.0,1.2),(14.0,0.4),(13.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,26.0),(13.2,26.8),(14.0,26.8),(14.0,26.0),(13.2,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,5.2),(-31.6,6.0),(-30.8,6.0),(-30.8,5.2),(-31.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-17.2),(24.4,-16.4),(25.2,-16.4),(25.2,-17.2),(24.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-14.0),(-18.8,-13.2),(-18.0,-13.2),(-18.0,-14.0),(-18.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,14.8),(18.0,15.6),(18.8,15.6),(18.8,14.8),(18.0,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,2.0),(2.0,2.8),(2.8,2.8),(2.8,2.0),(2.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-7.6),(16.4,-6.8),(17.2,-6.8),(17.2,-7.6),(16.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-4.4),(19.6,-3.6),(20.4,-3.6),(20.4,-4.4),(19.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-23.6),(-9.2,-22.8),(-8.4,-22.8),(-8.4,-23.6),(-9.2,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,8.4),(13.2,9.2),(14.0,9.2),(14.0,8.4),(13.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-1.2),(11.6,-0.4),(12.4,-0.4),(12.4,-1.2),(11.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-2.8),(22.8,-2.0),(23.6,-2.0),(23.6,-2.8),(22.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-12.4),(-6.0,-11.6),(-5.2,-11.6),(-5.2,-12.4),(-6.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-12.4),(6.8,-11.6),(7.6,-11.6),(7.6,-12.4),(6.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-14.0),(14.8,-13.2),(15.6,-13.2),(15.6,-14.0),(14.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-14.0),(-10.8,-13.2),(-10.0,-13.2),(-10.0,-14.0),(-10.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-7.6),(21.2,-6.8),(22.0,-6.8),(22.0,-7.6),(21.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-6.0),(-25.2,-5.2),(-24.4,-5.2),(-24.4,-6.0),(-25.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,-6.0),(-36.4,-5.2),(-35.6,-5.2),(-35.6,-6.0),(-36.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-6.0),(-14.0,-5.2),(-13.2,-5.2),(-13.2,-6.0),(-14.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,16.4),(-9.2,17.2),(-8.4,17.2),(-8.4,16.4),(-9.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,8.4),(11.6,9.2),(12.4,9.2),(12.4,8.4),(11.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-14.0),(16.4,-13.2),(17.2,-13.2),(17.2,-14.0),(16.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,11.6),(-1.2,12.4),(-0.4,12.4),(-0.4,11.6),(-1.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,10.0),(-31.6,10.8),(-30.8,10.8),(-30.8,10.0),(-31.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-17.2),(-14.0,-16.4),(-13.2,-16.4),(-13.2,-17.2),(-14.0,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-14.0),(3.6,-13.2),(4.4,-13.2),(4.4,-14.0),(3.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-1.2),(30.8,-0.4),(31.6,-0.4),(31.6,-1.2),(30.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,2.0),(11.6,2.8),(12.4,2.8),(12.4,2.0),(11.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,24.4),(5.2,25.2),(6.0,25.2),(6.0,24.4),(5.2,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,3.6),(18.0,4.4),(18.8,4.4),(18.8,3.6),(18.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-25.2),(-15.6,-24.4),(-14.8,-24.4),(-14.8,-25.2),(-15.6,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-1.2),(2.0,-0.4),(2.8,-0.4),(2.8,-1.2),(2.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-14.0),(8.4,-13.2),(9.2,-13.2),(9.2,-14.0),(8.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-10.8),(-23.6,-10.0),(-22.8,-10.0),(-22.8,-10.8),(-23.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,18.0),(-22.0,18.8),(-21.2,18.8),(-21.2,18.0),(-22.0,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,6.8),(-22.0,7.6),(-21.2,7.6),(-21.2,6.8),(-22.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-18.8),(11.6,-18.0),(12.4,-18.0),(12.4,-18.8),(11.6,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,3.6),(10.0,4.4),(10.8,4.4),(10.8,3.6),(10.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,6.8),(24.4,7.6),(25.2,7.6),(25.2,6.8),(24.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,2.0),(-26.8,2.8),(-26.0,2.8),(-26.0,2.0),(-26.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,14.8),(-2.8,15.6),(-2.0,15.6),(-2.0,14.8),(-2.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-18.8),(10.0,-18.0),(10.8,-18.0),(10.8,-18.8),(10.0,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-7.6),(0.4,-6.8),(1.2,-6.8),(1.2,-7.6),(0.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,19.6),(16.4,20.4),(17.2,20.4),(17.2,19.6),(16.4,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-15.6),(19.6,-14.8),(20.4,-14.8),(20.4,-15.6),(19.6,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,8.4),(2.0,9.2),(2.8,9.2),(2.8,8.4),(2.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,2.0),(-2.8,2.8),(-2.0,2.8),(-2.0,2.0),(-2.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-18.8),(21.2,-18.0),(22.0,-18.0),(22.0,-18.8),(21.2,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,0.4),(8.4,1.2),(9.2,1.2),(9.2,0.4),(8.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,0.4),(-26.8,1.2),(-26.0,1.2),(-26.0,0.4),(-26.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,0.4),(26.0,1.2),(26.8,1.2),(26.8,0.4),(26.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-9.2),(-31.6,-8.4),(-30.8,-8.4),(-30.8,-9.2),(-31.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,2.0),(-23.6,2.8),(-22.8,2.8),(-22.8,2.0),(-23.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-10.8),(-17.2,-10.0),(-16.4,-10.0),(-16.4,-10.8),(-17.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-2.8),(19.6,-2.0),(20.4,-2.0),(20.4,-2.8),(19.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-26.8),(-12.4,-26.0),(-11.6,-26.0),(-11.6,-26.8),(-12.4,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,26.0),(5.2,26.8),(6.0,26.8),(6.0,26.0),(5.2,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-17.2),(5.2,-16.4),(6.0,-16.4),(6.0,-17.2),(5.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-22.0),(-14.0,-21.2),(-13.2,-21.2),(-13.2,-22.0),(-14.0,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,11.6),(-18.8,12.4),(-18.0,12.4),(-18.0,11.6),(-18.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-7.6),(-22.0,-6.8),(-21.2,-6.8),(-21.2,-7.6),(-22.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-25.2),(8.4,-24.4),(9.2,-24.4),(9.2,-25.2),(8.4,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-14.0),(0.4,-13.2),(1.2,-13.2),(1.2,-14.0),(0.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-1.2),(-18.8,-0.4),(-18.0,-0.4),(-18.0,-1.2),(-18.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,0.4),(35.6,1.2),(36.4,1.2),(36.4,0.4),(35.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-15.6),(-2.8,-14.8),(-2.0,-14.8),(-2.0,-15.6),(-2.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,8.4),(5.2,9.2),(6.0,9.2),(6.0,8.4),(5.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-10.8),(-22.0,-10.0),(-21.2,-10.0),(-21.2,-10.8),(-22.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,5.2),(8.4,6.0),(9.2,6.0),(9.2,5.2),(8.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,11.6),(-10.8,12.4),(-10.0,12.4),(-10.0,11.6),(-10.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-22.0),(-7.6,-21.2),(-6.8,-21.2),(-6.8,-22.0),(-7.6,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,0.4),(-22.0,1.2),(-21.2,1.2),(-21.2,0.4),(-22.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,0.4),(22.8,1.2),(23.6,1.2),(23.6,0.4),(22.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,5.2),(22.8,6.0),(23.6,6.0),(23.6,5.2),(22.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-6.0),(-12.4,-5.2),(-11.6,-5.2),(-11.6,-6.0),(-12.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,24.4),(10.0,25.2),(10.8,25.2),(10.8,24.4),(10.0,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-20.4),(-4.4,-19.6),(-3.6,-19.6),(-3.6,-20.4),(-4.4,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,0.4),(11.6,1.2),(12.4,1.2),(12.4,0.4),(11.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,8.4),(3.6,9.2),(4.4,9.2),(4.4,8.4),(3.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,2.0),(-6.0,2.8),(-5.2,2.8),(-5.2,2.0),(-6.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-2.8),(10.0,-2.0),(10.8,-2.0),(10.8,-2.8),(10.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,3.6),(29.2,4.4),(30.0,4.4),(30.0,3.6),(29.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-4.4),(16.4,-3.6),(17.2,-3.6),(17.2,-4.4),(16.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-23.6),(0.4,-22.8),(1.2,-22.8),(1.2,-23.6),(0.4,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-20.4),(-9.2,-19.6),(-8.4,-19.6),(-8.4,-20.4),(-9.2,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-12.4),(-18.8,-11.6),(-18.0,-11.6),(-18.0,-12.4),(-18.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-26.8),(-10.8,-26.0),(-10.0,-26.0),(-10.0,-26.8),(-10.8,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-12.4),(18.0,-11.6),(18.8,-11.6),(18.8,-12.4),(18.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-17.2),(-17.2,-16.4),(-16.4,-16.4),(-16.4,-17.2),(-17.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,26.0),(-9.2,26.8),(-8.4,26.8),(-8.4,26.0),(-9.2,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-10.8),(13.2,-10.0),(14.0,-10.0),(14.0,-10.8),(13.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,2.0),(34.0,2.8),(34.8,2.8),(34.8,2.0),(34.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,3.6),(5.2,4.4),(6.0,4.4),(6.0,3.6),(5.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,14.8),(22.8,15.6),(23.6,15.6),(23.6,14.8),(22.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,18.0),(-15.6,18.8),(-14.8,18.8),(-14.8,18.0),(-15.6,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-10.8),(-12.4,-10.0),(-11.6,-10.0),(-11.6,-10.8),(-12.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-12.4),(-10.8,-11.6),(-10.0,-11.6),(-10.0,-12.4),(-10.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,2.0),(-20.4,2.8),(-19.6,2.8),(-19.6,2.0),(-20.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-15.6),(-12.4,-14.8),(-11.6,-14.8),(-11.6,-15.6),(-12.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,6.8),(-17.2,7.6),(-16.4,7.6),(-16.4,6.8),(-17.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-17.2),(-2.8,-16.4),(-2.0,-16.4),(-2.0,-17.2),(-2.8,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-20.4),(21.2,-19.6),(22.0,-19.6),(22.0,-20.4),(21.2,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-1.2),(24.4,-0.4),(25.2,-0.4),(25.2,-1.2),(24.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-7.6),(2.0,-6.8),(2.8,-6.8),(2.8,-7.6),(2.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-9.2),(14.8,-8.4),(15.6,-8.4),(15.6,-9.2),(14.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,0.4),(10.0,1.2),(10.8,1.2),(10.8,0.4),(10.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,5.2),(21.2,6.0),(22.0,6.0),(22.0,5.2),(21.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,19.6),(-17.2,20.4),(-16.4,20.4),(-16.4,19.6),(-17.2,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-10.8),(-9.2,-10.0),(-8.4,-10.0),(-8.4,-10.8),(-9.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-1.2),(6.8,-0.4),(7.6,-0.4),(7.6,-1.2),(6.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,3.6),(24.4,4.4),(25.2,4.4),(25.2,3.6),(24.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-26.8),(-4.4,-26.0),(-3.6,-26.0),(-3.6,-26.8),(-4.4,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-10.8),(-18.8,-10.0),(-18.0,-10.0),(-18.0,-10.8),(-18.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,5.2),(2.0,6.0),(2.8,6.0),(2.8,5.2),(2.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,21.2),(18.0,22.0),(18.8,22.0),(18.8,21.2),(18.0,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-17.2),(10.0,-16.4),(10.8,-16.4),(10.8,-17.2),(10.0,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,5.2),(19.6,6.0),(20.4,6.0),(20.4,5.2),(19.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,24.4),(-12.4,25.2),(-11.6,25.2),(-11.6,24.4),(-12.4,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,10.0),(22.8,10.8),(23.6,10.8),(23.6,10.0),(22.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-4.4),(0.4,-3.6),(1.2,-3.6),(1.2,-4.4),(0.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-4.4),(-9.2,-3.6),(-8.4,-3.6),(-8.4,-4.4),(-9.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-7.6),(-17.2,-6.8),(-16.4,-6.8),(-16.4,-7.6),(-17.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,2.0),(-17.2,2.8),(-16.4,2.8),(-16.4,2.0),(-17.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-10.8),(-10.8,-10.0),(-10.0,-10.0),(-10.0,-10.8),(-10.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-2.8),(29.2,-2.0),(30.0,-2.0),(30.0,-2.8),(29.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-2.8),(16.4,-2.0),(17.2,-2.0),(17.2,-2.8),(16.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-22.0),(10.0,-21.2),(10.8,-21.2),(10.8,-22.0),(10.0,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,3.6),(19.6,4.4),(20.4,4.4),(20.4,3.6),(19.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,8.4),(-22.0,9.2),(-21.2,9.2),(-21.2,8.4),(-22.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,8.4),(22.8,9.2),(23.6,9.2),(23.6,8.4),(22.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-17.2),(-20.4,-16.4),(-19.6,-16.4),(-19.6,-17.2),(-20.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-25.2),(-12.4,-24.4),(-11.6,-24.4),(-11.6,-25.2),(-12.4,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,-4.4),(-36.4,-3.6),(-35.6,-3.6),(-35.6,-4.4),(-36.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,11.6),(6.8,12.4),(7.6,12.4),(7.6,11.6),(6.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,8.4),(-1.2,9.2),(-0.4,9.2),(-0.4,8.4),(-1.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,19.6),(-10.8,20.4),(-10.0,20.4),(-10.0,19.6),(-10.8,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,3.6),(-4.4,4.4),(-3.6,4.4),(-3.6,3.6),(-4.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-10.8),(-15.6,-10.0),(-14.8,-10.0),(-14.8,-10.8),(-15.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-6.0),(-15.6,-5.2),(-14.8,-5.2),(-14.8,-6.0),(-15.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,6.8),(5.2,7.6),(6.0,7.6),(6.0,6.8),(5.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-23.6),(2.0,-22.8),(2.8,-22.8),(2.8,-23.6),(2.0,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-23.6),(6.8,-22.8),(7.6,-22.8),(7.6,-23.6),(6.8,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-25.2),(14.8,-24.4),(15.6,-24.4),(15.6,-25.2),(14.8,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,2.0),(32.4,2.8),(33.2,2.8),(33.2,2.0),(32.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,10.0),(27.6,10.8),(28.4,10.8),(28.4,10.0),(27.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-20.4),(-18.8,-19.6),(-18.0,-19.6),(-18.0,-20.4),(-18.8,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,26.0),(-7.6,26.8),(-6.8,26.8),(-6.8,26.0),(-7.6,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,26.0),(8.4,26.8),(9.2,26.8),(9.2,26.0),(8.4,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-10.8),(5.2,-10.0),(6.0,-10.0),(6.0,-10.8),(5.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-20.4),(18.0,-19.6),(18.8,-19.6),(18.8,-20.4),(18.0,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-18.8),(22.8,-18.0),(23.6,-18.0),(23.6,-18.8),(22.8,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-6.0),(22.8,-5.2),(23.6,-5.2),(23.6,-6.0),(22.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-6.0),(24.4,-5.2),(25.2,-5.2),(25.2,-6.0),(24.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-22.0),(5.2,-21.2),(6.0,-21.2),(6.0,-22.0),(5.2,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,0.4),(-20.4,1.2),(-19.6,1.2),(-19.6,0.4),(-20.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,3.6),(-17.2,4.4),(-16.4,4.4),(-16.4,3.6),(-17.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-10.8),(-4.4,-10.0),(-3.6,-10.0),(-3.6,-10.8),(-4.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,0.4),(21.2,1.2),(22.0,1.2),(22.0,0.4),(21.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-15.6),(-4.4,-14.8),(-3.6,-14.8),(-3.6,-15.6),(-4.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,6.8),(-1.2,7.6),(-0.4,7.6),(-0.4,6.8),(-1.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,8.4),(-12.4,9.2),(-11.6,9.2),(-11.6,8.4),(-12.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,-4.4),(-33.2,-3.6),(-32.4,-3.6),(-32.4,-4.4),(-33.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,19.6),(-6.0,20.4),(-5.2,20.4),(-5.2,19.6),(-6.0,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,19.6),(-18.8,20.4),(-18.0,20.4),(-18.0,19.6),(-18.8,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,2.0),(-30.0,2.8),(-29.2,2.8),(-29.2,2.0),(-30.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-2.8),(0.4,-2.0),(1.2,-2.0),(1.2,-2.8),(0.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-22.0),(11.6,-21.2),(12.4,-21.2),(12.4,-22.0),(11.6,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-9.2),(-12.4,-8.4),(-11.6,-8.4),(-11.6,-9.2),(-12.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,24.4),(-7.6,25.2),(-6.8,25.2),(-6.8,24.4),(-7.6,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,24.4),(8.4,25.2),(9.2,25.2),(9.2,24.4),(8.4,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-10.8),(-14.0,-10.0),(-13.2,-10.0),(-13.2,-10.8),(-14.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,3.6),(-28.4,4.4),(-27.6,4.4),(-27.6,3.6),(-28.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,24.4),(-4.4,25.2),(-3.6,25.2),(-3.6,24.4),(-4.4,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,10.0),(18.0,10.8),(18.8,10.8),(18.8,10.0),(18.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,11.6),(-30.0,12.4),(-29.2,12.4),(-29.2,11.6),(-30.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,5.2),(26.0,6.0),(26.8,6.0),(26.8,5.2),(26.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,13.2),(-18.8,14.0),(-18.0,14.0),(-18.0,13.2),(-18.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,18.0),(-12.4,18.8),(-11.6,18.8),(-11.6,18.0),(-12.4,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-15.6),(13.2,-14.8),(14.0,-14.8),(14.0,-15.6),(13.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-6.0),(5.2,-5.2),(6.0,-5.2),(6.0,-6.0),(5.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-17.2),(6.8,-16.4),(7.6,-16.4),(7.6,-17.2),(6.8,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,21.2),(-12.4,22.0),(-11.6,22.0),(-11.6,21.2),(-12.4,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-18.8),(19.6,-18.0),(20.4,-18.0),(20.4,-18.8),(19.6,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-6.0),(19.6,-5.2),(20.4,-5.2),(20.4,-6.0),(19.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-12.4),(27.6,-11.6),(28.4,-11.6),(28.4,-12.4),(27.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-25.2),(-4.4,-24.4),(-3.6,-24.4),(-3.6,-25.2),(-4.4,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-14.0),(-28.4,-13.2),(-27.6,-13.2),(-27.6,-14.0),(-28.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-18.8),(-10.8,-18.0),(-10.0,-18.0),(-10.0,-18.8),(-10.8,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,26.0),(-2.8,26.8),(-2.0,26.8),(-2.0,26.0),(-2.8,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-1.2),(13.2,-0.4),(14.0,-0.4),(14.0,-1.2),(13.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,13.2),(-10.8,14.0),(-10.0,14.0),(-10.0,13.2),(-10.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-14.0),(-6.0,-13.2),(-5.2,-13.2),(-5.2,-14.0),(-6.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-4.4),(-12.4,-3.6),(-11.6,-3.6),(-11.6,-4.4),(-12.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,16.4),(3.6,17.2),(4.4,17.2),(4.4,16.4),(3.6,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,14.8),(14.8,15.6),(15.6,15.6),(15.6,14.8),(14.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,10.0),(19.6,10.8),(20.4,10.8),(20.4,10.0),(19.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-12.4),(21.2,-11.6),(22.0,-11.6),(22.0,-12.4),(21.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,-7.6),(34.0,-6.8),(34.8,-6.8),(34.8,-7.6),(34.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-10.8),(6.8,-10.0),(7.6,-10.0),(7.6,-10.8),(6.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,-1.2),(-33.2,-0.4),(-32.4,-0.4),(-32.4,-1.2),(-33.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,11.6),(26.0,12.4),(26.8,12.4),(26.8,11.6),(26.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-7.6),(14.8,-6.8),(15.6,-6.8),(15.6,-7.6),(14.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-18.8),(0.4,-18.0),(1.2,-18.0),(1.2,-18.8),(0.4,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,22.8),(-18.8,23.6),(-18.0,23.6),(-18.0,22.8),(-18.8,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-22.0),(18.0,-21.2),(18.8,-21.2),(18.8,-22.0),(18.0,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,5.2),(-20.4,6.0),(-19.6,6.0),(-19.6,5.2),(-20.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,11.6),(2.0,12.4),(2.8,12.4),(2.8,11.6),(2.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-4.4),(-26.8,-3.6),(-26.0,-3.6),(-26.0,-4.4),(-26.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-4.4),(26.0,-3.6),(26.8,-3.6),(26.8,-4.4),(26.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,16.4),(13.2,17.2),(14.0,17.2),(14.0,16.4),(13.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,0.4),(-17.2,1.2),(-16.4,1.2),(-16.4,0.4),(-17.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-17.2),(8.4,-16.4),(9.2,-16.4),(9.2,-17.2),(8.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,5.2),(-25.2,6.0),(-24.4,6.0),(-24.4,5.2),(-25.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,8.4),(-4.4,9.2),(-3.6,9.2),(-3.6,8.4),(-4.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,3.6),(-15.6,4.4),(-14.8,4.4),(-14.8,3.6),(-15.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,5.2),(-14.0,6.0),(-13.2,6.0),(-13.2,5.2),(-14.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-18.8),(-18.8,-18.0),(-18.0,-18.0),(-18.0,-18.8),(-18.8,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,18.0),(18.0,18.8),(18.8,18.8),(18.8,18.0),(18.0,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,-1.2),(35.6,-0.4),(36.4,-0.4),(36.4,-1.2),(35.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-4.4),(-2.8,-3.6),(-2.0,-3.6),(-2.0,-4.4),(-2.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,10.0),(14.8,10.8),(15.6,10.8),(15.6,10.0),(14.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-4.4),(-23.6,-3.6),(-22.8,-3.6),(-22.8,-4.4),(-23.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-18.8),(-9.2,-18.0),(-8.4,-18.0),(-8.4,-18.8),(-9.2,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,14.8),(-6.0,15.6),(-5.2,15.6),(-5.2,14.8),(-6.0,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-10.8),(11.6,-10.0),(12.4,-10.0),(12.4,-10.8),(11.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-9.2),(-4.4,-8.4),(-3.6,-8.4),(-3.6,-9.2),(-4.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,22.8),(-7.6,23.6),(-6.8,23.6),(-6.8,22.8),(-7.6,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,6.8),(10.0,7.6),(10.8,7.6),(10.8,6.8),(10.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,3.6),(-14.0,4.4),(-13.2,4.4),(-13.2,3.6),(-14.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,0.4),(19.6,1.2),(20.4,1.2),(20.4,0.4),(19.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,10.0),(16.4,10.8),(17.2,10.8),(17.2,10.0),(16.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,8.4),(-14.0,9.2),(-13.2,9.2),(-13.2,8.4),(-14.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,8.4),(14.8,9.2),(15.6,9.2),(15.6,8.4),(14.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-7.6),(3.6,-6.8),(4.4,-6.8),(4.4,-7.6),(3.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-17.2),(-25.2,-16.4),(-24.4,-16.4),(-24.4,-17.2),(-25.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-25.2),(11.6,-24.4),(12.4,-24.4),(12.4,-25.2),(11.6,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-1.2),(-9.2,-0.4),(-8.4,-0.4),(-8.4,-1.2),(-9.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-6.0),(-18.8,-5.2),(-18.0,-5.2),(-18.0,-6.0),(-18.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-15.6),(5.2,-14.8),(6.0,-14.8),(6.0,-15.6),(5.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-20.4),(10.0,-19.6),(10.8,-19.6),(10.8,-20.4),(10.0,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,10.0),(-7.6,10.8),(-6.8,10.8),(-6.8,10.0),(-7.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,18.0),(-6.0,18.8),(-5.2,18.8),(-5.2,18.0),(-6.0,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,10.0),(8.4,10.8),(9.2,10.8),(9.2,10.0),(8.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,6.8),(18.0,7.6),(18.8,7.6),(18.8,6.8),(18.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-12.4),(19.6,-11.6),(20.4,-11.6),(20.4,-12.4),(19.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,0.4),(-34.8,1.2),(-34.0,1.2),(-34.0,0.4),(-34.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,0.4),(34.0,1.2),(34.8,1.2),(34.8,0.4),(34.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-14.0),(-20.4,-13.2),(-19.6,-13.2),(-19.6,-14.0),(-20.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,5.2),(32.4,6.0),(33.2,6.0),(33.2,5.2),(32.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,16.4),(-1.2,17.2),(-0.4,17.2),(-0.4,16.4),(-1.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,8.4),(-33.2,9.2),(-32.4,9.2),(-32.4,8.4),(-33.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-17.2),(18.0,-16.4),(18.8,-16.4),(18.8,-17.2),(18.0,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-15.6),(-6.0,-14.8),(-5.2,-14.8),(-5.2,-15.6),(-6.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-10.8),(2.0,-10.0),(2.8,-10.0),(2.8,-10.8),(2.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-4.4),(-6.0,-3.6),(-5.2,-3.6),(-5.2,-4.4),(-6.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-4.4),(6.8,-3.6),(7.6,-3.6),(7.6,-4.4),(6.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,18.0),(14.8,18.8),(15.6,18.8),(15.6,18.0),(14.8,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-14.0),(-25.2,-13.2),(-24.4,-13.2),(-24.4,-14.0),(-25.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,19.6),(-15.6,20.4),(-14.8,20.4),(-14.8,19.6),(-15.6,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,21.2),(-14.0,22.0),(-13.2,22.0),(-13.2,21.2),(-14.0,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-20.4),(-2.8,-19.6),(-2.0,-19.6),(-2.0,-20.4),(-2.8,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-18.8),(5.2,-18.0),(6.0,-18.0),(6.0,-18.8),(5.2,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-1.2),(-15.6,-0.4),(-14.8,-0.4),(-14.8,-1.2),(-15.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,13.2),(6.8,14.0),(7.6,14.0),(7.6,13.2),(6.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,10.0),(-12.4,10.8),(-11.6,10.8),(-11.6,10.0),(-12.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,21.2),(0.4,22.0),(1.2,22.0),(1.2,21.2),(0.4,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,11.6),(13.2,12.4),(14.0,12.4),(14.0,11.6),(13.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,14.8),(-25.2,15.6),(-24.4,15.6),(-24.4,14.8),(-25.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-9.2),(-7.6,-8.4),(-6.8,-8.4),(-6.8,-9.2),(-7.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,6.8),(-26.8,7.6),(-26.0,7.6),(-26.0,6.8),(-26.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-2.8),(-23.6,-2.0),(-22.8,-2.0),(-22.8,-2.8),(-23.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-22.0),(2.0,-21.2),(2.8,-21.2),(2.8,-22.0),(2.0,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,10.0),(0.4,10.8),(1.2,10.8),(1.2,10.0),(0.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-6.0),(26.0,-5.2),(26.8,-5.2),(26.8,-6.0),(26.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-7.6),(27.6,-6.8),(28.4,-6.8),(28.4,-7.6),(27.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-9.2),(-17.2,-8.4),(-16.4,-8.4),(-16.4,-9.2),(-17.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-9.2),(13.2,-8.4),(14.0,-8.4),(14.0,-9.2),(13.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,19.6),(-2.8,20.4),(-2.0,20.4),(-2.0,19.6),(-2.8,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,6.8),(-2.8,7.6),(-2.0,7.6),(-2.0,6.8),(-2.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-26.8),(10.0,-26.0),(10.8,-26.0),(10.8,-26.8),(10.0,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-23.6),(8.4,-22.8),(9.2,-22.8),(9.2,-23.6),(8.4,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-10.8),(3.6,-10.0),(4.4,-10.0),(4.4,-10.8),(3.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-22.0),(-1.2,-21.2),(-0.4,-21.2),(-0.4,-22.0),(-1.2,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,24.4),(-2.8,25.2),(-2.0,25.2),(-2.0,24.4),(-2.8,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,0.4),(-31.6,1.2),(-30.8,1.2),(-30.8,0.4),(-31.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-7.6),(-10.8,-6.8),(-10.0,-6.8),(-10.0,-7.6),(-10.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,18.0),(13.2,18.8),(14.0,18.8),(14.0,18.0),(13.2,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,18.0),(-9.2,18.8),(-8.4,18.8),(-8.4,18.0),(-9.2,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,13.2),(11.6,14.0),(12.4,14.0),(12.4,13.2),(11.6,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,22.8),(-4.4,23.6),(-3.6,23.6),(-3.6,22.8),(-4.4,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-1.2),(-30.0,-0.4),(-29.2,-0.4),(-29.2,-1.2),(-30.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-17.2),(14.8,-16.4),(15.6,-16.4),(15.6,-17.2),(14.8,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-15.6),(-25.2,-14.8),(-24.4,-14.8),(-24.4,-15.6),(-25.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,10.0),(-25.2,10.8),(-24.4,10.8),(-24.4,10.0),(-25.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,6.8),(-15.6,7.6),(-14.8,7.6),(-14.8,6.8),(-15.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-18.8),(-12.4,-18.0),(-11.6,-18.0),(-11.6,-18.8),(-12.4,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-25.2),(3.6,-24.4),(4.4,-24.4),(4.4,-25.2),(3.6,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-15.6),(18.0,-14.8),(18.8,-14.8),(18.8,-15.6),(18.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-2.8),(-6.0,-2.0),(-5.2,-2.0),(-5.2,-2.8),(-6.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,3.6),(-18.8,4.4),(-18.0,4.4),(-18.0,3.6),(-18.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-1.2),(26.0,-0.4),(26.8,-0.4),(26.8,-1.2),(26.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-25.2),(-2.8,-24.4),(-2.0,-24.4),(-2.0,-25.2),(-2.8,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-10.8),(24.4,-10.0),(25.2,-10.0),(25.2,-10.8),(24.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-7.6),(-23.6,-6.8),(-22.8,-6.8),(-22.8,-7.6),(-23.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-12.4),(-17.2,-11.6),(-16.4,-11.6),(-16.4,-12.4),(-17.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,8.4),(-18.8,9.2),(-18.0,9.2),(-18.0,8.4),(-18.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-12.4),(-28.4,-11.6),(-27.6,-11.6),(-27.6,-12.4),(-28.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-20.4),(5.2,-19.6),(6.0,-19.6),(6.0,-20.4),(5.2,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,14.8),(16.4,15.6),(17.2,15.6),(17.2,14.8),(16.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,16.4),(16.4,17.2),(17.2,17.2),(17.2,16.4),(16.4,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,8.4),(-25.2,9.2),(-24.4,9.2),(-24.4,8.4),(-25.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,8.4),(18.0,9.2),(18.8,9.2),(18.8,8.4),(18.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,2.0),(26.0,2.8),(26.8,2.8),(26.8,2.0),(26.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,11.6),(27.6,12.4),(28.4,12.4),(28.4,11.6),(27.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-2.8),(-20.4,-2.0),(-19.6,-2.0),(-19.6,-2.8),(-20.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,8.4),(-10.8,9.2),(-10.0,9.2),(-10.0,8.4),(-10.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,14.8),(8.4,15.6),(9.2,15.6),(9.2,14.8),(8.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,5.2),(-23.6,6.0),(-22.8,6.0),(-22.8,5.2),(-23.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-20.4),(-14.0,-19.6),(-13.2,-19.6),(-13.2,-20.4),(-14.0,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-9.2),(-18.8,-8.4),(-18.0,-8.4),(-18.0,-9.2),(-18.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,-1.2),(32.4,-0.4),(33.2,-0.4),(33.2,-1.2),(32.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,11.6),(-12.4,12.4),(-11.6,12.4),(-11.6,11.6),(-12.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,22.8),(-2.8,23.6),(-2.0,23.6),(-2.0,22.8),(-2.8,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-14.0),(-23.6,-13.2),(-22.8,-13.2),(-22.8,-14.0),(-23.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-20.4),(14.8,-19.6),(15.6,-19.6),(15.6,-20.4),(14.8,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-7.6),(8.4,-6.8),(9.2,-6.8),(9.2,-7.6),(8.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,6.8),(6.8,7.6),(7.6,7.6),(7.6,6.8),(6.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-22.0),(19.6,-21.2),(20.4,-21.2),(20.4,-22.0),(19.6,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,16.4),(2.0,17.2),(2.8,17.2),(2.8,16.4),(2.0,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,10.0),(-26.8,10.8),(-26.0,10.8),(-26.0,10.0),(-26.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,10.0),(-4.4,10.8),(-3.6,10.8),(-3.6,10.0),(-4.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,11.6),(5.2,12.4),(6.0,12.4),(6.0,11.6),(5.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,22.8),(11.6,23.6),(12.4,23.6),(12.4,22.8),(11.6,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-9.2),(-10.8,-8.4),(-10.0,-8.4),(-10.0,-9.2),(-10.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,6.8),(-4.4,7.6),(-3.6,7.6),(-3.6,6.8),(-4.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-9.2),(-30.0,-8.4),(-29.2,-8.4),(-29.2,-9.2),(-30.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-18.8),(-2.8,-18.0),(-2.0,-18.0),(-2.0,-18.8),(-2.8,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-9.2),(-9.2,-8.4),(-8.4,-8.4),(-8.4,-9.2),(-9.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-9.2),(5.2,-8.4),(6.0,-8.4),(6.0,-9.2),(5.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-4.4),(-30.0,-3.6),(-29.2,-3.6),(-29.2,-4.4),(-30.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-4.4),(30.8,-3.6),(31.6,-3.6),(31.6,-4.4),(30.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,18.0),(-20.4,18.8),(-19.6,18.8),(-19.6,18.0),(-20.4,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-10.8),(-1.2,-10.0),(-0.4,-10.0),(-0.4,-10.8),(-1.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,21.2),(-20.4,22.0),(-19.6,22.0),(-19.6,21.2),(-20.4,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-2.8),(-17.2,-2.0),(-16.4,-2.0),(-16.4,-2.8),(-17.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-17.2),(-4.4,-16.4),(-3.6,-16.4),(-3.6,-17.2),(-4.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,14.8),(0.4,15.6),(1.2,15.6),(1.2,14.8),(0.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,0.4),(16.4,1.2),(17.2,1.2),(17.2,0.4),(16.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-23.6),(-12.4,-22.8),(-11.6,-22.8),(-11.6,-23.6),(-12.4,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,13.2),(16.4,14.0),(17.2,14.0),(17.2,13.2),(16.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,6.8),(19.6,7.6),(20.4,7.6),(20.4,6.8),(19.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,2.0),(6.8,2.8),(7.6,2.8),(7.6,2.0),(6.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,13.2),(3.6,14.0),(4.4,14.0),(4.4,13.2),(3.6,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,13.2),(21.2,14.0),(22.0,14.0),(22.0,13.2),(21.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-2.8),(-18.8,-2.0),(-18.0,-2.0),(-18.0,-2.8),(-18.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,0.4),(-7.6,1.2),(-6.8,1.2),(-6.8,0.4),(-7.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-25.2),(-1.2,-24.4),(-0.4,-24.4),(-0.4,-25.2),(-1.2,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-18.8),(6.8,-18.0),(7.6,-18.0),(7.6,-18.8),(6.8,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,13.2),(8.4,14.0),(9.2,14.0),(9.2,13.2),(8.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-23.6),(5.2,-22.8),(6.0,-22.8),(6.0,-23.6),(5.2,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,16.4),(-12.4,17.2),(-11.6,17.2),(-11.6,16.4),(-12.4,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,2.0),(24.4,2.8),(25.2,2.8),(25.2,2.0),(24.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-22.0),(-9.2,-21.2),(-8.4,-21.2),(-8.4,-22.0),(-9.2,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-12.4),(-9.2,-11.6),(-8.4,-11.6),(-8.4,-12.4),(-9.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-1.2),(-20.4,-0.4),(-19.6,-0.4),(-19.6,-1.2),(-20.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-12.4),(-20.4,-11.6),(-19.6,-11.6),(-19.6,-12.4),(-20.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,16.4),(21.2,17.2),(22.0,17.2),(22.0,16.4),(21.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-18.8),(-14.0,-18.0),(-13.2,-18.0),(-13.2,-18.8),(-14.0,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,0.4),(-25.2,1.2),(-24.4,1.2),(-24.4,0.4),(-25.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,6.8),(-28.4,7.6),(-27.6,7.6),(-27.6,6.8),(-28.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-1.2),(14.8,-0.4),(15.6,-0.4),(15.6,-1.2),(14.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,11.6),(19.6,12.4),(20.4,12.4),(20.4,11.6),(19.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,0.4),(-30.0,1.2),(-29.2,1.2),(-29.2,0.4),(-30.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,0.4),(30.8,1.2),(31.6,1.2),(31.6,0.4),(30.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-14.0),(27.6,-13.2),(28.4,-13.2),(28.4,-14.0),(27.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,3.6),(6.8,4.4),(7.6,4.4),(7.6,3.6),(6.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-2.8),(13.2,-2.0),(14.0,-2.0),(14.0,-2.8),(13.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,11.6),(-4.4,12.4),(-3.6,12.4),(-3.6,11.6),(-4.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-26.8),(-7.6,-26.0),(-6.8,-26.0),(-6.8,-26.8),(-7.6,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-1.2),(-6.0,-0.4),(-5.2,-0.4),(-5.2,-1.2),(-6.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,13.2),(-12.4,14.0),(-11.6,14.0),(-11.6,13.2),(-12.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,22.8),(-6.0,23.6),(-5.2,23.6),(-5.2,22.8),(-6.0,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,11.6),(16.4,12.4),(17.2,12.4),(17.2,11.6),(16.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,26.0),(-15.6,26.8),(-14.8,26.8),(-14.8,26.0),(-15.6,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,22.8),(8.4,23.6),(9.2,23.6),(9.2,22.8),(8.4,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-2.8),(26.0,-2.0),(26.8,-2.0),(26.8,-2.8),(26.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-7.6),(-12.4,-6.8),(-11.6,-6.8),(-11.6,-7.6),(-12.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,13.2),(0.4,14.0),(1.2,14.0),(1.2,13.2),(0.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-2.8),(-30.0,-2.0),(-29.2,-2.0),(-29.2,-2.8),(-30.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-15.6),(22.8,-14.8),(23.6,-14.8),(23.6,-15.6),(22.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,13.2),(-17.2,14.0),(-16.4,14.0),(-16.4,13.2),(-17.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,-4.4),(32.4,-3.6),(33.2,-3.6),(33.2,-4.4),(32.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-20.4),(2.0,-19.6),(2.8,-19.6),(2.8,-20.4),(2.0,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-14.0),(2.0,-13.2),(2.8,-13.2),(2.8,-14.0),(2.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-1.2),(5.2,-0.4),(6.0,-0.4),(6.0,-1.2),(5.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,22.8),(14.8,23.6),(15.6,23.6),(15.6,22.8),(14.8,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-20.4),(-1.2,-19.6),(-0.4,-19.6),(-0.4,-20.4),(-1.2,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,2.0),(3.6,2.8),(4.4,2.8),(4.4,2.0),(3.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,11.6),(-7.6,12.4),(-6.8,12.4),(-6.8,11.6),(-7.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,11.6),(8.4,12.4),(9.2,12.4),(9.2,11.6),(8.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,26.0),(-1.2,26.8),(-0.4,26.8),(-0.4,26.0),(-1.2,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-22.0),(-6.0,-21.2),(-5.2,-21.2),(-5.2,-22.0),(-6.0,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-17.2),(-10.8,-16.4),(-10.0,-16.4),(-10.0,-17.2),(-10.8,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-25.2),(16.4,-24.4),(17.2,-24.4),(17.2,-25.2),(16.4,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-4.4),(8.4,-3.6),(9.2,-3.6),(9.2,-4.4),(8.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,0.4),(-28.4,1.2),(-27.6,1.2),(-27.6,0.4),(-28.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-18.8),(3.6,-18.0),(4.4,-18.0),(4.4,-18.8),(3.6,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-1.2),(29.2,-0.4),(30.0,-0.4),(30.0,-1.2),(29.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,13.2),(-22.0,14.0),(-21.2,14.0),(-21.2,13.2),(-22.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,14.8),(2.0,15.6),(2.8,15.6),(2.8,14.8),(2.0,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,11.6),(-6.0,12.4),(-5.2,12.4),(-5.2,11.6),(-6.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-23.6),(-6.0,-22.8),(-5.2,-22.8),(-5.2,-23.6),(-6.0,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-26.8),(0.4,-26.0),(1.2,-26.0),(1.2,-26.8),(0.4,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-18.8),(8.4,-18.0),(9.2,-18.0),(9.2,-18.8),(8.4,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,6.8),(30.8,7.6),(31.6,7.6),(31.6,6.8),(30.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,24.4),(-15.6,25.2),(-14.8,25.2),(-14.8,24.4),(-15.6,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,22.8),(16.4,23.6),(17.2,23.6),(17.2,22.8),(16.4,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-26.8),(-6.0,-26.0),(-5.2,-26.0),(-5.2,-26.8),(-6.0,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-12.4),(-22.0,-11.6),(-21.2,-11.6),(-21.2,-12.4),(-22.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-12.4),(22.8,-11.6),(23.6,-11.6),(23.6,-12.4),(22.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-25.2),(2.0,-24.4),(2.8,-24.4),(2.8,-25.2),(2.0,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-14.0),(-26.8,-13.2),(-26.0,-13.2),(-26.0,-14.0),(-26.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-12.4),(-7.6,-11.6),(-6.8,-11.6),(-6.8,-12.4),(-7.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,10.0),(13.2,10.8),(14.0,10.8),(14.0,10.0),(13.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,11.6),(0.4,12.4),(1.2,12.4),(1.2,11.6),(0.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-4.4),(13.2,-3.6),(14.0,-3.6),(14.0,-4.4),(13.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-7.6),(26.0,-6.8),(26.8,-6.8),(26.8,-7.6),(26.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-2.8),(14.8,-2.0),(15.6,-2.0),(15.6,-2.8),(14.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,5.2),(-18.8,6.0),(-18.0,6.0),(-18.0,5.2),(-18.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,8.4),(27.6,9.2),(28.4,9.2),(28.4,8.4),(27.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-14.0),(-15.6,-13.2),(-14.8,-13.2),(-14.8,-14.0),(-15.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,6.8),(29.2,7.6),(30.0,7.6),(30.0,6.8),(29.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-4.4),(-1.2,-3.6),(-0.4,-3.6),(-0.4,-4.4),(-1.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,16.4),(-14.0,17.2),(-13.2,17.2),(-13.2,16.4),(-14.0,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-20.4),(11.6,-19.6),(12.4,-19.6),(12.4,-20.4),(11.6,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,16.4),(14.8,17.2),(15.6,17.2),(15.6,16.4),(14.8,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-14.0),(19.6,-13.2),(20.4,-13.2),(20.4,-14.0),(19.6,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,8.4),(-31.6,9.2),(-30.8,9.2),(-30.8,8.4),(-31.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,2.0),(27.6,2.8),(28.4,2.8),(28.4,2.0),(27.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-6.0),(-6.0,-5.2),(-5.2,-5.2),(-5.2,-6.0),(-6.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,2.0),(30.8,2.8),(31.6,2.8),(31.6,2.0),(30.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,-2.8),(32.4,-2.0),(33.2,-2.0),(33.2,-2.8),(32.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-14.0),(24.4,-13.2),(25.2,-13.2),(25.2,-14.0),(24.4,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,13.2),(-4.4,14.0),(-3.6,14.0),(-3.6,13.2),(-4.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-6.0),(-4.4,-5.2),(-3.6,-5.2),(-3.6,-6.0),(-4.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,19.6),(14.8,20.4),(15.6,20.4),(15.6,19.6),(14.8,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,18.0),(21.2,18.8),(22.0,18.8),(22.0,18.0),(21.2,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-1.2),(10.0,-0.4),(10.8,-0.4),(10.8,-1.2),(10.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-9.2),(10.0,-8.4),(10.8,-8.4),(10.8,-9.2),(10.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,13.2),(-9.2,14.0),(-8.4,14.0),(-8.4,13.2),(-9.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-2.8),(8.4,-2.0),(9.2,-2.0),(9.2,-2.8),(8.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,26.0),(-6.0,26.8),(-5.2,26.8),(-5.2,26.0),(-6.0,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,6.8),(-14.0,7.6),(-13.2,7.6),(-13.2,6.8),(-14.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,3.6),(2.0,4.4),(2.8,4.4),(2.8,3.6),(2.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-18.8),(-20.4,-18.0),(-19.6,-18.0),(-19.6,-18.8),(-20.4,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,18.0),(10.0,18.8),(10.8,18.8),(10.8,18.0),(10.0,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,0.4),(24.4,1.2),(25.2,1.2),(25.2,0.4),(24.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-1.2),(-17.2,-0.4),(-16.4,-0.4),(-16.4,-1.2),(-17.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-17.2),(-9.2,-16.4),(-8.4,-16.4),(-8.4,-17.2),(-9.2,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,21.2),(10.0,22.0),(10.8,22.0),(10.8,21.2),(10.0,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,13.2),(18.0,14.0),(18.8,14.0),(18.8,13.2),(18.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-17.2),(0.4,-16.4),(1.2,-16.4),(1.2,-17.2),(0.4,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,10.0),(-30.0,10.8),(-29.2,10.8),(-29.2,10.0),(-30.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-18.8),(-1.2,-18.0),(-0.4,-18.0),(-0.4,-18.8),(-1.2,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,3.6),(30.8,4.4),(31.6,4.4),(31.6,3.6),(30.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,6.8),(-9.2,7.6),(-8.4,7.6),(-8.4,6.8),(-9.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,8.4),(29.2,9.2),(30.0,9.2),(30.0,8.4),(29.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,2.0),(-15.6,2.8),(-14.8,2.8),(-14.8,2.0),(-15.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-4.4),(11.6,-3.6),(12.4,-3.6),(12.4,-4.4),(11.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,14.8),(-7.6,15.6),(-6.8,15.6),(-6.8,14.8),(-7.6,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,-7.6),(-34.8,-6.8),(-34.0,-6.8),(-34.0,-7.6),(-34.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-1.2),(19.6,-0.4),(20.4,-0.4),(20.4,-1.2),(19.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,8.4),(21.2,9.2),(22.0,9.2),(22.0,8.4),(21.2,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,19.6),(13.2,20.4),(14.0,20.4),(14.0,19.6),(13.2,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,5.2),(24.4,6.0),(25.2,6.0),(25.2,5.2),(24.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,11.6),(-26.8,12.4),(-26.0,12.4),(-26.0,11.6),(-26.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-7.6),(-14.0,-6.8),(-13.2,-6.8),(-13.2,-7.6),(-14.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,10.0),(5.2,10.8),(6.0,10.8),(6.0,10.0),(5.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-7.6),(13.2,-6.8),(14.0,-6.8),(14.0,-7.6),(13.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,19.6),(-9.2,20.4),(-8.4,20.4),(-8.4,19.6),(-9.2,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-6.0),(-17.2,-5.2),(-16.4,-5.2),(-16.4,-6.0),(-17.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,24.4),(-6.0,25.2),(-5.2,25.2),(-5.2,24.4),(-6.0,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,24.4),(6.8,25.2),(7.6,25.2),(7.6,24.4),(6.8,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-6.0),(-28.4,-5.2),(-27.6,-5.2),(-27.6,-6.0),(-28.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-12.4),(29.2,-11.6),(30.0,-11.6),(30.0,-12.4),(29.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,8.4),(19.6,9.2),(20.4,9.2),(20.4,8.4),(19.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,2.0),(-22.0,2.8),(-21.2,2.8),(-21.2,2.0),(-22.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-7.6),(-9.2,-6.8),(-8.4,-6.8),(-8.4,-7.6),(-9.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,2.0),(-9.2,2.8),(-8.4,2.8),(-8.4,2.0),(-9.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,19.6),(2.0,20.4),(2.8,20.4),(2.8,19.6),(2.0,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,5.2),(14.8,6.0),(15.6,6.0),(15.6,5.2),(14.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,3.6),(21.2,4.4),(22.0,4.4),(22.0,3.6),(21.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-15.6),(14.8,-14.8),(15.6,-14.8),(15.6,-15.6),(14.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-2.8),(2.0,-2.0),(2.8,-2.0),(2.8,-2.8),(2.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-22.0),(8.4,-21.2),(9.2,-21.2),(9.2,-22.0),(8.4,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-15.6),(-7.6,-14.8),(-6.8,-14.8),(-6.8,-15.6),(-7.6,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-10.8),(-28.4,-10.0),(-27.6,-10.0),(-27.6,-10.8),(-28.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-12.4),(-26.8,-11.6),(-26.0,-11.6),(-26.0,-12.4),(-26.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-12.4),(26.0,-11.6),(26.8,-11.6),(26.8,-12.4),(26.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,6.8),(-33.2,7.6),(-32.4,7.6),(-32.4,6.8),(-33.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-1.2),(8.4,-0.4),(9.2,-0.4),(9.2,-1.2),(8.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-12.4),(2.0,-11.6),(2.8,-11.6),(2.8,-12.4),(2.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,-7.6),(32.4,-6.8),(33.2,-6.8),(33.2,-7.6),(32.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,13.2),(-14.0,14.0),(-13.2,14.0),(-13.2,13.2),(-14.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,13.2),(-7.6,14.0),(-6.8,14.0),(-6.8,13.2),(-7.6,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,16.4),(-20.4,17.2),(-19.6,17.2),(-19.6,16.4),(-20.4,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,14.8),(-12.4,15.6),(-11.6,15.6),(-11.6,14.8),(-12.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,3.6),(-9.2,4.4),(-8.4,4.4),(-8.4,3.6),(-9.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-25.2),(-6.0,-24.4),(-5.2,-24.4),(-5.2,-25.2),(-6.0,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-10.8),(-25.2,-10.0),(-24.4,-10.0),(-24.4,-10.8),(-25.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-2.8),(11.6,-2.0),(12.4,-2.0),(12.4,-2.8),(11.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,16.4),(-15.6,17.2),(-14.8,17.2),(-14.8,16.4),(-15.6,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-12.4),(14.8,-11.6),(15.6,-11.6),(15.6,-12.4),(14.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,-1.2),(34.0,-0.4),(34.8,-0.4),(34.8,-1.2),(34.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-6.0),(-30.0,-5.2),(-29.2,-5.2),(-29.2,-6.0),(-30.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-12.4),(-14.0,-11.6),(-13.2,-11.6),(-13.2,-12.4),(-14.0,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-22.0),(16.4,-21.2),(17.2,-21.2),(17.2,-22.0),(16.4,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,22.8),(13.2,23.6),(14.0,23.6),(14.0,22.8),(13.2,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,19.6),(-12.4,20.4),(-11.6,20.4),(-11.6,19.6),(-12.4,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-22.0),(-10.8,-21.2),(-10.0,-21.2),(-10.0,-22.0),(-10.8,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-4.4),(-25.2,-3.6),(-24.4,-3.6),(-24.4,-4.4),(-25.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,14.8),(11.6,15.6),(12.4,15.6),(12.4,14.8),(11.6,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,-7.6),(-33.2,-6.8),(-32.4,-6.8),(-32.4,-7.6),(-33.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,2.0),(-33.2,2.8),(-32.4,2.8),(-32.4,2.0),(-33.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-10.8),(-26.8,-10.0),(-26.0,-10.0),(-26.0,-10.8),(-26.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,24.4),(2.0,25.2),(2.8,25.2),(2.8,24.4),(2.0,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-17.2),(11.6,-16.4),(12.4,-16.4),(12.4,-17.2),(11.6,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,21.2),(14.8,22.0),(15.6,22.0),(15.6,21.2),(14.8,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((34.0,3.6),(34.0,4.4),(34.8,4.4),(34.8,3.6),(34.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,21.2),(13.2,22.0),(14.0,22.0),(14.0,21.2),(13.2,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-18.8),(2.0,-18.0),(2.8,-18.0),(2.8,-18.8),(2.0,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-9.2),(16.4,-8.4),(17.2,-8.4),(17.2,-9.2),(16.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,3.6),(35.6,4.4),(36.4,4.4),(36.4,3.6),(35.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-22.0),(3.6,-21.2),(4.4,-21.2),(4.4,-22.0),(3.6,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,18.0),(0.4,18.8),(1.2,18.8),(1.2,18.0),(0.4,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,0.4),(0.4,1.2),(1.2,1.2),(1.2,0.4),(0.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,11.6),(22.8,12.4),(23.6,12.4),(23.6,11.6),(22.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,3.6),(-20.4,4.4),(-19.6,4.4),(-19.6,3.6),(-20.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-9.2),(8.4,-8.4),(9.2,-8.4),(9.2,-9.2),(8.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,14.8),(-18.8,15.6),(-18.0,15.6),(-18.0,14.8),(-18.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,21.2),(11.6,22.0),(12.4,22.0),(12.4,21.2),(11.6,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-14.0),(18.0,-13.2),(18.8,-13.2),(18.8,-14.0),(18.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,6.8),(21.2,7.6),(22.0,7.6),(22.0,6.8),(21.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,6.8),(16.4,7.6),(17.2,7.6),(17.2,6.8),(16.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,2.0),(-18.8,2.8),(-18.0,2.8),(-18.0,2.0),(-18.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-10.8),(21.2,-10.0),(22.0,-10.0),(22.0,-10.8),(21.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,18.0),(-4.4,18.8),(-3.6,18.8),(-3.6,18.0),(-4.4,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,0.4),(-36.4,1.2),(-35.6,1.2),(-35.6,0.4),(-36.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,-6.0),(-34.8,-5.2),(-34.0,-5.2),(-34.0,-6.0),(-34.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,3.6),(-33.2,4.4),(-32.4,4.4),(-32.4,3.6),(-33.2,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,21.2),(-4.4,22.0),(-3.6,22.0),(-3.6,21.2),(-4.4,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,14.8),(-10.8,15.6),(-10.0,15.6),(-10.0,14.8),(-10.8,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-6.0),(-7.6,-5.2),(-6.8,-5.2),(-6.8,-6.0),(-7.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-9.2),(-6.0,-8.4),(-5.2,-8.4),(-5.2,-9.2),(-6.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,19.6),(11.6,20.4),(12.4,20.4),(12.4,19.6),(11.6,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,0.4),(-15.6,1.2),(-14.8,1.2),(-14.8,0.4),(-15.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-10.8),(-20.4,-10.0),(-19.6,-10.0),(-19.6,-10.8),(-20.4,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-4.4),(-4.4,-3.6),(-3.6,-3.6),(-3.6,-4.4),(-4.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,8.4),(10.0,9.2),(10.8,9.2),(10.8,8.4),(10.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-15.6),(-20.4,-14.8),(-19.6,-14.8),(-19.6,-15.6),(-20.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-1.2),(-2.8,-0.4),(-2.0,-0.4),(-2.0,-1.2),(-2.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,2.0),(-12.4,2.8),(-11.6,2.8),(-11.6,2.0),(-12.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,13.2),(-1.2,14.0),(-0.4,14.0),(-0.4,13.2),(-1.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-6.0),(14.8,-5.2),(15.6,-5.2),(15.6,-6.0),(14.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-6.0),(-10.8,-5.2),(-10.0,-5.2),(-10.0,-6.0),(-10.8,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,8.4),(-28.4,9.2),(-27.6,9.2),(-27.6,8.4),(-28.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,18.0),(-23.6,18.8),(-22.8,18.8),(-22.8,18.0),(-23.6,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-15.6),(-18.8,-14.8),(-18.0,-14.8),(-18.0,-15.6),(-18.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-9.2),(0.4,-8.4),(1.2,-8.4),(1.2,-9.2),(0.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,5.2),(13.2,6.0),(14.0,6.0),(14.0,5.2),(13.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,14.8),(-4.4,15.6),(-3.6,15.6),(-3.6,14.8),(-4.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-20.4),(-7.6,-19.6),(-6.8,-19.6),(-6.8,-20.4),(-7.6,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-1.2),(-28.4,-0.4),(-27.6,-0.4),(-27.6,-1.2),(-28.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-9.2),(-28.4,-8.4),(-27.6,-8.4),(-27.6,-9.2),(-28.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-15.6),(-10.8,-14.8),(-10.0,-14.8),(-10.0,-15.6),(-10.8,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,16.4),(5.2,17.2),(6.0,17.2),(6.0,16.4),(5.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,10.0),(29.2,10.8),(30.0,10.8),(30.0,10.0),(29.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,14.8),(3.6,15.6),(4.4,15.6),(4.4,14.8),(3.6,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,5.2),(11.6,6.0),(12.4,6.0),(12.4,5.2),(11.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-20.4),(19.6,-19.6),(20.4,-19.6),(20.4,-20.4),(19.6,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,6.8),(0.4,7.6),(1.2,7.6),(1.2,6.8),(0.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-9.2),(18.0,-8.4),(18.8,-8.4),(18.8,-9.2),(18.0,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-6.0),(21.2,-5.2),(22.0,-5.2),(22.0,-6.0),(21.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,3.6),(11.6,4.4),(12.4,4.4),(12.4,3.6),(11.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,19.6),(-7.6,20.4),(-6.8,20.4),(-6.8,19.6),(-7.6,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,21.2),(-6.0,22.0),(-5.2,22.0),(-5.2,21.2),(-6.0,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-4.4),(-28.4,-3.6),(-27.6,-3.6),(-27.6,-4.4),(-28.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,18.0),(2.0,18.8),(2.8,18.8),(2.8,18.0),(2.0,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,10.0),(26.0,10.8),(26.8,10.8),(26.8,10.0),(26.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,21.2),(2.0,22.0),(2.8,22.0),(2.8,21.2),(2.0,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,24.4),(-17.2,25.2),(-16.4,25.2),(-16.4,24.4),(-17.2,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-14.0),(-22.0,-13.2),(-21.2,-13.2),(-21.2,-14.0),(-22.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,13.2),(-26.8,14.0),(-26.0,14.0),(-26.0,13.2),(-26.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-22.0),(14.8,-21.2),(15.6,-21.2),(15.6,-22.0),(14.8,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-20.4),(0.4,-19.6),(1.2,-19.6),(1.2,-20.4),(0.4,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,18.0),(-1.2,18.8),(-0.4,18.8),(-0.4,18.0),(-1.2,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,10.0),(2.0,10.8),(2.8,10.8),(2.8,10.0),(2.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-15.6),(16.4,-14.8),(17.2,-14.8),(17.2,-15.6),(16.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,-4.4),(35.6,-3.6),(36.4,-3.6),(36.4,-4.4),(35.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-9.2),(30.8,-8.4),(31.6,-8.4),(31.6,-9.2),(30.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-10.8),(22.8,-10.0),(23.6,-10.0),(23.6,-10.8),(22.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-6.0),(10.0,-5.2),(10.8,-5.2),(10.8,-6.0),(10.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-15.6),(8.4,-14.8),(9.2,-14.8),(9.2,-15.6),(8.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,0.4),(-33.2,1.2),(-32.4,1.2),(-32.4,0.4),(-33.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,3.6),(-10.8,4.4),(-10.0,4.4),(-10.0,3.6),(-10.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-7.6),(6.8,-6.8),(7.6,-6.8),(7.6,-7.6),(6.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-26.8),(-15.6,-26.0),(-14.8,-26.0),(-14.8,-26.8),(-15.6,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,8.4),(-20.4,9.2),(-19.6,9.2),(-19.6,8.4),(-20.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-22.0),(-15.6,-21.2),(-14.8,-21.2),(-14.8,-22.0),(-15.6,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-15.6),(-1.2,-14.8),(-0.4,-14.8),(-0.4,-15.6),(-1.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,10.0),(-1.2,10.8),(-0.4,10.8),(-0.4,10.0),(-1.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,3.6),(16.4,4.4),(17.2,4.4),(17.2,3.6),(16.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-23.6),(11.6,-22.8),(12.4,-22.8),(12.4,-23.6),(11.6,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,26.0),(-10.8,26.8),(-10.0,26.8),(-10.0,26.0),(-10.8,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-10.8),(27.6,-10.0),(28.4,-10.0),(28.4,-10.8),(27.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,14.8),(-22.0,15.6),(-21.2,15.6),(-21.2,14.8),(-22.0,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,3.6),(-7.6,4.4),(-6.8,4.4),(-6.8,3.6),(-7.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-9.2),(-20.4,-8.4),(-19.6,-8.4),(-19.6,-9.2),(-20.4,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,5.2),(-6.0,6.0),(-5.2,6.0),(-5.2,5.2),(-6.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,18.0),(11.6,18.8),(12.4,18.8),(12.4,18.0),(11.6,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-10.8),(-31.6,-10.0),(-30.8,-10.0),(-30.8,-10.8),(-31.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-4.4),(-15.6,-3.6),(-14.8,-3.6),(-14.8,-4.4),(-15.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-6.0),(-31.6,-5.2),(-30.8,-5.2),(-30.8,-6.0),(-31.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-15.6),(0.4,-14.8),(1.2,-14.8),(1.2,-15.6),(0.4,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,21.2),(-17.2,22.0),(-16.4,22.0),(-16.4,21.2),(-17.2,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-7.6),(19.6,-6.8),(20.4,-6.8),(20.4,-7.6),(19.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,16.4),(-23.6,17.2),(-22.8,17.2),(-22.8,16.4),(-23.6,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,10.0),(-2.8,10.8),(-2.0,10.8),(-2.0,10.0),(-2.8,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,3.6),(-6.0,4.4),(-5.2,4.4),(-5.2,3.6),(-6.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,6.8),(2.0,7.6),(2.8,7.6),(2.8,6.8),(2.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,11.6),(14.8,12.4),(15.6,12.4),(15.6,11.6),(14.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,8.4),(16.4,9.2),(17.2,9.2),(17.2,8.4),(16.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-26.8),(8.4,-26.0),(9.2,-26.0),(9.2,-26.8),(8.4,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-15.6),(21.2,-14.8),(22.0,-14.8),(22.0,-15.6),(21.2,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,10.0),(-23.6,10.8),(-22.8,10.8),(-22.8,10.0),(-23.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,10.0),(24.4,10.8),(25.2,10.8),(25.2,10.0),(24.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-6.0),(11.6,-5.2),(12.4,-5.2),(12.4,-6.0),(11.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,-2.8),(35.6,-2.0),(36.4,-2.0),(36.4,-2.8),(35.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-10.8),(18.0,-10.0),(18.8,-10.0),(18.8,-10.8),(18.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,0.4),(32.4,1.2),(33.2,1.2),(33.2,0.4),(32.4,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,8.4),(-7.6,9.2),(-6.8,9.2),(-6.8,8.4),(-7.6,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,8.4),(8.4,9.2),(9.2,9.2),(9.2,8.4),(8.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-1.2),(21.2,-0.4),(22.0,-0.4),(22.0,-1.2),(21.2,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,0.4),(-1.2,1.2),(-0.4,1.2),(-0.4,0.4),(-1.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-4.4),(-22.0,-3.6),(-21.2,-3.6),(-21.2,-4.4),(-22.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-4.4),(22.8,-3.6),(23.6,-3.6),(23.6,-4.4),(22.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,18.0),(5.2,18.8),(6.0,18.8),(6.0,18.0),(5.2,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-26.8),(-14.0,-26.0),(-13.2,-26.0),(-13.2,-26.8),(-14.0,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,24.4),(-9.2,25.2),(-8.4,25.2),(-8.4,24.4),(-9.2,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-17.2),(-23.6,-16.4),(-22.8,-16.4),(-22.8,-17.2),(-23.6,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-15.6),(-22.0,-14.8),(-21.2,-14.8),(-21.2,-15.6),(-22.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-6.0),(16.4,-5.2),(17.2,-5.2),(17.2,-6.0),(16.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-23.6),(16.4,-22.8),(17.2,-22.8),(17.2,-23.6),(16.4,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,3.6),(0.4,4.4),(1.2,4.4),(1.2,3.6),(0.4,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-18.8),(-4.4,-18.0),(-3.6,-18.0),(-3.6,-18.8),(-4.4,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,-2.8),(-34.8,-2.0),(-34.0,-2.0),(-34.0,-2.8),(-34.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,21.2),(-7.6,22.0),(-6.8,22.0),(-6.8,21.2),(-7.6,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-1.2),(16.4,-0.4),(17.2,-0.4),(17.2,-1.2),(16.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,5.2),(-12.4,6.0),(-11.6,6.0),(-11.6,5.2),(-12.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-12.4),(-1.2,-11.6),(-0.4,-11.6),(-0.4,-12.4),(-1.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,0.4),(-2.8,1.2),(-2.0,1.2),(-2.0,0.4),(-2.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,13.2),(22.8,14.0),(23.6,14.0),(23.6,13.2),(22.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,-2.8),(-10.8,-2.0),(-10.0,-2.0),(-10.0,-2.8),(-10.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-10.8),(29.2,-10.0),(30.0,-10.0),(30.0,-10.8),(29.2,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,10.0),(-28.4,10.8),(-27.6,10.8),(-27.6,10.0),(-28.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,-10.8),(-30.0,-10.0),(-29.2,-10.0),(-29.2,-10.8),(-30.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-1.2),(-23.6,-0.4),(-22.8,-0.4),(-22.8,-1.2),(-23.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-9.2),(-23.6,-8.4),(-22.8,-8.4),(-22.8,-9.2),(-23.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,19.6),(-20.4,20.4),(-19.6,20.4),(-19.6,19.6),(-20.4,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,5.2),(-17.2,6.0),(-16.4,6.0),(-16.4,5.2),(-17.2,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,10.0),(-6.0,10.8),(-5.2,10.8),(-5.2,10.0),(-6.0,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-12.4),(16.4,-11.6),(17.2,-11.6),(17.2,-12.4),(16.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,8.4),(0.4,9.2),(1.2,9.2),(1.2,8.4),(0.4,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,-9.2),(-33.2,-8.4),(-32.4,-8.4),(-32.4,-9.2),(-33.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-17.2),(19.6,-16.4),(20.4,-16.4),(20.4,-17.2),(19.6,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-23.6),(14.8,-22.8),(15.6,-22.8),(15.6,-23.6),(14.8,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-2.8),(-15.6,-2.0),(-14.8,-2.0),(-14.8,-2.8),(-15.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,-12.4),(8.4,-11.6),(9.2,-11.6),(9.2,-12.4),(8.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,-10.8),(19.6,-10.0),(20.4,-10.0),(20.4,-10.8),(19.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-7.6),(-26.8,-6.8),(-26.0,-6.8),(-26.0,-7.6),(-26.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,2.0),(-36.4,2.8),(-35.6,2.8),(-35.6,2.0),(-36.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,22.8),(3.6,23.6),(4.4,23.6),(4.4,22.8),(3.6,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,5.2),(18.0,6.0),(18.8,6.0),(18.8,5.2),(18.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-6.0),(0.4,-5.2),(1.2,-5.2),(1.2,-6.0),(0.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,11.6),(-17.2,12.4),(-16.4,12.4),(-16.4,11.6),(-17.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-15.6),(2.0,-14.8),(2.8,-14.8),(2.8,-15.6),(2.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,19.6),(0.4,20.4),(1.2,20.4),(1.2,19.6),(0.4,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-7.6),(-2.8,-6.8),(-2.0,-6.8),(-2.0,-7.6),(-2.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-2.8),(-22.0,-2.0),(-21.2,-2.0),(-21.2,-2.8),(-22.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-14.0),(-14.0,-13.2),(-13.2,-13.2),(-13.2,-14.0),(-14.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,21.2),(-10.8,22.0),(-10.0,22.0),(-10.0,21.2),(-10.8,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,-7.6),(30.8,-6.8),(31.6,-6.8),(31.6,-7.6),(30.8,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,2.0),(13.2,2.8),(14.0,2.8),(14.0,2.0),(13.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,19.6),(19.6,20.4),(20.4,20.4),(20.4,19.6),(19.6,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-2.8),(-9.2,-2.0),(-8.4,-2.0),(-8.4,-2.8),(-9.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,6.8),(-7.6,7.6),(-6.8,7.6),(-6.8,6.8),(-7.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,-15.6),(26.0,-14.8),(26.8,-14.8),(26.8,-15.6),(26.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-23.6),(-4.4,-22.8),(-3.6,-22.8),(-3.6,-23.6),(-4.4,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,19.6),(-14.0,20.4),(-13.2,20.4),(-13.2,19.6),(-14.0,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,13.2),(2.0,14.0),(2.8,14.0),(2.8,13.2),(2.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-10.8),(14.8,-10.0),(15.6,-10.0),(15.6,-10.8),(14.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-12.4),(0.4,-11.6),(1.2,-11.6),(1.2,-12.4),(0.4,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,14.8),(13.2,15.6),(14.0,15.6),(14.0,14.8),(13.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-7.6),(-15.6,-6.8),(-14.8,-6.8),(-14.8,-7.6),(-15.6,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,24.4),(-14.0,25.2),(-13.2,25.2),(-13.2,24.4),(-14.0,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,24.4),(14.8,25.2),(15.6,25.2),(15.6,24.4),(14.8,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,3.6),(-31.6,4.4),(-30.8,4.4),(-30.8,3.6),(-31.6,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,8.4),(26.0,9.2),(26.8,9.2),(26.8,8.4),(26.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-4.4),(-18.8,-3.6),(-18.0,-3.6),(-18.0,-4.4),(-18.8,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-4.4),(18.0,-3.6),(18.8,-3.6),(18.8,-4.4),(18.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,11.6),(10.0,12.4),(10.8,12.4),(10.8,11.6),(10.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,-2.8),(-36.4,-2.0),(-35.6,-2.0),(-35.6,-2.8),(-36.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,5.2),(-30.0,6.0),(-29.2,6.0),(-29.2,5.2),(-30.0,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,8.4),(-26.8,9.2),(-26.0,9.2),(-26.0,8.4),(-26.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-1.2),(-26.8,-0.4),(-26.0,-0.4),(-26.0,-1.2),(-26.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-9.2),(11.6,-8.4),(12.4,-8.4),(12.4,-9.2),(11.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,14.8),(24.4,15.6),(25.2,15.6),(25.2,14.8),(24.4,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,16.4),(-4.4,17.2),(-3.6,17.2),(-3.6,16.4),(-4.4,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-4.4),(10.0,-3.6),(10.8,-3.6),(10.8,-4.4),(10.0,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,11.6),(-28.4,12.4),(-27.6,12.4),(-27.6,11.6),(-28.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-18.8),(-15.6,-18.0),(-14.8,-18.0),(-14.8,-18.8),(-15.6,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-7.6),(24.4,-6.8),(25.2,-6.8),(25.2,-7.6),(24.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,6.8),(22.8,7.6),(23.6,7.6),(23.6,6.8),(22.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,18.0),(-10.8,18.8),(-10.0,18.8),(-10.0,18.0),(-10.8,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,3.6),(-30.0,4.4),(-29.2,4.4),(-29.2,3.6),(-30.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,10.0),(-20.4,10.8),(-19.6,10.8),(-19.6,10.0),(-20.4,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,0.4),(-9.2,1.2),(-8.4,1.2),(-8.4,0.4),(-9.2,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,5.2),(-15.6,6.0),(-14.8,6.0),(-14.8,5.2),(-15.6,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-14.0),(6.8,-13.2),(7.6,-13.2),(7.6,-14.0),(6.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-26.8,-9.2),(-26.8,-8.4),(-26.0,-8.4),(-26.0,-9.2),(-26.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,11.6),(21.2,12.4),(22.0,12.4),(22.0,11.6),(21.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-14.0),(-2.8,-13.2),(-2.0,-13.2),(-2.0,-14.0),(-2.8,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,6.8),(-20.4,7.6),(-19.6,7.6),(-19.6,6.8),(-20.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((2.0,-26.8),(2.0,-26.0),(2.8,-26.0),(2.8,-26.8),(2.0,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-30.0,8.4),(-30.0,9.2),(-29.2,9.2),(-29.2,8.4),(-30.0,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,14.8),(-14.0,15.6),(-13.2,15.6),(-13.2,14.8),(-14.0,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((30.8,8.4),(30.8,9.2),(31.6,9.2),(31.6,8.4),(30.8,8.4)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,26.0),(10.0,26.8),(10.8,26.8),(10.8,26.0),(10.0,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-23.6),(-1.2,-22.8),(-0.4,-22.8),(-0.4,-23.6),(-1.2,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-9.2),(-25.2,-8.4),(-24.4,-8.4),(-24.4,-9.2),(-25.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-2.8),(5.2,-2.0),(6.0,-2.0),(6.0,-2.8),(5.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,5.2),(-10.8,6.0),(-10.0,6.0),(-10.0,5.2),(-10.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,26.0),(11.6,26.8),(12.4,26.8),(12.4,26.0),(11.6,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,-9.2),(21.2,-8.4),(22.0,-8.4),(22.0,-9.2),(21.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,-2.8),(-33.2,-2.0),(-32.4,-2.0),(-32.4,-2.8),(-33.2,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-9.2),(29.2,-8.4),(30.0,-8.4),(30.0,-9.2),(29.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-7.6),(-4.4,-6.8),(-3.6,-6.8),(-3.6,-7.6),(-4.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,3.6),(26.0,4.4),(26.8,4.4),(26.8,3.6),(26.0,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,2.0),(22.8,2.8),(23.6,2.8),(23.6,2.0),(22.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,13.2),(19.6,14.0),(20.4,14.0),(20.4,13.2),(19.6,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-23.6),(-15.6,-22.8),(-14.8,-22.8),(-14.8,-23.6),(-15.6,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,10.0),(-15.6,10.8),(-14.8,10.8),(-14.8,10.0),(-15.6,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,11.6),(-9.2,12.4),(-8.4,12.4),(-8.4,11.6),(-9.2,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,0.4),(-23.6,1.2),(-22.8,1.2),(-22.8,0.4),(-23.6,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,18.0),(-18.8,18.8),(-18.0,18.8),(-18.0,18.0),(-18.8,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-18.8),(18.0,-18.0),(18.8,-18.0),(18.8,-18.8),(18.0,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,13.2),(24.4,14.0),(25.2,14.0),(25.2,13.2),(24.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-15.6),(-14.0,-14.8),(-13.2,-14.8),(-13.2,-15.6),(-14.0,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-10.8),(10.0,-10.0),(10.8,-10.0),(10.8,-10.8),(10.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-14.0),(13.2,-13.2),(14.0,-13.2),(14.0,-14.0),(13.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-12.4),(-25.2,-11.6),(-24.4,-11.6),(-24.4,-12.4),(-25.2,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-6.0),(-1.2,-5.2),(-0.4,-5.2),(-0.4,-6.0),(-1.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,-1.2),(-4.4,-0.4),(-3.6,-0.4),(-3.6,-1.2),(-4.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-4.4),(29.2,-3.6),(30.0,-3.6),(30.0,-4.4),(29.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,24.4),(11.6,25.2),(12.4,25.2),(12.4,24.4),(11.6,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,14.8),(5.2,15.6),(6.0,15.6),(6.0,14.8),(5.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-2.8),(-12.4,-2.0),(-11.6,-2.0),(-11.6,-2.8),(-12.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,22.8),(-15.6,23.6),(-14.8,23.6),(-14.8,22.8),(-15.6,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,16.4),(-10.8,17.2),(-10.0,17.2),(-10.0,16.4),(-10.8,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-9.2),(3.6,-8.4),(4.4,-8.4),(4.4,-9.2),(3.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,3.6),(22.8,4.4),(23.6,4.4),(23.6,3.6),(22.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,18.0),(-7.6,18.8),(-6.8,18.8),(-6.8,18.0),(-7.6,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,13.2),(14.8,14.0),(15.6,14.0),(15.6,13.2),(14.8,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((0.4,-1.2),(0.4,-0.4),(1.2,-0.4),(1.2,-1.2),(0.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,-9.2),(-15.6,-8.4),(-14.8,-8.4),(-14.8,-9.2),(-15.6,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,11.6),(-20.4,12.4),(-19.6,12.4),(-19.6,11.6),(-20.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,6.8),(-18.8,7.6),(-18.0,7.6),(-18.0,6.8),(-18.8,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,-1.2),(22.8,-0.4),(23.6,-0.4),(23.6,-1.2),(22.8,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-25.2),(6.8,-24.4),(7.6,-24.4),(7.6,-25.2),(6.8,-25.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,13.2),(-28.4,14.0),(-27.6,14.0),(-27.6,13.2),(-28.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,-18.8),(16.4,-18.0),(17.2,-18.0),(17.2,-18.8),(16.4,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-6.0),(18.0,-5.2),(18.8,-5.2),(18.8,-6.0),(18.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.6,-6.0),(35.6,-5.2),(36.4,-5.2),(36.4,-6.0),(35.6,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-4.4),(5.2,-3.6),(6.0,-3.6),(6.0,-4.4),(5.2,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-28.4,-7.6),(-28.4,-6.8),(-27.6,-6.8),(-27.6,-7.6),(-28.4,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,18.0),(19.6,18.8),(20.4,18.8),(20.4,18.0),(19.6,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,14.8),(-1.2,15.6),(-0.4,15.6),(-0.4,14.8),(-1.2,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-20.4),(-22.0,-19.6),(-21.2,-19.6),(-21.2,-20.4),(-22.0,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,11.6),(-2.8,12.4),(-2.0,12.4),(-2.0,11.6),(-2.8,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,-1.2),(-14.0,-0.4),(-13.2,-0.4),(-13.2,-1.2),(-14.0,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,18.0),(-14.0,18.8),(-13.2,18.8),(-13.2,18.0),(-14.0,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-20.4),(3.6,-19.6),(4.4,-19.6),(4.4,-20.4),(3.6,-20.4)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,2.0),(21.2,2.8),(22.0,2.8),(22.0,2.0),(21.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,11.6),(-23.6,12.4),(-22.8,12.4),(-22.8,11.6),(-23.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.6,2.0),(19.6,2.8),(20.4,2.8),(20.4,2.0),(19.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,6.8),(-31.6,7.6),(-30.8,7.6),(-30.8,6.8),(-31.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-23.6),(18.0,-22.8),(18.8,-22.8),(18.8,-23.6),(18.0,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,11.6),(24.4,12.4),(25.2,12.4),(25.2,11.6),(24.4,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,26.0),(3.6,26.8),(4.4,26.8),(4.4,26.0),(3.6,26.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-34.8,3.6),(-34.8,4.4),(-34.0,4.4),(-34.0,3.6),(-34.8,3.6)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-4.4),(24.4,-3.6),(25.2,-3.6),(25.2,-4.4),(24.4,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,5.2),(-36.4,6.0),(-35.6,6.0),(-35.6,5.2),(-36.4,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,16.4),(-18.8,17.2),(-18.0,17.2),(-18.0,16.4),(-18.8,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,16.4),(18.0,17.2),(18.8,17.2),(18.8,16.4),(18.0,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,-6.0),(29.2,-5.2),(30.0,-5.2),(30.0,-6.0),(29.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,11.6),(-22.0,12.4),(-21.2,12.4),(-21.2,11.6),(-22.0,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,6.8),(11.6,7.6),(12.4,7.6),(12.4,6.8),(11.6,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((11.6,-15.6),(11.6,-14.8),(12.4,-14.8),(12.4,-15.6),(11.6,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-12.4),(-2.8,-11.6),(-2.0,-11.6),(-2.0,-12.4),(-2.8,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,2.0),(18.0,2.8),(18.8,2.8),(18.8,2.0),(18.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,21.2),(8.4,22.0),(9.2,22.0),(9.2,21.2),(8.4,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-12.4),(-23.6,-11.6),(-22.8,-11.6),(-22.8,-12.4),(-23.6,-12.4)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-14.0),(5.2,-13.2),(6.0,-13.2),(6.0,-14.0),(5.2,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-9.2),(6.8,-8.4),(7.6,-8.4),(7.6,-9.2),(6.8,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,2.0),(10.0,2.8),(10.8,2.8),(10.8,2.0),(10.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-12.4,-22.0),(-12.4,-21.2),(-11.6,-21.2),(-11.6,-22.0),(-12.4,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,24.4),(3.6,25.2),(4.4,25.2),(4.4,24.4),(3.6,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-4.4),(3.6,-3.6),(4.4,-3.6),(4.4,-4.4),(3.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,-9.2),(-1.2,-8.4),(-0.4,-8.4),(-0.4,-9.2),(-1.2,-9.2)),
        )
        createRL(
            tech, net, 'via4',
            ((13.2,-26.8),(13.2,-26.0),(14.0,-26.0),(14.0,-26.8),(13.2,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-18.8),(-22.0,-18.0),(-21.2,-18.0),(-21.2,-18.8),(-22.0,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,-6.0),(-22.0,-5.2),(-21.2,-5.2),(-21.2,-6.0),(-22.0,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-31.6,-1.2),(-31.6,-0.4),(-30.8,-0.4),(-30.8,-1.2),(-31.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,19.6),(5.2,20.4),(6.0,20.4),(6.0,19.6),(5.2,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,-2.8),(6.8,-2.0),(7.6,-2.0),(7.6,-2.8),(6.8,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-7.6),(5.2,-6.8),(6.0,-6.8),(6.0,-7.6),(5.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,13.2),(-20.4,14.0),(-19.6,14.0),(-19.6,13.2),(-20.4,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-6.0),(-9.2,-5.2),(-8.4,-5.2),(-8.4,-6.0),(-9.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-36.4,-1.2),(-36.4,-0.4),(-35.6,-0.4),(-35.6,-1.2),(-36.4,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-20.4,-6.0),(-20.4,-5.2),(-19.6,-5.2),(-19.6,-6.0),(-20.4,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-10.8),(-2.8,-10.0),(-2.0,-10.0),(-2.0,-10.8),(-2.8,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,21.2),(16.4,22.0),(17.2,22.0),(17.2,21.2),(16.4,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,22.8),(-17.2,23.6),(-16.4,23.6),(-16.4,22.8),(-17.2,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,13.2),(-25.2,14.0),(-24.4,14.0),(-24.4,13.2),(-25.2,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-18.8),(-23.6,-18.0),(-22.8,-18.0),(-22.8,-18.8),(-23.6,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((24.4,-2.8),(24.4,-2.0),(25.2,-2.0),(25.2,-2.8),(24.4,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,16.4),(-7.6,17.2),(-6.8,17.2),(-6.8,16.4),(-7.6,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((32.4,6.8),(32.4,7.6),(33.2,7.6),(33.2,6.8),(32.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-10.8),(-7.6,-10.0),(-6.8,-10.0),(-6.8,-10.8),(-7.6,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-9.2,-26.8),(-9.2,-26.0),(-8.4,-26.0),(-8.4,-26.8),(-9.2,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,6.8),(-6.0,7.6),(-5.2,7.6),(-5.2,6.8),(-6.0,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,21.2),(6.8,22.0),(7.6,22.0),(7.6,21.2),(6.8,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,6.8),(8.4,7.6),(9.2,7.6),(9.2,6.8),(8.4,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,2.0),(-10.8,2.8),(-10.0,2.8),(-10.0,2.0),(-10.8,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((29.2,2.0),(29.2,2.8),(30.0,2.8),(30.0,2.0),(29.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,6.8),(-25.2,7.6),(-24.4,7.6),(-24.4,6.8),(-25.2,6.8)),
        )
        createRL(
            tech, net, 'via4',
            ((26.0,13.2),(26.0,14.0),(26.8,14.0),(26.8,13.2),(26.0,13.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,-17.2),(-7.6,-16.4),(-6.8,-16.4),(-6.8,-17.2),(-7.6,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((16.4,2.0),(16.4,2.8),(17.2,2.8),(17.2,2.0),(16.4,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.6,-4.4),(27.6,-3.6),(28.4,-3.6),(28.4,-4.4),(27.6,-4.4)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-15.6),(3.6,-14.8),(4.4,-14.8),(4.4,-15.6),(3.6,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-10.8,0.4),(-10.8,1.2),(-10.0,1.2),(-10.0,0.4),(-10.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,-23.6),(-17.2,-22.8),(-16.4,-22.8),(-16.4,-23.6),(-17.2,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,14.8),(-23.6,15.6),(-22.8,15.6),(-22.8,14.8),(-23.6,14.8)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-1.2),(3.6,-0.4),(4.4,-0.4),(4.4,-1.2),(3.6,-1.2)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,18.0),(-2.8,18.8),(-2.0,18.8),(-2.0,18.0),(-2.8,18.0)),
        )
        createRL(
            tech, net, 'via4',
            ((21.2,10.0),(21.2,10.8),(22.0,10.8),(22.0,10.0),(21.2,10.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-7.6,2.0),(-7.6,2.8),(-6.8,2.8),(-6.8,2.0),(-7.6,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-2.8),(3.6,-2.0),(4.4,-2.0),(4.4,-2.8),(3.6,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-23.6),(10.0,-22.8),(10.8,-22.8),(10.8,-23.6),(10.0,-23.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-33.2,-6.0),(-33.2,-5.2),(-32.4,-5.2),(-32.4,-6.0),(-33.2,-6.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-2.8,-26.8),(-2.8,-26.0),(-2.0,-26.0),(-2.0,-26.8),(-2.8,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,24.4),(-1.2,25.2),(-0.4,25.2),(-0.4,24.4),(-1.2,24.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-17.2,16.4),(-17.2,17.2),(-16.4,17.2),(-16.4,16.4),(-17.2,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-4.4,19.6),(-4.4,20.4),(-3.6,20.4),(-3.6,19.6),(-4.4,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-7.6),(-6.0,-6.8),(-5.2,-6.8),(-5.2,-7.6),(-6.0,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,22.8),(5.2,23.6),(6.0,23.6),(6.0,22.8),(5.2,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,-7.6),(-25.2,-6.8),(-24.4,-6.8),(-24.4,-7.6),(-25.2,-7.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-25.2,2.0),(-25.2,2.8),(-24.4,2.8),(-24.4,2.0),(-25.2,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((18.0,-2.8),(18.0,-2.0),(18.8,-2.0),(18.8,-2.8),(18.0,-2.8)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,-17.2),(3.6,-16.4),(4.4,-16.4),(4.4,-17.2),(3.6,-17.2)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,-26.8),(5.2,-26.0),(6.0,-26.0),(6.0,-26.8),(5.2,-26.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,-10.8),(-6.0,-10.0),(-5.2,-10.0),(-5.2,-10.8),(-6.0,-10.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-14.0,2.0),(-14.0,2.8),(-13.2,2.8),(-13.2,2.0),(-14.0,2.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-18.8,-22.0),(-18.8,-21.2),(-18.0,-21.2),(-18.0,-22.0),(-18.8,-22.0)),
        )
        createRL(
            tech, net, 'via4',
            ((5.2,21.2),(5.2,22.0),(6.0,22.0),(6.0,21.2),(5.2,21.2)),
        )
        createRL(
            tech, net, 'via4',
            ((10.0,-14.0),(10.0,-13.2),(10.8,-13.2),(10.8,-14.0),(10.0,-14.0)),
        )
        createRL(
            tech, net, 'via4',
            ((-23.6,-15.6),(-23.6,-14.8),(-22.8,-14.8),(-22.8,-15.6),(-23.6,-15.6)),
        )
        createRL(
            tech, net, 'via4',
            ((-6.0,0.4),(-6.0,1.2),(-5.2,1.2),(-5.2,0.4),(-6.0,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,0.4),(6.8,1.2),(7.6,1.2),(7.6,0.4),(6.8,0.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-22.0,16.4),(-22.0,17.2),(-21.2,17.2),(-21.2,16.4),(-22.0,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((22.8,16.4),(22.8,17.2),(23.6,17.2),(23.6,16.4),(22.8,16.4)),
        )
        createRL(
            tech, net, 'via4',
            ((-15.6,11.6),(-15.6,12.4),(-14.8,12.4),(-14.8,11.6),(-15.6,11.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.8,5.2),(6.8,6.0),(7.6,6.0),(7.6,5.2),(6.8,5.2)),
        )
        createRL(
            tech, net, 'via4',
            ((8.4,19.6),(8.4,20.4),(9.2,20.4),(9.2,19.6),(8.4,19.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.8,-18.8),(14.8,-18.0),(15.6,-18.0),(15.6,-18.8),(14.8,-18.8)),
        )
        createRL(
            tech, net, 'via4',
            ((-1.2,22.8),(-1.2,23.6),(-0.4,23.6),(-0.4,22.8),(-1.2,22.8)),
        )
        createRL(
            tech, net, 'via4',
            ((3.6,21.2),(3.6,22.0),(4.4,22.0),(4.4,21.2),(3.6,21.2)),
        )
        net = nets['*']
        createRL(
            tech, net, 'm1',
            ((-40.5,-31.0),(-40.5,31.0),(40.5,31.0),(40.5,-31.0),(-40.5,-31.0)),
        )
        createRL(
            tech, net, 'm2',
            ((-40.5,-31.0),(-40.5,31.0),(40.5,31.0),(40.5,-31.0),(-40.5,-31.0)),
        )
        createRL(
            tech, net, 'm3',
            ((-40.5,-31.0),(-40.5,31.0),(40.5,31.0),(40.5,-31.0),(-40.5,-31.0)),
        )
        createRL(
            tech, net, 'm4',
            ((-40.5,-31.0),(-40.5,31.0),(40.5,31.0),(40.5,-31.0),(-40.5,-31.0)),
        )
        createRL(
            tech, net, 'm5',
            ((-40.5,-31.0),(-40.5,31.0),(40.5,31.0),(40.5,-31.0),(-40.5,-31.0)),
        )
        nets['pad'].setDirection(Net.Direction.IN)

    cell = new_cells['GuardRing_N18000W4468HFF']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-45.0), u(-11.17), u(45.0), u(11.17),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'conn': Net.create(cell, 'conn'),
        }
        net = nets['conn']
        createRL(
            tech, net, 'difftap',
            ((-45.0,-11.17),(-45.0,-10.69),(45.0,-10.69),(45.0,-11.17),(-45.0,-11.17)),
        )
        createRL(
            tech, net, 'difftap',
            ((-45.0,10.69),(-45.0,11.17),(45.0,11.17),(45.0,10.69),(-45.0,10.69)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.52,-10.69),(44.52,10.69),(45.0,10.69),(45.0,-10.69),(44.52,-10.69)),
        )
        createRL(
            tech, net, 'difftap',
            ((-45.0,-10.69),(-45.0,10.69),(-44.52,10.69),(-44.52,-10.69),(-45.0,-10.69)),
        )
        createRL(
            tech, net, 'licon',
            ((3.825,-11.015),(3.825,-10.845),(3.995,-10.845),(3.995,-11.015),(3.825,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((3.145,-11.015),(3.145,-10.845),(3.315,-10.845),(3.315,-11.015),(3.145,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((3.485,-11.015),(3.485,-10.845),(3.655,-10.845),(3.655,-11.015),(3.485,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((33.745,-11.015),(33.745,-10.845),(33.915,-10.845),(33.915,-11.015),(33.745,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((33.065,-11.015),(33.065,-10.845),(33.235,-10.845),(33.235,-11.015),(33.065,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((2.125,-11.015),(2.125,-10.845),(2.295,-10.845),(2.295,-11.015),(2.125,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((2.465,-11.015),(2.465,-10.845),(2.635,-10.845),(2.635,-11.015),(2.465,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((2.805,-11.015),(2.805,-10.845),(2.975,-10.845),(2.975,-11.015),(2.805,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((33.405,-11.015),(33.405,-10.845),(33.575,-10.845),(33.575,-11.015),(33.405,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.855,10.845),(-30.855,11.015),(-30.685,11.015),(-30.685,10.845),(-30.855,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.515,10.845),(-30.515,11.015),(-30.345,11.015),(-30.345,10.845),(-30.515,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.175,10.845),(-30.175,11.015),(-30.005,11.015),(-30.005,10.845),(-30.175,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.625,10.845),(44.625,11.015),(44.795,11.015),(44.795,10.845),(44.625,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-10.115),(44.675,-9.945),(44.845,-9.945),(44.845,-10.115),(44.675,-10.115)),
        )
        createRL(
            tech, net, 'licon',
            ((44.285,10.845),(44.285,11.015),(44.455,11.015),(44.455,10.845),(44.285,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.935,-11.015),(-34.935,-10.845),(-34.765,-10.845),(-34.765,-11.015),(-34.935,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.595,-11.015),(-34.595,-10.845),(-34.425,-10.845),(-34.425,-11.015),(-34.595,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.255,-11.015),(-34.255,-10.845),(-34.085,-10.845),(-34.085,-11.015),(-34.255,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((6.885,10.845),(6.885,11.015),(7.055,11.015),(7.055,10.845),(6.885,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.925,-11.015),(42.925,-10.845),(43.095,-10.845),(43.095,-11.015),(42.925,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.815,10.845),(-11.815,11.015),(-11.645,11.015),(-11.645,10.845),(-11.815,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.475,10.845),(-11.475,11.015),(-11.305,11.015),(-11.305,10.845),(-11.475,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.305,10.845),(11.305,11.015),(11.475,11.015),(11.475,10.845),(11.305,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.645,10.845),(11.645,11.015),(11.815,11.015),(11.815,10.845),(11.645,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,7.905),(44.675,8.075),(44.845,8.075),(44.845,7.905),(44.675,7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-7.055),(44.675,-6.885),(44.845,-6.885),(44.845,-7.055),(44.675,-7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.715,10.845),(-23.715,11.015),(-23.545,11.015),(-23.545,10.845),(-23.715,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.985,-11.015),(28.985,-10.845),(29.155,-10.845),(29.155,-11.015),(28.985,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.375,10.845),(-23.375,11.015),(-23.205,11.015),(-23.205,10.845),(-23.375,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.075,10.845),(-42.075,11.015),(-41.905,11.015),(-41.905,10.845),(-42.075,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.205,10.845),(23.205,11.015),(23.375,11.015),(23.375,10.845),(23.205,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.545,10.845),(23.545,11.015),(23.715,11.015),(23.715,10.845),(23.545,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.735,-11.015),(-7.735,-10.845),(-7.565,-10.845),(-7.565,-11.015),(-7.735,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.395,-11.015),(-7.395,-10.845),(-7.225,-10.845),(-7.225,-11.015),(-7.395,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,8.245),(-44.845,8.415),(-44.675,8.415),(-44.675,8.245),(-44.845,8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,8.585),(-44.845,8.755),(-44.675,8.755),(-44.675,8.585),(-44.845,8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,8.245),(44.675,8.415),(44.845,8.415),(44.845,8.245),(44.675,8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.905,10.845),(7.905,11.015),(8.075,11.015),(8.075,10.845),(7.905,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,8.585),(44.675,8.755),(44.845,8.755),(44.845,8.585),(44.675,8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.795,-11.015),(-27.795,-10.845),(-27.625,-10.845),(-27.625,-11.015),(-27.795,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.455,-11.015),(-27.455,-10.845),(-27.285,-10.845),(-27.285,-11.015),(-27.455,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((37.145,-11.015),(37.145,-10.845),(37.315,-10.845),(37.315,-11.015),(37.145,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((37.485,-11.015),(37.485,-10.845),(37.655,-10.845),(37.655,-11.015),(37.485,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((37.825,-11.015),(37.825,-10.845),(37.995,-10.845),(37.995,-11.015),(37.825,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((14.025,-11.015),(14.025,-10.845),(14.195,-10.845),(14.195,-11.015),(14.025,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((14.365,-11.015),(14.365,-10.845),(14.535,-10.845),(14.535,-11.015),(14.365,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((14.705,-11.015),(14.705,-10.845),(14.875,-10.845),(14.875,-11.015),(14.705,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.155,-11.015),(-12.155,-10.845),(-11.985,-10.845),(-11.985,-11.015),(-12.155,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.075,10.845),(-8.075,11.015),(-7.905,11.015),(-7.905,10.845),(-8.075,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.245,-11.015),(42.245,-10.845),(42.415,-10.845),(42.415,-11.015),(42.245,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((42.585,-11.015),(42.585,-10.845),(42.755,-10.845),(42.755,-11.015),(42.585,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((9.945,10.845),(9.945,11.015),(10.115,11.015),(10.115,10.845),(9.945,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.985,10.845),(11.985,11.015),(12.155,11.015),(12.155,10.845),(11.985,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-5.695),(-44.845,-5.525),(-44.675,-5.525),(-44.675,-5.695),(-44.845,-5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-5.355),(-44.845,-5.185),(-44.675,-5.185),(-44.675,-5.355),(-44.845,-5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,5.185),(-44.845,5.355),(-44.675,5.355),(-44.675,5.185),(-44.845,5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,5.525),(-44.845,5.695),(-44.675,5.695),(-44.675,5.525),(-44.845,5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((22.185,10.845),(22.185,11.015),(22.355,11.015),(22.355,10.845),(22.185,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((22.525,10.845),(22.525,11.015),(22.695,11.015),(22.695,10.845),(22.525,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.055,-11.015),(-24.055,-10.845),(-23.885,-10.845),(-23.885,-11.015),(-24.055,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((25.245,-11.015),(25.245,-10.845),(25.415,-10.845),(25.415,-11.015),(25.245,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((25.585,-11.015),(25.585,-10.845),(25.755,-10.845),(25.755,-11.015),(25.585,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.995,10.845),(-3.995,11.015),(-3.825,11.015),(-3.825,10.845),(-3.995,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.655,10.845),(-3.655,11.015),(-3.485,11.015),(-3.485,10.845),(-3.655,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.315,10.845),(-3.315,11.015),(-3.145,11.015),(-3.145,10.845),(-3.315,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((3.145,10.845),(3.145,11.015),(3.315,11.015),(3.315,10.845),(3.145,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((3.485,10.845),(3.485,11.015),(3.655,11.015),(3.655,10.845),(3.485,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((3.825,10.845),(3.825,11.015),(3.995,11.015),(3.995,10.845),(3.825,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.285,-11.015),(44.285,-10.845),(44.455,-10.845),(44.455,-11.015),(44.285,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.625,-11.015),(44.625,-10.845),(44.795,-10.845),(44.795,-11.015),(44.625,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,-11.015),(31.025,-10.845),(31.195,-10.845),(31.195,-11.015),(31.025,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((31.365,-11.015),(31.365,-10.845),(31.535,-10.845),(31.535,-11.015),(31.365,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((31.705,-11.015),(31.705,-10.845),(31.875,-10.845),(31.875,-11.015),(31.705,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-8.075),(-44.845,-7.905),(-44.675,-7.905),(-44.675,-8.075),(-44.845,-8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-8.075),(44.675,-7.905),(44.845,-7.905),(44.845,-8.075),(44.675,-8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((2.125,10.845),(2.125,11.015),(2.295,11.015),(2.295,10.845),(2.125,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((2.465,10.845),(2.465,11.015),(2.635,11.015),(2.635,10.845),(2.465,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((2.805,10.845),(2.805,11.015),(2.975,11.015),(2.975,10.845),(2.805,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.755,10.845),(-8.755,11.015),(-8.585,11.015),(-8.585,10.845),(-8.755,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.415,10.845),(-8.415,11.015),(-8.245,11.015),(-8.245,10.845),(-8.415,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.945,-11.015),(43.945,-10.845),(44.115,-10.845),(44.115,-11.015),(43.945,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.975,-11.015),(-19.975,-10.845),(-19.805,-10.845),(-19.805,-11.015),(-19.975,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.635,-11.015),(-19.635,-10.845),(-19.465,-10.845),(-19.465,-11.015),(-19.635,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.295,-11.015),(-19.295,-10.845),(-19.125,-10.845),(-19.125,-11.015),(-19.295,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.815,10.845),(-28.815,11.015),(-28.645,11.015),(-28.645,10.845),(-28.815,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.475,10.845),(-28.475,11.015),(-28.305,11.015),(-28.305,10.845),(-28.475,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.475,-11.015),(-28.475,-10.845),(-28.305,-10.845),(-28.305,-11.015),(-28.475,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.815,-11.015),(-28.815,-10.845),(-28.645,-10.845),(-28.645,-11.015),(-28.815,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.615,-11.015),(-1.615,-10.845),(-1.445,-10.845),(-1.445,-11.015),(-1.615,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.275,-11.015),(-1.275,-10.845),(-1.105,-10.845),(-1.105,-11.015),(-1.275,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.955,-11.015),(-1.955,-10.845),(-1.785,-10.845),(-1.785,-11.015),(-1.955,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((26.945,10.845),(26.945,11.015),(27.115,11.015),(27.115,10.845),(26.945,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.855,-11.015),(-13.855,-10.845),(-13.685,-10.845),(-13.685,-11.015),(-13.855,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.515,-11.015),(-13.515,-10.845),(-13.345,-10.845),(-13.345,-11.015),(-13.515,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.175,-11.015),(-13.175,-10.845),(-13.005,-10.845),(-13.005,-11.015),(-13.175,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.895,10.845),(-15.895,11.015),(-15.725,11.015),(-15.725,10.845),(-15.895,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.555,10.845),(-15.555,11.015),(-15.385,11.015),(-15.385,10.845),(-15.555,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.215,10.845),(-15.215,11.015),(-15.045,11.015),(-15.045,10.845),(-15.215,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.045,10.845),(15.045,11.015),(15.215,11.015),(15.215,10.845),(15.045,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.385,10.845),(15.385,11.015),(15.555,11.015),(15.555,10.845),(15.385,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.725,10.845),(15.725,11.015),(15.895,11.015),(15.895,10.845),(15.725,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-9.775),(44.675,-9.605),(44.845,-9.605),(44.845,-9.775),(44.675,-9.775)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-9.435),(44.675,-9.265),(44.845,-9.265),(44.845,-9.435),(44.675,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((40.885,-11.015),(40.885,-10.845),(41.055,-10.845),(41.055,-11.015),(40.885,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,9.265),(44.675,9.435),(44.845,9.435),(44.845,9.265),(44.675,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,9.605),(44.675,9.775),(44.845,9.775),(44.845,9.605),(44.675,9.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.985,10.845),(28.985,11.015),(29.155,11.015),(29.155,10.845),(28.985,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.315,10.845),(-20.315,11.015),(-20.145,11.015),(-20.145,10.845),(-20.315,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.995,10.845),(-20.995,11.015),(-20.825,11.015),(-20.825,10.845),(-20.995,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.315,-11.015),(-20.315,-10.845),(-20.145,-10.845),(-20.145,-11.015),(-20.315,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.995,-11.015),(-20.995,-10.845),(-20.825,-10.845),(-20.825,-11.015),(-20.995,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.655,-11.015),(-20.655,-10.845),(-20.485,-10.845),(-20.485,-11.015),(-20.655,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.655,10.845),(-20.655,11.015),(-20.485,11.015),(-20.485,10.845),(-20.655,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.015,-11.015),(-22.015,-10.845),(-21.845,-10.845),(-21.845,-11.015),(-22.015,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((14.025,10.845),(14.025,11.015),(14.195,11.015),(14.195,10.845),(14.025,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((14.365,10.845),(14.365,11.015),(14.535,11.015),(14.535,10.845),(14.365,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((14.705,10.845),(14.705,11.015),(14.875,11.015),(14.875,10.845),(14.705,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-3.995),(-44.845,-3.825),(-44.675,-3.825),(-44.675,-3.995),(-44.845,-3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-3.655),(-44.845,-3.485),(-44.675,-3.485),(-44.675,-3.655),(-44.845,-3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-3.315),(-44.845,-3.145),(-44.675,-3.145),(-44.675,-3.315),(-44.845,-3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,3.145),(-44.845,3.315),(-44.675,3.315),(-44.675,3.145),(-44.845,3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,3.485),(-44.845,3.655),(-44.675,3.655),(-44.675,3.485),(-44.845,3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,3.825),(-44.845,3.995),(-44.675,3.995),(-44.675,3.825),(-44.845,3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.695,-11.015),(-5.695,-10.845),(-5.525,-10.845),(-5.525,-11.015),(-5.695,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.355,-11.015),(-5.355,-10.845),(-5.185,-10.845),(-5.185,-11.015),(-5.355,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.715,10.845),(-6.715,11.015),(-6.545,11.015),(-6.545,10.845),(-6.715,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.375,10.845),(-6.375,11.015),(-6.205,11.015),(-6.205,10.845),(-6.375,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.065,-11.015),(16.065,-10.845),(16.235,-10.845),(16.235,-11.015),(16.065,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((16.405,-11.015),(16.405,-10.845),(16.575,-10.845),(16.575,-11.015),(16.405,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((16.745,-11.015),(16.745,-10.845),(16.915,-10.845),(16.915,-11.015),(16.745,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.255,10.845),(-34.255,11.015),(-34.085,11.015),(-34.085,10.845),(-34.255,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.935,10.845),(-34.935,11.015),(-34.765,11.015),(-34.765,10.845),(-34.935,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.595,10.845),(-34.595,11.015),(-34.425,11.015),(-34.425,10.845),(-34.595,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.695,-11.015),(-22.695,-10.845),(-22.525,-10.845),(-22.525,-11.015),(-22.695,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.355,-11.015),(-22.355,-10.845),(-22.185,-10.845),(-22.185,-11.015),(-22.355,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.055,10.845),(-41.055,11.015),(-40.885,11.015),(-40.885,10.845),(-41.055,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.245,-11.015),(8.245,-10.845),(8.415,-10.845),(8.415,-11.015),(8.245,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((8.585,-11.015),(8.585,-10.845),(8.755,-10.845),(8.755,-11.015),(8.585,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.115,10.845),(-44.115,11.015),(-43.945,11.015),(-43.945,10.845),(-44.115,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.935,10.845),(-17.935,11.015),(-17.765,11.015),(-17.765,10.845),(-17.935,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.595,10.845),(-17.595,11.015),(-17.425,11.015),(-17.425,10.845),(-17.595,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.255,10.845),(-17.255,11.015),(-17.085,11.015),(-17.085,10.845),(-17.255,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((17.085,10.845),(17.085,11.015),(17.255,11.015),(17.255,10.845),(17.085,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((17.425,10.845),(17.425,11.015),(17.595,11.015),(17.595,10.845),(17.425,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((17.765,10.845),(17.765,11.015),(17.935,11.015),(17.935,10.845),(17.765,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.935,10.845),(-0.935,11.015),(-0.765,11.015),(-0.765,10.845),(-0.935,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.595,10.845),(-0.595,11.015),(-0.425,11.015),(-0.425,10.845),(-0.595,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.425,10.845),(0.425,11.015),(0.595,11.015),(0.595,10.845),(0.425,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.765,10.845),(0.765,11.015),(0.935,11.015),(0.935,10.845),(0.765,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.775,10.845),(-9.775,11.015),(-9.605,11.015),(-9.605,10.845),(-9.775,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.435,10.845),(-9.435,11.015),(-9.265,11.015),(-9.265,10.845),(-9.435,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.265,10.845),(9.265,11.015),(9.435,11.015),(9.435,10.845),(9.265,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.605,10.845),(9.605,11.015),(9.775,11.015),(9.775,10.845),(9.605,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-9.095),(-44.845,-8.925),(-44.675,-8.925),(-44.675,-9.095),(-44.845,-9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((12.325,10.845),(12.325,11.015),(12.495,11.015),(12.495,10.845),(12.325,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((12.665,10.845),(12.665,11.015),(12.835,11.015),(12.835,10.845),(12.665,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.975,-11.015),(-2.975,-10.845),(-2.805,-10.845),(-2.805,-11.015),(-2.975,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.635,-11.015),(-2.635,-10.845),(-2.465,-10.845),(-2.465,-11.015),(-2.635,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.295,-11.015),(-2.295,-10.845),(-2.125,-10.845),(-2.125,-11.015),(-2.295,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,8.925),(-44.845,9.095),(-44.675,9.095),(-44.675,8.925),(-44.845,8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,8.925),(44.675,9.095),(44.845,9.095),(44.845,8.925),(44.675,8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.115,10.845),(-27.115,11.015),(-26.945,11.015),(-26.945,10.845),(-27.115,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-6.715),(-44.845,-6.545),(-44.675,-6.545),(-44.675,-6.715),(-44.845,-6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-6.375),(-44.845,-6.205),(-44.675,-6.205),(-44.675,-6.375),(-44.845,-6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,6.205),(-44.845,6.375),(-44.675,6.375),(-44.675,6.205),(-44.845,6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,6.545),(-44.845,6.715),(-44.675,6.715),(-44.675,6.545),(-44.845,6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.115,10.845),(-10.115,11.015),(-9.945,11.015),(-9.945,10.845),(-10.115,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-5.015),(44.675,-4.845),(44.845,-4.845),(44.845,-5.015),(44.675,-5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((5.865,-11.015),(5.865,-10.845),(6.035,-10.845),(6.035,-11.015),(5.865,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.075,-11.015),(-42.075,-10.845),(-41.905,-10.845),(-41.905,-11.015),(-42.075,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,7.905),(-44.845,8.075),(-44.675,8.075),(-44.675,7.905),(-44.845,7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((4.165,10.845),(4.165,11.015),(4.335,11.015),(4.335,10.845),(4.165,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((4.505,10.845),(4.505,11.015),(4.675,11.015),(4.675,10.845),(4.505,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.055,-11.015),(-7.055,-10.845),(-6.885,-10.845),(-6.885,-11.015),(-7.055,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-7.055),(-44.845,-6.885),(-44.675,-6.885),(-44.675,-7.055),(-44.845,-7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.635,10.845),(-19.635,11.015),(-19.465,11.015),(-19.465,10.845),(-19.635,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.295,10.845),(-19.295,11.015),(-19.125,11.015),(-19.125,10.845),(-19.295,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((7.225,-11.015),(7.225,-10.845),(7.395,-10.845),(7.395,-11.015),(7.225,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((7.565,-11.015),(7.565,-10.845),(7.735,-10.845),(7.735,-11.015),(7.565,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.715,-11.015),(-40.715,-10.845),(-40.545,-10.845),(-40.545,-11.015),(-40.715,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.375,-11.015),(-40.375,-10.845),(-40.205,-10.845),(-40.205,-11.015),(-40.375,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((7.905,-11.015),(7.905,-10.845),(8.075,-10.845),(8.075,-11.015),(7.905,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((27.285,-11.015),(27.285,-10.845),(27.455,-10.845),(27.455,-11.015),(27.285,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((27.625,-11.015),(27.625,-10.845),(27.795,-10.845),(27.795,-11.015),(27.625,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.775,10.845),(-26.775,11.015),(-26.605,11.015),(-26.605,10.845),(-26.775,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.435,10.845),(-26.435,11.015),(-26.265,11.015),(-26.265,10.845),(-26.435,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.875,-11.015),(-14.875,-10.845),(-14.705,-10.845),(-14.705,-11.015),(-14.875,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.535,-11.015),(-14.535,-10.845),(-14.365,-10.845),(-14.365,-11.015),(-14.535,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.195,-11.015),(-14.195,-10.845),(-14.025,-10.845),(-14.025,-11.015),(-14.195,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.895,-11.015),(-32.895,-10.845),(-32.725,-10.845),(-32.725,-11.015),(-32.895,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.555,-11.015),(-32.555,-10.845),(-32.385,-10.845),(-32.385,-11.015),(-32.555,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.215,-11.015),(-32.215,-10.845),(-32.045,-10.845),(-32.045,-11.015),(-32.215,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-0.935),(-44.845,-0.765),(-44.675,-0.765),(-44.675,-0.935),(-44.845,-0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-0.595),(-44.845,-0.425),(-44.675,-0.425),(-44.675,-0.595),(-44.845,-0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,0.425),(-44.845,0.595),(-44.675,0.595),(-44.675,0.425),(-44.845,0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,0.765),(-44.845,0.935),(-44.675,0.935),(-44.675,0.765),(-44.845,0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-0.935),(44.675,-0.765),(44.845,-0.765),(44.845,-0.935),(44.675,-0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.755,-11.015),(-42.755,-10.845),(-42.585,-10.845),(-42.585,-11.015),(-42.755,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.415,-11.015),(-42.415,-10.845),(-42.245,-10.845),(-42.245,-11.015),(-42.415,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-0.595),(44.675,-0.425),(44.845,-0.425),(44.845,-0.595),(44.675,-0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,0.425),(44.675,0.595),(44.845,0.595),(44.845,0.425),(44.675,0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,0.765),(44.675,0.935),(44.845,0.935),(44.845,0.765),(44.675,0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.985,-11.015),(11.985,-10.845),(12.155,-10.845),(12.155,-11.015),(11.985,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((36.125,-11.015),(36.125,-10.845),(36.295,-10.845),(36.295,-11.015),(36.125,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((36.465,-11.015),(36.465,-10.845),(36.635,-10.845),(36.635,-11.015),(36.465,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((36.805,-11.015),(36.805,-10.845),(36.975,-10.845),(36.975,-11.015),(36.805,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((25.925,-11.015),(25.925,-10.845),(26.095,-10.845),(26.095,-11.015),(25.925,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.995,10.845),(-37.995,11.015),(-37.825,11.015),(-37.825,10.845),(-37.995,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.655,10.845),(-37.655,11.015),(-37.485,11.015),(-37.485,10.845),(-37.655,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.315,10.845),(-37.315,11.015),(-37.145,11.015),(-37.145,10.845),(-37.315,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.145,10.845),(37.145,11.015),(37.315,11.015),(37.315,10.845),(37.145,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.485,10.845),(37.485,11.015),(37.655,11.015),(37.655,10.845),(37.485,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.825,10.845),(37.825,11.015),(37.995,11.015),(37.995,10.845),(37.825,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((19.125,-11.015),(19.125,-10.845),(19.295,-10.845),(19.295,-11.015),(19.125,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((19.465,-11.015),(19.465,-10.845),(19.635,-10.845),(19.635,-11.015),(19.465,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((19.805,-11.015),(19.805,-10.845),(19.975,-10.845),(19.975,-11.015),(19.805,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((42.245,10.845),(42.245,11.015),(42.415,11.015),(42.415,10.845),(42.245,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.585,10.845),(42.585,11.015),(42.755,11.015),(42.755,10.845),(42.585,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.255,10.845),(-0.255,11.015),(-0.085,11.015),(-0.085,10.845),(-0.255,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.085,10.845),(0.085,11.015),(0.255,11.015),(0.255,10.845),(0.085,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((1.105,-11.015),(1.105,-10.845),(1.275,-10.845),(1.275,-11.015),(1.105,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((1.445,-11.015),(1.445,-10.845),(1.615,-10.845),(1.615,-11.015),(1.445,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((1.785,-11.015),(1.785,-10.845),(1.955,-10.845),(1.955,-11.015),(1.785,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.735,-11.015),(-41.735,-10.845),(-41.565,-10.845),(-41.565,-11.015),(-41.735,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.395,-11.015),(-41.395,-10.845),(-41.225,-10.845),(-41.225,-11.015),(-41.395,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.055,-11.015),(-41.055,-10.845),(-40.885,-10.845),(-40.885,-11.015),(-41.055,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((13.685,-11.015),(13.685,-10.845),(13.855,-10.845),(13.855,-11.015),(13.685,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((13.005,-11.015),(13.005,-10.845),(13.175,-10.845),(13.175,-11.015),(13.005,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((13.345,-11.015),(13.345,-10.845),(13.515,-10.845),(13.515,-11.015),(13.345,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((5.865,10.845),(5.865,11.015),(6.035,11.015),(6.035,10.845),(5.865,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((22.865,10.845),(22.865,11.015),(23.035,11.015),(23.035,10.845),(22.865,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.795,10.845),(-27.795,11.015),(-27.625,11.015),(-27.625,10.845),(-27.795,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.455,10.845),(-27.455,11.015),(-27.285,11.015),(-27.285,10.845),(-27.455,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.285,10.845),(27.285,11.015),(27.455,11.015),(27.455,10.845),(27.285,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.625,10.845),(27.625,11.015),(27.795,11.015),(27.795,10.845),(27.625,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.965,-11.015),(10.965,-10.845),(11.135,-10.845),(11.135,-11.015),(10.965,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.715,-11.015),(-23.715,-10.845),(-23.545,-10.845),(-23.545,-11.015),(-23.715,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.375,-11.015),(-23.375,-10.845),(-23.205,-10.845),(-23.205,-11.015),(-23.375,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((23.885,10.845),(23.885,11.015),(24.055,11.015),(24.055,10.845),(23.885,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.155,10.845),(-12.155,11.015),(-11.985,11.015),(-11.985,10.845),(-12.155,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.095,-11.015),(-43.095,-10.845),(-42.925,-10.845),(-42.925,-11.015),(-43.095,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.135,-11.015),(-28.135,-10.845),(-27.965,-10.845),(-27.965,-11.015),(-28.135,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.015,10.845),(-39.015,11.015),(-38.845,11.015),(-38.845,10.845),(-39.015,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.055,10.845),(-24.055,11.015),(-23.885,11.015),(-23.885,10.845),(-24.055,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.925,10.845),(25.925,11.015),(26.095,11.015),(26.095,10.845),(25.925,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.885,10.845),(40.885,11.015),(41.055,11.015),(41.055,10.845),(40.885,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.965,10.845),(27.965,11.015),(28.135,11.015),(28.135,10.845),(27.965,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((5.185,-11.015),(5.185,-10.845),(5.355,-10.845),(5.355,-11.015),(5.185,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((5.525,-11.015),(5.525,-10.845),(5.695,-10.845),(5.695,-11.015),(5.525,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-6.035),(-44.845,-5.865),(-44.675,-5.865),(-44.675,-6.035),(-44.845,-6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,6.885),(-44.845,7.055),(-44.675,7.055),(-44.675,6.885),(-44.845,6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.165,10.845),(38.165,11.015),(38.335,11.015),(38.335,10.845),(38.165,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((38.505,10.845),(38.505,11.015),(38.675,11.015),(38.675,10.845),(38.505,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.105,-11.015),(18.105,-10.845),(18.275,-10.845),(18.275,-11.015),(18.105,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((18.445,-11.015),(18.445,-10.845),(18.615,-10.845),(18.615,-11.015),(18.445,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((18.785,-11.015),(18.785,-10.845),(18.955,-10.845),(18.955,-11.015),(18.785,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((19.125,10.845),(19.125,11.015),(19.295,11.015),(19.295,10.845),(19.125,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((19.465,10.845),(19.465,11.015),(19.635,11.015),(19.635,10.845),(19.465,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((19.805,10.845),(19.805,11.015),(19.975,11.015),(19.975,10.845),(19.805,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-2.975),(44.675,-2.805),(44.845,-2.805),(44.845,-2.975),(44.675,-2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,2.805),(44.675,2.975),(44.845,2.975),(44.845,2.805),(44.675,2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-2.635),(44.675,-2.465),(44.845,-2.465),(44.845,-2.635),(44.675,-2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((10.285,-11.015),(10.285,-10.845),(10.455,-10.845),(10.455,-11.015),(10.285,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((10.625,-11.015),(10.625,-10.845),(10.795,-10.845),(10.795,-11.015),(10.625,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,2.465),(44.675,2.635),(44.845,2.635),(44.845,2.465),(44.675,2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.975,10.845),(-19.975,11.015),(-19.805,11.015),(-19.805,10.845),(-19.975,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-5.695),(44.675,-5.525),(44.845,-5.525),(44.845,-5.695),(44.675,-5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-5.355),(44.675,-5.185),(44.845,-5.185),(44.845,-5.355),(44.675,-5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,5.185),(44.675,5.355),(44.845,5.355),(44.845,5.185),(44.675,5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,5.525),(44.675,5.695),(44.845,5.695),(44.845,5.525),(44.675,5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-10.455),(-44.845,-10.285),(-44.675,-10.285),(-44.675,-10.455),(-44.845,-10.455)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,9.945),(-44.845,10.115),(-44.675,10.115),(-44.675,9.945),(-44.845,9.945)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,10.285),(-44.845,10.455),(-44.675,10.455),(-44.675,10.285),(-44.845,10.285)),
        )
        createRL(
            tech, net, 'licon',
            ((38.845,-11.015),(38.845,-10.845),(39.015,-10.845),(39.015,-11.015),(38.845,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.735,10.845),(-24.735,11.015),(-24.565,11.015),(-24.565,10.845),(-24.735,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.395,10.845),(-24.395,11.015),(-24.225,11.015),(-24.225,10.845),(-24.395,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.205,10.845),(40.205,11.015),(40.375,11.015),(40.375,10.845),(40.205,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.545,10.845),(40.545,11.015),(40.715,11.015),(40.715,10.845),(40.545,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.955,-11.015),(-35.955,-10.845),(-35.785,-10.845),(-35.785,-11.015),(-35.955,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.615,-11.015),(-35.615,-10.845),(-35.445,-10.845),(-35.445,-11.015),(-35.615,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.275,-11.015),(-35.275,-10.845),(-35.105,-10.845),(-35.105,-11.015),(-35.275,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.795,-11.015),(-44.795,-10.845),(-44.625,-10.845),(-44.625,-11.015),(-44.795,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.455,-11.015),(-44.455,-10.845),(-44.285,-10.845),(-44.285,-11.015),(-44.455,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((12.325,-11.015),(12.325,-10.845),(12.495,-10.845),(12.495,-11.015),(12.325,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((12.665,-11.015),(12.665,-10.845),(12.835,-10.845),(12.835,-11.015),(12.665,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.515,10.845),(-13.515,11.015),(-13.345,11.015),(-13.345,10.845),(-13.515,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.175,10.845),(-13.175,11.015),(-13.005,11.015),(-13.005,10.845),(-13.175,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.005,10.845),(13.005,11.015),(13.175,11.015),(13.175,10.845),(13.005,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.345,10.845),(13.345,11.015),(13.515,11.015),(13.515,10.845),(13.345,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.855,10.845),(-13.855,11.015),(-13.685,11.015),(-13.685,10.845),(-13.855,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.685,10.845),(13.685,11.015),(13.855,11.015),(13.855,10.845),(13.685,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((38.165,-11.015),(38.165,-10.845),(38.335,-10.845),(38.335,-11.015),(38.165,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((38.505,-11.015),(38.505,-10.845),(38.675,-10.845),(38.675,-11.015),(38.505,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.755,-11.015),(-8.755,-10.845),(-8.585,-10.845),(-8.585,-11.015),(-8.755,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.415,-11.015),(-8.415,-10.845),(-8.245,-10.845),(-8.245,-11.015),(-8.415,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.835,-11.015),(-29.835,-10.845),(-29.665,-10.845),(-29.665,-11.015),(-29.835,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.495,-11.015),(-29.495,-10.845),(-29.325,-10.845),(-29.325,-11.015),(-29.495,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.895,-11.015),(-15.895,-10.845),(-15.725,-10.845),(-15.725,-11.015),(-15.895,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.555,-11.015),(-15.555,-10.845),(-15.385,-10.845),(-15.385,-11.015),(-15.555,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.215,-11.015),(-15.215,-10.845),(-15.045,-10.845),(-15.045,-11.015),(-15.215,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,-11.015),(30.005,-10.845),(30.175,-10.845),(30.175,-11.015),(30.005,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.345,-11.015),(30.345,-10.845),(30.515,-10.845),(30.515,-11.015),(30.345,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.685,-11.015),(30.685,-10.845),(30.855,-10.845),(30.855,-11.015),(30.685,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.035,10.845),(-6.035,11.015),(-5.865,11.015),(-5.865,10.845),(-6.035,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-1.955),(-44.845,-1.785),(-44.675,-1.785),(-44.675,-1.955),(-44.845,-1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-1.615),(-44.845,-1.445),(-44.675,-1.445),(-44.675,-1.615),(-44.845,-1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-1.275),(-44.845,-1.105),(-44.675,-1.105),(-44.675,-1.275),(-44.845,-1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,1.105),(-44.845,1.275),(-44.675,1.275),(-44.675,1.105),(-44.845,1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,1.445),(-44.845,1.615),(-44.675,1.615),(-44.675,1.445),(-44.845,1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,1.785),(-44.845,1.955),(-44.675,1.955),(-44.675,1.785),(-44.845,1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.295,10.845),(-36.295,11.015),(-36.125,11.015),(-36.125,10.845),(-36.295,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.975,10.845),(-36.975,11.015),(-36.805,11.015),(-36.805,10.845),(-36.975,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((4.165,-11.015),(4.165,-10.845),(4.335,-10.845),(4.335,-11.015),(4.165,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.635,10.845),(-36.635,11.015),(-36.465,11.015),(-36.465,10.845),(-36.635,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((4.505,-11.015),(4.505,-10.845),(4.675,-10.845),(4.675,-11.015),(4.505,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((8.925,-11.015),(8.925,-10.845),(9.095,-10.845),(9.095,-11.015),(8.925,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.695,10.845),(-5.695,11.015),(-5.525,11.015),(-5.525,10.845),(-5.695,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.355,10.845),(-5.355,11.015),(-5.185,11.015),(-5.185,10.845),(-5.355,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((5.185,10.845),(5.185,11.015),(5.355,11.015),(5.355,10.845),(5.185,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((5.525,10.845),(5.525,11.015),(5.695,11.015),(5.695,10.845),(5.525,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.105,10.845),(18.105,11.015),(18.275,11.015),(18.275,10.845),(18.105,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.445,10.845),(18.445,11.015),(18.615,11.015),(18.615,10.845),(18.445,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.785,10.845),(18.785,11.015),(18.955,11.015),(18.955,10.845),(18.785,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.675,-11.015),(-21.675,-10.845),(-21.505,-10.845),(-21.505,-11.015),(-21.675,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.335,-11.015),(-21.335,-10.845),(-21.165,-10.845),(-21.165,-11.015),(-21.335,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.695,10.845),(-22.695,11.015),(-22.525,11.015),(-22.525,10.845),(-22.695,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.355,10.845),(-22.355,11.015),(-22.185,11.015),(-22.185,10.845),(-22.355,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.285,10.845),(10.285,11.015),(10.455,11.015),(10.455,10.845),(10.285,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.625,10.845),(10.625,11.015),(10.795,11.015),(10.795,10.845),(10.625,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.915,10.845),(-16.915,11.015),(-16.745,11.015),(-16.745,10.845),(-16.915,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.575,10.845),(-16.575,11.015),(-16.405,11.015),(-16.405,10.845),(-16.575,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.235,10.845),(-16.235,11.015),(-16.065,11.015),(-16.065,10.845),(-16.235,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.015,10.845),(-5.015,11.015),(-4.845,11.015),(-4.845,10.845),(-5.015,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((24.225,-11.015),(24.225,-10.845),(24.395,-10.845),(24.395,-11.015),(24.225,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.015,-11.015),(-5.015,-10.845),(-4.845,-10.845),(-4.845,-11.015),(-5.015,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((24.565,-11.015),(24.565,-10.845),(24.735,-10.845),(24.735,-11.015),(24.565,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.935,-11.015),(-17.935,-10.845),(-17.765,-10.845),(-17.765,-11.015),(-17.935,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.595,-11.015),(-17.595,-10.845),(-17.425,-10.845),(-17.425,-11.015),(-17.595,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.255,-11.015),(-17.255,-10.845),(-17.085,-10.845),(-17.085,-11.015),(-17.255,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.255,-11.015),(-0.255,-10.845),(-0.085,-10.845),(-0.085,-11.015),(-0.255,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((0.085,-11.015),(0.085,-10.845),(0.255,-10.845),(0.255,-11.015),(0.085,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.755,10.845),(-25.755,11.015),(-25.585,11.015),(-25.585,10.845),(-25.755,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.695,10.845),(-39.695,11.015),(-39.525,11.015),(-39.525,10.845),(-39.695,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.355,10.845),(-39.355,11.015),(-39.185,11.015),(-39.185,10.845),(-39.355,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.415,10.845),(-25.415,11.015),(-25.245,11.015),(-25.245,10.845),(-25.415,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.245,10.845),(25.245,11.015),(25.415,11.015),(25.415,10.845),(25.245,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.585,10.845),(25.585,11.015),(25.755,11.015),(25.755,10.845),(25.585,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.775,-11.015),(-9.775,-10.845),(-9.605,-10.845),(-9.605,-11.015),(-9.775,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.435,-11.015),(-9.435,-10.845),(-9.265,-10.845),(-9.265,-11.015),(-9.435,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.975,10.845),(-2.975,11.015),(-2.805,11.015),(-2.805,10.845),(-2.975,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.635,10.845),(-2.635,11.015),(-2.465,11.015),(-2.465,10.845),(-2.635,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.295,10.845),(-2.295,11.015),(-2.125,11.015),(-2.125,10.845),(-2.295,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.095,10.845),(-9.095,11.015),(-8.925,11.015),(-8.925,10.845),(-9.095,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.185,10.845),(39.185,11.015),(39.355,11.015),(39.355,10.845),(39.185,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.095,-11.015),(-9.095,-10.845),(-8.925,-10.845),(-8.925,-11.015),(-9.095,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.435,-11.015),(-43.435,-10.845),(-43.265,-10.845),(-43.265,-11.015),(-43.435,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.775,-11.015),(-43.775,-10.845),(-43.605,-10.845),(-43.605,-11.015),(-43.775,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.875,10.845),(-31.875,11.015),(-31.705,11.015),(-31.705,10.845),(-31.875,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.535,10.845),(-31.535,11.015),(-31.365,11.015),(-31.365,10.845),(-31.535,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.195,10.845),(-31.195,11.015),(-31.025,11.015),(-31.025,10.845),(-31.195,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.305,10.845),(28.305,11.015),(28.475,11.015),(28.475,10.845),(28.305,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.645,10.845),(28.645,11.015),(28.815,11.015),(28.815,10.845),(28.645,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.845),(31.025,11.015),(31.195,11.015),(31.195,10.845),(31.025,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((31.365,10.845),(31.365,11.015),(31.535,11.015),(31.535,10.845),(31.365,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((31.705,10.845),(31.705,11.015),(31.875,11.015),(31.875,10.845),(31.705,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,4.165),(-44.845,4.335),(-44.675,4.335),(-44.675,4.165),(-44.845,4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,4.505),(-44.845,4.675),(-44.675,4.675),(-44.675,4.505),(-44.845,4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-7.735),(44.675,-7.565),(44.845,-7.565),(44.845,-7.735),(44.675,-7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-7.395),(44.675,-7.225),(44.845,-7.225),(44.845,-7.395),(44.675,-7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-4.675),(44.675,-4.505),(44.845,-4.505),(44.845,-4.675),(44.675,-4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,7.225),(44.675,7.395),(44.845,7.395),(44.845,7.225),(44.675,7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,7.565),(44.675,7.735),(44.845,7.735),(44.845,7.565),(44.675,7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.095,10.845),(-43.095,11.015),(-42.925,11.015),(-42.925,10.845),(-43.095,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.035,-11.015),(-40.035,-10.845),(-39.865,-10.845),(-39.865,-11.015),(-40.035,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.095,10.845),(-26.095,11.015),(-25.925,11.015),(-25.925,10.845),(-26.095,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((41.225,-11.015),(41.225,-10.845),(41.395,-10.845),(41.395,-11.015),(41.225,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((41.565,-11.015),(41.565,-10.845),(41.735,-10.845),(41.735,-11.015),(41.565,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.845),(30.005,11.015),(30.175,11.015),(30.175,10.845),(30.005,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.345,10.845),(30.345,11.015),(30.515,11.015),(30.515,10.845),(30.345,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.685,10.845),(30.685,11.015),(30.855,11.015),(30.855,10.845),(30.685,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,5.865),(-44.845,6.035),(-44.675,6.035),(-44.675,5.865),(-44.845,5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.135,-11.015),(-11.135,-10.845),(-10.965,-10.845),(-10.965,-11.015),(-11.135,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.845,-11.015),(21.845,-10.845),(22.015,-10.845),(22.015,-11.015),(21.845,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.055,10.845),(-7.055,11.015),(-6.885,11.015),(-6.885,10.845),(-7.055,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.925,10.845),(8.925,11.015),(9.095,11.015),(9.095,10.845),(8.925,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.795,10.845),(-44.795,11.015),(-44.625,11.015),(-44.625,10.845),(-44.795,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.455,10.845),(-44.455,11.015),(-44.285,11.015),(-44.285,10.845),(-44.455,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.145,10.845),(20.145,11.015),(20.315,11.015),(20.315,10.845),(20.145,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.485,10.845),(20.485,11.015),(20.655,11.015),(20.655,10.845),(20.485,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.825,10.845),(20.825,11.015),(20.995,11.015),(20.995,10.845),(20.825,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-10.115),(-44.845,-9.945),(-44.675,-9.945),(-44.675,-10.115),(-44.845,-10.115)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.035,-11.015),(-23.035,-10.845),(-22.865,-10.845),(-22.865,-11.015),(-23.035,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((32.045,-11.015),(32.045,-10.845),(32.215,-10.845),(32.215,-11.015),(32.045,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((32.385,-11.015),(32.385,-10.845),(32.555,-10.845),(32.555,-11.015),(32.385,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((32.725,-11.015),(32.725,-10.845),(32.895,-10.845),(32.895,-11.015),(32.725,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.115,-11.015),(-10.115,-10.845),(-9.945,-10.845),(-9.945,-11.015),(-10.115,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((23.205,-11.015),(23.205,-10.845),(23.375,-10.845),(23.375,-11.015),(23.205,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((23.545,-11.015),(23.545,-10.845),(23.715,-10.845),(23.715,-11.015),(23.545,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.875,10.845),(-14.875,11.015),(-14.705,11.015),(-14.705,10.845),(-14.875,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.535,10.845),(-14.535,11.015),(-14.365,11.015),(-14.365,10.845),(-14.535,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.195,10.845),(-14.195,11.015),(-14.025,11.015),(-14.025,10.845),(-14.195,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.885,-11.015),(23.885,-10.845),(24.055,-10.845),(24.055,-11.015),(23.885,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.235,10.845),(-33.235,11.015),(-33.065,11.015),(-33.065,10.845),(-33.235,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.915,10.845),(-33.915,11.015),(-33.745,11.015),(-33.745,10.845),(-33.915,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.575,10.845),(-33.575,11.015),(-33.405,11.015),(-33.405,10.845),(-33.575,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.065,10.845),(33.065,11.015),(33.235,11.015),(33.235,10.845),(33.065,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.405,10.845),(33.405,11.015),(33.575,11.015),(33.575,10.845),(33.405,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.745,10.845),(33.745,11.015),(33.915,11.015),(33.915,10.845),(33.745,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.065,10.845),(16.065,11.015),(16.235,11.015),(16.235,10.845),(16.065,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.405,10.845),(16.405,11.015),(16.575,11.015),(16.575,10.845),(16.405,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.745,10.845),(16.745,11.015),(16.915,11.015),(16.915,10.845),(16.745,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.925,10.845),(42.925,11.015),(43.095,11.015),(43.095,10.845),(42.925,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.885,-11.015),(6.885,-10.845),(7.055,-10.845),(7.055,-11.015),(6.885,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((8.245,10.845),(8.245,11.015),(8.415,11.015),(8.415,10.845),(8.245,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.585,10.845),(8.585,11.015),(8.755,11.015),(8.755,10.845),(8.585,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.965,-11.015),(27.965,-10.845),(28.135,-10.845),(28.135,-11.015),(27.965,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.955,-11.015),(-18.955,-10.845),(-18.785,-10.845),(-18.785,-11.015),(-18.955,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.615,-11.015),(-18.615,-10.845),(-18.445,-10.845),(-18.445,-11.015),(-18.615,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.275,-11.015),(-18.275,-10.845),(-18.105,-10.845),(-18.105,-11.015),(-18.275,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.795,-11.015),(-10.795,-10.845),(-10.625,-10.845),(-10.625,-11.015),(-10.795,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.455,-11.015),(-10.455,-10.845),(-10.285,-10.845),(-10.285,-11.015),(-10.455,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-9.095),(44.675,-8.925),(44.845,-8.925),(44.845,-9.095),(44.675,-9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.975,-11.015),(-36.975,-10.845),(-36.805,-10.845),(-36.805,-11.015),(-36.975,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.635,-11.015),(-36.635,-10.845),(-36.465,-10.845),(-36.465,-11.015),(-36.635,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.295,-11.015),(-36.295,-10.845),(-36.125,-10.845),(-36.125,-11.015),(-36.295,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,9.945),(44.675,10.115),(44.845,10.115),(44.845,9.945),(44.675,9.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.205,-11.015),(6.205,-10.845),(6.375,-10.845),(6.375,-11.015),(6.205,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((6.545,-11.015),(6.545,-10.845),(6.715,-10.845),(6.715,-11.015),(6.545,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((35.105,-11.015),(35.105,-10.845),(35.275,-10.845),(35.275,-11.015),(35.105,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((35.445,-11.015),(35.445,-10.845),(35.615,-10.845),(35.615,-11.015),(35.445,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((35.785,-11.015),(35.785,-10.845),(35.955,-10.845),(35.955,-11.015),(35.785,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,2.125),(44.675,2.295),(44.845,2.295),(44.845,2.125),(44.675,2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-4.675),(-44.845,-4.505),(-44.675,-4.505),(-44.675,-4.675),(-44.845,-4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-4.335),(-44.845,-4.165),(-44.675,-4.165),(-44.675,-4.335),(-44.845,-4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-0.255),(-44.845,-0.085),(-44.675,-0.085),(-44.675,-0.255),(-44.845,-0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,0.085),(-44.845,0.255),(-44.675,0.255),(-44.675,0.085),(-44.845,0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-0.255),(44.675,-0.085),(44.845,-0.085),(44.845,-0.255),(44.675,-0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,0.085),(44.675,0.255),(44.845,0.255),(44.845,0.085),(44.675,0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,4.165),(44.675,4.335),(44.845,4.335),(44.845,4.165),(44.675,4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,4.505),(44.675,4.675),(44.845,4.675),(44.845,4.505),(44.675,4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.675,-11.015),(-38.675,-10.845),(-38.505,-10.845),(-38.505,-11.015),(-38.675,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.335,-11.015),(-38.335,-10.845),(-38.165,-10.845),(-38.165,-11.015),(-38.335,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((29.665,-11.015),(29.665,-10.845),(29.835,-10.845),(29.835,-11.015),(29.665,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((29.325,-11.015),(29.325,-10.845),(29.495,-10.845),(29.495,-11.015),(29.325,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.845,10.845),(21.845,11.015),(22.015,11.015),(22.015,10.845),(21.845,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.045,-11.015),(15.045,-10.845),(15.215,-10.845),(15.215,-11.015),(15.045,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((15.385,-11.015),(15.385,-10.845),(15.555,-10.845),(15.555,-11.015),(15.385,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.855,-11.015),(-30.855,-10.845),(-30.685,-10.845),(-30.685,-11.015),(-30.855,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.515,-11.015),(-30.515,-10.845),(-30.345,-10.845),(-30.345,-11.015),(-30.515,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.175,-11.015),(-30.175,-10.845),(-30.005,-10.845),(-30.005,-11.015),(-30.175,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((15.725,-11.015),(15.725,-10.845),(15.895,-10.845),(15.895,-11.015),(15.725,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((38.845,10.845),(38.845,11.015),(39.015,11.015),(39.015,10.845),(38.845,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-1.955),(44.675,-1.785),(44.845,-1.785),(44.845,-1.955),(44.675,-1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.775,10.845),(-43.775,11.015),(-43.605,11.015),(-43.605,10.845),(-43.775,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.435,10.845),(-43.435,11.015),(-43.265,11.015),(-43.265,10.845),(-43.435,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.265,10.845),(43.265,11.015),(43.435,11.015),(43.435,10.845),(43.265,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.605,10.845),(43.605,11.015),(43.775,11.015),(43.775,10.845),(43.605,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-1.615),(44.675,-1.445),(44.845,-1.445),(44.845,-1.615),(44.675,-1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-1.275),(44.675,-1.105),(44.845,-1.105),(44.845,-1.275),(44.675,-1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,1.105),(44.675,1.275),(44.845,1.275),(44.845,1.105),(44.675,1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,1.445),(44.675,1.615),(44.845,1.615),(44.845,1.445),(44.675,1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,1.785),(44.675,1.955),(44.845,1.955),(44.845,1.785),(44.675,1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-4.335),(44.675,-4.165),(44.845,-4.165),(44.845,-4.335),(44.675,-4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((26.945,-11.015),(26.945,-10.845),(27.115,-10.845),(27.115,-11.015),(26.945,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.695,-11.015),(-39.695,-10.845),(-39.525,-10.845),(-39.525,-11.015),(-39.695,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.355,-11.015),(-39.355,-10.845),(-39.185,-10.845),(-39.185,-11.015),(-39.355,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,4.845),(-44.845,5.015),(-44.675,5.015),(-44.675,4.845),(-44.845,4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.135,10.845),(-28.135,11.015),(-27.965,11.015),(-27.965,10.845),(-28.135,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.735,10.845),(-7.735,11.015),(-7.565,11.015),(-7.565,10.845),(-7.735,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.115,-11.015),(-44.115,-10.845),(-43.945,-10.845),(-43.945,-11.015),(-44.115,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.395,10.845),(-7.395,11.015),(-7.225,11.015),(-7.225,10.845),(-7.395,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((7.225,10.845),(7.225,11.015),(7.395,11.015),(7.395,10.845),(7.225,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((7.565,10.845),(7.565,11.015),(7.735,11.015),(7.735,10.845),(7.565,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.035,10.845),(-40.035,11.015),(-39.865,11.015),(-39.865,10.845),(-40.035,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((41.905,10.845),(41.905,11.015),(42.075,11.015),(42.075,10.845),(41.905,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.945,10.845),(43.945,11.015),(44.115,11.015),(44.115,10.845),(43.945,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.815,-11.015),(-11.815,-10.845),(-11.645,-10.845),(-11.645,-11.015),(-11.815,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.475,-11.015),(-11.475,-10.845),(-11.305,-10.845),(-11.305,-11.015),(-11.475,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.165,-11.015),(21.165,-10.845),(21.335,-10.845),(21.335,-11.015),(21.165,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.505,-11.015),(21.505,-10.845),(21.675,-10.845),(21.675,-11.015),(21.505,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((26.265,-11.015),(26.265,-10.845),(26.435,-10.845),(26.435,-11.015),(26.265,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((26.605,-11.015),(26.605,-10.845),(26.775,-10.845),(26.775,-11.015),(26.605,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((17.085,-11.015),(17.085,-10.845),(17.255,-10.845),(17.255,-11.015),(17.085,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((17.425,-11.015),(17.425,-10.845),(17.595,-10.845),(17.595,-11.015),(17.425,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((17.765,-11.015),(17.765,-10.845),(17.935,-10.845),(17.935,-11.015),(17.765,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.075,-11.015),(-8.075,-10.845),(-7.905,-10.845),(-7.905,-11.015),(-8.075,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((6.205,10.845),(6.205,11.015),(6.375,11.015),(6.375,10.845),(6.205,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.545,10.845),(6.545,11.015),(6.715,11.015),(6.715,10.845),(6.545,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.265,-11.015),(9.265,-10.845),(9.435,-10.845),(9.435,-11.015),(9.265,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((9.605,-11.015),(9.605,-10.845),(9.775,-10.845),(9.775,-11.015),(9.605,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((34.085,10.845),(34.085,11.015),(34.255,11.015),(34.255,10.845),(34.085,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.425,10.845),(34.425,11.015),(34.595,11.015),(34.595,10.845),(34.425,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.715,10.845),(-40.715,11.015),(-40.545,11.015),(-40.545,10.845),(-40.715,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.375,10.845),(-40.375,11.015),(-40.205,11.015),(-40.205,10.845),(-40.375,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.765,10.845),(34.765,11.015),(34.935,11.015),(34.935,10.845),(34.765,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.265,-11.015),(43.265,-10.845),(43.435,-10.845),(43.435,-11.015),(43.265,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((43.605,-11.015),(43.605,-10.845),(43.775,-10.845),(43.775,-11.015),(43.605,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((28.305,-11.015),(28.305,-10.845),(28.475,-10.845),(28.475,-11.015),(28.305,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((28.645,-11.015),(28.645,-10.845),(28.815,-10.845),(28.815,-11.015),(28.645,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.755,10.845),(-42.755,11.015),(-42.585,11.015),(-42.585,10.845),(-42.755,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.415,10.845),(-42.415,11.015),(-42.245,11.015),(-42.245,10.845),(-42.415,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-7.735),(-44.845,-7.565),(-44.675,-7.565),(-44.675,-7.735),(-44.845,-7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-7.395),(-44.845,-7.225),(-44.675,-7.225),(-44.675,-7.395),(-44.845,-7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,7.225),(-44.845,7.395),(-44.675,7.395),(-44.675,7.225),(-44.845,7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,7.565),(-44.845,7.735),(-44.675,7.735),(-44.675,7.565),(-44.845,7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((4.845,-11.015),(4.845,-10.845),(5.015,-10.845),(5.015,-11.015),(4.845,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.835,10.845),(-29.835,11.015),(-29.665,11.015),(-29.665,10.845),(-29.835,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.495,10.845),(-29.495,11.015),(-29.325,11.015),(-29.325,10.845),(-29.495,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((29.325,10.845),(29.325,11.015),(29.495,11.015),(29.495,10.845),(29.325,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((29.665,10.845),(29.665,11.015),(29.835,11.015),(29.835,10.845),(29.665,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.525,10.845),(39.525,11.015),(39.695,11.015),(39.695,10.845),(39.525,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.995,-11.015),(-3.995,-10.845),(-3.825,-10.845),(-3.825,-11.015),(-3.995,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.655,-11.015),(-3.655,-10.845),(-3.485,-10.845),(-3.485,-11.015),(-3.655,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.315,-11.015),(-3.315,-10.845),(-3.145,-10.845),(-3.145,-11.015),(-3.315,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.835,10.845),(-12.835,11.015),(-12.665,11.015),(-12.665,10.845),(-12.835,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.495,10.845),(-12.495,11.015),(-12.325,11.015),(-12.325,10.845),(-12.495,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.835,-11.015),(-12.835,-10.845),(-12.665,-10.845),(-12.665,-11.015),(-12.835,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.495,-11.015),(-12.495,-10.845),(-12.325,-10.845),(-12.325,-11.015),(-12.495,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.915,-11.015),(-33.915,-10.845),(-33.745,-10.845),(-33.745,-11.015),(-33.915,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.575,-11.015),(-33.575,-10.845),(-33.405,-10.845),(-33.405,-11.015),(-33.575,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.235,-11.015),(-33.235,-10.845),(-33.065,-10.845),(-33.065,-11.015),(-33.235,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((41.905,-11.015),(41.905,-10.845),(42.075,-10.845),(42.075,-11.015),(41.905,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-2.295),(44.675,-2.125),(44.845,-2.125),(44.845,-2.295),(44.675,-2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.935,-11.015),(-0.935,-10.845),(-0.765,-10.845),(-0.765,-11.015),(-0.935,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.595,-11.015),(-0.595,-10.845),(-0.425,-10.845),(-0.425,-11.015),(-0.595,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((0.425,-11.015),(0.425,-10.845),(0.595,-10.845),(0.595,-11.015),(0.425,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((0.765,-11.015),(0.765,-10.845),(0.935,-10.845),(0.935,-11.015),(0.765,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.735,-11.015),(-24.735,-10.845),(-24.565,-10.845),(-24.565,-11.015),(-24.735,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.395,-11.015),(-24.395,-10.845),(-24.225,-10.845),(-24.225,-11.015),(-24.395,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.955,10.845),(-1.955,11.015),(-1.785,11.015),(-1.785,10.845),(-1.955,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.615,10.845),(-1.615,11.015),(-1.445,11.015),(-1.445,10.845),(-1.615,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.275,10.845),(-1.275,11.015),(-1.105,11.015),(-1.105,10.845),(-1.275,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((1.105,10.845),(1.105,11.015),(1.275,11.015),(1.275,10.845),(1.105,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((1.445,10.845),(1.445,11.015),(1.615,11.015),(1.615,10.845),(1.445,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((1.785,10.845),(1.785,11.015),(1.955,11.015),(1.955,10.845),(1.785,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-6.715),(44.675,-6.545),(44.845,-6.545),(44.845,-6.715),(44.675,-6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-6.375),(44.675,-6.205),(44.845,-6.205),(44.845,-6.375),(44.675,-6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,6.205),(44.675,6.375),(44.845,6.375),(44.845,6.205),(44.675,6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,6.545),(44.675,6.715),(44.845,6.715),(44.845,6.545),(44.675,6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.015,10.845),(-22.015,11.015),(-21.845,11.015),(-21.845,10.845),(-22.015,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.965,10.845),(10.965,11.015),(11.135,11.015),(11.135,10.845),(10.965,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.155,10.845),(-29.155,11.015),(-28.985,11.015),(-28.985,10.845),(-29.155,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.155,-11.015),(-29.155,-10.845),(-28.985,-10.845),(-28.985,-11.015),(-29.155,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((20.145,-11.015),(20.145,-10.845),(20.315,-10.845),(20.315,-11.015),(20.145,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((20.485,-11.015),(20.485,-10.845),(20.655,-10.845),(20.655,-11.015),(20.485,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((20.825,-11.015),(20.825,-10.845),(20.995,-10.845),(20.995,-11.015),(20.825,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((34.085,-11.015),(34.085,-10.845),(34.255,-10.845),(34.255,-11.015),(34.085,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((24.905,-11.015),(24.905,-10.845),(25.075,-10.845),(25.075,-11.015),(24.905,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((34.425,-11.015),(34.425,-10.845),(34.595,-10.845),(34.595,-11.015),(34.425,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((34.765,-11.015),(34.765,-10.845),(34.935,-10.845),(34.935,-11.015),(34.765,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.675,10.845),(-21.675,11.015),(-21.505,11.015),(-21.505,10.845),(-21.675,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.335,10.845),(-21.335,11.015),(-21.165,11.015),(-21.165,10.845),(-21.335,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.165,10.845),(21.165,11.015),(21.335,11.015),(21.335,10.845),(21.165,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.505,10.845),(21.505,11.015),(21.675,11.015),(21.675,10.845),(21.505,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-3.995),(44.675,-3.825),(44.845,-3.825),(44.845,-3.995),(44.675,-3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-3.655),(44.675,-3.485),(44.845,-3.485),(44.845,-3.655),(44.675,-3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-3.315),(44.675,-3.145),(44.845,-3.145),(44.845,-3.315),(44.675,-3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.675,10.845),(-4.675,11.015),(-4.505,11.015),(-4.505,10.845),(-4.675,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.335,10.845),(-4.335,11.015),(-4.165,11.015),(-4.165,10.845),(-4.335,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.675,-11.015),(-4.675,-10.845),(-4.505,-10.845),(-4.505,-11.015),(-4.675,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.335,-11.015),(-4.335,-10.845),(-4.165,-10.845),(-4.165,-11.015),(-4.335,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,3.145),(44.675,3.315),(44.845,3.315),(44.845,3.145),(44.675,3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,3.485),(44.675,3.655),(44.845,3.655),(44.845,3.485),(44.675,3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,3.825),(44.675,3.995),(44.845,3.995),(44.845,3.825),(44.675,3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.035,-11.015),(-6.035,-10.845),(-5.865,-10.845),(-5.865,-11.015),(-6.035,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,4.845),(44.675,5.015),(44.845,5.015),(44.845,4.845),(44.675,4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.995,-11.015),(-37.995,-10.845),(-37.825,-10.845),(-37.825,-11.015),(-37.995,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.655,-11.015),(-37.655,-10.845),(-37.485,-10.845),(-37.485,-11.015),(-37.655,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.315,-11.015),(-37.315,-10.845),(-37.145,-10.845),(-37.145,-11.015),(-37.315,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.675,10.845),(-38.675,11.015),(-38.505,11.015),(-38.505,10.845),(-38.675,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.335,10.845),(-38.335,11.015),(-38.165,11.015),(-38.165,10.845),(-38.335,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.265,10.845),(26.265,11.015),(26.435,11.015),(26.435,10.845),(26.265,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.605,10.845),(26.605,11.015),(26.775,11.015),(26.775,10.845),(26.605,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.205,-11.015),(40.205,-10.845),(40.375,-10.845),(40.375,-11.015),(40.205,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((40.545,-11.015),(40.545,-10.845),(40.715,-10.845),(40.715,-11.015),(40.545,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((32.045,10.845),(32.045,11.015),(32.215,11.015),(32.215,10.845),(32.045,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.385,10.845),(32.385,11.015),(32.555,11.015),(32.555,10.845),(32.385,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.725,10.845),(32.725,11.015),(32.895,11.015),(32.895,10.845),(32.725,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-10.455),(44.675,-10.285),(44.845,-10.285),(44.845,-10.455),(44.675,-10.455)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,10.285),(44.675,10.455),(44.845,10.455),(44.845,10.285),(44.675,10.285)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.735,10.845),(-41.735,11.015),(-41.565,11.015),(-41.565,10.845),(-41.735,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.395,10.845),(-41.395,11.015),(-41.225,11.015),(-41.225,10.845),(-41.395,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((41.225,10.845),(41.225,11.015),(41.395,11.015),(41.395,10.845),(41.225,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((41.565,10.845),(41.565,11.015),(41.735,11.015),(41.735,10.845),(41.565,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.755,-11.015),(-25.755,-10.845),(-25.585,-10.845),(-25.585,-11.015),(-25.755,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.415,-11.015),(-25.415,-10.845),(-25.245,-10.845),(-25.245,-11.015),(-25.415,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.715,-11.015),(-6.715,-10.845),(-6.545,-10.845),(-6.545,-11.015),(-6.715,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.375,-11.015),(-6.375,-10.845),(-6.205,-10.845),(-6.205,-11.015),(-6.375,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.075,10.845),(-25.075,11.015),(-24.905,11.015),(-24.905,10.845),(-25.075,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.865,10.845),(39.865,11.015),(40.035,11.015),(40.035,10.845),(39.865,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.075,-11.015),(-25.075,-10.845),(-24.905,-10.845),(-24.905,-11.015),(-25.075,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((4.845,10.845),(4.845,11.015),(5.015,11.015),(5.015,10.845),(4.845,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.875,-11.015),(-31.875,-10.845),(-31.705,-10.845),(-31.705,-11.015),(-31.875,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.535,-11.015),(-31.535,-10.845),(-31.365,-10.845),(-31.365,-11.015),(-31.535,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.195,-11.015),(-31.195,-10.845),(-31.025,-10.845),(-31.025,-11.015),(-31.195,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.915,-11.015),(-16.915,-10.845),(-16.745,-10.845),(-16.745,-11.015),(-16.915,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.575,-11.015),(-16.575,-10.845),(-16.405,-10.845),(-16.405,-11.015),(-16.575,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.235,-11.015),(-16.235,-10.845),(-16.065,-10.845),(-16.065,-11.015),(-16.235,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.955,10.845),(-35.955,11.015),(-35.785,11.015),(-35.785,10.845),(-35.955,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.615,10.845),(-35.615,11.015),(-35.445,11.015),(-35.445,10.845),(-35.615,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.275,10.845),(-35.275,11.015),(-35.105,11.015),(-35.105,10.845),(-35.275,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.105,10.845),(35.105,11.015),(35.275,11.015),(35.275,10.845),(35.105,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.445,10.845),(35.445,11.015),(35.615,11.015),(35.615,10.845),(35.445,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.785,10.845),(35.785,11.015),(35.955,11.015),(35.955,10.845),(35.785,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.135,10.845),(-11.135,11.015),(-10.965,11.015),(-10.965,10.845),(-11.135,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-5.015),(-44.845,-4.845),(-44.675,-4.845),(-44.675,-5.015),(-44.845,-5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.115,-11.015),(-27.115,-10.845),(-26.945,-10.845),(-26.945,-11.015),(-27.115,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.035,10.845),(-23.035,11.015),(-22.865,11.015),(-22.865,10.845),(-23.035,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((24.905,10.845),(24.905,11.015),(25.075,11.015),(25.075,10.845),(24.905,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((36.125,10.845),(36.125,11.015),(36.295,11.015),(36.295,10.845),(36.125,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((36.465,10.845),(36.465,11.015),(36.635,11.015),(36.635,10.845),(36.465,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((36.805,10.845),(36.805,11.015),(36.975,11.015),(36.975,10.845),(36.805,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,5.865),(44.675,6.035),(44.845,6.035),(44.845,5.865),(44.675,5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-9.775),(-44.845,-9.605),(-44.675,-9.605),(-44.675,-9.775),(-44.845,-9.775)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-9.435),(-44.845,-9.265),(-44.675,-9.265),(-44.675,-9.435),(-44.845,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.015,-11.015),(-39.015,-10.845),(-38.845,-10.845),(-38.845,-11.015),(-39.015,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.895,10.845),(-32.895,11.015),(-32.725,11.015),(-32.725,10.845),(-32.895,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.555,10.845),(-32.555,11.015),(-32.385,11.015),(-32.385,10.845),(-32.555,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.215,10.845),(-32.215,11.015),(-32.045,11.015),(-32.045,10.845),(-32.215,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,9.265),(-44.845,9.435),(-44.675,9.435),(-44.675,9.265),(-44.845,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,9.605),(-44.845,9.775),(-44.675,9.775),(-44.675,9.605),(-44.845,9.605)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-8.755),(-44.845,-8.585),(-44.675,-8.585),(-44.675,-8.755),(-44.845,-8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-8.415),(-44.845,-8.245),(-44.675,-8.245),(-44.675,-8.415),(-44.845,-8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.095,-11.015),(-26.095,-10.845),(-25.925,-10.845),(-25.925,-11.015),(-26.095,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((39.185,-11.015),(39.185,-10.845),(39.355,-10.845),(39.355,-11.015),(39.185,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((39.525,-11.015),(39.525,-10.845),(39.695,-10.845),(39.695,-11.015),(39.525,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-8.755),(44.675,-8.585),(44.845,-8.585),(44.845,-8.755),(44.675,-8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-8.415),(44.675,-8.245),(44.845,-8.245),(44.845,-8.415),(44.675,-8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((39.865,-11.015),(39.865,-10.845),(40.035,-10.845),(40.035,-11.015),(39.865,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((22.865,-11.015),(22.865,-10.845),(23.035,-10.845),(23.035,-11.015),(22.865,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.955,10.845),(-18.955,11.015),(-18.785,11.015),(-18.785,10.845),(-18.955,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.615,10.845),(-18.615,11.015),(-18.445,11.015),(-18.445,10.845),(-18.615,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.275,10.845),(-18.275,11.015),(-18.105,11.015),(-18.105,10.845),(-18.275,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((24.225,10.845),(24.225,11.015),(24.395,11.015),(24.395,10.845),(24.225,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((24.565,10.845),(24.565,11.015),(24.735,11.015),(24.735,10.845),(24.565,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.305,-11.015),(11.305,-10.845),(11.475,-10.845),(11.475,-11.015),(11.305,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((11.645,-11.015),(11.645,-10.845),(11.815,-10.845),(11.815,-11.015),(11.645,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.795,10.845),(-10.795,11.015),(-10.625,11.015),(-10.625,10.845),(-10.795,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.455,10.845),(-10.455,11.015),(-10.285,11.015),(-10.285,10.845),(-10.455,10.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.775,-11.015),(-26.775,-10.845),(-26.605,-10.845),(-26.605,-11.015),(-26.775,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.435,-11.015),(-26.435,-10.845),(-26.265,-10.845),(-26.265,-11.015),(-26.435,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,-6.035),(44.675,-5.865),(44.845,-5.865),(44.845,-6.035),(44.675,-6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((44.675,6.885),(44.675,7.055),(44.845,7.055),(44.845,6.885),(44.675,6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.945,-11.015),(9.945,-10.845),(10.115,-10.845),(10.115,-11.015),(9.945,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((22.185,-11.015),(22.185,-10.845),(22.355,-10.845),(22.355,-11.015),(22.185,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((22.525,-11.015),(22.525,-10.845),(22.695,-10.845),(22.695,-11.015),(22.525,-11.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-2.975),(-44.845,-2.805),(-44.675,-2.805),(-44.675,-2.975),(-44.845,-2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-2.635),(-44.845,-2.465),(-44.675,-2.465),(-44.675,-2.635),(-44.845,-2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,-2.295),(-44.845,-2.125),(-44.675,-2.125),(-44.675,-2.295),(-44.845,-2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,2.125),(-44.845,2.295),(-44.675,2.295),(-44.675,2.125),(-44.845,2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,2.465),(-44.845,2.635),(-44.675,2.635),(-44.675,2.465),(-44.845,2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-44.845,2.805),(-44.845,2.975),(-44.675,2.975),(-44.675,2.805),(-44.845,2.805)),
        )
        createRL(
            tech, net, 'li',
            ((-45.0,-11.17),(-45.0,-10.69),(45.0,-10.69),(45.0,-11.17),(-45.0,-11.17)),
        )
        createRL(
            tech, net, 'li',
            ((-44.795,10.765),(-44.795,11.095),(44.795,11.095),(44.795,10.765),(-44.795,10.765)),
        )
        createRL(
            tech, net, 'li',
            ((-44.795,-11.095),(-44.795,-10.765),(44.795,-10.765),(44.795,-11.095),(-44.795,-11.095)),
        )
        createRL(
            tech, net, 'li',
            ((44.52,-11.17),(44.52,11.17),(45.0,11.17),(45.0,-11.17),(44.52,-11.17)),
        )
        createRL(
            tech, net, 'li',
            ((-45.0,10.69),(-45.0,11.17),(45.0,11.17),(45.0,10.69),(-45.0,10.69)),
        )
        createRL(
            tech, net, 'li',
            ((44.675,-10.535),(44.675,10.535),(44.845,10.535),(44.845,-10.535),(44.675,-10.535)),
        )
        createRL(
            tech, net, 'li',
            ((-45.0,-11.17),(-45.0,11.17),(-44.52,11.17),(-44.52,-11.17),(-45.0,-11.17)),
        )
        createRL(
            tech, net, 'li',
            ((-44.845,-10.535),(-44.845,10.535),(-44.675,10.535),(-44.675,-10.535),(-44.845,-10.535)),
        )
        createRL(
            tech, net, 'nwm',
            ((-45.18,-11.35),(-45.18,-10.51),(45.18,-10.51),(45.18,-11.35),(-45.18,-11.35)),
        )
        createRL(
            tech, net, 'nwm',
            ((-45.18,10.51),(-45.18,11.35),(45.18,11.35),(45.18,10.51),(-45.18,10.51)),
        )
        createRL(
            tech, net, 'nwm',
            ((44.34,-10.87),(44.34,10.87),(45.18,10.87),(45.18,-10.87),(44.34,-10.87)),
        )
        createRL(
            tech, net, 'nwm',
            ((-45.18,-10.87),(-45.18,10.87),(-44.34,10.87),(-44.34,-10.87),(-45.18,-10.87)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-45.125,-11.295),(-45.125,-10.565),(45.125,-10.565),(45.125,-11.295),(-45.125,-11.295)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-45.125,10.565),(-45.125,11.295),(45.125,11.295),(45.125,10.565),(-45.125,10.565)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.395,-10.815),(44.395,10.815),(45.125,10.815),(45.125,-10.815),(44.395,-10.815)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-45.125,-10.815),(-45.125,10.815),(-44.395,10.815),(-44.395,-10.815),(-45.125,-10.815)),
        )
        nets['conn'].setDirection(Net.Direction.IN)

    cell = new_cells['GuardRing_P17368W3836HFF']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-43.42), u(-9.59), u(43.42), u(9.59),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'conn': Net.create(cell, 'conn'),
        }
        net = nets['conn']
        createRL(
            tech, net, 'difftap',
            ((42.94,-9.11),(42.94,9.11),(43.42,9.11),(43.42,-9.11),(42.94,-9.11)),
        )
        createRL(
            tech, net, 'difftap',
            ((-43.42,-9.59),(-43.42,-9.11),(43.42,-9.11),(43.42,-9.59),(-43.42,-9.59)),
        )
        createRL(
            tech, net, 'difftap',
            ((-43.42,-9.11),(-43.42,9.11),(-42.94,9.11),(-42.94,-9.11),(-43.42,-9.11)),
        )
        createRL(
            tech, net, 'difftap',
            ((-43.42,9.11),(-43.42,9.59),(43.42,9.59),(43.42,9.11),(-43.42,9.11)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.145,-9.435),(-37.145,-9.265),(-36.975,-9.265),(-36.975,-9.435),(-37.145,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.745,-9.435),(-16.745,-9.265),(-16.575,-9.265),(-16.575,-9.435),(-16.745,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.405,-9.435),(-16.405,-9.265),(-16.235,-9.265),(-16.235,-9.435),(-16.405,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.405,9.265),(-16.405,9.435),(-16.235,9.435),(-16.235,9.265),(-16.405,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.745,9.265),(-16.745,9.435),(-16.575,9.435),(-16.575,9.265),(-16.745,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((15.215,9.265),(15.215,9.435),(15.385,9.435),(15.385,9.265),(15.215,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,1.955),(-43.265,2.125),(-43.095,2.125),(-43.095,1.955),(-43.265,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((15.555,9.265),(15.555,9.435),(15.725,9.435),(15.725,9.265),(15.555,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.725,-9.435),(-15.725,-9.265),(-15.555,-9.265),(-15.555,-9.435),(-15.725,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.385,-9.435),(-15.385,-9.265),(-15.215,-9.265),(-15.215,-9.435),(-15.385,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.945,9.265),(-26.945,9.435),(-26.775,9.435),(-26.775,9.265),(-26.945,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.605,9.265),(-26.605,9.435),(-26.435,9.435),(-26.435,9.265),(-26.605,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.265,9.265),(-26.265,9.435),(-26.095,9.435),(-26.095,9.265),(-26.265,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.935,9.265),(34.935,9.435),(35.105,9.435),(35.105,9.265),(34.935,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.945,-9.435),(-26.945,-9.265),(-26.775,-9.265),(-26.775,-9.435),(-26.945,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.605,-9.435),(-26.605,-9.265),(-26.435,-9.265),(-26.435,-9.435),(-26.605,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.265,-9.435),(-26.265,-9.265),(-26.095,-9.265),(-26.095,-9.435),(-26.265,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.145,-9.435),(-3.145,-9.265),(-2.975,-9.265),(-2.975,-9.435),(-3.145,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-0.085),(43.095,0.085),(43.265,0.085),(43.265,-0.085),(43.095,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-0.085),(-43.265,0.085),(-43.095,0.085),(-43.095,-0.085),(-43.265,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.955,-9.435),(1.955,-9.265),(2.125,-9.265),(2.125,-9.435),(1.955,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.865,9.265),(-5.865,9.435),(-5.695,9.435),(-5.695,9.265),(-5.865,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.525,9.265),(-5.525,9.435),(-5.355,9.435),(-5.355,9.265),(-5.525,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.185,9.265),(-5.185,9.435),(-5.015,9.435),(-5.015,9.265),(-5.185,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((5.015,-9.435),(5.015,-9.265),(5.185,-9.265),(5.185,-9.435),(5.015,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,6.035),(43.095,6.205),(43.265,6.205),(43.265,6.035),(43.095,6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,6.375),(43.095,6.545),(43.265,6.545),(43.265,6.375),(43.095,6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,6.715),(43.095,6.885),(43.265,6.885),(43.265,6.715),(43.095,6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,6.035),(-43.265,6.205),(-43.095,6.205),(-43.095,6.035),(-43.265,6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,6.375),(-43.265,6.545),(-43.095,6.545),(-43.095,6.375),(-43.265,6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,6.715),(-43.265,6.885),(-43.095,6.885),(-43.095,6.715),(-43.265,6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.085,-9.435),(-34.085,-9.265),(-33.915,-9.265),(-33.915,-9.435),(-34.085,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((13.855,-9.435),(13.855,-9.265),(14.025,-9.265),(14.025,-9.435),(13.855,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.045,-9.435),(-32.045,-9.265),(-31.875,-9.265),(-31.875,-9.435),(-32.045,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((15.895,-9.435),(15.895,-9.265),(16.065,-9.265),(16.065,-9.435),(15.895,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.025,9.265),(-14.025,9.435),(-13.855,9.435),(-13.855,9.265),(-14.025,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.905,-9.435),(-7.905,-9.265),(-7.735,-9.265),(-7.735,-9.435),(-7.905,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((19.975,-9.435),(19.975,-9.265),(20.145,-9.265),(20.145,-9.435),(19.975,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.925,9.265),(-25.925,9.435),(-25.755,9.435),(-25.755,9.265),(-25.925,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.585,9.265),(-25.585,9.435),(-25.415,9.435),(-25.415,9.265),(-25.585,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.245,9.265),(-25.245,9.435),(-25.075,9.435),(-25.075,9.265),(-25.245,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.075,-9.435),(25.075,-9.265),(25.245,-9.265),(25.245,-9.435),(25.075,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,-9.435),(25.415,-9.265),(25.585,-9.265),(25.585,-9.435),(25.415,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((25.755,-9.435),(25.755,-9.265),(25.925,-9.265),(25.925,-9.435),(25.755,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-0.425),(-43.265,-0.255),(-43.095,-0.255),(-43.095,-0.425),(-43.265,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-0.425),(43.095,-0.255),(43.265,-0.255),(43.265,-0.425),(43.095,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,0.255),(43.095,0.425),(43.265,0.425),(43.265,0.255),(43.095,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,0.255),(-43.265,0.425),(-43.095,0.425),(-43.095,0.255),(-43.265,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,7.395),(-43.265,7.565),(-43.095,7.565),(-43.095,7.395),(-43.265,7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-7.565),(43.095,-7.395),(43.265,-7.395),(43.265,-7.565),(43.095,-7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-7.905),(43.095,-7.735),(43.265,-7.735),(43.265,-7.905),(43.095,-7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-7.225),(43.095,-7.055),(43.265,-7.055),(43.265,-7.225),(43.095,-7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.325,-9.435),(-29.325,-9.265),(-29.155,-9.265),(-29.155,-9.435),(-29.325,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.105,-9.435),(-1.105,-9.265),(-0.935,-9.265),(-0.935,-9.435),(-1.105,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,7.735),(-43.265,7.905),(-43.095,7.905),(-43.095,7.735),(-43.265,7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((29.155,9.265),(29.155,9.435),(29.325,9.435),(29.325,9.265),(29.155,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((29.495,9.265),(29.495,9.435),(29.665,9.435),(29.665,9.265),(29.495,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.665,-9.435),(-29.665,-9.265),(-29.495,-9.265),(-29.495,-9.435),(-29.665,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-1.105),(-43.265,-0.935),(-43.095,-0.935),(-43.095,-1.105),(-43.265,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.935,-9.435),(0.935,-9.265),(1.105,-9.265),(1.105,-9.435),(0.935,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-3.145),(-43.265,-2.975),(-43.095,-2.975),(-43.095,-3.145),(-43.265,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.025,9.265),(-31.025,9.435),(-30.855,9.435),(-30.855,9.265),(-31.025,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,9.265),(1.275,9.435),(1.445,9.435),(1.445,9.265),(1.275,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((1.615,9.265),(1.615,9.435),(1.785,9.435),(1.785,9.265),(1.615,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.785,-9.435),(-1.785,-9.265),(-1.615,-9.265),(-1.615,-9.435),(-1.785,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.445,-9.435),(-1.445,-9.265),(-1.275,-9.265),(-1.275,-9.435),(-1.445,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((12.835,-9.435),(12.835,-9.265),(13.005,-9.265),(13.005,-9.435),(12.835,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.025,-9.435),(-31.025,-9.265),(-30.855,-9.265),(-30.855,-9.435),(-31.025,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.805,9.265),(-36.805,9.435),(-36.635,9.435),(-36.635,9.265),(-36.805,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.465,9.265),(-36.465,9.435),(-36.295,9.435),(-36.295,9.265),(-36.465,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.805,-9.435),(-36.805,-9.265),(-36.635,-9.265),(-36.635,-9.435),(-36.805,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.465,-9.435),(-36.465,-9.265),(-36.295,-9.265),(-36.295,-9.435),(-36.465,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((11.475,-9.435),(11.475,-9.265),(11.645,-9.265),(11.645,-9.435),(11.475,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((11.815,-9.435),(11.815,-9.265),(11.985,-9.265),(11.985,-9.435),(11.815,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((21.675,9.265),(21.675,9.435),(21.845,9.435),(21.845,9.265),(21.675,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((21.335,9.265),(21.335,9.435),(21.505,9.435),(21.505,9.265),(21.335,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.985,9.265),(-11.985,9.435),(-11.815,9.435),(-11.815,9.265),(-11.985,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.505,-9.435),(-21.505,-9.265),(-21.335,-9.265),(-21.335,-9.435),(-21.505,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.305,9.265),(-11.305,9.435),(-11.135,9.435),(-11.135,9.265),(-11.305,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.845,-9.435),(-21.845,-9.265),(-21.675,-9.265),(-21.675,-9.435),(-21.845,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.645,9.265),(-11.645,9.435),(-11.475,9.435),(-11.475,9.265),(-11.645,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.135,-9.435),(11.135,-9.265),(11.305,-9.265),(11.305,-9.435),(11.135,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((6.375,9.265),(6.375,9.435),(6.545,9.435),(6.545,9.265),(6.375,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.035,9.265),(6.035,9.435),(6.205,9.435),(6.205,9.265),(6.035,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.715,9.265),(6.715,9.435),(6.885,9.435),(6.885,9.265),(6.715,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.035,-9.435),(6.035,-9.265),(6.205,-9.265),(6.205,-9.435),(6.035,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((6.375,-9.435),(6.375,-9.265),(6.545,-9.265),(6.545,-9.435),(6.375,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((6.715,-9.435),(6.715,-9.265),(6.885,-9.265),(6.885,-9.435),(6.715,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.885,9.265),(-23.885,9.435),(-23.715,9.435),(-23.715,9.265),(-23.885,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.545,9.265),(-23.545,9.435),(-23.375,9.435),(-23.375,9.265),(-23.545,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.205,9.265),(-23.205,9.435),(-23.035,9.435),(-23.035,9.265),(-23.205,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.035,-9.435),(23.035,-9.265),(23.205,-9.265),(23.205,-9.435),(23.035,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((23.375,-9.435),(23.375,-9.265),(23.545,-9.265),(23.545,-9.435),(23.375,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((23.715,-9.435),(23.715,-9.265),(23.885,-9.265),(23.885,-9.435),(23.715,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.125,9.265),(-36.125,9.435),(-35.955,9.435),(-35.955,9.265),(-36.125,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.485,9.265),(-3.485,9.435),(-3.315,9.435),(-3.315,9.265),(-3.485,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-1.785),(43.095,-1.615),(43.265,-1.615),(43.265,-1.785),(43.095,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-1.445),(43.095,-1.275),(43.265,-1.275),(43.265,-1.445),(43.095,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,1.275),(-43.265,1.445),(-43.095,1.445),(-43.095,1.275),(-43.265,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,1.615),(-43.265,1.785),(-43.095,1.785),(-43.095,1.615),(-43.265,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.825,9.265),(-3.825,9.435),(-3.655,9.435),(-3.655,9.265),(-3.825,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((3.315,-9.435),(3.315,-9.265),(3.485,-9.265),(3.485,-9.435),(3.315,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((3.655,-9.435),(3.655,-9.265),(3.825,-9.265),(3.825,-9.435),(3.655,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((2.975,9.265),(2.975,9.435),(3.145,9.435),(3.145,9.265),(2.975,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.125,-9.435),(-2.125,-9.265),(-1.955,-9.265),(-1.955,-9.435),(-2.125,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((24.055,9.265),(24.055,9.435),(24.225,9.435),(24.225,9.265),(24.055,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.395,9.265),(24.395,9.435),(24.565,9.435),(24.565,9.265),(24.395,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.735,9.265),(24.735,9.435),(24.905,9.435),(24.905,9.265),(24.735,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.055,-9.435),(24.055,-9.265),(24.225,-9.265),(24.225,-9.435),(24.055,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((24.395,-9.435),(24.395,-9.265),(24.565,-9.265),(24.565,-9.435),(24.395,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((24.735,-9.435),(24.735,-9.265),(24.905,-9.265),(24.905,-9.435),(24.735,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((13.855,9.265),(13.855,9.435),(14.025,9.435),(14.025,9.265),(13.855,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.425,9.265),(-0.425,9.435),(-0.255,9.435),(-0.255,9.265),(-0.425,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.255,9.265),(0.255,9.435),(0.425,9.435),(0.425,9.265),(0.255,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.425,-9.435),(-0.425,-9.265),(-0.255,-9.265),(-0.255,-9.435),(-0.425,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((33.915,9.265),(33.915,9.435),(34.085,9.435),(34.085,9.265),(33.915,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.255,-9.435),(0.255,-9.265),(0.425,-9.265),(0.425,-9.435),(0.255,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.725,9.265),(-15.725,9.435),(-15.555,9.435),(-15.555,9.265),(-15.725,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.385,9.265),(-15.385,9.435),(-15.215,9.435),(-15.215,9.265),(-15.385,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((15.895,9.265),(15.895,9.435),(16.065,9.435),(16.065,9.265),(15.895,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((15.215,-9.435),(15.215,-9.265),(15.385,-9.265),(15.385,-9.435),(15.215,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((15.555,-9.435),(15.555,-9.265),(15.725,-9.265),(15.725,-9.435),(15.555,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((26.095,9.265),(26.095,9.435),(26.265,9.435),(26.265,9.265),(26.095,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.435,9.265),(26.435,9.435),(26.605,9.435),(26.605,9.265),(26.435,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.775,9.265),(26.775,9.435),(26.945,9.435),(26.945,9.265),(26.775,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.095,-9.435),(26.095,-9.265),(26.265,-9.265),(26.265,-9.435),(26.095,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((26.435,-9.435),(26.435,-9.265),(26.605,-9.265),(26.605,-9.435),(26.435,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((26.775,-9.435),(26.775,-9.265),(26.945,-9.265),(26.945,-9.435),(26.775,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((27.115,9.265),(27.115,9.435),(27.285,9.435),(27.285,9.265),(27.115,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.455,9.265),(27.455,9.435),(27.625,9.435),(27.625,9.265),(27.455,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.795,9.265),(27.795,9.435),(27.965,9.435),(27.965,9.265),(27.795,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.965,-9.435),(-27.965,-9.265),(-27.795,-9.265),(-27.795,-9.435),(-27.965,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.625,-9.435),(-27.625,-9.265),(-27.455,-9.265),(-27.455,-9.435),(-27.625,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.285,-9.435),(-27.285,-9.265),(-27.115,-9.265),(-27.115,-9.435),(-27.285,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((19.975,9.265),(19.975,9.435),(20.145,9.435),(20.145,9.265),(19.975,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.935,-9.435),(34.935,-9.265),(35.105,-9.265),(35.105,-9.435),(34.935,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.865,9.265),(-22.865,9.435),(-22.695,9.435),(-22.695,9.265),(-22.865,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.525,9.265),(-22.525,9.435),(-22.355,9.435),(-22.355,9.265),(-22.525,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.185,9.265),(-22.185,9.435),(-22.015,9.435),(-22.015,9.265),(-22.185,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.865,-9.435),(-22.865,-9.265),(-22.695,-9.265),(-22.695,-9.435),(-22.865,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.525,-9.435),(-22.525,-9.265),(-22.355,-9.265),(-22.355,-9.435),(-22.525,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.185,-9.435),(-22.185,-9.265),(-22.015,-9.265),(-22.015,-9.435),(-22.185,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((39.015,9.265),(39.015,9.435),(39.185,9.435),(39.185,9.265),(39.015,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.355,9.265),(39.355,9.435),(39.525,9.435),(39.525,9.265),(39.355,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.695,9.265),(39.695,9.435),(39.865,9.435),(39.865,9.265),(39.695,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.865,-9.435),(-39.865,-9.265),(-39.695,-9.265),(-39.695,-9.435),(-39.865,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.525,-9.435),(-39.525,-9.265),(-39.355,-9.265),(-39.355,-9.435),(-39.525,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.185,-9.435),(-39.185,-9.265),(-39.015,-9.265),(-39.015,-9.435),(-39.185,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((14.875,9.265),(14.875,9.435),(15.045,9.435),(15.045,9.265),(14.875,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.145,-9.435),(-20.145,-9.265),(-19.975,-9.265),(-19.975,-9.435),(-20.145,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,3.315),(43.095,3.485),(43.265,3.485),(43.265,3.315),(43.095,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,3.655),(43.095,3.825),(43.265,3.825),(43.265,3.655),(43.095,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-3.825),(-43.265,-3.655),(-43.095,-3.655),(-43.095,-3.825),(-43.265,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-3.485),(-43.265,-3.315),(-43.095,-3.315),(-43.095,-3.485),(-43.265,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.665,9.265),(-12.665,9.435),(-12.495,9.435),(-12.495,9.265),(-12.665,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.325,9.265),(-12.325,9.435),(-12.155,9.435),(-12.155,9.265),(-12.325,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.805,9.265),(-2.805,9.435),(-2.635,9.435),(-2.635,9.265),(-2.805,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.465,9.265),(-2.465,9.435),(-2.295,9.435),(-2.295,9.265),(-2.465,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.805,-9.435),(-2.805,-9.265),(-2.635,-9.265),(-2.635,-9.435),(-2.805,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.465,-9.435),(-2.465,-9.265),(-2.295,-9.265),(-2.295,-9.435),(-2.465,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.665,-9.435),(-12.665,-9.265),(-12.495,-9.265),(-12.495,-9.435),(-12.665,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.325,-9.435),(-12.325,-9.265),(-12.155,-9.265),(-12.155,-9.435),(-12.325,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((16.915,9.265),(16.915,9.435),(17.085,9.435),(17.085,9.265),(16.915,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.065,9.265),(-33.065,9.435),(-32.895,9.435),(-32.895,9.265),(-33.065,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.105,9.265),(-1.105,9.435),(-0.935,9.435),(-0.935,9.265),(-1.105,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.025,-9.435),(-14.025,-9.265),(-13.855,-9.265),(-13.855,-9.435),(-14.025,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((19.295,9.265),(19.295,9.435),(19.465,9.435),(19.465,9.265),(19.295,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((19.635,9.265),(19.635,9.435),(19.805,9.435),(19.805,9.265),(19.635,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.215,9.265),(32.215,9.435),(32.385,9.435),(32.385,9.265),(32.215,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.555,9.265),(32.555,9.435),(32.725,9.435),(32.725,9.265),(32.555,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.805,-9.435),(-19.805,-9.265),(-19.635,-9.265),(-19.635,-9.435),(-19.805,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.465,-9.435),(-19.465,-9.265),(-19.295,-9.265),(-19.295,-9.435),(-19.465,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((32.215,-9.435),(32.215,-9.265),(32.385,-9.265),(32.385,-9.435),(32.215,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((32.555,-9.435),(32.555,-9.265),(32.725,-9.265),(32.725,-9.435),(32.555,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.105,9.265),(-35.105,9.435),(-34.935,9.435),(-34.935,9.265),(-35.105,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.255,9.265),(34.255,9.435),(34.425,9.435),(34.425,9.265),(34.255,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.595,9.265),(34.595,9.435),(34.765,9.435),(34.765,9.265),(34.595,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.665,9.265),(-29.665,9.435),(-29.495,9.435),(-29.495,9.265),(-29.665,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.325,9.265),(-29.325,9.435),(-29.155,9.435),(-29.155,9.265),(-29.325,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.005,-9.435),(-13.005,-9.265),(-12.835,-9.265),(-12.835,-9.435),(-13.005,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((29.155,-9.435),(29.155,-9.265),(29.325,-9.265),(29.325,-9.435),(29.155,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((29.495,-9.435),(29.495,-9.265),(29.665,-9.265),(29.665,-9.435),(29.495,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((34.255,-9.435),(34.255,-9.265),(34.425,-9.265),(34.425,-9.435),(34.255,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((34.595,-9.435),(34.595,-9.265),(34.765,-9.265),(34.765,-9.435),(34.595,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.165,9.265),(-21.165,9.435),(-20.995,9.435),(-20.995,9.265),(-21.165,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.845,9.265),(-4.845,9.435),(-4.675,9.435),(-4.675,9.265),(-4.845,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.505,9.265),(-4.505,9.435),(-4.335,9.435),(-4.335,9.265),(-4.505,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.845,-9.435),(-4.845,-9.265),(-4.675,-9.265),(-4.675,-9.435),(-4.845,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.505,-9.435),(-4.505,-9.265),(-4.335,-9.265),(-4.335,-9.435),(-4.505,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-3.145),(43.095,-2.975),(43.265,-2.975),(43.265,-3.145),(43.095,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.085,-9.435),(-17.085,-9.265),(-16.915,-9.265),(-16.915,-9.435),(-17.085,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.785,9.265),(-1.785,9.435),(-1.615,9.435),(-1.615,9.265),(-1.785,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.445,9.265),(-1.445,9.435),(-1.275,9.435),(-1.275,9.265),(-1.445,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,-9.435),(1.275,-9.265),(1.445,-9.265),(1.445,-9.435),(1.275,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((1.615,-9.435),(1.615,-9.265),(1.785,-9.265),(1.785,-9.435),(1.615,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((41.055,9.265),(41.055,9.435),(41.225,9.435),(41.225,9.265),(41.055,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((41.395,9.265),(41.395,9.435),(41.565,9.435),(41.565,9.265),(41.395,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((41.735,9.265),(41.735,9.435),(41.905,9.435),(41.905,9.265),(41.735,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.905,-9.435),(-41.905,-9.265),(-41.735,-9.265),(-41.735,-9.435),(-41.905,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.565,-9.435),(-41.565,-9.265),(-41.395,-9.265),(-41.395,-9.435),(-41.565,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.225,-9.435),(-41.225,-9.265),(-41.055,-9.265),(-41.055,-9.435),(-41.225,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.365,-9.435),(-14.365,-9.265),(-14.195,-9.265),(-14.195,-9.435),(-14.365,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.705,9.265),(-14.705,9.435),(-14.535,9.435),(-14.535,9.265),(-14.705,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.365,9.265),(-14.365,9.435),(-14.195,9.435),(-14.195,9.265),(-14.365,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.705,-9.435),(-14.705,-9.265),(-14.535,-9.265),(-14.535,-9.435),(-14.705,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.925,9.265),(-42.925,9.435),(-42.755,9.435),(-42.755,9.265),(-42.925,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.585,9.265),(-42.585,9.435),(-42.415,9.435),(-42.415,9.265),(-42.585,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.245,9.265),(-42.245,9.435),(-42.075,9.435),(-42.075,9.265),(-42.245,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.925,-9.435),(-42.925,-9.265),(-42.755,-9.265),(-42.755,-9.435),(-42.925,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.585,-9.435),(-42.585,-9.265),(-42.415,-9.265),(-42.415,-9.435),(-42.585,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-42.245,-9.435),(-42.245,-9.265),(-42.075,-9.265),(-42.075,-9.435),(-42.245,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.125,-9.435),(-19.125,-9.265),(-18.955,-9.265),(-18.955,-9.435),(-19.125,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((36.295,9.265),(36.295,9.435),(36.465,9.435),(36.465,9.265),(36.295,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((36.635,9.265),(36.635,9.435),(36.805,9.435),(36.805,9.265),(36.635,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((36.295,-9.435),(36.295,-9.265),(36.465,-9.265),(36.465,-9.435),(36.295,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.165,9.265),(-4.165,9.435),(-3.995,9.435),(-3.995,9.265),(-4.165,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((36.635,-9.435),(36.635,-9.265),(36.805,-9.265),(36.805,-9.435),(36.635,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.845,9.265),(-21.845,9.435),(-21.675,9.435),(-21.675,9.265),(-21.845,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.505,9.265),(-21.505,9.435),(-21.335,9.435),(-21.335,9.265),(-21.505,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((21.335,-9.435),(21.335,-9.265),(21.505,-9.265),(21.505,-9.435),(21.335,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((21.675,-9.435),(21.675,-9.265),(21.845,-9.265),(21.845,-9.435),(21.675,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((29.835,-9.435),(29.835,-9.265),(30.005,-9.265),(30.005,-9.435),(29.835,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-2.805),(43.095,-2.635),(43.265,-2.635),(43.265,-2.805),(43.095,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-2.465),(43.095,-2.295),(43.265,-2.295),(43.265,-2.465),(43.095,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-2.805),(-43.265,-2.635),(-43.095,-2.635),(-43.095,-2.805),(-43.265,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-2.465),(-43.265,-2.295),(-43.095,-2.295),(-43.095,-2.465),(-43.265,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((36.975,9.265),(36.975,9.435),(37.145,9.435),(37.145,9.265),(36.975,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.955,-9.435),(35.955,-9.265),(36.125,-9.265),(36.125,-9.435),(35.955,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.105,9.265),(-18.105,9.435),(-17.935,9.435),(-17.935,9.265),(-18.105,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.065,9.265),(-16.065,9.435),(-15.895,9.435),(-15.895,9.265),(-16.065,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.885,9.265),(-40.885,9.435),(-40.715,9.435),(-40.715,9.265),(-40.885,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.545,9.265),(-40.545,9.435),(-40.375,9.435),(-40.375,9.265),(-40.545,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.205,9.265),(-40.205,9.435),(-40.035,9.435),(-40.035,9.265),(-40.205,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.885,-9.435),(-40.885,-9.265),(-40.715,-9.265),(-40.715,-9.435),(-40.885,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.545,-9.435),(-40.545,-9.265),(-40.375,-9.265),(-40.375,-9.435),(-40.545,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-40.205,-9.435),(-40.205,-9.265),(-40.035,-9.265),(-40.035,-9.435),(-40.205,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.725,9.265),(-32.725,9.435),(-32.555,9.435),(-32.555,9.265),(-32.725,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.385,9.265),(-32.385,9.435),(-32.215,9.435),(-32.215,9.265),(-32.385,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.725,-9.435),(-32.725,-9.265),(-32.555,-9.265),(-32.555,-9.435),(-32.725,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.385,-9.435),(-32.385,-9.265),(-32.215,-9.265),(-32.215,-9.435),(-32.385,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((31.195,9.265),(31.195,9.435),(31.365,9.435),(31.365,9.265),(31.195,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.535,9.265),(31.535,9.435),(31.705,9.435),(31.705,9.265),(31.535,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.705,-9.435),(-31.705,-9.265),(-31.535,-9.265),(-31.535,-9.435),(-31.705,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.365,-9.435),(-31.365,-9.265),(-31.195,-9.265),(-31.195,-9.435),(-31.365,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((17.935,-9.435),(17.935,-9.265),(18.105,-9.265),(18.105,-9.435),(17.935,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,3.995),(43.095,4.165),(43.265,4.165),(43.265,3.995),(43.095,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((2.975,-9.435),(2.975,-9.265),(3.145,-9.265),(3.145,-9.435),(2.975,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((5.355,-9.435),(5.355,-9.265),(5.525,-9.265),(5.525,-9.435),(5.355,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.165,9.265),(-38.165,9.435),(-37.995,9.435),(-37.995,9.265),(-38.165,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.005,9.265),(-30.005,9.435),(-29.835,9.435),(-29.835,9.265),(-30.005,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-0.765),(-43.265,-0.595),(-43.095,-0.595),(-43.095,-0.765),(-43.265,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,0.595),(-43.265,0.765),(-43.095,0.765),(-43.095,0.595),(-43.265,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-0.765),(43.095,-0.595),(43.265,-0.595),(43.265,-0.765),(43.095,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,0.595),(43.095,0.765),(43.265,0.765),(43.265,0.595),(43.095,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((27.115,-9.435),(27.115,-9.265),(27.285,-9.265),(27.285,-9.435),(27.115,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((27.455,-9.435),(27.455,-9.265),(27.625,-9.265),(27.625,-9.435),(27.455,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((27.795,-9.435),(27.795,-9.265),(27.965,-9.265),(27.965,-9.435),(27.795,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.485,-9.435),(-37.485,-9.265),(-37.315,-9.265),(-37.315,-9.435),(-37.485,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.965,9.265),(-27.965,9.435),(-27.795,9.435),(-27.795,9.265),(-27.965,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.625,9.265),(-27.625,9.435),(-27.455,9.435),(-27.455,9.265),(-27.625,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.285,9.265),(-27.285,9.435),(-27.115,9.435),(-27.115,9.265),(-27.285,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.315,9.265),(37.315,9.435),(37.485,9.435),(37.485,9.265),(37.315,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.655,9.265),(37.655,9.435),(37.825,9.435),(37.825,9.265),(37.655,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.825,-9.435),(-37.825,-9.265),(-37.655,-9.265),(-37.655,-9.435),(-37.825,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((22.355,-9.435),(22.355,-9.265),(22.525,-9.265),(22.525,-9.435),(22.355,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((22.695,-9.435),(22.695,-9.265),(22.865,-9.265),(22.865,-9.435),(22.695,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((22.015,9.265),(22.015,9.435),(22.185,9.435),(22.185,9.265),(22.015,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((22.355,9.265),(22.355,9.435),(22.525,9.435),(22.525,9.265),(22.355,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((22.695,9.265),(22.695,9.435),(22.865,9.435),(22.865,9.265),(22.695,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((22.015,-9.435),(22.015,-9.265),(22.185,-9.265),(22.185,-9.435),(22.015,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.865,9.265),(-39.865,9.435),(-39.695,9.435),(-39.695,9.265),(-39.865,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.525,9.265),(-39.525,9.435),(-39.355,9.435),(-39.355,9.265),(-39.525,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-39.185,9.265),(-39.185,9.435),(-39.015,9.435),(-39.015,9.265),(-39.185,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.015,-9.435),(39.015,-9.265),(39.185,-9.265),(39.185,-9.435),(39.015,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((39.355,-9.435),(39.355,-9.265),(39.525,-9.265),(39.525,-9.435),(39.355,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((39.695,-9.435),(39.695,-9.265),(39.865,-9.265),(39.865,-9.435),(39.695,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,9.265),(0.595,9.435),(0.765,9.435),(0.765,9.265),(0.595,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,-9.435),(0.595,-9.265),(0.765,-9.265),(0.765,-9.435),(0.595,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.765,-9.435),(-0.765,-9.265),(-0.595,-9.265),(-0.595,-9.435),(-0.765,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.765,9.265),(-0.765,9.435),(-0.595,9.435),(-0.595,9.265),(-0.765,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.995,-9.435),(20.995,-9.265),(21.165,-9.265),(21.165,-9.435),(20.995,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-3.825),(43.095,-3.655),(43.265,-3.655),(43.265,-3.825),(43.095,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,3.315),(-43.265,3.485),(-43.095,3.485),(-43.095,3.315),(-43.265,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((12.155,9.265),(12.155,9.435),(12.325,9.435),(12.325,9.265),(12.155,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((12.155,-9.435),(12.155,-9.265),(12.325,-9.265),(12.325,-9.435),(12.155,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((12.495,-9.435),(12.495,-9.265),(12.665,-9.265),(12.665,-9.435),(12.495,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,3.655),(-43.265,3.825),(-43.095,3.825),(-43.095,3.655),(-43.265,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((2.295,9.265),(2.295,9.435),(2.465,9.435),(2.465,9.265),(2.295,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((2.635,9.265),(2.635,9.435),(2.805,9.435),(2.805,9.265),(2.635,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((2.295,-9.435),(2.295,-9.265),(2.465,-9.265),(2.465,-9.435),(2.295,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((2.635,-9.435),(2.635,-9.265),(2.805,-9.265),(2.805,-9.435),(2.635,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((12.495,9.265),(12.495,9.435),(12.665,9.435),(12.665,9.265),(12.495,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((14.875,-9.435),(14.875,-9.265),(15.045,-9.265),(15.045,-9.435),(14.875,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((16.915,-9.435),(16.915,-9.265),(17.085,-9.265),(17.085,-9.435),(16.915,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.805,9.265),(-19.805,9.435),(-19.635,9.435),(-19.635,9.265),(-19.805,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.465,9.265),(-19.465,9.435),(-19.295,9.435),(-19.295,9.265),(-19.465,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((19.295,-9.435),(19.295,-9.265),(19.465,-9.265),(19.465,-9.435),(19.295,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((19.635,-9.435),(19.635,-9.265),(19.805,-9.265),(19.805,-9.435),(19.635,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((17.255,9.265),(17.255,9.435),(17.425,9.435),(17.425,9.265),(17.255,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((17.595,9.265),(17.595,9.435),(17.765,9.435),(17.765,9.265),(17.595,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.425,-9.435),(-17.425,-9.265),(-17.255,-9.265),(-17.255,-9.435),(-17.425,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.765,-9.435),(-17.765,-9.265),(-17.595,-9.265),(-17.595,-9.435),(-17.765,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((9.775,9.265),(9.775,9.435),(9.945,9.435),(9.945,9.265),(9.775,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.095,9.265),(9.095,9.435),(9.265,9.435),(9.265,9.265),(9.095,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.435,9.265),(9.435,9.435),(9.605,9.435),(9.605,9.265),(9.435,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.945,-9.435),(-9.945,-9.265),(-9.775,-9.265),(-9.775,-9.435),(-9.945,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.605,-9.435),(-9.605,-9.265),(-9.435,-9.265),(-9.435,-9.435),(-9.605,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((12.835,9.265),(12.835,9.435),(13.005,9.435),(13.005,9.265),(12.835,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.265,-9.435),(-9.265,-9.265),(-9.095,-9.265),(-9.095,-9.435),(-9.265,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((31.875,-9.435),(31.875,-9.265),(32.045,-9.265),(32.045,-9.435),(31.875,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((4.335,9.265),(4.335,9.435),(4.505,9.435),(4.505,9.265),(4.335,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-2.125),(43.095,-1.955),(43.265,-1.955),(43.265,-2.125),(43.095,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-2.125),(-43.265,-1.955),(-43.095,-1.955),(-43.095,-2.125),(-43.265,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((4.675,9.265),(4.675,9.435),(4.845,9.435),(4.845,9.265),(4.675,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((4.335,-9.435),(4.335,-9.265),(4.505,-9.265),(4.505,-9.435),(4.335,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((4.675,-9.435),(4.675,-9.265),(4.845,-9.265),(4.845,-9.435),(4.675,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((40.035,9.265),(40.035,9.435),(40.205,9.435),(40.205,9.265),(40.035,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.375,9.265),(40.375,9.435),(40.545,9.435),(40.545,9.265),(40.375,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.715,9.265),(40.715,9.435),(40.885,9.435),(40.885,9.265),(40.715,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.035,-9.435),(40.035,-9.265),(40.205,-9.265),(40.205,-9.435),(40.035,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((40.375,-9.435),(40.375,-9.265),(40.545,-9.265),(40.545,-9.435),(40.375,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((40.715,-9.435),(40.715,-9.265),(40.885,-9.265),(40.885,-9.435),(40.715,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((41.055,-9.435),(41.055,-9.265),(41.225,-9.265),(41.225,-9.435),(41.055,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((41.395,-9.435),(41.395,-9.265),(41.565,-9.265),(41.565,-9.435),(41.395,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((41.735,-9.435),(41.735,-9.265),(41.905,-9.265),(41.905,-9.435),(41.735,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.905,9.265),(-41.905,9.435),(-41.735,9.435),(-41.735,9.265),(-41.905,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.565,9.265),(-41.565,9.435),(-41.395,9.435),(-41.395,9.265),(-41.565,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-41.225,9.265),(-41.225,9.435),(-41.055,9.435),(-41.055,9.265),(-41.225,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((14.195,9.265),(14.195,9.435),(14.365,9.435),(14.365,9.265),(14.195,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((14.535,9.265),(14.535,9.435),(14.705,9.435),(14.705,9.265),(14.535,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((29.835,9.265),(29.835,9.435),(30.005,9.435),(30.005,9.265),(29.835,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((14.195,-9.435),(14.195,-9.265),(14.365,-9.265),(14.365,-9.435),(14.195,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((14.535,-9.435),(14.535,-9.265),(14.705,-9.265),(14.705,-9.435),(14.535,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,5.015),(43.095,5.185),(43.265,5.185),(43.265,5.015),(43.095,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,5.355),(43.095,5.525),(43.265,5.525),(43.265,5.355),(43.095,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,5.695),(43.095,5.865),(43.265,5.865),(43.265,5.695),(43.095,5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-5.865),(-43.265,-5.695),(-43.095,-5.695),(-43.095,-5.865),(-43.265,-5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-5.525),(-43.265,-5.355),(-43.095,-5.355),(-43.095,-5.525),(-43.265,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-5.185),(-43.265,-5.015),(-43.095,-5.015),(-43.095,-5.185),(-43.265,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.075,9.265),(42.075,9.435),(42.245,9.435),(42.245,9.265),(42.075,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.415,9.265),(42.415,9.435),(42.585,9.435),(42.585,9.265),(42.415,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.755,9.265),(42.755,9.435),(42.925,9.435),(42.925,9.265),(42.755,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.075,-9.435),(42.075,-9.265),(42.245,-9.265),(42.245,-9.435),(42.075,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((42.415,-9.435),(42.415,-9.265),(42.585,-9.265),(42.585,-9.435),(42.415,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((42.755,-9.435),(42.755,-9.265),(42.925,-9.265),(42.925,-9.435),(42.755,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.085,9.265),(-0.085,9.435),(0.085,9.435),(0.085,9.265),(-0.085,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.085,-9.435),(-0.085,-9.265),(0.085,-9.265),(0.085,-9.435),(-0.085,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((1.955,9.265),(1.955,9.435),(2.125,9.435),(2.125,9.265),(1.955,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.955,9.265),(35.955,9.435),(36.125,9.435),(36.125,9.265),(35.955,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.785,-9.435),(-18.785,-9.265),(-18.615,-9.265),(-18.615,-9.435),(-18.785,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.925,9.265),(-8.925,9.435),(-8.755,9.435),(-8.755,9.265),(-8.925,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.585,9.265),(-8.585,9.435),(-8.415,9.435),(-8.415,9.265),(-8.585,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.245,9.265),(-8.245,9.435),(-8.075,9.435),(-8.075,9.265),(-8.245,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.925,-9.435),(-8.925,-9.265),(-8.755,-9.265),(-8.755,-9.435),(-8.925,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.585,-9.435),(-8.585,-9.265),(-8.415,-9.265),(-8.415,-9.435),(-8.585,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.245,-9.435),(-8.245,-9.265),(-8.075,-9.265),(-8.075,-9.435),(-8.245,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.225,-9.435),(-7.225,-9.265),(-7.055,-9.265),(-7.055,-9.435),(-7.225,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.565,-9.435),(-7.565,-9.265),(-7.395,-9.265),(-7.395,-9.435),(-7.565,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((7.735,9.265),(7.735,9.435),(7.905,9.435),(7.905,9.265),(7.735,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.055,9.265),(7.055,9.435),(7.225,9.435),(7.225,9.265),(7.055,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.395,9.265),(7.395,9.435),(7.565,9.435),(7.565,9.265),(7.395,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.985,9.265),(-28.985,9.435),(-28.815,9.435),(-28.815,9.265),(-28.985,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.645,9.265),(-28.645,9.435),(-28.475,9.435),(-28.475,9.265),(-28.645,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.305,9.265),(-28.305,9.435),(-28.135,9.435),(-28.135,9.265),(-28.305,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.985,-9.435),(-28.985,-9.265),(-28.815,-9.265),(-28.815,-9.435),(-28.985,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.645,-9.435),(-28.645,-9.265),(-28.475,-9.265),(-28.475,-9.435),(-28.645,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.305,-9.435),(-28.305,-9.265),(-28.135,-9.265),(-28.135,-9.435),(-28.305,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((18.955,9.265),(18.955,9.435),(19.125,9.435),(19.125,9.265),(18.955,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.275,9.265),(35.275,9.435),(35.445,9.435),(35.445,9.265),(35.275,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.615,9.265),(35.615,9.435),(35.785,9.435),(35.785,9.265),(35.615,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.785,-9.435),(-35.785,-9.265),(-35.615,-9.265),(-35.615,-9.435),(-35.785,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.445,-9.435),(-35.445,-9.265),(-35.275,-9.265),(-35.275,-9.435),(-35.445,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.105,-9.435),(-18.105,-9.265),(-17.935,-9.265),(-17.935,-9.435),(-18.105,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,0.935),(43.095,1.105),(43.265,1.105),(43.265,0.935),(43.095,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-6.545),(43.095,-6.375),(43.265,-6.375),(43.265,-6.545),(43.095,-6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-6.205),(43.095,-6.035),(43.265,-6.035),(43.265,-6.205),(43.095,-6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-6.885),(43.095,-6.715),(43.265,-6.715),(43.265,-6.885),(43.095,-6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-6.885),(-43.265,-6.715),(-43.095,-6.715),(-43.095,-6.885),(-43.265,-6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-6.545),(-43.265,-6.375),(-43.095,-6.375),(-43.095,-6.545),(-43.265,-6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-6.205),(-43.265,-6.035),(-43.095,-6.035),(-43.095,-6.205),(-43.265,-6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,0.935),(-43.265,1.105),(-43.095,1.105),(-43.095,0.935),(-43.265,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.065,-9.435),(-16.065,-9.265),(-15.895,-9.265),(-15.895,-9.435),(-16.065,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.705,9.265),(-31.705,9.435),(-31.535,9.435),(-31.535,9.265),(-31.705,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.145,9.265),(-37.145,9.435),(-36.975,9.435),(-36.975,9.265),(-37.145,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-31.365,9.265),(-31.365,9.435),(-31.195,9.435),(-31.195,9.265),(-31.365,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.195,-9.435),(31.195,-9.265),(31.365,-9.265),(31.365,-9.435),(31.195,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((31.535,-9.435),(31.535,-9.265),(31.705,-9.265),(31.705,-9.435),(31.535,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.825,9.265),(-20.825,9.435),(-20.655,9.435),(-20.655,9.265),(-20.825,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.485,9.265),(-20.485,9.435),(-20.315,9.435),(-20.315,9.265),(-20.485,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.825,-9.435),(-20.825,-9.265),(-20.655,-9.265),(-20.655,-9.435),(-20.825,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.145,9.265),(-3.145,9.435),(-2.975,9.435),(-2.975,9.265),(-3.145,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.485,-9.435),(-20.485,-9.265),(-20.315,-9.265),(-20.315,-9.435),(-20.485,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.065,-9.435),(-33.065,-9.265),(-32.895,-9.265),(-32.895,-9.435),(-33.065,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,3.995),(-43.265,4.165),(-43.095,4.165),(-43.095,3.995),(-43.265,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.765,9.265),(-34.765,9.435),(-34.595,9.435),(-34.595,9.265),(-34.765,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.425,9.265),(-34.425,9.435),(-34.255,9.435),(-34.255,9.265),(-34.425,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.765,-9.435),(-34.765,-9.265),(-34.595,-9.265),(-34.595,-9.435),(-34.765,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.425,-9.435),(-34.425,-9.265),(-34.255,-9.265),(-34.255,-9.435),(-34.425,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.855,9.265),(30.855,9.435),(31.025,9.435),(31.025,9.265),(30.855,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.105,-9.435),(-35.105,-9.265),(-34.935,-9.265),(-34.935,-9.435),(-35.105,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.165,-9.435),(-38.165,-9.265),(-37.995,-9.265),(-37.995,-9.435),(-38.165,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-4.845),(43.095,-4.675),(43.265,-4.675),(43.265,-4.845),(43.095,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.915,-9.435),(33.915,-9.265),(34.085,-9.265),(34.085,-9.435),(33.915,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.145,9.265),(-20.145,9.435),(-19.975,9.435),(-19.975,9.265),(-20.145,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.445,9.265),(-18.445,9.435),(-18.275,9.435),(-18.275,9.265),(-18.445,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.655,-9.435),(37.655,-9.265),(37.825,-9.265),(37.825,-9.435),(37.655,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-4.505),(43.095,-4.335),(43.265,-4.335),(43.265,-4.505),(43.095,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-4.845),(-43.265,-4.675),(-43.095,-4.675),(-43.095,-4.845),(-43.265,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-4.505),(-43.265,-4.335),(-43.095,-4.335),(-43.095,-4.505),(-43.265,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.825,9.265),(-37.825,9.435),(-37.655,9.435),(-37.655,9.265),(-37.825,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-37.485,9.265),(-37.485,9.435),(-37.315,9.435),(-37.315,9.265),(-37.485,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.785,9.265),(-18.785,9.435),(-18.615,9.435),(-18.615,9.265),(-18.785,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.895,9.265),(32.895,9.435),(33.065,9.435),(33.065,9.265),(32.895,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.165,-9.435),(-21.165,-9.265),(-20.995,-9.265),(-20.995,-9.435),(-21.165,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((37.315,-9.435),(37.315,-9.265),(37.485,-9.265),(37.485,-9.435),(37.315,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.005,-9.435),(-30.005,-9.265),(-29.835,-9.265),(-29.835,-9.435),(-30.005,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.965,9.265),(-10.965,9.435),(-10.795,9.435),(-10.795,9.265),(-10.965,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.625,9.265),(-10.625,9.435),(-10.455,9.435),(-10.455,9.265),(-10.625,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.285,9.265),(-10.285,9.435),(-10.115,9.435),(-10.115,9.265),(-10.285,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.965,-9.435),(-10.965,-9.265),(-10.795,-9.265),(-10.795,-9.435),(-10.965,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.625,-9.435),(-10.625,-9.265),(-10.455,-9.265),(-10.455,-9.435),(-10.625,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.285,-9.435),(-10.285,-9.265),(-10.115,-9.265),(-10.115,-9.435),(-10.285,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.045,9.265),(-15.045,9.435),(-14.875,9.435),(-14.875,9.265),(-15.045,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.045,-9.435),(-15.045,-9.265),(-14.875,-9.265),(-14.875,-9.435),(-15.045,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((31.875,9.265),(31.875,9.435),(32.045,9.435),(32.045,9.265),(31.875,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-3.485),(43.095,-3.315),(43.265,-3.315),(43.265,-3.485),(43.095,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,4.335),(43.095,4.505),(43.265,4.505),(43.265,4.335),(43.095,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,4.675),(43.095,4.845),(43.265,4.845),(43.265,4.675),(43.095,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,4.335),(-43.265,4.505),(-43.095,4.505),(-43.095,4.335),(-43.265,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,4.675),(-43.265,4.845),(-43.095,4.845),(-43.095,4.675),(-43.265,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,9.265),(43.095,9.435),(43.265,9.435),(43.265,9.265),(43.095,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-9.435),(-43.265,-9.265),(-43.095,-9.265),(-43.095,-9.435),(-43.265,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((3.995,-9.435),(3.995,-9.265),(4.165,-9.265),(4.165,-9.435),(3.995,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.765,9.265),(-17.765,9.435),(-17.595,9.435),(-17.595,9.265),(-17.765,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.425,9.265),(-17.425,9.435),(-17.255,9.435),(-17.255,9.265),(-17.425,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((17.255,-9.435),(17.255,-9.265),(17.425,-9.265),(17.425,-9.435),(17.255,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((17.595,-9.435),(17.595,-9.265),(17.765,-9.265),(17.765,-9.435),(17.595,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.845,9.265),(-38.845,9.435),(-38.675,9.435),(-38.675,9.265),(-38.845,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.505,9.265),(-38.505,9.435),(-38.335,9.435),(-38.335,9.265),(-38.505,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.845,-9.435),(-38.845,-9.265),(-38.675,-9.265),(-38.675,-9.435),(-38.845,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-38.505,-9.435),(-38.505,-9.265),(-38.335,-9.265),(-38.335,-9.435),(-38.505,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((37.995,-9.435),(37.995,-9.265),(38.165,-9.265),(38.165,-9.435),(37.995,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.945,9.265),(-9.945,9.435),(-9.775,9.435),(-9.775,9.265),(-9.945,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.605,9.265),(-9.605,9.435),(-9.435,9.435),(-9.435,9.265),(-9.605,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.265,9.265),(-9.265,9.435),(-9.095,9.435),(-9.095,9.265),(-9.265,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.095,-9.435),(9.095,-9.265),(9.265,-9.265),(9.265,-9.435),(9.095,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((9.435,-9.435),(9.435,-9.265),(9.605,-9.265),(9.605,-9.435),(9.435,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((9.775,-9.435),(9.775,-9.265),(9.945,-9.265),(9.945,-9.435),(9.775,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.685,9.265),(-30.685,9.435),(-30.515,9.435),(-30.515,9.265),(-30.685,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.345,9.265),(-30.345,9.435),(-30.175,9.435),(-30.175,9.265),(-30.345,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.685,-9.435),(-30.685,-9.265),(-30.515,-9.265),(-30.515,-9.435),(-30.685,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.345,-9.435),(-30.345,-9.265),(-30.175,-9.265),(-30.175,-9.435),(-30.345,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-36.125,-9.435),(-36.125,-9.265),(-35.955,-9.265),(-35.955,-9.435),(-36.125,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((13.175,9.265),(13.175,9.435),(13.345,9.435),(13.345,9.265),(13.175,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.515,9.265),(13.515,9.435),(13.685,9.435),(13.685,9.265),(13.515,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.685,-9.435),(-13.685,-9.265),(-13.515,-9.265),(-13.515,-9.435),(-13.685,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.345,-9.435),(-13.345,-9.265),(-13.175,-9.265),(-13.175,-9.435),(-13.345,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((33.575,9.265),(33.575,9.435),(33.745,9.435),(33.745,9.265),(33.575,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.235,9.265),(33.235,9.435),(33.405,9.435),(33.405,9.265),(33.235,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.745,-9.435),(-33.745,-9.265),(-33.575,-9.265),(-33.575,-9.435),(-33.745,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.405,-9.435),(-33.405,-9.265),(-33.235,-9.265),(-33.235,-9.435),(-33.405,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,2.295),(43.095,2.465),(43.265,2.465),(43.265,2.295),(43.095,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,2.635),(43.095,2.805),(43.265,2.805),(43.265,2.635),(43.095,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,2.295),(-43.265,2.465),(-43.095,2.465),(-43.095,2.295),(-43.265,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,2.635),(-43.265,2.805),(-43.095,2.805),(-43.095,2.635),(-43.265,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-5.865),(43.095,-5.695),(43.265,-5.695),(43.265,-5.865),(43.095,-5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-5.525),(43.095,-5.355),(43.265,-5.355),(43.265,-5.525),(43.095,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-5.185),(43.095,-5.015),(43.265,-5.015),(43.265,-5.185),(43.095,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,5.015),(-43.265,5.185),(-43.095,5.185),(-43.095,5.015),(-43.265,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,5.355),(-43.265,5.525),(-43.095,5.525),(-43.095,5.355),(-43.265,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,5.695),(-43.265,5.865),(-43.095,5.865),(-43.095,5.695),(-43.265,5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,1.955),(43.095,2.125),(43.265,2.125),(43.265,1.955),(43.095,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-34.085,9.265),(-34.085,9.435),(-33.915,9.435),(-33.915,9.265),(-34.085,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((5.015,9.265),(5.015,9.435),(5.185,9.435),(5.185,9.265),(5.015,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((5.355,9.265),(5.355,9.435),(5.525,9.435),(5.525,9.265),(5.355,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((5.695,9.265),(5.695,9.435),(5.865,9.435),(5.865,9.265),(5.695,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.865,-9.435),(-5.865,-9.265),(-5.695,-9.265),(-5.695,-9.435),(-5.865,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.525,-9.435),(-5.525,-9.265),(-5.355,-9.265),(-5.355,-9.435),(-5.525,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-32.045,9.265),(-32.045,9.435),(-31.875,9.435),(-31.875,9.265),(-32.045,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.185,-9.435),(-5.185,-9.265),(-5.015,-9.265),(-5.015,-9.435),(-5.185,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.905,9.265),(-7.905,9.435),(-7.735,9.435),(-7.735,9.265),(-7.905,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.565,9.265),(-7.565,9.435),(-7.395,9.435),(-7.395,9.265),(-7.565,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.475,9.265),(28.475,9.435),(28.645,9.435),(28.645,9.265),(28.475,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.815,9.265),(28.815,9.435),(28.985,9.435),(28.985,9.265),(28.815,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.225,9.265),(-7.225,9.435),(-7.055,9.435),(-7.055,9.265),(-7.225,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.135,9.265),(28.135,9.435),(28.305,9.435),(28.305,9.265),(28.135,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.055,-9.435),(7.055,-9.265),(7.225,-9.265),(7.225,-9.435),(7.055,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((7.395,-9.435),(7.395,-9.265),(7.565,-9.265),(7.565,-9.435),(7.395,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((7.735,-9.435),(7.735,-9.265),(7.905,-9.265),(7.905,-9.435),(7.735,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((28.135,-9.435),(28.135,-9.265),(28.305,-9.265),(28.305,-9.435),(28.135,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((28.475,-9.435),(28.475,-9.265),(28.645,-9.265),(28.645,-9.435),(28.475,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((28.815,-9.435),(28.815,-9.265),(28.985,-9.265),(28.985,-9.435),(28.815,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.445,-9.435),(-18.445,-9.265),(-18.275,-9.265),(-18.275,-9.435),(-18.445,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.785,9.265),(-35.785,9.435),(-35.615,9.435),(-35.615,9.265),(-35.785,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-35.445,9.265),(-35.445,9.435),(-35.275,9.435),(-35.275,9.265),(-35.445,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.275,-9.435),(35.275,-9.265),(35.445,-9.265),(35.445,-9.435),(35.275,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((35.615,-9.435),(35.615,-9.265),(35.785,-9.265),(35.785,-9.435),(35.615,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((18.955,-9.435),(18.955,-9.265),(19.125,-9.265),(19.125,-9.435),(18.955,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-4.165),(43.095,-3.995),(43.265,-3.995),(43.265,-4.165),(43.095,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-4.165),(-43.265,-3.995),(-43.095,-3.995),(-43.095,-4.165),(-43.265,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.755,9.265),(25.755,9.435),(25.925,9.435),(25.925,9.265),(25.755,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.075,9.265),(25.075,9.435),(25.245,9.435),(25.245,9.265),(25.075,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,9.265),(25.415,9.435),(25.585,9.435),(25.585,9.265),(25.415,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.925,-9.435),(-25.925,-9.265),(-25.755,-9.265),(-25.755,-9.435),(-25.925,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.585,-9.435),(-25.585,-9.265),(-25.415,-9.265),(-25.415,-9.435),(-25.585,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.245,-9.435),(-25.245,-9.265),(-25.075,-9.265),(-25.075,-9.435),(-25.245,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((20.315,9.265),(20.315,9.435),(20.485,9.435),(20.485,9.265),(20.315,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.655,9.265),(20.655,9.435),(20.825,9.435),(20.825,9.265),(20.655,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.315,-9.435),(20.315,-9.265),(20.485,-9.265),(20.485,-9.435),(20.315,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((20.655,-9.435),(20.655,-9.265),(20.825,-9.265),(20.825,-9.435),(20.655,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,7.055),(43.095,7.225),(43.265,7.225),(43.265,7.055),(43.095,7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,7.395),(43.095,7.565),(43.265,7.565),(43.265,7.395),(43.095,7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,7.735),(43.095,7.905),(43.265,7.905),(43.265,7.735),(43.095,7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-7.905),(-43.265,-7.735),(-43.095,-7.735),(-43.095,-7.905),(-43.265,-7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-7.565),(-43.265,-7.395),(-43.095,-7.395),(-43.095,-7.565),(-43.265,-7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-7.225),(-43.265,-7.055),(-43.095,-7.055),(-43.095,-7.225),(-43.265,-7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.935,9.265),(0.935,9.435),(1.105,9.435),(1.105,9.265),(0.935,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-1.105),(43.095,-0.935),(43.265,-0.935),(43.265,-1.105),(43.095,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,7.055),(-43.265,7.225),(-43.095,7.225),(-43.095,7.055),(-43.265,7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((16.235,9.265),(16.235,9.435),(16.405,9.435),(16.405,9.265),(16.235,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.575,9.265),(16.575,9.435),(16.745,9.435),(16.745,9.265),(16.575,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.235,-9.435),(16.235,-9.265),(16.405,-9.265),(16.405,-9.435),(16.235,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((16.575,-9.435),(16.575,-9.265),(16.745,-9.265),(16.745,-9.435),(16.575,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((8.075,9.265),(8.075,9.435),(8.245,9.435),(8.245,9.265),(8.075,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.415,9.265),(8.415,9.435),(8.585,9.435),(8.585,9.265),(8.415,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.755,9.265),(8.755,9.435),(8.925,9.435),(8.925,9.265),(8.755,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.075,-9.435),(8.075,-9.265),(8.245,-9.265),(8.245,-9.435),(8.075,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((8.415,-9.435),(8.415,-9.265),(8.585,-9.265),(8.585,-9.435),(8.415,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((8.755,-9.435),(8.755,-9.265),(8.925,-9.265),(8.925,-9.435),(8.755,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((20.995,9.265),(20.995,9.435),(21.165,9.435),(21.165,9.265),(20.995,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.275,9.265),(18.275,9.435),(18.445,9.435),(18.445,9.265),(18.275,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.615,9.265),(18.615,9.435),(18.785,9.435),(18.785,9.265),(18.615,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.275,-9.435),(18.275,-9.265),(18.445,-9.265),(18.445,-9.435),(18.275,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((18.615,-9.435),(18.615,-9.265),(18.785,-9.265),(18.785,-9.435),(18.615,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.855,-9.435),(30.855,-9.265),(31.025,-9.265),(31.025,-9.435),(30.855,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,8.075),(43.095,8.245),(43.265,8.245),(43.265,8.075),(43.095,8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,8.415),(43.095,8.585),(43.265,8.585),(43.265,8.415),(43.095,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((10.795,9.265),(10.795,9.435),(10.965,9.435),(10.965,9.265),(10.795,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.455,9.265),(10.455,9.435),(10.625,9.435),(10.625,9.265),(10.455,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,8.755),(43.095,8.925),(43.265,8.925),(43.265,8.755),(43.095,8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,8.075),(-43.265,8.245),(-43.095,8.245),(-43.095,8.075),(-43.265,8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,8.415),(-43.265,8.585),(-43.095,8.585),(-43.095,8.415),(-43.265,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,8.755),(-43.265,8.925),(-43.095,8.925),(-43.095,8.755),(-43.265,8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((10.115,9.265),(10.115,9.435),(10.285,9.435),(10.285,9.265),(10.115,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.115,-9.435),(10.115,-9.265),(10.285,-9.265),(10.285,-9.435),(10.115,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((10.455,-9.435),(10.455,-9.265),(10.625,-9.265),(10.625,-9.435),(10.455,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((10.795,-9.435),(10.795,-9.265),(10.965,-9.265),(10.965,-9.435),(10.795,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((32.895,-9.435),(32.895,-9.265),(33.065,-9.265),(33.065,-9.435),(32.895,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((11.135,9.265),(11.135,9.435),(11.305,9.435),(11.305,9.265),(11.135,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.475,9.265),(11.475,9.435),(11.645,9.435),(11.645,9.265),(11.475,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.815,9.265),(11.815,9.435),(11.985,9.435),(11.985,9.265),(11.815,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.985,-9.435),(-11.985,-9.265),(-11.815,-9.265),(-11.815,-9.435),(-11.985,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.645,-9.435),(-11.645,-9.265),(-11.475,-9.265),(-11.475,-9.435),(-11.645,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.305,-9.435),(-11.305,-9.265),(-11.135,-9.265),(-11.135,-9.435),(-11.305,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((3.995,9.265),(3.995,9.435),(4.165,9.435),(4.165,9.265),(3.995,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.545,-9.435),(-6.545,-9.265),(-6.375,-9.265),(-6.375,-9.435),(-6.545,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.205,-9.435),(-6.205,-9.265),(-6.035,-9.265),(-6.035,-9.435),(-6.205,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.885,9.265),(-6.885,9.435),(-6.715,9.435),(-6.715,9.265),(-6.885,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.545,9.265),(-6.545,9.435),(-6.375,9.435),(-6.375,9.265),(-6.545,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.205,9.265),(-6.205,9.435),(-6.035,9.435),(-6.035,9.265),(-6.205,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.885,-9.435),(-6.885,-9.265),(-6.715,-9.265),(-6.715,-9.435),(-6.885,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.905,9.265),(-24.905,9.435),(-24.735,9.435),(-24.735,9.265),(-24.905,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.565,9.265),(-24.565,9.435),(-24.395,9.435),(-24.395,9.265),(-24.565,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.225,9.265),(-24.225,9.435),(-24.055,9.435),(-24.055,9.265),(-24.225,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.905,-9.435),(-24.905,-9.265),(-24.735,-9.265),(-24.735,-9.435),(-24.905,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.565,-9.435),(-24.565,-9.265),(-24.395,-9.265),(-24.395,-9.435),(-24.565,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.225,-9.435),(-24.225,-9.265),(-24.055,-9.265),(-24.055,-9.435),(-24.225,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((23.035,9.265),(23.035,9.435),(23.205,9.435),(23.205,9.265),(23.035,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.375,9.265),(23.375,9.435),(23.545,9.435),(23.545,9.265),(23.375,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.715,9.265),(23.715,9.435),(23.885,9.435),(23.885,9.265),(23.715,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.885,-9.435),(-23.885,-9.265),(-23.715,-9.265),(-23.715,-9.435),(-23.885,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.545,-9.435),(-23.545,-9.265),(-23.375,-9.265),(-23.375,-9.435),(-23.545,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((37.995,9.265),(37.995,9.435),(38.165,9.435),(38.165,9.265),(37.995,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.205,-9.435),(-23.205,-9.265),(-23.035,-9.265),(-23.035,-9.435),(-23.205,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.005,9.265),(-13.005,9.435),(-12.835,9.435),(-12.835,9.265),(-13.005,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,2.975),(43.095,3.145),(43.265,3.145),(43.265,2.975),(43.095,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-8.925),(43.095,-8.755),(43.265,-8.755),(43.265,-8.925),(43.095,-8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-8.585),(43.095,-8.415),(43.265,-8.415),(43.265,-8.585),(43.095,-8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-8.245),(43.095,-8.075),(43.265,-8.075),(43.265,-8.245),(43.095,-8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-8.925),(-43.265,-8.755),(-43.095,-8.755),(-43.095,-8.925),(-43.265,-8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-8.585),(-43.265,-8.415),(-43.095,-8.415),(-43.095,-8.585),(-43.265,-8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-8.245),(-43.265,-8.075),(-43.095,-8.075),(-43.095,-8.245),(-43.265,-8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,2.975),(-43.265,3.145),(-43.095,3.145),(-43.095,2.975),(-43.265,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.165,-9.435),(-4.165,-9.265),(-3.995,-9.265),(-3.995,-9.435),(-4.165,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((5.695,-9.435),(5.695,-9.265),(5.865,-9.265),(5.865,-9.435),(5.695,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,9.265),(-43.265,9.435),(-43.095,9.435),(-43.095,9.265),(-43.265,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,-9.435),(43.095,-9.265),(43.265,-9.265),(43.265,-9.435),(43.095,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.085,9.265),(-17.085,9.435),(-16.915,9.435),(-16.915,9.265),(-17.085,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((38.335,9.265),(38.335,9.435),(38.505,9.435),(38.505,9.265),(38.335,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,9.265),(38.675,9.435),(38.845,9.435),(38.845,9.265),(38.675,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((38.335,-9.435),(38.335,-9.265),(38.505,-9.265),(38.505,-9.435),(38.335,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,-9.435),(38.675,-9.265),(38.845,-9.265),(38.845,-9.435),(38.675,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.175,-9.435),(30.175,-9.265),(30.345,-9.265),(30.345,-9.435),(30.175,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,-9.435),(30.515,-9.265),(30.685,-9.265),(30.685,-9.435),(30.515,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.175,9.265),(30.175,9.435),(30.345,9.435),(30.345,9.265),(30.175,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.265),(30.515,9.435),(30.685,9.435),(30.685,9.265),(30.515,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,1.275),(43.095,1.445),(43.265,1.445),(43.265,1.275),(43.095,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((43.095,1.615),(43.095,1.785),(43.265,1.785),(43.265,1.615),(43.095,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-1.785),(-43.265,-1.615),(-43.095,-1.615),(-43.095,-1.785),(-43.265,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-43.265,-1.445),(-43.265,-1.275),(-43.095,-1.275),(-43.095,-1.445),(-43.265,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((3.315,9.265),(3.315,9.435),(3.485,9.435),(3.485,9.265),(3.315,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((3.655,9.265),(3.655,9.435),(3.825,9.435),(3.825,9.265),(3.655,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.825,-9.435),(-3.825,-9.265),(-3.655,-9.265),(-3.655,-9.435),(-3.825,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.485,-9.435),(-3.485,-9.265),(-3.315,-9.265),(-3.315,-9.435),(-3.485,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((36.975,-9.435),(36.975,-9.265),(37.145,-9.265),(37.145,-9.435),(36.975,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.125,9.265),(-19.125,9.435),(-18.955,9.435),(-18.955,9.265),(-19.125,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.685,9.265),(-13.685,9.435),(-13.515,9.435),(-13.515,9.265),(-13.685,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.345,9.265),(-13.345,9.435),(-13.175,9.435),(-13.175,9.265),(-13.345,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.175,-9.435),(13.175,-9.265),(13.345,-9.265),(13.345,-9.435),(13.175,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((13.515,-9.435),(13.515,-9.265),(13.685,-9.265),(13.685,-9.435),(13.515,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((17.935,9.265),(17.935,9.435),(18.105,9.435),(18.105,9.265),(17.935,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.745,9.265),(-33.745,9.435),(-33.575,9.435),(-33.575,9.265),(-33.745,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-33.405,9.265),(-33.405,9.435),(-33.235,9.435),(-33.235,9.265),(-33.405,9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.235,-9.435),(33.235,-9.265),(33.405,-9.265),(33.405,-9.435),(33.235,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((33.575,-9.435),(33.575,-9.265),(33.745,-9.265),(33.745,-9.435),(33.575,-9.435)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.125,9.265),(-2.125,9.435),(-1.955,9.435),(-1.955,9.265),(-2.125,9.265)),
        )
        createRL(
            tech, net, 'li',
            ((-43.42,-9.59),(-43.42,-9.11),(43.42,-9.11),(43.42,-9.59),(-43.42,-9.59)),
        )
        createRL(
            tech, net, 'li',
            ((-43.265,9.185),(-43.265,9.515),(43.265,9.515),(43.265,9.185),(-43.265,9.185)),
        )
        createRL(
            tech, net, 'li',
            ((-43.265,-9.005),(-43.265,9.005),(-43.095,9.005),(-43.095,-9.005),(-43.265,-9.005)),
        )
        createRL(
            tech, net, 'li',
            ((-43.265,-9.515),(-43.265,-9.185),(43.265,-9.185),(43.265,-9.515),(-43.265,-9.515)),
        )
        createRL(
            tech, net, 'li',
            ((-43.42,9.11),(-43.42,9.59),(43.42,9.59),(43.42,9.11),(-43.42,9.11)),
        )
        createRL(
            tech, net, 'li',
            ((43.095,-9.005),(43.095,9.005),(43.265,9.005),(43.265,-9.005),(43.095,-9.005)),
        )
        createRL(
            tech, net, 'li',
            ((42.94,-9.59),(42.94,9.59),(43.42,9.59),(43.42,-9.59),(42.94,-9.59)),
        )
        createRL(
            tech, net, 'li',
            ((-43.42,-9.59),(-43.42,9.59),(-42.94,9.59),(-42.94,-9.59),(-43.42,-9.59)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((42.815,-9.235),(42.815,9.235),(43.545,9.235),(43.545,-9.235),(42.815,-9.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((-43.545,-9.235),(-43.545,9.235),(-42.815,9.235),(-42.815,-9.235),(-43.545,-9.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((-43.545,-9.715),(-43.545,-8.985),(43.545,-8.985),(43.545,-9.715),(-43.545,-9.715)),
        )
        createRL(
            tech, net, 'psdm',
            ((-43.545,8.985),(-43.545,9.715),(43.545,9.715),(43.545,8.985),(-43.545,8.985)),
        )
        nets['conn'].setDirection(Net.Direction.IN)

    cell = new_cells['Clamp_N32N0D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(22.34),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovss': Net.create(cell, 'iovss'),
            'off': Net.create(cell, 'off'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((59.05,2.72),(59.05,19.62),(59.75,19.62),(59.75,2.72),(59.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.55,2.72),(16.55,19.62),(16.87,19.62),(16.87,2.72),(16.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.835,2.72),(74.835,19.62),(75.435,19.62),(75.435,2.72),(74.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.965,2.72),(67.965,19.62),(68.215,19.62),(68.215,2.72),(67.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.25,2.72),(78.25,19.62),(78.95,19.62),(78.95,2.72),(78.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.585,2.72),(74.585,19.62),(74.835,19.62),(74.835,2.72),(74.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.235,2.72),(65.235,19.62),(65.835,19.62),(65.835,2.72),(65.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,2.72),(39.415,19.62),(40.87,19.62),(40.87,2.72),(39.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(40.985,19.62),(40.985,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.85,2.72),(39.85,19.62),(40.55,19.62),(40.55,2.72),(39.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(54.25,19.62),(54.25,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.165,2.72),(24.165,19.62),(24.765,19.62),(24.765,2.72),(24.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.165,2.72),(39.165,19.62),(39.415,19.62),(39.415,2.72),(39.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.165,2.72),(63.165,19.62),(63.415,19.62),(63.415,2.72),(63.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(44.65,19.62),(44.65,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,19.62),(31.385,19.62),(31.385,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,2.72),(54.25,19.62),(54.95,19.62),(54.95,2.72),(54.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.815,2.72),(29.815,19.62),(31.27,19.62),(31.27,2.72),(29.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.035,2.72),(70.035,19.62),(70.635,19.62),(70.635,2.72),(70.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.435,2.72),(36.435,19.62),(37.035,19.62),(37.035,2.72),(36.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.965,2.72),(28.965,19.62),(29.565,19.62),(29.565,2.72),(28.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.785,2.72),(45.785,19.62),(46.035,19.62),(46.035,2.72),(45.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.365,2.72),(58.365,19.62),(58.615,19.62),(58.615,2.72),(58.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.985,2.72),(64.985,19.62),(65.235,19.62),(65.235,2.72),(64.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.185,2.72),(60.185,19.62),(60.435,19.62),(60.435,2.72),(60.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.185,2.72),(12.185,19.62),(12.435,19.62),(12.435,2.72),(12.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.95,2.72),(78.95,19.62),(79.27,19.62),(79.27,2.72),(78.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((83.05,2.72),(83.05,19.62),(83.75,19.62),(83.75,2.72),(83.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.365,2.72),(19.365,19.62),(19.965,19.62),(19.965,2.72),(19.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.585,2.72),(50.585,19.62),(50.835,19.62),(50.835,2.72),(50.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.165,2.72),(15.165,19.62),(15.415,19.62),(15.415,2.72),(15.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.385,2.72),(55.385,19.62),(55.635,19.62),(55.635,2.72),(55.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.765,2.72),(72.765,19.62),(73.015,19.62),(73.015,2.72),(72.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.635,2.72),(55.635,19.62),(56.235,19.62),(56.235,2.72),(55.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.965,2.72),(43.965,19.62),(44.215,19.62),(44.215,2.72),(43.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,19.62),(30.25,19.62),(30.25,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.65,2.72),(44.65,19.62),(45.35,19.62),(45.35,2.72),(44.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.215,2.72),(44.215,19.62),(45.67,19.62),(45.67,2.72),(44.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(45.785,19.62),(45.785,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.95,2.72),(54.95,19.62),(55.27,19.62),(55.27,2.72),(54.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,19.62),(63.85,19.62),(63.85,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,19.62),(53.565,19.62),(53.565,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.035,2.72),(46.035,19.62),(46.635,19.62),(46.635,2.72),(46.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.75,2.72),(35.75,19.62),(36.07,19.62),(36.07,2.72),(35.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.85,2.72),(15.85,19.62),(16.55,19.62),(16.55,2.72),(15.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.415,2.72),(15.415,19.62),(16.87,19.62),(16.87,2.72),(15.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,19.62),(16.985,19.62),(16.985,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.815,2.72),(77.815,19.62),(79.27,19.62),(79.27,2.72),(77.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,19.62),(79.385,19.62),(79.385,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(35.05,19.62),(35.05,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.615,2.72),(34.615,19.62),(36.07,19.62),(36.07,2.72),(34.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(36.185,19.62),(36.185,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.365,2.72),(67.365,19.62),(67.965,19.62),(67.965,2.72),(67.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.565,2.72),(29.565,19.62),(29.815,19.62),(29.815,2.72),(29.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.165,2.72),(72.165,19.62),(72.765,19.62),(72.765,2.72),(72.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,19.62),(20.65,19.62),(20.65,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.765,2.72),(81.765,19.62),(82.365,19.62),(82.365,2.72),(81.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,19.62),(34.365,19.62),(34.365,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.765,2.72),(24.765,19.62),(25.015,19.62),(25.015,2.72),(24.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,19.62),(15.85,19.62),(15.85,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.785,2.72),(21.785,19.62),(22.035,19.62),(22.035,2.72),(21.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,19.62),(30.95,19.62),(30.95,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.435,2.72),(60.435,19.62),(61.035,19.62),(61.035,2.72),(60.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.75,2.72),(59.75,19.62),(60.07,19.62),(60.07,2.72),(59.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.365,2.72),(10.365,19.62),(10.615,19.62),(10.615,2.72),(10.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.365,2.72),(82.365,19.62),(82.615,19.62),(82.615,2.72),(82.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.185,2.72),(36.185,19.62),(36.435,19.62),(36.435,2.72),(36.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.45,2.72),(25.45,19.62),(26.15,19.62),(26.15,2.72),(25.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.05,2.72),(11.05,19.62),(11.75,19.62),(11.75,2.72),(11.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.015,2.72),(25.015,19.62),(26.47,19.62),(26.47,2.72),(25.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,19.62),(26.585,19.62),(26.585,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.835,2.72),(50.835,19.62),(51.435,19.62),(51.435,2.72),(50.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.565,2.72),(14.565,19.62),(15.165,19.62),(15.165,2.72),(14.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,19.62),(78.25,19.62),(78.25,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.565,2.72),(53.565,19.62),(53.815,19.62),(53.815,2.72),(53.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.85,2.72),(63.85,19.62),(64.55,19.62),(64.55,2.72),(63.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.415,2.72),(63.415,19.62),(64.87,19.62),(64.87,2.72),(63.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,19.62),(64.985,19.62),(64.985,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.235,2.72),(41.235,19.62),(41.835,19.62),(41.835,2.72),(41.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.35,2.72),(69.35,19.62),(69.67,19.62),(69.67,2.72),(69.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.635,2.72),(7.635,19.62),(8.235,19.62),(8.235,2.72),(7.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.635,2.72),(79.635,19.62),(80.235,19.62),(80.235,2.72),(79.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.215,2.72),(20.215,19.62),(21.67,19.62),(21.67,2.72),(20.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,19.62),(21.785,19.62),(21.785,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.65,2.72),(20.65,19.62),(21.35,19.62),(21.35,2.72),(20.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.235,2.72),(17.235,19.62),(17.835,19.62),(17.835,2.72),(17.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.365,2.72),(34.365,19.62),(34.615,19.62),(34.615,2.72),(34.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.985,2.72),(40.985,19.62),(41.235,19.62),(41.235,2.72),(40.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,19.62),(25.45,19.62),(25.45,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(39.85,19.62),(39.85,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,19.62),(68.65,19.62),(68.65,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.95,2.72),(30.95,19.62),(31.27,19.62),(31.27,2.72),(30.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,19.62),(6.95,19.62),(6.95,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.35,2.72),(21.35,19.62),(21.67,19.62),(21.67,2.72),(21.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.565,2.72),(77.565,19.62),(77.815,19.62),(77.815,2.72),(77.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.765,2.72),(9.765,19.62),(10.365,19.62),(10.365,2.72),(9.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.015,2.72),(73.015,19.62),(74.47,19.62),(74.47,2.72),(73.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.45,2.72),(73.45,19.62),(74.15,19.62),(74.15,2.72),(73.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,19.62),(74.585,19.62),(74.585,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.385,2.72),(7.385,19.62),(7.635,19.62),(7.635,2.72),(7.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,19.62),(48.765,19.62),(48.765,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.385,2.72),(79.385,19.62),(79.635,19.62),(79.635,2.72),(79.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.765,2.72),(48.765,19.62),(49.015,19.62),(49.015,2.72),(48.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.35,2.72),(45.35,19.62),(45.67,19.62),(45.67,2.72),(45.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.65,2.72),(68.65,19.62),(69.35,19.62),(69.35,2.72),(68.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.215,2.72),(68.215,19.62),(69.67,19.62),(69.67,2.72),(68.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,19.62),(69.785,19.62),(69.785,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.95,2.72),(6.95,19.62),(7.27,19.62),(7.27,2.72),(6.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,19.62),(7.385,19.62),(7.385,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(59.05,19.62),(59.05,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,19.62),(73.45,19.62),(73.45,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.035,2.72),(22.035,19.62),(22.635,19.62),(22.635,2.72),(22.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.635,2.72),(31.635,19.62),(32.235,19.62),(32.235,2.72),(31.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,19.62),(39.165,19.62),(39.165,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.835,2.72),(26.835,19.62),(27.435,19.62),(27.435,2.72),(26.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.965,2.72),(19.965,19.62),(20.215,19.62),(20.215,2.72),(19.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,19.62),(11.05,19.62),(11.05,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.435,2.72),(12.435,19.62),(13.035,19.62),(13.035,2.72),(12.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.15,2.72),(50.15,19.62),(50.47,19.62),(50.47,2.72),(50.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.785,2.72),(69.785,19.62),(70.035,19.62),(70.035,2.72),(69.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.965,2.72),(76.965,19.62),(77.565,19.62),(77.565,2.72),(76.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.585,2.72),(26.585,19.62),(26.835,19.62),(26.835,2.72),(26.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.73,2.72),(82.73,19.62),(83.05,19.62),(83.05,2.72),(82.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.615,2.72),(82.615,19.62),(83.75,19.62),(83.75,2.72),(82.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.385,2.72),(31.385,19.62),(31.635,19.62),(31.635,2.72),(31.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.75,2.72),(11.75,19.62),(12.07,19.62),(12.07,2.72),(11.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.55,2.72),(40.55,19.62),(40.87,19.62),(40.87,2.72),(40.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.615,2.72),(58.615,19.62),(60.07,19.62),(60.07,2.72),(58.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(60.185,19.62),(60.185,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.15,2.72),(74.15,19.62),(74.47,19.62),(74.47,2.72),(74.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.05,2.72),(35.05,19.62),(35.75,19.62),(35.75,2.72),(35.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.55,2.72),(64.55,19.62),(64.87,19.62),(64.87,2.72),(64.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(49.45,19.62),(49.45,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.45,2.72),(49.45,19.62),(50.15,19.62),(50.15,2.72),(49.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(50.585,19.62),(50.585,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.015,2.72),(49.015,19.62),(50.47,19.62),(50.47,2.72),(49.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.985,2.72),(16.985,19.62),(17.235,19.62),(17.235,2.72),(16.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.615,2.72),(10.615,19.62),(12.07,19.62),(12.07,2.72),(10.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,19.62),(12.185,19.62),(12.185,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(55.385,19.62),(55.385,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.815,2.72),(53.815,19.62),(55.27,19.62),(55.27,2.72),(53.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.15,2.72),(26.15,19.62),(26.47,19.62),(26.47,2.72),(26.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.565,2.72),(62.565,19.62),(63.165,19.62),(63.165,2.72),(62.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,19.62),(43.965,19.62),(43.965,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,19.62),(58.365,19.62),(58.365,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.685),(83.315,7.855),(83.485,7.855),(83.485,7.685),(83.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.285),(78.515,4.455),(78.685,4.455),(78.685,4.285),(78.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.285),(78.005,4.455),(78.175,4.455),(78.175,4.285),(78.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.625),(78.515,4.795),(78.685,4.795),(78.685,4.625),(78.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.625),(78.005,4.795),(78.175,4.795),(78.175,4.625),(78.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.025),(16.115,8.195),(16.285,8.195),(16.285,8.025),(16.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.025),(16.625,8.195),(16.795,8.195),(16.795,8.025),(16.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.705),(16.625,8.875),(16.795,8.875),(16.795,8.705),(16.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.365),(16.115,8.535),(16.285,8.535),(16.285,8.365),(16.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.365),(16.625,8.535),(16.795,8.535),(16.795,8.365),(16.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.705),(16.115,8.875),(16.285,8.875),(16.285,8.705),(16.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.685),(35.315,7.855),(35.485,7.855),(35.485,7.685),(35.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.685),(35.825,7.855),(35.995,7.855),(35.995,7.685),(35.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.005),(35.825,7.175),(35.995,7.175),(35.995,7.005),(35.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.005),(35.315,7.175),(35.485,7.175),(35.485,7.005),(35.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.345),(35.825,7.515),(35.995,7.515),(35.995,7.345),(35.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.965),(40.115,5.135),(40.285,5.135),(40.285,4.965),(40.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.965),(40.625,5.135),(40.795,5.135),(40.795,4.965),(40.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.345),(35.315,7.515),(35.485,7.515),(35.485,7.345),(35.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.245),(35.825,19.415),(35.995,19.415),(35.995,19.245),(35.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.245),(35.315,19.415),(35.485,19.415),(35.485,19.245),(35.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.985),(73.715,6.155),(73.885,6.155),(73.885,5.985),(73.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.985),(73.205,6.155),(73.375,6.155),(73.375,5.985),(73.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.225),(44.405,18.395),(44.575,18.395),(44.575,18.225),(44.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.565),(44.405,18.735),(44.575,18.735),(44.575,18.565),(44.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.005),(59.825,7.175),(59.995,7.175),(59.995,7.005),(59.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.005),(59.315,7.175),(59.485,7.175),(59.485,7.005),(59.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.345),(59.825,7.515),(59.995,7.515),(59.995,7.345),(59.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.345),(59.315,7.515),(59.485,7.515),(59.485,7.345),(59.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.885),(69.425,18.055),(69.595,18.055),(69.595,17.885),(69.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.185),(16.625,16.355),(16.795,16.355),(16.795,16.185),(16.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.185),(16.115,16.355),(16.285,16.355),(16.285,16.185),(16.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.525),(16.115,16.695),(16.285,16.695),(16.285,16.525),(16.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.045),(58.805,9.215),(58.975,9.215),(58.975,9.045),(58.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.525),(16.625,16.695),(16.795,16.695),(16.795,16.525),(16.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.185),(59.825,16.355),(59.995,16.355),(59.995,16.185),(59.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.525),(59.825,16.695),(59.995,16.695),(59.995,16.525),(59.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.185),(59.315,16.355),(59.485,16.355),(59.485,16.185),(59.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.525),(59.315,16.695),(59.485,16.695),(59.485,16.525),(59.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.225),(82.805,18.395),(82.975,18.395),(82.975,18.225),(82.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.565),(82.805,18.735),(82.975,18.735),(82.975,18.565),(82.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.765),(58.805,11.935),(58.975,11.935),(58.975,11.765),(58.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.085),(58.805,11.255),(58.975,11.255),(58.975,11.085),(58.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.425),(58.805,11.595),(58.975,11.595),(58.975,11.425),(58.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.785),(73.715,12.955),(73.885,12.955),(73.885,12.785),(73.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.785),(73.205,12.955),(73.375,12.955),(73.375,12.785),(73.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.445),(73.205,12.615),(73.375,12.615),(73.375,12.445),(73.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.445),(73.715,12.615),(73.885,12.615),(73.885,12.445),(73.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.105),(73.205,12.275),(73.375,12.275),(73.375,12.105),(73.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.105),(73.715,12.275),(73.885,12.275),(73.885,12.105),(73.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.545),(31.025,17.715),(31.195,17.715),(31.195,17.545),(31.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.205),(31.025,17.375),(31.195,17.375),(31.195,17.205),(31.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.105),(25.205,12.275),(25.375,12.275),(25.375,12.105),(25.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.445),(25.715,12.615),(25.885,12.615),(25.885,12.445),(25.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.785),(25.715,12.955),(25.885,12.955),(25.885,12.785),(25.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.785),(25.205,12.955),(25.375,12.955),(25.375,12.785),(25.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.445),(25.205,12.615),(25.375,12.615),(25.375,12.445),(25.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.345),(25.205,7.515),(25.375,7.515),(25.375,7.345),(25.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.345),(25.715,7.515),(25.885,7.515),(25.885,7.345),(25.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.105),(25.715,12.275),(25.885,12.275),(25.885,12.105),(25.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.005),(25.205,7.175),(25.375,7.175),(25.375,7.005),(25.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.005),(25.715,7.175),(25.885,7.175),(25.885,7.005),(25.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.385),(64.115,9.555),(64.285,9.555),(64.285,9.385),(64.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.725),(64.115,9.895),(64.285,9.895),(64.285,9.725),(64.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.385),(64.625,9.555),(64.795,9.555),(64.795,9.385),(64.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.725),(64.625,9.895),(64.795,9.895),(64.795,9.725),(64.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.245),(68.915,19.415),(69.085,19.415),(69.085,19.245),(68.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.825),(49.205,14.995),(49.375,14.995),(49.375,14.825),(49.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.145),(49.205,14.315),(49.375,14.315),(49.375,14.145),(49.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.485),(49.205,14.655),(49.375,14.655),(49.375,14.485),(49.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.485),(49.715,14.655),(49.885,14.655),(49.885,14.485),(49.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.825),(49.715,14.995),(49.885,14.995),(49.885,14.825),(49.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.885),(16.625,18.055),(16.795,18.055),(16.795,17.885),(16.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.885),(16.115,18.055),(16.285,18.055),(16.285,17.885),(16.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.385),(69.425,9.555),(69.595,9.555),(69.595,9.385),(69.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.725),(69.425,9.895),(69.595,9.895),(69.595,9.725),(69.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.245),(15.605,19.415),(15.775,19.415),(15.775,19.245),(15.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.325),(64.115,6.495),(64.285,6.495),(64.285,6.325),(64.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.665),(64.625,6.835),(64.795,6.835),(64.795,6.665),(64.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.325),(64.625,6.495),(64.795,6.495),(64.795,6.325),(64.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.665),(64.115,6.835),(64.285,6.835),(64.285,6.665),(64.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.265),(40.625,3.435),(40.795,3.435),(40.795,3.265),(40.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.265),(40.115,3.435),(40.285,3.435),(40.285,3.265),(40.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.605),(40.115,3.775),(40.285,3.775),(40.285,3.605),(40.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.605),(40.625,3.775),(40.795,3.775),(40.795,3.605),(40.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.725),(21.425,9.895),(21.595,9.895),(21.595,9.725),(21.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.385),(21.425,9.555),(21.595,9.555),(21.595,9.385),(21.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.865),(68.915,17.035),(69.085,17.035),(69.085,16.865),(68.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.105),(64.625,12.275),(64.795,12.275),(64.795,12.105),(64.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.785),(64.625,12.955),(64.795,12.955),(64.795,12.785),(64.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.445),(64.625,12.615),(64.795,12.615),(64.795,12.445),(64.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.445),(64.115,12.615),(64.285,12.615),(64.285,12.445),(64.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.785),(64.115,12.955),(64.285,12.955),(64.285,12.785),(64.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.105),(64.115,12.275),(64.285,12.275),(64.285,12.105),(64.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.045),(44.915,9.215),(45.085,9.215),(45.085,9.045),(44.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.985),(68.405,6.155),(68.575,6.155),(68.575,5.985),(68.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.045),(68.915,9.215),(69.085,9.215),(69.085,9.045),(68.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.845),(69.425,16.015),(69.595,16.015),(69.595,15.845),(69.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.265),(16.115,3.435),(16.285,3.435),(16.285,3.265),(16.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.265),(16.625,3.435),(16.795,3.435),(16.795,3.265),(16.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.605),(16.625,3.775),(16.795,3.775),(16.795,3.605),(16.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.605),(16.115,3.775),(16.285,3.775),(16.285,3.605),(16.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.885),(39.605,18.055),(39.775,18.055),(39.775,17.885),(39.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.865),(82.805,17.035),(82.975,17.035),(82.975,16.865),(82.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.965),(11.315,5.135),(11.485,5.135),(11.485,4.965),(11.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.965),(11.825,5.135),(11.995,5.135),(11.995,4.965),(11.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.985),(68.915,6.155),(69.085,6.155),(69.085,5.985),(68.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.885),(54.515,18.055),(54.685,18.055),(54.685,17.885),(54.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.885),(54.005,18.055),(54.175,18.055),(54.175,17.885),(54.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.445),(16.115,12.615),(16.285,12.615),(16.285,12.445),(16.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.785),(16.625,12.955),(16.795,12.955),(16.795,12.785),(16.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.445),(16.625,12.615),(16.795,12.615),(16.795,12.445),(16.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.785),(16.115,12.955),(16.285,12.955),(16.285,12.785),(16.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.105),(16.625,12.275),(16.795,12.275),(16.795,12.105),(16.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.105),(16.115,12.275),(16.285,12.275),(16.285,12.105),(16.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.185),(44.405,16.355),(44.575,16.355),(44.575,16.185),(44.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.525),(44.405,16.695),(44.575,16.695),(44.575,16.525),(44.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.905),(69.425,19.075),(69.595,19.075),(69.595,18.905),(69.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.665),(39.605,6.835),(39.775,6.835),(39.775,6.665),(39.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.325),(39.605,6.495),(39.775,6.495),(39.775,6.325),(39.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.885),(20.405,18.055),(20.575,18.055),(20.575,17.885),(20.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,10.79),(85.76,10.96),(85.93,10.96),(85.93,10.79),(85.76,10.79)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.245),(74.225,19.415),(74.395,19.415),(74.395,19.245),(74.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.385),(34.805,9.555),(34.975,9.555),(34.975,9.385),(34.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.725),(34.805,9.895),(34.975,9.895),(34.975,9.725),(34.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.245),(82.805,19.415),(82.975,19.415),(82.975,19.245),(82.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.165),(74.225,15.335),(74.395,15.335),(74.395,15.165),(74.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.505),(74.225,15.675),(74.395,15.675),(74.395,15.505),(74.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.305),(69.425,5.475),(69.595,5.475),(69.595,5.305),(69.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.645),(69.425,5.815),(69.595,5.815),(69.595,5.645),(69.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.505),(26.225,15.675),(26.395,15.675),(26.395,15.505),(26.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.165),(26.225,15.335),(26.395,15.335),(26.395,15.165),(26.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.205),(64.115,17.375),(64.285,17.375),(64.285,17.205),(64.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.545),(64.625,17.715),(64.795,17.715),(64.795,17.545),(64.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.205),(64.625,17.375),(64.795,17.375),(64.795,17.205),(64.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.545),(64.115,17.715),(64.285,17.715),(64.285,17.545),(64.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.945),(68.915,4.115),(69.085,4.115),(69.085,3.945),(68.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.305),(21.425,5.475),(21.595,5.475),(21.595,5.305),(21.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.645),(21.425,5.815),(21.595,5.815),(21.595,5.645),(21.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.185),(54.515,16.355),(54.685,16.355),(54.685,16.185),(54.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.185),(54.005,16.355),(54.175,16.355),(54.175,16.185),(54.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.325),(63.605,6.495),(63.775,6.495),(63.775,6.325),(63.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.665),(63.605,6.835),(63.775,6.835),(63.775,6.665),(63.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.525),(54.515,16.695),(54.685,16.695),(54.685,16.525),(54.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.525),(54.005,16.695),(54.175,16.695),(54.175,16.525),(54.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.865),(69.425,17.035),(69.595,17.035),(69.595,16.865),(69.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.845),(45.425,16.015),(45.595,16.015),(45.595,15.845),(45.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.905),(34.805,19.075),(34.975,19.075),(34.975,18.905),(34.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.865),(63.605,17.035),(63.775,17.035),(63.775,16.865),(63.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.505),(79.025,15.675),(79.195,15.675),(79.195,15.505),(79.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.165),(79.025,15.335),(79.195,15.335),(79.195,15.165),(79.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.905),(35.825,19.075),(35.995,19.075),(35.995,18.905),(35.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.905),(35.315,19.075),(35.485,19.075),(35.485,18.905),(35.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.965),(59.315,5.135),(59.485,5.135),(59.485,4.965),(59.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.325),(11.315,6.495),(11.485,6.495),(11.485,6.325),(11.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.665),(11.315,6.835),(11.485,6.835),(11.485,6.665),(11.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.965),(59.825,5.135),(59.995,5.135),(59.995,4.965),(59.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.325),(11.825,6.495),(11.995,6.495),(11.995,6.325),(11.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.665),(11.825,6.835),(11.995,6.835),(11.995,6.665),(11.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.185),(31.025,16.355),(31.195,16.355),(31.195,16.185),(31.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.525),(31.025,16.695),(31.195,16.695),(31.195,16.525),(31.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.065),(39.605,10.235),(39.775,10.235),(39.775,10.065),(39.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.745),(39.605,10.915),(39.775,10.915),(39.775,10.745),(39.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.405),(39.605,10.575),(39.775,10.575),(39.775,10.405),(39.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.325),(78.005,6.495),(78.175,6.495),(78.175,6.325),(78.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.665),(78.005,6.835),(78.175,6.835),(78.175,6.665),(78.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.325),(78.515,6.495),(78.685,6.495),(78.685,6.325),(78.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.665),(78.515,6.835),(78.685,6.835),(78.685,6.665),(78.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.945),(44.915,4.115),(45.085,4.115),(45.085,3.945),(44.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.005),(73.205,7.175),(73.375,7.175),(73.375,7.005),(73.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.005),(73.715,7.175),(73.885,7.175),(73.885,7.005),(73.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.345),(73.205,7.515),(73.375,7.515),(73.375,7.345),(73.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.345),(73.715,7.515),(73.885,7.515),(73.885,7.345),(73.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.025),(39.605,8.195),(39.775,8.195),(39.775,8.025),(39.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.705),(39.605,8.875),(39.775,8.875),(39.775,8.705),(39.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.365),(39.605,8.535),(39.775,8.535),(39.775,8.365),(39.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.245),(69.425,19.415),(69.595,19.415),(69.595,19.245),(69.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.185),(50.225,16.355),(50.395,16.355),(50.395,16.185),(50.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.525),(50.225,16.695),(50.395,16.695),(50.395,16.525),(50.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.325),(25.715,6.495),(25.885,6.495),(25.885,6.325),(25.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.665),(25.205,6.835),(25.375,6.835),(25.375,6.665),(25.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.325),(25.205,6.495),(25.375,6.495),(25.375,6.325),(25.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.665),(25.715,6.835),(25.885,6.835),(25.885,6.665),(25.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.645),(26.225,5.815),(26.395,5.815),(26.395,5.645),(26.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.305),(26.225,5.475),(26.395,5.475),(26.395,5.305),(26.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.905),(26.225,19.075),(26.395,19.075),(26.395,18.905),(26.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.785),(26.225,12.955),(26.395,12.955),(26.395,12.785),(26.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.105),(26.225,12.275),(26.395,12.275),(26.395,12.105),(26.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.445),(26.225,12.615),(26.395,12.615),(26.395,12.445),(26.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.185),(11.825,16.355),(11.995,16.355),(11.995,16.185),(11.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.185),(11.315,16.355),(11.485,16.355),(11.485,16.185),(11.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.525),(11.315,16.695),(11.485,16.695),(11.485,16.525),(11.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.525),(11.825,16.695),(11.995,16.695),(11.995,16.525),(11.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.605),(30.005,3.775),(30.175,3.775),(30.175,3.605),(30.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.265),(30.005,3.435),(30.175,3.435),(30.175,3.265),(30.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.265),(30.515,3.435),(30.685,3.435),(30.685,3.265),(30.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.045),(31.025,9.215),(31.195,9.215),(31.195,9.045),(31.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.605),(30.515,3.775),(30.685,3.775),(30.685,3.605),(30.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.265),(7.025,3.435),(7.195,3.435),(7.195,3.265),(7.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.605),(7.025,3.775),(7.195,3.775),(7.195,3.605),(7.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.645),(44.405,5.815),(44.575,5.815),(44.575,5.645),(44.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.305),(44.405,5.475),(44.575,5.475),(44.575,5.305),(44.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.285),(68.915,4.455),(69.085,4.455),(69.085,4.285),(68.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.625),(68.915,4.795),(69.085,4.795),(69.085,4.625),(68.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.245),(44.405,19.415),(44.575,19.415),(44.575,19.245),(44.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.545),(74.225,17.715),(74.395,17.715),(74.395,17.545),(74.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.745),(16.115,10.915),(16.285,10.915),(16.285,10.745),(16.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.745),(16.625,10.915),(16.795,10.915),(16.795,10.745),(16.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.405),(16.115,10.575),(16.285,10.575),(16.285,10.405),(16.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.505),(31.025,15.675),(31.195,15.675),(31.195,15.505),(31.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.165),(31.025,15.335),(31.195,15.335),(31.195,15.165),(31.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.405),(16.625,10.575),(16.795,10.575),(16.795,10.405),(16.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.285),(20.915,4.455),(21.085,4.455),(21.085,4.285),(20.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.625),(20.915,4.795),(21.085,4.795),(21.085,4.625),(20.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.065),(16.115,10.235),(16.285,10.235),(16.285,10.065),(16.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.065),(16.625,10.235),(16.795,10.235),(16.795,10.065),(16.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.605),(11.825,3.775),(11.995,3.775),(11.995,3.605),(11.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.265),(11.315,3.435),(11.485,3.435),(11.485,3.265),(11.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.605),(11.315,3.775),(11.485,3.775),(11.485,3.605),(11.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.265),(11.825,3.435),(11.995,3.435),(11.995,3.265),(11.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.325),(30.515,6.495),(30.685,6.495),(30.685,6.325),(30.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.665),(30.515,6.835),(30.685,6.835),(30.685,6.665),(30.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.325),(30.005,6.495),(30.175,6.495),(30.175,6.325),(30.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.665),(30.005,6.835),(30.175,6.835),(30.175,6.665),(30.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.605),(25.715,3.775),(25.885,3.775),(25.885,3.605),(25.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.265),(25.205,3.435),(25.375,3.435),(25.375,3.265),(25.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.265),(25.715,3.435),(25.885,3.435),(25.885,3.265),(25.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.605),(25.205,3.775),(25.375,3.775),(25.375,3.605),(25.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.305),(39.605,5.475),(39.775,5.475),(39.775,5.305),(39.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.645),(39.605,5.815),(39.775,5.815),(39.775,5.645),(39.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.305),(15.605,5.475),(15.775,5.475),(15.775,5.305),(15.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.645),(15.605,5.815),(15.775,5.815),(15.775,5.645),(15.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.205),(83.315,17.375),(83.485,17.375),(83.485,17.205),(83.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.865),(74.225,17.035),(74.395,17.035),(74.395,16.865),(74.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.545),(83.315,17.715),(83.485,17.715),(83.485,17.545),(83.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.605),(20.915,3.775),(21.085,3.775),(21.085,3.605),(20.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.265),(20.915,3.435),(21.085,3.435),(21.085,3.265),(20.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.845),(10.805,16.015),(10.975,16.015),(10.975,15.845),(10.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.505),(64.115,15.675),(64.285,15.675),(64.285,15.505),(64.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.505),(64.625,15.675),(64.795,15.675),(64.795,15.505),(64.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.165),(64.115,15.335),(64.285,15.335),(64.285,15.165),(64.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.165),(64.625,15.335),(64.795,15.335),(64.795,15.165),(64.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.385),(82.805,9.555),(82.975,9.555),(82.975,9.385),(82.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.725),(82.805,9.895),(82.975,9.895),(82.975,9.725),(82.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.665),(58.805,6.835),(58.975,6.835),(58.975,6.665),(58.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.325),(58.805,6.495),(58.975,6.495),(58.975,6.325),(58.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.485),(40.625,14.655),(40.795,14.655),(40.795,14.485),(40.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.825),(40.625,14.995),(40.795,14.995),(40.795,14.825),(40.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.825),(40.115,14.995),(40.285,14.995),(40.285,14.825),(40.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.485),(40.115,14.655),(40.285,14.655),(40.285,14.485),(40.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.145),(40.625,14.315),(40.795,14.315),(40.795,14.145),(40.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.225),(55.025,18.395),(55.195,18.395),(55.195,18.225),(55.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.565),(55.025,18.735),(55.195,18.735),(55.195,18.565),(55.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.325),(34.805,6.495),(34.975,6.495),(34.975,6.325),(34.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.665),(34.805,6.835),(34.975,6.835),(34.975,6.665),(34.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.465),(73.715,13.635),(73.885,13.635),(73.885,13.465),(73.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.665),(54.515,6.835),(54.685,6.835),(54.685,6.665),(54.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.325),(54.515,6.495),(54.685,6.495),(54.685,6.325),(54.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.665),(54.005,6.835),(54.175,6.835),(54.175,6.665),(54.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.325),(54.005,6.495),(54.175,6.495),(54.175,6.325),(54.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.325),(10.805,6.495),(10.975,6.495),(10.975,6.325),(10.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.665),(10.805,6.835),(10.975,6.835),(10.975,6.665),(10.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.185),(39.605,16.355),(39.775,16.355),(39.775,16.185),(39.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.525),(39.605,16.695),(39.775,16.695),(39.775,16.525),(39.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.265),(49.205,3.435),(49.375,3.435),(49.375,3.265),(49.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.605),(49.205,3.775),(49.375,3.775),(49.375,3.605),(49.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.605),(49.715,3.775),(49.885,3.775),(49.885,3.605),(49.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.265),(49.715,3.435),(49.885,3.435),(49.885,3.265),(49.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.945),(83.315,4.115),(83.485,4.115),(83.485,3.945),(83.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.945),(79.025,4.115),(79.195,4.115),(79.195,3.945),(79.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.305),(63.605,5.475),(63.775,5.475),(63.775,5.305),(63.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.645),(63.605,5.815),(63.775,5.815),(63.775,5.645),(63.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.905),(79.025,19.075),(79.195,19.075),(79.195,18.905),(79.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.745),(83.315,10.915),(83.485,10.915),(83.485,10.745),(83.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.065),(83.315,10.235),(83.485,10.235),(83.485,10.065),(83.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.405),(83.315,10.575),(83.485,10.575),(83.485,10.405),(83.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.465),(83.315,13.635),(83.485,13.635),(83.485,13.465),(83.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.725),(45.425,9.895),(45.595,9.895),(45.595,9.725),(45.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.385),(45.425,9.555),(45.595,9.555),(45.595,9.385),(45.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.945),(35.315,4.115),(35.485,4.115),(35.485,3.945),(35.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.945),(35.825,4.115),(35.995,4.115),(35.995,3.945),(35.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.545),(49.205,17.715),(49.375,17.715),(49.375,17.545),(49.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.205),(49.205,17.375),(49.375,17.375),(49.375,17.205),(49.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.365),(6.515,8.535),(6.685,8.535),(6.685,8.365),(6.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.705),(6.515,8.875),(6.685,8.875),(6.685,8.705),(6.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.205),(49.715,17.375),(49.885,17.375),(49.885,17.205),(49.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.025),(6.515,8.195),(6.685,8.195),(6.685,8.025),(6.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.545),(49.715,17.715),(49.885,17.715),(49.885,17.545),(49.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.745),(6.515,10.915),(6.685,10.915),(6.685,10.745),(6.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.405),(6.515,10.575),(6.685,10.575),(6.685,10.405),(6.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.065),(6.515,10.235),(6.685,10.235),(6.685,10.065),(6.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.945),(30.005,4.115),(30.175,4.115),(30.175,3.945),(30.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.945),(30.515,4.115),(30.685,4.115),(30.685,3.945),(30.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.385),(7.025,9.555),(7.195,9.555),(7.195,9.385),(7.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.725),(7.025,9.895),(7.195,9.895),(7.195,9.725),(7.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.945),(59.315,4.115),(59.485,4.115),(59.485,3.945),(59.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.945),(59.825,4.115),(59.995,4.115),(59.995,3.945),(59.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.225),(25.205,18.395),(25.375,18.395),(25.375,18.225),(25.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.565),(25.715,18.735),(25.885,18.735),(25.885,18.565),(25.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.565),(25.205,18.735),(25.375,18.735),(25.375,18.565),(25.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.225),(25.715,18.395),(25.885,18.395),(25.885,18.225),(25.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.505),(16.625,15.675),(16.795,15.675),(16.795,15.505),(16.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.505),(16.115,15.675),(16.285,15.675),(16.285,15.505),(16.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.165),(16.115,15.335),(16.285,15.335),(16.285,15.165),(16.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.165),(16.625,15.335),(16.795,15.335),(16.795,15.165),(16.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.545),(16.115,17.715),(16.285,17.715),(16.285,17.545),(16.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.545),(16.625,17.715),(16.795,17.715),(16.795,17.545),(16.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.205),(16.115,17.375),(16.285,17.375),(16.285,17.205),(16.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.205),(16.625,17.375),(16.795,17.375),(16.795,17.205),(16.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.885),(50.225,18.055),(50.395,18.055),(50.395,17.885),(50.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.865),(64.115,17.035),(64.285,17.035),(64.285,16.865),(64.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.865),(64.625,17.035),(64.795,17.035),(64.795,16.865),(64.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.325),(49.205,6.495),(49.375,6.495),(49.375,6.325),(49.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.325),(49.715,6.495),(49.885,6.495),(49.885,6.325),(49.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.665),(49.205,6.835),(49.375,6.835),(49.375,6.665),(49.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.665),(49.715,6.835),(49.885,6.835),(49.885,6.665),(49.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.045),(79.025,9.215),(79.195,9.215),(79.195,9.045),(79.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.125),(7.025,13.295),(7.195,13.295),(7.195,13.125),(7.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.465),(7.025,13.635),(7.195,13.635),(7.195,13.465),(7.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.805),(7.025,13.975),(7.195,13.975),(7.195,13.805),(7.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.745),(69.425,10.915),(69.595,10.915),(69.595,10.745),(69.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.065),(69.425,10.235),(69.595,10.235),(69.595,10.065),(69.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.405),(69.425,10.575),(69.595,10.575),(69.595,10.405),(69.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.545),(68.915,17.715),(69.085,17.715),(69.085,17.545),(68.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.205),(68.915,17.375),(69.085,17.375),(69.085,17.205),(68.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.945),(21.425,4.115),(21.595,4.115),(21.595,3.945),(21.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.845),(58.805,16.015),(58.975,16.015),(58.975,15.845),(58.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.565),(44.915,18.735),(45.085,18.735),(45.085,18.565),(44.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.225),(44.915,18.395),(45.085,18.395),(45.085,18.225),(44.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.285),(21.425,4.455),(21.595,4.455),(21.595,4.285),(21.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.945),(31.025,4.115),(31.195,4.115),(31.195,3.945),(31.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.625),(21.425,4.795),(21.595,4.795),(21.595,4.625),(21.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.405),(21.425,10.575),(21.595,10.575),(21.595,10.405),(21.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.745),(21.425,10.915),(21.595,10.915),(21.595,10.745),(21.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.065),(21.425,10.235),(21.595,10.235),(21.595,10.065),(21.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.745),(74.225,10.915),(74.395,10.915),(74.395,10.745),(74.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.065),(74.225,10.235),(74.395,10.235),(74.395,10.065),(74.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.405),(74.225,10.575),(74.395,10.575),(74.395,10.405),(74.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.065),(64.115,10.235),(64.285,10.235),(64.285,10.065),(64.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.065),(64.625,10.235),(64.795,10.235),(64.795,10.065),(64.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.745),(64.115,10.915),(64.285,10.915),(64.285,10.745),(64.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.745),(64.625,10.915),(64.795,10.915),(64.795,10.745),(64.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.405),(64.115,10.575),(64.285,10.575),(64.285,10.405),(64.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.405),(64.625,10.575),(64.795,10.575),(64.795,10.405),(64.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.365),(26.225,8.535),(26.395,8.535),(26.395,8.365),(26.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.705),(26.225,8.875),(26.395,8.875),(26.395,8.705),(26.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.025),(26.225,8.195),(26.395,8.195),(26.395,8.025),(26.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.285),(44.405,4.455),(44.575,4.455),(44.575,4.285),(44.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.625),(44.405,4.795),(44.575,4.795),(44.575,4.625),(44.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.965),(73.205,5.135),(73.375,5.135),(73.375,4.965),(73.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.965),(73.715,5.135),(73.885,5.135),(73.885,4.965),(73.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.245),(63.605,19.415),(63.775,19.415),(63.775,19.245),(63.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.745),(26.225,10.915),(26.395,10.915),(26.395,10.745),(26.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.405),(26.225,10.575),(26.395,10.575),(26.395,10.405),(26.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.065),(26.225,10.235),(26.395,10.235),(26.395,10.065),(26.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.305),(68.405,5.475),(68.575,5.475),(68.575,5.305),(68.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.645),(68.405,5.815),(68.575,5.815),(68.575,5.645),(68.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.845),(83.315,16.015),(83.485,16.015),(83.485,15.845),(83.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.265),(26.225,3.435),(26.395,3.435),(26.395,3.265),(26.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.605),(26.225,3.775),(26.395,3.775),(26.395,3.605),(26.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.965),(25.205,5.135),(25.375,5.135),(25.375,4.965),(25.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.965),(25.715,5.135),(25.885,5.135),(25.885,4.965),(25.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.185),(6.515,16.355),(6.685,16.355),(6.685,16.185),(6.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.525),(6.515,16.695),(6.685,16.695),(6.685,16.525),(6.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.845),(35.315,16.015),(35.485,16.015),(35.485,15.845),(35.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.845),(35.825,16.015),(35.995,16.015),(35.995,15.845),(35.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.445),(74.225,12.615),(74.395,12.615),(74.395,12.445),(74.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.785),(74.225,12.955),(74.395,12.955),(74.395,12.785),(74.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.105),(74.225,12.275),(74.395,12.275),(74.395,12.105),(74.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.205),(35.825,17.375),(35.995,17.375),(35.995,17.205),(35.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.545),(35.825,17.715),(35.995,17.715),(35.995,17.545),(35.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.205),(35.315,17.375),(35.485,17.375),(35.485,17.205),(35.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.545),(35.315,17.715),(35.485,17.715),(35.485,17.545),(35.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.025),(54.005,8.195),(54.175,8.195),(54.175,8.025),(54.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.705),(54.005,8.875),(54.175,8.875),(54.175,8.705),(54.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.365),(54.005,8.535),(54.175,8.535),(54.175,8.365),(54.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.705),(54.515,8.875),(54.685,8.875),(54.685,8.705),(54.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.365),(54.515,8.535),(54.685,8.535),(54.685,8.365),(54.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.225),(59.825,18.395),(59.995,18.395),(59.995,18.225),(59.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.565),(59.315,18.735),(59.485,18.735),(59.485,18.565),(59.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.225),(59.315,18.395),(59.485,18.395),(59.485,18.225),(59.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.565),(59.825,18.735),(59.995,18.735),(59.995,18.565),(59.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.945),(55.025,4.115),(55.195,4.115),(55.195,3.945),(55.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.205),(21.425,17.375),(21.595,17.375),(21.595,17.205),(21.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.545),(21.425,17.715),(21.595,17.715),(21.595,17.545),(21.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.745),(54.005,10.915),(54.175,10.915),(54.175,10.745),(54.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.745),(54.515,10.915),(54.685,10.915),(54.685,10.745),(54.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.405),(54.515,10.575),(54.685,10.575),(54.685,10.405),(54.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.405),(54.005,10.575),(54.175,10.575),(54.175,10.405),(54.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.065),(54.005,10.235),(54.175,10.235),(54.175,10.065),(54.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.065),(54.515,10.235),(54.685,10.235),(54.685,10.065),(54.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.405),(35.825,10.575),(35.995,10.575),(35.995,10.405),(35.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.745),(35.315,10.915),(35.485,10.915),(35.485,10.745),(35.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.745),(35.825,10.915),(35.995,10.915),(35.995,10.745),(35.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.405),(35.315,10.575),(35.485,10.575),(35.485,10.405),(35.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.385),(55.025,9.555),(55.195,9.555),(55.195,9.385),(55.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.725),(55.025,9.895),(55.195,9.895),(55.195,9.725),(55.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.065),(35.825,10.235),(35.995,10.235),(35.995,10.065),(35.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.065),(35.315,10.235),(35.485,10.235),(35.485,10.065),(35.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.825),(50.225,14.995),(50.395,14.995),(50.395,14.825),(50.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.145),(50.225,14.315),(50.395,14.315),(50.395,14.145),(50.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.485),(50.225,14.655),(50.395,14.655),(50.395,14.485),(50.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.645),(11.315,5.815),(11.485,5.815),(11.485,5.645),(11.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.305),(11.825,5.475),(11.995,5.475),(11.995,5.305),(11.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.645),(11.825,5.815),(11.995,5.815),(11.995,5.645),(11.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.305),(11.315,5.475),(11.485,5.475),(11.485,5.305),(11.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.205),(54.005,17.375),(54.175,17.375),(54.175,17.205),(54.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.545),(54.005,17.715),(54.175,17.715),(54.175,17.545),(54.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.545),(54.515,17.715),(54.685,17.715),(54.685,17.545),(54.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.205),(54.515,17.375),(54.685,17.375),(54.685,17.205),(54.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.485),(31.025,14.655),(31.195,14.655),(31.195,14.485),(31.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.305),(20.915,5.475),(21.085,5.475),(21.085,5.305),(20.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.825),(31.025,14.995),(31.195,14.995),(31.195,14.825),(31.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.645),(20.915,5.815),(21.085,5.815),(21.085,5.645),(20.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.145),(31.025,14.315),(31.195,14.315),(31.195,14.145),(31.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.885),(6.515,18.055),(6.685,18.055),(6.685,17.885),(6.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.205),(20.405,17.375),(20.575,17.375),(20.575,17.205),(20.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.545),(20.405,17.715),(20.575,17.715),(20.575,17.545),(20.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.125),(55.025,13.295),(55.195,13.295),(55.195,13.125),(55.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.465),(55.025,13.635),(55.195,13.635),(55.195,13.465),(55.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.805),(55.025,13.975),(55.195,13.975),(55.195,13.805),(55.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.265),(69.425,3.435),(69.595,3.435),(69.595,3.265),(69.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.605),(69.425,3.775),(69.595,3.775),(69.595,3.605),(69.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.845),(39.605,16.015),(39.775,16.015),(39.775,15.845),(39.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.005),(78.515,7.175),(78.685,7.175),(78.685,7.005),(78.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.265),(20.405,3.435),(20.575,3.435),(20.575,3.265),(20.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.605),(20.405,3.775),(20.575,3.775),(20.575,3.605),(20.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.905),(20.915,19.075),(21.085,19.075),(21.085,18.905),(20.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.985),(55.025,6.155),(55.195,6.155),(55.195,5.985),(55.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,2.925),(16.115,3.095),(16.285,3.095),(16.285,2.925),(16.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.485),(20.405,14.655),(20.575,14.655),(20.575,14.485),(20.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.825),(20.405,14.995),(20.575,14.995),(20.575,14.825),(20.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,2.925),(16.625,3.095),(16.795,3.095),(16.795,2.925),(16.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.145),(20.405,14.315),(20.575,14.315),(20.575,14.145),(20.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.625),(15.605,4.795),(15.775,4.795),(15.775,4.625),(15.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.285),(15.605,4.455),(15.775,4.455),(15.775,4.285),(15.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.845),(25.715,16.015),(25.885,16.015),(25.885,15.845),(25.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.845),(25.205,16.015),(25.375,16.015),(25.375,15.845),(25.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.045),(73.205,9.215),(73.375,9.215),(73.375,9.045),(73.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.045),(73.715,9.215),(73.885,9.215),(73.885,9.045),(73.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.185),(20.915,16.355),(21.085,16.355),(21.085,16.185),(20.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.525),(20.915,16.695),(21.085,16.695),(21.085,16.525),(20.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.945),(45.425,4.115),(45.595,4.115),(45.595,3.945),(45.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.905),(31.025,19.075),(31.195,19.075),(31.195,18.905),(31.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.045),(25.205,9.215),(25.375,9.215),(25.375,9.045),(25.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.045),(25.715,9.215),(25.885,9.215),(25.885,9.045),(25.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.945),(26.225,4.115),(26.395,4.115),(26.395,3.945),(26.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.045),(20.405,9.215),(20.575,9.215),(20.575,9.045),(20.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.725),(78.515,9.895),(78.685,9.895),(78.685,9.725),(78.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.725),(78.005,9.895),(78.175,9.895),(78.175,9.725),(78.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.385),(78.005,9.555),(78.175,9.555),(78.175,9.385),(78.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.385),(78.515,9.555),(78.685,9.555),(78.685,9.385),(78.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.425),(35.825,11.595),(35.995,11.595),(35.995,11.425),(35.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.965),(6.515,5.135),(6.685,5.135),(6.685,4.965),(6.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.405),(11.315,10.575),(11.485,10.575),(11.485,10.405),(11.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.405),(11.825,10.575),(11.995,10.575),(11.995,10.405),(11.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.745),(11.315,10.915),(11.485,10.915),(11.485,10.745),(11.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.745),(11.825,10.915),(11.995,10.915),(11.995,10.745),(11.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.065),(11.315,10.235),(11.485,10.235),(11.485,10.065),(11.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.065),(11.825,10.235),(11.995,10.235),(11.995,10.065),(11.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.925),(40.115,3.095),(40.285,3.095),(40.285,2.925),(40.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.925),(40.625,3.095),(40.795,3.095),(40.795,2.925),(40.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.905),(74.225,19.075),(74.395,19.075),(74.395,18.905),(74.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.565),(64.115,18.735),(64.285,18.735),(64.285,18.565),(64.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.565),(64.625,18.735),(64.795,18.735),(64.795,18.565),(64.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.225),(64.625,18.395),(64.795,18.395),(64.795,18.225),(64.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.225),(64.115,18.395),(64.285,18.395),(64.285,18.225),(64.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.025),(68.915,8.195),(69.085,8.195),(69.085,8.025),(68.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.325),(82.805,6.495),(82.975,6.495),(82.975,6.325),(82.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.365),(68.915,8.535),(69.085,8.535),(69.085,8.365),(68.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.705),(68.915,8.875),(69.085,8.875),(69.085,8.705),(68.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.665),(82.805,6.835),(82.975,6.835),(82.975,6.665),(82.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.185),(45.425,16.355),(45.595,16.355),(45.595,16.185),(45.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.525),(45.425,16.695),(45.595,16.695),(45.595,16.525),(45.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.965),(49.715,5.135),(49.885,5.135),(49.885,4.965),(49.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.965),(49.205,5.135),(49.375,5.135),(49.375,4.965),(49.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.705),(20.915,8.875),(21.085,8.875),(21.085,8.705),(20.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.365),(20.915,8.535),(21.085,8.535),(21.085,8.365),(20.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.025),(20.915,8.195),(21.085,8.195),(21.085,8.025),(20.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,2.925),(78.005,3.095),(78.175,3.095),(78.175,2.925),(78.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,2.925),(78.515,3.095),(78.685,3.095),(78.685,2.925),(78.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.145),(78.005,14.315),(78.175,14.315),(78.175,14.145),(78.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.145),(78.515,14.315),(78.685,14.315),(78.685,14.145),(78.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.825),(78.005,14.995),(78.175,14.995),(78.175,14.825),(78.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.485),(78.515,14.655),(78.685,14.655),(78.685,14.485),(78.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.825),(78.515,14.995),(78.685,14.995),(78.685,14.825),(78.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.485),(78.005,14.655),(78.175,14.655),(78.175,14.485),(78.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.785),(55.025,12.955),(55.195,12.955),(55.195,12.785),(55.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.445),(55.025,12.615),(55.195,12.615),(55.195,12.445),(55.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.105),(55.025,12.275),(55.195,12.275),(55.195,12.105),(55.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.745),(45.425,10.915),(45.595,10.915),(45.595,10.745),(45.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.405),(45.425,10.575),(45.595,10.575),(45.595,10.405),(45.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.065),(45.425,10.235),(45.595,10.235),(45.595,10.065),(45.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.365),(64.625,8.535),(64.795,8.535),(64.795,8.365),(64.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.865),(79.025,17.035),(79.195,17.035),(79.195,16.865),(79.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.705),(64.115,8.875),(64.285,8.875),(64.285,8.705),(64.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.945),(73.715,4.115),(73.885,4.115),(73.885,3.945),(73.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.945),(73.205,4.115),(73.375,4.115),(73.375,3.945),(73.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.965),(30.515,5.135),(30.685,5.135),(30.685,4.965),(30.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.965),(30.005,5.135),(30.175,5.135),(30.175,4.965),(30.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.945),(64.625,4.115),(64.795,4.115),(64.795,3.945),(64.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.945),(64.115,4.115),(64.285,4.115),(64.285,3.945),(64.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,2.925),(6.515,3.095),(6.685,3.095),(6.685,2.925),(6.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.625),(69.425,4.795),(69.595,4.795),(69.595,4.625),(69.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.285),(69.425,4.455),(69.595,4.455),(69.595,4.285),(69.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.445),(7.025,12.615),(7.195,12.615),(7.195,12.445),(7.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.785),(7.025,12.955),(7.195,12.955),(7.195,12.785),(7.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.805),(26.225,13.975),(26.395,13.975),(26.395,13.805),(26.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.465),(26.225,13.635),(26.395,13.635),(26.395,13.465),(26.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.125),(26.225,13.295),(26.395,13.295),(26.395,13.125),(26.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.985),(79.025,6.155),(79.195,6.155),(79.195,5.985),(79.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.105),(7.025,12.275),(7.195,12.275),(7.195,12.105),(7.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.725),(30.515,9.895),(30.685,9.895),(30.685,9.725),(30.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.385),(30.515,9.555),(30.685,9.555),(30.685,9.385),(30.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.385),(30.005,9.555),(30.175,9.555),(30.175,9.385),(30.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.725),(30.005,9.895),(30.175,9.895),(30.175,9.725),(30.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.625),(39.605,4.795),(39.775,4.795),(39.775,4.625),(39.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.285),(39.605,4.455),(39.775,4.455),(39.775,4.285),(39.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.025),(74.225,8.195),(74.395,8.195),(74.395,8.025),(74.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.365),(74.225,8.535),(74.395,8.535),(74.395,8.365),(74.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.705),(74.225,8.875),(74.395,8.875),(74.395,8.705),(74.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.145),(79.025,14.315),(79.195,14.315),(79.195,14.145),(79.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.485),(79.025,14.655),(79.195,14.655),(79.195,14.485),(79.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.825),(79.025,14.995),(79.195,14.995),(79.195,14.825),(79.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.845),(59.315,16.015),(59.485,16.015),(59.485,15.845),(59.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.785),(68.405,12.955),(68.575,12.955),(68.575,12.785),(68.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.105),(68.405,12.275),(68.575,12.275),(68.575,12.105),(68.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.845),(59.825,16.015),(59.995,16.015),(59.995,15.845),(59.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.445),(68.405,12.615),(68.575,12.615),(68.575,12.445),(68.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.885),(15.605,18.055),(15.775,18.055),(15.775,17.885),(15.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.965),(58.805,5.135),(58.975,5.135),(58.975,4.965),(58.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.845),(11.315,16.015),(11.485,16.015),(11.485,15.845),(11.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.445),(20.405,12.615),(20.575,12.615),(20.575,12.445),(20.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.785),(20.405,12.955),(20.575,12.955),(20.575,12.785),(20.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.105),(20.405,12.275),(20.575,12.275),(20.575,12.105),(20.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.845),(11.825,16.015),(11.995,16.015),(11.995,15.845),(11.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.965),(34.805,5.135),(34.975,5.135),(34.975,4.965),(34.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.725),(15.605,9.895),(15.775,9.895),(15.775,9.725),(15.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.385),(15.605,9.555),(15.775,9.555),(15.775,9.385),(15.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.965),(54.005,5.135),(54.175,5.135),(54.175,4.965),(54.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.965),(10.805,5.135),(10.975,5.135),(10.975,4.965),(10.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.965),(54.515,5.135),(54.685,5.135),(54.685,4.965),(54.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.745),(59.825,10.915),(59.995,10.915),(59.995,10.745),(59.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.745),(59.315,10.915),(59.485,10.915),(59.485,10.745),(59.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.065),(59.315,10.235),(59.485,10.235),(59.485,10.065),(59.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.065),(59.825,10.235),(59.995,10.235),(59.995,10.065),(59.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.885),(20.915,18.055),(21.085,18.055),(21.085,17.885),(20.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,2.925),(30.005,3.095),(30.175,3.095),(30.175,2.925),(30.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.925),(30.515,3.095),(30.685,3.095),(30.685,2.925),(30.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.405),(59.825,10.575),(59.995,10.575),(59.995,10.405),(59.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.405),(59.315,10.575),(59.485,10.575),(59.485,10.405),(59.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.485),(30.515,14.655),(30.685,14.655),(30.685,14.485),(30.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.825),(30.515,14.995),(30.685,14.995),(30.685,14.825),(30.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.185),(49.715,16.355),(49.885,16.355),(49.885,16.185),(49.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.185),(49.205,16.355),(49.375,16.355),(49.375,16.185),(49.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.825),(30.005,14.995),(30.175,14.995),(30.175,14.825),(30.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.485),(30.005,14.655),(30.175,14.655),(30.175,14.485),(30.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.145),(30.005,14.315),(30.175,14.315),(30.175,14.145),(30.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.905),(39.605,19.075),(39.775,19.075),(39.775,18.905),(39.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.525),(49.205,16.695),(49.375,16.695),(49.375,16.525),(49.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.525),(49.715,16.695),(49.885,16.695),(49.885,16.525),(49.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,2.925),(64.115,3.095),(64.285,3.095),(64.285,2.925),(64.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,2.925),(64.625,3.095),(64.795,3.095),(64.795,2.925),(64.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.565),(54.515,18.735),(54.685,18.735),(54.685,18.565),(54.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.225),(54.515,18.395),(54.685,18.395),(54.685,18.225),(54.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.565),(54.005,18.735),(54.175,18.735),(54.175,18.565),(54.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.285),(63.605,4.455),(63.775,4.455),(63.775,4.285),(63.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.225),(54.005,18.395),(54.175,18.395),(54.175,18.225),(54.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.625),(63.605,4.795),(63.775,4.795),(63.775,4.625),(63.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.225),(7.025,18.395),(7.195,18.395),(7.195,18.225),(7.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.565),(7.025,18.735),(7.195,18.735),(7.195,18.565),(7.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.125),(15.605,13.295),(15.775,13.295),(15.775,13.125),(15.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.465),(15.605,13.635),(15.775,13.635),(15.775,13.465),(15.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.805),(15.605,13.975),(15.775,13.975),(15.775,13.805),(15.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.905),(49.715,19.075),(49.885,19.075),(49.885,18.905),(49.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.905),(49.205,19.075),(49.375,19.075),(49.375,18.905),(49.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.965),(82.805,5.135),(82.975,5.135),(82.975,4.965),(82.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.385),(63.605,9.555),(63.775,9.555),(63.775,9.385),(63.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.885),(59.825,18.055),(59.995,18.055),(59.995,17.885),(59.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.885),(59.315,18.055),(59.485,18.055),(59.485,17.885),(59.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.725),(63.605,9.895),(63.775,9.895),(63.775,9.725),(63.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.685),(74.225,7.855),(74.395,7.855),(74.395,7.685),(74.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.345),(74.225,7.515),(74.395,7.515),(74.395,7.345),(74.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.885),(68.405,18.055),(68.575,18.055),(68.575,17.885),(68.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.605),(39.605,3.775),(39.775,3.775),(39.775,3.605),(39.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.265),(39.605,3.435),(39.775,3.435),(39.775,3.265),(39.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.145),(58.805,14.315),(58.975,14.315),(58.975,14.145),(58.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.565),(11.315,18.735),(11.485,18.735),(11.485,18.565),(11.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.225),(11.825,18.395),(11.995,18.395),(11.995,18.225),(11.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.825),(58.805,14.995),(58.975,14.995),(58.975,14.825),(58.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.485),(58.805,14.655),(58.975,14.655),(58.975,14.485),(58.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.565),(11.825,18.735),(11.995,18.735),(11.995,18.565),(11.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.225),(11.315,18.395),(11.485,18.395),(11.485,18.225),(11.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.565),(50.225,18.735),(50.395,18.735),(50.395,18.565),(50.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.225),(50.225,18.395),(50.395,18.395),(50.395,18.225),(50.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.925),(54.515,3.095),(54.685,3.095),(54.685,2.925),(54.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.925),(54.005,3.095),(54.175,3.095),(54.175,2.925),(54.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.505),(54.515,15.675),(54.685,15.675),(54.685,15.505),(54.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.685),(26.225,7.855),(26.395,7.855),(26.395,7.685),(26.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.165),(54.515,15.335),(54.685,15.335),(54.685,15.165),(54.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.165),(54.005,15.335),(54.175,15.335),(54.175,15.165),(54.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.145),(10.805,14.315),(10.975,14.315),(10.975,14.145),(10.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.505),(54.005,15.675),(54.175,15.675),(54.175,15.505),(54.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.485),(10.805,14.655),(10.975,14.655),(10.975,14.485),(10.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.825),(10.805,14.995),(10.975,14.995),(10.975,14.825),(10.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.145),(68.405,14.315),(68.575,14.315),(68.575,14.145),(68.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.165),(6.515,15.335),(6.685,15.335),(6.685,15.165),(6.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.485),(68.405,14.655),(68.575,14.655),(68.575,14.485),(68.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.825),(68.405,14.995),(68.575,14.995),(68.575,14.825),(68.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.505),(6.515,15.675),(6.685,15.675),(6.685,15.505),(6.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.845),(73.205,16.015),(73.375,16.015),(73.375,15.845),(73.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.205),(50.225,17.375),(50.395,17.375),(50.395,17.205),(50.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.545),(50.225,17.715),(50.395,17.715),(50.395,17.545),(50.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.125),(63.605,13.295),(63.775,13.295),(63.775,13.125),(63.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.465),(63.605,13.635),(63.775,13.635),(63.775,13.465),(63.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.805),(63.605,13.975),(63.775,13.975),(63.775,13.805),(63.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.845),(73.715,16.015),(73.885,16.015),(73.885,15.845),(73.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.005),(79.025,7.175),(79.195,7.175),(79.195,7.005),(79.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.345),(79.025,7.515),(79.195,7.515),(79.195,7.345),(79.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.685),(79.025,7.855),(79.195,7.855),(79.195,7.685),(79.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.045),(54.515,9.215),(54.685,9.215),(54.685,9.045),(54.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.045),(54.005,9.215),(54.175,9.215),(54.175,9.045),(54.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.085),(54.515,11.255),(54.685,11.255),(54.685,11.085),(54.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.085),(54.005,11.255),(54.175,11.255),(54.175,11.085),(54.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.425),(54.515,11.595),(54.685,11.595),(54.685,11.425),(54.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.765),(54.515,11.935),(54.685,11.935),(54.685,11.765),(54.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.765),(54.005,11.935),(54.175,11.935),(54.175,11.765),(54.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.425),(54.005,11.595),(54.175,11.595),(54.175,11.425),(54.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.045),(6.515,9.215),(6.685,9.215),(6.685,9.045),(6.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.565),(45.425,18.735),(45.595,18.735),(45.595,18.565),(45.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.225),(45.425,18.395),(45.595,18.395),(45.595,18.225),(45.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.685),(7.025,7.855),(7.195,7.855),(7.195,7.685),(7.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.005),(7.025,7.175),(7.195,7.175),(7.195,7.005),(7.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.045),(44.405,9.215),(44.575,9.215),(44.575,9.045),(44.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.345),(7.025,7.515),(7.195,7.515),(7.195,7.345),(7.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.605),(63.605,3.775),(63.775,3.775),(63.775,3.605),(63.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.265),(63.605,3.435),(63.775,3.435),(63.775,3.265),(63.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.085),(6.515,11.255),(6.685,11.255),(6.685,11.085),(6.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.425),(6.515,11.595),(6.685,11.595),(6.685,11.425),(6.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.765),(6.515,11.935),(6.685,11.935),(6.685,11.765),(6.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.045),(68.405,9.215),(68.575,9.215),(68.575,9.045),(68.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.965),(78.005,5.135),(78.175,5.135),(78.175,4.965),(78.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.965),(78.515,5.135),(78.685,5.135),(78.685,4.965),(78.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.385),(49.715,9.555),(49.885,9.555),(49.885,9.385),(49.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.385),(49.205,9.555),(49.375,9.555),(49.375,9.385),(49.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.725),(49.205,9.895),(49.375,9.895),(49.375,9.725),(49.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.725),(49.715,9.895),(49.885,9.895),(49.885,9.725),(49.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.625),(35.315,4.795),(35.485,4.795),(35.485,4.625),(35.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.285),(35.315,4.455),(35.485,4.455),(35.485,4.285),(35.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.625),(35.825,4.795),(35.995,4.795),(35.995,4.625),(35.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.285),(35.825,4.455),(35.995,4.455),(35.995,4.285),(35.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.565),(16.625,18.735),(16.795,18.735),(16.795,18.565),(16.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.225),(16.115,18.395),(16.285,18.395),(16.285,18.225),(16.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.225),(16.625,18.395),(16.795,18.395),(16.795,18.225),(16.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.565),(16.115,18.735),(16.285,18.735),(16.285,18.565),(16.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.285),(26.225,4.455),(26.395,4.455),(26.395,4.285),(26.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.625),(26.225,4.795),(26.395,4.795),(26.395,4.625),(26.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.845),(15.605,16.015),(15.775,16.015),(15.775,15.845),(15.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.785),(6.515,12.955),(6.685,12.955),(6.685,12.785),(6.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.445),(6.515,12.615),(6.685,12.615),(6.685,12.445),(6.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.105),(6.515,12.275),(6.685,12.275),(6.685,12.105),(6.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.305),(73.715,5.475),(73.885,5.475),(73.885,5.305),(73.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.885),(55.025,18.055),(55.195,18.055),(55.195,17.885),(55.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.645),(73.715,5.815),(73.885,5.815),(73.885,5.645),(73.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.305),(73.205,5.475),(73.375,5.475),(73.375,5.305),(73.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.645),(73.205,5.815),(73.375,5.815),(73.375,5.645),(73.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.905),(44.405,19.075),(44.575,19.075),(44.575,18.905),(44.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.185),(58.805,16.355),(58.975,16.355),(58.975,16.185),(58.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.525),(58.805,16.695),(58.975,16.695),(58.975,16.525),(58.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.205),(69.425,17.375),(69.595,17.375),(69.595,17.205),(69.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.545),(69.425,17.715),(69.595,17.715),(69.595,17.545),(69.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.865),(16.115,17.035),(16.285,17.035),(16.285,16.865),(16.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.865),(16.625,17.035),(16.795,17.035),(16.795,16.865),(16.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.005),(31.025,7.175),(31.195,7.175),(31.195,7.005),(31.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.345),(31.025,7.515),(31.195,7.515),(31.195,7.345),(31.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.685),(31.025,7.855),(31.195,7.855),(31.195,7.685),(31.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,2.925),(83.315,3.095),(83.485,3.095),(83.485,2.925),(83.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.865),(59.825,17.035),(59.995,17.035),(59.995,16.865),(59.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.185),(55.025,16.355),(55.195,16.355),(55.195,16.185),(55.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.525),(55.025,16.695),(55.195,16.695),(55.195,16.525),(55.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.865),(59.315,17.035),(59.485,17.035),(59.485,16.865),(59.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.905),(82.805,19.075),(82.975,19.075),(82.975,18.905),(82.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.085),(7.025,11.255),(7.195,11.255),(7.195,11.085),(7.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.425),(7.025,11.595),(7.195,11.595),(7.195,11.425),(7.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.765),(7.025,11.935),(7.195,11.935),(7.195,11.765),(7.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.085),(74.225,11.255),(74.395,11.255),(74.395,11.085),(74.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.425),(74.225,11.595),(74.395,11.595),(74.395,11.425),(74.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.765),(74.225,11.935),(74.395,11.935),(74.395,11.765),(74.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.045),(26.225,9.215),(26.395,9.215),(26.395,9.045),(26.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.425),(26.225,11.595),(26.395,11.595),(26.395,11.425),(26.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.765),(26.225,11.935),(26.395,11.935),(26.395,11.765),(26.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.085),(26.225,11.255),(26.395,11.255),(26.395,11.085),(26.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.285),(50.225,4.455),(50.395,4.455),(50.395,4.285),(50.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.625),(50.225,4.795),(50.395,4.795),(50.395,4.625),(50.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.845),(63.605,16.015),(63.775,16.015),(63.775,15.845),(63.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.145),(44.405,14.315),(44.575,14.315),(44.575,14.145),(44.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.945),(15.605,4.115),(15.775,4.115),(15.775,3.945),(15.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.485),(44.405,14.655),(44.575,14.655),(44.575,14.485),(44.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.825),(44.405,14.995),(44.575,14.995),(44.575,14.825),(44.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.805),(74.225,13.975),(74.395,13.975),(74.395,13.805),(74.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.465),(74.225,13.635),(74.395,13.635),(74.395,13.465),(74.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.045),(39.605,9.215),(39.775,9.215),(39.775,9.045),(39.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.125),(74.225,13.295),(74.395,13.295),(74.395,13.125),(74.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.205),(6.515,17.375),(6.685,17.375),(6.685,17.205),(6.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.545),(6.515,17.715),(6.685,17.715),(6.685,17.545),(6.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.805),(73.715,13.975),(73.885,13.975),(73.885,13.805),(73.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.165),(39.605,15.335),(39.775,15.335),(39.775,15.165),(39.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.005),(55.025,7.175),(55.195,7.175),(55.195,7.005),(55.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.505),(39.605,15.675),(39.775,15.675),(39.775,15.505),(39.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.345),(55.025,7.515),(55.195,7.515),(55.195,7.345),(55.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.685),(55.025,7.855),(55.195,7.855),(55.195,7.685),(55.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,2.925),(69.425,3.095),(69.595,3.095),(69.595,2.925),(69.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.085),(68.405,11.255),(68.575,11.255),(68.575,11.085),(68.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.765),(68.405,11.935),(68.575,11.935),(68.575,11.765),(68.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.425),(68.405,11.595),(68.575,11.595),(68.575,11.425),(68.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.505),(82.805,15.675),(82.975,15.675),(82.975,15.505),(82.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.165),(82.805,15.335),(82.975,15.335),(82.975,15.165),(82.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,2.925),(21.425,3.095),(21.595,3.095),(21.595,2.925),(21.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.285),(83.315,4.455),(83.485,4.455),(83.485,4.285),(83.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.625),(83.315,4.795),(83.485,4.795),(83.485,4.625),(83.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.425),(20.405,11.595),(20.575,11.595),(20.575,11.425),(20.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.085),(20.405,11.255),(20.575,11.255),(20.575,11.085),(20.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.765),(20.405,11.935),(20.575,11.935),(20.575,11.765),(20.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.505),(25.205,15.675),(25.375,15.675),(25.375,15.505),(25.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.505),(25.715,15.675),(25.885,15.675),(25.885,15.505),(25.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.165),(25.715,15.335),(25.885,15.335),(25.885,15.165),(25.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.165),(25.205,15.335),(25.375,15.335),(25.375,15.165),(25.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.005),(50.225,7.175),(50.395,7.175),(50.395,7.005),(50.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.685),(50.225,7.855),(50.395,7.855),(50.395,7.685),(50.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.345),(50.225,7.515),(50.395,7.515),(50.395,7.345),(50.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.185),(68.915,16.355),(69.085,16.355),(69.085,16.185),(68.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.525),(68.915,16.695),(69.085,16.695),(69.085,16.525),(68.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.445),(34.805,12.615),(34.975,12.615),(34.975,12.445),(34.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.785),(34.805,12.955),(34.975,12.955),(34.975,12.785),(34.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.105),(34.805,12.275),(34.975,12.275),(34.975,12.105),(34.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.785),(54.515,12.955),(54.685,12.955),(54.685,12.785),(54.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.445),(54.515,12.615),(54.685,12.615),(54.685,12.445),(54.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.785),(54.005,12.955),(54.175,12.955),(54.175,12.785),(54.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.445),(54.005,12.615),(54.175,12.615),(54.175,12.445),(54.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.105),(54.005,12.275),(54.175,12.275),(54.175,12.105),(54.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.105),(54.515,12.275),(54.685,12.275),(54.685,12.105),(54.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.225),(20.405,18.395),(20.575,18.395),(20.575,18.225),(20.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.565),(20.405,18.735),(20.575,18.735),(20.575,18.565),(20.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.085),(40.625,11.255),(40.795,11.255),(40.795,11.085),(40.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.085),(40.115,11.255),(40.285,11.255),(40.285,11.085),(40.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.765),(40.115,11.935),(40.285,11.935),(40.285,11.765),(40.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.765),(40.625,11.935),(40.795,11.935),(40.795,11.765),(40.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.425),(40.625,11.595),(40.795,11.595),(40.795,11.425),(40.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.425),(40.115,11.595),(40.285,11.595),(40.285,11.425),(40.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.425),(49.205,11.595),(49.375,11.595),(49.375,11.425),(49.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.425),(49.715,11.595),(49.885,11.595),(49.885,11.425),(49.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.085),(49.205,11.255),(49.375,11.255),(49.375,11.085),(49.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.705),(44.915,8.875),(45.085,8.875),(45.085,8.705),(44.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.365),(44.915,8.535),(45.085,8.535),(45.085,8.365),(44.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.085),(49.715,11.255),(49.885,11.255),(49.885,11.085),(49.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.765),(49.715,11.935),(49.885,11.935),(49.885,11.765),(49.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.765),(49.205,11.935),(49.375,11.935),(49.375,11.765),(49.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.985),(45.425,6.155),(45.595,6.155),(45.595,5.985),(45.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.765),(55.025,11.935),(55.195,11.935),(55.195,11.765),(55.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.085),(55.025,11.255),(55.195,11.255),(55.195,11.085),(55.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.425),(55.025,11.595),(55.195,11.595),(55.195,11.425),(55.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.105),(15.605,12.275),(15.775,12.275),(15.775,12.105),(15.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.785),(15.605,12.955),(15.775,12.955),(15.775,12.785),(15.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.445),(15.605,12.615),(15.775,12.615),(15.775,12.445),(15.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.405),(20.915,10.575),(21.085,10.575),(21.085,10.405),(20.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.745),(20.915,10.915),(21.085,10.915),(21.085,10.745),(20.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.065),(20.915,10.235),(21.085,10.235),(21.085,10.065),(20.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.205),(39.605,17.375),(39.775,17.375),(39.775,17.205),(39.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.545),(39.605,17.715),(39.775,17.715),(39.775,17.545),(39.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.445),(82.805,12.615),(82.975,12.615),(82.975,12.445),(82.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.785),(82.805,12.955),(82.975,12.955),(82.975,12.785),(82.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.925),(35.315,3.095),(35.485,3.095),(35.485,2.925),(35.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.925),(35.825,3.095),(35.995,3.095),(35.995,2.925),(35.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.105),(82.805,12.275),(82.975,12.275),(82.975,12.105),(82.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.225),(6.515,18.395),(6.685,18.395),(6.685,18.225),(6.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.565),(6.515,18.735),(6.685,18.735),(6.685,18.565),(6.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.505),(34.805,15.675),(34.975,15.675),(34.975,15.505),(34.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.165),(34.805,15.335),(34.975,15.335),(34.975,15.165),(34.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.345),(45.425,7.515),(45.595,7.515),(45.595,7.345),(45.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.005),(45.425,7.175),(45.595,7.175),(45.595,7.005),(45.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.685),(45.425,7.855),(45.595,7.855),(45.595,7.685),(45.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,2.925),(20.405,3.095),(20.575,3.095),(20.575,2.925),(20.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.225),(73.715,18.395),(73.885,18.395),(73.885,18.225),(73.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.565),(73.715,18.735),(73.885,18.735),(73.885,18.565),(73.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.225),(73.205,18.395),(73.375,18.395),(73.375,18.225),(73.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.565),(73.205,18.735),(73.375,18.735),(73.375,18.565),(73.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.605),(82.805,3.775),(82.975,3.775),(82.975,3.605),(82.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.265),(82.805,3.435),(82.975,3.435),(82.975,3.265),(82.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.885),(58.805,18.055),(58.975,18.055),(58.975,17.885),(58.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.865),(44.405,17.035),(44.575,17.035),(44.575,16.865),(44.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.245),(79.025,19.415),(79.195,19.415),(79.195,19.245),(79.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.445),(44.405,12.615),(44.575,12.615),(44.575,12.445),(44.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.785),(44.405,12.955),(44.575,12.955),(44.575,12.785),(44.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.245),(54.515,19.415),(54.685,19.415),(54.685,19.245),(54.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.245),(54.005,19.415),(54.175,19.415),(54.175,19.245),(54.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.105),(44.405,12.275),(44.575,12.275),(44.575,12.105),(44.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.325),(55.025,6.495),(55.195,6.495),(55.195,6.325),(55.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.665),(55.025,6.835),(55.195,6.835),(55.195,6.665),(55.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.845),(82.805,16.015),(82.975,16.015),(82.975,15.845),(82.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.885),(40.115,18.055),(40.285,18.055),(40.285,17.885),(40.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.885),(40.625,18.055),(40.795,18.055),(40.795,17.885),(40.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.965),(44.915,5.135),(45.085,5.135),(45.085,4.965),(44.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.285),(74.225,4.455),(74.395,4.455),(74.395,4.285),(74.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.625),(74.225,4.795),(74.395,4.795),(74.395,4.625),(74.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.005),(68.405,7.175),(68.575,7.175),(68.575,7.005),(68.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.345),(68.405,7.515),(68.575,7.515),(68.575,7.345),(68.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.685),(68.405,7.855),(68.575,7.855),(68.575,7.685),(68.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.865),(54.005,17.035),(54.175,17.035),(54.175,16.865),(54.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.865),(54.515,17.035),(54.685,17.035),(54.685,16.865),(54.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.325),(69.425,6.495),(69.595,6.495),(69.595,6.325),(69.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.665),(69.425,6.835),(69.595,6.835),(69.595,6.665),(69.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.465),(69.425,13.635),(69.595,13.635),(69.595,13.465),(69.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.805),(69.425,13.975),(69.595,13.975),(69.595,13.805),(69.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.685),(20.405,7.855),(20.575,7.855),(20.575,7.685),(20.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.125),(69.425,13.295),(69.595,13.295),(69.595,13.125),(69.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.885),(78.515,18.055),(78.685,18.055),(78.685,17.885),(78.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.325),(21.425,6.495),(21.595,6.495),(21.595,6.325),(21.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.885),(78.005,18.055),(78.175,18.055),(78.175,17.885),(78.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.665),(21.425,6.835),(21.595,6.835),(21.595,6.665),(21.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.045),(74.225,9.215),(74.395,9.215),(74.395,9.045),(74.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.985),(35.315,6.155),(35.485,6.155),(35.485,5.985),(35.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.985),(35.825,6.155),(35.995,6.155),(35.995,5.985),(35.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.465),(21.425,13.635),(21.595,13.635),(21.595,13.465),(21.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.805),(21.425,13.975),(21.595,13.975),(21.595,13.805),(21.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.125),(21.425,13.295),(21.595,13.295),(21.595,13.125),(21.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.865),(31.025,17.035),(31.195,17.035),(31.195,16.865),(31.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.405),(55.025,10.575),(55.195,10.575),(55.195,10.405),(55.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.745),(55.025,10.915),(55.195,10.915),(55.195,10.745),(55.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.065),(55.025,10.235),(55.195,10.235),(55.195,10.065),(55.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.385),(40.115,9.555),(40.285,9.555),(40.285,9.385),(40.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.725),(40.115,9.895),(40.285,9.895),(40.285,9.725),(40.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.385),(40.625,9.555),(40.795,9.555),(40.795,9.385),(40.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.725),(40.625,9.895),(40.795,9.895),(40.795,9.725),(40.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.845),(34.805,16.015),(34.975,16.015),(34.975,15.845),(34.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.245),(59.825,19.415),(59.995,19.415),(59.995,19.245),(59.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.245),(59.315,19.415),(59.485,19.415),(59.485,19.245),(59.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.005),(44.405,7.175),(44.575,7.175),(44.575,7.005),(44.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.345),(44.405,7.515),(44.575,7.515),(44.575,7.345),(44.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.525),(40.625,16.695),(40.795,16.695),(40.795,16.525),(40.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.185),(40.115,16.355),(40.285,16.355),(40.285,16.185),(40.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.185),(40.625,16.355),(40.795,16.355),(40.795,16.185),(40.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.885),(25.715,18.055),(25.885,18.055),(25.885,17.885),(25.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.885),(25.205,18.055),(25.375,18.055),(25.375,17.885),(25.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.885),(7.025,18.055),(7.195,18.055),(7.195,17.885),(7.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.025),(55.025,8.195),(55.195,8.195),(55.195,8.025),(55.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.365),(55.025,8.535),(55.195,8.535),(55.195,8.365),(55.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.705),(55.025,8.875),(55.195,8.875),(55.195,8.705),(55.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.525),(40.115,16.695),(40.285,16.695),(40.285,16.525),(40.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.745),(7.025,10.915),(7.195,10.915),(7.195,10.745),(7.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.405),(7.025,10.575),(7.195,10.575),(7.195,10.405),(7.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.065),(7.025,10.235),(7.195,10.235),(7.195,10.065),(7.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.865),(50.225,17.035),(50.395,17.035),(50.395,16.865),(50.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.885),(63.605,18.055),(63.775,18.055),(63.775,17.885),(63.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.985),(59.825,6.155),(59.995,6.155),(59.995,5.985),(59.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.985),(59.315,6.155),(59.485,6.155),(59.485,5.985),(59.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.025),(7.025,8.195),(7.195,8.195),(7.195,8.025),(7.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.365),(7.025,8.535),(7.195,8.535),(7.195,8.365),(7.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.185),(20.405,16.355),(20.575,16.355),(20.575,16.185),(20.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.525),(20.405,16.695),(20.575,16.695),(20.575,16.525),(20.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.705),(7.025,8.875),(7.195,8.875),(7.195,8.705),(7.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.205),(68.405,17.375),(68.575,17.375),(68.575,17.205),(68.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.545),(68.405,17.715),(68.575,17.715),(68.575,17.545),(68.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.865),(11.825,17.035),(11.995,17.035),(11.995,16.865),(11.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.865),(11.315,17.035),(11.485,17.035),(11.485,16.865),(11.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.025),(34.805,8.195),(34.975,8.195),(34.975,8.025),(34.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.705),(34.805,8.875),(34.975,8.875),(34.975,8.705),(34.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.365),(34.805,8.535),(34.975,8.535),(34.975,8.365),(34.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.105),(63.605,12.275),(63.775,12.275),(63.775,12.105),(63.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.445),(63.605,12.615),(63.775,12.615),(63.775,12.445),(63.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.785),(63.605,12.955),(63.775,12.955),(63.775,12.785),(63.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.945),(82.805,4.115),(82.975,4.115),(82.975,3.945),(82.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.085),(83.315,11.255),(83.485,11.255),(83.485,11.085),(83.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.425),(83.315,11.595),(83.485,11.595),(83.485,11.425),(83.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.885),(11.315,18.055),(11.485,18.055),(11.485,17.885),(11.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.885),(11.825,18.055),(11.995,18.055),(11.995,17.885),(11.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.765),(83.315,11.935),(83.485,11.935),(83.485,11.765),(83.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.065),(34.805,10.235),(34.975,10.235),(34.975,10.065),(34.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.405),(34.805,10.575),(34.975,10.575),(34.975,10.405),(34.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.425),(44.405,11.595),(44.575,11.595),(44.575,11.425),(44.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.905),(68.915,19.075),(69.085,19.075),(69.085,18.905),(68.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.765),(44.405,11.935),(44.575,11.935),(44.575,11.765),(44.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.085),(44.405,11.255),(44.575,11.255),(44.575,11.085),(44.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.745),(34.805,10.915),(34.975,10.915),(34.975,10.745),(34.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.705),(68.405,8.875),(68.575,8.875),(68.575,8.705),(68.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.025),(68.405,8.195),(68.575,8.195),(68.575,8.025),(68.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.365),(68.405,8.535),(68.575,8.535),(68.575,8.365),(68.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.765),(35.315,11.935),(35.485,11.935),(35.485,11.765),(35.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.765),(35.825,11.935),(35.995,11.935),(35.995,11.765),(35.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.085),(35.315,11.255),(35.485,11.255),(35.485,11.085),(35.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.085),(35.825,11.255),(35.995,11.255),(35.995,11.085),(35.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.425),(35.315,11.595),(35.485,11.595),(35.485,11.425),(35.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.345),(54.515,7.515),(54.685,7.515),(54.685,7.345),(54.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.005),(54.515,7.175),(54.685,7.175),(54.685,7.005),(54.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.345),(54.005,7.515),(54.175,7.515),(54.175,7.345),(54.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.005),(54.005,7.175),(54.175,7.175),(54.175,7.005),(54.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.165),(73.205,15.335),(73.375,15.335),(73.375,15.165),(73.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.165),(73.715,15.335),(73.885,15.335),(73.885,15.165),(73.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.505),(73.205,15.675),(73.375,15.675),(73.375,15.505),(73.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.945),(68.405,4.115),(68.575,4.115),(68.575,3.945),(68.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.505),(73.715,15.675),(73.885,15.675),(73.885,15.505),(73.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.045),(35.315,9.215),(35.485,9.215),(35.485,9.045),(35.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.045),(35.825,9.215),(35.995,9.215),(35.995,9.045),(35.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.025),(20.405,8.195),(20.575,8.195),(20.575,8.025),(20.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.365),(20.405,8.535),(20.575,8.535),(20.575,8.365),(20.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.705),(20.405,8.875),(20.575,8.875),(20.575,8.705),(20.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.485),(25.715,14.655),(25.885,14.655),(25.885,14.485),(25.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.825),(25.205,14.995),(25.375,14.995),(25.375,14.825),(25.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.825),(25.715,14.995),(25.885,14.995),(25.885,14.825),(25.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.485),(25.205,14.655),(25.375,14.655),(25.375,14.485),(25.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.145),(25.205,14.315),(25.375,14.315),(25.375,14.145),(25.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.145),(25.715,14.315),(25.885,14.315),(25.885,14.145),(25.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.085),(15.605,11.255),(15.775,11.255),(15.775,11.085),(15.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.425),(15.605,11.595),(15.775,11.595),(15.775,11.425),(15.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.765),(15.605,11.935),(15.775,11.935),(15.775,11.765),(15.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.025),(82.805,8.195),(82.975,8.195),(82.975,8.025),(82.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.365),(82.805,8.535),(82.975,8.535),(82.975,8.365),(82.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.705),(82.805,8.875),(82.975,8.875),(82.975,8.705),(82.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.945),(44.405,4.115),(44.575,4.115),(44.575,3.945),(44.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.745),(68.915,10.915),(69.085,10.915),(69.085,10.745),(68.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.405),(68.915,10.575),(69.085,10.575),(69.085,10.405),(68.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.065),(68.915,10.235),(69.085,10.235),(69.085,10.065),(68.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.085),(21.425,11.255),(21.595,11.255),(21.595,11.085),(21.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.765),(21.425,11.935),(21.595,11.935),(21.595,11.765),(21.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.425),(21.425,11.595),(21.595,11.595),(21.595,11.425),(21.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.765),(68.915,11.935),(69.085,11.935),(69.085,11.765),(68.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.085),(68.915,11.255),(69.085,11.255),(69.085,11.085),(68.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.425),(68.915,11.595),(69.085,11.595),(69.085,11.425),(68.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.345),(30.515,7.515),(30.685,7.515),(30.685,7.345),(30.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.345),(30.005,7.515),(30.175,7.515),(30.175,7.345),(30.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.005),(30.005,7.175),(30.175,7.175),(30.175,7.005),(30.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.005),(30.515,7.175),(30.685,7.175),(30.685,7.005),(30.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.905),(55.025,19.075),(55.195,19.075),(55.195,18.905),(55.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,2.925),(68.405,3.095),(68.575,3.095),(68.575,2.925),(68.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.425),(63.605,11.595),(63.775,11.595),(63.775,11.425),(63.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.765),(63.605,11.935),(63.775,11.935),(63.775,11.765),(63.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.085),(63.605,11.255),(63.775,11.255),(63.775,11.085),(63.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.765),(20.915,11.935),(21.085,11.935),(21.085,11.765),(20.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.425),(20.915,11.595),(21.085,11.595),(21.085,11.425),(20.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.085),(20.915,11.255),(21.085,11.255),(21.085,11.085),(20.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.725),(50.225,9.895),(50.395,9.895),(50.395,9.725),(50.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.385),(50.225,9.555),(50.395,9.555),(50.395,9.385),(50.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.685),(64.115,7.855),(64.285,7.855),(64.285,7.685),(64.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.685),(64.625,7.855),(64.795,7.855),(64.795,7.685),(64.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.185),(10.805,16.355),(10.975,16.355),(10.975,16.185),(10.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.525),(10.805,16.695),(10.975,16.695),(10.975,16.525),(10.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.865),(39.605,17.035),(39.775,17.035),(39.775,16.865),(39.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.685),(40.115,7.855),(40.285,7.855),(40.285,7.685),(40.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.685),(40.625,7.855),(40.795,7.855),(40.795,7.685),(40.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.345),(40.625,7.515),(40.795,7.515),(40.795,7.345),(40.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.345),(40.115,7.515),(40.285,7.515),(40.285,7.345),(40.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.465),(54.515,13.635),(54.685,13.635),(54.685,13.465),(54.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.805),(54.515,13.975),(54.685,13.975),(54.685,13.805),(54.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.125),(54.005,13.295),(54.175,13.295),(54.175,13.125),(54.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.005),(40.115,7.175),(40.285,7.175),(40.285,7.005),(40.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.005),(40.625,7.175),(40.795,7.175),(40.795,7.005),(40.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.465),(54.005,13.635),(54.175,13.635),(54.175,13.465),(54.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.805),(54.005,13.975),(54.175,13.975),(54.175,13.805),(54.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.125),(54.515,13.295),(54.685,13.295),(54.685,13.125),(54.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.165),(21.425,15.335),(21.595,15.335),(21.595,15.165),(21.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.505),(21.425,15.675),(21.595,15.675),(21.595,15.505),(21.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.245),(40.115,19.415),(40.285,19.415),(40.285,19.245),(40.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.245),(40.625,19.415),(40.795,19.415),(40.795,19.245),(40.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.185),(25.205,16.355),(25.375,16.355),(25.375,16.185),(25.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.525),(7.025,16.695),(7.195,16.695),(7.195,16.525),(7.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.125),(6.515,13.295),(6.685,13.295),(6.685,13.125),(6.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.525),(25.715,16.695),(25.885,16.695),(25.885,16.525),(25.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.525),(25.205,16.695),(25.375,16.695),(25.375,16.525),(25.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.465),(6.515,13.635),(6.685,13.635),(6.685,13.465),(6.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.805),(6.515,13.975),(6.685,13.975),(6.685,13.805),(6.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.185),(25.715,16.355),(25.885,16.355),(25.885,16.185),(25.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.185),(7.025,16.355),(7.195,16.355),(7.195,16.185),(7.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.325),(79.025,6.495),(79.195,6.495),(79.195,6.325),(79.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.665),(79.025,6.835),(79.195,6.835),(79.195,6.665),(79.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.005),(11.825,7.175),(11.995,7.175),(11.995,7.005),(11.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.145),(39.605,14.315),(39.775,14.315),(39.775,14.145),(39.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.485),(39.605,14.655),(39.775,14.655),(39.775,14.485),(39.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.825),(39.605,14.995),(39.775,14.995),(39.775,14.825),(39.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.005),(10.805,7.175),(10.975,7.175),(10.975,7.005),(10.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.345),(10.805,7.515),(10.975,7.515),(10.975,7.345),(10.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.325),(44.915,6.495),(45.085,6.495),(45.085,6.325),(44.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.665),(44.915,6.835),(45.085,6.835),(45.085,6.665),(44.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.525),(78.005,16.695),(78.175,16.695),(78.175,16.525),(78.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.185),(78.515,16.355),(78.685,16.355),(78.685,16.185),(78.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.565),(15.605,18.735),(15.775,18.735),(15.775,18.565),(15.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.185),(78.005,16.355),(78.175,16.355),(78.175,16.185),(78.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.525),(78.515,16.695),(78.685,16.695),(78.685,16.525),(78.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.225),(15.605,18.395),(15.775,18.395),(15.775,18.225),(15.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.905),(25.205,19.075),(25.375,19.075),(25.375,18.905),(25.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.905),(25.715,19.075),(25.885,19.075),(25.885,18.905),(25.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.845),(49.715,16.015),(49.885,16.015),(49.885,15.845),(49.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.845),(49.205,16.015),(49.375,16.015),(49.375,15.845),(49.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.885),(10.805,18.055),(10.975,18.055),(10.975,17.885),(10.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.665),(44.405,6.835),(44.575,6.835),(44.575,6.665),(44.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.325),(44.405,6.495),(44.575,6.495),(44.575,6.325),(44.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.685),(16.625,7.855),(16.795,7.855),(16.795,7.685),(16.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.685),(16.115,7.855),(16.285,7.855),(16.285,7.685),(16.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.245),(50.225,19.415),(50.395,19.415),(50.395,19.245),(50.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.345),(15.605,7.515),(15.775,7.515),(15.775,7.345),(15.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.005),(15.605,7.175),(15.775,7.175),(15.775,7.005),(15.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.065),(44.915,10.235),(45.085,10.235),(45.085,10.065),(44.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.745),(44.915,10.915),(45.085,10.915),(45.085,10.745),(44.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.405),(44.915,10.575),(45.085,10.575),(45.085,10.405),(44.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.885),(68.915,18.055),(69.085,18.055),(69.085,17.885),(68.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.025),(40.625,8.195),(40.795,8.195),(40.795,8.025),(40.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.345),(82.805,7.515),(82.975,7.515),(82.975,7.345),(82.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.365),(40.625,8.535),(40.795,8.535),(40.795,8.365),(40.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.705),(40.115,8.875),(40.285,8.875),(40.285,8.705),(40.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.965),(21.425,5.135),(21.595,5.135),(21.595,4.965),(21.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.705),(40.625,8.875),(40.795,8.875),(40.795,8.705),(40.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.365),(40.115,8.535),(40.285,8.535),(40.285,8.365),(40.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.005),(82.805,7.175),(82.975,7.175),(82.975,7.005),(82.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.845),(74.225,16.015),(74.395,16.015),(74.395,15.845),(74.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.985),(83.315,6.155),(83.485,6.155),(83.485,5.985),(83.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.845),(26.225,16.015),(26.395,16.015),(26.395,15.845),(26.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.965),(44.405,5.135),(44.575,5.135),(44.575,4.965),(44.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.405),(49.715,10.575),(49.885,10.575),(49.885,10.405),(49.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.405),(49.205,10.575),(49.375,10.575),(49.375,10.405),(49.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.785),(21.425,12.955),(21.595,12.955),(21.595,12.785),(21.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.445),(21.425,12.615),(21.595,12.615),(21.595,12.445),(21.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.065),(49.205,10.235),(49.375,10.235),(49.375,10.065),(49.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.065),(49.715,10.235),(49.885,10.235),(49.885,10.065),(49.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.745),(49.205,10.915),(49.375,10.915),(49.375,10.745),(49.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.745),(49.715,10.915),(49.885,10.915),(49.885,10.745),(49.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.105),(21.425,12.275),(21.595,12.275),(21.595,12.105),(21.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.865),(6.515,17.035),(6.685,17.035),(6.685,16.865),(6.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.325),(26.225,6.495),(26.395,6.495),(26.395,6.325),(26.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.665),(26.225,6.835),(26.395,6.835),(26.395,6.665),(26.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.005),(63.605,7.175),(63.775,7.175),(63.775,7.005),(63.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.345),(63.605,7.515),(63.775,7.515),(63.775,7.345),(63.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.325),(68.915,6.495),(69.085,6.495),(69.085,6.325),(68.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.665),(68.915,6.835),(69.085,6.835),(69.085,6.665),(68.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.925),(44.915,3.095),(45.085,3.095),(45.085,2.925),(44.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.005),(68.915,7.175),(69.085,7.175),(69.085,7.005),(68.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.685),(68.915,7.855),(69.085,7.855),(69.085,7.685),(68.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.345),(68.915,7.515),(69.085,7.515),(69.085,7.345),(68.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.045),(16.115,9.215),(16.285,9.215),(16.285,9.045),(16.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.045),(16.625,9.215),(16.795,9.215),(16.795,9.045),(16.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.425),(59.315,11.595),(59.485,11.595),(59.485,11.425),(59.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.425),(59.825,11.595),(59.995,11.595),(59.995,11.425),(59.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.085),(59.825,11.255),(59.995,11.255),(59.995,11.085),(59.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.905),(59.825,19.075),(59.995,19.075),(59.995,18.905),(59.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.905),(59.315,19.075),(59.485,19.075),(59.485,18.905),(59.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.085),(59.315,11.255),(59.485,11.255),(59.485,11.085),(59.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.765),(59.825,11.935),(59.995,11.935),(59.995,11.765),(59.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.765),(59.315,11.935),(59.485,11.935),(59.485,11.765),(59.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.565),(58.805,18.735),(58.975,18.735),(58.975,18.565),(58.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.225),(58.805,18.395),(58.975,18.395),(58.975,18.225),(58.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.345),(20.915,7.515),(21.085,7.515),(21.085,7.345),(20.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.685),(20.915,7.855),(21.085,7.855),(21.085,7.685),(20.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.005),(20.915,7.175),(21.085,7.175),(21.085,7.005),(20.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.125),(35.825,13.295),(35.995,13.295),(35.995,13.125),(35.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.805),(35.825,13.975),(35.995,13.975),(35.995,13.805),(35.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.465),(35.825,13.635),(35.995,13.635),(35.995,13.465),(35.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.805),(35.315,13.975),(35.485,13.975),(35.485,13.805),(35.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.465),(35.315,13.635),(35.485,13.635),(35.485,13.465),(35.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.985),(20.405,6.155),(20.575,6.155),(20.575,5.985),(20.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.725),(20.915,9.895),(21.085,9.895),(21.085,9.725),(20.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.385),(20.915,9.555),(21.085,9.555),(21.085,9.385),(20.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.045),(59.825,9.215),(59.995,9.215),(59.995,9.045),(59.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.045),(59.315,9.215),(59.485,9.215),(59.485,9.045),(59.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.765),(11.825,11.935),(11.995,11.935),(11.995,11.765),(11.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.085),(11.825,11.255),(11.995,11.255),(11.995,11.085),(11.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.765),(11.315,11.935),(11.485,11.935),(11.485,11.765),(11.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.085),(11.315,11.255),(11.485,11.255),(11.485,11.085),(11.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.425),(11.315,11.595),(11.485,11.595),(11.485,11.425),(11.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.425),(11.825,11.595),(11.995,11.595),(11.995,11.425),(11.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.385),(10.805,9.555),(10.975,9.555),(10.975,9.385),(10.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.725),(10.805,9.895),(10.975,9.895),(10.975,9.725),(10.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.245),(20.405,19.415),(20.575,19.415),(20.575,19.245),(20.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,2.925),(15.605,3.095),(15.775,3.095),(15.775,2.925),(15.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.345),(78.005,7.515),(78.175,7.515),(78.175,7.345),(78.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.005),(34.805,7.175),(34.975,7.175),(34.975,7.005),(34.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.345),(78.515,7.515),(78.685,7.515),(78.685,7.345),(78.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.345),(34.805,7.515),(34.975,7.515),(34.975,7.345),(34.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.325),(68.405,6.495),(68.575,6.495),(68.575,6.325),(68.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.045),(83.315,9.215),(83.485,9.215),(83.485,9.045),(83.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.665),(68.405,6.835),(68.575,6.835),(68.575,6.665),(68.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.045),(11.315,9.215),(11.485,9.215),(11.485,9.045),(11.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.045),(11.825,9.215),(11.995,9.215),(11.995,9.045),(11.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.005),(78.005,7.175),(78.175,7.175),(78.175,7.005),(78.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.205),(58.805,17.375),(58.975,17.375),(58.975,17.205),(58.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.545),(58.805,17.715),(58.975,17.715),(58.975,17.545),(58.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.145),(73.205,14.315),(73.375,14.315),(73.375,14.145),(73.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.145),(73.715,14.315),(73.885,14.315),(73.885,14.145),(73.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.485),(73.205,14.655),(73.375,14.655),(73.375,14.485),(73.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.825),(73.205,14.995),(73.375,14.995),(73.375,14.825),(73.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.825),(73.715,14.995),(73.885,14.995),(73.885,14.825),(73.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.485),(73.715,14.655),(73.885,14.655),(73.885,14.485),(73.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.985),(20.915,6.155),(21.085,6.155),(21.085,5.985),(20.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.925),(58.805,3.095),(58.975,3.095),(58.975,2.925),(58.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.245),(6.515,19.415),(6.685,19.415),(6.685,19.245),(6.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.925),(34.805,3.095),(34.975,3.095),(34.975,2.925),(34.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.545),(40.625,17.715),(40.795,17.715),(40.795,17.545),(40.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.545),(40.115,17.715),(40.285,17.715),(40.285,17.545),(40.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.205),(40.115,17.375),(40.285,17.375),(40.285,17.205),(40.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.205),(40.625,17.375),(40.795,17.375),(40.795,17.205),(40.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,2.925),(10.805,3.095),(10.975,3.095),(10.975,2.925),(10.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.565),(20.915,18.735),(21.085,18.735),(21.085,18.565),(20.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.225),(20.915,18.395),(21.085,18.395),(21.085,18.225),(20.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.745),(82.805,10.915),(82.975,10.915),(82.975,10.745),(82.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.405),(82.805,10.575),(82.975,10.575),(82.975,10.405),(82.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.065),(82.805,10.235),(82.975,10.235),(82.975,10.065),(82.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.665),(40.115,6.835),(40.285,6.835),(40.285,6.665),(40.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.325),(40.625,6.495),(40.795,6.495),(40.795,6.325),(40.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.325),(40.115,6.495),(40.285,6.495),(40.285,6.325),(40.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.665),(40.625,6.835),(40.795,6.835),(40.795,6.665),(40.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.465),(45.425,13.635),(45.595,13.635),(45.595,13.465),(45.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.805),(45.425,13.975),(45.595,13.975),(45.595,13.805),(45.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.745),(15.605,10.915),(15.775,10.915),(15.775,10.745),(15.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.125),(45.425,13.295),(45.595,13.295),(45.595,13.125),(45.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.065),(15.605,10.235),(15.775,10.235),(15.775,10.065),(15.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.405),(15.605,10.575),(15.775,10.575),(15.775,10.405),(15.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.305),(55.025,5.475),(55.195,5.475),(55.195,5.305),(55.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.645),(55.025,5.815),(55.195,5.815),(55.195,5.645),(55.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.085),(69.425,11.255),(69.595,11.255),(69.595,11.085),(69.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.425),(69.425,11.595),(69.595,11.595),(69.595,11.425),(69.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.765),(69.425,11.935),(69.595,11.935),(69.595,11.765),(69.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.965),(15.605,5.135),(15.775,5.135),(15.775,4.965),(15.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.705),(15.605,8.875),(15.775,8.875),(15.775,8.705),(15.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.085),(44.915,11.255),(45.085,11.255),(45.085,11.085),(44.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.765),(44.915,11.935),(45.085,11.935),(45.085,11.765),(44.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.365),(15.605,8.535),(15.775,8.535),(15.775,8.365),(15.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.425),(44.915,11.595),(45.085,11.595),(45.085,11.425),(44.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.025),(15.605,8.195),(15.775,8.195),(15.775,8.025),(15.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.005),(83.315,7.175),(83.485,7.175),(83.485,7.005),(83.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.345),(83.315,7.515),(83.485,7.515),(83.485,7.345),(83.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.545),(78.515,17.715),(78.685,17.715),(78.685,17.545),(78.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.205),(78.005,17.375),(78.175,17.375),(78.175,17.205),(78.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.505),(69.425,15.675),(69.595,15.675),(69.595,15.505),(69.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.165),(69.425,15.335),(69.595,15.335),(69.595,15.165),(69.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.245),(31.025,19.415),(31.195,19.415),(31.195,19.245),(31.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.545),(78.005,17.715),(78.175,17.715),(78.175,17.545),(78.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.485),(69.425,14.655),(69.595,14.655),(69.595,14.485),(69.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.825),(69.425,14.995),(69.595,14.995),(69.595,14.825),(69.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.805),(34.805,13.975),(34.975,13.975),(34.975,13.805),(34.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.125),(34.805,13.295),(34.975,13.295),(34.975,13.125),(34.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.145),(69.425,14.315),(69.595,14.315),(69.595,14.145),(69.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.465),(34.805,13.635),(34.975,13.635),(34.975,13.465),(34.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.685),(59.315,7.855),(59.485,7.855),(59.485,7.685),(59.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.885),(73.205,18.055),(73.375,18.055),(73.375,17.885),(73.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.885),(73.715,18.055),(73.885,18.055),(73.885,17.885),(73.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.685),(59.825,7.855),(59.995,7.855),(59.995,7.685),(59.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.145),(21.425,14.315),(21.595,14.315),(21.595,14.145),(21.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.485),(21.425,14.655),(21.595,14.655),(21.595,14.485),(21.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.825),(21.425,14.995),(21.595,14.995),(21.595,14.825),(21.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.985),(25.205,6.155),(25.375,6.155),(25.375,5.985),(25.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.985),(25.715,6.155),(25.885,6.155),(25.885,5.985),(25.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.725),(58.805,9.895),(58.975,9.895),(58.975,9.725),(58.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.385),(58.805,9.555),(58.975,9.555),(58.975,9.385),(58.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.245),(39.605,19.415),(39.775,19.415),(39.775,19.245),(39.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.525),(30.515,16.695),(30.685,16.695),(30.685,16.525),(30.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.185),(30.005,16.355),(30.175,16.355),(30.175,16.185),(30.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.525),(30.005,16.695),(30.175,16.695),(30.175,16.525),(30.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.185),(30.515,16.355),(30.685,16.355),(30.685,16.185),(30.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.345),(11.315,7.515),(11.485,7.515),(11.485,7.345),(11.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.345),(11.825,7.515),(11.995,7.515),(11.995,7.345),(11.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.685),(11.315,7.855),(11.485,7.855),(11.485,7.685),(11.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.925),(39.605,3.095),(39.775,3.095),(39.775,2.925),(39.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.685),(11.825,7.855),(11.995,7.855),(11.995,7.685),(11.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.005),(11.315,7.175),(11.485,7.175),(11.485,7.005),(11.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.525),(68.405,16.695),(68.575,16.695),(68.575,16.525),(68.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.185),(68.405,16.355),(68.575,16.355),(68.575,16.185),(68.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.025),(44.405,8.195),(44.575,8.195),(44.575,8.025),(44.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.705),(44.405,8.875),(44.575,8.875),(44.575,8.705),(44.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.365),(44.405,8.535),(44.575,8.535),(44.575,8.365),(44.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.905),(64.625,19.075),(64.795,19.075),(64.795,18.905),(64.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.905),(64.115,19.075),(64.285,19.075),(64.285,18.905),(64.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.245),(11.315,19.415),(11.485,19.415),(11.485,19.245),(11.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.245),(11.825,19.415),(11.995,19.415),(11.995,19.245),(11.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.445),(40.625,12.615),(40.795,12.615),(40.795,12.445),(40.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.785),(40.115,12.955),(40.285,12.955),(40.285,12.785),(40.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.105),(40.115,12.275),(40.285,12.275),(40.285,12.105),(40.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.445),(40.115,12.615),(40.285,12.615),(40.285,12.445),(40.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.105),(40.625,12.275),(40.795,12.275),(40.795,12.105),(40.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.785),(40.625,12.955),(40.795,12.955),(40.795,12.785),(40.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.865),(45.425,17.035),(45.595,17.035),(45.595,16.865),(45.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.685),(25.205,7.855),(25.375,7.855),(25.375,7.685),(25.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.685),(25.715,7.855),(25.885,7.855),(25.885,7.685),(25.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.125),(49.715,13.295),(49.885,13.295),(49.885,13.125),(49.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.125),(49.205,13.295),(49.375,13.295),(49.375,13.125),(49.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.245),(49.205,19.415),(49.375,19.415),(49.375,19.245),(49.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.245),(49.715,19.415),(49.885,19.415),(49.885,19.245),(49.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.805),(49.715,13.975),(49.885,13.975),(49.885,13.805),(49.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.465),(49.715,13.635),(49.885,13.635),(49.885,13.465),(49.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.465),(49.205,13.635),(49.375,13.635),(49.375,13.465),(49.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.805),(49.205,13.975),(49.375,13.975),(49.375,13.805),(49.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.985),(40.625,6.155),(40.795,6.155),(40.795,5.985),(40.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.985),(40.115,6.155),(40.285,6.155),(40.285,5.985),(40.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.045),(64.625,9.215),(64.795,9.215),(64.795,9.045),(64.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.045),(64.115,9.215),(64.285,9.215),(64.285,9.045),(64.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.705),(35.825,8.875),(35.995,8.875),(35.995,8.705),(35.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.705),(35.315,8.875),(35.485,8.875),(35.485,8.705),(35.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.365),(35.825,8.535),(35.995,8.535),(35.995,8.365),(35.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.365),(35.315,8.535),(35.485,8.535),(35.485,8.365),(35.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.025),(35.825,8.195),(35.995,8.195),(35.995,8.025),(35.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.985),(49.205,6.155),(49.375,6.155),(49.375,5.985),(49.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.265),(64.625,3.435),(64.795,3.435),(64.795,3.265),(64.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.605),(64.625,3.775),(64.795,3.775),(64.795,3.605),(64.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.265),(64.115,3.435),(64.285,3.435),(64.285,3.265),(64.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.985),(49.715,6.155),(49.885,6.155),(49.885,5.985),(49.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.605),(64.115,3.775),(64.285,3.775),(64.285,3.605),(64.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.045),(69.425,9.215),(69.595,9.215),(69.595,9.045),(69.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.885),(30.515,18.055),(30.685,18.055),(30.685,17.885),(30.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.965),(69.425,5.135),(69.595,5.135),(69.595,4.965),(69.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.885),(30.005,18.055),(30.175,18.055),(30.175,17.885),(30.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.765),(45.425,11.935),(45.595,11.935),(45.595,11.765),(45.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.425),(45.425,11.595),(45.595,11.595),(45.595,11.425),(45.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.085),(45.425,11.255),(45.595,11.255),(45.595,11.085),(45.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.665),(15.605,6.835),(15.775,6.835),(15.775,6.665),(15.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.325),(15.605,6.495),(15.775,6.495),(15.775,6.325),(15.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.305),(79.025,5.475),(79.195,5.475),(79.195,5.305),(79.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.645),(79.025,5.815),(79.195,5.815),(79.195,5.645),(79.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,2.925),(63.605,3.095),(63.775,3.095),(63.775,2.925),(63.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.285),(79.025,4.455),(79.195,4.455),(79.195,4.285),(79.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.625),(79.025,4.795),(79.195,4.795),(79.195,4.625),(79.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.965),(39.605,5.135),(39.775,5.135),(39.775,4.965),(39.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.445),(45.425,12.615),(45.595,12.615),(45.595,12.445),(45.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.845),(7.025,16.015),(7.195,16.015),(7.195,15.845),(7.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.785),(45.425,12.955),(45.595,12.955),(45.595,12.785),(45.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.105),(45.425,12.275),(45.595,12.275),(45.595,12.105),(45.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.045),(21.425,9.215),(21.595,9.215),(21.595,9.045),(21.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.985),(50.225,6.155),(50.395,6.155),(50.395,5.985),(50.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.285),(55.025,4.455),(55.195,4.455),(55.195,4.285),(55.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.625),(55.025,4.795),(55.195,4.795),(55.195,4.625),(55.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.225),(68.405,18.395),(68.575,18.395),(68.575,18.225),(68.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.565),(68.405,18.735),(68.575,18.735),(68.575,18.565),(68.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.105),(69.425,12.275),(69.595,12.275),(69.595,12.105),(69.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.785),(69.425,12.955),(69.595,12.955),(69.595,12.785),(69.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.445),(69.425,12.615),(69.595,12.615),(69.595,12.445),(69.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.565),(78.515,18.735),(78.685,18.735),(78.685,18.565),(78.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.225),(78.515,18.395),(78.685,18.395),(78.685,18.225),(78.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.225),(78.005,18.395),(78.175,18.395),(78.175,18.225),(78.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.565),(78.005,18.735),(78.175,18.735),(78.175,18.565),(78.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.245),(44.915,19.415),(45.085,19.415),(45.085,19.245),(44.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.625),(7.025,4.795),(7.195,4.795),(7.195,4.625),(7.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.285),(7.025,4.455),(7.195,4.455),(7.195,4.285),(7.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.685),(49.715,7.855),(49.885,7.855),(49.885,7.685),(49.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.685),(49.205,7.855),(49.375,7.855),(49.375,7.685),(49.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.005),(49.205,7.175),(49.375,7.175),(49.375,7.005),(49.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.005),(49.715,7.175),(49.885,7.175),(49.885,7.005),(49.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.345),(49.205,7.515),(49.375,7.515),(49.375,7.345),(49.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.345),(49.715,7.515),(49.885,7.515),(49.885,7.345),(49.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.165),(83.315,15.335),(83.485,15.335),(83.485,15.165),(83.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.465),(16.625,13.635),(16.795,13.635),(16.795,13.465),(16.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.805),(16.625,13.975),(16.795,13.975),(16.795,13.805),(16.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.525),(83.315,16.695),(83.485,16.695),(83.485,16.525),(83.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.185),(83.315,16.355),(83.485,16.355),(83.485,16.185),(83.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.125),(16.625,13.295),(16.795,13.295),(16.795,13.125),(16.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.805),(16.115,13.975),(16.285,13.975),(16.285,13.805),(16.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.505),(45.425,15.675),(45.595,15.675),(45.595,15.505),(45.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.165),(45.425,15.335),(45.595,15.335),(45.595,15.165),(45.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.125),(16.115,13.295),(16.285,13.295),(16.285,13.125),(16.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.465),(16.115,13.635),(16.285,13.635),(16.285,13.465),(16.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.205),(15.605,17.375),(15.775,17.375),(15.775,17.205),(15.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.545),(15.605,17.715),(15.775,17.715),(15.775,17.545),(15.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.125),(59.315,13.295),(59.485,13.295),(59.485,13.125),(59.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.125),(59.825,13.295),(59.995,13.295),(59.995,13.125),(59.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.465),(59.825,13.635),(59.995,13.635),(59.995,13.465),(59.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.805),(59.825,13.975),(59.995,13.975),(59.995,13.805),(59.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.465),(59.315,13.635),(59.485,13.635),(59.485,13.465),(59.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.385),(44.915,9.555),(45.085,9.555),(45.085,9.385),(44.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.725),(44.915,9.895),(45.085,9.895),(45.085,9.725),(44.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.985),(16.625,6.155),(16.795,6.155),(16.795,5.985),(16.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.985),(16.115,6.155),(16.285,6.155),(16.285,5.985),(16.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.805),(59.315,13.975),(59.485,13.975),(59.485,13.805),(59.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.805),(83.315,13.975),(83.485,13.975),(83.485,13.805),(83.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.125),(11.315,13.295),(11.485,13.295),(11.485,13.125),(11.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.125),(11.825,13.295),(11.995,13.295),(11.995,13.125),(11.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.125),(83.315,13.295),(83.485,13.295),(83.485,13.125),(83.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.805),(11.315,13.975),(11.485,13.975),(11.485,13.805),(11.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.385),(68.915,9.555),(69.085,9.555),(69.085,9.385),(68.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.065),(63.605,10.235),(63.775,10.235),(63.775,10.065),(63.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.725),(68.915,9.895),(69.085,9.895),(69.085,9.725),(68.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.465),(11.315,13.635),(11.485,13.635),(11.485,13.465),(11.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.405),(63.605,10.575),(63.775,10.575),(63.775,10.405),(63.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.865),(49.715,17.035),(49.885,17.035),(49.885,16.865),(49.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.745),(63.605,10.915),(63.775,10.915),(63.775,10.745),(63.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.865),(49.205,17.035),(49.375,17.035),(49.375,16.865),(49.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.905),(54.005,19.075),(54.175,19.075),(54.175,18.905),(54.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.905),(54.515,19.075),(54.685,19.075),(54.685,18.905),(54.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.985),(74.225,6.155),(74.395,6.155),(74.395,5.985),(74.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.965),(63.605,5.135),(63.775,5.135),(63.775,4.965),(63.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.705),(63.605,8.875),(63.775,8.875),(63.775,8.705),(63.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.025),(63.605,8.195),(63.775,8.195),(63.775,8.025),(63.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.365),(63.605,8.535),(63.775,8.535),(63.775,8.365),(63.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.905),(7.025,19.075),(7.195,19.075),(7.195,18.905),(7.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.625),(31.025,4.795),(31.195,4.795),(31.195,4.625),(31.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.285),(31.025,4.455),(31.195,4.455),(31.195,4.285),(31.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.085),(82.805,11.255),(82.975,11.255),(82.975,11.085),(82.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.425),(82.805,11.595),(82.975,11.595),(82.975,11.425),(82.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.765),(82.805,11.935),(82.975,11.935),(82.975,11.765),(82.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.525),(73.715,16.695),(73.885,16.695),(73.885,16.525),(73.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.185),(73.205,16.355),(73.375,16.355),(73.375,16.185),(73.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.185),(73.715,16.355),(73.885,16.355),(73.885,16.185),(73.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.525),(73.205,16.695),(73.375,16.695),(73.375,16.525),(73.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.205),(59.315,17.375),(59.485,17.375),(59.485,17.205),(59.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.545),(59.315,17.715),(59.485,17.715),(59.485,17.545),(59.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.545),(59.825,17.715),(59.995,17.715),(59.995,17.545),(59.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.205),(59.825,17.375),(59.995,17.375),(59.995,17.205),(59.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.465),(82.805,13.635),(82.975,13.635),(82.975,13.465),(82.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.125),(82.805,13.295),(82.975,13.295),(82.975,13.125),(82.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.805),(82.805,13.975),(82.975,13.975),(82.975,13.805),(82.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.885),(45.425,18.055),(45.595,18.055),(45.595,17.885),(45.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.905),(11.825,19.075),(11.995,19.075),(11.995,18.905),(11.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.905),(11.315,19.075),(11.485,19.075),(11.485,18.905),(11.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.705),(83.315,8.875),(83.485,8.875),(83.485,8.705),(83.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.705),(11.825,8.875),(11.995,8.875),(11.995,8.705),(11.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.025),(11.825,8.195),(11.995,8.195),(11.995,8.025),(11.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.025),(83.315,8.195),(83.485,8.195),(83.485,8.025),(83.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.845),(68.915,16.015),(69.085,16.015),(69.085,15.845),(68.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.025),(11.315,8.195),(11.485,8.195),(11.485,8.025),(11.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.365),(11.825,8.535),(11.995,8.535),(11.995,8.365),(11.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.365),(11.315,8.535),(11.485,8.535),(11.485,8.365),(11.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.705),(11.315,8.875),(11.485,8.875),(11.485,8.705),(11.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.905),(50.225,19.075),(50.395,19.075),(50.395,18.905),(50.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.845),(20.915,16.015),(21.085,16.015),(21.085,15.845),(20.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.405),(40.115,10.575),(40.285,10.575),(40.285,10.405),(40.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.405),(40.625,10.575),(40.795,10.575),(40.795,10.405),(40.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.745),(40.115,10.915),(40.285,10.915),(40.285,10.745),(40.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.745),(40.625,10.915),(40.795,10.915),(40.795,10.745),(40.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.065),(40.115,10.235),(40.285,10.235),(40.285,10.065),(40.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.065),(40.625,10.235),(40.795,10.235),(40.795,10.065),(40.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.845),(55.025,16.015),(55.195,16.015),(55.195,15.845),(55.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.505),(40.115,15.675),(40.285,15.675),(40.285,15.505),(40.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.505),(40.625,15.675),(40.795,15.675),(40.795,15.505),(40.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.165),(40.115,15.335),(40.285,15.335),(40.285,15.165),(40.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.165),(40.625,15.335),(40.795,15.335),(40.795,15.165),(40.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.205),(10.805,17.375),(10.975,17.375),(10.975,17.205),(10.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.545),(10.805,17.715),(10.975,17.715),(10.975,17.545),(10.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.245),(45.425,19.415),(45.595,19.415),(45.595,19.245),(45.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.025),(49.205,8.195),(49.375,8.195),(49.375,8.025),(49.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.705),(49.715,8.875),(49.885,8.875),(49.885,8.705),(49.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.365),(49.205,8.535),(49.375,8.535),(49.375,8.365),(49.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.705),(49.205,8.875),(49.375,8.875),(49.375,8.705),(49.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.365),(49.715,8.535),(49.885,8.535),(49.885,8.365),(49.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.045),(34.805,9.215),(34.975,9.215),(34.975,9.045),(34.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.325),(83.315,6.495),(83.485,6.495),(83.485,6.325),(83.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.665),(83.315,6.835),(83.485,6.835),(83.485,6.665),(83.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.905),(45.425,19.075),(45.595,19.075),(45.595,18.905),(45.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.065),(78.515,10.235),(78.685,10.235),(78.685,10.065),(78.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.405),(78.005,10.575),(78.175,10.575),(78.175,10.405),(78.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.405),(78.515,10.575),(78.685,10.575),(78.685,10.405),(78.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.065),(78.005,10.235),(78.175,10.235),(78.175,10.065),(78.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.765),(34.805,11.935),(34.975,11.935),(34.975,11.765),(34.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.085),(34.805,11.255),(34.975,11.255),(34.975,11.085),(34.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.425),(34.805,11.595),(34.975,11.595),(34.975,11.425),(34.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.465),(11.825,13.635),(11.995,13.635),(11.995,13.465),(11.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.745),(78.005,10.915),(78.175,10.915),(78.175,10.745),(78.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.745),(78.515,10.915),(78.685,10.915),(78.685,10.745),(78.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.485),(45.425,14.655),(45.595,14.655),(45.595,14.485),(45.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.825),(45.425,14.995),(45.595,14.995),(45.595,14.825),(45.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.145),(45.425,14.315),(45.595,14.315),(45.595,14.145),(45.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.605),(54.515,3.775),(54.685,3.775),(54.685,3.605),(54.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.265),(54.005,3.435),(54.175,3.435),(54.175,3.265),(54.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.605),(54.005,3.775),(54.175,3.775),(54.175,3.605),(54.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,2.925),(82.805,3.095),(82.975,3.095),(82.975,2.925),(82.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.265),(54.515,3.435),(54.685,3.435),(54.685,3.265),(54.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.965),(35.825,5.135),(35.995,5.135),(35.995,4.965),(35.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.965),(35.315,5.135),(35.485,5.135),(35.485,4.965),(35.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.905),(16.625,19.075),(16.795,19.075),(16.795,18.905),(16.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.905),(16.115,19.075),(16.285,19.075),(16.285,18.905),(16.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.965),(26.225,5.135),(26.395,5.135),(26.395,4.965),(26.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.265),(6.515,3.435),(6.685,3.435),(6.685,3.265),(6.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.605),(6.515,3.775),(6.685,3.775),(6.685,3.605),(6.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.945),(20.915,4.115),(21.085,4.115),(21.085,3.945),(20.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.865),(44.915,17.035),(45.085,17.035),(45.085,16.865),(44.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.205),(55.025,17.375),(55.195,17.375),(55.195,17.205),(55.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.545),(55.025,17.715),(55.195,17.715),(55.195,17.545),(55.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.445),(35.315,12.615),(35.485,12.615),(35.485,12.445),(35.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.785),(35.315,12.955),(35.485,12.955),(35.485,12.785),(35.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.445),(35.825,12.615),(35.995,12.615),(35.995,12.445),(35.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.785),(35.825,12.955),(35.995,12.955),(35.995,12.785),(35.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.105),(35.825,12.275),(35.995,12.275),(35.995,12.105),(35.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.105),(35.315,12.275),(35.485,12.275),(35.485,12.105),(35.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.865),(58.805,17.035),(58.975,17.035),(58.975,16.865),(58.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.685),(73.205,7.855),(73.375,7.855),(73.375,7.685),(73.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.685),(73.715,7.855),(73.885,7.855),(73.885,7.685),(73.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.125),(64.115,13.295),(64.285,13.295),(64.285,13.125),(64.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.125),(64.625,13.295),(64.795,13.295),(64.795,13.125),(64.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.465),(64.115,13.635),(64.285,13.635),(64.285,13.465),(64.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.805),(64.115,13.975),(64.285,13.975),(64.285,13.805),(64.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.805),(64.625,13.975),(64.795,13.975),(64.795,13.805),(64.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.465),(64.625,13.635),(64.795,13.635),(64.795,13.465),(64.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.205),(44.915,17.375),(45.085,17.375),(45.085,17.205),(44.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.545),(44.915,17.715),(45.085,17.715),(45.085,17.545),(44.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.185),(21.425,16.355),(21.595,16.355),(21.595,16.185),(21.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.525),(21.425,16.695),(21.595,16.695),(21.595,16.525),(21.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.865),(55.025,17.035),(55.195,17.035),(55.195,16.865),(55.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.025),(59.825,8.195),(59.995,8.195),(59.995,8.025),(59.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.365),(59.315,8.535),(59.485,8.535),(59.485,8.365),(59.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.705),(59.315,8.875),(59.485,8.875),(59.485,8.705),(59.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.365),(59.825,8.535),(59.995,8.535),(59.995,8.365),(59.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.705),(59.825,8.875),(59.995,8.875),(59.995,8.705),(59.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.245),(68.405,19.415),(68.575,19.415),(68.575,19.245),(68.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.305),(20.405,5.475),(20.575,5.475),(20.575,5.305),(20.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.645),(20.405,5.815),(20.575,5.815),(20.575,5.645),(20.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.265),(83.315,3.435),(83.485,3.435),(83.485,3.265),(83.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.605),(83.315,3.775),(83.485,3.775),(83.485,3.605),(83.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.365),(30.515,8.535),(30.685,8.535),(30.685,8.365),(30.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.705),(30.515,8.875),(30.685,8.875),(30.685,8.705),(30.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.365),(30.005,8.535),(30.175,8.535),(30.175,8.365),(30.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.705),(30.005,8.875),(30.175,8.875),(30.175,8.705),(30.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.025),(30.005,8.195),(30.175,8.195),(30.175,8.025),(30.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.985),(64.625,6.155),(64.795,6.155),(64.795,5.985),(64.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.605),(79.025,3.775),(79.195,3.775),(79.195,3.605),(79.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.985),(64.115,6.155),(64.285,6.155),(64.285,5.985),(64.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.325),(6.515,6.495),(6.685,6.495),(6.685,6.325),(6.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.665),(6.515,6.835),(6.685,6.835),(6.685,6.665),(6.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.265),(79.025,3.435),(79.195,3.435),(79.195,3.265),(79.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.405),(30.515,10.575),(30.685,10.575),(30.685,10.405),(30.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.065),(30.515,10.235),(30.685,10.235),(30.685,10.065),(30.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.145),(74.225,14.315),(74.395,14.315),(74.395,14.145),(74.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.745),(30.515,10.915),(30.685,10.915),(30.685,10.745),(30.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.745),(30.005,10.915),(30.175,10.915),(30.175,10.745),(30.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.825),(74.225,14.995),(74.395,14.995),(74.395,14.825),(74.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.565),(10.805,18.735),(10.975,18.735),(10.975,18.565),(10.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.225),(10.805,18.395),(10.975,18.395),(10.975,18.225),(10.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.265),(35.315,3.435),(35.485,3.435),(35.485,3.265),(35.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.605),(35.315,3.775),(35.485,3.775),(35.485,3.605),(35.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.265),(35.825,3.435),(35.995,3.435),(35.995,3.265),(35.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.605),(35.825,3.775),(35.995,3.775),(35.995,3.605),(35.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.985),(78.515,6.155),(78.685,6.155),(78.685,5.985),(78.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.985),(78.005,6.155),(78.175,6.155),(78.175,5.985),(78.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.965),(50.225,5.135),(50.395,5.135),(50.395,4.965),(50.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.725),(31.025,9.895),(31.195,9.895),(31.195,9.725),(31.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.385),(31.025,9.555),(31.195,9.555),(31.195,9.385),(31.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.985),(54.515,6.155),(54.685,6.155),(54.685,5.985),(54.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.985),(54.005,6.155),(54.175,6.155),(54.175,5.985),(54.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.485),(26.225,14.655),(26.395,14.655),(26.395,14.485),(26.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.825),(26.225,14.995),(26.395,14.995),(26.395,14.825),(26.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.145),(26.225,14.315),(26.395,14.315),(26.395,14.145),(26.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.985),(6.515,6.155),(6.685,6.155),(6.685,5.985),(6.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.265),(59.825,3.435),(59.995,3.435),(59.995,3.265),(59.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.605),(59.315,3.775),(59.485,3.775),(59.485,3.605),(59.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.605),(59.825,3.775),(59.995,3.775),(59.995,3.605),(59.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.265),(59.315,3.435),(59.485,3.435),(59.485,3.265),(59.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.465),(31.025,13.635),(31.195,13.635),(31.195,13.465),(31.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.805),(31.025,13.975),(31.195,13.975),(31.195,13.805),(31.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.125),(31.025,13.295),(31.195,13.295),(31.195,13.125),(31.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.185),(15.605,16.355),(15.775,16.355),(15.775,16.185),(15.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.525),(15.605,16.695),(15.775,16.695),(15.775,16.525),(15.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.365),(21.425,8.535),(21.595,8.535),(21.595,8.365),(21.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.705),(21.425,8.875),(21.595,8.875),(21.595,8.705),(21.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.025),(21.425,8.195),(21.595,8.195),(21.595,8.025),(21.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.625),(68.405,4.795),(68.575,4.795),(68.575,4.625),(68.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.285),(68.405,4.455),(68.575,4.455),(68.575,4.285),(68.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.965),(83.315,5.135),(83.485,5.135),(83.485,4.965),(83.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.325),(35.315,6.495),(35.485,6.495),(35.485,6.325),(35.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.665),(35.315,6.835),(35.485,6.835),(35.485,6.665),(35.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.665),(35.825,6.835),(35.995,6.835),(35.995,6.665),(35.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.325),(35.825,6.495),(35.995,6.495),(35.995,6.325),(35.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.285),(20.405,4.455),(20.575,4.455),(20.575,4.285),(20.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.625),(20.405,4.795),(20.575,4.795),(20.575,4.625),(20.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.265),(21.425,3.435),(21.595,3.435),(21.595,3.265),(21.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.605),(21.425,3.775),(21.595,3.775),(21.595,3.605),(21.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.185),(34.805,16.355),(34.975,16.355),(34.975,16.185),(34.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.525),(34.805,16.695),(34.975,16.695),(34.975,16.525),(34.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.225),(63.605,18.395),(63.775,18.395),(63.775,18.225),(63.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.565),(63.605,18.735),(63.775,18.735),(63.775,18.565),(63.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.265),(31.025,3.435),(31.195,3.435),(31.195,3.265),(31.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.605),(31.025,3.775),(31.195,3.775),(31.195,3.605),(31.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.265),(68.915,3.435),(69.085,3.435),(69.085,3.265),(68.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.605),(68.915,3.775),(69.085,3.775),(69.085,3.605),(68.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.845),(79.025,16.015),(79.195,16.015),(79.195,15.845),(79.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.945),(54.005,4.115),(54.175,4.115),(54.175,3.945),(54.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.945),(54.515,4.115),(54.685,4.115),(54.685,3.945),(54.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.245),(64.625,19.415),(64.795,19.415),(64.795,19.245),(64.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.985),(30.005,6.155),(30.175,6.155),(30.175,5.985),(30.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.105),(11.315,12.275),(11.485,12.275),(11.485,12.105),(11.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.245),(64.115,19.415),(64.285,19.415),(64.285,19.245),(64.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.985),(30.515,6.155),(30.685,6.155),(30.685,5.985),(30.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.445),(83.315,12.615),(83.485,12.615),(83.485,12.445),(83.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.785),(83.315,12.955),(83.485,12.955),(83.485,12.785),(83.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.785),(11.825,12.955),(11.995,12.955),(11.995,12.785),(11.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.445),(11.315,12.615),(11.485,12.615),(11.485,12.445),(11.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.445),(11.825,12.615),(11.995,12.615),(11.995,12.445),(11.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.785),(11.315,12.955),(11.485,12.955),(11.485,12.785),(11.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.105),(83.315,12.275),(83.485,12.275),(83.485,12.105),(83.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.505),(83.315,15.675),(83.485,15.675),(83.485,15.505),(83.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.325),(59.825,6.495),(59.995,6.495),(59.995,6.325),(59.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.665),(59.825,6.835),(59.995,6.835),(59.995,6.665),(59.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.905),(20.405,19.075),(20.575,19.075),(20.575,18.905),(20.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.325),(59.315,6.495),(59.485,6.495),(59.485,6.325),(59.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.665),(59.315,6.835),(59.485,6.835),(59.485,6.665),(59.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.225),(83.315,18.395),(83.485,18.395),(83.485,18.225),(83.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.565),(83.315,18.735),(83.485,18.735),(83.485,18.565),(83.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.945),(6.515,4.115),(6.685,4.115),(6.685,3.945),(6.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.525),(35.825,16.695),(35.995,16.695),(35.995,16.525),(35.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.185),(35.315,16.355),(35.485,16.355),(35.485,16.185),(35.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.525),(35.315,16.695),(35.485,16.695),(35.485,16.525),(35.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.045),(82.805,9.215),(82.975,9.215),(82.975,9.045),(82.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.505),(35.825,15.675),(35.995,15.675),(35.995,15.505),(35.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.505),(35.315,15.675),(35.485,15.675),(35.485,15.505),(35.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.165),(35.315,15.335),(35.485,15.335),(35.485,15.165),(35.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.165),(35.825,15.335),(35.995,15.335),(35.995,15.165),(35.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.185),(35.825,16.355),(35.995,16.355),(35.995,16.185),(35.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.305),(45.425,5.475),(45.595,5.475),(45.595,5.305),(45.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.645),(45.425,5.815),(45.595,5.815),(45.595,5.645),(45.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.265),(44.915,3.435),(45.085,3.435),(45.085,3.265),(44.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.605),(44.915,3.775),(45.085,3.775),(45.085,3.605),(44.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.185),(26.225,16.355),(26.395,16.355),(26.395,16.185),(26.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.525),(26.225,16.695),(26.395,16.695),(26.395,16.525),(26.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.845),(44.915,16.015),(45.085,16.015),(45.085,15.845),(44.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.445),(49.715,12.615),(49.885,12.615),(49.885,12.445),(49.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.785),(49.205,12.955),(49.375,12.955),(49.375,12.785),(49.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.785),(49.715,12.955),(49.885,12.955),(49.885,12.785),(49.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.445),(49.205,12.615),(49.375,12.615),(49.375,12.445),(49.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.105),(49.205,12.275),(49.375,12.275),(49.375,12.105),(49.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.905),(6.515,19.075),(6.685,19.075),(6.685,18.905),(6.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.105),(49.715,12.275),(49.885,12.275),(49.885,12.105),(49.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.265),(55.025,3.435),(55.195,3.435),(55.195,3.265),(55.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.605),(55.025,3.775),(55.195,3.775),(55.195,3.605),(55.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.045),(45.425,9.215),(45.595,9.215),(45.595,9.045),(45.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.905),(73.715,19.075),(73.885,19.075),(73.885,18.905),(73.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.905),(73.205,19.075),(73.375,19.075),(73.375,18.905),(73.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.985),(10.805,6.155),(10.975,6.155),(10.975,5.985),(10.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.945),(7.025,4.115),(7.195,4.115),(7.195,3.945),(7.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.305),(40.625,5.475),(40.795,5.475),(40.795,5.305),(40.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.645),(40.625,5.815),(40.795,5.815),(40.795,5.645),(40.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.645),(40.115,5.815),(40.285,5.815),(40.285,5.645),(40.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.845),(31.025,16.015),(31.195,16.015),(31.195,15.845),(31.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.305),(40.115,5.475),(40.285,5.475),(40.285,5.305),(40.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.045),(7.025,9.215),(7.195,9.215),(7.195,9.045),(7.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.845),(54.515,16.015),(54.685,16.015),(54.685,15.845),(54.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.845),(54.005,16.015),(54.175,16.015),(54.175,15.845),(54.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.885),(26.225,18.055),(26.395,18.055),(26.395,17.885),(26.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.225),(21.425,18.395),(21.595,18.395),(21.595,18.225),(21.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.565),(21.425,18.735),(21.595,18.735),(21.595,18.565),(21.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.245),(58.805,19.415),(58.975,19.415),(58.975,19.245),(58.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.025),(78.005,8.195),(78.175,8.195),(78.175,8.025),(78.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.025),(78.515,8.195),(78.685,8.195),(78.685,8.025),(78.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.365),(78.005,8.535),(78.175,8.535),(78.175,8.365),(78.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.705),(78.005,8.875),(78.175,8.875),(78.175,8.705),(78.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.365),(78.515,8.535),(78.685,8.535),(78.685,8.365),(78.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.705),(78.515,8.875),(78.685,8.875),(78.685,8.705),(78.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.205),(30.005,17.375),(30.175,17.375),(30.175,17.205),(30.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.545),(30.005,17.715),(30.175,17.715),(30.175,17.545),(30.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.205),(30.515,17.375),(30.685,17.375),(30.685,17.205),(30.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.545),(30.515,17.715),(30.685,17.715),(30.685,17.545),(30.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.945),(11.315,4.115),(11.485,4.115),(11.485,3.945),(11.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.945),(11.825,4.115),(11.995,4.115),(11.995,3.945),(11.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.845),(6.515,16.015),(6.685,16.015),(6.685,15.845),(6.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.885),(79.025,18.055),(79.195,18.055),(79.195,17.885),(79.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.305),(50.225,5.475),(50.395,5.475),(50.395,5.305),(50.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.645),(50.225,5.815),(50.395,5.815),(50.395,5.645),(50.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.505),(7.025,15.675),(7.195,15.675),(7.195,15.505),(7.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.165),(7.025,15.335),(7.195,15.335),(7.195,15.165),(7.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.605),(78.005,3.775),(78.175,3.775),(78.175,3.605),(78.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.265),(78.515,3.435),(78.685,3.435),(78.685,3.265),(78.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.385),(79.025,9.555),(79.195,9.555),(79.195,9.385),(79.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.725),(79.025,9.895),(79.195,9.895),(79.195,9.725),(79.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.625),(44.915,4.795),(45.085,4.795),(45.085,4.625),(44.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.285),(44.915,4.455),(45.085,4.455),(45.085,4.285),(44.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.605),(78.515,3.775),(78.685,3.775),(78.685,3.605),(78.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.265),(78.005,3.435),(78.175,3.435),(78.175,3.265),(78.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.965),(74.225,5.135),(74.395,5.135),(74.395,4.965),(74.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.105),(59.315,12.275),(59.485,12.275),(59.485,12.105),(59.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.105),(59.825,12.275),(59.995,12.275),(59.995,12.105),(59.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.445),(59.825,12.615),(59.995,12.615),(59.995,12.445),(59.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.445),(59.315,12.615),(59.485,12.615),(59.485,12.445),(59.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.785),(59.315,12.955),(59.485,12.955),(59.485,12.785),(59.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.785),(59.825,12.955),(59.995,12.955),(59.995,12.785),(59.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.945),(25.715,4.115),(25.885,4.115),(25.885,3.945),(25.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.945),(25.205,4.115),(25.375,4.115),(25.375,3.945),(25.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.105),(11.825,12.275),(11.995,12.275),(11.995,12.105),(11.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.985),(7.025,6.155),(7.195,6.155),(7.195,5.985),(7.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.265),(74.225,3.435),(74.395,3.435),(74.395,3.265),(74.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.605),(74.225,3.775),(74.395,3.775),(74.395,3.605),(74.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.605),(45.425,3.775),(45.595,3.775),(45.595,3.605),(45.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.265),(45.425,3.435),(45.595,3.435),(45.595,3.265),(45.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.305),(16.625,5.475),(16.795,5.475),(16.795,5.305),(16.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.645),(16.115,5.815),(16.285,5.815),(16.285,5.645),(16.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.305),(16.115,5.475),(16.285,5.475),(16.285,5.305),(16.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.645),(16.625,5.815),(16.795,5.815),(16.795,5.645),(16.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.285),(64.115,4.455),(64.285,4.455),(64.285,4.285),(64.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.625),(64.625,4.795),(64.795,4.795),(64.795,4.625),(64.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.285),(64.625,4.455),(64.795,4.455),(64.795,4.285),(64.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.125),(79.025,13.295),(79.195,13.295),(79.195,13.125),(79.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.465),(79.025,13.635),(79.195,13.635),(79.195,13.465),(79.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.805),(79.025,13.975),(79.195,13.975),(79.195,13.805),(79.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.625),(64.115,4.795),(64.285,4.795),(64.285,4.625),(64.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.445),(79.025,12.615),(79.195,12.615),(79.195,12.445),(79.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.785),(79.025,12.955),(79.195,12.955),(79.195,12.785),(79.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.225),(40.625,18.395),(40.795,18.395),(40.795,18.225),(40.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.225),(40.115,18.395),(40.285,18.395),(40.285,18.225),(40.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.105),(79.025,12.275),(79.195,12.275),(79.195,12.105),(79.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.565),(40.625,18.735),(40.795,18.735),(40.795,18.565),(40.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.565),(40.115,18.735),(40.285,18.735),(40.285,18.565),(40.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.285),(45.425,4.455),(45.595,4.455),(45.595,4.285),(45.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.625),(45.425,4.795),(45.595,4.795),(45.595,4.625),(45.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.665),(73.715,6.835),(73.885,6.835),(73.885,6.665),(73.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.665),(73.205,6.835),(73.375,6.835),(73.375,6.665),(73.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.325),(73.205,6.495),(73.375,6.495),(73.375,6.325),(73.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.325),(73.715,6.495),(73.885,6.495),(73.885,6.325),(73.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.305),(74.225,5.475),(74.395,5.475),(74.395,5.305),(74.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.645),(74.225,5.815),(74.395,5.815),(74.395,5.645),(74.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.305),(35.315,5.475),(35.485,5.475),(35.485,5.305),(35.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.645),(35.315,5.815),(35.485,5.815),(35.485,5.645),(35.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.645),(35.825,5.815),(35.995,5.815),(35.995,5.645),(35.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.505),(68.405,15.675),(68.575,15.675),(68.575,15.505),(68.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.305),(35.825,5.475),(35.995,5.475),(35.995,5.305),(35.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.165),(68.405,15.335),(68.575,15.335),(68.575,15.165),(68.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.145),(16.115,14.315),(16.285,14.315),(16.285,14.145),(16.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.145),(16.625,14.315),(16.795,14.315),(16.795,14.145),(16.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.485),(16.115,14.655),(16.285,14.655),(16.285,14.485),(16.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.825),(16.115,14.995),(16.285,14.995),(16.285,14.825),(16.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.485),(16.625,14.655),(16.795,14.655),(16.795,14.485),(16.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.825),(16.625,14.995),(16.795,14.995),(16.795,14.825),(16.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.005),(74.225,7.175),(74.395,7.175),(74.395,7.005),(74.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.885),(34.805,18.055),(34.975,18.055),(34.975,17.885),(34.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.505),(20.405,15.675),(20.575,15.675),(20.575,15.505),(20.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.165),(20.405,15.335),(20.575,15.335),(20.575,15.165),(20.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.985),(58.805,6.155),(58.975,6.155),(58.975,5.985),(58.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.945),(49.205,4.115),(49.375,4.115),(49.375,3.945),(49.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.945),(49.715,4.115),(49.885,4.115),(49.885,3.945),(49.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.865),(40.115,17.035),(40.285,17.035),(40.285,16.865),(40.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.865),(40.625,17.035),(40.795,17.035),(40.795,16.865),(40.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.545),(25.715,17.715),(25.885,17.715),(25.885,17.545),(25.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.205),(25.715,17.375),(25.885,17.375),(25.885,17.205),(25.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.205),(25.205,17.375),(25.375,17.375),(25.375,17.205),(25.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.545),(25.205,17.715),(25.375,17.715),(25.375,17.545),(25.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.985),(34.805,6.155),(34.975,6.155),(34.975,5.985),(34.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.205),(7.025,17.375),(7.195,17.375),(7.195,17.205),(7.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.545),(7.025,17.715),(7.195,17.715),(7.195,17.545),(7.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.365),(83.315,8.535),(83.485,8.535),(83.485,8.365),(83.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.645),(59.315,5.815),(59.485,5.815),(59.485,5.645),(59.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.205),(63.605,17.375),(63.775,17.375),(63.775,17.205),(63.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.105),(50.225,12.275),(50.395,12.275),(50.395,12.105),(50.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.545),(63.605,17.715),(63.775,17.715),(63.775,17.545),(63.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.305),(59.315,5.475),(59.485,5.475),(59.485,5.305),(59.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.785),(50.225,12.955),(50.395,12.955),(50.395,12.785),(50.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.445),(50.225,12.615),(50.395,12.615),(50.395,12.445),(50.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.305),(59.825,5.475),(59.995,5.475),(59.995,5.305),(59.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.645),(59.825,5.815),(59.995,5.815),(59.995,5.645),(59.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.045),(55.025,9.215),(55.195,9.215),(55.195,9.045),(55.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.985),(31.025,6.155),(31.195,6.155),(31.195,5.985),(31.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.865),(20.405,17.035),(20.575,17.035),(20.575,16.865),(20.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.225),(30.005,18.395),(30.175,18.395),(30.175,18.225),(30.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.565),(30.005,18.735),(30.175,18.735),(30.175,18.565),(30.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.565),(30.515,18.735),(30.685,18.735),(30.685,18.565),(30.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.225),(30.515,18.395),(30.685,18.395),(30.685,18.225),(30.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.365),(45.425,8.535),(45.595,8.535),(45.595,8.365),(45.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.705),(45.425,8.875),(45.595,8.875),(45.595,8.705),(45.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.025),(45.425,8.195),(45.595,8.195),(45.595,8.025),(45.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.205),(11.315,17.375),(11.485,17.375),(11.485,17.205),(11.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.545),(11.315,17.715),(11.485,17.715),(11.485,17.545),(11.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.205),(11.825,17.375),(11.995,17.375),(11.995,17.205),(11.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.545),(11.825,17.715),(11.995,17.715),(11.995,17.545),(11.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.225),(68.915,18.395),(69.085,18.395),(69.085,18.225),(68.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.565),(68.915,18.735),(69.085,18.735),(69.085,18.565),(68.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.365),(69.425,8.535),(69.595,8.535),(69.595,8.365),(69.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.705),(69.425,8.875),(69.595,8.875),(69.595,8.705),(69.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.025),(69.425,8.195),(69.595,8.195),(69.595,8.025),(69.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.505),(55.025,15.675),(55.195,15.675),(55.195,15.505),(55.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.165),(55.025,15.335),(55.195,15.335),(55.195,15.165),(55.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.285),(16.625,4.455),(16.795,4.455),(16.795,4.285),(16.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.285),(16.115,4.455),(16.285,4.455),(16.285,4.285),(16.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.625),(16.115,4.795),(16.285,4.795),(16.285,4.625),(16.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.625),(16.625,4.795),(16.795,4.795),(16.795,4.625),(16.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.485),(20.915,14.655),(21.085,14.655),(21.085,14.485),(20.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.825),(20.915,14.995),(21.085,14.995),(21.085,14.825),(20.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.105),(31.025,12.275),(31.195,12.275),(31.195,12.105),(31.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.445),(31.025,12.615),(31.195,12.615),(31.195,12.445),(31.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.785),(31.025,12.955),(31.195,12.955),(31.195,12.785),(31.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.145),(20.915,14.315),(21.085,14.315),(21.085,14.145),(20.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.265),(73.715,3.435),(73.885,3.435),(73.885,3.265),(73.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.265),(73.205,3.435),(73.375,3.435),(73.375,3.265),(73.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.605),(73.205,3.775),(73.375,3.775),(73.375,3.605),(73.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.605),(68.405,3.775),(68.575,3.775),(68.575,3.605),(68.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.265),(68.405,3.435),(68.575,3.435),(68.575,3.265),(68.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.605),(73.715,3.775),(73.885,3.775),(73.885,3.605),(73.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.305),(44.915,5.475),(45.085,5.475),(45.085,5.305),(44.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.645),(44.915,5.815),(45.085,5.815),(45.085,5.645),(44.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.165),(50.225,15.335),(50.395,15.335),(50.395,15.165),(50.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.505),(50.225,15.675),(50.395,15.675),(50.395,15.505),(50.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.505),(59.825,15.675),(59.995,15.675),(59.995,15.505),(59.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.505),(59.315,15.675),(59.485,15.675),(59.485,15.505),(59.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.165),(59.825,15.335),(59.995,15.335),(59.995,15.165),(59.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.165),(59.315,15.335),(59.485,15.335),(59.485,15.165),(59.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.945),(78.515,4.115),(78.685,4.115),(78.685,3.945),(78.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.945),(78.005,4.115),(78.175,4.115),(78.175,3.945),(78.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.885),(44.405,18.055),(44.575,18.055),(44.575,17.885),(44.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.165),(11.315,15.335),(11.485,15.335),(11.485,15.165),(11.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.165),(11.825,15.335),(11.995,15.335),(11.995,15.165),(11.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.505),(11.315,15.675),(11.485,15.675),(11.485,15.505),(11.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.505),(11.825,15.675),(11.995,15.675),(11.995,15.505),(11.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.145),(83.315,14.315),(83.485,14.315),(83.485,14.145),(83.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.485),(83.315,14.655),(83.485,14.655),(83.485,14.485),(83.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.825),(83.315,14.995),(83.485,14.995),(83.485,14.825),(83.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.605),(44.405,3.775),(44.575,3.775),(44.575,3.605),(44.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.265),(44.405,3.435),(44.575,3.435),(44.575,3.265),(44.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.725),(73.205,9.895),(73.375,9.895),(73.375,9.725),(73.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.725),(73.715,9.895),(73.885,9.895),(73.885,9.725),(73.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.385),(73.715,9.555),(73.885,9.555),(73.885,9.385),(73.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.385),(73.205,9.555),(73.375,9.555),(73.375,9.385),(73.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.285),(40.625,4.455),(40.795,4.455),(40.795,4.285),(40.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.285),(40.115,4.455),(40.285,4.455),(40.285,4.285),(40.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.625),(40.625,4.795),(40.795,4.795),(40.795,4.625),(40.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.625),(40.115,4.795),(40.285,4.795),(40.285,4.625),(40.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.945),(74.225,4.115),(74.395,4.115),(74.395,3.945),(74.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.385),(25.715,9.555),(25.885,9.555),(25.885,9.385),(25.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.385),(25.205,9.555),(25.375,9.555),(25.375,9.385),(25.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.725),(25.715,9.895),(25.885,9.895),(25.885,9.725),(25.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.725),(25.205,9.895),(25.375,9.895),(25.375,9.725),(25.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.725),(20.405,9.895),(20.575,9.895),(20.575,9.725),(20.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.385),(20.405,9.555),(20.575,9.555),(20.575,9.385),(20.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.045),(78.005,9.215),(78.175,9.215),(78.175,9.045),(78.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.045),(78.515,9.215),(78.685,9.215),(78.685,9.045),(78.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.845),(68.405,16.015),(68.575,16.015),(68.575,15.845),(68.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.865),(10.805,17.035),(10.975,17.035),(10.975,16.865),(10.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.845),(20.405,16.015),(20.575,16.015),(20.575,15.845),(20.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.645),(64.625,5.815),(64.795,5.815),(64.795,5.645),(64.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.305),(64.115,5.475),(64.285,5.475),(64.285,5.305),(64.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.305),(64.625,5.475),(64.795,5.475),(64.795,5.305),(64.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.645),(64.115,5.815),(64.285,5.815),(64.285,5.645),(64.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.865),(25.715,17.035),(25.885,17.035),(25.885,16.865),(25.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.865),(25.205,17.035),(25.375,17.035),(25.375,16.865),(25.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.865),(7.025,17.035),(7.195,17.035),(7.195,16.865),(7.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.885),(31.025,18.055),(31.195,18.055),(31.195,17.885),(31.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.805),(20.405,13.975),(20.575,13.975),(20.575,13.805),(20.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.465),(20.405,13.635),(20.575,13.635),(20.575,13.465),(20.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.125),(20.405,13.295),(20.575,13.295),(20.575,13.125),(20.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.305),(78.515,5.475),(78.685,5.475),(78.685,5.305),(78.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.645),(78.515,5.815),(78.685,5.815),(78.685,5.645),(78.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.305),(78.005,5.475),(78.175,5.475),(78.175,5.305),(78.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.645),(78.005,5.815),(78.175,5.815),(78.175,5.645),(78.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.265),(50.225,3.435),(50.395,3.435),(50.395,3.265),(50.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.305),(54.515,5.475),(54.685,5.475),(54.685,5.305),(54.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.645),(54.515,5.815),(54.685,5.815),(54.685,5.645),(54.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.605),(50.225,3.775),(50.395,3.775),(50.395,3.605),(50.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.305),(54.005,5.475),(54.175,5.475),(54.175,5.305),(54.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.645),(54.005,5.815),(54.175,5.815),(54.175,5.645),(54.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.145),(64.625,14.315),(64.795,14.315),(64.795,14.145),(64.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.145),(64.115,14.315),(64.285,14.315),(64.285,14.145),(64.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.485),(64.115,14.655),(64.285,14.655),(64.285,14.485),(64.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.825),(64.115,14.995),(64.285,14.995),(64.285,14.825),(64.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.485),(64.625,14.655),(64.795,14.655),(64.795,14.485),(64.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.825),(64.625,14.995),(64.795,14.995),(64.795,14.825),(64.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.145),(55.025,14.315),(55.195,14.315),(55.195,14.145),(55.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.485),(55.025,14.655),(55.195,14.655),(55.195,14.485),(55.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.165),(30.515,15.335),(30.685,15.335),(30.685,15.165),(30.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.165),(30.005,15.335),(30.175,15.335),(30.175,15.165),(30.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.505),(30.515,15.675),(30.685,15.675),(30.685,15.505),(30.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.505),(30.005,15.675),(30.175,15.675),(30.175,15.505),(30.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.825),(55.025,14.995),(55.195,14.995),(55.195,14.825),(55.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.305),(6.515,5.475),(6.685,5.475),(6.685,5.305),(6.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.645),(6.515,5.815),(6.685,5.815),(6.685,5.645),(6.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.865),(78.005,17.035),(78.175,17.035),(78.175,16.865),(78.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.865),(78.515,17.035),(78.685,17.035),(78.685,16.865),(78.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.905),(15.605,19.075),(15.775,19.075),(15.775,18.905),(15.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.985),(82.805,6.155),(82.975,6.155),(82.975,5.985),(82.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.485),(7.025,14.655),(7.195,14.655),(7.195,14.485),(7.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.825),(7.025,14.995),(7.195,14.995),(7.195,14.825),(7.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.145),(7.025,14.315),(7.195,14.315),(7.195,14.145),(7.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.945),(69.425,4.115),(69.595,4.115),(69.595,3.945),(69.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.445),(68.915,12.615),(69.085,12.615),(69.085,12.445),(68.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.785),(68.915,12.955),(69.085,12.955),(69.085,12.785),(68.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.105),(68.915,12.275),(69.085,12.275),(69.085,12.105),(68.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.085),(79.025,11.255),(79.195,11.255),(79.195,11.085),(79.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.765),(79.025,11.935),(79.195,11.935),(79.195,11.765),(79.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.245),(25.205,19.415),(25.375,19.415),(25.375,19.245),(25.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.945),(40.625,4.115),(40.795,4.115),(40.795,3.945),(40.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.945),(40.115,4.115),(40.285,4.115),(40.285,3.945),(40.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.245),(25.715,19.415),(25.885,19.415),(25.885,19.245),(25.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.425),(79.025,11.595),(79.195,11.595),(79.195,11.425),(79.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.845),(50.225,16.015),(50.395,16.015),(50.395,15.845),(50.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.045),(30.515,9.215),(30.685,9.215),(30.685,9.045),(30.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.045),(30.005,9.215),(30.175,9.215),(30.175,9.045),(30.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.105),(20.915,12.275),(21.085,12.275),(21.085,12.105),(20.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.445),(20.915,12.615),(21.085,12.615),(21.085,12.445),(20.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.785),(20.915,12.955),(21.085,12.955),(21.085,12.785),(20.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.425),(30.005,11.595),(30.175,11.595),(30.175,11.425),(30.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.425),(30.515,11.595),(30.685,11.595),(30.685,11.425),(30.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.085),(30.005,11.255),(30.175,11.255),(30.175,11.085),(30.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.085),(30.515,11.255),(30.685,11.255),(30.685,11.085),(30.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.245),(10.805,19.415),(10.975,19.415),(10.975,19.245),(10.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.765),(30.005,11.935),(30.175,11.935),(30.175,11.765),(30.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.765),(30.515,11.935),(30.685,11.935),(30.685,11.765),(30.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.025),(50.225,8.195),(50.395,8.195),(50.395,8.025),(50.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.705),(50.225,8.875),(50.395,8.875),(50.395,8.705),(50.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.365),(50.225,8.535),(50.395,8.535),(50.395,8.365),(50.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.485),(35.825,14.655),(35.995,14.655),(35.995,14.485),(35.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.825),(35.825,14.995),(35.995,14.995),(35.995,14.825),(35.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.485),(35.315,14.655),(35.485,14.655),(35.485,14.485),(35.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.825),(35.315,14.995),(35.485,14.995),(35.485,14.825),(35.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.305),(83.315,5.475),(83.485,5.475),(83.485,5.305),(83.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.645),(83.315,5.815),(83.485,5.815),(83.485,5.645),(83.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.165),(44.405,15.335),(44.575,15.335),(44.575,15.165),(44.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.505),(44.405,15.675),(44.575,15.675),(44.575,15.505),(44.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.145),(35.825,14.315),(35.995,14.315),(35.995,14.145),(35.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.505),(10.805,15.675),(10.975,15.675),(10.975,15.505),(10.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.165),(10.805,15.335),(10.975,15.335),(10.975,15.165),(10.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.065),(50.225,10.235),(50.395,10.235),(50.395,10.065),(50.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.745),(50.225,10.915),(50.395,10.915),(50.395,10.745),(50.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.405),(50.225,10.575),(50.395,10.575),(50.395,10.405),(50.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.305),(30.515,5.475),(30.685,5.475),(30.685,5.305),(30.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.645),(30.005,5.815),(30.175,5.815),(30.175,5.645),(30.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.305),(30.005,5.475),(30.175,5.475),(30.175,5.305),(30.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.645),(30.515,5.815),(30.685,5.815),(30.685,5.645),(30.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.045),(15.605,9.215),(15.775,9.215),(15.775,9.045),(15.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.785),(30.515,12.955),(30.685,12.955),(30.685,12.785),(30.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.445),(30.515,12.615),(30.685,12.615),(30.685,12.445),(30.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.105),(30.515,12.275),(30.685,12.275),(30.685,12.105),(30.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.105),(30.005,12.275),(30.175,12.275),(30.175,12.105),(30.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.785),(30.005,12.955),(30.175,12.955),(30.175,12.785),(30.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.445),(30.005,12.615),(30.175,12.615),(30.175,12.445),(30.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.245),(78.005,19.415),(78.175,19.415),(78.175,19.245),(78.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.245),(78.515,19.415),(78.685,19.415),(78.685,19.245),(78.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.245),(55.025,19.415),(55.195,19.415),(55.195,19.245),(55.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.425),(25.715,11.595),(25.885,11.595),(25.885,11.425),(25.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.425),(25.205,11.595),(25.375,11.595),(25.375,11.425),(25.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.085),(25.205,11.255),(25.375,11.255),(25.375,11.085),(25.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.085),(25.715,11.255),(25.885,11.255),(25.885,11.085),(25.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.945),(16.625,4.115),(16.795,4.115),(16.795,3.945),(16.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.765),(25.715,11.935),(25.885,11.935),(25.885,11.765),(25.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.765),(25.205,11.935),(25.375,11.935),(25.375,11.765),(25.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.945),(16.115,4.115),(16.285,4.115),(16.285,3.945),(16.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.505),(15.605,15.675),(15.775,15.675),(15.775,15.505),(15.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.165),(15.605,15.335),(15.775,15.335),(15.775,15.165),(15.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.765),(31.025,11.935),(31.195,11.935),(31.195,11.765),(31.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.085),(31.025,11.255),(31.195,11.255),(31.195,11.085),(31.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.425),(31.025,11.595),(31.195,11.595),(31.195,11.425),(31.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.525),(82.805,16.695),(82.975,16.695),(82.975,16.525),(82.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.185),(82.805,16.355),(82.975,16.355),(82.975,16.185),(82.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.905),(58.805,19.075),(58.975,19.075),(58.975,18.905),(58.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.625),(11.315,4.795),(11.485,4.795),(11.485,4.625),(11.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.625),(11.825,4.795),(11.995,4.795),(11.995,4.625),(11.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.285),(11.825,4.455),(11.995,4.455),(11.995,4.285),(11.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.285),(11.315,4.455),(11.485,4.455),(11.485,4.285),(11.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.645),(68.915,5.815),(69.085,5.815),(69.085,5.645),(68.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.305),(68.915,5.475),(69.085,5.475),(69.085,5.305),(68.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.105),(58.805,12.275),(58.975,12.275),(58.975,12.105),(58.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.785),(58.805,12.955),(58.975,12.955),(58.975,12.785),(58.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.445),(58.805,12.615),(58.975,12.615),(58.975,12.445),(58.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.485),(68.915,14.655),(69.085,14.655),(69.085,14.485),(68.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.825),(68.915,14.995),(69.085,14.995),(69.085,14.825),(68.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.145),(68.915,14.315),(69.085,14.315),(69.085,14.145),(68.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.505),(68.915,15.675),(69.085,15.675),(69.085,15.505),(68.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.305),(10.805,5.475),(10.975,5.475),(10.975,5.305),(10.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.645),(10.805,5.815),(10.975,5.815),(10.975,5.645),(10.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.165),(68.915,15.335),(69.085,15.335),(69.085,15.165),(68.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.045),(63.605,9.215),(63.775,9.215),(63.775,9.045),(63.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.845),(30.005,16.015),(30.175,16.015),(30.175,15.845),(30.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.845),(30.515,16.015),(30.685,16.015),(30.685,15.845),(30.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.445),(10.805,12.615),(10.975,12.615),(10.975,12.445),(10.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.785),(10.805,12.955),(10.975,12.955),(10.975,12.785),(10.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.105),(10.805,12.275),(10.975,12.275),(10.975,12.105),(10.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.605),(15.605,3.775),(15.775,3.775),(15.775,3.605),(15.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.265),(15.605,3.435),(15.775,3.435),(15.775,3.265),(15.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.165),(20.915,15.335),(21.085,15.335),(21.085,15.165),(20.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.505),(20.915,15.675),(21.085,15.675),(21.085,15.505),(20.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.945),(50.225,4.115),(50.395,4.115),(50.395,3.945),(50.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.005),(26.225,7.175),(26.395,7.175),(26.395,7.005),(26.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.345),(26.225,7.515),(26.395,7.515),(26.395,7.345),(26.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.225),(69.425,18.395),(69.595,18.395),(69.595,18.225),(69.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.565),(69.425,18.735),(69.595,18.735),(69.595,18.565),(69.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.245),(16.115,19.415),(16.285,19.415),(16.285,19.245),(16.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.245),(16.625,19.415),(16.795,19.415),(16.795,19.245),(16.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.505),(63.605,15.675),(63.775,15.675),(63.775,15.505),(63.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.165),(63.605,15.335),(63.775,15.335),(63.775,15.165),(63.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.205),(26.225,17.375),(26.395,17.375),(26.395,17.205),(26.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.545),(26.225,17.715),(26.395,17.715),(26.395,17.545),(26.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.385),(54.515,9.555),(54.685,9.555),(54.685,9.385),(54.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.725),(54.515,9.895),(54.685,9.895),(54.685,9.725),(54.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.385),(54.005,9.555),(54.175,9.555),(54.175,9.385),(54.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.725),(54.005,9.895),(54.175,9.895),(54.175,9.725),(54.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.145),(11.825,14.315),(11.995,14.315),(11.995,14.145),(11.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.145),(11.315,14.315),(11.485,14.315),(11.485,14.145),(11.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.485),(11.315,14.655),(11.485,14.655),(11.485,14.485),(11.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.825),(11.315,14.995),(11.485,14.995),(11.485,14.825),(11.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.485),(11.825,14.655),(11.995,14.655),(11.995,14.485),(11.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.825),(11.825,14.995),(11.995,14.995),(11.995,14.825),(11.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.165),(58.805,15.335),(58.975,15.335),(58.975,15.165),(58.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.385),(6.515,9.555),(6.685,9.555),(6.685,9.385),(6.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.725),(6.515,9.895),(6.685,9.895),(6.685,9.725),(6.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.505),(58.805,15.675),(58.975,15.675),(58.975,15.505),(58.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.385),(44.405,9.555),(44.575,9.555),(44.575,9.385),(44.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.725),(44.405,9.895),(44.575,9.895),(44.575,9.725),(44.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.165),(78.005,15.335),(78.175,15.335),(78.175,15.165),(78.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.165),(78.515,15.335),(78.685,15.335),(78.685,15.165),(78.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.505),(78.515,15.675),(78.685,15.675),(78.685,15.505),(78.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.505),(78.005,15.675),(78.175,15.675),(78.175,15.505),(78.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.485),(74.225,14.655),(74.395,14.655),(74.395,14.485),(74.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.985),(69.425,6.155),(69.595,6.155),(69.595,5.985),(69.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.385),(68.405,9.555),(68.575,9.555),(68.575,9.385),(68.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.725),(68.405,9.895),(68.575,9.895),(68.575,9.725),(68.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.045),(49.205,9.215),(49.375,9.215),(49.375,9.045),(49.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.045),(49.715,9.215),(49.885,9.215),(49.885,9.045),(49.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.845),(44.405,16.015),(44.575,16.015),(44.575,15.845),(44.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.985),(21.425,6.155),(21.595,6.155),(21.595,5.985),(21.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.185),(69.425,16.355),(69.595,16.355),(69.595,16.185),(69.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.525),(69.425,16.695),(69.595,16.695),(69.595,16.525),(69.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.565),(34.805,18.735),(34.975,18.735),(34.975,18.565),(34.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.225),(34.805,18.395),(34.975,18.395),(34.975,18.225),(34.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.525),(63.605,16.695),(63.775,16.695),(63.775,16.525),(63.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.185),(63.605,16.355),(63.775,16.355),(63.775,16.185),(63.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.805),(44.405,13.975),(44.575,13.975),(44.575,13.805),(44.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.125),(44.405,13.295),(44.575,13.295),(44.575,13.125),(44.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.465),(44.405,13.635),(44.575,13.635),(44.575,13.465),(44.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.565),(35.825,18.735),(35.995,18.735),(35.995,18.565),(35.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.225),(35.825,18.395),(35.995,18.395),(35.995,18.225),(35.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.085),(78.005,11.255),(78.175,11.255),(78.175,11.085),(78.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.085),(78.515,11.255),(78.685,11.255),(78.685,11.085),(78.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.765),(78.515,11.935),(78.685,11.935),(78.685,11.765),(78.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.765),(78.005,11.935),(78.175,11.935),(78.175,11.765),(78.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.225),(35.315,18.395),(35.485,18.395),(35.485,18.225),(35.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.565),(35.315,18.735),(35.485,18.735),(35.485,18.565),(35.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.425),(78.515,11.595),(78.685,11.595),(78.685,11.425),(78.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.425),(78.005,11.595),(78.175,11.595),(78.175,11.425),(78.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.625),(59.315,4.795),(59.485,4.795),(59.485,4.625),(59.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.285),(59.825,4.455),(59.995,4.455),(59.995,4.285),(59.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.625),(59.825,4.795),(59.995,4.795),(59.995,4.625),(59.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.285),(59.315,4.455),(59.485,4.455),(59.485,4.285),(59.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.145),(6.515,14.315),(6.685,14.315),(6.685,14.145),(6.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.825),(6.515,14.995),(6.685,14.995),(6.685,14.825),(6.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.485),(6.515,14.655),(6.685,14.655),(6.685,14.485),(6.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.125),(68.405,13.295),(68.575,13.295),(68.575,13.125),(68.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.465),(68.405,13.635),(68.575,13.635),(68.575,13.465),(68.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.805),(68.405,13.975),(68.575,13.975),(68.575,13.805),(68.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.205),(73.205,17.375),(73.375,17.375),(73.375,17.205),(73.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.545),(73.715,17.715),(73.885,17.715),(73.885,17.545),(73.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.205),(73.715,17.375),(73.885,17.375),(73.885,17.205),(73.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.545),(73.205,17.715),(73.375,17.715),(73.375,17.545),(73.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.205),(34.805,17.375),(34.975,17.375),(34.975,17.205),(34.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.545),(34.805,17.715),(34.975,17.715),(34.975,17.545),(34.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.685),(21.425,7.855),(21.595,7.855),(21.595,7.685),(21.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.345),(21.425,7.515),(21.595,7.515),(21.595,7.345),(21.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.645),(25.205,5.815),(25.375,5.815),(25.375,5.645),(25.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.305),(25.205,5.475),(25.375,5.475),(25.375,5.305),(25.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.305),(25.715,5.475),(25.885,5.475),(25.885,5.305),(25.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.645),(25.715,5.815),(25.885,5.815),(25.885,5.645),(25.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.005),(21.425,7.175),(21.595,7.175),(21.595,7.005),(21.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.305),(58.805,5.475),(58.975,5.475),(58.975,5.305),(58.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.645),(58.805,5.815),(58.975,5.815),(58.975,5.645),(58.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.825),(44.915,14.995),(45.085,14.995),(45.085,14.825),(44.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.865),(30.515,17.035),(30.685,17.035),(30.685,16.865),(30.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.865),(30.005,17.035),(30.175,17.035),(30.175,16.865),(30.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.305),(34.805,5.475),(34.975,5.475),(34.975,5.305),(34.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.645),(34.805,5.815),(34.975,5.815),(34.975,5.645),(34.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.865),(68.405,17.035),(68.575,17.035),(68.575,16.865),(68.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.925),(55.025,3.095),(55.195,3.095),(55.195,2.925),(55.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.445),(78.515,12.615),(78.685,12.615),(78.685,12.445),(78.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.445),(78.005,12.615),(78.175,12.615),(78.175,12.445),(78.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.785),(78.005,12.955),(78.175,12.955),(78.175,12.785),(78.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.785),(78.515,12.955),(78.685,12.955),(78.685,12.785),(78.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.725),(26.225,9.895),(26.395,9.895),(26.395,9.725),(26.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.385),(26.225,9.555),(26.395,9.555),(26.395,9.385),(26.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.105),(78.005,12.275),(78.175,12.275),(78.175,12.105),(78.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.105),(78.515,12.275),(78.685,12.275),(78.685,12.105),(78.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.225),(26.225,18.395),(26.395,18.395),(26.395,18.225),(26.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.565),(26.225,18.735),(26.395,18.735),(26.395,18.565),(26.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.945),(39.605,4.115),(39.775,4.115),(39.775,3.945),(39.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,2.925),(7.025,3.095),(7.195,3.095),(7.195,2.925),(7.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.385),(39.605,9.555),(39.775,9.555),(39.775,9.385),(39.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.725),(39.605,9.895),(39.775,9.895),(39.775,9.725),(39.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.965),(68.915,5.135),(69.085,5.135),(69.085,4.965),(68.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.825),(59.825,14.995),(59.995,14.995),(59.995,14.825),(59.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.485),(59.825,14.655),(59.995,14.655),(59.995,14.485),(59.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.825),(59.315,14.995),(59.485,14.995),(59.485,14.825),(59.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.485),(59.315,14.655),(59.485,14.655),(59.485,14.485),(59.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.145),(59.825,14.315),(59.995,14.315),(59.995,14.145),(59.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,2.925),(74.225,3.095),(74.395,3.095),(74.395,2.925),(74.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,2.925),(11.315,3.095),(11.485,3.095),(11.485,2.925),(11.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,2.925),(11.825,3.095),(11.995,3.095),(11.995,2.925),(11.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.125),(20.915,13.295),(21.085,13.295),(21.085,13.125),(20.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.465),(20.915,13.635),(21.085,13.635),(21.085,13.465),(20.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.805),(20.915,13.975),(21.085,13.975),(21.085,13.805),(20.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.305),(49.715,5.475),(49.885,5.475),(49.885,5.305),(49.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.645),(49.715,5.815),(49.885,5.815),(49.885,5.645),(49.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.645),(49.205,5.815),(49.375,5.815),(49.375,5.645),(49.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.965),(20.915,5.135),(21.085,5.135),(21.085,4.965),(20.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.305),(49.205,5.475),(49.375,5.475),(49.375,5.305),(49.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,2.925),(26.225,3.095),(26.395,3.095),(26.395,2.925),(26.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.965),(79.025,5.135),(79.195,5.135),(79.195,4.965),(79.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.465),(39.605,13.635),(39.775,13.635),(39.775,13.465),(39.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.805),(39.605,13.975),(39.775,13.975),(39.775,13.805),(39.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.125),(39.605,13.295),(39.775,13.295),(39.775,13.125),(39.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.025),(79.025,8.195),(79.195,8.195),(79.195,8.025),(79.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.365),(79.025,8.535),(79.195,8.535),(79.195,8.365),(79.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.705),(79.025,8.875),(79.195,8.875),(79.195,8.705),(79.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.845),(78.005,16.015),(78.175,16.015),(78.175,15.845),(78.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.845),(78.515,16.015),(78.685,16.015),(78.685,15.845),(78.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.965),(55.025,5.135),(55.195,5.135),(55.195,4.965),(55.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,2.925),(25.715,3.095),(25.885,3.095),(25.885,2.925),(25.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,2.925),(25.205,3.095),(25.375,3.095),(25.375,2.925),(25.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.905),(68.405,19.075),(68.575,19.075),(68.575,18.905),(68.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.245),(30.005,19.415),(30.175,19.415),(30.175,19.245),(30.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.245),(30.515,19.415),(30.685,19.415),(30.685,19.245),(30.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.205),(44.405,17.375),(44.575,17.375),(44.575,17.205),(44.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.545),(44.405,17.715),(44.575,17.715),(44.575,17.545),(44.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.945),(63.605,4.115),(63.775,4.115),(63.775,3.945),(63.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.925),(31.025,3.095),(31.195,3.095),(31.195,2.925),(31.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.905),(78.515,19.075),(78.685,19.075),(78.685,18.905),(78.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.905),(78.005,19.075),(78.175,19.075),(78.175,18.905),(78.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.965),(7.025,5.135),(7.195,5.135),(7.195,4.965),(7.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.125),(35.315,13.295),(35.485,13.295),(35.485,13.125),(35.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.985),(39.605,6.155),(39.775,6.155),(39.775,5.985),(39.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.025),(58.805,8.195),(58.975,8.195),(58.975,8.025),(58.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.365),(58.805,8.535),(58.975,8.535),(58.975,8.365),(58.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.705),(58.805,8.875),(58.975,8.875),(58.975,8.705),(58.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.865),(83.315,17.035),(83.485,17.035),(83.485,16.865),(83.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.985),(15.605,6.155),(15.775,6.155),(15.775,5.985),(15.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.765),(73.715,11.935),(73.885,11.935),(73.885,11.765),(73.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.085),(73.715,11.255),(73.885,11.255),(73.885,11.085),(73.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.745),(58.805,10.915),(58.975,10.915),(58.975,10.745),(58.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.825),(34.805,14.995),(34.975,14.995),(34.975,14.825),(34.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.085),(73.205,11.255),(73.375,11.255),(73.375,11.085),(73.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.145),(34.805,14.315),(34.975,14.315),(34.975,14.145),(34.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.425),(73.205,11.595),(73.375,11.595),(73.375,11.425),(73.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.425),(73.715,11.595),(73.885,11.595),(73.885,11.425),(73.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.405),(58.805,10.575),(58.975,10.575),(58.975,10.405),(58.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.065),(58.805,10.235),(58.975,10.235),(58.975,10.065),(58.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.885),(83.315,18.055),(83.485,18.055),(83.485,17.885),(83.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.025),(10.805,8.195),(10.975,8.195),(10.975,8.025),(10.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.925),(45.425,3.095),(45.595,3.095),(45.595,2.925),(45.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.365),(10.805,8.535),(10.975,8.535),(10.975,8.365),(10.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.705),(10.805,8.875),(10.975,8.875),(10.975,8.705),(10.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.185),(74.225,16.355),(74.395,16.355),(74.395,16.185),(74.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.525),(74.225,16.695),(74.395,16.695),(74.395,16.525),(74.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.825),(54.005,14.995),(54.175,14.995),(54.175,14.825),(54.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.485),(54.005,14.655),(54.175,14.655),(54.175,14.485),(54.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.485),(54.515,14.655),(54.685,14.655),(54.685,14.485),(54.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.825),(54.515,14.995),(54.685,14.995),(54.685,14.825),(54.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.145),(54.005,14.315),(54.175,14.315),(54.175,14.145),(54.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.405),(10.805,10.575),(10.975,10.575),(10.975,10.405),(10.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.745),(10.805,10.915),(10.975,10.915),(10.975,10.745),(10.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.065),(10.805,10.235),(10.975,10.235),(10.975,10.065),(10.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.145),(15.605,14.315),(15.775,14.315),(15.775,14.145),(15.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.485),(15.605,14.655),(15.775,14.655),(15.775,14.485),(15.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.825),(15.605,14.995),(15.775,14.995),(15.775,14.825),(15.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.265),(10.805,3.435),(10.975,3.435),(10.975,3.265),(10.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.605),(10.805,3.775),(10.975,3.775),(10.975,3.605),(10.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.925),(50.225,3.095),(50.395,3.095),(50.395,2.925),(50.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.845),(64.115,16.015),(64.285,16.015),(64.285,15.845),(64.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.845),(64.625,16.015),(64.795,16.015),(64.795,15.845),(64.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.165),(44.915,15.335),(45.085,15.335),(45.085,15.165),(44.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.505),(44.915,15.675),(45.085,15.675),(45.085,15.505),(44.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.065),(25.205,10.235),(25.375,10.235),(25.375,10.065),(25.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.745),(25.715,10.915),(25.885,10.915),(25.885,10.745),(25.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.745),(25.205,10.915),(25.375,10.915),(25.375,10.745),(25.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.405),(25.715,10.575),(25.885,10.575),(25.885,10.405),(25.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.405),(25.205,10.575),(25.375,10.575),(25.375,10.405),(25.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.065),(25.715,10.235),(25.885,10.235),(25.885,10.065),(25.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.405),(31.025,10.575),(31.195,10.575),(31.195,10.405),(31.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.065),(31.025,10.235),(31.195,10.235),(31.195,10.065),(31.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.745),(31.025,10.915),(31.195,10.915),(31.195,10.745),(31.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.865),(73.205,17.035),(73.375,17.035),(73.375,16.865),(73.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.965),(31.025,5.135),(31.195,5.135),(31.195,4.965),(31.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.865),(73.715,17.035),(73.885,17.035),(73.885,16.865),(73.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.245),(7.025,19.415),(7.195,19.415),(7.195,19.245),(7.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.365),(31.025,8.535),(31.195,8.535),(31.195,8.365),(31.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.705),(31.025,8.875),(31.195,8.875),(31.195,8.705),(31.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.025),(31.025,8.195),(31.195,8.195),(31.195,8.025),(31.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.985),(63.605,6.155),(63.775,6.155),(63.775,5.985),(63.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.225),(79.025,18.395),(79.195,18.395),(79.195,18.225),(79.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.565),(79.025,18.735),(79.195,18.735),(79.195,18.565),(79.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.105),(44.915,12.275),(45.085,12.275),(45.085,12.105),(44.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.445),(44.915,12.615),(45.085,12.615),(45.085,12.445),(44.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.785),(44.915,12.955),(45.085,12.955),(45.085,12.785),(44.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.405),(30.005,10.575),(30.175,10.575),(30.175,10.405),(30.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.065),(30.005,10.235),(30.175,10.235),(30.175,10.065),(30.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.885),(49.205,18.055),(49.375,18.055),(49.375,17.885),(49.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.885),(49.715,18.055),(49.885,18.055),(49.885,17.885),(49.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.885),(74.225,18.055),(74.395,18.055),(74.395,17.885),(74.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.205),(45.425,17.375),(45.595,17.375),(45.595,17.205),(45.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.545),(45.425,17.715),(45.595,17.715),(45.595,17.545),(45.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,2.925),(59.825,3.095),(59.995,3.095),(59.995,2.925),(59.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.925),(59.315,3.095),(59.485,3.095),(59.485,2.925),(59.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.745),(20.405,10.915),(20.575,10.915),(20.575,10.745),(20.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.405),(20.405,10.575),(20.575,10.575),(20.575,10.405),(20.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.065),(20.405,10.235),(20.575,10.235),(20.575,10.065),(20.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.885),(82.805,18.055),(82.975,18.055),(82.975,17.885),(82.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.805),(50.225,13.975),(50.395,13.975),(50.395,13.805),(50.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.465),(50.225,13.635),(50.395,13.635),(50.395,13.465),(50.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.125),(50.225,13.295),(50.395,13.295),(50.395,13.125),(50.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.365),(64.115,8.535),(64.285,8.535),(64.285,8.365),(64.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.305),(82.805,5.475),(82.975,5.475),(82.975,5.305),(82.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.645),(82.805,5.815),(82.975,5.815),(82.975,5.645),(82.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.525),(64.625,16.695),(64.795,16.695),(64.795,16.525),(64.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.185),(64.625,16.355),(64.795,16.355),(64.795,16.185),(64.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.185),(64.115,16.355),(64.285,16.355),(64.285,16.185),(64.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.525),(64.115,16.695),(64.285,16.695),(64.285,16.525),(64.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.325),(7.025,6.495),(7.195,6.495),(7.195,6.325),(7.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.665),(7.025,6.835),(7.195,6.835),(7.195,6.665),(7.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.845),(16.625,16.015),(16.795,16.015),(16.795,15.845),(16.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.845),(16.115,16.015),(16.285,16.015),(16.285,15.845),(16.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.805),(78.515,13.975),(78.685,13.975),(78.685,13.805),(78.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.465),(78.005,13.635),(78.175,13.635),(78.175,13.465),(78.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.805),(78.005,13.975),(78.175,13.975),(78.175,13.805),(78.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.465),(78.515,13.635),(78.685,13.635),(78.685,13.465),(78.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.125),(78.005,13.295),(78.175,13.295),(78.175,13.125),(78.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.125),(78.515,13.295),(78.685,13.295),(78.685,13.125),(78.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.905),(44.915,19.075),(45.085,19.075),(45.085,18.905),(44.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.265),(58.805,3.435),(58.975,3.435),(58.975,3.265),(58.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.605),(58.805,3.775),(58.975,3.775),(58.975,3.605),(58.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.245),(83.315,19.415),(83.485,19.415),(83.485,19.245),(83.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.685),(69.425,7.855),(69.595,7.855),(69.595,7.685),(69.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.005),(69.425,7.175),(69.595,7.175),(69.595,7.005),(69.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.345),(69.425,7.515),(69.595,7.515),(69.595,7.345),(69.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.625),(73.715,4.795),(73.885,4.795),(73.885,4.625),(73.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.285),(73.715,4.455),(73.885,4.455),(73.885,4.285),(73.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.605),(34.805,3.775),(34.975,3.775),(34.975,3.605),(34.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.625),(73.205,4.795),(73.375,4.795),(73.375,4.625),(73.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.265),(34.805,3.435),(34.975,3.435),(34.975,3.265),(34.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.285),(73.205,4.455),(73.375,4.455),(73.375,4.285),(73.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.005),(20.405,7.175),(20.575,7.175),(20.575,7.005),(20.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.345),(20.405,7.515),(20.575,7.515),(20.575,7.345),(20.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.185),(44.915,16.355),(45.085,16.355),(45.085,16.185),(44.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.525),(44.915,16.695),(45.085,16.695),(45.085,16.525),(44.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.625),(25.205,4.795),(25.375,4.795),(25.375,4.625),(25.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.285),(25.205,4.455),(25.375,4.455),(25.375,4.285),(25.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.625),(25.715,4.795),(25.885,4.795),(25.885,4.625),(25.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.285),(25.715,4.455),(25.885,4.455),(25.885,4.285),(25.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.665),(31.025,6.835),(31.195,6.835),(31.195,6.665),(31.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.325),(31.025,6.495),(31.195,6.495),(31.195,6.325),(31.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.725),(74.225,9.895),(74.395,9.895),(74.395,9.725),(74.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.385),(74.225,9.555),(74.395,9.555),(74.395,9.385),(74.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.925),(49.205,3.095),(49.375,3.095),(49.375,2.925),(49.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.925),(49.715,3.095),(49.885,3.095),(49.885,2.925),(49.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,2.925),(79.025,3.095),(79.195,3.095),(79.195,2.925),(79.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.945),(10.805,4.115),(10.975,4.115),(10.975,3.945),(10.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.885),(35.825,18.055),(35.995,18.055),(35.995,17.885),(35.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.885),(35.315,18.055),(35.485,18.055),(35.485,17.885),(35.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.045),(40.115,9.215),(40.285,9.215),(40.285,9.045),(40.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.865),(21.425,17.035),(21.595,17.035),(21.595,16.865),(21.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.885),(44.915,18.055),(45.085,18.055),(45.085,17.885),(44.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.045),(40.625,9.215),(40.795,9.215),(40.795,9.045),(40.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.685),(44.405,7.855),(44.575,7.855),(44.575,7.685),(44.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.325),(45.425,6.495),(45.595,6.495),(45.595,6.325),(45.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.665),(45.425,6.835),(45.595,6.835),(45.595,6.665),(45.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.465),(30.515,13.635),(30.685,13.635),(30.685,13.465),(30.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.805),(30.515,13.975),(30.685,13.975),(30.685,13.805),(30.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.805),(30.005,13.975),(30.175,13.975),(30.175,13.805),(30.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.885),(21.425,18.055),(21.595,18.055),(21.595,17.885),(21.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.465),(30.005,13.635),(30.175,13.635),(30.175,13.465),(30.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.125),(30.005,13.295),(30.175,13.295),(30.175,13.125),(30.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.125),(30.515,13.295),(30.685,13.295),(30.685,13.125),(30.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.805),(44.915,13.975),(45.085,13.975),(45.085,13.805),(44.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.465),(44.915,13.635),(45.085,13.635),(45.085,13.465),(44.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.125),(44.915,13.295),(45.085,13.295),(45.085,13.125),(44.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.805),(11.825,13.975),(11.995,13.975),(11.995,13.805),(11.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.485),(44.915,14.655),(45.085,14.655),(45.085,14.485),(44.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.905),(10.805,19.075),(10.975,19.075),(10.975,18.905),(10.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.825),(63.605,14.995),(63.775,14.995),(63.775,14.825),(63.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.145),(63.605,14.315),(63.775,14.315),(63.775,14.145),(63.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.805),(68.915,13.975),(69.085,13.975),(69.085,13.805),(68.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.465),(68.915,13.635),(69.085,13.635),(69.085,13.465),(68.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.485),(63.605,14.655),(63.775,14.655),(63.775,14.485),(63.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.985),(11.315,6.155),(11.485,6.155),(11.485,5.985),(11.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.985),(11.825,6.155),(11.995,6.155),(11.995,5.985),(11.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.325),(20.915,6.495),(21.085,6.495),(21.085,6.325),(20.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.665),(20.915,6.835),(21.085,6.835),(21.085,6.665),(20.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.125),(68.915,13.295),(69.085,13.295),(69.085,13.125),(68.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.925),(44.405,3.095),(44.575,3.095),(44.575,2.925),(44.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.205),(78.515,17.375),(78.685,17.375),(78.685,17.205),(78.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.245),(21.425,19.415),(21.595,19.415),(21.595,19.245),(21.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.425),(64.115,11.595),(64.285,11.595),(64.285,11.425),(64.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.425),(64.625,11.595),(64.795,11.595),(64.795,11.425),(64.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.085),(64.115,11.255),(64.285,11.255),(64.285,11.085),(64.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.085),(64.625,11.255),(64.795,11.255),(64.795,11.085),(64.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.765),(64.115,11.935),(64.285,11.935),(64.285,11.765),(64.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.765),(64.625,11.935),(64.795,11.935),(64.795,11.765),(64.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.405),(79.025,10.575),(79.195,10.575),(79.195,10.405),(79.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.745),(79.025,10.915),(79.195,10.915),(79.195,10.745),(79.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.065),(79.025,10.235),(79.195,10.235),(79.195,10.065),(79.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,2.925),(73.205,3.095),(73.375,3.095),(73.375,2.925),(73.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,2.925),(73.715,3.095),(73.885,3.095),(73.885,2.925),(73.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.685),(54.515,7.855),(54.685,7.855),(54.685,7.685),(54.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.685),(54.005,7.855),(54.175,7.855),(54.175,7.685),(54.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.325),(20.405,6.495),(20.575,6.495),(20.575,6.325),(20.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.665),(20.405,6.835),(20.575,6.835),(20.575,6.665),(20.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.385),(35.825,9.555),(35.995,9.555),(35.995,9.385),(35.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.725),(35.825,9.895),(35.995,9.895),(35.995,9.725),(35.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.385),(35.315,9.555),(35.485,9.555),(35.485,9.385),(35.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.725),(35.315,9.895),(35.485,9.895),(35.485,9.725),(35.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.245),(20.915,19.415),(21.085,19.415),(21.085,19.245),(20.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.345),(6.515,7.515),(6.685,7.515),(6.685,7.345),(6.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.685),(6.515,7.855),(6.685,7.855),(6.685,7.685),(6.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.005),(6.515,7.175),(6.685,7.175),(6.685,7.005),(6.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.125),(10.805,13.295),(10.975,13.295),(10.975,13.125),(10.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.465),(10.805,13.635),(10.975,13.635),(10.975,13.465),(10.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.805),(10.805,13.975),(10.975,13.975),(10.975,13.805),(10.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.945),(20.405,4.115),(20.575,4.115),(20.575,3.945),(20.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.865),(15.605,17.035),(15.775,17.035),(15.775,16.865),(15.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.505),(49.715,15.675),(49.885,15.675),(49.885,15.505),(49.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.165),(49.715,15.335),(49.885,15.335),(49.885,15.165),(49.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.165),(49.205,15.335),(49.375,15.335),(49.375,15.165),(49.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.505),(49.205,15.675),(49.375,15.675),(49.375,15.505),(49.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.965),(68.405,5.135),(68.575,5.135),(68.575,4.965),(68.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.965),(20.405,5.135),(20.575,5.135),(20.575,4.965),(20.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.865),(34.805,17.035),(34.975,17.035),(34.975,16.865),(34.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.905),(63.605,19.075),(63.775,19.075),(63.775,18.905),(63.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.865),(20.915,17.035),(21.085,17.035),(21.085,16.865),(20.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.745),(73.205,10.915),(73.375,10.915),(73.375,10.745),(73.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.745),(73.715,10.915),(73.885,10.915),(73.885,10.745),(73.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.405),(73.715,10.575),(73.885,10.575),(73.885,10.405),(73.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.405),(73.205,10.575),(73.375,10.575),(73.375,10.405),(73.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.065),(73.205,10.235),(73.375,10.235),(73.375,10.065),(73.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.065),(73.715,10.235),(73.885,10.235),(73.885,10.065),(73.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.945),(58.805,4.115),(58.975,4.115),(58.975,3.945),(58.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.565),(31.025,18.735),(31.195,18.735),(31.195,18.565),(31.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.225),(31.025,18.395),(31.195,18.395),(31.195,18.225),(31.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.945),(34.805,4.115),(34.975,4.115),(34.975,3.945),(34.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.905),(83.315,19.075),(83.485,19.075),(83.485,18.905),(83.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,2.925),(20.915,3.095),(21.085,3.095),(21.085,2.925),(20.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.865),(35.315,17.035),(35.485,17.035),(35.485,16.865),(35.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.865),(35.825,17.035),(35.995,17.035),(35.995,16.865),(35.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.765),(16.625,11.935),(16.795,11.935),(16.795,11.765),(16.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.085),(16.115,11.255),(16.285,11.255),(16.285,11.085),(16.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.085),(16.625,11.255),(16.795,11.255),(16.795,11.085),(16.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.425),(16.115,11.595),(16.285,11.595),(16.285,11.425),(16.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.425),(16.625,11.595),(16.795,11.595),(16.795,11.425),(16.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.765),(16.115,11.935),(16.285,11.935),(16.285,11.765),(16.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.685),(30.005,7.855),(30.175,7.855),(30.175,7.685),(30.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.685),(30.515,7.855),(30.685,7.855),(30.685,7.685),(30.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.765),(73.205,11.935),(73.375,11.935),(73.375,11.765),(73.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.285),(6.515,4.455),(6.685,4.455),(6.685,4.285),(6.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.625),(6.515,4.795),(6.685,4.795),(6.685,4.625),(6.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.045),(50.225,9.215),(50.395,9.215),(50.395,9.045),(50.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.865),(26.225,17.035),(26.395,17.035),(26.395,16.865),(26.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.345),(64.115,7.515),(64.285,7.515),(64.285,7.345),(64.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.345),(64.625,7.515),(64.795,7.515),(64.795,7.345),(64.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.145),(82.805,14.315),(82.975,14.315),(82.975,14.145),(82.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.005),(64.625,7.175),(64.795,7.175),(64.795,7.005),(64.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.005),(64.115,7.175),(64.285,7.175),(64.285,7.005),(64.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.485),(82.805,14.655),(82.975,14.655),(82.975,14.485),(82.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.825),(82.805,14.995),(82.975,14.995),(82.975,14.825),(82.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.225),(74.225,18.395),(74.395,18.395),(74.395,18.225),(74.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.565),(74.225,18.735),(74.395,18.735),(74.395,18.565),(74.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.425),(50.225,11.595),(50.395,11.595),(50.395,11.425),(50.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.085),(50.225,11.255),(50.395,11.255),(50.395,11.085),(50.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.765),(50.225,11.935),(50.395,11.935),(50.395,11.765),(50.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.405),(68.405,10.575),(68.575,10.575),(68.575,10.405),(68.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.745),(68.405,10.915),(68.575,10.915),(68.575,10.745),(68.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.065),(68.405,10.235),(68.575,10.235),(68.575,10.065),(68.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.125),(73.715,13.295),(73.885,13.295),(73.885,13.125),(73.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.125),(73.205,13.295),(73.375,13.295),(73.375,13.125),(73.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.245),(73.205,19.415),(73.375,19.415),(73.375,19.245),(73.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.245),(73.715,19.415),(73.885,19.415),(73.885,19.245),(73.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.465),(73.205,13.635),(73.375,13.635),(73.375,13.465),(73.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.805),(73.205,13.975),(73.375,13.975),(73.375,13.805),(73.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.285),(49.715,4.455),(49.885,4.455),(49.885,4.285),(49.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.625),(49.715,4.795),(49.885,4.795),(49.885,4.625),(49.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.285),(49.205,4.455),(49.375,4.455),(49.375,4.285),(49.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.625),(49.205,4.795),(49.375,4.795),(49.375,4.625),(49.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.685),(10.805,7.855),(10.975,7.855),(10.975,7.685),(10.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.125),(25.715,13.295),(25.885,13.295),(25.885,13.125),(25.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.805),(25.205,13.975),(25.375,13.975),(25.375,13.805),(25.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.125),(25.205,13.295),(25.375,13.295),(25.375,13.125),(25.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.805),(25.715,13.975),(25.885,13.975),(25.885,13.805),(25.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.465),(25.205,13.635),(25.375,13.635),(25.375,13.465),(25.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.465),(25.715,13.635),(25.885,13.635),(25.885,13.465),(25.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.845),(40.115,16.015),(40.285,16.015),(40.285,15.845),(40.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.105),(39.605,12.275),(39.775,12.275),(39.775,12.105),(39.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.845),(40.625,16.015),(40.795,16.015),(40.795,15.845),(40.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.465),(58.805,13.635),(58.975,13.635),(58.975,13.465),(58.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.805),(58.805,13.975),(58.975,13.975),(58.975,13.805),(58.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.125),(58.805,13.295),(58.975,13.295),(58.975,13.125),(58.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.445),(39.605,12.615),(39.775,12.615),(39.775,12.445),(39.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.785),(39.605,12.955),(39.775,12.955),(39.775,12.785),(39.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.185),(79.025,16.355),(79.195,16.355),(79.195,16.185),(79.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.525),(79.025,16.695),(79.195,16.695),(79.195,16.525),(79.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.285),(30.005,4.455),(30.175,4.455),(30.175,4.285),(30.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.905),(21.425,19.075),(21.595,19.075),(21.595,18.905),(21.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.625),(30.005,4.795),(30.175,4.795),(30.175,4.625),(30.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.285),(30.515,4.455),(30.685,4.455),(30.685,4.285),(30.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.625),(30.515,4.795),(30.685,4.795),(30.685,4.625),(30.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.205),(79.025,17.375),(79.195,17.375),(79.195,17.205),(79.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.545),(79.025,17.715),(79.195,17.715),(79.195,17.545),(79.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.245),(26.225,19.415),(26.395,19.415),(26.395,19.245),(26.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.005),(39.605,7.175),(39.775,7.175),(39.775,7.005),(39.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.345),(39.605,7.515),(39.775,7.515),(39.775,7.345),(39.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.685),(39.605,7.855),(39.775,7.855),(39.775,7.685),(39.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.005),(16.625,7.175),(16.795,7.175),(16.795,7.005),(16.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.005),(16.115,7.175),(16.285,7.175),(16.285,7.005),(16.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.705),(73.715,8.875),(73.885,8.875),(73.885,8.705),(73.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.345),(16.115,7.515),(16.285,7.515),(16.285,7.345),(16.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.345),(16.625,7.515),(16.795,7.515),(16.795,7.345),(16.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.365),(73.205,8.535),(73.375,8.535),(73.375,8.365),(73.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.685),(15.605,7.855),(15.775,7.855),(15.775,7.685),(15.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.705),(73.205,8.875),(73.375,8.875),(73.375,8.705),(73.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.365),(73.715,8.535),(73.885,8.535),(73.885,8.365),(73.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.025),(73.205,8.195),(73.375,8.195),(73.375,8.025),(73.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.025),(73.715,8.195),(73.885,8.195),(73.885,8.025),(73.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.685),(82.805,7.855),(82.975,7.855),(82.975,7.685),(82.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.705),(25.715,8.875),(25.885,8.875),(25.885,8.705),(25.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.365),(25.715,8.535),(25.885,8.535),(25.885,8.365),(25.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.365),(25.205,8.535),(25.375,8.535),(25.375,8.365),(25.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.705),(25.205,8.875),(25.375,8.875),(25.375,8.705),(25.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.025),(25.205,8.195),(25.375,8.195),(25.375,8.025),(25.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.025),(25.715,8.195),(25.885,8.195),(25.885,8.025),(25.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.465),(40.115,13.635),(40.285,13.635),(40.285,13.465),(40.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.465),(40.625,13.635),(40.795,13.635),(40.795,13.465),(40.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.805),(40.625,13.975),(40.795,13.975),(40.795,13.805),(40.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.805),(40.115,13.975),(40.285,13.975),(40.285,13.805),(40.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.125),(40.115,13.295),(40.285,13.295),(40.285,13.125),(40.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.125),(40.625,13.295),(40.795,13.295),(40.795,13.125),(40.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.885),(64.115,18.055),(64.285,18.055),(64.285,17.885),(64.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.885),(64.625,18.055),(64.795,18.055),(64.795,17.885),(64.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.285),(58.805,4.455),(58.975,4.455),(58.975,4.285),(58.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.625),(58.805,4.795),(58.975,4.795),(58.975,4.625),(58.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.305),(7.025,5.475),(7.195,5.475),(7.195,5.305),(7.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.645),(7.025,5.815),(7.195,5.815),(7.195,5.645),(7.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.285),(34.805,4.455),(34.975,4.455),(34.975,4.285),(34.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.625),(34.805,4.795),(34.975,4.795),(34.975,4.625),(34.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.965),(64.625,5.135),(64.795,5.135),(64.795,4.965),(64.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.965),(64.115,5.135),(64.285,5.135),(64.285,4.965),(64.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.625),(10.805,4.795),(10.975,4.795),(10.975,4.625),(10.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.285),(10.805,4.455),(10.975,4.455),(10.975,4.285),(10.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.285),(54.005,4.455),(54.175,4.455),(54.175,4.285),(54.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.205),(20.915,17.375),(21.085,17.375),(21.085,17.205),(20.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.285),(54.515,4.455),(54.685,4.455),(54.685,4.285),(54.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.625),(54.515,4.795),(54.685,4.795),(54.685,4.625),(54.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.625),(54.005,4.795),(54.175,4.795),(54.175,4.625),(54.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.545),(20.915,17.715),(21.085,17.715),(21.085,17.545),(20.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.325),(74.225,6.495),(74.395,6.495),(74.395,6.325),(74.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.665),(74.225,6.835),(74.395,6.835),(74.395,6.665),(74.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.905),(40.625,19.075),(40.795,19.075),(40.795,18.905),(40.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.965),(45.425,5.135),(45.595,5.135),(45.595,4.965),(45.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.905),(40.115,19.075),(40.285,19.075),(40.285,18.905),(40.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.225),(39.605,18.395),(39.775,18.395),(39.775,18.225),(39.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.565),(39.605,18.735),(39.775,18.735),(39.775,18.565),(39.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.745),(44.405,10.915),(44.575,10.915),(44.575,10.745),(44.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.405),(44.405,10.575),(44.575,10.575),(44.575,10.405),(44.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.065),(44.405,10.235),(44.575,10.235),(44.575,10.065),(44.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.685),(63.605,7.855),(63.775,7.855),(63.775,7.685),(63.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.425),(39.605,11.595),(39.775,11.595),(39.775,11.425),(39.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.085),(39.605,11.255),(39.775,11.255),(39.775,11.085),(39.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.725),(16.115,9.895),(16.285,9.895),(16.285,9.725),(16.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.725),(16.625,9.895),(16.795,9.895),(16.795,9.725),(16.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.385),(16.625,9.555),(16.795,9.555),(16.795,9.385),(16.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.385),(16.115,9.555),(16.285,9.555),(16.285,9.385),(16.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.765),(39.605,11.935),(39.775,11.935),(39.775,11.765),(39.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.225),(49.715,18.395),(49.885,18.395),(49.885,18.225),(49.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.565),(49.715,18.735),(49.885,18.735),(49.885,18.565),(49.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.225),(49.205,18.395),(49.375,18.395),(49.375,18.225),(49.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.565),(49.205,18.735),(49.375,18.735),(49.375,18.565),(49.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.725),(59.315,9.895),(59.485,9.895),(59.485,9.725),(59.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.385),(59.825,9.555),(59.995,9.555),(59.995,9.385),(59.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.725),(59.825,9.895),(59.995,9.895),(59.995,9.725),(59.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.385),(59.315,9.555),(59.485,9.555),(59.485,9.385),(59.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.045),(20.915,9.215),(21.085,9.215),(21.085,9.045),(20.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.245),(34.805,19.415),(34.975,19.415),(34.975,19.245),(34.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.325),(16.625,6.495),(16.795,6.495),(16.795,6.325),(16.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.665),(16.625,6.835),(16.795,6.835),(16.795,6.665),(16.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.325),(16.115,6.495),(16.285,6.495),(16.285,6.325),(16.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.285),(82.805,4.455),(82.975,4.455),(82.975,4.285),(82.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.985),(26.225,6.155),(26.395,6.155),(26.395,5.985),(26.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.625),(82.805,4.795),(82.975,4.795),(82.975,4.625),(82.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.665),(16.115,6.835),(16.285,6.835),(16.285,6.665),(16.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.045),(10.805,9.215),(10.975,9.215),(10.975,9.045),(10.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.705),(64.625,8.875),(64.795,8.875),(64.795,8.705),(64.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.645),(31.025,5.815),(31.195,5.815),(31.195,5.645),(31.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.305),(31.025,5.475),(31.195,5.475),(31.195,5.305),(31.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.685),(58.805,7.855),(58.975,7.855),(58.975,7.685),(58.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.005),(58.805,7.175),(58.975,7.175),(58.975,7.005),(58.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.345),(58.805,7.515),(58.975,7.515),(58.975,7.345),(58.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.025),(64.115,8.195),(64.285,8.195),(64.285,8.025),(64.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.025),(64.625,8.195),(64.795,8.195),(64.795,8.025),(64.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.205),(74.225,17.375),(74.395,17.375),(74.395,17.205),(74.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.845),(21.425,16.015),(21.595,16.015),(21.595,15.845),(21.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.905),(30.515,19.075),(30.685,19.075),(30.685,18.905),(30.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.905),(30.005,19.075),(30.175,19.075),(30.175,18.905),(30.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.685),(78.515,7.855),(78.685,7.855),(78.685,7.685),(78.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.685),(34.805,7.855),(34.975,7.855),(34.975,7.685),(34.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.685),(78.005,7.855),(78.175,7.855),(78.175,7.685),(78.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.725),(11.825,9.895),(11.995,9.895),(11.995,9.725),(11.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.385),(83.315,9.555),(83.485,9.555),(83.485,9.385),(83.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.725),(83.315,9.895),(83.485,9.895),(83.485,9.725),(83.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.385),(11.315,9.555),(11.485,9.555),(11.485,9.385),(11.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.725),(11.315,9.895),(11.485,9.895),(11.485,9.725),(11.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.385),(11.825,9.555),(11.995,9.555),(11.995,9.385),(11.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.085),(10.805,11.255),(10.975,11.255),(10.975,11.085),(10.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.765),(10.805,11.935),(10.975,11.935),(10.975,11.765),(10.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.425),(10.805,11.595),(10.975,11.595),(10.975,11.425),(10.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.005),(44.915,7.175),(45.085,7.175),(45.085,7.005),(44.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.685),(44.915,7.855),(45.085,7.855),(45.085,7.685),(44.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.985),(44.405,6.155),(44.575,6.155),(44.575,5.985),(44.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.345),(44.915,7.515),(45.085,7.515),(45.085,7.345),(44.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.545),(82.805,17.715),(82.975,17.715),(82.975,17.545),(82.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.205),(82.805,17.375),(82.975,17.375),(82.975,17.205),(82.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.325),(50.225,6.495),(50.395,6.495),(50.395,6.325),(50.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.665),(50.225,6.835),(50.395,6.835),(50.395,6.665),(50.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.965),(16.115,5.135),(16.285,5.135),(16.285,4.965),(16.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.965),(16.625,5.135),(16.795,5.135),(16.795,4.965),(16.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.485),(34.805,14.655),(34.975,14.655),(34.975,14.485),(34.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.985),(44.915,6.155),(45.085,6.155),(45.085,5.985),(44.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,2.925),(68.915,3.095),(69.085,3.095),(69.085,2.925),(68.915,2.925)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.985),(59.315,19.355),(59.485,19.355),(59.485,2.985),(59.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.845),(59.315,19.495),(59.485,19.495),(59.485,2.845),(59.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.985),(16.115,19.355),(16.285,19.355),(16.285,2.985),(16.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.845),(16.115,19.495),(16.285,19.495),(16.285,2.845),(16.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.985),(78.515,19.355),(78.685,19.355),(78.685,2.985),(78.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.28),(44.915,20.76),(45.085,20.76),(45.085,20.28),(44.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.845),(78.515,19.495),(78.685,19.495),(78.685,2.845),(78.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.845),(39.605,19.495),(40.795,19.495),(40.795,2.845),(39.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.845),(54.515,19.495),(54.685,19.495),(54.685,2.845),(54.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.985),(54.515,19.355),(54.685,19.355),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,20.435),(78.515,20.605),(78.685,20.605),(78.685,20.435),(78.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,20.28),(78.515,20.76),(78.685,20.76),(78.685,20.28),(78.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,20.435),(83.06,20.605),(83.23,20.605),(83.23,20.435),(83.06,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,20.28),(83.06,20.76),(83.23,20.76),(83.23,20.28),(83.06,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,20.435),(11.315,20.605),(11.485,20.605),(11.485,20.435),(11.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,20.28),(11.315,20.76),(11.485,20.76),(11.485,20.28),(11.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((78.005,2.845),(78.005,19.495),(79.195,19.495),(79.195,2.845),(78.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.985),(83.06,19.355),(83.23,19.355),(83.23,2.985),(83.06,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.845),(83.06,19.495),(83.23,19.495),(83.23,2.845),(83.06,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,20.435),(68.915,20.605),(69.085,20.605),(69.085,20.435),(68.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,20.28),(68.915,20.76),(69.085,20.76),(69.085,20.28),(68.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.58),(20.915,2.06),(21.085,2.06),(21.085,1.58),(20.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.58),(64.115,2.06),(64.285,2.06),(64.285,1.58),(64.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.845),(44.405,19.495),(45.595,19.495),(45.595,2.845),(44.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.985),(44.915,19.355),(45.085,19.355),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.845),(44.915,19.495),(45.085,19.495),(45.085,2.845),(44.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.845),(54.005,19.495),(55.195,19.495),(55.195,2.845),(54.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,20.435),(20.915,20.605),(21.085,20.605),(21.085,20.435),(20.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,20.28),(20.915,20.76),(21.085,20.76),(21.085,20.28),(20.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,20.435),(30.515,20.605),(30.685,20.605),(30.685,20.435),(30.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,20.28),(30.515,20.76),(30.685,20.76),(30.685,20.28),(30.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((15.605,2.845),(15.605,19.495),(16.795,19.495),(16.795,2.845),(15.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.845),(34.805,19.495),(35.995,19.495),(35.995,2.845),(34.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.28),(54.515,20.76),(54.685,20.76),(54.685,20.28),(54.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,20.435),(64.115,20.605),(64.285,20.605),(64.285,20.435),(64.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,20.28),(64.115,20.76),(64.285,20.76),(64.285,20.28),(64.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.58),(16.115,2.06),(16.285,2.06),(16.285,1.58),(16.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.985),(30.515,19.355),(30.685,19.355),(30.685,2.985),(30.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.845),(30.515,19.495),(30.685,19.495),(30.685,2.845),(30.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.58),(68.915,2.06),(69.085,2.06),(69.085,1.58),(68.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((25.205,2.845),(25.205,19.495),(26.395,19.495),(26.395,2.845),(25.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.985),(11.315,19.355),(11.485,19.355),(11.485,2.985),(11.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.845),(11.315,19.495),(11.485,19.495),(11.485,2.845),(11.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((63.605,2.845),(63.605,19.495),(64.795,19.495),(64.795,2.845),(63.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.405,2.845),(20.405,19.495),(21.595,19.495),(21.595,2.845),(20.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.985),(20.915,19.355),(21.085,19.355),(21.085,2.985),(20.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.845),(20.915,19.495),(21.085,19.495),(21.085,2.845),(20.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,20.435),(73.715,20.605),(73.885,20.605),(73.885,20.435),(73.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,20.28),(73.715,20.76),(73.885,20.76),(73.885,20.28),(73.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.985),(25.715,19.355),(25.885,19.355),(25.885,2.985),(25.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.845),(25.715,19.495),(25.885,19.495),(25.885,2.845),(25.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.005,2.845),(30.005,19.495),(31.195,19.495),(31.195,2.845),(30.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.985),(6.77,19.355),(6.94,19.355),(6.94,2.985),(6.77,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.845),(6.77,19.495),(6.94,19.495),(6.94,2.845),(6.77,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.58),(78.515,2.06),(78.685,2.06),(78.685,1.58),(78.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,20.435),(25.715,20.605),(25.885,20.605),(25.885,20.435),(25.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,20.28),(25.715,20.76),(25.885,20.76),(25.885,20.28),(25.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.28),(35.315,20.76),(35.485,20.76),(35.485,20.28),(35.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.28),(49.715,20.76),(49.885,20.76),(49.885,20.28),(49.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((73.205,2.845),(73.205,19.495),(74.395,19.495),(74.395,2.845),(73.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,1.735),(85.58,1.905),(86.11,1.905),(86.11,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.58),(6.77,2.06),(6.94,2.06),(6.94,1.58),(6.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,20.435),(16.115,20.605),(16.285,20.605),(16.285,20.435),(16.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,20.28),(16.115,20.76),(16.285,20.76),(16.285,20.28),(16.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((68.405,2.845),(68.405,19.495),(69.595,19.495),(69.595,2.845),(68.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.985),(68.915,19.355),(69.085,19.355),(69.085,2.985),(68.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.845),(68.915,19.495),(69.085,19.495),(69.085,2.845),(68.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.845),(58.805,19.495),(59.995,19.495),(59.995,2.845),(58.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.515,2.845),(6.515,19.495),(7.195,19.495),(7.195,2.845),(6.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,20.435),(59.315,20.605),(59.485,20.605),(59.485,20.435),(59.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,20.28),(59.315,20.76),(59.485,20.76),(59.485,20.28),(59.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.985),(73.715,19.355),(73.885,19.355),(73.885,2.985),(73.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.845),(73.715,19.495),(73.885,19.495),(73.885,2.845),(73.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,20.435),(6.77,20.605),(6.94,20.605),(6.94,20.435),(6.77,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,20.28),(6.77,20.76),(6.94,20.76),(6.94,20.28),(6.77,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.58),(73.715,2.06),(73.885,2.06),(73.885,1.58),(73.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((10.805,2.845),(10.805,19.495),(11.995,19.495),(11.995,2.845),(10.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((82.805,2.845),(82.805,19.495),(83.485,19.495),(83.485,2.845),(82.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.58),(25.715,2.06),(25.885,2.06),(25.885,1.58),(25.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,10.71),(85.76,11.04),(85.93,11.04),(85.93,10.71),(85.76,10.71)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.985),(40.115,19.355),(40.285,19.355),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.845),(40.115,19.495),(40.285,19.495),(40.285,2.845),(40.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.28),(40.115,20.76),(40.285,20.76),(40.285,20.28),(40.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.985),(35.315,19.355),(35.485,19.355),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.845),(35.315,19.495),(35.485,19.495),(35.485,2.845),(35.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.985),(64.115,19.355),(64.285,19.355),(64.285,2.985),(64.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.845),(64.115,19.495),(64.285,19.495),(64.285,2.845),(64.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.985),(49.715,19.355),(49.885,19.355),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.845),(49.715,19.495),(49.885,19.495),(49.885,2.845),(49.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.58),(59.315,2.06),(59.485,2.06),(59.485,1.58),(59.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.845),(49.205,19.495),(50.395,19.495),(50.395,2.845),(49.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.58),(30.515,2.06),(30.685,2.06),(30.685,1.58),(30.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.58),(83.06,2.06),(83.23,2.06),(83.23,1.58),(83.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.58),(11.315,2.06),(11.485,2.06),(11.485,1.58),(11.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,10.79),(85.58,10.96),(86.11,10.96),(86.11,10.79),(85.58,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.985),(49.715,3.155),(49.885,3.155),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.345),(49.715,3.515),(49.885,3.515),(49.885,3.345),(49.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.705),(49.715,3.875),(49.885,3.875),(49.885,3.705),(49.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.065),(49.715,4.235),(49.885,4.235),(49.885,4.065),(49.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.425),(49.715,4.595),(49.885,4.595),(49.885,4.425),(49.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.785),(49.715,4.955),(49.885,4.955),(49.885,4.785),(49.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.145),(49.715,5.315),(49.885,5.315),(49.885,5.145),(49.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.505),(49.715,5.675),(49.885,5.675),(49.885,5.505),(49.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.865),(49.715,6.035),(49.885,6.035),(49.885,5.865),(49.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.225),(49.715,6.395),(49.885,6.395),(49.885,6.225),(49.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.585),(49.715,6.755),(49.885,6.755),(49.885,6.585),(49.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.305),(49.715,7.475),(49.885,7.475),(49.885,7.305),(49.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.665),(49.715,7.835),(49.885,7.835),(49.885,7.665),(49.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.385),(49.715,8.555),(49.885,8.555),(49.885,8.385),(49.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.745),(49.715,8.915),(49.885,8.915),(49.885,8.745),(49.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.105),(49.715,9.275),(49.885,9.275),(49.885,9.105),(49.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.465),(49.715,9.635),(49.885,9.635),(49.885,9.465),(49.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.825),(49.715,9.995),(49.885,9.995),(49.885,9.825),(49.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.185),(49.715,10.355),(49.885,10.355),(49.885,10.185),(49.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.545),(49.715,10.715),(49.885,10.715),(49.885,10.545),(49.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.905),(49.715,11.075),(49.885,11.075),(49.885,10.905),(49.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.265),(49.715,11.435),(49.885,11.435),(49.885,11.265),(49.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.625),(49.715,11.795),(49.885,11.795),(49.885,11.625),(49.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.985),(49.715,12.155),(49.885,12.155),(49.885,11.985),(49.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.345),(49.715,12.515),(49.885,12.515),(49.885,12.345),(49.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.705),(49.715,12.875),(49.885,12.875),(49.885,12.705),(49.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.425),(49.715,13.595),(49.885,13.595),(49.885,13.425),(49.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.785),(49.715,13.955),(49.885,13.955),(49.885,13.785),(49.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.505),(49.715,14.675),(49.885,14.675),(49.885,14.505),(49.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.865),(49.715,15.035),(49.885,15.035),(49.885,14.865),(49.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.225),(49.715,15.395),(49.885,15.395),(49.885,15.225),(49.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.585),(49.715,15.755),(49.885,15.755),(49.885,15.585),(49.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.945),(49.715,16.115),(49.885,16.115),(49.885,15.945),(49.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.305),(49.715,16.475),(49.885,16.475),(49.885,16.305),(49.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.665),(49.715,16.835),(49.885,16.835),(49.885,16.665),(49.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.025),(49.715,17.195),(49.885,17.195),(49.885,17.025),(49.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.385),(49.715,17.555),(49.885,17.555),(49.885,17.385),(49.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.745),(49.715,17.915),(49.885,17.915),(49.885,17.745),(49.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.105),(49.715,18.275),(49.885,18.275),(49.885,18.105),(49.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.465),(49.715,18.635),(49.885,18.635),(49.885,18.465),(49.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.825),(49.715,18.995),(49.885,18.995),(49.885,18.825),(49.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.435),(73.715,20.605),(73.885,20.605),(73.885,20.435),(73.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,2.985),(68.915,3.155),(69.085,3.155),(69.085,2.985),(68.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.345),(68.915,3.515),(69.085,3.515),(69.085,3.345),(68.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.705),(68.915,3.875),(69.085,3.875),(69.085,3.705),(68.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.065),(68.915,4.235),(69.085,4.235),(69.085,4.065),(68.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.425),(68.915,4.595),(69.085,4.595),(69.085,4.425),(68.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.785),(68.915,4.955),(69.085,4.955),(69.085,4.785),(68.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.145),(68.915,5.315),(69.085,5.315),(69.085,5.145),(68.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.505),(68.915,5.675),(69.085,5.675),(69.085,5.505),(68.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.865),(68.915,6.035),(69.085,6.035),(69.085,5.865),(68.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.225),(68.915,6.395),(69.085,6.395),(69.085,6.225),(68.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.585),(68.915,6.755),(69.085,6.755),(69.085,6.585),(68.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.945),(68.915,7.115),(69.085,7.115),(69.085,6.945),(68.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.305),(68.915,7.475),(69.085,7.475),(69.085,7.305),(68.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.665),(68.915,7.835),(69.085,7.835),(69.085,7.665),(68.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.025),(68.915,8.195),(69.085,8.195),(69.085,8.025),(68.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.385),(68.915,8.555),(69.085,8.555),(69.085,8.385),(68.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.745),(68.915,8.915),(69.085,8.915),(69.085,8.745),(68.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.105),(68.915,9.275),(69.085,9.275),(69.085,9.105),(68.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.465),(68.915,9.635),(69.085,9.635),(69.085,9.465),(68.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.825),(68.915,9.995),(69.085,9.995),(69.085,9.825),(68.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.185),(68.915,10.355),(69.085,10.355),(69.085,10.185),(68.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.545),(68.915,10.715),(69.085,10.715),(69.085,10.545),(68.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.905),(68.915,11.075),(69.085,11.075),(69.085,10.905),(68.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.265),(68.915,11.435),(69.085,11.435),(69.085,11.265),(68.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.625),(68.915,11.795),(69.085,11.795),(69.085,11.625),(68.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.985),(68.915,12.155),(69.085,12.155),(69.085,11.985),(68.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.345),(68.915,12.515),(69.085,12.515),(69.085,12.345),(68.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.705),(68.915,12.875),(69.085,12.875),(69.085,12.705),(68.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.065),(68.915,13.235),(69.085,13.235),(69.085,13.065),(68.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.425),(68.915,13.595),(69.085,13.595),(69.085,13.425),(68.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.785),(68.915,13.955),(69.085,13.955),(69.085,13.785),(68.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.145),(68.915,14.315),(69.085,14.315),(69.085,14.145),(68.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.505),(68.915,14.675),(69.085,14.675),(69.085,14.505),(68.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.865),(68.915,15.035),(69.085,15.035),(69.085,14.865),(68.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.225),(68.915,15.395),(69.085,15.395),(69.085,15.225),(68.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.585),(68.915,15.755),(69.085,15.755),(69.085,15.585),(68.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.945),(68.915,16.115),(69.085,16.115),(69.085,15.945),(68.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.305),(68.915,16.475),(69.085,16.475),(69.085,16.305),(68.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.665),(68.915,16.835),(69.085,16.835),(69.085,16.665),(68.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.025),(68.915,17.195),(69.085,17.195),(69.085,17.025),(68.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.385),(68.915,17.555),(69.085,17.555),(69.085,17.385),(68.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.745),(68.915,17.915),(69.085,17.915),(69.085,17.745),(68.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.105),(68.915,18.275),(69.085,18.275),(69.085,18.105),(68.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.465),(68.915,18.635),(69.085,18.635),(69.085,18.465),(68.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.825),(68.915,18.995),(69.085,18.995),(69.085,18.825),(68.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.185),(68.915,19.355),(69.085,19.355),(69.085,19.185),(68.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.435),(20.915,20.605),(21.085,20.605),(21.085,20.435),(20.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.985),(44.915,3.155),(45.085,3.155),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.345),(44.915,3.515),(45.085,3.515),(45.085,3.345),(44.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.705),(44.915,3.875),(45.085,3.875),(45.085,3.705),(44.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.065),(44.915,4.235),(45.085,4.235),(45.085,4.065),(44.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.425),(44.915,4.595),(45.085,4.595),(45.085,4.425),(44.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.785),(44.915,4.955),(45.085,4.955),(45.085,4.785),(44.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.145),(44.915,5.315),(45.085,5.315),(45.085,5.145),(44.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.505),(44.915,5.675),(45.085,5.675),(45.085,5.505),(44.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.865),(44.915,6.035),(45.085,6.035),(45.085,5.865),(44.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.225),(44.915,6.395),(45.085,6.395),(45.085,6.225),(44.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.585),(44.915,6.755),(45.085,6.755),(45.085,6.585),(44.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.305),(44.915,7.475),(45.085,7.475),(45.085,7.305),(44.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.665),(44.915,7.835),(45.085,7.835),(45.085,7.665),(44.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.385),(44.915,8.555),(45.085,8.555),(45.085,8.385),(44.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.745),(44.915,8.915),(45.085,8.915),(45.085,8.745),(44.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.105),(44.915,9.275),(45.085,9.275),(45.085,9.105),(44.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.465),(44.915,9.635),(45.085,9.635),(45.085,9.465),(44.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.825),(44.915,9.995),(45.085,9.995),(45.085,9.825),(44.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.185),(44.915,10.355),(45.085,10.355),(45.085,10.185),(44.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.545),(44.915,10.715),(45.085,10.715),(45.085,10.545),(44.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.905),(44.915,11.075),(45.085,11.075),(45.085,10.905),(44.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.265),(44.915,11.435),(45.085,11.435),(45.085,11.265),(44.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.625),(44.915,11.795),(45.085,11.795),(45.085,11.625),(44.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.985),(44.915,12.155),(45.085,12.155),(45.085,11.985),(44.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.345),(44.915,12.515),(45.085,12.515),(45.085,12.345),(44.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.705),(44.915,12.875),(45.085,12.875),(45.085,12.705),(44.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.425),(44.915,13.595),(45.085,13.595),(45.085,13.425),(44.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.785),(44.915,13.955),(45.085,13.955),(45.085,13.785),(44.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.505),(44.915,14.675),(45.085,14.675),(45.085,14.505),(44.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.865),(44.915,15.035),(45.085,15.035),(45.085,14.865),(44.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.225),(44.915,15.395),(45.085,15.395),(45.085,15.225),(44.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.585),(44.915,15.755),(45.085,15.755),(45.085,15.585),(44.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.945),(44.915,16.115),(45.085,16.115),(45.085,15.945),(44.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.305),(44.915,16.475),(45.085,16.475),(45.085,16.305),(44.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.665),(44.915,16.835),(45.085,16.835),(45.085,16.665),(44.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.025),(44.915,17.195),(45.085,17.195),(45.085,17.025),(44.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.385),(44.915,17.555),(45.085,17.555),(45.085,17.385),(44.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.745),(44.915,17.915),(45.085,17.915),(45.085,17.745),(44.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.105),(44.915,18.275),(45.085,18.275),(45.085,18.105),(44.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.465),(44.915,18.635),(45.085,18.635),(45.085,18.465),(44.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.825),(44.915,18.995),(45.085,18.995),(45.085,18.825),(44.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,2.985),(16.115,3.155),(16.285,3.155),(16.285,2.985),(16.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.345),(16.115,3.515),(16.285,3.515),(16.285,3.345),(16.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.705),(16.115,3.875),(16.285,3.875),(16.285,3.705),(16.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.065),(16.115,4.235),(16.285,4.235),(16.285,4.065),(16.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.425),(16.115,4.595),(16.285,4.595),(16.285,4.425),(16.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.785),(16.115,4.955),(16.285,4.955),(16.285,4.785),(16.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.145),(16.115,5.315),(16.285,5.315),(16.285,5.145),(16.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.505),(16.115,5.675),(16.285,5.675),(16.285,5.505),(16.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.865),(16.115,6.035),(16.285,6.035),(16.285,5.865),(16.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.225),(16.115,6.395),(16.285,6.395),(16.285,6.225),(16.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.585),(16.115,6.755),(16.285,6.755),(16.285,6.585),(16.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.945),(16.115,7.115),(16.285,7.115),(16.285,6.945),(16.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.305),(16.115,7.475),(16.285,7.475),(16.285,7.305),(16.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.665),(16.115,7.835),(16.285,7.835),(16.285,7.665),(16.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.025),(16.115,8.195),(16.285,8.195),(16.285,8.025),(16.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.385),(16.115,8.555),(16.285,8.555),(16.285,8.385),(16.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.745),(16.115,8.915),(16.285,8.915),(16.285,8.745),(16.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.105),(16.115,9.275),(16.285,9.275),(16.285,9.105),(16.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.465),(16.115,9.635),(16.285,9.635),(16.285,9.465),(16.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.825),(16.115,9.995),(16.285,9.995),(16.285,9.825),(16.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.185),(16.115,10.355),(16.285,10.355),(16.285,10.185),(16.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.545),(16.115,10.715),(16.285,10.715),(16.285,10.545),(16.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.905),(16.115,11.075),(16.285,11.075),(16.285,10.905),(16.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.265),(16.115,11.435),(16.285,11.435),(16.285,11.265),(16.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.625),(16.115,11.795),(16.285,11.795),(16.285,11.625),(16.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.985),(16.115,12.155),(16.285,12.155),(16.285,11.985),(16.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.345),(16.115,12.515),(16.285,12.515),(16.285,12.345),(16.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.705),(16.115,12.875),(16.285,12.875),(16.285,12.705),(16.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.065),(16.115,13.235),(16.285,13.235),(16.285,13.065),(16.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.425),(16.115,13.595),(16.285,13.595),(16.285,13.425),(16.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.785),(16.115,13.955),(16.285,13.955),(16.285,13.785),(16.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.145),(16.115,14.315),(16.285,14.315),(16.285,14.145),(16.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.505),(16.115,14.675),(16.285,14.675),(16.285,14.505),(16.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.865),(16.115,15.035),(16.285,15.035),(16.285,14.865),(16.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.225),(16.115,15.395),(16.285,15.395),(16.285,15.225),(16.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.585),(16.115,15.755),(16.285,15.755),(16.285,15.585),(16.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.945),(16.115,16.115),(16.285,16.115),(16.285,15.945),(16.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.305),(16.115,16.475),(16.285,16.475),(16.285,16.305),(16.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.665),(16.115,16.835),(16.285,16.835),(16.285,16.665),(16.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.025),(16.115,17.195),(16.285,17.195),(16.285,17.025),(16.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.385),(16.115,17.555),(16.285,17.555),(16.285,17.385),(16.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.745),(16.115,17.915),(16.285,17.915),(16.285,17.745),(16.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.105),(16.115,18.275),(16.285,18.275),(16.285,18.105),(16.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.465),(16.115,18.635),(16.285,18.635),(16.285,18.465),(16.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.825),(16.115,18.995),(16.285,18.995),(16.285,18.825),(16.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.185),(16.115,19.355),(16.285,19.355),(16.285,19.185),(16.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.435),(30.515,20.605),(30.685,20.605),(30.685,20.435),(30.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.435),(64.115,20.605),(64.285,20.605),(64.285,20.435),(64.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.435),(25.715,20.605),(25.885,20.605),(25.885,20.435),(25.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,1.735),(85.58,1.905),(85.75,1.905),(85.75,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,1.735),(85.94,1.905),(86.11,1.905),(86.11,1.735),(85.94,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,2.985),(30.515,3.155),(30.685,3.155),(30.685,2.985),(30.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.345),(30.515,3.515),(30.685,3.515),(30.685,3.345),(30.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.705),(30.515,3.875),(30.685,3.875),(30.685,3.705),(30.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.065),(30.515,4.235),(30.685,4.235),(30.685,4.065),(30.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.425),(30.515,4.595),(30.685,4.595),(30.685,4.425),(30.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.785),(30.515,4.955),(30.685,4.955),(30.685,4.785),(30.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.145),(30.515,5.315),(30.685,5.315),(30.685,5.145),(30.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.505),(30.515,5.675),(30.685,5.675),(30.685,5.505),(30.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.865),(30.515,6.035),(30.685,6.035),(30.685,5.865),(30.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.225),(30.515,6.395),(30.685,6.395),(30.685,6.225),(30.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.585),(30.515,6.755),(30.685,6.755),(30.685,6.585),(30.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.945),(30.515,7.115),(30.685,7.115),(30.685,6.945),(30.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.305),(30.515,7.475),(30.685,7.475),(30.685,7.305),(30.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.665),(30.515,7.835),(30.685,7.835),(30.685,7.665),(30.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.385),(30.515,8.555),(30.685,8.555),(30.685,8.385),(30.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.745),(30.515,8.915),(30.685,8.915),(30.685,8.745),(30.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.105),(30.515,9.275),(30.685,9.275),(30.685,9.105),(30.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.465),(30.515,9.635),(30.685,9.635),(30.685,9.465),(30.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.825),(30.515,9.995),(30.685,9.995),(30.685,9.825),(30.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.185),(30.515,10.355),(30.685,10.355),(30.685,10.185),(30.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.545),(30.515,10.715),(30.685,10.715),(30.685,10.545),(30.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.905),(30.515,11.075),(30.685,11.075),(30.685,10.905),(30.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.265),(30.515,11.435),(30.685,11.435),(30.685,11.265),(30.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.625),(30.515,11.795),(30.685,11.795),(30.685,11.625),(30.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.985),(30.515,12.155),(30.685,12.155),(30.685,11.985),(30.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.345),(30.515,12.515),(30.685,12.515),(30.685,12.345),(30.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.705),(30.515,12.875),(30.685,12.875),(30.685,12.705),(30.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.065),(30.515,13.235),(30.685,13.235),(30.685,13.065),(30.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.425),(30.515,13.595),(30.685,13.595),(30.685,13.425),(30.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.785),(30.515,13.955),(30.685,13.955),(30.685,13.785),(30.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.505),(30.515,14.675),(30.685,14.675),(30.685,14.505),(30.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.865),(30.515,15.035),(30.685,15.035),(30.685,14.865),(30.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.225),(30.515,15.395),(30.685,15.395),(30.685,15.225),(30.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.585),(30.515,15.755),(30.685,15.755),(30.685,15.585),(30.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.945),(30.515,16.115),(30.685,16.115),(30.685,15.945),(30.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.305),(30.515,16.475),(30.685,16.475),(30.685,16.305),(30.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.665),(30.515,16.835),(30.685,16.835),(30.685,16.665),(30.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.025),(30.515,17.195),(30.685,17.195),(30.685,17.025),(30.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.385),(30.515,17.555),(30.685,17.555),(30.685,17.385),(30.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.745),(30.515,17.915),(30.685,17.915),(30.685,17.745),(30.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.105),(30.515,18.275),(30.685,18.275),(30.685,18.105),(30.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.465),(30.515,18.635),(30.685,18.635),(30.685,18.465),(30.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.825),(30.515,18.995),(30.685,18.995),(30.685,18.825),(30.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.185),(30.515,19.355),(30.685,19.355),(30.685,19.185),(30.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.985),(54.515,3.155),(54.685,3.155),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.345),(54.515,3.515),(54.685,3.515),(54.685,3.345),(54.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.705),(54.515,3.875),(54.685,3.875),(54.685,3.705),(54.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.065),(54.515,4.235),(54.685,4.235),(54.685,4.065),(54.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.425),(54.515,4.595),(54.685,4.595),(54.685,4.425),(54.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.785),(54.515,4.955),(54.685,4.955),(54.685,4.785),(54.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.145),(54.515,5.315),(54.685,5.315),(54.685,5.145),(54.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.505),(54.515,5.675),(54.685,5.675),(54.685,5.505),(54.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.865),(54.515,6.035),(54.685,6.035),(54.685,5.865),(54.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.225),(54.515,6.395),(54.685,6.395),(54.685,6.225),(54.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.585),(54.515,6.755),(54.685,6.755),(54.685,6.585),(54.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.305),(54.515,7.475),(54.685,7.475),(54.685,7.305),(54.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.665),(54.515,7.835),(54.685,7.835),(54.685,7.665),(54.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.385),(54.515,8.555),(54.685,8.555),(54.685,8.385),(54.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.745),(54.515,8.915),(54.685,8.915),(54.685,8.745),(54.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.105),(54.515,9.275),(54.685,9.275),(54.685,9.105),(54.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.465),(54.515,9.635),(54.685,9.635),(54.685,9.465),(54.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.825),(54.515,9.995),(54.685,9.995),(54.685,9.825),(54.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.185),(54.515,10.355),(54.685,10.355),(54.685,10.185),(54.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.545),(54.515,10.715),(54.685,10.715),(54.685,10.545),(54.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.905),(54.515,11.075),(54.685,11.075),(54.685,10.905),(54.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.265),(54.515,11.435),(54.685,11.435),(54.685,11.265),(54.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.625),(54.515,11.795),(54.685,11.795),(54.685,11.625),(54.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.985),(54.515,12.155),(54.685,12.155),(54.685,11.985),(54.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.345),(54.515,12.515),(54.685,12.515),(54.685,12.345),(54.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.705),(54.515,12.875),(54.685,12.875),(54.685,12.705),(54.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.425),(54.515,13.595),(54.685,13.595),(54.685,13.425),(54.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.785),(54.515,13.955),(54.685,13.955),(54.685,13.785),(54.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.505),(54.515,14.675),(54.685,14.675),(54.685,14.505),(54.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.865),(54.515,15.035),(54.685,15.035),(54.685,14.865),(54.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.225),(54.515,15.395),(54.685,15.395),(54.685,15.225),(54.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.585),(54.515,15.755),(54.685,15.755),(54.685,15.585),(54.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.945),(54.515,16.115),(54.685,16.115),(54.685,15.945),(54.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.305),(54.515,16.475),(54.685,16.475),(54.685,16.305),(54.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.665),(54.515,16.835),(54.685,16.835),(54.685,16.665),(54.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.025),(54.515,17.195),(54.685,17.195),(54.685,17.025),(54.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.385),(54.515,17.555),(54.685,17.555),(54.685,17.385),(54.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.745),(54.515,17.915),(54.685,17.915),(54.685,17.745),(54.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.105),(54.515,18.275),(54.685,18.275),(54.685,18.105),(54.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.465),(54.515,18.635),(54.685,18.635),(54.685,18.465),(54.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.825),(54.515,18.995),(54.685,18.995),(54.685,18.825),(54.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,2.985),(11.315,3.155),(11.485,3.155),(11.485,2.985),(11.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.345),(11.315,3.515),(11.485,3.515),(11.485,3.345),(11.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.705),(11.315,3.875),(11.485,3.875),(11.485,3.705),(11.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.065),(11.315,4.235),(11.485,4.235),(11.485,4.065),(11.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.425),(11.315,4.595),(11.485,4.595),(11.485,4.425),(11.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.785),(11.315,4.955),(11.485,4.955),(11.485,4.785),(11.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.145),(11.315,5.315),(11.485,5.315),(11.485,5.145),(11.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.505),(11.315,5.675),(11.485,5.675),(11.485,5.505),(11.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.865),(11.315,6.035),(11.485,6.035),(11.485,5.865),(11.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.225),(11.315,6.395),(11.485,6.395),(11.485,6.225),(11.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.585),(11.315,6.755),(11.485,6.755),(11.485,6.585),(11.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.945),(11.315,7.115),(11.485,7.115),(11.485,6.945),(11.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.305),(11.315,7.475),(11.485,7.475),(11.485,7.305),(11.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.665),(11.315,7.835),(11.485,7.835),(11.485,7.665),(11.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.025),(11.315,8.195),(11.485,8.195),(11.485,8.025),(11.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.385),(11.315,8.555),(11.485,8.555),(11.485,8.385),(11.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.745),(11.315,8.915),(11.485,8.915),(11.485,8.745),(11.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.105),(11.315,9.275),(11.485,9.275),(11.485,9.105),(11.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.465),(11.315,9.635),(11.485,9.635),(11.485,9.465),(11.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.825),(11.315,9.995),(11.485,9.995),(11.485,9.825),(11.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.185),(11.315,10.355),(11.485,10.355),(11.485,10.185),(11.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.545),(11.315,10.715),(11.485,10.715),(11.485,10.545),(11.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.905),(11.315,11.075),(11.485,11.075),(11.485,10.905),(11.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.265),(11.315,11.435),(11.485,11.435),(11.485,11.265),(11.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.625),(11.315,11.795),(11.485,11.795),(11.485,11.625),(11.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.985),(11.315,12.155),(11.485,12.155),(11.485,11.985),(11.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.345),(11.315,12.515),(11.485,12.515),(11.485,12.345),(11.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.705),(11.315,12.875),(11.485,12.875),(11.485,12.705),(11.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.065),(11.315,13.235),(11.485,13.235),(11.485,13.065),(11.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.425),(11.315,13.595),(11.485,13.595),(11.485,13.425),(11.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.785),(11.315,13.955),(11.485,13.955),(11.485,13.785),(11.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.145),(11.315,14.315),(11.485,14.315),(11.485,14.145),(11.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.505),(11.315,14.675),(11.485,14.675),(11.485,14.505),(11.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.865),(11.315,15.035),(11.485,15.035),(11.485,14.865),(11.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.225),(11.315,15.395),(11.485,15.395),(11.485,15.225),(11.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.585),(11.315,15.755),(11.485,15.755),(11.485,15.585),(11.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.945),(11.315,16.115),(11.485,16.115),(11.485,15.945),(11.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.305),(11.315,16.475),(11.485,16.475),(11.485,16.305),(11.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.665),(11.315,16.835),(11.485,16.835),(11.485,16.665),(11.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.025),(11.315,17.195),(11.485,17.195),(11.485,17.025),(11.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.385),(11.315,17.555),(11.485,17.555),(11.485,17.385),(11.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.745),(11.315,17.915),(11.485,17.915),(11.485,17.745),(11.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.105),(11.315,18.275),(11.485,18.275),(11.485,18.105),(11.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.465),(11.315,18.635),(11.485,18.635),(11.485,18.465),(11.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.825),(11.315,18.995),(11.485,18.995),(11.485,18.825),(11.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.185),(11.315,19.355),(11.485,19.355),(11.485,19.185),(11.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.435),(78.515,20.605),(78.685,20.605),(78.685,20.435),(78.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,2.985),(78.515,3.155),(78.685,3.155),(78.685,2.985),(78.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.345),(78.515,3.515),(78.685,3.515),(78.685,3.345),(78.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.705),(78.515,3.875),(78.685,3.875),(78.685,3.705),(78.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.065),(78.515,4.235),(78.685,4.235),(78.685,4.065),(78.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.425),(78.515,4.595),(78.685,4.595),(78.685,4.425),(78.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.785),(78.515,4.955),(78.685,4.955),(78.685,4.785),(78.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.145),(78.515,5.315),(78.685,5.315),(78.685,5.145),(78.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.505),(78.515,5.675),(78.685,5.675),(78.685,5.505),(78.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.865),(78.515,6.035),(78.685,6.035),(78.685,5.865),(78.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.225),(78.515,6.395),(78.685,6.395),(78.685,6.225),(78.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.585),(78.515,6.755),(78.685,6.755),(78.685,6.585),(78.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.945),(78.515,7.115),(78.685,7.115),(78.685,6.945),(78.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.305),(78.515,7.475),(78.685,7.475),(78.685,7.305),(78.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.665),(78.515,7.835),(78.685,7.835),(78.685,7.665),(78.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.025),(78.515,8.195),(78.685,8.195),(78.685,8.025),(78.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.385),(78.515,8.555),(78.685,8.555),(78.685,8.385),(78.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.745),(78.515,8.915),(78.685,8.915),(78.685,8.745),(78.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.105),(78.515,9.275),(78.685,9.275),(78.685,9.105),(78.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.465),(78.515,9.635),(78.685,9.635),(78.685,9.465),(78.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.825),(78.515,9.995),(78.685,9.995),(78.685,9.825),(78.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.185),(78.515,10.355),(78.685,10.355),(78.685,10.185),(78.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.545),(78.515,10.715),(78.685,10.715),(78.685,10.545),(78.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.905),(78.515,11.075),(78.685,11.075),(78.685,10.905),(78.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.265),(78.515,11.435),(78.685,11.435),(78.685,11.265),(78.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.625),(78.515,11.795),(78.685,11.795),(78.685,11.625),(78.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.985),(78.515,12.155),(78.685,12.155),(78.685,11.985),(78.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.345),(78.515,12.515),(78.685,12.515),(78.685,12.345),(78.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.705),(78.515,12.875),(78.685,12.875),(78.685,12.705),(78.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.065),(78.515,13.235),(78.685,13.235),(78.685,13.065),(78.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.425),(78.515,13.595),(78.685,13.595),(78.685,13.425),(78.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.785),(78.515,13.955),(78.685,13.955),(78.685,13.785),(78.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.145),(78.515,14.315),(78.685,14.315),(78.685,14.145),(78.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.505),(78.515,14.675),(78.685,14.675),(78.685,14.505),(78.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.865),(78.515,15.035),(78.685,15.035),(78.685,14.865),(78.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.225),(78.515,15.395),(78.685,15.395),(78.685,15.225),(78.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.585),(78.515,15.755),(78.685,15.755),(78.685,15.585),(78.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.945),(78.515,16.115),(78.685,16.115),(78.685,15.945),(78.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.305),(78.515,16.475),(78.685,16.475),(78.685,16.305),(78.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.665),(78.515,16.835),(78.685,16.835),(78.685,16.665),(78.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.025),(78.515,17.195),(78.685,17.195),(78.685,17.025),(78.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.385),(78.515,17.555),(78.685,17.555),(78.685,17.385),(78.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.745),(78.515,17.915),(78.685,17.915),(78.685,17.745),(78.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.105),(78.515,18.275),(78.685,18.275),(78.685,18.105),(78.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.465),(78.515,18.635),(78.685,18.635),(78.685,18.465),(78.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.825),(78.515,18.995),(78.685,18.995),(78.685,18.825),(78.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.185),(78.515,19.355),(78.685,19.355),(78.685,19.185),(78.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.435),(83.06,20.605),(83.23,20.605),(83.23,20.435),(83.06,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.435),(11.315,20.605),(11.485,20.605),(11.485,20.435),(11.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,2.985),(6.77,3.155),(6.94,3.155),(6.94,2.985),(6.77,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.345),(6.77,3.515),(6.94,3.515),(6.94,3.345),(6.77,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.705),(6.77,3.875),(6.94,3.875),(6.94,3.705),(6.77,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.065),(6.77,4.235),(6.94,4.235),(6.94,4.065),(6.77,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.425),(6.77,4.595),(6.94,4.595),(6.94,4.425),(6.77,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.785),(6.77,4.955),(6.94,4.955),(6.94,4.785),(6.77,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.145),(6.77,5.315),(6.94,5.315),(6.94,5.145),(6.77,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.505),(6.77,5.675),(6.94,5.675),(6.94,5.505),(6.77,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.865),(6.77,6.035),(6.94,6.035),(6.94,5.865),(6.77,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.225),(6.77,6.395),(6.94,6.395),(6.94,6.225),(6.77,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.585),(6.77,6.755),(6.94,6.755),(6.94,6.585),(6.77,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.945),(6.77,7.115),(6.94,7.115),(6.94,6.945),(6.77,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.305),(6.77,7.475),(6.94,7.475),(6.94,7.305),(6.77,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.665),(6.77,7.835),(6.94,7.835),(6.94,7.665),(6.77,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.025),(6.77,8.195),(6.94,8.195),(6.94,8.025),(6.77,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.385),(6.77,8.555),(6.94,8.555),(6.94,8.385),(6.77,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.745),(6.77,8.915),(6.94,8.915),(6.94,8.745),(6.77,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.105),(6.77,9.275),(6.94,9.275),(6.94,9.105),(6.77,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.465),(6.77,9.635),(6.94,9.635),(6.94,9.465),(6.77,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.825),(6.77,9.995),(6.94,9.995),(6.94,9.825),(6.77,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.185),(6.77,10.355),(6.94,10.355),(6.94,10.185),(6.77,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.545),(6.77,10.715),(6.94,10.715),(6.94,10.545),(6.77,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.905),(6.77,11.075),(6.94,11.075),(6.94,10.905),(6.77,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.265),(6.77,11.435),(6.94,11.435),(6.94,11.265),(6.77,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.625),(6.77,11.795),(6.94,11.795),(6.94,11.625),(6.77,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.985),(6.77,12.155),(6.94,12.155),(6.94,11.985),(6.77,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.345),(6.77,12.515),(6.94,12.515),(6.94,12.345),(6.77,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.705),(6.77,12.875),(6.94,12.875),(6.94,12.705),(6.77,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.065),(6.77,13.235),(6.94,13.235),(6.94,13.065),(6.77,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.425),(6.77,13.595),(6.94,13.595),(6.94,13.425),(6.77,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.785),(6.77,13.955),(6.94,13.955),(6.94,13.785),(6.77,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.145),(6.77,14.315),(6.94,14.315),(6.94,14.145),(6.77,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.505),(6.77,14.675),(6.94,14.675),(6.94,14.505),(6.77,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.865),(6.77,15.035),(6.94,15.035),(6.94,14.865),(6.77,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.225),(6.77,15.395),(6.94,15.395),(6.94,15.225),(6.77,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.585),(6.77,15.755),(6.94,15.755),(6.94,15.585),(6.77,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.945),(6.77,16.115),(6.94,16.115),(6.94,15.945),(6.77,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.305),(6.77,16.475),(6.94,16.475),(6.94,16.305),(6.77,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.665),(6.77,16.835),(6.94,16.835),(6.94,16.665),(6.77,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.025),(6.77,17.195),(6.94,17.195),(6.94,17.025),(6.77,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.385),(6.77,17.555),(6.94,17.555),(6.94,17.385),(6.77,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.745),(6.77,17.915),(6.94,17.915),(6.94,17.745),(6.77,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.105),(6.77,18.275),(6.94,18.275),(6.94,18.105),(6.77,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.465),(6.77,18.635),(6.94,18.635),(6.94,18.465),(6.77,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.825),(6.77,18.995),(6.94,18.995),(6.94,18.825),(6.77,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.185),(6.77,19.355),(6.94,19.355),(6.94,19.185),(6.77,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,10.79),(85.58,10.96),(85.75,10.96),(85.75,10.79),(85.58,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,10.79),(85.94,10.96),(86.11,10.96),(86.11,10.79),(85.94,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.435),(16.115,20.605),(16.285,20.605),(16.285,20.435),(16.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,2.985),(20.915,3.155),(21.085,3.155),(21.085,2.985),(20.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.345),(20.915,3.515),(21.085,3.515),(21.085,3.345),(20.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.705),(20.915,3.875),(21.085,3.875),(21.085,3.705),(20.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.065),(20.915,4.235),(21.085,4.235),(21.085,4.065),(20.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.425),(20.915,4.595),(21.085,4.595),(21.085,4.425),(20.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.785),(20.915,4.955),(21.085,4.955),(21.085,4.785),(20.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.145),(20.915,5.315),(21.085,5.315),(21.085,5.145),(20.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.505),(20.915,5.675),(21.085,5.675),(21.085,5.505),(20.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.865),(20.915,6.035),(21.085,6.035),(21.085,5.865),(20.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.225),(20.915,6.395),(21.085,6.395),(21.085,6.225),(20.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.585),(20.915,6.755),(21.085,6.755),(21.085,6.585),(20.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.945),(20.915,7.115),(21.085,7.115),(21.085,6.945),(20.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.305),(20.915,7.475),(21.085,7.475),(21.085,7.305),(20.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.665),(20.915,7.835),(21.085,7.835),(21.085,7.665),(20.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.025),(20.915,8.195),(21.085,8.195),(21.085,8.025),(20.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.385),(20.915,8.555),(21.085,8.555),(21.085,8.385),(20.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.745),(20.915,8.915),(21.085,8.915),(21.085,8.745),(20.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.105),(20.915,9.275),(21.085,9.275),(21.085,9.105),(20.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.465),(20.915,9.635),(21.085,9.635),(21.085,9.465),(20.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.825),(20.915,9.995),(21.085,9.995),(21.085,9.825),(20.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.185),(20.915,10.355),(21.085,10.355),(21.085,10.185),(20.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.545),(20.915,10.715),(21.085,10.715),(21.085,10.545),(20.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.905),(20.915,11.075),(21.085,11.075),(21.085,10.905),(20.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.265),(20.915,11.435),(21.085,11.435),(21.085,11.265),(20.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.625),(20.915,11.795),(21.085,11.795),(21.085,11.625),(20.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.985),(20.915,12.155),(21.085,12.155),(21.085,11.985),(20.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.345),(20.915,12.515),(21.085,12.515),(21.085,12.345),(20.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.705),(20.915,12.875),(21.085,12.875),(21.085,12.705),(20.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.065),(20.915,13.235),(21.085,13.235),(21.085,13.065),(20.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.425),(20.915,13.595),(21.085,13.595),(21.085,13.425),(20.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.785),(20.915,13.955),(21.085,13.955),(21.085,13.785),(20.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.145),(20.915,14.315),(21.085,14.315),(21.085,14.145),(20.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.505),(20.915,14.675),(21.085,14.675),(21.085,14.505),(20.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.865),(20.915,15.035),(21.085,15.035),(21.085,14.865),(20.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.225),(20.915,15.395),(21.085,15.395),(21.085,15.225),(20.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.585),(20.915,15.755),(21.085,15.755),(21.085,15.585),(20.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.945),(20.915,16.115),(21.085,16.115),(21.085,15.945),(20.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.305),(20.915,16.475),(21.085,16.475),(21.085,16.305),(20.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.665),(20.915,16.835),(21.085,16.835),(21.085,16.665),(20.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.025),(20.915,17.195),(21.085,17.195),(21.085,17.025),(20.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.385),(20.915,17.555),(21.085,17.555),(21.085,17.385),(20.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.745),(20.915,17.915),(21.085,17.915),(21.085,17.745),(20.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.105),(20.915,18.275),(21.085,18.275),(21.085,18.105),(20.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.465),(20.915,18.635),(21.085,18.635),(21.085,18.465),(20.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.825),(20.915,18.995),(21.085,18.995),(21.085,18.825),(20.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.185),(20.915,19.355),(21.085,19.355),(21.085,19.185),(20.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,2.985),(64.115,3.155),(64.285,3.155),(64.285,2.985),(64.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.345),(64.115,3.515),(64.285,3.515),(64.285,3.345),(64.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.705),(64.115,3.875),(64.285,3.875),(64.285,3.705),(64.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.065),(64.115,4.235),(64.285,4.235),(64.285,4.065),(64.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.425),(64.115,4.595),(64.285,4.595),(64.285,4.425),(64.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.785),(64.115,4.955),(64.285,4.955),(64.285,4.785),(64.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.145),(64.115,5.315),(64.285,5.315),(64.285,5.145),(64.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.505),(64.115,5.675),(64.285,5.675),(64.285,5.505),(64.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.865),(64.115,6.035),(64.285,6.035),(64.285,5.865),(64.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.225),(64.115,6.395),(64.285,6.395),(64.285,6.225),(64.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.585),(64.115,6.755),(64.285,6.755),(64.285,6.585),(64.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.945),(64.115,7.115),(64.285,7.115),(64.285,6.945),(64.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.305),(64.115,7.475),(64.285,7.475),(64.285,7.305),(64.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.665),(64.115,7.835),(64.285,7.835),(64.285,7.665),(64.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.025),(64.115,8.195),(64.285,8.195),(64.285,8.025),(64.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.385),(64.115,8.555),(64.285,8.555),(64.285,8.385),(64.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.745),(64.115,8.915),(64.285,8.915),(64.285,8.745),(64.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.105),(64.115,9.275),(64.285,9.275),(64.285,9.105),(64.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.465),(64.115,9.635),(64.285,9.635),(64.285,9.465),(64.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.825),(64.115,9.995),(64.285,9.995),(64.285,9.825),(64.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.185),(64.115,10.355),(64.285,10.355),(64.285,10.185),(64.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.545),(64.115,10.715),(64.285,10.715),(64.285,10.545),(64.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.905),(64.115,11.075),(64.285,11.075),(64.285,10.905),(64.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.265),(64.115,11.435),(64.285,11.435),(64.285,11.265),(64.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.625),(64.115,11.795),(64.285,11.795),(64.285,11.625),(64.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.985),(64.115,12.155),(64.285,12.155),(64.285,11.985),(64.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.345),(64.115,12.515),(64.285,12.515),(64.285,12.345),(64.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.705),(64.115,12.875),(64.285,12.875),(64.285,12.705),(64.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.065),(64.115,13.235),(64.285,13.235),(64.285,13.065),(64.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.425),(64.115,13.595),(64.285,13.595),(64.285,13.425),(64.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.785),(64.115,13.955),(64.285,13.955),(64.285,13.785),(64.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.145),(64.115,14.315),(64.285,14.315),(64.285,14.145),(64.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.505),(64.115,14.675),(64.285,14.675),(64.285,14.505),(64.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.865),(64.115,15.035),(64.285,15.035),(64.285,14.865),(64.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.225),(64.115,15.395),(64.285,15.395),(64.285,15.225),(64.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.585),(64.115,15.755),(64.285,15.755),(64.285,15.585),(64.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.945),(64.115,16.115),(64.285,16.115),(64.285,15.945),(64.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.305),(64.115,16.475),(64.285,16.475),(64.285,16.305),(64.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.665),(64.115,16.835),(64.285,16.835),(64.285,16.665),(64.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.025),(64.115,17.195),(64.285,17.195),(64.285,17.025),(64.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.385),(64.115,17.555),(64.285,17.555),(64.285,17.385),(64.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.745),(64.115,17.915),(64.285,17.915),(64.285,17.745),(64.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.105),(64.115,18.275),(64.285,18.275),(64.285,18.105),(64.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.465),(64.115,18.635),(64.285,18.635),(64.285,18.465),(64.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.825),(64.115,18.995),(64.285,18.995),(64.285,18.825),(64.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.185),(64.115,19.355),(64.285,19.355),(64.285,19.185),(64.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.985),(40.115,3.155),(40.285,3.155),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.345),(40.115,3.515),(40.285,3.515),(40.285,3.345),(40.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.705),(40.115,3.875),(40.285,3.875),(40.285,3.705),(40.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.065),(40.115,4.235),(40.285,4.235),(40.285,4.065),(40.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.425),(40.115,4.595),(40.285,4.595),(40.285,4.425),(40.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.785),(40.115,4.955),(40.285,4.955),(40.285,4.785),(40.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.145),(40.115,5.315),(40.285,5.315),(40.285,5.145),(40.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.505),(40.115,5.675),(40.285,5.675),(40.285,5.505),(40.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.865),(40.115,6.035),(40.285,6.035),(40.285,5.865),(40.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.225),(40.115,6.395),(40.285,6.395),(40.285,6.225),(40.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.585),(40.115,6.755),(40.285,6.755),(40.285,6.585),(40.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.305),(40.115,7.475),(40.285,7.475),(40.285,7.305),(40.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.665),(40.115,7.835),(40.285,7.835),(40.285,7.665),(40.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.385),(40.115,8.555),(40.285,8.555),(40.285,8.385),(40.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.745),(40.115,8.915),(40.285,8.915),(40.285,8.745),(40.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.105),(40.115,9.275),(40.285,9.275),(40.285,9.105),(40.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.465),(40.115,9.635),(40.285,9.635),(40.285,9.465),(40.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.825),(40.115,9.995),(40.285,9.995),(40.285,9.825),(40.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.185),(40.115,10.355),(40.285,10.355),(40.285,10.185),(40.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.545),(40.115,10.715),(40.285,10.715),(40.285,10.545),(40.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.905),(40.115,11.075),(40.285,11.075),(40.285,10.905),(40.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.265),(40.115,11.435),(40.285,11.435),(40.285,11.265),(40.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.625),(40.115,11.795),(40.285,11.795),(40.285,11.625),(40.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.985),(40.115,12.155),(40.285,12.155),(40.285,11.985),(40.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.345),(40.115,12.515),(40.285,12.515),(40.285,12.345),(40.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.705),(40.115,12.875),(40.285,12.875),(40.285,12.705),(40.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.425),(40.115,13.595),(40.285,13.595),(40.285,13.425),(40.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.785),(40.115,13.955),(40.285,13.955),(40.285,13.785),(40.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.505),(40.115,14.675),(40.285,14.675),(40.285,14.505),(40.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.865),(40.115,15.035),(40.285,15.035),(40.285,14.865),(40.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.225),(40.115,15.395),(40.285,15.395),(40.285,15.225),(40.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.585),(40.115,15.755),(40.285,15.755),(40.285,15.585),(40.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.945),(40.115,16.115),(40.285,16.115),(40.285,15.945),(40.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.305),(40.115,16.475),(40.285,16.475),(40.285,16.305),(40.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.665),(40.115,16.835),(40.285,16.835),(40.285,16.665),(40.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.025),(40.115,17.195),(40.285,17.195),(40.285,17.025),(40.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.385),(40.115,17.555),(40.285,17.555),(40.285,17.385),(40.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.745),(40.115,17.915),(40.285,17.915),(40.285,17.745),(40.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.105),(40.115,18.275),(40.285,18.275),(40.285,18.105),(40.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.465),(40.115,18.635),(40.285,18.635),(40.285,18.465),(40.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.825),(40.115,18.995),(40.285,18.995),(40.285,18.825),(40.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.435),(68.915,20.605),(69.085,20.605),(69.085,20.435),(68.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.985),(35.315,3.155),(35.485,3.155),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.345),(35.315,3.515),(35.485,3.515),(35.485,3.345),(35.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.705),(35.315,3.875),(35.485,3.875),(35.485,3.705),(35.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.065),(35.315,4.235),(35.485,4.235),(35.485,4.065),(35.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.425),(35.315,4.595),(35.485,4.595),(35.485,4.425),(35.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.785),(35.315,4.955),(35.485,4.955),(35.485,4.785),(35.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.145),(35.315,5.315),(35.485,5.315),(35.485,5.145),(35.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.505),(35.315,5.675),(35.485,5.675),(35.485,5.505),(35.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.865),(35.315,6.035),(35.485,6.035),(35.485,5.865),(35.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.225),(35.315,6.395),(35.485,6.395),(35.485,6.225),(35.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.585),(35.315,6.755),(35.485,6.755),(35.485,6.585),(35.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.305),(35.315,7.475),(35.485,7.475),(35.485,7.305),(35.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.665),(35.315,7.835),(35.485,7.835),(35.485,7.665),(35.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.385),(35.315,8.555),(35.485,8.555),(35.485,8.385),(35.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.745),(35.315,8.915),(35.485,8.915),(35.485,8.745),(35.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.105),(35.315,9.275),(35.485,9.275),(35.485,9.105),(35.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.465),(35.315,9.635),(35.485,9.635),(35.485,9.465),(35.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.825),(35.315,9.995),(35.485,9.995),(35.485,9.825),(35.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.185),(35.315,10.355),(35.485,10.355),(35.485,10.185),(35.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.545),(35.315,10.715),(35.485,10.715),(35.485,10.545),(35.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.905),(35.315,11.075),(35.485,11.075),(35.485,10.905),(35.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.265),(35.315,11.435),(35.485,11.435),(35.485,11.265),(35.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.625),(35.315,11.795),(35.485,11.795),(35.485,11.625),(35.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.985),(35.315,12.155),(35.485,12.155),(35.485,11.985),(35.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.345),(35.315,12.515),(35.485,12.515),(35.485,12.345),(35.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.705),(35.315,12.875),(35.485,12.875),(35.485,12.705),(35.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.425),(35.315,13.595),(35.485,13.595),(35.485,13.425),(35.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.785),(35.315,13.955),(35.485,13.955),(35.485,13.785),(35.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.505),(35.315,14.675),(35.485,14.675),(35.485,14.505),(35.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.865),(35.315,15.035),(35.485,15.035),(35.485,14.865),(35.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.225),(35.315,15.395),(35.485,15.395),(35.485,15.225),(35.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.585),(35.315,15.755),(35.485,15.755),(35.485,15.585),(35.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.945),(35.315,16.115),(35.485,16.115),(35.485,15.945),(35.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.305),(35.315,16.475),(35.485,16.475),(35.485,16.305),(35.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.665),(35.315,16.835),(35.485,16.835),(35.485,16.665),(35.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.025),(35.315,17.195),(35.485,17.195),(35.485,17.025),(35.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.385),(35.315,17.555),(35.485,17.555),(35.485,17.385),(35.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.745),(35.315,17.915),(35.485,17.915),(35.485,17.745),(35.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.105),(35.315,18.275),(35.485,18.275),(35.485,18.105),(35.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.465),(35.315,18.635),(35.485,18.635),(35.485,18.465),(35.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.825),(35.315,18.995),(35.485,18.995),(35.485,18.825),(35.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.435),(59.315,20.605),(59.485,20.605),(59.485,20.435),(59.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,2.985),(73.715,3.155),(73.885,3.155),(73.885,2.985),(73.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.345),(73.715,3.515),(73.885,3.515),(73.885,3.345),(73.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.705),(73.715,3.875),(73.885,3.875),(73.885,3.705),(73.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.065),(73.715,4.235),(73.885,4.235),(73.885,4.065),(73.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.425),(73.715,4.595),(73.885,4.595),(73.885,4.425),(73.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.785),(73.715,4.955),(73.885,4.955),(73.885,4.785),(73.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.145),(73.715,5.315),(73.885,5.315),(73.885,5.145),(73.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.505),(73.715,5.675),(73.885,5.675),(73.885,5.505),(73.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.865),(73.715,6.035),(73.885,6.035),(73.885,5.865),(73.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.225),(73.715,6.395),(73.885,6.395),(73.885,6.225),(73.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.585),(73.715,6.755),(73.885,6.755),(73.885,6.585),(73.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.945),(73.715,7.115),(73.885,7.115),(73.885,6.945),(73.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.305),(73.715,7.475),(73.885,7.475),(73.885,7.305),(73.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.665),(73.715,7.835),(73.885,7.835),(73.885,7.665),(73.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.025),(73.715,8.195),(73.885,8.195),(73.885,8.025),(73.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.385),(73.715,8.555),(73.885,8.555),(73.885,8.385),(73.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.745),(73.715,8.915),(73.885,8.915),(73.885,8.745),(73.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.105),(73.715,9.275),(73.885,9.275),(73.885,9.105),(73.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.465),(73.715,9.635),(73.885,9.635),(73.885,9.465),(73.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.825),(73.715,9.995),(73.885,9.995),(73.885,9.825),(73.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.185),(73.715,10.355),(73.885,10.355),(73.885,10.185),(73.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.545),(73.715,10.715),(73.885,10.715),(73.885,10.545),(73.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.905),(73.715,11.075),(73.885,11.075),(73.885,10.905),(73.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.265),(73.715,11.435),(73.885,11.435),(73.885,11.265),(73.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.625),(73.715,11.795),(73.885,11.795),(73.885,11.625),(73.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.985),(73.715,12.155),(73.885,12.155),(73.885,11.985),(73.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.345),(73.715,12.515),(73.885,12.515),(73.885,12.345),(73.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.705),(73.715,12.875),(73.885,12.875),(73.885,12.705),(73.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.065),(73.715,13.235),(73.885,13.235),(73.885,13.065),(73.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.425),(73.715,13.595),(73.885,13.595),(73.885,13.425),(73.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.785),(73.715,13.955),(73.885,13.955),(73.885,13.785),(73.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.145),(73.715,14.315),(73.885,14.315),(73.885,14.145),(73.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.505),(73.715,14.675),(73.885,14.675),(73.885,14.505),(73.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.865),(73.715,15.035),(73.885,15.035),(73.885,14.865),(73.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.225),(73.715,15.395),(73.885,15.395),(73.885,15.225),(73.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.585),(73.715,15.755),(73.885,15.755),(73.885,15.585),(73.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.945),(73.715,16.115),(73.885,16.115),(73.885,15.945),(73.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.305),(73.715,16.475),(73.885,16.475),(73.885,16.305),(73.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.665),(73.715,16.835),(73.885,16.835),(73.885,16.665),(73.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.025),(73.715,17.195),(73.885,17.195),(73.885,17.025),(73.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.385),(73.715,17.555),(73.885,17.555),(73.885,17.385),(73.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.745),(73.715,17.915),(73.885,17.915),(73.885,17.745),(73.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.105),(73.715,18.275),(73.885,18.275),(73.885,18.105),(73.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.465),(73.715,18.635),(73.885,18.635),(73.885,18.465),(73.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.825),(73.715,18.995),(73.885,18.995),(73.885,18.825),(73.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.185),(73.715,19.355),(73.885,19.355),(73.885,19.185),(73.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,2.985),(59.315,3.155),(59.485,3.155),(59.485,2.985),(59.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.345),(59.315,3.515),(59.485,3.515),(59.485,3.345),(59.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.705),(59.315,3.875),(59.485,3.875),(59.485,3.705),(59.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.065),(59.315,4.235),(59.485,4.235),(59.485,4.065),(59.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.425),(59.315,4.595),(59.485,4.595),(59.485,4.425),(59.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.785),(59.315,4.955),(59.485,4.955),(59.485,4.785),(59.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.145),(59.315,5.315),(59.485,5.315),(59.485,5.145),(59.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.505),(59.315,5.675),(59.485,5.675),(59.485,5.505),(59.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.865),(59.315,6.035),(59.485,6.035),(59.485,5.865),(59.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.225),(59.315,6.395),(59.485,6.395),(59.485,6.225),(59.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.585),(59.315,6.755),(59.485,6.755),(59.485,6.585),(59.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.945),(59.315,7.115),(59.485,7.115),(59.485,6.945),(59.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.305),(59.315,7.475),(59.485,7.475),(59.485,7.305),(59.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.665),(59.315,7.835),(59.485,7.835),(59.485,7.665),(59.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.385),(59.315,8.555),(59.485,8.555),(59.485,8.385),(59.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.745),(59.315,8.915),(59.485,8.915),(59.485,8.745),(59.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.105),(59.315,9.275),(59.485,9.275),(59.485,9.105),(59.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.465),(59.315,9.635),(59.485,9.635),(59.485,9.465),(59.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.825),(59.315,9.995),(59.485,9.995),(59.485,9.825),(59.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.185),(59.315,10.355),(59.485,10.355),(59.485,10.185),(59.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.545),(59.315,10.715),(59.485,10.715),(59.485,10.545),(59.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.905),(59.315,11.075),(59.485,11.075),(59.485,10.905),(59.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.265),(59.315,11.435),(59.485,11.435),(59.485,11.265),(59.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.625),(59.315,11.795),(59.485,11.795),(59.485,11.625),(59.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.985),(59.315,12.155),(59.485,12.155),(59.485,11.985),(59.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.345),(59.315,12.515),(59.485,12.515),(59.485,12.345),(59.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.705),(59.315,12.875),(59.485,12.875),(59.485,12.705),(59.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.065),(59.315,13.235),(59.485,13.235),(59.485,13.065),(59.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.425),(59.315,13.595),(59.485,13.595),(59.485,13.425),(59.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.785),(59.315,13.955),(59.485,13.955),(59.485,13.785),(59.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.505),(59.315,14.675),(59.485,14.675),(59.485,14.505),(59.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.865),(59.315,15.035),(59.485,15.035),(59.485,14.865),(59.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.225),(59.315,15.395),(59.485,15.395),(59.485,15.225),(59.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.585),(59.315,15.755),(59.485,15.755),(59.485,15.585),(59.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.945),(59.315,16.115),(59.485,16.115),(59.485,15.945),(59.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.305),(59.315,16.475),(59.485,16.475),(59.485,16.305),(59.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.665),(59.315,16.835),(59.485,16.835),(59.485,16.665),(59.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.025),(59.315,17.195),(59.485,17.195),(59.485,17.025),(59.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.385),(59.315,17.555),(59.485,17.555),(59.485,17.385),(59.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.745),(59.315,17.915),(59.485,17.915),(59.485,17.745),(59.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.105),(59.315,18.275),(59.485,18.275),(59.485,18.105),(59.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.465),(59.315,18.635),(59.485,18.635),(59.485,18.465),(59.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.825),(59.315,18.995),(59.485,18.995),(59.485,18.825),(59.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.185),(59.315,19.355),(59.485,19.355),(59.485,19.185),(59.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,2.985),(25.715,3.155),(25.885,3.155),(25.885,2.985),(25.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.345),(25.715,3.515),(25.885,3.515),(25.885,3.345),(25.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.705),(25.715,3.875),(25.885,3.875),(25.885,3.705),(25.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.065),(25.715,4.235),(25.885,4.235),(25.885,4.065),(25.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.425),(25.715,4.595),(25.885,4.595),(25.885,4.425),(25.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.785),(25.715,4.955),(25.885,4.955),(25.885,4.785),(25.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.145),(25.715,5.315),(25.885,5.315),(25.885,5.145),(25.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.505),(25.715,5.675),(25.885,5.675),(25.885,5.505),(25.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.865),(25.715,6.035),(25.885,6.035),(25.885,5.865),(25.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.225),(25.715,6.395),(25.885,6.395),(25.885,6.225),(25.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.585),(25.715,6.755),(25.885,6.755),(25.885,6.585),(25.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.945),(25.715,7.115),(25.885,7.115),(25.885,6.945),(25.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.305),(25.715,7.475),(25.885,7.475),(25.885,7.305),(25.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.665),(25.715,7.835),(25.885,7.835),(25.885,7.665),(25.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.025),(25.715,8.195),(25.885,8.195),(25.885,8.025),(25.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.385),(25.715,8.555),(25.885,8.555),(25.885,8.385),(25.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.745),(25.715,8.915),(25.885,8.915),(25.885,8.745),(25.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.105),(25.715,9.275),(25.885,9.275),(25.885,9.105),(25.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.465),(25.715,9.635),(25.885,9.635),(25.885,9.465),(25.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.825),(25.715,9.995),(25.885,9.995),(25.885,9.825),(25.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.185),(25.715,10.355),(25.885,10.355),(25.885,10.185),(25.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.545),(25.715,10.715),(25.885,10.715),(25.885,10.545),(25.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.905),(25.715,11.075),(25.885,11.075),(25.885,10.905),(25.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.265),(25.715,11.435),(25.885,11.435),(25.885,11.265),(25.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.625),(25.715,11.795),(25.885,11.795),(25.885,11.625),(25.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.985),(25.715,12.155),(25.885,12.155),(25.885,11.985),(25.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.345),(25.715,12.515),(25.885,12.515),(25.885,12.345),(25.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.705),(25.715,12.875),(25.885,12.875),(25.885,12.705),(25.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.065),(25.715,13.235),(25.885,13.235),(25.885,13.065),(25.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.425),(25.715,13.595),(25.885,13.595),(25.885,13.425),(25.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.785),(25.715,13.955),(25.885,13.955),(25.885,13.785),(25.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.145),(25.715,14.315),(25.885,14.315),(25.885,14.145),(25.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.505),(25.715,14.675),(25.885,14.675),(25.885,14.505),(25.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.865),(25.715,15.035),(25.885,15.035),(25.885,14.865),(25.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.225),(25.715,15.395),(25.885,15.395),(25.885,15.225),(25.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.585),(25.715,15.755),(25.885,15.755),(25.885,15.585),(25.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.945),(25.715,16.115),(25.885,16.115),(25.885,15.945),(25.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.305),(25.715,16.475),(25.885,16.475),(25.885,16.305),(25.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.665),(25.715,16.835),(25.885,16.835),(25.885,16.665),(25.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.025),(25.715,17.195),(25.885,17.195),(25.885,17.025),(25.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.385),(25.715,17.555),(25.885,17.555),(25.885,17.385),(25.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.745),(25.715,17.915),(25.885,17.915),(25.885,17.745),(25.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.105),(25.715,18.275),(25.885,18.275),(25.885,18.105),(25.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.465),(25.715,18.635),(25.885,18.635),(25.885,18.465),(25.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.825),(25.715,18.995),(25.885,18.995),(25.885,18.825),(25.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.185),(25.715,19.355),(25.885,19.355),(25.885,19.185),(25.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,2.985),(83.06,3.155),(83.23,3.155),(83.23,2.985),(83.06,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.345),(83.06,3.515),(83.23,3.515),(83.23,3.345),(83.06,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.705),(83.06,3.875),(83.23,3.875),(83.23,3.705),(83.06,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.065),(83.06,4.235),(83.23,4.235),(83.23,4.065),(83.06,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.425),(83.06,4.595),(83.23,4.595),(83.23,4.425),(83.06,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.785),(83.06,4.955),(83.23,4.955),(83.23,4.785),(83.06,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.145),(83.06,5.315),(83.23,5.315),(83.23,5.145),(83.06,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.505),(83.06,5.675),(83.23,5.675),(83.23,5.505),(83.06,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.865),(83.06,6.035),(83.23,6.035),(83.23,5.865),(83.06,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.225),(83.06,6.395),(83.23,6.395),(83.23,6.225),(83.06,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.585),(83.06,6.755),(83.23,6.755),(83.23,6.585),(83.06,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.945),(83.06,7.115),(83.23,7.115),(83.23,6.945),(83.06,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.305),(83.06,7.475),(83.23,7.475),(83.23,7.305),(83.06,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.665),(83.06,7.835),(83.23,7.835),(83.23,7.665),(83.06,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.025),(83.06,8.195),(83.23,8.195),(83.23,8.025),(83.06,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.385),(83.06,8.555),(83.23,8.555),(83.23,8.385),(83.06,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.745),(83.06,8.915),(83.23,8.915),(83.23,8.745),(83.06,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.105),(83.06,9.275),(83.23,9.275),(83.23,9.105),(83.06,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.465),(83.06,9.635),(83.23,9.635),(83.23,9.465),(83.06,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.825),(83.06,9.995),(83.23,9.995),(83.23,9.825),(83.06,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.185),(83.06,10.355),(83.23,10.355),(83.23,10.185),(83.06,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.545),(83.06,10.715),(83.23,10.715),(83.23,10.545),(83.06,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.905),(83.06,11.075),(83.23,11.075),(83.23,10.905),(83.06,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.265),(83.06,11.435),(83.23,11.435),(83.23,11.265),(83.06,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.625),(83.06,11.795),(83.23,11.795),(83.23,11.625),(83.06,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.985),(83.06,12.155),(83.23,12.155),(83.23,11.985),(83.06,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.345),(83.06,12.515),(83.23,12.515),(83.23,12.345),(83.06,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.705),(83.06,12.875),(83.23,12.875),(83.23,12.705),(83.06,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.065),(83.06,13.235),(83.23,13.235),(83.23,13.065),(83.06,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.425),(83.06,13.595),(83.23,13.595),(83.23,13.425),(83.06,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.785),(83.06,13.955),(83.23,13.955),(83.23,13.785),(83.06,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.145),(83.06,14.315),(83.23,14.315),(83.23,14.145),(83.06,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.505),(83.06,14.675),(83.23,14.675),(83.23,14.505),(83.06,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.865),(83.06,15.035),(83.23,15.035),(83.23,14.865),(83.06,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.225),(83.06,15.395),(83.23,15.395),(83.23,15.225),(83.06,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.585),(83.06,15.755),(83.23,15.755),(83.23,15.585),(83.06,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.945),(83.06,16.115),(83.23,16.115),(83.23,15.945),(83.06,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.305),(83.06,16.475),(83.23,16.475),(83.23,16.305),(83.06,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.665),(83.06,16.835),(83.23,16.835),(83.23,16.665),(83.06,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.025),(83.06,17.195),(83.23,17.195),(83.23,17.025),(83.06,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.385),(83.06,17.555),(83.23,17.555),(83.23,17.385),(83.06,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.745),(83.06,17.915),(83.23,17.915),(83.23,17.745),(83.06,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.105),(83.06,18.275),(83.23,18.275),(83.23,18.105),(83.06,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.465),(83.06,18.635),(83.23,18.635),(83.23,18.465),(83.06,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.825),(83.06,18.995),(83.23,18.995),(83.23,18.825),(83.06,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.185),(83.06,19.355),(83.23,19.355),(83.23,19.185),(83.06,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.435),(6.77,20.605),(6.94,20.605),(6.94,20.435),(6.77,20.435)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,2.925),(59.285,19.415),(59.515,19.415),(59.515,2.925),(59.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,2.925),(16.085,19.415),(16.315,19.415),(16.315,2.925),(16.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,1.675),(40.085,1.965),(40.315,1.965),(40.315,1.675),(40.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,20.375),(44.885,20.665),(45.115,20.665),(45.115,20.375),(44.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,2.925),(78.485,19.415),(78.715,19.415),(78.715,2.925),(78.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,0.0),(49.685,22.34),(49.915,22.34),(49.915,0.0),(49.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,0.0),(44.885,22.34),(45.115,22.34),(45.115,0.0),(44.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,22.34),(45.13,22.34),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,22.34),(49.93,22.34),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,2.925),(54.485,19.415),(54.715,19.415),(54.715,2.925),(54.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,20.375),(78.485,20.665),(78.715,20.665),(78.715,20.375),(78.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,20.375),(83.03,20.665),(83.26,20.665),(83.26,20.375),(83.03,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,20.375),(11.285,20.665),(11.515,20.665),(11.515,20.375),(11.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,2.925),(83.03,19.415),(83.26,19.415),(83.26,2.925),(83.03,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,20.375),(68.885,20.665),(69.115,20.665),(69.115,20.375),(68.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,1.675),(64.085,1.965),(64.315,1.965),(64.315,1.675),(64.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,2.925),(44.885,19.415),(45.115,19.415),(45.115,2.925),(44.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,0.0),(68.885,22.34),(69.115,22.34),(69.115,0.0),(68.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.13),(68.87,22.21),(69.13,22.21),(69.13,0.13),(68.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.0),(68.87,22.34),(69.13,22.34),(69.13,0.0),(68.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,20.375),(20.885,20.665),(21.115,20.665),(21.115,20.375),(20.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,20.375),(30.485,20.665),(30.715,20.665),(30.715,20.375),(30.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,10.73),(85.55,11.02),(86.14,11.02),(86.14,10.73),(85.55,10.73)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.13),(83.015,22.21),(83.275,22.21),(83.275,0.13),(83.015,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,0.0),(11.285,22.34),(11.515,22.34),(11.515,0.0),(11.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.0),(83.015,22.34),(83.275,22.34),(83.275,0.0),(83.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,0.0),(83.03,22.34),(83.26,22.34),(83.26,0.0),(83.03,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.13),(11.27,22.21),(11.53,22.21),(11.53,0.13),(11.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.0),(11.27,22.34),(11.53,22.34),(11.53,0.0),(11.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,20.375),(54.485,20.665),(54.715,20.665),(54.715,20.375),(54.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,20.375),(64.085,20.665),(64.315,20.665),(64.315,20.375),(64.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,0.0),(20.885,22.34),(21.115,22.34),(21.115,0.0),(20.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.13),(20.87,22.21),(21.13,22.21),(21.13,0.13),(20.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.0),(20.87,22.34),(21.13,22.34),(21.13,0.0),(20.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,11.02),(86.14,11.02),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,0.0),(54.485,22.34),(54.715,22.34),(54.715,0.0),(54.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,22.34),(54.73,22.34),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,1.675),(16.085,1.965),(16.315,1.965),(16.315,1.675),(16.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,2.925),(30.485,19.415),(30.715,19.415),(30.715,2.925),(30.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,1.675),(73.685,1.965),(73.915,1.965),(73.915,1.675),(73.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,2.925),(11.285,19.415),(11.515,19.415),(11.515,2.925),(11.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,1.675),(35.285,1.965),(35.515,1.965),(35.515,1.675),(35.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,0.0),(64.085,22.34),(64.315,22.34),(64.315,0.0),(64.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.13),(64.07,22.21),(64.33,22.21),(64.33,0.13),(64.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.0),(64.07,22.34),(64.33,22.34),(64.33,0.0),(64.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,1.675),(25.685,1.965),(25.915,1.965),(25.915,1.675),(25.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,0.0),(78.485,22.34),(78.715,22.34),(78.715,0.0),(78.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.0),(78.47,22.34),(78.73,22.34),(78.73,0.0),(78.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.13),(78.47,22.21),(78.73,22.21),(78.73,0.13),(78.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,2.925),(20.885,19.415),(21.115,19.415),(21.115,2.925),(20.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,20.375),(73.685,20.665),(73.915,20.665),(73.915,20.375),(73.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,2.925),(25.685,19.415),(25.915,19.415),(25.915,2.925),(25.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,2.925),(6.74,19.415),(6.97,19.415),(6.97,2.925),(6.74,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,1.675),(20.885,1.965),(21.115,1.965),(21.115,1.675),(20.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,1.675),(78.485,1.965),(78.715,1.965),(78.715,1.675),(78.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,1.675),(59.285,1.965),(59.515,1.965),(59.515,1.675),(59.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,20.375),(25.685,20.665),(25.915,20.665),(25.915,20.375),(25.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,20.375),(35.285,20.665),(35.515,20.665),(35.515,20.375),(35.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,1.675),(54.485,1.965),(54.715,1.965),(54.715,1.675),(54.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,20.375),(49.685,20.665),(49.915,20.665),(49.915,20.375),(49.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,0.0),(30.485,22.34),(30.715,22.34),(30.715,0.0),(30.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.13),(30.47,22.21),(30.73,22.21),(30.73,0.13),(30.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.0),(30.47,22.34),(30.73,22.34),(30.73,0.0),(30.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,1.965),(86.14,1.965),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,1.675),(83.03,1.965),(83.26,1.965),(83.26,1.675),(83.03,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,1.675),(11.285,1.965),(11.515,1.965),(11.515,1.675),(11.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,1.675),(6.74,1.965),(6.97,1.965),(6.97,1.675),(6.74,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.13),(73.67,22.21),(73.93,22.21),(73.93,0.13),(73.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.0),(73.67,22.34),(73.93,22.34),(73.93,0.0),(73.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,0.0),(73.685,22.34),(73.915,22.34),(73.915,0.0),(73.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,0.0),(40.085,22.34),(40.315,22.34),(40.315,0.0),(40.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,22.34),(40.33,22.34),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,1.675),(44.885,1.965),(45.115,1.965),(45.115,1.675),(44.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,20.375),(16.085,20.665),(16.315,20.665),(16.315,20.375),(16.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,2.925),(68.885,19.415),(69.115,19.415),(69.115,2.925),(68.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,20.375),(59.285,20.665),(59.515,20.665),(59.515,20.375),(59.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,0.0),(25.685,22.34),(25.915,22.34),(25.915,0.0),(25.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.13),(25.67,22.21),(25.93,22.21),(25.93,0.13),(25.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.0),(25.67,22.34),(25.93,22.34),(25.93,0.0),(25.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,2.925),(73.685,19.415),(73.915,19.415),(73.915,2.925),(73.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,20.375),(6.74,20.665),(6.97,20.665),(6.97,20.375),(6.74,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,0.0),(35.285,22.34),(35.515,22.34),(35.515,0.0),(35.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,22.34),(35.53,22.34),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,1.675),(68.885,1.965),(69.115,1.965),(69.115,1.675),(68.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,1.675),(49.685,1.965),(49.915,1.965),(49.915,1.675),(49.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,0.0),(6.74,22.34),(6.97,22.34),(6.97,0.0),(6.74,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.13),(6.725,22.21),(6.985,22.21),(6.985,0.13),(6.725,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.0),(6.725,22.34),(6.985,22.34),(6.985,0.0),(6.725,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,0.0),(16.085,22.34),(16.315,22.34),(16.315,0.0),(16.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.13),(16.07,22.21),(16.33,22.21),(16.33,0.13),(16.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.0),(16.07,22.34),(16.33,22.34),(16.33,0.0),(16.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,2.925),(40.085,19.415),(40.315,19.415),(40.315,2.925),(40.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,20.375),(40.085,20.665),(40.315,20.665),(40.315,20.375),(40.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,0.0),(59.285,22.34),(59.515,22.34),(59.515,0.0),(59.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.13),(59.27,22.21),(59.53,22.21),(59.53,0.13),(59.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.0),(59.27,22.34),(59.53,22.34),(59.53,0.0),(59.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,2.925),(35.285,19.415),(35.515,19.415),(35.515,2.925),(35.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,2.925),(64.085,19.415),(64.315,19.415),(64.315,2.925),(64.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,2.925),(49.685,19.415),(49.915,19.415),(49.915,2.925),(49.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,1.675),(30.485,1.965),(30.715,1.965),(30.715,1.675),(30.485,1.675)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.215),(68.925,0.365),(69.075,0.365),(69.075,0.215),(68.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.535),(68.925,0.685),(69.075,0.685),(69.075,0.535),(68.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.855),(68.925,1.005),(69.075,1.005),(69.075,0.855),(68.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.175),(68.925,1.325),(69.075,1.325),(69.075,1.175),(68.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.495),(68.925,1.645),(69.075,1.645),(69.075,1.495),(68.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.815),(68.925,1.965),(69.075,1.965),(69.075,1.815),(68.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.135),(68.925,2.285),(69.075,2.285),(69.075,2.135),(68.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.455),(68.925,2.605),(69.075,2.605),(69.075,2.455),(68.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.775),(68.925,2.925),(69.075,2.925),(69.075,2.775),(68.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.095),(68.925,3.245),(69.075,3.245),(69.075,3.095),(68.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.415),(68.925,3.565),(69.075,3.565),(69.075,3.415),(68.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.735),(68.925,3.885),(69.075,3.885),(69.075,3.735),(68.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.055),(68.925,4.205),(69.075,4.205),(69.075,4.055),(68.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.375),(68.925,4.525),(69.075,4.525),(69.075,4.375),(68.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.695),(68.925,4.845),(69.075,4.845),(69.075,4.695),(68.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.015),(68.925,5.165),(69.075,5.165),(69.075,5.015),(68.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.335),(68.925,5.485),(69.075,5.485),(69.075,5.335),(68.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.655),(68.925,5.805),(69.075,5.805),(69.075,5.655),(68.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.975),(68.925,6.125),(69.075,6.125),(69.075,5.975),(68.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.295),(68.925,6.445),(69.075,6.445),(69.075,6.295),(68.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.615),(68.925,6.765),(69.075,6.765),(69.075,6.615),(68.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.935),(68.925,7.085),(69.075,7.085),(69.075,6.935),(68.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.255),(68.925,7.405),(69.075,7.405),(69.075,7.255),(68.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.575),(68.925,7.725),(69.075,7.725),(69.075,7.575),(68.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.895),(68.925,8.045),(69.075,8.045),(69.075,7.895),(68.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.215),(68.925,8.365),(69.075,8.365),(69.075,8.215),(68.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.535),(68.925,8.685),(69.075,8.685),(69.075,8.535),(68.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.855),(68.925,9.005),(69.075,9.005),(69.075,8.855),(68.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.175),(68.925,9.325),(69.075,9.325),(69.075,9.175),(68.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.495),(68.925,9.645),(69.075,9.645),(69.075,9.495),(68.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.815),(68.925,9.965),(69.075,9.965),(69.075,9.815),(68.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.135),(68.925,10.285),(69.075,10.285),(69.075,10.135),(68.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.455),(68.925,10.605),(69.075,10.605),(69.075,10.455),(68.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.775),(68.925,10.925),(69.075,10.925),(69.075,10.775),(68.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.095),(68.925,11.245),(69.075,11.245),(69.075,11.095),(68.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.415),(68.925,11.565),(69.075,11.565),(69.075,11.415),(68.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.735),(68.925,11.885),(69.075,11.885),(69.075,11.735),(68.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.055),(68.925,12.205),(69.075,12.205),(69.075,12.055),(68.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.375),(68.925,12.525),(69.075,12.525),(69.075,12.375),(68.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.695),(68.925,12.845),(69.075,12.845),(69.075,12.695),(68.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.015),(68.925,13.165),(69.075,13.165),(69.075,13.015),(68.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.335),(68.925,13.485),(69.075,13.485),(69.075,13.335),(68.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.655),(68.925,13.805),(69.075,13.805),(69.075,13.655),(68.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.975),(68.925,14.125),(69.075,14.125),(69.075,13.975),(68.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.295),(68.925,14.445),(69.075,14.445),(69.075,14.295),(68.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.615),(68.925,14.765),(69.075,14.765),(69.075,14.615),(68.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.935),(68.925,15.085),(69.075,15.085),(69.075,14.935),(68.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.255),(68.925,15.405),(69.075,15.405),(69.075,15.255),(68.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.575),(68.925,15.725),(69.075,15.725),(69.075,15.575),(68.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.895),(68.925,16.045),(69.075,16.045),(69.075,15.895),(68.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.215),(68.925,16.365),(69.075,16.365),(69.075,16.215),(68.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.535),(68.925,16.685),(69.075,16.685),(69.075,16.535),(68.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.855),(68.925,17.005),(69.075,17.005),(69.075,16.855),(68.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.175),(68.925,17.325),(69.075,17.325),(69.075,17.175),(68.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.495),(68.925,17.645),(69.075,17.645),(69.075,17.495),(68.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.815),(68.925,17.965),(69.075,17.965),(69.075,17.815),(68.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.135),(68.925,18.285),(69.075,18.285),(69.075,18.135),(68.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.455),(68.925,18.605),(69.075,18.605),(69.075,18.455),(68.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.775),(68.925,18.925),(69.075,18.925),(69.075,18.775),(68.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.095),(68.925,19.245),(69.075,19.245),(69.075,19.095),(68.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.415),(68.925,19.565),(69.075,19.565),(69.075,19.415),(68.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.735),(68.925,19.885),(69.075,19.885),(69.075,19.735),(68.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.055),(68.925,20.205),(69.075,20.205),(69.075,20.055),(68.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.375),(68.925,20.525),(69.075,20.525),(69.075,20.375),(68.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.695),(68.925,20.845),(69.075,20.845),(69.075,20.695),(68.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.015),(68.925,21.165),(69.075,21.165),(69.075,21.015),(68.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.335),(68.925,21.485),(69.075,21.485),(69.075,21.335),(68.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.655),(68.925,21.805),(69.075,21.805),(69.075,21.655),(68.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.975),(68.925,22.125),(69.075,22.125),(69.075,21.975),(68.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.215),(6.78,0.365),(6.93,0.365),(6.93,0.215),(6.78,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.535),(6.78,0.685),(6.93,0.685),(6.93,0.535),(6.78,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.855),(6.78,1.005),(6.93,1.005),(6.93,0.855),(6.78,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.175),(6.78,1.325),(6.93,1.325),(6.93,1.175),(6.78,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.495),(6.78,1.645),(6.93,1.645),(6.93,1.495),(6.78,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.815),(6.78,1.965),(6.93,1.965),(6.93,1.815),(6.78,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.135),(6.78,2.285),(6.93,2.285),(6.93,2.135),(6.78,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.455),(6.78,2.605),(6.93,2.605),(6.93,2.455),(6.78,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.775),(6.78,2.925),(6.93,2.925),(6.93,2.775),(6.78,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.095),(6.78,3.245),(6.93,3.245),(6.93,3.095),(6.78,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.415),(6.78,3.565),(6.93,3.565),(6.93,3.415),(6.78,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.735),(6.78,3.885),(6.93,3.885),(6.93,3.735),(6.78,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.055),(6.78,4.205),(6.93,4.205),(6.93,4.055),(6.78,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.375),(6.78,4.525),(6.93,4.525),(6.93,4.375),(6.78,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.695),(6.78,4.845),(6.93,4.845),(6.93,4.695),(6.78,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.015),(6.78,5.165),(6.93,5.165),(6.93,5.015),(6.78,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.335),(6.78,5.485),(6.93,5.485),(6.93,5.335),(6.78,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.655),(6.78,5.805),(6.93,5.805),(6.93,5.655),(6.78,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.975),(6.78,6.125),(6.93,6.125),(6.93,5.975),(6.78,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.295),(6.78,6.445),(6.93,6.445),(6.93,6.295),(6.78,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.615),(6.78,6.765),(6.93,6.765),(6.93,6.615),(6.78,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.935),(6.78,7.085),(6.93,7.085),(6.93,6.935),(6.78,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.255),(6.78,7.405),(6.93,7.405),(6.93,7.255),(6.78,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.575),(6.78,7.725),(6.93,7.725),(6.93,7.575),(6.78,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.895),(6.78,8.045),(6.93,8.045),(6.93,7.895),(6.78,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.215),(6.78,8.365),(6.93,8.365),(6.93,8.215),(6.78,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.535),(6.78,8.685),(6.93,8.685),(6.93,8.535),(6.78,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.855),(6.78,9.005),(6.93,9.005),(6.93,8.855),(6.78,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.175),(6.78,9.325),(6.93,9.325),(6.93,9.175),(6.78,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.495),(6.78,9.645),(6.93,9.645),(6.93,9.495),(6.78,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.815),(6.78,9.965),(6.93,9.965),(6.93,9.815),(6.78,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.135),(6.78,10.285),(6.93,10.285),(6.93,10.135),(6.78,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.455),(6.78,10.605),(6.93,10.605),(6.93,10.455),(6.78,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.775),(6.78,10.925),(6.93,10.925),(6.93,10.775),(6.78,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.095),(6.78,11.245),(6.93,11.245),(6.93,11.095),(6.78,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.415),(6.78,11.565),(6.93,11.565),(6.93,11.415),(6.78,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.735),(6.78,11.885),(6.93,11.885),(6.93,11.735),(6.78,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.055),(6.78,12.205),(6.93,12.205),(6.93,12.055),(6.78,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.375),(6.78,12.525),(6.93,12.525),(6.93,12.375),(6.78,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.695),(6.78,12.845),(6.93,12.845),(6.93,12.695),(6.78,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.015),(6.78,13.165),(6.93,13.165),(6.93,13.015),(6.78,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.335),(6.78,13.485),(6.93,13.485),(6.93,13.335),(6.78,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.655),(6.78,13.805),(6.93,13.805),(6.93,13.655),(6.78,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.975),(6.78,14.125),(6.93,14.125),(6.93,13.975),(6.78,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.295),(6.78,14.445),(6.93,14.445),(6.93,14.295),(6.78,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.615),(6.78,14.765),(6.93,14.765),(6.93,14.615),(6.78,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.935),(6.78,15.085),(6.93,15.085),(6.93,14.935),(6.78,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.255),(6.78,15.405),(6.93,15.405),(6.93,15.255),(6.78,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.575),(6.78,15.725),(6.93,15.725),(6.93,15.575),(6.78,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.895),(6.78,16.045),(6.93,16.045),(6.93,15.895),(6.78,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.215),(6.78,16.365),(6.93,16.365),(6.93,16.215),(6.78,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.535),(6.78,16.685),(6.93,16.685),(6.93,16.535),(6.78,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.855),(6.78,17.005),(6.93,17.005),(6.93,16.855),(6.78,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.175),(6.78,17.325),(6.93,17.325),(6.93,17.175),(6.78,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.495),(6.78,17.645),(6.93,17.645),(6.93,17.495),(6.78,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.815),(6.78,17.965),(6.93,17.965),(6.93,17.815),(6.78,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.135),(6.78,18.285),(6.93,18.285),(6.93,18.135),(6.78,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.455),(6.78,18.605),(6.93,18.605),(6.93,18.455),(6.78,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.775),(6.78,18.925),(6.93,18.925),(6.93,18.775),(6.78,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.095),(6.78,19.245),(6.93,19.245),(6.93,19.095),(6.78,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.415),(6.78,19.565),(6.93,19.565),(6.93,19.415),(6.78,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.735),(6.78,19.885),(6.93,19.885),(6.93,19.735),(6.78,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.055),(6.78,20.205),(6.93,20.205),(6.93,20.055),(6.78,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.375),(6.78,20.525),(6.93,20.525),(6.93,20.375),(6.78,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.695),(6.78,20.845),(6.93,20.845),(6.93,20.695),(6.78,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.015),(6.78,21.165),(6.93,21.165),(6.93,21.015),(6.78,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.335),(6.78,21.485),(6.93,21.485),(6.93,21.335),(6.78,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.655),(6.78,21.805),(6.93,21.805),(6.93,21.655),(6.78,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.975),(6.78,22.125),(6.93,22.125),(6.93,21.975),(6.78,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.215),(35.325,0.365),(35.475,0.365),(35.475,0.215),(35.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.535),(35.325,0.685),(35.475,0.685),(35.475,0.535),(35.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.855),(35.325,1.005),(35.475,1.005),(35.475,0.855),(35.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.175),(35.325,1.325),(35.475,1.325),(35.475,1.175),(35.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.495),(35.325,1.645),(35.475,1.645),(35.475,1.495),(35.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.815),(35.325,1.965),(35.475,1.965),(35.475,1.815),(35.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.135),(35.325,2.285),(35.475,2.285),(35.475,2.135),(35.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.455),(35.325,2.605),(35.475,2.605),(35.475,2.455),(35.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.775),(35.325,2.925),(35.475,2.925),(35.475,2.775),(35.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.095),(35.325,3.245),(35.475,3.245),(35.475,3.095),(35.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.415),(35.325,3.565),(35.475,3.565),(35.475,3.415),(35.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.735),(35.325,3.885),(35.475,3.885),(35.475,3.735),(35.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.055),(35.325,4.205),(35.475,4.205),(35.475,4.055),(35.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.375),(35.325,4.525),(35.475,4.525),(35.475,4.375),(35.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.695),(35.325,4.845),(35.475,4.845),(35.475,4.695),(35.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.015),(35.325,5.165),(35.475,5.165),(35.475,5.015),(35.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.335),(35.325,5.485),(35.475,5.485),(35.475,5.335),(35.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.655),(35.325,5.805),(35.475,5.805),(35.475,5.655),(35.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.975),(35.325,6.125),(35.475,6.125),(35.475,5.975),(35.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.295),(35.325,6.445),(35.475,6.445),(35.475,6.295),(35.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.615),(35.325,6.765),(35.475,6.765),(35.475,6.615),(35.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.935),(35.325,7.085),(35.475,7.085),(35.475,6.935),(35.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.255),(35.325,7.405),(35.475,7.405),(35.475,7.255),(35.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.575),(35.325,7.725),(35.475,7.725),(35.475,7.575),(35.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.895),(35.325,8.045),(35.475,8.045),(35.475,7.895),(35.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.215),(35.325,8.365),(35.475,8.365),(35.475,8.215),(35.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.535),(35.325,8.685),(35.475,8.685),(35.475,8.535),(35.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.855),(35.325,9.005),(35.475,9.005),(35.475,8.855),(35.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.175),(35.325,9.325),(35.475,9.325),(35.475,9.175),(35.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.495),(35.325,9.645),(35.475,9.645),(35.475,9.495),(35.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.815),(35.325,9.965),(35.475,9.965),(35.475,9.815),(35.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.135),(35.325,10.285),(35.475,10.285),(35.475,10.135),(35.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.455),(35.325,10.605),(35.475,10.605),(35.475,10.455),(35.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.775),(35.325,10.925),(35.475,10.925),(35.475,10.775),(35.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.095),(35.325,11.245),(35.475,11.245),(35.475,11.095),(35.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.415),(35.325,11.565),(35.475,11.565),(35.475,11.415),(35.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.735),(35.325,11.885),(35.475,11.885),(35.475,11.735),(35.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.055),(35.325,12.205),(35.475,12.205),(35.475,12.055),(35.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.375),(35.325,12.525),(35.475,12.525),(35.475,12.375),(35.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.695),(35.325,12.845),(35.475,12.845),(35.475,12.695),(35.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.015),(35.325,13.165),(35.475,13.165),(35.475,13.015),(35.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.335),(35.325,13.485),(35.475,13.485),(35.475,13.335),(35.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.655),(35.325,13.805),(35.475,13.805),(35.475,13.655),(35.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.975),(35.325,14.125),(35.475,14.125),(35.475,13.975),(35.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.295),(35.325,14.445),(35.475,14.445),(35.475,14.295),(35.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.615),(35.325,14.765),(35.475,14.765),(35.475,14.615),(35.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.935),(35.325,15.085),(35.475,15.085),(35.475,14.935),(35.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.255),(35.325,15.405),(35.475,15.405),(35.475,15.255),(35.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.575),(35.325,15.725),(35.475,15.725),(35.475,15.575),(35.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.895),(35.325,16.045),(35.475,16.045),(35.475,15.895),(35.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.215),(35.325,16.365),(35.475,16.365),(35.475,16.215),(35.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.535),(35.325,16.685),(35.475,16.685),(35.475,16.535),(35.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.855),(35.325,17.005),(35.475,17.005),(35.475,16.855),(35.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.175),(35.325,17.325),(35.475,17.325),(35.475,17.175),(35.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.495),(35.325,17.645),(35.475,17.645),(35.475,17.495),(35.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.815),(35.325,17.965),(35.475,17.965),(35.475,17.815),(35.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.135),(35.325,18.285),(35.475,18.285),(35.475,18.135),(35.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.455),(35.325,18.605),(35.475,18.605),(35.475,18.455),(35.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.775),(35.325,18.925),(35.475,18.925),(35.475,18.775),(35.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.095),(35.325,19.245),(35.475,19.245),(35.475,19.095),(35.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.415),(35.325,19.565),(35.475,19.565),(35.475,19.415),(35.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.735),(35.325,19.885),(35.475,19.885),(35.475,19.735),(35.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.055),(35.325,20.205),(35.475,20.205),(35.475,20.055),(35.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.375),(35.325,20.525),(35.475,20.525),(35.475,20.375),(35.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.695),(35.325,20.845),(35.475,20.845),(35.475,20.695),(35.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.015),(35.325,21.165),(35.475,21.165),(35.475,21.015),(35.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.335),(35.325,21.485),(35.475,21.485),(35.475,21.335),(35.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.655),(35.325,21.805),(35.475,21.805),(35.475,21.655),(35.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.975),(35.325,22.125),(35.475,22.125),(35.475,21.975),(35.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.215),(49.725,0.365),(49.875,0.365),(49.875,0.215),(49.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.535),(49.725,0.685),(49.875,0.685),(49.875,0.535),(49.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.855),(49.725,1.005),(49.875,1.005),(49.875,0.855),(49.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.175),(49.725,1.325),(49.875,1.325),(49.875,1.175),(49.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.495),(49.725,1.645),(49.875,1.645),(49.875,1.495),(49.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.815),(49.725,1.965),(49.875,1.965),(49.875,1.815),(49.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.135),(49.725,2.285),(49.875,2.285),(49.875,2.135),(49.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.455),(49.725,2.605),(49.875,2.605),(49.875,2.455),(49.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.775),(49.725,2.925),(49.875,2.925),(49.875,2.775),(49.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.095),(49.725,3.245),(49.875,3.245),(49.875,3.095),(49.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.415),(49.725,3.565),(49.875,3.565),(49.875,3.415),(49.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.735),(49.725,3.885),(49.875,3.885),(49.875,3.735),(49.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.055),(49.725,4.205),(49.875,4.205),(49.875,4.055),(49.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.375),(49.725,4.525),(49.875,4.525),(49.875,4.375),(49.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.695),(49.725,4.845),(49.875,4.845),(49.875,4.695),(49.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.015),(49.725,5.165),(49.875,5.165),(49.875,5.015),(49.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.335),(49.725,5.485),(49.875,5.485),(49.875,5.335),(49.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.655),(49.725,5.805),(49.875,5.805),(49.875,5.655),(49.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.975),(49.725,6.125),(49.875,6.125),(49.875,5.975),(49.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.295),(49.725,6.445),(49.875,6.445),(49.875,6.295),(49.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.615),(49.725,6.765),(49.875,6.765),(49.875,6.615),(49.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.935),(49.725,7.085),(49.875,7.085),(49.875,6.935),(49.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.255),(49.725,7.405),(49.875,7.405),(49.875,7.255),(49.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.575),(49.725,7.725),(49.875,7.725),(49.875,7.575),(49.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.895),(49.725,8.045),(49.875,8.045),(49.875,7.895),(49.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.215),(49.725,8.365),(49.875,8.365),(49.875,8.215),(49.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.535),(49.725,8.685),(49.875,8.685),(49.875,8.535),(49.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.855),(49.725,9.005),(49.875,9.005),(49.875,8.855),(49.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.175),(49.725,9.325),(49.875,9.325),(49.875,9.175),(49.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.495),(49.725,9.645),(49.875,9.645),(49.875,9.495),(49.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.815),(49.725,9.965),(49.875,9.965),(49.875,9.815),(49.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.135),(49.725,10.285),(49.875,10.285),(49.875,10.135),(49.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.455),(49.725,10.605),(49.875,10.605),(49.875,10.455),(49.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.775),(49.725,10.925),(49.875,10.925),(49.875,10.775),(49.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.095),(49.725,11.245),(49.875,11.245),(49.875,11.095),(49.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.415),(49.725,11.565),(49.875,11.565),(49.875,11.415),(49.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.735),(49.725,11.885),(49.875,11.885),(49.875,11.735),(49.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.055),(49.725,12.205),(49.875,12.205),(49.875,12.055),(49.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.375),(49.725,12.525),(49.875,12.525),(49.875,12.375),(49.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.695),(49.725,12.845),(49.875,12.845),(49.875,12.695),(49.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.015),(49.725,13.165),(49.875,13.165),(49.875,13.015),(49.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.335),(49.725,13.485),(49.875,13.485),(49.875,13.335),(49.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.655),(49.725,13.805),(49.875,13.805),(49.875,13.655),(49.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.975),(49.725,14.125),(49.875,14.125),(49.875,13.975),(49.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.295),(49.725,14.445),(49.875,14.445),(49.875,14.295),(49.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.615),(49.725,14.765),(49.875,14.765),(49.875,14.615),(49.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.935),(49.725,15.085),(49.875,15.085),(49.875,14.935),(49.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.255),(49.725,15.405),(49.875,15.405),(49.875,15.255),(49.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.575),(49.725,15.725),(49.875,15.725),(49.875,15.575),(49.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.895),(49.725,16.045),(49.875,16.045),(49.875,15.895),(49.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.215),(49.725,16.365),(49.875,16.365),(49.875,16.215),(49.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.535),(49.725,16.685),(49.875,16.685),(49.875,16.535),(49.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.855),(49.725,17.005),(49.875,17.005),(49.875,16.855),(49.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.175),(49.725,17.325),(49.875,17.325),(49.875,17.175),(49.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.495),(49.725,17.645),(49.875,17.645),(49.875,17.495),(49.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.815),(49.725,17.965),(49.875,17.965),(49.875,17.815),(49.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.135),(49.725,18.285),(49.875,18.285),(49.875,18.135),(49.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.455),(49.725,18.605),(49.875,18.605),(49.875,18.455),(49.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.775),(49.725,18.925),(49.875,18.925),(49.875,18.775),(49.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.095),(49.725,19.245),(49.875,19.245),(49.875,19.095),(49.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.415),(49.725,19.565),(49.875,19.565),(49.875,19.415),(49.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.735),(49.725,19.885),(49.875,19.885),(49.875,19.735),(49.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.055),(49.725,20.205),(49.875,20.205),(49.875,20.055),(49.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.375),(49.725,20.525),(49.875,20.525),(49.875,20.375),(49.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.695),(49.725,20.845),(49.875,20.845),(49.875,20.695),(49.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.015),(49.725,21.165),(49.875,21.165),(49.875,21.015),(49.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.335),(49.725,21.485),(49.875,21.485),(49.875,21.335),(49.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.655),(49.725,21.805),(49.875,21.805),(49.875,21.655),(49.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.975),(49.725,22.125),(49.875,22.125),(49.875,21.975),(49.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.215),(59.325,0.365),(59.475,0.365),(59.475,0.215),(59.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.535),(59.325,0.685),(59.475,0.685),(59.475,0.535),(59.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.855),(59.325,1.005),(59.475,1.005),(59.475,0.855),(59.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.175),(59.325,1.325),(59.475,1.325),(59.475,1.175),(59.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.495),(59.325,1.645),(59.475,1.645),(59.475,1.495),(59.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.815),(59.325,1.965),(59.475,1.965),(59.475,1.815),(59.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.135),(59.325,2.285),(59.475,2.285),(59.475,2.135),(59.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.455),(59.325,2.605),(59.475,2.605),(59.475,2.455),(59.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.775),(59.325,2.925),(59.475,2.925),(59.475,2.775),(59.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.095),(59.325,3.245),(59.475,3.245),(59.475,3.095),(59.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.415),(59.325,3.565),(59.475,3.565),(59.475,3.415),(59.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.735),(59.325,3.885),(59.475,3.885),(59.475,3.735),(59.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.055),(59.325,4.205),(59.475,4.205),(59.475,4.055),(59.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.375),(59.325,4.525),(59.475,4.525),(59.475,4.375),(59.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.695),(59.325,4.845),(59.475,4.845),(59.475,4.695),(59.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.015),(59.325,5.165),(59.475,5.165),(59.475,5.015),(59.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.335),(59.325,5.485),(59.475,5.485),(59.475,5.335),(59.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.655),(59.325,5.805),(59.475,5.805),(59.475,5.655),(59.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.975),(59.325,6.125),(59.475,6.125),(59.475,5.975),(59.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.295),(59.325,6.445),(59.475,6.445),(59.475,6.295),(59.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.615),(59.325,6.765),(59.475,6.765),(59.475,6.615),(59.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.935),(59.325,7.085),(59.475,7.085),(59.475,6.935),(59.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.255),(59.325,7.405),(59.475,7.405),(59.475,7.255),(59.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.575),(59.325,7.725),(59.475,7.725),(59.475,7.575),(59.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.895),(59.325,8.045),(59.475,8.045),(59.475,7.895),(59.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.215),(59.325,8.365),(59.475,8.365),(59.475,8.215),(59.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.535),(59.325,8.685),(59.475,8.685),(59.475,8.535),(59.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.855),(59.325,9.005),(59.475,9.005),(59.475,8.855),(59.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.175),(59.325,9.325),(59.475,9.325),(59.475,9.175),(59.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.495),(59.325,9.645),(59.475,9.645),(59.475,9.495),(59.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.815),(59.325,9.965),(59.475,9.965),(59.475,9.815),(59.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.135),(59.325,10.285),(59.475,10.285),(59.475,10.135),(59.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.455),(59.325,10.605),(59.475,10.605),(59.475,10.455),(59.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.775),(59.325,10.925),(59.475,10.925),(59.475,10.775),(59.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.095),(59.325,11.245),(59.475,11.245),(59.475,11.095),(59.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.415),(59.325,11.565),(59.475,11.565),(59.475,11.415),(59.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.735),(59.325,11.885),(59.475,11.885),(59.475,11.735),(59.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.055),(59.325,12.205),(59.475,12.205),(59.475,12.055),(59.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.375),(59.325,12.525),(59.475,12.525),(59.475,12.375),(59.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.695),(59.325,12.845),(59.475,12.845),(59.475,12.695),(59.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.015),(59.325,13.165),(59.475,13.165),(59.475,13.015),(59.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.335),(59.325,13.485),(59.475,13.485),(59.475,13.335),(59.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.655),(59.325,13.805),(59.475,13.805),(59.475,13.655),(59.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.975),(59.325,14.125),(59.475,14.125),(59.475,13.975),(59.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.295),(59.325,14.445),(59.475,14.445),(59.475,14.295),(59.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.615),(59.325,14.765),(59.475,14.765),(59.475,14.615),(59.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.935),(59.325,15.085),(59.475,15.085),(59.475,14.935),(59.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.255),(59.325,15.405),(59.475,15.405),(59.475,15.255),(59.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.575),(59.325,15.725),(59.475,15.725),(59.475,15.575),(59.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.895),(59.325,16.045),(59.475,16.045),(59.475,15.895),(59.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.215),(59.325,16.365),(59.475,16.365),(59.475,16.215),(59.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.535),(59.325,16.685),(59.475,16.685),(59.475,16.535),(59.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.855),(59.325,17.005),(59.475,17.005),(59.475,16.855),(59.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.175),(59.325,17.325),(59.475,17.325),(59.475,17.175),(59.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.495),(59.325,17.645),(59.475,17.645),(59.475,17.495),(59.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.815),(59.325,17.965),(59.475,17.965),(59.475,17.815),(59.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.135),(59.325,18.285),(59.475,18.285),(59.475,18.135),(59.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.455),(59.325,18.605),(59.475,18.605),(59.475,18.455),(59.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.775),(59.325,18.925),(59.475,18.925),(59.475,18.775),(59.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.095),(59.325,19.245),(59.475,19.245),(59.475,19.095),(59.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.415),(59.325,19.565),(59.475,19.565),(59.475,19.415),(59.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.735),(59.325,19.885),(59.475,19.885),(59.475,19.735),(59.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.055),(59.325,20.205),(59.475,20.205),(59.475,20.055),(59.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.375),(59.325,20.525),(59.475,20.525),(59.475,20.375),(59.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.695),(59.325,20.845),(59.475,20.845),(59.475,20.695),(59.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.015),(59.325,21.165),(59.475,21.165),(59.475,21.015),(59.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.335),(59.325,21.485),(59.475,21.485),(59.475,21.335),(59.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.655),(59.325,21.805),(59.475,21.805),(59.475,21.655),(59.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.975),(59.325,22.125),(59.475,22.125),(59.475,21.975),(59.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.215),(83.07,0.365),(83.22,0.365),(83.22,0.215),(83.07,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.535),(83.07,0.685),(83.22,0.685),(83.22,0.535),(83.07,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.855),(83.07,1.005),(83.22,1.005),(83.22,0.855),(83.07,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.175),(83.07,1.325),(83.22,1.325),(83.22,1.175),(83.07,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.495),(83.07,1.645),(83.22,1.645),(83.22,1.495),(83.07,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.815),(83.07,1.965),(83.22,1.965),(83.22,1.815),(83.07,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.135),(83.07,2.285),(83.22,2.285),(83.22,2.135),(83.07,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.455),(83.07,2.605),(83.22,2.605),(83.22,2.455),(83.07,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.775),(83.07,2.925),(83.22,2.925),(83.22,2.775),(83.07,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.095),(83.07,3.245),(83.22,3.245),(83.22,3.095),(83.07,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.415),(83.07,3.565),(83.22,3.565),(83.22,3.415),(83.07,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.735),(83.07,3.885),(83.22,3.885),(83.22,3.735),(83.07,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.055),(83.07,4.205),(83.22,4.205),(83.22,4.055),(83.07,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.375),(83.07,4.525),(83.22,4.525),(83.22,4.375),(83.07,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.695),(83.07,4.845),(83.22,4.845),(83.22,4.695),(83.07,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.015),(83.07,5.165),(83.22,5.165),(83.22,5.015),(83.07,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.335),(83.07,5.485),(83.22,5.485),(83.22,5.335),(83.07,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.655),(83.07,5.805),(83.22,5.805),(83.22,5.655),(83.07,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.975),(83.07,6.125),(83.22,6.125),(83.22,5.975),(83.07,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.295),(83.07,6.445),(83.22,6.445),(83.22,6.295),(83.07,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.615),(83.07,6.765),(83.22,6.765),(83.22,6.615),(83.07,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.935),(83.07,7.085),(83.22,7.085),(83.22,6.935),(83.07,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.255),(83.07,7.405),(83.22,7.405),(83.22,7.255),(83.07,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.575),(83.07,7.725),(83.22,7.725),(83.22,7.575),(83.07,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.895),(83.07,8.045),(83.22,8.045),(83.22,7.895),(83.07,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.215),(83.07,8.365),(83.22,8.365),(83.22,8.215),(83.07,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.535),(83.07,8.685),(83.22,8.685),(83.22,8.535),(83.07,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.855),(83.07,9.005),(83.22,9.005),(83.22,8.855),(83.07,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.175),(83.07,9.325),(83.22,9.325),(83.22,9.175),(83.07,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.495),(83.07,9.645),(83.22,9.645),(83.22,9.495),(83.07,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.815),(83.07,9.965),(83.22,9.965),(83.22,9.815),(83.07,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.135),(83.07,10.285),(83.22,10.285),(83.22,10.135),(83.07,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.455),(83.07,10.605),(83.22,10.605),(83.22,10.455),(83.07,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.775),(83.07,10.925),(83.22,10.925),(83.22,10.775),(83.07,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.095),(83.07,11.245),(83.22,11.245),(83.22,11.095),(83.07,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.415),(83.07,11.565),(83.22,11.565),(83.22,11.415),(83.07,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.735),(83.07,11.885),(83.22,11.885),(83.22,11.735),(83.07,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.055),(83.07,12.205),(83.22,12.205),(83.22,12.055),(83.07,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.375),(83.07,12.525),(83.22,12.525),(83.22,12.375),(83.07,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.695),(83.07,12.845),(83.22,12.845),(83.22,12.695),(83.07,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.015),(83.07,13.165),(83.22,13.165),(83.22,13.015),(83.07,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.335),(83.07,13.485),(83.22,13.485),(83.22,13.335),(83.07,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.655),(83.07,13.805),(83.22,13.805),(83.22,13.655),(83.07,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.975),(83.07,14.125),(83.22,14.125),(83.22,13.975),(83.07,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.295),(83.07,14.445),(83.22,14.445),(83.22,14.295),(83.07,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.615),(83.07,14.765),(83.22,14.765),(83.22,14.615),(83.07,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.935),(83.07,15.085),(83.22,15.085),(83.22,14.935),(83.07,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.255),(83.07,15.405),(83.22,15.405),(83.22,15.255),(83.07,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.575),(83.07,15.725),(83.22,15.725),(83.22,15.575),(83.07,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.895),(83.07,16.045),(83.22,16.045),(83.22,15.895),(83.07,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.215),(83.07,16.365),(83.22,16.365),(83.22,16.215),(83.07,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.535),(83.07,16.685),(83.22,16.685),(83.22,16.535),(83.07,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.855),(83.07,17.005),(83.22,17.005),(83.22,16.855),(83.07,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.175),(83.07,17.325),(83.22,17.325),(83.22,17.175),(83.07,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.495),(83.07,17.645),(83.22,17.645),(83.22,17.495),(83.07,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.815),(83.07,17.965),(83.22,17.965),(83.22,17.815),(83.07,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.135),(83.07,18.285),(83.22,18.285),(83.22,18.135),(83.07,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.455),(83.07,18.605),(83.22,18.605),(83.22,18.455),(83.07,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.775),(83.07,18.925),(83.22,18.925),(83.22,18.775),(83.07,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.095),(83.07,19.245),(83.22,19.245),(83.22,19.095),(83.07,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.415),(83.07,19.565),(83.22,19.565),(83.22,19.415),(83.07,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.735),(83.07,19.885),(83.22,19.885),(83.22,19.735),(83.07,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.055),(83.07,20.205),(83.22,20.205),(83.22,20.055),(83.07,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.375),(83.07,20.525),(83.22,20.525),(83.22,20.375),(83.07,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.695),(83.07,20.845),(83.22,20.845),(83.22,20.695),(83.07,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.015),(83.07,21.165),(83.22,21.165),(83.22,21.015),(83.07,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.335),(83.07,21.485),(83.22,21.485),(83.22,21.335),(83.07,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.655),(83.07,21.805),(83.22,21.805),(83.22,21.655),(83.07,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.975),(83.07,22.125),(83.22,22.125),(83.22,21.975),(83.07,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.215),(40.125,0.365),(40.275,0.365),(40.275,0.215),(40.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.535),(40.125,0.685),(40.275,0.685),(40.275,0.535),(40.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.855),(40.125,1.005),(40.275,1.005),(40.275,0.855),(40.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.175),(40.125,1.325),(40.275,1.325),(40.275,1.175),(40.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.495),(40.125,1.645),(40.275,1.645),(40.275,1.495),(40.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.815),(40.125,1.965),(40.275,1.965),(40.275,1.815),(40.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.135),(40.125,2.285),(40.275,2.285),(40.275,2.135),(40.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.455),(40.125,2.605),(40.275,2.605),(40.275,2.455),(40.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.775),(40.125,2.925),(40.275,2.925),(40.275,2.775),(40.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.095),(40.125,3.245),(40.275,3.245),(40.275,3.095),(40.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.415),(40.125,3.565),(40.275,3.565),(40.275,3.415),(40.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.735),(40.125,3.885),(40.275,3.885),(40.275,3.735),(40.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.055),(40.125,4.205),(40.275,4.205),(40.275,4.055),(40.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.375),(40.125,4.525),(40.275,4.525),(40.275,4.375),(40.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.695),(40.125,4.845),(40.275,4.845),(40.275,4.695),(40.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.015),(40.125,5.165),(40.275,5.165),(40.275,5.015),(40.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.335),(40.125,5.485),(40.275,5.485),(40.275,5.335),(40.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.655),(40.125,5.805),(40.275,5.805),(40.275,5.655),(40.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.975),(40.125,6.125),(40.275,6.125),(40.275,5.975),(40.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.295),(40.125,6.445),(40.275,6.445),(40.275,6.295),(40.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.615),(40.125,6.765),(40.275,6.765),(40.275,6.615),(40.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.935),(40.125,7.085),(40.275,7.085),(40.275,6.935),(40.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.255),(40.125,7.405),(40.275,7.405),(40.275,7.255),(40.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.575),(40.125,7.725),(40.275,7.725),(40.275,7.575),(40.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.895),(40.125,8.045),(40.275,8.045),(40.275,7.895),(40.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.215),(40.125,8.365),(40.275,8.365),(40.275,8.215),(40.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.535),(40.125,8.685),(40.275,8.685),(40.275,8.535),(40.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.855),(40.125,9.005),(40.275,9.005),(40.275,8.855),(40.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.175),(40.125,9.325),(40.275,9.325),(40.275,9.175),(40.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.495),(40.125,9.645),(40.275,9.645),(40.275,9.495),(40.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.815),(40.125,9.965),(40.275,9.965),(40.275,9.815),(40.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.135),(40.125,10.285),(40.275,10.285),(40.275,10.135),(40.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.455),(40.125,10.605),(40.275,10.605),(40.275,10.455),(40.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.775),(40.125,10.925),(40.275,10.925),(40.275,10.775),(40.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.095),(40.125,11.245),(40.275,11.245),(40.275,11.095),(40.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.415),(40.125,11.565),(40.275,11.565),(40.275,11.415),(40.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.735),(40.125,11.885),(40.275,11.885),(40.275,11.735),(40.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.055),(40.125,12.205),(40.275,12.205),(40.275,12.055),(40.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.375),(40.125,12.525),(40.275,12.525),(40.275,12.375),(40.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.695),(40.125,12.845),(40.275,12.845),(40.275,12.695),(40.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.015),(40.125,13.165),(40.275,13.165),(40.275,13.015),(40.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.335),(40.125,13.485),(40.275,13.485),(40.275,13.335),(40.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.655),(40.125,13.805),(40.275,13.805),(40.275,13.655),(40.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.975),(40.125,14.125),(40.275,14.125),(40.275,13.975),(40.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.295),(40.125,14.445),(40.275,14.445),(40.275,14.295),(40.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.615),(40.125,14.765),(40.275,14.765),(40.275,14.615),(40.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.935),(40.125,15.085),(40.275,15.085),(40.275,14.935),(40.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.255),(40.125,15.405),(40.275,15.405),(40.275,15.255),(40.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.575),(40.125,15.725),(40.275,15.725),(40.275,15.575),(40.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.895),(40.125,16.045),(40.275,16.045),(40.275,15.895),(40.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.215),(40.125,16.365),(40.275,16.365),(40.275,16.215),(40.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.535),(40.125,16.685),(40.275,16.685),(40.275,16.535),(40.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.855),(40.125,17.005),(40.275,17.005),(40.275,16.855),(40.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.175),(40.125,17.325),(40.275,17.325),(40.275,17.175),(40.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.495),(40.125,17.645),(40.275,17.645),(40.275,17.495),(40.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.815),(40.125,17.965),(40.275,17.965),(40.275,17.815),(40.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.135),(40.125,18.285),(40.275,18.285),(40.275,18.135),(40.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.455),(40.125,18.605),(40.275,18.605),(40.275,18.455),(40.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.775),(40.125,18.925),(40.275,18.925),(40.275,18.775),(40.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.095),(40.125,19.245),(40.275,19.245),(40.275,19.095),(40.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.415),(40.125,19.565),(40.275,19.565),(40.275,19.415),(40.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.735),(40.125,19.885),(40.275,19.885),(40.275,19.735),(40.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.055),(40.125,20.205),(40.275,20.205),(40.275,20.055),(40.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.375),(40.125,20.525),(40.275,20.525),(40.275,20.375),(40.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.695),(40.125,20.845),(40.275,20.845),(40.275,20.695),(40.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.015),(40.125,21.165),(40.275,21.165),(40.275,21.015),(40.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.335),(40.125,21.485),(40.275,21.485),(40.275,21.335),(40.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.655),(40.125,21.805),(40.275,21.805),(40.275,21.655),(40.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.975),(40.125,22.125),(40.275,22.125),(40.275,21.975),(40.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.215),(44.925,0.365),(45.075,0.365),(45.075,0.215),(44.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.535),(44.925,0.685),(45.075,0.685),(45.075,0.535),(44.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.855),(44.925,1.005),(45.075,1.005),(45.075,0.855),(44.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.175),(44.925,1.325),(45.075,1.325),(45.075,1.175),(44.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.495),(44.925,1.645),(45.075,1.645),(45.075,1.495),(44.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.815),(44.925,1.965),(45.075,1.965),(45.075,1.815),(44.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.135),(44.925,2.285),(45.075,2.285),(45.075,2.135),(44.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.455),(44.925,2.605),(45.075,2.605),(45.075,2.455),(44.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.775),(44.925,2.925),(45.075,2.925),(45.075,2.775),(44.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.095),(44.925,3.245),(45.075,3.245),(45.075,3.095),(44.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.415),(44.925,3.565),(45.075,3.565),(45.075,3.415),(44.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.735),(44.925,3.885),(45.075,3.885),(45.075,3.735),(44.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.055),(44.925,4.205),(45.075,4.205),(45.075,4.055),(44.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.375),(44.925,4.525),(45.075,4.525),(45.075,4.375),(44.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.695),(44.925,4.845),(45.075,4.845),(45.075,4.695),(44.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.015),(44.925,5.165),(45.075,5.165),(45.075,5.015),(44.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.335),(44.925,5.485),(45.075,5.485),(45.075,5.335),(44.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.655),(44.925,5.805),(45.075,5.805),(45.075,5.655),(44.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.975),(44.925,6.125),(45.075,6.125),(45.075,5.975),(44.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.295),(44.925,6.445),(45.075,6.445),(45.075,6.295),(44.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.615),(44.925,6.765),(45.075,6.765),(45.075,6.615),(44.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.935),(44.925,7.085),(45.075,7.085),(45.075,6.935),(44.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.255),(44.925,7.405),(45.075,7.405),(45.075,7.255),(44.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.575),(44.925,7.725),(45.075,7.725),(45.075,7.575),(44.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.895),(44.925,8.045),(45.075,8.045),(45.075,7.895),(44.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.215),(44.925,8.365),(45.075,8.365),(45.075,8.215),(44.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.535),(44.925,8.685),(45.075,8.685),(45.075,8.535),(44.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.855),(44.925,9.005),(45.075,9.005),(45.075,8.855),(44.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.175),(44.925,9.325),(45.075,9.325),(45.075,9.175),(44.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.495),(44.925,9.645),(45.075,9.645),(45.075,9.495),(44.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.815),(44.925,9.965),(45.075,9.965),(45.075,9.815),(44.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.135),(44.925,10.285),(45.075,10.285),(45.075,10.135),(44.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.455),(44.925,10.605),(45.075,10.605),(45.075,10.455),(44.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.775),(44.925,10.925),(45.075,10.925),(45.075,10.775),(44.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.095),(44.925,11.245),(45.075,11.245),(45.075,11.095),(44.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.415),(44.925,11.565),(45.075,11.565),(45.075,11.415),(44.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.735),(44.925,11.885),(45.075,11.885),(45.075,11.735),(44.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.055),(44.925,12.205),(45.075,12.205),(45.075,12.055),(44.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.375),(44.925,12.525),(45.075,12.525),(45.075,12.375),(44.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.695),(44.925,12.845),(45.075,12.845),(45.075,12.695),(44.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.015),(44.925,13.165),(45.075,13.165),(45.075,13.015),(44.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.335),(44.925,13.485),(45.075,13.485),(45.075,13.335),(44.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.655),(44.925,13.805),(45.075,13.805),(45.075,13.655),(44.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.975),(44.925,14.125),(45.075,14.125),(45.075,13.975),(44.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.295),(44.925,14.445),(45.075,14.445),(45.075,14.295),(44.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.615),(44.925,14.765),(45.075,14.765),(45.075,14.615),(44.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.935),(44.925,15.085),(45.075,15.085),(45.075,14.935),(44.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.255),(44.925,15.405),(45.075,15.405),(45.075,15.255),(44.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.575),(44.925,15.725),(45.075,15.725),(45.075,15.575),(44.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.895),(44.925,16.045),(45.075,16.045),(45.075,15.895),(44.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.215),(44.925,16.365),(45.075,16.365),(45.075,16.215),(44.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.535),(44.925,16.685),(45.075,16.685),(45.075,16.535),(44.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.855),(44.925,17.005),(45.075,17.005),(45.075,16.855),(44.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.175),(44.925,17.325),(45.075,17.325),(45.075,17.175),(44.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.495),(44.925,17.645),(45.075,17.645),(45.075,17.495),(44.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.815),(44.925,17.965),(45.075,17.965),(45.075,17.815),(44.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.135),(44.925,18.285),(45.075,18.285),(45.075,18.135),(44.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.455),(44.925,18.605),(45.075,18.605),(45.075,18.455),(44.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.775),(44.925,18.925),(45.075,18.925),(45.075,18.775),(44.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.095),(44.925,19.245),(45.075,19.245),(45.075,19.095),(44.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.415),(44.925,19.565),(45.075,19.565),(45.075,19.415),(44.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.735),(44.925,19.885),(45.075,19.885),(45.075,19.735),(44.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.055),(44.925,20.205),(45.075,20.205),(45.075,20.055),(44.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.375),(44.925,20.525),(45.075,20.525),(45.075,20.375),(44.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.695),(44.925,20.845),(45.075,20.845),(45.075,20.695),(44.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.015),(44.925,21.165),(45.075,21.165),(45.075,21.015),(44.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.335),(44.925,21.485),(45.075,21.485),(45.075,21.335),(44.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.655),(44.925,21.805),(45.075,21.805),(45.075,21.655),(44.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.975),(44.925,22.125),(45.075,22.125),(45.075,21.975),(44.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.215),(25.725,0.365),(25.875,0.365),(25.875,0.215),(25.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.535),(25.725,0.685),(25.875,0.685),(25.875,0.535),(25.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.855),(25.725,1.005),(25.875,1.005),(25.875,0.855),(25.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.175),(25.725,1.325),(25.875,1.325),(25.875,1.175),(25.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.495),(25.725,1.645),(25.875,1.645),(25.875,1.495),(25.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.815),(25.725,1.965),(25.875,1.965),(25.875,1.815),(25.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.135),(25.725,2.285),(25.875,2.285),(25.875,2.135),(25.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.455),(25.725,2.605),(25.875,2.605),(25.875,2.455),(25.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.775),(25.725,2.925),(25.875,2.925),(25.875,2.775),(25.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.095),(25.725,3.245),(25.875,3.245),(25.875,3.095),(25.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.415),(25.725,3.565),(25.875,3.565),(25.875,3.415),(25.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.735),(25.725,3.885),(25.875,3.885),(25.875,3.735),(25.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.055),(25.725,4.205),(25.875,4.205),(25.875,4.055),(25.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.375),(25.725,4.525),(25.875,4.525),(25.875,4.375),(25.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.695),(25.725,4.845),(25.875,4.845),(25.875,4.695),(25.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.015),(25.725,5.165),(25.875,5.165),(25.875,5.015),(25.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.335),(25.725,5.485),(25.875,5.485),(25.875,5.335),(25.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.655),(25.725,5.805),(25.875,5.805),(25.875,5.655),(25.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.975),(25.725,6.125),(25.875,6.125),(25.875,5.975),(25.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.295),(25.725,6.445),(25.875,6.445),(25.875,6.295),(25.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.615),(25.725,6.765),(25.875,6.765),(25.875,6.615),(25.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.935),(25.725,7.085),(25.875,7.085),(25.875,6.935),(25.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.255),(25.725,7.405),(25.875,7.405),(25.875,7.255),(25.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.575),(25.725,7.725),(25.875,7.725),(25.875,7.575),(25.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.895),(25.725,8.045),(25.875,8.045),(25.875,7.895),(25.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.215),(25.725,8.365),(25.875,8.365),(25.875,8.215),(25.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.535),(25.725,8.685),(25.875,8.685),(25.875,8.535),(25.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.855),(25.725,9.005),(25.875,9.005),(25.875,8.855),(25.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.175),(25.725,9.325),(25.875,9.325),(25.875,9.175),(25.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.495),(25.725,9.645),(25.875,9.645),(25.875,9.495),(25.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.815),(25.725,9.965),(25.875,9.965),(25.875,9.815),(25.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.135),(25.725,10.285),(25.875,10.285),(25.875,10.135),(25.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.455),(25.725,10.605),(25.875,10.605),(25.875,10.455),(25.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.775),(25.725,10.925),(25.875,10.925),(25.875,10.775),(25.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.095),(25.725,11.245),(25.875,11.245),(25.875,11.095),(25.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.415),(25.725,11.565),(25.875,11.565),(25.875,11.415),(25.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.735),(25.725,11.885),(25.875,11.885),(25.875,11.735),(25.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.055),(25.725,12.205),(25.875,12.205),(25.875,12.055),(25.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.375),(25.725,12.525),(25.875,12.525),(25.875,12.375),(25.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.695),(25.725,12.845),(25.875,12.845),(25.875,12.695),(25.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.015),(25.725,13.165),(25.875,13.165),(25.875,13.015),(25.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.335),(25.725,13.485),(25.875,13.485),(25.875,13.335),(25.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.655),(25.725,13.805),(25.875,13.805),(25.875,13.655),(25.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.975),(25.725,14.125),(25.875,14.125),(25.875,13.975),(25.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.295),(25.725,14.445),(25.875,14.445),(25.875,14.295),(25.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.615),(25.725,14.765),(25.875,14.765),(25.875,14.615),(25.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.935),(25.725,15.085),(25.875,15.085),(25.875,14.935),(25.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.255),(25.725,15.405),(25.875,15.405),(25.875,15.255),(25.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.575),(25.725,15.725),(25.875,15.725),(25.875,15.575),(25.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.895),(25.725,16.045),(25.875,16.045),(25.875,15.895),(25.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.215),(25.725,16.365),(25.875,16.365),(25.875,16.215),(25.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.535),(25.725,16.685),(25.875,16.685),(25.875,16.535),(25.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.855),(25.725,17.005),(25.875,17.005),(25.875,16.855),(25.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.175),(25.725,17.325),(25.875,17.325),(25.875,17.175),(25.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.495),(25.725,17.645),(25.875,17.645),(25.875,17.495),(25.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.815),(25.725,17.965),(25.875,17.965),(25.875,17.815),(25.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.135),(25.725,18.285),(25.875,18.285),(25.875,18.135),(25.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.455),(25.725,18.605),(25.875,18.605),(25.875,18.455),(25.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.775),(25.725,18.925),(25.875,18.925),(25.875,18.775),(25.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.095),(25.725,19.245),(25.875,19.245),(25.875,19.095),(25.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.415),(25.725,19.565),(25.875,19.565),(25.875,19.415),(25.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.735),(25.725,19.885),(25.875,19.885),(25.875,19.735),(25.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.055),(25.725,20.205),(25.875,20.205),(25.875,20.055),(25.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.375),(25.725,20.525),(25.875,20.525),(25.875,20.375),(25.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.695),(25.725,20.845),(25.875,20.845),(25.875,20.695),(25.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.015),(25.725,21.165),(25.875,21.165),(25.875,21.015),(25.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.335),(25.725,21.485),(25.875,21.485),(25.875,21.335),(25.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.655),(25.725,21.805),(25.875,21.805),(25.875,21.655),(25.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.975),(25.725,22.125),(25.875,22.125),(25.875,21.975),(25.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.215),(78.525,0.365),(78.675,0.365),(78.675,0.215),(78.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.535),(78.525,0.685),(78.675,0.685),(78.675,0.535),(78.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.855),(78.525,1.005),(78.675,1.005),(78.675,0.855),(78.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.175),(78.525,1.325),(78.675,1.325),(78.675,1.175),(78.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.495),(78.525,1.645),(78.675,1.645),(78.675,1.495),(78.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.815),(78.525,1.965),(78.675,1.965),(78.675,1.815),(78.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.135),(78.525,2.285),(78.675,2.285),(78.675,2.135),(78.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.455),(78.525,2.605),(78.675,2.605),(78.675,2.455),(78.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.775),(78.525,2.925),(78.675,2.925),(78.675,2.775),(78.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.095),(78.525,3.245),(78.675,3.245),(78.675,3.095),(78.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.415),(78.525,3.565),(78.675,3.565),(78.675,3.415),(78.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.735),(78.525,3.885),(78.675,3.885),(78.675,3.735),(78.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.055),(78.525,4.205),(78.675,4.205),(78.675,4.055),(78.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.375),(78.525,4.525),(78.675,4.525),(78.675,4.375),(78.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.695),(78.525,4.845),(78.675,4.845),(78.675,4.695),(78.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.015),(78.525,5.165),(78.675,5.165),(78.675,5.015),(78.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.335),(78.525,5.485),(78.675,5.485),(78.675,5.335),(78.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.655),(78.525,5.805),(78.675,5.805),(78.675,5.655),(78.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.975),(78.525,6.125),(78.675,6.125),(78.675,5.975),(78.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.295),(78.525,6.445),(78.675,6.445),(78.675,6.295),(78.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.615),(78.525,6.765),(78.675,6.765),(78.675,6.615),(78.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.935),(78.525,7.085),(78.675,7.085),(78.675,6.935),(78.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.255),(78.525,7.405),(78.675,7.405),(78.675,7.255),(78.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.575),(78.525,7.725),(78.675,7.725),(78.675,7.575),(78.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.895),(78.525,8.045),(78.675,8.045),(78.675,7.895),(78.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.215),(78.525,8.365),(78.675,8.365),(78.675,8.215),(78.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.535),(78.525,8.685),(78.675,8.685),(78.675,8.535),(78.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.855),(78.525,9.005),(78.675,9.005),(78.675,8.855),(78.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.175),(78.525,9.325),(78.675,9.325),(78.675,9.175),(78.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.495),(78.525,9.645),(78.675,9.645),(78.675,9.495),(78.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.815),(78.525,9.965),(78.675,9.965),(78.675,9.815),(78.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.135),(78.525,10.285),(78.675,10.285),(78.675,10.135),(78.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.455),(78.525,10.605),(78.675,10.605),(78.675,10.455),(78.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.775),(78.525,10.925),(78.675,10.925),(78.675,10.775),(78.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.095),(78.525,11.245),(78.675,11.245),(78.675,11.095),(78.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.415),(78.525,11.565),(78.675,11.565),(78.675,11.415),(78.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.735),(78.525,11.885),(78.675,11.885),(78.675,11.735),(78.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.055),(78.525,12.205),(78.675,12.205),(78.675,12.055),(78.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.375),(78.525,12.525),(78.675,12.525),(78.675,12.375),(78.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.695),(78.525,12.845),(78.675,12.845),(78.675,12.695),(78.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.015),(78.525,13.165),(78.675,13.165),(78.675,13.015),(78.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.335),(78.525,13.485),(78.675,13.485),(78.675,13.335),(78.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.655),(78.525,13.805),(78.675,13.805),(78.675,13.655),(78.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.975),(78.525,14.125),(78.675,14.125),(78.675,13.975),(78.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.295),(78.525,14.445),(78.675,14.445),(78.675,14.295),(78.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.615),(78.525,14.765),(78.675,14.765),(78.675,14.615),(78.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.935),(78.525,15.085),(78.675,15.085),(78.675,14.935),(78.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.255),(78.525,15.405),(78.675,15.405),(78.675,15.255),(78.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.575),(78.525,15.725),(78.675,15.725),(78.675,15.575),(78.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.895),(78.525,16.045),(78.675,16.045),(78.675,15.895),(78.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.215),(78.525,16.365),(78.675,16.365),(78.675,16.215),(78.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.535),(78.525,16.685),(78.675,16.685),(78.675,16.535),(78.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.855),(78.525,17.005),(78.675,17.005),(78.675,16.855),(78.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.175),(78.525,17.325),(78.675,17.325),(78.675,17.175),(78.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.495),(78.525,17.645),(78.675,17.645),(78.675,17.495),(78.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.815),(78.525,17.965),(78.675,17.965),(78.675,17.815),(78.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.135),(78.525,18.285),(78.675,18.285),(78.675,18.135),(78.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.455),(78.525,18.605),(78.675,18.605),(78.675,18.455),(78.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.775),(78.525,18.925),(78.675,18.925),(78.675,18.775),(78.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.095),(78.525,19.245),(78.675,19.245),(78.675,19.095),(78.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.415),(78.525,19.565),(78.675,19.565),(78.675,19.415),(78.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.735),(78.525,19.885),(78.675,19.885),(78.675,19.735),(78.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.055),(78.525,20.205),(78.675,20.205),(78.675,20.055),(78.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.375),(78.525,20.525),(78.675,20.525),(78.675,20.375),(78.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.695),(78.525,20.845),(78.675,20.845),(78.675,20.695),(78.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.015),(78.525,21.165),(78.675,21.165),(78.675,21.015),(78.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.335),(78.525,21.485),(78.675,21.485),(78.675,21.335),(78.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.655),(78.525,21.805),(78.675,21.805),(78.675,21.655),(78.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.975),(78.525,22.125),(78.675,22.125),(78.675,21.975),(78.525,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.215),(64.125,0.365),(64.275,0.365),(64.275,0.215),(64.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.535),(64.125,0.685),(64.275,0.685),(64.275,0.535),(64.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.855),(64.125,1.005),(64.275,1.005),(64.275,0.855),(64.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.175),(64.125,1.325),(64.275,1.325),(64.275,1.175),(64.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.495),(64.125,1.645),(64.275,1.645),(64.275,1.495),(64.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.815),(64.125,1.965),(64.275,1.965),(64.275,1.815),(64.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.135),(64.125,2.285),(64.275,2.285),(64.275,2.135),(64.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.455),(64.125,2.605),(64.275,2.605),(64.275,2.455),(64.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.775),(64.125,2.925),(64.275,2.925),(64.275,2.775),(64.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.095),(64.125,3.245),(64.275,3.245),(64.275,3.095),(64.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.415),(64.125,3.565),(64.275,3.565),(64.275,3.415),(64.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.735),(64.125,3.885),(64.275,3.885),(64.275,3.735),(64.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.055),(64.125,4.205),(64.275,4.205),(64.275,4.055),(64.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.375),(64.125,4.525),(64.275,4.525),(64.275,4.375),(64.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.695),(64.125,4.845),(64.275,4.845),(64.275,4.695),(64.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.015),(64.125,5.165),(64.275,5.165),(64.275,5.015),(64.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.335),(64.125,5.485),(64.275,5.485),(64.275,5.335),(64.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.655),(64.125,5.805),(64.275,5.805),(64.275,5.655),(64.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.975),(64.125,6.125),(64.275,6.125),(64.275,5.975),(64.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.295),(64.125,6.445),(64.275,6.445),(64.275,6.295),(64.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.615),(64.125,6.765),(64.275,6.765),(64.275,6.615),(64.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.935),(64.125,7.085),(64.275,7.085),(64.275,6.935),(64.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.255),(64.125,7.405),(64.275,7.405),(64.275,7.255),(64.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.575),(64.125,7.725),(64.275,7.725),(64.275,7.575),(64.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.895),(64.125,8.045),(64.275,8.045),(64.275,7.895),(64.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.215),(64.125,8.365),(64.275,8.365),(64.275,8.215),(64.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.535),(64.125,8.685),(64.275,8.685),(64.275,8.535),(64.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.855),(64.125,9.005),(64.275,9.005),(64.275,8.855),(64.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.175),(64.125,9.325),(64.275,9.325),(64.275,9.175),(64.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.495),(64.125,9.645),(64.275,9.645),(64.275,9.495),(64.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.815),(64.125,9.965),(64.275,9.965),(64.275,9.815),(64.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.135),(64.125,10.285),(64.275,10.285),(64.275,10.135),(64.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.455),(64.125,10.605),(64.275,10.605),(64.275,10.455),(64.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.775),(64.125,10.925),(64.275,10.925),(64.275,10.775),(64.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.095),(64.125,11.245),(64.275,11.245),(64.275,11.095),(64.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.415),(64.125,11.565),(64.275,11.565),(64.275,11.415),(64.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.735),(64.125,11.885),(64.275,11.885),(64.275,11.735),(64.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.055),(64.125,12.205),(64.275,12.205),(64.275,12.055),(64.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.375),(64.125,12.525),(64.275,12.525),(64.275,12.375),(64.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.695),(64.125,12.845),(64.275,12.845),(64.275,12.695),(64.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.015),(64.125,13.165),(64.275,13.165),(64.275,13.015),(64.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.335),(64.125,13.485),(64.275,13.485),(64.275,13.335),(64.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.655),(64.125,13.805),(64.275,13.805),(64.275,13.655),(64.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.975),(64.125,14.125),(64.275,14.125),(64.275,13.975),(64.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.295),(64.125,14.445),(64.275,14.445),(64.275,14.295),(64.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.615),(64.125,14.765),(64.275,14.765),(64.275,14.615),(64.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.935),(64.125,15.085),(64.275,15.085),(64.275,14.935),(64.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.255),(64.125,15.405),(64.275,15.405),(64.275,15.255),(64.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.575),(64.125,15.725),(64.275,15.725),(64.275,15.575),(64.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.895),(64.125,16.045),(64.275,16.045),(64.275,15.895),(64.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.215),(64.125,16.365),(64.275,16.365),(64.275,16.215),(64.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.535),(64.125,16.685),(64.275,16.685),(64.275,16.535),(64.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.855),(64.125,17.005),(64.275,17.005),(64.275,16.855),(64.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.175),(64.125,17.325),(64.275,17.325),(64.275,17.175),(64.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.495),(64.125,17.645),(64.275,17.645),(64.275,17.495),(64.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.815),(64.125,17.965),(64.275,17.965),(64.275,17.815),(64.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.135),(64.125,18.285),(64.275,18.285),(64.275,18.135),(64.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.455),(64.125,18.605),(64.275,18.605),(64.275,18.455),(64.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.775),(64.125,18.925),(64.275,18.925),(64.275,18.775),(64.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.095),(64.125,19.245),(64.275,19.245),(64.275,19.095),(64.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.415),(64.125,19.565),(64.275,19.565),(64.275,19.415),(64.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.735),(64.125,19.885),(64.275,19.885),(64.275,19.735),(64.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.055),(64.125,20.205),(64.275,20.205),(64.275,20.055),(64.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.375),(64.125,20.525),(64.275,20.525),(64.275,20.375),(64.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.695),(64.125,20.845),(64.275,20.845),(64.275,20.695),(64.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.015),(64.125,21.165),(64.275,21.165),(64.275,21.015),(64.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.335),(64.125,21.485),(64.275,21.485),(64.275,21.335),(64.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.655),(64.125,21.805),(64.275,21.805),(64.275,21.655),(64.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.975),(64.125,22.125),(64.275,22.125),(64.275,21.975),(64.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.215),(54.525,0.365),(54.675,0.365),(54.675,0.215),(54.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.535),(54.525,0.685),(54.675,0.685),(54.675,0.535),(54.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.855),(54.525,1.005),(54.675,1.005),(54.675,0.855),(54.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.175),(54.525,1.325),(54.675,1.325),(54.675,1.175),(54.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.495),(54.525,1.645),(54.675,1.645),(54.675,1.495),(54.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.815),(54.525,1.965),(54.675,1.965),(54.675,1.815),(54.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.135),(54.525,2.285),(54.675,2.285),(54.675,2.135),(54.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.455),(54.525,2.605),(54.675,2.605),(54.675,2.455),(54.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.775),(54.525,2.925),(54.675,2.925),(54.675,2.775),(54.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.095),(54.525,3.245),(54.675,3.245),(54.675,3.095),(54.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.415),(54.525,3.565),(54.675,3.565),(54.675,3.415),(54.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.735),(54.525,3.885),(54.675,3.885),(54.675,3.735),(54.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.055),(54.525,4.205),(54.675,4.205),(54.675,4.055),(54.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.375),(54.525,4.525),(54.675,4.525),(54.675,4.375),(54.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.695),(54.525,4.845),(54.675,4.845),(54.675,4.695),(54.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.015),(54.525,5.165),(54.675,5.165),(54.675,5.015),(54.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.335),(54.525,5.485),(54.675,5.485),(54.675,5.335),(54.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.655),(54.525,5.805),(54.675,5.805),(54.675,5.655),(54.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.975),(54.525,6.125),(54.675,6.125),(54.675,5.975),(54.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.295),(54.525,6.445),(54.675,6.445),(54.675,6.295),(54.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.615),(54.525,6.765),(54.675,6.765),(54.675,6.615),(54.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.935),(54.525,7.085),(54.675,7.085),(54.675,6.935),(54.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.255),(54.525,7.405),(54.675,7.405),(54.675,7.255),(54.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.575),(54.525,7.725),(54.675,7.725),(54.675,7.575),(54.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.895),(54.525,8.045),(54.675,8.045),(54.675,7.895),(54.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.215),(54.525,8.365),(54.675,8.365),(54.675,8.215),(54.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.535),(54.525,8.685),(54.675,8.685),(54.675,8.535),(54.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.855),(54.525,9.005),(54.675,9.005),(54.675,8.855),(54.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.175),(54.525,9.325),(54.675,9.325),(54.675,9.175),(54.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.495),(54.525,9.645),(54.675,9.645),(54.675,9.495),(54.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.815),(54.525,9.965),(54.675,9.965),(54.675,9.815),(54.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.135),(54.525,10.285),(54.675,10.285),(54.675,10.135),(54.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.455),(54.525,10.605),(54.675,10.605),(54.675,10.455),(54.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.775),(54.525,10.925),(54.675,10.925),(54.675,10.775),(54.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.095),(54.525,11.245),(54.675,11.245),(54.675,11.095),(54.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.415),(54.525,11.565),(54.675,11.565),(54.675,11.415),(54.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.735),(54.525,11.885),(54.675,11.885),(54.675,11.735),(54.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.055),(54.525,12.205),(54.675,12.205),(54.675,12.055),(54.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.375),(54.525,12.525),(54.675,12.525),(54.675,12.375),(54.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.695),(54.525,12.845),(54.675,12.845),(54.675,12.695),(54.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.015),(54.525,13.165),(54.675,13.165),(54.675,13.015),(54.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.335),(54.525,13.485),(54.675,13.485),(54.675,13.335),(54.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.655),(54.525,13.805),(54.675,13.805),(54.675,13.655),(54.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.975),(54.525,14.125),(54.675,14.125),(54.675,13.975),(54.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.295),(54.525,14.445),(54.675,14.445),(54.675,14.295),(54.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.615),(54.525,14.765),(54.675,14.765),(54.675,14.615),(54.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.935),(54.525,15.085),(54.675,15.085),(54.675,14.935),(54.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.255),(54.525,15.405),(54.675,15.405),(54.675,15.255),(54.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.575),(54.525,15.725),(54.675,15.725),(54.675,15.575),(54.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.895),(54.525,16.045),(54.675,16.045),(54.675,15.895),(54.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.215),(54.525,16.365),(54.675,16.365),(54.675,16.215),(54.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.535),(54.525,16.685),(54.675,16.685),(54.675,16.535),(54.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.855),(54.525,17.005),(54.675,17.005),(54.675,16.855),(54.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.175),(54.525,17.325),(54.675,17.325),(54.675,17.175),(54.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.495),(54.525,17.645),(54.675,17.645),(54.675,17.495),(54.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.815),(54.525,17.965),(54.675,17.965),(54.675,17.815),(54.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.135),(54.525,18.285),(54.675,18.285),(54.675,18.135),(54.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.455),(54.525,18.605),(54.675,18.605),(54.675,18.455),(54.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.775),(54.525,18.925),(54.675,18.925),(54.675,18.775),(54.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.095),(54.525,19.245),(54.675,19.245),(54.675,19.095),(54.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.415),(54.525,19.565),(54.675,19.565),(54.675,19.415),(54.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.735),(54.525,19.885),(54.675,19.885),(54.675,19.735),(54.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.055),(54.525,20.205),(54.675,20.205),(54.675,20.055),(54.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.375),(54.525,20.525),(54.675,20.525),(54.675,20.375),(54.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.695),(54.525,20.845),(54.675,20.845),(54.675,20.695),(54.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.015),(54.525,21.165),(54.675,21.165),(54.675,21.015),(54.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.335),(54.525,21.485),(54.675,21.485),(54.675,21.335),(54.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.655),(54.525,21.805),(54.675,21.805),(54.675,21.655),(54.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.975),(54.525,22.125),(54.675,22.125),(54.675,21.975),(54.525,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.215),(16.125,0.365),(16.275,0.365),(16.275,0.215),(16.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.535),(16.125,0.685),(16.275,0.685),(16.275,0.535),(16.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.855),(16.125,1.005),(16.275,1.005),(16.275,0.855),(16.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.175),(16.125,1.325),(16.275,1.325),(16.275,1.175),(16.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.495),(16.125,1.645),(16.275,1.645),(16.275,1.495),(16.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.815),(16.125,1.965),(16.275,1.965),(16.275,1.815),(16.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.135),(16.125,2.285),(16.275,2.285),(16.275,2.135),(16.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.455),(16.125,2.605),(16.275,2.605),(16.275,2.455),(16.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.775),(16.125,2.925),(16.275,2.925),(16.275,2.775),(16.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.095),(16.125,3.245),(16.275,3.245),(16.275,3.095),(16.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.415),(16.125,3.565),(16.275,3.565),(16.275,3.415),(16.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.735),(16.125,3.885),(16.275,3.885),(16.275,3.735),(16.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.055),(16.125,4.205),(16.275,4.205),(16.275,4.055),(16.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.375),(16.125,4.525),(16.275,4.525),(16.275,4.375),(16.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.695),(16.125,4.845),(16.275,4.845),(16.275,4.695),(16.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.015),(16.125,5.165),(16.275,5.165),(16.275,5.015),(16.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.335),(16.125,5.485),(16.275,5.485),(16.275,5.335),(16.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.655),(16.125,5.805),(16.275,5.805),(16.275,5.655),(16.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.975),(16.125,6.125),(16.275,6.125),(16.275,5.975),(16.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.295),(16.125,6.445),(16.275,6.445),(16.275,6.295),(16.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.615),(16.125,6.765),(16.275,6.765),(16.275,6.615),(16.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.935),(16.125,7.085),(16.275,7.085),(16.275,6.935),(16.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.255),(16.125,7.405),(16.275,7.405),(16.275,7.255),(16.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.575),(16.125,7.725),(16.275,7.725),(16.275,7.575),(16.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.895),(16.125,8.045),(16.275,8.045),(16.275,7.895),(16.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.215),(16.125,8.365),(16.275,8.365),(16.275,8.215),(16.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.535),(16.125,8.685),(16.275,8.685),(16.275,8.535),(16.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.855),(16.125,9.005),(16.275,9.005),(16.275,8.855),(16.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.175),(16.125,9.325),(16.275,9.325),(16.275,9.175),(16.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.495),(16.125,9.645),(16.275,9.645),(16.275,9.495),(16.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.815),(16.125,9.965),(16.275,9.965),(16.275,9.815),(16.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.135),(16.125,10.285),(16.275,10.285),(16.275,10.135),(16.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.455),(16.125,10.605),(16.275,10.605),(16.275,10.455),(16.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.775),(16.125,10.925),(16.275,10.925),(16.275,10.775),(16.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.095),(16.125,11.245),(16.275,11.245),(16.275,11.095),(16.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.415),(16.125,11.565),(16.275,11.565),(16.275,11.415),(16.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.735),(16.125,11.885),(16.275,11.885),(16.275,11.735),(16.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.055),(16.125,12.205),(16.275,12.205),(16.275,12.055),(16.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.375),(16.125,12.525),(16.275,12.525),(16.275,12.375),(16.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.695),(16.125,12.845),(16.275,12.845),(16.275,12.695),(16.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.015),(16.125,13.165),(16.275,13.165),(16.275,13.015),(16.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.335),(16.125,13.485),(16.275,13.485),(16.275,13.335),(16.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.655),(16.125,13.805),(16.275,13.805),(16.275,13.655),(16.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.975),(16.125,14.125),(16.275,14.125),(16.275,13.975),(16.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.295),(16.125,14.445),(16.275,14.445),(16.275,14.295),(16.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.615),(16.125,14.765),(16.275,14.765),(16.275,14.615),(16.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.935),(16.125,15.085),(16.275,15.085),(16.275,14.935),(16.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.255),(16.125,15.405),(16.275,15.405),(16.275,15.255),(16.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.575),(16.125,15.725),(16.275,15.725),(16.275,15.575),(16.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.895),(16.125,16.045),(16.275,16.045),(16.275,15.895),(16.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.215),(16.125,16.365),(16.275,16.365),(16.275,16.215),(16.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.535),(16.125,16.685),(16.275,16.685),(16.275,16.535),(16.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.855),(16.125,17.005),(16.275,17.005),(16.275,16.855),(16.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.175),(16.125,17.325),(16.275,17.325),(16.275,17.175),(16.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.495),(16.125,17.645),(16.275,17.645),(16.275,17.495),(16.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.815),(16.125,17.965),(16.275,17.965),(16.275,17.815),(16.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.135),(16.125,18.285),(16.275,18.285),(16.275,18.135),(16.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.455),(16.125,18.605),(16.275,18.605),(16.275,18.455),(16.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.775),(16.125,18.925),(16.275,18.925),(16.275,18.775),(16.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.095),(16.125,19.245),(16.275,19.245),(16.275,19.095),(16.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.415),(16.125,19.565),(16.275,19.565),(16.275,19.415),(16.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.735),(16.125,19.885),(16.275,19.885),(16.275,19.735),(16.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.055),(16.125,20.205),(16.275,20.205),(16.275,20.055),(16.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.375),(16.125,20.525),(16.275,20.525),(16.275,20.375),(16.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.695),(16.125,20.845),(16.275,20.845),(16.275,20.695),(16.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.015),(16.125,21.165),(16.275,21.165),(16.275,21.015),(16.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.335),(16.125,21.485),(16.275,21.485),(16.275,21.335),(16.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.655),(16.125,21.805),(16.275,21.805),(16.275,21.655),(16.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.975),(16.125,22.125),(16.275,22.125),(16.275,21.975),(16.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.215),(20.925,0.365),(21.075,0.365),(21.075,0.215),(20.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.535),(20.925,0.685),(21.075,0.685),(21.075,0.535),(20.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.855),(20.925,1.005),(21.075,1.005),(21.075,0.855),(20.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.175),(20.925,1.325),(21.075,1.325),(21.075,1.175),(20.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.495),(20.925,1.645),(21.075,1.645),(21.075,1.495),(20.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.815),(20.925,1.965),(21.075,1.965),(21.075,1.815),(20.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.135),(20.925,2.285),(21.075,2.285),(21.075,2.135),(20.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.455),(20.925,2.605),(21.075,2.605),(21.075,2.455),(20.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.775),(20.925,2.925),(21.075,2.925),(21.075,2.775),(20.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.095),(20.925,3.245),(21.075,3.245),(21.075,3.095),(20.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.415),(20.925,3.565),(21.075,3.565),(21.075,3.415),(20.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.735),(20.925,3.885),(21.075,3.885),(21.075,3.735),(20.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.055),(20.925,4.205),(21.075,4.205),(21.075,4.055),(20.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.375),(20.925,4.525),(21.075,4.525),(21.075,4.375),(20.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.695),(20.925,4.845),(21.075,4.845),(21.075,4.695),(20.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.015),(20.925,5.165),(21.075,5.165),(21.075,5.015),(20.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.335),(20.925,5.485),(21.075,5.485),(21.075,5.335),(20.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.655),(20.925,5.805),(21.075,5.805),(21.075,5.655),(20.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.975),(20.925,6.125),(21.075,6.125),(21.075,5.975),(20.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.295),(20.925,6.445),(21.075,6.445),(21.075,6.295),(20.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.615),(20.925,6.765),(21.075,6.765),(21.075,6.615),(20.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.935),(20.925,7.085),(21.075,7.085),(21.075,6.935),(20.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.255),(20.925,7.405),(21.075,7.405),(21.075,7.255),(20.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.575),(20.925,7.725),(21.075,7.725),(21.075,7.575),(20.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.895),(20.925,8.045),(21.075,8.045),(21.075,7.895),(20.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.215),(20.925,8.365),(21.075,8.365),(21.075,8.215),(20.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.535),(20.925,8.685),(21.075,8.685),(21.075,8.535),(20.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.855),(20.925,9.005),(21.075,9.005),(21.075,8.855),(20.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.175),(20.925,9.325),(21.075,9.325),(21.075,9.175),(20.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.495),(20.925,9.645),(21.075,9.645),(21.075,9.495),(20.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.815),(20.925,9.965),(21.075,9.965),(21.075,9.815),(20.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.135),(20.925,10.285),(21.075,10.285),(21.075,10.135),(20.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.455),(20.925,10.605),(21.075,10.605),(21.075,10.455),(20.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.775),(20.925,10.925),(21.075,10.925),(21.075,10.775),(20.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.095),(20.925,11.245),(21.075,11.245),(21.075,11.095),(20.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.415),(20.925,11.565),(21.075,11.565),(21.075,11.415),(20.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.735),(20.925,11.885),(21.075,11.885),(21.075,11.735),(20.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.055),(20.925,12.205),(21.075,12.205),(21.075,12.055),(20.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.375),(20.925,12.525),(21.075,12.525),(21.075,12.375),(20.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.695),(20.925,12.845),(21.075,12.845),(21.075,12.695),(20.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.015),(20.925,13.165),(21.075,13.165),(21.075,13.015),(20.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.335),(20.925,13.485),(21.075,13.485),(21.075,13.335),(20.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.655),(20.925,13.805),(21.075,13.805),(21.075,13.655),(20.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.975),(20.925,14.125),(21.075,14.125),(21.075,13.975),(20.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.295),(20.925,14.445),(21.075,14.445),(21.075,14.295),(20.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.615),(20.925,14.765),(21.075,14.765),(21.075,14.615),(20.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.935),(20.925,15.085),(21.075,15.085),(21.075,14.935),(20.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.255),(20.925,15.405),(21.075,15.405),(21.075,15.255),(20.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.575),(20.925,15.725),(21.075,15.725),(21.075,15.575),(20.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.895),(20.925,16.045),(21.075,16.045),(21.075,15.895),(20.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.215),(20.925,16.365),(21.075,16.365),(21.075,16.215),(20.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.535),(20.925,16.685),(21.075,16.685),(21.075,16.535),(20.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.855),(20.925,17.005),(21.075,17.005),(21.075,16.855),(20.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.175),(20.925,17.325),(21.075,17.325),(21.075,17.175),(20.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.495),(20.925,17.645),(21.075,17.645),(21.075,17.495),(20.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.815),(20.925,17.965),(21.075,17.965),(21.075,17.815),(20.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.135),(20.925,18.285),(21.075,18.285),(21.075,18.135),(20.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.455),(20.925,18.605),(21.075,18.605),(21.075,18.455),(20.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.775),(20.925,18.925),(21.075,18.925),(21.075,18.775),(20.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.095),(20.925,19.245),(21.075,19.245),(21.075,19.095),(20.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.415),(20.925,19.565),(21.075,19.565),(21.075,19.415),(20.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.735),(20.925,19.885),(21.075,19.885),(21.075,19.735),(20.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.055),(20.925,20.205),(21.075,20.205),(21.075,20.055),(20.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.375),(20.925,20.525),(21.075,20.525),(21.075,20.375),(20.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.695),(20.925,20.845),(21.075,20.845),(21.075,20.695),(20.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.015),(20.925,21.165),(21.075,21.165),(21.075,21.015),(20.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.335),(20.925,21.485),(21.075,21.485),(21.075,21.335),(20.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.655),(20.925,21.805),(21.075,21.805),(21.075,21.655),(20.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.975),(20.925,22.125),(21.075,22.125),(21.075,21.975),(20.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.215),(73.725,0.365),(73.875,0.365),(73.875,0.215),(73.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.535),(73.725,0.685),(73.875,0.685),(73.875,0.535),(73.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.855),(73.725,1.005),(73.875,1.005),(73.875,0.855),(73.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.175),(73.725,1.325),(73.875,1.325),(73.875,1.175),(73.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.495),(73.725,1.645),(73.875,1.645),(73.875,1.495),(73.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.815),(73.725,1.965),(73.875,1.965),(73.875,1.815),(73.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.135),(73.725,2.285),(73.875,2.285),(73.875,2.135),(73.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.455),(73.725,2.605),(73.875,2.605),(73.875,2.455),(73.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.775),(73.725,2.925),(73.875,2.925),(73.875,2.775),(73.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.095),(73.725,3.245),(73.875,3.245),(73.875,3.095),(73.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.415),(73.725,3.565),(73.875,3.565),(73.875,3.415),(73.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.735),(73.725,3.885),(73.875,3.885),(73.875,3.735),(73.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.055),(73.725,4.205),(73.875,4.205),(73.875,4.055),(73.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.375),(73.725,4.525),(73.875,4.525),(73.875,4.375),(73.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.695),(73.725,4.845),(73.875,4.845),(73.875,4.695),(73.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.015),(73.725,5.165),(73.875,5.165),(73.875,5.015),(73.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.335),(73.725,5.485),(73.875,5.485),(73.875,5.335),(73.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.655),(73.725,5.805),(73.875,5.805),(73.875,5.655),(73.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.975),(73.725,6.125),(73.875,6.125),(73.875,5.975),(73.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.295),(73.725,6.445),(73.875,6.445),(73.875,6.295),(73.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.615),(73.725,6.765),(73.875,6.765),(73.875,6.615),(73.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.935),(73.725,7.085),(73.875,7.085),(73.875,6.935),(73.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.255),(73.725,7.405),(73.875,7.405),(73.875,7.255),(73.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.575),(73.725,7.725),(73.875,7.725),(73.875,7.575),(73.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.895),(73.725,8.045),(73.875,8.045),(73.875,7.895),(73.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.215),(73.725,8.365),(73.875,8.365),(73.875,8.215),(73.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.535),(73.725,8.685),(73.875,8.685),(73.875,8.535),(73.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.855),(73.725,9.005),(73.875,9.005),(73.875,8.855),(73.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.175),(73.725,9.325),(73.875,9.325),(73.875,9.175),(73.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.495),(73.725,9.645),(73.875,9.645),(73.875,9.495),(73.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.815),(73.725,9.965),(73.875,9.965),(73.875,9.815),(73.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.135),(73.725,10.285),(73.875,10.285),(73.875,10.135),(73.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.455),(73.725,10.605),(73.875,10.605),(73.875,10.455),(73.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.775),(73.725,10.925),(73.875,10.925),(73.875,10.775),(73.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.095),(73.725,11.245),(73.875,11.245),(73.875,11.095),(73.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.415),(73.725,11.565),(73.875,11.565),(73.875,11.415),(73.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.735),(73.725,11.885),(73.875,11.885),(73.875,11.735),(73.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.055),(73.725,12.205),(73.875,12.205),(73.875,12.055),(73.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.375),(73.725,12.525),(73.875,12.525),(73.875,12.375),(73.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.695),(73.725,12.845),(73.875,12.845),(73.875,12.695),(73.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.015),(73.725,13.165),(73.875,13.165),(73.875,13.015),(73.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.335),(73.725,13.485),(73.875,13.485),(73.875,13.335),(73.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.655),(73.725,13.805),(73.875,13.805),(73.875,13.655),(73.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.975),(73.725,14.125),(73.875,14.125),(73.875,13.975),(73.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.295),(73.725,14.445),(73.875,14.445),(73.875,14.295),(73.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.615),(73.725,14.765),(73.875,14.765),(73.875,14.615),(73.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.935),(73.725,15.085),(73.875,15.085),(73.875,14.935),(73.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.255),(73.725,15.405),(73.875,15.405),(73.875,15.255),(73.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.575),(73.725,15.725),(73.875,15.725),(73.875,15.575),(73.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.895),(73.725,16.045),(73.875,16.045),(73.875,15.895),(73.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.215),(73.725,16.365),(73.875,16.365),(73.875,16.215),(73.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.535),(73.725,16.685),(73.875,16.685),(73.875,16.535),(73.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.855),(73.725,17.005),(73.875,17.005),(73.875,16.855),(73.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.175),(73.725,17.325),(73.875,17.325),(73.875,17.175),(73.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.495),(73.725,17.645),(73.875,17.645),(73.875,17.495),(73.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.815),(73.725,17.965),(73.875,17.965),(73.875,17.815),(73.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.135),(73.725,18.285),(73.875,18.285),(73.875,18.135),(73.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.455),(73.725,18.605),(73.875,18.605),(73.875,18.455),(73.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.775),(73.725,18.925),(73.875,18.925),(73.875,18.775),(73.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.095),(73.725,19.245),(73.875,19.245),(73.875,19.095),(73.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.415),(73.725,19.565),(73.875,19.565),(73.875,19.415),(73.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.735),(73.725,19.885),(73.875,19.885),(73.875,19.735),(73.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.055),(73.725,20.205),(73.875,20.205),(73.875,20.055),(73.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.375),(73.725,20.525),(73.875,20.525),(73.875,20.375),(73.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.695),(73.725,20.845),(73.875,20.845),(73.875,20.695),(73.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.015),(73.725,21.165),(73.875,21.165),(73.875,21.015),(73.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.335),(73.725,21.485),(73.875,21.485),(73.875,21.335),(73.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.655),(73.725,21.805),(73.875,21.805),(73.875,21.655),(73.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.975),(73.725,22.125),(73.875,22.125),(73.875,21.975),(73.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.215),(11.325,0.365),(11.475,0.365),(11.475,0.215),(11.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.535),(11.325,0.685),(11.475,0.685),(11.475,0.535),(11.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.855),(11.325,1.005),(11.475,1.005),(11.475,0.855),(11.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.175),(11.325,1.325),(11.475,1.325),(11.475,1.175),(11.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.495),(11.325,1.645),(11.475,1.645),(11.475,1.495),(11.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.815),(11.325,1.965),(11.475,1.965),(11.475,1.815),(11.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.135),(11.325,2.285),(11.475,2.285),(11.475,2.135),(11.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.455),(11.325,2.605),(11.475,2.605),(11.475,2.455),(11.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.775),(11.325,2.925),(11.475,2.925),(11.475,2.775),(11.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.095),(11.325,3.245),(11.475,3.245),(11.475,3.095),(11.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.415),(11.325,3.565),(11.475,3.565),(11.475,3.415),(11.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.735),(11.325,3.885),(11.475,3.885),(11.475,3.735),(11.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.055),(11.325,4.205),(11.475,4.205),(11.475,4.055),(11.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.375),(11.325,4.525),(11.475,4.525),(11.475,4.375),(11.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.695),(11.325,4.845),(11.475,4.845),(11.475,4.695),(11.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.015),(11.325,5.165),(11.475,5.165),(11.475,5.015),(11.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.335),(11.325,5.485),(11.475,5.485),(11.475,5.335),(11.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.655),(11.325,5.805),(11.475,5.805),(11.475,5.655),(11.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.975),(11.325,6.125),(11.475,6.125),(11.475,5.975),(11.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.295),(11.325,6.445),(11.475,6.445),(11.475,6.295),(11.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.615),(11.325,6.765),(11.475,6.765),(11.475,6.615),(11.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.935),(11.325,7.085),(11.475,7.085),(11.475,6.935),(11.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.255),(11.325,7.405),(11.475,7.405),(11.475,7.255),(11.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.575),(11.325,7.725),(11.475,7.725),(11.475,7.575),(11.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.895),(11.325,8.045),(11.475,8.045),(11.475,7.895),(11.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.215),(11.325,8.365),(11.475,8.365),(11.475,8.215),(11.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.535),(11.325,8.685),(11.475,8.685),(11.475,8.535),(11.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.855),(11.325,9.005),(11.475,9.005),(11.475,8.855),(11.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.175),(11.325,9.325),(11.475,9.325),(11.475,9.175),(11.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.495),(11.325,9.645),(11.475,9.645),(11.475,9.495),(11.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.815),(11.325,9.965),(11.475,9.965),(11.475,9.815),(11.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.135),(11.325,10.285),(11.475,10.285),(11.475,10.135),(11.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.455),(11.325,10.605),(11.475,10.605),(11.475,10.455),(11.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.775),(11.325,10.925),(11.475,10.925),(11.475,10.775),(11.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.095),(11.325,11.245),(11.475,11.245),(11.475,11.095),(11.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.415),(11.325,11.565),(11.475,11.565),(11.475,11.415),(11.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.735),(11.325,11.885),(11.475,11.885),(11.475,11.735),(11.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.055),(11.325,12.205),(11.475,12.205),(11.475,12.055),(11.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.375),(11.325,12.525),(11.475,12.525),(11.475,12.375),(11.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.695),(11.325,12.845),(11.475,12.845),(11.475,12.695),(11.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.015),(11.325,13.165),(11.475,13.165),(11.475,13.015),(11.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.335),(11.325,13.485),(11.475,13.485),(11.475,13.335),(11.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.655),(11.325,13.805),(11.475,13.805),(11.475,13.655),(11.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.975),(11.325,14.125),(11.475,14.125),(11.475,13.975),(11.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.295),(11.325,14.445),(11.475,14.445),(11.475,14.295),(11.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.615),(11.325,14.765),(11.475,14.765),(11.475,14.615),(11.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.935),(11.325,15.085),(11.475,15.085),(11.475,14.935),(11.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.255),(11.325,15.405),(11.475,15.405),(11.475,15.255),(11.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.575),(11.325,15.725),(11.475,15.725),(11.475,15.575),(11.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.895),(11.325,16.045),(11.475,16.045),(11.475,15.895),(11.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.215),(11.325,16.365),(11.475,16.365),(11.475,16.215),(11.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.535),(11.325,16.685),(11.475,16.685),(11.475,16.535),(11.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.855),(11.325,17.005),(11.475,17.005),(11.475,16.855),(11.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.175),(11.325,17.325),(11.475,17.325),(11.475,17.175),(11.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.495),(11.325,17.645),(11.475,17.645),(11.475,17.495),(11.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.815),(11.325,17.965),(11.475,17.965),(11.475,17.815),(11.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.135),(11.325,18.285),(11.475,18.285),(11.475,18.135),(11.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.455),(11.325,18.605),(11.475,18.605),(11.475,18.455),(11.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.775),(11.325,18.925),(11.475,18.925),(11.475,18.775),(11.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.095),(11.325,19.245),(11.475,19.245),(11.475,19.095),(11.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.415),(11.325,19.565),(11.475,19.565),(11.475,19.415),(11.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.735),(11.325,19.885),(11.475,19.885),(11.475,19.735),(11.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.055),(11.325,20.205),(11.475,20.205),(11.475,20.055),(11.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.375),(11.325,20.525),(11.475,20.525),(11.475,20.375),(11.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.695),(11.325,20.845),(11.475,20.845),(11.475,20.695),(11.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.015),(11.325,21.165),(11.475,21.165),(11.475,21.015),(11.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.335),(11.325,21.485),(11.475,21.485),(11.475,21.335),(11.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.655),(11.325,21.805),(11.475,21.805),(11.475,21.655),(11.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.975),(11.325,22.125),(11.475,22.125),(11.475,21.975),(11.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.215),(30.525,0.365),(30.675,0.365),(30.675,0.215),(30.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.535),(30.525,0.685),(30.675,0.685),(30.675,0.535),(30.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.855),(30.525,1.005),(30.675,1.005),(30.675,0.855),(30.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.175),(30.525,1.325),(30.675,1.325),(30.675,1.175),(30.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.495),(30.525,1.645),(30.675,1.645),(30.675,1.495),(30.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.815),(30.525,1.965),(30.675,1.965),(30.675,1.815),(30.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.135),(30.525,2.285),(30.675,2.285),(30.675,2.135),(30.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.455),(30.525,2.605),(30.675,2.605),(30.675,2.455),(30.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.775),(30.525,2.925),(30.675,2.925),(30.675,2.775),(30.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.095),(30.525,3.245),(30.675,3.245),(30.675,3.095),(30.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.415),(30.525,3.565),(30.675,3.565),(30.675,3.415),(30.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.735),(30.525,3.885),(30.675,3.885),(30.675,3.735),(30.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.055),(30.525,4.205),(30.675,4.205),(30.675,4.055),(30.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.375),(30.525,4.525),(30.675,4.525),(30.675,4.375),(30.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.695),(30.525,4.845),(30.675,4.845),(30.675,4.695),(30.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.015),(30.525,5.165),(30.675,5.165),(30.675,5.015),(30.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.335),(30.525,5.485),(30.675,5.485),(30.675,5.335),(30.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.655),(30.525,5.805),(30.675,5.805),(30.675,5.655),(30.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.975),(30.525,6.125),(30.675,6.125),(30.675,5.975),(30.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.295),(30.525,6.445),(30.675,6.445),(30.675,6.295),(30.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.615),(30.525,6.765),(30.675,6.765),(30.675,6.615),(30.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.935),(30.525,7.085),(30.675,7.085),(30.675,6.935),(30.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.255),(30.525,7.405),(30.675,7.405),(30.675,7.255),(30.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.575),(30.525,7.725),(30.675,7.725),(30.675,7.575),(30.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.895),(30.525,8.045),(30.675,8.045),(30.675,7.895),(30.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.215),(30.525,8.365),(30.675,8.365),(30.675,8.215),(30.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.535),(30.525,8.685),(30.675,8.685),(30.675,8.535),(30.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.855),(30.525,9.005),(30.675,9.005),(30.675,8.855),(30.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.175),(30.525,9.325),(30.675,9.325),(30.675,9.175),(30.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.495),(30.525,9.645),(30.675,9.645),(30.675,9.495),(30.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.815),(30.525,9.965),(30.675,9.965),(30.675,9.815),(30.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.135),(30.525,10.285),(30.675,10.285),(30.675,10.135),(30.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.455),(30.525,10.605),(30.675,10.605),(30.675,10.455),(30.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.775),(30.525,10.925),(30.675,10.925),(30.675,10.775),(30.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.095),(30.525,11.245),(30.675,11.245),(30.675,11.095),(30.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.415),(30.525,11.565),(30.675,11.565),(30.675,11.415),(30.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.735),(30.525,11.885),(30.675,11.885),(30.675,11.735),(30.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.055),(30.525,12.205),(30.675,12.205),(30.675,12.055),(30.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.375),(30.525,12.525),(30.675,12.525),(30.675,12.375),(30.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.695),(30.525,12.845),(30.675,12.845),(30.675,12.695),(30.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.015),(30.525,13.165),(30.675,13.165),(30.675,13.015),(30.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.335),(30.525,13.485),(30.675,13.485),(30.675,13.335),(30.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.655),(30.525,13.805),(30.675,13.805),(30.675,13.655),(30.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.975),(30.525,14.125),(30.675,14.125),(30.675,13.975),(30.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.295),(30.525,14.445),(30.675,14.445),(30.675,14.295),(30.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.615),(30.525,14.765),(30.675,14.765),(30.675,14.615),(30.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.935),(30.525,15.085),(30.675,15.085),(30.675,14.935),(30.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.255),(30.525,15.405),(30.675,15.405),(30.675,15.255),(30.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.575),(30.525,15.725),(30.675,15.725),(30.675,15.575),(30.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.895),(30.525,16.045),(30.675,16.045),(30.675,15.895),(30.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.215),(30.525,16.365),(30.675,16.365),(30.675,16.215),(30.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.535),(30.525,16.685),(30.675,16.685),(30.675,16.535),(30.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.855),(30.525,17.005),(30.675,17.005),(30.675,16.855),(30.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.175),(30.525,17.325),(30.675,17.325),(30.675,17.175),(30.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.495),(30.525,17.645),(30.675,17.645),(30.675,17.495),(30.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.815),(30.525,17.965),(30.675,17.965),(30.675,17.815),(30.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.135),(30.525,18.285),(30.675,18.285),(30.675,18.135),(30.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.455),(30.525,18.605),(30.675,18.605),(30.675,18.455),(30.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.775),(30.525,18.925),(30.675,18.925),(30.675,18.775),(30.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.095),(30.525,19.245),(30.675,19.245),(30.675,19.095),(30.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.415),(30.525,19.565),(30.675,19.565),(30.675,19.415),(30.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.735),(30.525,19.885),(30.675,19.885),(30.675,19.735),(30.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.055),(30.525,20.205),(30.675,20.205),(30.675,20.055),(30.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.375),(30.525,20.525),(30.675,20.525),(30.675,20.375),(30.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.695),(30.525,20.845),(30.675,20.845),(30.675,20.695),(30.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.015),(30.525,21.165),(30.675,21.165),(30.675,21.015),(30.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.335),(30.525,21.485),(30.675,21.485),(30.675,21.335),(30.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.655),(30.525,21.805),(30.675,21.805),(30.675,21.655),(30.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.975),(30.525,22.125),(30.675,22.125),(30.675,21.975),(30.525,21.975)),
        )
        createRL(
            tech, net, 'm2',
            ((83.015,0.13),(83.015,22.21),(83.275,22.21),(83.275,0.13),(83.015,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((30.47,0.13),(30.47,22.21),(30.73,22.21),(30.73,0.13),(30.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((78.47,0.13),(78.47,22.21),(78.73,22.21),(78.73,0.13),(78.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((68.87,0.13),(68.87,22.21),(69.13,22.21),(69.13,0.13),(68.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((20.87,0.13),(20.87,22.21),(21.13,22.21),(21.13,0.13),(20.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((16.07,0.13),(16.07,22.21),(16.33,22.21),(16.33,0.13),(16.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((64.07,0.13),(64.07,22.21),(64.33,22.21),(64.33,0.13),(64.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((25.67,0.13),(25.67,22.21),(25.93,22.21),(25.93,0.13),(25.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((11.27,0.13),(11.27,22.21),(11.53,22.21),(11.53,0.13),(11.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((6.725,0.13),(6.725,22.21),(6.985,22.21),(6.985,0.13),(6.725,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((73.67,0.13),(73.67,22.21),(73.93,22.21),(73.93,0.13),(73.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((59.27,0.13),(59.27,22.21),(59.53,22.21),(59.53,0.13),(59.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,10.74),(85.68,11.005),(86.01,11.005),(86.01,10.74),(85.68,10.74)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,10.71),(85.68,11.0),(86.01,11.0),(86.01,10.71),(85.68,10.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((11.05,2.595),(11.05,19.745),(11.75,19.745),(11.75,2.595),(11.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.05,2.595),(35.05,19.745),(35.75,19.745),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.05,2.595),(59.05,19.745),(59.75,19.745),(59.75,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((83.05,2.595),(83.05,19.745),(83.875,19.745),(83.875,2.595),(83.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((73.45,2.595),(73.45,19.745),(74.15,19.745),(74.15,2.595),(73.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.65,2.595),(44.65,19.745),(45.35,19.745),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((68.65,2.595),(68.65,19.745),(69.35,19.745),(69.35,2.595),(68.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.25,2.595),(54.25,19.745),(54.95,19.745),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((20.65,2.595),(20.65,19.745),(21.35,19.745),(21.35,2.595),(20.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((78.25,2.595),(78.25,19.745),(78.95,19.745),(78.95,2.595),(78.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.45,2.595),(49.45,19.745),(50.15,19.745),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.25,2.595),(30.25,19.745),(30.95,19.745),(30.95,2.595),(30.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.85,2.595),(39.85,19.745),(40.55,19.745),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((15.85,2.595),(15.85,19.745),(16.55,19.745),(16.55,2.595),(15.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.85,2.595),(63.85,19.745),(64.55,19.745),(64.55,2.595),(63.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((6.125,2.595),(6.125,19.745),(6.95,19.745),(6.95,2.595),(6.125,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.45,2.595),(25.45,19.745),(26.15,19.745),(26.15,2.595),(25.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.55,2.595),(16.55,19.745),(16.995,19.745),(16.995,2.595),(16.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((12.365,2.65),(12.365,19.69),(13.105,19.69),(13.105,2.65),(12.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((12.06,2.595),(12.06,19.745),(13.41,19.745),(13.41,2.595),(12.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((22.98,2.595),(22.98,19.745),(23.82,19.745),(23.82,2.595),(22.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.765,2.65),(74.765,19.69),(75.505,19.69),(75.505,2.65),(74.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.46,2.595),(74.46,19.745),(75.81,19.745),(75.81,2.595),(74.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.18,2.595),(42.18,19.745),(43.02,19.745),(43.02,2.595),(42.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((53.805,2.595),(53.805,19.745),(54.25,19.745),(54.25,2.595),(53.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.46,2.595),(26.46,19.745),(27.81,19.745),(27.81,2.595),(26.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.765,2.65),(26.765,19.69),(27.505,19.69),(27.505,2.65),(26.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((72.095,2.65),(72.095,19.69),(72.835,19.69),(72.835,2.65),(72.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((75.78,2.595),(75.78,19.745),(76.62,19.745),(76.62,2.595),(75.78,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.205,2.595),(44.205,19.745),(44.65,19.745),(44.65,2.595),(44.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((56.58,2.595),(56.58,19.745),(57.42,19.745),(57.42,2.595),(56.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((9.695,2.65),(9.695,19.69),(10.435,19.69),(10.435,2.65),(9.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((9.39,2.595),(9.39,19.745),(10.74,19.745),(10.74,2.595),(9.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.79,2.595),(71.79,19.745),(73.14,19.745),(73.14,2.595),(71.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((81.695,2.65),(81.695,19.69),(82.435,19.69),(82.435,2.65),(81.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((81.39,2.595),(81.39,19.745),(82.74,19.745),(82.74,2.595),(81.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((27.78,2.595),(27.78,19.745),(28.62,19.745),(28.62,2.595),(27.78,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.99,2.595),(42.99,19.745),(44.34,19.745),(44.34,2.595),(42.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((62.19,2.595),(62.19,19.745),(63.54,19.745),(63.54,2.595),(62.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((62.495,2.65),(62.495,19.69),(63.235,19.69),(63.235,2.65),(62.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((78.95,2.595),(78.95,19.745),(79.395,19.745),(79.395,2.595),(78.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((8.58,2.595),(8.58,19.745),(9.42,19.745),(9.42,2.595),(8.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.66,2.595),(69.66,19.745),(71.01,19.745),(71.01,2.595),(69.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((29.805,2.595),(29.805,19.745),(30.25,19.745),(30.25,2.595),(29.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((65.165,2.65),(65.165,19.69),(65.905,19.69),(65.905,2.65),(65.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((63.405,2.595),(63.405,19.745),(63.85,19.745),(63.85,2.595),(63.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.95,2.595),(54.95,19.745),(55.395,19.745),(55.395,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.695,2.65),(33.695,19.69),(34.435,19.69),(34.435,2.65),(33.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.39,2.595),(33.39,19.745),(34.74,19.745),(34.74,2.595),(33.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.75,2.595),(35.75,19.745),(36.195,19.745),(36.195,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.66,2.595),(21.66,19.745),(23.01,19.745),(23.01,2.595),(21.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((34.605,2.595),(34.605,19.745),(35.05,19.745),(35.05,2.595),(34.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((18.18,2.595),(18.18,19.745),(19.02,19.745),(19.02,2.595),(18.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((28.895,2.65),(28.895,19.69),(29.635,19.69),(29.635,2.65),(28.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((28.59,2.595),(28.59,19.745),(29.94,19.745),(29.94,2.595),(28.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((18.99,2.595),(18.99,19.745),(20.34,19.745),(20.34,2.595),(18.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.495,2.65),(38.495,19.69),(39.235,19.69),(39.235,2.65),(38.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.19,2.595),(38.19,19.745),(39.54,19.745),(39.54,2.595),(38.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((19.295,2.65),(19.295,19.69),(20.035,19.69),(20.035,2.65),(19.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((20.205,2.595),(20.205,19.745),(20.65,19.745),(20.65,2.595),(20.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.79,2.595),(47.79,19.745),(49.14,19.745),(49.14,2.595),(47.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.965,2.65),(69.965,19.69),(70.705,19.69),(70.705,2.65),(69.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((15.405,2.595),(15.405,19.745),(15.85,19.745),(15.85,2.595),(15.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((37.38,2.595),(37.38,19.745),(38.22,19.745),(38.22,2.595),(37.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((59.75,2.595),(59.75,19.745),(60.195,19.745),(60.195,2.595),(59.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.66,2.595),(45.66,19.745),(47.01,19.745),(47.01,2.595),(45.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((77.805,2.595),(77.805,19.745),(78.25,19.745),(78.25,2.595),(77.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.965,2.65),(21.965,19.69),(22.705,19.69),(22.705,2.65),(21.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((43.295,2.65),(43.295,19.69),(44.035,19.69),(44.035,2.65),(43.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.35,2.595),(69.35,19.745),(69.795,19.745),(69.795,2.595),(69.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((76.895,2.65),(76.895,19.69),(77.635,19.69),(77.635,2.65),(76.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((76.59,2.595),(76.59,19.745),(77.94,19.745),(77.94,2.595),(76.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((61.38,2.595),(61.38,19.745),(62.22,19.745),(62.22,2.595),(61.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((67.295,2.65),(67.295,19.69),(68.035,19.69),(68.035,2.65),(67.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((25.005,2.595),(25.005,19.745),(25.45,19.745),(25.45,2.595),(25.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((39.405,2.595),(39.405,19.745),(39.85,19.745),(39.85,2.595),(39.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.205,2.595),(68.205,19.745),(68.65,19.745),(68.65,2.595),(68.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((30.95,2.595),(30.95,19.745),(31.395,19.745),(31.395,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((46.98,2.595),(46.98,19.745),(47.82,19.745),(47.82,2.595),(46.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.86,2.595),(40.86,19.745),(42.21,19.745),(42.21,2.595),(40.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.35,2.595),(21.35,19.745),(21.795,19.745),(21.795,2.595),(21.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.965,2.65),(45.965,19.69),(46.705,19.69),(46.705,2.65),(45.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((64.86,2.595),(64.86,19.745),(66.21,19.745),(66.21,2.595),(64.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.565,2.65),(31.565,19.69),(32.305,19.69),(32.305,2.65),(31.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.26,2.595),(31.26,19.745),(32.61,19.745),(32.61,2.595),(31.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((48.095,2.65),(48.095,19.69),(48.835,19.69),(48.835,2.65),(48.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((17.165,2.65),(17.165,19.69),(17.905,19.69),(17.905,2.65),(17.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.695,2.65),(57.695,19.69),(58.435,19.69),(58.435,2.65),(57.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.35,2.595),(45.35,19.745),(45.795,19.745),(45.795,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.39,2.595),(57.39,19.745),(58.74,19.745),(58.74,2.595),(57.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.86,2.595),(16.86,19.745),(18.21,19.745),(18.21,2.595),(16.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((6.95,2.595),(6.95,19.745),(7.395,19.745),(7.395,2.595),(6.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((58.605,2.595),(58.605,19.745),(59.05,19.745),(59.05,2.595),(58.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((32.58,2.595),(32.58,19.745),(33.42,19.745),(33.42,2.595),(32.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.26,2.595),(55.26,19.745),(56.61,19.745),(56.61,2.595),(55.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.565,2.65),(55.565,19.69),(56.305,19.69),(56.305,2.65),(55.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((73.005,2.595),(73.005,19.745),(73.45,19.745),(73.45,2.595),(73.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.895,2.65),(52.895,19.69),(53.635,19.69),(53.635,2.65),(52.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.59,2.595),(52.59,19.745),(53.94,19.745),(53.94,2.595),(52.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((10.605,2.595),(10.605,19.745),(11.05,19.745),(11.05,2.595),(10.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.15,2.595),(50.15,19.745),(50.595,19.745),(50.595,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((79.26,2.595),(79.26,19.745),(80.61,19.745),(80.61,2.595),(79.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((79.565,2.65),(79.565,19.69),(80.305,19.69),(80.305,2.65),(79.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((7.26,2.595),(7.26,19.745),(8.61,19.745),(8.61,2.595),(7.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((7.565,2.65),(7.565,19.69),(8.305,19.69),(8.305,2.65),(7.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((82.605,2.595),(82.605,19.745),(83.05,19.745),(83.05,2.595),(82.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.365,2.65),(36.365,19.69),(37.105,19.69),(37.105,2.65),(36.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.06,2.595),(36.06,19.745),(37.41,19.745),(37.41,2.595),(36.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.55,2.595),(40.55,19.745),(40.995,19.745),(40.995,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((11.75,2.595),(11.75,19.745),(12.195,19.745),(12.195,2.595),(11.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((41.165,2.65),(41.165,19.69),(41.905,19.69),(41.905,2.65),(41.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.15,2.595),(74.15,19.745),(74.595,19.745),(74.595,2.595),(74.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((64.55,2.595),(64.55,19.745),(64.995,19.745),(64.995,2.595),(64.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.005,2.595),(49.005,19.745),(49.45,19.745),(49.45,2.595),(49.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((24.095,2.65),(24.095,19.69),(24.835,19.69),(24.835,2.65),(24.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((66.18,2.595),(66.18,19.745),(67.02,19.745),(67.02,2.595),(66.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((14.495,2.65),(14.495,19.69),(15.235,19.69),(15.235,2.65),(14.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((14.19,2.595),(14.19,19.745),(15.54,19.745),(15.54,2.595),(14.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.15,2.595),(26.15,19.745),(26.595,19.745),(26.595,2.595),(26.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.765,2.65),(50.765,19.69),(51.505,19.69),(51.505,2.65),(50.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.46,2.595),(50.46,19.745),(51.81,19.745),(51.81,2.595),(50.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((23.79,2.595),(23.79,19.745),(25.14,19.745),(25.14,2.595),(23.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((60.365,2.65),(60.365,19.69),(61.105,19.69),(61.105,2.65),(60.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((66.99,2.595),(66.99,19.745),(68.34,19.745),(68.34,2.595),(66.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((60.06,2.595),(60.06,19.745),(61.41,19.745),(61.41,2.595),(60.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((13.38,2.595),(13.38,19.745),(14.22,19.745),(14.22,2.595),(13.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.98,2.595),(70.98,19.745),(71.82,19.745),(71.82,2.595),(70.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((80.58,2.595),(80.58,19.745),(81.42,19.745),(81.42,2.595),(80.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((51.78,2.595),(51.78,19.745),(52.62,19.745),(52.62,2.595),(51.78,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.535,2.54),(76.535,19.8),(77.995,19.8),(77.995,2.54),(76.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.765,2.52),(76.765,19.82),(77.765,19.82),(77.765,2.52),(76.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.535,2.54),(52.535,19.8),(53.995,19.8),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.765,2.52),(52.765,19.82),(53.765,19.82),(53.765,2.52),(52.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.635,2.52),(74.635,19.82),(75.635,19.82),(75.635,2.52),(74.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.405,2.54),(74.405,19.8),(75.865,19.8),(75.865,2.54),(74.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.005,2.54),(12.005,19.8),(13.465,19.8),(13.465,2.54),(12.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.235,2.52),(12.235,19.82),(13.235,19.82),(13.235,2.52),(12.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.565,2.52),(33.565,19.82),(34.565,19.82),(34.565,2.52),(33.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.335,2.54),(33.335,19.8),(34.795,19.8),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((65.035,2.52),(65.035,19.82),(66.035,19.82),(66.035,2.52),(65.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.765,2.52),(28.765,19.82),(29.765,19.82),(29.765,2.52),(28.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.965,2.52),(47.965,19.82),(48.965,19.82),(48.965,2.52),(47.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.965,2.52),(71.965,19.82),(72.965,19.82),(72.965,2.52),(71.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((67.165,2.52),(67.165,19.82),(68.165,19.82),(68.165,2.52),(67.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.435,2.52),(79.435,19.82),(80.435,19.82),(80.435,2.52),(79.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.205,2.54),(79.205,19.8),(80.665,19.8),(80.665,2.54),(79.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.805,2.54),(40.805,19.8),(42.265,19.8),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.435,2.52),(7.435,19.82),(8.435,19.82),(8.435,2.52),(7.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.605,2.54),(21.605,19.8),(23.065,19.8),(23.065,2.54),(21.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.205,2.54),(7.205,19.8),(8.665,19.8),(8.665,2.54),(7.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.235,2.52),(36.235,19.82),(37.235,19.82),(37.235,2.52),(36.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((18.935,2.54),(18.935,19.8),(20.395,19.8),(20.395,2.54),(18.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((64.805,2.54),(64.805,19.8),(66.265,19.8),(66.265,2.54),(64.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.005,2.54),(36.005,19.8),(37.465,19.8),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.635,2.52),(26.635,19.82),(27.635,19.82),(27.635,2.52),(26.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.405,2.54),(26.405,19.8),(27.865,19.8),(27.865,2.54),(26.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.365,2.52),(38.365,19.82),(39.365,19.82),(39.365,2.52),(38.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.135,2.54),(38.135,19.8),(39.595,19.8),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((6.05,2.52),(6.05,19.82),(83.95,19.82),(83.95,2.52),(6.05,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.535,2.54),(28.535,19.8),(29.995,19.8),(29.995,2.54),(28.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((19.165,2.52),(19.165,19.82),(20.165,19.82),(20.165,2.52),(19.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.965,2.52),(23.965,19.82),(24.965,19.82),(24.965,2.52),(23.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.435,2.52),(31.435,19.82),(32.435,19.82),(32.435,2.52),(31.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.205,2.54),(31.205,19.8),(32.665,19.8),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.565,2.52),(9.565,19.82),(10.565,19.82),(10.565,2.52),(9.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.335,2.54),(9.335,19.8),(10.795,19.8),(10.795,2.54),(9.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.735,2.54),(47.735,19.8),(49.195,19.8),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.735,2.54),(71.735,19.8),(73.195,19.8),(73.195,2.54),(71.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.835,2.52),(69.835,19.82),(70.835,19.82),(70.835,2.52),(69.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.335,2.54),(81.335,19.8),(82.795,19.8),(82.795,2.54),(81.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.565,2.52),(81.565,19.82),(82.565,19.82),(82.565,2.52),(81.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((17.035,2.52),(17.035,19.82),(18.035,19.82),(18.035,2.52),(17.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.935,2.54),(42.935,19.8),(44.395,19.8),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.605,2.54),(45.605,19.8),(47.065,19.8),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.135,2.54),(62.135,19.8),(63.595,19.8),(63.595,2.54),(62.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.365,2.52),(62.365,19.82),(63.365,19.82),(63.365,2.52),(62.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.135,2.54),(14.135,19.8),(15.595,19.8),(15.595,2.54),(14.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.365,2.52),(14.365,19.82),(15.365,19.82),(15.365,2.52),(14.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.405,2.54),(50.405,19.8),(51.865,19.8),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.635,2.52),(50.635,19.82),(51.635,19.82),(51.635,2.52),(50.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.335,2.54),(57.335,19.8),(58.795,19.8),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.565,2.52),(57.565,19.82),(58.565,19.82),(58.565,2.52),(57.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.735,2.54),(23.735,19.8),(25.195,19.8),(25.195,2.54),(23.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.005,2.54),(60.005,19.8),(61.465,19.8),(61.465,2.54),(60.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.235,2.52),(60.235,19.82),(61.235,19.82),(61.235,2.52),(60.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.835,2.52),(21.835,19.82),(22.835,19.82),(22.835,2.52),(21.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.805,2.54),(16.805,19.8),(18.265,19.8),(18.265,2.54),(16.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((66.935,2.54),(66.935,19.8),(68.395,19.8),(68.395,2.54),(66.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.435,2.52),(55.435,19.82),(56.435,19.82),(56.435,2.52),(55.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.205,2.54),(55.205,19.8),(56.665,19.8),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.165,2.52),(43.165,19.82),(44.165,19.82),(44.165,2.52),(43.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.605,2.54),(69.605,19.8),(71.065,19.8),(71.065,2.54),(69.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.835,2.52),(45.835,19.82),(46.835,19.82),(46.835,2.52),(45.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.035,2.52),(41.035,19.82),(42.035,19.82),(42.035,2.52),(41.035,2.52)),
        )
        createRL(
            tech, net, 'polyres',
            ((85.675,11.005),(85.675,11.335),(86.015,11.335),(86.015,11.005),(85.675,11.005)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,11.005),(85.68,11.335),(86.01,11.335),(86.01,11.005),(85.68,11.005)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,19.62),(32.485,19.62),(32.485,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.915,2.72),(23.915,19.62),(24.165,19.62),(24.165,2.72),(23.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,19.62),(62.095,19.62),(62.095,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.285,2.72),(61.285,19.62),(62.095,19.62),(62.095,2.72),(61.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,19.62),(62.315,19.62),(62.315,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.915,2.72),(47.915,19.62),(48.165,19.62),(48.165,2.72),(47.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(43.115,19.62),(43.115,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.885,2.72),(22.885,19.62),(23.695,19.62),(23.695,2.72),(22.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,19.62),(46.885,19.62),(46.885,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,19.62),(66.895,19.62),(66.895,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.085,2.72),(66.085,19.62),(66.895,19.62),(66.895,2.72),(66.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.315,2.72),(38.315,19.62),(38.565,19.62),(38.565,2.72),(38.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.435,2.72),(27.435,19.62),(27.685,19.62),(27.685,2.72),(27.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.435,2.72),(75.435,19.62),(75.685,19.62),(75.685,2.72),(75.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.295,19.62),(33.295,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,19.62),(71.695,19.62),(71.695,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,19.62),(71.915,19.62),(71.915,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.485,2.72),(32.485,19.62),(33.295,19.62),(33.295,2.72),(32.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,19.62),(19.115,19.62),(19.115,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.885,2.72),(46.885,19.62),(47.695,19.62),(47.695,2.72),(46.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.515,19.62),(33.515,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.515,2.72),(9.515,19.62),(9.765,19.62),(9.765,2.72),(9.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.235,2.72),(80.235,19.62),(80.485,19.62),(80.485,2.72),(80.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.115,2.72),(67.115,19.62),(67.365,19.62),(67.365,2.72),(67.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.035,2.72),(13.035,19.62),(13.285,19.62),(13.285,2.72),(13.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.915,2.72),(71.915,19.62),(72.165,19.62),(72.165,2.72),(71.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,19.62),(76.495,19.62),(76.495,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,19.62),(42.085,19.62),(42.085,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.685,2.72),(75.685,19.62),(76.495,19.62),(76.495,2.72),(75.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,19.62),(76.715,19.62),(76.715,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,19.62),(56.485,19.62),(56.485,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,19.62),(23.695,19.62),(23.695,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,19.62),(23.915,19.62),(23.915,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.235,2.72),(8.235,19.62),(8.485,19.62),(8.485,2.72),(8.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.635,2.72),(70.635,19.62),(70.885,19.62),(70.885,2.72),(70.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.515,2.72),(33.515,19.62),(33.765,19.62),(33.765,2.72),(33.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.485,2.72),(56.485,19.62),(57.295,19.62),(57.295,2.72),(56.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.085,2.72),(42.085,19.62),(42.895,19.62),(42.895,2.72),(42.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.515,2.72),(81.515,19.62),(81.765,19.62),(81.765,2.72),(81.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.295,19.62),(57.295,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(42.895,19.62),(42.895,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.515,19.62),(57.515,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.095,19.62),(38.095,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.695,19.62),(47.695,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.915,19.62),(47.915,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.285,2.72),(37.285,19.62),(38.095,19.62),(38.095,2.72),(37.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.315,19.62),(38.315,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.085,2.72),(18.085,19.62),(18.895,19.62),(18.895,2.72),(18.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,19.62),(18.895,19.62),(18.895,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,19.62),(28.495,19.62),(28.495,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.685,2.72),(27.685,19.62),(28.495,19.62),(28.495,2.72),(27.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,19.62),(28.715,19.62),(28.715,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.715,2.72),(52.715,19.62),(52.965,19.62),(52.965,2.72),(52.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.715,2.72),(76.715,19.62),(76.965,19.62),(76.965,2.72),(76.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.715,2.72),(28.715,19.62),(28.965,19.62),(28.965,2.72),(28.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,19.62),(67.115,19.62),(67.115,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.515,2.72),(57.515,19.62),(57.765,19.62),(57.765,2.72),(57.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,19.62),(9.515,19.62),(9.515,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.485,2.72),(8.485,19.62),(9.295,19.62),(9.295,2.72),(8.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,19.62),(9.295,19.62),(9.295,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,19.62),(51.685,19.62),(51.685,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,19.62),(14.095,19.62),(14.095,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.285,2.72),(13.285,19.62),(14.095,19.62),(14.095,2.72),(13.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,19.62),(14.315,19.62),(14.315,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.115,2.72),(19.115,19.62),(19.365,19.62),(19.365,2.72),(19.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.885,2.72),(70.885,19.62),(71.695,19.62),(71.695,2.72),(70.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.115,2.72),(43.115,19.62),(43.365,19.62),(43.365,2.72),(43.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.035,2.72),(61.035,19.62),(61.285,19.62),(61.285,2.72),(61.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,19.62),(81.295,19.62),(81.295,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.485,2.72),(80.485,19.62),(81.295,19.62),(81.295,2.72),(80.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,19.62),(81.515,19.62),(81.515,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,19.62),(37.285,19.62),(37.285,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.315,2.72),(62.315,19.62),(62.565,19.62),(62.565,2.72),(62.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.835,2.72),(65.835,19.62),(66.085,19.62),(66.085,2.72),(65.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.835,2.72),(17.835,19.62),(18.085,19.62),(18.085,2.72),(17.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.315,2.72),(14.315,19.62),(14.565,19.62),(14.565,2.72),(14.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.495,19.62),(52.495,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.685,2.72),(51.685,19.62),(52.495,19.62),(52.495,2.72),(51.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.715,19.62),(52.715,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.635,2.72),(22.635,19.62),(22.885,19.62),(22.885,2.72),(22.635,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.165),(18.345,15.335),(18.515,15.335),(18.515,15.165),(18.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.165),(18.685,15.335),(18.855,15.335),(18.855,15.165),(18.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.505),(18.345,15.675),(18.515,15.675),(18.515,15.505),(18.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.425),(75.945,11.595),(76.115,11.595),(76.115,11.425),(75.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.765),(75.945,11.935),(76.115,11.935),(76.115,11.765),(75.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.505),(18.685,15.675),(18.855,15.675),(18.855,15.505),(18.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.085),(75.945,11.255),(76.115,11.255),(76.115,11.085),(75.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.985),(23.145,6.155),(23.315,6.155),(23.315,5.985),(23.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.985),(23.485,6.155),(23.655,6.155),(23.655,5.985),(23.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.245),(32.745,19.415),(32.915,19.415),(32.915,19.245),(32.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.085),(27.945,11.255),(28.115,11.255),(28.115,11.085),(27.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.765),(27.945,11.935),(28.115,11.935),(28.115,11.765),(27.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.425),(27.945,11.595),(28.115,11.595),(28.115,11.425),(27.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.905),(76.285,19.075),(76.455,19.075),(76.455,18.905),(76.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.945),(61.545,4.115),(61.715,4.115),(61.715,3.945),(61.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.285),(56.745,4.455),(56.915,4.455),(56.915,4.285),(56.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.625),(56.745,4.795),(56.915,4.795),(56.915,4.625),(56.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.425),(81.085,11.595),(81.255,11.595),(81.255,11.425),(81.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.085),(81.085,11.255),(81.255,11.255),(81.255,11.085),(81.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.765),(81.085,11.935),(81.255,11.935),(81.255,11.765),(81.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.145),(80.745,14.315),(80.915,14.315),(80.915,14.145),(80.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.485),(80.745,14.655),(80.915,14.655),(80.915,14.485),(80.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.825),(80.745,14.995),(80.915,14.995),(80.915,14.825),(80.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.285),(32.745,4.455),(32.915,4.455),(32.915,4.285),(32.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.625),(32.745,4.795),(32.915,4.795),(32.915,4.625),(32.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.945),(13.545,4.115),(13.715,4.115),(13.715,3.945),(13.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.285),(13.545,4.455),(13.715,4.455),(13.715,4.285),(13.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.625),(13.545,4.795),(13.715,4.795),(13.715,4.625),(13.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.285),(8.745,4.455),(8.915,4.455),(8.915,4.285),(8.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.625),(8.745,4.795),(8.915,4.795),(8.915,4.625),(8.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.305),(27.945,5.475),(28.115,5.475),(28.115,5.305),(27.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.645),(27.945,5.815),(28.115,5.815),(28.115,5.645),(27.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.385),(51.945,9.555),(52.115,9.555),(52.115,9.385),(51.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.725),(51.945,9.895),(52.115,9.895),(52.115,9.725),(51.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.485),(76.285,14.655),(76.455,14.655),(76.455,14.485),(76.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.825),(76.285,14.995),(76.455,14.995),(76.455,14.825),(76.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.145),(76.285,14.315),(76.455,14.315),(76.455,14.145),(76.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.785),(18.685,12.955),(18.855,12.955),(18.855,12.785),(18.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.445),(18.345,12.615),(18.515,12.615),(18.515,12.445),(18.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.445),(18.685,12.615),(18.855,12.615),(18.855,12.445),(18.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.785),(18.345,12.955),(18.515,12.955),(18.515,12.785),(18.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.105),(18.345,12.275),(18.515,12.275),(18.515,12.105),(18.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.105),(18.685,12.275),(18.855,12.275),(18.855,12.105),(18.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.205),(61.545,17.375),(61.715,17.375),(61.715,17.205),(61.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.545),(61.545,17.715),(61.715,17.715),(61.715,17.545),(61.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.025),(13.545,8.195),(13.715,8.195),(13.715,8.025),(13.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.365),(13.545,8.535),(13.715,8.535),(13.715,8.365),(13.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.705),(13.545,8.875),(13.715,8.875),(13.715,8.705),(13.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.265),(37.885,3.435),(38.055,3.435),(38.055,3.265),(37.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.605),(37.885,3.775),(38.055,3.775),(38.055,3.605),(37.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.865),(61.885,17.035),(62.055,17.035),(62.055,16.865),(61.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.965),(27.945,5.135),(28.115,5.135),(28.115,4.965),(27.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.385),(81.085,9.555),(81.255,9.555),(81.255,9.385),(81.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.725),(81.085,9.895),(81.255,9.895),(81.255,9.725),(81.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.845),(18.345,16.015),(18.515,16.015),(18.515,15.845),(18.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.845),(18.685,16.015),(18.855,16.015),(18.855,15.845),(18.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.565),(52.285,18.735),(52.455,18.735),(52.455,18.565),(52.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.225),(52.285,18.395),(52.455,18.395),(52.455,18.225),(52.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.305),(51.945,5.475),(52.115,5.475),(52.115,5.305),(51.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.645),(51.945,5.815),(52.115,5.815),(52.115,5.645),(51.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.285),(61.545,4.455),(61.715,4.455),(61.715,4.285),(61.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.625),(61.545,4.795),(61.715,4.795),(61.715,4.625),(61.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.005),(52.285,7.175),(52.455,7.175),(52.455,7.005),(52.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.345),(52.285,7.515),(52.455,7.515),(52.455,7.345),(52.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.685),(52.285,7.855),(52.455,7.855),(52.455,7.685),(52.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.245),(33.085,19.415),(33.255,19.415),(33.255,19.245),(33.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.445),(47.485,12.615),(47.655,12.615),(47.655,12.445),(47.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.785),(47.485,12.955),(47.655,12.955),(47.655,12.785),(47.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.445),(47.145,12.615),(47.315,12.615),(47.315,12.445),(47.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.105),(47.145,12.275),(47.315,12.275),(47.315,12.105),(47.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.105),(47.485,12.275),(47.655,12.275),(47.655,12.105),(47.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.785),(47.145,12.955),(47.315,12.955),(47.315,12.785),(47.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.385),(27.945,9.555),(28.115,9.555),(28.115,9.385),(27.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.725),(27.945,9.895),(28.115,9.895),(28.115,9.725),(27.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.045),(61.885,9.215),(62.055,9.215),(62.055,9.045),(61.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.165),(66.345,15.335),(66.515,15.335),(66.515,15.165),(66.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.165),(66.685,15.335),(66.855,15.335),(66.855,15.165),(66.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.505),(66.345,15.675),(66.515,15.675),(66.515,15.505),(66.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.885),(57.085,18.055),(57.255,18.055),(57.255,17.885),(57.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.505),(66.685,15.675),(66.855,15.675),(66.855,15.505),(66.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.925),(52.285,3.095),(52.455,3.095),(52.455,2.925),(52.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.865),(71.145,17.035),(71.315,17.035),(71.315,16.865),(71.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.865),(71.485,17.035),(71.655,17.035),(71.655,16.865),(71.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.245),(23.485,19.415),(23.655,19.415),(23.655,19.245),(23.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.245),(23.145,19.415),(23.315,19.415),(23.315,19.245),(23.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.045),(71.145,9.215),(71.315,9.215),(71.315,9.045),(71.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.045),(71.485,9.215),(71.655,9.215),(71.655,9.045),(71.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.345),(28.285,7.515),(28.455,7.515),(28.455,7.345),(28.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.005),(28.285,7.175),(28.455,7.175),(28.455,7.005),(28.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.045),(13.885,9.215),(14.055,9.215),(14.055,9.045),(13.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.365),(61.545,8.535),(61.715,8.535),(61.715,8.365),(61.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.705),(61.545,8.875),(61.715,8.875),(61.715,8.705),(61.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.025),(61.545,8.195),(61.715,8.195),(61.715,8.025),(61.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.645),(81.085,5.815),(81.255,5.815),(81.255,5.645),(81.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.305),(81.085,5.475),(81.255,5.475),(81.255,5.305),(81.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.065),(66.345,10.235),(66.515,10.235),(66.515,10.065),(66.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.065),(66.685,10.235),(66.855,10.235),(66.855,10.065),(66.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.745),(66.345,10.915),(66.515,10.915),(66.515,10.745),(66.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.745),(66.685,10.915),(66.855,10.915),(66.855,10.745),(66.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.405),(66.685,10.575),(66.855,10.575),(66.855,10.405),(66.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.405),(66.345,10.575),(66.515,10.575),(66.515,10.405),(66.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.765),(28.285,11.935),(28.455,11.935),(28.455,11.765),(28.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.085),(28.285,11.255),(28.455,11.255),(28.455,11.085),(28.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.425),(28.285,11.595),(28.455,11.595),(28.455,11.425),(28.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.145),(23.145,14.315),(23.315,14.315),(23.315,14.145),(23.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.145),(23.485,14.315),(23.655,14.315),(23.655,14.145),(23.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.485),(23.145,14.655),(23.315,14.655),(23.315,14.485),(23.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.485),(23.485,14.655),(23.655,14.655),(23.655,14.485),(23.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.825),(23.145,14.995),(23.315,14.995),(23.315,14.825),(23.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.825),(23.485,14.995),(23.655,14.995),(23.655,14.825),(23.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.065),(51.945,10.235),(52.115,10.235),(52.115,10.065),(51.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.745),(51.945,10.915),(52.115,10.915),(52.115,10.745),(51.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.405),(51.945,10.575),(52.115,10.575),(52.115,10.405),(51.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.865),(33.085,17.035),(33.255,17.035),(33.255,16.865),(33.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.105),(66.685,12.275),(66.855,12.275),(66.855,12.105),(66.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.445),(66.345,12.615),(66.515,12.615),(66.515,12.445),(66.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.445),(66.685,12.615),(66.855,12.615),(66.855,12.445),(66.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.785),(66.345,12.955),(66.515,12.955),(66.515,12.785),(66.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.785),(66.685,12.955),(66.855,12.955),(66.855,12.785),(66.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.105),(66.345,12.275),(66.515,12.275),(66.515,12.105),(66.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.765),(47.145,11.935),(47.315,11.935),(47.315,11.765),(47.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.765),(47.485,11.935),(47.655,11.935),(47.655,11.765),(47.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.425),(47.145,11.595),(47.315,11.595),(47.315,11.425),(47.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.425),(47.485,11.595),(47.655,11.595),(47.655,11.425),(47.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.085),(47.145,11.255),(47.315,11.255),(47.315,11.085),(47.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.085),(47.485,11.255),(47.655,11.255),(47.655,11.085),(47.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.145),(9.085,14.315),(9.255,14.315),(9.255,14.145),(9.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.485),(9.085,14.655),(9.255,14.655),(9.255,14.485),(9.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.825),(9.085,14.995),(9.255,14.995),(9.255,14.825),(9.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.325),(28.285,6.495),(28.455,6.495),(28.455,6.325),(28.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.665),(28.285,6.835),(28.455,6.835),(28.455,6.665),(28.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.265),(66.685,3.435),(66.855,3.435),(66.855,3.265),(66.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.265),(66.345,3.435),(66.515,3.435),(66.515,3.265),(66.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.605),(66.345,3.775),(66.515,3.775),(66.515,3.605),(66.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.605),(66.685,3.775),(66.855,3.775),(66.855,3.605),(66.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.365),(18.345,8.535),(18.515,8.535),(18.515,8.365),(18.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.365),(18.685,8.535),(18.855,8.535),(18.855,8.365),(18.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.705),(18.685,8.875),(18.855,8.875),(18.855,8.705),(18.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.705),(18.345,8.875),(18.515,8.875),(18.515,8.705),(18.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.025),(18.345,8.195),(18.515,8.195),(18.515,8.025),(18.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.025),(18.685,8.195),(18.855,8.195),(18.855,8.025),(18.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.945),(28.285,4.115),(28.455,4.115),(28.455,3.945),(28.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.965),(76.285,5.135),(76.455,5.135),(76.455,4.965),(76.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.065),(18.685,10.235),(18.855,10.235),(18.855,10.065),(18.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.745),(18.685,10.915),(18.855,10.915),(18.855,10.745),(18.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.745),(18.345,10.915),(18.515,10.915),(18.515,10.745),(18.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.405),(18.685,10.575),(18.855,10.575),(18.855,10.405),(18.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.405),(18.345,10.575),(18.515,10.575),(18.515,10.405),(18.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.065),(18.345,10.235),(18.515,10.235),(18.515,10.065),(18.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.205),(71.145,17.375),(71.315,17.375),(71.315,17.205),(71.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.205),(71.485,17.375),(71.655,17.375),(71.655,17.205),(71.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.545),(71.145,17.715),(71.315,17.715),(71.315,17.545),(71.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.545),(71.485,17.715),(71.655,17.715),(71.655,17.545),(71.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.965),(28.285,5.135),(28.455,5.135),(28.455,4.965),(28.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.845),(66.345,16.015),(66.515,16.015),(66.515,15.845),(66.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.845),(66.685,16.015),(66.855,16.015),(66.855,15.845),(66.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.185),(37.545,16.355),(37.715,16.355),(37.715,16.185),(37.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.525),(37.545,16.695),(37.715,16.695),(37.715,16.525),(37.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.845),(33.085,16.015),(33.255,16.015),(33.255,15.845),(33.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.205),(37.885,17.375),(38.055,17.375),(38.055,17.205),(37.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.545),(37.885,17.715),(38.055,17.715),(38.055,17.545),(37.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.185),(52.285,16.355),(52.455,16.355),(52.455,16.185),(52.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.525),(52.285,16.695),(52.455,16.695),(52.455,16.525),(52.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.325),(75.945,6.495),(76.115,6.495),(76.115,6.325),(75.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.665),(75.945,6.835),(76.115,6.835),(76.115,6.665),(75.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.285),(80.745,4.455),(80.915,4.455),(80.915,4.285),(80.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.625),(80.745,4.795),(80.915,4.795),(80.915,4.625),(80.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.325),(27.945,6.495),(28.115,6.495),(28.115,6.325),(27.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.665),(27.945,6.835),(28.115,6.835),(28.115,6.665),(27.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.965),(75.945,5.135),(76.115,5.135),(76.115,4.965),(75.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.105),(51.945,12.275),(52.115,12.275),(52.115,12.105),(51.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.445),(51.945,12.615),(52.115,12.615),(52.115,12.445),(51.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.785),(51.945,12.955),(52.115,12.955),(52.115,12.785),(51.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.325),(52.285,6.495),(52.455,6.495),(52.455,6.325),(52.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.665),(52.285,6.835),(52.455,6.835),(52.455,6.665),(52.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.905),(27.945,19.075),(28.115,19.075),(28.115,18.905),(27.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.025),(52.285,8.195),(52.455,8.195),(52.455,8.025),(52.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.705),(52.285,8.875),(52.455,8.875),(52.455,8.705),(52.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.365),(52.285,8.535),(52.455,8.535),(52.455,8.365),(52.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.225),(37.885,18.395),(38.055,18.395),(38.055,18.225),(37.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.565),(37.885,18.735),(38.055,18.735),(38.055,18.565),(37.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.845),(81.085,16.015),(81.255,16.015),(81.255,15.845),(81.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.885),(42.345,18.055),(42.515,18.055),(42.515,17.885),(42.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.885),(42.685,18.055),(42.855,18.055),(42.855,17.885),(42.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.745),(33.085,10.915),(33.255,10.915),(33.255,10.745),(33.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.485),(57.085,14.655),(57.255,14.655),(57.255,14.485),(57.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.825),(57.085,14.995),(57.255,14.995),(57.255,14.825),(57.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.405),(33.085,10.575),(33.255,10.575),(33.255,10.405),(33.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.065),(33.085,10.235),(33.255,10.235),(33.255,10.065),(33.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.145),(57.085,14.315),(57.255,14.315),(57.255,14.145),(57.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.345),(71.485,7.515),(71.655,7.515),(71.655,7.345),(71.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.345),(71.145,7.515),(71.315,7.515),(71.315,7.345),(71.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.005),(71.145,7.175),(71.315,7.175),(71.315,7.005),(71.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.005),(71.485,7.175),(71.655,7.175),(71.655,7.005),(71.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.865),(13.885,17.035),(14.055,17.035),(14.055,16.865),(13.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.945),(66.345,4.115),(66.515,4.115),(66.515,3.945),(66.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.945),(66.685,4.115),(66.855,4.115),(66.855,3.945),(66.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.385),(75.945,9.555),(76.115,9.555),(76.115,9.385),(75.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.725),(75.945,9.895),(76.115,9.895),(76.115,9.725),(75.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.985),(37.545,6.155),(37.715,6.155),(37.715,5.985),(37.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.885),(75.945,18.055),(76.115,18.055),(76.115,17.885),(75.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.905),(56.745,19.075),(56.915,19.075),(56.915,18.905),(56.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.465),(66.345,13.635),(66.515,13.635),(66.515,13.465),(66.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.805),(66.345,13.975),(66.515,13.975),(66.515,13.805),(66.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.465),(66.685,13.635),(66.855,13.635),(66.855,13.465),(66.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.805),(66.685,13.975),(66.855,13.975),(66.855,13.805),(66.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.125),(66.345,13.295),(66.515,13.295),(66.515,13.125),(66.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.125),(66.685,13.295),(66.855,13.295),(66.855,13.125),(66.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.185),(42.345,16.355),(42.515,16.355),(42.515,16.185),(42.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.185),(42.685,16.355),(42.855,16.355),(42.855,16.185),(42.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.525),(42.345,16.695),(42.515,16.695),(42.515,16.525),(42.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.525),(42.685,16.695),(42.855,16.695),(42.855,16.525),(42.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.685),(37.545,7.855),(37.715,7.855),(37.715,7.685),(37.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.185),(57.085,16.355),(57.255,16.355),(57.255,16.185),(57.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.525),(57.085,16.695),(57.255,16.695),(57.255,16.525),(57.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.985),(52.285,6.155),(52.455,6.155),(52.455,5.985),(52.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.365),(66.685,8.535),(66.855,8.535),(66.855,8.365),(66.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.705),(66.345,8.875),(66.515,8.875),(66.515,8.705),(66.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.025),(66.345,8.195),(66.515,8.195),(66.515,8.025),(66.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.025),(66.685,8.195),(66.855,8.195),(66.855,8.025),(66.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.365),(66.345,8.535),(66.515,8.535),(66.515,8.365),(66.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.705),(66.685,8.875),(66.855,8.875),(66.855,8.705),(66.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.745),(75.945,10.915),(76.115,10.915),(76.115,10.745),(75.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.405),(75.945,10.575),(76.115,10.575),(76.115,10.405),(75.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.025),(76.285,8.195),(76.455,8.195),(76.455,8.025),(76.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.065),(75.945,10.235),(76.115,10.235),(76.115,10.065),(75.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.365),(76.285,8.535),(76.455,8.535),(76.455,8.365),(76.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.705),(76.285,8.875),(76.455,8.875),(76.455,8.705),(76.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.385),(42.345,9.555),(42.515,9.555),(42.515,9.385),(42.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.385),(42.685,9.555),(42.855,9.555),(42.855,9.385),(42.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.725),(42.345,9.895),(42.515,9.895),(42.515,9.725),(42.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.605),(27.945,3.775),(28.115,3.775),(28.115,3.605),(27.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.765),(76.285,11.935),(76.455,11.935),(76.455,11.765),(76.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.425),(76.285,11.595),(76.455,11.595),(76.455,11.425),(76.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.085),(76.285,11.255),(76.455,11.255),(76.455,11.085),(76.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.245),(52.285,19.415),(52.455,19.415),(52.455,19.245),(52.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.265),(27.945,3.435),(28.115,3.435),(28.115,3.265),(27.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.725),(42.685,9.895),(42.855,9.895),(42.855,9.725),(42.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.485),(71.485,14.655),(71.655,14.655),(71.655,14.485),(71.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.825),(71.145,14.995),(71.315,14.995),(71.315,14.825),(71.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.825),(71.485,14.995),(71.655,14.995),(71.655,14.825),(71.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.485),(71.145,14.655),(71.315,14.655),(71.315,14.485),(71.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.145),(71.145,14.315),(71.315,14.315),(71.315,14.145),(71.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.145),(71.485,14.315),(71.655,14.315),(71.655,14.145),(71.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,2.925),(23.145,3.095),(23.315,3.095),(23.315,2.925),(23.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,2.925),(23.485,3.095),(23.655,3.095),(23.655,2.925),(23.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.745),(27.945,10.915),(28.115,10.915),(28.115,10.745),(27.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.065),(27.945,10.235),(28.115,10.235),(28.115,10.065),(27.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.405),(27.945,10.575),(28.115,10.575),(28.115,10.405),(27.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.025),(28.285,8.195),(28.455,8.195),(28.455,8.025),(28.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.365),(28.285,8.535),(28.455,8.535),(28.455,8.365),(28.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.705),(28.285,8.875),(28.455,8.875),(28.455,8.705),(28.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.985),(76.285,6.155),(76.455,6.155),(76.455,5.985),(76.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.565),(47.145,18.735),(47.315,18.735),(47.315,18.565),(47.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.225),(47.145,18.395),(47.315,18.395),(47.315,18.225),(47.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.225),(47.485,18.395),(47.655,18.395),(47.655,18.225),(47.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.565),(47.485,18.735),(47.655,18.735),(47.655,18.565),(47.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.005),(13.545,7.175),(13.715,7.175),(13.715,7.005),(13.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.345),(13.545,7.515),(13.715,7.515),(13.715,7.345),(13.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.905),(57.085,19.075),(57.255,19.075),(57.255,18.905),(57.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.225),(37.545,18.395),(37.715,18.395),(37.715,18.225),(37.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.565),(37.545,18.735),(37.715,18.735),(37.715,18.565),(37.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.205),(13.545,17.375),(13.715,17.375),(13.715,17.205),(13.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.545),(13.545,17.715),(13.715,17.715),(13.715,17.545),(13.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,2.925),(66.685,3.095),(66.855,3.095),(66.855,2.925),(66.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,2.925),(66.345,3.095),(66.515,3.095),(66.515,2.925),(66.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.125),(18.345,13.295),(18.515,13.295),(18.515,13.125),(18.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.125),(18.685,13.295),(18.855,13.295),(18.855,13.125),(18.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.465),(18.685,13.635),(18.855,13.635),(18.855,13.465),(18.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.465),(18.345,13.635),(18.515,13.635),(18.515,13.465),(18.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.805),(18.345,13.975),(18.515,13.975),(18.515,13.805),(18.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.805),(18.685,13.975),(18.855,13.975),(18.855,13.805),(18.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.965),(71.145,5.135),(71.315,5.135),(71.315,4.965),(71.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.965),(71.485,5.135),(71.655,5.135),(71.655,4.965),(71.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.965),(23.145,5.135),(23.315,5.135),(23.315,4.965),(23.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.965),(23.485,5.135),(23.655,5.135),(23.655,4.965),(23.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.205),(51.945,17.375),(52.115,17.375),(52.115,17.205),(51.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.545),(51.945,17.715),(52.115,17.715),(52.115,17.545),(51.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.445),(23.145,12.615),(23.315,12.615),(23.315,12.445),(23.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.745),(81.085,10.915),(81.255,10.915),(81.255,10.745),(81.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.405),(81.085,10.575),(81.255,10.575),(81.255,10.405),(81.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.065),(81.085,10.235),(81.255,10.235),(81.255,10.065),(81.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.465),(33.085,13.635),(33.255,13.635),(33.255,13.465),(33.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.805),(33.085,13.975),(33.255,13.975),(33.255,13.805),(33.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.125),(33.085,13.295),(33.255,13.295),(33.255,13.125),(33.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,2.925),(13.545,3.095),(13.715,3.095),(13.715,2.925),(13.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.865),(81.085,17.035),(81.255,17.035),(81.255,16.865),(81.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.985),(57.085,6.155),(57.255,6.155),(57.255,5.985),(57.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.245),(71.145,19.415),(71.315,19.415),(71.315,19.245),(71.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.245),(71.485,19.415),(71.655,19.415),(71.655,19.245),(71.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.985),(33.085,6.155),(33.255,6.155),(33.255,5.985),(33.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,2.925),(18.685,3.095),(18.855,3.095),(18.855,2.925),(18.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,2.925),(18.345,3.095),(18.515,3.095),(18.515,2.925),(18.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.985),(9.085,6.155),(9.255,6.155),(9.255,5.985),(9.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.925),(47.145,3.095),(47.315,3.095),(47.315,2.925),(47.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.925),(47.485,3.095),(47.655,3.095),(47.655,2.925),(47.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.105),(27.945,12.275),(28.115,12.275),(28.115,12.105),(27.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.445),(27.945,12.615),(28.115,12.615),(28.115,12.445),(27.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.785),(27.945,12.955),(28.115,12.955),(28.115,12.785),(27.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.245),(80.745,19.415),(80.915,19.415),(80.915,19.245),(80.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.885),(9.085,18.055),(9.255,18.055),(9.255,17.885),(9.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.345),(57.085,7.515),(57.255,7.515),(57.255,7.345),(57.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.685),(57.085,7.855),(57.255,7.855),(57.255,7.685),(57.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.005),(57.085,7.175),(57.255,7.175),(57.255,7.005),(57.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.245),(81.085,19.415),(81.255,19.415),(81.255,19.245),(81.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.825),(37.885,14.995),(38.055,14.995),(38.055,14.825),(37.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.485),(37.885,14.655),(38.055,14.655),(38.055,14.485),(37.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.145),(37.885,14.315),(38.055,14.315),(38.055,14.145),(37.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.005),(33.085,7.175),(33.255,7.175),(33.255,7.005),(33.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.345),(33.085,7.515),(33.255,7.515),(33.255,7.345),(33.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.685),(33.085,7.855),(33.255,7.855),(33.255,7.685),(33.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.285),(13.885,4.455),(14.055,4.455),(14.055,4.285),(13.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.625),(13.885,4.795),(14.055,4.795),(14.055,4.625),(13.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.685),(9.085,7.855),(9.255,7.855),(9.255,7.685),(9.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.005),(9.085,7.175),(9.255,7.175),(9.255,7.005),(9.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.345),(9.085,7.515),(9.255,7.515),(9.255,7.345),(9.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.925),(42.345,3.095),(42.515,3.095),(42.515,2.925),(42.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.925),(42.685,3.095),(42.855,3.095),(42.855,2.925),(42.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.065),(47.145,10.235),(47.315,10.235),(47.315,10.065),(47.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.065),(47.485,10.235),(47.655,10.235),(47.655,10.065),(47.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.325),(23.145,6.495),(23.315,6.495),(23.315,6.325),(23.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.325),(23.485,6.495),(23.655,6.495),(23.655,6.325),(23.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.665),(23.145,6.835),(23.315,6.835),(23.315,6.665),(23.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.665),(23.485,6.835),(23.655,6.835),(23.655,6.665),(23.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.405),(47.145,10.575),(47.315,10.575),(47.315,10.405),(47.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.405),(47.485,10.575),(47.655,10.575),(47.655,10.405),(47.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.745),(47.145,10.915),(47.315,10.915),(47.315,10.745),(47.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.745),(47.485,10.915),(47.655,10.915),(47.655,10.745),(47.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.965),(47.485,5.135),(47.655,5.135),(47.655,4.965),(47.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.965),(47.145,5.135),(47.315,5.135),(47.315,4.965),(47.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.185),(32.745,16.355),(32.915,16.355),(32.915,16.185),(32.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.525),(32.745,16.695),(32.915,16.695),(32.915,16.525),(32.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.905),(61.885,19.075),(62.055,19.075),(62.055,18.905),(61.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.025),(47.145,8.195),(47.315,8.195),(47.315,8.025),(47.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.025),(47.485,8.195),(47.655,8.195),(47.655,8.025),(47.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.365),(47.145,8.535),(47.315,8.535),(47.315,8.365),(47.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.365),(47.485,8.535),(47.655,8.535),(47.655,8.365),(47.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.705),(47.145,8.875),(47.315,8.875),(47.315,8.705),(47.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.705),(47.485,8.875),(47.655,8.875),(47.655,8.705),(47.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.365),(81.085,8.535),(81.255,8.535),(81.255,8.365),(81.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.705),(81.085,8.875),(81.255,8.875),(81.255,8.705),(81.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.025),(81.085,8.195),(81.255,8.195),(81.255,8.025),(81.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.045),(66.345,9.215),(66.515,9.215),(66.515,9.045),(66.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.045),(66.685,9.215),(66.855,9.215),(66.855,9.045),(66.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.345),(81.085,7.515),(81.255,7.515),(81.255,7.345),(81.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.685),(81.085,7.855),(81.255,7.855),(81.255,7.685),(81.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.005),(81.085,7.175),(81.255,7.175),(81.255,7.005),(81.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.205),(47.485,17.375),(47.655,17.375),(47.655,17.205),(47.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.545),(47.145,17.715),(47.315,17.715),(47.315,17.545),(47.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.205),(47.145,17.375),(47.315,17.375),(47.315,17.205),(47.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.545),(47.485,17.715),(47.655,17.715),(47.655,17.545),(47.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,2.925),(61.545,3.095),(61.715,3.095),(61.715,2.925),(61.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.305),(61.885,5.475),(62.055,5.475),(62.055,5.305),(61.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.645),(61.885,5.815),(62.055,5.815),(62.055,5.645),(61.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.305),(13.885,5.475),(14.055,5.475),(14.055,5.305),(13.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.645),(13.885,5.815),(14.055,5.815),(14.055,5.645),(13.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,2.925),(71.145,3.095),(71.315,3.095),(71.315,2.925),(71.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,2.925),(71.485,3.095),(71.655,3.095),(71.655,2.925),(71.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.845),(32.745,16.015),(32.915,16.015),(32.915,15.845),(32.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.145),(13.885,14.315),(14.055,14.315),(14.055,14.145),(13.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.485),(13.885,14.655),(14.055,14.655),(14.055,14.485),(13.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.825),(13.885,14.995),(14.055,14.995),(14.055,14.825),(13.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.285),(61.885,4.455),(62.055,4.455),(62.055,4.285),(61.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.625),(61.885,4.795),(62.055,4.795),(62.055,4.625),(61.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.045),(8.745,9.215),(8.915,9.215),(8.915,9.045),(8.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.025),(33.085,8.195),(33.255,8.195),(33.255,8.025),(33.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.365),(33.085,8.535),(33.255,8.535),(33.255,8.365),(33.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.705),(33.085,8.875),(33.255,8.875),(33.255,8.705),(33.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.045),(18.345,9.215),(18.515,9.215),(18.515,9.045),(18.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.045),(18.685,9.215),(18.855,9.215),(18.855,9.045),(18.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.325),(13.545,6.495),(13.715,6.495),(13.715,6.325),(13.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.665),(13.545,6.835),(13.715,6.835),(13.715,6.665),(13.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.785),(23.145,12.955),(23.315,12.955),(23.315,12.785),(23.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.185),(9.085,16.355),(9.255,16.355),(9.255,16.185),(9.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.525),(9.085,16.695),(9.255,16.695),(9.255,16.525),(9.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.425),(18.685,11.595),(18.855,11.595),(18.855,11.425),(18.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.425),(18.345,11.595),(18.515,11.595),(18.515,11.425),(18.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.765),(18.345,11.935),(18.515,11.935),(18.515,11.765),(18.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.765),(18.685,11.935),(18.855,11.935),(18.855,11.765),(18.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.085),(18.345,11.255),(18.515,11.255),(18.515,11.085),(18.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.085),(18.685,11.255),(18.855,11.255),(18.855,11.085),(18.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.905),(75.945,19.075),(76.115,19.075),(76.115,18.905),(75.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.325),(47.145,6.495),(47.315,6.495),(47.315,6.325),(47.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.325),(47.485,6.495),(47.655,6.495),(47.655,6.325),(47.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.665),(47.145,6.835),(47.315,6.835),(47.315,6.665),(47.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.665),(47.485,6.835),(47.655,6.835),(47.655,6.665),(47.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.205),(42.345,17.375),(42.515,17.375),(42.515,17.205),(42.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.205),(42.685,17.375),(42.855,17.375),(42.855,17.205),(42.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.545),(42.345,17.715),(42.515,17.715),(42.515,17.545),(42.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.545),(42.685,17.715),(42.855,17.715),(42.855,17.545),(42.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.905),(9.085,19.075),(9.255,19.075),(9.255,18.905),(9.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.885),(28.285,18.055),(28.455,18.055),(28.455,17.885),(28.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.105),(75.945,12.275),(76.115,12.275),(76.115,12.105),(75.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.445),(75.945,12.615),(76.115,12.615),(76.115,12.445),(75.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.785),(75.945,12.955),(76.115,12.955),(76.115,12.785),(75.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.885),(32.745,18.055),(32.915,18.055),(32.915,17.885),(32.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.145),(61.885,14.315),(62.055,14.315),(62.055,14.145),(61.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.485),(61.885,14.655),(62.055,14.655),(62.055,14.485),(61.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.825),(61.885,14.995),(62.055,14.995),(62.055,14.825),(61.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.245),(27.945,19.415),(28.115,19.415),(28.115,19.245),(27.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.045),(56.745,9.215),(56.915,9.215),(56.915,9.045),(56.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.905),(8.745,19.075),(8.915,19.075),(8.915,18.905),(8.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.325),(61.545,6.495),(61.715,6.495),(61.715,6.325),(61.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.665),(61.545,6.835),(61.715,6.835),(61.715,6.665),(61.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.645),(52.285,5.815),(52.455,5.815),(52.455,5.645),(52.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.305),(52.285,5.475),(52.455,5.475),(52.455,5.305),(52.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.125),(81.085,13.295),(81.255,13.295),(81.255,13.125),(81.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.465),(81.085,13.635),(81.255,13.635),(81.255,13.465),(81.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.805),(81.085,13.975),(81.255,13.975),(81.255,13.805),(81.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.445),(81.085,12.615),(81.255,12.615),(81.255,12.445),(81.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.785),(81.085,12.955),(81.255,12.955),(81.255,12.785),(81.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.105),(81.085,12.275),(81.255,12.275),(81.255,12.105),(81.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.945),(27.945,4.115),(28.115,4.115),(28.115,3.945),(27.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.185),(51.945,16.355),(52.115,16.355),(52.115,16.185),(51.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.525),(51.945,16.695),(52.115,16.695),(52.115,16.525),(51.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.005),(8.745,7.175),(8.915,7.175),(8.915,7.005),(8.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.345),(8.745,7.515),(8.915,7.515),(8.915,7.345),(8.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.305),(76.285,5.475),(76.455,5.475),(76.455,5.305),(76.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.645),(76.285,5.815),(76.455,5.815),(76.455,5.645),(76.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.325),(71.145,6.495),(71.315,6.495),(71.315,6.325),(71.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.325),(71.485,6.495),(71.655,6.495),(71.655,6.325),(71.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.665),(71.145,6.835),(71.315,6.835),(71.315,6.665),(71.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.665),(71.485,6.835),(71.655,6.835),(71.655,6.665),(71.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.845),(80.745,16.015),(80.915,16.015),(80.915,15.845),(80.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.765),(32.745,11.935),(32.915,11.935),(32.915,11.765),(32.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.085),(32.745,11.255),(32.915,11.255),(32.915,11.085),(32.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.425),(32.745,11.595),(32.915,11.595),(32.915,11.425),(32.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.845),(8.745,16.015),(8.915,16.015),(8.915,15.845),(8.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.425),(66.685,11.595),(66.855,11.595),(66.855,11.425),(66.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.425),(66.345,11.595),(66.515,11.595),(66.515,11.425),(66.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.765),(66.685,11.935),(66.855,11.935),(66.855,11.765),(66.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.765),(66.345,11.935),(66.515,11.935),(66.515,11.765),(66.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.085),(66.345,11.255),(66.515,11.255),(66.515,11.085),(66.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.085),(66.685,11.255),(66.855,11.255),(66.855,11.085),(66.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.105),(33.085,12.275),(33.255,12.275),(33.255,12.105),(33.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.445),(33.085,12.615),(33.255,12.615),(33.255,12.445),(33.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.785),(33.085,12.955),(33.255,12.955),(33.255,12.785),(33.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.305),(47.145,5.475),(47.315,5.475),(47.315,5.305),(47.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.305),(47.485,5.475),(47.655,5.475),(47.655,5.305),(47.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.645),(47.145,5.815),(47.315,5.815),(47.315,5.645),(47.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.645),(47.485,5.815),(47.655,5.815),(47.655,5.645),(47.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.905),(13.885,19.075),(14.055,19.075),(14.055,18.905),(13.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.325),(8.745,6.495),(8.915,6.495),(8.915,6.325),(8.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.665),(8.745,6.835),(8.915,6.835),(8.915,6.665),(8.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.305),(23.145,5.475),(23.315,5.475),(23.315,5.305),(23.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.305),(23.485,5.475),(23.655,5.475),(23.655,5.305),(23.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.645),(23.145,5.815),(23.315,5.815),(23.315,5.645),(23.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.645),(23.485,5.815),(23.655,5.815),(23.655,5.645),(23.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.465),(8.745,13.635),(8.915,13.635),(8.915,13.465),(8.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.805),(8.745,13.975),(8.915,13.975),(8.915,13.805),(8.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.125),(8.745,13.295),(8.915,13.295),(8.915,13.125),(8.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.965),(56.745,5.135),(56.915,5.135),(56.915,4.965),(56.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.325),(66.685,6.495),(66.855,6.495),(66.855,6.325),(66.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.325),(66.345,6.495),(66.515,6.495),(66.515,6.325),(66.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.665),(66.685,6.835),(66.855,6.835),(66.855,6.665),(66.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.665),(66.345,6.835),(66.515,6.835),(66.515,6.665),(66.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.965),(32.745,5.135),(32.915,5.135),(32.915,4.965),(32.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.385),(80.745,9.555),(80.915,9.555),(80.915,9.385),(80.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.965),(13.545,5.135),(13.715,5.135),(13.715,4.965),(13.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.725),(80.745,9.895),(80.915,9.895),(80.915,9.725),(80.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.965),(8.745,5.135),(8.915,5.135),(8.915,4.965),(8.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.605),(81.085,3.775),(81.255,3.775),(81.255,3.605),(81.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.265),(81.085,3.435),(81.255,3.435),(81.255,3.265),(81.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.885),(66.685,18.055),(66.855,18.055),(66.855,17.885),(66.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.885),(66.345,18.055),(66.515,18.055),(66.515,17.885),(66.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.985),(27.945,6.155),(28.115,6.155),(28.115,5.985),(27.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.565),(42.345,18.735),(42.515,18.735),(42.515,18.565),(42.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.225),(42.345,18.395),(42.515,18.395),(42.515,18.225),(42.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.565),(42.685,18.735),(42.855,18.735),(42.855,18.565),(42.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.225),(42.685,18.395),(42.855,18.395),(42.855,18.225),(42.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.845),(37.545,16.015),(37.715,16.015),(37.715,15.845),(37.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.245),(61.885,19.415),(62.055,19.415),(62.055,19.245),(61.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.365),(32.745,8.535),(32.915,8.535),(32.915,8.365),(32.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.705),(32.745,8.875),(32.915,8.875),(32.915,8.705),(32.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.025),(32.745,8.195),(32.915,8.195),(32.915,8.025),(32.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.845),(56.745,16.015),(56.915,16.015),(56.915,15.845),(56.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.185),(61.885,16.355),(62.055,16.355),(62.055,16.185),(61.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.525),(61.885,16.695),(62.055,16.695),(62.055,16.525),(61.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.525),(47.145,16.695),(47.315,16.695),(47.315,16.525),(47.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.185),(47.145,16.355),(47.315,16.355),(47.315,16.185),(47.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.525),(47.485,16.695),(47.655,16.695),(47.655,16.525),(47.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.185),(47.485,16.355),(47.655,16.355),(47.655,16.185),(47.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.285),(27.945,4.455),(28.115,4.455),(28.115,4.285),(27.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.625),(27.945,4.795),(28.115,4.795),(28.115,4.625),(27.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.665),(18.345,6.835),(18.515,6.835),(18.515,6.665),(18.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.665),(18.685,6.835),(18.855,6.835),(18.855,6.665),(18.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.325),(18.345,6.495),(18.515,6.495),(18.515,6.325),(18.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.325),(18.685,6.495),(18.855,6.495),(18.855,6.325),(18.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.685),(51.945,7.855),(52.115,7.855),(52.115,7.685),(51.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.385),(32.745,9.555),(32.915,9.555),(32.915,9.385),(32.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.725),(32.745,9.895),(32.915,9.895),(32.915,9.725),(32.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.345),(51.945,7.515),(52.115,7.515),(52.115,7.345),(51.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.005),(51.945,7.175),(52.115,7.175),(52.115,7.005),(51.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.765),(37.885,11.935),(38.055,11.935),(38.055,11.765),(37.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.085),(37.885,11.255),(38.055,11.255),(38.055,11.085),(37.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.425),(37.885,11.595),(38.055,11.595),(38.055,11.425),(37.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.285),(52.285,4.455),(52.455,4.455),(52.455,4.285),(52.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.625),(52.285,4.795),(52.455,4.795),(52.455,4.625),(52.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.945),(57.085,4.115),(57.255,4.115),(57.255,3.945),(57.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.465),(56.745,13.635),(56.915,13.635),(56.915,13.465),(56.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.805),(56.745,13.975),(56.915,13.975),(56.915,13.805),(56.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.125),(56.745,13.295),(56.915,13.295),(56.915,13.125),(56.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.945),(33.085,4.115),(33.255,4.115),(33.255,3.945),(33.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.765),(80.745,11.935),(80.915,11.935),(80.915,11.765),(80.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.985),(18.345,6.155),(18.515,6.155),(18.515,5.985),(18.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.985),(18.685,6.155),(18.855,6.155),(18.855,5.985),(18.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.945),(9.085,4.115),(9.255,4.115),(9.255,3.945),(9.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.425),(80.745,11.595),(80.915,11.595),(80.915,11.425),(80.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.085),(80.745,11.255),(80.915,11.255),(80.915,11.085),(80.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.905),(52.285,19.075),(52.455,19.075),(52.455,18.905),(52.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.985),(51.945,6.155),(52.115,6.155),(52.115,5.985),(51.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.965),(61.545,5.135),(61.715,5.135),(61.715,4.965),(61.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.325),(42.345,6.495),(42.515,6.495),(42.515,6.325),(42.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.325),(42.685,6.495),(42.855,6.495),(42.855,6.325),(42.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.665),(42.345,6.835),(42.515,6.835),(42.515,6.665),(42.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.665),(42.685,6.835),(42.855,6.835),(42.855,6.665),(42.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.445),(37.885,12.615),(38.055,12.615),(38.055,12.445),(37.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.505),(52.285,15.675),(52.455,15.675),(52.455,15.505),(52.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.165),(52.285,15.335),(52.455,15.335),(52.455,15.165),(52.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.785),(37.885,12.955),(38.055,12.955),(38.055,12.785),(37.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.105),(37.885,12.275),(38.055,12.275),(38.055,12.105),(37.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.205),(57.085,17.375),(57.255,17.375),(57.255,17.205),(57.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.545),(57.085,17.715),(57.255,17.715),(57.255,17.545),(57.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.885),(37.545,18.055),(37.715,18.055),(37.715,17.885),(37.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.885),(80.745,18.055),(80.915,18.055),(80.915,17.885),(80.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.245),(37.545,19.415),(37.715,19.415),(37.715,19.245),(37.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.005),(80.745,7.175),(80.915,7.175),(80.915,7.005),(80.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.345),(80.745,7.515),(80.915,7.515),(80.915,7.345),(80.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.325),(81.085,6.495),(81.255,6.495),(81.255,6.325),(81.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.665),(81.085,6.835),(81.255,6.835),(81.255,6.665),(81.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.185),(66.345,16.355),(66.515,16.355),(66.515,16.185),(66.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.185),(66.685,16.355),(66.855,16.355),(66.855,16.185),(66.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.525),(66.345,16.695),(66.515,16.695),(66.515,16.525),(66.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.525),(66.685,16.695),(66.855,16.695),(66.855,16.525),(66.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.385),(37.545,9.555),(37.715,9.555),(37.715,9.385),(37.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.725),(37.545,9.895),(37.715,9.895),(37.715,9.725),(37.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.885),(76.285,18.055),(76.455,18.055),(76.455,17.885),(76.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.205),(28.285,17.375),(28.455,17.375),(28.455,17.205),(28.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.545),(28.285,17.715),(28.455,17.715),(28.455,17.545),(28.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.345),(37.885,7.515),(38.055,7.515),(38.055,7.345),(37.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.685),(37.885,7.855),(38.055,7.855),(38.055,7.685),(37.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.005),(37.885,7.175),(38.055,7.175),(38.055,7.005),(37.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.985),(80.745,6.155),(80.915,6.155),(80.915,5.985),(80.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.885),(33.085,18.055),(33.255,18.055),(33.255,17.885),(33.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.265),(28.285,3.435),(28.455,3.435),(28.455,3.265),(28.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.605),(28.285,3.775),(28.455,3.775),(28.455,3.605),(28.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.385),(57.085,9.555),(57.255,9.555),(57.255,9.385),(57.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.725),(57.085,9.895),(57.255,9.895),(57.255,9.725),(57.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.105),(32.745,12.275),(32.915,12.275),(32.915,12.105),(32.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.445),(32.745,12.615),(32.915,12.615),(32.915,12.445),(32.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.785),(32.745,12.955),(32.915,12.955),(32.915,12.785),(32.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.105),(13.885,12.275),(14.055,12.275),(14.055,12.105),(13.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.445),(13.885,12.615),(14.055,12.615),(14.055,12.445),(13.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.785),(13.885,12.955),(14.055,12.955),(14.055,12.785),(13.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.245),(75.945,19.415),(76.115,19.415),(76.115,19.245),(75.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.205),(32.745,17.375),(32.915,17.375),(32.915,17.205),(32.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.545),(32.745,17.715),(32.915,17.715),(32.915,17.545),(32.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.005),(61.885,7.175),(62.055,7.175),(62.055,7.005),(61.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.845),(61.545,16.015),(61.715,16.015),(61.715,15.845),(61.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.345),(61.885,7.515),(62.055,7.515),(62.055,7.345),(61.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.385),(9.085,9.555),(9.255,9.555),(9.255,9.385),(9.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.725),(9.085,9.895),(9.255,9.895),(9.255,9.725),(9.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.385),(52.285,9.555),(52.455,9.555),(52.455,9.385),(52.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.725),(52.285,9.895),(52.455,9.895),(52.455,9.725),(52.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.865),(37.545,17.035),(37.715,17.035),(37.715,16.865),(37.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.845),(13.545,16.015),(13.715,16.015),(13.715,15.845),(13.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.845),(52.285,16.015),(52.455,16.015),(52.455,15.845),(52.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.885),(37.885,18.055),(38.055,18.055),(38.055,17.885),(37.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.865),(52.285,17.035),(52.455,17.035),(52.455,16.865),(52.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.465),(52.285,13.635),(52.455,13.635),(52.455,13.465),(52.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.805),(52.285,13.975),(52.455,13.975),(52.455,13.805),(52.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.125),(52.285,13.295),(52.455,13.295),(52.455,13.125),(52.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.965),(80.745,5.135),(80.915,5.135),(80.915,4.965),(80.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.125),(71.145,13.295),(71.315,13.295),(71.315,13.125),(71.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.285),(75.945,4.455),(76.115,4.455),(76.115,4.285),(75.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.625),(75.945,4.795),(76.115,4.795),(76.115,4.625),(75.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.985),(56.745,6.155),(56.915,6.155),(56.915,5.985),(56.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.325),(61.885,6.495),(62.055,6.495),(62.055,6.325),(61.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.665),(61.885,6.835),(62.055,6.835),(62.055,6.665),(61.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.085),(61.885,11.255),(62.055,11.255),(62.055,11.085),(61.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.425),(61.885,11.595),(62.055,11.595),(62.055,11.425),(61.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.765),(61.885,11.935),(62.055,11.935),(62.055,11.765),(61.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.985),(32.745,6.155),(32.915,6.155),(32.915,5.985),(32.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.085),(13.885,11.255),(14.055,11.255),(14.055,11.085),(13.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.765),(13.885,11.935),(14.055,11.935),(14.055,11.765),(13.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.225),(27.945,18.395),(28.115,18.395),(28.115,18.225),(27.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.565),(27.945,18.735),(28.115,18.735),(28.115,18.565),(27.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.425),(13.885,11.595),(14.055,11.595),(14.055,11.425),(13.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.245),(57.085,19.415),(57.255,19.415),(57.255,19.245),(57.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.025),(80.745,8.195),(80.915,8.195),(80.915,8.025),(80.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.365),(80.745,8.535),(80.915,8.535),(80.915,8.365),(80.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.705),(80.745,8.875),(80.915,8.875),(80.915,8.705),(80.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.245),(42.345,19.415),(42.515,19.415),(42.515,19.245),(42.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.245),(42.685,19.415),(42.855,19.415),(42.855,19.245),(42.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.185),(13.885,16.355),(14.055,16.355),(14.055,16.185),(13.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.525),(13.885,16.695),(14.055,16.695),(14.055,16.525),(13.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.445),(61.885,12.615),(62.055,12.615),(62.055,12.445),(61.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.785),(61.885,12.955),(62.055,12.955),(62.055,12.785),(61.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.105),(61.885,12.275),(62.055,12.275),(62.055,12.105),(61.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.505),(42.345,15.675),(42.515,15.675),(42.515,15.505),(42.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.505),(42.685,15.675),(42.855,15.675),(42.855,15.505),(42.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.165),(42.345,15.335),(42.515,15.335),(42.515,15.165),(42.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.165),(42.685,15.335),(42.855,15.335),(42.855,15.165),(42.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.925),(37.885,3.095),(38.055,3.095),(38.055,2.925),(37.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.045),(47.145,9.215),(47.315,9.215),(47.315,9.045),(47.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.045),(47.485,9.215),(47.655,9.215),(47.655,9.045),(47.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.505),(28.285,15.675),(28.455,15.675),(28.455,15.505),(28.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.165),(28.285,15.335),(28.455,15.335),(28.455,15.165),(28.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.305),(37.545,5.475),(37.715,5.475),(37.715,5.305),(37.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.645),(37.545,5.815),(37.715,5.815),(37.715,5.645),(37.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.185),(80.745,16.355),(80.915,16.355),(80.915,16.185),(80.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.525),(80.745,16.695),(80.915,16.695),(80.915,16.525),(80.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.965),(37.885,5.135),(38.055,5.135),(38.055,4.965),(37.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.765),(57.085,11.935),(57.255,11.935),(57.255,11.765),(57.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.865),(42.345,17.035),(42.515,17.035),(42.515,16.865),(42.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.085),(57.085,11.255),(57.255,11.255),(57.255,11.085),(57.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.425),(57.085,11.595),(57.255,11.595),(57.255,11.425),(57.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.865),(42.685,17.035),(42.855,17.035),(42.855,16.865),(42.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.745),(32.745,10.915),(32.915,10.915),(32.915,10.745),(32.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.065),(32.745,10.235),(32.915,10.235),(32.915,10.065),(32.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.145),(56.745,14.315),(56.915,14.315),(56.915,14.145),(56.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.485),(56.745,14.655),(56.915,14.655),(56.915,14.485),(56.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.825),(56.745,14.995),(56.915,14.995),(56.915,14.825),(56.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.405),(32.745,10.575),(32.915,10.575),(32.915,10.405),(32.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.165),(47.145,15.335),(47.315,15.335),(47.315,15.165),(47.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.165),(47.485,15.335),(47.655,15.335),(47.655,15.165),(47.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.505),(47.485,15.675),(47.655,15.675),(47.655,15.505),(47.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.505),(47.145,15.675),(47.315,15.675),(47.315,15.505),(47.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.545),(66.685,17.715),(66.855,17.715),(66.855,17.545),(66.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.205),(66.345,17.375),(66.515,17.375),(66.515,17.205),(66.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.765),(9.085,11.935),(9.255,11.935),(9.255,11.765),(9.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.425),(9.085,11.595),(9.255,11.595),(9.255,11.425),(9.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.205),(66.685,17.375),(66.855,17.375),(66.855,17.205),(66.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.545),(66.345,17.715),(66.515,17.715),(66.515,17.545),(66.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.085),(9.085,11.255),(9.255,11.255),(9.255,11.085),(9.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.485),(8.745,14.655),(8.915,14.655),(8.915,14.485),(8.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.825),(8.745,14.995),(8.915,14.995),(8.915,14.825),(8.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.145),(8.745,14.315),(8.915,14.315),(8.915,14.145),(8.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.865),(57.085,17.035),(57.255,17.035),(57.255,16.865),(57.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.945),(13.885,4.115),(14.055,4.115),(14.055,3.945),(13.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.265),(71.145,3.435),(71.315,3.435),(71.315,3.265),(71.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.265),(71.485,3.435),(71.655,3.435),(71.655,3.265),(71.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.605),(71.145,3.775),(71.315,3.775),(71.315,3.605),(71.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.605),(71.485,3.775),(71.655,3.775),(71.655,3.605),(71.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.525),(18.345,16.695),(18.515,16.695),(18.515,16.525),(18.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.525),(18.685,16.695),(18.855,16.695),(18.855,16.525),(18.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.185),(18.345,16.355),(18.515,16.355),(18.515,16.185),(18.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.185),(18.685,16.355),(18.855,16.355),(18.855,16.185),(18.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.385),(61.545,9.555),(61.715,9.555),(61.715,9.385),(61.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.725),(61.545,9.895),(61.715,9.895),(61.715,9.725),(61.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.265),(47.145,3.435),(47.315,3.435),(47.315,3.265),(47.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.265),(47.485,3.435),(47.655,3.435),(47.655,3.265),(47.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.605),(47.145,3.775),(47.315,3.775),(47.315,3.605),(47.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.605),(47.485,3.775),(47.655,3.775),(47.655,3.605),(47.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.265),(23.485,3.435),(23.655,3.435),(23.655,3.265),(23.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.265),(23.145,3.435),(23.315,3.435),(23.315,3.265),(23.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.605),(23.145,3.775),(23.315,3.775),(23.315,3.605),(23.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.905),(47.145,19.075),(47.315,19.075),(47.315,18.905),(47.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.905),(47.485,19.075),(47.655,19.075),(47.655,18.905),(47.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.605),(23.485,3.775),(23.655,3.775),(23.655,3.605),(23.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.725),(13.545,9.895),(13.715,9.895),(13.715,9.725),(13.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.385),(13.545,9.555),(13.715,9.555),(13.715,9.385),(13.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.245),(13.885,19.415),(14.055,19.415),(14.055,19.245),(13.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.065),(80.745,10.235),(80.915,10.235),(80.915,10.065),(80.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.405),(80.745,10.575),(80.915,10.575),(80.915,10.405),(80.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.045),(33.085,9.215),(33.255,9.215),(33.255,9.045),(33.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.745),(80.745,10.915),(80.915,10.915),(80.915,10.745),(80.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.905),(37.545,19.075),(37.715,19.075),(37.715,18.905),(37.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.725),(76.285,9.895),(76.455,9.895),(76.455,9.725),(76.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.385),(76.285,9.555),(76.455,9.555),(76.455,9.385),(76.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.885),(18.345,18.055),(18.515,18.055),(18.515,17.885),(18.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.885),(18.685,18.055),(18.855,18.055),(18.855,17.885),(18.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.305),(18.345,5.475),(18.515,5.475),(18.515,5.305),(18.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.645),(18.345,5.815),(18.515,5.815),(18.515,5.645),(18.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.645),(18.685,5.815),(18.855,5.815),(18.855,5.645),(18.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.305),(18.685,5.475),(18.855,5.475),(18.855,5.305),(18.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.385),(28.285,9.555),(28.455,9.555),(28.455,9.385),(28.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.725),(28.285,9.895),(28.455,9.895),(28.455,9.725),(28.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.885),(51.945,18.055),(52.115,18.055),(52.115,17.885),(51.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.565),(66.685,18.735),(66.855,18.735),(66.855,18.565),(66.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.225),(66.345,18.395),(66.515,18.395),(66.515,18.225),(66.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.225),(66.685,18.395),(66.855,18.395),(66.855,18.225),(66.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.565),(66.345,18.735),(66.515,18.735),(66.515,18.565),(66.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.845),(28.285,16.015),(28.455,16.015),(28.455,15.845),(28.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.125),(76.285,13.295),(76.455,13.295),(76.455,13.125),(76.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.465),(76.285,13.635),(76.455,13.635),(76.455,13.465),(76.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.805),(76.285,13.975),(76.455,13.975),(76.455,13.805),(76.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.265),(61.545,3.435),(61.715,3.435),(61.715,3.265),(61.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.605),(61.545,3.775),(61.715,3.775),(61.715,3.605),(61.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.845),(37.885,16.015),(38.055,16.015),(38.055,15.845),(37.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.125),(28.285,13.295),(28.455,13.295),(28.455,13.125),(28.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.465),(28.285,13.635),(28.455,13.635),(28.455,13.465),(28.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.805),(28.285,13.975),(28.455,13.975),(28.455,13.805),(28.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.265),(13.545,3.435),(13.715,3.435),(13.715,3.265),(13.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.605),(13.545,3.775),(13.715,3.775),(13.715,3.605),(13.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.305),(57.085,5.475),(57.255,5.475),(57.255,5.305),(57.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.645),(57.085,5.815),(57.255,5.815),(57.255,5.645),(57.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.225),(23.145,18.395),(23.315,18.395),(23.315,18.225),(23.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.225),(23.485,18.395),(23.655,18.395),(23.655,18.225),(23.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.565),(23.145,18.735),(23.315,18.735),(23.315,18.565),(23.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.565),(23.485,18.735),(23.655,18.735),(23.655,18.565),(23.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.305),(33.085,5.475),(33.255,5.475),(33.255,5.305),(33.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.645),(33.085,5.815),(33.255,5.815),(33.255,5.645),(33.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.105),(80.745,12.275),(80.915,12.275),(80.915,12.105),(80.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.445),(80.745,12.615),(80.915,12.615),(80.915,12.445),(80.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.305),(9.085,5.475),(9.255,5.475),(9.255,5.305),(9.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.645),(9.085,5.815),(9.255,5.815),(9.255,5.645),(9.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.785),(80.745,12.955),(80.915,12.955),(80.915,12.785),(80.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.205),(9.085,17.375),(9.255,17.375),(9.255,17.205),(9.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.545),(9.085,17.715),(9.255,17.715),(9.255,17.545),(9.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.105),(42.345,12.275),(42.515,12.275),(42.515,12.105),(42.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.105),(42.685,12.275),(42.855,12.275),(42.855,12.105),(42.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.185),(61.545,16.355),(61.715,16.355),(61.715,16.185),(61.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.525),(61.545,16.695),(61.715,16.695),(61.715,16.525),(61.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.445),(42.345,12.615),(42.515,12.615),(42.515,12.445),(42.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.445),(42.685,12.615),(42.855,12.615),(42.855,12.445),(42.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.785),(42.345,12.955),(42.515,12.955),(42.515,12.785),(42.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.785),(42.685,12.955),(42.855,12.955),(42.855,12.785),(42.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.785),(23.485,12.955),(23.655,12.955),(23.655,12.785),(23.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.205),(61.885,17.375),(62.055,17.375),(62.055,17.205),(61.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.545),(61.885,17.715),(62.055,17.715),(62.055,17.545),(61.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.205),(80.745,17.375),(80.915,17.375),(80.915,17.205),(80.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.545),(80.745,17.715),(80.915,17.715),(80.915,17.545),(80.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.225),(32.745,18.395),(32.915,18.395),(32.915,18.225),(32.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.565),(32.745,18.735),(32.915,18.735),(32.915,18.565),(32.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.385),(23.145,9.555),(23.315,9.555),(23.315,9.385),(23.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.385),(23.485,9.555),(23.655,9.555),(23.655,9.385),(23.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.725),(23.145,9.895),(23.315,9.895),(23.315,9.725),(23.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.725),(23.485,9.895),(23.655,9.895),(23.655,9.725),(23.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.385),(37.885,9.555),(38.055,9.555),(38.055,9.385),(37.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.725),(37.885,9.895),(38.055,9.895),(38.055,9.725),(37.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.865),(27.945,17.035),(28.115,17.035),(28.115,16.865),(27.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.945),(37.885,4.115),(38.055,4.115),(38.055,3.945),(37.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,2.925),(75.945,3.095),(76.115,3.095),(76.115,2.925),(75.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,2.925),(27.945,3.095),(28.115,3.095),(28.115,2.925),(27.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.865),(32.745,17.035),(32.915,17.035),(32.915,16.865),(32.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.225),(61.885,18.395),(62.055,18.395),(62.055,18.225),(61.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.565),(61.885,18.735),(62.055,18.735),(62.055,18.565),(61.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.505),(76.285,15.675),(76.455,15.675),(76.455,15.505),(76.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.165),(76.285,15.335),(76.455,15.335),(76.455,15.165),(76.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.545),(76.285,17.715),(76.455,17.715),(76.455,17.545),(76.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.205),(76.285,17.375),(76.455,17.375),(76.455,17.205),(76.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.805),(23.485,13.975),(23.655,13.975),(23.655,13.805),(23.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.465),(23.145,13.635),(23.315,13.635),(23.315,13.465),(23.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.465),(23.485,13.635),(23.655,13.635),(23.655,13.465),(23.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.805),(23.145,13.975),(23.315,13.975),(23.315,13.805),(23.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.125),(23.145,13.295),(23.315,13.295),(23.315,13.125),(23.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.125),(23.485,13.295),(23.655,13.295),(23.655,13.125),(23.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,2.925),(9.085,3.095),(9.255,3.095),(9.255,2.925),(9.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.945),(37.545,4.115),(37.715,4.115),(37.715,3.945),(37.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.645),(80.745,5.815),(80.915,5.815),(80.915,5.645),(80.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.305),(80.745,5.475),(80.915,5.475),(80.915,5.305),(80.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.565),(33.085,18.735),(33.255,18.735),(33.255,18.565),(33.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.225),(33.085,18.395),(33.255,18.395),(33.255,18.225),(33.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.145),(66.345,14.315),(66.515,14.315),(66.515,14.145),(66.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.145),(66.685,14.315),(66.855,14.315),(66.855,14.145),(66.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.485),(66.345,14.655),(66.515,14.655),(66.515,14.485),(66.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.485),(66.685,14.655),(66.855,14.655),(66.855,14.485),(66.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.825),(66.345,14.995),(66.515,14.995),(66.515,14.825),(66.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.825),(66.685,14.995),(66.855,14.995),(66.855,14.825),(66.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.985),(61.885,6.155),(62.055,6.155),(62.055,5.985),(61.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.985),(13.885,6.155),(14.055,6.155),(14.055,5.985),(13.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.165),(32.745,15.335),(32.915,15.335),(32.915,15.165),(32.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.505),(32.745,15.675),(32.915,15.675),(32.915,15.505),(32.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.265),(42.345,3.435),(42.515,3.435),(42.515,3.265),(42.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.265),(42.685,3.435),(42.855,3.435),(42.855,3.265),(42.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.605),(42.685,3.775),(42.855,3.775),(42.855,3.605),(42.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.605),(42.345,3.775),(42.515,3.775),(42.515,3.605),(42.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.405),(9.085,10.575),(9.255,10.575),(9.255,10.405),(9.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.065),(9.085,10.235),(9.255,10.235),(9.255,10.065),(9.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.565),(28.285,18.735),(28.455,18.735),(28.455,18.565),(28.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.745),(9.085,10.915),(9.255,10.915),(9.255,10.745),(9.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.225),(28.285,18.395),(28.455,18.395),(28.455,18.225),(28.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.925),(56.745,3.095),(56.915,3.095),(56.915,2.925),(56.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.045),(51.945,9.215),(52.115,9.215),(52.115,9.045),(51.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.925),(32.745,3.095),(32.915,3.095),(32.915,2.925),(32.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.965),(51.945,5.135),(52.115,5.135),(52.115,4.965),(51.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.125),(71.485,13.295),(71.655,13.295),(71.655,13.125),(71.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,2.925),(8.745,3.095),(8.915,3.095),(8.915,2.925),(8.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.305),(56.745,5.475),(56.915,5.475),(56.915,5.305),(56.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.865),(9.085,17.035),(9.255,17.035),(9.255,16.865),(9.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.645),(56.745,5.815),(56.915,5.815),(56.915,5.645),(56.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.225),(75.945,18.395),(76.115,18.395),(76.115,18.225),(75.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.565),(75.945,18.735),(76.115,18.735),(76.115,18.565),(75.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.305),(32.745,5.475),(32.915,5.475),(32.915,5.305),(32.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.645),(32.745,5.815),(32.915,5.815),(32.915,5.645),(32.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.825),(18.345,14.995),(18.515,14.995),(18.515,14.825),(18.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.485),(18.345,14.655),(18.515,14.655),(18.515,14.485),(18.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.485),(18.685,14.655),(18.855,14.655),(18.855,14.485),(18.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.825),(18.685,14.995),(18.855,14.995),(18.855,14.825),(18.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.145),(18.345,14.315),(18.515,14.315),(18.515,14.145),(18.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.145),(18.685,14.315),(18.855,14.315),(18.855,14.145),(18.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,2.925),(28.285,3.095),(28.455,3.095),(28.455,2.925),(28.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.265),(18.345,3.435),(18.515,3.435),(18.515,3.265),(18.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.265),(18.685,3.435),(18.855,3.435),(18.855,3.265),(18.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.605),(18.685,3.775),(18.855,3.775),(18.855,3.605),(18.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.605),(18.345,3.775),(18.515,3.775),(18.515,3.605),(18.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.925),(57.085,3.095),(57.255,3.095),(57.255,2.925),(57.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,2.925),(80.745,3.095),(80.915,3.095),(80.915,2.925),(80.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.245),(9.085,19.415),(9.255,19.415),(9.255,19.245),(9.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.925),(33.085,3.095),(33.255,3.095),(33.255,2.925),(33.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.225),(61.545,18.395),(61.715,18.395),(61.715,18.225),(61.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.565),(61.545,18.735),(61.715,18.735),(61.715,18.565),(61.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.265),(61.885,3.435),(62.055,3.435),(62.055,3.265),(61.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.605),(61.885,3.775),(62.055,3.775),(62.055,3.605),(61.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.045),(81.085,9.215),(81.255,9.215),(81.255,9.045),(81.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.845),(76.285,16.015),(76.455,16.015),(76.455,15.845),(76.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.285),(37.545,4.455),(37.715,4.455),(37.715,4.285),(37.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.625),(37.545,4.795),(37.715,4.795),(37.715,4.625),(37.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.845),(61.885,16.015),(62.055,16.015),(62.055,15.845),(61.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.405),(37.545,10.575),(37.715,10.575),(37.715,10.405),(37.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.065),(37.545,10.235),(37.715,10.235),(37.715,10.065),(37.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.745),(37.545,10.915),(37.715,10.915),(37.715,10.745),(37.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.265),(13.885,3.435),(14.055,3.435),(14.055,3.265),(13.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.605),(13.885,3.775),(14.055,3.775),(14.055,3.605),(13.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.365),(42.345,8.535),(42.515,8.535),(42.515,8.365),(42.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.365),(42.685,8.535),(42.855,8.535),(42.855,8.365),(42.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.705),(42.345,8.875),(42.515,8.875),(42.515,8.705),(42.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.705),(42.685,8.875),(42.855,8.875),(42.855,8.705),(42.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.025),(42.345,8.195),(42.515,8.195),(42.515,8.025),(42.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.025),(42.685,8.195),(42.855,8.195),(42.855,8.025),(42.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.845),(13.885,16.015),(14.055,16.015),(14.055,15.845),(13.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.065),(42.345,10.235),(42.515,10.235),(42.515,10.065),(42.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.065),(42.685,10.235),(42.855,10.235),(42.855,10.065),(42.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.405),(42.345,10.575),(42.515,10.575),(42.515,10.405),(42.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.405),(42.685,10.575),(42.855,10.575),(42.855,10.405),(42.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.745),(42.345,10.915),(42.515,10.915),(42.515,10.745),(42.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.745),(42.685,10.915),(42.855,10.915),(42.855,10.745),(42.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.825),(47.485,14.995),(47.655,14.995),(47.655,14.825),(47.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.485),(47.485,14.655),(47.655,14.655),(47.655,14.485),(47.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.485),(47.145,14.655),(47.315,14.655),(47.315,14.485),(47.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.825),(47.145,14.995),(47.315,14.995),(47.315,14.825),(47.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.145),(47.145,14.315),(47.315,14.315),(47.315,14.145),(47.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.145),(47.485,14.315),(47.655,14.315),(47.655,14.145),(47.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.405),(57.085,10.575),(57.255,10.575),(57.255,10.405),(57.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.065),(57.085,10.235),(57.255,10.235),(57.255,10.065),(57.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.745),(57.085,10.915),(57.255,10.915),(57.255,10.745),(57.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.945),(42.345,4.115),(42.515,4.115),(42.515,3.945),(42.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.945),(42.685,4.115),(42.855,4.115),(42.855,3.945),(42.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.285),(9.085,4.455),(9.255,4.455),(9.255,4.285),(9.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.625),(9.085,4.795),(9.255,4.795),(9.255,4.625),(9.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.045),(27.945,9.215),(28.115,9.215),(28.115,9.045),(27.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.385),(61.885,9.555),(62.055,9.555),(62.055,9.385),(61.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.725),(61.885,9.895),(62.055,9.895),(62.055,9.725),(61.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.385),(71.485,9.555),(71.655,9.555),(71.655,9.385),(71.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.725),(71.145,9.895),(71.315,9.895),(71.315,9.725),(71.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.725),(71.485,9.895),(71.655,9.895),(71.655,9.725),(71.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.385),(71.145,9.555),(71.315,9.555),(71.315,9.385),(71.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.685),(28.285,7.855),(28.455,7.855),(28.455,7.685),(28.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.725),(13.885,9.895),(14.055,9.895),(14.055,9.725),(13.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.525),(56.745,16.695),(56.915,16.695),(56.915,16.525),(56.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.185),(56.745,16.355),(56.915,16.355),(56.915,16.185),(56.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.385),(13.885,9.555),(14.055,9.555),(14.055,9.385),(13.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.165),(33.085,15.335),(33.255,15.335),(33.255,15.165),(33.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.505),(33.085,15.675),(33.255,15.675),(33.255,15.505),(33.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.165),(80.745,15.335),(80.915,15.335),(80.915,15.165),(80.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.505),(80.745,15.675),(80.915,15.675),(80.915,15.505),(80.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.065),(52.285,10.235),(52.455,10.235),(52.455,10.065),(52.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.405),(52.285,10.575),(52.455,10.575),(52.455,10.405),(52.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.745),(52.285,10.915),(52.455,10.915),(52.455,10.745),(52.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.285),(81.085,4.455),(81.255,4.455),(81.255,4.285),(81.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.625),(81.085,4.795),(81.255,4.795),(81.255,4.625),(81.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.185),(13.545,16.355),(13.715,16.355),(13.715,16.185),(13.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.525),(13.545,16.695),(13.715,16.695),(13.715,16.525),(13.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.805),(71.485,13.975),(71.655,13.975),(71.655,13.805),(71.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.465),(71.145,13.635),(71.315,13.635),(71.315,13.465),(71.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.465),(71.485,13.635),(71.655,13.635),(71.655,13.465),(71.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.805),(71.145,13.975),(71.315,13.975),(71.315,13.805),(71.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.445),(71.145,12.615),(71.315,12.615),(71.315,12.445),(71.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.445),(71.485,12.615),(71.655,12.615),(71.655,12.445),(71.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.785),(71.485,12.955),(71.655,12.955),(71.655,12.785),(71.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.785),(71.145,12.955),(71.315,12.955),(71.315,12.785),(71.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.105),(71.145,12.275),(71.315,12.275),(71.315,12.105),(71.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.105),(71.485,12.275),(71.655,12.275),(71.655,12.105),(71.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.185),(28.285,16.355),(28.455,16.355),(28.455,16.185),(28.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.945),(18.685,4.115),(18.855,4.115),(18.855,3.945),(18.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.525),(28.285,16.695),(28.455,16.695),(28.455,16.525),(28.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.945),(18.345,4.115),(18.515,4.115),(18.515,3.945),(18.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.405),(13.545,10.575),(13.715,10.575),(13.715,10.405),(13.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.745),(13.545,10.915),(13.715,10.915),(13.715,10.745),(13.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.465),(42.345,13.635),(42.515,13.635),(42.515,13.465),(42.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.465),(42.685,13.635),(42.855,13.635),(42.855,13.465),(42.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.805),(42.345,13.975),(42.515,13.975),(42.515,13.805),(42.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.805),(42.685,13.975),(42.855,13.975),(42.855,13.805),(42.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.105),(23.145,12.275),(23.315,12.275),(23.315,12.105),(23.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.105),(23.485,12.275),(23.655,12.275),(23.655,12.105),(23.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.065),(13.545,10.235),(13.715,10.235),(13.715,10.065),(13.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.125),(42.345,13.295),(42.515,13.295),(42.515,13.125),(42.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.125),(42.685,13.295),(42.855,13.295),(42.855,13.125),(42.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.945),(52.285,4.115),(52.455,4.115),(52.455,3.945),(52.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.165),(81.085,15.335),(81.255,15.335),(81.255,15.165),(81.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.985),(71.145,6.155),(71.315,6.155),(71.315,5.985),(71.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.985),(71.485,6.155),(71.655,6.155),(71.655,5.985),(71.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.505),(81.085,15.675),(81.255,15.675),(81.255,15.505),(81.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.945),(8.745,4.115),(8.915,4.115),(8.915,3.945),(8.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.545),(18.685,17.715),(18.855,17.715),(18.855,17.545),(18.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.205),(18.345,17.375),(18.515,17.375),(18.515,17.205),(18.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.205),(18.685,17.375),(18.855,17.375),(18.855,17.205),(18.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.545),(18.345,17.715),(18.515,17.715),(18.515,17.545),(18.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.225),(13.885,18.395),(14.055,18.395),(14.055,18.225),(13.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.565),(13.885,18.735),(14.055,18.735),(14.055,18.565),(13.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.285),(57.085,4.455),(57.255,4.455),(57.255,4.285),(57.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.625),(57.085,4.795),(57.255,4.795),(57.255,4.625),(57.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,2.925),(81.085,3.095),(81.255,3.095),(81.255,2.925),(81.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.285),(33.085,4.455),(33.255,4.455),(33.255,4.285),(33.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.625),(33.085,4.795),(33.255,4.795),(33.255,4.625),(33.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.305),(75.945,5.475),(76.115,5.475),(76.115,5.305),(75.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.645),(75.945,5.815),(76.115,5.815),(76.115,5.645),(75.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.165),(9.085,15.335),(9.255,15.335),(9.255,15.165),(9.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.325),(51.945,6.495),(52.115,6.495),(52.115,6.325),(51.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.665),(51.945,6.835),(52.115,6.835),(52.115,6.665),(51.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.885),(81.085,18.055),(81.255,18.055),(81.255,17.885),(81.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.905),(51.945,19.075),(52.115,19.075),(52.115,18.905),(51.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.745),(28.285,10.915),(28.455,10.915),(28.455,10.745),(28.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.065),(28.285,10.235),(28.455,10.235),(28.455,10.065),(28.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.885),(23.145,18.055),(23.315,18.055),(23.315,17.885),(23.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.885),(23.485,18.055),(23.655,18.055),(23.655,17.885),(23.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.405),(28.285,10.575),(28.455,10.575),(28.455,10.405),(28.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.905),(42.345,19.075),(42.515,19.075),(42.515,18.905),(42.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.905),(42.685,19.075),(42.855,19.075),(42.855,18.905),(42.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,2.925),(76.285,3.095),(76.455,3.095),(76.455,2.925),(76.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.005),(42.345,7.175),(42.515,7.175),(42.515,7.005),(42.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.005),(42.685,7.175),(42.855,7.175),(42.855,7.005),(42.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.805),(57.085,13.975),(57.255,13.975),(57.255,13.805),(57.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.465),(57.085,13.635),(57.255,13.635),(57.255,13.465),(57.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.125),(57.085,13.295),(57.255,13.295),(57.255,13.125),(57.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.345),(42.685,7.515),(42.855,7.515),(42.855,7.345),(42.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.065),(61.545,10.235),(61.715,10.235),(61.715,10.065),(61.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.405),(61.545,10.575),(61.715,10.575),(61.715,10.405),(61.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.745),(61.545,10.915),(61.715,10.915),(61.715,10.745),(61.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.345),(42.345,7.515),(42.515,7.515),(42.515,7.345),(42.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.205),(13.885,17.375),(14.055,17.375),(14.055,17.205),(13.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.545),(13.885,17.715),(14.055,17.715),(14.055,17.545),(13.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.225),(18.345,18.395),(18.515,18.395),(18.515,18.225),(18.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.225),(18.685,18.395),(18.855,18.395),(18.855,18.225),(18.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.565),(18.685,18.735),(18.855,18.735),(18.855,18.565),(18.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.565),(18.345,18.735),(18.515,18.735),(18.515,18.565),(18.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.125),(9.085,13.295),(9.255,13.295),(9.255,13.125),(9.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.465),(9.085,13.635),(9.255,13.635),(9.255,13.465),(9.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.805),(9.085,13.975),(9.255,13.975),(9.255,13.805),(9.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.945),(56.745,4.115),(56.915,4.115),(56.915,3.945),(56.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.865),(47.485,17.035),(47.655,17.035),(47.655,16.865),(47.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.865),(47.145,17.035),(47.315,17.035),(47.315,16.865),(47.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.945),(32.745,4.115),(32.915,4.115),(32.915,3.945),(32.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.885),(56.745,18.055),(56.915,18.055),(56.915,17.885),(56.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.685),(71.145,7.855),(71.315,7.855),(71.315,7.685),(71.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.685),(71.485,7.855),(71.655,7.855),(71.655,7.685),(71.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.345),(47.485,7.515),(47.655,7.515),(47.655,7.345),(47.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.345),(47.145,7.515),(47.315,7.515),(47.315,7.345),(47.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.005),(47.145,7.175),(47.315,7.175),(47.315,7.005),(47.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.005),(47.485,7.175),(47.655,7.175),(47.655,7.005),(47.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.685),(47.145,7.855),(47.315,7.855),(47.315,7.685),(47.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.365),(51.945,8.535),(52.115,8.535),(52.115,8.365),(51.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.705),(51.945,8.875),(52.115,8.875),(52.115,8.705),(51.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.025),(51.945,8.195),(52.115,8.195),(52.115,8.025),(51.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.965),(52.285,5.135),(52.455,5.135),(52.455,4.965),(52.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.685),(47.485,7.855),(47.655,7.855),(47.655,7.685),(47.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.685),(23.145,7.855),(23.315,7.855),(23.315,7.685),(23.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.685),(23.485,7.855),(23.655,7.855),(23.655,7.685),(23.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.005),(23.145,7.175),(23.315,7.175),(23.315,7.005),(23.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.005),(23.485,7.175),(23.655,7.175),(23.655,7.005),(23.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.345),(23.145,7.515),(23.315,7.515),(23.315,7.345),(23.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.345),(23.485,7.515),(23.655,7.515),(23.655,7.345),(23.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.165),(51.945,15.335),(52.115,15.335),(52.115,15.165),(51.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.505),(51.945,15.675),(52.115,15.675),(52.115,15.505),(51.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.225),(13.545,18.395),(13.715,18.395),(13.715,18.225),(13.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.565),(13.545,18.735),(13.715,18.735),(13.715,18.565),(13.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.225),(80.745,18.395),(80.915,18.395),(80.915,18.225),(80.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.565),(80.745,18.735),(80.915,18.735),(80.915,18.565),(80.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.365),(9.085,8.535),(9.255,8.535),(9.255,8.365),(9.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.705),(9.085,8.875),(9.255,8.875),(9.255,8.705),(9.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.025),(9.085,8.195),(9.255,8.195),(9.255,8.025),(9.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.045),(75.945,9.215),(76.115,9.215),(76.115,9.045),(75.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.005),(18.345,7.175),(18.515,7.175),(18.515,7.005),(18.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.005),(18.685,7.175),(18.855,7.175),(18.855,7.005),(18.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.345),(18.345,7.515),(18.515,7.515),(18.515,7.345),(18.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.345),(18.685,7.515),(18.855,7.515),(18.855,7.345),(18.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.685),(18.345,7.855),(18.515,7.855),(18.515,7.685),(18.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.685),(18.685,7.855),(18.855,7.855),(18.855,7.685),(18.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.685),(76.285,7.855),(76.455,7.855),(76.455,7.685),(76.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.345),(76.285,7.515),(76.455,7.515),(76.455,7.345),(76.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.005),(76.285,7.175),(76.455,7.175),(76.455,7.005),(76.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.985),(61.545,6.155),(61.715,6.155),(61.715,5.985),(61.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.425),(71.145,11.595),(71.315,11.595),(71.315,11.425),(71.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.425),(71.485,11.595),(71.655,11.595),(71.655,11.425),(71.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.765),(71.145,11.935),(71.315,11.935),(71.315,11.765),(71.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.765),(71.485,11.935),(71.655,11.935),(71.655,11.765),(71.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.005),(37.545,7.175),(37.715,7.175),(37.715,7.005),(37.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.345),(37.545,7.515),(37.715,7.515),(37.715,7.345),(37.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.085),(71.145,11.255),(71.315,11.255),(71.315,11.085),(71.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.085),(71.485,11.255),(71.655,11.255),(71.655,11.085),(71.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.205),(27.945,17.375),(28.115,17.375),(28.115,17.205),(27.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.545),(27.945,17.715),(28.115,17.715),(28.115,17.545),(27.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.265),(75.945,3.435),(76.115,3.435),(76.115,3.265),(75.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.605),(75.945,3.775),(76.115,3.775),(76.115,3.605),(75.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.985),(13.545,6.155),(13.715,6.155),(13.715,5.985),(13.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.425),(23.485,11.595),(23.655,11.595),(23.655,11.425),(23.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.425),(23.145,11.595),(23.315,11.595),(23.315,11.425),(23.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.765),(23.145,11.935),(23.315,11.935),(23.315,11.765),(23.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.765),(23.485,11.935),(23.655,11.935),(23.655,11.765),(23.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.085),(23.145,11.255),(23.315,11.255),(23.315,11.085),(23.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.085),(23.485,11.255),(23.655,11.255),(23.655,11.085),(23.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.205),(37.545,17.375),(37.715,17.375),(37.715,17.205),(37.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.545),(37.545,17.715),(37.715,17.715),(37.715,17.545),(37.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.045),(42.345,9.215),(42.515,9.215),(42.515,9.045),(42.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.045),(42.685,9.215),(42.855,9.215),(42.855,9.045),(42.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.185),(23.145,16.355),(23.315,16.355),(23.315,16.185),(23.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.185),(23.485,16.355),(23.655,16.355),(23.655,16.185),(23.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.525),(23.145,16.695),(23.315,16.695),(23.315,16.525),(23.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.525),(23.485,16.695),(23.655,16.695),(23.655,16.525),(23.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.345),(61.545,7.515),(61.715,7.515),(61.715,7.345),(61.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.685),(61.545,7.855),(61.715,7.855),(61.715,7.685),(61.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.005),(61.545,7.175),(61.715,7.175),(61.715,7.005),(61.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.765),(42.345,11.935),(42.515,11.935),(42.515,11.765),(42.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.765),(42.685,11.935),(42.855,11.935),(42.855,11.765),(42.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.425),(42.345,11.595),(42.515,11.595),(42.515,11.425),(42.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.425),(42.685,11.595),(42.855,11.595),(42.855,11.425),(42.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.865),(37.885,17.035),(38.055,17.035),(38.055,16.865),(37.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.085),(42.345,11.255),(42.515,11.255),(42.515,11.085),(42.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.085),(42.685,11.255),(42.855,11.255),(42.855,11.085),(42.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.685),(13.545,7.855),(13.715,7.855),(13.715,7.685),(13.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.285),(18.685,4.455),(18.855,4.455),(18.855,4.285),(18.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.625),(18.345,4.795),(18.515,4.795),(18.515,4.625),(18.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.285),(18.345,4.455),(18.515,4.455),(18.515,4.285),(18.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.625),(18.685,4.795),(18.855,4.795),(18.855,4.625),(18.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.985),(28.285,6.155),(28.455,6.155),(28.455,5.985),(28.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.505),(75.945,15.675),(76.115,15.675),(76.115,15.505),(75.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.245),(28.285,19.415),(28.455,19.415),(28.455,19.245),(28.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.165),(75.945,15.335),(76.115,15.335),(76.115,15.165),(75.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.325),(76.285,6.495),(76.455,6.495),(76.455,6.325),(76.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.665),(76.285,6.835),(76.455,6.835),(76.455,6.665),(76.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.165),(27.945,15.335),(28.115,15.335),(28.115,15.165),(27.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.865),(66.345,17.035),(66.515,17.035),(66.515,16.865),(66.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.505),(27.945,15.675),(28.115,15.675),(28.115,15.505),(27.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.865),(66.685,17.035),(66.855,17.035),(66.855,16.865),(66.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.945),(76.285,4.115),(76.455,4.115),(76.455,3.945),(76.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.365),(57.085,8.535),(57.255,8.535),(57.255,8.365),(57.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.705),(57.085,8.875),(57.255,8.875),(57.255,8.705),(57.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.025),(57.085,8.195),(57.255,8.195),(57.255,8.025),(57.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.445),(23.485,12.615),(23.655,12.615),(23.655,12.445),(23.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.285),(42.345,4.455),(42.515,4.455),(42.515,4.285),(42.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.285),(42.685,4.455),(42.855,4.455),(42.855,4.285),(42.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.625),(42.345,4.795),(42.515,4.795),(42.515,4.625),(42.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.625),(42.685,4.795),(42.855,4.795),(42.855,4.625),(42.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.945),(80.745,4.115),(80.915,4.115),(80.915,3.945),(80.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.205),(33.085,17.375),(33.255,17.375),(33.255,17.205),(33.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.545),(33.085,17.715),(33.255,17.715),(33.255,17.545),(33.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.225),(71.145,18.395),(71.315,18.395),(71.315,18.225),(71.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.225),(71.485,18.395),(71.655,18.395),(71.655,18.225),(71.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.565),(71.145,18.735),(71.315,18.735),(71.315,18.565),(71.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.565),(71.485,18.735),(71.655,18.735),(71.655,18.565),(71.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.265),(51.945,3.435),(52.115,3.435),(52.115,3.265),(51.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.605),(51.945,3.775),(52.115,3.775),(52.115,3.605),(51.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.465),(51.945,13.635),(52.115,13.635),(52.115,13.465),(51.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.805),(51.945,13.975),(52.115,13.975),(52.115,13.805),(51.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.125),(51.945,13.295),(52.115,13.295),(52.115,13.125),(51.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.065),(76.285,10.235),(76.455,10.235),(76.455,10.065),(76.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.405),(76.285,10.575),(76.455,10.575),(76.455,10.405),(76.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.745),(76.285,10.915),(76.455,10.915),(76.455,10.745),(76.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.165),(37.885,15.335),(38.055,15.335),(38.055,15.165),(37.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.505),(37.885,15.675),(38.055,15.675),(38.055,15.505),(37.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.425),(8.745,11.595),(8.915,11.595),(8.915,11.425),(8.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.085),(8.745,11.255),(8.915,11.255),(8.915,11.085),(8.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.485),(33.085,14.655),(33.255,14.655),(33.255,14.485),(33.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.825),(33.085,14.995),(33.255,14.995),(33.255,14.825),(33.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.145),(33.085,14.315),(33.255,14.315),(33.255,14.145),(33.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.765),(8.745,11.935),(8.915,11.935),(8.915,11.765),(8.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.225),(81.085,18.395),(81.255,18.395),(81.255,18.225),(81.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.565),(81.085,18.735),(81.255,18.735),(81.255,18.565),(81.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.245),(66.345,19.415),(66.515,19.415),(66.515,19.245),(66.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.245),(66.685,19.415),(66.855,19.415),(66.855,19.245),(66.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.245),(56.745,19.415),(56.915,19.415),(56.915,19.245),(56.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.005),(66.345,7.175),(66.515,7.175),(66.515,7.005),(66.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.005),(66.685,7.175),(66.855,7.175),(66.855,7.005),(66.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.345),(66.345,7.515),(66.515,7.515),(66.515,7.345),(66.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.345),(66.685,7.515),(66.855,7.515),(66.855,7.345),(66.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.685),(66.345,7.855),(66.515,7.855),(66.515,7.685),(66.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.685),(66.685,7.855),(66.855,7.855),(66.855,7.685),(66.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.865),(75.945,17.035),(76.115,17.035),(76.115,16.865),(75.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.185),(8.745,16.355),(8.915,16.355),(8.915,16.185),(8.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.525),(8.745,16.695),(8.915,16.695),(8.915,16.525),(8.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.105),(9.085,12.275),(9.255,12.275),(9.255,12.105),(9.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.445),(9.085,12.615),(9.255,12.615),(9.255,12.445),(9.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.785),(9.085,12.955),(9.255,12.955),(9.255,12.785),(9.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.185),(76.285,16.355),(76.455,16.355),(76.455,16.185),(76.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.525),(76.285,16.695),(76.455,16.695),(76.455,16.525),(76.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.365),(27.945,8.535),(28.115,8.535),(28.115,8.365),(27.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.705),(27.945,8.875),(28.115,8.875),(28.115,8.705),(27.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.025),(27.945,8.195),(28.115,8.195),(28.115,8.025),(27.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.245),(47.145,19.415),(47.315,19.415),(47.315,19.245),(47.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.245),(47.485,19.415),(47.655,19.415),(47.655,19.245),(47.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.925),(37.545,3.095),(37.715,3.095),(37.715,2.925),(37.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.305),(37.885,5.475),(38.055,5.475),(38.055,5.305),(37.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.645),(37.885,5.815),(38.055,5.815),(38.055,5.645),(37.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.385),(66.685,9.555),(66.855,9.555),(66.855,9.385),(66.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.725),(66.685,9.895),(66.855,9.895),(66.855,9.725),(66.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.385),(66.345,9.555),(66.515,9.555),(66.515,9.385),(66.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.725),(66.345,9.895),(66.515,9.895),(66.515,9.725),(66.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.885),(8.745,18.055),(8.915,18.055),(8.915,17.885),(8.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.625),(66.685,4.795),(66.855,4.795),(66.855,4.625),(66.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.285),(66.685,4.455),(66.855,4.455),(66.855,4.285),(66.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.625),(66.345,4.795),(66.515,4.795),(66.515,4.625),(66.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.285),(66.345,4.455),(66.515,4.455),(66.515,4.285),(66.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.465),(27.945,13.635),(28.115,13.635),(28.115,13.465),(27.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.805),(27.945,13.975),(28.115,13.975),(28.115,13.805),(27.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.125),(27.945,13.295),(28.115,13.295),(28.115,13.125),(27.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.865),(80.745,17.035),(80.915,17.035),(80.915,16.865),(80.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.425),(56.745,11.595),(56.915,11.595),(56.915,11.425),(56.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.085),(56.745,11.255),(56.915,11.255),(56.915,11.085),(56.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.765),(56.745,11.935),(56.915,11.935),(56.915,11.765),(56.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.565),(76.285,18.735),(76.455,18.735),(76.455,18.565),(76.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.225),(76.285,18.395),(76.455,18.395),(76.455,18.225),(76.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.285),(37.885,4.455),(38.055,4.455),(38.055,4.285),(37.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.625),(37.885,4.795),(38.055,4.795),(38.055,4.625),(37.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.125),(37.545,13.295),(37.715,13.295),(37.715,13.125),(37.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.465),(37.545,13.635),(37.715,13.635),(37.715,13.465),(37.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.805),(37.545,13.975),(37.715,13.975),(37.715,13.805),(37.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.485),(51.945,14.655),(52.115,14.655),(52.115,14.485),(51.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.825),(51.945,14.995),(52.115,14.995),(52.115,14.825),(51.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.145),(51.945,14.315),(52.115,14.315),(52.115,14.145),(51.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.025),(71.145,8.195),(71.315,8.195),(71.315,8.025),(71.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.025),(71.485,8.195),(71.655,8.195),(71.655,8.025),(71.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.705),(71.485,8.875),(71.655,8.875),(71.655,8.705),(71.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.365),(71.145,8.535),(71.315,8.535),(71.315,8.365),(71.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.365),(71.485,8.535),(71.655,8.535),(71.655,8.365),(71.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.705),(71.145,8.875),(71.315,8.875),(71.315,8.705),(71.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.745),(23.145,10.915),(23.315,10.915),(23.315,10.745),(23.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.745),(23.485,10.915),(23.655,10.915),(23.655,10.745),(23.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.405),(23.145,10.575),(23.315,10.575),(23.315,10.405),(23.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.405),(23.485,10.575),(23.655,10.575),(23.655,10.405),(23.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.065),(23.145,10.235),(23.315,10.235),(23.315,10.065),(23.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.065),(23.485,10.235),(23.655,10.235),(23.655,10.065),(23.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.385),(8.745,9.555),(8.915,9.555),(8.915,9.385),(8.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.725),(8.745,9.895),(8.915,9.895),(8.915,9.725),(8.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.785),(57.085,12.955),(57.255,12.955),(57.255,12.785),(57.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.105),(57.085,12.275),(57.255,12.275),(57.255,12.105),(57.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.445),(57.085,12.615),(57.255,12.615),(57.255,12.445),(57.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.385),(18.345,9.555),(18.515,9.555),(18.515,9.385),(18.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.385),(18.685,9.555),(18.855,9.555),(18.855,9.385),(18.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.725),(18.345,9.895),(18.515,9.895),(18.515,9.725),(18.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.725),(18.685,9.895),(18.855,9.895),(18.855,9.725),(18.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.365),(23.145,8.535),(23.315,8.535),(23.315,8.365),(23.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.365),(23.485,8.535),(23.655,8.535),(23.655,8.365),(23.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.705),(23.145,8.875),(23.315,8.875),(23.315,8.705),(23.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.705),(23.485,8.875),(23.655,8.875),(23.655,8.705),(23.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.025),(23.145,8.195),(23.315,8.195),(23.315,8.025),(23.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.025),(23.485,8.195),(23.655,8.195),(23.655,8.025),(23.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.865),(18.685,17.035),(18.855,17.035),(18.855,16.865),(18.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.865),(18.345,17.035),(18.515,17.035),(18.515,16.865),(18.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.885),(61.545,18.055),(61.715,18.055),(61.715,17.885),(61.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.485),(81.085,14.655),(81.255,14.655),(81.255,14.485),(81.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.825),(81.085,14.995),(81.255,14.995),(81.255,14.825),(81.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.145),(81.085,14.315),(81.255,14.315),(81.255,14.145),(81.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.885),(52.285,18.055),(52.455,18.055),(52.455,17.885),(52.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.205),(56.745,17.375),(56.915,17.375),(56.915,17.205),(56.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.545),(56.745,17.715),(56.915,17.715),(56.915,17.545),(56.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.245),(61.545,19.415),(61.715,19.415),(61.715,19.245),(61.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.845),(51.945,16.015),(52.115,16.015),(52.115,15.845),(51.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.165),(61.885,15.335),(62.055,15.335),(62.055,15.165),(61.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.505),(61.885,15.675),(62.055,15.675),(62.055,15.505),(61.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.165),(13.885,15.335),(14.055,15.335),(14.055,15.165),(13.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.505),(13.885,15.675),(14.055,15.675),(14.055,15.505),(13.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.025),(56.745,8.195),(56.915,8.195),(56.915,8.025),(56.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.705),(56.745,8.875),(56.915,8.875),(56.915,8.705),(56.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.365),(56.745,8.535),(56.915,8.535),(56.915,8.365),(56.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.245),(18.345,19.415),(18.515,19.415),(18.515,19.245),(18.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.245),(18.685,19.415),(18.855,19.415),(18.855,19.245),(18.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.905),(66.685,19.075),(66.855,19.075),(66.855,18.905),(66.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.905),(66.345,19.075),(66.515,19.075),(66.515,18.905),(66.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.025),(8.745,8.195),(8.915,8.195),(8.915,8.025),(8.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.365),(8.745,8.535),(8.915,8.535),(8.915,8.365),(8.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.705),(8.745,8.875),(8.915,8.875),(8.915,8.705),(8.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.665),(37.545,6.835),(37.715,6.835),(37.715,6.665),(37.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.325),(37.545,6.495),(37.715,6.495),(37.715,6.325),(37.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.085),(37.545,11.255),(37.715,11.255),(37.715,11.085),(37.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.765),(37.545,11.935),(37.715,11.935),(37.715,11.765),(37.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.425),(37.545,11.595),(37.715,11.595),(37.715,11.425),(37.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.725),(56.745,9.895),(56.915,9.895),(56.915,9.725),(56.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.385),(56.745,9.555),(56.915,9.555),(56.915,9.385),(56.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.905),(23.485,19.075),(23.655,19.075),(23.655,18.905),(23.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.905),(23.145,19.075),(23.315,19.075),(23.315,18.905),(23.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.945),(75.945,4.115),(76.115,4.115),(76.115,3.945),(75.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.185),(71.145,16.355),(71.315,16.355),(71.315,16.185),(71.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.185),(71.485,16.355),(71.655,16.355),(71.655,16.185),(71.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.525),(71.145,16.695),(71.315,16.695),(71.315,16.525),(71.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.525),(71.485,16.695),(71.655,16.695),(71.655,16.525),(71.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.505),(37.545,15.675),(37.715,15.675),(37.715,15.505),(37.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.165),(37.545,15.335),(37.715,15.335),(37.715,15.165),(37.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.365),(75.945,8.535),(76.115,8.535),(76.115,8.365),(75.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.705),(75.945,8.875),(76.115,8.875),(76.115,8.705),(75.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.025),(75.945,8.195),(76.115,8.195),(76.115,8.025),(75.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.685),(8.745,7.855),(8.915,7.855),(8.915,7.685),(8.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.865),(61.545,17.035),(61.715,17.035),(61.715,16.865),(61.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.325),(9.085,6.495),(9.255,6.495),(9.255,6.325),(9.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.665),(9.085,6.835),(9.255,6.835),(9.255,6.665),(9.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.245),(8.745,19.415),(8.915,19.415),(8.915,19.245),(8.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.885),(61.885,18.055),(62.055,18.055),(62.055,17.885),(61.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.985),(81.085,6.155),(81.255,6.155),(81.255,5.985),(81.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.845),(75.945,16.015),(76.115,16.015),(76.115,15.845),(75.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.905),(32.745,19.075),(32.915,19.075),(32.915,18.905),(32.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.305),(28.285,5.475),(28.455,5.475),(28.455,5.305),(28.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.645),(28.285,5.815),(28.455,5.815),(28.455,5.645),(28.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.845),(27.945,16.015),(28.115,16.015),(28.115,15.845),(27.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.185),(27.945,16.355),(28.115,16.355),(28.115,16.185),(27.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.525),(27.945,16.695),(28.115,16.695),(28.115,16.525),(27.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.465),(75.945,13.635),(76.115,13.635),(76.115,13.465),(75.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.805),(75.945,13.975),(76.115,13.975),(76.115,13.805),(75.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.125),(75.945,13.295),(76.115,13.295),(76.115,13.125),(75.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.185),(33.085,16.355),(33.255,16.355),(33.255,16.185),(33.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.525),(33.085,16.695),(33.255,16.695),(33.255,16.525),(33.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.265),(57.085,3.435),(57.255,3.435),(57.255,3.265),(57.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.605),(57.085,3.775),(57.255,3.775),(57.255,3.605),(57.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.245),(51.945,19.415),(52.115,19.415),(52.115,19.245),(51.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.325),(56.745,6.495),(56.915,6.495),(56.915,6.325),(56.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.665),(56.745,6.835),(56.915,6.835),(56.915,6.665),(56.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.465),(61.545,13.635),(61.715,13.635),(61.715,13.465),(61.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.805),(61.545,13.975),(61.715,13.975),(61.715,13.805),(61.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.125),(61.545,13.295),(61.715,13.295),(61.715,13.125),(61.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.265),(33.085,3.435),(33.255,3.435),(33.255,3.265),(33.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.605),(33.085,3.775),(33.255,3.775),(33.255,3.605),(33.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.325),(32.745,6.495),(32.915,6.495),(32.915,6.325),(32.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.665),(32.745,6.835),(32.915,6.835),(32.915,6.665),(32.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.485),(75.945,14.655),(76.115,14.655),(76.115,14.485),(75.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.825),(75.945,14.995),(76.115,14.995),(76.115,14.825),(75.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.145),(75.945,14.315),(76.115,14.315),(76.115,14.145),(75.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.265),(9.085,3.435),(9.255,3.435),(9.255,3.265),(9.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.605),(9.085,3.775),(9.255,3.775),(9.255,3.605),(9.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.905),(33.085,19.075),(33.255,19.075),(33.255,18.905),(33.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.465),(13.545,13.635),(13.715,13.635),(13.715,13.465),(13.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.805),(13.545,13.975),(13.715,13.975),(13.715,13.805),(13.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.125),(13.545,13.295),(13.715,13.295),(13.715,13.125),(13.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.345),(75.945,7.515),(76.115,7.515),(76.115,7.345),(75.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.685),(75.945,7.855),(76.115,7.855),(76.115,7.685),(75.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.005),(75.945,7.175),(76.115,7.175),(76.115,7.005),(75.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.845),(42.345,16.015),(42.515,16.015),(42.515,15.845),(42.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.845),(42.685,16.015),(42.855,16.015),(42.855,15.845),(42.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.945),(51.945,4.115),(52.115,4.115),(52.115,3.945),(51.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.145),(27.945,14.315),(28.115,14.315),(28.115,14.145),(27.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.485),(27.945,14.655),(28.115,14.655),(28.115,14.485),(27.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.825),(27.945,14.995),(28.115,14.995),(28.115,14.825),(27.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.285),(76.285,4.455),(76.455,4.455),(76.455,4.285),(76.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.625),(76.285,4.795),(76.455,4.795),(76.455,4.625),(76.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.345),(27.945,7.515),(28.115,7.515),(28.115,7.345),(27.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.685),(27.945,7.855),(28.115,7.855),(28.115,7.685),(27.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.885),(71.485,18.055),(71.655,18.055),(71.655,17.885),(71.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.885),(71.145,18.055),(71.315,18.055),(71.315,17.885),(71.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.005),(27.945,7.175),(28.115,7.175),(28.115,7.005),(27.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.065),(71.145,10.235),(71.315,10.235),(71.315,10.065),(71.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.065),(71.485,10.235),(71.655,10.235),(71.655,10.065),(71.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.745),(71.145,10.915),(71.315,10.915),(71.315,10.745),(71.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.745),(71.485,10.915),(71.655,10.915),(71.655,10.745),(71.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.405),(71.485,10.575),(71.655,10.575),(71.655,10.405),(71.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.405),(71.145,10.575),(71.315,10.575),(71.315,10.405),(71.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.285),(28.285,4.455),(28.455,4.455),(28.455,4.285),(28.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.625),(28.285,4.795),(28.455,4.795),(28.455,4.625),(28.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.045),(80.745,9.215),(80.915,9.215),(80.915,9.045),(80.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.005),(56.745,7.175),(56.915,7.175),(56.915,7.005),(56.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.685),(56.745,7.855),(56.915,7.855),(56.915,7.685),(56.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.345),(56.745,7.515),(56.915,7.515),(56.915,7.345),(56.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.325),(57.085,6.495),(57.255,6.495),(57.255,6.325),(57.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.665),(57.085,6.835),(57.255,6.835),(57.255,6.665),(57.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.005),(32.745,7.175),(32.915,7.175),(32.915,7.005),(32.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.345),(32.745,7.515),(32.915,7.515),(32.915,7.345),(32.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.685),(32.745,7.855),(32.915,7.855),(32.915,7.685),(32.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.905),(28.285,19.075),(28.455,19.075),(28.455,18.905),(28.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.325),(80.745,6.495),(80.915,6.495),(80.915,6.325),(80.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.665),(80.745,6.835),(80.915,6.835),(80.915,6.665),(80.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.325),(33.085,6.495),(33.255,6.495),(33.255,6.325),(33.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.665),(33.085,6.835),(33.255,6.835),(33.255,6.665),(33.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.985),(66.345,6.155),(66.515,6.155),(66.515,5.985),(66.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.985),(66.685,6.155),(66.855,6.155),(66.855,5.985),(66.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.285),(51.945,4.455),(52.115,4.455),(52.115,4.285),(51.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.625),(51.945,4.795),(52.115,4.795),(52.115,4.625),(51.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.985),(42.345,6.155),(42.515,6.155),(42.515,5.985),(42.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.985),(42.685,6.155),(42.855,6.155),(42.855,5.985),(42.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.445),(56.745,12.615),(56.915,12.615),(56.915,12.445),(56.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.105),(56.745,12.275),(56.915,12.275),(56.915,12.105),(56.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.785),(56.745,12.955),(56.915,12.955),(56.915,12.785),(56.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.445),(8.745,12.615),(8.915,12.615),(8.915,12.445),(8.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.785),(8.745,12.955),(8.915,12.955),(8.915,12.785),(8.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.105),(8.745,12.275),(8.915,12.275),(8.915,12.105),(8.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.905),(37.885,19.075),(38.055,19.075),(38.055,18.905),(37.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.045),(32.745,9.215),(32.915,9.215),(32.915,9.045),(32.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.425),(61.545,11.595),(61.715,11.595),(61.715,11.425),(61.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.085),(61.545,11.255),(61.715,11.255),(61.715,11.085),(61.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.765),(61.545,11.935),(61.715,11.935),(61.715,11.765),(61.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.905),(61.545,19.075),(61.715,19.075),(61.715,18.905),(61.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.205),(8.745,17.375),(8.915,17.375),(8.915,17.205),(8.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.545),(8.745,17.715),(8.915,17.715),(8.915,17.545),(8.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.965),(37.545,5.135),(37.715,5.135),(37.715,4.965),(37.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.765),(13.545,11.935),(13.715,11.935),(13.715,11.765),(13.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.425),(13.545,11.595),(13.715,11.595),(13.715,11.425),(13.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.085),(13.545,11.255),(13.715,11.255),(13.715,11.085),(13.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.125),(37.885,13.295),(38.055,13.295),(38.055,13.125),(37.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.465),(37.885,13.635),(38.055,13.635),(38.055,13.465),(37.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.805),(37.885,13.975),(38.055,13.975),(38.055,13.805),(37.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.365),(37.885,8.535),(38.055,8.535),(38.055,8.365),(37.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.705),(37.885,8.875),(38.055,8.875),(38.055,8.705),(37.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.025),(37.885,8.195),(38.055,8.195),(38.055,8.025),(37.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.445),(37.545,12.615),(37.715,12.615),(37.715,12.445),(37.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.785),(37.545,12.955),(37.715,12.955),(37.715,12.785),(37.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.105),(37.545,12.275),(37.715,12.275),(37.715,12.105),(37.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.505),(61.545,15.675),(61.715,15.675),(61.715,15.505),(61.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.165),(61.545,15.335),(61.715,15.335),(61.715,15.165),(61.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.405),(37.885,10.575),(38.055,10.575),(38.055,10.405),(37.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.745),(37.885,10.915),(38.055,10.915),(38.055,10.745),(37.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.065),(37.885,10.235),(38.055,10.235),(38.055,10.065),(37.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.205),(75.945,17.375),(76.115,17.375),(76.115,17.205),(75.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.545),(75.945,17.715),(76.115,17.715),(76.115,17.545),(75.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.505),(13.545,15.675),(13.715,15.675),(13.715,15.505),(13.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.165),(13.545,15.335),(13.715,15.335),(13.715,15.165),(13.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.225),(56.745,18.395),(56.915,18.395),(56.915,18.225),(56.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.565),(56.745,18.735),(56.915,18.735),(56.915,18.565),(56.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.965),(9.085,5.135),(9.255,5.135),(9.255,4.965),(9.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.945),(81.085,4.115),(81.255,4.115),(81.255,3.945),(81.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.865),(56.745,17.035),(56.915,17.035),(56.915,16.865),(56.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.245),(76.285,19.415),(76.455,19.415),(76.455,19.245),(76.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.965),(81.085,5.135),(81.255,5.135),(81.255,4.965),(81.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.225),(57.085,18.395),(57.255,18.395),(57.255,18.225),(57.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.565),(57.085,18.735),(57.255,18.735),(57.255,18.565),(57.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.865),(13.545,17.035),(13.715,17.035),(13.715,16.865),(13.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.685),(80.745,7.855),(80.915,7.855),(80.915,7.685),(80.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.885),(13.545,18.055),(13.715,18.055),(13.715,17.885),(13.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.205),(52.285,17.375),(52.455,17.375),(52.455,17.205),(52.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.545),(52.285,17.715),(52.455,17.715),(52.455,17.545),(52.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.985),(8.745,6.155),(8.915,6.155),(8.915,5.985),(8.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.325),(13.885,6.495),(14.055,6.495),(14.055,6.325),(13.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.665),(13.885,6.835),(14.055,6.835),(14.055,6.665),(13.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.745),(56.745,10.915),(56.915,10.915),(56.915,10.745),(56.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.065),(56.745,10.235),(56.915,10.235),(56.915,10.065),(56.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.405),(56.745,10.575),(56.915,10.575),(56.915,10.405),(56.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.865),(28.285,17.035),(28.455,17.035),(28.455,16.865),(28.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.845),(71.145,16.015),(71.315,16.015),(71.315,15.845),(71.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.845),(71.485,16.015),(71.655,16.015),(71.655,15.845),(71.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.265),(52.285,3.435),(52.455,3.435),(52.455,3.265),(52.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.605),(52.285,3.775),(52.455,3.775),(52.455,3.605),(52.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.745),(8.745,10.915),(8.915,10.915),(8.915,10.745),(8.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.065),(8.745,10.235),(8.915,10.235),(8.915,10.065),(8.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.405),(8.745,10.575),(8.915,10.575),(8.915,10.405),(8.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.845),(23.485,16.015),(23.655,16.015),(23.655,15.845),(23.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.845),(23.145,16.015),(23.315,16.015),(23.315,15.845),(23.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.045),(37.545,9.215),(37.715,9.215),(37.715,9.045),(37.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.305),(71.145,5.475),(71.315,5.475),(71.315,5.305),(71.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.305),(71.485,5.475),(71.655,5.475),(71.655,5.305),(71.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.645),(71.145,5.815),(71.315,5.815),(71.315,5.645),(71.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.625),(71.145,4.795),(71.315,4.795),(71.315,4.625),(71.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.645),(71.485,5.815),(71.655,5.815),(71.655,5.645),(71.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.285),(71.145,4.455),(71.315,4.455),(71.315,4.285),(71.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.625),(71.485,4.795),(71.655,4.795),(71.655,4.625),(71.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.285),(71.485,4.455),(71.655,4.455),(71.655,4.285),(71.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.265),(8.745,3.435),(8.915,3.435),(8.915,3.265),(8.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.605),(8.745,3.775),(8.915,3.775),(8.915,3.605),(8.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.365),(13.885,8.535),(14.055,8.535),(14.055,8.365),(13.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.705),(13.885,8.875),(14.055,8.875),(14.055,8.705),(13.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.025),(13.885,8.195),(14.055,8.195),(14.055,8.025),(13.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.245),(13.545,19.415),(13.715,19.415),(13.715,19.245),(13.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.465),(80.745,13.635),(80.915,13.635),(80.915,13.465),(80.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.805),(80.745,13.975),(80.915,13.975),(80.915,13.805),(80.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.105),(13.545,12.275),(13.715,12.275),(13.715,12.105),(13.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.845),(57.085,16.015),(57.255,16.015),(57.255,15.845),(57.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.445),(13.545,12.615),(13.715,12.615),(13.715,12.445),(13.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.785),(13.545,12.955),(13.715,12.955),(13.715,12.785),(13.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.125),(80.745,13.295),(80.915,13.295),(80.915,13.125),(80.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.285),(23.485,4.455),(23.655,4.455),(23.655,4.285),(23.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.625),(23.145,4.795),(23.315,4.795),(23.315,4.625),(23.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.625),(23.485,4.795),(23.655,4.795),(23.655,4.625),(23.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.285),(23.145,4.455),(23.315,4.455),(23.315,4.285),(23.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.065),(13.885,10.235),(14.055,10.235),(14.055,10.065),(13.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.405),(13.885,10.575),(14.055,10.575),(14.055,10.405),(13.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.745),(13.885,10.915),(14.055,10.915),(14.055,10.745),(13.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.985),(47.485,6.155),(47.655,6.155),(47.655,5.985),(47.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.845),(9.085,16.015),(9.255,16.015),(9.255,15.845),(9.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.045),(57.085,9.215),(57.255,9.215),(57.255,9.045),(57.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.965),(57.085,5.135),(57.255,5.135),(57.255,4.965),(57.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.965),(33.085,5.135),(33.255,5.135),(33.255,4.965),(33.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.985),(75.945,6.155),(76.115,6.155),(76.115,5.985),(75.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.685),(61.885,7.855),(62.055,7.855),(62.055,7.685),(61.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.045),(9.085,9.215),(9.255,9.215),(9.255,9.045),(9.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.045),(52.285,9.215),(52.455,9.215),(52.455,9.045),(52.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.185),(81.085,16.355),(81.255,16.355),(81.255,16.185),(81.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.825),(37.545,14.995),(37.715,14.995),(37.715,14.825),(37.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.145),(37.545,14.315),(37.715,14.315),(37.715,14.145),(37.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.525),(81.085,16.695),(81.255,16.695),(81.255,16.525),(81.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.485),(37.545,14.655),(37.715,14.655),(37.715,14.485),(37.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.005),(13.885,7.175),(14.055,7.175),(14.055,7.005),(13.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.685),(13.885,7.855),(14.055,7.855),(14.055,7.685),(13.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.345),(13.885,7.515),(14.055,7.515),(14.055,7.345),(13.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.205),(81.085,17.375),(81.255,17.375),(81.255,17.205),(81.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.545),(81.085,17.715),(81.255,17.715),(81.255,17.545),(81.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.665),(37.885,6.835),(38.055,6.835),(38.055,6.665),(37.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,2.925),(13.885,3.095),(14.055,3.095),(14.055,2.925),(13.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.325),(37.885,6.495),(38.055,6.495),(38.055,6.325),(37.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.565),(51.945,18.735),(52.115,18.735),(52.115,18.565),(51.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.225),(51.945,18.395),(52.115,18.395),(52.115,18.225),(51.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.205),(23.145,17.375),(23.315,17.375),(23.315,17.205),(23.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.205),(23.485,17.375),(23.655,17.375),(23.655,17.205),(23.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.545),(23.145,17.715),(23.315,17.715),(23.315,17.545),(23.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.545),(23.485,17.715),(23.655,17.715),(23.655,17.545),(23.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.125),(32.745,13.295),(32.915,13.295),(32.915,13.125),(32.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.465),(32.745,13.635),(32.915,13.635),(32.915,13.465),(32.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.805),(32.745,13.975),(32.915,13.975),(32.915,13.805),(32.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.965),(13.885,5.135),(14.055,5.135),(14.055,4.965),(13.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.465),(61.885,13.635),(62.055,13.635),(62.055,13.465),(61.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.805),(61.885,13.975),(62.055,13.975),(62.055,13.805),(61.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.125),(61.885,13.295),(62.055,13.295),(62.055,13.125),(61.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.885),(13.885,18.055),(14.055,18.055),(14.055,17.885),(13.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.905),(18.345,19.075),(18.515,19.075),(18.515,18.905),(18.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.905),(18.685,19.075),(18.855,19.075),(18.855,18.905),(18.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.265),(56.745,3.435),(56.915,3.435),(56.915,3.265),(56.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.605),(56.745,3.775),(56.915,3.775),(56.915,3.605),(56.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.125),(13.885,13.295),(14.055,13.295),(14.055,13.125),(13.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.465),(13.885,13.635),(14.055,13.635),(14.055,13.465),(13.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.805),(13.885,13.975),(14.055,13.975),(14.055,13.805),(13.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.025),(61.885,8.195),(62.055,8.195),(62.055,8.025),(61.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.365),(61.885,8.535),(62.055,8.535),(62.055,8.365),(61.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.705),(61.885,8.875),(62.055,8.875),(62.055,8.705),(61.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.265),(32.745,3.435),(32.915,3.435),(32.915,3.265),(32.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.605),(32.745,3.775),(32.915,3.775),(32.915,3.605),(32.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.445),(61.545,12.615),(61.715,12.615),(61.715,12.445),(61.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.785),(61.545,12.955),(61.715,12.955),(61.715,12.785),(61.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.105),(61.545,12.275),(61.715,12.275),(61.715,12.105),(61.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.165),(8.745,15.335),(8.915,15.335),(8.915,15.165),(8.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.505),(8.745,15.675),(8.915,15.675),(8.915,15.505),(8.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.065),(61.885,10.235),(62.055,10.235),(62.055,10.065),(61.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.405),(61.885,10.575),(62.055,10.575),(62.055,10.405),(61.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.745),(61.885,10.915),(62.055,10.915),(62.055,10.745),(61.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.825),(52.285,14.995),(52.455,14.995),(52.455,14.825),(52.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.145),(52.285,14.315),(52.455,14.315),(52.455,14.145),(52.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.485),(52.285,14.655),(52.455,14.655),(52.455,14.485),(52.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.625),(47.485,4.795),(47.655,4.795),(47.655,4.625),(47.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.625),(47.145,4.795),(47.315,4.795),(47.315,4.625),(47.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.285),(47.145,4.455),(47.315,4.455),(47.315,4.285),(47.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.285),(47.485,4.455),(47.655,4.455),(47.655,4.285),(47.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.905),(13.545,19.075),(13.715,19.075),(13.715,18.905),(13.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.905),(80.745,19.075),(80.915,19.075),(80.915,18.905),(80.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.885),(47.145,18.055),(47.315,18.055),(47.315,17.885),(47.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.885),(47.485,18.055),(47.655,18.055),(47.655,17.885),(47.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.485),(13.545,14.655),(13.715,14.655),(13.715,14.485),(13.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.825),(13.545,14.995),(13.715,14.995),(13.715,14.825),(13.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.145),(13.545,14.315),(13.715,14.315),(13.715,14.145),(13.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.725),(47.145,9.895),(47.315,9.895),(47.315,9.725),(47.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.725),(47.485,9.895),(47.655,9.895),(47.655,9.725),(47.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.385),(47.145,9.555),(47.315,9.555),(47.315,9.385),(47.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.385),(47.485,9.555),(47.655,9.555),(47.655,9.385),(47.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,2.925),(61.885,3.095),(62.055,3.095),(62.055,2.925),(61.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.305),(61.545,5.475),(61.715,5.475),(61.715,5.305),(61.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.645),(61.545,5.815),(61.715,5.815),(61.715,5.645),(61.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.805),(47.145,13.975),(47.315,13.975),(47.315,13.805),(47.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.885),(27.945,18.055),(28.115,18.055),(28.115,17.885),(27.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.805),(47.485,13.975),(47.655,13.975),(47.655,13.805),(47.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.465),(47.145,13.635),(47.315,13.635),(47.315,13.465),(47.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.465),(47.485,13.635),(47.655,13.635),(47.655,13.465),(47.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.245),(37.885,19.415),(38.055,19.415),(38.055,19.245),(37.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.125),(47.145,13.295),(47.315,13.295),(47.315,13.125),(47.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.125),(47.485,13.295),(47.655,13.295),(47.655,13.125),(47.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.305),(13.545,5.475),(13.715,5.475),(13.715,5.305),(13.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.645),(13.545,5.815),(13.715,5.815),(13.715,5.645),(13.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.965),(61.885,5.135),(62.055,5.135),(62.055,4.965),(61.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.305),(66.345,5.475),(66.515,5.475),(66.515,5.305),(66.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.645),(66.345,5.815),(66.515,5.815),(66.515,5.645),(66.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.645),(66.685,5.815),(66.855,5.815),(66.855,5.645),(66.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.305),(66.685,5.475),(66.855,5.475),(66.855,5.305),(66.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.305),(42.345,5.475),(42.515,5.475),(42.515,5.305),(42.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.305),(42.685,5.475),(42.855,5.475),(42.855,5.305),(42.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.645),(42.345,5.815),(42.515,5.815),(42.515,5.645),(42.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.645),(42.685,5.815),(42.855,5.815),(42.855,5.645),(42.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.865),(23.485,17.035),(23.655,17.035),(23.655,16.865),(23.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.865),(23.145,17.035),(23.315,17.035),(23.315,16.865),(23.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.045),(61.545,9.215),(61.715,9.215),(61.715,9.045),(61.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.185),(37.885,16.355),(38.055,16.355),(38.055,16.185),(37.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.525),(37.885,16.695),(38.055,16.695),(38.055,16.525),(37.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.045),(13.545,9.215),(13.715,9.215),(13.715,9.045),(13.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.965),(18.685,5.135),(18.855,5.135),(18.855,4.965),(18.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.165),(56.745,15.335),(56.915,15.335),(56.915,15.165),(56.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.505),(56.745,15.675),(56.915,15.675),(56.915,15.505),(56.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.965),(18.345,5.135),(18.515,5.135),(18.515,4.965),(18.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.385),(33.085,9.555),(33.255,9.555),(33.255,9.385),(33.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.725),(33.085,9.895),(33.255,9.895),(33.255,9.725),(33.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.485),(28.285,14.655),(28.455,14.655),(28.455,14.485),(28.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.825),(28.285,14.995),(28.455,14.995),(28.455,14.825),(28.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.145),(28.285,14.315),(28.455,14.315),(28.455,14.145),(28.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.225),(9.085,18.395),(9.255,18.395),(9.255,18.225),(9.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.565),(9.085,18.735),(9.255,18.735),(9.255,18.565),(9.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.605),(76.285,3.775),(76.455,3.775),(76.455,3.605),(76.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.265),(76.285,3.435),(76.455,3.435),(76.455,3.265),(76.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.045),(76.285,9.215),(76.455,9.215),(76.455,9.045),(76.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.485),(61.545,14.655),(61.715,14.655),(61.715,14.485),(61.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.825),(61.545,14.995),(61.715,14.995),(61.715,14.825),(61.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.145),(61.545,14.315),(61.715,14.315),(61.715,14.145),(61.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.445),(52.285,12.615),(52.455,12.615),(52.455,12.445),(52.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.785),(52.285,12.955),(52.455,12.955),(52.455,12.785),(52.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.265),(37.545,3.435),(37.715,3.435),(37.715,3.265),(37.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.605),(37.545,3.775),(37.715,3.775),(37.715,3.605),(37.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.045),(28.285,9.215),(28.455,9.215),(28.455,9.045),(28.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.105),(52.285,12.275),(52.455,12.275),(52.455,12.105),(52.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.965),(42.345,5.135),(42.515,5.135),(42.515,4.965),(42.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.965),(42.685,5.135),(42.855,5.135),(42.855,4.965),(42.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.265),(80.745,3.435),(80.915,3.435),(80.915,3.265),(80.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.605),(80.745,3.775),(80.915,3.775),(80.915,3.605),(80.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.905),(71.145,19.075),(71.315,19.075),(71.315,18.905),(71.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.905),(71.485,19.075),(71.655,19.075),(71.655,18.905),(71.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.845),(47.145,16.015),(47.315,16.015),(47.315,15.845),(47.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.845),(47.485,16.015),(47.655,16.015),(47.655,15.845),(47.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.685),(42.345,7.855),(42.515,7.855),(42.515,7.685),(42.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.685),(42.685,7.855),(42.855,7.855),(42.855,7.685),(42.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.085),(51.945,11.255),(52.115,11.255),(52.115,11.085),(51.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.425),(51.945,11.595),(52.115,11.595),(52.115,11.425),(51.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.765),(51.945,11.935),(52.115,11.935),(52.115,11.765),(51.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.225),(8.745,18.395),(8.915,18.395),(8.915,18.225),(8.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.565),(8.745,18.735),(8.915,18.735),(8.915,18.565),(8.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.905),(81.085,19.075),(81.255,19.075),(81.255,18.905),(81.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.865),(51.945,17.035),(52.115,17.035),(52.115,16.865),(51.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.945),(71.485,4.115),(71.655,4.115),(71.655,3.945),(71.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.945),(71.145,4.115),(71.315,4.115),(71.315,3.945),(71.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.525),(75.945,16.695),(76.115,16.695),(76.115,16.525),(75.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.185),(75.945,16.355),(76.115,16.355),(76.115,16.185),(75.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.945),(47.145,4.115),(47.315,4.115),(47.315,3.945),(47.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.945),(47.485,4.115),(47.655,4.115),(47.655,3.945),(47.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.825),(42.685,14.995),(42.855,14.995),(42.855,14.825),(42.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.485),(42.345,14.655),(42.515,14.655),(42.515,14.485),(42.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.485),(42.685,14.655),(42.855,14.655),(42.855,14.485),(42.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.825),(42.345,14.995),(42.515,14.995),(42.515,14.825),(42.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.145),(42.345,14.315),(42.515,14.315),(42.515,14.145),(42.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.145),(42.685,14.315),(42.855,14.315),(42.855,14.145),(42.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.865),(8.745,17.035),(8.915,17.035),(8.915,16.865),(8.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.945),(23.145,4.115),(23.315,4.115),(23.315,3.945),(23.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.945),(23.485,4.115),(23.655,4.115),(23.655,3.945),(23.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.925),(51.945,3.095),(52.115,3.095),(52.115,2.925),(51.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.045),(23.145,9.215),(23.315,9.215),(23.315,9.045),(23.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.045),(23.485,9.215),(23.655,9.215),(23.655,9.045),(23.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.045),(37.885,9.215),(38.055,9.215),(38.055,9.045),(37.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.865),(76.285,17.035),(76.455,17.035),(76.455,16.865),(76.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.305),(8.745,5.475),(8.915,5.475),(8.915,5.305),(8.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.645),(8.745,5.815),(8.915,5.815),(8.915,5.645),(8.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.445),(76.285,12.615),(76.455,12.615),(76.455,12.445),(76.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.105),(76.285,12.275),(76.455,12.275),(76.455,12.105),(76.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.505),(71.485,15.675),(71.655,15.675),(71.655,15.505),(71.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.165),(71.145,15.335),(71.315,15.335),(71.315,15.165),(71.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.165),(71.485,15.335),(71.655,15.335),(71.655,15.165),(71.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.785),(76.285,12.955),(76.455,12.955),(76.455,12.785),(76.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.505),(71.145,15.675),(71.315,15.675),(71.315,15.505),(71.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.365),(37.545,8.535),(37.715,8.535),(37.715,8.365),(37.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.705),(37.545,8.875),(37.715,8.875),(37.715,8.705),(37.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.025),(37.545,8.195),(37.715,8.195),(37.715,8.025),(37.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.425),(33.085,11.595),(33.255,11.595),(33.255,11.425),(33.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.085),(33.085,11.255),(33.255,11.255),(33.255,11.085),(33.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.765),(33.085,11.935),(33.255,11.935),(33.255,11.765),(33.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.105),(28.285,12.275),(28.455,12.275),(28.455,12.105),(28.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.145),(32.745,14.315),(32.915,14.315),(32.915,14.145),(32.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.165),(23.145,15.335),(23.315,15.335),(23.315,15.165),(23.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.165),(23.485,15.335),(23.655,15.335),(23.655,15.165),(23.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.445),(28.285,12.615),(28.455,12.615),(28.455,12.445),(28.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.785),(28.285,12.955),(28.455,12.955),(28.455,12.785),(28.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.505),(23.145,15.675),(23.315,15.675),(23.315,15.505),(23.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.505),(23.485,15.675),(23.655,15.675),(23.655,15.505),(23.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.485),(32.745,14.655),(32.915,14.655),(32.915,14.485),(32.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.825),(32.745,14.995),(32.915,14.995),(32.915,14.825),(32.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.985),(37.885,6.155),(38.055,6.155),(38.055,5.985),(37.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.085),(52.285,11.255),(52.455,11.255),(52.455,11.085),(52.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.765),(52.285,11.935),(52.455,11.935),(52.455,11.765),(52.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.425),(52.285,11.595),(52.455,11.595),(52.455,11.425),(52.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.945),(61.885,4.115),(62.055,4.115),(62.055,3.945),(61.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.505),(57.085,15.675),(57.255,15.675),(57.255,15.505),(57.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.165),(57.085,15.335),(57.255,15.335),(57.255,15.165),(57.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.965),(66.685,5.135),(66.855,5.135),(66.855,4.965),(66.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.965),(66.345,5.135),(66.515,5.135),(66.515,4.965),(66.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.505),(9.085,15.675),(9.255,15.675),(9.255,15.505),(9.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.985),(47.145,6.155),(47.315,6.155),(47.315,5.985),(47.145,5.985)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.985),(22.775,19.355),(24.025,19.355),(24.025,2.985),(22.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.845),(22.775,19.495),(24.025,19.495),(24.025,2.845),(22.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.985),(61.175,19.355),(62.425,19.355),(62.425,2.985),(61.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((61.545,2.845),(61.545,19.495),(62.055,19.495),(62.055,2.845),(61.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.845),(61.175,19.495),(62.425,19.495),(62.425,2.845),(61.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((66.345,2.845),(66.345,19.495),(66.855,19.495),(66.855,2.845),(66.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((71.145,2.845),(71.145,19.495),(71.655,19.495),(71.655,2.845),(71.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.985),(46.775,19.355),(48.025,19.355),(48.025,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.845),(46.775,19.495),(48.025,19.495),(48.025,2.845),(46.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.985),(65.975,19.355),(67.225,19.355),(67.225,2.985),(65.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.845),(65.975,19.495),(67.225,19.495),(67.225,2.845),(65.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((75.945,2.845),(75.945,19.495),(76.455,19.495),(76.455,2.845),(75.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.985),(75.575,19.355),(76.825,19.355),(76.825,2.985),(75.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.845),(75.575,19.495),(76.825,19.495),(76.825,2.845),(75.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((23.145,2.845),(23.145,19.495),(23.655,19.495),(23.655,2.845),(23.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((42.345,2.845),(42.345,19.495),(42.855,19.495),(42.855,2.845),(42.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.985),(56.375,19.355),(57.625,19.355),(57.625,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((56.745,2.845),(56.745,19.495),(57.255,19.495),(57.255,2.845),(56.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.845),(56.375,19.495),(57.625,19.495),(57.625,2.845),(56.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.545,2.845),(37.545,19.495),(38.055,19.495),(38.055,2.845),(37.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((47.145,2.845),(47.145,19.495),(47.655,19.495),(47.655,2.845),(47.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.985),(37.175,19.355),(38.425,19.355),(38.425,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.845),(37.175,19.495),(38.425,19.495),(38.425,2.845),(37.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((18.345,2.845),(18.345,19.495),(18.855,19.495),(18.855,2.845),(18.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.985),(41.975,19.355),(43.225,19.355),(43.225,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((27.945,2.845),(27.945,19.495),(28.455,19.495),(28.455,2.845),(27.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.985),(27.575,19.355),(28.825,19.355),(28.825,2.985),(27.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.845),(27.575,19.495),(28.825,19.495),(28.825,2.845),(27.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.845),(41.975,19.495),(43.225,19.495),(43.225,2.845),(41.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((8.745,2.845),(8.745,19.495),(9.255,19.495),(9.255,2.845),(8.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.985),(70.775,19.355),(72.025,19.355),(72.025,2.985),(70.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.845),(70.775,19.495),(72.025,19.495),(72.025,2.845),(70.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.985),(17.975,19.355),(19.225,19.355),(19.225,2.985),(17.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.845),(17.975,19.495),(19.225,19.495),(19.225,2.845),(17.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.985),(8.375,19.355),(9.625,19.355),(9.625,2.985),(8.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.845),(8.375,19.495),(9.625,19.495),(9.625,2.845),(8.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((13.545,2.845),(13.545,19.495),(14.055,19.495),(14.055,2.845),(13.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.985),(13.175,19.355),(14.425,19.355),(14.425,2.985),(13.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.845),(13.175,19.495),(14.425,19.495),(14.425,2.845),(13.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((80.745,2.845),(80.745,19.495),(81.255,19.495),(81.255,2.845),(80.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.745,2.845),(32.745,19.495),(33.255,19.495),(33.255,2.845),(32.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.985),(80.375,19.355),(81.625,19.355),(81.625,2.985),(80.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.845),(80.375,19.495),(81.625,19.495),(81.625,2.845),(80.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.945,2.845),(51.945,19.495),(52.455,19.495),(52.455,2.845),(51.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.985),(32.375,19.355),(33.625,19.355),(33.625,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.845),(32.375,19.495),(33.625,19.495),(33.625,2.845),(32.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.985),(51.575,19.355),(52.825,19.355),(52.825,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.845),(51.575,19.495),(52.825,19.495),(52.825,2.845),(51.575,2.845)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,2.985),(80.375,3.155),(80.545,3.155),(80.545,2.985),(80.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,2.985),(80.735,3.155),(80.905,3.155),(80.905,2.985),(80.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,2.985),(81.095,3.155),(81.265,3.155),(81.265,2.985),(81.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,2.985),(81.455,3.155),(81.625,3.155),(81.625,2.985),(81.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.345),(80.375,3.515),(80.545,3.515),(80.545,3.345),(80.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.345),(80.735,3.515),(80.905,3.515),(80.905,3.345),(80.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.345),(81.095,3.515),(81.265,3.515),(81.265,3.345),(81.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.345),(81.455,3.515),(81.625,3.515),(81.625,3.345),(81.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.705),(80.375,3.875),(80.545,3.875),(80.545,3.705),(80.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.705),(80.735,3.875),(80.905,3.875),(80.905,3.705),(80.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.705),(81.095,3.875),(81.265,3.875),(81.265,3.705),(81.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.705),(81.455,3.875),(81.625,3.875),(81.625,3.705),(81.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.065),(80.375,4.235),(80.545,4.235),(80.545,4.065),(80.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.065),(80.735,4.235),(80.905,4.235),(80.905,4.065),(80.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.065),(81.095,4.235),(81.265,4.235),(81.265,4.065),(81.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.065),(81.455,4.235),(81.625,4.235),(81.625,4.065),(81.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.425),(80.375,4.595),(80.545,4.595),(80.545,4.425),(80.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.425),(80.735,4.595),(80.905,4.595),(80.905,4.425),(80.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.425),(81.095,4.595),(81.265,4.595),(81.265,4.425),(81.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.425),(81.455,4.595),(81.625,4.595),(81.625,4.425),(81.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.785),(80.375,4.955),(80.545,4.955),(80.545,4.785),(80.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.785),(80.735,4.955),(80.905,4.955),(80.905,4.785),(80.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.785),(81.095,4.955),(81.265,4.955),(81.265,4.785),(81.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.785),(81.455,4.955),(81.625,4.955),(81.625,4.785),(81.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.145),(80.375,5.315),(80.545,5.315),(80.545,5.145),(80.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.145),(80.735,5.315),(80.905,5.315),(80.905,5.145),(80.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.145),(81.095,5.315),(81.265,5.315),(81.265,5.145),(81.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.145),(81.455,5.315),(81.625,5.315),(81.625,5.145),(81.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.505),(80.375,5.675),(80.545,5.675),(80.545,5.505),(80.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.505),(80.735,5.675),(80.905,5.675),(80.905,5.505),(80.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.505),(81.095,5.675),(81.265,5.675),(81.265,5.505),(81.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.505),(81.455,5.675),(81.625,5.675),(81.625,5.505),(81.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.865),(80.375,6.035),(80.545,6.035),(80.545,5.865),(80.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.865),(80.735,6.035),(80.905,6.035),(80.905,5.865),(80.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.865),(81.095,6.035),(81.265,6.035),(81.265,5.865),(81.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.865),(81.455,6.035),(81.625,6.035),(81.625,5.865),(81.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.225),(80.375,6.395),(80.545,6.395),(80.545,6.225),(80.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.225),(80.735,6.395),(80.905,6.395),(80.905,6.225),(80.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.225),(81.095,6.395),(81.265,6.395),(81.265,6.225),(81.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.225),(81.455,6.395),(81.625,6.395),(81.625,6.225),(81.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.585),(80.375,6.755),(80.545,6.755),(80.545,6.585),(80.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.585),(80.735,6.755),(80.905,6.755),(80.905,6.585),(80.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.585),(81.095,6.755),(81.265,6.755),(81.265,6.585),(81.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.585),(81.455,6.755),(81.625,6.755),(81.625,6.585),(81.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.945),(80.375,7.115),(80.545,7.115),(80.545,6.945),(80.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.945),(80.735,7.115),(80.905,7.115),(80.905,6.945),(80.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.945),(81.095,7.115),(81.265,7.115),(81.265,6.945),(81.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.945),(81.455,7.115),(81.625,7.115),(81.625,6.945),(81.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.305),(80.375,7.475),(80.545,7.475),(80.545,7.305),(80.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.305),(80.735,7.475),(80.905,7.475),(80.905,7.305),(80.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.305),(81.095,7.475),(81.265,7.475),(81.265,7.305),(81.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.305),(81.455,7.475),(81.625,7.475),(81.625,7.305),(81.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.665),(80.375,7.835),(80.545,7.835),(80.545,7.665),(80.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.665),(80.735,7.835),(80.905,7.835),(80.905,7.665),(80.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.665),(81.095,7.835),(81.265,7.835),(81.265,7.665),(81.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.665),(81.455,7.835),(81.625,7.835),(81.625,7.665),(81.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.025),(80.375,8.195),(80.545,8.195),(80.545,8.025),(80.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.025),(80.735,8.195),(80.905,8.195),(80.905,8.025),(80.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.025),(81.095,8.195),(81.265,8.195),(81.265,8.025),(81.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.025),(81.455,8.195),(81.625,8.195),(81.625,8.025),(81.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.385),(80.375,8.555),(80.545,8.555),(80.545,8.385),(80.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.385),(80.735,8.555),(80.905,8.555),(80.905,8.385),(80.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.385),(81.095,8.555),(81.265,8.555),(81.265,8.385),(81.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.385),(81.455,8.555),(81.625,8.555),(81.625,8.385),(81.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.745),(80.375,8.915),(80.545,8.915),(80.545,8.745),(80.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.745),(80.735,8.915),(80.905,8.915),(80.905,8.745),(80.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.745),(81.095,8.915),(81.265,8.915),(81.265,8.745),(81.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.745),(81.455,8.915),(81.625,8.915),(81.625,8.745),(81.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.105),(80.375,9.275),(80.545,9.275),(80.545,9.105),(80.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.105),(80.735,9.275),(80.905,9.275),(80.905,9.105),(80.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.105),(81.095,9.275),(81.265,9.275),(81.265,9.105),(81.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.105),(81.455,9.275),(81.625,9.275),(81.625,9.105),(81.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.465),(80.375,9.635),(80.545,9.635),(80.545,9.465),(80.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.465),(80.735,9.635),(80.905,9.635),(80.905,9.465),(80.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.465),(81.095,9.635),(81.265,9.635),(81.265,9.465),(81.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.465),(81.455,9.635),(81.625,9.635),(81.625,9.465),(81.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.825),(80.375,9.995),(80.545,9.995),(80.545,9.825),(80.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.825),(80.735,9.995),(80.905,9.995),(80.905,9.825),(80.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.825),(81.095,9.995),(81.265,9.995),(81.265,9.825),(81.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.825),(81.455,9.995),(81.625,9.995),(81.625,9.825),(81.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.185),(80.375,10.355),(80.545,10.355),(80.545,10.185),(80.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.185),(80.735,10.355),(80.905,10.355),(80.905,10.185),(80.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.185),(81.095,10.355),(81.265,10.355),(81.265,10.185),(81.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.185),(81.455,10.355),(81.625,10.355),(81.625,10.185),(81.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.545),(80.375,10.715),(80.545,10.715),(80.545,10.545),(80.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.545),(80.735,10.715),(80.905,10.715),(80.905,10.545),(80.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.545),(81.095,10.715),(81.265,10.715),(81.265,10.545),(81.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.545),(81.455,10.715),(81.625,10.715),(81.625,10.545),(81.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.905),(80.375,11.075),(80.545,11.075),(80.545,10.905),(80.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.905),(80.735,11.075),(80.905,11.075),(80.905,10.905),(80.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.905),(81.095,11.075),(81.265,11.075),(81.265,10.905),(81.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.905),(81.455,11.075),(81.625,11.075),(81.625,10.905),(81.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.265),(80.375,11.435),(80.545,11.435),(80.545,11.265),(80.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.265),(80.735,11.435),(80.905,11.435),(80.905,11.265),(80.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.265),(81.095,11.435),(81.265,11.435),(81.265,11.265),(81.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.265),(81.455,11.435),(81.625,11.435),(81.625,11.265),(81.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.625),(80.375,11.795),(80.545,11.795),(80.545,11.625),(80.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.625),(80.735,11.795),(80.905,11.795),(80.905,11.625),(80.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.625),(81.095,11.795),(81.265,11.795),(81.265,11.625),(81.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.625),(81.455,11.795),(81.625,11.795),(81.625,11.625),(81.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.985),(80.375,12.155),(80.545,12.155),(80.545,11.985),(80.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.985),(80.735,12.155),(80.905,12.155),(80.905,11.985),(80.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.985),(81.095,12.155),(81.265,12.155),(81.265,11.985),(81.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.985),(81.455,12.155),(81.625,12.155),(81.625,11.985),(81.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.345),(80.375,12.515),(80.545,12.515),(80.545,12.345),(80.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.345),(80.735,12.515),(80.905,12.515),(80.905,12.345),(80.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.345),(81.095,12.515),(81.265,12.515),(81.265,12.345),(81.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.345),(81.455,12.515),(81.625,12.515),(81.625,12.345),(81.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.705),(80.375,12.875),(80.545,12.875),(80.545,12.705),(80.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.705),(80.735,12.875),(80.905,12.875),(80.905,12.705),(80.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.705),(81.095,12.875),(81.265,12.875),(81.265,12.705),(81.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.705),(81.455,12.875),(81.625,12.875),(81.625,12.705),(81.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.065),(80.375,13.235),(80.545,13.235),(80.545,13.065),(80.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.065),(80.735,13.235),(80.905,13.235),(80.905,13.065),(80.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.065),(81.095,13.235),(81.265,13.235),(81.265,13.065),(81.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.065),(81.455,13.235),(81.625,13.235),(81.625,13.065),(81.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.425),(80.375,13.595),(80.545,13.595),(80.545,13.425),(80.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.425),(80.735,13.595),(80.905,13.595),(80.905,13.425),(80.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.425),(81.095,13.595),(81.265,13.595),(81.265,13.425),(81.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.425),(81.455,13.595),(81.625,13.595),(81.625,13.425),(81.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.785),(80.375,13.955),(80.545,13.955),(80.545,13.785),(80.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.785),(80.735,13.955),(80.905,13.955),(80.905,13.785),(80.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.785),(81.095,13.955),(81.265,13.955),(81.265,13.785),(81.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.785),(81.455,13.955),(81.625,13.955),(81.625,13.785),(81.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.145),(80.375,14.315),(80.545,14.315),(80.545,14.145),(80.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.145),(80.735,14.315),(80.905,14.315),(80.905,14.145),(80.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.145),(81.095,14.315),(81.265,14.315),(81.265,14.145),(81.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.145),(81.455,14.315),(81.625,14.315),(81.625,14.145),(81.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.505),(80.375,14.675),(80.545,14.675),(80.545,14.505),(80.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.505),(80.735,14.675),(80.905,14.675),(80.905,14.505),(80.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.505),(81.095,14.675),(81.265,14.675),(81.265,14.505),(81.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.505),(81.455,14.675),(81.625,14.675),(81.625,14.505),(81.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.865),(80.375,15.035),(80.545,15.035),(80.545,14.865),(80.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.865),(80.735,15.035),(80.905,15.035),(80.905,14.865),(80.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.865),(81.095,15.035),(81.265,15.035),(81.265,14.865),(81.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.865),(81.455,15.035),(81.625,15.035),(81.625,14.865),(81.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.225),(80.375,15.395),(80.545,15.395),(80.545,15.225),(80.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.225),(80.735,15.395),(80.905,15.395),(80.905,15.225),(80.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.225),(81.095,15.395),(81.265,15.395),(81.265,15.225),(81.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.225),(81.455,15.395),(81.625,15.395),(81.625,15.225),(81.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.585),(80.375,15.755),(80.545,15.755),(80.545,15.585),(80.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.585),(80.735,15.755),(80.905,15.755),(80.905,15.585),(80.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.585),(81.095,15.755),(81.265,15.755),(81.265,15.585),(81.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.585),(81.455,15.755),(81.625,15.755),(81.625,15.585),(81.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.945),(80.375,16.115),(80.545,16.115),(80.545,15.945),(80.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.945),(80.735,16.115),(80.905,16.115),(80.905,15.945),(80.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.945),(81.095,16.115),(81.265,16.115),(81.265,15.945),(81.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.945),(81.455,16.115),(81.625,16.115),(81.625,15.945),(81.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.305),(80.375,16.475),(80.545,16.475),(80.545,16.305),(80.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.305),(80.735,16.475),(80.905,16.475),(80.905,16.305),(80.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.305),(81.095,16.475),(81.265,16.475),(81.265,16.305),(81.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.305),(81.455,16.475),(81.625,16.475),(81.625,16.305),(81.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.665),(80.375,16.835),(80.545,16.835),(80.545,16.665),(80.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.665),(80.735,16.835),(80.905,16.835),(80.905,16.665),(80.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.665),(81.095,16.835),(81.265,16.835),(81.265,16.665),(81.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.665),(81.455,16.835),(81.625,16.835),(81.625,16.665),(81.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.025),(80.375,17.195),(80.545,17.195),(80.545,17.025),(80.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.025),(80.735,17.195),(80.905,17.195),(80.905,17.025),(80.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.025),(81.095,17.195),(81.265,17.195),(81.265,17.025),(81.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.025),(81.455,17.195),(81.625,17.195),(81.625,17.025),(81.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.385),(80.375,17.555),(80.545,17.555),(80.545,17.385),(80.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.385),(80.735,17.555),(80.905,17.555),(80.905,17.385),(80.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.385),(81.095,17.555),(81.265,17.555),(81.265,17.385),(81.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.385),(81.455,17.555),(81.625,17.555),(81.625,17.385),(81.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.745),(80.375,17.915),(80.545,17.915),(80.545,17.745),(80.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.745),(80.735,17.915),(80.905,17.915),(80.905,17.745),(80.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.745),(81.095,17.915),(81.265,17.915),(81.265,17.745),(81.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.745),(81.455,17.915),(81.625,17.915),(81.625,17.745),(81.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.105),(80.375,18.275),(80.545,18.275),(80.545,18.105),(80.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.105),(80.735,18.275),(80.905,18.275),(80.905,18.105),(80.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.105),(81.095,18.275),(81.265,18.275),(81.265,18.105),(81.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.105),(81.455,18.275),(81.625,18.275),(81.625,18.105),(81.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.465),(80.375,18.635),(80.545,18.635),(80.545,18.465),(80.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.465),(80.735,18.635),(80.905,18.635),(80.905,18.465),(80.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.465),(81.095,18.635),(81.265,18.635),(81.265,18.465),(81.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.465),(81.455,18.635),(81.625,18.635),(81.625,18.465),(81.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.825),(80.375,18.995),(80.545,18.995),(80.545,18.825),(80.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.825),(80.735,18.995),(80.905,18.995),(80.905,18.825),(80.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.825),(81.095,18.995),(81.265,18.995),(81.265,18.825),(81.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.825),(81.455,18.995),(81.625,18.995),(81.625,18.825),(81.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.185),(80.375,19.355),(80.545,19.355),(80.545,19.185),(80.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.185),(80.735,19.355),(80.905,19.355),(80.905,19.185),(80.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.185),(81.095,19.355),(81.265,19.355),(81.265,19.185),(81.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.185),(81.455,19.355),(81.625,19.355),(81.625,19.185),(81.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.985),(41.975,3.155),(42.145,3.155),(42.145,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.985),(42.335,3.155),(42.505,3.155),(42.505,2.985),(42.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.985),(42.695,3.155),(42.865,3.155),(42.865,2.985),(42.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.985),(43.055,3.155),(43.225,3.155),(43.225,2.985),(43.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.345),(41.975,3.515),(42.145,3.515),(42.145,3.345),(41.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.345),(42.335,3.515),(42.505,3.515),(42.505,3.345),(42.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.345),(42.695,3.515),(42.865,3.515),(42.865,3.345),(42.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.345),(43.055,3.515),(43.225,3.515),(43.225,3.345),(43.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.705),(41.975,3.875),(42.145,3.875),(42.145,3.705),(41.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.705),(42.335,3.875),(42.505,3.875),(42.505,3.705),(42.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.705),(42.695,3.875),(42.865,3.875),(42.865,3.705),(42.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.705),(43.055,3.875),(43.225,3.875),(43.225,3.705),(43.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.065),(41.975,4.235),(42.145,4.235),(42.145,4.065),(41.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.065),(42.335,4.235),(42.505,4.235),(42.505,4.065),(42.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.065),(42.695,4.235),(42.865,4.235),(42.865,4.065),(42.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.065),(43.055,4.235),(43.225,4.235),(43.225,4.065),(43.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.425),(41.975,4.595),(42.145,4.595),(42.145,4.425),(41.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.425),(42.335,4.595),(42.505,4.595),(42.505,4.425),(42.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.425),(42.695,4.595),(42.865,4.595),(42.865,4.425),(42.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.425),(43.055,4.595),(43.225,4.595),(43.225,4.425),(43.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.785),(41.975,4.955),(42.145,4.955),(42.145,4.785),(41.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.785),(42.335,4.955),(42.505,4.955),(42.505,4.785),(42.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.785),(42.695,4.955),(42.865,4.955),(42.865,4.785),(42.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.785),(43.055,4.955),(43.225,4.955),(43.225,4.785),(43.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.145),(41.975,5.315),(42.145,5.315),(42.145,5.145),(41.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.145),(42.335,5.315),(42.505,5.315),(42.505,5.145),(42.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.145),(42.695,5.315),(42.865,5.315),(42.865,5.145),(42.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.145),(43.055,5.315),(43.225,5.315),(43.225,5.145),(43.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.505),(41.975,5.675),(42.145,5.675),(42.145,5.505),(41.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.505),(42.335,5.675),(42.505,5.675),(42.505,5.505),(42.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.505),(42.695,5.675),(42.865,5.675),(42.865,5.505),(42.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.505),(43.055,5.675),(43.225,5.675),(43.225,5.505),(43.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.865),(41.975,6.035),(42.145,6.035),(42.145,5.865),(41.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.865),(42.335,6.035),(42.505,6.035),(42.505,5.865),(42.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.865),(42.695,6.035),(42.865,6.035),(42.865,5.865),(42.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.865),(43.055,6.035),(43.225,6.035),(43.225,5.865),(43.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.225),(41.975,6.395),(42.145,6.395),(42.145,6.225),(41.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.225),(42.335,6.395),(42.505,6.395),(42.505,6.225),(42.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.225),(42.695,6.395),(42.865,6.395),(42.865,6.225),(42.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.225),(43.055,6.395),(43.225,6.395),(43.225,6.225),(43.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.585),(41.975,6.755),(42.145,6.755),(42.145,6.585),(41.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.585),(42.335,6.755),(42.505,6.755),(42.505,6.585),(42.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.585),(42.695,6.755),(42.865,6.755),(42.865,6.585),(42.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.585),(43.055,6.755),(43.225,6.755),(43.225,6.585),(43.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.945),(41.975,7.115),(42.145,7.115),(42.145,6.945),(41.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.945),(42.335,7.115),(42.505,7.115),(42.505,6.945),(42.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.945),(42.695,7.115),(42.865,7.115),(42.865,6.945),(42.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.945),(43.055,7.115),(43.225,7.115),(43.225,6.945),(43.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.305),(41.975,7.475),(42.145,7.475),(42.145,7.305),(41.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.305),(42.335,7.475),(42.505,7.475),(42.505,7.305),(42.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.305),(42.695,7.475),(42.865,7.475),(42.865,7.305),(42.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.305),(43.055,7.475),(43.225,7.475),(43.225,7.305),(43.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.665),(41.975,7.835),(42.145,7.835),(42.145,7.665),(41.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.665),(42.335,7.835),(42.505,7.835),(42.505,7.665),(42.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.665),(42.695,7.835),(42.865,7.835),(42.865,7.665),(42.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.665),(43.055,7.835),(43.225,7.835),(43.225,7.665),(43.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.025),(41.975,8.195),(42.145,8.195),(42.145,8.025),(41.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.025),(42.335,8.195),(42.505,8.195),(42.505,8.025),(42.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.025),(42.695,8.195),(42.865,8.195),(42.865,8.025),(42.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.025),(43.055,8.195),(43.225,8.195),(43.225,8.025),(43.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.385),(41.975,8.555),(42.145,8.555),(42.145,8.385),(41.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.385),(42.335,8.555),(42.505,8.555),(42.505,8.385),(42.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.385),(42.695,8.555),(42.865,8.555),(42.865,8.385),(42.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.385),(43.055,8.555),(43.225,8.555),(43.225,8.385),(43.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.745),(41.975,8.915),(42.145,8.915),(42.145,8.745),(41.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.745),(42.335,8.915),(42.505,8.915),(42.505,8.745),(42.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.745),(42.695,8.915),(42.865,8.915),(42.865,8.745),(42.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.745),(43.055,8.915),(43.225,8.915),(43.225,8.745),(43.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.105),(41.975,9.275),(42.145,9.275),(42.145,9.105),(41.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.105),(42.335,9.275),(42.505,9.275),(42.505,9.105),(42.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.105),(42.695,9.275),(42.865,9.275),(42.865,9.105),(42.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.105),(43.055,9.275),(43.225,9.275),(43.225,9.105),(43.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.465),(41.975,9.635),(42.145,9.635),(42.145,9.465),(41.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.465),(42.335,9.635),(42.505,9.635),(42.505,9.465),(42.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.465),(42.695,9.635),(42.865,9.635),(42.865,9.465),(42.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.465),(43.055,9.635),(43.225,9.635),(43.225,9.465),(43.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.825),(41.975,9.995),(42.145,9.995),(42.145,9.825),(41.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.825),(42.335,9.995),(42.505,9.995),(42.505,9.825),(42.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.825),(42.695,9.995),(42.865,9.995),(42.865,9.825),(42.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.825),(43.055,9.995),(43.225,9.995),(43.225,9.825),(43.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.185),(41.975,10.355),(42.145,10.355),(42.145,10.185),(41.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.185),(42.335,10.355),(42.505,10.355),(42.505,10.185),(42.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.185),(42.695,10.355),(42.865,10.355),(42.865,10.185),(42.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.185),(43.055,10.355),(43.225,10.355),(43.225,10.185),(43.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.545),(41.975,10.715),(42.145,10.715),(42.145,10.545),(41.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.545),(42.335,10.715),(42.505,10.715),(42.505,10.545),(42.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.545),(42.695,10.715),(42.865,10.715),(42.865,10.545),(42.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.545),(43.055,10.715),(43.225,10.715),(43.225,10.545),(43.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.905),(41.975,11.075),(42.145,11.075),(42.145,10.905),(41.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.905),(42.335,11.075),(42.505,11.075),(42.505,10.905),(42.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.905),(42.695,11.075),(42.865,11.075),(42.865,10.905),(42.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.905),(43.055,11.075),(43.225,11.075),(43.225,10.905),(43.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.265),(41.975,11.435),(42.145,11.435),(42.145,11.265),(41.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.265),(42.335,11.435),(42.505,11.435),(42.505,11.265),(42.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.265),(42.695,11.435),(42.865,11.435),(42.865,11.265),(42.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.265),(43.055,11.435),(43.225,11.435),(43.225,11.265),(43.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.625),(41.975,11.795),(42.145,11.795),(42.145,11.625),(41.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.625),(42.335,11.795),(42.505,11.795),(42.505,11.625),(42.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.625),(42.695,11.795),(42.865,11.795),(42.865,11.625),(42.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.625),(43.055,11.795),(43.225,11.795),(43.225,11.625),(43.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.985),(41.975,12.155),(42.145,12.155),(42.145,11.985),(41.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.985),(42.335,12.155),(42.505,12.155),(42.505,11.985),(42.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.985),(42.695,12.155),(42.865,12.155),(42.865,11.985),(42.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.985),(43.055,12.155),(43.225,12.155),(43.225,11.985),(43.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.345),(41.975,12.515),(42.145,12.515),(42.145,12.345),(41.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.345),(42.335,12.515),(42.505,12.515),(42.505,12.345),(42.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.345),(42.695,12.515),(42.865,12.515),(42.865,12.345),(42.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.345),(43.055,12.515),(43.225,12.515),(43.225,12.345),(43.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.705),(41.975,12.875),(42.145,12.875),(42.145,12.705),(41.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.705),(42.335,12.875),(42.505,12.875),(42.505,12.705),(42.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.705),(42.695,12.875),(42.865,12.875),(42.865,12.705),(42.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.705),(43.055,12.875),(43.225,12.875),(43.225,12.705),(43.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.065),(41.975,13.235),(42.145,13.235),(42.145,13.065),(41.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.065),(42.335,13.235),(42.505,13.235),(42.505,13.065),(42.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.065),(42.695,13.235),(42.865,13.235),(42.865,13.065),(42.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.065),(43.055,13.235),(43.225,13.235),(43.225,13.065),(43.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.425),(41.975,13.595),(42.145,13.595),(42.145,13.425),(41.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.425),(42.335,13.595),(42.505,13.595),(42.505,13.425),(42.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.425),(42.695,13.595),(42.865,13.595),(42.865,13.425),(42.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.425),(43.055,13.595),(43.225,13.595),(43.225,13.425),(43.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.785),(41.975,13.955),(42.145,13.955),(42.145,13.785),(41.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.785),(42.335,13.955),(42.505,13.955),(42.505,13.785),(42.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.785),(42.695,13.955),(42.865,13.955),(42.865,13.785),(42.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.785),(43.055,13.955),(43.225,13.955),(43.225,13.785),(43.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.145),(41.975,14.315),(42.145,14.315),(42.145,14.145),(41.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.145),(42.335,14.315),(42.505,14.315),(42.505,14.145),(42.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.145),(42.695,14.315),(42.865,14.315),(42.865,14.145),(42.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.145),(43.055,14.315),(43.225,14.315),(43.225,14.145),(43.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.505),(41.975,14.675),(42.145,14.675),(42.145,14.505),(41.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.505),(42.335,14.675),(42.505,14.675),(42.505,14.505),(42.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.505),(42.695,14.675),(42.865,14.675),(42.865,14.505),(42.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.505),(43.055,14.675),(43.225,14.675),(43.225,14.505),(43.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.865),(41.975,15.035),(42.145,15.035),(42.145,14.865),(41.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.865),(42.335,15.035),(42.505,15.035),(42.505,14.865),(42.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.865),(42.695,15.035),(42.865,15.035),(42.865,14.865),(42.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.865),(43.055,15.035),(43.225,15.035),(43.225,14.865),(43.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.225),(41.975,15.395),(42.145,15.395),(42.145,15.225),(41.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.225),(42.335,15.395),(42.505,15.395),(42.505,15.225),(42.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.225),(42.695,15.395),(42.865,15.395),(42.865,15.225),(42.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.225),(43.055,15.395),(43.225,15.395),(43.225,15.225),(43.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.585),(41.975,15.755),(42.145,15.755),(42.145,15.585),(41.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.585),(42.335,15.755),(42.505,15.755),(42.505,15.585),(42.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.585),(42.695,15.755),(42.865,15.755),(42.865,15.585),(42.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.585),(43.055,15.755),(43.225,15.755),(43.225,15.585),(43.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.945),(41.975,16.115),(42.145,16.115),(42.145,15.945),(41.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.945),(42.335,16.115),(42.505,16.115),(42.505,15.945),(42.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.945),(42.695,16.115),(42.865,16.115),(42.865,15.945),(42.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.945),(43.055,16.115),(43.225,16.115),(43.225,15.945),(43.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.305),(41.975,16.475),(42.145,16.475),(42.145,16.305),(41.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.305),(42.335,16.475),(42.505,16.475),(42.505,16.305),(42.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.305),(42.695,16.475),(42.865,16.475),(42.865,16.305),(42.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.305),(43.055,16.475),(43.225,16.475),(43.225,16.305),(43.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.665),(41.975,16.835),(42.145,16.835),(42.145,16.665),(41.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.665),(42.335,16.835),(42.505,16.835),(42.505,16.665),(42.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.665),(42.695,16.835),(42.865,16.835),(42.865,16.665),(42.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.665),(43.055,16.835),(43.225,16.835),(43.225,16.665),(43.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.025),(41.975,17.195),(42.145,17.195),(42.145,17.025),(41.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.025),(42.335,17.195),(42.505,17.195),(42.505,17.025),(42.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.025),(42.695,17.195),(42.865,17.195),(42.865,17.025),(42.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.025),(43.055,17.195),(43.225,17.195),(43.225,17.025),(43.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.385),(41.975,17.555),(42.145,17.555),(42.145,17.385),(41.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.385),(42.335,17.555),(42.505,17.555),(42.505,17.385),(42.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.385),(42.695,17.555),(42.865,17.555),(42.865,17.385),(42.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.385),(43.055,17.555),(43.225,17.555),(43.225,17.385),(43.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.745),(41.975,17.915),(42.145,17.915),(42.145,17.745),(41.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.745),(42.335,17.915),(42.505,17.915),(42.505,17.745),(42.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.745),(42.695,17.915),(42.865,17.915),(42.865,17.745),(42.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.745),(43.055,17.915),(43.225,17.915),(43.225,17.745),(43.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.105),(41.975,18.275),(42.145,18.275),(42.145,18.105),(41.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.105),(42.335,18.275),(42.505,18.275),(42.505,18.105),(42.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.105),(42.695,18.275),(42.865,18.275),(42.865,18.105),(42.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.105),(43.055,18.275),(43.225,18.275),(43.225,18.105),(43.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.465),(41.975,18.635),(42.145,18.635),(42.145,18.465),(41.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.465),(42.335,18.635),(42.505,18.635),(42.505,18.465),(42.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.465),(42.695,18.635),(42.865,18.635),(42.865,18.465),(42.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.465),(43.055,18.635),(43.225,18.635),(43.225,18.465),(43.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.825),(41.975,18.995),(42.145,18.995),(42.145,18.825),(41.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.825),(42.335,18.995),(42.505,18.995),(42.505,18.825),(42.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.825),(42.695,18.995),(42.865,18.995),(42.865,18.825),(42.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.825),(43.055,18.995),(43.225,18.995),(43.225,18.825),(43.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.185),(41.975,19.355),(42.145,19.355),(42.145,19.185),(41.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.185),(42.335,19.355),(42.505,19.355),(42.505,19.185),(42.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.185),(42.695,19.355),(42.865,19.355),(42.865,19.185),(42.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.185),(43.055,19.355),(43.225,19.355),(43.225,19.185),(43.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.985),(46.775,3.155),(46.945,3.155),(46.945,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.985),(47.135,3.155),(47.305,3.155),(47.305,2.985),(47.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.985),(47.495,3.155),(47.665,3.155),(47.665,2.985),(47.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.985),(47.855,3.155),(48.025,3.155),(48.025,2.985),(47.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.345),(46.775,3.515),(46.945,3.515),(46.945,3.345),(46.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.345),(47.135,3.515),(47.305,3.515),(47.305,3.345),(47.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.345),(47.495,3.515),(47.665,3.515),(47.665,3.345),(47.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.345),(47.855,3.515),(48.025,3.515),(48.025,3.345),(47.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.705),(46.775,3.875),(46.945,3.875),(46.945,3.705),(46.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.705),(47.135,3.875),(47.305,3.875),(47.305,3.705),(47.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.705),(47.495,3.875),(47.665,3.875),(47.665,3.705),(47.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.705),(47.855,3.875),(48.025,3.875),(48.025,3.705),(47.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.065),(46.775,4.235),(46.945,4.235),(46.945,4.065),(46.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.065),(47.135,4.235),(47.305,4.235),(47.305,4.065),(47.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.065),(47.495,4.235),(47.665,4.235),(47.665,4.065),(47.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.065),(47.855,4.235),(48.025,4.235),(48.025,4.065),(47.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.425),(46.775,4.595),(46.945,4.595),(46.945,4.425),(46.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.425),(47.135,4.595),(47.305,4.595),(47.305,4.425),(47.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.425),(47.495,4.595),(47.665,4.595),(47.665,4.425),(47.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.425),(47.855,4.595),(48.025,4.595),(48.025,4.425),(47.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.785),(46.775,4.955),(46.945,4.955),(46.945,4.785),(46.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.785),(47.135,4.955),(47.305,4.955),(47.305,4.785),(47.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.785),(47.495,4.955),(47.665,4.955),(47.665,4.785),(47.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.785),(47.855,4.955),(48.025,4.955),(48.025,4.785),(47.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.145),(46.775,5.315),(46.945,5.315),(46.945,5.145),(46.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.145),(47.135,5.315),(47.305,5.315),(47.305,5.145),(47.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.145),(47.495,5.315),(47.665,5.315),(47.665,5.145),(47.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.145),(47.855,5.315),(48.025,5.315),(48.025,5.145),(47.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.505),(46.775,5.675),(46.945,5.675),(46.945,5.505),(46.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.505),(47.135,5.675),(47.305,5.675),(47.305,5.505),(47.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.505),(47.495,5.675),(47.665,5.675),(47.665,5.505),(47.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.505),(47.855,5.675),(48.025,5.675),(48.025,5.505),(47.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.865),(46.775,6.035),(46.945,6.035),(46.945,5.865),(46.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.865),(47.135,6.035),(47.305,6.035),(47.305,5.865),(47.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.865),(47.495,6.035),(47.665,6.035),(47.665,5.865),(47.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.865),(47.855,6.035),(48.025,6.035),(48.025,5.865),(47.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.225),(46.775,6.395),(46.945,6.395),(46.945,6.225),(46.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.225),(47.135,6.395),(47.305,6.395),(47.305,6.225),(47.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.225),(47.495,6.395),(47.665,6.395),(47.665,6.225),(47.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.225),(47.855,6.395),(48.025,6.395),(48.025,6.225),(47.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.585),(46.775,6.755),(46.945,6.755),(46.945,6.585),(46.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.585),(47.135,6.755),(47.305,6.755),(47.305,6.585),(47.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.585),(47.495,6.755),(47.665,6.755),(47.665,6.585),(47.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.585),(47.855,6.755),(48.025,6.755),(48.025,6.585),(47.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.945),(46.775,7.115),(46.945,7.115),(46.945,6.945),(46.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.945),(47.135,7.115),(47.305,7.115),(47.305,6.945),(47.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.945),(47.495,7.115),(47.665,7.115),(47.665,6.945),(47.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.945),(47.855,7.115),(48.025,7.115),(48.025,6.945),(47.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.305),(46.775,7.475),(46.945,7.475),(46.945,7.305),(46.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.305),(47.135,7.475),(47.305,7.475),(47.305,7.305),(47.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.305),(47.495,7.475),(47.665,7.475),(47.665,7.305),(47.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.305),(47.855,7.475),(48.025,7.475),(48.025,7.305),(47.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.665),(46.775,7.835),(46.945,7.835),(46.945,7.665),(46.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.665),(47.135,7.835),(47.305,7.835),(47.305,7.665),(47.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.665),(47.495,7.835),(47.665,7.835),(47.665,7.665),(47.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.665),(47.855,7.835),(48.025,7.835),(48.025,7.665),(47.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.025),(46.775,8.195),(46.945,8.195),(46.945,8.025),(46.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.025),(47.135,8.195),(47.305,8.195),(47.305,8.025),(47.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.025),(47.495,8.195),(47.665,8.195),(47.665,8.025),(47.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.025),(47.855,8.195),(48.025,8.195),(48.025,8.025),(47.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.385),(46.775,8.555),(46.945,8.555),(46.945,8.385),(46.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.385),(47.135,8.555),(47.305,8.555),(47.305,8.385),(47.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.385),(47.495,8.555),(47.665,8.555),(47.665,8.385),(47.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.385),(47.855,8.555),(48.025,8.555),(48.025,8.385),(47.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.745),(46.775,8.915),(46.945,8.915),(46.945,8.745),(46.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.745),(47.135,8.915),(47.305,8.915),(47.305,8.745),(47.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.745),(47.495,8.915),(47.665,8.915),(47.665,8.745),(47.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.745),(47.855,8.915),(48.025,8.915),(48.025,8.745),(47.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.105),(46.775,9.275),(46.945,9.275),(46.945,9.105),(46.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.105),(47.135,9.275),(47.305,9.275),(47.305,9.105),(47.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.105),(47.495,9.275),(47.665,9.275),(47.665,9.105),(47.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.105),(47.855,9.275),(48.025,9.275),(48.025,9.105),(47.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.465),(46.775,9.635),(46.945,9.635),(46.945,9.465),(46.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.465),(47.135,9.635),(47.305,9.635),(47.305,9.465),(47.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.465),(47.495,9.635),(47.665,9.635),(47.665,9.465),(47.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.465),(47.855,9.635),(48.025,9.635),(48.025,9.465),(47.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.825),(46.775,9.995),(46.945,9.995),(46.945,9.825),(46.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.825),(47.135,9.995),(47.305,9.995),(47.305,9.825),(47.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.825),(47.495,9.995),(47.665,9.995),(47.665,9.825),(47.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.825),(47.855,9.995),(48.025,9.995),(48.025,9.825),(47.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.185),(46.775,10.355),(46.945,10.355),(46.945,10.185),(46.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.185),(47.135,10.355),(47.305,10.355),(47.305,10.185),(47.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.185),(47.495,10.355),(47.665,10.355),(47.665,10.185),(47.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.185),(47.855,10.355),(48.025,10.355),(48.025,10.185),(47.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.545),(46.775,10.715),(46.945,10.715),(46.945,10.545),(46.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.545),(47.135,10.715),(47.305,10.715),(47.305,10.545),(47.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.545),(47.495,10.715),(47.665,10.715),(47.665,10.545),(47.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.545),(47.855,10.715),(48.025,10.715),(48.025,10.545),(47.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.905),(46.775,11.075),(46.945,11.075),(46.945,10.905),(46.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.905),(47.135,11.075),(47.305,11.075),(47.305,10.905),(47.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.905),(47.495,11.075),(47.665,11.075),(47.665,10.905),(47.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.905),(47.855,11.075),(48.025,11.075),(48.025,10.905),(47.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.265),(46.775,11.435),(46.945,11.435),(46.945,11.265),(46.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.265),(47.135,11.435),(47.305,11.435),(47.305,11.265),(47.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.265),(47.495,11.435),(47.665,11.435),(47.665,11.265),(47.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.265),(47.855,11.435),(48.025,11.435),(48.025,11.265),(47.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.625),(46.775,11.795),(46.945,11.795),(46.945,11.625),(46.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.625),(47.135,11.795),(47.305,11.795),(47.305,11.625),(47.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.625),(47.495,11.795),(47.665,11.795),(47.665,11.625),(47.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.625),(47.855,11.795),(48.025,11.795),(48.025,11.625),(47.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.985),(46.775,12.155),(46.945,12.155),(46.945,11.985),(46.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.985),(47.135,12.155),(47.305,12.155),(47.305,11.985),(47.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.985),(47.495,12.155),(47.665,12.155),(47.665,11.985),(47.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.985),(47.855,12.155),(48.025,12.155),(48.025,11.985),(47.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.345),(46.775,12.515),(46.945,12.515),(46.945,12.345),(46.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.345),(47.135,12.515),(47.305,12.515),(47.305,12.345),(47.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.345),(47.495,12.515),(47.665,12.515),(47.665,12.345),(47.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.345),(47.855,12.515),(48.025,12.515),(48.025,12.345),(47.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.705),(46.775,12.875),(46.945,12.875),(46.945,12.705),(46.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.705),(47.135,12.875),(47.305,12.875),(47.305,12.705),(47.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.705),(47.495,12.875),(47.665,12.875),(47.665,12.705),(47.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.705),(47.855,12.875),(48.025,12.875),(48.025,12.705),(47.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.065),(46.775,13.235),(46.945,13.235),(46.945,13.065),(46.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.065),(47.135,13.235),(47.305,13.235),(47.305,13.065),(47.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.065),(47.495,13.235),(47.665,13.235),(47.665,13.065),(47.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.065),(47.855,13.235),(48.025,13.235),(48.025,13.065),(47.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.425),(46.775,13.595),(46.945,13.595),(46.945,13.425),(46.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.425),(47.135,13.595),(47.305,13.595),(47.305,13.425),(47.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.425),(47.495,13.595),(47.665,13.595),(47.665,13.425),(47.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.425),(47.855,13.595),(48.025,13.595),(48.025,13.425),(47.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.785),(46.775,13.955),(46.945,13.955),(46.945,13.785),(46.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.785),(47.135,13.955),(47.305,13.955),(47.305,13.785),(47.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.785),(47.495,13.955),(47.665,13.955),(47.665,13.785),(47.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.785),(47.855,13.955),(48.025,13.955),(48.025,13.785),(47.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.145),(46.775,14.315),(46.945,14.315),(46.945,14.145),(46.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.145),(47.135,14.315),(47.305,14.315),(47.305,14.145),(47.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.145),(47.495,14.315),(47.665,14.315),(47.665,14.145),(47.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.145),(47.855,14.315),(48.025,14.315),(48.025,14.145),(47.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.505),(46.775,14.675),(46.945,14.675),(46.945,14.505),(46.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.505),(47.135,14.675),(47.305,14.675),(47.305,14.505),(47.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.505),(47.495,14.675),(47.665,14.675),(47.665,14.505),(47.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.505),(47.855,14.675),(48.025,14.675),(48.025,14.505),(47.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.865),(46.775,15.035),(46.945,15.035),(46.945,14.865),(46.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.865),(47.135,15.035),(47.305,15.035),(47.305,14.865),(47.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.865),(47.495,15.035),(47.665,15.035),(47.665,14.865),(47.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.865),(47.855,15.035),(48.025,15.035),(48.025,14.865),(47.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.225),(46.775,15.395),(46.945,15.395),(46.945,15.225),(46.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.225),(47.135,15.395),(47.305,15.395),(47.305,15.225),(47.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.225),(47.495,15.395),(47.665,15.395),(47.665,15.225),(47.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.225),(47.855,15.395),(48.025,15.395),(48.025,15.225),(47.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.585),(46.775,15.755),(46.945,15.755),(46.945,15.585),(46.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.585),(47.135,15.755),(47.305,15.755),(47.305,15.585),(47.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.585),(47.495,15.755),(47.665,15.755),(47.665,15.585),(47.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.585),(47.855,15.755),(48.025,15.755),(48.025,15.585),(47.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.945),(46.775,16.115),(46.945,16.115),(46.945,15.945),(46.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.945),(47.135,16.115),(47.305,16.115),(47.305,15.945),(47.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.945),(47.495,16.115),(47.665,16.115),(47.665,15.945),(47.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.945),(47.855,16.115),(48.025,16.115),(48.025,15.945),(47.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.305),(46.775,16.475),(46.945,16.475),(46.945,16.305),(46.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.305),(47.135,16.475),(47.305,16.475),(47.305,16.305),(47.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.305),(47.495,16.475),(47.665,16.475),(47.665,16.305),(47.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.305),(47.855,16.475),(48.025,16.475),(48.025,16.305),(47.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.665),(46.775,16.835),(46.945,16.835),(46.945,16.665),(46.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.665),(47.135,16.835),(47.305,16.835),(47.305,16.665),(47.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.665),(47.495,16.835),(47.665,16.835),(47.665,16.665),(47.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.665),(47.855,16.835),(48.025,16.835),(48.025,16.665),(47.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.025),(46.775,17.195),(46.945,17.195),(46.945,17.025),(46.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.025),(47.135,17.195),(47.305,17.195),(47.305,17.025),(47.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.025),(47.495,17.195),(47.665,17.195),(47.665,17.025),(47.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.025),(47.855,17.195),(48.025,17.195),(48.025,17.025),(47.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.385),(46.775,17.555),(46.945,17.555),(46.945,17.385),(46.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.385),(47.135,17.555),(47.305,17.555),(47.305,17.385),(47.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.385),(47.495,17.555),(47.665,17.555),(47.665,17.385),(47.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.385),(47.855,17.555),(48.025,17.555),(48.025,17.385),(47.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.745),(46.775,17.915),(46.945,17.915),(46.945,17.745),(46.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.745),(47.135,17.915),(47.305,17.915),(47.305,17.745),(47.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.745),(47.495,17.915),(47.665,17.915),(47.665,17.745),(47.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.745),(47.855,17.915),(48.025,17.915),(48.025,17.745),(47.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.105),(46.775,18.275),(46.945,18.275),(46.945,18.105),(46.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.105),(47.135,18.275),(47.305,18.275),(47.305,18.105),(47.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.105),(47.495,18.275),(47.665,18.275),(47.665,18.105),(47.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.105),(47.855,18.275),(48.025,18.275),(48.025,18.105),(47.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.465),(46.775,18.635),(46.945,18.635),(46.945,18.465),(46.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.465),(47.135,18.635),(47.305,18.635),(47.305,18.465),(47.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.465),(47.495,18.635),(47.665,18.635),(47.665,18.465),(47.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.465),(47.855,18.635),(48.025,18.635),(48.025,18.465),(47.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.825),(46.775,18.995),(46.945,18.995),(46.945,18.825),(46.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.825),(47.135,18.995),(47.305,18.995),(47.305,18.825),(47.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.825),(47.495,18.995),(47.665,18.995),(47.665,18.825),(47.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.825),(47.855,18.995),(48.025,18.995),(48.025,18.825),(47.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.185),(46.775,19.355),(46.945,19.355),(46.945,19.185),(46.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.185),(47.135,19.355),(47.305,19.355),(47.305,19.185),(47.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.185),(47.495,19.355),(47.665,19.355),(47.665,19.185),(47.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.185),(47.855,19.355),(48.025,19.355),(48.025,19.185),(47.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,2.985),(8.375,3.155),(8.545,3.155),(8.545,2.985),(8.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,2.985),(8.735,3.155),(8.905,3.155),(8.905,2.985),(8.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,2.985),(9.095,3.155),(9.265,3.155),(9.265,2.985),(9.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,2.985),(9.455,3.155),(9.625,3.155),(9.625,2.985),(9.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.345),(8.375,3.515),(8.545,3.515),(8.545,3.345),(8.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.345),(8.735,3.515),(8.905,3.515),(8.905,3.345),(8.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.345),(9.095,3.515),(9.265,3.515),(9.265,3.345),(9.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.345),(9.455,3.515),(9.625,3.515),(9.625,3.345),(9.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.705),(8.375,3.875),(8.545,3.875),(8.545,3.705),(8.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.705),(8.735,3.875),(8.905,3.875),(8.905,3.705),(8.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.705),(9.095,3.875),(9.265,3.875),(9.265,3.705),(9.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.705),(9.455,3.875),(9.625,3.875),(9.625,3.705),(9.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.065),(8.375,4.235),(8.545,4.235),(8.545,4.065),(8.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.065),(8.735,4.235),(8.905,4.235),(8.905,4.065),(8.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.065),(9.095,4.235),(9.265,4.235),(9.265,4.065),(9.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.065),(9.455,4.235),(9.625,4.235),(9.625,4.065),(9.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.425),(8.375,4.595),(8.545,4.595),(8.545,4.425),(8.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.425),(8.735,4.595),(8.905,4.595),(8.905,4.425),(8.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.425),(9.095,4.595),(9.265,4.595),(9.265,4.425),(9.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.425),(9.455,4.595),(9.625,4.595),(9.625,4.425),(9.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.785),(8.375,4.955),(8.545,4.955),(8.545,4.785),(8.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.785),(8.735,4.955),(8.905,4.955),(8.905,4.785),(8.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.785),(9.095,4.955),(9.265,4.955),(9.265,4.785),(9.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.785),(9.455,4.955),(9.625,4.955),(9.625,4.785),(9.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.145),(8.375,5.315),(8.545,5.315),(8.545,5.145),(8.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.145),(8.735,5.315),(8.905,5.315),(8.905,5.145),(8.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.145),(9.095,5.315),(9.265,5.315),(9.265,5.145),(9.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.145),(9.455,5.315),(9.625,5.315),(9.625,5.145),(9.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.505),(8.375,5.675),(8.545,5.675),(8.545,5.505),(8.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.505),(8.735,5.675),(8.905,5.675),(8.905,5.505),(8.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.505),(9.095,5.675),(9.265,5.675),(9.265,5.505),(9.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.505),(9.455,5.675),(9.625,5.675),(9.625,5.505),(9.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.865),(8.375,6.035),(8.545,6.035),(8.545,5.865),(8.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.865),(8.735,6.035),(8.905,6.035),(8.905,5.865),(8.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.865),(9.095,6.035),(9.265,6.035),(9.265,5.865),(9.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.865),(9.455,6.035),(9.625,6.035),(9.625,5.865),(9.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.225),(8.375,6.395),(8.545,6.395),(8.545,6.225),(8.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.225),(8.735,6.395),(8.905,6.395),(8.905,6.225),(8.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.225),(9.095,6.395),(9.265,6.395),(9.265,6.225),(9.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.225),(9.455,6.395),(9.625,6.395),(9.625,6.225),(9.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.585),(8.375,6.755),(8.545,6.755),(8.545,6.585),(8.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.585),(8.735,6.755),(8.905,6.755),(8.905,6.585),(8.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.585),(9.095,6.755),(9.265,6.755),(9.265,6.585),(9.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.585),(9.455,6.755),(9.625,6.755),(9.625,6.585),(9.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.945),(8.375,7.115),(8.545,7.115),(8.545,6.945),(8.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.945),(8.735,7.115),(8.905,7.115),(8.905,6.945),(8.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.945),(9.095,7.115),(9.265,7.115),(9.265,6.945),(9.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.945),(9.455,7.115),(9.625,7.115),(9.625,6.945),(9.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.305),(8.375,7.475),(8.545,7.475),(8.545,7.305),(8.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.305),(8.735,7.475),(8.905,7.475),(8.905,7.305),(8.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.305),(9.095,7.475),(9.265,7.475),(9.265,7.305),(9.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.305),(9.455,7.475),(9.625,7.475),(9.625,7.305),(9.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.665),(8.375,7.835),(8.545,7.835),(8.545,7.665),(8.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.665),(8.735,7.835),(8.905,7.835),(8.905,7.665),(8.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.665),(9.095,7.835),(9.265,7.835),(9.265,7.665),(9.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.665),(9.455,7.835),(9.625,7.835),(9.625,7.665),(9.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.025),(8.375,8.195),(8.545,8.195),(8.545,8.025),(8.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.025),(8.735,8.195),(8.905,8.195),(8.905,8.025),(8.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.025),(9.095,8.195),(9.265,8.195),(9.265,8.025),(9.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.025),(9.455,8.195),(9.625,8.195),(9.625,8.025),(9.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.385),(8.375,8.555),(8.545,8.555),(8.545,8.385),(8.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.385),(8.735,8.555),(8.905,8.555),(8.905,8.385),(8.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.385),(9.095,8.555),(9.265,8.555),(9.265,8.385),(9.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.385),(9.455,8.555),(9.625,8.555),(9.625,8.385),(9.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.745),(8.375,8.915),(8.545,8.915),(8.545,8.745),(8.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.745),(8.735,8.915),(8.905,8.915),(8.905,8.745),(8.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.745),(9.095,8.915),(9.265,8.915),(9.265,8.745),(9.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.745),(9.455,8.915),(9.625,8.915),(9.625,8.745),(9.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.105),(8.375,9.275),(8.545,9.275),(8.545,9.105),(8.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.105),(8.735,9.275),(8.905,9.275),(8.905,9.105),(8.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.105),(9.095,9.275),(9.265,9.275),(9.265,9.105),(9.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.105),(9.455,9.275),(9.625,9.275),(9.625,9.105),(9.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.465),(8.375,9.635),(8.545,9.635),(8.545,9.465),(8.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.465),(8.735,9.635),(8.905,9.635),(8.905,9.465),(8.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.465),(9.095,9.635),(9.265,9.635),(9.265,9.465),(9.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.465),(9.455,9.635),(9.625,9.635),(9.625,9.465),(9.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.825),(8.375,9.995),(8.545,9.995),(8.545,9.825),(8.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.825),(8.735,9.995),(8.905,9.995),(8.905,9.825),(8.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.825),(9.095,9.995),(9.265,9.995),(9.265,9.825),(9.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.825),(9.455,9.995),(9.625,9.995),(9.625,9.825),(9.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.185),(8.375,10.355),(8.545,10.355),(8.545,10.185),(8.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.185),(8.735,10.355),(8.905,10.355),(8.905,10.185),(8.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.185),(9.095,10.355),(9.265,10.355),(9.265,10.185),(9.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.185),(9.455,10.355),(9.625,10.355),(9.625,10.185),(9.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.545),(8.375,10.715),(8.545,10.715),(8.545,10.545),(8.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.545),(8.735,10.715),(8.905,10.715),(8.905,10.545),(8.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.545),(9.095,10.715),(9.265,10.715),(9.265,10.545),(9.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.545),(9.455,10.715),(9.625,10.715),(9.625,10.545),(9.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.905),(8.375,11.075),(8.545,11.075),(8.545,10.905),(8.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.905),(8.735,11.075),(8.905,11.075),(8.905,10.905),(8.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.905),(9.095,11.075),(9.265,11.075),(9.265,10.905),(9.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.905),(9.455,11.075),(9.625,11.075),(9.625,10.905),(9.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.265),(8.375,11.435),(8.545,11.435),(8.545,11.265),(8.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.265),(8.735,11.435),(8.905,11.435),(8.905,11.265),(8.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.265),(9.095,11.435),(9.265,11.435),(9.265,11.265),(9.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.265),(9.455,11.435),(9.625,11.435),(9.625,11.265),(9.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.625),(8.375,11.795),(8.545,11.795),(8.545,11.625),(8.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.625),(8.735,11.795),(8.905,11.795),(8.905,11.625),(8.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.625),(9.095,11.795),(9.265,11.795),(9.265,11.625),(9.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.625),(9.455,11.795),(9.625,11.795),(9.625,11.625),(9.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.985),(8.375,12.155),(8.545,12.155),(8.545,11.985),(8.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.985),(8.735,12.155),(8.905,12.155),(8.905,11.985),(8.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.985),(9.095,12.155),(9.265,12.155),(9.265,11.985),(9.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.985),(9.455,12.155),(9.625,12.155),(9.625,11.985),(9.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.345),(8.375,12.515),(8.545,12.515),(8.545,12.345),(8.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.345),(8.735,12.515),(8.905,12.515),(8.905,12.345),(8.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.345),(9.095,12.515),(9.265,12.515),(9.265,12.345),(9.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.345),(9.455,12.515),(9.625,12.515),(9.625,12.345),(9.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.705),(8.375,12.875),(8.545,12.875),(8.545,12.705),(8.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.705),(8.735,12.875),(8.905,12.875),(8.905,12.705),(8.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.705),(9.095,12.875),(9.265,12.875),(9.265,12.705),(9.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.705),(9.455,12.875),(9.625,12.875),(9.625,12.705),(9.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.065),(8.375,13.235),(8.545,13.235),(8.545,13.065),(8.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.065),(8.735,13.235),(8.905,13.235),(8.905,13.065),(8.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.065),(9.095,13.235),(9.265,13.235),(9.265,13.065),(9.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.065),(9.455,13.235),(9.625,13.235),(9.625,13.065),(9.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.425),(8.375,13.595),(8.545,13.595),(8.545,13.425),(8.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.425),(8.735,13.595),(8.905,13.595),(8.905,13.425),(8.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.425),(9.095,13.595),(9.265,13.595),(9.265,13.425),(9.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.425),(9.455,13.595),(9.625,13.595),(9.625,13.425),(9.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.785),(8.375,13.955),(8.545,13.955),(8.545,13.785),(8.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.785),(8.735,13.955),(8.905,13.955),(8.905,13.785),(8.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.785),(9.095,13.955),(9.265,13.955),(9.265,13.785),(9.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.785),(9.455,13.955),(9.625,13.955),(9.625,13.785),(9.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.145),(8.375,14.315),(8.545,14.315),(8.545,14.145),(8.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.145),(8.735,14.315),(8.905,14.315),(8.905,14.145),(8.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.145),(9.095,14.315),(9.265,14.315),(9.265,14.145),(9.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.145),(9.455,14.315),(9.625,14.315),(9.625,14.145),(9.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.505),(8.375,14.675),(8.545,14.675),(8.545,14.505),(8.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.505),(8.735,14.675),(8.905,14.675),(8.905,14.505),(8.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.505),(9.095,14.675),(9.265,14.675),(9.265,14.505),(9.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.505),(9.455,14.675),(9.625,14.675),(9.625,14.505),(9.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.865),(8.375,15.035),(8.545,15.035),(8.545,14.865),(8.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.865),(8.735,15.035),(8.905,15.035),(8.905,14.865),(8.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.865),(9.095,15.035),(9.265,15.035),(9.265,14.865),(9.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.865),(9.455,15.035),(9.625,15.035),(9.625,14.865),(9.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.225),(8.375,15.395),(8.545,15.395),(8.545,15.225),(8.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.225),(8.735,15.395),(8.905,15.395),(8.905,15.225),(8.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.225),(9.095,15.395),(9.265,15.395),(9.265,15.225),(9.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.225),(9.455,15.395),(9.625,15.395),(9.625,15.225),(9.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.585),(8.375,15.755),(8.545,15.755),(8.545,15.585),(8.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.585),(8.735,15.755),(8.905,15.755),(8.905,15.585),(8.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.585),(9.095,15.755),(9.265,15.755),(9.265,15.585),(9.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.585),(9.455,15.755),(9.625,15.755),(9.625,15.585),(9.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.945),(8.375,16.115),(8.545,16.115),(8.545,15.945),(8.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.945),(8.735,16.115),(8.905,16.115),(8.905,15.945),(8.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.945),(9.095,16.115),(9.265,16.115),(9.265,15.945),(9.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.945),(9.455,16.115),(9.625,16.115),(9.625,15.945),(9.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.305),(8.375,16.475),(8.545,16.475),(8.545,16.305),(8.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.305),(8.735,16.475),(8.905,16.475),(8.905,16.305),(8.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.305),(9.095,16.475),(9.265,16.475),(9.265,16.305),(9.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.305),(9.455,16.475),(9.625,16.475),(9.625,16.305),(9.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.665),(8.375,16.835),(8.545,16.835),(8.545,16.665),(8.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.665),(8.735,16.835),(8.905,16.835),(8.905,16.665),(8.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.665),(9.095,16.835),(9.265,16.835),(9.265,16.665),(9.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.665),(9.455,16.835),(9.625,16.835),(9.625,16.665),(9.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.025),(8.375,17.195),(8.545,17.195),(8.545,17.025),(8.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.025),(8.735,17.195),(8.905,17.195),(8.905,17.025),(8.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.025),(9.095,17.195),(9.265,17.195),(9.265,17.025),(9.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.025),(9.455,17.195),(9.625,17.195),(9.625,17.025),(9.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.385),(8.375,17.555),(8.545,17.555),(8.545,17.385),(8.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.385),(8.735,17.555),(8.905,17.555),(8.905,17.385),(8.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.385),(9.095,17.555),(9.265,17.555),(9.265,17.385),(9.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.385),(9.455,17.555),(9.625,17.555),(9.625,17.385),(9.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.745),(8.375,17.915),(8.545,17.915),(8.545,17.745),(8.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.745),(8.735,17.915),(8.905,17.915),(8.905,17.745),(8.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.745),(9.095,17.915),(9.265,17.915),(9.265,17.745),(9.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.745),(9.455,17.915),(9.625,17.915),(9.625,17.745),(9.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.105),(8.375,18.275),(8.545,18.275),(8.545,18.105),(8.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.105),(8.735,18.275),(8.905,18.275),(8.905,18.105),(8.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.105),(9.095,18.275),(9.265,18.275),(9.265,18.105),(9.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.105),(9.455,18.275),(9.625,18.275),(9.625,18.105),(9.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.465),(8.375,18.635),(8.545,18.635),(8.545,18.465),(8.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.465),(8.735,18.635),(8.905,18.635),(8.905,18.465),(8.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.465),(9.095,18.635),(9.265,18.635),(9.265,18.465),(9.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.465),(9.455,18.635),(9.625,18.635),(9.625,18.465),(9.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.825),(8.375,18.995),(8.545,18.995),(8.545,18.825),(8.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.825),(8.735,18.995),(8.905,18.995),(8.905,18.825),(8.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.825),(9.095,18.995),(9.265,18.995),(9.265,18.825),(9.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.825),(9.455,18.995),(9.625,18.995),(9.625,18.825),(9.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.185),(8.375,19.355),(8.545,19.355),(8.545,19.185),(8.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.185),(8.735,19.355),(8.905,19.355),(8.905,19.185),(8.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.185),(9.095,19.355),(9.265,19.355),(9.265,19.185),(9.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.185),(9.455,19.355),(9.625,19.355),(9.625,19.185),(9.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.985),(32.375,3.155),(32.545,3.155),(32.545,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.985),(32.735,3.155),(32.905,3.155),(32.905,2.985),(32.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.985),(33.095,3.155),(33.265,3.155),(33.265,2.985),(33.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.985),(33.455,3.155),(33.625,3.155),(33.625,2.985),(33.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.345),(32.375,3.515),(32.545,3.515),(32.545,3.345),(32.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.345),(32.735,3.515),(32.905,3.515),(32.905,3.345),(32.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.345),(33.095,3.515),(33.265,3.515),(33.265,3.345),(33.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.345),(33.455,3.515),(33.625,3.515),(33.625,3.345),(33.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.705),(32.375,3.875),(32.545,3.875),(32.545,3.705),(32.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.705),(32.735,3.875),(32.905,3.875),(32.905,3.705),(32.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.705),(33.095,3.875),(33.265,3.875),(33.265,3.705),(33.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.705),(33.455,3.875),(33.625,3.875),(33.625,3.705),(33.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.065),(32.375,4.235),(32.545,4.235),(32.545,4.065),(32.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.065),(32.735,4.235),(32.905,4.235),(32.905,4.065),(32.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.065),(33.095,4.235),(33.265,4.235),(33.265,4.065),(33.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.065),(33.455,4.235),(33.625,4.235),(33.625,4.065),(33.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.425),(32.375,4.595),(32.545,4.595),(32.545,4.425),(32.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.425),(32.735,4.595),(32.905,4.595),(32.905,4.425),(32.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.425),(33.095,4.595),(33.265,4.595),(33.265,4.425),(33.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.425),(33.455,4.595),(33.625,4.595),(33.625,4.425),(33.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.785),(32.375,4.955),(32.545,4.955),(32.545,4.785),(32.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.785),(32.735,4.955),(32.905,4.955),(32.905,4.785),(32.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.785),(33.095,4.955),(33.265,4.955),(33.265,4.785),(33.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.785),(33.455,4.955),(33.625,4.955),(33.625,4.785),(33.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.145),(32.375,5.315),(32.545,5.315),(32.545,5.145),(32.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.145),(32.735,5.315),(32.905,5.315),(32.905,5.145),(32.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.145),(33.095,5.315),(33.265,5.315),(33.265,5.145),(33.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.145),(33.455,5.315),(33.625,5.315),(33.625,5.145),(33.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.505),(32.375,5.675),(32.545,5.675),(32.545,5.505),(32.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.505),(32.735,5.675),(32.905,5.675),(32.905,5.505),(32.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.505),(33.095,5.675),(33.265,5.675),(33.265,5.505),(33.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.505),(33.455,5.675),(33.625,5.675),(33.625,5.505),(33.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.865),(32.375,6.035),(32.545,6.035),(32.545,5.865),(32.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.865),(32.735,6.035),(32.905,6.035),(32.905,5.865),(32.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.865),(33.095,6.035),(33.265,6.035),(33.265,5.865),(33.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.865),(33.455,6.035),(33.625,6.035),(33.625,5.865),(33.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.225),(32.375,6.395),(32.545,6.395),(32.545,6.225),(32.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.225),(32.735,6.395),(32.905,6.395),(32.905,6.225),(32.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.225),(33.095,6.395),(33.265,6.395),(33.265,6.225),(33.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.225),(33.455,6.395),(33.625,6.395),(33.625,6.225),(33.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.585),(32.375,6.755),(32.545,6.755),(32.545,6.585),(32.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.585),(32.735,6.755),(32.905,6.755),(32.905,6.585),(32.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.585),(33.095,6.755),(33.265,6.755),(33.265,6.585),(33.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.585),(33.455,6.755),(33.625,6.755),(33.625,6.585),(33.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.945),(32.375,7.115),(32.545,7.115),(32.545,6.945),(32.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.945),(32.735,7.115),(32.905,7.115),(32.905,6.945),(32.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.945),(33.095,7.115),(33.265,7.115),(33.265,6.945),(33.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.945),(33.455,7.115),(33.625,7.115),(33.625,6.945),(33.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.305),(32.375,7.475),(32.545,7.475),(32.545,7.305),(32.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.305),(32.735,7.475),(32.905,7.475),(32.905,7.305),(32.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.305),(33.095,7.475),(33.265,7.475),(33.265,7.305),(33.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.305),(33.455,7.475),(33.625,7.475),(33.625,7.305),(33.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.665),(32.375,7.835),(32.545,7.835),(32.545,7.665),(32.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.665),(32.735,7.835),(32.905,7.835),(32.905,7.665),(32.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.665),(33.095,7.835),(33.265,7.835),(33.265,7.665),(33.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.665),(33.455,7.835),(33.625,7.835),(33.625,7.665),(33.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.025),(32.375,8.195),(32.545,8.195),(32.545,8.025),(32.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.025),(32.735,8.195),(32.905,8.195),(32.905,8.025),(32.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.025),(33.095,8.195),(33.265,8.195),(33.265,8.025),(33.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.025),(33.455,8.195),(33.625,8.195),(33.625,8.025),(33.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.385),(32.375,8.555),(32.545,8.555),(32.545,8.385),(32.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.385),(32.735,8.555),(32.905,8.555),(32.905,8.385),(32.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.385),(33.095,8.555),(33.265,8.555),(33.265,8.385),(33.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.385),(33.455,8.555),(33.625,8.555),(33.625,8.385),(33.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.745),(32.375,8.915),(32.545,8.915),(32.545,8.745),(32.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.745),(32.735,8.915),(32.905,8.915),(32.905,8.745),(32.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.745),(33.095,8.915),(33.265,8.915),(33.265,8.745),(33.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.745),(33.455,8.915),(33.625,8.915),(33.625,8.745),(33.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.105),(32.375,9.275),(32.545,9.275),(32.545,9.105),(32.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.105),(32.735,9.275),(32.905,9.275),(32.905,9.105),(32.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.105),(33.095,9.275),(33.265,9.275),(33.265,9.105),(33.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.105),(33.455,9.275),(33.625,9.275),(33.625,9.105),(33.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.465),(32.375,9.635),(32.545,9.635),(32.545,9.465),(32.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.465),(32.735,9.635),(32.905,9.635),(32.905,9.465),(32.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.465),(33.095,9.635),(33.265,9.635),(33.265,9.465),(33.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.465),(33.455,9.635),(33.625,9.635),(33.625,9.465),(33.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.825),(32.375,9.995),(32.545,9.995),(32.545,9.825),(32.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.825),(32.735,9.995),(32.905,9.995),(32.905,9.825),(32.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.825),(33.095,9.995),(33.265,9.995),(33.265,9.825),(33.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.825),(33.455,9.995),(33.625,9.995),(33.625,9.825),(33.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.185),(32.375,10.355),(32.545,10.355),(32.545,10.185),(32.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.185),(32.735,10.355),(32.905,10.355),(32.905,10.185),(32.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.185),(33.095,10.355),(33.265,10.355),(33.265,10.185),(33.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.185),(33.455,10.355),(33.625,10.355),(33.625,10.185),(33.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.545),(32.375,10.715),(32.545,10.715),(32.545,10.545),(32.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.545),(32.735,10.715),(32.905,10.715),(32.905,10.545),(32.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.545),(33.095,10.715),(33.265,10.715),(33.265,10.545),(33.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.545),(33.455,10.715),(33.625,10.715),(33.625,10.545),(33.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.905),(32.375,11.075),(32.545,11.075),(32.545,10.905),(32.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.905),(32.735,11.075),(32.905,11.075),(32.905,10.905),(32.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.905),(33.095,11.075),(33.265,11.075),(33.265,10.905),(33.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.905),(33.455,11.075),(33.625,11.075),(33.625,10.905),(33.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.265),(32.375,11.435),(32.545,11.435),(32.545,11.265),(32.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.265),(32.735,11.435),(32.905,11.435),(32.905,11.265),(32.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.265),(33.095,11.435),(33.265,11.435),(33.265,11.265),(33.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.265),(33.455,11.435),(33.625,11.435),(33.625,11.265),(33.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.625),(32.375,11.795),(32.545,11.795),(32.545,11.625),(32.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.625),(32.735,11.795),(32.905,11.795),(32.905,11.625),(32.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.625),(33.095,11.795),(33.265,11.795),(33.265,11.625),(33.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.625),(33.455,11.795),(33.625,11.795),(33.625,11.625),(33.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.985),(32.375,12.155),(32.545,12.155),(32.545,11.985),(32.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.985),(32.735,12.155),(32.905,12.155),(32.905,11.985),(32.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.985),(33.095,12.155),(33.265,12.155),(33.265,11.985),(33.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.985),(33.455,12.155),(33.625,12.155),(33.625,11.985),(33.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.345),(32.375,12.515),(32.545,12.515),(32.545,12.345),(32.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.345),(32.735,12.515),(32.905,12.515),(32.905,12.345),(32.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.345),(33.095,12.515),(33.265,12.515),(33.265,12.345),(33.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.345),(33.455,12.515),(33.625,12.515),(33.625,12.345),(33.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.705),(32.375,12.875),(32.545,12.875),(32.545,12.705),(32.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.705),(32.735,12.875),(32.905,12.875),(32.905,12.705),(32.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.705),(33.095,12.875),(33.265,12.875),(33.265,12.705),(33.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.705),(33.455,12.875),(33.625,12.875),(33.625,12.705),(33.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.065),(32.375,13.235),(32.545,13.235),(32.545,13.065),(32.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.065),(32.735,13.235),(32.905,13.235),(32.905,13.065),(32.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.065),(33.095,13.235),(33.265,13.235),(33.265,13.065),(33.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.065),(33.455,13.235),(33.625,13.235),(33.625,13.065),(33.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.425),(32.375,13.595),(32.545,13.595),(32.545,13.425),(32.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.425),(32.735,13.595),(32.905,13.595),(32.905,13.425),(32.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.425),(33.095,13.595),(33.265,13.595),(33.265,13.425),(33.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.425),(33.455,13.595),(33.625,13.595),(33.625,13.425),(33.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.785),(32.375,13.955),(32.545,13.955),(32.545,13.785),(32.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.785),(32.735,13.955),(32.905,13.955),(32.905,13.785),(32.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.785),(33.095,13.955),(33.265,13.955),(33.265,13.785),(33.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.785),(33.455,13.955),(33.625,13.955),(33.625,13.785),(33.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.145),(32.375,14.315),(32.545,14.315),(32.545,14.145),(32.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.145),(32.735,14.315),(32.905,14.315),(32.905,14.145),(32.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.145),(33.095,14.315),(33.265,14.315),(33.265,14.145),(33.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.145),(33.455,14.315),(33.625,14.315),(33.625,14.145),(33.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.505),(32.375,14.675),(32.545,14.675),(32.545,14.505),(32.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.505),(32.735,14.675),(32.905,14.675),(32.905,14.505),(32.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.505),(33.095,14.675),(33.265,14.675),(33.265,14.505),(33.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.505),(33.455,14.675),(33.625,14.675),(33.625,14.505),(33.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.865),(32.375,15.035),(32.545,15.035),(32.545,14.865),(32.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.865),(32.735,15.035),(32.905,15.035),(32.905,14.865),(32.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.865),(33.095,15.035),(33.265,15.035),(33.265,14.865),(33.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.865),(33.455,15.035),(33.625,15.035),(33.625,14.865),(33.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.225),(32.375,15.395),(32.545,15.395),(32.545,15.225),(32.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.225),(32.735,15.395),(32.905,15.395),(32.905,15.225),(32.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.225),(33.095,15.395),(33.265,15.395),(33.265,15.225),(33.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.225),(33.455,15.395),(33.625,15.395),(33.625,15.225),(33.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.585),(32.375,15.755),(32.545,15.755),(32.545,15.585),(32.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.585),(32.735,15.755),(32.905,15.755),(32.905,15.585),(32.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.585),(33.095,15.755),(33.265,15.755),(33.265,15.585),(33.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.585),(33.455,15.755),(33.625,15.755),(33.625,15.585),(33.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.945),(32.375,16.115),(32.545,16.115),(32.545,15.945),(32.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.945),(32.735,16.115),(32.905,16.115),(32.905,15.945),(32.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.945),(33.095,16.115),(33.265,16.115),(33.265,15.945),(33.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.945),(33.455,16.115),(33.625,16.115),(33.625,15.945),(33.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.305),(32.375,16.475),(32.545,16.475),(32.545,16.305),(32.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.305),(32.735,16.475),(32.905,16.475),(32.905,16.305),(32.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.305),(33.095,16.475),(33.265,16.475),(33.265,16.305),(33.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.305),(33.455,16.475),(33.625,16.475),(33.625,16.305),(33.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.665),(32.375,16.835),(32.545,16.835),(32.545,16.665),(32.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.665),(32.735,16.835),(32.905,16.835),(32.905,16.665),(32.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.665),(33.095,16.835),(33.265,16.835),(33.265,16.665),(33.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.665),(33.455,16.835),(33.625,16.835),(33.625,16.665),(33.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.025),(32.375,17.195),(32.545,17.195),(32.545,17.025),(32.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.025),(32.735,17.195),(32.905,17.195),(32.905,17.025),(32.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.025),(33.095,17.195),(33.265,17.195),(33.265,17.025),(33.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.025),(33.455,17.195),(33.625,17.195),(33.625,17.025),(33.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.385),(32.375,17.555),(32.545,17.555),(32.545,17.385),(32.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.385),(32.735,17.555),(32.905,17.555),(32.905,17.385),(32.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.385),(33.095,17.555),(33.265,17.555),(33.265,17.385),(33.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.385),(33.455,17.555),(33.625,17.555),(33.625,17.385),(33.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.745),(32.375,17.915),(32.545,17.915),(32.545,17.745),(32.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.745),(32.735,17.915),(32.905,17.915),(32.905,17.745),(32.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.745),(33.095,17.915),(33.265,17.915),(33.265,17.745),(33.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.745),(33.455,17.915),(33.625,17.915),(33.625,17.745),(33.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.105),(32.375,18.275),(32.545,18.275),(32.545,18.105),(32.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.105),(32.735,18.275),(32.905,18.275),(32.905,18.105),(32.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.105),(33.095,18.275),(33.265,18.275),(33.265,18.105),(33.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.105),(33.455,18.275),(33.625,18.275),(33.625,18.105),(33.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.465),(32.375,18.635),(32.545,18.635),(32.545,18.465),(32.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.465),(32.735,18.635),(32.905,18.635),(32.905,18.465),(32.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.465),(33.095,18.635),(33.265,18.635),(33.265,18.465),(33.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.465),(33.455,18.635),(33.625,18.635),(33.625,18.465),(33.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.825),(32.375,18.995),(32.545,18.995),(32.545,18.825),(32.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.825),(32.735,18.995),(32.905,18.995),(32.905,18.825),(32.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.825),(33.095,18.995),(33.265,18.995),(33.265,18.825),(33.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.825),(33.455,18.995),(33.625,18.995),(33.625,18.825),(33.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.185),(32.375,19.355),(32.545,19.355),(32.545,19.185),(32.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.185),(32.735,19.355),(32.905,19.355),(32.905,19.185),(32.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.185),(33.095,19.355),(33.265,19.355),(33.265,19.185),(33.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.185),(33.455,19.355),(33.625,19.355),(33.625,19.185),(33.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,2.985),(61.175,3.155),(61.345,3.155),(61.345,2.985),(61.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,2.985),(61.535,3.155),(61.705,3.155),(61.705,2.985),(61.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,2.985),(61.895,3.155),(62.065,3.155),(62.065,2.985),(61.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,2.985),(62.255,3.155),(62.425,3.155),(62.425,2.985),(62.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.345),(61.175,3.515),(61.345,3.515),(61.345,3.345),(61.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.345),(61.535,3.515),(61.705,3.515),(61.705,3.345),(61.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.345),(61.895,3.515),(62.065,3.515),(62.065,3.345),(61.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.345),(62.255,3.515),(62.425,3.515),(62.425,3.345),(62.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.705),(61.175,3.875),(61.345,3.875),(61.345,3.705),(61.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.705),(61.535,3.875),(61.705,3.875),(61.705,3.705),(61.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.705),(61.895,3.875),(62.065,3.875),(62.065,3.705),(61.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.705),(62.255,3.875),(62.425,3.875),(62.425,3.705),(62.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.065),(61.175,4.235),(61.345,4.235),(61.345,4.065),(61.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.065),(61.535,4.235),(61.705,4.235),(61.705,4.065),(61.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.065),(61.895,4.235),(62.065,4.235),(62.065,4.065),(61.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.065),(62.255,4.235),(62.425,4.235),(62.425,4.065),(62.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.425),(61.175,4.595),(61.345,4.595),(61.345,4.425),(61.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.425),(61.535,4.595),(61.705,4.595),(61.705,4.425),(61.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.425),(61.895,4.595),(62.065,4.595),(62.065,4.425),(61.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.425),(62.255,4.595),(62.425,4.595),(62.425,4.425),(62.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.785),(61.175,4.955),(61.345,4.955),(61.345,4.785),(61.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.785),(61.535,4.955),(61.705,4.955),(61.705,4.785),(61.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.785),(61.895,4.955),(62.065,4.955),(62.065,4.785),(61.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.785),(62.255,4.955),(62.425,4.955),(62.425,4.785),(62.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.145),(61.175,5.315),(61.345,5.315),(61.345,5.145),(61.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.145),(61.535,5.315),(61.705,5.315),(61.705,5.145),(61.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.145),(61.895,5.315),(62.065,5.315),(62.065,5.145),(61.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.145),(62.255,5.315),(62.425,5.315),(62.425,5.145),(62.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.505),(61.175,5.675),(61.345,5.675),(61.345,5.505),(61.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.505),(61.535,5.675),(61.705,5.675),(61.705,5.505),(61.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.505),(61.895,5.675),(62.065,5.675),(62.065,5.505),(61.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.505),(62.255,5.675),(62.425,5.675),(62.425,5.505),(62.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.865),(61.175,6.035),(61.345,6.035),(61.345,5.865),(61.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.865),(61.535,6.035),(61.705,6.035),(61.705,5.865),(61.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.865),(61.895,6.035),(62.065,6.035),(62.065,5.865),(61.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.865),(62.255,6.035),(62.425,6.035),(62.425,5.865),(62.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.225),(61.175,6.395),(61.345,6.395),(61.345,6.225),(61.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.225),(61.535,6.395),(61.705,6.395),(61.705,6.225),(61.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.225),(61.895,6.395),(62.065,6.395),(62.065,6.225),(61.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.225),(62.255,6.395),(62.425,6.395),(62.425,6.225),(62.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.585),(61.175,6.755),(61.345,6.755),(61.345,6.585),(61.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.585),(61.535,6.755),(61.705,6.755),(61.705,6.585),(61.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.585),(61.895,6.755),(62.065,6.755),(62.065,6.585),(61.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.585),(62.255,6.755),(62.425,6.755),(62.425,6.585),(62.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.945),(61.175,7.115),(61.345,7.115),(61.345,6.945),(61.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.945),(61.535,7.115),(61.705,7.115),(61.705,6.945),(61.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.945),(61.895,7.115),(62.065,7.115),(62.065,6.945),(61.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.945),(62.255,7.115),(62.425,7.115),(62.425,6.945),(62.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.305),(61.175,7.475),(61.345,7.475),(61.345,7.305),(61.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.305),(61.535,7.475),(61.705,7.475),(61.705,7.305),(61.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.305),(61.895,7.475),(62.065,7.475),(62.065,7.305),(61.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.305),(62.255,7.475),(62.425,7.475),(62.425,7.305),(62.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.665),(61.175,7.835),(61.345,7.835),(61.345,7.665),(61.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.665),(61.535,7.835),(61.705,7.835),(61.705,7.665),(61.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.665),(61.895,7.835),(62.065,7.835),(62.065,7.665),(61.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.665),(62.255,7.835),(62.425,7.835),(62.425,7.665),(62.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.025),(61.175,8.195),(61.345,8.195),(61.345,8.025),(61.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.025),(61.535,8.195),(61.705,8.195),(61.705,8.025),(61.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.025),(61.895,8.195),(62.065,8.195),(62.065,8.025),(61.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.025),(62.255,8.195),(62.425,8.195),(62.425,8.025),(62.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.385),(61.175,8.555),(61.345,8.555),(61.345,8.385),(61.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.385),(61.535,8.555),(61.705,8.555),(61.705,8.385),(61.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.385),(61.895,8.555),(62.065,8.555),(62.065,8.385),(61.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.385),(62.255,8.555),(62.425,8.555),(62.425,8.385),(62.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.745),(61.175,8.915),(61.345,8.915),(61.345,8.745),(61.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.745),(61.535,8.915),(61.705,8.915),(61.705,8.745),(61.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.745),(61.895,8.915),(62.065,8.915),(62.065,8.745),(61.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.745),(62.255,8.915),(62.425,8.915),(62.425,8.745),(62.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.105),(61.175,9.275),(61.345,9.275),(61.345,9.105),(61.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.105),(61.535,9.275),(61.705,9.275),(61.705,9.105),(61.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.105),(61.895,9.275),(62.065,9.275),(62.065,9.105),(61.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.105),(62.255,9.275),(62.425,9.275),(62.425,9.105),(62.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.465),(61.175,9.635),(61.345,9.635),(61.345,9.465),(61.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.465),(61.535,9.635),(61.705,9.635),(61.705,9.465),(61.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.465),(61.895,9.635),(62.065,9.635),(62.065,9.465),(61.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.465),(62.255,9.635),(62.425,9.635),(62.425,9.465),(62.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.825),(61.175,9.995),(61.345,9.995),(61.345,9.825),(61.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.825),(61.535,9.995),(61.705,9.995),(61.705,9.825),(61.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.825),(61.895,9.995),(62.065,9.995),(62.065,9.825),(61.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.825),(62.255,9.995),(62.425,9.995),(62.425,9.825),(62.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.185),(61.175,10.355),(61.345,10.355),(61.345,10.185),(61.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.185),(61.535,10.355),(61.705,10.355),(61.705,10.185),(61.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.185),(61.895,10.355),(62.065,10.355),(62.065,10.185),(61.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.185),(62.255,10.355),(62.425,10.355),(62.425,10.185),(62.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.545),(61.175,10.715),(61.345,10.715),(61.345,10.545),(61.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.545),(61.535,10.715),(61.705,10.715),(61.705,10.545),(61.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.545),(61.895,10.715),(62.065,10.715),(62.065,10.545),(61.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.545),(62.255,10.715),(62.425,10.715),(62.425,10.545),(62.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.905),(61.175,11.075),(61.345,11.075),(61.345,10.905),(61.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.905),(61.535,11.075),(61.705,11.075),(61.705,10.905),(61.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.905),(61.895,11.075),(62.065,11.075),(62.065,10.905),(61.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.905),(62.255,11.075),(62.425,11.075),(62.425,10.905),(62.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.265),(61.175,11.435),(61.345,11.435),(61.345,11.265),(61.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.265),(61.535,11.435),(61.705,11.435),(61.705,11.265),(61.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.265),(61.895,11.435),(62.065,11.435),(62.065,11.265),(61.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.265),(62.255,11.435),(62.425,11.435),(62.425,11.265),(62.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.625),(61.175,11.795),(61.345,11.795),(61.345,11.625),(61.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.625),(61.535,11.795),(61.705,11.795),(61.705,11.625),(61.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.625),(61.895,11.795),(62.065,11.795),(62.065,11.625),(61.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.625),(62.255,11.795),(62.425,11.795),(62.425,11.625),(62.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.985),(61.175,12.155),(61.345,12.155),(61.345,11.985),(61.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.985),(61.535,12.155),(61.705,12.155),(61.705,11.985),(61.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.985),(61.895,12.155),(62.065,12.155),(62.065,11.985),(61.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.985),(62.255,12.155),(62.425,12.155),(62.425,11.985),(62.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.345),(61.175,12.515),(61.345,12.515),(61.345,12.345),(61.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.345),(61.535,12.515),(61.705,12.515),(61.705,12.345),(61.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.345),(61.895,12.515),(62.065,12.515),(62.065,12.345),(61.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.345),(62.255,12.515),(62.425,12.515),(62.425,12.345),(62.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.705),(61.175,12.875),(61.345,12.875),(61.345,12.705),(61.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.705),(61.535,12.875),(61.705,12.875),(61.705,12.705),(61.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.705),(61.895,12.875),(62.065,12.875),(62.065,12.705),(61.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.705),(62.255,12.875),(62.425,12.875),(62.425,12.705),(62.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.065),(61.175,13.235),(61.345,13.235),(61.345,13.065),(61.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.065),(61.535,13.235),(61.705,13.235),(61.705,13.065),(61.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.065),(61.895,13.235),(62.065,13.235),(62.065,13.065),(61.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.065),(62.255,13.235),(62.425,13.235),(62.425,13.065),(62.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.425),(61.175,13.595),(61.345,13.595),(61.345,13.425),(61.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.425),(61.535,13.595),(61.705,13.595),(61.705,13.425),(61.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.425),(61.895,13.595),(62.065,13.595),(62.065,13.425),(61.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.425),(62.255,13.595),(62.425,13.595),(62.425,13.425),(62.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.785),(61.175,13.955),(61.345,13.955),(61.345,13.785),(61.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.785),(61.535,13.955),(61.705,13.955),(61.705,13.785),(61.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.785),(61.895,13.955),(62.065,13.955),(62.065,13.785),(61.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.785),(62.255,13.955),(62.425,13.955),(62.425,13.785),(62.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.145),(61.175,14.315),(61.345,14.315),(61.345,14.145),(61.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.145),(61.535,14.315),(61.705,14.315),(61.705,14.145),(61.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.145),(61.895,14.315),(62.065,14.315),(62.065,14.145),(61.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.145),(62.255,14.315),(62.425,14.315),(62.425,14.145),(62.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.505),(61.175,14.675),(61.345,14.675),(61.345,14.505),(61.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.505),(61.535,14.675),(61.705,14.675),(61.705,14.505),(61.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.505),(61.895,14.675),(62.065,14.675),(62.065,14.505),(61.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.505),(62.255,14.675),(62.425,14.675),(62.425,14.505),(62.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.865),(61.175,15.035),(61.345,15.035),(61.345,14.865),(61.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.865),(61.535,15.035),(61.705,15.035),(61.705,14.865),(61.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.865),(61.895,15.035),(62.065,15.035),(62.065,14.865),(61.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.865),(62.255,15.035),(62.425,15.035),(62.425,14.865),(62.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.225),(61.175,15.395),(61.345,15.395),(61.345,15.225),(61.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.225),(61.535,15.395),(61.705,15.395),(61.705,15.225),(61.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.225),(61.895,15.395),(62.065,15.395),(62.065,15.225),(61.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.225),(62.255,15.395),(62.425,15.395),(62.425,15.225),(62.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.585),(61.175,15.755),(61.345,15.755),(61.345,15.585),(61.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.585),(61.535,15.755),(61.705,15.755),(61.705,15.585),(61.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.585),(61.895,15.755),(62.065,15.755),(62.065,15.585),(61.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.585),(62.255,15.755),(62.425,15.755),(62.425,15.585),(62.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.945),(61.175,16.115),(61.345,16.115),(61.345,15.945),(61.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.945),(61.535,16.115),(61.705,16.115),(61.705,15.945),(61.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.945),(61.895,16.115),(62.065,16.115),(62.065,15.945),(61.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.945),(62.255,16.115),(62.425,16.115),(62.425,15.945),(62.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.305),(61.175,16.475),(61.345,16.475),(61.345,16.305),(61.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.305),(61.535,16.475),(61.705,16.475),(61.705,16.305),(61.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.305),(61.895,16.475),(62.065,16.475),(62.065,16.305),(61.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.305),(62.255,16.475),(62.425,16.475),(62.425,16.305),(62.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.665),(61.175,16.835),(61.345,16.835),(61.345,16.665),(61.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.665),(61.535,16.835),(61.705,16.835),(61.705,16.665),(61.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.665),(61.895,16.835),(62.065,16.835),(62.065,16.665),(61.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.665),(62.255,16.835),(62.425,16.835),(62.425,16.665),(62.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.025),(61.175,17.195),(61.345,17.195),(61.345,17.025),(61.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.025),(61.535,17.195),(61.705,17.195),(61.705,17.025),(61.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.025),(61.895,17.195),(62.065,17.195),(62.065,17.025),(61.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.025),(62.255,17.195),(62.425,17.195),(62.425,17.025),(62.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.385),(61.175,17.555),(61.345,17.555),(61.345,17.385),(61.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.385),(61.535,17.555),(61.705,17.555),(61.705,17.385),(61.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.385),(61.895,17.555),(62.065,17.555),(62.065,17.385),(61.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.385),(62.255,17.555),(62.425,17.555),(62.425,17.385),(62.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.745),(61.175,17.915),(61.345,17.915),(61.345,17.745),(61.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.745),(61.535,17.915),(61.705,17.915),(61.705,17.745),(61.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.745),(61.895,17.915),(62.065,17.915),(62.065,17.745),(61.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.745),(62.255,17.915),(62.425,17.915),(62.425,17.745),(62.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.105),(61.175,18.275),(61.345,18.275),(61.345,18.105),(61.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.105),(61.535,18.275),(61.705,18.275),(61.705,18.105),(61.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.105),(61.895,18.275),(62.065,18.275),(62.065,18.105),(61.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.105),(62.255,18.275),(62.425,18.275),(62.425,18.105),(62.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.465),(61.175,18.635),(61.345,18.635),(61.345,18.465),(61.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.465),(61.535,18.635),(61.705,18.635),(61.705,18.465),(61.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.465),(61.895,18.635),(62.065,18.635),(62.065,18.465),(61.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.465),(62.255,18.635),(62.425,18.635),(62.425,18.465),(62.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.825),(61.175,18.995),(61.345,18.995),(61.345,18.825),(61.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.825),(61.535,18.995),(61.705,18.995),(61.705,18.825),(61.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.825),(61.895,18.995),(62.065,18.995),(62.065,18.825),(61.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.825),(62.255,18.995),(62.425,18.995),(62.425,18.825),(62.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.185),(61.175,19.355),(61.345,19.355),(61.345,19.185),(61.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.185),(61.535,19.355),(61.705,19.355),(61.705,19.185),(61.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.185),(61.895,19.355),(62.065,19.355),(62.065,19.185),(61.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.185),(62.255,19.355),(62.425,19.355),(62.425,19.185),(62.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.985),(51.575,3.155),(51.745,3.155),(51.745,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.985),(51.935,3.155),(52.105,3.155),(52.105,2.985),(51.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.985),(52.295,3.155),(52.465,3.155),(52.465,2.985),(52.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.985),(52.655,3.155),(52.825,3.155),(52.825,2.985),(52.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.345),(51.575,3.515),(51.745,3.515),(51.745,3.345),(51.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.345),(51.935,3.515),(52.105,3.515),(52.105,3.345),(51.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.345),(52.295,3.515),(52.465,3.515),(52.465,3.345),(52.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.345),(52.655,3.515),(52.825,3.515),(52.825,3.345),(52.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.705),(51.575,3.875),(51.745,3.875),(51.745,3.705),(51.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.705),(51.935,3.875),(52.105,3.875),(52.105,3.705),(51.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.705),(52.295,3.875),(52.465,3.875),(52.465,3.705),(52.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.705),(52.655,3.875),(52.825,3.875),(52.825,3.705),(52.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.065),(51.575,4.235),(51.745,4.235),(51.745,4.065),(51.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.065),(51.935,4.235),(52.105,4.235),(52.105,4.065),(51.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.065),(52.295,4.235),(52.465,4.235),(52.465,4.065),(52.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.065),(52.655,4.235),(52.825,4.235),(52.825,4.065),(52.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.425),(51.575,4.595),(51.745,4.595),(51.745,4.425),(51.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.425),(51.935,4.595),(52.105,4.595),(52.105,4.425),(51.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.425),(52.295,4.595),(52.465,4.595),(52.465,4.425),(52.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.425),(52.655,4.595),(52.825,4.595),(52.825,4.425),(52.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.785),(51.575,4.955),(51.745,4.955),(51.745,4.785),(51.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.785),(51.935,4.955),(52.105,4.955),(52.105,4.785),(51.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.785),(52.295,4.955),(52.465,4.955),(52.465,4.785),(52.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.785),(52.655,4.955),(52.825,4.955),(52.825,4.785),(52.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.145),(51.575,5.315),(51.745,5.315),(51.745,5.145),(51.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.145),(51.935,5.315),(52.105,5.315),(52.105,5.145),(51.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.145),(52.295,5.315),(52.465,5.315),(52.465,5.145),(52.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.145),(52.655,5.315),(52.825,5.315),(52.825,5.145),(52.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.505),(51.575,5.675),(51.745,5.675),(51.745,5.505),(51.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.505),(51.935,5.675),(52.105,5.675),(52.105,5.505),(51.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.505),(52.295,5.675),(52.465,5.675),(52.465,5.505),(52.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.505),(52.655,5.675),(52.825,5.675),(52.825,5.505),(52.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.865),(51.575,6.035),(51.745,6.035),(51.745,5.865),(51.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.865),(51.935,6.035),(52.105,6.035),(52.105,5.865),(51.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.865),(52.295,6.035),(52.465,6.035),(52.465,5.865),(52.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.865),(52.655,6.035),(52.825,6.035),(52.825,5.865),(52.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.225),(51.575,6.395),(51.745,6.395),(51.745,6.225),(51.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.225),(51.935,6.395),(52.105,6.395),(52.105,6.225),(51.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.225),(52.295,6.395),(52.465,6.395),(52.465,6.225),(52.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.225),(52.655,6.395),(52.825,6.395),(52.825,6.225),(52.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.585),(51.575,6.755),(51.745,6.755),(51.745,6.585),(51.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.585),(51.935,6.755),(52.105,6.755),(52.105,6.585),(51.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.585),(52.295,6.755),(52.465,6.755),(52.465,6.585),(52.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.585),(52.655,6.755),(52.825,6.755),(52.825,6.585),(52.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.945),(51.575,7.115),(51.745,7.115),(51.745,6.945),(51.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.945),(51.935,7.115),(52.105,7.115),(52.105,6.945),(51.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.945),(52.295,7.115),(52.465,7.115),(52.465,6.945),(52.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.945),(52.655,7.115),(52.825,7.115),(52.825,6.945),(52.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.305),(51.575,7.475),(51.745,7.475),(51.745,7.305),(51.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.305),(51.935,7.475),(52.105,7.475),(52.105,7.305),(51.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.305),(52.295,7.475),(52.465,7.475),(52.465,7.305),(52.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.305),(52.655,7.475),(52.825,7.475),(52.825,7.305),(52.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.665),(51.575,7.835),(51.745,7.835),(51.745,7.665),(51.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.665),(51.935,7.835),(52.105,7.835),(52.105,7.665),(51.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.665),(52.295,7.835),(52.465,7.835),(52.465,7.665),(52.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.665),(52.655,7.835),(52.825,7.835),(52.825,7.665),(52.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.025),(51.575,8.195),(51.745,8.195),(51.745,8.025),(51.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.025),(51.935,8.195),(52.105,8.195),(52.105,8.025),(51.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.025),(52.295,8.195),(52.465,8.195),(52.465,8.025),(52.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.025),(52.655,8.195),(52.825,8.195),(52.825,8.025),(52.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.385),(51.575,8.555),(51.745,8.555),(51.745,8.385),(51.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.385),(51.935,8.555),(52.105,8.555),(52.105,8.385),(51.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.385),(52.295,8.555),(52.465,8.555),(52.465,8.385),(52.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.385),(52.655,8.555),(52.825,8.555),(52.825,8.385),(52.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.745),(51.575,8.915),(51.745,8.915),(51.745,8.745),(51.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.745),(51.935,8.915),(52.105,8.915),(52.105,8.745),(51.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.745),(52.295,8.915),(52.465,8.915),(52.465,8.745),(52.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.745),(52.655,8.915),(52.825,8.915),(52.825,8.745),(52.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.105),(51.575,9.275),(51.745,9.275),(51.745,9.105),(51.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.105),(51.935,9.275),(52.105,9.275),(52.105,9.105),(51.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.105),(52.295,9.275),(52.465,9.275),(52.465,9.105),(52.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.105),(52.655,9.275),(52.825,9.275),(52.825,9.105),(52.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.465),(51.575,9.635),(51.745,9.635),(51.745,9.465),(51.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.465),(51.935,9.635),(52.105,9.635),(52.105,9.465),(51.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.465),(52.295,9.635),(52.465,9.635),(52.465,9.465),(52.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.465),(52.655,9.635),(52.825,9.635),(52.825,9.465),(52.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.825),(51.575,9.995),(51.745,9.995),(51.745,9.825),(51.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.825),(51.935,9.995),(52.105,9.995),(52.105,9.825),(51.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.825),(52.295,9.995),(52.465,9.995),(52.465,9.825),(52.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.825),(52.655,9.995),(52.825,9.995),(52.825,9.825),(52.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.185),(51.575,10.355),(51.745,10.355),(51.745,10.185),(51.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.185),(51.935,10.355),(52.105,10.355),(52.105,10.185),(51.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.185),(52.295,10.355),(52.465,10.355),(52.465,10.185),(52.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.185),(52.655,10.355),(52.825,10.355),(52.825,10.185),(52.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.545),(51.575,10.715),(51.745,10.715),(51.745,10.545),(51.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.545),(51.935,10.715),(52.105,10.715),(52.105,10.545),(51.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.545),(52.295,10.715),(52.465,10.715),(52.465,10.545),(52.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.545),(52.655,10.715),(52.825,10.715),(52.825,10.545),(52.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.905),(51.575,11.075),(51.745,11.075),(51.745,10.905),(51.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.905),(51.935,11.075),(52.105,11.075),(52.105,10.905),(51.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.905),(52.295,11.075),(52.465,11.075),(52.465,10.905),(52.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.905),(52.655,11.075),(52.825,11.075),(52.825,10.905),(52.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.265),(51.575,11.435),(51.745,11.435),(51.745,11.265),(51.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.265),(51.935,11.435),(52.105,11.435),(52.105,11.265),(51.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.265),(52.295,11.435),(52.465,11.435),(52.465,11.265),(52.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.265),(52.655,11.435),(52.825,11.435),(52.825,11.265),(52.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.625),(51.575,11.795),(51.745,11.795),(51.745,11.625),(51.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.625),(51.935,11.795),(52.105,11.795),(52.105,11.625),(51.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.625),(52.295,11.795),(52.465,11.795),(52.465,11.625),(52.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.625),(52.655,11.795),(52.825,11.795),(52.825,11.625),(52.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.985),(51.575,12.155),(51.745,12.155),(51.745,11.985),(51.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.985),(51.935,12.155),(52.105,12.155),(52.105,11.985),(51.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.985),(52.295,12.155),(52.465,12.155),(52.465,11.985),(52.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.985),(52.655,12.155),(52.825,12.155),(52.825,11.985),(52.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.345),(51.575,12.515),(51.745,12.515),(51.745,12.345),(51.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.345),(51.935,12.515),(52.105,12.515),(52.105,12.345),(51.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.345),(52.295,12.515),(52.465,12.515),(52.465,12.345),(52.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.345),(52.655,12.515),(52.825,12.515),(52.825,12.345),(52.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.705),(51.575,12.875),(51.745,12.875),(51.745,12.705),(51.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.705),(51.935,12.875),(52.105,12.875),(52.105,12.705),(51.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.705),(52.295,12.875),(52.465,12.875),(52.465,12.705),(52.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.705),(52.655,12.875),(52.825,12.875),(52.825,12.705),(52.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.065),(51.575,13.235),(51.745,13.235),(51.745,13.065),(51.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.065),(51.935,13.235),(52.105,13.235),(52.105,13.065),(51.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.065),(52.295,13.235),(52.465,13.235),(52.465,13.065),(52.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.065),(52.655,13.235),(52.825,13.235),(52.825,13.065),(52.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.425),(51.575,13.595),(51.745,13.595),(51.745,13.425),(51.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.425),(51.935,13.595),(52.105,13.595),(52.105,13.425),(51.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.425),(52.295,13.595),(52.465,13.595),(52.465,13.425),(52.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.425),(52.655,13.595),(52.825,13.595),(52.825,13.425),(52.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.785),(51.575,13.955),(51.745,13.955),(51.745,13.785),(51.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.785),(51.935,13.955),(52.105,13.955),(52.105,13.785),(51.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.785),(52.295,13.955),(52.465,13.955),(52.465,13.785),(52.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.785),(52.655,13.955),(52.825,13.955),(52.825,13.785),(52.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.145),(51.575,14.315),(51.745,14.315),(51.745,14.145),(51.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.145),(51.935,14.315),(52.105,14.315),(52.105,14.145),(51.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.145),(52.295,14.315),(52.465,14.315),(52.465,14.145),(52.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.145),(52.655,14.315),(52.825,14.315),(52.825,14.145),(52.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.505),(51.575,14.675),(51.745,14.675),(51.745,14.505),(51.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.505),(51.935,14.675),(52.105,14.675),(52.105,14.505),(51.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.505),(52.295,14.675),(52.465,14.675),(52.465,14.505),(52.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.505),(52.655,14.675),(52.825,14.675),(52.825,14.505),(52.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.865),(51.575,15.035),(51.745,15.035),(51.745,14.865),(51.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.865),(51.935,15.035),(52.105,15.035),(52.105,14.865),(51.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.865),(52.295,15.035),(52.465,15.035),(52.465,14.865),(52.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.865),(52.655,15.035),(52.825,15.035),(52.825,14.865),(52.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.225),(51.575,15.395),(51.745,15.395),(51.745,15.225),(51.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.225),(51.935,15.395),(52.105,15.395),(52.105,15.225),(51.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.225),(52.295,15.395),(52.465,15.395),(52.465,15.225),(52.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.225),(52.655,15.395),(52.825,15.395),(52.825,15.225),(52.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.585),(51.575,15.755),(51.745,15.755),(51.745,15.585),(51.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.585),(51.935,15.755),(52.105,15.755),(52.105,15.585),(51.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.585),(52.295,15.755),(52.465,15.755),(52.465,15.585),(52.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.585),(52.655,15.755),(52.825,15.755),(52.825,15.585),(52.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.945),(51.575,16.115),(51.745,16.115),(51.745,15.945),(51.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.945),(51.935,16.115),(52.105,16.115),(52.105,15.945),(51.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.945),(52.295,16.115),(52.465,16.115),(52.465,15.945),(52.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.945),(52.655,16.115),(52.825,16.115),(52.825,15.945),(52.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.305),(51.575,16.475),(51.745,16.475),(51.745,16.305),(51.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.305),(51.935,16.475),(52.105,16.475),(52.105,16.305),(51.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.305),(52.295,16.475),(52.465,16.475),(52.465,16.305),(52.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.305),(52.655,16.475),(52.825,16.475),(52.825,16.305),(52.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.665),(51.575,16.835),(51.745,16.835),(51.745,16.665),(51.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.665),(51.935,16.835),(52.105,16.835),(52.105,16.665),(51.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.665),(52.295,16.835),(52.465,16.835),(52.465,16.665),(52.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.665),(52.655,16.835),(52.825,16.835),(52.825,16.665),(52.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.025),(51.575,17.195),(51.745,17.195),(51.745,17.025),(51.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.025),(51.935,17.195),(52.105,17.195),(52.105,17.025),(51.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.025),(52.295,17.195),(52.465,17.195),(52.465,17.025),(52.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.025),(52.655,17.195),(52.825,17.195),(52.825,17.025),(52.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.385),(51.575,17.555),(51.745,17.555),(51.745,17.385),(51.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.385),(51.935,17.555),(52.105,17.555),(52.105,17.385),(51.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.385),(52.295,17.555),(52.465,17.555),(52.465,17.385),(52.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.385),(52.655,17.555),(52.825,17.555),(52.825,17.385),(52.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.745),(51.575,17.915),(51.745,17.915),(51.745,17.745),(51.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.745),(51.935,17.915),(52.105,17.915),(52.105,17.745),(51.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.745),(52.295,17.915),(52.465,17.915),(52.465,17.745),(52.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.745),(52.655,17.915),(52.825,17.915),(52.825,17.745),(52.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.105),(51.575,18.275),(51.745,18.275),(51.745,18.105),(51.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.105),(51.935,18.275),(52.105,18.275),(52.105,18.105),(51.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.105),(52.295,18.275),(52.465,18.275),(52.465,18.105),(52.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.105),(52.655,18.275),(52.825,18.275),(52.825,18.105),(52.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.465),(51.575,18.635),(51.745,18.635),(51.745,18.465),(51.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.465),(51.935,18.635),(52.105,18.635),(52.105,18.465),(51.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.465),(52.295,18.635),(52.465,18.635),(52.465,18.465),(52.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.465),(52.655,18.635),(52.825,18.635),(52.825,18.465),(52.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.825),(51.575,18.995),(51.745,18.995),(51.745,18.825),(51.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.825),(51.935,18.995),(52.105,18.995),(52.105,18.825),(51.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.825),(52.295,18.995),(52.465,18.995),(52.465,18.825),(52.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.825),(52.655,18.995),(52.825,18.995),(52.825,18.825),(52.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.185),(51.575,19.355),(51.745,19.355),(51.745,19.185),(51.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.185),(51.935,19.355),(52.105,19.355),(52.105,19.185),(51.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.185),(52.295,19.355),(52.465,19.355),(52.465,19.185),(52.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.185),(52.655,19.355),(52.825,19.355),(52.825,19.185),(52.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.985),(37.175,3.155),(37.345,3.155),(37.345,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.985),(37.535,3.155),(37.705,3.155),(37.705,2.985),(37.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.985),(37.895,3.155),(38.065,3.155),(38.065,2.985),(37.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.985),(38.255,3.155),(38.425,3.155),(38.425,2.985),(38.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.345),(37.175,3.515),(37.345,3.515),(37.345,3.345),(37.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.345),(37.535,3.515),(37.705,3.515),(37.705,3.345),(37.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.345),(37.895,3.515),(38.065,3.515),(38.065,3.345),(37.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.345),(38.255,3.515),(38.425,3.515),(38.425,3.345),(38.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.705),(37.175,3.875),(37.345,3.875),(37.345,3.705),(37.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.705),(37.535,3.875),(37.705,3.875),(37.705,3.705),(37.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.705),(37.895,3.875),(38.065,3.875),(38.065,3.705),(37.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.705),(38.255,3.875),(38.425,3.875),(38.425,3.705),(38.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.065),(37.175,4.235),(37.345,4.235),(37.345,4.065),(37.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.065),(37.535,4.235),(37.705,4.235),(37.705,4.065),(37.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.065),(37.895,4.235),(38.065,4.235),(38.065,4.065),(37.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.065),(38.255,4.235),(38.425,4.235),(38.425,4.065),(38.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.425),(37.175,4.595),(37.345,4.595),(37.345,4.425),(37.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.425),(37.535,4.595),(37.705,4.595),(37.705,4.425),(37.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.425),(37.895,4.595),(38.065,4.595),(38.065,4.425),(37.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.425),(38.255,4.595),(38.425,4.595),(38.425,4.425),(38.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.785),(37.175,4.955),(37.345,4.955),(37.345,4.785),(37.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.785),(37.535,4.955),(37.705,4.955),(37.705,4.785),(37.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.785),(37.895,4.955),(38.065,4.955),(38.065,4.785),(37.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.785),(38.255,4.955),(38.425,4.955),(38.425,4.785),(38.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.145),(37.175,5.315),(37.345,5.315),(37.345,5.145),(37.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.145),(37.535,5.315),(37.705,5.315),(37.705,5.145),(37.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.145),(37.895,5.315),(38.065,5.315),(38.065,5.145),(37.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.145),(38.255,5.315),(38.425,5.315),(38.425,5.145),(38.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.505),(37.175,5.675),(37.345,5.675),(37.345,5.505),(37.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.505),(37.535,5.675),(37.705,5.675),(37.705,5.505),(37.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.505),(37.895,5.675),(38.065,5.675),(38.065,5.505),(37.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.505),(38.255,5.675),(38.425,5.675),(38.425,5.505),(38.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.865),(37.175,6.035),(37.345,6.035),(37.345,5.865),(37.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.865),(37.535,6.035),(37.705,6.035),(37.705,5.865),(37.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.865),(37.895,6.035),(38.065,6.035),(38.065,5.865),(37.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.865),(38.255,6.035),(38.425,6.035),(38.425,5.865),(38.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.225),(37.175,6.395),(37.345,6.395),(37.345,6.225),(37.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.225),(37.535,6.395),(37.705,6.395),(37.705,6.225),(37.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.225),(37.895,6.395),(38.065,6.395),(38.065,6.225),(37.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.225),(38.255,6.395),(38.425,6.395),(38.425,6.225),(38.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.585),(37.175,6.755),(37.345,6.755),(37.345,6.585),(37.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.585),(37.535,6.755),(37.705,6.755),(37.705,6.585),(37.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.585),(37.895,6.755),(38.065,6.755),(38.065,6.585),(37.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.585),(38.255,6.755),(38.425,6.755),(38.425,6.585),(38.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.945),(37.175,7.115),(37.345,7.115),(37.345,6.945),(37.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.945),(37.535,7.115),(37.705,7.115),(37.705,6.945),(37.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.945),(37.895,7.115),(38.065,7.115),(38.065,6.945),(37.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.945),(38.255,7.115),(38.425,7.115),(38.425,6.945),(38.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.305),(37.175,7.475),(37.345,7.475),(37.345,7.305),(37.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.305),(37.535,7.475),(37.705,7.475),(37.705,7.305),(37.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.305),(37.895,7.475),(38.065,7.475),(38.065,7.305),(37.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.305),(38.255,7.475),(38.425,7.475),(38.425,7.305),(38.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.665),(37.175,7.835),(37.345,7.835),(37.345,7.665),(37.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.665),(37.535,7.835),(37.705,7.835),(37.705,7.665),(37.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.665),(37.895,7.835),(38.065,7.835),(38.065,7.665),(37.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.665),(38.255,7.835),(38.425,7.835),(38.425,7.665),(38.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.025),(37.175,8.195),(37.345,8.195),(37.345,8.025),(37.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.025),(37.535,8.195),(37.705,8.195),(37.705,8.025),(37.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.025),(37.895,8.195),(38.065,8.195),(38.065,8.025),(37.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.025),(38.255,8.195),(38.425,8.195),(38.425,8.025),(38.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.385),(37.175,8.555),(37.345,8.555),(37.345,8.385),(37.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.385),(37.535,8.555),(37.705,8.555),(37.705,8.385),(37.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.385),(37.895,8.555),(38.065,8.555),(38.065,8.385),(37.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.385),(38.255,8.555),(38.425,8.555),(38.425,8.385),(38.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.745),(37.175,8.915),(37.345,8.915),(37.345,8.745),(37.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.745),(37.535,8.915),(37.705,8.915),(37.705,8.745),(37.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.745),(37.895,8.915),(38.065,8.915),(38.065,8.745),(37.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.745),(38.255,8.915),(38.425,8.915),(38.425,8.745),(38.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.105),(37.175,9.275),(37.345,9.275),(37.345,9.105),(37.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.105),(37.535,9.275),(37.705,9.275),(37.705,9.105),(37.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.105),(37.895,9.275),(38.065,9.275),(38.065,9.105),(37.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.105),(38.255,9.275),(38.425,9.275),(38.425,9.105),(38.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.465),(37.175,9.635),(37.345,9.635),(37.345,9.465),(37.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.465),(37.535,9.635),(37.705,9.635),(37.705,9.465),(37.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.465),(37.895,9.635),(38.065,9.635),(38.065,9.465),(37.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.465),(38.255,9.635),(38.425,9.635),(38.425,9.465),(38.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.825),(37.175,9.995),(37.345,9.995),(37.345,9.825),(37.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.825),(37.535,9.995),(37.705,9.995),(37.705,9.825),(37.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.825),(37.895,9.995),(38.065,9.995),(38.065,9.825),(37.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.825),(38.255,9.995),(38.425,9.995),(38.425,9.825),(38.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.185),(37.175,10.355),(37.345,10.355),(37.345,10.185),(37.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.185),(37.535,10.355),(37.705,10.355),(37.705,10.185),(37.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.185),(37.895,10.355),(38.065,10.355),(38.065,10.185),(37.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.185),(38.255,10.355),(38.425,10.355),(38.425,10.185),(38.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.545),(37.175,10.715),(37.345,10.715),(37.345,10.545),(37.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.545),(37.535,10.715),(37.705,10.715),(37.705,10.545),(37.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.545),(37.895,10.715),(38.065,10.715),(38.065,10.545),(37.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.545),(38.255,10.715),(38.425,10.715),(38.425,10.545),(38.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.905),(37.175,11.075),(37.345,11.075),(37.345,10.905),(37.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.905),(37.535,11.075),(37.705,11.075),(37.705,10.905),(37.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.905),(37.895,11.075),(38.065,11.075),(38.065,10.905),(37.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.905),(38.255,11.075),(38.425,11.075),(38.425,10.905),(38.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.265),(37.175,11.435),(37.345,11.435),(37.345,11.265),(37.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.265),(37.535,11.435),(37.705,11.435),(37.705,11.265),(37.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.265),(37.895,11.435),(38.065,11.435),(38.065,11.265),(37.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.265),(38.255,11.435),(38.425,11.435),(38.425,11.265),(38.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.625),(37.175,11.795),(37.345,11.795),(37.345,11.625),(37.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.625),(37.535,11.795),(37.705,11.795),(37.705,11.625),(37.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.625),(37.895,11.795),(38.065,11.795),(38.065,11.625),(37.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.625),(38.255,11.795),(38.425,11.795),(38.425,11.625),(38.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.985),(37.175,12.155),(37.345,12.155),(37.345,11.985),(37.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.985),(37.535,12.155),(37.705,12.155),(37.705,11.985),(37.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.985),(37.895,12.155),(38.065,12.155),(38.065,11.985),(37.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.985),(38.255,12.155),(38.425,12.155),(38.425,11.985),(38.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.345),(37.175,12.515),(37.345,12.515),(37.345,12.345),(37.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.345),(37.535,12.515),(37.705,12.515),(37.705,12.345),(37.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.345),(37.895,12.515),(38.065,12.515),(38.065,12.345),(37.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.345),(38.255,12.515),(38.425,12.515),(38.425,12.345),(38.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.705),(37.175,12.875),(37.345,12.875),(37.345,12.705),(37.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.705),(37.535,12.875),(37.705,12.875),(37.705,12.705),(37.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.705),(37.895,12.875),(38.065,12.875),(38.065,12.705),(37.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.705),(38.255,12.875),(38.425,12.875),(38.425,12.705),(38.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.065),(37.175,13.235),(37.345,13.235),(37.345,13.065),(37.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.065),(37.535,13.235),(37.705,13.235),(37.705,13.065),(37.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.065),(37.895,13.235),(38.065,13.235),(38.065,13.065),(37.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.065),(38.255,13.235),(38.425,13.235),(38.425,13.065),(38.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.425),(37.175,13.595),(37.345,13.595),(37.345,13.425),(37.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.425),(37.535,13.595),(37.705,13.595),(37.705,13.425),(37.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.425),(37.895,13.595),(38.065,13.595),(38.065,13.425),(37.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.425),(38.255,13.595),(38.425,13.595),(38.425,13.425),(38.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.785),(37.175,13.955),(37.345,13.955),(37.345,13.785),(37.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.785),(37.535,13.955),(37.705,13.955),(37.705,13.785),(37.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.785),(37.895,13.955),(38.065,13.955),(38.065,13.785),(37.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.785),(38.255,13.955),(38.425,13.955),(38.425,13.785),(38.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.145),(37.175,14.315),(37.345,14.315),(37.345,14.145),(37.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.145),(37.535,14.315),(37.705,14.315),(37.705,14.145),(37.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.145),(37.895,14.315),(38.065,14.315),(38.065,14.145),(37.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.145),(38.255,14.315),(38.425,14.315),(38.425,14.145),(38.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.505),(37.175,14.675),(37.345,14.675),(37.345,14.505),(37.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.505),(37.535,14.675),(37.705,14.675),(37.705,14.505),(37.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.505),(37.895,14.675),(38.065,14.675),(38.065,14.505),(37.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.505),(38.255,14.675),(38.425,14.675),(38.425,14.505),(38.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.865),(37.175,15.035),(37.345,15.035),(37.345,14.865),(37.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.865),(37.535,15.035),(37.705,15.035),(37.705,14.865),(37.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.865),(37.895,15.035),(38.065,15.035),(38.065,14.865),(37.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.865),(38.255,15.035),(38.425,15.035),(38.425,14.865),(38.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.225),(37.175,15.395),(37.345,15.395),(37.345,15.225),(37.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.225),(37.535,15.395),(37.705,15.395),(37.705,15.225),(37.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.225),(37.895,15.395),(38.065,15.395),(38.065,15.225),(37.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.225),(38.255,15.395),(38.425,15.395),(38.425,15.225),(38.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.585),(37.175,15.755),(37.345,15.755),(37.345,15.585),(37.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.585),(37.535,15.755),(37.705,15.755),(37.705,15.585),(37.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.585),(37.895,15.755),(38.065,15.755),(38.065,15.585),(37.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.585),(38.255,15.755),(38.425,15.755),(38.425,15.585),(38.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.945),(37.175,16.115),(37.345,16.115),(37.345,15.945),(37.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.945),(37.535,16.115),(37.705,16.115),(37.705,15.945),(37.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.945),(37.895,16.115),(38.065,16.115),(38.065,15.945),(37.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.945),(38.255,16.115),(38.425,16.115),(38.425,15.945),(38.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.305),(37.175,16.475),(37.345,16.475),(37.345,16.305),(37.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.305),(37.535,16.475),(37.705,16.475),(37.705,16.305),(37.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.305),(37.895,16.475),(38.065,16.475),(38.065,16.305),(37.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.305),(38.255,16.475),(38.425,16.475),(38.425,16.305),(38.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.665),(37.175,16.835),(37.345,16.835),(37.345,16.665),(37.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.665),(37.535,16.835),(37.705,16.835),(37.705,16.665),(37.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.665),(37.895,16.835),(38.065,16.835),(38.065,16.665),(37.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.665),(38.255,16.835),(38.425,16.835),(38.425,16.665),(38.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.025),(37.175,17.195),(37.345,17.195),(37.345,17.025),(37.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.025),(37.535,17.195),(37.705,17.195),(37.705,17.025),(37.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.025),(37.895,17.195),(38.065,17.195),(38.065,17.025),(37.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.025),(38.255,17.195),(38.425,17.195),(38.425,17.025),(38.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.385),(37.175,17.555),(37.345,17.555),(37.345,17.385),(37.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.385),(37.535,17.555),(37.705,17.555),(37.705,17.385),(37.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.385),(37.895,17.555),(38.065,17.555),(38.065,17.385),(37.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.385),(38.255,17.555),(38.425,17.555),(38.425,17.385),(38.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.745),(37.175,17.915),(37.345,17.915),(37.345,17.745),(37.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.745),(37.535,17.915),(37.705,17.915),(37.705,17.745),(37.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.745),(37.895,17.915),(38.065,17.915),(38.065,17.745),(37.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.745),(38.255,17.915),(38.425,17.915),(38.425,17.745),(38.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.105),(37.175,18.275),(37.345,18.275),(37.345,18.105),(37.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.105),(37.535,18.275),(37.705,18.275),(37.705,18.105),(37.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.105),(37.895,18.275),(38.065,18.275),(38.065,18.105),(37.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.105),(38.255,18.275),(38.425,18.275),(38.425,18.105),(38.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.465),(37.175,18.635),(37.345,18.635),(37.345,18.465),(37.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.465),(37.535,18.635),(37.705,18.635),(37.705,18.465),(37.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.465),(37.895,18.635),(38.065,18.635),(38.065,18.465),(37.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.465),(38.255,18.635),(38.425,18.635),(38.425,18.465),(38.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.825),(37.175,18.995),(37.345,18.995),(37.345,18.825),(37.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.825),(37.535,18.995),(37.705,18.995),(37.705,18.825),(37.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.825),(37.895,18.995),(38.065,18.995),(38.065,18.825),(37.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.825),(38.255,18.995),(38.425,18.995),(38.425,18.825),(38.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.185),(37.175,19.355),(37.345,19.355),(37.345,19.185),(37.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.185),(37.535,19.355),(37.705,19.355),(37.705,19.185),(37.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.185),(37.895,19.355),(38.065,19.355),(38.065,19.185),(37.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.185),(38.255,19.355),(38.425,19.355),(38.425,19.185),(38.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,2.985),(22.775,3.155),(22.945,3.155),(22.945,2.985),(22.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,2.985),(23.135,3.155),(23.305,3.155),(23.305,2.985),(23.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,2.985),(23.495,3.155),(23.665,3.155),(23.665,2.985),(23.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,2.985),(23.855,3.155),(24.025,3.155),(24.025,2.985),(23.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.345),(22.775,3.515),(22.945,3.515),(22.945,3.345),(22.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.345),(23.135,3.515),(23.305,3.515),(23.305,3.345),(23.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.345),(23.495,3.515),(23.665,3.515),(23.665,3.345),(23.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.345),(23.855,3.515),(24.025,3.515),(24.025,3.345),(23.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.705),(22.775,3.875),(22.945,3.875),(22.945,3.705),(22.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.705),(23.135,3.875),(23.305,3.875),(23.305,3.705),(23.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.705),(23.495,3.875),(23.665,3.875),(23.665,3.705),(23.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.705),(23.855,3.875),(24.025,3.875),(24.025,3.705),(23.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.065),(22.775,4.235),(22.945,4.235),(22.945,4.065),(22.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.065),(23.135,4.235),(23.305,4.235),(23.305,4.065),(23.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.065),(23.495,4.235),(23.665,4.235),(23.665,4.065),(23.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.065),(23.855,4.235),(24.025,4.235),(24.025,4.065),(23.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.425),(22.775,4.595),(22.945,4.595),(22.945,4.425),(22.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.425),(23.135,4.595),(23.305,4.595),(23.305,4.425),(23.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.425),(23.495,4.595),(23.665,4.595),(23.665,4.425),(23.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.425),(23.855,4.595),(24.025,4.595),(24.025,4.425),(23.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.785),(22.775,4.955),(22.945,4.955),(22.945,4.785),(22.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.785),(23.135,4.955),(23.305,4.955),(23.305,4.785),(23.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.785),(23.495,4.955),(23.665,4.955),(23.665,4.785),(23.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.785),(23.855,4.955),(24.025,4.955),(24.025,4.785),(23.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.145),(22.775,5.315),(22.945,5.315),(22.945,5.145),(22.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.145),(23.135,5.315),(23.305,5.315),(23.305,5.145),(23.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.145),(23.495,5.315),(23.665,5.315),(23.665,5.145),(23.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.145),(23.855,5.315),(24.025,5.315),(24.025,5.145),(23.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.505),(22.775,5.675),(22.945,5.675),(22.945,5.505),(22.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.505),(23.135,5.675),(23.305,5.675),(23.305,5.505),(23.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.505),(23.495,5.675),(23.665,5.675),(23.665,5.505),(23.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.505),(23.855,5.675),(24.025,5.675),(24.025,5.505),(23.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.865),(22.775,6.035),(22.945,6.035),(22.945,5.865),(22.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.865),(23.135,6.035),(23.305,6.035),(23.305,5.865),(23.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.865),(23.495,6.035),(23.665,6.035),(23.665,5.865),(23.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.865),(23.855,6.035),(24.025,6.035),(24.025,5.865),(23.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.225),(22.775,6.395),(22.945,6.395),(22.945,6.225),(22.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.225),(23.135,6.395),(23.305,6.395),(23.305,6.225),(23.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.225),(23.495,6.395),(23.665,6.395),(23.665,6.225),(23.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.225),(23.855,6.395),(24.025,6.395),(24.025,6.225),(23.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.585),(22.775,6.755),(22.945,6.755),(22.945,6.585),(22.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.585),(23.135,6.755),(23.305,6.755),(23.305,6.585),(23.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.585),(23.495,6.755),(23.665,6.755),(23.665,6.585),(23.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.585),(23.855,6.755),(24.025,6.755),(24.025,6.585),(23.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.945),(22.775,7.115),(22.945,7.115),(22.945,6.945),(22.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.945),(23.135,7.115),(23.305,7.115),(23.305,6.945),(23.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.945),(23.495,7.115),(23.665,7.115),(23.665,6.945),(23.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.945),(23.855,7.115),(24.025,7.115),(24.025,6.945),(23.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.305),(22.775,7.475),(22.945,7.475),(22.945,7.305),(22.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.305),(23.135,7.475),(23.305,7.475),(23.305,7.305),(23.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.305),(23.495,7.475),(23.665,7.475),(23.665,7.305),(23.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.305),(23.855,7.475),(24.025,7.475),(24.025,7.305),(23.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.665),(22.775,7.835),(22.945,7.835),(22.945,7.665),(22.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.665),(23.135,7.835),(23.305,7.835),(23.305,7.665),(23.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.665),(23.495,7.835),(23.665,7.835),(23.665,7.665),(23.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.665),(23.855,7.835),(24.025,7.835),(24.025,7.665),(23.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.025),(22.775,8.195),(22.945,8.195),(22.945,8.025),(22.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.025),(23.135,8.195),(23.305,8.195),(23.305,8.025),(23.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.025),(23.495,8.195),(23.665,8.195),(23.665,8.025),(23.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.025),(23.855,8.195),(24.025,8.195),(24.025,8.025),(23.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.385),(22.775,8.555),(22.945,8.555),(22.945,8.385),(22.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.385),(23.135,8.555),(23.305,8.555),(23.305,8.385),(23.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.385),(23.495,8.555),(23.665,8.555),(23.665,8.385),(23.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.385),(23.855,8.555),(24.025,8.555),(24.025,8.385),(23.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.745),(22.775,8.915),(22.945,8.915),(22.945,8.745),(22.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.745),(23.135,8.915),(23.305,8.915),(23.305,8.745),(23.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.745),(23.495,8.915),(23.665,8.915),(23.665,8.745),(23.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.745),(23.855,8.915),(24.025,8.915),(24.025,8.745),(23.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.105),(22.775,9.275),(22.945,9.275),(22.945,9.105),(22.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.105),(23.135,9.275),(23.305,9.275),(23.305,9.105),(23.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.105),(23.495,9.275),(23.665,9.275),(23.665,9.105),(23.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.105),(23.855,9.275),(24.025,9.275),(24.025,9.105),(23.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.465),(22.775,9.635),(22.945,9.635),(22.945,9.465),(22.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.465),(23.135,9.635),(23.305,9.635),(23.305,9.465),(23.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.465),(23.495,9.635),(23.665,9.635),(23.665,9.465),(23.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.465),(23.855,9.635),(24.025,9.635),(24.025,9.465),(23.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.825),(22.775,9.995),(22.945,9.995),(22.945,9.825),(22.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.825),(23.135,9.995),(23.305,9.995),(23.305,9.825),(23.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.825),(23.495,9.995),(23.665,9.995),(23.665,9.825),(23.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.825),(23.855,9.995),(24.025,9.995),(24.025,9.825),(23.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.185),(22.775,10.355),(22.945,10.355),(22.945,10.185),(22.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.185),(23.135,10.355),(23.305,10.355),(23.305,10.185),(23.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.185),(23.495,10.355),(23.665,10.355),(23.665,10.185),(23.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.185),(23.855,10.355),(24.025,10.355),(24.025,10.185),(23.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.545),(22.775,10.715),(22.945,10.715),(22.945,10.545),(22.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.545),(23.135,10.715),(23.305,10.715),(23.305,10.545),(23.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.545),(23.495,10.715),(23.665,10.715),(23.665,10.545),(23.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.545),(23.855,10.715),(24.025,10.715),(24.025,10.545),(23.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.905),(22.775,11.075),(22.945,11.075),(22.945,10.905),(22.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.905),(23.135,11.075),(23.305,11.075),(23.305,10.905),(23.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.905),(23.495,11.075),(23.665,11.075),(23.665,10.905),(23.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.905),(23.855,11.075),(24.025,11.075),(24.025,10.905),(23.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.265),(22.775,11.435),(22.945,11.435),(22.945,11.265),(22.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.265),(23.135,11.435),(23.305,11.435),(23.305,11.265),(23.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.265),(23.495,11.435),(23.665,11.435),(23.665,11.265),(23.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.265),(23.855,11.435),(24.025,11.435),(24.025,11.265),(23.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.625),(22.775,11.795),(22.945,11.795),(22.945,11.625),(22.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.625),(23.135,11.795),(23.305,11.795),(23.305,11.625),(23.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.625),(23.495,11.795),(23.665,11.795),(23.665,11.625),(23.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.625),(23.855,11.795),(24.025,11.795),(24.025,11.625),(23.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.985),(22.775,12.155),(22.945,12.155),(22.945,11.985),(22.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.985),(23.135,12.155),(23.305,12.155),(23.305,11.985),(23.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.985),(23.495,12.155),(23.665,12.155),(23.665,11.985),(23.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.985),(23.855,12.155),(24.025,12.155),(24.025,11.985),(23.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.345),(22.775,12.515),(22.945,12.515),(22.945,12.345),(22.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.345),(23.135,12.515),(23.305,12.515),(23.305,12.345),(23.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.345),(23.495,12.515),(23.665,12.515),(23.665,12.345),(23.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.345),(23.855,12.515),(24.025,12.515),(24.025,12.345),(23.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.705),(22.775,12.875),(22.945,12.875),(22.945,12.705),(22.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.705),(23.135,12.875),(23.305,12.875),(23.305,12.705),(23.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.705),(23.495,12.875),(23.665,12.875),(23.665,12.705),(23.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.705),(23.855,12.875),(24.025,12.875),(24.025,12.705),(23.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.065),(22.775,13.235),(22.945,13.235),(22.945,13.065),(22.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.065),(23.135,13.235),(23.305,13.235),(23.305,13.065),(23.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.065),(23.495,13.235),(23.665,13.235),(23.665,13.065),(23.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.065),(23.855,13.235),(24.025,13.235),(24.025,13.065),(23.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.425),(22.775,13.595),(22.945,13.595),(22.945,13.425),(22.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.425),(23.135,13.595),(23.305,13.595),(23.305,13.425),(23.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.425),(23.495,13.595),(23.665,13.595),(23.665,13.425),(23.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.425),(23.855,13.595),(24.025,13.595),(24.025,13.425),(23.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.785),(22.775,13.955),(22.945,13.955),(22.945,13.785),(22.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.785),(23.135,13.955),(23.305,13.955),(23.305,13.785),(23.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.785),(23.495,13.955),(23.665,13.955),(23.665,13.785),(23.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.785),(23.855,13.955),(24.025,13.955),(24.025,13.785),(23.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.145),(22.775,14.315),(22.945,14.315),(22.945,14.145),(22.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.145),(23.135,14.315),(23.305,14.315),(23.305,14.145),(23.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.145),(23.495,14.315),(23.665,14.315),(23.665,14.145),(23.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.145),(23.855,14.315),(24.025,14.315),(24.025,14.145),(23.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.505),(22.775,14.675),(22.945,14.675),(22.945,14.505),(22.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.505),(23.135,14.675),(23.305,14.675),(23.305,14.505),(23.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.505),(23.495,14.675),(23.665,14.675),(23.665,14.505),(23.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.505),(23.855,14.675),(24.025,14.675),(24.025,14.505),(23.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.865),(22.775,15.035),(22.945,15.035),(22.945,14.865),(22.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.865),(23.135,15.035),(23.305,15.035),(23.305,14.865),(23.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.865),(23.495,15.035),(23.665,15.035),(23.665,14.865),(23.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.865),(23.855,15.035),(24.025,15.035),(24.025,14.865),(23.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.225),(22.775,15.395),(22.945,15.395),(22.945,15.225),(22.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.225),(23.135,15.395),(23.305,15.395),(23.305,15.225),(23.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.225),(23.495,15.395),(23.665,15.395),(23.665,15.225),(23.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.225),(23.855,15.395),(24.025,15.395),(24.025,15.225),(23.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.585),(22.775,15.755),(22.945,15.755),(22.945,15.585),(22.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.585),(23.135,15.755),(23.305,15.755),(23.305,15.585),(23.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.585),(23.495,15.755),(23.665,15.755),(23.665,15.585),(23.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.585),(23.855,15.755),(24.025,15.755),(24.025,15.585),(23.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.945),(22.775,16.115),(22.945,16.115),(22.945,15.945),(22.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.945),(23.135,16.115),(23.305,16.115),(23.305,15.945),(23.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.945),(23.495,16.115),(23.665,16.115),(23.665,15.945),(23.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.945),(23.855,16.115),(24.025,16.115),(24.025,15.945),(23.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.305),(22.775,16.475),(22.945,16.475),(22.945,16.305),(22.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.305),(23.135,16.475),(23.305,16.475),(23.305,16.305),(23.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.305),(23.495,16.475),(23.665,16.475),(23.665,16.305),(23.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.305),(23.855,16.475),(24.025,16.475),(24.025,16.305),(23.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.665),(22.775,16.835),(22.945,16.835),(22.945,16.665),(22.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.665),(23.135,16.835),(23.305,16.835),(23.305,16.665),(23.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.665),(23.495,16.835),(23.665,16.835),(23.665,16.665),(23.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.665),(23.855,16.835),(24.025,16.835),(24.025,16.665),(23.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.025),(22.775,17.195),(22.945,17.195),(22.945,17.025),(22.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.025),(23.135,17.195),(23.305,17.195),(23.305,17.025),(23.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.025),(23.495,17.195),(23.665,17.195),(23.665,17.025),(23.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.025),(23.855,17.195),(24.025,17.195),(24.025,17.025),(23.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.385),(22.775,17.555),(22.945,17.555),(22.945,17.385),(22.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.385),(23.135,17.555),(23.305,17.555),(23.305,17.385),(23.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.385),(23.495,17.555),(23.665,17.555),(23.665,17.385),(23.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.385),(23.855,17.555),(24.025,17.555),(24.025,17.385),(23.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.745),(22.775,17.915),(22.945,17.915),(22.945,17.745),(22.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.745),(23.135,17.915),(23.305,17.915),(23.305,17.745),(23.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.745),(23.495,17.915),(23.665,17.915),(23.665,17.745),(23.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.745),(23.855,17.915),(24.025,17.915),(24.025,17.745),(23.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.105),(22.775,18.275),(22.945,18.275),(22.945,18.105),(22.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.105),(23.135,18.275),(23.305,18.275),(23.305,18.105),(23.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.105),(23.495,18.275),(23.665,18.275),(23.665,18.105),(23.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.105),(23.855,18.275),(24.025,18.275),(24.025,18.105),(23.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.465),(22.775,18.635),(22.945,18.635),(22.945,18.465),(22.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.465),(23.135,18.635),(23.305,18.635),(23.305,18.465),(23.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.465),(23.495,18.635),(23.665,18.635),(23.665,18.465),(23.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.465),(23.855,18.635),(24.025,18.635),(24.025,18.465),(23.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.825),(22.775,18.995),(22.945,18.995),(22.945,18.825),(22.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.825),(23.135,18.995),(23.305,18.995),(23.305,18.825),(23.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.825),(23.495,18.995),(23.665,18.995),(23.665,18.825),(23.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.825),(23.855,18.995),(24.025,18.995),(24.025,18.825),(23.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.185),(22.775,19.355),(22.945,19.355),(22.945,19.185),(22.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.185),(23.135,19.355),(23.305,19.355),(23.305,19.185),(23.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.185),(23.495,19.355),(23.665,19.355),(23.665,19.185),(23.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.185),(23.855,19.355),(24.025,19.355),(24.025,19.185),(23.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.985),(56.375,3.155),(56.545,3.155),(56.545,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.985),(56.735,3.155),(56.905,3.155),(56.905,2.985),(56.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.985),(57.095,3.155),(57.265,3.155),(57.265,2.985),(57.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.985),(57.455,3.155),(57.625,3.155),(57.625,2.985),(57.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.345),(56.375,3.515),(56.545,3.515),(56.545,3.345),(56.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.345),(56.735,3.515),(56.905,3.515),(56.905,3.345),(56.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.345),(57.095,3.515),(57.265,3.515),(57.265,3.345),(57.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.345),(57.455,3.515),(57.625,3.515),(57.625,3.345),(57.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.705),(56.375,3.875),(56.545,3.875),(56.545,3.705),(56.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.705),(56.735,3.875),(56.905,3.875),(56.905,3.705),(56.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.705),(57.095,3.875),(57.265,3.875),(57.265,3.705),(57.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.705),(57.455,3.875),(57.625,3.875),(57.625,3.705),(57.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.065),(56.375,4.235),(56.545,4.235),(56.545,4.065),(56.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.065),(56.735,4.235),(56.905,4.235),(56.905,4.065),(56.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.065),(57.095,4.235),(57.265,4.235),(57.265,4.065),(57.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.065),(57.455,4.235),(57.625,4.235),(57.625,4.065),(57.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.425),(56.375,4.595),(56.545,4.595),(56.545,4.425),(56.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.425),(56.735,4.595),(56.905,4.595),(56.905,4.425),(56.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.425),(57.095,4.595),(57.265,4.595),(57.265,4.425),(57.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.425),(57.455,4.595),(57.625,4.595),(57.625,4.425),(57.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.785),(56.375,4.955),(56.545,4.955),(56.545,4.785),(56.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.785),(56.735,4.955),(56.905,4.955),(56.905,4.785),(56.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.785),(57.095,4.955),(57.265,4.955),(57.265,4.785),(57.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.785),(57.455,4.955),(57.625,4.955),(57.625,4.785),(57.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.145),(56.375,5.315),(56.545,5.315),(56.545,5.145),(56.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.145),(56.735,5.315),(56.905,5.315),(56.905,5.145),(56.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.145),(57.095,5.315),(57.265,5.315),(57.265,5.145),(57.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.145),(57.455,5.315),(57.625,5.315),(57.625,5.145),(57.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.505),(56.375,5.675),(56.545,5.675),(56.545,5.505),(56.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.505),(56.735,5.675),(56.905,5.675),(56.905,5.505),(56.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.505),(57.095,5.675),(57.265,5.675),(57.265,5.505),(57.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.505),(57.455,5.675),(57.625,5.675),(57.625,5.505),(57.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.865),(56.375,6.035),(56.545,6.035),(56.545,5.865),(56.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.865),(56.735,6.035),(56.905,6.035),(56.905,5.865),(56.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.865),(57.095,6.035),(57.265,6.035),(57.265,5.865),(57.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.865),(57.455,6.035),(57.625,6.035),(57.625,5.865),(57.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.225),(56.375,6.395),(56.545,6.395),(56.545,6.225),(56.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.225),(56.735,6.395),(56.905,6.395),(56.905,6.225),(56.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.225),(57.095,6.395),(57.265,6.395),(57.265,6.225),(57.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.225),(57.455,6.395),(57.625,6.395),(57.625,6.225),(57.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.585),(56.375,6.755),(56.545,6.755),(56.545,6.585),(56.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.585),(56.735,6.755),(56.905,6.755),(56.905,6.585),(56.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.585),(57.095,6.755),(57.265,6.755),(57.265,6.585),(57.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.585),(57.455,6.755),(57.625,6.755),(57.625,6.585),(57.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.945),(56.375,7.115),(56.545,7.115),(56.545,6.945),(56.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.945),(56.735,7.115),(56.905,7.115),(56.905,6.945),(56.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.945),(57.095,7.115),(57.265,7.115),(57.265,6.945),(57.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.945),(57.455,7.115),(57.625,7.115),(57.625,6.945),(57.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.305),(56.375,7.475),(56.545,7.475),(56.545,7.305),(56.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.305),(56.735,7.475),(56.905,7.475),(56.905,7.305),(56.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.305),(57.095,7.475),(57.265,7.475),(57.265,7.305),(57.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.305),(57.455,7.475),(57.625,7.475),(57.625,7.305),(57.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.665),(56.375,7.835),(56.545,7.835),(56.545,7.665),(56.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.665),(56.735,7.835),(56.905,7.835),(56.905,7.665),(56.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.665),(57.095,7.835),(57.265,7.835),(57.265,7.665),(57.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.665),(57.455,7.835),(57.625,7.835),(57.625,7.665),(57.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.025),(56.375,8.195),(56.545,8.195),(56.545,8.025),(56.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.025),(56.735,8.195),(56.905,8.195),(56.905,8.025),(56.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.025),(57.095,8.195),(57.265,8.195),(57.265,8.025),(57.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.025),(57.455,8.195),(57.625,8.195),(57.625,8.025),(57.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.385),(56.375,8.555),(56.545,8.555),(56.545,8.385),(56.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.385),(56.735,8.555),(56.905,8.555),(56.905,8.385),(56.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.385),(57.095,8.555),(57.265,8.555),(57.265,8.385),(57.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.385),(57.455,8.555),(57.625,8.555),(57.625,8.385),(57.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.745),(56.375,8.915),(56.545,8.915),(56.545,8.745),(56.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.745),(56.735,8.915),(56.905,8.915),(56.905,8.745),(56.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.745),(57.095,8.915),(57.265,8.915),(57.265,8.745),(57.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.745),(57.455,8.915),(57.625,8.915),(57.625,8.745),(57.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.105),(56.375,9.275),(56.545,9.275),(56.545,9.105),(56.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.105),(56.735,9.275),(56.905,9.275),(56.905,9.105),(56.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.105),(57.095,9.275),(57.265,9.275),(57.265,9.105),(57.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.105),(57.455,9.275),(57.625,9.275),(57.625,9.105),(57.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.465),(56.375,9.635),(56.545,9.635),(56.545,9.465),(56.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.465),(56.735,9.635),(56.905,9.635),(56.905,9.465),(56.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.465),(57.095,9.635),(57.265,9.635),(57.265,9.465),(57.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.465),(57.455,9.635),(57.625,9.635),(57.625,9.465),(57.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.825),(56.375,9.995),(56.545,9.995),(56.545,9.825),(56.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.825),(56.735,9.995),(56.905,9.995),(56.905,9.825),(56.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.825),(57.095,9.995),(57.265,9.995),(57.265,9.825),(57.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.825),(57.455,9.995),(57.625,9.995),(57.625,9.825),(57.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.185),(56.375,10.355),(56.545,10.355),(56.545,10.185),(56.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.185),(56.735,10.355),(56.905,10.355),(56.905,10.185),(56.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.185),(57.095,10.355),(57.265,10.355),(57.265,10.185),(57.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.185),(57.455,10.355),(57.625,10.355),(57.625,10.185),(57.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.545),(56.375,10.715),(56.545,10.715),(56.545,10.545),(56.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.545),(56.735,10.715),(56.905,10.715),(56.905,10.545),(56.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.545),(57.095,10.715),(57.265,10.715),(57.265,10.545),(57.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.545),(57.455,10.715),(57.625,10.715),(57.625,10.545),(57.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.905),(56.375,11.075),(56.545,11.075),(56.545,10.905),(56.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.905),(56.735,11.075),(56.905,11.075),(56.905,10.905),(56.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.905),(57.095,11.075),(57.265,11.075),(57.265,10.905),(57.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.905),(57.455,11.075),(57.625,11.075),(57.625,10.905),(57.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.265),(56.375,11.435),(56.545,11.435),(56.545,11.265),(56.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.265),(56.735,11.435),(56.905,11.435),(56.905,11.265),(56.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.265),(57.095,11.435),(57.265,11.435),(57.265,11.265),(57.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.265),(57.455,11.435),(57.625,11.435),(57.625,11.265),(57.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.625),(56.375,11.795),(56.545,11.795),(56.545,11.625),(56.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.625),(56.735,11.795),(56.905,11.795),(56.905,11.625),(56.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.625),(57.095,11.795),(57.265,11.795),(57.265,11.625),(57.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.625),(57.455,11.795),(57.625,11.795),(57.625,11.625),(57.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.985),(56.375,12.155),(56.545,12.155),(56.545,11.985),(56.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.985),(56.735,12.155),(56.905,12.155),(56.905,11.985),(56.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.985),(57.095,12.155),(57.265,12.155),(57.265,11.985),(57.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.985),(57.455,12.155),(57.625,12.155),(57.625,11.985),(57.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.345),(56.375,12.515),(56.545,12.515),(56.545,12.345),(56.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.345),(56.735,12.515),(56.905,12.515),(56.905,12.345),(56.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.345),(57.095,12.515),(57.265,12.515),(57.265,12.345),(57.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.345),(57.455,12.515),(57.625,12.515),(57.625,12.345),(57.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.705),(56.375,12.875),(56.545,12.875),(56.545,12.705),(56.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.705),(56.735,12.875),(56.905,12.875),(56.905,12.705),(56.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.705),(57.095,12.875),(57.265,12.875),(57.265,12.705),(57.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.705),(57.455,12.875),(57.625,12.875),(57.625,12.705),(57.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.065),(56.375,13.235),(56.545,13.235),(56.545,13.065),(56.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.065),(56.735,13.235),(56.905,13.235),(56.905,13.065),(56.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.065),(57.095,13.235),(57.265,13.235),(57.265,13.065),(57.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.065),(57.455,13.235),(57.625,13.235),(57.625,13.065),(57.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.425),(56.375,13.595),(56.545,13.595),(56.545,13.425),(56.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.425),(56.735,13.595),(56.905,13.595),(56.905,13.425),(56.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.425),(57.095,13.595),(57.265,13.595),(57.265,13.425),(57.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.425),(57.455,13.595),(57.625,13.595),(57.625,13.425),(57.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.785),(56.375,13.955),(56.545,13.955),(56.545,13.785),(56.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.785),(56.735,13.955),(56.905,13.955),(56.905,13.785),(56.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.785),(57.095,13.955),(57.265,13.955),(57.265,13.785),(57.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.785),(57.455,13.955),(57.625,13.955),(57.625,13.785),(57.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.145),(56.375,14.315),(56.545,14.315),(56.545,14.145),(56.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.145),(56.735,14.315),(56.905,14.315),(56.905,14.145),(56.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.145),(57.095,14.315),(57.265,14.315),(57.265,14.145),(57.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.145),(57.455,14.315),(57.625,14.315),(57.625,14.145),(57.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.505),(56.375,14.675),(56.545,14.675),(56.545,14.505),(56.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.505),(56.735,14.675),(56.905,14.675),(56.905,14.505),(56.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.505),(57.095,14.675),(57.265,14.675),(57.265,14.505),(57.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.505),(57.455,14.675),(57.625,14.675),(57.625,14.505),(57.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.865),(56.375,15.035),(56.545,15.035),(56.545,14.865),(56.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.865),(56.735,15.035),(56.905,15.035),(56.905,14.865),(56.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.865),(57.095,15.035),(57.265,15.035),(57.265,14.865),(57.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.865),(57.455,15.035),(57.625,15.035),(57.625,14.865),(57.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.225),(56.375,15.395),(56.545,15.395),(56.545,15.225),(56.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.225),(56.735,15.395),(56.905,15.395),(56.905,15.225),(56.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.225),(57.095,15.395),(57.265,15.395),(57.265,15.225),(57.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.225),(57.455,15.395),(57.625,15.395),(57.625,15.225),(57.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.585),(56.375,15.755),(56.545,15.755),(56.545,15.585),(56.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.585),(56.735,15.755),(56.905,15.755),(56.905,15.585),(56.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.585),(57.095,15.755),(57.265,15.755),(57.265,15.585),(57.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.585),(57.455,15.755),(57.625,15.755),(57.625,15.585),(57.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.945),(56.375,16.115),(56.545,16.115),(56.545,15.945),(56.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.945),(56.735,16.115),(56.905,16.115),(56.905,15.945),(56.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.945),(57.095,16.115),(57.265,16.115),(57.265,15.945),(57.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.945),(57.455,16.115),(57.625,16.115),(57.625,15.945),(57.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.305),(56.375,16.475),(56.545,16.475),(56.545,16.305),(56.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.305),(56.735,16.475),(56.905,16.475),(56.905,16.305),(56.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.305),(57.095,16.475),(57.265,16.475),(57.265,16.305),(57.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.305),(57.455,16.475),(57.625,16.475),(57.625,16.305),(57.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.665),(56.375,16.835),(56.545,16.835),(56.545,16.665),(56.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.665),(56.735,16.835),(56.905,16.835),(56.905,16.665),(56.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.665),(57.095,16.835),(57.265,16.835),(57.265,16.665),(57.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.665),(57.455,16.835),(57.625,16.835),(57.625,16.665),(57.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.025),(56.375,17.195),(56.545,17.195),(56.545,17.025),(56.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.025),(56.735,17.195),(56.905,17.195),(56.905,17.025),(56.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.025),(57.095,17.195),(57.265,17.195),(57.265,17.025),(57.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.025),(57.455,17.195),(57.625,17.195),(57.625,17.025),(57.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.385),(56.375,17.555),(56.545,17.555),(56.545,17.385),(56.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.385),(56.735,17.555),(56.905,17.555),(56.905,17.385),(56.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.385),(57.095,17.555),(57.265,17.555),(57.265,17.385),(57.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.385),(57.455,17.555),(57.625,17.555),(57.625,17.385),(57.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.745),(56.375,17.915),(56.545,17.915),(56.545,17.745),(56.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.745),(56.735,17.915),(56.905,17.915),(56.905,17.745),(56.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.745),(57.095,17.915),(57.265,17.915),(57.265,17.745),(57.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.745),(57.455,17.915),(57.625,17.915),(57.625,17.745),(57.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.105),(56.375,18.275),(56.545,18.275),(56.545,18.105),(56.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.105),(56.735,18.275),(56.905,18.275),(56.905,18.105),(56.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.105),(57.095,18.275),(57.265,18.275),(57.265,18.105),(57.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.105),(57.455,18.275),(57.625,18.275),(57.625,18.105),(57.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.465),(56.375,18.635),(56.545,18.635),(56.545,18.465),(56.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.465),(56.735,18.635),(56.905,18.635),(56.905,18.465),(56.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.465),(57.095,18.635),(57.265,18.635),(57.265,18.465),(57.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.465),(57.455,18.635),(57.625,18.635),(57.625,18.465),(57.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.825),(56.375,18.995),(56.545,18.995),(56.545,18.825),(56.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.825),(56.735,18.995),(56.905,18.995),(56.905,18.825),(56.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.825),(57.095,18.995),(57.265,18.995),(57.265,18.825),(57.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.825),(57.455,18.995),(57.625,18.995),(57.625,18.825),(57.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.185),(56.375,19.355),(56.545,19.355),(56.545,19.185),(56.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.185),(56.735,19.355),(56.905,19.355),(56.905,19.185),(56.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.185),(57.095,19.355),(57.265,19.355),(57.265,19.185),(57.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.185),(57.455,19.355),(57.625,19.355),(57.625,19.185),(57.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,2.985),(70.775,3.155),(70.945,3.155),(70.945,2.985),(70.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,2.985),(71.135,3.155),(71.305,3.155),(71.305,2.985),(71.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,2.985),(71.495,3.155),(71.665,3.155),(71.665,2.985),(71.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,2.985),(71.855,3.155),(72.025,3.155),(72.025,2.985),(71.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.345),(70.775,3.515),(70.945,3.515),(70.945,3.345),(70.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.345),(71.135,3.515),(71.305,3.515),(71.305,3.345),(71.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.345),(71.495,3.515),(71.665,3.515),(71.665,3.345),(71.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.345),(71.855,3.515),(72.025,3.515),(72.025,3.345),(71.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.705),(70.775,3.875),(70.945,3.875),(70.945,3.705),(70.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.705),(71.135,3.875),(71.305,3.875),(71.305,3.705),(71.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.705),(71.495,3.875),(71.665,3.875),(71.665,3.705),(71.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.705),(71.855,3.875),(72.025,3.875),(72.025,3.705),(71.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.065),(70.775,4.235),(70.945,4.235),(70.945,4.065),(70.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.065),(71.135,4.235),(71.305,4.235),(71.305,4.065),(71.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.065),(71.495,4.235),(71.665,4.235),(71.665,4.065),(71.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.065),(71.855,4.235),(72.025,4.235),(72.025,4.065),(71.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.425),(70.775,4.595),(70.945,4.595),(70.945,4.425),(70.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.425),(71.135,4.595),(71.305,4.595),(71.305,4.425),(71.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.425),(71.495,4.595),(71.665,4.595),(71.665,4.425),(71.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.425),(71.855,4.595),(72.025,4.595),(72.025,4.425),(71.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.785),(70.775,4.955),(70.945,4.955),(70.945,4.785),(70.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.785),(71.135,4.955),(71.305,4.955),(71.305,4.785),(71.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.785),(71.495,4.955),(71.665,4.955),(71.665,4.785),(71.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.785),(71.855,4.955),(72.025,4.955),(72.025,4.785),(71.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.145),(70.775,5.315),(70.945,5.315),(70.945,5.145),(70.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.145),(71.135,5.315),(71.305,5.315),(71.305,5.145),(71.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.145),(71.495,5.315),(71.665,5.315),(71.665,5.145),(71.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.145),(71.855,5.315),(72.025,5.315),(72.025,5.145),(71.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.505),(70.775,5.675),(70.945,5.675),(70.945,5.505),(70.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.505),(71.135,5.675),(71.305,5.675),(71.305,5.505),(71.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.505),(71.495,5.675),(71.665,5.675),(71.665,5.505),(71.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.505),(71.855,5.675),(72.025,5.675),(72.025,5.505),(71.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.865),(70.775,6.035),(70.945,6.035),(70.945,5.865),(70.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.865),(71.135,6.035),(71.305,6.035),(71.305,5.865),(71.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.865),(71.495,6.035),(71.665,6.035),(71.665,5.865),(71.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.865),(71.855,6.035),(72.025,6.035),(72.025,5.865),(71.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.225),(70.775,6.395),(70.945,6.395),(70.945,6.225),(70.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.225),(71.135,6.395),(71.305,6.395),(71.305,6.225),(71.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.225),(71.495,6.395),(71.665,6.395),(71.665,6.225),(71.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.225),(71.855,6.395),(72.025,6.395),(72.025,6.225),(71.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.585),(70.775,6.755),(70.945,6.755),(70.945,6.585),(70.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.585),(71.135,6.755),(71.305,6.755),(71.305,6.585),(71.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.585),(71.495,6.755),(71.665,6.755),(71.665,6.585),(71.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.585),(71.855,6.755),(72.025,6.755),(72.025,6.585),(71.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.945),(70.775,7.115),(70.945,7.115),(70.945,6.945),(70.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.945),(71.135,7.115),(71.305,7.115),(71.305,6.945),(71.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.945),(71.495,7.115),(71.665,7.115),(71.665,6.945),(71.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.945),(71.855,7.115),(72.025,7.115),(72.025,6.945),(71.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.305),(70.775,7.475),(70.945,7.475),(70.945,7.305),(70.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.305),(71.135,7.475),(71.305,7.475),(71.305,7.305),(71.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.305),(71.495,7.475),(71.665,7.475),(71.665,7.305),(71.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.305),(71.855,7.475),(72.025,7.475),(72.025,7.305),(71.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.665),(70.775,7.835),(70.945,7.835),(70.945,7.665),(70.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.665),(71.135,7.835),(71.305,7.835),(71.305,7.665),(71.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.665),(71.495,7.835),(71.665,7.835),(71.665,7.665),(71.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.665),(71.855,7.835),(72.025,7.835),(72.025,7.665),(71.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.025),(70.775,8.195),(70.945,8.195),(70.945,8.025),(70.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.025),(71.135,8.195),(71.305,8.195),(71.305,8.025),(71.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.025),(71.495,8.195),(71.665,8.195),(71.665,8.025),(71.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.025),(71.855,8.195),(72.025,8.195),(72.025,8.025),(71.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.385),(70.775,8.555),(70.945,8.555),(70.945,8.385),(70.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.385),(71.135,8.555),(71.305,8.555),(71.305,8.385),(71.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.385),(71.495,8.555),(71.665,8.555),(71.665,8.385),(71.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.385),(71.855,8.555),(72.025,8.555),(72.025,8.385),(71.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.745),(70.775,8.915),(70.945,8.915),(70.945,8.745),(70.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.745),(71.135,8.915),(71.305,8.915),(71.305,8.745),(71.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.745),(71.495,8.915),(71.665,8.915),(71.665,8.745),(71.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.745),(71.855,8.915),(72.025,8.915),(72.025,8.745),(71.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.105),(70.775,9.275),(70.945,9.275),(70.945,9.105),(70.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.105),(71.135,9.275),(71.305,9.275),(71.305,9.105),(71.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.105),(71.495,9.275),(71.665,9.275),(71.665,9.105),(71.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.105),(71.855,9.275),(72.025,9.275),(72.025,9.105),(71.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.465),(70.775,9.635),(70.945,9.635),(70.945,9.465),(70.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.465),(71.135,9.635),(71.305,9.635),(71.305,9.465),(71.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.465),(71.495,9.635),(71.665,9.635),(71.665,9.465),(71.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.465),(71.855,9.635),(72.025,9.635),(72.025,9.465),(71.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.825),(70.775,9.995),(70.945,9.995),(70.945,9.825),(70.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.825),(71.135,9.995),(71.305,9.995),(71.305,9.825),(71.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.825),(71.495,9.995),(71.665,9.995),(71.665,9.825),(71.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.825),(71.855,9.995),(72.025,9.995),(72.025,9.825),(71.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.185),(70.775,10.355),(70.945,10.355),(70.945,10.185),(70.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.185),(71.135,10.355),(71.305,10.355),(71.305,10.185),(71.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.185),(71.495,10.355),(71.665,10.355),(71.665,10.185),(71.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.185),(71.855,10.355),(72.025,10.355),(72.025,10.185),(71.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.545),(70.775,10.715),(70.945,10.715),(70.945,10.545),(70.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.545),(71.135,10.715),(71.305,10.715),(71.305,10.545),(71.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.545),(71.495,10.715),(71.665,10.715),(71.665,10.545),(71.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.545),(71.855,10.715),(72.025,10.715),(72.025,10.545),(71.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.905),(70.775,11.075),(70.945,11.075),(70.945,10.905),(70.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.905),(71.135,11.075),(71.305,11.075),(71.305,10.905),(71.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.905),(71.495,11.075),(71.665,11.075),(71.665,10.905),(71.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.905),(71.855,11.075),(72.025,11.075),(72.025,10.905),(71.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.265),(70.775,11.435),(70.945,11.435),(70.945,11.265),(70.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.265),(71.135,11.435),(71.305,11.435),(71.305,11.265),(71.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.265),(71.495,11.435),(71.665,11.435),(71.665,11.265),(71.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.265),(71.855,11.435),(72.025,11.435),(72.025,11.265),(71.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.625),(70.775,11.795),(70.945,11.795),(70.945,11.625),(70.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.625),(71.135,11.795),(71.305,11.795),(71.305,11.625),(71.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.625),(71.495,11.795),(71.665,11.795),(71.665,11.625),(71.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.625),(71.855,11.795),(72.025,11.795),(72.025,11.625),(71.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.985),(70.775,12.155),(70.945,12.155),(70.945,11.985),(70.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.985),(71.135,12.155),(71.305,12.155),(71.305,11.985),(71.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.985),(71.495,12.155),(71.665,12.155),(71.665,11.985),(71.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.985),(71.855,12.155),(72.025,12.155),(72.025,11.985),(71.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.345),(70.775,12.515),(70.945,12.515),(70.945,12.345),(70.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.345),(71.135,12.515),(71.305,12.515),(71.305,12.345),(71.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.345),(71.495,12.515),(71.665,12.515),(71.665,12.345),(71.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.345),(71.855,12.515),(72.025,12.515),(72.025,12.345),(71.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.705),(70.775,12.875),(70.945,12.875),(70.945,12.705),(70.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.705),(71.135,12.875),(71.305,12.875),(71.305,12.705),(71.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.705),(71.495,12.875),(71.665,12.875),(71.665,12.705),(71.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.705),(71.855,12.875),(72.025,12.875),(72.025,12.705),(71.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.065),(70.775,13.235),(70.945,13.235),(70.945,13.065),(70.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.065),(71.135,13.235),(71.305,13.235),(71.305,13.065),(71.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.065),(71.495,13.235),(71.665,13.235),(71.665,13.065),(71.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.065),(71.855,13.235),(72.025,13.235),(72.025,13.065),(71.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.425),(70.775,13.595),(70.945,13.595),(70.945,13.425),(70.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.425),(71.135,13.595),(71.305,13.595),(71.305,13.425),(71.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.425),(71.495,13.595),(71.665,13.595),(71.665,13.425),(71.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.425),(71.855,13.595),(72.025,13.595),(72.025,13.425),(71.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.785),(70.775,13.955),(70.945,13.955),(70.945,13.785),(70.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.785),(71.135,13.955),(71.305,13.955),(71.305,13.785),(71.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.785),(71.495,13.955),(71.665,13.955),(71.665,13.785),(71.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.785),(71.855,13.955),(72.025,13.955),(72.025,13.785),(71.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.145),(70.775,14.315),(70.945,14.315),(70.945,14.145),(70.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.145),(71.135,14.315),(71.305,14.315),(71.305,14.145),(71.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.145),(71.495,14.315),(71.665,14.315),(71.665,14.145),(71.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.145),(71.855,14.315),(72.025,14.315),(72.025,14.145),(71.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.505),(70.775,14.675),(70.945,14.675),(70.945,14.505),(70.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.505),(71.135,14.675),(71.305,14.675),(71.305,14.505),(71.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.505),(71.495,14.675),(71.665,14.675),(71.665,14.505),(71.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.505),(71.855,14.675),(72.025,14.675),(72.025,14.505),(71.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.865),(70.775,15.035),(70.945,15.035),(70.945,14.865),(70.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.865),(71.135,15.035),(71.305,15.035),(71.305,14.865),(71.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.865),(71.495,15.035),(71.665,15.035),(71.665,14.865),(71.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.865),(71.855,15.035),(72.025,15.035),(72.025,14.865),(71.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.225),(70.775,15.395),(70.945,15.395),(70.945,15.225),(70.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.225),(71.135,15.395),(71.305,15.395),(71.305,15.225),(71.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.225),(71.495,15.395),(71.665,15.395),(71.665,15.225),(71.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.225),(71.855,15.395),(72.025,15.395),(72.025,15.225),(71.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.585),(70.775,15.755),(70.945,15.755),(70.945,15.585),(70.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.585),(71.135,15.755),(71.305,15.755),(71.305,15.585),(71.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.585),(71.495,15.755),(71.665,15.755),(71.665,15.585),(71.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.585),(71.855,15.755),(72.025,15.755),(72.025,15.585),(71.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.945),(70.775,16.115),(70.945,16.115),(70.945,15.945),(70.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.945),(71.135,16.115),(71.305,16.115),(71.305,15.945),(71.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.945),(71.495,16.115),(71.665,16.115),(71.665,15.945),(71.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.945),(71.855,16.115),(72.025,16.115),(72.025,15.945),(71.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.305),(70.775,16.475),(70.945,16.475),(70.945,16.305),(70.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.305),(71.135,16.475),(71.305,16.475),(71.305,16.305),(71.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.305),(71.495,16.475),(71.665,16.475),(71.665,16.305),(71.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.305),(71.855,16.475),(72.025,16.475),(72.025,16.305),(71.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.665),(70.775,16.835),(70.945,16.835),(70.945,16.665),(70.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.665),(71.135,16.835),(71.305,16.835),(71.305,16.665),(71.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.665),(71.495,16.835),(71.665,16.835),(71.665,16.665),(71.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.665),(71.855,16.835),(72.025,16.835),(72.025,16.665),(71.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.025),(70.775,17.195),(70.945,17.195),(70.945,17.025),(70.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.025),(71.135,17.195),(71.305,17.195),(71.305,17.025),(71.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.025),(71.495,17.195),(71.665,17.195),(71.665,17.025),(71.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.025),(71.855,17.195),(72.025,17.195),(72.025,17.025),(71.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.385),(70.775,17.555),(70.945,17.555),(70.945,17.385),(70.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.385),(71.135,17.555),(71.305,17.555),(71.305,17.385),(71.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.385),(71.495,17.555),(71.665,17.555),(71.665,17.385),(71.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.385),(71.855,17.555),(72.025,17.555),(72.025,17.385),(71.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.745),(70.775,17.915),(70.945,17.915),(70.945,17.745),(70.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.745),(71.135,17.915),(71.305,17.915),(71.305,17.745),(71.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.745),(71.495,17.915),(71.665,17.915),(71.665,17.745),(71.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.745),(71.855,17.915),(72.025,17.915),(72.025,17.745),(71.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.105),(70.775,18.275),(70.945,18.275),(70.945,18.105),(70.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.105),(71.135,18.275),(71.305,18.275),(71.305,18.105),(71.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.105),(71.495,18.275),(71.665,18.275),(71.665,18.105),(71.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.105),(71.855,18.275),(72.025,18.275),(72.025,18.105),(71.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.465),(70.775,18.635),(70.945,18.635),(70.945,18.465),(70.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.465),(71.135,18.635),(71.305,18.635),(71.305,18.465),(71.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.465),(71.495,18.635),(71.665,18.635),(71.665,18.465),(71.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.465),(71.855,18.635),(72.025,18.635),(72.025,18.465),(71.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.825),(70.775,18.995),(70.945,18.995),(70.945,18.825),(70.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.825),(71.135,18.995),(71.305,18.995),(71.305,18.825),(71.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.825),(71.495,18.995),(71.665,18.995),(71.665,18.825),(71.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.825),(71.855,18.995),(72.025,18.995),(72.025,18.825),(71.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.185),(70.775,19.355),(70.945,19.355),(70.945,19.185),(70.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.185),(71.135,19.355),(71.305,19.355),(71.305,19.185),(71.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.185),(71.495,19.355),(71.665,19.355),(71.665,19.185),(71.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.185),(71.855,19.355),(72.025,19.355),(72.025,19.185),(71.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,2.985),(27.575,3.155),(27.745,3.155),(27.745,2.985),(27.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,2.985),(27.935,3.155),(28.105,3.155),(28.105,2.985),(27.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,2.985),(28.295,3.155),(28.465,3.155),(28.465,2.985),(28.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,2.985),(28.655,3.155),(28.825,3.155),(28.825,2.985),(28.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.345),(27.575,3.515),(27.745,3.515),(27.745,3.345),(27.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.345),(27.935,3.515),(28.105,3.515),(28.105,3.345),(27.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.345),(28.295,3.515),(28.465,3.515),(28.465,3.345),(28.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.345),(28.655,3.515),(28.825,3.515),(28.825,3.345),(28.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.705),(27.575,3.875),(27.745,3.875),(27.745,3.705),(27.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.705),(27.935,3.875),(28.105,3.875),(28.105,3.705),(27.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.705),(28.295,3.875),(28.465,3.875),(28.465,3.705),(28.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.705),(28.655,3.875),(28.825,3.875),(28.825,3.705),(28.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.065),(27.575,4.235),(27.745,4.235),(27.745,4.065),(27.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.065),(27.935,4.235),(28.105,4.235),(28.105,4.065),(27.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.065),(28.295,4.235),(28.465,4.235),(28.465,4.065),(28.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.065),(28.655,4.235),(28.825,4.235),(28.825,4.065),(28.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.425),(27.575,4.595),(27.745,4.595),(27.745,4.425),(27.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.425),(27.935,4.595),(28.105,4.595),(28.105,4.425),(27.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.425),(28.295,4.595),(28.465,4.595),(28.465,4.425),(28.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.425),(28.655,4.595),(28.825,4.595),(28.825,4.425),(28.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.785),(27.575,4.955),(27.745,4.955),(27.745,4.785),(27.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.785),(27.935,4.955),(28.105,4.955),(28.105,4.785),(27.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.785),(28.295,4.955),(28.465,4.955),(28.465,4.785),(28.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.785),(28.655,4.955),(28.825,4.955),(28.825,4.785),(28.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.145),(27.575,5.315),(27.745,5.315),(27.745,5.145),(27.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.145),(27.935,5.315),(28.105,5.315),(28.105,5.145),(27.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.145),(28.295,5.315),(28.465,5.315),(28.465,5.145),(28.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.145),(28.655,5.315),(28.825,5.315),(28.825,5.145),(28.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.505),(27.575,5.675),(27.745,5.675),(27.745,5.505),(27.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.505),(27.935,5.675),(28.105,5.675),(28.105,5.505),(27.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.505),(28.295,5.675),(28.465,5.675),(28.465,5.505),(28.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.505),(28.655,5.675),(28.825,5.675),(28.825,5.505),(28.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.865),(27.575,6.035),(27.745,6.035),(27.745,5.865),(27.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.865),(27.935,6.035),(28.105,6.035),(28.105,5.865),(27.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.865),(28.295,6.035),(28.465,6.035),(28.465,5.865),(28.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.865),(28.655,6.035),(28.825,6.035),(28.825,5.865),(28.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.225),(27.575,6.395),(27.745,6.395),(27.745,6.225),(27.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.225),(27.935,6.395),(28.105,6.395),(28.105,6.225),(27.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.225),(28.295,6.395),(28.465,6.395),(28.465,6.225),(28.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.225),(28.655,6.395),(28.825,6.395),(28.825,6.225),(28.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.585),(27.575,6.755),(27.745,6.755),(27.745,6.585),(27.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.585),(27.935,6.755),(28.105,6.755),(28.105,6.585),(27.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.585),(28.295,6.755),(28.465,6.755),(28.465,6.585),(28.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.585),(28.655,6.755),(28.825,6.755),(28.825,6.585),(28.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.945),(27.575,7.115),(27.745,7.115),(27.745,6.945),(27.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.945),(27.935,7.115),(28.105,7.115),(28.105,6.945),(27.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.945),(28.295,7.115),(28.465,7.115),(28.465,6.945),(28.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.945),(28.655,7.115),(28.825,7.115),(28.825,6.945),(28.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.305),(27.575,7.475),(27.745,7.475),(27.745,7.305),(27.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.305),(27.935,7.475),(28.105,7.475),(28.105,7.305),(27.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.305),(28.295,7.475),(28.465,7.475),(28.465,7.305),(28.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.305),(28.655,7.475),(28.825,7.475),(28.825,7.305),(28.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.665),(27.575,7.835),(27.745,7.835),(27.745,7.665),(27.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.665),(27.935,7.835),(28.105,7.835),(28.105,7.665),(27.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.665),(28.295,7.835),(28.465,7.835),(28.465,7.665),(28.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.665),(28.655,7.835),(28.825,7.835),(28.825,7.665),(28.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.025),(27.575,8.195),(27.745,8.195),(27.745,8.025),(27.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.025),(27.935,8.195),(28.105,8.195),(28.105,8.025),(27.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.025),(28.295,8.195),(28.465,8.195),(28.465,8.025),(28.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.025),(28.655,8.195),(28.825,8.195),(28.825,8.025),(28.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.385),(27.575,8.555),(27.745,8.555),(27.745,8.385),(27.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.385),(27.935,8.555),(28.105,8.555),(28.105,8.385),(27.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.385),(28.295,8.555),(28.465,8.555),(28.465,8.385),(28.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.385),(28.655,8.555),(28.825,8.555),(28.825,8.385),(28.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.745),(27.575,8.915),(27.745,8.915),(27.745,8.745),(27.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.745),(27.935,8.915),(28.105,8.915),(28.105,8.745),(27.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.745),(28.295,8.915),(28.465,8.915),(28.465,8.745),(28.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.745),(28.655,8.915),(28.825,8.915),(28.825,8.745),(28.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.105),(27.575,9.275),(27.745,9.275),(27.745,9.105),(27.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.105),(27.935,9.275),(28.105,9.275),(28.105,9.105),(27.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.105),(28.295,9.275),(28.465,9.275),(28.465,9.105),(28.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.105),(28.655,9.275),(28.825,9.275),(28.825,9.105),(28.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.465),(27.575,9.635),(27.745,9.635),(27.745,9.465),(27.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.465),(27.935,9.635),(28.105,9.635),(28.105,9.465),(27.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.465),(28.295,9.635),(28.465,9.635),(28.465,9.465),(28.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.465),(28.655,9.635),(28.825,9.635),(28.825,9.465),(28.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.825),(27.575,9.995),(27.745,9.995),(27.745,9.825),(27.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.825),(27.935,9.995),(28.105,9.995),(28.105,9.825),(27.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.825),(28.295,9.995),(28.465,9.995),(28.465,9.825),(28.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.825),(28.655,9.995),(28.825,9.995),(28.825,9.825),(28.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.185),(27.575,10.355),(27.745,10.355),(27.745,10.185),(27.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.185),(27.935,10.355),(28.105,10.355),(28.105,10.185),(27.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.185),(28.295,10.355),(28.465,10.355),(28.465,10.185),(28.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.185),(28.655,10.355),(28.825,10.355),(28.825,10.185),(28.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.545),(27.575,10.715),(27.745,10.715),(27.745,10.545),(27.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.545),(27.935,10.715),(28.105,10.715),(28.105,10.545),(27.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.545),(28.295,10.715),(28.465,10.715),(28.465,10.545),(28.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.545),(28.655,10.715),(28.825,10.715),(28.825,10.545),(28.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.905),(27.575,11.075),(27.745,11.075),(27.745,10.905),(27.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.905),(27.935,11.075),(28.105,11.075),(28.105,10.905),(27.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.905),(28.295,11.075),(28.465,11.075),(28.465,10.905),(28.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.905),(28.655,11.075),(28.825,11.075),(28.825,10.905),(28.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.265),(27.575,11.435),(27.745,11.435),(27.745,11.265),(27.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.265),(27.935,11.435),(28.105,11.435),(28.105,11.265),(27.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.265),(28.295,11.435),(28.465,11.435),(28.465,11.265),(28.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.265),(28.655,11.435),(28.825,11.435),(28.825,11.265),(28.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.625),(27.575,11.795),(27.745,11.795),(27.745,11.625),(27.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.625),(27.935,11.795),(28.105,11.795),(28.105,11.625),(27.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.625),(28.295,11.795),(28.465,11.795),(28.465,11.625),(28.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.625),(28.655,11.795),(28.825,11.795),(28.825,11.625),(28.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.985),(27.575,12.155),(27.745,12.155),(27.745,11.985),(27.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.985),(27.935,12.155),(28.105,12.155),(28.105,11.985),(27.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.985),(28.295,12.155),(28.465,12.155),(28.465,11.985),(28.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.985),(28.655,12.155),(28.825,12.155),(28.825,11.985),(28.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.345),(27.575,12.515),(27.745,12.515),(27.745,12.345),(27.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.345),(27.935,12.515),(28.105,12.515),(28.105,12.345),(27.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.345),(28.295,12.515),(28.465,12.515),(28.465,12.345),(28.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.345),(28.655,12.515),(28.825,12.515),(28.825,12.345),(28.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.705),(27.575,12.875),(27.745,12.875),(27.745,12.705),(27.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.705),(27.935,12.875),(28.105,12.875),(28.105,12.705),(27.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.705),(28.295,12.875),(28.465,12.875),(28.465,12.705),(28.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.705),(28.655,12.875),(28.825,12.875),(28.825,12.705),(28.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.065),(27.575,13.235),(27.745,13.235),(27.745,13.065),(27.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.065),(27.935,13.235),(28.105,13.235),(28.105,13.065),(27.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.065),(28.295,13.235),(28.465,13.235),(28.465,13.065),(28.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.065),(28.655,13.235),(28.825,13.235),(28.825,13.065),(28.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.425),(27.575,13.595),(27.745,13.595),(27.745,13.425),(27.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.425),(27.935,13.595),(28.105,13.595),(28.105,13.425),(27.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.425),(28.295,13.595),(28.465,13.595),(28.465,13.425),(28.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.425),(28.655,13.595),(28.825,13.595),(28.825,13.425),(28.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.785),(27.575,13.955),(27.745,13.955),(27.745,13.785),(27.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.785),(27.935,13.955),(28.105,13.955),(28.105,13.785),(27.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.785),(28.295,13.955),(28.465,13.955),(28.465,13.785),(28.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.785),(28.655,13.955),(28.825,13.955),(28.825,13.785),(28.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.145),(27.575,14.315),(27.745,14.315),(27.745,14.145),(27.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.145),(27.935,14.315),(28.105,14.315),(28.105,14.145),(27.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.145),(28.295,14.315),(28.465,14.315),(28.465,14.145),(28.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.145),(28.655,14.315),(28.825,14.315),(28.825,14.145),(28.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.505),(27.575,14.675),(27.745,14.675),(27.745,14.505),(27.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.505),(27.935,14.675),(28.105,14.675),(28.105,14.505),(27.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.505),(28.295,14.675),(28.465,14.675),(28.465,14.505),(28.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.505),(28.655,14.675),(28.825,14.675),(28.825,14.505),(28.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.865),(27.575,15.035),(27.745,15.035),(27.745,14.865),(27.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.865),(27.935,15.035),(28.105,15.035),(28.105,14.865),(27.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.865),(28.295,15.035),(28.465,15.035),(28.465,14.865),(28.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.865),(28.655,15.035),(28.825,15.035),(28.825,14.865),(28.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.225),(27.575,15.395),(27.745,15.395),(27.745,15.225),(27.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.225),(27.935,15.395),(28.105,15.395),(28.105,15.225),(27.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.225),(28.295,15.395),(28.465,15.395),(28.465,15.225),(28.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.225),(28.655,15.395),(28.825,15.395),(28.825,15.225),(28.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.585),(27.575,15.755),(27.745,15.755),(27.745,15.585),(27.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.585),(27.935,15.755),(28.105,15.755),(28.105,15.585),(27.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.585),(28.295,15.755),(28.465,15.755),(28.465,15.585),(28.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.585),(28.655,15.755),(28.825,15.755),(28.825,15.585),(28.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.945),(27.575,16.115),(27.745,16.115),(27.745,15.945),(27.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.945),(27.935,16.115),(28.105,16.115),(28.105,15.945),(27.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.945),(28.295,16.115),(28.465,16.115),(28.465,15.945),(28.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.945),(28.655,16.115),(28.825,16.115),(28.825,15.945),(28.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.305),(27.575,16.475),(27.745,16.475),(27.745,16.305),(27.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.305),(27.935,16.475),(28.105,16.475),(28.105,16.305),(27.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.305),(28.295,16.475),(28.465,16.475),(28.465,16.305),(28.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.305),(28.655,16.475),(28.825,16.475),(28.825,16.305),(28.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.665),(27.575,16.835),(27.745,16.835),(27.745,16.665),(27.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.665),(27.935,16.835),(28.105,16.835),(28.105,16.665),(27.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.665),(28.295,16.835),(28.465,16.835),(28.465,16.665),(28.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.665),(28.655,16.835),(28.825,16.835),(28.825,16.665),(28.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.025),(27.575,17.195),(27.745,17.195),(27.745,17.025),(27.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.025),(27.935,17.195),(28.105,17.195),(28.105,17.025),(27.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.025),(28.295,17.195),(28.465,17.195),(28.465,17.025),(28.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.025),(28.655,17.195),(28.825,17.195),(28.825,17.025),(28.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.385),(27.575,17.555),(27.745,17.555),(27.745,17.385),(27.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.385),(27.935,17.555),(28.105,17.555),(28.105,17.385),(27.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.385),(28.295,17.555),(28.465,17.555),(28.465,17.385),(28.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.385),(28.655,17.555),(28.825,17.555),(28.825,17.385),(28.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.745),(27.575,17.915),(27.745,17.915),(27.745,17.745),(27.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.745),(27.935,17.915),(28.105,17.915),(28.105,17.745),(27.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.745),(28.295,17.915),(28.465,17.915),(28.465,17.745),(28.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.745),(28.655,17.915),(28.825,17.915),(28.825,17.745),(28.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.105),(27.575,18.275),(27.745,18.275),(27.745,18.105),(27.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.105),(27.935,18.275),(28.105,18.275),(28.105,18.105),(27.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.105),(28.295,18.275),(28.465,18.275),(28.465,18.105),(28.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.105),(28.655,18.275),(28.825,18.275),(28.825,18.105),(28.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.465),(27.575,18.635),(27.745,18.635),(27.745,18.465),(27.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.465),(27.935,18.635),(28.105,18.635),(28.105,18.465),(27.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.465),(28.295,18.635),(28.465,18.635),(28.465,18.465),(28.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.465),(28.655,18.635),(28.825,18.635),(28.825,18.465),(28.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.825),(27.575,18.995),(27.745,18.995),(27.745,18.825),(27.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.825),(27.935,18.995),(28.105,18.995),(28.105,18.825),(27.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.825),(28.295,18.995),(28.465,18.995),(28.465,18.825),(28.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.825),(28.655,18.995),(28.825,18.995),(28.825,18.825),(28.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.185),(27.575,19.355),(27.745,19.355),(27.745,19.185),(27.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.185),(27.935,19.355),(28.105,19.355),(28.105,19.185),(27.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.185),(28.295,19.355),(28.465,19.355),(28.465,19.185),(28.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.185),(28.655,19.355),(28.825,19.355),(28.825,19.185),(28.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,2.985),(65.975,3.155),(66.145,3.155),(66.145,2.985),(65.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,2.985),(66.335,3.155),(66.505,3.155),(66.505,2.985),(66.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,2.985),(66.695,3.155),(66.865,3.155),(66.865,2.985),(66.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,2.985),(67.055,3.155),(67.225,3.155),(67.225,2.985),(67.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.345),(65.975,3.515),(66.145,3.515),(66.145,3.345),(65.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.345),(66.335,3.515),(66.505,3.515),(66.505,3.345),(66.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.345),(66.695,3.515),(66.865,3.515),(66.865,3.345),(66.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.345),(67.055,3.515),(67.225,3.515),(67.225,3.345),(67.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.705),(65.975,3.875),(66.145,3.875),(66.145,3.705),(65.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.705),(66.335,3.875),(66.505,3.875),(66.505,3.705),(66.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.705),(66.695,3.875),(66.865,3.875),(66.865,3.705),(66.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.705),(67.055,3.875),(67.225,3.875),(67.225,3.705),(67.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.065),(65.975,4.235),(66.145,4.235),(66.145,4.065),(65.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.065),(66.335,4.235),(66.505,4.235),(66.505,4.065),(66.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.065),(66.695,4.235),(66.865,4.235),(66.865,4.065),(66.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.065),(67.055,4.235),(67.225,4.235),(67.225,4.065),(67.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.425),(65.975,4.595),(66.145,4.595),(66.145,4.425),(65.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.425),(66.335,4.595),(66.505,4.595),(66.505,4.425),(66.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.425),(66.695,4.595),(66.865,4.595),(66.865,4.425),(66.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.425),(67.055,4.595),(67.225,4.595),(67.225,4.425),(67.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.785),(65.975,4.955),(66.145,4.955),(66.145,4.785),(65.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.785),(66.335,4.955),(66.505,4.955),(66.505,4.785),(66.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.785),(66.695,4.955),(66.865,4.955),(66.865,4.785),(66.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.785),(67.055,4.955),(67.225,4.955),(67.225,4.785),(67.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.145),(65.975,5.315),(66.145,5.315),(66.145,5.145),(65.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.145),(66.335,5.315),(66.505,5.315),(66.505,5.145),(66.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.145),(66.695,5.315),(66.865,5.315),(66.865,5.145),(66.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.145),(67.055,5.315),(67.225,5.315),(67.225,5.145),(67.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.505),(65.975,5.675),(66.145,5.675),(66.145,5.505),(65.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.505),(66.335,5.675),(66.505,5.675),(66.505,5.505),(66.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.505),(66.695,5.675),(66.865,5.675),(66.865,5.505),(66.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.505),(67.055,5.675),(67.225,5.675),(67.225,5.505),(67.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.865),(65.975,6.035),(66.145,6.035),(66.145,5.865),(65.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.865),(66.335,6.035),(66.505,6.035),(66.505,5.865),(66.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.865),(66.695,6.035),(66.865,6.035),(66.865,5.865),(66.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.865),(67.055,6.035),(67.225,6.035),(67.225,5.865),(67.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.225),(65.975,6.395),(66.145,6.395),(66.145,6.225),(65.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.225),(66.335,6.395),(66.505,6.395),(66.505,6.225),(66.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.225),(66.695,6.395),(66.865,6.395),(66.865,6.225),(66.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.225),(67.055,6.395),(67.225,6.395),(67.225,6.225),(67.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.585),(65.975,6.755),(66.145,6.755),(66.145,6.585),(65.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.585),(66.335,6.755),(66.505,6.755),(66.505,6.585),(66.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.585),(66.695,6.755),(66.865,6.755),(66.865,6.585),(66.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.585),(67.055,6.755),(67.225,6.755),(67.225,6.585),(67.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.945),(65.975,7.115),(66.145,7.115),(66.145,6.945),(65.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.945),(66.335,7.115),(66.505,7.115),(66.505,6.945),(66.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.945),(66.695,7.115),(66.865,7.115),(66.865,6.945),(66.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.945),(67.055,7.115),(67.225,7.115),(67.225,6.945),(67.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.305),(65.975,7.475),(66.145,7.475),(66.145,7.305),(65.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.305),(66.335,7.475),(66.505,7.475),(66.505,7.305),(66.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.305),(66.695,7.475),(66.865,7.475),(66.865,7.305),(66.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.305),(67.055,7.475),(67.225,7.475),(67.225,7.305),(67.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.665),(65.975,7.835),(66.145,7.835),(66.145,7.665),(65.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.665),(66.335,7.835),(66.505,7.835),(66.505,7.665),(66.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.665),(66.695,7.835),(66.865,7.835),(66.865,7.665),(66.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.665),(67.055,7.835),(67.225,7.835),(67.225,7.665),(67.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.025),(65.975,8.195),(66.145,8.195),(66.145,8.025),(65.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.025),(66.335,8.195),(66.505,8.195),(66.505,8.025),(66.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.025),(66.695,8.195),(66.865,8.195),(66.865,8.025),(66.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.025),(67.055,8.195),(67.225,8.195),(67.225,8.025),(67.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.385),(65.975,8.555),(66.145,8.555),(66.145,8.385),(65.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.385),(66.335,8.555),(66.505,8.555),(66.505,8.385),(66.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.385),(66.695,8.555),(66.865,8.555),(66.865,8.385),(66.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.385),(67.055,8.555),(67.225,8.555),(67.225,8.385),(67.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.745),(65.975,8.915),(66.145,8.915),(66.145,8.745),(65.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.745),(66.335,8.915),(66.505,8.915),(66.505,8.745),(66.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.745),(66.695,8.915),(66.865,8.915),(66.865,8.745),(66.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.745),(67.055,8.915),(67.225,8.915),(67.225,8.745),(67.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.105),(65.975,9.275),(66.145,9.275),(66.145,9.105),(65.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.105),(66.335,9.275),(66.505,9.275),(66.505,9.105),(66.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.105),(66.695,9.275),(66.865,9.275),(66.865,9.105),(66.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.105),(67.055,9.275),(67.225,9.275),(67.225,9.105),(67.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.465),(65.975,9.635),(66.145,9.635),(66.145,9.465),(65.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.465),(66.335,9.635),(66.505,9.635),(66.505,9.465),(66.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.465),(66.695,9.635),(66.865,9.635),(66.865,9.465),(66.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.465),(67.055,9.635),(67.225,9.635),(67.225,9.465),(67.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.825),(65.975,9.995),(66.145,9.995),(66.145,9.825),(65.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.825),(66.335,9.995),(66.505,9.995),(66.505,9.825),(66.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.825),(66.695,9.995),(66.865,9.995),(66.865,9.825),(66.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.825),(67.055,9.995),(67.225,9.995),(67.225,9.825),(67.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.185),(65.975,10.355),(66.145,10.355),(66.145,10.185),(65.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.185),(66.335,10.355),(66.505,10.355),(66.505,10.185),(66.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.185),(66.695,10.355),(66.865,10.355),(66.865,10.185),(66.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.185),(67.055,10.355),(67.225,10.355),(67.225,10.185),(67.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.545),(65.975,10.715),(66.145,10.715),(66.145,10.545),(65.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.545),(66.335,10.715),(66.505,10.715),(66.505,10.545),(66.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.545),(66.695,10.715),(66.865,10.715),(66.865,10.545),(66.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.545),(67.055,10.715),(67.225,10.715),(67.225,10.545),(67.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.905),(65.975,11.075),(66.145,11.075),(66.145,10.905),(65.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.905),(66.335,11.075),(66.505,11.075),(66.505,10.905),(66.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.905),(66.695,11.075),(66.865,11.075),(66.865,10.905),(66.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.905),(67.055,11.075),(67.225,11.075),(67.225,10.905),(67.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.265),(65.975,11.435),(66.145,11.435),(66.145,11.265),(65.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.265),(66.335,11.435),(66.505,11.435),(66.505,11.265),(66.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.265),(66.695,11.435),(66.865,11.435),(66.865,11.265),(66.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.265),(67.055,11.435),(67.225,11.435),(67.225,11.265),(67.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.625),(65.975,11.795),(66.145,11.795),(66.145,11.625),(65.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.625),(66.335,11.795),(66.505,11.795),(66.505,11.625),(66.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.625),(66.695,11.795),(66.865,11.795),(66.865,11.625),(66.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.625),(67.055,11.795),(67.225,11.795),(67.225,11.625),(67.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.985),(65.975,12.155),(66.145,12.155),(66.145,11.985),(65.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.985),(66.335,12.155),(66.505,12.155),(66.505,11.985),(66.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.985),(66.695,12.155),(66.865,12.155),(66.865,11.985),(66.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.985),(67.055,12.155),(67.225,12.155),(67.225,11.985),(67.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.345),(65.975,12.515),(66.145,12.515),(66.145,12.345),(65.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.345),(66.335,12.515),(66.505,12.515),(66.505,12.345),(66.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.345),(66.695,12.515),(66.865,12.515),(66.865,12.345),(66.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.345),(67.055,12.515),(67.225,12.515),(67.225,12.345),(67.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.705),(65.975,12.875),(66.145,12.875),(66.145,12.705),(65.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.705),(66.335,12.875),(66.505,12.875),(66.505,12.705),(66.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.705),(66.695,12.875),(66.865,12.875),(66.865,12.705),(66.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.705),(67.055,12.875),(67.225,12.875),(67.225,12.705),(67.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.065),(65.975,13.235),(66.145,13.235),(66.145,13.065),(65.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.065),(66.335,13.235),(66.505,13.235),(66.505,13.065),(66.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.065),(66.695,13.235),(66.865,13.235),(66.865,13.065),(66.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.065),(67.055,13.235),(67.225,13.235),(67.225,13.065),(67.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.425),(65.975,13.595),(66.145,13.595),(66.145,13.425),(65.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.425),(66.335,13.595),(66.505,13.595),(66.505,13.425),(66.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.425),(66.695,13.595),(66.865,13.595),(66.865,13.425),(66.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.425),(67.055,13.595),(67.225,13.595),(67.225,13.425),(67.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.785),(65.975,13.955),(66.145,13.955),(66.145,13.785),(65.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.785),(66.335,13.955),(66.505,13.955),(66.505,13.785),(66.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.785),(66.695,13.955),(66.865,13.955),(66.865,13.785),(66.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.785),(67.055,13.955),(67.225,13.955),(67.225,13.785),(67.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.145),(65.975,14.315),(66.145,14.315),(66.145,14.145),(65.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.145),(66.335,14.315),(66.505,14.315),(66.505,14.145),(66.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.145),(66.695,14.315),(66.865,14.315),(66.865,14.145),(66.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.145),(67.055,14.315),(67.225,14.315),(67.225,14.145),(67.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.505),(65.975,14.675),(66.145,14.675),(66.145,14.505),(65.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.505),(66.335,14.675),(66.505,14.675),(66.505,14.505),(66.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.505),(66.695,14.675),(66.865,14.675),(66.865,14.505),(66.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.505),(67.055,14.675),(67.225,14.675),(67.225,14.505),(67.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.865),(65.975,15.035),(66.145,15.035),(66.145,14.865),(65.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.865),(66.335,15.035),(66.505,15.035),(66.505,14.865),(66.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.865),(66.695,15.035),(66.865,15.035),(66.865,14.865),(66.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.865),(67.055,15.035),(67.225,15.035),(67.225,14.865),(67.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.225),(65.975,15.395),(66.145,15.395),(66.145,15.225),(65.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.225),(66.335,15.395),(66.505,15.395),(66.505,15.225),(66.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.225),(66.695,15.395),(66.865,15.395),(66.865,15.225),(66.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.225),(67.055,15.395),(67.225,15.395),(67.225,15.225),(67.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.585),(65.975,15.755),(66.145,15.755),(66.145,15.585),(65.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.585),(66.335,15.755),(66.505,15.755),(66.505,15.585),(66.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.585),(66.695,15.755),(66.865,15.755),(66.865,15.585),(66.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.585),(67.055,15.755),(67.225,15.755),(67.225,15.585),(67.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.945),(65.975,16.115),(66.145,16.115),(66.145,15.945),(65.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.945),(66.335,16.115),(66.505,16.115),(66.505,15.945),(66.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.945),(66.695,16.115),(66.865,16.115),(66.865,15.945),(66.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.945),(67.055,16.115),(67.225,16.115),(67.225,15.945),(67.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.305),(65.975,16.475),(66.145,16.475),(66.145,16.305),(65.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.305),(66.335,16.475),(66.505,16.475),(66.505,16.305),(66.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.305),(66.695,16.475),(66.865,16.475),(66.865,16.305),(66.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.305),(67.055,16.475),(67.225,16.475),(67.225,16.305),(67.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.665),(65.975,16.835),(66.145,16.835),(66.145,16.665),(65.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.665),(66.335,16.835),(66.505,16.835),(66.505,16.665),(66.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.665),(66.695,16.835),(66.865,16.835),(66.865,16.665),(66.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.665),(67.055,16.835),(67.225,16.835),(67.225,16.665),(67.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.025),(65.975,17.195),(66.145,17.195),(66.145,17.025),(65.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.025),(66.335,17.195),(66.505,17.195),(66.505,17.025),(66.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.025),(66.695,17.195),(66.865,17.195),(66.865,17.025),(66.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.025),(67.055,17.195),(67.225,17.195),(67.225,17.025),(67.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.385),(65.975,17.555),(66.145,17.555),(66.145,17.385),(65.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.385),(66.335,17.555),(66.505,17.555),(66.505,17.385),(66.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.385),(66.695,17.555),(66.865,17.555),(66.865,17.385),(66.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.385),(67.055,17.555),(67.225,17.555),(67.225,17.385),(67.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.745),(65.975,17.915),(66.145,17.915),(66.145,17.745),(65.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.745),(66.335,17.915),(66.505,17.915),(66.505,17.745),(66.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.745),(66.695,17.915),(66.865,17.915),(66.865,17.745),(66.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.745),(67.055,17.915),(67.225,17.915),(67.225,17.745),(67.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.105),(65.975,18.275),(66.145,18.275),(66.145,18.105),(65.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.105),(66.335,18.275),(66.505,18.275),(66.505,18.105),(66.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.105),(66.695,18.275),(66.865,18.275),(66.865,18.105),(66.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.105),(67.055,18.275),(67.225,18.275),(67.225,18.105),(67.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.465),(65.975,18.635),(66.145,18.635),(66.145,18.465),(65.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.465),(66.335,18.635),(66.505,18.635),(66.505,18.465),(66.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.465),(66.695,18.635),(66.865,18.635),(66.865,18.465),(66.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.465),(67.055,18.635),(67.225,18.635),(67.225,18.465),(67.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.825),(65.975,18.995),(66.145,18.995),(66.145,18.825),(65.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.825),(66.335,18.995),(66.505,18.995),(66.505,18.825),(66.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.825),(66.695,18.995),(66.865,18.995),(66.865,18.825),(66.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.825),(67.055,18.995),(67.225,18.995),(67.225,18.825),(67.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.185),(65.975,19.355),(66.145,19.355),(66.145,19.185),(65.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.185),(66.335,19.355),(66.505,19.355),(66.505,19.185),(66.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.185),(66.695,19.355),(66.865,19.355),(66.865,19.185),(66.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.185),(67.055,19.355),(67.225,19.355),(67.225,19.185),(67.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,2.985),(75.575,3.155),(75.745,3.155),(75.745,2.985),(75.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,2.985),(75.935,3.155),(76.105,3.155),(76.105,2.985),(75.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,2.985),(76.295,3.155),(76.465,3.155),(76.465,2.985),(76.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,2.985),(76.655,3.155),(76.825,3.155),(76.825,2.985),(76.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.345),(75.575,3.515),(75.745,3.515),(75.745,3.345),(75.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.345),(75.935,3.515),(76.105,3.515),(76.105,3.345),(75.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.345),(76.295,3.515),(76.465,3.515),(76.465,3.345),(76.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.345),(76.655,3.515),(76.825,3.515),(76.825,3.345),(76.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.705),(75.575,3.875),(75.745,3.875),(75.745,3.705),(75.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.705),(75.935,3.875),(76.105,3.875),(76.105,3.705),(75.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.705),(76.295,3.875),(76.465,3.875),(76.465,3.705),(76.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.705),(76.655,3.875),(76.825,3.875),(76.825,3.705),(76.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.065),(75.575,4.235),(75.745,4.235),(75.745,4.065),(75.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.065),(75.935,4.235),(76.105,4.235),(76.105,4.065),(75.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.065),(76.295,4.235),(76.465,4.235),(76.465,4.065),(76.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.065),(76.655,4.235),(76.825,4.235),(76.825,4.065),(76.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.425),(75.575,4.595),(75.745,4.595),(75.745,4.425),(75.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.425),(75.935,4.595),(76.105,4.595),(76.105,4.425),(75.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.425),(76.295,4.595),(76.465,4.595),(76.465,4.425),(76.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.425),(76.655,4.595),(76.825,4.595),(76.825,4.425),(76.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.785),(75.575,4.955),(75.745,4.955),(75.745,4.785),(75.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.785),(75.935,4.955),(76.105,4.955),(76.105,4.785),(75.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.785),(76.295,4.955),(76.465,4.955),(76.465,4.785),(76.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.785),(76.655,4.955),(76.825,4.955),(76.825,4.785),(76.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.145),(75.575,5.315),(75.745,5.315),(75.745,5.145),(75.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.145),(75.935,5.315),(76.105,5.315),(76.105,5.145),(75.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.145),(76.295,5.315),(76.465,5.315),(76.465,5.145),(76.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.145),(76.655,5.315),(76.825,5.315),(76.825,5.145),(76.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.505),(75.575,5.675),(75.745,5.675),(75.745,5.505),(75.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.505),(75.935,5.675),(76.105,5.675),(76.105,5.505),(75.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.505),(76.295,5.675),(76.465,5.675),(76.465,5.505),(76.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.505),(76.655,5.675),(76.825,5.675),(76.825,5.505),(76.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.865),(75.575,6.035),(75.745,6.035),(75.745,5.865),(75.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.865),(75.935,6.035),(76.105,6.035),(76.105,5.865),(75.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.865),(76.295,6.035),(76.465,6.035),(76.465,5.865),(76.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.865),(76.655,6.035),(76.825,6.035),(76.825,5.865),(76.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.225),(75.575,6.395),(75.745,6.395),(75.745,6.225),(75.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.225),(75.935,6.395),(76.105,6.395),(76.105,6.225),(75.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.225),(76.295,6.395),(76.465,6.395),(76.465,6.225),(76.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.225),(76.655,6.395),(76.825,6.395),(76.825,6.225),(76.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.585),(75.575,6.755),(75.745,6.755),(75.745,6.585),(75.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.585),(75.935,6.755),(76.105,6.755),(76.105,6.585),(75.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.585),(76.295,6.755),(76.465,6.755),(76.465,6.585),(76.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.585),(76.655,6.755),(76.825,6.755),(76.825,6.585),(76.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.945),(75.575,7.115),(75.745,7.115),(75.745,6.945),(75.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.945),(75.935,7.115),(76.105,7.115),(76.105,6.945),(75.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.945),(76.295,7.115),(76.465,7.115),(76.465,6.945),(76.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.945),(76.655,7.115),(76.825,7.115),(76.825,6.945),(76.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.305),(75.575,7.475),(75.745,7.475),(75.745,7.305),(75.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.305),(75.935,7.475),(76.105,7.475),(76.105,7.305),(75.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.305),(76.295,7.475),(76.465,7.475),(76.465,7.305),(76.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.305),(76.655,7.475),(76.825,7.475),(76.825,7.305),(76.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.665),(75.575,7.835),(75.745,7.835),(75.745,7.665),(75.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.665),(75.935,7.835),(76.105,7.835),(76.105,7.665),(75.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.665),(76.295,7.835),(76.465,7.835),(76.465,7.665),(76.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.665),(76.655,7.835),(76.825,7.835),(76.825,7.665),(76.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.025),(75.575,8.195),(75.745,8.195),(75.745,8.025),(75.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.025),(75.935,8.195),(76.105,8.195),(76.105,8.025),(75.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.025),(76.295,8.195),(76.465,8.195),(76.465,8.025),(76.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.025),(76.655,8.195),(76.825,8.195),(76.825,8.025),(76.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.385),(75.575,8.555),(75.745,8.555),(75.745,8.385),(75.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.385),(75.935,8.555),(76.105,8.555),(76.105,8.385),(75.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.385),(76.295,8.555),(76.465,8.555),(76.465,8.385),(76.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.385),(76.655,8.555),(76.825,8.555),(76.825,8.385),(76.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.745),(75.575,8.915),(75.745,8.915),(75.745,8.745),(75.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.745),(75.935,8.915),(76.105,8.915),(76.105,8.745),(75.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.745),(76.295,8.915),(76.465,8.915),(76.465,8.745),(76.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.745),(76.655,8.915),(76.825,8.915),(76.825,8.745),(76.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.105),(75.575,9.275),(75.745,9.275),(75.745,9.105),(75.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.105),(75.935,9.275),(76.105,9.275),(76.105,9.105),(75.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.105),(76.295,9.275),(76.465,9.275),(76.465,9.105),(76.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.105),(76.655,9.275),(76.825,9.275),(76.825,9.105),(76.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.465),(75.575,9.635),(75.745,9.635),(75.745,9.465),(75.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.465),(75.935,9.635),(76.105,9.635),(76.105,9.465),(75.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.465),(76.295,9.635),(76.465,9.635),(76.465,9.465),(76.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.465),(76.655,9.635),(76.825,9.635),(76.825,9.465),(76.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.825),(75.575,9.995),(75.745,9.995),(75.745,9.825),(75.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.825),(75.935,9.995),(76.105,9.995),(76.105,9.825),(75.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.825),(76.295,9.995),(76.465,9.995),(76.465,9.825),(76.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.825),(76.655,9.995),(76.825,9.995),(76.825,9.825),(76.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.185),(75.575,10.355),(75.745,10.355),(75.745,10.185),(75.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.185),(75.935,10.355),(76.105,10.355),(76.105,10.185),(75.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.185),(76.295,10.355),(76.465,10.355),(76.465,10.185),(76.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.185),(76.655,10.355),(76.825,10.355),(76.825,10.185),(76.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.545),(75.575,10.715),(75.745,10.715),(75.745,10.545),(75.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.545),(75.935,10.715),(76.105,10.715),(76.105,10.545),(75.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.545),(76.295,10.715),(76.465,10.715),(76.465,10.545),(76.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.545),(76.655,10.715),(76.825,10.715),(76.825,10.545),(76.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.905),(75.575,11.075),(75.745,11.075),(75.745,10.905),(75.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.905),(75.935,11.075),(76.105,11.075),(76.105,10.905),(75.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.905),(76.295,11.075),(76.465,11.075),(76.465,10.905),(76.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.905),(76.655,11.075),(76.825,11.075),(76.825,10.905),(76.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.265),(75.575,11.435),(75.745,11.435),(75.745,11.265),(75.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.265),(75.935,11.435),(76.105,11.435),(76.105,11.265),(75.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.265),(76.295,11.435),(76.465,11.435),(76.465,11.265),(76.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.265),(76.655,11.435),(76.825,11.435),(76.825,11.265),(76.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.625),(75.575,11.795),(75.745,11.795),(75.745,11.625),(75.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.625),(75.935,11.795),(76.105,11.795),(76.105,11.625),(75.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.625),(76.295,11.795),(76.465,11.795),(76.465,11.625),(76.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.625),(76.655,11.795),(76.825,11.795),(76.825,11.625),(76.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.985),(75.575,12.155),(75.745,12.155),(75.745,11.985),(75.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.985),(75.935,12.155),(76.105,12.155),(76.105,11.985),(75.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.985),(76.295,12.155),(76.465,12.155),(76.465,11.985),(76.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.985),(76.655,12.155),(76.825,12.155),(76.825,11.985),(76.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.345),(75.575,12.515),(75.745,12.515),(75.745,12.345),(75.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.345),(75.935,12.515),(76.105,12.515),(76.105,12.345),(75.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.345),(76.295,12.515),(76.465,12.515),(76.465,12.345),(76.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.345),(76.655,12.515),(76.825,12.515),(76.825,12.345),(76.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.705),(75.575,12.875),(75.745,12.875),(75.745,12.705),(75.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.705),(75.935,12.875),(76.105,12.875),(76.105,12.705),(75.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.705),(76.295,12.875),(76.465,12.875),(76.465,12.705),(76.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.705),(76.655,12.875),(76.825,12.875),(76.825,12.705),(76.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.065),(75.575,13.235),(75.745,13.235),(75.745,13.065),(75.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.065),(75.935,13.235),(76.105,13.235),(76.105,13.065),(75.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.065),(76.295,13.235),(76.465,13.235),(76.465,13.065),(76.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.065),(76.655,13.235),(76.825,13.235),(76.825,13.065),(76.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.425),(75.575,13.595),(75.745,13.595),(75.745,13.425),(75.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.425),(75.935,13.595),(76.105,13.595),(76.105,13.425),(75.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.425),(76.295,13.595),(76.465,13.595),(76.465,13.425),(76.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.425),(76.655,13.595),(76.825,13.595),(76.825,13.425),(76.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.785),(75.575,13.955),(75.745,13.955),(75.745,13.785),(75.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.785),(75.935,13.955),(76.105,13.955),(76.105,13.785),(75.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.785),(76.295,13.955),(76.465,13.955),(76.465,13.785),(76.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.785),(76.655,13.955),(76.825,13.955),(76.825,13.785),(76.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.145),(75.575,14.315),(75.745,14.315),(75.745,14.145),(75.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.145),(75.935,14.315),(76.105,14.315),(76.105,14.145),(75.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.145),(76.295,14.315),(76.465,14.315),(76.465,14.145),(76.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.145),(76.655,14.315),(76.825,14.315),(76.825,14.145),(76.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.505),(75.575,14.675),(75.745,14.675),(75.745,14.505),(75.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.505),(75.935,14.675),(76.105,14.675),(76.105,14.505),(75.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.505),(76.295,14.675),(76.465,14.675),(76.465,14.505),(76.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.505),(76.655,14.675),(76.825,14.675),(76.825,14.505),(76.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.865),(75.575,15.035),(75.745,15.035),(75.745,14.865),(75.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.865),(75.935,15.035),(76.105,15.035),(76.105,14.865),(75.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.865),(76.295,15.035),(76.465,15.035),(76.465,14.865),(76.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.865),(76.655,15.035),(76.825,15.035),(76.825,14.865),(76.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.225),(75.575,15.395),(75.745,15.395),(75.745,15.225),(75.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.225),(75.935,15.395),(76.105,15.395),(76.105,15.225),(75.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.225),(76.295,15.395),(76.465,15.395),(76.465,15.225),(76.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.225),(76.655,15.395),(76.825,15.395),(76.825,15.225),(76.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.585),(75.575,15.755),(75.745,15.755),(75.745,15.585),(75.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.585),(75.935,15.755),(76.105,15.755),(76.105,15.585),(75.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.585),(76.295,15.755),(76.465,15.755),(76.465,15.585),(76.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.585),(76.655,15.755),(76.825,15.755),(76.825,15.585),(76.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.945),(75.575,16.115),(75.745,16.115),(75.745,15.945),(75.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.945),(75.935,16.115),(76.105,16.115),(76.105,15.945),(75.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.945),(76.295,16.115),(76.465,16.115),(76.465,15.945),(76.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.945),(76.655,16.115),(76.825,16.115),(76.825,15.945),(76.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.305),(75.575,16.475),(75.745,16.475),(75.745,16.305),(75.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.305),(75.935,16.475),(76.105,16.475),(76.105,16.305),(75.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.305),(76.295,16.475),(76.465,16.475),(76.465,16.305),(76.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.305),(76.655,16.475),(76.825,16.475),(76.825,16.305),(76.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.665),(75.575,16.835),(75.745,16.835),(75.745,16.665),(75.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.665),(75.935,16.835),(76.105,16.835),(76.105,16.665),(75.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.665),(76.295,16.835),(76.465,16.835),(76.465,16.665),(76.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.665),(76.655,16.835),(76.825,16.835),(76.825,16.665),(76.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.025),(75.575,17.195),(75.745,17.195),(75.745,17.025),(75.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.025),(75.935,17.195),(76.105,17.195),(76.105,17.025),(75.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.025),(76.295,17.195),(76.465,17.195),(76.465,17.025),(76.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.025),(76.655,17.195),(76.825,17.195),(76.825,17.025),(76.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.385),(75.575,17.555),(75.745,17.555),(75.745,17.385),(75.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.385),(75.935,17.555),(76.105,17.555),(76.105,17.385),(75.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.385),(76.295,17.555),(76.465,17.555),(76.465,17.385),(76.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.385),(76.655,17.555),(76.825,17.555),(76.825,17.385),(76.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.745),(75.575,17.915),(75.745,17.915),(75.745,17.745),(75.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.745),(75.935,17.915),(76.105,17.915),(76.105,17.745),(75.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.745),(76.295,17.915),(76.465,17.915),(76.465,17.745),(76.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.745),(76.655,17.915),(76.825,17.915),(76.825,17.745),(76.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.105),(75.575,18.275),(75.745,18.275),(75.745,18.105),(75.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.105),(75.935,18.275),(76.105,18.275),(76.105,18.105),(75.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.105),(76.295,18.275),(76.465,18.275),(76.465,18.105),(76.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.105),(76.655,18.275),(76.825,18.275),(76.825,18.105),(76.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.465),(75.575,18.635),(75.745,18.635),(75.745,18.465),(75.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.465),(75.935,18.635),(76.105,18.635),(76.105,18.465),(75.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.465),(76.295,18.635),(76.465,18.635),(76.465,18.465),(76.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.465),(76.655,18.635),(76.825,18.635),(76.825,18.465),(76.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.825),(75.575,18.995),(75.745,18.995),(75.745,18.825),(75.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.825),(75.935,18.995),(76.105,18.995),(76.105,18.825),(75.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.825),(76.295,18.995),(76.465,18.995),(76.465,18.825),(76.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.825),(76.655,18.995),(76.825,18.995),(76.825,18.825),(76.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.185),(75.575,19.355),(75.745,19.355),(75.745,19.185),(75.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.185),(75.935,19.355),(76.105,19.355),(76.105,19.185),(75.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.185),(76.295,19.355),(76.465,19.355),(76.465,19.185),(76.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.185),(76.655,19.355),(76.825,19.355),(76.825,19.185),(76.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,2.985),(17.975,3.155),(18.145,3.155),(18.145,2.985),(17.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,2.985),(18.335,3.155),(18.505,3.155),(18.505,2.985),(18.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,2.985),(18.695,3.155),(18.865,3.155),(18.865,2.985),(18.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,2.985),(19.055,3.155),(19.225,3.155),(19.225,2.985),(19.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.345),(17.975,3.515),(18.145,3.515),(18.145,3.345),(17.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.345),(18.335,3.515),(18.505,3.515),(18.505,3.345),(18.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.345),(18.695,3.515),(18.865,3.515),(18.865,3.345),(18.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.345),(19.055,3.515),(19.225,3.515),(19.225,3.345),(19.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.705),(17.975,3.875),(18.145,3.875),(18.145,3.705),(17.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.705),(18.335,3.875),(18.505,3.875),(18.505,3.705),(18.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.705),(18.695,3.875),(18.865,3.875),(18.865,3.705),(18.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.705),(19.055,3.875),(19.225,3.875),(19.225,3.705),(19.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.065),(17.975,4.235),(18.145,4.235),(18.145,4.065),(17.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.065),(18.335,4.235),(18.505,4.235),(18.505,4.065),(18.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.065),(18.695,4.235),(18.865,4.235),(18.865,4.065),(18.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.065),(19.055,4.235),(19.225,4.235),(19.225,4.065),(19.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.425),(17.975,4.595),(18.145,4.595),(18.145,4.425),(17.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.425),(18.335,4.595),(18.505,4.595),(18.505,4.425),(18.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.425),(18.695,4.595),(18.865,4.595),(18.865,4.425),(18.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.425),(19.055,4.595),(19.225,4.595),(19.225,4.425),(19.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.785),(17.975,4.955),(18.145,4.955),(18.145,4.785),(17.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.785),(18.335,4.955),(18.505,4.955),(18.505,4.785),(18.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.785),(18.695,4.955),(18.865,4.955),(18.865,4.785),(18.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.785),(19.055,4.955),(19.225,4.955),(19.225,4.785),(19.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.145),(17.975,5.315),(18.145,5.315),(18.145,5.145),(17.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.145),(18.335,5.315),(18.505,5.315),(18.505,5.145),(18.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.145),(18.695,5.315),(18.865,5.315),(18.865,5.145),(18.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.145),(19.055,5.315),(19.225,5.315),(19.225,5.145),(19.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.505),(17.975,5.675),(18.145,5.675),(18.145,5.505),(17.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.505),(18.335,5.675),(18.505,5.675),(18.505,5.505),(18.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.505),(18.695,5.675),(18.865,5.675),(18.865,5.505),(18.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.505),(19.055,5.675),(19.225,5.675),(19.225,5.505),(19.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.865),(17.975,6.035),(18.145,6.035),(18.145,5.865),(17.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.865),(18.335,6.035),(18.505,6.035),(18.505,5.865),(18.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.865),(18.695,6.035),(18.865,6.035),(18.865,5.865),(18.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.865),(19.055,6.035),(19.225,6.035),(19.225,5.865),(19.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.225),(17.975,6.395),(18.145,6.395),(18.145,6.225),(17.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.225),(18.335,6.395),(18.505,6.395),(18.505,6.225),(18.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.225),(18.695,6.395),(18.865,6.395),(18.865,6.225),(18.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.225),(19.055,6.395),(19.225,6.395),(19.225,6.225),(19.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.585),(17.975,6.755),(18.145,6.755),(18.145,6.585),(17.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.585),(18.335,6.755),(18.505,6.755),(18.505,6.585),(18.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.585),(18.695,6.755),(18.865,6.755),(18.865,6.585),(18.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.585),(19.055,6.755),(19.225,6.755),(19.225,6.585),(19.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.945),(17.975,7.115),(18.145,7.115),(18.145,6.945),(17.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.945),(18.335,7.115),(18.505,7.115),(18.505,6.945),(18.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.945),(18.695,7.115),(18.865,7.115),(18.865,6.945),(18.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.945),(19.055,7.115),(19.225,7.115),(19.225,6.945),(19.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.305),(17.975,7.475),(18.145,7.475),(18.145,7.305),(17.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.305),(18.335,7.475),(18.505,7.475),(18.505,7.305),(18.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.305),(18.695,7.475),(18.865,7.475),(18.865,7.305),(18.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.305),(19.055,7.475),(19.225,7.475),(19.225,7.305),(19.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.665),(17.975,7.835),(18.145,7.835),(18.145,7.665),(17.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.665),(18.335,7.835),(18.505,7.835),(18.505,7.665),(18.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.665),(18.695,7.835),(18.865,7.835),(18.865,7.665),(18.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.665),(19.055,7.835),(19.225,7.835),(19.225,7.665),(19.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.025),(17.975,8.195),(18.145,8.195),(18.145,8.025),(17.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.025),(18.335,8.195),(18.505,8.195),(18.505,8.025),(18.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.025),(18.695,8.195),(18.865,8.195),(18.865,8.025),(18.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.025),(19.055,8.195),(19.225,8.195),(19.225,8.025),(19.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.385),(17.975,8.555),(18.145,8.555),(18.145,8.385),(17.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.385),(18.335,8.555),(18.505,8.555),(18.505,8.385),(18.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.385),(18.695,8.555),(18.865,8.555),(18.865,8.385),(18.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.385),(19.055,8.555),(19.225,8.555),(19.225,8.385),(19.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.745),(17.975,8.915),(18.145,8.915),(18.145,8.745),(17.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.745),(18.335,8.915),(18.505,8.915),(18.505,8.745),(18.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.745),(18.695,8.915),(18.865,8.915),(18.865,8.745),(18.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.745),(19.055,8.915),(19.225,8.915),(19.225,8.745),(19.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.105),(17.975,9.275),(18.145,9.275),(18.145,9.105),(17.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.105),(18.335,9.275),(18.505,9.275),(18.505,9.105),(18.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.105),(18.695,9.275),(18.865,9.275),(18.865,9.105),(18.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.105),(19.055,9.275),(19.225,9.275),(19.225,9.105),(19.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.465),(17.975,9.635),(18.145,9.635),(18.145,9.465),(17.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.465),(18.335,9.635),(18.505,9.635),(18.505,9.465),(18.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.465),(18.695,9.635),(18.865,9.635),(18.865,9.465),(18.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.465),(19.055,9.635),(19.225,9.635),(19.225,9.465),(19.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.825),(17.975,9.995),(18.145,9.995),(18.145,9.825),(17.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.825),(18.335,9.995),(18.505,9.995),(18.505,9.825),(18.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.825),(18.695,9.995),(18.865,9.995),(18.865,9.825),(18.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.825),(19.055,9.995),(19.225,9.995),(19.225,9.825),(19.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.185),(17.975,10.355),(18.145,10.355),(18.145,10.185),(17.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.185),(18.335,10.355),(18.505,10.355),(18.505,10.185),(18.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.185),(18.695,10.355),(18.865,10.355),(18.865,10.185),(18.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.185),(19.055,10.355),(19.225,10.355),(19.225,10.185),(19.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.545),(17.975,10.715),(18.145,10.715),(18.145,10.545),(17.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.545),(18.335,10.715),(18.505,10.715),(18.505,10.545),(18.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.545),(18.695,10.715),(18.865,10.715),(18.865,10.545),(18.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.545),(19.055,10.715),(19.225,10.715),(19.225,10.545),(19.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.905),(17.975,11.075),(18.145,11.075),(18.145,10.905),(17.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.905),(18.335,11.075),(18.505,11.075),(18.505,10.905),(18.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.905),(18.695,11.075),(18.865,11.075),(18.865,10.905),(18.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.905),(19.055,11.075),(19.225,11.075),(19.225,10.905),(19.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.265),(17.975,11.435),(18.145,11.435),(18.145,11.265),(17.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.265),(18.335,11.435),(18.505,11.435),(18.505,11.265),(18.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.265),(18.695,11.435),(18.865,11.435),(18.865,11.265),(18.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.265),(19.055,11.435),(19.225,11.435),(19.225,11.265),(19.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.625),(17.975,11.795),(18.145,11.795),(18.145,11.625),(17.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.625),(18.335,11.795),(18.505,11.795),(18.505,11.625),(18.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.625),(18.695,11.795),(18.865,11.795),(18.865,11.625),(18.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.625),(19.055,11.795),(19.225,11.795),(19.225,11.625),(19.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.985),(17.975,12.155),(18.145,12.155),(18.145,11.985),(17.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.985),(18.335,12.155),(18.505,12.155),(18.505,11.985),(18.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.985),(18.695,12.155),(18.865,12.155),(18.865,11.985),(18.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.985),(19.055,12.155),(19.225,12.155),(19.225,11.985),(19.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.345),(17.975,12.515),(18.145,12.515),(18.145,12.345),(17.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.345),(18.335,12.515),(18.505,12.515),(18.505,12.345),(18.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.345),(18.695,12.515),(18.865,12.515),(18.865,12.345),(18.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.345),(19.055,12.515),(19.225,12.515),(19.225,12.345),(19.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.705),(17.975,12.875),(18.145,12.875),(18.145,12.705),(17.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.705),(18.335,12.875),(18.505,12.875),(18.505,12.705),(18.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.705),(18.695,12.875),(18.865,12.875),(18.865,12.705),(18.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.705),(19.055,12.875),(19.225,12.875),(19.225,12.705),(19.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.065),(17.975,13.235),(18.145,13.235),(18.145,13.065),(17.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.065),(18.335,13.235),(18.505,13.235),(18.505,13.065),(18.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.065),(18.695,13.235),(18.865,13.235),(18.865,13.065),(18.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.065),(19.055,13.235),(19.225,13.235),(19.225,13.065),(19.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.425),(17.975,13.595),(18.145,13.595),(18.145,13.425),(17.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.425),(18.335,13.595),(18.505,13.595),(18.505,13.425),(18.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.425),(18.695,13.595),(18.865,13.595),(18.865,13.425),(18.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.425),(19.055,13.595),(19.225,13.595),(19.225,13.425),(19.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.785),(17.975,13.955),(18.145,13.955),(18.145,13.785),(17.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.785),(18.335,13.955),(18.505,13.955),(18.505,13.785),(18.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.785),(18.695,13.955),(18.865,13.955),(18.865,13.785),(18.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.785),(19.055,13.955),(19.225,13.955),(19.225,13.785),(19.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.145),(17.975,14.315),(18.145,14.315),(18.145,14.145),(17.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.145),(18.335,14.315),(18.505,14.315),(18.505,14.145),(18.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.145),(18.695,14.315),(18.865,14.315),(18.865,14.145),(18.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.145),(19.055,14.315),(19.225,14.315),(19.225,14.145),(19.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.505),(17.975,14.675),(18.145,14.675),(18.145,14.505),(17.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.505),(18.335,14.675),(18.505,14.675),(18.505,14.505),(18.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.505),(18.695,14.675),(18.865,14.675),(18.865,14.505),(18.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.505),(19.055,14.675),(19.225,14.675),(19.225,14.505),(19.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.865),(17.975,15.035),(18.145,15.035),(18.145,14.865),(17.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.865),(18.335,15.035),(18.505,15.035),(18.505,14.865),(18.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.865),(18.695,15.035),(18.865,15.035),(18.865,14.865),(18.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.865),(19.055,15.035),(19.225,15.035),(19.225,14.865),(19.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.225),(17.975,15.395),(18.145,15.395),(18.145,15.225),(17.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.225),(18.335,15.395),(18.505,15.395),(18.505,15.225),(18.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.225),(18.695,15.395),(18.865,15.395),(18.865,15.225),(18.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.225),(19.055,15.395),(19.225,15.395),(19.225,15.225),(19.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.585),(17.975,15.755),(18.145,15.755),(18.145,15.585),(17.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.585),(18.335,15.755),(18.505,15.755),(18.505,15.585),(18.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.585),(18.695,15.755),(18.865,15.755),(18.865,15.585),(18.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.585),(19.055,15.755),(19.225,15.755),(19.225,15.585),(19.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.945),(17.975,16.115),(18.145,16.115),(18.145,15.945),(17.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.945),(18.335,16.115),(18.505,16.115),(18.505,15.945),(18.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.945),(18.695,16.115),(18.865,16.115),(18.865,15.945),(18.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.945),(19.055,16.115),(19.225,16.115),(19.225,15.945),(19.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.305),(17.975,16.475),(18.145,16.475),(18.145,16.305),(17.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.305),(18.335,16.475),(18.505,16.475),(18.505,16.305),(18.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.305),(18.695,16.475),(18.865,16.475),(18.865,16.305),(18.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.305),(19.055,16.475),(19.225,16.475),(19.225,16.305),(19.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.665),(17.975,16.835),(18.145,16.835),(18.145,16.665),(17.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.665),(18.335,16.835),(18.505,16.835),(18.505,16.665),(18.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.665),(18.695,16.835),(18.865,16.835),(18.865,16.665),(18.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.665),(19.055,16.835),(19.225,16.835),(19.225,16.665),(19.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.025),(17.975,17.195),(18.145,17.195),(18.145,17.025),(17.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.025),(18.335,17.195),(18.505,17.195),(18.505,17.025),(18.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.025),(18.695,17.195),(18.865,17.195),(18.865,17.025),(18.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.025),(19.055,17.195),(19.225,17.195),(19.225,17.025),(19.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.385),(17.975,17.555),(18.145,17.555),(18.145,17.385),(17.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.385),(18.335,17.555),(18.505,17.555),(18.505,17.385),(18.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.385),(18.695,17.555),(18.865,17.555),(18.865,17.385),(18.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.385),(19.055,17.555),(19.225,17.555),(19.225,17.385),(19.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.745),(17.975,17.915),(18.145,17.915),(18.145,17.745),(17.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.745),(18.335,17.915),(18.505,17.915),(18.505,17.745),(18.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.745),(18.695,17.915),(18.865,17.915),(18.865,17.745),(18.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.745),(19.055,17.915),(19.225,17.915),(19.225,17.745),(19.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.105),(17.975,18.275),(18.145,18.275),(18.145,18.105),(17.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.105),(18.335,18.275),(18.505,18.275),(18.505,18.105),(18.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.105),(18.695,18.275),(18.865,18.275),(18.865,18.105),(18.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.105),(19.055,18.275),(19.225,18.275),(19.225,18.105),(19.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.465),(17.975,18.635),(18.145,18.635),(18.145,18.465),(17.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.465),(18.335,18.635),(18.505,18.635),(18.505,18.465),(18.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.465),(18.695,18.635),(18.865,18.635),(18.865,18.465),(18.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.465),(19.055,18.635),(19.225,18.635),(19.225,18.465),(19.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.825),(17.975,18.995),(18.145,18.995),(18.145,18.825),(17.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.825),(18.335,18.995),(18.505,18.995),(18.505,18.825),(18.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.825),(18.695,18.995),(18.865,18.995),(18.865,18.825),(18.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.825),(19.055,18.995),(19.225,18.995),(19.225,18.825),(19.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.185),(17.975,19.355),(18.145,19.355),(18.145,19.185),(17.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.185),(18.335,19.355),(18.505,19.355),(18.505,19.185),(18.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.185),(18.695,19.355),(18.865,19.355),(18.865,19.185),(18.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.185),(19.055,19.355),(19.225,19.355),(19.225,19.185),(19.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,2.985),(13.175,3.155),(13.345,3.155),(13.345,2.985),(13.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,2.985),(13.535,3.155),(13.705,3.155),(13.705,2.985),(13.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,2.985),(13.895,3.155),(14.065,3.155),(14.065,2.985),(13.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,2.985),(14.255,3.155),(14.425,3.155),(14.425,2.985),(14.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.345),(13.175,3.515),(13.345,3.515),(13.345,3.345),(13.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.345),(13.535,3.515),(13.705,3.515),(13.705,3.345),(13.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.345),(13.895,3.515),(14.065,3.515),(14.065,3.345),(13.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.345),(14.255,3.515),(14.425,3.515),(14.425,3.345),(14.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.705),(13.175,3.875),(13.345,3.875),(13.345,3.705),(13.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.705),(13.535,3.875),(13.705,3.875),(13.705,3.705),(13.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.705),(13.895,3.875),(14.065,3.875),(14.065,3.705),(13.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.705),(14.255,3.875),(14.425,3.875),(14.425,3.705),(14.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.065),(13.175,4.235),(13.345,4.235),(13.345,4.065),(13.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.065),(13.535,4.235),(13.705,4.235),(13.705,4.065),(13.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.065),(13.895,4.235),(14.065,4.235),(14.065,4.065),(13.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.065),(14.255,4.235),(14.425,4.235),(14.425,4.065),(14.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.425),(13.175,4.595),(13.345,4.595),(13.345,4.425),(13.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.425),(13.535,4.595),(13.705,4.595),(13.705,4.425),(13.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.425),(13.895,4.595),(14.065,4.595),(14.065,4.425),(13.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.425),(14.255,4.595),(14.425,4.595),(14.425,4.425),(14.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.785),(13.175,4.955),(13.345,4.955),(13.345,4.785),(13.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.785),(13.535,4.955),(13.705,4.955),(13.705,4.785),(13.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.785),(13.895,4.955),(14.065,4.955),(14.065,4.785),(13.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.785),(14.255,4.955),(14.425,4.955),(14.425,4.785),(14.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.145),(13.175,5.315),(13.345,5.315),(13.345,5.145),(13.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.145),(13.535,5.315),(13.705,5.315),(13.705,5.145),(13.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.145),(13.895,5.315),(14.065,5.315),(14.065,5.145),(13.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.145),(14.255,5.315),(14.425,5.315),(14.425,5.145),(14.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.505),(13.175,5.675),(13.345,5.675),(13.345,5.505),(13.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.505),(13.535,5.675),(13.705,5.675),(13.705,5.505),(13.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.505),(13.895,5.675),(14.065,5.675),(14.065,5.505),(13.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.505),(14.255,5.675),(14.425,5.675),(14.425,5.505),(14.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.865),(13.175,6.035),(13.345,6.035),(13.345,5.865),(13.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.865),(13.535,6.035),(13.705,6.035),(13.705,5.865),(13.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.865),(13.895,6.035),(14.065,6.035),(14.065,5.865),(13.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.865),(14.255,6.035),(14.425,6.035),(14.425,5.865),(14.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.225),(13.175,6.395),(13.345,6.395),(13.345,6.225),(13.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.225),(13.535,6.395),(13.705,6.395),(13.705,6.225),(13.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.225),(13.895,6.395),(14.065,6.395),(14.065,6.225),(13.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.225),(14.255,6.395),(14.425,6.395),(14.425,6.225),(14.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.585),(13.175,6.755),(13.345,6.755),(13.345,6.585),(13.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.585),(13.535,6.755),(13.705,6.755),(13.705,6.585),(13.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.585),(13.895,6.755),(14.065,6.755),(14.065,6.585),(13.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.585),(14.255,6.755),(14.425,6.755),(14.425,6.585),(14.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.945),(13.175,7.115),(13.345,7.115),(13.345,6.945),(13.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.945),(13.535,7.115),(13.705,7.115),(13.705,6.945),(13.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.945),(13.895,7.115),(14.065,7.115),(14.065,6.945),(13.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.945),(14.255,7.115),(14.425,7.115),(14.425,6.945),(14.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.305),(13.175,7.475),(13.345,7.475),(13.345,7.305),(13.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.305),(13.535,7.475),(13.705,7.475),(13.705,7.305),(13.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.305),(13.895,7.475),(14.065,7.475),(14.065,7.305),(13.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.305),(14.255,7.475),(14.425,7.475),(14.425,7.305),(14.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.665),(13.175,7.835),(13.345,7.835),(13.345,7.665),(13.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.665),(13.535,7.835),(13.705,7.835),(13.705,7.665),(13.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.665),(13.895,7.835),(14.065,7.835),(14.065,7.665),(13.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.665),(14.255,7.835),(14.425,7.835),(14.425,7.665),(14.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.025),(13.175,8.195),(13.345,8.195),(13.345,8.025),(13.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.025),(13.535,8.195),(13.705,8.195),(13.705,8.025),(13.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.025),(13.895,8.195),(14.065,8.195),(14.065,8.025),(13.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.025),(14.255,8.195),(14.425,8.195),(14.425,8.025),(14.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.385),(13.175,8.555),(13.345,8.555),(13.345,8.385),(13.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.385),(13.535,8.555),(13.705,8.555),(13.705,8.385),(13.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.385),(13.895,8.555),(14.065,8.555),(14.065,8.385),(13.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.385),(14.255,8.555),(14.425,8.555),(14.425,8.385),(14.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.745),(13.175,8.915),(13.345,8.915),(13.345,8.745),(13.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.745),(13.535,8.915),(13.705,8.915),(13.705,8.745),(13.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.745),(13.895,8.915),(14.065,8.915),(14.065,8.745),(13.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.745),(14.255,8.915),(14.425,8.915),(14.425,8.745),(14.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.105),(13.175,9.275),(13.345,9.275),(13.345,9.105),(13.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.105),(13.535,9.275),(13.705,9.275),(13.705,9.105),(13.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.105),(13.895,9.275),(14.065,9.275),(14.065,9.105),(13.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.105),(14.255,9.275),(14.425,9.275),(14.425,9.105),(14.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.465),(13.175,9.635),(13.345,9.635),(13.345,9.465),(13.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.465),(13.535,9.635),(13.705,9.635),(13.705,9.465),(13.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.465),(13.895,9.635),(14.065,9.635),(14.065,9.465),(13.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.465),(14.255,9.635),(14.425,9.635),(14.425,9.465),(14.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.825),(13.175,9.995),(13.345,9.995),(13.345,9.825),(13.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.825),(13.535,9.995),(13.705,9.995),(13.705,9.825),(13.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.825),(13.895,9.995),(14.065,9.995),(14.065,9.825),(13.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.825),(14.255,9.995),(14.425,9.995),(14.425,9.825),(14.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.185),(13.175,10.355),(13.345,10.355),(13.345,10.185),(13.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.185),(13.535,10.355),(13.705,10.355),(13.705,10.185),(13.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.185),(13.895,10.355),(14.065,10.355),(14.065,10.185),(13.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.185),(14.255,10.355),(14.425,10.355),(14.425,10.185),(14.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.545),(13.175,10.715),(13.345,10.715),(13.345,10.545),(13.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.545),(13.535,10.715),(13.705,10.715),(13.705,10.545),(13.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.545),(13.895,10.715),(14.065,10.715),(14.065,10.545),(13.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.545),(14.255,10.715),(14.425,10.715),(14.425,10.545),(14.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.905),(13.175,11.075),(13.345,11.075),(13.345,10.905),(13.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.905),(13.535,11.075),(13.705,11.075),(13.705,10.905),(13.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.905),(13.895,11.075),(14.065,11.075),(14.065,10.905),(13.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.905),(14.255,11.075),(14.425,11.075),(14.425,10.905),(14.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.265),(13.175,11.435),(13.345,11.435),(13.345,11.265),(13.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.265),(13.535,11.435),(13.705,11.435),(13.705,11.265),(13.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.265),(13.895,11.435),(14.065,11.435),(14.065,11.265),(13.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.265),(14.255,11.435),(14.425,11.435),(14.425,11.265),(14.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.625),(13.175,11.795),(13.345,11.795),(13.345,11.625),(13.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.625),(13.535,11.795),(13.705,11.795),(13.705,11.625),(13.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.625),(13.895,11.795),(14.065,11.795),(14.065,11.625),(13.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.625),(14.255,11.795),(14.425,11.795),(14.425,11.625),(14.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.985),(13.175,12.155),(13.345,12.155),(13.345,11.985),(13.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.985),(13.535,12.155),(13.705,12.155),(13.705,11.985),(13.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.985),(13.895,12.155),(14.065,12.155),(14.065,11.985),(13.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.985),(14.255,12.155),(14.425,12.155),(14.425,11.985),(14.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.345),(13.175,12.515),(13.345,12.515),(13.345,12.345),(13.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.345),(13.535,12.515),(13.705,12.515),(13.705,12.345),(13.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.345),(13.895,12.515),(14.065,12.515),(14.065,12.345),(13.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.345),(14.255,12.515),(14.425,12.515),(14.425,12.345),(14.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.705),(13.175,12.875),(13.345,12.875),(13.345,12.705),(13.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.705),(13.535,12.875),(13.705,12.875),(13.705,12.705),(13.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.705),(13.895,12.875),(14.065,12.875),(14.065,12.705),(13.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.705),(14.255,12.875),(14.425,12.875),(14.425,12.705),(14.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.065),(13.175,13.235),(13.345,13.235),(13.345,13.065),(13.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.065),(13.535,13.235),(13.705,13.235),(13.705,13.065),(13.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.065),(13.895,13.235),(14.065,13.235),(14.065,13.065),(13.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.065),(14.255,13.235),(14.425,13.235),(14.425,13.065),(14.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.425),(13.175,13.595),(13.345,13.595),(13.345,13.425),(13.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.425),(13.535,13.595),(13.705,13.595),(13.705,13.425),(13.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.425),(13.895,13.595),(14.065,13.595),(14.065,13.425),(13.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.425),(14.255,13.595),(14.425,13.595),(14.425,13.425),(14.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.785),(13.175,13.955),(13.345,13.955),(13.345,13.785),(13.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.785),(13.535,13.955),(13.705,13.955),(13.705,13.785),(13.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.785),(13.895,13.955),(14.065,13.955),(14.065,13.785),(13.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.785),(14.255,13.955),(14.425,13.955),(14.425,13.785),(14.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.145),(13.175,14.315),(13.345,14.315),(13.345,14.145),(13.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.145),(13.535,14.315),(13.705,14.315),(13.705,14.145),(13.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.145),(13.895,14.315),(14.065,14.315),(14.065,14.145),(13.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.145),(14.255,14.315),(14.425,14.315),(14.425,14.145),(14.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.505),(13.175,14.675),(13.345,14.675),(13.345,14.505),(13.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.505),(13.535,14.675),(13.705,14.675),(13.705,14.505),(13.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.505),(13.895,14.675),(14.065,14.675),(14.065,14.505),(13.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.505),(14.255,14.675),(14.425,14.675),(14.425,14.505),(14.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.865),(13.175,15.035),(13.345,15.035),(13.345,14.865),(13.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.865),(13.535,15.035),(13.705,15.035),(13.705,14.865),(13.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.865),(13.895,15.035),(14.065,15.035),(14.065,14.865),(13.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.865),(14.255,15.035),(14.425,15.035),(14.425,14.865),(14.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.225),(13.175,15.395),(13.345,15.395),(13.345,15.225),(13.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.225),(13.535,15.395),(13.705,15.395),(13.705,15.225),(13.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.225),(13.895,15.395),(14.065,15.395),(14.065,15.225),(13.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.225),(14.255,15.395),(14.425,15.395),(14.425,15.225),(14.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.585),(13.175,15.755),(13.345,15.755),(13.345,15.585),(13.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.585),(13.535,15.755),(13.705,15.755),(13.705,15.585),(13.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.585),(13.895,15.755),(14.065,15.755),(14.065,15.585),(13.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.585),(14.255,15.755),(14.425,15.755),(14.425,15.585),(14.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.945),(13.175,16.115),(13.345,16.115),(13.345,15.945),(13.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.945),(13.535,16.115),(13.705,16.115),(13.705,15.945),(13.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.945),(13.895,16.115),(14.065,16.115),(14.065,15.945),(13.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.945),(14.255,16.115),(14.425,16.115),(14.425,15.945),(14.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.305),(13.175,16.475),(13.345,16.475),(13.345,16.305),(13.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.305),(13.535,16.475),(13.705,16.475),(13.705,16.305),(13.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.305),(13.895,16.475),(14.065,16.475),(14.065,16.305),(13.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.305),(14.255,16.475),(14.425,16.475),(14.425,16.305),(14.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.665),(13.175,16.835),(13.345,16.835),(13.345,16.665),(13.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.665),(13.535,16.835),(13.705,16.835),(13.705,16.665),(13.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.665),(13.895,16.835),(14.065,16.835),(14.065,16.665),(13.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.665),(14.255,16.835),(14.425,16.835),(14.425,16.665),(14.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.025),(13.175,17.195),(13.345,17.195),(13.345,17.025),(13.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.025),(13.535,17.195),(13.705,17.195),(13.705,17.025),(13.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.025),(13.895,17.195),(14.065,17.195),(14.065,17.025),(13.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.025),(14.255,17.195),(14.425,17.195),(14.425,17.025),(14.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.385),(13.175,17.555),(13.345,17.555),(13.345,17.385),(13.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.385),(13.535,17.555),(13.705,17.555),(13.705,17.385),(13.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.385),(13.895,17.555),(14.065,17.555),(14.065,17.385),(13.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.385),(14.255,17.555),(14.425,17.555),(14.425,17.385),(14.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.745),(13.175,17.915),(13.345,17.915),(13.345,17.745),(13.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.745),(13.535,17.915),(13.705,17.915),(13.705,17.745),(13.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.745),(13.895,17.915),(14.065,17.915),(14.065,17.745),(13.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.745),(14.255,17.915),(14.425,17.915),(14.425,17.745),(14.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.105),(13.175,18.275),(13.345,18.275),(13.345,18.105),(13.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.105),(13.535,18.275),(13.705,18.275),(13.705,18.105),(13.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.105),(13.895,18.275),(14.065,18.275),(14.065,18.105),(13.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.105),(14.255,18.275),(14.425,18.275),(14.425,18.105),(14.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.465),(13.175,18.635),(13.345,18.635),(13.345,18.465),(13.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.465),(13.535,18.635),(13.705,18.635),(13.705,18.465),(13.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.465),(13.895,18.635),(14.065,18.635),(14.065,18.465),(13.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.465),(14.255,18.635),(14.425,18.635),(14.425,18.465),(14.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.825),(13.175,18.995),(13.345,18.995),(13.345,18.825),(13.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.825),(13.535,18.995),(13.705,18.995),(13.705,18.825),(13.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.825),(13.895,18.995),(14.065,18.995),(14.065,18.825),(13.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.825),(14.255,18.995),(14.425,18.995),(14.425,18.825),(14.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.185),(13.175,19.355),(13.345,19.355),(13.345,19.185),(13.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.185),(13.535,19.355),(13.705,19.355),(13.705,19.185),(13.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.185),(13.895,19.355),(14.065,19.355),(14.065,19.185),(13.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.185),(14.255,19.355),(14.425,19.355),(14.425,19.185),(14.255,19.185)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,19.415),(24.055,19.415),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,22.34),(62.455,22.34),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,22.34),(24.055,22.34),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,22.34),(28.855,22.34),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,19.415),(62.455,19.415),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,19.415),(48.055,19.415),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,19.415),(67.255,19.415),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,22.34),(48.055,22.34),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,22.34),(52.855,22.34),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,22.34),(67.255,22.34),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,19.415),(76.855,19.415),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,22.34),(57.655,22.34),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,19.415),(57.655,19.415),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,22.34),(38.455,22.34),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,19.415),(38.455,19.415),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,19.415),(43.255,19.415),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,19.415),(28.855,19.415),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,22.34),(43.255,22.34),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,22.34),(9.655,22.34),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,19.415),(9.655,19.415),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,19.415),(72.055,19.415),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,19.415),(19.255,19.415),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,22.34),(14.455,22.34),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,22.34),(72.055,22.34),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,22.34),(76.855,22.34),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,19.415),(14.455,19.415),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,22.34),(19.255,22.34),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,22.34),(81.655,22.34),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,22.34),(33.655,22.34),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,19.415),(81.655,19.415),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,19.415),(33.655,19.415),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,19.415),(52.855,19.415),(52.855,2.925),(51.545,2.925)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(13.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(13.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(61.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(61.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(71.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(71.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(66.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(66.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(18.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(18.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(28.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(28.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(81.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(81.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(76.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(76.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(23.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(23.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(9.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(9.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['off']
        createRL(
            tech, net, 'poly',
            ((12.435,2.59),(12.435,19.75),(13.035,19.75),(13.035,2.59),(12.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,19.78),(48.33,20.11),(48.6,20.11),(48.6,19.78),(48.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,19.75),(12.435,19.78),(13.035,19.78),(13.035,19.75),(12.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.59),(74.835,19.75),(75.435,19.75),(75.435,2.59),(74.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,19.75),(74.835,19.78),(75.435,19.78),(75.435,19.75),(74.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.56),(26.835,2.59),(27.435,2.59),(27.435,2.56),(26.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,19.78),(9.93,20.11),(10.2,20.11),(10.2,19.78),(9.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,19.78),(70.2,20.11),(70.47,20.11),(70.47,19.78),(70.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,19.78),(60.6,20.11),(60.87,20.11),(60.87,19.78),(60.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.59),(43.365,19.75),(43.965,19.75),(43.965,2.59),(43.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,2.23),(9.93,2.56),(10.2,2.56),(10.2,2.23),(9.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.56),(9.765,2.59),(10.365,2.59),(10.365,2.56),(9.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,19.78),(77.13,20.11),(77.4,20.11),(77.4,19.78),(77.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.59),(26.835,19.75),(27.435,19.75),(27.435,2.59),(26.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,19.75),(26.835,19.78),(27.435,19.78),(27.435,19.75),(26.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.59),(72.165,19.75),(72.765,19.75),(72.765,2.59),(72.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.56),(43.365,2.59),(43.965,2.59),(43.965,2.56),(43.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.56),(55.635,2.59),(56.235,2.59),(56.235,2.56),(55.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,19.75),(50.835,19.78),(51.435,19.78),(51.435,19.75),(50.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.59),(9.765,19.75),(10.365,19.75),(10.365,2.59),(9.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.59),(67.365,19.75),(67.965,19.75),(67.965,2.59),(67.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,19.75),(52.965,19.78),(53.565,19.78),(53.565,19.75),(52.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.56),(72.165,2.59),(72.765,2.59),(72.765,2.56),(72.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,2.23),(72.33,2.56),(72.6,2.56),(72.6,2.23),(72.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.59),(81.765,19.75),(82.365,19.75),(82.365,2.59),(81.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,19.75),(81.765,19.78),(82.365,19.78),(82.365,19.75),(81.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,19.78),(72.33,20.11),(72.6,20.11),(72.6,19.78),(72.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,2.23),(67.53,2.56),(67.8,2.56),(67.8,2.23),(67.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,2.23),(79.8,2.56),(80.07,2.56),(80.07,2.23),(79.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.56),(79.635,2.59),(80.235,2.59),(80.235,2.56),(79.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.56),(67.365,2.59),(67.965,2.59),(67.965,2.56),(67.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.59),(62.565,19.75),(63.165,19.75),(63.165,2.59),(62.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,19.75),(22.035,19.78),(22.635,19.78),(22.635,19.75),(22.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,2.23),(7.8,2.56),(8.07,2.56),(8.07,2.23),(7.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.56),(7.635,2.59),(8.235,2.59),(8.235,2.56),(7.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,19.78),(75.0,20.11),(75.27,20.11),(75.27,19.78),(75.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,19.78),(43.53,20.11),(43.8,20.11),(43.8,19.78),(43.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,19.78),(31.8,20.11),(32.07,20.11),(32.07,19.78),(31.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,19.75),(31.635,19.78),(32.235,19.78),(32.235,19.75),(31.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.56),(48.165,2.59),(48.765,2.59),(48.765,2.56),(48.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.56),(17.235,2.59),(17.835,2.59),(17.835,2.56),(17.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,2.23),(17.4,2.56),(17.67,2.56),(17.67,2.23),(17.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,19.78),(33.93,20.11),(34.2,20.11),(34.2,19.78),(33.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.59),(65.235,19.75),(65.835,19.75),(65.835,2.59),(65.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,19.78),(27.0,20.11),(27.27,20.11),(27.27,19.78),(27.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.56),(28.965,2.59),(29.565,2.59),(29.565,2.56),(28.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.59),(33.765,19.75),(34.365,19.75),(34.365,2.59),(33.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,19.78),(65.4,20.11),(65.67,20.11),(65.67,19.78),(65.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.56),(38.565,2.59),(39.165,2.59),(39.165,2.56),(38.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,2.23),(14.73,2.56),(15.0,2.56),(15.0,2.23),(14.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.56),(14.565,2.59),(15.165,2.59),(15.165,2.56),(14.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.56),(50.835,2.59),(51.435,2.59),(51.435,2.56),(50.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.59),(28.965,19.75),(29.565,19.75),(29.565,2.59),(28.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,19.78),(53.13,20.11),(53.4,20.11),(53.4,19.78),(53.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,19.75),(28.965,19.78),(29.565,19.78),(29.565,19.75),(28.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.59),(38.565,19.75),(39.165,19.75),(39.165,2.59),(38.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,19.78),(55.8,20.11),(56.07,20.11),(56.07,19.78),(55.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,19.75),(55.635,19.78),(56.235,19.78),(56.235,19.75),(55.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,19.78),(62.73,20.11),(63.0,20.11),(63.0,19.78),(62.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,19.75),(70.035,19.78),(70.635,19.78),(70.635,19.75),(70.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,19.75),(62.565,19.78),(63.165,19.78),(63.165,19.75),(62.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,11.335),(85.68,11.6),(86.01,11.6),(86.01,11.335),(85.68,11.335)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,19.78),(67.53,20.11),(67.8,20.11),(67.8,19.78),(67.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.59),(46.035,19.75),(46.635,19.75),(46.635,2.59),(46.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,19.78),(17.4,20.11),(17.67,20.11),(17.67,19.78),(17.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,2.23),(60.6,2.56),(60.87,2.56),(60.87,2.23),(60.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,2.23),(70.2,2.56),(70.47,2.56),(70.47,2.23),(70.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.56),(70.035,2.59),(70.635,2.59),(70.635,2.56),(70.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,2.23),(29.13,2.56),(29.4,2.56),(29.4,2.23),(29.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,11.34),(85.68,11.63),(86.01,11.63),(86.01,11.34),(85.68,11.34)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,19.78),(41.4,20.11),(41.67,20.11),(41.67,19.78),(41.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.56),(46.035,2.59),(46.635,2.59),(46.635,2.56),(46.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,19.78),(19.53,20.11),(19.8,20.11),(19.8,19.78),(19.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,19.75),(36.435,19.78),(37.035,19.78),(37.035,19.75),(36.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.56),(76.965,2.59),(77.565,2.59),(77.565,2.56),(76.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,2.23),(12.6,2.56),(12.87,2.56),(12.87,2.23),(12.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,2.23),(22.2,2.56),(22.47,2.56),(22.47,2.23),(22.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.56),(22.035,2.59),(22.635,2.59),(22.635,2.56),(22.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,19.78),(14.73,20.11),(15.0,20.11),(15.0,19.78),(14.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,19.75),(14.565,19.78),(15.165,19.78),(15.165,19.75),(14.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,19.78),(12.6,20.11),(12.87,20.11),(12.87,19.78),(12.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,19.78),(81.93,20.11),(82.2,20.11),(82.2,19.78),(81.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.59),(76.965,19.75),(77.565,19.75),(77.565,2.59),(76.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,19.75),(76.965,19.78),(77.565,19.78),(77.565,19.75),(76.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,19.78),(79.8,20.11),(80.07,20.11),(80.07,19.78),(79.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,2.23),(81.93,2.56),(82.2,2.56),(82.2,2.23),(81.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.56),(81.765,2.59),(82.365,2.59),(82.365,2.56),(81.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,19.75),(79.635,19.78),(80.235,19.78),(80.235,19.75),(79.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,19.75),(43.365,19.78),(43.965,19.78),(43.965,19.75),(43.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,2.23),(62.73,2.56),(63.0,2.56),(63.0,2.23),(62.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.56),(62.565,2.59),(63.165,2.59),(63.165,2.56),(62.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,19.75),(60.435,19.78),(61.035,19.78),(61.035,19.75),(60.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,19.78),(46.2,20.11),(46.47,20.11),(46.47,19.78),(46.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.59),(31.635,19.75),(32.235,19.75),(32.235,2.59),(31.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,2.23),(77.13,2.56),(77.4,2.56),(77.4,2.23),(77.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,19.75),(57.765,19.78),(58.365,19.78),(58.365,19.75),(57.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.59),(48.165,19.75),(48.765,19.75),(48.765,2.59),(48.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,19.75),(65.235,19.78),(65.835,19.78),(65.835,19.75),(65.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.56),(57.765,2.59),(58.365,2.59),(58.365,2.56),(57.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.59),(17.235,19.75),(17.835,19.75),(17.835,2.59),(17.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,19.75),(24.165,19.78),(24.765,19.78),(24.765,19.75),(24.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.56),(33.765,2.59),(34.365,2.59),(34.365,2.56),(33.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,19.75),(48.165,19.78),(48.765,19.78),(48.765,19.75),(48.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.59),(57.765,19.75),(58.365,19.75),(58.365,2.59),(57.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,19.75),(9.765,19.78),(10.365,19.78),(10.365,19.75),(9.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,19.78),(51.0,20.11),(51.27,20.11),(51.27,19.78),(51.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.56),(52.965,2.59),(53.565,2.59),(53.565,2.56),(52.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.59),(55.635,19.75),(56.235,19.75),(56.235,2.59),(55.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,2.23),(75.0,2.56),(75.27,2.56),(75.27,2.23),(75.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,19.75),(67.365,19.78),(67.965,19.78),(67.965,19.75),(67.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,19.75),(17.235,19.78),(17.835,19.78),(17.835,19.75),(17.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.59),(52.965,19.75),(53.565,19.75),(53.565,2.59),(52.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,2.23),(19.53,2.56),(19.8,2.56),(19.8,2.23),(19.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.56),(36.435,2.59),(37.035,2.59),(37.035,2.56),(36.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,19.78),(7.8,20.11),(8.07,20.11),(8.07,19.78),(7.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.59),(79.635,19.75),(80.235,19.75),(80.235,2.59),(79.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.59),(7.635,19.75),(8.235,19.75),(8.235,2.59),(7.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,19.75),(41.235,19.78),(41.835,19.78),(41.835,19.75),(41.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,19.75),(7.635,19.78),(8.235,19.78),(8.235,19.75),(7.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,2.23),(27.0,2.56),(27.27,2.56),(27.27,2.23),(27.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,19.75),(19.365,19.78),(19.965,19.78),(19.965,19.75),(19.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.59),(70.035,19.75),(70.635,19.75),(70.635,2.59),(70.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.59),(36.435,19.75),(37.035,19.75),(37.035,2.59),(36.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,19.75),(72.165,19.78),(72.765,19.78),(72.765,19.75),(72.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.59),(41.235,19.75),(41.835,19.75),(41.835,2.59),(41.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,19.78),(22.2,20.11),(22.47,20.11),(22.47,19.78),(22.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.59),(22.035,19.75),(22.635,19.75),(22.635,2.59),(22.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.56),(65.235,2.59),(65.835,2.59),(65.835,2.56),(65.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,2.23),(65.4,2.56),(65.67,2.56),(65.67,2.23),(65.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,19.78),(29.13,20.11),(29.4,20.11),(29.4,19.78),(29.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,19.75),(46.035,19.78),(46.635,19.78),(46.635,19.75),(46.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.56),(60.435,2.59),(61.035,2.59),(61.035,2.56),(60.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.59),(24.165,19.75),(24.765,19.75),(24.765,2.59),(24.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.56),(41.235,2.59),(41.835,2.59),(41.835,2.56),(41.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,19.75),(33.765,19.78),(34.365,19.78),(34.365,19.75),(33.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.59),(14.565,19.75),(15.165,19.75),(15.165,2.59),(14.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.59),(50.835,19.75),(51.435,19.75),(51.435,2.59),(50.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.59),(19.365,19.75),(19.965,19.75),(19.965,2.59),(19.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,19.78),(36.6,20.11),(36.87,20.11),(36.87,19.78),(36.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.59),(60.435,19.75),(61.035,19.75),(61.035,2.59),(60.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,19.78),(38.73,20.11),(39.0,20.11),(39.0,19.78),(38.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,2.23),(24.33,2.56),(24.6,2.56),(24.6,2.23),(24.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.56),(24.165,2.59),(24.765,2.59),(24.765,2.56),(24.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,2.56),(12.435,2.59),(13.035,2.59),(13.035,2.56),(12.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,19.75),(38.565,19.78),(39.165,19.78),(39.165,19.75),(38.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.56),(74.835,2.59),(75.435,2.59),(75.435,2.56),(74.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,19.78),(57.93,20.11),(58.2,20.11),(58.2,19.78),(57.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,19.78),(24.33,20.11),(24.6,20.11),(24.6,19.78),(24.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.56),(19.365,2.59),(19.965,2.59),(19.965,2.56),(19.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.56),(31.635,2.59),(32.235,2.59),(32.235,2.56),(31.635,2.56)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,19.86),(12.65,20.03),(12.82,20.03),(12.82,19.86),(12.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,2.31),(17.45,2.48),(17.62,2.48),(17.62,2.31),(17.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,19.86),(81.98,20.03),(82.15,20.03),(82.15,19.86),(81.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,19.86),(33.98,20.03),(34.15,20.03),(34.15,19.86),(33.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,19.86),(48.38,20.03),(48.55,20.03),(48.55,19.86),(48.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,19.86),(27.05,20.03),(27.22,20.03),(27.22,19.86),(27.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,2.31),(19.58,2.48),(19.75,2.48),(19.75,2.31),(19.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,11.38),(85.76,11.55),(85.93,11.55),(85.93,11.38),(85.76,11.38)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,19.86),(7.85,20.03),(8.02,20.03),(8.02,19.86),(7.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,19.86),(65.45,20.03),(65.62,20.03),(65.62,19.86),(65.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,19.86),(79.85,20.03),(80.02,20.03),(80.02,19.86),(79.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,19.86),(9.98,20.03),(10.15,20.03),(10.15,19.86),(9.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,2.31),(81.98,2.48),(82.15,2.48),(82.15,2.31),(81.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,2.31),(27.05,2.48),(27.22,2.48),(27.22,2.31),(27.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,19.86),(38.78,20.03),(38.95,20.03),(38.95,19.86),(38.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,19.86),(70.25,20.03),(70.42,20.03),(70.42,19.86),(70.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,19.86),(60.65,20.03),(60.82,20.03),(60.82,19.86),(60.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,2.31),(9.98,2.48),(10.15,2.48),(10.15,2.31),(9.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,2.31),(62.78,2.48),(62.95,2.48),(62.95,2.31),(62.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,2.31),(14.78,2.48),(14.95,2.48),(14.95,2.31),(14.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,19.86),(77.18,20.03),(77.35,20.03),(77.35,19.86),(77.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,19.86),(53.18,20.03),(53.35,20.03),(53.35,19.86),(53.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,19.86),(46.25,20.03),(46.42,20.03),(46.42,19.86),(46.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,19.86),(14.78,20.03),(14.95,20.03),(14.95,19.86),(14.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,19.86),(55.85,20.03),(56.02,20.03),(56.02,19.86),(55.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,2.31),(77.18,2.48),(77.35,2.48),(77.35,2.31),(77.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,19.86),(22.25,20.03),(22.42,20.03),(22.42,19.86),(22.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,2.31),(75.05,2.48),(75.22,2.48),(75.22,2.31),(75.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,2.31),(65.45,2.48),(65.62,2.48),(65.62,2.31),(65.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,19.86),(67.58,20.03),(67.75,20.03),(67.75,19.86),(67.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,19.86),(29.18,20.03),(29.35,20.03),(29.35,19.86),(29.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,2.31),(72.38,2.48),(72.55,2.48),(72.55,2.31),(72.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,19.86),(17.45,20.03),(17.62,20.03),(17.62,19.86),(17.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,2.31),(60.65,2.48),(60.82,2.48),(60.82,2.31),(60.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,2.31),(70.25,2.48),(70.42,2.48),(70.42,2.31),(70.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,19.86),(72.38,20.03),(72.55,20.03),(72.55,19.86),(72.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,2.31),(29.18,2.48),(29.35,2.48),(29.35,2.31),(29.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,2.31),(7.85,2.48),(8.02,2.48),(8.02,2.31),(7.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,2.31),(79.85,2.48),(80.02,2.48),(80.02,2.31),(79.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,2.31),(67.58,2.48),(67.75,2.48),(67.75,2.31),(67.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,19.86),(36.65,20.03),(36.82,20.03),(36.82,19.86),(36.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,19.86),(41.45,20.03),(41.62,20.03),(41.62,19.86),(41.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,19.86),(19.58,20.03),(19.75,20.03),(19.75,19.86),(19.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,2.31),(24.38,2.48),(24.55,2.48),(24.55,2.31),(24.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,19.86),(51.05,20.03),(51.22,20.03),(51.22,19.86),(51.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,19.86),(43.58,20.03),(43.75,20.03),(43.75,19.86),(43.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,19.86),(75.05,20.03),(75.22,20.03),(75.22,19.86),(75.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,19.86),(62.78,20.03),(62.95,20.03),(62.95,19.86),(62.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,19.86),(31.85,20.03),(32.02,20.03),(32.02,19.86),(31.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,2.31),(12.65,2.48),(12.82,2.48),(12.82,2.31),(12.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,19.86),(57.98,20.03),(58.15,20.03),(58.15,19.86),(57.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,2.31),(22.25,2.48),(22.42,2.48),(22.42,2.31),(22.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,19.86),(24.38,20.03),(24.55,20.03),(24.55,19.86),(24.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,19.78),(48.38,20.11),(48.55,20.11),(48.55,19.78),(48.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.56),(62.78,19.78),(62.95,19.78),(62.95,2.56),(62.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,19.78),(9.98,20.11),(10.15,20.11),(10.15,19.78),(9.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,19.78),(70.25,20.11),(70.42,20.11),(70.42,19.78),(70.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.56),(43.58,19.78),(43.75,19.78),(43.75,2.56),(43.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,19.78),(60.65,20.11),(60.82,20.11),(60.82,19.78),(60.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.23),(9.98,2.56),(10.15,2.56),(10.15,2.23),(9.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.23),(62.78,2.56),(62.95,2.56),(62.95,2.23),(62.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,19.78),(77.18,20.11),(77.35,20.11),(77.35,19.78),(77.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.56),(72.38,19.78),(72.55,19.78),(72.55,2.56),(72.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.23),(43.58,2.56),(43.75,2.56),(43.75,2.23),(43.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.23),(55.85,2.56),(56.02,2.56),(56.02,2.23),(55.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.56),(9.98,19.78),(10.15,19.78),(10.15,2.56),(9.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.56),(67.58,19.78),(67.75,19.78),(67.75,2.56),(67.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.23),(72.38,2.56),(72.55,2.56),(72.55,2.23),(72.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.56),(81.98,19.78),(82.15,19.78),(82.15,2.56),(81.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,19.78),(72.38,20.11),(72.55,20.11),(72.55,19.78),(72.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.23),(67.58,2.56),(67.75,2.56),(67.75,2.23),(67.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.23),(79.85,2.56),(80.02,2.56),(80.02,2.23),(79.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.23),(7.85,2.56),(8.02,2.56),(8.02,2.23),(7.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.56),(38.78,19.78),(38.95,19.78),(38.95,2.56),(38.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.56),(53.18,19.78),(53.35,19.78),(53.35,2.56),(53.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,19.94),(7.85,20.11),(82.15,20.11),(82.15,19.94),(7.85,19.94)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,19.78),(43.58,20.11),(43.75,20.11),(43.75,19.78),(43.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,19.78),(75.05,20.11),(75.22,20.11),(75.22,19.78),(75.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,19.78),(62.78,20.11),(62.95,20.11),(62.95,19.78),(62.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,19.78),(31.85,20.11),(32.02,20.11),(32.02,19.78),(31.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.23),(53.18,2.56),(53.35,2.56),(53.35,2.23),(53.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.23),(48.38,2.56),(48.55,2.56),(48.55,2.23),(48.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.23),(17.45,2.56),(17.62,2.56),(17.62,2.23),(17.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,19.78),(33.98,20.11),(34.15,20.11),(34.15,19.78),(33.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.56),(65.45,19.78),(65.62,19.78),(65.62,2.56),(65.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,19.78),(27.05,20.11),(27.22,20.11),(27.22,19.78),(27.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,11.3),(85.76,11.63),(85.93,11.63),(85.93,11.3),(85.76,11.3)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.56),(33.98,19.78),(34.15,19.78),(34.15,2.56),(33.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,19.78),(65.45,20.11),(65.62,20.11),(65.62,19.78),(65.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.23),(36.65,2.56),(36.82,2.56),(36.82,2.23),(36.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,19.78),(53.18,20.11),(53.35,20.11),(53.35,19.78),(53.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,19.78),(14.78,20.11),(14.95,20.11),(14.95,19.78),(14.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,19.78),(55.85,20.11),(56.02,20.11),(56.02,19.78),(55.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.56),(29.18,19.78),(29.35,19.78),(29.35,2.56),(29.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,19.78),(67.58,20.11),(67.75,20.11),(67.75,19.78),(67.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.56),(46.25,19.78),(46.42,19.78),(46.42,2.56),(46.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,19.78),(17.45,20.11),(17.62,20.11),(17.62,19.78),(17.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.23),(60.65,2.56),(60.82,2.56),(60.82,2.23),(60.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.23),(70.25,2.56),(70.42,2.56),(70.42,2.23),(70.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.23),(29.18,2.56),(29.35,2.56),(29.35,2.23),(29.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,19.78),(41.45,20.11),(41.62,20.11),(41.62,19.78),(41.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.23),(46.25,2.56),(46.42,2.56),(46.42,2.23),(46.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,19.78),(19.58,20.11),(19.75,20.11),(19.75,19.78),(19.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.23),(12.65,2.56),(12.82,2.56),(12.82,2.23),(12.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.23),(22.25,2.56),(22.42,2.56),(22.42,2.23),(22.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,19.78),(12.65,20.11),(12.82,20.11),(12.82,19.78),(12.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,19.78),(81.98,20.11),(82.15,20.11),(82.15,19.78),(81.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,19.78),(79.85,20.11),(80.02,20.11),(80.02,19.78),(79.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.23),(81.98,2.56),(82.15,2.56),(82.15,2.23),(81.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.56),(51.05,19.78),(51.22,19.78),(51.22,2.56),(51.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.56),(77.18,19.78),(77.35,19.78),(77.35,2.56),(77.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,19.78),(46.25,20.11),(46.42,20.11),(46.42,19.78),(46.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.56),(31.85,19.78),(32.02,19.78),(32.02,2.56),(31.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.23),(51.05,2.56),(51.22,2.56),(51.22,2.23),(51.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.23),(77.18,2.56),(77.35,2.56),(77.35,2.23),(77.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.56),(48.38,19.78),(48.55,19.78),(48.55,2.56),(48.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.23),(57.98,2.56),(58.15,2.56),(58.15,2.23),(57.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.56),(17.45,19.78),(17.62,19.78),(17.62,2.56),(17.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.23),(33.98,2.56),(34.15,2.56),(34.15,2.23),(33.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.56),(36.65,19.78),(36.82,19.78),(36.82,2.56),(36.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.56),(57.98,19.78),(58.15,19.78),(58.15,2.56),(57.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.56),(75.05,19.78),(75.22,19.78),(75.22,2.56),(75.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,19.78),(51.05,20.11),(51.22,20.11),(51.22,19.78),(51.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.56),(55.85,19.78),(56.02,19.78),(56.02,2.56),(55.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.23),(75.05,2.56),(75.22,2.56),(75.22,2.23),(75.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.56),(27.05,19.78),(27.22,19.78),(27.22,2.56),(27.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.56),(14.78,19.78),(14.95,19.78),(14.95,2.56),(14.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,19.78),(7.85,20.11),(8.02,20.11),(8.02,19.78),(7.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.56),(79.85,19.78),(80.02,19.78),(80.02,2.56),(79.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.56),(7.85,19.78),(8.02,19.78),(8.02,2.56),(7.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.23),(38.78,2.56),(38.95,2.56),(38.95,2.23),(38.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.23),(27.05,2.56),(27.22,2.56),(27.22,2.23),(27.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.56),(60.65,19.78),(60.82,19.78),(60.82,2.56),(60.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,19.78),(38.78,20.11),(38.95,20.11),(38.95,19.78),(38.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.56),(70.25,19.78),(70.42,19.78),(70.42,2.56),(70.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.23),(14.78,2.56),(14.95,2.56),(14.95,2.23),(14.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,11.3),(85.76,20.11),(85.93,20.11),(85.93,11.3),(85.76,11.3)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.56),(41.45,19.78),(41.62,19.78),(41.62,2.56),(41.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.56),(12.65,19.78),(12.82,19.78),(12.82,2.56),(12.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,19.78),(22.25,20.11),(22.42,20.11),(22.42,19.78),(22.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.56),(22.25,19.78),(22.42,19.78),(22.42,2.56),(22.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.23),(65.45,2.56),(65.62,2.56),(65.62,2.23),(65.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,19.78),(29.18,20.11),(29.35,20.11),(29.35,19.78),(29.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.23),(41.45,2.56),(41.62,2.56),(41.62,2.23),(41.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.56),(24.38,19.78),(24.55,19.78),(24.55,2.56),(24.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.56),(19.58,19.78),(19.75,19.78),(19.75,2.56),(19.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,19.78),(36.65,20.11),(36.82,20.11),(36.82,19.78),(36.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.23),(24.38,2.56),(24.55,2.56),(24.55,2.23),(24.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,19.78),(57.98,20.11),(58.15,20.11),(58.15,19.78),(57.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,19.78),(24.38,20.11),(24.55,20.11),(24.55,19.78),(24.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.23),(19.58,2.56),(19.75,2.56),(19.75,2.23),(19.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.23),(31.85,2.56),(32.02,2.56),(32.02,2.23),(31.85,2.23)),
        )
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_N18000W4468HFF']
        except:
            subcell = af.getCell('GuardRing_N18000W4468HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_P17368W3836HFF']
        except:
            subcell = af.getCell('GuardRing_P17368W3836HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Clamp_P32N0D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(43.64),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'off': Net.create(cell, 'off'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((7.385,2.72),(7.385,40.92),(7.635,40.92),(7.635,2.72),(7.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.35,2.72),(69.35,40.92),(69.67,40.92),(69.67,2.72),(69.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.235,2.72),(65.235,40.92),(65.835,40.92),(65.835,2.72),(65.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.765,2.72),(81.765,40.92),(82.365,40.92),(82.365,2.72),(81.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.965,2.72),(28.965,40.92),(29.565,40.92),(29.565,2.72),(28.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.435,2.72),(36.435,40.92),(37.035,40.92),(37.035,2.72),(36.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.785,2.72),(69.785,40.92),(70.035,40.92),(70.035,2.72),(69.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.585,2.72),(50.585,40.92),(50.835,40.92),(50.835,2.72),(50.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,40.92),(43.965,40.92),(43.965,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.365,2.72),(19.365,40.92),(19.965,40.92),(19.965,2.72),(19.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.365,2.72),(67.365,40.92),(67.965,40.92),(67.965,2.72),(67.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.035,2.72),(46.035,40.92),(46.635,40.92),(46.635,2.72),(46.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.765,2.72),(48.765,40.92),(49.015,40.92),(49.015,2.72),(48.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.05,2.72),(11.05,40.92),(11.75,40.92),(11.75,2.72),(11.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.235,2.72),(41.235,40.92),(41.835,40.92),(41.835,2.72),(41.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.815,2.72),(53.815,40.92),(55.27,40.92),(55.27,2.72),(53.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,40.92),(55.385,40.92),(55.385,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.15,2.72),(50.15,40.92),(50.47,40.92),(50.47,2.72),(50.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.165,2.72),(15.165,40.92),(15.415,40.92),(15.415,2.72),(15.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.365,2.72),(10.365,40.92),(10.615,40.92),(10.615,2.72),(10.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.985,2.72),(40.985,40.92),(41.235,40.92),(41.235,2.72),(40.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.815,2.72),(29.815,40.92),(31.27,40.92),(31.27,2.72),(29.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,40.92),(31.385,40.92),(31.385,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,40.92),(44.65,40.92),(44.65,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.765,2.72),(72.765,40.92),(73.015,40.92),(73.015,2.72),(72.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.165,2.72),(24.165,40.92),(24.765,40.92),(24.765,2.72),(24.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.55,2.72),(40.55,40.92),(40.87,40.92),(40.87,2.72),(40.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,40.92),(39.165,40.92),(39.165,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.365,2.72),(34.365,40.92),(34.615,40.92),(34.615,2.72),(34.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.35,2.72),(21.35,40.92),(21.67,40.92),(21.67,2.72),(21.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.185,2.72),(36.185,40.92),(36.435,40.92),(36.435,2.72),(36.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.95,2.72),(30.95,40.92),(31.27,40.92),(31.27,2.72),(30.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.565,2.72),(53.565,40.92),(53.815,40.92),(53.815,2.72),(53.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.85,2.72),(15.85,40.92),(16.55,40.92),(16.55,2.72),(15.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,40.92),(16.985,40.92),(16.985,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.415,2.72),(15.415,40.92),(16.87,40.92),(16.87,2.72),(15.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.75,2.72),(35.75,40.92),(36.07,40.92),(36.07,2.72),(35.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.585,2.72),(26.585,40.92),(26.835,40.92),(26.835,2.72),(26.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.165,2.72),(63.165,40.92),(63.415,40.92),(63.415,2.72),(63.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.635,2.72),(31.635,40.92),(32.235,40.92),(32.235,2.72),(31.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.635,2.72),(55.635,40.92),(56.235,40.92),(56.235,2.72),(55.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.035,2.72),(22.035,40.92),(22.635,40.92),(22.635,2.72),(22.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.85,2.72),(63.85,40.92),(64.55,40.92),(64.55,2.72),(63.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.415,2.72),(63.415,40.92),(64.87,40.92),(64.87,2.72),(63.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,40.92),(64.985,40.92),(64.985,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.835,2.72),(74.835,40.92),(75.435,40.92),(75.435,2.72),(74.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,40.92),(54.25,40.92),(54.25,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,40.92),(6.95,40.92),(6.95,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.365,2.72),(82.365,40.92),(82.615,40.92),(82.615,2.72),(82.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.35,2.72),(45.35,40.92),(45.67,40.92),(45.67,2.72),(45.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.25,2.72),(78.25,40.92),(78.95,40.92),(78.95,2.72),(78.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.75,2.72),(59.75,40.92),(60.07,40.92),(60.07,2.72),(59.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,40.92),(30.25,40.92),(30.25,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.215,2.72),(44.215,40.92),(45.67,40.92),(45.67,2.72),(44.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.585,2.72),(74.585,40.92),(74.835,40.92),(74.835,2.72),(74.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,40.92),(45.785,40.92),(45.785,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.65,2.72),(44.65,40.92),(45.35,40.92),(45.35,2.72),(44.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,40.92),(49.45,40.92),(49.45,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.05,2.72),(35.05,40.92),(35.75,40.92),(35.75,2.72),(35.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.635,2.72),(7.635,40.92),(8.235,40.92),(8.235,2.72),(7.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.635,2.72),(79.635,40.92),(80.235,40.92),(80.235,2.72),(79.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,40.92),(20.65,40.92),(20.65,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.765,2.72),(24.765,40.92),(25.015,40.92),(25.015,2.72),(24.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.385,2.72),(31.385,40.92),(31.635,40.92),(31.635,2.72),(31.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,40.92),(48.765,40.92),(48.765,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.73,2.72),(82.73,40.92),(83.05,40.92),(83.05,2.72),(82.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.615,2.72),(82.615,40.92),(83.75,40.92),(83.75,2.72),(82.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.815,2.72),(77.815,40.92),(79.27,40.92),(79.27,2.72),(77.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,40.92),(79.385,40.92),(79.385,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,40.92),(39.85,40.92),(39.85,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,40.92),(25.45,40.92),(25.45,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.95,2.72),(54.95,40.92),(55.27,40.92),(55.27,2.72),(54.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.05,2.72),(59.05,40.92),(59.75,40.92),(59.75,2.72),(59.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.035,2.72),(70.035,40.92),(70.635,40.92),(70.635,2.72),(70.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,40.92),(73.45,40.92),(73.45,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.785,2.72),(45.785,40.92),(46.035,40.92),(46.035,2.72),(45.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.185,2.72),(12.185,40.92),(12.435,40.92),(12.435,2.72),(12.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.385,2.72),(79.385,40.92),(79.635,40.92),(79.635,2.72),(79.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.65,2.72),(20.65,40.92),(21.35,40.92),(21.35,2.72),(20.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.215,2.72),(20.215,40.92),(21.67,40.92),(21.67,2.72),(20.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,40.92),(21.785,40.92),(21.785,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.55,2.72),(64.55,40.92),(64.87,40.92),(64.87,2.72),(64.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.615,2.72),(58.615,40.92),(60.07,40.92),(60.07,2.72),(58.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,40.92),(60.185,40.92),(60.185,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.75,2.72),(11.75,40.92),(12.07,40.92),(12.07,2.72),(11.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.835,2.72),(26.835,40.92),(27.435,40.92),(27.435,2.72),(26.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,40.92),(78.25,40.92),(78.25,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.615,2.72),(34.615,40.92),(36.07,40.92),(36.07,2.72),(34.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,40.92),(36.185,40.92),(36.185,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.15,2.72),(26.15,40.92),(26.47,40.92),(26.47,2.72),(26.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.185,2.72),(60.185,40.92),(60.435,40.92),(60.435,2.72),(60.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,40.92),(68.65,40.92),(68.65,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,40.92),(58.365,40.92),(58.365,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.45,2.72),(49.45,40.92),(50.15,40.92),(50.15,2.72),(49.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,40.92),(30.95,40.92),(30.95,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.015,2.72),(49.015,40.92),(50.47,40.92),(50.47,2.72),(49.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,40.92),(50.585,40.92),(50.585,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.015,2.72),(73.015,40.92),(74.47,40.92),(74.47,2.72),(73.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,40.92),(74.585,40.92),(74.585,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.565,2.72),(29.565,40.92),(29.815,40.92),(29.815,2.72),(29.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.565,2.72),(62.565,40.92),(63.165,40.92),(63.165,2.72),(62.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.835,2.72),(50.835,40.92),(51.435,40.92),(51.435,2.72),(50.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.565,2.72),(14.565,40.92),(15.165,40.92),(15.165,2.72),(14.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,40.92),(63.85,40.92),(63.85,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.15,2.72),(74.15,40.92),(74.47,40.92),(74.47,2.72),(74.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.385,2.72),(55.385,40.92),(55.635,40.92),(55.635,2.72),(55.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.55,2.72),(16.55,40.92),(16.87,40.92),(16.87,2.72),(16.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.965,2.72),(19.965,40.92),(20.215,40.92),(20.215,2.72),(19.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.965,2.72),(43.965,40.92),(44.215,40.92),(44.215,2.72),(43.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.235,2.72),(17.235,40.92),(17.835,40.92),(17.835,2.72),(17.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.965,2.72),(76.965,40.92),(77.565,40.92),(77.565,2.72),(76.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.785,2.72),(21.785,40.92),(22.035,40.92),(22.035,2.72),(21.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,40.92),(34.365,40.92),(34.365,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.435,2.72),(60.435,40.92),(61.035,40.92),(61.035,2.72),(60.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,40.92),(53.565,40.92),(53.565,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.435,2.72),(12.435,40.92),(13.035,40.92),(13.035,2.72),(12.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,40.92),(7.385,40.92),(7.385,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.95,2.72),(6.95,40.92),(7.27,40.92),(7.27,2.72),(6.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,40.92),(59.05,40.92),(59.05,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((83.05,2.72),(83.05,40.92),(83.75,40.92),(83.75,2.72),(83.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.95,2.72),(78.95,40.92),(79.27,40.92),(79.27,2.72),(78.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.765,2.72),(9.765,40.92),(10.365,40.92),(10.365,2.72),(9.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.565,2.72),(77.565,40.92),(77.815,40.92),(77.815,2.72),(77.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.615,2.72),(10.615,40.92),(12.07,40.92),(12.07,2.72),(10.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,40.92),(12.185,40.92),(12.185,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.165,2.72),(39.165,40.92),(39.415,40.92),(39.415,2.72),(39.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,40.92),(15.85,40.92),(15.85,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.365,2.72),(58.365,40.92),(58.615,40.92),(58.615,2.72),(58.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.965,2.72),(67.965,40.92),(68.215,40.92),(68.215,2.72),(67.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.985,2.72),(16.985,40.92),(17.235,40.92),(17.235,2.72),(16.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.985,2.72),(64.985,40.92),(65.235,40.92),(65.235,2.72),(64.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.165,2.72),(72.165,40.92),(72.765,40.92),(72.765,2.72),(72.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.65,2.72),(68.65,40.92),(69.35,40.92),(69.35,2.72),(68.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.215,2.72),(68.215,40.92),(69.67,40.92),(69.67,2.72),(68.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,40.92),(69.785,40.92),(69.785,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.45,2.72),(25.45,40.92),(26.15,40.92),(26.15,2.72),(25.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.015,2.72),(25.015,40.92),(26.47,40.92),(26.47,2.72),(25.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,40.92),(26.585,40.92),(26.585,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,40.92),(35.05,40.92),(35.05,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.85,2.72),(39.85,40.92),(40.55,40.92),(40.55,2.72),(39.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,2.72),(39.415,40.92),(40.87,40.92),(40.87,2.72),(39.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,40.92),(40.985,40.92),(40.985,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,40.92),(11.05,40.92),(11.05,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.45,2.72),(73.45,40.92),(74.15,40.92),(74.15,2.72),(73.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,2.72),(54.25,40.92),(54.95,40.92),(54.95,2.72),(54.25,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,22.585),(30.005,22.755),(30.175,22.755),(30.175,22.585),(30.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,22.245),(30.005,22.415),(30.175,22.415),(30.175,22.245),(30.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,26.325),(55.025,26.495),(55.195,26.495),(55.195,26.325),(55.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,29.385),(20.405,29.555),(20.575,29.555),(20.575,29.385),(20.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.585),(39.605,39.755),(39.775,39.755),(39.775,39.585),(39.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.245),(39.605,39.415),(39.775,39.415),(39.775,39.245),(39.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.925),(73.205,6.095),(73.375,6.095),(73.375,5.925),(73.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.925),(73.715,6.095),(73.885,6.095),(73.885,5.925),(73.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.505),(44.405,18.675),(44.575,18.675),(44.575,18.505),(44.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,27.345),(15.605,27.515),(15.775,27.515),(15.775,27.345),(15.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.285),(59.315,7.455),(59.485,7.455),(59.485,7.285),(59.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.285),(59.825,7.455),(59.995,7.455),(59.995,7.285),(59.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,33.125),(74.225,33.295),(74.395,33.295),(74.395,33.125),(74.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,33.465),(74.225,33.635),(74.395,33.635),(74.395,33.465),(74.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,33.805),(74.225,33.975),(74.395,33.975),(74.395,33.805),(74.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.625),(11.825,7.795),(11.995,7.795),(11.995,7.625),(11.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.625),(11.315,7.795),(11.485,7.795),(11.485,7.625),(11.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,39.585),(83.315,39.755),(83.485,39.755),(83.485,39.585),(83.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.165),(82.805,18.335),(82.975,18.335),(82.975,18.165),(82.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.885),(44.915,38.055),(45.085,38.055),(45.085,37.885),(44.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,39.245),(83.315,39.415),(83.485,39.415),(83.485,39.245),(83.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.645),(44.405,8.815),(44.575,8.815),(44.575,8.645),(44.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.925),(50.225,40.095),(50.395,40.095),(50.395,39.925),(50.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.305),(49.205,25.475),(49.375,25.475),(49.375,25.305),(49.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.645),(49.205,25.815),(49.375,25.815),(49.375,25.645),(49.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.645),(49.715,25.815),(49.885,25.815),(49.885,25.645),(49.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.305),(49.715,25.475),(49.885,25.475),(49.885,25.305),(49.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.025),(58.805,11.195),(58.975,11.195),(58.975,11.025),(58.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.705),(58.805,11.875),(58.975,11.875),(58.975,11.705),(58.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.365),(58.805,11.535),(58.975,11.535),(58.975,11.365),(58.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.385),(73.715,12.555),(73.885,12.555),(73.885,12.385),(73.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.385),(73.205,12.555),(73.375,12.555),(73.375,12.385),(73.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.865),(34.805,20.035),(34.975,20.035),(34.975,19.865),(34.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.485),(31.025,17.655),(31.195,17.655),(31.195,17.485),(31.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,34.145),(25.715,34.315),(25.885,34.315),(25.885,34.145),(25.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,34.485),(25.715,34.655),(25.885,34.655),(25.885,34.485),(25.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,34.145),(25.205,34.315),(25.375,34.315),(25.375,34.145),(25.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,34.485),(25.205,34.655),(25.375,34.655),(25.375,34.485),(25.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,34.825),(25.715,34.995),(25.885,34.995),(25.885,34.825),(25.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,34.825),(25.205,34.995),(25.375,34.995),(25.375,34.825),(25.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,22.585),(20.405,22.755),(20.575,22.755),(20.575,22.585),(20.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.985),(50.225,26.155),(50.395,26.155),(50.395,25.985),(50.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,24.965),(64.625,25.135),(64.795,25.135),(64.795,24.965),(64.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,24.965),(64.115,25.135),(64.285,25.135),(64.285,24.965),(64.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.645),(35.315,8.815),(35.485,8.815),(35.485,8.645),(35.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.645),(35.825,8.815),(35.995,8.815),(35.995,8.645),(35.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.185),(15.605,19.355),(15.775,19.355),(15.775,19.185),(15.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.525),(15.605,19.695),(15.775,19.695),(15.775,19.525),(15.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.205),(40.115,3.375),(40.285,3.375),(40.285,3.205),(40.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.205),(40.625,3.375),(40.795,3.375),(40.795,3.205),(40.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,40.265),(45.425,40.435),(45.595,40.435),(45.595,40.265),(45.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,39.925),(25.205,40.095),(25.375,40.095),(25.375,39.925),(25.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,40.605),(45.425,40.775),(45.595,40.775),(45.595,40.605),(45.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,39.925),(25.715,40.095),(25.885,40.095),(25.885,39.925),(25.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.465),(50.225,33.635),(50.395,33.635),(50.395,33.465),(50.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.805),(50.225,33.975),(50.395,33.975),(50.395,33.805),(50.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.665),(21.425,9.835),(21.595,9.835),(21.595,9.665),(21.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.125),(50.225,33.295),(50.395,33.295),(50.395,33.125),(50.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.325),(21.425,9.495),(21.595,9.495),(21.595,9.325),(21.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,27.345),(25.715,27.515),(25.885,27.515),(25.885,27.345),(25.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,27.345),(25.205,27.515),(25.375,27.515),(25.375,27.345),(25.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.225),(7.025,4.395),(7.195,4.395),(7.195,4.225),(7.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.565),(7.025,4.735),(7.195,4.735),(7.195,4.565),(7.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,34.145),(59.825,34.315),(59.995,34.315),(59.995,34.145),(59.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,34.485),(59.825,34.655),(59.995,34.655),(59.995,34.485),(59.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.825),(59.315,34.995),(59.485,34.995),(59.485,34.825),(59.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.485),(59.315,34.655),(59.485,34.655),(59.485,34.485),(59.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.225),(50.225,21.395),(50.395,21.395),(50.395,21.225),(50.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.145),(59.315,34.315),(59.485,34.315),(59.485,34.145),(59.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,28.705),(6.515,28.875),(6.685,28.875),(6.685,28.705),(6.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,34.825),(59.825,34.995),(59.995,34.995),(59.995,34.825),(59.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,28.025),(6.515,28.195),(6.685,28.195),(6.685,28.025),(6.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,28.365),(6.515,28.535),(6.685,28.535),(6.685,28.365),(6.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.565),(49.715,21.735),(49.885,21.735),(49.885,21.565),(49.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,24.965),(78.515,25.135),(78.685,25.135),(78.685,24.965),(78.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,24.965),(78.005,25.135),(78.175,25.135),(78.175,24.965),(78.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.565),(49.205,21.735),(49.375,21.735),(49.375,21.565),(49.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.225),(49.715,21.395),(49.885,21.395),(49.885,21.225),(49.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,27.345),(20.915,27.515),(21.085,27.515),(21.085,27.345),(20.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.225),(49.205,21.395),(49.375,21.395),(49.375,21.225),(49.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.865),(31.025,20.035),(31.195,20.035),(31.195,19.865),(31.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.965),(44.405,25.135),(44.575,25.135),(44.575,24.965),(44.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,31.765),(82.805,31.935),(82.975,31.935),(82.975,31.765),(82.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,31.085),(82.805,31.255),(82.975,31.255),(82.975,31.085),(82.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,31.425),(82.805,31.595),(82.975,31.595),(82.975,31.425),(82.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,23.605),(15.605,23.775),(15.775,23.775),(15.775,23.605),(15.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.205),(16.625,3.375),(16.795,3.375),(16.795,3.205),(16.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.545),(16.625,3.715),(16.795,3.715),(16.795,3.545),(16.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.565),(31.025,4.735),(31.195,4.735),(31.195,4.565),(31.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.305),(54.005,25.475),(54.175,25.475),(54.175,25.305),(54.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.645),(54.005,25.815),(54.175,25.815),(54.175,25.645),(54.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.305),(54.515,25.475),(54.685,25.475),(54.685,25.305),(54.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.645),(54.515,25.815),(54.685,25.815),(54.685,25.645),(54.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,30.405),(16.115,30.575),(16.285,30.575),(16.285,30.405),(16.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,30.405),(16.625,30.575),(16.795,30.575),(16.795,30.405),(16.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.965),(35.825,25.135),(35.995,25.135),(35.995,24.965),(35.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.965),(35.315,25.135),(35.485,25.135),(35.485,24.965),(35.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.645),(83.315,8.815),(83.485,8.815),(83.485,8.645),(83.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.865),(49.715,20.035),(49.885,20.035),(49.885,19.865),(49.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.865),(49.205,20.035),(49.375,20.035),(49.375,19.865),(49.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.205),(44.405,20.375),(44.575,20.375),(44.575,20.205),(44.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,39.925),(74.225,40.095),(74.395,40.095),(74.395,39.925),(74.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.545),(44.405,20.715),(44.575,20.715),(44.575,20.545),(44.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,20.885),(73.715,21.055),(73.885,21.055),(73.885,20.885),(73.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,20.885),(73.205,21.055),(73.375,21.055),(73.375,20.885),(73.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,21.565),(68.405,21.735),(68.575,21.735),(68.575,21.565),(68.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.525),(82.805,19.695),(82.975,19.695),(82.975,19.525),(82.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,31.765),(68.405,31.935),(68.575,31.935),(68.575,31.765),(68.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,31.085),(68.405,31.255),(68.575,31.255),(68.575,31.085),(68.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.105),(74.225,15.275),(74.395,15.275),(74.395,15.105),(74.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.445),(74.225,15.615),(74.395,15.615),(74.395,15.445),(74.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.545),(54.005,20.715),(54.175,20.715),(54.175,20.545),(54.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.545),(54.515,20.715),(54.685,20.715),(54.685,20.545),(54.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.225),(54.005,38.395),(54.175,38.395),(54.175,38.225),(54.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.225),(54.515,38.395),(54.685,38.395),(54.685,38.225),(54.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.565),(54.515,38.735),(54.685,38.735),(54.685,38.565),(54.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.565),(54.005,38.735),(54.175,38.735),(54.175,38.565),(54.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.105),(26.225,15.275),(26.395,15.275),(26.395,15.105),(26.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.845),(34.805,19.015),(34.975,19.015),(34.975,18.845),(34.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.105),(44.405,32.275),(44.575,32.275),(44.575,32.105),(44.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.445),(44.405,32.615),(44.575,32.615),(44.575,32.445),(44.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.785),(44.405,32.955),(44.575,32.955),(44.575,32.785),(44.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.105),(79.025,15.275),(79.195,15.275),(79.195,15.105),(79.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.445),(79.025,15.615),(79.195,15.615),(79.195,15.445),(79.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.605),(11.825,6.775),(11.995,6.775),(11.995,6.605),(11.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.605),(11.315,6.775),(11.485,6.775),(11.485,6.605),(11.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.685),(39.605,10.855),(39.775,10.855),(39.775,10.685),(39.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.005),(39.605,10.175),(39.775,10.175),(39.775,10.005),(39.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,24.965),(11.825,25.135),(11.995,25.135),(11.995,24.965),(11.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.405),(59.315,30.575),(59.485,30.575),(59.485,30.405),(59.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.565),(35.315,38.735),(35.485,38.735),(35.485,38.565),(35.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.225),(35.315,38.395),(35.485,38.395),(35.485,38.225),(35.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.225),(35.825,38.395),(35.995,38.395),(35.995,38.225),(35.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.565),(35.825,38.735),(35.995,38.735),(35.995,38.565),(35.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,30.405),(59.825,30.575),(59.995,30.575),(59.995,30.405),(59.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,24.965),(11.315,25.135),(11.485,25.135),(11.485,24.965),(11.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,29.045),(20.915,29.215),(21.085,29.215),(21.085,29.045),(20.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,29.725),(20.915,29.895),(21.085,29.895),(21.085,29.725),(20.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,29.385),(20.915,29.555),(21.085,29.555),(21.085,29.385),(20.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.265),(55.025,23.435),(55.195,23.435),(55.195,23.265),(55.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.605),(55.025,23.775),(55.195,23.775),(55.195,23.605),(55.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.465),(50.225,16.635),(50.395,16.635),(50.395,16.465),(50.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.385),(34.805,29.555),(34.975,29.555),(34.975,29.385),(34.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.245),(44.405,5.415),(44.575,5.415),(44.575,5.245),(44.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,37.205),(25.205,37.375),(25.375,37.375),(25.375,37.205),(25.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,37.545),(25.715,37.715),(25.885,37.715),(25.885,37.545),(25.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,37.205),(25.715,37.375),(25.885,37.375),(25.885,37.205),(25.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,37.545),(25.205,37.715),(25.375,37.715),(25.375,37.545),(25.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.925),(6.515,6.095),(6.685,6.095),(6.685,5.925),(6.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.525),(44.405,19.695),(44.575,19.695),(44.575,19.525),(44.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.185),(44.405,19.355),(44.575,19.355),(44.575,19.185),(44.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.965),(54.005,8.135),(54.175,8.135),(54.175,7.965),(54.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,25.645),(73.205,25.815),(73.375,25.815),(73.375,25.645),(73.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,25.645),(73.715,25.815),(73.885,25.815),(73.885,25.645),(73.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.965),(54.515,8.135),(54.685,8.135),(54.685,7.965),(54.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.865),(45.425,20.035),(45.595,20.035),(45.595,19.865),(45.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.005),(16.115,10.175),(16.285,10.175),(16.285,10.005),(16.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.005),(16.625,10.175),(16.795,10.175),(16.795,10.005),(16.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.685),(16.115,10.855),(16.285,10.855),(16.285,10.685),(16.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.685),(16.625,10.855),(16.795,10.855),(16.795,10.685),(16.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.785),(31.025,15.955),(31.195,15.955),(31.195,15.785),(31.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,39.925),(59.825,40.095),(59.995,40.095),(59.995,39.925),(59.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.925),(59.315,40.095),(59.485,40.095),(59.485,39.925),(59.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.865),(82.805,20.035),(82.975,20.035),(82.975,19.865),(82.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.205),(25.205,3.375),(25.375,3.375),(25.375,3.205),(25.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.205),(25.715,3.375),(25.885,3.375),(25.885,3.205),(25.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,38.905),(10.805,39.075),(10.975,39.075),(10.975,38.905),(10.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.545),(31.025,3.715),(31.195,3.715),(31.195,3.545),(31.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.265),(59.315,6.435),(59.485,6.435),(59.485,6.265),(59.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.265),(59.825,6.435),(59.995,6.435),(59.995,6.265),(59.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.605),(59.825,6.775),(59.995,6.775),(59.995,6.605),(59.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.605),(59.315,6.775),(59.485,6.775),(59.485,6.605),(59.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,36.525),(20.915,36.695),(21.085,36.695),(21.085,36.525),(20.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,40.605),(6.515,40.775),(6.685,40.775),(6.685,40.605),(6.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,40.265),(6.515,40.435),(6.685,40.435),(6.685,40.265),(6.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,36.185),(20.915,36.355),(21.085,36.355),(21.085,36.185),(20.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,22.585),(15.605,22.755),(15.775,22.755),(15.775,22.585),(15.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.765),(40.115,14.935),(40.285,14.935),(40.285,14.765),(40.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.965),(30.005,8.135),(30.175,8.135),(30.175,7.965),(30.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.585),(45.425,5.755),(45.595,5.755),(45.595,5.585),(45.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.085),(40.625,14.255),(40.795,14.255),(40.795,14.085),(40.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.765),(40.625,14.935),(40.795,14.935),(40.795,14.765),(40.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.965),(30.515,8.135),(30.685,8.135),(30.685,7.965),(30.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.085),(40.115,14.255),(40.285,14.255),(40.285,14.085),(40.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.205),(44.915,3.375),(45.085,3.375),(45.085,3.205),(44.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.545),(44.915,3.715),(45.085,3.715),(45.085,3.545),(44.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,28.705),(30.005,28.875),(30.175,28.875),(30.175,28.705),(30.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,28.025),(30.005,28.195),(30.175,28.195),(30.175,28.025),(30.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,28.365),(30.005,28.535),(30.175,28.535),(30.175,28.365),(30.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.805),(39.605,16.975),(39.775,16.975),(39.775,16.805),(39.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.125),(39.605,16.295),(39.775,16.295),(39.775,16.125),(39.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.465),(39.605,16.635),(39.775,16.635),(39.775,16.465),(39.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,30.405),(7.025,30.575),(7.195,30.575),(7.195,30.405),(7.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,30.065),(7.025,30.235),(7.195,30.235),(7.195,30.065),(7.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,30.745),(7.025,30.915),(7.195,30.915),(7.195,30.745),(7.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.245),(55.025,22.415),(55.195,22.415),(55.195,22.245),(55.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.585),(55.025,22.755),(55.195,22.755),(55.195,22.585),(55.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.865),(40.625,20.035),(40.795,20.035),(40.795,19.865),(40.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.865),(40.115,20.035),(40.285,20.035),(40.285,19.865),(40.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,22.925),(78.515,23.095),(78.685,23.095),(78.685,22.925),(78.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,22.925),(78.005,23.095),(78.175,23.095),(78.175,22.925),(78.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,24.965),(73.715,25.135),(73.885,25.135),(73.885,24.965),(73.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,24.965),(73.205,25.135),(73.375,25.135),(73.375,24.965),(73.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,27.685),(63.605,27.855),(63.775,27.855),(63.775,27.685),(63.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,27.005),(63.605,27.175),(63.775,27.175),(63.775,27.005),(63.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,27.345),(63.605,27.515),(63.775,27.515),(63.775,27.345),(63.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.665),(7.025,9.835),(7.195,9.835),(7.195,9.665),(7.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.425),(44.405,31.595),(44.575,31.595),(44.575,31.425),(44.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,40.265),(26.225,40.435),(26.395,40.435),(26.395,40.265),(26.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,40.605),(26.225,40.775),(26.395,40.775),(26.395,40.605),(26.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,31.425),(10.805,31.595),(10.975,31.595),(10.975,31.425),(10.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.445),(16.115,15.615),(16.285,15.615),(16.285,15.445),(16.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.105),(16.115,15.275),(16.285,15.275),(16.285,15.105),(16.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.645),(78.005,8.815),(78.175,8.815),(78.175,8.645),(78.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.645),(78.515,8.815),(78.685,8.815),(78.685,8.645),(78.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,35.165),(26.225,35.335),(26.395,35.335),(26.395,35.165),(26.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,35.505),(26.225,35.675),(26.395,35.675),(26.395,35.505),(26.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.225),(44.915,4.395),(45.085,4.395),(45.085,4.225),(44.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,25.985),(74.225,26.155),(74.395,26.155),(74.395,25.985),(74.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.545),(49.715,20.715),(49.885,20.715),(49.885,20.545),(49.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.205),(49.205,20.375),(49.375,20.375),(49.375,20.205),(49.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.545),(49.205,20.715),(49.375,20.715),(49.375,20.545),(49.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.005),(69.425,10.175),(69.595,10.175),(69.595,10.005),(69.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.685),(69.425,10.855),(69.595,10.855),(69.595,10.685),(69.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.205),(49.715,20.375),(49.885,20.375),(49.885,20.205),(49.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.945),(59.315,24.115),(59.485,24.115),(59.485,23.945),(59.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,23.945),(59.825,24.115),(59.995,24.115),(59.995,23.945),(59.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.505),(44.915,18.675),(45.085,18.675),(45.085,18.505),(44.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.005),(21.425,10.175),(21.595,10.175),(21.595,10.005),(21.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.345),(21.425,10.515),(21.595,10.515),(21.595,10.345),(21.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.685),(21.425,10.855),(21.595,10.855),(21.595,10.685),(21.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,21.225),(68.915,21.395),(69.085,21.395),(69.085,21.225),(68.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.185),(63.605,19.355),(63.775,19.355),(63.775,19.185),(63.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,30.405),(68.915,30.575),(69.085,30.575),(69.085,30.405),(68.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.525),(63.605,19.695),(63.775,19.695),(63.775,19.525),(63.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.925),(49.715,23.095),(49.885,23.095),(49.885,22.925),(49.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.925),(49.205,23.095),(49.375,23.095),(49.375,22.925),(49.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,35.845),(11.825,36.015),(11.995,36.015),(11.995,35.845),(11.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,35.845),(11.315,36.015),(11.485,36.015),(11.485,35.845),(11.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,30.745),(68.915,30.915),(69.085,30.915),(69.085,30.745),(68.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,30.065),(68.915,30.235),(69.085,30.235),(69.085,30.065),(68.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,23.605),(74.225,23.775),(74.395,23.775),(74.395,23.605),(74.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,23.265),(74.225,23.435),(74.395,23.435),(74.395,23.265),(74.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,24.965),(16.115,25.135),(16.285,25.135),(16.285,24.965),(16.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,24.965),(16.625,25.135),(16.795,25.135),(16.795,24.965),(16.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.465),(6.515,16.635),(6.685,16.635),(6.685,16.465),(6.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,24.965),(68.915,25.135),(69.085,25.135),(69.085,24.965),(68.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.825),(35.825,17.995),(35.995,17.995),(35.995,17.825),(35.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.145),(35.315,17.315),(35.485,17.315),(35.485,17.145),(35.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.825),(35.315,17.995),(35.485,17.995),(35.485,17.825),(35.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.145),(35.825,17.315),(35.995,17.315),(35.995,17.145),(35.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.965),(21.425,8.135),(21.595,8.135),(21.595,7.965),(21.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.165),(59.315,18.335),(59.485,18.335),(59.485,18.165),(59.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.165),(59.825,18.335),(59.995,18.335),(59.995,18.165),(59.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,35.165),(69.425,35.335),(69.595,35.335),(69.595,35.165),(69.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,35.505),(69.425,35.675),(69.595,35.675),(69.595,35.505),(69.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.945),(45.425,7.115),(45.595,7.115),(45.595,6.945),(45.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.485),(21.425,17.655),(21.595,17.655),(21.595,17.485),(21.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.585),(44.915,22.755),(45.085,22.755),(45.085,22.585),(44.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.245),(44.915,22.415),(45.085,22.415),(45.085,22.245),(44.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.005),(35.315,10.175),(35.485,10.175),(35.485,10.005),(35.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.685),(35.825,10.855),(35.995,10.855),(35.995,10.685),(35.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.685),(35.315,10.855),(35.485,10.855),(35.485,10.685),(35.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.005),(35.825,10.175),(35.995,10.175),(35.995,10.005),(35.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.665),(55.025,9.835),(55.195,9.835),(55.195,9.665),(55.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.985),(7.025,9.155),(7.195,9.155),(7.195,8.985),(7.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.985),(34.805,9.155),(34.975,9.155),(34.975,8.985),(34.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,29.725),(64.115,29.895),(64.285,29.895),(64.285,29.725),(64.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,29.725),(64.625,29.895),(64.795,29.895),(64.795,29.725),(64.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,29.045),(64.625,29.215),(64.795,29.215),(64.795,29.045),(64.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,29.385),(64.625,29.555),(64.795,29.555),(64.795,29.385),(64.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.565),(16.625,4.735),(16.795,4.735),(16.795,4.565),(16.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.565),(16.115,4.735),(16.285,4.735),(16.285,4.565),(16.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,29.045),(64.115,29.215),(64.285,29.215),(64.285,29.045),(64.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,29.385),(64.115,29.555),(64.285,29.555),(64.285,29.385),(64.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.145),(20.405,17.315),(20.575,17.315),(20.575,17.145),(20.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.485),(20.405,17.655),(20.575,17.655),(20.575,17.485),(20.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.545),(50.225,20.715),(50.395,20.715),(50.395,20.545),(50.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.205),(50.225,20.375),(50.395,20.375),(50.395,20.205),(50.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.825),(20.405,17.995),(20.575,17.995),(20.575,17.825),(20.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.545),(73.715,3.715),(73.885,3.715),(73.885,3.545),(73.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.545),(73.205,3.715),(73.375,3.715),(73.375,3.545),(73.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.405),(55.025,13.575),(55.195,13.575),(55.195,13.405),(55.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.985),(20.405,9.155),(20.575,9.155),(20.575,8.985),(20.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.585),(44.915,5.755),(45.085,5.755),(45.085,5.585),(44.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.845),(20.915,19.015),(21.085,19.015),(21.085,18.845),(20.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.885),(78.005,4.055),(78.175,4.055),(78.175,3.885),(78.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.885),(78.515,4.055),(78.685,4.055),(78.685,3.885),(78.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,21.565),(21.425,21.735),(21.595,21.735),(21.595,21.565),(21.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,37.885),(73.715,38.055),(73.885,38.055),(73.885,37.885),(73.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,37.885),(73.205,38.055),(73.375,38.055),(73.375,37.885),(73.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,2.865),(16.115,3.035),(16.285,3.035),(16.285,2.865),(16.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.425),(20.405,14.595),(20.575,14.595),(20.575,14.425),(20.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.405),(44.915,30.575),(45.085,30.575),(45.085,30.405),(44.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.885),(45.425,21.055),(45.595,21.055),(45.595,20.885),(45.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.865),(49.715,37.035),(49.885,37.035),(49.885,36.865),(49.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.865),(49.205,37.035),(49.375,37.035),(49.375,36.865),(49.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,40.265),(63.605,40.435),(63.775,40.435),(63.775,40.265),(63.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,40.605),(63.605,40.775),(63.775,40.775),(63.775,40.605),(63.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,25.985),(20.405,26.155),(20.575,26.155),(20.575,25.985),(20.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.125),(20.915,16.295),(21.085,16.295),(21.085,16.125),(20.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.805),(20.915,16.975),(21.085,16.975),(21.085,16.805),(20.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,20.885),(59.825,21.055),(59.995,21.055),(59.995,20.885),(59.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.885),(59.315,21.055),(59.485,21.055),(59.485,20.885),(59.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.925),(39.605,40.095),(39.775,40.095),(39.775,39.925),(39.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.845),(31.025,19.015),(31.195,19.015),(31.195,18.845),(31.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.325),(78.005,9.495),(78.175,9.495),(78.175,9.325),(78.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.325),(78.515,9.495),(78.685,9.495),(78.685,9.325),(78.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.125),(45.425,33.295),(45.595,33.295),(45.595,33.125),(45.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.465),(45.425,33.635),(45.595,33.635),(45.595,33.465),(45.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.805),(45.425,33.975),(45.595,33.975),(45.595,33.805),(45.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,27.685),(11.825,27.855),(11.995,27.855),(11.995,27.685),(11.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,27.685),(11.315,27.855),(11.485,27.855),(11.485,27.685),(11.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,27.005),(11.825,27.175),(11.995,27.175),(11.995,27.005),(11.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,27.005),(11.315,27.175),(11.485,27.175),(11.485,27.005),(11.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,27.345),(11.315,27.515),(11.485,27.515),(11.485,27.345),(11.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,27.345),(11.825,27.515),(11.995,27.515),(11.995,27.345),(11.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.685),(11.315,10.855),(11.485,10.855),(11.485,10.685),(11.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.685),(11.825,10.855),(11.995,10.855),(11.995,10.685),(11.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.005),(11.315,10.175),(11.485,10.175),(11.485,10.005),(11.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.005),(11.825,10.175),(11.995,10.175),(11.995,10.005),(11.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,22.925),(20.915,23.095),(21.085,23.095),(21.085,22.925),(20.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.265),(44.915,23.435),(45.085,23.435),(45.085,23.265),(44.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.605),(44.915,23.775),(45.085,23.775),(45.085,23.605),(44.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.125),(45.425,16.295),(45.595,16.295),(45.595,16.125),(45.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.805),(45.425,16.975),(45.595,16.975),(45.595,16.805),(45.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.465),(45.425,16.635),(45.595,16.635),(45.595,16.465),(45.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.945),(79.025,7.115),(79.195,7.115),(79.195,6.945),(79.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.905),(40.115,39.075),(40.285,39.075),(40.285,38.905),(40.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.905),(40.625,39.075),(40.795,39.075),(40.795,38.905),(40.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,40.605),(49.205,40.775),(49.375,40.775),(49.375,40.605),(49.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,40.265),(49.715,40.435),(49.885,40.435),(49.885,40.265),(49.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,40.605),(49.715,40.775),(49.885,40.775),(49.885,40.605),(49.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,40.265),(49.205,40.435),(49.375,40.435),(49.375,40.265),(49.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,2.865),(78.515,3.035),(78.685,3.035),(78.685,2.865),(78.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,36.185),(6.515,36.355),(6.685,36.355),(6.685,36.185),(6.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,2.865),(78.005,3.035),(78.175,3.035),(78.175,2.865),(78.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,36.525),(6.515,36.695),(6.685,36.695),(6.685,36.525),(6.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.345),(45.425,10.515),(45.595,10.515),(45.595,10.345),(45.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,24.965),(26.225,25.135),(26.395,25.135),(26.395,24.965),(26.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,27.005),(69.425,27.175),(69.595,27.175),(69.595,27.005),(69.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,27.345),(69.425,27.515),(69.595,27.515),(69.595,27.345),(69.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,27.685),(69.425,27.855),(69.595,27.855),(69.595,27.685),(69.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.385),(7.025,12.555),(7.195,12.555),(7.195,12.385),(7.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.045),(7.025,12.215),(7.195,12.215),(7.195,12.045),(7.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.725),(7.025,12.895),(7.195,12.895),(7.195,12.725),(7.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.105),(44.915,32.275),(45.085,32.275),(45.085,32.105),(44.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.445),(44.915,32.615),(45.085,32.615),(45.085,32.445),(44.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.785),(44.915,32.955),(45.085,32.955),(45.085,32.785),(44.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.085),(44.915,31.255),(45.085,31.255),(45.085,31.085),(44.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.765),(44.915,31.935),(45.085,31.935),(45.085,31.765),(44.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.725),(68.405,12.895),(68.575,12.895),(68.575,12.725),(68.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.045),(68.405,12.215),(68.575,12.215),(68.575,12.045),(68.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.965),(54.005,25.135),(54.175,25.135),(54.175,24.965),(54.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.965),(54.515,25.135),(54.685,25.135),(54.685,24.965),(54.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,36.185),(30.005,36.355),(30.175,36.355),(30.175,36.185),(30.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,36.525),(30.005,36.695),(30.175,36.695),(30.175,36.525),(30.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.045),(20.405,12.215),(20.575,12.215),(20.575,12.045),(20.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.385),(20.405,12.555),(20.575,12.555),(20.575,12.385),(20.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.725),(20.405,12.895),(20.575,12.895),(20.575,12.725),(20.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,38.905),(16.625,39.075),(16.795,39.075),(16.795,38.905),(16.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,25.305),(59.825,25.475),(59.995,25.475),(59.995,25.305),(59.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.605),(45.425,23.775),(45.595,23.775),(45.595,23.605),(45.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.305),(59.315,25.475),(59.485,25.475),(59.485,25.305),(59.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.965),(69.425,8.135),(69.595,8.135),(69.595,7.965),(69.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.665),(15.605,9.835),(15.775,9.835),(15.775,9.665),(15.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.325),(15.605,9.495),(15.775,9.495),(15.775,9.325),(15.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.685),(59.825,10.855),(59.995,10.855),(59.995,10.685),(59.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.005),(59.315,10.175),(59.485,10.175),(59.485,10.005),(59.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.685),(59.315,10.855),(59.485,10.855),(59.485,10.685),(59.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.005),(59.825,10.175),(59.995,10.175),(59.995,10.005),(59.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.425),(30.515,14.595),(30.685,14.595),(30.685,14.425),(30.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.085),(30.515,14.255),(30.685,14.255),(30.685,14.085),(30.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.465),(49.205,16.635),(49.375,16.635),(49.375,16.465),(49.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.465),(49.715,16.635),(49.885,16.635),(49.885,16.465),(49.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,32.445),(68.405,32.615),(68.575,32.615),(68.575,32.445),(68.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,32.105),(68.405,32.275),(68.575,32.275),(68.575,32.105),(68.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.765),(30.515,14.935),(30.685,14.935),(30.685,14.765),(30.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,32.785),(68.405,32.955),(68.575,32.955),(68.575,32.785),(68.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.505),(54.005,18.675),(54.175,18.675),(54.175,18.505),(54.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.505),(54.515,18.675),(54.685,18.675),(54.685,18.505),(54.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,25.985),(7.025,26.155),(7.195,26.155),(7.195,25.985),(7.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,40.265),(25.205,40.435),(25.375,40.435),(25.375,40.265),(25.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,40.605),(25.205,40.775),(25.375,40.775),(25.375,40.605),(25.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,40.605),(25.715,40.775),(25.885,40.775),(25.885,40.605),(25.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.945),(50.225,24.115),(50.395,24.115),(50.395,23.945),(50.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,40.265),(25.715,40.435),(25.885,40.435),(25.885,40.265),(25.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,38.225),(69.425,38.395),(69.595,38.395),(69.595,38.225),(69.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,38.565),(69.425,38.735),(69.595,38.735),(69.595,38.565),(69.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.165),(7.025,18.335),(7.195,18.335),(7.195,18.165),(7.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.505),(7.025,18.675),(7.195,18.675),(7.195,18.505),(7.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,29.385),(16.115,29.555),(16.285,29.555),(16.285,29.385),(16.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,29.045),(16.625,29.215),(16.795,29.215),(16.795,29.045),(16.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,36.865),(73.205,37.035),(73.375,37.035),(73.375,36.865),(73.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,36.865),(73.715,37.035),(73.885,37.035),(73.885,36.865),(73.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,29.045),(16.115,29.215),(16.285,29.215),(16.285,29.045),(16.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,29.725),(16.115,29.895),(16.285,29.895),(16.285,29.725),(16.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,29.725),(16.625,29.895),(16.795,29.895),(16.795,29.725),(16.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,29.385),(16.625,29.555),(16.795,29.555),(16.795,29.385),(16.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.245),(55.025,39.415),(55.195,39.415),(55.195,39.245),(55.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.585),(55.025,39.755),(55.195,39.755),(55.195,39.585),(55.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,21.905),(16.115,22.075),(16.285,22.075),(16.285,21.905),(16.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.425),(58.805,14.595),(58.975,14.595),(58.975,14.425),(58.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.345),(45.425,27.515),(45.595,27.515),(45.595,27.345),(45.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.685),(45.425,27.855),(45.595,27.855),(45.595,27.685),(45.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.005),(45.425,27.175),(45.595,27.175),(45.595,27.005),(45.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.765),(10.805,14.935),(10.975,14.935),(10.975,14.765),(10.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.085),(10.805,14.255),(10.975,14.255),(10.975,14.085),(10.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.765),(68.405,14.935),(68.575,14.935),(68.575,14.765),(68.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.085),(68.405,14.255),(68.575,14.255),(68.575,14.085),(68.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.425),(68.405,14.595),(68.575,14.595),(68.575,14.425),(68.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.485),(50.225,17.655),(50.395,17.655),(50.395,17.485),(50.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.145),(50.225,17.315),(50.395,17.315),(50.395,17.145),(50.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.825),(50.225,17.995),(50.395,17.995),(50.395,17.825),(50.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,35.845),(82.805,36.015),(82.975,36.015),(82.975,35.845),(82.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,20.205),(21.425,20.375),(21.595,20.375),(21.595,20.205),(21.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,20.545),(21.425,20.715),(21.595,20.715),(21.595,20.545),(21.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,35.845),(20.915,36.015),(21.085,36.015),(21.085,35.845),(20.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,38.225),(68.405,38.395),(68.575,38.395),(68.575,38.225),(68.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,38.565),(68.405,38.735),(68.575,38.735),(68.575,38.565),(68.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,29.725),(82.805,29.895),(82.975,29.895),(82.975,29.725),(82.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,29.045),(82.805,29.215),(82.975,29.215),(82.975,29.045),(82.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,40.265),(44.915,40.435),(45.085,40.435),(45.085,40.265),(44.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,40.605),(44.915,40.775),(45.085,40.775),(45.085,40.605),(44.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,34.825),(83.315,34.995),(83.485,34.995),(83.485,34.825),(83.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,34.485),(83.315,34.655),(83.485,34.655),(83.485,34.485),(83.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,34.145),(83.315,34.315),(83.485,34.315),(83.485,34.145),(83.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.645),(44.915,25.815),(45.085,25.815),(45.085,25.645),(44.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.245),(31.025,39.415),(31.195,39.415),(31.195,39.245),(31.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,21.905),(25.205,22.075),(25.375,22.075),(25.375,21.905),(25.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,21.905),(25.715,22.075),(25.885,22.075),(25.885,21.905),(25.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.985),(15.605,9.155),(15.775,9.155),(15.775,8.985),(15.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.585),(31.025,39.755),(31.195,39.755),(31.195,39.585),(31.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,39.585),(73.715,39.755),(73.885,39.755),(73.885,39.585),(73.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,39.245),(73.205,39.415),(73.375,39.415),(73.375,39.245),(73.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,39.585),(73.205,39.755),(73.375,39.755),(73.375,39.585),(73.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,39.245),(73.715,39.415),(73.885,39.415),(73.885,39.245),(73.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,25.305),(68.915,25.475),(69.085,25.475),(69.085,25.305),(68.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,25.645),(68.915,25.815),(69.085,25.815),(69.085,25.645),(68.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.245),(45.425,22.415),(45.595,22.415),(45.595,22.245),(45.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,22.925),(30.005,23.095),(30.175,23.095),(30.175,22.925),(30.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,24.625),(7.025,24.795),(7.195,24.795),(7.195,24.625),(7.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,23.265),(25.205,23.435),(25.375,23.435),(25.375,23.265),(25.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,23.265),(25.715,23.435),(25.885,23.435),(25.885,23.265),(25.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.385),(6.515,12.555),(6.685,12.555),(6.685,12.385),(6.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.725),(6.515,12.895),(6.685,12.895),(6.685,12.725),(6.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.045),(6.515,12.215),(6.685,12.215),(6.685,12.045),(6.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,32.445),(25.715,32.615),(25.885,32.615),(25.885,32.445),(25.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,32.445),(25.205,32.615),(25.375,32.615),(25.375,32.445),(25.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,32.105),(25.715,32.275),(25.885,32.275),(25.885,32.105),(25.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,32.105),(25.205,32.275),(25.375,32.275),(25.375,32.105),(25.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,32.785),(25.205,32.955),(25.375,32.955),(25.375,32.785),(25.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,32.785),(25.715,32.955),(25.885,32.955),(25.885,32.785),(25.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.945),(55.025,24.115),(55.195,24.115),(55.195,23.945),(55.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.465),(55.025,16.635),(55.195,16.635),(55.195,16.465),(55.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.245),(34.805,5.415),(34.975,5.415),(34.975,5.245),(34.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.845),(82.805,19.015),(82.975,19.015),(82.975,18.845),(82.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.245),(50.225,39.415),(50.395,39.415),(50.395,39.245),(50.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.585),(50.225,39.755),(50.395,39.755),(50.395,39.585),(50.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.365),(7.025,11.535),(7.195,11.535),(7.195,11.365),(7.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.025),(7.025,11.195),(7.195,11.195),(7.195,11.025),(7.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.705),(7.025,11.875),(7.195,11.875),(7.195,11.705),(7.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,22.245),(63.605,22.415),(63.775,22.415),(63.775,22.245),(63.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,29.385),(10.805,29.555),(10.975,29.555),(10.975,29.385),(10.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.885),(15.605,4.055),(15.775,4.055),(15.775,3.885),(15.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.345),(50.225,27.515),(50.395,27.515),(50.395,27.345),(50.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.405),(74.225,13.575),(74.395,13.575),(74.395,13.405),(74.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.785),(39.605,15.955),(39.775,15.955),(39.775,15.785),(39.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.365),(68.405,11.535),(68.575,11.535),(68.575,11.365),(68.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.445),(82.805,15.615),(82.975,15.615),(82.975,15.445),(82.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.365),(20.405,11.535),(20.575,11.535),(20.575,11.365),(20.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.025),(20.405,11.195),(20.575,11.195),(20.575,11.025),(20.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.705),(20.405,11.875),(20.575,11.875),(20.575,11.705),(20.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.785),(25.205,15.955),(25.375,15.955),(25.375,15.785),(25.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.785),(25.715,15.955),(25.885,15.955),(25.885,15.785),(25.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.905),(7.025,5.075),(7.195,5.075),(7.195,4.905),(7.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.385),(54.515,12.555),(54.685,12.555),(54.685,12.385),(54.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.385),(54.005,12.555),(54.175,12.555),(54.175,12.385),(54.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.165),(20.405,18.335),(20.575,18.335),(20.575,18.165),(20.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.025),(49.715,11.195),(49.885,11.195),(49.885,11.025),(49.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.365),(49.205,11.535),(49.375,11.535),(49.375,11.365),(49.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.365),(49.715,11.535),(49.885,11.535),(49.885,11.365),(49.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.025),(49.205,11.195),(49.375,11.195),(49.375,11.025),(49.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.705),(49.205,11.875),(49.375,11.875),(49.375,11.705),(49.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.705),(49.715,11.875),(49.885,11.875),(49.885,11.705),(49.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.025),(55.025,11.195),(55.195,11.195),(55.195,11.025),(55.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.705),(55.025,11.875),(55.195,11.875),(55.195,11.705),(55.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,22.585),(6.515,22.755),(6.685,22.755),(6.685,22.585),(6.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.385),(15.605,12.555),(15.775,12.555),(15.775,12.385),(15.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.345),(20.915,10.515),(21.085,10.515),(21.085,10.345),(20.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.165),(59.315,35.335),(59.485,35.335),(59.485,35.165),(59.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.505),(59.315,35.675),(59.485,35.675),(59.485,35.505),(59.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.825),(39.605,17.995),(39.775,17.995),(39.775,17.825),(39.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.485),(39.605,17.655),(39.775,17.655),(39.775,17.485),(39.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.145),(39.605,17.315),(39.775,17.315),(39.775,17.145),(39.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,35.165),(59.825,35.335),(59.995,35.335),(59.995,35.165),(59.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,35.505),(59.825,35.675),(59.995,35.675),(59.995,35.505),(59.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.645),(31.025,8.815),(31.195,8.815),(31.195,8.645),(31.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,38.565),(7.025,38.735),(7.195,38.735),(7.195,38.565),(7.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,38.225),(7.025,38.395),(7.195,38.395),(7.195,38.225),(7.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,37.885),(16.625,38.055),(16.795,38.055),(16.795,37.885),(16.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.165),(73.205,18.335),(73.375,18.335),(73.375,18.165),(73.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.165),(73.715,18.335),(73.885,18.335),(73.885,18.165),(73.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.385),(40.115,29.555),(40.285,29.555),(40.285,29.385),(40.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.385),(40.625,29.555),(40.795,29.555),(40.795,29.385),(40.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.185),(54.005,19.355),(54.175,19.355),(54.175,19.185),(54.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.525),(54.005,19.695),(54.175,19.695),(54.175,19.525),(54.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.525),(54.515,19.695),(54.685,19.695),(54.685,19.525),(54.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,21.565),(7.025,21.735),(7.195,21.735),(7.195,21.565),(7.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.885),(44.405,21.055),(44.575,21.055),(44.575,20.885),(44.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,39.585),(74.225,39.755),(74.395,39.755),(74.395,39.585),(74.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,39.245),(74.225,39.415),(74.395,39.415),(74.395,39.245),(74.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.865),(20.915,20.035),(21.085,20.035),(21.085,19.865),(20.915,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,33.805),(83.315,33.975),(83.485,33.975),(83.485,33.805),(83.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,33.125),(83.315,33.295),(83.485,33.295),(83.485,33.125),(83.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,33.465),(83.315,33.635),(83.485,33.635),(83.485,33.465),(83.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.825),(44.405,34.995),(44.575,34.995),(44.575,34.825),(44.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.485),(44.405,34.655),(44.575,34.655),(44.575,34.485),(44.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.145),(44.405,34.315),(44.575,34.315),(44.575,34.145),(44.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.905),(54.005,39.075),(54.175,39.075),(54.175,38.905),(54.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.905),(54.515,39.075),(54.685,39.075),(54.685,38.905),(54.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.965),(83.315,8.135),(83.485,8.135),(83.485,7.965),(83.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,22.245),(10.805,22.415),(10.975,22.415),(10.975,22.245),(10.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.605),(69.425,6.775),(69.595,6.775),(69.595,6.605),(69.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.265),(69.425,6.435),(69.595,6.435),(69.595,6.265),(69.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.545),(34.805,3.715),(34.975,3.715),(34.975,3.545),(34.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.145),(39.605,34.315),(39.775,34.315),(39.775,34.145),(39.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.485),(39.605,34.655),(39.775,34.655),(39.775,34.485),(39.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.825),(39.605,34.995),(39.775,34.995),(39.775,34.825),(39.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.605),(21.425,6.775),(21.595,6.775),(21.595,6.605),(21.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.265),(21.425,6.435),(21.595,6.435),(21.595,6.265),(21.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,31.765),(78.515,31.935),(78.685,31.935),(78.685,31.765),(78.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,31.765),(78.005,31.935),(78.175,31.935),(78.175,31.765),(78.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,33.125),(69.425,33.295),(69.595,33.295),(69.595,33.125),(69.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,33.465),(69.425,33.635),(69.595,33.635),(69.595,33.465),(69.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,31.085),(78.515,31.255),(78.685,31.255),(78.685,31.085),(78.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,31.085),(78.005,31.255),(78.175,31.255),(78.175,31.085),(78.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,33.805),(69.425,33.975),(69.595,33.975),(69.595,33.805),(69.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,31.425),(64.625,31.595),(64.795,31.595),(64.795,31.425),(64.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,31.425),(64.115,31.595),(64.285,31.595),(64.285,31.425),(64.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.525),(59.825,19.695),(59.995,19.695),(59.995,19.525),(59.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.525),(59.315,19.695),(59.485,19.695),(59.485,19.525),(59.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.625),(44.405,7.795),(44.575,7.795),(44.575,7.625),(44.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.905),(35.315,39.075),(35.485,39.075),(35.485,38.905),(35.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.905),(35.825,39.075),(35.995,39.075),(35.995,38.905),(35.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.865),(7.025,20.035),(7.195,20.035),(7.195,19.865),(7.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,34.825),(10.805,34.995),(10.975,34.995),(10.975,34.825),(10.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,34.145),(10.805,34.315),(10.975,34.315),(10.975,34.145),(10.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,34.485),(10.805,34.655),(10.975,34.655),(10.975,34.485),(10.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,39.245),(20.405,39.415),(20.575,39.415),(20.575,39.245),(20.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,39.585),(20.405,39.755),(20.575,39.755),(20.575,39.585),(20.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.725),(63.605,12.895),(63.775,12.895),(63.775,12.725),(63.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.045),(63.605,12.215),(63.775,12.215),(63.775,12.045),(63.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,38.225),(78.005,38.395),(78.175,38.395),(78.175,38.225),(78.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,38.225),(78.515,38.395),(78.685,38.395),(78.685,38.225),(78.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,38.565),(78.515,38.735),(78.685,38.735),(78.685,38.565),(78.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.025),(44.405,11.195),(44.575,11.195),(44.575,11.025),(44.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,38.565),(78.005,38.735),(78.175,38.735),(78.175,38.565),(78.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.705),(44.405,11.875),(44.575,11.875),(44.575,11.705),(44.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.025),(35.825,11.195),(35.995,11.195),(35.995,11.025),(35.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.025),(35.315,11.195),(35.485,11.195),(35.485,11.025),(35.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.705),(35.315,11.875),(35.485,11.875),(35.485,11.705),(35.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.705),(35.825,11.875),(35.995,11.875),(35.995,11.705),(35.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.285),(54.005,7.455),(54.175,7.455),(54.175,7.285),(54.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.285),(54.515,7.455),(54.685,7.455),(54.685,7.285),(54.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.605),(20.405,6.775),(20.575,6.775),(20.575,6.605),(20.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.625),(6.515,7.795),(6.685,7.795),(6.685,7.625),(6.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.025),(15.605,11.195),(15.775,11.195),(15.775,11.025),(15.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.365),(15.605,11.535),(15.775,11.535),(15.775,11.365),(15.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.705),(15.605,11.875),(15.775,11.875),(15.775,11.705),(15.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,32.445),(68.915,32.615),(69.085,32.615),(69.085,32.445),(68.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,32.785),(68.915,32.955),(69.085,32.955),(69.085,32.785),(68.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,32.105),(68.915,32.275),(69.085,32.275),(69.085,32.105),(68.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,23.605),(11.825,23.775),(11.995,23.775),(11.995,23.605),(11.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,23.265),(11.315,23.435),(11.485,23.435),(11.485,23.265),(11.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,23.605),(11.315,23.775),(11.485,23.775),(11.485,23.605),(11.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,23.265),(11.825,23.435),(11.995,23.435),(11.995,23.265),(11.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.565),(35.315,21.735),(35.485,21.735),(35.485,21.565),(35.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.565),(35.825,21.735),(35.995,21.735),(35.995,21.565),(35.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.945),(59.315,7.115),(59.485,7.115),(59.485,6.945),(59.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.945),(59.825,7.115),(59.995,7.115),(59.995,6.945),(59.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.885),(34.805,4.055),(34.975,4.055),(34.975,3.885),(34.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.365),(21.425,11.535),(21.595,11.535),(21.595,11.365),(21.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.025),(21.425,11.195),(21.595,11.195),(21.595,11.025),(21.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.705),(21.425,11.875),(21.595,11.875),(21.595,11.705),(21.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.285),(30.005,7.455),(30.175,7.455),(30.175,7.285),(30.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.285),(30.515,7.455),(30.685,7.455),(30.685,7.285),(30.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.665),(50.225,9.835),(50.395,9.835),(50.395,9.665),(50.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,33.805),(15.605,33.975),(15.775,33.975),(15.775,33.805),(15.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,33.125),(15.605,33.295),(15.775,33.295),(15.775,33.125),(15.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.465),(10.805,16.635),(10.975,16.635),(10.975,16.465),(10.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,33.465),(15.605,33.635),(15.775,33.635),(15.775,33.465),(15.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.925),(55.025,23.095),(55.195,23.095),(55.195,22.925),(55.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.065),(54.005,13.235),(54.175,13.235),(54.175,13.065),(54.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.745),(54.005,13.915),(54.175,13.915),(54.175,13.745),(54.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.745),(54.515,13.915),(54.685,13.915),(54.685,13.745),(54.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.525),(40.115,19.695),(40.285,19.695),(40.285,19.525),(40.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.525),(40.625,19.695),(40.795,19.695),(40.795,19.525),(40.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.185),(40.625,19.355),(40.795,19.355),(40.795,19.185),(40.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,32.445),(16.115,32.615),(16.285,32.615),(16.285,32.445),(16.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,32.105),(16.115,32.275),(16.285,32.275),(16.285,32.105),(16.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,32.445),(16.625,32.615),(16.795,32.615),(16.795,32.445),(16.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,32.785),(16.115,32.955),(16.285,32.955),(16.285,32.785),(16.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,32.105),(16.625,32.275),(16.795,32.275),(16.795,32.105),(16.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,32.785),(16.625,32.955),(16.795,32.955),(16.795,32.785),(16.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.985),(20.915,9.155),(21.085,9.155),(21.085,8.985),(20.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,20.545),(7.025,20.715),(7.195,20.715),(7.195,20.545),(7.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.865),(21.425,20.035),(21.595,20.035),(21.595,19.865),(21.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,20.205),(7.025,20.375),(7.195,20.375),(7.195,20.205),(7.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.265),(44.915,6.435),(45.085,6.435),(45.085,6.265),(44.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.605),(44.915,6.775),(45.085,6.775),(45.085,6.605),(44.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.165),(15.605,18.335),(15.775,18.335),(15.775,18.165),(15.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.505),(15.605,18.675),(15.775,18.675),(15.775,18.505),(15.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,34.145),(30.005,34.315),(30.175,34.315),(30.175,34.145),(30.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,34.485),(30.005,34.655),(30.175,34.655),(30.175,34.485),(30.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,34.825),(30.005,34.995),(30.175,34.995),(30.175,34.825),(30.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.925),(44.915,40.095),(45.085,40.095),(45.085,39.925),(44.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.285),(39.605,7.455),(39.775,7.455),(39.775,7.285),(39.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,26.665),(58.805,26.835),(58.975,26.835),(58.975,26.665),(58.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.005),(44.915,10.175),(45.085,10.175),(45.085,10.005),(44.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.685),(44.915,10.855),(45.085,10.855),(45.085,10.685),(44.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.885),(49.715,21.055),(49.885,21.055),(49.885,20.885),(49.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.885),(49.205,21.055),(49.375,21.055),(49.375,20.885),(49.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.285),(82.805,7.455),(82.975,7.455),(82.975,7.285),(82.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.085),(30.515,31.255),(30.685,31.255),(30.685,31.085),(30.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.425),(30.515,31.595),(30.685,31.595),(30.685,31.425),(30.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.765),(30.515,31.935),(30.685,31.935),(30.685,31.765),(30.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.925),(83.315,6.095),(83.485,6.095),(83.485,5.925),(83.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,21.905),(68.915,22.075),(69.085,22.075),(69.085,21.905),(68.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.205),(58.805,37.375),(58.975,37.375),(58.975,37.205),(58.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.545),(58.805,37.715),(58.975,37.715),(58.975,37.545),(58.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.225),(34.805,4.395),(34.975,4.395),(34.975,4.225),(34.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.565),(34.805,4.735),(34.975,4.735),(34.975,4.565),(34.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,26.325),(25.715,26.495),(25.885,26.495),(25.885,26.325),(25.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,26.325),(25.205,26.495),(25.375,26.495),(25.375,26.325),(25.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,29.045),(78.515,29.215),(78.685,29.215),(78.685,29.045),(78.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,29.045),(78.005,29.215),(78.175,29.215),(78.175,29.045),(78.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,29.725),(78.515,29.895),(78.685,29.895),(78.685,29.725),(78.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,29.725),(78.005,29.895),(78.175,29.895),(78.175,29.725),(78.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,24.285),(68.915,24.455),(69.085,24.455),(69.085,24.285),(68.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,24.625),(68.915,24.795),(69.085,24.795),(69.085,24.625),(68.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.025),(59.315,11.195),(59.485,11.195),(59.485,11.025),(59.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.365),(59.315,11.535),(59.485,11.535),(59.485,11.365),(59.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.705),(59.315,11.875),(59.485,11.875),(59.485,11.705),(59.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.025),(59.825,11.195),(59.995,11.195),(59.995,11.025),(59.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.365),(59.825,11.535),(59.995,11.535),(59.995,11.365),(59.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.925),(55.025,40.095),(55.195,40.095),(55.195,39.925),(55.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.705),(59.825,11.875),(59.995,11.875),(59.995,11.705),(59.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.845),(59.825,19.015),(59.995,19.015),(59.995,18.845),(59.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.845),(59.315,19.015),(59.485,19.015),(59.485,18.845),(59.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.165),(58.805,18.335),(58.975,18.335),(58.975,18.165),(58.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.505),(58.805,18.675),(58.975,18.675),(58.975,18.505),(58.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.665),(20.915,9.835),(21.085,9.835),(21.085,9.665),(20.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.325),(20.915,9.495),(21.085,9.495),(21.085,9.325),(20.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.365),(11.825,11.535),(11.995,11.535),(11.995,11.365),(11.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.365),(11.315,11.535),(11.485,11.535),(11.485,11.365),(11.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.285),(58.805,7.455),(58.975,7.455),(58.975,7.285),(58.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.525),(20.405,19.695),(20.575,19.695),(20.575,19.525),(20.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.865),(73.205,20.035),(73.375,20.035),(73.375,19.865),(73.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.285),(34.805,7.455),(34.975,7.455),(34.975,7.285),(34.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.605),(68.405,6.775),(68.575,6.775),(68.575,6.605),(68.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.865),(73.715,20.035),(73.885,20.035),(73.885,19.865),(73.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,30.405),(20.405,30.575),(20.575,30.575),(20.575,30.405),(20.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.285),(44.915,7.455),(45.085,7.455),(45.085,7.285),(44.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.865),(16.625,20.035),(16.795,20.035),(16.795,19.865),(16.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,21.225),(78.515,21.395),(78.685,21.395),(78.685,21.225),(78.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,21.225),(78.005,21.395),(78.175,21.395),(78.175,21.225),(78.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,21.565),(78.515,21.735),(78.685,21.735),(78.685,21.565),(78.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,21.565),(78.005,21.735),(78.175,21.735),(78.175,21.565),(78.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.885),(50.225,21.055),(50.395,21.055),(50.395,20.885),(50.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.165),(20.915,18.335),(21.085,18.335),(21.085,18.165),(20.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,37.205),(68.915,37.375),(69.085,37.375),(69.085,37.205),(68.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,37.545),(68.915,37.715),(69.085,37.715),(69.085,37.545),(68.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.605),(40.115,6.775),(40.285,6.775),(40.285,6.605),(40.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.605),(40.625,6.775),(40.795,6.775),(40.795,6.605),(40.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.065),(45.425,13.235),(45.595,13.235),(45.595,13.065),(45.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.745),(45.425,13.915),(45.595,13.915),(45.595,13.745),(45.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.925),(31.025,40.095),(31.195,40.095),(31.195,39.925),(31.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,37.205),(73.205,37.375),(73.375,37.375),(73.375,37.205),(73.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,37.545),(73.715,37.715),(73.885,37.715),(73.885,37.545),(73.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,37.205),(73.715,37.375),(73.885,37.375),(73.885,37.205),(73.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,37.545),(73.205,37.715),(73.375,37.715),(73.375,37.545),(73.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.365),(69.425,11.535),(69.595,11.535),(69.595,11.365),(69.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,39.925),(73.205,40.095),(73.375,40.095),(73.375,39.925),(73.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,39.925),(73.715,40.095),(73.885,40.095),(73.885,39.925),(73.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.285),(83.315,7.455),(83.485,7.455),(83.485,7.285),(83.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.565),(78.515,4.735),(78.685,4.735),(78.685,4.565),(78.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.565),(78.005,4.735),(78.175,4.735),(78.175,4.565),(78.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.645),(16.625,8.815),(16.795,8.815),(16.795,8.645),(16.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.645),(16.115,8.815),(16.285,8.815),(16.285,8.645),(16.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,23.945),(25.715,24.115),(25.885,24.115),(25.885,23.945),(25.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,23.945),(25.205,24.115),(25.375,24.115),(25.375,23.945),(25.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.145),(78.005,17.315),(78.175,17.315),(78.175,17.145),(78.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.825),(78.515,17.995),(78.685,17.995),(78.685,17.825),(78.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.145),(78.515,17.315),(78.685,17.315),(78.685,17.145),(78.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.785),(69.425,15.955),(69.595,15.955),(69.595,15.785),(69.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.825),(78.005,17.995),(78.175,17.995),(78.175,17.825),(78.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.065),(34.805,13.235),(34.975,13.235),(34.975,13.065),(34.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.745),(34.805,13.915),(34.975,13.915),(34.975,13.745),(34.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.225),(44.405,21.395),(44.575,21.395),(44.575,21.225),(44.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,36.185),(15.605,36.355),(15.775,36.355),(15.775,36.185),(15.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,36.525),(15.605,36.695),(15.775,36.695),(15.775,36.525),(15.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.185),(39.605,19.355),(39.775,19.355),(39.775,19.185),(39.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,22.245),(20.915,22.415),(21.085,22.415),(21.085,22.245),(20.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.805),(30.005,16.975),(30.175,16.975),(30.175,16.805),(30.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.465),(30.005,16.635),(30.175,16.635),(30.175,16.465),(30.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,28.705),(10.805,28.875),(10.975,28.875),(10.975,28.705),(10.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.125),(30.005,16.295),(30.175,16.295),(30.175,16.125),(30.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.465),(68.405,16.635),(68.575,16.635),(68.575,16.465),(68.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,29.385),(26.225,29.555),(26.395,29.555),(26.395,29.385),(26.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,23.945),(6.515,24.115),(6.685,24.115),(6.685,23.945),(6.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,29.385),(15.605,29.555),(15.775,29.555),(15.775,29.385),(15.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,24.285),(20.405,24.455),(20.575,24.455),(20.575,24.285),(20.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,36.865),(6.515,37.035),(6.685,37.035),(6.685,36.865),(6.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.145),(44.915,34.315),(45.085,34.315),(45.085,34.145),(44.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.485),(44.915,34.655),(45.085,34.655),(45.085,34.485),(44.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.825),(44.915,34.995),(45.085,34.995),(45.085,34.825),(44.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.645),(44.405,25.815),(44.575,25.815),(44.575,25.645),(44.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,39.245),(11.825,39.415),(11.995,39.415),(11.995,39.245),(11.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,39.585),(11.825,39.755),(11.995,39.755),(11.995,39.585),(11.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,39.245),(11.315,39.415),(11.485,39.415),(11.485,39.245),(11.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,39.585),(11.315,39.755),(11.485,39.755),(11.485,39.585),(11.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.605),(64.115,6.775),(64.285,6.775),(64.285,6.605),(64.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.605),(64.625,6.775),(64.795,6.775),(64.795,6.605),(64.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,21.44),(85.76,21.61),(85.93,21.61),(85.93,21.44),(85.76,21.44)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.265),(15.605,6.435),(15.775,6.435),(15.775,6.265),(15.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,25.305),(68.405,25.475),(68.575,25.475),(68.575,25.305),(68.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.925),(50.225,6.095),(50.395,6.095),(50.395,5.925),(50.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.545),(35.825,20.715),(35.995,20.715),(35.995,20.545),(35.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.545),(35.315,20.715),(35.485,20.715),(35.485,20.545),(35.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,31.425),(16.625,31.595),(16.795,31.595),(16.795,31.425),(16.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,31.085),(16.115,31.255),(16.285,31.255),(16.285,31.085),(16.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,31.765),(16.115,31.935),(16.285,31.935),(16.285,31.765),(16.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.525),(44.915,19.695),(45.085,19.695),(45.085,19.525),(44.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.225),(50.225,38.395),(50.395,38.395),(50.395,38.225),(50.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.565),(50.225,38.735),(50.395,38.735),(50.395,38.565),(50.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.745),(16.115,13.915),(16.285,13.915),(16.285,13.745),(16.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.405),(16.115,13.575),(16.285,13.575),(16.285,13.405),(16.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.065),(16.115,13.235),(16.285,13.235),(16.285,13.065),(16.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.785),(45.425,15.955),(45.595,15.955),(45.595,15.785),(45.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,36.865),(30.005,37.035),(30.175,37.035),(30.175,36.865),(30.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.485),(15.605,17.655),(15.775,17.655),(15.775,17.485),(15.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.325),(44.915,9.495),(45.085,9.495),(45.085,9.325),(44.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.665),(44.915,9.835),(45.085,9.835),(45.085,9.665),(44.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.645),(45.425,25.815),(45.595,25.815),(45.595,25.645),(45.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.005),(63.605,10.175),(63.775,10.175),(63.775,10.005),(63.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.345),(63.605,10.515),(63.775,10.515),(63.775,10.345),(63.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.685),(63.605,10.855),(63.775,10.855),(63.775,10.685),(63.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.325),(68.915,9.495),(69.085,9.495),(69.085,9.325),(68.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.925),(74.225,6.095),(74.395,6.095),(74.395,5.925),(74.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.425),(54.515,31.595),(54.685,31.595),(54.685,31.425),(54.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.425),(54.005,31.595),(54.175,31.595),(54.175,31.425),(54.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,25.305),(7.025,25.475),(7.195,25.475),(7.195,25.305),(7.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,25.645),(7.025,25.815),(7.195,25.815),(7.195,25.645),(7.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,38.905),(69.425,39.075),(69.595,39.075),(69.595,38.905),(69.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.605),(50.225,23.775),(50.395,23.775),(50.395,23.605),(50.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.265),(50.225,23.435),(50.395,23.435),(50.395,23.265),(50.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.845),(7.025,19.015),(7.195,19.015),(7.195,18.845),(7.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.805),(73.715,16.975),(73.885,16.975),(73.885,16.805),(73.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.805),(73.205,16.975),(73.375,16.975),(73.375,16.805),(73.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.125),(73.715,16.295),(73.885,16.295),(73.885,16.125),(73.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.125),(73.205,16.295),(73.375,16.295),(73.375,16.125),(73.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,29.385),(25.715,29.555),(25.885,29.555),(25.885,29.385),(25.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,29.385),(25.205,29.555),(25.375,29.555),(25.375,29.385),(25.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,29.045),(25.205,29.215),(25.375,29.215),(25.375,29.045),(25.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,29.045),(25.715,29.215),(25.885,29.215),(25.885,29.045),(25.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,29.725),(25.715,29.895),(25.885,29.895),(25.885,29.725),(25.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,29.725),(25.205,29.895),(25.375,29.895),(25.375,29.725),(25.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.405),(82.805,13.575),(82.975,13.575),(82.975,13.405),(82.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.565),(34.805,21.735),(34.975,21.735),(34.975,21.565),(34.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,35.845),(16.625,36.015),(16.795,36.015),(16.795,35.845),(16.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,40.605),(58.805,40.775),(58.975,40.775),(58.975,40.605),(58.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,40.265),(58.805,40.435),(58.975,40.435),(58.975,40.265),(58.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.725),(39.605,29.895),(39.775,29.895),(39.775,29.725),(39.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.045),(39.605,29.215),(39.775,29.215),(39.775,29.045),(39.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.385),(39.605,29.555),(39.775,29.555),(39.775,29.385),(39.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.345),(40.115,10.515),(40.285,10.515),(40.285,10.345),(40.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.345),(40.625,10.515),(40.795,10.515),(40.795,10.345),(40.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,35.165),(6.515,35.335),(6.685,35.335),(6.685,35.165),(6.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,35.505),(6.515,35.675),(6.685,35.675),(6.685,35.505),(6.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,20.885),(21.425,21.055),(21.595,21.055),(21.595,20.885),(21.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,38.905),(68.405,39.075),(68.575,39.075),(68.575,38.905),(68.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.845),(58.805,36.015),(58.975,36.015),(58.975,35.845),(58.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,38.225),(21.425,38.395),(21.595,38.395),(21.595,38.225),(21.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,38.565),(21.425,38.735),(21.595,38.735),(21.595,38.565),(21.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.345),(78.005,10.515),(78.175,10.515),(78.175,10.345),(78.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.685),(78.515,10.855),(78.685,10.855),(78.685,10.685),(78.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.685),(78.005,10.855),(78.175,10.855),(78.175,10.685),(78.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.005),(78.515,10.175),(78.685,10.175),(78.685,10.005),(78.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.705),(34.805,11.875),(34.975,11.875),(34.975,11.705),(34.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.025),(34.805,11.195),(34.975,11.195),(34.975,11.025),(34.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.345),(78.515,10.515),(78.685,10.515),(78.685,10.345),(78.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.005),(78.005,10.175),(78.175,10.175),(78.175,10.005),(78.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,23.265),(21.425,23.435),(21.595,23.435),(21.595,23.265),(21.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,21.225),(25.205,21.395),(25.375,21.395),(25.375,21.225),(25.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,21.225),(25.715,21.395),(25.885,21.395),(25.885,21.225),(25.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,23.605),(21.425,23.775),(21.595,23.775),(21.595,23.605),(21.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.625),(44.915,24.795),(45.085,24.795),(45.085,24.625),(44.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,25.985),(68.915,26.155),(69.085,26.155),(69.085,25.985),(68.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.925),(45.425,23.095),(45.595,23.095),(45.595,22.925),(45.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,38.225),(25.715,38.395),(25.885,38.395),(25.885,38.225),(25.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,38.565),(25.715,38.735),(25.885,38.735),(25.885,38.565),(25.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,38.225),(25.205,38.395),(25.375,38.395),(25.375,38.225),(25.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,38.565),(25.205,38.735),(25.375,38.735),(25.375,38.565),(25.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.605),(63.605,6.775),(63.775,6.775),(63.775,6.605),(63.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,23.605),(20.915,23.775),(21.085,23.775),(21.085,23.605),(20.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,23.265),(20.915,23.435),(21.085,23.435),(21.085,23.265),(20.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.045),(35.825,12.215),(35.995,12.215),(35.995,12.045),(35.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.385),(35.315,12.555),(35.485,12.555),(35.485,12.385),(35.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.385),(35.825,12.555),(35.995,12.555),(35.995,12.385),(35.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.045),(35.315,12.215),(35.485,12.215),(35.485,12.045),(35.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.725),(35.825,12.895),(35.995,12.895),(35.995,12.725),(35.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.725),(35.315,12.895),(35.485,12.895),(35.485,12.725),(35.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.805),(21.425,16.975),(21.595,16.975),(21.595,16.805),(21.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.125),(21.425,16.295),(21.595,16.295),(21.595,16.125),(21.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.305),(39.605,8.475),(39.775,8.475),(39.775,8.305),(39.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,20.885),(20.915,21.055),(21.085,21.055),(21.085,20.885),(20.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.205),(83.315,3.375),(83.485,3.375),(83.485,3.205),(83.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,38.225),(20.405,38.395),(20.575,38.395),(20.575,38.225),(20.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,38.565),(20.405,38.735),(20.575,38.735),(20.575,38.565),(20.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.265),(6.515,6.435),(6.685,6.435),(6.685,6.265),(6.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.605),(6.515,6.775),(6.685,6.775),(6.685,6.605),(6.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,28.025),(15.605,28.195),(15.775,28.195),(15.775,28.025),(15.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,28.365),(15.605,28.535),(15.775,28.535),(15.775,28.365),(15.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,22.925),(63.605,23.095),(63.775,23.095),(63.775,22.925),(63.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.545),(35.825,3.715),(35.995,3.715),(35.995,3.545),(35.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.545),(35.315,3.715),(35.485,3.715),(35.485,3.545),(35.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.945),(20.915,7.115),(21.085,7.115),(21.085,6.945),(20.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.225),(59.315,38.395),(59.485,38.395),(59.485,38.225),(59.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.565),(59.315,38.735),(59.485,38.735),(59.485,38.565),(59.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,38.225),(59.825,38.395),(59.995,38.395),(59.995,38.225),(59.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,38.565),(59.825,38.735),(59.995,38.735),(59.995,38.565),(59.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.325),(31.025,9.495),(31.195,9.495),(31.195,9.325),(31.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.925),(44.405,40.095),(44.575,40.095),(44.575,39.925),(44.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.625),(58.805,24.795),(58.975,24.795),(58.975,24.625),(58.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.105),(50.225,32.275),(50.395,32.275),(50.395,32.105),(50.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.785),(50.225,32.955),(50.395,32.955),(50.395,32.785),(50.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,20.545),(74.225,20.715),(74.395,20.715),(74.395,20.545),(74.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,20.205),(74.225,20.375),(74.395,20.375),(74.395,20.205),(74.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.445),(50.225,32.615),(50.395,32.615),(50.395,32.445),(50.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.725),(30.515,29.895),(30.685,29.895),(30.685,29.725),(30.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,29.385),(30.005,29.555),(30.175,29.555),(30.175,29.385),(30.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.045),(30.515,29.215),(30.685,29.215),(30.685,29.045),(30.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.545),(40.625,20.715),(40.795,20.715),(40.795,20.545),(40.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.545),(40.115,20.715),(40.285,20.715),(40.285,20.545),(40.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.245),(45.425,39.415),(45.595,39.415),(45.595,39.245),(45.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.585),(45.425,39.755),(45.595,39.755),(45.595,39.585),(45.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,34.825),(68.405,34.995),(68.575,34.995),(68.575,34.825),(68.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,34.485),(68.405,34.655),(68.575,34.655),(68.575,34.485),(68.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,34.145),(68.405,34.315),(68.575,34.315),(68.575,34.145),(68.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.265),(35.315,6.435),(35.485,6.435),(35.485,6.265),(35.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.265),(35.825,6.435),(35.995,6.435),(35.995,6.265),(35.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.125),(34.805,16.295),(34.975,16.295),(34.975,16.125),(34.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.465),(34.805,16.635),(34.975,16.635),(34.975,16.465),(34.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.805),(34.805,16.975),(34.975,16.975),(34.975,16.805),(34.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.245),(39.605,5.415),(39.775,5.415),(39.775,5.245),(39.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,25.645),(64.625,25.815),(64.795,25.815),(64.795,25.645),(64.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,25.645),(64.115,25.815),(64.285,25.815),(64.285,25.645),(64.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,25.305),(64.625,25.475),(64.795,25.475),(64.795,25.305),(64.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,25.305),(64.115,25.475),(64.285,25.475),(64.285,25.305),(64.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.845),(20.405,19.015),(20.575,19.015),(20.575,18.845),(20.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,20.205),(79.025,20.375),(79.195,20.375),(79.195,20.205),(79.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,20.545),(79.025,20.715),(79.195,20.715),(79.195,20.545),(79.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.125),(35.825,16.295),(35.995,16.295),(35.995,16.125),(35.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.465),(35.825,16.635),(35.995,16.635),(35.995,16.465),(35.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.465),(35.315,16.635),(35.485,16.635),(35.485,16.465),(35.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.805),(35.315,16.975),(35.485,16.975),(35.485,16.805),(35.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.805),(35.825,16.975),(35.995,16.975),(35.995,16.805),(35.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.125),(35.315,16.295),(35.485,16.295),(35.485,16.125),(35.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.605),(58.805,6.775),(58.975,6.775),(58.975,6.605),(58.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.865),(44.915,37.035),(45.085,37.035),(45.085,36.865),(44.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.605),(34.805,6.775),(34.975,6.775),(34.975,6.605),(34.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.265),(34.805,6.435),(34.975,6.435),(34.975,6.265),(34.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.225),(30.515,21.395),(30.685,21.395),(30.685,21.225),(30.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.225),(30.005,21.395),(30.175,21.395),(30.175,21.225),(30.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.565),(30.005,21.735),(30.175,21.735),(30.175,21.565),(30.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.565),(30.515,21.735),(30.685,21.735),(30.685,21.565),(30.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,21.905),(11.315,22.075),(11.485,22.075),(11.485,21.905),(11.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,21.905),(11.825,22.075),(11.995,22.075),(11.995,21.905),(11.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.725),(49.715,12.895),(49.885,12.895),(49.885,12.725),(49.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.725),(49.205,12.895),(49.375,12.895),(49.375,12.725),(49.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.385),(49.205,12.555),(49.375,12.555),(49.375,12.385),(49.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.385),(49.715,12.555),(49.885,12.555),(49.885,12.385),(49.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.045),(49.715,12.215),(49.885,12.215),(49.885,12.045),(49.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.045),(49.205,12.215),(49.375,12.215),(49.375,12.045),(49.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.585),(63.605,5.755),(63.775,5.755),(63.775,5.585),(63.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,38.905),(7.025,39.075),(7.195,39.075),(7.195,38.905),(7.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.845),(73.205,19.015),(73.375,19.015),(73.375,18.845),(73.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.845),(73.715,19.015),(73.885,19.015),(73.885,18.845),(73.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.305),(6.515,8.475),(6.685,8.475),(6.685,8.305),(6.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.885),(7.025,4.055),(7.195,4.055),(7.195,3.885),(7.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,28.025),(68.405,28.195),(68.575,28.195),(68.575,28.025),(68.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,28.365),(68.405,28.535),(68.575,28.535),(68.575,28.365),(68.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,28.705),(68.405,28.875),(68.575,28.875),(68.575,28.705),(68.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.185),(58.805,19.355),(58.975,19.355),(58.975,19.185),(58.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.145),(30.005,17.315),(30.175,17.315),(30.175,17.145),(30.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.825),(30.005,17.995),(30.175,17.995),(30.175,17.825),(30.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.485),(30.005,17.655),(30.175,17.655),(30.175,17.485),(30.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,26.665),(34.805,26.835),(34.975,26.835),(34.975,26.665),(34.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.445),(7.025,15.615),(7.195,15.615),(7.195,15.445),(7.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,36.185),(10.805,36.355),(10.975,36.355),(10.975,36.185),(10.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,36.525),(10.805,36.695),(10.975,36.695),(10.975,36.525),(10.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,20.545),(25.205,20.715),(25.375,20.715),(25.375,20.545),(25.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,20.545),(25.715,20.715),(25.885,20.715),(25.885,20.545),(25.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,37.885),(10.805,38.055),(10.975,38.055),(10.975,37.885),(10.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.385),(59.315,12.555),(59.485,12.555),(59.485,12.385),(59.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.385),(59.825,12.555),(59.995,12.555),(59.995,12.385),(59.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.885),(31.025,4.055),(31.195,4.055),(31.195,3.885),(31.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.305),(26.225,8.475),(26.395,8.475),(26.395,8.305),(26.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.545),(74.225,3.715),(74.395,3.715),(74.395,3.545),(74.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,22.925),(10.805,23.095),(10.975,23.095),(10.975,22.925),(10.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.945),(69.425,7.115),(69.595,7.115),(69.595,6.945),(69.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.205),(26.225,3.375),(26.395,3.375),(26.395,3.205),(26.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.945),(21.425,7.115),(21.595,7.115),(21.595,6.945),(21.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,26.665),(68.405,26.835),(68.575,26.835),(68.575,26.665),(68.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.245),(74.225,5.415),(74.395,5.415),(74.395,5.245),(74.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.245),(35.315,5.415),(35.485,5.415),(35.485,5.245),(35.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.245),(35.825,5.415),(35.995,5.415),(35.995,5.245),(35.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.945),(68.915,7.115),(69.085,7.115),(69.085,6.945),(68.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.305),(54.515,8.475),(54.685,8.475),(54.685,8.305),(54.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.645),(54.515,8.815),(54.685,8.815),(54.685,8.645),(54.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,24.625),(83.315,24.795),(83.485,24.795),(83.485,24.625),(83.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.305),(54.005,8.475),(54.175,8.475),(54.175,8.305),(54.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.645),(54.005,8.815),(54.175,8.815),(54.175,8.645),(54.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.885),(49.205,4.055),(49.375,4.055),(49.375,3.885),(49.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.885),(49.715,4.055),(49.885,4.055),(49.885,3.885),(49.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.885),(55.025,4.055),(55.195,4.055),(55.195,3.885),(55.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.485),(63.605,17.655),(63.775,17.655),(63.775,17.485),(63.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.365),(39.605,28.535),(39.775,28.535),(39.775,28.365),(39.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.025),(39.605,28.195),(39.775,28.195),(39.775,28.025),(39.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,31.425),(79.025,31.595),(79.195,31.595),(79.195,31.425),(79.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.885),(50.225,38.055),(50.395,38.055),(50.395,37.885),(50.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.145),(11.825,17.315),(11.995,17.315),(11.995,17.145),(11.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.485),(11.825,17.655),(11.995,17.655),(11.995,17.485),(11.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.145),(11.315,17.315),(11.485,17.315),(11.485,17.145),(11.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.485),(11.315,17.655),(11.485,17.655),(11.485,17.485),(11.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.825),(11.315,17.995),(11.485,17.995),(11.485,17.825),(11.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.825),(11.825,17.995),(11.995,17.995),(11.995,17.825),(11.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,38.905),(78.005,39.075),(78.175,39.075),(78.175,38.905),(78.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,38.905),(78.515,39.075),(78.685,39.075),(78.685,38.905),(78.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.445),(55.025,15.615),(55.195,15.615),(55.195,15.445),(55.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.165),(49.715,35.335),(49.885,35.335),(49.885,35.165),(49.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.765),(20.915,14.935),(21.085,14.935),(21.085,14.765),(20.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.505),(49.205,35.675),(49.375,35.675),(49.375,35.505),(49.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.165),(49.205,35.335),(49.375,35.335),(49.375,35.165),(49.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,25.305),(16.625,25.475),(16.795,25.475),(16.795,25.305),(16.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,39.925),(21.425,40.095),(21.595,40.095),(21.595,39.925),(21.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,25.305),(16.115,25.475),(16.285,25.475),(16.285,25.305),(16.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.505),(49.715,35.675),(49.885,35.675),(49.885,35.505),(49.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.085),(20.915,14.255),(21.085,14.255),(21.085,14.085),(20.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.545),(69.425,3.715),(69.595,3.715),(69.595,3.545),(69.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.205),(69.425,3.375),(69.595,3.375),(69.595,3.205),(69.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.285),(40.115,24.455),(40.285,24.455),(40.285,24.285),(40.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.285),(40.625,24.455),(40.795,24.455),(40.795,24.285),(40.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,25.985),(25.715,26.155),(25.885,26.155),(25.885,25.985),(25.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,25.985),(25.205,26.155),(25.375,26.155),(25.375,25.985),(25.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,40.605),(7.025,40.775),(7.195,40.775),(7.195,40.605),(7.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,40.265),(7.025,40.435),(7.195,40.435),(7.195,40.265),(7.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.565),(31.025,21.735),(31.195,21.735),(31.195,21.565),(31.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.785),(59.315,15.955),(59.485,15.955),(59.485,15.785),(59.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.785),(59.825,15.955),(59.995,15.955),(59.995,15.785),(59.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,39.245),(63.605,39.415),(63.775,39.415),(63.775,39.245),(63.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,39.585),(63.605,39.755),(63.775,39.755),(63.775,39.585),(63.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.925),(55.025,6.095),(55.195,6.095),(55.195,5.925),(55.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.785),(11.825,15.955),(11.995,15.955),(11.995,15.785),(11.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.785),(11.315,15.955),(11.485,15.955),(11.485,15.785),(11.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.385),(54.005,29.555),(54.175,29.555),(54.175,29.385),(54.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.385),(54.515,29.555),(54.685,29.555),(54.685,29.385),(54.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,26.665),(44.405,26.835),(44.575,26.835),(44.575,26.665),(44.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,26.325),(44.405,26.495),(44.575,26.495),(44.575,26.325),(44.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,27.345),(7.025,27.515),(7.195,27.515),(7.195,27.345),(7.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.885),(74.225,4.055),(74.395,4.055),(74.395,3.885),(74.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.625),(59.315,24.795),(59.485,24.795),(59.485,24.625),(59.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,24.625),(59.825,24.795),(59.995,24.795),(59.995,24.625),(59.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,34.145),(16.625,34.315),(16.795,34.315),(16.795,34.145),(16.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,34.825),(16.625,34.995),(16.795,34.995),(16.795,34.825),(16.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,34.485),(16.625,34.655),(16.795,34.655),(16.795,34.485),(16.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.325),(20.405,9.495),(20.575,9.495),(20.575,9.325),(20.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.665),(20.405,9.835),(20.575,9.835),(20.575,9.665),(20.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,37.545),(6.515,37.715),(6.685,37.715),(6.685,37.545),(6.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,37.205),(6.515,37.375),(6.685,37.375),(6.685,37.205),(6.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.545),(34.805,20.715),(34.975,20.715),(34.975,20.545),(34.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,34.825),(11.315,34.995),(11.485,34.995),(11.485,34.825),(11.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,34.145),(11.825,34.315),(11.995,34.315),(11.995,34.145),(11.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,34.485),(11.825,34.655),(11.995,34.655),(11.995,34.485),(11.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,34.145),(11.315,34.315),(11.485,34.315),(11.485,34.145),(11.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.085),(39.605,31.255),(39.775,31.255),(39.775,31.085),(39.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,34.485),(11.315,34.655),(11.485,34.655),(11.485,34.485),(11.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.765),(39.605,31.935),(39.775,31.935),(39.775,31.765),(39.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,34.825),(11.825,34.995),(11.995,34.995),(11.995,34.825),(11.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,40.605),(73.715,40.775),(73.885,40.775),(73.885,40.605),(73.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,40.265),(73.715,40.435),(73.885,40.435),(73.885,40.265),(73.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,40.605),(73.205,40.775),(73.375,40.775),(73.375,40.605),(73.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,40.265),(73.205,40.435),(73.375,40.435),(73.375,40.265),(73.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.645),(68.915,8.815),(69.085,8.815),(69.085,8.645),(68.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.405),(20.405,13.575),(20.575,13.575),(20.575,13.405),(20.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,25.985),(82.805,26.155),(82.975,26.155),(82.975,25.985),(82.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.205),(50.225,3.375),(50.395,3.375),(50.395,3.205),(50.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.305),(20.915,8.475),(21.085,8.475),(21.085,8.305),(20.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.645),(20.915,8.815),(21.085,8.815),(21.085,8.645),(20.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.425),(64.625,14.595),(64.795,14.595),(64.795,14.425),(64.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.425),(64.115,14.595),(64.285,14.595),(64.285,14.425),(64.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,20.885),(7.025,21.055),(7.195,21.055),(7.195,20.885),(7.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.765),(55.025,14.935),(55.195,14.935),(55.195,14.765),(55.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.085),(55.025,14.255),(55.195,14.255),(55.195,14.085),(55.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.105),(30.005,15.275),(30.175,15.275),(30.175,15.105),(30.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.445),(30.005,15.615),(30.175,15.615),(30.175,15.445),(30.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,24.625),(25.715,24.795),(25.885,24.795),(25.885,24.625),(25.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,24.625),(25.205,24.795),(25.375,24.795),(25.375,24.625),(25.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.905),(39.605,22.075),(39.775,22.075),(39.775,21.905),(39.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.845),(15.605,19.015),(15.775,19.015),(15.775,18.845),(15.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.085),(7.025,14.255),(7.195,14.255),(7.195,14.085),(7.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.425),(7.025,14.595),(7.195,14.595),(7.195,14.425),(7.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.765),(7.025,14.935),(7.195,14.935),(7.195,14.765),(7.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.885),(73.205,4.055),(73.375,4.055),(73.375,3.885),(73.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.885),(73.715,4.055),(73.885,4.055),(73.885,3.885),(73.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.805),(30.515,33.975),(30.685,33.975),(30.685,33.805),(30.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.125),(30.515,33.295),(30.685,33.295),(30.685,33.125),(30.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.465),(30.515,33.635),(30.685,33.635),(30.685,33.465),(30.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.925),(79.025,6.095),(79.195,6.095),(79.195,5.925),(79.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,28.025),(21.425,28.195),(21.595,28.195),(21.595,28.025),(21.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,28.365),(21.425,28.535),(21.595,28.535),(21.595,28.365),(21.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,28.705),(21.425,28.875),(21.595,28.875),(21.595,28.705),(21.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.225),(39.605,4.395),(39.775,4.395),(39.775,4.225),(39.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.565),(39.605,4.735),(39.775,4.735),(39.775,4.565),(39.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,21.225),(82.805,21.395),(82.975,21.395),(82.975,21.225),(82.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.445),(44.405,15.615),(44.575,15.615),(44.575,15.445),(44.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.445),(10.805,15.615),(10.975,15.615),(10.975,15.445),(10.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.105),(10.805,15.275),(10.975,15.275),(10.975,15.105),(10.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.005),(50.225,10.175),(50.395,10.175),(50.395,10.005),(50.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.345),(50.225,10.515),(50.395,10.515),(50.395,10.345),(50.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.685),(50.225,10.855),(50.395,10.855),(50.395,10.685),(50.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.905),(34.805,5.075),(34.975,5.075),(34.975,4.905),(34.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.525),(55.025,19.695),(55.195,19.695),(55.195,19.525),(55.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,26.665),(83.315,26.835),(83.485,26.835),(83.485,26.665),(83.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.225),(63.605,4.395),(63.775,4.395),(63.775,4.225),(63.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.365),(25.205,11.535),(25.375,11.535),(25.375,11.365),(25.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.365),(25.715,11.535),(25.885,11.535),(25.885,11.365),(25.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.105),(15.605,15.275),(15.775,15.275),(15.775,15.105),(15.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.445),(15.605,15.615),(15.775,15.615),(15.775,15.445),(15.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.365),(31.025,11.535),(31.195,11.535),(31.195,11.365),(31.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.025),(31.025,11.195),(31.195,11.195),(31.195,11.025),(31.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.705),(31.025,11.875),(31.195,11.875),(31.195,11.705),(31.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.025),(44.405,28.195),(44.575,28.195),(44.575,28.025),(44.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.365),(44.405,28.535),(44.575,28.535),(44.575,28.365),(44.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.805),(82.805,16.975),(82.975,16.975),(82.975,16.805),(82.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.125),(82.805,16.295),(82.975,16.295),(82.975,16.125),(82.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,26.665),(64.625,26.835),(64.795,26.835),(64.795,26.665),(64.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,26.665),(64.115,26.835),(64.285,26.835),(64.285,26.665),(64.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.845),(58.805,19.015),(58.975,19.015),(58.975,18.845),(58.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,20.545),(64.115,20.715),(64.285,20.715),(64.285,20.545),(64.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,20.545),(64.625,20.715),(64.795,20.715),(64.795,20.545),(64.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.445),(68.915,15.615),(69.085,15.615),(69.085,15.445),(68.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.105),(68.915,15.275),(69.085,15.275),(69.085,15.105),(68.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.205),(39.605,3.375),(39.775,3.375),(39.775,3.205),(39.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,38.225),(26.225,38.395),(26.395,38.395),(26.395,38.225),(26.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,38.565),(26.225,38.735),(26.395,38.735),(26.395,38.565),(26.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.105),(20.915,15.275),(21.085,15.275),(21.085,15.105),(20.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,34.825),(68.915,34.995),(69.085,34.995),(69.085,34.825),(68.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,34.145),(68.915,34.315),(69.085,34.315),(69.085,34.145),(68.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,34.485),(68.915,34.655),(69.085,34.655),(69.085,34.485),(68.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.285),(26.225,7.455),(26.395,7.455),(26.395,7.285),(26.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.525),(16.115,19.695),(16.285,19.695),(16.285,19.525),(16.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.185),(16.625,19.355),(16.795,19.355),(16.795,19.185),(16.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,23.265),(83.315,23.435),(83.485,23.435),(83.485,23.265),(83.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,23.605),(83.315,23.775),(83.485,23.775),(83.485,23.605),(83.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,34.825),(82.805,34.995),(82.975,34.995),(82.975,34.825),(82.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,34.485),(82.805,34.655),(82.975,34.655),(82.975,34.485),(82.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,34.145),(82.805,34.315),(82.975,34.315),(82.975,34.145),(82.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.785),(63.605,15.955),(63.775,15.955),(63.775,15.785),(63.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.145),(26.225,17.315),(26.395,17.315),(26.395,17.145),(26.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.825),(26.225,17.995),(26.395,17.995),(26.395,17.825),(26.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.205),(31.025,20.375),(31.195,20.375),(31.195,20.205),(31.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,28.705),(63.605,28.875),(63.775,28.875),(63.775,28.705),(63.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,37.885),(68.915,38.055),(69.085,38.055),(69.085,37.885),(68.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,23.945),(78.005,24.115),(78.175,24.115),(78.175,23.945),(78.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,23.945),(78.515,24.115),(78.685,24.115),(78.685,23.945),(78.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.105),(58.805,15.275),(58.975,15.275),(58.975,15.105),(58.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.445),(58.805,15.615),(58.975,15.615),(58.975,15.445),(58.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.325),(6.515,9.495),(6.685,9.495),(6.685,9.325),(6.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.665),(6.515,9.835),(6.685,9.835),(6.685,9.665),(6.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.285),(7.025,7.455),(7.195,7.455),(7.195,7.285),(7.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.325),(44.405,9.495),(44.575,9.495),(44.575,9.325),(44.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.665),(44.405,9.835),(44.575,9.835),(44.575,9.665),(44.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.785),(78.515,15.955),(78.685,15.955),(78.685,15.785),(78.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.785),(78.005,15.955),(78.175,15.955),(78.175,15.785),(78.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.545),(63.605,3.715),(63.775,3.715),(63.775,3.545),(63.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.325),(68.405,9.495),(68.575,9.495),(68.575,9.325),(68.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.565),(35.825,4.735),(35.995,4.735),(35.995,4.565),(35.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.565),(35.315,4.735),(35.485,4.735),(35.485,4.565),(35.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.225),(26.225,4.395),(26.395,4.395),(26.395,4.225),(26.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.565),(26.225,4.735),(26.395,4.735),(26.395,4.565),(26.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.705),(78.005,11.875),(78.175,11.875),(78.175,11.705),(78.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.025),(78.005,11.195),(78.175,11.195),(78.175,11.025),(78.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.025),(78.515,11.195),(78.685,11.195),(78.685,11.025),(78.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.705),(78.515,11.875),(78.685,11.875),(78.685,11.705),(78.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,36.865),(15.605,37.035),(15.775,37.035),(15.775,36.865),(15.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.405),(68.405,13.575),(68.575,13.575),(68.575,13.405),(68.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.345),(44.405,27.515),(44.575,27.515),(44.575,27.345),(44.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.065),(68.405,13.235),(68.575,13.235),(68.575,13.065),(68.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,36.865),(68.915,37.035),(69.085,37.035),(69.085,36.865),(68.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.745),(68.405,13.915),(68.575,13.915),(68.575,13.745),(68.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,40.605),(50.225,40.775),(50.395,40.775),(50.395,40.605),(50.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,40.265),(50.225,40.435),(50.395,40.435),(50.395,40.265),(50.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.825),(34.805,17.995),(34.975,17.995),(34.975,17.825),(34.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.145),(34.805,17.315),(34.975,17.315),(34.975,17.145),(34.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,33.805),(11.825,33.975),(11.995,33.975),(11.995,33.805),(11.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.765),(44.915,14.935),(45.085,14.935),(45.085,14.765),(44.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,33.805),(11.315,33.975),(11.485,33.975),(11.485,33.805),(11.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.425),(44.915,14.595),(45.085,14.595),(45.085,14.425),(44.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.085),(44.915,14.255),(45.085,14.255),(45.085,14.085),(44.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,33.465),(11.315,33.635),(11.485,33.635),(11.485,33.465),(11.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,33.125),(11.825,33.295),(11.995,33.295),(11.995,33.125),(11.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,33.465),(11.825,33.635),(11.995,33.635),(11.995,33.465),(11.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,33.125),(11.315,33.295),(11.485,33.295),(11.485,33.125),(11.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,31.085),(73.715,31.255),(73.885,31.255),(73.885,31.085),(73.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,31.085),(73.205,31.255),(73.375,31.255),(73.375,31.085),(73.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,31.765),(73.715,31.935),(73.885,31.935),(73.885,31.765),(73.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,31.765),(73.205,31.935),(73.375,31.935),(73.375,31.765),(73.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.865),(55.025,3.035),(55.195,3.035),(55.195,2.865),(55.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.045),(78.515,12.215),(78.685,12.215),(78.685,12.045),(78.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.045),(78.005,12.215),(78.175,12.215),(78.175,12.045),(78.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.725),(78.515,12.895),(78.685,12.895),(78.685,12.725),(78.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.725),(78.005,12.895),(78.175,12.895),(78.175,12.725),(78.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.325),(26.225,9.495),(26.395,9.495),(26.395,9.325),(26.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,23.265),(6.515,23.435),(6.685,23.435),(6.685,23.265),(6.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,23.605),(6.515,23.775),(6.685,23.775),(6.685,23.605),(6.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.665),(26.225,9.835),(26.395,9.835),(26.395,9.665),(26.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.225),(50.225,4.395),(50.395,4.395),(50.395,4.225),(50.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.385),(55.025,29.555),(55.195,29.555),(55.195,29.385),(55.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,24.965),(20.405,25.135),(20.575,25.135),(20.575,24.965),(20.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,37.885),(15.605,38.055),(15.775,38.055),(15.775,37.885),(15.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,2.865),(74.225,3.035),(74.395,3.035),(74.395,2.865),(74.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.285),(55.025,7.455),(55.195,7.455),(55.195,7.285),(55.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.945),(15.605,7.115),(15.775,7.115),(15.775,6.945),(15.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,2.865),(26.225,3.035),(26.395,3.035),(26.395,2.865),(26.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.065),(39.605,13.235),(39.775,13.235),(39.775,13.065),(39.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.745),(39.605,13.915),(39.775,13.915),(39.775,13.745),(39.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,20.545),(30.005,20.715),(30.175,20.715),(30.175,20.545),(30.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.545),(30.515,20.715),(30.685,20.715),(30.685,20.545),(30.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.565),(83.315,4.735),(83.485,4.735),(83.485,4.565),(83.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.225),(83.315,4.395),(83.485,4.395),(83.485,4.225),(83.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.905),(50.225,39.075),(50.395,39.075),(50.395,38.905),(50.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.705),(73.715,11.875),(73.885,11.875),(73.885,11.705),(73.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.705),(73.205,11.875),(73.375,11.875),(73.375,11.705),(73.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.365),(73.205,11.535),(73.375,11.535),(73.375,11.365),(73.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.365),(73.715,11.535),(73.885,11.535),(73.885,11.365),(73.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.085),(34.805,14.255),(34.975,14.255),(34.975,14.085),(34.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.025),(73.715,11.195),(73.885,11.195),(73.885,11.025),(73.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.025),(73.205,11.195),(73.375,11.195),(73.375,11.025),(73.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.765),(34.805,14.935),(34.975,14.935),(34.975,14.765),(34.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,26.665),(16.625,26.835),(16.795,26.835),(16.795,26.665),(16.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.425),(34.805,14.595),(34.975,14.595),(34.975,14.425),(34.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,26.665),(16.115,26.835),(16.285,26.835),(16.285,26.665),(16.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.425),(31.025,31.595),(31.195,31.595),(31.195,31.425),(31.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,23.945),(68.915,24.115),(69.085,24.115),(69.085,23.945),(68.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.645),(44.915,8.815),(45.085,8.815),(45.085,8.645),(44.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.065),(39.605,30.235),(39.775,30.235),(39.775,30.065),(39.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.405),(39.605,30.575),(39.775,30.575),(39.775,30.405),(39.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.745),(39.605,30.915),(39.775,30.915),(39.775,30.745),(39.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,32.445),(15.605,32.615),(15.775,32.615),(15.775,32.445),(15.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,32.105),(15.605,32.275),(15.775,32.275),(15.775,32.105),(15.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,32.785),(15.605,32.955),(15.775,32.955),(15.775,32.785),(15.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.105),(44.915,15.275),(45.085,15.275),(45.085,15.105),(44.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,30.405),(79.025,30.575),(79.195,30.575),(79.195,30.405),(79.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,30.065),(79.025,30.235),(79.195,30.235),(79.195,30.065),(79.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,30.745),(79.025,30.915),(79.195,30.915),(79.195,30.745),(79.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,26.665),(49.205,26.835),(49.375,26.835),(49.375,26.665),(49.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,26.665),(49.715,26.835),(49.885,26.835),(49.885,26.665),(49.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,38.225),(83.315,38.395),(83.485,38.395),(83.485,38.225),(83.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,38.565),(83.315,38.735),(83.485,38.735),(83.485,38.565),(83.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.705),(55.025,28.875),(55.195,28.875),(55.195,28.705),(55.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,39.925),(64.115,40.095),(64.285,40.095),(64.285,39.925),(64.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,39.925),(64.625,40.095),(64.795,40.095),(64.795,39.925),(64.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.165),(34.805,35.335),(34.975,35.335),(34.975,35.165),(34.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.945),(30.515,24.115),(30.685,24.115),(30.685,23.945),(30.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,23.945),(30.005,24.115),(30.175,24.115),(30.175,23.945),(30.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.505),(34.805,35.675),(34.975,35.675),(34.975,35.505),(34.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,35.505),(16.625,35.675),(16.795,35.675),(16.795,35.505),(16.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,35.165),(16.625,35.335),(16.795,35.335),(16.795,35.165),(16.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.345),(20.405,10.515),(20.575,10.515),(20.575,10.345),(20.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,39.585),(69.425,39.755),(69.595,39.755),(69.595,39.585),(69.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,39.245),(69.425,39.415),(69.595,39.415),(69.595,39.245),(69.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.125),(64.625,16.295),(64.795,16.295),(64.795,16.125),(64.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.125),(64.115,16.295),(64.285,16.295),(64.285,16.125),(64.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.465),(64.115,16.635),(64.285,16.635),(64.285,16.465),(64.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.465),(64.625,16.635),(64.795,16.635),(64.795,16.465),(64.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.805),(64.625,16.975),(64.795,16.975),(64.795,16.805),(64.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.805),(64.115,16.975),(64.285,16.975),(64.285,16.805),(64.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.265),(7.025,6.435),(7.195,6.435),(7.195,6.265),(7.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,36.185),(25.715,36.355),(25.885,36.355),(25.885,36.185),(25.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,36.525),(25.715,36.695),(25.885,36.695),(25.885,36.525),(25.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,36.185),(25.205,36.355),(25.375,36.355),(25.375,36.185),(25.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,36.525),(25.205,36.695),(25.375,36.695),(25.375,36.525),(25.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,38.905),(21.425,39.075),(21.595,39.075),(21.595,38.905),(21.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,26.325),(59.825,26.495),(59.995,26.495),(59.995,26.325),(59.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,26.325),(59.315,26.495),(59.485,26.495),(59.485,26.325),(59.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,26.665),(59.315,26.835),(59.485,26.835),(59.485,26.665),(59.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,26.665),(59.825,26.835),(59.995,26.835),(59.995,26.665),(59.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.745),(40.625,30.915),(40.795,30.915),(40.795,30.745),(40.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.065),(40.115,30.235),(40.285,30.235),(40.285,30.065),(40.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.745),(40.115,30.915),(40.285,30.915),(40.285,30.745),(40.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.065),(40.625,30.235),(40.795,30.235),(40.795,30.065),(40.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,26.665),(82.805,26.835),(82.975,26.835),(82.975,26.665),(82.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,38.905),(25.205,39.075),(25.375,39.075),(25.375,38.905),(25.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,38.905),(25.715,39.075),(25.885,39.075),(25.885,38.905),(25.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,21.225),(20.405,21.395),(20.575,21.395),(20.575,21.225),(20.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,21.565),(20.405,21.735),(20.575,21.735),(20.575,21.565),(20.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,26.325),(82.805,26.495),(82.975,26.495),(82.975,26.325),(82.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.385),(35.825,29.555),(35.995,29.555),(35.995,29.385),(35.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.385),(35.315,29.555),(35.485,29.555),(35.485,29.385),(35.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.185),(55.025,36.355),(55.195,36.355),(55.195,36.185),(55.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.525),(55.025,36.695),(55.195,36.695),(55.195,36.525),(55.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.325),(74.225,9.495),(74.395,9.495),(74.395,9.325),(74.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,30.065),(73.715,30.235),(73.885,30.235),(73.885,30.065),(73.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,30.065),(73.205,30.235),(73.375,30.235),(73.375,30.065),(73.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,30.745),(73.715,30.915),(73.885,30.915),(73.885,30.745),(73.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,30.745),(73.205,30.915),(73.375,30.915),(73.375,30.745),(73.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,23.945),(82.805,24.115),(82.975,24.115),(82.975,23.945),(82.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,37.205),(20.915,37.375),(21.085,37.375),(21.085,37.205),(20.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,37.545),(20.915,37.715),(21.085,37.715),(21.085,37.545),(20.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,40.605),(79.025,40.775),(79.195,40.775),(79.195,40.605),(79.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,40.265),(79.025,40.435),(79.195,40.435),(79.195,40.265),(79.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.985),(39.605,9.155),(39.775,9.155),(39.775,8.985),(39.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,26.665),(6.515,26.835),(6.685,26.835),(6.685,26.665),(6.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,26.325),(6.515,26.495),(6.685,26.495),(6.685,26.325),(6.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,39.925),(83.315,40.095),(83.485,40.095),(83.485,39.925),(83.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.405),(30.005,13.575),(30.175,13.575),(30.175,13.405),(30.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.405),(30.515,13.575),(30.685,13.575),(30.685,13.405),(30.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,20.545),(20.915,20.715),(21.085,20.715),(21.085,20.545),(20.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,20.205),(20.915,20.375),(21.085,20.375),(21.085,20.205),(20.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.405),(44.915,13.575),(45.085,13.575),(45.085,13.405),(44.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.745),(44.915,13.915),(45.085,13.915),(45.085,13.745),(44.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,38.905),(20.405,39.075),(20.575,39.075),(20.575,38.905),(20.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.945),(6.515,7.115),(6.685,7.115),(6.685,6.945),(6.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.265),(20.915,6.435),(21.085,6.435),(21.085,6.265),(20.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.925),(11.825,6.095),(11.995,6.095),(11.995,5.925),(11.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.925),(11.315,6.095),(11.485,6.095),(11.485,5.925),(11.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.245),(40.625,22.415),(40.795,22.415),(40.795,22.245),(40.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.245),(40.115,22.415),(40.285,22.415),(40.285,22.245),(40.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,38.905),(59.825,39.075),(59.995,39.075),(59.995,38.905),(59.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.905),(59.315,39.075),(59.485,39.075),(59.485,38.905),(59.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.005),(79.025,10.175),(79.195,10.175),(79.195,10.005),(79.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.685),(79.025,10.855),(79.195,10.855),(79.195,10.685),(79.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,20.885),(74.225,21.055),(74.395,21.055),(74.395,20.885),(74.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.885),(68.405,4.055),(68.575,4.055),(68.575,3.885),(68.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.725),(49.715,29.895),(49.885,29.895),(49.885,29.725),(49.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.045),(49.715,29.215),(49.885,29.215),(49.885,29.045),(49.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.045),(49.205,29.215),(49.375,29.215),(49.375,29.045),(49.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.725),(49.205,29.895),(49.375,29.895),(49.375,29.725),(49.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.525),(20.915,19.695),(21.085,19.695),(21.085,19.525),(20.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.525),(54.005,36.695),(54.175,36.695),(54.175,36.525),(54.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.185),(54.515,36.355),(54.685,36.355),(54.685,36.185),(54.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.525),(54.515,36.695),(54.685,36.695),(54.685,36.525),(54.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.185),(54.005,36.355),(54.175,36.355),(54.175,36.185),(54.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,39.925),(63.605,40.095),(63.775,40.095),(63.775,39.925),(63.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,31.425),(69.425,31.595),(69.595,31.595),(69.595,31.425),(69.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,26.325),(74.225,26.495),(74.395,26.495),(74.395,26.325),(74.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.065),(50.225,30.235),(50.395,30.235),(50.395,30.065),(50.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,30.405),(69.425,30.575),(69.595,30.575),(69.595,30.405),(69.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.745),(50.225,30.915),(50.395,30.915),(50.395,30.745),(50.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.105),(49.715,15.275),(49.885,15.275),(49.885,15.105),(49.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.445),(49.205,15.615),(49.375,15.615),(49.375,15.445),(49.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.105),(49.205,15.275),(49.375,15.275),(49.375,15.105),(49.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.445),(49.715,15.615),(49.885,15.615),(49.885,15.445),(49.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.305),(82.805,8.475),(82.975,8.475),(82.975,8.305),(82.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.945),(35.825,7.115),(35.995,7.115),(35.995,6.945),(35.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.405),(31.025,30.575),(31.195,30.575),(31.195,30.405),(31.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.905),(50.225,22.075),(50.395,22.075),(50.395,21.905),(50.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,20.545),(16.625,20.715),(16.795,20.715),(16.795,20.545),(16.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,20.205),(16.115,20.375),(16.285,20.375),(16.285,20.205),(16.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,20.885),(79.025,21.055),(79.195,21.055),(79.195,20.885),(79.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,2.865),(20.915,3.035),(21.085,3.035),(21.085,2.865),(20.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,24.285),(79.025,24.455),(79.195,24.455),(79.195,24.285),(79.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,24.625),(79.025,24.795),(79.195,24.795),(79.195,24.625),(79.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.945),(34.805,7.115),(34.975,7.115),(34.975,6.945),(34.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.525),(44.915,36.695),(45.085,36.695),(45.085,36.525),(44.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.185),(44.915,36.355),(45.085,36.355),(45.085,36.185),(44.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,35.505),(25.715,35.675),(25.885,35.675),(25.885,35.505),(25.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,35.165),(25.715,35.335),(25.885,35.335),(25.885,35.165),(25.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,35.165),(25.205,35.335),(25.375,35.335),(25.375,35.165),(25.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,35.505),(25.205,35.675),(25.375,35.675),(25.375,35.505),(25.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.865),(59.825,20.035),(59.995,20.035),(59.995,19.865),(59.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.865),(59.315,20.035),(59.485,20.035),(59.485,19.865),(59.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,35.845),(78.515,36.015),(78.685,36.015),(78.685,35.845),(78.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,21.225),(11.825,21.395),(11.995,21.395),(11.995,21.225),(11.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,21.225),(11.315,21.395),(11.485,21.395),(11.485,21.225),(11.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,35.845),(78.005,36.015),(78.175,36.015),(78.175,35.845),(78.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.285),(40.625,7.455),(40.795,7.455),(40.795,7.285),(40.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.285),(40.115,7.455),(40.285,7.455),(40.285,7.285),(40.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,21.905),(15.605,22.075),(15.775,22.075),(15.775,21.905),(15.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,24.285),(69.425,24.455),(69.595,24.455),(69.595,24.285),(69.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,24.625),(69.425,24.795),(69.595,24.795),(69.595,24.625),(69.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.985),(54.005,26.155),(54.175,26.155),(54.175,25.985),(54.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.985),(54.515,26.155),(54.685,26.155),(54.685,25.985),(54.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.985),(6.515,9.155),(6.685,9.155),(6.685,8.985),(6.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,39.925),(30.005,40.095),(30.175,40.095),(30.175,39.925),(30.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,27.345),(82.805,27.515),(82.975,27.515),(82.975,27.345),(82.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.845),(44.405,36.015),(44.575,36.015),(44.575,35.845),(44.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.385),(39.605,12.555),(39.775,12.555),(39.775,12.385),(39.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.065),(58.805,13.235),(58.975,13.235),(58.975,13.065),(58.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.745),(58.805,13.915),(58.975,13.915),(58.975,13.745),(58.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.465),(79.025,16.635),(79.195,16.635),(79.195,16.465),(79.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.125),(79.025,16.295),(79.195,16.295),(79.195,16.125),(79.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.805),(79.025,16.975),(79.195,16.975),(79.195,16.805),(79.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.125),(44.405,33.295),(44.575,33.295),(44.575,33.125),(44.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.805),(44.405,33.975),(44.575,33.975),(44.575,33.805),(44.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.465),(44.405,33.635),(44.575,33.635),(44.575,33.465),(44.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,36.865),(10.805,37.035),(10.975,37.035),(10.975,36.865),(10.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,29.385),(11.315,29.555),(11.485,29.555),(11.485,29.385),(11.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,29.045),(11.825,29.215),(11.995,29.215),(11.995,29.045),(11.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.025),(54.005,28.195),(54.175,28.195),(54.175,28.025),(54.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.365),(54.005,28.535),(54.175,28.535),(54.175,28.365),(54.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,29.045),(11.315,29.215),(11.485,29.215),(11.485,29.045),(11.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.025),(54.515,28.195),(54.685,28.195),(54.685,28.025),(54.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,29.725),(11.825,29.895),(11.995,29.895),(11.995,29.725),(11.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,29.725),(11.315,29.895),(11.485,29.895),(11.485,29.725),(11.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.365),(54.515,28.535),(54.685,28.535),(54.685,28.365),(54.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,29.385),(11.825,29.555),(11.995,29.555),(11.995,29.385),(11.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.265),(44.405,6.435),(44.575,6.435),(44.575,6.265),(44.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.925),(54.515,40.095),(54.685,40.095),(54.685,39.925),(54.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.925),(54.005,40.095),(54.175,40.095),(54.175,39.925),(54.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.305),(40.625,8.475),(40.795,8.475),(40.795,8.305),(40.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.305),(40.115,8.475),(40.285,8.475),(40.285,8.305),(40.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.985),(26.225,9.155),(26.395,9.155),(26.395,8.985),(26.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,40.265),(64.115,40.435),(64.285,40.435),(64.285,40.265),(64.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,40.605),(64.115,40.775),(64.285,40.775),(64.285,40.605),(64.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,40.265),(64.625,40.435),(64.795,40.435),(64.795,40.265),(64.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,40.605),(64.625,40.775),(64.795,40.775),(64.795,40.605),(64.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.165),(39.605,18.335),(39.775,18.335),(39.775,18.165),(39.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,25.985),(79.025,26.155),(79.195,26.155),(79.195,25.985),(79.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,39.925),(26.225,40.095),(26.395,40.095),(26.395,39.925),(26.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.685),(44.405,10.855),(44.575,10.855),(44.575,10.685),(44.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.005),(44.405,10.175),(44.575,10.175),(44.575,10.005),(44.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.265),(68.915,6.435),(69.085,6.435),(69.085,6.265),(68.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,26.665),(40.115,26.835),(40.285,26.835),(40.285,26.665),(40.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,26.325),(40.115,26.495),(40.285,26.495),(40.285,26.325),(40.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,26.665),(40.625,26.835),(40.795,26.835),(40.795,26.665),(40.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,26.325),(40.625,26.495),(40.795,26.495),(40.795,26.325),(40.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.625),(50.225,24.795),(50.395,24.795),(50.395,24.625),(50.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.425),(55.025,31.595),(55.195,31.595),(55.195,31.425),(55.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.365),(39.605,11.535),(39.775,11.535),(39.775,11.365),(39.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.985),(54.005,9.155),(54.175,9.155),(54.175,8.985),(54.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.985),(54.515,9.155),(54.685,9.155),(54.685,8.985),(54.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.965),(40.115,8.135),(40.285,8.135),(40.285,7.965),(40.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.965),(40.625,8.135),(40.795,8.135),(40.795,7.965),(40.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.325),(59.825,9.495),(59.995,9.495),(59.995,9.325),(59.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.325),(59.315,9.495),(59.485,9.495),(59.485,9.325),(59.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,21.565),(6.515,21.735),(6.685,21.735),(6.685,21.565),(6.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.325),(11.825,9.495),(11.995,9.495),(11.995,9.325),(11.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.665),(11.315,9.835),(11.485,9.835),(11.485,9.665),(11.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.665),(83.315,9.835),(83.485,9.835),(83.485,9.665),(83.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.325),(11.315,9.495),(11.485,9.495),(11.485,9.325),(11.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.665),(11.825,9.835),(11.995,9.835),(11.995,9.665),(11.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.485),(82.805,17.655),(82.975,17.655),(82.975,17.485),(82.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.145),(82.805,17.315),(82.975,17.315),(82.975,17.145),(82.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.825),(82.805,17.995),(82.975,17.995),(82.975,17.825),(82.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.925),(20.915,6.095),(21.085,6.095),(21.085,5.925),(20.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.065),(45.425,30.235),(45.595,30.235),(45.595,30.065),(45.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.745),(45.425,30.915),(45.595,30.915),(45.595,30.745),(45.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,33.125),(26.225,33.295),(26.395,33.295),(26.395,33.125),(26.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,33.465),(26.225,33.635),(26.395,33.635),(26.395,33.465),(26.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,33.805),(26.225,33.975),(26.395,33.975),(26.395,33.805),(26.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.965),(40.625,25.135),(40.795,25.135),(40.795,24.965),(40.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.965),(40.115,25.135),(40.285,25.135),(40.285,24.965),(40.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,25.305),(25.715,25.475),(25.885,25.475),(25.885,25.305),(25.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,25.305),(25.205,25.475),(25.375,25.475),(25.375,25.305),(25.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,23.945),(68.405,24.115),(68.575,24.115),(68.575,23.945),(68.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.965),(7.025,8.135),(7.195,8.135),(7.195,7.965),(7.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.705),(35.315,28.875),(35.485,28.875),(35.485,28.705),(35.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.705),(35.825,28.875),(35.995,28.875),(35.995,28.705),(35.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,2.865),(68.915,3.035),(69.085,3.035),(69.085,2.865),(68.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.285),(39.605,24.455),(39.775,24.455),(39.775,24.285),(39.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.625),(39.605,24.795),(39.775,24.795),(39.775,24.625),(39.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,30.065),(74.225,30.235),(74.395,30.235),(74.395,30.065),(74.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,30.405),(74.225,30.575),(74.395,30.575),(74.395,30.405),(74.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,30.745),(74.225,30.915),(74.395,30.915),(74.395,30.745),(74.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.965),(31.025,8.135),(31.195,8.135),(31.195,7.965),(31.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,21.225),(10.805,21.395),(10.975,21.395),(10.975,21.225),(10.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.925),(25.715,6.095),(25.885,6.095),(25.885,5.925),(25.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.925),(25.205,6.095),(25.375,6.095),(25.375,5.925),(25.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.805),(16.625,16.975),(16.795,16.975),(16.795,16.805),(16.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.125),(16.625,16.295),(16.795,16.295),(16.795,16.125),(16.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.465),(16.625,16.635),(16.795,16.635),(16.795,16.465),(16.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,27.345),(83.315,27.515),(83.485,27.515),(83.485,27.345),(83.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.185),(45.425,36.355),(45.595,36.355),(45.595,36.185),(45.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.525),(45.425,36.695),(45.595,36.695),(45.595,36.525),(45.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,25.985),(21.425,26.155),(21.595,26.155),(21.595,25.985),(21.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.705),(49.205,28.875),(49.375,28.875),(49.375,28.705),(49.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.025),(49.715,28.195),(49.885,28.195),(49.885,28.025),(49.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.365),(49.715,28.535),(49.885,28.535),(49.885,28.365),(49.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.705),(49.715,28.875),(49.885,28.875),(49.885,28.705),(49.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.025),(49.205,28.195),(49.375,28.195),(49.375,28.025),(49.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.365),(49.205,28.535),(49.375,28.535),(49.375,28.365),(49.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.225),(39.605,21.395),(39.775,21.395),(39.775,21.225),(39.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.325),(64.115,9.495),(64.285,9.495),(64.285,9.325),(64.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.325),(64.625,9.495),(64.795,9.495),(64.795,9.325),(64.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.665),(64.115,9.835),(64.285,9.835),(64.285,9.665),(64.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.665),(64.625,9.835),(64.795,9.835),(64.795,9.665),(64.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.425),(49.715,14.595),(49.885,14.595),(49.885,14.425),(49.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.425),(49.205,14.595),(49.375,14.595),(49.375,14.425),(49.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,28.705),(11.315,28.875),(11.485,28.875),(11.485,28.705),(11.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,28.705),(11.825,28.875),(11.995,28.875),(11.995,28.705),(11.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,27.345),(6.515,27.515),(6.685,27.515),(6.685,27.345),(6.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.585),(79.025,5.755),(79.195,5.755),(79.195,5.585),(79.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.225),(79.025,4.395),(79.195,4.395),(79.195,4.225),(79.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.565),(79.025,4.735),(79.195,4.735),(79.195,4.565),(79.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.905),(39.605,5.075),(39.775,5.075),(39.775,4.905),(39.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.985),(31.025,26.155),(31.195,26.155),(31.195,25.985),(31.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.625),(49.205,7.795),(49.375,7.795),(49.375,7.625),(49.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.625),(49.715,7.795),(49.885,7.795),(49.885,7.625),(49.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.045),(64.115,12.215),(64.285,12.215),(64.285,12.045),(64.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.045),(64.625,12.215),(64.795,12.215),(64.795,12.045),(64.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.725),(64.625,12.895),(64.795,12.895),(64.795,12.725),(64.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.725),(64.115,12.895),(64.285,12.895),(64.285,12.725),(64.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,24.285),(6.515,24.455),(6.685,24.455),(6.685,24.285),(6.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,24.625),(6.515,24.795),(6.685,24.795),(6.685,24.625),(6.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,31.765),(20.915,31.935),(21.085,31.935),(21.085,31.765),(20.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,31.425),(20.915,31.595),(21.085,31.595),(21.085,31.425),(20.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,31.085),(20.915,31.255),(21.085,31.255),(21.085,31.085),(20.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.905),(63.605,5.075),(63.775,5.075),(63.775,4.905),(63.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,23.605),(26.225,23.775),(26.395,23.775),(26.395,23.605),(26.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,27.685),(78.515,27.855),(78.685,27.855),(78.685,27.685),(78.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,27.685),(78.005,27.855),(78.175,27.855),(78.175,27.685),(78.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,27.005),(78.005,27.175),(78.175,27.175),(78.175,27.005),(78.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,27.005),(78.515,27.175),(78.685,27.175),(78.685,27.005),(78.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,24.965),(20.915,25.135),(21.085,25.135),(21.085,24.965),(20.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.925),(68.915,6.095),(69.085,6.095),(69.085,5.925),(68.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.005),(49.205,27.175),(49.375,27.175),(49.375,27.005),(49.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.685),(49.205,27.855),(49.375,27.855),(49.375,27.685),(49.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.005),(49.715,27.175),(49.885,27.175),(49.885,27.005),(49.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.685),(49.715,27.855),(49.885,27.855),(49.885,27.685),(49.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,38.905),(26.225,39.075),(26.395,39.075),(26.395,38.905),(26.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.725),(16.115,12.895),(16.285,12.895),(16.285,12.725),(16.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.385),(16.625,12.555),(16.795,12.555),(16.795,12.385),(16.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.045),(16.115,12.215),(16.285,12.215),(16.285,12.045),(16.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.465),(44.405,16.635),(44.575,16.635),(44.575,16.465),(44.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.705),(50.225,28.875),(50.395,28.875),(50.395,28.705),(50.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.485),(45.425,34.655),(45.595,34.655),(45.595,34.485),(45.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.145),(45.425,34.315),(45.595,34.315),(45.595,34.145),(45.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.825),(45.425,34.995),(45.595,34.995),(45.595,34.825),(45.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.885),(31.025,21.055),(31.195,21.055),(31.195,20.885),(31.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.285),(31.025,24.455),(31.195,24.455),(31.195,24.285),(31.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.625),(31.025,24.795),(31.195,24.795),(31.195,24.625),(31.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.185),(74.225,19.355),(74.395,19.355),(74.395,19.185),(74.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,21.905),(63.605,22.075),(63.775,22.075),(63.775,21.905),(63.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,21.905),(83.315,22.075),(83.485,22.075),(83.485,21.905),(83.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.605),(34.805,23.775),(34.975,23.775),(34.975,23.605),(34.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,23.265),(78.005,23.435),(78.175,23.435),(78.175,23.265),(78.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,23.605),(78.005,23.775),(78.175,23.775),(78.175,23.605),(78.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,23.265),(78.515,23.435),(78.685,23.435),(78.685,23.265),(78.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,23.605),(78.515,23.775),(78.685,23.775),(78.685,23.605),(78.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.785),(74.225,15.955),(74.395,15.955),(74.395,15.785),(74.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.785),(26.225,15.955),(26.395,15.955),(26.395,15.785),(26.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.485),(64.625,17.655),(64.795,17.655),(64.795,17.485),(64.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.485),(64.115,17.655),(64.285,17.655),(64.285,17.485),(64.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.905),(26.225,5.075),(26.395,5.075),(26.395,4.905),(26.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.205),(6.515,3.375),(6.685,3.375),(6.685,3.205),(6.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.885),(20.915,4.055),(21.085,4.055),(21.085,3.885),(20.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.785),(79.025,15.955),(79.195,15.955),(79.195,15.785),(79.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,25.985),(11.825,26.155),(11.995,26.155),(11.995,25.985),(11.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,25.985),(11.315,26.155),(11.485,26.155),(11.485,25.985),(11.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.465),(31.025,16.635),(31.195,16.635),(31.195,16.465),(31.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,36.185),(68.915,36.355),(69.085,36.355),(69.085,36.185),(68.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,36.525),(68.915,36.695),(69.085,36.695),(69.085,36.525),(68.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.965),(68.915,8.135),(69.085,8.135),(69.085,7.965),(68.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.625),(73.715,7.795),(73.885,7.795),(73.885,7.625),(73.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.625),(73.205,7.795),(73.375,7.795),(73.375,7.625),(73.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.965),(20.915,8.135),(21.085,8.135),(21.085,7.965),(20.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.525),(69.425,19.695),(69.595,19.695),(69.595,19.525),(69.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.185),(69.425,19.355),(69.595,19.355),(69.595,19.185),(69.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.645),(30.005,8.815),(30.175,8.815),(30.175,8.645),(30.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.305),(30.005,8.475),(30.175,8.475),(30.175,8.305),(30.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.545),(79.025,3.715),(79.195,3.715),(79.195,3.545),(79.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.125),(11.825,16.295),(11.995,16.295),(11.995,16.125),(11.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.465),(11.825,16.635),(11.995,16.635),(11.995,16.465),(11.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.125),(11.315,16.295),(11.485,16.295),(11.485,16.125),(11.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.465),(11.315,16.635),(11.485,16.635),(11.485,16.465),(11.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.805),(11.825,16.975),(11.995,16.975),(11.995,16.805),(11.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.905),(50.225,5.075),(50.395,5.075),(50.395,4.905),(50.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.805),(11.315,16.975),(11.485,16.975),(11.485,16.805),(11.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.545),(30.515,3.715),(30.685,3.715),(30.685,3.545),(30.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.205),(30.005,3.375),(30.175,3.375),(30.175,3.205),(30.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,31.765),(11.315,31.935),(11.485,31.935),(11.485,31.765),(11.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,31.765),(11.825,31.935),(11.995,31.935),(11.995,31.765),(11.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,31.085),(11.315,31.255),(11.485,31.255),(11.485,31.085),(11.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,31.085),(11.825,31.255),(11.995,31.255),(11.995,31.085),(11.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,37.545),(15.605,37.715),(15.775,37.715),(15.775,37.545),(15.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,37.205),(15.605,37.375),(15.775,37.375),(15.775,37.205),(15.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.545),(59.825,3.715),(59.995,3.715),(59.995,3.545),(59.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.545),(59.315,3.715),(59.485,3.715),(59.485,3.545),(59.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,37.205),(74.225,37.375),(74.395,37.375),(74.395,37.205),(74.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,37.545),(74.225,37.715),(74.395,37.715),(74.395,37.545),(74.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.105),(31.025,15.275),(31.195,15.275),(31.195,15.105),(31.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,35.165),(83.315,35.335),(83.485,35.335),(83.485,35.165),(83.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,35.505),(83.315,35.675),(83.485,35.675),(83.485,35.505),(83.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.205),(11.315,3.375),(11.485,3.375),(11.485,3.205),(11.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.205),(11.825,3.375),(11.995,3.375),(11.995,3.205),(11.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.645),(21.425,8.815),(21.595,8.815),(21.595,8.645),(21.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,35.845),(15.605,36.015),(15.775,36.015),(15.775,35.845),(15.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.305),(21.425,8.475),(21.595,8.475),(21.595,8.305),(21.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.225),(68.405,4.395),(68.575,4.395),(68.575,4.225),(68.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.905),(83.315,5.075),(83.485,5.075),(83.485,4.905),(83.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.225),(20.405,4.395),(20.575,4.395),(20.575,4.225),(20.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.565),(20.405,4.735),(20.575,4.735),(20.575,4.565),(20.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.885),(54.005,4.055),(54.175,4.055),(54.175,3.885),(54.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.885),(54.515,4.055),(54.685,4.055),(54.685,3.885),(54.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.925),(30.515,6.095),(30.685,6.095),(30.685,5.925),(30.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.145),(83.315,17.315),(83.485,17.315),(83.485,17.145),(83.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.485),(83.315,17.655),(83.485,17.655),(83.485,17.485),(83.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.825),(83.315,17.995),(83.485,17.995),(83.485,17.825),(83.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,22.245),(64.115,22.415),(64.285,22.415),(64.285,22.245),(64.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,22.245),(64.625,22.415),(64.795,22.415),(64.795,22.245),(64.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.665),(82.805,9.835),(82.975,9.835),(82.975,9.665),(82.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,26.325),(7.025,26.495),(7.195,26.495),(7.195,26.325),(7.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.505),(55.025,18.675),(55.195,18.675),(55.195,18.505),(55.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,28.705),(68.915,28.875),(69.085,28.875),(69.085,28.705),(68.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,38.905),(83.315,39.075),(83.485,39.075),(83.485,38.905),(83.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.205),(39.605,20.375),(39.775,20.375),(39.775,20.205),(39.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.885),(35.825,4.055),(35.995,4.055),(35.995,3.885),(35.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.885),(35.315,4.055),(35.485,4.055),(35.485,3.885),(35.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.825),(49.715,17.995),(49.885,17.995),(49.885,17.825),(49.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.145),(49.205,17.315),(49.375,17.315),(49.375,17.145),(49.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.145),(49.715,17.315),(49.885,17.315),(49.885,17.145),(49.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.485),(49.715,17.655),(49.885,17.655),(49.885,17.485),(49.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.825),(49.205,17.995),(49.375,17.995),(49.375,17.825),(49.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.925),(10.805,6.095),(10.975,6.095),(10.975,5.925),(10.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.485),(49.205,17.655),(49.375,17.655),(49.375,17.485),(49.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,23.265),(30.005,23.435),(30.175,23.435),(30.175,23.265),(30.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.265),(30.515,23.435),(30.685,23.435),(30.685,23.265),(30.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.885),(30.515,4.055),(30.685,4.055),(30.685,3.885),(30.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.645),(50.225,25.815),(50.395,25.815),(50.395,25.645),(50.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.785),(16.115,15.955),(16.285,15.955),(16.285,15.785),(16.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.145),(16.115,17.315),(16.285,17.315),(16.285,17.145),(16.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.825),(16.115,17.995),(16.285,17.995),(16.285,17.825),(16.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.485),(16.625,17.655),(16.795,17.655),(16.795,17.485),(16.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.945),(7.025,7.115),(7.195,7.115),(7.195,6.945),(7.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,36.865),(25.715,37.035),(25.885,37.035),(25.885,36.865),(25.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,36.865),(25.205,37.035),(25.375,37.035),(25.375,36.865),(25.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,26.665),(79.025,26.835),(79.195,26.835),(79.195,26.665),(79.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,38.565),(74.225,38.735),(74.395,38.735),(74.395,38.565),(74.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,38.225),(74.225,38.395),(74.395,38.395),(74.395,38.225),(74.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.885),(21.425,4.055),(21.595,4.055),(21.595,3.885),(21.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,27.005),(68.915,27.175),(69.085,27.175),(69.085,27.005),(68.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,27.345),(68.915,27.515),(69.085,27.515),(69.085,27.345),(68.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,27.685),(68.915,27.855),(69.085,27.855),(69.085,27.685),(68.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.345),(74.225,10.515),(74.395,10.515),(74.395,10.345),(74.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.285),(55.025,24.455),(55.195,24.455),(55.195,24.285),(55.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.345),(64.115,10.515),(64.285,10.515),(64.285,10.345),(64.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.345),(64.625,10.515),(64.795,10.515),(64.795,10.345),(64.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.205),(45.425,3.375),(45.595,3.375),(45.595,3.205),(45.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,20.545),(6.515,20.715),(6.685,20.715),(6.685,20.545),(6.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.865),(55.025,37.035),(55.195,37.035),(55.195,36.865),(55.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,20.205),(6.515,20.375),(6.685,20.375),(6.685,20.205),(6.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.985),(55.025,26.155),(55.195,26.155),(55.195,25.985),(55.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.005),(26.225,10.175),(26.395,10.175),(26.395,10.005),(26.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.685),(26.225,10.855),(26.395,10.855),(26.395,10.685),(26.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,32.445),(7.025,32.615),(7.195,32.615),(7.195,32.445),(7.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,32.105),(7.025,32.275),(7.195,32.275),(7.195,32.105),(7.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,32.785),(7.025,32.955),(7.195,32.955),(7.195,32.785),(7.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.725),(74.225,12.895),(74.395,12.895),(74.395,12.725),(74.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.385),(74.225,12.555),(74.395,12.555),(74.395,12.385),(74.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.045),(74.225,12.215),(74.395,12.215),(74.395,12.045),(74.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,23.265),(82.805,23.435),(82.975,23.435),(82.975,23.265),(82.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,23.605),(82.805,23.775),(82.975,23.775),(82.975,23.605),(82.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,37.885),(20.915,38.055),(21.085,38.055),(21.085,37.885),(20.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.685),(54.515,10.855),(54.685,10.855),(54.685,10.685),(54.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.685),(54.005,10.855),(54.175,10.855),(54.175,10.685),(54.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.005),(54.005,10.175),(54.175,10.175),(54.175,10.005),(54.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.005),(54.515,10.175),(54.685,10.175),(54.685,10.005),(54.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.245),(59.315,5.415),(59.485,5.415),(59.485,5.245),(59.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.245),(59.825,5.415),(59.995,5.415),(59.995,5.245),(59.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.225),(58.805,38.395),(58.975,38.395),(58.975,38.225),(58.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.425),(50.225,14.595),(50.395,14.595),(50.395,14.425),(50.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.565),(58.805,38.735),(58.975,38.735),(58.975,38.565),(58.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.305),(45.425,8.475),(45.595,8.475),(45.595,8.305),(45.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.925),(40.115,23.095),(40.285,23.095),(40.285,22.925),(40.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,25.305),(6.515,25.475),(6.685,25.475),(6.685,25.305),(6.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.485),(54.515,17.655),(54.685,17.655),(54.685,17.485),(54.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.145),(54.005,17.315),(54.175,17.315),(54.175,17.145),(54.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.825),(54.005,17.995),(54.175,17.995),(54.175,17.825),(54.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.925),(40.625,23.095),(40.795,23.095),(40.795,22.925),(40.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.145),(54.515,17.315),(54.685,17.315),(54.685,17.145),(54.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.645),(45.425,8.815),(45.595,8.815),(45.595,8.645),(45.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.825),(54.515,17.995),(54.685,17.995),(54.685,17.825),(54.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.485),(54.005,17.655),(54.175,17.655),(54.175,17.485),(54.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.645),(69.425,8.815),(69.595,8.815),(69.595,8.645),(69.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.105),(31.025,32.275),(31.195,32.275),(31.195,32.105),(31.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.445),(31.025,32.615),(31.195,32.615),(31.195,32.445),(31.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.785),(31.025,32.955),(31.195,32.955),(31.195,32.785),(31.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.545),(68.405,3.715),(68.575,3.715),(68.575,3.545),(68.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.205),(68.405,3.375),(68.575,3.375),(68.575,3.205),(68.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,22.245),(16.625,22.415),(16.795,22.415),(16.795,22.245),(16.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,22.245),(16.115,22.415),(16.285,22.415),(16.285,22.245),(16.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.865),(54.515,37.035),(54.685,37.035),(54.685,36.865),(54.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.045),(44.405,29.215),(44.575,29.215),(44.575,29.045),(44.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.865),(54.005,37.035),(54.175,37.035),(54.175,36.865),(54.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.725),(44.405,29.895),(44.575,29.895),(44.575,29.725),(44.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.385),(44.405,29.555),(44.575,29.555),(44.575,29.385),(44.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.985),(82.805,9.155),(82.975,9.155),(82.975,8.985),(82.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,29.385),(68.405,29.555),(68.575,29.555),(68.575,29.385),(68.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,30.405),(6.515,30.575),(6.685,30.575),(6.685,30.405),(6.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,20.885),(16.115,21.055),(16.285,21.055),(16.285,20.885),(16.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,33.805),(25.715,33.975),(25.885,33.975),(25.885,33.805),(25.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,33.805),(25.205,33.975),(25.375,33.975),(25.375,33.805),(25.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,33.465),(25.715,33.635),(25.885,33.635),(25.885,33.465),(25.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,33.125),(25.715,33.295),(25.885,33.295),(25.885,33.125),(25.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,33.465),(25.205,33.635),(25.375,33.635),(25.375,33.465),(25.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,33.125),(25.205,33.295),(25.375,33.295),(25.375,33.125),(25.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,24.965),(79.025,25.135),(79.195,25.135),(79.195,24.965),(79.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,21.565),(26.225,21.735),(26.395,21.735),(26.395,21.565),(26.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,21.225),(26.225,21.395),(26.395,21.395),(26.395,21.225),(26.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.385),(58.805,29.555),(58.975,29.555),(58.975,29.385),(58.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,22.245),(68.405,22.415),(68.575,22.415),(68.575,22.245),(68.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,22.585),(68.405,22.755),(68.575,22.755),(68.575,22.585),(68.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,32.105),(10.805,32.275),(10.975,32.275),(10.975,32.105),(10.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,32.785),(10.805,32.955),(10.975,32.955),(10.975,32.785),(10.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,32.445),(10.805,32.615),(10.975,32.615),(10.975,32.445),(10.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,21.565),(15.605,21.735),(15.775,21.735),(15.775,21.565),(15.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,21.225),(15.605,21.395),(15.775,21.395),(15.775,21.225),(15.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.165),(64.625,18.335),(64.795,18.335),(64.795,18.165),(64.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.165),(64.115,18.335),(64.285,18.335),(64.285,18.165),(64.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,24.965),(69.425,25.135),(69.595,25.135),(69.595,24.965),(69.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,26.665),(31.025,26.835),(31.195,26.835),(31.195,26.665),(31.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,26.325),(31.025,26.495),(31.195,26.495),(31.195,26.325),(31.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,39.245),(30.005,39.415),(30.175,39.415),(30.175,39.245),(30.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,39.585),(30.005,39.755),(30.175,39.755),(30.175,39.585),(30.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.165),(44.405,35.335),(44.575,35.335),(44.575,35.165),(44.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.505),(44.405,35.675),(44.575,35.675),(44.575,35.505),(44.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.245),(6.515,5.415),(6.685,5.415),(6.685,5.245),(6.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,36.525),(63.605,36.695),(63.775,36.695),(63.775,36.525),(63.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,36.185),(63.605,36.355),(63.775,36.355),(63.775,36.185),(63.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.725),(55.025,12.895),(55.195,12.895),(55.195,12.725),(55.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.045),(55.025,12.215),(55.195,12.215),(55.195,12.045),(55.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,27.345),(73.205,27.515),(73.375,27.515),(73.375,27.345),(73.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,27.345),(73.715,27.515),(73.885,27.515),(73.885,27.345),(73.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.005),(44.915,27.175),(45.085,27.175),(45.085,27.005),(44.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.405),(26.225,13.575),(26.395,13.575),(26.395,13.405),(26.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.685),(44.915,27.855),(45.085,27.855),(45.085,27.685),(44.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.325),(30.515,9.495),(30.685,9.495),(30.685,9.325),(30.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.665),(30.005,9.835),(30.175,9.835),(30.175,9.665),(30.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.945),(44.405,7.115),(44.575,7.115),(44.575,6.945),(44.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.965),(49.715,8.135),(49.885,8.135),(49.885,7.965),(49.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.965),(49.205,8.135),(49.375,8.135),(49.375,7.965),(49.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.245),(54.005,39.415),(54.175,39.415),(54.175,39.245),(54.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.585),(54.005,39.755),(54.175,39.755),(54.175,39.585),(54.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.585),(54.515,39.755),(54.685,39.755),(54.685,39.585),(54.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.245),(54.515,39.415),(54.685,39.415),(54.685,39.245),(54.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.985),(40.625,9.155),(40.795,9.155),(40.795,8.985),(40.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.985),(40.115,9.155),(40.285,9.155),(40.285,8.985),(40.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.585),(58.805,22.755),(58.975,22.755),(58.975,22.585),(58.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.845),(50.225,36.015),(50.395,36.015),(50.395,35.845),(50.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.965),(68.405,8.135),(68.575,8.135),(68.575,7.965),(68.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.585),(30.005,5.755),(30.175,5.755),(30.175,5.585),(30.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.585),(30.515,5.755),(30.685,5.755),(30.685,5.585),(30.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.585),(54.005,22.755),(54.175,22.755),(54.175,22.585),(54.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.585),(54.515,22.755),(54.685,22.755),(54.685,22.585),(54.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.245),(54.515,22.415),(54.685,22.415),(54.685,22.245),(54.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.245),(54.005,22.415),(54.175,22.415),(54.175,22.245),(54.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.705),(44.915,28.875),(45.085,28.875),(45.085,28.705),(44.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.965),(20.405,8.135),(20.575,8.135),(20.575,7.965),(20.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,33.125),(16.115,33.295),(16.285,33.295),(16.285,33.125),(16.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,33.465),(16.115,33.635),(16.285,33.635),(16.285,33.465),(16.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,33.805),(16.115,33.975),(16.285,33.975),(16.285,33.805),(16.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,2.865),(30.005,3.035),(30.175,3.035),(30.175,2.865),(30.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.845),(39.605,19.015),(39.775,19.015),(39.775,18.845),(39.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,25.645),(79.025,25.815),(79.195,25.815),(79.195,25.645),(79.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,25.305),(79.025,25.475),(79.195,25.475),(79.195,25.305),(79.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,2.865),(64.625,3.035),(64.795,3.035),(64.795,2.865),(64.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,39.245),(26.225,39.415),(26.395,39.415),(26.395,39.245),(26.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,39.585),(26.225,39.755),(26.395,39.755),(26.395,39.585),(26.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,2.865),(64.115,3.035),(64.285,3.035),(64.285,2.865),(64.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.065),(15.605,13.235),(15.775,13.235),(15.775,13.065),(15.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.745),(15.605,13.915),(15.775,13.915),(15.775,13.745),(15.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.225),(11.825,4.395),(11.995,4.395),(11.995,4.225),(11.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.225),(11.315,4.395),(11.485,4.395),(11.485,4.225),(11.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,36.185),(83.315,36.355),(83.485,36.355),(83.485,36.185),(83.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,36.525),(83.315,36.695),(83.485,36.695),(83.485,36.525),(83.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.565),(11.315,4.735),(11.485,4.735),(11.485,4.565),(11.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.565),(11.825,4.735),(11.995,4.735),(11.995,4.565),(11.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,22.245),(7.025,22.415),(7.195,22.415),(7.195,22.245),(7.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,22.585),(7.025,22.755),(7.195,22.755),(7.195,22.585),(7.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.585),(10.805,5.755),(10.975,5.755),(10.975,5.585),(10.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.665),(63.605,9.835),(63.775,9.835),(63.775,9.665),(63.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.505),(11.825,18.675),(11.995,18.675),(11.995,18.505),(11.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.505),(11.315,18.675),(11.485,18.675),(11.485,18.505),(11.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.565),(55.025,21.735),(55.195,21.735),(55.195,21.565),(55.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.165),(50.225,18.335),(50.395,18.335),(50.395,18.165),(50.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.505),(50.225,18.675),(50.395,18.675),(50.395,18.505),(50.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,32.445),(30.005,32.615),(30.175,32.615),(30.175,32.445),(30.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,32.105),(30.005,32.275),(30.175,32.275),(30.175,32.105),(30.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,32.785),(30.005,32.955),(30.175,32.955),(30.175,32.785),(30.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.785),(6.515,15.955),(6.685,15.955),(6.685,15.785),(6.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.865),(25.205,20.035),(25.375,20.035),(25.375,19.865),(25.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.865),(25.715,20.035),(25.885,20.035),(25.885,19.865),(25.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.025),(54.005,11.195),(54.175,11.195),(54.175,11.025),(54.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.025),(54.515,11.195),(54.685,11.195),(54.685,11.025),(54.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.705),(54.005,11.875),(54.175,11.875),(54.175,11.705),(54.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.705),(54.515,11.875),(54.685,11.875),(54.685,11.705),(54.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.365),(54.005,11.535),(54.175,11.535),(54.175,11.365),(54.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.365),(54.515,11.535),(54.685,11.535),(54.685,11.365),(54.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.165),(45.425,18.335),(45.595,18.335),(45.595,18.165),(45.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,38.225),(11.315,38.395),(11.485,38.395),(11.485,38.225),(11.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,38.565),(11.315,38.735),(11.485,38.735),(11.485,38.565),(11.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,38.565),(11.825,38.735),(11.995,38.735),(11.995,38.565),(11.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,38.225),(11.825,38.395),(11.995,38.395),(11.995,38.225),(11.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.365),(6.515,11.535),(6.685,11.535),(6.685,11.365),(6.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.965),(39.605,25.135),(39.775,25.135),(39.775,24.965),(39.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,23.945),(11.825,24.115),(11.995,24.115),(11.995,23.945),(11.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,23.945),(11.315,24.115),(11.485,24.115),(11.485,23.945),(11.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.665),(49.715,9.835),(49.885,9.835),(49.885,9.665),(49.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.325),(49.715,9.495),(49.885,9.495),(49.885,9.325),(49.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.325),(49.205,9.495),(49.375,9.495),(49.375,9.325),(49.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.665),(49.205,9.835),(49.375,9.835),(49.375,9.665),(49.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.505),(16.625,18.675),(16.795,18.675),(16.795,18.505),(16.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.165),(16.625,18.335),(16.795,18.335),(16.795,18.165),(16.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,29.725),(68.915,29.895),(69.085,29.895),(69.085,29.725),(68.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,29.045),(68.915,29.215),(69.085,29.215),(69.085,29.045),(68.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.865),(55.025,20.035),(55.195,20.035),(55.195,19.865),(55.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.585),(73.715,5.755),(73.885,5.755),(73.885,5.585),(73.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.585),(73.205,5.755),(73.375,5.755),(73.375,5.585),(73.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.245),(73.715,5.415),(73.885,5.415),(73.885,5.245),(73.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.245),(73.205,5.415),(73.375,5.415),(73.375,5.245),(73.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.805),(58.805,16.975),(58.975,16.975),(58.975,16.805),(58.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.125),(58.805,16.295),(58.975,16.295),(58.975,16.125),(58.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.565),(59.825,4.735),(59.995,4.735),(59.995,4.565),(59.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.565),(59.315,4.735),(59.485,4.735),(59.485,4.565),(59.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.225),(59.825,4.395),(59.995,4.395),(59.995,4.225),(59.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.225),(59.315,4.395),(59.485,4.395),(59.485,4.225),(59.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.965),(73.715,8.135),(73.885,8.135),(73.885,7.965),(73.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.965),(73.205,8.135),(73.375,8.135),(73.375,7.965),(73.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.285),(21.425,7.455),(21.595,7.455),(21.595,7.285),(21.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.485),(69.425,17.655),(69.595,17.655),(69.595,17.485),(69.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.585),(25.715,5.755),(25.885,5.755),(25.885,5.585),(25.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.585),(25.205,5.755),(25.375,5.755),(25.375,5.585),(25.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.585),(58.805,5.755),(58.975,5.755),(58.975,5.585),(58.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,36.525),(78.005,36.695),(78.175,36.695),(78.175,36.525),(78.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,36.185),(78.515,36.355),(78.685,36.355),(78.685,36.185),(78.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,36.525),(78.515,36.695),(78.685,36.695),(78.685,36.525),(78.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,36.185),(78.005,36.355),(78.175,36.355),(78.175,36.185),(78.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,2.865),(83.315,3.035),(83.485,3.035),(83.485,2.865),(83.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,35.845),(74.225,36.015),(74.395,36.015),(74.395,35.845),(74.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.865),(68.405,20.035),(68.575,20.035),(68.575,19.865),(68.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.865),(45.425,37.035),(45.595,37.035),(45.595,36.865),(45.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.025),(74.225,11.195),(74.395,11.195),(74.395,11.025),(74.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.365),(74.225,11.535),(74.395,11.535),(74.395,11.365),(74.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.705),(74.225,11.875),(74.395,11.875),(74.395,11.705),(74.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,25.305),(21.425,25.475),(21.595,25.475),(21.595,25.305),(21.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.545),(55.025,20.715),(55.195,20.715),(55.195,20.545),(55.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.245),(49.205,5.415),(49.375,5.415),(49.375,5.245),(49.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.245),(49.715,5.415),(49.885,5.415),(49.885,5.245),(49.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.445),(39.605,15.615),(39.775,15.615),(39.775,15.445),(39.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,21.225),(64.625,21.395),(64.795,21.395),(64.795,21.225),(64.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,21.225),(64.115,21.395),(64.285,21.395),(64.285,21.225),(64.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,21.565),(64.625,21.735),(64.795,21.735),(64.795,21.565),(64.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,21.565),(64.115,21.735),(64.285,21.735),(64.285,21.565),(64.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.905),(79.025,5.075),(79.195,5.075),(79.195,4.905),(79.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.645),(79.025,8.815),(79.195,8.815),(79.195,8.645),(79.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.305),(79.025,8.475),(79.195,8.475),(79.195,8.305),(79.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.245),(44.915,39.415),(45.085,39.415),(45.085,39.245),(44.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.585),(44.915,39.755),(45.085,39.755),(45.085,39.585),(44.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.785),(82.805,15.955),(82.975,15.955),(82.975,15.785),(82.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.305),(31.025,25.475),(31.195,25.475),(31.195,25.305),(31.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.885),(63.605,4.055),(63.775,4.055),(63.775,3.885),(63.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.445),(25.715,15.615),(25.885,15.615),(25.885,15.445),(25.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.105),(25.205,15.275),(25.375,15.275),(25.375,15.105),(25.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.105),(25.715,15.275),(25.885,15.275),(25.885,15.105),(25.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.445),(25.205,15.615),(25.375,15.615),(25.375,15.445),(25.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.125),(68.915,16.295),(69.085,16.295),(69.085,16.125),(68.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.465),(68.915,16.635),(69.085,16.635),(69.085,16.465),(68.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.805),(68.915,16.975),(69.085,16.975),(69.085,16.805),(68.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.725),(34.805,12.895),(34.975,12.895),(34.975,12.725),(34.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.045),(34.805,12.215),(34.975,12.215),(34.975,12.045),(34.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.385),(34.805,12.555),(34.975,12.555),(34.975,12.385),(34.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.605),(40.115,23.775),(40.285,23.775),(40.285,23.605),(40.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.605),(40.625,23.775),(40.795,23.775),(40.795,23.605),(40.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.305),(10.805,8.475),(10.975,8.475),(10.975,8.305),(10.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.885),(58.805,38.055),(58.975,38.055),(58.975,37.885),(58.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.645),(10.805,8.815),(10.975,8.815),(10.975,8.645),(10.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,38.225),(15.605,38.395),(15.775,38.395),(15.775,38.225),(15.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,38.565),(15.605,38.735),(15.775,38.735),(15.775,38.565),(15.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,27.345),(79.025,27.515),(79.195,27.515),(79.195,27.345),(79.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,34.145),(26.225,34.315),(26.395,34.315),(26.395,34.145),(26.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,34.485),(26.225,34.655),(26.395,34.655),(26.395,34.485),(26.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,34.825),(26.225,34.995),(26.395,34.995),(26.395,34.825),(26.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,24.965),(6.515,25.135),(6.685,25.135),(6.685,24.965),(6.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.545),(10.805,3.715),(10.975,3.715),(10.975,3.545),(10.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.205),(10.805,3.375),(10.975,3.375),(10.975,3.205),(10.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,35.505),(63.605,35.675),(63.775,35.675),(63.775,35.505),(63.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,35.165),(63.605,35.335),(63.775,35.335),(63.775,35.165),(63.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.045),(82.805,12.215),(82.975,12.215),(82.975,12.045),(82.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.385),(82.805,12.555),(82.975,12.555),(82.975,12.385),(82.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.725),(82.805,12.895),(82.975,12.895),(82.975,12.725),(82.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,24.285),(20.915,24.455),(21.085,24.455),(21.085,24.285),(20.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.505),(6.515,18.675),(6.685,18.675),(6.685,18.505),(6.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.165),(6.515,18.335),(6.685,18.335),(6.685,18.165),(6.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.105),(45.425,32.275),(45.595,32.275),(45.595,32.105),(45.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.445),(45.425,32.615),(45.595,32.615),(45.595,32.445),(45.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.105),(34.805,15.275),(34.975,15.275),(34.975,15.105),(34.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.785),(45.425,32.955),(45.595,32.955),(45.595,32.785),(45.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,2.865),(20.405,3.035),(20.575,3.035),(20.575,2.865),(20.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.205),(82.805,3.375),(82.975,3.375),(82.975,3.205),(82.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.185),(79.025,19.355),(79.195,19.355),(79.195,19.185),(79.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.525),(79.025,19.695),(79.195,19.695),(79.195,19.525),(79.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,31.765),(15.605,31.935),(15.775,31.935),(15.775,31.765),(15.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,31.085),(15.605,31.255),(15.775,31.255),(15.775,31.085),(15.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,31.425),(15.605,31.595),(15.775,31.595),(15.775,31.425),(15.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.585),(82.805,5.755),(82.975,5.755),(82.975,5.585),(82.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.725),(44.405,12.895),(44.575,12.895),(44.575,12.725),(44.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.045),(44.405,12.215),(44.575,12.215),(44.575,12.045),(44.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,21.905),(78.515,22.075),(78.685,22.075),(78.685,21.905),(78.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,21.905),(78.005,22.075),(78.175,22.075),(78.175,21.905),(78.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.965),(31.025,25.135),(31.195,25.135),(31.195,24.965),(31.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,21.565),(63.605,21.735),(63.775,21.735),(63.775,21.565),(63.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,21.225),(63.605,21.395),(63.775,21.395),(63.775,21.225),(63.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,21.225),(83.315,21.395),(83.485,21.395),(83.485,21.225),(83.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.185),(50.225,36.355),(50.395,36.355),(50.395,36.185),(50.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.525),(50.225,36.695),(50.395,36.695),(50.395,36.525),(50.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.245),(50.225,22.415),(50.395,22.415),(50.395,22.245),(50.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.305),(15.605,8.475),(15.775,8.475),(15.775,8.305),(15.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.685),(39.605,27.855),(39.775,27.855),(39.775,27.685),(39.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.005),(39.605,27.175),(39.775,27.175),(39.775,27.005),(39.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.945),(40.115,24.115),(40.285,24.115),(40.285,23.945),(40.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.945),(40.625,24.115),(40.795,24.115),(40.795,23.945),(40.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.205),(58.805,3.375),(58.975,3.375),(58.975,3.205),(58.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.805),(44.915,33.975),(45.085,33.975),(45.085,33.805),(44.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.125),(44.915,33.295),(45.085,33.295),(45.085,33.125),(44.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.465),(44.915,33.635),(45.085,33.635),(45.085,33.465),(44.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.625),(69.425,7.795),(69.595,7.795),(69.595,7.625),(69.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,23.605),(79.025,23.775),(79.195,23.775),(79.195,23.605),(79.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.065),(69.425,13.235),(69.595,13.235),(69.595,13.065),(69.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.745),(69.425,13.915),(69.595,13.915),(69.595,13.745),(69.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,25.305),(11.825,25.475),(11.995,25.475),(11.995,25.305),(11.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,25.305),(11.315,25.475),(11.485,25.475),(11.485,25.305),(11.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.225),(25.205,4.395),(25.375,4.395),(25.375,4.225),(25.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.225),(25.715,4.395),(25.885,4.395),(25.885,4.225),(25.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.565),(25.205,4.735),(25.375,4.735),(25.375,4.565),(25.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.565),(25.715,4.735),(25.885,4.735),(25.885,4.565),(25.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.925),(35.825,6.095),(35.995,6.095),(35.995,5.925),(35.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.925),(35.315,6.095),(35.485,6.095),(35.485,5.925),(35.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.905),(44.405,22.075),(44.575,22.075),(44.575,21.905),(44.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.705),(58.805,28.875),(58.975,28.875),(58.975,28.705),(58.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.025),(58.805,28.195),(58.975,28.195),(58.975,28.025),(58.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.365),(58.805,28.535),(58.975,28.535),(58.975,28.365),(58.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.685),(7.025,10.855),(7.195,10.855),(7.195,10.685),(7.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.005),(7.025,10.175),(7.195,10.175),(7.195,10.005),(7.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.345),(7.025,10.515),(7.195,10.515),(7.195,10.345),(7.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,35.165),(73.715,35.335),(73.885,35.335),(73.885,35.165),(73.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.985),(30.005,9.155),(30.175,9.155),(30.175,8.985),(30.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,35.505),(73.205,35.675),(73.375,35.675),(73.375,35.505),(73.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,35.165),(73.205,35.335),(73.375,35.335),(73.375,35.165),(73.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,35.505),(73.715,35.675),(73.885,35.675),(73.885,35.505),(73.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,21.565),(16.625,21.735),(16.795,21.735),(16.795,21.565),(16.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,21.225),(16.625,21.395),(16.795,21.395),(16.795,21.225),(16.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.805),(20.405,16.975),(20.575,16.975),(20.575,16.805),(20.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.125),(20.405,16.295),(20.575,16.295),(20.575,16.125),(20.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.145),(68.405,17.315),(68.575,17.315),(68.575,17.145),(68.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.485),(68.405,17.655),(68.575,17.655),(68.575,17.485),(68.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.825),(68.405,17.995),(68.575,17.995),(68.575,17.825),(68.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.565),(44.405,38.735),(44.575,38.735),(44.575,38.565),(44.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.225),(44.405,38.395),(44.575,38.395),(44.575,38.225),(44.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,33.125),(6.515,33.295),(6.685,33.295),(6.685,33.125),(6.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,33.465),(6.515,33.635),(6.685,33.635),(6.685,33.465),(6.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,33.805),(6.515,33.975),(6.685,33.975),(6.685,33.805),(6.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.845),(68.915,19.015),(69.085,19.015),(69.085,18.845),(68.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.105),(73.205,15.275),(73.375,15.275),(73.375,15.105),(73.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.445),(73.205,15.615),(73.375,15.615),(73.375,15.445),(73.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.105),(73.715,15.275),(73.885,15.275),(73.885,15.105),(73.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.445),(73.715,15.615),(73.885,15.615),(73.885,15.445),(73.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,39.925),(11.825,40.095),(11.995,40.095),(11.995,39.925),(11.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,39.925),(11.315,40.095),(11.485,40.095),(11.485,39.925),(11.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,25.985),(68.405,26.155),(68.575,26.155),(68.575,25.985),(68.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.985),(21.425,9.155),(21.595,9.155),(21.595,8.985),(21.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,21.905),(73.715,22.075),(73.885,22.075),(73.885,21.905),(73.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,21.905),(73.205,22.075),(73.375,22.075),(73.375,21.905),(73.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.905),(68.405,5.075),(68.575,5.075),(68.575,4.905),(68.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,20.545),(26.225,20.715),(26.395,20.715),(26.395,20.545),(26.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.905),(20.405,5.075),(20.575,5.075),(20.575,4.905),(20.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,22.925),(64.115,23.095),(64.285,23.095),(64.285,22.925),(64.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,22.925),(64.625,23.095),(64.795,23.095),(64.795,22.925),(64.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.225),(30.515,38.395),(30.685,38.395),(30.685,38.225),(30.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.565),(30.515,38.735),(30.685,38.735),(30.685,38.565),(30.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,34.825),(78.515,34.995),(78.685,34.995),(78.685,34.825),(78.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,34.145),(78.515,34.315),(78.685,34.315),(78.685,34.145),(78.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,34.485),(78.515,34.655),(78.685,34.655),(78.685,34.485),(78.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,2.865),(68.405,3.035),(68.575,3.035),(68.575,2.865),(68.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,34.145),(78.005,34.315),(78.175,34.315),(78.175,34.145),(78.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,34.485),(78.005,34.655),(78.175,34.655),(78.175,34.485),(78.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,34.825),(78.005,34.995),(78.175,34.995),(78.175,34.825),(78.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.365),(63.605,11.535),(63.775,11.535),(63.775,11.365),(63.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.025),(63.605,11.195),(63.775,11.195),(63.775,11.025),(63.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.705),(63.605,11.875),(63.775,11.875),(63.775,11.705),(63.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.365),(20.915,11.535),(21.085,11.535),(21.085,11.365),(20.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.705),(20.915,11.875),(21.085,11.875),(21.085,11.705),(20.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.025),(20.915,11.195),(21.085,11.195),(21.085,11.025),(20.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.225),(6.515,4.395),(6.685,4.395),(6.685,4.225),(6.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.445),(21.425,15.615),(21.595,15.615),(21.595,15.445),(21.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.105),(21.425,15.275),(21.595,15.275),(21.595,15.105),(21.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.485),(34.805,34.655),(34.975,34.655),(34.975,34.485),(34.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.065),(34.805,30.235),(34.975,30.235),(34.975,30.065),(34.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.405),(34.805,30.575),(34.975,30.575),(34.975,30.405),(34.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.745),(34.805,30.915),(34.975,30.915),(34.975,30.745),(34.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.145),(34.805,34.315),(34.975,34.315),(34.975,34.145),(34.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.825),(34.805,34.995),(34.975,34.995),(34.975,34.825),(34.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.465),(7.025,16.635),(7.195,16.635),(7.195,16.465),(7.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.065),(6.515,13.235),(6.685,13.235),(6.685,13.065),(6.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.745),(6.515,13.915),(6.685,13.915),(6.685,13.745),(6.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.885),(39.605,21.055),(39.775,21.055),(39.775,20.885),(39.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.565),(49.205,4.735),(49.375,4.735),(49.375,4.565),(49.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.565),(49.715,4.735),(49.885,4.735),(49.885,4.565),(49.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,39.245),(68.405,39.415),(68.575,39.415),(68.575,39.245),(68.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,39.585),(68.405,39.755),(68.575,39.755),(68.575,39.585),(68.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.765),(39.605,14.935),(39.775,14.935),(39.775,14.765),(39.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.085),(39.605,14.255),(39.775,14.255),(39.775,14.085),(39.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.565),(30.005,4.735),(30.175,4.735),(30.175,4.565),(30.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.565),(30.515,4.735),(30.685,4.735),(30.685,4.565),(30.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.625),(39.605,7.795),(39.775,7.795),(39.775,7.625),(39.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,38.905),(74.225,39.075),(74.395,39.075),(74.395,38.905),(74.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,35.845),(7.025,36.015),(7.195,36.015),(7.195,35.845),(7.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.305),(73.205,8.475),(73.375,8.475),(73.375,8.305),(73.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.305),(73.715,8.475),(73.885,8.475),(73.885,8.305),(73.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.645),(73.205,8.815),(73.375,8.815),(73.375,8.645),(73.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.185),(50.225,19.355),(50.395,19.355),(50.395,19.185),(50.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.645),(73.715,8.815),(73.885,8.815),(73.885,8.645),(73.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.645),(25.715,8.815),(25.885,8.815),(25.885,8.645),(25.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,23.945),(21.425,24.115),(21.595,24.115),(21.595,23.945),(21.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.645),(25.205,8.815),(25.375,8.815),(25.375,8.645),(25.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.965),(55.025,25.135),(55.195,25.135),(55.195,24.965),(55.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,20.885),(6.515,21.055),(6.685,21.055),(6.685,20.885),(6.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.545),(34.805,37.715),(34.975,37.715),(34.975,37.545),(34.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.205),(34.805,37.375),(34.975,37.375),(34.975,37.205),(34.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.305),(55.025,25.475),(55.195,25.475),(55.195,25.305),(55.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.645),(55.025,25.815),(55.195,25.815),(55.195,25.645),(55.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.225),(10.805,4.395),(10.975,4.395),(10.975,4.225),(10.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.225),(54.005,4.395),(54.175,4.395),(54.175,4.225),(54.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.045),(21.425,12.215),(21.595,12.215),(21.595,12.045),(21.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.385),(21.425,12.555),(21.595,12.555),(21.595,12.385),(21.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.725),(21.425,12.895),(21.595,12.895),(21.595,12.725),(21.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.225),(54.515,4.395),(54.685,4.395),(54.685,4.225),(54.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.565),(10.805,4.735),(10.975,4.735),(10.975,4.565),(10.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.285),(63.605,7.455),(63.775,7.455),(63.775,7.285),(63.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.845),(31.025,36.015),(31.195,36.015),(31.195,35.845),(31.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.865),(44.915,3.035),(45.085,3.035),(45.085,2.865),(44.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,37.545),(16.115,37.715),(16.285,37.715),(16.285,37.545),(16.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,37.205),(16.115,37.375),(16.285,37.375),(16.285,37.205),(16.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,26.325),(20.405,26.495),(20.575,26.495),(20.575,26.325),(20.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.605),(16.625,6.775),(16.795,6.775),(16.795,6.605),(16.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.605),(16.115,6.775),(16.285,6.775),(16.285,6.605),(16.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.565),(82.805,4.735),(82.975,4.735),(82.975,4.565),(82.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.925),(26.225,6.095),(26.395,6.095),(26.395,5.925),(26.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.225),(82.805,4.395),(82.975,4.395),(82.975,4.225),(82.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.305),(64.625,8.475),(64.795,8.475),(64.795,8.305),(64.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.305),(64.115,8.475),(64.285,8.475),(64.285,8.305),(64.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.665),(10.805,9.835),(10.975,9.835),(10.975,9.665),(10.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.905),(58.805,39.075),(58.975,39.075),(58.975,38.905),(58.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.625),(78.515,7.795),(78.685,7.795),(78.685,7.625),(78.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.625),(78.005,7.795),(78.175,7.795),(78.175,7.625),(78.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.985),(45.425,9.155),(45.595,9.155),(45.595,8.985),(45.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,20.205),(69.425,20.375),(69.595,20.375),(69.595,20.205),(69.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,20.545),(69.425,20.715),(69.595,20.715),(69.595,20.545),(69.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.145),(58.805,17.315),(58.975,17.315),(58.975,17.145),(58.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.825),(58.805,17.995),(58.975,17.995),(58.975,17.825),(58.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,20.545),(63.605,20.715),(63.775,20.715),(63.775,20.545),(63.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,20.205),(63.605,20.375),(63.775,20.375),(63.775,20.205),(63.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.965),(26.225,8.135),(26.395,8.135),(26.395,7.965),(26.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.685),(31.025,27.855),(31.195,27.855),(31.195,27.685),(31.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.005),(31.025,27.175),(31.195,27.175),(31.195,27.005),(31.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.345),(31.025,27.515),(31.195,27.515),(31.195,27.345),(31.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.525),(6.515,19.695),(6.685,19.695),(6.685,19.525),(6.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,22.925),(16.625,23.095),(16.795,23.095),(16.795,22.925),(16.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,22.925),(16.115,23.095),(16.285,23.095),(16.285,22.925),(16.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.485),(40.115,17.655),(40.285,17.655),(40.285,17.485),(40.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.485),(40.625,17.655),(40.795,17.655),(40.795,17.485),(40.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.925),(44.915,6.095),(45.085,6.095),(45.085,5.925),(44.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.925),(45.425,40.095),(45.595,40.095),(45.595,39.925),(45.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.205),(40.625,37.375),(40.795,37.375),(40.795,37.205),(40.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.545),(40.115,37.715),(40.285,37.715),(40.285,37.545),(40.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.545),(40.625,37.715),(40.795,37.715),(40.795,37.545),(40.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.205),(40.115,37.375),(40.285,37.375),(40.285,37.205),(40.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.345),(15.605,10.515),(15.775,10.515),(15.775,10.345),(15.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.025),(44.915,11.195),(45.085,11.195),(45.085,11.025),(44.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.705),(44.915,11.875),(45.085,11.875),(45.085,11.705),(44.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,23.265),(73.205,23.435),(73.375,23.435),(73.375,23.265),(73.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,23.605),(73.205,23.775),(73.375,23.775),(73.375,23.605),(73.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,27.005),(64.625,27.175),(64.795,27.175),(64.795,27.005),(64.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,23.605),(73.715,23.775),(73.885,23.775),(73.885,23.605),(73.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,23.265),(73.715,23.435),(73.885,23.435),(73.885,23.265),(73.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,27.345),(64.625,27.515),(64.795,27.515),(64.795,27.345),(64.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,27.345),(64.115,27.515),(64.285,27.515),(64.285,27.345),(64.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,27.685),(64.115,27.855),(64.285,27.855),(64.285,27.685),(64.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,27.005),(64.115,27.175),(64.285,27.175),(64.285,27.005),(64.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,27.685),(64.625,27.855),(64.795,27.855),(64.795,27.685),(64.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,25.985),(64.115,26.155),(64.285,26.155),(64.285,25.985),(64.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,25.985),(64.625,26.155),(64.795,26.155),(64.795,25.985),(64.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,31.765),(63.605,31.935),(63.775,31.935),(63.775,31.765),(63.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,31.085),(63.605,31.255),(63.775,31.255),(63.775,31.085),(63.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.625),(35.825,7.795),(35.995,7.795),(35.995,7.625),(35.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.625),(35.315,7.795),(35.485,7.795),(35.485,7.625),(35.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.445),(69.425,15.615),(69.595,15.615),(69.595,15.445),(69.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.105),(69.425,15.275),(69.595,15.275),(69.595,15.105),(69.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.185),(31.025,19.355),(31.195,19.355),(31.195,19.185),(31.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.085),(69.425,14.255),(69.595,14.255),(69.595,14.085),(69.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.765),(69.425,14.935),(69.595,14.935),(69.595,14.765),(69.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.905),(30.515,22.075),(30.685,22.075),(30.685,21.905),(30.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,21.905),(30.005,22.075),(30.175,22.075),(30.175,21.905),(30.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.665),(58.805,9.835),(58.975,9.835),(58.975,9.665),(58.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,22.925),(68.405,23.095),(68.575,23.095),(68.575,22.925),(68.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.845),(64.115,19.015),(64.285,19.015),(64.285,18.845),(64.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.845),(64.625,19.015),(64.795,19.015),(64.795,18.845),(64.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.525),(11.315,19.695),(11.485,19.695),(11.485,19.525),(11.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.525),(11.825,19.695),(11.995,19.695),(11.995,19.525),(11.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.065),(49.205,13.235),(49.375,13.235),(49.375,13.065),(49.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.745),(49.205,13.915),(49.375,13.915),(49.375,13.745),(49.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.185),(49.205,19.355),(49.375,19.355),(49.375,19.185),(49.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.745),(49.715,13.915),(49.885,13.915),(49.885,13.745),(49.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.925),(40.625,6.095),(40.795,6.095),(40.795,5.925),(40.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.925),(40.115,6.095),(40.285,6.095),(40.285,5.925),(40.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,32.445),(82.805,32.615),(82.975,32.615),(82.975,32.445),(82.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,32.105),(82.805,32.275),(82.975,32.275),(82.975,32.105),(82.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,32.785),(82.805,32.955),(82.975,32.955),(82.975,32.785),(82.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,23.265),(64.625,23.435),(64.795,23.435),(64.795,23.265),(64.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,23.265),(64.115,23.435),(64.285,23.435),(64.285,23.265),(64.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.265),(31.025,23.435),(31.195,23.435),(31.195,23.265),(31.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.605),(31.025,23.775),(31.195,23.775),(31.195,23.605),(31.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,36.865),(63.605,37.035),(63.775,37.035),(63.775,36.865),(63.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,38.565),(82.805,38.735),(82.975,38.735),(82.975,38.565),(82.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,2.865),(63.605,3.035),(63.775,3.035),(63.775,2.865),(63.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,38.225),(82.805,38.395),(82.975,38.395),(82.975,38.225),(82.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.865),(6.515,20.035),(6.685,20.035),(6.685,19.865),(6.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.385),(45.425,12.555),(45.595,12.555),(45.595,12.385),(45.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,22.585),(79.025,22.755),(79.195,22.755),(79.195,22.585),(79.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.165),(68.405,18.335),(68.575,18.335),(68.575,18.165),(68.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.165),(78.515,18.335),(78.685,18.335),(78.685,18.165),(78.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.165),(78.005,18.335),(78.175,18.335),(78.175,18.165),(78.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.505),(78.005,18.675),(78.175,18.675),(78.175,18.505),(78.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.505),(78.515,18.675),(78.685,18.675),(78.685,18.505),(78.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.805),(83.315,16.975),(83.485,16.975),(83.485,16.805),(83.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.125),(83.315,16.295),(83.485,16.295),(83.485,16.125),(83.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.105),(45.425,15.275),(45.595,15.275),(45.595,15.105),(45.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.445),(45.425,15.615),(45.595,15.615),(45.595,15.445),(45.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.405),(59.315,13.575),(59.485,13.575),(59.485,13.405),(59.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.745),(59.825,13.915),(59.995,13.915),(59.995,13.745),(59.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.065),(59.825,13.235),(59.995,13.235),(59.995,13.065),(59.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.065),(59.315,13.235),(59.485,13.235),(59.485,13.065),(59.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.925),(54.515,23.095),(54.685,23.095),(54.685,22.925),(54.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.405),(59.825,13.575),(59.995,13.575),(59.995,13.405),(59.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.745),(59.315,13.915),(59.485,13.915),(59.485,13.745),(59.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.925),(54.005,23.095),(54.175,23.095),(54.175,22.925),(54.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.925),(16.625,6.095),(16.795,6.095),(16.795,5.925),(16.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.925),(16.115,6.095),(16.285,6.095),(16.285,5.925),(16.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.865),(35.825,20.035),(35.995,20.035),(35.995,19.865),(35.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.865),(35.315,20.035),(35.485,20.035),(35.485,19.865),(35.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.745),(11.315,13.915),(11.485,13.915),(11.485,13.745),(11.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.065),(83.315,13.235),(83.485,13.235),(83.485,13.065),(83.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.745),(83.315,13.915),(83.485,13.915),(83.485,13.745),(83.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.065),(11.825,13.235),(11.995,13.235),(11.995,13.065),(11.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.405),(11.825,13.575),(11.995,13.575),(11.995,13.405),(11.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.405),(11.315,13.575),(11.485,13.575),(11.485,13.405),(11.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.745),(11.825,13.915),(11.995,13.915),(11.995,13.745),(11.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.065),(11.315,13.235),(11.485,13.235),(11.485,13.065),(11.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.365),(82.805,11.535),(82.975,11.535),(82.975,11.365),(82.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,36.865),(83.315,37.035),(83.485,37.035),(83.485,36.865),(83.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.905),(11.315,5.075),(11.485,5.075),(11.485,4.905),(11.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.905),(11.825,5.075),(11.995,5.075),(11.995,4.905),(11.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,22.925),(7.025,23.095),(7.195,23.095),(7.195,22.925),(7.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.845),(50.225,19.015),(50.395,19.015),(50.395,18.845),(50.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,32.105),(63.605,32.275),(63.775,32.275),(63.775,32.105),(63.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,32.785),(63.605,32.955),(63.775,32.955),(63.775,32.785),(63.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,32.445),(63.605,32.615),(63.775,32.615),(63.775,32.445),(63.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,25.985),(16.115,26.155),(16.285,26.155),(16.285,25.985),(16.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,25.985),(16.625,26.155),(16.795,26.155),(16.795,25.985),(16.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.525),(45.425,19.695),(45.595,19.695),(45.595,19.525),(45.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.185),(45.425,19.355),(45.595,19.355),(45.595,19.185),(45.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.265),(83.315,6.435),(83.485,6.435),(83.485,6.265),(83.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.845),(45.425,19.015),(45.595,19.015),(45.595,18.845),(45.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,38.905),(11.825,39.075),(11.995,39.075),(11.995,38.905),(11.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,38.905),(11.315,39.075),(11.485,39.075),(11.485,38.905),(11.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,26.665),(10.805,26.835),(10.975,26.835),(10.975,26.665),(10.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.085),(45.425,14.255),(45.595,14.255),(45.595,14.085),(45.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.425),(45.425,14.595),(45.595,14.595),(45.595,14.425),(45.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.765),(45.425,14.935),(45.595,14.935),(45.595,14.765),(45.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.245),(69.425,5.415),(69.595,5.415),(69.595,5.245),(69.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.585),(69.425,5.755),(69.595,5.755),(69.595,5.585),(69.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,2.865),(82.805,3.035),(82.975,3.035),(82.975,2.865),(82.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.845),(16.625,19.015),(16.795,19.015),(16.795,18.845),(16.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.025),(34.805,28.195),(34.975,28.195),(34.975,28.025),(34.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.365),(34.805,28.535),(34.975,28.535),(34.975,28.365),(34.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.705),(34.805,28.875),(34.975,28.875),(34.975,28.705),(34.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.905),(59.825,5.075),(59.995,5.075),(59.995,4.905),(59.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.905),(59.315,5.075),(59.485,5.075),(59.485,4.905),(59.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,37.885),(6.515,38.055),(6.685,38.055),(6.685,37.885),(6.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.265),(78.005,6.435),(78.175,6.435),(78.175,6.265),(78.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.605),(78.515,6.775),(78.685,6.775),(78.685,6.605),(78.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,24.285),(15.605,24.455),(15.775,24.455),(15.775,24.285),(15.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.265),(78.515,6.435),(78.685,6.435),(78.685,6.265),(78.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.605),(78.005,6.775),(78.175,6.775),(78.175,6.605),(78.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.885),(44.915,4.055),(45.085,4.055),(45.085,3.885),(44.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,33.805),(73.715,33.975),(73.885,33.975),(73.885,33.805),(73.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,33.805),(73.205,33.975),(73.375,33.975),(73.375,33.805),(73.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.745),(64.625,13.915),(64.795,13.915),(64.795,13.745),(64.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.065),(64.625,13.235),(64.795,13.235),(64.795,13.065),(64.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.745),(64.115,13.915),(64.285,13.915),(64.285,13.745),(64.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,33.125),(73.715,33.295),(73.885,33.295),(73.885,33.125),(73.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,33.465),(73.715,33.635),(73.885,33.635),(73.885,33.465),(73.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,33.465),(73.205,33.635),(73.375,33.635),(73.375,33.465),(73.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.485),(44.915,17.655),(45.085,17.655),(45.085,17.485),(44.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,36.865),(78.005,37.035),(78.175,37.035),(78.175,36.865),(78.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,36.865),(78.515,37.035),(78.685,37.035),(78.685,36.865),(78.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.825),(44.915,17.995),(45.085,17.995),(45.085,17.825),(44.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.145),(44.915,17.315),(45.085,17.315),(45.085,17.145),(44.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.525),(68.405,19.695),(68.575,19.695),(68.575,19.525),(68.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.585),(20.405,5.755),(20.575,5.755),(20.575,5.585),(20.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.185),(68.405,19.355),(68.575,19.355),(68.575,19.185),(68.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,36.525),(26.225,36.695),(26.395,36.695),(26.395,36.525),(26.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,36.185),(26.225,36.355),(26.395,36.355),(26.395,36.185),(26.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.345),(30.515,10.515),(30.685,10.515),(30.685,10.345),(30.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.505),(10.805,18.675),(10.975,18.675),(10.975,18.505),(10.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.165),(10.805,18.335),(10.975,18.335),(10.975,18.165),(10.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.425),(74.225,14.595),(74.395,14.595),(74.395,14.425),(74.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.345),(30.005,10.515),(30.175,10.515),(30.175,10.345),(30.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.965),(44.915,8.135),(45.085,8.135),(45.085,7.965),(44.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.425),(26.225,14.595),(26.395,14.595),(26.395,14.425),(26.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,27.005),(20.405,27.175),(20.575,27.175),(20.575,27.005),(20.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,27.345),(20.405,27.515),(20.575,27.515),(20.575,27.345),(20.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,27.685),(20.405,27.855),(20.575,27.855),(20.575,27.685),(20.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.565),(68.915,4.735),(69.085,4.735),(69.085,4.565),(68.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,39.925),(20.915,40.095),(21.085,40.095),(21.085,39.925),(20.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.985),(79.025,9.155),(79.195,9.155),(79.195,8.985),(79.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,30.405),(63.605,30.575),(63.775,30.575),(63.775,30.405),(63.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,21.905),(82.805,22.075),(82.975,22.075),(82.975,21.905),(82.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.345),(55.025,27.515),(55.195,27.515),(55.195,27.345),(55.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,26.665),(20.915,26.835),(21.085,26.835),(21.085,26.665),(20.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.205),(68.915,3.375),(69.085,3.375),(69.085,3.205),(68.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.545),(68.915,3.715),(69.085,3.715),(69.085,3.545),(68.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.245),(15.605,5.415),(15.775,5.415),(15.775,5.245),(15.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.725),(83.315,12.895),(83.485,12.895),(83.485,12.725),(83.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.045),(83.315,12.215),(83.485,12.215),(83.485,12.045),(83.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.105),(83.315,15.275),(83.485,15.275),(83.485,15.105),(83.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.445),(83.315,15.615),(83.485,15.615),(83.485,15.445),(83.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.985),(10.805,9.155),(10.975,9.155),(10.975,8.985),(10.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,38.905),(15.605,39.075),(15.775,39.075),(15.775,38.905),(15.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.205),(44.405,37.375),(44.575,37.375),(44.575,37.205),(44.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.545),(44.405,37.715),(44.575,37.715),(44.575,37.545),(44.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.505),(83.315,18.675),(83.485,18.675),(83.485,18.505),(83.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,35.505),(11.825,35.675),(11.995,35.675),(11.995,35.505),(11.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,35.505),(11.315,35.675),(11.485,35.675),(11.485,35.505),(11.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,35.165),(11.825,35.335),(11.995,35.335),(11.995,35.165),(11.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,35.165),(11.315,35.335),(11.485,35.335),(11.485,35.165),(11.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.105),(35.315,15.275),(35.485,15.275),(35.485,15.105),(35.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.105),(35.825,15.275),(35.995,15.275),(35.995,15.105),(35.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,40.605),(21.425,40.775),(21.595,40.775),(21.595,40.605),(21.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,40.265),(21.425,40.435),(21.595,40.435),(21.595,40.265),(21.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,24.285),(82.805,24.455),(82.975,24.455),(82.975,24.285),(82.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.265),(54.515,6.435),(54.685,6.435),(54.685,6.265),(54.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.605),(54.005,6.775),(54.175,6.775),(54.175,6.605),(54.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.265),(54.005,6.435),(54.175,6.435),(54.175,6.265),(54.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.605),(54.515,6.775),(54.685,6.775),(54.685,6.605),(54.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,36.525),(20.405,36.695),(20.575,36.695),(20.575,36.525),(20.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,36.185),(20.405,36.355),(20.575,36.355),(20.575,36.185),(20.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,28.025),(64.115,28.195),(64.285,28.195),(64.285,28.025),(64.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,28.365),(64.625,28.535),(64.795,28.535),(64.795,28.365),(64.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,28.025),(64.625,28.195),(64.795,28.195),(64.795,28.025),(64.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,28.365),(64.115,28.535),(64.285,28.535),(64.285,28.365),(64.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.845),(6.515,19.015),(6.685,19.015),(6.685,18.845),(6.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.885),(79.025,4.055),(79.195,4.055),(79.195,3.885),(79.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,27.685),(16.625,27.855),(16.795,27.855),(16.795,27.685),(16.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,27.345),(16.115,27.515),(16.285,27.515),(16.285,27.345),(16.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,27.005),(16.115,27.175),(16.285,27.175),(16.285,27.005),(16.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,27.685),(16.115,27.855),(16.285,27.855),(16.285,27.685),(16.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,27.005),(16.625,27.175),(16.795,27.175),(16.795,27.005),(16.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,27.345),(16.625,27.515),(16.795,27.515),(16.795,27.345),(16.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,30.405),(82.805,30.575),(82.975,30.575),(82.975,30.405),(82.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.885),(59.825,4.055),(59.995,4.055),(59.995,3.885),(59.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.885),(59.315,4.055),(59.485,4.055),(59.485,3.885),(59.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,23.945),(83.315,24.115),(83.485,24.115),(83.485,23.945),(83.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,37.885),(83.315,38.055),(83.485,38.055),(83.485,37.885),(83.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.505),(21.425,18.675),(21.595,18.675),(21.595,18.505),(21.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.165),(21.425,18.335),(21.595,18.335),(21.595,18.165),(21.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.965),(39.605,8.135),(39.775,8.135),(39.775,7.965),(39.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.785),(7.025,15.955),(7.195,15.955),(7.195,15.785),(7.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.865),(50.225,37.035),(50.395,37.035),(50.395,36.865),(50.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,33.125),(73.205,33.295),(73.375,33.295),(73.375,33.125),(73.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.505),(44.915,35.675),(45.085,35.675),(45.085,35.505),(44.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.165),(44.915,35.335),(45.085,35.335),(45.085,35.165),(44.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.665),(79.025,9.835),(79.195,9.835),(79.195,9.665),(79.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.325),(79.025,9.495),(79.195,9.495),(79.195,9.325),(79.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.925),(50.225,23.095),(50.395,23.095),(50.395,22.925),(50.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.065),(64.115,13.235),(64.285,13.235),(64.285,13.065),(64.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.925),(34.805,40.095),(34.975,40.095),(34.975,39.925),(34.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.225),(21.425,4.395),(21.595,4.395),(21.595,4.225),(21.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.565),(21.425,4.735),(21.595,4.735),(21.595,4.565),(21.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,34.825),(15.605,34.995),(15.775,34.995),(15.775,34.825),(15.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,34.485),(15.605,34.655),(15.775,34.655),(15.775,34.485),(15.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,34.145),(15.605,34.315),(15.775,34.315),(15.775,34.145),(15.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.045),(79.025,12.215),(79.195,12.215),(79.195,12.045),(79.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.385),(79.025,12.555),(79.195,12.555),(79.195,12.385),(79.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.725),(79.025,12.895),(79.195,12.895),(79.195,12.725),(79.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.245),(68.405,5.415),(68.575,5.415),(68.575,5.245),(68.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.905),(25.205,5.075),(25.375,5.075),(25.375,4.905),(25.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.905),(25.715,5.075),(25.885,5.075),(25.885,4.905),(25.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.645),(34.805,25.815),(34.975,25.815),(34.975,25.645),(34.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.305),(34.805,25.475),(34.975,25.475),(34.975,25.305),(34.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,23.605),(16.115,23.775),(16.285,23.775),(16.285,23.605),(16.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,23.265),(16.625,23.435),(16.795,23.435),(16.795,23.265),(16.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,23.605),(16.625,23.775),(16.795,23.775),(16.795,23.605),(16.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,23.265),(16.115,23.435),(16.285,23.435),(16.285,23.265),(16.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.785),(68.405,15.955),(68.575,15.955),(68.575,15.785),(68.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.425),(16.115,14.595),(16.285,14.595),(16.285,14.425),(16.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.085),(16.625,14.255),(16.795,14.255),(16.795,14.085),(16.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.765),(16.625,14.935),(16.795,14.935),(16.795,14.765),(16.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,36.185),(16.115,36.355),(16.285,36.355),(16.285,36.185),(16.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,36.525),(16.115,36.695),(16.285,36.695),(16.285,36.525),(16.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,35.845),(21.425,36.015),(21.595,36.015),(21.595,35.845),(21.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,30.405),(68.405,30.575),(68.575,30.575),(68.575,30.405),(68.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.605),(54.005,23.775),(54.175,23.775),(54.175,23.605),(54.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,29.045),(73.205,29.215),(73.375,29.215),(73.375,29.045),(73.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,29.725),(73.715,29.895),(73.885,29.895),(73.885,29.725),(73.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,29.725),(73.205,29.895),(73.375,29.895),(73.375,29.725),(73.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,29.385),(73.205,29.555),(73.375,29.555),(73.375,29.385),(73.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.605),(54.515,23.775),(54.685,23.775),(54.685,23.605),(54.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,30.065),(68.405,30.235),(68.575,30.235),(68.575,30.065),(68.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,29.045),(73.715,29.215),(73.885,29.215),(73.885,29.045),(73.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,29.385),(73.715,29.555),(73.885,29.555),(73.885,29.385),(73.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.145),(25.205,17.315),(25.375,17.315),(25.375,17.145),(25.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.485),(7.025,17.655),(7.195,17.655),(7.195,17.485),(7.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.825),(25.205,17.995),(25.375,17.995),(25.375,17.825),(25.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.825),(25.715,17.995),(25.885,17.995),(25.885,17.825),(25.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.485),(25.205,17.655),(25.375,17.655),(25.375,17.485),(25.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.485),(25.715,17.655),(25.885,17.655),(25.885,17.485),(25.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.125),(34.805,33.295),(34.975,33.295),(34.975,33.125),(34.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.465),(34.805,33.635),(34.975,33.635),(34.975,33.465),(34.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.805),(34.805,33.975),(34.975,33.975),(34.975,33.805),(34.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.145),(25.715,17.315),(25.885,17.315),(25.885,17.145),(25.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,30.065),(25.715,30.235),(25.885,30.235),(25.885,30.065),(25.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,30.405),(25.715,30.575),(25.885,30.575),(25.885,30.405),(25.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,30.065),(25.205,30.235),(25.375,30.235),(25.375,30.065),(25.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,30.405),(25.205,30.575),(25.375,30.575),(25.375,30.405),(25.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,30.745),(25.715,30.915),(25.885,30.915),(25.885,30.745),(25.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,30.745),(25.205,30.915),(25.375,30.915),(25.375,30.745),(25.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.505),(30.005,18.675),(30.175,18.675),(30.175,18.505),(30.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.165),(30.515,18.335),(30.685,18.335),(30.685,18.165),(30.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.905),(44.405,39.075),(44.575,39.075),(44.575,38.905),(44.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.165),(68.915,18.335),(69.085,18.335),(69.085,18.165),(68.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.245),(20.915,5.415),(21.085,5.415),(21.085,5.245),(20.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.785),(55.025,15.955),(55.195,15.955),(55.195,15.785),(55.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.585),(44.405,22.755),(44.575,22.755),(44.575,22.585),(44.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.445),(50.225,15.615),(50.395,15.615),(50.395,15.445),(50.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.105),(50.225,15.275),(50.395,15.275),(50.395,15.105),(50.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,21.225),(73.715,21.395),(73.885,21.395),(73.885,21.225),(73.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,21.225),(73.205,21.395),(73.375,21.395),(73.375,21.225),(73.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.105),(59.825,15.275),(59.995,15.275),(59.995,15.105),(59.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.105),(59.315,15.275),(59.485,15.275),(59.485,15.105),(59.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.445),(59.315,15.615),(59.485,15.615),(59.485,15.445),(59.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.445),(59.825,15.615),(59.995,15.615),(59.995,15.445),(59.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,23.945),(73.205,24.115),(73.375,24.115),(73.375,23.945),(73.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,23.945),(73.715,24.115),(73.885,24.115),(73.885,23.945),(73.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.225),(55.025,38.395),(55.195,38.395),(55.195,38.225),(55.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.565),(55.025,38.735),(55.195,38.735),(55.195,38.565),(55.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.445),(11.315,15.615),(11.485,15.615),(11.485,15.445),(11.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.445),(11.825,15.615),(11.995,15.615),(11.995,15.445),(11.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,22.245),(74.225,22.415),(74.395,22.415),(74.395,22.245),(74.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.325),(73.205,9.495),(73.375,9.495),(73.375,9.325),(73.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.665),(73.715,9.835),(73.885,9.835),(73.885,9.665),(73.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.665),(73.205,9.835),(73.375,9.835),(73.375,9.665),(73.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.325),(73.715,9.495),(73.885,9.495),(73.885,9.325),(73.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,31.085),(21.425,31.255),(21.595,31.255),(21.595,31.085),(21.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,31.425),(21.425,31.595),(21.595,31.595),(21.595,31.425),(21.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,31.765),(21.425,31.935),(21.595,31.935),(21.595,31.765),(21.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,23.265),(68.915,23.435),(69.085,23.435),(69.085,23.265),(68.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,23.605),(68.915,23.775),(69.085,23.775),(69.085,23.605),(68.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.325),(25.715,9.495),(25.885,9.495),(25.885,9.325),(25.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.325),(25.205,9.495),(25.375,9.495),(25.375,9.325),(25.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.905),(30.515,39.075),(30.685,39.075),(30.685,38.905),(30.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.405),(44.405,30.575),(44.575,30.575),(44.575,30.405),(44.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,29.385),(74.225,29.555),(74.395,29.555),(74.395,29.385),(74.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,40.265),(82.805,40.435),(82.975,40.435),(82.975,40.265),(82.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,40.605),(82.805,40.775),(82.975,40.775),(82.975,40.605),(82.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,33.465),(68.405,33.635),(68.575,33.635),(68.575,33.465),(68.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,33.805),(68.405,33.975),(68.575,33.975),(68.575,33.805),(68.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,33.125),(68.405,33.295),(68.575,33.295),(68.575,33.125),(68.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.905),(6.515,5.075),(6.685,5.075),(6.685,4.905),(6.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,20.885),(68.915,21.055),(69.085,21.055),(69.085,20.885),(68.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,27.005),(10.805,27.175),(10.975,27.175),(10.975,27.005),(10.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,27.345),(10.805,27.515),(10.975,27.515),(10.975,27.345),(10.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,27.685),(10.805,27.855),(10.975,27.855),(10.975,27.685),(10.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,34.485),(74.225,34.655),(74.395,34.655),(74.395,34.485),(74.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,34.825),(74.225,34.995),(74.395,34.995),(74.395,34.825),(74.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,34.145),(74.225,34.315),(74.395,34.315),(74.395,34.145),(74.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.245),(64.625,5.415),(64.795,5.415),(64.795,5.245),(64.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.245),(64.115,5.415),(64.285,5.415),(64.285,5.245),(64.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.605),(82.805,6.775),(82.975,6.775),(82.975,6.605),(82.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.265),(82.805,6.435),(82.975,6.435),(82.975,6.265),(82.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,28.025),(82.805,28.195),(82.975,28.195),(82.975,28.025),(82.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,28.365),(82.805,28.535),(82.975,28.535),(82.975,28.365),(82.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,28.705),(82.805,28.875),(82.975,28.875),(82.975,28.705),(82.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.945),(31.025,24.115),(31.195,24.115),(31.195,23.945),(31.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.785),(30.005,15.955),(30.175,15.955),(30.175,15.785),(30.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,24.285),(21.425,24.455),(21.595,24.455),(21.595,24.285),(21.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,39.925),(69.425,40.095),(69.595,40.095),(69.595,39.925),(69.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,24.625),(10.805,24.795),(10.975,24.795),(10.975,24.625),(10.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,24.285),(10.805,24.455),(10.975,24.455),(10.975,24.285),(10.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.225),(69.425,4.395),(69.595,4.395),(69.595,4.225),(69.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.365),(79.025,11.535),(79.195,11.535),(79.195,11.365),(79.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.025),(79.025,11.195),(79.195,11.195),(79.195,11.025),(79.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.705),(79.025,11.875),(79.195,11.875),(79.195,11.705),(79.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.005),(40.625,27.175),(40.795,27.175),(40.795,27.005),(40.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.685),(40.625,27.855),(40.795,27.855),(40.795,27.685),(40.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.005),(40.115,27.175),(40.285,27.175),(40.285,27.005),(40.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.685),(40.115,27.855),(40.285,27.855),(40.285,27.685),(40.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.525),(10.805,19.695),(10.975,19.695),(10.975,19.525),(10.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.365),(30.515,11.535),(30.685,11.535),(30.685,11.365),(30.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.025),(30.515,11.195),(30.685,11.195),(30.685,11.025),(30.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.705),(30.515,11.875),(30.685,11.875),(30.685,11.705),(30.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.985),(73.715,9.155),(73.885,9.155),(73.885,8.985),(73.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.985),(73.205,9.155),(73.375,9.155),(73.375,8.985),(73.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.485),(49.205,34.655),(49.375,34.655),(49.375,34.485),(49.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.145),(49.715,34.315),(49.885,34.315),(49.885,34.145),(49.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.145),(49.205,34.315),(49.375,34.315),(49.375,34.145),(49.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.825),(49.715,34.995),(49.885,34.995),(49.885,34.825),(49.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.825),(49.205,34.995),(49.375,34.995),(49.375,34.825),(49.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.485),(49.715,34.655),(49.885,34.655),(49.885,34.485),(49.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.425),(35.825,14.595),(35.995,14.595),(35.995,14.425),(35.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.425),(35.315,14.595),(35.485,14.595),(35.485,14.425),(35.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.785),(44.405,15.955),(44.575,15.955),(44.575,15.785),(44.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,34.145),(6.515,34.315),(6.685,34.315),(6.685,34.145),(6.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.145),(58.805,34.315),(58.975,34.315),(58.975,34.145),(58.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.485),(58.805,34.655),(58.975,34.655),(58.975,34.485),(58.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,34.485),(6.515,34.655),(6.685,34.655),(6.685,34.485),(6.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,34.825),(6.515,34.995),(6.685,34.995),(6.685,34.825),(6.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.825),(58.805,34.995),(58.975,34.995),(58.975,34.825),(58.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,21.905),(20.405,22.075),(20.575,22.075),(20.575,21.905),(20.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,24.625),(78.005,24.795),(78.175,24.795),(78.175,24.625),(78.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,24.625),(78.515,24.795),(78.685,24.795),(78.685,24.625),(78.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,26.325),(15.605,26.495),(15.775,26.495),(15.775,26.325),(15.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.045),(30.005,12.215),(30.175,12.215),(30.175,12.045),(30.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.385),(30.515,12.555),(30.685,12.555),(30.685,12.385),(30.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.725),(30.515,12.895),(30.685,12.895),(30.685,12.725),(30.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.045),(30.515,12.215),(30.685,12.215),(30.685,12.045),(30.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.385),(30.005,12.555),(30.175,12.555),(30.175,12.385),(30.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.725),(30.005,12.895),(30.175,12.895),(30.175,12.725),(30.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.905),(54.515,5.075),(54.685,5.075),(54.685,4.905),(54.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.905),(10.805,5.075),(10.975,5.075),(10.975,4.905),(10.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.905),(54.005,5.075),(54.175,5.075),(54.175,4.905),(54.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,39.585),(16.115,39.755),(16.285,39.755),(16.285,39.585),(16.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,39.245),(16.115,39.415),(16.285,39.415),(16.285,39.245),(16.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.185),(78.005,19.355),(78.175,19.355),(78.175,19.185),(78.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.525),(78.005,19.695),(78.175,19.695),(78.175,19.525),(78.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.185),(78.515,19.355),(78.685,19.355),(78.685,19.185),(78.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.525),(78.515,19.695),(78.685,19.695),(78.685,19.525),(78.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.885),(16.115,4.055),(16.285,4.055),(16.285,3.885),(16.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.585),(68.915,5.755),(69.085,5.755),(69.085,5.585),(68.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.045),(58.805,12.215),(58.975,12.215),(58.975,12.045),(58.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.725),(58.805,12.895),(58.975,12.895),(58.975,12.725),(58.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.385),(58.805,12.555),(58.975,12.555),(58.975,12.385),(58.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.905),(82.805,5.075),(82.975,5.075),(82.975,4.905),(82.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.985),(64.115,9.155),(64.285,9.155),(64.285,8.985),(64.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.985),(64.625,9.155),(64.795,9.155),(64.795,8.985),(64.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,39.925),(20.405,40.095),(20.575,40.095),(20.575,39.925),(20.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.285),(74.225,7.455),(74.395,7.455),(74.395,7.285),(74.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.385),(10.805,12.555),(10.975,12.555),(10.975,12.385),(10.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.725),(10.805,12.895),(10.975,12.895),(10.975,12.725),(10.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.045),(10.805,12.215),(10.975,12.215),(10.975,12.045),(10.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.205),(15.605,3.375),(15.775,3.375),(15.775,3.205),(15.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.545),(15.605,3.715),(15.775,3.715),(15.775,3.545),(15.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,20.885),(69.425,21.055),(69.595,21.055),(69.595,20.885),(69.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,20.885),(63.605,21.055),(63.775,21.055),(63.775,20.885),(63.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.625),(26.225,7.795),(26.395,7.795),(26.395,7.625),(26.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.245),(40.625,39.415),(40.795,39.415),(40.795,39.245),(40.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.245),(40.115,39.415),(40.285,39.415),(40.285,39.245),(40.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,24.285),(63.605,24.455),(63.775,24.455),(63.775,24.285),(63.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,24.625),(63.605,24.795),(63.775,24.795),(63.775,24.625),(63.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.585),(40.115,39.755),(40.285,39.755),(40.285,39.585),(40.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.585),(40.625,39.755),(40.795,39.755),(40.795,39.585),(40.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,23.265),(69.425,23.435),(69.595,23.435),(69.595,23.265),(69.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,23.605),(69.425,23.775),(69.595,23.775),(69.595,23.605),(69.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,22.245),(69.425,22.415),(69.595,22.415),(69.595,22.245),(69.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,36.185),(11.315,36.355),(11.485,36.355),(11.485,36.185),(11.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,36.525),(11.315,36.695),(11.485,36.695),(11.485,36.525),(11.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,36.185),(11.825,36.355),(11.995,36.355),(11.995,36.185),(11.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,36.525),(11.825,36.695),(11.995,36.695),(11.995,36.525),(11.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.425),(11.825,14.595),(11.995,14.595),(11.995,14.425),(11.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.425),(11.315,14.595),(11.485,14.595),(11.485,14.425),(11.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.865),(10.805,20.035),(10.975,20.035),(10.975,19.865),(10.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,35.845),(68.405,36.015),(68.575,36.015),(68.575,35.845),(68.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,28.365),(16.625,28.535),(16.795,28.535),(16.795,28.365),(16.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,28.025),(16.625,28.195),(16.795,28.195),(16.795,28.025),(16.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.105),(78.005,15.275),(78.175,15.275),(78.175,15.105),(78.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.105),(78.515,15.275),(78.685,15.275),(78.685,15.105),(78.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,28.365),(16.115,28.535),(16.285,28.535),(16.285,28.365),(16.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,28.025),(16.115,28.195),(16.285,28.195),(16.285,28.025),(16.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,26.665),(26.225,26.835),(26.395,26.835),(26.395,26.665),(26.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,26.325),(26.225,26.495),(26.395,26.495),(26.395,26.325),(26.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,37.205),(78.005,37.375),(78.175,37.375),(78.175,37.205),(78.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,37.205),(78.515,37.375),(78.685,37.375),(78.685,37.205),(78.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,37.545),(78.515,37.715),(78.685,37.715),(78.685,37.545),(78.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,37.545),(78.005,37.715),(78.175,37.715),(78.175,37.545),(78.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.465),(69.425,16.635),(69.595,16.635),(69.595,16.465),(69.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.805),(69.425,16.975),(69.595,16.975),(69.595,16.805),(69.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.125),(69.425,16.295),(69.595,16.295),(69.595,16.125),(69.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.505),(34.805,18.675),(34.975,18.675),(34.975,18.505),(34.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.125),(63.605,16.295),(63.775,16.295),(63.775,16.125),(63.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.805),(63.605,16.975),(63.775,16.975),(63.775,16.805),(63.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.285),(49.205,24.455),(49.375,24.455),(49.375,24.285),(49.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.625),(49.205,24.795),(49.375,24.795),(49.375,24.625),(49.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.285),(49.715,24.455),(49.885,24.455),(49.885,24.285),(49.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.625),(49.715,24.795),(49.885,24.795),(49.885,24.625),(49.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,26.665),(54.515,26.835),(54.685,26.835),(54.685,26.665),(54.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,39.925),(16.625,40.095),(16.795,40.095),(16.795,39.925),(16.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,26.665),(54.005,26.835),(54.175,26.835),(54.175,26.665),(54.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,21.565),(59.825,21.735),(59.995,21.735),(59.995,21.565),(59.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.565),(59.315,21.735),(59.485,21.735),(59.485,21.565),(59.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.085),(6.515,14.255),(6.685,14.255),(6.685,14.085),(6.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.765),(6.515,14.935),(6.685,14.935),(6.685,14.765),(6.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.505),(26.225,18.675),(26.395,18.675),(26.395,18.505),(26.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.165),(26.225,18.335),(26.395,18.335),(26.395,18.165),(26.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,25.645),(78.515,25.815),(78.685,25.815),(78.685,25.645),(78.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,25.645),(78.005,25.815),(78.175,25.815),(78.175,25.645),(78.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,25.305),(78.005,25.475),(78.175,25.475),(78.175,25.305),(78.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,25.305),(78.515,25.475),(78.685,25.475),(78.685,25.305),(78.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,25.985),(73.205,26.155),(73.375,26.155),(73.375,25.985),(73.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,25.985),(73.715,26.155),(73.885,26.155),(73.885,25.985),(73.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.425),(59.315,14.595),(59.485,14.595),(59.485,14.425),(59.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.425),(59.825,14.595),(59.995,14.595),(59.995,14.425),(59.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,2.865),(11.825,3.035),(11.995,3.035),(11.995,2.865),(11.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,2.865),(11.315,3.035),(11.485,3.035),(11.485,2.865),(11.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.745),(20.915,13.915),(21.085,13.915),(21.085,13.745),(20.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.065),(20.915,13.235),(21.085,13.235),(21.085,13.065),(20.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.405),(20.915,13.575),(21.085,13.575),(21.085,13.405),(20.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.285),(30.515,24.455),(30.685,24.455),(30.685,24.285),(30.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,24.285),(30.005,24.455),(30.175,24.455),(30.175,24.285),(30.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.625),(30.515,24.795),(30.685,24.795),(30.685,24.625),(30.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,24.625),(30.005,24.795),(30.175,24.795),(30.175,24.625),(30.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,38.905),(82.805,39.075),(82.975,39.075),(82.975,38.905),(82.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,29.725),(83.315,29.895),(83.485,29.895),(83.485,29.725),(83.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,29.385),(83.315,29.555),(83.485,29.555),(83.485,29.385),(83.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,29.045),(83.315,29.215),(83.485,29.215),(83.485,29.045),(83.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.845),(68.405,19.015),(68.575,19.015),(68.575,18.845),(68.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.185),(30.515,19.355),(30.685,19.355),(30.685,19.185),(30.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.525),(30.515,19.695),(30.685,19.695),(30.685,19.525),(30.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.845),(78.005,19.015),(78.175,19.015),(78.175,18.845),(78.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.845),(78.515,19.015),(78.685,19.015),(78.685,18.845),(78.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.625),(50.225,7.795),(50.395,7.795),(50.395,7.625),(50.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,30.405),(78.515,30.575),(78.685,30.575),(78.685,30.405),(78.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,30.405),(78.005,30.575),(78.175,30.575),(78.175,30.405),(78.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,30.065),(78.005,30.235),(78.175,30.235),(78.175,30.065),(78.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,30.065),(78.515,30.235),(78.685,30.235),(78.685,30.065),(78.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,30.745),(78.005,30.915),(78.175,30.915),(78.175,30.745),(78.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,30.745),(78.515,30.915),(78.685,30.915),(78.685,30.745),(78.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,40.605),(31.025,40.775),(31.195,40.775),(31.195,40.605),(31.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,40.265),(31.025,40.435),(31.195,40.435),(31.195,40.265),(31.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.345),(58.805,10.515),(58.975,10.515),(58.975,10.345),(58.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,33.805),(79.025,33.975),(79.195,33.975),(79.195,33.805),(79.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,33.125),(79.025,33.295),(79.195,33.295),(79.195,33.125),(79.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,33.465),(79.025,33.635),(79.195,33.635),(79.195,33.465),(79.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.465),(74.225,16.635),(74.395,16.635),(74.395,16.465),(74.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.865),(45.425,3.035),(45.595,3.035),(45.595,2.865),(45.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,26.325),(39.605,26.495),(39.775,26.495),(39.775,26.325),(39.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.425),(54.515,14.595),(54.685,14.595),(54.685,14.425),(54.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.425),(54.005,14.595),(54.175,14.595),(54.175,14.425),(54.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,29.385),(6.515,29.555),(6.685,29.555),(6.685,29.385),(6.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.685),(31.025,10.855),(31.195,10.855),(31.195,10.685),(31.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.345),(31.025,10.515),(31.195,10.515),(31.195,10.345),(31.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.005),(31.025,10.175),(31.195,10.175),(31.195,10.005),(31.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.225),(54.515,21.395),(54.685,21.395),(54.685,21.225),(54.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.565),(54.005,21.735),(54.175,21.735),(54.175,21.565),(54.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.225),(54.005,21.395),(54.175,21.395),(54.175,21.225),(54.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.565),(54.515,21.735),(54.685,21.735),(54.685,21.565),(54.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.185),(7.025,19.355),(7.195,19.355),(7.195,19.185),(7.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.505),(79.025,18.675),(79.195,18.675),(79.195,18.505),(79.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.165),(79.025,18.335),(79.195,18.335),(79.195,18.165),(79.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.625),(45.425,7.795),(45.595,7.795),(45.595,7.625),(45.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.385),(44.915,12.555),(45.085,12.555),(45.085,12.385),(44.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,40.265),(10.805,40.435),(10.975,40.435),(10.975,40.265),(10.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,40.605),(10.805,40.775),(10.975,40.775),(10.975,40.605),(10.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,22.585),(78.005,22.755),(78.175,22.755),(78.175,22.585),(78.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,22.585),(78.515,22.755),(78.685,22.755),(78.685,22.585),(78.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.265),(39.605,23.435),(39.775,23.435),(39.775,23.265),(39.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.485),(45.425,17.655),(45.595,17.655),(45.595,17.485),(45.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.145),(45.425,17.315),(45.595,17.315),(45.595,17.145),(45.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.825),(45.425,17.995),(45.595,17.995),(45.595,17.825),(45.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,24.625),(73.205,24.795),(73.375,24.795),(73.375,24.625),(73.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,24.625),(73.715,24.795),(73.885,24.795),(73.885,24.625),(73.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,35.165),(10.805,35.335),(10.975,35.335),(10.975,35.165),(10.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,35.505),(10.805,35.675),(10.975,35.675),(10.975,35.505),(10.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.605),(55.025,6.775),(55.195,6.775),(55.195,6.605),(55.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.265),(55.025,6.435),(55.195,6.435),(55.195,6.265),(55.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.845),(39.605,36.015),(39.775,36.015),(39.775,35.845),(39.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.945),(83.315,7.115),(83.485,7.115),(83.485,6.945),(83.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.865),(30.005,20.035),(30.175,20.035),(30.175,19.865),(30.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.845),(44.915,19.015),(45.085,19.015),(45.085,18.845),(44.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.565),(45.425,21.735),(45.595,21.735),(45.595,21.565),(45.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.525),(83.315,19.695),(83.485,19.695),(83.485,19.525),(83.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.625),(68.405,7.795),(68.575,7.795),(68.575,7.625),(68.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,25.305),(10.805,25.475),(10.975,25.475),(10.975,25.305),(10.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,25.645),(10.805,25.815),(10.975,25.815),(10.975,25.645),(10.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.285),(20.405,7.455),(20.575,7.455),(20.575,7.285),(20.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.805),(44.915,16.975),(45.085,16.975),(45.085,16.805),(44.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.125),(44.915,16.295),(45.085,16.295),(45.085,16.125),(44.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,30.065),(26.225,30.235),(26.395,30.235),(26.395,30.065),(26.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,30.745),(26.225,30.915),(26.395,30.915),(26.395,30.745),(26.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.945),(78.515,7.115),(78.685,7.115),(78.685,6.945),(78.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.945),(78.005,7.115),(78.175,7.115),(78.175,6.945),(78.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,21.905),(10.805,22.075),(10.975,22.075),(10.975,21.905),(10.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,24.965),(15.605,25.135),(15.775,25.135),(15.775,24.965),(15.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.305),(55.025,8.475),(55.195,8.475),(55.195,8.305),(55.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,36.865),(26.225,37.035),(26.395,37.035),(26.395,36.865),(26.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.585),(34.805,22.755),(34.975,22.755),(34.975,22.585),(34.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.245),(34.805,22.415),(34.975,22.415),(34.975,22.245),(34.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.645),(7.025,8.815),(7.195,8.815),(7.195,8.645),(7.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.845),(10.805,19.015),(10.975,19.015),(10.975,18.845),(10.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.645),(34.805,8.815),(34.975,8.815),(34.975,8.645),(34.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.185),(39.605,36.355),(39.775,36.355),(39.775,36.185),(39.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.525),(39.605,36.695),(39.775,36.695),(39.775,36.525),(39.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.185),(21.425,19.355),(21.595,19.355),(21.595,19.185),(21.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.025),(64.625,11.195),(64.795,11.195),(64.795,11.025),(64.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.705),(64.115,11.875),(64.285,11.875),(64.285,11.705),(64.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.705),(64.625,11.875),(64.795,11.875),(64.795,11.705),(64.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.025),(64.115,11.195),(64.285,11.195),(64.285,11.025),(64.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.305),(68.405,8.475),(68.575,8.475),(68.575,8.305),(68.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.645),(68.405,8.815),(68.575,8.815),(68.575,8.645),(68.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.685),(54.515,27.855),(54.685,27.855),(54.685,27.685),(54.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.005),(54.515,27.175),(54.685,27.175),(54.685,27.005),(54.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.685),(54.005,27.855),(54.175,27.855),(54.175,27.685),(54.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.005),(54.005,27.175),(54.175,27.175),(54.175,27.005),(54.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,29.725),(7.025,29.895),(7.195,29.895),(7.195,29.725),(7.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,29.045),(7.025,29.215),(7.195,29.215),(7.195,29.045),(7.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,31.765),(83.315,31.935),(83.485,31.935),(83.485,31.765),(83.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,31.085),(83.315,31.255),(83.485,31.255),(83.485,31.085),(83.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,31.425),(83.315,31.595),(83.485,31.595),(83.485,31.425),(83.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.265),(35.825,23.435),(35.995,23.435),(35.995,23.265),(35.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.265),(35.315,23.435),(35.485,23.435),(35.485,23.265),(35.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,35.165),(30.005,35.335),(30.175,35.335),(30.175,35.165),(30.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,35.505),(30.005,35.675),(30.175,35.675),(30.175,35.505),(30.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.785),(49.205,15.955),(49.375,15.955),(49.375,15.785),(49.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.785),(49.715,15.955),(49.885,15.955),(49.885,15.785),(49.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,21.905),(21.425,22.075),(21.595,22.075),(21.595,21.905),(21.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,39.925),(78.515,40.095),(78.685,40.095),(78.685,39.925),(78.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,39.925),(78.005,40.095),(78.175,40.095),(78.175,39.925),(78.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.545),(45.425,20.715),(45.595,20.715),(45.595,20.545),(45.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,36.185),(79.025,36.355),(79.195,36.355),(79.195,36.185),(79.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,34.145),(69.425,34.315),(69.595,34.315),(69.595,34.145),(69.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,34.485),(69.425,34.655),(69.595,34.655),(69.595,34.485),(69.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,34.825),(69.425,34.995),(69.595,34.995),(69.595,34.825),(69.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,36.525),(79.025,36.695),(79.195,36.695),(79.195,36.525),(79.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.345),(73.205,10.515),(73.375,10.515),(73.375,10.345),(73.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.005),(73.715,10.175),(73.885,10.175),(73.885,10.005),(73.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.345),(73.715,10.515),(73.885,10.515),(73.885,10.345),(73.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.005),(73.205,10.175),(73.375,10.175),(73.375,10.005),(73.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.545),(59.315,20.715),(59.485,20.715),(59.485,20.545),(59.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,20.545),(59.825,20.715),(59.995,20.715),(59.995,20.545),(59.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.685),(73.715,10.855),(73.885,10.855),(73.885,10.685),(73.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.685),(73.205,10.855),(73.375,10.855),(73.375,10.685),(73.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.225),(58.805,21.395),(58.975,21.395),(58.975,21.225),(58.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.565),(58.805,21.735),(58.975,21.735),(58.975,21.565),(58.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.365),(40.625,28.535),(40.795,28.535),(40.795,28.365),(40.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.025),(40.625,28.195),(40.795,28.195),(40.795,28.025),(40.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.705),(40.115,28.875),(40.285,28.875),(40.285,28.705),(40.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.025),(40.115,28.195),(40.285,28.195),(40.285,28.025),(40.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.365),(40.115,28.535),(40.285,28.535),(40.285,28.365),(40.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.705),(40.625,28.875),(40.795,28.875),(40.795,28.705),(40.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,24.965),(82.805,25.135),(82.975,25.135),(82.975,24.965),(82.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,26.325),(35.315,26.495),(35.485,26.495),(35.485,26.325),(35.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,26.325),(35.825,26.495),(35.995,26.495),(35.995,26.325),(35.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.165),(54.005,35.335),(54.175,35.335),(54.175,35.165),(54.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.165),(54.515,35.335),(54.685,35.335),(54.685,35.165),(54.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.505),(54.515,35.675),(54.685,35.675),(54.685,35.505),(54.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.505),(54.005,35.675),(54.175,35.675),(54.175,35.505),(54.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.945),(54.005,7.115),(54.175,7.115),(54.175,6.945),(54.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,29.385),(79.025,29.555),(79.195,29.555),(79.195,29.385),(79.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.625),(64.115,7.795),(64.285,7.795),(64.285,7.625),(64.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.625),(64.625,7.795),(64.795,7.795),(64.795,7.625),(64.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,28.365),(79.025,28.535),(79.195,28.535),(79.195,28.365),(79.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,28.025),(79.025,28.195),(79.195,28.195),(79.195,28.025),(79.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,27.345),(26.225,27.515),(26.395,27.515),(26.395,27.345),(26.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,36.865),(20.405,37.035),(20.575,37.035),(20.575,36.865),(20.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,26.665),(63.605,26.835),(63.775,26.835),(63.775,26.665),(63.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,39.245),(15.605,39.415),(15.775,39.415),(15.775,39.245),(15.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,39.585),(15.605,39.755),(15.775,39.755),(15.775,39.585),(15.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.185),(73.715,19.355),(73.885,19.355),(73.885,19.185),(73.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.185),(73.205,19.355),(73.375,19.355),(73.375,19.185),(73.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,28.025),(69.425,28.195),(69.595,28.195),(69.595,28.025),(69.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,28.365),(69.425,28.535),(69.595,28.535),(69.595,28.365),(69.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,28.705),(59.825,28.875),(59.995,28.875),(59.995,28.705),(59.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.705),(59.315,28.875),(59.485,28.875),(59.485,28.705),(59.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,37.545),(83.315,37.715),(83.485,37.715),(83.485,37.545),(83.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,37.205),(83.315,37.375),(83.485,37.375),(83.485,37.205),(83.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,24.625),(26.225,24.795),(26.395,24.795),(26.395,24.625),(26.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.845),(21.425,19.015),(21.595,19.015),(21.595,18.845),(21.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.085),(34.805,31.255),(34.975,31.255),(34.975,31.085),(34.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.765),(34.805,31.935),(34.975,31.935),(34.975,31.765),(34.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.485),(79.025,17.655),(79.195,17.655),(79.195,17.485),(79.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.525),(35.825,36.695),(35.995,36.695),(35.995,36.525),(35.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.185),(35.315,36.355),(35.485,36.355),(35.485,36.185),(35.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.525),(35.315,36.695),(35.485,36.695),(35.485,36.525),(35.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.185),(35.825,36.355),(35.995,36.355),(35.995,36.185),(35.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.185),(26.225,19.355),(26.395,19.355),(26.395,19.185),(26.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.525),(26.225,19.695),(26.395,19.695),(26.395,19.525),(26.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.285),(16.115,7.455),(16.285,7.455),(16.285,7.285),(16.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.845),(30.515,36.015),(30.685,36.015),(30.685,35.845),(30.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.245),(34.805,39.415),(34.975,39.415),(34.975,39.245),(34.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.585),(34.805,39.755),(34.975,39.755),(34.975,39.585),(34.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.905),(21.425,5.075),(21.595,5.075),(21.595,4.905),(21.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.405),(40.115,13.575),(40.285,13.575),(40.285,13.405),(40.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.625),(54.515,24.795),(54.685,24.795),(54.685,24.625),(54.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.405),(40.625,13.575),(40.795,13.575),(40.795,13.405),(40.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.625),(54.005,24.795),(54.175,24.795),(54.175,24.625),(54.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.585),(7.025,5.755),(7.195,5.755),(7.195,5.585),(7.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.245),(7.025,5.415),(7.195,5.415),(7.195,5.245),(7.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,38.225),(16.115,38.395),(16.285,38.395),(16.285,38.225),(16.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,38.565),(16.115,38.735),(16.285,38.735),(16.285,38.565),(16.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.145),(20.915,17.315),(21.085,17.315),(21.085,17.145),(20.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.485),(20.915,17.655),(21.085,17.655),(21.085,17.485),(20.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.305),(30.515,25.475),(30.685,25.475),(30.685,25.305),(30.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.825),(20.915,17.995),(21.085,17.995),(21.085,17.825),(20.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,25.305),(30.005,25.475),(30.175,25.475),(30.175,25.305),(30.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.265),(74.225,6.435),(74.395,6.435),(74.395,6.265),(74.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,25.985),(83.315,26.155),(83.485,26.155),(83.485,25.985),(83.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.285),(68.915,7.455),(69.085,7.455),(69.085,7.285),(68.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,36.865),(16.115,37.035),(16.285,37.035),(16.285,36.865),(16.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.245),(39.605,22.415),(39.775,22.415),(39.775,22.245),(39.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.585),(39.605,22.755),(39.775,22.755),(39.775,22.585),(39.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.325),(16.115,9.495),(16.285,9.495),(16.285,9.325),(16.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.325),(16.625,9.495),(16.795,9.495),(16.795,9.325),(16.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.665),(16.625,9.835),(16.795,9.835),(16.795,9.665),(16.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.665),(16.115,9.835),(16.285,9.835),(16.285,9.665),(16.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.965),(64.115,8.135),(64.285,8.135),(64.285,7.965),(64.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.965),(64.625,8.135),(64.795,8.135),(64.795,7.965),(64.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.625),(20.915,7.795),(21.085,7.795),(21.085,7.625),(20.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.165),(49.715,18.335),(49.885,18.335),(49.885,18.165),(49.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.165),(49.205,18.335),(49.375,18.335),(49.375,18.165),(49.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.525),(34.805,19.695),(34.975,19.695),(34.975,19.525),(34.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.185),(34.805,19.355),(34.975,19.355),(34.975,19.185),(34.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.245),(31.025,5.415),(31.195,5.415),(31.195,5.245),(31.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,26.665),(45.425,26.835),(45.595,26.835),(45.595,26.665),(45.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,26.325),(45.425,26.495),(45.595,26.495),(45.595,26.325),(45.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.845),(30.515,19.015),(30.685,19.015),(30.685,18.845),(30.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.425),(59.315,31.595),(59.485,31.595),(59.485,31.425),(59.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,31.425),(59.825,31.595),(59.995,31.595),(59.995,31.425),(59.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,30.065),(30.005,30.235),(30.175,30.235),(30.175,30.065),(30.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.405),(30.515,30.575),(30.685,30.575),(30.685,30.405),(30.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,30.745),(30.005,30.915),(30.175,30.915),(30.175,30.745),(30.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,28.705),(7.025,28.875),(7.195,28.875),(7.195,28.705),(7.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,30.065),(83.315,30.235),(83.485,30.235),(83.485,30.065),(83.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,30.745),(83.315,30.915),(83.485,30.915),(83.485,30.745),(83.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,40.265),(16.625,40.435),(16.795,40.435),(16.795,40.265),(16.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,40.605),(16.625,40.775),(16.795,40.775),(16.795,40.605),(16.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.265),(50.225,6.435),(50.395,6.435),(50.395,6.265),(50.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,37.885),(74.225,38.055),(74.395,38.055),(74.395,37.885),(74.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.585),(55.025,5.755),(55.195,5.755),(55.195,5.585),(55.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.245),(55.025,5.415),(55.195,5.415),(55.195,5.245),(55.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.905),(55.025,39.075),(55.195,39.075),(55.195,38.905),(55.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,22.925),(74.225,23.095),(74.395,23.095),(74.395,22.925),(74.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.725),(31.025,29.895),(31.195,29.895),(31.195,29.725),(31.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.045),(31.025,29.215),(31.195,29.215),(31.195,29.045),(31.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.385),(31.025,29.555),(31.195,29.555),(31.195,29.385),(31.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.585),(30.515,22.755),(30.685,22.755),(30.685,22.585),(30.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.245),(30.515,22.415),(30.685,22.415),(30.685,22.245),(30.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,34.485),(7.025,34.655),(7.195,34.655),(7.195,34.485),(7.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,26.665),(55.025,26.835),(55.195,26.835),(55.195,26.665),(55.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,34.145),(7.025,34.315),(7.195,34.315),(7.195,34.145),(7.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,34.825),(7.025,34.995),(7.195,34.995),(7.195,34.825),(7.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,29.725),(20.405,29.895),(20.575,29.895),(20.575,29.725),(20.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,29.045),(20.405,29.215),(20.575,29.215),(20.575,29.045),(20.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.165),(44.405,18.335),(44.575,18.335),(44.575,18.165),(44.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,27.685),(15.605,27.855),(15.775,27.855),(15.775,27.685),(15.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,27.005),(15.605,27.175),(15.775,27.175),(15.775,27.005),(15.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.625),(59.825,7.795),(59.995,7.795),(59.995,7.625),(59.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.625),(59.315,7.795),(59.485,7.795),(59.485,7.625),(59.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,20.205),(68.915,20.375),(69.085,20.375),(69.085,20.205),(68.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,20.545),(68.915,20.715),(69.085,20.715),(69.085,20.545),(68.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.525),(58.805,36.695),(58.975,36.695),(58.975,36.525),(58.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.185),(58.805,36.355),(58.975,36.355),(58.975,36.185),(58.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.125),(59.825,16.295),(59.995,16.295),(59.995,16.125),(59.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.465),(59.825,16.635),(59.995,16.635),(59.995,16.465),(59.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.805),(59.315,16.975),(59.485,16.975),(59.485,16.805),(59.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.125),(59.315,16.295),(59.485,16.295),(59.485,16.125),(59.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.285),(11.825,7.455),(11.995,7.455),(11.995,7.285),(11.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.285),(11.315,7.455),(11.485,7.455),(11.485,7.285),(11.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.505),(82.805,18.675),(82.975,18.675),(82.975,18.505),(82.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.805),(59.825,16.975),(59.995,16.975),(59.995,16.805),(59.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.465),(59.315,16.635),(59.485,16.635),(59.485,16.465),(59.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.305),(44.405,8.475),(44.575,8.475),(44.575,8.305),(44.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.725),(73.715,12.895),(73.885,12.895),(73.885,12.725),(73.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.725),(73.205,12.895),(73.375,12.895),(73.375,12.725),(73.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.045),(73.715,12.215),(73.885,12.215),(73.885,12.045),(73.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.045),(73.205,12.215),(73.375,12.215),(73.375,12.045),(73.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.825),(31.025,17.995),(31.195,17.995),(31.195,17.825),(31.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,28.705),(20.915,28.875),(21.085,28.875),(21.085,28.705),(20.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,28.365),(20.915,28.535),(21.085,28.535),(21.085,28.365),(20.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.145),(31.025,17.315),(31.195,17.315),(31.195,17.145),(31.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.945),(82.805,7.115),(82.975,7.115),(82.975,6.945),(82.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,28.025),(20.915,28.195),(21.085,28.195),(21.085,28.025),(20.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.385),(25.205,12.555),(25.375,12.555),(25.375,12.385),(25.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.045),(25.205,12.215),(25.375,12.215),(25.375,12.045),(25.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.385),(25.715,12.555),(25.885,12.555),(25.885,12.385),(25.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.045),(25.715,12.215),(25.885,12.215),(25.885,12.045),(25.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.285),(25.715,7.455),(25.885,7.455),(25.885,7.285),(25.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.285),(25.205,7.455),(25.375,7.455),(25.375,7.285),(25.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.725),(25.205,12.895),(25.375,12.895),(25.375,12.725),(25.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.725),(25.715,12.895),(25.885,12.895),(25.885,12.725),(25.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.145),(31.025,34.315),(31.195,34.315),(31.195,34.145),(31.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.485),(31.025,34.655),(31.195,34.655),(31.195,34.485),(31.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,22.245),(20.405,22.415),(20.575,22.415),(20.575,22.245),(20.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.825),(31.025,34.995),(31.195,34.995),(31.195,34.825),(31.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.585),(35.825,22.755),(35.995,22.755),(35.995,22.585),(35.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.245),(35.825,22.415),(35.995,22.415),(35.995,22.245),(35.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.585),(35.315,22.755),(35.485,22.755),(35.485,22.585),(35.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.245),(35.315,22.415),(35.485,22.415),(35.485,22.245),(35.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,24.965),(21.425,25.135),(21.595,25.135),(21.595,24.965),(21.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.525),(68.915,19.695),(69.085,19.695),(69.085,19.525),(68.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.185),(68.915,19.355),(69.085,19.355),(69.085,19.185),(68.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.305),(35.315,8.475),(35.485,8.475),(35.485,8.305),(35.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.305),(35.825,8.475),(35.995,8.475),(35.995,8.305),(35.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.925),(49.205,6.095),(49.375,6.095),(49.375,5.925),(49.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.925),(49.715,6.095),(49.885,6.095),(49.885,5.925),(49.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.325),(69.425,9.495),(69.595,9.495),(69.595,9.325),(69.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.665),(69.425,9.835),(69.595,9.835),(69.595,9.665),(69.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,24.965),(10.805,25.135),(10.975,25.135),(10.975,24.965),(10.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.905),(69.425,5.075),(69.595,5.075),(69.595,4.905),(69.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.105),(49.205,32.275),(49.375,32.275),(49.375,32.105),(49.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.445),(49.715,32.615),(49.885,32.615),(49.885,32.445),(49.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.445),(49.205,32.615),(49.375,32.615),(49.375,32.445),(49.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.785),(49.715,32.955),(49.885,32.955),(49.885,32.785),(49.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.785),(49.205,32.955),(49.375,32.955),(49.375,32.785),(49.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.105),(49.715,32.275),(49.885,32.275),(49.885,32.105),(49.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.545),(40.115,3.715),(40.285,3.715),(40.285,3.545),(40.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.545),(40.625,3.715),(40.795,3.715),(40.795,3.545),(40.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.225),(55.025,4.395),(55.195,4.395),(55.195,4.225),(55.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.565),(55.025,4.735),(55.195,4.735),(55.195,4.565),(55.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,27.685),(25.715,27.855),(25.885,27.855),(25.885,27.685),(25.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,27.685),(25.205,27.855),(25.375,27.855),(25.375,27.685),(25.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,27.005),(25.715,27.175),(25.885,27.175),(25.885,27.005),(25.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,27.005),(25.205,27.175),(25.375,27.175),(25.375,27.005),(25.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.565),(50.225,21.735),(50.395,21.735),(50.395,21.565),(50.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,27.005),(20.915,27.175),(21.085,27.175),(21.085,27.005),(20.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,27.685),(20.915,27.855),(21.085,27.855),(21.085,27.685),(20.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,23.265),(15.605,23.435),(15.775,23.435),(15.775,23.265),(15.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.205),(16.115,3.375),(16.285,3.375),(16.285,3.205),(16.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.545),(16.115,3.715),(16.285,3.715),(16.285,3.545),(16.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.225),(31.025,4.395),(31.195,4.395),(31.195,4.225),(31.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.865),(11.315,20.035),(11.485,20.035),(11.485,19.865),(11.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.865),(11.825,20.035),(11.995,20.035),(11.995,19.865),(11.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.945),(39.605,24.115),(39.775,24.115),(39.775,23.945),(39.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,30.065),(16.625,30.235),(16.795,30.235),(16.795,30.065),(16.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,30.745),(16.625,30.915),(16.795,30.915),(16.795,30.745),(16.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,31.425),(7.025,31.595),(7.195,31.595),(7.195,31.425),(7.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,30.065),(16.115,30.235),(16.285,30.235),(16.285,30.065),(16.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,30.745),(16.115,30.915),(16.285,30.915),(16.285,30.745),(16.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,31.765),(7.025,31.935),(7.195,31.935),(7.195,31.765),(7.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,31.085),(7.025,31.255),(7.195,31.255),(7.195,31.085),(7.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.305),(83.315,8.475),(83.485,8.475),(83.485,8.305),(83.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.645),(11.825,8.815),(11.995,8.815),(11.995,8.645),(11.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.645),(11.315,8.815),(11.485,8.815),(11.485,8.645),(11.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.305),(11.825,8.475),(11.995,8.475),(11.995,8.305),(11.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.305),(11.315,8.475),(11.485,8.475),(11.485,8.305),(11.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,38.565),(63.605,38.735),(63.775,38.735),(63.775,38.565),(63.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,38.225),(63.605,38.395),(63.775,38.395),(63.775,38.225),(63.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,25.985),(6.515,26.155),(6.685,26.155),(6.685,25.985),(6.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,36.525),(74.225,36.695),(74.395,36.695),(74.395,36.525),(74.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,36.185),(74.225,36.355),(74.395,36.355),(74.395,36.185),(74.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,28.365),(78.005,28.535),(78.175,28.535),(78.175,28.365),(78.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,28.025),(78.515,28.195),(78.685,28.195),(78.685,28.025),(78.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,28.365),(78.515,28.535),(78.685,28.535),(78.685,28.365),(78.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,28.025),(78.005,28.195),(78.175,28.195),(78.175,28.025),(78.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,28.705),(78.515,28.875),(78.685,28.875),(78.685,28.705),(78.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,28.705),(78.005,28.875),(78.175,28.875),(78.175,28.705),(78.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,24.965),(63.605,25.135),(63.775,25.135),(63.775,24.965),(63.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,21.905),(7.025,22.075),(7.195,22.075),(7.195,21.905),(7.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,22.925),(69.425,23.095),(69.595,23.095),(69.595,22.925),(69.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,36.865),(11.315,37.035),(11.485,37.035),(11.485,36.865),(11.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,36.865),(11.825,37.035),(11.995,37.035),(11.995,36.865),(11.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.205),(54.005,37.375),(54.175,37.375),(54.175,37.205),(54.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.545),(54.515,37.715),(54.685,37.715),(54.685,37.545),(54.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.545),(54.005,37.715),(54.175,37.715),(54.175,37.545),(54.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.205),(54.515,37.375),(54.685,37.375),(54.685,37.205),(54.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,21.225),(68.405,21.395),(68.575,21.395),(68.575,21.225),(68.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.205),(58.805,20.375),(58.975,20.375),(58.975,20.205),(58.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.545),(58.805,20.715),(58.975,20.715),(58.975,20.545),(58.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.665),(34.805,9.835),(34.975,9.835),(34.975,9.665),(34.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.325),(34.805,9.495),(34.975,9.495),(34.975,9.325),(34.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.705),(31.025,28.875),(31.195,28.875),(31.195,28.705),(31.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.025),(31.025,28.195),(31.195,28.195),(31.195,28.025),(31.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.185),(82.805,19.355),(82.975,19.355),(82.975,19.185),(82.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.365),(31.025,28.535),(31.195,28.535),(31.195,28.365),(31.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,31.425),(68.405,31.595),(68.575,31.595),(68.575,31.425),(68.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,35.505),(68.405,35.675),(68.575,35.675),(68.575,35.505),(68.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,35.165),(68.405,35.335),(68.575,35.335),(68.575,35.165),(68.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.205),(54.515,20.375),(54.685,20.375),(54.685,20.205),(54.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.205),(54.005,20.375),(54.175,20.375),(54.175,20.205),(54.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.445),(26.225,15.615),(26.395,15.615),(26.395,15.445),(26.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,33.125),(7.025,33.295),(7.195,33.295),(7.195,33.125),(7.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,33.465),(7.025,33.635),(7.195,33.635),(7.195,33.465),(7.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,33.805),(7.025,33.975),(7.195,33.975),(7.195,33.805),(7.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,37.205),(26.225,37.375),(26.395,37.375),(26.395,37.205),(26.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,37.545),(26.225,37.715),(26.395,37.715),(26.395,37.545),(26.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,25.645),(26.225,25.815),(26.395,25.815),(26.395,25.645),(26.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,25.305),(26.225,25.475),(26.395,25.475),(26.395,25.305),(26.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.965),(49.205,25.135),(49.375,25.135),(49.375,24.965),(49.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.965),(49.715,25.135),(49.885,25.135),(49.885,24.965),(49.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,37.885),(11.825,38.055),(11.995,38.055),(11.995,37.885),(11.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,37.885),(11.315,38.055),(11.485,38.055),(11.485,37.885),(11.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.265),(11.315,6.435),(11.485,6.435),(11.485,6.265),(11.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.265),(11.825,6.435),(11.995,6.435),(11.995,6.265),(11.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,21.905),(26.225,22.075),(26.395,22.075),(26.395,21.905),(26.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.345),(39.605,10.515),(39.775,10.515),(39.775,10.345),(39.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,37.885),(69.425,38.055),(69.595,38.055),(69.595,37.885),(69.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,30.065),(59.825,30.235),(59.995,30.235),(59.995,30.065),(59.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,30.745),(59.825,30.915),(59.995,30.915),(59.995,30.745),(59.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.745),(59.315,30.915),(59.485,30.915),(59.485,30.745),(59.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.065),(59.315,30.235),(59.485,30.235),(59.485,30.065),(59.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.645),(59.315,8.815),(59.485,8.815),(59.485,8.645),(59.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.305),(59.825,8.475),(59.995,8.475),(59.995,8.305),(59.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.305),(59.315,8.475),(59.485,8.475),(59.485,8.305),(59.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.645),(59.825,8.815),(59.995,8.815),(59.995,8.645),(59.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.125),(50.225,16.295),(50.395,16.295),(50.395,16.125),(50.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.805),(50.225,16.975),(50.395,16.975),(50.395,16.805),(50.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.845),(26.225,19.015),(26.395,19.015),(26.395,18.845),(26.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.725),(26.225,12.895),(26.395,12.895),(26.395,12.725),(26.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,35.845),(20.405,36.015),(20.575,36.015),(20.575,35.845),(20.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.045),(26.225,12.215),(26.395,12.215),(26.395,12.045),(26.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.925),(78.005,6.095),(78.175,6.095),(78.175,5.925),(78.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.925),(78.515,6.095),(78.685,6.095),(78.685,5.925),(78.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.385),(26.225,12.555),(26.395,12.555),(26.395,12.385),(26.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.045),(34.805,29.215),(34.975,29.215),(34.975,29.045),(34.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.725),(34.805,29.895),(34.975,29.895),(34.975,29.725),(34.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.925),(54.005,6.095),(54.175,6.095),(54.175,5.925),(54.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.925),(54.515,6.095),(54.685,6.095),(54.685,5.925),(54.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.545),(7.025,3.715),(7.195,3.715),(7.195,3.545),(7.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.205),(7.025,3.375),(7.195,3.375),(7.195,3.205),(7.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.585),(44.405,5.755),(44.575,5.755),(44.575,5.585),(44.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,22.585),(82.805,22.755),(82.975,22.755),(82.975,22.585),(82.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,22.245),(82.805,22.415),(82.975,22.415),(82.975,22.245),(82.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,25.305),(73.205,25.475),(73.375,25.475),(73.375,25.305),(73.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,25.305),(73.715,25.475),(73.885,25.475),(73.885,25.305),(73.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.345),(16.115,10.515),(16.285,10.515),(16.285,10.345),(16.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.345),(16.625,10.515),(16.795,10.515),(16.795,10.345),(16.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,33.465),(20.405,33.635),(20.575,33.635),(20.575,33.465),(20.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,33.805),(20.405,33.975),(20.575,33.975),(20.575,33.805),(20.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,33.125),(20.405,33.295),(20.575,33.295),(20.575,33.125),(20.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,24.965),(30.005,25.135),(30.175,25.135),(30.175,24.965),(30.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.405),(54.515,30.575),(54.685,30.575),(54.685,30.405),(54.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.065),(54.515,30.235),(54.685,30.235),(54.685,30.065),(54.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.065),(54.005,30.235),(54.175,30.235),(54.175,30.065),(54.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.405),(54.005,30.575),(54.175,30.575),(54.175,30.405),(54.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.965),(30.515,25.135),(30.685,25.135),(30.685,24.965),(30.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.965),(6.515,8.135),(6.685,8.135),(6.685,7.965),(6.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.745),(54.005,30.915),(54.175,30.915),(54.175,30.745),(54.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.745),(54.515,30.915),(54.685,30.915),(54.685,30.745),(54.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,32.105),(69.425,32.275),(69.595,32.275),(69.595,32.105),(69.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,32.785),(69.425,32.955),(69.595,32.955),(69.595,32.785),(69.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,32.445),(69.425,32.615),(69.595,32.615),(69.595,32.445),(69.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.545),(25.715,3.715),(25.885,3.715),(25.885,3.545),(25.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.545),(25.205,3.715),(25.375,3.715),(25.375,3.545),(25.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.205),(31.025,3.375),(31.195,3.375),(31.195,3.205),(31.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.905),(35.315,22.075),(35.485,22.075),(35.485,21.905),(35.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.905),(35.825,22.075),(35.995,22.075),(35.995,21.905),(35.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.845),(55.025,36.015),(55.195,36.015),(55.195,35.845),(55.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,22.245),(15.605,22.415),(15.775,22.415),(15.775,22.245),(15.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.785),(64.625,15.955),(64.795,15.955),(64.795,15.785),(64.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.785),(64.115,15.955),(64.285,15.955),(64.285,15.785),(64.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.265),(44.405,23.435),(44.575,23.435),(44.575,23.265),(44.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.605),(44.405,23.775),(44.575,23.775),(44.575,23.605),(44.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.425),(40.625,14.595),(40.795,14.595),(40.795,14.425),(40.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.425),(40.115,14.595),(40.285,14.595),(40.285,14.425),(40.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.245),(45.425,5.415),(45.595,5.415),(45.595,5.245),(45.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,26.665),(50.225,26.835),(50.395,26.835),(50.395,26.665),(50.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,26.325),(50.225,26.495),(50.395,26.495),(50.395,26.325),(50.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.705),(30.515,28.875),(30.685,28.875),(30.685,28.705),(30.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.025),(30.515,28.195),(30.685,28.195),(30.685,28.025),(30.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.365),(30.515,28.535),(30.685,28.535),(30.685,28.365),(30.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.545),(49.715,3.715),(49.885,3.715),(49.885,3.545),(49.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.205),(49.715,3.375),(49.885,3.375),(49.885,3.205),(49.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.545),(49.205,3.715),(49.375,3.715),(49.375,3.545),(49.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.205),(49.205,3.375),(49.375,3.375),(49.375,3.205),(49.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,25.985),(69.425,26.155),(69.595,26.155),(69.595,25.985),(69.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.545),(55.025,3.715),(55.195,3.715),(55.195,3.545),(55.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.205),(55.025,3.375),(55.195,3.375),(55.195,3.205),(55.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.845),(79.025,19.015),(79.195,19.015),(79.195,18.845),(79.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.685),(83.315,10.855),(83.485,10.855),(83.485,10.685),(83.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.005),(83.315,10.175),(83.485,10.175),(83.485,10.005),(83.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.345),(83.315,10.515),(83.485,10.515),(83.485,10.345),(83.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,39.925),(15.605,40.095),(15.775,40.095),(15.775,39.925),(15.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.325),(45.425,9.495),(45.595,9.495),(45.595,9.325),(45.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.665),(45.425,9.835),(45.595,9.835),(45.595,9.665),(45.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.685),(35.825,27.855),(35.995,27.855),(35.995,27.685),(35.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.685),(35.315,27.855),(35.485,27.855),(35.485,27.685),(35.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.345),(35.825,27.515),(35.995,27.515),(35.995,27.345),(35.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.345),(35.315,27.515),(35.485,27.515),(35.485,27.345),(35.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.005),(35.315,27.175),(35.485,27.175),(35.485,27.005),(35.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.005),(35.825,27.175),(35.995,27.175),(35.995,27.005),(35.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,33.805),(68.915,33.975),(69.085,33.975),(69.085,33.805),(68.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,33.125),(68.915,33.295),(69.085,33.295),(69.085,33.125),(68.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,33.465),(68.915,33.635),(69.085,33.635),(69.085,33.465),(68.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.965),(10.805,8.135),(10.975,8.135),(10.975,7.965),(10.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.325),(7.025,9.495),(7.195,9.495),(7.195,9.325),(7.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.085),(44.405,31.255),(44.575,31.255),(44.575,31.085),(44.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.765),(44.405,31.935),(44.575,31.935),(44.575,31.765),(44.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,31.085),(10.805,31.255),(10.975,31.255),(10.975,31.085),(10.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,31.765),(10.805,31.935),(10.975,31.935),(10.975,31.765),(10.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.105),(16.625,15.275),(16.795,15.275),(16.795,15.105),(16.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.445),(16.625,15.615),(16.795,15.615),(16.795,15.445),(16.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.945),(55.025,7.115),(55.195,7.115),(55.195,6.945),(55.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.305),(78.005,8.475),(78.175,8.475),(78.175,8.305),(78.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.305),(78.515,8.475),(78.685,8.475),(78.685,8.305),(78.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.545),(78.515,3.715),(78.685,3.715),(78.685,3.545),(78.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.205),(78.005,3.375),(78.175,3.375),(78.175,3.205),(78.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.205),(78.515,3.375),(78.685,3.375),(78.685,3.205),(78.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.565),(44.915,4.735),(45.085,4.735),(45.085,4.565),(44.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.545),(78.005,3.715),(78.175,3.715),(78.175,3.545),(78.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.405),(7.025,13.575),(7.195,13.575),(7.195,13.405),(7.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.065),(7.025,13.235),(7.195,13.235),(7.195,13.065),(7.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.745),(7.025,13.915),(7.195,13.915),(7.195,13.745),(7.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.345),(69.425,10.515),(69.595,10.515),(69.595,10.345),(69.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.965),(82.805,8.135),(82.975,8.135),(82.975,7.965),(82.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.165),(44.915,18.335),(45.085,18.335),(45.085,18.165),(44.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,32.105),(26.225,32.275),(26.395,32.275),(26.395,32.105),(26.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,32.785),(26.225,32.955),(26.395,32.955),(26.395,32.785),(26.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,32.445),(26.225,32.615),(26.395,32.615),(26.395,32.445),(26.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,21.565),(68.915,21.735),(69.085,21.735),(69.085,21.565),(68.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,31.765),(68.915,31.935),(69.085,31.935),(69.085,31.765),(68.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,31.085),(68.915,31.255),(69.085,31.255),(69.085,31.085),(68.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,31.425),(68.915,31.595),(69.085,31.595),(69.085,31.425),(68.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.565),(45.425,4.735),(45.595,4.735),(45.595,4.565),(45.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.225),(45.425,4.395),(45.595,4.395),(45.595,4.225),(45.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.265),(73.205,6.435),(73.375,6.435),(73.375,6.265),(73.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.605),(73.715,6.775),(73.885,6.775),(73.885,6.605),(73.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.605),(73.205,6.775),(73.375,6.775),(73.375,6.605),(73.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.265),(73.715,6.435),(73.885,6.435),(73.885,6.265),(73.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.125),(6.515,16.295),(6.685,16.295),(6.685,16.125),(6.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.805),(6.515,16.975),(6.685,16.975),(6.685,16.805),(6.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.485),(35.825,17.655),(35.995,17.655),(35.995,17.485),(35.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.485),(35.315,17.655),(35.485,17.655),(35.485,17.485),(35.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,36.185),(21.425,36.355),(21.595,36.355),(21.595,36.185),(21.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,36.525),(21.425,36.695),(21.595,36.695),(21.595,36.525),(21.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.505),(59.315,18.675),(59.485,18.675),(59.485,18.505),(59.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.505),(59.825,18.675),(59.995,18.675),(59.995,18.505),(59.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.985),(55.025,9.155),(55.195,9.155),(55.195,8.985),(55.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.145),(21.425,17.315),(21.595,17.315),(21.595,17.145),(21.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.825),(21.425,17.995),(21.595,17.995),(21.595,17.825),(21.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.925),(34.805,23.095),(34.975,23.095),(34.975,22.925),(34.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.345),(35.825,10.515),(35.995,10.515),(35.995,10.345),(35.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.345),(35.315,10.515),(35.485,10.515),(35.485,10.345),(35.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.965),(58.805,8.135),(58.975,8.135),(58.975,7.965),(58.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.325),(55.025,9.495),(55.195,9.495),(55.195,9.325),(55.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.865),(20.405,20.035),(20.575,20.035),(20.575,19.865),(20.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.225),(34.805,38.395),(34.975,38.395),(34.975,38.225),(34.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.565),(34.805,38.735),(34.975,38.735),(34.975,38.565),(34.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.865),(39.605,37.035),(39.775,37.035),(39.775,36.865),(39.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,23.265),(63.605,23.435),(63.775,23.435),(63.775,23.265),(63.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,23.605),(63.605,23.775),(63.775,23.775),(63.775,23.605),(63.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.985),(68.405,9.155),(68.575,9.155),(68.575,8.985),(68.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.225),(16.625,4.395),(16.795,4.395),(16.795,4.225),(16.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.225),(16.115,4.395),(16.285,4.395),(16.285,4.225),(16.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.205),(73.715,3.375),(73.885,3.375),(73.885,3.205),(73.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.205),(73.205,3.375),(73.375,3.375),(73.375,3.205),(73.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.065),(55.025,13.235),(55.195,13.235),(55.195,13.065),(55.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.745),(55.025,13.915),(55.195,13.915),(55.195,13.745),(55.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,21.905),(64.625,22.075),(64.795,22.075),(64.795,21.905),(64.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,21.905),(64.115,22.075),(64.285,22.075),(64.285,21.905),(64.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.245),(44.915,5.415),(45.085,5.415),(45.085,5.245),(44.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,35.845),(26.225,36.015),(26.395,36.015),(26.395,35.845),(26.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,21.225),(21.425,21.395),(21.595,21.395),(21.595,21.225),(21.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,2.865),(16.625,3.035),(16.795,3.035),(16.795,2.865),(16.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.085),(20.405,14.255),(20.575,14.255),(20.575,14.085),(20.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.765),(20.405,14.935),(20.575,14.935),(20.575,14.765),(20.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,39.585),(78.005,39.755),(78.175,39.755),(78.175,39.585),(78.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,39.245),(78.005,39.415),(78.175,39.415),(78.175,39.245),(78.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,39.245),(78.515,39.415),(78.685,39.415),(78.685,39.245),(78.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,39.585),(78.515,39.755),(78.685,39.755),(78.685,39.585),(78.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.065),(44.915,30.235),(45.085,30.235),(45.085,30.065),(44.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.745),(44.915,30.915),(45.085,30.915),(45.085,30.745),(44.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,36.865),(79.025,37.035),(79.195,37.035),(79.195,36.865),(79.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.465),(20.915,16.635),(21.085,16.635),(21.085,16.465),(20.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.225),(40.625,4.395),(40.795,4.395),(40.795,4.225),(40.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.225),(40.115,4.395),(40.285,4.395),(40.285,4.225),(40.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.565),(40.115,4.735),(40.285,4.735),(40.285,4.565),(40.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.565),(40.625,4.735),(40.795,4.735),(40.795,4.565),(40.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.665),(78.515,9.835),(78.685,9.835),(78.685,9.665),(78.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.665),(78.005,9.835),(78.175,9.835),(78.175,9.665),(78.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.345),(11.315,10.515),(11.485,10.515),(11.485,10.345),(11.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.345),(11.825,10.515),(11.995,10.515),(11.995,10.345),(11.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.865),(40.115,3.035),(40.285,3.035),(40.285,2.865),(40.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.865),(40.625,3.035),(40.795,3.035),(40.795,2.865),(40.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,37.885),(79.025,38.055),(79.195,38.055),(79.195,37.885),(79.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.245),(78.515,5.415),(78.685,5.415),(78.685,5.245),(78.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.245),(78.005,5.415),(78.175,5.415),(78.175,5.245),(78.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.585),(78.515,5.755),(78.685,5.755),(78.685,5.585),(78.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.585),(78.005,5.755),(78.175,5.755),(78.175,5.585),(78.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,33.125),(64.115,33.295),(64.285,33.295),(64.285,33.125),(64.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,33.805),(64.115,33.975),(64.285,33.975),(64.285,33.805),(64.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,34.825),(21.425,34.995),(21.595,34.995),(21.595,34.825),(21.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,34.145),(21.425,34.315),(21.595,34.315),(21.595,34.145),(21.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,33.805),(64.625,33.975),(64.795,33.975),(64.795,33.805),(64.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,34.485),(21.425,34.655),(21.595,34.655),(21.595,34.485),(21.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,33.125),(64.625,33.295),(64.795,33.295),(64.795,33.125),(64.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,33.465),(64.625,33.635),(64.795,33.635),(64.795,33.465),(64.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,33.465),(64.115,33.635),(64.285,33.635),(64.285,33.465),(64.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.005),(45.425,10.175),(45.595,10.175),(45.595,10.005),(45.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.685),(45.425,10.855),(45.595,10.855),(45.595,10.685),(45.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.925),(82.805,6.095),(82.975,6.095),(82.975,5.925),(82.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,35.505),(82.805,35.675),(82.975,35.675),(82.975,35.505),(82.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,35.165),(82.805,35.335),(82.975,35.335),(82.975,35.165),(82.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.865),(35.825,37.035),(35.995,37.035),(35.995,36.865),(35.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.865),(35.315,37.035),(35.485,37.035),(35.485,36.865),(35.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.425),(44.915,31.595),(45.085,31.595),(45.085,31.425),(44.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.425),(79.025,14.595),(79.195,14.595),(79.195,14.425),(79.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.085),(79.025,14.255),(79.195,14.255),(79.195,14.085),(79.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.765),(79.025,14.935),(79.195,14.935),(79.195,14.765),(79.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.385),(68.405,12.555),(68.575,12.555),(68.575,12.385),(68.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.645),(50.225,8.815),(50.395,8.815),(50.395,8.645),(50.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.305),(50.225,8.475),(50.395,8.475),(50.395,8.305),(50.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,32.105),(79.025,32.275),(79.195,32.275),(79.195,32.105),(79.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,32.445),(79.025,32.615),(79.195,32.615),(79.195,32.445),(79.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,32.785),(79.025,32.955),(79.195,32.955),(79.195,32.785),(79.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.185),(30.515,36.355),(30.685,36.355),(30.685,36.185),(30.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.525),(30.515,36.695),(30.685,36.695),(30.685,36.525),(30.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,38.905),(16.115,39.075),(16.285,39.075),(16.285,38.905),(16.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.265),(45.425,23.435),(45.595,23.435),(45.595,23.265),(45.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,25.645),(59.825,25.815),(59.995,25.815),(59.995,25.645),(59.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.645),(59.315,25.815),(59.485,25.815),(59.485,25.645),(59.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.985),(45.425,26.155),(45.595,26.155),(45.595,25.985),(45.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,40.265),(59.315,40.435),(59.485,40.435),(59.485,40.265),(59.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.345),(59.825,10.515),(59.995,10.515),(59.995,10.345),(59.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.345),(59.315,10.515),(59.485,10.515),(59.485,10.345),(59.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.945),(74.225,7.115),(74.395,7.115),(74.395,6.945),(74.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,23.945),(15.605,24.115),(15.775,24.115),(15.775,23.945),(15.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,25.305),(83.315,25.475),(83.485,25.475),(83.485,25.305),(83.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,25.645),(83.315,25.815),(83.485,25.815),(83.485,25.645),(83.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.765),(30.005,14.935),(30.175,14.935),(30.175,14.765),(30.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.425),(30.005,14.595),(30.175,14.595),(30.175,14.425),(30.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.805),(49.205,16.975),(49.375,16.975),(49.375,16.805),(49.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.125),(49.205,16.295),(49.375,16.295),(49.375,16.125),(49.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.085),(30.005,14.255),(30.175,14.255),(30.175,14.085),(30.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.125),(49.715,16.295),(49.885,16.295),(49.885,16.125),(49.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.805),(49.715,16.975),(49.885,16.975),(49.885,16.805),(49.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.165),(54.515,18.335),(54.685,18.335),(54.685,18.165),(54.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.165),(54.005,18.335),(54.175,18.335),(54.175,18.165),(54.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.105),(34.805,32.275),(34.975,32.275),(34.975,32.105),(34.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.445),(34.805,32.615),(34.975,32.615),(34.975,32.445),(34.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.785),(34.805,32.955),(34.975,32.955),(34.975,32.785),(34.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.925),(39.605,23.095),(39.775,23.095),(39.775,22.925),(39.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.885),(49.715,38.055),(49.885,38.055),(49.885,37.885),(49.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.885),(49.205,38.055),(49.375,38.055),(49.375,37.885),(49.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.845),(49.715,19.015),(49.885,19.015),(49.885,18.845),(49.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.845),(49.205,19.015),(49.375,19.015),(49.375,18.845),(49.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,21.905),(16.625,22.075),(16.795,22.075),(16.795,21.905),(16.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.885),(44.915,21.055),(45.085,21.055),(45.085,20.885),(44.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.765),(58.805,14.935),(58.975,14.935),(58.975,14.765),(58.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.085),(58.805,14.255),(58.975,14.255),(58.975,14.085),(58.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.585),(49.715,39.755),(49.885,39.755),(49.885,39.585),(49.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.245),(49.715,39.415),(49.885,39.415),(49.885,39.245),(49.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.585),(49.205,39.755),(49.375,39.755),(49.375,39.585),(49.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.245),(49.205,39.415),(49.375,39.415),(49.375,39.245),(49.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.105),(54.005,15.275),(54.175,15.275),(54.175,15.105),(54.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.445),(54.005,15.615),(54.175,15.615),(54.175,15.445),(54.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.105),(54.515,15.275),(54.685,15.275),(54.685,15.105),(54.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.445),(54.515,15.615),(54.685,15.615),(54.685,15.445),(54.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.425),(10.805,14.595),(10.975,14.595),(10.975,14.425),(10.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.945),(50.225,7.115),(50.395,7.115),(50.395,6.945),(50.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.105),(6.515,15.275),(6.685,15.275),(6.685,15.105),(6.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.445),(6.515,15.615),(6.685,15.615),(6.685,15.445),(6.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,36.525),(82.805,36.695),(82.975,36.695),(82.975,36.525),(82.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,36.185),(82.805,36.355),(82.975,36.355),(82.975,36.185),(82.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,29.385),(82.805,29.555),(82.975,29.555),(82.975,29.385),(82.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.305),(44.915,25.475),(45.085,25.475),(45.085,25.305),(44.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.925),(69.425,6.095),(69.595,6.095),(69.595,5.925),(69.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.965),(44.915,25.135),(45.085,25.135),(45.085,24.965),(44.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.585),(45.425,22.755),(45.595,22.755),(45.595,22.585),(45.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.925),(30.515,23.095),(30.685,23.095),(30.685,22.925),(30.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.925),(21.425,6.095),(21.595,6.095),(21.595,5.925),(21.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,24.285),(7.025,24.455),(7.195,24.455),(7.195,24.285),(7.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,23.605),(25.715,23.775),(25.885,23.775),(25.885,23.605),(25.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,23.605),(25.205,23.775),(25.375,23.775),(25.375,23.605),(25.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.845),(44.405,19.015),(44.575,19.015),(44.575,18.845),(44.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.865),(58.805,37.035),(58.975,37.035),(58.975,36.865),(58.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.125),(55.025,16.295),(55.195,16.295),(55.195,16.125),(55.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.805),(55.025,16.975),(55.195,16.975),(55.195,16.805),(55.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.585),(34.805,5.755),(34.975,5.755),(34.975,5.585),(34.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.985),(44.405,9.155),(44.575,9.155),(44.575,8.985),(44.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,22.585),(63.605,22.755),(63.775,22.755),(63.775,22.585),(63.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,29.045),(10.805,29.215),(10.975,29.215),(10.975,29.045),(10.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,29.725),(10.805,29.895),(10.975,29.895),(10.975,29.725),(10.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.765),(44.405,14.935),(44.575,14.935),(44.575,14.765),(44.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.085),(44.405,14.255),(44.575,14.255),(44.575,14.085),(44.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.425),(44.405,14.595),(44.575,14.595),(44.575,14.425),(44.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,22.925),(20.405,23.095),(20.575,23.095),(20.575,22.925),(20.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.065),(74.225,13.235),(74.395,13.235),(74.395,13.065),(74.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.745),(74.225,13.915),(74.395,13.915),(74.395,13.745),(74.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.685),(50.225,27.855),(50.395,27.855),(50.395,27.685),(50.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.005),(50.225,27.175),(50.395,27.175),(50.395,27.005),(50.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.925),(35.315,23.095),(35.485,23.095),(35.485,22.925),(35.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.925),(35.825,23.095),(35.995,23.095),(35.995,22.925),(35.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.825),(6.515,17.995),(6.685,17.995),(6.685,17.825),(6.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.145),(6.515,17.315),(6.685,17.315),(6.685,17.145),(6.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.485),(6.515,17.655),(6.685,17.655),(6.685,17.485),(6.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.985),(35.825,9.155),(35.995,9.155),(35.995,8.985),(35.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.985),(35.315,9.155),(35.485,9.155),(35.485,8.985),(35.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.025),(68.405,11.195),(68.575,11.195),(68.575,11.025),(68.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.705),(68.405,11.875),(68.575,11.875),(68.575,11.705),(68.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.905),(55.025,5.075),(55.195,5.075),(55.195,4.905),(55.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.105),(82.805,15.275),(82.975,15.275),(82.975,15.105),(82.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,32.105),(78.005,32.275),(78.175,32.275),(78.175,32.105),(78.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,32.445),(78.005,32.615),(78.175,32.615),(78.175,32.445),(78.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,32.445),(78.515,32.615),(78.685,32.615),(78.685,32.445),(78.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,32.785),(78.005,32.955),(78.175,32.955),(78.175,32.785),(78.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,32.785),(78.515,32.955),(78.685,32.955),(78.685,32.785),(78.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,32.105),(78.515,32.275),(78.685,32.275),(78.685,32.105),(78.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.925),(39.605,6.095),(39.775,6.095),(39.775,5.925),(39.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.925),(15.605,6.095),(15.775,6.095),(15.775,5.925),(15.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.045),(54.005,12.215),(54.175,12.215),(54.175,12.045),(54.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.725),(54.005,12.895),(54.175,12.895),(54.175,12.725),(54.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.045),(54.515,12.215),(54.685,12.215),(54.685,12.045),(54.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.725),(54.515,12.895),(54.685,12.895),(54.685,12.725),(54.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.865),(64.625,20.035),(64.795,20.035),(64.795,19.865),(64.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.865),(64.115,20.035),(64.285,20.035),(64.285,19.865),(64.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.505),(20.405,18.675),(20.575,18.675),(20.575,18.505),(20.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,21.905),(79.025,22.075),(79.195,22.075),(79.195,21.905),(79.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.885),(34.805,38.055),(34.975,38.055),(34.975,37.885),(34.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.365),(55.025,11.535),(55.195,11.535),(55.195,11.365),(55.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,22.245),(6.515,22.415),(6.685,22.415),(6.685,22.245),(6.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.045),(15.605,12.215),(15.775,12.215),(15.775,12.045),(15.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.725),(15.605,12.895),(15.775,12.895),(15.775,12.725),(15.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.005),(20.915,10.175),(21.085,10.175),(21.085,10.005),(20.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.685),(20.915,10.855),(21.085,10.855),(21.085,10.685),(20.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.905),(31.025,5.075),(31.195,5.075),(31.195,4.905),(31.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.305),(31.025,8.475),(31.195,8.475),(31.195,8.305),(31.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.785),(34.805,15.955),(34.975,15.955),(34.975,15.785),(34.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,37.885),(16.115,38.055),(16.285,38.055),(16.285,37.885),(16.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.505),(73.205,18.675),(73.375,18.675),(73.375,18.505),(73.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.505),(73.715,18.675),(73.885,18.675),(73.885,18.505),(73.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.985),(11.825,9.155),(11.995,9.155),(11.995,8.985),(11.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.985),(11.315,9.155),(11.485,9.155),(11.485,8.985),(11.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,38.905),(63.605,39.075),(63.775,39.075),(63.775,38.905),(63.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.985),(83.315,9.155),(83.485,9.155),(83.485,8.985),(83.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,36.865),(74.225,37.035),(74.395,37.035),(74.395,36.865),(74.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.045),(40.625,29.215),(40.795,29.215),(40.795,29.045),(40.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.725),(40.115,29.895),(40.285,29.895),(40.285,29.725),(40.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.725),(40.625,29.895),(40.795,29.895),(40.795,29.725),(40.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.045),(40.115,29.215),(40.285,29.215),(40.285,29.045),(40.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,31.765),(26.225,31.935),(26.395,31.935),(26.395,31.765),(26.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,31.425),(26.225,31.595),(26.395,31.595),(26.395,31.425),(26.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,31.085),(26.225,31.255),(26.395,31.255),(26.395,31.085),(26.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,21.225),(7.025,21.395),(7.195,21.395),(7.195,21.225),(7.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.885),(40.625,38.055),(40.795,38.055),(40.795,37.885),(40.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.885),(40.115,38.055),(40.285,38.055),(40.285,37.885),(40.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.885),(58.805,21.055),(58.975,21.055),(58.975,20.885),(58.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.885),(54.515,21.055),(54.685,21.055),(54.685,20.885),(54.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.885),(54.005,21.055),(54.175,21.055),(54.175,20.885),(54.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,22.585),(25.205,22.755),(25.375,22.755),(25.375,22.585),(25.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,22.245),(25.205,22.415),(25.375,22.415),(25.375,22.245),(25.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,22.585),(25.715,22.755),(25.885,22.755),(25.885,22.585),(25.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,22.245),(25.715,22.415),(25.885,22.415),(25.885,22.245),(25.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,22.585),(10.805,22.755),(10.975,22.755),(10.975,22.585),(10.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.965),(35.315,8.135),(35.485,8.135),(35.485,7.965),(35.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.965),(35.825,8.135),(35.995,8.135),(35.995,7.965),(35.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.845),(35.315,36.015),(35.485,36.015),(35.485,35.845),(35.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.205),(34.805,3.375),(34.975,3.375),(34.975,3.205),(34.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.845),(35.825,36.015),(35.995,36.015),(35.995,35.845),(35.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,37.545),(11.825,37.715),(11.995,37.715),(11.995,37.545),(11.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,37.545),(11.315,37.715),(11.485,37.715),(11.485,37.545),(11.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,37.205),(11.825,37.375),(11.995,37.375),(11.995,37.205),(11.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,37.205),(11.315,37.375),(11.485,37.375),(11.485,37.205),(11.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.945),(11.315,7.115),(11.485,7.115),(11.485,6.945),(11.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.945),(11.825,7.115),(11.995,7.115),(11.995,6.945),(11.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,31.425),(78.005,31.595),(78.175,31.595),(78.175,31.425),(78.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,31.425),(78.515,31.595),(78.685,31.595),(78.685,31.425),(78.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,37.205),(69.425,37.375),(69.595,37.375),(69.595,37.205),(69.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,37.545),(69.425,37.715),(69.595,37.715),(69.595,37.545),(69.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.325),(40.625,9.495),(40.795,9.495),(40.795,9.325),(40.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,31.085),(64.625,31.255),(64.795,31.255),(64.795,31.085),(64.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.325),(40.115,9.495),(40.285,9.495),(40.285,9.325),(40.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.665),(40.625,9.835),(40.795,9.835),(40.795,9.665),(40.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,31.085),(64.115,31.255),(64.285,31.255),(64.285,31.085),(64.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,31.765),(64.115,31.935),(64.285,31.935),(64.285,31.765),(64.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.185),(59.825,19.355),(59.995,19.355),(59.995,19.185),(59.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.185),(59.315,19.355),(59.485,19.355),(59.485,19.185),(59.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.665),(40.115,9.835),(40.285,9.835),(40.285,9.665),(40.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,31.765),(64.625,31.935),(64.795,31.935),(64.795,31.765),(64.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.985),(59.315,9.155),(59.485,9.155),(59.485,8.985),(59.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.985),(59.825,9.155),(59.995,9.155),(59.995,8.985),(59.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,35.165),(20.405,35.335),(20.575,35.335),(20.575,35.165),(20.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,35.505),(20.405,35.675),(20.575,35.675),(20.575,35.505),(20.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,34.145),(63.605,34.315),(63.775,34.315),(63.775,34.145),(63.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,23.945),(63.605,24.115),(63.775,24.115),(63.775,23.945),(63.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,34.825),(63.605,34.995),(63.775,34.995),(63.775,34.825),(63.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,34.485),(63.605,34.655),(63.775,34.655),(63.775,34.485),(63.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.385),(63.605,12.555),(63.775,12.555),(63.775,12.385),(63.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.365),(83.315,11.535),(83.485,11.535),(83.485,11.365),(83.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.025),(83.315,11.195),(83.485,11.195),(83.485,11.025),(83.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.705),(83.315,11.875),(83.485,11.875),(83.485,11.705),(83.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.365),(44.405,11.535),(44.575,11.535),(44.575,11.365),(44.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.345),(34.805,10.515),(34.975,10.515),(34.975,10.345),(34.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,37.205),(68.405,37.375),(68.575,37.375),(68.575,37.205),(68.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,37.545),(68.405,37.715),(68.575,37.715),(68.575,37.545),(68.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,20.205),(20.405,20.375),(20.575,20.375),(20.575,20.205),(20.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,20.545),(20.405,20.715),(20.575,20.715),(20.575,20.545),(20.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.685),(34.805,10.855),(34.975,10.855),(34.975,10.685),(34.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.005),(34.805,10.175),(34.975,10.175),(34.975,10.005),(34.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.365),(35.825,11.535),(35.995,11.535),(35.995,11.365),(35.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,22.925),(82.805,23.095),(82.975,23.095),(82.975,22.925),(82.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.365),(35.315,11.535),(35.485,11.535),(35.485,11.365),(35.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.625),(54.515,7.795),(54.685,7.795),(54.685,7.625),(54.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.625),(54.005,7.795),(54.175,7.795),(54.175,7.625),(54.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.865),(54.515,20.035),(54.685,20.035),(54.685,19.865),(54.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.785),(73.715,15.955),(73.885,15.955),(73.885,15.785),(73.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.785),(73.205,15.955),(73.375,15.955),(73.375,15.785),(73.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.865),(54.005,20.035),(54.175,20.035),(54.175,19.865),(54.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.265),(20.405,6.435),(20.575,6.435),(20.575,6.265),(20.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.905),(31.025,22.075),(31.195,22.075),(31.195,21.905),(31.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.865),(83.315,20.035),(83.485,20.035),(83.485,19.865),(83.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,21.565),(74.225,21.735),(74.395,21.735),(74.395,21.565),(74.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,21.225),(74.225,21.395),(74.395,21.395),(74.395,21.225),(74.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.225),(35.825,21.395),(35.995,21.395),(35.995,21.225),(35.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.345),(68.915,10.515),(69.085,10.515),(69.085,10.345),(68.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.225),(35.315,21.395),(35.485,21.395),(35.485,21.225),(35.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.005),(68.915,10.175),(69.085,10.175),(69.085,10.005),(68.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.685),(68.915,10.855),(69.085,10.855),(69.085,10.685),(68.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,22.925),(15.605,23.095),(15.775,23.095),(15.775,22.925),(15.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.625),(30.005,7.795),(30.175,7.795),(30.175,7.625),(30.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.625),(30.515,7.795),(30.685,7.795),(30.685,7.625),(30.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.485),(54.005,34.655),(54.175,34.655),(54.175,34.485),(54.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.825),(54.005,34.995),(54.175,34.995),(54.175,34.825),(54.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.825),(54.515,34.995),(54.685,34.995),(54.685,34.825),(54.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.145),(54.005,34.315),(54.175,34.315),(54.175,34.145),(54.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.485),(54.515,34.655),(54.685,34.655),(54.685,34.485),(54.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.145),(54.515,34.315),(54.685,34.315),(54.685,34.145),(54.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.325),(50.225,9.495),(50.395,9.495),(50.395,9.325),(50.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.125),(10.805,16.295),(10.975,16.295),(10.975,16.125),(10.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.805),(10.805,16.975),(10.975,16.975),(10.975,16.805),(10.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.405),(54.005,13.575),(54.175,13.575),(54.175,13.405),(54.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.405),(54.515,13.575),(54.685,13.575),(54.685,13.405),(54.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,25.305),(69.425,25.475),(69.595,25.475),(69.595,25.305),(69.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.785),(21.425,15.955),(21.595,15.955),(21.595,15.785),(21.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,25.645),(69.425,25.815),(69.595,25.815),(69.595,25.645),(69.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.185),(44.405,36.355),(44.575,36.355),(44.575,36.185),(44.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.525),(44.405,36.695),(44.575,36.695),(44.575,36.525),(44.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.985),(68.915,9.155),(69.085,9.155),(69.085,8.985),(68.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.625),(10.805,7.795),(10.975,7.795),(10.975,7.625),(10.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.805),(78.515,16.975),(78.685,16.975),(78.685,16.805),(78.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.805),(78.005,16.975),(78.175,16.975),(78.175,16.805),(78.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.125),(78.515,16.295),(78.685,16.295),(78.685,16.125),(78.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.125),(78.005,16.295),(78.175,16.295),(78.175,16.125),(78.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.465),(78.005,16.635),(78.175,16.635),(78.175,16.465),(78.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.465),(78.515,16.635),(78.685,16.635),(78.685,16.465),(78.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,35.845),(79.025,36.015),(79.195,36.015),(79.195,35.845),(79.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.985),(78.515,9.155),(78.685,9.155),(78.685,8.985),(78.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.985),(78.005,9.155),(78.175,9.155),(78.175,8.985),(78.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.485),(30.515,34.655),(30.685,34.655),(30.685,34.485),(30.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.825),(30.515,34.995),(30.685,34.995),(30.685,34.825),(30.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.145),(30.515,34.315),(30.685,34.315),(30.685,34.145),(30.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,40.265),(34.805,40.435),(34.975,40.435),(34.975,40.265),(34.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,40.605),(34.805,40.775),(34.975,40.775),(34.975,40.605),(34.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,37.205),(64.625,37.375),(64.795,37.375),(64.795,37.205),(64.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,37.545),(64.625,37.715),(64.795,37.715),(64.795,37.545),(64.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,37.205),(64.115,37.375),(64.285,37.375),(64.285,37.205),(64.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,37.545),(64.115,37.715),(64.285,37.715),(64.285,37.545),(64.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,26.325),(58.805,26.495),(58.975,26.495),(58.975,26.325),(58.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.625),(15.605,7.795),(15.775,7.795),(15.775,7.625),(15.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.345),(44.915,10.515),(45.085,10.515),(45.085,10.345),(44.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,31.425),(30.005,31.595),(30.175,31.595),(30.175,31.425),(30.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,31.085),(30.005,31.255),(30.175,31.255),(30.175,31.085),(30.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,31.765),(30.005,31.935),(30.175,31.935),(30.175,31.765),(30.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.625),(82.805,7.795),(82.975,7.795),(82.975,7.625),(82.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,36.185),(59.825,36.355),(59.995,36.355),(59.995,36.185),(59.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,36.525),(59.825,36.695),(59.995,36.695),(59.995,36.525),(59.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.525),(59.315,36.695),(59.485,36.695),(59.485,36.525),(59.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.185),(59.315,36.355),(59.485,36.355),(59.485,36.185),(59.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,26.665),(25.715,26.835),(25.885,26.835),(25.885,26.665),(25.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,26.665),(25.205,26.835),(25.375,26.835),(25.375,26.665),(25.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.905),(45.425,5.075),(45.595,5.075),(45.595,4.905),(45.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,29.385),(78.515,29.555),(78.685,29.555),(78.685,29.385),(78.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,29.385),(78.005,29.555),(78.175,29.555),(78.175,29.385),(78.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.945),(73.715,7.115),(73.885,7.115),(73.885,6.945),(73.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.945),(73.205,7.115),(73.375,7.115),(73.375,6.945),(73.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,36.865),(21.425,37.035),(21.595,37.035),(21.595,36.865),(21.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,37.885),(7.025,38.055),(7.195,38.055),(7.195,37.885),(7.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.845),(45.425,36.015),(45.595,36.015),(45.595,35.845),(45.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.705),(11.825,11.875),(11.995,11.875),(11.995,11.705),(11.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.025),(11.825,11.195),(11.995,11.195),(11.995,11.025),(11.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.025),(11.315,11.195),(11.485,11.195),(11.485,11.025),(11.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.705),(11.315,11.875),(11.485,11.875),(11.485,11.705),(11.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.625),(58.805,7.795),(58.975,7.795),(58.975,7.625),(58.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.185),(20.405,19.355),(20.575,19.355),(20.575,19.185),(20.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,2.865),(15.605,3.035),(15.775,3.035),(15.775,2.865),(15.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.925),(49.715,40.095),(49.885,40.095),(49.885,39.925),(49.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.265),(68.405,6.435),(68.575,6.435),(68.575,6.265),(68.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.925),(49.205,40.095),(49.375,40.095),(49.375,39.925),(49.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.905),(34.805,39.075),(34.975,39.075),(34.975,38.905),(34.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,30.065),(20.405,30.235),(20.575,30.235),(20.575,30.065),(20.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,30.745),(20.405,30.915),(20.575,30.915),(20.575,30.745),(20.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.625),(44.915,7.795),(45.085,7.795),(45.085,7.625),(44.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,38.905),(68.915,39.075),(69.085,39.075),(69.085,38.905),(68.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.865),(16.115,20.035),(16.285,20.035),(16.285,19.865),(16.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.905),(16.625,5.075),(16.795,5.075),(16.795,4.905),(16.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.905),(16.115,5.075),(16.285,5.075),(16.285,4.905),(16.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,37.885),(21.425,38.055),(21.595,38.055),(21.595,37.885),(21.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,39.585),(20.915,39.755),(21.085,39.755),(21.085,39.585),(20.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,39.245),(20.915,39.415),(21.085,39.415),(21.085,39.245),(20.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.865),(34.805,3.035),(34.975,3.035),(34.975,2.865),(34.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.505),(20.915,18.675),(21.085,18.675),(21.085,18.505),(20.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.265),(40.625,6.435),(40.795,6.435),(40.795,6.265),(40.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.265),(40.115,6.435),(40.285,6.435),(40.285,6.265),(40.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.405),(45.425,13.575),(45.595,13.575),(45.595,13.405),(45.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,22.245),(11.825,22.415),(11.995,22.415),(11.995,22.245),(11.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,22.245),(11.315,22.415),(11.485,22.415),(11.485,22.245),(11.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,22.585),(11.315,22.755),(11.485,22.755),(11.485,22.585),(11.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,22.585),(11.825,22.755),(11.995,22.755),(11.995,22.585),(11.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.025),(69.425,11.195),(69.595,11.195),(69.595,11.025),(69.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.705),(69.425,11.875),(69.595,11.875),(69.595,11.705),(69.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.125),(39.605,33.295),(39.775,33.295),(39.775,33.125),(39.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.465),(39.605,33.635),(39.775,33.635),(39.775,33.465),(39.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.805),(39.605,33.975),(39.775,33.975),(39.775,33.805),(39.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,23.265),(20.405,23.435),(20.575,23.435),(20.575,23.265),(20.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,23.605),(20.405,23.775),(20.575,23.775),(20.575,23.605),(20.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.225),(78.515,4.395),(78.685,4.395),(78.685,4.225),(78.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.225),(78.005,4.395),(78.175,4.395),(78.175,4.225),(78.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,40.265),(83.315,40.435),(83.485,40.435),(83.485,40.265),(83.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,40.605),(83.315,40.775),(83.485,40.775),(83.485,40.605),(83.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.305),(16.115,8.475),(16.285,8.475),(16.285,8.305),(16.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.305),(16.625,8.475),(16.795,8.475),(16.795,8.305),(16.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.905),(40.625,5.075),(40.795,5.075),(40.795,4.905),(40.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.905),(40.115,5.075),(40.285,5.075),(40.285,4.905),(40.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.885),(44.405,38.055),(44.575,38.055),(44.575,37.885),(44.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.485),(78.005,17.655),(78.175,17.655),(78.175,17.485),(78.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.485),(78.515,17.655),(78.685,17.655),(78.685,17.485),(78.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,35.165),(68.915,35.335),(69.085,35.335),(69.085,35.165),(68.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.405),(34.805,13.575),(34.975,13.575),(34.975,13.405),(34.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,35.505),(68.915,35.675),(69.085,35.675),(69.085,35.505),(68.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.565),(44.405,21.735),(44.575,21.735),(44.575,21.565),(44.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.525),(39.605,19.695),(39.775,19.695),(39.775,19.525),(39.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,22.585),(20.915,22.755),(21.085,22.755),(21.085,22.585),(20.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.465),(30.515,16.635),(30.685,16.635),(30.685,16.465),(30.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,28.025),(10.805,28.195),(10.975,28.195),(10.975,28.025),(10.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,32.445),(21.425,32.615),(21.595,32.615),(21.595,32.445),(21.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,28.365),(10.805,28.535),(10.975,28.535),(10.975,28.365),(10.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.125),(30.515,16.295),(30.685,16.295),(30.685,16.125),(30.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,32.105),(21.425,32.275),(21.595,32.275),(21.595,32.105),(21.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,32.785),(21.425,32.955),(21.595,32.955),(21.595,32.785),(21.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.805),(30.515,16.975),(30.685,16.975),(30.685,16.805),(30.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.805),(68.405,16.975),(68.575,16.975),(68.575,16.805),(68.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.125),(68.405,16.295),(68.575,16.295),(68.575,16.125),(68.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,37.205),(79.025,37.375),(79.195,37.375),(79.195,37.205),(79.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,37.545),(79.025,37.715),(79.195,37.715),(79.195,37.545),(79.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,29.045),(26.225,29.215),(26.395,29.215),(26.395,29.045),(26.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,29.725),(26.225,29.895),(26.395,29.895),(26.395,29.725),(26.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,29.725),(15.605,29.895),(15.775,29.895),(15.775,29.725),(15.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,29.045),(15.605,29.215),(15.775,29.215),(15.775,29.045),(15.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,24.625),(20.405,24.795),(20.575,24.795),(20.575,24.625),(20.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.305),(44.405,25.475),(44.575,25.475),(44.575,25.305),(44.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.265),(64.625,6.435),(64.795,6.435),(64.795,6.265),(64.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.265),(64.115,6.435),(64.285,6.435),(64.285,6.265),(64.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.365),(45.425,11.535),(45.595,11.535),(45.595,11.365),(45.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.025),(45.425,11.195),(45.595,11.195),(45.595,11.025),(45.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.705),(45.425,11.875),(45.595,11.875),(45.595,11.705),(45.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.605),(15.605,6.775),(15.775,6.775),(15.775,6.605),(15.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.785),(55.025,32.955),(55.195,32.955),(55.195,32.785),(55.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.445),(55.025,32.615),(55.195,32.615),(55.195,32.445),(55.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.105),(55.025,32.275),(55.195,32.275),(55.195,32.105),(55.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.505),(58.805,35.675),(58.975,35.675),(58.975,35.505),(58.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.165),(58.805,35.335),(58.975,35.335),(58.975,35.165),(58.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,25.645),(68.405,25.815),(68.575,25.815),(68.575,25.645),(68.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.205),(35.825,20.375),(35.995,20.375),(35.995,20.205),(35.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.205),(35.315,20.375),(35.485,20.375),(35.485,20.205),(35.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,31.425),(16.115,31.595),(16.285,31.595),(16.285,31.425),(16.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,31.085),(16.625,31.255),(16.795,31.255),(16.795,31.085),(16.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,31.765),(16.625,31.935),(16.795,31.935),(16.795,31.765),(16.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.385),(69.425,12.555),(69.595,12.555),(69.595,12.385),(69.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.725),(69.425,12.895),(69.595,12.895),(69.595,12.725),(69.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.045),(69.425,12.215),(69.595,12.215),(69.595,12.045),(69.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.985),(50.225,9.155),(50.395,9.155),(50.395,8.985),(50.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.745),(16.625,13.915),(16.795,13.915),(16.795,13.745),(16.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.065),(16.625,13.235),(16.795,13.235),(16.795,13.065),(16.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.405),(16.625,13.575),(16.795,13.575),(16.795,13.405),(16.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,33.465),(20.915,33.635),(21.085,33.635),(21.085,33.465),(20.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,33.125),(20.915,33.295),(21.085,33.295),(21.085,33.125),(20.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,33.805),(20.915,33.975),(21.085,33.975),(21.085,33.805),(20.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.865),(30.515,37.035),(30.685,37.035),(30.685,36.865),(30.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.825),(15.605,17.995),(15.775,17.995),(15.775,17.825),(15.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.145),(15.605,17.315),(15.775,17.315),(15.775,17.145),(15.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.305),(45.425,25.475),(45.595,25.475),(45.595,25.305),(45.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.405),(58.805,30.575),(58.975,30.575),(58.975,30.405),(58.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.065),(58.805,30.235),(58.975,30.235),(58.975,30.065),(58.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.745),(58.805,30.915),(58.975,30.915),(58.975,30.745),(58.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.985),(44.915,9.155),(45.085,9.155),(45.085,8.985),(44.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.665),(68.915,9.835),(69.085,9.835),(69.085,9.665),(68.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.985),(34.805,26.155),(34.975,26.155),(34.975,25.985),(34.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.845),(54.005,19.015),(54.175,19.015),(54.175,18.845),(54.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.845),(54.515,19.015),(54.685,19.015),(54.685,18.845),(54.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.765),(54.515,31.935),(54.685,31.935),(54.685,31.765),(54.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.765),(54.005,31.935),(54.175,31.935),(54.175,31.765),(54.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.085),(54.515,31.255),(54.685,31.255),(54.685,31.085),(54.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.085),(54.005,31.255),(54.175,31.255),(54.175,31.085),(54.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,23.945),(10.805,24.115),(10.975,24.115),(10.975,23.945),(10.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.205),(49.715,37.375),(49.885,37.375),(49.885,37.205),(49.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.545),(49.715,37.715),(49.885,37.715),(49.885,37.545),(49.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.545),(49.205,37.715),(49.375,37.715),(49.375,37.545),(49.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.205),(49.205,37.375),(49.375,37.375),(49.375,37.205),(49.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.465),(73.715,16.635),(73.885,16.635),(73.885,16.465),(73.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.465),(73.205,16.635),(73.375,16.635),(73.375,16.465),(73.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.065),(82.805,13.235),(82.975,13.235),(82.975,13.065),(82.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.745),(82.805,13.915),(82.975,13.915),(82.975,13.745),(82.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.205),(44.915,20.375),(45.085,20.375),(45.085,20.205),(44.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.545),(44.915,20.715),(45.085,20.715),(45.085,20.545),(44.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.225),(34.805,21.395),(34.975,21.395),(34.975,21.225),(34.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,35.845),(16.115,36.015),(16.285,36.015),(16.285,35.845),(16.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.005),(40.115,10.175),(40.285,10.175),(40.285,10.005),(40.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.685),(40.115,10.855),(40.285,10.855),(40.285,10.685),(40.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.005),(40.625,10.175),(40.795,10.175),(40.795,10.005),(40.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.685),(40.625,10.855),(40.795,10.855),(40.795,10.685),(40.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.105),(40.115,15.275),(40.285,15.275),(40.285,15.105),(40.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.105),(40.625,15.275),(40.795,15.275),(40.795,15.105),(40.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.445),(40.625,15.615),(40.795,15.615),(40.795,15.445),(40.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.445),(40.115,15.615),(40.285,15.615),(40.285,15.445),(40.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.865),(15.605,20.035),(15.775,20.035),(15.775,19.865),(15.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.145),(10.805,17.315),(10.975,17.315),(10.975,17.145),(10.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.485),(10.805,17.655),(10.975,17.655),(10.975,17.485),(10.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.825),(10.805,17.995),(10.975,17.995),(10.975,17.825),(10.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,36.865),(82.805,37.035),(82.975,37.035),(82.975,36.865),(82.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,35.505),(15.605,35.675),(15.775,35.675),(15.775,35.505),(15.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,35.165),(15.605,35.335),(15.775,35.335),(15.775,35.165),(15.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.785),(58.805,32.955),(58.975,32.955),(58.975,32.785),(58.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,32.445),(6.515,32.615),(6.685,32.615),(6.685,32.445),(6.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,32.105),(6.515,32.275),(6.685,32.275),(6.685,32.105),(6.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,40.265),(11.825,40.435),(11.995,40.435),(11.995,40.265),(11.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,40.265),(11.315,40.435),(11.485,40.435),(11.485,40.265),(11.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,40.605),(11.825,40.775),(11.995,40.775),(11.995,40.605),(11.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,40.605),(11.315,40.775),(11.485,40.775),(11.485,40.605),(11.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,32.785),(6.515,32.955),(6.685,32.955),(6.685,32.785),(6.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.445),(58.805,32.615),(58.975,32.615),(58.975,32.445),(58.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.105),(58.805,32.275),(58.975,32.275),(58.975,32.105),(58.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.985),(44.915,26.155),(45.085,26.155),(45.085,25.985),(44.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.365),(34.805,11.535),(34.975,11.535),(34.975,11.365),(34.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,21.565),(25.205,21.735),(25.375,21.735),(25.375,21.565),(25.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,21.565),(25.715,21.735),(25.885,21.735),(25.885,21.565),(25.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.285),(44.915,24.455),(45.085,24.455),(45.085,24.285),(44.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.845),(40.115,36.015),(40.285,36.015),(40.285,35.845),(40.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.845),(40.625,36.015),(40.795,36.015),(40.795,35.845),(40.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,22.245),(26.225,22.415),(26.395,22.415),(26.395,22.245),(26.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,22.585),(26.225,22.755),(26.395,22.755),(26.395,22.585),(26.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.265),(63.605,6.435),(63.775,6.435),(63.775,6.265),(63.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,24.965),(7.025,25.135),(7.195,25.135),(7.195,24.965),(7.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.145),(55.025,17.315),(55.195,17.315),(55.195,17.145),(55.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.485),(55.025,17.655),(55.195,17.655),(55.195,17.485),(55.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.825),(55.025,17.995),(55.195,17.995),(55.195,17.825),(55.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.805),(40.115,33.975),(40.285,33.975),(40.285,33.805),(40.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.125),(40.115,33.295),(40.285,33.295),(40.285,33.125),(40.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.465),(40.115,33.635),(40.285,33.635),(40.285,33.465),(40.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.465),(40.625,33.635),(40.795,33.635),(40.795,33.465),(40.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.805),(40.625,33.975),(40.795,33.975),(40.795,33.805),(40.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.125),(40.625,33.295),(40.795,33.295),(40.795,33.125),(40.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.465),(21.425,16.635),(21.595,16.635),(21.595,16.465),(21.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.645),(39.605,8.815),(39.775,8.815),(39.775,8.645),(39.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,40.265),(69.425,40.435),(69.595,40.435),(69.595,40.265),(69.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,40.605),(69.425,40.775),(69.595,40.775),(69.595,40.605),(69.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.545),(83.315,3.715),(83.485,3.715),(83.485,3.545),(83.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,28.705),(15.605,28.875),(15.775,28.875),(15.775,28.705),(15.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.245),(26.225,5.415),(26.395,5.415),(26.395,5.245),(26.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.585),(26.225,5.755),(26.395,5.755),(26.395,5.585),(26.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.565),(44.915,21.735),(45.085,21.735),(45.085,21.565),(44.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.225),(44.915,21.395),(45.085,21.395),(45.085,21.225),(44.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,36.185),(68.405,36.355),(68.575,36.355),(68.575,36.185),(68.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,36.525),(68.405,36.695),(68.575,36.695),(68.575,36.525),(68.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.205),(35.825,3.375),(35.995,3.375),(35.995,3.205),(35.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.205),(35.315,3.375),(35.485,3.375),(35.485,3.205),(35.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.665),(31.025,9.835),(31.195,9.835),(31.195,9.665),(31.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.285),(58.805,24.455),(58.975,24.455),(58.975,24.285),(58.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.385),(30.515,29.555),(30.685,29.555),(30.685,29.385),(30.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,29.725),(30.005,29.895),(30.175,29.895),(30.175,29.725),(30.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,29.045),(30.005,29.215),(30.175,29.215),(30.175,29.045),(30.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.205),(40.115,20.375),(40.285,20.375),(40.285,20.205),(40.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.205),(40.625,20.375),(40.795,20.375),(40.795,20.205),(40.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,35.845),(6.515,36.015),(6.685,36.015),(6.685,35.845),(6.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.605),(30.005,6.775),(30.175,6.775),(30.175,6.605),(30.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.605),(30.515,6.775),(30.685,6.775),(30.685,6.605),(30.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.265),(30.515,6.435),(30.685,6.435),(30.685,6.265),(30.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.265),(30.005,6.435),(30.175,6.435),(30.175,6.265),(30.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.605),(35.825,6.775),(35.995,6.775),(35.995,6.605),(35.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.605),(35.315,6.775),(35.485,6.775),(35.485,6.605),(35.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.545),(21.425,3.715),(21.595,3.715),(21.595,3.545),(21.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.205),(21.425,3.375),(21.595,3.375),(21.595,3.205),(21.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.165),(63.605,18.335),(63.775,18.335),(63.775,18.165),(63.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.505),(63.605,18.675),(63.775,18.675),(63.775,18.505),(63.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.585),(39.605,5.755),(39.775,5.755),(39.775,5.585),(39.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.185),(64.625,19.355),(64.795,19.355),(64.795,19.185),(64.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.525),(64.625,19.695),(64.795,19.695),(64.795,19.525),(64.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.185),(64.115,19.355),(64.285,19.355),(64.285,19.185),(64.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.525),(64.115,19.695),(64.285,19.695),(64.285,19.525),(64.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.785),(83.315,15.955),(83.485,15.955),(83.485,15.785),(83.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,32.105),(74.225,32.275),(74.395,32.275),(74.395,32.105),(74.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,32.445),(74.225,32.615),(74.395,32.615),(74.395,32.445),(74.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,32.785),(74.225,32.955),(74.395,32.955),(74.395,32.785),(74.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,21.225),(79.025,21.395),(79.195,21.395),(79.195,21.225),(79.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,21.565),(79.025,21.735),(79.195,21.735),(79.195,21.565),(79.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.785),(35.315,15.955),(35.485,15.955),(35.485,15.785),(35.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.785),(35.825,15.955),(35.995,15.955),(35.995,15.785),(35.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.265),(58.805,6.435),(58.975,6.435),(58.975,6.265),(58.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.345),(58.805,27.515),(58.975,27.515),(58.975,27.345),(58.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.005),(58.805,27.175),(58.975,27.175),(58.975,27.005),(58.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.765),(49.205,31.935),(49.375,31.935),(49.375,31.765),(49.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.685),(58.805,27.855),(58.975,27.855),(58.975,27.685),(58.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.085),(49.205,31.255),(49.375,31.255),(49.375,31.085),(49.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.425),(49.205,31.595),(49.375,31.595),(49.375,31.425),(49.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.085),(49.715,31.255),(49.885,31.255),(49.885,31.085),(49.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.425),(49.715,31.595),(49.885,31.595),(49.885,31.425),(49.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.765),(49.715,31.935),(49.885,31.935),(49.885,31.765),(49.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,22.925),(6.515,23.095),(6.685,23.095),(6.685,22.925),(6.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.265),(10.805,6.435),(10.975,6.435),(10.975,6.265),(10.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.605),(10.805,6.775),(10.975,6.775),(10.975,6.605),(10.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.805),(26.225,16.975),(26.395,16.975),(26.395,16.805),(26.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.125),(26.225,16.295),(26.395,16.295),(26.395,16.125),(26.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.465),(26.225,16.635),(26.395,16.635),(26.395,16.465),(26.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,28.025),(25.715,28.195),(25.885,28.195),(25.885,28.025),(25.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,28.365),(25.715,28.535),(25.885,28.535),(25.885,28.365),(25.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,28.365),(25.205,28.535),(25.375,28.535),(25.375,28.365),(25.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,28.025),(25.205,28.195),(25.375,28.195),(25.375,28.025),(25.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,28.705),(25.715,28.875),(25.885,28.875),(25.885,28.705),(25.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,28.705),(25.205,28.875),(25.375,28.875),(25.375,28.705),(25.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.985),(31.025,9.155),(31.195,9.155),(31.195,8.985),(31.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.245),(63.605,5.415),(63.775,5.415),(63.775,5.245),(63.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.645),(6.515,8.815),(6.685,8.815),(6.685,8.645),(6.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.585),(40.625,5.755),(40.795,5.755),(40.795,5.585),(40.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.245),(40.625,5.415),(40.795,5.415),(40.795,5.245),(40.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.245),(40.115,5.415),(40.285,5.415),(40.285,5.245),(40.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.585),(40.115,5.755),(40.285,5.755),(40.285,5.585),(40.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.525),(58.805,19.695),(58.975,19.695),(58.975,19.525),(58.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,36.185),(64.625,36.355),(64.795,36.355),(64.795,36.185),(64.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.145),(30.515,17.315),(30.685,17.315),(30.685,17.145),(30.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.825),(30.515,17.995),(30.685,17.995),(30.685,17.825),(30.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,36.525),(64.115,36.695),(64.285,36.695),(64.285,36.525),(64.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,36.185),(64.115,36.355),(64.285,36.355),(64.285,36.185),(64.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,36.525),(64.625,36.695),(64.795,36.695),(64.795,36.525),(64.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.485),(30.515,17.655),(30.685,17.655),(30.685,17.485),(30.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,23.945),(69.425,24.115),(69.595,24.115),(69.595,23.945),(69.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,39.925),(68.915,40.095),(69.085,40.095),(69.085,39.925),(68.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,26.325),(34.805,26.495),(34.975,26.495),(34.975,26.325),(34.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.585),(50.225,5.755),(50.395,5.755),(50.395,5.585),(50.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.245),(50.225,5.415),(50.395,5.415),(50.395,5.245),(50.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.105),(7.025,15.275),(7.195,15.275),(7.195,15.105),(7.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.965),(15.605,8.135),(15.775,8.135),(15.775,7.965),(15.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,20.205),(25.205,20.375),(25.375,20.375),(25.375,20.205),(25.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,22.585),(21.425,22.755),(21.595,22.755),(21.595,22.585),(21.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,20.205),(25.715,20.375),(25.885,20.375),(25.885,20.205),(25.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,22.245),(21.425,22.415),(21.595,22.415),(21.595,22.245),(21.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,29.045),(21.425,29.215),(21.595,29.215),(21.595,29.045),(21.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,29.385),(21.425,29.555),(21.595,29.555),(21.595,29.385),(21.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,29.725),(21.425,29.895),(21.595,29.895),(21.595,29.725),(21.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.725),(59.315,12.895),(59.485,12.895),(59.485,12.725),(59.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.045),(59.315,12.215),(59.485,12.215),(59.485,12.045),(59.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.725),(59.825,12.895),(59.995,12.895),(59.995,12.725),(59.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.885),(25.205,4.055),(25.375,4.055),(25.375,3.885),(25.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,29.725),(63.605,29.895),(63.775,29.895),(63.775,29.725),(63.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,29.045),(63.605,29.215),(63.775,29.215),(63.775,29.045),(63.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,29.385),(63.605,29.555),(63.775,29.555),(63.775,29.385),(63.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.885),(25.715,4.055),(25.885,4.055),(25.885,3.885),(25.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.045),(59.825,12.215),(59.995,12.215),(59.995,12.045),(59.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,38.225),(79.025,38.395),(79.195,38.395),(79.195,38.225),(79.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,38.565),(79.025,38.735),(79.195,38.735),(79.195,38.565),(79.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,39.925),(10.805,40.095),(10.975,40.095),(10.975,39.925),(10.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,37.885),(78.515,38.055),(78.685,38.055),(78.685,37.885),(78.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,37.885),(78.005,38.055),(78.175,38.055),(78.175,37.885),(78.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.645),(26.225,8.815),(26.395,8.815),(26.395,8.645),(26.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,22.925),(25.715,23.095),(25.885,23.095),(25.885,22.925),(25.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,22.925),(25.205,23.095),(25.375,23.095),(25.375,22.925),(25.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.205),(74.225,3.375),(74.395,3.375),(74.395,3.205),(74.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.585),(16.115,5.755),(16.285,5.755),(16.285,5.585),(16.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.585),(16.625,5.755),(16.795,5.755),(16.795,5.585),(16.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.245),(16.115,5.415),(16.285,5.415),(16.285,5.245),(16.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.245),(16.625,5.415),(16.795,5.415),(16.795,5.245),(16.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.545),(26.225,3.715),(26.395,3.715),(26.395,3.545),(26.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,26.325),(68.405,26.495),(68.575,26.495),(68.575,26.325),(68.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.585),(74.225,5.755),(74.395,5.755),(74.395,5.585),(74.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.585),(35.315,5.755),(35.485,5.755),(35.485,5.585),(35.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.585),(35.825,5.755),(35.995,5.755),(35.995,5.585),(35.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.445),(68.405,15.615),(68.575,15.615),(68.575,15.445),(68.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.105),(68.405,15.275),(68.575,15.275),(68.575,15.105),(68.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.105),(20.405,15.275),(20.575,15.275),(20.575,15.105),(20.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.445),(20.405,15.615),(20.575,15.615),(20.575,15.445),(20.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,24.285),(83.315,24.455),(83.485,24.455),(83.485,24.285),(83.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.145),(63.605,17.315),(63.775,17.315),(63.775,17.145),(63.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.825),(63.605,17.995),(63.775,17.995),(63.775,17.825),(63.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.725),(50.225,12.895),(50.395,12.895),(50.395,12.725),(50.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.045),(50.225,12.215),(50.395,12.215),(50.395,12.045),(50.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.385),(50.225,12.555),(50.395,12.555),(50.395,12.385),(50.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,33.125),(10.805,33.295),(10.975,33.295),(10.975,33.125),(10.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,33.465),(10.805,33.635),(10.975,33.635),(10.975,33.465),(10.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,33.805),(10.805,33.975),(10.975,33.975),(10.975,33.805),(10.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.705),(39.605,28.875),(39.775,28.875),(39.775,28.705),(39.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,31.085),(79.025,31.255),(79.195,31.255),(79.195,31.085),(79.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,31.765),(79.025,31.935),(79.195,31.935),(79.195,31.765),(79.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,25.985),(78.005,26.155),(78.175,26.155),(78.175,25.985),(78.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,25.985),(78.515,26.155),(78.685,26.155),(78.685,25.985),(78.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,20.885),(20.405,21.055),(20.575,21.055),(20.575,20.885),(20.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.105),(55.025,15.275),(55.195,15.275),(55.195,15.105),(55.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.425),(20.915,14.595),(21.085,14.595),(21.085,14.425),(20.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,25.645),(16.625,25.815),(16.795,25.815),(16.795,25.645),(16.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,25.645),(16.115,25.815),(16.285,25.815),(16.285,25.645),(16.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.725),(31.025,12.895),(31.195,12.895),(31.195,12.725),(31.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.385),(31.025,12.555),(31.195,12.555),(31.195,12.385),(31.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.045),(31.025,12.215),(31.195,12.215),(31.195,12.045),(31.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.945),(20.405,7.115),(20.575,7.115),(20.575,6.945),(20.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.865),(58.805,20.035),(58.975,20.035),(58.975,19.865),(58.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.625),(40.115,24.795),(40.285,24.795),(40.285,24.625),(40.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.625),(40.625,24.795),(40.795,24.795),(40.795,24.625),(40.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.225),(31.025,21.395),(31.195,21.395),(31.195,21.225),(31.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.785),(50.225,15.955),(50.395,15.955),(50.395,15.785),(50.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.445),(35.825,32.615),(35.995,32.615),(35.995,32.445),(35.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.785),(35.825,32.955),(35.995,32.955),(35.995,32.785),(35.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.785),(35.315,32.955),(35.485,32.955),(35.485,32.785),(35.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.445),(35.315,32.615),(35.485,32.615),(35.485,32.445),(35.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.105),(35.315,32.275),(35.485,32.275),(35.485,32.105),(35.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.105),(35.825,32.275),(35.995,32.275),(35.995,32.105),(35.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,40.265),(68.405,40.435),(68.575,40.435),(68.575,40.265),(68.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,40.605),(68.405,40.775),(68.575,40.775),(68.575,40.605),(68.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.725),(54.005,29.895),(54.175,29.895),(54.175,29.725),(54.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.045),(54.005,29.215),(54.175,29.215),(54.175,29.045),(54.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.725),(54.515,29.895),(54.685,29.895),(54.685,29.725),(54.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.045),(54.515,29.215),(54.685,29.215),(54.685,29.045),(54.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,27.685),(7.025,27.855),(7.195,27.855),(7.195,27.685),(7.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,27.005),(7.025,27.175),(7.195,27.175),(7.195,27.005),(7.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.865),(63.605,20.035),(63.775,20.035),(63.775,19.865),(63.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,24.285),(59.825,24.455),(59.995,24.455),(59.995,24.285),(59.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.285),(59.315,24.455),(59.485,24.455),(59.485,24.285),(59.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,34.825),(16.115,34.995),(16.285,34.995),(16.285,34.825),(16.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,34.145),(16.115,34.315),(16.285,34.315),(16.285,34.145),(16.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.885),(26.225,4.055),(26.395,4.055),(26.395,3.885),(26.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,34.485),(16.115,34.655),(16.285,34.655),(16.285,34.485),(16.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.205),(34.805,20.375),(34.975,20.375),(34.975,20.205),(34.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,28.705),(26.225,28.875),(26.395,28.875),(26.395,28.705),(26.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,28.365),(26.225,28.535),(26.395,28.535),(26.395,28.365),(26.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,28.025),(26.225,28.195),(26.395,28.195),(26.395,28.025),(26.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,35.845),(69.425,36.015),(69.595,36.015),(69.595,35.845),(69.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.905),(54.005,22.075),(54.175,22.075),(54.175,21.905),(54.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.905),(54.515,22.075),(54.685,22.075),(54.685,21.905),(54.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.425),(39.605,31.595),(39.775,31.595),(39.775,31.425),(39.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.225),(39.605,38.395),(39.775,38.395),(39.775,38.225),(39.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.565),(39.605,38.735),(39.775,38.735),(39.775,38.565),(39.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.965),(45.425,8.135),(45.595,8.135),(45.595,7.965),(45.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.865),(44.405,37.035),(44.575,37.035),(44.575,36.865),(44.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.305),(68.915,8.475),(69.085,8.475),(69.085,8.305),(68.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,27.685),(68.405,27.855),(68.575,27.855),(68.575,27.685),(68.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,27.005),(68.405,27.175),(68.575,27.175),(68.575,27.005),(68.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.065),(20.405,13.235),(20.575,13.235),(20.575,13.065),(20.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.745),(20.405,13.915),(20.575,13.915),(20.575,13.745),(20.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,27.345),(68.405,27.515),(68.575,27.515),(68.575,27.345),(68.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.545),(50.225,3.715),(50.395,3.715),(50.395,3.545),(50.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.085),(64.625,14.255),(64.795,14.255),(64.795,14.085),(64.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.085),(64.115,14.255),(64.285,14.255),(64.285,14.085),(64.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.765),(64.625,14.935),(64.795,14.935),(64.795,14.765),(64.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.765),(64.115,14.935),(64.285,14.935),(64.285,14.765),(64.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.425),(55.025,14.595),(55.195,14.595),(55.195,14.425),(55.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.105),(30.515,15.275),(30.685,15.275),(30.685,15.105),(30.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.445),(30.515,15.615),(30.685,15.615),(30.685,15.445),(30.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,24.285),(25.715,24.455),(25.885,24.455),(25.885,24.285),(25.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,24.285),(25.205,24.455),(25.375,24.455),(25.375,24.285),(25.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.545),(30.515,37.715),(30.685,37.715),(30.685,37.545),(30.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.205),(30.515,37.375),(30.685,37.375),(30.685,37.205),(30.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,37.545),(30.005,37.715),(30.175,37.715),(30.175,37.545),(30.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,37.205),(30.005,37.375),(30.175,37.375),(30.175,37.205),(30.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,33.465),(30.005,33.635),(30.175,33.635),(30.175,33.465),(30.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,33.125),(30.005,33.295),(30.175,33.295),(30.175,33.125),(30.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.245),(35.315,39.415),(35.485,39.415),(35.485,39.245),(35.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.585),(35.315,39.755),(35.485,39.755),(35.485,39.585),(35.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.245),(35.825,39.415),(35.995,39.415),(35.995,39.245),(35.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.885),(64.115,4.055),(64.285,4.055),(64.285,3.885),(64.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,33.805),(30.005,33.975),(30.175,33.975),(30.175,33.805),(30.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.885),(64.625,4.055),(64.795,4.055),(64.795,3.885),(64.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.585),(35.825,39.755),(35.995,39.755),(35.995,39.585),(35.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.525),(25.715,19.695),(25.885,19.695),(25.885,19.525),(25.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.525),(25.205,19.695),(25.375,19.695),(25.375,19.525),(25.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.185),(25.205,19.355),(25.375,19.355),(25.375,19.185),(25.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.185),(25.715,19.355),(25.885,19.355),(25.885,19.185),(25.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.645),(74.225,8.815),(74.395,8.815),(74.395,8.645),(74.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.305),(74.225,8.475),(74.395,8.475),(74.395,8.305),(74.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,21.565),(82.805,21.735),(82.975,21.735),(82.975,21.565),(82.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.865),(59.315,37.035),(59.485,37.035),(59.485,36.865),(59.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,36.865),(59.825,37.035),(59.995,37.035),(59.995,36.865),(59.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.245),(83.315,5.415),(83.485,5.415),(83.485,5.245),(83.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.585),(83.315,5.755),(83.485,5.755),(83.485,5.585),(83.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.105),(44.405,15.275),(44.575,15.275),(44.575,15.105),(44.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.065),(49.715,30.235),(49.885,30.235),(49.885,30.065),(49.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.405),(49.205,30.575),(49.375,30.575),(49.375,30.405),(49.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.405),(49.715,30.575),(49.885,30.575),(49.885,30.405),(49.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.745),(49.205,30.915),(49.375,30.915),(49.375,30.745),(49.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.745),(49.715,30.915),(49.885,30.915),(49.885,30.745),(49.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.065),(49.205,30.235),(49.375,30.235),(49.375,30.065),(49.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.125),(54.515,33.295),(54.685,33.295),(54.685,33.125),(54.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.465),(54.515,33.635),(54.685,33.635),(54.685,33.465),(54.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.805),(54.005,33.975),(54.175,33.975),(54.175,33.805),(54.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.805),(54.515,33.975),(54.685,33.975),(54.685,33.805),(54.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.465),(54.005,33.635),(54.175,33.635),(54.175,33.465),(54.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,25.985),(10.805,26.155),(10.975,26.155),(10.975,25.985),(10.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.125),(54.005,33.295),(54.175,33.295),(54.175,33.125),(54.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,20.545),(78.515,20.715),(78.685,20.715),(78.685,20.545),(78.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,20.545),(78.005,20.715),(78.175,20.715),(78.175,20.545),(78.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,20.205),(78.005,20.375),(78.175,20.375),(78.175,20.205),(78.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,20.205),(78.515,20.375),(78.685,20.375),(78.685,20.205),(78.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.185),(55.025,19.355),(55.195,19.355),(55.195,19.185),(55.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,26.325),(83.315,26.495),(83.485,26.495),(83.485,26.325),(83.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.565),(63.605,4.735),(63.775,4.735),(63.775,4.565),(63.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,23.945),(26.225,24.115),(26.395,24.115),(26.395,23.945),(26.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.805),(55.025,33.975),(55.195,33.975),(55.195,33.805),(55.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.465),(55.025,33.635),(55.195,33.635),(55.195,33.465),(55.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.125),(55.025,33.295),(55.195,33.295),(55.195,33.125),(55.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.025),(25.205,11.195),(25.375,11.195),(25.375,11.025),(25.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.025),(25.715,11.195),(25.885,11.195),(25.885,11.025),(25.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.705),(25.205,11.875),(25.375,11.875),(25.375,11.705),(25.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.705),(25.715,11.875),(25.885,11.875),(25.885,11.705),(25.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.705),(44.405,28.875),(44.575,28.875),(44.575,28.705),(44.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.465),(82.805,16.635),(82.975,16.635),(82.975,16.465),(82.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,37.205),(7.025,37.375),(7.195,37.375),(7.195,37.205),(7.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,37.545),(7.025,37.715),(7.195,37.715),(7.195,37.545),(7.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,26.325),(64.115,26.495),(64.285,26.495),(64.285,26.325),(64.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,26.325),(64.625,26.495),(64.795,26.495),(64.795,26.325),(64.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,37.205),(82.805,37.375),(82.975,37.375),(82.975,37.205),(82.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,37.545),(82.805,37.715),(82.975,37.715),(82.975,37.545),(82.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,20.205),(64.625,20.375),(64.795,20.375),(64.795,20.205),(64.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,20.205),(64.115,20.375),(64.285,20.375),(64.285,20.205),(64.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.085),(68.915,14.255),(69.085,14.255),(69.085,14.085),(68.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.425),(68.915,14.595),(69.085,14.595),(69.085,14.425),(68.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.765),(68.915,14.935),(69.085,14.935),(69.085,14.765),(68.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.545),(39.605,3.715),(39.775,3.715),(39.775,3.545),(39.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.945),(68.405,7.115),(68.575,7.115),(68.575,6.945),(68.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.445),(20.915,15.615),(21.085,15.615),(21.085,15.445),(20.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.885),(50.225,4.055),(50.395,4.055),(50.395,3.885),(50.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,38.225),(68.915,38.395),(69.085,38.395),(69.085,38.225),(68.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,38.565),(68.915,38.735),(69.085,38.735),(69.085,38.565),(68.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.165),(69.425,18.335),(69.595,18.335),(69.595,18.165),(69.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.505),(69.425,18.675),(69.595,18.675),(69.595,18.505),(69.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.525),(16.625,19.695),(16.795,19.695),(16.795,19.525),(16.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.185),(16.115,19.355),(16.285,19.355),(16.285,19.185),(16.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.485),(26.225,17.655),(26.395,17.655),(26.395,17.485),(26.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.545),(31.025,20.715),(31.195,20.715),(31.195,20.545),(31.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,28.365),(63.605,28.535),(63.775,28.535),(63.775,28.365),(63.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.945),(35.825,24.115),(35.995,24.115),(35.995,23.945),(35.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,28.025),(63.605,28.195),(63.775,28.195),(63.775,28.025),(63.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.945),(35.315,24.115),(35.485,24.115),(35.485,23.945),(35.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,37.545),(21.425,37.715),(21.595,37.715),(21.595,37.545),(21.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.125),(31.025,33.295),(31.195,33.295),(31.195,33.125),(31.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.285),(79.025,7.455),(79.195,7.455),(79.195,7.285),(79.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,37.205),(21.425,37.375),(21.595,37.375),(21.595,37.205),(21.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.805),(31.025,33.975),(31.195,33.975),(31.195,33.805),(31.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.465),(31.025,33.635),(31.195,33.635),(31.195,33.465),(31.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.325),(54.005,9.495),(54.175,9.495),(54.175,9.325),(54.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.325),(54.515,9.495),(54.685,9.495),(54.685,9.325),(54.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.665),(54.005,9.835),(54.175,9.835),(54.175,9.665),(54.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.665),(54.515,9.835),(54.685,9.835),(54.685,9.665),(54.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,26.665),(21.425,26.835),(21.595,26.835),(21.595,26.665),(21.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,26.325),(21.425,26.495),(21.595,26.495),(21.595,26.325),(21.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.945),(34.805,24.115),(34.975,24.115),(34.975,23.945),(34.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.945),(40.625,7.115),(40.795,7.115),(40.795,6.945),(40.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.405),(64.625,13.575),(64.795,13.575),(64.795,13.405),(64.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.625),(7.025,7.795),(7.195,7.795),(7.195,7.625),(7.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,22.925),(11.825,23.095),(11.995,23.095),(11.995,22.925),(11.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,22.925),(11.315,23.095),(11.485,23.095),(11.485,22.925),(11.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.205),(63.605,3.375),(63.775,3.375),(63.775,3.205),(63.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.645),(58.805,25.815),(58.975,25.815),(58.975,25.645),(58.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.305),(58.805,25.475),(58.975,25.475),(58.975,25.305),(58.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.305),(40.625,25.475),(40.795,25.475),(40.795,25.305),(40.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.305),(40.115,25.475),(40.285,25.475),(40.285,25.305),(40.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.645),(40.115,25.815),(40.285,25.815),(40.285,25.645),(40.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.645),(40.625,25.815),(40.795,25.815),(40.795,25.645),(40.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.665),(68.405,9.835),(68.575,9.835),(68.575,9.665),(68.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.905),(78.005,5.075),(78.175,5.075),(78.175,4.905),(78.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.905),(78.515,5.075),(78.685,5.075),(78.685,4.905),(78.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.985),(16.115,9.155),(16.285,9.155),(16.285,8.985),(16.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.985),(16.625,9.155),(16.795,9.155),(16.795,8.985),(16.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.225),(35.315,4.395),(35.485,4.395),(35.485,4.225),(35.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.225),(35.825,4.395),(35.995,4.395),(35.995,4.225),(35.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,37.545),(20.405,37.715),(20.575,37.715),(20.575,37.545),(20.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,37.205),(20.405,37.375),(20.575,37.375),(20.575,37.205),(20.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.905),(58.805,22.075),(58.975,22.075),(58.975,21.905),(58.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.405),(44.405,13.575),(44.575,13.575),(44.575,13.405),(44.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.745),(44.405,13.915),(44.575,13.915),(44.575,13.745),(44.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.165),(35.825,18.335),(35.995,18.335),(35.995,18.165),(35.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.165),(35.315,18.335),(35.485,18.335),(35.485,18.165),(35.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.505),(35.315,18.675),(35.485,18.675),(35.485,18.505),(35.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.065),(44.405,13.235),(44.575,13.235),(44.575,13.065),(44.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.365),(78.515,11.535),(78.685,11.535),(78.685,11.365),(78.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.365),(78.005,11.535),(78.175,11.535),(78.175,11.365),(78.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,38.905),(20.915,39.075),(21.085,39.075),(21.085,38.905),(20.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.505),(35.825,18.675),(35.995,18.675),(35.995,18.505),(35.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.685),(44.405,27.855),(44.575,27.855),(44.575,27.685),(44.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.005),(44.405,27.175),(44.575,27.175),(44.575,27.005),(44.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.485),(73.205,17.655),(73.375,17.655),(73.375,17.485),(73.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.145),(73.715,17.315),(73.885,17.315),(73.885,17.145),(73.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.145),(73.205,17.315),(73.375,17.315),(73.375,17.145),(73.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.825),(73.205,17.995),(73.375,17.995),(73.375,17.825),(73.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.825),(73.715,17.995),(73.885,17.995),(73.885,17.825),(73.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.485),(73.715,17.655),(73.885,17.655),(73.885,17.485),(73.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.485),(34.805,17.655),(34.975,17.655),(34.975,17.485),(34.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.625),(31.025,7.795),(31.195,7.795),(31.195,7.625),(31.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,31.425),(73.205,31.595),(73.375,31.595),(73.375,31.425),(73.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,31.425),(73.715,31.595),(73.885,31.595),(73.885,31.425),(73.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.385),(78.005,12.555),(78.175,12.555),(78.175,12.385),(78.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.385),(78.515,12.555),(78.685,12.555),(78.685,12.385),(78.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,39.585),(64.625,39.755),(64.795,39.755),(64.795,39.585),(64.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,2.865),(7.025,3.035),(7.195,3.035),(7.195,2.865),(7.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,39.585),(64.115,39.755),(64.285,39.755),(64.285,39.585),(64.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,39.245),(64.115,39.415),(64.285,39.415),(64.285,39.245),(64.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,39.245),(64.625,39.415),(64.795,39.415),(64.795,39.245),(64.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.565),(50.225,4.735),(50.395,4.735),(50.395,4.565),(50.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,39.925),(68.405,40.095),(68.575,40.095),(68.575,39.925),(68.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.725),(55.025,29.895),(55.195,29.895),(55.195,29.725),(55.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.045),(55.025,29.215),(55.195,29.215),(55.195,29.045),(55.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.325),(39.605,9.495),(39.775,9.495),(39.775,9.325),(39.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.665),(39.605,9.835),(39.775,9.835),(39.775,9.665),(39.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,26.665),(68.915,26.835),(69.085,26.835),(69.085,26.665),(68.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,26.325),(68.915,26.495),(69.085,26.495),(69.085,26.325),(68.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.625),(55.025,7.795),(55.195,7.795),(55.195,7.625),(55.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.945),(64.115,7.115),(64.285,7.115),(64.285,6.945),(64.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.945),(64.625,7.115),(64.795,7.115),(64.795,6.945),(64.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,35.165),(20.915,35.335),(21.085,35.335),(21.085,35.165),(20.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,35.505),(20.915,35.675),(21.085,35.675),(21.085,35.505),(20.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.405),(39.605,13.575),(39.775,13.575),(39.775,13.405),(39.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,2.865),(25.715,3.035),(25.885,3.035),(25.885,2.865),(25.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.885),(35.825,21.055),(35.995,21.055),(35.995,20.885),(35.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.885),(35.315,21.055),(35.485,21.055),(35.485,20.885),(35.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,2.865),(25.205,3.035),(25.375,3.035),(25.375,2.865),(25.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,20.205),(30.005,20.375),(30.175,20.375),(30.175,20.205),(30.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.205),(30.515,20.375),(30.685,20.375),(30.685,20.205),(30.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.865),(31.025,3.035),(31.195,3.035),(31.195,2.865),(31.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.285),(50.225,7.455),(50.395,7.455),(50.395,7.285),(50.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,26.325),(16.115,26.495),(16.285,26.495),(16.285,26.325),(16.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,26.325),(16.625,26.495),(16.795,26.495),(16.795,26.325),(16.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.765),(31.025,31.935),(31.195,31.935),(31.195,31.765),(31.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,30.745),(68.405,30.915),(68.575,30.915),(68.575,30.745),(68.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.085),(31.025,31.255),(31.195,31.255),(31.195,31.085),(31.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,26.665),(78.515,26.835),(78.685,26.835),(78.685,26.665),(78.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,26.325),(78.515,26.495),(78.685,26.495),(78.685,26.325),(78.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,26.325),(78.005,26.495),(78.175,26.495),(78.175,26.325),(78.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,26.665),(78.005,26.835),(78.175,26.835),(78.175,26.665),(78.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.685),(34.805,27.855),(34.975,27.855),(34.975,27.685),(34.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.345),(34.805,27.515),(34.975,27.515),(34.975,27.345),(34.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.005),(34.805,27.175),(34.975,27.175),(34.975,27.005),(34.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.985),(30.515,26.155),(30.685,26.155),(30.685,25.985),(30.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,25.985),(30.005,26.155),(30.175,26.155),(30.175,25.985),(30.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.765),(15.605,14.935),(15.775,14.935),(15.775,14.765),(15.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.085),(15.605,14.255),(15.775,14.255),(15.775,14.085),(15.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.425),(15.605,14.595),(15.775,14.595),(15.775,14.425),(15.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.925),(45.425,6.095),(45.595,6.095),(45.595,5.925),(45.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.305),(44.915,8.475),(45.085,8.475),(45.085,8.305),(44.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.865),(50.225,3.035),(50.395,3.035),(50.395,2.865),(50.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.445),(44.915,15.615),(45.085,15.615),(45.085,15.445),(44.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,23.605),(10.805,23.775),(10.975,23.775),(10.975,23.605),(10.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,23.265),(10.805,23.435),(10.975,23.435),(10.975,23.265),(10.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,26.325),(49.205,26.495),(49.375,26.495),(49.375,26.325),(49.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,26.325),(49.715,26.495),(49.885,26.495),(49.885,26.325),(49.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.025),(55.025,28.195),(55.195,28.195),(55.195,28.025),(55.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.365),(55.025,28.535),(55.195,28.535),(55.195,28.365),(55.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,22.245),(83.315,22.415),(83.485,22.415),(83.485,22.245),(83.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,22.585),(83.315,22.755),(83.485,22.755),(83.485,22.585),(83.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,26.665),(44.915,26.835),(45.085,26.835),(45.085,26.665),(44.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,26.325),(44.915,26.495),(45.085,26.495),(45.085,26.325),(44.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,35.165),(16.115,35.335),(16.285,35.335),(16.285,35.165),(16.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,35.505),(16.115,35.675),(16.285,35.675),(16.285,35.505),(16.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.005),(20.405,10.175),(20.575,10.175),(20.575,10.005),(20.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.685),(20.405,10.855),(20.575,10.855),(20.575,10.685),(20.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.405),(50.225,13.575),(50.395,13.575),(50.395,13.405),(50.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.065),(50.225,13.235),(50.395,13.235),(50.395,13.065),(50.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.745),(50.225,13.915),(50.395,13.915),(50.395,13.745),(50.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,20.205),(82.805,20.375),(82.975,20.375),(82.975,20.205),(82.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,20.545),(82.805,20.715),(82.975,20.715),(82.975,20.545),(82.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.525),(31.025,36.695),(31.195,36.695),(31.195,36.525),(31.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.185),(31.025,36.355),(31.195,36.355),(31.195,36.185),(31.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.605),(7.025,6.775),(7.195,6.775),(7.195,6.605),(7.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.565),(74.225,4.735),(74.395,4.735),(74.395,4.565),(74.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.225),(74.225,4.395),(74.395,4.395),(74.395,4.225),(74.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.405),(40.625,30.575),(40.795,30.575),(40.795,30.405),(40.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.405),(40.115,30.575),(40.285,30.575),(40.285,30.405),(40.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.165),(40.625,35.335),(40.795,35.335),(40.795,35.165),(40.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.505),(40.625,35.675),(40.795,35.675),(40.795,35.505),(40.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.165),(40.115,35.335),(40.285,35.335),(40.285,35.165),(40.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.505),(40.115,35.675),(40.285,35.675),(40.285,35.505),(40.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.045),(35.825,29.215),(35.995,29.215),(35.995,29.045),(35.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.725),(35.825,29.895),(35.995,29.895),(35.995,29.725),(35.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.045),(35.315,29.215),(35.485,29.215),(35.485,29.045),(35.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,22.925),(26.225,23.095),(26.395,23.095),(26.395,22.925),(26.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.725),(35.315,29.895),(35.485,29.895),(35.485,29.725),(35.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.945),(63.605,7.115),(63.775,7.115),(63.775,6.945),(63.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.605),(31.025,6.775),(31.195,6.775),(31.195,6.605),(31.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.265),(31.025,6.435),(31.195,6.435),(31.195,6.265),(31.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.665),(74.225,9.835),(74.395,9.835),(74.395,9.665),(74.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.865),(49.715,3.035),(49.885,3.035),(49.885,2.865),(49.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.865),(49.205,3.035),(49.375,3.035),(49.375,2.865),(49.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,30.405),(73.715,30.575),(73.885,30.575),(73.885,30.405),(73.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,30.405),(73.205,30.575),(73.375,30.575),(73.375,30.405),(73.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.965),(59.315,8.135),(59.485,8.135),(59.485,7.965),(59.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,35.165),(78.005,35.335),(78.175,35.335),(78.175,35.165),(78.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,35.505),(78.515,35.675),(78.685,35.675),(78.685,35.505),(78.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,35.505),(78.005,35.675),(78.175,35.675),(78.175,35.505),(78.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.845),(59.315,36.015),(59.485,36.015),(59.485,35.845),(59.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.965),(59.825,8.135),(59.995,8.135),(59.995,7.965),(59.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,35.845),(59.825,36.015),(59.995,36.015),(59.995,35.845),(59.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,35.165),(78.515,35.335),(78.685,35.335),(78.685,35.165),(78.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.885),(39.605,38.055),(39.775,38.055),(39.775,37.885),(39.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.965),(11.825,8.135),(11.995,8.135),(11.995,7.965),(11.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.745),(30.515,13.915),(30.685,13.915),(30.685,13.745),(30.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.065),(30.515,13.235),(30.685,13.235),(30.685,13.065),(30.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.965),(11.315,8.135),(11.485,8.135),(11.485,7.965),(11.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.745),(30.005,13.915),(30.175,13.915),(30.175,13.745),(30.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.065),(30.005,13.235),(30.175,13.235),(30.175,13.065),(30.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.925),(59.825,6.095),(59.995,6.095),(59.995,5.925),(59.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.925),(59.315,6.095),(59.485,6.095),(59.485,5.925),(59.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.905),(44.915,22.075),(45.085,22.075),(45.085,21.905),(44.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.405),(68.915,13.575),(69.085,13.575),(69.085,13.405),(68.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,36.865),(68.405,37.035),(68.575,37.035),(68.575,36.865),(68.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.745),(68.915,13.915),(69.085,13.915),(69.085,13.745),(68.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.065),(68.915,13.235),(69.085,13.235),(69.085,13.065),(68.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.605),(20.915,6.775),(21.085,6.775),(21.085,6.605),(20.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.585),(40.115,22.755),(40.285,22.755),(40.285,22.585),(40.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.585),(40.625,22.755),(40.795,22.755),(40.795,22.585),(40.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.845),(34.805,36.015),(34.975,36.015),(34.975,35.845),(34.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.345),(79.025,10.515),(79.195,10.515),(79.195,10.345),(79.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.965),(58.805,25.135),(58.975,25.135),(58.975,24.965),(58.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,2.865),(73.715,3.035),(73.885,3.035),(73.885,2.865),(73.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,2.865),(73.205,3.035),(73.375,3.035),(73.375,2.865),(73.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.665),(35.825,9.835),(35.995,9.835),(35.995,9.665),(35.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.385),(49.205,29.555),(49.375,29.555),(49.375,29.385),(49.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.325),(35.315,9.495),(35.485,9.495),(35.485,9.325),(35.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.385),(49.715,29.555),(49.885,29.555),(49.885,29.385),(49.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.665),(35.315,9.835),(35.485,9.835),(35.485,9.665),(35.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.325),(35.825,9.495),(35.995,9.495),(35.995,9.325),(35.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.885),(40.115,21.055),(40.285,21.055),(40.285,20.885),(40.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.185),(20.915,19.355),(21.085,19.355),(21.085,19.185),(20.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.885),(40.625,21.055),(40.795,21.055),(40.795,20.885),(40.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.885),(20.405,4.055),(20.575,4.055),(20.575,3.885),(20.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,31.085),(69.425,31.255),(69.595,31.255),(69.595,31.085),(69.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,31.765),(69.425,31.935),(69.595,31.935),(69.595,31.765),(69.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,26.665),(74.225,26.835),(74.395,26.835),(74.395,26.665),(74.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.405),(50.225,30.575),(50.395,30.575),(50.395,30.405),(50.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,30.745),(69.425,30.915),(69.595,30.915),(69.595,30.745),(69.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,30.065),(69.425,30.235),(69.595,30.235),(69.595,30.065),(69.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.945),(30.515,7.115),(30.685,7.115),(30.685,6.945),(30.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.945),(30.005,7.115),(30.175,7.115),(30.175,6.945),(30.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,35.165),(7.025,35.335),(7.195,35.335),(7.195,35.165),(7.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,35.505),(7.025,35.675),(7.195,35.675),(7.195,35.505),(7.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.645),(82.805,8.815),(82.975,8.815),(82.975,8.645),(82.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.065),(31.025,30.235),(31.195,30.235),(31.195,30.065),(31.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.745),(31.025,30.915),(31.195,30.915),(31.195,30.745),(31.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.845),(63.605,19.015),(63.775,19.015),(63.775,18.845),(63.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,20.545),(16.115,20.715),(16.285,20.715),(16.285,20.545),(16.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,20.205),(16.625,20.375),(16.795,20.375),(16.795,20.205),(16.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.945),(58.805,7.115),(58.975,7.115),(58.975,6.945),(58.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.365),(16.115,11.535),(16.285,11.535),(16.285,11.365),(16.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.025),(16.625,11.195),(16.795,11.195),(16.795,11.025),(16.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.705),(16.625,11.875),(16.795,11.875),(16.795,11.705),(16.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.365),(16.625,11.535),(16.795,11.535),(16.795,11.365),(16.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.025),(16.115,11.195),(16.285,11.195),(16.285,11.025),(16.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.705),(16.115,11.875),(16.285,11.875),(16.285,11.705),(16.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.985),(39.605,26.155),(39.775,26.155),(39.775,25.985),(39.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.945),(10.805,7.115),(10.975,7.115),(10.975,6.945),(10.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.505),(31.025,35.675),(31.195,35.675),(31.195,35.505),(31.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.165),(31.025,35.335),(31.195,35.335),(31.195,35.165),(31.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,21.565),(11.315,21.735),(11.485,21.735),(11.485,21.565),(11.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,21.565),(11.825,21.735),(11.995,21.735),(11.995,21.565),(11.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.625),(45.425,24.795),(45.595,24.795),(45.595,24.625),(45.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.285),(45.425,24.455),(45.595,24.455),(45.595,24.285),(45.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.625),(40.115,7.795),(40.285,7.795),(40.285,7.625),(40.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.625),(40.625,7.795),(40.795,7.795),(40.795,7.625),(40.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.165),(74.225,18.335),(74.395,18.335),(74.395,18.165),(74.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.505),(74.225,18.675),(74.395,18.675),(74.395,18.505),(74.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.025),(50.225,11.195),(50.395,11.195),(50.395,11.025),(50.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.705),(50.225,11.875),(50.395,11.875),(50.395,11.705),(50.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.365),(50.225,11.535),(50.395,11.535),(50.395,11.365),(50.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.005),(68.405,10.175),(68.575,10.175),(68.575,10.005),(68.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.345),(68.405,10.515),(68.575,10.515),(68.575,10.345),(68.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.685),(68.405,10.855),(68.575,10.855),(68.575,10.685),(68.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.925),(30.515,40.095),(30.685,40.095),(30.685,39.925),(30.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.745),(73.205,13.915),(73.375,13.915),(73.375,13.745),(73.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.745),(73.715,13.915),(73.885,13.915),(73.885,13.745),(73.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.405),(73.205,13.575),(73.375,13.575),(73.375,13.405),(73.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.405),(73.715,13.575),(73.885,13.575),(73.885,13.405),(73.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.885),(35.315,38.055),(35.485,38.055),(35.485,37.885),(35.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.885),(35.825,38.055),(35.995,38.055),(35.995,37.885),(35.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.065),(73.205,13.235),(73.375,13.235),(73.375,13.065),(73.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.065),(73.715,13.235),(73.885,13.235),(73.885,13.065),(73.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,27.005),(82.805,27.175),(82.975,27.175),(82.975,27.005),(82.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,27.685),(82.805,27.855),(82.975,27.855),(82.975,27.685),(82.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.045),(39.605,12.215),(39.775,12.215),(39.775,12.045),(39.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.725),(39.605,12.895),(39.775,12.895),(39.775,12.725),(39.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.405),(58.805,13.575),(58.975,13.575),(58.975,13.405),(58.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.085),(45.425,31.255),(45.595,31.255),(45.595,31.085),(45.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.425),(45.425,31.595),(45.595,31.595),(45.595,31.425),(45.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.765),(45.425,31.935),(45.595,31.935),(45.595,31.765),(45.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,36.865),(64.625,37.035),(64.795,37.035),(64.795,36.865),(64.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,36.865),(64.115,37.035),(64.285,37.035),(64.285,36.865),(64.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.885),(54.005,38.055),(54.175,38.055),(54.175,37.885),(54.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.885),(54.515,38.055),(54.685,38.055),(54.685,37.885),(54.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,21.905),(68.405,22.075),(68.575,22.075),(68.575,21.905),(68.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.705),(54.515,28.875),(54.685,28.875),(54.685,28.705),(54.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.705),(54.005,28.875),(54.175,28.875),(54.175,28.705),(54.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,20.885),(25.715,21.055),(25.885,21.055),(25.885,20.885),(25.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,20.885),(25.205,21.055),(25.375,21.055),(25.375,20.885),(25.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.605),(44.405,6.775),(44.575,6.775),(44.575,6.605),(44.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,22.925),(21.425,23.095),(21.595,23.095),(21.595,22.925),(21.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.625),(16.625,7.795),(16.795,7.795),(16.795,7.625),(16.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.625),(16.115,7.795),(16.285,7.795),(16.285,7.625),(16.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.645),(40.115,8.815),(40.285,8.815),(40.285,8.645),(40.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.645),(40.625,8.815),(40.795,8.815),(40.795,8.645),(40.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,38.905),(79.025,39.075),(79.195,39.075),(79.195,38.905),(79.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,31.765),(20.405,31.935),(20.575,31.935),(20.575,31.765),(20.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,31.085),(20.405,31.255),(20.575,31.255),(20.575,31.085),(20.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,31.425),(20.405,31.595),(20.575,31.595),(20.575,31.425),(20.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,39.245),(10.805,39.415),(10.975,39.415),(10.975,39.245),(10.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,39.585),(10.805,39.755),(10.975,39.755),(10.975,39.585),(10.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,40.265),(78.515,40.435),(78.685,40.435),(78.685,40.265),(78.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,40.605),(78.515,40.775),(78.685,40.775),(78.685,40.605),(78.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,40.605),(78.005,40.775),(78.175,40.775),(78.175,40.605),(78.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,40.265),(78.005,40.435),(78.175,40.435),(78.175,40.265),(78.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,37.885),(26.225,38.055),(26.395,38.055),(26.395,37.885),(26.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,25.985),(26.225,26.155),(26.395,26.155),(26.395,25.985),(26.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.505),(39.605,18.675),(39.775,18.675),(39.775,18.505),(39.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.345),(44.405,10.515),(44.575,10.515),(44.575,10.345),(44.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.605),(26.225,6.775),(26.395,6.775),(26.395,6.605),(26.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.265),(26.225,6.435),(26.395,6.435),(26.395,6.265),(26.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,21.225),(20.915,21.395),(21.085,21.395),(21.085,21.225),(20.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,21.565),(20.915,21.735),(21.085,21.735),(21.085,21.565),(20.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.605),(68.915,6.775),(69.085,6.775),(69.085,6.605),(68.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.765),(55.025,31.935),(55.195,31.935),(55.195,31.765),(55.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.085),(55.025,31.255),(55.195,31.255),(55.195,31.085),(55.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.285),(50.225,24.455),(50.395,24.455),(50.395,24.285),(50.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.705),(39.605,11.875),(39.775,11.875),(39.775,11.705),(39.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,30.065),(20.915,30.235),(21.085,30.235),(21.085,30.065),(20.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,30.405),(20.915,30.575),(21.085,30.575),(21.085,30.405),(20.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.025),(39.605,11.195),(39.775,11.195),(39.775,11.025),(39.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,30.745),(20.915,30.915),(21.085,30.915),(21.085,30.745),(20.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,24.965),(83.315,25.135),(83.485,25.135),(83.485,24.965),(83.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.665),(59.315,9.835),(59.485,9.835),(59.485,9.665),(59.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.665),(59.825,9.835),(59.995,9.835),(59.995,9.665),(59.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,21.225),(6.515,21.395),(6.685,21.395),(6.685,21.225),(6.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.325),(83.315,9.495),(83.485,9.495),(83.485,9.325),(83.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.905),(55.025,22.075),(55.195,22.075),(55.195,21.905),(55.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.925),(44.405,6.095),(44.575,6.095),(44.575,5.925),(44.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.405),(45.425,30.575),(45.595,30.575),(45.595,30.405),(45.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,26.665),(30.515,26.835),(30.685,26.835),(30.685,26.665),(30.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,26.665),(30.005,26.835),(30.175,26.835),(30.175,26.665),(30.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,26.325),(30.515,26.495),(30.685,26.495),(30.685,26.325),(30.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,26.325),(30.005,26.495),(30.175,26.495),(30.175,26.325),(30.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,33.805),(82.805,33.975),(82.975,33.975),(82.975,33.805),(82.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,33.125),(82.805,33.295),(82.975,33.295),(82.975,33.125),(82.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,33.465),(82.805,33.635),(82.975,33.635),(82.975,33.465),(82.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,25.645),(25.715,25.815),(25.885,25.815),(25.885,25.645),(25.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,25.645),(25.205,25.815),(25.375,25.815),(25.375,25.645),(25.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.365),(35.825,28.535),(35.995,28.535),(35.995,28.365),(35.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.025),(35.315,28.195),(35.485,28.195),(35.485,28.025),(35.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.365),(35.315,28.535),(35.485,28.535),(35.485,28.365),(35.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.025),(35.825,28.195),(35.995,28.195),(35.995,28.025),(35.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.965),(16.625,8.135),(16.795,8.135),(16.795,7.965),(16.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.965),(16.115,8.135),(16.285,8.135),(16.285,7.965),(16.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,34.825),(79.025,34.995),(79.195,34.995),(79.195,34.825),(79.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,34.485),(79.025,34.655),(79.195,34.655),(79.195,34.485),(79.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,34.145),(79.025,34.315),(79.195,34.315),(79.195,34.145),(79.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.525),(35.825,19.695),(35.995,19.695),(35.995,19.525),(35.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.185),(35.825,19.355),(35.995,19.355),(35.995,19.185),(35.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.525),(35.315,19.695),(35.485,19.695),(35.485,19.525),(35.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,24.965),(59.825,25.135),(59.995,25.135),(59.995,24.965),(59.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.965),(59.315,25.135),(59.485,25.135),(59.485,24.965),(59.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,20.545),(11.825,20.715),(11.995,20.715),(11.995,20.545),(11.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,20.545),(11.315,20.715),(11.485,20.715),(11.485,20.545),(11.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,20.205),(11.825,20.375),(11.995,20.375),(11.995,20.205),(11.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,20.205),(11.315,20.375),(11.485,20.375),(11.485,20.205),(11.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.065),(55.025,30.235),(55.195,30.235),(55.195,30.065),(55.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.405),(55.025,30.575),(55.195,30.575),(55.195,30.405),(55.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.745),(55.025,30.915),(55.195,30.915),(55.195,30.745),(55.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.465),(35.825,33.635),(35.995,33.635),(35.995,33.465),(35.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.885),(34.805,21.055),(34.975,21.055),(34.975,20.885),(34.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.465),(35.315,33.635),(35.485,33.635),(35.485,33.465),(35.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.805),(35.315,33.975),(35.485,33.975),(35.485,33.805),(35.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.805),(35.825,33.975),(35.995,33.975),(35.995,33.805),(35.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.125),(35.315,33.295),(35.485,33.295),(35.485,33.125),(35.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,21.565),(10.805,21.735),(10.975,21.735),(10.975,21.565),(10.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.125),(35.825,33.295),(35.995,33.295),(35.995,33.125),(35.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.805),(16.115,16.975),(16.285,16.975),(16.285,16.805),(16.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.125),(16.115,16.295),(16.285,16.295),(16.285,16.125),(16.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.465),(16.115,16.635),(16.285,16.635),(16.285,16.465),(16.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,38.225),(64.115,38.395),(64.285,38.395),(64.285,38.225),(64.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,38.565),(64.115,38.735),(64.285,38.735),(64.285,38.565),(64.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,27.685),(83.315,27.855),(83.485,27.855),(83.485,27.685),(83.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.985),(35.825,26.155),(35.995,26.155),(35.995,25.985),(35.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.185),(34.805,36.355),(34.975,36.355),(34.975,36.185),(34.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.525),(34.805,36.695),(34.975,36.695),(34.975,36.525),(34.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.985),(35.315,26.155),(35.485,26.155),(35.485,25.985),(35.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,27.005),(83.315,27.175),(83.485,27.175),(83.485,27.005),(83.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,38.565),(64.625,38.735),(64.795,38.735),(64.795,38.565),(64.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,38.225),(64.625,38.395),(64.795,38.395),(64.795,38.225),(64.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.905),(39.605,39.075),(39.775,39.075),(39.775,38.905),(39.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.625),(25.715,7.795),(25.885,7.795),(25.885,7.625),(25.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.625),(25.205,7.795),(25.375,7.795),(25.375,7.625),(25.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,24.965),(25.715,25.135),(25.885,25.135),(25.885,24.965),(25.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,24.965),(25.205,25.135),(25.375,25.135),(25.375,24.965),(25.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,40.265),(30.515,40.435),(30.685,40.435),(30.685,40.265),(30.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.565),(39.605,21.735),(39.775,21.735),(39.775,21.565),(39.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.085),(49.205,14.255),(49.375,14.255),(49.375,14.085),(49.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.765),(49.205,14.935),(49.375,14.935),(49.375,14.765),(49.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.085),(49.715,14.255),(49.885,14.255),(49.885,14.085),(49.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.965),(55.025,8.135),(55.195,8.135),(55.195,7.965),(55.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.765),(49.715,14.935),(49.885,14.935),(49.885,14.765),(49.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.545),(64.625,3.715),(64.795,3.715),(64.795,3.545),(64.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.205),(64.625,3.375),(64.795,3.375),(64.795,3.205),(64.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,28.025),(11.825,28.195),(11.995,28.195),(11.995,28.025),(11.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,28.365),(11.825,28.535),(11.995,28.535),(11.995,28.365),(11.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,28.025),(11.315,28.195),(11.485,28.195),(11.485,28.025),(11.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.545),(64.115,3.715),(64.285,3.715),(64.285,3.545),(64.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.205),(64.115,3.375),(64.285,3.375),(64.285,3.205),(64.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,28.365),(11.315,28.535),(11.485,28.535),(11.485,28.365),(11.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,27.685),(6.515,27.855),(6.685,27.855),(6.685,27.685),(6.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,27.005),(6.515,27.175),(6.685,27.175),(6.685,27.005),(6.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.245),(79.025,5.415),(79.195,5.415),(79.195,5.245),(79.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,21.905),(69.425,22.075),(69.595,22.075),(69.595,21.905),(69.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.765),(35.315,31.935),(35.485,31.935),(35.485,31.765),(35.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.765),(35.825,31.935),(35.995,31.935),(35.995,31.765),(35.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.085),(35.825,31.255),(35.995,31.255),(35.995,31.085),(35.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.085),(35.315,31.255),(35.485,31.255),(35.485,31.085),(35.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.985),(74.225,9.155),(74.395,9.155),(74.395,8.985),(74.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.425),(35.315,31.595),(35.485,31.595),(35.485,31.425),(35.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.425),(35.825,31.595),(35.995,31.595),(35.995,31.425),(35.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.285),(49.205,7.455),(49.375,7.455),(49.375,7.285),(49.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,27.685),(21.425,27.855),(21.595,27.855),(21.595,27.685),(21.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,27.005),(21.425,27.175),(21.595,27.175),(21.595,27.005),(21.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,27.345),(21.425,27.515),(21.595,27.515),(21.595,27.345),(21.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.285),(49.715,7.455),(49.885,7.455),(49.885,7.285),(49.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.385),(64.115,12.555),(64.285,12.555),(64.285,12.385),(64.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.385),(64.625,12.555),(64.795,12.555),(64.795,12.385),(64.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,39.925),(82.805,40.095),(82.975,40.095),(82.975,39.925),(82.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,34.485),(73.715,34.655),(73.885,34.655),(73.885,34.485),(73.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,34.485),(73.205,34.655),(73.375,34.655),(73.375,34.485),(73.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,34.145),(73.205,34.315),(73.375,34.315),(73.375,34.145),(73.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,34.145),(73.715,34.315),(73.885,34.315),(73.885,34.145),(73.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,34.825),(73.205,34.995),(73.375,34.995),(73.375,34.825),(73.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,34.825),(73.715,34.995),(73.885,34.995),(73.885,34.825),(73.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,20.885),(78.515,21.055),(78.685,21.055),(78.685,20.885),(78.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,20.885),(78.005,21.055),(78.175,21.055),(78.175,20.885),(78.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,27.345),(74.225,27.515),(74.395,27.515),(74.395,27.345),(74.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,27.685),(74.225,27.855),(74.395,27.855),(74.395,27.685),(74.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,27.005),(74.225,27.175),(74.395,27.175),(74.395,27.005),(74.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.225),(40.115,21.395),(40.285,21.395),(40.285,21.225),(40.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.565),(40.625,21.735),(40.795,21.735),(40.795,21.565),(40.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.565),(40.115,21.735),(40.285,21.735),(40.285,21.565),(40.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.225),(40.625,21.395),(40.795,21.395),(40.795,21.225),(40.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,23.265),(26.225,23.435),(26.395,23.435),(26.395,23.265),(26.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.305),(63.605,8.475),(63.775,8.475),(63.775,8.305),(63.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.645),(63.605,8.815),(63.775,8.815),(63.775,8.645),(63.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.865),(39.605,20.035),(39.775,20.035),(39.775,19.865),(39.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,27.345),(78.005,27.515),(78.175,27.515),(78.175,27.345),(78.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,27.345),(78.515,27.515),(78.685,27.515),(78.685,27.345),(78.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,20.885),(64.625,21.055),(64.795,21.055),(64.795,20.885),(64.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,20.885),(64.115,21.055),(64.285,21.055),(64.285,20.885),(64.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.425),(58.805,31.595),(58.975,31.595),(58.975,31.425),(58.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.765),(58.805,31.935),(58.975,31.935),(58.975,31.765),(58.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.345),(49.715,27.515),(49.885,27.515),(49.885,27.345),(49.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.085),(58.805,31.255),(58.975,31.255),(58.975,31.085),(58.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.345),(49.205,27.515),(49.375,27.515),(49.375,27.345),(49.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.045),(16.625,12.215),(16.795,12.215),(16.795,12.045),(16.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.725),(16.625,12.895),(16.795,12.895),(16.795,12.725),(16.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.385),(16.115,12.555),(16.285,12.555),(16.285,12.385),(16.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.805),(44.405,16.975),(44.575,16.975),(44.575,16.805),(44.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.125),(44.405,16.295),(44.575,16.295),(44.575,16.125),(44.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.025),(50.225,28.195),(50.395,28.195),(50.395,28.025),(50.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.365),(50.225,28.535),(50.395,28.535),(50.395,28.365),(50.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.845),(69.425,19.015),(69.595,19.015),(69.595,18.845),(69.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.525),(74.225,19.695),(74.395,19.695),(74.395,19.525),(74.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,40.605),(39.605,40.775),(39.775,40.775),(39.775,40.605),(39.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,40.265),(39.605,40.435),(39.775,40.435),(39.775,40.265),(39.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.305),(49.715,8.475),(49.885,8.475),(49.885,8.305),(49.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.645),(49.715,8.815),(49.885,8.815),(49.885,8.645),(49.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.305),(49.205,8.475),(49.375,8.475),(49.375,8.305),(49.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.645),(49.205,8.815),(49.375,8.815),(49.375,8.645),(49.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.265),(34.805,23.435),(34.975,23.435),(34.975,23.265),(34.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.825),(64.115,17.995),(64.285,17.995),(64.285,17.825),(64.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.825),(64.625,17.995),(64.795,17.995),(64.795,17.825),(64.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.145),(64.115,17.315),(64.285,17.315),(64.285,17.145),(64.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.145),(64.625,17.315),(64.795,17.315),(64.795,17.145),(64.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.205),(54.515,3.375),(54.685,3.375),(54.685,3.205),(54.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.205),(54.005,3.375),(54.175,3.375),(54.175,3.205),(54.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.885),(68.915,4.055),(69.085,4.055),(69.085,3.885),(68.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.545),(54.515,3.715),(54.685,3.715),(54.685,3.545),(54.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.545),(54.005,3.715),(54.175,3.715),(54.175,3.545),(54.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.905),(35.825,5.075),(35.995,5.075),(35.995,4.905),(35.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.905),(35.315,5.075),(35.485,5.075),(35.485,4.905),(35.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.125),(54.515,16.295),(54.685,16.295),(54.685,16.125),(54.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.465),(54.515,16.635),(54.685,16.635),(54.685,16.465),(54.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.125),(54.005,16.295),(54.175,16.295),(54.175,16.125),(54.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.465),(54.005,16.635),(54.175,16.635),(54.175,16.465),(54.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.805),(54.515,16.975),(54.685,16.975),(54.685,16.805),(54.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.805),(54.005,16.975),(54.175,16.975),(54.175,16.805),(54.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.545),(6.515,3.715),(6.685,3.715),(6.685,3.545),(6.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.005),(59.315,27.175),(59.485,27.175),(59.485,27.005),(59.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,27.685),(59.825,27.855),(59.995,27.855),(59.995,27.685),(59.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.685),(59.315,27.855),(59.485,27.855),(59.485,27.685),(59.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.845),(35.825,19.015),(35.995,19.015),(35.995,18.845),(35.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.845),(35.315,19.015),(35.485,19.015),(35.485,18.845),(35.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,27.005),(59.825,27.175),(59.995,27.175),(59.995,27.005),(59.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,27.345),(59.825,27.515),(59.995,27.515),(59.995,27.345),(59.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.345),(59.315,27.515),(59.485,27.515),(59.485,27.345),(59.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,38.225),(20.915,38.395),(21.085,38.395),(21.085,38.225),(20.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,38.565),(20.915,38.735),(21.085,38.735),(21.085,38.565),(20.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,25.305),(20.915,25.475),(21.085,25.475),(21.085,25.305),(20.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.445),(40.625,32.615),(40.795,32.615),(40.795,32.445),(40.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.105),(40.115,32.275),(40.285,32.275),(40.285,32.105),(40.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.445),(40.115,32.615),(40.285,32.615),(40.285,32.445),(40.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.785),(40.115,32.955),(40.285,32.955),(40.285,32.785),(40.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.105),(40.625,32.275),(40.795,32.275),(40.795,32.105),(40.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,25.645),(20.915,25.815),(21.085,25.815),(21.085,25.645),(20.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.805),(31.025,16.975),(31.195,16.975),(31.195,16.805),(31.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.125),(31.025,16.295),(31.195,16.295),(31.195,16.125),(31.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.785),(40.625,32.955),(40.795,32.955),(40.795,32.785),(40.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.285),(73.715,7.455),(73.885,7.455),(73.885,7.285),(73.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.285),(73.205,7.455),(73.375,7.455),(73.375,7.285),(73.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.645),(30.515,8.815),(30.685,8.815),(30.685,8.645),(30.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.305),(30.515,8.475),(30.685,8.475),(30.685,8.305),(30.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.605),(25.715,6.775),(25.885,6.775),(25.885,6.605),(25.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.605),(25.205,6.775),(25.375,6.775),(25.375,6.605),(25.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.265),(25.715,6.435),(25.885,6.435),(25.885,6.265),(25.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.265),(25.205,6.435),(25.375,6.435),(25.375,6.265),(25.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.205),(79.025,3.375),(79.195,3.375),(79.195,3.205),(79.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,40.605),(20.405,40.775),(20.575,40.775),(20.575,40.605),(20.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,40.265),(20.405,40.435),(20.575,40.435),(20.575,40.265),(20.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.205),(30.515,3.375),(30.685,3.375),(30.685,3.205),(30.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.545),(30.005,3.715),(30.175,3.715),(30.175,3.545),(30.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,31.425),(11.315,31.595),(11.485,31.595),(11.485,31.425),(11.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,31.425),(11.825,31.595),(11.995,31.595),(11.995,31.425),(11.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.205),(59.825,3.375),(59.995,3.375),(59.995,3.205),(59.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.205),(59.315,3.375),(59.485,3.375),(59.485,3.205),(59.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.445),(31.025,15.615),(31.195,15.615),(31.195,15.445),(31.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.865),(74.225,20.035),(74.395,20.035),(74.395,19.865),(74.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.545),(11.315,3.715),(11.485,3.715),(11.485,3.545),(11.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.545),(11.825,3.715),(11.995,3.715),(11.995,3.545),(11.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.565),(68.405,4.735),(68.575,4.735),(68.575,4.565),(68.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.845),(44.915,36.015),(45.085,36.015),(45.085,35.845),(44.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,20.885),(30.005,21.055),(30.175,21.055),(30.175,20.885),(30.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.885),(30.515,21.055),(30.685,21.055),(30.685,20.885),(30.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,27.005),(30.005,27.175),(30.175,27.175),(30.175,27.005),(30.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.005),(30.515,27.175),(30.685,27.175),(30.685,27.005),(30.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,27.685),(30.005,27.855),(30.175,27.855),(30.175,27.685),(30.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.685),(30.515,27.855),(30.685,27.855),(30.685,27.685),(30.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.345),(30.515,27.515),(30.685,27.515),(30.685,27.345),(30.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.925),(30.005,6.095),(30.175,6.095),(30.175,5.925),(30.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,27.345),(30.005,27.515),(30.175,27.515),(30.175,27.345),(30.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.945),(45.425,24.115),(45.595,24.115),(45.595,23.945),(45.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,22.585),(64.115,22.755),(64.285,22.755),(64.285,22.585),(64.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,22.585),(64.625,22.755),(64.795,22.755),(64.795,22.585),(64.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.105),(64.115,15.275),(64.285,15.275),(64.285,15.105),(64.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.105),(64.625,15.275),(64.795,15.275),(64.795,15.105),(64.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.445),(64.115,15.615),(64.285,15.615),(64.285,15.445),(64.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.445),(64.625,15.615),(64.795,15.615),(64.795,15.445),(64.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.885),(6.515,4.055),(6.685,4.055),(6.685,3.885),(6.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.325),(82.805,9.495),(82.975,9.495),(82.975,9.325),(82.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,26.665),(7.025,26.835),(7.195,26.835),(7.195,26.665),(7.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.165),(55.025,18.335),(55.195,18.335),(55.195,18.165),(55.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,35.165),(21.425,35.335),(21.595,35.335),(21.595,35.165),(21.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,35.505),(21.425,35.675),(21.595,35.675),(21.595,35.505),(21.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.885),(83.315,4.055),(83.485,4.055),(83.485,3.885),(83.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,28.025),(68.915,28.195),(69.085,28.195),(69.085,28.025),(68.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,28.365),(68.915,28.535),(69.085,28.535),(69.085,28.365),(68.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.545),(39.605,20.715),(39.775,20.715),(39.775,20.545),(39.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,24.625),(74.225,24.795),(74.395,24.795),(74.395,24.625),(74.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,24.285),(74.225,24.455),(74.395,24.455),(74.395,24.285),(74.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,36.185),(69.425,36.355),(69.595,36.355),(69.595,36.185),(69.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,36.525),(69.425,36.695),(69.595,36.695),(69.595,36.525),(69.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,22.925),(83.315,23.095),(83.485,23.095),(83.485,22.925),(83.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.605),(30.515,23.775),(30.685,23.775),(30.685,23.605),(30.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,23.605),(30.005,23.775),(30.175,23.775),(30.175,23.605),(30.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.345),(6.515,10.515),(6.685,10.515),(6.685,10.345),(6.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.005),(6.515,10.175),(6.685,10.175),(6.685,10.005),(6.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.685),(6.515,10.855),(6.685,10.855),(6.685,10.685),(6.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.885),(30.005,4.055),(30.175,4.055),(30.175,3.885),(30.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.885),(55.025,38.055),(55.195,38.055),(55.195,37.885),(55.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.305),(50.225,25.475),(50.395,25.475),(50.395,25.305),(50.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,20.885),(82.805,21.055),(82.975,21.055),(82.975,20.885),(82.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.065),(35.315,30.235),(35.485,30.235),(35.485,30.065),(35.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.405),(35.315,30.575),(35.485,30.575),(35.485,30.405),(35.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.405),(35.825,30.575),(35.995,30.575),(35.995,30.405),(35.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.065),(35.825,30.235),(35.995,30.235),(35.995,30.065),(35.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.745),(35.315,30.915),(35.485,30.915),(35.485,30.745),(35.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.745),(35.825,30.915),(35.995,30.915),(35.995,30.745),(35.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.865),(31.025,37.035),(31.195,37.035),(31.195,36.865),(31.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.505),(25.715,18.675),(25.885,18.675),(25.885,18.505),(25.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.165),(25.205,18.335),(25.375,18.335),(25.375,18.165),(25.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.165),(25.715,18.335),(25.885,18.335),(25.885,18.165),(25.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.505),(25.205,18.675),(25.375,18.675),(25.375,18.505),(25.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.485),(16.115,17.655),(16.285,17.655),(16.285,17.485),(16.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.825),(16.625,17.995),(16.795,17.995),(16.795,17.825),(16.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.785),(16.625,15.955),(16.795,15.955),(16.795,15.785),(16.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.145),(16.625,17.315),(16.795,17.315),(16.795,17.145),(16.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.265),(49.715,6.435),(49.885,6.435),(49.885,6.265),(49.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.605),(49.205,6.775),(49.375,6.775),(49.375,6.605),(49.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.265),(49.205,6.435),(49.375,6.435),(49.375,6.265),(49.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.605),(49.715,6.775),(49.885,6.775),(49.885,6.605),(49.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,26.325),(79.025,26.495),(79.195,26.495),(79.195,26.325),(79.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.905),(74.225,5.075),(74.395,5.075),(74.395,4.905),(74.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.485),(68.915,17.655),(69.085,17.655),(69.085,17.485),(68.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.145),(68.915,17.315),(69.085,17.315),(69.085,17.145),(68.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.825),(68.915,17.995),(69.085,17.995),(69.085,17.825),(68.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.685),(74.225,10.855),(74.395,10.855),(74.395,10.685),(74.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.005),(74.225,10.175),(74.395,10.175),(74.395,10.005),(74.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.625),(55.025,24.795),(55.195,24.795),(55.195,24.625),(55.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.685),(64.115,10.855),(64.285,10.855),(64.285,10.685),(64.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.685),(64.625,10.855),(64.795,10.855),(64.795,10.685),(64.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.005),(64.115,10.175),(64.285,10.175),(64.285,10.005),(64.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.005),(64.625,10.175),(64.795,10.175),(64.795,10.005),(64.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.545),(45.425,3.715),(45.595,3.715),(45.595,3.545),(45.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.885),(31.025,38.055),(31.195,38.055),(31.195,37.885),(31.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.565),(64.115,4.735),(64.285,4.735),(64.285,4.565),(64.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.225),(64.625,4.395),(64.795,4.395),(64.795,4.225),(64.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.565),(64.625,4.735),(64.795,4.735),(64.795,4.565),(64.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.225),(64.115,4.395),(64.285,4.395),(64.285,4.225),(64.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.345),(26.225,10.515),(26.395,10.515),(26.395,10.345),(26.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.945),(31.025,7.115),(31.195,7.115),(31.195,6.945),(31.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.205),(39.605,37.375),(39.775,37.375),(39.775,37.205),(39.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.545),(39.605,37.715),(39.775,37.715),(39.775,37.545),(39.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.925),(58.805,6.095),(58.975,6.095),(58.975,5.925),(58.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.925),(34.805,6.095),(34.975,6.095),(34.975,5.925),(34.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.345),(54.515,10.515),(54.685,10.515),(54.685,10.345),(54.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.345),(54.005,10.515),(54.175,10.515),(54.175,10.345),(54.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.585),(59.825,5.755),(59.995,5.755),(59.995,5.585),(59.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.585),(59.315,5.755),(59.485,5.755),(59.485,5.585),(59.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,40.605),(35.315,40.775),(35.485,40.775),(35.485,40.605),(35.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,40.605),(35.825,40.775),(35.995,40.775),(35.995,40.605),(35.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,40.265),(35.825,40.435),(35.995,40.435),(35.995,40.265),(35.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,40.265),(35.315,40.435),(35.485,40.435),(35.485,40.265),(35.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.765),(50.225,14.935),(50.395,14.935),(50.395,14.765),(50.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.085),(50.225,14.255),(50.395,14.255),(50.395,14.085),(50.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,30.065),(11.825,30.235),(11.995,30.235),(11.995,30.065),(11.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,30.745),(11.315,30.915),(11.485,30.915),(11.485,30.745),(11.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,30.745),(11.825,30.915),(11.995,30.915),(11.995,30.745),(11.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.965),(78.005,8.135),(78.175,8.135),(78.175,7.965),(78.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.245),(11.825,5.415),(11.995,5.415),(11.995,5.245),(11.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.585),(11.315,5.755),(11.485,5.755),(11.485,5.585),(11.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,30.405),(11.825,30.575),(11.995,30.575),(11.995,30.405),(11.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,30.405),(11.315,30.575),(11.485,30.575),(11.485,30.405),(11.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.965),(78.515,8.135),(78.685,8.135),(78.685,7.965),(78.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,30.065),(11.315,30.235),(11.485,30.235),(11.485,30.065),(11.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.965),(34.805,8.135),(34.975,8.135),(34.975,7.965),(34.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.585),(11.825,5.755),(11.995,5.755),(11.995,5.585),(11.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.245),(11.315,5.415),(11.485,5.415),(11.485,5.245),(11.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,25.645),(6.515,25.815),(6.685,25.815),(6.685,25.645),(6.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,23.265),(7.025,23.435),(7.195,23.435),(7.195,23.265),(7.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,23.605),(7.025,23.775),(7.195,23.775),(7.195,23.605),(7.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.765),(31.025,14.935),(31.195,14.935),(31.195,14.765),(31.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.425),(31.025,14.595),(31.195,14.595),(31.195,14.425),(31.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.085),(31.025,14.255),(31.195,14.255),(31.195,14.085),(31.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.305),(69.425,8.475),(69.595,8.475),(69.595,8.305),(69.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,33.805),(63.605,33.975),(63.775,33.975),(63.775,33.805),(63.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,33.465),(63.605,33.635),(63.775,33.635),(63.775,33.465),(63.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,33.125),(63.605,33.295),(63.775,33.295),(63.775,33.125),(63.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,22.585),(16.625,22.755),(16.795,22.755),(16.795,22.585),(16.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,22.585),(16.115,22.755),(16.285,22.755),(16.285,22.585),(16.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.545),(20.405,3.715),(20.575,3.715),(20.575,3.545),(20.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.205),(20.405,3.375),(20.575,3.375),(20.575,3.205),(20.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,30.065),(6.515,30.235),(6.685,30.235),(6.685,30.065),(6.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,30.745),(6.515,30.915),(6.685,30.915),(6.685,30.745),(6.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,29.045),(68.405,29.215),(68.575,29.215),(68.575,29.045),(68.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,29.725),(68.405,29.895),(68.575,29.895),(68.575,29.725),(68.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,20.205),(10.805,20.375),(10.975,20.375),(10.975,20.205),(10.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,20.545),(10.805,20.715),(10.975,20.715),(10.975,20.545),(10.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.165),(50.225,35.335),(50.395,35.335),(50.395,35.165),(50.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.505),(50.225,35.675),(50.395,35.675),(50.395,35.505),(50.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,20.885),(16.625,21.055),(16.795,21.055),(16.795,20.885),(16.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,32.105),(59.825,32.275),(59.995,32.275),(59.995,32.105),(59.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,32.445),(59.825,32.615),(59.995,32.615),(59.995,32.445),(59.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.105),(59.315,32.275),(59.485,32.275),(59.485,32.105),(59.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.445),(59.315,32.615),(59.485,32.615),(59.485,32.445),(59.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,32.785),(59.825,32.955),(59.995,32.955),(59.995,32.785),(59.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.785),(59.315,32.955),(59.485,32.955),(59.485,32.785),(59.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.305),(39.605,25.475),(39.775,25.475),(39.775,25.305),(39.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.645),(39.605,25.815),(39.775,25.815),(39.775,25.645),(39.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.725),(58.805,29.895),(58.975,29.895),(58.975,29.725),(58.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.045),(58.805,29.215),(58.975,29.215),(58.975,29.045),(58.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.965),(45.425,25.135),(45.595,25.135),(45.595,24.965),(45.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.845),(74.225,19.015),(74.395,19.015),(74.395,18.845),(74.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.505),(64.625,18.675),(64.795,18.675),(64.795,18.505),(64.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.505),(64.115,18.675),(64.285,18.675),(64.285,18.505),(64.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.965),(25.715,8.135),(25.885,8.135),(25.885,7.965),(25.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.965),(25.205,8.135),(25.375,8.135),(25.375,7.965),(25.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.245),(30.515,39.415),(30.685,39.415),(30.685,39.245),(30.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.585),(30.515,39.755),(30.685,39.755),(30.685,39.585),(30.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.585),(54.515,5.755),(54.685,5.755),(54.685,5.585),(54.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.245),(54.515,5.415),(54.685,5.415),(54.685,5.245),(54.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.545),(35.315,37.715),(35.485,37.715),(35.485,37.545),(35.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.205),(35.315,37.375),(35.485,37.375),(35.485,37.205),(35.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.205),(35.825,37.375),(35.995,37.375),(35.995,37.205),(35.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.545),(35.825,37.715),(35.995,37.715),(35.995,37.545),(35.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.245),(54.005,5.415),(54.175,5.415),(54.175,5.245),(54.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.585),(54.005,5.755),(54.175,5.755),(54.175,5.585),(54.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.585),(44.405,39.755),(44.575,39.755),(44.575,39.585),(44.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.245),(44.405,39.415),(44.575,39.415),(44.575,39.245),(44.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.765),(78.515,14.935),(78.685,14.935),(78.685,14.765),(78.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.765),(78.005,14.935),(78.175,14.935),(78.175,14.765),(78.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.425),(78.005,14.595),(78.175,14.595),(78.175,14.425),(78.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.085),(78.515,14.255),(78.685,14.255),(78.685,14.085),(78.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.585),(6.515,5.755),(6.685,5.755),(6.685,5.585),(6.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.425),(78.515,14.595),(78.685,14.595),(78.685,14.425),(78.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.085),(78.005,14.255),(78.175,14.255),(78.175,14.085),(78.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.845),(49.205,36.015),(49.375,36.015),(49.375,35.845),(49.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.845),(49.715,36.015),(49.885,36.015),(49.885,35.845),(49.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.385),(55.025,12.555),(55.195,12.555),(55.195,12.385),(55.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,27.005),(73.715,27.175),(73.885,27.175),(73.885,27.005),(73.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,27.005),(73.205,27.175),(73.375,27.175),(73.375,27.005),(73.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,27.685),(73.715,27.855),(73.885,27.855),(73.885,27.685),(73.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,27.685),(73.205,27.855),(73.375,27.855),(73.375,27.685),(73.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.885),(69.425,4.055),(69.595,4.055),(69.595,3.885),(69.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,2.865),(6.515,3.035),(6.685,3.035),(6.685,2.865),(6.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.345),(44.915,27.515),(45.085,27.515),(45.085,27.345),(44.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.745),(26.225,13.915),(26.395,13.915),(26.395,13.745),(26.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.065),(26.225,13.235),(26.395,13.235),(26.395,13.065),(26.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.665),(30.515,9.835),(30.685,9.835),(30.685,9.665),(30.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.325),(30.005,9.495),(30.175,9.495),(30.175,9.325),(30.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,39.245),(59.825,39.415),(59.995,39.415),(59.995,39.245),(59.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,39.585),(59.825,39.755),(59.995,39.755),(59.995,39.585),(59.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.245),(59.315,39.415),(59.485,39.415),(59.485,39.245),(59.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.585),(59.315,39.755),(59.485,39.755),(59.485,39.585),(59.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.245),(58.805,22.415),(58.975,22.415),(58.975,22.245),(58.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.245),(30.515,5.415),(30.685,5.415),(30.685,5.245),(30.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.245),(30.005,5.415),(30.175,5.415),(30.175,5.245),(30.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.025),(44.915,28.195),(45.085,28.195),(45.085,28.025),(44.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.445),(54.515,32.615),(54.685,32.615),(54.685,32.445),(54.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.105),(54.005,32.275),(54.175,32.275),(54.175,32.105),(54.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,40.265),(59.825,40.435),(59.995,40.435),(59.995,40.265),(59.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.785),(54.005,32.955),(54.175,32.955),(54.175,32.785),(54.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.785),(54.515,32.955),(54.685,32.955),(54.685,32.785),(54.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.445),(54.005,32.615),(54.175,32.615),(54.175,32.445),(54.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.105),(54.515,32.275),(54.685,32.275),(54.685,32.105),(54.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,40.605),(59.825,40.775),(59.995,40.775),(59.995,40.605),(59.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.365),(44.915,28.535),(45.085,28.535),(45.085,28.365),(44.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,40.605),(59.315,40.775),(59.485,40.775),(59.485,40.605),(59.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,33.465),(16.625,33.635),(16.795,33.635),(16.795,33.465),(16.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,33.805),(16.625,33.975),(16.795,33.975),(16.795,33.805),(16.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,33.125),(16.625,33.295),(16.795,33.295),(16.795,33.125),(16.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.865),(30.515,3.035),(30.685,3.035),(30.685,2.865),(30.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,40.605),(74.225,40.775),(74.395,40.775),(74.395,40.605),(74.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,40.265),(74.225,40.435),(74.395,40.435),(74.395,40.265),(74.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.945),(26.225,7.115),(26.395,7.115),(26.395,6.945),(26.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,21.905),(20.915,22.075),(21.085,22.075),(21.085,21.905),(20.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.965),(50.225,25.135),(50.395,25.135),(50.395,24.965),(50.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,35.165),(74.225,35.335),(74.395,35.335),(74.395,35.165),(74.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,35.505),(74.225,35.675),(74.395,35.675),(74.395,35.505),(74.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.405),(15.605,13.575),(15.775,13.575),(15.775,13.405),(15.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,39.585),(79.025,39.755),(79.195,39.755),(79.195,39.585),(79.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,39.245),(79.025,39.415),(79.195,39.415),(79.195,39.245),(79.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.245),(10.805,5.415),(10.975,5.415),(10.975,5.245),(10.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.325),(63.605,9.495),(63.775,9.495),(63.775,9.325),(63.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.165),(11.315,18.335),(11.485,18.335),(11.485,18.165),(11.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.165),(11.825,18.335),(11.995,18.335),(11.995,18.165),(11.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.225),(55.025,21.395),(55.195,21.395),(55.195,21.225),(55.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.865),(54.515,3.035),(54.685,3.035),(54.685,2.865),(54.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.865),(54.005,3.035),(54.175,3.035),(54.175,2.865),(54.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.785),(54.515,15.955),(54.685,15.955),(54.685,15.785),(54.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.785),(54.005,15.955),(54.175,15.955),(54.175,15.785),(54.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,37.885),(68.405,38.055),(68.575,38.055),(68.575,37.885),(68.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.105),(30.515,32.275),(30.685,32.275),(30.685,32.105),(30.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.445),(30.515,32.615),(30.685,32.615),(30.685,32.445),(30.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.785),(30.515,32.955),(30.685,32.955),(30.685,32.785),(30.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.065),(63.605,13.235),(63.775,13.235),(63.775,13.065),(63.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.745),(63.605,13.915),(63.775,13.915),(63.775,13.745),(63.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.405),(63.605,13.575),(63.775,13.575),(63.775,13.405),(63.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,25.645),(74.225,25.815),(74.395,25.815),(74.395,25.645),(74.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,25.305),(74.225,25.475),(74.395,25.475),(74.395,25.305),(74.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.885),(45.425,38.055),(45.595,38.055),(45.595,37.885),(45.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.505),(45.425,18.675),(45.595,18.675),(45.595,18.505),(45.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.265),(59.315,23.435),(59.485,23.435),(59.485,23.265),(59.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.605),(59.315,23.775),(59.485,23.775),(59.485,23.605),(59.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,23.605),(59.825,23.775),(59.995,23.775),(59.995,23.605),(59.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,23.265),(59.825,23.435),(59.995,23.435),(59.995,23.265),(59.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.025),(6.515,11.195),(6.685,11.195),(6.685,11.025),(6.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.705),(6.515,11.875),(6.685,11.875),(6.685,11.705),(6.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,32.785),(20.405,32.955),(20.575,32.955),(20.575,32.785),(20.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,32.105),(20.405,32.275),(20.575,32.275),(20.575,32.105),(20.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,32.445),(20.405,32.615),(20.575,32.615),(20.575,32.445),(20.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,21.905),(74.225,22.075),(74.395,22.075),(74.395,21.905),(74.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.045),(44.915,29.215),(45.085,29.215),(45.085,29.045),(44.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.385),(44.915,29.555),(45.085,29.555),(45.085,29.385),(44.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.725),(44.915,29.895),(45.085,29.895),(45.085,29.725),(44.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.505),(16.115,18.675),(16.285,18.675),(16.285,18.505),(16.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.165),(16.115,18.335),(16.285,18.335),(16.285,18.165),(16.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,29.385),(68.915,29.555),(69.085,29.555),(69.085,29.385),(68.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,20.885),(11.315,21.055),(11.485,21.055),(11.485,20.885),(11.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,20.885),(11.825,21.055),(11.995,21.055),(11.995,20.885),(11.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.465),(58.805,16.635),(58.975,16.635),(58.975,16.465),(58.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,20.205),(15.605,20.375),(15.775,20.375),(15.775,20.205),(15.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,20.545),(15.605,20.715),(15.775,20.715),(15.775,20.545),(15.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.145),(69.425,17.315),(69.595,17.315),(69.595,17.145),(69.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.245),(25.205,5.415),(25.375,5.415),(25.375,5.245),(25.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.245),(25.715,5.415),(25.885,5.415),(25.885,5.245),(25.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.625),(21.425,7.795),(21.595,7.795),(21.595,7.625),(21.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.825),(69.425,17.995),(69.595,17.995),(69.595,17.825),(69.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.245),(58.805,5.415),(58.975,5.415),(58.975,5.245),(58.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,38.905),(64.625,39.075),(64.795,39.075),(64.795,38.905),(64.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,38.905),(64.115,39.075),(64.285,39.075),(64.285,38.905),(64.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.645),(35.825,25.815),(35.995,25.815),(35.995,25.645),(35.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.305),(35.315,25.475),(35.485,25.475),(35.485,25.305),(35.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.865),(34.805,37.035),(34.975,37.035),(34.975,36.865),(34.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.645),(35.315,25.815),(35.485,25.815),(35.485,25.645),(35.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.305),(35.825,25.475),(35.995,25.475),(35.995,25.305),(35.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.885),(39.605,4.055),(39.775,4.055),(39.775,3.885),(39.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,25.645),(21.425,25.815),(21.595,25.815),(21.595,25.645),(21.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.085),(40.625,31.255),(40.795,31.255),(40.795,31.085),(40.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.765),(40.625,31.935),(40.795,31.935),(40.795,31.765),(40.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.425),(40.115,31.595),(40.285,31.595),(40.285,31.425),(40.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.085),(40.115,31.255),(40.285,31.255),(40.285,31.085),(40.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.365),(26.225,11.535),(26.395,11.535),(26.395,11.365),(26.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.765),(40.115,31.935),(40.285,31.935),(40.285,31.765),(40.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.425),(40.625,31.595),(40.795,31.595),(40.795,31.425),(40.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.025),(26.225,11.195),(26.395,11.195),(26.395,11.025),(26.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.705),(26.225,11.875),(26.395,11.875),(26.395,11.705),(26.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.205),(55.025,20.375),(55.195,20.375),(55.195,20.205),(55.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.905),(68.915,5.075),(69.085,5.075),(69.085,4.905),(68.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.585),(49.205,5.755),(49.375,5.755),(49.375,5.585),(49.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.585),(49.715,5.755),(49.885,5.755),(49.885,5.585),(49.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.905),(20.915,5.075),(21.085,5.075),(21.085,4.905),(20.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.105),(39.605,15.275),(39.775,15.275),(39.775,15.105),(39.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,21.565),(69.425,21.735),(69.595,21.735),(69.595,21.565),(69.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,21.225),(69.425,21.395),(69.595,21.395),(69.595,21.225),(69.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,2.865),(69.425,3.035),(69.595,3.035),(69.595,2.865),(69.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.165),(39.605,35.335),(39.775,35.335),(39.775,35.165),(39.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.505),(39.605,35.675),(39.775,35.675),(39.775,35.505),(39.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,37.885),(64.115,38.055),(64.285,38.055),(64.285,37.885),(64.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,37.885),(64.625,38.055),(64.795,38.055),(64.795,37.885),(64.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.645),(31.025,25.815),(31.195,25.815),(31.195,25.645),(31.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,2.865),(21.425,3.035),(21.595,3.035),(21.595,2.865),(21.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.645),(58.805,8.815),(58.975,8.815),(58.975,8.645),(58.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.305),(58.805,8.475),(58.975,8.475),(58.975,8.305),(58.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.265),(40.625,23.435),(40.795,23.435),(40.795,23.265),(40.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.265),(40.115,23.435),(40.285,23.435),(40.285,23.265),(40.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,25.305),(20.405,25.475),(20.575,25.475),(20.575,25.305),(20.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,25.645),(20.405,25.815),(20.575,25.815),(20.575,25.645),(20.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,27.005),(79.025,27.175),(79.195,27.175),(79.195,27.005),(79.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,27.685),(79.025,27.855),(79.195,27.855),(79.195,27.685),(79.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,39.585),(82.805,39.755),(82.975,39.755),(82.975,39.585),(82.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,39.245),(82.805,39.415),(82.975,39.415),(82.975,39.245),(82.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.025),(40.625,11.195),(40.795,11.195),(40.795,11.025),(40.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.705),(40.625,11.875),(40.795,11.875),(40.795,11.705),(40.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.025),(40.115,11.195),(40.285,11.195),(40.285,11.025),(40.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.365),(40.115,11.535),(40.285,11.535),(40.285,11.365),(40.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.705),(40.115,11.875),(40.285,11.875),(40.285,11.705),(40.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.365),(40.625,11.535),(40.795,11.535),(40.795,11.365),(40.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.925),(58.805,40.095),(58.975,40.095),(58.975,39.925),(58.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.985),(63.605,9.155),(63.775,9.155),(63.775,8.985),(63.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.865),(35.825,3.035),(35.995,3.035),(35.995,2.865),(35.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.865),(35.315,3.035),(35.485,3.035),(35.485,2.865),(35.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.945),(44.915,24.115),(45.085,24.115),(45.085,23.945),(44.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,24.625),(20.915,24.795),(21.085,24.795),(21.085,24.625),(20.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.925),(63.605,6.095),(63.775,6.095),(63.775,5.925),(63.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.445),(34.805,15.615),(34.975,15.615),(34.975,15.445),(34.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.545),(82.805,3.715),(82.975,3.715),(82.975,3.545),(82.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.485),(55.025,34.655),(55.195,34.655),(55.195,34.485),(55.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.825),(55.025,34.995),(55.195,34.995),(55.195,34.825),(55.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.145),(55.025,34.315),(55.195,34.315),(55.195,34.145),(55.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.805),(58.805,33.975),(58.975,33.975),(58.975,33.805),(58.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.125),(58.805,33.295),(58.975,33.295),(58.975,33.125),(58.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.465),(58.805,33.635),(58.975,33.635),(58.975,33.465),(58.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.385),(44.405,12.555),(44.575,12.555),(44.575,12.385),(44.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.245),(82.805,5.415),(82.975,5.415),(82.975,5.245),(82.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,21.565),(83.315,21.735),(83.485,21.735),(83.485,21.565),(83.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.985),(49.205,9.155),(49.375,9.155),(49.375,8.985),(49.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.985),(49.715,9.155),(49.885,9.155),(49.885,8.985),(49.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.585),(50.225,22.755),(50.395,22.755),(50.395,22.585),(50.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.345),(39.605,27.515),(39.775,27.515),(39.775,27.345),(39.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.825),(40.625,34.995),(40.795,34.995),(40.795,34.825),(40.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.825),(40.115,34.995),(40.285,34.995),(40.285,34.825),(40.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.145),(40.625,34.315),(40.795,34.315),(40.795,34.145),(40.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.145),(40.115,34.315),(40.285,34.315),(40.285,34.145),(40.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.485),(40.115,34.655),(40.285,34.655),(40.285,34.485),(40.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.485),(40.625,34.655),(40.795,34.655),(40.795,34.485),(40.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.545),(58.805,3.715),(58.975,3.715),(58.975,3.545),(58.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.285),(69.425,7.455),(69.595,7.455),(69.595,7.285),(69.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.225),(73.205,4.395),(73.375,4.395),(73.375,4.225),(73.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.225),(73.715,4.395),(73.885,4.395),(73.885,4.225),(73.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.565),(73.715,4.735),(73.885,4.735),(73.885,4.565),(73.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.565),(73.205,4.735),(73.375,4.735),(73.375,4.565),(73.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,23.265),(79.025,23.435),(79.195,23.435),(79.195,23.265),(79.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.405),(69.425,13.575),(69.595,13.575),(69.595,13.405),(69.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,32.785),(83.315,32.955),(83.485,32.955),(83.485,32.785),(83.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,32.445),(83.315,32.615),(83.485,32.615),(83.485,32.445),(83.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,32.105),(83.315,32.275),(83.485,32.275),(83.485,32.105),(83.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,25.645),(11.825,25.815),(11.995,25.815),(11.995,25.645),(11.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,25.645),(11.315,25.815),(11.485,25.815),(11.485,25.645),(11.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,25.985),(20.915,26.155),(21.085,26.155),(21.085,25.985),(20.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.885),(10.805,4.055),(10.975,4.055),(10.975,3.885),(10.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.745),(21.425,13.915),(21.595,13.915),(21.595,13.745),(21.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.065),(21.425,13.235),(21.595,13.235),(21.595,13.065),(21.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.405),(21.425,13.575),(21.595,13.575),(21.595,13.405),(21.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.685),(55.025,10.855),(55.195,10.855),(55.195,10.685),(55.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.005),(55.025,10.175),(55.195,10.175),(55.195,10.005),(55.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.345),(55.025,10.515),(55.195,10.515),(55.195,10.345),(55.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.945),(54.005,24.115),(54.175,24.115),(54.175,23.945),(54.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.945),(54.515,24.115),(54.685,24.115),(54.685,23.945),(54.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.285),(44.405,7.455),(44.575,7.455),(44.575,7.285),(44.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.805),(40.115,16.975),(40.285,16.975),(40.285,16.805),(40.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.125),(40.115,16.295),(40.285,16.295),(40.285,16.125),(40.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.465),(40.115,16.635),(40.285,16.635),(40.285,16.465),(40.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.465),(40.625,16.635),(40.795,16.635),(40.795,16.465),(40.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.805),(40.625,16.975),(40.795,16.975),(40.795,16.805),(40.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.125),(40.625,16.295),(40.795,16.295),(40.795,16.125),(40.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.985),(30.515,9.155),(30.685,9.155),(30.685,8.985),(30.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.945),(25.205,7.115),(25.375,7.115),(25.375,6.945),(25.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.945),(25.715,7.115),(25.885,7.115),(25.885,6.945),(25.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,21.565),(16.115,21.735),(16.285,21.735),(16.285,21.565),(16.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,21.225),(16.115,21.395),(16.285,21.395),(16.285,21.225),(16.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.465),(20.405,16.635),(20.575,16.635),(20.575,16.465),(20.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,23.945),(7.025,24.115),(7.195,24.115),(7.195,23.945),(7.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.885),(82.805,4.055),(82.975,4.055),(82.975,3.885),(82.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.985),(44.405,26.155),(44.575,26.155),(44.575,25.985),(44.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,38.225),(6.515,38.395),(6.685,38.395),(6.685,38.225),(6.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,38.565),(6.515,38.735),(6.685,38.735),(6.685,38.565),(6.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,22.245),(59.825,22.415),(59.995,22.415),(59.995,22.245),(59.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,22.585),(59.825,22.755),(59.995,22.755),(59.995,22.585),(59.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.245),(59.315,22.415),(59.485,22.415),(59.485,22.245),(59.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.585),(59.315,22.755),(59.485,22.755),(59.485,22.585),(59.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.285),(6.515,7.455),(6.685,7.455),(6.685,7.285),(6.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,32.445),(73.715,32.615),(73.885,32.615),(73.885,32.445),(73.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,32.445),(73.205,32.615),(73.375,32.615),(73.375,32.445),(73.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,32.105),(73.715,32.275),(73.885,32.275),(73.885,32.105),(73.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,32.105),(73.205,32.275),(73.375,32.275),(73.375,32.105),(73.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,32.785),(73.715,32.955),(73.885,32.955),(73.885,32.785),(73.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,32.785),(73.205,32.955),(73.375,32.955),(73.375,32.785),(73.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.425),(25.205,14.595),(25.375,14.595),(25.375,14.425),(25.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.425),(25.715,14.595),(25.885,14.595),(25.885,14.425),(25.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.765),(25.205,14.935),(25.375,14.935),(25.375,14.765),(25.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.765),(25.715,14.935),(25.885,14.935),(25.885,14.765),(25.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.085),(25.205,14.255),(25.375,14.255),(25.375,14.085),(25.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.085),(25.715,14.255),(25.885,14.255),(25.885,14.085),(25.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,32.445),(64.115,32.615),(64.285,32.615),(64.285,32.445),(64.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,32.445),(64.625,32.615),(64.795,32.615),(64.795,32.445),(64.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,32.105),(64.115,32.275),(64.285,32.275),(64.285,32.105),(64.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,32.105),(64.625,32.275),(64.795,32.275),(64.795,32.105),(64.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,32.785),(64.625,32.955),(64.795,32.955),(64.795,32.785),(64.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,32.785),(64.115,32.955),(64.285,32.955),(64.285,32.785),(64.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.405),(64.115,13.575),(64.285,13.575),(64.285,13.405),(64.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,20.205),(26.225,20.375),(26.395,20.375),(26.395,20.205),(26.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,40.265),(55.025,40.435),(55.195,40.435),(55.195,40.265),(55.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,40.605),(55.025,40.775),(55.195,40.775),(55.195,40.605),(55.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.225),(45.425,38.395),(45.595,38.395),(45.595,38.225),(45.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.565),(45.425,38.735),(45.595,38.735),(45.595,38.565),(45.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.885),(44.405,4.055),(44.575,4.055),(44.575,3.885),(44.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.885),(58.805,4.055),(58.975,4.055),(58.975,3.885),(58.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,22.925),(68.915,23.095),(69.085,23.095),(69.085,22.925),(68.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,33.125),(21.425,33.295),(21.595,33.295),(21.595,33.125),(21.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,33.465),(21.425,33.635),(21.595,33.635),(21.595,33.465),(21.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,33.805),(21.425,33.975),(21.595,33.975),(21.595,33.805),(21.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,38.225),(30.005,38.395),(30.175,38.395),(30.175,38.225),(30.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,38.565),(30.005,38.735),(30.175,38.735),(30.175,38.565),(30.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.705),(68.915,11.875),(69.085,11.875),(69.085,11.705),(68.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.025),(68.915,11.195),(69.085,11.195),(69.085,11.025),(68.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.365),(68.915,11.535),(69.085,11.535),(69.085,11.365),(68.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.085),(50.225,31.255),(50.395,31.255),(50.395,31.085),(50.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.425),(50.225,31.595),(50.395,31.595),(50.395,31.425),(50.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.765),(50.225,31.935),(50.395,31.935),(50.395,31.765),(50.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.845),(55.025,19.015),(55.195,19.015),(55.195,18.845),(55.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.565),(6.515,4.735),(6.685,4.735),(6.685,4.565),(6.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.805),(7.025,16.975),(7.195,16.975),(7.195,16.805),(7.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.125),(25.715,16.295),(25.885,16.295),(25.885,16.125),(25.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.125),(7.025,16.295),(7.195,16.295),(7.195,16.125),(7.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.405),(6.515,13.575),(6.685,13.575),(6.685,13.405),(6.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.805),(25.715,16.975),(25.885,16.975),(25.885,16.805),(25.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.465),(25.715,16.635),(25.885,16.635),(25.885,16.465),(25.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.805),(25.205,16.975),(25.375,16.975),(25.375,16.805),(25.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.125),(25.205,16.295),(25.375,16.295),(25.375,16.125),(25.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.465),(25.205,16.635),(25.375,16.635),(25.375,16.465),(25.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,24.965),(74.225,25.135),(74.395,25.135),(74.395,24.965),(74.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,36.865),(69.425,37.035),(69.595,37.035),(69.595,36.865),(69.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,30.065),(15.605,30.235),(15.775,30.235),(15.775,30.065),(15.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,30.405),(15.605,30.575),(15.775,30.575),(15.775,30.405),(15.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,30.745),(15.605,30.915),(15.775,30.915),(15.775,30.745),(15.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.225),(49.715,4.395),(49.885,4.395),(49.885,4.225),(49.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.225),(49.205,4.395),(49.375,4.395),(49.375,4.225),(49.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.905),(34.805,22.075),(34.975,22.075),(34.975,21.905),(34.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.425),(39.605,14.595),(39.775,14.595),(39.775,14.425),(39.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.545),(55.025,37.715),(55.195,37.715),(55.195,37.545),(55.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.205),(55.025,37.375),(55.195,37.375),(55.195,37.205),(55.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.285),(10.805,7.455),(10.975,7.455),(10.975,7.285),(10.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.845),(25.205,19.015),(25.375,19.015),(25.375,18.845),(25.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.845),(25.715,19.015),(25.885,19.015),(25.885,18.845),(25.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,40.265),(54.515,40.435),(54.685,40.435),(54.685,40.265),(54.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,40.605),(54.515,40.775),(54.685,40.775),(54.685,40.605),(54.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,40.265),(54.005,40.435),(54.175,40.435),(54.175,40.265),(54.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,40.605),(54.005,40.775),(54.175,40.775),(54.175,40.605),(54.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.225),(30.515,4.395),(30.685,4.395),(30.685,4.225),(30.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,20.545),(83.315,20.715),(83.485,20.715),(83.485,20.545),(83.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.225),(30.005,4.395),(30.175,4.395),(30.175,4.225),(30.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.885),(59.315,38.055),(59.485,38.055),(59.485,37.885),(59.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,37.885),(59.825,38.055),(59.995,38.055),(59.995,37.885),(59.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,20.205),(83.315,20.375),(83.485,20.375),(83.485,20.205),(83.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,32.785),(20.915,32.955),(21.085,32.955),(21.085,32.785),(20.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,32.105),(20.915,32.275),(21.085,32.275),(21.085,32.105),(20.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.945),(49.205,7.115),(49.375,7.115),(49.375,6.945),(49.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,32.445),(20.915,32.615),(21.085,32.615),(21.085,32.445),(20.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.525),(50.225,19.695),(50.395,19.695),(50.395,19.525),(50.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.285),(15.605,7.455),(15.775,7.455),(15.775,7.285),(15.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.305),(25.205,8.475),(25.375,8.475),(25.375,8.305),(25.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.305),(25.715,8.475),(25.885,8.475),(25.885,8.305),(25.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.565),(58.805,4.735),(58.975,4.735),(58.975,4.565),(58.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.225),(58.805,4.395),(58.975,4.395),(58.975,4.225),(58.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,40.265),(44.405,40.435),(44.575,40.435),(44.575,40.265),(44.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,40.605),(44.405,40.775),(44.575,40.775),(44.575,40.605),(44.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.205),(31.025,37.375),(31.195,37.375),(31.195,37.205),(31.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.545),(31.025,37.715),(31.195,37.715),(31.195,37.545),(31.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.905),(64.625,5.075),(64.795,5.075),(64.795,4.905),(64.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.905),(64.115,5.075),(64.285,5.075),(64.285,4.905),(64.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.945),(58.805,24.115),(58.975,24.115),(58.975,23.945),(58.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.565),(54.005,4.735),(54.175,4.735),(54.175,4.565),(54.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.565),(54.515,4.735),(54.685,4.735),(54.685,4.565),(54.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.005),(49.205,10.175),(49.375,10.175),(49.375,10.005),(49.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.345),(49.205,10.515),(49.375,10.515),(49.375,10.345),(49.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.345),(49.715,10.515),(49.885,10.515),(49.885,10.345),(49.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.005),(49.715,10.175),(49.885,10.175),(49.885,10.005),(49.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.685),(49.715,10.855),(49.885,10.855),(49.885,10.685),(49.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.685),(49.205,10.855),(49.375,10.855),(49.375,10.685),(49.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,35.845),(25.205,36.015),(25.375,36.015),(25.375,35.845),(25.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,35.845),(25.715,36.015),(25.885,36.015),(25.885,35.845),(25.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.625),(63.605,7.795),(63.775,7.795),(63.775,7.625),(63.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,39.925),(79.025,40.095),(79.195,40.095),(79.195,39.925),(79.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.925),(20.405,6.095),(20.575,6.095),(20.575,5.925),(20.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.745),(35.315,13.915),(35.485,13.915),(35.485,13.745),(35.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.405),(35.315,13.575),(35.485,13.575),(35.485,13.405),(35.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.065),(35.825,13.235),(35.995,13.235),(35.995,13.065),(35.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.405),(35.825,13.575),(35.995,13.575),(35.995,13.405),(35.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,37.205),(16.625,37.375),(16.795,37.375),(16.795,37.205),(16.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,26.665),(20.405,26.835),(20.575,26.835),(20.575,26.665),(20.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,37.545),(16.625,37.715),(16.795,37.715),(16.795,37.545),(16.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.745),(35.825,13.915),(35.995,13.915),(35.995,13.745),(35.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.265),(16.115,6.435),(16.285,6.435),(16.285,6.265),(16.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.265),(16.625,6.435),(16.795,6.435),(16.795,6.265),(16.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.645),(64.115,8.815),(64.285,8.815),(64.285,8.645),(64.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.645),(64.625,8.815),(64.795,8.815),(64.795,8.645),(64.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.325),(10.805,9.495),(10.975,9.495),(10.975,9.325),(10.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.965),(74.225,8.135),(74.395,8.135),(74.395,7.965),(74.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.285),(78.005,7.455),(78.175,7.455),(78.175,7.285),(78.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.285),(78.515,7.455),(78.685,7.455),(78.685,7.285),(78.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.625),(34.805,7.795),(34.975,7.795),(34.975,7.625),(34.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,31.085),(74.225,31.255),(74.395,31.255),(74.395,31.085),(74.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.485),(58.805,17.655),(58.975,17.655),(58.975,17.485),(58.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,31.765),(74.225,31.935),(74.395,31.935),(74.395,31.765),(74.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,31.425),(74.225,31.595),(74.395,31.595),(74.395,31.425),(74.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,40.605),(15.605,40.775),(15.775,40.775),(15.775,40.605),(15.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,40.265),(15.605,40.435),(15.775,40.435),(15.775,40.265),(15.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.085),(73.205,14.255),(73.375,14.255),(73.375,14.085),(73.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.085),(73.715,14.255),(73.885,14.255),(73.885,14.085),(73.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.765),(73.205,14.935),(73.375,14.935),(73.375,14.765),(73.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.765),(73.715,14.935),(73.885,14.935),(73.885,14.765),(73.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.425),(73.205,14.595),(73.375,14.595),(73.375,14.425),(73.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.425),(73.715,14.595),(73.885,14.595),(73.885,14.425),(73.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.985),(69.425,9.155),(69.595,9.155),(69.595,8.985),(69.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.865),(68.915,20.035),(69.085,20.035),(69.085,19.865),(68.915,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.865),(58.805,3.035),(58.975,3.035),(58.975,2.865),(58.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.185),(6.515,19.355),(6.685,19.355),(6.685,19.185),(6.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.145),(40.625,17.315),(40.795,17.315),(40.795,17.145),(40.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.825),(40.625,17.995),(40.795,17.995),(40.795,17.825),(40.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.145),(40.115,17.315),(40.285,17.315),(40.285,17.145),(40.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.825),(40.115,17.995),(40.285,17.995),(40.285,17.825),(40.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,2.865),(10.805,3.035),(10.975,3.035),(10.975,2.865),(10.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.345),(82.805,10.515),(82.975,10.515),(82.975,10.345),(82.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.685),(82.805,10.855),(82.975,10.855),(82.975,10.685),(82.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.005),(82.805,10.175),(82.975,10.175),(82.975,10.005),(82.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.285),(34.805,24.455),(34.975,24.455),(34.975,24.285),(34.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.625),(34.805,24.795),(34.975,24.795),(34.975,24.625),(34.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.005),(15.605,10.175),(15.775,10.175),(15.775,10.005),(15.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.685),(15.605,10.855),(15.775,10.855),(15.775,10.685),(15.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.865),(50.225,20.035),(50.395,20.035),(50.395,19.865),(50.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,20.885),(10.805,21.055),(10.975,21.055),(10.975,20.885),(10.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.365),(44.915,11.535),(45.085,11.535),(45.085,11.365),(44.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.625),(83.315,7.795),(83.485,7.795),(83.485,7.625),(83.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,31.425),(63.605,31.595),(63.775,31.595),(63.775,31.425),(63.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.285),(35.315,7.455),(35.485,7.455),(35.485,7.285),(35.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.285),(35.825,7.455),(35.995,7.455),(35.995,7.285),(35.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.945),(44.405,24.115),(44.575,24.115),(44.575,23.945),(44.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.525),(31.025,19.695),(31.195,19.695),(31.195,19.525),(31.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.425),(69.425,14.595),(69.595,14.595),(69.595,14.425),(69.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,21.905),(59.825,22.075),(59.995,22.075),(59.995,21.905),(59.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.905),(59.315,22.075),(59.485,22.075),(59.485,21.905),(59.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.765),(21.425,14.935),(21.595,14.935),(21.595,14.765),(21.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.085),(21.425,14.255),(21.595,14.255),(21.595,14.085),(21.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.425),(21.425,14.595),(21.595,14.595),(21.595,14.425),(21.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.325),(58.805,9.495),(58.975,9.495),(58.975,9.325),(58.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.865),(39.605,3.035),(39.775,3.035),(39.775,2.865),(39.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.185),(11.825,19.355),(11.995,19.355),(11.995,19.185),(11.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.185),(11.315,19.355),(11.485,19.355),(11.485,19.185),(11.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.465),(59.315,33.635),(59.485,33.635),(59.485,33.465),(59.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,33.125),(59.825,33.295),(59.995,33.295),(59.995,33.125),(59.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.805),(59.315,33.975),(59.485,33.975),(59.485,33.805),(59.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.125),(59.315,33.295),(59.485,33.295),(59.485,33.125),(59.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,33.465),(59.825,33.635),(59.995,33.635),(59.995,33.465),(59.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,33.805),(59.825,33.975),(59.995,33.975),(59.995,33.805),(59.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.045),(40.625,12.215),(40.795,12.215),(40.795,12.045),(40.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.385),(40.625,12.555),(40.795,12.555),(40.795,12.385),(40.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.045),(40.115,12.215),(40.285,12.215),(40.285,12.045),(40.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.725),(40.625,12.895),(40.795,12.895),(40.795,12.725),(40.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.725),(40.115,12.895),(40.285,12.895),(40.285,12.725),(40.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.385),(40.115,12.555),(40.285,12.555),(40.285,12.385),(40.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,20.545),(68.405,20.715),(68.575,20.715),(68.575,20.545),(68.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,20.205),(68.405,20.375),(68.575,20.375),(68.575,20.205),(68.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.405),(49.205,13.575),(49.375,13.575),(49.375,13.405),(49.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.405),(49.715,13.575),(49.885,13.575),(49.885,13.405),(49.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.525),(49.715,19.695),(49.885,19.695),(49.885,19.525),(49.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.525),(49.205,19.695),(49.375,19.695),(49.375,19.525),(49.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,36.185),(7.025,36.355),(7.195,36.355),(7.195,36.185),(7.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,36.525),(7.025,36.695),(7.195,36.695),(7.195,36.525),(7.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,23.605),(64.625,23.775),(64.795,23.775),(64.795,23.605),(64.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,23.605),(64.115,23.775),(64.285,23.775),(64.285,23.605),(64.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,28.025),(20.405,28.195),(20.575,28.195),(20.575,28.025),(20.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,28.365),(20.405,28.535),(20.575,28.535),(20.575,28.365),(20.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,28.705),(20.405,28.875),(20.575,28.875),(20.575,28.705),(20.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,40.605),(68.915,40.775),(69.085,40.775),(69.085,40.605),(68.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,40.265),(68.915,40.435),(69.085,40.435),(69.085,40.265),(68.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.145),(35.825,34.315),(35.995,34.315),(35.995,34.145),(35.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,39.245),(68.915,39.415),(69.085,39.415),(69.085,39.245),(68.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.485),(35.315,34.655),(35.485,34.655),(35.485,34.485),(35.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.145),(35.315,34.315),(35.485,34.315),(35.485,34.145),(35.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.485),(35.825,34.655),(35.995,34.655),(35.995,34.485),(35.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.825),(35.315,34.995),(35.485,34.995),(35.485,34.825),(35.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.825),(35.825,34.995),(35.995,34.995),(35.995,34.825),(35.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,39.585),(68.915,39.755),(69.085,39.755),(69.085,39.585),(68.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.725),(45.425,12.895),(45.595,12.895),(45.595,12.725),(45.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.045),(45.425,12.215),(45.595,12.215),(45.595,12.045),(45.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,22.245),(79.025,22.415),(79.195,22.415),(79.195,22.245),(79.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.505),(68.405,18.675),(68.575,18.675),(68.575,18.505),(68.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.965),(50.225,8.135),(50.395,8.135),(50.395,7.965),(50.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.925),(58.805,23.095),(58.975,23.095),(58.975,22.925),(58.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.465),(83.315,16.635),(83.485,16.635),(83.485,16.465),(83.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.925),(68.405,6.095),(68.575,6.095),(68.575,5.925),(68.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.405),(83.315,13.575),(83.485,13.575),(83.485,13.405),(83.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.785),(39.605,32.955),(39.775,32.955),(39.775,32.785),(39.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.445),(39.605,32.615),(39.775,32.615),(39.775,32.445),(39.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.105),(39.605,32.275),(39.775,32.275),(39.775,32.105),(39.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.025),(82.805,11.195),(82.975,11.195),(82.975,11.025),(82.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.705),(82.805,11.875),(82.975,11.875),(82.975,11.705),(82.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,25.985),(15.605,26.155),(15.775,26.155),(15.775,25.985),(15.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.825),(59.315,17.995),(59.485,17.995),(59.485,17.825),(59.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.145),(59.315,17.315),(59.485,17.315),(59.485,17.145),(59.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.145),(59.825,17.315),(59.995,17.315),(59.995,17.145),(59.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.485),(59.315,17.655),(59.485,17.655),(59.485,17.485),(59.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.485),(59.825,17.655),(59.995,17.655),(59.995,17.485),(59.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.825),(59.825,17.995),(59.995,17.995),(59.995,17.825),(59.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.845),(11.825,19.015),(11.995,19.015),(11.995,18.845),(11.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.845),(11.315,19.015),(11.485,19.015),(11.485,18.845),(11.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.265),(39.605,6.435),(39.775,6.435),(39.775,6.265),(39.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.605),(39.605,6.775),(39.775,6.775),(39.775,6.605),(39.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.785),(40.115,15.955),(40.285,15.955),(40.285,15.785),(40.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.785),(40.625,15.955),(40.795,15.955),(40.795,15.785),(40.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,23.945),(64.115,24.115),(64.285,24.115),(64.285,23.945),(64.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,23.945),(64.625,24.115),(64.795,24.115),(64.795,23.945),(64.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,34.825),(20.405,34.995),(20.575,34.995),(20.575,34.825),(20.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,34.145),(20.405,34.315),(20.575,34.315),(20.575,34.145),(20.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,34.485),(20.405,34.655),(20.575,34.655),(20.575,34.485),(20.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,22.245),(73.205,22.415),(73.375,22.415),(73.375,22.245),(73.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,22.245),(73.715,22.415),(73.885,22.415),(73.885,22.245),(73.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,22.585),(73.715,22.755),(73.885,22.755),(73.885,22.585),(73.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,22.585),(73.205,22.755),(73.375,22.755),(73.375,22.585),(73.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.605),(83.315,6.775),(83.485,6.775),(83.485,6.605),(83.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.205),(45.425,37.375),(45.595,37.375),(45.595,37.205),(45.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.545),(45.425,37.715),(45.595,37.715),(45.595,37.545),(45.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,26.325),(10.805,26.495),(10.975,26.495),(10.975,26.325),(10.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.385),(50.225,29.555),(50.395,29.555),(50.395,29.385),(50.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.725),(50.225,29.895),(50.395,29.895),(50.395,29.725),(50.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.045),(50.225,29.215),(50.395,29.215),(50.395,29.045),(50.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.905),(45.425,22.075),(45.595,22.075),(45.595,21.905),(45.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,37.885),(63.605,38.055),(63.775,38.055),(63.775,37.885),(63.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,23.945),(79.025,24.115),(79.195,24.115),(79.195,23.945),(79.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.585),(21.425,5.755),(21.595,5.755),(21.595,5.585),(21.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.245),(21.425,5.415),(21.595,5.415),(21.595,5.245),(21.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.845),(16.115,19.015),(16.285,19.015),(16.285,18.845),(16.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.165),(55.025,35.335),(55.195,35.335),(55.195,35.165),(55.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.505),(55.025,35.675),(55.195,35.675),(55.195,35.505),(55.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,39.245),(7.025,39.415),(7.195,39.415),(7.195,39.245),(7.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,39.585),(7.025,39.755),(7.195,39.755),(7.195,39.585),(7.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,20.885),(15.605,21.055),(15.775,21.055),(15.775,20.885),(15.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,24.625),(15.605,24.795),(15.775,24.795),(15.775,24.625),(15.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.905),(44.915,39.075),(45.085,39.075),(45.085,38.905),(44.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.245),(20.405,5.415),(20.575,5.415),(20.575,5.245),(20.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,39.925),(6.515,40.095),(6.685,40.095),(6.685,39.925),(6.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.925),(64.115,6.095),(64.285,6.095),(64.285,5.925),(64.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.925),(64.625,6.095),(64.795,6.095),(64.795,5.925),(64.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.685),(30.515,10.855),(30.685,10.855),(30.685,10.685),(30.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.085),(74.225,14.255),(74.395,14.255),(74.395,14.085),(74.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.685),(30.005,10.855),(30.175,10.855),(30.175,10.685),(30.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.005),(30.515,10.175),(30.685,10.175),(30.685,10.005),(30.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.765),(74.225,14.935),(74.395,14.935),(74.395,14.765),(74.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.005),(30.005,10.175),(30.175,10.175),(30.175,10.005),(30.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.885),(55.025,21.055),(55.195,21.055),(55.195,20.885),(55.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.245),(31.025,22.415),(31.195,22.415),(31.195,22.245),(31.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.585),(31.025,22.755),(31.195,22.755),(31.195,22.585),(31.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.085),(26.225,14.255),(26.395,14.255),(26.395,14.085),(26.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.765),(26.225,14.935),(26.395,14.935),(26.395,14.765),(26.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,31.085),(25.715,31.255),(25.885,31.255),(25.885,31.085),(25.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,31.085),(25.205,31.255),(25.375,31.255),(25.375,31.085),(25.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,31.425),(25.715,31.595),(25.885,31.595),(25.885,31.425),(25.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,31.425),(25.205,31.595),(25.375,31.595),(25.375,31.425),(25.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,31.765),(25.205,31.935),(25.375,31.935),(25.375,31.765),(25.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,31.765),(25.715,31.935),(25.885,31.935),(25.885,31.765),(25.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.225),(68.915,4.395),(69.085,4.395),(69.085,4.225),(68.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,37.885),(30.005,38.055),(30.175,38.055),(30.175,37.885),(30.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.885),(30.515,38.055),(30.685,38.055),(30.685,37.885),(30.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,38.565),(73.715,38.735),(73.885,38.735),(73.885,38.565),(73.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,38.225),(73.205,38.395),(73.375,38.395),(73.375,38.225),(73.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,38.565),(73.205,38.735),(73.375,38.735),(73.375,38.565),(73.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,38.225),(73.715,38.395),(73.885,38.395),(73.885,38.225),(73.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.925),(35.825,40.095),(35.995,40.095),(35.995,39.925),(35.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.925),(35.315,40.095),(35.485,40.095),(35.485,39.925),(35.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.565),(20.915,4.735),(21.085,4.735),(21.085,4.565),(20.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.225),(20.915,4.395),(21.085,4.395),(21.085,4.225),(20.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.065),(31.025,13.235),(31.195,13.235),(31.195,13.065),(31.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.405),(31.025,13.575),(31.195,13.575),(31.195,13.405),(31.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.745),(31.025,13.915),(31.195,13.915),(31.195,13.745),(31.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.805),(15.605,16.975),(15.775,16.975),(15.775,16.805),(15.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.125),(15.605,16.295),(15.775,16.295),(15.775,16.125),(15.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.465),(15.605,16.635),(15.775,16.635),(15.775,16.465),(15.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,30.745),(63.605,30.915),(63.775,30.915),(63.775,30.745),(63.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,30.065),(63.605,30.235),(63.775,30.235),(63.775,30.065),(63.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,23.265),(68.405,23.435),(68.575,23.435),(68.575,23.265),(68.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,23.605),(68.405,23.775),(68.575,23.775),(68.575,23.605),(68.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.685),(55.025,27.855),(55.195,27.855),(55.195,27.685),(55.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.005),(55.025,27.175),(55.195,27.175),(55.195,27.005),(55.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,35.845),(64.625,36.015),(64.795,36.015),(64.795,35.845),(64.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,35.845),(64.115,36.015),(64.285,36.015),(64.285,35.845),(64.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,26.325),(20.915,26.495),(21.085,26.495),(21.085,26.325),(20.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.985),(58.805,9.155),(58.975,9.155),(58.975,8.985),(58.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.585),(15.605,5.755),(15.775,5.755),(15.775,5.585),(15.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.385),(11.825,12.555),(11.995,12.555),(11.995,12.385),(11.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.385),(83.315,12.555),(83.485,12.555),(83.485,12.385),(83.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.725),(11.825,12.895),(11.995,12.895),(11.995,12.725),(11.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.385),(11.315,12.555),(11.485,12.555),(11.485,12.385),(11.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.045),(11.315,12.215),(11.485,12.215),(11.485,12.045),(11.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.725),(11.315,12.895),(11.485,12.895),(11.485,12.725),(11.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.045),(11.825,12.215),(11.995,12.215),(11.995,12.045),(11.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.545),(20.915,3.715),(21.085,3.715),(21.085,3.545),(20.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.205),(20.915,3.375),(21.085,3.375),(21.085,3.205),(20.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.165),(83.315,18.335),(83.485,18.335),(83.485,18.165),(83.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.445),(35.315,15.615),(35.485,15.615),(35.485,15.445),(35.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.445),(35.825,15.615),(35.995,15.615),(35.995,15.445),(35.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.565),(49.205,38.735),(49.375,38.735),(49.375,38.565),(49.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.225),(49.715,38.395),(49.885,38.395),(49.885,38.225),(49.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.245),(58.805,39.415),(58.975,39.415),(58.975,39.245),(58.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.565),(49.715,38.735),(49.885,38.735),(49.885,38.565),(49.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.225),(49.205,38.395),(49.375,38.395),(49.375,38.225),(49.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.585),(58.805,39.755),(58.975,39.755),(58.975,39.585),(58.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,24.625),(82.805,24.795),(82.975,24.795),(82.975,24.625),(82.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,28.705),(64.625,28.875),(64.795,28.875),(64.795,28.705),(64.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,28.705),(64.115,28.875),(64.285,28.875),(64.285,28.705),(64.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.865),(69.425,20.035),(69.595,20.035),(69.595,19.865),(69.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,37.885),(82.805,38.055),(82.975,38.055),(82.975,37.885),(82.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,24.625),(68.405,24.795),(68.575,24.795),(68.575,24.625),(68.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,24.285),(68.405,24.455),(68.575,24.455),(68.575,24.285),(68.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,30.065),(82.805,30.235),(82.975,30.235),(82.975,30.065),(82.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,30.745),(82.805,30.915),(82.975,30.915),(82.975,30.745),(82.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,35.845),(83.315,36.015),(83.485,36.015),(83.485,35.845),(83.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.885),(11.825,4.055),(11.995,4.055),(11.995,3.885),(11.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.885),(11.315,4.055),(11.485,4.055),(11.485,3.885),(11.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.465),(49.715,33.635),(49.885,33.635),(49.885,33.465),(49.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.465),(49.205,33.635),(49.375,33.635),(49.375,33.465),(49.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.805),(49.715,33.975),(49.885,33.975),(49.885,33.805),(49.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.805),(49.205,33.975),(49.375,33.975),(49.375,33.805),(49.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.125),(49.715,33.295),(49.885,33.295),(49.885,33.125),(49.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.125),(49.205,33.295),(49.375,33.295),(49.375,33.125),(49.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.525),(40.115,36.695),(40.285,36.695),(40.285,36.525),(40.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.525),(40.625,36.695),(40.795,36.695),(40.795,36.525),(40.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.185),(40.115,36.355),(40.285,36.355),(40.285,36.185),(40.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.185),(40.625,36.355),(40.795,36.355),(40.795,36.185),(40.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,26.325),(73.715,26.495),(73.885,26.495),(73.885,26.325),(73.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,26.325),(73.205,26.495),(73.375,26.495),(73.375,26.325),(73.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,26.665),(73.205,26.835),(73.375,26.835),(73.375,26.665),(73.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,26.665),(73.715,26.835),(73.885,26.835),(73.885,26.665),(73.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.985),(58.805,26.155),(58.975,26.155),(58.975,25.985),(58.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.985),(40.625,26.155),(40.795,26.155),(40.795,25.985),(40.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.985),(40.115,26.155),(40.285,26.155),(40.285,25.985),(40.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.925),(7.025,6.095),(7.195,6.095),(7.195,5.925),(7.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.565),(44.405,4.735),(44.575,4.735),(44.575,4.565),(44.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.225),(44.405,4.395),(44.575,4.395),(44.575,4.225),(44.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,37.885),(20.405,38.055),(20.575,38.055),(20.575,37.885),(20.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.905),(73.715,5.075),(73.885,5.075),(73.885,4.905),(73.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.905),(73.205,5.075),(73.375,5.075),(73.375,4.905),(73.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.405),(79.025,13.575),(79.195,13.575),(79.195,13.405),(79.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.065),(79.025,13.235),(79.195,13.235),(79.195,13.065),(79.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.745),(79.025,13.915),(79.195,13.915),(79.195,13.745),(79.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.505),(40.625,18.675),(40.795,18.675),(40.795,18.505),(40.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.505),(40.115,18.675),(40.285,18.675),(40.285,18.505),(40.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.165),(40.115,18.335),(40.285,18.335),(40.285,18.165),(40.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.165),(40.625,18.335),(40.795,18.335),(40.795,18.165),(40.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.585),(68.405,5.755),(68.575,5.755),(68.575,5.585),(68.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.965),(63.605,8.135),(63.775,8.135),(63.775,7.965),(63.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,30.065),(10.805,30.235),(10.975,30.235),(10.975,30.065),(10.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,30.745),(10.805,30.915),(10.975,30.915),(10.975,30.745),(10.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,30.405),(10.805,30.575),(10.975,30.575),(10.975,30.405),(10.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.085),(16.115,14.255),(16.285,14.255),(16.285,14.085),(16.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.425),(16.625,14.595),(16.795,14.595),(16.795,14.425),(16.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.765),(16.115,14.935),(16.285,14.935),(16.285,14.765),(16.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,36.525),(16.625,36.695),(16.795,36.695),(16.795,36.525),(16.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,36.185),(16.625,36.355),(16.795,36.355),(16.795,36.185),(16.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.785),(20.405,15.955),(20.575,15.955),(20.575,15.785),(20.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,31.085),(6.515,31.255),(6.685,31.255),(6.685,31.085),(6.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,31.765),(6.515,31.935),(6.685,31.935),(6.685,31.765),(6.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.265),(54.515,23.435),(54.685,23.435),(54.685,23.265),(54.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.265),(54.005,23.435),(54.175,23.435),(54.175,23.265),(54.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,31.425),(6.515,31.595),(6.685,31.595),(6.685,31.425),(6.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.145),(7.025,17.315),(7.195,17.315),(7.195,17.145),(7.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.825),(7.025,17.995),(7.195,17.995),(7.195,17.825),(7.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.925),(31.025,6.095),(31.195,6.095),(31.195,5.925),(31.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.505),(30.515,18.675),(30.685,18.675),(30.685,18.505),(30.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.165),(30.005,18.335),(30.175,18.335),(30.175,18.165),(30.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.225),(31.025,38.395),(31.195,38.395),(31.195,38.225),(31.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.565),(31.025,38.735),(31.195,38.735),(31.195,38.565),(31.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.505),(68.915,18.675),(69.085,18.675),(69.085,18.505),(68.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.585),(20.915,5.755),(21.085,5.755),(21.085,5.585),(20.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.245),(44.405,22.415),(44.575,22.415),(44.575,22.245),(44.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,38.905),(6.515,39.075),(6.685,39.075),(6.685,38.905),(6.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.925),(59.315,23.095),(59.485,23.095),(59.485,22.925),(59.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,22.925),(59.825,23.095),(59.995,23.095),(59.995,22.925),(59.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,25.985),(63.605,26.155),(63.775,26.155),(63.775,25.985),(63.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,21.565),(73.205,21.735),(73.375,21.735),(73.375,21.565),(73.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,21.565),(73.715,21.735),(73.885,21.735),(73.885,21.565),(73.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,20.885),(26.225,21.055),(26.395,21.055),(26.395,20.885),(26.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.225),(15.605,4.395),(15.775,4.395),(15.775,4.225),(15.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.565),(15.605,4.735),(15.775,4.735),(15.775,4.565),(15.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.905),(45.425,39.075),(45.595,39.075),(45.595,38.905),(45.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.105),(11.315,15.275),(11.485,15.275),(11.485,15.105),(11.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.105),(11.825,15.275),(11.995,15.275),(11.995,15.105),(11.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,22.585),(74.225,22.755),(74.395,22.755),(74.395,22.585),(74.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.085),(83.315,14.255),(83.485,14.255),(83.485,14.085),(83.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.425),(83.315,14.595),(83.485,14.595),(83.485,14.425),(83.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.765),(83.315,14.935),(83.485,14.935),(83.485,14.765),(83.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.545),(44.405,3.715),(44.575,3.715),(44.575,3.545),(44.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.205),(44.405,3.375),(44.575,3.375),(44.575,3.205),(44.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.885),(45.425,4.055),(45.595,4.055),(45.595,3.885),(45.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,22.245),(68.915,22.415),(69.085,22.415),(69.085,22.245),(68.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,22.585),(68.915,22.755),(69.085,22.755),(69.085,22.585),(68.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.665),(25.715,9.835),(25.885,9.835),(25.885,9.665),(25.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.665),(25.205,9.835),(25.375,9.835),(25.375,9.665),(25.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,38.905),(30.005,39.075),(30.175,39.075),(30.175,38.905),(30.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.065),(44.405,30.235),(44.575,30.235),(44.575,30.065),(44.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.745),(44.405,30.915),(44.575,30.915),(44.575,30.745),(44.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,23.945),(20.915,24.115),(21.085,24.115),(21.085,23.945),(20.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,29.045),(74.225,29.215),(74.395,29.215),(74.395,29.045),(74.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,29.725),(74.225,29.895),(74.395,29.895),(74.395,29.725),(74.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,23.945),(16.625,24.115),(16.795,24.115),(16.795,23.945),(16.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,23.945),(16.115,24.115),(16.285,24.115),(16.285,23.945),(16.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,40.605),(40.115,40.775),(40.285,40.775),(40.285,40.605),(40.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,40.265),(40.115,40.435),(40.285,40.435),(40.285,40.265),(40.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,40.265),(40.625,40.435),(40.795,40.435),(40.795,40.265),(40.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,40.605),(40.625,40.775),(40.795,40.775),(40.795,40.605),(40.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.545),(44.915,37.715),(45.085,37.715),(45.085,37.545),(44.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.205),(44.915,37.375),(45.085,37.375),(45.085,37.205),(44.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.985),(49.205,26.155),(49.375,26.155),(49.375,25.985),(49.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.985),(49.715,26.155),(49.885,26.155),(49.885,25.985),(49.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.585),(64.115,5.755),(64.285,5.755),(64.285,5.585),(64.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.585),(64.625,5.755),(64.795,5.755),(64.795,5.585),(64.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,34.145),(20.915,34.315),(21.085,34.315),(21.085,34.145),(20.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,34.485),(20.915,34.655),(21.085,34.655),(21.085,34.485),(20.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,34.825),(20.915,34.995),(21.085,34.995),(21.085,34.825),(20.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.905),(49.205,5.075),(49.375,5.075),(49.375,4.905),(49.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.905),(49.715,5.075),(49.885,5.075),(49.885,4.905),(49.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.785),(30.515,15.955),(30.685,15.955),(30.685,15.785),(30.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,24.625),(21.425,24.795),(21.595,24.795),(21.595,24.625),(21.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,24.285),(64.625,24.455),(64.795,24.455),(64.795,24.285),(64.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,24.285),(64.115,24.455),(64.285,24.455),(64.285,24.285),(64.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,24.625),(64.625,24.795),(64.795,24.795),(64.795,24.625),(64.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,24.625),(64.115,24.795),(64.285,24.795),(64.285,24.625),(64.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.905),(30.005,5.075),(30.175,5.075),(30.175,4.905),(30.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.905),(30.515,5.075),(30.685,5.075),(30.685,4.905),(30.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,20.885),(83.315,21.055),(83.485,21.055),(83.485,20.885),(83.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.205),(59.315,37.375),(59.485,37.375),(59.485,37.205),(59.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.725),(68.915,12.895),(69.085,12.895),(69.085,12.725),(68.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.045),(68.915,12.215),(69.085,12.215),(69.085,12.045),(68.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.385),(68.915,12.555),(69.085,12.555),(69.085,12.385),(68.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.545),(59.315,37.715),(59.485,37.715),(59.485,37.545),(59.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,37.545),(59.825,37.715),(59.995,37.715),(59.995,37.545),(59.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,37.205),(59.825,37.375),(59.995,37.375),(59.995,37.205),(59.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.565),(69.425,4.735),(69.595,4.735),(69.595,4.565),(69.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.885),(40.115,4.055),(40.285,4.055),(40.285,3.885),(40.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.885),(40.625,4.055),(40.795,4.055),(40.795,3.885),(40.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.385),(20.915,12.555),(21.085,12.555),(21.085,12.385),(20.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.725),(20.915,12.895),(21.085,12.895),(21.085,12.725),(20.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.345),(40.115,27.515),(40.285,27.515),(40.285,27.345),(40.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.345),(40.625,27.515),(40.795,27.515),(40.795,27.345),(40.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.045),(20.915,12.215),(21.085,12.215),(21.085,12.045),(20.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.365),(30.005,11.535),(30.175,11.535),(30.175,11.365),(30.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.705),(30.005,11.875),(30.175,11.875),(30.175,11.705),(30.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.185),(10.805,19.355),(10.975,19.355),(10.975,19.185),(10.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.025),(30.005,11.195),(30.175,11.195),(30.175,11.025),(30.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.985),(25.205,9.155),(25.375,9.155),(25.375,8.985),(25.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.985),(25.715,9.155),(25.885,9.155),(25.885,8.985),(25.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.765),(35.315,14.935),(35.485,14.935),(35.485,14.765),(35.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.085),(35.315,14.255),(35.485,14.255),(35.485,14.085),(35.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.085),(35.825,14.255),(35.995,14.255),(35.995,14.085),(35.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.765),(35.825,14.935),(35.995,14.935),(35.995,14.765),(35.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.785),(10.805,15.955),(10.975,15.955),(10.975,15.785),(10.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.905),(58.805,5.075),(58.975,5.075),(58.975,4.905),(58.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.905),(49.715,22.075),(49.885,22.075),(49.885,21.905),(49.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.905),(49.205,22.075),(49.375,22.075),(49.375,21.905),(49.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,24.285),(78.005,24.455),(78.175,24.455),(78.175,24.285),(78.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,24.285),(78.515,24.455),(78.685,24.455),(78.685,24.285),(78.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,26.665),(15.605,26.835),(15.775,26.835),(15.775,26.665),(15.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.265),(58.805,23.435),(58.975,23.435),(58.975,23.265),(58.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.605),(58.805,23.775),(58.975,23.775),(58.975,23.605),(58.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,39.585),(16.625,39.755),(16.795,39.755),(16.795,39.585),(16.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,39.245),(16.625,39.415),(16.795,39.415),(16.795,39.245),(16.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.285),(44.405,24.455),(44.575,24.455),(44.575,24.285),(44.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.625),(44.405,24.795),(44.575,24.795),(44.575,24.625),(44.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,28.365),(73.205,28.535),(73.375,28.535),(73.375,28.365),(73.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,28.025),(73.205,28.195),(73.375,28.195),(73.375,28.025),(73.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,28.365),(73.715,28.535),(73.885,28.535),(73.885,28.365),(73.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,28.025),(73.715,28.195),(73.885,28.195),(73.885,28.025),(73.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,28.705),(73.715,28.875),(73.885,28.875),(73.885,28.705),(73.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,28.705),(73.205,28.875),(73.375,28.875),(73.375,28.705),(73.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.885),(16.625,4.055),(16.795,4.055),(16.795,3.885),(16.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.605),(49.205,23.775),(49.375,23.775),(49.375,23.605),(49.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.785),(15.605,15.955),(15.775,15.955),(15.775,15.785),(15.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.265),(49.715,23.435),(49.885,23.435),(49.885,23.265),(49.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.605),(49.715,23.775),(49.885,23.775),(49.885,23.605),(49.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.965),(44.405,8.135),(44.575,8.135),(44.575,7.965),(44.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.265),(49.205,23.435),(49.375,23.435),(49.375,23.265),(49.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.245),(68.915,5.415),(69.085,5.415),(69.085,5.245),(68.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.945),(16.625,7.115),(16.795,7.115),(16.795,6.945),(16.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.945),(16.115,7.115),(16.285,7.115),(16.285,6.945),(16.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.785),(68.915,15.955),(69.085,15.955),(69.085,15.785),(68.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.625),(35.825,24.795),(35.995,24.795),(35.995,24.625),(35.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.285),(35.825,24.455),(35.995,24.455),(35.995,24.285),(35.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.625),(35.315,24.795),(35.485,24.795),(35.485,24.625),(35.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.285),(35.315,24.455),(35.485,24.455),(35.485,24.285),(35.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.625),(74.225,7.795),(74.395,7.795),(74.395,7.625),(74.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,34.825),(64.115,34.995),(64.285,34.995),(64.285,34.825),(64.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,34.145),(64.115,34.315),(64.285,34.315),(64.285,34.145),(64.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,34.485),(64.115,34.655),(64.285,34.655),(64.285,34.485),(64.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,34.485),(64.625,34.655),(64.795,34.655),(64.795,34.485),(64.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,34.145),(64.625,34.315),(64.795,34.315),(64.795,34.145),(64.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,34.825),(64.625,34.995),(64.795,34.995),(64.795,34.825),(64.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.785),(20.915,15.955),(21.085,15.955),(21.085,15.785),(20.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.105),(63.605,15.275),(63.775,15.275),(63.775,15.105),(63.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.445),(63.605,15.615),(63.775,15.615),(63.775,15.445),(63.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,20.545),(73.715,20.715),(73.885,20.715),(73.885,20.545),(73.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,20.545),(73.205,20.715),(73.375,20.715),(73.375,20.545),(73.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,20.205),(73.205,20.375),(73.375,20.375),(73.375,20.205),(73.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,20.205),(73.715,20.375),(73.885,20.375),(73.885,20.205),(73.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,22.585),(69.425,22.755),(69.595,22.755),(69.595,22.585),(69.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.625),(79.025,7.795),(79.195,7.795),(79.195,7.625),(79.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,29.385),(69.425,29.555),(69.595,29.555),(69.595,29.385),(69.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,29.045),(69.425,29.215),(69.595,29.215),(69.595,29.045),(69.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,29.725),(69.425,29.895),(69.595,29.895),(69.595,29.725),(69.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.485),(50.225,34.655),(50.395,34.655),(50.395,34.485),(50.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.825),(50.225,34.995),(50.395,34.995),(50.395,34.825),(50.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.765),(11.315,14.935),(11.485,14.935),(11.485,14.765),(11.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.085),(11.315,14.255),(11.485,14.255),(11.485,14.085),(11.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.085),(11.825,14.255),(11.995,14.255),(11.995,14.085),(11.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.145),(50.225,34.315),(50.395,34.315),(50.395,34.145),(50.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.765),(11.825,14.935),(11.995,14.935),(11.995,14.765),(11.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,37.205),(10.805,37.375),(10.975,37.375),(10.975,37.205),(10.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,37.545),(10.805,37.715),(10.975,37.715),(10.975,37.545),(10.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.785),(58.805,15.955),(58.975,15.955),(58.975,15.785),(58.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.965),(34.805,25.135),(34.975,25.135),(34.975,24.965),(34.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.445),(78.515,15.615),(78.685,15.615),(78.685,15.445),(78.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,28.705),(16.625,28.875),(16.795,28.875),(16.795,28.705),(16.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,28.705),(16.115,28.875),(16.285,28.875),(16.285,28.705),(16.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.445),(78.005,15.615),(78.175,15.615),(78.175,15.445),(78.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,30.405),(21.425,30.575),(21.595,30.575),(21.595,30.405),(21.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,30.745),(21.425,30.915),(21.595,30.915),(21.595,30.745),(21.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,30.065),(21.425,30.235),(21.595,30.235),(21.595,30.065),(21.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,33.805),(78.515,33.975),(78.685,33.975),(78.685,33.805),(78.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,33.805),(78.005,33.975),(78.175,33.975),(78.175,33.805),(78.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,33.125),(78.005,33.295),(78.175,33.295),(78.175,33.125),(78.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,33.125),(78.515,33.295),(78.685,33.295),(78.685,33.125),(78.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,33.465),(78.005,33.635),(78.175,33.635),(78.175,33.465),(78.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,33.465),(78.515,33.635),(78.685,33.635),(78.685,33.465),(78.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.165),(34.805,18.335),(34.975,18.335),(34.975,18.165),(34.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.465),(63.605,16.635),(63.775,16.635),(63.775,16.465),(63.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,39.925),(7.025,40.095),(7.195,40.095),(7.195,39.925),(7.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,26.325),(54.515,26.495),(54.685,26.495),(54.685,26.325),(54.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,39.925),(16.115,40.095),(16.285,40.095),(16.285,39.925),(16.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,26.325),(54.005,26.495),(54.175,26.495),(54.175,26.325),(54.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.865),(78.005,20.035),(78.175,20.035),(78.175,19.865),(78.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,21.225),(59.825,21.395),(59.995,21.395),(59.995,21.225),(59.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.225),(59.315,21.395),(59.485,21.395),(59.485,21.225),(59.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.865),(78.515,20.035),(78.685,20.035),(78.685,19.865),(78.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.425),(6.515,14.595),(6.685,14.595),(6.685,14.425),(6.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.285),(31.025,7.455),(31.195,7.455),(31.195,7.285),(31.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,24.285),(11.825,24.455),(11.995,24.455),(11.995,24.285),(11.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,24.285),(11.315,24.455),(11.485,24.455),(11.485,24.285),(11.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,24.625),(11.825,24.795),(11.995,24.795),(11.995,24.625),(11.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,24.625),(11.315,24.795),(11.485,24.795),(11.485,24.625),(11.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,20.885),(68.405,21.055),(68.575,21.055),(68.575,20.885),(68.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.205),(50.225,37.375),(50.395,37.375),(50.395,37.205),(50.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.545),(50.225,37.715),(50.395,37.715),(50.395,37.545),(50.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,36.865),(7.025,37.035),(7.195,37.035),(7.195,36.865),(7.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,37.885),(25.715,38.055),(25.885,38.055),(25.885,37.885),(25.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,37.885),(25.205,38.055),(25.375,38.055),(25.375,37.885),(25.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.925),(40.115,40.095),(40.285,40.095),(40.285,39.925),(40.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.925),(40.625,40.095),(40.795,40.095),(40.795,39.925),(40.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.865),(44.405,20.035),(44.575,20.035),(44.575,19.865),(44.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,39.245),(21.425,39.415),(21.595,39.415),(21.595,39.245),(21.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,39.585),(21.425,39.755),(21.595,39.755),(21.595,39.585),(21.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.085),(59.315,14.255),(59.485,14.255),(59.485,14.085),(59.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.085),(59.825,14.255),(59.995,14.255),(59.995,14.085),(59.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.765),(59.315,14.935),(59.485,14.935),(59.485,14.765),(59.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.765),(59.825,14.935),(59.995,14.935),(59.995,14.765),(59.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,29.045),(59.825,29.215),(59.995,29.215),(59.995,29.045),(59.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,29.725),(59.825,29.895),(59.995,29.895),(59.995,29.725),(59.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.725),(59.315,29.895),(59.485,29.895),(59.485,29.725),(59.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.045),(59.315,29.215),(59.485,29.215),(59.485,29.045),(59.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,29.385),(59.825,29.555),(59.995,29.555),(59.995,29.385),(59.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.385),(59.315,29.555),(59.485,29.555),(59.485,29.385),(59.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,39.245),(25.205,39.415),(25.375,39.415),(25.375,39.245),(25.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,39.585),(25.715,39.755),(25.885,39.755),(25.885,39.585),(25.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,39.245),(25.715,39.415),(25.885,39.415),(25.885,39.245),(25.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,39.585),(25.205,39.755),(25.375,39.755),(25.375,39.585),(25.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,22.925),(79.025,23.095),(79.195,23.095),(79.195,22.925),(79.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.525),(30.005,19.695),(30.175,19.695),(30.175,19.525),(30.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.185),(30.005,19.355),(30.175,19.355),(30.175,19.185),(30.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.485),(44.405,17.655),(44.575,17.655),(44.575,17.485),(44.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.825),(44.405,17.995),(44.575,17.995),(44.575,17.825),(44.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.145),(44.405,17.315),(44.575,17.315),(44.575,17.145),(44.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,38.565),(10.805,38.735),(10.975,38.735),(10.975,38.565),(10.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,38.225),(10.805,38.395),(10.975,38.395),(10.975,38.225),(10.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.005),(58.805,10.175),(58.975,10.175),(58.975,10.005),(58.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.685),(58.805,10.855),(58.975,10.855),(58.975,10.685),(58.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.805),(74.225,16.975),(74.395,16.975),(74.395,16.805),(74.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.125),(74.225,16.295),(74.395,16.295),(74.395,16.125),(74.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,26.665),(39.605,26.835),(39.775,26.835),(39.775,26.665),(39.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,36.865),(20.915,37.035),(21.085,37.035),(21.085,36.865),(20.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.765),(54.515,14.935),(54.685,14.935),(54.685,14.765),(54.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.765),(54.005,14.935),(54.175,14.935),(54.175,14.765),(54.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.085),(54.005,14.255),(54.175,14.255),(54.175,14.085),(54.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.085),(54.515,14.255),(54.685,14.255),(54.685,14.085),(54.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,29.725),(6.515,29.895),(6.685,29.895),(6.685,29.725),(6.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.165),(35.315,35.335),(35.485,35.335),(35.485,35.165),(35.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.505),(35.315,35.675),(35.485,35.675),(35.485,35.505),(35.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,29.045),(6.515,29.215),(6.685,29.215),(6.685,29.045),(6.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.165),(35.825,35.335),(35.995,35.335),(35.995,35.165),(35.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.505),(35.825,35.675),(35.995,35.675),(35.995,35.505),(35.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.005),(10.805,10.175),(10.975,10.175),(10.975,10.005),(10.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.345),(10.805,10.515),(10.975,10.515),(10.975,10.345),(10.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.685),(10.805,10.855),(10.975,10.855),(10.975,10.685),(10.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.785),(44.915,15.955),(45.085,15.955),(45.085,15.785),(44.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.005),(25.205,10.175),(25.375,10.175),(25.375,10.005),(25.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.005),(25.715,10.175),(25.885,10.175),(25.885,10.005),(25.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.345),(25.715,10.515),(25.885,10.515),(25.885,10.345),(25.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.345),(25.205,10.515),(25.375,10.515),(25.375,10.345),(25.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.685),(25.205,10.855),(25.375,10.855),(25.375,10.685),(25.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.685),(25.715,10.855),(25.885,10.855),(25.885,10.685),(25.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.525),(7.025,19.695),(7.195,19.695),(7.195,19.525),(7.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.285),(45.425,7.455),(45.595,7.455),(45.595,7.285),(45.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,25.305),(15.605,25.475),(15.775,25.475),(15.775,25.305),(15.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.725),(44.915,12.895),(45.085,12.895),(45.085,12.725),(44.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,25.645),(15.605,25.815),(15.775,25.815),(15.775,25.645),(15.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,21.905),(6.515,22.075),(6.685,22.075),(6.685,21.905),(6.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.045),(44.915,12.215),(45.085,12.215),(45.085,12.045),(44.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,22.245),(78.005,22.415),(78.175,22.415),(78.175,22.245),(78.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,22.245),(78.515,22.415),(78.685,22.415),(78.685,22.245),(78.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.605),(39.605,23.775),(39.775,23.775),(39.775,23.605),(39.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,25.305),(82.805,25.475),(82.975,25.475),(82.975,25.305),(82.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,25.645),(82.805,25.815),(82.975,25.815),(82.975,25.645),(82.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,24.285),(73.205,24.455),(73.375,24.455),(73.375,24.285),(73.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,24.285),(73.715,24.455),(73.885,24.455),(73.885,24.285),(73.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,2.865),(59.825,3.035),(59.995,3.035),(59.995,2.865),(59.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.865),(59.315,3.035),(59.485,3.035),(59.485,2.865),(59.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.945),(39.605,7.115),(39.775,7.115),(39.775,6.945),(39.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.065),(78.515,13.235),(78.685,13.235),(78.685,13.065),(78.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.405),(78.515,13.575),(78.685,13.575),(78.685,13.405),(78.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.065),(78.005,13.235),(78.175,13.235),(78.175,13.065),(78.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.405),(78.005,13.575),(78.175,13.575),(78.175,13.405),(78.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.745),(78.005,13.915),(78.175,13.915),(78.175,13.745),(78.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.745),(78.515,13.915),(78.685,13.915),(78.685,13.745),(78.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.905),(44.915,5.075),(45.085,5.075),(45.085,4.905),(44.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,22.925),(73.715,23.095),(73.885,23.095),(73.885,22.925),(73.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,22.925),(73.205,23.095),(73.375,23.095),(73.375,22.925),(73.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.865),(30.515,20.035),(30.685,20.035),(30.685,19.865),(30.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,23.945),(20.405,24.115),(20.575,24.115),(20.575,23.945),(20.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.225),(45.425,21.395),(45.595,21.395),(45.595,21.225),(45.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,37.205),(63.605,37.375),(63.775,37.375),(63.775,37.205),(63.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,37.545),(63.605,37.715),(63.775,37.715),(63.775,37.545),(63.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.185),(83.315,19.355),(83.485,19.355),(83.485,19.185),(83.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.285),(68.405,7.455),(68.575,7.455),(68.575,7.285),(68.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.245),(49.715,22.415),(49.885,22.415),(49.885,22.245),(49.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.245),(49.205,22.415),(49.375,22.415),(49.375,22.245),(49.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.585),(49.715,22.755),(49.885,22.755),(49.885,22.585),(49.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.585),(49.205,22.755),(49.375,22.755),(49.375,22.585),(49.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,23.945),(74.225,24.115),(74.395,24.115),(74.395,23.945),(74.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.625),(20.405,7.795),(20.575,7.795),(20.575,7.625),(20.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.465),(44.915,16.635),(45.085,16.635),(45.085,16.465),(44.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,35.845),(63.605,36.015),(63.775,36.015),(63.775,35.845),(63.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,24.625),(16.115,24.795),(16.285,24.795),(16.285,24.625),(16.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,24.625),(16.625,24.795),(16.795,24.795),(16.795,24.625),(16.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,24.285),(16.625,24.455),(16.795,24.455),(16.795,24.285),(16.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,24.285),(16.115,24.455),(16.285,24.455),(16.285,24.285),(16.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,30.405),(26.225,30.575),(26.395,30.575),(26.395,30.405),(26.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,2.865),(79.025,3.035),(79.195,3.035),(79.195,2.865),(79.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.225),(44.915,38.395),(45.085,38.395),(45.085,38.225),(44.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.565),(44.915,38.735),(45.085,38.735),(45.085,38.565),(44.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.265),(45.425,6.435),(45.595,6.435),(45.595,6.265),(45.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.645),(55.025,8.815),(55.195,8.815),(55.195,8.645),(55.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.605),(45.425,6.775),(45.595,6.775),(45.595,6.605),(45.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,39.245),(6.515,39.415),(6.685,39.415),(6.685,39.245),(6.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,39.585),(6.515,39.755),(6.685,39.755),(6.685,39.585),(6.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.925),(44.915,23.095),(45.085,23.095),(45.085,22.925),(44.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.305),(7.025,8.475),(7.195,8.475),(7.195,8.305),(7.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.765),(63.605,14.935),(63.775,14.935),(63.775,14.765),(63.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.085),(63.605,14.255),(63.775,14.255),(63.775,14.085),(63.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.425),(63.605,14.595),(63.775,14.595),(63.775,14.425),(63.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.725),(45.425,29.895),(45.595,29.895),(45.595,29.725),(45.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.045),(45.425,29.215),(45.595,29.215),(45.595,29.045),(45.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.385),(45.425,29.555),(45.595,29.555),(45.595,29.385),(45.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.305),(34.805,8.475),(34.975,8.475),(34.975,8.305),(34.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,32.785),(11.315,32.955),(11.485,32.955),(11.485,32.785),(11.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,32.105),(11.825,32.275),(11.995,32.275),(11.995,32.105),(11.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,32.785),(11.825,32.955),(11.995,32.955),(11.995,32.785),(11.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,32.445),(11.315,32.615),(11.485,32.615),(11.485,32.445),(11.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,32.445),(11.825,32.615),(11.995,32.615),(11.995,32.445),(11.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,32.105),(11.315,32.275),(11.485,32.275),(11.485,32.105),(11.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.925),(31.025,23.095),(31.195,23.095),(31.195,22.925),(31.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.865),(44.405,3.035),(44.575,3.035),(44.575,2.865),(44.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.865),(79.025,20.035),(79.195,20.035),(79.195,19.865),(79.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,35.845),(10.805,36.015),(10.975,36.015),(10.975,35.845),(10.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.525),(21.425,19.695),(21.595,19.695),(21.595,19.525),(21.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.365),(64.115,11.535),(64.285,11.535),(64.285,11.365),(64.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.365),(64.625,11.535),(64.795,11.535),(64.795,11.365),(64.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.345),(54.515,27.515),(54.685,27.515),(54.685,27.345),(54.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.345),(54.005,27.515),(54.175,27.515),(54.175,27.345),(54.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,29.385),(7.025,29.555),(7.195,29.555),(7.195,29.385),(7.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,38.905),(73.715,39.075),(73.885,39.075),(73.885,38.905),(73.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,26.665),(69.425,26.835),(69.595,26.835),(69.595,26.665),(69.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,26.325),(69.425,26.495),(69.595,26.495),(69.595,26.325),(69.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,38.905),(73.205,39.075),(73.375,39.075),(73.375,38.905),(73.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,40.605),(30.005,40.775),(30.175,40.775),(30.175,40.605),(30.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,40.605),(30.515,40.775),(30.685,40.775),(30.685,40.605),(30.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,28.025),(83.315,28.195),(83.485,28.195),(83.485,28.025),(83.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,28.365),(83.315,28.535),(83.485,28.535),(83.485,28.365),(83.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,40.265),(30.005,40.435),(30.175,40.435),(30.175,40.265),(30.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,28.705),(83.315,28.875),(83.485,28.875),(83.485,28.705),(83.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,35.505),(79.025,35.675),(79.195,35.675),(79.195,35.505),(79.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.605),(35.315,23.775),(35.485,23.775),(35.485,23.605),(35.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,35.165),(79.025,35.335),(79.195,35.335),(79.195,35.165),(79.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.605),(35.825,23.775),(35.995,23.775),(35.995,23.605),(35.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.305),(20.405,8.475),(20.575,8.475),(20.575,8.305),(20.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.645),(20.405,8.815),(20.575,8.815),(20.575,8.645),(20.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.065),(10.805,13.235),(10.975,13.235),(10.975,13.065),(10.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.405),(10.805,13.575),(10.975,13.575),(10.975,13.405),(10.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.745),(10.805,13.915),(10.975,13.915),(10.975,13.745),(10.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.165),(30.515,35.335),(30.685,35.335),(30.685,35.165),(30.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.505),(30.515,35.675),(30.685,35.675),(30.685,35.505),(30.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,35.165),(64.115,35.335),(64.285,35.335),(64.285,35.165),(64.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,35.505),(64.115,35.675),(64.285,35.675),(64.285,35.505),(64.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,35.505),(64.625,35.675),(64.795,35.675),(64.795,35.505),(64.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,35.165),(64.625,35.335),(64.795,35.335),(64.795,35.165),(64.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.205),(45.425,20.375),(45.595,20.375),(45.595,20.205),(45.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.185),(49.205,36.355),(49.375,36.355),(49.375,36.185),(49.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.525),(49.205,36.695),(49.375,36.695),(49.375,36.525),(49.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.185),(49.715,36.355),(49.885,36.355),(49.885,36.185),(49.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.525),(49.715,36.695),(49.885,36.695),(49.885,36.525),(49.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,20.205),(59.825,20.375),(59.995,20.375),(59.995,20.205),(59.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.205),(59.315,20.375),(59.485,20.375),(59.485,20.205),(59.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,28.365),(74.225,28.535),(74.395,28.535),(74.395,28.365),(74.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,28.025),(74.225,28.195),(74.395,28.195),(74.395,28.025),(74.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.505),(31.025,18.675),(31.195,18.675),(31.195,18.505),(31.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,28.705),(74.225,28.875),(74.395,28.875),(74.395,28.705),(74.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.165),(31.025,18.335),(31.195,18.335),(31.195,18.165),(31.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.845),(83.315,19.015),(83.485,19.015),(83.485,18.845),(83.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.905),(49.715,39.075),(49.885,39.075),(49.885,38.905),(49.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.905),(49.205,39.075),(49.375,39.075),(49.375,38.905),(49.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.905),(40.625,22.075),(40.795,22.075),(40.795,21.905),(40.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.905),(40.115,22.075),(40.285,22.075),(40.285,21.905),(40.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,40.605),(20.915,40.775),(21.085,40.775),(21.085,40.605),(20.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,40.265),(20.915,40.435),(21.085,40.435),(21.085,40.265),(20.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,26.665),(35.315,26.835),(35.485,26.835),(35.485,26.665),(35.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,26.665),(35.825,26.835),(35.995,26.835),(35.995,26.665),(35.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,29.045),(79.025,29.215),(79.195,29.215),(79.195,29.045),(79.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,29.725),(79.025,29.895),(79.195,29.895),(79.195,29.725),(79.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.285),(64.115,7.455),(64.285,7.455),(64.285,7.285),(64.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.285),(64.625,7.455),(64.795,7.455),(64.795,7.285),(64.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,28.705),(79.025,28.875),(79.195,28.875),(79.195,28.705),(79.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.085),(82.805,14.255),(82.975,14.255),(82.975,14.085),(82.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,27.005),(26.225,27.175),(26.395,27.175),(26.395,27.005),(26.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,27.685),(26.225,27.855),(26.395,27.855),(26.395,27.685),(26.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.425),(82.805,14.595),(82.975,14.595),(82.975,14.425),(82.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.765),(82.805,14.935),(82.975,14.935),(82.975,14.765),(82.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,26.325),(63.605,26.495),(63.775,26.495),(63.775,26.325),(63.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,35.845),(73.715,36.015),(73.885,36.015),(73.885,35.845),(73.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,35.845),(73.205,36.015),(73.375,36.015),(73.375,35.845),(73.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.505),(45.425,35.675),(45.595,35.675),(45.595,35.505),(45.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.165),(45.425,35.335),(45.595,35.335),(45.595,35.165),(45.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.025),(45.425,28.195),(45.595,28.195),(45.595,28.025),(45.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,24.965),(68.405,25.135),(68.575,25.135),(68.575,24.965),(68.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.365),(45.425,28.535),(45.595,28.535),(45.595,28.365),(45.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.705),(45.425,28.875),(45.595,28.875),(45.595,28.705),(45.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.265),(79.025,6.435),(79.195,6.435),(79.195,6.265),(79.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.605),(79.025,6.775),(79.195,6.775),(79.195,6.605),(79.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.525),(73.205,19.695),(73.375,19.695),(73.375,19.525),(73.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.525),(73.715,19.695),(73.885,19.695),(73.885,19.525),(73.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.225),(40.115,38.395),(40.285,38.395),(40.285,38.225),(40.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.565),(40.625,38.735),(40.795,38.735),(40.795,38.565),(40.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.565),(40.115,38.735),(40.285,38.735),(40.285,38.565),(40.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.225),(40.625,38.395),(40.795,38.395),(40.795,38.225),(40.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,28.025),(59.825,28.195),(59.995,28.195),(59.995,28.025),(59.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.365),(59.315,28.535),(59.485,28.535),(59.485,28.365),(59.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.025),(59.315,28.195),(59.485,28.195),(59.485,28.025),(59.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,28.365),(59.825,28.535),(59.995,28.535),(59.995,28.365),(59.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,28.705),(69.425,28.875),(69.595,28.875),(69.595,28.705),(69.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.745),(25.715,13.915),(25.885,13.915),(25.885,13.745),(25.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.745),(25.205,13.915),(25.375,13.915),(25.375,13.745),(25.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.065),(25.205,13.235),(25.375,13.235),(25.375,13.065),(25.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.405),(25.205,13.575),(25.375,13.575),(25.375,13.405),(25.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.405),(25.715,13.575),(25.885,13.575),(25.885,13.405),(25.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.065),(25.715,13.235),(25.885,13.235),(25.885,13.065),(25.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,24.285),(26.225,24.455),(26.395,24.455),(26.395,24.285),(26.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.425),(34.805,31.595),(34.975,31.595),(34.975,31.425),(34.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.865),(40.115,37.035),(40.285,37.035),(40.285,36.865),(40.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.865),(40.625,37.035),(40.795,37.035),(40.795,36.865),(40.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.145),(79.025,17.315),(79.195,17.315),(79.195,17.145),(79.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.825),(79.025,17.995),(79.195,17.995),(79.195,17.825),(79.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.285),(16.625,7.455),(16.795,7.455),(16.795,7.285),(16.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,35.845),(30.005,36.015),(30.175,36.015),(30.175,35.845),(30.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.285),(54.005,24.455),(54.175,24.455),(54.175,24.285),(54.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.285),(54.515,24.455),(54.685,24.455),(54.685,24.285),(54.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.745),(40.625,13.915),(40.795,13.915),(40.795,13.745),(40.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.065),(40.625,13.235),(40.795,13.235),(40.795,13.065),(40.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.745),(40.115,13.915),(40.285,13.915),(40.285,13.745),(40.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,38.565),(16.625,38.735),(16.795,38.735),(16.795,38.565),(16.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,38.225),(16.625,38.395),(16.795,38.395),(16.795,38.225),(16.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.985),(59.315,26.155),(59.485,26.155),(59.485,25.985),(59.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,25.985),(59.825,26.155),(59.995,26.155),(59.995,25.985),(59.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.905),(44.405,5.075),(44.575,5.075),(44.575,4.905),(44.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,26.325),(11.825,26.495),(11.995,26.495),(11.995,26.325),(11.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,26.325),(11.315,26.495),(11.485,26.495),(11.485,26.325),(11.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,26.665),(11.825,26.835),(11.995,26.835),(11.995,26.665),(11.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,26.665),(11.315,26.835),(11.485,26.835),(11.485,26.665),(11.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.845),(40.115,19.015),(40.285,19.015),(40.285,18.845),(40.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.845),(40.625,19.015),(40.795,19.015),(40.795,18.845),(40.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,25.645),(30.005,25.815),(30.175,25.815),(30.175,25.645),(30.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.645),(30.515,25.815),(30.685,25.815),(30.685,25.645),(30.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.605),(74.225,6.775),(74.395,6.775),(74.395,6.605),(74.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,35.845),(68.915,36.015),(69.085,36.015),(69.085,35.845),(68.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.945),(49.205,24.115),(49.375,24.115),(49.375,23.945),(49.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.945),(49.715,24.115),(49.885,24.115),(49.885,23.945),(49.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,36.865),(16.625,37.035),(16.795,37.035),(16.795,36.865),(16.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.625),(68.915,7.795),(69.085,7.795),(69.085,7.625),(68.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.845),(54.005,36.015),(54.175,36.015),(54.175,35.845),(54.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.845),(54.515,36.015),(54.685,36.015),(54.685,35.845),(54.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,36.525),(73.205,36.695),(73.375,36.695),(73.375,36.525),(73.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,36.185),(73.205,36.355),(73.375,36.355),(73.375,36.185),(73.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,36.185),(73.715,36.355),(73.885,36.355),(73.885,36.185),(73.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,36.525),(73.715,36.695),(73.885,36.695),(73.885,36.525),(73.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.285),(20.915,7.455),(21.085,7.455),(21.085,7.285),(20.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.505),(49.715,18.675),(49.885,18.675),(49.885,18.505),(49.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.505),(49.205,18.675),(49.375,18.675),(49.375,18.505),(49.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.145),(74.225,17.315),(74.395,17.315),(74.395,17.145),(74.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.485),(74.225,17.655),(74.395,17.655),(74.395,17.485),(74.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.585),(31.025,5.755),(31.195,5.755),(31.195,5.585),(31.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.825),(74.225,17.995),(74.395,17.995),(74.395,17.825),(74.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.845),(30.005,19.015),(30.175,19.015),(30.175,18.845),(30.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.765),(59.315,31.935),(59.485,31.935),(59.485,31.765),(59.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,31.085),(59.825,31.255),(59.995,31.255),(59.995,31.085),(59.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,31.765),(59.825,31.935),(59.995,31.935),(59.995,31.765),(59.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.745),(30.515,30.915),(30.685,30.915),(30.685,30.745),(30.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.065),(30.515,30.235),(30.685,30.235),(30.685,30.065),(30.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,30.405),(30.005,30.575),(30.175,30.575),(30.175,30.405),(30.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.905),(31.025,39.075),(31.195,39.075),(31.195,38.905),(31.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.085),(59.315,31.255),(59.485,31.255),(59.485,31.085),(59.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.365),(10.805,11.535),(10.975,11.535),(10.975,11.365),(10.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.025),(10.805,11.195),(10.975,11.195),(10.975,11.025),(10.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.705),(10.805,11.875),(10.975,11.875),(10.975,11.705),(10.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,28.025),(7.025,28.195),(7.195,28.195),(7.195,28.025),(7.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,28.365),(7.025,28.535),(7.195,28.535),(7.195,28.365),(7.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,30.405),(83.315,30.575),(83.485,30.575),(83.485,30.405),(83.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,40.605),(16.115,40.775),(16.285,40.775),(16.285,40.605),(16.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,40.265),(16.115,40.435),(16.285,40.435),(16.285,40.265),(16.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.605),(50.225,6.775),(50.395,6.775),(50.395,6.605),(50.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.925),(44.405,23.095),(44.575,23.095),(44.575,22.925),(44.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.965),(79.025,8.135),(79.195,8.135),(79.195,7.965),(79.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,30.405),(64.625,30.575),(64.795,30.575),(64.795,30.405),(64.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,30.745),(64.115,30.915),(64.285,30.915),(64.285,30.745),(64.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,30.745),(64.625,30.915),(64.795,30.915),(64.795,30.745),(64.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,30.065),(64.115,30.235),(64.285,30.235),(64.285,30.065),(64.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,30.405),(64.115,30.575),(64.285,30.575),(64.285,30.405),(64.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,30.065),(64.625,30.235),(64.795,30.235),(64.795,30.065),(64.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,25.645),(63.605,25.815),(63.775,25.815),(63.775,25.645),(63.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,25.305),(63.605,25.475),(63.775,25.475),(63.775,25.305),(63.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.865),(26.225,20.035),(26.395,20.035),(26.395,19.865),(26.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.905),(15.605,5.075),(15.775,5.075),(15.775,4.905),(15.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.645),(15.605,8.815),(15.775,8.815),(15.775,8.645),(15.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.865),(44.915,20.035),(45.085,20.035),(45.085,19.865),(44.915,19.865)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.785),(11.315,40.855),(11.485,40.855),(11.485,2.785),(11.315,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.835),(11.315,40.805),(11.485,40.805),(11.485,2.835),(11.315,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,41.58),(83.06,42.06),(83.23,42.06),(83.23,41.58),(83.06,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,41.58),(11.315,42.06),(11.485,42.06),(11.485,41.58),(11.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.835),(40.115,40.805),(40.285,40.805),(40.285,2.835),(40.115,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.785),(40.115,40.855),(40.285,40.855),(40.285,2.785),(40.115,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,41.735),(25.715,41.905),(25.885,41.905),(25.885,41.735),(25.715,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.005,2.785),(30.005,40.855),(31.195,40.855),(31.195,2.785),(30.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((15.605,2.785),(15.605,40.855),(16.795,40.855),(16.795,2.785),(15.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.58),(20.915,2.06),(21.085,2.06),(21.085,1.58),(20.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.58),(64.115,2.06),(64.285,2.06),(64.285,1.58),(64.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.835),(54.515,40.805),(54.685,40.805),(54.685,2.835),(54.515,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,41.735),(44.915,41.905),(45.085,41.905),(45.085,41.735),(44.915,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((63.605,2.785),(63.605,40.855),(64.795,40.855),(64.795,2.785),(63.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.835),(6.77,40.805),(6.94,40.805),(6.94,2.835),(6.77,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.785),(6.77,40.855),(6.94,40.855),(6.94,2.785),(6.77,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,41.735),(68.915,41.905),(69.085,41.905),(69.085,41.735),(68.915,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,41.735),(16.115,41.905),(16.285,41.905),(16.285,41.735),(16.115,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,41.58),(16.115,42.06),(16.285,42.06),(16.285,41.58),(16.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.835),(78.515,40.805),(78.685,40.805),(78.685,2.835),(78.515,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.785),(78.515,40.855),(78.685,40.855),(78.685,2.785),(78.515,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.785),(44.915,40.855),(45.085,40.855),(45.085,2.785),(44.915,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.785),(44.405,40.855),(45.595,40.855),(45.595,2.785),(44.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.835),(44.915,40.805),(45.085,40.805),(45.085,2.835),(44.915,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.835),(49.715,40.805),(49.885,40.805),(49.885,2.835),(49.715,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.785),(49.715,40.855),(49.885,40.855),(49.885,2.785),(49.715,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.58),(16.115,2.06),(16.285,2.06),(16.285,1.58),(16.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.835),(35.315,40.805),(35.485,40.805),(35.485,2.835),(35.315,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.785),(35.315,40.855),(35.485,40.855),(35.485,2.785),(35.315,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,41.735),(35.315,41.905),(35.485,41.905),(35.485,41.735),(35.315,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.58),(68.915,2.06),(69.085,2.06),(69.085,1.58),(68.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((82.805,2.785),(82.805,40.855),(83.485,40.855),(83.485,2.785),(82.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.835),(25.715,40.805),(25.885,40.805),(25.885,2.835),(25.715,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.785),(25.715,40.855),(25.885,40.855),(25.885,2.785),(25.715,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,41.735),(6.77,41.905),(6.94,41.905),(6.94,41.735),(6.77,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,41.58),(6.77,42.06),(6.94,42.06),(6.94,41.58),(6.77,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.785),(54.005,40.855),(55.195,40.855),(55.195,2.785),(54.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,41.735),(78.515,41.905),(78.685,41.905),(78.685,41.735),(78.515,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.835),(59.315,40.805),(59.485,40.805),(59.485,2.835),(59.315,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.785),(59.315,40.855),(59.485,40.855),(59.485,2.785),(59.315,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,41.735),(59.315,41.905),(59.485,41.905),(59.485,41.735),(59.315,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,41.58),(25.715,42.06),(25.885,42.06),(25.885,41.58),(25.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,41.58),(78.515,42.06),(78.685,42.06),(78.685,41.58),(78.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.785),(73.715,40.855),(73.885,40.855),(73.885,2.785),(73.715,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.835),(73.715,40.805),(73.885,40.805),(73.885,2.835),(73.715,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,21.36),(85.76,21.69),(85.93,21.69),(85.93,21.36),(85.76,21.36)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,41.58),(20.915,42.06),(21.085,42.06),(21.085,41.58),(20.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.58),(78.515,2.06),(78.685,2.06),(78.685,1.58),(78.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,41.735),(49.715,41.905),(49.885,41.905),(49.885,41.735),(49.715,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,21.44),(85.58,21.61),(86.11,21.61),(86.11,21.44),(85.58,21.44)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.835),(20.915,40.805),(21.085,40.805),(21.085,2.835),(20.915,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.785),(20.915,40.855),(21.085,40.855),(21.085,2.785),(20.915,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((20.405,2.785),(20.405,40.855),(21.595,40.855),(21.595,2.785),(20.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,41.735),(40.115,41.905),(40.285,41.905),(40.285,41.735),(40.115,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,41.58),(40.115,42.06),(40.285,42.06),(40.285,41.58),(40.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,41.735),(73.715,41.905),(73.885,41.905),(73.885,41.735),(73.715,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.835),(64.115,40.805),(64.285,40.805),(64.285,2.835),(64.115,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.785),(64.115,40.855),(64.285,40.855),(64.285,2.785),(64.115,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,41.735),(30.515,41.905),(30.685,41.905),(30.685,41.735),(30.515,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,1.735),(85.58,1.905),(86.11,1.905),(86.11,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,41.58),(30.515,42.06),(30.685,42.06),(30.685,41.58),(30.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.58),(6.77,2.06),(6.94,2.06),(6.94,1.58),(6.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.785),(49.205,40.855),(50.395,40.855),(50.395,2.785),(49.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.835),(30.515,40.805),(30.685,40.805),(30.685,2.835),(30.515,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,41.58),(35.315,42.06),(35.485,42.06),(35.485,41.58),(35.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.785),(30.515,40.855),(30.685,40.855),(30.685,2.785),(30.515,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.835),(16.115,40.805),(16.285,40.805),(16.285,2.835),(16.115,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.785),(16.115,40.855),(16.285,40.855),(16.285,2.785),(16.115,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.58),(73.715,2.06),(73.885,2.06),(73.885,1.58),(73.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((6.515,2.785),(6.515,40.855),(7.195,40.855),(7.195,2.785),(6.515,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.785),(58.805,40.855),(59.995,40.855),(59.995,2.785),(58.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.835),(83.06,40.805),(83.23,40.805),(83.23,2.835),(83.06,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.785),(83.06,40.855),(83.23,40.855),(83.23,2.785),(83.06,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,41.735),(11.315,41.905),(11.485,41.905),(11.485,41.735),(11.315,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,41.735),(83.06,41.905),(83.23,41.905),(83.23,41.735),(83.06,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.58),(25.715,2.06),(25.885,2.06),(25.885,1.58),(25.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((78.005,2.785),(78.005,40.855),(79.195,40.855),(79.195,2.785),(78.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,41.58),(59.315,42.06),(59.485,42.06),(59.485,41.58),(59.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,41.735),(20.915,41.905),(21.085,41.905),(21.085,41.735),(20.915,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.58),(59.315,2.06),(59.485,2.06),(59.485,1.58),(59.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,41.735),(54.515,41.905),(54.685,41.905),(54.685,41.735),(54.515,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((68.405,2.785),(68.405,40.855),(69.595,40.855),(69.595,2.785),(68.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.835),(68.915,40.805),(69.085,40.805),(69.085,2.835),(68.915,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,41.58),(49.715,42.06),(49.885,42.06),(49.885,41.58),(49.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.785),(68.915,40.855),(69.085,40.855),(69.085,2.785),(68.915,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,41.58),(54.515,42.06),(54.685,42.06),(54.685,41.58),(54.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,41.58),(44.915,42.06),(45.085,42.06),(45.085,41.58),(44.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((25.205,2.785),(25.205,40.855),(26.395,40.855),(26.395,2.785),(25.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,41.58),(73.715,42.06),(73.885,42.06),(73.885,41.58),(73.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,41.735),(64.115,41.905),(64.285,41.905),(64.285,41.735),(64.115,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.785),(34.805,40.855),(35.995,40.855),(35.995,2.785),(34.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.58),(30.515,2.06),(30.685,2.06),(30.685,1.58),(30.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,41.58),(64.115,42.06),(64.285,42.06),(64.285,41.58),(64.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.58),(83.06,2.06),(83.23,2.06),(83.23,1.58),(83.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.58),(11.315,2.06),(11.485,2.06),(11.485,1.58),(11.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.785),(39.605,40.855),(40.795,40.855),(40.795,2.785),(39.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((10.805,2.785),(10.805,40.855),(11.995,40.855),(11.995,2.785),(10.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,41.58),(68.915,42.06),(69.085,42.06),(69.085,41.58),(68.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.205,2.785),(73.205,40.855),(74.395,40.855),(74.395,2.785),(73.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.785),(54.515,40.855),(54.685,40.855),(54.685,2.785),(54.515,2.785)),
        )
        createRL(
            tech, net, 'nwm',
            ((8.525,2.54),(8.525,41.1),(9.475,41.1),(9.475,2.54),(8.525,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((49.27,2.54),(49.27,41.1),(50.33,41.1),(50.33,2.54),(49.27,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((49.97,2.54),(49.97,41.1),(50.65,41.1),(50.65,2.54),(49.97,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((7.205,2.54),(7.205,41.1),(8.665,41.1),(8.665,2.54),(7.205,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((79.205,2.54),(79.205,41.1),(80.665,41.1),(80.665,2.54),(79.205,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((20.15,2.54),(20.15,41.1),(20.83,41.1),(20.83,2.54),(20.15,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((23.735,2.54),(23.735,41.1),(25.195,41.1),(25.195,2.54),(23.735,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((51.725,2.54),(51.725,41.1),(52.675,41.1),(52.675,2.54),(51.725,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((21.605,2.54),(21.605,41.1),(23.065,41.1),(23.065,2.54),(21.605,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((6.07,2.54),(6.07,41.1),(7.13,41.1),(7.13,2.54),(6.07,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((6.77,2.54),(6.77,41.1),(7.45,41.1),(7.45,2.54),(6.77,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((40.805,2.54),(40.805,41.1),(42.265,41.1),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((58.55,2.54),(58.55,41.1),(59.23,41.1),(59.23,2.54),(58.55,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((58.87,2.54),(58.87,41.1),(59.93,41.1),(59.93,2.54),(58.87,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((62.135,2.54),(62.135,41.1),(63.595,41.1),(63.595,2.54),(62.135,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((78.77,2.54),(78.77,41.1),(79.45,41.1),(79.45,2.54),(78.77,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((78.07,2.54),(78.07,41.1),(79.13,41.1),(79.13,2.54),(78.07,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((52.535,2.54),(52.535,41.1),(53.995,41.1),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((24.95,2.54),(24.95,41.1),(25.63,41.1),(25.63,2.54),(24.95,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((80.525,2.54),(80.525,41.1),(81.475,41.1),(81.475,2.54),(80.525,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((75.725,2.54),(75.725,41.1),(76.675,41.1),(76.675,2.54),(75.725,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((68.47,2.54),(68.47,41.1),(69.53,41.1),(69.53,2.54),(68.47,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((45.605,2.54),(45.605,41.1),(47.065,41.1),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((25.27,2.54),(25.27,41.1),(26.33,41.1),(26.33,2.54),(25.27,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((25.97,2.54),(25.97,41.1),(26.65,41.1),(26.65,2.54),(25.97,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((40.37,2.54),(40.37,41.1),(41.05,41.1),(41.05,2.54),(40.37,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((34.87,2.54),(34.87,41.1),(35.93,41.1),(35.93,2.54),(34.87,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((34.55,2.54),(34.55,41.1),(35.23,41.1),(35.23,2.54),(34.55,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((18.125,2.54),(18.125,41.1),(19.075,41.1),(19.075,2.54),(18.125,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((81.335,2.54),(81.335,41.1),(82.795,41.1),(82.795,2.54),(81.335,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((39.67,2.54),(39.67,41.1),(40.73,41.1),(40.73,2.54),(39.67,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((39.35,2.54),(39.35,41.1),(40.03,41.1),(40.03,2.54),(39.35,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((10.87,2.54),(10.87,41.1),(11.93,41.1),(11.93,2.54),(10.87,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((10.55,2.54),(10.55,41.1),(11.23,41.1),(11.23,2.54),(10.55,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((73.27,2.54),(73.27,41.1),(74.33,41.1),(74.33,2.54),(73.27,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((73.97,2.54),(73.97,41.1),(74.65,41.1),(74.65,2.54),(73.97,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((18.935,2.54),(18.935,41.1),(20.395,41.1),(20.395,2.54),(18.935,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((36.005,2.54),(36.005,41.1),(37.465,41.1),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((68.15,2.54),(68.15,41.1),(68.83,41.1),(68.83,2.54),(68.15,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((70.925,2.54),(70.925,41.1),(71.875,41.1),(71.875,2.54),(70.925,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((71.735,2.54),(71.735,41.1),(73.195,41.1),(73.195,2.54),(71.735,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((33.335,2.54),(33.335,41.1),(34.795,41.1),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((27.725,2.54),(27.725,41.1),(28.675,41.1),(28.675,2.54),(27.725,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((12.005,2.54),(12.005,41.1),(13.465,41.1),(13.465,2.54),(12.005,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((13.325,2.54),(13.325,41.1),(14.275,41.1),(14.275,2.54),(13.325,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((60.005,2.54),(60.005,41.1),(61.465,41.1),(61.465,2.54),(60.005,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((26.405,2.54),(26.405,41.1),(27.865,41.1),(27.865,2.54),(26.405,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((72.95,2.54),(72.95,41.1),(73.63,41.1),(73.63,2.54),(72.95,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((57.335,2.54),(57.335,41.1),(58.795,41.1),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((46.925,2.54),(46.925,41.1),(47.875,41.1),(47.875,2.54),(46.925,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((30.07,2.54),(30.07,41.1),(31.13,41.1),(31.13,2.54),(30.07,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((30.77,2.54),(30.77,41.1),(31.45,41.1),(31.45,2.54),(30.77,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((15.35,2.54),(15.35,41.1),(16.03,41.1),(16.03,2.54),(15.35,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((15.67,2.54),(15.67,41.1),(16.73,41.1),(16.73,2.54),(15.67,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((35.57,2.54),(35.57,41.1),(36.25,41.1),(36.25,2.54),(35.57,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((22.925,2.54),(22.925,41.1),(23.875,41.1),(23.875,2.54),(22.925,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((74.405,2.54),(74.405,41.1),(75.865,41.1),(75.865,2.54),(74.405,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((42.125,2.54),(42.125,41.1),(43.075,41.1),(43.075,2.54),(42.125,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((64.805,2.54),(64.805,41.1),(66.265,41.1),(66.265,2.54),(64.805,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((48.95,2.54),(48.95,41.1),(49.63,41.1),(49.63,2.54),(48.95,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((63.67,2.54),(63.67,41.1),(64.73,41.1),(64.73,2.54),(63.67,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((63.35,2.54),(63.35,41.1),(64.03,41.1),(64.03,2.54),(63.35,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((53.75,2.54),(53.75,41.1),(54.43,41.1),(54.43,2.54),(53.75,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((47.735,2.54),(47.735,41.1),(49.195,41.1),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((59.57,2.54),(59.57,41.1),(60.25,41.1),(60.25,2.54),(59.57,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((69.17,2.54),(69.17,41.1),(69.85,41.1),(69.85,2.54),(69.17,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((29.75,2.54),(29.75,41.1),(30.43,41.1),(30.43,2.54),(29.75,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((44.47,2.54),(44.47,41.1),(45.53,41.1),(45.53,2.54),(44.47,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((16.805,2.54),(16.805,41.1),(18.265,41.1),(18.265,2.54),(16.805,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((31.205,2.54),(31.205,41.1),(32.665,41.1),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((38.135,2.54),(38.135,41.1),(39.595,41.1),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((42.935,2.54),(42.935,41.1),(44.395,41.1),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((82.87,2.54),(82.87,41.1),(83.93,41.1),(83.93,2.54),(82.87,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((82.55,2.54),(82.55,41.1),(83.23,41.1),(83.23,2.54),(82.55,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((37.325,2.54),(37.325,41.1),(38.275,41.1),(38.275,2.54),(37.325,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((44.15,2.54),(44.15,41.1),(44.83,41.1),(44.83,2.54),(44.15,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((54.77,2.54),(54.77,41.1),(55.45,41.1),(55.45,2.54),(54.77,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((54.07,2.54),(54.07,41.1),(55.13,41.1),(55.13,2.54),(54.07,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((9.335,2.54),(9.335,41.1),(10.795,41.1),(10.795,2.54),(9.335,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((56.525,2.54),(56.525,41.1),(57.475,41.1),(57.475,2.54),(56.525,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((64.37,2.54),(64.37,41.1),(65.05,41.1),(65.05,2.54),(64.37,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((55.205,2.54),(55.205,41.1),(56.665,41.1),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((21.17,2.54),(21.17,41.1),(21.85,41.1),(21.85,2.54),(21.17,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((28.535,2.54),(28.535,41.1),(29.995,41.1),(29.995,2.54),(28.535,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((50.405,2.54),(50.405,41.1),(51.865,41.1),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((14.135,2.54),(14.135,41.1),(15.595,41.1),(15.595,2.54),(14.135,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((66.125,2.54),(66.125,41.1),(67.075,41.1),(67.075,2.54),(66.125,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((61.325,2.54),(61.325,41.1),(62.275,41.1),(62.275,2.54),(61.325,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((76.535,2.54),(76.535,41.1),(77.995,41.1),(77.995,2.54),(76.535,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((20.47,2.54),(20.47,41.1),(21.53,41.1),(21.53,2.54),(20.47,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((69.605,2.54),(69.605,41.1),(71.065,41.1),(71.065,2.54),(69.605,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((66.935,2.54),(66.935,41.1),(68.395,41.1),(68.395,2.54),(66.935,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((16.37,2.54),(16.37,41.1),(17.05,41.1),(17.05,2.54),(16.37,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((32.525,2.54),(32.525,41.1),(33.475,41.1),(33.475,2.54),(32.525,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((11.57,2.54),(11.57,41.1),(12.25,41.1),(12.25,2.54),(11.57,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((45.17,2.54),(45.17,41.1),(45.85,41.1),(45.85,2.54),(45.17,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((77.75,2.54),(77.75,41.1),(78.43,41.1),(78.43,2.54),(77.75,2.54)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,41.735),(44.915,41.905),(45.085,41.905),(45.085,41.735),(44.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,41.735),(78.515,41.905),(78.685,41.905),(78.685,41.735),(78.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,41.735),(59.315,41.905),(59.485,41.905),(59.485,41.735),(59.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,2.835),(78.515,3.005),(78.685,3.005),(78.685,2.835),(78.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.195),(78.515,3.365),(78.685,3.365),(78.685,3.195),(78.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.555),(78.515,3.725),(78.685,3.725),(78.685,3.555),(78.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.915),(78.515,4.085),(78.685,4.085),(78.685,3.915),(78.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.275),(78.515,4.445),(78.685,4.445),(78.685,4.275),(78.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.635),(78.515,4.805),(78.685,4.805),(78.685,4.635),(78.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.995),(78.515,5.165),(78.685,5.165),(78.685,4.995),(78.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.355),(78.515,5.525),(78.685,5.525),(78.685,5.355),(78.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.715),(78.515,5.885),(78.685,5.885),(78.685,5.715),(78.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.075),(78.515,6.245),(78.685,6.245),(78.685,6.075),(78.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.435),(78.515,6.605),(78.685,6.605),(78.685,6.435),(78.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.795),(78.515,6.965),(78.685,6.965),(78.685,6.795),(78.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.155),(78.515,7.325),(78.685,7.325),(78.685,7.155),(78.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.515),(78.515,7.685),(78.685,7.685),(78.685,7.515),(78.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.875),(78.515,8.045),(78.685,8.045),(78.685,7.875),(78.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.235),(78.515,8.405),(78.685,8.405),(78.685,8.235),(78.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.595),(78.515,8.765),(78.685,8.765),(78.685,8.595),(78.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.955),(78.515,9.125),(78.685,9.125),(78.685,8.955),(78.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.315),(78.515,9.485),(78.685,9.485),(78.685,9.315),(78.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.675),(78.515,9.845),(78.685,9.845),(78.685,9.675),(78.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.035),(78.515,10.205),(78.685,10.205),(78.685,10.035),(78.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.395),(78.515,10.565),(78.685,10.565),(78.685,10.395),(78.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.755),(78.515,10.925),(78.685,10.925),(78.685,10.755),(78.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.115),(78.515,11.285),(78.685,11.285),(78.685,11.115),(78.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.475),(78.515,11.645),(78.685,11.645),(78.685,11.475),(78.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.835),(78.515,12.005),(78.685,12.005),(78.685,11.835),(78.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.195),(78.515,12.365),(78.685,12.365),(78.685,12.195),(78.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.555),(78.515,12.725),(78.685,12.725),(78.685,12.555),(78.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.915),(78.515,13.085),(78.685,13.085),(78.685,12.915),(78.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.275),(78.515,13.445),(78.685,13.445),(78.685,13.275),(78.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.635),(78.515,13.805),(78.685,13.805),(78.685,13.635),(78.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.995),(78.515,14.165),(78.685,14.165),(78.685,13.995),(78.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.355),(78.515,14.525),(78.685,14.525),(78.685,14.355),(78.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.715),(78.515,14.885),(78.685,14.885),(78.685,14.715),(78.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.075),(78.515,15.245),(78.685,15.245),(78.685,15.075),(78.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.435),(78.515,15.605),(78.685,15.605),(78.685,15.435),(78.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.795),(78.515,15.965),(78.685,15.965),(78.685,15.795),(78.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.155),(78.515,16.325),(78.685,16.325),(78.685,16.155),(78.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.515),(78.515,16.685),(78.685,16.685),(78.685,16.515),(78.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.875),(78.515,17.045),(78.685,17.045),(78.685,16.875),(78.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.235),(78.515,17.405),(78.685,17.405),(78.685,17.235),(78.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.595),(78.515,17.765),(78.685,17.765),(78.685,17.595),(78.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.955),(78.515,18.125),(78.685,18.125),(78.685,17.955),(78.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.315),(78.515,18.485),(78.685,18.485),(78.685,18.315),(78.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.675),(78.515,18.845),(78.685,18.845),(78.685,18.675),(78.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.035),(78.515,19.205),(78.685,19.205),(78.685,19.035),(78.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.395),(78.515,19.565),(78.685,19.565),(78.685,19.395),(78.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.755),(78.515,19.925),(78.685,19.925),(78.685,19.755),(78.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.115),(78.515,20.285),(78.685,20.285),(78.685,20.115),(78.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.475),(78.515,20.645),(78.685,20.645),(78.685,20.475),(78.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.835),(78.515,21.005),(78.685,21.005),(78.685,20.835),(78.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,21.195),(78.515,21.365),(78.685,21.365),(78.685,21.195),(78.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,21.555),(78.515,21.725),(78.685,21.725),(78.685,21.555),(78.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,21.915),(78.515,22.085),(78.685,22.085),(78.685,21.915),(78.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,22.275),(78.515,22.445),(78.685,22.445),(78.685,22.275),(78.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,22.635),(78.515,22.805),(78.685,22.805),(78.685,22.635),(78.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,22.995),(78.515,23.165),(78.685,23.165),(78.685,22.995),(78.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,23.355),(78.515,23.525),(78.685,23.525),(78.685,23.355),(78.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,23.715),(78.515,23.885),(78.685,23.885),(78.685,23.715),(78.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,24.075),(78.515,24.245),(78.685,24.245),(78.685,24.075),(78.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,24.435),(78.515,24.605),(78.685,24.605),(78.685,24.435),(78.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,24.795),(78.515,24.965),(78.685,24.965),(78.685,24.795),(78.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,25.155),(78.515,25.325),(78.685,25.325),(78.685,25.155),(78.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,25.515),(78.515,25.685),(78.685,25.685),(78.685,25.515),(78.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,25.875),(78.515,26.045),(78.685,26.045),(78.685,25.875),(78.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,26.235),(78.515,26.405),(78.685,26.405),(78.685,26.235),(78.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,26.595),(78.515,26.765),(78.685,26.765),(78.685,26.595),(78.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,26.955),(78.515,27.125),(78.685,27.125),(78.685,26.955),(78.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,27.315),(78.515,27.485),(78.685,27.485),(78.685,27.315),(78.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,27.675),(78.515,27.845),(78.685,27.845),(78.685,27.675),(78.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,28.035),(78.515,28.205),(78.685,28.205),(78.685,28.035),(78.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,28.395),(78.515,28.565),(78.685,28.565),(78.685,28.395),(78.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,28.755),(78.515,28.925),(78.685,28.925),(78.685,28.755),(78.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,29.115),(78.515,29.285),(78.685,29.285),(78.685,29.115),(78.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,29.475),(78.515,29.645),(78.685,29.645),(78.685,29.475),(78.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,29.835),(78.515,30.005),(78.685,30.005),(78.685,29.835),(78.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,30.195),(78.515,30.365),(78.685,30.365),(78.685,30.195),(78.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,30.555),(78.515,30.725),(78.685,30.725),(78.685,30.555),(78.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,30.915),(78.515,31.085),(78.685,31.085),(78.685,30.915),(78.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,31.275),(78.515,31.445),(78.685,31.445),(78.685,31.275),(78.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,31.635),(78.515,31.805),(78.685,31.805),(78.685,31.635),(78.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,31.995),(78.515,32.165),(78.685,32.165),(78.685,31.995),(78.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,32.355),(78.515,32.525),(78.685,32.525),(78.685,32.355),(78.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,32.715),(78.515,32.885),(78.685,32.885),(78.685,32.715),(78.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,33.075),(78.515,33.245),(78.685,33.245),(78.685,33.075),(78.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,33.435),(78.515,33.605),(78.685,33.605),(78.685,33.435),(78.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,33.795),(78.515,33.965),(78.685,33.965),(78.685,33.795),(78.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,34.155),(78.515,34.325),(78.685,34.325),(78.685,34.155),(78.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,34.515),(78.515,34.685),(78.685,34.685),(78.685,34.515),(78.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,34.875),(78.515,35.045),(78.685,35.045),(78.685,34.875),(78.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,35.235),(78.515,35.405),(78.685,35.405),(78.685,35.235),(78.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,35.595),(78.515,35.765),(78.685,35.765),(78.685,35.595),(78.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,35.955),(78.515,36.125),(78.685,36.125),(78.685,35.955),(78.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,36.315),(78.515,36.485),(78.685,36.485),(78.685,36.315),(78.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,36.675),(78.515,36.845),(78.685,36.845),(78.685,36.675),(78.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,37.035),(78.515,37.205),(78.685,37.205),(78.685,37.035),(78.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,37.395),(78.515,37.565),(78.685,37.565),(78.685,37.395),(78.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,37.755),(78.515,37.925),(78.685,37.925),(78.685,37.755),(78.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,38.115),(78.515,38.285),(78.685,38.285),(78.685,38.115),(78.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,38.475),(78.515,38.645),(78.685,38.645),(78.685,38.475),(78.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,38.835),(78.515,39.005),(78.685,39.005),(78.685,38.835),(78.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,39.195),(78.515,39.365),(78.685,39.365),(78.685,39.195),(78.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,39.555),(78.515,39.725),(78.685,39.725),(78.685,39.555),(78.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,39.915),(78.515,40.085),(78.685,40.085),(78.685,39.915),(78.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,40.275),(78.515,40.445),(78.685,40.445),(78.685,40.275),(78.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,40.635),(78.515,40.805),(78.685,40.805),(78.685,40.635),(78.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,2.835),(30.515,3.005),(30.685,3.005),(30.685,2.835),(30.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.195),(30.515,3.365),(30.685,3.365),(30.685,3.195),(30.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.555),(30.515,3.725),(30.685,3.725),(30.685,3.555),(30.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.915),(30.515,4.085),(30.685,4.085),(30.685,3.915),(30.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.275),(30.515,4.445),(30.685,4.445),(30.685,4.275),(30.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.635),(30.515,4.805),(30.685,4.805),(30.685,4.635),(30.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.995),(30.515,5.165),(30.685,5.165),(30.685,4.995),(30.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.355),(30.515,5.525),(30.685,5.525),(30.685,5.355),(30.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.715),(30.515,5.885),(30.685,5.885),(30.685,5.715),(30.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.075),(30.515,6.245),(30.685,6.245),(30.685,6.075),(30.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.435),(30.515,6.605),(30.685,6.605),(30.685,6.435),(30.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.795),(30.515,6.965),(30.685,6.965),(30.685,6.795),(30.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.155),(30.515,7.325),(30.685,7.325),(30.685,7.155),(30.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.515),(30.515,7.685),(30.685,7.685),(30.685,7.515),(30.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.875),(30.515,8.045),(30.685,8.045),(30.685,7.875),(30.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.235),(30.515,8.405),(30.685,8.405),(30.685,8.235),(30.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.595),(30.515,8.765),(30.685,8.765),(30.685,8.595),(30.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.955),(30.515,9.125),(30.685,9.125),(30.685,8.955),(30.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.315),(30.515,9.485),(30.685,9.485),(30.685,9.315),(30.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.675),(30.515,9.845),(30.685,9.845),(30.685,9.675),(30.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.035),(30.515,10.205),(30.685,10.205),(30.685,10.035),(30.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.395),(30.515,10.565),(30.685,10.565),(30.685,10.395),(30.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.755),(30.515,10.925),(30.685,10.925),(30.685,10.755),(30.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.115),(30.515,11.285),(30.685,11.285),(30.685,11.115),(30.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.475),(30.515,11.645),(30.685,11.645),(30.685,11.475),(30.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.835),(30.515,12.005),(30.685,12.005),(30.685,11.835),(30.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.195),(30.515,12.365),(30.685,12.365),(30.685,12.195),(30.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.555),(30.515,12.725),(30.685,12.725),(30.685,12.555),(30.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.915),(30.515,13.085),(30.685,13.085),(30.685,12.915),(30.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.275),(30.515,13.445),(30.685,13.445),(30.685,13.275),(30.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.635),(30.515,13.805),(30.685,13.805),(30.685,13.635),(30.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.995),(30.515,14.165),(30.685,14.165),(30.685,13.995),(30.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.355),(30.515,14.525),(30.685,14.525),(30.685,14.355),(30.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.715),(30.515,14.885),(30.685,14.885),(30.685,14.715),(30.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.075),(30.515,15.245),(30.685,15.245),(30.685,15.075),(30.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.435),(30.515,15.605),(30.685,15.605),(30.685,15.435),(30.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.795),(30.515,15.965),(30.685,15.965),(30.685,15.795),(30.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.155),(30.515,16.325),(30.685,16.325),(30.685,16.155),(30.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.515),(30.515,16.685),(30.685,16.685),(30.685,16.515),(30.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.875),(30.515,17.045),(30.685,17.045),(30.685,16.875),(30.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.235),(30.515,17.405),(30.685,17.405),(30.685,17.235),(30.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.595),(30.515,17.765),(30.685,17.765),(30.685,17.595),(30.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.955),(30.515,18.125),(30.685,18.125),(30.685,17.955),(30.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.315),(30.515,18.485),(30.685,18.485),(30.685,18.315),(30.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.675),(30.515,18.845),(30.685,18.845),(30.685,18.675),(30.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.035),(30.515,19.205),(30.685,19.205),(30.685,19.035),(30.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.395),(30.515,19.565),(30.685,19.565),(30.685,19.395),(30.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.755),(30.515,19.925),(30.685,19.925),(30.685,19.755),(30.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.115),(30.515,20.285),(30.685,20.285),(30.685,20.115),(30.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.475),(30.515,20.645),(30.685,20.645),(30.685,20.475),(30.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.835),(30.515,21.005),(30.685,21.005),(30.685,20.835),(30.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,21.195),(30.515,21.365),(30.685,21.365),(30.685,21.195),(30.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,21.555),(30.515,21.725),(30.685,21.725),(30.685,21.555),(30.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,21.915),(30.515,22.085),(30.685,22.085),(30.685,21.915),(30.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,22.275),(30.515,22.445),(30.685,22.445),(30.685,22.275),(30.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,22.635),(30.515,22.805),(30.685,22.805),(30.685,22.635),(30.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,22.995),(30.515,23.165),(30.685,23.165),(30.685,22.995),(30.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,23.355),(30.515,23.525),(30.685,23.525),(30.685,23.355),(30.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,23.715),(30.515,23.885),(30.685,23.885),(30.685,23.715),(30.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,24.075),(30.515,24.245),(30.685,24.245),(30.685,24.075),(30.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,24.435),(30.515,24.605),(30.685,24.605),(30.685,24.435),(30.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,24.795),(30.515,24.965),(30.685,24.965),(30.685,24.795),(30.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,25.155),(30.515,25.325),(30.685,25.325),(30.685,25.155),(30.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,25.515),(30.515,25.685),(30.685,25.685),(30.685,25.515),(30.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,25.875),(30.515,26.045),(30.685,26.045),(30.685,25.875),(30.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,26.235),(30.515,26.405),(30.685,26.405),(30.685,26.235),(30.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,26.595),(30.515,26.765),(30.685,26.765),(30.685,26.595),(30.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,26.955),(30.515,27.125),(30.685,27.125),(30.685,26.955),(30.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,27.315),(30.515,27.485),(30.685,27.485),(30.685,27.315),(30.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,27.675),(30.515,27.845),(30.685,27.845),(30.685,27.675),(30.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,28.035),(30.515,28.205),(30.685,28.205),(30.685,28.035),(30.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,28.395),(30.515,28.565),(30.685,28.565),(30.685,28.395),(30.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,28.755),(30.515,28.925),(30.685,28.925),(30.685,28.755),(30.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,29.115),(30.515,29.285),(30.685,29.285),(30.685,29.115),(30.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,29.475),(30.515,29.645),(30.685,29.645),(30.685,29.475),(30.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,29.835),(30.515,30.005),(30.685,30.005),(30.685,29.835),(30.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,30.195),(30.515,30.365),(30.685,30.365),(30.685,30.195),(30.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,30.555),(30.515,30.725),(30.685,30.725),(30.685,30.555),(30.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,30.915),(30.515,31.085),(30.685,31.085),(30.685,30.915),(30.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,31.275),(30.515,31.445),(30.685,31.445),(30.685,31.275),(30.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,31.635),(30.515,31.805),(30.685,31.805),(30.685,31.635),(30.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,31.995),(30.515,32.165),(30.685,32.165),(30.685,31.995),(30.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,32.355),(30.515,32.525),(30.685,32.525),(30.685,32.355),(30.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,32.715),(30.515,32.885),(30.685,32.885),(30.685,32.715),(30.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,33.075),(30.515,33.245),(30.685,33.245),(30.685,33.075),(30.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,33.435),(30.515,33.605),(30.685,33.605),(30.685,33.435),(30.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,33.795),(30.515,33.965),(30.685,33.965),(30.685,33.795),(30.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,34.155),(30.515,34.325),(30.685,34.325),(30.685,34.155),(30.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,34.515),(30.515,34.685),(30.685,34.685),(30.685,34.515),(30.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,34.875),(30.515,35.045),(30.685,35.045),(30.685,34.875),(30.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,35.235),(30.515,35.405),(30.685,35.405),(30.685,35.235),(30.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,35.595),(30.515,35.765),(30.685,35.765),(30.685,35.595),(30.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,35.955),(30.515,36.125),(30.685,36.125),(30.685,35.955),(30.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,36.315),(30.515,36.485),(30.685,36.485),(30.685,36.315),(30.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,36.675),(30.515,36.845),(30.685,36.845),(30.685,36.675),(30.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,37.035),(30.515,37.205),(30.685,37.205),(30.685,37.035),(30.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,37.395),(30.515,37.565),(30.685,37.565),(30.685,37.395),(30.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,37.755),(30.515,37.925),(30.685,37.925),(30.685,37.755),(30.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,38.115),(30.515,38.285),(30.685,38.285),(30.685,38.115),(30.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,38.475),(30.515,38.645),(30.685,38.645),(30.685,38.475),(30.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,38.835),(30.515,39.005),(30.685,39.005),(30.685,38.835),(30.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,39.195),(30.515,39.365),(30.685,39.365),(30.685,39.195),(30.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,39.555),(30.515,39.725),(30.685,39.725),(30.685,39.555),(30.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,39.915),(30.515,40.085),(30.685,40.085),(30.685,39.915),(30.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,40.275),(30.515,40.445),(30.685,40.445),(30.685,40.275),(30.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,40.635),(30.515,40.805),(30.685,40.805),(30.685,40.635),(30.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.835),(44.915,3.005),(45.085,3.005),(45.085,2.835),(44.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.195),(44.915,3.365),(45.085,3.365),(45.085,3.195),(44.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.555),(44.915,3.725),(45.085,3.725),(45.085,3.555),(44.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.915),(44.915,4.085),(45.085,4.085),(45.085,3.915),(44.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.275),(44.915,4.445),(45.085,4.445),(45.085,4.275),(44.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.635),(44.915,4.805),(45.085,4.805),(45.085,4.635),(44.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.995),(44.915,5.165),(45.085,5.165),(45.085,4.995),(44.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.355),(44.915,5.525),(45.085,5.525),(45.085,5.355),(44.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.715),(44.915,5.885),(45.085,5.885),(45.085,5.715),(44.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.075),(44.915,6.245),(45.085,6.245),(45.085,6.075),(44.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.435),(44.915,6.605),(45.085,6.605),(45.085,6.435),(44.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.795),(44.915,6.965),(45.085,6.965),(45.085,6.795),(44.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.155),(44.915,7.325),(45.085,7.325),(45.085,7.155),(44.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.515),(44.915,7.685),(45.085,7.685),(45.085,7.515),(44.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.875),(44.915,8.045),(45.085,8.045),(45.085,7.875),(44.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.235),(44.915,8.405),(45.085,8.405),(45.085,8.235),(44.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.595),(44.915,8.765),(45.085,8.765),(45.085,8.595),(44.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.955),(44.915,9.125),(45.085,9.125),(45.085,8.955),(44.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.315),(44.915,9.485),(45.085,9.485),(45.085,9.315),(44.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.675),(44.915,9.845),(45.085,9.845),(45.085,9.675),(44.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.035),(44.915,10.205),(45.085,10.205),(45.085,10.035),(44.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.395),(44.915,10.565),(45.085,10.565),(45.085,10.395),(44.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.755),(44.915,10.925),(45.085,10.925),(45.085,10.755),(44.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.115),(44.915,11.285),(45.085,11.285),(45.085,11.115),(44.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.475),(44.915,11.645),(45.085,11.645),(45.085,11.475),(44.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.835),(44.915,12.005),(45.085,12.005),(45.085,11.835),(44.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.195),(44.915,12.365),(45.085,12.365),(45.085,12.195),(44.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.555),(44.915,12.725),(45.085,12.725),(45.085,12.555),(44.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.915),(44.915,13.085),(45.085,13.085),(45.085,12.915),(44.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.275),(44.915,13.445),(45.085,13.445),(45.085,13.275),(44.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.635),(44.915,13.805),(45.085,13.805),(45.085,13.635),(44.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.995),(44.915,14.165),(45.085,14.165),(45.085,13.995),(44.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.355),(44.915,14.525),(45.085,14.525),(45.085,14.355),(44.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.715),(44.915,14.885),(45.085,14.885),(45.085,14.715),(44.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.075),(44.915,15.245),(45.085,15.245),(45.085,15.075),(44.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.435),(44.915,15.605),(45.085,15.605),(45.085,15.435),(44.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.795),(44.915,15.965),(45.085,15.965),(45.085,15.795),(44.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.155),(44.915,16.325),(45.085,16.325),(45.085,16.155),(44.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.515),(44.915,16.685),(45.085,16.685),(45.085,16.515),(44.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.875),(44.915,17.045),(45.085,17.045),(45.085,16.875),(44.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.235),(44.915,17.405),(45.085,17.405),(45.085,17.235),(44.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.595),(44.915,17.765),(45.085,17.765),(45.085,17.595),(44.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.955),(44.915,18.125),(45.085,18.125),(45.085,17.955),(44.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.315),(44.915,18.485),(45.085,18.485),(45.085,18.315),(44.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.675),(44.915,18.845),(45.085,18.845),(45.085,18.675),(44.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.035),(44.915,19.205),(45.085,19.205),(45.085,19.035),(44.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.395),(44.915,19.565),(45.085,19.565),(45.085,19.395),(44.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.755),(44.915,19.925),(45.085,19.925),(45.085,19.755),(44.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.115),(44.915,20.285),(45.085,20.285),(45.085,20.115),(44.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.475),(44.915,20.645),(45.085,20.645),(45.085,20.475),(44.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.835),(44.915,21.005),(45.085,21.005),(45.085,20.835),(44.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.195),(44.915,21.365),(45.085,21.365),(45.085,21.195),(44.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.555),(44.915,21.725),(45.085,21.725),(45.085,21.555),(44.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.915),(44.915,22.085),(45.085,22.085),(45.085,21.915),(44.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.275),(44.915,22.445),(45.085,22.445),(45.085,22.275),(44.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.635),(44.915,22.805),(45.085,22.805),(45.085,22.635),(44.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.995),(44.915,23.165),(45.085,23.165),(45.085,22.995),(44.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,23.355),(44.915,23.525),(45.085,23.525),(45.085,23.355),(44.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,23.715),(44.915,23.885),(45.085,23.885),(45.085,23.715),(44.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.075),(44.915,24.245),(45.085,24.245),(45.085,24.075),(44.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.435),(44.915,24.605),(45.085,24.605),(45.085,24.435),(44.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.795),(44.915,24.965),(45.085,24.965),(45.085,24.795),(44.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.155),(44.915,25.325),(45.085,25.325),(45.085,25.155),(44.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.515),(44.915,25.685),(45.085,25.685),(45.085,25.515),(44.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.875),(44.915,26.045),(45.085,26.045),(45.085,25.875),(44.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.235),(44.915,26.405),(45.085,26.405),(45.085,26.235),(44.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.595),(44.915,26.765),(45.085,26.765),(45.085,26.595),(44.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.955),(44.915,27.125),(45.085,27.125),(45.085,26.955),(44.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,27.315),(44.915,27.485),(45.085,27.485),(45.085,27.315),(44.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,27.675),(44.915,27.845),(45.085,27.845),(45.085,27.675),(44.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.035),(44.915,28.205),(45.085,28.205),(45.085,28.035),(44.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.395),(44.915,28.565),(45.085,28.565),(45.085,28.395),(44.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.755),(44.915,28.925),(45.085,28.925),(45.085,28.755),(44.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.115),(44.915,29.285),(45.085,29.285),(45.085,29.115),(44.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.475),(44.915,29.645),(45.085,29.645),(45.085,29.475),(44.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.835),(44.915,30.005),(45.085,30.005),(45.085,29.835),(44.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.195),(44.915,30.365),(45.085,30.365),(45.085,30.195),(44.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.555),(44.915,30.725),(45.085,30.725),(45.085,30.555),(44.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.915),(44.915,31.085),(45.085,31.085),(45.085,30.915),(44.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.275),(44.915,31.445),(45.085,31.445),(45.085,31.275),(44.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.635),(44.915,31.805),(45.085,31.805),(45.085,31.635),(44.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.995),(44.915,32.165),(45.085,32.165),(45.085,31.995),(44.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.355),(44.915,32.525),(45.085,32.525),(45.085,32.355),(44.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.715),(44.915,32.885),(45.085,32.885),(45.085,32.715),(44.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.075),(44.915,33.245),(45.085,33.245),(45.085,33.075),(44.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.435),(44.915,33.605),(45.085,33.605),(45.085,33.435),(44.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.795),(44.915,33.965),(45.085,33.965),(45.085,33.795),(44.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.155),(44.915,34.325),(45.085,34.325),(45.085,34.155),(44.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.515),(44.915,34.685),(45.085,34.685),(45.085,34.515),(44.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.875),(44.915,35.045),(45.085,35.045),(45.085,34.875),(44.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.235),(44.915,35.405),(45.085,35.405),(45.085,35.235),(44.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.595),(44.915,35.765),(45.085,35.765),(45.085,35.595),(44.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.955),(44.915,36.125),(45.085,36.125),(45.085,35.955),(44.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.315),(44.915,36.485),(45.085,36.485),(45.085,36.315),(44.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.675),(44.915,36.845),(45.085,36.845),(45.085,36.675),(44.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.035),(44.915,37.205),(45.085,37.205),(45.085,37.035),(44.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.395),(44.915,37.565),(45.085,37.565),(45.085,37.395),(44.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.755),(44.915,37.925),(45.085,37.925),(45.085,37.755),(44.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.115),(44.915,38.285),(45.085,38.285),(45.085,38.115),(44.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.475),(44.915,38.645),(45.085,38.645),(45.085,38.475),(44.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.835),(44.915,39.005),(45.085,39.005),(45.085,38.835),(44.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.195),(44.915,39.365),(45.085,39.365),(45.085,39.195),(44.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.555),(44.915,39.725),(45.085,39.725),(45.085,39.555),(44.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.915),(44.915,40.085),(45.085,40.085),(45.085,39.915),(44.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,40.275),(44.915,40.445),(45.085,40.445),(45.085,40.275),(44.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,40.635),(44.915,40.805),(45.085,40.805),(45.085,40.635),(44.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,41.735),(68.915,41.905),(69.085,41.905),(69.085,41.735),(68.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,41.735),(83.06,41.905),(83.23,41.905),(83.23,41.735),(83.06,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,41.735),(11.315,41.905),(11.485,41.905),(11.485,41.735),(11.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,2.835),(73.715,3.005),(73.885,3.005),(73.885,2.835),(73.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.195),(73.715,3.365),(73.885,3.365),(73.885,3.195),(73.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.555),(73.715,3.725),(73.885,3.725),(73.885,3.555),(73.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.915),(73.715,4.085),(73.885,4.085),(73.885,3.915),(73.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.275),(73.715,4.445),(73.885,4.445),(73.885,4.275),(73.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.635),(73.715,4.805),(73.885,4.805),(73.885,4.635),(73.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.995),(73.715,5.165),(73.885,5.165),(73.885,4.995),(73.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.355),(73.715,5.525),(73.885,5.525),(73.885,5.355),(73.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.715),(73.715,5.885),(73.885,5.885),(73.885,5.715),(73.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.075),(73.715,6.245),(73.885,6.245),(73.885,6.075),(73.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.435),(73.715,6.605),(73.885,6.605),(73.885,6.435),(73.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.795),(73.715,6.965),(73.885,6.965),(73.885,6.795),(73.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.155),(73.715,7.325),(73.885,7.325),(73.885,7.155),(73.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.515),(73.715,7.685),(73.885,7.685),(73.885,7.515),(73.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.875),(73.715,8.045),(73.885,8.045),(73.885,7.875),(73.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.235),(73.715,8.405),(73.885,8.405),(73.885,8.235),(73.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.595),(73.715,8.765),(73.885,8.765),(73.885,8.595),(73.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.955),(73.715,9.125),(73.885,9.125),(73.885,8.955),(73.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.315),(73.715,9.485),(73.885,9.485),(73.885,9.315),(73.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.675),(73.715,9.845),(73.885,9.845),(73.885,9.675),(73.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.035),(73.715,10.205),(73.885,10.205),(73.885,10.035),(73.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.395),(73.715,10.565),(73.885,10.565),(73.885,10.395),(73.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.755),(73.715,10.925),(73.885,10.925),(73.885,10.755),(73.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.115),(73.715,11.285),(73.885,11.285),(73.885,11.115),(73.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.475),(73.715,11.645),(73.885,11.645),(73.885,11.475),(73.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.835),(73.715,12.005),(73.885,12.005),(73.885,11.835),(73.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.195),(73.715,12.365),(73.885,12.365),(73.885,12.195),(73.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.555),(73.715,12.725),(73.885,12.725),(73.885,12.555),(73.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.915),(73.715,13.085),(73.885,13.085),(73.885,12.915),(73.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.275),(73.715,13.445),(73.885,13.445),(73.885,13.275),(73.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.635),(73.715,13.805),(73.885,13.805),(73.885,13.635),(73.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.995),(73.715,14.165),(73.885,14.165),(73.885,13.995),(73.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.355),(73.715,14.525),(73.885,14.525),(73.885,14.355),(73.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.715),(73.715,14.885),(73.885,14.885),(73.885,14.715),(73.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.075),(73.715,15.245),(73.885,15.245),(73.885,15.075),(73.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.435),(73.715,15.605),(73.885,15.605),(73.885,15.435),(73.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.795),(73.715,15.965),(73.885,15.965),(73.885,15.795),(73.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.155),(73.715,16.325),(73.885,16.325),(73.885,16.155),(73.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.515),(73.715,16.685),(73.885,16.685),(73.885,16.515),(73.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.875),(73.715,17.045),(73.885,17.045),(73.885,16.875),(73.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.235),(73.715,17.405),(73.885,17.405),(73.885,17.235),(73.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.595),(73.715,17.765),(73.885,17.765),(73.885,17.595),(73.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.955),(73.715,18.125),(73.885,18.125),(73.885,17.955),(73.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.315),(73.715,18.485),(73.885,18.485),(73.885,18.315),(73.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.675),(73.715,18.845),(73.885,18.845),(73.885,18.675),(73.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.035),(73.715,19.205),(73.885,19.205),(73.885,19.035),(73.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.395),(73.715,19.565),(73.885,19.565),(73.885,19.395),(73.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.755),(73.715,19.925),(73.885,19.925),(73.885,19.755),(73.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.115),(73.715,20.285),(73.885,20.285),(73.885,20.115),(73.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.475),(73.715,20.645),(73.885,20.645),(73.885,20.475),(73.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.835),(73.715,21.005),(73.885,21.005),(73.885,20.835),(73.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,21.195),(73.715,21.365),(73.885,21.365),(73.885,21.195),(73.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,21.555),(73.715,21.725),(73.885,21.725),(73.885,21.555),(73.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,21.915),(73.715,22.085),(73.885,22.085),(73.885,21.915),(73.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,22.275),(73.715,22.445),(73.885,22.445),(73.885,22.275),(73.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,22.635),(73.715,22.805),(73.885,22.805),(73.885,22.635),(73.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,22.995),(73.715,23.165),(73.885,23.165),(73.885,22.995),(73.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,23.355),(73.715,23.525),(73.885,23.525),(73.885,23.355),(73.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,23.715),(73.715,23.885),(73.885,23.885),(73.885,23.715),(73.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,24.075),(73.715,24.245),(73.885,24.245),(73.885,24.075),(73.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,24.435),(73.715,24.605),(73.885,24.605),(73.885,24.435),(73.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,24.795),(73.715,24.965),(73.885,24.965),(73.885,24.795),(73.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,25.155),(73.715,25.325),(73.885,25.325),(73.885,25.155),(73.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,25.515),(73.715,25.685),(73.885,25.685),(73.885,25.515),(73.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,25.875),(73.715,26.045),(73.885,26.045),(73.885,25.875),(73.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,26.235),(73.715,26.405),(73.885,26.405),(73.885,26.235),(73.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,26.595),(73.715,26.765),(73.885,26.765),(73.885,26.595),(73.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,26.955),(73.715,27.125),(73.885,27.125),(73.885,26.955),(73.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,27.315),(73.715,27.485),(73.885,27.485),(73.885,27.315),(73.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,27.675),(73.715,27.845),(73.885,27.845),(73.885,27.675),(73.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,28.035),(73.715,28.205),(73.885,28.205),(73.885,28.035),(73.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,28.395),(73.715,28.565),(73.885,28.565),(73.885,28.395),(73.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,28.755),(73.715,28.925),(73.885,28.925),(73.885,28.755),(73.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,29.115),(73.715,29.285),(73.885,29.285),(73.885,29.115),(73.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,29.475),(73.715,29.645),(73.885,29.645),(73.885,29.475),(73.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,29.835),(73.715,30.005),(73.885,30.005),(73.885,29.835),(73.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,30.195),(73.715,30.365),(73.885,30.365),(73.885,30.195),(73.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,30.555),(73.715,30.725),(73.885,30.725),(73.885,30.555),(73.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,30.915),(73.715,31.085),(73.885,31.085),(73.885,30.915),(73.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,31.275),(73.715,31.445),(73.885,31.445),(73.885,31.275),(73.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,31.635),(73.715,31.805),(73.885,31.805),(73.885,31.635),(73.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,31.995),(73.715,32.165),(73.885,32.165),(73.885,31.995),(73.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,32.355),(73.715,32.525),(73.885,32.525),(73.885,32.355),(73.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,32.715),(73.715,32.885),(73.885,32.885),(73.885,32.715),(73.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,33.075),(73.715,33.245),(73.885,33.245),(73.885,33.075),(73.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,33.435),(73.715,33.605),(73.885,33.605),(73.885,33.435),(73.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,33.795),(73.715,33.965),(73.885,33.965),(73.885,33.795),(73.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,34.155),(73.715,34.325),(73.885,34.325),(73.885,34.155),(73.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,34.515),(73.715,34.685),(73.885,34.685),(73.885,34.515),(73.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,34.875),(73.715,35.045),(73.885,35.045),(73.885,34.875),(73.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,35.235),(73.715,35.405),(73.885,35.405),(73.885,35.235),(73.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,35.595),(73.715,35.765),(73.885,35.765),(73.885,35.595),(73.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,35.955),(73.715,36.125),(73.885,36.125),(73.885,35.955),(73.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,36.315),(73.715,36.485),(73.885,36.485),(73.885,36.315),(73.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,36.675),(73.715,36.845),(73.885,36.845),(73.885,36.675),(73.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,37.035),(73.715,37.205),(73.885,37.205),(73.885,37.035),(73.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,37.395),(73.715,37.565),(73.885,37.565),(73.885,37.395),(73.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,37.755),(73.715,37.925),(73.885,37.925),(73.885,37.755),(73.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,38.115),(73.715,38.285),(73.885,38.285),(73.885,38.115),(73.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,38.475),(73.715,38.645),(73.885,38.645),(73.885,38.475),(73.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,38.835),(73.715,39.005),(73.885,39.005),(73.885,38.835),(73.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,39.195),(73.715,39.365),(73.885,39.365),(73.885,39.195),(73.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,39.555),(73.715,39.725),(73.885,39.725),(73.885,39.555),(73.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,39.915),(73.715,40.085),(73.885,40.085),(73.885,39.915),(73.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,40.275),(73.715,40.445),(73.885,40.445),(73.885,40.275),(73.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,40.635),(73.715,40.805),(73.885,40.805),(73.885,40.635),(73.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,41.735),(16.115,41.905),(16.285,41.905),(16.285,41.735),(16.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,41.735),(49.715,41.905),(49.885,41.905),(49.885,41.735),(49.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,1.735),(85.58,1.905),(85.75,1.905),(85.75,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,1.735),(85.94,1.905),(86.11,1.905),(86.11,1.735),(85.94,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,2.835),(68.915,3.005),(69.085,3.005),(69.085,2.835),(68.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.195),(68.915,3.365),(69.085,3.365),(69.085,3.195),(68.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.555),(68.915,3.725),(69.085,3.725),(69.085,3.555),(68.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.915),(68.915,4.085),(69.085,4.085),(69.085,3.915),(68.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.275),(68.915,4.445),(69.085,4.445),(69.085,4.275),(68.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.635),(68.915,4.805),(69.085,4.805),(69.085,4.635),(68.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.995),(68.915,5.165),(69.085,5.165),(69.085,4.995),(68.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.355),(68.915,5.525),(69.085,5.525),(69.085,5.355),(68.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.715),(68.915,5.885),(69.085,5.885),(69.085,5.715),(68.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.075),(68.915,6.245),(69.085,6.245),(69.085,6.075),(68.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.435),(68.915,6.605),(69.085,6.605),(69.085,6.435),(68.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.795),(68.915,6.965),(69.085,6.965),(69.085,6.795),(68.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.155),(68.915,7.325),(69.085,7.325),(69.085,7.155),(68.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.515),(68.915,7.685),(69.085,7.685),(69.085,7.515),(68.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.875),(68.915,8.045),(69.085,8.045),(69.085,7.875),(68.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.235),(68.915,8.405),(69.085,8.405),(69.085,8.235),(68.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.595),(68.915,8.765),(69.085,8.765),(69.085,8.595),(68.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.955),(68.915,9.125),(69.085,9.125),(69.085,8.955),(68.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.315),(68.915,9.485),(69.085,9.485),(69.085,9.315),(68.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.675),(68.915,9.845),(69.085,9.845),(69.085,9.675),(68.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.035),(68.915,10.205),(69.085,10.205),(69.085,10.035),(68.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.395),(68.915,10.565),(69.085,10.565),(69.085,10.395),(68.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.755),(68.915,10.925),(69.085,10.925),(69.085,10.755),(68.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.115),(68.915,11.285),(69.085,11.285),(69.085,11.115),(68.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.475),(68.915,11.645),(69.085,11.645),(69.085,11.475),(68.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.835),(68.915,12.005),(69.085,12.005),(69.085,11.835),(68.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.195),(68.915,12.365),(69.085,12.365),(69.085,12.195),(68.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.555),(68.915,12.725),(69.085,12.725),(69.085,12.555),(68.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.915),(68.915,13.085),(69.085,13.085),(69.085,12.915),(68.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.275),(68.915,13.445),(69.085,13.445),(69.085,13.275),(68.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.635),(68.915,13.805),(69.085,13.805),(69.085,13.635),(68.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.995),(68.915,14.165),(69.085,14.165),(69.085,13.995),(68.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.355),(68.915,14.525),(69.085,14.525),(69.085,14.355),(68.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.715),(68.915,14.885),(69.085,14.885),(69.085,14.715),(68.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.075),(68.915,15.245),(69.085,15.245),(69.085,15.075),(68.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.435),(68.915,15.605),(69.085,15.605),(69.085,15.435),(68.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.795),(68.915,15.965),(69.085,15.965),(69.085,15.795),(68.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.155),(68.915,16.325),(69.085,16.325),(69.085,16.155),(68.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.515),(68.915,16.685),(69.085,16.685),(69.085,16.515),(68.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.875),(68.915,17.045),(69.085,17.045),(69.085,16.875),(68.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.235),(68.915,17.405),(69.085,17.405),(69.085,17.235),(68.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.595),(68.915,17.765),(69.085,17.765),(69.085,17.595),(68.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.955),(68.915,18.125),(69.085,18.125),(69.085,17.955),(68.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.315),(68.915,18.485),(69.085,18.485),(69.085,18.315),(68.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.675),(68.915,18.845),(69.085,18.845),(69.085,18.675),(68.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.035),(68.915,19.205),(69.085,19.205),(69.085,19.035),(68.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.395),(68.915,19.565),(69.085,19.565),(69.085,19.395),(68.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.755),(68.915,19.925),(69.085,19.925),(69.085,19.755),(68.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.115),(68.915,20.285),(69.085,20.285),(69.085,20.115),(68.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.475),(68.915,20.645),(69.085,20.645),(69.085,20.475),(68.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.835),(68.915,21.005),(69.085,21.005),(69.085,20.835),(68.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,21.195),(68.915,21.365),(69.085,21.365),(69.085,21.195),(68.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,21.555),(68.915,21.725),(69.085,21.725),(69.085,21.555),(68.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,21.915),(68.915,22.085),(69.085,22.085),(69.085,21.915),(68.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,22.275),(68.915,22.445),(69.085,22.445),(69.085,22.275),(68.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,22.635),(68.915,22.805),(69.085,22.805),(69.085,22.635),(68.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,22.995),(68.915,23.165),(69.085,23.165),(69.085,22.995),(68.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,23.355),(68.915,23.525),(69.085,23.525),(69.085,23.355),(68.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,23.715),(68.915,23.885),(69.085,23.885),(69.085,23.715),(68.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,24.075),(68.915,24.245),(69.085,24.245),(69.085,24.075),(68.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,24.435),(68.915,24.605),(69.085,24.605),(69.085,24.435),(68.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,24.795),(68.915,24.965),(69.085,24.965),(69.085,24.795),(68.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,25.155),(68.915,25.325),(69.085,25.325),(69.085,25.155),(68.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,25.515),(68.915,25.685),(69.085,25.685),(69.085,25.515),(68.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,25.875),(68.915,26.045),(69.085,26.045),(69.085,25.875),(68.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,26.235),(68.915,26.405),(69.085,26.405),(69.085,26.235),(68.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,26.595),(68.915,26.765),(69.085,26.765),(69.085,26.595),(68.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,26.955),(68.915,27.125),(69.085,27.125),(69.085,26.955),(68.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,27.315),(68.915,27.485),(69.085,27.485),(69.085,27.315),(68.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,27.675),(68.915,27.845),(69.085,27.845),(69.085,27.675),(68.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,28.035),(68.915,28.205),(69.085,28.205),(69.085,28.035),(68.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,28.395),(68.915,28.565),(69.085,28.565),(69.085,28.395),(68.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,28.755),(68.915,28.925),(69.085,28.925),(69.085,28.755),(68.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,29.115),(68.915,29.285),(69.085,29.285),(69.085,29.115),(68.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,29.475),(68.915,29.645),(69.085,29.645),(69.085,29.475),(68.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,29.835),(68.915,30.005),(69.085,30.005),(69.085,29.835),(68.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,30.195),(68.915,30.365),(69.085,30.365),(69.085,30.195),(68.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,30.555),(68.915,30.725),(69.085,30.725),(69.085,30.555),(68.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,30.915),(68.915,31.085),(69.085,31.085),(69.085,30.915),(68.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,31.275),(68.915,31.445),(69.085,31.445),(69.085,31.275),(68.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,31.635),(68.915,31.805),(69.085,31.805),(69.085,31.635),(68.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,31.995),(68.915,32.165),(69.085,32.165),(69.085,31.995),(68.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,32.355),(68.915,32.525),(69.085,32.525),(69.085,32.355),(68.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,32.715),(68.915,32.885),(69.085,32.885),(69.085,32.715),(68.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,33.075),(68.915,33.245),(69.085,33.245),(69.085,33.075),(68.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,33.435),(68.915,33.605),(69.085,33.605),(69.085,33.435),(68.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,33.795),(68.915,33.965),(69.085,33.965),(69.085,33.795),(68.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,34.155),(68.915,34.325),(69.085,34.325),(69.085,34.155),(68.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,34.515),(68.915,34.685),(69.085,34.685),(69.085,34.515),(68.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,34.875),(68.915,35.045),(69.085,35.045),(69.085,34.875),(68.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,35.235),(68.915,35.405),(69.085,35.405),(69.085,35.235),(68.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,35.595),(68.915,35.765),(69.085,35.765),(69.085,35.595),(68.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,35.955),(68.915,36.125),(69.085,36.125),(69.085,35.955),(68.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,36.315),(68.915,36.485),(69.085,36.485),(69.085,36.315),(68.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,36.675),(68.915,36.845),(69.085,36.845),(69.085,36.675),(68.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,37.035),(68.915,37.205),(69.085,37.205),(69.085,37.035),(68.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,37.395),(68.915,37.565),(69.085,37.565),(69.085,37.395),(68.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,37.755),(68.915,37.925),(69.085,37.925),(69.085,37.755),(68.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,38.115),(68.915,38.285),(69.085,38.285),(69.085,38.115),(68.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,38.475),(68.915,38.645),(69.085,38.645),(69.085,38.475),(68.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,38.835),(68.915,39.005),(69.085,39.005),(69.085,38.835),(68.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,39.195),(68.915,39.365),(69.085,39.365),(69.085,39.195),(68.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,39.555),(68.915,39.725),(69.085,39.725),(69.085,39.555),(68.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,39.915),(68.915,40.085),(69.085,40.085),(69.085,39.915),(68.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,40.275),(68.915,40.445),(69.085,40.445),(69.085,40.275),(68.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,40.635),(68.915,40.805),(69.085,40.805),(69.085,40.635),(68.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,2.835),(20.915,3.005),(21.085,3.005),(21.085,2.835),(20.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.195),(20.915,3.365),(21.085,3.365),(21.085,3.195),(20.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.555),(20.915,3.725),(21.085,3.725),(21.085,3.555),(20.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.915),(20.915,4.085),(21.085,4.085),(21.085,3.915),(20.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.275),(20.915,4.445),(21.085,4.445),(21.085,4.275),(20.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.635),(20.915,4.805),(21.085,4.805),(21.085,4.635),(20.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.995),(20.915,5.165),(21.085,5.165),(21.085,4.995),(20.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.355),(20.915,5.525),(21.085,5.525),(21.085,5.355),(20.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.715),(20.915,5.885),(21.085,5.885),(21.085,5.715),(20.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.075),(20.915,6.245),(21.085,6.245),(21.085,6.075),(20.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.435),(20.915,6.605),(21.085,6.605),(21.085,6.435),(20.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.795),(20.915,6.965),(21.085,6.965),(21.085,6.795),(20.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.155),(20.915,7.325),(21.085,7.325),(21.085,7.155),(20.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.515),(20.915,7.685),(21.085,7.685),(21.085,7.515),(20.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.875),(20.915,8.045),(21.085,8.045),(21.085,7.875),(20.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.235),(20.915,8.405),(21.085,8.405),(21.085,8.235),(20.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.595),(20.915,8.765),(21.085,8.765),(21.085,8.595),(20.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.955),(20.915,9.125),(21.085,9.125),(21.085,8.955),(20.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.315),(20.915,9.485),(21.085,9.485),(21.085,9.315),(20.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.675),(20.915,9.845),(21.085,9.845),(21.085,9.675),(20.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.035),(20.915,10.205),(21.085,10.205),(21.085,10.035),(20.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.395),(20.915,10.565),(21.085,10.565),(21.085,10.395),(20.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.755),(20.915,10.925),(21.085,10.925),(21.085,10.755),(20.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.115),(20.915,11.285),(21.085,11.285),(21.085,11.115),(20.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.475),(20.915,11.645),(21.085,11.645),(21.085,11.475),(20.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.835),(20.915,12.005),(21.085,12.005),(21.085,11.835),(20.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.195),(20.915,12.365),(21.085,12.365),(21.085,12.195),(20.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.555),(20.915,12.725),(21.085,12.725),(21.085,12.555),(20.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.915),(20.915,13.085),(21.085,13.085),(21.085,12.915),(20.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.275),(20.915,13.445),(21.085,13.445),(21.085,13.275),(20.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.635),(20.915,13.805),(21.085,13.805),(21.085,13.635),(20.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.995),(20.915,14.165),(21.085,14.165),(21.085,13.995),(20.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.355),(20.915,14.525),(21.085,14.525),(21.085,14.355),(20.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.715),(20.915,14.885),(21.085,14.885),(21.085,14.715),(20.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.075),(20.915,15.245),(21.085,15.245),(21.085,15.075),(20.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.435),(20.915,15.605),(21.085,15.605),(21.085,15.435),(20.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.795),(20.915,15.965),(21.085,15.965),(21.085,15.795),(20.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.155),(20.915,16.325),(21.085,16.325),(21.085,16.155),(20.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.515),(20.915,16.685),(21.085,16.685),(21.085,16.515),(20.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.875),(20.915,17.045),(21.085,17.045),(21.085,16.875),(20.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.235),(20.915,17.405),(21.085,17.405),(21.085,17.235),(20.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.595),(20.915,17.765),(21.085,17.765),(21.085,17.595),(20.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.955),(20.915,18.125),(21.085,18.125),(21.085,17.955),(20.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.315),(20.915,18.485),(21.085,18.485),(21.085,18.315),(20.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.675),(20.915,18.845),(21.085,18.845),(21.085,18.675),(20.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.035),(20.915,19.205),(21.085,19.205),(21.085,19.035),(20.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.395),(20.915,19.565),(21.085,19.565),(21.085,19.395),(20.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.755),(20.915,19.925),(21.085,19.925),(21.085,19.755),(20.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.115),(20.915,20.285),(21.085,20.285),(21.085,20.115),(20.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.475),(20.915,20.645),(21.085,20.645),(21.085,20.475),(20.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.835),(20.915,21.005),(21.085,21.005),(21.085,20.835),(20.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,21.195),(20.915,21.365),(21.085,21.365),(21.085,21.195),(20.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,21.555),(20.915,21.725),(21.085,21.725),(21.085,21.555),(20.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,21.915),(20.915,22.085),(21.085,22.085),(21.085,21.915),(20.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,22.275),(20.915,22.445),(21.085,22.445),(21.085,22.275),(20.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,22.635),(20.915,22.805),(21.085,22.805),(21.085,22.635),(20.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,22.995),(20.915,23.165),(21.085,23.165),(21.085,22.995),(20.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,23.355),(20.915,23.525),(21.085,23.525),(21.085,23.355),(20.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,23.715),(20.915,23.885),(21.085,23.885),(21.085,23.715),(20.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,24.075),(20.915,24.245),(21.085,24.245),(21.085,24.075),(20.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,24.435),(20.915,24.605),(21.085,24.605),(21.085,24.435),(20.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,24.795),(20.915,24.965),(21.085,24.965),(21.085,24.795),(20.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,25.155),(20.915,25.325),(21.085,25.325),(21.085,25.155),(20.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,25.515),(20.915,25.685),(21.085,25.685),(21.085,25.515),(20.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,25.875),(20.915,26.045),(21.085,26.045),(21.085,25.875),(20.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,26.235),(20.915,26.405),(21.085,26.405),(21.085,26.235),(20.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,26.595),(20.915,26.765),(21.085,26.765),(21.085,26.595),(20.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,26.955),(20.915,27.125),(21.085,27.125),(21.085,26.955),(20.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,27.315),(20.915,27.485),(21.085,27.485),(21.085,27.315),(20.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,27.675),(20.915,27.845),(21.085,27.845),(21.085,27.675),(20.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,28.035),(20.915,28.205),(21.085,28.205),(21.085,28.035),(20.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,28.395),(20.915,28.565),(21.085,28.565),(21.085,28.395),(20.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,28.755),(20.915,28.925),(21.085,28.925),(21.085,28.755),(20.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,29.115),(20.915,29.285),(21.085,29.285),(21.085,29.115),(20.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,29.475),(20.915,29.645),(21.085,29.645),(21.085,29.475),(20.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,29.835),(20.915,30.005),(21.085,30.005),(21.085,29.835),(20.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,30.195),(20.915,30.365),(21.085,30.365),(21.085,30.195),(20.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,30.555),(20.915,30.725),(21.085,30.725),(21.085,30.555),(20.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,30.915),(20.915,31.085),(21.085,31.085),(21.085,30.915),(20.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,31.275),(20.915,31.445),(21.085,31.445),(21.085,31.275),(20.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,31.635),(20.915,31.805),(21.085,31.805),(21.085,31.635),(20.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,31.995),(20.915,32.165),(21.085,32.165),(21.085,31.995),(20.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,32.355),(20.915,32.525),(21.085,32.525),(21.085,32.355),(20.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,32.715),(20.915,32.885),(21.085,32.885),(21.085,32.715),(20.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,33.075),(20.915,33.245),(21.085,33.245),(21.085,33.075),(20.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,33.435),(20.915,33.605),(21.085,33.605),(21.085,33.435),(20.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,33.795),(20.915,33.965),(21.085,33.965),(21.085,33.795),(20.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,34.155),(20.915,34.325),(21.085,34.325),(21.085,34.155),(20.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,34.515),(20.915,34.685),(21.085,34.685),(21.085,34.515),(20.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,34.875),(20.915,35.045),(21.085,35.045),(21.085,34.875),(20.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,35.235),(20.915,35.405),(21.085,35.405),(21.085,35.235),(20.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,35.595),(20.915,35.765),(21.085,35.765),(21.085,35.595),(20.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,35.955),(20.915,36.125),(21.085,36.125),(21.085,35.955),(20.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,36.315),(20.915,36.485),(21.085,36.485),(21.085,36.315),(20.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,36.675),(20.915,36.845),(21.085,36.845),(21.085,36.675),(20.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,37.035),(20.915,37.205),(21.085,37.205),(21.085,37.035),(20.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,37.395),(20.915,37.565),(21.085,37.565),(21.085,37.395),(20.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,37.755),(20.915,37.925),(21.085,37.925),(21.085,37.755),(20.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,38.115),(20.915,38.285),(21.085,38.285),(21.085,38.115),(20.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,38.475),(20.915,38.645),(21.085,38.645),(21.085,38.475),(20.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,38.835),(20.915,39.005),(21.085,39.005),(21.085,38.835),(20.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,39.195),(20.915,39.365),(21.085,39.365),(21.085,39.195),(20.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,39.555),(20.915,39.725),(21.085,39.725),(21.085,39.555),(20.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,39.915),(20.915,40.085),(21.085,40.085),(21.085,39.915),(20.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,40.275),(20.915,40.445),(21.085,40.445),(21.085,40.275),(20.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,40.635),(20.915,40.805),(21.085,40.805),(21.085,40.635),(20.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,41.735),(40.115,41.905),(40.285,41.905),(40.285,41.735),(40.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,21.44),(85.58,21.61),(85.75,21.61),(85.75,21.44),(85.58,21.44)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,21.44),(85.94,21.61),(86.11,21.61),(86.11,21.44),(85.94,21.44)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,41.735),(73.715,41.905),(73.885,41.905),(73.885,41.735),(73.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,41.735),(20.915,41.905),(21.085,41.905),(21.085,41.735),(20.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,41.735),(30.515,41.905),(30.685,41.905),(30.685,41.735),(30.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.835),(49.715,3.005),(49.885,3.005),(49.885,2.835),(49.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.195),(49.715,3.365),(49.885,3.365),(49.885,3.195),(49.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.555),(49.715,3.725),(49.885,3.725),(49.885,3.555),(49.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.915),(49.715,4.085),(49.885,4.085),(49.885,3.915),(49.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.275),(49.715,4.445),(49.885,4.445),(49.885,4.275),(49.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.635),(49.715,4.805),(49.885,4.805),(49.885,4.635),(49.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.995),(49.715,5.165),(49.885,5.165),(49.885,4.995),(49.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.355),(49.715,5.525),(49.885,5.525),(49.885,5.355),(49.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.715),(49.715,5.885),(49.885,5.885),(49.885,5.715),(49.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.075),(49.715,6.245),(49.885,6.245),(49.885,6.075),(49.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.435),(49.715,6.605),(49.885,6.605),(49.885,6.435),(49.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.795),(49.715,6.965),(49.885,6.965),(49.885,6.795),(49.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.155),(49.715,7.325),(49.885,7.325),(49.885,7.155),(49.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.515),(49.715,7.685),(49.885,7.685),(49.885,7.515),(49.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.875),(49.715,8.045),(49.885,8.045),(49.885,7.875),(49.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.235),(49.715,8.405),(49.885,8.405),(49.885,8.235),(49.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.595),(49.715,8.765),(49.885,8.765),(49.885,8.595),(49.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.955),(49.715,9.125),(49.885,9.125),(49.885,8.955),(49.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.315),(49.715,9.485),(49.885,9.485),(49.885,9.315),(49.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.675),(49.715,9.845),(49.885,9.845),(49.885,9.675),(49.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.035),(49.715,10.205),(49.885,10.205),(49.885,10.035),(49.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.395),(49.715,10.565),(49.885,10.565),(49.885,10.395),(49.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.755),(49.715,10.925),(49.885,10.925),(49.885,10.755),(49.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.115),(49.715,11.285),(49.885,11.285),(49.885,11.115),(49.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.475),(49.715,11.645),(49.885,11.645),(49.885,11.475),(49.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.835),(49.715,12.005),(49.885,12.005),(49.885,11.835),(49.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.195),(49.715,12.365),(49.885,12.365),(49.885,12.195),(49.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.555),(49.715,12.725),(49.885,12.725),(49.885,12.555),(49.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.915),(49.715,13.085),(49.885,13.085),(49.885,12.915),(49.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.275),(49.715,13.445),(49.885,13.445),(49.885,13.275),(49.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.635),(49.715,13.805),(49.885,13.805),(49.885,13.635),(49.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.995),(49.715,14.165),(49.885,14.165),(49.885,13.995),(49.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.355),(49.715,14.525),(49.885,14.525),(49.885,14.355),(49.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.715),(49.715,14.885),(49.885,14.885),(49.885,14.715),(49.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.075),(49.715,15.245),(49.885,15.245),(49.885,15.075),(49.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.435),(49.715,15.605),(49.885,15.605),(49.885,15.435),(49.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.795),(49.715,15.965),(49.885,15.965),(49.885,15.795),(49.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.155),(49.715,16.325),(49.885,16.325),(49.885,16.155),(49.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.515),(49.715,16.685),(49.885,16.685),(49.885,16.515),(49.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.875),(49.715,17.045),(49.885,17.045),(49.885,16.875),(49.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.235),(49.715,17.405),(49.885,17.405),(49.885,17.235),(49.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.595),(49.715,17.765),(49.885,17.765),(49.885,17.595),(49.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.955),(49.715,18.125),(49.885,18.125),(49.885,17.955),(49.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.315),(49.715,18.485),(49.885,18.485),(49.885,18.315),(49.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.675),(49.715,18.845),(49.885,18.845),(49.885,18.675),(49.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.035),(49.715,19.205),(49.885,19.205),(49.885,19.035),(49.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.395),(49.715,19.565),(49.885,19.565),(49.885,19.395),(49.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.755),(49.715,19.925),(49.885,19.925),(49.885,19.755),(49.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.115),(49.715,20.285),(49.885,20.285),(49.885,20.115),(49.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.475),(49.715,20.645),(49.885,20.645),(49.885,20.475),(49.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.835),(49.715,21.005),(49.885,21.005),(49.885,20.835),(49.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.195),(49.715,21.365),(49.885,21.365),(49.885,21.195),(49.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.555),(49.715,21.725),(49.885,21.725),(49.885,21.555),(49.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.915),(49.715,22.085),(49.885,22.085),(49.885,21.915),(49.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.275),(49.715,22.445),(49.885,22.445),(49.885,22.275),(49.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.635),(49.715,22.805),(49.885,22.805),(49.885,22.635),(49.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.995),(49.715,23.165),(49.885,23.165),(49.885,22.995),(49.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,23.355),(49.715,23.525),(49.885,23.525),(49.885,23.355),(49.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,23.715),(49.715,23.885),(49.885,23.885),(49.885,23.715),(49.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.075),(49.715,24.245),(49.885,24.245),(49.885,24.075),(49.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.435),(49.715,24.605),(49.885,24.605),(49.885,24.435),(49.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.795),(49.715,24.965),(49.885,24.965),(49.885,24.795),(49.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.155),(49.715,25.325),(49.885,25.325),(49.885,25.155),(49.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.515),(49.715,25.685),(49.885,25.685),(49.885,25.515),(49.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.875),(49.715,26.045),(49.885,26.045),(49.885,25.875),(49.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.235),(49.715,26.405),(49.885,26.405),(49.885,26.235),(49.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.595),(49.715,26.765),(49.885,26.765),(49.885,26.595),(49.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.955),(49.715,27.125),(49.885,27.125),(49.885,26.955),(49.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,27.315),(49.715,27.485),(49.885,27.485),(49.885,27.315),(49.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,27.675),(49.715,27.845),(49.885,27.845),(49.885,27.675),(49.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.035),(49.715,28.205),(49.885,28.205),(49.885,28.035),(49.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.395),(49.715,28.565),(49.885,28.565),(49.885,28.395),(49.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.755),(49.715,28.925),(49.885,28.925),(49.885,28.755),(49.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.115),(49.715,29.285),(49.885,29.285),(49.885,29.115),(49.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.475),(49.715,29.645),(49.885,29.645),(49.885,29.475),(49.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.835),(49.715,30.005),(49.885,30.005),(49.885,29.835),(49.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.195),(49.715,30.365),(49.885,30.365),(49.885,30.195),(49.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.555),(49.715,30.725),(49.885,30.725),(49.885,30.555),(49.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.915),(49.715,31.085),(49.885,31.085),(49.885,30.915),(49.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.275),(49.715,31.445),(49.885,31.445),(49.885,31.275),(49.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.635),(49.715,31.805),(49.885,31.805),(49.885,31.635),(49.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.995),(49.715,32.165),(49.885,32.165),(49.885,31.995),(49.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,32.355),(49.715,32.525),(49.885,32.525),(49.885,32.355),(49.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,32.715),(49.715,32.885),(49.885,32.885),(49.885,32.715),(49.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.075),(49.715,33.245),(49.885,33.245),(49.885,33.075),(49.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.435),(49.715,33.605),(49.885,33.605),(49.885,33.435),(49.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.795),(49.715,33.965),(49.885,33.965),(49.885,33.795),(49.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.155),(49.715,34.325),(49.885,34.325),(49.885,34.155),(49.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.515),(49.715,34.685),(49.885,34.685),(49.885,34.515),(49.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.875),(49.715,35.045),(49.885,35.045),(49.885,34.875),(49.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.235),(49.715,35.405),(49.885,35.405),(49.885,35.235),(49.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.595),(49.715,35.765),(49.885,35.765),(49.885,35.595),(49.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.955),(49.715,36.125),(49.885,36.125),(49.885,35.955),(49.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,36.315),(49.715,36.485),(49.885,36.485),(49.885,36.315),(49.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,36.675),(49.715,36.845),(49.885,36.845),(49.885,36.675),(49.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.035),(49.715,37.205),(49.885,37.205),(49.885,37.035),(49.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.395),(49.715,37.565),(49.885,37.565),(49.885,37.395),(49.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.755),(49.715,37.925),(49.885,37.925),(49.885,37.755),(49.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.115),(49.715,38.285),(49.885,38.285),(49.885,38.115),(49.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.475),(49.715,38.645),(49.885,38.645),(49.885,38.475),(49.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.835),(49.715,39.005),(49.885,39.005),(49.885,38.835),(49.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.195),(49.715,39.365),(49.885,39.365),(49.885,39.195),(49.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.555),(49.715,39.725),(49.885,39.725),(49.885,39.555),(49.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.915),(49.715,40.085),(49.885,40.085),(49.885,39.915),(49.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,40.275),(49.715,40.445),(49.885,40.445),(49.885,40.275),(49.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,40.635),(49.715,40.805),(49.885,40.805),(49.885,40.635),(49.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,41.735),(35.315,41.905),(35.485,41.905),(35.485,41.735),(35.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,2.835),(6.77,3.005),(6.94,3.005),(6.94,2.835),(6.77,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.195),(6.77,3.365),(6.94,3.365),(6.94,3.195),(6.77,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.555),(6.77,3.725),(6.94,3.725),(6.94,3.555),(6.77,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.915),(6.77,4.085),(6.94,4.085),(6.94,3.915),(6.77,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.275),(6.77,4.445),(6.94,4.445),(6.94,4.275),(6.77,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.635),(6.77,4.805),(6.94,4.805),(6.94,4.635),(6.77,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.995),(6.77,5.165),(6.94,5.165),(6.94,4.995),(6.77,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.355),(6.77,5.525),(6.94,5.525),(6.94,5.355),(6.77,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.715),(6.77,5.885),(6.94,5.885),(6.94,5.715),(6.77,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.075),(6.77,6.245),(6.94,6.245),(6.94,6.075),(6.77,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.435),(6.77,6.605),(6.94,6.605),(6.94,6.435),(6.77,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.795),(6.77,6.965),(6.94,6.965),(6.94,6.795),(6.77,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.155),(6.77,7.325),(6.94,7.325),(6.94,7.155),(6.77,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.515),(6.77,7.685),(6.94,7.685),(6.94,7.515),(6.77,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.875),(6.77,8.045),(6.94,8.045),(6.94,7.875),(6.77,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.235),(6.77,8.405),(6.94,8.405),(6.94,8.235),(6.77,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.595),(6.77,8.765),(6.94,8.765),(6.94,8.595),(6.77,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.955),(6.77,9.125),(6.94,9.125),(6.94,8.955),(6.77,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.315),(6.77,9.485),(6.94,9.485),(6.94,9.315),(6.77,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.675),(6.77,9.845),(6.94,9.845),(6.94,9.675),(6.77,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.035),(6.77,10.205),(6.94,10.205),(6.94,10.035),(6.77,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.395),(6.77,10.565),(6.94,10.565),(6.94,10.395),(6.77,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.755),(6.77,10.925),(6.94,10.925),(6.94,10.755),(6.77,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.115),(6.77,11.285),(6.94,11.285),(6.94,11.115),(6.77,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.475),(6.77,11.645),(6.94,11.645),(6.94,11.475),(6.77,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.835),(6.77,12.005),(6.94,12.005),(6.94,11.835),(6.77,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.195),(6.77,12.365),(6.94,12.365),(6.94,12.195),(6.77,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.555),(6.77,12.725),(6.94,12.725),(6.94,12.555),(6.77,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.915),(6.77,13.085),(6.94,13.085),(6.94,12.915),(6.77,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.275),(6.77,13.445),(6.94,13.445),(6.94,13.275),(6.77,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.635),(6.77,13.805),(6.94,13.805),(6.94,13.635),(6.77,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.995),(6.77,14.165),(6.94,14.165),(6.94,13.995),(6.77,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.355),(6.77,14.525),(6.94,14.525),(6.94,14.355),(6.77,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.715),(6.77,14.885),(6.94,14.885),(6.94,14.715),(6.77,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.075),(6.77,15.245),(6.94,15.245),(6.94,15.075),(6.77,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.435),(6.77,15.605),(6.94,15.605),(6.94,15.435),(6.77,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.795),(6.77,15.965),(6.94,15.965),(6.94,15.795),(6.77,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.155),(6.77,16.325),(6.94,16.325),(6.94,16.155),(6.77,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.515),(6.77,16.685),(6.94,16.685),(6.94,16.515),(6.77,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.875),(6.77,17.045),(6.94,17.045),(6.94,16.875),(6.77,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.235),(6.77,17.405),(6.94,17.405),(6.94,17.235),(6.77,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.595),(6.77,17.765),(6.94,17.765),(6.94,17.595),(6.77,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.955),(6.77,18.125),(6.94,18.125),(6.94,17.955),(6.77,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.315),(6.77,18.485),(6.94,18.485),(6.94,18.315),(6.77,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.675),(6.77,18.845),(6.94,18.845),(6.94,18.675),(6.77,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.035),(6.77,19.205),(6.94,19.205),(6.94,19.035),(6.77,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.395),(6.77,19.565),(6.94,19.565),(6.94,19.395),(6.77,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.755),(6.77,19.925),(6.94,19.925),(6.94,19.755),(6.77,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.115),(6.77,20.285),(6.94,20.285),(6.94,20.115),(6.77,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.475),(6.77,20.645),(6.94,20.645),(6.94,20.475),(6.77,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.835),(6.77,21.005),(6.94,21.005),(6.94,20.835),(6.77,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,21.195),(6.77,21.365),(6.94,21.365),(6.94,21.195),(6.77,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,21.555),(6.77,21.725),(6.94,21.725),(6.94,21.555),(6.77,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,21.915),(6.77,22.085),(6.94,22.085),(6.94,21.915),(6.77,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,22.275),(6.77,22.445),(6.94,22.445),(6.94,22.275),(6.77,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,22.635),(6.77,22.805),(6.94,22.805),(6.94,22.635),(6.77,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,22.995),(6.77,23.165),(6.94,23.165),(6.94,22.995),(6.77,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,23.355),(6.77,23.525),(6.94,23.525),(6.94,23.355),(6.77,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,23.715),(6.77,23.885),(6.94,23.885),(6.94,23.715),(6.77,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,24.075),(6.77,24.245),(6.94,24.245),(6.94,24.075),(6.77,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,24.435),(6.77,24.605),(6.94,24.605),(6.94,24.435),(6.77,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,24.795),(6.77,24.965),(6.94,24.965),(6.94,24.795),(6.77,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,25.155),(6.77,25.325),(6.94,25.325),(6.94,25.155),(6.77,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,25.515),(6.77,25.685),(6.94,25.685),(6.94,25.515),(6.77,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,25.875),(6.77,26.045),(6.94,26.045),(6.94,25.875),(6.77,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,26.235),(6.77,26.405),(6.94,26.405),(6.94,26.235),(6.77,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,26.595),(6.77,26.765),(6.94,26.765),(6.94,26.595),(6.77,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,26.955),(6.77,27.125),(6.94,27.125),(6.94,26.955),(6.77,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,27.315),(6.77,27.485),(6.94,27.485),(6.94,27.315),(6.77,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,27.675),(6.77,27.845),(6.94,27.845),(6.94,27.675),(6.77,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,28.035),(6.77,28.205),(6.94,28.205),(6.94,28.035),(6.77,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,28.395),(6.77,28.565),(6.94,28.565),(6.94,28.395),(6.77,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,28.755),(6.77,28.925),(6.94,28.925),(6.94,28.755),(6.77,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,29.115),(6.77,29.285),(6.94,29.285),(6.94,29.115),(6.77,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,29.475),(6.77,29.645),(6.94,29.645),(6.94,29.475),(6.77,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,29.835),(6.77,30.005),(6.94,30.005),(6.94,29.835),(6.77,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,30.195),(6.77,30.365),(6.94,30.365),(6.94,30.195),(6.77,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,30.555),(6.77,30.725),(6.94,30.725),(6.94,30.555),(6.77,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,30.915),(6.77,31.085),(6.94,31.085),(6.94,30.915),(6.77,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,31.275),(6.77,31.445),(6.94,31.445),(6.94,31.275),(6.77,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,31.635),(6.77,31.805),(6.94,31.805),(6.94,31.635),(6.77,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,31.995),(6.77,32.165),(6.94,32.165),(6.94,31.995),(6.77,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,32.355),(6.77,32.525),(6.94,32.525),(6.94,32.355),(6.77,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,32.715),(6.77,32.885),(6.94,32.885),(6.94,32.715),(6.77,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,33.075),(6.77,33.245),(6.94,33.245),(6.94,33.075),(6.77,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,33.435),(6.77,33.605),(6.94,33.605),(6.94,33.435),(6.77,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,33.795),(6.77,33.965),(6.94,33.965),(6.94,33.795),(6.77,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,34.155),(6.77,34.325),(6.94,34.325),(6.94,34.155),(6.77,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,34.515),(6.77,34.685),(6.94,34.685),(6.94,34.515),(6.77,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,34.875),(6.77,35.045),(6.94,35.045),(6.94,34.875),(6.77,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,35.235),(6.77,35.405),(6.94,35.405),(6.94,35.235),(6.77,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,35.595),(6.77,35.765),(6.94,35.765),(6.94,35.595),(6.77,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,35.955),(6.77,36.125),(6.94,36.125),(6.94,35.955),(6.77,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,36.315),(6.77,36.485),(6.94,36.485),(6.94,36.315),(6.77,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,36.675),(6.77,36.845),(6.94,36.845),(6.94,36.675),(6.77,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,37.035),(6.77,37.205),(6.94,37.205),(6.94,37.035),(6.77,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,37.395),(6.77,37.565),(6.94,37.565),(6.94,37.395),(6.77,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,37.755),(6.77,37.925),(6.94,37.925),(6.94,37.755),(6.77,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,38.115),(6.77,38.285),(6.94,38.285),(6.94,38.115),(6.77,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,38.475),(6.77,38.645),(6.94,38.645),(6.94,38.475),(6.77,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,38.835),(6.77,39.005),(6.94,39.005),(6.94,38.835),(6.77,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,39.195),(6.77,39.365),(6.94,39.365),(6.94,39.195),(6.77,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,39.555),(6.77,39.725),(6.94,39.725),(6.94,39.555),(6.77,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,39.915),(6.77,40.085),(6.94,40.085),(6.94,39.915),(6.77,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,40.275),(6.77,40.445),(6.94,40.445),(6.94,40.275),(6.77,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,40.635),(6.77,40.805),(6.94,40.805),(6.94,40.635),(6.77,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,2.835),(83.06,3.005),(83.23,3.005),(83.23,2.835),(83.06,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.195),(83.06,3.365),(83.23,3.365),(83.23,3.195),(83.06,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.555),(83.06,3.725),(83.23,3.725),(83.23,3.555),(83.06,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.915),(83.06,4.085),(83.23,4.085),(83.23,3.915),(83.06,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.275),(83.06,4.445),(83.23,4.445),(83.23,4.275),(83.06,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.635),(83.06,4.805),(83.23,4.805),(83.23,4.635),(83.06,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.995),(83.06,5.165),(83.23,5.165),(83.23,4.995),(83.06,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.355),(83.06,5.525),(83.23,5.525),(83.23,5.355),(83.06,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.715),(83.06,5.885),(83.23,5.885),(83.23,5.715),(83.06,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.075),(83.06,6.245),(83.23,6.245),(83.23,6.075),(83.06,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.435),(83.06,6.605),(83.23,6.605),(83.23,6.435),(83.06,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.795),(83.06,6.965),(83.23,6.965),(83.23,6.795),(83.06,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.155),(83.06,7.325),(83.23,7.325),(83.23,7.155),(83.06,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.515),(83.06,7.685),(83.23,7.685),(83.23,7.515),(83.06,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.875),(83.06,8.045),(83.23,8.045),(83.23,7.875),(83.06,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.235),(83.06,8.405),(83.23,8.405),(83.23,8.235),(83.06,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.595),(83.06,8.765),(83.23,8.765),(83.23,8.595),(83.06,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.955),(83.06,9.125),(83.23,9.125),(83.23,8.955),(83.06,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.315),(83.06,9.485),(83.23,9.485),(83.23,9.315),(83.06,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.675),(83.06,9.845),(83.23,9.845),(83.23,9.675),(83.06,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.035),(83.06,10.205),(83.23,10.205),(83.23,10.035),(83.06,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.395),(83.06,10.565),(83.23,10.565),(83.23,10.395),(83.06,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.755),(83.06,10.925),(83.23,10.925),(83.23,10.755),(83.06,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.115),(83.06,11.285),(83.23,11.285),(83.23,11.115),(83.06,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.475),(83.06,11.645),(83.23,11.645),(83.23,11.475),(83.06,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.835),(83.06,12.005),(83.23,12.005),(83.23,11.835),(83.06,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.195),(83.06,12.365),(83.23,12.365),(83.23,12.195),(83.06,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.555),(83.06,12.725),(83.23,12.725),(83.23,12.555),(83.06,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.915),(83.06,13.085),(83.23,13.085),(83.23,12.915),(83.06,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.275),(83.06,13.445),(83.23,13.445),(83.23,13.275),(83.06,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.635),(83.06,13.805),(83.23,13.805),(83.23,13.635),(83.06,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.995),(83.06,14.165),(83.23,14.165),(83.23,13.995),(83.06,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.355),(83.06,14.525),(83.23,14.525),(83.23,14.355),(83.06,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.715),(83.06,14.885),(83.23,14.885),(83.23,14.715),(83.06,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.075),(83.06,15.245),(83.23,15.245),(83.23,15.075),(83.06,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.435),(83.06,15.605),(83.23,15.605),(83.23,15.435),(83.06,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.795),(83.06,15.965),(83.23,15.965),(83.23,15.795),(83.06,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.155),(83.06,16.325),(83.23,16.325),(83.23,16.155),(83.06,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.515),(83.06,16.685),(83.23,16.685),(83.23,16.515),(83.06,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.875),(83.06,17.045),(83.23,17.045),(83.23,16.875),(83.06,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.235),(83.06,17.405),(83.23,17.405),(83.23,17.235),(83.06,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.595),(83.06,17.765),(83.23,17.765),(83.23,17.595),(83.06,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.955),(83.06,18.125),(83.23,18.125),(83.23,17.955),(83.06,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.315),(83.06,18.485),(83.23,18.485),(83.23,18.315),(83.06,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.675),(83.06,18.845),(83.23,18.845),(83.23,18.675),(83.06,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.035),(83.06,19.205),(83.23,19.205),(83.23,19.035),(83.06,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.395),(83.06,19.565),(83.23,19.565),(83.23,19.395),(83.06,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.755),(83.06,19.925),(83.23,19.925),(83.23,19.755),(83.06,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.115),(83.06,20.285),(83.23,20.285),(83.23,20.115),(83.06,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.475),(83.06,20.645),(83.23,20.645),(83.23,20.475),(83.06,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.835),(83.06,21.005),(83.23,21.005),(83.23,20.835),(83.06,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,21.195),(83.06,21.365),(83.23,21.365),(83.23,21.195),(83.06,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,21.555),(83.06,21.725),(83.23,21.725),(83.23,21.555),(83.06,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,21.915),(83.06,22.085),(83.23,22.085),(83.23,21.915),(83.06,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,22.275),(83.06,22.445),(83.23,22.445),(83.23,22.275),(83.06,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,22.635),(83.06,22.805),(83.23,22.805),(83.23,22.635),(83.06,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,22.995),(83.06,23.165),(83.23,23.165),(83.23,22.995),(83.06,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,23.355),(83.06,23.525),(83.23,23.525),(83.23,23.355),(83.06,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,23.715),(83.06,23.885),(83.23,23.885),(83.23,23.715),(83.06,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,24.075),(83.06,24.245),(83.23,24.245),(83.23,24.075),(83.06,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,24.435),(83.06,24.605),(83.23,24.605),(83.23,24.435),(83.06,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,24.795),(83.06,24.965),(83.23,24.965),(83.23,24.795),(83.06,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,25.155),(83.06,25.325),(83.23,25.325),(83.23,25.155),(83.06,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,25.515),(83.06,25.685),(83.23,25.685),(83.23,25.515),(83.06,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,25.875),(83.06,26.045),(83.23,26.045),(83.23,25.875),(83.06,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,26.235),(83.06,26.405),(83.23,26.405),(83.23,26.235),(83.06,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,26.595),(83.06,26.765),(83.23,26.765),(83.23,26.595),(83.06,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,26.955),(83.06,27.125),(83.23,27.125),(83.23,26.955),(83.06,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,27.315),(83.06,27.485),(83.23,27.485),(83.23,27.315),(83.06,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,27.675),(83.06,27.845),(83.23,27.845),(83.23,27.675),(83.06,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,28.035),(83.06,28.205),(83.23,28.205),(83.23,28.035),(83.06,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,28.395),(83.06,28.565),(83.23,28.565),(83.23,28.395),(83.06,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,28.755),(83.06,28.925),(83.23,28.925),(83.23,28.755),(83.06,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,29.115),(83.06,29.285),(83.23,29.285),(83.23,29.115),(83.06,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,29.475),(83.06,29.645),(83.23,29.645),(83.23,29.475),(83.06,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,29.835),(83.06,30.005),(83.23,30.005),(83.23,29.835),(83.06,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,30.195),(83.06,30.365),(83.23,30.365),(83.23,30.195),(83.06,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,30.555),(83.06,30.725),(83.23,30.725),(83.23,30.555),(83.06,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,30.915),(83.06,31.085),(83.23,31.085),(83.23,30.915),(83.06,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,31.275),(83.06,31.445),(83.23,31.445),(83.23,31.275),(83.06,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,31.635),(83.06,31.805),(83.23,31.805),(83.23,31.635),(83.06,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,31.995),(83.06,32.165),(83.23,32.165),(83.23,31.995),(83.06,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,32.355),(83.06,32.525),(83.23,32.525),(83.23,32.355),(83.06,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,32.715),(83.06,32.885),(83.23,32.885),(83.23,32.715),(83.06,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,33.075),(83.06,33.245),(83.23,33.245),(83.23,33.075),(83.06,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,33.435),(83.06,33.605),(83.23,33.605),(83.23,33.435),(83.06,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,33.795),(83.06,33.965),(83.23,33.965),(83.23,33.795),(83.06,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,34.155),(83.06,34.325),(83.23,34.325),(83.23,34.155),(83.06,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,34.515),(83.06,34.685),(83.23,34.685),(83.23,34.515),(83.06,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,34.875),(83.06,35.045),(83.23,35.045),(83.23,34.875),(83.06,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,35.235),(83.06,35.405),(83.23,35.405),(83.23,35.235),(83.06,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,35.595),(83.06,35.765),(83.23,35.765),(83.23,35.595),(83.06,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,35.955),(83.06,36.125),(83.23,36.125),(83.23,35.955),(83.06,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,36.315),(83.06,36.485),(83.23,36.485),(83.23,36.315),(83.06,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,36.675),(83.06,36.845),(83.23,36.845),(83.23,36.675),(83.06,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,37.035),(83.06,37.205),(83.23,37.205),(83.23,37.035),(83.06,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,37.395),(83.06,37.565),(83.23,37.565),(83.23,37.395),(83.06,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,37.755),(83.06,37.925),(83.23,37.925),(83.23,37.755),(83.06,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,38.115),(83.06,38.285),(83.23,38.285),(83.23,38.115),(83.06,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,38.475),(83.06,38.645),(83.23,38.645),(83.23,38.475),(83.06,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,38.835),(83.06,39.005),(83.23,39.005),(83.23,38.835),(83.06,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,39.195),(83.06,39.365),(83.23,39.365),(83.23,39.195),(83.06,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,39.555),(83.06,39.725),(83.23,39.725),(83.23,39.555),(83.06,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,39.915),(83.06,40.085),(83.23,40.085),(83.23,39.915),(83.06,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,40.275),(83.06,40.445),(83.23,40.445),(83.23,40.275),(83.06,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,40.635),(83.06,40.805),(83.23,40.805),(83.23,40.635),(83.06,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.835),(54.515,3.005),(54.685,3.005),(54.685,2.835),(54.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.195),(54.515,3.365),(54.685,3.365),(54.685,3.195),(54.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.555),(54.515,3.725),(54.685,3.725),(54.685,3.555),(54.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.915),(54.515,4.085),(54.685,4.085),(54.685,3.915),(54.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.275),(54.515,4.445),(54.685,4.445),(54.685,4.275),(54.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.635),(54.515,4.805),(54.685,4.805),(54.685,4.635),(54.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.995),(54.515,5.165),(54.685,5.165),(54.685,4.995),(54.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.355),(54.515,5.525),(54.685,5.525),(54.685,5.355),(54.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.715),(54.515,5.885),(54.685,5.885),(54.685,5.715),(54.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.075),(54.515,6.245),(54.685,6.245),(54.685,6.075),(54.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.435),(54.515,6.605),(54.685,6.605),(54.685,6.435),(54.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.795),(54.515,6.965),(54.685,6.965),(54.685,6.795),(54.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.155),(54.515,7.325),(54.685,7.325),(54.685,7.155),(54.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.515),(54.515,7.685),(54.685,7.685),(54.685,7.515),(54.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.875),(54.515,8.045),(54.685,8.045),(54.685,7.875),(54.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.235),(54.515,8.405),(54.685,8.405),(54.685,8.235),(54.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.595),(54.515,8.765),(54.685,8.765),(54.685,8.595),(54.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.955),(54.515,9.125),(54.685,9.125),(54.685,8.955),(54.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.315),(54.515,9.485),(54.685,9.485),(54.685,9.315),(54.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.675),(54.515,9.845),(54.685,9.845),(54.685,9.675),(54.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.035),(54.515,10.205),(54.685,10.205),(54.685,10.035),(54.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.395),(54.515,10.565),(54.685,10.565),(54.685,10.395),(54.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.755),(54.515,10.925),(54.685,10.925),(54.685,10.755),(54.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.115),(54.515,11.285),(54.685,11.285),(54.685,11.115),(54.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.475),(54.515,11.645),(54.685,11.645),(54.685,11.475),(54.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.835),(54.515,12.005),(54.685,12.005),(54.685,11.835),(54.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.195),(54.515,12.365),(54.685,12.365),(54.685,12.195),(54.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.555),(54.515,12.725),(54.685,12.725),(54.685,12.555),(54.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.915),(54.515,13.085),(54.685,13.085),(54.685,12.915),(54.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.275),(54.515,13.445),(54.685,13.445),(54.685,13.275),(54.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.635),(54.515,13.805),(54.685,13.805),(54.685,13.635),(54.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.995),(54.515,14.165),(54.685,14.165),(54.685,13.995),(54.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.355),(54.515,14.525),(54.685,14.525),(54.685,14.355),(54.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.715),(54.515,14.885),(54.685,14.885),(54.685,14.715),(54.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.075),(54.515,15.245),(54.685,15.245),(54.685,15.075),(54.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.435),(54.515,15.605),(54.685,15.605),(54.685,15.435),(54.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.795),(54.515,15.965),(54.685,15.965),(54.685,15.795),(54.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.155),(54.515,16.325),(54.685,16.325),(54.685,16.155),(54.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.515),(54.515,16.685),(54.685,16.685),(54.685,16.515),(54.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.875),(54.515,17.045),(54.685,17.045),(54.685,16.875),(54.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.235),(54.515,17.405),(54.685,17.405),(54.685,17.235),(54.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.595),(54.515,17.765),(54.685,17.765),(54.685,17.595),(54.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.955),(54.515,18.125),(54.685,18.125),(54.685,17.955),(54.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.315),(54.515,18.485),(54.685,18.485),(54.685,18.315),(54.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.675),(54.515,18.845),(54.685,18.845),(54.685,18.675),(54.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.035),(54.515,19.205),(54.685,19.205),(54.685,19.035),(54.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.395),(54.515,19.565),(54.685,19.565),(54.685,19.395),(54.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.755),(54.515,19.925),(54.685,19.925),(54.685,19.755),(54.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.115),(54.515,20.285),(54.685,20.285),(54.685,20.115),(54.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.475),(54.515,20.645),(54.685,20.645),(54.685,20.475),(54.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.835),(54.515,21.005),(54.685,21.005),(54.685,20.835),(54.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.195),(54.515,21.365),(54.685,21.365),(54.685,21.195),(54.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.555),(54.515,21.725),(54.685,21.725),(54.685,21.555),(54.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.915),(54.515,22.085),(54.685,22.085),(54.685,21.915),(54.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.275),(54.515,22.445),(54.685,22.445),(54.685,22.275),(54.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.635),(54.515,22.805),(54.685,22.805),(54.685,22.635),(54.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.995),(54.515,23.165),(54.685,23.165),(54.685,22.995),(54.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,23.355),(54.515,23.525),(54.685,23.525),(54.685,23.355),(54.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,23.715),(54.515,23.885),(54.685,23.885),(54.685,23.715),(54.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.075),(54.515,24.245),(54.685,24.245),(54.685,24.075),(54.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.435),(54.515,24.605),(54.685,24.605),(54.685,24.435),(54.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.795),(54.515,24.965),(54.685,24.965),(54.685,24.795),(54.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.155),(54.515,25.325),(54.685,25.325),(54.685,25.155),(54.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.515),(54.515,25.685),(54.685,25.685),(54.685,25.515),(54.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.875),(54.515,26.045),(54.685,26.045),(54.685,25.875),(54.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.235),(54.515,26.405),(54.685,26.405),(54.685,26.235),(54.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.595),(54.515,26.765),(54.685,26.765),(54.685,26.595),(54.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.955),(54.515,27.125),(54.685,27.125),(54.685,26.955),(54.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,27.315),(54.515,27.485),(54.685,27.485),(54.685,27.315),(54.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,27.675),(54.515,27.845),(54.685,27.845),(54.685,27.675),(54.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.035),(54.515,28.205),(54.685,28.205),(54.685,28.035),(54.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.395),(54.515,28.565),(54.685,28.565),(54.685,28.395),(54.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.755),(54.515,28.925),(54.685,28.925),(54.685,28.755),(54.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.115),(54.515,29.285),(54.685,29.285),(54.685,29.115),(54.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.475),(54.515,29.645),(54.685,29.645),(54.685,29.475),(54.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.835),(54.515,30.005),(54.685,30.005),(54.685,29.835),(54.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.195),(54.515,30.365),(54.685,30.365),(54.685,30.195),(54.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.555),(54.515,30.725),(54.685,30.725),(54.685,30.555),(54.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.915),(54.515,31.085),(54.685,31.085),(54.685,30.915),(54.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.275),(54.515,31.445),(54.685,31.445),(54.685,31.275),(54.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.635),(54.515,31.805),(54.685,31.805),(54.685,31.635),(54.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.995),(54.515,32.165),(54.685,32.165),(54.685,31.995),(54.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,32.355),(54.515,32.525),(54.685,32.525),(54.685,32.355),(54.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,32.715),(54.515,32.885),(54.685,32.885),(54.685,32.715),(54.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.075),(54.515,33.245),(54.685,33.245),(54.685,33.075),(54.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.435),(54.515,33.605),(54.685,33.605),(54.685,33.435),(54.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.795),(54.515,33.965),(54.685,33.965),(54.685,33.795),(54.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.155),(54.515,34.325),(54.685,34.325),(54.685,34.155),(54.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.515),(54.515,34.685),(54.685,34.685),(54.685,34.515),(54.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.875),(54.515,35.045),(54.685,35.045),(54.685,34.875),(54.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.235),(54.515,35.405),(54.685,35.405),(54.685,35.235),(54.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.595),(54.515,35.765),(54.685,35.765),(54.685,35.595),(54.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.955),(54.515,36.125),(54.685,36.125),(54.685,35.955),(54.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,36.315),(54.515,36.485),(54.685,36.485),(54.685,36.315),(54.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,36.675),(54.515,36.845),(54.685,36.845),(54.685,36.675),(54.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.035),(54.515,37.205),(54.685,37.205),(54.685,37.035),(54.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.395),(54.515,37.565),(54.685,37.565),(54.685,37.395),(54.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.755),(54.515,37.925),(54.685,37.925),(54.685,37.755),(54.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.115),(54.515,38.285),(54.685,38.285),(54.685,38.115),(54.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.475),(54.515,38.645),(54.685,38.645),(54.685,38.475),(54.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.835),(54.515,39.005),(54.685,39.005),(54.685,38.835),(54.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.195),(54.515,39.365),(54.685,39.365),(54.685,39.195),(54.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.555),(54.515,39.725),(54.685,39.725),(54.685,39.555),(54.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.915),(54.515,40.085),(54.685,40.085),(54.685,39.915),(54.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,40.275),(54.515,40.445),(54.685,40.445),(54.685,40.275),(54.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,40.635),(54.515,40.805),(54.685,40.805),(54.685,40.635),(54.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,2.835),(25.715,3.005),(25.885,3.005),(25.885,2.835),(25.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.195),(25.715,3.365),(25.885,3.365),(25.885,3.195),(25.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.555),(25.715,3.725),(25.885,3.725),(25.885,3.555),(25.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.915),(25.715,4.085),(25.885,4.085),(25.885,3.915),(25.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.275),(25.715,4.445),(25.885,4.445),(25.885,4.275),(25.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.635),(25.715,4.805),(25.885,4.805),(25.885,4.635),(25.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.995),(25.715,5.165),(25.885,5.165),(25.885,4.995),(25.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.355),(25.715,5.525),(25.885,5.525),(25.885,5.355),(25.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.715),(25.715,5.885),(25.885,5.885),(25.885,5.715),(25.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.075),(25.715,6.245),(25.885,6.245),(25.885,6.075),(25.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.435),(25.715,6.605),(25.885,6.605),(25.885,6.435),(25.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.795),(25.715,6.965),(25.885,6.965),(25.885,6.795),(25.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.155),(25.715,7.325),(25.885,7.325),(25.885,7.155),(25.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.515),(25.715,7.685),(25.885,7.685),(25.885,7.515),(25.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.875),(25.715,8.045),(25.885,8.045),(25.885,7.875),(25.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.235),(25.715,8.405),(25.885,8.405),(25.885,8.235),(25.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.595),(25.715,8.765),(25.885,8.765),(25.885,8.595),(25.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.955),(25.715,9.125),(25.885,9.125),(25.885,8.955),(25.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.315),(25.715,9.485),(25.885,9.485),(25.885,9.315),(25.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.675),(25.715,9.845),(25.885,9.845),(25.885,9.675),(25.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.035),(25.715,10.205),(25.885,10.205),(25.885,10.035),(25.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.395),(25.715,10.565),(25.885,10.565),(25.885,10.395),(25.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.755),(25.715,10.925),(25.885,10.925),(25.885,10.755),(25.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.115),(25.715,11.285),(25.885,11.285),(25.885,11.115),(25.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.475),(25.715,11.645),(25.885,11.645),(25.885,11.475),(25.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.835),(25.715,12.005),(25.885,12.005),(25.885,11.835),(25.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.195),(25.715,12.365),(25.885,12.365),(25.885,12.195),(25.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.555),(25.715,12.725),(25.885,12.725),(25.885,12.555),(25.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.915),(25.715,13.085),(25.885,13.085),(25.885,12.915),(25.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.275),(25.715,13.445),(25.885,13.445),(25.885,13.275),(25.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.635),(25.715,13.805),(25.885,13.805),(25.885,13.635),(25.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.995),(25.715,14.165),(25.885,14.165),(25.885,13.995),(25.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.355),(25.715,14.525),(25.885,14.525),(25.885,14.355),(25.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.715),(25.715,14.885),(25.885,14.885),(25.885,14.715),(25.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.075),(25.715,15.245),(25.885,15.245),(25.885,15.075),(25.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.435),(25.715,15.605),(25.885,15.605),(25.885,15.435),(25.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.795),(25.715,15.965),(25.885,15.965),(25.885,15.795),(25.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.155),(25.715,16.325),(25.885,16.325),(25.885,16.155),(25.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.515),(25.715,16.685),(25.885,16.685),(25.885,16.515),(25.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.875),(25.715,17.045),(25.885,17.045),(25.885,16.875),(25.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.235),(25.715,17.405),(25.885,17.405),(25.885,17.235),(25.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.595),(25.715,17.765),(25.885,17.765),(25.885,17.595),(25.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.955),(25.715,18.125),(25.885,18.125),(25.885,17.955),(25.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.315),(25.715,18.485),(25.885,18.485),(25.885,18.315),(25.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.675),(25.715,18.845),(25.885,18.845),(25.885,18.675),(25.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.035),(25.715,19.205),(25.885,19.205),(25.885,19.035),(25.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.395),(25.715,19.565),(25.885,19.565),(25.885,19.395),(25.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.755),(25.715,19.925),(25.885,19.925),(25.885,19.755),(25.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.115),(25.715,20.285),(25.885,20.285),(25.885,20.115),(25.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.475),(25.715,20.645),(25.885,20.645),(25.885,20.475),(25.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.835),(25.715,21.005),(25.885,21.005),(25.885,20.835),(25.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,21.195),(25.715,21.365),(25.885,21.365),(25.885,21.195),(25.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,21.555),(25.715,21.725),(25.885,21.725),(25.885,21.555),(25.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,21.915),(25.715,22.085),(25.885,22.085),(25.885,21.915),(25.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,22.275),(25.715,22.445),(25.885,22.445),(25.885,22.275),(25.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,22.635),(25.715,22.805),(25.885,22.805),(25.885,22.635),(25.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,22.995),(25.715,23.165),(25.885,23.165),(25.885,22.995),(25.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,23.355),(25.715,23.525),(25.885,23.525),(25.885,23.355),(25.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,23.715),(25.715,23.885),(25.885,23.885),(25.885,23.715),(25.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,24.075),(25.715,24.245),(25.885,24.245),(25.885,24.075),(25.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,24.435),(25.715,24.605),(25.885,24.605),(25.885,24.435),(25.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,24.795),(25.715,24.965),(25.885,24.965),(25.885,24.795),(25.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,25.155),(25.715,25.325),(25.885,25.325),(25.885,25.155),(25.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,25.515),(25.715,25.685),(25.885,25.685),(25.885,25.515),(25.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,25.875),(25.715,26.045),(25.885,26.045),(25.885,25.875),(25.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,26.235),(25.715,26.405),(25.885,26.405),(25.885,26.235),(25.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,26.595),(25.715,26.765),(25.885,26.765),(25.885,26.595),(25.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,26.955),(25.715,27.125),(25.885,27.125),(25.885,26.955),(25.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,27.315),(25.715,27.485),(25.885,27.485),(25.885,27.315),(25.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,27.675),(25.715,27.845),(25.885,27.845),(25.885,27.675),(25.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,28.035),(25.715,28.205),(25.885,28.205),(25.885,28.035),(25.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,28.395),(25.715,28.565),(25.885,28.565),(25.885,28.395),(25.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,28.755),(25.715,28.925),(25.885,28.925),(25.885,28.755),(25.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,29.115),(25.715,29.285),(25.885,29.285),(25.885,29.115),(25.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,29.475),(25.715,29.645),(25.885,29.645),(25.885,29.475),(25.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,29.835),(25.715,30.005),(25.885,30.005),(25.885,29.835),(25.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,30.195),(25.715,30.365),(25.885,30.365),(25.885,30.195),(25.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,30.555),(25.715,30.725),(25.885,30.725),(25.885,30.555),(25.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,30.915),(25.715,31.085),(25.885,31.085),(25.885,30.915),(25.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,31.275),(25.715,31.445),(25.885,31.445),(25.885,31.275),(25.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,31.635),(25.715,31.805),(25.885,31.805),(25.885,31.635),(25.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,31.995),(25.715,32.165),(25.885,32.165),(25.885,31.995),(25.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,32.355),(25.715,32.525),(25.885,32.525),(25.885,32.355),(25.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,32.715),(25.715,32.885),(25.885,32.885),(25.885,32.715),(25.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,33.075),(25.715,33.245),(25.885,33.245),(25.885,33.075),(25.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,33.435),(25.715,33.605),(25.885,33.605),(25.885,33.435),(25.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,33.795),(25.715,33.965),(25.885,33.965),(25.885,33.795),(25.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,34.155),(25.715,34.325),(25.885,34.325),(25.885,34.155),(25.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,34.515),(25.715,34.685),(25.885,34.685),(25.885,34.515),(25.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,34.875),(25.715,35.045),(25.885,35.045),(25.885,34.875),(25.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,35.235),(25.715,35.405),(25.885,35.405),(25.885,35.235),(25.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,35.595),(25.715,35.765),(25.885,35.765),(25.885,35.595),(25.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,35.955),(25.715,36.125),(25.885,36.125),(25.885,35.955),(25.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,36.315),(25.715,36.485),(25.885,36.485),(25.885,36.315),(25.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,36.675),(25.715,36.845),(25.885,36.845),(25.885,36.675),(25.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,37.035),(25.715,37.205),(25.885,37.205),(25.885,37.035),(25.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,37.395),(25.715,37.565),(25.885,37.565),(25.885,37.395),(25.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,37.755),(25.715,37.925),(25.885,37.925),(25.885,37.755),(25.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,38.115),(25.715,38.285),(25.885,38.285),(25.885,38.115),(25.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,38.475),(25.715,38.645),(25.885,38.645),(25.885,38.475),(25.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,38.835),(25.715,39.005),(25.885,39.005),(25.885,38.835),(25.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,39.195),(25.715,39.365),(25.885,39.365),(25.885,39.195),(25.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,39.555),(25.715,39.725),(25.885,39.725),(25.885,39.555),(25.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,39.915),(25.715,40.085),(25.885,40.085),(25.885,39.915),(25.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,40.275),(25.715,40.445),(25.885,40.445),(25.885,40.275),(25.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,40.635),(25.715,40.805),(25.885,40.805),(25.885,40.635),(25.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.835),(40.115,3.005),(40.285,3.005),(40.285,2.835),(40.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.195),(40.115,3.365),(40.285,3.365),(40.285,3.195),(40.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.555),(40.115,3.725),(40.285,3.725),(40.285,3.555),(40.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.915),(40.115,4.085),(40.285,4.085),(40.285,3.915),(40.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.275),(40.115,4.445),(40.285,4.445),(40.285,4.275),(40.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.635),(40.115,4.805),(40.285,4.805),(40.285,4.635),(40.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.995),(40.115,5.165),(40.285,5.165),(40.285,4.995),(40.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.355),(40.115,5.525),(40.285,5.525),(40.285,5.355),(40.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.715),(40.115,5.885),(40.285,5.885),(40.285,5.715),(40.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.075),(40.115,6.245),(40.285,6.245),(40.285,6.075),(40.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.435),(40.115,6.605),(40.285,6.605),(40.285,6.435),(40.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.795),(40.115,6.965),(40.285,6.965),(40.285,6.795),(40.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.155),(40.115,7.325),(40.285,7.325),(40.285,7.155),(40.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.515),(40.115,7.685),(40.285,7.685),(40.285,7.515),(40.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.875),(40.115,8.045),(40.285,8.045),(40.285,7.875),(40.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.235),(40.115,8.405),(40.285,8.405),(40.285,8.235),(40.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.595),(40.115,8.765),(40.285,8.765),(40.285,8.595),(40.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.955),(40.115,9.125),(40.285,9.125),(40.285,8.955),(40.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.315),(40.115,9.485),(40.285,9.485),(40.285,9.315),(40.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.675),(40.115,9.845),(40.285,9.845),(40.285,9.675),(40.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.035),(40.115,10.205),(40.285,10.205),(40.285,10.035),(40.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.395),(40.115,10.565),(40.285,10.565),(40.285,10.395),(40.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.755),(40.115,10.925),(40.285,10.925),(40.285,10.755),(40.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.115),(40.115,11.285),(40.285,11.285),(40.285,11.115),(40.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.475),(40.115,11.645),(40.285,11.645),(40.285,11.475),(40.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.835),(40.115,12.005),(40.285,12.005),(40.285,11.835),(40.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.195),(40.115,12.365),(40.285,12.365),(40.285,12.195),(40.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.555),(40.115,12.725),(40.285,12.725),(40.285,12.555),(40.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.915),(40.115,13.085),(40.285,13.085),(40.285,12.915),(40.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.275),(40.115,13.445),(40.285,13.445),(40.285,13.275),(40.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.635),(40.115,13.805),(40.285,13.805),(40.285,13.635),(40.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.995),(40.115,14.165),(40.285,14.165),(40.285,13.995),(40.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.355),(40.115,14.525),(40.285,14.525),(40.285,14.355),(40.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.715),(40.115,14.885),(40.285,14.885),(40.285,14.715),(40.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.075),(40.115,15.245),(40.285,15.245),(40.285,15.075),(40.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.435),(40.115,15.605),(40.285,15.605),(40.285,15.435),(40.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.795),(40.115,15.965),(40.285,15.965),(40.285,15.795),(40.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.155),(40.115,16.325),(40.285,16.325),(40.285,16.155),(40.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.515),(40.115,16.685),(40.285,16.685),(40.285,16.515),(40.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.875),(40.115,17.045),(40.285,17.045),(40.285,16.875),(40.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.235),(40.115,17.405),(40.285,17.405),(40.285,17.235),(40.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.595),(40.115,17.765),(40.285,17.765),(40.285,17.595),(40.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.955),(40.115,18.125),(40.285,18.125),(40.285,17.955),(40.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.315),(40.115,18.485),(40.285,18.485),(40.285,18.315),(40.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.675),(40.115,18.845),(40.285,18.845),(40.285,18.675),(40.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.035),(40.115,19.205),(40.285,19.205),(40.285,19.035),(40.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.395),(40.115,19.565),(40.285,19.565),(40.285,19.395),(40.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.755),(40.115,19.925),(40.285,19.925),(40.285,19.755),(40.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.115),(40.115,20.285),(40.285,20.285),(40.285,20.115),(40.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.475),(40.115,20.645),(40.285,20.645),(40.285,20.475),(40.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.835),(40.115,21.005),(40.285,21.005),(40.285,20.835),(40.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.195),(40.115,21.365),(40.285,21.365),(40.285,21.195),(40.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.555),(40.115,21.725),(40.285,21.725),(40.285,21.555),(40.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.915),(40.115,22.085),(40.285,22.085),(40.285,21.915),(40.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.275),(40.115,22.445),(40.285,22.445),(40.285,22.275),(40.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.635),(40.115,22.805),(40.285,22.805),(40.285,22.635),(40.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.995),(40.115,23.165),(40.285,23.165),(40.285,22.995),(40.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,23.355),(40.115,23.525),(40.285,23.525),(40.285,23.355),(40.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,23.715),(40.115,23.885),(40.285,23.885),(40.285,23.715),(40.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.075),(40.115,24.245),(40.285,24.245),(40.285,24.075),(40.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.435),(40.115,24.605),(40.285,24.605),(40.285,24.435),(40.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.795),(40.115,24.965),(40.285,24.965),(40.285,24.795),(40.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.155),(40.115,25.325),(40.285,25.325),(40.285,25.155),(40.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.515),(40.115,25.685),(40.285,25.685),(40.285,25.515),(40.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.875),(40.115,26.045),(40.285,26.045),(40.285,25.875),(40.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.235),(40.115,26.405),(40.285,26.405),(40.285,26.235),(40.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.595),(40.115,26.765),(40.285,26.765),(40.285,26.595),(40.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.955),(40.115,27.125),(40.285,27.125),(40.285,26.955),(40.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,27.315),(40.115,27.485),(40.285,27.485),(40.285,27.315),(40.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,27.675),(40.115,27.845),(40.285,27.845),(40.285,27.675),(40.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.035),(40.115,28.205),(40.285,28.205),(40.285,28.035),(40.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.395),(40.115,28.565),(40.285,28.565),(40.285,28.395),(40.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.755),(40.115,28.925),(40.285,28.925),(40.285,28.755),(40.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.115),(40.115,29.285),(40.285,29.285),(40.285,29.115),(40.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.475),(40.115,29.645),(40.285,29.645),(40.285,29.475),(40.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.835),(40.115,30.005),(40.285,30.005),(40.285,29.835),(40.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.195),(40.115,30.365),(40.285,30.365),(40.285,30.195),(40.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.555),(40.115,30.725),(40.285,30.725),(40.285,30.555),(40.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.915),(40.115,31.085),(40.285,31.085),(40.285,30.915),(40.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.275),(40.115,31.445),(40.285,31.445),(40.285,31.275),(40.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.635),(40.115,31.805),(40.285,31.805),(40.285,31.635),(40.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.995),(40.115,32.165),(40.285,32.165),(40.285,31.995),(40.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,32.355),(40.115,32.525),(40.285,32.525),(40.285,32.355),(40.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,32.715),(40.115,32.885),(40.285,32.885),(40.285,32.715),(40.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.075),(40.115,33.245),(40.285,33.245),(40.285,33.075),(40.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.435),(40.115,33.605),(40.285,33.605),(40.285,33.435),(40.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.795),(40.115,33.965),(40.285,33.965),(40.285,33.795),(40.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.155),(40.115,34.325),(40.285,34.325),(40.285,34.155),(40.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.515),(40.115,34.685),(40.285,34.685),(40.285,34.515),(40.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.875),(40.115,35.045),(40.285,35.045),(40.285,34.875),(40.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.235),(40.115,35.405),(40.285,35.405),(40.285,35.235),(40.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.595),(40.115,35.765),(40.285,35.765),(40.285,35.595),(40.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.955),(40.115,36.125),(40.285,36.125),(40.285,35.955),(40.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,36.315),(40.115,36.485),(40.285,36.485),(40.285,36.315),(40.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,36.675),(40.115,36.845),(40.285,36.845),(40.285,36.675),(40.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.035),(40.115,37.205),(40.285,37.205),(40.285,37.035),(40.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.395),(40.115,37.565),(40.285,37.565),(40.285,37.395),(40.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.755),(40.115,37.925),(40.285,37.925),(40.285,37.755),(40.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.115),(40.115,38.285),(40.285,38.285),(40.285,38.115),(40.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.475),(40.115,38.645),(40.285,38.645),(40.285,38.475),(40.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.835),(40.115,39.005),(40.285,39.005),(40.285,38.835),(40.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.195),(40.115,39.365),(40.285,39.365),(40.285,39.195),(40.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.555),(40.115,39.725),(40.285,39.725),(40.285,39.555),(40.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.915),(40.115,40.085),(40.285,40.085),(40.285,39.915),(40.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,40.275),(40.115,40.445),(40.285,40.445),(40.285,40.275),(40.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,40.635),(40.115,40.805),(40.285,40.805),(40.285,40.635),(40.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,41.735),(54.515,41.905),(54.685,41.905),(54.685,41.735),(54.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,2.835),(64.115,3.005),(64.285,3.005),(64.285,2.835),(64.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.195),(64.115,3.365),(64.285,3.365),(64.285,3.195),(64.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.555),(64.115,3.725),(64.285,3.725),(64.285,3.555),(64.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.915),(64.115,4.085),(64.285,4.085),(64.285,3.915),(64.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.275),(64.115,4.445),(64.285,4.445),(64.285,4.275),(64.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.635),(64.115,4.805),(64.285,4.805),(64.285,4.635),(64.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.995),(64.115,5.165),(64.285,5.165),(64.285,4.995),(64.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.355),(64.115,5.525),(64.285,5.525),(64.285,5.355),(64.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.715),(64.115,5.885),(64.285,5.885),(64.285,5.715),(64.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.075),(64.115,6.245),(64.285,6.245),(64.285,6.075),(64.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.435),(64.115,6.605),(64.285,6.605),(64.285,6.435),(64.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.795),(64.115,6.965),(64.285,6.965),(64.285,6.795),(64.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.155),(64.115,7.325),(64.285,7.325),(64.285,7.155),(64.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.515),(64.115,7.685),(64.285,7.685),(64.285,7.515),(64.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.875),(64.115,8.045),(64.285,8.045),(64.285,7.875),(64.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.235),(64.115,8.405),(64.285,8.405),(64.285,8.235),(64.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.595),(64.115,8.765),(64.285,8.765),(64.285,8.595),(64.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.955),(64.115,9.125),(64.285,9.125),(64.285,8.955),(64.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.315),(64.115,9.485),(64.285,9.485),(64.285,9.315),(64.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.675),(64.115,9.845),(64.285,9.845),(64.285,9.675),(64.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.035),(64.115,10.205),(64.285,10.205),(64.285,10.035),(64.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.395),(64.115,10.565),(64.285,10.565),(64.285,10.395),(64.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.755),(64.115,10.925),(64.285,10.925),(64.285,10.755),(64.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.115),(64.115,11.285),(64.285,11.285),(64.285,11.115),(64.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.475),(64.115,11.645),(64.285,11.645),(64.285,11.475),(64.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.835),(64.115,12.005),(64.285,12.005),(64.285,11.835),(64.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.195),(64.115,12.365),(64.285,12.365),(64.285,12.195),(64.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.555),(64.115,12.725),(64.285,12.725),(64.285,12.555),(64.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.915),(64.115,13.085),(64.285,13.085),(64.285,12.915),(64.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.275),(64.115,13.445),(64.285,13.445),(64.285,13.275),(64.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.635),(64.115,13.805),(64.285,13.805),(64.285,13.635),(64.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.995),(64.115,14.165),(64.285,14.165),(64.285,13.995),(64.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.355),(64.115,14.525),(64.285,14.525),(64.285,14.355),(64.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.715),(64.115,14.885),(64.285,14.885),(64.285,14.715),(64.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.075),(64.115,15.245),(64.285,15.245),(64.285,15.075),(64.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.435),(64.115,15.605),(64.285,15.605),(64.285,15.435),(64.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.795),(64.115,15.965),(64.285,15.965),(64.285,15.795),(64.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.155),(64.115,16.325),(64.285,16.325),(64.285,16.155),(64.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.515),(64.115,16.685),(64.285,16.685),(64.285,16.515),(64.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.875),(64.115,17.045),(64.285,17.045),(64.285,16.875),(64.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.235),(64.115,17.405),(64.285,17.405),(64.285,17.235),(64.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.595),(64.115,17.765),(64.285,17.765),(64.285,17.595),(64.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.955),(64.115,18.125),(64.285,18.125),(64.285,17.955),(64.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.315),(64.115,18.485),(64.285,18.485),(64.285,18.315),(64.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.675),(64.115,18.845),(64.285,18.845),(64.285,18.675),(64.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.035),(64.115,19.205),(64.285,19.205),(64.285,19.035),(64.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.395),(64.115,19.565),(64.285,19.565),(64.285,19.395),(64.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.755),(64.115,19.925),(64.285,19.925),(64.285,19.755),(64.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.115),(64.115,20.285),(64.285,20.285),(64.285,20.115),(64.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.475),(64.115,20.645),(64.285,20.645),(64.285,20.475),(64.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.835),(64.115,21.005),(64.285,21.005),(64.285,20.835),(64.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,21.195),(64.115,21.365),(64.285,21.365),(64.285,21.195),(64.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,21.555),(64.115,21.725),(64.285,21.725),(64.285,21.555),(64.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,21.915),(64.115,22.085),(64.285,22.085),(64.285,21.915),(64.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,22.275),(64.115,22.445),(64.285,22.445),(64.285,22.275),(64.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,22.635),(64.115,22.805),(64.285,22.805),(64.285,22.635),(64.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,22.995),(64.115,23.165),(64.285,23.165),(64.285,22.995),(64.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,23.355),(64.115,23.525),(64.285,23.525),(64.285,23.355),(64.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,23.715),(64.115,23.885),(64.285,23.885),(64.285,23.715),(64.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,24.075),(64.115,24.245),(64.285,24.245),(64.285,24.075),(64.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,24.435),(64.115,24.605),(64.285,24.605),(64.285,24.435),(64.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,24.795),(64.115,24.965),(64.285,24.965),(64.285,24.795),(64.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,25.155),(64.115,25.325),(64.285,25.325),(64.285,25.155),(64.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,25.515),(64.115,25.685),(64.285,25.685),(64.285,25.515),(64.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,25.875),(64.115,26.045),(64.285,26.045),(64.285,25.875),(64.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,26.235),(64.115,26.405),(64.285,26.405),(64.285,26.235),(64.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,26.595),(64.115,26.765),(64.285,26.765),(64.285,26.595),(64.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,26.955),(64.115,27.125),(64.285,27.125),(64.285,26.955),(64.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,27.315),(64.115,27.485),(64.285,27.485),(64.285,27.315),(64.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,27.675),(64.115,27.845),(64.285,27.845),(64.285,27.675),(64.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,28.035),(64.115,28.205),(64.285,28.205),(64.285,28.035),(64.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,28.395),(64.115,28.565),(64.285,28.565),(64.285,28.395),(64.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,28.755),(64.115,28.925),(64.285,28.925),(64.285,28.755),(64.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,29.115),(64.115,29.285),(64.285,29.285),(64.285,29.115),(64.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,29.475),(64.115,29.645),(64.285,29.645),(64.285,29.475),(64.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,29.835),(64.115,30.005),(64.285,30.005),(64.285,29.835),(64.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,30.195),(64.115,30.365),(64.285,30.365),(64.285,30.195),(64.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,30.555),(64.115,30.725),(64.285,30.725),(64.285,30.555),(64.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,30.915),(64.115,31.085),(64.285,31.085),(64.285,30.915),(64.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,31.275),(64.115,31.445),(64.285,31.445),(64.285,31.275),(64.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,31.635),(64.115,31.805),(64.285,31.805),(64.285,31.635),(64.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,31.995),(64.115,32.165),(64.285,32.165),(64.285,31.995),(64.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,32.355),(64.115,32.525),(64.285,32.525),(64.285,32.355),(64.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,32.715),(64.115,32.885),(64.285,32.885),(64.285,32.715),(64.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,33.075),(64.115,33.245),(64.285,33.245),(64.285,33.075),(64.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,33.435),(64.115,33.605),(64.285,33.605),(64.285,33.435),(64.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,33.795),(64.115,33.965),(64.285,33.965),(64.285,33.795),(64.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,34.155),(64.115,34.325),(64.285,34.325),(64.285,34.155),(64.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,34.515),(64.115,34.685),(64.285,34.685),(64.285,34.515),(64.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,34.875),(64.115,35.045),(64.285,35.045),(64.285,34.875),(64.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,35.235),(64.115,35.405),(64.285,35.405),(64.285,35.235),(64.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,35.595),(64.115,35.765),(64.285,35.765),(64.285,35.595),(64.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,35.955),(64.115,36.125),(64.285,36.125),(64.285,35.955),(64.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,36.315),(64.115,36.485),(64.285,36.485),(64.285,36.315),(64.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,36.675),(64.115,36.845),(64.285,36.845),(64.285,36.675),(64.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,37.035),(64.115,37.205),(64.285,37.205),(64.285,37.035),(64.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,37.395),(64.115,37.565),(64.285,37.565),(64.285,37.395),(64.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,37.755),(64.115,37.925),(64.285,37.925),(64.285,37.755),(64.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,38.115),(64.115,38.285),(64.285,38.285),(64.285,38.115),(64.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,38.475),(64.115,38.645),(64.285,38.645),(64.285,38.475),(64.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,38.835),(64.115,39.005),(64.285,39.005),(64.285,38.835),(64.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,39.195),(64.115,39.365),(64.285,39.365),(64.285,39.195),(64.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,39.555),(64.115,39.725),(64.285,39.725),(64.285,39.555),(64.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,39.915),(64.115,40.085),(64.285,40.085),(64.285,39.915),(64.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,40.275),(64.115,40.445),(64.285,40.445),(64.285,40.275),(64.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,40.635),(64.115,40.805),(64.285,40.805),(64.285,40.635),(64.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,41.735),(25.715,41.905),(25.885,41.905),(25.885,41.735),(25.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,2.835),(59.315,3.005),(59.485,3.005),(59.485,2.835),(59.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.195),(59.315,3.365),(59.485,3.365),(59.485,3.195),(59.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.555),(59.315,3.725),(59.485,3.725),(59.485,3.555),(59.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.915),(59.315,4.085),(59.485,4.085),(59.485,3.915),(59.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.275),(59.315,4.445),(59.485,4.445),(59.485,4.275),(59.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.635),(59.315,4.805),(59.485,4.805),(59.485,4.635),(59.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.995),(59.315,5.165),(59.485,5.165),(59.485,4.995),(59.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.355),(59.315,5.525),(59.485,5.525),(59.485,5.355),(59.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.715),(59.315,5.885),(59.485,5.885),(59.485,5.715),(59.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.075),(59.315,6.245),(59.485,6.245),(59.485,6.075),(59.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.435),(59.315,6.605),(59.485,6.605),(59.485,6.435),(59.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.795),(59.315,6.965),(59.485,6.965),(59.485,6.795),(59.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.155),(59.315,7.325),(59.485,7.325),(59.485,7.155),(59.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.515),(59.315,7.685),(59.485,7.685),(59.485,7.515),(59.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.875),(59.315,8.045),(59.485,8.045),(59.485,7.875),(59.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.235),(59.315,8.405),(59.485,8.405),(59.485,8.235),(59.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.595),(59.315,8.765),(59.485,8.765),(59.485,8.595),(59.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.955),(59.315,9.125),(59.485,9.125),(59.485,8.955),(59.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.315),(59.315,9.485),(59.485,9.485),(59.485,9.315),(59.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.675),(59.315,9.845),(59.485,9.845),(59.485,9.675),(59.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.035),(59.315,10.205),(59.485,10.205),(59.485,10.035),(59.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.395),(59.315,10.565),(59.485,10.565),(59.485,10.395),(59.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.755),(59.315,10.925),(59.485,10.925),(59.485,10.755),(59.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.115),(59.315,11.285),(59.485,11.285),(59.485,11.115),(59.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.475),(59.315,11.645),(59.485,11.645),(59.485,11.475),(59.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.835),(59.315,12.005),(59.485,12.005),(59.485,11.835),(59.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.195),(59.315,12.365),(59.485,12.365),(59.485,12.195),(59.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.555),(59.315,12.725),(59.485,12.725),(59.485,12.555),(59.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.915),(59.315,13.085),(59.485,13.085),(59.485,12.915),(59.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.275),(59.315,13.445),(59.485,13.445),(59.485,13.275),(59.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.635),(59.315,13.805),(59.485,13.805),(59.485,13.635),(59.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.995),(59.315,14.165),(59.485,14.165),(59.485,13.995),(59.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.355),(59.315,14.525),(59.485,14.525),(59.485,14.355),(59.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.715),(59.315,14.885),(59.485,14.885),(59.485,14.715),(59.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.075),(59.315,15.245),(59.485,15.245),(59.485,15.075),(59.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.435),(59.315,15.605),(59.485,15.605),(59.485,15.435),(59.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.795),(59.315,15.965),(59.485,15.965),(59.485,15.795),(59.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.155),(59.315,16.325),(59.485,16.325),(59.485,16.155),(59.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.515),(59.315,16.685),(59.485,16.685),(59.485,16.515),(59.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.875),(59.315,17.045),(59.485,17.045),(59.485,16.875),(59.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.235),(59.315,17.405),(59.485,17.405),(59.485,17.235),(59.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.595),(59.315,17.765),(59.485,17.765),(59.485,17.595),(59.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.955),(59.315,18.125),(59.485,18.125),(59.485,17.955),(59.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.315),(59.315,18.485),(59.485,18.485),(59.485,18.315),(59.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.675),(59.315,18.845),(59.485,18.845),(59.485,18.675),(59.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.035),(59.315,19.205),(59.485,19.205),(59.485,19.035),(59.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.395),(59.315,19.565),(59.485,19.565),(59.485,19.395),(59.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.755),(59.315,19.925),(59.485,19.925),(59.485,19.755),(59.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.115),(59.315,20.285),(59.485,20.285),(59.485,20.115),(59.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.475),(59.315,20.645),(59.485,20.645),(59.485,20.475),(59.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.835),(59.315,21.005),(59.485,21.005),(59.485,20.835),(59.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,21.195),(59.315,21.365),(59.485,21.365),(59.485,21.195),(59.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,21.555),(59.315,21.725),(59.485,21.725),(59.485,21.555),(59.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,21.915),(59.315,22.085),(59.485,22.085),(59.485,21.915),(59.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,22.275),(59.315,22.445),(59.485,22.445),(59.485,22.275),(59.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,22.635),(59.315,22.805),(59.485,22.805),(59.485,22.635),(59.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,22.995),(59.315,23.165),(59.485,23.165),(59.485,22.995),(59.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,23.355),(59.315,23.525),(59.485,23.525),(59.485,23.355),(59.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,23.715),(59.315,23.885),(59.485,23.885),(59.485,23.715),(59.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,24.075),(59.315,24.245),(59.485,24.245),(59.485,24.075),(59.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,24.435),(59.315,24.605),(59.485,24.605),(59.485,24.435),(59.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,24.795),(59.315,24.965),(59.485,24.965),(59.485,24.795),(59.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,25.155),(59.315,25.325),(59.485,25.325),(59.485,25.155),(59.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,25.515),(59.315,25.685),(59.485,25.685),(59.485,25.515),(59.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,25.875),(59.315,26.045),(59.485,26.045),(59.485,25.875),(59.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,26.235),(59.315,26.405),(59.485,26.405),(59.485,26.235),(59.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,26.595),(59.315,26.765),(59.485,26.765),(59.485,26.595),(59.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,26.955),(59.315,27.125),(59.485,27.125),(59.485,26.955),(59.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,27.315),(59.315,27.485),(59.485,27.485),(59.485,27.315),(59.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,27.675),(59.315,27.845),(59.485,27.845),(59.485,27.675),(59.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,28.035),(59.315,28.205),(59.485,28.205),(59.485,28.035),(59.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,28.395),(59.315,28.565),(59.485,28.565),(59.485,28.395),(59.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,28.755),(59.315,28.925),(59.485,28.925),(59.485,28.755),(59.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,29.115),(59.315,29.285),(59.485,29.285),(59.485,29.115),(59.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,29.475),(59.315,29.645),(59.485,29.645),(59.485,29.475),(59.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,29.835),(59.315,30.005),(59.485,30.005),(59.485,29.835),(59.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,30.195),(59.315,30.365),(59.485,30.365),(59.485,30.195),(59.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,30.555),(59.315,30.725),(59.485,30.725),(59.485,30.555),(59.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,30.915),(59.315,31.085),(59.485,31.085),(59.485,30.915),(59.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,31.275),(59.315,31.445),(59.485,31.445),(59.485,31.275),(59.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,31.635),(59.315,31.805),(59.485,31.805),(59.485,31.635),(59.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,31.995),(59.315,32.165),(59.485,32.165),(59.485,31.995),(59.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,32.355),(59.315,32.525),(59.485,32.525),(59.485,32.355),(59.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,32.715),(59.315,32.885),(59.485,32.885),(59.485,32.715),(59.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,33.075),(59.315,33.245),(59.485,33.245),(59.485,33.075),(59.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,33.435),(59.315,33.605),(59.485,33.605),(59.485,33.435),(59.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,33.795),(59.315,33.965),(59.485,33.965),(59.485,33.795),(59.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,34.155),(59.315,34.325),(59.485,34.325),(59.485,34.155),(59.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,34.515),(59.315,34.685),(59.485,34.685),(59.485,34.515),(59.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,34.875),(59.315,35.045),(59.485,35.045),(59.485,34.875),(59.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,35.235),(59.315,35.405),(59.485,35.405),(59.485,35.235),(59.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,35.595),(59.315,35.765),(59.485,35.765),(59.485,35.595),(59.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,35.955),(59.315,36.125),(59.485,36.125),(59.485,35.955),(59.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,36.315),(59.315,36.485),(59.485,36.485),(59.485,36.315),(59.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,36.675),(59.315,36.845),(59.485,36.845),(59.485,36.675),(59.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,37.035),(59.315,37.205),(59.485,37.205),(59.485,37.035),(59.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,37.395),(59.315,37.565),(59.485,37.565),(59.485,37.395),(59.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,37.755),(59.315,37.925),(59.485,37.925),(59.485,37.755),(59.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,38.115),(59.315,38.285),(59.485,38.285),(59.485,38.115),(59.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,38.475),(59.315,38.645),(59.485,38.645),(59.485,38.475),(59.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,38.835),(59.315,39.005),(59.485,39.005),(59.485,38.835),(59.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,39.195),(59.315,39.365),(59.485,39.365),(59.485,39.195),(59.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,39.555),(59.315,39.725),(59.485,39.725),(59.485,39.555),(59.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,39.915),(59.315,40.085),(59.485,40.085),(59.485,39.915),(59.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,40.275),(59.315,40.445),(59.485,40.445),(59.485,40.275),(59.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,40.635),(59.315,40.805),(59.485,40.805),(59.485,40.635),(59.315,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,41.735),(64.115,41.905),(64.285,41.905),(64.285,41.735),(64.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,41.735),(6.77,41.905),(6.94,41.905),(6.94,41.735),(6.77,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,2.835),(11.315,3.005),(11.485,3.005),(11.485,2.835),(11.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.195),(11.315,3.365),(11.485,3.365),(11.485,3.195),(11.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.555),(11.315,3.725),(11.485,3.725),(11.485,3.555),(11.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.915),(11.315,4.085),(11.485,4.085),(11.485,3.915),(11.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.275),(11.315,4.445),(11.485,4.445),(11.485,4.275),(11.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.635),(11.315,4.805),(11.485,4.805),(11.485,4.635),(11.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.995),(11.315,5.165),(11.485,5.165),(11.485,4.995),(11.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.355),(11.315,5.525),(11.485,5.525),(11.485,5.355),(11.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.715),(11.315,5.885),(11.485,5.885),(11.485,5.715),(11.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.075),(11.315,6.245),(11.485,6.245),(11.485,6.075),(11.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.435),(11.315,6.605),(11.485,6.605),(11.485,6.435),(11.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.795),(11.315,6.965),(11.485,6.965),(11.485,6.795),(11.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.155),(11.315,7.325),(11.485,7.325),(11.485,7.155),(11.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.515),(11.315,7.685),(11.485,7.685),(11.485,7.515),(11.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.875),(11.315,8.045),(11.485,8.045),(11.485,7.875),(11.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.235),(11.315,8.405),(11.485,8.405),(11.485,8.235),(11.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.595),(11.315,8.765),(11.485,8.765),(11.485,8.595),(11.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.955),(11.315,9.125),(11.485,9.125),(11.485,8.955),(11.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.315),(11.315,9.485),(11.485,9.485),(11.485,9.315),(11.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.675),(11.315,9.845),(11.485,9.845),(11.485,9.675),(11.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.035),(11.315,10.205),(11.485,10.205),(11.485,10.035),(11.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.395),(11.315,10.565),(11.485,10.565),(11.485,10.395),(11.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.755),(11.315,10.925),(11.485,10.925),(11.485,10.755),(11.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.115),(11.315,11.285),(11.485,11.285),(11.485,11.115),(11.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.475),(11.315,11.645),(11.485,11.645),(11.485,11.475),(11.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.835),(11.315,12.005),(11.485,12.005),(11.485,11.835),(11.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.195),(11.315,12.365),(11.485,12.365),(11.485,12.195),(11.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.555),(11.315,12.725),(11.485,12.725),(11.485,12.555),(11.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.915),(11.315,13.085),(11.485,13.085),(11.485,12.915),(11.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.275),(11.315,13.445),(11.485,13.445),(11.485,13.275),(11.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.635),(11.315,13.805),(11.485,13.805),(11.485,13.635),(11.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.995),(11.315,14.165),(11.485,14.165),(11.485,13.995),(11.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.355),(11.315,14.525),(11.485,14.525),(11.485,14.355),(11.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.715),(11.315,14.885),(11.485,14.885),(11.485,14.715),(11.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.075),(11.315,15.245),(11.485,15.245),(11.485,15.075),(11.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.435),(11.315,15.605),(11.485,15.605),(11.485,15.435),(11.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.795),(11.315,15.965),(11.485,15.965),(11.485,15.795),(11.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.155),(11.315,16.325),(11.485,16.325),(11.485,16.155),(11.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.515),(11.315,16.685),(11.485,16.685),(11.485,16.515),(11.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.875),(11.315,17.045),(11.485,17.045),(11.485,16.875),(11.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.235),(11.315,17.405),(11.485,17.405),(11.485,17.235),(11.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.595),(11.315,17.765),(11.485,17.765),(11.485,17.595),(11.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.955),(11.315,18.125),(11.485,18.125),(11.485,17.955),(11.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.315),(11.315,18.485),(11.485,18.485),(11.485,18.315),(11.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.675),(11.315,18.845),(11.485,18.845),(11.485,18.675),(11.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.035),(11.315,19.205),(11.485,19.205),(11.485,19.035),(11.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.395),(11.315,19.565),(11.485,19.565),(11.485,19.395),(11.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.755),(11.315,19.925),(11.485,19.925),(11.485,19.755),(11.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.115),(11.315,20.285),(11.485,20.285),(11.485,20.115),(11.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.475),(11.315,20.645),(11.485,20.645),(11.485,20.475),(11.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.835),(11.315,21.005),(11.485,21.005),(11.485,20.835),(11.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,21.195),(11.315,21.365),(11.485,21.365),(11.485,21.195),(11.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,21.555),(11.315,21.725),(11.485,21.725),(11.485,21.555),(11.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,21.915),(11.315,22.085),(11.485,22.085),(11.485,21.915),(11.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,22.275),(11.315,22.445),(11.485,22.445),(11.485,22.275),(11.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,22.635),(11.315,22.805),(11.485,22.805),(11.485,22.635),(11.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,22.995),(11.315,23.165),(11.485,23.165),(11.485,22.995),(11.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,23.355),(11.315,23.525),(11.485,23.525),(11.485,23.355),(11.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,23.715),(11.315,23.885),(11.485,23.885),(11.485,23.715),(11.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,24.075),(11.315,24.245),(11.485,24.245),(11.485,24.075),(11.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,24.435),(11.315,24.605),(11.485,24.605),(11.485,24.435),(11.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,24.795),(11.315,24.965),(11.485,24.965),(11.485,24.795),(11.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,25.155),(11.315,25.325),(11.485,25.325),(11.485,25.155),(11.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,25.515),(11.315,25.685),(11.485,25.685),(11.485,25.515),(11.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,25.875),(11.315,26.045),(11.485,26.045),(11.485,25.875),(11.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,26.235),(11.315,26.405),(11.485,26.405),(11.485,26.235),(11.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,26.595),(11.315,26.765),(11.485,26.765),(11.485,26.595),(11.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,26.955),(11.315,27.125),(11.485,27.125),(11.485,26.955),(11.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,27.315),(11.315,27.485),(11.485,27.485),(11.485,27.315),(11.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,27.675),(11.315,27.845),(11.485,27.845),(11.485,27.675),(11.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,28.035),(11.315,28.205),(11.485,28.205),(11.485,28.035),(11.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,28.395),(11.315,28.565),(11.485,28.565),(11.485,28.395),(11.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,28.755),(11.315,28.925),(11.485,28.925),(11.485,28.755),(11.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,29.115),(11.315,29.285),(11.485,29.285),(11.485,29.115),(11.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,29.475),(11.315,29.645),(11.485,29.645),(11.485,29.475),(11.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,29.835),(11.315,30.005),(11.485,30.005),(11.485,29.835),(11.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,30.195),(11.315,30.365),(11.485,30.365),(11.485,30.195),(11.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,30.555),(11.315,30.725),(11.485,30.725),(11.485,30.555),(11.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,30.915),(11.315,31.085),(11.485,31.085),(11.485,30.915),(11.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,31.275),(11.315,31.445),(11.485,31.445),(11.485,31.275),(11.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,31.635),(11.315,31.805),(11.485,31.805),(11.485,31.635),(11.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,31.995),(11.315,32.165),(11.485,32.165),(11.485,31.995),(11.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,32.355),(11.315,32.525),(11.485,32.525),(11.485,32.355),(11.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,32.715),(11.315,32.885),(11.485,32.885),(11.485,32.715),(11.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,33.075),(11.315,33.245),(11.485,33.245),(11.485,33.075),(11.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,33.435),(11.315,33.605),(11.485,33.605),(11.485,33.435),(11.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,33.795),(11.315,33.965),(11.485,33.965),(11.485,33.795),(11.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,34.155),(11.315,34.325),(11.485,34.325),(11.485,34.155),(11.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,34.515),(11.315,34.685),(11.485,34.685),(11.485,34.515),(11.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,34.875),(11.315,35.045),(11.485,35.045),(11.485,34.875),(11.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,35.235),(11.315,35.405),(11.485,35.405),(11.485,35.235),(11.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,35.595),(11.315,35.765),(11.485,35.765),(11.485,35.595),(11.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,35.955),(11.315,36.125),(11.485,36.125),(11.485,35.955),(11.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,36.315),(11.315,36.485),(11.485,36.485),(11.485,36.315),(11.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,36.675),(11.315,36.845),(11.485,36.845),(11.485,36.675),(11.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,37.035),(11.315,37.205),(11.485,37.205),(11.485,37.035),(11.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,37.395),(11.315,37.565),(11.485,37.565),(11.485,37.395),(11.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,37.755),(11.315,37.925),(11.485,37.925),(11.485,37.755),(11.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,38.115),(11.315,38.285),(11.485,38.285),(11.485,38.115),(11.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,38.475),(11.315,38.645),(11.485,38.645),(11.485,38.475),(11.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,38.835),(11.315,39.005),(11.485,39.005),(11.485,38.835),(11.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,39.195),(11.315,39.365),(11.485,39.365),(11.485,39.195),(11.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,39.555),(11.315,39.725),(11.485,39.725),(11.485,39.555),(11.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,39.915),(11.315,40.085),(11.485,40.085),(11.485,39.915),(11.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,40.275),(11.315,40.445),(11.485,40.445),(11.485,40.275),(11.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,40.635),(11.315,40.805),(11.485,40.805),(11.485,40.635),(11.315,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,2.835),(16.115,3.005),(16.285,3.005),(16.285,2.835),(16.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.195),(16.115,3.365),(16.285,3.365),(16.285,3.195),(16.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.555),(16.115,3.725),(16.285,3.725),(16.285,3.555),(16.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.915),(16.115,4.085),(16.285,4.085),(16.285,3.915),(16.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.275),(16.115,4.445),(16.285,4.445),(16.285,4.275),(16.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.635),(16.115,4.805),(16.285,4.805),(16.285,4.635),(16.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.995),(16.115,5.165),(16.285,5.165),(16.285,4.995),(16.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.355),(16.115,5.525),(16.285,5.525),(16.285,5.355),(16.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.715),(16.115,5.885),(16.285,5.885),(16.285,5.715),(16.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.075),(16.115,6.245),(16.285,6.245),(16.285,6.075),(16.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.435),(16.115,6.605),(16.285,6.605),(16.285,6.435),(16.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.795),(16.115,6.965),(16.285,6.965),(16.285,6.795),(16.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.155),(16.115,7.325),(16.285,7.325),(16.285,7.155),(16.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.515),(16.115,7.685),(16.285,7.685),(16.285,7.515),(16.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.875),(16.115,8.045),(16.285,8.045),(16.285,7.875),(16.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.235),(16.115,8.405),(16.285,8.405),(16.285,8.235),(16.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.595),(16.115,8.765),(16.285,8.765),(16.285,8.595),(16.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.955),(16.115,9.125),(16.285,9.125),(16.285,8.955),(16.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.315),(16.115,9.485),(16.285,9.485),(16.285,9.315),(16.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.675),(16.115,9.845),(16.285,9.845),(16.285,9.675),(16.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.035),(16.115,10.205),(16.285,10.205),(16.285,10.035),(16.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.395),(16.115,10.565),(16.285,10.565),(16.285,10.395),(16.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.755),(16.115,10.925),(16.285,10.925),(16.285,10.755),(16.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.115),(16.115,11.285),(16.285,11.285),(16.285,11.115),(16.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.475),(16.115,11.645),(16.285,11.645),(16.285,11.475),(16.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.835),(16.115,12.005),(16.285,12.005),(16.285,11.835),(16.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.195),(16.115,12.365),(16.285,12.365),(16.285,12.195),(16.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.555),(16.115,12.725),(16.285,12.725),(16.285,12.555),(16.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.915),(16.115,13.085),(16.285,13.085),(16.285,12.915),(16.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.275),(16.115,13.445),(16.285,13.445),(16.285,13.275),(16.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.635),(16.115,13.805),(16.285,13.805),(16.285,13.635),(16.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.995),(16.115,14.165),(16.285,14.165),(16.285,13.995),(16.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.355),(16.115,14.525),(16.285,14.525),(16.285,14.355),(16.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.715),(16.115,14.885),(16.285,14.885),(16.285,14.715),(16.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.075),(16.115,15.245),(16.285,15.245),(16.285,15.075),(16.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.435),(16.115,15.605),(16.285,15.605),(16.285,15.435),(16.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.795),(16.115,15.965),(16.285,15.965),(16.285,15.795),(16.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.155),(16.115,16.325),(16.285,16.325),(16.285,16.155),(16.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.515),(16.115,16.685),(16.285,16.685),(16.285,16.515),(16.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.875),(16.115,17.045),(16.285,17.045),(16.285,16.875),(16.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.235),(16.115,17.405),(16.285,17.405),(16.285,17.235),(16.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.595),(16.115,17.765),(16.285,17.765),(16.285,17.595),(16.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.955),(16.115,18.125),(16.285,18.125),(16.285,17.955),(16.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.315),(16.115,18.485),(16.285,18.485),(16.285,18.315),(16.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.675),(16.115,18.845),(16.285,18.845),(16.285,18.675),(16.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.035),(16.115,19.205),(16.285,19.205),(16.285,19.035),(16.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.395),(16.115,19.565),(16.285,19.565),(16.285,19.395),(16.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.755),(16.115,19.925),(16.285,19.925),(16.285,19.755),(16.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.115),(16.115,20.285),(16.285,20.285),(16.285,20.115),(16.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.475),(16.115,20.645),(16.285,20.645),(16.285,20.475),(16.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.835),(16.115,21.005),(16.285,21.005),(16.285,20.835),(16.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,21.195),(16.115,21.365),(16.285,21.365),(16.285,21.195),(16.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,21.555),(16.115,21.725),(16.285,21.725),(16.285,21.555),(16.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,21.915),(16.115,22.085),(16.285,22.085),(16.285,21.915),(16.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,22.275),(16.115,22.445),(16.285,22.445),(16.285,22.275),(16.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,22.635),(16.115,22.805),(16.285,22.805),(16.285,22.635),(16.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,22.995),(16.115,23.165),(16.285,23.165),(16.285,22.995),(16.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,23.355),(16.115,23.525),(16.285,23.525),(16.285,23.355),(16.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,23.715),(16.115,23.885),(16.285,23.885),(16.285,23.715),(16.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,24.075),(16.115,24.245),(16.285,24.245),(16.285,24.075),(16.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,24.435),(16.115,24.605),(16.285,24.605),(16.285,24.435),(16.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,24.795),(16.115,24.965),(16.285,24.965),(16.285,24.795),(16.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,25.155),(16.115,25.325),(16.285,25.325),(16.285,25.155),(16.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,25.515),(16.115,25.685),(16.285,25.685),(16.285,25.515),(16.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,25.875),(16.115,26.045),(16.285,26.045),(16.285,25.875),(16.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,26.235),(16.115,26.405),(16.285,26.405),(16.285,26.235),(16.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,26.595),(16.115,26.765),(16.285,26.765),(16.285,26.595),(16.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,26.955),(16.115,27.125),(16.285,27.125),(16.285,26.955),(16.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,27.315),(16.115,27.485),(16.285,27.485),(16.285,27.315),(16.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,27.675),(16.115,27.845),(16.285,27.845),(16.285,27.675),(16.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,28.035),(16.115,28.205),(16.285,28.205),(16.285,28.035),(16.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,28.395),(16.115,28.565),(16.285,28.565),(16.285,28.395),(16.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,28.755),(16.115,28.925),(16.285,28.925),(16.285,28.755),(16.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,29.115),(16.115,29.285),(16.285,29.285),(16.285,29.115),(16.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,29.475),(16.115,29.645),(16.285,29.645),(16.285,29.475),(16.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,29.835),(16.115,30.005),(16.285,30.005),(16.285,29.835),(16.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,30.195),(16.115,30.365),(16.285,30.365),(16.285,30.195),(16.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,30.555),(16.115,30.725),(16.285,30.725),(16.285,30.555),(16.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,30.915),(16.115,31.085),(16.285,31.085),(16.285,30.915),(16.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,31.275),(16.115,31.445),(16.285,31.445),(16.285,31.275),(16.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,31.635),(16.115,31.805),(16.285,31.805),(16.285,31.635),(16.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,31.995),(16.115,32.165),(16.285,32.165),(16.285,31.995),(16.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,32.355),(16.115,32.525),(16.285,32.525),(16.285,32.355),(16.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,32.715),(16.115,32.885),(16.285,32.885),(16.285,32.715),(16.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,33.075),(16.115,33.245),(16.285,33.245),(16.285,33.075),(16.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,33.435),(16.115,33.605),(16.285,33.605),(16.285,33.435),(16.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,33.795),(16.115,33.965),(16.285,33.965),(16.285,33.795),(16.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,34.155),(16.115,34.325),(16.285,34.325),(16.285,34.155),(16.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,34.515),(16.115,34.685),(16.285,34.685),(16.285,34.515),(16.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,34.875),(16.115,35.045),(16.285,35.045),(16.285,34.875),(16.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,35.235),(16.115,35.405),(16.285,35.405),(16.285,35.235),(16.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,35.595),(16.115,35.765),(16.285,35.765),(16.285,35.595),(16.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,35.955),(16.115,36.125),(16.285,36.125),(16.285,35.955),(16.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,36.315),(16.115,36.485),(16.285,36.485),(16.285,36.315),(16.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,36.675),(16.115,36.845),(16.285,36.845),(16.285,36.675),(16.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,37.035),(16.115,37.205),(16.285,37.205),(16.285,37.035),(16.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,37.395),(16.115,37.565),(16.285,37.565),(16.285,37.395),(16.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,37.755),(16.115,37.925),(16.285,37.925),(16.285,37.755),(16.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,38.115),(16.115,38.285),(16.285,38.285),(16.285,38.115),(16.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,38.475),(16.115,38.645),(16.285,38.645),(16.285,38.475),(16.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,38.835),(16.115,39.005),(16.285,39.005),(16.285,38.835),(16.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,39.195),(16.115,39.365),(16.285,39.365),(16.285,39.195),(16.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,39.555),(16.115,39.725),(16.285,39.725),(16.285,39.555),(16.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,39.915),(16.115,40.085),(16.285,40.085),(16.285,39.915),(16.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,40.275),(16.115,40.445),(16.285,40.445),(16.285,40.275),(16.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,40.635),(16.115,40.805),(16.285,40.805),(16.285,40.635),(16.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.835),(35.315,3.005),(35.485,3.005),(35.485,2.835),(35.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.195),(35.315,3.365),(35.485,3.365),(35.485,3.195),(35.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.555),(35.315,3.725),(35.485,3.725),(35.485,3.555),(35.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.915),(35.315,4.085),(35.485,4.085),(35.485,3.915),(35.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.275),(35.315,4.445),(35.485,4.445),(35.485,4.275),(35.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.635),(35.315,4.805),(35.485,4.805),(35.485,4.635),(35.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.995),(35.315,5.165),(35.485,5.165),(35.485,4.995),(35.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.355),(35.315,5.525),(35.485,5.525),(35.485,5.355),(35.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.715),(35.315,5.885),(35.485,5.885),(35.485,5.715),(35.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.075),(35.315,6.245),(35.485,6.245),(35.485,6.075),(35.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.435),(35.315,6.605),(35.485,6.605),(35.485,6.435),(35.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.795),(35.315,6.965),(35.485,6.965),(35.485,6.795),(35.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.155),(35.315,7.325),(35.485,7.325),(35.485,7.155),(35.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.515),(35.315,7.685),(35.485,7.685),(35.485,7.515),(35.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.875),(35.315,8.045),(35.485,8.045),(35.485,7.875),(35.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.235),(35.315,8.405),(35.485,8.405),(35.485,8.235),(35.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.595),(35.315,8.765),(35.485,8.765),(35.485,8.595),(35.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.955),(35.315,9.125),(35.485,9.125),(35.485,8.955),(35.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.315),(35.315,9.485),(35.485,9.485),(35.485,9.315),(35.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.675),(35.315,9.845),(35.485,9.845),(35.485,9.675),(35.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.035),(35.315,10.205),(35.485,10.205),(35.485,10.035),(35.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.395),(35.315,10.565),(35.485,10.565),(35.485,10.395),(35.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.755),(35.315,10.925),(35.485,10.925),(35.485,10.755),(35.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.115),(35.315,11.285),(35.485,11.285),(35.485,11.115),(35.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.475),(35.315,11.645),(35.485,11.645),(35.485,11.475),(35.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.835),(35.315,12.005),(35.485,12.005),(35.485,11.835),(35.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.195),(35.315,12.365),(35.485,12.365),(35.485,12.195),(35.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.555),(35.315,12.725),(35.485,12.725),(35.485,12.555),(35.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.915),(35.315,13.085),(35.485,13.085),(35.485,12.915),(35.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.275),(35.315,13.445),(35.485,13.445),(35.485,13.275),(35.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.635),(35.315,13.805),(35.485,13.805),(35.485,13.635),(35.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.995),(35.315,14.165),(35.485,14.165),(35.485,13.995),(35.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.355),(35.315,14.525),(35.485,14.525),(35.485,14.355),(35.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.715),(35.315,14.885),(35.485,14.885),(35.485,14.715),(35.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.075),(35.315,15.245),(35.485,15.245),(35.485,15.075),(35.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.435),(35.315,15.605),(35.485,15.605),(35.485,15.435),(35.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.795),(35.315,15.965),(35.485,15.965),(35.485,15.795),(35.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.155),(35.315,16.325),(35.485,16.325),(35.485,16.155),(35.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.515),(35.315,16.685),(35.485,16.685),(35.485,16.515),(35.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.875),(35.315,17.045),(35.485,17.045),(35.485,16.875),(35.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.235),(35.315,17.405),(35.485,17.405),(35.485,17.235),(35.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.595),(35.315,17.765),(35.485,17.765),(35.485,17.595),(35.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.955),(35.315,18.125),(35.485,18.125),(35.485,17.955),(35.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.315),(35.315,18.485),(35.485,18.485),(35.485,18.315),(35.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.675),(35.315,18.845),(35.485,18.845),(35.485,18.675),(35.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.035),(35.315,19.205),(35.485,19.205),(35.485,19.035),(35.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.395),(35.315,19.565),(35.485,19.565),(35.485,19.395),(35.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.755),(35.315,19.925),(35.485,19.925),(35.485,19.755),(35.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.115),(35.315,20.285),(35.485,20.285),(35.485,20.115),(35.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.475),(35.315,20.645),(35.485,20.645),(35.485,20.475),(35.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.835),(35.315,21.005),(35.485,21.005),(35.485,20.835),(35.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.195),(35.315,21.365),(35.485,21.365),(35.485,21.195),(35.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.555),(35.315,21.725),(35.485,21.725),(35.485,21.555),(35.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.915),(35.315,22.085),(35.485,22.085),(35.485,21.915),(35.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.275),(35.315,22.445),(35.485,22.445),(35.485,22.275),(35.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.635),(35.315,22.805),(35.485,22.805),(35.485,22.635),(35.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.995),(35.315,23.165),(35.485,23.165),(35.485,22.995),(35.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,23.355),(35.315,23.525),(35.485,23.525),(35.485,23.355),(35.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,23.715),(35.315,23.885),(35.485,23.885),(35.485,23.715),(35.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.075),(35.315,24.245),(35.485,24.245),(35.485,24.075),(35.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.435),(35.315,24.605),(35.485,24.605),(35.485,24.435),(35.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.795),(35.315,24.965),(35.485,24.965),(35.485,24.795),(35.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.155),(35.315,25.325),(35.485,25.325),(35.485,25.155),(35.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.515),(35.315,25.685),(35.485,25.685),(35.485,25.515),(35.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.875),(35.315,26.045),(35.485,26.045),(35.485,25.875),(35.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.235),(35.315,26.405),(35.485,26.405),(35.485,26.235),(35.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.595),(35.315,26.765),(35.485,26.765),(35.485,26.595),(35.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.955),(35.315,27.125),(35.485,27.125),(35.485,26.955),(35.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,27.315),(35.315,27.485),(35.485,27.485),(35.485,27.315),(35.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,27.675),(35.315,27.845),(35.485,27.845),(35.485,27.675),(35.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.035),(35.315,28.205),(35.485,28.205),(35.485,28.035),(35.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.395),(35.315,28.565),(35.485,28.565),(35.485,28.395),(35.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.755),(35.315,28.925),(35.485,28.925),(35.485,28.755),(35.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.115),(35.315,29.285),(35.485,29.285),(35.485,29.115),(35.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.475),(35.315,29.645),(35.485,29.645),(35.485,29.475),(35.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.835),(35.315,30.005),(35.485,30.005),(35.485,29.835),(35.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.195),(35.315,30.365),(35.485,30.365),(35.485,30.195),(35.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.555),(35.315,30.725),(35.485,30.725),(35.485,30.555),(35.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.915),(35.315,31.085),(35.485,31.085),(35.485,30.915),(35.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.275),(35.315,31.445),(35.485,31.445),(35.485,31.275),(35.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.635),(35.315,31.805),(35.485,31.805),(35.485,31.635),(35.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.995),(35.315,32.165),(35.485,32.165),(35.485,31.995),(35.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,32.355),(35.315,32.525),(35.485,32.525),(35.485,32.355),(35.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,32.715),(35.315,32.885),(35.485,32.885),(35.485,32.715),(35.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.075),(35.315,33.245),(35.485,33.245),(35.485,33.075),(35.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.435),(35.315,33.605),(35.485,33.605),(35.485,33.435),(35.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.795),(35.315,33.965),(35.485,33.965),(35.485,33.795),(35.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.155),(35.315,34.325),(35.485,34.325),(35.485,34.155),(35.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.515),(35.315,34.685),(35.485,34.685),(35.485,34.515),(35.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.875),(35.315,35.045),(35.485,35.045),(35.485,34.875),(35.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.235),(35.315,35.405),(35.485,35.405),(35.485,35.235),(35.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.595),(35.315,35.765),(35.485,35.765),(35.485,35.595),(35.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.955),(35.315,36.125),(35.485,36.125),(35.485,35.955),(35.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,36.315),(35.315,36.485),(35.485,36.485),(35.485,36.315),(35.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,36.675),(35.315,36.845),(35.485,36.845),(35.485,36.675),(35.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.035),(35.315,37.205),(35.485,37.205),(35.485,37.035),(35.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.395),(35.315,37.565),(35.485,37.565),(35.485,37.395),(35.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.755),(35.315,37.925),(35.485,37.925),(35.485,37.755),(35.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.115),(35.315,38.285),(35.485,38.285),(35.485,38.115),(35.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.475),(35.315,38.645),(35.485,38.645),(35.485,38.475),(35.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.835),(35.315,39.005),(35.485,39.005),(35.485,38.835),(35.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.195),(35.315,39.365),(35.485,39.365),(35.485,39.195),(35.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.555),(35.315,39.725),(35.485,39.725),(35.485,39.555),(35.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.915),(35.315,40.085),(35.485,40.085),(35.485,39.915),(35.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,40.275),(35.315,40.445),(35.485,40.445),(35.485,40.275),(35.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,40.635),(35.315,40.805),(35.485,40.805),(35.485,40.635),(35.315,40.635)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,1.675),(40.085,1.965),(40.315,1.965),(40.315,1.675),(40.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,2.775),(11.285,40.865),(11.515,40.865),(11.515,2.775),(11.285,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.06),(35.27,43.58),(35.53,43.58),(35.53,0.06),(35.27,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,43.64),(35.53,43.64),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,0.0),(35.285,43.64),(35.515,43.64),(35.515,0.0),(35.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,2.775),(40.085,40.865),(40.315,40.865),(40.315,2.775),(40.085,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.0),(73.67,43.64),(73.93,43.64),(73.93,0.0),(73.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,0.0),(73.685,43.64),(73.915,43.64),(73.915,0.0),(73.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,43.64),(54.73,43.64),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,0.0),(54.485,43.64),(54.715,43.64),(54.715,0.0),(54.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.06),(73.67,43.58),(73.93,43.58),(73.93,0.06),(73.67,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.06),(54.47,43.58),(54.73,43.58),(54.73,0.06),(54.47,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,0.0),(16.085,43.64),(16.315,43.64),(16.315,0.0),(16.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.06),(16.07,43.58),(16.33,43.58),(16.33,0.06),(16.07,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.0),(16.07,43.64),(16.33,43.64),(16.33,0.0),(16.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,41.675),(25.685,41.965),(25.915,41.965),(25.915,41.675),(25.685,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,0.0),(59.285,43.64),(59.515,43.64),(59.515,0.0),(59.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.06),(59.27,43.58),(59.53,43.58),(59.53,0.06),(59.27,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.0),(59.27,43.64),(59.53,43.64),(59.53,0.0),(59.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,1.675),(64.085,1.965),(64.315,1.965),(64.315,1.675),(64.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,41.675),(44.885,41.965),(45.115,41.965),(45.115,41.675),(44.885,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,0.0),(49.685,43.64),(49.915,43.64),(49.915,0.0),(49.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.06),(49.67,43.58),(49.93,43.58),(49.93,0.06),(49.67,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,43.64),(49.93,43.64),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,2.775),(6.74,40.865),(6.97,40.865),(6.97,2.775),(6.74,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,41.675),(68.885,41.965),(69.115,41.965),(69.115,41.675),(68.885,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,41.675),(16.085,41.965),(16.315,41.965),(16.315,41.675),(16.085,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,2.775),(78.485,40.865),(78.715,40.865),(78.715,2.775),(78.485,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,2.775),(44.885,40.865),(45.115,40.865),(45.115,2.775),(44.885,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,1.675),(16.085,1.965),(16.315,1.965),(16.315,1.675),(16.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,0.0),(25.685,43.64),(25.915,43.64),(25.915,0.0),(25.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,2.775),(49.685,40.865),(49.915,40.865),(49.915,2.775),(49.685,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.06),(25.67,43.58),(25.93,43.58),(25.93,0.06),(25.67,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.0),(25.67,43.64),(25.93,43.64),(25.93,0.0),(25.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,2.775),(35.285,40.865),(35.515,40.865),(35.515,2.775),(35.285,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,41.675),(35.285,41.965),(35.515,41.965),(35.515,41.675),(35.285,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,1.675),(73.685,1.965),(73.915,1.965),(73.915,1.675),(73.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,1.675),(35.285,1.965),(35.515,1.965),(35.515,1.675),(35.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,0.0),(44.885,43.64),(45.115,43.64),(45.115,0.0),(44.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.06),(44.87,43.58),(45.13,43.58),(45.13,0.06),(44.87,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,43.64),(45.13,43.64),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,2.775),(25.685,40.865),(25.915,40.865),(25.915,2.775),(25.685,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,41.675),(6.74,41.965),(6.97,41.965),(6.97,41.675),(6.74,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.06),(6.725,43.58),(6.985,43.58),(6.985,0.06),(6.725,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,0.0),(6.74,43.64),(6.97,43.64),(6.97,0.0),(6.74,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.0),(6.725,43.64),(6.985,43.64),(6.985,0.0),(6.725,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,1.675),(25.685,1.965),(25.915,1.965),(25.915,1.675),(25.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,41.675),(78.485,41.965),(78.715,41.965),(78.715,41.675),(78.485,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,2.775),(59.285,40.865),(59.515,40.865),(59.515,2.775),(59.285,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,41.675),(59.285,41.965),(59.515,41.965),(59.515,41.675),(59.285,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,2.775),(73.685,40.865),(73.915,40.865),(73.915,2.775),(73.685,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,1.675),(20.885,1.965),(21.115,1.965),(21.115,1.675),(20.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,1.675),(78.485,1.965),(78.715,1.965),(78.715,1.675),(78.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,1.675),(59.285,1.965),(59.515,1.965),(59.515,1.675),(59.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,41.675),(49.685,41.965),(49.915,41.965),(49.915,41.675),(49.685,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,21.67),(86.14,21.67),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,0.0),(40.085,43.64),(40.315,43.64),(40.315,0.0),(40.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.06),(40.07,43.58),(40.33,43.58),(40.33,0.06),(40.07,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,43.64),(40.33,43.64),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,1.675),(54.485,1.965),(54.715,1.965),(54.715,1.675),(54.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,2.775),(20.885,40.865),(21.115,40.865),(21.115,2.775),(20.885,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,21.38),(85.55,21.67),(86.14,21.67),(86.14,21.38),(85.55,21.38)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,41.675),(40.085,41.965),(40.315,41.965),(40.315,41.675),(40.085,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,41.675),(73.685,41.965),(73.915,41.965),(73.915,41.675),(73.685,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,2.775),(64.085,40.865),(64.315,40.865),(64.315,2.775),(64.085,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,1.965),(86.14,1.965),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,41.675),(30.485,41.965),(30.715,41.965),(30.715,41.675),(30.485,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,1.675),(83.03,1.965),(83.26,1.965),(83.26,1.675),(83.03,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,1.675),(11.285,1.965),(11.515,1.965),(11.515,1.675),(11.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,1.675),(6.74,1.965),(6.97,1.965),(6.97,1.675),(6.74,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,1.675),(44.885,1.965),(45.115,1.965),(45.115,1.675),(44.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,0.0),(20.885,43.64),(21.115,43.64),(21.115,0.0),(20.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.06),(20.87,43.58),(21.13,43.58),(21.13,0.06),(20.87,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.0),(20.87,43.64),(21.13,43.64),(21.13,0.0),(20.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,2.775),(30.485,40.865),(30.715,40.865),(30.715,2.775),(30.485,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,2.775),(16.085,40.865),(16.315,40.865),(16.315,2.775),(16.085,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,1.675),(68.885,1.965),(69.115,1.965),(69.115,1.675),(68.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,0.0),(68.885,43.64),(69.115,43.64),(69.115,0.0),(68.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.06),(68.87,43.58),(69.13,43.58),(69.13,0.06),(68.87,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.0),(68.87,43.64),(69.13,43.64),(69.13,0.0),(68.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,0.0),(78.485,43.64),(78.715,43.64),(78.715,0.0),(78.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,1.675),(49.685,1.965),(49.915,1.965),(49.915,1.675),(49.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.06),(78.47,43.58),(78.73,43.58),(78.73,0.06),(78.47,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.0),(78.47,43.64),(78.73,43.64),(78.73,0.0),(78.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,0.0),(83.03,43.64),(83.26,43.64),(83.26,0.0),(83.03,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.06),(83.015,43.58),(83.275,43.58),(83.275,0.06),(83.015,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.06),(11.27,43.58),(11.53,43.58),(11.53,0.06),(11.27,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,0.0),(11.285,43.64),(11.515,43.64),(11.515,0.0),(11.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.0),(83.015,43.64),(83.275,43.64),(83.275,0.0),(83.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.0),(11.27,43.64),(11.53,43.64),(11.53,0.0),(11.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,0.0),(64.085,43.64),(64.315,43.64),(64.315,0.0),(64.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.06),(64.07,43.58),(64.33,43.58),(64.33,0.06),(64.07,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.0),(64.07,43.64),(64.33,43.64),(64.33,0.0),(64.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,2.775),(83.03,40.865),(83.26,40.865),(83.26,2.775),(83.03,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,41.675),(83.03,41.965),(83.26,41.965),(83.26,41.675),(83.03,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,41.675),(11.285,41.965),(11.515,41.965),(11.515,41.675),(11.285,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,41.675),(20.885,41.965),(21.115,41.965),(21.115,41.675),(20.885,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,0.0),(30.485,43.64),(30.715,43.64),(30.715,0.0),(30.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.06),(30.47,43.58),(30.73,43.58),(30.73,0.06),(30.47,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.0),(30.47,43.64),(30.73,43.64),(30.73,0.0),(30.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,41.675),(54.485,41.965),(54.715,41.965),(54.715,41.675),(54.485,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,2.775),(68.885,40.865),(69.115,40.865),(69.115,2.775),(68.885,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,1.675),(30.485,1.965),(30.715,1.965),(30.715,1.675),(30.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,41.675),(64.085,41.965),(64.315,41.965),(64.315,41.675),(64.085,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,2.775),(54.485,40.865),(54.715,40.865),(54.715,2.775),(54.485,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.145),(11.325,0.295),(11.475,0.295),(11.475,0.145),(11.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.465),(11.325,0.615),(11.475,0.615),(11.475,0.465),(11.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.785),(11.325,0.935),(11.475,0.935),(11.475,0.785),(11.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.105),(11.325,1.255),(11.475,1.255),(11.475,1.105),(11.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.425),(11.325,1.575),(11.475,1.575),(11.475,1.425),(11.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.745),(11.325,1.895),(11.475,1.895),(11.475,1.745),(11.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.065),(11.325,2.215),(11.475,2.215),(11.475,2.065),(11.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.385),(11.325,2.535),(11.475,2.535),(11.475,2.385),(11.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.705),(11.325,2.855),(11.475,2.855),(11.475,2.705),(11.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.025),(11.325,3.175),(11.475,3.175),(11.475,3.025),(11.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.345),(11.325,3.495),(11.475,3.495),(11.475,3.345),(11.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.665),(11.325,3.815),(11.475,3.815),(11.475,3.665),(11.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.985),(11.325,4.135),(11.475,4.135),(11.475,3.985),(11.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.305),(11.325,4.455),(11.475,4.455),(11.475,4.305),(11.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.625),(11.325,4.775),(11.475,4.775),(11.475,4.625),(11.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.945),(11.325,5.095),(11.475,5.095),(11.475,4.945),(11.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.265),(11.325,5.415),(11.475,5.415),(11.475,5.265),(11.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.585),(11.325,5.735),(11.475,5.735),(11.475,5.585),(11.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.905),(11.325,6.055),(11.475,6.055),(11.475,5.905),(11.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.225),(11.325,6.375),(11.475,6.375),(11.475,6.225),(11.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.545),(11.325,6.695),(11.475,6.695),(11.475,6.545),(11.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.865),(11.325,7.015),(11.475,7.015),(11.475,6.865),(11.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.185),(11.325,7.335),(11.475,7.335),(11.475,7.185),(11.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.505),(11.325,7.655),(11.475,7.655),(11.475,7.505),(11.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.825),(11.325,7.975),(11.475,7.975),(11.475,7.825),(11.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.145),(11.325,8.295),(11.475,8.295),(11.475,8.145),(11.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.465),(11.325,8.615),(11.475,8.615),(11.475,8.465),(11.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.785),(11.325,8.935),(11.475,8.935),(11.475,8.785),(11.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.105),(11.325,9.255),(11.475,9.255),(11.475,9.105),(11.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.425),(11.325,9.575),(11.475,9.575),(11.475,9.425),(11.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.745),(11.325,9.895),(11.475,9.895),(11.475,9.745),(11.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.065),(11.325,10.215),(11.475,10.215),(11.475,10.065),(11.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.385),(11.325,10.535),(11.475,10.535),(11.475,10.385),(11.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.705),(11.325,10.855),(11.475,10.855),(11.475,10.705),(11.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.025),(11.325,11.175),(11.475,11.175),(11.475,11.025),(11.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.345),(11.325,11.495),(11.475,11.495),(11.475,11.345),(11.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.665),(11.325,11.815),(11.475,11.815),(11.475,11.665),(11.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.985),(11.325,12.135),(11.475,12.135),(11.475,11.985),(11.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.305),(11.325,12.455),(11.475,12.455),(11.475,12.305),(11.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.625),(11.325,12.775),(11.475,12.775),(11.475,12.625),(11.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.945),(11.325,13.095),(11.475,13.095),(11.475,12.945),(11.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.265),(11.325,13.415),(11.475,13.415),(11.475,13.265),(11.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.585),(11.325,13.735),(11.475,13.735),(11.475,13.585),(11.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.905),(11.325,14.055),(11.475,14.055),(11.475,13.905),(11.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.225),(11.325,14.375),(11.475,14.375),(11.475,14.225),(11.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.545),(11.325,14.695),(11.475,14.695),(11.475,14.545),(11.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.865),(11.325,15.015),(11.475,15.015),(11.475,14.865),(11.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.185),(11.325,15.335),(11.475,15.335),(11.475,15.185),(11.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.505),(11.325,15.655),(11.475,15.655),(11.475,15.505),(11.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.825),(11.325,15.975),(11.475,15.975),(11.475,15.825),(11.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.145),(11.325,16.295),(11.475,16.295),(11.475,16.145),(11.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.465),(11.325,16.615),(11.475,16.615),(11.475,16.465),(11.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.785),(11.325,16.935),(11.475,16.935),(11.475,16.785),(11.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.105),(11.325,17.255),(11.475,17.255),(11.475,17.105),(11.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.425),(11.325,17.575),(11.475,17.575),(11.475,17.425),(11.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.745),(11.325,17.895),(11.475,17.895),(11.475,17.745),(11.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.065),(11.325,18.215),(11.475,18.215),(11.475,18.065),(11.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.385),(11.325,18.535),(11.475,18.535),(11.475,18.385),(11.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.705),(11.325,18.855),(11.475,18.855),(11.475,18.705),(11.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.025),(11.325,19.175),(11.475,19.175),(11.475,19.025),(11.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.345),(11.325,19.495),(11.475,19.495),(11.475,19.345),(11.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.665),(11.325,19.815),(11.475,19.815),(11.475,19.665),(11.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.985),(11.325,20.135),(11.475,20.135),(11.475,19.985),(11.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.305),(11.325,20.455),(11.475,20.455),(11.475,20.305),(11.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.625),(11.325,20.775),(11.475,20.775),(11.475,20.625),(11.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.945),(11.325,21.095),(11.475,21.095),(11.475,20.945),(11.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.265),(11.325,21.415),(11.475,21.415),(11.475,21.265),(11.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.585),(11.325,21.735),(11.475,21.735),(11.475,21.585),(11.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.905),(11.325,22.055),(11.475,22.055),(11.475,21.905),(11.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,22.225),(11.325,22.375),(11.475,22.375),(11.475,22.225),(11.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,22.545),(11.325,22.695),(11.475,22.695),(11.475,22.545),(11.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,22.865),(11.325,23.015),(11.475,23.015),(11.475,22.865),(11.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,23.185),(11.325,23.335),(11.475,23.335),(11.475,23.185),(11.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,23.505),(11.325,23.655),(11.475,23.655),(11.475,23.505),(11.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,23.825),(11.325,23.975),(11.475,23.975),(11.475,23.825),(11.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,24.145),(11.325,24.295),(11.475,24.295),(11.475,24.145),(11.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,24.465),(11.325,24.615),(11.475,24.615),(11.475,24.465),(11.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,24.785),(11.325,24.935),(11.475,24.935),(11.475,24.785),(11.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,25.105),(11.325,25.255),(11.475,25.255),(11.475,25.105),(11.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,25.425),(11.325,25.575),(11.475,25.575),(11.475,25.425),(11.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,25.745),(11.325,25.895),(11.475,25.895),(11.475,25.745),(11.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,26.065),(11.325,26.215),(11.475,26.215),(11.475,26.065),(11.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,26.385),(11.325,26.535),(11.475,26.535),(11.475,26.385),(11.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,26.705),(11.325,26.855),(11.475,26.855),(11.475,26.705),(11.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.025),(11.325,27.175),(11.475,27.175),(11.475,27.025),(11.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.345),(11.325,27.495),(11.475,27.495),(11.475,27.345),(11.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.665),(11.325,27.815),(11.475,27.815),(11.475,27.665),(11.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,27.985),(11.325,28.135),(11.475,28.135),(11.475,27.985),(11.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,28.305),(11.325,28.455),(11.475,28.455),(11.475,28.305),(11.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,28.625),(11.325,28.775),(11.475,28.775),(11.475,28.625),(11.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,28.945),(11.325,29.095),(11.475,29.095),(11.475,28.945),(11.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,29.265),(11.325,29.415),(11.475,29.415),(11.475,29.265),(11.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,29.585),(11.325,29.735),(11.475,29.735),(11.475,29.585),(11.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,29.905),(11.325,30.055),(11.475,30.055),(11.475,29.905),(11.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,30.225),(11.325,30.375),(11.475,30.375),(11.475,30.225),(11.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,30.545),(11.325,30.695),(11.475,30.695),(11.475,30.545),(11.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,30.865),(11.325,31.015),(11.475,31.015),(11.475,30.865),(11.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,31.185),(11.325,31.335),(11.475,31.335),(11.475,31.185),(11.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,31.505),(11.325,31.655),(11.475,31.655),(11.475,31.505),(11.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,31.825),(11.325,31.975),(11.475,31.975),(11.475,31.825),(11.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,32.145),(11.325,32.295),(11.475,32.295),(11.475,32.145),(11.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,32.465),(11.325,32.615),(11.475,32.615),(11.475,32.465),(11.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,32.785),(11.325,32.935),(11.475,32.935),(11.475,32.785),(11.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,33.105),(11.325,33.255),(11.475,33.255),(11.475,33.105),(11.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,33.425),(11.325,33.575),(11.475,33.575),(11.475,33.425),(11.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,33.745),(11.325,33.895),(11.475,33.895),(11.475,33.745),(11.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,34.065),(11.325,34.215),(11.475,34.215),(11.475,34.065),(11.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,34.385),(11.325,34.535),(11.475,34.535),(11.475,34.385),(11.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,34.705),(11.325,34.855),(11.475,34.855),(11.475,34.705),(11.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.025),(11.325,35.175),(11.475,35.175),(11.475,35.025),(11.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.345),(11.325,35.495),(11.475,35.495),(11.475,35.345),(11.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.665),(11.325,35.815),(11.475,35.815),(11.475,35.665),(11.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,35.985),(11.325,36.135),(11.475,36.135),(11.475,35.985),(11.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,36.305),(11.325,36.455),(11.475,36.455),(11.475,36.305),(11.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,36.625),(11.325,36.775),(11.475,36.775),(11.475,36.625),(11.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,36.945),(11.325,37.095),(11.475,37.095),(11.475,36.945),(11.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,37.265),(11.325,37.415),(11.475,37.415),(11.475,37.265),(11.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,37.585),(11.325,37.735),(11.475,37.735),(11.475,37.585),(11.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,37.905),(11.325,38.055),(11.475,38.055),(11.475,37.905),(11.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,38.225),(11.325,38.375),(11.475,38.375),(11.475,38.225),(11.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,38.545),(11.325,38.695),(11.475,38.695),(11.475,38.545),(11.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,38.865),(11.325,39.015),(11.475,39.015),(11.475,38.865),(11.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,39.185),(11.325,39.335),(11.475,39.335),(11.475,39.185),(11.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,39.505),(11.325,39.655),(11.475,39.655),(11.475,39.505),(11.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,39.825),(11.325,39.975),(11.475,39.975),(11.475,39.825),(11.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,40.145),(11.325,40.295),(11.475,40.295),(11.475,40.145),(11.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,40.465),(11.325,40.615),(11.475,40.615),(11.475,40.465),(11.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,40.785),(11.325,40.935),(11.475,40.935),(11.475,40.785),(11.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,41.105),(11.325,41.255),(11.475,41.255),(11.475,41.105),(11.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,41.425),(11.325,41.575),(11.475,41.575),(11.475,41.425),(11.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,41.745),(11.325,41.895),(11.475,41.895),(11.475,41.745),(11.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,42.065),(11.325,42.215),(11.475,42.215),(11.475,42.065),(11.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,42.385),(11.325,42.535),(11.475,42.535),(11.475,42.385),(11.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,42.705),(11.325,42.855),(11.475,42.855),(11.475,42.705),(11.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,43.025),(11.325,43.175),(11.475,43.175),(11.475,43.025),(11.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,43.345),(11.325,43.495),(11.475,43.495),(11.475,43.345),(11.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.145),(35.325,0.295),(35.475,0.295),(35.475,0.145),(35.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.465),(35.325,0.615),(35.475,0.615),(35.475,0.465),(35.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.785),(35.325,0.935),(35.475,0.935),(35.475,0.785),(35.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.105),(35.325,1.255),(35.475,1.255),(35.475,1.105),(35.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.425),(35.325,1.575),(35.475,1.575),(35.475,1.425),(35.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.745),(35.325,1.895),(35.475,1.895),(35.475,1.745),(35.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.065),(35.325,2.215),(35.475,2.215),(35.475,2.065),(35.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.385),(35.325,2.535),(35.475,2.535),(35.475,2.385),(35.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.705),(35.325,2.855),(35.475,2.855),(35.475,2.705),(35.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.025),(35.325,3.175),(35.475,3.175),(35.475,3.025),(35.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.345),(35.325,3.495),(35.475,3.495),(35.475,3.345),(35.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.665),(35.325,3.815),(35.475,3.815),(35.475,3.665),(35.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.985),(35.325,4.135),(35.475,4.135),(35.475,3.985),(35.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.305),(35.325,4.455),(35.475,4.455),(35.475,4.305),(35.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.625),(35.325,4.775),(35.475,4.775),(35.475,4.625),(35.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.945),(35.325,5.095),(35.475,5.095),(35.475,4.945),(35.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.265),(35.325,5.415),(35.475,5.415),(35.475,5.265),(35.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.585),(35.325,5.735),(35.475,5.735),(35.475,5.585),(35.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.905),(35.325,6.055),(35.475,6.055),(35.475,5.905),(35.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.225),(35.325,6.375),(35.475,6.375),(35.475,6.225),(35.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.545),(35.325,6.695),(35.475,6.695),(35.475,6.545),(35.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.865),(35.325,7.015),(35.475,7.015),(35.475,6.865),(35.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.185),(35.325,7.335),(35.475,7.335),(35.475,7.185),(35.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.505),(35.325,7.655),(35.475,7.655),(35.475,7.505),(35.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.825),(35.325,7.975),(35.475,7.975),(35.475,7.825),(35.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.145),(35.325,8.295),(35.475,8.295),(35.475,8.145),(35.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.465),(35.325,8.615),(35.475,8.615),(35.475,8.465),(35.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.785),(35.325,8.935),(35.475,8.935),(35.475,8.785),(35.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.105),(35.325,9.255),(35.475,9.255),(35.475,9.105),(35.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.425),(35.325,9.575),(35.475,9.575),(35.475,9.425),(35.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.745),(35.325,9.895),(35.475,9.895),(35.475,9.745),(35.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.065),(35.325,10.215),(35.475,10.215),(35.475,10.065),(35.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.385),(35.325,10.535),(35.475,10.535),(35.475,10.385),(35.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.705),(35.325,10.855),(35.475,10.855),(35.475,10.705),(35.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.025),(35.325,11.175),(35.475,11.175),(35.475,11.025),(35.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.345),(35.325,11.495),(35.475,11.495),(35.475,11.345),(35.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.665),(35.325,11.815),(35.475,11.815),(35.475,11.665),(35.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.985),(35.325,12.135),(35.475,12.135),(35.475,11.985),(35.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.305),(35.325,12.455),(35.475,12.455),(35.475,12.305),(35.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.625),(35.325,12.775),(35.475,12.775),(35.475,12.625),(35.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.945),(35.325,13.095),(35.475,13.095),(35.475,12.945),(35.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.265),(35.325,13.415),(35.475,13.415),(35.475,13.265),(35.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.585),(35.325,13.735),(35.475,13.735),(35.475,13.585),(35.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.905),(35.325,14.055),(35.475,14.055),(35.475,13.905),(35.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.225),(35.325,14.375),(35.475,14.375),(35.475,14.225),(35.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.545),(35.325,14.695),(35.475,14.695),(35.475,14.545),(35.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.865),(35.325,15.015),(35.475,15.015),(35.475,14.865),(35.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.185),(35.325,15.335),(35.475,15.335),(35.475,15.185),(35.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.505),(35.325,15.655),(35.475,15.655),(35.475,15.505),(35.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.825),(35.325,15.975),(35.475,15.975),(35.475,15.825),(35.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.145),(35.325,16.295),(35.475,16.295),(35.475,16.145),(35.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.465),(35.325,16.615),(35.475,16.615),(35.475,16.465),(35.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.785),(35.325,16.935),(35.475,16.935),(35.475,16.785),(35.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.105),(35.325,17.255),(35.475,17.255),(35.475,17.105),(35.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.425),(35.325,17.575),(35.475,17.575),(35.475,17.425),(35.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.745),(35.325,17.895),(35.475,17.895),(35.475,17.745),(35.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.065),(35.325,18.215),(35.475,18.215),(35.475,18.065),(35.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.385),(35.325,18.535),(35.475,18.535),(35.475,18.385),(35.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.705),(35.325,18.855),(35.475,18.855),(35.475,18.705),(35.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.025),(35.325,19.175),(35.475,19.175),(35.475,19.025),(35.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.345),(35.325,19.495),(35.475,19.495),(35.475,19.345),(35.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.665),(35.325,19.815),(35.475,19.815),(35.475,19.665),(35.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.985),(35.325,20.135),(35.475,20.135),(35.475,19.985),(35.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.305),(35.325,20.455),(35.475,20.455),(35.475,20.305),(35.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.625),(35.325,20.775),(35.475,20.775),(35.475,20.625),(35.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.945),(35.325,21.095),(35.475,21.095),(35.475,20.945),(35.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.265),(35.325,21.415),(35.475,21.415),(35.475,21.265),(35.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.585),(35.325,21.735),(35.475,21.735),(35.475,21.585),(35.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.905),(35.325,22.055),(35.475,22.055),(35.475,21.905),(35.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.225),(35.325,22.375),(35.475,22.375),(35.475,22.225),(35.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.545),(35.325,22.695),(35.475,22.695),(35.475,22.545),(35.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.865),(35.325,23.015),(35.475,23.015),(35.475,22.865),(35.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.185),(35.325,23.335),(35.475,23.335),(35.475,23.185),(35.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.505),(35.325,23.655),(35.475,23.655),(35.475,23.505),(35.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.825),(35.325,23.975),(35.475,23.975),(35.475,23.825),(35.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.145),(35.325,24.295),(35.475,24.295),(35.475,24.145),(35.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.465),(35.325,24.615),(35.475,24.615),(35.475,24.465),(35.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.785),(35.325,24.935),(35.475,24.935),(35.475,24.785),(35.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.105),(35.325,25.255),(35.475,25.255),(35.475,25.105),(35.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.425),(35.325,25.575),(35.475,25.575),(35.475,25.425),(35.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.745),(35.325,25.895),(35.475,25.895),(35.475,25.745),(35.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.065),(35.325,26.215),(35.475,26.215),(35.475,26.065),(35.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.385),(35.325,26.535),(35.475,26.535),(35.475,26.385),(35.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.705),(35.325,26.855),(35.475,26.855),(35.475,26.705),(35.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.025),(35.325,27.175),(35.475,27.175),(35.475,27.025),(35.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.345),(35.325,27.495),(35.475,27.495),(35.475,27.345),(35.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.665),(35.325,27.815),(35.475,27.815),(35.475,27.665),(35.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.985),(35.325,28.135),(35.475,28.135),(35.475,27.985),(35.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.305),(35.325,28.455),(35.475,28.455),(35.475,28.305),(35.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.625),(35.325,28.775),(35.475,28.775),(35.475,28.625),(35.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.945),(35.325,29.095),(35.475,29.095),(35.475,28.945),(35.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.265),(35.325,29.415),(35.475,29.415),(35.475,29.265),(35.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.585),(35.325,29.735),(35.475,29.735),(35.475,29.585),(35.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.905),(35.325,30.055),(35.475,30.055),(35.475,29.905),(35.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.225),(35.325,30.375),(35.475,30.375),(35.475,30.225),(35.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.545),(35.325,30.695),(35.475,30.695),(35.475,30.545),(35.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.865),(35.325,31.015),(35.475,31.015),(35.475,30.865),(35.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.185),(35.325,31.335),(35.475,31.335),(35.475,31.185),(35.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.505),(35.325,31.655),(35.475,31.655),(35.475,31.505),(35.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.825),(35.325,31.975),(35.475,31.975),(35.475,31.825),(35.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.145),(35.325,32.295),(35.475,32.295),(35.475,32.145),(35.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.465),(35.325,32.615),(35.475,32.615),(35.475,32.465),(35.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.785),(35.325,32.935),(35.475,32.935),(35.475,32.785),(35.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.105),(35.325,33.255),(35.475,33.255),(35.475,33.105),(35.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.425),(35.325,33.575),(35.475,33.575),(35.475,33.425),(35.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.745),(35.325,33.895),(35.475,33.895),(35.475,33.745),(35.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.065),(35.325,34.215),(35.475,34.215),(35.475,34.065),(35.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.385),(35.325,34.535),(35.475,34.535),(35.475,34.385),(35.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.705),(35.325,34.855),(35.475,34.855),(35.475,34.705),(35.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.025),(35.325,35.175),(35.475,35.175),(35.475,35.025),(35.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.345),(35.325,35.495),(35.475,35.495),(35.475,35.345),(35.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.665),(35.325,35.815),(35.475,35.815),(35.475,35.665),(35.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.985),(35.325,36.135),(35.475,36.135),(35.475,35.985),(35.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.305),(35.325,36.455),(35.475,36.455),(35.475,36.305),(35.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.625),(35.325,36.775),(35.475,36.775),(35.475,36.625),(35.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.945),(35.325,37.095),(35.475,37.095),(35.475,36.945),(35.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.265),(35.325,37.415),(35.475,37.415),(35.475,37.265),(35.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.585),(35.325,37.735),(35.475,37.735),(35.475,37.585),(35.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.905),(35.325,38.055),(35.475,38.055),(35.475,37.905),(35.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.225),(35.325,38.375),(35.475,38.375),(35.475,38.225),(35.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.545),(35.325,38.695),(35.475,38.695),(35.475,38.545),(35.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.865),(35.325,39.015),(35.475,39.015),(35.475,38.865),(35.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.185),(35.325,39.335),(35.475,39.335),(35.475,39.185),(35.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.505),(35.325,39.655),(35.475,39.655),(35.475,39.505),(35.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.825),(35.325,39.975),(35.475,39.975),(35.475,39.825),(35.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.145),(35.325,40.295),(35.475,40.295),(35.475,40.145),(35.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.465),(35.325,40.615),(35.475,40.615),(35.475,40.465),(35.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.785),(35.325,40.935),(35.475,40.935),(35.475,40.785),(35.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.105),(35.325,41.255),(35.475,41.255),(35.475,41.105),(35.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.425),(35.325,41.575),(35.475,41.575),(35.475,41.425),(35.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.745),(35.325,41.895),(35.475,41.895),(35.475,41.745),(35.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.065),(35.325,42.215),(35.475,42.215),(35.475,42.065),(35.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.385),(35.325,42.535),(35.475,42.535),(35.475,42.385),(35.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.705),(35.325,42.855),(35.475,42.855),(35.475,42.705),(35.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,43.025),(35.325,43.175),(35.475,43.175),(35.475,43.025),(35.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,43.345),(35.325,43.495),(35.475,43.495),(35.475,43.345),(35.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.145),(40.125,0.295),(40.275,0.295),(40.275,0.145),(40.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.465),(40.125,0.615),(40.275,0.615),(40.275,0.465),(40.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.785),(40.125,0.935),(40.275,0.935),(40.275,0.785),(40.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.105),(40.125,1.255),(40.275,1.255),(40.275,1.105),(40.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.425),(40.125,1.575),(40.275,1.575),(40.275,1.425),(40.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.745),(40.125,1.895),(40.275,1.895),(40.275,1.745),(40.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.065),(40.125,2.215),(40.275,2.215),(40.275,2.065),(40.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.385),(40.125,2.535),(40.275,2.535),(40.275,2.385),(40.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.705),(40.125,2.855),(40.275,2.855),(40.275,2.705),(40.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.025),(40.125,3.175),(40.275,3.175),(40.275,3.025),(40.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.345),(40.125,3.495),(40.275,3.495),(40.275,3.345),(40.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.665),(40.125,3.815),(40.275,3.815),(40.275,3.665),(40.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.985),(40.125,4.135),(40.275,4.135),(40.275,3.985),(40.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.305),(40.125,4.455),(40.275,4.455),(40.275,4.305),(40.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.625),(40.125,4.775),(40.275,4.775),(40.275,4.625),(40.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.945),(40.125,5.095),(40.275,5.095),(40.275,4.945),(40.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.265),(40.125,5.415),(40.275,5.415),(40.275,5.265),(40.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.585),(40.125,5.735),(40.275,5.735),(40.275,5.585),(40.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.905),(40.125,6.055),(40.275,6.055),(40.275,5.905),(40.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.225),(40.125,6.375),(40.275,6.375),(40.275,6.225),(40.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.545),(40.125,6.695),(40.275,6.695),(40.275,6.545),(40.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.865),(40.125,7.015),(40.275,7.015),(40.275,6.865),(40.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.185),(40.125,7.335),(40.275,7.335),(40.275,7.185),(40.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.505),(40.125,7.655),(40.275,7.655),(40.275,7.505),(40.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.825),(40.125,7.975),(40.275,7.975),(40.275,7.825),(40.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.145),(40.125,8.295),(40.275,8.295),(40.275,8.145),(40.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.465),(40.125,8.615),(40.275,8.615),(40.275,8.465),(40.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.785),(40.125,8.935),(40.275,8.935),(40.275,8.785),(40.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.105),(40.125,9.255),(40.275,9.255),(40.275,9.105),(40.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.425),(40.125,9.575),(40.275,9.575),(40.275,9.425),(40.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.745),(40.125,9.895),(40.275,9.895),(40.275,9.745),(40.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.065),(40.125,10.215),(40.275,10.215),(40.275,10.065),(40.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.385),(40.125,10.535),(40.275,10.535),(40.275,10.385),(40.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.705),(40.125,10.855),(40.275,10.855),(40.275,10.705),(40.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.025),(40.125,11.175),(40.275,11.175),(40.275,11.025),(40.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.345),(40.125,11.495),(40.275,11.495),(40.275,11.345),(40.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.665),(40.125,11.815),(40.275,11.815),(40.275,11.665),(40.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.985),(40.125,12.135),(40.275,12.135),(40.275,11.985),(40.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.305),(40.125,12.455),(40.275,12.455),(40.275,12.305),(40.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.625),(40.125,12.775),(40.275,12.775),(40.275,12.625),(40.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.945),(40.125,13.095),(40.275,13.095),(40.275,12.945),(40.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.265),(40.125,13.415),(40.275,13.415),(40.275,13.265),(40.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.585),(40.125,13.735),(40.275,13.735),(40.275,13.585),(40.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.905),(40.125,14.055),(40.275,14.055),(40.275,13.905),(40.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.225),(40.125,14.375),(40.275,14.375),(40.275,14.225),(40.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.545),(40.125,14.695),(40.275,14.695),(40.275,14.545),(40.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.865),(40.125,15.015),(40.275,15.015),(40.275,14.865),(40.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.185),(40.125,15.335),(40.275,15.335),(40.275,15.185),(40.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.505),(40.125,15.655),(40.275,15.655),(40.275,15.505),(40.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.825),(40.125,15.975),(40.275,15.975),(40.275,15.825),(40.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.145),(40.125,16.295),(40.275,16.295),(40.275,16.145),(40.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.465),(40.125,16.615),(40.275,16.615),(40.275,16.465),(40.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.785),(40.125,16.935),(40.275,16.935),(40.275,16.785),(40.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.105),(40.125,17.255),(40.275,17.255),(40.275,17.105),(40.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.425),(40.125,17.575),(40.275,17.575),(40.275,17.425),(40.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.745),(40.125,17.895),(40.275,17.895),(40.275,17.745),(40.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.065),(40.125,18.215),(40.275,18.215),(40.275,18.065),(40.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.385),(40.125,18.535),(40.275,18.535),(40.275,18.385),(40.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.705),(40.125,18.855),(40.275,18.855),(40.275,18.705),(40.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.025),(40.125,19.175),(40.275,19.175),(40.275,19.025),(40.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.345),(40.125,19.495),(40.275,19.495),(40.275,19.345),(40.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.665),(40.125,19.815),(40.275,19.815),(40.275,19.665),(40.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.985),(40.125,20.135),(40.275,20.135),(40.275,19.985),(40.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.305),(40.125,20.455),(40.275,20.455),(40.275,20.305),(40.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.625),(40.125,20.775),(40.275,20.775),(40.275,20.625),(40.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.945),(40.125,21.095),(40.275,21.095),(40.275,20.945),(40.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.265),(40.125,21.415),(40.275,21.415),(40.275,21.265),(40.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.585),(40.125,21.735),(40.275,21.735),(40.275,21.585),(40.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.905),(40.125,22.055),(40.275,22.055),(40.275,21.905),(40.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.225),(40.125,22.375),(40.275,22.375),(40.275,22.225),(40.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.545),(40.125,22.695),(40.275,22.695),(40.275,22.545),(40.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.865),(40.125,23.015),(40.275,23.015),(40.275,22.865),(40.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.185),(40.125,23.335),(40.275,23.335),(40.275,23.185),(40.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.505),(40.125,23.655),(40.275,23.655),(40.275,23.505),(40.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.825),(40.125,23.975),(40.275,23.975),(40.275,23.825),(40.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.145),(40.125,24.295),(40.275,24.295),(40.275,24.145),(40.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.465),(40.125,24.615),(40.275,24.615),(40.275,24.465),(40.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.785),(40.125,24.935),(40.275,24.935),(40.275,24.785),(40.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.105),(40.125,25.255),(40.275,25.255),(40.275,25.105),(40.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.425),(40.125,25.575),(40.275,25.575),(40.275,25.425),(40.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.745),(40.125,25.895),(40.275,25.895),(40.275,25.745),(40.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.065),(40.125,26.215),(40.275,26.215),(40.275,26.065),(40.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.385),(40.125,26.535),(40.275,26.535),(40.275,26.385),(40.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.705),(40.125,26.855),(40.275,26.855),(40.275,26.705),(40.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.025),(40.125,27.175),(40.275,27.175),(40.275,27.025),(40.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.345),(40.125,27.495),(40.275,27.495),(40.275,27.345),(40.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.665),(40.125,27.815),(40.275,27.815),(40.275,27.665),(40.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.985),(40.125,28.135),(40.275,28.135),(40.275,27.985),(40.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.305),(40.125,28.455),(40.275,28.455),(40.275,28.305),(40.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.625),(40.125,28.775),(40.275,28.775),(40.275,28.625),(40.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.945),(40.125,29.095),(40.275,29.095),(40.275,28.945),(40.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.265),(40.125,29.415),(40.275,29.415),(40.275,29.265),(40.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.585),(40.125,29.735),(40.275,29.735),(40.275,29.585),(40.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.905),(40.125,30.055),(40.275,30.055),(40.275,29.905),(40.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.225),(40.125,30.375),(40.275,30.375),(40.275,30.225),(40.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.545),(40.125,30.695),(40.275,30.695),(40.275,30.545),(40.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.865),(40.125,31.015),(40.275,31.015),(40.275,30.865),(40.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.185),(40.125,31.335),(40.275,31.335),(40.275,31.185),(40.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.505),(40.125,31.655),(40.275,31.655),(40.275,31.505),(40.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.825),(40.125,31.975),(40.275,31.975),(40.275,31.825),(40.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.145),(40.125,32.295),(40.275,32.295),(40.275,32.145),(40.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.465),(40.125,32.615),(40.275,32.615),(40.275,32.465),(40.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.785),(40.125,32.935),(40.275,32.935),(40.275,32.785),(40.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.105),(40.125,33.255),(40.275,33.255),(40.275,33.105),(40.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.425),(40.125,33.575),(40.275,33.575),(40.275,33.425),(40.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.745),(40.125,33.895),(40.275,33.895),(40.275,33.745),(40.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.065),(40.125,34.215),(40.275,34.215),(40.275,34.065),(40.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.385),(40.125,34.535),(40.275,34.535),(40.275,34.385),(40.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.705),(40.125,34.855),(40.275,34.855),(40.275,34.705),(40.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.025),(40.125,35.175),(40.275,35.175),(40.275,35.025),(40.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.345),(40.125,35.495),(40.275,35.495),(40.275,35.345),(40.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.665),(40.125,35.815),(40.275,35.815),(40.275,35.665),(40.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.985),(40.125,36.135),(40.275,36.135),(40.275,35.985),(40.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.305),(40.125,36.455),(40.275,36.455),(40.275,36.305),(40.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.625),(40.125,36.775),(40.275,36.775),(40.275,36.625),(40.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.945),(40.125,37.095),(40.275,37.095),(40.275,36.945),(40.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.265),(40.125,37.415),(40.275,37.415),(40.275,37.265),(40.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.585),(40.125,37.735),(40.275,37.735),(40.275,37.585),(40.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.905),(40.125,38.055),(40.275,38.055),(40.275,37.905),(40.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.225),(40.125,38.375),(40.275,38.375),(40.275,38.225),(40.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.545),(40.125,38.695),(40.275,38.695),(40.275,38.545),(40.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.865),(40.125,39.015),(40.275,39.015),(40.275,38.865),(40.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.185),(40.125,39.335),(40.275,39.335),(40.275,39.185),(40.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.505),(40.125,39.655),(40.275,39.655),(40.275,39.505),(40.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.825),(40.125,39.975),(40.275,39.975),(40.275,39.825),(40.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.145),(40.125,40.295),(40.275,40.295),(40.275,40.145),(40.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.465),(40.125,40.615),(40.275,40.615),(40.275,40.465),(40.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.785),(40.125,40.935),(40.275,40.935),(40.275,40.785),(40.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.105),(40.125,41.255),(40.275,41.255),(40.275,41.105),(40.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.425),(40.125,41.575),(40.275,41.575),(40.275,41.425),(40.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.745),(40.125,41.895),(40.275,41.895),(40.275,41.745),(40.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.065),(40.125,42.215),(40.275,42.215),(40.275,42.065),(40.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.385),(40.125,42.535),(40.275,42.535),(40.275,42.385),(40.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.705),(40.125,42.855),(40.275,42.855),(40.275,42.705),(40.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,43.025),(40.125,43.175),(40.275,43.175),(40.275,43.025),(40.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,43.345),(40.125,43.495),(40.275,43.495),(40.275,43.345),(40.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.145),(16.125,0.295),(16.275,0.295),(16.275,0.145),(16.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.465),(16.125,0.615),(16.275,0.615),(16.275,0.465),(16.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.785),(16.125,0.935),(16.275,0.935),(16.275,0.785),(16.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.105),(16.125,1.255),(16.275,1.255),(16.275,1.105),(16.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.425),(16.125,1.575),(16.275,1.575),(16.275,1.425),(16.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.745),(16.125,1.895),(16.275,1.895),(16.275,1.745),(16.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.065),(16.125,2.215),(16.275,2.215),(16.275,2.065),(16.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.385),(16.125,2.535),(16.275,2.535),(16.275,2.385),(16.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.705),(16.125,2.855),(16.275,2.855),(16.275,2.705),(16.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.025),(16.125,3.175),(16.275,3.175),(16.275,3.025),(16.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.345),(16.125,3.495),(16.275,3.495),(16.275,3.345),(16.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.665),(16.125,3.815),(16.275,3.815),(16.275,3.665),(16.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.985),(16.125,4.135),(16.275,4.135),(16.275,3.985),(16.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.305),(16.125,4.455),(16.275,4.455),(16.275,4.305),(16.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.625),(16.125,4.775),(16.275,4.775),(16.275,4.625),(16.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.945),(16.125,5.095),(16.275,5.095),(16.275,4.945),(16.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.265),(16.125,5.415),(16.275,5.415),(16.275,5.265),(16.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.585),(16.125,5.735),(16.275,5.735),(16.275,5.585),(16.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.905),(16.125,6.055),(16.275,6.055),(16.275,5.905),(16.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.225),(16.125,6.375),(16.275,6.375),(16.275,6.225),(16.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.545),(16.125,6.695),(16.275,6.695),(16.275,6.545),(16.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.865),(16.125,7.015),(16.275,7.015),(16.275,6.865),(16.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.185),(16.125,7.335),(16.275,7.335),(16.275,7.185),(16.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.505),(16.125,7.655),(16.275,7.655),(16.275,7.505),(16.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.825),(16.125,7.975),(16.275,7.975),(16.275,7.825),(16.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.145),(16.125,8.295),(16.275,8.295),(16.275,8.145),(16.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.465),(16.125,8.615),(16.275,8.615),(16.275,8.465),(16.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.785),(16.125,8.935),(16.275,8.935),(16.275,8.785),(16.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.105),(16.125,9.255),(16.275,9.255),(16.275,9.105),(16.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.425),(16.125,9.575),(16.275,9.575),(16.275,9.425),(16.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.745),(16.125,9.895),(16.275,9.895),(16.275,9.745),(16.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.065),(16.125,10.215),(16.275,10.215),(16.275,10.065),(16.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.385),(16.125,10.535),(16.275,10.535),(16.275,10.385),(16.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.705),(16.125,10.855),(16.275,10.855),(16.275,10.705),(16.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.025),(16.125,11.175),(16.275,11.175),(16.275,11.025),(16.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.345),(16.125,11.495),(16.275,11.495),(16.275,11.345),(16.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.665),(16.125,11.815),(16.275,11.815),(16.275,11.665),(16.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.985),(16.125,12.135),(16.275,12.135),(16.275,11.985),(16.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.305),(16.125,12.455),(16.275,12.455),(16.275,12.305),(16.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.625),(16.125,12.775),(16.275,12.775),(16.275,12.625),(16.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.945),(16.125,13.095),(16.275,13.095),(16.275,12.945),(16.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.265),(16.125,13.415),(16.275,13.415),(16.275,13.265),(16.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.585),(16.125,13.735),(16.275,13.735),(16.275,13.585),(16.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.905),(16.125,14.055),(16.275,14.055),(16.275,13.905),(16.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.225),(16.125,14.375),(16.275,14.375),(16.275,14.225),(16.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.545),(16.125,14.695),(16.275,14.695),(16.275,14.545),(16.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.865),(16.125,15.015),(16.275,15.015),(16.275,14.865),(16.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.185),(16.125,15.335),(16.275,15.335),(16.275,15.185),(16.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.505),(16.125,15.655),(16.275,15.655),(16.275,15.505),(16.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.825),(16.125,15.975),(16.275,15.975),(16.275,15.825),(16.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.145),(16.125,16.295),(16.275,16.295),(16.275,16.145),(16.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.465),(16.125,16.615),(16.275,16.615),(16.275,16.465),(16.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.785),(16.125,16.935),(16.275,16.935),(16.275,16.785),(16.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.105),(16.125,17.255),(16.275,17.255),(16.275,17.105),(16.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.425),(16.125,17.575),(16.275,17.575),(16.275,17.425),(16.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.745),(16.125,17.895),(16.275,17.895),(16.275,17.745),(16.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.065),(16.125,18.215),(16.275,18.215),(16.275,18.065),(16.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.385),(16.125,18.535),(16.275,18.535),(16.275,18.385),(16.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.705),(16.125,18.855),(16.275,18.855),(16.275,18.705),(16.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.025),(16.125,19.175),(16.275,19.175),(16.275,19.025),(16.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.345),(16.125,19.495),(16.275,19.495),(16.275,19.345),(16.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.665),(16.125,19.815),(16.275,19.815),(16.275,19.665),(16.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.985),(16.125,20.135),(16.275,20.135),(16.275,19.985),(16.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.305),(16.125,20.455),(16.275,20.455),(16.275,20.305),(16.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.625),(16.125,20.775),(16.275,20.775),(16.275,20.625),(16.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.945),(16.125,21.095),(16.275,21.095),(16.275,20.945),(16.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.265),(16.125,21.415),(16.275,21.415),(16.275,21.265),(16.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.585),(16.125,21.735),(16.275,21.735),(16.275,21.585),(16.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.905),(16.125,22.055),(16.275,22.055),(16.275,21.905),(16.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,22.225),(16.125,22.375),(16.275,22.375),(16.275,22.225),(16.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,22.545),(16.125,22.695),(16.275,22.695),(16.275,22.545),(16.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,22.865),(16.125,23.015),(16.275,23.015),(16.275,22.865),(16.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,23.185),(16.125,23.335),(16.275,23.335),(16.275,23.185),(16.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,23.505),(16.125,23.655),(16.275,23.655),(16.275,23.505),(16.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,23.825),(16.125,23.975),(16.275,23.975),(16.275,23.825),(16.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,24.145),(16.125,24.295),(16.275,24.295),(16.275,24.145),(16.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,24.465),(16.125,24.615),(16.275,24.615),(16.275,24.465),(16.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,24.785),(16.125,24.935),(16.275,24.935),(16.275,24.785),(16.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,25.105),(16.125,25.255),(16.275,25.255),(16.275,25.105),(16.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,25.425),(16.125,25.575),(16.275,25.575),(16.275,25.425),(16.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,25.745),(16.125,25.895),(16.275,25.895),(16.275,25.745),(16.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,26.065),(16.125,26.215),(16.275,26.215),(16.275,26.065),(16.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,26.385),(16.125,26.535),(16.275,26.535),(16.275,26.385),(16.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,26.705),(16.125,26.855),(16.275,26.855),(16.275,26.705),(16.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.025),(16.125,27.175),(16.275,27.175),(16.275,27.025),(16.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.345),(16.125,27.495),(16.275,27.495),(16.275,27.345),(16.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.665),(16.125,27.815),(16.275,27.815),(16.275,27.665),(16.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,27.985),(16.125,28.135),(16.275,28.135),(16.275,27.985),(16.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,28.305),(16.125,28.455),(16.275,28.455),(16.275,28.305),(16.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,28.625),(16.125,28.775),(16.275,28.775),(16.275,28.625),(16.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,28.945),(16.125,29.095),(16.275,29.095),(16.275,28.945),(16.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,29.265),(16.125,29.415),(16.275,29.415),(16.275,29.265),(16.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,29.585),(16.125,29.735),(16.275,29.735),(16.275,29.585),(16.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,29.905),(16.125,30.055),(16.275,30.055),(16.275,29.905),(16.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,30.225),(16.125,30.375),(16.275,30.375),(16.275,30.225),(16.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,30.545),(16.125,30.695),(16.275,30.695),(16.275,30.545),(16.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,30.865),(16.125,31.015),(16.275,31.015),(16.275,30.865),(16.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,31.185),(16.125,31.335),(16.275,31.335),(16.275,31.185),(16.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,31.505),(16.125,31.655),(16.275,31.655),(16.275,31.505),(16.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,31.825),(16.125,31.975),(16.275,31.975),(16.275,31.825),(16.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,32.145),(16.125,32.295),(16.275,32.295),(16.275,32.145),(16.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,32.465),(16.125,32.615),(16.275,32.615),(16.275,32.465),(16.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,32.785),(16.125,32.935),(16.275,32.935),(16.275,32.785),(16.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,33.105),(16.125,33.255),(16.275,33.255),(16.275,33.105),(16.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,33.425),(16.125,33.575),(16.275,33.575),(16.275,33.425),(16.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,33.745),(16.125,33.895),(16.275,33.895),(16.275,33.745),(16.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,34.065),(16.125,34.215),(16.275,34.215),(16.275,34.065),(16.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,34.385),(16.125,34.535),(16.275,34.535),(16.275,34.385),(16.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,34.705),(16.125,34.855),(16.275,34.855),(16.275,34.705),(16.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.025),(16.125,35.175),(16.275,35.175),(16.275,35.025),(16.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.345),(16.125,35.495),(16.275,35.495),(16.275,35.345),(16.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.665),(16.125,35.815),(16.275,35.815),(16.275,35.665),(16.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,35.985),(16.125,36.135),(16.275,36.135),(16.275,35.985),(16.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,36.305),(16.125,36.455),(16.275,36.455),(16.275,36.305),(16.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,36.625),(16.125,36.775),(16.275,36.775),(16.275,36.625),(16.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,36.945),(16.125,37.095),(16.275,37.095),(16.275,36.945),(16.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,37.265),(16.125,37.415),(16.275,37.415),(16.275,37.265),(16.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,37.585),(16.125,37.735),(16.275,37.735),(16.275,37.585),(16.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,37.905),(16.125,38.055),(16.275,38.055),(16.275,37.905),(16.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,38.225),(16.125,38.375),(16.275,38.375),(16.275,38.225),(16.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,38.545),(16.125,38.695),(16.275,38.695),(16.275,38.545),(16.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,38.865),(16.125,39.015),(16.275,39.015),(16.275,38.865),(16.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,39.185),(16.125,39.335),(16.275,39.335),(16.275,39.185),(16.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,39.505),(16.125,39.655),(16.275,39.655),(16.275,39.505),(16.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,39.825),(16.125,39.975),(16.275,39.975),(16.275,39.825),(16.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,40.145),(16.125,40.295),(16.275,40.295),(16.275,40.145),(16.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,40.465),(16.125,40.615),(16.275,40.615),(16.275,40.465),(16.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,40.785),(16.125,40.935),(16.275,40.935),(16.275,40.785),(16.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,41.105),(16.125,41.255),(16.275,41.255),(16.275,41.105),(16.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,41.425),(16.125,41.575),(16.275,41.575),(16.275,41.425),(16.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,41.745),(16.125,41.895),(16.275,41.895),(16.275,41.745),(16.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,42.065),(16.125,42.215),(16.275,42.215),(16.275,42.065),(16.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,42.385),(16.125,42.535),(16.275,42.535),(16.275,42.385),(16.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,42.705),(16.125,42.855),(16.275,42.855),(16.275,42.705),(16.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,43.025),(16.125,43.175),(16.275,43.175),(16.275,43.025),(16.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,43.345),(16.125,43.495),(16.275,43.495),(16.275,43.345),(16.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.145),(83.07,0.295),(83.22,0.295),(83.22,0.145),(83.07,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.465),(83.07,0.615),(83.22,0.615),(83.22,0.465),(83.07,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.785),(83.07,0.935),(83.22,0.935),(83.22,0.785),(83.07,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.105),(83.07,1.255),(83.22,1.255),(83.22,1.105),(83.07,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.425),(83.07,1.575),(83.22,1.575),(83.22,1.425),(83.07,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.745),(83.07,1.895),(83.22,1.895),(83.22,1.745),(83.07,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.065),(83.07,2.215),(83.22,2.215),(83.22,2.065),(83.07,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.385),(83.07,2.535),(83.22,2.535),(83.22,2.385),(83.07,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.705),(83.07,2.855),(83.22,2.855),(83.22,2.705),(83.07,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.025),(83.07,3.175),(83.22,3.175),(83.22,3.025),(83.07,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.345),(83.07,3.495),(83.22,3.495),(83.22,3.345),(83.07,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.665),(83.07,3.815),(83.22,3.815),(83.22,3.665),(83.07,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.985),(83.07,4.135),(83.22,4.135),(83.22,3.985),(83.07,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.305),(83.07,4.455),(83.22,4.455),(83.22,4.305),(83.07,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.625),(83.07,4.775),(83.22,4.775),(83.22,4.625),(83.07,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.945),(83.07,5.095),(83.22,5.095),(83.22,4.945),(83.07,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.265),(83.07,5.415),(83.22,5.415),(83.22,5.265),(83.07,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.585),(83.07,5.735),(83.22,5.735),(83.22,5.585),(83.07,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.905),(83.07,6.055),(83.22,6.055),(83.22,5.905),(83.07,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.225),(83.07,6.375),(83.22,6.375),(83.22,6.225),(83.07,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.545),(83.07,6.695),(83.22,6.695),(83.22,6.545),(83.07,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.865),(83.07,7.015),(83.22,7.015),(83.22,6.865),(83.07,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.185),(83.07,7.335),(83.22,7.335),(83.22,7.185),(83.07,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.505),(83.07,7.655),(83.22,7.655),(83.22,7.505),(83.07,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.825),(83.07,7.975),(83.22,7.975),(83.22,7.825),(83.07,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.145),(83.07,8.295),(83.22,8.295),(83.22,8.145),(83.07,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.465),(83.07,8.615),(83.22,8.615),(83.22,8.465),(83.07,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.785),(83.07,8.935),(83.22,8.935),(83.22,8.785),(83.07,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.105),(83.07,9.255),(83.22,9.255),(83.22,9.105),(83.07,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.425),(83.07,9.575),(83.22,9.575),(83.22,9.425),(83.07,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.745),(83.07,9.895),(83.22,9.895),(83.22,9.745),(83.07,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.065),(83.07,10.215),(83.22,10.215),(83.22,10.065),(83.07,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.385),(83.07,10.535),(83.22,10.535),(83.22,10.385),(83.07,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.705),(83.07,10.855),(83.22,10.855),(83.22,10.705),(83.07,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.025),(83.07,11.175),(83.22,11.175),(83.22,11.025),(83.07,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.345),(83.07,11.495),(83.22,11.495),(83.22,11.345),(83.07,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.665),(83.07,11.815),(83.22,11.815),(83.22,11.665),(83.07,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.985),(83.07,12.135),(83.22,12.135),(83.22,11.985),(83.07,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.305),(83.07,12.455),(83.22,12.455),(83.22,12.305),(83.07,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.625),(83.07,12.775),(83.22,12.775),(83.22,12.625),(83.07,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.945),(83.07,13.095),(83.22,13.095),(83.22,12.945),(83.07,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.265),(83.07,13.415),(83.22,13.415),(83.22,13.265),(83.07,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.585),(83.07,13.735),(83.22,13.735),(83.22,13.585),(83.07,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.905),(83.07,14.055),(83.22,14.055),(83.22,13.905),(83.07,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.225),(83.07,14.375),(83.22,14.375),(83.22,14.225),(83.07,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.545),(83.07,14.695),(83.22,14.695),(83.22,14.545),(83.07,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.865),(83.07,15.015),(83.22,15.015),(83.22,14.865),(83.07,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.185),(83.07,15.335),(83.22,15.335),(83.22,15.185),(83.07,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.505),(83.07,15.655),(83.22,15.655),(83.22,15.505),(83.07,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.825),(83.07,15.975),(83.22,15.975),(83.22,15.825),(83.07,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.145),(83.07,16.295),(83.22,16.295),(83.22,16.145),(83.07,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.465),(83.07,16.615),(83.22,16.615),(83.22,16.465),(83.07,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.785),(83.07,16.935),(83.22,16.935),(83.22,16.785),(83.07,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.105),(83.07,17.255),(83.22,17.255),(83.22,17.105),(83.07,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.425),(83.07,17.575),(83.22,17.575),(83.22,17.425),(83.07,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.745),(83.07,17.895),(83.22,17.895),(83.22,17.745),(83.07,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.065),(83.07,18.215),(83.22,18.215),(83.22,18.065),(83.07,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.385),(83.07,18.535),(83.22,18.535),(83.22,18.385),(83.07,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.705),(83.07,18.855),(83.22,18.855),(83.22,18.705),(83.07,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.025),(83.07,19.175),(83.22,19.175),(83.22,19.025),(83.07,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.345),(83.07,19.495),(83.22,19.495),(83.22,19.345),(83.07,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.665),(83.07,19.815),(83.22,19.815),(83.22,19.665),(83.07,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.985),(83.07,20.135),(83.22,20.135),(83.22,19.985),(83.07,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.305),(83.07,20.455),(83.22,20.455),(83.22,20.305),(83.07,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.625),(83.07,20.775),(83.22,20.775),(83.22,20.625),(83.07,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.945),(83.07,21.095),(83.22,21.095),(83.22,20.945),(83.07,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.265),(83.07,21.415),(83.22,21.415),(83.22,21.265),(83.07,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.585),(83.07,21.735),(83.22,21.735),(83.22,21.585),(83.07,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.905),(83.07,22.055),(83.22,22.055),(83.22,21.905),(83.07,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,22.225),(83.07,22.375),(83.22,22.375),(83.22,22.225),(83.07,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,22.545),(83.07,22.695),(83.22,22.695),(83.22,22.545),(83.07,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,22.865),(83.07,23.015),(83.22,23.015),(83.22,22.865),(83.07,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,23.185),(83.07,23.335),(83.22,23.335),(83.22,23.185),(83.07,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,23.505),(83.07,23.655),(83.22,23.655),(83.22,23.505),(83.07,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,23.825),(83.07,23.975),(83.22,23.975),(83.22,23.825),(83.07,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,24.145),(83.07,24.295),(83.22,24.295),(83.22,24.145),(83.07,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,24.465),(83.07,24.615),(83.22,24.615),(83.22,24.465),(83.07,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,24.785),(83.07,24.935),(83.22,24.935),(83.22,24.785),(83.07,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,25.105),(83.07,25.255),(83.22,25.255),(83.22,25.105),(83.07,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,25.425),(83.07,25.575),(83.22,25.575),(83.22,25.425),(83.07,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,25.745),(83.07,25.895),(83.22,25.895),(83.22,25.745),(83.07,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,26.065),(83.07,26.215),(83.22,26.215),(83.22,26.065),(83.07,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,26.385),(83.07,26.535),(83.22,26.535),(83.22,26.385),(83.07,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,26.705),(83.07,26.855),(83.22,26.855),(83.22,26.705),(83.07,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.025),(83.07,27.175),(83.22,27.175),(83.22,27.025),(83.07,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.345),(83.07,27.495),(83.22,27.495),(83.22,27.345),(83.07,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.665),(83.07,27.815),(83.22,27.815),(83.22,27.665),(83.07,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,27.985),(83.07,28.135),(83.22,28.135),(83.22,27.985),(83.07,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,28.305),(83.07,28.455),(83.22,28.455),(83.22,28.305),(83.07,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,28.625),(83.07,28.775),(83.22,28.775),(83.22,28.625),(83.07,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,28.945),(83.07,29.095),(83.22,29.095),(83.22,28.945),(83.07,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,29.265),(83.07,29.415),(83.22,29.415),(83.22,29.265),(83.07,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,29.585),(83.07,29.735),(83.22,29.735),(83.22,29.585),(83.07,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,29.905),(83.07,30.055),(83.22,30.055),(83.22,29.905),(83.07,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,30.225),(83.07,30.375),(83.22,30.375),(83.22,30.225),(83.07,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,30.545),(83.07,30.695),(83.22,30.695),(83.22,30.545),(83.07,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,30.865),(83.07,31.015),(83.22,31.015),(83.22,30.865),(83.07,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,31.185),(83.07,31.335),(83.22,31.335),(83.22,31.185),(83.07,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,31.505),(83.07,31.655),(83.22,31.655),(83.22,31.505),(83.07,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,31.825),(83.07,31.975),(83.22,31.975),(83.22,31.825),(83.07,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,32.145),(83.07,32.295),(83.22,32.295),(83.22,32.145),(83.07,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,32.465),(83.07,32.615),(83.22,32.615),(83.22,32.465),(83.07,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,32.785),(83.07,32.935),(83.22,32.935),(83.22,32.785),(83.07,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,33.105),(83.07,33.255),(83.22,33.255),(83.22,33.105),(83.07,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,33.425),(83.07,33.575),(83.22,33.575),(83.22,33.425),(83.07,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,33.745),(83.07,33.895),(83.22,33.895),(83.22,33.745),(83.07,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,34.065),(83.07,34.215),(83.22,34.215),(83.22,34.065),(83.07,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,34.385),(83.07,34.535),(83.22,34.535),(83.22,34.385),(83.07,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,34.705),(83.07,34.855),(83.22,34.855),(83.22,34.705),(83.07,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.025),(83.07,35.175),(83.22,35.175),(83.22,35.025),(83.07,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.345),(83.07,35.495),(83.22,35.495),(83.22,35.345),(83.07,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.665),(83.07,35.815),(83.22,35.815),(83.22,35.665),(83.07,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,35.985),(83.07,36.135),(83.22,36.135),(83.22,35.985),(83.07,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,36.305),(83.07,36.455),(83.22,36.455),(83.22,36.305),(83.07,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,36.625),(83.07,36.775),(83.22,36.775),(83.22,36.625),(83.07,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,36.945),(83.07,37.095),(83.22,37.095),(83.22,36.945),(83.07,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,37.265),(83.07,37.415),(83.22,37.415),(83.22,37.265),(83.07,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,37.585),(83.07,37.735),(83.22,37.735),(83.22,37.585),(83.07,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,37.905),(83.07,38.055),(83.22,38.055),(83.22,37.905),(83.07,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,38.225),(83.07,38.375),(83.22,38.375),(83.22,38.225),(83.07,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,38.545),(83.07,38.695),(83.22,38.695),(83.22,38.545),(83.07,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,38.865),(83.07,39.015),(83.22,39.015),(83.22,38.865),(83.07,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,39.185),(83.07,39.335),(83.22,39.335),(83.22,39.185),(83.07,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,39.505),(83.07,39.655),(83.22,39.655),(83.22,39.505),(83.07,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,39.825),(83.07,39.975),(83.22,39.975),(83.22,39.825),(83.07,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,40.145),(83.07,40.295),(83.22,40.295),(83.22,40.145),(83.07,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,40.465),(83.07,40.615),(83.22,40.615),(83.22,40.465),(83.07,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,40.785),(83.07,40.935),(83.22,40.935),(83.22,40.785),(83.07,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,41.105),(83.07,41.255),(83.22,41.255),(83.22,41.105),(83.07,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,41.425),(83.07,41.575),(83.22,41.575),(83.22,41.425),(83.07,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,41.745),(83.07,41.895),(83.22,41.895),(83.22,41.745),(83.07,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,42.065),(83.07,42.215),(83.22,42.215),(83.22,42.065),(83.07,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,42.385),(83.07,42.535),(83.22,42.535),(83.22,42.385),(83.07,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,42.705),(83.07,42.855),(83.22,42.855),(83.22,42.705),(83.07,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,43.025),(83.07,43.175),(83.22,43.175),(83.22,43.025),(83.07,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,43.345),(83.07,43.495),(83.22,43.495),(83.22,43.345),(83.07,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.145),(73.725,0.295),(73.875,0.295),(73.875,0.145),(73.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.465),(73.725,0.615),(73.875,0.615),(73.875,0.465),(73.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.785),(73.725,0.935),(73.875,0.935),(73.875,0.785),(73.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.105),(73.725,1.255),(73.875,1.255),(73.875,1.105),(73.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.425),(73.725,1.575),(73.875,1.575),(73.875,1.425),(73.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.745),(73.725,1.895),(73.875,1.895),(73.875,1.745),(73.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.065),(73.725,2.215),(73.875,2.215),(73.875,2.065),(73.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.385),(73.725,2.535),(73.875,2.535),(73.875,2.385),(73.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.705),(73.725,2.855),(73.875,2.855),(73.875,2.705),(73.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.025),(73.725,3.175),(73.875,3.175),(73.875,3.025),(73.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.345),(73.725,3.495),(73.875,3.495),(73.875,3.345),(73.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.665),(73.725,3.815),(73.875,3.815),(73.875,3.665),(73.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.985),(73.725,4.135),(73.875,4.135),(73.875,3.985),(73.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.305),(73.725,4.455),(73.875,4.455),(73.875,4.305),(73.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.625),(73.725,4.775),(73.875,4.775),(73.875,4.625),(73.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.945),(73.725,5.095),(73.875,5.095),(73.875,4.945),(73.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.265),(73.725,5.415),(73.875,5.415),(73.875,5.265),(73.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.585),(73.725,5.735),(73.875,5.735),(73.875,5.585),(73.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.905),(73.725,6.055),(73.875,6.055),(73.875,5.905),(73.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.225),(73.725,6.375),(73.875,6.375),(73.875,6.225),(73.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.545),(73.725,6.695),(73.875,6.695),(73.875,6.545),(73.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.865),(73.725,7.015),(73.875,7.015),(73.875,6.865),(73.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.185),(73.725,7.335),(73.875,7.335),(73.875,7.185),(73.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.505),(73.725,7.655),(73.875,7.655),(73.875,7.505),(73.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.825),(73.725,7.975),(73.875,7.975),(73.875,7.825),(73.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.145),(73.725,8.295),(73.875,8.295),(73.875,8.145),(73.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.465),(73.725,8.615),(73.875,8.615),(73.875,8.465),(73.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.785),(73.725,8.935),(73.875,8.935),(73.875,8.785),(73.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.105),(73.725,9.255),(73.875,9.255),(73.875,9.105),(73.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.425),(73.725,9.575),(73.875,9.575),(73.875,9.425),(73.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.745),(73.725,9.895),(73.875,9.895),(73.875,9.745),(73.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.065),(73.725,10.215),(73.875,10.215),(73.875,10.065),(73.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.385),(73.725,10.535),(73.875,10.535),(73.875,10.385),(73.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.705),(73.725,10.855),(73.875,10.855),(73.875,10.705),(73.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.025),(73.725,11.175),(73.875,11.175),(73.875,11.025),(73.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.345),(73.725,11.495),(73.875,11.495),(73.875,11.345),(73.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.665),(73.725,11.815),(73.875,11.815),(73.875,11.665),(73.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.985),(73.725,12.135),(73.875,12.135),(73.875,11.985),(73.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.305),(73.725,12.455),(73.875,12.455),(73.875,12.305),(73.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.625),(73.725,12.775),(73.875,12.775),(73.875,12.625),(73.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.945),(73.725,13.095),(73.875,13.095),(73.875,12.945),(73.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.265),(73.725,13.415),(73.875,13.415),(73.875,13.265),(73.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.585),(73.725,13.735),(73.875,13.735),(73.875,13.585),(73.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.905),(73.725,14.055),(73.875,14.055),(73.875,13.905),(73.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.225),(73.725,14.375),(73.875,14.375),(73.875,14.225),(73.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.545),(73.725,14.695),(73.875,14.695),(73.875,14.545),(73.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.865),(73.725,15.015),(73.875,15.015),(73.875,14.865),(73.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.185),(73.725,15.335),(73.875,15.335),(73.875,15.185),(73.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.505),(73.725,15.655),(73.875,15.655),(73.875,15.505),(73.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.825),(73.725,15.975),(73.875,15.975),(73.875,15.825),(73.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.145),(73.725,16.295),(73.875,16.295),(73.875,16.145),(73.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.465),(73.725,16.615),(73.875,16.615),(73.875,16.465),(73.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.785),(73.725,16.935),(73.875,16.935),(73.875,16.785),(73.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.105),(73.725,17.255),(73.875,17.255),(73.875,17.105),(73.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.425),(73.725,17.575),(73.875,17.575),(73.875,17.425),(73.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.745),(73.725,17.895),(73.875,17.895),(73.875,17.745),(73.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.065),(73.725,18.215),(73.875,18.215),(73.875,18.065),(73.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.385),(73.725,18.535),(73.875,18.535),(73.875,18.385),(73.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.705),(73.725,18.855),(73.875,18.855),(73.875,18.705),(73.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.025),(73.725,19.175),(73.875,19.175),(73.875,19.025),(73.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.345),(73.725,19.495),(73.875,19.495),(73.875,19.345),(73.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.665),(73.725,19.815),(73.875,19.815),(73.875,19.665),(73.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.985),(73.725,20.135),(73.875,20.135),(73.875,19.985),(73.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.305),(73.725,20.455),(73.875,20.455),(73.875,20.305),(73.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.625),(73.725,20.775),(73.875,20.775),(73.875,20.625),(73.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.945),(73.725,21.095),(73.875,21.095),(73.875,20.945),(73.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.265),(73.725,21.415),(73.875,21.415),(73.875,21.265),(73.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.585),(73.725,21.735),(73.875,21.735),(73.875,21.585),(73.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.905),(73.725,22.055),(73.875,22.055),(73.875,21.905),(73.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,22.225),(73.725,22.375),(73.875,22.375),(73.875,22.225),(73.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,22.545),(73.725,22.695),(73.875,22.695),(73.875,22.545),(73.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,22.865),(73.725,23.015),(73.875,23.015),(73.875,22.865),(73.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,23.185),(73.725,23.335),(73.875,23.335),(73.875,23.185),(73.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,23.505),(73.725,23.655),(73.875,23.655),(73.875,23.505),(73.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,23.825),(73.725,23.975),(73.875,23.975),(73.875,23.825),(73.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,24.145),(73.725,24.295),(73.875,24.295),(73.875,24.145),(73.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,24.465),(73.725,24.615),(73.875,24.615),(73.875,24.465),(73.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,24.785),(73.725,24.935),(73.875,24.935),(73.875,24.785),(73.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,25.105),(73.725,25.255),(73.875,25.255),(73.875,25.105),(73.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,25.425),(73.725,25.575),(73.875,25.575),(73.875,25.425),(73.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,25.745),(73.725,25.895),(73.875,25.895),(73.875,25.745),(73.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,26.065),(73.725,26.215),(73.875,26.215),(73.875,26.065),(73.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,26.385),(73.725,26.535),(73.875,26.535),(73.875,26.385),(73.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,26.705),(73.725,26.855),(73.875,26.855),(73.875,26.705),(73.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.025),(73.725,27.175),(73.875,27.175),(73.875,27.025),(73.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.345),(73.725,27.495),(73.875,27.495),(73.875,27.345),(73.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.665),(73.725,27.815),(73.875,27.815),(73.875,27.665),(73.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,27.985),(73.725,28.135),(73.875,28.135),(73.875,27.985),(73.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,28.305),(73.725,28.455),(73.875,28.455),(73.875,28.305),(73.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,28.625),(73.725,28.775),(73.875,28.775),(73.875,28.625),(73.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,28.945),(73.725,29.095),(73.875,29.095),(73.875,28.945),(73.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,29.265),(73.725,29.415),(73.875,29.415),(73.875,29.265),(73.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,29.585),(73.725,29.735),(73.875,29.735),(73.875,29.585),(73.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,29.905),(73.725,30.055),(73.875,30.055),(73.875,29.905),(73.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,30.225),(73.725,30.375),(73.875,30.375),(73.875,30.225),(73.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,30.545),(73.725,30.695),(73.875,30.695),(73.875,30.545),(73.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,30.865),(73.725,31.015),(73.875,31.015),(73.875,30.865),(73.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,31.185),(73.725,31.335),(73.875,31.335),(73.875,31.185),(73.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,31.505),(73.725,31.655),(73.875,31.655),(73.875,31.505),(73.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,31.825),(73.725,31.975),(73.875,31.975),(73.875,31.825),(73.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,32.145),(73.725,32.295),(73.875,32.295),(73.875,32.145),(73.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,32.465),(73.725,32.615),(73.875,32.615),(73.875,32.465),(73.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,32.785),(73.725,32.935),(73.875,32.935),(73.875,32.785),(73.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,33.105),(73.725,33.255),(73.875,33.255),(73.875,33.105),(73.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,33.425),(73.725,33.575),(73.875,33.575),(73.875,33.425),(73.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,33.745),(73.725,33.895),(73.875,33.895),(73.875,33.745),(73.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,34.065),(73.725,34.215),(73.875,34.215),(73.875,34.065),(73.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,34.385),(73.725,34.535),(73.875,34.535),(73.875,34.385),(73.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,34.705),(73.725,34.855),(73.875,34.855),(73.875,34.705),(73.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.025),(73.725,35.175),(73.875,35.175),(73.875,35.025),(73.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.345),(73.725,35.495),(73.875,35.495),(73.875,35.345),(73.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.665),(73.725,35.815),(73.875,35.815),(73.875,35.665),(73.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,35.985),(73.725,36.135),(73.875,36.135),(73.875,35.985),(73.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,36.305),(73.725,36.455),(73.875,36.455),(73.875,36.305),(73.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,36.625),(73.725,36.775),(73.875,36.775),(73.875,36.625),(73.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,36.945),(73.725,37.095),(73.875,37.095),(73.875,36.945),(73.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,37.265),(73.725,37.415),(73.875,37.415),(73.875,37.265),(73.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,37.585),(73.725,37.735),(73.875,37.735),(73.875,37.585),(73.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,37.905),(73.725,38.055),(73.875,38.055),(73.875,37.905),(73.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,38.225),(73.725,38.375),(73.875,38.375),(73.875,38.225),(73.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,38.545),(73.725,38.695),(73.875,38.695),(73.875,38.545),(73.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,38.865),(73.725,39.015),(73.875,39.015),(73.875,38.865),(73.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,39.185),(73.725,39.335),(73.875,39.335),(73.875,39.185),(73.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,39.505),(73.725,39.655),(73.875,39.655),(73.875,39.505),(73.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,39.825),(73.725,39.975),(73.875,39.975),(73.875,39.825),(73.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,40.145),(73.725,40.295),(73.875,40.295),(73.875,40.145),(73.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,40.465),(73.725,40.615),(73.875,40.615),(73.875,40.465),(73.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,40.785),(73.725,40.935),(73.875,40.935),(73.875,40.785),(73.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,41.105),(73.725,41.255),(73.875,41.255),(73.875,41.105),(73.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,41.425),(73.725,41.575),(73.875,41.575),(73.875,41.425),(73.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,41.745),(73.725,41.895),(73.875,41.895),(73.875,41.745),(73.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,42.065),(73.725,42.215),(73.875,42.215),(73.875,42.065),(73.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,42.385),(73.725,42.535),(73.875,42.535),(73.875,42.385),(73.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,42.705),(73.725,42.855),(73.875,42.855),(73.875,42.705),(73.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,43.025),(73.725,43.175),(73.875,43.175),(73.875,43.025),(73.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,43.345),(73.725,43.495),(73.875,43.495),(73.875,43.345),(73.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.145),(59.325,0.295),(59.475,0.295),(59.475,0.145),(59.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.465),(59.325,0.615),(59.475,0.615),(59.475,0.465),(59.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.785),(59.325,0.935),(59.475,0.935),(59.475,0.785),(59.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.105),(59.325,1.255),(59.475,1.255),(59.475,1.105),(59.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.425),(59.325,1.575),(59.475,1.575),(59.475,1.425),(59.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.745),(59.325,1.895),(59.475,1.895),(59.475,1.745),(59.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.065),(59.325,2.215),(59.475,2.215),(59.475,2.065),(59.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.385),(59.325,2.535),(59.475,2.535),(59.475,2.385),(59.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.705),(59.325,2.855),(59.475,2.855),(59.475,2.705),(59.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.025),(59.325,3.175),(59.475,3.175),(59.475,3.025),(59.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.345),(59.325,3.495),(59.475,3.495),(59.475,3.345),(59.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.665),(59.325,3.815),(59.475,3.815),(59.475,3.665),(59.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.985),(59.325,4.135),(59.475,4.135),(59.475,3.985),(59.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.305),(59.325,4.455),(59.475,4.455),(59.475,4.305),(59.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.625),(59.325,4.775),(59.475,4.775),(59.475,4.625),(59.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.945),(59.325,5.095),(59.475,5.095),(59.475,4.945),(59.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.265),(59.325,5.415),(59.475,5.415),(59.475,5.265),(59.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.585),(59.325,5.735),(59.475,5.735),(59.475,5.585),(59.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.905),(59.325,6.055),(59.475,6.055),(59.475,5.905),(59.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.225),(59.325,6.375),(59.475,6.375),(59.475,6.225),(59.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.545),(59.325,6.695),(59.475,6.695),(59.475,6.545),(59.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.865),(59.325,7.015),(59.475,7.015),(59.475,6.865),(59.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.185),(59.325,7.335),(59.475,7.335),(59.475,7.185),(59.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.505),(59.325,7.655),(59.475,7.655),(59.475,7.505),(59.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.825),(59.325,7.975),(59.475,7.975),(59.475,7.825),(59.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.145),(59.325,8.295),(59.475,8.295),(59.475,8.145),(59.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.465),(59.325,8.615),(59.475,8.615),(59.475,8.465),(59.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.785),(59.325,8.935),(59.475,8.935),(59.475,8.785),(59.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.105),(59.325,9.255),(59.475,9.255),(59.475,9.105),(59.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.425),(59.325,9.575),(59.475,9.575),(59.475,9.425),(59.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.745),(59.325,9.895),(59.475,9.895),(59.475,9.745),(59.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.065),(59.325,10.215),(59.475,10.215),(59.475,10.065),(59.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.385),(59.325,10.535),(59.475,10.535),(59.475,10.385),(59.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.705),(59.325,10.855),(59.475,10.855),(59.475,10.705),(59.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.025),(59.325,11.175),(59.475,11.175),(59.475,11.025),(59.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.345),(59.325,11.495),(59.475,11.495),(59.475,11.345),(59.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.665),(59.325,11.815),(59.475,11.815),(59.475,11.665),(59.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.985),(59.325,12.135),(59.475,12.135),(59.475,11.985),(59.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.305),(59.325,12.455),(59.475,12.455),(59.475,12.305),(59.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.625),(59.325,12.775),(59.475,12.775),(59.475,12.625),(59.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.945),(59.325,13.095),(59.475,13.095),(59.475,12.945),(59.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.265),(59.325,13.415),(59.475,13.415),(59.475,13.265),(59.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.585),(59.325,13.735),(59.475,13.735),(59.475,13.585),(59.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.905),(59.325,14.055),(59.475,14.055),(59.475,13.905),(59.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.225),(59.325,14.375),(59.475,14.375),(59.475,14.225),(59.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.545),(59.325,14.695),(59.475,14.695),(59.475,14.545),(59.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.865),(59.325,15.015),(59.475,15.015),(59.475,14.865),(59.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.185),(59.325,15.335),(59.475,15.335),(59.475,15.185),(59.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.505),(59.325,15.655),(59.475,15.655),(59.475,15.505),(59.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.825),(59.325,15.975),(59.475,15.975),(59.475,15.825),(59.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.145),(59.325,16.295),(59.475,16.295),(59.475,16.145),(59.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.465),(59.325,16.615),(59.475,16.615),(59.475,16.465),(59.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.785),(59.325,16.935),(59.475,16.935),(59.475,16.785),(59.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.105),(59.325,17.255),(59.475,17.255),(59.475,17.105),(59.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.425),(59.325,17.575),(59.475,17.575),(59.475,17.425),(59.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.745),(59.325,17.895),(59.475,17.895),(59.475,17.745),(59.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.065),(59.325,18.215),(59.475,18.215),(59.475,18.065),(59.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.385),(59.325,18.535),(59.475,18.535),(59.475,18.385),(59.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.705),(59.325,18.855),(59.475,18.855),(59.475,18.705),(59.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.025),(59.325,19.175),(59.475,19.175),(59.475,19.025),(59.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.345),(59.325,19.495),(59.475,19.495),(59.475,19.345),(59.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.665),(59.325,19.815),(59.475,19.815),(59.475,19.665),(59.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.985),(59.325,20.135),(59.475,20.135),(59.475,19.985),(59.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.305),(59.325,20.455),(59.475,20.455),(59.475,20.305),(59.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.625),(59.325,20.775),(59.475,20.775),(59.475,20.625),(59.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.945),(59.325,21.095),(59.475,21.095),(59.475,20.945),(59.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.265),(59.325,21.415),(59.475,21.415),(59.475,21.265),(59.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.585),(59.325,21.735),(59.475,21.735),(59.475,21.585),(59.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.905),(59.325,22.055),(59.475,22.055),(59.475,21.905),(59.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,22.225),(59.325,22.375),(59.475,22.375),(59.475,22.225),(59.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,22.545),(59.325,22.695),(59.475,22.695),(59.475,22.545),(59.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,22.865),(59.325,23.015),(59.475,23.015),(59.475,22.865),(59.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,23.185),(59.325,23.335),(59.475,23.335),(59.475,23.185),(59.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,23.505),(59.325,23.655),(59.475,23.655),(59.475,23.505),(59.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,23.825),(59.325,23.975),(59.475,23.975),(59.475,23.825),(59.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,24.145),(59.325,24.295),(59.475,24.295),(59.475,24.145),(59.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,24.465),(59.325,24.615),(59.475,24.615),(59.475,24.465),(59.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,24.785),(59.325,24.935),(59.475,24.935),(59.475,24.785),(59.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,25.105),(59.325,25.255),(59.475,25.255),(59.475,25.105),(59.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,25.425),(59.325,25.575),(59.475,25.575),(59.475,25.425),(59.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,25.745),(59.325,25.895),(59.475,25.895),(59.475,25.745),(59.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,26.065),(59.325,26.215),(59.475,26.215),(59.475,26.065),(59.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,26.385),(59.325,26.535),(59.475,26.535),(59.475,26.385),(59.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,26.705),(59.325,26.855),(59.475,26.855),(59.475,26.705),(59.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.025),(59.325,27.175),(59.475,27.175),(59.475,27.025),(59.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.345),(59.325,27.495),(59.475,27.495),(59.475,27.345),(59.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.665),(59.325,27.815),(59.475,27.815),(59.475,27.665),(59.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,27.985),(59.325,28.135),(59.475,28.135),(59.475,27.985),(59.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,28.305),(59.325,28.455),(59.475,28.455),(59.475,28.305),(59.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,28.625),(59.325,28.775),(59.475,28.775),(59.475,28.625),(59.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,28.945),(59.325,29.095),(59.475,29.095),(59.475,28.945),(59.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,29.265),(59.325,29.415),(59.475,29.415),(59.475,29.265),(59.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,29.585),(59.325,29.735),(59.475,29.735),(59.475,29.585),(59.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,29.905),(59.325,30.055),(59.475,30.055),(59.475,29.905),(59.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,30.225),(59.325,30.375),(59.475,30.375),(59.475,30.225),(59.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,30.545),(59.325,30.695),(59.475,30.695),(59.475,30.545),(59.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,30.865),(59.325,31.015),(59.475,31.015),(59.475,30.865),(59.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,31.185),(59.325,31.335),(59.475,31.335),(59.475,31.185),(59.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,31.505),(59.325,31.655),(59.475,31.655),(59.475,31.505),(59.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,31.825),(59.325,31.975),(59.475,31.975),(59.475,31.825),(59.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,32.145),(59.325,32.295),(59.475,32.295),(59.475,32.145),(59.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,32.465),(59.325,32.615),(59.475,32.615),(59.475,32.465),(59.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,32.785),(59.325,32.935),(59.475,32.935),(59.475,32.785),(59.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,33.105),(59.325,33.255),(59.475,33.255),(59.475,33.105),(59.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,33.425),(59.325,33.575),(59.475,33.575),(59.475,33.425),(59.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,33.745),(59.325,33.895),(59.475,33.895),(59.475,33.745),(59.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,34.065),(59.325,34.215),(59.475,34.215),(59.475,34.065),(59.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,34.385),(59.325,34.535),(59.475,34.535),(59.475,34.385),(59.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,34.705),(59.325,34.855),(59.475,34.855),(59.475,34.705),(59.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.025),(59.325,35.175),(59.475,35.175),(59.475,35.025),(59.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.345),(59.325,35.495),(59.475,35.495),(59.475,35.345),(59.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.665),(59.325,35.815),(59.475,35.815),(59.475,35.665),(59.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,35.985),(59.325,36.135),(59.475,36.135),(59.475,35.985),(59.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,36.305),(59.325,36.455),(59.475,36.455),(59.475,36.305),(59.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,36.625),(59.325,36.775),(59.475,36.775),(59.475,36.625),(59.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,36.945),(59.325,37.095),(59.475,37.095),(59.475,36.945),(59.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,37.265),(59.325,37.415),(59.475,37.415),(59.475,37.265),(59.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,37.585),(59.325,37.735),(59.475,37.735),(59.475,37.585),(59.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,37.905),(59.325,38.055),(59.475,38.055),(59.475,37.905),(59.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,38.225),(59.325,38.375),(59.475,38.375),(59.475,38.225),(59.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,38.545),(59.325,38.695),(59.475,38.695),(59.475,38.545),(59.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,38.865),(59.325,39.015),(59.475,39.015),(59.475,38.865),(59.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,39.185),(59.325,39.335),(59.475,39.335),(59.475,39.185),(59.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,39.505),(59.325,39.655),(59.475,39.655),(59.475,39.505),(59.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,39.825),(59.325,39.975),(59.475,39.975),(59.475,39.825),(59.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,40.145),(59.325,40.295),(59.475,40.295),(59.475,40.145),(59.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,40.465),(59.325,40.615),(59.475,40.615),(59.475,40.465),(59.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,40.785),(59.325,40.935),(59.475,40.935),(59.475,40.785),(59.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,41.105),(59.325,41.255),(59.475,41.255),(59.475,41.105),(59.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,41.425),(59.325,41.575),(59.475,41.575),(59.475,41.425),(59.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,41.745),(59.325,41.895),(59.475,41.895),(59.475,41.745),(59.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,42.065),(59.325,42.215),(59.475,42.215),(59.475,42.065),(59.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,42.385),(59.325,42.535),(59.475,42.535),(59.475,42.385),(59.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,42.705),(59.325,42.855),(59.475,42.855),(59.475,42.705),(59.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,43.025),(59.325,43.175),(59.475,43.175),(59.475,43.025),(59.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,43.345),(59.325,43.495),(59.475,43.495),(59.475,43.345),(59.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.145),(20.925,0.295),(21.075,0.295),(21.075,0.145),(20.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.465),(20.925,0.615),(21.075,0.615),(21.075,0.465),(20.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.785),(20.925,0.935),(21.075,0.935),(21.075,0.785),(20.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.105),(20.925,1.255),(21.075,1.255),(21.075,1.105),(20.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.425),(20.925,1.575),(21.075,1.575),(21.075,1.425),(20.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.745),(20.925,1.895),(21.075,1.895),(21.075,1.745),(20.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.065),(20.925,2.215),(21.075,2.215),(21.075,2.065),(20.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.385),(20.925,2.535),(21.075,2.535),(21.075,2.385),(20.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.705),(20.925,2.855),(21.075,2.855),(21.075,2.705),(20.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.025),(20.925,3.175),(21.075,3.175),(21.075,3.025),(20.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.345),(20.925,3.495),(21.075,3.495),(21.075,3.345),(20.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.665),(20.925,3.815),(21.075,3.815),(21.075,3.665),(20.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.985),(20.925,4.135),(21.075,4.135),(21.075,3.985),(20.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.305),(20.925,4.455),(21.075,4.455),(21.075,4.305),(20.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.625),(20.925,4.775),(21.075,4.775),(21.075,4.625),(20.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.945),(20.925,5.095),(21.075,5.095),(21.075,4.945),(20.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.265),(20.925,5.415),(21.075,5.415),(21.075,5.265),(20.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.585),(20.925,5.735),(21.075,5.735),(21.075,5.585),(20.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.905),(20.925,6.055),(21.075,6.055),(21.075,5.905),(20.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.225),(20.925,6.375),(21.075,6.375),(21.075,6.225),(20.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.545),(20.925,6.695),(21.075,6.695),(21.075,6.545),(20.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.865),(20.925,7.015),(21.075,7.015),(21.075,6.865),(20.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.185),(20.925,7.335),(21.075,7.335),(21.075,7.185),(20.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.505),(20.925,7.655),(21.075,7.655),(21.075,7.505),(20.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.825),(20.925,7.975),(21.075,7.975),(21.075,7.825),(20.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.145),(20.925,8.295),(21.075,8.295),(21.075,8.145),(20.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.465),(20.925,8.615),(21.075,8.615),(21.075,8.465),(20.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.785),(20.925,8.935),(21.075,8.935),(21.075,8.785),(20.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.105),(20.925,9.255),(21.075,9.255),(21.075,9.105),(20.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.425),(20.925,9.575),(21.075,9.575),(21.075,9.425),(20.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.745),(20.925,9.895),(21.075,9.895),(21.075,9.745),(20.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.065),(20.925,10.215),(21.075,10.215),(21.075,10.065),(20.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.385),(20.925,10.535),(21.075,10.535),(21.075,10.385),(20.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.705),(20.925,10.855),(21.075,10.855),(21.075,10.705),(20.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.025),(20.925,11.175),(21.075,11.175),(21.075,11.025),(20.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.345),(20.925,11.495),(21.075,11.495),(21.075,11.345),(20.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.665),(20.925,11.815),(21.075,11.815),(21.075,11.665),(20.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.985),(20.925,12.135),(21.075,12.135),(21.075,11.985),(20.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.305),(20.925,12.455),(21.075,12.455),(21.075,12.305),(20.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.625),(20.925,12.775),(21.075,12.775),(21.075,12.625),(20.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.945),(20.925,13.095),(21.075,13.095),(21.075,12.945),(20.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.265),(20.925,13.415),(21.075,13.415),(21.075,13.265),(20.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.585),(20.925,13.735),(21.075,13.735),(21.075,13.585),(20.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.905),(20.925,14.055),(21.075,14.055),(21.075,13.905),(20.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.225),(20.925,14.375),(21.075,14.375),(21.075,14.225),(20.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.545),(20.925,14.695),(21.075,14.695),(21.075,14.545),(20.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.865),(20.925,15.015),(21.075,15.015),(21.075,14.865),(20.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.185),(20.925,15.335),(21.075,15.335),(21.075,15.185),(20.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.505),(20.925,15.655),(21.075,15.655),(21.075,15.505),(20.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.825),(20.925,15.975),(21.075,15.975),(21.075,15.825),(20.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.145),(20.925,16.295),(21.075,16.295),(21.075,16.145),(20.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.465),(20.925,16.615),(21.075,16.615),(21.075,16.465),(20.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.785),(20.925,16.935),(21.075,16.935),(21.075,16.785),(20.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.105),(20.925,17.255),(21.075,17.255),(21.075,17.105),(20.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.425),(20.925,17.575),(21.075,17.575),(21.075,17.425),(20.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.745),(20.925,17.895),(21.075,17.895),(21.075,17.745),(20.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.065),(20.925,18.215),(21.075,18.215),(21.075,18.065),(20.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.385),(20.925,18.535),(21.075,18.535),(21.075,18.385),(20.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.705),(20.925,18.855),(21.075,18.855),(21.075,18.705),(20.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.025),(20.925,19.175),(21.075,19.175),(21.075,19.025),(20.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.345),(20.925,19.495),(21.075,19.495),(21.075,19.345),(20.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.665),(20.925,19.815),(21.075,19.815),(21.075,19.665),(20.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.985),(20.925,20.135),(21.075,20.135),(21.075,19.985),(20.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.305),(20.925,20.455),(21.075,20.455),(21.075,20.305),(20.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.625),(20.925,20.775),(21.075,20.775),(21.075,20.625),(20.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.945),(20.925,21.095),(21.075,21.095),(21.075,20.945),(20.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.265),(20.925,21.415),(21.075,21.415),(21.075,21.265),(20.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.585),(20.925,21.735),(21.075,21.735),(21.075,21.585),(20.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.905),(20.925,22.055),(21.075,22.055),(21.075,21.905),(20.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,22.225),(20.925,22.375),(21.075,22.375),(21.075,22.225),(20.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,22.545),(20.925,22.695),(21.075,22.695),(21.075,22.545),(20.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,22.865),(20.925,23.015),(21.075,23.015),(21.075,22.865),(20.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,23.185),(20.925,23.335),(21.075,23.335),(21.075,23.185),(20.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,23.505),(20.925,23.655),(21.075,23.655),(21.075,23.505),(20.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,23.825),(20.925,23.975),(21.075,23.975),(21.075,23.825),(20.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,24.145),(20.925,24.295),(21.075,24.295),(21.075,24.145),(20.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,24.465),(20.925,24.615),(21.075,24.615),(21.075,24.465),(20.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,24.785),(20.925,24.935),(21.075,24.935),(21.075,24.785),(20.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,25.105),(20.925,25.255),(21.075,25.255),(21.075,25.105),(20.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,25.425),(20.925,25.575),(21.075,25.575),(21.075,25.425),(20.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,25.745),(20.925,25.895),(21.075,25.895),(21.075,25.745),(20.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,26.065),(20.925,26.215),(21.075,26.215),(21.075,26.065),(20.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,26.385),(20.925,26.535),(21.075,26.535),(21.075,26.385),(20.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,26.705),(20.925,26.855),(21.075,26.855),(21.075,26.705),(20.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.025),(20.925,27.175),(21.075,27.175),(21.075,27.025),(20.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.345),(20.925,27.495),(21.075,27.495),(21.075,27.345),(20.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.665),(20.925,27.815),(21.075,27.815),(21.075,27.665),(20.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,27.985),(20.925,28.135),(21.075,28.135),(21.075,27.985),(20.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,28.305),(20.925,28.455),(21.075,28.455),(21.075,28.305),(20.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,28.625),(20.925,28.775),(21.075,28.775),(21.075,28.625),(20.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,28.945),(20.925,29.095),(21.075,29.095),(21.075,28.945),(20.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,29.265),(20.925,29.415),(21.075,29.415),(21.075,29.265),(20.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,29.585),(20.925,29.735),(21.075,29.735),(21.075,29.585),(20.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,29.905),(20.925,30.055),(21.075,30.055),(21.075,29.905),(20.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,30.225),(20.925,30.375),(21.075,30.375),(21.075,30.225),(20.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,30.545),(20.925,30.695),(21.075,30.695),(21.075,30.545),(20.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,30.865),(20.925,31.015),(21.075,31.015),(21.075,30.865),(20.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,31.185),(20.925,31.335),(21.075,31.335),(21.075,31.185),(20.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,31.505),(20.925,31.655),(21.075,31.655),(21.075,31.505),(20.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,31.825),(20.925,31.975),(21.075,31.975),(21.075,31.825),(20.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,32.145),(20.925,32.295),(21.075,32.295),(21.075,32.145),(20.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,32.465),(20.925,32.615),(21.075,32.615),(21.075,32.465),(20.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,32.785),(20.925,32.935),(21.075,32.935),(21.075,32.785),(20.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,33.105),(20.925,33.255),(21.075,33.255),(21.075,33.105),(20.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,33.425),(20.925,33.575),(21.075,33.575),(21.075,33.425),(20.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,33.745),(20.925,33.895),(21.075,33.895),(21.075,33.745),(20.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,34.065),(20.925,34.215),(21.075,34.215),(21.075,34.065),(20.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,34.385),(20.925,34.535),(21.075,34.535),(21.075,34.385),(20.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,34.705),(20.925,34.855),(21.075,34.855),(21.075,34.705),(20.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.025),(20.925,35.175),(21.075,35.175),(21.075,35.025),(20.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.345),(20.925,35.495),(21.075,35.495),(21.075,35.345),(20.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.665),(20.925,35.815),(21.075,35.815),(21.075,35.665),(20.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,35.985),(20.925,36.135),(21.075,36.135),(21.075,35.985),(20.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,36.305),(20.925,36.455),(21.075,36.455),(21.075,36.305),(20.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,36.625),(20.925,36.775),(21.075,36.775),(21.075,36.625),(20.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,36.945),(20.925,37.095),(21.075,37.095),(21.075,36.945),(20.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,37.265),(20.925,37.415),(21.075,37.415),(21.075,37.265),(20.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,37.585),(20.925,37.735),(21.075,37.735),(21.075,37.585),(20.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,37.905),(20.925,38.055),(21.075,38.055),(21.075,37.905),(20.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,38.225),(20.925,38.375),(21.075,38.375),(21.075,38.225),(20.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,38.545),(20.925,38.695),(21.075,38.695),(21.075,38.545),(20.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,38.865),(20.925,39.015),(21.075,39.015),(21.075,38.865),(20.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,39.185),(20.925,39.335),(21.075,39.335),(21.075,39.185),(20.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,39.505),(20.925,39.655),(21.075,39.655),(21.075,39.505),(20.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,39.825),(20.925,39.975),(21.075,39.975),(21.075,39.825),(20.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,40.145),(20.925,40.295),(21.075,40.295),(21.075,40.145),(20.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,40.465),(20.925,40.615),(21.075,40.615),(21.075,40.465),(20.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,40.785),(20.925,40.935),(21.075,40.935),(21.075,40.785),(20.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,41.105),(20.925,41.255),(21.075,41.255),(21.075,41.105),(20.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,41.425),(20.925,41.575),(21.075,41.575),(21.075,41.425),(20.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,41.745),(20.925,41.895),(21.075,41.895),(21.075,41.745),(20.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,42.065),(20.925,42.215),(21.075,42.215),(21.075,42.065),(20.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,42.385),(20.925,42.535),(21.075,42.535),(21.075,42.385),(20.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,42.705),(20.925,42.855),(21.075,42.855),(21.075,42.705),(20.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,43.025),(20.925,43.175),(21.075,43.175),(21.075,43.025),(20.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,43.345),(20.925,43.495),(21.075,43.495),(21.075,43.345),(20.925,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.145),(6.78,0.295),(6.93,0.295),(6.93,0.145),(6.78,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.465),(6.78,0.615),(6.93,0.615),(6.93,0.465),(6.78,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.785),(6.78,0.935),(6.93,0.935),(6.93,0.785),(6.78,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.105),(6.78,1.255),(6.93,1.255),(6.93,1.105),(6.78,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.425),(6.78,1.575),(6.93,1.575),(6.93,1.425),(6.78,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.745),(6.78,1.895),(6.93,1.895),(6.93,1.745),(6.78,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.065),(6.78,2.215),(6.93,2.215),(6.93,2.065),(6.78,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.385),(6.78,2.535),(6.93,2.535),(6.93,2.385),(6.78,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.705),(6.78,2.855),(6.93,2.855),(6.93,2.705),(6.78,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.025),(6.78,3.175),(6.93,3.175),(6.93,3.025),(6.78,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.345),(6.78,3.495),(6.93,3.495),(6.93,3.345),(6.78,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.665),(6.78,3.815),(6.93,3.815),(6.93,3.665),(6.78,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.985),(6.78,4.135),(6.93,4.135),(6.93,3.985),(6.78,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.305),(6.78,4.455),(6.93,4.455),(6.93,4.305),(6.78,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.625),(6.78,4.775),(6.93,4.775),(6.93,4.625),(6.78,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.945),(6.78,5.095),(6.93,5.095),(6.93,4.945),(6.78,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.265),(6.78,5.415),(6.93,5.415),(6.93,5.265),(6.78,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.585),(6.78,5.735),(6.93,5.735),(6.93,5.585),(6.78,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.905),(6.78,6.055),(6.93,6.055),(6.93,5.905),(6.78,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.225),(6.78,6.375),(6.93,6.375),(6.93,6.225),(6.78,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.545),(6.78,6.695),(6.93,6.695),(6.93,6.545),(6.78,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.865),(6.78,7.015),(6.93,7.015),(6.93,6.865),(6.78,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.185),(6.78,7.335),(6.93,7.335),(6.93,7.185),(6.78,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.505),(6.78,7.655),(6.93,7.655),(6.93,7.505),(6.78,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.825),(6.78,7.975),(6.93,7.975),(6.93,7.825),(6.78,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.145),(6.78,8.295),(6.93,8.295),(6.93,8.145),(6.78,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.465),(6.78,8.615),(6.93,8.615),(6.93,8.465),(6.78,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.785),(6.78,8.935),(6.93,8.935),(6.93,8.785),(6.78,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.105),(6.78,9.255),(6.93,9.255),(6.93,9.105),(6.78,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.425),(6.78,9.575),(6.93,9.575),(6.93,9.425),(6.78,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.745),(6.78,9.895),(6.93,9.895),(6.93,9.745),(6.78,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.065),(6.78,10.215),(6.93,10.215),(6.93,10.065),(6.78,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.385),(6.78,10.535),(6.93,10.535),(6.93,10.385),(6.78,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.705),(6.78,10.855),(6.93,10.855),(6.93,10.705),(6.78,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.025),(6.78,11.175),(6.93,11.175),(6.93,11.025),(6.78,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.345),(6.78,11.495),(6.93,11.495),(6.93,11.345),(6.78,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.665),(6.78,11.815),(6.93,11.815),(6.93,11.665),(6.78,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.985),(6.78,12.135),(6.93,12.135),(6.93,11.985),(6.78,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.305),(6.78,12.455),(6.93,12.455),(6.93,12.305),(6.78,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.625),(6.78,12.775),(6.93,12.775),(6.93,12.625),(6.78,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.945),(6.78,13.095),(6.93,13.095),(6.93,12.945),(6.78,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.265),(6.78,13.415),(6.93,13.415),(6.93,13.265),(6.78,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.585),(6.78,13.735),(6.93,13.735),(6.93,13.585),(6.78,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.905),(6.78,14.055),(6.93,14.055),(6.93,13.905),(6.78,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.225),(6.78,14.375),(6.93,14.375),(6.93,14.225),(6.78,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.545),(6.78,14.695),(6.93,14.695),(6.93,14.545),(6.78,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.865),(6.78,15.015),(6.93,15.015),(6.93,14.865),(6.78,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.185),(6.78,15.335),(6.93,15.335),(6.93,15.185),(6.78,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.505),(6.78,15.655),(6.93,15.655),(6.93,15.505),(6.78,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.825),(6.78,15.975),(6.93,15.975),(6.93,15.825),(6.78,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.145),(6.78,16.295),(6.93,16.295),(6.93,16.145),(6.78,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.465),(6.78,16.615),(6.93,16.615),(6.93,16.465),(6.78,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.785),(6.78,16.935),(6.93,16.935),(6.93,16.785),(6.78,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.105),(6.78,17.255),(6.93,17.255),(6.93,17.105),(6.78,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.425),(6.78,17.575),(6.93,17.575),(6.93,17.425),(6.78,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.745),(6.78,17.895),(6.93,17.895),(6.93,17.745),(6.78,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.065),(6.78,18.215),(6.93,18.215),(6.93,18.065),(6.78,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.385),(6.78,18.535),(6.93,18.535),(6.93,18.385),(6.78,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.705),(6.78,18.855),(6.93,18.855),(6.93,18.705),(6.78,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.025),(6.78,19.175),(6.93,19.175),(6.93,19.025),(6.78,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.345),(6.78,19.495),(6.93,19.495),(6.93,19.345),(6.78,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.665),(6.78,19.815),(6.93,19.815),(6.93,19.665),(6.78,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.985),(6.78,20.135),(6.93,20.135),(6.93,19.985),(6.78,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.305),(6.78,20.455),(6.93,20.455),(6.93,20.305),(6.78,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.625),(6.78,20.775),(6.93,20.775),(6.93,20.625),(6.78,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.945),(6.78,21.095),(6.93,21.095),(6.93,20.945),(6.78,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.265),(6.78,21.415),(6.93,21.415),(6.93,21.265),(6.78,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.585),(6.78,21.735),(6.93,21.735),(6.93,21.585),(6.78,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.905),(6.78,22.055),(6.93,22.055),(6.93,21.905),(6.78,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,22.225),(6.78,22.375),(6.93,22.375),(6.93,22.225),(6.78,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,22.545),(6.78,22.695),(6.93,22.695),(6.93,22.545),(6.78,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,22.865),(6.78,23.015),(6.93,23.015),(6.93,22.865),(6.78,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,23.185),(6.78,23.335),(6.93,23.335),(6.93,23.185),(6.78,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,23.505),(6.78,23.655),(6.93,23.655),(6.93,23.505),(6.78,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,23.825),(6.78,23.975),(6.93,23.975),(6.93,23.825),(6.78,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,24.145),(6.78,24.295),(6.93,24.295),(6.93,24.145),(6.78,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,24.465),(6.78,24.615),(6.93,24.615),(6.93,24.465),(6.78,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,24.785),(6.78,24.935),(6.93,24.935),(6.93,24.785),(6.78,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,25.105),(6.78,25.255),(6.93,25.255),(6.93,25.105),(6.78,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,25.425),(6.78,25.575),(6.93,25.575),(6.93,25.425),(6.78,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,25.745),(6.78,25.895),(6.93,25.895),(6.93,25.745),(6.78,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,26.065),(6.78,26.215),(6.93,26.215),(6.93,26.065),(6.78,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,26.385),(6.78,26.535),(6.93,26.535),(6.93,26.385),(6.78,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,26.705),(6.78,26.855),(6.93,26.855),(6.93,26.705),(6.78,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.025),(6.78,27.175),(6.93,27.175),(6.93,27.025),(6.78,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.345),(6.78,27.495),(6.93,27.495),(6.93,27.345),(6.78,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.665),(6.78,27.815),(6.93,27.815),(6.93,27.665),(6.78,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,27.985),(6.78,28.135),(6.93,28.135),(6.93,27.985),(6.78,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,28.305),(6.78,28.455),(6.93,28.455),(6.93,28.305),(6.78,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,28.625),(6.78,28.775),(6.93,28.775),(6.93,28.625),(6.78,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,28.945),(6.78,29.095),(6.93,29.095),(6.93,28.945),(6.78,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,29.265),(6.78,29.415),(6.93,29.415),(6.93,29.265),(6.78,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,29.585),(6.78,29.735),(6.93,29.735),(6.93,29.585),(6.78,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,29.905),(6.78,30.055),(6.93,30.055),(6.93,29.905),(6.78,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,30.225),(6.78,30.375),(6.93,30.375),(6.93,30.225),(6.78,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,30.545),(6.78,30.695),(6.93,30.695),(6.93,30.545),(6.78,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,30.865),(6.78,31.015),(6.93,31.015),(6.93,30.865),(6.78,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,31.185),(6.78,31.335),(6.93,31.335),(6.93,31.185),(6.78,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,31.505),(6.78,31.655),(6.93,31.655),(6.93,31.505),(6.78,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,31.825),(6.78,31.975),(6.93,31.975),(6.93,31.825),(6.78,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,32.145),(6.78,32.295),(6.93,32.295),(6.93,32.145),(6.78,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,32.465),(6.78,32.615),(6.93,32.615),(6.93,32.465),(6.78,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,32.785),(6.78,32.935),(6.93,32.935),(6.93,32.785),(6.78,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,33.105),(6.78,33.255),(6.93,33.255),(6.93,33.105),(6.78,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,33.425),(6.78,33.575),(6.93,33.575),(6.93,33.425),(6.78,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,33.745),(6.78,33.895),(6.93,33.895),(6.93,33.745),(6.78,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,34.065),(6.78,34.215),(6.93,34.215),(6.93,34.065),(6.78,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,34.385),(6.78,34.535),(6.93,34.535),(6.93,34.385),(6.78,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,34.705),(6.78,34.855),(6.93,34.855),(6.93,34.705),(6.78,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.025),(6.78,35.175),(6.93,35.175),(6.93,35.025),(6.78,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.345),(6.78,35.495),(6.93,35.495),(6.93,35.345),(6.78,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.665),(6.78,35.815),(6.93,35.815),(6.93,35.665),(6.78,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,35.985),(6.78,36.135),(6.93,36.135),(6.93,35.985),(6.78,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,36.305),(6.78,36.455),(6.93,36.455),(6.93,36.305),(6.78,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,36.625),(6.78,36.775),(6.93,36.775),(6.93,36.625),(6.78,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,36.945),(6.78,37.095),(6.93,37.095),(6.93,36.945),(6.78,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,37.265),(6.78,37.415),(6.93,37.415),(6.93,37.265),(6.78,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,37.585),(6.78,37.735),(6.93,37.735),(6.93,37.585),(6.78,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,37.905),(6.78,38.055),(6.93,38.055),(6.93,37.905),(6.78,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,38.225),(6.78,38.375),(6.93,38.375),(6.93,38.225),(6.78,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,38.545),(6.78,38.695),(6.93,38.695),(6.93,38.545),(6.78,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,38.865),(6.78,39.015),(6.93,39.015),(6.93,38.865),(6.78,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,39.185),(6.78,39.335),(6.93,39.335),(6.93,39.185),(6.78,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,39.505),(6.78,39.655),(6.93,39.655),(6.93,39.505),(6.78,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,39.825),(6.78,39.975),(6.93,39.975),(6.93,39.825),(6.78,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,40.145),(6.78,40.295),(6.93,40.295),(6.93,40.145),(6.78,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,40.465),(6.78,40.615),(6.93,40.615),(6.93,40.465),(6.78,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,40.785),(6.78,40.935),(6.93,40.935),(6.93,40.785),(6.78,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,41.105),(6.78,41.255),(6.93,41.255),(6.93,41.105),(6.78,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,41.425),(6.78,41.575),(6.93,41.575),(6.93,41.425),(6.78,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,41.745),(6.78,41.895),(6.93,41.895),(6.93,41.745),(6.78,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,42.065),(6.78,42.215),(6.93,42.215),(6.93,42.065),(6.78,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,42.385),(6.78,42.535),(6.93,42.535),(6.93,42.385),(6.78,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,42.705),(6.78,42.855),(6.93,42.855),(6.93,42.705),(6.78,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,43.025),(6.78,43.175),(6.93,43.175),(6.93,43.025),(6.78,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,43.345),(6.78,43.495),(6.93,43.495),(6.93,43.345),(6.78,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.145),(30.525,0.295),(30.675,0.295),(30.675,0.145),(30.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.465),(30.525,0.615),(30.675,0.615),(30.675,0.465),(30.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.785),(30.525,0.935),(30.675,0.935),(30.675,0.785),(30.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.105),(30.525,1.255),(30.675,1.255),(30.675,1.105),(30.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.425),(30.525,1.575),(30.675,1.575),(30.675,1.425),(30.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.745),(30.525,1.895),(30.675,1.895),(30.675,1.745),(30.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.065),(30.525,2.215),(30.675,2.215),(30.675,2.065),(30.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.385),(30.525,2.535),(30.675,2.535),(30.675,2.385),(30.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.705),(30.525,2.855),(30.675,2.855),(30.675,2.705),(30.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.025),(30.525,3.175),(30.675,3.175),(30.675,3.025),(30.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.345),(30.525,3.495),(30.675,3.495),(30.675,3.345),(30.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.665),(30.525,3.815),(30.675,3.815),(30.675,3.665),(30.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.985),(30.525,4.135),(30.675,4.135),(30.675,3.985),(30.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.305),(30.525,4.455),(30.675,4.455),(30.675,4.305),(30.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.625),(30.525,4.775),(30.675,4.775),(30.675,4.625),(30.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.945),(30.525,5.095),(30.675,5.095),(30.675,4.945),(30.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.265),(30.525,5.415),(30.675,5.415),(30.675,5.265),(30.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.585),(30.525,5.735),(30.675,5.735),(30.675,5.585),(30.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.905),(30.525,6.055),(30.675,6.055),(30.675,5.905),(30.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.225),(30.525,6.375),(30.675,6.375),(30.675,6.225),(30.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.545),(30.525,6.695),(30.675,6.695),(30.675,6.545),(30.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.865),(30.525,7.015),(30.675,7.015),(30.675,6.865),(30.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.185),(30.525,7.335),(30.675,7.335),(30.675,7.185),(30.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.505),(30.525,7.655),(30.675,7.655),(30.675,7.505),(30.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.825),(30.525,7.975),(30.675,7.975),(30.675,7.825),(30.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.145),(30.525,8.295),(30.675,8.295),(30.675,8.145),(30.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.465),(30.525,8.615),(30.675,8.615),(30.675,8.465),(30.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.785),(30.525,8.935),(30.675,8.935),(30.675,8.785),(30.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.105),(30.525,9.255),(30.675,9.255),(30.675,9.105),(30.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.425),(30.525,9.575),(30.675,9.575),(30.675,9.425),(30.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.745),(30.525,9.895),(30.675,9.895),(30.675,9.745),(30.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.065),(30.525,10.215),(30.675,10.215),(30.675,10.065),(30.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.385),(30.525,10.535),(30.675,10.535),(30.675,10.385),(30.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.705),(30.525,10.855),(30.675,10.855),(30.675,10.705),(30.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.025),(30.525,11.175),(30.675,11.175),(30.675,11.025),(30.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.345),(30.525,11.495),(30.675,11.495),(30.675,11.345),(30.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.665),(30.525,11.815),(30.675,11.815),(30.675,11.665),(30.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.985),(30.525,12.135),(30.675,12.135),(30.675,11.985),(30.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.305),(30.525,12.455),(30.675,12.455),(30.675,12.305),(30.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.625),(30.525,12.775),(30.675,12.775),(30.675,12.625),(30.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.945),(30.525,13.095),(30.675,13.095),(30.675,12.945),(30.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.265),(30.525,13.415),(30.675,13.415),(30.675,13.265),(30.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.585),(30.525,13.735),(30.675,13.735),(30.675,13.585),(30.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.905),(30.525,14.055),(30.675,14.055),(30.675,13.905),(30.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.225),(30.525,14.375),(30.675,14.375),(30.675,14.225),(30.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.545),(30.525,14.695),(30.675,14.695),(30.675,14.545),(30.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.865),(30.525,15.015),(30.675,15.015),(30.675,14.865),(30.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.185),(30.525,15.335),(30.675,15.335),(30.675,15.185),(30.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.505),(30.525,15.655),(30.675,15.655),(30.675,15.505),(30.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.825),(30.525,15.975),(30.675,15.975),(30.675,15.825),(30.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.145),(30.525,16.295),(30.675,16.295),(30.675,16.145),(30.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.465),(30.525,16.615),(30.675,16.615),(30.675,16.465),(30.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.785),(30.525,16.935),(30.675,16.935),(30.675,16.785),(30.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.105),(30.525,17.255),(30.675,17.255),(30.675,17.105),(30.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.425),(30.525,17.575),(30.675,17.575),(30.675,17.425),(30.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.745),(30.525,17.895),(30.675,17.895),(30.675,17.745),(30.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.065),(30.525,18.215),(30.675,18.215),(30.675,18.065),(30.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.385),(30.525,18.535),(30.675,18.535),(30.675,18.385),(30.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.705),(30.525,18.855),(30.675,18.855),(30.675,18.705),(30.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.025),(30.525,19.175),(30.675,19.175),(30.675,19.025),(30.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.345),(30.525,19.495),(30.675,19.495),(30.675,19.345),(30.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.665),(30.525,19.815),(30.675,19.815),(30.675,19.665),(30.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.985),(30.525,20.135),(30.675,20.135),(30.675,19.985),(30.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.305),(30.525,20.455),(30.675,20.455),(30.675,20.305),(30.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.625),(30.525,20.775),(30.675,20.775),(30.675,20.625),(30.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.945),(30.525,21.095),(30.675,21.095),(30.675,20.945),(30.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.265),(30.525,21.415),(30.675,21.415),(30.675,21.265),(30.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.585),(30.525,21.735),(30.675,21.735),(30.675,21.585),(30.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.905),(30.525,22.055),(30.675,22.055),(30.675,21.905),(30.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,22.225),(30.525,22.375),(30.675,22.375),(30.675,22.225),(30.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,22.545),(30.525,22.695),(30.675,22.695),(30.675,22.545),(30.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,22.865),(30.525,23.015),(30.675,23.015),(30.675,22.865),(30.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,23.185),(30.525,23.335),(30.675,23.335),(30.675,23.185),(30.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,23.505),(30.525,23.655),(30.675,23.655),(30.675,23.505),(30.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,23.825),(30.525,23.975),(30.675,23.975),(30.675,23.825),(30.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,24.145),(30.525,24.295),(30.675,24.295),(30.675,24.145),(30.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,24.465),(30.525,24.615),(30.675,24.615),(30.675,24.465),(30.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,24.785),(30.525,24.935),(30.675,24.935),(30.675,24.785),(30.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,25.105),(30.525,25.255),(30.675,25.255),(30.675,25.105),(30.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,25.425),(30.525,25.575),(30.675,25.575),(30.675,25.425),(30.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,25.745),(30.525,25.895),(30.675,25.895),(30.675,25.745),(30.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,26.065),(30.525,26.215),(30.675,26.215),(30.675,26.065),(30.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,26.385),(30.525,26.535),(30.675,26.535),(30.675,26.385),(30.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,26.705),(30.525,26.855),(30.675,26.855),(30.675,26.705),(30.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.025),(30.525,27.175),(30.675,27.175),(30.675,27.025),(30.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.345),(30.525,27.495),(30.675,27.495),(30.675,27.345),(30.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.665),(30.525,27.815),(30.675,27.815),(30.675,27.665),(30.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,27.985),(30.525,28.135),(30.675,28.135),(30.675,27.985),(30.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,28.305),(30.525,28.455),(30.675,28.455),(30.675,28.305),(30.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,28.625),(30.525,28.775),(30.675,28.775),(30.675,28.625),(30.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,28.945),(30.525,29.095),(30.675,29.095),(30.675,28.945),(30.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,29.265),(30.525,29.415),(30.675,29.415),(30.675,29.265),(30.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,29.585),(30.525,29.735),(30.675,29.735),(30.675,29.585),(30.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,29.905),(30.525,30.055),(30.675,30.055),(30.675,29.905),(30.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,30.225),(30.525,30.375),(30.675,30.375),(30.675,30.225),(30.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,30.545),(30.525,30.695),(30.675,30.695),(30.675,30.545),(30.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,30.865),(30.525,31.015),(30.675,31.015),(30.675,30.865),(30.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,31.185),(30.525,31.335),(30.675,31.335),(30.675,31.185),(30.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,31.505),(30.525,31.655),(30.675,31.655),(30.675,31.505),(30.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,31.825),(30.525,31.975),(30.675,31.975),(30.675,31.825),(30.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,32.145),(30.525,32.295),(30.675,32.295),(30.675,32.145),(30.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,32.465),(30.525,32.615),(30.675,32.615),(30.675,32.465),(30.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,32.785),(30.525,32.935),(30.675,32.935),(30.675,32.785),(30.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,33.105),(30.525,33.255),(30.675,33.255),(30.675,33.105),(30.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,33.425),(30.525,33.575),(30.675,33.575),(30.675,33.425),(30.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,33.745),(30.525,33.895),(30.675,33.895),(30.675,33.745),(30.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,34.065),(30.525,34.215),(30.675,34.215),(30.675,34.065),(30.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,34.385),(30.525,34.535),(30.675,34.535),(30.675,34.385),(30.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,34.705),(30.525,34.855),(30.675,34.855),(30.675,34.705),(30.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.025),(30.525,35.175),(30.675,35.175),(30.675,35.025),(30.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.345),(30.525,35.495),(30.675,35.495),(30.675,35.345),(30.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.665),(30.525,35.815),(30.675,35.815),(30.675,35.665),(30.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,35.985),(30.525,36.135),(30.675,36.135),(30.675,35.985),(30.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,36.305),(30.525,36.455),(30.675,36.455),(30.675,36.305),(30.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,36.625),(30.525,36.775),(30.675,36.775),(30.675,36.625),(30.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,36.945),(30.525,37.095),(30.675,37.095),(30.675,36.945),(30.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,37.265),(30.525,37.415),(30.675,37.415),(30.675,37.265),(30.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,37.585),(30.525,37.735),(30.675,37.735),(30.675,37.585),(30.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,37.905),(30.525,38.055),(30.675,38.055),(30.675,37.905),(30.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,38.225),(30.525,38.375),(30.675,38.375),(30.675,38.225),(30.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,38.545),(30.525,38.695),(30.675,38.695),(30.675,38.545),(30.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,38.865),(30.525,39.015),(30.675,39.015),(30.675,38.865),(30.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,39.185),(30.525,39.335),(30.675,39.335),(30.675,39.185),(30.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,39.505),(30.525,39.655),(30.675,39.655),(30.675,39.505),(30.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,39.825),(30.525,39.975),(30.675,39.975),(30.675,39.825),(30.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,40.145),(30.525,40.295),(30.675,40.295),(30.675,40.145),(30.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,40.465),(30.525,40.615),(30.675,40.615),(30.675,40.465),(30.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,40.785),(30.525,40.935),(30.675,40.935),(30.675,40.785),(30.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,41.105),(30.525,41.255),(30.675,41.255),(30.675,41.105),(30.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,41.425),(30.525,41.575),(30.675,41.575),(30.675,41.425),(30.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,41.745),(30.525,41.895),(30.675,41.895),(30.675,41.745),(30.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,42.065),(30.525,42.215),(30.675,42.215),(30.675,42.065),(30.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,42.385),(30.525,42.535),(30.675,42.535),(30.675,42.385),(30.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,42.705),(30.525,42.855),(30.675,42.855),(30.675,42.705),(30.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,43.025),(30.525,43.175),(30.675,43.175),(30.675,43.025),(30.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,43.345),(30.525,43.495),(30.675,43.495),(30.675,43.345),(30.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.145),(54.525,0.295),(54.675,0.295),(54.675,0.145),(54.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.465),(54.525,0.615),(54.675,0.615),(54.675,0.465),(54.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.785),(54.525,0.935),(54.675,0.935),(54.675,0.785),(54.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.105),(54.525,1.255),(54.675,1.255),(54.675,1.105),(54.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.425),(54.525,1.575),(54.675,1.575),(54.675,1.425),(54.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.745),(54.525,1.895),(54.675,1.895),(54.675,1.745),(54.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.065),(54.525,2.215),(54.675,2.215),(54.675,2.065),(54.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.385),(54.525,2.535),(54.675,2.535),(54.675,2.385),(54.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.705),(54.525,2.855),(54.675,2.855),(54.675,2.705),(54.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.025),(54.525,3.175),(54.675,3.175),(54.675,3.025),(54.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.345),(54.525,3.495),(54.675,3.495),(54.675,3.345),(54.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.665),(54.525,3.815),(54.675,3.815),(54.675,3.665),(54.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.985),(54.525,4.135),(54.675,4.135),(54.675,3.985),(54.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.305),(54.525,4.455),(54.675,4.455),(54.675,4.305),(54.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.625),(54.525,4.775),(54.675,4.775),(54.675,4.625),(54.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.945),(54.525,5.095),(54.675,5.095),(54.675,4.945),(54.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.265),(54.525,5.415),(54.675,5.415),(54.675,5.265),(54.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.585),(54.525,5.735),(54.675,5.735),(54.675,5.585),(54.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.905),(54.525,6.055),(54.675,6.055),(54.675,5.905),(54.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.225),(54.525,6.375),(54.675,6.375),(54.675,6.225),(54.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.545),(54.525,6.695),(54.675,6.695),(54.675,6.545),(54.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.865),(54.525,7.015),(54.675,7.015),(54.675,6.865),(54.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.185),(54.525,7.335),(54.675,7.335),(54.675,7.185),(54.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.505),(54.525,7.655),(54.675,7.655),(54.675,7.505),(54.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.825),(54.525,7.975),(54.675,7.975),(54.675,7.825),(54.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.145),(54.525,8.295),(54.675,8.295),(54.675,8.145),(54.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.465),(54.525,8.615),(54.675,8.615),(54.675,8.465),(54.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.785),(54.525,8.935),(54.675,8.935),(54.675,8.785),(54.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.105),(54.525,9.255),(54.675,9.255),(54.675,9.105),(54.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.425),(54.525,9.575),(54.675,9.575),(54.675,9.425),(54.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.745),(54.525,9.895),(54.675,9.895),(54.675,9.745),(54.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.065),(54.525,10.215),(54.675,10.215),(54.675,10.065),(54.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.385),(54.525,10.535),(54.675,10.535),(54.675,10.385),(54.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.705),(54.525,10.855),(54.675,10.855),(54.675,10.705),(54.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.025),(54.525,11.175),(54.675,11.175),(54.675,11.025),(54.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.345),(54.525,11.495),(54.675,11.495),(54.675,11.345),(54.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.665),(54.525,11.815),(54.675,11.815),(54.675,11.665),(54.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.985),(54.525,12.135),(54.675,12.135),(54.675,11.985),(54.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.305),(54.525,12.455),(54.675,12.455),(54.675,12.305),(54.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.625),(54.525,12.775),(54.675,12.775),(54.675,12.625),(54.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.945),(54.525,13.095),(54.675,13.095),(54.675,12.945),(54.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.265),(54.525,13.415),(54.675,13.415),(54.675,13.265),(54.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.585),(54.525,13.735),(54.675,13.735),(54.675,13.585),(54.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.905),(54.525,14.055),(54.675,14.055),(54.675,13.905),(54.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.225),(54.525,14.375),(54.675,14.375),(54.675,14.225),(54.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.545),(54.525,14.695),(54.675,14.695),(54.675,14.545),(54.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.865),(54.525,15.015),(54.675,15.015),(54.675,14.865),(54.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.185),(54.525,15.335),(54.675,15.335),(54.675,15.185),(54.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.505),(54.525,15.655),(54.675,15.655),(54.675,15.505),(54.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.825),(54.525,15.975),(54.675,15.975),(54.675,15.825),(54.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.145),(54.525,16.295),(54.675,16.295),(54.675,16.145),(54.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.465),(54.525,16.615),(54.675,16.615),(54.675,16.465),(54.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.785),(54.525,16.935),(54.675,16.935),(54.675,16.785),(54.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.105),(54.525,17.255),(54.675,17.255),(54.675,17.105),(54.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.425),(54.525,17.575),(54.675,17.575),(54.675,17.425),(54.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.745),(54.525,17.895),(54.675,17.895),(54.675,17.745),(54.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.065),(54.525,18.215),(54.675,18.215),(54.675,18.065),(54.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.385),(54.525,18.535),(54.675,18.535),(54.675,18.385),(54.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.705),(54.525,18.855),(54.675,18.855),(54.675,18.705),(54.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.025),(54.525,19.175),(54.675,19.175),(54.675,19.025),(54.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.345),(54.525,19.495),(54.675,19.495),(54.675,19.345),(54.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.665),(54.525,19.815),(54.675,19.815),(54.675,19.665),(54.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.985),(54.525,20.135),(54.675,20.135),(54.675,19.985),(54.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.305),(54.525,20.455),(54.675,20.455),(54.675,20.305),(54.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.625),(54.525,20.775),(54.675,20.775),(54.675,20.625),(54.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.945),(54.525,21.095),(54.675,21.095),(54.675,20.945),(54.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.265),(54.525,21.415),(54.675,21.415),(54.675,21.265),(54.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.585),(54.525,21.735),(54.675,21.735),(54.675,21.585),(54.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.905),(54.525,22.055),(54.675,22.055),(54.675,21.905),(54.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.225),(54.525,22.375),(54.675,22.375),(54.675,22.225),(54.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.545),(54.525,22.695),(54.675,22.695),(54.675,22.545),(54.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.865),(54.525,23.015),(54.675,23.015),(54.675,22.865),(54.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.185),(54.525,23.335),(54.675,23.335),(54.675,23.185),(54.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.505),(54.525,23.655),(54.675,23.655),(54.675,23.505),(54.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.825),(54.525,23.975),(54.675,23.975),(54.675,23.825),(54.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.145),(54.525,24.295),(54.675,24.295),(54.675,24.145),(54.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.465),(54.525,24.615),(54.675,24.615),(54.675,24.465),(54.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.785),(54.525,24.935),(54.675,24.935),(54.675,24.785),(54.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.105),(54.525,25.255),(54.675,25.255),(54.675,25.105),(54.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.425),(54.525,25.575),(54.675,25.575),(54.675,25.425),(54.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.745),(54.525,25.895),(54.675,25.895),(54.675,25.745),(54.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.065),(54.525,26.215),(54.675,26.215),(54.675,26.065),(54.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.385),(54.525,26.535),(54.675,26.535),(54.675,26.385),(54.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.705),(54.525,26.855),(54.675,26.855),(54.675,26.705),(54.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.025),(54.525,27.175),(54.675,27.175),(54.675,27.025),(54.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.345),(54.525,27.495),(54.675,27.495),(54.675,27.345),(54.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.665),(54.525,27.815),(54.675,27.815),(54.675,27.665),(54.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.985),(54.525,28.135),(54.675,28.135),(54.675,27.985),(54.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.305),(54.525,28.455),(54.675,28.455),(54.675,28.305),(54.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.625),(54.525,28.775),(54.675,28.775),(54.675,28.625),(54.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.945),(54.525,29.095),(54.675,29.095),(54.675,28.945),(54.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.265),(54.525,29.415),(54.675,29.415),(54.675,29.265),(54.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.585),(54.525,29.735),(54.675,29.735),(54.675,29.585),(54.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.905),(54.525,30.055),(54.675,30.055),(54.675,29.905),(54.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.225),(54.525,30.375),(54.675,30.375),(54.675,30.225),(54.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.545),(54.525,30.695),(54.675,30.695),(54.675,30.545),(54.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.865),(54.525,31.015),(54.675,31.015),(54.675,30.865),(54.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.185),(54.525,31.335),(54.675,31.335),(54.675,31.185),(54.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.505),(54.525,31.655),(54.675,31.655),(54.675,31.505),(54.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.825),(54.525,31.975),(54.675,31.975),(54.675,31.825),(54.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.145),(54.525,32.295),(54.675,32.295),(54.675,32.145),(54.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.465),(54.525,32.615),(54.675,32.615),(54.675,32.465),(54.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.785),(54.525,32.935),(54.675,32.935),(54.675,32.785),(54.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.105),(54.525,33.255),(54.675,33.255),(54.675,33.105),(54.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.425),(54.525,33.575),(54.675,33.575),(54.675,33.425),(54.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.745),(54.525,33.895),(54.675,33.895),(54.675,33.745),(54.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.065),(54.525,34.215),(54.675,34.215),(54.675,34.065),(54.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.385),(54.525,34.535),(54.675,34.535),(54.675,34.385),(54.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.705),(54.525,34.855),(54.675,34.855),(54.675,34.705),(54.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.025),(54.525,35.175),(54.675,35.175),(54.675,35.025),(54.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.345),(54.525,35.495),(54.675,35.495),(54.675,35.345),(54.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.665),(54.525,35.815),(54.675,35.815),(54.675,35.665),(54.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.985),(54.525,36.135),(54.675,36.135),(54.675,35.985),(54.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.305),(54.525,36.455),(54.675,36.455),(54.675,36.305),(54.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.625),(54.525,36.775),(54.675,36.775),(54.675,36.625),(54.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.945),(54.525,37.095),(54.675,37.095),(54.675,36.945),(54.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.265),(54.525,37.415),(54.675,37.415),(54.675,37.265),(54.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.585),(54.525,37.735),(54.675,37.735),(54.675,37.585),(54.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.905),(54.525,38.055),(54.675,38.055),(54.675,37.905),(54.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.225),(54.525,38.375),(54.675,38.375),(54.675,38.225),(54.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.545),(54.525,38.695),(54.675,38.695),(54.675,38.545),(54.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.865),(54.525,39.015),(54.675,39.015),(54.675,38.865),(54.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.185),(54.525,39.335),(54.675,39.335),(54.675,39.185),(54.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.505),(54.525,39.655),(54.675,39.655),(54.675,39.505),(54.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.825),(54.525,39.975),(54.675,39.975),(54.675,39.825),(54.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.145),(54.525,40.295),(54.675,40.295),(54.675,40.145),(54.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.465),(54.525,40.615),(54.675,40.615),(54.675,40.465),(54.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.785),(54.525,40.935),(54.675,40.935),(54.675,40.785),(54.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.105),(54.525,41.255),(54.675,41.255),(54.675,41.105),(54.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.425),(54.525,41.575),(54.675,41.575),(54.675,41.425),(54.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.745),(54.525,41.895),(54.675,41.895),(54.675,41.745),(54.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.065),(54.525,42.215),(54.675,42.215),(54.675,42.065),(54.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.385),(54.525,42.535),(54.675,42.535),(54.675,42.385),(54.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.705),(54.525,42.855),(54.675,42.855),(54.675,42.705),(54.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,43.025),(54.525,43.175),(54.675,43.175),(54.675,43.025),(54.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,43.345),(54.525,43.495),(54.675,43.495),(54.675,43.345),(54.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.145),(49.725,0.295),(49.875,0.295),(49.875,0.145),(49.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.465),(49.725,0.615),(49.875,0.615),(49.875,0.465),(49.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.785),(49.725,0.935),(49.875,0.935),(49.875,0.785),(49.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.105),(49.725,1.255),(49.875,1.255),(49.875,1.105),(49.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.425),(49.725,1.575),(49.875,1.575),(49.875,1.425),(49.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.745),(49.725,1.895),(49.875,1.895),(49.875,1.745),(49.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.065),(49.725,2.215),(49.875,2.215),(49.875,2.065),(49.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.385),(49.725,2.535),(49.875,2.535),(49.875,2.385),(49.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.705),(49.725,2.855),(49.875,2.855),(49.875,2.705),(49.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.025),(49.725,3.175),(49.875,3.175),(49.875,3.025),(49.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.345),(49.725,3.495),(49.875,3.495),(49.875,3.345),(49.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.665),(49.725,3.815),(49.875,3.815),(49.875,3.665),(49.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.985),(49.725,4.135),(49.875,4.135),(49.875,3.985),(49.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.305),(49.725,4.455),(49.875,4.455),(49.875,4.305),(49.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.625),(49.725,4.775),(49.875,4.775),(49.875,4.625),(49.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.945),(49.725,5.095),(49.875,5.095),(49.875,4.945),(49.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.265),(49.725,5.415),(49.875,5.415),(49.875,5.265),(49.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.585),(49.725,5.735),(49.875,5.735),(49.875,5.585),(49.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.905),(49.725,6.055),(49.875,6.055),(49.875,5.905),(49.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.225),(49.725,6.375),(49.875,6.375),(49.875,6.225),(49.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.545),(49.725,6.695),(49.875,6.695),(49.875,6.545),(49.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.865),(49.725,7.015),(49.875,7.015),(49.875,6.865),(49.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.185),(49.725,7.335),(49.875,7.335),(49.875,7.185),(49.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.505),(49.725,7.655),(49.875,7.655),(49.875,7.505),(49.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.825),(49.725,7.975),(49.875,7.975),(49.875,7.825),(49.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.145),(49.725,8.295),(49.875,8.295),(49.875,8.145),(49.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.465),(49.725,8.615),(49.875,8.615),(49.875,8.465),(49.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.785),(49.725,8.935),(49.875,8.935),(49.875,8.785),(49.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.105),(49.725,9.255),(49.875,9.255),(49.875,9.105),(49.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.425),(49.725,9.575),(49.875,9.575),(49.875,9.425),(49.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.745),(49.725,9.895),(49.875,9.895),(49.875,9.745),(49.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.065),(49.725,10.215),(49.875,10.215),(49.875,10.065),(49.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.385),(49.725,10.535),(49.875,10.535),(49.875,10.385),(49.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.705),(49.725,10.855),(49.875,10.855),(49.875,10.705),(49.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.025),(49.725,11.175),(49.875,11.175),(49.875,11.025),(49.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.345),(49.725,11.495),(49.875,11.495),(49.875,11.345),(49.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.665),(49.725,11.815),(49.875,11.815),(49.875,11.665),(49.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.985),(49.725,12.135),(49.875,12.135),(49.875,11.985),(49.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.305),(49.725,12.455),(49.875,12.455),(49.875,12.305),(49.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.625),(49.725,12.775),(49.875,12.775),(49.875,12.625),(49.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.945),(49.725,13.095),(49.875,13.095),(49.875,12.945),(49.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.265),(49.725,13.415),(49.875,13.415),(49.875,13.265),(49.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.585),(49.725,13.735),(49.875,13.735),(49.875,13.585),(49.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.905),(49.725,14.055),(49.875,14.055),(49.875,13.905),(49.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.225),(49.725,14.375),(49.875,14.375),(49.875,14.225),(49.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.545),(49.725,14.695),(49.875,14.695),(49.875,14.545),(49.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.865),(49.725,15.015),(49.875,15.015),(49.875,14.865),(49.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.185),(49.725,15.335),(49.875,15.335),(49.875,15.185),(49.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.505),(49.725,15.655),(49.875,15.655),(49.875,15.505),(49.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.825),(49.725,15.975),(49.875,15.975),(49.875,15.825),(49.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.145),(49.725,16.295),(49.875,16.295),(49.875,16.145),(49.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.465),(49.725,16.615),(49.875,16.615),(49.875,16.465),(49.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.785),(49.725,16.935),(49.875,16.935),(49.875,16.785),(49.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.105),(49.725,17.255),(49.875,17.255),(49.875,17.105),(49.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.425),(49.725,17.575),(49.875,17.575),(49.875,17.425),(49.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.745),(49.725,17.895),(49.875,17.895),(49.875,17.745),(49.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.065),(49.725,18.215),(49.875,18.215),(49.875,18.065),(49.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.385),(49.725,18.535),(49.875,18.535),(49.875,18.385),(49.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.705),(49.725,18.855),(49.875,18.855),(49.875,18.705),(49.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.025),(49.725,19.175),(49.875,19.175),(49.875,19.025),(49.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.345),(49.725,19.495),(49.875,19.495),(49.875,19.345),(49.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.665),(49.725,19.815),(49.875,19.815),(49.875,19.665),(49.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.985),(49.725,20.135),(49.875,20.135),(49.875,19.985),(49.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.305),(49.725,20.455),(49.875,20.455),(49.875,20.305),(49.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.625),(49.725,20.775),(49.875,20.775),(49.875,20.625),(49.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.945),(49.725,21.095),(49.875,21.095),(49.875,20.945),(49.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.265),(49.725,21.415),(49.875,21.415),(49.875,21.265),(49.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.585),(49.725,21.735),(49.875,21.735),(49.875,21.585),(49.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.905),(49.725,22.055),(49.875,22.055),(49.875,21.905),(49.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.225),(49.725,22.375),(49.875,22.375),(49.875,22.225),(49.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.545),(49.725,22.695),(49.875,22.695),(49.875,22.545),(49.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.865),(49.725,23.015),(49.875,23.015),(49.875,22.865),(49.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.185),(49.725,23.335),(49.875,23.335),(49.875,23.185),(49.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.505),(49.725,23.655),(49.875,23.655),(49.875,23.505),(49.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.825),(49.725,23.975),(49.875,23.975),(49.875,23.825),(49.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.145),(49.725,24.295),(49.875,24.295),(49.875,24.145),(49.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.465),(49.725,24.615),(49.875,24.615),(49.875,24.465),(49.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.785),(49.725,24.935),(49.875,24.935),(49.875,24.785),(49.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.105),(49.725,25.255),(49.875,25.255),(49.875,25.105),(49.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.425),(49.725,25.575),(49.875,25.575),(49.875,25.425),(49.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.745),(49.725,25.895),(49.875,25.895),(49.875,25.745),(49.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.065),(49.725,26.215),(49.875,26.215),(49.875,26.065),(49.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.385),(49.725,26.535),(49.875,26.535),(49.875,26.385),(49.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.705),(49.725,26.855),(49.875,26.855),(49.875,26.705),(49.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.025),(49.725,27.175),(49.875,27.175),(49.875,27.025),(49.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.345),(49.725,27.495),(49.875,27.495),(49.875,27.345),(49.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.665),(49.725,27.815),(49.875,27.815),(49.875,27.665),(49.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.985),(49.725,28.135),(49.875,28.135),(49.875,27.985),(49.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.305),(49.725,28.455),(49.875,28.455),(49.875,28.305),(49.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.625),(49.725,28.775),(49.875,28.775),(49.875,28.625),(49.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.945),(49.725,29.095),(49.875,29.095),(49.875,28.945),(49.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.265),(49.725,29.415),(49.875,29.415),(49.875,29.265),(49.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.585),(49.725,29.735),(49.875,29.735),(49.875,29.585),(49.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.905),(49.725,30.055),(49.875,30.055),(49.875,29.905),(49.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.225),(49.725,30.375),(49.875,30.375),(49.875,30.225),(49.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.545),(49.725,30.695),(49.875,30.695),(49.875,30.545),(49.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.865),(49.725,31.015),(49.875,31.015),(49.875,30.865),(49.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.185),(49.725,31.335),(49.875,31.335),(49.875,31.185),(49.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.505),(49.725,31.655),(49.875,31.655),(49.875,31.505),(49.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.825),(49.725,31.975),(49.875,31.975),(49.875,31.825),(49.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.145),(49.725,32.295),(49.875,32.295),(49.875,32.145),(49.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.465),(49.725,32.615),(49.875,32.615),(49.875,32.465),(49.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.785),(49.725,32.935),(49.875,32.935),(49.875,32.785),(49.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.105),(49.725,33.255),(49.875,33.255),(49.875,33.105),(49.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.425),(49.725,33.575),(49.875,33.575),(49.875,33.425),(49.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.745),(49.725,33.895),(49.875,33.895),(49.875,33.745),(49.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.065),(49.725,34.215),(49.875,34.215),(49.875,34.065),(49.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.385),(49.725,34.535),(49.875,34.535),(49.875,34.385),(49.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.705),(49.725,34.855),(49.875,34.855),(49.875,34.705),(49.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.025),(49.725,35.175),(49.875,35.175),(49.875,35.025),(49.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.345),(49.725,35.495),(49.875,35.495),(49.875,35.345),(49.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.665),(49.725,35.815),(49.875,35.815),(49.875,35.665),(49.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.985),(49.725,36.135),(49.875,36.135),(49.875,35.985),(49.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.305),(49.725,36.455),(49.875,36.455),(49.875,36.305),(49.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.625),(49.725,36.775),(49.875,36.775),(49.875,36.625),(49.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.945),(49.725,37.095),(49.875,37.095),(49.875,36.945),(49.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.265),(49.725,37.415),(49.875,37.415),(49.875,37.265),(49.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.585),(49.725,37.735),(49.875,37.735),(49.875,37.585),(49.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.905),(49.725,38.055),(49.875,38.055),(49.875,37.905),(49.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.225),(49.725,38.375),(49.875,38.375),(49.875,38.225),(49.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.545),(49.725,38.695),(49.875,38.695),(49.875,38.545),(49.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.865),(49.725,39.015),(49.875,39.015),(49.875,38.865),(49.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.185),(49.725,39.335),(49.875,39.335),(49.875,39.185),(49.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.505),(49.725,39.655),(49.875,39.655),(49.875,39.505),(49.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.825),(49.725,39.975),(49.875,39.975),(49.875,39.825),(49.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.145),(49.725,40.295),(49.875,40.295),(49.875,40.145),(49.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.465),(49.725,40.615),(49.875,40.615),(49.875,40.465),(49.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.785),(49.725,40.935),(49.875,40.935),(49.875,40.785),(49.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.105),(49.725,41.255),(49.875,41.255),(49.875,41.105),(49.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.425),(49.725,41.575),(49.875,41.575),(49.875,41.425),(49.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.745),(49.725,41.895),(49.875,41.895),(49.875,41.745),(49.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.065),(49.725,42.215),(49.875,42.215),(49.875,42.065),(49.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.385),(49.725,42.535),(49.875,42.535),(49.875,42.385),(49.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.705),(49.725,42.855),(49.875,42.855),(49.875,42.705),(49.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,43.025),(49.725,43.175),(49.875,43.175),(49.875,43.025),(49.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,43.345),(49.725,43.495),(49.875,43.495),(49.875,43.345),(49.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.145),(64.125,0.295),(64.275,0.295),(64.275,0.145),(64.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.465),(64.125,0.615),(64.275,0.615),(64.275,0.465),(64.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.785),(64.125,0.935),(64.275,0.935),(64.275,0.785),(64.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.105),(64.125,1.255),(64.275,1.255),(64.275,1.105),(64.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.425),(64.125,1.575),(64.275,1.575),(64.275,1.425),(64.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.745),(64.125,1.895),(64.275,1.895),(64.275,1.745),(64.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.065),(64.125,2.215),(64.275,2.215),(64.275,2.065),(64.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.385),(64.125,2.535),(64.275,2.535),(64.275,2.385),(64.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.705),(64.125,2.855),(64.275,2.855),(64.275,2.705),(64.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.025),(64.125,3.175),(64.275,3.175),(64.275,3.025),(64.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.345),(64.125,3.495),(64.275,3.495),(64.275,3.345),(64.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.665),(64.125,3.815),(64.275,3.815),(64.275,3.665),(64.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.985),(64.125,4.135),(64.275,4.135),(64.275,3.985),(64.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.305),(64.125,4.455),(64.275,4.455),(64.275,4.305),(64.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.625),(64.125,4.775),(64.275,4.775),(64.275,4.625),(64.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.945),(64.125,5.095),(64.275,5.095),(64.275,4.945),(64.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.265),(64.125,5.415),(64.275,5.415),(64.275,5.265),(64.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.585),(64.125,5.735),(64.275,5.735),(64.275,5.585),(64.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.905),(64.125,6.055),(64.275,6.055),(64.275,5.905),(64.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.225),(64.125,6.375),(64.275,6.375),(64.275,6.225),(64.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.545),(64.125,6.695),(64.275,6.695),(64.275,6.545),(64.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.865),(64.125,7.015),(64.275,7.015),(64.275,6.865),(64.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.185),(64.125,7.335),(64.275,7.335),(64.275,7.185),(64.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.505),(64.125,7.655),(64.275,7.655),(64.275,7.505),(64.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.825),(64.125,7.975),(64.275,7.975),(64.275,7.825),(64.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.145),(64.125,8.295),(64.275,8.295),(64.275,8.145),(64.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.465),(64.125,8.615),(64.275,8.615),(64.275,8.465),(64.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.785),(64.125,8.935),(64.275,8.935),(64.275,8.785),(64.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.105),(64.125,9.255),(64.275,9.255),(64.275,9.105),(64.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.425),(64.125,9.575),(64.275,9.575),(64.275,9.425),(64.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.745),(64.125,9.895),(64.275,9.895),(64.275,9.745),(64.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.065),(64.125,10.215),(64.275,10.215),(64.275,10.065),(64.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.385),(64.125,10.535),(64.275,10.535),(64.275,10.385),(64.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.705),(64.125,10.855),(64.275,10.855),(64.275,10.705),(64.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.025),(64.125,11.175),(64.275,11.175),(64.275,11.025),(64.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.345),(64.125,11.495),(64.275,11.495),(64.275,11.345),(64.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.665),(64.125,11.815),(64.275,11.815),(64.275,11.665),(64.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.985),(64.125,12.135),(64.275,12.135),(64.275,11.985),(64.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.305),(64.125,12.455),(64.275,12.455),(64.275,12.305),(64.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.625),(64.125,12.775),(64.275,12.775),(64.275,12.625),(64.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.945),(64.125,13.095),(64.275,13.095),(64.275,12.945),(64.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.265),(64.125,13.415),(64.275,13.415),(64.275,13.265),(64.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.585),(64.125,13.735),(64.275,13.735),(64.275,13.585),(64.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.905),(64.125,14.055),(64.275,14.055),(64.275,13.905),(64.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.225),(64.125,14.375),(64.275,14.375),(64.275,14.225),(64.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.545),(64.125,14.695),(64.275,14.695),(64.275,14.545),(64.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.865),(64.125,15.015),(64.275,15.015),(64.275,14.865),(64.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.185),(64.125,15.335),(64.275,15.335),(64.275,15.185),(64.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.505),(64.125,15.655),(64.275,15.655),(64.275,15.505),(64.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.825),(64.125,15.975),(64.275,15.975),(64.275,15.825),(64.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.145),(64.125,16.295),(64.275,16.295),(64.275,16.145),(64.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.465),(64.125,16.615),(64.275,16.615),(64.275,16.465),(64.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.785),(64.125,16.935),(64.275,16.935),(64.275,16.785),(64.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.105),(64.125,17.255),(64.275,17.255),(64.275,17.105),(64.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.425),(64.125,17.575),(64.275,17.575),(64.275,17.425),(64.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.745),(64.125,17.895),(64.275,17.895),(64.275,17.745),(64.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.065),(64.125,18.215),(64.275,18.215),(64.275,18.065),(64.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.385),(64.125,18.535),(64.275,18.535),(64.275,18.385),(64.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.705),(64.125,18.855),(64.275,18.855),(64.275,18.705),(64.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.025),(64.125,19.175),(64.275,19.175),(64.275,19.025),(64.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.345),(64.125,19.495),(64.275,19.495),(64.275,19.345),(64.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.665),(64.125,19.815),(64.275,19.815),(64.275,19.665),(64.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.985),(64.125,20.135),(64.275,20.135),(64.275,19.985),(64.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.305),(64.125,20.455),(64.275,20.455),(64.275,20.305),(64.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.625),(64.125,20.775),(64.275,20.775),(64.275,20.625),(64.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.945),(64.125,21.095),(64.275,21.095),(64.275,20.945),(64.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.265),(64.125,21.415),(64.275,21.415),(64.275,21.265),(64.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.585),(64.125,21.735),(64.275,21.735),(64.275,21.585),(64.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.905),(64.125,22.055),(64.275,22.055),(64.275,21.905),(64.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,22.225),(64.125,22.375),(64.275,22.375),(64.275,22.225),(64.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,22.545),(64.125,22.695),(64.275,22.695),(64.275,22.545),(64.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,22.865),(64.125,23.015),(64.275,23.015),(64.275,22.865),(64.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,23.185),(64.125,23.335),(64.275,23.335),(64.275,23.185),(64.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,23.505),(64.125,23.655),(64.275,23.655),(64.275,23.505),(64.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,23.825),(64.125,23.975),(64.275,23.975),(64.275,23.825),(64.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,24.145),(64.125,24.295),(64.275,24.295),(64.275,24.145),(64.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,24.465),(64.125,24.615),(64.275,24.615),(64.275,24.465),(64.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,24.785),(64.125,24.935),(64.275,24.935),(64.275,24.785),(64.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,25.105),(64.125,25.255),(64.275,25.255),(64.275,25.105),(64.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,25.425),(64.125,25.575),(64.275,25.575),(64.275,25.425),(64.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,25.745),(64.125,25.895),(64.275,25.895),(64.275,25.745),(64.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,26.065),(64.125,26.215),(64.275,26.215),(64.275,26.065),(64.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,26.385),(64.125,26.535),(64.275,26.535),(64.275,26.385),(64.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,26.705),(64.125,26.855),(64.275,26.855),(64.275,26.705),(64.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.025),(64.125,27.175),(64.275,27.175),(64.275,27.025),(64.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.345),(64.125,27.495),(64.275,27.495),(64.275,27.345),(64.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.665),(64.125,27.815),(64.275,27.815),(64.275,27.665),(64.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,27.985),(64.125,28.135),(64.275,28.135),(64.275,27.985),(64.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,28.305),(64.125,28.455),(64.275,28.455),(64.275,28.305),(64.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,28.625),(64.125,28.775),(64.275,28.775),(64.275,28.625),(64.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,28.945),(64.125,29.095),(64.275,29.095),(64.275,28.945),(64.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,29.265),(64.125,29.415),(64.275,29.415),(64.275,29.265),(64.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,29.585),(64.125,29.735),(64.275,29.735),(64.275,29.585),(64.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,29.905),(64.125,30.055),(64.275,30.055),(64.275,29.905),(64.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,30.225),(64.125,30.375),(64.275,30.375),(64.275,30.225),(64.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,30.545),(64.125,30.695),(64.275,30.695),(64.275,30.545),(64.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,30.865),(64.125,31.015),(64.275,31.015),(64.275,30.865),(64.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,31.185),(64.125,31.335),(64.275,31.335),(64.275,31.185),(64.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,31.505),(64.125,31.655),(64.275,31.655),(64.275,31.505),(64.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,31.825),(64.125,31.975),(64.275,31.975),(64.275,31.825),(64.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,32.145),(64.125,32.295),(64.275,32.295),(64.275,32.145),(64.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,32.465),(64.125,32.615),(64.275,32.615),(64.275,32.465),(64.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,32.785),(64.125,32.935),(64.275,32.935),(64.275,32.785),(64.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,33.105),(64.125,33.255),(64.275,33.255),(64.275,33.105),(64.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,33.425),(64.125,33.575),(64.275,33.575),(64.275,33.425),(64.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,33.745),(64.125,33.895),(64.275,33.895),(64.275,33.745),(64.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,34.065),(64.125,34.215),(64.275,34.215),(64.275,34.065),(64.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,34.385),(64.125,34.535),(64.275,34.535),(64.275,34.385),(64.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,34.705),(64.125,34.855),(64.275,34.855),(64.275,34.705),(64.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.025),(64.125,35.175),(64.275,35.175),(64.275,35.025),(64.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.345),(64.125,35.495),(64.275,35.495),(64.275,35.345),(64.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.665),(64.125,35.815),(64.275,35.815),(64.275,35.665),(64.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,35.985),(64.125,36.135),(64.275,36.135),(64.275,35.985),(64.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,36.305),(64.125,36.455),(64.275,36.455),(64.275,36.305),(64.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,36.625),(64.125,36.775),(64.275,36.775),(64.275,36.625),(64.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,36.945),(64.125,37.095),(64.275,37.095),(64.275,36.945),(64.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,37.265),(64.125,37.415),(64.275,37.415),(64.275,37.265),(64.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,37.585),(64.125,37.735),(64.275,37.735),(64.275,37.585),(64.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,37.905),(64.125,38.055),(64.275,38.055),(64.275,37.905),(64.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,38.225),(64.125,38.375),(64.275,38.375),(64.275,38.225),(64.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,38.545),(64.125,38.695),(64.275,38.695),(64.275,38.545),(64.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,38.865),(64.125,39.015),(64.275,39.015),(64.275,38.865),(64.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,39.185),(64.125,39.335),(64.275,39.335),(64.275,39.185),(64.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,39.505),(64.125,39.655),(64.275,39.655),(64.275,39.505),(64.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,39.825),(64.125,39.975),(64.275,39.975),(64.275,39.825),(64.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,40.145),(64.125,40.295),(64.275,40.295),(64.275,40.145),(64.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,40.465),(64.125,40.615),(64.275,40.615),(64.275,40.465),(64.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,40.785),(64.125,40.935),(64.275,40.935),(64.275,40.785),(64.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,41.105),(64.125,41.255),(64.275,41.255),(64.275,41.105),(64.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,41.425),(64.125,41.575),(64.275,41.575),(64.275,41.425),(64.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,41.745),(64.125,41.895),(64.275,41.895),(64.275,41.745),(64.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,42.065),(64.125,42.215),(64.275,42.215),(64.275,42.065),(64.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,42.385),(64.125,42.535),(64.275,42.535),(64.275,42.385),(64.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,42.705),(64.125,42.855),(64.275,42.855),(64.275,42.705),(64.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,43.025),(64.125,43.175),(64.275,43.175),(64.275,43.025),(64.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,43.345),(64.125,43.495),(64.275,43.495),(64.275,43.345),(64.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.145),(78.525,0.295),(78.675,0.295),(78.675,0.145),(78.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.465),(78.525,0.615),(78.675,0.615),(78.675,0.465),(78.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.785),(78.525,0.935),(78.675,0.935),(78.675,0.785),(78.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.105),(78.525,1.255),(78.675,1.255),(78.675,1.105),(78.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.425),(78.525,1.575),(78.675,1.575),(78.675,1.425),(78.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.745),(78.525,1.895),(78.675,1.895),(78.675,1.745),(78.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.065),(78.525,2.215),(78.675,2.215),(78.675,2.065),(78.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.385),(78.525,2.535),(78.675,2.535),(78.675,2.385),(78.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.705),(78.525,2.855),(78.675,2.855),(78.675,2.705),(78.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.025),(78.525,3.175),(78.675,3.175),(78.675,3.025),(78.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.345),(78.525,3.495),(78.675,3.495),(78.675,3.345),(78.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.665),(78.525,3.815),(78.675,3.815),(78.675,3.665),(78.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.985),(78.525,4.135),(78.675,4.135),(78.675,3.985),(78.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.305),(78.525,4.455),(78.675,4.455),(78.675,4.305),(78.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.625),(78.525,4.775),(78.675,4.775),(78.675,4.625),(78.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.945),(78.525,5.095),(78.675,5.095),(78.675,4.945),(78.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.265),(78.525,5.415),(78.675,5.415),(78.675,5.265),(78.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.585),(78.525,5.735),(78.675,5.735),(78.675,5.585),(78.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.905),(78.525,6.055),(78.675,6.055),(78.675,5.905),(78.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.225),(78.525,6.375),(78.675,6.375),(78.675,6.225),(78.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.545),(78.525,6.695),(78.675,6.695),(78.675,6.545),(78.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.865),(78.525,7.015),(78.675,7.015),(78.675,6.865),(78.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.185),(78.525,7.335),(78.675,7.335),(78.675,7.185),(78.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.505),(78.525,7.655),(78.675,7.655),(78.675,7.505),(78.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.825),(78.525,7.975),(78.675,7.975),(78.675,7.825),(78.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.145),(78.525,8.295),(78.675,8.295),(78.675,8.145),(78.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.465),(78.525,8.615),(78.675,8.615),(78.675,8.465),(78.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.785),(78.525,8.935),(78.675,8.935),(78.675,8.785),(78.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.105),(78.525,9.255),(78.675,9.255),(78.675,9.105),(78.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.425),(78.525,9.575),(78.675,9.575),(78.675,9.425),(78.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.745),(78.525,9.895),(78.675,9.895),(78.675,9.745),(78.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.065),(78.525,10.215),(78.675,10.215),(78.675,10.065),(78.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.385),(78.525,10.535),(78.675,10.535),(78.675,10.385),(78.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.705),(78.525,10.855),(78.675,10.855),(78.675,10.705),(78.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.025),(78.525,11.175),(78.675,11.175),(78.675,11.025),(78.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.345),(78.525,11.495),(78.675,11.495),(78.675,11.345),(78.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.665),(78.525,11.815),(78.675,11.815),(78.675,11.665),(78.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.985),(78.525,12.135),(78.675,12.135),(78.675,11.985),(78.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.305),(78.525,12.455),(78.675,12.455),(78.675,12.305),(78.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.625),(78.525,12.775),(78.675,12.775),(78.675,12.625),(78.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.945),(78.525,13.095),(78.675,13.095),(78.675,12.945),(78.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.265),(78.525,13.415),(78.675,13.415),(78.675,13.265),(78.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.585),(78.525,13.735),(78.675,13.735),(78.675,13.585),(78.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.905),(78.525,14.055),(78.675,14.055),(78.675,13.905),(78.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.225),(78.525,14.375),(78.675,14.375),(78.675,14.225),(78.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.545),(78.525,14.695),(78.675,14.695),(78.675,14.545),(78.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.865),(78.525,15.015),(78.675,15.015),(78.675,14.865),(78.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.185),(78.525,15.335),(78.675,15.335),(78.675,15.185),(78.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.505),(78.525,15.655),(78.675,15.655),(78.675,15.505),(78.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.825),(78.525,15.975),(78.675,15.975),(78.675,15.825),(78.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.145),(78.525,16.295),(78.675,16.295),(78.675,16.145),(78.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.465),(78.525,16.615),(78.675,16.615),(78.675,16.465),(78.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.785),(78.525,16.935),(78.675,16.935),(78.675,16.785),(78.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.105),(78.525,17.255),(78.675,17.255),(78.675,17.105),(78.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.425),(78.525,17.575),(78.675,17.575),(78.675,17.425),(78.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.745),(78.525,17.895),(78.675,17.895),(78.675,17.745),(78.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.065),(78.525,18.215),(78.675,18.215),(78.675,18.065),(78.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.385),(78.525,18.535),(78.675,18.535),(78.675,18.385),(78.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.705),(78.525,18.855),(78.675,18.855),(78.675,18.705),(78.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.025),(78.525,19.175),(78.675,19.175),(78.675,19.025),(78.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.345),(78.525,19.495),(78.675,19.495),(78.675,19.345),(78.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.665),(78.525,19.815),(78.675,19.815),(78.675,19.665),(78.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.985),(78.525,20.135),(78.675,20.135),(78.675,19.985),(78.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.305),(78.525,20.455),(78.675,20.455),(78.675,20.305),(78.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.625),(78.525,20.775),(78.675,20.775),(78.675,20.625),(78.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.945),(78.525,21.095),(78.675,21.095),(78.675,20.945),(78.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.265),(78.525,21.415),(78.675,21.415),(78.675,21.265),(78.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.585),(78.525,21.735),(78.675,21.735),(78.675,21.585),(78.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.905),(78.525,22.055),(78.675,22.055),(78.675,21.905),(78.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,22.225),(78.525,22.375),(78.675,22.375),(78.675,22.225),(78.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,22.545),(78.525,22.695),(78.675,22.695),(78.675,22.545),(78.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,22.865),(78.525,23.015),(78.675,23.015),(78.675,22.865),(78.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,23.185),(78.525,23.335),(78.675,23.335),(78.675,23.185),(78.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,23.505),(78.525,23.655),(78.675,23.655),(78.675,23.505),(78.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,23.825),(78.525,23.975),(78.675,23.975),(78.675,23.825),(78.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,24.145),(78.525,24.295),(78.675,24.295),(78.675,24.145),(78.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,24.465),(78.525,24.615),(78.675,24.615),(78.675,24.465),(78.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,24.785),(78.525,24.935),(78.675,24.935),(78.675,24.785),(78.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,25.105),(78.525,25.255),(78.675,25.255),(78.675,25.105),(78.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,25.425),(78.525,25.575),(78.675,25.575),(78.675,25.425),(78.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,25.745),(78.525,25.895),(78.675,25.895),(78.675,25.745),(78.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,26.065),(78.525,26.215),(78.675,26.215),(78.675,26.065),(78.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,26.385),(78.525,26.535),(78.675,26.535),(78.675,26.385),(78.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,26.705),(78.525,26.855),(78.675,26.855),(78.675,26.705),(78.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.025),(78.525,27.175),(78.675,27.175),(78.675,27.025),(78.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.345),(78.525,27.495),(78.675,27.495),(78.675,27.345),(78.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.665),(78.525,27.815),(78.675,27.815),(78.675,27.665),(78.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,27.985),(78.525,28.135),(78.675,28.135),(78.675,27.985),(78.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,28.305),(78.525,28.455),(78.675,28.455),(78.675,28.305),(78.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,28.625),(78.525,28.775),(78.675,28.775),(78.675,28.625),(78.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,28.945),(78.525,29.095),(78.675,29.095),(78.675,28.945),(78.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,29.265),(78.525,29.415),(78.675,29.415),(78.675,29.265),(78.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,29.585),(78.525,29.735),(78.675,29.735),(78.675,29.585),(78.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,29.905),(78.525,30.055),(78.675,30.055),(78.675,29.905),(78.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,30.225),(78.525,30.375),(78.675,30.375),(78.675,30.225),(78.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,30.545),(78.525,30.695),(78.675,30.695),(78.675,30.545),(78.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,30.865),(78.525,31.015),(78.675,31.015),(78.675,30.865),(78.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,31.185),(78.525,31.335),(78.675,31.335),(78.675,31.185),(78.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,31.505),(78.525,31.655),(78.675,31.655),(78.675,31.505),(78.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,31.825),(78.525,31.975),(78.675,31.975),(78.675,31.825),(78.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,32.145),(78.525,32.295),(78.675,32.295),(78.675,32.145),(78.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,32.465),(78.525,32.615),(78.675,32.615),(78.675,32.465),(78.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,32.785),(78.525,32.935),(78.675,32.935),(78.675,32.785),(78.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,33.105),(78.525,33.255),(78.675,33.255),(78.675,33.105),(78.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,33.425),(78.525,33.575),(78.675,33.575),(78.675,33.425),(78.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,33.745),(78.525,33.895),(78.675,33.895),(78.675,33.745),(78.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,34.065),(78.525,34.215),(78.675,34.215),(78.675,34.065),(78.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,34.385),(78.525,34.535),(78.675,34.535),(78.675,34.385),(78.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,34.705),(78.525,34.855),(78.675,34.855),(78.675,34.705),(78.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.025),(78.525,35.175),(78.675,35.175),(78.675,35.025),(78.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.345),(78.525,35.495),(78.675,35.495),(78.675,35.345),(78.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.665),(78.525,35.815),(78.675,35.815),(78.675,35.665),(78.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,35.985),(78.525,36.135),(78.675,36.135),(78.675,35.985),(78.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,36.305),(78.525,36.455),(78.675,36.455),(78.675,36.305),(78.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,36.625),(78.525,36.775),(78.675,36.775),(78.675,36.625),(78.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,36.945),(78.525,37.095),(78.675,37.095),(78.675,36.945),(78.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,37.265),(78.525,37.415),(78.675,37.415),(78.675,37.265),(78.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,37.585),(78.525,37.735),(78.675,37.735),(78.675,37.585),(78.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,37.905),(78.525,38.055),(78.675,38.055),(78.675,37.905),(78.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,38.225),(78.525,38.375),(78.675,38.375),(78.675,38.225),(78.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,38.545),(78.525,38.695),(78.675,38.695),(78.675,38.545),(78.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,38.865),(78.525,39.015),(78.675,39.015),(78.675,38.865),(78.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,39.185),(78.525,39.335),(78.675,39.335),(78.675,39.185),(78.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,39.505),(78.525,39.655),(78.675,39.655),(78.675,39.505),(78.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,39.825),(78.525,39.975),(78.675,39.975),(78.675,39.825),(78.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,40.145),(78.525,40.295),(78.675,40.295),(78.675,40.145),(78.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,40.465),(78.525,40.615),(78.675,40.615),(78.675,40.465),(78.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,40.785),(78.525,40.935),(78.675,40.935),(78.675,40.785),(78.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,41.105),(78.525,41.255),(78.675,41.255),(78.675,41.105),(78.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,41.425),(78.525,41.575),(78.675,41.575),(78.675,41.425),(78.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,41.745),(78.525,41.895),(78.675,41.895),(78.675,41.745),(78.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,42.065),(78.525,42.215),(78.675,42.215),(78.675,42.065),(78.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,42.385),(78.525,42.535),(78.675,42.535),(78.675,42.385),(78.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,42.705),(78.525,42.855),(78.675,42.855),(78.675,42.705),(78.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,43.025),(78.525,43.175),(78.675,43.175),(78.675,43.025),(78.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,43.345),(78.525,43.495),(78.675,43.495),(78.675,43.345),(78.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.145),(25.725,0.295),(25.875,0.295),(25.875,0.145),(25.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.465),(25.725,0.615),(25.875,0.615),(25.875,0.465),(25.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.785),(25.725,0.935),(25.875,0.935),(25.875,0.785),(25.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.105),(25.725,1.255),(25.875,1.255),(25.875,1.105),(25.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.425),(25.725,1.575),(25.875,1.575),(25.875,1.425),(25.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.745),(25.725,1.895),(25.875,1.895),(25.875,1.745),(25.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.065),(25.725,2.215),(25.875,2.215),(25.875,2.065),(25.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.385),(25.725,2.535),(25.875,2.535),(25.875,2.385),(25.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.705),(25.725,2.855),(25.875,2.855),(25.875,2.705),(25.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.025),(25.725,3.175),(25.875,3.175),(25.875,3.025),(25.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.345),(25.725,3.495),(25.875,3.495),(25.875,3.345),(25.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.665),(25.725,3.815),(25.875,3.815),(25.875,3.665),(25.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.985),(25.725,4.135),(25.875,4.135),(25.875,3.985),(25.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.305),(25.725,4.455),(25.875,4.455),(25.875,4.305),(25.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.625),(25.725,4.775),(25.875,4.775),(25.875,4.625),(25.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.945),(25.725,5.095),(25.875,5.095),(25.875,4.945),(25.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.265),(25.725,5.415),(25.875,5.415),(25.875,5.265),(25.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.585),(25.725,5.735),(25.875,5.735),(25.875,5.585),(25.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.905),(25.725,6.055),(25.875,6.055),(25.875,5.905),(25.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.225),(25.725,6.375),(25.875,6.375),(25.875,6.225),(25.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.545),(25.725,6.695),(25.875,6.695),(25.875,6.545),(25.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.865),(25.725,7.015),(25.875,7.015),(25.875,6.865),(25.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.185),(25.725,7.335),(25.875,7.335),(25.875,7.185),(25.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.505),(25.725,7.655),(25.875,7.655),(25.875,7.505),(25.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.825),(25.725,7.975),(25.875,7.975),(25.875,7.825),(25.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.145),(25.725,8.295),(25.875,8.295),(25.875,8.145),(25.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.465),(25.725,8.615),(25.875,8.615),(25.875,8.465),(25.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.785),(25.725,8.935),(25.875,8.935),(25.875,8.785),(25.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.105),(25.725,9.255),(25.875,9.255),(25.875,9.105),(25.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.425),(25.725,9.575),(25.875,9.575),(25.875,9.425),(25.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.745),(25.725,9.895),(25.875,9.895),(25.875,9.745),(25.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.065),(25.725,10.215),(25.875,10.215),(25.875,10.065),(25.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.385),(25.725,10.535),(25.875,10.535),(25.875,10.385),(25.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.705),(25.725,10.855),(25.875,10.855),(25.875,10.705),(25.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.025),(25.725,11.175),(25.875,11.175),(25.875,11.025),(25.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.345),(25.725,11.495),(25.875,11.495),(25.875,11.345),(25.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.665),(25.725,11.815),(25.875,11.815),(25.875,11.665),(25.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.985),(25.725,12.135),(25.875,12.135),(25.875,11.985),(25.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.305),(25.725,12.455),(25.875,12.455),(25.875,12.305),(25.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.625),(25.725,12.775),(25.875,12.775),(25.875,12.625),(25.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.945),(25.725,13.095),(25.875,13.095),(25.875,12.945),(25.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.265),(25.725,13.415),(25.875,13.415),(25.875,13.265),(25.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.585),(25.725,13.735),(25.875,13.735),(25.875,13.585),(25.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.905),(25.725,14.055),(25.875,14.055),(25.875,13.905),(25.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.225),(25.725,14.375),(25.875,14.375),(25.875,14.225),(25.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.545),(25.725,14.695),(25.875,14.695),(25.875,14.545),(25.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.865),(25.725,15.015),(25.875,15.015),(25.875,14.865),(25.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.185),(25.725,15.335),(25.875,15.335),(25.875,15.185),(25.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.505),(25.725,15.655),(25.875,15.655),(25.875,15.505),(25.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.825),(25.725,15.975),(25.875,15.975),(25.875,15.825),(25.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.145),(25.725,16.295),(25.875,16.295),(25.875,16.145),(25.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.465),(25.725,16.615),(25.875,16.615),(25.875,16.465),(25.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.785),(25.725,16.935),(25.875,16.935),(25.875,16.785),(25.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.105),(25.725,17.255),(25.875,17.255),(25.875,17.105),(25.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.425),(25.725,17.575),(25.875,17.575),(25.875,17.425),(25.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.745),(25.725,17.895),(25.875,17.895),(25.875,17.745),(25.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.065),(25.725,18.215),(25.875,18.215),(25.875,18.065),(25.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.385),(25.725,18.535),(25.875,18.535),(25.875,18.385),(25.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.705),(25.725,18.855),(25.875,18.855),(25.875,18.705),(25.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.025),(25.725,19.175),(25.875,19.175),(25.875,19.025),(25.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.345),(25.725,19.495),(25.875,19.495),(25.875,19.345),(25.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.665),(25.725,19.815),(25.875,19.815),(25.875,19.665),(25.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.985),(25.725,20.135),(25.875,20.135),(25.875,19.985),(25.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.305),(25.725,20.455),(25.875,20.455),(25.875,20.305),(25.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.625),(25.725,20.775),(25.875,20.775),(25.875,20.625),(25.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.945),(25.725,21.095),(25.875,21.095),(25.875,20.945),(25.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.265),(25.725,21.415),(25.875,21.415),(25.875,21.265),(25.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.585),(25.725,21.735),(25.875,21.735),(25.875,21.585),(25.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.905),(25.725,22.055),(25.875,22.055),(25.875,21.905),(25.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,22.225),(25.725,22.375),(25.875,22.375),(25.875,22.225),(25.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,22.545),(25.725,22.695),(25.875,22.695),(25.875,22.545),(25.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,22.865),(25.725,23.015),(25.875,23.015),(25.875,22.865),(25.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,23.185),(25.725,23.335),(25.875,23.335),(25.875,23.185),(25.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,23.505),(25.725,23.655),(25.875,23.655),(25.875,23.505),(25.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,23.825),(25.725,23.975),(25.875,23.975),(25.875,23.825),(25.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,24.145),(25.725,24.295),(25.875,24.295),(25.875,24.145),(25.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,24.465),(25.725,24.615),(25.875,24.615),(25.875,24.465),(25.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,24.785),(25.725,24.935),(25.875,24.935),(25.875,24.785),(25.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,25.105),(25.725,25.255),(25.875,25.255),(25.875,25.105),(25.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,25.425),(25.725,25.575),(25.875,25.575),(25.875,25.425),(25.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,25.745),(25.725,25.895),(25.875,25.895),(25.875,25.745),(25.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,26.065),(25.725,26.215),(25.875,26.215),(25.875,26.065),(25.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,26.385),(25.725,26.535),(25.875,26.535),(25.875,26.385),(25.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,26.705),(25.725,26.855),(25.875,26.855),(25.875,26.705),(25.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.025),(25.725,27.175),(25.875,27.175),(25.875,27.025),(25.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.345),(25.725,27.495),(25.875,27.495),(25.875,27.345),(25.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.665),(25.725,27.815),(25.875,27.815),(25.875,27.665),(25.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,27.985),(25.725,28.135),(25.875,28.135),(25.875,27.985),(25.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,28.305),(25.725,28.455),(25.875,28.455),(25.875,28.305),(25.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,28.625),(25.725,28.775),(25.875,28.775),(25.875,28.625),(25.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,28.945),(25.725,29.095),(25.875,29.095),(25.875,28.945),(25.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,29.265),(25.725,29.415),(25.875,29.415),(25.875,29.265),(25.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,29.585),(25.725,29.735),(25.875,29.735),(25.875,29.585),(25.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,29.905),(25.725,30.055),(25.875,30.055),(25.875,29.905),(25.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,30.225),(25.725,30.375),(25.875,30.375),(25.875,30.225),(25.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,30.545),(25.725,30.695),(25.875,30.695),(25.875,30.545),(25.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,30.865),(25.725,31.015),(25.875,31.015),(25.875,30.865),(25.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,31.185),(25.725,31.335),(25.875,31.335),(25.875,31.185),(25.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,31.505),(25.725,31.655),(25.875,31.655),(25.875,31.505),(25.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,31.825),(25.725,31.975),(25.875,31.975),(25.875,31.825),(25.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,32.145),(25.725,32.295),(25.875,32.295),(25.875,32.145),(25.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,32.465),(25.725,32.615),(25.875,32.615),(25.875,32.465),(25.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,32.785),(25.725,32.935),(25.875,32.935),(25.875,32.785),(25.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,33.105),(25.725,33.255),(25.875,33.255),(25.875,33.105),(25.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,33.425),(25.725,33.575),(25.875,33.575),(25.875,33.425),(25.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,33.745),(25.725,33.895),(25.875,33.895),(25.875,33.745),(25.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,34.065),(25.725,34.215),(25.875,34.215),(25.875,34.065),(25.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,34.385),(25.725,34.535),(25.875,34.535),(25.875,34.385),(25.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,34.705),(25.725,34.855),(25.875,34.855),(25.875,34.705),(25.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.025),(25.725,35.175),(25.875,35.175),(25.875,35.025),(25.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.345),(25.725,35.495),(25.875,35.495),(25.875,35.345),(25.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.665),(25.725,35.815),(25.875,35.815),(25.875,35.665),(25.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,35.985),(25.725,36.135),(25.875,36.135),(25.875,35.985),(25.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,36.305),(25.725,36.455),(25.875,36.455),(25.875,36.305),(25.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,36.625),(25.725,36.775),(25.875,36.775),(25.875,36.625),(25.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,36.945),(25.725,37.095),(25.875,37.095),(25.875,36.945),(25.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,37.265),(25.725,37.415),(25.875,37.415),(25.875,37.265),(25.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,37.585),(25.725,37.735),(25.875,37.735),(25.875,37.585),(25.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,37.905),(25.725,38.055),(25.875,38.055),(25.875,37.905),(25.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,38.225),(25.725,38.375),(25.875,38.375),(25.875,38.225),(25.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,38.545),(25.725,38.695),(25.875,38.695),(25.875,38.545),(25.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,38.865),(25.725,39.015),(25.875,39.015),(25.875,38.865),(25.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,39.185),(25.725,39.335),(25.875,39.335),(25.875,39.185),(25.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,39.505),(25.725,39.655),(25.875,39.655),(25.875,39.505),(25.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,39.825),(25.725,39.975),(25.875,39.975),(25.875,39.825),(25.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,40.145),(25.725,40.295),(25.875,40.295),(25.875,40.145),(25.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,40.465),(25.725,40.615),(25.875,40.615),(25.875,40.465),(25.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,40.785),(25.725,40.935),(25.875,40.935),(25.875,40.785),(25.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,41.105),(25.725,41.255),(25.875,41.255),(25.875,41.105),(25.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,41.425),(25.725,41.575),(25.875,41.575),(25.875,41.425),(25.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,41.745),(25.725,41.895),(25.875,41.895),(25.875,41.745),(25.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,42.065),(25.725,42.215),(25.875,42.215),(25.875,42.065),(25.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,42.385),(25.725,42.535),(25.875,42.535),(25.875,42.385),(25.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,42.705),(25.725,42.855),(25.875,42.855),(25.875,42.705),(25.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,43.025),(25.725,43.175),(25.875,43.175),(25.875,43.025),(25.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,43.345),(25.725,43.495),(25.875,43.495),(25.875,43.345),(25.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.145),(44.925,0.295),(45.075,0.295),(45.075,0.145),(44.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.465),(44.925,0.615),(45.075,0.615),(45.075,0.465),(44.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.785),(44.925,0.935),(45.075,0.935),(45.075,0.785),(44.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.105),(44.925,1.255),(45.075,1.255),(45.075,1.105),(44.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.425),(44.925,1.575),(45.075,1.575),(45.075,1.425),(44.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.745),(44.925,1.895),(45.075,1.895),(45.075,1.745),(44.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.065),(44.925,2.215),(45.075,2.215),(45.075,2.065),(44.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.385),(44.925,2.535),(45.075,2.535),(45.075,2.385),(44.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.705),(44.925,2.855),(45.075,2.855),(45.075,2.705),(44.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.025),(44.925,3.175),(45.075,3.175),(45.075,3.025),(44.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.345),(44.925,3.495),(45.075,3.495),(45.075,3.345),(44.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.665),(44.925,3.815),(45.075,3.815),(45.075,3.665),(44.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.985),(44.925,4.135),(45.075,4.135),(45.075,3.985),(44.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.305),(44.925,4.455),(45.075,4.455),(45.075,4.305),(44.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.625),(44.925,4.775),(45.075,4.775),(45.075,4.625),(44.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.945),(44.925,5.095),(45.075,5.095),(45.075,4.945),(44.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.265),(44.925,5.415),(45.075,5.415),(45.075,5.265),(44.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.585),(44.925,5.735),(45.075,5.735),(45.075,5.585),(44.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.905),(44.925,6.055),(45.075,6.055),(45.075,5.905),(44.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.225),(44.925,6.375),(45.075,6.375),(45.075,6.225),(44.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.545),(44.925,6.695),(45.075,6.695),(45.075,6.545),(44.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.865),(44.925,7.015),(45.075,7.015),(45.075,6.865),(44.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.185),(44.925,7.335),(45.075,7.335),(45.075,7.185),(44.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.505),(44.925,7.655),(45.075,7.655),(45.075,7.505),(44.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.825),(44.925,7.975),(45.075,7.975),(45.075,7.825),(44.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.145),(44.925,8.295),(45.075,8.295),(45.075,8.145),(44.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.465),(44.925,8.615),(45.075,8.615),(45.075,8.465),(44.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.785),(44.925,8.935),(45.075,8.935),(45.075,8.785),(44.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.105),(44.925,9.255),(45.075,9.255),(45.075,9.105),(44.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.425),(44.925,9.575),(45.075,9.575),(45.075,9.425),(44.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.745),(44.925,9.895),(45.075,9.895),(45.075,9.745),(44.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.065),(44.925,10.215),(45.075,10.215),(45.075,10.065),(44.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.385),(44.925,10.535),(45.075,10.535),(45.075,10.385),(44.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.705),(44.925,10.855),(45.075,10.855),(45.075,10.705),(44.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.025),(44.925,11.175),(45.075,11.175),(45.075,11.025),(44.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.345),(44.925,11.495),(45.075,11.495),(45.075,11.345),(44.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.665),(44.925,11.815),(45.075,11.815),(45.075,11.665),(44.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.985),(44.925,12.135),(45.075,12.135),(45.075,11.985),(44.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.305),(44.925,12.455),(45.075,12.455),(45.075,12.305),(44.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.625),(44.925,12.775),(45.075,12.775),(45.075,12.625),(44.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.945),(44.925,13.095),(45.075,13.095),(45.075,12.945),(44.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.265),(44.925,13.415),(45.075,13.415),(45.075,13.265),(44.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.585),(44.925,13.735),(45.075,13.735),(45.075,13.585),(44.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.905),(44.925,14.055),(45.075,14.055),(45.075,13.905),(44.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.225),(44.925,14.375),(45.075,14.375),(45.075,14.225),(44.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.545),(44.925,14.695),(45.075,14.695),(45.075,14.545),(44.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.865),(44.925,15.015),(45.075,15.015),(45.075,14.865),(44.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.185),(44.925,15.335),(45.075,15.335),(45.075,15.185),(44.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.505),(44.925,15.655),(45.075,15.655),(45.075,15.505),(44.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.825),(44.925,15.975),(45.075,15.975),(45.075,15.825),(44.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.145),(44.925,16.295),(45.075,16.295),(45.075,16.145),(44.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.465),(44.925,16.615),(45.075,16.615),(45.075,16.465),(44.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.785),(44.925,16.935),(45.075,16.935),(45.075,16.785),(44.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.105),(44.925,17.255),(45.075,17.255),(45.075,17.105),(44.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.425),(44.925,17.575),(45.075,17.575),(45.075,17.425),(44.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.745),(44.925,17.895),(45.075,17.895),(45.075,17.745),(44.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.065),(44.925,18.215),(45.075,18.215),(45.075,18.065),(44.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.385),(44.925,18.535),(45.075,18.535),(45.075,18.385),(44.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.705),(44.925,18.855),(45.075,18.855),(45.075,18.705),(44.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.025),(44.925,19.175),(45.075,19.175),(45.075,19.025),(44.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.345),(44.925,19.495),(45.075,19.495),(45.075,19.345),(44.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.665),(44.925,19.815),(45.075,19.815),(45.075,19.665),(44.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.985),(44.925,20.135),(45.075,20.135),(45.075,19.985),(44.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.305),(44.925,20.455),(45.075,20.455),(45.075,20.305),(44.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.625),(44.925,20.775),(45.075,20.775),(45.075,20.625),(44.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.945),(44.925,21.095),(45.075,21.095),(45.075,20.945),(44.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.265),(44.925,21.415),(45.075,21.415),(45.075,21.265),(44.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.585),(44.925,21.735),(45.075,21.735),(45.075,21.585),(44.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.905),(44.925,22.055),(45.075,22.055),(45.075,21.905),(44.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.225),(44.925,22.375),(45.075,22.375),(45.075,22.225),(44.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.545),(44.925,22.695),(45.075,22.695),(45.075,22.545),(44.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.865),(44.925,23.015),(45.075,23.015),(45.075,22.865),(44.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.185),(44.925,23.335),(45.075,23.335),(45.075,23.185),(44.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.505),(44.925,23.655),(45.075,23.655),(45.075,23.505),(44.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.825),(44.925,23.975),(45.075,23.975),(45.075,23.825),(44.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.145),(44.925,24.295),(45.075,24.295),(45.075,24.145),(44.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.465),(44.925,24.615),(45.075,24.615),(45.075,24.465),(44.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.785),(44.925,24.935),(45.075,24.935),(45.075,24.785),(44.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.105),(44.925,25.255),(45.075,25.255),(45.075,25.105),(44.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.425),(44.925,25.575),(45.075,25.575),(45.075,25.425),(44.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.745),(44.925,25.895),(45.075,25.895),(45.075,25.745),(44.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.065),(44.925,26.215),(45.075,26.215),(45.075,26.065),(44.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.385),(44.925,26.535),(45.075,26.535),(45.075,26.385),(44.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.705),(44.925,26.855),(45.075,26.855),(45.075,26.705),(44.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.025),(44.925,27.175),(45.075,27.175),(45.075,27.025),(44.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.345),(44.925,27.495),(45.075,27.495),(45.075,27.345),(44.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.665),(44.925,27.815),(45.075,27.815),(45.075,27.665),(44.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.985),(44.925,28.135),(45.075,28.135),(45.075,27.985),(44.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.305),(44.925,28.455),(45.075,28.455),(45.075,28.305),(44.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.625),(44.925,28.775),(45.075,28.775),(45.075,28.625),(44.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.945),(44.925,29.095),(45.075,29.095),(45.075,28.945),(44.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.265),(44.925,29.415),(45.075,29.415),(45.075,29.265),(44.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.585),(44.925,29.735),(45.075,29.735),(45.075,29.585),(44.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.905),(44.925,30.055),(45.075,30.055),(45.075,29.905),(44.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.225),(44.925,30.375),(45.075,30.375),(45.075,30.225),(44.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.545),(44.925,30.695),(45.075,30.695),(45.075,30.545),(44.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.865),(44.925,31.015),(45.075,31.015),(45.075,30.865),(44.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.185),(44.925,31.335),(45.075,31.335),(45.075,31.185),(44.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.505),(44.925,31.655),(45.075,31.655),(45.075,31.505),(44.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.825),(44.925,31.975),(45.075,31.975),(45.075,31.825),(44.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.145),(44.925,32.295),(45.075,32.295),(45.075,32.145),(44.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.465),(44.925,32.615),(45.075,32.615),(45.075,32.465),(44.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.785),(44.925,32.935),(45.075,32.935),(45.075,32.785),(44.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.105),(44.925,33.255),(45.075,33.255),(45.075,33.105),(44.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.425),(44.925,33.575),(45.075,33.575),(45.075,33.425),(44.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.745),(44.925,33.895),(45.075,33.895),(45.075,33.745),(44.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.065),(44.925,34.215),(45.075,34.215),(45.075,34.065),(44.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.385),(44.925,34.535),(45.075,34.535),(45.075,34.385),(44.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.705),(44.925,34.855),(45.075,34.855),(45.075,34.705),(44.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.025),(44.925,35.175),(45.075,35.175),(45.075,35.025),(44.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.345),(44.925,35.495),(45.075,35.495),(45.075,35.345),(44.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.665),(44.925,35.815),(45.075,35.815),(45.075,35.665),(44.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.985),(44.925,36.135),(45.075,36.135),(45.075,35.985),(44.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.305),(44.925,36.455),(45.075,36.455),(45.075,36.305),(44.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.625),(44.925,36.775),(45.075,36.775),(45.075,36.625),(44.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.945),(44.925,37.095),(45.075,37.095),(45.075,36.945),(44.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.265),(44.925,37.415),(45.075,37.415),(45.075,37.265),(44.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.585),(44.925,37.735),(45.075,37.735),(45.075,37.585),(44.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.905),(44.925,38.055),(45.075,38.055),(45.075,37.905),(44.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.225),(44.925,38.375),(45.075,38.375),(45.075,38.225),(44.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.545),(44.925,38.695),(45.075,38.695),(45.075,38.545),(44.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.865),(44.925,39.015),(45.075,39.015),(45.075,38.865),(44.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.185),(44.925,39.335),(45.075,39.335),(45.075,39.185),(44.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.505),(44.925,39.655),(45.075,39.655),(45.075,39.505),(44.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.825),(44.925,39.975),(45.075,39.975),(45.075,39.825),(44.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.145),(44.925,40.295),(45.075,40.295),(45.075,40.145),(44.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.465),(44.925,40.615),(45.075,40.615),(45.075,40.465),(44.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.785),(44.925,40.935),(45.075,40.935),(45.075,40.785),(44.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.105),(44.925,41.255),(45.075,41.255),(45.075,41.105),(44.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.425),(44.925,41.575),(45.075,41.575),(45.075,41.425),(44.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.745),(44.925,41.895),(45.075,41.895),(45.075,41.745),(44.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.065),(44.925,42.215),(45.075,42.215),(45.075,42.065),(44.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.385),(44.925,42.535),(45.075,42.535),(45.075,42.385),(44.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.705),(44.925,42.855),(45.075,42.855),(45.075,42.705),(44.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,43.025),(44.925,43.175),(45.075,43.175),(45.075,43.025),(44.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,43.345),(44.925,43.495),(45.075,43.495),(45.075,43.345),(44.925,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.145),(68.925,0.295),(69.075,0.295),(69.075,0.145),(68.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.465),(68.925,0.615),(69.075,0.615),(69.075,0.465),(68.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.785),(68.925,0.935),(69.075,0.935),(69.075,0.785),(68.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.105),(68.925,1.255),(69.075,1.255),(69.075,1.105),(68.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.425),(68.925,1.575),(69.075,1.575),(69.075,1.425),(68.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.745),(68.925,1.895),(69.075,1.895),(69.075,1.745),(68.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.065),(68.925,2.215),(69.075,2.215),(69.075,2.065),(68.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.385),(68.925,2.535),(69.075,2.535),(69.075,2.385),(68.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.705),(68.925,2.855),(69.075,2.855),(69.075,2.705),(68.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.025),(68.925,3.175),(69.075,3.175),(69.075,3.025),(68.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.345),(68.925,3.495),(69.075,3.495),(69.075,3.345),(68.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.665),(68.925,3.815),(69.075,3.815),(69.075,3.665),(68.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.985),(68.925,4.135),(69.075,4.135),(69.075,3.985),(68.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.305),(68.925,4.455),(69.075,4.455),(69.075,4.305),(68.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.625),(68.925,4.775),(69.075,4.775),(69.075,4.625),(68.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.945),(68.925,5.095),(69.075,5.095),(69.075,4.945),(68.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.265),(68.925,5.415),(69.075,5.415),(69.075,5.265),(68.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.585),(68.925,5.735),(69.075,5.735),(69.075,5.585),(68.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.905),(68.925,6.055),(69.075,6.055),(69.075,5.905),(68.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.225),(68.925,6.375),(69.075,6.375),(69.075,6.225),(68.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.545),(68.925,6.695),(69.075,6.695),(69.075,6.545),(68.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.865),(68.925,7.015),(69.075,7.015),(69.075,6.865),(68.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.185),(68.925,7.335),(69.075,7.335),(69.075,7.185),(68.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.505),(68.925,7.655),(69.075,7.655),(69.075,7.505),(68.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.825),(68.925,7.975),(69.075,7.975),(69.075,7.825),(68.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.145),(68.925,8.295),(69.075,8.295),(69.075,8.145),(68.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.465),(68.925,8.615),(69.075,8.615),(69.075,8.465),(68.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.785),(68.925,8.935),(69.075,8.935),(69.075,8.785),(68.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.105),(68.925,9.255),(69.075,9.255),(69.075,9.105),(68.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.425),(68.925,9.575),(69.075,9.575),(69.075,9.425),(68.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.745),(68.925,9.895),(69.075,9.895),(69.075,9.745),(68.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.065),(68.925,10.215),(69.075,10.215),(69.075,10.065),(68.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.385),(68.925,10.535),(69.075,10.535),(69.075,10.385),(68.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.705),(68.925,10.855),(69.075,10.855),(69.075,10.705),(68.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.025),(68.925,11.175),(69.075,11.175),(69.075,11.025),(68.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.345),(68.925,11.495),(69.075,11.495),(69.075,11.345),(68.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.665),(68.925,11.815),(69.075,11.815),(69.075,11.665),(68.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.985),(68.925,12.135),(69.075,12.135),(69.075,11.985),(68.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.305),(68.925,12.455),(69.075,12.455),(69.075,12.305),(68.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.625),(68.925,12.775),(69.075,12.775),(69.075,12.625),(68.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.945),(68.925,13.095),(69.075,13.095),(69.075,12.945),(68.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.265),(68.925,13.415),(69.075,13.415),(69.075,13.265),(68.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.585),(68.925,13.735),(69.075,13.735),(69.075,13.585),(68.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.905),(68.925,14.055),(69.075,14.055),(69.075,13.905),(68.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.225),(68.925,14.375),(69.075,14.375),(69.075,14.225),(68.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.545),(68.925,14.695),(69.075,14.695),(69.075,14.545),(68.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.865),(68.925,15.015),(69.075,15.015),(69.075,14.865),(68.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.185),(68.925,15.335),(69.075,15.335),(69.075,15.185),(68.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.505),(68.925,15.655),(69.075,15.655),(69.075,15.505),(68.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.825),(68.925,15.975),(69.075,15.975),(69.075,15.825),(68.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.145),(68.925,16.295),(69.075,16.295),(69.075,16.145),(68.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.465),(68.925,16.615),(69.075,16.615),(69.075,16.465),(68.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.785),(68.925,16.935),(69.075,16.935),(69.075,16.785),(68.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.105),(68.925,17.255),(69.075,17.255),(69.075,17.105),(68.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.425),(68.925,17.575),(69.075,17.575),(69.075,17.425),(68.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.745),(68.925,17.895),(69.075,17.895),(69.075,17.745),(68.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.065),(68.925,18.215),(69.075,18.215),(69.075,18.065),(68.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.385),(68.925,18.535),(69.075,18.535),(69.075,18.385),(68.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.705),(68.925,18.855),(69.075,18.855),(69.075,18.705),(68.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.025),(68.925,19.175),(69.075,19.175),(69.075,19.025),(68.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.345),(68.925,19.495),(69.075,19.495),(69.075,19.345),(68.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.665),(68.925,19.815),(69.075,19.815),(69.075,19.665),(68.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.985),(68.925,20.135),(69.075,20.135),(69.075,19.985),(68.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.305),(68.925,20.455),(69.075,20.455),(69.075,20.305),(68.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.625),(68.925,20.775),(69.075,20.775),(69.075,20.625),(68.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.945),(68.925,21.095),(69.075,21.095),(69.075,20.945),(68.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.265),(68.925,21.415),(69.075,21.415),(69.075,21.265),(68.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.585),(68.925,21.735),(69.075,21.735),(69.075,21.585),(68.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.905),(68.925,22.055),(69.075,22.055),(69.075,21.905),(68.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,22.225),(68.925,22.375),(69.075,22.375),(69.075,22.225),(68.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,22.545),(68.925,22.695),(69.075,22.695),(69.075,22.545),(68.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,22.865),(68.925,23.015),(69.075,23.015),(69.075,22.865),(68.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,23.185),(68.925,23.335),(69.075,23.335),(69.075,23.185),(68.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,23.505),(68.925,23.655),(69.075,23.655),(69.075,23.505),(68.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,23.825),(68.925,23.975),(69.075,23.975),(69.075,23.825),(68.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,24.145),(68.925,24.295),(69.075,24.295),(69.075,24.145),(68.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,24.465),(68.925,24.615),(69.075,24.615),(69.075,24.465),(68.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,24.785),(68.925,24.935),(69.075,24.935),(69.075,24.785),(68.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,25.105),(68.925,25.255),(69.075,25.255),(69.075,25.105),(68.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,25.425),(68.925,25.575),(69.075,25.575),(69.075,25.425),(68.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,25.745),(68.925,25.895),(69.075,25.895),(69.075,25.745),(68.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,26.065),(68.925,26.215),(69.075,26.215),(69.075,26.065),(68.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,26.385),(68.925,26.535),(69.075,26.535),(69.075,26.385),(68.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,26.705),(68.925,26.855),(69.075,26.855),(69.075,26.705),(68.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.025),(68.925,27.175),(69.075,27.175),(69.075,27.025),(68.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.345),(68.925,27.495),(69.075,27.495),(69.075,27.345),(68.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.665),(68.925,27.815),(69.075,27.815),(69.075,27.665),(68.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,27.985),(68.925,28.135),(69.075,28.135),(69.075,27.985),(68.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,28.305),(68.925,28.455),(69.075,28.455),(69.075,28.305),(68.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,28.625),(68.925,28.775),(69.075,28.775),(69.075,28.625),(68.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,28.945),(68.925,29.095),(69.075,29.095),(69.075,28.945),(68.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,29.265),(68.925,29.415),(69.075,29.415),(69.075,29.265),(68.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,29.585),(68.925,29.735),(69.075,29.735),(69.075,29.585),(68.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,29.905),(68.925,30.055),(69.075,30.055),(69.075,29.905),(68.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,30.225),(68.925,30.375),(69.075,30.375),(69.075,30.225),(68.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,30.545),(68.925,30.695),(69.075,30.695),(69.075,30.545),(68.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,30.865),(68.925,31.015),(69.075,31.015),(69.075,30.865),(68.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,31.185),(68.925,31.335),(69.075,31.335),(69.075,31.185),(68.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,31.505),(68.925,31.655),(69.075,31.655),(69.075,31.505),(68.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,31.825),(68.925,31.975),(69.075,31.975),(69.075,31.825),(68.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,32.145),(68.925,32.295),(69.075,32.295),(69.075,32.145),(68.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,32.465),(68.925,32.615),(69.075,32.615),(69.075,32.465),(68.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,32.785),(68.925,32.935),(69.075,32.935),(69.075,32.785),(68.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,33.105),(68.925,33.255),(69.075,33.255),(69.075,33.105),(68.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,33.425),(68.925,33.575),(69.075,33.575),(69.075,33.425),(68.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,33.745),(68.925,33.895),(69.075,33.895),(69.075,33.745),(68.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,34.065),(68.925,34.215),(69.075,34.215),(69.075,34.065),(68.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,34.385),(68.925,34.535),(69.075,34.535),(69.075,34.385),(68.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,34.705),(68.925,34.855),(69.075,34.855),(69.075,34.705),(68.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.025),(68.925,35.175),(69.075,35.175),(69.075,35.025),(68.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.345),(68.925,35.495),(69.075,35.495),(69.075,35.345),(68.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.665),(68.925,35.815),(69.075,35.815),(69.075,35.665),(68.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,35.985),(68.925,36.135),(69.075,36.135),(69.075,35.985),(68.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,36.305),(68.925,36.455),(69.075,36.455),(69.075,36.305),(68.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,36.625),(68.925,36.775),(69.075,36.775),(69.075,36.625),(68.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,36.945),(68.925,37.095),(69.075,37.095),(69.075,36.945),(68.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,37.265),(68.925,37.415),(69.075,37.415),(69.075,37.265),(68.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,37.585),(68.925,37.735),(69.075,37.735),(69.075,37.585),(68.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,37.905),(68.925,38.055),(69.075,38.055),(69.075,37.905),(68.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,38.225),(68.925,38.375),(69.075,38.375),(69.075,38.225),(68.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,38.545),(68.925,38.695),(69.075,38.695),(69.075,38.545),(68.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,38.865),(68.925,39.015),(69.075,39.015),(69.075,38.865),(68.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,39.185),(68.925,39.335),(69.075,39.335),(69.075,39.185),(68.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,39.505),(68.925,39.655),(69.075,39.655),(69.075,39.505),(68.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,39.825),(68.925,39.975),(69.075,39.975),(69.075,39.825),(68.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,40.145),(68.925,40.295),(69.075,40.295),(69.075,40.145),(68.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,40.465),(68.925,40.615),(69.075,40.615),(69.075,40.465),(68.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,40.785),(68.925,40.935),(69.075,40.935),(69.075,40.785),(68.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,41.105),(68.925,41.255),(69.075,41.255),(69.075,41.105),(68.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,41.425),(68.925,41.575),(69.075,41.575),(69.075,41.425),(68.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,41.745),(68.925,41.895),(69.075,41.895),(69.075,41.745),(68.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,42.065),(68.925,42.215),(69.075,42.215),(69.075,42.065),(68.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,42.385),(68.925,42.535),(69.075,42.535),(69.075,42.385),(68.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,42.705),(68.925,42.855),(69.075,42.855),(69.075,42.705),(68.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,43.025),(68.925,43.175),(69.075,43.175),(69.075,43.025),(68.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,43.345),(68.925,43.495),(69.075,43.495),(69.075,43.345),(68.925,43.345)),
        )
        createRL(
            tech, net, 'm2',
            ((64.07,0.06),(64.07,43.58),(64.33,43.58),(64.33,0.06),(64.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((16.07,0.06),(16.07,43.58),(16.33,43.58),(16.33,0.06),(16.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((20.87,0.06),(20.87,43.58),(21.13,43.58),(21.13,0.06),(20.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.06),(44.87,43.58),(45.13,43.58),(45.13,0.06),(44.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((68.87,0.06),(68.87,43.58),(69.13,43.58),(69.13,0.06),(68.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((25.67,0.06),(25.67,43.58),(25.93,43.58),(25.93,0.06),(25.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.06),(49.67,43.58),(49.93,43.58),(49.93,0.06),(49.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((78.47,0.06),(78.47,43.58),(78.73,43.58),(78.73,0.06),(78.47,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((30.47,0.06),(30.47,43.58),(30.73,43.58),(30.73,0.06),(30.47,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.06),(54.47,43.58),(54.73,43.58),(54.73,0.06),(54.47,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.06),(40.07,43.58),(40.33,43.58),(40.33,0.06),(40.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((11.27,0.06),(11.27,43.58),(11.53,43.58),(11.53,0.06),(11.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((83.015,0.06),(83.015,43.58),(83.275,43.58),(83.275,0.06),(83.015,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.06),(35.27,43.58),(35.53,43.58),(35.53,0.06),(35.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((59.27,0.06),(59.27,43.58),(59.53,43.58),(59.53,0.06),(59.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((73.67,0.06),(73.67,43.58),(73.93,43.58),(73.93,0.06),(73.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((6.725,0.06),(6.725,43.58),(6.985,43.58),(6.985,0.06),(6.725,0.06)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.36),(85.68,21.65),(86.01,21.65),(86.01,21.36),(85.68,21.36)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.39),(85.68,21.655),(86.01,21.655),(86.01,21.39),(85.68,21.39)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((20.65,2.595),(20.65,41.045),(21.35,41.045),(21.35,2.595),(20.65,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((39.85,2.595),(39.85,41.045),(40.55,41.045),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((78.25,2.595),(78.25,41.045),(78.95,41.045),(78.95,2.595),(78.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((25.45,2.595),(25.45,41.045),(26.15,41.045),(26.15,2.595),(25.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((73.45,2.595),(73.45,41.045),(74.15,41.045),(74.15,2.595),(73.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((30.25,2.595),(30.25,41.045),(30.95,41.045),(30.95,2.595),(30.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.65,2.595),(68.65,41.045),(69.35,41.045),(69.35,2.595),(68.65,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((83.05,2.595),(83.05,41.045),(83.875,41.045),(83.875,2.595),(83.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.05,2.595),(35.05,41.045),(35.75,41.045),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((6.125,2.595),(6.125,41.045),(6.95,41.045),(6.95,2.595),(6.125,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.45,2.595),(49.45,41.045),(50.15,41.045),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((59.05,2.595),(59.05,41.045),(59.75,41.045),(59.75,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.25,2.595),(54.25,41.045),(54.95,41.045),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((15.85,2.595),(15.85,41.045),(16.55,41.045),(16.55,2.595),(15.85,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((63.85,2.595),(63.85,41.045),(64.55,41.045),(64.55,2.595),(63.85,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((11.05,2.595),(11.05,41.045),(11.75,41.045),(11.75,2.595),(11.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.65,2.595),(44.65,41.045),(45.35,41.045),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((8.58,2.595),(8.58,41.045),(9.42,41.045),(9.42,2.595),(8.58,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.005,2.595),(49.005,41.045),(49.45,41.045),(49.45,2.595),(49.005,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.365,2.65),(36.365,40.99),(37.105,40.99),(37.105,2.65),(36.365,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((7.26,2.595),(7.26,41.045),(8.61,41.045),(8.61,2.595),(7.26,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((79.26,2.595),(79.26,41.045),(80.61,41.045),(80.61,2.595),(79.26,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((20.205,2.595),(20.205,41.045),(20.65,41.045),(20.65,2.595),(20.205,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((23.79,2.595),(23.79,41.045),(25.14,41.045),(25.14,2.595),(23.79,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.695,2.65),(33.695,40.99),(34.435,40.99),(34.435,2.65),(33.695,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((24.095,2.65),(24.095,40.99),(24.835,40.99),(24.835,2.65),(24.095,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((12.365,2.65),(12.365,40.99),(13.105,40.99),(13.105,2.65),(12.365,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((51.78,2.595),(51.78,41.045),(52.62,41.045),(52.62,2.595),(51.78,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((17.165,2.65),(17.165,40.99),(17.905,40.99),(17.905,2.65),(17.165,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((21.66,2.595),(21.66,41.045),(23.01,41.045),(23.01,2.595),(21.66,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((6.95,2.595),(6.95,41.045),(7.395,41.045),(7.395,2.595),(6.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.86,2.595),(40.86,41.045),(42.21,41.045),(42.21,2.595),(40.86,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.605,2.595),(58.605,41.045),(59.05,41.045),(59.05,2.595),(58.605,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.405,2.595),(39.405,41.045),(39.85,41.045),(39.85,2.595),(39.405,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.005,2.595),(25.005,41.045),(25.45,41.045),(25.45,2.595),(25.005,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((19.295,2.65),(19.295,40.99),(20.035,40.99),(20.035,2.65),(19.295,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((62.19,2.595),(62.19,41.045),(63.54,41.045),(63.54,2.595),(62.19,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((78.95,2.595),(78.95,41.045),(79.395,41.045),(79.395,2.595),(78.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((60.365,2.65),(60.365,40.99),(61.105,40.99),(61.105,2.65),(60.365,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.765,2.65),(26.765,40.99),(27.505,40.99),(27.505,2.65),(26.765,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.695,2.65),(57.695,40.99),(58.435,40.99),(58.435,2.65),(57.695,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.59,2.595),(52.59,41.045),(53.94,41.045),(53.94,2.595),(52.59,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((73.005,2.595),(73.005,41.045),(73.45,41.045),(73.45,2.595),(73.005,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((80.58,2.595),(80.58,41.045),(81.42,41.045),(81.42,2.595),(80.58,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((74.765,2.65),(74.765,40.99),(75.505,40.99),(75.505,2.65),(74.765,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((75.78,2.595),(75.78,41.045),(76.62,41.045),(76.62,2.595),(75.78,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.66,2.595),(45.66,41.045),(47.01,41.045),(47.01,2.595),(45.66,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.295,2.65),(43.295,40.99),(44.035,40.99),(44.035,2.65),(43.295,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((34.605,2.595),(34.605,41.045),(35.05,41.045),(35.05,2.595),(34.605,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((18.18,2.595),(18.18,41.045),(19.02,41.045),(19.02,2.595),(18.18,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((81.39,2.595),(81.39,41.045),(82.74,41.045),(82.74,2.595),(81.39,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((64.55,2.595),(64.55,41.045),(64.995,41.045),(64.995,2.595),(64.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((10.605,2.595),(10.605,41.045),(11.05,41.045),(11.05,2.595),(10.605,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((18.99,2.595),(18.99,41.045),(20.34,41.045),(20.34,2.595),(18.99,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.15,2.595),(26.15,41.045),(26.595,41.045),(26.595,2.595),(26.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.06,2.595),(36.06,41.045),(37.41,41.045),(37.41,2.595),(36.06,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((68.205,2.595),(68.205,41.045),(68.65,41.045),(68.65,2.595),(68.205,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((48.095,2.65),(48.095,40.99),(48.835,40.99),(48.835,2.65),(48.095,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((70.98,2.595),(70.98,41.045),(71.82,41.045),(71.82,2.595),(70.98,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((71.79,2.595),(71.79,41.045),(73.14,41.045),(73.14,2.595),(71.79,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.565,2.65),(31.565,40.99),(32.305,40.99),(32.305,2.65),(31.565,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((72.095,2.65),(72.095,40.99),(72.835,40.99),(72.835,2.65),(72.095,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.405,2.595),(63.405,41.045),(63.85,41.045),(63.85,2.595),(63.405,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((74.15,2.595),(74.15,41.045),(74.595,41.045),(74.595,2.595),(74.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.39,2.595),(33.39,41.045),(34.74,41.045),(34.74,2.595),(33.39,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((16.55,2.595),(16.55,41.045),(16.995,41.045),(16.995,2.595),(16.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.495,2.65),(38.495,40.99),(39.235,40.99),(39.235,2.65),(38.495,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((27.78,2.595),(27.78,41.045),(28.62,41.045),(28.62,2.595),(27.78,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((12.06,2.595),(12.06,41.045),(13.41,41.045),(13.41,2.595),(12.06,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((67.295,2.65),(67.295,40.99),(68.035,40.99),(68.035,2.65),(67.295,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((69.965,2.65),(69.965,40.99),(70.705,40.99),(70.705,2.65),(69.965,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((9.695,2.65),(9.695,40.99),(10.435,40.99),(10.435,2.65),(9.695,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((13.38,2.595),(13.38,41.045),(14.22,41.045),(14.22,2.595),(13.38,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((60.06,2.595),(60.06,41.045),(61.41,41.045),(61.41,2.595),(60.06,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.46,2.595),(26.46,41.045),(27.81,41.045),(27.81,2.595),(26.46,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.39,2.595),(57.39,41.045),(58.74,41.045),(58.74,2.595),(57.39,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.565,2.65),(55.565,40.99),(56.305,40.99),(56.305,2.65),(55.565,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((46.98,2.595),(46.98,41.045),(47.82,41.045),(47.82,2.595),(46.98,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((15.405,2.595),(15.405,41.045),(15.85,41.045),(15.85,2.595),(15.405,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.95,2.595),(30.95,41.045),(31.395,41.045),(31.395,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((28.895,2.65),(28.895,40.99),(29.635,40.99),(29.635,2.65),(28.895,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.75,2.595),(35.75,41.045),(36.195,41.045),(36.195,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((22.98,2.595),(22.98,41.045),(23.82,41.045),(23.82,2.595),(22.98,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((74.46,2.595),(74.46,41.045),(75.81,41.045),(75.81,2.595),(74.46,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.18,2.595),(42.18,41.045),(43.02,41.045),(43.02,2.595),(42.18,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.765,2.65),(50.765,40.99),(51.505,40.99),(51.505,2.65),(50.765,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((14.495,2.65),(14.495,40.99),(15.235,40.99),(15.235,2.65),(14.495,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((64.86,2.595),(64.86,41.045),(66.21,41.045),(66.21,2.595),(64.86,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((76.895,2.65),(76.895,40.99),(77.635,40.99),(77.635,2.65),(76.895,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((53.805,2.595),(53.805,41.045),(54.25,41.045),(54.25,2.595),(53.805,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((41.165,2.65),(41.165,40.99),(41.905,40.99),(41.905,2.65),(41.165,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.79,2.595),(47.79,41.045),(49.14,41.045),(49.14,2.595),(47.79,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((21.965,2.65),(21.965,40.99),(22.705,40.99),(22.705,2.65),(21.965,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.75,2.595),(59.75,41.045),(60.195,41.045),(60.195,2.595),(59.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((69.35,2.595),(69.35,41.045),(69.795,41.045),(69.795,2.595),(69.35,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((29.805,2.595),(29.805,41.045),(30.25,41.045),(30.25,2.595),(29.805,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((7.565,2.65),(7.565,40.99),(8.305,40.99),(8.305,2.65),(7.565,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((79.565,2.65),(79.565,40.99),(80.305,40.99),(80.305,2.65),(79.565,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((16.86,2.595),(16.86,41.045),(18.21,41.045),(18.21,2.595),(16.86,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.26,2.595),(31.26,41.045),(32.61,41.045),(32.61,2.595),(31.26,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((65.165,2.65),(65.165,40.99),(65.905,40.99),(65.905,2.65),(65.165,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.19,2.595),(38.19,41.045),(39.54,41.045),(39.54,2.595),(38.19,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.99,2.595),(42.99,41.045),(44.34,41.045),(44.34,2.595),(42.99,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.15,2.595),(50.15,41.045),(50.595,41.045),(50.595,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((82.605,2.595),(82.605,41.045),(83.05,41.045),(83.05,2.595),(82.605,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.965,2.65),(45.965,40.99),(46.705,40.99),(46.705,2.65),(45.965,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((37.38,2.595),(37.38,41.045),(38.22,41.045),(38.22,2.595),(37.38,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.205,2.595),(44.205,41.045),(44.65,41.045),(44.65,2.595),(44.205,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.95,2.595),(54.95,41.045),(55.395,41.045),(55.395,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((9.39,2.595),(9.39,41.045),(10.74,41.045),(10.74,2.595),(9.39,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((56.58,2.595),(56.58,41.045),(57.42,41.045),(57.42,2.595),(56.58,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((62.495,2.65),(62.495,40.99),(63.235,40.99),(63.235,2.65),(62.495,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.55,2.595),(40.55,41.045),(40.995,41.045),(40.995,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.895,2.65),(52.895,40.99),(53.635,40.99),(53.635,2.65),(52.895,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.26,2.595),(55.26,41.045),(56.61,41.045),(56.61,2.595),(55.26,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((21.35,2.595),(21.35,41.045),(21.795,41.045),(21.795,2.595),(21.35,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((28.59,2.595),(28.59,41.045),(29.94,41.045),(29.94,2.595),(28.59,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((14.19,2.595),(14.19,41.045),(15.54,41.045),(15.54,2.595),(14.19,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.46,2.595),(50.46,41.045),(51.81,41.045),(51.81,2.595),(50.46,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((66.18,2.595),(66.18,41.045),(67.02,41.045),(67.02,2.595),(66.18,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((61.38,2.595),(61.38,41.045),(62.22,41.045),(62.22,2.595),(61.38,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((76.59,2.595),(76.59,41.045),(77.94,41.045),(77.94,2.595),(76.59,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((69.66,2.595),(69.66,41.045),(71.01,41.045),(71.01,2.595),(69.66,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((81.695,2.65),(81.695,40.99),(82.435,40.99),(82.435,2.65),(81.695,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((66.99,2.595),(66.99,41.045),(68.34,41.045),(68.34,2.595),(66.99,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((32.58,2.595),(32.58,41.045),(33.42,41.045),(33.42,2.595),(32.58,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((11.75,2.595),(11.75,41.045),(12.195,41.045),(12.195,2.595),(11.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.35,2.595),(45.35,41.045),(45.795,41.045),(45.795,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((77.805,2.595),(77.805,41.045),(78.25,41.045),(78.25,2.595),(77.805,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.605,2.54),(45.605,41.1),(47.065,41.1),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.635,2.52),(26.635,41.12),(27.635,41.12),(27.635,2.52),(26.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.935,2.54),(42.935,41.1),(44.395,41.1),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.405,2.54),(26.405,41.1),(27.865,41.1),(27.865,2.54),(26.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.365,2.52),(38.365,41.12),(39.365,41.12),(39.365,2.52),(38.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.135,2.54),(38.135,41.1),(39.595,41.1),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.335,2.54),(57.335,41.1),(58.795,41.1),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.565,2.52),(57.565,41.12),(58.565,41.12),(58.565,2.52),(57.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.835,2.52),(21.835,41.12),(22.835,41.12),(22.835,2.52),(21.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.635,2.52),(50.635,41.12),(51.635,41.12),(51.635,2.52),(50.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((17.035,2.52),(17.035,41.12),(18.035,41.12),(18.035,2.52),(17.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.335,2.54),(81.335,41.1),(82.795,41.1),(82.795,2.54),(81.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.565,2.52),(81.565,41.12),(82.565,41.12),(82.565,2.52),(81.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.205,2.54),(79.205,41.1),(80.665,41.1),(80.665,2.54),(79.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.435,2.52),(7.435,41.12),(8.435,41.12),(8.435,2.52),(7.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.205,2.54),(7.205,41.1),(8.665,41.1),(8.665,2.54),(7.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.965,2.52),(71.965,41.12),(72.965,41.12),(72.965,2.52),(71.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.965,2.52),(47.965,41.12),(48.965,41.12),(48.965,2.52),(47.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.435,2.52),(79.435,41.12),(80.435,41.12),(80.435,2.52),(79.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.835,2.52),(69.835,41.12),(70.835,41.12),(70.835,2.52),(69.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((67.165,2.52),(67.165,41.12),(68.165,41.12),(68.165,2.52),(67.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.405,2.54),(74.405,41.1),(75.865,41.1),(75.865,2.54),(74.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.635,2.52),(74.635,41.12),(75.635,41.12),(75.635,2.52),(74.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.335,2.54),(9.335,41.1),(10.795,41.1),(10.795,2.54),(9.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.565,2.52),(9.565,41.12),(10.565,41.12),(10.565,2.52),(9.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.735,2.54),(23.735,41.1),(25.195,41.1),(25.195,2.54),(23.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.965,2.52),(23.965,41.12),(24.965,41.12),(24.965,2.52),(23.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((64.805,2.54),(64.805,41.1),(66.265,41.1),(66.265,2.54),(64.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((18.935,2.54),(18.935,41.1),(20.395,41.1),(20.395,2.54),(18.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((6.05,2.52),(6.05,41.12),(83.95,41.12),(83.95,2.52),(6.05,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.165,2.52),(43.165,41.12),(44.165,41.12),(44.165,2.52),(43.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.435,2.52),(55.435,41.12),(56.435,41.12),(56.435,2.52),(55.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.205,2.54),(55.205,41.1),(56.665,41.1),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.765,2.52),(28.765,41.12),(29.765,41.12),(29.765,2.52),(28.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.535,2.54),(28.535,41.1),(29.995,41.1),(29.995,2.54),(28.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.235,2.52),(36.235,41.12),(37.235,41.12),(37.235,2.52),(36.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.005,2.54),(36.005,41.1),(37.465,41.1),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.605,2.54),(21.605,41.1),(23.065,41.1),(23.065,2.54),(21.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.835,2.52),(45.835,41.12),(46.835,41.12),(46.835,2.52),(45.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.805,2.54),(40.805,41.1),(42.265,41.1),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.005,2.54),(60.005,41.1),(61.465,41.1),(61.465,2.54),(60.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.735,2.54),(47.735,41.1),(49.195,41.1),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.735,2.54),(71.735,41.1),(73.195,41.1),(73.195,2.54),(71.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.365,2.52),(14.365,41.12),(15.365,41.12),(15.365,2.52),(14.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.135,2.54),(14.135,41.1),(15.595,41.1),(15.595,2.54),(14.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.365,2.52),(62.365,41.12),(63.365,41.12),(63.365,2.52),(62.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.135,2.54),(62.135,41.1),(63.595,41.1),(63.595,2.54),(62.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((65.035,2.52),(65.035,41.12),(66.035,41.12),(66.035,2.52),(65.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.335,2.54),(33.335,41.1),(34.795,41.1),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.565,2.52),(33.565,41.12),(34.565,41.12),(34.565,2.52),(33.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.405,2.54),(50.405,41.1),(51.865,41.1),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.435,2.52),(31.435,41.12),(32.435,41.12),(32.435,2.52),(31.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.205,2.54),(31.205,41.1),(32.665,41.1),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.535,2.54),(76.535,41.1),(77.995,41.1),(77.995,2.54),(76.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.765,2.52),(52.765,41.12),(53.765,41.12),(53.765,2.52),(52.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.535,2.54),(52.535,41.1),(53.995,41.1),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.605,2.54),(69.605,41.1),(71.065,41.1),(71.065,2.54),(69.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.235,2.52),(12.235,41.12),(13.235,41.12),(13.235,2.52),(12.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.005,2.54),(12.005,41.1),(13.465,41.1),(13.465,2.54),(12.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.765,2.52),(76.765,41.12),(77.765,41.12),(77.765,2.52),(76.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.035,2.52),(41.035,41.12),(42.035,41.12),(42.035,2.52),(41.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((66.935,2.54),(66.935,41.1),(68.395,41.1),(68.395,2.54),(66.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.805,2.54),(16.805,41.1),(18.265,41.1),(18.265,2.54),(16.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((19.165,2.52),(19.165,41.12),(20.165,41.12),(20.165,2.52),(19.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.235,2.52),(60.235,41.12),(61.235,41.12),(61.235,2.52),(60.235,2.52)),
        )
        createRL(
            tech, net, 'polyres',
            ((85.675,21.655),(85.675,21.985),(86.015,21.985),(86.015,21.655),(85.675,21.655)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.655),(85.68,21.985),(86.01,21.985),(86.01,21.655),(85.68,21.655)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((57.515,2.72),(57.515,40.92),(57.765,40.92),(57.765,2.72),(57.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,40.92),(43.115,40.92),(43.115,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.635,2.72),(70.635,40.92),(70.885,40.92),(70.885,2.72),(70.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.635,2.72),(22.635,40.92),(22.885,40.92),(22.885,2.72),(22.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.885,2.72),(46.885,40.92),(47.695,40.92),(47.695,2.72),(46.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,40.92),(52.495,40.92),(52.495,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.685,2.72),(51.685,40.92),(52.495,40.92),(52.495,2.72),(51.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,40.92),(52.715,40.92),(52.715,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.915,2.72),(23.915,40.92),(24.165,40.92),(24.165,2.72),(23.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.315,2.72),(14.315,40.92),(14.565,40.92),(14.565,2.72),(14.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.315,2.72),(62.315,40.92),(62.565,40.92),(62.565,2.72),(62.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.115,2.72),(67.115,40.92),(67.365,40.92),(67.365,2.72),(67.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.115,2.72),(43.115,40.92),(43.365,40.92),(43.365,2.72),(43.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,40.92),(46.885,40.92),(46.885,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.885,2.72),(70.885,40.92),(71.695,40.92),(71.695,2.72),(70.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.115,2.72),(19.115,40.92),(19.365,40.92),(19.365,2.72),(19.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,40.92),(32.485,40.92),(32.485,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.435,2.72),(75.435,40.92),(75.685,40.92),(75.685,2.72),(75.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.715,2.72),(76.715,40.92),(76.965,40.92),(76.965,2.72),(76.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.715,2.72),(52.715,40.92),(52.965,40.92),(52.965,2.72),(52.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,40.92),(67.115,40.92),(67.115,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.485,2.72),(80.485,40.92),(81.295,40.92),(81.295,2.72),(80.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,40.92),(81.515,40.92),(81.515,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,40.92),(37.285,40.92),(37.285,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,40.92),(66.895,40.92),(66.895,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.085,2.72),(66.085,40.92),(66.895,40.92),(66.895,2.72),(66.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.035,2.72),(13.035,40.92),(13.285,40.92),(13.285,2.72),(13.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,40.92),(28.715,40.92),(28.715,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,40.92),(28.495,40.92),(28.495,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.685,2.72),(27.685,40.92),(28.495,40.92),(28.495,2.72),(27.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.035,2.72),(61.035,40.92),(61.285,40.92),(61.285,2.72),(61.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,40.92),(62.095,40.92),(62.095,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.285,2.72),(61.285,40.92),(62.095,40.92),(62.095,2.72),(61.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,40.92),(62.315,40.92),(62.315,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,40.92),(47.915,40.92),(47.915,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,40.92),(47.695,40.92),(47.695,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.235,2.72),(80.235,40.92),(80.485,40.92),(80.485,2.72),(80.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,40.92),(23.695,40.92),(23.695,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,40.92),(81.295,40.92),(81.295,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,40.92),(33.295,40.92),(33.295,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.485,2.72),(32.485,40.92),(33.295,40.92),(33.295,2.72),(32.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,40.92),(33.515,40.92),(33.515,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,40.92),(76.495,40.92),(76.495,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.685,2.72),(75.685,40.92),(76.495,40.92),(76.495,2.72),(75.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,40.92),(76.715,40.92),(76.715,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,40.92),(23.915,40.92),(23.915,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,40.92),(14.315,40.92),(14.315,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,40.92),(14.095,40.92),(14.095,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.285,2.72),(13.285,40.92),(14.095,40.92),(14.095,2.72),(13.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.915,2.72),(47.915,40.92),(48.165,40.92),(48.165,2.72),(47.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.915,2.72),(71.915,40.92),(72.165,40.92),(72.165,2.72),(71.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.235,2.72),(8.235,40.92),(8.485,40.92),(8.485,2.72),(8.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,40.92),(9.515,40.92),(9.515,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,40.92),(9.295,40.92),(9.295,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.485,2.72),(8.485,40.92),(9.295,40.92),(9.295,2.72),(8.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.435,2.72),(27.435,40.92),(27.685,40.92),(27.685,2.72),(27.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.485,2.72),(56.485,40.92),(57.295,40.92),(57.295,2.72),(56.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,40.92),(57.515,40.92),(57.515,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.715,2.72),(28.715,40.92),(28.965,40.92),(28.965,2.72),(28.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.835,2.72),(17.835,40.92),(18.085,40.92),(18.085,2.72),(17.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,40.92),(42.085,40.92),(42.085,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,40.92),(19.115,40.92),(19.115,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.835,2.72),(65.835,40.92),(66.085,40.92),(66.085,2.72),(65.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,40.92),(71.695,40.92),(71.695,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.515,2.72),(81.515,40.92),(81.765,40.92),(81.765,2.72),(81.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,40.92),(18.895,40.92),(18.895,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.085,2.72),(18.085,40.92),(18.895,40.92),(18.895,2.72),(18.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.515,2.72),(33.515,40.92),(33.765,40.92),(33.765,2.72),(33.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.085,2.72),(42.085,40.92),(42.895,40.92),(42.895,2.72),(42.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,40.92),(71.915,40.92),(71.915,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.515,2.72),(9.515,40.92),(9.765,40.92),(9.765,2.72),(9.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,40.92),(51.685,40.92),(51.685,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,40.92),(38.095,40.92),(38.095,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.285,2.72),(37.285,40.92),(38.095,40.92),(38.095,2.72),(37.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,40.92),(38.315,40.92),(38.315,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.315,2.72),(38.315,40.92),(38.565,40.92),(38.565,2.72),(38.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.885,2.72),(22.885,40.92),(23.695,40.92),(23.695,2.72),(22.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,40.92),(56.485,40.92),(56.485,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,40.92),(57.295,40.92),(57.295,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,40.92),(42.895,40.92),(42.895,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.445),(18.685,15.615),(18.855,15.615),(18.855,15.445),(18.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.445),(18.345,15.615),(18.515,15.615),(18.515,15.445),(18.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.105),(18.685,15.275),(18.855,15.275),(18.855,15.105),(18.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.025),(75.945,11.195),(76.115,11.195),(76.115,11.025),(75.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.365),(75.945,11.535),(76.115,11.535),(76.115,11.365),(75.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.105),(18.345,15.275),(18.515,15.275),(18.515,15.105),(18.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.705),(75.945,11.875),(76.115,11.875),(76.115,11.705),(75.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.785),(18.345,15.955),(18.515,15.955),(18.515,15.785),(18.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.785),(18.685,15.955),(18.855,15.955),(18.855,15.785),(18.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.925),(23.145,6.095),(23.315,6.095),(23.315,5.925),(23.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.925),(23.485,6.095),(23.655,6.095),(23.655,5.925),(23.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,20.205),(61.885,20.375),(62.055,20.375),(62.055,20.205),(61.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,20.545),(61.885,20.715),(62.055,20.715),(62.055,20.545),(61.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.545),(56.745,3.715),(56.915,3.715),(56.915,3.545),(56.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,32.105),(9.085,32.275),(9.255,32.275),(9.255,32.105),(9.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,32.445),(9.085,32.615),(9.255,32.615),(9.255,32.445),(9.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,32.785),(9.085,32.955),(9.255,32.955),(9.255,32.785),(9.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,25.985),(8.745,26.155),(8.915,26.155),(8.915,25.985),(8.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.525),(32.745,19.695),(32.915,19.695),(32.915,19.525),(32.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.185),(32.745,19.355),(32.915,19.355),(32.915,19.185),(32.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.705),(27.945,11.875),(28.115,11.875),(28.115,11.705),(27.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.025),(27.945,11.195),(28.115,11.195),(28.115,11.025),(27.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.905),(47.145,39.075),(47.315,39.075),(47.315,38.905),(47.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.905),(47.485,39.075),(47.655,39.075),(47.655,38.905),(47.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.885),(61.545,4.055),(61.715,4.055),(61.715,3.885),(61.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.365),(27.945,11.535),(28.115,11.535),(28.115,11.365),(27.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.845),(76.285,19.015),(76.455,19.015),(76.455,18.845),(76.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,20.885),(75.945,21.055),(76.115,21.055),(76.115,20.885),(75.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.025),(81.085,11.195),(81.255,11.195),(81.255,11.025),(81.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.365),(81.085,11.535),(81.255,11.535),(81.255,11.365),(81.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.705),(81.085,11.875),(81.255,11.875),(81.255,11.705),(81.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,38.905),(23.485,39.075),(23.655,39.075),(23.655,38.905),(23.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.205),(47.145,20.375),(47.315,20.375),(47.315,20.205),(47.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.205),(47.485,20.375),(47.655,20.375),(47.655,20.205),(47.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.545),(47.145,20.715),(47.315,20.715),(47.315,20.545),(47.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.545),(47.485,20.715),(47.655,20.715),(47.655,20.545),(47.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.205),(42.345,3.375),(42.515,3.375),(42.515,3.205),(42.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.205),(42.685,3.375),(42.855,3.375),(42.855,3.205),(42.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.545),(42.345,3.715),(42.515,3.715),(42.515,3.545),(42.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.765),(80.745,14.935),(80.915,14.935),(80.915,14.765),(80.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.085),(80.745,14.255),(80.915,14.255),(80.915,14.085),(80.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.425),(80.745,14.595),(80.915,14.595),(80.915,14.425),(80.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.545),(42.685,3.715),(42.855,3.715),(42.855,3.545),(42.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,32.785),(23.485,32.955),(23.655,32.955),(23.655,32.785),(23.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.005),(80.745,10.175),(80.915,10.175),(80.915,10.005),(80.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.885),(13.545,4.055),(13.715,4.055),(13.715,3.885),(13.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,36.185),(66.345,36.355),(66.515,36.355),(66.515,36.185),(66.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,36.185),(66.685,36.355),(66.855,36.355),(66.855,36.185),(66.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,36.525),(66.345,36.695),(66.515,36.695),(66.515,36.525),(66.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,36.525),(66.685,36.695),(66.855,36.695),(66.855,36.525),(66.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.105),(37.885,32.275),(38.055,32.275),(38.055,32.105),(37.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.445),(37.885,32.615),(38.055,32.615),(38.055,32.445),(37.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.785),(37.885,32.955),(38.055,32.955),(38.055,32.785),(37.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,36.185),(75.945,36.355),(76.115,36.355),(76.115,36.185),(75.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,36.525),(75.945,36.695),(76.115,36.695),(76.115,36.525),(75.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,27.345),(61.885,27.515),(62.055,27.515),(62.055,27.345),(61.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,27.005),(61.885,27.175),(62.055,27.175),(62.055,27.005),(61.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,27.685),(61.885,27.855),(62.055,27.855),(62.055,27.685),(61.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,35.845),(13.885,36.015),(14.055,36.015),(14.055,35.845),(13.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.245),(27.945,5.415),(28.115,5.415),(28.115,5.245),(27.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.585),(27.945,5.755),(28.115,5.755),(28.115,5.585),(27.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.665),(51.945,9.835),(52.115,9.835),(52.115,9.665),(51.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.325),(51.945,9.495),(52.115,9.495),(52.115,9.325),(51.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.985),(33.085,9.155),(33.255,9.155),(33.255,8.985),(33.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.085),(76.285,14.255),(76.455,14.255),(76.455,14.085),(76.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.765),(76.285,14.935),(76.455,14.935),(76.455,14.765),(76.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.425),(76.285,14.595),(76.455,14.595),(76.455,14.425),(76.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.905),(51.945,5.075),(52.115,5.075),(52.115,4.905),(51.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.925),(52.285,23.095),(52.455,23.095),(52.455,22.925),(52.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,37.885),(13.885,38.055),(14.055,38.055),(14.055,37.885),(13.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,31.085),(61.885,31.255),(62.055,31.255),(62.055,31.085),(61.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,31.425),(61.885,31.595),(62.055,31.595),(62.055,31.425),(61.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,31.765),(61.885,31.935),(62.055,31.935),(62.055,31.765),(61.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.965),(61.545,8.135),(61.715,8.135),(61.715,7.965),(61.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,28.705),(23.485,28.875),(23.655,28.875),(23.655,28.705),(23.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.045),(18.345,12.215),(18.515,12.215),(18.515,12.045),(18.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.045),(18.685,12.215),(18.855,12.215),(18.855,12.045),(18.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.385),(18.345,12.555),(18.515,12.555),(18.515,12.385),(18.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.385),(18.685,12.555),(18.855,12.555),(18.855,12.385),(18.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.245),(56.745,5.415),(56.915,5.415),(56.915,5.245),(56.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.585),(56.745,5.755),(56.915,5.755),(56.915,5.585),(56.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.725),(18.345,12.895),(18.515,12.895),(18.515,12.725),(18.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,24.625),(61.885,24.795),(62.055,24.795),(62.055,24.625),(61.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,24.285),(61.885,24.455),(62.055,24.455),(62.055,24.285),(61.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.725),(18.685,12.895),(18.855,12.895),(18.855,12.725),(18.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.245),(32.745,5.415),(32.915,5.415),(32.915,5.245),(32.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.585),(32.745,5.755),(32.915,5.755),(32.915,5.585),(32.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.825),(61.545,17.995),(61.715,17.995),(61.715,17.825),(61.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.145),(61.545,17.315),(61.715,17.315),(61.715,17.145),(61.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,25.305),(80.745,25.475),(80.915,25.475),(80.915,25.305),(80.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,25.645),(80.745,25.815),(80.915,25.815),(80.915,25.645),(80.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.485),(61.545,17.655),(61.715,17.655),(61.715,17.485),(61.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.965),(13.545,8.135),(13.715,8.135),(13.715,7.965),(13.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.225),(32.745,38.395),(32.915,38.395),(32.915,38.225),(32.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.565),(32.745,38.735),(32.915,38.735),(32.915,38.565),(32.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.765),(47.145,31.935),(47.315,31.935),(47.315,31.765),(47.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.765),(47.485,31.935),(47.655,31.935),(47.655,31.765),(47.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.085),(47.145,31.255),(47.315,31.255),(47.315,31.085),(47.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.085),(47.485,31.255),(47.655,31.255),(47.655,31.085),(47.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,36.185),(13.545,36.355),(13.715,36.355),(13.715,36.185),(13.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,36.525),(13.545,36.695),(13.715,36.695),(13.715,36.525),(13.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.425),(47.145,31.595),(47.315,31.595),(47.315,31.425),(47.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.425),(47.485,31.595),(47.655,31.595),(47.655,31.425),(47.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.545),(18.345,3.715),(18.515,3.715),(18.515,3.545),(18.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.205),(18.685,3.375),(18.855,3.375),(18.855,3.205),(18.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.205),(18.345,3.375),(18.515,3.375),(18.515,3.205),(18.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.545),(18.685,3.715),(18.855,3.715),(18.855,3.545),(18.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,38.905),(61.545,39.075),(61.715,39.075),(61.715,38.905),(61.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.865),(32.745,37.035),(32.915,37.035),(32.915,36.865),(32.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.545),(61.885,3.715),(62.055,3.715),(62.055,3.545),(61.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.205),(61.885,3.375),(62.055,3.375),(62.055,3.205),(61.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.665),(81.085,9.835),(81.255,9.835),(81.255,9.665),(81.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.325),(81.085,9.495),(81.255,9.495),(81.255,9.325),(81.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.565),(37.545,4.735),(37.715,4.735),(37.715,4.565),(37.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.225),(37.545,4.395),(37.715,4.395),(37.715,4.225),(37.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.305),(56.745,25.475),(56.915,25.475),(56.915,25.305),(56.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.645),(56.745,25.815),(56.915,25.815),(56.915,25.645),(56.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.845),(56.745,36.015),(56.915,36.015),(56.915,35.845),(56.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,27.005),(71.145,27.175),(71.315,27.175),(71.315,27.005),(71.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,27.005),(71.485,27.175),(71.655,27.175),(71.655,27.005),(71.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,27.345),(71.485,27.515),(71.655,27.515),(71.655,27.345),(71.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.265),(37.545,23.435),(37.715,23.435),(37.715,23.265),(37.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.605),(37.545,23.775),(37.715,23.775),(37.715,23.605),(37.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,27.345),(71.145,27.515),(71.315,27.515),(71.315,27.345),(71.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.205),(13.885,3.375),(14.055,3.375),(14.055,3.205),(13.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.545),(13.885,3.715),(14.055,3.715),(14.055,3.545),(13.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,27.685),(71.145,27.855),(71.315,27.855),(71.315,27.685),(71.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,27.685),(71.485,27.855),(71.655,27.855),(71.655,27.685),(71.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.645),(42.685,8.815),(42.855,8.815),(42.855,8.645),(42.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.305),(42.345,8.475),(42.515,8.475),(42.515,8.305),(42.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.305),(42.685,8.475),(42.855,8.475),(42.855,8.305),(42.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.645),(42.345,8.815),(42.515,8.815),(42.515,8.645),(42.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.165),(52.285,18.335),(52.455,18.335),(52.455,18.165),(52.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.505),(52.285,18.675),(52.455,18.675),(52.455,18.505),(52.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.725),(23.145,12.895),(23.315,12.895),(23.315,12.725),(23.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,40.605),(13.545,40.775),(13.715,40.775),(13.715,40.605),(13.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,40.265),(13.545,40.435),(13.715,40.435),(13.715,40.265),(13.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.985),(37.885,9.155),(38.055,9.155),(38.055,8.985),(37.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.065),(56.745,30.235),(56.915,30.235),(56.915,30.065),(56.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.405),(56.745,30.575),(56.915,30.575),(56.915,30.405),(56.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.745),(56.745,30.915),(56.915,30.915),(56.915,30.745),(56.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,21.565),(61.545,21.735),(61.715,21.735),(61.715,21.565),(61.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,21.225),(61.545,21.395),(61.715,21.395),(61.715,21.225),(61.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,37.205),(76.285,37.375),(76.455,37.375),(76.455,37.205),(76.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,37.545),(76.285,37.715),(76.455,37.715),(76.455,37.545),(76.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,34.825),(80.745,34.995),(80.915,34.995),(80.915,34.825),(80.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,34.145),(80.745,34.315),(80.915,34.315),(80.915,34.145),(80.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,34.485),(80.745,34.655),(80.915,34.655),(80.915,34.485),(80.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.945),(37.545,7.115),(37.715,7.115),(37.715,6.945),(37.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.145),(47.145,34.315),(47.315,34.315),(47.315,34.145),(47.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.145),(47.485,34.315),(47.655,34.315),(47.655,34.145),(47.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.485),(47.145,34.655),(47.315,34.655),(47.315,34.485),(47.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.485),(47.485,34.655),(47.655,34.655),(47.655,34.485),(47.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.825),(47.145,34.995),(47.315,34.995),(47.315,34.825),(47.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.825),(47.485,34.995),(47.655,34.995),(47.655,34.825),(47.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.185),(33.085,19.355),(33.255,19.355),(33.255,19.185),(33.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.525),(33.085,19.695),(33.255,19.695),(33.255,19.525),(33.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.725),(47.145,12.895),(47.315,12.895),(47.315,12.725),(47.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.725),(47.485,12.895),(47.655,12.895),(47.655,12.725),(47.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.045),(47.145,12.215),(47.315,12.215),(47.315,12.045),(47.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.045),(47.485,12.215),(47.655,12.215),(47.655,12.045),(47.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.385),(47.145,12.555),(47.315,12.555),(47.315,12.385),(47.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.385),(47.485,12.555),(47.655,12.555),(47.655,12.385),(47.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,23.945),(28.285,24.115),(28.455,24.115),(28.455,23.945),(28.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,40.265),(32.745,40.435),(32.915,40.435),(32.915,40.265),(32.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,40.605),(32.745,40.775),(32.915,40.775),(32.915,40.605),(32.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.885),(42.345,4.055),(42.515,4.055),(42.515,3.885),(42.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.885),(42.685,4.055),(42.855,4.055),(42.855,3.885),(42.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,21.905),(76.285,22.075),(76.455,22.075),(76.455,21.905),(76.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.225),(9.085,4.395),(9.255,4.395),(9.255,4.225),(9.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.565),(9.085,4.735),(9.255,4.735),(9.255,4.565),(9.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.665),(27.945,9.835),(28.115,9.835),(28.115,9.665),(27.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.325),(27.945,9.495),(28.115,9.495),(28.115,9.325),(27.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.885),(56.745,38.055),(56.915,38.055),(56.915,37.885),(56.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,38.225),(61.885,38.395),(62.055,38.395),(62.055,38.225),(61.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,38.565),(61.885,38.735),(62.055,38.735),(62.055,38.565),(61.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,21.565),(28.285,21.735),(28.455,21.735),(28.455,21.565),(28.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,21.225),(28.285,21.395),(28.455,21.395),(28.455,21.225),(28.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,27.685),(80.745,27.855),(80.915,27.855),(80.915,27.685),(80.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,27.005),(80.745,27.175),(80.915,27.175),(80.915,27.005),(80.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,27.345),(80.745,27.515),(80.915,27.515),(80.915,27.345),(80.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.105),(66.345,15.275),(66.515,15.275),(66.515,15.105),(66.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.105),(66.685,15.275),(66.855,15.275),(66.855,15.105),(66.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.445),(66.345,15.615),(66.515,15.615),(66.515,15.445),(66.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.445),(66.685,15.615),(66.855,15.615),(66.855,15.445),(66.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.785),(66.345,15.955),(66.515,15.955),(66.515,15.785),(66.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.785),(66.685,15.955),(66.855,15.955),(66.855,15.785),(66.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.865),(52.285,3.035),(52.455,3.035),(52.455,2.865),(52.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,40.265),(52.285,40.435),(52.455,40.435),(52.455,40.265),(52.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,40.605),(52.285,40.775),(52.455,40.775),(52.455,40.605),(52.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.525),(23.145,19.695),(23.315,19.695),(23.315,19.525),(23.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.185),(23.145,19.355),(23.315,19.355),(23.315,19.185),(23.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,31.425),(71.145,31.595),(71.315,31.595),(71.315,31.425),(71.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.525),(23.485,19.695),(23.655,19.695),(23.655,19.525),(23.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.185),(23.485,19.355),(23.655,19.355),(23.655,19.185),(23.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.285),(28.285,7.455),(28.455,7.455),(28.455,7.285),(28.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.625),(28.285,7.795),(28.455,7.795),(28.455,7.625),(28.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.105),(9.085,15.275),(9.255,15.275),(9.255,15.105),(9.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.185),(56.745,36.355),(56.915,36.355),(56.915,36.185),(56.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.525),(56.745,36.695),(56.915,36.695),(56.915,36.525),(56.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,39.925),(61.885,40.095),(62.055,40.095),(62.055,39.925),(61.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.945),(9.085,7.115),(9.255,7.115),(9.255,6.945),(9.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,20.885),(71.145,21.055),(71.315,21.055),(71.315,20.885),(71.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,20.885),(71.485,21.055),(71.655,21.055),(71.655,20.885),(71.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,32.105),(81.085,32.275),(81.255,32.275),(81.255,32.105),(81.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,32.445),(81.085,32.615),(81.255,32.615),(81.255,32.445),(81.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,32.785),(81.085,32.955),(81.255,32.955),(81.255,32.785),(81.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.245),(81.085,5.415),(81.255,5.415),(81.255,5.245),(81.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.585),(81.085,5.755),(81.255,5.755),(81.255,5.585),(81.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.685),(66.345,10.855),(66.515,10.855),(66.515,10.685),(66.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.685),(66.685,10.855),(66.855,10.855),(66.855,10.685),(66.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.225),(81.085,4.395),(81.255,4.395),(81.255,4.225),(81.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.565),(81.085,4.735),(81.255,4.735),(81.255,4.565),(81.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.585),(56.745,22.755),(56.915,22.755),(56.915,22.585),(56.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.005),(66.345,10.175),(66.515,10.175),(66.515,10.005),(66.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,29.385),(61.545,29.555),(61.715,29.555),(61.715,29.385),(61.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,29.045),(61.545,29.215),(61.715,29.215),(61.715,29.045),(61.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.005),(66.685,10.175),(66.855,10.175),(66.855,10.005),(66.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,21.905),(66.345,22.075),(66.515,22.075),(66.515,21.905),(66.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,21.905),(66.685,22.075),(66.855,22.075),(66.855,21.905),(66.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.245),(56.745,22.415),(56.915,22.415),(56.915,22.245),(56.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,29.725),(61.545,29.895),(61.715,29.895),(61.715,29.725),(61.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.025),(28.285,11.195),(28.455,11.195),(28.455,11.025),(28.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.365),(28.285,11.535),(28.455,11.535),(28.455,11.365),(28.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.705),(28.285,11.875),(28.455,11.875),(28.455,11.705),(28.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.685),(37.885,27.855),(38.055,27.855),(38.055,27.685),(37.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.005),(37.885,27.175),(38.055,27.175),(38.055,27.005),(37.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.345),(37.885,27.515),(38.055,27.515),(38.055,27.345),(37.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.825),(66.685,17.995),(66.855,17.995),(66.855,17.825),(66.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.765),(23.145,14.935),(23.315,14.935),(23.315,14.765),(23.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.765),(23.485,14.935),(23.655,14.935),(23.655,14.765),(23.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.085),(23.145,14.255),(23.315,14.255),(23.315,14.085),(23.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,25.985),(76.285,26.155),(76.455,26.155),(76.455,25.985),(76.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.085),(23.485,14.255),(23.655,14.255),(23.655,14.085),(23.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.425),(23.145,14.595),(23.315,14.595),(23.315,14.425),(23.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.425),(23.485,14.595),(23.655,14.595),(23.655,14.425),(23.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.885),(37.545,21.055),(37.715,21.055),(37.715,20.885),(37.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.005),(51.945,10.175),(52.115,10.175),(52.115,10.005),(51.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.345),(51.945,10.515),(52.115,10.515),(52.115,10.345),(51.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.885),(18.345,4.055),(18.515,4.055),(18.515,3.885),(18.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.885),(18.685,4.055),(18.855,4.055),(18.855,3.885),(18.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.005),(18.685,10.175),(18.855,10.175),(18.855,10.005),(18.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.685),(51.945,10.855),(52.115,10.855),(52.115,10.685),(51.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,30.745),(27.945,30.915),(28.115,30.915),(28.115,30.745),(27.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.285),(32.745,24.455),(32.915,24.455),(32.915,24.285),(32.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.625),(32.745,24.795),(32.915,24.795),(32.915,24.625),(32.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,30.065),(27.945,30.235),(28.115,30.235),(28.115,30.065),(27.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,30.405),(27.945,30.575),(28.115,30.575),(28.115,30.405),(27.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,25.305),(28.285,25.475),(28.455,25.475),(28.455,25.305),(28.285,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,25.645),(28.285,25.815),(28.455,25.815),(28.455,25.645),(28.285,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.865),(9.085,20.035),(9.255,20.035),(9.255,19.865),(9.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.085),(37.885,31.255),(38.055,31.255),(38.055,31.085),(37.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.425),(37.885,31.595),(38.055,31.595),(38.055,31.425),(37.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.765),(37.885,31.935),(38.055,31.935),(38.055,31.765),(37.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.885),(56.745,21.055),(56.915,21.055),(56.915,20.885),(56.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.925),(71.145,6.095),(71.315,6.095),(71.315,5.925),(71.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.925),(71.485,6.095),(71.655,6.095),(71.655,5.925),(71.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.725),(66.345,12.895),(66.515,12.895),(66.515,12.725),(66.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.725),(66.685,12.895),(66.855,12.895),(66.855,12.725),(66.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,36.865),(28.285,37.035),(28.455,37.035),(28.455,36.865),(28.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.045),(66.345,12.215),(66.515,12.215),(66.515,12.045),(66.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.045),(66.685,12.215),(66.855,12.215),(66.855,12.045),(66.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.705),(47.145,11.875),(47.315,11.875),(47.315,11.705),(47.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.705),(47.485,11.875),(47.655,11.875),(47.655,11.705),(47.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.385),(66.345,12.555),(66.515,12.555),(66.515,12.385),(66.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.885),(8.745,4.055),(8.915,4.055),(8.915,3.885),(8.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,34.825),(13.545,34.995),(13.715,34.995),(13.715,34.825),(13.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,34.145),(13.545,34.315),(13.715,34.315),(13.715,34.145),(13.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,34.485),(13.545,34.655),(13.715,34.655),(13.715,34.485),(13.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.285),(37.885,24.455),(38.055,24.455),(38.055,24.285),(37.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.625),(37.885,24.795),(38.055,24.795),(38.055,24.625),(37.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.905),(42.345,39.075),(42.515,39.075),(42.515,38.905),(42.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.985),(13.885,9.155),(14.055,9.155),(14.055,8.985),(13.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.905),(42.685,39.075),(42.855,39.075),(42.855,38.905),(42.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.085),(9.085,14.255),(9.255,14.255),(9.255,14.085),(9.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.425),(9.085,14.595),(9.255,14.595),(9.255,14.425),(9.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.765),(9.085,14.935),(9.255,14.935),(9.255,14.765),(9.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,27.685),(8.745,27.855),(8.915,27.855),(8.915,27.685),(8.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,20.885),(81.085,21.055),(81.255,21.055),(81.255,20.885),(81.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,27.005),(8.745,27.175),(8.915,27.175),(8.915,27.005),(8.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,27.345),(8.745,27.515),(8.915,27.515),(8.915,27.345),(8.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.945),(56.745,7.115),(56.915,7.115),(56.915,6.945),(56.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,38.905),(75.945,39.075),(76.115,39.075),(76.115,38.905),(75.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.245),(57.085,22.415),(57.255,22.415),(57.255,22.245),(57.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.585),(57.085,22.755),(57.255,22.755),(57.255,22.585),(57.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.945),(32.745,7.115),(32.915,7.115),(32.915,6.945),(32.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.585),(42.685,22.755),(42.855,22.755),(42.855,22.585),(42.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,23.265),(80.745,23.435),(80.915,23.435),(80.915,23.265),(80.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,23.605),(80.745,23.775),(80.915,23.775),(80.915,23.605),(80.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.965),(75.945,8.135),(76.115,8.135),(76.115,7.965),(75.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.205),(66.345,3.375),(66.515,3.375),(66.515,3.205),(66.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.205),(66.685,3.375),(66.855,3.375),(66.855,3.205),(66.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.545),(66.345,3.715),(66.515,3.715),(66.515,3.545),(66.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.545),(66.685,3.715),(66.855,3.715),(66.855,3.545),(66.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.245),(42.345,22.415),(42.515,22.415),(42.515,22.245),(42.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.585),(42.345,22.755),(42.515,22.755),(42.515,22.585),(42.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,21.905),(9.085,22.075),(9.255,22.075),(9.255,21.905),(9.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.945),(8.745,7.115),(8.915,7.115),(8.915,6.945),(8.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,38.905),(13.885,39.075),(14.055,39.075),(14.055,38.905),(13.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.885),(28.285,4.055),(28.455,4.055),(28.455,3.885),(28.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,36.185),(80.745,36.355),(80.915,36.355),(80.915,36.185),(80.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,36.525),(80.745,36.695),(80.915,36.695),(80.915,36.525),(80.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.685),(32.745,10.855),(32.915,10.855),(32.915,10.685),(32.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,39.245),(80.745,39.415),(80.915,39.415),(80.915,39.245),(80.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,39.585),(80.745,39.755),(80.915,39.755),(80.915,39.585),(80.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.225),(57.085,4.395),(57.255,4.395),(57.255,4.225),(57.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.565),(57.085,4.735),(57.255,4.735),(57.255,4.565),(57.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.965),(27.945,8.135),(28.115,8.135),(28.115,7.965),(27.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.685),(18.345,10.855),(18.515,10.855),(18.515,10.685),(18.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.685),(18.685,10.855),(18.855,10.855),(18.855,10.685),(18.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.225),(33.085,4.395),(33.255,4.395),(33.255,4.225),(33.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.565),(33.085,4.735),(33.255,4.735),(33.255,4.565),(33.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,22.925),(27.945,23.095),(28.115,23.095),(28.115,22.925),(27.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.005),(18.345,10.175),(18.515,10.175),(18.515,10.005),(18.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.825),(71.145,17.995),(71.315,17.995),(71.315,17.825),(71.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.825),(71.485,17.995),(71.655,17.995),(71.655,17.825),(71.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.245),(75.945,5.415),(76.115,5.415),(76.115,5.245),(75.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.585),(75.945,5.755),(76.115,5.755),(76.115,5.585),(75.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.145),(71.145,17.315),(71.315,17.315),(71.315,17.145),(71.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.145),(71.485,17.315),(71.655,17.315),(71.655,17.145),(71.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.485),(71.145,17.655),(71.315,17.655),(71.315,17.485),(71.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.485),(71.485,17.655),(71.655,17.655),(71.655,17.485),(71.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,20.205),(13.885,20.375),(14.055,20.375),(14.055,20.205),(13.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,20.545),(13.885,20.715),(14.055,20.715),(14.055,20.545),(13.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,39.925),(9.085,40.095),(9.255,40.095),(9.255,39.925),(9.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.025),(56.745,28.195),(56.915,28.195),(56.915,28.025),(56.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.365),(56.745,28.535),(56.915,28.535),(56.915,28.365),(56.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.705),(56.745,28.875),(56.915,28.875),(56.915,28.705),(56.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.065),(47.485,30.235),(47.655,30.235),(47.655,30.065),(47.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,23.265),(9.085,23.435),(9.255,23.435),(9.255,23.265),(9.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,23.605),(9.085,23.775),(9.255,23.775),(9.255,23.605),(9.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.805),(37.545,16.975),(37.715,16.975),(37.715,16.805),(37.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.125),(37.545,16.295),(37.715,16.295),(37.715,16.125),(37.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.465),(37.545,16.635),(37.715,16.635),(37.715,16.465),(37.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.945),(57.085,7.115),(57.255,7.115),(57.255,6.945),(57.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.945),(37.885,7.115),(38.055,7.115),(38.055,6.945),(37.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.845),(52.285,36.015),(52.455,36.015),(52.455,35.845),(52.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,33.805),(61.885,33.975),(62.055,33.975),(62.055,33.805),(61.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.825),(37.885,17.995),(38.055,17.995),(38.055,17.825),(37.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.945),(80.745,7.115),(80.915,7.115),(80.915,6.945),(80.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,33.465),(61.885,33.635),(62.055,33.635),(62.055,33.465),(61.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,33.125),(61.885,33.295),(62.055,33.295),(62.055,33.125),(61.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,30.065),(66.345,30.235),(66.515,30.235),(66.515,30.065),(66.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.945),(33.085,7.115),(33.255,7.115),(33.255,6.945),(33.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,30.065),(66.685,30.235),(66.855,30.235),(66.855,30.065),(66.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,30.405),(66.345,30.575),(66.515,30.575),(66.515,30.405),(66.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.805),(52.285,16.975),(52.455,16.975),(52.455,16.805),(52.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,30.405),(66.685,30.575),(66.855,30.575),(66.855,30.405),(66.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,30.745),(66.345,30.915),(66.515,30.915),(66.515,30.745),(66.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,30.745),(66.685,30.915),(66.855,30.915),(66.855,30.745),(66.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.125),(52.285,16.295),(52.455,16.295),(52.455,16.125),(52.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.465),(52.285,16.635),(52.455,16.635),(52.455,16.465),(52.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,20.205),(27.945,20.375),(28.115,20.375),(28.115,20.205),(27.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.605),(75.945,6.775),(76.115,6.775),(76.115,6.605),(75.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.265),(75.945,6.435),(76.115,6.435),(76.115,6.265),(75.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.385),(66.685,12.555),(66.855,12.555),(66.855,12.385),(66.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.265),(51.945,23.435),(52.115,23.435),(52.115,23.265),(51.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.605),(51.945,23.775),(52.115,23.775),(52.115,23.605),(51.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.425),(71.485,14.595),(71.655,14.595),(71.655,14.425),(71.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,26.665),(8.745,26.835),(8.915,26.835),(8.915,26.665),(8.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,36.865),(76.285,37.035),(76.455,37.035),(76.455,36.865),(76.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.565),(37.885,21.735),(38.055,21.735),(38.055,21.565),(37.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.225),(37.885,21.395),(38.055,21.395),(38.055,21.225),(37.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.265),(27.945,6.435),(28.115,6.435),(28.115,6.265),(27.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.605),(27.945,6.775),(28.115,6.775),(28.115,6.605),(27.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,38.225),(66.345,38.395),(66.515,38.395),(66.515,38.225),(66.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,38.225),(66.685,38.395),(66.855,38.395),(66.855,38.225),(66.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,38.565),(66.345,38.735),(66.515,38.735),(66.515,38.565),(66.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,38.565),(66.685,38.735),(66.855,38.735),(66.855,38.565),(66.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.965),(51.945,25.135),(52.115,25.135),(52.115,24.965),(51.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.205),(52.285,20.375),(52.455,20.375),(52.455,20.205),(52.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.545),(52.285,20.715),(52.455,20.715),(52.455,20.545),(52.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.205),(32.745,20.375),(32.915,20.375),(32.915,20.205),(32.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.545),(32.745,20.715),(32.915,20.715),(32.915,20.545),(32.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,40.265),(71.145,40.435),(71.315,40.435),(71.315,40.265),(71.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.985),(32.745,9.155),(32.915,9.155),(32.915,8.985),(32.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,40.265),(71.485,40.435),(71.655,40.435),(71.655,40.265),(71.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,40.605),(71.485,40.775),(71.655,40.775),(71.655,40.605),(71.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,40.605),(71.145,40.775),(71.315,40.775),(71.315,40.605),(71.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.805),(52.285,33.975),(52.455,33.975),(52.455,33.805),(52.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.125),(52.285,33.295),(52.455,33.295),(52.455,33.125),(52.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.465),(52.285,33.635),(52.455,33.635),(52.455,33.465),(52.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.285),(42.345,7.455),(42.515,7.455),(42.515,7.285),(42.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.285),(42.685,7.455),(42.855,7.455),(42.855,7.285),(42.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.625),(42.345,7.795),(42.515,7.795),(42.515,7.625),(42.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.625),(42.685,7.795),(42.855,7.795),(42.855,7.625),(42.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.045),(51.945,12.215),(52.115,12.215),(52.115,12.045),(51.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.385),(51.945,12.555),(52.115,12.555),(52.115,12.385),(51.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.725),(51.945,12.895),(52.115,12.895),(52.115,12.725),(51.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.265),(52.285,6.435),(52.455,6.435),(52.455,6.265),(52.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.605),(52.285,6.775),(52.455,6.775),(52.455,6.605),(52.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.845),(27.945,19.015),(28.115,19.015),(28.115,18.845),(27.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.165),(37.885,18.335),(38.055,18.335),(38.055,18.165),(37.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.505),(37.885,18.675),(38.055,18.675),(38.055,18.505),(37.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,29.385),(23.485,29.555),(23.655,29.555),(23.655,29.385),(23.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,29.045),(23.145,29.215),(23.315,29.215),(23.315,29.045),(23.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,29.045),(23.485,29.215),(23.655,29.215),(23.655,29.045),(23.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.885),(56.745,4.055),(56.915,4.055),(56.915,3.885),(56.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,24.285),(13.885,24.455),(14.055,24.455),(14.055,24.285),(13.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,24.625),(13.885,24.795),(14.055,24.795),(14.055,24.625),(13.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,29.385),(23.145,29.555),(23.315,29.555),(23.315,29.385),(23.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,29.725),(23.145,29.895),(23.315,29.895),(23.315,29.725),(23.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,29.725),(23.485,29.895),(23.655,29.895),(23.655,29.725),(23.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.985),(61.885,9.155),(62.055,9.155),(62.055,8.985),(61.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.685),(33.085,10.855),(33.255,10.855),(33.255,10.685),(33.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.085),(57.085,14.255),(57.255,14.255),(57.255,14.085),(57.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.425),(57.085,14.595),(57.255,14.595),(57.255,14.425),(57.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.765),(57.085,14.935),(57.255,14.935),(57.255,14.765),(57.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.005),(33.085,10.175),(33.255,10.175),(33.255,10.005),(33.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.345),(33.085,10.515),(33.255,10.515),(33.255,10.345),(33.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,31.765),(61.545,31.935),(61.715,31.935),(61.715,31.765),(61.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.885),(32.745,4.055),(32.915,4.055),(32.915,3.885),(32.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,31.085),(61.545,31.255),(61.715,31.255),(61.715,31.085),(61.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,31.425),(61.545,31.595),(61.715,31.595),(61.715,31.425),(61.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.225),(51.945,38.395),(52.115,38.395),(52.115,38.225),(51.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.565),(51.945,38.735),(52.115,38.735),(52.115,38.565),(51.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.145),(51.945,34.315),(52.115,34.315),(52.115,34.145),(51.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.485),(51.945,34.655),(52.115,34.655),(52.115,34.485),(51.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.825),(51.945,34.995),(52.115,34.995),(52.115,34.825),(51.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.625),(71.485,7.795),(71.655,7.795),(71.655,7.625),(71.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.285),(71.145,7.455),(71.315,7.455),(71.315,7.285),(71.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.285),(71.485,7.455),(71.655,7.455),(71.655,7.285),(71.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.625),(71.145,7.795),(71.315,7.795),(71.315,7.625),(71.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,28.705),(66.685,28.875),(66.855,28.875),(66.855,28.705),(66.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.305),(42.345,25.475),(42.515,25.475),(42.515,25.305),(42.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.625),(47.145,7.795),(47.315,7.795),(47.315,7.625),(47.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.285),(47.145,7.455),(47.315,7.455),(47.315,7.285),(47.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.285),(47.485,7.455),(47.655,7.455),(47.655,7.285),(47.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.625),(47.485,7.795),(47.655,7.795),(47.655,7.625),(47.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.905),(52.285,5.075),(52.455,5.075),(52.455,4.905),(52.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.305),(51.945,8.475),(52.115,8.475),(52.115,8.305),(51.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.645),(51.945,8.815),(52.115,8.815),(52.115,8.645),(51.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.625),(23.485,7.795),(23.655,7.795),(23.655,7.625),(23.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.285),(23.145,7.455),(23.315,7.455),(23.315,7.285),(23.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.285),(23.485,7.455),(23.655,7.455),(23.655,7.285),(23.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.725),(37.545,29.895),(37.715,29.895),(37.715,29.725),(37.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.625),(23.145,7.795),(23.315,7.795),(23.315,7.625),(23.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.045),(37.545,29.215),(37.715,29.215),(37.715,29.045),(37.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.385),(37.545,29.555),(37.715,29.555),(37.715,29.385),(37.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,23.945),(61.885,24.115),(62.055,24.115),(62.055,23.945),(61.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,21.905),(75.945,22.075),(76.115,22.075),(76.115,21.905),(75.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.925),(47.145,23.095),(47.315,23.095),(47.315,22.925),(47.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.925),(47.485,23.095),(47.655,23.095),(47.655,22.925),(47.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,23.945),(80.745,24.115),(80.915,24.115),(80.915,23.945),(80.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.305),(9.085,8.475),(9.255,8.475),(9.255,8.305),(9.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.645),(9.085,8.815),(9.255,8.815),(9.255,8.645),(9.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.885),(66.345,4.055),(66.515,4.055),(66.515,3.885),(66.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.665),(75.945,9.835),(76.115,9.835),(76.115,9.665),(75.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.325),(75.945,9.495),(76.115,9.495),(76.115,9.325),(75.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.885),(66.685,4.055),(66.855,4.055),(66.855,3.885),(66.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,39.925),(71.145,40.095),(71.315,40.095),(71.315,39.925),(71.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,39.925),(71.485,40.095),(71.655,40.095),(71.655,39.925),(71.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,38.225),(18.345,38.395),(18.515,38.395),(18.515,38.225),(18.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,38.225),(18.685,38.395),(18.855,38.395),(18.855,38.225),(18.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,38.565),(18.685,38.735),(18.855,38.735),(18.855,38.565),(18.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,25.305),(8.745,25.475),(8.915,25.475),(8.915,25.305),(8.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,25.645),(8.745,25.815),(8.915,25.815),(8.915,25.645),(8.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,38.565),(18.345,38.735),(18.515,38.735),(18.515,38.565),(18.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,23.265),(13.885,23.435),(14.055,23.435),(14.055,23.265),(13.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,23.605),(13.885,23.775),(14.055,23.775),(14.055,23.605),(13.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.925),(33.085,40.095),(33.255,40.095),(33.255,39.925),(33.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.625),(18.345,7.795),(18.515,7.795),(18.515,7.625),(18.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.285),(18.345,7.455),(18.515,7.455),(18.515,7.285),(18.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.285),(18.685,7.455),(18.855,7.455),(18.855,7.285),(18.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.625),(18.685,7.795),(18.855,7.795),(18.855,7.625),(18.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,39.925),(80.745,40.095),(80.915,40.095),(80.915,39.925),(80.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.585),(37.885,22.755),(38.055,22.755),(38.055,22.585),(37.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.245),(37.885,22.415),(38.055,22.415),(38.055,22.245),(37.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.285),(76.285,7.455),(76.455,7.455),(76.455,7.285),(76.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.625),(76.285,7.795),(76.455,7.795),(76.455,7.625),(76.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.845),(56.745,19.015),(56.915,19.015),(56.915,18.845),(56.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.345),(18.685,10.515),(18.855,10.515),(18.855,10.345),(18.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.065),(66.345,13.235),(66.515,13.235),(66.515,13.065),(66.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.065),(66.685,13.235),(66.855,13.235),(66.855,13.065),(66.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.405),(66.345,13.575),(66.515,13.575),(66.515,13.405),(66.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.405),(66.685,13.575),(66.855,13.575),(66.855,13.405),(66.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.745),(66.345,13.915),(66.515,13.915),(66.515,13.745),(66.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.745),(66.685,13.915),(66.855,13.915),(66.855,13.745),(66.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.125),(42.345,16.295),(42.515,16.295),(42.515,16.125),(42.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.125),(42.685,16.295),(42.855,16.295),(42.855,16.125),(42.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.465),(42.345,16.635),(42.515,16.635),(42.515,16.465),(42.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.465),(42.685,16.635),(42.855,16.635),(42.855,16.465),(42.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.805),(42.345,16.975),(42.515,16.975),(42.515,16.805),(42.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.925),(61.545,6.095),(61.715,6.095),(61.715,5.925),(61.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.805),(42.685,16.975),(42.855,16.975),(42.855,16.805),(42.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.425),(37.545,14.595),(37.715,14.595),(37.715,14.425),(37.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.925),(13.545,6.095),(13.715,6.095),(13.715,5.925),(13.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.805),(57.085,16.975),(57.255,16.975),(57.255,16.805),(57.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.125),(57.085,16.295),(57.255,16.295),(57.255,16.125),(57.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,26.665),(56.745,26.835),(56.915,26.835),(56.915,26.665),(56.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.925),(52.285,6.095),(52.455,6.095),(52.455,5.925),(52.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.465),(57.085,16.635),(57.255,16.635),(57.255,16.465),(57.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,26.325),(56.745,26.495),(56.915,26.495),(56.915,26.325),(56.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,32.105),(8.745,32.275),(8.915,32.275),(8.915,32.105),(8.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,32.445),(8.745,32.615),(8.915,32.615),(8.915,32.445),(8.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,32.785),(8.745,32.955),(8.915,32.955),(8.915,32.785),(8.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.005),(75.945,10.175),(76.115,10.175),(76.115,10.005),(75.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.345),(75.945,10.515),(76.115,10.515),(76.115,10.345),(75.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.685),(75.945,10.855),(76.115,10.855),(76.115,10.685),(75.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.745),(47.145,30.915),(47.315,30.915),(47.315,30.745),(47.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.745),(47.485,30.915),(47.655,30.915),(47.655,30.745),(47.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.325),(42.345,9.495),(42.515,9.495),(42.515,9.325),(42.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.325),(42.685,9.495),(42.855,9.495),(42.855,9.325),(42.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.665),(42.345,9.835),(42.515,9.835),(42.515,9.665),(42.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.665),(42.685,9.835),(42.855,9.835),(42.855,9.665),(42.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.705),(76.285,11.875),(76.455,11.875),(76.455,11.705),(76.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.185),(52.285,19.355),(52.455,19.355),(52.455,19.185),(52.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.525),(52.285,19.695),(52.455,19.695),(52.455,19.525),(52.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,27.345),(13.885,27.515),(14.055,27.515),(14.055,27.345),(13.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,38.905),(76.285,39.075),(76.455,39.075),(76.455,38.905),(76.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,27.005),(13.885,27.175),(14.055,27.175),(14.055,27.005),(13.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,27.685),(13.885,27.855),(14.055,27.855),(14.055,27.685),(13.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.025),(76.285,11.195),(76.455,11.195),(76.455,11.025),(76.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.365),(76.285,11.535),(76.455,11.535),(76.455,11.365),(76.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.105),(42.345,32.275),(42.515,32.275),(42.515,32.105),(42.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.765),(71.145,14.935),(71.315,14.935),(71.315,14.765),(71.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.765),(71.485,14.935),(71.655,14.935),(71.655,14.765),(71.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.085),(71.145,14.255),(71.315,14.255),(71.315,14.085),(71.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.085),(71.485,14.255),(71.655,14.255),(71.655,14.085),(71.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,35.165),(76.285,35.335),(76.455,35.335),(76.455,35.165),(76.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.285),(61.545,7.455),(61.715,7.455),(61.715,7.285),(61.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.625),(61.545,7.795),(61.715,7.795),(61.715,7.625),(61.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,2.865),(23.145,3.035),(23.315,3.035),(23.315,2.865),(23.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,2.865),(23.485,3.035),(23.655,3.035),(23.655,2.865),(23.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.345),(27.945,10.515),(28.115,10.515),(28.115,10.345),(27.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.005),(27.945,10.175),(28.115,10.175),(28.115,10.005),(27.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.685),(27.945,10.855),(28.115,10.855),(28.115,10.685),(27.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,28.705),(23.145,28.875),(23.315,28.875),(23.315,28.705),(23.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.165),(47.145,18.335),(47.315,18.335),(47.315,18.165),(47.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.165),(47.485,18.335),(47.655,18.335),(47.655,18.165),(47.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.505),(47.145,18.675),(47.315,18.675),(47.315,18.505),(47.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.505),(47.485,18.675),(47.655,18.675),(47.655,18.505),(47.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.285),(13.545,7.455),(13.715,7.455),(13.715,7.285),(13.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.625),(13.545,7.795),(13.715,7.795),(13.715,7.625),(13.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.845),(57.085,19.015),(57.255,19.015),(57.255,18.845),(57.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,31.085),(13.885,31.255),(14.055,31.255),(14.055,31.085),(13.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,31.425),(13.885,31.595),(14.055,31.595),(14.055,31.425),(13.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,31.765),(13.885,31.935),(14.055,31.935),(14.055,31.765),(13.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.225),(18.345,4.395),(18.515,4.395),(18.515,4.225),(18.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.225),(18.685,4.395),(18.855,4.395),(18.855,4.225),(18.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.565),(18.345,4.735),(18.515,4.735),(18.515,4.565),(18.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.565),(18.685,4.735),(18.855,4.735),(18.855,4.565),(18.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,35.845),(81.085,36.015),(81.255,36.015),(81.255,35.845),(81.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,21.225),(81.085,21.395),(81.255,21.395),(81.255,21.225),(81.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.505),(37.545,18.675),(37.715,18.675),(37.715,18.505),(37.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.165),(37.545,18.335),(37.715,18.335),(37.715,18.165),(37.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.145),(13.545,17.315),(13.715,17.315),(13.715,17.145),(13.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.485),(13.545,17.655),(13.715,17.655),(13.715,17.485),(13.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.825),(13.545,17.995),(13.715,17.995),(13.715,17.825),(13.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.945),(81.085,7.115),(81.255,7.115),(81.255,6.945),(81.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,2.865),(66.345,3.035),(66.515,3.035),(66.515,2.865),(66.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,2.865),(66.685,3.035),(66.855,3.035),(66.855,2.865),(66.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.245),(37.545,22.415),(37.715,22.415),(37.715,22.245),(37.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.585),(37.545,22.755),(37.715,22.755),(37.715,22.585),(37.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.065),(18.345,13.235),(18.515,13.235),(18.515,13.065),(18.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.405),(18.345,13.575),(18.515,13.575),(18.515,13.405),(18.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.765),(33.085,31.935),(33.255,31.935),(33.255,31.765),(33.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.065),(18.685,13.235),(18.855,13.235),(18.855,13.065),(18.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.085),(33.085,31.255),(33.255,31.255),(33.255,31.085),(33.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.425),(33.085,31.595),(33.255,31.595),(33.255,31.425),(33.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.745),(18.345,13.915),(18.515,13.915),(18.515,13.745),(18.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.745),(18.685,13.915),(18.855,13.915),(18.855,13.745),(18.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.405),(18.685,13.575),(18.855,13.575),(18.855,13.405),(18.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.965),(56.745,25.135),(56.915,25.135),(56.915,24.965),(56.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.565),(51.945,21.735),(52.115,21.735),(52.115,21.565),(51.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.225),(51.945,21.395),(52.115,21.395),(52.115,21.225),(51.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.885),(76.285,4.055),(76.455,4.055),(76.455,3.885),(76.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.425),(33.085,14.595),(33.255,14.595),(33.255,14.425),(33.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.305),(57.085,8.475),(57.255,8.475),(57.255,8.305),(57.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.645),(57.085,8.815),(57.255,8.815),(57.255,8.645),(57.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,20.205),(61.545,20.375),(61.715,20.375),(61.715,20.205),(61.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,20.545),(61.545,20.715),(61.715,20.715),(61.715,20.545),(61.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.265),(52.285,23.435),(52.455,23.435),(52.455,23.265),(52.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.605),(52.285,23.775),(52.455,23.775),(52.455,23.605),(52.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.105),(42.685,32.275),(42.855,32.275),(42.855,32.105),(42.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,26.325),(80.745,26.495),(80.915,26.495),(80.915,26.325),(80.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,26.665),(80.745,26.835),(80.915,26.835),(80.915,26.665),(80.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.145),(51.945,17.315),(52.115,17.315),(52.115,17.145),(51.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.485),(51.945,17.655),(52.115,17.655),(52.115,17.485),(51.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.825),(51.945,17.995),(52.115,17.995),(52.115,17.825),(51.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,26.325),(57.085,26.495),(57.255,26.495),(57.255,26.325),(57.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,26.665),(57.085,26.835),(57.255,26.835),(57.255,26.665),(57.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.225),(42.345,4.395),(42.515,4.395),(42.515,4.225),(42.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.225),(42.685,4.395),(42.855,4.395),(42.855,4.225),(42.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.785),(37.545,32.955),(37.715,32.955),(37.715,32.785),(37.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.565),(42.345,4.735),(42.515,4.735),(42.515,4.565),(42.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.685),(81.085,10.855),(81.255,10.855),(81.255,10.685),(81.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.005),(81.085,10.175),(81.255,10.175),(81.255,10.005),(81.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,37.205),(9.085,37.375),(9.255,37.375),(9.255,37.205),(9.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,37.545),(9.085,37.715),(9.255,37.715),(9.255,37.545),(9.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.085),(37.545,31.255),(37.715,31.255),(37.715,31.085),(37.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.425),(37.545,31.595),(37.715,31.595),(37.715,31.425),(37.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.345),(81.085,10.515),(81.255,10.515),(81.255,10.345),(81.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.885),(80.745,4.055),(80.915,4.055),(80.915,3.885),(80.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.765),(37.545,31.935),(37.715,31.935),(37.715,31.765),(37.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.945),(57.085,24.115),(57.255,24.115),(57.255,23.945),(57.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.545),(51.945,3.715),(52.115,3.715),(52.115,3.545),(51.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.205),(51.945,3.375),(52.115,3.375),(52.115,3.205),(51.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,22.245),(9.085,22.415),(9.255,22.415),(9.255,22.245),(9.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,22.585),(9.085,22.755),(9.255,22.755),(9.255,22.585),(9.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,25.305),(61.885,25.475),(62.055,25.475),(62.055,25.305),(61.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,25.645),(61.885,25.815),(62.055,25.815),(62.055,25.645),(61.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,37.205),(71.485,37.375),(71.655,37.375),(71.655,37.205),(71.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,37.545),(71.145,37.715),(71.315,37.715),(71.315,37.545),(71.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.745),(33.085,13.915),(33.255,13.915),(33.255,13.745),(33.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,37.545),(71.485,37.715),(71.655,37.715),(71.655,37.545),(71.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,37.205),(71.145,37.375),(71.315,37.375),(71.315,37.205),(71.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.825),(76.285,17.995),(76.455,17.995),(76.455,17.825),(76.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,30.065),(8.745,30.235),(8.915,30.235),(8.915,30.065),(8.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,30.405),(8.745,30.575),(8.915,30.575),(8.915,30.405),(8.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,21.225),(13.545,21.395),(13.715,21.395),(13.715,21.225),(13.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,21.565),(13.545,21.735),(13.715,21.735),(13.715,21.565),(13.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,30.745),(8.745,30.915),(8.915,30.915),(8.915,30.745),(8.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,2.865),(13.545,3.035),(13.715,3.035),(13.715,2.865),(13.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.905),(56.745,22.075),(56.915,22.075),(56.915,21.905),(56.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,21.225),(76.285,21.395),(76.455,21.395),(76.455,21.225),(76.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,21.565),(76.285,21.735),(76.455,21.735),(76.455,21.565),(76.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,35.845),(23.485,36.015),(23.655,36.015),(23.655,35.845),(23.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,35.845),(23.145,36.015),(23.315,36.015),(23.315,35.845),(23.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,25.985),(66.345,26.155),(66.515,26.155),(66.515,25.985),(66.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,25.985),(66.685,26.155),(66.855,26.155),(66.855,25.985),(66.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.785),(42.345,32.955),(42.515,32.955),(42.515,32.785),(42.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.785),(42.685,32.955),(42.855,32.955),(42.855,32.785),(42.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,24.285),(61.545,24.455),(61.715,24.455),(61.715,24.285),(61.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,29.385),(61.885,29.555),(62.055,29.555),(62.055,29.385),(61.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,29.045),(61.885,29.215),(62.055,29.215),(62.055,29.045),(61.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,24.625),(61.545,24.795),(61.715,24.795),(61.715,24.625),(61.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.185),(71.145,19.355),(71.315,19.355),(71.315,19.185),(71.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.185),(71.485,19.355),(71.655,19.355),(71.655,19.185),(71.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.525),(71.145,19.695),(71.315,19.695),(71.315,19.525),(71.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.525),(71.485,19.695),(71.655,19.695),(71.655,19.525),(71.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.865),(47.145,37.035),(47.315,37.035),(47.315,36.865),(47.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,29.725),(61.885,29.895),(62.055,29.895),(62.055,29.725),(61.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,24.965),(27.945,25.135),(28.115,25.135),(28.115,24.965),(27.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,2.865),(18.345,3.035),(18.515,3.035),(18.515,2.865),(18.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,2.865),(18.685,3.035),(18.855,3.035),(18.855,2.865),(18.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,36.865),(23.145,37.035),(23.315,37.035),(23.315,36.865),(23.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,28.365),(66.345,28.535),(66.515,28.535),(66.515,28.365),(66.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,36.865),(23.485,37.035),(23.655,37.035),(23.655,36.865),(23.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,26.665),(52.285,26.835),(52.455,26.835),(52.455,26.665),(52.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,26.325),(52.285,26.495),(52.455,26.495),(52.455,26.325),(52.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.885),(37.545,38.055),(37.715,38.055),(37.715,37.885),(37.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,35.165),(28.285,35.335),(28.455,35.335),(28.455,35.165),(28.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.865),(47.145,3.035),(47.315,3.035),(47.315,2.865),(47.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.865),(47.485,3.035),(47.655,3.035),(47.655,2.865),(47.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.725),(27.945,12.895),(28.115,12.895),(28.115,12.725),(27.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.045),(27.945,12.215),(28.115,12.215),(28.115,12.045),(27.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.385),(27.945,12.555),(28.115,12.555),(28.115,12.385),(27.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,35.505),(28.285,35.675),(28.455,35.675),(28.455,35.505),(28.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.185),(80.745,19.355),(80.915,19.355),(80.915,19.185),(80.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.525),(80.745,19.695),(80.915,19.695),(80.915,19.525),(80.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,28.705),(61.545,28.875),(61.715,28.875),(61.715,28.705),(61.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,28.025),(61.545,28.195),(61.715,28.195),(61.715,28.025),(61.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.285),(66.345,7.455),(66.515,7.455),(66.515,7.285),(66.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.285),(66.685,7.455),(66.855,7.455),(66.855,7.285),(66.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.625),(66.345,7.795),(66.515,7.795),(66.515,7.625),(66.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.625),(66.685,7.795),(66.855,7.795),(66.855,7.625),(66.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,28.365),(61.545,28.535),(61.715,28.535),(61.715,28.365),(61.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.145),(37.885,34.315),(38.055,34.315),(38.055,34.145),(37.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.485),(37.885,34.655),(38.055,34.655),(38.055,34.485),(37.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,26.665),(61.885,26.835),(62.055,26.835),(62.055,26.665),(61.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.825),(37.885,34.995),(38.055,34.995),(38.055,34.825),(37.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,26.325),(61.885,26.495),(62.055,26.495),(62.055,26.325),(61.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.745),(52.285,30.915),(52.455,30.915),(52.455,30.745),(52.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.065),(52.285,30.235),(52.455,30.235),(52.455,30.065),(52.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.405),(52.285,30.575),(52.455,30.575),(52.455,30.405),(52.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.925),(47.485,6.095),(47.655,6.095),(47.655,5.925),(47.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,35.165),(80.745,35.335),(80.915,35.335),(80.915,35.165),(80.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,35.505),(80.745,35.675),(80.915,35.675),(80.915,35.505),(80.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.045),(47.485,29.215),(47.655,29.215),(47.655,29.045),(47.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.385),(47.145,29.555),(47.315,29.555),(47.315,29.385),(47.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.385),(47.485,29.555),(47.655,29.555),(47.655,29.385),(47.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.765),(37.885,14.935),(38.055,14.935),(38.055,14.765),(37.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.045),(47.145,29.215),(47.315,29.215),(47.315,29.045),(47.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.085),(37.885,14.255),(38.055,14.255),(38.055,14.085),(37.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.425),(37.885,14.595),(38.055,14.595),(38.055,14.425),(37.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.185),(81.085,19.355),(81.255,19.355),(81.255,19.185),(81.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,39.245),(81.085,39.415),(81.255,39.415),(81.255,39.245),(81.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,39.585),(81.085,39.755),(81.255,39.755),(81.255,39.585),(81.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.105),(37.545,32.275),(37.715,32.275),(37.715,32.105),(37.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,28.025),(23.145,28.195),(23.315,28.195),(23.315,28.025),(23.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,28.025),(23.485,28.195),(23.655,28.195),(23.655,28.025),(23.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,21.565),(66.345,21.735),(66.515,21.735),(66.515,21.565),(66.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,21.565),(66.685,21.735),(66.855,21.735),(66.855,21.565),(66.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.165),(37.545,35.335),(37.715,35.335),(37.715,35.165),(37.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.505),(37.545,35.675),(37.715,35.675),(37.715,35.505),(37.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,21.225),(66.345,21.395),(66.515,21.395),(66.515,21.225),(66.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,21.225),(66.685,21.395),(66.855,21.395),(66.855,21.225),(66.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,28.365),(23.145,28.535),(23.315,28.535),(23.315,28.365),(23.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,28.365),(23.485,28.535),(23.655,28.535),(23.655,28.365),(23.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,38.905),(23.145,39.075),(23.315,39.075),(23.315,38.905),(23.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.185),(37.545,36.355),(37.715,36.355),(37.715,36.185),(37.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.525),(37.545,36.695),(37.715,36.695),(37.715,36.525),(37.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,30.065),(75.945,30.235),(76.115,30.235),(76.115,30.065),(75.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,30.405),(75.945,30.575),(76.115,30.575),(76.115,30.405),(75.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.305),(27.945,8.475),(28.115,8.475),(28.115,8.305),(27.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.645),(27.945,8.815),(28.115,8.815),(28.115,8.645),(27.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,30.745),(75.945,30.915),(76.115,30.915),(76.115,30.745),(75.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.325),(37.545,9.495),(37.715,9.495),(37.715,9.325),(37.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,22.245),(8.745,22.415),(8.915,22.415),(8.915,22.245),(8.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,22.585),(8.745,22.755),(8.915,22.755),(8.915,22.585),(8.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,29.045),(13.545,29.215),(13.715,29.215),(13.715,29.045),(13.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,29.385),(13.545,29.555),(13.715,29.555),(13.715,29.385),(13.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,29.725),(13.545,29.895),(13.715,29.895),(13.715,29.725),(13.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,25.305),(76.285,25.475),(76.455,25.475),(76.455,25.305),(76.285,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,25.645),(76.285,25.815),(76.455,25.815),(76.455,25.645),(76.285,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.025),(23.485,11.195),(23.655,11.195),(23.655,11.025),(23.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,28.025),(80.745,28.195),(80.915,28.195),(80.915,28.025),(80.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,28.365),(80.745,28.535),(80.915,28.535),(80.915,28.365),(80.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,28.705),(80.745,28.875),(80.915,28.875),(80.915,28.705),(80.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.865),(42.345,3.035),(42.515,3.035),(42.515,2.865),(42.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.865),(42.685,3.035),(42.855,3.035),(42.855,2.865),(42.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,37.885),(23.145,38.055),(23.315,38.055),(23.315,37.885),(23.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,37.885),(23.485,38.055),(23.655,38.055),(23.655,37.885),(23.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,32.105),(18.345,32.275),(18.515,32.275),(18.515,32.105),(18.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,32.105),(18.685,32.275),(18.855,32.275),(18.855,32.105),(18.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.265),(23.145,6.435),(23.315,6.435),(23.315,6.265),(23.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.685),(47.145,10.855),(47.315,10.855),(47.315,10.685),(47.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.685),(47.485,10.855),(47.655,10.855),(47.655,10.685),(47.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,32.445),(18.345,32.615),(18.515,32.615),(18.515,32.445),(18.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,32.445),(18.685,32.615),(18.855,32.615),(18.855,32.445),(18.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.005),(47.145,10.175),(47.315,10.175),(47.315,10.005),(47.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.005),(47.485,10.175),(47.655,10.175),(47.655,10.005),(47.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.345),(47.145,10.515),(47.315,10.515),(47.315,10.345),(47.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.345),(47.485,10.515),(47.655,10.515),(47.655,10.345),(47.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.985),(80.745,9.155),(80.915,9.155),(80.915,8.985),(80.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,22.245),(28.285,22.415),(28.455,22.415),(28.455,22.245),(28.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,22.585),(28.285,22.755),(28.455,22.755),(28.455,22.585),(28.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,36.525),(61.885,36.695),(62.055,36.695),(62.055,36.525),(61.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,36.185),(61.885,36.355),(62.055,36.355),(62.055,36.185),(61.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.125),(32.745,16.295),(32.915,16.295),(32.915,16.125),(32.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.465),(32.745,16.635),(32.915,16.635),(32.915,16.465),(32.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.805),(32.745,16.975),(32.915,16.975),(32.915,16.805),(32.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.885),(42.685,21.055),(42.855,21.055),(42.855,20.885),(42.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.845),(61.885,19.015),(62.055,19.015),(62.055,18.845),(61.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.885),(42.345,21.055),(42.515,21.055),(42.515,20.885),(42.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,32.105),(13.885,32.275),(14.055,32.275),(14.055,32.105),(13.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,32.445),(13.885,32.615),(14.055,32.615),(14.055,32.445),(13.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,32.785),(13.885,32.955),(14.055,32.955),(14.055,32.785),(13.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,20.885),(8.745,21.055),(8.915,21.055),(8.915,20.885),(8.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.225),(66.345,4.395),(66.515,4.395),(66.515,4.225),(66.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.225),(66.685,4.395),(66.855,4.395),(66.855,4.225),(66.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.565),(66.345,4.735),(66.515,4.735),(66.515,4.565),(66.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.565),(66.685,4.735),(66.855,4.735),(66.855,4.565),(66.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.205),(33.085,37.375),(33.255,37.375),(33.255,37.205),(33.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.545),(33.085,37.715),(33.255,37.715),(33.255,37.545),(33.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.825),(47.145,17.995),(47.315,17.995),(47.315,17.825),(47.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.825),(47.485,17.995),(47.655,17.995),(47.655,17.825),(47.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.145),(47.145,17.315),(47.315,17.315),(47.315,17.145),(47.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,2.865),(61.545,3.035),(61.715,3.035),(61.715,2.865),(61.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.145),(47.485,17.315),(47.655,17.315),(47.655,17.145),(47.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.485),(47.145,17.655),(47.315,17.655),(47.315,17.485),(47.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.485),(47.485,17.655),(47.655,17.655),(47.655,17.485),(47.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.585),(61.885,5.755),(62.055,5.755),(62.055,5.585),(61.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.245),(61.885,5.415),(62.055,5.415),(62.055,5.245),(61.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,22.925),(75.945,23.095),(76.115,23.095),(76.115,22.925),(75.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.245),(13.885,5.415),(14.055,5.415),(14.055,5.245),(13.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.585),(13.885,5.755),(14.055,5.755),(14.055,5.585),(13.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,21.905),(18.685,22.075),(18.855,22.075),(18.855,21.905),(18.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,21.905),(18.345,22.075),(18.515,22.075),(18.515,21.905),(18.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,23.265),(61.885,23.435),(62.055,23.435),(62.055,23.265),(61.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,26.325),(28.285,26.495),(28.455,26.495),(28.455,26.325),(28.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,26.665),(28.285,26.835),(28.455,26.835),(28.455,26.665),(28.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,20.545),(27.945,20.715),(28.115,20.715),(28.115,20.545),(27.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.225),(37.885,4.395),(38.055,4.395),(38.055,4.225),(37.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.565),(37.885,4.735),(38.055,4.735),(38.055,4.565),(37.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.405),(47.145,30.575),(47.315,30.575),(47.315,30.405),(47.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.945),(42.345,24.115),(42.515,24.115),(42.515,23.945),(42.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.945),(42.685,24.115),(42.855,24.115),(42.855,23.945),(42.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.025),(42.345,28.195),(42.515,28.195),(42.515,28.025),(42.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.025),(42.685,28.195),(42.855,28.195),(42.855,28.025),(42.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.365),(42.345,28.535),(42.515,28.535),(42.515,28.365),(42.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.365),(42.685,28.535),(42.855,28.535),(42.855,28.365),(42.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.705),(42.345,28.875),(42.515,28.875),(42.515,28.705),(42.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.705),(42.685,28.875),(42.855,28.875),(42.855,28.705),(42.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,2.865),(71.145,3.035),(71.315,3.035),(71.315,2.865),(71.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.785),(47.145,32.955),(47.315,32.955),(47.315,32.785),(47.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.785),(47.485,32.955),(47.655,32.955),(47.655,32.785),(47.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.105),(47.145,32.275),(47.315,32.275),(47.315,32.105),(47.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.105),(47.485,32.275),(47.655,32.275),(47.655,32.105),(47.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.445),(47.145,32.615),(47.315,32.615),(47.315,32.445),(47.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.445),(47.485,32.615),(47.655,32.615),(47.655,32.445),(47.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,2.865),(71.485,3.035),(71.655,3.035),(71.655,2.865),(71.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,28.025),(8.745,28.195),(8.915,28.195),(8.915,28.025),(8.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,28.365),(8.745,28.535),(8.915,28.535),(8.915,28.365),(8.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,30.065),(28.285,30.235),(28.455,30.235),(28.455,30.065),(28.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,30.405),(28.285,30.575),(28.455,30.575),(28.455,30.405),(28.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,28.705),(8.745,28.875),(8.915,28.875),(8.915,28.705),(8.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,30.745),(28.285,30.915),(28.455,30.915),(28.455,30.745),(28.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,29.385),(71.485,29.555),(71.655,29.555),(71.655,29.385),(71.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.845),(37.885,36.015),(38.055,36.015),(38.055,35.845),(37.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,22.925),(61.885,23.095),(62.055,23.095),(62.055,22.925),(61.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,36.865),(71.485,37.035),(71.655,37.035),(71.655,36.865),(71.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,36.865),(71.145,37.035),(71.315,37.035),(71.315,36.865),(71.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.765),(13.885,14.935),(14.055,14.935),(14.055,14.765),(13.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.085),(13.885,14.255),(14.055,14.255),(14.055,14.085),(13.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.425),(13.885,14.595),(14.055,14.595),(14.055,14.425),(13.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.305),(71.145,8.475),(71.315,8.475),(71.315,8.305),(71.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.305),(71.485,8.475),(71.655,8.475),(71.655,8.305),(71.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.645),(71.145,8.815),(71.315,8.815),(71.315,8.645),(71.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.645),(71.485,8.815),(71.655,8.815),(71.655,8.645),(71.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.725),(57.085,29.895),(57.255,29.895),(57.255,29.725),(57.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.045),(57.085,29.215),(57.255,29.215),(57.255,29.045),(57.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.385),(57.085,29.555),(57.255,29.555),(57.255,29.385),(57.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.985),(47.145,26.155),(47.315,26.155),(47.315,25.985),(47.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.985),(47.485,26.155),(47.655,26.155),(47.655,25.985),(47.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,26.325),(61.545,26.495),(61.715,26.495),(61.715,26.325),(61.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,26.665),(61.545,26.835),(61.715,26.835),(61.715,26.665),(61.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.305),(37.885,25.475),(38.055,25.475),(38.055,25.305),(37.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.645),(37.885,25.815),(38.055,25.815),(38.055,25.645),(37.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.305),(23.145,8.475),(23.315,8.475),(23.315,8.305),(23.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.265),(13.545,6.435),(13.715,6.435),(13.715,6.265),(13.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.605),(13.545,6.775),(13.715,6.775),(13.715,6.605),(13.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.285),(52.285,24.455),(52.455,24.455),(52.455,24.285),(52.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.625),(52.285,24.795),(52.455,24.795),(52.455,24.625),(52.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.645),(23.485,8.815),(23.655,8.815),(23.655,8.645),(23.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.885),(37.885,38.055),(38.055,38.055),(38.055,37.885),(37.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.305),(23.485,8.475),(23.655,8.475),(23.655,8.305),(23.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.645),(23.145,8.815),(23.315,8.815),(23.315,8.645),(23.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.725),(47.145,29.895),(47.315,29.895),(47.315,29.725),(47.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.725),(47.485,29.895),(47.655,29.895),(47.655,29.725),(47.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.805),(9.085,16.975),(9.255,16.975),(9.255,16.805),(9.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.125),(9.085,16.295),(9.255,16.295),(9.255,16.125),(9.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.365),(18.685,11.535),(18.855,11.535),(18.855,11.365),(18.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.025),(18.345,11.195),(18.515,11.195),(18.515,11.025),(18.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.025),(18.685,11.195),(18.855,11.195),(18.855,11.025),(18.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.365),(18.345,11.535),(18.515,11.535),(18.515,11.365),(18.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.705),(18.345,11.875),(18.515,11.875),(18.515,11.705),(18.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.705),(18.685,11.875),(18.855,11.875),(18.855,11.705),(18.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.465),(9.085,16.635),(9.255,16.635),(9.255,16.465),(9.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.845),(75.945,19.015),(76.115,19.015),(76.115,18.845),(75.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.225),(37.545,38.395),(37.715,38.395),(37.715,38.225),(37.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,30.405),(61.545,30.575),(61.715,30.575),(61.715,30.405),(61.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,30.065),(61.545,30.235),(61.715,30.235),(61.715,30.065),(61.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.565),(37.545,38.735),(37.715,38.735),(37.715,38.565),(37.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,30.745),(61.545,30.915),(61.715,30.915),(61.715,30.745),(61.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.885),(57.085,38.055),(57.255,38.055),(57.255,37.885),(57.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.285),(37.545,24.455),(37.715,24.455),(37.715,24.285),(37.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.725),(37.885,29.895),(38.055,29.895),(38.055,29.725),(37.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.625),(37.545,24.795),(37.715,24.795),(37.715,24.625),(37.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.045),(37.885,29.215),(38.055,29.215),(38.055,29.045),(37.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.385),(37.885,29.555),(38.055,29.555),(38.055,29.385),(37.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.705),(52.285,28.875),(52.455,28.875),(52.455,28.705),(52.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.025),(52.285,28.195),(52.455,28.195),(52.455,28.025),(52.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.365),(52.285,28.535),(52.455,28.535),(52.455,28.365),(52.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.885),(47.145,38.055),(47.315,38.055),(47.315,37.885),(47.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.885),(47.485,38.055),(47.655,38.055),(47.655,37.885),(47.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.345),(66.345,10.515),(66.515,10.515),(66.515,10.345),(66.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.265),(47.145,6.435),(47.315,6.435),(47.315,6.265),(47.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.865),(47.145,20.035),(47.315,20.035),(47.315,19.865),(47.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.485),(42.685,17.655),(42.855,17.655),(42.855,17.485),(42.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.865),(47.485,20.035),(47.655,20.035),(47.655,19.865),(47.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.145),(42.345,17.315),(42.515,17.315),(42.515,17.145),(42.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.145),(42.685,17.315),(42.855,17.315),(42.855,17.145),(42.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.485),(42.345,17.655),(42.515,17.655),(42.515,17.485),(42.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.265),(47.485,6.435),(47.655,6.435),(47.655,6.265),(47.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.605),(47.145,6.775),(47.315,6.775),(47.315,6.605),(47.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.605),(47.485,6.775),(47.655,6.775),(47.655,6.605),(47.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.825),(42.345,17.995),(42.515,17.995),(42.515,17.825),(42.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.825),(42.685,17.995),(42.855,17.995),(42.855,17.825),(42.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,24.285),(66.345,24.455),(66.515,24.455),(66.515,24.285),(66.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,24.285),(66.685,24.455),(66.855,24.455),(66.855,24.285),(66.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.705),(37.545,28.875),(37.715,28.875),(37.715,28.705),(37.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,24.625),(66.345,24.795),(66.515,24.795),(66.515,24.625),(66.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.025),(37.545,28.195),(37.715,28.195),(37.715,28.025),(37.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.365),(37.545,28.535),(37.715,28.535),(37.715,28.365),(37.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,24.625),(66.685,24.795),(66.855,24.795),(66.855,24.625),(66.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.845),(9.085,19.015),(9.255,19.015),(9.255,18.845),(9.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,35.845),(61.545,36.015),(61.715,36.015),(61.715,35.845),(61.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,26.325),(37.885,26.495),(38.055,26.495),(38.055,26.325),(37.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,26.665),(37.885,26.835),(38.055,26.835),(38.055,26.665),(37.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,36.865),(81.085,37.035),(81.255,37.035),(81.255,36.865),(81.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,35.165),(71.145,35.335),(71.315,35.335),(71.315,35.165),(71.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.085),(51.945,31.255),(52.115,31.255),(52.115,31.085),(51.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.425),(51.945,31.595),(52.115,31.595),(52.115,31.425),(51.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,35.505),(71.145,35.675),(71.315,35.675),(71.315,35.505),(71.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,35.505),(71.485,35.675),(71.655,35.675),(71.655,35.505),(71.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.765),(51.945,31.935),(52.115,31.935),(52.115,31.765),(51.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,35.165),(71.485,35.335),(71.655,35.335),(71.655,35.165),(71.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.245),(57.085,39.415),(57.255,39.415),(57.255,39.245),(57.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.585),(57.085,39.755),(57.255,39.755),(57.255,39.585),(57.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,30.745),(18.345,30.915),(18.515,30.915),(18.515,30.745),(18.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,31.085),(13.545,31.255),(13.715,31.255),(13.715,31.085),(13.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,31.425),(13.545,31.595),(13.715,31.595),(13.715,31.425),(13.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,31.765),(13.545,31.935),(13.715,31.935),(13.715,31.765),(13.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.525),(57.085,36.695),(57.255,36.695),(57.255,36.525),(57.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.185),(57.085,36.355),(57.255,36.355),(57.255,36.185),(57.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.225),(57.085,21.395),(57.255,21.395),(57.255,21.225),(57.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.685),(51.945,27.855),(52.115,27.855),(52.115,27.685),(51.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,36.865),(18.685,37.035),(18.855,37.035),(18.855,36.865),(18.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.565),(57.085,21.735),(57.255,21.735),(57.255,21.565),(57.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,30.065),(18.685,30.235),(18.855,30.235),(18.855,30.065),(18.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,30.405),(18.685,30.575),(18.855,30.575),(18.855,30.405),(18.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.785),(52.285,32.955),(52.455,32.955),(52.455,32.785),(52.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,30.065),(18.345,30.235),(18.515,30.235),(18.515,30.065),(18.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,30.405),(18.345,30.575),(18.515,30.575),(18.515,30.405),(18.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.105),(52.285,32.275),(52.455,32.275),(52.455,32.105),(52.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.445),(52.285,32.615),(52.455,32.615),(52.455,32.445),(52.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,23.945),(76.285,24.115),(76.455,24.115),(76.455,23.945),(76.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.985),(33.085,26.155),(33.255,26.155),(33.255,25.985),(33.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.405),(32.745,30.575),(32.915,30.575),(32.915,30.405),(32.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.245),(80.745,5.415),(80.915,5.415),(80.915,5.245),(80.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.745),(32.745,30.915),(32.915,30.915),(32.915,30.745),(32.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.065),(32.745,30.235),(32.915,30.235),(32.915,30.065),(32.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.305),(56.745,8.475),(56.915,8.475),(56.915,8.305),(56.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.645),(56.745,8.815),(56.915,8.815),(56.915,8.645),(56.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.565),(42.685,21.735),(42.855,21.735),(42.855,21.565),(42.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,32.785),(18.685,32.955),(18.855,32.955),(18.855,32.785),(18.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,20.205),(13.545,20.375),(13.715,20.375),(13.715,20.205),(13.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,20.545),(13.545,20.715),(13.715,20.715),(13.715,20.545),(13.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,23.945),(13.885,24.115),(14.055,24.115),(14.055,23.945),(13.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.905),(57.085,39.075),(57.255,39.075),(57.255,38.905),(57.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,32.105),(66.345,32.275),(66.515,32.275),(66.515,32.105),(66.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,32.105),(66.685,32.275),(66.855,32.275),(66.855,32.105),(66.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,32.445),(66.345,32.615),(66.515,32.615),(66.515,32.445),(66.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,32.445),(66.685,32.615),(66.855,32.615),(66.855,32.445),(66.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,32.785),(66.345,32.955),(66.515,32.955),(66.515,32.785),(66.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,32.785),(66.685,32.955),(66.855,32.955),(66.855,32.785),(66.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.905),(37.885,39.075),(38.055,39.075),(38.055,38.905),(37.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.305),(8.745,8.475),(8.915,8.475),(8.915,8.305),(8.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.645),(8.745,8.815),(8.915,8.815),(8.915,8.645),(8.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,39.925),(61.545,40.095),(61.715,40.095),(61.715,39.925),(61.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,26.325),(9.085,26.495),(9.255,26.495),(9.255,26.325),(9.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,26.665),(9.085,26.835),(9.255,26.835),(9.255,26.665),(9.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.725),(75.945,12.895),(76.115,12.895),(76.115,12.725),(75.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.045),(75.945,12.215),(76.115,12.215),(76.115,12.045),(75.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.385),(75.945,12.555),(76.115,12.555),(76.115,12.385),(75.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,37.885),(81.085,38.055),(81.255,38.055),(81.255,37.885),(81.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.605),(66.685,6.775),(66.855,6.775),(66.855,6.605),(66.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.085),(61.885,14.255),(62.055,14.255),(62.055,14.085),(61.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.425),(61.885,14.595),(62.055,14.595),(62.055,14.425),(61.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.725),(33.085,29.895),(33.255,29.895),(33.255,29.725),(33.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.765),(61.885,14.935),(62.055,14.935),(62.055,14.765),(61.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.185),(27.945,19.355),(28.115,19.355),(28.115,19.185),(27.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.525),(27.945,19.695),(28.115,19.695),(28.115,19.525),(27.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.845),(8.745,19.015),(8.915,19.015),(8.915,18.845),(8.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.265),(61.545,6.435),(61.715,6.435),(61.715,6.265),(61.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.605),(61.545,6.775),(61.715,6.775),(61.715,6.605),(61.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,24.285),(28.285,24.455),(28.455,24.455),(28.455,24.285),(28.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,24.625),(28.285,24.795),(28.455,24.795),(28.455,24.625),(28.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,21.905),(8.745,22.075),(8.915,22.075),(8.915,21.905),(8.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.245),(52.285,5.415),(52.455,5.415),(52.455,5.245),(52.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.585),(52.285,5.755),(52.455,5.755),(52.455,5.585),(52.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,40.265),(81.085,40.435),(81.255,40.435),(81.255,40.265),(81.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,40.605),(81.085,40.775),(81.255,40.775),(81.255,40.605),(81.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.065),(81.085,13.235),(81.255,13.235),(81.255,13.065),(81.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.405),(81.085,13.575),(81.255,13.575),(81.255,13.405),(81.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.745),(81.085,13.915),(81.255,13.915),(81.255,13.745),(81.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,33.125),(13.545,33.295),(13.715,33.295),(13.715,33.125),(13.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.045),(81.085,12.215),(81.255,12.215),(81.255,12.045),(81.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.385),(81.085,12.555),(81.255,12.555),(81.255,12.385),(81.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,33.465),(13.545,33.635),(13.715,33.635),(13.715,33.465),(13.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.725),(81.085,12.895),(81.255,12.895),(81.255,12.725),(81.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,33.805),(13.545,33.975),(13.715,33.975),(13.715,33.805),(13.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,24.285),(13.545,24.455),(13.715,24.455),(13.715,24.285),(13.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.125),(51.945,16.295),(52.115,16.295),(52.115,16.125),(51.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.465),(51.945,16.635),(52.115,16.635),(52.115,16.465),(51.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.805),(51.945,16.975),(52.115,16.975),(52.115,16.805),(51.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.305),(75.945,8.475),(76.115,8.475),(76.115,8.305),(75.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.645),(75.945,8.815),(76.115,8.815),(76.115,8.645),(75.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,24.625),(13.545,24.795),(13.715,24.795),(13.715,24.625),(13.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.285),(8.745,7.455),(8.915,7.455),(8.915,7.285),(8.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.625),(8.745,7.795),(8.915,7.795),(8.915,7.625),(8.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,34.145),(27.945,34.315),(28.115,34.315),(28.115,34.145),(27.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,28.705),(28.285,28.875),(28.455,28.875),(28.455,28.705),(28.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,34.485),(27.945,34.655),(28.115,34.655),(28.115,34.485),(27.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,33.805),(9.085,33.975),(9.255,33.975),(9.255,33.805),(9.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,31.425),(23.145,31.595),(23.315,31.595),(23.315,31.425),(23.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,31.085),(23.145,31.255),(23.315,31.255),(23.315,31.085),(23.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,31.085),(23.485,31.255),(23.655,31.255),(23.655,31.085),(23.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,31.425),(23.485,31.595),(23.655,31.595),(23.655,31.425),(23.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,31.765),(23.145,31.935),(23.315,31.935),(23.315,31.765),(23.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,34.825),(27.945,34.995),(28.115,34.995),(28.115,34.825),(27.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,26.325),(8.745,26.495),(8.915,26.495),(8.915,26.325),(8.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,31.765),(23.485,31.935),(23.655,31.935),(23.655,31.765),(23.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,33.125),(9.085,33.295),(9.255,33.295),(9.255,33.125),(9.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,35.165),(61.885,35.335),(62.055,35.335),(62.055,35.165),(61.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,35.505),(61.885,35.675),(62.055,35.675),(62.055,35.505),(61.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.685),(52.285,27.855),(52.455,27.855),(52.455,27.685),(52.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.005),(52.285,27.175),(52.455,27.175),(52.455,27.005),(52.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.345),(52.285,27.515),(52.455,27.515),(52.455,27.345),(52.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.765),(57.085,31.935),(57.255,31.935),(57.255,31.765),(57.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.425),(57.085,31.595),(57.255,31.595),(57.255,31.425),(57.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.085),(57.085,31.255),(57.255,31.255),(57.255,31.085),(57.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.265),(71.145,6.435),(71.315,6.435),(71.315,6.265),(71.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.265),(71.485,6.435),(71.655,6.435),(71.655,6.265),(71.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.605),(71.145,6.775),(71.315,6.775),(71.315,6.605),(71.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.605),(71.485,6.775),(71.655,6.775),(71.655,6.605),(71.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,28.705),(13.545,28.875),(13.715,28.875),(13.715,28.705),(13.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,28.025),(13.545,28.195),(13.715,28.195),(13.715,28.025),(13.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,28.365),(13.545,28.535),(13.715,28.535),(13.715,28.365),(13.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,26.665),(13.885,26.835),(14.055,26.835),(14.055,26.665),(13.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,26.325),(13.885,26.495),(14.055,26.495),(14.055,26.325),(13.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.065),(33.085,30.235),(33.255,30.235),(33.255,30.065),(33.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.405),(33.085,30.575),(33.255,30.575),(33.255,30.405),(33.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.745),(33.085,30.915),(33.255,30.915),(33.255,30.745),(33.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,31.765),(27.945,31.935),(28.115,31.935),(28.115,31.765),(27.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,31.085),(27.945,31.255),(28.115,31.255),(28.115,31.085),(27.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.185),(51.945,19.355),(52.115,19.355),(52.115,19.185),(51.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,31.425),(27.945,31.595),(28.115,31.595),(28.115,31.425),(27.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.905),(33.085,22.075),(33.255,22.075),(33.255,21.905),(33.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.025),(32.745,11.195),(32.915,11.195),(32.915,11.025),(32.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.365),(32.745,11.535),(32.915,11.535),(32.915,11.365),(32.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,35.845),(76.285,36.015),(76.455,36.015),(76.455,35.845),(76.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.705),(32.745,11.875),(32.915,11.875),(32.915,11.705),(32.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.805),(56.745,33.975),(56.915,33.975),(56.915,33.805),(56.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.125),(56.745,33.295),(56.915,33.295),(56.915,33.125),(56.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.465),(56.745,33.635),(56.915,33.635),(56.915,33.465),(56.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,21.905),(23.145,22.075),(23.315,22.075),(23.315,21.905),(23.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,21.905),(23.485,22.075),(23.655,22.075),(23.655,21.905),(23.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,38.905),(8.745,39.075),(8.915,39.075),(8.915,38.905),(8.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.125),(32.745,33.295),(32.915,33.295),(32.915,33.125),(32.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.805),(32.745,33.975),(32.915,33.975),(32.915,33.805),(32.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,26.325),(37.545,26.495),(37.715,26.495),(37.715,26.325),(37.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,26.665),(37.545,26.835),(37.715,26.835),(37.715,26.665),(37.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.465),(32.745,33.635),(32.915,33.635),(32.915,33.465),(32.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,27.685),(27.945,27.855),(28.115,27.855),(28.115,27.685),(27.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,27.005),(27.945,27.175),(28.115,27.175),(28.115,27.005),(27.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,27.345),(27.945,27.515),(28.115,27.515),(28.115,27.345),(27.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.865),(61.545,20.035),(61.715,20.035),(61.715,19.865),(61.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.225),(33.085,38.395),(33.255,38.395),(33.255,38.225),(33.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.565),(33.085,38.735),(33.255,38.735),(33.255,38.565),(33.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.365),(66.345,11.535),(66.515,11.535),(66.515,11.365),(66.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.025),(66.345,11.195),(66.515,11.195),(66.515,11.025),(66.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.025),(66.685,11.195),(66.855,11.195),(66.855,11.025),(66.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.705),(66.345,11.875),(66.515,11.875),(66.515,11.705),(66.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.705),(66.685,11.875),(66.855,11.875),(66.855,11.705),(66.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.365),(66.685,11.535),(66.855,11.535),(66.855,11.365),(66.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,38.225),(9.085,38.395),(9.255,38.395),(9.255,38.225),(9.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,38.565),(9.085,38.735),(9.255,38.735),(9.255,38.565),(9.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,26.325),(42.685,26.495),(42.855,26.495),(42.855,26.325),(42.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,26.665),(42.685,26.835),(42.855,26.835),(42.855,26.665),(42.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.745),(37.545,30.915),(37.715,30.915),(37.715,30.745),(37.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,26.665),(42.345,26.835),(42.515,26.835),(42.515,26.665),(42.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,26.325),(42.345,26.495),(42.515,26.495),(42.515,26.325),(42.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,40.265),(27.945,40.435),(28.115,40.435),(28.115,40.265),(27.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,40.605),(27.945,40.775),(28.115,40.775),(28.115,40.605),(27.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.265),(33.085,23.435),(33.255,23.435),(33.255,23.265),(33.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.605),(33.085,23.775),(33.255,23.775),(33.255,23.605),(33.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.065),(37.545,30.235),(37.715,30.235),(37.715,30.065),(37.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.405),(37.545,30.575),(37.715,30.575),(37.715,30.405),(37.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,24.965),(8.745,25.135),(8.915,25.135),(8.915,24.965),(8.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.045),(51.945,29.215),(52.115,29.215),(52.115,29.045),(51.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.385),(51.945,29.555),(52.115,29.555),(52.115,29.385),(51.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.725),(51.945,29.895),(52.115,29.895),(52.115,29.725),(51.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.725),(33.085,12.895),(33.255,12.895),(33.255,12.725),(33.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.045),(33.085,12.215),(33.255,12.215),(33.255,12.045),(33.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,38.225),(80.745,38.395),(80.915,38.395),(80.915,38.225),(80.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,38.565),(80.745,38.735),(80.915,38.735),(80.915,38.565),(80.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.385),(33.085,12.555),(33.255,12.555),(33.255,12.385),(33.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,24.625),(80.745,24.795),(80.915,24.795),(80.915,24.625),(80.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,24.285),(80.745,24.455),(80.915,24.455),(80.915,24.285),(80.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.585),(47.485,5.755),(47.655,5.755),(47.655,5.585),(47.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.585),(47.145,5.755),(47.315,5.755),(47.315,5.585),(47.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.845),(13.885,19.015),(14.055,19.015),(14.055,18.845),(13.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.245),(47.485,5.415),(47.655,5.415),(47.655,5.245),(47.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.245),(47.145,5.415),(47.315,5.415),(47.315,5.245),(47.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.365),(47.145,11.535),(47.315,11.535),(47.315,11.365),(47.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.365),(47.485,11.535),(47.655,11.535),(47.655,11.365),(47.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.245),(23.485,5.415),(23.655,5.415),(23.655,5.245),(23.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.585),(23.145,5.755),(23.315,5.755),(23.315,5.585),(23.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.285),(75.945,7.455),(76.115,7.455),(76.115,7.285),(75.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.625),(75.945,7.795),(76.115,7.795),(76.115,7.625),(75.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.585),(23.485,5.755),(23.655,5.755),(23.655,5.585),(23.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.245),(23.145,5.415),(23.315,5.415),(23.315,5.245),(23.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.305),(51.945,25.475),(52.115,25.475),(52.115,25.305),(51.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.645),(51.945,25.815),(52.115,25.815),(52.115,25.645),(51.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.065),(8.745,13.235),(8.915,13.235),(8.915,13.065),(8.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.405),(8.745,13.575),(8.915,13.575),(8.915,13.405),(8.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.745),(8.745,13.915),(8.915,13.915),(8.915,13.745),(8.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.885),(51.945,21.055),(52.115,21.055),(52.115,20.885),(51.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.885),(51.945,4.055),(52.115,4.055),(52.115,3.885),(51.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.825),(32.745,17.995),(32.915,17.995),(32.915,17.825),(32.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.565),(76.285,4.735),(76.455,4.735),(76.455,4.565),(76.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.225),(76.285,4.395),(76.455,4.395),(76.455,4.225),(76.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.285),(27.945,7.455),(28.115,7.455),(28.115,7.285),(27.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.625),(27.945,7.795),(28.115,7.795),(28.115,7.625),(27.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,20.205),(75.945,20.375),(76.115,20.375),(76.115,20.205),(75.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,23.945),(61.545,24.115),(61.715,24.115),(61.715,23.945),(61.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,20.545),(75.945,20.715),(76.115,20.715),(76.115,20.545),(75.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,31.085),(81.085,31.255),(81.255,31.255),(81.255,31.085),(81.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,31.425),(81.085,31.595),(81.255,31.595),(81.255,31.425),(81.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.565),(56.745,21.735),(56.915,21.735),(56.915,21.565),(56.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.885),(47.145,21.055),(47.315,21.055),(47.315,20.885),(47.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.885),(47.485,21.055),(47.655,21.055),(47.655,20.885),(47.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,23.945),(9.085,24.115),(9.255,24.115),(9.255,23.945),(9.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.225),(56.745,21.395),(56.915,21.395),(56.915,21.225),(56.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,31.765),(81.085,31.935),(81.255,31.935),(81.255,31.765),(81.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.265),(66.345,6.435),(66.515,6.435),(66.515,6.265),(66.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.265),(66.685,6.435),(66.855,6.435),(66.855,6.265),(66.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.285),(47.145,24.455),(47.315,24.455),(47.315,24.285),(47.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.285),(47.485,24.455),(47.655,24.455),(47.655,24.285),(47.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.225),(28.285,4.395),(28.455,4.395),(28.455,4.225),(28.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.565),(28.285,4.735),(28.455,4.735),(28.455,4.565),(28.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.945),(51.945,7.115),(52.115,7.115),(52.115,6.945),(51.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.625),(47.145,24.795),(47.315,24.795),(47.315,24.625),(47.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.625),(47.485,24.795),(47.655,24.795),(47.655,24.625),(47.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.605),(66.345,6.775),(66.515,6.775),(66.515,6.605),(66.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,25.305),(13.885,25.475),(14.055,25.475),(14.055,25.305),(13.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,25.645),(66.685,25.815),(66.855,25.815),(66.855,25.645),(66.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,25.645),(13.885,25.815),(14.055,25.815),(14.055,25.645),(13.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,25.305),(66.685,25.475),(66.855,25.475),(66.855,25.305),(66.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,36.865),(66.345,37.035),(66.515,37.035),(66.515,36.865),(66.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,36.865),(66.685,37.035),(66.855,37.035),(66.855,36.865),(66.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,25.305),(66.345,25.475),(66.515,25.475),(66.515,25.305),(66.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.325),(80.745,9.495),(80.915,9.495),(80.915,9.325),(80.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,25.645),(66.345,25.815),(66.515,25.815),(66.515,25.645),(66.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.665),(80.745,9.835),(80.915,9.835),(80.915,9.665),(80.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.625),(56.745,7.795),(56.915,7.795),(56.915,7.625),(56.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.285),(56.745,7.455),(56.915,7.455),(56.915,7.285),(56.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,28.365),(66.685,28.535),(66.855,28.535),(66.855,28.365),(66.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.285),(32.745,7.455),(32.915,7.455),(32.915,7.285),(32.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.625),(32.745,7.795),(32.915,7.795),(32.915,7.625),(32.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.025),(47.145,28.195),(47.315,28.195),(47.315,28.025),(47.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.025),(47.485,28.195),(47.655,28.195),(47.655,28.025),(47.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.365),(47.145,28.535),(47.315,28.535),(47.315,28.365),(47.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.365),(47.485,28.535),(47.655,28.535),(47.655,28.365),(47.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.125),(33.085,33.295),(33.255,33.295),(33.255,33.125),(33.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.465),(33.085,33.635),(33.255,33.635),(33.255,33.465),(33.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.805),(33.085,33.975),(33.255,33.975),(33.255,33.805),(33.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.705),(47.145,28.875),(47.315,28.875),(47.315,28.705),(47.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.705),(47.485,28.875),(47.655,28.875),(47.655,28.705),(47.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,32.785),(27.945,32.955),(28.115,32.955),(28.115,32.785),(27.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,29.725),(13.885,29.895),(14.055,29.895),(14.055,29.725),(13.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,32.105),(27.945,32.275),(28.115,32.275),(28.115,32.105),(27.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,32.445),(27.945,32.615),(28.115,32.615),(28.115,32.445),(27.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,29.045),(13.885,29.215),(14.055,29.215),(14.055,29.045),(13.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,29.385),(13.885,29.555),(14.055,29.555),(14.055,29.385),(13.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.165),(42.345,18.335),(42.515,18.335),(42.515,18.165),(42.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.165),(42.685,18.335),(42.855,18.335),(42.855,18.165),(42.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.505),(42.345,18.675),(42.515,18.675),(42.515,18.505),(42.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.505),(42.685,18.675),(42.855,18.675),(42.855,18.505),(42.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.925),(27.945,6.095),(28.115,6.095),(28.115,5.925),(27.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.205),(51.945,37.375),(52.115,37.375),(52.115,37.205),(51.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,24.625),(18.685,24.795),(18.855,24.795),(18.855,24.625),(18.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,24.285),(18.345,24.455),(18.515,24.455),(18.515,24.285),(18.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,24.625),(18.345,24.795),(18.515,24.795),(18.515,24.625),(18.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,24.285),(18.685,24.455),(18.855,24.455),(18.855,24.285),(18.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.545),(51.945,37.715),(52.115,37.715),(52.115,37.545),(51.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.225),(51.945,4.395),(52.115,4.395),(52.115,4.225),(51.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.565),(51.945,4.735),(52.115,4.735),(52.115,4.565),(51.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.445),(9.085,15.615),(9.255,15.615),(9.255,15.445),(9.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,29.725),(71.145,29.895),(71.315,29.895),(71.315,29.725),(71.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,29.725),(71.485,29.895),(71.655,29.895),(71.655,29.725),(71.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,29.045),(71.145,29.215),(71.315,29.215),(71.315,29.045),(71.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.965),(8.745,8.135),(8.915,8.135),(8.915,7.965),(8.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,28.365),(71.485,28.535),(71.655,28.535),(71.655,28.365),(71.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,28.025),(71.145,28.195),(71.315,28.195),(71.315,28.025),(71.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,28.025),(71.485,28.195),(71.655,28.195),(71.655,28.025),(71.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,28.365),(71.145,28.535),(71.315,28.535),(71.315,28.365),(71.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,28.705),(71.145,28.875),(71.315,28.875),(71.315,28.705),(71.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,28.705),(71.485,28.875),(71.655,28.875),(71.655,28.705),(71.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,22.925),(13.885,23.095),(14.055,23.095),(14.055,22.925),(13.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,26.665),(32.745,26.835),(32.915,26.835),(32.915,26.665),(32.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.185),(61.885,19.355),(62.055,19.355),(62.055,19.185),(61.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.525),(61.885,19.695),(62.055,19.695),(62.055,19.525),(61.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.445),(37.545,32.615),(37.715,32.615),(37.715,32.445),(37.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,26.325),(13.545,26.495),(13.715,26.495),(13.715,26.325),(13.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,26.665),(13.545,26.835),(13.715,26.835),(13.715,26.665),(13.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,39.245),(23.145,39.415),(23.315,39.415),(23.315,39.245),(23.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,39.245),(23.485,39.415),(23.655,39.415),(23.655,39.245),(23.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,39.585),(23.485,39.755),(23.655,39.755),(23.655,39.585),(23.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,37.885),(18.345,38.055),(18.515,38.055),(18.515,37.885),(18.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,39.585),(23.145,39.755),(23.315,39.755),(23.315,39.585),(23.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.905),(32.745,39.075),(32.915,39.075),(32.915,38.905),(32.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,37.885),(18.685,38.055),(18.855,38.055),(18.855,37.885),(18.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,36.865),(13.545,37.035),(13.715,37.035),(13.715,36.865),(13.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.805),(61.885,16.975),(62.055,16.975),(62.055,16.805),(61.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.125),(61.885,16.295),(62.055,16.295),(62.055,16.125),(61.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.465),(61.885,16.635),(62.055,16.635),(62.055,16.465),(61.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.125),(47.145,16.295),(47.315,16.295),(47.315,16.125),(47.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.125),(47.485,16.295),(47.655,16.295),(47.655,16.125),(47.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.465),(47.145,16.635),(47.315,16.635),(47.315,16.465),(47.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.465),(47.485,16.635),(47.655,16.635),(47.655,16.465),(47.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.805),(47.145,16.975),(47.315,16.975),(47.315,16.805),(47.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.805),(47.485,16.975),(47.655,16.975),(47.655,16.805),(47.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,30.065),(13.545,30.235),(13.715,30.235),(13.715,30.065),(13.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,30.405),(13.545,30.575),(13.715,30.575),(13.715,30.405),(13.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,30.745),(13.545,30.915),(13.715,30.915),(13.715,30.745),(13.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.965),(71.145,8.135),(71.315,8.135),(71.315,7.965),(71.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.965),(71.485,8.135),(71.655,8.135),(71.655,7.965),(71.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.605),(18.345,6.775),(18.515,6.775),(18.515,6.605),(18.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.605),(18.685,6.775),(18.855,6.775),(18.855,6.605),(18.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.285),(33.085,24.455),(33.255,24.455),(33.255,24.285),(33.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.625),(33.085,24.795),(33.255,24.795),(33.255,24.625),(33.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.265),(18.345,6.435),(18.515,6.435),(18.515,6.265),(18.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.265),(18.685,6.435),(18.855,6.435),(18.855,6.265),(18.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,26.325),(66.345,26.495),(66.515,26.495),(66.515,26.325),(66.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,29.045),(27.945,29.215),(28.115,29.215),(28.115,29.045),(27.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,29.385),(27.945,29.555),(28.115,29.555),(28.115,29.385),(27.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,26.325),(66.685,26.495),(66.855,26.495),(66.855,26.325),(66.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,29.725),(27.945,29.895),(28.115,29.895),(28.115,29.725),(27.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.965),(47.145,8.135),(47.315,8.135),(47.315,7.965),(47.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,20.205),(80.745,20.375),(80.915,20.375),(80.915,20.205),(80.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,20.545),(80.745,20.715),(80.915,20.715),(80.915,20.545),(80.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.965),(47.485,8.135),(47.655,8.135),(47.655,7.965),(47.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.325),(32.745,9.495),(32.915,9.495),(32.915,9.325),(32.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,25.985),(18.345,26.155),(18.515,26.155),(18.515,25.985),(18.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,25.985),(18.685,26.155),(18.855,26.155),(18.855,25.985),(18.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.665),(32.745,9.835),(32.915,9.835),(32.915,9.665),(32.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.965),(23.145,8.135),(23.315,8.135),(23.315,7.965),(23.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.965),(23.485,8.135),(23.655,8.135),(23.655,7.965),(23.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.885),(37.885,21.055),(38.055,21.055),(38.055,20.885),(37.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.705),(37.885,11.875),(38.055,11.875),(38.055,11.705),(37.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.025),(37.885,11.195),(38.055,11.195),(38.055,11.025),(37.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.365),(37.885,11.535),(38.055,11.535),(38.055,11.365),(37.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.885),(57.085,4.055),(57.255,4.055),(57.255,3.885),(57.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.905),(37.545,5.075),(37.715,5.075),(37.715,4.905),(37.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,25.305),(27.945,25.475),(28.115,25.475),(28.115,25.305),(27.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.745),(56.745,13.915),(56.915,13.915),(56.915,13.745),(56.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.065),(56.745,13.235),(56.915,13.235),(56.915,13.065),(56.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.405),(56.745,13.575),(56.915,13.575),(56.915,13.405),(56.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.885),(33.085,4.055),(33.255,4.055),(33.255,3.885),(33.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,25.645),(27.945,25.815),(28.115,25.815),(28.115,25.645),(27.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,28.365),(61.885,28.535),(62.055,28.535),(62.055,28.365),(61.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.025),(80.745,11.195),(80.915,11.195),(80.915,11.025),(80.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.365),(80.745,11.535),(80.915,11.535),(80.915,11.365),(80.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.705),(80.745,11.875),(80.915,11.875),(80.915,11.705),(80.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.885),(9.085,4.055),(9.255,4.055),(9.255,3.885),(9.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.985),(42.345,9.155),(42.515,9.155),(42.515,8.985),(42.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.985),(42.685,9.155),(42.855,9.155),(42.855,8.985),(42.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.845),(52.285,19.015),(52.455,19.015),(52.455,18.845),(52.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,28.025),(66.345,28.195),(66.515,28.195),(66.515,28.025),(66.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,28.025),(66.685,28.195),(66.855,28.195),(66.855,28.025),(66.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,34.485),(71.485,34.655),(71.655,34.655),(71.655,34.485),(71.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,34.145),(71.145,34.315),(71.315,34.315),(71.315,34.145),(71.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,34.145),(71.485,34.315),(71.655,34.315),(71.655,34.145),(71.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,34.485),(71.145,34.655),(71.315,34.655),(71.315,34.485),(71.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,34.825),(71.145,34.995),(71.315,34.995),(71.315,34.825),(71.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,37.885),(13.545,38.055),(13.715,38.055),(13.715,37.885),(13.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.305),(37.885,8.475),(38.055,8.475),(38.055,8.305),(37.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.645),(37.885,8.815),(38.055,8.815),(38.055,8.645),(37.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,36.865),(27.945,37.035),(28.115,37.035),(28.115,36.865),(27.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,34.825),(71.485,34.995),(71.655,34.995),(71.655,34.825),(71.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.345),(51.945,27.515),(52.115,27.515),(52.115,27.345),(51.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,40.605),(9.085,40.775),(9.255,40.775),(9.255,40.605),(9.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,21.565),(18.685,21.735),(18.855,21.735),(18.855,21.565),(18.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,21.565),(18.345,21.735),(18.515,21.735),(18.515,21.565),(18.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,21.225),(18.345,21.395),(18.515,21.395),(18.515,21.225),(18.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,21.225),(18.685,21.395),(18.855,21.395),(18.855,21.225),(18.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.265),(42.345,6.435),(42.515,6.435),(42.515,6.265),(42.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.265),(42.685,6.435),(42.855,6.435),(42.855,6.265),(42.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.605),(42.345,6.775),(42.515,6.775),(42.515,6.605),(42.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.605),(42.685,6.775),(42.855,6.775),(42.855,6.605),(42.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,26.325),(23.145,26.495),(23.315,26.495),(23.315,26.325),(23.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,26.325),(23.485,26.495),(23.655,26.495),(23.655,26.325),(23.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,26.665),(23.145,26.835),(23.315,26.835),(23.315,26.665),(23.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,26.665),(23.485,26.835),(23.655,26.835),(23.655,26.665),(23.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.165),(57.085,35.335),(57.255,35.335),(57.255,35.165),(57.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.505),(57.085,35.675),(57.255,35.675),(57.255,35.505),(57.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.025),(57.085,28.195),(57.255,28.195),(57.255,28.025),(57.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.365),(57.085,28.535),(57.255,28.535),(57.255,28.365),(57.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.705),(57.085,28.875),(57.255,28.875),(57.255,28.705),(57.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.225),(56.745,38.395),(56.915,38.395),(56.915,38.225),(56.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.565),(56.745,38.735),(56.915,38.735),(56.915,38.565),(56.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.905),(9.085,5.075),(9.255,5.075),(9.255,4.905),(9.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,38.565),(8.745,38.735),(8.915,38.735),(8.915,38.565),(8.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.165),(33.085,35.335),(33.255,35.335),(33.255,35.165),(33.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.505),(33.085,35.675),(33.255,35.675),(33.255,35.505),(33.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.725),(37.885,12.895),(38.055,12.895),(38.055,12.725),(37.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.785),(52.285,15.955),(52.455,15.955),(52.455,15.785),(52.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.045),(37.885,12.215),(38.055,12.215),(38.055,12.045),(37.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.385),(37.885,12.555),(38.055,12.555),(38.055,12.385),(37.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.885),(81.085,4.055),(81.255,4.055),(81.255,3.885),(81.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.105),(52.285,15.275),(52.455,15.275),(52.455,15.105),(52.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.445),(52.285,15.615),(52.455,15.615),(52.455,15.445),(52.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,27.685),(28.285,27.855),(28.455,27.855),(28.455,27.685),(28.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.965),(56.745,8.135),(56.915,8.135),(56.915,7.965),(56.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,27.005),(28.285,27.175),(28.455,27.175),(28.455,27.005),(28.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,27.345),(28.285,27.515),(28.455,27.515),(28.455,27.345),(28.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.825),(57.085,17.995),(57.255,17.995),(57.255,17.825),(57.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.145),(57.085,17.315),(57.255,17.315),(57.255,17.145),(57.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.485),(57.085,17.655),(57.255,17.655),(57.255,17.485),(57.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,30.065),(23.145,30.235),(23.315,30.235),(23.315,30.065),(23.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,30.065),(23.485,30.235),(23.655,30.235),(23.655,30.065),(23.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,30.405),(23.145,30.575),(23.315,30.575),(23.315,30.405),(23.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,30.405),(23.485,30.575),(23.655,30.575),(23.655,30.405),(23.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,30.745),(23.145,30.915),(23.315,30.915),(23.315,30.745),(23.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,30.745),(23.485,30.915),(23.655,30.915),(23.655,30.745),(23.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,34.825),(66.345,34.995),(66.515,34.995),(66.515,34.825),(66.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,34.825),(66.685,34.995),(66.855,34.995),(66.855,34.825),(66.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,34.145),(66.345,34.315),(66.515,34.315),(66.515,34.145),(66.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,26.665),(51.945,26.835),(52.115,26.835),(52.115,26.665),(51.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,34.145),(66.685,34.315),(66.855,34.315),(66.855,34.145),(66.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,34.485),(66.345,34.655),(66.515,34.655),(66.515,34.485),(66.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,34.485),(66.685,34.655),(66.855,34.655),(66.855,34.485),(66.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,26.325),(51.945,26.495),(52.115,26.495),(52.115,26.325),(51.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.965),(32.745,8.135),(32.915,8.135),(32.915,7.965),(32.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.145),(42.345,34.315),(42.515,34.315),(42.515,34.145),(42.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.485),(42.685,34.655),(42.855,34.655),(42.855,34.485),(42.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.825),(42.685,34.995),(42.855,34.995),(42.855,34.825),(42.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.485),(42.345,34.655),(42.515,34.655),(42.515,34.485),(42.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.825),(42.345,34.995),(42.515,34.995),(42.515,34.825),(42.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.145),(42.685,34.315),(42.855,34.315),(42.855,34.145),(42.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.865),(56.745,37.035),(56.915,37.035),(56.915,36.865),(56.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.245),(47.485,39.415),(47.655,39.415),(47.655,39.245),(47.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.585),(47.485,39.755),(47.655,39.755),(47.655,39.585),(47.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.245),(47.145,39.415),(47.315,39.415),(47.315,39.245),(47.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.585),(47.145,39.755),(47.315,39.755),(47.315,39.585),(47.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.725),(23.485,12.895),(23.655,12.895),(23.655,12.725),(23.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,29.045),(9.085,29.215),(9.255,29.215),(9.255,29.045),(9.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,29.385),(9.085,29.555),(9.255,29.555),(9.255,29.385),(9.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,29.725),(9.085,29.895),(9.255,29.895),(9.255,29.725),(9.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.905),(81.085,5.075),(81.255,5.075),(81.255,4.905),(81.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.925),(56.745,23.095),(56.915,23.095),(56.915,22.925),(56.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.185),(37.545,19.355),(37.715,19.355),(37.715,19.185),(37.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.525),(37.545,19.695),(37.715,19.695),(37.715,19.525),(37.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,32.785),(13.545,32.955),(13.715,32.955),(13.715,32.785),(13.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,32.105),(13.545,32.275),(13.715,32.275),(13.715,32.105),(13.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,32.445),(13.545,32.615),(13.715,32.615),(13.715,32.445),(13.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.285),(80.745,7.455),(80.915,7.455),(80.915,7.285),(80.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.625),(80.745,7.795),(80.915,7.795),(80.915,7.625),(80.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.865),(47.485,37.035),(47.655,37.035),(47.655,36.865),(47.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.865),(28.285,20.035),(28.455,20.035),(28.455,19.865),(28.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.985),(57.085,26.155),(57.255,26.155),(57.255,25.985),(57.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,23.945),(27.945,24.115),(28.115,24.115),(28.115,23.945),(27.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.545),(57.085,20.715),(57.255,20.715),(57.255,20.545),(57.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.205),(57.085,20.375),(57.255,20.375),(57.255,20.205),(57.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.965),(32.745,25.135),(32.915,25.135),(32.915,24.965),(32.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,33.805),(76.285,33.975),(76.455,33.975),(76.455,33.805),(76.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,33.465),(76.285,33.635),(76.455,33.635),(76.455,33.465),(76.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,33.125),(76.285,33.295),(76.455,33.295),(76.455,33.125),(76.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.805),(66.345,16.975),(66.515,16.975),(66.515,16.805),(66.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.805),(66.685,16.975),(66.855,16.975),(66.855,16.805),(66.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.125),(66.345,16.295),(66.515,16.295),(66.515,16.125),(66.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.125),(66.685,16.295),(66.855,16.295),(66.855,16.125),(66.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.465),(66.345,16.635),(66.515,16.635),(66.515,16.465),(66.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.465),(66.685,16.635),(66.855,16.635),(66.855,16.465),(66.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.665),(37.545,9.835),(37.715,9.835),(37.715,9.665),(37.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.245),(71.145,5.415),(71.315,5.415),(71.315,5.245),(71.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.245),(71.485,5.415),(71.655,5.415),(71.655,5.245),(71.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.585),(71.145,5.755),(71.315,5.755),(71.315,5.585),(71.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.225),(71.485,4.395),(71.655,4.395),(71.655,4.225),(71.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.565),(71.145,4.735),(71.315,4.735),(71.315,4.565),(71.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.585),(71.485,5.755),(71.655,5.755),(71.655,5.585),(71.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.225),(71.145,4.395),(71.315,4.395),(71.315,4.225),(71.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.565),(71.485,4.735),(71.655,4.735),(71.655,4.565),(71.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,28.365),(76.285,28.535),(76.455,28.535),(76.455,28.365),(76.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.205),(8.745,3.375),(8.915,3.375),(8.915,3.205),(8.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.545),(8.745,3.715),(8.915,3.715),(8.915,3.545),(8.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,34.145),(23.145,34.315),(23.315,34.315),(23.315,34.145),(23.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,34.145),(23.485,34.315),(23.655,34.315),(23.655,34.145),(23.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,34.485),(23.145,34.655),(23.315,34.655),(23.315,34.485),(23.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,34.485),(23.485,34.655),(23.655,34.655),(23.655,34.485),(23.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,34.825),(23.145,34.995),(23.315,34.995),(23.315,34.825),(23.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.305),(13.885,8.475),(14.055,8.475),(14.055,8.305),(13.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.645),(13.885,8.815),(14.055,8.815),(14.055,8.645),(13.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,34.825),(23.485,34.995),(23.655,34.995),(23.655,34.825),(23.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.905),(37.545,22.075),(37.715,22.075),(37.715,21.905),(37.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,37.885),(66.345,38.055),(66.515,38.055),(66.515,37.885),(66.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,26.665),(33.085,26.835),(33.255,26.835),(33.255,26.665),(33.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,37.885),(66.685,38.055),(66.855,38.055),(66.855,37.885),(66.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,26.325),(33.085,26.495),(33.255,26.495),(33.255,26.325),(33.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,34.485),(18.345,34.655),(18.515,34.655),(18.515,34.485),(18.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,34.145),(18.685,34.315),(18.855,34.315),(18.855,34.145),(18.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,34.145),(18.345,34.315),(18.515,34.315),(18.515,34.145),(18.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,34.485),(18.685,34.655),(18.855,34.655),(18.855,34.485),(18.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.225),(23.145,4.395),(23.315,4.395),(23.315,4.225),(23.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.565),(23.485,4.735),(23.655,4.735),(23.655,4.565),(23.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,34.825),(18.345,34.995),(18.515,34.995),(18.515,34.825),(18.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,34.825),(18.685,34.995),(18.855,34.995),(18.855,34.825),(18.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.825),(28.285,17.995),(28.455,17.995),(28.455,17.825),(28.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.145),(28.285,17.315),(28.455,17.315),(28.455,17.145),(28.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.485),(28.285,17.655),(28.455,17.655),(28.455,17.485),(28.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,38.225),(75.945,38.395),(76.115,38.395),(76.115,38.225),(75.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,38.565),(75.945,38.735),(76.115,38.735),(76.115,38.565),(75.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.925),(57.085,23.095),(57.255,23.095),(57.255,22.925),(57.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,34.825),(75.945,34.995),(76.115,34.995),(76.115,34.825),(75.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,34.145),(75.945,34.315),(76.115,34.315),(76.115,34.145),(75.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,34.485),(75.945,34.655),(76.115,34.655),(76.115,34.485),(75.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.925),(42.685,23.095),(42.855,23.095),(42.855,22.925),(42.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.925),(42.345,23.095),(42.515,23.095),(42.515,22.925),(42.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.885),(32.745,38.055),(32.915,38.055),(32.915,37.885),(32.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,21.225),(9.085,21.395),(9.255,21.395),(9.255,21.225),(9.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,21.565),(9.085,21.735),(9.255,21.735),(9.255,21.565),(9.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,34.145),(13.885,34.315),(14.055,34.315),(14.055,34.145),(13.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,34.485),(13.885,34.655),(14.055,34.655),(14.055,34.485),(13.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,34.825),(13.885,34.995),(14.055,34.995),(14.055,34.825),(13.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,37.885),(8.745,38.055),(8.915,38.055),(8.915,37.885),(8.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,38.225),(13.885,38.395),(14.055,38.395),(14.055,38.225),(13.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.205),(28.285,3.375),(28.455,3.375),(28.455,3.205),(28.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.545),(28.285,3.715),(28.455,3.715),(28.455,3.545),(28.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,38.565),(13.885,38.735),(14.055,38.735),(14.055,38.565),(13.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,36.865),(80.745,37.035),(80.915,37.035),(80.915,36.865),(80.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,24.965),(75.945,25.135),(76.115,25.135),(76.115,24.965),(75.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.665),(57.085,9.835),(57.255,9.835),(57.255,9.665),(57.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.325),(57.085,9.495),(57.255,9.495),(57.255,9.325),(57.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.905),(57.085,5.075),(57.255,5.075),(57.255,4.905),(57.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.045),(32.745,12.215),(32.915,12.215),(32.915,12.045),(32.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.385),(32.745,12.555),(32.915,12.555),(32.915,12.385),(32.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,39.585),(61.545,39.755),(61.715,39.755),(61.715,39.585),(61.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,39.245),(61.545,39.415),(61.715,39.415),(61.715,39.245),(61.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.725),(32.745,12.895),(32.915,12.895),(32.915,12.725),(32.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.925),(51.945,40.095),(52.115,40.095),(52.115,39.925),(51.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.725),(13.885,12.895),(14.055,12.895),(14.055,12.725),(13.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.045),(13.885,12.215),(14.055,12.215),(14.055,12.045),(13.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.905),(33.085,5.075),(33.255,5.075),(33.255,4.905),(33.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.385),(13.885,12.555),(14.055,12.555),(14.055,12.385),(13.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,22.245),(27.945,22.415),(28.115,22.415),(28.115,22.245),(27.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,22.585),(27.945,22.755),(28.115,22.755),(28.115,22.585),(27.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.925),(75.945,6.095),(76.115,6.095),(76.115,5.925),(75.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.185),(75.945,19.355),(76.115,19.355),(76.115,19.185),(75.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.525),(75.945,19.695),(76.115,19.695),(76.115,19.525),(75.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.065),(42.345,30.235),(42.515,30.235),(42.515,30.065),(42.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.745),(42.345,30.915),(42.515,30.915),(42.515,30.745),(42.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.745),(42.685,30.915),(42.855,30.915),(42.855,30.745),(42.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.285),(61.885,7.455),(62.055,7.455),(62.055,7.285),(61.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.625),(61.885,7.795),(62.055,7.795),(62.055,7.625),(61.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.145),(32.745,17.315),(32.915,17.315),(32.915,17.145),(32.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.485),(32.745,17.655),(32.915,17.655),(32.915,17.485),(32.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.665),(52.285,9.835),(52.455,9.835),(52.455,9.665),(52.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.325),(9.085,9.495),(9.255,9.495),(9.255,9.325),(9.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.665),(9.085,9.835),(9.255,9.835),(9.255,9.665),(9.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,33.805),(13.885,33.975),(14.055,33.975),(14.055,33.805),(13.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,33.125),(13.885,33.295),(14.055,33.295),(14.055,33.125),(13.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,33.465),(13.885,33.635),(14.055,33.635),(14.055,33.465),(13.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.325),(52.285,9.495),(52.455,9.495),(52.455,9.325),(52.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,24.285),(76.285,24.455),(76.455,24.455),(76.455,24.285),(76.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,24.625),(76.285,24.795),(76.455,24.795),(76.455,24.625),(76.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.865),(27.945,20.035),(28.115,20.035),(28.115,19.865),(27.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.285),(13.885,7.455),(14.055,7.455),(14.055,7.285),(13.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.625),(13.885,7.795),(14.055,7.795),(14.055,7.625),(13.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,38.225),(28.285,38.395),(28.455,38.395),(28.455,38.225),(28.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,38.565),(28.285,38.735),(28.455,38.735),(28.455,38.565),(28.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.245),(32.745,22.415),(32.915,22.415),(32.915,22.245),(32.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.585),(32.745,22.755),(32.915,22.755),(32.915,22.585),(32.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.345),(42.685,27.515),(42.855,27.515),(42.855,27.345),(42.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.685),(42.345,27.855),(42.515,27.855),(42.515,27.685),(42.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,21.565),(8.745,21.735),(8.915,21.735),(8.915,21.565),(8.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.685),(42.685,27.855),(42.855,27.855),(42.855,27.685),(42.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.005),(42.345,27.175),(42.515,27.175),(42.515,27.005),(42.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.005),(42.685,27.175),(42.855,27.175),(42.855,27.005),(42.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.345),(42.345,27.515),(42.515,27.515),(42.515,27.345),(42.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,21.225),(8.745,21.395),(8.915,21.395),(8.915,21.225),(8.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.265),(37.885,6.435),(38.055,6.435),(38.055,6.265),(37.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.165),(52.285,35.335),(52.455,35.335),(52.455,35.165),(52.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.505),(52.285,35.675),(52.455,35.675),(52.455,35.505),(52.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.865),(56.745,20.035),(56.915,20.035),(56.915,19.865),(56.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.605),(37.885,6.775),(38.055,6.775),(38.055,6.605),(37.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,30.745),(80.745,30.915),(80.915,30.915),(80.915,30.745),(80.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,30.065),(80.745,30.235),(80.915,30.235),(80.915,30.065),(80.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,30.405),(80.745,30.575),(80.915,30.575),(80.915,30.405),(80.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,28.705),(76.285,28.875),(76.455,28.875),(76.455,28.705),(76.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.245),(52.285,39.415),(52.455,39.415),(52.455,39.245),(52.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.585),(52.285,39.755),(52.455,39.755),(52.455,39.585),(52.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,40.265),(18.685,40.435),(18.855,40.435),(18.855,40.265),(18.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,31.425),(71.485,31.595),(71.655,31.595),(71.655,31.425),(71.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,31.085),(71.485,31.255),(71.655,31.255),(71.655,31.085),(71.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.745),(57.085,30.915),(57.255,30.915),(57.255,30.745),(57.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.865),(37.885,20.035),(38.055,20.035),(38.055,19.865),(37.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,31.765),(71.485,31.935),(71.655,31.935),(71.655,31.765),(71.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.405),(57.085,30.575),(57.255,30.575),(57.255,30.405),(57.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,40.265),(18.345,40.435),(18.515,40.435),(18.515,40.265),(18.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.065),(57.085,30.235),(57.255,30.235),(57.255,30.065),(57.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,40.265),(80.745,40.435),(80.915,40.435),(80.915,40.265),(80.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,40.605),(80.745,40.775),(80.915,40.775),(80.915,40.605),(80.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.065),(52.285,13.235),(52.455,13.235),(52.455,13.065),(52.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.405),(52.285,13.575),(52.455,13.575),(52.455,13.405),(52.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,34.485),(61.545,34.655),(61.715,34.655),(61.715,34.485),(61.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,34.145),(61.545,34.315),(61.715,34.315),(61.715,34.145),(61.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,34.825),(61.545,34.995),(61.715,34.995),(61.715,34.825),(61.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.445),(42.685,32.615),(42.855,32.615),(42.855,32.445),(42.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.745),(52.285,13.915),(52.455,13.915),(52.455,13.745),(52.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,39.925),(81.085,40.095),(81.255,40.095),(81.255,39.925),(81.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,35.505),(76.285,35.675),(76.455,35.675),(76.455,35.505),(76.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.905),(37.885,22.075),(38.055,22.075),(38.055,21.905),(37.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,38.905),(66.345,39.075),(66.515,39.075),(66.515,38.905),(66.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,38.905),(66.685,39.075),(66.855,39.075),(66.855,38.905),(66.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.825),(57.085,34.995),(57.255,34.995),(57.255,34.825),(57.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.285),(51.945,24.455),(52.115,24.455),(52.115,24.285),(51.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.625),(51.945,24.795),(52.115,24.795),(52.115,24.625),(51.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.145),(57.085,34.315),(57.255,34.315),(57.255,34.145),(57.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.485),(57.085,34.655),(57.255,34.655),(57.255,34.485),(57.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,31.085),(75.945,31.255),(76.115,31.255),(76.115,31.085),(75.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.905),(13.885,5.075),(14.055,5.075),(14.055,4.905),(13.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,31.425),(75.945,31.595),(76.115,31.595),(76.115,31.425),(75.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.885),(52.285,21.055),(52.455,21.055),(52.455,20.885),(52.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.885),(32.745,21.055),(32.915,21.055),(32.915,20.885),(32.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.705),(61.885,11.875),(62.055,11.875),(62.055,11.705),(61.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.025),(61.885,11.195),(62.055,11.195),(62.055,11.025),(61.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,23.605),(23.145,23.775),(23.315,23.775),(23.315,23.605),(23.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,23.265),(23.485,23.435),(23.655,23.435),(23.655,23.265),(23.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.365),(61.885,11.535),(62.055,11.535),(62.055,11.365),(61.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,23.265),(23.145,23.435),(23.315,23.435),(23.315,23.265),(23.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.825),(33.085,34.995),(33.255,34.995),(33.255,34.825),(33.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.145),(33.085,34.315),(33.255,34.315),(33.255,34.145),(33.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,22.245),(76.285,22.415),(76.455,22.415),(76.455,22.245),(76.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,22.585),(76.285,22.755),(76.455,22.755),(76.455,22.585),(76.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.485),(33.085,34.655),(33.255,34.655),(33.255,34.485),(33.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,23.605),(23.485,23.775),(23.655,23.775),(23.655,23.605),(23.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.865),(37.885,37.035),(38.055,37.035),(38.055,36.865),(37.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.165),(27.945,18.335),(28.115,18.335),(28.115,18.165),(27.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.505),(27.945,18.675),(28.115,18.675),(28.115,18.505),(27.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.025),(13.885,11.195),(14.055,11.195),(14.055,11.025),(13.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,31.765),(9.085,31.935),(9.255,31.935),(9.255,31.765),(9.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.365),(13.885,11.535),(14.055,11.535),(14.055,11.365),(13.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,31.085),(9.085,31.255),(9.255,31.255),(9.255,31.085),(9.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,31.425),(9.085,31.595),(9.255,31.595),(9.255,31.425),(9.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.945),(52.285,7.115),(52.455,7.115),(52.455,6.945),(52.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.705),(13.885,11.875),(14.055,11.875),(14.055,11.705),(13.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,27.005),(75.945,27.175),(76.115,27.175),(76.115,27.005),(75.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,27.345),(75.945,27.515),(76.115,27.515),(76.115,27.345),(75.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.965),(80.745,8.135),(80.915,8.135),(80.915,7.965),(80.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,27.685),(75.945,27.855),(76.115,27.855),(76.115,27.685),(75.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,28.365),(18.685,28.535),(18.855,28.535),(18.855,28.365),(18.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,28.025),(18.345,28.195),(18.515,28.195),(18.515,28.025),(18.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,28.025),(18.685,28.195),(18.855,28.195),(18.855,28.025),(18.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.245),(33.085,22.415),(33.255,22.415),(33.255,22.245),(33.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.585),(33.085,22.755),(33.255,22.755),(33.255,22.585),(33.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,28.705),(18.345,28.875),(18.515,28.875),(18.515,28.705),(18.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,28.705),(18.685,28.875),(18.855,28.875),(18.855,28.705),(18.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.185),(57.085,19.355),(57.255,19.355),(57.255,19.185),(57.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.525),(57.085,19.695),(57.255,19.695),(57.255,19.525),(57.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,28.365),(18.345,28.535),(18.515,28.535),(18.515,28.365),(18.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.305),(61.885,8.475),(62.055,8.475),(62.055,8.305),(61.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.645),(61.885,8.815),(62.055,8.815),(62.055,8.645),(61.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.205),(32.745,3.375),(32.915,3.375),(32.915,3.205),(32.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.545),(32.745,3.715),(32.915,3.715),(32.915,3.545),(32.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.225),(47.145,4.395),(47.315,4.395),(47.315,4.225),(47.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.225),(47.485,4.395),(47.655,4.395),(47.655,4.225),(47.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.565),(47.145,4.735),(47.315,4.735),(47.315,4.565),(47.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.565),(47.485,4.735),(47.655,4.735),(47.655,4.565),(47.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.525),(42.685,19.695),(42.855,19.695),(42.855,19.525),(42.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.185),(42.345,19.355),(42.515,19.355),(42.515,19.185),(42.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.185),(42.685,19.355),(42.855,19.355),(42.855,19.185),(42.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.525),(42.345,19.695),(42.515,19.695),(42.515,19.525),(42.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.805),(13.885,16.975),(14.055,16.975),(14.055,16.805),(13.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.125),(13.885,16.295),(14.055,16.295),(14.055,16.125),(13.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.465),(13.885,16.635),(14.055,16.635),(14.055,16.465),(13.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.865),(13.545,20.035),(13.715,20.035),(13.715,19.865),(13.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,26.325),(76.285,26.495),(76.455,26.495),(76.455,26.325),(76.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,26.665),(76.285,26.835),(76.455,26.835),(76.455,26.665),(76.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.045),(61.885,12.215),(62.055,12.215),(62.055,12.045),(61.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.385),(61.885,12.555),(62.055,12.555),(62.055,12.385),(61.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.725),(61.885,12.895),(62.055,12.895),(62.055,12.725),(61.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.445),(42.345,15.615),(42.515,15.615),(42.515,15.445),(42.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.105),(42.685,15.275),(42.855,15.275),(42.855,15.105),(42.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.105),(42.345,15.275),(42.515,15.275),(42.515,15.105),(42.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.445),(42.685,15.615),(42.855,15.615),(42.855,15.445),(42.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.865),(37.885,3.035),(38.055,3.035),(38.055,2.865),(37.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.785),(42.685,15.955),(42.855,15.955),(42.855,15.785),(42.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.785),(42.345,15.955),(42.515,15.955),(42.515,15.785),(42.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.905),(52.285,22.075),(52.455,22.075),(52.455,21.905),(52.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.985),(9.085,9.155),(9.255,9.155),(9.255,8.985),(9.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,38.905),(18.685,39.075),(18.855,39.075),(18.855,38.905),(18.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.785),(28.285,15.955),(28.455,15.955),(28.455,15.785),(28.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.105),(28.285,15.275),(28.455,15.275),(28.455,15.105),(28.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.445),(28.285,15.615),(28.455,15.615),(28.455,15.445),(28.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,38.905),(18.345,39.075),(18.515,39.075),(18.515,38.905),(18.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.125),(80.745,16.295),(80.915,16.295),(80.915,16.125),(80.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.465),(80.745,16.635),(80.915,16.635),(80.915,16.465),(80.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,30.065),(76.285,30.235),(76.455,30.235),(76.455,30.065),(76.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,30.405),(76.285,30.575),(76.455,30.575),(76.455,30.405),(76.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,30.745),(76.285,30.915),(76.455,30.915),(76.455,30.745),(76.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.985),(42.685,26.155),(42.855,26.155),(42.855,25.985),(42.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.985),(42.345,26.155),(42.515,26.155),(42.515,25.985),(42.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.805),(80.745,16.975),(80.915,16.975),(80.915,16.805),(80.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,23.265),(61.545,23.435),(61.715,23.435),(61.715,23.265),(61.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,23.605),(61.545,23.775),(61.715,23.775),(61.715,23.605),(61.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,38.225),(13.545,38.395),(13.715,38.395),(13.715,38.225),(13.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,38.565),(13.545,38.735),(13.715,38.735),(13.715,38.565),(13.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,26.325),(27.945,26.495),(28.115,26.495),(28.115,26.325),(27.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,40.605),(23.145,40.775),(23.315,40.775),(23.315,40.605),(23.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,40.265),(23.145,40.435),(23.315,40.435),(23.315,40.265),(23.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,40.265),(23.485,40.435),(23.655,40.435),(23.655,40.265),(23.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,25.985),(61.545,26.155),(61.715,26.155),(61.715,25.985),(61.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,34.825),(8.745,34.995),(8.915,34.995),(8.915,34.825),(8.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,34.145),(8.745,34.315),(8.915,34.315),(8.915,34.145),(8.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,34.485),(8.745,34.655),(8.915,34.655),(8.915,34.485),(8.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,26.665),(27.945,26.835),(28.115,26.835),(28.115,26.665),(27.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.205),(56.745,37.375),(56.915,37.375),(56.915,37.205),(56.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,24.285),(81.085,24.455),(81.255,24.455),(81.255,24.285),(81.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,24.625),(81.085,24.795),(81.255,24.795),(81.255,24.625),(81.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.365),(57.085,11.535),(57.255,11.535),(57.255,11.365),(57.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.025),(57.085,11.195),(57.255,11.195),(57.255,11.025),(57.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.705),(57.085,11.875),(57.255,11.875),(57.255,11.705),(57.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,23.945),(13.545,24.115),(13.715,24.115),(13.715,23.945),(13.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.345),(32.745,10.515),(32.915,10.515),(32.915,10.345),(32.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.085),(56.745,14.255),(56.915,14.255),(56.915,14.085),(56.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,23.605),(81.085,23.775),(81.255,23.775),(81.255,23.605),(81.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,23.265),(81.085,23.435),(81.255,23.435),(81.255,23.265),(81.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.425),(56.745,14.595),(56.915,14.595),(56.915,14.425),(56.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.005),(32.745,10.175),(32.915,10.175),(32.915,10.005),(32.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.105),(47.145,15.275),(47.315,15.275),(47.315,15.105),(47.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.105),(47.485,15.275),(47.655,15.275),(47.655,15.105),(47.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.445),(47.145,15.615),(47.315,15.615),(47.315,15.445),(47.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.445),(47.485,15.615),(47.655,15.615),(47.655,15.445),(47.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.245),(61.545,5.415),(61.715,5.415),(61.715,5.245),(61.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.585),(61.545,5.755),(61.715,5.755),(61.715,5.585),(61.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.385),(71.145,12.555),(71.315,12.555),(71.315,12.385),(71.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.585),(37.885,39.755),(38.055,39.755),(38.055,39.585),(37.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.245),(37.885,39.415),(38.055,39.415),(38.055,39.245),(37.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.485),(66.685,17.655),(66.855,17.655),(66.855,17.485),(66.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.145),(66.685,17.315),(66.855,17.315),(66.855,17.145),(66.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.485),(66.345,17.655),(66.515,17.655),(66.515,17.485),(66.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.145),(66.345,17.315),(66.515,17.315),(66.515,17.145),(66.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.045),(33.085,29.215),(33.255,29.215),(33.255,29.045),(33.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.385),(33.085,29.555),(33.255,29.555),(33.255,29.385),(33.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.025),(9.085,11.195),(9.255,11.195),(9.255,11.025),(9.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.365),(9.085,11.535),(9.255,11.535),(9.255,11.365),(9.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.765),(8.745,14.935),(8.915,14.935),(8.915,14.765),(8.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.085),(8.745,14.255),(8.915,14.255),(8.915,14.085),(8.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.245),(13.545,5.415),(13.715,5.415),(13.715,5.245),(13.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.585),(13.545,5.755),(13.715,5.755),(13.715,5.585),(13.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.425),(8.745,14.595),(8.915,14.595),(8.915,14.425),(8.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.965),(28.285,8.135),(28.455,8.135),(28.455,7.965),(28.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.905),(61.885,5.075),(62.055,5.075),(62.055,4.905),(61.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,28.025),(9.085,28.195),(9.255,28.195),(9.255,28.025),(9.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,28.365),(9.085,28.535),(9.255,28.535),(9.255,28.365),(9.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,28.705),(9.085,28.875),(9.255,28.875),(9.255,28.705),(9.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.205),(71.145,3.375),(71.315,3.375),(71.315,3.205),(71.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.205),(71.485,3.375),(71.655,3.375),(71.655,3.205),(71.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.545),(71.145,3.715),(71.315,3.715),(71.315,3.545),(71.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.545),(71.485,3.715),(71.655,3.715),(71.655,3.545),(71.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.465),(18.685,16.635),(18.855,16.635),(18.855,16.465),(18.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.465),(18.345,16.635),(18.515,16.635),(18.515,16.465),(18.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.125),(18.345,16.295),(18.515,16.295),(18.515,16.125),(18.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.125),(18.685,16.295),(18.855,16.295),(18.855,16.125),(18.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.805),(18.345,16.975),(18.515,16.975),(18.515,16.805),(18.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.805),(18.685,16.975),(18.855,16.975),(18.855,16.805),(18.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.325),(61.545,9.495),(61.715,9.495),(61.715,9.325),(61.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.205),(47.145,3.375),(47.315,3.375),(47.315,3.205),(47.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.205),(47.485,3.375),(47.655,3.375),(47.655,3.205),(47.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.545),(47.145,3.715),(47.315,3.715),(47.315,3.545),(47.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.545),(47.485,3.715),(47.655,3.715),(47.655,3.545),(47.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.665),(61.545,9.835),(61.715,9.835),(61.715,9.665),(61.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,32.105),(28.285,32.275),(28.455,32.275),(28.455,32.105),(28.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,32.445),(28.285,32.615),(28.455,32.615),(28.455,32.445),(28.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,32.785),(28.285,32.955),(28.455,32.955),(28.455,32.785),(28.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.285),(57.085,24.455),(57.255,24.455),(57.255,24.285),(57.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.625),(57.085,24.795),(57.255,24.795),(57.255,24.625),(57.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.205),(56.745,3.375),(56.915,3.375),(56.915,3.205),(56.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.205),(23.145,3.375),(23.315,3.375),(23.315,3.205),(23.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.545),(23.485,3.715),(23.655,3.715),(23.655,3.545),(23.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.545),(23.145,3.715),(23.315,3.715),(23.315,3.545),(23.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.845),(47.145,19.015),(47.315,19.015),(47.315,18.845),(47.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.845),(47.485,19.015),(47.655,19.015),(47.655,18.845),(47.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.205),(23.485,3.375),(23.655,3.375),(23.655,3.205),(23.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,37.205),(18.345,37.375),(18.515,37.375),(18.515,37.205),(18.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,37.545),(18.345,37.715),(18.515,37.715),(18.515,37.545),(18.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,37.545),(18.685,37.715),(18.855,37.715),(18.855,37.545),(18.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,37.205),(18.685,37.375),(18.855,37.375),(18.855,37.205),(18.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.665),(13.545,9.835),(13.715,9.835),(13.715,9.665),(13.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.905),(18.685,5.075),(18.855,5.075),(18.855,4.905),(18.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.905),(18.345,5.075),(18.515,5.075),(18.515,4.905),(18.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.325),(13.545,9.495),(13.715,9.495),(13.715,9.325),(13.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.185),(13.885,19.355),(14.055,19.355),(14.055,19.185),(13.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.525),(13.885,19.695),(14.055,19.695),(14.055,19.525),(13.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.685),(80.745,10.855),(80.915,10.855),(80.915,10.685),(80.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,27.685),(61.545,27.855),(61.715,27.855),(61.715,27.685),(61.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,27.005),(61.545,27.175),(61.715,27.175),(61.715,27.005),(61.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.285),(42.345,24.455),(42.515,24.455),(42.515,24.285),(42.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.845),(37.545,19.015),(37.715,19.015),(37.715,18.845),(37.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,27.345),(61.545,27.515),(61.715,27.515),(61.715,27.345),(61.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,37.205),(61.885,37.375),(62.055,37.375),(62.055,37.205),(61.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,37.545),(61.885,37.715),(62.055,37.715),(62.055,37.545),(61.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.285),(42.685,24.455),(42.855,24.455),(42.855,24.285),(42.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.625),(42.685,24.795),(42.855,24.795),(42.855,24.625),(42.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.625),(42.345,24.795),(42.515,24.795),(42.515,24.625),(42.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,40.265),(66.345,40.435),(66.515,40.435),(66.515,40.265),(66.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,40.265),(66.685,40.435),(66.855,40.435),(66.855,40.265),(66.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,40.605),(66.345,40.775),(66.515,40.775),(66.515,40.605),(66.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,40.605),(66.685,40.775),(66.855,40.775),(66.855,40.605),(66.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.925),(57.085,40.095),(57.255,40.095),(57.255,39.925),(57.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,35.165),(27.945,35.335),(28.115,35.335),(28.115,35.165),(27.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,35.505),(27.945,35.675),(28.115,35.675),(28.115,35.505),(27.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.245),(42.685,22.415),(42.855,22.415),(42.855,22.245),(42.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.925),(37.545,23.095),(37.715,23.095),(37.715,22.925),(37.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,25.305),(18.685,25.475),(18.855,25.475),(18.855,25.305),(18.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,25.645),(18.345,25.815),(18.515,25.815),(18.515,25.645),(18.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,25.645),(18.685,25.815),(18.855,25.815),(18.855,25.645),(18.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,25.305),(18.345,25.475),(18.515,25.475),(18.515,25.305),(18.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,40.265),(28.285,40.435),(28.455,40.435),(28.455,40.265),(28.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,40.605),(28.285,40.775),(28.455,40.775),(28.455,40.605),(28.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.905),(51.945,22.075),(52.115,22.075),(52.115,21.905),(51.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.205),(76.285,3.375),(76.455,3.375),(76.455,3.205),(76.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.545),(76.285,3.715),(76.455,3.715),(76.455,3.545),(76.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.865),(42.345,20.035),(42.515,20.035),(42.515,19.865),(42.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.865),(42.685,20.035),(42.855,20.035),(42.855,19.865),(42.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.665),(76.285,9.835),(76.455,9.835),(76.455,9.665),(76.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.985),(57.085,9.155),(57.255,9.155),(57.255,8.985),(57.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.325),(76.285,9.495),(76.455,9.495),(76.455,9.325),(76.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,20.885),(61.545,21.055),(61.715,21.055),(61.715,20.885),(61.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,20.545),(9.085,20.715),(9.255,20.715),(9.255,20.545),(9.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,20.205),(9.085,20.375),(9.255,20.375),(9.255,20.205),(9.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,30.065),(81.085,30.235),(81.255,30.235),(81.255,30.065),(81.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,30.405),(81.085,30.575),(81.255,30.575),(81.255,30.405),(81.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,30.745),(81.085,30.915),(81.255,30.915),(81.255,30.745),(81.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,37.885),(28.285,38.055),(28.455,38.055),(28.455,37.885),(28.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.665),(28.285,9.835),(28.455,9.835),(28.455,9.665),(28.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.325),(28.285,9.495),(28.455,9.495),(28.455,9.325),(28.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,26.325),(47.145,26.495),(47.315,26.495),(47.315,26.325),(47.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,26.325),(47.485,26.495),(47.655,26.495),(47.655,26.325),(47.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,26.665),(47.145,26.835),(47.315,26.835),(47.315,26.665),(47.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,26.665),(47.485,26.835),(47.655,26.835),(47.655,26.665),(47.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.905),(42.685,5.075),(42.855,5.075),(42.855,4.905),(42.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.245),(56.745,39.415),(56.915,39.415),(56.915,39.245),(56.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.585),(56.745,39.755),(56.915,39.755),(56.915,39.585),(56.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.905),(42.345,5.075),(42.515,5.075),(42.515,4.905),(42.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.005),(51.945,27.175),(52.115,27.175),(52.115,27.005),(51.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.545),(80.745,3.715),(80.915,3.715),(80.915,3.545),(80.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.205),(80.745,3.375),(80.915,3.375),(80.915,3.205),(80.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.425),(47.485,14.595),(47.655,14.595),(47.655,14.425),(47.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.405),(33.085,13.575),(33.255,13.575),(33.255,13.405),(33.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.165),(66.345,18.335),(66.515,18.335),(66.515,18.165),(66.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.165),(66.685,18.335),(66.855,18.335),(66.855,18.165),(66.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.505),(66.345,18.675),(66.515,18.675),(66.515,18.505),(66.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.505),(66.685,18.675),(66.855,18.675),(66.855,18.505),(66.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,20.205),(66.345,20.375),(66.515,20.375),(66.515,20.205),(66.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,20.205),(66.685,20.375),(66.855,20.375),(66.855,20.205),(66.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,20.545),(66.345,20.715),(66.515,20.715),(66.515,20.545),(66.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,20.545),(66.685,20.715),(66.855,20.715),(66.855,20.545),(66.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.785),(47.145,15.955),(47.315,15.955),(47.315,15.785),(47.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.065),(76.285,13.235),(76.455,13.235),(76.455,13.065),(76.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,22.925),(9.085,23.095),(9.255,23.095),(9.255,22.925),(9.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.405),(76.285,13.575),(76.455,13.575),(76.455,13.405),(76.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,25.985),(61.885,26.155),(62.055,26.155),(62.055,25.985),(61.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.745),(76.285,13.915),(76.455,13.915),(76.455,13.745),(76.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.205),(61.545,3.375),(61.715,3.375),(61.715,3.205),(61.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.545),(61.545,3.715),(61.715,3.715),(61.715,3.545),(61.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,32.785),(76.285,32.955),(76.455,32.955),(76.455,32.785),(76.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,32.105),(76.285,32.275),(76.455,32.275),(76.455,32.105),(76.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,32.445),(76.285,32.615),(76.455,32.615),(76.455,32.445),(76.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,31.765),(75.945,31.935),(76.115,31.935),(76.115,31.765),(75.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,25.985),(81.085,26.155),(81.255,26.155),(81.255,25.985),(81.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.745),(28.285,13.915),(28.455,13.915),(28.455,13.745),(28.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.065),(28.285,13.235),(28.455,13.235),(28.455,13.065),(28.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.405),(28.285,13.575),(28.455,13.575),(28.455,13.405),(28.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.205),(13.545,3.375),(13.715,3.375),(13.715,3.205),(13.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.545),(13.545,3.715),(13.715,3.715),(13.715,3.545),(13.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,25.985),(23.145,26.155),(23.315,26.155),(23.315,25.985),(23.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,25.985),(23.485,26.155),(23.655,26.155),(23.655,25.985),(23.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,24.965),(61.545,25.135),(61.715,25.135),(61.715,24.965),(61.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.505),(23.145,18.675),(23.315,18.675),(23.315,18.505),(23.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,24.285),(27.945,24.455),(28.115,24.455),(28.115,24.285),(27.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,24.625),(27.945,24.795),(28.115,24.795),(28.115,24.625),(27.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.505),(23.485,18.675),(23.655,18.675),(23.655,18.505),(23.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.165),(23.145,18.335),(23.315,18.335),(23.315,18.165),(23.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.165),(23.485,18.335),(23.655,18.335),(23.655,18.165),(23.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,26.665),(18.345,26.835),(18.515,26.835),(18.515,26.665),(18.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,26.665),(18.685,26.835),(18.855,26.835),(18.855,26.665),(18.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,26.325),(18.345,26.495),(18.515,26.495),(18.515,26.325),(18.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,26.325),(18.685,26.495),(18.855,26.495),(18.855,26.325),(18.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.725),(80.745,12.895),(80.915,12.895),(80.915,12.725),(80.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.045),(80.745,12.215),(80.915,12.215),(80.915,12.045),(80.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.805),(37.545,33.975),(37.715,33.975),(37.715,33.805),(37.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.385),(80.745,12.555),(80.915,12.555),(80.915,12.385),(80.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.125),(37.545,33.295),(37.715,33.295),(37.715,33.125),(37.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.465),(37.545,33.635),(37.715,33.635),(37.715,33.465),(37.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.205),(37.545,37.375),(37.715,37.375),(37.715,37.205),(37.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.545),(37.545,37.715),(37.715,37.715),(37.715,37.545),(37.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.145),(9.085,17.315),(9.255,17.315),(9.255,17.145),(9.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.485),(9.085,17.655),(9.255,17.655),(9.255,17.485),(9.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.725),(42.345,12.895),(42.515,12.895),(42.515,12.725),(42.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.725),(42.685,12.895),(42.855,12.895),(42.855,12.725),(42.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,22.585),(23.485,22.755),(23.655,22.755),(23.655,22.585),(23.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,22.245),(23.485,22.415),(23.655,22.415),(23.655,22.245),(23.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,22.245),(23.145,22.415),(23.315,22.415),(23.315,22.245),(23.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.045),(42.345,12.215),(42.515,12.215),(42.515,12.045),(42.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.045),(42.685,12.215),(42.855,12.215),(42.855,12.045),(42.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.805),(61.545,16.975),(61.715,16.975),(61.715,16.805),(61.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.385),(42.345,12.555),(42.515,12.555),(42.515,12.385),(42.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.465),(61.545,16.635),(61.715,16.635),(61.715,16.465),(61.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.125),(61.545,16.295),(61.715,16.295),(61.715,16.125),(61.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,22.585),(23.145,22.755),(23.315,22.755),(23.315,22.585),(23.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.425),(71.145,14.595),(71.315,14.595),(71.315,14.425),(71.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.985),(37.545,26.155),(37.715,26.155),(37.715,25.985),(37.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,21.905),(71.145,22.075),(71.315,22.075),(71.315,21.905),(71.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,21.905),(71.485,22.075),(71.655,22.075),(71.655,21.905),(71.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.865),(8.745,20.035),(8.915,20.035),(8.915,19.865),(8.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.025),(47.145,11.195),(47.315,11.195),(47.315,11.025),(47.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.025),(47.485,11.195),(47.655,11.195),(47.655,11.025),(47.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,30.065),(9.085,30.235),(9.255,30.235),(9.255,30.065),(9.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,30.405),(9.085,30.575),(9.255,30.575),(9.255,30.405),(9.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,30.745),(9.085,30.915),(9.255,30.915),(9.255,30.745),(9.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.485),(61.885,17.655),(62.055,17.655),(62.055,17.485),(61.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.145),(61.885,17.315),(62.055,17.315),(62.055,17.145),(61.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.825),(61.885,17.995),(62.055,17.995),(62.055,17.825),(61.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.065),(42.685,30.235),(42.855,30.235),(42.855,30.065),(42.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.145),(80.745,17.315),(80.915,17.315),(80.915,17.145),(80.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.485),(80.745,17.655),(80.915,17.655),(80.915,17.485),(80.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.825),(80.745,17.995),(80.915,17.995),(80.915,17.825),(80.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.165),(32.745,18.335),(32.915,18.335),(32.915,18.165),(32.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.505),(32.745,18.675),(32.915,18.675),(32.915,18.505),(32.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.325),(23.145,9.495),(23.315,9.495),(23.315,9.325),(23.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.325),(23.485,9.495),(23.655,9.495),(23.655,9.325),(23.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.665),(23.145,9.835),(23.315,9.835),(23.315,9.665),(23.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.665),(23.485,9.835),(23.655,9.835),(23.655,9.665),(23.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.325),(37.885,9.495),(38.055,9.495),(38.055,9.325),(37.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,40.265),(56.745,40.435),(56.915,40.435),(56.915,40.265),(56.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,40.605),(56.745,40.775),(56.915,40.775),(56.915,40.605),(56.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.665),(37.885,9.835),(38.055,9.835),(38.055,9.665),(37.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.865),(37.545,37.035),(37.715,37.035),(37.715,36.865),(37.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,23.945),(75.945,24.115),(76.115,24.115),(76.115,23.945),(75.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,21.225),(61.885,21.395),(62.055,21.395),(62.055,21.225),(61.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,21.565),(61.885,21.735),(62.055,21.735),(62.055,21.565),(61.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,22.925),(8.745,23.095),(8.915,23.095),(8.915,22.925),(8.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,2.865),(75.945,3.035),(76.115,3.035),(76.115,2.865),(75.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,37.545),(23.145,37.715),(23.315,37.715),(23.315,37.545),(23.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,37.205),(23.145,37.375),(23.315,37.375),(23.315,37.205),(23.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,37.545),(23.485,37.715),(23.655,37.715),(23.655,37.545),(23.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,37.205),(23.485,37.375),(23.655,37.375),(23.655,37.205),(23.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,23.945),(66.345,24.115),(66.515,24.115),(66.515,23.945),(66.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,23.945),(66.685,24.115),(66.855,24.115),(66.855,23.945),(66.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.305),(37.545,8.475),(37.715,8.475),(37.715,8.305),(37.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.645),(37.545,8.815),(37.715,8.815),(37.715,8.645),(37.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,40.265),(37.885,40.435),(38.055,40.435),(38.055,40.265),(37.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,40.605),(37.885,40.775),(38.055,40.775),(38.055,40.605),(37.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.945),(23.145,7.115),(23.315,7.115),(23.315,6.945),(23.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.945),(23.485,7.115),(23.655,7.115),(23.655,6.945),(23.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,22.925),(28.285,23.095),(28.455,23.095),(28.455,22.925),(28.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,33.125),(71.145,33.295),(71.315,33.295),(71.315,33.125),(71.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,33.125),(71.485,33.295),(71.655,33.295),(71.655,33.125),(71.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,33.465),(71.145,33.635),(71.315,33.635),(71.315,33.465),(71.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,33.465),(71.485,33.635),(71.655,33.635),(71.655,33.465),(71.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,33.805),(71.145,33.975),(71.315,33.975),(71.315,33.805),(71.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.945),(33.085,24.115),(33.255,24.115),(33.255,23.945),(33.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,2.865),(27.945,3.035),(28.115,3.035),(28.115,2.865),(27.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,33.805),(71.485,33.975),(71.655,33.975),(71.655,33.805),(71.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.725),(32.745,29.895),(32.915,29.895),(32.915,29.725),(32.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,25.985),(9.085,26.155),(9.255,26.155),(9.255,25.985),(9.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.045),(32.745,29.215),(32.915,29.215),(32.915,29.045),(32.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.385),(32.745,29.555),(32.915,29.555),(32.915,29.385),(32.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.145),(37.885,17.315),(38.055,17.315),(38.055,17.145),(37.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.165),(61.885,18.335),(62.055,18.335),(62.055,18.165),(61.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.145),(76.285,17.315),(76.455,17.315),(76.455,17.145),(76.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.485),(76.285,17.655),(76.455,17.655),(76.455,17.485),(76.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.105),(76.285,15.275),(76.455,15.275),(76.455,15.105),(76.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.445),(76.285,15.615),(76.455,15.615),(76.455,15.445),(76.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.785),(76.285,15.955),(76.455,15.955),(76.455,15.785),(76.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.505),(61.885,18.675),(62.055,18.675),(62.055,18.505),(61.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.065),(23.145,13.235),(23.315,13.235),(23.315,13.065),(23.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.065),(23.485,13.235),(23.655,13.235),(23.655,13.065),(23.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.405),(23.485,13.575),(23.655,13.575),(23.655,13.405),(23.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.745),(23.145,13.915),(23.315,13.915),(23.315,13.745),(23.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.745),(23.485,13.915),(23.655,13.915),(23.655,13.745),(23.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.405),(23.145,13.575),(23.315,13.575),(23.315,13.405),(23.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,37.205),(66.345,37.375),(66.515,37.375),(66.515,37.205),(66.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,37.205),(66.685,37.375),(66.855,37.375),(66.855,37.205),(66.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.885),(61.885,4.055),(62.055,4.055),(62.055,3.885),(61.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,21.905),(81.085,22.075),(81.255,22.075),(81.255,21.905),(81.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,37.545),(66.345,37.715),(66.515,37.715),(66.515,37.545),(66.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,37.545),(66.685,37.715),(66.855,37.715),(66.855,37.545),(66.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.105),(56.745,32.275),(56.915,32.275),(56.915,32.105),(56.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.445),(56.745,32.615),(56.915,32.615),(56.915,32.445),(56.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.785),(56.745,32.955),(56.915,32.955),(56.915,32.785),(56.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.905),(32.745,22.075),(32.915,22.075),(32.915,21.905),(32.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.905),(66.345,5.075),(66.515,5.075),(66.515,4.905),(66.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,2.865),(9.085,3.035),(9.255,3.035),(9.255,2.865),(9.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.905),(66.685,5.075),(66.855,5.075),(66.855,4.905),(66.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.885),(37.545,4.055),(37.715,4.055),(37.715,3.885),(37.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.685),(37.545,27.855),(37.715,27.855),(37.715,27.685),(37.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.005),(37.545,27.175),(37.715,27.175),(37.715,27.005),(37.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.345),(37.545,27.515),(37.715,27.515),(37.715,27.345),(37.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.105),(32.745,32.275),(32.915,32.275),(32.915,32.105),(32.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.445),(32.745,32.615),(32.915,32.615),(32.915,32.445),(32.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.785),(32.745,32.955),(32.915,32.955),(32.915,32.785),(32.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.885),(13.885,4.055),(14.055,4.055),(14.055,3.885),(13.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,37.205),(27.945,37.375),(28.115,37.375),(28.115,37.205),(27.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.205),(32.745,37.375),(32.915,37.375),(32.915,37.205),(32.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,37.545),(27.945,37.715),(28.115,37.715),(28.115,37.545),(27.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.165),(33.085,18.335),(33.255,18.335),(33.255,18.165),(33.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.505),(33.085,18.675),(33.255,18.675),(33.255,18.505),(33.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,26.325),(32.745,26.495),(32.915,26.495),(32.915,26.325),(32.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.545),(32.745,37.715),(32.915,37.715),(32.915,37.545),(32.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.765),(66.345,14.935),(66.515,14.935),(66.515,14.765),(66.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.765),(66.685,14.935),(66.855,14.935),(66.855,14.765),(66.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.085),(66.345,14.255),(66.515,14.255),(66.515,14.085),(66.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.085),(66.685,14.255),(66.855,14.255),(66.855,14.085),(66.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.425),(66.345,14.595),(66.515,14.595),(66.515,14.425),(66.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.425),(66.685,14.595),(66.855,14.595),(66.855,14.425),(66.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.925),(61.885,6.095),(62.055,6.095),(62.055,5.925),(61.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,37.205),(8.745,37.375),(8.915,37.375),(8.915,37.205),(8.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,37.545),(8.745,37.715),(8.915,37.715),(8.915,37.545),(8.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,22.245),(75.945,22.415),(76.115,22.415),(76.115,22.245),(75.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,22.585),(75.945,22.755),(76.115,22.755),(76.115,22.585),(75.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.925),(56.745,40.095),(56.915,40.095),(56.915,39.925),(56.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.925),(13.885,6.095),(14.055,6.095),(14.055,5.925),(13.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,24.625),(23.145,24.795),(23.315,24.795),(23.315,24.625),(23.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,24.285),(23.485,24.455),(23.655,24.455),(23.655,24.285),(23.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,24.285),(23.145,24.455),(23.315,24.455),(23.315,24.285),(23.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,24.625),(23.485,24.795),(23.655,24.795),(23.655,24.625),(23.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.965),(76.285,8.135),(76.455,8.135),(76.455,7.965),(76.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.865),(75.945,20.035),(76.115,20.035),(76.115,19.865),(75.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.225),(56.745,4.395),(56.915,4.395),(56.915,4.225),(56.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.565),(56.745,4.735),(56.915,4.735),(56.915,4.565),(56.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.965),(61.885,8.135),(62.055,8.135),(62.055,7.965),(61.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.785),(32.745,15.955),(32.915,15.955),(32.915,15.785),(32.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.105),(32.745,15.275),(32.915,15.275),(32.915,15.105),(32.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.445),(32.745,15.615),(32.915,15.615),(32.915,15.445),(32.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.225),(32.745,4.395),(32.915,4.395),(32.915,4.225),(32.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.565),(32.745,4.735),(32.915,4.735),(32.915,4.565),(32.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.225),(13.545,4.395),(13.715,4.395),(13.715,4.225),(13.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.565),(13.545,4.735),(13.715,4.735),(13.715,4.565),(13.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.605),(42.685,23.775),(42.855,23.775),(42.855,23.605),(42.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.225),(8.745,4.395),(8.915,4.395),(8.915,4.225),(8.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.965),(13.885,8.135),(14.055,8.135),(14.055,7.965),(13.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.565),(8.745,4.735),(8.915,4.735),(8.915,4.565),(8.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.265),(42.345,23.435),(42.515,23.435),(42.515,23.265),(42.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.265),(42.685,23.435),(42.855,23.435),(42.855,23.265),(42.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.605),(42.345,23.775),(42.515,23.775),(42.515,23.605),(42.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.965),(37.545,8.135),(37.715,8.135),(37.715,7.965),(37.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.685),(9.085,10.855),(9.255,10.855),(9.255,10.685),(9.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.785),(51.945,32.955),(52.115,32.955),(52.115,32.785),(51.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.165),(28.285,18.335),(28.455,18.335),(28.455,18.165),(28.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.505),(28.285,18.675),(28.455,18.675),(28.455,18.505),(28.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.105),(51.945,32.275),(52.115,32.275),(52.115,32.105),(51.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,22.585),(61.885,22.755),(62.055,22.755),(62.055,22.585),(61.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.445),(51.945,32.615),(52.115,32.615),(52.115,32.445),(51.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.005),(9.085,10.175),(9.255,10.175),(9.255,10.005),(9.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.345),(9.085,10.515),(9.255,10.515),(9.255,10.345),(9.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,22.245),(61.885,22.415),(62.055,22.415),(62.055,22.245),(61.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.985),(71.145,9.155),(71.315,9.155),(71.315,8.985),(71.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.985),(71.485,9.155),(71.655,9.155),(71.655,8.985),(71.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.865),(56.745,3.035),(56.915,3.035),(56.915,2.865),(56.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.305),(47.145,25.475),(47.315,25.475),(47.315,25.305),(47.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.305),(47.485,25.475),(47.655,25.475),(47.655,25.305),(47.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.645),(47.145,25.815),(47.315,25.815),(47.315,25.645),(47.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.645),(47.485,25.815),(47.655,25.815),(47.655,25.645),(47.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.865),(32.745,3.035),(32.915,3.035),(32.915,2.865),(32.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.985),(37.885,26.155),(38.055,26.155),(38.055,25.985),(37.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,23.605),(71.145,23.775),(71.315,23.775),(71.315,23.605),(71.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,23.265),(71.145,23.435),(71.315,23.435),(71.315,23.265),(71.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,23.265),(71.485,23.435),(71.655,23.435),(71.655,23.265),(71.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.945),(13.545,7.115),(13.715,7.115),(13.715,6.945),(13.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,23.605),(71.485,23.775),(71.655,23.775),(71.655,23.605),(71.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.985),(23.145,9.155),(23.315,9.155),(23.315,8.985),(23.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.985),(23.485,9.155),(23.655,9.155),(23.655,8.985),(23.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.965),(52.285,25.135),(52.455,25.135),(52.455,24.965),(52.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,2.865),(8.745,3.035),(8.915,3.035),(8.915,2.865),(8.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,32.785),(61.885,32.955),(62.055,32.955),(62.055,32.785),(61.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.525),(81.085,19.695),(81.255,19.695),(81.255,19.525),(81.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,32.105),(61.885,32.275),(62.055,32.275),(62.055,32.105),(61.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,32.445),(61.885,32.615),(62.055,32.615),(62.055,32.445),(61.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,39.925),(23.145,40.095),(23.315,40.095),(23.315,39.925),(23.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,39.925),(23.485,40.095),(23.655,40.095),(23.655,39.925),(23.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.385),(42.685,12.555),(42.855,12.555),(42.855,12.385),(42.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.165),(75.945,18.335),(76.115,18.335),(76.115,18.165),(75.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.505),(75.945,18.675),(76.115,18.675),(76.115,18.505),(75.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,29.725),(75.945,29.895),(76.115,29.895),(76.115,29.725),(75.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,29.045),(75.945,29.215),(76.115,29.215),(76.115,29.045),(75.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.905),(37.545,39.075),(37.715,39.075),(37.715,38.905),(37.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,29.385),(75.945,29.555),(76.115,29.555),(76.115,29.385),(75.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.545),(57.085,37.715),(57.255,37.715),(57.255,37.545),(57.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.205),(57.085,37.375),(57.255,37.375),(57.255,37.205),(57.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.765),(18.345,14.935),(18.515,14.935),(18.515,14.765),(18.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.965),(37.545,25.135),(37.715,25.135),(37.715,24.965),(37.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.765),(18.685,14.935),(18.855,14.935),(18.855,14.765),(18.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,35.845),(13.545,36.015),(13.715,36.015),(13.715,35.845),(13.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.085),(18.345,14.255),(18.515,14.255),(18.515,14.085),(18.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.085),(18.685,14.255),(18.855,14.255),(18.855,14.085),(18.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.425),(18.345,14.595),(18.515,14.595),(18.515,14.425),(18.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.425),(18.685,14.595),(18.855,14.595),(18.855,14.425),(18.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.305),(13.545,8.475),(13.715,8.475),(13.715,8.305),(13.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.645),(13.545,8.815),(13.715,8.815),(13.715,8.645),(13.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.545),(47.145,37.715),(47.315,37.715),(47.315,37.545),(47.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.205),(47.145,37.375),(47.315,37.375),(47.315,37.205),(47.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.205),(47.485,37.375),(47.655,37.375),(47.655,37.205),(47.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.545),(47.485,37.715),(47.655,37.715),(47.655,37.545),(47.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,40.605),(18.345,40.775),(18.515,40.775),(18.515,40.605),(18.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,28.025),(75.945,28.195),(76.115,28.195),(76.115,28.025),(75.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,28.365),(75.945,28.535),(76.115,28.535),(76.115,28.365),(75.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,35.845),(9.085,36.015),(9.255,36.015),(9.255,35.845),(9.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.945),(47.145,7.115),(47.315,7.115),(47.315,6.945),(47.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,24.285),(9.085,24.455),(9.255,24.455),(9.255,24.285),(9.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,24.625),(9.085,24.795),(9.255,24.795),(9.255,24.625),(9.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,22.245),(80.745,22.415),(80.915,22.415),(80.915,22.245),(80.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.205),(37.885,3.375),(38.055,3.375),(38.055,3.205),(37.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.545),(37.885,3.715),(38.055,3.715),(38.055,3.545),(37.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.945),(47.485,7.115),(47.655,7.115),(47.655,6.945),(47.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,25.645),(75.945,25.815),(76.115,25.815),(76.115,25.645),(75.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,25.305),(75.945,25.475),(76.115,25.475),(76.115,25.305),(75.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,2.865),(28.285,3.035),(28.455,3.035),(28.455,2.865),(28.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,22.585),(80.745,22.755),(80.915,22.755),(80.915,22.585),(80.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.905),(27.945,5.075),(28.115,5.075),(28.115,4.905),(27.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.145),(52.285,34.315),(52.455,34.315),(52.455,34.145),(52.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.485),(52.285,34.655),(52.455,34.655),(52.455,34.485),(52.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,24.965),(66.345,25.135),(66.515,25.135),(66.515,24.965),(66.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,24.965),(66.685,25.135),(66.855,25.135),(66.855,24.965),(66.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.825),(52.285,34.995),(52.455,34.995),(52.455,34.825),(52.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.865),(57.085,3.035),(57.255,3.035),(57.255,2.865),(57.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,20.205),(18.345,20.375),(18.515,20.375),(18.515,20.205),(18.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,20.205),(18.685,20.375),(18.855,20.375),(18.855,20.205),(18.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,20.545),(18.345,20.715),(18.515,20.715),(18.515,20.545),(18.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.845),(47.145,36.015),(47.315,36.015),(47.315,35.845),(47.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.845),(47.485,36.015),(47.655,36.015),(47.655,35.845),(47.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,2.865),(80.745,3.035),(80.915,3.035),(80.915,2.865),(80.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,20.545),(18.685,20.715),(18.855,20.715),(18.855,20.545),(18.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.185),(9.085,19.355),(9.255,19.355),(9.255,19.185),(9.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.525),(9.085,19.695),(9.255,19.695),(9.255,19.525),(9.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.865),(33.085,3.035),(33.255,3.035),(33.255,2.865),(33.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.165),(61.545,18.335),(61.715,18.335),(61.715,18.165),(61.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.505),(61.545,18.675),(61.715,18.675),(61.715,18.505),(61.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.425),(56.745,31.595),(56.915,31.595),(56.915,31.425),(56.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.865),(57.085,37.035),(57.255,37.035),(57.255,36.865),(57.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,30.745),(61.885,30.915),(62.055,30.915),(62.055,30.745),(61.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,30.065),(61.885,30.235),(62.055,30.235),(62.055,30.065),(61.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,30.405),(61.885,30.575),(62.055,30.575),(62.055,30.405),(61.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.945),(52.285,24.115),(52.455,24.115),(52.455,23.945),(52.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.685),(37.545,10.855),(37.715,10.855),(37.715,10.685),(37.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.005),(37.545,10.175),(37.715,10.175),(37.715,10.005),(37.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.345),(37.545,10.515),(37.715,10.515),(37.715,10.345),(37.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,22.245),(61.545,22.415),(61.715,22.415),(61.715,22.245),(61.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,22.585),(61.545,22.755),(61.715,22.755),(61.715,22.585),(61.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,39.925),(13.545,40.095),(13.715,40.095),(13.715,39.925),(13.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.305),(33.085,25.475),(33.255,25.475),(33.255,25.305),(33.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.645),(33.085,25.815),(33.255,25.815),(33.255,25.645),(33.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,26.665),(71.145,26.835),(71.315,26.835),(71.315,26.665),(71.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,26.665),(71.485,26.835),(71.655,26.835),(71.655,26.665),(71.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,26.325),(71.145,26.495),(71.315,26.495),(71.315,26.325),(71.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,26.325),(71.485,26.495),(71.655,26.495),(71.655,26.325),(71.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.865),(51.945,37.035),(52.115,37.035),(52.115,36.865),(51.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.225),(52.285,21.395),(52.455,21.395),(52.455,21.225),(52.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.565),(52.285,21.735),(52.455,21.735),(52.455,21.565),(52.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,32.105),(23.145,32.275),(23.315,32.275),(23.315,32.105),(23.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,32.105),(23.485,32.275),(23.655,32.275),(23.655,32.105),(23.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,27.345),(66.685,27.515),(66.855,27.515),(66.855,27.345),(66.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,27.005),(66.345,27.175),(66.515,27.175),(66.515,27.005),(66.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,27.005),(66.685,27.175),(66.855,27.175),(66.855,27.005),(66.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,27.345),(66.345,27.515),(66.515,27.515),(66.515,27.345),(66.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,39.245),(28.285,39.415),(28.455,39.415),(28.455,39.245),(28.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,39.585),(28.285,39.755),(28.455,39.755),(28.455,39.585),(28.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,32.445),(23.145,32.615),(23.315,32.615),(23.315,32.445),(23.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,32.445),(23.485,32.615),(23.655,32.615),(23.655,32.445),(23.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.985),(56.745,9.155),(56.915,9.155),(56.915,8.985),(56.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,27.685),(66.345,27.855),(66.515,27.855),(66.515,27.685),(66.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.245),(51.945,5.415),(52.115,5.415),(52.115,5.245),(51.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.585),(51.945,5.755),(52.115,5.755),(52.115,5.585),(51.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.685),(42.345,10.855),(42.515,10.855),(42.515,10.685),(42.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,20.885),(13.545,21.055),(13.715,21.055),(13.715,20.885),(13.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.685),(42.685,10.855),(42.855,10.855),(42.855,10.685),(42.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,26.325),(75.945,26.495),(76.115,26.495),(76.115,26.325),(75.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.005),(42.345,10.175),(42.515,10.175),(42.515,10.005),(42.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.005),(42.685,10.175),(42.855,10.175),(42.855,10.005),(42.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.345),(42.345,10.515),(42.515,10.515),(42.515,10.345),(42.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.345),(42.685,10.515),(42.855,10.515),(42.855,10.345),(42.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,26.665),(75.945,26.835),(76.115,26.835),(76.115,26.665),(75.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.085),(47.485,14.255),(47.655,14.255),(47.655,14.085),(47.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.765),(47.145,14.935),(47.315,14.935),(47.315,14.765),(47.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.765),(47.485,14.935),(47.655,14.935),(47.655,14.765),(47.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.225),(61.545,4.395),(61.715,4.395),(61.715,4.225),(61.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.565),(61.545,4.735),(61.715,4.735),(61.715,4.565),(61.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.225),(37.885,38.395),(38.055,38.395),(38.055,38.225),(37.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.565),(37.885,38.735),(38.055,38.735),(38.055,38.565),(37.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.085),(47.145,14.255),(47.315,14.255),(47.315,14.085),(47.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.645),(42.685,25.815),(42.855,25.815),(42.855,25.645),(42.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.425),(47.145,14.595),(47.315,14.595),(47.315,14.425),(47.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.645),(42.345,25.815),(42.515,25.815),(42.515,25.645),(42.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.985),(8.745,9.155),(8.915,9.155),(8.915,8.985),(8.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,27.685),(76.285,27.855),(76.455,27.855),(76.455,27.685),(76.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,27.005),(76.285,27.175),(76.455,27.175),(76.455,27.005),(76.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.285),(52.285,7.455),(52.455,7.455),(52.455,7.285),(52.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.625),(52.285,7.795),(52.455,7.795),(52.455,7.625),(52.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,30.065),(71.145,30.235),(71.315,30.235),(71.315,30.065),(71.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,30.065),(71.485,30.235),(71.655,30.235),(71.655,30.065),(71.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,30.405),(71.145,30.575),(71.315,30.575),(71.315,30.405),(71.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,30.405),(71.485,30.575),(71.655,30.575),(71.655,30.405),(71.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,30.745),(71.145,30.915),(71.315,30.915),(71.315,30.745),(71.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,30.745),(71.485,30.915),(71.655,30.915),(71.655,30.745),(71.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.025),(33.085,28.195),(33.255,28.195),(33.255,28.025),(33.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.365),(33.085,28.535),(33.255,28.535),(33.255,28.365),(33.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.705),(33.085,28.875),(33.255,28.875),(33.255,28.705),(33.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.345),(57.085,10.515),(57.255,10.515),(57.255,10.345),(57.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.005),(57.085,10.175),(57.255,10.175),(57.255,10.005),(57.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.685),(57.085,10.855),(57.255,10.855),(57.255,10.685),(57.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,37.205),(81.085,37.375),(81.255,37.375),(81.255,37.205),(81.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,37.545),(81.085,37.715),(81.255,37.715),(81.255,37.545),(81.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,26.665),(81.085,26.835),(81.255,26.835),(81.255,26.665),(81.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,26.325),(81.085,26.495),(81.255,26.495),(81.255,26.325),(81.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,23.265),(13.545,23.435),(13.715,23.435),(13.715,23.265),(13.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,23.605),(13.545,23.775),(13.715,23.775),(13.715,23.605),(13.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,25.985),(13.545,26.155),(13.715,26.155),(13.715,25.985),(13.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.905),(42.345,22.075),(42.515,22.075),(42.515,21.905),(42.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.905),(42.685,22.075),(42.855,22.075),(42.855,21.905),(42.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.925),(37.885,40.095),(38.055,40.095),(38.055,39.925),(37.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.945),(61.545,7.115),(61.715,7.115),(61.715,6.945),(61.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,24.965),(28.285,25.135),(28.455,25.135),(28.455,24.965),(28.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.665),(61.885,9.835),(62.055,9.835),(62.055,9.665),(61.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.225),(52.285,38.395),(52.455,38.395),(52.455,38.225),(52.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.565),(52.285,38.735),(52.455,38.735),(52.455,38.565),(52.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.325),(61.885,9.495),(62.055,9.495),(62.055,9.325),(61.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,35.165),(13.885,35.335),(14.055,35.335),(14.055,35.165),(13.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,35.505),(13.885,35.675),(14.055,35.675),(14.055,35.505),(13.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,22.245),(66.345,22.415),(66.515,22.415),(66.515,22.245),(66.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,22.245),(66.685,22.415),(66.855,22.415),(66.855,22.245),(66.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,22.585),(66.345,22.755),(66.515,22.755),(66.515,22.585),(66.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,22.585),(66.685,22.755),(66.855,22.755),(66.855,22.585),(66.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.325),(71.485,9.495),(71.655,9.495),(71.655,9.325),(71.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.325),(71.145,9.495),(71.315,9.495),(71.315,9.325),(71.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.665),(71.145,9.835),(71.315,9.835),(71.315,9.665),(71.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.665),(71.485,9.835),(71.655,9.835),(71.655,9.665),(71.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.925),(47.145,40.095),(47.315,40.095),(47.315,39.925),(47.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.925),(47.485,40.095),(47.655,40.095),(47.655,39.925),(47.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.325),(13.885,9.495),(14.055,9.495),(14.055,9.325),(13.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.805),(56.745,16.975),(56.915,16.975),(56.915,16.805),(56.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.125),(56.745,16.295),(56.915,16.295),(56.915,16.125),(56.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.765),(56.745,31.935),(56.915,31.935),(56.915,31.765),(56.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,24.965),(13.545,25.135),(13.715,25.135),(13.715,24.965),(13.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.465),(56.745,16.635),(56.915,16.635),(56.915,16.465),(56.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.665),(13.885,9.835),(14.055,9.835),(14.055,9.665),(13.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,27.005),(23.485,27.175),(23.655,27.175),(23.655,27.005),(23.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,23.945),(18.345,24.115),(18.515,24.115),(18.515,23.945),(18.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.105),(33.085,15.275),(33.255,15.275),(33.255,15.105),(33.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.445),(33.085,15.615),(33.255,15.615),(33.255,15.445),(33.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.165),(56.745,35.335),(56.915,35.335),(56.915,35.165),(56.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,23.945),(18.685,24.115),(18.855,24.115),(18.855,23.945),(18.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.305),(61.545,8.475),(61.715,8.475),(61.715,8.305),(61.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.645),(61.545,8.815),(61.715,8.815),(61.715,8.645),(61.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.785),(33.085,15.955),(33.255,15.955),(33.255,15.785),(33.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.505),(56.745,35.675),(56.915,35.675),(56.915,35.505),(56.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,40.265),(61.885,40.435),(62.055,40.435),(62.055,40.265),(61.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.445),(80.745,15.615),(80.915,15.615),(80.915,15.445),(80.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.105),(80.745,15.275),(80.915,15.275),(80.915,15.105),(80.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.785),(80.745,15.955),(80.915,15.955),(80.915,15.785),(80.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,40.605),(61.885,40.775),(62.055,40.775),(62.055,40.605),(61.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.645),(52.285,25.815),(52.455,25.815),(52.455,25.645),(52.285,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.865),(76.285,20.035),(76.455,20.035),(76.455,19.865),(76.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.685),(52.285,10.855),(52.455,10.855),(52.455,10.685),(52.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.345),(52.285,10.515),(52.455,10.515),(52.455,10.345),(52.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.005),(52.285,10.175),(52.455,10.175),(52.455,10.005),(52.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.945),(71.145,7.115),(71.315,7.115),(71.315,6.945),(71.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.265),(23.485,6.435),(23.655,6.435),(23.655,6.265),(23.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.945),(71.485,7.115),(71.655,7.115),(71.655,6.945),(71.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.185),(33.085,36.355),(33.255,36.355),(33.255,36.185),(33.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.525),(33.085,36.695),(33.255,36.695),(33.255,36.525),(33.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.805),(13.545,16.975),(13.715,16.975),(13.715,16.805),(13.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.125),(13.545,16.295),(13.715,16.295),(13.715,16.125),(13.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.465),(13.545,16.635),(13.715,16.635),(13.715,16.465),(13.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,36.185),(9.085,36.355),(9.255,36.355),(9.255,36.185),(9.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,36.525),(9.085,36.695),(9.255,36.695),(9.255,36.525),(9.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.565),(33.085,21.735),(33.255,21.735),(33.255,21.565),(33.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.225),(33.085,21.395),(33.255,21.395),(33.255,21.225),(33.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.065),(71.145,13.235),(71.315,13.235),(71.315,13.065),(71.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.065),(71.485,13.235),(71.655,13.235),(71.655,13.065),(71.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.405),(71.145,13.575),(71.315,13.575),(71.315,13.405),(71.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.405),(71.485,13.575),(71.655,13.575),(71.655,13.405),(71.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.725),(71.145,12.895),(71.315,12.895),(71.315,12.725),(71.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.725),(71.485,12.895),(71.655,12.895),(71.655,12.725),(71.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.745),(71.145,13.915),(71.315,13.915),(71.315,13.745),(71.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.745),(71.485,13.915),(71.655,13.915),(71.655,13.745),(71.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,39.245),(76.285,39.415),(76.455,39.415),(76.455,39.245),(76.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,39.585),(76.285,39.755),(76.455,39.755),(76.455,39.585),(76.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.945),(13.885,7.115),(14.055,7.115),(14.055,6.945),(13.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.045),(71.145,12.215),(71.315,12.215),(71.315,12.045),(71.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,21.225),(23.145,21.395),(23.315,21.395),(23.315,21.225),(23.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,21.565),(23.145,21.735),(23.315,21.735),(23.315,21.565),(23.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,21.565),(23.485,21.735),(23.655,21.735),(23.655,21.565),(23.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,21.225),(23.485,21.395),(23.655,21.395),(23.655,21.225),(23.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,39.925),(27.945,40.095),(28.115,40.095),(28.115,39.925),(27.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.345),(18.345,10.515),(18.515,10.515),(18.515,10.345),(18.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.805),(28.285,16.975),(28.455,16.975),(28.455,16.805),(28.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.125),(28.285,16.295),(28.455,16.295),(28.455,16.125),(28.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,27.005),(13.545,27.175),(13.715,27.175),(13.715,27.005),(13.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,27.345),(13.545,27.515),(13.715,27.515),(13.715,27.345),(13.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.465),(28.285,16.635),(28.455,16.635),(28.455,16.465),(28.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,27.685),(13.545,27.855),(13.715,27.855),(13.715,27.685),(13.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,35.845),(27.945,36.015),(28.115,36.015),(28.115,35.845),(27.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.045),(23.145,12.215),(23.315,12.215),(23.315,12.045),(23.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.045),(23.485,12.215),(23.655,12.215),(23.655,12.045),(23.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.065),(42.685,13.235),(42.855,13.235),(42.855,13.065),(42.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.385),(23.145,12.555),(23.315,12.555),(23.315,12.385),(23.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.385),(23.485,12.555),(23.655,12.555),(23.655,12.385),(23.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.745),(42.685,13.915),(42.855,13.915),(42.855,13.745),(42.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.065),(42.345,13.235),(42.515,13.235),(42.515,13.065),(42.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.885),(52.285,4.055),(52.455,4.055),(52.455,3.885),(52.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.405),(42.345,13.575),(42.515,13.575),(42.515,13.405),(42.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.685),(13.545,10.855),(13.715,10.855),(13.715,10.685),(13.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.745),(42.345,13.915),(42.515,13.915),(42.515,13.745),(42.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.405),(42.685,13.575),(42.855,13.575),(42.855,13.405),(42.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,23.265),(27.945,23.435),(28.115,23.435),(28.115,23.265),(27.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,23.605),(27.945,23.775),(28.115,23.775),(28.115,23.605),(27.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.905),(33.085,39.075),(33.255,39.075),(33.255,38.905),(33.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.785),(81.085,15.955),(81.255,15.955),(81.255,15.785),(81.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.105),(81.085,15.275),(81.255,15.275),(81.255,15.105),(81.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.445),(81.085,15.615),(81.255,15.615),(81.255,15.445),(81.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,38.905),(9.085,39.075),(9.255,39.075),(9.255,38.905),(9.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,20.205),(28.285,20.375),(28.455,20.375),(28.455,20.205),(28.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,20.545),(28.285,20.715),(28.455,20.715),(28.455,20.545),(28.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.925),(51.945,23.095),(52.115,23.095),(52.115,22.925),(51.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.825),(18.345,17.995),(18.515,17.995),(18.515,17.825),(18.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.825),(18.685,17.995),(18.855,17.995),(18.855,17.825),(18.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.145),(18.345,17.315),(18.515,17.315),(18.515,17.145),(18.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.145),(18.685,17.315),(18.855,17.315),(18.855,17.145),(18.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.485),(18.345,17.655),(18.515,17.655),(18.515,17.485),(18.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.485),(18.685,17.655),(18.855,17.655),(18.855,17.485),(18.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,37.205),(28.285,37.375),(28.455,37.375),(28.455,37.205),(28.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,37.545),(28.285,37.715),(28.455,37.715),(28.455,37.545),(28.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.265),(56.745,23.435),(56.915,23.435),(56.915,23.265),(56.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,39.245),(13.885,39.415),(14.055,39.415),(14.055,39.245),(13.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,39.585),(13.885,39.755),(14.055,39.755),(14.055,39.585),(13.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.605),(56.745,23.775),(56.915,23.775),(56.915,23.605),(56.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,38.905),(80.745,39.075),(80.915,39.075),(80.915,38.905),(80.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.265),(28.285,6.435),(28.455,6.435),(28.455,6.265),(28.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.605),(28.285,6.775),(28.455,6.775),(28.455,6.605),(28.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,24.965),(80.745,25.135),(80.915,25.135),(80.915,24.965),(80.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.165),(13.885,18.335),(14.055,18.335),(14.055,18.165),(13.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.505),(13.885,18.675),(14.055,18.675),(14.055,18.505),(13.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,22.245),(81.085,22.415),(81.255,22.415),(81.255,22.245),(81.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,22.585),(81.085,22.755),(81.255,22.755),(81.255,22.585),(81.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,32.445),(71.485,32.615),(71.655,32.615),(71.655,32.445),(71.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,32.105),(71.145,32.275),(71.315,32.275),(71.315,32.105),(71.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,32.105),(71.485,32.275),(71.655,32.275),(71.655,32.105),(71.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,32.445),(71.145,32.615),(71.315,32.615),(71.315,32.445),(71.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,32.785),(71.145,32.955),(71.315,32.955),(71.315,32.785),(71.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,32.785),(71.485,32.955),(71.655,32.955),(71.655,32.785),(71.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.645),(18.345,8.815),(18.515,8.815),(18.515,8.645),(18.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.645),(18.685,8.815),(18.855,8.815),(18.855,8.645),(18.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.305),(18.345,8.475),(18.515,8.475),(18.515,8.305),(18.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.305),(18.685,8.475),(18.855,8.475),(18.855,8.305),(18.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,36.865),(18.345,37.035),(18.515,37.035),(18.515,36.865),(18.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.985),(51.945,26.155),(52.115,26.155),(52.115,25.985),(51.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.205),(51.945,20.375),(52.115,20.375),(52.115,20.205),(51.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.545),(51.945,20.715),(52.115,20.715),(52.115,20.545),(51.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,38.225),(81.085,38.395),(81.255,38.395),(81.255,38.225),(81.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.905),(76.285,5.075),(76.455,5.075),(76.455,4.905),(76.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.865),(33.085,20.035),(33.255,20.035),(33.255,19.865),(33.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,38.565),(81.085,38.735),(81.255,38.735),(81.255,38.565),(81.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.685),(33.085,27.855),(33.255,27.855),(33.255,27.685),(33.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.005),(33.085,27.175),(33.255,27.175),(33.255,27.005),(33.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.345),(33.085,27.515),(33.255,27.515),(33.255,27.345),(33.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,2.865),(81.085,3.035),(81.255,3.035),(81.255,2.865),(81.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.125),(37.885,33.295),(38.055,33.295),(38.055,33.125),(37.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.465),(37.885,33.635),(38.055,33.635),(38.055,33.465),(37.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.805),(37.885,33.975),(38.055,33.975),(38.055,33.805),(37.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.245),(51.945,39.415),(52.115,39.415),(52.115,39.245),(51.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.585),(51.945,39.755),(52.115,39.755),(52.115,39.585),(51.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.745),(37.885,30.915),(38.055,30.915),(38.055,30.745),(37.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.845),(32.745,36.015),(32.915,36.015),(32.915,35.845),(32.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.065),(37.885,30.235),(38.055,30.235),(38.055,30.065),(37.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.405),(37.885,30.575),(38.055,30.575),(38.055,30.405),(37.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.565),(23.145,4.735),(23.315,4.735),(23.315,4.565),(23.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.945),(66.345,7.115),(66.515,7.115),(66.515,6.945),(66.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.945),(66.685,7.115),(66.855,7.115),(66.855,6.945),(66.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.965),(47.145,25.135),(47.315,25.135),(47.315,24.965),(47.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.965),(47.485,25.135),(47.655,25.135),(47.655,24.965),(47.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.265),(51.945,6.435),(52.115,6.435),(52.115,6.265),(51.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.605),(51.945,6.775),(52.115,6.775),(52.115,6.605),(51.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.905),(28.285,5.075),(28.455,5.075),(28.455,4.905),(28.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,36.865),(13.885,37.035),(14.055,37.035),(14.055,36.865),(13.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,35.845),(8.745,36.015),(8.915,36.015),(8.915,35.845),(8.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,25.985),(13.885,26.155),(14.055,26.155),(14.055,25.985),(13.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.065),(47.145,30.235),(47.315,30.235),(47.315,30.065),(47.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.185),(52.285,36.355),(52.455,36.355),(52.455,36.185),(52.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.525),(52.285,36.695),(52.455,36.695),(52.455,36.525),(52.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,29.385),(80.745,29.555),(80.915,29.555),(80.915,29.385),(80.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,29.725),(80.745,29.895),(80.915,29.895),(80.915,29.725),(80.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,29.045),(80.745,29.215),(80.915,29.215),(80.915,29.045),(80.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.905),(47.145,22.075),(47.315,22.075),(47.315,21.905),(47.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.905),(47.485,22.075),(47.655,22.075),(47.655,21.905),(47.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.865),(23.485,20.035),(23.655,20.035),(23.655,19.865),(23.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.685),(28.285,10.855),(28.455,10.855),(28.455,10.685),(28.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.005),(28.285,10.175),(28.455,10.175),(28.455,10.005),(28.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.345),(28.285,10.515),(28.455,10.515),(28.455,10.345),(28.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.865),(23.145,20.035),(23.315,20.035),(23.315,19.865),(23.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,21.905),(80.745,22.075),(80.915,22.075),(80.915,21.905),(80.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.845),(51.945,19.015),(52.115,19.015),(52.115,18.845),(51.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,39.925),(75.945,40.095),(76.115,40.095),(76.115,39.925),(75.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.845),(42.345,19.015),(42.515,19.015),(42.515,18.845),(42.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.845),(42.685,19.015),(42.855,19.015),(42.855,18.845),(42.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.885),(51.945,38.055),(52.115,38.055),(52.115,37.885),(51.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,24.965),(18.345,25.135),(18.515,25.135),(18.515,24.965),(18.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,24.965),(18.685,25.135),(18.855,25.135),(18.855,24.965),(18.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.225),(80.745,4.395),(80.915,4.395),(80.915,4.225),(80.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.565),(80.745,4.735),(80.915,4.735),(80.915,4.565),(80.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,33.125),(8.745,33.295),(8.915,33.295),(8.915,33.125),(8.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,33.465),(8.745,33.635),(8.915,33.635),(8.915,33.465),(8.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,33.805),(8.745,33.975),(8.915,33.975),(8.915,33.805),(8.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,2.865),(76.285,3.035),(76.455,3.035),(76.455,2.865),(76.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,23.945),(23.485,24.115),(23.655,24.115),(23.655,23.945),(23.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.905),(75.945,5.075),(76.115,5.075),(76.115,4.905),(75.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,23.945),(23.145,24.115),(23.315,24.115),(23.315,23.945),(23.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,22.245),(13.885,22.415),(14.055,22.415),(14.055,22.245),(13.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,22.585),(13.885,22.755),(14.055,22.755),(14.055,22.585),(13.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,33.465),(9.085,33.635),(9.255,33.635),(9.255,33.465),(9.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,37.205),(75.945,37.375),(76.115,37.375),(76.115,37.205),(75.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.945),(61.885,7.115),(62.055,7.115),(62.055,6.945),(61.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,37.545),(75.945,37.715),(76.115,37.715),(76.115,37.545),(75.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.045),(56.745,29.215),(56.915,29.215),(56.915,29.045),(56.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.385),(56.745,29.555),(56.915,29.555),(56.915,29.385),(56.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.725),(56.745,29.895),(56.915,29.895),(56.915,29.725),(56.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.065),(57.085,13.235),(57.255,13.235),(57.255,13.065),(57.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.405),(57.085,13.575),(57.255,13.575),(57.255,13.405),(57.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.745),(57.085,13.915),(57.255,13.915),(57.255,13.745),(57.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.685),(61.545,10.855),(61.715,10.855),(61.715,10.685),(61.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.345),(61.545,10.515),(61.715,10.515),(61.715,10.345),(61.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.005),(61.545,10.175),(61.715,10.175),(61.715,10.005),(61.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.145),(13.885,17.315),(14.055,17.315),(14.055,17.145),(13.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.485),(13.885,17.655),(14.055,17.655),(14.055,17.485),(13.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.825),(13.885,17.995),(14.055,17.995),(14.055,17.825),(13.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,35.165),(81.085,35.335),(81.255,35.335),(81.255,35.165),(81.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,35.505),(81.085,35.675),(81.255,35.675),(81.255,35.505),(81.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.165),(18.345,18.335),(18.515,18.335),(18.515,18.165),(18.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.165),(18.685,18.335),(18.855,18.335),(18.855,18.165),(18.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.505),(18.345,18.675),(18.515,18.675),(18.515,18.505),(18.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.505),(18.685,18.675),(18.855,18.675),(18.855,18.505),(18.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.305),(52.285,8.475),(52.455,8.475),(52.455,8.305),(52.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.645),(52.285,8.815),(52.455,8.815),(52.455,8.645),(52.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.065),(9.085,13.235),(9.255,13.235),(9.255,13.065),(9.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.405),(9.085,13.575),(9.255,13.575),(9.255,13.405),(9.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.745),(9.085,13.915),(9.255,13.915),(9.255,13.745),(9.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,27.345),(18.345,27.515),(18.515,27.515),(18.515,27.345),(18.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,27.345),(18.685,27.515),(18.855,27.515),(18.855,27.345),(18.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,27.005),(18.345,27.175),(18.515,27.175),(18.515,27.005),(18.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,27.005),(18.685,27.175),(18.855,27.175),(18.855,27.005),(18.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.185),(42.345,36.355),(42.515,36.355),(42.515,36.185),(42.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.525),(42.345,36.695),(42.515,36.695),(42.515,36.525),(42.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.185),(42.685,36.355),(42.855,36.355),(42.855,36.185),(42.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.525),(42.685,36.695),(42.855,36.695),(42.855,36.525),(42.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,27.685),(18.345,27.855),(18.515,27.855),(18.515,27.685),(18.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,27.685),(18.685,27.855),(18.855,27.855),(18.855,27.685),(18.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.965),(51.945,8.135),(52.115,8.135),(52.115,7.965),(51.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.945),(18.685,7.115),(18.855,7.115),(18.855,6.945),(18.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.945),(18.345,7.115),(18.515,7.115),(18.515,6.945),(18.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.965),(33.085,25.135),(33.255,25.135),(33.255,24.965),(33.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,21.225),(13.885,21.395),(14.055,21.395),(14.055,21.225),(13.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,21.565),(13.885,21.735),(14.055,21.735),(14.055,21.565),(13.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.165),(51.945,35.335),(52.115,35.335),(52.115,35.165),(51.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.505),(51.945,35.675),(52.115,35.675),(52.115,35.505),(51.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.265),(37.885,23.435),(38.055,23.435),(38.055,23.265),(37.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.605),(37.885,23.775),(38.055,23.775),(38.055,23.605),(37.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,38.905),(27.945,39.075),(28.115,39.075),(28.115,38.905),(27.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,20.885),(80.745,21.055),(80.915,21.055),(80.915,20.885),(80.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.305),(42.685,25.475),(42.855,25.475),(42.855,25.305),(42.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,39.925),(66.345,40.095),(66.515,40.095),(66.515,39.925),(66.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,39.925),(66.685,40.095),(66.855,40.095),(66.855,39.925),(66.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.205),(37.885,20.375),(38.055,20.375),(38.055,20.205),(37.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.545),(37.885,20.715),(38.055,20.715),(38.055,20.545),(37.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.225),(32.745,21.395),(32.915,21.395),(32.915,21.225),(32.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.565),(32.745,21.735),(32.915,21.735),(32.915,21.565),(32.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,25.985),(27.945,26.155),(28.115,26.155),(28.115,25.985),(27.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.085),(52.285,31.255),(52.455,31.255),(52.455,31.085),(52.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.425),(52.285,31.595),(52.455,31.595),(52.455,31.425),(52.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.765),(52.285,31.935),(52.455,31.935),(52.455,31.765),(52.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.785),(51.945,15.955),(52.115,15.955),(52.115,15.785),(51.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.105),(51.945,15.275),(52.115,15.275),(52.115,15.105),(51.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.445),(51.945,15.615),(52.115,15.615),(52.115,15.445),(51.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.945),(56.745,24.115),(56.915,24.115),(56.915,23.945),(56.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.165),(13.545,18.335),(13.715,18.335),(13.715,18.165),(13.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.505),(13.545,18.675),(13.715,18.675),(13.715,18.505),(13.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.165),(80.745,18.335),(80.915,18.335),(80.915,18.165),(80.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.805),(57.085,33.975),(57.255,33.975),(57.255,33.805),(57.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.505),(80.745,18.675),(80.915,18.675),(80.915,18.505),(80.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.125),(57.085,33.295),(57.255,33.295),(57.255,33.125),(57.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.465),(57.085,33.635),(57.255,33.635),(57.255,33.465),(57.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,30.065),(13.885,30.235),(14.055,30.235),(14.055,30.065),(13.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,30.405),(13.885,30.575),(14.055,30.575),(14.055,30.405),(13.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,30.745),(13.885,30.915),(14.055,30.915),(14.055,30.745),(13.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,24.285),(71.145,24.455),(71.315,24.455),(71.315,24.285),(71.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,24.285),(71.485,24.455),(71.655,24.455),(71.655,24.285),(71.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,24.625),(71.145,24.795),(71.315,24.795),(71.315,24.625),(71.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,24.625),(71.485,24.795),(71.655,24.795),(71.655,24.625),(71.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,36.185),(27.945,36.355),(28.115,36.355),(28.115,36.185),(27.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,36.525),(27.945,36.695),(28.115,36.695),(28.115,36.525),(27.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,32.785),(18.345,32.955),(18.515,32.955),(18.515,32.785),(18.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,37.205),(13.545,37.375),(13.715,37.375),(13.715,37.205),(13.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,37.545),(13.545,37.715),(13.715,37.715),(13.715,37.545),(13.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.925),(37.545,6.095),(37.715,6.095),(37.715,5.925),(37.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,40.605),(23.485,40.775),(23.655,40.775),(23.655,40.605),(23.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,22.245),(13.545,22.415),(13.715,22.415),(13.715,22.245),(13.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,22.585),(13.545,22.755),(13.715,22.755),(13.715,22.585),(13.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,21.225),(27.945,21.395),(28.115,21.395),(28.115,21.225),(27.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,21.565),(27.945,21.735),(28.115,21.735),(28.115,21.565),(27.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.945),(42.345,7.115),(42.515,7.115),(42.515,6.945),(42.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.945),(42.685,7.115),(42.855,7.115),(42.855,6.945),(42.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,23.945),(81.085,24.115),(81.255,24.115),(81.255,23.945),(81.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,32.785),(23.145,32.955),(23.315,32.955),(23.315,32.785),(23.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.905),(56.745,39.075),(56.915,39.075),(56.915,38.905),(56.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,35.505),(23.145,35.675),(23.315,35.675),(23.315,35.505),(23.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,35.505),(23.485,35.675),(23.655,35.675),(23.655,35.505),(23.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,35.165),(23.145,35.335),(23.315,35.335),(23.315,35.165),(23.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,35.165),(23.485,35.335),(23.655,35.335),(23.655,35.165),(23.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.365),(71.485,11.535),(71.655,11.535),(71.655,11.365),(71.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.285),(37.545,7.455),(37.715,7.455),(37.715,7.285),(37.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.025),(71.145,11.195),(71.315,11.195),(71.315,11.025),(71.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.025),(71.485,11.195),(71.655,11.195),(71.655,11.025),(71.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.365),(71.145,11.535),(71.315,11.535),(71.315,11.365),(71.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,40.265),(57.085,40.435),(57.255,40.435),(57.255,40.265),(57.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.625),(37.545,7.795),(37.715,7.795),(37.715,7.625),(37.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,40.605),(57.085,40.775),(57.255,40.775),(57.255,40.605),(57.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.705),(71.145,11.875),(71.315,11.875),(71.315,11.705),(71.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.145),(27.945,17.315),(28.115,17.315),(28.115,17.145),(27.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.485),(27.945,17.655),(28.115,17.655),(28.115,17.485),(27.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.825),(27.945,17.995),(28.115,17.995),(28.115,17.825),(27.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.205),(75.945,3.375),(76.115,3.375),(76.115,3.205),(75.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.545),(75.945,3.715),(76.115,3.715),(76.115,3.545),(75.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.305),(66.345,8.475),(66.515,8.475),(66.515,8.305),(66.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.305),(66.685,8.475),(66.855,8.475),(66.855,8.305),(66.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.645),(66.345,8.815),(66.515,8.815),(66.515,8.645),(66.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.645),(66.685,8.815),(66.855,8.815),(66.855,8.645),(66.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.145),(37.545,17.315),(37.715,17.315),(37.715,17.145),(37.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.485),(37.545,17.655),(37.715,17.655),(37.715,17.485),(37.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.025),(23.145,11.195),(23.315,11.195),(23.315,11.025),(23.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.825),(37.545,17.995),(37.715,17.995),(37.715,17.825),(37.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.705),(23.145,11.875),(23.315,11.875),(23.315,11.705),(23.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.705),(23.485,11.875),(23.655,11.875),(23.655,11.705),(23.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.645),(76.285,8.815),(76.455,8.815),(76.455,8.645),(76.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,39.925),(18.685,40.095),(18.855,40.095),(18.855,39.925),(18.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.365),(23.145,11.535),(23.315,11.535),(23.315,11.365),(23.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.365),(23.485,11.535),(23.655,11.535),(23.655,11.365),(23.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.305),(76.285,8.475),(76.455,8.475),(76.455,8.305),(76.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,39.925),(18.345,40.095),(18.515,40.095),(18.515,39.925),(18.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.205),(27.945,3.375),(28.115,3.375),(28.115,3.205),(27.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.545),(27.945,3.715),(28.115,3.715),(28.115,3.545),(27.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.125),(23.145,16.295),(23.315,16.295),(23.315,16.125),(23.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.125),(23.485,16.295),(23.655,16.295),(23.655,16.125),(23.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.465),(23.145,16.635),(23.315,16.635),(23.315,16.465),(23.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.465),(23.485,16.635),(23.655,16.635),(23.655,16.465),(23.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.805),(23.145,16.975),(23.315,16.975),(23.315,16.805),(23.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.805),(23.485,16.975),(23.655,16.975),(23.655,16.805),(23.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.085),(32.745,14.255),(32.915,14.255),(32.915,14.085),(32.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.425),(32.745,14.595),(32.915,14.595),(32.915,14.425),(32.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.705),(42.345,11.875),(42.515,11.875),(42.515,11.705),(42.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.705),(42.685,11.875),(42.855,11.875),(42.855,11.705),(42.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.365),(42.345,11.535),(42.515,11.535),(42.515,11.365),(42.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.025),(42.345,11.195),(42.515,11.195),(42.515,11.025),(42.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.025),(42.685,11.195),(42.855,11.195),(42.855,11.025),(42.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.365),(42.685,11.535),(42.855,11.535),(42.855,11.365),(42.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,40.265),(37.545,40.435),(37.715,40.435),(37.715,40.265),(37.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,40.605),(37.545,40.775),(37.715,40.775),(37.715,40.605),(37.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.305),(28.285,8.475),(28.455,8.475),(28.455,8.305),(28.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.645),(28.285,8.815),(28.455,8.815),(28.455,8.645),(28.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.925),(76.285,6.095),(76.455,6.095),(76.455,5.925),(76.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,29.725),(81.085,29.895),(81.255,29.895),(81.255,29.725),(81.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,29.045),(81.085,29.215),(81.255,29.215),(81.255,29.045),(81.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,31.765),(8.745,31.935),(8.915,31.935),(8.915,31.765),(8.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,31.085),(8.745,31.255),(8.915,31.255),(8.915,31.085),(8.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,28.705),(81.085,28.875),(81.255,28.875),(81.255,28.705),(81.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,20.205),(23.145,20.375),(23.315,20.375),(23.315,20.205),(23.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,20.545),(23.145,20.715),(23.315,20.715),(23.315,20.545),(23.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,31.425),(8.745,31.595),(8.915,31.595),(8.915,31.425),(8.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,33.805),(81.085,33.975),(81.255,33.975),(81.255,33.805),(81.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,20.545),(23.485,20.715),(23.655,20.715),(23.655,20.545),(23.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,33.125),(81.085,33.295),(81.255,33.295),(81.255,33.125),(81.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,33.465),(81.085,33.635),(81.255,33.635),(81.255,33.465),(81.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,20.205),(23.485,20.375),(23.655,20.375),(23.655,20.205),(23.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,28.025),(81.085,28.195),(81.255,28.195),(81.255,28.025),(81.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.925),(28.285,6.095),(28.455,6.095),(28.455,5.925),(28.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,23.605),(61.885,23.775),(62.055,23.775),(62.055,23.605),(61.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,31.085),(66.345,31.255),(66.515,31.255),(66.515,31.085),(66.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,31.085),(66.685,31.255),(66.855,31.255),(66.855,31.085),(66.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,31.425),(66.345,31.595),(66.515,31.595),(66.515,31.425),(66.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,31.425),(66.685,31.595),(66.855,31.595),(66.855,31.425),(66.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,31.765),(66.345,31.935),(66.515,31.935),(66.515,31.765),(66.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,31.765),(66.685,31.935),(66.855,31.935),(66.855,31.765),(66.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.125),(51.945,33.295),(52.115,33.295),(52.115,33.125),(51.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.465),(51.945,33.635),(52.115,33.635),(52.115,33.465),(51.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.805),(51.945,33.975),(52.115,33.975),(52.115,33.805),(51.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.885),(42.685,38.055),(42.855,38.055),(42.855,37.885),(42.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.885),(42.345,38.055),(42.515,38.055),(42.515,37.885),(42.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.785),(75.945,15.955),(76.115,15.955),(76.115,15.785),(75.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.105),(75.945,15.275),(76.115,15.275),(76.115,15.105),(75.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.445),(75.945,15.615),(76.115,15.615),(76.115,15.445),(75.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.185),(28.285,19.355),(28.455,19.355),(28.455,19.185),(28.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.525),(28.285,19.695),(28.455,19.695),(28.455,19.525),(28.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.305),(57.085,25.475),(57.255,25.475),(57.255,25.305),(57.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.645),(57.085,25.815),(57.255,25.815),(57.255,25.645),(57.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.885),(57.085,21.055),(57.255,21.055),(57.255,20.885),(57.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.265),(76.285,6.435),(76.455,6.435),(76.455,6.265),(76.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.605),(76.285,6.775),(76.455,6.775),(76.455,6.605),(76.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.565),(42.685,4.735),(42.855,4.735),(42.855,4.565),(42.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.105),(27.945,15.275),(28.115,15.275),(28.115,15.105),(27.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.445),(27.945,15.615),(28.115,15.615),(28.115,15.445),(27.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.785),(27.945,15.955),(28.115,15.955),(28.115,15.785),(27.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,29.045),(71.485,29.215),(71.655,29.215),(71.655,29.045),(71.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.925),(42.345,40.095),(42.515,40.095),(42.515,39.925),(42.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.925),(42.685,40.095),(42.855,40.095),(42.855,39.925),(42.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.905),(71.145,5.075),(71.315,5.075),(71.315,4.905),(71.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.905),(71.485,5.075),(71.655,5.075),(71.655,4.905),(71.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,33.125),(18.345,33.295),(18.515,33.295),(18.515,33.125),(18.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,33.125),(18.685,33.295),(18.855,33.295),(18.855,33.125),(18.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,33.465),(18.345,33.635),(18.515,33.635),(18.515,33.465),(18.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,33.465),(18.685,33.635),(18.855,33.635),(18.855,33.465),(18.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,33.805),(18.345,33.975),(18.515,33.975),(18.515,33.805),(18.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,33.805),(18.685,33.975),(18.855,33.975),(18.855,33.805),(18.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.225),(37.545,21.395),(37.715,21.395),(37.715,21.225),(37.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.565),(37.545,21.735),(37.715,21.735),(37.715,21.565),(37.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,33.125),(80.745,33.295),(80.915,33.295),(80.915,33.125),(80.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,33.465),(80.745,33.635),(80.915,33.635),(80.915,33.465),(80.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,33.805),(80.745,33.975),(80.915,33.975),(80.915,33.805),(80.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.885),(52.285,38.055),(52.455,38.055),(52.455,37.885),(52.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.905),(23.145,5.075),(23.315,5.075),(23.315,4.905),(23.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.905),(23.485,5.075),(23.655,5.075),(23.655,4.905),(23.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,39.245),(13.545,39.415),(13.715,39.415),(13.715,39.245),(13.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,39.585),(13.545,39.755),(13.715,39.755),(13.715,39.585),(13.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.005),(13.545,10.175),(13.715,10.175),(13.715,10.005),(13.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,25.985),(71.145,26.155),(71.315,26.155),(71.315,25.985),(71.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,25.985),(71.485,26.155),(71.655,26.155),(71.655,25.985),(71.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.825),(33.085,17.995),(33.255,17.995),(33.255,17.825),(33.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.145),(33.085,17.315),(33.255,17.315),(33.255,17.145),(33.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.485),(33.085,17.655),(33.255,17.655),(33.255,17.485),(33.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.165),(71.145,18.335),(71.315,18.335),(71.315,18.165),(71.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,24.285),(75.945,24.455),(76.115,24.455),(76.115,24.285),(75.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,24.625),(75.945,24.795),(76.115,24.795),(76.115,24.625),(75.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.165),(71.485,18.335),(71.655,18.335),(71.655,18.165),(71.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.505),(71.145,18.675),(71.315,18.675),(71.315,18.505),(71.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.505),(71.485,18.675),(71.655,18.675),(71.655,18.505),(71.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.725),(52.285,29.895),(52.455,29.895),(52.455,29.725),(52.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,23.265),(8.745,23.435),(8.915,23.435),(8.915,23.265),(8.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,23.605),(8.745,23.775),(8.915,23.775),(8.915,23.605),(8.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.045),(52.285,29.215),(52.455,29.215),(52.455,29.045),(52.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.385),(52.285,29.555),(52.455,29.555),(52.455,29.385),(52.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.745),(51.945,13.915),(52.115,13.915),(52.115,13.745),(51.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.065),(51.945,13.235),(52.115,13.235),(52.115,13.065),(51.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.405),(51.945,13.575),(52.115,13.575),(52.115,13.405),(51.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.345),(76.285,10.515),(76.455,10.515),(76.455,10.345),(76.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.685),(76.285,10.855),(76.455,10.855),(76.455,10.685),(76.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.005),(76.285,10.175),(76.455,10.175),(76.455,10.005),(76.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.105),(37.885,15.275),(38.055,15.275),(38.055,15.105),(37.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.445),(37.885,15.615),(38.055,15.615),(38.055,15.445),(37.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.785),(37.885,15.955),(38.055,15.955),(38.055,15.785),(37.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,28.365),(81.085,28.535),(81.255,28.535),(81.255,28.365),(81.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.005),(47.145,27.175),(47.315,27.175),(47.315,27.005),(47.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.345),(47.485,27.515),(47.655,27.515),(47.655,27.345),(47.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.005),(47.485,27.175),(47.655,27.175),(47.655,27.005),(47.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.345),(47.145,27.515),(47.315,27.515),(47.315,27.345),(47.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.685),(47.145,27.855),(47.315,27.855),(47.315,27.685),(47.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.685),(47.485,27.855),(47.655,27.855),(47.655,27.685),(47.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,23.265),(28.285,23.435),(28.455,23.435),(28.455,23.265),(28.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,23.605),(28.285,23.775),(28.455,23.775),(28.455,23.605),(28.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,32.105),(61.545,32.275),(61.715,32.275),(61.715,32.105),(61.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,32.445),(61.545,32.615),(61.715,32.615),(61.715,32.445),(61.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,22.245),(71.145,22.415),(71.315,22.415),(71.315,22.245),(71.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,22.245),(71.485,22.415),(71.655,22.415),(71.655,22.245),(71.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,22.585),(71.145,22.755),(71.315,22.755),(71.315,22.585),(71.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,32.785),(61.545,32.955),(61.715,32.955),(61.715,32.785),(61.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,24.965),(76.285,25.135),(76.455,25.135),(76.455,24.965),(76.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,22.585),(71.485,22.755),(71.655,22.755),(71.655,22.585),(71.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.225),(42.685,21.395),(42.855,21.395),(42.855,21.225),(42.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.225),(42.345,21.395),(42.515,21.395),(42.515,21.225),(42.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.565),(42.345,21.735),(42.515,21.735),(42.515,21.565),(42.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.925),(57.085,6.095),(57.255,6.095),(57.255,5.925),(57.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.025),(8.745,11.195),(8.915,11.195),(8.915,11.025),(8.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.365),(8.745,11.535),(8.915,11.535),(8.915,11.365),(8.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.765),(33.085,14.935),(33.255,14.935),(33.255,14.765),(33.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.705),(8.745,11.875),(8.915,11.875),(8.915,11.705),(8.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.125),(42.345,33.295),(42.515,33.295),(42.515,33.125),(42.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.125),(42.685,33.295),(42.855,33.295),(42.855,33.125),(42.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.465),(42.345,33.635),(42.515,33.635),(42.515,33.465),(42.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.465),(42.685,33.635),(42.855,33.635),(42.855,33.465),(42.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.805),(42.345,33.975),(42.515,33.975),(42.515,33.805),(42.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.805),(42.685,33.975),(42.855,33.975),(42.855,33.805),(42.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.105),(57.085,32.275),(57.255,32.275),(57.255,32.105),(57.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,38.905),(28.285,39.075),(28.455,39.075),(28.455,38.905),(28.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.785),(57.085,32.955),(57.255,32.955),(57.255,32.785),(57.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.445),(57.085,32.615),(57.255,32.615),(57.255,32.445),(57.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.925),(33.085,6.095),(33.255,6.095),(33.255,5.925),(33.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.165),(81.085,18.335),(81.255,18.335),(81.255,18.165),(81.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.505),(81.085,18.675),(81.255,18.675),(81.255,18.505),(81.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,38.225),(71.145,38.395),(71.315,38.395),(71.315,38.225),(71.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,38.225),(71.485,38.395),(71.655,38.395),(71.655,38.225),(71.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,38.565),(71.145,38.735),(71.315,38.735),(71.315,38.565),(71.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,38.565),(71.485,38.735),(71.655,38.735),(71.655,38.565),(71.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.925),(32.745,23.095),(32.915,23.095),(32.915,22.925),(32.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.105),(33.085,32.275),(33.255,32.275),(33.255,32.105),(33.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.445),(33.085,32.615),(33.255,32.615),(33.255,32.445),(33.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.185),(66.685,19.355),(66.855,19.355),(66.855,19.185),(66.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.525),(66.685,19.695),(66.855,19.695),(66.855,19.525),(66.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.785),(33.085,32.955),(33.255,32.955),(33.255,32.785),(33.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.185),(66.345,19.355),(66.515,19.355),(66.515,19.185),(66.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.185),(56.745,19.355),(56.915,19.355),(56.915,19.185),(56.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.525),(56.745,19.695),(56.915,19.695),(56.915,19.525),(56.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.925),(9.085,6.095),(9.255,6.095),(9.255,5.925),(9.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.525),(66.345,19.695),(66.515,19.695),(66.515,19.525),(66.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,31.085),(71.145,31.255),(71.315,31.255),(71.315,31.085),(71.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.205),(33.085,20.375),(33.255,20.375),(33.255,20.205),(33.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.545),(33.085,20.715),(33.255,20.715),(33.255,20.545),(33.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.305),(52.285,25.475),(52.455,25.475),(52.455,25.305),(52.285,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.625),(57.085,7.795),(57.255,7.795),(57.255,7.625),(57.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.285),(57.085,7.455),(57.255,7.455),(57.255,7.285),(57.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.805),(8.745,16.975),(8.915,16.975),(8.915,16.805),(8.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.125),(8.745,16.295),(8.915,16.295),(8.915,16.125),(8.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.465),(8.745,16.635),(8.915,16.635),(8.915,16.465),(8.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.625),(33.085,7.795),(33.255,7.795),(33.255,7.625),(33.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.225),(13.885,4.395),(14.055,4.395),(14.055,4.225),(13.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.565),(13.885,4.735),(14.055,4.735),(14.055,4.565),(13.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.285),(33.085,7.455),(33.255,7.455),(33.255,7.285),(33.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,37.885),(61.545,38.055),(61.715,38.055),(61.715,37.885),(61.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.725),(9.085,12.895),(9.255,12.895),(9.255,12.725),(9.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,22.925),(76.285,23.095),(76.455,23.095),(76.455,22.925),(76.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.045),(9.085,12.215),(9.255,12.215),(9.255,12.045),(9.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.385),(9.085,12.555),(9.255,12.555),(9.255,12.385),(9.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.285),(9.085,7.455),(9.255,7.455),(9.255,7.285),(9.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.625),(9.085,7.795),(9.255,7.795),(9.255,7.625),(9.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.465),(76.285,16.635),(76.455,16.635),(76.455,16.465),(76.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.125),(76.285,16.295),(76.455,16.295),(76.455,16.125),(76.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.805),(76.285,16.975),(76.455,16.975),(76.455,16.805),(76.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.185),(37.885,36.355),(38.055,36.355),(38.055,36.185),(37.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.525),(37.885,36.695),(38.055,36.695),(38.055,36.525),(37.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,34.145),(61.885,34.315),(62.055,34.315),(62.055,34.145),(61.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,34.485),(61.885,34.655),(62.055,34.655),(62.055,34.485),(61.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,32.785),(75.945,32.955),(76.115,32.955),(76.115,32.785),(75.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,34.825),(61.885,34.995),(62.055,34.995),(62.055,34.825),(61.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,28.705),(61.885,28.875),(62.055,28.875),(62.055,28.705),(61.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,32.105),(75.945,32.275),(76.115,32.275),(76.115,32.105),(75.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,32.445),(75.945,32.615),(76.115,32.615),(76.115,32.445),(75.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,28.025),(61.885,28.195),(62.055,28.195),(62.055,28.025),(61.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.185),(47.145,19.355),(47.315,19.355),(47.315,19.185),(47.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.185),(47.485,19.355),(47.655,19.355),(47.655,19.185),(47.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.525),(47.145,19.695),(47.315,19.695),(47.315,19.525),(47.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.525),(47.485,19.695),(47.655,19.695),(47.655,19.525),(47.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,23.265),(75.945,23.435),(76.115,23.435),(76.115,23.265),(75.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,23.605),(75.945,23.775),(76.115,23.775),(76.115,23.605),(75.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.925),(33.085,23.095),(33.255,23.095),(33.255,22.925),(33.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,29.385),(81.085,29.555),(81.255,29.555),(81.255,29.385),(81.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,29.725),(8.745,29.895),(8.915,29.895),(8.915,29.725),(8.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,29.045),(8.745,29.215),(8.915,29.215),(8.915,29.045),(8.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,29.385),(8.745,29.555),(8.915,29.555),(8.915,29.385),(8.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,31.765),(28.285,31.935),(28.455,31.935),(28.455,31.765),(28.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,31.085),(28.285,31.255),(28.455,31.255),(28.455,31.085),(28.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,31.425),(28.285,31.595),(28.455,31.595),(28.455,31.425),(28.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,20.205),(76.285,20.375),(76.455,20.375),(76.455,20.205),(76.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,20.545),(76.285,20.715),(76.455,20.715),(76.455,20.545),(76.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,35.165),(61.545,35.335),(61.715,35.335),(61.715,35.165),(61.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,35.505),(61.545,35.675),(61.715,35.675),(61.715,35.505),(61.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.905),(47.145,5.075),(47.315,5.075),(47.315,4.905),(47.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.905),(47.485,5.075),(47.655,5.075),(47.655,4.905),(47.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.245),(37.885,5.415),(38.055,5.415),(38.055,5.245),(37.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.585),(37.885,5.755),(38.055,5.755),(38.055,5.585),(37.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,36.185),(61.545,36.355),(61.715,36.355),(61.715,36.185),(61.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,36.525),(61.545,36.695),(61.715,36.695),(61.715,36.525),(61.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.865),(37.545,3.035),(37.715,3.035),(37.715,2.865),(37.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.305),(81.085,8.475),(81.255,8.475),(81.255,8.305),(81.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.645),(81.085,8.815),(81.255,8.815),(81.255,8.645),(81.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.305),(47.145,8.475),(47.315,8.475),(47.315,8.305),(47.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.305),(47.485,8.475),(47.655,8.475),(47.655,8.305),(47.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.645),(47.145,8.815),(47.315,8.815),(47.315,8.645),(47.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.645),(47.485,8.815),(47.655,8.815),(47.655,8.645),(47.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,34.825),(81.085,34.995),(81.255,34.995),(81.255,34.825),(81.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,34.145),(81.085,34.315),(81.255,34.315),(81.255,34.145),(81.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.325),(66.345,9.495),(66.515,9.495),(66.515,9.325),(66.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.325),(66.685,9.495),(66.855,9.495),(66.855,9.325),(66.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.685),(57.085,27.855),(57.255,27.855),(57.255,27.685),(57.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.005),(57.085,27.175),(57.255,27.175),(57.255,27.005),(57.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.345),(57.085,27.515),(57.255,27.515),(57.255,27.345),(57.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,34.485),(81.085,34.655),(81.255,34.655),(81.255,34.485),(81.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.665),(66.345,9.835),(66.515,9.835),(66.515,9.665),(66.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.665),(66.685,9.835),(66.855,9.835),(66.855,9.665),(66.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.285),(81.085,7.455),(81.255,7.455),(81.255,7.285),(81.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.625),(81.085,7.795),(81.255,7.795),(81.255,7.625),(81.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,40.265),(75.945,40.435),(76.115,40.435),(76.115,40.265),(75.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,36.185),(8.745,36.355),(8.915,36.355),(8.915,36.185),(8.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,36.525),(8.745,36.695),(8.915,36.695),(8.915,36.525),(8.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,39.925),(13.885,40.095),(14.055,40.095),(14.055,39.925),(13.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,40.605),(75.945,40.775),(76.115,40.775),(76.115,40.605),(75.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,22.245),(18.345,22.415),(18.515,22.415),(18.515,22.245),(18.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,22.585),(18.345,22.755),(18.515,22.755),(18.515,22.585),(18.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,22.245),(18.685,22.415),(18.855,22.415),(18.855,22.245),(18.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,22.585),(18.685,22.755),(18.855,22.755),(18.855,22.585),(18.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.745),(27.945,13.915),(28.115,13.915),(28.115,13.745),(27.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.065),(27.945,13.235),(28.115,13.235),(28.115,13.065),(27.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.405),(27.945,13.575),(28.115,13.575),(28.115,13.405),(27.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,20.885),(61.885,21.055),(62.055,21.055),(62.055,20.885),(61.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.865),(32.745,20.035),(32.915,20.035),(32.915,19.865),(32.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.025),(56.745,11.195),(56.915,11.195),(56.915,11.025),(56.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.365),(56.745,11.535),(56.915,11.535),(56.915,11.365),(56.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.705),(56.745,11.875),(56.915,11.875),(56.915,11.705),(56.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.225),(47.145,38.395),(47.315,38.395),(47.315,38.225),(47.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.225),(47.485,38.395),(47.655,38.395),(47.655,38.225),(47.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.565),(47.145,38.735),(47.315,38.735),(47.315,38.565),(47.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.565),(47.485,38.735),(47.655,38.735),(47.655,38.565),(47.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.165),(76.285,18.335),(76.455,18.335),(76.455,18.165),(76.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.505),(76.285,18.675),(76.455,18.675),(76.455,18.505),(76.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,23.945),(8.745,24.115),(8.915,24.115),(8.915,23.945),(8.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,27.345),(76.285,27.515),(76.455,27.515),(76.455,27.345),(76.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,38.905),(13.545,39.075),(13.715,39.075),(13.715,38.905),(13.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,38.225),(23.485,38.395),(23.655,38.395),(23.655,38.225),(23.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,38.565),(23.485,38.735),(23.655,38.735),(23.655,38.565),(23.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,33.125),(66.345,33.295),(66.515,33.295),(66.515,33.125),(66.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,33.125),(66.685,33.295),(66.855,33.295),(66.855,33.125),(66.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,25.305),(61.545,25.475),(61.715,25.475),(61.715,25.305),(61.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,25.645),(61.545,25.815),(61.715,25.815),(61.715,25.645),(61.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,33.465),(66.345,33.635),(66.515,33.635),(66.515,33.465),(66.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,33.465),(66.685,33.635),(66.855,33.635),(66.855,33.465),(66.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,38.225),(23.145,38.395),(23.315,38.395),(23.315,38.225),(23.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,38.565),(23.145,38.735),(23.315,38.735),(23.315,38.565),(23.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,33.805),(66.345,33.975),(66.515,33.975),(66.515,33.805),(66.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,33.805),(66.685,33.975),(66.855,33.975),(66.855,33.805),(66.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.265),(47.145,23.435),(47.315,23.435),(47.315,23.265),(47.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.265),(47.485,23.435),(47.655,23.435),(47.655,23.265),(47.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.605),(47.145,23.775),(47.315,23.775),(47.315,23.605),(47.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,24.965),(81.085,25.135),(81.255,25.135),(81.255,24.965),(81.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,40.605),(61.545,40.775),(61.715,40.775),(61.715,40.605),(61.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,40.265),(61.545,40.435),(61.715,40.435),(61.715,40.265),(61.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.605),(47.485,23.775),(47.655,23.775),(47.655,23.605),(47.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.405),(47.485,30.575),(47.655,30.575),(47.655,30.405),(47.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.065),(37.545,13.235),(37.715,13.235),(37.715,13.065),(37.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.405),(37.545,13.575),(37.715,13.575),(37.715,13.405),(37.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.745),(37.545,13.915),(37.715,13.915),(37.715,13.745),(37.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.865),(71.145,20.035),(71.315,20.035),(71.315,19.865),(71.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.865),(71.485,20.035),(71.655,20.035),(71.655,19.865),(71.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,26.665),(66.345,26.835),(66.515,26.835),(66.515,26.665),(66.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,34.825),(9.085,34.995),(9.255,34.995),(9.255,34.825),(9.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.765),(51.945,14.935),(52.115,14.935),(52.115,14.765),(51.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,34.145),(9.085,34.315),(9.255,34.315),(9.255,34.145),(9.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,34.485),(9.085,34.655),(9.255,34.655),(9.255,34.485),(9.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,36.865),(75.945,37.035),(76.115,37.035),(76.115,36.865),(75.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,34.825),(28.285,34.995),(28.455,34.995),(28.455,34.825),(28.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.085),(51.945,14.255),(52.115,14.255),(52.115,14.085),(51.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.425),(51.945,14.595),(52.115,14.595),(52.115,14.425),(51.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,34.145),(28.285,34.315),(28.455,34.315),(28.455,34.145),(28.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,34.485),(28.285,34.655),(28.455,34.655),(28.455,34.485),(28.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,21.565),(80.745,21.735),(80.915,21.735),(80.915,21.565),(80.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,21.225),(80.745,21.395),(80.915,21.395),(80.915,21.225),(80.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,31.085),(18.685,31.255),(18.855,31.255),(18.855,31.085),(18.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,31.425),(18.685,31.595),(18.855,31.595),(18.855,31.425),(18.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,31.085),(18.345,31.255),(18.515,31.255),(18.515,31.085),(18.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,31.765),(18.345,31.935),(18.515,31.935),(18.515,31.765),(18.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,31.765),(18.685,31.935),(18.855,31.935),(18.855,31.765),(18.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,31.425),(18.345,31.595),(18.515,31.595),(18.515,31.425),(18.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.865),(66.345,20.035),(66.515,20.035),(66.515,19.865),(66.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.865),(66.685,20.035),(66.855,20.035),(66.855,19.865),(66.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.565),(61.885,4.735),(62.055,4.735),(62.055,4.565),(61.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.225),(61.885,4.395),(62.055,4.395),(62.055,4.225),(61.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.685),(23.145,10.855),(23.315,10.855),(23.315,10.685),(23.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,23.945),(71.145,24.115),(71.315,24.115),(71.315,23.945),(71.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,23.945),(71.485,24.115),(71.655,24.115),(71.655,23.945),(71.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.685),(23.485,10.855),(23.655,10.855),(23.655,10.685),(23.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.005),(23.145,10.175),(23.315,10.175),(23.315,10.005),(23.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.005),(23.485,10.175),(23.655,10.175),(23.655,10.005),(23.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.345),(23.145,10.515),(23.315,10.515),(23.315,10.345),(23.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.345),(23.485,10.515),(23.655,10.515),(23.655,10.345),(23.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.045),(57.085,12.215),(57.255,12.215),(57.255,12.045),(57.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.725),(57.085,12.895),(57.255,12.895),(57.255,12.725),(57.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.305),(33.085,8.475),(33.255,8.475),(33.255,8.305),(33.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.645),(33.085,8.815),(33.255,8.815),(33.255,8.645),(33.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.325),(8.745,9.495),(8.915,9.495),(8.915,9.325),(8.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.705),(51.945,28.875),(52.115,28.875),(52.115,28.705),(51.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.665),(8.745,9.835),(8.915,9.835),(8.915,9.665),(8.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.385),(57.085,12.555),(57.255,12.555),(57.255,12.385),(57.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.025),(51.945,28.195),(52.115,28.195),(52.115,28.025),(51.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.365),(51.945,28.535),(52.115,28.535),(52.115,28.365),(51.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.325),(18.345,9.495),(18.515,9.495),(18.515,9.325),(18.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.325),(18.685,9.495),(18.855,9.495),(18.855,9.325),(18.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.665),(18.345,9.835),(18.515,9.835),(18.515,9.665),(18.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.665),(18.685,9.835),(18.855,9.835),(18.855,9.665),(18.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.245),(52.285,22.415),(52.455,22.415),(52.455,22.245),(52.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.585),(52.285,22.755),(52.455,22.755),(52.455,22.585),(52.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,37.205),(13.885,37.375),(14.055,37.375),(14.055,37.205),(13.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,37.545),(13.885,37.715),(14.055,37.715),(14.055,37.545),(13.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.865),(81.085,20.035),(81.255,20.035),(81.255,19.865),(81.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,27.685),(81.085,27.855),(81.255,27.855),(81.255,27.685),(81.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,27.005),(81.085,27.175),(81.255,27.175),(81.255,27.005),(81.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,27.345),(81.085,27.515),(81.255,27.515),(81.255,27.345),(81.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,35.845),(61.885,36.015),(62.055,36.015),(62.055,35.845),(61.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,24.965),(61.885,25.135),(62.055,25.135),(62.055,24.965),(61.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.965),(57.085,25.135),(57.255,25.135),(57.255,24.965),(57.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.845),(37.545,36.015),(37.715,36.015),(37.715,35.845),(37.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,29.725),(66.345,29.895),(66.515,29.895),(66.515,29.725),(66.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,29.725),(66.685,29.895),(66.855,29.895),(66.855,29.725),(66.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,29.045),(66.345,29.215),(66.515,29.215),(66.515,29.045),(66.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,29.045),(66.685,29.215),(66.855,29.215),(66.855,29.045),(66.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,29.385),(66.345,29.555),(66.515,29.555),(66.515,29.385),(66.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,29.385),(66.685,29.555),(66.855,29.555),(66.855,29.385),(66.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.765),(81.085,14.935),(81.255,14.935),(81.255,14.765),(81.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.085),(81.085,14.255),(81.255,14.255),(81.255,14.085),(81.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.425),(81.085,14.595),(81.255,14.595),(81.255,14.425),(81.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.965),(42.685,25.135),(42.855,25.135),(42.855,24.965),(42.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.965),(42.345,25.135),(42.515,25.135),(42.515,24.965),(42.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,37.885),(61.885,38.055),(62.055,38.055),(62.055,37.885),(61.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.825),(56.745,17.995),(56.915,17.995),(56.915,17.825),(56.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.145),(56.745,17.315),(56.915,17.315),(56.915,17.145),(56.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,38.225),(61.545,38.395),(61.715,38.395),(61.715,38.225),(61.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,38.565),(61.545,38.735),(61.715,38.735),(61.715,38.565),(61.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.485),(56.745,17.655),(56.915,17.655),(56.915,17.485),(56.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.785),(23.145,15.955),(23.315,15.955),(23.315,15.785),(23.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.045),(71.485,12.215),(71.655,12.215),(71.655,12.045),(71.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.845),(51.945,36.015),(52.115,36.015),(52.115,35.845),(51.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.945),(37.885,24.115),(38.055,24.115),(38.055,23.945),(37.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.185),(61.545,19.355),(61.715,19.355),(61.715,19.185),(61.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.525),(61.545,19.695),(61.715,19.695),(61.715,19.525),(61.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.185),(32.745,36.355),(32.915,36.355),(32.915,36.185),(32.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.525),(32.745,36.695),(32.915,36.695),(32.915,36.525),(32.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.105),(61.885,15.275),(62.055,15.275),(62.055,15.105),(61.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.445),(61.885,15.615),(62.055,15.615),(62.055,15.445),(61.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.785),(61.885,15.955),(62.055,15.955),(62.055,15.785),(61.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,29.045),(28.285,29.215),(28.455,29.215),(28.455,29.045),(28.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,29.385),(28.285,29.555),(28.455,29.555),(28.455,29.385),(28.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,29.725),(28.285,29.895),(28.455,29.895),(28.455,29.725),(28.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,20.885),(9.085,21.055),(9.255,21.055),(9.255,20.885),(9.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.785),(13.885,15.955),(14.055,15.955),(14.055,15.785),(13.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.445),(13.885,15.615),(14.055,15.615),(14.055,15.445),(13.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.105),(13.885,15.275),(14.055,15.275),(14.055,15.105),(13.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.925),(37.545,40.095),(37.715,40.095),(37.715,39.925),(37.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.365),(37.885,28.535),(38.055,28.535),(38.055,28.365),(37.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.025),(37.885,28.195),(38.055,28.195),(38.055,28.025),(37.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.705),(37.885,28.875),(38.055,28.875),(38.055,28.705),(37.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.985),(37.545,9.155),(37.715,9.155),(37.715,8.985),(37.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.185),(18.685,19.355),(18.855,19.355),(18.855,19.185),(18.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.525),(18.345,19.695),(18.515,19.695),(18.515,19.525),(18.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.185),(18.345,19.355),(18.515,19.355),(18.515,19.185),(18.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.525),(18.685,19.695),(18.855,19.695),(18.855,19.525),(18.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,21.905),(61.545,22.075),(61.715,22.075),(61.715,21.905),(61.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.845),(66.345,19.015),(66.515,19.015),(66.515,18.845),(66.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.845),(66.685,19.015),(66.855,19.015),(66.855,18.845),(66.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,20.885),(66.345,21.055),(66.515,21.055),(66.515,20.885),(66.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,20.885),(66.685,21.055),(66.855,21.055),(66.855,20.885),(66.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.265),(37.545,6.435),(37.715,6.435),(37.715,6.265),(37.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.605),(37.545,6.775),(37.715,6.775),(37.715,6.605),(37.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.025),(37.545,11.195),(37.715,11.195),(37.715,11.025),(37.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.365),(37.545,11.535),(37.715,11.535),(37.715,11.365),(37.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.705),(37.545,11.875),(37.715,11.875),(37.715,11.705),(37.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,37.885),(80.745,38.055),(80.915,38.055),(80.915,37.885),(80.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,25.305),(81.085,25.475),(81.255,25.475),(81.255,25.305),(81.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,25.645),(81.085,25.815),(81.255,25.815),(81.255,25.645),(81.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.325),(56.745,9.495),(56.915,9.495),(56.915,9.325),(56.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.665),(56.745,9.835),(56.915,9.835),(56.915,9.665),(56.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,25.645),(23.485,25.815),(23.655,25.815),(23.655,25.645),(23.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,25.645),(23.145,25.815),(23.315,25.815),(23.315,25.645),(23.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,38.905),(61.885,39.075),(62.055,39.075),(62.055,38.905),(61.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,25.305),(23.485,25.475),(23.655,25.475),(23.655,25.305),(23.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,25.305),(23.145,25.475),(23.315,25.475),(23.315,25.305),(23.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.845),(23.485,19.015),(23.655,19.015),(23.655,18.845),(23.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.845),(23.145,19.015),(23.315,19.015),(23.315,18.845),(23.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.165),(37.885,35.335),(38.055,35.335),(38.055,35.165),(37.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.505),(37.885,35.675),(38.055,35.675),(38.055,35.505),(37.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.925),(52.285,40.095),(52.455,40.095),(52.455,39.925),(52.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.885),(75.945,4.055),(76.115,4.055),(76.115,3.885),(75.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.765),(32.745,31.935),(32.915,31.935),(32.915,31.765),(32.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.085),(32.745,31.255),(32.915,31.255),(32.915,31.085),(32.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.465),(71.145,16.635),(71.315,16.635),(71.315,16.465),(71.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.125),(71.145,16.295),(71.315,16.295),(71.315,16.125),(71.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.125),(71.485,16.295),(71.655,16.295),(71.655,16.125),(71.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.465),(71.485,16.635),(71.655,16.635),(71.655,16.465),(71.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.805),(71.145,16.975),(71.315,16.975),(71.315,16.805),(71.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.805),(71.485,16.975),(71.655,16.975),(71.655,16.805),(71.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.425),(32.745,31.595),(32.915,31.595),(32.915,31.425),(32.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.785),(37.545,15.955),(37.715,15.955),(37.715,15.785),(37.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.105),(37.545,15.275),(37.715,15.275),(37.715,15.105),(37.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.445),(37.545,15.615),(37.715,15.615),(37.715,15.445),(37.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.885),(27.945,4.055),(28.115,4.055),(28.115,3.885),(27.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,22.925),(23.485,23.095),(23.655,23.095),(23.655,22.925),(23.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,22.925),(23.145,23.095),(23.315,23.095),(23.315,22.925),(23.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.265),(9.085,6.435),(9.255,6.435),(9.255,6.265),(9.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.605),(9.085,6.775),(9.255,6.775),(9.255,6.605),(9.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,40.265),(8.745,40.435),(8.915,40.435),(8.915,40.265),(8.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,40.605),(8.745,40.775),(8.915,40.775),(8.915,40.605),(8.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,21.565),(71.145,21.735),(71.315,21.735),(71.315,21.565),(71.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,21.565),(71.485,21.735),(71.655,21.735),(71.655,21.565),(71.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.645),(37.545,25.815),(37.715,25.815),(37.715,25.645),(37.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,21.225),(71.145,21.395),(71.315,21.395),(71.315,21.225),(71.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,20.205),(71.145,20.375),(71.315,20.375),(71.315,20.205),(71.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,20.205),(71.485,20.375),(71.655,20.375),(71.655,20.205),(71.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,20.545),(71.145,20.715),(71.315,20.715),(71.315,20.545),(71.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,20.545),(71.485,20.715),(71.655,20.715),(71.655,20.545),(71.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,21.225),(71.485,21.395),(71.655,21.395),(71.655,21.225),(71.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.305),(37.545,25.475),(37.715,25.475),(37.715,25.305),(37.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.185),(8.745,19.355),(8.915,19.355),(8.915,19.185),(8.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.525),(8.745,19.695),(8.915,19.695),(8.915,19.525),(8.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.585),(76.285,5.755),(76.455,5.755),(76.455,5.585),(76.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.245),(76.285,5.415),(76.455,5.415),(76.455,5.245),(76.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.865),(61.885,20.035),(62.055,20.035),(62.055,19.865),(61.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.925),(81.085,6.095),(81.255,6.095),(81.255,5.925),(81.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.845),(32.745,19.015),(32.915,19.015),(32.915,18.845),(32.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.245),(28.285,5.415),(28.455,5.415),(28.455,5.245),(28.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.585),(28.285,5.755),(28.455,5.755),(28.455,5.585),(28.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,21.905),(61.885,22.075),(62.055,22.075),(62.055,21.905),(61.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.545),(42.345,37.715),(42.515,37.715),(42.515,37.545),(42.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.545),(42.685,37.715),(42.855,37.715),(42.855,37.545),(42.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.145),(56.745,34.315),(56.915,34.315),(56.915,34.145),(56.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.485),(56.745,34.655),(56.915,34.655),(56.915,34.485),(56.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.205),(42.345,37.375),(42.515,37.375),(42.515,37.205),(42.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.205),(42.685,37.375),(42.855,37.375),(42.855,37.205),(42.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.205),(37.545,20.375),(37.715,20.375),(37.715,20.205),(37.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.545),(37.545,20.715),(37.715,20.715),(37.715,20.545),(37.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.125),(27.945,16.295),(28.115,16.295),(28.115,16.125),(27.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.465),(27.945,16.635),(28.115,16.635),(28.115,16.465),(27.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.805),(27.945,16.975),(28.115,16.975),(28.115,16.805),(27.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.825),(32.745,34.995),(32.915,34.995),(32.915,34.825),(32.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.145),(32.745,34.315),(32.915,34.315),(32.915,34.145),(32.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.485),(32.745,34.655),(32.915,34.655),(32.915,34.485),(32.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.745),(75.945,13.915),(76.115,13.915),(76.115,13.745),(75.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.065),(75.945,13.235),(76.115,13.235),(76.115,13.065),(75.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.405),(75.945,13.575),(76.115,13.575),(76.115,13.405),(75.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,35.845),(71.145,36.015),(71.315,36.015),(71.315,35.845),(71.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,23.265),(66.345,23.435),(66.515,23.435),(66.515,23.265),(66.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,23.265),(66.685,23.435),(66.855,23.435),(66.855,23.265),(66.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,23.605),(66.345,23.775),(66.515,23.775),(66.515,23.605),(66.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,23.605),(66.685,23.775),(66.855,23.775),(66.855,23.605),(66.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.585),(32.745,39.755),(32.915,39.755),(32.915,39.585),(32.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,35.845),(71.485,36.015),(71.655,36.015),(71.655,35.845),(71.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.125),(33.085,16.295),(33.255,16.295),(33.255,16.125),(33.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.465),(33.085,16.635),(33.255,16.635),(33.255,16.465),(33.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.245),(32.745,39.415),(32.915,39.415),(32.915,39.245),(32.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,39.245),(27.945,39.415),(28.115,39.415),(28.115,39.245),(27.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,39.585),(27.945,39.755),(28.115,39.755),(28.115,39.585),(27.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,28.025),(13.885,28.195),(14.055,28.195),(14.055,28.025),(13.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,28.365),(13.885,28.535),(14.055,28.535),(14.055,28.365),(13.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,28.705),(13.885,28.875),(14.055,28.875),(14.055,28.705),(13.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.805),(33.085,16.975),(33.255,16.975),(33.255,16.805),(33.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.205),(56.745,20.375),(56.915,20.375),(56.915,20.205),(56.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.545),(56.745,20.715),(56.915,20.715),(56.915,20.545),(56.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,39.245),(8.745,39.415),(8.915,39.415),(8.915,39.245),(8.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,39.585),(8.745,39.755),(8.915,39.755),(8.915,39.585),(8.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,36.185),(28.285,36.355),(28.455,36.355),(28.455,36.185),(28.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,36.525),(28.285,36.695),(28.455,36.695),(28.455,36.525),(28.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,25.305),(9.085,25.475),(9.255,25.475),(9.255,25.305),(9.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,25.645),(9.085,25.815),(9.255,25.815),(9.255,25.645),(9.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.965),(37.885,25.135),(38.055,25.135),(38.055,24.965),(37.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.565),(42.345,38.735),(42.515,38.735),(42.515,38.565),(42.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.565),(42.685,38.735),(42.855,38.735),(42.855,38.565),(42.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.225),(42.345,38.395),(42.515,38.395),(42.515,38.225),(42.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.225),(42.685,38.395),(42.855,38.395),(42.855,38.225),(42.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,21.565),(81.085,21.735),(81.255,21.735),(81.255,21.565),(81.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.205),(57.085,3.375),(57.255,3.375),(57.255,3.205),(57.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.205),(52.285,37.375),(52.455,37.375),(52.455,37.205),(52.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.545),(52.285,37.715),(52.455,37.715),(52.455,37.545),(52.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,20.205),(81.085,20.375),(81.255,20.375),(81.255,20.205),(81.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,20.545),(81.085,20.715),(81.255,20.715),(81.255,20.545),(81.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.265),(56.745,6.435),(56.915,6.435),(56.915,6.265),(56.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.605),(56.745,6.775),(56.915,6.775),(56.915,6.605),(56.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.745),(61.545,13.915),(61.715,13.915),(61.715,13.745),(61.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.545),(57.085,3.715),(57.255,3.715),(57.255,3.545),(57.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.065),(61.545,13.235),(61.715,13.235),(61.715,13.065),(61.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.405),(61.545,13.575),(61.715,13.575),(61.715,13.405),(61.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.205),(33.085,3.375),(33.255,3.375),(33.255,3.205),(33.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.545),(33.085,3.715),(33.255,3.715),(33.255,3.545),(33.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.265),(32.745,6.435),(32.915,6.435),(32.915,6.265),(32.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,28.025),(28.285,28.195),(28.455,28.195),(28.455,28.025),(28.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,28.365),(28.285,28.535),(28.455,28.535),(28.455,28.365),(28.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.605),(32.745,6.775),(32.915,6.775),(32.915,6.605),(32.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.085),(75.945,14.255),(76.115,14.255),(76.115,14.085),(75.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.425),(75.945,14.595),(76.115,14.595),(76.115,14.425),(75.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.765),(75.945,14.935),(76.115,14.935),(76.115,14.765),(75.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,37.885),(27.945,38.055),(28.115,38.055),(28.115,37.885),(27.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.205),(9.085,3.375),(9.255,3.375),(9.255,3.205),(9.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.545),(9.085,3.715),(9.255,3.715),(9.255,3.545),(9.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.845),(33.085,19.015),(33.255,19.015),(33.255,18.845),(33.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.265),(8.745,6.435),(8.915,6.435),(8.915,6.265),(8.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.605),(8.745,6.775),(8.915,6.775),(8.915,6.605),(8.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.065),(13.545,13.235),(13.715,13.235),(13.715,13.065),(13.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.405),(13.545,13.575),(13.715,13.575),(13.715,13.405),(13.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.745),(13.545,13.915),(13.715,13.915),(13.715,13.745),(13.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.865),(18.345,20.035),(18.515,20.035),(18.515,19.865),(18.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.865),(18.685,20.035),(18.855,20.035),(18.855,19.865),(18.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.425),(27.945,14.595),(28.115,14.595),(28.115,14.425),(27.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.085),(27.945,14.255),(28.115,14.255),(28.115,14.085),(27.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.765),(27.945,14.935),(28.115,14.935),(28.115,14.765),(27.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.405),(42.345,30.575),(42.515,30.575),(42.515,30.405),(42.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.405),(42.685,30.575),(42.855,30.575),(42.855,30.405),(42.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,24.965),(23.145,25.135),(23.315,25.135),(23.315,24.965),(23.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,24.965),(23.485,25.135),(23.655,25.135),(23.655,24.965),(23.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.905),(56.745,5.075),(56.915,5.075),(56.915,4.905),(56.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.985),(32.745,26.155),(32.915,26.155),(32.915,25.985),(32.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.685),(71.145,10.855),(71.315,10.855),(71.315,10.685),(71.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.685),(71.485,10.855),(71.655,10.855),(71.655,10.685),(71.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.005),(71.145,10.175),(71.315,10.175),(71.315,10.005),(71.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.005),(71.485,10.175),(71.655,10.175),(71.655,10.005),(71.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.345),(71.485,10.515),(71.655,10.515),(71.655,10.345),(71.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.345),(71.145,10.515),(71.315,10.515),(71.315,10.345),(71.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,20.885),(13.885,21.055),(14.055,21.055),(14.055,20.885),(13.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,28.705),(27.945,28.875),(28.115,28.875),(28.115,28.705),(27.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.905),(32.745,5.075),(32.915,5.075),(32.915,4.905),(32.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,28.025),(27.945,28.195),(28.115,28.195),(28.115,28.025),(27.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,28.365),(27.945,28.535),(28.115,28.535),(28.115,28.365),(27.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.905),(13.545,5.075),(13.715,5.075),(13.715,4.905),(13.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.905),(8.745,5.075),(8.915,5.075),(8.915,4.905),(8.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.825),(9.085,17.995),(9.255,17.995),(9.255,17.825),(9.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.385),(71.485,12.555),(71.655,12.555),(71.655,12.385),(71.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.605),(57.085,6.775),(57.255,6.775),(57.255,6.605),(57.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.265),(57.085,6.435),(57.255,6.435),(57.255,6.265),(57.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.205),(81.085,3.375),(81.255,3.375),(81.255,3.205),(81.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.545),(81.085,3.715),(81.255,3.715),(81.255,3.545),(81.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.845),(28.285,19.015),(28.455,19.015),(28.455,18.845),(28.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.265),(80.745,6.435),(80.915,6.435),(80.915,6.265),(80.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.605),(80.745,6.775),(80.915,6.775),(80.915,6.605),(80.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,40.265),(42.345,40.435),(42.515,40.435),(42.515,40.265),(42.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,40.605),(42.685,40.775),(42.855,40.775),(42.855,40.605),(42.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,40.265),(42.685,40.435),(42.855,40.435),(42.855,40.265),(42.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,40.605),(42.345,40.775),(42.515,40.775),(42.515,40.605),(42.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,20.885),(27.945,21.055),(28.115,21.055),(28.115,20.885),(27.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.265),(33.085,6.435),(33.255,6.435),(33.255,6.265),(33.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.605),(33.085,6.775),(33.255,6.775),(33.255,6.605),(33.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.945),(75.945,7.115),(76.115,7.115),(76.115,6.945),(75.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,33.465),(23.485,33.635),(23.655,33.635),(23.655,33.465),(23.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,33.125),(23.145,33.295),(23.315,33.295),(23.315,33.125),(23.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,33.125),(23.485,33.295),(23.655,33.295),(23.655,33.125),(23.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,33.465),(23.145,33.635),(23.315,33.635),(23.315,33.465),(23.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,33.805),(23.145,33.975),(23.315,33.975),(23.315,33.805),(23.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,33.805),(23.485,33.975),(23.655,33.975),(23.655,33.805),(23.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.925),(66.345,6.095),(66.515,6.095),(66.515,5.925),(66.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.925),(66.685,6.095),(66.855,6.095),(66.855,5.925),(66.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,39.585),(75.945,39.755),(76.115,39.755),(76.115,39.585),(75.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,39.245),(75.945,39.415),(76.115,39.415),(76.115,39.245),(75.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,35.165),(66.345,35.335),(66.515,35.335),(66.515,35.165),(66.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,35.165),(66.685,35.335),(66.855,35.335),(66.855,35.165),(66.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,35.505),(66.345,35.675),(66.515,35.675),(66.515,35.505),(66.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,35.505),(66.685,35.675),(66.855,35.675),(66.855,35.505),(66.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.925),(42.345,6.095),(42.515,6.095),(42.515,5.925),(42.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.925),(42.685,6.095),(42.855,6.095),(42.855,5.925),(42.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,36.185),(76.285,36.355),(76.455,36.355),(76.455,36.185),(76.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,36.525),(76.285,36.695),(76.455,36.695),(76.455,36.525),(76.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.945),(27.945,7.115),(28.115,7.115),(28.115,6.945),(27.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.725),(56.745,12.895),(56.915,12.895),(56.915,12.725),(56.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.645),(32.745,8.815),(32.915,8.815),(32.915,8.645),(32.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.305),(32.745,8.475),(32.915,8.475),(32.915,8.305),(32.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.385),(56.745,12.555),(56.915,12.555),(56.915,12.385),(56.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.045),(56.745,12.215),(56.915,12.215),(56.915,12.045),(56.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.965),(42.345,8.135),(42.515,8.135),(42.515,7.965),(42.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.965),(42.685,8.135),(42.855,8.135),(42.855,7.965),(42.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.985),(13.545,9.155),(13.715,9.155),(13.715,8.985),(13.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.425),(42.685,31.595),(42.855,31.595),(42.855,31.425),(42.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.765),(42.345,31.935),(42.515,31.935),(42.515,31.765),(42.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.765),(42.685,31.935),(42.855,31.935),(42.855,31.765),(42.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.085),(42.345,31.255),(42.515,31.255),(42.515,31.085),(42.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.845),(37.885,19.015),(38.055,19.015),(38.055,18.845),(37.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.425),(42.345,31.595),(42.515,31.595),(42.515,31.425),(42.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.045),(8.745,12.215),(8.915,12.215),(8.915,12.045),(8.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.385),(8.745,12.555),(8.915,12.555),(8.915,12.385),(8.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.085),(42.685,31.255),(42.855,31.255),(42.855,31.085),(42.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.725),(8.745,12.895),(8.915,12.895),(8.915,12.725),(8.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,24.965),(13.885,25.135),(14.055,25.135),(14.055,24.965),(13.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,24.965),(9.085,25.135),(9.255,25.135),(9.255,24.965),(9.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,22.925),(80.745,23.095),(80.915,23.095),(80.915,22.925),(80.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,25.985),(75.945,26.155),(76.115,26.155),(76.115,25.985),(75.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.225),(27.945,4.395),(28.115,4.395),(28.115,4.225),(27.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.565),(27.945,4.735),(28.115,4.735),(28.115,4.565),(27.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,27.685),(66.685,27.855),(66.855,27.855),(66.855,27.685),(66.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.905),(51.945,39.075),(52.115,39.075),(52.115,38.905),(51.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,20.885),(18.685,21.055),(18.855,21.055),(18.855,20.885),(18.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,20.885),(18.345,21.055),(18.515,21.055),(18.515,20.885),(18.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.925),(32.745,40.095),(32.915,40.095),(32.915,39.925),(32.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.285),(51.945,7.455),(52.115,7.455),(52.115,7.285),(51.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.625),(51.945,7.795),(52.115,7.795),(52.115,7.625),(51.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.025),(61.545,11.195),(61.715,11.195),(61.715,11.025),(61.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.365),(61.545,11.535),(61.715,11.535),(61.715,11.365),(61.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.705),(61.545,11.875),(61.715,11.875),(61.715,11.705),(61.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.845),(61.545,19.015),(61.715,19.015),(61.715,18.845),(61.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,34.825),(76.285,34.995),(76.455,34.995),(76.455,34.825),(76.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,34.145),(76.285,34.315),(76.455,34.315),(76.455,34.145),(76.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,34.485),(76.285,34.655),(76.455,34.655),(76.455,34.485),(76.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,39.925),(8.745,40.095),(8.915,40.095),(8.915,39.925),(8.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.225),(52.285,4.395),(52.455,4.395),(52.455,4.225),(52.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.565),(52.285,4.735),(52.455,4.735),(52.455,4.565),(52.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.985),(51.945,9.155),(52.115,9.155),(52.115,8.985),(51.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.825),(8.745,17.995),(8.915,17.995),(8.915,17.825),(8.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.145),(8.745,17.315),(8.915,17.315),(8.915,17.145),(8.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.485),(8.745,17.655),(8.915,17.655),(8.915,17.485),(8.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.705),(13.545,11.875),(13.715,11.875),(13.715,11.705),(13.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.025),(13.545,11.195),(13.715,11.195),(13.715,11.025),(13.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.365),(13.545,11.535),(13.715,11.535),(13.715,11.365),(13.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.745),(37.885,13.915),(38.055,13.915),(38.055,13.745),(37.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.065),(37.885,13.235),(38.055,13.235),(38.055,13.065),(37.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.405),(37.885,13.575),(38.055,13.575),(38.055,13.405),(37.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,21.565),(75.945,21.735),(76.115,21.735),(76.115,21.565),(75.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,21.225),(75.945,21.395),(76.115,21.395),(76.115,21.225),(75.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.925),(18.345,6.095),(18.515,6.095),(18.515,5.925),(18.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.925),(18.685,6.095),(18.855,6.095),(18.855,5.925),(18.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,22.925),(61.545,23.095),(61.715,23.095),(61.715,22.925),(61.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,27.005),(9.085,27.175),(9.255,27.175),(9.255,27.005),(9.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,27.345),(9.085,27.515),(9.255,27.515),(9.255,27.345),(9.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,27.685),(9.085,27.855),(9.255,27.855),(9.255,27.685),(9.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.185),(51.945,36.355),(52.115,36.355),(52.115,36.185),(51.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,35.505),(18.685,35.675),(18.855,35.675),(18.855,35.505),(18.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.525),(51.945,36.695),(52.115,36.695),(52.115,36.525),(51.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,35.165),(18.345,35.335),(18.515,35.335),(18.515,35.165),(18.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,35.165),(18.685,35.335),(18.855,35.335),(18.855,35.165),(18.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,35.505),(18.345,35.675),(18.515,35.675),(18.515,35.505),(18.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.245),(47.145,22.415),(47.315,22.415),(47.315,22.245),(47.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.245),(47.485,22.415),(47.655,22.415),(47.655,22.245),(47.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.585),(47.145,22.755),(47.315,22.755),(47.315,22.585),(47.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.585),(47.485,22.755),(47.655,22.755),(47.655,22.585),(47.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.925),(51.945,6.095),(52.115,6.095),(52.115,5.925),(51.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,35.165),(75.945,35.335),(76.115,35.335),(76.115,35.165),(75.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,35.505),(75.945,35.675),(76.115,35.675),(76.115,35.505),(75.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,40.265),(9.085,40.435),(9.255,40.435),(9.255,40.265),(9.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.045),(37.545,12.215),(37.715,12.215),(37.715,12.045),(37.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.385),(37.545,12.555),(37.715,12.555),(37.715,12.385),(37.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.725),(37.545,12.895),(37.715,12.895),(37.715,12.725),(37.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.785),(61.545,15.955),(61.715,15.955),(61.715,15.785),(61.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.105),(61.545,15.275),(61.715,15.275),(61.715,15.105),(61.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.445),(61.545,15.615),(61.715,15.615),(61.715,15.445),(61.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.905),(61.545,5.075),(61.715,5.075),(61.715,4.905),(61.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,40.265),(76.285,40.435),(76.455,40.435),(76.455,40.265),(76.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.965),(18.345,8.135),(18.515,8.135),(18.515,7.965),(18.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.965),(18.685,8.135),(18.855,8.135),(18.855,7.965),(18.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.685),(37.885,10.855),(38.055,10.855),(38.055,10.685),(37.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.145),(75.945,17.315),(76.115,17.315),(76.115,17.145),(75.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.485),(75.945,17.655),(76.115,17.655),(76.115,17.485),(75.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.825),(75.945,17.995),(76.115,17.995),(76.115,17.825),(75.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.005),(37.885,10.175),(38.055,10.175),(38.055,10.005),(37.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.345),(37.885,10.515),(38.055,10.515),(38.055,10.345),(37.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,40.605),(76.285,40.775),(76.455,40.775),(76.455,40.605),(76.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.925),(37.885,23.095),(38.055,23.095),(38.055,22.925),(37.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,40.605),(18.685,40.775),(18.855,40.775),(18.855,40.605),(18.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.105),(13.545,15.275),(13.715,15.275),(13.715,15.105),(13.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.445),(13.545,15.615),(13.715,15.615),(13.715,15.445),(13.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.785),(13.545,15.955),(13.715,15.955),(13.715,15.785),(13.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.505),(56.745,18.675),(56.915,18.675),(56.915,18.505),(56.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.165),(56.745,18.335),(56.915,18.335),(56.915,18.165),(56.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.225),(23.485,4.395),(23.655,4.395),(23.655,4.225),(23.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,32.105),(80.745,32.275),(80.915,32.275),(80.915,32.105),(80.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,32.445),(80.745,32.615),(80.915,32.615),(80.915,32.445),(80.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,32.785),(80.745,32.955),(80.915,32.955),(80.915,32.785),(80.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,38.225),(8.745,38.395),(8.915,38.395),(8.915,38.225),(8.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,25.305),(13.545,25.475),(13.715,25.475),(13.715,25.305),(13.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,25.645),(13.545,25.815),(13.715,25.815),(13.715,25.645),(13.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,26.665),(66.685,26.835),(66.855,26.835),(66.855,26.665),(66.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.125),(47.145,33.295),(47.315,33.295),(47.315,33.125),(47.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.125),(47.485,33.295),(47.655,33.295),(47.655,33.125),(47.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.465),(47.145,33.635),(47.315,33.635),(47.315,33.465),(47.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.465),(47.485,33.635),(47.655,33.635),(47.655,33.465),(47.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.805),(47.145,33.975),(47.315,33.975),(47.315,33.805),(47.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.805),(47.485,33.975),(47.655,33.975),(47.655,33.805),(47.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,33.125),(27.945,33.295),(28.115,33.295),(28.115,33.125),(27.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,33.465),(27.945,33.635),(28.115,33.635),(28.115,33.465),(27.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,33.805),(27.945,33.975),(28.115,33.975),(28.115,33.805),(27.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.085),(56.745,31.255),(56.915,31.255),(56.915,31.085),(56.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,29.385),(71.145,29.555),(71.315,29.555),(71.315,29.385),(71.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.905),(52.285,39.075),(52.455,39.075),(52.455,38.905),(52.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.085),(33.085,14.255),(33.255,14.255),(33.255,14.085),(33.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,22.925),(66.345,23.095),(66.515,23.095),(66.515,22.925),(66.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,22.925),(66.685,23.095),(66.855,23.095),(66.855,22.925),(66.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.165),(42.685,35.335),(42.855,35.335),(42.855,35.165),(42.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.505),(42.345,35.675),(42.515,35.675),(42.515,35.505),(42.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.505),(42.685,35.675),(42.855,35.675),(42.855,35.505),(42.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.165),(42.345,35.335),(42.515,35.335),(42.515,35.165),(42.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.865),(52.285,20.035),(52.455,20.035),(52.455,19.865),(52.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,38.225),(76.285,38.395),(76.455,38.395),(76.455,38.225),(76.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,38.565),(76.285,38.735),(76.455,38.735),(76.455,38.565),(76.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,23.265),(18.345,23.435),(18.515,23.435),(18.515,23.265),(18.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,23.265),(18.685,23.435),(18.855,23.435),(18.855,23.265),(18.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,23.605),(18.685,23.775),(18.855,23.775),(18.855,23.605),(18.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.985),(61.545,9.155),(61.715,9.155),(61.715,8.985),(61.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,23.605),(18.345,23.775),(18.515,23.775),(18.515,23.605),(18.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,35.845),(66.345,36.015),(66.515,36.015),(66.515,35.845),(66.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,35.845),(66.685,36.015),(66.855,36.015),(66.855,35.845),(66.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.185),(76.285,19.355),(76.455,19.355),(76.455,19.185),(76.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.525),(76.285,19.695),(76.455,19.695),(76.455,19.525),(76.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.865),(33.085,37.035),(33.255,37.035),(33.255,36.865),(33.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.165),(57.085,18.335),(57.255,18.335),(57.255,18.165),(57.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.505),(57.085,18.675),(57.255,18.675),(57.255,18.505),(57.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,40.265),(47.145,40.435),(47.315,40.435),(47.315,40.265),(47.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,40.265),(47.485,40.435),(47.655,40.435),(47.655,40.265),(47.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,40.605),(47.145,40.775),(47.315,40.775),(47.315,40.605),(47.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,40.605),(47.485,40.775),(47.655,40.775),(47.655,40.605),(47.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,36.865),(9.085,37.035),(9.255,37.035),(9.255,36.865),(9.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.345),(66.685,10.515),(66.855,10.515),(66.855,10.345),(66.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.145),(52.285,17.315),(52.455,17.315),(52.455,17.145),(52.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.485),(52.285,17.655),(52.455,17.655),(52.455,17.485),(52.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.265),(81.085,6.435),(81.255,6.435),(81.255,6.265),(81.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.605),(81.085,6.775),(81.255,6.775),(81.255,6.605),(81.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.825),(52.285,17.995),(52.455,17.995),(52.455,17.825),(52.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.925),(8.745,6.095),(8.915,6.095),(8.915,5.925),(8.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.265),(13.885,6.435),(14.055,6.435),(14.055,6.265),(13.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.605),(13.885,6.775),(14.055,6.775),(14.055,6.605),(13.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.005),(56.745,10.175),(56.915,10.175),(56.915,10.005),(56.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.345),(56.745,10.515),(56.915,10.515),(56.915,10.345),(56.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.685),(56.745,10.855),(56.915,10.855),(56.915,10.685),(56.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,29.725),(76.285,29.895),(76.455,29.895),(76.455,29.725),(76.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,29.045),(76.285,29.215),(76.455,29.215),(76.455,29.045),(76.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,29.385),(76.285,29.555),(76.455,29.555),(76.455,29.385),(76.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.205),(52.285,3.375),(52.455,3.375),(52.455,3.205),(52.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.005),(8.745,10.175),(8.915,10.175),(8.915,10.005),(8.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.345),(8.745,10.515),(8.915,10.515),(8.915,10.345),(8.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.545),(52.285,3.715),(52.455,3.715),(52.455,3.545),(52.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.685),(8.745,10.855),(8.915,10.855),(8.915,10.685),(8.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.285),(56.745,24.455),(56.915,24.455),(56.915,24.285),(56.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.625),(56.745,24.795),(56.915,24.795),(56.915,24.625),(56.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.765),(56.745,14.935),(56.915,14.935),(56.915,14.765),(56.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.485),(37.885,17.655),(38.055,17.655),(38.055,17.485),(37.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,30.745),(18.685,30.915),(18.855,30.915),(18.855,30.745),(18.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,28.025),(76.285,28.195),(76.455,28.195),(76.455,28.025),(76.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,20.885),(28.285,21.055),(28.455,21.055),(28.455,20.885),(28.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.245),(51.945,22.415),(52.115,22.415),(52.115,22.245),(51.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.585),(51.945,22.755),(52.115,22.755),(52.115,22.585),(51.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.185),(13.545,19.355),(13.715,19.355),(13.715,19.185),(13.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.525),(13.545,19.695),(13.715,19.695),(13.715,19.525),(13.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.065),(80.745,13.235),(80.915,13.235),(80.915,13.065),(80.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.405),(80.745,13.575),(80.915,13.575),(80.915,13.405),(80.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.045),(13.545,12.215),(13.715,12.215),(13.715,12.045),(13.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.385),(13.545,12.555),(13.715,12.555),(13.715,12.385),(13.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.745),(80.745,13.915),(80.915,13.915),(80.915,13.745),(80.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.725),(13.545,12.895),(13.715,12.895),(13.715,12.725),(13.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.245),(37.545,39.415),(37.715,39.415),(37.715,39.245),(37.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.585),(37.545,39.755),(37.715,39.755),(37.715,39.585),(37.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.685),(13.885,10.855),(14.055,10.855),(14.055,10.685),(13.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.005),(13.885,10.175),(14.055,10.175),(14.055,10.005),(13.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.345),(13.885,10.515),(14.055,10.515),(14.055,10.345),(13.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.285),(37.885,7.455),(38.055,7.455),(38.055,7.285),(37.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.625),(37.885,7.795),(38.055,7.795),(38.055,7.625),(37.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.945),(28.285,7.115),(28.455,7.115),(28.455,6.945),(28.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.005),(32.745,27.175),(32.915,27.175),(32.915,27.005),(32.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.345),(32.745,27.515),(32.915,27.515),(32.915,27.345),(32.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,23.605),(76.285,23.775),(76.455,23.775),(76.455,23.605),(76.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,23.265),(76.285,23.435),(76.455,23.435),(76.455,23.265),(76.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.685),(32.745,27.855),(32.915,27.855),(32.915,27.685),(32.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.985),(52.285,26.155),(52.455,26.155),(52.455,25.985),(52.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.925),(80.745,6.095),(80.915,6.095),(80.915,5.925),(80.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,22.925),(81.085,23.095),(81.255,23.095),(81.255,22.925),(81.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,35.845),(18.345,36.015),(18.515,36.015),(18.515,35.845),(18.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,35.845),(18.685,36.015),(18.855,36.015),(18.855,35.845),(18.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,37.885),(9.085,38.055),(9.255,38.055),(9.255,37.885),(9.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.985),(18.685,9.155),(18.855,9.155),(18.855,8.985),(18.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.985),(18.345,9.155),(18.515,9.155),(18.515,8.985),(18.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,38.905),(81.085,39.075),(81.255,39.075),(81.255,38.905),(81.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,29.725),(18.685,29.895),(18.855,29.895),(18.855,29.725),(18.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,29.725),(18.345,29.895),(18.515,29.895),(18.515,29.725),(18.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,29.385),(18.345,29.555),(18.515,29.555),(18.515,29.385),(18.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,37.885),(71.145,38.055),(71.315,38.055),(71.315,37.885),(71.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,37.885),(71.485,38.055),(71.655,38.055),(71.655,37.885),(71.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,29.045),(18.345,29.215),(18.515,29.215),(18.515,29.045),(18.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,29.045),(18.685,29.215),(18.855,29.215),(18.855,29.045),(18.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,29.385),(18.685,29.555),(18.855,29.555),(18.855,29.385),(18.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,21.905),(13.545,22.075),(13.715,22.075),(13.715,21.905),(13.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,40.605),(33.085,40.775),(33.255,40.775),(33.255,40.605),(33.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,40.265),(33.085,40.435),(33.255,40.435),(33.255,40.265),(33.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.165),(32.745,35.335),(32.915,35.335),(32.915,35.165),(32.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.505),(32.745,35.675),(32.915,35.675),(32.915,35.505),(32.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,37.205),(80.745,37.375),(80.915,37.375),(80.915,37.205),(80.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.845),(57.085,36.015),(57.255,36.015),(57.255,35.845),(57.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,37.545),(80.745,37.715),(80.915,37.715),(80.915,37.545),(80.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.705),(9.085,11.875),(9.255,11.875),(9.255,11.705),(9.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.805),(81.085,16.975),(81.255,16.975),(81.255,16.805),(81.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.125),(81.085,16.295),(81.255,16.295),(81.255,16.125),(81.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.465),(81.085,16.635),(81.255,16.635),(81.255,16.465),(81.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.765),(37.545,14.935),(37.715,14.935),(37.715,14.765),(37.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.085),(37.545,14.255),(37.715,14.255),(37.715,14.085),(37.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,36.185),(13.885,36.355),(14.055,36.355),(14.055,36.185),(13.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,36.525),(13.885,36.695),(14.055,36.695),(14.055,36.525),(13.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,35.165),(8.745,35.335),(8.915,35.335),(8.915,35.165),(8.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,35.505),(8.745,35.675),(8.915,35.675),(8.915,35.505),(8.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.865),(52.285,37.035),(52.455,37.035),(52.455,36.865),(52.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.845),(33.085,36.015),(33.255,36.015),(33.255,35.845),(33.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,40.265),(13.885,40.435),(14.055,40.435),(14.055,40.265),(13.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,40.605),(13.885,40.775),(14.055,40.775),(14.055,40.605),(13.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.525),(47.145,36.695),(47.315,36.695),(47.315,36.525),(47.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.485),(37.545,34.655),(37.715,34.655),(37.715,34.485),(37.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.825),(37.545,34.995),(37.715,34.995),(37.715,34.825),(37.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.525),(47.485,36.695),(47.655,36.695),(47.655,36.525),(47.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.185),(47.145,36.355),(47.315,36.355),(47.315,36.185),(47.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,39.245),(9.085,39.415),(9.255,39.415),(9.255,39.245),(9.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,39.585),(9.085,39.755),(9.255,39.755),(9.255,39.585),(9.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.145),(37.545,34.315),(37.715,34.315),(37.715,34.145),(37.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.185),(47.485,36.355),(47.655,36.355),(47.655,36.185),(47.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,36.525),(23.145,36.695),(23.315,36.695),(23.315,36.525),(23.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,36.185),(23.485,36.355),(23.655,36.355),(23.655,36.185),(23.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,36.525),(23.485,36.695),(23.655,36.695),(23.655,36.525),(23.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,36.185),(23.145,36.355),(23.315,36.355),(23.315,36.185),(23.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.825),(81.085,17.995),(81.255,17.995),(81.255,17.825),(81.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.145),(81.085,17.315),(81.255,17.315),(81.255,17.145),(81.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.485),(81.085,17.655),(81.255,17.655),(81.255,17.485),(81.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.225),(47.145,21.395),(47.315,21.395),(47.315,21.225),(47.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.225),(47.485,21.395),(47.655,21.395),(47.655,21.225),(47.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.565),(47.145,21.735),(47.315,21.735),(47.315,21.565),(47.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.565),(47.485,21.735),(47.655,21.735),(47.655,21.565),(47.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,2.865),(13.885,3.035),(14.055,3.035),(14.055,2.865),(13.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.165),(51.945,18.335),(52.115,18.335),(52.115,18.165),(51.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.505),(51.945,18.675),(52.115,18.675),(52.115,18.505),(51.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.145),(23.485,17.315),(23.655,17.315),(23.655,17.145),(23.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.145),(23.145,17.315),(23.315,17.315),(23.315,17.145),(23.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.485),(23.145,17.655),(23.315,17.655),(23.315,17.485),(23.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.485),(23.485,17.655),(23.655,17.655),(23.655,17.485),(23.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.825),(23.485,17.995),(23.655,17.995),(23.655,17.825),(23.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,35.845),(28.285,36.015),(28.455,36.015),(28.455,35.845),(28.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.825),(23.145,17.995),(23.315,17.995),(23.315,17.825),(23.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.865),(80.745,20.035),(80.915,20.035),(80.915,19.865),(80.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.945),(51.945,24.115),(52.115,24.115),(52.115,23.945),(51.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.965),(66.345,8.135),(66.515,8.135),(66.515,7.965),(66.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.965),(66.685,8.135),(66.855,8.135),(66.855,7.965),(66.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.965),(57.085,8.135),(57.255,8.135),(57.255,7.965),(57.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.445),(42.345,32.615),(42.515,32.615),(42.515,32.445),(42.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.905),(80.745,5.075),(80.915,5.075),(80.915,4.905),(80.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.845),(42.345,36.015),(42.515,36.015),(42.515,35.845),(42.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.845),(42.685,36.015),(42.855,36.015),(42.855,35.845),(42.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.065),(32.745,13.235),(32.915,13.235),(32.915,13.065),(32.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.405),(32.745,13.575),(32.915,13.575),(32.915,13.405),(32.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.745),(32.745,13.915),(32.915,13.915),(32.915,13.745),(32.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.965),(33.085,8.135),(33.255,8.135),(33.255,7.965),(33.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,35.845),(80.745,36.015),(80.915,36.015),(80.915,35.845),(80.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.225),(75.945,4.395),(76.115,4.395),(76.115,4.225),(75.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.565),(75.945,4.735),(76.115,4.735),(76.115,4.565),(75.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,31.765),(76.285,31.935),(76.455,31.935),(76.455,31.765),(76.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,31.085),(76.285,31.255),(76.455,31.255),(76.455,31.085),(76.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,31.425),(76.285,31.595),(76.455,31.595),(76.455,31.425),(76.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.965),(9.085,8.135),(9.255,8.135),(9.255,7.965),(9.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.925),(56.745,6.095),(56.915,6.095),(56.915,5.925),(56.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,37.885),(75.945,38.055),(76.115,38.055),(76.115,37.885),(75.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.265),(61.885,6.435),(62.055,6.435),(62.055,6.265),(61.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.605),(61.885,6.775),(62.055,6.775),(62.055,6.605),(61.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.925),(32.745,6.095),(32.915,6.095),(32.915,5.925),(32.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.865),(37.545,20.035),(37.715,20.035),(37.715,19.865),(37.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,25.985),(80.745,26.155),(80.915,26.155),(80.915,25.985),(80.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,33.805),(28.285,33.975),(28.455,33.975),(28.455,33.805),(28.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,33.125),(28.285,33.295),(28.455,33.295),(28.455,33.125),(28.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,33.465),(28.285,33.635),(28.455,33.635),(28.455,33.465),(28.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.745),(61.885,13.915),(62.055,13.915),(62.055,13.745),(61.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.065),(61.885,13.235),(62.055,13.235),(62.055,13.065),(61.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.405),(61.885,13.575),(62.055,13.575),(62.055,13.405),(61.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.525),(51.945,19.695),(52.115,19.695),(52.115,19.525),(51.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.985),(27.945,9.155),(28.115,9.155),(28.115,8.985),(27.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.865),(13.885,20.035),(14.055,20.035),(14.055,19.865),(13.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.845),(18.345,19.015),(18.515,19.015),(18.515,18.845),(18.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.845),(18.685,19.015),(18.855,19.015),(18.855,18.845),(18.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.985),(52.285,9.155),(52.455,9.155),(52.455,8.985),(52.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.265),(32.745,23.435),(32.915,23.435),(32.915,23.265),(32.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.605),(32.745,23.775),(32.915,23.775),(32.915,23.605),(32.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.745),(13.885,13.915),(14.055,13.915),(14.055,13.745),(13.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.065),(13.885,13.235),(14.055,13.235),(14.055,13.065),(13.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.405),(13.885,13.575),(14.055,13.575),(14.055,13.405),(13.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.865),(42.345,37.035),(42.515,37.035),(42.515,36.865),(42.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.865),(42.685,37.035),(42.855,37.035),(42.855,36.865),(42.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.725),(61.545,12.895),(61.715,12.895),(61.715,12.725),(61.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.045),(61.545,12.215),(61.715,12.215),(61.715,12.045),(61.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.385),(61.545,12.555),(61.715,12.555),(61.715,12.385),(61.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.105),(8.745,15.275),(8.915,15.275),(8.915,15.105),(8.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.445),(8.745,15.615),(8.915,15.615),(8.915,15.445),(8.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.785),(8.745,15.955),(8.915,15.955),(8.915,15.785),(8.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,21.905),(13.885,22.075),(14.055,22.075),(14.055,21.905),(13.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.005),(61.885,10.175),(62.055,10.175),(62.055,10.005),(61.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.345),(61.885,10.515),(62.055,10.515),(62.055,10.345),(61.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.685),(61.885,10.855),(62.055,10.855),(62.055,10.685),(61.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,38.225),(27.945,38.395),(28.115,38.395),(28.115,38.225),(27.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.305),(80.745,8.475),(80.915,8.475),(80.915,8.305),(80.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.645),(80.745,8.815),(80.915,8.815),(80.915,8.645),(80.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,38.565),(27.945,38.735),(28.115,38.735),(28.115,38.565),(27.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.765),(52.285,14.935),(52.455,14.935),(52.455,14.765),(52.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,36.865),(61.885,37.035),(62.055,37.035),(62.055,36.865),(61.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.425),(52.285,14.595),(52.455,14.595),(52.455,14.425),(52.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.085),(52.285,14.255),(52.455,14.255),(52.455,14.085),(52.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.205),(42.345,20.375),(42.515,20.375),(42.515,20.205),(42.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.205),(42.685,20.375),(42.855,20.375),(42.855,20.205),(42.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.545),(42.345,20.715),(42.515,20.715),(42.515,20.545),(42.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.965),(81.085,8.135),(81.255,8.135),(81.255,7.965),(81.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,39.245),(66.345,39.415),(66.515,39.415),(66.515,39.245),(66.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,39.245),(66.685,39.415),(66.855,39.415),(66.855,39.245),(66.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,39.585),(66.345,39.755),(66.515,39.755),(66.515,39.585),(66.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,39.585),(66.685,39.755),(66.855,39.755),(66.855,39.585),(66.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.545),(42.685,20.715),(42.855,20.715),(42.855,20.545),(42.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.865),(51.945,20.035),(52.115,20.035),(52.115,19.865),(51.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,20.205),(8.745,20.375),(8.915,20.375),(8.915,20.205),(8.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,20.545),(8.745,20.715),(8.915,20.715),(8.915,20.545),(8.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.985),(56.745,26.155),(56.915,26.155),(56.915,25.985),(56.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.885),(33.085,38.055),(33.255,38.055),(33.255,37.885),(33.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.945),(37.545,24.115),(37.715,24.115),(37.715,23.945),(37.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,39.925),(28.285,40.095),(28.455,40.095),(28.455,39.925),(28.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.345),(13.545,10.515),(13.715,10.515),(13.715,10.345),(13.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.845),(80.745,19.015),(80.915,19.015),(80.915,18.845),(80.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.845),(13.545,19.015),(13.715,19.015),(13.715,18.845),(13.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,24.965),(71.485,25.135),(71.655,25.135),(71.655,24.965),(71.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,24.965),(71.145,25.135),(71.315,25.135),(71.315,24.965),(71.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,27.345),(23.485,27.515),(23.655,27.515),(23.655,27.345),(23.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,27.685),(23.145,27.855),(23.315,27.855),(23.315,27.685),(23.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,27.685),(23.485,27.855),(23.655,27.855),(23.655,27.685),(23.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,27.345),(23.145,27.515),(23.315,27.515),(23.315,27.345),(23.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.765),(13.545,14.935),(13.715,14.935),(13.715,14.765),(13.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.085),(13.545,14.255),(13.715,14.255),(13.715,14.085),(13.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.425),(13.545,14.595),(13.715,14.595),(13.715,14.425),(13.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,27.005),(23.145,27.175),(23.315,27.175),(23.315,27.005),(23.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.245),(37.545,5.415),(37.715,5.415),(37.715,5.245),(37.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.325),(47.145,9.495),(47.315,9.495),(47.315,9.325),(47.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.325),(47.485,9.495),(47.655,9.495),(47.655,9.325),(47.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.965),(52.285,8.135),(52.455,8.135),(52.455,7.965),(52.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.585),(37.545,5.755),(37.715,5.755),(37.715,5.585),(37.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.665),(47.145,9.835),(47.315,9.835),(47.315,9.665),(47.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.665),(47.485,9.835),(47.655,9.835),(47.655,9.665),(47.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,37.885),(76.285,38.055),(76.455,38.055),(76.455,37.885),(76.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,39.585),(71.145,39.755),(71.315,39.755),(71.315,39.585),(71.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,39.245),(71.485,39.415),(71.655,39.415),(71.655,39.245),(71.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,39.245),(71.145,39.415),(71.315,39.415),(71.315,39.245),(71.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,22.925),(13.545,23.095),(13.715,23.095),(13.715,22.925),(13.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,39.585),(71.485,39.755),(71.655,39.755),(71.655,39.585),(71.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.945),(47.145,24.115),(47.315,24.115),(47.315,23.945),(47.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.945),(47.485,24.115),(47.655,24.115),(47.655,23.945),(47.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.305),(32.745,25.475),(32.915,25.475),(32.915,25.305),(32.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.645),(32.745,25.815),(32.915,25.815),(32.915,25.645),(32.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.245),(33.085,39.415),(33.255,39.415),(33.255,39.245),(33.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.585),(33.085,39.755),(33.255,39.755),(33.255,39.585),(33.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,21.905),(27.945,22.075),(28.115,22.075),(28.115,21.905),(27.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.905),(37.885,5.075),(38.055,5.075),(38.055,4.905),(37.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,2.865),(61.885,3.035),(62.055,3.035),(62.055,2.865),(61.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.545),(56.745,37.715),(56.915,37.715),(56.915,37.545),(56.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,21.905),(28.285,22.075),(28.455,22.075),(28.455,21.905),(28.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.065),(47.145,13.235),(47.315,13.235),(47.315,13.065),(47.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.065),(47.485,13.235),(47.655,13.235),(47.655,13.065),(47.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.405),(47.145,13.575),(47.315,13.575),(47.315,13.405),(47.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.405),(47.485,13.575),(47.655,13.575),(47.655,13.405),(47.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.745),(47.145,13.915),(47.315,13.915),(47.315,13.745),(47.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.185),(37.885,19.355),(38.055,19.355),(38.055,19.185),(37.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.525),(37.885,19.695),(38.055,19.695),(38.055,19.525),(37.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.745),(47.485,13.915),(47.655,13.915),(47.655,13.745),(47.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,36.185),(71.145,36.355),(71.315,36.355),(71.315,36.185),(71.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,36.525),(71.145,36.695),(71.315,36.695),(71.315,36.525),(71.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,36.185),(71.485,36.355),(71.655,36.355),(71.655,36.185),(71.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,36.525),(71.485,36.695),(71.655,36.695),(71.655,36.525),(71.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,31.765),(71.145,31.935),(71.315,31.935),(71.315,31.765),(71.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.985),(66.345,9.155),(66.515,9.155),(66.515,8.985),(66.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.985),(66.685,9.155),(66.855,9.155),(66.855,8.985),(66.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.245),(66.345,5.415),(66.515,5.415),(66.515,5.245),(66.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.245),(66.685,5.415),(66.855,5.415),(66.855,5.245),(66.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.585),(66.345,5.755),(66.515,5.755),(66.515,5.585),(66.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.585),(66.685,5.755),(66.855,5.755),(66.855,5.585),(66.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.985),(76.285,9.155),(76.455,9.155),(76.455,8.985),(76.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,39.245),(18.685,39.415),(18.855,39.415),(18.855,39.245),(18.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,39.585),(18.685,39.755),(18.855,39.755),(18.855,39.585),(18.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,39.245),(18.345,39.415),(18.515,39.415),(18.515,39.245),(18.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,39.585),(18.345,39.755),(18.515,39.755),(18.515,39.585),(18.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.585),(42.345,5.755),(42.515,5.755),(42.515,5.585),(42.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.585),(42.685,5.755),(42.855,5.755),(42.855,5.585),(42.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.245),(42.685,5.415),(42.855,5.415),(42.855,5.245),(42.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.245),(42.345,5.415),(42.515,5.415),(42.515,5.245),(42.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.205),(37.885,37.375),(38.055,37.375),(38.055,37.205),(37.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.545),(37.885,37.715),(38.055,37.715),(38.055,37.545),(37.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,39.245),(61.885,39.415),(62.055,39.415),(62.055,39.245),(61.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,39.585),(61.885,39.755),(62.055,39.755),(62.055,39.585),(61.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.985),(28.285,9.155),(28.455,9.155),(28.455,8.985),(28.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.805),(37.885,16.975),(38.055,16.975),(38.055,16.805),(37.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.125),(37.885,16.295),(38.055,16.295),(38.055,16.125),(37.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.465),(37.885,16.635),(38.055,16.635),(38.055,16.465),(37.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.605),(23.145,6.775),(23.315,6.775),(23.315,6.605),(23.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.605),(23.485,6.775),(23.655,6.775),(23.655,6.605),(23.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,20.885),(23.145,21.055),(23.315,21.055),(23.315,20.885),(23.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,20.885),(23.485,21.055),(23.655,21.055),(23.655,20.885),(23.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.105),(56.745,15.275),(56.915,15.275),(56.915,15.105),(56.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.445),(56.745,15.615),(56.915,15.615),(56.915,15.445),(56.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.785),(56.745,15.955),(56.915,15.955),(56.915,15.785),(56.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.325),(33.085,9.495),(33.255,9.495),(33.255,9.325),(33.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.665),(33.085,9.835),(33.255,9.835),(33.255,9.665),(33.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,39.925),(76.285,40.095),(76.455,40.095),(76.455,39.925),(76.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.765),(28.285,14.935),(28.455,14.935),(28.455,14.765),(28.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.085),(28.285,14.255),(28.455,14.255),(28.455,14.085),(28.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.425),(28.285,14.595),(28.455,14.595),(28.455,14.425),(28.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,31.765),(80.745,31.935),(80.915,31.935),(80.915,31.765),(80.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,31.085),(80.745,31.255),(80.915,31.255),(80.915,31.085),(80.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,31.425),(80.745,31.595),(80.915,31.595),(80.915,31.425),(80.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.825),(66.345,17.995),(66.515,17.995),(66.515,17.825),(66.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.865),(57.085,20.035),(57.255,20.035),(57.255,19.865),(57.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.945),(32.745,24.115),(32.915,24.115),(32.915,23.945),(32.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.345),(80.745,10.515),(80.915,10.515),(80.915,10.345),(80.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.165),(9.085,18.335),(9.255,18.335),(9.255,18.165),(9.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.505),(9.085,18.675),(9.255,18.675),(9.255,18.505),(9.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,36.185),(81.085,36.355),(81.255,36.355),(81.255,36.185),(81.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.945),(76.285,7.115),(76.455,7.115),(76.455,6.945),(76.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,36.525),(81.085,36.695),(81.255,36.695),(81.255,36.525),(81.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.825),(56.745,34.995),(56.915,34.995),(56.915,34.825),(56.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,25.985),(28.285,26.155),(28.455,26.155),(28.455,25.985),(28.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,33.805),(75.945,33.975),(76.115,33.975),(76.115,33.805),(75.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,33.125),(75.945,33.295),(76.115,33.295),(76.115,33.125),(75.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,33.465),(75.945,33.635),(76.115,33.635),(76.115,33.465),(75.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.245),(42.685,39.415),(42.855,39.415),(42.855,39.245),(42.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.245),(42.345,39.415),(42.515,39.415),(42.515,39.245),(42.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.585),(42.685,39.755),(42.855,39.755),(42.855,39.585),(42.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.585),(42.345,39.755),(42.515,39.755),(42.515,39.585),(42.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.765),(61.545,14.935),(61.715,14.935),(61.715,14.765),(61.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.085),(61.545,14.255),(61.715,14.255),(61.715,14.085),(61.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.425),(61.545,14.595),(61.715,14.595),(61.715,14.425),(61.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.905),(57.085,22.075),(57.255,22.075),(57.255,21.905),(57.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,36.185),(18.345,36.355),(18.515,36.355),(18.515,36.185),(18.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,36.525),(18.345,36.695),(18.515,36.695),(18.515,36.525),(18.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,36.185),(18.685,36.355),(18.855,36.355),(18.855,36.185),(18.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,36.525),(18.685,36.695),(18.855,36.695),(18.855,36.525),(18.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.585),(18.685,5.755),(18.855,5.755),(18.855,5.585),(18.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.045),(52.285,12.215),(52.455,12.215),(52.455,12.045),(52.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.385),(52.285,12.555),(52.455,12.555),(52.455,12.385),(52.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.245),(18.345,5.415),(18.515,5.415),(18.515,5.245),(18.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.725),(52.285,12.895),(52.455,12.895),(52.455,12.725),(52.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.245),(18.685,5.415),(18.855,5.415),(18.855,5.245),(18.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.585),(18.345,5.755),(18.515,5.755),(18.515,5.585),(18.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.205),(37.545,3.375),(37.715,3.375),(37.715,3.205),(37.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.545),(37.545,3.715),(37.715,3.715),(37.715,3.545),(37.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,35.845),(75.945,36.015),(76.115,36.015),(76.115,35.845),(75.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,25.305),(71.145,25.475),(71.315,25.475),(71.315,25.305),(71.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,25.645),(71.145,25.815),(71.315,25.815),(71.315,25.645),(71.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,25.645),(71.485,25.815),(71.655,25.815),(71.655,25.645),(71.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,25.305),(71.485,25.475),(71.655,25.475),(71.655,25.305),(71.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.225),(57.085,38.395),(57.255,38.395),(57.255,38.225),(57.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.565),(57.085,38.735),(57.255,38.735),(57.255,38.565),(57.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.065),(33.085,13.235),(33.255,13.235),(33.255,13.065),(33.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.845),(71.145,19.015),(71.315,19.015),(71.315,18.845),(71.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.845),(71.485,19.015),(71.655,19.015),(71.655,18.845),(71.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.785),(47.485,15.955),(47.655,15.955),(47.655,15.785),(47.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,40.265),(51.945,40.435),(52.115,40.435),(52.115,40.265),(51.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,40.605),(51.945,40.775),(52.115,40.775),(52.115,40.605),(51.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.605),(57.085,23.775),(57.255,23.775),(57.255,23.605),(57.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.265),(57.085,23.435),(57.255,23.435),(57.255,23.265),(57.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,22.925),(71.145,23.095),(71.315,23.095),(71.315,22.925),(71.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,22.925),(71.485,23.095),(71.655,23.095),(71.655,22.925),(71.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.245),(57.085,5.415),(57.255,5.415),(57.255,5.245),(57.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.705),(51.945,11.875),(52.115,11.875),(52.115,11.705),(51.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.585),(57.085,5.755),(57.255,5.755),(57.255,5.585),(57.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.025),(51.945,11.195),(52.115,11.195),(52.115,11.025),(51.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.365),(51.945,11.535),(52.115,11.535),(52.115,11.365),(51.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.165),(8.745,18.335),(8.915,18.335),(8.915,18.165),(8.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.505),(8.745,18.675),(8.915,18.675),(8.915,18.505),(8.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.245),(33.085,5.415),(33.255,5.415),(33.255,5.245),(33.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.585),(33.085,5.755),(33.255,5.755),(33.255,5.585),(33.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,38.905),(71.145,39.075),(71.315,39.075),(71.315,38.905),(71.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.845),(81.085,19.015),(81.255,19.015),(81.255,18.845),(81.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,38.905),(71.485,39.075),(71.655,39.075),(71.655,38.905),(71.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.245),(9.085,5.415),(9.255,5.415),(9.255,5.245),(9.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.585),(9.085,5.755),(9.255,5.755),(9.255,5.585),(9.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.045),(42.345,29.215),(42.515,29.215),(42.515,29.045),(42.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.985),(75.945,9.155),(76.115,9.155),(76.115,8.985),(75.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.725),(42.345,29.895),(42.515,29.895),(42.515,29.725),(42.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.725),(42.685,29.895),(42.855,29.895),(42.855,29.725),(42.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.045),(42.685,29.215),(42.855,29.215),(42.855,29.045),(42.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.385),(42.345,29.555),(42.515,29.555),(42.515,29.385),(42.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.385),(42.685,29.555),(42.855,29.555),(42.855,29.385),(42.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.885),(71.145,4.055),(71.315,4.055),(71.315,3.885),(71.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.705),(32.745,28.875),(32.915,28.875),(32.915,28.705),(32.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.885),(71.485,4.055),(71.655,4.055),(71.655,3.885),(71.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.025),(32.745,28.195),(32.915,28.195),(32.915,28.025),(32.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.365),(32.745,28.535),(32.915,28.535),(32.915,28.365),(32.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.885),(33.085,21.055),(33.255,21.055),(33.255,20.885),(33.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.885),(47.145,4.055),(47.315,4.055),(47.315,3.885),(47.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.885),(47.485,4.055),(47.655,4.055),(47.655,3.885),(47.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.465),(75.945,16.635),(76.115,16.635),(76.115,16.465),(75.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.125),(75.945,16.295),(76.115,16.295),(76.115,16.125),(75.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.805),(75.945,16.975),(76.115,16.975),(76.115,16.805),(75.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.425),(42.345,14.595),(42.515,14.595),(42.515,14.425),(42.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.425),(42.685,14.595),(42.855,14.595),(42.855,14.425),(42.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.085),(42.685,14.255),(42.855,14.255),(42.855,14.085),(42.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.765),(42.345,14.935),(42.515,14.935),(42.515,14.765),(42.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.765),(42.685,14.935),(42.855,14.935),(42.855,14.765),(42.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.085),(42.345,14.255),(42.515,14.255),(42.515,14.085),(42.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.885),(23.145,4.055),(23.315,4.055),(23.315,3.885),(23.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.885),(23.485,4.055),(23.655,4.055),(23.655,3.885),(23.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.865),(51.945,3.035),(52.115,3.035),(52.115,2.865),(51.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,33.805),(61.545,33.975),(61.715,33.975),(61.715,33.805),(61.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,33.125),(61.545,33.295),(61.715,33.295),(61.715,33.125),(61.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,33.465),(61.545,33.635),(61.715,33.635),(61.715,33.465),(61.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,37.545),(61.545,37.715),(61.715,37.715),(61.715,37.545),(61.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,37.205),(61.545,37.375),(61.715,37.375),(61.715,37.205),(61.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,35.165),(13.545,35.335),(13.715,35.335),(13.715,35.165),(13.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,35.505),(13.545,35.675),(13.715,35.675),(13.715,35.505),(13.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.245),(8.745,5.415),(8.915,5.415),(8.915,5.245),(8.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.585),(8.745,5.755),(8.915,5.755),(8.915,5.585),(8.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,35.165),(9.085,35.335),(9.255,35.335),(9.255,35.165),(9.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,35.505),(9.085,35.675),(9.255,35.675),(9.255,35.505),(9.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.045),(76.285,12.215),(76.455,12.215),(76.455,12.045),(76.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.385),(76.285,12.555),(76.455,12.555),(76.455,12.385),(76.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.105),(71.145,15.275),(71.315,15.275),(71.315,15.105),(71.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.105),(71.485,15.275),(71.655,15.275),(71.655,15.105),(71.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.445),(71.145,15.615),(71.315,15.615),(71.315,15.445),(71.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.445),(71.485,15.615),(71.655,15.615),(71.655,15.445),(71.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.885),(37.885,4.055),(38.055,4.055),(38.055,3.885),(37.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.725),(76.285,12.895),(76.455,12.895),(76.455,12.725),(76.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.785),(71.145,15.955),(71.315,15.955),(71.315,15.785),(71.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.785),(71.485,15.955),(71.655,15.955),(71.655,15.785),(71.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.705),(71.485,11.875),(71.655,11.875),(71.655,11.705),(71.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.005),(56.745,27.175),(56.915,27.175),(56.915,27.005),(56.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.345),(56.745,27.515),(56.915,27.515),(56.915,27.345),(56.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.685),(56.745,27.855),(56.915,27.855),(56.915,27.685),(56.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,20.885),(76.285,21.055),(76.455,21.055),(76.455,20.885),(76.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.025),(33.085,11.195),(33.255,11.195),(33.255,11.025),(33.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.365),(33.085,11.535),(33.255,11.535),(33.255,11.365),(33.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.705),(33.085,11.875),(33.255,11.875),(33.255,11.705),(33.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.045),(28.285,12.215),(28.455,12.215),(28.455,12.045),(28.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.385),(28.285,12.555),(28.455,12.555),(28.455,12.385),(28.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.105),(23.145,15.275),(23.315,15.275),(23.315,15.105),(23.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.105),(23.485,15.275),(23.655,15.275),(23.655,15.105),(23.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.445),(23.145,15.615),(23.315,15.615),(23.315,15.445),(23.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.445),(23.485,15.615),(23.655,15.615),(23.655,15.445),(23.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.785),(23.485,15.955),(23.655,15.955),(23.655,15.785),(23.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.725),(28.285,12.895),(28.455,12.895),(28.455,12.725),(28.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.765),(32.745,14.935),(32.915,14.935),(32.915,14.765),(32.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,28.705),(66.345,28.875),(66.515,28.875),(66.515,28.705),(66.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.505),(47.485,35.675),(47.655,35.675),(47.655,35.505),(47.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.505),(47.145,35.675),(47.315,35.675),(47.315,35.505),(47.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.165),(47.145,35.335),(47.315,35.335),(47.315,35.165),(47.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,36.865),(61.545,37.035),(61.715,37.035),(61.715,36.865),(61.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.925),(37.885,6.095),(38.055,6.095),(38.055,5.925),(37.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.165),(47.485,35.335),(47.655,35.335),(47.655,35.165),(47.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.985),(47.145,9.155),(47.315,9.155),(47.315,8.985),(47.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.985),(47.485,9.155),(47.655,9.155),(47.655,8.985),(47.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.985),(81.085,9.155),(81.255,9.155),(81.255,8.985),(81.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.025),(52.285,11.195),(52.455,11.195),(52.455,11.025),(52.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.365),(52.285,11.535),(52.455,11.535),(52.455,11.365),(52.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.705),(52.285,11.875),(52.455,11.875),(52.455,11.705),(52.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.105),(57.085,15.275),(57.255,15.275),(57.255,15.105),(57.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.445),(57.085,15.615),(57.255,15.615),(57.255,15.445),(57.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.785),(57.085,15.955),(57.255,15.955),(57.255,15.785),(57.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,24.285),(8.745,24.455),(8.915,24.455),(8.915,24.285),(8.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,24.625),(8.745,24.795),(8.915,24.795),(8.915,24.625),(8.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,36.865),(8.745,37.035),(8.915,37.035),(8.915,36.865),(8.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,22.925),(18.345,23.095),(18.515,23.095),(18.515,22.925),(18.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,22.925),(18.685,23.095),(18.855,23.095),(18.855,22.925),(18.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.745),(51.945,30.915),(52.115,30.915),(52.115,30.745),(51.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.065),(51.945,30.235),(52.115,30.235),(52.115,30.065),(51.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.405),(51.945,30.575),(52.115,30.575),(52.115,30.405),(51.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.965),(37.885,8.135),(38.055,8.135),(38.055,7.965),(37.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,28.705),(75.945,28.875),(76.115,28.875),(76.115,28.705),(75.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.785),(9.085,15.955),(9.255,15.955),(9.255,15.785),(9.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.925),(47.145,6.095),(47.315,6.095),(47.315,5.925),(47.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.585),(80.745,5.755),(80.915,5.755),(80.915,5.585),(80.745,5.585)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.835),(22.775,40.805),(24.025,40.805),(24.025,2.835),(22.775,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.785),(22.775,40.855),(24.025,40.855),(24.025,2.785),(22.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((51.945,2.785),(51.945,40.855),(52.455,40.855),(52.455,2.785),(51.945,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.835),(51.575,40.805),(52.825,40.805),(52.825,2.835),(51.575,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.785),(51.575,40.855),(52.825,40.855),(52.825,2.785),(51.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.835),(17.975,40.805),(19.225,40.805),(19.225,2.835),(17.975,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.785),(17.975,40.855),(19.225,40.855),(19.225,2.785),(17.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.835),(70.775,40.805),(72.025,40.805),(72.025,2.835),(70.775,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.785),(70.775,40.855),(72.025,40.855),(72.025,2.785),(70.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((66.345,2.785),(66.345,40.855),(66.855,40.855),(66.855,2.785),(66.345,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((27.945,2.785),(27.945,40.855),(28.455,40.855),(28.455,2.785),(27.945,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.835),(27.575,40.805),(28.825,40.805),(28.825,2.835),(27.575,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.785),(27.575,40.855),(28.825,40.855),(28.825,2.785),(27.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.835),(41.975,40.805),(43.225,40.805),(43.225,2.835),(41.975,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((61.545,2.785),(61.545,40.855),(62.055,40.855),(62.055,2.785),(61.545,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.835),(61.175,40.805),(62.425,40.805),(62.425,2.835),(61.175,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.785),(61.175,40.855),(62.425,40.855),(62.425,2.785),(61.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.785),(41.975,40.855),(43.225,40.855),(43.225,2.785),(41.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((47.145,2.785),(47.145,40.855),(47.655,40.855),(47.655,2.785),(47.145,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((23.145,2.785),(23.145,40.855),(23.655,40.855),(23.655,2.785),(23.145,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.745,2.785),(32.745,40.855),(33.255,40.855),(33.255,2.785),(32.745,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((80.745,2.785),(80.745,40.855),(81.255,40.855),(81.255,2.785),(80.745,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.785),(32.375,40.855),(33.625,40.855),(33.625,2.785),(32.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.835),(32.375,40.805),(33.625,40.805),(33.625,2.835),(32.375,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((75.945,2.785),(75.945,40.855),(76.455,40.855),(76.455,2.785),(75.945,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.835),(75.575,40.805),(76.825,40.805),(76.825,2.835),(75.575,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.785),(75.575,40.855),(76.825,40.855),(76.825,2.785),(75.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.835),(80.375,40.805),(81.625,40.805),(81.625,2.835),(80.375,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((13.545,2.785),(13.545,40.855),(14.055,40.855),(14.055,2.785),(13.545,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.785),(80.375,40.855),(81.625,40.855),(81.625,2.785),(80.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.835),(13.175,40.805),(14.425,40.805),(14.425,2.835),(13.175,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.785),(13.175,40.855),(14.425,40.855),(14.425,2.785),(13.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((8.745,2.785),(8.745,40.855),(9.255,40.855),(9.255,2.785),(8.745,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.835),(8.375,40.805),(9.625,40.805),(9.625,2.835),(8.375,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.785),(8.375,40.855),(9.625,40.855),(9.625,2.785),(8.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.835),(65.975,40.805),(67.225,40.805),(67.225,2.835),(65.975,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.785),(65.975,40.855),(67.225,40.855),(67.225,2.785),(65.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.835),(46.775,40.805),(48.025,40.805),(48.025,2.835),(46.775,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.785),(46.775,40.855),(48.025,40.855),(48.025,2.785),(46.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((56.745,2.785),(56.745,40.855),(57.255,40.855),(57.255,2.785),(56.745,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.785),(56.375,40.855),(57.625,40.855),(57.625,2.785),(56.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((71.145,2.785),(71.145,40.855),(71.655,40.855),(71.655,2.785),(71.145,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((18.345,2.785),(18.345,40.855),(18.855,40.855),(18.855,2.785),(18.345,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((37.545,2.785),(37.545,40.855),(38.055,40.855),(38.055,2.785),(37.545,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.835),(37.175,40.805),(38.425,40.805),(38.425,2.835),(37.175,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.785),(37.175,40.855),(38.425,40.855),(38.425,2.785),(37.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.835),(56.375,40.805),(57.625,40.805),(57.625,2.835),(56.375,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((42.345,2.785),(42.345,40.855),(42.855,40.855),(42.855,2.785),(42.345,2.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,2.835),(61.175,3.005),(61.345,3.005),(61.345,2.835),(61.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,2.835),(61.535,3.005),(61.705,3.005),(61.705,2.835),(61.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,2.835),(61.895,3.005),(62.065,3.005),(62.065,2.835),(61.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,2.835),(62.255,3.005),(62.425,3.005),(62.425,2.835),(62.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.195),(61.175,3.365),(61.345,3.365),(61.345,3.195),(61.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.195),(61.535,3.365),(61.705,3.365),(61.705,3.195),(61.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.195),(61.895,3.365),(62.065,3.365),(62.065,3.195),(61.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.195),(62.255,3.365),(62.425,3.365),(62.425,3.195),(62.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.555),(61.175,3.725),(61.345,3.725),(61.345,3.555),(61.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.555),(61.535,3.725),(61.705,3.725),(61.705,3.555),(61.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.555),(61.895,3.725),(62.065,3.725),(62.065,3.555),(61.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.555),(62.255,3.725),(62.425,3.725),(62.425,3.555),(62.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.915),(61.175,4.085),(61.345,4.085),(61.345,3.915),(61.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.915),(61.535,4.085),(61.705,4.085),(61.705,3.915),(61.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.915),(61.895,4.085),(62.065,4.085),(62.065,3.915),(61.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.915),(62.255,4.085),(62.425,4.085),(62.425,3.915),(62.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.275),(61.175,4.445),(61.345,4.445),(61.345,4.275),(61.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.275),(61.535,4.445),(61.705,4.445),(61.705,4.275),(61.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.275),(61.895,4.445),(62.065,4.445),(62.065,4.275),(61.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.275),(62.255,4.445),(62.425,4.445),(62.425,4.275),(62.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.635),(61.175,4.805),(61.345,4.805),(61.345,4.635),(61.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.635),(61.535,4.805),(61.705,4.805),(61.705,4.635),(61.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.635),(61.895,4.805),(62.065,4.805),(62.065,4.635),(61.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.635),(62.255,4.805),(62.425,4.805),(62.425,4.635),(62.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.995),(61.175,5.165),(61.345,5.165),(61.345,4.995),(61.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.995),(61.535,5.165),(61.705,5.165),(61.705,4.995),(61.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.995),(61.895,5.165),(62.065,5.165),(62.065,4.995),(61.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.995),(62.255,5.165),(62.425,5.165),(62.425,4.995),(62.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.355),(61.175,5.525),(61.345,5.525),(61.345,5.355),(61.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.355),(61.535,5.525),(61.705,5.525),(61.705,5.355),(61.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.355),(61.895,5.525),(62.065,5.525),(62.065,5.355),(61.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.355),(62.255,5.525),(62.425,5.525),(62.425,5.355),(62.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.715),(61.175,5.885),(61.345,5.885),(61.345,5.715),(61.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.715),(61.535,5.885),(61.705,5.885),(61.705,5.715),(61.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.715),(61.895,5.885),(62.065,5.885),(62.065,5.715),(61.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.715),(62.255,5.885),(62.425,5.885),(62.425,5.715),(62.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.075),(61.175,6.245),(61.345,6.245),(61.345,6.075),(61.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.075),(61.535,6.245),(61.705,6.245),(61.705,6.075),(61.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.075),(61.895,6.245),(62.065,6.245),(62.065,6.075),(61.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.075),(62.255,6.245),(62.425,6.245),(62.425,6.075),(62.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.435),(61.175,6.605),(61.345,6.605),(61.345,6.435),(61.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.435),(61.535,6.605),(61.705,6.605),(61.705,6.435),(61.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.435),(61.895,6.605),(62.065,6.605),(62.065,6.435),(61.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.435),(62.255,6.605),(62.425,6.605),(62.425,6.435),(62.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.795),(61.175,6.965),(61.345,6.965),(61.345,6.795),(61.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.795),(61.535,6.965),(61.705,6.965),(61.705,6.795),(61.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.795),(61.895,6.965),(62.065,6.965),(62.065,6.795),(61.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.795),(62.255,6.965),(62.425,6.965),(62.425,6.795),(62.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.155),(61.175,7.325),(61.345,7.325),(61.345,7.155),(61.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.155),(61.535,7.325),(61.705,7.325),(61.705,7.155),(61.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.155),(61.895,7.325),(62.065,7.325),(62.065,7.155),(61.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.155),(62.255,7.325),(62.425,7.325),(62.425,7.155),(62.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.515),(61.175,7.685),(61.345,7.685),(61.345,7.515),(61.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.515),(61.535,7.685),(61.705,7.685),(61.705,7.515),(61.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.515),(61.895,7.685),(62.065,7.685),(62.065,7.515),(61.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.515),(62.255,7.685),(62.425,7.685),(62.425,7.515),(62.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.875),(61.175,8.045),(61.345,8.045),(61.345,7.875),(61.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.875),(61.535,8.045),(61.705,8.045),(61.705,7.875),(61.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.875),(61.895,8.045),(62.065,8.045),(62.065,7.875),(61.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.875),(62.255,8.045),(62.425,8.045),(62.425,7.875),(62.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.235),(61.175,8.405),(61.345,8.405),(61.345,8.235),(61.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.235),(61.535,8.405),(61.705,8.405),(61.705,8.235),(61.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.235),(61.895,8.405),(62.065,8.405),(62.065,8.235),(61.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.235),(62.255,8.405),(62.425,8.405),(62.425,8.235),(62.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.595),(61.175,8.765),(61.345,8.765),(61.345,8.595),(61.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.595),(61.535,8.765),(61.705,8.765),(61.705,8.595),(61.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.595),(61.895,8.765),(62.065,8.765),(62.065,8.595),(61.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.595),(62.255,8.765),(62.425,8.765),(62.425,8.595),(62.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.955),(61.175,9.125),(61.345,9.125),(61.345,8.955),(61.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.955),(61.535,9.125),(61.705,9.125),(61.705,8.955),(61.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.955),(61.895,9.125),(62.065,9.125),(62.065,8.955),(61.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.955),(62.255,9.125),(62.425,9.125),(62.425,8.955),(62.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.315),(61.175,9.485),(61.345,9.485),(61.345,9.315),(61.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.315),(61.535,9.485),(61.705,9.485),(61.705,9.315),(61.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.315),(61.895,9.485),(62.065,9.485),(62.065,9.315),(61.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.315),(62.255,9.485),(62.425,9.485),(62.425,9.315),(62.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.675),(61.175,9.845),(61.345,9.845),(61.345,9.675),(61.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.675),(61.535,9.845),(61.705,9.845),(61.705,9.675),(61.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.675),(61.895,9.845),(62.065,9.845),(62.065,9.675),(61.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.675),(62.255,9.845),(62.425,9.845),(62.425,9.675),(62.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.035),(61.175,10.205),(61.345,10.205),(61.345,10.035),(61.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.035),(61.535,10.205),(61.705,10.205),(61.705,10.035),(61.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.035),(61.895,10.205),(62.065,10.205),(62.065,10.035),(61.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.035),(62.255,10.205),(62.425,10.205),(62.425,10.035),(62.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.395),(61.175,10.565),(61.345,10.565),(61.345,10.395),(61.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.395),(61.535,10.565),(61.705,10.565),(61.705,10.395),(61.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.395),(61.895,10.565),(62.065,10.565),(62.065,10.395),(61.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.395),(62.255,10.565),(62.425,10.565),(62.425,10.395),(62.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.755),(61.175,10.925),(61.345,10.925),(61.345,10.755),(61.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.755),(61.535,10.925),(61.705,10.925),(61.705,10.755),(61.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.755),(61.895,10.925),(62.065,10.925),(62.065,10.755),(61.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.755),(62.255,10.925),(62.425,10.925),(62.425,10.755),(62.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.115),(61.175,11.285),(61.345,11.285),(61.345,11.115),(61.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.115),(61.535,11.285),(61.705,11.285),(61.705,11.115),(61.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.115),(61.895,11.285),(62.065,11.285),(62.065,11.115),(61.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.115),(62.255,11.285),(62.425,11.285),(62.425,11.115),(62.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.475),(61.175,11.645),(61.345,11.645),(61.345,11.475),(61.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.475),(61.535,11.645),(61.705,11.645),(61.705,11.475),(61.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.475),(61.895,11.645),(62.065,11.645),(62.065,11.475),(61.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.475),(62.255,11.645),(62.425,11.645),(62.425,11.475),(62.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.835),(61.175,12.005),(61.345,12.005),(61.345,11.835),(61.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.835),(61.535,12.005),(61.705,12.005),(61.705,11.835),(61.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.835),(61.895,12.005),(62.065,12.005),(62.065,11.835),(61.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.835),(62.255,12.005),(62.425,12.005),(62.425,11.835),(62.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.195),(61.175,12.365),(61.345,12.365),(61.345,12.195),(61.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.195),(61.535,12.365),(61.705,12.365),(61.705,12.195),(61.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.195),(61.895,12.365),(62.065,12.365),(62.065,12.195),(61.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.195),(62.255,12.365),(62.425,12.365),(62.425,12.195),(62.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.555),(61.175,12.725),(61.345,12.725),(61.345,12.555),(61.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.555),(61.535,12.725),(61.705,12.725),(61.705,12.555),(61.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.555),(61.895,12.725),(62.065,12.725),(62.065,12.555),(61.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.555),(62.255,12.725),(62.425,12.725),(62.425,12.555),(62.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.915),(61.175,13.085),(61.345,13.085),(61.345,12.915),(61.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.915),(61.535,13.085),(61.705,13.085),(61.705,12.915),(61.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.915),(61.895,13.085),(62.065,13.085),(62.065,12.915),(61.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.915),(62.255,13.085),(62.425,13.085),(62.425,12.915),(62.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.275),(61.175,13.445),(61.345,13.445),(61.345,13.275),(61.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.275),(61.535,13.445),(61.705,13.445),(61.705,13.275),(61.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.275),(61.895,13.445),(62.065,13.445),(62.065,13.275),(61.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.275),(62.255,13.445),(62.425,13.445),(62.425,13.275),(62.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.635),(61.175,13.805),(61.345,13.805),(61.345,13.635),(61.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.635),(61.535,13.805),(61.705,13.805),(61.705,13.635),(61.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.635),(61.895,13.805),(62.065,13.805),(62.065,13.635),(61.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.635),(62.255,13.805),(62.425,13.805),(62.425,13.635),(62.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.995),(61.175,14.165),(61.345,14.165),(61.345,13.995),(61.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.995),(61.535,14.165),(61.705,14.165),(61.705,13.995),(61.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.995),(61.895,14.165),(62.065,14.165),(62.065,13.995),(61.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.995),(62.255,14.165),(62.425,14.165),(62.425,13.995),(62.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.355),(61.175,14.525),(61.345,14.525),(61.345,14.355),(61.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.355),(61.535,14.525),(61.705,14.525),(61.705,14.355),(61.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.355),(61.895,14.525),(62.065,14.525),(62.065,14.355),(61.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.355),(62.255,14.525),(62.425,14.525),(62.425,14.355),(62.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.715),(61.175,14.885),(61.345,14.885),(61.345,14.715),(61.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.715),(61.535,14.885),(61.705,14.885),(61.705,14.715),(61.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.715),(61.895,14.885),(62.065,14.885),(62.065,14.715),(61.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.715),(62.255,14.885),(62.425,14.885),(62.425,14.715),(62.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.075),(61.175,15.245),(61.345,15.245),(61.345,15.075),(61.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.075),(61.535,15.245),(61.705,15.245),(61.705,15.075),(61.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.075),(61.895,15.245),(62.065,15.245),(62.065,15.075),(61.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.075),(62.255,15.245),(62.425,15.245),(62.425,15.075),(62.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.435),(61.175,15.605),(61.345,15.605),(61.345,15.435),(61.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.435),(61.535,15.605),(61.705,15.605),(61.705,15.435),(61.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.435),(61.895,15.605),(62.065,15.605),(62.065,15.435),(61.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.435),(62.255,15.605),(62.425,15.605),(62.425,15.435),(62.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.795),(61.175,15.965),(61.345,15.965),(61.345,15.795),(61.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.795),(61.535,15.965),(61.705,15.965),(61.705,15.795),(61.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.795),(61.895,15.965),(62.065,15.965),(62.065,15.795),(61.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.795),(62.255,15.965),(62.425,15.965),(62.425,15.795),(62.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.155),(61.175,16.325),(61.345,16.325),(61.345,16.155),(61.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.155),(61.535,16.325),(61.705,16.325),(61.705,16.155),(61.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.155),(61.895,16.325),(62.065,16.325),(62.065,16.155),(61.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.155),(62.255,16.325),(62.425,16.325),(62.425,16.155),(62.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.515),(61.175,16.685),(61.345,16.685),(61.345,16.515),(61.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.515),(61.535,16.685),(61.705,16.685),(61.705,16.515),(61.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.515),(61.895,16.685),(62.065,16.685),(62.065,16.515),(61.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.515),(62.255,16.685),(62.425,16.685),(62.425,16.515),(62.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.875),(61.175,17.045),(61.345,17.045),(61.345,16.875),(61.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.875),(61.535,17.045),(61.705,17.045),(61.705,16.875),(61.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.875),(61.895,17.045),(62.065,17.045),(62.065,16.875),(61.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.875),(62.255,17.045),(62.425,17.045),(62.425,16.875),(62.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.235),(61.175,17.405),(61.345,17.405),(61.345,17.235),(61.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.235),(61.535,17.405),(61.705,17.405),(61.705,17.235),(61.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.235),(61.895,17.405),(62.065,17.405),(62.065,17.235),(61.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.235),(62.255,17.405),(62.425,17.405),(62.425,17.235),(62.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.595),(61.175,17.765),(61.345,17.765),(61.345,17.595),(61.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.595),(61.535,17.765),(61.705,17.765),(61.705,17.595),(61.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.595),(61.895,17.765),(62.065,17.765),(62.065,17.595),(61.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.595),(62.255,17.765),(62.425,17.765),(62.425,17.595),(62.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.955),(61.175,18.125),(61.345,18.125),(61.345,17.955),(61.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.955),(61.535,18.125),(61.705,18.125),(61.705,17.955),(61.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.955),(61.895,18.125),(62.065,18.125),(62.065,17.955),(61.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.955),(62.255,18.125),(62.425,18.125),(62.425,17.955),(62.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.315),(61.175,18.485),(61.345,18.485),(61.345,18.315),(61.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.315),(61.535,18.485),(61.705,18.485),(61.705,18.315),(61.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.315),(61.895,18.485),(62.065,18.485),(62.065,18.315),(61.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.315),(62.255,18.485),(62.425,18.485),(62.425,18.315),(62.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.675),(61.175,18.845),(61.345,18.845),(61.345,18.675),(61.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.675),(61.535,18.845),(61.705,18.845),(61.705,18.675),(61.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.675),(61.895,18.845),(62.065,18.845),(62.065,18.675),(61.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.675),(62.255,18.845),(62.425,18.845),(62.425,18.675),(62.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.035),(61.175,19.205),(61.345,19.205),(61.345,19.035),(61.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.035),(61.535,19.205),(61.705,19.205),(61.705,19.035),(61.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.035),(61.895,19.205),(62.065,19.205),(62.065,19.035),(61.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.035),(62.255,19.205),(62.425,19.205),(62.425,19.035),(62.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.395),(61.175,19.565),(61.345,19.565),(61.345,19.395),(61.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.395),(61.535,19.565),(61.705,19.565),(61.705,19.395),(61.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.395),(61.895,19.565),(62.065,19.565),(62.065,19.395),(61.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.395),(62.255,19.565),(62.425,19.565),(62.425,19.395),(62.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.755),(61.175,19.925),(61.345,19.925),(61.345,19.755),(61.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.755),(61.535,19.925),(61.705,19.925),(61.705,19.755),(61.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.755),(61.895,19.925),(62.065,19.925),(62.065,19.755),(61.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.755),(62.255,19.925),(62.425,19.925),(62.425,19.755),(62.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,20.115),(61.175,20.285),(61.345,20.285),(61.345,20.115),(61.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,20.115),(61.535,20.285),(61.705,20.285),(61.705,20.115),(61.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,20.115),(61.895,20.285),(62.065,20.285),(62.065,20.115),(61.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,20.115),(62.255,20.285),(62.425,20.285),(62.425,20.115),(62.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,20.475),(61.175,20.645),(61.345,20.645),(61.345,20.475),(61.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,20.475),(61.535,20.645),(61.705,20.645),(61.705,20.475),(61.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,20.475),(61.895,20.645),(62.065,20.645),(62.065,20.475),(61.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,20.475),(62.255,20.645),(62.425,20.645),(62.425,20.475),(62.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,20.835),(61.175,21.005),(61.345,21.005),(61.345,20.835),(61.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,20.835),(61.535,21.005),(61.705,21.005),(61.705,20.835),(61.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,20.835),(61.895,21.005),(62.065,21.005),(62.065,20.835),(61.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,20.835),(62.255,21.005),(62.425,21.005),(62.425,20.835),(62.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,21.195),(61.175,21.365),(61.345,21.365),(61.345,21.195),(61.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,21.195),(61.535,21.365),(61.705,21.365),(61.705,21.195),(61.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,21.195),(61.895,21.365),(62.065,21.365),(62.065,21.195),(61.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,21.195),(62.255,21.365),(62.425,21.365),(62.425,21.195),(62.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,21.555),(61.175,21.725),(61.345,21.725),(61.345,21.555),(61.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,21.555),(61.535,21.725),(61.705,21.725),(61.705,21.555),(61.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,21.555),(61.895,21.725),(62.065,21.725),(62.065,21.555),(61.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,21.555),(62.255,21.725),(62.425,21.725),(62.425,21.555),(62.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,21.915),(61.175,22.085),(61.345,22.085),(61.345,21.915),(61.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,21.915),(61.535,22.085),(61.705,22.085),(61.705,21.915),(61.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,21.915),(61.895,22.085),(62.065,22.085),(62.065,21.915),(61.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,21.915),(62.255,22.085),(62.425,22.085),(62.425,21.915),(62.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.275),(61.175,22.445),(61.345,22.445),(61.345,22.275),(61.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.275),(61.535,22.445),(61.705,22.445),(61.705,22.275),(61.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.275),(61.895,22.445),(62.065,22.445),(62.065,22.275),(61.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.275),(62.255,22.445),(62.425,22.445),(62.425,22.275),(62.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.635),(61.175,22.805),(61.345,22.805),(61.345,22.635),(61.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.635),(61.535,22.805),(61.705,22.805),(61.705,22.635),(61.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.635),(61.895,22.805),(62.065,22.805),(62.065,22.635),(61.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.635),(62.255,22.805),(62.425,22.805),(62.425,22.635),(62.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.995),(61.175,23.165),(61.345,23.165),(61.345,22.995),(61.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.995),(61.535,23.165),(61.705,23.165),(61.705,22.995),(61.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.995),(61.895,23.165),(62.065,23.165),(62.065,22.995),(61.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.995),(62.255,23.165),(62.425,23.165),(62.425,22.995),(62.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,23.355),(61.175,23.525),(61.345,23.525),(61.345,23.355),(61.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,23.355),(61.535,23.525),(61.705,23.525),(61.705,23.355),(61.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,23.355),(61.895,23.525),(62.065,23.525),(62.065,23.355),(61.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,23.355),(62.255,23.525),(62.425,23.525),(62.425,23.355),(62.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,23.715),(61.175,23.885),(61.345,23.885),(61.345,23.715),(61.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,23.715),(61.535,23.885),(61.705,23.885),(61.705,23.715),(61.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,23.715),(61.895,23.885),(62.065,23.885),(62.065,23.715),(61.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,23.715),(62.255,23.885),(62.425,23.885),(62.425,23.715),(62.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,24.075),(61.175,24.245),(61.345,24.245),(61.345,24.075),(61.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,24.075),(61.535,24.245),(61.705,24.245),(61.705,24.075),(61.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,24.075),(61.895,24.245),(62.065,24.245),(62.065,24.075),(61.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,24.075),(62.255,24.245),(62.425,24.245),(62.425,24.075),(62.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,24.435),(61.175,24.605),(61.345,24.605),(61.345,24.435),(61.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,24.435),(61.535,24.605),(61.705,24.605),(61.705,24.435),(61.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,24.435),(61.895,24.605),(62.065,24.605),(62.065,24.435),(61.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,24.435),(62.255,24.605),(62.425,24.605),(62.425,24.435),(62.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,24.795),(61.175,24.965),(61.345,24.965),(61.345,24.795),(61.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,24.795),(61.535,24.965),(61.705,24.965),(61.705,24.795),(61.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,24.795),(61.895,24.965),(62.065,24.965),(62.065,24.795),(61.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,24.795),(62.255,24.965),(62.425,24.965),(62.425,24.795),(62.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,25.155),(61.175,25.325),(61.345,25.325),(61.345,25.155),(61.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,25.155),(61.535,25.325),(61.705,25.325),(61.705,25.155),(61.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,25.155),(61.895,25.325),(62.065,25.325),(62.065,25.155),(61.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,25.155),(62.255,25.325),(62.425,25.325),(62.425,25.155),(62.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,25.515),(61.175,25.685),(61.345,25.685),(61.345,25.515),(61.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,25.515),(61.535,25.685),(61.705,25.685),(61.705,25.515),(61.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,25.515),(61.895,25.685),(62.065,25.685),(62.065,25.515),(61.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,25.515),(62.255,25.685),(62.425,25.685),(62.425,25.515),(62.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,25.875),(61.175,26.045),(61.345,26.045),(61.345,25.875),(61.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,25.875),(61.535,26.045),(61.705,26.045),(61.705,25.875),(61.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,25.875),(61.895,26.045),(62.065,26.045),(62.065,25.875),(61.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,25.875),(62.255,26.045),(62.425,26.045),(62.425,25.875),(62.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,26.235),(61.175,26.405),(61.345,26.405),(61.345,26.235),(61.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,26.235),(61.535,26.405),(61.705,26.405),(61.705,26.235),(61.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,26.235),(61.895,26.405),(62.065,26.405),(62.065,26.235),(61.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,26.235),(62.255,26.405),(62.425,26.405),(62.425,26.235),(62.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,26.595),(61.175,26.765),(61.345,26.765),(61.345,26.595),(61.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,26.595),(61.535,26.765),(61.705,26.765),(61.705,26.595),(61.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,26.595),(61.895,26.765),(62.065,26.765),(62.065,26.595),(61.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,26.595),(62.255,26.765),(62.425,26.765),(62.425,26.595),(62.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,26.955),(61.175,27.125),(61.345,27.125),(61.345,26.955),(61.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,26.955),(61.535,27.125),(61.705,27.125),(61.705,26.955),(61.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,26.955),(61.895,27.125),(62.065,27.125),(62.065,26.955),(61.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,26.955),(62.255,27.125),(62.425,27.125),(62.425,26.955),(62.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,27.315),(61.175,27.485),(61.345,27.485),(61.345,27.315),(61.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,27.315),(61.535,27.485),(61.705,27.485),(61.705,27.315),(61.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,27.315),(61.895,27.485),(62.065,27.485),(62.065,27.315),(61.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,27.315),(62.255,27.485),(62.425,27.485),(62.425,27.315),(62.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,27.675),(61.175,27.845),(61.345,27.845),(61.345,27.675),(61.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,27.675),(61.535,27.845),(61.705,27.845),(61.705,27.675),(61.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,27.675),(61.895,27.845),(62.065,27.845),(62.065,27.675),(61.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,27.675),(62.255,27.845),(62.425,27.845),(62.425,27.675),(62.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,28.035),(61.175,28.205),(61.345,28.205),(61.345,28.035),(61.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,28.035),(61.535,28.205),(61.705,28.205),(61.705,28.035),(61.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,28.035),(61.895,28.205),(62.065,28.205),(62.065,28.035),(61.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,28.035),(62.255,28.205),(62.425,28.205),(62.425,28.035),(62.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,28.395),(61.175,28.565),(61.345,28.565),(61.345,28.395),(61.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,28.395),(61.535,28.565),(61.705,28.565),(61.705,28.395),(61.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,28.395),(61.895,28.565),(62.065,28.565),(62.065,28.395),(61.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,28.395),(62.255,28.565),(62.425,28.565),(62.425,28.395),(62.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,28.755),(61.175,28.925),(61.345,28.925),(61.345,28.755),(61.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,28.755),(61.535,28.925),(61.705,28.925),(61.705,28.755),(61.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,28.755),(61.895,28.925),(62.065,28.925),(62.065,28.755),(61.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,28.755),(62.255,28.925),(62.425,28.925),(62.425,28.755),(62.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,29.115),(61.175,29.285),(61.345,29.285),(61.345,29.115),(61.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,29.115),(61.535,29.285),(61.705,29.285),(61.705,29.115),(61.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,29.115),(61.895,29.285),(62.065,29.285),(62.065,29.115),(61.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,29.115),(62.255,29.285),(62.425,29.285),(62.425,29.115),(62.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,29.475),(61.175,29.645),(61.345,29.645),(61.345,29.475),(61.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,29.475),(61.535,29.645),(61.705,29.645),(61.705,29.475),(61.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,29.475),(61.895,29.645),(62.065,29.645),(62.065,29.475),(61.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,29.475),(62.255,29.645),(62.425,29.645),(62.425,29.475),(62.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,29.835),(61.175,30.005),(61.345,30.005),(61.345,29.835),(61.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,29.835),(61.535,30.005),(61.705,30.005),(61.705,29.835),(61.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,29.835),(61.895,30.005),(62.065,30.005),(62.065,29.835),(61.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,29.835),(62.255,30.005),(62.425,30.005),(62.425,29.835),(62.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,30.195),(61.175,30.365),(61.345,30.365),(61.345,30.195),(61.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,30.195),(61.535,30.365),(61.705,30.365),(61.705,30.195),(61.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,30.195),(61.895,30.365),(62.065,30.365),(62.065,30.195),(61.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,30.195),(62.255,30.365),(62.425,30.365),(62.425,30.195),(62.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,30.555),(61.175,30.725),(61.345,30.725),(61.345,30.555),(61.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,30.555),(61.535,30.725),(61.705,30.725),(61.705,30.555),(61.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,30.555),(61.895,30.725),(62.065,30.725),(62.065,30.555),(61.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,30.555),(62.255,30.725),(62.425,30.725),(62.425,30.555),(62.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,30.915),(61.175,31.085),(61.345,31.085),(61.345,30.915),(61.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,30.915),(61.535,31.085),(61.705,31.085),(61.705,30.915),(61.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,30.915),(61.895,31.085),(62.065,31.085),(62.065,30.915),(61.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,30.915),(62.255,31.085),(62.425,31.085),(62.425,30.915),(62.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,31.275),(61.175,31.445),(61.345,31.445),(61.345,31.275),(61.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,31.275),(61.535,31.445),(61.705,31.445),(61.705,31.275),(61.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,31.275),(61.895,31.445),(62.065,31.445),(62.065,31.275),(61.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,31.275),(62.255,31.445),(62.425,31.445),(62.425,31.275),(62.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,31.635),(61.175,31.805),(61.345,31.805),(61.345,31.635),(61.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,31.635),(61.535,31.805),(61.705,31.805),(61.705,31.635),(61.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,31.635),(61.895,31.805),(62.065,31.805),(62.065,31.635),(61.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,31.635),(62.255,31.805),(62.425,31.805),(62.425,31.635),(62.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,31.995),(61.175,32.165),(61.345,32.165),(61.345,31.995),(61.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,31.995),(61.535,32.165),(61.705,32.165),(61.705,31.995),(61.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,31.995),(61.895,32.165),(62.065,32.165),(62.065,31.995),(61.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,31.995),(62.255,32.165),(62.425,32.165),(62.425,31.995),(62.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,32.355),(61.175,32.525),(61.345,32.525),(61.345,32.355),(61.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,32.355),(61.535,32.525),(61.705,32.525),(61.705,32.355),(61.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,32.355),(61.895,32.525),(62.065,32.525),(62.065,32.355),(61.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,32.355),(62.255,32.525),(62.425,32.525),(62.425,32.355),(62.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,32.715),(61.175,32.885),(61.345,32.885),(61.345,32.715),(61.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,32.715),(61.535,32.885),(61.705,32.885),(61.705,32.715),(61.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,32.715),(61.895,32.885),(62.065,32.885),(62.065,32.715),(61.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,32.715),(62.255,32.885),(62.425,32.885),(62.425,32.715),(62.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,33.075),(61.175,33.245),(61.345,33.245),(61.345,33.075),(61.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,33.075),(61.535,33.245),(61.705,33.245),(61.705,33.075),(61.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,33.075),(61.895,33.245),(62.065,33.245),(62.065,33.075),(61.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,33.075),(62.255,33.245),(62.425,33.245),(62.425,33.075),(62.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,33.435),(61.175,33.605),(61.345,33.605),(61.345,33.435),(61.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,33.435),(61.535,33.605),(61.705,33.605),(61.705,33.435),(61.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,33.435),(61.895,33.605),(62.065,33.605),(62.065,33.435),(61.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,33.435),(62.255,33.605),(62.425,33.605),(62.425,33.435),(62.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,33.795),(61.175,33.965),(61.345,33.965),(61.345,33.795),(61.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,33.795),(61.535,33.965),(61.705,33.965),(61.705,33.795),(61.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,33.795),(61.895,33.965),(62.065,33.965),(62.065,33.795),(61.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,33.795),(62.255,33.965),(62.425,33.965),(62.425,33.795),(62.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,34.155),(61.175,34.325),(61.345,34.325),(61.345,34.155),(61.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,34.155),(61.535,34.325),(61.705,34.325),(61.705,34.155),(61.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,34.155),(61.895,34.325),(62.065,34.325),(62.065,34.155),(61.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,34.155),(62.255,34.325),(62.425,34.325),(62.425,34.155),(62.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,34.515),(61.175,34.685),(61.345,34.685),(61.345,34.515),(61.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,34.515),(61.535,34.685),(61.705,34.685),(61.705,34.515),(61.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,34.515),(61.895,34.685),(62.065,34.685),(62.065,34.515),(61.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,34.515),(62.255,34.685),(62.425,34.685),(62.425,34.515),(62.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,34.875),(61.175,35.045),(61.345,35.045),(61.345,34.875),(61.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,34.875),(61.535,35.045),(61.705,35.045),(61.705,34.875),(61.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,34.875),(61.895,35.045),(62.065,35.045),(62.065,34.875),(61.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,34.875),(62.255,35.045),(62.425,35.045),(62.425,34.875),(62.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,35.235),(61.175,35.405),(61.345,35.405),(61.345,35.235),(61.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,35.235),(61.535,35.405),(61.705,35.405),(61.705,35.235),(61.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,35.235),(61.895,35.405),(62.065,35.405),(62.065,35.235),(61.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,35.235),(62.255,35.405),(62.425,35.405),(62.425,35.235),(62.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,35.595),(61.175,35.765),(61.345,35.765),(61.345,35.595),(61.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,35.595),(61.535,35.765),(61.705,35.765),(61.705,35.595),(61.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,35.595),(61.895,35.765),(62.065,35.765),(62.065,35.595),(61.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,35.595),(62.255,35.765),(62.425,35.765),(62.425,35.595),(62.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,35.955),(61.175,36.125),(61.345,36.125),(61.345,35.955),(61.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,35.955),(61.535,36.125),(61.705,36.125),(61.705,35.955),(61.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,35.955),(61.895,36.125),(62.065,36.125),(62.065,35.955),(61.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,35.955),(62.255,36.125),(62.425,36.125),(62.425,35.955),(62.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,36.315),(61.175,36.485),(61.345,36.485),(61.345,36.315),(61.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,36.315),(61.535,36.485),(61.705,36.485),(61.705,36.315),(61.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,36.315),(61.895,36.485),(62.065,36.485),(62.065,36.315),(61.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,36.315),(62.255,36.485),(62.425,36.485),(62.425,36.315),(62.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,36.675),(61.175,36.845),(61.345,36.845),(61.345,36.675),(61.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,36.675),(61.535,36.845),(61.705,36.845),(61.705,36.675),(61.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,36.675),(61.895,36.845),(62.065,36.845),(62.065,36.675),(61.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,36.675),(62.255,36.845),(62.425,36.845),(62.425,36.675),(62.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,37.035),(61.175,37.205),(61.345,37.205),(61.345,37.035),(61.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,37.035),(61.535,37.205),(61.705,37.205),(61.705,37.035),(61.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,37.035),(61.895,37.205),(62.065,37.205),(62.065,37.035),(61.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,37.035),(62.255,37.205),(62.425,37.205),(62.425,37.035),(62.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,37.395),(61.175,37.565),(61.345,37.565),(61.345,37.395),(61.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,37.395),(61.535,37.565),(61.705,37.565),(61.705,37.395),(61.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,37.395),(61.895,37.565),(62.065,37.565),(62.065,37.395),(61.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,37.395),(62.255,37.565),(62.425,37.565),(62.425,37.395),(62.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,37.755),(61.175,37.925),(61.345,37.925),(61.345,37.755),(61.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,37.755),(61.535,37.925),(61.705,37.925),(61.705,37.755),(61.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,37.755),(61.895,37.925),(62.065,37.925),(62.065,37.755),(61.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,37.755),(62.255,37.925),(62.425,37.925),(62.425,37.755),(62.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,38.115),(61.175,38.285),(61.345,38.285),(61.345,38.115),(61.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,38.115),(61.535,38.285),(61.705,38.285),(61.705,38.115),(61.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,38.115),(61.895,38.285),(62.065,38.285),(62.065,38.115),(61.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,38.115),(62.255,38.285),(62.425,38.285),(62.425,38.115),(62.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,38.475),(61.175,38.645),(61.345,38.645),(61.345,38.475),(61.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,38.475),(61.535,38.645),(61.705,38.645),(61.705,38.475),(61.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,38.475),(61.895,38.645),(62.065,38.645),(62.065,38.475),(61.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,38.475),(62.255,38.645),(62.425,38.645),(62.425,38.475),(62.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,38.835),(61.175,39.005),(61.345,39.005),(61.345,38.835),(61.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,38.835),(61.535,39.005),(61.705,39.005),(61.705,38.835),(61.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,38.835),(61.895,39.005),(62.065,39.005),(62.065,38.835),(61.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,38.835),(62.255,39.005),(62.425,39.005),(62.425,38.835),(62.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,39.195),(61.175,39.365),(61.345,39.365),(61.345,39.195),(61.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,39.195),(61.535,39.365),(61.705,39.365),(61.705,39.195),(61.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,39.195),(61.895,39.365),(62.065,39.365),(62.065,39.195),(61.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,39.195),(62.255,39.365),(62.425,39.365),(62.425,39.195),(62.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,39.555),(61.175,39.725),(61.345,39.725),(61.345,39.555),(61.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,39.555),(61.535,39.725),(61.705,39.725),(61.705,39.555),(61.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,39.555),(61.895,39.725),(62.065,39.725),(62.065,39.555),(61.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,39.555),(62.255,39.725),(62.425,39.725),(62.425,39.555),(62.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,39.915),(61.175,40.085),(61.345,40.085),(61.345,39.915),(61.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,39.915),(61.535,40.085),(61.705,40.085),(61.705,39.915),(61.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,39.915),(61.895,40.085),(62.065,40.085),(62.065,39.915),(61.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,39.915),(62.255,40.085),(62.425,40.085),(62.425,39.915),(62.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,40.275),(61.175,40.445),(61.345,40.445),(61.345,40.275),(61.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,40.275),(61.535,40.445),(61.705,40.445),(61.705,40.275),(61.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,40.275),(61.895,40.445),(62.065,40.445),(62.065,40.275),(61.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,40.275),(62.255,40.445),(62.425,40.445),(62.425,40.275),(62.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,40.635),(61.175,40.805),(61.345,40.805),(61.345,40.635),(61.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,40.635),(61.535,40.805),(61.705,40.805),(61.705,40.635),(61.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,40.635),(61.895,40.805),(62.065,40.805),(62.065,40.635),(61.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,40.635),(62.255,40.805),(62.425,40.805),(62.425,40.635),(62.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.835),(56.375,3.005),(56.545,3.005),(56.545,2.835),(56.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.835),(56.735,3.005),(56.905,3.005),(56.905,2.835),(56.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.835),(57.095,3.005),(57.265,3.005),(57.265,2.835),(57.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.835),(57.455,3.005),(57.625,3.005),(57.625,2.835),(57.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.195),(56.375,3.365),(56.545,3.365),(56.545,3.195),(56.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.195),(56.735,3.365),(56.905,3.365),(56.905,3.195),(56.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.195),(57.095,3.365),(57.265,3.365),(57.265,3.195),(57.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.195),(57.455,3.365),(57.625,3.365),(57.625,3.195),(57.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.555),(56.375,3.725),(56.545,3.725),(56.545,3.555),(56.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.555),(56.735,3.725),(56.905,3.725),(56.905,3.555),(56.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.555),(57.095,3.725),(57.265,3.725),(57.265,3.555),(57.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.555),(57.455,3.725),(57.625,3.725),(57.625,3.555),(57.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.915),(56.375,4.085),(56.545,4.085),(56.545,3.915),(56.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.915),(56.735,4.085),(56.905,4.085),(56.905,3.915),(56.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.915),(57.095,4.085),(57.265,4.085),(57.265,3.915),(57.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.915),(57.455,4.085),(57.625,4.085),(57.625,3.915),(57.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.275),(56.375,4.445),(56.545,4.445),(56.545,4.275),(56.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.275),(56.735,4.445),(56.905,4.445),(56.905,4.275),(56.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.275),(57.095,4.445),(57.265,4.445),(57.265,4.275),(57.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.275),(57.455,4.445),(57.625,4.445),(57.625,4.275),(57.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.635),(56.375,4.805),(56.545,4.805),(56.545,4.635),(56.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.635),(56.735,4.805),(56.905,4.805),(56.905,4.635),(56.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.635),(57.095,4.805),(57.265,4.805),(57.265,4.635),(57.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.635),(57.455,4.805),(57.625,4.805),(57.625,4.635),(57.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.995),(56.375,5.165),(56.545,5.165),(56.545,4.995),(56.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.995),(56.735,5.165),(56.905,5.165),(56.905,4.995),(56.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.995),(57.095,5.165),(57.265,5.165),(57.265,4.995),(57.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.995),(57.455,5.165),(57.625,5.165),(57.625,4.995),(57.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.355),(56.375,5.525),(56.545,5.525),(56.545,5.355),(56.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.355),(56.735,5.525),(56.905,5.525),(56.905,5.355),(56.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.355),(57.095,5.525),(57.265,5.525),(57.265,5.355),(57.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.355),(57.455,5.525),(57.625,5.525),(57.625,5.355),(57.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.715),(56.375,5.885),(56.545,5.885),(56.545,5.715),(56.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.715),(56.735,5.885),(56.905,5.885),(56.905,5.715),(56.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.715),(57.095,5.885),(57.265,5.885),(57.265,5.715),(57.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.715),(57.455,5.885),(57.625,5.885),(57.625,5.715),(57.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.075),(56.375,6.245),(56.545,6.245),(56.545,6.075),(56.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.075),(56.735,6.245),(56.905,6.245),(56.905,6.075),(56.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.075),(57.095,6.245),(57.265,6.245),(57.265,6.075),(57.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.075),(57.455,6.245),(57.625,6.245),(57.625,6.075),(57.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.435),(56.375,6.605),(56.545,6.605),(56.545,6.435),(56.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.435),(56.735,6.605),(56.905,6.605),(56.905,6.435),(56.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.435),(57.095,6.605),(57.265,6.605),(57.265,6.435),(57.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.435),(57.455,6.605),(57.625,6.605),(57.625,6.435),(57.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.795),(56.375,6.965),(56.545,6.965),(56.545,6.795),(56.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.795),(56.735,6.965),(56.905,6.965),(56.905,6.795),(56.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.795),(57.095,6.965),(57.265,6.965),(57.265,6.795),(57.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.795),(57.455,6.965),(57.625,6.965),(57.625,6.795),(57.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.155),(56.375,7.325),(56.545,7.325),(56.545,7.155),(56.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.155),(56.735,7.325),(56.905,7.325),(56.905,7.155),(56.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.155),(57.095,7.325),(57.265,7.325),(57.265,7.155),(57.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.155),(57.455,7.325),(57.625,7.325),(57.625,7.155),(57.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.515),(56.375,7.685),(56.545,7.685),(56.545,7.515),(56.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.515),(56.735,7.685),(56.905,7.685),(56.905,7.515),(56.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.515),(57.095,7.685),(57.265,7.685),(57.265,7.515),(57.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.515),(57.455,7.685),(57.625,7.685),(57.625,7.515),(57.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.875),(56.375,8.045),(56.545,8.045),(56.545,7.875),(56.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.875),(56.735,8.045),(56.905,8.045),(56.905,7.875),(56.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.875),(57.095,8.045),(57.265,8.045),(57.265,7.875),(57.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.875),(57.455,8.045),(57.625,8.045),(57.625,7.875),(57.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.235),(56.375,8.405),(56.545,8.405),(56.545,8.235),(56.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.235),(56.735,8.405),(56.905,8.405),(56.905,8.235),(56.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.235),(57.095,8.405),(57.265,8.405),(57.265,8.235),(57.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.235),(57.455,8.405),(57.625,8.405),(57.625,8.235),(57.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.595),(56.375,8.765),(56.545,8.765),(56.545,8.595),(56.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.595),(56.735,8.765),(56.905,8.765),(56.905,8.595),(56.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.595),(57.095,8.765),(57.265,8.765),(57.265,8.595),(57.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.595),(57.455,8.765),(57.625,8.765),(57.625,8.595),(57.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.955),(56.375,9.125),(56.545,9.125),(56.545,8.955),(56.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.955),(56.735,9.125),(56.905,9.125),(56.905,8.955),(56.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.955),(57.095,9.125),(57.265,9.125),(57.265,8.955),(57.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.955),(57.455,9.125),(57.625,9.125),(57.625,8.955),(57.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.315),(56.375,9.485),(56.545,9.485),(56.545,9.315),(56.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.315),(56.735,9.485),(56.905,9.485),(56.905,9.315),(56.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.315),(57.095,9.485),(57.265,9.485),(57.265,9.315),(57.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.315),(57.455,9.485),(57.625,9.485),(57.625,9.315),(57.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.675),(56.375,9.845),(56.545,9.845),(56.545,9.675),(56.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.675),(56.735,9.845),(56.905,9.845),(56.905,9.675),(56.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.675),(57.095,9.845),(57.265,9.845),(57.265,9.675),(57.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.675),(57.455,9.845),(57.625,9.845),(57.625,9.675),(57.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.035),(56.375,10.205),(56.545,10.205),(56.545,10.035),(56.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.035),(56.735,10.205),(56.905,10.205),(56.905,10.035),(56.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.035),(57.095,10.205),(57.265,10.205),(57.265,10.035),(57.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.035),(57.455,10.205),(57.625,10.205),(57.625,10.035),(57.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.395),(56.375,10.565),(56.545,10.565),(56.545,10.395),(56.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.395),(56.735,10.565),(56.905,10.565),(56.905,10.395),(56.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.395),(57.095,10.565),(57.265,10.565),(57.265,10.395),(57.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.395),(57.455,10.565),(57.625,10.565),(57.625,10.395),(57.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.755),(56.375,10.925),(56.545,10.925),(56.545,10.755),(56.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.755),(56.735,10.925),(56.905,10.925),(56.905,10.755),(56.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.755),(57.095,10.925),(57.265,10.925),(57.265,10.755),(57.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.755),(57.455,10.925),(57.625,10.925),(57.625,10.755),(57.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.115),(56.375,11.285),(56.545,11.285),(56.545,11.115),(56.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.115),(56.735,11.285),(56.905,11.285),(56.905,11.115),(56.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.115),(57.095,11.285),(57.265,11.285),(57.265,11.115),(57.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.115),(57.455,11.285),(57.625,11.285),(57.625,11.115),(57.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.475),(56.375,11.645),(56.545,11.645),(56.545,11.475),(56.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.475),(56.735,11.645),(56.905,11.645),(56.905,11.475),(56.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.475),(57.095,11.645),(57.265,11.645),(57.265,11.475),(57.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.475),(57.455,11.645),(57.625,11.645),(57.625,11.475),(57.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.835),(56.375,12.005),(56.545,12.005),(56.545,11.835),(56.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.835),(56.735,12.005),(56.905,12.005),(56.905,11.835),(56.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.835),(57.095,12.005),(57.265,12.005),(57.265,11.835),(57.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.835),(57.455,12.005),(57.625,12.005),(57.625,11.835),(57.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.195),(56.375,12.365),(56.545,12.365),(56.545,12.195),(56.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.195),(56.735,12.365),(56.905,12.365),(56.905,12.195),(56.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.195),(57.095,12.365),(57.265,12.365),(57.265,12.195),(57.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.195),(57.455,12.365),(57.625,12.365),(57.625,12.195),(57.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.555),(56.375,12.725),(56.545,12.725),(56.545,12.555),(56.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.555),(56.735,12.725),(56.905,12.725),(56.905,12.555),(56.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.555),(57.095,12.725),(57.265,12.725),(57.265,12.555),(57.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.555),(57.455,12.725),(57.625,12.725),(57.625,12.555),(57.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.915),(56.375,13.085),(56.545,13.085),(56.545,12.915),(56.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.915),(56.735,13.085),(56.905,13.085),(56.905,12.915),(56.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.915),(57.095,13.085),(57.265,13.085),(57.265,12.915),(57.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.915),(57.455,13.085),(57.625,13.085),(57.625,12.915),(57.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.275),(56.375,13.445),(56.545,13.445),(56.545,13.275),(56.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.275),(56.735,13.445),(56.905,13.445),(56.905,13.275),(56.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.275),(57.095,13.445),(57.265,13.445),(57.265,13.275),(57.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.275),(57.455,13.445),(57.625,13.445),(57.625,13.275),(57.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.635),(56.375,13.805),(56.545,13.805),(56.545,13.635),(56.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.635),(56.735,13.805),(56.905,13.805),(56.905,13.635),(56.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.635),(57.095,13.805),(57.265,13.805),(57.265,13.635),(57.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.635),(57.455,13.805),(57.625,13.805),(57.625,13.635),(57.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.995),(56.375,14.165),(56.545,14.165),(56.545,13.995),(56.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.995),(56.735,14.165),(56.905,14.165),(56.905,13.995),(56.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.995),(57.095,14.165),(57.265,14.165),(57.265,13.995),(57.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.995),(57.455,14.165),(57.625,14.165),(57.625,13.995),(57.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.355),(56.375,14.525),(56.545,14.525),(56.545,14.355),(56.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.355),(56.735,14.525),(56.905,14.525),(56.905,14.355),(56.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.355),(57.095,14.525),(57.265,14.525),(57.265,14.355),(57.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.355),(57.455,14.525),(57.625,14.525),(57.625,14.355),(57.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.715),(56.375,14.885),(56.545,14.885),(56.545,14.715),(56.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.715),(56.735,14.885),(56.905,14.885),(56.905,14.715),(56.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.715),(57.095,14.885),(57.265,14.885),(57.265,14.715),(57.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.715),(57.455,14.885),(57.625,14.885),(57.625,14.715),(57.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.075),(56.375,15.245),(56.545,15.245),(56.545,15.075),(56.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.075),(56.735,15.245),(56.905,15.245),(56.905,15.075),(56.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.075),(57.095,15.245),(57.265,15.245),(57.265,15.075),(57.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.075),(57.455,15.245),(57.625,15.245),(57.625,15.075),(57.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.435),(56.375,15.605),(56.545,15.605),(56.545,15.435),(56.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.435),(56.735,15.605),(56.905,15.605),(56.905,15.435),(56.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.435),(57.095,15.605),(57.265,15.605),(57.265,15.435),(57.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.435),(57.455,15.605),(57.625,15.605),(57.625,15.435),(57.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.795),(56.375,15.965),(56.545,15.965),(56.545,15.795),(56.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.795),(56.735,15.965),(56.905,15.965),(56.905,15.795),(56.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.795),(57.095,15.965),(57.265,15.965),(57.265,15.795),(57.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.795),(57.455,15.965),(57.625,15.965),(57.625,15.795),(57.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.155),(56.375,16.325),(56.545,16.325),(56.545,16.155),(56.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.155),(56.735,16.325),(56.905,16.325),(56.905,16.155),(56.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.155),(57.095,16.325),(57.265,16.325),(57.265,16.155),(57.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.155),(57.455,16.325),(57.625,16.325),(57.625,16.155),(57.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.515),(56.375,16.685),(56.545,16.685),(56.545,16.515),(56.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.515),(56.735,16.685),(56.905,16.685),(56.905,16.515),(56.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.515),(57.095,16.685),(57.265,16.685),(57.265,16.515),(57.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.515),(57.455,16.685),(57.625,16.685),(57.625,16.515),(57.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.875),(56.375,17.045),(56.545,17.045),(56.545,16.875),(56.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.875),(56.735,17.045),(56.905,17.045),(56.905,16.875),(56.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.875),(57.095,17.045),(57.265,17.045),(57.265,16.875),(57.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.875),(57.455,17.045),(57.625,17.045),(57.625,16.875),(57.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.235),(56.375,17.405),(56.545,17.405),(56.545,17.235),(56.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.235),(56.735,17.405),(56.905,17.405),(56.905,17.235),(56.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.235),(57.095,17.405),(57.265,17.405),(57.265,17.235),(57.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.235),(57.455,17.405),(57.625,17.405),(57.625,17.235),(57.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.595),(56.375,17.765),(56.545,17.765),(56.545,17.595),(56.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.595),(56.735,17.765),(56.905,17.765),(56.905,17.595),(56.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.595),(57.095,17.765),(57.265,17.765),(57.265,17.595),(57.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.595),(57.455,17.765),(57.625,17.765),(57.625,17.595),(57.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.955),(56.375,18.125),(56.545,18.125),(56.545,17.955),(56.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.955),(56.735,18.125),(56.905,18.125),(56.905,17.955),(56.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.955),(57.095,18.125),(57.265,18.125),(57.265,17.955),(57.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.955),(57.455,18.125),(57.625,18.125),(57.625,17.955),(57.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.315),(56.375,18.485),(56.545,18.485),(56.545,18.315),(56.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.315),(56.735,18.485),(56.905,18.485),(56.905,18.315),(56.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.315),(57.095,18.485),(57.265,18.485),(57.265,18.315),(57.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.315),(57.455,18.485),(57.625,18.485),(57.625,18.315),(57.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.675),(56.375,18.845),(56.545,18.845),(56.545,18.675),(56.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.675),(56.735,18.845),(56.905,18.845),(56.905,18.675),(56.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.675),(57.095,18.845),(57.265,18.845),(57.265,18.675),(57.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.675),(57.455,18.845),(57.625,18.845),(57.625,18.675),(57.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.035),(56.375,19.205),(56.545,19.205),(56.545,19.035),(56.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.035),(56.735,19.205),(56.905,19.205),(56.905,19.035),(56.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.035),(57.095,19.205),(57.265,19.205),(57.265,19.035),(57.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.035),(57.455,19.205),(57.625,19.205),(57.625,19.035),(57.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.395),(56.375,19.565),(56.545,19.565),(56.545,19.395),(56.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.395),(56.735,19.565),(56.905,19.565),(56.905,19.395),(56.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.395),(57.095,19.565),(57.265,19.565),(57.265,19.395),(57.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.395),(57.455,19.565),(57.625,19.565),(57.625,19.395),(57.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.755),(56.375,19.925),(56.545,19.925),(56.545,19.755),(56.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.755),(56.735,19.925),(56.905,19.925),(56.905,19.755),(56.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.755),(57.095,19.925),(57.265,19.925),(57.265,19.755),(57.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.755),(57.455,19.925),(57.625,19.925),(57.625,19.755),(57.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.115),(56.375,20.285),(56.545,20.285),(56.545,20.115),(56.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.115),(56.735,20.285),(56.905,20.285),(56.905,20.115),(56.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.115),(57.095,20.285),(57.265,20.285),(57.265,20.115),(57.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.115),(57.455,20.285),(57.625,20.285),(57.625,20.115),(57.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.475),(56.375,20.645),(56.545,20.645),(56.545,20.475),(56.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.475),(56.735,20.645),(56.905,20.645),(56.905,20.475),(56.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.475),(57.095,20.645),(57.265,20.645),(57.265,20.475),(57.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.475),(57.455,20.645),(57.625,20.645),(57.625,20.475),(57.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.835),(56.375,21.005),(56.545,21.005),(56.545,20.835),(56.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.835),(56.735,21.005),(56.905,21.005),(56.905,20.835),(56.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.835),(57.095,21.005),(57.265,21.005),(57.265,20.835),(57.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.835),(57.455,21.005),(57.625,21.005),(57.625,20.835),(57.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.195),(56.375,21.365),(56.545,21.365),(56.545,21.195),(56.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.195),(56.735,21.365),(56.905,21.365),(56.905,21.195),(56.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.195),(57.095,21.365),(57.265,21.365),(57.265,21.195),(57.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.195),(57.455,21.365),(57.625,21.365),(57.625,21.195),(57.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.555),(56.375,21.725),(56.545,21.725),(56.545,21.555),(56.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.555),(56.735,21.725),(56.905,21.725),(56.905,21.555),(56.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.555),(57.095,21.725),(57.265,21.725),(57.265,21.555),(57.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.555),(57.455,21.725),(57.625,21.725),(57.625,21.555),(57.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.915),(56.375,22.085),(56.545,22.085),(56.545,21.915),(56.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.915),(56.735,22.085),(56.905,22.085),(56.905,21.915),(56.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.915),(57.095,22.085),(57.265,22.085),(57.265,21.915),(57.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.915),(57.455,22.085),(57.625,22.085),(57.625,21.915),(57.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.275),(56.375,22.445),(56.545,22.445),(56.545,22.275),(56.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.275),(56.735,22.445),(56.905,22.445),(56.905,22.275),(56.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.275),(57.095,22.445),(57.265,22.445),(57.265,22.275),(57.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.275),(57.455,22.445),(57.625,22.445),(57.625,22.275),(57.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.635),(56.375,22.805),(56.545,22.805),(56.545,22.635),(56.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.635),(56.735,22.805),(56.905,22.805),(56.905,22.635),(56.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.635),(57.095,22.805),(57.265,22.805),(57.265,22.635),(57.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.635),(57.455,22.805),(57.625,22.805),(57.625,22.635),(57.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.995),(56.375,23.165),(56.545,23.165),(56.545,22.995),(56.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.995),(56.735,23.165),(56.905,23.165),(56.905,22.995),(56.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.995),(57.095,23.165),(57.265,23.165),(57.265,22.995),(57.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.995),(57.455,23.165),(57.625,23.165),(57.625,22.995),(57.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,23.355),(56.375,23.525),(56.545,23.525),(56.545,23.355),(56.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,23.355),(56.735,23.525),(56.905,23.525),(56.905,23.355),(56.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,23.355),(57.095,23.525),(57.265,23.525),(57.265,23.355),(57.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,23.355),(57.455,23.525),(57.625,23.525),(57.625,23.355),(57.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,23.715),(56.375,23.885),(56.545,23.885),(56.545,23.715),(56.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,23.715),(56.735,23.885),(56.905,23.885),(56.905,23.715),(56.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,23.715),(57.095,23.885),(57.265,23.885),(57.265,23.715),(57.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,23.715),(57.455,23.885),(57.625,23.885),(57.625,23.715),(57.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.075),(56.375,24.245),(56.545,24.245),(56.545,24.075),(56.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.075),(56.735,24.245),(56.905,24.245),(56.905,24.075),(56.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.075),(57.095,24.245),(57.265,24.245),(57.265,24.075),(57.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.075),(57.455,24.245),(57.625,24.245),(57.625,24.075),(57.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.435),(56.375,24.605),(56.545,24.605),(56.545,24.435),(56.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.435),(56.735,24.605),(56.905,24.605),(56.905,24.435),(56.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.435),(57.095,24.605),(57.265,24.605),(57.265,24.435),(57.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.435),(57.455,24.605),(57.625,24.605),(57.625,24.435),(57.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.795),(56.375,24.965),(56.545,24.965),(56.545,24.795),(56.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.795),(56.735,24.965),(56.905,24.965),(56.905,24.795),(56.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.795),(57.095,24.965),(57.265,24.965),(57.265,24.795),(57.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.795),(57.455,24.965),(57.625,24.965),(57.625,24.795),(57.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.155),(56.375,25.325),(56.545,25.325),(56.545,25.155),(56.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.155),(56.735,25.325),(56.905,25.325),(56.905,25.155),(56.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.155),(57.095,25.325),(57.265,25.325),(57.265,25.155),(57.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.155),(57.455,25.325),(57.625,25.325),(57.625,25.155),(57.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.515),(56.375,25.685),(56.545,25.685),(56.545,25.515),(56.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.515),(56.735,25.685),(56.905,25.685),(56.905,25.515),(56.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.515),(57.095,25.685),(57.265,25.685),(57.265,25.515),(57.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.515),(57.455,25.685),(57.625,25.685),(57.625,25.515),(57.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.875),(56.375,26.045),(56.545,26.045),(56.545,25.875),(56.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.875),(56.735,26.045),(56.905,26.045),(56.905,25.875),(56.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.875),(57.095,26.045),(57.265,26.045),(57.265,25.875),(57.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.875),(57.455,26.045),(57.625,26.045),(57.625,25.875),(57.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.235),(56.375,26.405),(56.545,26.405),(56.545,26.235),(56.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.235),(56.735,26.405),(56.905,26.405),(56.905,26.235),(56.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.235),(57.095,26.405),(57.265,26.405),(57.265,26.235),(57.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.235),(57.455,26.405),(57.625,26.405),(57.625,26.235),(57.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.595),(56.375,26.765),(56.545,26.765),(56.545,26.595),(56.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.595),(56.735,26.765),(56.905,26.765),(56.905,26.595),(56.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.595),(57.095,26.765),(57.265,26.765),(57.265,26.595),(57.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.595),(57.455,26.765),(57.625,26.765),(57.625,26.595),(57.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.955),(56.375,27.125),(56.545,27.125),(56.545,26.955),(56.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.955),(56.735,27.125),(56.905,27.125),(56.905,26.955),(56.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.955),(57.095,27.125),(57.265,27.125),(57.265,26.955),(57.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.955),(57.455,27.125),(57.625,27.125),(57.625,26.955),(57.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,27.315),(56.375,27.485),(56.545,27.485),(56.545,27.315),(56.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,27.315),(56.735,27.485),(56.905,27.485),(56.905,27.315),(56.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,27.315),(57.095,27.485),(57.265,27.485),(57.265,27.315),(57.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,27.315),(57.455,27.485),(57.625,27.485),(57.625,27.315),(57.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,27.675),(56.375,27.845),(56.545,27.845),(56.545,27.675),(56.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,27.675),(56.735,27.845),(56.905,27.845),(56.905,27.675),(56.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,27.675),(57.095,27.845),(57.265,27.845),(57.265,27.675),(57.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,27.675),(57.455,27.845),(57.625,27.845),(57.625,27.675),(57.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.035),(56.375,28.205),(56.545,28.205),(56.545,28.035),(56.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.035),(56.735,28.205),(56.905,28.205),(56.905,28.035),(56.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.035),(57.095,28.205),(57.265,28.205),(57.265,28.035),(57.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.035),(57.455,28.205),(57.625,28.205),(57.625,28.035),(57.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.395),(56.375,28.565),(56.545,28.565),(56.545,28.395),(56.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.395),(56.735,28.565),(56.905,28.565),(56.905,28.395),(56.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.395),(57.095,28.565),(57.265,28.565),(57.265,28.395),(57.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.395),(57.455,28.565),(57.625,28.565),(57.625,28.395),(57.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.755),(56.375,28.925),(56.545,28.925),(56.545,28.755),(56.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.755),(56.735,28.925),(56.905,28.925),(56.905,28.755),(56.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.755),(57.095,28.925),(57.265,28.925),(57.265,28.755),(57.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.755),(57.455,28.925),(57.625,28.925),(57.625,28.755),(57.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.115),(56.375,29.285),(56.545,29.285),(56.545,29.115),(56.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.115),(56.735,29.285),(56.905,29.285),(56.905,29.115),(56.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.115),(57.095,29.285),(57.265,29.285),(57.265,29.115),(57.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.115),(57.455,29.285),(57.625,29.285),(57.625,29.115),(57.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.475),(56.375,29.645),(56.545,29.645),(56.545,29.475),(56.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.475),(56.735,29.645),(56.905,29.645),(56.905,29.475),(56.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.475),(57.095,29.645),(57.265,29.645),(57.265,29.475),(57.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.475),(57.455,29.645),(57.625,29.645),(57.625,29.475),(57.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.835),(56.375,30.005),(56.545,30.005),(56.545,29.835),(56.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.835),(56.735,30.005),(56.905,30.005),(56.905,29.835),(56.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.835),(57.095,30.005),(57.265,30.005),(57.265,29.835),(57.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.835),(57.455,30.005),(57.625,30.005),(57.625,29.835),(57.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.195),(56.375,30.365),(56.545,30.365),(56.545,30.195),(56.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.195),(56.735,30.365),(56.905,30.365),(56.905,30.195),(56.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.195),(57.095,30.365),(57.265,30.365),(57.265,30.195),(57.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.195),(57.455,30.365),(57.625,30.365),(57.625,30.195),(57.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.555),(56.375,30.725),(56.545,30.725),(56.545,30.555),(56.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.555),(56.735,30.725),(56.905,30.725),(56.905,30.555),(56.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.555),(57.095,30.725),(57.265,30.725),(57.265,30.555),(57.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.555),(57.455,30.725),(57.625,30.725),(57.625,30.555),(57.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.915),(56.375,31.085),(56.545,31.085),(56.545,30.915),(56.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.915),(56.735,31.085),(56.905,31.085),(56.905,30.915),(56.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.915),(57.095,31.085),(57.265,31.085),(57.265,30.915),(57.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.915),(57.455,31.085),(57.625,31.085),(57.625,30.915),(57.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.275),(56.375,31.445),(56.545,31.445),(56.545,31.275),(56.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.275),(56.735,31.445),(56.905,31.445),(56.905,31.275),(56.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.275),(57.095,31.445),(57.265,31.445),(57.265,31.275),(57.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.275),(57.455,31.445),(57.625,31.445),(57.625,31.275),(57.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.635),(56.375,31.805),(56.545,31.805),(56.545,31.635),(56.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.635),(56.735,31.805),(56.905,31.805),(56.905,31.635),(56.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.635),(57.095,31.805),(57.265,31.805),(57.265,31.635),(57.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.635),(57.455,31.805),(57.625,31.805),(57.625,31.635),(57.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.995),(56.375,32.165),(56.545,32.165),(56.545,31.995),(56.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.995),(56.735,32.165),(56.905,32.165),(56.905,31.995),(56.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.995),(57.095,32.165),(57.265,32.165),(57.265,31.995),(57.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.995),(57.455,32.165),(57.625,32.165),(57.625,31.995),(57.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,32.355),(56.375,32.525),(56.545,32.525),(56.545,32.355),(56.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,32.355),(56.735,32.525),(56.905,32.525),(56.905,32.355),(56.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,32.355),(57.095,32.525),(57.265,32.525),(57.265,32.355),(57.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,32.355),(57.455,32.525),(57.625,32.525),(57.625,32.355),(57.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,32.715),(56.375,32.885),(56.545,32.885),(56.545,32.715),(56.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,32.715),(56.735,32.885),(56.905,32.885),(56.905,32.715),(56.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,32.715),(57.095,32.885),(57.265,32.885),(57.265,32.715),(57.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,32.715),(57.455,32.885),(57.625,32.885),(57.625,32.715),(57.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.075),(56.375,33.245),(56.545,33.245),(56.545,33.075),(56.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.075),(56.735,33.245),(56.905,33.245),(56.905,33.075),(56.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.075),(57.095,33.245),(57.265,33.245),(57.265,33.075),(57.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.075),(57.455,33.245),(57.625,33.245),(57.625,33.075),(57.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.435),(56.375,33.605),(56.545,33.605),(56.545,33.435),(56.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.435),(56.735,33.605),(56.905,33.605),(56.905,33.435),(56.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.435),(57.095,33.605),(57.265,33.605),(57.265,33.435),(57.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.435),(57.455,33.605),(57.625,33.605),(57.625,33.435),(57.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.795),(56.375,33.965),(56.545,33.965),(56.545,33.795),(56.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.795),(56.735,33.965),(56.905,33.965),(56.905,33.795),(56.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.795),(57.095,33.965),(57.265,33.965),(57.265,33.795),(57.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.795),(57.455,33.965),(57.625,33.965),(57.625,33.795),(57.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.155),(56.375,34.325),(56.545,34.325),(56.545,34.155),(56.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.155),(56.735,34.325),(56.905,34.325),(56.905,34.155),(56.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.155),(57.095,34.325),(57.265,34.325),(57.265,34.155),(57.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.155),(57.455,34.325),(57.625,34.325),(57.625,34.155),(57.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.515),(56.375,34.685),(56.545,34.685),(56.545,34.515),(56.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.515),(56.735,34.685),(56.905,34.685),(56.905,34.515),(56.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.515),(57.095,34.685),(57.265,34.685),(57.265,34.515),(57.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.515),(57.455,34.685),(57.625,34.685),(57.625,34.515),(57.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.875),(56.375,35.045),(56.545,35.045),(56.545,34.875),(56.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.875),(56.735,35.045),(56.905,35.045),(56.905,34.875),(56.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.875),(57.095,35.045),(57.265,35.045),(57.265,34.875),(57.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.875),(57.455,35.045),(57.625,35.045),(57.625,34.875),(57.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.235),(56.375,35.405),(56.545,35.405),(56.545,35.235),(56.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.235),(56.735,35.405),(56.905,35.405),(56.905,35.235),(56.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.235),(57.095,35.405),(57.265,35.405),(57.265,35.235),(57.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.235),(57.455,35.405),(57.625,35.405),(57.625,35.235),(57.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.595),(56.375,35.765),(56.545,35.765),(56.545,35.595),(56.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.595),(56.735,35.765),(56.905,35.765),(56.905,35.595),(56.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.595),(57.095,35.765),(57.265,35.765),(57.265,35.595),(57.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.595),(57.455,35.765),(57.625,35.765),(57.625,35.595),(57.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.955),(56.375,36.125),(56.545,36.125),(56.545,35.955),(56.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.955),(56.735,36.125),(56.905,36.125),(56.905,35.955),(56.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.955),(57.095,36.125),(57.265,36.125),(57.265,35.955),(57.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.955),(57.455,36.125),(57.625,36.125),(57.625,35.955),(57.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,36.315),(56.375,36.485),(56.545,36.485),(56.545,36.315),(56.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,36.315),(56.735,36.485),(56.905,36.485),(56.905,36.315),(56.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,36.315),(57.095,36.485),(57.265,36.485),(57.265,36.315),(57.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,36.315),(57.455,36.485),(57.625,36.485),(57.625,36.315),(57.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,36.675),(56.375,36.845),(56.545,36.845),(56.545,36.675),(56.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,36.675),(56.735,36.845),(56.905,36.845),(56.905,36.675),(56.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,36.675),(57.095,36.845),(57.265,36.845),(57.265,36.675),(57.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,36.675),(57.455,36.845),(57.625,36.845),(57.625,36.675),(57.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.035),(56.375,37.205),(56.545,37.205),(56.545,37.035),(56.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.035),(56.735,37.205),(56.905,37.205),(56.905,37.035),(56.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.035),(57.095,37.205),(57.265,37.205),(57.265,37.035),(57.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.035),(57.455,37.205),(57.625,37.205),(57.625,37.035),(57.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.395),(56.375,37.565),(56.545,37.565),(56.545,37.395),(56.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.395),(56.735,37.565),(56.905,37.565),(56.905,37.395),(56.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.395),(57.095,37.565),(57.265,37.565),(57.265,37.395),(57.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.395),(57.455,37.565),(57.625,37.565),(57.625,37.395),(57.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.755),(56.375,37.925),(56.545,37.925),(56.545,37.755),(56.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.755),(56.735,37.925),(56.905,37.925),(56.905,37.755),(56.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.755),(57.095,37.925),(57.265,37.925),(57.265,37.755),(57.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.755),(57.455,37.925),(57.625,37.925),(57.625,37.755),(57.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.115),(56.375,38.285),(56.545,38.285),(56.545,38.115),(56.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.115),(56.735,38.285),(56.905,38.285),(56.905,38.115),(56.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.115),(57.095,38.285),(57.265,38.285),(57.265,38.115),(57.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.115),(57.455,38.285),(57.625,38.285),(57.625,38.115),(57.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.475),(56.375,38.645),(56.545,38.645),(56.545,38.475),(56.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.475),(56.735,38.645),(56.905,38.645),(56.905,38.475),(56.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.475),(57.095,38.645),(57.265,38.645),(57.265,38.475),(57.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.475),(57.455,38.645),(57.625,38.645),(57.625,38.475),(57.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.835),(56.375,39.005),(56.545,39.005),(56.545,38.835),(56.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.835),(56.735,39.005),(56.905,39.005),(56.905,38.835),(56.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.835),(57.095,39.005),(57.265,39.005),(57.265,38.835),(57.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.835),(57.455,39.005),(57.625,39.005),(57.625,38.835),(57.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.195),(56.375,39.365),(56.545,39.365),(56.545,39.195),(56.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.195),(56.735,39.365),(56.905,39.365),(56.905,39.195),(56.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.195),(57.095,39.365),(57.265,39.365),(57.265,39.195),(57.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.195),(57.455,39.365),(57.625,39.365),(57.625,39.195),(57.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.555),(56.375,39.725),(56.545,39.725),(56.545,39.555),(56.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.555),(56.735,39.725),(56.905,39.725),(56.905,39.555),(56.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.555),(57.095,39.725),(57.265,39.725),(57.265,39.555),(57.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.555),(57.455,39.725),(57.625,39.725),(57.625,39.555),(57.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.915),(56.375,40.085),(56.545,40.085),(56.545,39.915),(56.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.915),(56.735,40.085),(56.905,40.085),(56.905,39.915),(56.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.915),(57.095,40.085),(57.265,40.085),(57.265,39.915),(57.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.915),(57.455,40.085),(57.625,40.085),(57.625,39.915),(57.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,40.275),(56.375,40.445),(56.545,40.445),(56.545,40.275),(56.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,40.275),(56.735,40.445),(56.905,40.445),(56.905,40.275),(56.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,40.275),(57.095,40.445),(57.265,40.445),(57.265,40.275),(57.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,40.275),(57.455,40.445),(57.625,40.445),(57.625,40.275),(57.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,40.635),(56.375,40.805),(56.545,40.805),(56.545,40.635),(56.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,40.635),(56.735,40.805),(56.905,40.805),(56.905,40.635),(56.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,40.635),(57.095,40.805),(57.265,40.805),(57.265,40.635),(57.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,40.635),(57.455,40.805),(57.625,40.805),(57.625,40.635),(57.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,2.835),(8.375,3.005),(8.545,3.005),(8.545,2.835),(8.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,2.835),(8.735,3.005),(8.905,3.005),(8.905,2.835),(8.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,2.835),(9.095,3.005),(9.265,3.005),(9.265,2.835),(9.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,2.835),(9.455,3.005),(9.625,3.005),(9.625,2.835),(9.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.195),(8.375,3.365),(8.545,3.365),(8.545,3.195),(8.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.195),(8.735,3.365),(8.905,3.365),(8.905,3.195),(8.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.195),(9.095,3.365),(9.265,3.365),(9.265,3.195),(9.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.195),(9.455,3.365),(9.625,3.365),(9.625,3.195),(9.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.555),(8.375,3.725),(8.545,3.725),(8.545,3.555),(8.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.555),(8.735,3.725),(8.905,3.725),(8.905,3.555),(8.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.555),(9.095,3.725),(9.265,3.725),(9.265,3.555),(9.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.555),(9.455,3.725),(9.625,3.725),(9.625,3.555),(9.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.915),(8.375,4.085),(8.545,4.085),(8.545,3.915),(8.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.915),(8.735,4.085),(8.905,4.085),(8.905,3.915),(8.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.915),(9.095,4.085),(9.265,4.085),(9.265,3.915),(9.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.915),(9.455,4.085),(9.625,4.085),(9.625,3.915),(9.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.275),(8.375,4.445),(8.545,4.445),(8.545,4.275),(8.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.275),(8.735,4.445),(8.905,4.445),(8.905,4.275),(8.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.275),(9.095,4.445),(9.265,4.445),(9.265,4.275),(9.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.275),(9.455,4.445),(9.625,4.445),(9.625,4.275),(9.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.635),(8.375,4.805),(8.545,4.805),(8.545,4.635),(8.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.635),(8.735,4.805),(8.905,4.805),(8.905,4.635),(8.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.635),(9.095,4.805),(9.265,4.805),(9.265,4.635),(9.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.635),(9.455,4.805),(9.625,4.805),(9.625,4.635),(9.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.995),(8.375,5.165),(8.545,5.165),(8.545,4.995),(8.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.995),(8.735,5.165),(8.905,5.165),(8.905,4.995),(8.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.995),(9.095,5.165),(9.265,5.165),(9.265,4.995),(9.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.995),(9.455,5.165),(9.625,5.165),(9.625,4.995),(9.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.355),(8.375,5.525),(8.545,5.525),(8.545,5.355),(8.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.355),(8.735,5.525),(8.905,5.525),(8.905,5.355),(8.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.355),(9.095,5.525),(9.265,5.525),(9.265,5.355),(9.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.355),(9.455,5.525),(9.625,5.525),(9.625,5.355),(9.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.715),(8.375,5.885),(8.545,5.885),(8.545,5.715),(8.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.715),(8.735,5.885),(8.905,5.885),(8.905,5.715),(8.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.715),(9.095,5.885),(9.265,5.885),(9.265,5.715),(9.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.715),(9.455,5.885),(9.625,5.885),(9.625,5.715),(9.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.075),(8.375,6.245),(8.545,6.245),(8.545,6.075),(8.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.075),(8.735,6.245),(8.905,6.245),(8.905,6.075),(8.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.075),(9.095,6.245),(9.265,6.245),(9.265,6.075),(9.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.075),(9.455,6.245),(9.625,6.245),(9.625,6.075),(9.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.435),(8.375,6.605),(8.545,6.605),(8.545,6.435),(8.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.435),(8.735,6.605),(8.905,6.605),(8.905,6.435),(8.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.435),(9.095,6.605),(9.265,6.605),(9.265,6.435),(9.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.435),(9.455,6.605),(9.625,6.605),(9.625,6.435),(9.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.795),(8.375,6.965),(8.545,6.965),(8.545,6.795),(8.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.795),(8.735,6.965),(8.905,6.965),(8.905,6.795),(8.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.795),(9.095,6.965),(9.265,6.965),(9.265,6.795),(9.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.795),(9.455,6.965),(9.625,6.965),(9.625,6.795),(9.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.155),(8.375,7.325),(8.545,7.325),(8.545,7.155),(8.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.155),(8.735,7.325),(8.905,7.325),(8.905,7.155),(8.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.155),(9.095,7.325),(9.265,7.325),(9.265,7.155),(9.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.155),(9.455,7.325),(9.625,7.325),(9.625,7.155),(9.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.515),(8.375,7.685),(8.545,7.685),(8.545,7.515),(8.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.515),(8.735,7.685),(8.905,7.685),(8.905,7.515),(8.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.515),(9.095,7.685),(9.265,7.685),(9.265,7.515),(9.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.515),(9.455,7.685),(9.625,7.685),(9.625,7.515),(9.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.875),(8.375,8.045),(8.545,8.045),(8.545,7.875),(8.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.875),(8.735,8.045),(8.905,8.045),(8.905,7.875),(8.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.875),(9.095,8.045),(9.265,8.045),(9.265,7.875),(9.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.875),(9.455,8.045),(9.625,8.045),(9.625,7.875),(9.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.235),(8.375,8.405),(8.545,8.405),(8.545,8.235),(8.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.235),(8.735,8.405),(8.905,8.405),(8.905,8.235),(8.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.235),(9.095,8.405),(9.265,8.405),(9.265,8.235),(9.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.235),(9.455,8.405),(9.625,8.405),(9.625,8.235),(9.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.595),(8.375,8.765),(8.545,8.765),(8.545,8.595),(8.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.595),(8.735,8.765),(8.905,8.765),(8.905,8.595),(8.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.595),(9.095,8.765),(9.265,8.765),(9.265,8.595),(9.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.595),(9.455,8.765),(9.625,8.765),(9.625,8.595),(9.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.955),(8.375,9.125),(8.545,9.125),(8.545,8.955),(8.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.955),(8.735,9.125),(8.905,9.125),(8.905,8.955),(8.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.955),(9.095,9.125),(9.265,9.125),(9.265,8.955),(9.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.955),(9.455,9.125),(9.625,9.125),(9.625,8.955),(9.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.315),(8.375,9.485),(8.545,9.485),(8.545,9.315),(8.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.315),(8.735,9.485),(8.905,9.485),(8.905,9.315),(8.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.315),(9.095,9.485),(9.265,9.485),(9.265,9.315),(9.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.315),(9.455,9.485),(9.625,9.485),(9.625,9.315),(9.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.675),(8.375,9.845),(8.545,9.845),(8.545,9.675),(8.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.675),(8.735,9.845),(8.905,9.845),(8.905,9.675),(8.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.675),(9.095,9.845),(9.265,9.845),(9.265,9.675),(9.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.675),(9.455,9.845),(9.625,9.845),(9.625,9.675),(9.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.035),(8.375,10.205),(8.545,10.205),(8.545,10.035),(8.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.035),(8.735,10.205),(8.905,10.205),(8.905,10.035),(8.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.035),(9.095,10.205),(9.265,10.205),(9.265,10.035),(9.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.035),(9.455,10.205),(9.625,10.205),(9.625,10.035),(9.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.395),(8.375,10.565),(8.545,10.565),(8.545,10.395),(8.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.395),(8.735,10.565),(8.905,10.565),(8.905,10.395),(8.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.395),(9.095,10.565),(9.265,10.565),(9.265,10.395),(9.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.395),(9.455,10.565),(9.625,10.565),(9.625,10.395),(9.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.755),(8.375,10.925),(8.545,10.925),(8.545,10.755),(8.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.755),(8.735,10.925),(8.905,10.925),(8.905,10.755),(8.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.755),(9.095,10.925),(9.265,10.925),(9.265,10.755),(9.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.755),(9.455,10.925),(9.625,10.925),(9.625,10.755),(9.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.115),(8.375,11.285),(8.545,11.285),(8.545,11.115),(8.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.115),(8.735,11.285),(8.905,11.285),(8.905,11.115),(8.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.115),(9.095,11.285),(9.265,11.285),(9.265,11.115),(9.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.115),(9.455,11.285),(9.625,11.285),(9.625,11.115),(9.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.475),(8.375,11.645),(8.545,11.645),(8.545,11.475),(8.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.475),(8.735,11.645),(8.905,11.645),(8.905,11.475),(8.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.475),(9.095,11.645),(9.265,11.645),(9.265,11.475),(9.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.475),(9.455,11.645),(9.625,11.645),(9.625,11.475),(9.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.835),(8.375,12.005),(8.545,12.005),(8.545,11.835),(8.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.835),(8.735,12.005),(8.905,12.005),(8.905,11.835),(8.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.835),(9.095,12.005),(9.265,12.005),(9.265,11.835),(9.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.835),(9.455,12.005),(9.625,12.005),(9.625,11.835),(9.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.195),(8.375,12.365),(8.545,12.365),(8.545,12.195),(8.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.195),(8.735,12.365),(8.905,12.365),(8.905,12.195),(8.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.195),(9.095,12.365),(9.265,12.365),(9.265,12.195),(9.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.195),(9.455,12.365),(9.625,12.365),(9.625,12.195),(9.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.555),(8.375,12.725),(8.545,12.725),(8.545,12.555),(8.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.555),(8.735,12.725),(8.905,12.725),(8.905,12.555),(8.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.555),(9.095,12.725),(9.265,12.725),(9.265,12.555),(9.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.555),(9.455,12.725),(9.625,12.725),(9.625,12.555),(9.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.915),(8.375,13.085),(8.545,13.085),(8.545,12.915),(8.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.915),(8.735,13.085),(8.905,13.085),(8.905,12.915),(8.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.915),(9.095,13.085),(9.265,13.085),(9.265,12.915),(9.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.915),(9.455,13.085),(9.625,13.085),(9.625,12.915),(9.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.275),(8.375,13.445),(8.545,13.445),(8.545,13.275),(8.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.275),(8.735,13.445),(8.905,13.445),(8.905,13.275),(8.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.275),(9.095,13.445),(9.265,13.445),(9.265,13.275),(9.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.275),(9.455,13.445),(9.625,13.445),(9.625,13.275),(9.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.635),(8.375,13.805),(8.545,13.805),(8.545,13.635),(8.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.635),(8.735,13.805),(8.905,13.805),(8.905,13.635),(8.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.635),(9.095,13.805),(9.265,13.805),(9.265,13.635),(9.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.635),(9.455,13.805),(9.625,13.805),(9.625,13.635),(9.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.995),(8.375,14.165),(8.545,14.165),(8.545,13.995),(8.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.995),(8.735,14.165),(8.905,14.165),(8.905,13.995),(8.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.995),(9.095,14.165),(9.265,14.165),(9.265,13.995),(9.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.995),(9.455,14.165),(9.625,14.165),(9.625,13.995),(9.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.355),(8.375,14.525),(8.545,14.525),(8.545,14.355),(8.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.355),(8.735,14.525),(8.905,14.525),(8.905,14.355),(8.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.355),(9.095,14.525),(9.265,14.525),(9.265,14.355),(9.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.355),(9.455,14.525),(9.625,14.525),(9.625,14.355),(9.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.715),(8.375,14.885),(8.545,14.885),(8.545,14.715),(8.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.715),(8.735,14.885),(8.905,14.885),(8.905,14.715),(8.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.715),(9.095,14.885),(9.265,14.885),(9.265,14.715),(9.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.715),(9.455,14.885),(9.625,14.885),(9.625,14.715),(9.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.075),(8.375,15.245),(8.545,15.245),(8.545,15.075),(8.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.075),(8.735,15.245),(8.905,15.245),(8.905,15.075),(8.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.075),(9.095,15.245),(9.265,15.245),(9.265,15.075),(9.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.075),(9.455,15.245),(9.625,15.245),(9.625,15.075),(9.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.435),(8.375,15.605),(8.545,15.605),(8.545,15.435),(8.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.435),(8.735,15.605),(8.905,15.605),(8.905,15.435),(8.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.435),(9.095,15.605),(9.265,15.605),(9.265,15.435),(9.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.435),(9.455,15.605),(9.625,15.605),(9.625,15.435),(9.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.795),(8.375,15.965),(8.545,15.965),(8.545,15.795),(8.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.795),(8.735,15.965),(8.905,15.965),(8.905,15.795),(8.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.795),(9.095,15.965),(9.265,15.965),(9.265,15.795),(9.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.795),(9.455,15.965),(9.625,15.965),(9.625,15.795),(9.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.155),(8.375,16.325),(8.545,16.325),(8.545,16.155),(8.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.155),(8.735,16.325),(8.905,16.325),(8.905,16.155),(8.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.155),(9.095,16.325),(9.265,16.325),(9.265,16.155),(9.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.155),(9.455,16.325),(9.625,16.325),(9.625,16.155),(9.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.515),(8.375,16.685),(8.545,16.685),(8.545,16.515),(8.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.515),(8.735,16.685),(8.905,16.685),(8.905,16.515),(8.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.515),(9.095,16.685),(9.265,16.685),(9.265,16.515),(9.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.515),(9.455,16.685),(9.625,16.685),(9.625,16.515),(9.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.875),(8.375,17.045),(8.545,17.045),(8.545,16.875),(8.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.875),(8.735,17.045),(8.905,17.045),(8.905,16.875),(8.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.875),(9.095,17.045),(9.265,17.045),(9.265,16.875),(9.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.875),(9.455,17.045),(9.625,17.045),(9.625,16.875),(9.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.235),(8.375,17.405),(8.545,17.405),(8.545,17.235),(8.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.235),(8.735,17.405),(8.905,17.405),(8.905,17.235),(8.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.235),(9.095,17.405),(9.265,17.405),(9.265,17.235),(9.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.235),(9.455,17.405),(9.625,17.405),(9.625,17.235),(9.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.595),(8.375,17.765),(8.545,17.765),(8.545,17.595),(8.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.595),(8.735,17.765),(8.905,17.765),(8.905,17.595),(8.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.595),(9.095,17.765),(9.265,17.765),(9.265,17.595),(9.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.595),(9.455,17.765),(9.625,17.765),(9.625,17.595),(9.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.955),(8.375,18.125),(8.545,18.125),(8.545,17.955),(8.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.955),(8.735,18.125),(8.905,18.125),(8.905,17.955),(8.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.955),(9.095,18.125),(9.265,18.125),(9.265,17.955),(9.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.955),(9.455,18.125),(9.625,18.125),(9.625,17.955),(9.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.315),(8.375,18.485),(8.545,18.485),(8.545,18.315),(8.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.315),(8.735,18.485),(8.905,18.485),(8.905,18.315),(8.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.315),(9.095,18.485),(9.265,18.485),(9.265,18.315),(9.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.315),(9.455,18.485),(9.625,18.485),(9.625,18.315),(9.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.675),(8.375,18.845),(8.545,18.845),(8.545,18.675),(8.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.675),(8.735,18.845),(8.905,18.845),(8.905,18.675),(8.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.675),(9.095,18.845),(9.265,18.845),(9.265,18.675),(9.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.675),(9.455,18.845),(9.625,18.845),(9.625,18.675),(9.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.035),(8.375,19.205),(8.545,19.205),(8.545,19.035),(8.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.035),(8.735,19.205),(8.905,19.205),(8.905,19.035),(8.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.035),(9.095,19.205),(9.265,19.205),(9.265,19.035),(9.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.035),(9.455,19.205),(9.625,19.205),(9.625,19.035),(9.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.395),(8.375,19.565),(8.545,19.565),(8.545,19.395),(8.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.395),(8.735,19.565),(8.905,19.565),(8.905,19.395),(8.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.395),(9.095,19.565),(9.265,19.565),(9.265,19.395),(9.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.395),(9.455,19.565),(9.625,19.565),(9.625,19.395),(9.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.755),(8.375,19.925),(8.545,19.925),(8.545,19.755),(8.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.755),(8.735,19.925),(8.905,19.925),(8.905,19.755),(8.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.755),(9.095,19.925),(9.265,19.925),(9.265,19.755),(9.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.755),(9.455,19.925),(9.625,19.925),(9.625,19.755),(9.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,20.115),(8.375,20.285),(8.545,20.285),(8.545,20.115),(8.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,20.115),(8.735,20.285),(8.905,20.285),(8.905,20.115),(8.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,20.115),(9.095,20.285),(9.265,20.285),(9.265,20.115),(9.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,20.115),(9.455,20.285),(9.625,20.285),(9.625,20.115),(9.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,20.475),(8.375,20.645),(8.545,20.645),(8.545,20.475),(8.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,20.475),(8.735,20.645),(8.905,20.645),(8.905,20.475),(8.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,20.475),(9.095,20.645),(9.265,20.645),(9.265,20.475),(9.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,20.475),(9.455,20.645),(9.625,20.645),(9.625,20.475),(9.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,20.835),(8.375,21.005),(8.545,21.005),(8.545,20.835),(8.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,20.835),(8.735,21.005),(8.905,21.005),(8.905,20.835),(8.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,20.835),(9.095,21.005),(9.265,21.005),(9.265,20.835),(9.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,20.835),(9.455,21.005),(9.625,21.005),(9.625,20.835),(9.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,21.195),(8.375,21.365),(8.545,21.365),(8.545,21.195),(8.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,21.195),(8.735,21.365),(8.905,21.365),(8.905,21.195),(8.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,21.195),(9.095,21.365),(9.265,21.365),(9.265,21.195),(9.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,21.195),(9.455,21.365),(9.625,21.365),(9.625,21.195),(9.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,21.555),(8.375,21.725),(8.545,21.725),(8.545,21.555),(8.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,21.555),(8.735,21.725),(8.905,21.725),(8.905,21.555),(8.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,21.555),(9.095,21.725),(9.265,21.725),(9.265,21.555),(9.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,21.555),(9.455,21.725),(9.625,21.725),(9.625,21.555),(9.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,21.915),(8.375,22.085),(8.545,22.085),(8.545,21.915),(8.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,21.915),(8.735,22.085),(8.905,22.085),(8.905,21.915),(8.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,21.915),(9.095,22.085),(9.265,22.085),(9.265,21.915),(9.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,21.915),(9.455,22.085),(9.625,22.085),(9.625,21.915),(9.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.275),(8.375,22.445),(8.545,22.445),(8.545,22.275),(8.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.275),(8.735,22.445),(8.905,22.445),(8.905,22.275),(8.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.275),(9.095,22.445),(9.265,22.445),(9.265,22.275),(9.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.275),(9.455,22.445),(9.625,22.445),(9.625,22.275),(9.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.635),(8.375,22.805),(8.545,22.805),(8.545,22.635),(8.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.635),(8.735,22.805),(8.905,22.805),(8.905,22.635),(8.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.635),(9.095,22.805),(9.265,22.805),(9.265,22.635),(9.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.635),(9.455,22.805),(9.625,22.805),(9.625,22.635),(9.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.995),(8.375,23.165),(8.545,23.165),(8.545,22.995),(8.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.995),(8.735,23.165),(8.905,23.165),(8.905,22.995),(8.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.995),(9.095,23.165),(9.265,23.165),(9.265,22.995),(9.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.995),(9.455,23.165),(9.625,23.165),(9.625,22.995),(9.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,23.355),(8.375,23.525),(8.545,23.525),(8.545,23.355),(8.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,23.355),(8.735,23.525),(8.905,23.525),(8.905,23.355),(8.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,23.355),(9.095,23.525),(9.265,23.525),(9.265,23.355),(9.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,23.355),(9.455,23.525),(9.625,23.525),(9.625,23.355),(9.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,23.715),(8.375,23.885),(8.545,23.885),(8.545,23.715),(8.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,23.715),(8.735,23.885),(8.905,23.885),(8.905,23.715),(8.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,23.715),(9.095,23.885),(9.265,23.885),(9.265,23.715),(9.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,23.715),(9.455,23.885),(9.625,23.885),(9.625,23.715),(9.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,24.075),(8.375,24.245),(8.545,24.245),(8.545,24.075),(8.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,24.075),(8.735,24.245),(8.905,24.245),(8.905,24.075),(8.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,24.075),(9.095,24.245),(9.265,24.245),(9.265,24.075),(9.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,24.075),(9.455,24.245),(9.625,24.245),(9.625,24.075),(9.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,24.435),(8.375,24.605),(8.545,24.605),(8.545,24.435),(8.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,24.435),(8.735,24.605),(8.905,24.605),(8.905,24.435),(8.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,24.435),(9.095,24.605),(9.265,24.605),(9.265,24.435),(9.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,24.435),(9.455,24.605),(9.625,24.605),(9.625,24.435),(9.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,24.795),(8.375,24.965),(8.545,24.965),(8.545,24.795),(8.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,24.795),(8.735,24.965),(8.905,24.965),(8.905,24.795),(8.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,24.795),(9.095,24.965),(9.265,24.965),(9.265,24.795),(9.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,24.795),(9.455,24.965),(9.625,24.965),(9.625,24.795),(9.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,25.155),(8.375,25.325),(8.545,25.325),(8.545,25.155),(8.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,25.155),(8.735,25.325),(8.905,25.325),(8.905,25.155),(8.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,25.155),(9.095,25.325),(9.265,25.325),(9.265,25.155),(9.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,25.155),(9.455,25.325),(9.625,25.325),(9.625,25.155),(9.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,25.515),(8.375,25.685),(8.545,25.685),(8.545,25.515),(8.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,25.515),(8.735,25.685),(8.905,25.685),(8.905,25.515),(8.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,25.515),(9.095,25.685),(9.265,25.685),(9.265,25.515),(9.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,25.515),(9.455,25.685),(9.625,25.685),(9.625,25.515),(9.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,25.875),(8.375,26.045),(8.545,26.045),(8.545,25.875),(8.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,25.875),(8.735,26.045),(8.905,26.045),(8.905,25.875),(8.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,25.875),(9.095,26.045),(9.265,26.045),(9.265,25.875),(9.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,25.875),(9.455,26.045),(9.625,26.045),(9.625,25.875),(9.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,26.235),(8.375,26.405),(8.545,26.405),(8.545,26.235),(8.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,26.235),(8.735,26.405),(8.905,26.405),(8.905,26.235),(8.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,26.235),(9.095,26.405),(9.265,26.405),(9.265,26.235),(9.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,26.235),(9.455,26.405),(9.625,26.405),(9.625,26.235),(9.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,26.595),(8.375,26.765),(8.545,26.765),(8.545,26.595),(8.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,26.595),(8.735,26.765),(8.905,26.765),(8.905,26.595),(8.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,26.595),(9.095,26.765),(9.265,26.765),(9.265,26.595),(9.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,26.595),(9.455,26.765),(9.625,26.765),(9.625,26.595),(9.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,26.955),(8.375,27.125),(8.545,27.125),(8.545,26.955),(8.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,26.955),(8.735,27.125),(8.905,27.125),(8.905,26.955),(8.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,26.955),(9.095,27.125),(9.265,27.125),(9.265,26.955),(9.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,26.955),(9.455,27.125),(9.625,27.125),(9.625,26.955),(9.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,27.315),(8.375,27.485),(8.545,27.485),(8.545,27.315),(8.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,27.315),(8.735,27.485),(8.905,27.485),(8.905,27.315),(8.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,27.315),(9.095,27.485),(9.265,27.485),(9.265,27.315),(9.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,27.315),(9.455,27.485),(9.625,27.485),(9.625,27.315),(9.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,27.675),(8.375,27.845),(8.545,27.845),(8.545,27.675),(8.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,27.675),(8.735,27.845),(8.905,27.845),(8.905,27.675),(8.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,27.675),(9.095,27.845),(9.265,27.845),(9.265,27.675),(9.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,27.675),(9.455,27.845),(9.625,27.845),(9.625,27.675),(9.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,28.035),(8.375,28.205),(8.545,28.205),(8.545,28.035),(8.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,28.035),(8.735,28.205),(8.905,28.205),(8.905,28.035),(8.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,28.035),(9.095,28.205),(9.265,28.205),(9.265,28.035),(9.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,28.035),(9.455,28.205),(9.625,28.205),(9.625,28.035),(9.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,28.395),(8.375,28.565),(8.545,28.565),(8.545,28.395),(8.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,28.395),(8.735,28.565),(8.905,28.565),(8.905,28.395),(8.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,28.395),(9.095,28.565),(9.265,28.565),(9.265,28.395),(9.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,28.395),(9.455,28.565),(9.625,28.565),(9.625,28.395),(9.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,28.755),(8.375,28.925),(8.545,28.925),(8.545,28.755),(8.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,28.755),(8.735,28.925),(8.905,28.925),(8.905,28.755),(8.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,28.755),(9.095,28.925),(9.265,28.925),(9.265,28.755),(9.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,28.755),(9.455,28.925),(9.625,28.925),(9.625,28.755),(9.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,29.115),(8.375,29.285),(8.545,29.285),(8.545,29.115),(8.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,29.115),(8.735,29.285),(8.905,29.285),(8.905,29.115),(8.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,29.115),(9.095,29.285),(9.265,29.285),(9.265,29.115),(9.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,29.115),(9.455,29.285),(9.625,29.285),(9.625,29.115),(9.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,29.475),(8.375,29.645),(8.545,29.645),(8.545,29.475),(8.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,29.475),(8.735,29.645),(8.905,29.645),(8.905,29.475),(8.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,29.475),(9.095,29.645),(9.265,29.645),(9.265,29.475),(9.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,29.475),(9.455,29.645),(9.625,29.645),(9.625,29.475),(9.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,29.835),(8.375,30.005),(8.545,30.005),(8.545,29.835),(8.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,29.835),(8.735,30.005),(8.905,30.005),(8.905,29.835),(8.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,29.835),(9.095,30.005),(9.265,30.005),(9.265,29.835),(9.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,29.835),(9.455,30.005),(9.625,30.005),(9.625,29.835),(9.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,30.195),(8.375,30.365),(8.545,30.365),(8.545,30.195),(8.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,30.195),(8.735,30.365),(8.905,30.365),(8.905,30.195),(8.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,30.195),(9.095,30.365),(9.265,30.365),(9.265,30.195),(9.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,30.195),(9.455,30.365),(9.625,30.365),(9.625,30.195),(9.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,30.555),(8.375,30.725),(8.545,30.725),(8.545,30.555),(8.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,30.555),(8.735,30.725),(8.905,30.725),(8.905,30.555),(8.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,30.555),(9.095,30.725),(9.265,30.725),(9.265,30.555),(9.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,30.555),(9.455,30.725),(9.625,30.725),(9.625,30.555),(9.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,30.915),(8.375,31.085),(8.545,31.085),(8.545,30.915),(8.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,30.915),(8.735,31.085),(8.905,31.085),(8.905,30.915),(8.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,30.915),(9.095,31.085),(9.265,31.085),(9.265,30.915),(9.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,30.915),(9.455,31.085),(9.625,31.085),(9.625,30.915),(9.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,31.275),(8.375,31.445),(8.545,31.445),(8.545,31.275),(8.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,31.275),(8.735,31.445),(8.905,31.445),(8.905,31.275),(8.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,31.275),(9.095,31.445),(9.265,31.445),(9.265,31.275),(9.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,31.275),(9.455,31.445),(9.625,31.445),(9.625,31.275),(9.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,31.635),(8.375,31.805),(8.545,31.805),(8.545,31.635),(8.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,31.635),(8.735,31.805),(8.905,31.805),(8.905,31.635),(8.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,31.635),(9.095,31.805),(9.265,31.805),(9.265,31.635),(9.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,31.635),(9.455,31.805),(9.625,31.805),(9.625,31.635),(9.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,31.995),(8.375,32.165),(8.545,32.165),(8.545,31.995),(8.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,31.995),(8.735,32.165),(8.905,32.165),(8.905,31.995),(8.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,31.995),(9.095,32.165),(9.265,32.165),(9.265,31.995),(9.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,31.995),(9.455,32.165),(9.625,32.165),(9.625,31.995),(9.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,32.355),(8.375,32.525),(8.545,32.525),(8.545,32.355),(8.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,32.355),(8.735,32.525),(8.905,32.525),(8.905,32.355),(8.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,32.355),(9.095,32.525),(9.265,32.525),(9.265,32.355),(9.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,32.355),(9.455,32.525),(9.625,32.525),(9.625,32.355),(9.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,32.715),(8.375,32.885),(8.545,32.885),(8.545,32.715),(8.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,32.715),(8.735,32.885),(8.905,32.885),(8.905,32.715),(8.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,32.715),(9.095,32.885),(9.265,32.885),(9.265,32.715),(9.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,32.715),(9.455,32.885),(9.625,32.885),(9.625,32.715),(9.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,33.075),(8.375,33.245),(8.545,33.245),(8.545,33.075),(8.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,33.075),(8.735,33.245),(8.905,33.245),(8.905,33.075),(8.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,33.075),(9.095,33.245),(9.265,33.245),(9.265,33.075),(9.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,33.075),(9.455,33.245),(9.625,33.245),(9.625,33.075),(9.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,33.435),(8.375,33.605),(8.545,33.605),(8.545,33.435),(8.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,33.435),(8.735,33.605),(8.905,33.605),(8.905,33.435),(8.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,33.435),(9.095,33.605),(9.265,33.605),(9.265,33.435),(9.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,33.435),(9.455,33.605),(9.625,33.605),(9.625,33.435),(9.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,33.795),(8.375,33.965),(8.545,33.965),(8.545,33.795),(8.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,33.795),(8.735,33.965),(8.905,33.965),(8.905,33.795),(8.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,33.795),(9.095,33.965),(9.265,33.965),(9.265,33.795),(9.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,33.795),(9.455,33.965),(9.625,33.965),(9.625,33.795),(9.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,34.155),(8.375,34.325),(8.545,34.325),(8.545,34.155),(8.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,34.155),(8.735,34.325),(8.905,34.325),(8.905,34.155),(8.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,34.155),(9.095,34.325),(9.265,34.325),(9.265,34.155),(9.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,34.155),(9.455,34.325),(9.625,34.325),(9.625,34.155),(9.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,34.515),(8.375,34.685),(8.545,34.685),(8.545,34.515),(8.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,34.515),(8.735,34.685),(8.905,34.685),(8.905,34.515),(8.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,34.515),(9.095,34.685),(9.265,34.685),(9.265,34.515),(9.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,34.515),(9.455,34.685),(9.625,34.685),(9.625,34.515),(9.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,34.875),(8.375,35.045),(8.545,35.045),(8.545,34.875),(8.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,34.875),(8.735,35.045),(8.905,35.045),(8.905,34.875),(8.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,34.875),(9.095,35.045),(9.265,35.045),(9.265,34.875),(9.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,34.875),(9.455,35.045),(9.625,35.045),(9.625,34.875),(9.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,35.235),(8.375,35.405),(8.545,35.405),(8.545,35.235),(8.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,35.235),(8.735,35.405),(8.905,35.405),(8.905,35.235),(8.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,35.235),(9.095,35.405),(9.265,35.405),(9.265,35.235),(9.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,35.235),(9.455,35.405),(9.625,35.405),(9.625,35.235),(9.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,35.595),(8.375,35.765),(8.545,35.765),(8.545,35.595),(8.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,35.595),(8.735,35.765),(8.905,35.765),(8.905,35.595),(8.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,35.595),(9.095,35.765),(9.265,35.765),(9.265,35.595),(9.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,35.595),(9.455,35.765),(9.625,35.765),(9.625,35.595),(9.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,35.955),(8.375,36.125),(8.545,36.125),(8.545,35.955),(8.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,35.955),(8.735,36.125),(8.905,36.125),(8.905,35.955),(8.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,35.955),(9.095,36.125),(9.265,36.125),(9.265,35.955),(9.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,35.955),(9.455,36.125),(9.625,36.125),(9.625,35.955),(9.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,36.315),(8.375,36.485),(8.545,36.485),(8.545,36.315),(8.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,36.315),(8.735,36.485),(8.905,36.485),(8.905,36.315),(8.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,36.315),(9.095,36.485),(9.265,36.485),(9.265,36.315),(9.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,36.315),(9.455,36.485),(9.625,36.485),(9.625,36.315),(9.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,36.675),(8.375,36.845),(8.545,36.845),(8.545,36.675),(8.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,36.675),(8.735,36.845),(8.905,36.845),(8.905,36.675),(8.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,36.675),(9.095,36.845),(9.265,36.845),(9.265,36.675),(9.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,36.675),(9.455,36.845),(9.625,36.845),(9.625,36.675),(9.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,37.035),(8.375,37.205),(8.545,37.205),(8.545,37.035),(8.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,37.035),(8.735,37.205),(8.905,37.205),(8.905,37.035),(8.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,37.035),(9.095,37.205),(9.265,37.205),(9.265,37.035),(9.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,37.035),(9.455,37.205),(9.625,37.205),(9.625,37.035),(9.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,37.395),(8.375,37.565),(8.545,37.565),(8.545,37.395),(8.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,37.395),(8.735,37.565),(8.905,37.565),(8.905,37.395),(8.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,37.395),(9.095,37.565),(9.265,37.565),(9.265,37.395),(9.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,37.395),(9.455,37.565),(9.625,37.565),(9.625,37.395),(9.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,37.755),(8.375,37.925),(8.545,37.925),(8.545,37.755),(8.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,37.755),(8.735,37.925),(8.905,37.925),(8.905,37.755),(8.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,37.755),(9.095,37.925),(9.265,37.925),(9.265,37.755),(9.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,37.755),(9.455,37.925),(9.625,37.925),(9.625,37.755),(9.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,38.115),(8.375,38.285),(8.545,38.285),(8.545,38.115),(8.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,38.115),(8.735,38.285),(8.905,38.285),(8.905,38.115),(8.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,38.115),(9.095,38.285),(9.265,38.285),(9.265,38.115),(9.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,38.115),(9.455,38.285),(9.625,38.285),(9.625,38.115),(9.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,38.475),(8.375,38.645),(8.545,38.645),(8.545,38.475),(8.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,38.475),(8.735,38.645),(8.905,38.645),(8.905,38.475),(8.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,38.475),(9.095,38.645),(9.265,38.645),(9.265,38.475),(9.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,38.475),(9.455,38.645),(9.625,38.645),(9.625,38.475),(9.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,38.835),(8.375,39.005),(8.545,39.005),(8.545,38.835),(8.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,38.835),(8.735,39.005),(8.905,39.005),(8.905,38.835),(8.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,38.835),(9.095,39.005),(9.265,39.005),(9.265,38.835),(9.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,38.835),(9.455,39.005),(9.625,39.005),(9.625,38.835),(9.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,39.195),(8.375,39.365),(8.545,39.365),(8.545,39.195),(8.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,39.195),(8.735,39.365),(8.905,39.365),(8.905,39.195),(8.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,39.195),(9.095,39.365),(9.265,39.365),(9.265,39.195),(9.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,39.195),(9.455,39.365),(9.625,39.365),(9.625,39.195),(9.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,39.555),(8.375,39.725),(8.545,39.725),(8.545,39.555),(8.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,39.555),(8.735,39.725),(8.905,39.725),(8.905,39.555),(8.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,39.555),(9.095,39.725),(9.265,39.725),(9.265,39.555),(9.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,39.555),(9.455,39.725),(9.625,39.725),(9.625,39.555),(9.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,39.915),(8.375,40.085),(8.545,40.085),(8.545,39.915),(8.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,39.915),(8.735,40.085),(8.905,40.085),(8.905,39.915),(8.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,39.915),(9.095,40.085),(9.265,40.085),(9.265,39.915),(9.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,39.915),(9.455,40.085),(9.625,40.085),(9.625,39.915),(9.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,40.275),(8.375,40.445),(8.545,40.445),(8.545,40.275),(8.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,40.275),(8.735,40.445),(8.905,40.445),(8.905,40.275),(8.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,40.275),(9.095,40.445),(9.265,40.445),(9.265,40.275),(9.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,40.275),(9.455,40.445),(9.625,40.445),(9.625,40.275),(9.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,40.635),(8.375,40.805),(8.545,40.805),(8.545,40.635),(8.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,40.635),(8.735,40.805),(8.905,40.805),(8.905,40.635),(8.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,40.635),(9.095,40.805),(9.265,40.805),(9.265,40.635),(9.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,40.635),(9.455,40.805),(9.625,40.805),(9.625,40.635),(9.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,2.835),(65.975,3.005),(66.145,3.005),(66.145,2.835),(65.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,2.835),(66.335,3.005),(66.505,3.005),(66.505,2.835),(66.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,2.835),(66.695,3.005),(66.865,3.005),(66.865,2.835),(66.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,2.835),(67.055,3.005),(67.225,3.005),(67.225,2.835),(67.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.195),(65.975,3.365),(66.145,3.365),(66.145,3.195),(65.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.195),(66.335,3.365),(66.505,3.365),(66.505,3.195),(66.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.195),(66.695,3.365),(66.865,3.365),(66.865,3.195),(66.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.195),(67.055,3.365),(67.225,3.365),(67.225,3.195),(67.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.555),(65.975,3.725),(66.145,3.725),(66.145,3.555),(65.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.555),(66.335,3.725),(66.505,3.725),(66.505,3.555),(66.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.555),(66.695,3.725),(66.865,3.725),(66.865,3.555),(66.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.555),(67.055,3.725),(67.225,3.725),(67.225,3.555),(67.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.915),(65.975,4.085),(66.145,4.085),(66.145,3.915),(65.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.915),(66.335,4.085),(66.505,4.085),(66.505,3.915),(66.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.915),(66.695,4.085),(66.865,4.085),(66.865,3.915),(66.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.915),(67.055,4.085),(67.225,4.085),(67.225,3.915),(67.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.275),(65.975,4.445),(66.145,4.445),(66.145,4.275),(65.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.275),(66.335,4.445),(66.505,4.445),(66.505,4.275),(66.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.275),(66.695,4.445),(66.865,4.445),(66.865,4.275),(66.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.275),(67.055,4.445),(67.225,4.445),(67.225,4.275),(67.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.635),(65.975,4.805),(66.145,4.805),(66.145,4.635),(65.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.635),(66.335,4.805),(66.505,4.805),(66.505,4.635),(66.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.635),(66.695,4.805),(66.865,4.805),(66.865,4.635),(66.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.635),(67.055,4.805),(67.225,4.805),(67.225,4.635),(67.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.995),(65.975,5.165),(66.145,5.165),(66.145,4.995),(65.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.995),(66.335,5.165),(66.505,5.165),(66.505,4.995),(66.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.995),(66.695,5.165),(66.865,5.165),(66.865,4.995),(66.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.995),(67.055,5.165),(67.225,5.165),(67.225,4.995),(67.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.355),(65.975,5.525),(66.145,5.525),(66.145,5.355),(65.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.355),(66.335,5.525),(66.505,5.525),(66.505,5.355),(66.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.355),(66.695,5.525),(66.865,5.525),(66.865,5.355),(66.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.355),(67.055,5.525),(67.225,5.525),(67.225,5.355),(67.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.715),(65.975,5.885),(66.145,5.885),(66.145,5.715),(65.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.715),(66.335,5.885),(66.505,5.885),(66.505,5.715),(66.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.715),(66.695,5.885),(66.865,5.885),(66.865,5.715),(66.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.715),(67.055,5.885),(67.225,5.885),(67.225,5.715),(67.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.075),(65.975,6.245),(66.145,6.245),(66.145,6.075),(65.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.075),(66.335,6.245),(66.505,6.245),(66.505,6.075),(66.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.075),(66.695,6.245),(66.865,6.245),(66.865,6.075),(66.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.075),(67.055,6.245),(67.225,6.245),(67.225,6.075),(67.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.435),(65.975,6.605),(66.145,6.605),(66.145,6.435),(65.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.435),(66.335,6.605),(66.505,6.605),(66.505,6.435),(66.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.435),(66.695,6.605),(66.865,6.605),(66.865,6.435),(66.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.435),(67.055,6.605),(67.225,6.605),(67.225,6.435),(67.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.795),(65.975,6.965),(66.145,6.965),(66.145,6.795),(65.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.795),(66.335,6.965),(66.505,6.965),(66.505,6.795),(66.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.795),(66.695,6.965),(66.865,6.965),(66.865,6.795),(66.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.795),(67.055,6.965),(67.225,6.965),(67.225,6.795),(67.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.155),(65.975,7.325),(66.145,7.325),(66.145,7.155),(65.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.155),(66.335,7.325),(66.505,7.325),(66.505,7.155),(66.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.155),(66.695,7.325),(66.865,7.325),(66.865,7.155),(66.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.155),(67.055,7.325),(67.225,7.325),(67.225,7.155),(67.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.515),(65.975,7.685),(66.145,7.685),(66.145,7.515),(65.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.515),(66.335,7.685),(66.505,7.685),(66.505,7.515),(66.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.515),(66.695,7.685),(66.865,7.685),(66.865,7.515),(66.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.515),(67.055,7.685),(67.225,7.685),(67.225,7.515),(67.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.875),(65.975,8.045),(66.145,8.045),(66.145,7.875),(65.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.875),(66.335,8.045),(66.505,8.045),(66.505,7.875),(66.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.875),(66.695,8.045),(66.865,8.045),(66.865,7.875),(66.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.875),(67.055,8.045),(67.225,8.045),(67.225,7.875),(67.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.235),(65.975,8.405),(66.145,8.405),(66.145,8.235),(65.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.235),(66.335,8.405),(66.505,8.405),(66.505,8.235),(66.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.235),(66.695,8.405),(66.865,8.405),(66.865,8.235),(66.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.235),(67.055,8.405),(67.225,8.405),(67.225,8.235),(67.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.595),(65.975,8.765),(66.145,8.765),(66.145,8.595),(65.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.595),(66.335,8.765),(66.505,8.765),(66.505,8.595),(66.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.595),(66.695,8.765),(66.865,8.765),(66.865,8.595),(66.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.595),(67.055,8.765),(67.225,8.765),(67.225,8.595),(67.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.955),(65.975,9.125),(66.145,9.125),(66.145,8.955),(65.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.955),(66.335,9.125),(66.505,9.125),(66.505,8.955),(66.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.955),(66.695,9.125),(66.865,9.125),(66.865,8.955),(66.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.955),(67.055,9.125),(67.225,9.125),(67.225,8.955),(67.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.315),(65.975,9.485),(66.145,9.485),(66.145,9.315),(65.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.315),(66.335,9.485),(66.505,9.485),(66.505,9.315),(66.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.315),(66.695,9.485),(66.865,9.485),(66.865,9.315),(66.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.315),(67.055,9.485),(67.225,9.485),(67.225,9.315),(67.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.675),(65.975,9.845),(66.145,9.845),(66.145,9.675),(65.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.675),(66.335,9.845),(66.505,9.845),(66.505,9.675),(66.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.675),(66.695,9.845),(66.865,9.845),(66.865,9.675),(66.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.675),(67.055,9.845),(67.225,9.845),(67.225,9.675),(67.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.035),(65.975,10.205),(66.145,10.205),(66.145,10.035),(65.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.035),(66.335,10.205),(66.505,10.205),(66.505,10.035),(66.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.035),(66.695,10.205),(66.865,10.205),(66.865,10.035),(66.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.035),(67.055,10.205),(67.225,10.205),(67.225,10.035),(67.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.395),(65.975,10.565),(66.145,10.565),(66.145,10.395),(65.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.395),(66.335,10.565),(66.505,10.565),(66.505,10.395),(66.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.395),(66.695,10.565),(66.865,10.565),(66.865,10.395),(66.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.395),(67.055,10.565),(67.225,10.565),(67.225,10.395),(67.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.755),(65.975,10.925),(66.145,10.925),(66.145,10.755),(65.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.755),(66.335,10.925),(66.505,10.925),(66.505,10.755),(66.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.755),(66.695,10.925),(66.865,10.925),(66.865,10.755),(66.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.755),(67.055,10.925),(67.225,10.925),(67.225,10.755),(67.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.115),(65.975,11.285),(66.145,11.285),(66.145,11.115),(65.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.115),(66.335,11.285),(66.505,11.285),(66.505,11.115),(66.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.115),(66.695,11.285),(66.865,11.285),(66.865,11.115),(66.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.115),(67.055,11.285),(67.225,11.285),(67.225,11.115),(67.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.475),(65.975,11.645),(66.145,11.645),(66.145,11.475),(65.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.475),(66.335,11.645),(66.505,11.645),(66.505,11.475),(66.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.475),(66.695,11.645),(66.865,11.645),(66.865,11.475),(66.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.475),(67.055,11.645),(67.225,11.645),(67.225,11.475),(67.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.835),(65.975,12.005),(66.145,12.005),(66.145,11.835),(65.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.835),(66.335,12.005),(66.505,12.005),(66.505,11.835),(66.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.835),(66.695,12.005),(66.865,12.005),(66.865,11.835),(66.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.835),(67.055,12.005),(67.225,12.005),(67.225,11.835),(67.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.195),(65.975,12.365),(66.145,12.365),(66.145,12.195),(65.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.195),(66.335,12.365),(66.505,12.365),(66.505,12.195),(66.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.195),(66.695,12.365),(66.865,12.365),(66.865,12.195),(66.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.195),(67.055,12.365),(67.225,12.365),(67.225,12.195),(67.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.555),(65.975,12.725),(66.145,12.725),(66.145,12.555),(65.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.555),(66.335,12.725),(66.505,12.725),(66.505,12.555),(66.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.555),(66.695,12.725),(66.865,12.725),(66.865,12.555),(66.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.555),(67.055,12.725),(67.225,12.725),(67.225,12.555),(67.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.915),(65.975,13.085),(66.145,13.085),(66.145,12.915),(65.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.915),(66.335,13.085),(66.505,13.085),(66.505,12.915),(66.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.915),(66.695,13.085),(66.865,13.085),(66.865,12.915),(66.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.915),(67.055,13.085),(67.225,13.085),(67.225,12.915),(67.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.275),(65.975,13.445),(66.145,13.445),(66.145,13.275),(65.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.275),(66.335,13.445),(66.505,13.445),(66.505,13.275),(66.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.275),(66.695,13.445),(66.865,13.445),(66.865,13.275),(66.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.275),(67.055,13.445),(67.225,13.445),(67.225,13.275),(67.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.635),(65.975,13.805),(66.145,13.805),(66.145,13.635),(65.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.635),(66.335,13.805),(66.505,13.805),(66.505,13.635),(66.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.635),(66.695,13.805),(66.865,13.805),(66.865,13.635),(66.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.635),(67.055,13.805),(67.225,13.805),(67.225,13.635),(67.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.995),(65.975,14.165),(66.145,14.165),(66.145,13.995),(65.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.995),(66.335,14.165),(66.505,14.165),(66.505,13.995),(66.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.995),(66.695,14.165),(66.865,14.165),(66.865,13.995),(66.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.995),(67.055,14.165),(67.225,14.165),(67.225,13.995),(67.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.355),(65.975,14.525),(66.145,14.525),(66.145,14.355),(65.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.355),(66.335,14.525),(66.505,14.525),(66.505,14.355),(66.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.355),(66.695,14.525),(66.865,14.525),(66.865,14.355),(66.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.355),(67.055,14.525),(67.225,14.525),(67.225,14.355),(67.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.715),(65.975,14.885),(66.145,14.885),(66.145,14.715),(65.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.715),(66.335,14.885),(66.505,14.885),(66.505,14.715),(66.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.715),(66.695,14.885),(66.865,14.885),(66.865,14.715),(66.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.715),(67.055,14.885),(67.225,14.885),(67.225,14.715),(67.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.075),(65.975,15.245),(66.145,15.245),(66.145,15.075),(65.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.075),(66.335,15.245),(66.505,15.245),(66.505,15.075),(66.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.075),(66.695,15.245),(66.865,15.245),(66.865,15.075),(66.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.075),(67.055,15.245),(67.225,15.245),(67.225,15.075),(67.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.435),(65.975,15.605),(66.145,15.605),(66.145,15.435),(65.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.435),(66.335,15.605),(66.505,15.605),(66.505,15.435),(66.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.435),(66.695,15.605),(66.865,15.605),(66.865,15.435),(66.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.435),(67.055,15.605),(67.225,15.605),(67.225,15.435),(67.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.795),(65.975,15.965),(66.145,15.965),(66.145,15.795),(65.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.795),(66.335,15.965),(66.505,15.965),(66.505,15.795),(66.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.795),(66.695,15.965),(66.865,15.965),(66.865,15.795),(66.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.795),(67.055,15.965),(67.225,15.965),(67.225,15.795),(67.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.155),(65.975,16.325),(66.145,16.325),(66.145,16.155),(65.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.155),(66.335,16.325),(66.505,16.325),(66.505,16.155),(66.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.155),(66.695,16.325),(66.865,16.325),(66.865,16.155),(66.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.155),(67.055,16.325),(67.225,16.325),(67.225,16.155),(67.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.515),(65.975,16.685),(66.145,16.685),(66.145,16.515),(65.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.515),(66.335,16.685),(66.505,16.685),(66.505,16.515),(66.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.515),(66.695,16.685),(66.865,16.685),(66.865,16.515),(66.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.515),(67.055,16.685),(67.225,16.685),(67.225,16.515),(67.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.875),(65.975,17.045),(66.145,17.045),(66.145,16.875),(65.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.875),(66.335,17.045),(66.505,17.045),(66.505,16.875),(66.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.875),(66.695,17.045),(66.865,17.045),(66.865,16.875),(66.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.875),(67.055,17.045),(67.225,17.045),(67.225,16.875),(67.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.235),(65.975,17.405),(66.145,17.405),(66.145,17.235),(65.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.235),(66.335,17.405),(66.505,17.405),(66.505,17.235),(66.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.235),(66.695,17.405),(66.865,17.405),(66.865,17.235),(66.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.235),(67.055,17.405),(67.225,17.405),(67.225,17.235),(67.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.595),(65.975,17.765),(66.145,17.765),(66.145,17.595),(65.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.595),(66.335,17.765),(66.505,17.765),(66.505,17.595),(66.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.595),(66.695,17.765),(66.865,17.765),(66.865,17.595),(66.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.595),(67.055,17.765),(67.225,17.765),(67.225,17.595),(67.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.955),(65.975,18.125),(66.145,18.125),(66.145,17.955),(65.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.955),(66.335,18.125),(66.505,18.125),(66.505,17.955),(66.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.955),(66.695,18.125),(66.865,18.125),(66.865,17.955),(66.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.955),(67.055,18.125),(67.225,18.125),(67.225,17.955),(67.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.315),(65.975,18.485),(66.145,18.485),(66.145,18.315),(65.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.315),(66.335,18.485),(66.505,18.485),(66.505,18.315),(66.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.315),(66.695,18.485),(66.865,18.485),(66.865,18.315),(66.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.315),(67.055,18.485),(67.225,18.485),(67.225,18.315),(67.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.675),(65.975,18.845),(66.145,18.845),(66.145,18.675),(65.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.675),(66.335,18.845),(66.505,18.845),(66.505,18.675),(66.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.675),(66.695,18.845),(66.865,18.845),(66.865,18.675),(66.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.675),(67.055,18.845),(67.225,18.845),(67.225,18.675),(67.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.035),(65.975,19.205),(66.145,19.205),(66.145,19.035),(65.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.035),(66.335,19.205),(66.505,19.205),(66.505,19.035),(66.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.035),(66.695,19.205),(66.865,19.205),(66.865,19.035),(66.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.035),(67.055,19.205),(67.225,19.205),(67.225,19.035),(67.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.395),(65.975,19.565),(66.145,19.565),(66.145,19.395),(65.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.395),(66.335,19.565),(66.505,19.565),(66.505,19.395),(66.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.395),(66.695,19.565),(66.865,19.565),(66.865,19.395),(66.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.395),(67.055,19.565),(67.225,19.565),(67.225,19.395),(67.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.755),(65.975,19.925),(66.145,19.925),(66.145,19.755),(65.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.755),(66.335,19.925),(66.505,19.925),(66.505,19.755),(66.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.755),(66.695,19.925),(66.865,19.925),(66.865,19.755),(66.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.755),(67.055,19.925),(67.225,19.925),(67.225,19.755),(67.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,20.115),(65.975,20.285),(66.145,20.285),(66.145,20.115),(65.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,20.115),(66.335,20.285),(66.505,20.285),(66.505,20.115),(66.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,20.115),(66.695,20.285),(66.865,20.285),(66.865,20.115),(66.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,20.115),(67.055,20.285),(67.225,20.285),(67.225,20.115),(67.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,20.475),(65.975,20.645),(66.145,20.645),(66.145,20.475),(65.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,20.475),(66.335,20.645),(66.505,20.645),(66.505,20.475),(66.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,20.475),(66.695,20.645),(66.865,20.645),(66.865,20.475),(66.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,20.475),(67.055,20.645),(67.225,20.645),(67.225,20.475),(67.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,20.835),(65.975,21.005),(66.145,21.005),(66.145,20.835),(65.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,20.835),(66.335,21.005),(66.505,21.005),(66.505,20.835),(66.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,20.835),(66.695,21.005),(66.865,21.005),(66.865,20.835),(66.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,20.835),(67.055,21.005),(67.225,21.005),(67.225,20.835),(67.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,21.195),(65.975,21.365),(66.145,21.365),(66.145,21.195),(65.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,21.195),(66.335,21.365),(66.505,21.365),(66.505,21.195),(66.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,21.195),(66.695,21.365),(66.865,21.365),(66.865,21.195),(66.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,21.195),(67.055,21.365),(67.225,21.365),(67.225,21.195),(67.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,21.555),(65.975,21.725),(66.145,21.725),(66.145,21.555),(65.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,21.555),(66.335,21.725),(66.505,21.725),(66.505,21.555),(66.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,21.555),(66.695,21.725),(66.865,21.725),(66.865,21.555),(66.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,21.555),(67.055,21.725),(67.225,21.725),(67.225,21.555),(67.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,21.915),(65.975,22.085),(66.145,22.085),(66.145,21.915),(65.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,21.915),(66.335,22.085),(66.505,22.085),(66.505,21.915),(66.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,21.915),(66.695,22.085),(66.865,22.085),(66.865,21.915),(66.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,21.915),(67.055,22.085),(67.225,22.085),(67.225,21.915),(67.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.275),(65.975,22.445),(66.145,22.445),(66.145,22.275),(65.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.275),(66.335,22.445),(66.505,22.445),(66.505,22.275),(66.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.275),(66.695,22.445),(66.865,22.445),(66.865,22.275),(66.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.275),(67.055,22.445),(67.225,22.445),(67.225,22.275),(67.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.635),(65.975,22.805),(66.145,22.805),(66.145,22.635),(65.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.635),(66.335,22.805),(66.505,22.805),(66.505,22.635),(66.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.635),(66.695,22.805),(66.865,22.805),(66.865,22.635),(66.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.635),(67.055,22.805),(67.225,22.805),(67.225,22.635),(67.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.995),(65.975,23.165),(66.145,23.165),(66.145,22.995),(65.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.995),(66.335,23.165),(66.505,23.165),(66.505,22.995),(66.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.995),(66.695,23.165),(66.865,23.165),(66.865,22.995),(66.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.995),(67.055,23.165),(67.225,23.165),(67.225,22.995),(67.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,23.355),(65.975,23.525),(66.145,23.525),(66.145,23.355),(65.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,23.355),(66.335,23.525),(66.505,23.525),(66.505,23.355),(66.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,23.355),(66.695,23.525),(66.865,23.525),(66.865,23.355),(66.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,23.355),(67.055,23.525),(67.225,23.525),(67.225,23.355),(67.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,23.715),(65.975,23.885),(66.145,23.885),(66.145,23.715),(65.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,23.715),(66.335,23.885),(66.505,23.885),(66.505,23.715),(66.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,23.715),(66.695,23.885),(66.865,23.885),(66.865,23.715),(66.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,23.715),(67.055,23.885),(67.225,23.885),(67.225,23.715),(67.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,24.075),(65.975,24.245),(66.145,24.245),(66.145,24.075),(65.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,24.075),(66.335,24.245),(66.505,24.245),(66.505,24.075),(66.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,24.075),(66.695,24.245),(66.865,24.245),(66.865,24.075),(66.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,24.075),(67.055,24.245),(67.225,24.245),(67.225,24.075),(67.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,24.435),(65.975,24.605),(66.145,24.605),(66.145,24.435),(65.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,24.435),(66.335,24.605),(66.505,24.605),(66.505,24.435),(66.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,24.435),(66.695,24.605),(66.865,24.605),(66.865,24.435),(66.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,24.435),(67.055,24.605),(67.225,24.605),(67.225,24.435),(67.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,24.795),(65.975,24.965),(66.145,24.965),(66.145,24.795),(65.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,24.795),(66.335,24.965),(66.505,24.965),(66.505,24.795),(66.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,24.795),(66.695,24.965),(66.865,24.965),(66.865,24.795),(66.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,24.795),(67.055,24.965),(67.225,24.965),(67.225,24.795),(67.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,25.155),(65.975,25.325),(66.145,25.325),(66.145,25.155),(65.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,25.155),(66.335,25.325),(66.505,25.325),(66.505,25.155),(66.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,25.155),(66.695,25.325),(66.865,25.325),(66.865,25.155),(66.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,25.155),(67.055,25.325),(67.225,25.325),(67.225,25.155),(67.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,25.515),(65.975,25.685),(66.145,25.685),(66.145,25.515),(65.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,25.515),(66.335,25.685),(66.505,25.685),(66.505,25.515),(66.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,25.515),(66.695,25.685),(66.865,25.685),(66.865,25.515),(66.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,25.515),(67.055,25.685),(67.225,25.685),(67.225,25.515),(67.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,25.875),(65.975,26.045),(66.145,26.045),(66.145,25.875),(65.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,25.875),(66.335,26.045),(66.505,26.045),(66.505,25.875),(66.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,25.875),(66.695,26.045),(66.865,26.045),(66.865,25.875),(66.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,25.875),(67.055,26.045),(67.225,26.045),(67.225,25.875),(67.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,26.235),(65.975,26.405),(66.145,26.405),(66.145,26.235),(65.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,26.235),(66.335,26.405),(66.505,26.405),(66.505,26.235),(66.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,26.235),(66.695,26.405),(66.865,26.405),(66.865,26.235),(66.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,26.235),(67.055,26.405),(67.225,26.405),(67.225,26.235),(67.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,26.595),(65.975,26.765),(66.145,26.765),(66.145,26.595),(65.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,26.595),(66.335,26.765),(66.505,26.765),(66.505,26.595),(66.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,26.595),(66.695,26.765),(66.865,26.765),(66.865,26.595),(66.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,26.595),(67.055,26.765),(67.225,26.765),(67.225,26.595),(67.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,26.955),(65.975,27.125),(66.145,27.125),(66.145,26.955),(65.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,26.955),(66.335,27.125),(66.505,27.125),(66.505,26.955),(66.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,26.955),(66.695,27.125),(66.865,27.125),(66.865,26.955),(66.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,26.955),(67.055,27.125),(67.225,27.125),(67.225,26.955),(67.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,27.315),(65.975,27.485),(66.145,27.485),(66.145,27.315),(65.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,27.315),(66.335,27.485),(66.505,27.485),(66.505,27.315),(66.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,27.315),(66.695,27.485),(66.865,27.485),(66.865,27.315),(66.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,27.315),(67.055,27.485),(67.225,27.485),(67.225,27.315),(67.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,27.675),(65.975,27.845),(66.145,27.845),(66.145,27.675),(65.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,27.675),(66.335,27.845),(66.505,27.845),(66.505,27.675),(66.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,27.675),(66.695,27.845),(66.865,27.845),(66.865,27.675),(66.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,27.675),(67.055,27.845),(67.225,27.845),(67.225,27.675),(67.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,28.035),(65.975,28.205),(66.145,28.205),(66.145,28.035),(65.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,28.035),(66.335,28.205),(66.505,28.205),(66.505,28.035),(66.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,28.035),(66.695,28.205),(66.865,28.205),(66.865,28.035),(66.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,28.035),(67.055,28.205),(67.225,28.205),(67.225,28.035),(67.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,28.395),(65.975,28.565),(66.145,28.565),(66.145,28.395),(65.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,28.395),(66.335,28.565),(66.505,28.565),(66.505,28.395),(66.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,28.395),(66.695,28.565),(66.865,28.565),(66.865,28.395),(66.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,28.395),(67.055,28.565),(67.225,28.565),(67.225,28.395),(67.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,28.755),(65.975,28.925),(66.145,28.925),(66.145,28.755),(65.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,28.755),(66.335,28.925),(66.505,28.925),(66.505,28.755),(66.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,28.755),(66.695,28.925),(66.865,28.925),(66.865,28.755),(66.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,28.755),(67.055,28.925),(67.225,28.925),(67.225,28.755),(67.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,29.115),(65.975,29.285),(66.145,29.285),(66.145,29.115),(65.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,29.115),(66.335,29.285),(66.505,29.285),(66.505,29.115),(66.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,29.115),(66.695,29.285),(66.865,29.285),(66.865,29.115),(66.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,29.115),(67.055,29.285),(67.225,29.285),(67.225,29.115),(67.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,29.475),(65.975,29.645),(66.145,29.645),(66.145,29.475),(65.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,29.475),(66.335,29.645),(66.505,29.645),(66.505,29.475),(66.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,29.475),(66.695,29.645),(66.865,29.645),(66.865,29.475),(66.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,29.475),(67.055,29.645),(67.225,29.645),(67.225,29.475),(67.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,29.835),(65.975,30.005),(66.145,30.005),(66.145,29.835),(65.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,29.835),(66.335,30.005),(66.505,30.005),(66.505,29.835),(66.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,29.835),(66.695,30.005),(66.865,30.005),(66.865,29.835),(66.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,29.835),(67.055,30.005),(67.225,30.005),(67.225,29.835),(67.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,30.195),(65.975,30.365),(66.145,30.365),(66.145,30.195),(65.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,30.195),(66.335,30.365),(66.505,30.365),(66.505,30.195),(66.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,30.195),(66.695,30.365),(66.865,30.365),(66.865,30.195),(66.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,30.195),(67.055,30.365),(67.225,30.365),(67.225,30.195),(67.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,30.555),(65.975,30.725),(66.145,30.725),(66.145,30.555),(65.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,30.555),(66.335,30.725),(66.505,30.725),(66.505,30.555),(66.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,30.555),(66.695,30.725),(66.865,30.725),(66.865,30.555),(66.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,30.555),(67.055,30.725),(67.225,30.725),(67.225,30.555),(67.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,30.915),(65.975,31.085),(66.145,31.085),(66.145,30.915),(65.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,30.915),(66.335,31.085),(66.505,31.085),(66.505,30.915),(66.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,30.915),(66.695,31.085),(66.865,31.085),(66.865,30.915),(66.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,30.915),(67.055,31.085),(67.225,31.085),(67.225,30.915),(67.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,31.275),(65.975,31.445),(66.145,31.445),(66.145,31.275),(65.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,31.275),(66.335,31.445),(66.505,31.445),(66.505,31.275),(66.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,31.275),(66.695,31.445),(66.865,31.445),(66.865,31.275),(66.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,31.275),(67.055,31.445),(67.225,31.445),(67.225,31.275),(67.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,31.635),(65.975,31.805),(66.145,31.805),(66.145,31.635),(65.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,31.635),(66.335,31.805),(66.505,31.805),(66.505,31.635),(66.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,31.635),(66.695,31.805),(66.865,31.805),(66.865,31.635),(66.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,31.635),(67.055,31.805),(67.225,31.805),(67.225,31.635),(67.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,31.995),(65.975,32.165),(66.145,32.165),(66.145,31.995),(65.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,31.995),(66.335,32.165),(66.505,32.165),(66.505,31.995),(66.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,31.995),(66.695,32.165),(66.865,32.165),(66.865,31.995),(66.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,31.995),(67.055,32.165),(67.225,32.165),(67.225,31.995),(67.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,32.355),(65.975,32.525),(66.145,32.525),(66.145,32.355),(65.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,32.355),(66.335,32.525),(66.505,32.525),(66.505,32.355),(66.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,32.355),(66.695,32.525),(66.865,32.525),(66.865,32.355),(66.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,32.355),(67.055,32.525),(67.225,32.525),(67.225,32.355),(67.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,32.715),(65.975,32.885),(66.145,32.885),(66.145,32.715),(65.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,32.715),(66.335,32.885),(66.505,32.885),(66.505,32.715),(66.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,32.715),(66.695,32.885),(66.865,32.885),(66.865,32.715),(66.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,32.715),(67.055,32.885),(67.225,32.885),(67.225,32.715),(67.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,33.075),(65.975,33.245),(66.145,33.245),(66.145,33.075),(65.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,33.075),(66.335,33.245),(66.505,33.245),(66.505,33.075),(66.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,33.075),(66.695,33.245),(66.865,33.245),(66.865,33.075),(66.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,33.075),(67.055,33.245),(67.225,33.245),(67.225,33.075),(67.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,33.435),(65.975,33.605),(66.145,33.605),(66.145,33.435),(65.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,33.435),(66.335,33.605),(66.505,33.605),(66.505,33.435),(66.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,33.435),(66.695,33.605),(66.865,33.605),(66.865,33.435),(66.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,33.435),(67.055,33.605),(67.225,33.605),(67.225,33.435),(67.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,33.795),(65.975,33.965),(66.145,33.965),(66.145,33.795),(65.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,33.795),(66.335,33.965),(66.505,33.965),(66.505,33.795),(66.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,33.795),(66.695,33.965),(66.865,33.965),(66.865,33.795),(66.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,33.795),(67.055,33.965),(67.225,33.965),(67.225,33.795),(67.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,34.155),(65.975,34.325),(66.145,34.325),(66.145,34.155),(65.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,34.155),(66.335,34.325),(66.505,34.325),(66.505,34.155),(66.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,34.155),(66.695,34.325),(66.865,34.325),(66.865,34.155),(66.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,34.155),(67.055,34.325),(67.225,34.325),(67.225,34.155),(67.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,34.515),(65.975,34.685),(66.145,34.685),(66.145,34.515),(65.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,34.515),(66.335,34.685),(66.505,34.685),(66.505,34.515),(66.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,34.515),(66.695,34.685),(66.865,34.685),(66.865,34.515),(66.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,34.515),(67.055,34.685),(67.225,34.685),(67.225,34.515),(67.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,34.875),(65.975,35.045),(66.145,35.045),(66.145,34.875),(65.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,34.875),(66.335,35.045),(66.505,35.045),(66.505,34.875),(66.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,34.875),(66.695,35.045),(66.865,35.045),(66.865,34.875),(66.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,34.875),(67.055,35.045),(67.225,35.045),(67.225,34.875),(67.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,35.235),(65.975,35.405),(66.145,35.405),(66.145,35.235),(65.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,35.235),(66.335,35.405),(66.505,35.405),(66.505,35.235),(66.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,35.235),(66.695,35.405),(66.865,35.405),(66.865,35.235),(66.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,35.235),(67.055,35.405),(67.225,35.405),(67.225,35.235),(67.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,35.595),(65.975,35.765),(66.145,35.765),(66.145,35.595),(65.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,35.595),(66.335,35.765),(66.505,35.765),(66.505,35.595),(66.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,35.595),(66.695,35.765),(66.865,35.765),(66.865,35.595),(66.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,35.595),(67.055,35.765),(67.225,35.765),(67.225,35.595),(67.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,35.955),(65.975,36.125),(66.145,36.125),(66.145,35.955),(65.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,35.955),(66.335,36.125),(66.505,36.125),(66.505,35.955),(66.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,35.955),(66.695,36.125),(66.865,36.125),(66.865,35.955),(66.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,35.955),(67.055,36.125),(67.225,36.125),(67.225,35.955),(67.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,36.315),(65.975,36.485),(66.145,36.485),(66.145,36.315),(65.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,36.315),(66.335,36.485),(66.505,36.485),(66.505,36.315),(66.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,36.315),(66.695,36.485),(66.865,36.485),(66.865,36.315),(66.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,36.315),(67.055,36.485),(67.225,36.485),(67.225,36.315),(67.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,36.675),(65.975,36.845),(66.145,36.845),(66.145,36.675),(65.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,36.675),(66.335,36.845),(66.505,36.845),(66.505,36.675),(66.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,36.675),(66.695,36.845),(66.865,36.845),(66.865,36.675),(66.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,36.675),(67.055,36.845),(67.225,36.845),(67.225,36.675),(67.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,37.035),(65.975,37.205),(66.145,37.205),(66.145,37.035),(65.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,37.035),(66.335,37.205),(66.505,37.205),(66.505,37.035),(66.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,37.035),(66.695,37.205),(66.865,37.205),(66.865,37.035),(66.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,37.035),(67.055,37.205),(67.225,37.205),(67.225,37.035),(67.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,37.395),(65.975,37.565),(66.145,37.565),(66.145,37.395),(65.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,37.395),(66.335,37.565),(66.505,37.565),(66.505,37.395),(66.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,37.395),(66.695,37.565),(66.865,37.565),(66.865,37.395),(66.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,37.395),(67.055,37.565),(67.225,37.565),(67.225,37.395),(67.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,37.755),(65.975,37.925),(66.145,37.925),(66.145,37.755),(65.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,37.755),(66.335,37.925),(66.505,37.925),(66.505,37.755),(66.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,37.755),(66.695,37.925),(66.865,37.925),(66.865,37.755),(66.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,37.755),(67.055,37.925),(67.225,37.925),(67.225,37.755),(67.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,38.115),(65.975,38.285),(66.145,38.285),(66.145,38.115),(65.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,38.115),(66.335,38.285),(66.505,38.285),(66.505,38.115),(66.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,38.115),(66.695,38.285),(66.865,38.285),(66.865,38.115),(66.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,38.115),(67.055,38.285),(67.225,38.285),(67.225,38.115),(67.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,38.475),(65.975,38.645),(66.145,38.645),(66.145,38.475),(65.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,38.475),(66.335,38.645),(66.505,38.645),(66.505,38.475),(66.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,38.475),(66.695,38.645),(66.865,38.645),(66.865,38.475),(66.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,38.475),(67.055,38.645),(67.225,38.645),(67.225,38.475),(67.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,38.835),(65.975,39.005),(66.145,39.005),(66.145,38.835),(65.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,38.835),(66.335,39.005),(66.505,39.005),(66.505,38.835),(66.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,38.835),(66.695,39.005),(66.865,39.005),(66.865,38.835),(66.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,38.835),(67.055,39.005),(67.225,39.005),(67.225,38.835),(67.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,39.195),(65.975,39.365),(66.145,39.365),(66.145,39.195),(65.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,39.195),(66.335,39.365),(66.505,39.365),(66.505,39.195),(66.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,39.195),(66.695,39.365),(66.865,39.365),(66.865,39.195),(66.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,39.195),(67.055,39.365),(67.225,39.365),(67.225,39.195),(67.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,39.555),(65.975,39.725),(66.145,39.725),(66.145,39.555),(65.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,39.555),(66.335,39.725),(66.505,39.725),(66.505,39.555),(66.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,39.555),(66.695,39.725),(66.865,39.725),(66.865,39.555),(66.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,39.555),(67.055,39.725),(67.225,39.725),(67.225,39.555),(67.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,39.915),(65.975,40.085),(66.145,40.085),(66.145,39.915),(65.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,39.915),(66.335,40.085),(66.505,40.085),(66.505,39.915),(66.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,39.915),(66.695,40.085),(66.865,40.085),(66.865,39.915),(66.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,39.915),(67.055,40.085),(67.225,40.085),(67.225,39.915),(67.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,40.275),(65.975,40.445),(66.145,40.445),(66.145,40.275),(65.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,40.275),(66.335,40.445),(66.505,40.445),(66.505,40.275),(66.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,40.275),(66.695,40.445),(66.865,40.445),(66.865,40.275),(66.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,40.275),(67.055,40.445),(67.225,40.445),(67.225,40.275),(67.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,40.635),(65.975,40.805),(66.145,40.805),(66.145,40.635),(65.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,40.635),(66.335,40.805),(66.505,40.805),(66.505,40.635),(66.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,40.635),(66.695,40.805),(66.865,40.805),(66.865,40.635),(66.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,40.635),(67.055,40.805),(67.225,40.805),(67.225,40.635),(67.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.835),(51.575,3.005),(51.745,3.005),(51.745,2.835),(51.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.835),(51.935,3.005),(52.105,3.005),(52.105,2.835),(51.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.835),(52.295,3.005),(52.465,3.005),(52.465,2.835),(52.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.835),(52.655,3.005),(52.825,3.005),(52.825,2.835),(52.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.195),(51.575,3.365),(51.745,3.365),(51.745,3.195),(51.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.195),(51.935,3.365),(52.105,3.365),(52.105,3.195),(51.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.195),(52.295,3.365),(52.465,3.365),(52.465,3.195),(52.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.195),(52.655,3.365),(52.825,3.365),(52.825,3.195),(52.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.555),(51.575,3.725),(51.745,3.725),(51.745,3.555),(51.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.555),(51.935,3.725),(52.105,3.725),(52.105,3.555),(51.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.555),(52.295,3.725),(52.465,3.725),(52.465,3.555),(52.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.555),(52.655,3.725),(52.825,3.725),(52.825,3.555),(52.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.915),(51.575,4.085),(51.745,4.085),(51.745,3.915),(51.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.915),(51.935,4.085),(52.105,4.085),(52.105,3.915),(51.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.915),(52.295,4.085),(52.465,4.085),(52.465,3.915),(52.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.915),(52.655,4.085),(52.825,4.085),(52.825,3.915),(52.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.275),(51.575,4.445),(51.745,4.445),(51.745,4.275),(51.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.275),(51.935,4.445),(52.105,4.445),(52.105,4.275),(51.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.275),(52.295,4.445),(52.465,4.445),(52.465,4.275),(52.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.275),(52.655,4.445),(52.825,4.445),(52.825,4.275),(52.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.635),(51.575,4.805),(51.745,4.805),(51.745,4.635),(51.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.635),(51.935,4.805),(52.105,4.805),(52.105,4.635),(51.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.635),(52.295,4.805),(52.465,4.805),(52.465,4.635),(52.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.635),(52.655,4.805),(52.825,4.805),(52.825,4.635),(52.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.995),(51.575,5.165),(51.745,5.165),(51.745,4.995),(51.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.995),(51.935,5.165),(52.105,5.165),(52.105,4.995),(51.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.995),(52.295,5.165),(52.465,5.165),(52.465,4.995),(52.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.995),(52.655,5.165),(52.825,5.165),(52.825,4.995),(52.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.355),(51.575,5.525),(51.745,5.525),(51.745,5.355),(51.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.355),(51.935,5.525),(52.105,5.525),(52.105,5.355),(51.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.355),(52.295,5.525),(52.465,5.525),(52.465,5.355),(52.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.355),(52.655,5.525),(52.825,5.525),(52.825,5.355),(52.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.715),(51.575,5.885),(51.745,5.885),(51.745,5.715),(51.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.715),(51.935,5.885),(52.105,5.885),(52.105,5.715),(51.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.715),(52.295,5.885),(52.465,5.885),(52.465,5.715),(52.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.715),(52.655,5.885),(52.825,5.885),(52.825,5.715),(52.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.075),(51.575,6.245),(51.745,6.245),(51.745,6.075),(51.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.075),(51.935,6.245),(52.105,6.245),(52.105,6.075),(51.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.075),(52.295,6.245),(52.465,6.245),(52.465,6.075),(52.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.075),(52.655,6.245),(52.825,6.245),(52.825,6.075),(52.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.435),(51.575,6.605),(51.745,6.605),(51.745,6.435),(51.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.435),(51.935,6.605),(52.105,6.605),(52.105,6.435),(51.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.435),(52.295,6.605),(52.465,6.605),(52.465,6.435),(52.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.435),(52.655,6.605),(52.825,6.605),(52.825,6.435),(52.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.795),(51.575,6.965),(51.745,6.965),(51.745,6.795),(51.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.795),(51.935,6.965),(52.105,6.965),(52.105,6.795),(51.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.795),(52.295,6.965),(52.465,6.965),(52.465,6.795),(52.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.795),(52.655,6.965),(52.825,6.965),(52.825,6.795),(52.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.155),(51.575,7.325),(51.745,7.325),(51.745,7.155),(51.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.155),(51.935,7.325),(52.105,7.325),(52.105,7.155),(51.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.155),(52.295,7.325),(52.465,7.325),(52.465,7.155),(52.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.155),(52.655,7.325),(52.825,7.325),(52.825,7.155),(52.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.515),(51.575,7.685),(51.745,7.685),(51.745,7.515),(51.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.515),(51.935,7.685),(52.105,7.685),(52.105,7.515),(51.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.515),(52.295,7.685),(52.465,7.685),(52.465,7.515),(52.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.515),(52.655,7.685),(52.825,7.685),(52.825,7.515),(52.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.875),(51.575,8.045),(51.745,8.045),(51.745,7.875),(51.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.875),(51.935,8.045),(52.105,8.045),(52.105,7.875),(51.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.875),(52.295,8.045),(52.465,8.045),(52.465,7.875),(52.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.875),(52.655,8.045),(52.825,8.045),(52.825,7.875),(52.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.235),(51.575,8.405),(51.745,8.405),(51.745,8.235),(51.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.235),(51.935,8.405),(52.105,8.405),(52.105,8.235),(51.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.235),(52.295,8.405),(52.465,8.405),(52.465,8.235),(52.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.235),(52.655,8.405),(52.825,8.405),(52.825,8.235),(52.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.595),(51.575,8.765),(51.745,8.765),(51.745,8.595),(51.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.595),(51.935,8.765),(52.105,8.765),(52.105,8.595),(51.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.595),(52.295,8.765),(52.465,8.765),(52.465,8.595),(52.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.595),(52.655,8.765),(52.825,8.765),(52.825,8.595),(52.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.955),(51.575,9.125),(51.745,9.125),(51.745,8.955),(51.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.955),(51.935,9.125),(52.105,9.125),(52.105,8.955),(51.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.955),(52.295,9.125),(52.465,9.125),(52.465,8.955),(52.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.955),(52.655,9.125),(52.825,9.125),(52.825,8.955),(52.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.315),(51.575,9.485),(51.745,9.485),(51.745,9.315),(51.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.315),(51.935,9.485),(52.105,9.485),(52.105,9.315),(51.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.315),(52.295,9.485),(52.465,9.485),(52.465,9.315),(52.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.315),(52.655,9.485),(52.825,9.485),(52.825,9.315),(52.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.675),(51.575,9.845),(51.745,9.845),(51.745,9.675),(51.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.675),(51.935,9.845),(52.105,9.845),(52.105,9.675),(51.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.675),(52.295,9.845),(52.465,9.845),(52.465,9.675),(52.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.675),(52.655,9.845),(52.825,9.845),(52.825,9.675),(52.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.035),(51.575,10.205),(51.745,10.205),(51.745,10.035),(51.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.035),(51.935,10.205),(52.105,10.205),(52.105,10.035),(51.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.035),(52.295,10.205),(52.465,10.205),(52.465,10.035),(52.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.035),(52.655,10.205),(52.825,10.205),(52.825,10.035),(52.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.395),(51.575,10.565),(51.745,10.565),(51.745,10.395),(51.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.395),(51.935,10.565),(52.105,10.565),(52.105,10.395),(51.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.395),(52.295,10.565),(52.465,10.565),(52.465,10.395),(52.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.395),(52.655,10.565),(52.825,10.565),(52.825,10.395),(52.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.755),(51.575,10.925),(51.745,10.925),(51.745,10.755),(51.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.755),(51.935,10.925),(52.105,10.925),(52.105,10.755),(51.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.755),(52.295,10.925),(52.465,10.925),(52.465,10.755),(52.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.755),(52.655,10.925),(52.825,10.925),(52.825,10.755),(52.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.115),(51.575,11.285),(51.745,11.285),(51.745,11.115),(51.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.115),(51.935,11.285),(52.105,11.285),(52.105,11.115),(51.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.115),(52.295,11.285),(52.465,11.285),(52.465,11.115),(52.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.115),(52.655,11.285),(52.825,11.285),(52.825,11.115),(52.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.475),(51.575,11.645),(51.745,11.645),(51.745,11.475),(51.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.475),(51.935,11.645),(52.105,11.645),(52.105,11.475),(51.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.475),(52.295,11.645),(52.465,11.645),(52.465,11.475),(52.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.475),(52.655,11.645),(52.825,11.645),(52.825,11.475),(52.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.835),(51.575,12.005),(51.745,12.005),(51.745,11.835),(51.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.835),(51.935,12.005),(52.105,12.005),(52.105,11.835),(51.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.835),(52.295,12.005),(52.465,12.005),(52.465,11.835),(52.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.835),(52.655,12.005),(52.825,12.005),(52.825,11.835),(52.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.195),(51.575,12.365),(51.745,12.365),(51.745,12.195),(51.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.195),(51.935,12.365),(52.105,12.365),(52.105,12.195),(51.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.195),(52.295,12.365),(52.465,12.365),(52.465,12.195),(52.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.195),(52.655,12.365),(52.825,12.365),(52.825,12.195),(52.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.555),(51.575,12.725),(51.745,12.725),(51.745,12.555),(51.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.555),(51.935,12.725),(52.105,12.725),(52.105,12.555),(51.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.555),(52.295,12.725),(52.465,12.725),(52.465,12.555),(52.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.555),(52.655,12.725),(52.825,12.725),(52.825,12.555),(52.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.915),(51.575,13.085),(51.745,13.085),(51.745,12.915),(51.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.915),(51.935,13.085),(52.105,13.085),(52.105,12.915),(51.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.915),(52.295,13.085),(52.465,13.085),(52.465,12.915),(52.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.915),(52.655,13.085),(52.825,13.085),(52.825,12.915),(52.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.275),(51.575,13.445),(51.745,13.445),(51.745,13.275),(51.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.275),(51.935,13.445),(52.105,13.445),(52.105,13.275),(51.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.275),(52.295,13.445),(52.465,13.445),(52.465,13.275),(52.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.275),(52.655,13.445),(52.825,13.445),(52.825,13.275),(52.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.635),(51.575,13.805),(51.745,13.805),(51.745,13.635),(51.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.635),(51.935,13.805),(52.105,13.805),(52.105,13.635),(51.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.635),(52.295,13.805),(52.465,13.805),(52.465,13.635),(52.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.635),(52.655,13.805),(52.825,13.805),(52.825,13.635),(52.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.995),(51.575,14.165),(51.745,14.165),(51.745,13.995),(51.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.995),(51.935,14.165),(52.105,14.165),(52.105,13.995),(51.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.995),(52.295,14.165),(52.465,14.165),(52.465,13.995),(52.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.995),(52.655,14.165),(52.825,14.165),(52.825,13.995),(52.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.355),(51.575,14.525),(51.745,14.525),(51.745,14.355),(51.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.355),(51.935,14.525),(52.105,14.525),(52.105,14.355),(51.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.355),(52.295,14.525),(52.465,14.525),(52.465,14.355),(52.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.355),(52.655,14.525),(52.825,14.525),(52.825,14.355),(52.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.715),(51.575,14.885),(51.745,14.885),(51.745,14.715),(51.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.715),(51.935,14.885),(52.105,14.885),(52.105,14.715),(51.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.715),(52.295,14.885),(52.465,14.885),(52.465,14.715),(52.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.715),(52.655,14.885),(52.825,14.885),(52.825,14.715),(52.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.075),(51.575,15.245),(51.745,15.245),(51.745,15.075),(51.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.075),(51.935,15.245),(52.105,15.245),(52.105,15.075),(51.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.075),(52.295,15.245),(52.465,15.245),(52.465,15.075),(52.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.075),(52.655,15.245),(52.825,15.245),(52.825,15.075),(52.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.435),(51.575,15.605),(51.745,15.605),(51.745,15.435),(51.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.435),(51.935,15.605),(52.105,15.605),(52.105,15.435),(51.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.435),(52.295,15.605),(52.465,15.605),(52.465,15.435),(52.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.435),(52.655,15.605),(52.825,15.605),(52.825,15.435),(52.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.795),(51.575,15.965),(51.745,15.965),(51.745,15.795),(51.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.795),(51.935,15.965),(52.105,15.965),(52.105,15.795),(51.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.795),(52.295,15.965),(52.465,15.965),(52.465,15.795),(52.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.795),(52.655,15.965),(52.825,15.965),(52.825,15.795),(52.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.155),(51.575,16.325),(51.745,16.325),(51.745,16.155),(51.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.155),(51.935,16.325),(52.105,16.325),(52.105,16.155),(51.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.155),(52.295,16.325),(52.465,16.325),(52.465,16.155),(52.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.155),(52.655,16.325),(52.825,16.325),(52.825,16.155),(52.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.515),(51.575,16.685),(51.745,16.685),(51.745,16.515),(51.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.515),(51.935,16.685),(52.105,16.685),(52.105,16.515),(51.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.515),(52.295,16.685),(52.465,16.685),(52.465,16.515),(52.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.515),(52.655,16.685),(52.825,16.685),(52.825,16.515),(52.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.875),(51.575,17.045),(51.745,17.045),(51.745,16.875),(51.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.875),(51.935,17.045),(52.105,17.045),(52.105,16.875),(51.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.875),(52.295,17.045),(52.465,17.045),(52.465,16.875),(52.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.875),(52.655,17.045),(52.825,17.045),(52.825,16.875),(52.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.235),(51.575,17.405),(51.745,17.405),(51.745,17.235),(51.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.235),(51.935,17.405),(52.105,17.405),(52.105,17.235),(51.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.235),(52.295,17.405),(52.465,17.405),(52.465,17.235),(52.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.235),(52.655,17.405),(52.825,17.405),(52.825,17.235),(52.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.595),(51.575,17.765),(51.745,17.765),(51.745,17.595),(51.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.595),(51.935,17.765),(52.105,17.765),(52.105,17.595),(51.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.595),(52.295,17.765),(52.465,17.765),(52.465,17.595),(52.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.595),(52.655,17.765),(52.825,17.765),(52.825,17.595),(52.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.955),(51.575,18.125),(51.745,18.125),(51.745,17.955),(51.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.955),(51.935,18.125),(52.105,18.125),(52.105,17.955),(51.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.955),(52.295,18.125),(52.465,18.125),(52.465,17.955),(52.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.955),(52.655,18.125),(52.825,18.125),(52.825,17.955),(52.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.315),(51.575,18.485),(51.745,18.485),(51.745,18.315),(51.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.315),(51.935,18.485),(52.105,18.485),(52.105,18.315),(51.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.315),(52.295,18.485),(52.465,18.485),(52.465,18.315),(52.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.315),(52.655,18.485),(52.825,18.485),(52.825,18.315),(52.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.675),(51.575,18.845),(51.745,18.845),(51.745,18.675),(51.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.675),(51.935,18.845),(52.105,18.845),(52.105,18.675),(51.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.675),(52.295,18.845),(52.465,18.845),(52.465,18.675),(52.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.675),(52.655,18.845),(52.825,18.845),(52.825,18.675),(52.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.035),(51.575,19.205),(51.745,19.205),(51.745,19.035),(51.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.035),(51.935,19.205),(52.105,19.205),(52.105,19.035),(51.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.035),(52.295,19.205),(52.465,19.205),(52.465,19.035),(52.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.035),(52.655,19.205),(52.825,19.205),(52.825,19.035),(52.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.395),(51.575,19.565),(51.745,19.565),(51.745,19.395),(51.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.395),(51.935,19.565),(52.105,19.565),(52.105,19.395),(51.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.395),(52.295,19.565),(52.465,19.565),(52.465,19.395),(52.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.395),(52.655,19.565),(52.825,19.565),(52.825,19.395),(52.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.755),(51.575,19.925),(51.745,19.925),(51.745,19.755),(51.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.755),(51.935,19.925),(52.105,19.925),(52.105,19.755),(51.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.755),(52.295,19.925),(52.465,19.925),(52.465,19.755),(52.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.755),(52.655,19.925),(52.825,19.925),(52.825,19.755),(52.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.115),(51.575,20.285),(51.745,20.285),(51.745,20.115),(51.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.115),(51.935,20.285),(52.105,20.285),(52.105,20.115),(51.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.115),(52.295,20.285),(52.465,20.285),(52.465,20.115),(52.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.115),(52.655,20.285),(52.825,20.285),(52.825,20.115),(52.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.475),(51.575,20.645),(51.745,20.645),(51.745,20.475),(51.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.475),(51.935,20.645),(52.105,20.645),(52.105,20.475),(51.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.475),(52.295,20.645),(52.465,20.645),(52.465,20.475),(52.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.475),(52.655,20.645),(52.825,20.645),(52.825,20.475),(52.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.835),(51.575,21.005),(51.745,21.005),(51.745,20.835),(51.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.835),(51.935,21.005),(52.105,21.005),(52.105,20.835),(51.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.835),(52.295,21.005),(52.465,21.005),(52.465,20.835),(52.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.835),(52.655,21.005),(52.825,21.005),(52.825,20.835),(52.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.195),(51.575,21.365),(51.745,21.365),(51.745,21.195),(51.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.195),(51.935,21.365),(52.105,21.365),(52.105,21.195),(51.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.195),(52.295,21.365),(52.465,21.365),(52.465,21.195),(52.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.195),(52.655,21.365),(52.825,21.365),(52.825,21.195),(52.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.555),(51.575,21.725),(51.745,21.725),(51.745,21.555),(51.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.555),(51.935,21.725),(52.105,21.725),(52.105,21.555),(51.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.555),(52.295,21.725),(52.465,21.725),(52.465,21.555),(52.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.555),(52.655,21.725),(52.825,21.725),(52.825,21.555),(52.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.915),(51.575,22.085),(51.745,22.085),(51.745,21.915),(51.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.915),(51.935,22.085),(52.105,22.085),(52.105,21.915),(51.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.915),(52.295,22.085),(52.465,22.085),(52.465,21.915),(52.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.915),(52.655,22.085),(52.825,22.085),(52.825,21.915),(52.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.275),(51.575,22.445),(51.745,22.445),(51.745,22.275),(51.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.275),(51.935,22.445),(52.105,22.445),(52.105,22.275),(51.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.275),(52.295,22.445),(52.465,22.445),(52.465,22.275),(52.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.275),(52.655,22.445),(52.825,22.445),(52.825,22.275),(52.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.635),(51.575,22.805),(51.745,22.805),(51.745,22.635),(51.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.635),(51.935,22.805),(52.105,22.805),(52.105,22.635),(51.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.635),(52.295,22.805),(52.465,22.805),(52.465,22.635),(52.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.635),(52.655,22.805),(52.825,22.805),(52.825,22.635),(52.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.995),(51.575,23.165),(51.745,23.165),(51.745,22.995),(51.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.995),(51.935,23.165),(52.105,23.165),(52.105,22.995),(51.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.995),(52.295,23.165),(52.465,23.165),(52.465,22.995),(52.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.995),(52.655,23.165),(52.825,23.165),(52.825,22.995),(52.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,23.355),(51.575,23.525),(51.745,23.525),(51.745,23.355),(51.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,23.355),(51.935,23.525),(52.105,23.525),(52.105,23.355),(51.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,23.355),(52.295,23.525),(52.465,23.525),(52.465,23.355),(52.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,23.355),(52.655,23.525),(52.825,23.525),(52.825,23.355),(52.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,23.715),(51.575,23.885),(51.745,23.885),(51.745,23.715),(51.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,23.715),(51.935,23.885),(52.105,23.885),(52.105,23.715),(51.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,23.715),(52.295,23.885),(52.465,23.885),(52.465,23.715),(52.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,23.715),(52.655,23.885),(52.825,23.885),(52.825,23.715),(52.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.075),(51.575,24.245),(51.745,24.245),(51.745,24.075),(51.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.075),(51.935,24.245),(52.105,24.245),(52.105,24.075),(51.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.075),(52.295,24.245),(52.465,24.245),(52.465,24.075),(52.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.075),(52.655,24.245),(52.825,24.245),(52.825,24.075),(52.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.435),(51.575,24.605),(51.745,24.605),(51.745,24.435),(51.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.435),(51.935,24.605),(52.105,24.605),(52.105,24.435),(51.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.435),(52.295,24.605),(52.465,24.605),(52.465,24.435),(52.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.435),(52.655,24.605),(52.825,24.605),(52.825,24.435),(52.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.795),(51.575,24.965),(51.745,24.965),(51.745,24.795),(51.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.795),(51.935,24.965),(52.105,24.965),(52.105,24.795),(51.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.795),(52.295,24.965),(52.465,24.965),(52.465,24.795),(52.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.795),(52.655,24.965),(52.825,24.965),(52.825,24.795),(52.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.155),(51.575,25.325),(51.745,25.325),(51.745,25.155),(51.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.155),(51.935,25.325),(52.105,25.325),(52.105,25.155),(51.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.155),(52.295,25.325),(52.465,25.325),(52.465,25.155),(52.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.155),(52.655,25.325),(52.825,25.325),(52.825,25.155),(52.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.515),(51.575,25.685),(51.745,25.685),(51.745,25.515),(51.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.515),(51.935,25.685),(52.105,25.685),(52.105,25.515),(51.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.515),(52.295,25.685),(52.465,25.685),(52.465,25.515),(52.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.515),(52.655,25.685),(52.825,25.685),(52.825,25.515),(52.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.875),(51.575,26.045),(51.745,26.045),(51.745,25.875),(51.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.875),(51.935,26.045),(52.105,26.045),(52.105,25.875),(51.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.875),(52.295,26.045),(52.465,26.045),(52.465,25.875),(52.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.875),(52.655,26.045),(52.825,26.045),(52.825,25.875),(52.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.235),(51.575,26.405),(51.745,26.405),(51.745,26.235),(51.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.235),(51.935,26.405),(52.105,26.405),(52.105,26.235),(51.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.235),(52.295,26.405),(52.465,26.405),(52.465,26.235),(52.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.235),(52.655,26.405),(52.825,26.405),(52.825,26.235),(52.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.595),(51.575,26.765),(51.745,26.765),(51.745,26.595),(51.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.595),(51.935,26.765),(52.105,26.765),(52.105,26.595),(51.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.595),(52.295,26.765),(52.465,26.765),(52.465,26.595),(52.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.595),(52.655,26.765),(52.825,26.765),(52.825,26.595),(52.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.955),(51.575,27.125),(51.745,27.125),(51.745,26.955),(51.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.955),(51.935,27.125),(52.105,27.125),(52.105,26.955),(51.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.955),(52.295,27.125),(52.465,27.125),(52.465,26.955),(52.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.955),(52.655,27.125),(52.825,27.125),(52.825,26.955),(52.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,27.315),(51.575,27.485),(51.745,27.485),(51.745,27.315),(51.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,27.315),(51.935,27.485),(52.105,27.485),(52.105,27.315),(51.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,27.315),(52.295,27.485),(52.465,27.485),(52.465,27.315),(52.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,27.315),(52.655,27.485),(52.825,27.485),(52.825,27.315),(52.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,27.675),(51.575,27.845),(51.745,27.845),(51.745,27.675),(51.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,27.675),(51.935,27.845),(52.105,27.845),(52.105,27.675),(51.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,27.675),(52.295,27.845),(52.465,27.845),(52.465,27.675),(52.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,27.675),(52.655,27.845),(52.825,27.845),(52.825,27.675),(52.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.035),(51.575,28.205),(51.745,28.205),(51.745,28.035),(51.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.035),(51.935,28.205),(52.105,28.205),(52.105,28.035),(51.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.035),(52.295,28.205),(52.465,28.205),(52.465,28.035),(52.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.035),(52.655,28.205),(52.825,28.205),(52.825,28.035),(52.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.395),(51.575,28.565),(51.745,28.565),(51.745,28.395),(51.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.395),(51.935,28.565),(52.105,28.565),(52.105,28.395),(51.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.395),(52.295,28.565),(52.465,28.565),(52.465,28.395),(52.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.395),(52.655,28.565),(52.825,28.565),(52.825,28.395),(52.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.755),(51.575,28.925),(51.745,28.925),(51.745,28.755),(51.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.755),(51.935,28.925),(52.105,28.925),(52.105,28.755),(51.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.755),(52.295,28.925),(52.465,28.925),(52.465,28.755),(52.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.755),(52.655,28.925),(52.825,28.925),(52.825,28.755),(52.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.115),(51.575,29.285),(51.745,29.285),(51.745,29.115),(51.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.115),(51.935,29.285),(52.105,29.285),(52.105,29.115),(51.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.115),(52.295,29.285),(52.465,29.285),(52.465,29.115),(52.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.115),(52.655,29.285),(52.825,29.285),(52.825,29.115),(52.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.475),(51.575,29.645),(51.745,29.645),(51.745,29.475),(51.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.475),(51.935,29.645),(52.105,29.645),(52.105,29.475),(51.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.475),(52.295,29.645),(52.465,29.645),(52.465,29.475),(52.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.475),(52.655,29.645),(52.825,29.645),(52.825,29.475),(52.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.835),(51.575,30.005),(51.745,30.005),(51.745,29.835),(51.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.835),(51.935,30.005),(52.105,30.005),(52.105,29.835),(51.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.835),(52.295,30.005),(52.465,30.005),(52.465,29.835),(52.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.835),(52.655,30.005),(52.825,30.005),(52.825,29.835),(52.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.195),(51.575,30.365),(51.745,30.365),(51.745,30.195),(51.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.195),(51.935,30.365),(52.105,30.365),(52.105,30.195),(51.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.195),(52.295,30.365),(52.465,30.365),(52.465,30.195),(52.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.195),(52.655,30.365),(52.825,30.365),(52.825,30.195),(52.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.555),(51.575,30.725),(51.745,30.725),(51.745,30.555),(51.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.555),(51.935,30.725),(52.105,30.725),(52.105,30.555),(51.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.555),(52.295,30.725),(52.465,30.725),(52.465,30.555),(52.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.555),(52.655,30.725),(52.825,30.725),(52.825,30.555),(52.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.915),(51.575,31.085),(51.745,31.085),(51.745,30.915),(51.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.915),(51.935,31.085),(52.105,31.085),(52.105,30.915),(51.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.915),(52.295,31.085),(52.465,31.085),(52.465,30.915),(52.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.915),(52.655,31.085),(52.825,31.085),(52.825,30.915),(52.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.275),(51.575,31.445),(51.745,31.445),(51.745,31.275),(51.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.275),(51.935,31.445),(52.105,31.445),(52.105,31.275),(51.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.275),(52.295,31.445),(52.465,31.445),(52.465,31.275),(52.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.275),(52.655,31.445),(52.825,31.445),(52.825,31.275),(52.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.635),(51.575,31.805),(51.745,31.805),(51.745,31.635),(51.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.635),(51.935,31.805),(52.105,31.805),(52.105,31.635),(51.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.635),(52.295,31.805),(52.465,31.805),(52.465,31.635),(52.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.635),(52.655,31.805),(52.825,31.805),(52.825,31.635),(52.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.995),(51.575,32.165),(51.745,32.165),(51.745,31.995),(51.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.995),(51.935,32.165),(52.105,32.165),(52.105,31.995),(51.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.995),(52.295,32.165),(52.465,32.165),(52.465,31.995),(52.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.995),(52.655,32.165),(52.825,32.165),(52.825,31.995),(52.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,32.355),(51.575,32.525),(51.745,32.525),(51.745,32.355),(51.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,32.355),(51.935,32.525),(52.105,32.525),(52.105,32.355),(51.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,32.355),(52.295,32.525),(52.465,32.525),(52.465,32.355),(52.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,32.355),(52.655,32.525),(52.825,32.525),(52.825,32.355),(52.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,32.715),(51.575,32.885),(51.745,32.885),(51.745,32.715),(51.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,32.715),(51.935,32.885),(52.105,32.885),(52.105,32.715),(51.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,32.715),(52.295,32.885),(52.465,32.885),(52.465,32.715),(52.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,32.715),(52.655,32.885),(52.825,32.885),(52.825,32.715),(52.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.075),(51.575,33.245),(51.745,33.245),(51.745,33.075),(51.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.075),(51.935,33.245),(52.105,33.245),(52.105,33.075),(51.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.075),(52.295,33.245),(52.465,33.245),(52.465,33.075),(52.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.075),(52.655,33.245),(52.825,33.245),(52.825,33.075),(52.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.435),(51.575,33.605),(51.745,33.605),(51.745,33.435),(51.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.435),(51.935,33.605),(52.105,33.605),(52.105,33.435),(51.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.435),(52.295,33.605),(52.465,33.605),(52.465,33.435),(52.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.435),(52.655,33.605),(52.825,33.605),(52.825,33.435),(52.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.795),(51.575,33.965),(51.745,33.965),(51.745,33.795),(51.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.795),(51.935,33.965),(52.105,33.965),(52.105,33.795),(51.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.795),(52.295,33.965),(52.465,33.965),(52.465,33.795),(52.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.795),(52.655,33.965),(52.825,33.965),(52.825,33.795),(52.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.155),(51.575,34.325),(51.745,34.325),(51.745,34.155),(51.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.155),(51.935,34.325),(52.105,34.325),(52.105,34.155),(51.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.155),(52.295,34.325),(52.465,34.325),(52.465,34.155),(52.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.155),(52.655,34.325),(52.825,34.325),(52.825,34.155),(52.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.515),(51.575,34.685),(51.745,34.685),(51.745,34.515),(51.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.515),(51.935,34.685),(52.105,34.685),(52.105,34.515),(51.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.515),(52.295,34.685),(52.465,34.685),(52.465,34.515),(52.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.515),(52.655,34.685),(52.825,34.685),(52.825,34.515),(52.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.875),(51.575,35.045),(51.745,35.045),(51.745,34.875),(51.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.875),(51.935,35.045),(52.105,35.045),(52.105,34.875),(51.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.875),(52.295,35.045),(52.465,35.045),(52.465,34.875),(52.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.875),(52.655,35.045),(52.825,35.045),(52.825,34.875),(52.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.235),(51.575,35.405),(51.745,35.405),(51.745,35.235),(51.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.235),(51.935,35.405),(52.105,35.405),(52.105,35.235),(51.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.235),(52.295,35.405),(52.465,35.405),(52.465,35.235),(52.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.235),(52.655,35.405),(52.825,35.405),(52.825,35.235),(52.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.595),(51.575,35.765),(51.745,35.765),(51.745,35.595),(51.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.595),(51.935,35.765),(52.105,35.765),(52.105,35.595),(51.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.595),(52.295,35.765),(52.465,35.765),(52.465,35.595),(52.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.595),(52.655,35.765),(52.825,35.765),(52.825,35.595),(52.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.955),(51.575,36.125),(51.745,36.125),(51.745,35.955),(51.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.955),(51.935,36.125),(52.105,36.125),(52.105,35.955),(51.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.955),(52.295,36.125),(52.465,36.125),(52.465,35.955),(52.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.955),(52.655,36.125),(52.825,36.125),(52.825,35.955),(52.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,36.315),(51.575,36.485),(51.745,36.485),(51.745,36.315),(51.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,36.315),(51.935,36.485),(52.105,36.485),(52.105,36.315),(51.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,36.315),(52.295,36.485),(52.465,36.485),(52.465,36.315),(52.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,36.315),(52.655,36.485),(52.825,36.485),(52.825,36.315),(52.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,36.675),(51.575,36.845),(51.745,36.845),(51.745,36.675),(51.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,36.675),(51.935,36.845),(52.105,36.845),(52.105,36.675),(51.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,36.675),(52.295,36.845),(52.465,36.845),(52.465,36.675),(52.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,36.675),(52.655,36.845),(52.825,36.845),(52.825,36.675),(52.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.035),(51.575,37.205),(51.745,37.205),(51.745,37.035),(51.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.035),(51.935,37.205),(52.105,37.205),(52.105,37.035),(51.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.035),(52.295,37.205),(52.465,37.205),(52.465,37.035),(52.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.035),(52.655,37.205),(52.825,37.205),(52.825,37.035),(52.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.395),(51.575,37.565),(51.745,37.565),(51.745,37.395),(51.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.395),(51.935,37.565),(52.105,37.565),(52.105,37.395),(51.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.395),(52.295,37.565),(52.465,37.565),(52.465,37.395),(52.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.395),(52.655,37.565),(52.825,37.565),(52.825,37.395),(52.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.755),(51.575,37.925),(51.745,37.925),(51.745,37.755),(51.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.755),(51.935,37.925),(52.105,37.925),(52.105,37.755),(51.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.755),(52.295,37.925),(52.465,37.925),(52.465,37.755),(52.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.755),(52.655,37.925),(52.825,37.925),(52.825,37.755),(52.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.115),(51.575,38.285),(51.745,38.285),(51.745,38.115),(51.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.115),(51.935,38.285),(52.105,38.285),(52.105,38.115),(51.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.115),(52.295,38.285),(52.465,38.285),(52.465,38.115),(52.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.115),(52.655,38.285),(52.825,38.285),(52.825,38.115),(52.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.475),(51.575,38.645),(51.745,38.645),(51.745,38.475),(51.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.475),(51.935,38.645),(52.105,38.645),(52.105,38.475),(51.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.475),(52.295,38.645),(52.465,38.645),(52.465,38.475),(52.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.475),(52.655,38.645),(52.825,38.645),(52.825,38.475),(52.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.835),(51.575,39.005),(51.745,39.005),(51.745,38.835),(51.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.835),(51.935,39.005),(52.105,39.005),(52.105,38.835),(51.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.835),(52.295,39.005),(52.465,39.005),(52.465,38.835),(52.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.835),(52.655,39.005),(52.825,39.005),(52.825,38.835),(52.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.195),(51.575,39.365),(51.745,39.365),(51.745,39.195),(51.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.195),(51.935,39.365),(52.105,39.365),(52.105,39.195),(51.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.195),(52.295,39.365),(52.465,39.365),(52.465,39.195),(52.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.195),(52.655,39.365),(52.825,39.365),(52.825,39.195),(52.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.555),(51.575,39.725),(51.745,39.725),(51.745,39.555),(51.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.555),(51.935,39.725),(52.105,39.725),(52.105,39.555),(51.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.555),(52.295,39.725),(52.465,39.725),(52.465,39.555),(52.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.555),(52.655,39.725),(52.825,39.725),(52.825,39.555),(52.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.915),(51.575,40.085),(51.745,40.085),(51.745,39.915),(51.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.915),(51.935,40.085),(52.105,40.085),(52.105,39.915),(51.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.915),(52.295,40.085),(52.465,40.085),(52.465,39.915),(52.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.915),(52.655,40.085),(52.825,40.085),(52.825,39.915),(52.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,40.275),(51.575,40.445),(51.745,40.445),(51.745,40.275),(51.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,40.275),(51.935,40.445),(52.105,40.445),(52.105,40.275),(51.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,40.275),(52.295,40.445),(52.465,40.445),(52.465,40.275),(52.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,40.275),(52.655,40.445),(52.825,40.445),(52.825,40.275),(52.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,40.635),(51.575,40.805),(51.745,40.805),(51.745,40.635),(51.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,40.635),(51.935,40.805),(52.105,40.805),(52.105,40.635),(51.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,40.635),(52.295,40.805),(52.465,40.805),(52.465,40.635),(52.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,40.635),(52.655,40.805),(52.825,40.805),(52.825,40.635),(52.655,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,2.835),(22.775,3.005),(22.945,3.005),(22.945,2.835),(22.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,2.835),(23.135,3.005),(23.305,3.005),(23.305,2.835),(23.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,2.835),(23.495,3.005),(23.665,3.005),(23.665,2.835),(23.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,2.835),(23.855,3.005),(24.025,3.005),(24.025,2.835),(23.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.195),(22.775,3.365),(22.945,3.365),(22.945,3.195),(22.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.195),(23.135,3.365),(23.305,3.365),(23.305,3.195),(23.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.195),(23.495,3.365),(23.665,3.365),(23.665,3.195),(23.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.195),(23.855,3.365),(24.025,3.365),(24.025,3.195),(23.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.555),(22.775,3.725),(22.945,3.725),(22.945,3.555),(22.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.555),(23.135,3.725),(23.305,3.725),(23.305,3.555),(23.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.555),(23.495,3.725),(23.665,3.725),(23.665,3.555),(23.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.555),(23.855,3.725),(24.025,3.725),(24.025,3.555),(23.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.915),(22.775,4.085),(22.945,4.085),(22.945,3.915),(22.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.915),(23.135,4.085),(23.305,4.085),(23.305,3.915),(23.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.915),(23.495,4.085),(23.665,4.085),(23.665,3.915),(23.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.915),(23.855,4.085),(24.025,4.085),(24.025,3.915),(23.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.275),(22.775,4.445),(22.945,4.445),(22.945,4.275),(22.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.275),(23.135,4.445),(23.305,4.445),(23.305,4.275),(23.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.275),(23.495,4.445),(23.665,4.445),(23.665,4.275),(23.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.275),(23.855,4.445),(24.025,4.445),(24.025,4.275),(23.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.635),(22.775,4.805),(22.945,4.805),(22.945,4.635),(22.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.635),(23.135,4.805),(23.305,4.805),(23.305,4.635),(23.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.635),(23.495,4.805),(23.665,4.805),(23.665,4.635),(23.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.635),(23.855,4.805),(24.025,4.805),(24.025,4.635),(23.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.995),(22.775,5.165),(22.945,5.165),(22.945,4.995),(22.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.995),(23.135,5.165),(23.305,5.165),(23.305,4.995),(23.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.995),(23.495,5.165),(23.665,5.165),(23.665,4.995),(23.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.995),(23.855,5.165),(24.025,5.165),(24.025,4.995),(23.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.355),(22.775,5.525),(22.945,5.525),(22.945,5.355),(22.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.355),(23.135,5.525),(23.305,5.525),(23.305,5.355),(23.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.355),(23.495,5.525),(23.665,5.525),(23.665,5.355),(23.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.355),(23.855,5.525),(24.025,5.525),(24.025,5.355),(23.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.715),(22.775,5.885),(22.945,5.885),(22.945,5.715),(22.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.715),(23.135,5.885),(23.305,5.885),(23.305,5.715),(23.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.715),(23.495,5.885),(23.665,5.885),(23.665,5.715),(23.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.715),(23.855,5.885),(24.025,5.885),(24.025,5.715),(23.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.075),(22.775,6.245),(22.945,6.245),(22.945,6.075),(22.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.075),(23.135,6.245),(23.305,6.245),(23.305,6.075),(23.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.075),(23.495,6.245),(23.665,6.245),(23.665,6.075),(23.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.075),(23.855,6.245),(24.025,6.245),(24.025,6.075),(23.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.435),(22.775,6.605),(22.945,6.605),(22.945,6.435),(22.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.435),(23.135,6.605),(23.305,6.605),(23.305,6.435),(23.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.435),(23.495,6.605),(23.665,6.605),(23.665,6.435),(23.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.435),(23.855,6.605),(24.025,6.605),(24.025,6.435),(23.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.795),(22.775,6.965),(22.945,6.965),(22.945,6.795),(22.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.795),(23.135,6.965),(23.305,6.965),(23.305,6.795),(23.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.795),(23.495,6.965),(23.665,6.965),(23.665,6.795),(23.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.795),(23.855,6.965),(24.025,6.965),(24.025,6.795),(23.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.155),(22.775,7.325),(22.945,7.325),(22.945,7.155),(22.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.155),(23.135,7.325),(23.305,7.325),(23.305,7.155),(23.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.155),(23.495,7.325),(23.665,7.325),(23.665,7.155),(23.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.155),(23.855,7.325),(24.025,7.325),(24.025,7.155),(23.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.515),(22.775,7.685),(22.945,7.685),(22.945,7.515),(22.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.515),(23.135,7.685),(23.305,7.685),(23.305,7.515),(23.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.515),(23.495,7.685),(23.665,7.685),(23.665,7.515),(23.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.515),(23.855,7.685),(24.025,7.685),(24.025,7.515),(23.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.875),(22.775,8.045),(22.945,8.045),(22.945,7.875),(22.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.875),(23.135,8.045),(23.305,8.045),(23.305,7.875),(23.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.875),(23.495,8.045),(23.665,8.045),(23.665,7.875),(23.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.875),(23.855,8.045),(24.025,8.045),(24.025,7.875),(23.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.235),(22.775,8.405),(22.945,8.405),(22.945,8.235),(22.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.235),(23.135,8.405),(23.305,8.405),(23.305,8.235),(23.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.235),(23.495,8.405),(23.665,8.405),(23.665,8.235),(23.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.235),(23.855,8.405),(24.025,8.405),(24.025,8.235),(23.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.595),(22.775,8.765),(22.945,8.765),(22.945,8.595),(22.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.595),(23.135,8.765),(23.305,8.765),(23.305,8.595),(23.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.595),(23.495,8.765),(23.665,8.765),(23.665,8.595),(23.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.595),(23.855,8.765),(24.025,8.765),(24.025,8.595),(23.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.955),(22.775,9.125),(22.945,9.125),(22.945,8.955),(22.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.955),(23.135,9.125),(23.305,9.125),(23.305,8.955),(23.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.955),(23.495,9.125),(23.665,9.125),(23.665,8.955),(23.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.955),(23.855,9.125),(24.025,9.125),(24.025,8.955),(23.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.315),(22.775,9.485),(22.945,9.485),(22.945,9.315),(22.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.315),(23.135,9.485),(23.305,9.485),(23.305,9.315),(23.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.315),(23.495,9.485),(23.665,9.485),(23.665,9.315),(23.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.315),(23.855,9.485),(24.025,9.485),(24.025,9.315),(23.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.675),(22.775,9.845),(22.945,9.845),(22.945,9.675),(22.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.675),(23.135,9.845),(23.305,9.845),(23.305,9.675),(23.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.675),(23.495,9.845),(23.665,9.845),(23.665,9.675),(23.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.675),(23.855,9.845),(24.025,9.845),(24.025,9.675),(23.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.035),(22.775,10.205),(22.945,10.205),(22.945,10.035),(22.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.035),(23.135,10.205),(23.305,10.205),(23.305,10.035),(23.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.035),(23.495,10.205),(23.665,10.205),(23.665,10.035),(23.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.035),(23.855,10.205),(24.025,10.205),(24.025,10.035),(23.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.395),(22.775,10.565),(22.945,10.565),(22.945,10.395),(22.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.395),(23.135,10.565),(23.305,10.565),(23.305,10.395),(23.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.395),(23.495,10.565),(23.665,10.565),(23.665,10.395),(23.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.395),(23.855,10.565),(24.025,10.565),(24.025,10.395),(23.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.755),(22.775,10.925),(22.945,10.925),(22.945,10.755),(22.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.755),(23.135,10.925),(23.305,10.925),(23.305,10.755),(23.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.755),(23.495,10.925),(23.665,10.925),(23.665,10.755),(23.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.755),(23.855,10.925),(24.025,10.925),(24.025,10.755),(23.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.115),(22.775,11.285),(22.945,11.285),(22.945,11.115),(22.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.115),(23.135,11.285),(23.305,11.285),(23.305,11.115),(23.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.115),(23.495,11.285),(23.665,11.285),(23.665,11.115),(23.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.115),(23.855,11.285),(24.025,11.285),(24.025,11.115),(23.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.475),(22.775,11.645),(22.945,11.645),(22.945,11.475),(22.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.475),(23.135,11.645),(23.305,11.645),(23.305,11.475),(23.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.475),(23.495,11.645),(23.665,11.645),(23.665,11.475),(23.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.475),(23.855,11.645),(24.025,11.645),(24.025,11.475),(23.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.835),(22.775,12.005),(22.945,12.005),(22.945,11.835),(22.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.835),(23.135,12.005),(23.305,12.005),(23.305,11.835),(23.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.835),(23.495,12.005),(23.665,12.005),(23.665,11.835),(23.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.835),(23.855,12.005),(24.025,12.005),(24.025,11.835),(23.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.195),(22.775,12.365),(22.945,12.365),(22.945,12.195),(22.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.195),(23.135,12.365),(23.305,12.365),(23.305,12.195),(23.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.195),(23.495,12.365),(23.665,12.365),(23.665,12.195),(23.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.195),(23.855,12.365),(24.025,12.365),(24.025,12.195),(23.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.555),(22.775,12.725),(22.945,12.725),(22.945,12.555),(22.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.555),(23.135,12.725),(23.305,12.725),(23.305,12.555),(23.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.555),(23.495,12.725),(23.665,12.725),(23.665,12.555),(23.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.555),(23.855,12.725),(24.025,12.725),(24.025,12.555),(23.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.915),(22.775,13.085),(22.945,13.085),(22.945,12.915),(22.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.915),(23.135,13.085),(23.305,13.085),(23.305,12.915),(23.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.915),(23.495,13.085),(23.665,13.085),(23.665,12.915),(23.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.915),(23.855,13.085),(24.025,13.085),(24.025,12.915),(23.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.275),(22.775,13.445),(22.945,13.445),(22.945,13.275),(22.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.275),(23.135,13.445),(23.305,13.445),(23.305,13.275),(23.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.275),(23.495,13.445),(23.665,13.445),(23.665,13.275),(23.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.275),(23.855,13.445),(24.025,13.445),(24.025,13.275),(23.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.635),(22.775,13.805),(22.945,13.805),(22.945,13.635),(22.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.635),(23.135,13.805),(23.305,13.805),(23.305,13.635),(23.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.635),(23.495,13.805),(23.665,13.805),(23.665,13.635),(23.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.635),(23.855,13.805),(24.025,13.805),(24.025,13.635),(23.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.995),(22.775,14.165),(22.945,14.165),(22.945,13.995),(22.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.995),(23.135,14.165),(23.305,14.165),(23.305,13.995),(23.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.995),(23.495,14.165),(23.665,14.165),(23.665,13.995),(23.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.995),(23.855,14.165),(24.025,14.165),(24.025,13.995),(23.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.355),(22.775,14.525),(22.945,14.525),(22.945,14.355),(22.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.355),(23.135,14.525),(23.305,14.525),(23.305,14.355),(23.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.355),(23.495,14.525),(23.665,14.525),(23.665,14.355),(23.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.355),(23.855,14.525),(24.025,14.525),(24.025,14.355),(23.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.715),(22.775,14.885),(22.945,14.885),(22.945,14.715),(22.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.715),(23.135,14.885),(23.305,14.885),(23.305,14.715),(23.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.715),(23.495,14.885),(23.665,14.885),(23.665,14.715),(23.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.715),(23.855,14.885),(24.025,14.885),(24.025,14.715),(23.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.075),(22.775,15.245),(22.945,15.245),(22.945,15.075),(22.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.075),(23.135,15.245),(23.305,15.245),(23.305,15.075),(23.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.075),(23.495,15.245),(23.665,15.245),(23.665,15.075),(23.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.075),(23.855,15.245),(24.025,15.245),(24.025,15.075),(23.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.435),(22.775,15.605),(22.945,15.605),(22.945,15.435),(22.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.435),(23.135,15.605),(23.305,15.605),(23.305,15.435),(23.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.435),(23.495,15.605),(23.665,15.605),(23.665,15.435),(23.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.435),(23.855,15.605),(24.025,15.605),(24.025,15.435),(23.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.795),(22.775,15.965),(22.945,15.965),(22.945,15.795),(22.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.795),(23.135,15.965),(23.305,15.965),(23.305,15.795),(23.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.795),(23.495,15.965),(23.665,15.965),(23.665,15.795),(23.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.795),(23.855,15.965),(24.025,15.965),(24.025,15.795),(23.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.155),(22.775,16.325),(22.945,16.325),(22.945,16.155),(22.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.155),(23.135,16.325),(23.305,16.325),(23.305,16.155),(23.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.155),(23.495,16.325),(23.665,16.325),(23.665,16.155),(23.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.155),(23.855,16.325),(24.025,16.325),(24.025,16.155),(23.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.515),(22.775,16.685),(22.945,16.685),(22.945,16.515),(22.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.515),(23.135,16.685),(23.305,16.685),(23.305,16.515),(23.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.515),(23.495,16.685),(23.665,16.685),(23.665,16.515),(23.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.515),(23.855,16.685),(24.025,16.685),(24.025,16.515),(23.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.875),(22.775,17.045),(22.945,17.045),(22.945,16.875),(22.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.875),(23.135,17.045),(23.305,17.045),(23.305,16.875),(23.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.875),(23.495,17.045),(23.665,17.045),(23.665,16.875),(23.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.875),(23.855,17.045),(24.025,17.045),(24.025,16.875),(23.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.235),(22.775,17.405),(22.945,17.405),(22.945,17.235),(22.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.235),(23.135,17.405),(23.305,17.405),(23.305,17.235),(23.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.235),(23.495,17.405),(23.665,17.405),(23.665,17.235),(23.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.235),(23.855,17.405),(24.025,17.405),(24.025,17.235),(23.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.595),(22.775,17.765),(22.945,17.765),(22.945,17.595),(22.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.595),(23.135,17.765),(23.305,17.765),(23.305,17.595),(23.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.595),(23.495,17.765),(23.665,17.765),(23.665,17.595),(23.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.595),(23.855,17.765),(24.025,17.765),(24.025,17.595),(23.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.955),(22.775,18.125),(22.945,18.125),(22.945,17.955),(22.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.955),(23.135,18.125),(23.305,18.125),(23.305,17.955),(23.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.955),(23.495,18.125),(23.665,18.125),(23.665,17.955),(23.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.955),(23.855,18.125),(24.025,18.125),(24.025,17.955),(23.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.315),(22.775,18.485),(22.945,18.485),(22.945,18.315),(22.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.315),(23.135,18.485),(23.305,18.485),(23.305,18.315),(23.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.315),(23.495,18.485),(23.665,18.485),(23.665,18.315),(23.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.315),(23.855,18.485),(24.025,18.485),(24.025,18.315),(23.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.675),(22.775,18.845),(22.945,18.845),(22.945,18.675),(22.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.675),(23.135,18.845),(23.305,18.845),(23.305,18.675),(23.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.675),(23.495,18.845),(23.665,18.845),(23.665,18.675),(23.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.675),(23.855,18.845),(24.025,18.845),(24.025,18.675),(23.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.035),(22.775,19.205),(22.945,19.205),(22.945,19.035),(22.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.035),(23.135,19.205),(23.305,19.205),(23.305,19.035),(23.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.035),(23.495,19.205),(23.665,19.205),(23.665,19.035),(23.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.035),(23.855,19.205),(24.025,19.205),(24.025,19.035),(23.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.395),(22.775,19.565),(22.945,19.565),(22.945,19.395),(22.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.395),(23.135,19.565),(23.305,19.565),(23.305,19.395),(23.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.395),(23.495,19.565),(23.665,19.565),(23.665,19.395),(23.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.395),(23.855,19.565),(24.025,19.565),(24.025,19.395),(23.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.755),(22.775,19.925),(22.945,19.925),(22.945,19.755),(22.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.755),(23.135,19.925),(23.305,19.925),(23.305,19.755),(23.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.755),(23.495,19.925),(23.665,19.925),(23.665,19.755),(23.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.755),(23.855,19.925),(24.025,19.925),(24.025,19.755),(23.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,20.115),(22.775,20.285),(22.945,20.285),(22.945,20.115),(22.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,20.115),(23.135,20.285),(23.305,20.285),(23.305,20.115),(23.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,20.115),(23.495,20.285),(23.665,20.285),(23.665,20.115),(23.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,20.115),(23.855,20.285),(24.025,20.285),(24.025,20.115),(23.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,20.475),(22.775,20.645),(22.945,20.645),(22.945,20.475),(22.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,20.475),(23.135,20.645),(23.305,20.645),(23.305,20.475),(23.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,20.475),(23.495,20.645),(23.665,20.645),(23.665,20.475),(23.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,20.475),(23.855,20.645),(24.025,20.645),(24.025,20.475),(23.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,20.835),(22.775,21.005),(22.945,21.005),(22.945,20.835),(22.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,20.835),(23.135,21.005),(23.305,21.005),(23.305,20.835),(23.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,20.835),(23.495,21.005),(23.665,21.005),(23.665,20.835),(23.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,20.835),(23.855,21.005),(24.025,21.005),(24.025,20.835),(23.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,21.195),(22.775,21.365),(22.945,21.365),(22.945,21.195),(22.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,21.195),(23.135,21.365),(23.305,21.365),(23.305,21.195),(23.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,21.195),(23.495,21.365),(23.665,21.365),(23.665,21.195),(23.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,21.195),(23.855,21.365),(24.025,21.365),(24.025,21.195),(23.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,21.555),(22.775,21.725),(22.945,21.725),(22.945,21.555),(22.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,21.555),(23.135,21.725),(23.305,21.725),(23.305,21.555),(23.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,21.555),(23.495,21.725),(23.665,21.725),(23.665,21.555),(23.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,21.555),(23.855,21.725),(24.025,21.725),(24.025,21.555),(23.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,21.915),(22.775,22.085),(22.945,22.085),(22.945,21.915),(22.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,21.915),(23.135,22.085),(23.305,22.085),(23.305,21.915),(23.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,21.915),(23.495,22.085),(23.665,22.085),(23.665,21.915),(23.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,21.915),(23.855,22.085),(24.025,22.085),(24.025,21.915),(23.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.275),(22.775,22.445),(22.945,22.445),(22.945,22.275),(22.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.275),(23.135,22.445),(23.305,22.445),(23.305,22.275),(23.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.275),(23.495,22.445),(23.665,22.445),(23.665,22.275),(23.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.275),(23.855,22.445),(24.025,22.445),(24.025,22.275),(23.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.635),(22.775,22.805),(22.945,22.805),(22.945,22.635),(22.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.635),(23.135,22.805),(23.305,22.805),(23.305,22.635),(23.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.635),(23.495,22.805),(23.665,22.805),(23.665,22.635),(23.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.635),(23.855,22.805),(24.025,22.805),(24.025,22.635),(23.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.995),(22.775,23.165),(22.945,23.165),(22.945,22.995),(22.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.995),(23.135,23.165),(23.305,23.165),(23.305,22.995),(23.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.995),(23.495,23.165),(23.665,23.165),(23.665,22.995),(23.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.995),(23.855,23.165),(24.025,23.165),(24.025,22.995),(23.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,23.355),(22.775,23.525),(22.945,23.525),(22.945,23.355),(22.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,23.355),(23.135,23.525),(23.305,23.525),(23.305,23.355),(23.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,23.355),(23.495,23.525),(23.665,23.525),(23.665,23.355),(23.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,23.355),(23.855,23.525),(24.025,23.525),(24.025,23.355),(23.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,23.715),(22.775,23.885),(22.945,23.885),(22.945,23.715),(22.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,23.715),(23.135,23.885),(23.305,23.885),(23.305,23.715),(23.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,23.715),(23.495,23.885),(23.665,23.885),(23.665,23.715),(23.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,23.715),(23.855,23.885),(24.025,23.885),(24.025,23.715),(23.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,24.075),(22.775,24.245),(22.945,24.245),(22.945,24.075),(22.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,24.075),(23.135,24.245),(23.305,24.245),(23.305,24.075),(23.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,24.075),(23.495,24.245),(23.665,24.245),(23.665,24.075),(23.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,24.075),(23.855,24.245),(24.025,24.245),(24.025,24.075),(23.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,24.435),(22.775,24.605),(22.945,24.605),(22.945,24.435),(22.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,24.435),(23.135,24.605),(23.305,24.605),(23.305,24.435),(23.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,24.435),(23.495,24.605),(23.665,24.605),(23.665,24.435),(23.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,24.435),(23.855,24.605),(24.025,24.605),(24.025,24.435),(23.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,24.795),(22.775,24.965),(22.945,24.965),(22.945,24.795),(22.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,24.795),(23.135,24.965),(23.305,24.965),(23.305,24.795),(23.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,24.795),(23.495,24.965),(23.665,24.965),(23.665,24.795),(23.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,24.795),(23.855,24.965),(24.025,24.965),(24.025,24.795),(23.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,25.155),(22.775,25.325),(22.945,25.325),(22.945,25.155),(22.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,25.155),(23.135,25.325),(23.305,25.325),(23.305,25.155),(23.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,25.155),(23.495,25.325),(23.665,25.325),(23.665,25.155),(23.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,25.155),(23.855,25.325),(24.025,25.325),(24.025,25.155),(23.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,25.515),(22.775,25.685),(22.945,25.685),(22.945,25.515),(22.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,25.515),(23.135,25.685),(23.305,25.685),(23.305,25.515),(23.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,25.515),(23.495,25.685),(23.665,25.685),(23.665,25.515),(23.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,25.515),(23.855,25.685),(24.025,25.685),(24.025,25.515),(23.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,25.875),(22.775,26.045),(22.945,26.045),(22.945,25.875),(22.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,25.875),(23.135,26.045),(23.305,26.045),(23.305,25.875),(23.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,25.875),(23.495,26.045),(23.665,26.045),(23.665,25.875),(23.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,25.875),(23.855,26.045),(24.025,26.045),(24.025,25.875),(23.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,26.235),(22.775,26.405),(22.945,26.405),(22.945,26.235),(22.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,26.235),(23.135,26.405),(23.305,26.405),(23.305,26.235),(23.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,26.235),(23.495,26.405),(23.665,26.405),(23.665,26.235),(23.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,26.235),(23.855,26.405),(24.025,26.405),(24.025,26.235),(23.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,26.595),(22.775,26.765),(22.945,26.765),(22.945,26.595),(22.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,26.595),(23.135,26.765),(23.305,26.765),(23.305,26.595),(23.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,26.595),(23.495,26.765),(23.665,26.765),(23.665,26.595),(23.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,26.595),(23.855,26.765),(24.025,26.765),(24.025,26.595),(23.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,26.955),(22.775,27.125),(22.945,27.125),(22.945,26.955),(22.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,26.955),(23.135,27.125),(23.305,27.125),(23.305,26.955),(23.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,26.955),(23.495,27.125),(23.665,27.125),(23.665,26.955),(23.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,26.955),(23.855,27.125),(24.025,27.125),(24.025,26.955),(23.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,27.315),(22.775,27.485),(22.945,27.485),(22.945,27.315),(22.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,27.315),(23.135,27.485),(23.305,27.485),(23.305,27.315),(23.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,27.315),(23.495,27.485),(23.665,27.485),(23.665,27.315),(23.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,27.315),(23.855,27.485),(24.025,27.485),(24.025,27.315),(23.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,27.675),(22.775,27.845),(22.945,27.845),(22.945,27.675),(22.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,27.675),(23.135,27.845),(23.305,27.845),(23.305,27.675),(23.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,27.675),(23.495,27.845),(23.665,27.845),(23.665,27.675),(23.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,27.675),(23.855,27.845),(24.025,27.845),(24.025,27.675),(23.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,28.035),(22.775,28.205),(22.945,28.205),(22.945,28.035),(22.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,28.035),(23.135,28.205),(23.305,28.205),(23.305,28.035),(23.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,28.035),(23.495,28.205),(23.665,28.205),(23.665,28.035),(23.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,28.035),(23.855,28.205),(24.025,28.205),(24.025,28.035),(23.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,28.395),(22.775,28.565),(22.945,28.565),(22.945,28.395),(22.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,28.395),(23.135,28.565),(23.305,28.565),(23.305,28.395),(23.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,28.395),(23.495,28.565),(23.665,28.565),(23.665,28.395),(23.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,28.395),(23.855,28.565),(24.025,28.565),(24.025,28.395),(23.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,28.755),(22.775,28.925),(22.945,28.925),(22.945,28.755),(22.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,28.755),(23.135,28.925),(23.305,28.925),(23.305,28.755),(23.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,28.755),(23.495,28.925),(23.665,28.925),(23.665,28.755),(23.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,28.755),(23.855,28.925),(24.025,28.925),(24.025,28.755),(23.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,29.115),(22.775,29.285),(22.945,29.285),(22.945,29.115),(22.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,29.115),(23.135,29.285),(23.305,29.285),(23.305,29.115),(23.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,29.115),(23.495,29.285),(23.665,29.285),(23.665,29.115),(23.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,29.115),(23.855,29.285),(24.025,29.285),(24.025,29.115),(23.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,29.475),(22.775,29.645),(22.945,29.645),(22.945,29.475),(22.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,29.475),(23.135,29.645),(23.305,29.645),(23.305,29.475),(23.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,29.475),(23.495,29.645),(23.665,29.645),(23.665,29.475),(23.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,29.475),(23.855,29.645),(24.025,29.645),(24.025,29.475),(23.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,29.835),(22.775,30.005),(22.945,30.005),(22.945,29.835),(22.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,29.835),(23.135,30.005),(23.305,30.005),(23.305,29.835),(23.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,29.835),(23.495,30.005),(23.665,30.005),(23.665,29.835),(23.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,29.835),(23.855,30.005),(24.025,30.005),(24.025,29.835),(23.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,30.195),(22.775,30.365),(22.945,30.365),(22.945,30.195),(22.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,30.195),(23.135,30.365),(23.305,30.365),(23.305,30.195),(23.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,30.195),(23.495,30.365),(23.665,30.365),(23.665,30.195),(23.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,30.195),(23.855,30.365),(24.025,30.365),(24.025,30.195),(23.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,30.555),(22.775,30.725),(22.945,30.725),(22.945,30.555),(22.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,30.555),(23.135,30.725),(23.305,30.725),(23.305,30.555),(23.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,30.555),(23.495,30.725),(23.665,30.725),(23.665,30.555),(23.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,30.555),(23.855,30.725),(24.025,30.725),(24.025,30.555),(23.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,30.915),(22.775,31.085),(22.945,31.085),(22.945,30.915),(22.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,30.915),(23.135,31.085),(23.305,31.085),(23.305,30.915),(23.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,30.915),(23.495,31.085),(23.665,31.085),(23.665,30.915),(23.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,30.915),(23.855,31.085),(24.025,31.085),(24.025,30.915),(23.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,31.275),(22.775,31.445),(22.945,31.445),(22.945,31.275),(22.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,31.275),(23.135,31.445),(23.305,31.445),(23.305,31.275),(23.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,31.275),(23.495,31.445),(23.665,31.445),(23.665,31.275),(23.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,31.275),(23.855,31.445),(24.025,31.445),(24.025,31.275),(23.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,31.635),(22.775,31.805),(22.945,31.805),(22.945,31.635),(22.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,31.635),(23.135,31.805),(23.305,31.805),(23.305,31.635),(23.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,31.635),(23.495,31.805),(23.665,31.805),(23.665,31.635),(23.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,31.635),(23.855,31.805),(24.025,31.805),(24.025,31.635),(23.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,31.995),(22.775,32.165),(22.945,32.165),(22.945,31.995),(22.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,31.995),(23.135,32.165),(23.305,32.165),(23.305,31.995),(23.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,31.995),(23.495,32.165),(23.665,32.165),(23.665,31.995),(23.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,31.995),(23.855,32.165),(24.025,32.165),(24.025,31.995),(23.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,32.355),(22.775,32.525),(22.945,32.525),(22.945,32.355),(22.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,32.355),(23.135,32.525),(23.305,32.525),(23.305,32.355),(23.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,32.355),(23.495,32.525),(23.665,32.525),(23.665,32.355),(23.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,32.355),(23.855,32.525),(24.025,32.525),(24.025,32.355),(23.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,32.715),(22.775,32.885),(22.945,32.885),(22.945,32.715),(22.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,32.715),(23.135,32.885),(23.305,32.885),(23.305,32.715),(23.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,32.715),(23.495,32.885),(23.665,32.885),(23.665,32.715),(23.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,32.715),(23.855,32.885),(24.025,32.885),(24.025,32.715),(23.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,33.075),(22.775,33.245),(22.945,33.245),(22.945,33.075),(22.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,33.075),(23.135,33.245),(23.305,33.245),(23.305,33.075),(23.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,33.075),(23.495,33.245),(23.665,33.245),(23.665,33.075),(23.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,33.075),(23.855,33.245),(24.025,33.245),(24.025,33.075),(23.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,33.435),(22.775,33.605),(22.945,33.605),(22.945,33.435),(22.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,33.435),(23.135,33.605),(23.305,33.605),(23.305,33.435),(23.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,33.435),(23.495,33.605),(23.665,33.605),(23.665,33.435),(23.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,33.435),(23.855,33.605),(24.025,33.605),(24.025,33.435),(23.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,33.795),(22.775,33.965),(22.945,33.965),(22.945,33.795),(22.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,33.795),(23.135,33.965),(23.305,33.965),(23.305,33.795),(23.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,33.795),(23.495,33.965),(23.665,33.965),(23.665,33.795),(23.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,33.795),(23.855,33.965),(24.025,33.965),(24.025,33.795),(23.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,34.155),(22.775,34.325),(22.945,34.325),(22.945,34.155),(22.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,34.155),(23.135,34.325),(23.305,34.325),(23.305,34.155),(23.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,34.155),(23.495,34.325),(23.665,34.325),(23.665,34.155),(23.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,34.155),(23.855,34.325),(24.025,34.325),(24.025,34.155),(23.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,34.515),(22.775,34.685),(22.945,34.685),(22.945,34.515),(22.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,34.515),(23.135,34.685),(23.305,34.685),(23.305,34.515),(23.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,34.515),(23.495,34.685),(23.665,34.685),(23.665,34.515),(23.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,34.515),(23.855,34.685),(24.025,34.685),(24.025,34.515),(23.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,34.875),(22.775,35.045),(22.945,35.045),(22.945,34.875),(22.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,34.875),(23.135,35.045),(23.305,35.045),(23.305,34.875),(23.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,34.875),(23.495,35.045),(23.665,35.045),(23.665,34.875),(23.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,34.875),(23.855,35.045),(24.025,35.045),(24.025,34.875),(23.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,35.235),(22.775,35.405),(22.945,35.405),(22.945,35.235),(22.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,35.235),(23.135,35.405),(23.305,35.405),(23.305,35.235),(23.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,35.235),(23.495,35.405),(23.665,35.405),(23.665,35.235),(23.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,35.235),(23.855,35.405),(24.025,35.405),(24.025,35.235),(23.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,35.595),(22.775,35.765),(22.945,35.765),(22.945,35.595),(22.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,35.595),(23.135,35.765),(23.305,35.765),(23.305,35.595),(23.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,35.595),(23.495,35.765),(23.665,35.765),(23.665,35.595),(23.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,35.595),(23.855,35.765),(24.025,35.765),(24.025,35.595),(23.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,35.955),(22.775,36.125),(22.945,36.125),(22.945,35.955),(22.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,35.955),(23.135,36.125),(23.305,36.125),(23.305,35.955),(23.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,35.955),(23.495,36.125),(23.665,36.125),(23.665,35.955),(23.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,35.955),(23.855,36.125),(24.025,36.125),(24.025,35.955),(23.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,36.315),(22.775,36.485),(22.945,36.485),(22.945,36.315),(22.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,36.315),(23.135,36.485),(23.305,36.485),(23.305,36.315),(23.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,36.315),(23.495,36.485),(23.665,36.485),(23.665,36.315),(23.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,36.315),(23.855,36.485),(24.025,36.485),(24.025,36.315),(23.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,36.675),(22.775,36.845),(22.945,36.845),(22.945,36.675),(22.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,36.675),(23.135,36.845),(23.305,36.845),(23.305,36.675),(23.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,36.675),(23.495,36.845),(23.665,36.845),(23.665,36.675),(23.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,36.675),(23.855,36.845),(24.025,36.845),(24.025,36.675),(23.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,37.035),(22.775,37.205),(22.945,37.205),(22.945,37.035),(22.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,37.035),(23.135,37.205),(23.305,37.205),(23.305,37.035),(23.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,37.035),(23.495,37.205),(23.665,37.205),(23.665,37.035),(23.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,37.035),(23.855,37.205),(24.025,37.205),(24.025,37.035),(23.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,37.395),(22.775,37.565),(22.945,37.565),(22.945,37.395),(22.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,37.395),(23.135,37.565),(23.305,37.565),(23.305,37.395),(23.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,37.395),(23.495,37.565),(23.665,37.565),(23.665,37.395),(23.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,37.395),(23.855,37.565),(24.025,37.565),(24.025,37.395),(23.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,37.755),(22.775,37.925),(22.945,37.925),(22.945,37.755),(22.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,37.755),(23.135,37.925),(23.305,37.925),(23.305,37.755),(23.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,37.755),(23.495,37.925),(23.665,37.925),(23.665,37.755),(23.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,37.755),(23.855,37.925),(24.025,37.925),(24.025,37.755),(23.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,38.115),(22.775,38.285),(22.945,38.285),(22.945,38.115),(22.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,38.115),(23.135,38.285),(23.305,38.285),(23.305,38.115),(23.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,38.115),(23.495,38.285),(23.665,38.285),(23.665,38.115),(23.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,38.115),(23.855,38.285),(24.025,38.285),(24.025,38.115),(23.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,38.475),(22.775,38.645),(22.945,38.645),(22.945,38.475),(22.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,38.475),(23.135,38.645),(23.305,38.645),(23.305,38.475),(23.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,38.475),(23.495,38.645),(23.665,38.645),(23.665,38.475),(23.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,38.475),(23.855,38.645),(24.025,38.645),(24.025,38.475),(23.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,38.835),(22.775,39.005),(22.945,39.005),(22.945,38.835),(22.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,38.835),(23.135,39.005),(23.305,39.005),(23.305,38.835),(23.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,38.835),(23.495,39.005),(23.665,39.005),(23.665,38.835),(23.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,38.835),(23.855,39.005),(24.025,39.005),(24.025,38.835),(23.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,39.195),(22.775,39.365),(22.945,39.365),(22.945,39.195),(22.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,39.195),(23.135,39.365),(23.305,39.365),(23.305,39.195),(23.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,39.195),(23.495,39.365),(23.665,39.365),(23.665,39.195),(23.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,39.195),(23.855,39.365),(24.025,39.365),(24.025,39.195),(23.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,39.555),(22.775,39.725),(22.945,39.725),(22.945,39.555),(22.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,39.555),(23.135,39.725),(23.305,39.725),(23.305,39.555),(23.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,39.555),(23.495,39.725),(23.665,39.725),(23.665,39.555),(23.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,39.555),(23.855,39.725),(24.025,39.725),(24.025,39.555),(23.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,39.915),(22.775,40.085),(22.945,40.085),(22.945,39.915),(22.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,39.915),(23.135,40.085),(23.305,40.085),(23.305,39.915),(23.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,39.915),(23.495,40.085),(23.665,40.085),(23.665,39.915),(23.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,39.915),(23.855,40.085),(24.025,40.085),(24.025,39.915),(23.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,40.275),(22.775,40.445),(22.945,40.445),(22.945,40.275),(22.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,40.275),(23.135,40.445),(23.305,40.445),(23.305,40.275),(23.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,40.275),(23.495,40.445),(23.665,40.445),(23.665,40.275),(23.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,40.275),(23.855,40.445),(24.025,40.445),(24.025,40.275),(23.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,40.635),(22.775,40.805),(22.945,40.805),(22.945,40.635),(22.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,40.635),(23.135,40.805),(23.305,40.805),(23.305,40.635),(23.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,40.635),(23.495,40.805),(23.665,40.805),(23.665,40.635),(23.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,40.635),(23.855,40.805),(24.025,40.805),(24.025,40.635),(23.855,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.835),(46.775,3.005),(46.945,3.005),(46.945,2.835),(46.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.835),(47.135,3.005),(47.305,3.005),(47.305,2.835),(47.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.835),(47.495,3.005),(47.665,3.005),(47.665,2.835),(47.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.835),(47.855,3.005),(48.025,3.005),(48.025,2.835),(47.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.195),(46.775,3.365),(46.945,3.365),(46.945,3.195),(46.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.195),(47.135,3.365),(47.305,3.365),(47.305,3.195),(47.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.195),(47.495,3.365),(47.665,3.365),(47.665,3.195),(47.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.195),(47.855,3.365),(48.025,3.365),(48.025,3.195),(47.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.555),(46.775,3.725),(46.945,3.725),(46.945,3.555),(46.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.555),(47.135,3.725),(47.305,3.725),(47.305,3.555),(47.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.555),(47.495,3.725),(47.665,3.725),(47.665,3.555),(47.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.555),(47.855,3.725),(48.025,3.725),(48.025,3.555),(47.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.915),(46.775,4.085),(46.945,4.085),(46.945,3.915),(46.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.915),(47.135,4.085),(47.305,4.085),(47.305,3.915),(47.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.915),(47.495,4.085),(47.665,4.085),(47.665,3.915),(47.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.915),(47.855,4.085),(48.025,4.085),(48.025,3.915),(47.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.275),(46.775,4.445),(46.945,4.445),(46.945,4.275),(46.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.275),(47.135,4.445),(47.305,4.445),(47.305,4.275),(47.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.275),(47.495,4.445),(47.665,4.445),(47.665,4.275),(47.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.275),(47.855,4.445),(48.025,4.445),(48.025,4.275),(47.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.635),(46.775,4.805),(46.945,4.805),(46.945,4.635),(46.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.635),(47.135,4.805),(47.305,4.805),(47.305,4.635),(47.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.635),(47.495,4.805),(47.665,4.805),(47.665,4.635),(47.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.635),(47.855,4.805),(48.025,4.805),(48.025,4.635),(47.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.995),(46.775,5.165),(46.945,5.165),(46.945,4.995),(46.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.995),(47.135,5.165),(47.305,5.165),(47.305,4.995),(47.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.995),(47.495,5.165),(47.665,5.165),(47.665,4.995),(47.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.995),(47.855,5.165),(48.025,5.165),(48.025,4.995),(47.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.355),(46.775,5.525),(46.945,5.525),(46.945,5.355),(46.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.355),(47.135,5.525),(47.305,5.525),(47.305,5.355),(47.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.355),(47.495,5.525),(47.665,5.525),(47.665,5.355),(47.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.355),(47.855,5.525),(48.025,5.525),(48.025,5.355),(47.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.715),(46.775,5.885),(46.945,5.885),(46.945,5.715),(46.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.715),(47.135,5.885),(47.305,5.885),(47.305,5.715),(47.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.715),(47.495,5.885),(47.665,5.885),(47.665,5.715),(47.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.715),(47.855,5.885),(48.025,5.885),(48.025,5.715),(47.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.075),(46.775,6.245),(46.945,6.245),(46.945,6.075),(46.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.075),(47.135,6.245),(47.305,6.245),(47.305,6.075),(47.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.075),(47.495,6.245),(47.665,6.245),(47.665,6.075),(47.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.075),(47.855,6.245),(48.025,6.245),(48.025,6.075),(47.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.435),(46.775,6.605),(46.945,6.605),(46.945,6.435),(46.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.435),(47.135,6.605),(47.305,6.605),(47.305,6.435),(47.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.435),(47.495,6.605),(47.665,6.605),(47.665,6.435),(47.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.435),(47.855,6.605),(48.025,6.605),(48.025,6.435),(47.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.795),(46.775,6.965),(46.945,6.965),(46.945,6.795),(46.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.795),(47.135,6.965),(47.305,6.965),(47.305,6.795),(47.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.795),(47.495,6.965),(47.665,6.965),(47.665,6.795),(47.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.795),(47.855,6.965),(48.025,6.965),(48.025,6.795),(47.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.155),(46.775,7.325),(46.945,7.325),(46.945,7.155),(46.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.155),(47.135,7.325),(47.305,7.325),(47.305,7.155),(47.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.155),(47.495,7.325),(47.665,7.325),(47.665,7.155),(47.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.155),(47.855,7.325),(48.025,7.325),(48.025,7.155),(47.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.515),(46.775,7.685),(46.945,7.685),(46.945,7.515),(46.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.515),(47.135,7.685),(47.305,7.685),(47.305,7.515),(47.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.515),(47.495,7.685),(47.665,7.685),(47.665,7.515),(47.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.515),(47.855,7.685),(48.025,7.685),(48.025,7.515),(47.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.875),(46.775,8.045),(46.945,8.045),(46.945,7.875),(46.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.875),(47.135,8.045),(47.305,8.045),(47.305,7.875),(47.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.875),(47.495,8.045),(47.665,8.045),(47.665,7.875),(47.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.875),(47.855,8.045),(48.025,8.045),(48.025,7.875),(47.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.235),(46.775,8.405),(46.945,8.405),(46.945,8.235),(46.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.235),(47.135,8.405),(47.305,8.405),(47.305,8.235),(47.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.235),(47.495,8.405),(47.665,8.405),(47.665,8.235),(47.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.235),(47.855,8.405),(48.025,8.405),(48.025,8.235),(47.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.595),(46.775,8.765),(46.945,8.765),(46.945,8.595),(46.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.595),(47.135,8.765),(47.305,8.765),(47.305,8.595),(47.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.595),(47.495,8.765),(47.665,8.765),(47.665,8.595),(47.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.595),(47.855,8.765),(48.025,8.765),(48.025,8.595),(47.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.955),(46.775,9.125),(46.945,9.125),(46.945,8.955),(46.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.955),(47.135,9.125),(47.305,9.125),(47.305,8.955),(47.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.955),(47.495,9.125),(47.665,9.125),(47.665,8.955),(47.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.955),(47.855,9.125),(48.025,9.125),(48.025,8.955),(47.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.315),(46.775,9.485),(46.945,9.485),(46.945,9.315),(46.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.315),(47.135,9.485),(47.305,9.485),(47.305,9.315),(47.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.315),(47.495,9.485),(47.665,9.485),(47.665,9.315),(47.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.315),(47.855,9.485),(48.025,9.485),(48.025,9.315),(47.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.675),(46.775,9.845),(46.945,9.845),(46.945,9.675),(46.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.675),(47.135,9.845),(47.305,9.845),(47.305,9.675),(47.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.675),(47.495,9.845),(47.665,9.845),(47.665,9.675),(47.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.675),(47.855,9.845),(48.025,9.845),(48.025,9.675),(47.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.035),(46.775,10.205),(46.945,10.205),(46.945,10.035),(46.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.035),(47.135,10.205),(47.305,10.205),(47.305,10.035),(47.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.035),(47.495,10.205),(47.665,10.205),(47.665,10.035),(47.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.035),(47.855,10.205),(48.025,10.205),(48.025,10.035),(47.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.395),(46.775,10.565),(46.945,10.565),(46.945,10.395),(46.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.395),(47.135,10.565),(47.305,10.565),(47.305,10.395),(47.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.395),(47.495,10.565),(47.665,10.565),(47.665,10.395),(47.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.395),(47.855,10.565),(48.025,10.565),(48.025,10.395),(47.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.755),(46.775,10.925),(46.945,10.925),(46.945,10.755),(46.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.755),(47.135,10.925),(47.305,10.925),(47.305,10.755),(47.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.755),(47.495,10.925),(47.665,10.925),(47.665,10.755),(47.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.755),(47.855,10.925),(48.025,10.925),(48.025,10.755),(47.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.115),(46.775,11.285),(46.945,11.285),(46.945,11.115),(46.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.115),(47.135,11.285),(47.305,11.285),(47.305,11.115),(47.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.115),(47.495,11.285),(47.665,11.285),(47.665,11.115),(47.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.115),(47.855,11.285),(48.025,11.285),(48.025,11.115),(47.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.475),(46.775,11.645),(46.945,11.645),(46.945,11.475),(46.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.475),(47.135,11.645),(47.305,11.645),(47.305,11.475),(47.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.475),(47.495,11.645),(47.665,11.645),(47.665,11.475),(47.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.475),(47.855,11.645),(48.025,11.645),(48.025,11.475),(47.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.835),(46.775,12.005),(46.945,12.005),(46.945,11.835),(46.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.835),(47.135,12.005),(47.305,12.005),(47.305,11.835),(47.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.835),(47.495,12.005),(47.665,12.005),(47.665,11.835),(47.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.835),(47.855,12.005),(48.025,12.005),(48.025,11.835),(47.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.195),(46.775,12.365),(46.945,12.365),(46.945,12.195),(46.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.195),(47.135,12.365),(47.305,12.365),(47.305,12.195),(47.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.195),(47.495,12.365),(47.665,12.365),(47.665,12.195),(47.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.195),(47.855,12.365),(48.025,12.365),(48.025,12.195),(47.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.555),(46.775,12.725),(46.945,12.725),(46.945,12.555),(46.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.555),(47.135,12.725),(47.305,12.725),(47.305,12.555),(47.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.555),(47.495,12.725),(47.665,12.725),(47.665,12.555),(47.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.555),(47.855,12.725),(48.025,12.725),(48.025,12.555),(47.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.915),(46.775,13.085),(46.945,13.085),(46.945,12.915),(46.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.915),(47.135,13.085),(47.305,13.085),(47.305,12.915),(47.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.915),(47.495,13.085),(47.665,13.085),(47.665,12.915),(47.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.915),(47.855,13.085),(48.025,13.085),(48.025,12.915),(47.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.275),(46.775,13.445),(46.945,13.445),(46.945,13.275),(46.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.275),(47.135,13.445),(47.305,13.445),(47.305,13.275),(47.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.275),(47.495,13.445),(47.665,13.445),(47.665,13.275),(47.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.275),(47.855,13.445),(48.025,13.445),(48.025,13.275),(47.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.635),(46.775,13.805),(46.945,13.805),(46.945,13.635),(46.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.635),(47.135,13.805),(47.305,13.805),(47.305,13.635),(47.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.635),(47.495,13.805),(47.665,13.805),(47.665,13.635),(47.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.635),(47.855,13.805),(48.025,13.805),(48.025,13.635),(47.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.995),(46.775,14.165),(46.945,14.165),(46.945,13.995),(46.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.995),(47.135,14.165),(47.305,14.165),(47.305,13.995),(47.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.995),(47.495,14.165),(47.665,14.165),(47.665,13.995),(47.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.995),(47.855,14.165),(48.025,14.165),(48.025,13.995),(47.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.355),(46.775,14.525),(46.945,14.525),(46.945,14.355),(46.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.355),(47.135,14.525),(47.305,14.525),(47.305,14.355),(47.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.355),(47.495,14.525),(47.665,14.525),(47.665,14.355),(47.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.355),(47.855,14.525),(48.025,14.525),(48.025,14.355),(47.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.715),(46.775,14.885),(46.945,14.885),(46.945,14.715),(46.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.715),(47.135,14.885),(47.305,14.885),(47.305,14.715),(47.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.715),(47.495,14.885),(47.665,14.885),(47.665,14.715),(47.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.715),(47.855,14.885),(48.025,14.885),(48.025,14.715),(47.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.075),(46.775,15.245),(46.945,15.245),(46.945,15.075),(46.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.075),(47.135,15.245),(47.305,15.245),(47.305,15.075),(47.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.075),(47.495,15.245),(47.665,15.245),(47.665,15.075),(47.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.075),(47.855,15.245),(48.025,15.245),(48.025,15.075),(47.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.435),(46.775,15.605),(46.945,15.605),(46.945,15.435),(46.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.435),(47.135,15.605),(47.305,15.605),(47.305,15.435),(47.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.435),(47.495,15.605),(47.665,15.605),(47.665,15.435),(47.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.435),(47.855,15.605),(48.025,15.605),(48.025,15.435),(47.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.795),(46.775,15.965),(46.945,15.965),(46.945,15.795),(46.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.795),(47.135,15.965),(47.305,15.965),(47.305,15.795),(47.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.795),(47.495,15.965),(47.665,15.965),(47.665,15.795),(47.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.795),(47.855,15.965),(48.025,15.965),(48.025,15.795),(47.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.155),(46.775,16.325),(46.945,16.325),(46.945,16.155),(46.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.155),(47.135,16.325),(47.305,16.325),(47.305,16.155),(47.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.155),(47.495,16.325),(47.665,16.325),(47.665,16.155),(47.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.155),(47.855,16.325),(48.025,16.325),(48.025,16.155),(47.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.515),(46.775,16.685),(46.945,16.685),(46.945,16.515),(46.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.515),(47.135,16.685),(47.305,16.685),(47.305,16.515),(47.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.515),(47.495,16.685),(47.665,16.685),(47.665,16.515),(47.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.515),(47.855,16.685),(48.025,16.685),(48.025,16.515),(47.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.875),(46.775,17.045),(46.945,17.045),(46.945,16.875),(46.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.875),(47.135,17.045),(47.305,17.045),(47.305,16.875),(47.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.875),(47.495,17.045),(47.665,17.045),(47.665,16.875),(47.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.875),(47.855,17.045),(48.025,17.045),(48.025,16.875),(47.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.235),(46.775,17.405),(46.945,17.405),(46.945,17.235),(46.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.235),(47.135,17.405),(47.305,17.405),(47.305,17.235),(47.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.235),(47.495,17.405),(47.665,17.405),(47.665,17.235),(47.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.235),(47.855,17.405),(48.025,17.405),(48.025,17.235),(47.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.595),(46.775,17.765),(46.945,17.765),(46.945,17.595),(46.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.595),(47.135,17.765),(47.305,17.765),(47.305,17.595),(47.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.595),(47.495,17.765),(47.665,17.765),(47.665,17.595),(47.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.595),(47.855,17.765),(48.025,17.765),(48.025,17.595),(47.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.955),(46.775,18.125),(46.945,18.125),(46.945,17.955),(46.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.955),(47.135,18.125),(47.305,18.125),(47.305,17.955),(47.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.955),(47.495,18.125),(47.665,18.125),(47.665,17.955),(47.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.955),(47.855,18.125),(48.025,18.125),(48.025,17.955),(47.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.315),(46.775,18.485),(46.945,18.485),(46.945,18.315),(46.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.315),(47.135,18.485),(47.305,18.485),(47.305,18.315),(47.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.315),(47.495,18.485),(47.665,18.485),(47.665,18.315),(47.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.315),(47.855,18.485),(48.025,18.485),(48.025,18.315),(47.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.675),(46.775,18.845),(46.945,18.845),(46.945,18.675),(46.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.675),(47.135,18.845),(47.305,18.845),(47.305,18.675),(47.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.675),(47.495,18.845),(47.665,18.845),(47.665,18.675),(47.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.675),(47.855,18.845),(48.025,18.845),(48.025,18.675),(47.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.035),(46.775,19.205),(46.945,19.205),(46.945,19.035),(46.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.035),(47.135,19.205),(47.305,19.205),(47.305,19.035),(47.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.035),(47.495,19.205),(47.665,19.205),(47.665,19.035),(47.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.035),(47.855,19.205),(48.025,19.205),(48.025,19.035),(47.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.395),(46.775,19.565),(46.945,19.565),(46.945,19.395),(46.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.395),(47.135,19.565),(47.305,19.565),(47.305,19.395),(47.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.395),(47.495,19.565),(47.665,19.565),(47.665,19.395),(47.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.395),(47.855,19.565),(48.025,19.565),(48.025,19.395),(47.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.755),(46.775,19.925),(46.945,19.925),(46.945,19.755),(46.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.755),(47.135,19.925),(47.305,19.925),(47.305,19.755),(47.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.755),(47.495,19.925),(47.665,19.925),(47.665,19.755),(47.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.755),(47.855,19.925),(48.025,19.925),(48.025,19.755),(47.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.115),(46.775,20.285),(46.945,20.285),(46.945,20.115),(46.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.115),(47.135,20.285),(47.305,20.285),(47.305,20.115),(47.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.115),(47.495,20.285),(47.665,20.285),(47.665,20.115),(47.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.115),(47.855,20.285),(48.025,20.285),(48.025,20.115),(47.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.475),(46.775,20.645),(46.945,20.645),(46.945,20.475),(46.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.475),(47.135,20.645),(47.305,20.645),(47.305,20.475),(47.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.475),(47.495,20.645),(47.665,20.645),(47.665,20.475),(47.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.475),(47.855,20.645),(48.025,20.645),(48.025,20.475),(47.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.835),(46.775,21.005),(46.945,21.005),(46.945,20.835),(46.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.835),(47.135,21.005),(47.305,21.005),(47.305,20.835),(47.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.835),(47.495,21.005),(47.665,21.005),(47.665,20.835),(47.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.835),(47.855,21.005),(48.025,21.005),(48.025,20.835),(47.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.195),(46.775,21.365),(46.945,21.365),(46.945,21.195),(46.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.195),(47.135,21.365),(47.305,21.365),(47.305,21.195),(47.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.195),(47.495,21.365),(47.665,21.365),(47.665,21.195),(47.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.195),(47.855,21.365),(48.025,21.365),(48.025,21.195),(47.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.555),(46.775,21.725),(46.945,21.725),(46.945,21.555),(46.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.555),(47.135,21.725),(47.305,21.725),(47.305,21.555),(47.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.555),(47.495,21.725),(47.665,21.725),(47.665,21.555),(47.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.555),(47.855,21.725),(48.025,21.725),(48.025,21.555),(47.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.915),(46.775,22.085),(46.945,22.085),(46.945,21.915),(46.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.915),(47.135,22.085),(47.305,22.085),(47.305,21.915),(47.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.915),(47.495,22.085),(47.665,22.085),(47.665,21.915),(47.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.915),(47.855,22.085),(48.025,22.085),(48.025,21.915),(47.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.275),(46.775,22.445),(46.945,22.445),(46.945,22.275),(46.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.275),(47.135,22.445),(47.305,22.445),(47.305,22.275),(47.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.275),(47.495,22.445),(47.665,22.445),(47.665,22.275),(47.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.275),(47.855,22.445),(48.025,22.445),(48.025,22.275),(47.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.635),(46.775,22.805),(46.945,22.805),(46.945,22.635),(46.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.635),(47.135,22.805),(47.305,22.805),(47.305,22.635),(47.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.635),(47.495,22.805),(47.665,22.805),(47.665,22.635),(47.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.635),(47.855,22.805),(48.025,22.805),(48.025,22.635),(47.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.995),(46.775,23.165),(46.945,23.165),(46.945,22.995),(46.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.995),(47.135,23.165),(47.305,23.165),(47.305,22.995),(47.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.995),(47.495,23.165),(47.665,23.165),(47.665,22.995),(47.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.995),(47.855,23.165),(48.025,23.165),(48.025,22.995),(47.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,23.355),(46.775,23.525),(46.945,23.525),(46.945,23.355),(46.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,23.355),(47.135,23.525),(47.305,23.525),(47.305,23.355),(47.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,23.355),(47.495,23.525),(47.665,23.525),(47.665,23.355),(47.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,23.355),(47.855,23.525),(48.025,23.525),(48.025,23.355),(47.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,23.715),(46.775,23.885),(46.945,23.885),(46.945,23.715),(46.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,23.715),(47.135,23.885),(47.305,23.885),(47.305,23.715),(47.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,23.715),(47.495,23.885),(47.665,23.885),(47.665,23.715),(47.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,23.715),(47.855,23.885),(48.025,23.885),(48.025,23.715),(47.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.075),(46.775,24.245),(46.945,24.245),(46.945,24.075),(46.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.075),(47.135,24.245),(47.305,24.245),(47.305,24.075),(47.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.075),(47.495,24.245),(47.665,24.245),(47.665,24.075),(47.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.075),(47.855,24.245),(48.025,24.245),(48.025,24.075),(47.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.435),(46.775,24.605),(46.945,24.605),(46.945,24.435),(46.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.435),(47.135,24.605),(47.305,24.605),(47.305,24.435),(47.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.435),(47.495,24.605),(47.665,24.605),(47.665,24.435),(47.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.435),(47.855,24.605),(48.025,24.605),(48.025,24.435),(47.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.795),(46.775,24.965),(46.945,24.965),(46.945,24.795),(46.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.795),(47.135,24.965),(47.305,24.965),(47.305,24.795),(47.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.795),(47.495,24.965),(47.665,24.965),(47.665,24.795),(47.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.795),(47.855,24.965),(48.025,24.965),(48.025,24.795),(47.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.155),(46.775,25.325),(46.945,25.325),(46.945,25.155),(46.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.155),(47.135,25.325),(47.305,25.325),(47.305,25.155),(47.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.155),(47.495,25.325),(47.665,25.325),(47.665,25.155),(47.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.155),(47.855,25.325),(48.025,25.325),(48.025,25.155),(47.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.515),(46.775,25.685),(46.945,25.685),(46.945,25.515),(46.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.515),(47.135,25.685),(47.305,25.685),(47.305,25.515),(47.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.515),(47.495,25.685),(47.665,25.685),(47.665,25.515),(47.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.515),(47.855,25.685),(48.025,25.685),(48.025,25.515),(47.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.875),(46.775,26.045),(46.945,26.045),(46.945,25.875),(46.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.875),(47.135,26.045),(47.305,26.045),(47.305,25.875),(47.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.875),(47.495,26.045),(47.665,26.045),(47.665,25.875),(47.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.875),(47.855,26.045),(48.025,26.045),(48.025,25.875),(47.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.235),(46.775,26.405),(46.945,26.405),(46.945,26.235),(46.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.235),(47.135,26.405),(47.305,26.405),(47.305,26.235),(47.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.235),(47.495,26.405),(47.665,26.405),(47.665,26.235),(47.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.235),(47.855,26.405),(48.025,26.405),(48.025,26.235),(47.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.595),(46.775,26.765),(46.945,26.765),(46.945,26.595),(46.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.595),(47.135,26.765),(47.305,26.765),(47.305,26.595),(47.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.595),(47.495,26.765),(47.665,26.765),(47.665,26.595),(47.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.595),(47.855,26.765),(48.025,26.765),(48.025,26.595),(47.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.955),(46.775,27.125),(46.945,27.125),(46.945,26.955),(46.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.955),(47.135,27.125),(47.305,27.125),(47.305,26.955),(47.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.955),(47.495,27.125),(47.665,27.125),(47.665,26.955),(47.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.955),(47.855,27.125),(48.025,27.125),(48.025,26.955),(47.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,27.315),(46.775,27.485),(46.945,27.485),(46.945,27.315),(46.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,27.315),(47.135,27.485),(47.305,27.485),(47.305,27.315),(47.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,27.315),(47.495,27.485),(47.665,27.485),(47.665,27.315),(47.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,27.315),(47.855,27.485),(48.025,27.485),(48.025,27.315),(47.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,27.675),(46.775,27.845),(46.945,27.845),(46.945,27.675),(46.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,27.675),(47.135,27.845),(47.305,27.845),(47.305,27.675),(47.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,27.675),(47.495,27.845),(47.665,27.845),(47.665,27.675),(47.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,27.675),(47.855,27.845),(48.025,27.845),(48.025,27.675),(47.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.035),(46.775,28.205),(46.945,28.205),(46.945,28.035),(46.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.035),(47.135,28.205),(47.305,28.205),(47.305,28.035),(47.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.035),(47.495,28.205),(47.665,28.205),(47.665,28.035),(47.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.035),(47.855,28.205),(48.025,28.205),(48.025,28.035),(47.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.395),(46.775,28.565),(46.945,28.565),(46.945,28.395),(46.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.395),(47.135,28.565),(47.305,28.565),(47.305,28.395),(47.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.395),(47.495,28.565),(47.665,28.565),(47.665,28.395),(47.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.395),(47.855,28.565),(48.025,28.565),(48.025,28.395),(47.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.755),(46.775,28.925),(46.945,28.925),(46.945,28.755),(46.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.755),(47.135,28.925),(47.305,28.925),(47.305,28.755),(47.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.755),(47.495,28.925),(47.665,28.925),(47.665,28.755),(47.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.755),(47.855,28.925),(48.025,28.925),(48.025,28.755),(47.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.115),(46.775,29.285),(46.945,29.285),(46.945,29.115),(46.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.115),(47.135,29.285),(47.305,29.285),(47.305,29.115),(47.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.115),(47.495,29.285),(47.665,29.285),(47.665,29.115),(47.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.115),(47.855,29.285),(48.025,29.285),(48.025,29.115),(47.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.475),(46.775,29.645),(46.945,29.645),(46.945,29.475),(46.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.475),(47.135,29.645),(47.305,29.645),(47.305,29.475),(47.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.475),(47.495,29.645),(47.665,29.645),(47.665,29.475),(47.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.475),(47.855,29.645),(48.025,29.645),(48.025,29.475),(47.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.835),(46.775,30.005),(46.945,30.005),(46.945,29.835),(46.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.835),(47.135,30.005),(47.305,30.005),(47.305,29.835),(47.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.835),(47.495,30.005),(47.665,30.005),(47.665,29.835),(47.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.835),(47.855,30.005),(48.025,30.005),(48.025,29.835),(47.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.195),(46.775,30.365),(46.945,30.365),(46.945,30.195),(46.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.195),(47.135,30.365),(47.305,30.365),(47.305,30.195),(47.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.195),(47.495,30.365),(47.665,30.365),(47.665,30.195),(47.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.195),(47.855,30.365),(48.025,30.365),(48.025,30.195),(47.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.555),(46.775,30.725),(46.945,30.725),(46.945,30.555),(46.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.555),(47.135,30.725),(47.305,30.725),(47.305,30.555),(47.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.555),(47.495,30.725),(47.665,30.725),(47.665,30.555),(47.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.555),(47.855,30.725),(48.025,30.725),(48.025,30.555),(47.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.915),(46.775,31.085),(46.945,31.085),(46.945,30.915),(46.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.915),(47.135,31.085),(47.305,31.085),(47.305,30.915),(47.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.915),(47.495,31.085),(47.665,31.085),(47.665,30.915),(47.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.915),(47.855,31.085),(48.025,31.085),(48.025,30.915),(47.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.275),(46.775,31.445),(46.945,31.445),(46.945,31.275),(46.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.275),(47.135,31.445),(47.305,31.445),(47.305,31.275),(47.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.275),(47.495,31.445),(47.665,31.445),(47.665,31.275),(47.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.275),(47.855,31.445),(48.025,31.445),(48.025,31.275),(47.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.635),(46.775,31.805),(46.945,31.805),(46.945,31.635),(46.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.635),(47.135,31.805),(47.305,31.805),(47.305,31.635),(47.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.635),(47.495,31.805),(47.665,31.805),(47.665,31.635),(47.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.635),(47.855,31.805),(48.025,31.805),(48.025,31.635),(47.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.995),(46.775,32.165),(46.945,32.165),(46.945,31.995),(46.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.995),(47.135,32.165),(47.305,32.165),(47.305,31.995),(47.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.995),(47.495,32.165),(47.665,32.165),(47.665,31.995),(47.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.995),(47.855,32.165),(48.025,32.165),(48.025,31.995),(47.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,32.355),(46.775,32.525),(46.945,32.525),(46.945,32.355),(46.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,32.355),(47.135,32.525),(47.305,32.525),(47.305,32.355),(47.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,32.355),(47.495,32.525),(47.665,32.525),(47.665,32.355),(47.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,32.355),(47.855,32.525),(48.025,32.525),(48.025,32.355),(47.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,32.715),(46.775,32.885),(46.945,32.885),(46.945,32.715),(46.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,32.715),(47.135,32.885),(47.305,32.885),(47.305,32.715),(47.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,32.715),(47.495,32.885),(47.665,32.885),(47.665,32.715),(47.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,32.715),(47.855,32.885),(48.025,32.885),(48.025,32.715),(47.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.075),(46.775,33.245),(46.945,33.245),(46.945,33.075),(46.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.075),(47.135,33.245),(47.305,33.245),(47.305,33.075),(47.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.075),(47.495,33.245),(47.665,33.245),(47.665,33.075),(47.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.075),(47.855,33.245),(48.025,33.245),(48.025,33.075),(47.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.435),(46.775,33.605),(46.945,33.605),(46.945,33.435),(46.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.435),(47.135,33.605),(47.305,33.605),(47.305,33.435),(47.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.435),(47.495,33.605),(47.665,33.605),(47.665,33.435),(47.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.435),(47.855,33.605),(48.025,33.605),(48.025,33.435),(47.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.795),(46.775,33.965),(46.945,33.965),(46.945,33.795),(46.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.795),(47.135,33.965),(47.305,33.965),(47.305,33.795),(47.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.795),(47.495,33.965),(47.665,33.965),(47.665,33.795),(47.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.795),(47.855,33.965),(48.025,33.965),(48.025,33.795),(47.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.155),(46.775,34.325),(46.945,34.325),(46.945,34.155),(46.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.155),(47.135,34.325),(47.305,34.325),(47.305,34.155),(47.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.155),(47.495,34.325),(47.665,34.325),(47.665,34.155),(47.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.155),(47.855,34.325),(48.025,34.325),(48.025,34.155),(47.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.515),(46.775,34.685),(46.945,34.685),(46.945,34.515),(46.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.515),(47.135,34.685),(47.305,34.685),(47.305,34.515),(47.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.515),(47.495,34.685),(47.665,34.685),(47.665,34.515),(47.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.515),(47.855,34.685),(48.025,34.685),(48.025,34.515),(47.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.875),(46.775,35.045),(46.945,35.045),(46.945,34.875),(46.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.875),(47.135,35.045),(47.305,35.045),(47.305,34.875),(47.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.875),(47.495,35.045),(47.665,35.045),(47.665,34.875),(47.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.875),(47.855,35.045),(48.025,35.045),(48.025,34.875),(47.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.235),(46.775,35.405),(46.945,35.405),(46.945,35.235),(46.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.235),(47.135,35.405),(47.305,35.405),(47.305,35.235),(47.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.235),(47.495,35.405),(47.665,35.405),(47.665,35.235),(47.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.235),(47.855,35.405),(48.025,35.405),(48.025,35.235),(47.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.595),(46.775,35.765),(46.945,35.765),(46.945,35.595),(46.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.595),(47.135,35.765),(47.305,35.765),(47.305,35.595),(47.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.595),(47.495,35.765),(47.665,35.765),(47.665,35.595),(47.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.595),(47.855,35.765),(48.025,35.765),(48.025,35.595),(47.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.955),(46.775,36.125),(46.945,36.125),(46.945,35.955),(46.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.955),(47.135,36.125),(47.305,36.125),(47.305,35.955),(47.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.955),(47.495,36.125),(47.665,36.125),(47.665,35.955),(47.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.955),(47.855,36.125),(48.025,36.125),(48.025,35.955),(47.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,36.315),(46.775,36.485),(46.945,36.485),(46.945,36.315),(46.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,36.315),(47.135,36.485),(47.305,36.485),(47.305,36.315),(47.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,36.315),(47.495,36.485),(47.665,36.485),(47.665,36.315),(47.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,36.315),(47.855,36.485),(48.025,36.485),(48.025,36.315),(47.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,36.675),(46.775,36.845),(46.945,36.845),(46.945,36.675),(46.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,36.675),(47.135,36.845),(47.305,36.845),(47.305,36.675),(47.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,36.675),(47.495,36.845),(47.665,36.845),(47.665,36.675),(47.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,36.675),(47.855,36.845),(48.025,36.845),(48.025,36.675),(47.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.035),(46.775,37.205),(46.945,37.205),(46.945,37.035),(46.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.035),(47.135,37.205),(47.305,37.205),(47.305,37.035),(47.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.035),(47.495,37.205),(47.665,37.205),(47.665,37.035),(47.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.035),(47.855,37.205),(48.025,37.205),(48.025,37.035),(47.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.395),(46.775,37.565),(46.945,37.565),(46.945,37.395),(46.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.395),(47.135,37.565),(47.305,37.565),(47.305,37.395),(47.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.395),(47.495,37.565),(47.665,37.565),(47.665,37.395),(47.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.395),(47.855,37.565),(48.025,37.565),(48.025,37.395),(47.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.755),(46.775,37.925),(46.945,37.925),(46.945,37.755),(46.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.755),(47.135,37.925),(47.305,37.925),(47.305,37.755),(47.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.755),(47.495,37.925),(47.665,37.925),(47.665,37.755),(47.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.755),(47.855,37.925),(48.025,37.925),(48.025,37.755),(47.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.115),(46.775,38.285),(46.945,38.285),(46.945,38.115),(46.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.115),(47.135,38.285),(47.305,38.285),(47.305,38.115),(47.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.115),(47.495,38.285),(47.665,38.285),(47.665,38.115),(47.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.115),(47.855,38.285),(48.025,38.285),(48.025,38.115),(47.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.475),(46.775,38.645),(46.945,38.645),(46.945,38.475),(46.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.475),(47.135,38.645),(47.305,38.645),(47.305,38.475),(47.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.475),(47.495,38.645),(47.665,38.645),(47.665,38.475),(47.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.475),(47.855,38.645),(48.025,38.645),(48.025,38.475),(47.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.835),(46.775,39.005),(46.945,39.005),(46.945,38.835),(46.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.835),(47.135,39.005),(47.305,39.005),(47.305,38.835),(47.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.835),(47.495,39.005),(47.665,39.005),(47.665,38.835),(47.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.835),(47.855,39.005),(48.025,39.005),(48.025,38.835),(47.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.195),(46.775,39.365),(46.945,39.365),(46.945,39.195),(46.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.195),(47.135,39.365),(47.305,39.365),(47.305,39.195),(47.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.195),(47.495,39.365),(47.665,39.365),(47.665,39.195),(47.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.195),(47.855,39.365),(48.025,39.365),(48.025,39.195),(47.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.555),(46.775,39.725),(46.945,39.725),(46.945,39.555),(46.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.555),(47.135,39.725),(47.305,39.725),(47.305,39.555),(47.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.555),(47.495,39.725),(47.665,39.725),(47.665,39.555),(47.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.555),(47.855,39.725),(48.025,39.725),(48.025,39.555),(47.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.915),(46.775,40.085),(46.945,40.085),(46.945,39.915),(46.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.915),(47.135,40.085),(47.305,40.085),(47.305,39.915),(47.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.915),(47.495,40.085),(47.665,40.085),(47.665,39.915),(47.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.915),(47.855,40.085),(48.025,40.085),(48.025,39.915),(47.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,40.275),(46.775,40.445),(46.945,40.445),(46.945,40.275),(46.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,40.275),(47.135,40.445),(47.305,40.445),(47.305,40.275),(47.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,40.275),(47.495,40.445),(47.665,40.445),(47.665,40.275),(47.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,40.275),(47.855,40.445),(48.025,40.445),(48.025,40.275),(47.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,40.635),(46.775,40.805),(46.945,40.805),(46.945,40.635),(46.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,40.635),(47.135,40.805),(47.305,40.805),(47.305,40.635),(47.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,40.635),(47.495,40.805),(47.665,40.805),(47.665,40.635),(47.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,40.635),(47.855,40.805),(48.025,40.805),(48.025,40.635),(47.855,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,2.835),(13.175,3.005),(13.345,3.005),(13.345,2.835),(13.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,2.835),(13.535,3.005),(13.705,3.005),(13.705,2.835),(13.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,2.835),(13.895,3.005),(14.065,3.005),(14.065,2.835),(13.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,2.835),(14.255,3.005),(14.425,3.005),(14.425,2.835),(14.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.195),(13.175,3.365),(13.345,3.365),(13.345,3.195),(13.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.195),(13.535,3.365),(13.705,3.365),(13.705,3.195),(13.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.195),(13.895,3.365),(14.065,3.365),(14.065,3.195),(13.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.195),(14.255,3.365),(14.425,3.365),(14.425,3.195),(14.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.555),(13.175,3.725),(13.345,3.725),(13.345,3.555),(13.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.555),(13.535,3.725),(13.705,3.725),(13.705,3.555),(13.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.555),(13.895,3.725),(14.065,3.725),(14.065,3.555),(13.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.555),(14.255,3.725),(14.425,3.725),(14.425,3.555),(14.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.915),(13.175,4.085),(13.345,4.085),(13.345,3.915),(13.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.915),(13.535,4.085),(13.705,4.085),(13.705,3.915),(13.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.915),(13.895,4.085),(14.065,4.085),(14.065,3.915),(13.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.915),(14.255,4.085),(14.425,4.085),(14.425,3.915),(14.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.275),(13.175,4.445),(13.345,4.445),(13.345,4.275),(13.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.275),(13.535,4.445),(13.705,4.445),(13.705,4.275),(13.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.275),(13.895,4.445),(14.065,4.445),(14.065,4.275),(13.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.275),(14.255,4.445),(14.425,4.445),(14.425,4.275),(14.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.635),(13.175,4.805),(13.345,4.805),(13.345,4.635),(13.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.635),(13.535,4.805),(13.705,4.805),(13.705,4.635),(13.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.635),(13.895,4.805),(14.065,4.805),(14.065,4.635),(13.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.635),(14.255,4.805),(14.425,4.805),(14.425,4.635),(14.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.995),(13.175,5.165),(13.345,5.165),(13.345,4.995),(13.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.995),(13.535,5.165),(13.705,5.165),(13.705,4.995),(13.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.995),(13.895,5.165),(14.065,5.165),(14.065,4.995),(13.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.995),(14.255,5.165),(14.425,5.165),(14.425,4.995),(14.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.355),(13.175,5.525),(13.345,5.525),(13.345,5.355),(13.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.355),(13.535,5.525),(13.705,5.525),(13.705,5.355),(13.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.355),(13.895,5.525),(14.065,5.525),(14.065,5.355),(13.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.355),(14.255,5.525),(14.425,5.525),(14.425,5.355),(14.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.715),(13.175,5.885),(13.345,5.885),(13.345,5.715),(13.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.715),(13.535,5.885),(13.705,5.885),(13.705,5.715),(13.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.715),(13.895,5.885),(14.065,5.885),(14.065,5.715),(13.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.715),(14.255,5.885),(14.425,5.885),(14.425,5.715),(14.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.075),(13.175,6.245),(13.345,6.245),(13.345,6.075),(13.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.075),(13.535,6.245),(13.705,6.245),(13.705,6.075),(13.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.075),(13.895,6.245),(14.065,6.245),(14.065,6.075),(13.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.075),(14.255,6.245),(14.425,6.245),(14.425,6.075),(14.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.435),(13.175,6.605),(13.345,6.605),(13.345,6.435),(13.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.435),(13.535,6.605),(13.705,6.605),(13.705,6.435),(13.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.435),(13.895,6.605),(14.065,6.605),(14.065,6.435),(13.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.435),(14.255,6.605),(14.425,6.605),(14.425,6.435),(14.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.795),(13.175,6.965),(13.345,6.965),(13.345,6.795),(13.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.795),(13.535,6.965),(13.705,6.965),(13.705,6.795),(13.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.795),(13.895,6.965),(14.065,6.965),(14.065,6.795),(13.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.795),(14.255,6.965),(14.425,6.965),(14.425,6.795),(14.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.155),(13.175,7.325),(13.345,7.325),(13.345,7.155),(13.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.155),(13.535,7.325),(13.705,7.325),(13.705,7.155),(13.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.155),(13.895,7.325),(14.065,7.325),(14.065,7.155),(13.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.155),(14.255,7.325),(14.425,7.325),(14.425,7.155),(14.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.515),(13.175,7.685),(13.345,7.685),(13.345,7.515),(13.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.515),(13.535,7.685),(13.705,7.685),(13.705,7.515),(13.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.515),(13.895,7.685),(14.065,7.685),(14.065,7.515),(13.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.515),(14.255,7.685),(14.425,7.685),(14.425,7.515),(14.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.875),(13.175,8.045),(13.345,8.045),(13.345,7.875),(13.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.875),(13.535,8.045),(13.705,8.045),(13.705,7.875),(13.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.875),(13.895,8.045),(14.065,8.045),(14.065,7.875),(13.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.875),(14.255,8.045),(14.425,8.045),(14.425,7.875),(14.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.235),(13.175,8.405),(13.345,8.405),(13.345,8.235),(13.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.235),(13.535,8.405),(13.705,8.405),(13.705,8.235),(13.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.235),(13.895,8.405),(14.065,8.405),(14.065,8.235),(13.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.235),(14.255,8.405),(14.425,8.405),(14.425,8.235),(14.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.595),(13.175,8.765),(13.345,8.765),(13.345,8.595),(13.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.595),(13.535,8.765),(13.705,8.765),(13.705,8.595),(13.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.595),(13.895,8.765),(14.065,8.765),(14.065,8.595),(13.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.595),(14.255,8.765),(14.425,8.765),(14.425,8.595),(14.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.955),(13.175,9.125),(13.345,9.125),(13.345,8.955),(13.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.955),(13.535,9.125),(13.705,9.125),(13.705,8.955),(13.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.955),(13.895,9.125),(14.065,9.125),(14.065,8.955),(13.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.955),(14.255,9.125),(14.425,9.125),(14.425,8.955),(14.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.315),(13.175,9.485),(13.345,9.485),(13.345,9.315),(13.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.315),(13.535,9.485),(13.705,9.485),(13.705,9.315),(13.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.315),(13.895,9.485),(14.065,9.485),(14.065,9.315),(13.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.315),(14.255,9.485),(14.425,9.485),(14.425,9.315),(14.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.675),(13.175,9.845),(13.345,9.845),(13.345,9.675),(13.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.675),(13.535,9.845),(13.705,9.845),(13.705,9.675),(13.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.675),(13.895,9.845),(14.065,9.845),(14.065,9.675),(13.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.675),(14.255,9.845),(14.425,9.845),(14.425,9.675),(14.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.035),(13.175,10.205),(13.345,10.205),(13.345,10.035),(13.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.035),(13.535,10.205),(13.705,10.205),(13.705,10.035),(13.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.035),(13.895,10.205),(14.065,10.205),(14.065,10.035),(13.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.035),(14.255,10.205),(14.425,10.205),(14.425,10.035),(14.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.395),(13.175,10.565),(13.345,10.565),(13.345,10.395),(13.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.395),(13.535,10.565),(13.705,10.565),(13.705,10.395),(13.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.395),(13.895,10.565),(14.065,10.565),(14.065,10.395),(13.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.395),(14.255,10.565),(14.425,10.565),(14.425,10.395),(14.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.755),(13.175,10.925),(13.345,10.925),(13.345,10.755),(13.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.755),(13.535,10.925),(13.705,10.925),(13.705,10.755),(13.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.755),(13.895,10.925),(14.065,10.925),(14.065,10.755),(13.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.755),(14.255,10.925),(14.425,10.925),(14.425,10.755),(14.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.115),(13.175,11.285),(13.345,11.285),(13.345,11.115),(13.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.115),(13.535,11.285),(13.705,11.285),(13.705,11.115),(13.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.115),(13.895,11.285),(14.065,11.285),(14.065,11.115),(13.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.115),(14.255,11.285),(14.425,11.285),(14.425,11.115),(14.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.475),(13.175,11.645),(13.345,11.645),(13.345,11.475),(13.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.475),(13.535,11.645),(13.705,11.645),(13.705,11.475),(13.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.475),(13.895,11.645),(14.065,11.645),(14.065,11.475),(13.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.475),(14.255,11.645),(14.425,11.645),(14.425,11.475),(14.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.835),(13.175,12.005),(13.345,12.005),(13.345,11.835),(13.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.835),(13.535,12.005),(13.705,12.005),(13.705,11.835),(13.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.835),(13.895,12.005),(14.065,12.005),(14.065,11.835),(13.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.835),(14.255,12.005),(14.425,12.005),(14.425,11.835),(14.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.195),(13.175,12.365),(13.345,12.365),(13.345,12.195),(13.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.195),(13.535,12.365),(13.705,12.365),(13.705,12.195),(13.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.195),(13.895,12.365),(14.065,12.365),(14.065,12.195),(13.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.195),(14.255,12.365),(14.425,12.365),(14.425,12.195),(14.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.555),(13.175,12.725),(13.345,12.725),(13.345,12.555),(13.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.555),(13.535,12.725),(13.705,12.725),(13.705,12.555),(13.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.555),(13.895,12.725),(14.065,12.725),(14.065,12.555),(13.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.555),(14.255,12.725),(14.425,12.725),(14.425,12.555),(14.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.915),(13.175,13.085),(13.345,13.085),(13.345,12.915),(13.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.915),(13.535,13.085),(13.705,13.085),(13.705,12.915),(13.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.915),(13.895,13.085),(14.065,13.085),(14.065,12.915),(13.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.915),(14.255,13.085),(14.425,13.085),(14.425,12.915),(14.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.275),(13.175,13.445),(13.345,13.445),(13.345,13.275),(13.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.275),(13.535,13.445),(13.705,13.445),(13.705,13.275),(13.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.275),(13.895,13.445),(14.065,13.445),(14.065,13.275),(13.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.275),(14.255,13.445),(14.425,13.445),(14.425,13.275),(14.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.635),(13.175,13.805),(13.345,13.805),(13.345,13.635),(13.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.635),(13.535,13.805),(13.705,13.805),(13.705,13.635),(13.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.635),(13.895,13.805),(14.065,13.805),(14.065,13.635),(13.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.635),(14.255,13.805),(14.425,13.805),(14.425,13.635),(14.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.995),(13.175,14.165),(13.345,14.165),(13.345,13.995),(13.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.995),(13.535,14.165),(13.705,14.165),(13.705,13.995),(13.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.995),(13.895,14.165),(14.065,14.165),(14.065,13.995),(13.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.995),(14.255,14.165),(14.425,14.165),(14.425,13.995),(14.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.355),(13.175,14.525),(13.345,14.525),(13.345,14.355),(13.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.355),(13.535,14.525),(13.705,14.525),(13.705,14.355),(13.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.355),(13.895,14.525),(14.065,14.525),(14.065,14.355),(13.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.355),(14.255,14.525),(14.425,14.525),(14.425,14.355),(14.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.715),(13.175,14.885),(13.345,14.885),(13.345,14.715),(13.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.715),(13.535,14.885),(13.705,14.885),(13.705,14.715),(13.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.715),(13.895,14.885),(14.065,14.885),(14.065,14.715),(13.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.715),(14.255,14.885),(14.425,14.885),(14.425,14.715),(14.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.075),(13.175,15.245),(13.345,15.245),(13.345,15.075),(13.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.075),(13.535,15.245),(13.705,15.245),(13.705,15.075),(13.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.075),(13.895,15.245),(14.065,15.245),(14.065,15.075),(13.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.075),(14.255,15.245),(14.425,15.245),(14.425,15.075),(14.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.435),(13.175,15.605),(13.345,15.605),(13.345,15.435),(13.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.435),(13.535,15.605),(13.705,15.605),(13.705,15.435),(13.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.435),(13.895,15.605),(14.065,15.605),(14.065,15.435),(13.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.435),(14.255,15.605),(14.425,15.605),(14.425,15.435),(14.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.795),(13.175,15.965),(13.345,15.965),(13.345,15.795),(13.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.795),(13.535,15.965),(13.705,15.965),(13.705,15.795),(13.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.795),(13.895,15.965),(14.065,15.965),(14.065,15.795),(13.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.795),(14.255,15.965),(14.425,15.965),(14.425,15.795),(14.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.155),(13.175,16.325),(13.345,16.325),(13.345,16.155),(13.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.155),(13.535,16.325),(13.705,16.325),(13.705,16.155),(13.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.155),(13.895,16.325),(14.065,16.325),(14.065,16.155),(13.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.155),(14.255,16.325),(14.425,16.325),(14.425,16.155),(14.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.515),(13.175,16.685),(13.345,16.685),(13.345,16.515),(13.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.515),(13.535,16.685),(13.705,16.685),(13.705,16.515),(13.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.515),(13.895,16.685),(14.065,16.685),(14.065,16.515),(13.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.515),(14.255,16.685),(14.425,16.685),(14.425,16.515),(14.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.875),(13.175,17.045),(13.345,17.045),(13.345,16.875),(13.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.875),(13.535,17.045),(13.705,17.045),(13.705,16.875),(13.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.875),(13.895,17.045),(14.065,17.045),(14.065,16.875),(13.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.875),(14.255,17.045),(14.425,17.045),(14.425,16.875),(14.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.235),(13.175,17.405),(13.345,17.405),(13.345,17.235),(13.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.235),(13.535,17.405),(13.705,17.405),(13.705,17.235),(13.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.235),(13.895,17.405),(14.065,17.405),(14.065,17.235),(13.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.235),(14.255,17.405),(14.425,17.405),(14.425,17.235),(14.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.595),(13.175,17.765),(13.345,17.765),(13.345,17.595),(13.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.595),(13.535,17.765),(13.705,17.765),(13.705,17.595),(13.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.595),(13.895,17.765),(14.065,17.765),(14.065,17.595),(13.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.595),(14.255,17.765),(14.425,17.765),(14.425,17.595),(14.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.955),(13.175,18.125),(13.345,18.125),(13.345,17.955),(13.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.955),(13.535,18.125),(13.705,18.125),(13.705,17.955),(13.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.955),(13.895,18.125),(14.065,18.125),(14.065,17.955),(13.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.955),(14.255,18.125),(14.425,18.125),(14.425,17.955),(14.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.315),(13.175,18.485),(13.345,18.485),(13.345,18.315),(13.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.315),(13.535,18.485),(13.705,18.485),(13.705,18.315),(13.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.315),(13.895,18.485),(14.065,18.485),(14.065,18.315),(13.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.315),(14.255,18.485),(14.425,18.485),(14.425,18.315),(14.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.675),(13.175,18.845),(13.345,18.845),(13.345,18.675),(13.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.675),(13.535,18.845),(13.705,18.845),(13.705,18.675),(13.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.675),(13.895,18.845),(14.065,18.845),(14.065,18.675),(13.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.675),(14.255,18.845),(14.425,18.845),(14.425,18.675),(14.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.035),(13.175,19.205),(13.345,19.205),(13.345,19.035),(13.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.035),(13.535,19.205),(13.705,19.205),(13.705,19.035),(13.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.035),(13.895,19.205),(14.065,19.205),(14.065,19.035),(13.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.035),(14.255,19.205),(14.425,19.205),(14.425,19.035),(14.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.395),(13.175,19.565),(13.345,19.565),(13.345,19.395),(13.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.395),(13.535,19.565),(13.705,19.565),(13.705,19.395),(13.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.395),(13.895,19.565),(14.065,19.565),(14.065,19.395),(13.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.395),(14.255,19.565),(14.425,19.565),(14.425,19.395),(14.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.755),(13.175,19.925),(13.345,19.925),(13.345,19.755),(13.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.755),(13.535,19.925),(13.705,19.925),(13.705,19.755),(13.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.755),(13.895,19.925),(14.065,19.925),(14.065,19.755),(13.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.755),(14.255,19.925),(14.425,19.925),(14.425,19.755),(14.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,20.115),(13.175,20.285),(13.345,20.285),(13.345,20.115),(13.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,20.115),(13.535,20.285),(13.705,20.285),(13.705,20.115),(13.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,20.115),(13.895,20.285),(14.065,20.285),(14.065,20.115),(13.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,20.115),(14.255,20.285),(14.425,20.285),(14.425,20.115),(14.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,20.475),(13.175,20.645),(13.345,20.645),(13.345,20.475),(13.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,20.475),(13.535,20.645),(13.705,20.645),(13.705,20.475),(13.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,20.475),(13.895,20.645),(14.065,20.645),(14.065,20.475),(13.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,20.475),(14.255,20.645),(14.425,20.645),(14.425,20.475),(14.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,20.835),(13.175,21.005),(13.345,21.005),(13.345,20.835),(13.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,20.835),(13.535,21.005),(13.705,21.005),(13.705,20.835),(13.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,20.835),(13.895,21.005),(14.065,21.005),(14.065,20.835),(13.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,20.835),(14.255,21.005),(14.425,21.005),(14.425,20.835),(14.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,21.195),(13.175,21.365),(13.345,21.365),(13.345,21.195),(13.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,21.195),(13.535,21.365),(13.705,21.365),(13.705,21.195),(13.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,21.195),(13.895,21.365),(14.065,21.365),(14.065,21.195),(13.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,21.195),(14.255,21.365),(14.425,21.365),(14.425,21.195),(14.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,21.555),(13.175,21.725),(13.345,21.725),(13.345,21.555),(13.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,21.555),(13.535,21.725),(13.705,21.725),(13.705,21.555),(13.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,21.555),(13.895,21.725),(14.065,21.725),(14.065,21.555),(13.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,21.555),(14.255,21.725),(14.425,21.725),(14.425,21.555),(14.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,21.915),(13.175,22.085),(13.345,22.085),(13.345,21.915),(13.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,21.915),(13.535,22.085),(13.705,22.085),(13.705,21.915),(13.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,21.915),(13.895,22.085),(14.065,22.085),(14.065,21.915),(13.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,21.915),(14.255,22.085),(14.425,22.085),(14.425,21.915),(14.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.275),(13.175,22.445),(13.345,22.445),(13.345,22.275),(13.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.275),(13.535,22.445),(13.705,22.445),(13.705,22.275),(13.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.275),(13.895,22.445),(14.065,22.445),(14.065,22.275),(13.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.275),(14.255,22.445),(14.425,22.445),(14.425,22.275),(14.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.635),(13.175,22.805),(13.345,22.805),(13.345,22.635),(13.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.635),(13.535,22.805),(13.705,22.805),(13.705,22.635),(13.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.635),(13.895,22.805),(14.065,22.805),(14.065,22.635),(13.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.635),(14.255,22.805),(14.425,22.805),(14.425,22.635),(14.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.995),(13.175,23.165),(13.345,23.165),(13.345,22.995),(13.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.995),(13.535,23.165),(13.705,23.165),(13.705,22.995),(13.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.995),(13.895,23.165),(14.065,23.165),(14.065,22.995),(13.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.995),(14.255,23.165),(14.425,23.165),(14.425,22.995),(14.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,23.355),(13.175,23.525),(13.345,23.525),(13.345,23.355),(13.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,23.355),(13.535,23.525),(13.705,23.525),(13.705,23.355),(13.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,23.355),(13.895,23.525),(14.065,23.525),(14.065,23.355),(13.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,23.355),(14.255,23.525),(14.425,23.525),(14.425,23.355),(14.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,23.715),(13.175,23.885),(13.345,23.885),(13.345,23.715),(13.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,23.715),(13.535,23.885),(13.705,23.885),(13.705,23.715),(13.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,23.715),(13.895,23.885),(14.065,23.885),(14.065,23.715),(13.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,23.715),(14.255,23.885),(14.425,23.885),(14.425,23.715),(14.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,24.075),(13.175,24.245),(13.345,24.245),(13.345,24.075),(13.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,24.075),(13.535,24.245),(13.705,24.245),(13.705,24.075),(13.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,24.075),(13.895,24.245),(14.065,24.245),(14.065,24.075),(13.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,24.075),(14.255,24.245),(14.425,24.245),(14.425,24.075),(14.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,24.435),(13.175,24.605),(13.345,24.605),(13.345,24.435),(13.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,24.435),(13.535,24.605),(13.705,24.605),(13.705,24.435),(13.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,24.435),(13.895,24.605),(14.065,24.605),(14.065,24.435),(13.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,24.435),(14.255,24.605),(14.425,24.605),(14.425,24.435),(14.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,24.795),(13.175,24.965),(13.345,24.965),(13.345,24.795),(13.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,24.795),(13.535,24.965),(13.705,24.965),(13.705,24.795),(13.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,24.795),(13.895,24.965),(14.065,24.965),(14.065,24.795),(13.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,24.795),(14.255,24.965),(14.425,24.965),(14.425,24.795),(14.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,25.155),(13.175,25.325),(13.345,25.325),(13.345,25.155),(13.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,25.155),(13.535,25.325),(13.705,25.325),(13.705,25.155),(13.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,25.155),(13.895,25.325),(14.065,25.325),(14.065,25.155),(13.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,25.155),(14.255,25.325),(14.425,25.325),(14.425,25.155),(14.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,25.515),(13.175,25.685),(13.345,25.685),(13.345,25.515),(13.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,25.515),(13.535,25.685),(13.705,25.685),(13.705,25.515),(13.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,25.515),(13.895,25.685),(14.065,25.685),(14.065,25.515),(13.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,25.515),(14.255,25.685),(14.425,25.685),(14.425,25.515),(14.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,25.875),(13.175,26.045),(13.345,26.045),(13.345,25.875),(13.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,25.875),(13.535,26.045),(13.705,26.045),(13.705,25.875),(13.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,25.875),(13.895,26.045),(14.065,26.045),(14.065,25.875),(13.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,25.875),(14.255,26.045),(14.425,26.045),(14.425,25.875),(14.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,26.235),(13.175,26.405),(13.345,26.405),(13.345,26.235),(13.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,26.235),(13.535,26.405),(13.705,26.405),(13.705,26.235),(13.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,26.235),(13.895,26.405),(14.065,26.405),(14.065,26.235),(13.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,26.235),(14.255,26.405),(14.425,26.405),(14.425,26.235),(14.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,26.595),(13.175,26.765),(13.345,26.765),(13.345,26.595),(13.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,26.595),(13.535,26.765),(13.705,26.765),(13.705,26.595),(13.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,26.595),(13.895,26.765),(14.065,26.765),(14.065,26.595),(13.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,26.595),(14.255,26.765),(14.425,26.765),(14.425,26.595),(14.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,26.955),(13.175,27.125),(13.345,27.125),(13.345,26.955),(13.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,26.955),(13.535,27.125),(13.705,27.125),(13.705,26.955),(13.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,26.955),(13.895,27.125),(14.065,27.125),(14.065,26.955),(13.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,26.955),(14.255,27.125),(14.425,27.125),(14.425,26.955),(14.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,27.315),(13.175,27.485),(13.345,27.485),(13.345,27.315),(13.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,27.315),(13.535,27.485),(13.705,27.485),(13.705,27.315),(13.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,27.315),(13.895,27.485),(14.065,27.485),(14.065,27.315),(13.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,27.315),(14.255,27.485),(14.425,27.485),(14.425,27.315),(14.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,27.675),(13.175,27.845),(13.345,27.845),(13.345,27.675),(13.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,27.675),(13.535,27.845),(13.705,27.845),(13.705,27.675),(13.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,27.675),(13.895,27.845),(14.065,27.845),(14.065,27.675),(13.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,27.675),(14.255,27.845),(14.425,27.845),(14.425,27.675),(14.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,28.035),(13.175,28.205),(13.345,28.205),(13.345,28.035),(13.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,28.035),(13.535,28.205),(13.705,28.205),(13.705,28.035),(13.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,28.035),(13.895,28.205),(14.065,28.205),(14.065,28.035),(13.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,28.035),(14.255,28.205),(14.425,28.205),(14.425,28.035),(14.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,28.395),(13.175,28.565),(13.345,28.565),(13.345,28.395),(13.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,28.395),(13.535,28.565),(13.705,28.565),(13.705,28.395),(13.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,28.395),(13.895,28.565),(14.065,28.565),(14.065,28.395),(13.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,28.395),(14.255,28.565),(14.425,28.565),(14.425,28.395),(14.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,28.755),(13.175,28.925),(13.345,28.925),(13.345,28.755),(13.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,28.755),(13.535,28.925),(13.705,28.925),(13.705,28.755),(13.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,28.755),(13.895,28.925),(14.065,28.925),(14.065,28.755),(13.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,28.755),(14.255,28.925),(14.425,28.925),(14.425,28.755),(14.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,29.115),(13.175,29.285),(13.345,29.285),(13.345,29.115),(13.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,29.115),(13.535,29.285),(13.705,29.285),(13.705,29.115),(13.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,29.115),(13.895,29.285),(14.065,29.285),(14.065,29.115),(13.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,29.115),(14.255,29.285),(14.425,29.285),(14.425,29.115),(14.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,29.475),(13.175,29.645),(13.345,29.645),(13.345,29.475),(13.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,29.475),(13.535,29.645),(13.705,29.645),(13.705,29.475),(13.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,29.475),(13.895,29.645),(14.065,29.645),(14.065,29.475),(13.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,29.475),(14.255,29.645),(14.425,29.645),(14.425,29.475),(14.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,29.835),(13.175,30.005),(13.345,30.005),(13.345,29.835),(13.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,29.835),(13.535,30.005),(13.705,30.005),(13.705,29.835),(13.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,29.835),(13.895,30.005),(14.065,30.005),(14.065,29.835),(13.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,29.835),(14.255,30.005),(14.425,30.005),(14.425,29.835),(14.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,30.195),(13.175,30.365),(13.345,30.365),(13.345,30.195),(13.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,30.195),(13.535,30.365),(13.705,30.365),(13.705,30.195),(13.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,30.195),(13.895,30.365),(14.065,30.365),(14.065,30.195),(13.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,30.195),(14.255,30.365),(14.425,30.365),(14.425,30.195),(14.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,30.555),(13.175,30.725),(13.345,30.725),(13.345,30.555),(13.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,30.555),(13.535,30.725),(13.705,30.725),(13.705,30.555),(13.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,30.555),(13.895,30.725),(14.065,30.725),(14.065,30.555),(13.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,30.555),(14.255,30.725),(14.425,30.725),(14.425,30.555),(14.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,30.915),(13.175,31.085),(13.345,31.085),(13.345,30.915),(13.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,30.915),(13.535,31.085),(13.705,31.085),(13.705,30.915),(13.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,30.915),(13.895,31.085),(14.065,31.085),(14.065,30.915),(13.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,30.915),(14.255,31.085),(14.425,31.085),(14.425,30.915),(14.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,31.275),(13.175,31.445),(13.345,31.445),(13.345,31.275),(13.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,31.275),(13.535,31.445),(13.705,31.445),(13.705,31.275),(13.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,31.275),(13.895,31.445),(14.065,31.445),(14.065,31.275),(13.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,31.275),(14.255,31.445),(14.425,31.445),(14.425,31.275),(14.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,31.635),(13.175,31.805),(13.345,31.805),(13.345,31.635),(13.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,31.635),(13.535,31.805),(13.705,31.805),(13.705,31.635),(13.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,31.635),(13.895,31.805),(14.065,31.805),(14.065,31.635),(13.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,31.635),(14.255,31.805),(14.425,31.805),(14.425,31.635),(14.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,31.995),(13.175,32.165),(13.345,32.165),(13.345,31.995),(13.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,31.995),(13.535,32.165),(13.705,32.165),(13.705,31.995),(13.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,31.995),(13.895,32.165),(14.065,32.165),(14.065,31.995),(13.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,31.995),(14.255,32.165),(14.425,32.165),(14.425,31.995),(14.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,32.355),(13.175,32.525),(13.345,32.525),(13.345,32.355),(13.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,32.355),(13.535,32.525),(13.705,32.525),(13.705,32.355),(13.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,32.355),(13.895,32.525),(14.065,32.525),(14.065,32.355),(13.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,32.355),(14.255,32.525),(14.425,32.525),(14.425,32.355),(14.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,32.715),(13.175,32.885),(13.345,32.885),(13.345,32.715),(13.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,32.715),(13.535,32.885),(13.705,32.885),(13.705,32.715),(13.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,32.715),(13.895,32.885),(14.065,32.885),(14.065,32.715),(13.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,32.715),(14.255,32.885),(14.425,32.885),(14.425,32.715),(14.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,33.075),(13.175,33.245),(13.345,33.245),(13.345,33.075),(13.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,33.075),(13.535,33.245),(13.705,33.245),(13.705,33.075),(13.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,33.075),(13.895,33.245),(14.065,33.245),(14.065,33.075),(13.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,33.075),(14.255,33.245),(14.425,33.245),(14.425,33.075),(14.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,33.435),(13.175,33.605),(13.345,33.605),(13.345,33.435),(13.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,33.435),(13.535,33.605),(13.705,33.605),(13.705,33.435),(13.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,33.435),(13.895,33.605),(14.065,33.605),(14.065,33.435),(13.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,33.435),(14.255,33.605),(14.425,33.605),(14.425,33.435),(14.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,33.795),(13.175,33.965),(13.345,33.965),(13.345,33.795),(13.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,33.795),(13.535,33.965),(13.705,33.965),(13.705,33.795),(13.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,33.795),(13.895,33.965),(14.065,33.965),(14.065,33.795),(13.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,33.795),(14.255,33.965),(14.425,33.965),(14.425,33.795),(14.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,34.155),(13.175,34.325),(13.345,34.325),(13.345,34.155),(13.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,34.155),(13.535,34.325),(13.705,34.325),(13.705,34.155),(13.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,34.155),(13.895,34.325),(14.065,34.325),(14.065,34.155),(13.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,34.155),(14.255,34.325),(14.425,34.325),(14.425,34.155),(14.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,34.515),(13.175,34.685),(13.345,34.685),(13.345,34.515),(13.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,34.515),(13.535,34.685),(13.705,34.685),(13.705,34.515),(13.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,34.515),(13.895,34.685),(14.065,34.685),(14.065,34.515),(13.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,34.515),(14.255,34.685),(14.425,34.685),(14.425,34.515),(14.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,34.875),(13.175,35.045),(13.345,35.045),(13.345,34.875),(13.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,34.875),(13.535,35.045),(13.705,35.045),(13.705,34.875),(13.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,34.875),(13.895,35.045),(14.065,35.045),(14.065,34.875),(13.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,34.875),(14.255,35.045),(14.425,35.045),(14.425,34.875),(14.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,35.235),(13.175,35.405),(13.345,35.405),(13.345,35.235),(13.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,35.235),(13.535,35.405),(13.705,35.405),(13.705,35.235),(13.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,35.235),(13.895,35.405),(14.065,35.405),(14.065,35.235),(13.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,35.235),(14.255,35.405),(14.425,35.405),(14.425,35.235),(14.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,35.595),(13.175,35.765),(13.345,35.765),(13.345,35.595),(13.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,35.595),(13.535,35.765),(13.705,35.765),(13.705,35.595),(13.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,35.595),(13.895,35.765),(14.065,35.765),(14.065,35.595),(13.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,35.595),(14.255,35.765),(14.425,35.765),(14.425,35.595),(14.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,35.955),(13.175,36.125),(13.345,36.125),(13.345,35.955),(13.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,35.955),(13.535,36.125),(13.705,36.125),(13.705,35.955),(13.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,35.955),(13.895,36.125),(14.065,36.125),(14.065,35.955),(13.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,35.955),(14.255,36.125),(14.425,36.125),(14.425,35.955),(14.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,36.315),(13.175,36.485),(13.345,36.485),(13.345,36.315),(13.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,36.315),(13.535,36.485),(13.705,36.485),(13.705,36.315),(13.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,36.315),(13.895,36.485),(14.065,36.485),(14.065,36.315),(13.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,36.315),(14.255,36.485),(14.425,36.485),(14.425,36.315),(14.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,36.675),(13.175,36.845),(13.345,36.845),(13.345,36.675),(13.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,36.675),(13.535,36.845),(13.705,36.845),(13.705,36.675),(13.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,36.675),(13.895,36.845),(14.065,36.845),(14.065,36.675),(13.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,36.675),(14.255,36.845),(14.425,36.845),(14.425,36.675),(14.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,37.035),(13.175,37.205),(13.345,37.205),(13.345,37.035),(13.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,37.035),(13.535,37.205),(13.705,37.205),(13.705,37.035),(13.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,37.035),(13.895,37.205),(14.065,37.205),(14.065,37.035),(13.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,37.035),(14.255,37.205),(14.425,37.205),(14.425,37.035),(14.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,37.395),(13.175,37.565),(13.345,37.565),(13.345,37.395),(13.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,37.395),(13.535,37.565),(13.705,37.565),(13.705,37.395),(13.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,37.395),(13.895,37.565),(14.065,37.565),(14.065,37.395),(13.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,37.395),(14.255,37.565),(14.425,37.565),(14.425,37.395),(14.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,37.755),(13.175,37.925),(13.345,37.925),(13.345,37.755),(13.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,37.755),(13.535,37.925),(13.705,37.925),(13.705,37.755),(13.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,37.755),(13.895,37.925),(14.065,37.925),(14.065,37.755),(13.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,37.755),(14.255,37.925),(14.425,37.925),(14.425,37.755),(14.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,38.115),(13.175,38.285),(13.345,38.285),(13.345,38.115),(13.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,38.115),(13.535,38.285),(13.705,38.285),(13.705,38.115),(13.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,38.115),(13.895,38.285),(14.065,38.285),(14.065,38.115),(13.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,38.115),(14.255,38.285),(14.425,38.285),(14.425,38.115),(14.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,38.475),(13.175,38.645),(13.345,38.645),(13.345,38.475),(13.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,38.475),(13.535,38.645),(13.705,38.645),(13.705,38.475),(13.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,38.475),(13.895,38.645),(14.065,38.645),(14.065,38.475),(13.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,38.475),(14.255,38.645),(14.425,38.645),(14.425,38.475),(14.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,38.835),(13.175,39.005),(13.345,39.005),(13.345,38.835),(13.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,38.835),(13.535,39.005),(13.705,39.005),(13.705,38.835),(13.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,38.835),(13.895,39.005),(14.065,39.005),(14.065,38.835),(13.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,38.835),(14.255,39.005),(14.425,39.005),(14.425,38.835),(14.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,39.195),(13.175,39.365),(13.345,39.365),(13.345,39.195),(13.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,39.195),(13.535,39.365),(13.705,39.365),(13.705,39.195),(13.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,39.195),(13.895,39.365),(14.065,39.365),(14.065,39.195),(13.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,39.195),(14.255,39.365),(14.425,39.365),(14.425,39.195),(14.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,39.555),(13.175,39.725),(13.345,39.725),(13.345,39.555),(13.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,39.555),(13.535,39.725),(13.705,39.725),(13.705,39.555),(13.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,39.555),(13.895,39.725),(14.065,39.725),(14.065,39.555),(13.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,39.555),(14.255,39.725),(14.425,39.725),(14.425,39.555),(14.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,39.915),(13.175,40.085),(13.345,40.085),(13.345,39.915),(13.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,39.915),(13.535,40.085),(13.705,40.085),(13.705,39.915),(13.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,39.915),(13.895,40.085),(14.065,40.085),(14.065,39.915),(13.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,39.915),(14.255,40.085),(14.425,40.085),(14.425,39.915),(14.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,40.275),(13.175,40.445),(13.345,40.445),(13.345,40.275),(13.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,40.275),(13.535,40.445),(13.705,40.445),(13.705,40.275),(13.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,40.275),(13.895,40.445),(14.065,40.445),(14.065,40.275),(13.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,40.275),(14.255,40.445),(14.425,40.445),(14.425,40.275),(14.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,40.635),(13.175,40.805),(13.345,40.805),(13.345,40.635),(13.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,40.635),(13.535,40.805),(13.705,40.805),(13.705,40.635),(13.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,40.635),(13.895,40.805),(14.065,40.805),(14.065,40.635),(13.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,40.635),(14.255,40.805),(14.425,40.805),(14.425,40.635),(14.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,2.835),(75.575,3.005),(75.745,3.005),(75.745,2.835),(75.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,2.835),(75.935,3.005),(76.105,3.005),(76.105,2.835),(75.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,2.835),(76.295,3.005),(76.465,3.005),(76.465,2.835),(76.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,2.835),(76.655,3.005),(76.825,3.005),(76.825,2.835),(76.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.195),(75.575,3.365),(75.745,3.365),(75.745,3.195),(75.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.195),(75.935,3.365),(76.105,3.365),(76.105,3.195),(75.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.195),(76.295,3.365),(76.465,3.365),(76.465,3.195),(76.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.195),(76.655,3.365),(76.825,3.365),(76.825,3.195),(76.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.555),(75.575,3.725),(75.745,3.725),(75.745,3.555),(75.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.555),(75.935,3.725),(76.105,3.725),(76.105,3.555),(75.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.555),(76.295,3.725),(76.465,3.725),(76.465,3.555),(76.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.555),(76.655,3.725),(76.825,3.725),(76.825,3.555),(76.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.915),(75.575,4.085),(75.745,4.085),(75.745,3.915),(75.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.915),(75.935,4.085),(76.105,4.085),(76.105,3.915),(75.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.915),(76.295,4.085),(76.465,4.085),(76.465,3.915),(76.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.915),(76.655,4.085),(76.825,4.085),(76.825,3.915),(76.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.275),(75.575,4.445),(75.745,4.445),(75.745,4.275),(75.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.275),(75.935,4.445),(76.105,4.445),(76.105,4.275),(75.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.275),(76.295,4.445),(76.465,4.445),(76.465,4.275),(76.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.275),(76.655,4.445),(76.825,4.445),(76.825,4.275),(76.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.635),(75.575,4.805),(75.745,4.805),(75.745,4.635),(75.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.635),(75.935,4.805),(76.105,4.805),(76.105,4.635),(75.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.635),(76.295,4.805),(76.465,4.805),(76.465,4.635),(76.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.635),(76.655,4.805),(76.825,4.805),(76.825,4.635),(76.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.995),(75.575,5.165),(75.745,5.165),(75.745,4.995),(75.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.995),(75.935,5.165),(76.105,5.165),(76.105,4.995),(75.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.995),(76.295,5.165),(76.465,5.165),(76.465,4.995),(76.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.995),(76.655,5.165),(76.825,5.165),(76.825,4.995),(76.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.355),(75.575,5.525),(75.745,5.525),(75.745,5.355),(75.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.355),(75.935,5.525),(76.105,5.525),(76.105,5.355),(75.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.355),(76.295,5.525),(76.465,5.525),(76.465,5.355),(76.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.355),(76.655,5.525),(76.825,5.525),(76.825,5.355),(76.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.715),(75.575,5.885),(75.745,5.885),(75.745,5.715),(75.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.715),(75.935,5.885),(76.105,5.885),(76.105,5.715),(75.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.715),(76.295,5.885),(76.465,5.885),(76.465,5.715),(76.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.715),(76.655,5.885),(76.825,5.885),(76.825,5.715),(76.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.075),(75.575,6.245),(75.745,6.245),(75.745,6.075),(75.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.075),(75.935,6.245),(76.105,6.245),(76.105,6.075),(75.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.075),(76.295,6.245),(76.465,6.245),(76.465,6.075),(76.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.075),(76.655,6.245),(76.825,6.245),(76.825,6.075),(76.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.435),(75.575,6.605),(75.745,6.605),(75.745,6.435),(75.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.435),(75.935,6.605),(76.105,6.605),(76.105,6.435),(75.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.435),(76.295,6.605),(76.465,6.605),(76.465,6.435),(76.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.435),(76.655,6.605),(76.825,6.605),(76.825,6.435),(76.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.795),(75.575,6.965),(75.745,6.965),(75.745,6.795),(75.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.795),(75.935,6.965),(76.105,6.965),(76.105,6.795),(75.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.795),(76.295,6.965),(76.465,6.965),(76.465,6.795),(76.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.795),(76.655,6.965),(76.825,6.965),(76.825,6.795),(76.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.155),(75.575,7.325),(75.745,7.325),(75.745,7.155),(75.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.155),(75.935,7.325),(76.105,7.325),(76.105,7.155),(75.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.155),(76.295,7.325),(76.465,7.325),(76.465,7.155),(76.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.155),(76.655,7.325),(76.825,7.325),(76.825,7.155),(76.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.515),(75.575,7.685),(75.745,7.685),(75.745,7.515),(75.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.515),(75.935,7.685),(76.105,7.685),(76.105,7.515),(75.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.515),(76.295,7.685),(76.465,7.685),(76.465,7.515),(76.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.515),(76.655,7.685),(76.825,7.685),(76.825,7.515),(76.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.875),(75.575,8.045),(75.745,8.045),(75.745,7.875),(75.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.875),(75.935,8.045),(76.105,8.045),(76.105,7.875),(75.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.875),(76.295,8.045),(76.465,8.045),(76.465,7.875),(76.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.875),(76.655,8.045),(76.825,8.045),(76.825,7.875),(76.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.235),(75.575,8.405),(75.745,8.405),(75.745,8.235),(75.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.235),(75.935,8.405),(76.105,8.405),(76.105,8.235),(75.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.235),(76.295,8.405),(76.465,8.405),(76.465,8.235),(76.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.235),(76.655,8.405),(76.825,8.405),(76.825,8.235),(76.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.595),(75.575,8.765),(75.745,8.765),(75.745,8.595),(75.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.595),(75.935,8.765),(76.105,8.765),(76.105,8.595),(75.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.595),(76.295,8.765),(76.465,8.765),(76.465,8.595),(76.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.595),(76.655,8.765),(76.825,8.765),(76.825,8.595),(76.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.955),(75.575,9.125),(75.745,9.125),(75.745,8.955),(75.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.955),(75.935,9.125),(76.105,9.125),(76.105,8.955),(75.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.955),(76.295,9.125),(76.465,9.125),(76.465,8.955),(76.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.955),(76.655,9.125),(76.825,9.125),(76.825,8.955),(76.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.315),(75.575,9.485),(75.745,9.485),(75.745,9.315),(75.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.315),(75.935,9.485),(76.105,9.485),(76.105,9.315),(75.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.315),(76.295,9.485),(76.465,9.485),(76.465,9.315),(76.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.315),(76.655,9.485),(76.825,9.485),(76.825,9.315),(76.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.675),(75.575,9.845),(75.745,9.845),(75.745,9.675),(75.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.675),(75.935,9.845),(76.105,9.845),(76.105,9.675),(75.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.675),(76.295,9.845),(76.465,9.845),(76.465,9.675),(76.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.675),(76.655,9.845),(76.825,9.845),(76.825,9.675),(76.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.035),(75.575,10.205),(75.745,10.205),(75.745,10.035),(75.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.035),(75.935,10.205),(76.105,10.205),(76.105,10.035),(75.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.035),(76.295,10.205),(76.465,10.205),(76.465,10.035),(76.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.035),(76.655,10.205),(76.825,10.205),(76.825,10.035),(76.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.395),(75.575,10.565),(75.745,10.565),(75.745,10.395),(75.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.395),(75.935,10.565),(76.105,10.565),(76.105,10.395),(75.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.395),(76.295,10.565),(76.465,10.565),(76.465,10.395),(76.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.395),(76.655,10.565),(76.825,10.565),(76.825,10.395),(76.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.755),(75.575,10.925),(75.745,10.925),(75.745,10.755),(75.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.755),(75.935,10.925),(76.105,10.925),(76.105,10.755),(75.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.755),(76.295,10.925),(76.465,10.925),(76.465,10.755),(76.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.755),(76.655,10.925),(76.825,10.925),(76.825,10.755),(76.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.115),(75.575,11.285),(75.745,11.285),(75.745,11.115),(75.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.115),(75.935,11.285),(76.105,11.285),(76.105,11.115),(75.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.115),(76.295,11.285),(76.465,11.285),(76.465,11.115),(76.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.115),(76.655,11.285),(76.825,11.285),(76.825,11.115),(76.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.475),(75.575,11.645),(75.745,11.645),(75.745,11.475),(75.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.475),(75.935,11.645),(76.105,11.645),(76.105,11.475),(75.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.475),(76.295,11.645),(76.465,11.645),(76.465,11.475),(76.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.475),(76.655,11.645),(76.825,11.645),(76.825,11.475),(76.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.835),(75.575,12.005),(75.745,12.005),(75.745,11.835),(75.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.835),(75.935,12.005),(76.105,12.005),(76.105,11.835),(75.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.835),(76.295,12.005),(76.465,12.005),(76.465,11.835),(76.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.835),(76.655,12.005),(76.825,12.005),(76.825,11.835),(76.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.195),(75.575,12.365),(75.745,12.365),(75.745,12.195),(75.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.195),(75.935,12.365),(76.105,12.365),(76.105,12.195),(75.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.195),(76.295,12.365),(76.465,12.365),(76.465,12.195),(76.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.195),(76.655,12.365),(76.825,12.365),(76.825,12.195),(76.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.555),(75.575,12.725),(75.745,12.725),(75.745,12.555),(75.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.555),(75.935,12.725),(76.105,12.725),(76.105,12.555),(75.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.555),(76.295,12.725),(76.465,12.725),(76.465,12.555),(76.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.555),(76.655,12.725),(76.825,12.725),(76.825,12.555),(76.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.915),(75.575,13.085),(75.745,13.085),(75.745,12.915),(75.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.915),(75.935,13.085),(76.105,13.085),(76.105,12.915),(75.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.915),(76.295,13.085),(76.465,13.085),(76.465,12.915),(76.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.915),(76.655,13.085),(76.825,13.085),(76.825,12.915),(76.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.275),(75.575,13.445),(75.745,13.445),(75.745,13.275),(75.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.275),(75.935,13.445),(76.105,13.445),(76.105,13.275),(75.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.275),(76.295,13.445),(76.465,13.445),(76.465,13.275),(76.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.275),(76.655,13.445),(76.825,13.445),(76.825,13.275),(76.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.635),(75.575,13.805),(75.745,13.805),(75.745,13.635),(75.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.635),(75.935,13.805),(76.105,13.805),(76.105,13.635),(75.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.635),(76.295,13.805),(76.465,13.805),(76.465,13.635),(76.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.635),(76.655,13.805),(76.825,13.805),(76.825,13.635),(76.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.995),(75.575,14.165),(75.745,14.165),(75.745,13.995),(75.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.995),(75.935,14.165),(76.105,14.165),(76.105,13.995),(75.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.995),(76.295,14.165),(76.465,14.165),(76.465,13.995),(76.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.995),(76.655,14.165),(76.825,14.165),(76.825,13.995),(76.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.355),(75.575,14.525),(75.745,14.525),(75.745,14.355),(75.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.355),(75.935,14.525),(76.105,14.525),(76.105,14.355),(75.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.355),(76.295,14.525),(76.465,14.525),(76.465,14.355),(76.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.355),(76.655,14.525),(76.825,14.525),(76.825,14.355),(76.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.715),(75.575,14.885),(75.745,14.885),(75.745,14.715),(75.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.715),(75.935,14.885),(76.105,14.885),(76.105,14.715),(75.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.715),(76.295,14.885),(76.465,14.885),(76.465,14.715),(76.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.715),(76.655,14.885),(76.825,14.885),(76.825,14.715),(76.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.075),(75.575,15.245),(75.745,15.245),(75.745,15.075),(75.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.075),(75.935,15.245),(76.105,15.245),(76.105,15.075),(75.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.075),(76.295,15.245),(76.465,15.245),(76.465,15.075),(76.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.075),(76.655,15.245),(76.825,15.245),(76.825,15.075),(76.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.435),(75.575,15.605),(75.745,15.605),(75.745,15.435),(75.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.435),(75.935,15.605),(76.105,15.605),(76.105,15.435),(75.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.435),(76.295,15.605),(76.465,15.605),(76.465,15.435),(76.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.435),(76.655,15.605),(76.825,15.605),(76.825,15.435),(76.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.795),(75.575,15.965),(75.745,15.965),(75.745,15.795),(75.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.795),(75.935,15.965),(76.105,15.965),(76.105,15.795),(75.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.795),(76.295,15.965),(76.465,15.965),(76.465,15.795),(76.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.795),(76.655,15.965),(76.825,15.965),(76.825,15.795),(76.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.155),(75.575,16.325),(75.745,16.325),(75.745,16.155),(75.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.155),(75.935,16.325),(76.105,16.325),(76.105,16.155),(75.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.155),(76.295,16.325),(76.465,16.325),(76.465,16.155),(76.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.155),(76.655,16.325),(76.825,16.325),(76.825,16.155),(76.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.515),(75.575,16.685),(75.745,16.685),(75.745,16.515),(75.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.515),(75.935,16.685),(76.105,16.685),(76.105,16.515),(75.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.515),(76.295,16.685),(76.465,16.685),(76.465,16.515),(76.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.515),(76.655,16.685),(76.825,16.685),(76.825,16.515),(76.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.875),(75.575,17.045),(75.745,17.045),(75.745,16.875),(75.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.875),(75.935,17.045),(76.105,17.045),(76.105,16.875),(75.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.875),(76.295,17.045),(76.465,17.045),(76.465,16.875),(76.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.875),(76.655,17.045),(76.825,17.045),(76.825,16.875),(76.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.235),(75.575,17.405),(75.745,17.405),(75.745,17.235),(75.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.235),(75.935,17.405),(76.105,17.405),(76.105,17.235),(75.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.235),(76.295,17.405),(76.465,17.405),(76.465,17.235),(76.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.235),(76.655,17.405),(76.825,17.405),(76.825,17.235),(76.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.595),(75.575,17.765),(75.745,17.765),(75.745,17.595),(75.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.595),(75.935,17.765),(76.105,17.765),(76.105,17.595),(75.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.595),(76.295,17.765),(76.465,17.765),(76.465,17.595),(76.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.595),(76.655,17.765),(76.825,17.765),(76.825,17.595),(76.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.955),(75.575,18.125),(75.745,18.125),(75.745,17.955),(75.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.955),(75.935,18.125),(76.105,18.125),(76.105,17.955),(75.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.955),(76.295,18.125),(76.465,18.125),(76.465,17.955),(76.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.955),(76.655,18.125),(76.825,18.125),(76.825,17.955),(76.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.315),(75.575,18.485),(75.745,18.485),(75.745,18.315),(75.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.315),(75.935,18.485),(76.105,18.485),(76.105,18.315),(75.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.315),(76.295,18.485),(76.465,18.485),(76.465,18.315),(76.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.315),(76.655,18.485),(76.825,18.485),(76.825,18.315),(76.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.675),(75.575,18.845),(75.745,18.845),(75.745,18.675),(75.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.675),(75.935,18.845),(76.105,18.845),(76.105,18.675),(75.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.675),(76.295,18.845),(76.465,18.845),(76.465,18.675),(76.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.675),(76.655,18.845),(76.825,18.845),(76.825,18.675),(76.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.035),(75.575,19.205),(75.745,19.205),(75.745,19.035),(75.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.035),(75.935,19.205),(76.105,19.205),(76.105,19.035),(75.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.035),(76.295,19.205),(76.465,19.205),(76.465,19.035),(76.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.035),(76.655,19.205),(76.825,19.205),(76.825,19.035),(76.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.395),(75.575,19.565),(75.745,19.565),(75.745,19.395),(75.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.395),(75.935,19.565),(76.105,19.565),(76.105,19.395),(75.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.395),(76.295,19.565),(76.465,19.565),(76.465,19.395),(76.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.395),(76.655,19.565),(76.825,19.565),(76.825,19.395),(76.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.755),(75.575,19.925),(75.745,19.925),(75.745,19.755),(75.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.755),(75.935,19.925),(76.105,19.925),(76.105,19.755),(75.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.755),(76.295,19.925),(76.465,19.925),(76.465,19.755),(76.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.755),(76.655,19.925),(76.825,19.925),(76.825,19.755),(76.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,20.115),(75.575,20.285),(75.745,20.285),(75.745,20.115),(75.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,20.115),(75.935,20.285),(76.105,20.285),(76.105,20.115),(75.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,20.115),(76.295,20.285),(76.465,20.285),(76.465,20.115),(76.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,20.115),(76.655,20.285),(76.825,20.285),(76.825,20.115),(76.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,20.475),(75.575,20.645),(75.745,20.645),(75.745,20.475),(75.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,20.475),(75.935,20.645),(76.105,20.645),(76.105,20.475),(75.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,20.475),(76.295,20.645),(76.465,20.645),(76.465,20.475),(76.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,20.475),(76.655,20.645),(76.825,20.645),(76.825,20.475),(76.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,20.835),(75.575,21.005),(75.745,21.005),(75.745,20.835),(75.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,20.835),(75.935,21.005),(76.105,21.005),(76.105,20.835),(75.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,20.835),(76.295,21.005),(76.465,21.005),(76.465,20.835),(76.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,20.835),(76.655,21.005),(76.825,21.005),(76.825,20.835),(76.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,21.195),(75.575,21.365),(75.745,21.365),(75.745,21.195),(75.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,21.195),(75.935,21.365),(76.105,21.365),(76.105,21.195),(75.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,21.195),(76.295,21.365),(76.465,21.365),(76.465,21.195),(76.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,21.195),(76.655,21.365),(76.825,21.365),(76.825,21.195),(76.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,21.555),(75.575,21.725),(75.745,21.725),(75.745,21.555),(75.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,21.555),(75.935,21.725),(76.105,21.725),(76.105,21.555),(75.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,21.555),(76.295,21.725),(76.465,21.725),(76.465,21.555),(76.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,21.555),(76.655,21.725),(76.825,21.725),(76.825,21.555),(76.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,21.915),(75.575,22.085),(75.745,22.085),(75.745,21.915),(75.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,21.915),(75.935,22.085),(76.105,22.085),(76.105,21.915),(75.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,21.915),(76.295,22.085),(76.465,22.085),(76.465,21.915),(76.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,21.915),(76.655,22.085),(76.825,22.085),(76.825,21.915),(76.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.275),(75.575,22.445),(75.745,22.445),(75.745,22.275),(75.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.275),(75.935,22.445),(76.105,22.445),(76.105,22.275),(75.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.275),(76.295,22.445),(76.465,22.445),(76.465,22.275),(76.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.275),(76.655,22.445),(76.825,22.445),(76.825,22.275),(76.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.635),(75.575,22.805),(75.745,22.805),(75.745,22.635),(75.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.635),(75.935,22.805),(76.105,22.805),(76.105,22.635),(75.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.635),(76.295,22.805),(76.465,22.805),(76.465,22.635),(76.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.635),(76.655,22.805),(76.825,22.805),(76.825,22.635),(76.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.995),(75.575,23.165),(75.745,23.165),(75.745,22.995),(75.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.995),(75.935,23.165),(76.105,23.165),(76.105,22.995),(75.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.995),(76.295,23.165),(76.465,23.165),(76.465,22.995),(76.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.995),(76.655,23.165),(76.825,23.165),(76.825,22.995),(76.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,23.355),(75.575,23.525),(75.745,23.525),(75.745,23.355),(75.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,23.355),(75.935,23.525),(76.105,23.525),(76.105,23.355),(75.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,23.355),(76.295,23.525),(76.465,23.525),(76.465,23.355),(76.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,23.355),(76.655,23.525),(76.825,23.525),(76.825,23.355),(76.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,23.715),(75.575,23.885),(75.745,23.885),(75.745,23.715),(75.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,23.715),(75.935,23.885),(76.105,23.885),(76.105,23.715),(75.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,23.715),(76.295,23.885),(76.465,23.885),(76.465,23.715),(76.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,23.715),(76.655,23.885),(76.825,23.885),(76.825,23.715),(76.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,24.075),(75.575,24.245),(75.745,24.245),(75.745,24.075),(75.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,24.075),(75.935,24.245),(76.105,24.245),(76.105,24.075),(75.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,24.075),(76.295,24.245),(76.465,24.245),(76.465,24.075),(76.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,24.075),(76.655,24.245),(76.825,24.245),(76.825,24.075),(76.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,24.435),(75.575,24.605),(75.745,24.605),(75.745,24.435),(75.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,24.435),(75.935,24.605),(76.105,24.605),(76.105,24.435),(75.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,24.435),(76.295,24.605),(76.465,24.605),(76.465,24.435),(76.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,24.435),(76.655,24.605),(76.825,24.605),(76.825,24.435),(76.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,24.795),(75.575,24.965),(75.745,24.965),(75.745,24.795),(75.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,24.795),(75.935,24.965),(76.105,24.965),(76.105,24.795),(75.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,24.795),(76.295,24.965),(76.465,24.965),(76.465,24.795),(76.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,24.795),(76.655,24.965),(76.825,24.965),(76.825,24.795),(76.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,25.155),(75.575,25.325),(75.745,25.325),(75.745,25.155),(75.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,25.155),(75.935,25.325),(76.105,25.325),(76.105,25.155),(75.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,25.155),(76.295,25.325),(76.465,25.325),(76.465,25.155),(76.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,25.155),(76.655,25.325),(76.825,25.325),(76.825,25.155),(76.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,25.515),(75.575,25.685),(75.745,25.685),(75.745,25.515),(75.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,25.515),(75.935,25.685),(76.105,25.685),(76.105,25.515),(75.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,25.515),(76.295,25.685),(76.465,25.685),(76.465,25.515),(76.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,25.515),(76.655,25.685),(76.825,25.685),(76.825,25.515),(76.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,25.875),(75.575,26.045),(75.745,26.045),(75.745,25.875),(75.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,25.875),(75.935,26.045),(76.105,26.045),(76.105,25.875),(75.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,25.875),(76.295,26.045),(76.465,26.045),(76.465,25.875),(76.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,25.875),(76.655,26.045),(76.825,26.045),(76.825,25.875),(76.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,26.235),(75.575,26.405),(75.745,26.405),(75.745,26.235),(75.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,26.235),(75.935,26.405),(76.105,26.405),(76.105,26.235),(75.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,26.235),(76.295,26.405),(76.465,26.405),(76.465,26.235),(76.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,26.235),(76.655,26.405),(76.825,26.405),(76.825,26.235),(76.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,26.595),(75.575,26.765),(75.745,26.765),(75.745,26.595),(75.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,26.595),(75.935,26.765),(76.105,26.765),(76.105,26.595),(75.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,26.595),(76.295,26.765),(76.465,26.765),(76.465,26.595),(76.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,26.595),(76.655,26.765),(76.825,26.765),(76.825,26.595),(76.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,26.955),(75.575,27.125),(75.745,27.125),(75.745,26.955),(75.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,26.955),(75.935,27.125),(76.105,27.125),(76.105,26.955),(75.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,26.955),(76.295,27.125),(76.465,27.125),(76.465,26.955),(76.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,26.955),(76.655,27.125),(76.825,27.125),(76.825,26.955),(76.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,27.315),(75.575,27.485),(75.745,27.485),(75.745,27.315),(75.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,27.315),(75.935,27.485),(76.105,27.485),(76.105,27.315),(75.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,27.315),(76.295,27.485),(76.465,27.485),(76.465,27.315),(76.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,27.315),(76.655,27.485),(76.825,27.485),(76.825,27.315),(76.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,27.675),(75.575,27.845),(75.745,27.845),(75.745,27.675),(75.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,27.675),(75.935,27.845),(76.105,27.845),(76.105,27.675),(75.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,27.675),(76.295,27.845),(76.465,27.845),(76.465,27.675),(76.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,27.675),(76.655,27.845),(76.825,27.845),(76.825,27.675),(76.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,28.035),(75.575,28.205),(75.745,28.205),(75.745,28.035),(75.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,28.035),(75.935,28.205),(76.105,28.205),(76.105,28.035),(75.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,28.035),(76.295,28.205),(76.465,28.205),(76.465,28.035),(76.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,28.035),(76.655,28.205),(76.825,28.205),(76.825,28.035),(76.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,28.395),(75.575,28.565),(75.745,28.565),(75.745,28.395),(75.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,28.395),(75.935,28.565),(76.105,28.565),(76.105,28.395),(75.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,28.395),(76.295,28.565),(76.465,28.565),(76.465,28.395),(76.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,28.395),(76.655,28.565),(76.825,28.565),(76.825,28.395),(76.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,28.755),(75.575,28.925),(75.745,28.925),(75.745,28.755),(75.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,28.755),(75.935,28.925),(76.105,28.925),(76.105,28.755),(75.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,28.755),(76.295,28.925),(76.465,28.925),(76.465,28.755),(76.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,28.755),(76.655,28.925),(76.825,28.925),(76.825,28.755),(76.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,29.115),(75.575,29.285),(75.745,29.285),(75.745,29.115),(75.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,29.115),(75.935,29.285),(76.105,29.285),(76.105,29.115),(75.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,29.115),(76.295,29.285),(76.465,29.285),(76.465,29.115),(76.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,29.115),(76.655,29.285),(76.825,29.285),(76.825,29.115),(76.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,29.475),(75.575,29.645),(75.745,29.645),(75.745,29.475),(75.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,29.475),(75.935,29.645),(76.105,29.645),(76.105,29.475),(75.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,29.475),(76.295,29.645),(76.465,29.645),(76.465,29.475),(76.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,29.475),(76.655,29.645),(76.825,29.645),(76.825,29.475),(76.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,29.835),(75.575,30.005),(75.745,30.005),(75.745,29.835),(75.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,29.835),(75.935,30.005),(76.105,30.005),(76.105,29.835),(75.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,29.835),(76.295,30.005),(76.465,30.005),(76.465,29.835),(76.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,29.835),(76.655,30.005),(76.825,30.005),(76.825,29.835),(76.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,30.195),(75.575,30.365),(75.745,30.365),(75.745,30.195),(75.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,30.195),(75.935,30.365),(76.105,30.365),(76.105,30.195),(75.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,30.195),(76.295,30.365),(76.465,30.365),(76.465,30.195),(76.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,30.195),(76.655,30.365),(76.825,30.365),(76.825,30.195),(76.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,30.555),(75.575,30.725),(75.745,30.725),(75.745,30.555),(75.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,30.555),(75.935,30.725),(76.105,30.725),(76.105,30.555),(75.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,30.555),(76.295,30.725),(76.465,30.725),(76.465,30.555),(76.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,30.555),(76.655,30.725),(76.825,30.725),(76.825,30.555),(76.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,30.915),(75.575,31.085),(75.745,31.085),(75.745,30.915),(75.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,30.915),(75.935,31.085),(76.105,31.085),(76.105,30.915),(75.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,30.915),(76.295,31.085),(76.465,31.085),(76.465,30.915),(76.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,30.915),(76.655,31.085),(76.825,31.085),(76.825,30.915),(76.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,31.275),(75.575,31.445),(75.745,31.445),(75.745,31.275),(75.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,31.275),(75.935,31.445),(76.105,31.445),(76.105,31.275),(75.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,31.275),(76.295,31.445),(76.465,31.445),(76.465,31.275),(76.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,31.275),(76.655,31.445),(76.825,31.445),(76.825,31.275),(76.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,31.635),(75.575,31.805),(75.745,31.805),(75.745,31.635),(75.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,31.635),(75.935,31.805),(76.105,31.805),(76.105,31.635),(75.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,31.635),(76.295,31.805),(76.465,31.805),(76.465,31.635),(76.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,31.635),(76.655,31.805),(76.825,31.805),(76.825,31.635),(76.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,31.995),(75.575,32.165),(75.745,32.165),(75.745,31.995),(75.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,31.995),(75.935,32.165),(76.105,32.165),(76.105,31.995),(75.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,31.995),(76.295,32.165),(76.465,32.165),(76.465,31.995),(76.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,31.995),(76.655,32.165),(76.825,32.165),(76.825,31.995),(76.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,32.355),(75.575,32.525),(75.745,32.525),(75.745,32.355),(75.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,32.355),(75.935,32.525),(76.105,32.525),(76.105,32.355),(75.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,32.355),(76.295,32.525),(76.465,32.525),(76.465,32.355),(76.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,32.355),(76.655,32.525),(76.825,32.525),(76.825,32.355),(76.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,32.715),(75.575,32.885),(75.745,32.885),(75.745,32.715),(75.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,32.715),(75.935,32.885),(76.105,32.885),(76.105,32.715),(75.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,32.715),(76.295,32.885),(76.465,32.885),(76.465,32.715),(76.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,32.715),(76.655,32.885),(76.825,32.885),(76.825,32.715),(76.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,33.075),(75.575,33.245),(75.745,33.245),(75.745,33.075),(75.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,33.075),(75.935,33.245),(76.105,33.245),(76.105,33.075),(75.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,33.075),(76.295,33.245),(76.465,33.245),(76.465,33.075),(76.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,33.075),(76.655,33.245),(76.825,33.245),(76.825,33.075),(76.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,33.435),(75.575,33.605),(75.745,33.605),(75.745,33.435),(75.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,33.435),(75.935,33.605),(76.105,33.605),(76.105,33.435),(75.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,33.435),(76.295,33.605),(76.465,33.605),(76.465,33.435),(76.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,33.435),(76.655,33.605),(76.825,33.605),(76.825,33.435),(76.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,33.795),(75.575,33.965),(75.745,33.965),(75.745,33.795),(75.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,33.795),(75.935,33.965),(76.105,33.965),(76.105,33.795),(75.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,33.795),(76.295,33.965),(76.465,33.965),(76.465,33.795),(76.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,33.795),(76.655,33.965),(76.825,33.965),(76.825,33.795),(76.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,34.155),(75.575,34.325),(75.745,34.325),(75.745,34.155),(75.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,34.155),(75.935,34.325),(76.105,34.325),(76.105,34.155),(75.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,34.155),(76.295,34.325),(76.465,34.325),(76.465,34.155),(76.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,34.155),(76.655,34.325),(76.825,34.325),(76.825,34.155),(76.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,34.515),(75.575,34.685),(75.745,34.685),(75.745,34.515),(75.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,34.515),(75.935,34.685),(76.105,34.685),(76.105,34.515),(75.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,34.515),(76.295,34.685),(76.465,34.685),(76.465,34.515),(76.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,34.515),(76.655,34.685),(76.825,34.685),(76.825,34.515),(76.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,34.875),(75.575,35.045),(75.745,35.045),(75.745,34.875),(75.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,34.875),(75.935,35.045),(76.105,35.045),(76.105,34.875),(75.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,34.875),(76.295,35.045),(76.465,35.045),(76.465,34.875),(76.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,34.875),(76.655,35.045),(76.825,35.045),(76.825,34.875),(76.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,35.235),(75.575,35.405),(75.745,35.405),(75.745,35.235),(75.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,35.235),(75.935,35.405),(76.105,35.405),(76.105,35.235),(75.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,35.235),(76.295,35.405),(76.465,35.405),(76.465,35.235),(76.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,35.235),(76.655,35.405),(76.825,35.405),(76.825,35.235),(76.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,35.595),(75.575,35.765),(75.745,35.765),(75.745,35.595),(75.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,35.595),(75.935,35.765),(76.105,35.765),(76.105,35.595),(75.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,35.595),(76.295,35.765),(76.465,35.765),(76.465,35.595),(76.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,35.595),(76.655,35.765),(76.825,35.765),(76.825,35.595),(76.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,35.955),(75.575,36.125),(75.745,36.125),(75.745,35.955),(75.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,35.955),(75.935,36.125),(76.105,36.125),(76.105,35.955),(75.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,35.955),(76.295,36.125),(76.465,36.125),(76.465,35.955),(76.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,35.955),(76.655,36.125),(76.825,36.125),(76.825,35.955),(76.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,36.315),(75.575,36.485),(75.745,36.485),(75.745,36.315),(75.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,36.315),(75.935,36.485),(76.105,36.485),(76.105,36.315),(75.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,36.315),(76.295,36.485),(76.465,36.485),(76.465,36.315),(76.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,36.315),(76.655,36.485),(76.825,36.485),(76.825,36.315),(76.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,36.675),(75.575,36.845),(75.745,36.845),(75.745,36.675),(75.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,36.675),(75.935,36.845),(76.105,36.845),(76.105,36.675),(75.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,36.675),(76.295,36.845),(76.465,36.845),(76.465,36.675),(76.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,36.675),(76.655,36.845),(76.825,36.845),(76.825,36.675),(76.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,37.035),(75.575,37.205),(75.745,37.205),(75.745,37.035),(75.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,37.035),(75.935,37.205),(76.105,37.205),(76.105,37.035),(75.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,37.035),(76.295,37.205),(76.465,37.205),(76.465,37.035),(76.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,37.035),(76.655,37.205),(76.825,37.205),(76.825,37.035),(76.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,37.395),(75.575,37.565),(75.745,37.565),(75.745,37.395),(75.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,37.395),(75.935,37.565),(76.105,37.565),(76.105,37.395),(75.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,37.395),(76.295,37.565),(76.465,37.565),(76.465,37.395),(76.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,37.395),(76.655,37.565),(76.825,37.565),(76.825,37.395),(76.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,37.755),(75.575,37.925),(75.745,37.925),(75.745,37.755),(75.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,37.755),(75.935,37.925),(76.105,37.925),(76.105,37.755),(75.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,37.755),(76.295,37.925),(76.465,37.925),(76.465,37.755),(76.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,37.755),(76.655,37.925),(76.825,37.925),(76.825,37.755),(76.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,38.115),(75.575,38.285),(75.745,38.285),(75.745,38.115),(75.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,38.115),(75.935,38.285),(76.105,38.285),(76.105,38.115),(75.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,38.115),(76.295,38.285),(76.465,38.285),(76.465,38.115),(76.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,38.115),(76.655,38.285),(76.825,38.285),(76.825,38.115),(76.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,38.475),(75.575,38.645),(75.745,38.645),(75.745,38.475),(75.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,38.475),(75.935,38.645),(76.105,38.645),(76.105,38.475),(75.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,38.475),(76.295,38.645),(76.465,38.645),(76.465,38.475),(76.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,38.475),(76.655,38.645),(76.825,38.645),(76.825,38.475),(76.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,38.835),(75.575,39.005),(75.745,39.005),(75.745,38.835),(75.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,38.835),(75.935,39.005),(76.105,39.005),(76.105,38.835),(75.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,38.835),(76.295,39.005),(76.465,39.005),(76.465,38.835),(76.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,38.835),(76.655,39.005),(76.825,39.005),(76.825,38.835),(76.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,39.195),(75.575,39.365),(75.745,39.365),(75.745,39.195),(75.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,39.195),(75.935,39.365),(76.105,39.365),(76.105,39.195),(75.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,39.195),(76.295,39.365),(76.465,39.365),(76.465,39.195),(76.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,39.195),(76.655,39.365),(76.825,39.365),(76.825,39.195),(76.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,39.555),(75.575,39.725),(75.745,39.725),(75.745,39.555),(75.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,39.555),(75.935,39.725),(76.105,39.725),(76.105,39.555),(75.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,39.555),(76.295,39.725),(76.465,39.725),(76.465,39.555),(76.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,39.555),(76.655,39.725),(76.825,39.725),(76.825,39.555),(76.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,39.915),(75.575,40.085),(75.745,40.085),(75.745,39.915),(75.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,39.915),(75.935,40.085),(76.105,40.085),(76.105,39.915),(75.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,39.915),(76.295,40.085),(76.465,40.085),(76.465,39.915),(76.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,39.915),(76.655,40.085),(76.825,40.085),(76.825,39.915),(76.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,40.275),(75.575,40.445),(75.745,40.445),(75.745,40.275),(75.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,40.275),(75.935,40.445),(76.105,40.445),(76.105,40.275),(75.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,40.275),(76.295,40.445),(76.465,40.445),(76.465,40.275),(76.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,40.275),(76.655,40.445),(76.825,40.445),(76.825,40.275),(76.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,40.635),(75.575,40.805),(75.745,40.805),(75.745,40.635),(75.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,40.635),(75.935,40.805),(76.105,40.805),(76.105,40.635),(75.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,40.635),(76.295,40.805),(76.465,40.805),(76.465,40.635),(76.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,40.635),(76.655,40.805),(76.825,40.805),(76.825,40.635),(76.655,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.835),(37.175,3.005),(37.345,3.005),(37.345,2.835),(37.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.835),(37.535,3.005),(37.705,3.005),(37.705,2.835),(37.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.835),(37.895,3.005),(38.065,3.005),(38.065,2.835),(37.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.835),(38.255,3.005),(38.425,3.005),(38.425,2.835),(38.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.195),(37.175,3.365),(37.345,3.365),(37.345,3.195),(37.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.195),(37.535,3.365),(37.705,3.365),(37.705,3.195),(37.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.195),(37.895,3.365),(38.065,3.365),(38.065,3.195),(37.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.195),(38.255,3.365),(38.425,3.365),(38.425,3.195),(38.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.555),(37.175,3.725),(37.345,3.725),(37.345,3.555),(37.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.555),(37.535,3.725),(37.705,3.725),(37.705,3.555),(37.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.555),(37.895,3.725),(38.065,3.725),(38.065,3.555),(37.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.555),(38.255,3.725),(38.425,3.725),(38.425,3.555),(38.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.915),(37.175,4.085),(37.345,4.085),(37.345,3.915),(37.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.915),(37.535,4.085),(37.705,4.085),(37.705,3.915),(37.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.915),(37.895,4.085),(38.065,4.085),(38.065,3.915),(37.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.915),(38.255,4.085),(38.425,4.085),(38.425,3.915),(38.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.275),(37.175,4.445),(37.345,4.445),(37.345,4.275),(37.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.275),(37.535,4.445),(37.705,4.445),(37.705,4.275),(37.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.275),(37.895,4.445),(38.065,4.445),(38.065,4.275),(37.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.275),(38.255,4.445),(38.425,4.445),(38.425,4.275),(38.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.635),(37.175,4.805),(37.345,4.805),(37.345,4.635),(37.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.635),(37.535,4.805),(37.705,4.805),(37.705,4.635),(37.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.635),(37.895,4.805),(38.065,4.805),(38.065,4.635),(37.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.635),(38.255,4.805),(38.425,4.805),(38.425,4.635),(38.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.995),(37.175,5.165),(37.345,5.165),(37.345,4.995),(37.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.995),(37.535,5.165),(37.705,5.165),(37.705,4.995),(37.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.995),(37.895,5.165),(38.065,5.165),(38.065,4.995),(37.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.995),(38.255,5.165),(38.425,5.165),(38.425,4.995),(38.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.355),(37.175,5.525),(37.345,5.525),(37.345,5.355),(37.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.355),(37.535,5.525),(37.705,5.525),(37.705,5.355),(37.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.355),(37.895,5.525),(38.065,5.525),(38.065,5.355),(37.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.355),(38.255,5.525),(38.425,5.525),(38.425,5.355),(38.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.715),(37.175,5.885),(37.345,5.885),(37.345,5.715),(37.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.715),(37.535,5.885),(37.705,5.885),(37.705,5.715),(37.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.715),(37.895,5.885),(38.065,5.885),(38.065,5.715),(37.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.715),(38.255,5.885),(38.425,5.885),(38.425,5.715),(38.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.075),(37.175,6.245),(37.345,6.245),(37.345,6.075),(37.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.075),(37.535,6.245),(37.705,6.245),(37.705,6.075),(37.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.075),(37.895,6.245),(38.065,6.245),(38.065,6.075),(37.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.075),(38.255,6.245),(38.425,6.245),(38.425,6.075),(38.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.435),(37.175,6.605),(37.345,6.605),(37.345,6.435),(37.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.435),(37.535,6.605),(37.705,6.605),(37.705,6.435),(37.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.435),(37.895,6.605),(38.065,6.605),(38.065,6.435),(37.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.435),(38.255,6.605),(38.425,6.605),(38.425,6.435),(38.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.795),(37.175,6.965),(37.345,6.965),(37.345,6.795),(37.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.795),(37.535,6.965),(37.705,6.965),(37.705,6.795),(37.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.795),(37.895,6.965),(38.065,6.965),(38.065,6.795),(37.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.795),(38.255,6.965),(38.425,6.965),(38.425,6.795),(38.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.155),(37.175,7.325),(37.345,7.325),(37.345,7.155),(37.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.155),(37.535,7.325),(37.705,7.325),(37.705,7.155),(37.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.155),(37.895,7.325),(38.065,7.325),(38.065,7.155),(37.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.155),(38.255,7.325),(38.425,7.325),(38.425,7.155),(38.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.515),(37.175,7.685),(37.345,7.685),(37.345,7.515),(37.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.515),(37.535,7.685),(37.705,7.685),(37.705,7.515),(37.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.515),(37.895,7.685),(38.065,7.685),(38.065,7.515),(37.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.515),(38.255,7.685),(38.425,7.685),(38.425,7.515),(38.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.875),(37.175,8.045),(37.345,8.045),(37.345,7.875),(37.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.875),(37.535,8.045),(37.705,8.045),(37.705,7.875),(37.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.875),(37.895,8.045),(38.065,8.045),(38.065,7.875),(37.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.875),(38.255,8.045),(38.425,8.045),(38.425,7.875),(38.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.235),(37.175,8.405),(37.345,8.405),(37.345,8.235),(37.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.235),(37.535,8.405),(37.705,8.405),(37.705,8.235),(37.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.235),(37.895,8.405),(38.065,8.405),(38.065,8.235),(37.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.235),(38.255,8.405),(38.425,8.405),(38.425,8.235),(38.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.595),(37.175,8.765),(37.345,8.765),(37.345,8.595),(37.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.595),(37.535,8.765),(37.705,8.765),(37.705,8.595),(37.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.595),(37.895,8.765),(38.065,8.765),(38.065,8.595),(37.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.595),(38.255,8.765),(38.425,8.765),(38.425,8.595),(38.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.955),(37.175,9.125),(37.345,9.125),(37.345,8.955),(37.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.955),(37.535,9.125),(37.705,9.125),(37.705,8.955),(37.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.955),(37.895,9.125),(38.065,9.125),(38.065,8.955),(37.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.955),(38.255,9.125),(38.425,9.125),(38.425,8.955),(38.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.315),(37.175,9.485),(37.345,9.485),(37.345,9.315),(37.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.315),(37.535,9.485),(37.705,9.485),(37.705,9.315),(37.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.315),(37.895,9.485),(38.065,9.485),(38.065,9.315),(37.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.315),(38.255,9.485),(38.425,9.485),(38.425,9.315),(38.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.675),(37.175,9.845),(37.345,9.845),(37.345,9.675),(37.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.675),(37.535,9.845),(37.705,9.845),(37.705,9.675),(37.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.675),(37.895,9.845),(38.065,9.845),(38.065,9.675),(37.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.675),(38.255,9.845),(38.425,9.845),(38.425,9.675),(38.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.035),(37.175,10.205),(37.345,10.205),(37.345,10.035),(37.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.035),(37.535,10.205),(37.705,10.205),(37.705,10.035),(37.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.035),(37.895,10.205),(38.065,10.205),(38.065,10.035),(37.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.035),(38.255,10.205),(38.425,10.205),(38.425,10.035),(38.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.395),(37.175,10.565),(37.345,10.565),(37.345,10.395),(37.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.395),(37.535,10.565),(37.705,10.565),(37.705,10.395),(37.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.395),(37.895,10.565),(38.065,10.565),(38.065,10.395),(37.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.395),(38.255,10.565),(38.425,10.565),(38.425,10.395),(38.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.755),(37.175,10.925),(37.345,10.925),(37.345,10.755),(37.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.755),(37.535,10.925),(37.705,10.925),(37.705,10.755),(37.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.755),(37.895,10.925),(38.065,10.925),(38.065,10.755),(37.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.755),(38.255,10.925),(38.425,10.925),(38.425,10.755),(38.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.115),(37.175,11.285),(37.345,11.285),(37.345,11.115),(37.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.115),(37.535,11.285),(37.705,11.285),(37.705,11.115),(37.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.115),(37.895,11.285),(38.065,11.285),(38.065,11.115),(37.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.115),(38.255,11.285),(38.425,11.285),(38.425,11.115),(38.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.475),(37.175,11.645),(37.345,11.645),(37.345,11.475),(37.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.475),(37.535,11.645),(37.705,11.645),(37.705,11.475),(37.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.475),(37.895,11.645),(38.065,11.645),(38.065,11.475),(37.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.475),(38.255,11.645),(38.425,11.645),(38.425,11.475),(38.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.835),(37.175,12.005),(37.345,12.005),(37.345,11.835),(37.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.835),(37.535,12.005),(37.705,12.005),(37.705,11.835),(37.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.835),(37.895,12.005),(38.065,12.005),(38.065,11.835),(37.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.835),(38.255,12.005),(38.425,12.005),(38.425,11.835),(38.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.195),(37.175,12.365),(37.345,12.365),(37.345,12.195),(37.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.195),(37.535,12.365),(37.705,12.365),(37.705,12.195),(37.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.195),(37.895,12.365),(38.065,12.365),(38.065,12.195),(37.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.195),(38.255,12.365),(38.425,12.365),(38.425,12.195),(38.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.555),(37.175,12.725),(37.345,12.725),(37.345,12.555),(37.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.555),(37.535,12.725),(37.705,12.725),(37.705,12.555),(37.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.555),(37.895,12.725),(38.065,12.725),(38.065,12.555),(37.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.555),(38.255,12.725),(38.425,12.725),(38.425,12.555),(38.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.915),(37.175,13.085),(37.345,13.085),(37.345,12.915),(37.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.915),(37.535,13.085),(37.705,13.085),(37.705,12.915),(37.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.915),(37.895,13.085),(38.065,13.085),(38.065,12.915),(37.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.915),(38.255,13.085),(38.425,13.085),(38.425,12.915),(38.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.275),(37.175,13.445),(37.345,13.445),(37.345,13.275),(37.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.275),(37.535,13.445),(37.705,13.445),(37.705,13.275),(37.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.275),(37.895,13.445),(38.065,13.445),(38.065,13.275),(37.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.275),(38.255,13.445),(38.425,13.445),(38.425,13.275),(38.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.635),(37.175,13.805),(37.345,13.805),(37.345,13.635),(37.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.635),(37.535,13.805),(37.705,13.805),(37.705,13.635),(37.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.635),(37.895,13.805),(38.065,13.805),(38.065,13.635),(37.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.635),(38.255,13.805),(38.425,13.805),(38.425,13.635),(38.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.995),(37.175,14.165),(37.345,14.165),(37.345,13.995),(37.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.995),(37.535,14.165),(37.705,14.165),(37.705,13.995),(37.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.995),(37.895,14.165),(38.065,14.165),(38.065,13.995),(37.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.995),(38.255,14.165),(38.425,14.165),(38.425,13.995),(38.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.355),(37.175,14.525),(37.345,14.525),(37.345,14.355),(37.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.355),(37.535,14.525),(37.705,14.525),(37.705,14.355),(37.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.355),(37.895,14.525),(38.065,14.525),(38.065,14.355),(37.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.355),(38.255,14.525),(38.425,14.525),(38.425,14.355),(38.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.715),(37.175,14.885),(37.345,14.885),(37.345,14.715),(37.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.715),(37.535,14.885),(37.705,14.885),(37.705,14.715),(37.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.715),(37.895,14.885),(38.065,14.885),(38.065,14.715),(37.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.715),(38.255,14.885),(38.425,14.885),(38.425,14.715),(38.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.075),(37.175,15.245),(37.345,15.245),(37.345,15.075),(37.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.075),(37.535,15.245),(37.705,15.245),(37.705,15.075),(37.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.075),(37.895,15.245),(38.065,15.245),(38.065,15.075),(37.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.075),(38.255,15.245),(38.425,15.245),(38.425,15.075),(38.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.435),(37.175,15.605),(37.345,15.605),(37.345,15.435),(37.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.435),(37.535,15.605),(37.705,15.605),(37.705,15.435),(37.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.435),(37.895,15.605),(38.065,15.605),(38.065,15.435),(37.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.435),(38.255,15.605),(38.425,15.605),(38.425,15.435),(38.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.795),(37.175,15.965),(37.345,15.965),(37.345,15.795),(37.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.795),(37.535,15.965),(37.705,15.965),(37.705,15.795),(37.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.795),(37.895,15.965),(38.065,15.965),(38.065,15.795),(37.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.795),(38.255,15.965),(38.425,15.965),(38.425,15.795),(38.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.155),(37.175,16.325),(37.345,16.325),(37.345,16.155),(37.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.155),(37.535,16.325),(37.705,16.325),(37.705,16.155),(37.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.155),(37.895,16.325),(38.065,16.325),(38.065,16.155),(37.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.155),(38.255,16.325),(38.425,16.325),(38.425,16.155),(38.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.515),(37.175,16.685),(37.345,16.685),(37.345,16.515),(37.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.515),(37.535,16.685),(37.705,16.685),(37.705,16.515),(37.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.515),(37.895,16.685),(38.065,16.685),(38.065,16.515),(37.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.515),(38.255,16.685),(38.425,16.685),(38.425,16.515),(38.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.875),(37.175,17.045),(37.345,17.045),(37.345,16.875),(37.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.875),(37.535,17.045),(37.705,17.045),(37.705,16.875),(37.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.875),(37.895,17.045),(38.065,17.045),(38.065,16.875),(37.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.875),(38.255,17.045),(38.425,17.045),(38.425,16.875),(38.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.235),(37.175,17.405),(37.345,17.405),(37.345,17.235),(37.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.235),(37.535,17.405),(37.705,17.405),(37.705,17.235),(37.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.235),(37.895,17.405),(38.065,17.405),(38.065,17.235),(37.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.235),(38.255,17.405),(38.425,17.405),(38.425,17.235),(38.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.595),(37.175,17.765),(37.345,17.765),(37.345,17.595),(37.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.595),(37.535,17.765),(37.705,17.765),(37.705,17.595),(37.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.595),(37.895,17.765),(38.065,17.765),(38.065,17.595),(37.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.595),(38.255,17.765),(38.425,17.765),(38.425,17.595),(38.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.955),(37.175,18.125),(37.345,18.125),(37.345,17.955),(37.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.955),(37.535,18.125),(37.705,18.125),(37.705,17.955),(37.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.955),(37.895,18.125),(38.065,18.125),(38.065,17.955),(37.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.955),(38.255,18.125),(38.425,18.125),(38.425,17.955),(38.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.315),(37.175,18.485),(37.345,18.485),(37.345,18.315),(37.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.315),(37.535,18.485),(37.705,18.485),(37.705,18.315),(37.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.315),(37.895,18.485),(38.065,18.485),(38.065,18.315),(37.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.315),(38.255,18.485),(38.425,18.485),(38.425,18.315),(38.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.675),(37.175,18.845),(37.345,18.845),(37.345,18.675),(37.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.675),(37.535,18.845),(37.705,18.845),(37.705,18.675),(37.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.675),(37.895,18.845),(38.065,18.845),(38.065,18.675),(37.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.675),(38.255,18.845),(38.425,18.845),(38.425,18.675),(38.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.035),(37.175,19.205),(37.345,19.205),(37.345,19.035),(37.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.035),(37.535,19.205),(37.705,19.205),(37.705,19.035),(37.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.035),(37.895,19.205),(38.065,19.205),(38.065,19.035),(37.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.035),(38.255,19.205),(38.425,19.205),(38.425,19.035),(38.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.395),(37.175,19.565),(37.345,19.565),(37.345,19.395),(37.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.395),(37.535,19.565),(37.705,19.565),(37.705,19.395),(37.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.395),(37.895,19.565),(38.065,19.565),(38.065,19.395),(37.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.395),(38.255,19.565),(38.425,19.565),(38.425,19.395),(38.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.755),(37.175,19.925),(37.345,19.925),(37.345,19.755),(37.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.755),(37.535,19.925),(37.705,19.925),(37.705,19.755),(37.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.755),(37.895,19.925),(38.065,19.925),(38.065,19.755),(37.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.755),(38.255,19.925),(38.425,19.925),(38.425,19.755),(38.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.115),(37.175,20.285),(37.345,20.285),(37.345,20.115),(37.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.115),(37.535,20.285),(37.705,20.285),(37.705,20.115),(37.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.115),(37.895,20.285),(38.065,20.285),(38.065,20.115),(37.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.115),(38.255,20.285),(38.425,20.285),(38.425,20.115),(38.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.475),(37.175,20.645),(37.345,20.645),(37.345,20.475),(37.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.475),(37.535,20.645),(37.705,20.645),(37.705,20.475),(37.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.475),(37.895,20.645),(38.065,20.645),(38.065,20.475),(37.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.475),(38.255,20.645),(38.425,20.645),(38.425,20.475),(38.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.835),(37.175,21.005),(37.345,21.005),(37.345,20.835),(37.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.835),(37.535,21.005),(37.705,21.005),(37.705,20.835),(37.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.835),(37.895,21.005),(38.065,21.005),(38.065,20.835),(37.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.835),(38.255,21.005),(38.425,21.005),(38.425,20.835),(38.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.195),(37.175,21.365),(37.345,21.365),(37.345,21.195),(37.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.195),(37.535,21.365),(37.705,21.365),(37.705,21.195),(37.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.195),(37.895,21.365),(38.065,21.365),(38.065,21.195),(37.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.195),(38.255,21.365),(38.425,21.365),(38.425,21.195),(38.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.555),(37.175,21.725),(37.345,21.725),(37.345,21.555),(37.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.555),(37.535,21.725),(37.705,21.725),(37.705,21.555),(37.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.555),(37.895,21.725),(38.065,21.725),(38.065,21.555),(37.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.555),(38.255,21.725),(38.425,21.725),(38.425,21.555),(38.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.915),(37.175,22.085),(37.345,22.085),(37.345,21.915),(37.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.915),(37.535,22.085),(37.705,22.085),(37.705,21.915),(37.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.915),(37.895,22.085),(38.065,22.085),(38.065,21.915),(37.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.915),(38.255,22.085),(38.425,22.085),(38.425,21.915),(38.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.275),(37.175,22.445),(37.345,22.445),(37.345,22.275),(37.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.275),(37.535,22.445),(37.705,22.445),(37.705,22.275),(37.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.275),(37.895,22.445),(38.065,22.445),(38.065,22.275),(37.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.275),(38.255,22.445),(38.425,22.445),(38.425,22.275),(38.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.635),(37.175,22.805),(37.345,22.805),(37.345,22.635),(37.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.635),(37.535,22.805),(37.705,22.805),(37.705,22.635),(37.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.635),(37.895,22.805),(38.065,22.805),(38.065,22.635),(37.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.635),(38.255,22.805),(38.425,22.805),(38.425,22.635),(38.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.995),(37.175,23.165),(37.345,23.165),(37.345,22.995),(37.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.995),(37.535,23.165),(37.705,23.165),(37.705,22.995),(37.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.995),(37.895,23.165),(38.065,23.165),(38.065,22.995),(37.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.995),(38.255,23.165),(38.425,23.165),(38.425,22.995),(38.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,23.355),(37.175,23.525),(37.345,23.525),(37.345,23.355),(37.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,23.355),(37.535,23.525),(37.705,23.525),(37.705,23.355),(37.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,23.355),(37.895,23.525),(38.065,23.525),(38.065,23.355),(37.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,23.355),(38.255,23.525),(38.425,23.525),(38.425,23.355),(38.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,23.715),(37.175,23.885),(37.345,23.885),(37.345,23.715),(37.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,23.715),(37.535,23.885),(37.705,23.885),(37.705,23.715),(37.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,23.715),(37.895,23.885),(38.065,23.885),(38.065,23.715),(37.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,23.715),(38.255,23.885),(38.425,23.885),(38.425,23.715),(38.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.075),(37.175,24.245),(37.345,24.245),(37.345,24.075),(37.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.075),(37.535,24.245),(37.705,24.245),(37.705,24.075),(37.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.075),(37.895,24.245),(38.065,24.245),(38.065,24.075),(37.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.075),(38.255,24.245),(38.425,24.245),(38.425,24.075),(38.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.435),(37.175,24.605),(37.345,24.605),(37.345,24.435),(37.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.435),(37.535,24.605),(37.705,24.605),(37.705,24.435),(37.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.435),(37.895,24.605),(38.065,24.605),(38.065,24.435),(37.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.435),(38.255,24.605),(38.425,24.605),(38.425,24.435),(38.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.795),(37.175,24.965),(37.345,24.965),(37.345,24.795),(37.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.795),(37.535,24.965),(37.705,24.965),(37.705,24.795),(37.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.795),(37.895,24.965),(38.065,24.965),(38.065,24.795),(37.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.795),(38.255,24.965),(38.425,24.965),(38.425,24.795),(38.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.155),(37.175,25.325),(37.345,25.325),(37.345,25.155),(37.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.155),(37.535,25.325),(37.705,25.325),(37.705,25.155),(37.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.155),(37.895,25.325),(38.065,25.325),(38.065,25.155),(37.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.155),(38.255,25.325),(38.425,25.325),(38.425,25.155),(38.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.515),(37.175,25.685),(37.345,25.685),(37.345,25.515),(37.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.515),(37.535,25.685),(37.705,25.685),(37.705,25.515),(37.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.515),(37.895,25.685),(38.065,25.685),(38.065,25.515),(37.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.515),(38.255,25.685),(38.425,25.685),(38.425,25.515),(38.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.875),(37.175,26.045),(37.345,26.045),(37.345,25.875),(37.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.875),(37.535,26.045),(37.705,26.045),(37.705,25.875),(37.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.875),(37.895,26.045),(38.065,26.045),(38.065,25.875),(37.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.875),(38.255,26.045),(38.425,26.045),(38.425,25.875),(38.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.235),(37.175,26.405),(37.345,26.405),(37.345,26.235),(37.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.235),(37.535,26.405),(37.705,26.405),(37.705,26.235),(37.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.235),(37.895,26.405),(38.065,26.405),(38.065,26.235),(37.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.235),(38.255,26.405),(38.425,26.405),(38.425,26.235),(38.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.595),(37.175,26.765),(37.345,26.765),(37.345,26.595),(37.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.595),(37.535,26.765),(37.705,26.765),(37.705,26.595),(37.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.595),(37.895,26.765),(38.065,26.765),(38.065,26.595),(37.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.595),(38.255,26.765),(38.425,26.765),(38.425,26.595),(38.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.955),(37.175,27.125),(37.345,27.125),(37.345,26.955),(37.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.955),(37.535,27.125),(37.705,27.125),(37.705,26.955),(37.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.955),(37.895,27.125),(38.065,27.125),(38.065,26.955),(37.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.955),(38.255,27.125),(38.425,27.125),(38.425,26.955),(38.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,27.315),(37.175,27.485),(37.345,27.485),(37.345,27.315),(37.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,27.315),(37.535,27.485),(37.705,27.485),(37.705,27.315),(37.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,27.315),(37.895,27.485),(38.065,27.485),(38.065,27.315),(37.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,27.315),(38.255,27.485),(38.425,27.485),(38.425,27.315),(38.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,27.675),(37.175,27.845),(37.345,27.845),(37.345,27.675),(37.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,27.675),(37.535,27.845),(37.705,27.845),(37.705,27.675),(37.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,27.675),(37.895,27.845),(38.065,27.845),(38.065,27.675),(37.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,27.675),(38.255,27.845),(38.425,27.845),(38.425,27.675),(38.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.035),(37.175,28.205),(37.345,28.205),(37.345,28.035),(37.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.035),(37.535,28.205),(37.705,28.205),(37.705,28.035),(37.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.035),(37.895,28.205),(38.065,28.205),(38.065,28.035),(37.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.035),(38.255,28.205),(38.425,28.205),(38.425,28.035),(38.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.395),(37.175,28.565),(37.345,28.565),(37.345,28.395),(37.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.395),(37.535,28.565),(37.705,28.565),(37.705,28.395),(37.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.395),(37.895,28.565),(38.065,28.565),(38.065,28.395),(37.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.395),(38.255,28.565),(38.425,28.565),(38.425,28.395),(38.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.755),(37.175,28.925),(37.345,28.925),(37.345,28.755),(37.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.755),(37.535,28.925),(37.705,28.925),(37.705,28.755),(37.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.755),(37.895,28.925),(38.065,28.925),(38.065,28.755),(37.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.755),(38.255,28.925),(38.425,28.925),(38.425,28.755),(38.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.115),(37.175,29.285),(37.345,29.285),(37.345,29.115),(37.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.115),(37.535,29.285),(37.705,29.285),(37.705,29.115),(37.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.115),(37.895,29.285),(38.065,29.285),(38.065,29.115),(37.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.115),(38.255,29.285),(38.425,29.285),(38.425,29.115),(38.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.475),(37.175,29.645),(37.345,29.645),(37.345,29.475),(37.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.475),(37.535,29.645),(37.705,29.645),(37.705,29.475),(37.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.475),(37.895,29.645),(38.065,29.645),(38.065,29.475),(37.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.475),(38.255,29.645),(38.425,29.645),(38.425,29.475),(38.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.835),(37.175,30.005),(37.345,30.005),(37.345,29.835),(37.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.835),(37.535,30.005),(37.705,30.005),(37.705,29.835),(37.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.835),(37.895,30.005),(38.065,30.005),(38.065,29.835),(37.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.835),(38.255,30.005),(38.425,30.005),(38.425,29.835),(38.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.195),(37.175,30.365),(37.345,30.365),(37.345,30.195),(37.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.195),(37.535,30.365),(37.705,30.365),(37.705,30.195),(37.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.195),(37.895,30.365),(38.065,30.365),(38.065,30.195),(37.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.195),(38.255,30.365),(38.425,30.365),(38.425,30.195),(38.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.555),(37.175,30.725),(37.345,30.725),(37.345,30.555),(37.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.555),(37.535,30.725),(37.705,30.725),(37.705,30.555),(37.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.555),(37.895,30.725),(38.065,30.725),(38.065,30.555),(37.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.555),(38.255,30.725),(38.425,30.725),(38.425,30.555),(38.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.915),(37.175,31.085),(37.345,31.085),(37.345,30.915),(37.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.915),(37.535,31.085),(37.705,31.085),(37.705,30.915),(37.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.915),(37.895,31.085),(38.065,31.085),(38.065,30.915),(37.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.915),(38.255,31.085),(38.425,31.085),(38.425,30.915),(38.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.275),(37.175,31.445),(37.345,31.445),(37.345,31.275),(37.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.275),(37.535,31.445),(37.705,31.445),(37.705,31.275),(37.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.275),(37.895,31.445),(38.065,31.445),(38.065,31.275),(37.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.275),(38.255,31.445),(38.425,31.445),(38.425,31.275),(38.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.635),(37.175,31.805),(37.345,31.805),(37.345,31.635),(37.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.635),(37.535,31.805),(37.705,31.805),(37.705,31.635),(37.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.635),(37.895,31.805),(38.065,31.805),(38.065,31.635),(37.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.635),(38.255,31.805),(38.425,31.805),(38.425,31.635),(38.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.995),(37.175,32.165),(37.345,32.165),(37.345,31.995),(37.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.995),(37.535,32.165),(37.705,32.165),(37.705,31.995),(37.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.995),(37.895,32.165),(38.065,32.165),(38.065,31.995),(37.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.995),(38.255,32.165),(38.425,32.165),(38.425,31.995),(38.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,32.355),(37.175,32.525),(37.345,32.525),(37.345,32.355),(37.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,32.355),(37.535,32.525),(37.705,32.525),(37.705,32.355),(37.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,32.355),(37.895,32.525),(38.065,32.525),(38.065,32.355),(37.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,32.355),(38.255,32.525),(38.425,32.525),(38.425,32.355),(38.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,32.715),(37.175,32.885),(37.345,32.885),(37.345,32.715),(37.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,32.715),(37.535,32.885),(37.705,32.885),(37.705,32.715),(37.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,32.715),(37.895,32.885),(38.065,32.885),(38.065,32.715),(37.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,32.715),(38.255,32.885),(38.425,32.885),(38.425,32.715),(38.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.075),(37.175,33.245),(37.345,33.245),(37.345,33.075),(37.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.075),(37.535,33.245),(37.705,33.245),(37.705,33.075),(37.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.075),(37.895,33.245),(38.065,33.245),(38.065,33.075),(37.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.075),(38.255,33.245),(38.425,33.245),(38.425,33.075),(38.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.435),(37.175,33.605),(37.345,33.605),(37.345,33.435),(37.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.435),(37.535,33.605),(37.705,33.605),(37.705,33.435),(37.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.435),(37.895,33.605),(38.065,33.605),(38.065,33.435),(37.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.435),(38.255,33.605),(38.425,33.605),(38.425,33.435),(38.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.795),(37.175,33.965),(37.345,33.965),(37.345,33.795),(37.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.795),(37.535,33.965),(37.705,33.965),(37.705,33.795),(37.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.795),(37.895,33.965),(38.065,33.965),(38.065,33.795),(37.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.795),(38.255,33.965),(38.425,33.965),(38.425,33.795),(38.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.155),(37.175,34.325),(37.345,34.325),(37.345,34.155),(37.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.155),(37.535,34.325),(37.705,34.325),(37.705,34.155),(37.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.155),(37.895,34.325),(38.065,34.325),(38.065,34.155),(37.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.155),(38.255,34.325),(38.425,34.325),(38.425,34.155),(38.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.515),(37.175,34.685),(37.345,34.685),(37.345,34.515),(37.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.515),(37.535,34.685),(37.705,34.685),(37.705,34.515),(37.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.515),(37.895,34.685),(38.065,34.685),(38.065,34.515),(37.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.515),(38.255,34.685),(38.425,34.685),(38.425,34.515),(38.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.875),(37.175,35.045),(37.345,35.045),(37.345,34.875),(37.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.875),(37.535,35.045),(37.705,35.045),(37.705,34.875),(37.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.875),(37.895,35.045),(38.065,35.045),(38.065,34.875),(37.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.875),(38.255,35.045),(38.425,35.045),(38.425,34.875),(38.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.235),(37.175,35.405),(37.345,35.405),(37.345,35.235),(37.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.235),(37.535,35.405),(37.705,35.405),(37.705,35.235),(37.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.235),(37.895,35.405),(38.065,35.405),(38.065,35.235),(37.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.235),(38.255,35.405),(38.425,35.405),(38.425,35.235),(38.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.595),(37.175,35.765),(37.345,35.765),(37.345,35.595),(37.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.595),(37.535,35.765),(37.705,35.765),(37.705,35.595),(37.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.595),(37.895,35.765),(38.065,35.765),(38.065,35.595),(37.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.595),(38.255,35.765),(38.425,35.765),(38.425,35.595),(38.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.955),(37.175,36.125),(37.345,36.125),(37.345,35.955),(37.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.955),(37.535,36.125),(37.705,36.125),(37.705,35.955),(37.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.955),(37.895,36.125),(38.065,36.125),(38.065,35.955),(37.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.955),(38.255,36.125),(38.425,36.125),(38.425,35.955),(38.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,36.315),(37.175,36.485),(37.345,36.485),(37.345,36.315),(37.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,36.315),(37.535,36.485),(37.705,36.485),(37.705,36.315),(37.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,36.315),(37.895,36.485),(38.065,36.485),(38.065,36.315),(37.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,36.315),(38.255,36.485),(38.425,36.485),(38.425,36.315),(38.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,36.675),(37.175,36.845),(37.345,36.845),(37.345,36.675),(37.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,36.675),(37.535,36.845),(37.705,36.845),(37.705,36.675),(37.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,36.675),(37.895,36.845),(38.065,36.845),(38.065,36.675),(37.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,36.675),(38.255,36.845),(38.425,36.845),(38.425,36.675),(38.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.035),(37.175,37.205),(37.345,37.205),(37.345,37.035),(37.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.035),(37.535,37.205),(37.705,37.205),(37.705,37.035),(37.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.035),(37.895,37.205),(38.065,37.205),(38.065,37.035),(37.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.035),(38.255,37.205),(38.425,37.205),(38.425,37.035),(38.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.395),(37.175,37.565),(37.345,37.565),(37.345,37.395),(37.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.395),(37.535,37.565),(37.705,37.565),(37.705,37.395),(37.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.395),(37.895,37.565),(38.065,37.565),(38.065,37.395),(37.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.395),(38.255,37.565),(38.425,37.565),(38.425,37.395),(38.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.755),(37.175,37.925),(37.345,37.925),(37.345,37.755),(37.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.755),(37.535,37.925),(37.705,37.925),(37.705,37.755),(37.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.755),(37.895,37.925),(38.065,37.925),(38.065,37.755),(37.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.755),(38.255,37.925),(38.425,37.925),(38.425,37.755),(38.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.115),(37.175,38.285),(37.345,38.285),(37.345,38.115),(37.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.115),(37.535,38.285),(37.705,38.285),(37.705,38.115),(37.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.115),(37.895,38.285),(38.065,38.285),(38.065,38.115),(37.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.115),(38.255,38.285),(38.425,38.285),(38.425,38.115),(38.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.475),(37.175,38.645),(37.345,38.645),(37.345,38.475),(37.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.475),(37.535,38.645),(37.705,38.645),(37.705,38.475),(37.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.475),(37.895,38.645),(38.065,38.645),(38.065,38.475),(37.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.475),(38.255,38.645),(38.425,38.645),(38.425,38.475),(38.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.835),(37.175,39.005),(37.345,39.005),(37.345,38.835),(37.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.835),(37.535,39.005),(37.705,39.005),(37.705,38.835),(37.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.835),(37.895,39.005),(38.065,39.005),(38.065,38.835),(37.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.835),(38.255,39.005),(38.425,39.005),(38.425,38.835),(38.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.195),(37.175,39.365),(37.345,39.365),(37.345,39.195),(37.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.195),(37.535,39.365),(37.705,39.365),(37.705,39.195),(37.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.195),(37.895,39.365),(38.065,39.365),(38.065,39.195),(37.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.195),(38.255,39.365),(38.425,39.365),(38.425,39.195),(38.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.555),(37.175,39.725),(37.345,39.725),(37.345,39.555),(37.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.555),(37.535,39.725),(37.705,39.725),(37.705,39.555),(37.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.555),(37.895,39.725),(38.065,39.725),(38.065,39.555),(37.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.555),(38.255,39.725),(38.425,39.725),(38.425,39.555),(38.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.915),(37.175,40.085),(37.345,40.085),(37.345,39.915),(37.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.915),(37.535,40.085),(37.705,40.085),(37.705,39.915),(37.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.915),(37.895,40.085),(38.065,40.085),(38.065,39.915),(37.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.915),(38.255,40.085),(38.425,40.085),(38.425,39.915),(38.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,40.275),(37.175,40.445),(37.345,40.445),(37.345,40.275),(37.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,40.275),(37.535,40.445),(37.705,40.445),(37.705,40.275),(37.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,40.275),(37.895,40.445),(38.065,40.445),(38.065,40.275),(37.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,40.275),(38.255,40.445),(38.425,40.445),(38.425,40.275),(38.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,40.635),(37.175,40.805),(37.345,40.805),(37.345,40.635),(37.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,40.635),(37.535,40.805),(37.705,40.805),(37.705,40.635),(37.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,40.635),(37.895,40.805),(38.065,40.805),(38.065,40.635),(37.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,40.635),(38.255,40.805),(38.425,40.805),(38.425,40.635),(38.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.835),(32.375,3.005),(32.545,3.005),(32.545,2.835),(32.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.835),(32.735,3.005),(32.905,3.005),(32.905,2.835),(32.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.835),(33.095,3.005),(33.265,3.005),(33.265,2.835),(33.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.835),(33.455,3.005),(33.625,3.005),(33.625,2.835),(33.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.195),(32.375,3.365),(32.545,3.365),(32.545,3.195),(32.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.195),(32.735,3.365),(32.905,3.365),(32.905,3.195),(32.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.195),(33.095,3.365),(33.265,3.365),(33.265,3.195),(33.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.195),(33.455,3.365),(33.625,3.365),(33.625,3.195),(33.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.555),(32.375,3.725),(32.545,3.725),(32.545,3.555),(32.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.555),(32.735,3.725),(32.905,3.725),(32.905,3.555),(32.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.555),(33.095,3.725),(33.265,3.725),(33.265,3.555),(33.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.555),(33.455,3.725),(33.625,3.725),(33.625,3.555),(33.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.915),(32.375,4.085),(32.545,4.085),(32.545,3.915),(32.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.915),(32.735,4.085),(32.905,4.085),(32.905,3.915),(32.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.915),(33.095,4.085),(33.265,4.085),(33.265,3.915),(33.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.915),(33.455,4.085),(33.625,4.085),(33.625,3.915),(33.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.275),(32.375,4.445),(32.545,4.445),(32.545,4.275),(32.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.275),(32.735,4.445),(32.905,4.445),(32.905,4.275),(32.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.275),(33.095,4.445),(33.265,4.445),(33.265,4.275),(33.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.275),(33.455,4.445),(33.625,4.445),(33.625,4.275),(33.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.635),(32.375,4.805),(32.545,4.805),(32.545,4.635),(32.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.635),(32.735,4.805),(32.905,4.805),(32.905,4.635),(32.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.635),(33.095,4.805),(33.265,4.805),(33.265,4.635),(33.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.635),(33.455,4.805),(33.625,4.805),(33.625,4.635),(33.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.995),(32.375,5.165),(32.545,5.165),(32.545,4.995),(32.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.995),(32.735,5.165),(32.905,5.165),(32.905,4.995),(32.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.995),(33.095,5.165),(33.265,5.165),(33.265,4.995),(33.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.995),(33.455,5.165),(33.625,5.165),(33.625,4.995),(33.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.355),(32.375,5.525),(32.545,5.525),(32.545,5.355),(32.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.355),(32.735,5.525),(32.905,5.525),(32.905,5.355),(32.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.355),(33.095,5.525),(33.265,5.525),(33.265,5.355),(33.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.355),(33.455,5.525),(33.625,5.525),(33.625,5.355),(33.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.715),(32.375,5.885),(32.545,5.885),(32.545,5.715),(32.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.715),(32.735,5.885),(32.905,5.885),(32.905,5.715),(32.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.715),(33.095,5.885),(33.265,5.885),(33.265,5.715),(33.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.715),(33.455,5.885),(33.625,5.885),(33.625,5.715),(33.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.075),(32.375,6.245),(32.545,6.245),(32.545,6.075),(32.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.075),(32.735,6.245),(32.905,6.245),(32.905,6.075),(32.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.075),(33.095,6.245),(33.265,6.245),(33.265,6.075),(33.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.075),(33.455,6.245),(33.625,6.245),(33.625,6.075),(33.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.435),(32.375,6.605),(32.545,6.605),(32.545,6.435),(32.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.435),(32.735,6.605),(32.905,6.605),(32.905,6.435),(32.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.435),(33.095,6.605),(33.265,6.605),(33.265,6.435),(33.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.435),(33.455,6.605),(33.625,6.605),(33.625,6.435),(33.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.795),(32.375,6.965),(32.545,6.965),(32.545,6.795),(32.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.795),(32.735,6.965),(32.905,6.965),(32.905,6.795),(32.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.795),(33.095,6.965),(33.265,6.965),(33.265,6.795),(33.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.795),(33.455,6.965),(33.625,6.965),(33.625,6.795),(33.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.155),(32.375,7.325),(32.545,7.325),(32.545,7.155),(32.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.155),(32.735,7.325),(32.905,7.325),(32.905,7.155),(32.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.155),(33.095,7.325),(33.265,7.325),(33.265,7.155),(33.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.155),(33.455,7.325),(33.625,7.325),(33.625,7.155),(33.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.515),(32.375,7.685),(32.545,7.685),(32.545,7.515),(32.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.515),(32.735,7.685),(32.905,7.685),(32.905,7.515),(32.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.515),(33.095,7.685),(33.265,7.685),(33.265,7.515),(33.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.515),(33.455,7.685),(33.625,7.685),(33.625,7.515),(33.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.875),(32.375,8.045),(32.545,8.045),(32.545,7.875),(32.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.875),(32.735,8.045),(32.905,8.045),(32.905,7.875),(32.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.875),(33.095,8.045),(33.265,8.045),(33.265,7.875),(33.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.875),(33.455,8.045),(33.625,8.045),(33.625,7.875),(33.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.235),(32.375,8.405),(32.545,8.405),(32.545,8.235),(32.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.235),(32.735,8.405),(32.905,8.405),(32.905,8.235),(32.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.235),(33.095,8.405),(33.265,8.405),(33.265,8.235),(33.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.235),(33.455,8.405),(33.625,8.405),(33.625,8.235),(33.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.595),(32.375,8.765),(32.545,8.765),(32.545,8.595),(32.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.595),(32.735,8.765),(32.905,8.765),(32.905,8.595),(32.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.595),(33.095,8.765),(33.265,8.765),(33.265,8.595),(33.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.595),(33.455,8.765),(33.625,8.765),(33.625,8.595),(33.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.955),(32.375,9.125),(32.545,9.125),(32.545,8.955),(32.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.955),(32.735,9.125),(32.905,9.125),(32.905,8.955),(32.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.955),(33.095,9.125),(33.265,9.125),(33.265,8.955),(33.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.955),(33.455,9.125),(33.625,9.125),(33.625,8.955),(33.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.315),(32.375,9.485),(32.545,9.485),(32.545,9.315),(32.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.315),(32.735,9.485),(32.905,9.485),(32.905,9.315),(32.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.315),(33.095,9.485),(33.265,9.485),(33.265,9.315),(33.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.315),(33.455,9.485),(33.625,9.485),(33.625,9.315),(33.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.675),(32.375,9.845),(32.545,9.845),(32.545,9.675),(32.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.675),(32.735,9.845),(32.905,9.845),(32.905,9.675),(32.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.675),(33.095,9.845),(33.265,9.845),(33.265,9.675),(33.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.675),(33.455,9.845),(33.625,9.845),(33.625,9.675),(33.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.035),(32.375,10.205),(32.545,10.205),(32.545,10.035),(32.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.035),(32.735,10.205),(32.905,10.205),(32.905,10.035),(32.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.035),(33.095,10.205),(33.265,10.205),(33.265,10.035),(33.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.035),(33.455,10.205),(33.625,10.205),(33.625,10.035),(33.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.395),(32.375,10.565),(32.545,10.565),(32.545,10.395),(32.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.395),(32.735,10.565),(32.905,10.565),(32.905,10.395),(32.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.395),(33.095,10.565),(33.265,10.565),(33.265,10.395),(33.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.395),(33.455,10.565),(33.625,10.565),(33.625,10.395),(33.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.755),(32.375,10.925),(32.545,10.925),(32.545,10.755),(32.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.755),(32.735,10.925),(32.905,10.925),(32.905,10.755),(32.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.755),(33.095,10.925),(33.265,10.925),(33.265,10.755),(33.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.755),(33.455,10.925),(33.625,10.925),(33.625,10.755),(33.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.115),(32.375,11.285),(32.545,11.285),(32.545,11.115),(32.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.115),(32.735,11.285),(32.905,11.285),(32.905,11.115),(32.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.115),(33.095,11.285),(33.265,11.285),(33.265,11.115),(33.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.115),(33.455,11.285),(33.625,11.285),(33.625,11.115),(33.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.475),(32.375,11.645),(32.545,11.645),(32.545,11.475),(32.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.475),(32.735,11.645),(32.905,11.645),(32.905,11.475),(32.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.475),(33.095,11.645),(33.265,11.645),(33.265,11.475),(33.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.475),(33.455,11.645),(33.625,11.645),(33.625,11.475),(33.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.835),(32.375,12.005),(32.545,12.005),(32.545,11.835),(32.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.835),(32.735,12.005),(32.905,12.005),(32.905,11.835),(32.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.835),(33.095,12.005),(33.265,12.005),(33.265,11.835),(33.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.835),(33.455,12.005),(33.625,12.005),(33.625,11.835),(33.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.195),(32.375,12.365),(32.545,12.365),(32.545,12.195),(32.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.195),(32.735,12.365),(32.905,12.365),(32.905,12.195),(32.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.195),(33.095,12.365),(33.265,12.365),(33.265,12.195),(33.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.195),(33.455,12.365),(33.625,12.365),(33.625,12.195),(33.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.555),(32.375,12.725),(32.545,12.725),(32.545,12.555),(32.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.555),(32.735,12.725),(32.905,12.725),(32.905,12.555),(32.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.555),(33.095,12.725),(33.265,12.725),(33.265,12.555),(33.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.555),(33.455,12.725),(33.625,12.725),(33.625,12.555),(33.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.915),(32.375,13.085),(32.545,13.085),(32.545,12.915),(32.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.915),(32.735,13.085),(32.905,13.085),(32.905,12.915),(32.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.915),(33.095,13.085),(33.265,13.085),(33.265,12.915),(33.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.915),(33.455,13.085),(33.625,13.085),(33.625,12.915),(33.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.275),(32.375,13.445),(32.545,13.445),(32.545,13.275),(32.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.275),(32.735,13.445),(32.905,13.445),(32.905,13.275),(32.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.275),(33.095,13.445),(33.265,13.445),(33.265,13.275),(33.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.275),(33.455,13.445),(33.625,13.445),(33.625,13.275),(33.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.635),(32.375,13.805),(32.545,13.805),(32.545,13.635),(32.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.635),(32.735,13.805),(32.905,13.805),(32.905,13.635),(32.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.635),(33.095,13.805),(33.265,13.805),(33.265,13.635),(33.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.635),(33.455,13.805),(33.625,13.805),(33.625,13.635),(33.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.995),(32.375,14.165),(32.545,14.165),(32.545,13.995),(32.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.995),(32.735,14.165),(32.905,14.165),(32.905,13.995),(32.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.995),(33.095,14.165),(33.265,14.165),(33.265,13.995),(33.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.995),(33.455,14.165),(33.625,14.165),(33.625,13.995),(33.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.355),(32.375,14.525),(32.545,14.525),(32.545,14.355),(32.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.355),(32.735,14.525),(32.905,14.525),(32.905,14.355),(32.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.355),(33.095,14.525),(33.265,14.525),(33.265,14.355),(33.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.355),(33.455,14.525),(33.625,14.525),(33.625,14.355),(33.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.715),(32.375,14.885),(32.545,14.885),(32.545,14.715),(32.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.715),(32.735,14.885),(32.905,14.885),(32.905,14.715),(32.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.715),(33.095,14.885),(33.265,14.885),(33.265,14.715),(33.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.715),(33.455,14.885),(33.625,14.885),(33.625,14.715),(33.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.075),(32.375,15.245),(32.545,15.245),(32.545,15.075),(32.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.075),(32.735,15.245),(32.905,15.245),(32.905,15.075),(32.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.075),(33.095,15.245),(33.265,15.245),(33.265,15.075),(33.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.075),(33.455,15.245),(33.625,15.245),(33.625,15.075),(33.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.435),(32.375,15.605),(32.545,15.605),(32.545,15.435),(32.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.435),(32.735,15.605),(32.905,15.605),(32.905,15.435),(32.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.435),(33.095,15.605),(33.265,15.605),(33.265,15.435),(33.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.435),(33.455,15.605),(33.625,15.605),(33.625,15.435),(33.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.795),(32.375,15.965),(32.545,15.965),(32.545,15.795),(32.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.795),(32.735,15.965),(32.905,15.965),(32.905,15.795),(32.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.795),(33.095,15.965),(33.265,15.965),(33.265,15.795),(33.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.795),(33.455,15.965),(33.625,15.965),(33.625,15.795),(33.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.155),(32.375,16.325),(32.545,16.325),(32.545,16.155),(32.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.155),(32.735,16.325),(32.905,16.325),(32.905,16.155),(32.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.155),(33.095,16.325),(33.265,16.325),(33.265,16.155),(33.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.155),(33.455,16.325),(33.625,16.325),(33.625,16.155),(33.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.515),(32.375,16.685),(32.545,16.685),(32.545,16.515),(32.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.515),(32.735,16.685),(32.905,16.685),(32.905,16.515),(32.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.515),(33.095,16.685),(33.265,16.685),(33.265,16.515),(33.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.515),(33.455,16.685),(33.625,16.685),(33.625,16.515),(33.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.875),(32.375,17.045),(32.545,17.045),(32.545,16.875),(32.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.875),(32.735,17.045),(32.905,17.045),(32.905,16.875),(32.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.875),(33.095,17.045),(33.265,17.045),(33.265,16.875),(33.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.875),(33.455,17.045),(33.625,17.045),(33.625,16.875),(33.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.235),(32.375,17.405),(32.545,17.405),(32.545,17.235),(32.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.235),(32.735,17.405),(32.905,17.405),(32.905,17.235),(32.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.235),(33.095,17.405),(33.265,17.405),(33.265,17.235),(33.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.235),(33.455,17.405),(33.625,17.405),(33.625,17.235),(33.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.595),(32.375,17.765),(32.545,17.765),(32.545,17.595),(32.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.595),(32.735,17.765),(32.905,17.765),(32.905,17.595),(32.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.595),(33.095,17.765),(33.265,17.765),(33.265,17.595),(33.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.595),(33.455,17.765),(33.625,17.765),(33.625,17.595),(33.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.955),(32.375,18.125),(32.545,18.125),(32.545,17.955),(32.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.955),(32.735,18.125),(32.905,18.125),(32.905,17.955),(32.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.955),(33.095,18.125),(33.265,18.125),(33.265,17.955),(33.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.955),(33.455,18.125),(33.625,18.125),(33.625,17.955),(33.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.315),(32.375,18.485),(32.545,18.485),(32.545,18.315),(32.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.315),(32.735,18.485),(32.905,18.485),(32.905,18.315),(32.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.315),(33.095,18.485),(33.265,18.485),(33.265,18.315),(33.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.315),(33.455,18.485),(33.625,18.485),(33.625,18.315),(33.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.675),(32.375,18.845),(32.545,18.845),(32.545,18.675),(32.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.675),(32.735,18.845),(32.905,18.845),(32.905,18.675),(32.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.675),(33.095,18.845),(33.265,18.845),(33.265,18.675),(33.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.675),(33.455,18.845),(33.625,18.845),(33.625,18.675),(33.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.035),(32.375,19.205),(32.545,19.205),(32.545,19.035),(32.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.035),(32.735,19.205),(32.905,19.205),(32.905,19.035),(32.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.035),(33.095,19.205),(33.265,19.205),(33.265,19.035),(33.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.035),(33.455,19.205),(33.625,19.205),(33.625,19.035),(33.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.395),(32.375,19.565),(32.545,19.565),(32.545,19.395),(32.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.395),(32.735,19.565),(32.905,19.565),(32.905,19.395),(32.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.395),(33.095,19.565),(33.265,19.565),(33.265,19.395),(33.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.395),(33.455,19.565),(33.625,19.565),(33.625,19.395),(33.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.755),(32.375,19.925),(32.545,19.925),(32.545,19.755),(32.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.755),(32.735,19.925),(32.905,19.925),(32.905,19.755),(32.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.755),(33.095,19.925),(33.265,19.925),(33.265,19.755),(33.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.755),(33.455,19.925),(33.625,19.925),(33.625,19.755),(33.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.115),(32.375,20.285),(32.545,20.285),(32.545,20.115),(32.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.115),(32.735,20.285),(32.905,20.285),(32.905,20.115),(32.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.115),(33.095,20.285),(33.265,20.285),(33.265,20.115),(33.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.115),(33.455,20.285),(33.625,20.285),(33.625,20.115),(33.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.475),(32.375,20.645),(32.545,20.645),(32.545,20.475),(32.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.475),(32.735,20.645),(32.905,20.645),(32.905,20.475),(32.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.475),(33.095,20.645),(33.265,20.645),(33.265,20.475),(33.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.475),(33.455,20.645),(33.625,20.645),(33.625,20.475),(33.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.835),(32.375,21.005),(32.545,21.005),(32.545,20.835),(32.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.835),(32.735,21.005),(32.905,21.005),(32.905,20.835),(32.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.835),(33.095,21.005),(33.265,21.005),(33.265,20.835),(33.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.835),(33.455,21.005),(33.625,21.005),(33.625,20.835),(33.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.195),(32.375,21.365),(32.545,21.365),(32.545,21.195),(32.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.195),(32.735,21.365),(32.905,21.365),(32.905,21.195),(32.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.195),(33.095,21.365),(33.265,21.365),(33.265,21.195),(33.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.195),(33.455,21.365),(33.625,21.365),(33.625,21.195),(33.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.555),(32.375,21.725),(32.545,21.725),(32.545,21.555),(32.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.555),(32.735,21.725),(32.905,21.725),(32.905,21.555),(32.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.555),(33.095,21.725),(33.265,21.725),(33.265,21.555),(33.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.555),(33.455,21.725),(33.625,21.725),(33.625,21.555),(33.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.915),(32.375,22.085),(32.545,22.085),(32.545,21.915),(32.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.915),(32.735,22.085),(32.905,22.085),(32.905,21.915),(32.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.915),(33.095,22.085),(33.265,22.085),(33.265,21.915),(33.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.915),(33.455,22.085),(33.625,22.085),(33.625,21.915),(33.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.275),(32.375,22.445),(32.545,22.445),(32.545,22.275),(32.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.275),(32.735,22.445),(32.905,22.445),(32.905,22.275),(32.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.275),(33.095,22.445),(33.265,22.445),(33.265,22.275),(33.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.275),(33.455,22.445),(33.625,22.445),(33.625,22.275),(33.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.635),(32.375,22.805),(32.545,22.805),(32.545,22.635),(32.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.635),(32.735,22.805),(32.905,22.805),(32.905,22.635),(32.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.635),(33.095,22.805),(33.265,22.805),(33.265,22.635),(33.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.635),(33.455,22.805),(33.625,22.805),(33.625,22.635),(33.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.995),(32.375,23.165),(32.545,23.165),(32.545,22.995),(32.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.995),(32.735,23.165),(32.905,23.165),(32.905,22.995),(32.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.995),(33.095,23.165),(33.265,23.165),(33.265,22.995),(33.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.995),(33.455,23.165),(33.625,23.165),(33.625,22.995),(33.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,23.355),(32.375,23.525),(32.545,23.525),(32.545,23.355),(32.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,23.355),(32.735,23.525),(32.905,23.525),(32.905,23.355),(32.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,23.355),(33.095,23.525),(33.265,23.525),(33.265,23.355),(33.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,23.355),(33.455,23.525),(33.625,23.525),(33.625,23.355),(33.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,23.715),(32.375,23.885),(32.545,23.885),(32.545,23.715),(32.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,23.715),(32.735,23.885),(32.905,23.885),(32.905,23.715),(32.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,23.715),(33.095,23.885),(33.265,23.885),(33.265,23.715),(33.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,23.715),(33.455,23.885),(33.625,23.885),(33.625,23.715),(33.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.075),(32.375,24.245),(32.545,24.245),(32.545,24.075),(32.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.075),(32.735,24.245),(32.905,24.245),(32.905,24.075),(32.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.075),(33.095,24.245),(33.265,24.245),(33.265,24.075),(33.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.075),(33.455,24.245),(33.625,24.245),(33.625,24.075),(33.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.435),(32.375,24.605),(32.545,24.605),(32.545,24.435),(32.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.435),(32.735,24.605),(32.905,24.605),(32.905,24.435),(32.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.435),(33.095,24.605),(33.265,24.605),(33.265,24.435),(33.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.435),(33.455,24.605),(33.625,24.605),(33.625,24.435),(33.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.795),(32.375,24.965),(32.545,24.965),(32.545,24.795),(32.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.795),(32.735,24.965),(32.905,24.965),(32.905,24.795),(32.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.795),(33.095,24.965),(33.265,24.965),(33.265,24.795),(33.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.795),(33.455,24.965),(33.625,24.965),(33.625,24.795),(33.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.155),(32.375,25.325),(32.545,25.325),(32.545,25.155),(32.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.155),(32.735,25.325),(32.905,25.325),(32.905,25.155),(32.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.155),(33.095,25.325),(33.265,25.325),(33.265,25.155),(33.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.155),(33.455,25.325),(33.625,25.325),(33.625,25.155),(33.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.515),(32.375,25.685),(32.545,25.685),(32.545,25.515),(32.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.515),(32.735,25.685),(32.905,25.685),(32.905,25.515),(32.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.515),(33.095,25.685),(33.265,25.685),(33.265,25.515),(33.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.515),(33.455,25.685),(33.625,25.685),(33.625,25.515),(33.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.875),(32.375,26.045),(32.545,26.045),(32.545,25.875),(32.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.875),(32.735,26.045),(32.905,26.045),(32.905,25.875),(32.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.875),(33.095,26.045),(33.265,26.045),(33.265,25.875),(33.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.875),(33.455,26.045),(33.625,26.045),(33.625,25.875),(33.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.235),(32.375,26.405),(32.545,26.405),(32.545,26.235),(32.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.235),(32.735,26.405),(32.905,26.405),(32.905,26.235),(32.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.235),(33.095,26.405),(33.265,26.405),(33.265,26.235),(33.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.235),(33.455,26.405),(33.625,26.405),(33.625,26.235),(33.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.595),(32.375,26.765),(32.545,26.765),(32.545,26.595),(32.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.595),(32.735,26.765),(32.905,26.765),(32.905,26.595),(32.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.595),(33.095,26.765),(33.265,26.765),(33.265,26.595),(33.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.595),(33.455,26.765),(33.625,26.765),(33.625,26.595),(33.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.955),(32.375,27.125),(32.545,27.125),(32.545,26.955),(32.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.955),(32.735,27.125),(32.905,27.125),(32.905,26.955),(32.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.955),(33.095,27.125),(33.265,27.125),(33.265,26.955),(33.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.955),(33.455,27.125),(33.625,27.125),(33.625,26.955),(33.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,27.315),(32.375,27.485),(32.545,27.485),(32.545,27.315),(32.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,27.315),(32.735,27.485),(32.905,27.485),(32.905,27.315),(32.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,27.315),(33.095,27.485),(33.265,27.485),(33.265,27.315),(33.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,27.315),(33.455,27.485),(33.625,27.485),(33.625,27.315),(33.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,27.675),(32.375,27.845),(32.545,27.845),(32.545,27.675),(32.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,27.675),(32.735,27.845),(32.905,27.845),(32.905,27.675),(32.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,27.675),(33.095,27.845),(33.265,27.845),(33.265,27.675),(33.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,27.675),(33.455,27.845),(33.625,27.845),(33.625,27.675),(33.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.035),(32.375,28.205),(32.545,28.205),(32.545,28.035),(32.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.035),(32.735,28.205),(32.905,28.205),(32.905,28.035),(32.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.035),(33.095,28.205),(33.265,28.205),(33.265,28.035),(33.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.035),(33.455,28.205),(33.625,28.205),(33.625,28.035),(33.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.395),(32.375,28.565),(32.545,28.565),(32.545,28.395),(32.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.395),(32.735,28.565),(32.905,28.565),(32.905,28.395),(32.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.395),(33.095,28.565),(33.265,28.565),(33.265,28.395),(33.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.395),(33.455,28.565),(33.625,28.565),(33.625,28.395),(33.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.755),(32.375,28.925),(32.545,28.925),(32.545,28.755),(32.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.755),(32.735,28.925),(32.905,28.925),(32.905,28.755),(32.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.755),(33.095,28.925),(33.265,28.925),(33.265,28.755),(33.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.755),(33.455,28.925),(33.625,28.925),(33.625,28.755),(33.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.115),(32.375,29.285),(32.545,29.285),(32.545,29.115),(32.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.115),(32.735,29.285),(32.905,29.285),(32.905,29.115),(32.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.115),(33.095,29.285),(33.265,29.285),(33.265,29.115),(33.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.115),(33.455,29.285),(33.625,29.285),(33.625,29.115),(33.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.475),(32.375,29.645),(32.545,29.645),(32.545,29.475),(32.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.475),(32.735,29.645),(32.905,29.645),(32.905,29.475),(32.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.475),(33.095,29.645),(33.265,29.645),(33.265,29.475),(33.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.475),(33.455,29.645),(33.625,29.645),(33.625,29.475),(33.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.835),(32.375,30.005),(32.545,30.005),(32.545,29.835),(32.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.835),(32.735,30.005),(32.905,30.005),(32.905,29.835),(32.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.835),(33.095,30.005),(33.265,30.005),(33.265,29.835),(33.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.835),(33.455,30.005),(33.625,30.005),(33.625,29.835),(33.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.195),(32.375,30.365),(32.545,30.365),(32.545,30.195),(32.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.195),(32.735,30.365),(32.905,30.365),(32.905,30.195),(32.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.195),(33.095,30.365),(33.265,30.365),(33.265,30.195),(33.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.195),(33.455,30.365),(33.625,30.365),(33.625,30.195),(33.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.555),(32.375,30.725),(32.545,30.725),(32.545,30.555),(32.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.555),(32.735,30.725),(32.905,30.725),(32.905,30.555),(32.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.555),(33.095,30.725),(33.265,30.725),(33.265,30.555),(33.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.555),(33.455,30.725),(33.625,30.725),(33.625,30.555),(33.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.915),(32.375,31.085),(32.545,31.085),(32.545,30.915),(32.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.915),(32.735,31.085),(32.905,31.085),(32.905,30.915),(32.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.915),(33.095,31.085),(33.265,31.085),(33.265,30.915),(33.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.915),(33.455,31.085),(33.625,31.085),(33.625,30.915),(33.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.275),(32.375,31.445),(32.545,31.445),(32.545,31.275),(32.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.275),(32.735,31.445),(32.905,31.445),(32.905,31.275),(32.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.275),(33.095,31.445),(33.265,31.445),(33.265,31.275),(33.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.275),(33.455,31.445),(33.625,31.445),(33.625,31.275),(33.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.635),(32.375,31.805),(32.545,31.805),(32.545,31.635),(32.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.635),(32.735,31.805),(32.905,31.805),(32.905,31.635),(32.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.635),(33.095,31.805),(33.265,31.805),(33.265,31.635),(33.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.635),(33.455,31.805),(33.625,31.805),(33.625,31.635),(33.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.995),(32.375,32.165),(32.545,32.165),(32.545,31.995),(32.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.995),(32.735,32.165),(32.905,32.165),(32.905,31.995),(32.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.995),(33.095,32.165),(33.265,32.165),(33.265,31.995),(33.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.995),(33.455,32.165),(33.625,32.165),(33.625,31.995),(33.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,32.355),(32.375,32.525),(32.545,32.525),(32.545,32.355),(32.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,32.355),(32.735,32.525),(32.905,32.525),(32.905,32.355),(32.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,32.355),(33.095,32.525),(33.265,32.525),(33.265,32.355),(33.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,32.355),(33.455,32.525),(33.625,32.525),(33.625,32.355),(33.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,32.715),(32.375,32.885),(32.545,32.885),(32.545,32.715),(32.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,32.715),(32.735,32.885),(32.905,32.885),(32.905,32.715),(32.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,32.715),(33.095,32.885),(33.265,32.885),(33.265,32.715),(33.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,32.715),(33.455,32.885),(33.625,32.885),(33.625,32.715),(33.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.075),(32.375,33.245),(32.545,33.245),(32.545,33.075),(32.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.075),(32.735,33.245),(32.905,33.245),(32.905,33.075),(32.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.075),(33.095,33.245),(33.265,33.245),(33.265,33.075),(33.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.075),(33.455,33.245),(33.625,33.245),(33.625,33.075),(33.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.435),(32.375,33.605),(32.545,33.605),(32.545,33.435),(32.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.435),(32.735,33.605),(32.905,33.605),(32.905,33.435),(32.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.435),(33.095,33.605),(33.265,33.605),(33.265,33.435),(33.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.435),(33.455,33.605),(33.625,33.605),(33.625,33.435),(33.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.795),(32.375,33.965),(32.545,33.965),(32.545,33.795),(32.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.795),(32.735,33.965),(32.905,33.965),(32.905,33.795),(32.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.795),(33.095,33.965),(33.265,33.965),(33.265,33.795),(33.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.795),(33.455,33.965),(33.625,33.965),(33.625,33.795),(33.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.155),(32.375,34.325),(32.545,34.325),(32.545,34.155),(32.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.155),(32.735,34.325),(32.905,34.325),(32.905,34.155),(32.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.155),(33.095,34.325),(33.265,34.325),(33.265,34.155),(33.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.155),(33.455,34.325),(33.625,34.325),(33.625,34.155),(33.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.515),(32.375,34.685),(32.545,34.685),(32.545,34.515),(32.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.515),(32.735,34.685),(32.905,34.685),(32.905,34.515),(32.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.515),(33.095,34.685),(33.265,34.685),(33.265,34.515),(33.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.515),(33.455,34.685),(33.625,34.685),(33.625,34.515),(33.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.875),(32.375,35.045),(32.545,35.045),(32.545,34.875),(32.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.875),(32.735,35.045),(32.905,35.045),(32.905,34.875),(32.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.875),(33.095,35.045),(33.265,35.045),(33.265,34.875),(33.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.875),(33.455,35.045),(33.625,35.045),(33.625,34.875),(33.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.235),(32.375,35.405),(32.545,35.405),(32.545,35.235),(32.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.235),(32.735,35.405),(32.905,35.405),(32.905,35.235),(32.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.235),(33.095,35.405),(33.265,35.405),(33.265,35.235),(33.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.235),(33.455,35.405),(33.625,35.405),(33.625,35.235),(33.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.595),(32.375,35.765),(32.545,35.765),(32.545,35.595),(32.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.595),(32.735,35.765),(32.905,35.765),(32.905,35.595),(32.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.595),(33.095,35.765),(33.265,35.765),(33.265,35.595),(33.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.595),(33.455,35.765),(33.625,35.765),(33.625,35.595),(33.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.955),(32.375,36.125),(32.545,36.125),(32.545,35.955),(32.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.955),(32.735,36.125),(32.905,36.125),(32.905,35.955),(32.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.955),(33.095,36.125),(33.265,36.125),(33.265,35.955),(33.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.955),(33.455,36.125),(33.625,36.125),(33.625,35.955),(33.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,36.315),(32.375,36.485),(32.545,36.485),(32.545,36.315),(32.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,36.315),(32.735,36.485),(32.905,36.485),(32.905,36.315),(32.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,36.315),(33.095,36.485),(33.265,36.485),(33.265,36.315),(33.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,36.315),(33.455,36.485),(33.625,36.485),(33.625,36.315),(33.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,36.675),(32.375,36.845),(32.545,36.845),(32.545,36.675),(32.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,36.675),(32.735,36.845),(32.905,36.845),(32.905,36.675),(32.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,36.675),(33.095,36.845),(33.265,36.845),(33.265,36.675),(33.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,36.675),(33.455,36.845),(33.625,36.845),(33.625,36.675),(33.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.035),(32.375,37.205),(32.545,37.205),(32.545,37.035),(32.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.035),(32.735,37.205),(32.905,37.205),(32.905,37.035),(32.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.035),(33.095,37.205),(33.265,37.205),(33.265,37.035),(33.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.035),(33.455,37.205),(33.625,37.205),(33.625,37.035),(33.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.395),(32.375,37.565),(32.545,37.565),(32.545,37.395),(32.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.395),(32.735,37.565),(32.905,37.565),(32.905,37.395),(32.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.395),(33.095,37.565),(33.265,37.565),(33.265,37.395),(33.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.395),(33.455,37.565),(33.625,37.565),(33.625,37.395),(33.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.755),(32.375,37.925),(32.545,37.925),(32.545,37.755),(32.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.755),(32.735,37.925),(32.905,37.925),(32.905,37.755),(32.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.755),(33.095,37.925),(33.265,37.925),(33.265,37.755),(33.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.755),(33.455,37.925),(33.625,37.925),(33.625,37.755),(33.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.115),(32.375,38.285),(32.545,38.285),(32.545,38.115),(32.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.115),(32.735,38.285),(32.905,38.285),(32.905,38.115),(32.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.115),(33.095,38.285),(33.265,38.285),(33.265,38.115),(33.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.115),(33.455,38.285),(33.625,38.285),(33.625,38.115),(33.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.475),(32.375,38.645),(32.545,38.645),(32.545,38.475),(32.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.475),(32.735,38.645),(32.905,38.645),(32.905,38.475),(32.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.475),(33.095,38.645),(33.265,38.645),(33.265,38.475),(33.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.475),(33.455,38.645),(33.625,38.645),(33.625,38.475),(33.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.835),(32.375,39.005),(32.545,39.005),(32.545,38.835),(32.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.835),(32.735,39.005),(32.905,39.005),(32.905,38.835),(32.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.835),(33.095,39.005),(33.265,39.005),(33.265,38.835),(33.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.835),(33.455,39.005),(33.625,39.005),(33.625,38.835),(33.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.195),(32.375,39.365),(32.545,39.365),(32.545,39.195),(32.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.195),(32.735,39.365),(32.905,39.365),(32.905,39.195),(32.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.195),(33.095,39.365),(33.265,39.365),(33.265,39.195),(33.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.195),(33.455,39.365),(33.625,39.365),(33.625,39.195),(33.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.555),(32.375,39.725),(32.545,39.725),(32.545,39.555),(32.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.555),(32.735,39.725),(32.905,39.725),(32.905,39.555),(32.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.555),(33.095,39.725),(33.265,39.725),(33.265,39.555),(33.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.555),(33.455,39.725),(33.625,39.725),(33.625,39.555),(33.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.915),(32.375,40.085),(32.545,40.085),(32.545,39.915),(32.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.915),(32.735,40.085),(32.905,40.085),(32.905,39.915),(32.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.915),(33.095,40.085),(33.265,40.085),(33.265,39.915),(33.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.915),(33.455,40.085),(33.625,40.085),(33.625,39.915),(33.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,40.275),(32.375,40.445),(32.545,40.445),(32.545,40.275),(32.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,40.275),(32.735,40.445),(32.905,40.445),(32.905,40.275),(32.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,40.275),(33.095,40.445),(33.265,40.445),(33.265,40.275),(33.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,40.275),(33.455,40.445),(33.625,40.445),(33.625,40.275),(33.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,40.635),(32.375,40.805),(32.545,40.805),(32.545,40.635),(32.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,40.635),(32.735,40.805),(32.905,40.805),(32.905,40.635),(32.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,40.635),(33.095,40.805),(33.265,40.805),(33.265,40.635),(33.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,40.635),(33.455,40.805),(33.625,40.805),(33.625,40.635),(33.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,2.835),(17.975,3.005),(18.145,3.005),(18.145,2.835),(17.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,2.835),(18.335,3.005),(18.505,3.005),(18.505,2.835),(18.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,2.835),(18.695,3.005),(18.865,3.005),(18.865,2.835),(18.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,2.835),(19.055,3.005),(19.225,3.005),(19.225,2.835),(19.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.195),(17.975,3.365),(18.145,3.365),(18.145,3.195),(17.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.195),(18.335,3.365),(18.505,3.365),(18.505,3.195),(18.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.195),(18.695,3.365),(18.865,3.365),(18.865,3.195),(18.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.195),(19.055,3.365),(19.225,3.365),(19.225,3.195),(19.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.555),(17.975,3.725),(18.145,3.725),(18.145,3.555),(17.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.555),(18.335,3.725),(18.505,3.725),(18.505,3.555),(18.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.555),(18.695,3.725),(18.865,3.725),(18.865,3.555),(18.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.555),(19.055,3.725),(19.225,3.725),(19.225,3.555),(19.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.915),(17.975,4.085),(18.145,4.085),(18.145,3.915),(17.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.915),(18.335,4.085),(18.505,4.085),(18.505,3.915),(18.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.915),(18.695,4.085),(18.865,4.085),(18.865,3.915),(18.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.915),(19.055,4.085),(19.225,4.085),(19.225,3.915),(19.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.275),(17.975,4.445),(18.145,4.445),(18.145,4.275),(17.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.275),(18.335,4.445),(18.505,4.445),(18.505,4.275),(18.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.275),(18.695,4.445),(18.865,4.445),(18.865,4.275),(18.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.275),(19.055,4.445),(19.225,4.445),(19.225,4.275),(19.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.635),(17.975,4.805),(18.145,4.805),(18.145,4.635),(17.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.635),(18.335,4.805),(18.505,4.805),(18.505,4.635),(18.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.635),(18.695,4.805),(18.865,4.805),(18.865,4.635),(18.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.635),(19.055,4.805),(19.225,4.805),(19.225,4.635),(19.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.995),(17.975,5.165),(18.145,5.165),(18.145,4.995),(17.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.995),(18.335,5.165),(18.505,5.165),(18.505,4.995),(18.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.995),(18.695,5.165),(18.865,5.165),(18.865,4.995),(18.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.995),(19.055,5.165),(19.225,5.165),(19.225,4.995),(19.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.355),(17.975,5.525),(18.145,5.525),(18.145,5.355),(17.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.355),(18.335,5.525),(18.505,5.525),(18.505,5.355),(18.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.355),(18.695,5.525),(18.865,5.525),(18.865,5.355),(18.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.355),(19.055,5.525),(19.225,5.525),(19.225,5.355),(19.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.715),(17.975,5.885),(18.145,5.885),(18.145,5.715),(17.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.715),(18.335,5.885),(18.505,5.885),(18.505,5.715),(18.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.715),(18.695,5.885),(18.865,5.885),(18.865,5.715),(18.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.715),(19.055,5.885),(19.225,5.885),(19.225,5.715),(19.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.075),(17.975,6.245),(18.145,6.245),(18.145,6.075),(17.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.075),(18.335,6.245),(18.505,6.245),(18.505,6.075),(18.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.075),(18.695,6.245),(18.865,6.245),(18.865,6.075),(18.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.075),(19.055,6.245),(19.225,6.245),(19.225,6.075),(19.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.435),(17.975,6.605),(18.145,6.605),(18.145,6.435),(17.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.435),(18.335,6.605),(18.505,6.605),(18.505,6.435),(18.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.435),(18.695,6.605),(18.865,6.605),(18.865,6.435),(18.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.435),(19.055,6.605),(19.225,6.605),(19.225,6.435),(19.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.795),(17.975,6.965),(18.145,6.965),(18.145,6.795),(17.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.795),(18.335,6.965),(18.505,6.965),(18.505,6.795),(18.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.795),(18.695,6.965),(18.865,6.965),(18.865,6.795),(18.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.795),(19.055,6.965),(19.225,6.965),(19.225,6.795),(19.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.155),(17.975,7.325),(18.145,7.325),(18.145,7.155),(17.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.155),(18.335,7.325),(18.505,7.325),(18.505,7.155),(18.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.155),(18.695,7.325),(18.865,7.325),(18.865,7.155),(18.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.155),(19.055,7.325),(19.225,7.325),(19.225,7.155),(19.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.515),(17.975,7.685),(18.145,7.685),(18.145,7.515),(17.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.515),(18.335,7.685),(18.505,7.685),(18.505,7.515),(18.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.515),(18.695,7.685),(18.865,7.685),(18.865,7.515),(18.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.515),(19.055,7.685),(19.225,7.685),(19.225,7.515),(19.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.875),(17.975,8.045),(18.145,8.045),(18.145,7.875),(17.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.875),(18.335,8.045),(18.505,8.045),(18.505,7.875),(18.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.875),(18.695,8.045),(18.865,8.045),(18.865,7.875),(18.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.875),(19.055,8.045),(19.225,8.045),(19.225,7.875),(19.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.235),(17.975,8.405),(18.145,8.405),(18.145,8.235),(17.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.235),(18.335,8.405),(18.505,8.405),(18.505,8.235),(18.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.235),(18.695,8.405),(18.865,8.405),(18.865,8.235),(18.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.235),(19.055,8.405),(19.225,8.405),(19.225,8.235),(19.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.595),(17.975,8.765),(18.145,8.765),(18.145,8.595),(17.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.595),(18.335,8.765),(18.505,8.765),(18.505,8.595),(18.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.595),(18.695,8.765),(18.865,8.765),(18.865,8.595),(18.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.595),(19.055,8.765),(19.225,8.765),(19.225,8.595),(19.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.955),(17.975,9.125),(18.145,9.125),(18.145,8.955),(17.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.955),(18.335,9.125),(18.505,9.125),(18.505,8.955),(18.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.955),(18.695,9.125),(18.865,9.125),(18.865,8.955),(18.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.955),(19.055,9.125),(19.225,9.125),(19.225,8.955),(19.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.315),(17.975,9.485),(18.145,9.485),(18.145,9.315),(17.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.315),(18.335,9.485),(18.505,9.485),(18.505,9.315),(18.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.315),(18.695,9.485),(18.865,9.485),(18.865,9.315),(18.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.315),(19.055,9.485),(19.225,9.485),(19.225,9.315),(19.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.675),(17.975,9.845),(18.145,9.845),(18.145,9.675),(17.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.675),(18.335,9.845),(18.505,9.845),(18.505,9.675),(18.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.675),(18.695,9.845),(18.865,9.845),(18.865,9.675),(18.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.675),(19.055,9.845),(19.225,9.845),(19.225,9.675),(19.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.035),(17.975,10.205),(18.145,10.205),(18.145,10.035),(17.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.035),(18.335,10.205),(18.505,10.205),(18.505,10.035),(18.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.035),(18.695,10.205),(18.865,10.205),(18.865,10.035),(18.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.035),(19.055,10.205),(19.225,10.205),(19.225,10.035),(19.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.395),(17.975,10.565),(18.145,10.565),(18.145,10.395),(17.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.395),(18.335,10.565),(18.505,10.565),(18.505,10.395),(18.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.395),(18.695,10.565),(18.865,10.565),(18.865,10.395),(18.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.395),(19.055,10.565),(19.225,10.565),(19.225,10.395),(19.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.755),(17.975,10.925),(18.145,10.925),(18.145,10.755),(17.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.755),(18.335,10.925),(18.505,10.925),(18.505,10.755),(18.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.755),(18.695,10.925),(18.865,10.925),(18.865,10.755),(18.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.755),(19.055,10.925),(19.225,10.925),(19.225,10.755),(19.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.115),(17.975,11.285),(18.145,11.285),(18.145,11.115),(17.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.115),(18.335,11.285),(18.505,11.285),(18.505,11.115),(18.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.115),(18.695,11.285),(18.865,11.285),(18.865,11.115),(18.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.115),(19.055,11.285),(19.225,11.285),(19.225,11.115),(19.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.475),(17.975,11.645),(18.145,11.645),(18.145,11.475),(17.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.475),(18.335,11.645),(18.505,11.645),(18.505,11.475),(18.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.475),(18.695,11.645),(18.865,11.645),(18.865,11.475),(18.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.475),(19.055,11.645),(19.225,11.645),(19.225,11.475),(19.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.835),(17.975,12.005),(18.145,12.005),(18.145,11.835),(17.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.835),(18.335,12.005),(18.505,12.005),(18.505,11.835),(18.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.835),(18.695,12.005),(18.865,12.005),(18.865,11.835),(18.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.835),(19.055,12.005),(19.225,12.005),(19.225,11.835),(19.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.195),(17.975,12.365),(18.145,12.365),(18.145,12.195),(17.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.195),(18.335,12.365),(18.505,12.365),(18.505,12.195),(18.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.195),(18.695,12.365),(18.865,12.365),(18.865,12.195),(18.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.195),(19.055,12.365),(19.225,12.365),(19.225,12.195),(19.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.555),(17.975,12.725),(18.145,12.725),(18.145,12.555),(17.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.555),(18.335,12.725),(18.505,12.725),(18.505,12.555),(18.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.555),(18.695,12.725),(18.865,12.725),(18.865,12.555),(18.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.555),(19.055,12.725),(19.225,12.725),(19.225,12.555),(19.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.915),(17.975,13.085),(18.145,13.085),(18.145,12.915),(17.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.915),(18.335,13.085),(18.505,13.085),(18.505,12.915),(18.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.915),(18.695,13.085),(18.865,13.085),(18.865,12.915),(18.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.915),(19.055,13.085),(19.225,13.085),(19.225,12.915),(19.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.275),(17.975,13.445),(18.145,13.445),(18.145,13.275),(17.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.275),(18.335,13.445),(18.505,13.445),(18.505,13.275),(18.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.275),(18.695,13.445),(18.865,13.445),(18.865,13.275),(18.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.275),(19.055,13.445),(19.225,13.445),(19.225,13.275),(19.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.635),(17.975,13.805),(18.145,13.805),(18.145,13.635),(17.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.635),(18.335,13.805),(18.505,13.805),(18.505,13.635),(18.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.635),(18.695,13.805),(18.865,13.805),(18.865,13.635),(18.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.635),(19.055,13.805),(19.225,13.805),(19.225,13.635),(19.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.995),(17.975,14.165),(18.145,14.165),(18.145,13.995),(17.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.995),(18.335,14.165),(18.505,14.165),(18.505,13.995),(18.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.995),(18.695,14.165),(18.865,14.165),(18.865,13.995),(18.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.995),(19.055,14.165),(19.225,14.165),(19.225,13.995),(19.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.355),(17.975,14.525),(18.145,14.525),(18.145,14.355),(17.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.355),(18.335,14.525),(18.505,14.525),(18.505,14.355),(18.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.355),(18.695,14.525),(18.865,14.525),(18.865,14.355),(18.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.355),(19.055,14.525),(19.225,14.525),(19.225,14.355),(19.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.715),(17.975,14.885),(18.145,14.885),(18.145,14.715),(17.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.715),(18.335,14.885),(18.505,14.885),(18.505,14.715),(18.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.715),(18.695,14.885),(18.865,14.885),(18.865,14.715),(18.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.715),(19.055,14.885),(19.225,14.885),(19.225,14.715),(19.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.075),(17.975,15.245),(18.145,15.245),(18.145,15.075),(17.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.075),(18.335,15.245),(18.505,15.245),(18.505,15.075),(18.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.075),(18.695,15.245),(18.865,15.245),(18.865,15.075),(18.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.075),(19.055,15.245),(19.225,15.245),(19.225,15.075),(19.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.435),(17.975,15.605),(18.145,15.605),(18.145,15.435),(17.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.435),(18.335,15.605),(18.505,15.605),(18.505,15.435),(18.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.435),(18.695,15.605),(18.865,15.605),(18.865,15.435),(18.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.435),(19.055,15.605),(19.225,15.605),(19.225,15.435),(19.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.795),(17.975,15.965),(18.145,15.965),(18.145,15.795),(17.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.795),(18.335,15.965),(18.505,15.965),(18.505,15.795),(18.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.795),(18.695,15.965),(18.865,15.965),(18.865,15.795),(18.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.795),(19.055,15.965),(19.225,15.965),(19.225,15.795),(19.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.155),(17.975,16.325),(18.145,16.325),(18.145,16.155),(17.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.155),(18.335,16.325),(18.505,16.325),(18.505,16.155),(18.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.155),(18.695,16.325),(18.865,16.325),(18.865,16.155),(18.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.155),(19.055,16.325),(19.225,16.325),(19.225,16.155),(19.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.515),(17.975,16.685),(18.145,16.685),(18.145,16.515),(17.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.515),(18.335,16.685),(18.505,16.685),(18.505,16.515),(18.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.515),(18.695,16.685),(18.865,16.685),(18.865,16.515),(18.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.515),(19.055,16.685),(19.225,16.685),(19.225,16.515),(19.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.875),(17.975,17.045),(18.145,17.045),(18.145,16.875),(17.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.875),(18.335,17.045),(18.505,17.045),(18.505,16.875),(18.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.875),(18.695,17.045),(18.865,17.045),(18.865,16.875),(18.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.875),(19.055,17.045),(19.225,17.045),(19.225,16.875),(19.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.235),(17.975,17.405),(18.145,17.405),(18.145,17.235),(17.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.235),(18.335,17.405),(18.505,17.405),(18.505,17.235),(18.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.235),(18.695,17.405),(18.865,17.405),(18.865,17.235),(18.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.235),(19.055,17.405),(19.225,17.405),(19.225,17.235),(19.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.595),(17.975,17.765),(18.145,17.765),(18.145,17.595),(17.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.595),(18.335,17.765),(18.505,17.765),(18.505,17.595),(18.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.595),(18.695,17.765),(18.865,17.765),(18.865,17.595),(18.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.595),(19.055,17.765),(19.225,17.765),(19.225,17.595),(19.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.955),(17.975,18.125),(18.145,18.125),(18.145,17.955),(17.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.955),(18.335,18.125),(18.505,18.125),(18.505,17.955),(18.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.955),(18.695,18.125),(18.865,18.125),(18.865,17.955),(18.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.955),(19.055,18.125),(19.225,18.125),(19.225,17.955),(19.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.315),(17.975,18.485),(18.145,18.485),(18.145,18.315),(17.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.315),(18.335,18.485),(18.505,18.485),(18.505,18.315),(18.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.315),(18.695,18.485),(18.865,18.485),(18.865,18.315),(18.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.315),(19.055,18.485),(19.225,18.485),(19.225,18.315),(19.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.675),(17.975,18.845),(18.145,18.845),(18.145,18.675),(17.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.675),(18.335,18.845),(18.505,18.845),(18.505,18.675),(18.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.675),(18.695,18.845),(18.865,18.845),(18.865,18.675),(18.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.675),(19.055,18.845),(19.225,18.845),(19.225,18.675),(19.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.035),(17.975,19.205),(18.145,19.205),(18.145,19.035),(17.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.035),(18.335,19.205),(18.505,19.205),(18.505,19.035),(18.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.035),(18.695,19.205),(18.865,19.205),(18.865,19.035),(18.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.035),(19.055,19.205),(19.225,19.205),(19.225,19.035),(19.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.395),(17.975,19.565),(18.145,19.565),(18.145,19.395),(17.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.395),(18.335,19.565),(18.505,19.565),(18.505,19.395),(18.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.395),(18.695,19.565),(18.865,19.565),(18.865,19.395),(18.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.395),(19.055,19.565),(19.225,19.565),(19.225,19.395),(19.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.755),(17.975,19.925),(18.145,19.925),(18.145,19.755),(17.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.755),(18.335,19.925),(18.505,19.925),(18.505,19.755),(18.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.755),(18.695,19.925),(18.865,19.925),(18.865,19.755),(18.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.755),(19.055,19.925),(19.225,19.925),(19.225,19.755),(19.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,20.115),(17.975,20.285),(18.145,20.285),(18.145,20.115),(17.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,20.115),(18.335,20.285),(18.505,20.285),(18.505,20.115),(18.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,20.115),(18.695,20.285),(18.865,20.285),(18.865,20.115),(18.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,20.115),(19.055,20.285),(19.225,20.285),(19.225,20.115),(19.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,20.475),(17.975,20.645),(18.145,20.645),(18.145,20.475),(17.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,20.475),(18.335,20.645),(18.505,20.645),(18.505,20.475),(18.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,20.475),(18.695,20.645),(18.865,20.645),(18.865,20.475),(18.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,20.475),(19.055,20.645),(19.225,20.645),(19.225,20.475),(19.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,20.835),(17.975,21.005),(18.145,21.005),(18.145,20.835),(17.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,20.835),(18.335,21.005),(18.505,21.005),(18.505,20.835),(18.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,20.835),(18.695,21.005),(18.865,21.005),(18.865,20.835),(18.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,20.835),(19.055,21.005),(19.225,21.005),(19.225,20.835),(19.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,21.195),(17.975,21.365),(18.145,21.365),(18.145,21.195),(17.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,21.195),(18.335,21.365),(18.505,21.365),(18.505,21.195),(18.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,21.195),(18.695,21.365),(18.865,21.365),(18.865,21.195),(18.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,21.195),(19.055,21.365),(19.225,21.365),(19.225,21.195),(19.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,21.555),(17.975,21.725),(18.145,21.725),(18.145,21.555),(17.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,21.555),(18.335,21.725),(18.505,21.725),(18.505,21.555),(18.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,21.555),(18.695,21.725),(18.865,21.725),(18.865,21.555),(18.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,21.555),(19.055,21.725),(19.225,21.725),(19.225,21.555),(19.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,21.915),(17.975,22.085),(18.145,22.085),(18.145,21.915),(17.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,21.915),(18.335,22.085),(18.505,22.085),(18.505,21.915),(18.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,21.915),(18.695,22.085),(18.865,22.085),(18.865,21.915),(18.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,21.915),(19.055,22.085),(19.225,22.085),(19.225,21.915),(19.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.275),(17.975,22.445),(18.145,22.445),(18.145,22.275),(17.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.275),(18.335,22.445),(18.505,22.445),(18.505,22.275),(18.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.275),(18.695,22.445),(18.865,22.445),(18.865,22.275),(18.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.275),(19.055,22.445),(19.225,22.445),(19.225,22.275),(19.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.635),(17.975,22.805),(18.145,22.805),(18.145,22.635),(17.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.635),(18.335,22.805),(18.505,22.805),(18.505,22.635),(18.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.635),(18.695,22.805),(18.865,22.805),(18.865,22.635),(18.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.635),(19.055,22.805),(19.225,22.805),(19.225,22.635),(19.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.995),(17.975,23.165),(18.145,23.165),(18.145,22.995),(17.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.995),(18.335,23.165),(18.505,23.165),(18.505,22.995),(18.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.995),(18.695,23.165),(18.865,23.165),(18.865,22.995),(18.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.995),(19.055,23.165),(19.225,23.165),(19.225,22.995),(19.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,23.355),(17.975,23.525),(18.145,23.525),(18.145,23.355),(17.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,23.355),(18.335,23.525),(18.505,23.525),(18.505,23.355),(18.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,23.355),(18.695,23.525),(18.865,23.525),(18.865,23.355),(18.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,23.355),(19.055,23.525),(19.225,23.525),(19.225,23.355),(19.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,23.715),(17.975,23.885),(18.145,23.885),(18.145,23.715),(17.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,23.715),(18.335,23.885),(18.505,23.885),(18.505,23.715),(18.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,23.715),(18.695,23.885),(18.865,23.885),(18.865,23.715),(18.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,23.715),(19.055,23.885),(19.225,23.885),(19.225,23.715),(19.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,24.075),(17.975,24.245),(18.145,24.245),(18.145,24.075),(17.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,24.075),(18.335,24.245),(18.505,24.245),(18.505,24.075),(18.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,24.075),(18.695,24.245),(18.865,24.245),(18.865,24.075),(18.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,24.075),(19.055,24.245),(19.225,24.245),(19.225,24.075),(19.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,24.435),(17.975,24.605),(18.145,24.605),(18.145,24.435),(17.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,24.435),(18.335,24.605),(18.505,24.605),(18.505,24.435),(18.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,24.435),(18.695,24.605),(18.865,24.605),(18.865,24.435),(18.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,24.435),(19.055,24.605),(19.225,24.605),(19.225,24.435),(19.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,24.795),(17.975,24.965),(18.145,24.965),(18.145,24.795),(17.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,24.795),(18.335,24.965),(18.505,24.965),(18.505,24.795),(18.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,24.795),(18.695,24.965),(18.865,24.965),(18.865,24.795),(18.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,24.795),(19.055,24.965),(19.225,24.965),(19.225,24.795),(19.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,25.155),(17.975,25.325),(18.145,25.325),(18.145,25.155),(17.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,25.155),(18.335,25.325),(18.505,25.325),(18.505,25.155),(18.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,25.155),(18.695,25.325),(18.865,25.325),(18.865,25.155),(18.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,25.155),(19.055,25.325),(19.225,25.325),(19.225,25.155),(19.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,25.515),(17.975,25.685),(18.145,25.685),(18.145,25.515),(17.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,25.515),(18.335,25.685),(18.505,25.685),(18.505,25.515),(18.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,25.515),(18.695,25.685),(18.865,25.685),(18.865,25.515),(18.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,25.515),(19.055,25.685),(19.225,25.685),(19.225,25.515),(19.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,25.875),(17.975,26.045),(18.145,26.045),(18.145,25.875),(17.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,25.875),(18.335,26.045),(18.505,26.045),(18.505,25.875),(18.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,25.875),(18.695,26.045),(18.865,26.045),(18.865,25.875),(18.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,25.875),(19.055,26.045),(19.225,26.045),(19.225,25.875),(19.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,26.235),(17.975,26.405),(18.145,26.405),(18.145,26.235),(17.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,26.235),(18.335,26.405),(18.505,26.405),(18.505,26.235),(18.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,26.235),(18.695,26.405),(18.865,26.405),(18.865,26.235),(18.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,26.235),(19.055,26.405),(19.225,26.405),(19.225,26.235),(19.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,26.595),(17.975,26.765),(18.145,26.765),(18.145,26.595),(17.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,26.595),(18.335,26.765),(18.505,26.765),(18.505,26.595),(18.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,26.595),(18.695,26.765),(18.865,26.765),(18.865,26.595),(18.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,26.595),(19.055,26.765),(19.225,26.765),(19.225,26.595),(19.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,26.955),(17.975,27.125),(18.145,27.125),(18.145,26.955),(17.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,26.955),(18.335,27.125),(18.505,27.125),(18.505,26.955),(18.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,26.955),(18.695,27.125),(18.865,27.125),(18.865,26.955),(18.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,26.955),(19.055,27.125),(19.225,27.125),(19.225,26.955),(19.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,27.315),(17.975,27.485),(18.145,27.485),(18.145,27.315),(17.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,27.315),(18.335,27.485),(18.505,27.485),(18.505,27.315),(18.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,27.315),(18.695,27.485),(18.865,27.485),(18.865,27.315),(18.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,27.315),(19.055,27.485),(19.225,27.485),(19.225,27.315),(19.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,27.675),(17.975,27.845),(18.145,27.845),(18.145,27.675),(17.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,27.675),(18.335,27.845),(18.505,27.845),(18.505,27.675),(18.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,27.675),(18.695,27.845),(18.865,27.845),(18.865,27.675),(18.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,27.675),(19.055,27.845),(19.225,27.845),(19.225,27.675),(19.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,28.035),(17.975,28.205),(18.145,28.205),(18.145,28.035),(17.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,28.035),(18.335,28.205),(18.505,28.205),(18.505,28.035),(18.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,28.035),(18.695,28.205),(18.865,28.205),(18.865,28.035),(18.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,28.035),(19.055,28.205),(19.225,28.205),(19.225,28.035),(19.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,28.395),(17.975,28.565),(18.145,28.565),(18.145,28.395),(17.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,28.395),(18.335,28.565),(18.505,28.565),(18.505,28.395),(18.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,28.395),(18.695,28.565),(18.865,28.565),(18.865,28.395),(18.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,28.395),(19.055,28.565),(19.225,28.565),(19.225,28.395),(19.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,28.755),(17.975,28.925),(18.145,28.925),(18.145,28.755),(17.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,28.755),(18.335,28.925),(18.505,28.925),(18.505,28.755),(18.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,28.755),(18.695,28.925),(18.865,28.925),(18.865,28.755),(18.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,28.755),(19.055,28.925),(19.225,28.925),(19.225,28.755),(19.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,29.115),(17.975,29.285),(18.145,29.285),(18.145,29.115),(17.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,29.115),(18.335,29.285),(18.505,29.285),(18.505,29.115),(18.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,29.115),(18.695,29.285),(18.865,29.285),(18.865,29.115),(18.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,29.115),(19.055,29.285),(19.225,29.285),(19.225,29.115),(19.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,29.475),(17.975,29.645),(18.145,29.645),(18.145,29.475),(17.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,29.475),(18.335,29.645),(18.505,29.645),(18.505,29.475),(18.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,29.475),(18.695,29.645),(18.865,29.645),(18.865,29.475),(18.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,29.475),(19.055,29.645),(19.225,29.645),(19.225,29.475),(19.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,29.835),(17.975,30.005),(18.145,30.005),(18.145,29.835),(17.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,29.835),(18.335,30.005),(18.505,30.005),(18.505,29.835),(18.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,29.835),(18.695,30.005),(18.865,30.005),(18.865,29.835),(18.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,29.835),(19.055,30.005),(19.225,30.005),(19.225,29.835),(19.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,30.195),(17.975,30.365),(18.145,30.365),(18.145,30.195),(17.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,30.195),(18.335,30.365),(18.505,30.365),(18.505,30.195),(18.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,30.195),(18.695,30.365),(18.865,30.365),(18.865,30.195),(18.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,30.195),(19.055,30.365),(19.225,30.365),(19.225,30.195),(19.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,30.555),(17.975,30.725),(18.145,30.725),(18.145,30.555),(17.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,30.555),(18.335,30.725),(18.505,30.725),(18.505,30.555),(18.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,30.555),(18.695,30.725),(18.865,30.725),(18.865,30.555),(18.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,30.555),(19.055,30.725),(19.225,30.725),(19.225,30.555),(19.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,30.915),(17.975,31.085),(18.145,31.085),(18.145,30.915),(17.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,30.915),(18.335,31.085),(18.505,31.085),(18.505,30.915),(18.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,30.915),(18.695,31.085),(18.865,31.085),(18.865,30.915),(18.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,30.915),(19.055,31.085),(19.225,31.085),(19.225,30.915),(19.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,31.275),(17.975,31.445),(18.145,31.445),(18.145,31.275),(17.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,31.275),(18.335,31.445),(18.505,31.445),(18.505,31.275),(18.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,31.275),(18.695,31.445),(18.865,31.445),(18.865,31.275),(18.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,31.275),(19.055,31.445),(19.225,31.445),(19.225,31.275),(19.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,31.635),(17.975,31.805),(18.145,31.805),(18.145,31.635),(17.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,31.635),(18.335,31.805),(18.505,31.805),(18.505,31.635),(18.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,31.635),(18.695,31.805),(18.865,31.805),(18.865,31.635),(18.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,31.635),(19.055,31.805),(19.225,31.805),(19.225,31.635),(19.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,31.995),(17.975,32.165),(18.145,32.165),(18.145,31.995),(17.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,31.995),(18.335,32.165),(18.505,32.165),(18.505,31.995),(18.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,31.995),(18.695,32.165),(18.865,32.165),(18.865,31.995),(18.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,31.995),(19.055,32.165),(19.225,32.165),(19.225,31.995),(19.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,32.355),(17.975,32.525),(18.145,32.525),(18.145,32.355),(17.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,32.355),(18.335,32.525),(18.505,32.525),(18.505,32.355),(18.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,32.355),(18.695,32.525),(18.865,32.525),(18.865,32.355),(18.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,32.355),(19.055,32.525),(19.225,32.525),(19.225,32.355),(19.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,32.715),(17.975,32.885),(18.145,32.885),(18.145,32.715),(17.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,32.715),(18.335,32.885),(18.505,32.885),(18.505,32.715),(18.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,32.715),(18.695,32.885),(18.865,32.885),(18.865,32.715),(18.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,32.715),(19.055,32.885),(19.225,32.885),(19.225,32.715),(19.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,33.075),(17.975,33.245),(18.145,33.245),(18.145,33.075),(17.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,33.075),(18.335,33.245),(18.505,33.245),(18.505,33.075),(18.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,33.075),(18.695,33.245),(18.865,33.245),(18.865,33.075),(18.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,33.075),(19.055,33.245),(19.225,33.245),(19.225,33.075),(19.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,33.435),(17.975,33.605),(18.145,33.605),(18.145,33.435),(17.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,33.435),(18.335,33.605),(18.505,33.605),(18.505,33.435),(18.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,33.435),(18.695,33.605),(18.865,33.605),(18.865,33.435),(18.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,33.435),(19.055,33.605),(19.225,33.605),(19.225,33.435),(19.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,33.795),(17.975,33.965),(18.145,33.965),(18.145,33.795),(17.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,33.795),(18.335,33.965),(18.505,33.965),(18.505,33.795),(18.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,33.795),(18.695,33.965),(18.865,33.965),(18.865,33.795),(18.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,33.795),(19.055,33.965),(19.225,33.965),(19.225,33.795),(19.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,34.155),(17.975,34.325),(18.145,34.325),(18.145,34.155),(17.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,34.155),(18.335,34.325),(18.505,34.325),(18.505,34.155),(18.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,34.155),(18.695,34.325),(18.865,34.325),(18.865,34.155),(18.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,34.155),(19.055,34.325),(19.225,34.325),(19.225,34.155),(19.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,34.515),(17.975,34.685),(18.145,34.685),(18.145,34.515),(17.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,34.515),(18.335,34.685),(18.505,34.685),(18.505,34.515),(18.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,34.515),(18.695,34.685),(18.865,34.685),(18.865,34.515),(18.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,34.515),(19.055,34.685),(19.225,34.685),(19.225,34.515),(19.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,34.875),(17.975,35.045),(18.145,35.045),(18.145,34.875),(17.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,34.875),(18.335,35.045),(18.505,35.045),(18.505,34.875),(18.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,34.875),(18.695,35.045),(18.865,35.045),(18.865,34.875),(18.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,34.875),(19.055,35.045),(19.225,35.045),(19.225,34.875),(19.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,35.235),(17.975,35.405),(18.145,35.405),(18.145,35.235),(17.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,35.235),(18.335,35.405),(18.505,35.405),(18.505,35.235),(18.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,35.235),(18.695,35.405),(18.865,35.405),(18.865,35.235),(18.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,35.235),(19.055,35.405),(19.225,35.405),(19.225,35.235),(19.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,35.595),(17.975,35.765),(18.145,35.765),(18.145,35.595),(17.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,35.595),(18.335,35.765),(18.505,35.765),(18.505,35.595),(18.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,35.595),(18.695,35.765),(18.865,35.765),(18.865,35.595),(18.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,35.595),(19.055,35.765),(19.225,35.765),(19.225,35.595),(19.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,35.955),(17.975,36.125),(18.145,36.125),(18.145,35.955),(17.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,35.955),(18.335,36.125),(18.505,36.125),(18.505,35.955),(18.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,35.955),(18.695,36.125),(18.865,36.125),(18.865,35.955),(18.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,35.955),(19.055,36.125),(19.225,36.125),(19.225,35.955),(19.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,36.315),(17.975,36.485),(18.145,36.485),(18.145,36.315),(17.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,36.315),(18.335,36.485),(18.505,36.485),(18.505,36.315),(18.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,36.315),(18.695,36.485),(18.865,36.485),(18.865,36.315),(18.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,36.315),(19.055,36.485),(19.225,36.485),(19.225,36.315),(19.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,36.675),(17.975,36.845),(18.145,36.845),(18.145,36.675),(17.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,36.675),(18.335,36.845),(18.505,36.845),(18.505,36.675),(18.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,36.675),(18.695,36.845),(18.865,36.845),(18.865,36.675),(18.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,36.675),(19.055,36.845),(19.225,36.845),(19.225,36.675),(19.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,37.035),(17.975,37.205),(18.145,37.205),(18.145,37.035),(17.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,37.035),(18.335,37.205),(18.505,37.205),(18.505,37.035),(18.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,37.035),(18.695,37.205),(18.865,37.205),(18.865,37.035),(18.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,37.035),(19.055,37.205),(19.225,37.205),(19.225,37.035),(19.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,37.395),(17.975,37.565),(18.145,37.565),(18.145,37.395),(17.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,37.395),(18.335,37.565),(18.505,37.565),(18.505,37.395),(18.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,37.395),(18.695,37.565),(18.865,37.565),(18.865,37.395),(18.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,37.395),(19.055,37.565),(19.225,37.565),(19.225,37.395),(19.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,37.755),(17.975,37.925),(18.145,37.925),(18.145,37.755),(17.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,37.755),(18.335,37.925),(18.505,37.925),(18.505,37.755),(18.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,37.755),(18.695,37.925),(18.865,37.925),(18.865,37.755),(18.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,37.755),(19.055,37.925),(19.225,37.925),(19.225,37.755),(19.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,38.115),(17.975,38.285),(18.145,38.285),(18.145,38.115),(17.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,38.115),(18.335,38.285),(18.505,38.285),(18.505,38.115),(18.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,38.115),(18.695,38.285),(18.865,38.285),(18.865,38.115),(18.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,38.115),(19.055,38.285),(19.225,38.285),(19.225,38.115),(19.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,38.475),(17.975,38.645),(18.145,38.645),(18.145,38.475),(17.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,38.475),(18.335,38.645),(18.505,38.645),(18.505,38.475),(18.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,38.475),(18.695,38.645),(18.865,38.645),(18.865,38.475),(18.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,38.475),(19.055,38.645),(19.225,38.645),(19.225,38.475),(19.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,38.835),(17.975,39.005),(18.145,39.005),(18.145,38.835),(17.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,38.835),(18.335,39.005),(18.505,39.005),(18.505,38.835),(18.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,38.835),(18.695,39.005),(18.865,39.005),(18.865,38.835),(18.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,38.835),(19.055,39.005),(19.225,39.005),(19.225,38.835),(19.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,39.195),(17.975,39.365),(18.145,39.365),(18.145,39.195),(17.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,39.195),(18.335,39.365),(18.505,39.365),(18.505,39.195),(18.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,39.195),(18.695,39.365),(18.865,39.365),(18.865,39.195),(18.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,39.195),(19.055,39.365),(19.225,39.365),(19.225,39.195),(19.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,39.555),(17.975,39.725),(18.145,39.725),(18.145,39.555),(17.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,39.555),(18.335,39.725),(18.505,39.725),(18.505,39.555),(18.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,39.555),(18.695,39.725),(18.865,39.725),(18.865,39.555),(18.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,39.555),(19.055,39.725),(19.225,39.725),(19.225,39.555),(19.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,39.915),(17.975,40.085),(18.145,40.085),(18.145,39.915),(17.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,39.915),(18.335,40.085),(18.505,40.085),(18.505,39.915),(18.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,39.915),(18.695,40.085),(18.865,40.085),(18.865,39.915),(18.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,39.915),(19.055,40.085),(19.225,40.085),(19.225,39.915),(19.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,40.275),(17.975,40.445),(18.145,40.445),(18.145,40.275),(17.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,40.275),(18.335,40.445),(18.505,40.445),(18.505,40.275),(18.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,40.275),(18.695,40.445),(18.865,40.445),(18.865,40.275),(18.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,40.275),(19.055,40.445),(19.225,40.445),(19.225,40.275),(19.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,40.635),(17.975,40.805),(18.145,40.805),(18.145,40.635),(17.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,40.635),(18.335,40.805),(18.505,40.805),(18.505,40.635),(18.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,40.635),(18.695,40.805),(18.865,40.805),(18.865,40.635),(18.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,40.635),(19.055,40.805),(19.225,40.805),(19.225,40.635),(19.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,2.835),(27.575,3.005),(27.745,3.005),(27.745,2.835),(27.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,2.835),(27.935,3.005),(28.105,3.005),(28.105,2.835),(27.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,2.835),(28.295,3.005),(28.465,3.005),(28.465,2.835),(28.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,2.835),(28.655,3.005),(28.825,3.005),(28.825,2.835),(28.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.195),(27.575,3.365),(27.745,3.365),(27.745,3.195),(27.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.195),(27.935,3.365),(28.105,3.365),(28.105,3.195),(27.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.195),(28.295,3.365),(28.465,3.365),(28.465,3.195),(28.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.195),(28.655,3.365),(28.825,3.365),(28.825,3.195),(28.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.555),(27.575,3.725),(27.745,3.725),(27.745,3.555),(27.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.555),(27.935,3.725),(28.105,3.725),(28.105,3.555),(27.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.555),(28.295,3.725),(28.465,3.725),(28.465,3.555),(28.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.555),(28.655,3.725),(28.825,3.725),(28.825,3.555),(28.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.915),(27.575,4.085),(27.745,4.085),(27.745,3.915),(27.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.915),(27.935,4.085),(28.105,4.085),(28.105,3.915),(27.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.915),(28.295,4.085),(28.465,4.085),(28.465,3.915),(28.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.915),(28.655,4.085),(28.825,4.085),(28.825,3.915),(28.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.275),(27.575,4.445),(27.745,4.445),(27.745,4.275),(27.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.275),(27.935,4.445),(28.105,4.445),(28.105,4.275),(27.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.275),(28.295,4.445),(28.465,4.445),(28.465,4.275),(28.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.275),(28.655,4.445),(28.825,4.445),(28.825,4.275),(28.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.635),(27.575,4.805),(27.745,4.805),(27.745,4.635),(27.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.635),(27.935,4.805),(28.105,4.805),(28.105,4.635),(27.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.635),(28.295,4.805),(28.465,4.805),(28.465,4.635),(28.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.635),(28.655,4.805),(28.825,4.805),(28.825,4.635),(28.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.995),(27.575,5.165),(27.745,5.165),(27.745,4.995),(27.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.995),(27.935,5.165),(28.105,5.165),(28.105,4.995),(27.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.995),(28.295,5.165),(28.465,5.165),(28.465,4.995),(28.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.995),(28.655,5.165),(28.825,5.165),(28.825,4.995),(28.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.355),(27.575,5.525),(27.745,5.525),(27.745,5.355),(27.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.355),(27.935,5.525),(28.105,5.525),(28.105,5.355),(27.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.355),(28.295,5.525),(28.465,5.525),(28.465,5.355),(28.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.355),(28.655,5.525),(28.825,5.525),(28.825,5.355),(28.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.715),(27.575,5.885),(27.745,5.885),(27.745,5.715),(27.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.715),(27.935,5.885),(28.105,5.885),(28.105,5.715),(27.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.715),(28.295,5.885),(28.465,5.885),(28.465,5.715),(28.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.715),(28.655,5.885),(28.825,5.885),(28.825,5.715),(28.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.075),(27.575,6.245),(27.745,6.245),(27.745,6.075),(27.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.075),(27.935,6.245),(28.105,6.245),(28.105,6.075),(27.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.075),(28.295,6.245),(28.465,6.245),(28.465,6.075),(28.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.075),(28.655,6.245),(28.825,6.245),(28.825,6.075),(28.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.435),(27.575,6.605),(27.745,6.605),(27.745,6.435),(27.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.435),(27.935,6.605),(28.105,6.605),(28.105,6.435),(27.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.435),(28.295,6.605),(28.465,6.605),(28.465,6.435),(28.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.435),(28.655,6.605),(28.825,6.605),(28.825,6.435),(28.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.795),(27.575,6.965),(27.745,6.965),(27.745,6.795),(27.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.795),(27.935,6.965),(28.105,6.965),(28.105,6.795),(27.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.795),(28.295,6.965),(28.465,6.965),(28.465,6.795),(28.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.795),(28.655,6.965),(28.825,6.965),(28.825,6.795),(28.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.155),(27.575,7.325),(27.745,7.325),(27.745,7.155),(27.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.155),(27.935,7.325),(28.105,7.325),(28.105,7.155),(27.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.155),(28.295,7.325),(28.465,7.325),(28.465,7.155),(28.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.155),(28.655,7.325),(28.825,7.325),(28.825,7.155),(28.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.515),(27.575,7.685),(27.745,7.685),(27.745,7.515),(27.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.515),(27.935,7.685),(28.105,7.685),(28.105,7.515),(27.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.515),(28.295,7.685),(28.465,7.685),(28.465,7.515),(28.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.515),(28.655,7.685),(28.825,7.685),(28.825,7.515),(28.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.875),(27.575,8.045),(27.745,8.045),(27.745,7.875),(27.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.875),(27.935,8.045),(28.105,8.045),(28.105,7.875),(27.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.875),(28.295,8.045),(28.465,8.045),(28.465,7.875),(28.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.875),(28.655,8.045),(28.825,8.045),(28.825,7.875),(28.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.235),(27.575,8.405),(27.745,8.405),(27.745,8.235),(27.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.235),(27.935,8.405),(28.105,8.405),(28.105,8.235),(27.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.235),(28.295,8.405),(28.465,8.405),(28.465,8.235),(28.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.235),(28.655,8.405),(28.825,8.405),(28.825,8.235),(28.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.595),(27.575,8.765),(27.745,8.765),(27.745,8.595),(27.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.595),(27.935,8.765),(28.105,8.765),(28.105,8.595),(27.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.595),(28.295,8.765),(28.465,8.765),(28.465,8.595),(28.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.595),(28.655,8.765),(28.825,8.765),(28.825,8.595),(28.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.955),(27.575,9.125),(27.745,9.125),(27.745,8.955),(27.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.955),(27.935,9.125),(28.105,9.125),(28.105,8.955),(27.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.955),(28.295,9.125),(28.465,9.125),(28.465,8.955),(28.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.955),(28.655,9.125),(28.825,9.125),(28.825,8.955),(28.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.315),(27.575,9.485),(27.745,9.485),(27.745,9.315),(27.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.315),(27.935,9.485),(28.105,9.485),(28.105,9.315),(27.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.315),(28.295,9.485),(28.465,9.485),(28.465,9.315),(28.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.315),(28.655,9.485),(28.825,9.485),(28.825,9.315),(28.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.675),(27.575,9.845),(27.745,9.845),(27.745,9.675),(27.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.675),(27.935,9.845),(28.105,9.845),(28.105,9.675),(27.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.675),(28.295,9.845),(28.465,9.845),(28.465,9.675),(28.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.675),(28.655,9.845),(28.825,9.845),(28.825,9.675),(28.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.035),(27.575,10.205),(27.745,10.205),(27.745,10.035),(27.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.035),(27.935,10.205),(28.105,10.205),(28.105,10.035),(27.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.035),(28.295,10.205),(28.465,10.205),(28.465,10.035),(28.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.035),(28.655,10.205),(28.825,10.205),(28.825,10.035),(28.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.395),(27.575,10.565),(27.745,10.565),(27.745,10.395),(27.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.395),(27.935,10.565),(28.105,10.565),(28.105,10.395),(27.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.395),(28.295,10.565),(28.465,10.565),(28.465,10.395),(28.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.395),(28.655,10.565),(28.825,10.565),(28.825,10.395),(28.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.755),(27.575,10.925),(27.745,10.925),(27.745,10.755),(27.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.755),(27.935,10.925),(28.105,10.925),(28.105,10.755),(27.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.755),(28.295,10.925),(28.465,10.925),(28.465,10.755),(28.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.755),(28.655,10.925),(28.825,10.925),(28.825,10.755),(28.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.115),(27.575,11.285),(27.745,11.285),(27.745,11.115),(27.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.115),(27.935,11.285),(28.105,11.285),(28.105,11.115),(27.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.115),(28.295,11.285),(28.465,11.285),(28.465,11.115),(28.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.115),(28.655,11.285),(28.825,11.285),(28.825,11.115),(28.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.475),(27.575,11.645),(27.745,11.645),(27.745,11.475),(27.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.475),(27.935,11.645),(28.105,11.645),(28.105,11.475),(27.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.475),(28.295,11.645),(28.465,11.645),(28.465,11.475),(28.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.475),(28.655,11.645),(28.825,11.645),(28.825,11.475),(28.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.835),(27.575,12.005),(27.745,12.005),(27.745,11.835),(27.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.835),(27.935,12.005),(28.105,12.005),(28.105,11.835),(27.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.835),(28.295,12.005),(28.465,12.005),(28.465,11.835),(28.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.835),(28.655,12.005),(28.825,12.005),(28.825,11.835),(28.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.195),(27.575,12.365),(27.745,12.365),(27.745,12.195),(27.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.195),(27.935,12.365),(28.105,12.365),(28.105,12.195),(27.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.195),(28.295,12.365),(28.465,12.365),(28.465,12.195),(28.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.195),(28.655,12.365),(28.825,12.365),(28.825,12.195),(28.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.555),(27.575,12.725),(27.745,12.725),(27.745,12.555),(27.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.555),(27.935,12.725),(28.105,12.725),(28.105,12.555),(27.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.555),(28.295,12.725),(28.465,12.725),(28.465,12.555),(28.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.555),(28.655,12.725),(28.825,12.725),(28.825,12.555),(28.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.915),(27.575,13.085),(27.745,13.085),(27.745,12.915),(27.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.915),(27.935,13.085),(28.105,13.085),(28.105,12.915),(27.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.915),(28.295,13.085),(28.465,13.085),(28.465,12.915),(28.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.915),(28.655,13.085),(28.825,13.085),(28.825,12.915),(28.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.275),(27.575,13.445),(27.745,13.445),(27.745,13.275),(27.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.275),(27.935,13.445),(28.105,13.445),(28.105,13.275),(27.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.275),(28.295,13.445),(28.465,13.445),(28.465,13.275),(28.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.275),(28.655,13.445),(28.825,13.445),(28.825,13.275),(28.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.635),(27.575,13.805),(27.745,13.805),(27.745,13.635),(27.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.635),(27.935,13.805),(28.105,13.805),(28.105,13.635),(27.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.635),(28.295,13.805),(28.465,13.805),(28.465,13.635),(28.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.635),(28.655,13.805),(28.825,13.805),(28.825,13.635),(28.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.995),(27.575,14.165),(27.745,14.165),(27.745,13.995),(27.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.995),(27.935,14.165),(28.105,14.165),(28.105,13.995),(27.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.995),(28.295,14.165),(28.465,14.165),(28.465,13.995),(28.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.995),(28.655,14.165),(28.825,14.165),(28.825,13.995),(28.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.355),(27.575,14.525),(27.745,14.525),(27.745,14.355),(27.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.355),(27.935,14.525),(28.105,14.525),(28.105,14.355),(27.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.355),(28.295,14.525),(28.465,14.525),(28.465,14.355),(28.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.355),(28.655,14.525),(28.825,14.525),(28.825,14.355),(28.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.715),(27.575,14.885),(27.745,14.885),(27.745,14.715),(27.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.715),(27.935,14.885),(28.105,14.885),(28.105,14.715),(27.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.715),(28.295,14.885),(28.465,14.885),(28.465,14.715),(28.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.715),(28.655,14.885),(28.825,14.885),(28.825,14.715),(28.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.075),(27.575,15.245),(27.745,15.245),(27.745,15.075),(27.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.075),(27.935,15.245),(28.105,15.245),(28.105,15.075),(27.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.075),(28.295,15.245),(28.465,15.245),(28.465,15.075),(28.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.075),(28.655,15.245),(28.825,15.245),(28.825,15.075),(28.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.435),(27.575,15.605),(27.745,15.605),(27.745,15.435),(27.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.435),(27.935,15.605),(28.105,15.605),(28.105,15.435),(27.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.435),(28.295,15.605),(28.465,15.605),(28.465,15.435),(28.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.435),(28.655,15.605),(28.825,15.605),(28.825,15.435),(28.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.795),(27.575,15.965),(27.745,15.965),(27.745,15.795),(27.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.795),(27.935,15.965),(28.105,15.965),(28.105,15.795),(27.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.795),(28.295,15.965),(28.465,15.965),(28.465,15.795),(28.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.795),(28.655,15.965),(28.825,15.965),(28.825,15.795),(28.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.155),(27.575,16.325),(27.745,16.325),(27.745,16.155),(27.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.155),(27.935,16.325),(28.105,16.325),(28.105,16.155),(27.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.155),(28.295,16.325),(28.465,16.325),(28.465,16.155),(28.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.155),(28.655,16.325),(28.825,16.325),(28.825,16.155),(28.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.515),(27.575,16.685),(27.745,16.685),(27.745,16.515),(27.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.515),(27.935,16.685),(28.105,16.685),(28.105,16.515),(27.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.515),(28.295,16.685),(28.465,16.685),(28.465,16.515),(28.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.515),(28.655,16.685),(28.825,16.685),(28.825,16.515),(28.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.875),(27.575,17.045),(27.745,17.045),(27.745,16.875),(27.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.875),(27.935,17.045),(28.105,17.045),(28.105,16.875),(27.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.875),(28.295,17.045),(28.465,17.045),(28.465,16.875),(28.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.875),(28.655,17.045),(28.825,17.045),(28.825,16.875),(28.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.235),(27.575,17.405),(27.745,17.405),(27.745,17.235),(27.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.235),(27.935,17.405),(28.105,17.405),(28.105,17.235),(27.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.235),(28.295,17.405),(28.465,17.405),(28.465,17.235),(28.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.235),(28.655,17.405),(28.825,17.405),(28.825,17.235),(28.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.595),(27.575,17.765),(27.745,17.765),(27.745,17.595),(27.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.595),(27.935,17.765),(28.105,17.765),(28.105,17.595),(27.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.595),(28.295,17.765),(28.465,17.765),(28.465,17.595),(28.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.595),(28.655,17.765),(28.825,17.765),(28.825,17.595),(28.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.955),(27.575,18.125),(27.745,18.125),(27.745,17.955),(27.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.955),(27.935,18.125),(28.105,18.125),(28.105,17.955),(27.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.955),(28.295,18.125),(28.465,18.125),(28.465,17.955),(28.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.955),(28.655,18.125),(28.825,18.125),(28.825,17.955),(28.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.315),(27.575,18.485),(27.745,18.485),(27.745,18.315),(27.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.315),(27.935,18.485),(28.105,18.485),(28.105,18.315),(27.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.315),(28.295,18.485),(28.465,18.485),(28.465,18.315),(28.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.315),(28.655,18.485),(28.825,18.485),(28.825,18.315),(28.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.675),(27.575,18.845),(27.745,18.845),(27.745,18.675),(27.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.675),(27.935,18.845),(28.105,18.845),(28.105,18.675),(27.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.675),(28.295,18.845),(28.465,18.845),(28.465,18.675),(28.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.675),(28.655,18.845),(28.825,18.845),(28.825,18.675),(28.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.035),(27.575,19.205),(27.745,19.205),(27.745,19.035),(27.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.035),(27.935,19.205),(28.105,19.205),(28.105,19.035),(27.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.035),(28.295,19.205),(28.465,19.205),(28.465,19.035),(28.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.035),(28.655,19.205),(28.825,19.205),(28.825,19.035),(28.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.395),(27.575,19.565),(27.745,19.565),(27.745,19.395),(27.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.395),(27.935,19.565),(28.105,19.565),(28.105,19.395),(27.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.395),(28.295,19.565),(28.465,19.565),(28.465,19.395),(28.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.395),(28.655,19.565),(28.825,19.565),(28.825,19.395),(28.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.755),(27.575,19.925),(27.745,19.925),(27.745,19.755),(27.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.755),(27.935,19.925),(28.105,19.925),(28.105,19.755),(27.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.755),(28.295,19.925),(28.465,19.925),(28.465,19.755),(28.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.755),(28.655,19.925),(28.825,19.925),(28.825,19.755),(28.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,20.115),(27.575,20.285),(27.745,20.285),(27.745,20.115),(27.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,20.115),(27.935,20.285),(28.105,20.285),(28.105,20.115),(27.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,20.115),(28.295,20.285),(28.465,20.285),(28.465,20.115),(28.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,20.115),(28.655,20.285),(28.825,20.285),(28.825,20.115),(28.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,20.475),(27.575,20.645),(27.745,20.645),(27.745,20.475),(27.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,20.475),(27.935,20.645),(28.105,20.645),(28.105,20.475),(27.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,20.475),(28.295,20.645),(28.465,20.645),(28.465,20.475),(28.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,20.475),(28.655,20.645),(28.825,20.645),(28.825,20.475),(28.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,20.835),(27.575,21.005),(27.745,21.005),(27.745,20.835),(27.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,20.835),(27.935,21.005),(28.105,21.005),(28.105,20.835),(27.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,20.835),(28.295,21.005),(28.465,21.005),(28.465,20.835),(28.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,20.835),(28.655,21.005),(28.825,21.005),(28.825,20.835),(28.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,21.195),(27.575,21.365),(27.745,21.365),(27.745,21.195),(27.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,21.195),(27.935,21.365),(28.105,21.365),(28.105,21.195),(27.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,21.195),(28.295,21.365),(28.465,21.365),(28.465,21.195),(28.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,21.195),(28.655,21.365),(28.825,21.365),(28.825,21.195),(28.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,21.555),(27.575,21.725),(27.745,21.725),(27.745,21.555),(27.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,21.555),(27.935,21.725),(28.105,21.725),(28.105,21.555),(27.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,21.555),(28.295,21.725),(28.465,21.725),(28.465,21.555),(28.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,21.555),(28.655,21.725),(28.825,21.725),(28.825,21.555),(28.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,21.915),(27.575,22.085),(27.745,22.085),(27.745,21.915),(27.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,21.915),(27.935,22.085),(28.105,22.085),(28.105,21.915),(27.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,21.915),(28.295,22.085),(28.465,22.085),(28.465,21.915),(28.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,21.915),(28.655,22.085),(28.825,22.085),(28.825,21.915),(28.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.275),(27.575,22.445),(27.745,22.445),(27.745,22.275),(27.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.275),(27.935,22.445),(28.105,22.445),(28.105,22.275),(27.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.275),(28.295,22.445),(28.465,22.445),(28.465,22.275),(28.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.275),(28.655,22.445),(28.825,22.445),(28.825,22.275),(28.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.635),(27.575,22.805),(27.745,22.805),(27.745,22.635),(27.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.635),(27.935,22.805),(28.105,22.805),(28.105,22.635),(27.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.635),(28.295,22.805),(28.465,22.805),(28.465,22.635),(28.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.635),(28.655,22.805),(28.825,22.805),(28.825,22.635),(28.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.995),(27.575,23.165),(27.745,23.165),(27.745,22.995),(27.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.995),(27.935,23.165),(28.105,23.165),(28.105,22.995),(27.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.995),(28.295,23.165),(28.465,23.165),(28.465,22.995),(28.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.995),(28.655,23.165),(28.825,23.165),(28.825,22.995),(28.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,23.355),(27.575,23.525),(27.745,23.525),(27.745,23.355),(27.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,23.355),(27.935,23.525),(28.105,23.525),(28.105,23.355),(27.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,23.355),(28.295,23.525),(28.465,23.525),(28.465,23.355),(28.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,23.355),(28.655,23.525),(28.825,23.525),(28.825,23.355),(28.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,23.715),(27.575,23.885),(27.745,23.885),(27.745,23.715),(27.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,23.715),(27.935,23.885),(28.105,23.885),(28.105,23.715),(27.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,23.715),(28.295,23.885),(28.465,23.885),(28.465,23.715),(28.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,23.715),(28.655,23.885),(28.825,23.885),(28.825,23.715),(28.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,24.075),(27.575,24.245),(27.745,24.245),(27.745,24.075),(27.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,24.075),(27.935,24.245),(28.105,24.245),(28.105,24.075),(27.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,24.075),(28.295,24.245),(28.465,24.245),(28.465,24.075),(28.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,24.075),(28.655,24.245),(28.825,24.245),(28.825,24.075),(28.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,24.435),(27.575,24.605),(27.745,24.605),(27.745,24.435),(27.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,24.435),(27.935,24.605),(28.105,24.605),(28.105,24.435),(27.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,24.435),(28.295,24.605),(28.465,24.605),(28.465,24.435),(28.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,24.435),(28.655,24.605),(28.825,24.605),(28.825,24.435),(28.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,24.795),(27.575,24.965),(27.745,24.965),(27.745,24.795),(27.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,24.795),(27.935,24.965),(28.105,24.965),(28.105,24.795),(27.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,24.795),(28.295,24.965),(28.465,24.965),(28.465,24.795),(28.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,24.795),(28.655,24.965),(28.825,24.965),(28.825,24.795),(28.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,25.155),(27.575,25.325),(27.745,25.325),(27.745,25.155),(27.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,25.155),(27.935,25.325),(28.105,25.325),(28.105,25.155),(27.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,25.155),(28.295,25.325),(28.465,25.325),(28.465,25.155),(28.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,25.155),(28.655,25.325),(28.825,25.325),(28.825,25.155),(28.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,25.515),(27.575,25.685),(27.745,25.685),(27.745,25.515),(27.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,25.515),(27.935,25.685),(28.105,25.685),(28.105,25.515),(27.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,25.515),(28.295,25.685),(28.465,25.685),(28.465,25.515),(28.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,25.515),(28.655,25.685),(28.825,25.685),(28.825,25.515),(28.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,25.875),(27.575,26.045),(27.745,26.045),(27.745,25.875),(27.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,25.875),(27.935,26.045),(28.105,26.045),(28.105,25.875),(27.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,25.875),(28.295,26.045),(28.465,26.045),(28.465,25.875),(28.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,25.875),(28.655,26.045),(28.825,26.045),(28.825,25.875),(28.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,26.235),(27.575,26.405),(27.745,26.405),(27.745,26.235),(27.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,26.235),(27.935,26.405),(28.105,26.405),(28.105,26.235),(27.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,26.235),(28.295,26.405),(28.465,26.405),(28.465,26.235),(28.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,26.235),(28.655,26.405),(28.825,26.405),(28.825,26.235),(28.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,26.595),(27.575,26.765),(27.745,26.765),(27.745,26.595),(27.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,26.595),(27.935,26.765),(28.105,26.765),(28.105,26.595),(27.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,26.595),(28.295,26.765),(28.465,26.765),(28.465,26.595),(28.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,26.595),(28.655,26.765),(28.825,26.765),(28.825,26.595),(28.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,26.955),(27.575,27.125),(27.745,27.125),(27.745,26.955),(27.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,26.955),(27.935,27.125),(28.105,27.125),(28.105,26.955),(27.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,26.955),(28.295,27.125),(28.465,27.125),(28.465,26.955),(28.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,26.955),(28.655,27.125),(28.825,27.125),(28.825,26.955),(28.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,27.315),(27.575,27.485),(27.745,27.485),(27.745,27.315),(27.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,27.315),(27.935,27.485),(28.105,27.485),(28.105,27.315),(27.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,27.315),(28.295,27.485),(28.465,27.485),(28.465,27.315),(28.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,27.315),(28.655,27.485),(28.825,27.485),(28.825,27.315),(28.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,27.675),(27.575,27.845),(27.745,27.845),(27.745,27.675),(27.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,27.675),(27.935,27.845),(28.105,27.845),(28.105,27.675),(27.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,27.675),(28.295,27.845),(28.465,27.845),(28.465,27.675),(28.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,27.675),(28.655,27.845),(28.825,27.845),(28.825,27.675),(28.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,28.035),(27.575,28.205),(27.745,28.205),(27.745,28.035),(27.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,28.035),(27.935,28.205),(28.105,28.205),(28.105,28.035),(27.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,28.035),(28.295,28.205),(28.465,28.205),(28.465,28.035),(28.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,28.035),(28.655,28.205),(28.825,28.205),(28.825,28.035),(28.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,28.395),(27.575,28.565),(27.745,28.565),(27.745,28.395),(27.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,28.395),(27.935,28.565),(28.105,28.565),(28.105,28.395),(27.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,28.395),(28.295,28.565),(28.465,28.565),(28.465,28.395),(28.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,28.395),(28.655,28.565),(28.825,28.565),(28.825,28.395),(28.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,28.755),(27.575,28.925),(27.745,28.925),(27.745,28.755),(27.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,28.755),(27.935,28.925),(28.105,28.925),(28.105,28.755),(27.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,28.755),(28.295,28.925),(28.465,28.925),(28.465,28.755),(28.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,28.755),(28.655,28.925),(28.825,28.925),(28.825,28.755),(28.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,29.115),(27.575,29.285),(27.745,29.285),(27.745,29.115),(27.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,29.115),(27.935,29.285),(28.105,29.285),(28.105,29.115),(27.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,29.115),(28.295,29.285),(28.465,29.285),(28.465,29.115),(28.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,29.115),(28.655,29.285),(28.825,29.285),(28.825,29.115),(28.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,29.475),(27.575,29.645),(27.745,29.645),(27.745,29.475),(27.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,29.475),(27.935,29.645),(28.105,29.645),(28.105,29.475),(27.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,29.475),(28.295,29.645),(28.465,29.645),(28.465,29.475),(28.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,29.475),(28.655,29.645),(28.825,29.645),(28.825,29.475),(28.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,29.835),(27.575,30.005),(27.745,30.005),(27.745,29.835),(27.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,29.835),(27.935,30.005),(28.105,30.005),(28.105,29.835),(27.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,29.835),(28.295,30.005),(28.465,30.005),(28.465,29.835),(28.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,29.835),(28.655,30.005),(28.825,30.005),(28.825,29.835),(28.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,30.195),(27.575,30.365),(27.745,30.365),(27.745,30.195),(27.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,30.195),(27.935,30.365),(28.105,30.365),(28.105,30.195),(27.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,30.195),(28.295,30.365),(28.465,30.365),(28.465,30.195),(28.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,30.195),(28.655,30.365),(28.825,30.365),(28.825,30.195),(28.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,30.555),(27.575,30.725),(27.745,30.725),(27.745,30.555),(27.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,30.555),(27.935,30.725),(28.105,30.725),(28.105,30.555),(27.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,30.555),(28.295,30.725),(28.465,30.725),(28.465,30.555),(28.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,30.555),(28.655,30.725),(28.825,30.725),(28.825,30.555),(28.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,30.915),(27.575,31.085),(27.745,31.085),(27.745,30.915),(27.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,30.915),(27.935,31.085),(28.105,31.085),(28.105,30.915),(27.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,30.915),(28.295,31.085),(28.465,31.085),(28.465,30.915),(28.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,30.915),(28.655,31.085),(28.825,31.085),(28.825,30.915),(28.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,31.275),(27.575,31.445),(27.745,31.445),(27.745,31.275),(27.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,31.275),(27.935,31.445),(28.105,31.445),(28.105,31.275),(27.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,31.275),(28.295,31.445),(28.465,31.445),(28.465,31.275),(28.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,31.275),(28.655,31.445),(28.825,31.445),(28.825,31.275),(28.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,31.635),(27.575,31.805),(27.745,31.805),(27.745,31.635),(27.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,31.635),(27.935,31.805),(28.105,31.805),(28.105,31.635),(27.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,31.635),(28.295,31.805),(28.465,31.805),(28.465,31.635),(28.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,31.635),(28.655,31.805),(28.825,31.805),(28.825,31.635),(28.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,31.995),(27.575,32.165),(27.745,32.165),(27.745,31.995),(27.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,31.995),(27.935,32.165),(28.105,32.165),(28.105,31.995),(27.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,31.995),(28.295,32.165),(28.465,32.165),(28.465,31.995),(28.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,31.995),(28.655,32.165),(28.825,32.165),(28.825,31.995),(28.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,32.355),(27.575,32.525),(27.745,32.525),(27.745,32.355),(27.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,32.355),(27.935,32.525),(28.105,32.525),(28.105,32.355),(27.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,32.355),(28.295,32.525),(28.465,32.525),(28.465,32.355),(28.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,32.355),(28.655,32.525),(28.825,32.525),(28.825,32.355),(28.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,32.715),(27.575,32.885),(27.745,32.885),(27.745,32.715),(27.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,32.715),(27.935,32.885),(28.105,32.885),(28.105,32.715),(27.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,32.715),(28.295,32.885),(28.465,32.885),(28.465,32.715),(28.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,32.715),(28.655,32.885),(28.825,32.885),(28.825,32.715),(28.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,33.075),(27.575,33.245),(27.745,33.245),(27.745,33.075),(27.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,33.075),(27.935,33.245),(28.105,33.245),(28.105,33.075),(27.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,33.075),(28.295,33.245),(28.465,33.245),(28.465,33.075),(28.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,33.075),(28.655,33.245),(28.825,33.245),(28.825,33.075),(28.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,33.435),(27.575,33.605),(27.745,33.605),(27.745,33.435),(27.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,33.435),(27.935,33.605),(28.105,33.605),(28.105,33.435),(27.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,33.435),(28.295,33.605),(28.465,33.605),(28.465,33.435),(28.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,33.435),(28.655,33.605),(28.825,33.605),(28.825,33.435),(28.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,33.795),(27.575,33.965),(27.745,33.965),(27.745,33.795),(27.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,33.795),(27.935,33.965),(28.105,33.965),(28.105,33.795),(27.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,33.795),(28.295,33.965),(28.465,33.965),(28.465,33.795),(28.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,33.795),(28.655,33.965),(28.825,33.965),(28.825,33.795),(28.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,34.155),(27.575,34.325),(27.745,34.325),(27.745,34.155),(27.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,34.155),(27.935,34.325),(28.105,34.325),(28.105,34.155),(27.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,34.155),(28.295,34.325),(28.465,34.325),(28.465,34.155),(28.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,34.155),(28.655,34.325),(28.825,34.325),(28.825,34.155),(28.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,34.515),(27.575,34.685),(27.745,34.685),(27.745,34.515),(27.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,34.515),(27.935,34.685),(28.105,34.685),(28.105,34.515),(27.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,34.515),(28.295,34.685),(28.465,34.685),(28.465,34.515),(28.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,34.515),(28.655,34.685),(28.825,34.685),(28.825,34.515),(28.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,34.875),(27.575,35.045),(27.745,35.045),(27.745,34.875),(27.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,34.875),(27.935,35.045),(28.105,35.045),(28.105,34.875),(27.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,34.875),(28.295,35.045),(28.465,35.045),(28.465,34.875),(28.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,34.875),(28.655,35.045),(28.825,35.045),(28.825,34.875),(28.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,35.235),(27.575,35.405),(27.745,35.405),(27.745,35.235),(27.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,35.235),(27.935,35.405),(28.105,35.405),(28.105,35.235),(27.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,35.235),(28.295,35.405),(28.465,35.405),(28.465,35.235),(28.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,35.235),(28.655,35.405),(28.825,35.405),(28.825,35.235),(28.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,35.595),(27.575,35.765),(27.745,35.765),(27.745,35.595),(27.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,35.595),(27.935,35.765),(28.105,35.765),(28.105,35.595),(27.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,35.595),(28.295,35.765),(28.465,35.765),(28.465,35.595),(28.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,35.595),(28.655,35.765),(28.825,35.765),(28.825,35.595),(28.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,35.955),(27.575,36.125),(27.745,36.125),(27.745,35.955),(27.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,35.955),(27.935,36.125),(28.105,36.125),(28.105,35.955),(27.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,35.955),(28.295,36.125),(28.465,36.125),(28.465,35.955),(28.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,35.955),(28.655,36.125),(28.825,36.125),(28.825,35.955),(28.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,36.315),(27.575,36.485),(27.745,36.485),(27.745,36.315),(27.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,36.315),(27.935,36.485),(28.105,36.485),(28.105,36.315),(27.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,36.315),(28.295,36.485),(28.465,36.485),(28.465,36.315),(28.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,36.315),(28.655,36.485),(28.825,36.485),(28.825,36.315),(28.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,36.675),(27.575,36.845),(27.745,36.845),(27.745,36.675),(27.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,36.675),(27.935,36.845),(28.105,36.845),(28.105,36.675),(27.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,36.675),(28.295,36.845),(28.465,36.845),(28.465,36.675),(28.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,36.675),(28.655,36.845),(28.825,36.845),(28.825,36.675),(28.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,37.035),(27.575,37.205),(27.745,37.205),(27.745,37.035),(27.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,37.035),(27.935,37.205),(28.105,37.205),(28.105,37.035),(27.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,37.035),(28.295,37.205),(28.465,37.205),(28.465,37.035),(28.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,37.035),(28.655,37.205),(28.825,37.205),(28.825,37.035),(28.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,37.395),(27.575,37.565),(27.745,37.565),(27.745,37.395),(27.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,37.395),(27.935,37.565),(28.105,37.565),(28.105,37.395),(27.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,37.395),(28.295,37.565),(28.465,37.565),(28.465,37.395),(28.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,37.395),(28.655,37.565),(28.825,37.565),(28.825,37.395),(28.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,37.755),(27.575,37.925),(27.745,37.925),(27.745,37.755),(27.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,37.755),(27.935,37.925),(28.105,37.925),(28.105,37.755),(27.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,37.755),(28.295,37.925),(28.465,37.925),(28.465,37.755),(28.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,37.755),(28.655,37.925),(28.825,37.925),(28.825,37.755),(28.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,38.115),(27.575,38.285),(27.745,38.285),(27.745,38.115),(27.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,38.115),(27.935,38.285),(28.105,38.285),(28.105,38.115),(27.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,38.115),(28.295,38.285),(28.465,38.285),(28.465,38.115),(28.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,38.115),(28.655,38.285),(28.825,38.285),(28.825,38.115),(28.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,38.475),(27.575,38.645),(27.745,38.645),(27.745,38.475),(27.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,38.475),(27.935,38.645),(28.105,38.645),(28.105,38.475),(27.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,38.475),(28.295,38.645),(28.465,38.645),(28.465,38.475),(28.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,38.475),(28.655,38.645),(28.825,38.645),(28.825,38.475),(28.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,38.835),(27.575,39.005),(27.745,39.005),(27.745,38.835),(27.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,38.835),(27.935,39.005),(28.105,39.005),(28.105,38.835),(27.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,38.835),(28.295,39.005),(28.465,39.005),(28.465,38.835),(28.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,38.835),(28.655,39.005),(28.825,39.005),(28.825,38.835),(28.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,39.195),(27.575,39.365),(27.745,39.365),(27.745,39.195),(27.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,39.195),(27.935,39.365),(28.105,39.365),(28.105,39.195),(27.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,39.195),(28.295,39.365),(28.465,39.365),(28.465,39.195),(28.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,39.195),(28.655,39.365),(28.825,39.365),(28.825,39.195),(28.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,39.555),(27.575,39.725),(27.745,39.725),(27.745,39.555),(27.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,39.555),(27.935,39.725),(28.105,39.725),(28.105,39.555),(27.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,39.555),(28.295,39.725),(28.465,39.725),(28.465,39.555),(28.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,39.555),(28.655,39.725),(28.825,39.725),(28.825,39.555),(28.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,39.915),(27.575,40.085),(27.745,40.085),(27.745,39.915),(27.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,39.915),(27.935,40.085),(28.105,40.085),(28.105,39.915),(27.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,39.915),(28.295,40.085),(28.465,40.085),(28.465,39.915),(28.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,39.915),(28.655,40.085),(28.825,40.085),(28.825,39.915),(28.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,40.275),(27.575,40.445),(27.745,40.445),(27.745,40.275),(27.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,40.275),(27.935,40.445),(28.105,40.445),(28.105,40.275),(27.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,40.275),(28.295,40.445),(28.465,40.445),(28.465,40.275),(28.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,40.275),(28.655,40.445),(28.825,40.445),(28.825,40.275),(28.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,40.635),(27.575,40.805),(27.745,40.805),(27.745,40.635),(27.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,40.635),(27.935,40.805),(28.105,40.805),(28.105,40.635),(27.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,40.635),(28.295,40.805),(28.465,40.805),(28.465,40.635),(28.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,40.635),(28.655,40.805),(28.825,40.805),(28.825,40.635),(28.655,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,2.835),(80.375,3.005),(80.545,3.005),(80.545,2.835),(80.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,2.835),(80.735,3.005),(80.905,3.005),(80.905,2.835),(80.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,2.835),(81.095,3.005),(81.265,3.005),(81.265,2.835),(81.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,2.835),(81.455,3.005),(81.625,3.005),(81.625,2.835),(81.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.195),(80.375,3.365),(80.545,3.365),(80.545,3.195),(80.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.195),(80.735,3.365),(80.905,3.365),(80.905,3.195),(80.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.195),(81.095,3.365),(81.265,3.365),(81.265,3.195),(81.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.195),(81.455,3.365),(81.625,3.365),(81.625,3.195),(81.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.555),(80.375,3.725),(80.545,3.725),(80.545,3.555),(80.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.555),(80.735,3.725),(80.905,3.725),(80.905,3.555),(80.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.555),(81.095,3.725),(81.265,3.725),(81.265,3.555),(81.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.555),(81.455,3.725),(81.625,3.725),(81.625,3.555),(81.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.915),(80.375,4.085),(80.545,4.085),(80.545,3.915),(80.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.915),(80.735,4.085),(80.905,4.085),(80.905,3.915),(80.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.915),(81.095,4.085),(81.265,4.085),(81.265,3.915),(81.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.915),(81.455,4.085),(81.625,4.085),(81.625,3.915),(81.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.275),(80.375,4.445),(80.545,4.445),(80.545,4.275),(80.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.275),(80.735,4.445),(80.905,4.445),(80.905,4.275),(80.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.275),(81.095,4.445),(81.265,4.445),(81.265,4.275),(81.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.275),(81.455,4.445),(81.625,4.445),(81.625,4.275),(81.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.635),(80.375,4.805),(80.545,4.805),(80.545,4.635),(80.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.635),(80.735,4.805),(80.905,4.805),(80.905,4.635),(80.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.635),(81.095,4.805),(81.265,4.805),(81.265,4.635),(81.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.635),(81.455,4.805),(81.625,4.805),(81.625,4.635),(81.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.995),(80.375,5.165),(80.545,5.165),(80.545,4.995),(80.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.995),(80.735,5.165),(80.905,5.165),(80.905,4.995),(80.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.995),(81.095,5.165),(81.265,5.165),(81.265,4.995),(81.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.995),(81.455,5.165),(81.625,5.165),(81.625,4.995),(81.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.355),(80.375,5.525),(80.545,5.525),(80.545,5.355),(80.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.355),(80.735,5.525),(80.905,5.525),(80.905,5.355),(80.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.355),(81.095,5.525),(81.265,5.525),(81.265,5.355),(81.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.355),(81.455,5.525),(81.625,5.525),(81.625,5.355),(81.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.715),(80.375,5.885),(80.545,5.885),(80.545,5.715),(80.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.715),(80.735,5.885),(80.905,5.885),(80.905,5.715),(80.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.715),(81.095,5.885),(81.265,5.885),(81.265,5.715),(81.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.715),(81.455,5.885),(81.625,5.885),(81.625,5.715),(81.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.075),(80.375,6.245),(80.545,6.245),(80.545,6.075),(80.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.075),(80.735,6.245),(80.905,6.245),(80.905,6.075),(80.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.075),(81.095,6.245),(81.265,6.245),(81.265,6.075),(81.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.075),(81.455,6.245),(81.625,6.245),(81.625,6.075),(81.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.435),(80.375,6.605),(80.545,6.605),(80.545,6.435),(80.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.435),(80.735,6.605),(80.905,6.605),(80.905,6.435),(80.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.435),(81.095,6.605),(81.265,6.605),(81.265,6.435),(81.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.435),(81.455,6.605),(81.625,6.605),(81.625,6.435),(81.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.795),(80.375,6.965),(80.545,6.965),(80.545,6.795),(80.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.795),(80.735,6.965),(80.905,6.965),(80.905,6.795),(80.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.795),(81.095,6.965),(81.265,6.965),(81.265,6.795),(81.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.795),(81.455,6.965),(81.625,6.965),(81.625,6.795),(81.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.155),(80.375,7.325),(80.545,7.325),(80.545,7.155),(80.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.155),(80.735,7.325),(80.905,7.325),(80.905,7.155),(80.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.155),(81.095,7.325),(81.265,7.325),(81.265,7.155),(81.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.155),(81.455,7.325),(81.625,7.325),(81.625,7.155),(81.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.515),(80.375,7.685),(80.545,7.685),(80.545,7.515),(80.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.515),(80.735,7.685),(80.905,7.685),(80.905,7.515),(80.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.515),(81.095,7.685),(81.265,7.685),(81.265,7.515),(81.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.515),(81.455,7.685),(81.625,7.685),(81.625,7.515),(81.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.875),(80.375,8.045),(80.545,8.045),(80.545,7.875),(80.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.875),(80.735,8.045),(80.905,8.045),(80.905,7.875),(80.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.875),(81.095,8.045),(81.265,8.045),(81.265,7.875),(81.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.875),(81.455,8.045),(81.625,8.045),(81.625,7.875),(81.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.235),(80.375,8.405),(80.545,8.405),(80.545,8.235),(80.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.235),(80.735,8.405),(80.905,8.405),(80.905,8.235),(80.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.235),(81.095,8.405),(81.265,8.405),(81.265,8.235),(81.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.235),(81.455,8.405),(81.625,8.405),(81.625,8.235),(81.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.595),(80.375,8.765),(80.545,8.765),(80.545,8.595),(80.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.595),(80.735,8.765),(80.905,8.765),(80.905,8.595),(80.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.595),(81.095,8.765),(81.265,8.765),(81.265,8.595),(81.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.595),(81.455,8.765),(81.625,8.765),(81.625,8.595),(81.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.955),(80.375,9.125),(80.545,9.125),(80.545,8.955),(80.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.955),(80.735,9.125),(80.905,9.125),(80.905,8.955),(80.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.955),(81.095,9.125),(81.265,9.125),(81.265,8.955),(81.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.955),(81.455,9.125),(81.625,9.125),(81.625,8.955),(81.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.315),(80.375,9.485),(80.545,9.485),(80.545,9.315),(80.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.315),(80.735,9.485),(80.905,9.485),(80.905,9.315),(80.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.315),(81.095,9.485),(81.265,9.485),(81.265,9.315),(81.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.315),(81.455,9.485),(81.625,9.485),(81.625,9.315),(81.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.675),(80.375,9.845),(80.545,9.845),(80.545,9.675),(80.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.675),(80.735,9.845),(80.905,9.845),(80.905,9.675),(80.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.675),(81.095,9.845),(81.265,9.845),(81.265,9.675),(81.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.675),(81.455,9.845),(81.625,9.845),(81.625,9.675),(81.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.035),(80.375,10.205),(80.545,10.205),(80.545,10.035),(80.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.035),(80.735,10.205),(80.905,10.205),(80.905,10.035),(80.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.035),(81.095,10.205),(81.265,10.205),(81.265,10.035),(81.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.035),(81.455,10.205),(81.625,10.205),(81.625,10.035),(81.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.395),(80.375,10.565),(80.545,10.565),(80.545,10.395),(80.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.395),(80.735,10.565),(80.905,10.565),(80.905,10.395),(80.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.395),(81.095,10.565),(81.265,10.565),(81.265,10.395),(81.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.395),(81.455,10.565),(81.625,10.565),(81.625,10.395),(81.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.755),(80.375,10.925),(80.545,10.925),(80.545,10.755),(80.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.755),(80.735,10.925),(80.905,10.925),(80.905,10.755),(80.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.755),(81.095,10.925),(81.265,10.925),(81.265,10.755),(81.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.755),(81.455,10.925),(81.625,10.925),(81.625,10.755),(81.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.115),(80.375,11.285),(80.545,11.285),(80.545,11.115),(80.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.115),(80.735,11.285),(80.905,11.285),(80.905,11.115),(80.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.115),(81.095,11.285),(81.265,11.285),(81.265,11.115),(81.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.115),(81.455,11.285),(81.625,11.285),(81.625,11.115),(81.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.475),(80.375,11.645),(80.545,11.645),(80.545,11.475),(80.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.475),(80.735,11.645),(80.905,11.645),(80.905,11.475),(80.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.475),(81.095,11.645),(81.265,11.645),(81.265,11.475),(81.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.475),(81.455,11.645),(81.625,11.645),(81.625,11.475),(81.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.835),(80.375,12.005),(80.545,12.005),(80.545,11.835),(80.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.835),(80.735,12.005),(80.905,12.005),(80.905,11.835),(80.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.835),(81.095,12.005),(81.265,12.005),(81.265,11.835),(81.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.835),(81.455,12.005),(81.625,12.005),(81.625,11.835),(81.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.195),(80.375,12.365),(80.545,12.365),(80.545,12.195),(80.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.195),(80.735,12.365),(80.905,12.365),(80.905,12.195),(80.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.195),(81.095,12.365),(81.265,12.365),(81.265,12.195),(81.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.195),(81.455,12.365),(81.625,12.365),(81.625,12.195),(81.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.555),(80.375,12.725),(80.545,12.725),(80.545,12.555),(80.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.555),(80.735,12.725),(80.905,12.725),(80.905,12.555),(80.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.555),(81.095,12.725),(81.265,12.725),(81.265,12.555),(81.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.555),(81.455,12.725),(81.625,12.725),(81.625,12.555),(81.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.915),(80.375,13.085),(80.545,13.085),(80.545,12.915),(80.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.915),(80.735,13.085),(80.905,13.085),(80.905,12.915),(80.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.915),(81.095,13.085),(81.265,13.085),(81.265,12.915),(81.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.915),(81.455,13.085),(81.625,13.085),(81.625,12.915),(81.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.275),(80.375,13.445),(80.545,13.445),(80.545,13.275),(80.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.275),(80.735,13.445),(80.905,13.445),(80.905,13.275),(80.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.275),(81.095,13.445),(81.265,13.445),(81.265,13.275),(81.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.275),(81.455,13.445),(81.625,13.445),(81.625,13.275),(81.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.635),(80.375,13.805),(80.545,13.805),(80.545,13.635),(80.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.635),(80.735,13.805),(80.905,13.805),(80.905,13.635),(80.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.635),(81.095,13.805),(81.265,13.805),(81.265,13.635),(81.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.635),(81.455,13.805),(81.625,13.805),(81.625,13.635),(81.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.995),(80.375,14.165),(80.545,14.165),(80.545,13.995),(80.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.995),(80.735,14.165),(80.905,14.165),(80.905,13.995),(80.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.995),(81.095,14.165),(81.265,14.165),(81.265,13.995),(81.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.995),(81.455,14.165),(81.625,14.165),(81.625,13.995),(81.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.355),(80.375,14.525),(80.545,14.525),(80.545,14.355),(80.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.355),(80.735,14.525),(80.905,14.525),(80.905,14.355),(80.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.355),(81.095,14.525),(81.265,14.525),(81.265,14.355),(81.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.355),(81.455,14.525),(81.625,14.525),(81.625,14.355),(81.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.715),(80.375,14.885),(80.545,14.885),(80.545,14.715),(80.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.715),(80.735,14.885),(80.905,14.885),(80.905,14.715),(80.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.715),(81.095,14.885),(81.265,14.885),(81.265,14.715),(81.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.715),(81.455,14.885),(81.625,14.885),(81.625,14.715),(81.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.075),(80.375,15.245),(80.545,15.245),(80.545,15.075),(80.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.075),(80.735,15.245),(80.905,15.245),(80.905,15.075),(80.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.075),(81.095,15.245),(81.265,15.245),(81.265,15.075),(81.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.075),(81.455,15.245),(81.625,15.245),(81.625,15.075),(81.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.435),(80.375,15.605),(80.545,15.605),(80.545,15.435),(80.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.435),(80.735,15.605),(80.905,15.605),(80.905,15.435),(80.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.435),(81.095,15.605),(81.265,15.605),(81.265,15.435),(81.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.435),(81.455,15.605),(81.625,15.605),(81.625,15.435),(81.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.795),(80.375,15.965),(80.545,15.965),(80.545,15.795),(80.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.795),(80.735,15.965),(80.905,15.965),(80.905,15.795),(80.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.795),(81.095,15.965),(81.265,15.965),(81.265,15.795),(81.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.795),(81.455,15.965),(81.625,15.965),(81.625,15.795),(81.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.155),(80.375,16.325),(80.545,16.325),(80.545,16.155),(80.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.155),(80.735,16.325),(80.905,16.325),(80.905,16.155),(80.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.155),(81.095,16.325),(81.265,16.325),(81.265,16.155),(81.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.155),(81.455,16.325),(81.625,16.325),(81.625,16.155),(81.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.515),(80.375,16.685),(80.545,16.685),(80.545,16.515),(80.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.515),(80.735,16.685),(80.905,16.685),(80.905,16.515),(80.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.515),(81.095,16.685),(81.265,16.685),(81.265,16.515),(81.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.515),(81.455,16.685),(81.625,16.685),(81.625,16.515),(81.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.875),(80.375,17.045),(80.545,17.045),(80.545,16.875),(80.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.875),(80.735,17.045),(80.905,17.045),(80.905,16.875),(80.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.875),(81.095,17.045),(81.265,17.045),(81.265,16.875),(81.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.875),(81.455,17.045),(81.625,17.045),(81.625,16.875),(81.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.235),(80.375,17.405),(80.545,17.405),(80.545,17.235),(80.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.235),(80.735,17.405),(80.905,17.405),(80.905,17.235),(80.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.235),(81.095,17.405),(81.265,17.405),(81.265,17.235),(81.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.235),(81.455,17.405),(81.625,17.405),(81.625,17.235),(81.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.595),(80.375,17.765),(80.545,17.765),(80.545,17.595),(80.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.595),(80.735,17.765),(80.905,17.765),(80.905,17.595),(80.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.595),(81.095,17.765),(81.265,17.765),(81.265,17.595),(81.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.595),(81.455,17.765),(81.625,17.765),(81.625,17.595),(81.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.955),(80.375,18.125),(80.545,18.125),(80.545,17.955),(80.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.955),(80.735,18.125),(80.905,18.125),(80.905,17.955),(80.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.955),(81.095,18.125),(81.265,18.125),(81.265,17.955),(81.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.955),(81.455,18.125),(81.625,18.125),(81.625,17.955),(81.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.315),(80.375,18.485),(80.545,18.485),(80.545,18.315),(80.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.315),(80.735,18.485),(80.905,18.485),(80.905,18.315),(80.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.315),(81.095,18.485),(81.265,18.485),(81.265,18.315),(81.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.315),(81.455,18.485),(81.625,18.485),(81.625,18.315),(81.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.675),(80.375,18.845),(80.545,18.845),(80.545,18.675),(80.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.675),(80.735,18.845),(80.905,18.845),(80.905,18.675),(80.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.675),(81.095,18.845),(81.265,18.845),(81.265,18.675),(81.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.675),(81.455,18.845),(81.625,18.845),(81.625,18.675),(81.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.035),(80.375,19.205),(80.545,19.205),(80.545,19.035),(80.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.035),(80.735,19.205),(80.905,19.205),(80.905,19.035),(80.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.035),(81.095,19.205),(81.265,19.205),(81.265,19.035),(81.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.035),(81.455,19.205),(81.625,19.205),(81.625,19.035),(81.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.395),(80.375,19.565),(80.545,19.565),(80.545,19.395),(80.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.395),(80.735,19.565),(80.905,19.565),(80.905,19.395),(80.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.395),(81.095,19.565),(81.265,19.565),(81.265,19.395),(81.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.395),(81.455,19.565),(81.625,19.565),(81.625,19.395),(81.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.755),(80.375,19.925),(80.545,19.925),(80.545,19.755),(80.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.755),(80.735,19.925),(80.905,19.925),(80.905,19.755),(80.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.755),(81.095,19.925),(81.265,19.925),(81.265,19.755),(81.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.755),(81.455,19.925),(81.625,19.925),(81.625,19.755),(81.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,20.115),(80.375,20.285),(80.545,20.285),(80.545,20.115),(80.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,20.115),(80.735,20.285),(80.905,20.285),(80.905,20.115),(80.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,20.115),(81.095,20.285),(81.265,20.285),(81.265,20.115),(81.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,20.115),(81.455,20.285),(81.625,20.285),(81.625,20.115),(81.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,20.475),(80.375,20.645),(80.545,20.645),(80.545,20.475),(80.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,20.475),(80.735,20.645),(80.905,20.645),(80.905,20.475),(80.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,20.475),(81.095,20.645),(81.265,20.645),(81.265,20.475),(81.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,20.475),(81.455,20.645),(81.625,20.645),(81.625,20.475),(81.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,20.835),(80.375,21.005),(80.545,21.005),(80.545,20.835),(80.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,20.835),(80.735,21.005),(80.905,21.005),(80.905,20.835),(80.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,20.835),(81.095,21.005),(81.265,21.005),(81.265,20.835),(81.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,20.835),(81.455,21.005),(81.625,21.005),(81.625,20.835),(81.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,21.195),(80.375,21.365),(80.545,21.365),(80.545,21.195),(80.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,21.195),(80.735,21.365),(80.905,21.365),(80.905,21.195),(80.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,21.195),(81.095,21.365),(81.265,21.365),(81.265,21.195),(81.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,21.195),(81.455,21.365),(81.625,21.365),(81.625,21.195),(81.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,21.555),(80.375,21.725),(80.545,21.725),(80.545,21.555),(80.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,21.555),(80.735,21.725),(80.905,21.725),(80.905,21.555),(80.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,21.555),(81.095,21.725),(81.265,21.725),(81.265,21.555),(81.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,21.555),(81.455,21.725),(81.625,21.725),(81.625,21.555),(81.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,21.915),(80.375,22.085),(80.545,22.085),(80.545,21.915),(80.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,21.915),(80.735,22.085),(80.905,22.085),(80.905,21.915),(80.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,21.915),(81.095,22.085),(81.265,22.085),(81.265,21.915),(81.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,21.915),(81.455,22.085),(81.625,22.085),(81.625,21.915),(81.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.275),(80.375,22.445),(80.545,22.445),(80.545,22.275),(80.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.275),(80.735,22.445),(80.905,22.445),(80.905,22.275),(80.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.275),(81.095,22.445),(81.265,22.445),(81.265,22.275),(81.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.275),(81.455,22.445),(81.625,22.445),(81.625,22.275),(81.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.635),(80.375,22.805),(80.545,22.805),(80.545,22.635),(80.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.635),(80.735,22.805),(80.905,22.805),(80.905,22.635),(80.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.635),(81.095,22.805),(81.265,22.805),(81.265,22.635),(81.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.635),(81.455,22.805),(81.625,22.805),(81.625,22.635),(81.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.995),(80.375,23.165),(80.545,23.165),(80.545,22.995),(80.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.995),(80.735,23.165),(80.905,23.165),(80.905,22.995),(80.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.995),(81.095,23.165),(81.265,23.165),(81.265,22.995),(81.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.995),(81.455,23.165),(81.625,23.165),(81.625,22.995),(81.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,23.355),(80.375,23.525),(80.545,23.525),(80.545,23.355),(80.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,23.355),(80.735,23.525),(80.905,23.525),(80.905,23.355),(80.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,23.355),(81.095,23.525),(81.265,23.525),(81.265,23.355),(81.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,23.355),(81.455,23.525),(81.625,23.525),(81.625,23.355),(81.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,23.715),(80.375,23.885),(80.545,23.885),(80.545,23.715),(80.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,23.715),(80.735,23.885),(80.905,23.885),(80.905,23.715),(80.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,23.715),(81.095,23.885),(81.265,23.885),(81.265,23.715),(81.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,23.715),(81.455,23.885),(81.625,23.885),(81.625,23.715),(81.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,24.075),(80.375,24.245),(80.545,24.245),(80.545,24.075),(80.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,24.075),(80.735,24.245),(80.905,24.245),(80.905,24.075),(80.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,24.075),(81.095,24.245),(81.265,24.245),(81.265,24.075),(81.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,24.075),(81.455,24.245),(81.625,24.245),(81.625,24.075),(81.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,24.435),(80.375,24.605),(80.545,24.605),(80.545,24.435),(80.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,24.435),(80.735,24.605),(80.905,24.605),(80.905,24.435),(80.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,24.435),(81.095,24.605),(81.265,24.605),(81.265,24.435),(81.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,24.435),(81.455,24.605),(81.625,24.605),(81.625,24.435),(81.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,24.795),(80.375,24.965),(80.545,24.965),(80.545,24.795),(80.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,24.795),(80.735,24.965),(80.905,24.965),(80.905,24.795),(80.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,24.795),(81.095,24.965),(81.265,24.965),(81.265,24.795),(81.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,24.795),(81.455,24.965),(81.625,24.965),(81.625,24.795),(81.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,25.155),(80.375,25.325),(80.545,25.325),(80.545,25.155),(80.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,25.155),(80.735,25.325),(80.905,25.325),(80.905,25.155),(80.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,25.155),(81.095,25.325),(81.265,25.325),(81.265,25.155),(81.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,25.155),(81.455,25.325),(81.625,25.325),(81.625,25.155),(81.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,25.515),(80.375,25.685),(80.545,25.685),(80.545,25.515),(80.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,25.515),(80.735,25.685),(80.905,25.685),(80.905,25.515),(80.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,25.515),(81.095,25.685),(81.265,25.685),(81.265,25.515),(81.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,25.515),(81.455,25.685),(81.625,25.685),(81.625,25.515),(81.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,25.875),(80.375,26.045),(80.545,26.045),(80.545,25.875),(80.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,25.875),(80.735,26.045),(80.905,26.045),(80.905,25.875),(80.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,25.875),(81.095,26.045),(81.265,26.045),(81.265,25.875),(81.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,25.875),(81.455,26.045),(81.625,26.045),(81.625,25.875),(81.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,26.235),(80.375,26.405),(80.545,26.405),(80.545,26.235),(80.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,26.235),(80.735,26.405),(80.905,26.405),(80.905,26.235),(80.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,26.235),(81.095,26.405),(81.265,26.405),(81.265,26.235),(81.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,26.235),(81.455,26.405),(81.625,26.405),(81.625,26.235),(81.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,26.595),(80.375,26.765),(80.545,26.765),(80.545,26.595),(80.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,26.595),(80.735,26.765),(80.905,26.765),(80.905,26.595),(80.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,26.595),(81.095,26.765),(81.265,26.765),(81.265,26.595),(81.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,26.595),(81.455,26.765),(81.625,26.765),(81.625,26.595),(81.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,26.955),(80.375,27.125),(80.545,27.125),(80.545,26.955),(80.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,26.955),(80.735,27.125),(80.905,27.125),(80.905,26.955),(80.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,26.955),(81.095,27.125),(81.265,27.125),(81.265,26.955),(81.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,26.955),(81.455,27.125),(81.625,27.125),(81.625,26.955),(81.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,27.315),(80.375,27.485),(80.545,27.485),(80.545,27.315),(80.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,27.315),(80.735,27.485),(80.905,27.485),(80.905,27.315),(80.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,27.315),(81.095,27.485),(81.265,27.485),(81.265,27.315),(81.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,27.315),(81.455,27.485),(81.625,27.485),(81.625,27.315),(81.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,27.675),(80.375,27.845),(80.545,27.845),(80.545,27.675),(80.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,27.675),(80.735,27.845),(80.905,27.845),(80.905,27.675),(80.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,27.675),(81.095,27.845),(81.265,27.845),(81.265,27.675),(81.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,27.675),(81.455,27.845),(81.625,27.845),(81.625,27.675),(81.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,28.035),(80.375,28.205),(80.545,28.205),(80.545,28.035),(80.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,28.035),(80.735,28.205),(80.905,28.205),(80.905,28.035),(80.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,28.035),(81.095,28.205),(81.265,28.205),(81.265,28.035),(81.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,28.035),(81.455,28.205),(81.625,28.205),(81.625,28.035),(81.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,28.395),(80.375,28.565),(80.545,28.565),(80.545,28.395),(80.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,28.395),(80.735,28.565),(80.905,28.565),(80.905,28.395),(80.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,28.395),(81.095,28.565),(81.265,28.565),(81.265,28.395),(81.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,28.395),(81.455,28.565),(81.625,28.565),(81.625,28.395),(81.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,28.755),(80.375,28.925),(80.545,28.925),(80.545,28.755),(80.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,28.755),(80.735,28.925),(80.905,28.925),(80.905,28.755),(80.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,28.755),(81.095,28.925),(81.265,28.925),(81.265,28.755),(81.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,28.755),(81.455,28.925),(81.625,28.925),(81.625,28.755),(81.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,29.115),(80.375,29.285),(80.545,29.285),(80.545,29.115),(80.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,29.115),(80.735,29.285),(80.905,29.285),(80.905,29.115),(80.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,29.115),(81.095,29.285),(81.265,29.285),(81.265,29.115),(81.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,29.115),(81.455,29.285),(81.625,29.285),(81.625,29.115),(81.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,29.475),(80.375,29.645),(80.545,29.645),(80.545,29.475),(80.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,29.475),(80.735,29.645),(80.905,29.645),(80.905,29.475),(80.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,29.475),(81.095,29.645),(81.265,29.645),(81.265,29.475),(81.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,29.475),(81.455,29.645),(81.625,29.645),(81.625,29.475),(81.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,29.835),(80.375,30.005),(80.545,30.005),(80.545,29.835),(80.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,29.835),(80.735,30.005),(80.905,30.005),(80.905,29.835),(80.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,29.835),(81.095,30.005),(81.265,30.005),(81.265,29.835),(81.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,29.835),(81.455,30.005),(81.625,30.005),(81.625,29.835),(81.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,30.195),(80.375,30.365),(80.545,30.365),(80.545,30.195),(80.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,30.195),(80.735,30.365),(80.905,30.365),(80.905,30.195),(80.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,30.195),(81.095,30.365),(81.265,30.365),(81.265,30.195),(81.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,30.195),(81.455,30.365),(81.625,30.365),(81.625,30.195),(81.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,30.555),(80.375,30.725),(80.545,30.725),(80.545,30.555),(80.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,30.555),(80.735,30.725),(80.905,30.725),(80.905,30.555),(80.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,30.555),(81.095,30.725),(81.265,30.725),(81.265,30.555),(81.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,30.555),(81.455,30.725),(81.625,30.725),(81.625,30.555),(81.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,30.915),(80.375,31.085),(80.545,31.085),(80.545,30.915),(80.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,30.915),(80.735,31.085),(80.905,31.085),(80.905,30.915),(80.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,30.915),(81.095,31.085),(81.265,31.085),(81.265,30.915),(81.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,30.915),(81.455,31.085),(81.625,31.085),(81.625,30.915),(81.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,31.275),(80.375,31.445),(80.545,31.445),(80.545,31.275),(80.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,31.275),(80.735,31.445),(80.905,31.445),(80.905,31.275),(80.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,31.275),(81.095,31.445),(81.265,31.445),(81.265,31.275),(81.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,31.275),(81.455,31.445),(81.625,31.445),(81.625,31.275),(81.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,31.635),(80.375,31.805),(80.545,31.805),(80.545,31.635),(80.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,31.635),(80.735,31.805),(80.905,31.805),(80.905,31.635),(80.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,31.635),(81.095,31.805),(81.265,31.805),(81.265,31.635),(81.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,31.635),(81.455,31.805),(81.625,31.805),(81.625,31.635),(81.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,31.995),(80.375,32.165),(80.545,32.165),(80.545,31.995),(80.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,31.995),(80.735,32.165),(80.905,32.165),(80.905,31.995),(80.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,31.995),(81.095,32.165),(81.265,32.165),(81.265,31.995),(81.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,31.995),(81.455,32.165),(81.625,32.165),(81.625,31.995),(81.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,32.355),(80.375,32.525),(80.545,32.525),(80.545,32.355),(80.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,32.355),(80.735,32.525),(80.905,32.525),(80.905,32.355),(80.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,32.355),(81.095,32.525),(81.265,32.525),(81.265,32.355),(81.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,32.355),(81.455,32.525),(81.625,32.525),(81.625,32.355),(81.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,32.715),(80.375,32.885),(80.545,32.885),(80.545,32.715),(80.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,32.715),(80.735,32.885),(80.905,32.885),(80.905,32.715),(80.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,32.715),(81.095,32.885),(81.265,32.885),(81.265,32.715),(81.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,32.715),(81.455,32.885),(81.625,32.885),(81.625,32.715),(81.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,33.075),(80.375,33.245),(80.545,33.245),(80.545,33.075),(80.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,33.075),(80.735,33.245),(80.905,33.245),(80.905,33.075),(80.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,33.075),(81.095,33.245),(81.265,33.245),(81.265,33.075),(81.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,33.075),(81.455,33.245),(81.625,33.245),(81.625,33.075),(81.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,33.435),(80.375,33.605),(80.545,33.605),(80.545,33.435),(80.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,33.435),(80.735,33.605),(80.905,33.605),(80.905,33.435),(80.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,33.435),(81.095,33.605),(81.265,33.605),(81.265,33.435),(81.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,33.435),(81.455,33.605),(81.625,33.605),(81.625,33.435),(81.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,33.795),(80.375,33.965),(80.545,33.965),(80.545,33.795),(80.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,33.795),(80.735,33.965),(80.905,33.965),(80.905,33.795),(80.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,33.795),(81.095,33.965),(81.265,33.965),(81.265,33.795),(81.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,33.795),(81.455,33.965),(81.625,33.965),(81.625,33.795),(81.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,34.155),(80.375,34.325),(80.545,34.325),(80.545,34.155),(80.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,34.155),(80.735,34.325),(80.905,34.325),(80.905,34.155),(80.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,34.155),(81.095,34.325),(81.265,34.325),(81.265,34.155),(81.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,34.155),(81.455,34.325),(81.625,34.325),(81.625,34.155),(81.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,34.515),(80.375,34.685),(80.545,34.685),(80.545,34.515),(80.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,34.515),(80.735,34.685),(80.905,34.685),(80.905,34.515),(80.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,34.515),(81.095,34.685),(81.265,34.685),(81.265,34.515),(81.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,34.515),(81.455,34.685),(81.625,34.685),(81.625,34.515),(81.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,34.875),(80.375,35.045),(80.545,35.045),(80.545,34.875),(80.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,34.875),(80.735,35.045),(80.905,35.045),(80.905,34.875),(80.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,34.875),(81.095,35.045),(81.265,35.045),(81.265,34.875),(81.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,34.875),(81.455,35.045),(81.625,35.045),(81.625,34.875),(81.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,35.235),(80.375,35.405),(80.545,35.405),(80.545,35.235),(80.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,35.235),(80.735,35.405),(80.905,35.405),(80.905,35.235),(80.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,35.235),(81.095,35.405),(81.265,35.405),(81.265,35.235),(81.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,35.235),(81.455,35.405),(81.625,35.405),(81.625,35.235),(81.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,35.595),(80.375,35.765),(80.545,35.765),(80.545,35.595),(80.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,35.595),(80.735,35.765),(80.905,35.765),(80.905,35.595),(80.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,35.595),(81.095,35.765),(81.265,35.765),(81.265,35.595),(81.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,35.595),(81.455,35.765),(81.625,35.765),(81.625,35.595),(81.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,35.955),(80.375,36.125),(80.545,36.125),(80.545,35.955),(80.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,35.955),(80.735,36.125),(80.905,36.125),(80.905,35.955),(80.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,35.955),(81.095,36.125),(81.265,36.125),(81.265,35.955),(81.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,35.955),(81.455,36.125),(81.625,36.125),(81.625,35.955),(81.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,36.315),(80.375,36.485),(80.545,36.485),(80.545,36.315),(80.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,36.315),(80.735,36.485),(80.905,36.485),(80.905,36.315),(80.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,36.315),(81.095,36.485),(81.265,36.485),(81.265,36.315),(81.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,36.315),(81.455,36.485),(81.625,36.485),(81.625,36.315),(81.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,36.675),(80.375,36.845),(80.545,36.845),(80.545,36.675),(80.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,36.675),(80.735,36.845),(80.905,36.845),(80.905,36.675),(80.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,36.675),(81.095,36.845),(81.265,36.845),(81.265,36.675),(81.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,36.675),(81.455,36.845),(81.625,36.845),(81.625,36.675),(81.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,37.035),(80.375,37.205),(80.545,37.205),(80.545,37.035),(80.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,37.035),(80.735,37.205),(80.905,37.205),(80.905,37.035),(80.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,37.035),(81.095,37.205),(81.265,37.205),(81.265,37.035),(81.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,37.035),(81.455,37.205),(81.625,37.205),(81.625,37.035),(81.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,37.395),(80.375,37.565),(80.545,37.565),(80.545,37.395),(80.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,37.395),(80.735,37.565),(80.905,37.565),(80.905,37.395),(80.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,37.395),(81.095,37.565),(81.265,37.565),(81.265,37.395),(81.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,37.395),(81.455,37.565),(81.625,37.565),(81.625,37.395),(81.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,37.755),(80.375,37.925),(80.545,37.925),(80.545,37.755),(80.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,37.755),(80.735,37.925),(80.905,37.925),(80.905,37.755),(80.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,37.755),(81.095,37.925),(81.265,37.925),(81.265,37.755),(81.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,37.755),(81.455,37.925),(81.625,37.925),(81.625,37.755),(81.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,38.115),(80.375,38.285),(80.545,38.285),(80.545,38.115),(80.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,38.115),(80.735,38.285),(80.905,38.285),(80.905,38.115),(80.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,38.115),(81.095,38.285),(81.265,38.285),(81.265,38.115),(81.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,38.115),(81.455,38.285),(81.625,38.285),(81.625,38.115),(81.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,38.475),(80.375,38.645),(80.545,38.645),(80.545,38.475),(80.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,38.475),(80.735,38.645),(80.905,38.645),(80.905,38.475),(80.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,38.475),(81.095,38.645),(81.265,38.645),(81.265,38.475),(81.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,38.475),(81.455,38.645),(81.625,38.645),(81.625,38.475),(81.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,38.835),(80.375,39.005),(80.545,39.005),(80.545,38.835),(80.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,38.835),(80.735,39.005),(80.905,39.005),(80.905,38.835),(80.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,38.835),(81.095,39.005),(81.265,39.005),(81.265,38.835),(81.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,38.835),(81.455,39.005),(81.625,39.005),(81.625,38.835),(81.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,39.195),(80.375,39.365),(80.545,39.365),(80.545,39.195),(80.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,39.195),(80.735,39.365),(80.905,39.365),(80.905,39.195),(80.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,39.195),(81.095,39.365),(81.265,39.365),(81.265,39.195),(81.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,39.195),(81.455,39.365),(81.625,39.365),(81.625,39.195),(81.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,39.555),(80.375,39.725),(80.545,39.725),(80.545,39.555),(80.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,39.555),(80.735,39.725),(80.905,39.725),(80.905,39.555),(80.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,39.555),(81.095,39.725),(81.265,39.725),(81.265,39.555),(81.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,39.555),(81.455,39.725),(81.625,39.725),(81.625,39.555),(81.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,39.915),(80.375,40.085),(80.545,40.085),(80.545,39.915),(80.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,39.915),(80.735,40.085),(80.905,40.085),(80.905,39.915),(80.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,39.915),(81.095,40.085),(81.265,40.085),(81.265,39.915),(81.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,39.915),(81.455,40.085),(81.625,40.085),(81.625,39.915),(81.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,40.275),(80.375,40.445),(80.545,40.445),(80.545,40.275),(80.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,40.275),(80.735,40.445),(80.905,40.445),(80.905,40.275),(80.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,40.275),(81.095,40.445),(81.265,40.445),(81.265,40.275),(81.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,40.275),(81.455,40.445),(81.625,40.445),(81.625,40.275),(81.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,40.635),(80.375,40.805),(80.545,40.805),(80.545,40.635),(80.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,40.635),(80.735,40.805),(80.905,40.805),(80.905,40.635),(80.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,40.635),(81.095,40.805),(81.265,40.805),(81.265,40.635),(81.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,40.635),(81.455,40.805),(81.625,40.805),(81.625,40.635),(81.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.835),(41.975,3.005),(42.145,3.005),(42.145,2.835),(41.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.835),(42.335,3.005),(42.505,3.005),(42.505,2.835),(42.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.835),(42.695,3.005),(42.865,3.005),(42.865,2.835),(42.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.835),(43.055,3.005),(43.225,3.005),(43.225,2.835),(43.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.195),(41.975,3.365),(42.145,3.365),(42.145,3.195),(41.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.195),(42.335,3.365),(42.505,3.365),(42.505,3.195),(42.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.195),(42.695,3.365),(42.865,3.365),(42.865,3.195),(42.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.195),(43.055,3.365),(43.225,3.365),(43.225,3.195),(43.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.555),(41.975,3.725),(42.145,3.725),(42.145,3.555),(41.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.555),(42.335,3.725),(42.505,3.725),(42.505,3.555),(42.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.555),(42.695,3.725),(42.865,3.725),(42.865,3.555),(42.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.555),(43.055,3.725),(43.225,3.725),(43.225,3.555),(43.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.915),(41.975,4.085),(42.145,4.085),(42.145,3.915),(41.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.915),(42.335,4.085),(42.505,4.085),(42.505,3.915),(42.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.915),(42.695,4.085),(42.865,4.085),(42.865,3.915),(42.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.915),(43.055,4.085),(43.225,4.085),(43.225,3.915),(43.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.275),(41.975,4.445),(42.145,4.445),(42.145,4.275),(41.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.275),(42.335,4.445),(42.505,4.445),(42.505,4.275),(42.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.275),(42.695,4.445),(42.865,4.445),(42.865,4.275),(42.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.275),(43.055,4.445),(43.225,4.445),(43.225,4.275),(43.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.635),(41.975,4.805),(42.145,4.805),(42.145,4.635),(41.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.635),(42.335,4.805),(42.505,4.805),(42.505,4.635),(42.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.635),(42.695,4.805),(42.865,4.805),(42.865,4.635),(42.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.635),(43.055,4.805),(43.225,4.805),(43.225,4.635),(43.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.995),(41.975,5.165),(42.145,5.165),(42.145,4.995),(41.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.995),(42.335,5.165),(42.505,5.165),(42.505,4.995),(42.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.995),(42.695,5.165),(42.865,5.165),(42.865,4.995),(42.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.995),(43.055,5.165),(43.225,5.165),(43.225,4.995),(43.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.355),(41.975,5.525),(42.145,5.525),(42.145,5.355),(41.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.355),(42.335,5.525),(42.505,5.525),(42.505,5.355),(42.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.355),(42.695,5.525),(42.865,5.525),(42.865,5.355),(42.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.355),(43.055,5.525),(43.225,5.525),(43.225,5.355),(43.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.715),(41.975,5.885),(42.145,5.885),(42.145,5.715),(41.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.715),(42.335,5.885),(42.505,5.885),(42.505,5.715),(42.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.715),(42.695,5.885),(42.865,5.885),(42.865,5.715),(42.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.715),(43.055,5.885),(43.225,5.885),(43.225,5.715),(43.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.075),(41.975,6.245),(42.145,6.245),(42.145,6.075),(41.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.075),(42.335,6.245),(42.505,6.245),(42.505,6.075),(42.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.075),(42.695,6.245),(42.865,6.245),(42.865,6.075),(42.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.075),(43.055,6.245),(43.225,6.245),(43.225,6.075),(43.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.435),(41.975,6.605),(42.145,6.605),(42.145,6.435),(41.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.435),(42.335,6.605),(42.505,6.605),(42.505,6.435),(42.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.435),(42.695,6.605),(42.865,6.605),(42.865,6.435),(42.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.435),(43.055,6.605),(43.225,6.605),(43.225,6.435),(43.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.795),(41.975,6.965),(42.145,6.965),(42.145,6.795),(41.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.795),(42.335,6.965),(42.505,6.965),(42.505,6.795),(42.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.795),(42.695,6.965),(42.865,6.965),(42.865,6.795),(42.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.795),(43.055,6.965),(43.225,6.965),(43.225,6.795),(43.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.155),(41.975,7.325),(42.145,7.325),(42.145,7.155),(41.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.155),(42.335,7.325),(42.505,7.325),(42.505,7.155),(42.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.155),(42.695,7.325),(42.865,7.325),(42.865,7.155),(42.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.155),(43.055,7.325),(43.225,7.325),(43.225,7.155),(43.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.515),(41.975,7.685),(42.145,7.685),(42.145,7.515),(41.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.515),(42.335,7.685),(42.505,7.685),(42.505,7.515),(42.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.515),(42.695,7.685),(42.865,7.685),(42.865,7.515),(42.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.515),(43.055,7.685),(43.225,7.685),(43.225,7.515),(43.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.875),(41.975,8.045),(42.145,8.045),(42.145,7.875),(41.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.875),(42.335,8.045),(42.505,8.045),(42.505,7.875),(42.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.875),(42.695,8.045),(42.865,8.045),(42.865,7.875),(42.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.875),(43.055,8.045),(43.225,8.045),(43.225,7.875),(43.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.235),(41.975,8.405),(42.145,8.405),(42.145,8.235),(41.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.235),(42.335,8.405),(42.505,8.405),(42.505,8.235),(42.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.235),(42.695,8.405),(42.865,8.405),(42.865,8.235),(42.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.235),(43.055,8.405),(43.225,8.405),(43.225,8.235),(43.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.595),(41.975,8.765),(42.145,8.765),(42.145,8.595),(41.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.595),(42.335,8.765),(42.505,8.765),(42.505,8.595),(42.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.595),(42.695,8.765),(42.865,8.765),(42.865,8.595),(42.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.595),(43.055,8.765),(43.225,8.765),(43.225,8.595),(43.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.955),(41.975,9.125),(42.145,9.125),(42.145,8.955),(41.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.955),(42.335,9.125),(42.505,9.125),(42.505,8.955),(42.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.955),(42.695,9.125),(42.865,9.125),(42.865,8.955),(42.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.955),(43.055,9.125),(43.225,9.125),(43.225,8.955),(43.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.315),(41.975,9.485),(42.145,9.485),(42.145,9.315),(41.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.315),(42.335,9.485),(42.505,9.485),(42.505,9.315),(42.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.315),(42.695,9.485),(42.865,9.485),(42.865,9.315),(42.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.315),(43.055,9.485),(43.225,9.485),(43.225,9.315),(43.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.675),(41.975,9.845),(42.145,9.845),(42.145,9.675),(41.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.675),(42.335,9.845),(42.505,9.845),(42.505,9.675),(42.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.675),(42.695,9.845),(42.865,9.845),(42.865,9.675),(42.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.675),(43.055,9.845),(43.225,9.845),(43.225,9.675),(43.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.035),(41.975,10.205),(42.145,10.205),(42.145,10.035),(41.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.035),(42.335,10.205),(42.505,10.205),(42.505,10.035),(42.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.035),(42.695,10.205),(42.865,10.205),(42.865,10.035),(42.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.035),(43.055,10.205),(43.225,10.205),(43.225,10.035),(43.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.395),(41.975,10.565),(42.145,10.565),(42.145,10.395),(41.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.395),(42.335,10.565),(42.505,10.565),(42.505,10.395),(42.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.395),(42.695,10.565),(42.865,10.565),(42.865,10.395),(42.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.395),(43.055,10.565),(43.225,10.565),(43.225,10.395),(43.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.755),(41.975,10.925),(42.145,10.925),(42.145,10.755),(41.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.755),(42.335,10.925),(42.505,10.925),(42.505,10.755),(42.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.755),(42.695,10.925),(42.865,10.925),(42.865,10.755),(42.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.755),(43.055,10.925),(43.225,10.925),(43.225,10.755),(43.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.115),(41.975,11.285),(42.145,11.285),(42.145,11.115),(41.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.115),(42.335,11.285),(42.505,11.285),(42.505,11.115),(42.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.115),(42.695,11.285),(42.865,11.285),(42.865,11.115),(42.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.115),(43.055,11.285),(43.225,11.285),(43.225,11.115),(43.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.475),(41.975,11.645),(42.145,11.645),(42.145,11.475),(41.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.475),(42.335,11.645),(42.505,11.645),(42.505,11.475),(42.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.475),(42.695,11.645),(42.865,11.645),(42.865,11.475),(42.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.475),(43.055,11.645),(43.225,11.645),(43.225,11.475),(43.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.835),(41.975,12.005),(42.145,12.005),(42.145,11.835),(41.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.835),(42.335,12.005),(42.505,12.005),(42.505,11.835),(42.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.835),(42.695,12.005),(42.865,12.005),(42.865,11.835),(42.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.835),(43.055,12.005),(43.225,12.005),(43.225,11.835),(43.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.195),(41.975,12.365),(42.145,12.365),(42.145,12.195),(41.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.195),(42.335,12.365),(42.505,12.365),(42.505,12.195),(42.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.195),(42.695,12.365),(42.865,12.365),(42.865,12.195),(42.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.195),(43.055,12.365),(43.225,12.365),(43.225,12.195),(43.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.555),(41.975,12.725),(42.145,12.725),(42.145,12.555),(41.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.555),(42.335,12.725),(42.505,12.725),(42.505,12.555),(42.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.555),(42.695,12.725),(42.865,12.725),(42.865,12.555),(42.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.555),(43.055,12.725),(43.225,12.725),(43.225,12.555),(43.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.915),(41.975,13.085),(42.145,13.085),(42.145,12.915),(41.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.915),(42.335,13.085),(42.505,13.085),(42.505,12.915),(42.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.915),(42.695,13.085),(42.865,13.085),(42.865,12.915),(42.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.915),(43.055,13.085),(43.225,13.085),(43.225,12.915),(43.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.275),(41.975,13.445),(42.145,13.445),(42.145,13.275),(41.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.275),(42.335,13.445),(42.505,13.445),(42.505,13.275),(42.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.275),(42.695,13.445),(42.865,13.445),(42.865,13.275),(42.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.275),(43.055,13.445),(43.225,13.445),(43.225,13.275),(43.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.635),(41.975,13.805),(42.145,13.805),(42.145,13.635),(41.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.635),(42.335,13.805),(42.505,13.805),(42.505,13.635),(42.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.635),(42.695,13.805),(42.865,13.805),(42.865,13.635),(42.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.635),(43.055,13.805),(43.225,13.805),(43.225,13.635),(43.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.995),(41.975,14.165),(42.145,14.165),(42.145,13.995),(41.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.995),(42.335,14.165),(42.505,14.165),(42.505,13.995),(42.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.995),(42.695,14.165),(42.865,14.165),(42.865,13.995),(42.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.995),(43.055,14.165),(43.225,14.165),(43.225,13.995),(43.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.355),(41.975,14.525),(42.145,14.525),(42.145,14.355),(41.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.355),(42.335,14.525),(42.505,14.525),(42.505,14.355),(42.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.355),(42.695,14.525),(42.865,14.525),(42.865,14.355),(42.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.355),(43.055,14.525),(43.225,14.525),(43.225,14.355),(43.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.715),(41.975,14.885),(42.145,14.885),(42.145,14.715),(41.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.715),(42.335,14.885),(42.505,14.885),(42.505,14.715),(42.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.715),(42.695,14.885),(42.865,14.885),(42.865,14.715),(42.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.715),(43.055,14.885),(43.225,14.885),(43.225,14.715),(43.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.075),(41.975,15.245),(42.145,15.245),(42.145,15.075),(41.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.075),(42.335,15.245),(42.505,15.245),(42.505,15.075),(42.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.075),(42.695,15.245),(42.865,15.245),(42.865,15.075),(42.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.075),(43.055,15.245),(43.225,15.245),(43.225,15.075),(43.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.435),(41.975,15.605),(42.145,15.605),(42.145,15.435),(41.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.435),(42.335,15.605),(42.505,15.605),(42.505,15.435),(42.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.435),(42.695,15.605),(42.865,15.605),(42.865,15.435),(42.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.435),(43.055,15.605),(43.225,15.605),(43.225,15.435),(43.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.795),(41.975,15.965),(42.145,15.965),(42.145,15.795),(41.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.795),(42.335,15.965),(42.505,15.965),(42.505,15.795),(42.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.795),(42.695,15.965),(42.865,15.965),(42.865,15.795),(42.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.795),(43.055,15.965),(43.225,15.965),(43.225,15.795),(43.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.155),(41.975,16.325),(42.145,16.325),(42.145,16.155),(41.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.155),(42.335,16.325),(42.505,16.325),(42.505,16.155),(42.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.155),(42.695,16.325),(42.865,16.325),(42.865,16.155),(42.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.155),(43.055,16.325),(43.225,16.325),(43.225,16.155),(43.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.515),(41.975,16.685),(42.145,16.685),(42.145,16.515),(41.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.515),(42.335,16.685),(42.505,16.685),(42.505,16.515),(42.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.515),(42.695,16.685),(42.865,16.685),(42.865,16.515),(42.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.515),(43.055,16.685),(43.225,16.685),(43.225,16.515),(43.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.875),(41.975,17.045),(42.145,17.045),(42.145,16.875),(41.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.875),(42.335,17.045),(42.505,17.045),(42.505,16.875),(42.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.875),(42.695,17.045),(42.865,17.045),(42.865,16.875),(42.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.875),(43.055,17.045),(43.225,17.045),(43.225,16.875),(43.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.235),(41.975,17.405),(42.145,17.405),(42.145,17.235),(41.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.235),(42.335,17.405),(42.505,17.405),(42.505,17.235),(42.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.235),(42.695,17.405),(42.865,17.405),(42.865,17.235),(42.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.235),(43.055,17.405),(43.225,17.405),(43.225,17.235),(43.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.595),(41.975,17.765),(42.145,17.765),(42.145,17.595),(41.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.595),(42.335,17.765),(42.505,17.765),(42.505,17.595),(42.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.595),(42.695,17.765),(42.865,17.765),(42.865,17.595),(42.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.595),(43.055,17.765),(43.225,17.765),(43.225,17.595),(43.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.955),(41.975,18.125),(42.145,18.125),(42.145,17.955),(41.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.955),(42.335,18.125),(42.505,18.125),(42.505,17.955),(42.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.955),(42.695,18.125),(42.865,18.125),(42.865,17.955),(42.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.955),(43.055,18.125),(43.225,18.125),(43.225,17.955),(43.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.315),(41.975,18.485),(42.145,18.485),(42.145,18.315),(41.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.315),(42.335,18.485),(42.505,18.485),(42.505,18.315),(42.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.315),(42.695,18.485),(42.865,18.485),(42.865,18.315),(42.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.315),(43.055,18.485),(43.225,18.485),(43.225,18.315),(43.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.675),(41.975,18.845),(42.145,18.845),(42.145,18.675),(41.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.675),(42.335,18.845),(42.505,18.845),(42.505,18.675),(42.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.675),(42.695,18.845),(42.865,18.845),(42.865,18.675),(42.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.675),(43.055,18.845),(43.225,18.845),(43.225,18.675),(43.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.035),(41.975,19.205),(42.145,19.205),(42.145,19.035),(41.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.035),(42.335,19.205),(42.505,19.205),(42.505,19.035),(42.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.035),(42.695,19.205),(42.865,19.205),(42.865,19.035),(42.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.035),(43.055,19.205),(43.225,19.205),(43.225,19.035),(43.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.395),(41.975,19.565),(42.145,19.565),(42.145,19.395),(41.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.395),(42.335,19.565),(42.505,19.565),(42.505,19.395),(42.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.395),(42.695,19.565),(42.865,19.565),(42.865,19.395),(42.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.395),(43.055,19.565),(43.225,19.565),(43.225,19.395),(43.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.755),(41.975,19.925),(42.145,19.925),(42.145,19.755),(41.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.755),(42.335,19.925),(42.505,19.925),(42.505,19.755),(42.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.755),(42.695,19.925),(42.865,19.925),(42.865,19.755),(42.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.755),(43.055,19.925),(43.225,19.925),(43.225,19.755),(43.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.115),(41.975,20.285),(42.145,20.285),(42.145,20.115),(41.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.115),(42.335,20.285),(42.505,20.285),(42.505,20.115),(42.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.115),(42.695,20.285),(42.865,20.285),(42.865,20.115),(42.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.115),(43.055,20.285),(43.225,20.285),(43.225,20.115),(43.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.475),(41.975,20.645),(42.145,20.645),(42.145,20.475),(41.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.475),(42.335,20.645),(42.505,20.645),(42.505,20.475),(42.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.475),(42.695,20.645),(42.865,20.645),(42.865,20.475),(42.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.475),(43.055,20.645),(43.225,20.645),(43.225,20.475),(43.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.835),(41.975,21.005),(42.145,21.005),(42.145,20.835),(41.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.835),(42.335,21.005),(42.505,21.005),(42.505,20.835),(42.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.835),(42.695,21.005),(42.865,21.005),(42.865,20.835),(42.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.835),(43.055,21.005),(43.225,21.005),(43.225,20.835),(43.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.195),(41.975,21.365),(42.145,21.365),(42.145,21.195),(41.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.195),(42.335,21.365),(42.505,21.365),(42.505,21.195),(42.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.195),(42.695,21.365),(42.865,21.365),(42.865,21.195),(42.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.195),(43.055,21.365),(43.225,21.365),(43.225,21.195),(43.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.555),(41.975,21.725),(42.145,21.725),(42.145,21.555),(41.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.555),(42.335,21.725),(42.505,21.725),(42.505,21.555),(42.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.555),(42.695,21.725),(42.865,21.725),(42.865,21.555),(42.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.555),(43.055,21.725),(43.225,21.725),(43.225,21.555),(43.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.915),(41.975,22.085),(42.145,22.085),(42.145,21.915),(41.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.915),(42.335,22.085),(42.505,22.085),(42.505,21.915),(42.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.915),(42.695,22.085),(42.865,22.085),(42.865,21.915),(42.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.915),(43.055,22.085),(43.225,22.085),(43.225,21.915),(43.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.275),(41.975,22.445),(42.145,22.445),(42.145,22.275),(41.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.275),(42.335,22.445),(42.505,22.445),(42.505,22.275),(42.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.275),(42.695,22.445),(42.865,22.445),(42.865,22.275),(42.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.275),(43.055,22.445),(43.225,22.445),(43.225,22.275),(43.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.635),(41.975,22.805),(42.145,22.805),(42.145,22.635),(41.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.635),(42.335,22.805),(42.505,22.805),(42.505,22.635),(42.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.635),(42.695,22.805),(42.865,22.805),(42.865,22.635),(42.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.635),(43.055,22.805),(43.225,22.805),(43.225,22.635),(43.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.995),(41.975,23.165),(42.145,23.165),(42.145,22.995),(41.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.995),(42.335,23.165),(42.505,23.165),(42.505,22.995),(42.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.995),(42.695,23.165),(42.865,23.165),(42.865,22.995),(42.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.995),(43.055,23.165),(43.225,23.165),(43.225,22.995),(43.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,23.355),(41.975,23.525),(42.145,23.525),(42.145,23.355),(41.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,23.355),(42.335,23.525),(42.505,23.525),(42.505,23.355),(42.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,23.355),(42.695,23.525),(42.865,23.525),(42.865,23.355),(42.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,23.355),(43.055,23.525),(43.225,23.525),(43.225,23.355),(43.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,23.715),(41.975,23.885),(42.145,23.885),(42.145,23.715),(41.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,23.715),(42.335,23.885),(42.505,23.885),(42.505,23.715),(42.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,23.715),(42.695,23.885),(42.865,23.885),(42.865,23.715),(42.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,23.715),(43.055,23.885),(43.225,23.885),(43.225,23.715),(43.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.075),(41.975,24.245),(42.145,24.245),(42.145,24.075),(41.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.075),(42.335,24.245),(42.505,24.245),(42.505,24.075),(42.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.075),(42.695,24.245),(42.865,24.245),(42.865,24.075),(42.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.075),(43.055,24.245),(43.225,24.245),(43.225,24.075),(43.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.435),(41.975,24.605),(42.145,24.605),(42.145,24.435),(41.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.435),(42.335,24.605),(42.505,24.605),(42.505,24.435),(42.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.435),(42.695,24.605),(42.865,24.605),(42.865,24.435),(42.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.435),(43.055,24.605),(43.225,24.605),(43.225,24.435),(43.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.795),(41.975,24.965),(42.145,24.965),(42.145,24.795),(41.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.795),(42.335,24.965),(42.505,24.965),(42.505,24.795),(42.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.795),(42.695,24.965),(42.865,24.965),(42.865,24.795),(42.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.795),(43.055,24.965),(43.225,24.965),(43.225,24.795),(43.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.155),(41.975,25.325),(42.145,25.325),(42.145,25.155),(41.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.155),(42.335,25.325),(42.505,25.325),(42.505,25.155),(42.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.155),(42.695,25.325),(42.865,25.325),(42.865,25.155),(42.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.155),(43.055,25.325),(43.225,25.325),(43.225,25.155),(43.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.515),(41.975,25.685),(42.145,25.685),(42.145,25.515),(41.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.515),(42.335,25.685),(42.505,25.685),(42.505,25.515),(42.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.515),(42.695,25.685),(42.865,25.685),(42.865,25.515),(42.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.515),(43.055,25.685),(43.225,25.685),(43.225,25.515),(43.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.875),(41.975,26.045),(42.145,26.045),(42.145,25.875),(41.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.875),(42.335,26.045),(42.505,26.045),(42.505,25.875),(42.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.875),(42.695,26.045),(42.865,26.045),(42.865,25.875),(42.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.875),(43.055,26.045),(43.225,26.045),(43.225,25.875),(43.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.235),(41.975,26.405),(42.145,26.405),(42.145,26.235),(41.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.235),(42.335,26.405),(42.505,26.405),(42.505,26.235),(42.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.235),(42.695,26.405),(42.865,26.405),(42.865,26.235),(42.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.235),(43.055,26.405),(43.225,26.405),(43.225,26.235),(43.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.595),(41.975,26.765),(42.145,26.765),(42.145,26.595),(41.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.595),(42.335,26.765),(42.505,26.765),(42.505,26.595),(42.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.595),(42.695,26.765),(42.865,26.765),(42.865,26.595),(42.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.595),(43.055,26.765),(43.225,26.765),(43.225,26.595),(43.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.955),(41.975,27.125),(42.145,27.125),(42.145,26.955),(41.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.955),(42.335,27.125),(42.505,27.125),(42.505,26.955),(42.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.955),(42.695,27.125),(42.865,27.125),(42.865,26.955),(42.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.955),(43.055,27.125),(43.225,27.125),(43.225,26.955),(43.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,27.315),(41.975,27.485),(42.145,27.485),(42.145,27.315),(41.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,27.315),(42.335,27.485),(42.505,27.485),(42.505,27.315),(42.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,27.315),(42.695,27.485),(42.865,27.485),(42.865,27.315),(42.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,27.315),(43.055,27.485),(43.225,27.485),(43.225,27.315),(43.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,27.675),(41.975,27.845),(42.145,27.845),(42.145,27.675),(41.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,27.675),(42.335,27.845),(42.505,27.845),(42.505,27.675),(42.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,27.675),(42.695,27.845),(42.865,27.845),(42.865,27.675),(42.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,27.675),(43.055,27.845),(43.225,27.845),(43.225,27.675),(43.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.035),(41.975,28.205),(42.145,28.205),(42.145,28.035),(41.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.035),(42.335,28.205),(42.505,28.205),(42.505,28.035),(42.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.035),(42.695,28.205),(42.865,28.205),(42.865,28.035),(42.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.035),(43.055,28.205),(43.225,28.205),(43.225,28.035),(43.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.395),(41.975,28.565),(42.145,28.565),(42.145,28.395),(41.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.395),(42.335,28.565),(42.505,28.565),(42.505,28.395),(42.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.395),(42.695,28.565),(42.865,28.565),(42.865,28.395),(42.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.395),(43.055,28.565),(43.225,28.565),(43.225,28.395),(43.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.755),(41.975,28.925),(42.145,28.925),(42.145,28.755),(41.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.755),(42.335,28.925),(42.505,28.925),(42.505,28.755),(42.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.755),(42.695,28.925),(42.865,28.925),(42.865,28.755),(42.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.755),(43.055,28.925),(43.225,28.925),(43.225,28.755),(43.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.115),(41.975,29.285),(42.145,29.285),(42.145,29.115),(41.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.115),(42.335,29.285),(42.505,29.285),(42.505,29.115),(42.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.115),(42.695,29.285),(42.865,29.285),(42.865,29.115),(42.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.115),(43.055,29.285),(43.225,29.285),(43.225,29.115),(43.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.475),(41.975,29.645),(42.145,29.645),(42.145,29.475),(41.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.475),(42.335,29.645),(42.505,29.645),(42.505,29.475),(42.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.475),(42.695,29.645),(42.865,29.645),(42.865,29.475),(42.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.475),(43.055,29.645),(43.225,29.645),(43.225,29.475),(43.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.835),(41.975,30.005),(42.145,30.005),(42.145,29.835),(41.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.835),(42.335,30.005),(42.505,30.005),(42.505,29.835),(42.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.835),(42.695,30.005),(42.865,30.005),(42.865,29.835),(42.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.835),(43.055,30.005),(43.225,30.005),(43.225,29.835),(43.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.195),(41.975,30.365),(42.145,30.365),(42.145,30.195),(41.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.195),(42.335,30.365),(42.505,30.365),(42.505,30.195),(42.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.195),(42.695,30.365),(42.865,30.365),(42.865,30.195),(42.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.195),(43.055,30.365),(43.225,30.365),(43.225,30.195),(43.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.555),(41.975,30.725),(42.145,30.725),(42.145,30.555),(41.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.555),(42.335,30.725),(42.505,30.725),(42.505,30.555),(42.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.555),(42.695,30.725),(42.865,30.725),(42.865,30.555),(42.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.555),(43.055,30.725),(43.225,30.725),(43.225,30.555),(43.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.915),(41.975,31.085),(42.145,31.085),(42.145,30.915),(41.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.915),(42.335,31.085),(42.505,31.085),(42.505,30.915),(42.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.915),(42.695,31.085),(42.865,31.085),(42.865,30.915),(42.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.915),(43.055,31.085),(43.225,31.085),(43.225,30.915),(43.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.275),(41.975,31.445),(42.145,31.445),(42.145,31.275),(41.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.275),(42.335,31.445),(42.505,31.445),(42.505,31.275),(42.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.275),(42.695,31.445),(42.865,31.445),(42.865,31.275),(42.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.275),(43.055,31.445),(43.225,31.445),(43.225,31.275),(43.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.635),(41.975,31.805),(42.145,31.805),(42.145,31.635),(41.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.635),(42.335,31.805),(42.505,31.805),(42.505,31.635),(42.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.635),(42.695,31.805),(42.865,31.805),(42.865,31.635),(42.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.635),(43.055,31.805),(43.225,31.805),(43.225,31.635),(43.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.995),(41.975,32.165),(42.145,32.165),(42.145,31.995),(41.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.995),(42.335,32.165),(42.505,32.165),(42.505,31.995),(42.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.995),(42.695,32.165),(42.865,32.165),(42.865,31.995),(42.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.995),(43.055,32.165),(43.225,32.165),(43.225,31.995),(43.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,32.355),(41.975,32.525),(42.145,32.525),(42.145,32.355),(41.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,32.355),(42.335,32.525),(42.505,32.525),(42.505,32.355),(42.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,32.355),(42.695,32.525),(42.865,32.525),(42.865,32.355),(42.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,32.355),(43.055,32.525),(43.225,32.525),(43.225,32.355),(43.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,32.715),(41.975,32.885),(42.145,32.885),(42.145,32.715),(41.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,32.715),(42.335,32.885),(42.505,32.885),(42.505,32.715),(42.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,32.715),(42.695,32.885),(42.865,32.885),(42.865,32.715),(42.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,32.715),(43.055,32.885),(43.225,32.885),(43.225,32.715),(43.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.075),(41.975,33.245),(42.145,33.245),(42.145,33.075),(41.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.075),(42.335,33.245),(42.505,33.245),(42.505,33.075),(42.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.075),(42.695,33.245),(42.865,33.245),(42.865,33.075),(42.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.075),(43.055,33.245),(43.225,33.245),(43.225,33.075),(43.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.435),(41.975,33.605),(42.145,33.605),(42.145,33.435),(41.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.435),(42.335,33.605),(42.505,33.605),(42.505,33.435),(42.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.435),(42.695,33.605),(42.865,33.605),(42.865,33.435),(42.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.435),(43.055,33.605),(43.225,33.605),(43.225,33.435),(43.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.795),(41.975,33.965),(42.145,33.965),(42.145,33.795),(41.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.795),(42.335,33.965),(42.505,33.965),(42.505,33.795),(42.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.795),(42.695,33.965),(42.865,33.965),(42.865,33.795),(42.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.795),(43.055,33.965),(43.225,33.965),(43.225,33.795),(43.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.155),(41.975,34.325),(42.145,34.325),(42.145,34.155),(41.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.155),(42.335,34.325),(42.505,34.325),(42.505,34.155),(42.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.155),(42.695,34.325),(42.865,34.325),(42.865,34.155),(42.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.155),(43.055,34.325),(43.225,34.325),(43.225,34.155),(43.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.515),(41.975,34.685),(42.145,34.685),(42.145,34.515),(41.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.515),(42.335,34.685),(42.505,34.685),(42.505,34.515),(42.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.515),(42.695,34.685),(42.865,34.685),(42.865,34.515),(42.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.515),(43.055,34.685),(43.225,34.685),(43.225,34.515),(43.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.875),(41.975,35.045),(42.145,35.045),(42.145,34.875),(41.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.875),(42.335,35.045),(42.505,35.045),(42.505,34.875),(42.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.875),(42.695,35.045),(42.865,35.045),(42.865,34.875),(42.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.875),(43.055,35.045),(43.225,35.045),(43.225,34.875),(43.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.235),(41.975,35.405),(42.145,35.405),(42.145,35.235),(41.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.235),(42.335,35.405),(42.505,35.405),(42.505,35.235),(42.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.235),(42.695,35.405),(42.865,35.405),(42.865,35.235),(42.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.235),(43.055,35.405),(43.225,35.405),(43.225,35.235),(43.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.595),(41.975,35.765),(42.145,35.765),(42.145,35.595),(41.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.595),(42.335,35.765),(42.505,35.765),(42.505,35.595),(42.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.595),(42.695,35.765),(42.865,35.765),(42.865,35.595),(42.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.595),(43.055,35.765),(43.225,35.765),(43.225,35.595),(43.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.955),(41.975,36.125),(42.145,36.125),(42.145,35.955),(41.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.955),(42.335,36.125),(42.505,36.125),(42.505,35.955),(42.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.955),(42.695,36.125),(42.865,36.125),(42.865,35.955),(42.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.955),(43.055,36.125),(43.225,36.125),(43.225,35.955),(43.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,36.315),(41.975,36.485),(42.145,36.485),(42.145,36.315),(41.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,36.315),(42.335,36.485),(42.505,36.485),(42.505,36.315),(42.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,36.315),(42.695,36.485),(42.865,36.485),(42.865,36.315),(42.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,36.315),(43.055,36.485),(43.225,36.485),(43.225,36.315),(43.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,36.675),(41.975,36.845),(42.145,36.845),(42.145,36.675),(41.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,36.675),(42.335,36.845),(42.505,36.845),(42.505,36.675),(42.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,36.675),(42.695,36.845),(42.865,36.845),(42.865,36.675),(42.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,36.675),(43.055,36.845),(43.225,36.845),(43.225,36.675),(43.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.035),(41.975,37.205),(42.145,37.205),(42.145,37.035),(41.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.035),(42.335,37.205),(42.505,37.205),(42.505,37.035),(42.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.035),(42.695,37.205),(42.865,37.205),(42.865,37.035),(42.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.035),(43.055,37.205),(43.225,37.205),(43.225,37.035),(43.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.395),(41.975,37.565),(42.145,37.565),(42.145,37.395),(41.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.395),(42.335,37.565),(42.505,37.565),(42.505,37.395),(42.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.395),(42.695,37.565),(42.865,37.565),(42.865,37.395),(42.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.395),(43.055,37.565),(43.225,37.565),(43.225,37.395),(43.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.755),(41.975,37.925),(42.145,37.925),(42.145,37.755),(41.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.755),(42.335,37.925),(42.505,37.925),(42.505,37.755),(42.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.755),(42.695,37.925),(42.865,37.925),(42.865,37.755),(42.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.755),(43.055,37.925),(43.225,37.925),(43.225,37.755),(43.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.115),(41.975,38.285),(42.145,38.285),(42.145,38.115),(41.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.115),(42.335,38.285),(42.505,38.285),(42.505,38.115),(42.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.115),(42.695,38.285),(42.865,38.285),(42.865,38.115),(42.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.115),(43.055,38.285),(43.225,38.285),(43.225,38.115),(43.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.475),(41.975,38.645),(42.145,38.645),(42.145,38.475),(41.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.475),(42.335,38.645),(42.505,38.645),(42.505,38.475),(42.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.475),(42.695,38.645),(42.865,38.645),(42.865,38.475),(42.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.475),(43.055,38.645),(43.225,38.645),(43.225,38.475),(43.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.835),(41.975,39.005),(42.145,39.005),(42.145,38.835),(41.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.835),(42.335,39.005),(42.505,39.005),(42.505,38.835),(42.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.835),(42.695,39.005),(42.865,39.005),(42.865,38.835),(42.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.835),(43.055,39.005),(43.225,39.005),(43.225,38.835),(43.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.195),(41.975,39.365),(42.145,39.365),(42.145,39.195),(41.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.195),(42.335,39.365),(42.505,39.365),(42.505,39.195),(42.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.195),(42.695,39.365),(42.865,39.365),(42.865,39.195),(42.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.195),(43.055,39.365),(43.225,39.365),(43.225,39.195),(43.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.555),(41.975,39.725),(42.145,39.725),(42.145,39.555),(41.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.555),(42.335,39.725),(42.505,39.725),(42.505,39.555),(42.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.555),(42.695,39.725),(42.865,39.725),(42.865,39.555),(42.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.555),(43.055,39.725),(43.225,39.725),(43.225,39.555),(43.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.915),(41.975,40.085),(42.145,40.085),(42.145,39.915),(41.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.915),(42.335,40.085),(42.505,40.085),(42.505,39.915),(42.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.915),(42.695,40.085),(42.865,40.085),(42.865,39.915),(42.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.915),(43.055,40.085),(43.225,40.085),(43.225,39.915),(43.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,40.275),(41.975,40.445),(42.145,40.445),(42.145,40.275),(41.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,40.275),(42.335,40.445),(42.505,40.445),(42.505,40.275),(42.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,40.275),(42.695,40.445),(42.865,40.445),(42.865,40.275),(42.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,40.275),(43.055,40.445),(43.225,40.445),(43.225,40.275),(43.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,40.635),(41.975,40.805),(42.145,40.805),(42.145,40.635),(41.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,40.635),(42.335,40.805),(42.505,40.805),(42.505,40.635),(42.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,40.635),(42.695,40.805),(42.865,40.805),(42.865,40.635),(42.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,40.635),(43.055,40.805),(43.225,40.805),(43.225,40.635),(43.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,2.835),(70.775,3.005),(70.945,3.005),(70.945,2.835),(70.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,2.835),(71.135,3.005),(71.305,3.005),(71.305,2.835),(71.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,2.835),(71.495,3.005),(71.665,3.005),(71.665,2.835),(71.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,2.835),(71.855,3.005),(72.025,3.005),(72.025,2.835),(71.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.195),(70.775,3.365),(70.945,3.365),(70.945,3.195),(70.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.195),(71.135,3.365),(71.305,3.365),(71.305,3.195),(71.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.195),(71.495,3.365),(71.665,3.365),(71.665,3.195),(71.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.195),(71.855,3.365),(72.025,3.365),(72.025,3.195),(71.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.555),(70.775,3.725),(70.945,3.725),(70.945,3.555),(70.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.555),(71.135,3.725),(71.305,3.725),(71.305,3.555),(71.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.555),(71.495,3.725),(71.665,3.725),(71.665,3.555),(71.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.555),(71.855,3.725),(72.025,3.725),(72.025,3.555),(71.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.915),(70.775,4.085),(70.945,4.085),(70.945,3.915),(70.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.915),(71.135,4.085),(71.305,4.085),(71.305,3.915),(71.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.915),(71.495,4.085),(71.665,4.085),(71.665,3.915),(71.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.915),(71.855,4.085),(72.025,4.085),(72.025,3.915),(71.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.275),(70.775,4.445),(70.945,4.445),(70.945,4.275),(70.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.275),(71.135,4.445),(71.305,4.445),(71.305,4.275),(71.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.275),(71.495,4.445),(71.665,4.445),(71.665,4.275),(71.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.275),(71.855,4.445),(72.025,4.445),(72.025,4.275),(71.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.635),(70.775,4.805),(70.945,4.805),(70.945,4.635),(70.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.635),(71.135,4.805),(71.305,4.805),(71.305,4.635),(71.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.635),(71.495,4.805),(71.665,4.805),(71.665,4.635),(71.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.635),(71.855,4.805),(72.025,4.805),(72.025,4.635),(71.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.995),(70.775,5.165),(70.945,5.165),(70.945,4.995),(70.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.995),(71.135,5.165),(71.305,5.165),(71.305,4.995),(71.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.995),(71.495,5.165),(71.665,5.165),(71.665,4.995),(71.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.995),(71.855,5.165),(72.025,5.165),(72.025,4.995),(71.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.355),(70.775,5.525),(70.945,5.525),(70.945,5.355),(70.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.355),(71.135,5.525),(71.305,5.525),(71.305,5.355),(71.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.355),(71.495,5.525),(71.665,5.525),(71.665,5.355),(71.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.355),(71.855,5.525),(72.025,5.525),(72.025,5.355),(71.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.715),(70.775,5.885),(70.945,5.885),(70.945,5.715),(70.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.715),(71.135,5.885),(71.305,5.885),(71.305,5.715),(71.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.715),(71.495,5.885),(71.665,5.885),(71.665,5.715),(71.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.715),(71.855,5.885),(72.025,5.885),(72.025,5.715),(71.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.075),(70.775,6.245),(70.945,6.245),(70.945,6.075),(70.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.075),(71.135,6.245),(71.305,6.245),(71.305,6.075),(71.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.075),(71.495,6.245),(71.665,6.245),(71.665,6.075),(71.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.075),(71.855,6.245),(72.025,6.245),(72.025,6.075),(71.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.435),(70.775,6.605),(70.945,6.605),(70.945,6.435),(70.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.435),(71.135,6.605),(71.305,6.605),(71.305,6.435),(71.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.435),(71.495,6.605),(71.665,6.605),(71.665,6.435),(71.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.435),(71.855,6.605),(72.025,6.605),(72.025,6.435),(71.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.795),(70.775,6.965),(70.945,6.965),(70.945,6.795),(70.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.795),(71.135,6.965),(71.305,6.965),(71.305,6.795),(71.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.795),(71.495,6.965),(71.665,6.965),(71.665,6.795),(71.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.795),(71.855,6.965),(72.025,6.965),(72.025,6.795),(71.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.155),(70.775,7.325),(70.945,7.325),(70.945,7.155),(70.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.155),(71.135,7.325),(71.305,7.325),(71.305,7.155),(71.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.155),(71.495,7.325),(71.665,7.325),(71.665,7.155),(71.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.155),(71.855,7.325),(72.025,7.325),(72.025,7.155),(71.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.515),(70.775,7.685),(70.945,7.685),(70.945,7.515),(70.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.515),(71.135,7.685),(71.305,7.685),(71.305,7.515),(71.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.515),(71.495,7.685),(71.665,7.685),(71.665,7.515),(71.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.515),(71.855,7.685),(72.025,7.685),(72.025,7.515),(71.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.875),(70.775,8.045),(70.945,8.045),(70.945,7.875),(70.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.875),(71.135,8.045),(71.305,8.045),(71.305,7.875),(71.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.875),(71.495,8.045),(71.665,8.045),(71.665,7.875),(71.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.875),(71.855,8.045),(72.025,8.045),(72.025,7.875),(71.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.235),(70.775,8.405),(70.945,8.405),(70.945,8.235),(70.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.235),(71.135,8.405),(71.305,8.405),(71.305,8.235),(71.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.235),(71.495,8.405),(71.665,8.405),(71.665,8.235),(71.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.235),(71.855,8.405),(72.025,8.405),(72.025,8.235),(71.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.595),(70.775,8.765),(70.945,8.765),(70.945,8.595),(70.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.595),(71.135,8.765),(71.305,8.765),(71.305,8.595),(71.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.595),(71.495,8.765),(71.665,8.765),(71.665,8.595),(71.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.595),(71.855,8.765),(72.025,8.765),(72.025,8.595),(71.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.955),(70.775,9.125),(70.945,9.125),(70.945,8.955),(70.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.955),(71.135,9.125),(71.305,9.125),(71.305,8.955),(71.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.955),(71.495,9.125),(71.665,9.125),(71.665,8.955),(71.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.955),(71.855,9.125),(72.025,9.125),(72.025,8.955),(71.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.315),(70.775,9.485),(70.945,9.485),(70.945,9.315),(70.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.315),(71.135,9.485),(71.305,9.485),(71.305,9.315),(71.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.315),(71.495,9.485),(71.665,9.485),(71.665,9.315),(71.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.315),(71.855,9.485),(72.025,9.485),(72.025,9.315),(71.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.675),(70.775,9.845),(70.945,9.845),(70.945,9.675),(70.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.675),(71.135,9.845),(71.305,9.845),(71.305,9.675),(71.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.675),(71.495,9.845),(71.665,9.845),(71.665,9.675),(71.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.675),(71.855,9.845),(72.025,9.845),(72.025,9.675),(71.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.035),(70.775,10.205),(70.945,10.205),(70.945,10.035),(70.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.035),(71.135,10.205),(71.305,10.205),(71.305,10.035),(71.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.035),(71.495,10.205),(71.665,10.205),(71.665,10.035),(71.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.035),(71.855,10.205),(72.025,10.205),(72.025,10.035),(71.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.395),(70.775,10.565),(70.945,10.565),(70.945,10.395),(70.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.395),(71.135,10.565),(71.305,10.565),(71.305,10.395),(71.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.395),(71.495,10.565),(71.665,10.565),(71.665,10.395),(71.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.395),(71.855,10.565),(72.025,10.565),(72.025,10.395),(71.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.755),(70.775,10.925),(70.945,10.925),(70.945,10.755),(70.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.755),(71.135,10.925),(71.305,10.925),(71.305,10.755),(71.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.755),(71.495,10.925),(71.665,10.925),(71.665,10.755),(71.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.755),(71.855,10.925),(72.025,10.925),(72.025,10.755),(71.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.115),(70.775,11.285),(70.945,11.285),(70.945,11.115),(70.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.115),(71.135,11.285),(71.305,11.285),(71.305,11.115),(71.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.115),(71.495,11.285),(71.665,11.285),(71.665,11.115),(71.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.115),(71.855,11.285),(72.025,11.285),(72.025,11.115),(71.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.475),(70.775,11.645),(70.945,11.645),(70.945,11.475),(70.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.475),(71.135,11.645),(71.305,11.645),(71.305,11.475),(71.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.475),(71.495,11.645),(71.665,11.645),(71.665,11.475),(71.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.475),(71.855,11.645),(72.025,11.645),(72.025,11.475),(71.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.835),(70.775,12.005),(70.945,12.005),(70.945,11.835),(70.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.835),(71.135,12.005),(71.305,12.005),(71.305,11.835),(71.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.835),(71.495,12.005),(71.665,12.005),(71.665,11.835),(71.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.835),(71.855,12.005),(72.025,12.005),(72.025,11.835),(71.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.195),(70.775,12.365),(70.945,12.365),(70.945,12.195),(70.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.195),(71.135,12.365),(71.305,12.365),(71.305,12.195),(71.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.195),(71.495,12.365),(71.665,12.365),(71.665,12.195),(71.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.195),(71.855,12.365),(72.025,12.365),(72.025,12.195),(71.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.555),(70.775,12.725),(70.945,12.725),(70.945,12.555),(70.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.555),(71.135,12.725),(71.305,12.725),(71.305,12.555),(71.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.555),(71.495,12.725),(71.665,12.725),(71.665,12.555),(71.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.555),(71.855,12.725),(72.025,12.725),(72.025,12.555),(71.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.915),(70.775,13.085),(70.945,13.085),(70.945,12.915),(70.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.915),(71.135,13.085),(71.305,13.085),(71.305,12.915),(71.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.915),(71.495,13.085),(71.665,13.085),(71.665,12.915),(71.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.915),(71.855,13.085),(72.025,13.085),(72.025,12.915),(71.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.275),(70.775,13.445),(70.945,13.445),(70.945,13.275),(70.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.275),(71.135,13.445),(71.305,13.445),(71.305,13.275),(71.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.275),(71.495,13.445),(71.665,13.445),(71.665,13.275),(71.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.275),(71.855,13.445),(72.025,13.445),(72.025,13.275),(71.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.635),(70.775,13.805),(70.945,13.805),(70.945,13.635),(70.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.635),(71.135,13.805),(71.305,13.805),(71.305,13.635),(71.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.635),(71.495,13.805),(71.665,13.805),(71.665,13.635),(71.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.635),(71.855,13.805),(72.025,13.805),(72.025,13.635),(71.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.995),(70.775,14.165),(70.945,14.165),(70.945,13.995),(70.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.995),(71.135,14.165),(71.305,14.165),(71.305,13.995),(71.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.995),(71.495,14.165),(71.665,14.165),(71.665,13.995),(71.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.995),(71.855,14.165),(72.025,14.165),(72.025,13.995),(71.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.355),(70.775,14.525),(70.945,14.525),(70.945,14.355),(70.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.355),(71.135,14.525),(71.305,14.525),(71.305,14.355),(71.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.355),(71.495,14.525),(71.665,14.525),(71.665,14.355),(71.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.355),(71.855,14.525),(72.025,14.525),(72.025,14.355),(71.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.715),(70.775,14.885),(70.945,14.885),(70.945,14.715),(70.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.715),(71.135,14.885),(71.305,14.885),(71.305,14.715),(71.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.715),(71.495,14.885),(71.665,14.885),(71.665,14.715),(71.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.715),(71.855,14.885),(72.025,14.885),(72.025,14.715),(71.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.075),(70.775,15.245),(70.945,15.245),(70.945,15.075),(70.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.075),(71.135,15.245),(71.305,15.245),(71.305,15.075),(71.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.075),(71.495,15.245),(71.665,15.245),(71.665,15.075),(71.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.075),(71.855,15.245),(72.025,15.245),(72.025,15.075),(71.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.435),(70.775,15.605),(70.945,15.605),(70.945,15.435),(70.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.435),(71.135,15.605),(71.305,15.605),(71.305,15.435),(71.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.435),(71.495,15.605),(71.665,15.605),(71.665,15.435),(71.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.435),(71.855,15.605),(72.025,15.605),(72.025,15.435),(71.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.795),(70.775,15.965),(70.945,15.965),(70.945,15.795),(70.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.795),(71.135,15.965),(71.305,15.965),(71.305,15.795),(71.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.795),(71.495,15.965),(71.665,15.965),(71.665,15.795),(71.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.795),(71.855,15.965),(72.025,15.965),(72.025,15.795),(71.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.155),(70.775,16.325),(70.945,16.325),(70.945,16.155),(70.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.155),(71.135,16.325),(71.305,16.325),(71.305,16.155),(71.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.155),(71.495,16.325),(71.665,16.325),(71.665,16.155),(71.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.155),(71.855,16.325),(72.025,16.325),(72.025,16.155),(71.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.515),(70.775,16.685),(70.945,16.685),(70.945,16.515),(70.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.515),(71.135,16.685),(71.305,16.685),(71.305,16.515),(71.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.515),(71.495,16.685),(71.665,16.685),(71.665,16.515),(71.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.515),(71.855,16.685),(72.025,16.685),(72.025,16.515),(71.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.875),(70.775,17.045),(70.945,17.045),(70.945,16.875),(70.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.875),(71.135,17.045),(71.305,17.045),(71.305,16.875),(71.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.875),(71.495,17.045),(71.665,17.045),(71.665,16.875),(71.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.875),(71.855,17.045),(72.025,17.045),(72.025,16.875),(71.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.235),(70.775,17.405),(70.945,17.405),(70.945,17.235),(70.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.235),(71.135,17.405),(71.305,17.405),(71.305,17.235),(71.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.235),(71.495,17.405),(71.665,17.405),(71.665,17.235),(71.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.235),(71.855,17.405),(72.025,17.405),(72.025,17.235),(71.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.595),(70.775,17.765),(70.945,17.765),(70.945,17.595),(70.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.595),(71.135,17.765),(71.305,17.765),(71.305,17.595),(71.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.595),(71.495,17.765),(71.665,17.765),(71.665,17.595),(71.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.595),(71.855,17.765),(72.025,17.765),(72.025,17.595),(71.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.955),(70.775,18.125),(70.945,18.125),(70.945,17.955),(70.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.955),(71.135,18.125),(71.305,18.125),(71.305,17.955),(71.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.955),(71.495,18.125),(71.665,18.125),(71.665,17.955),(71.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.955),(71.855,18.125),(72.025,18.125),(72.025,17.955),(71.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.315),(70.775,18.485),(70.945,18.485),(70.945,18.315),(70.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.315),(71.135,18.485),(71.305,18.485),(71.305,18.315),(71.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.315),(71.495,18.485),(71.665,18.485),(71.665,18.315),(71.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.315),(71.855,18.485),(72.025,18.485),(72.025,18.315),(71.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.675),(70.775,18.845),(70.945,18.845),(70.945,18.675),(70.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.675),(71.135,18.845),(71.305,18.845),(71.305,18.675),(71.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.675),(71.495,18.845),(71.665,18.845),(71.665,18.675),(71.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.675),(71.855,18.845),(72.025,18.845),(72.025,18.675),(71.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.035),(70.775,19.205),(70.945,19.205),(70.945,19.035),(70.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.035),(71.135,19.205),(71.305,19.205),(71.305,19.035),(71.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.035),(71.495,19.205),(71.665,19.205),(71.665,19.035),(71.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.035),(71.855,19.205),(72.025,19.205),(72.025,19.035),(71.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.395),(70.775,19.565),(70.945,19.565),(70.945,19.395),(70.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.395),(71.135,19.565),(71.305,19.565),(71.305,19.395),(71.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.395),(71.495,19.565),(71.665,19.565),(71.665,19.395),(71.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.395),(71.855,19.565),(72.025,19.565),(72.025,19.395),(71.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.755),(70.775,19.925),(70.945,19.925),(70.945,19.755),(70.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.755),(71.135,19.925),(71.305,19.925),(71.305,19.755),(71.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.755),(71.495,19.925),(71.665,19.925),(71.665,19.755),(71.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.755),(71.855,19.925),(72.025,19.925),(72.025,19.755),(71.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,20.115),(70.775,20.285),(70.945,20.285),(70.945,20.115),(70.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,20.115),(71.135,20.285),(71.305,20.285),(71.305,20.115),(71.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,20.115),(71.495,20.285),(71.665,20.285),(71.665,20.115),(71.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,20.115),(71.855,20.285),(72.025,20.285),(72.025,20.115),(71.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,20.475),(70.775,20.645),(70.945,20.645),(70.945,20.475),(70.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,20.475),(71.135,20.645),(71.305,20.645),(71.305,20.475),(71.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,20.475),(71.495,20.645),(71.665,20.645),(71.665,20.475),(71.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,20.475),(71.855,20.645),(72.025,20.645),(72.025,20.475),(71.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,20.835),(70.775,21.005),(70.945,21.005),(70.945,20.835),(70.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,20.835),(71.135,21.005),(71.305,21.005),(71.305,20.835),(71.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,20.835),(71.495,21.005),(71.665,21.005),(71.665,20.835),(71.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,20.835),(71.855,21.005),(72.025,21.005),(72.025,20.835),(71.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,21.195),(70.775,21.365),(70.945,21.365),(70.945,21.195),(70.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,21.195),(71.135,21.365),(71.305,21.365),(71.305,21.195),(71.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,21.195),(71.495,21.365),(71.665,21.365),(71.665,21.195),(71.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,21.195),(71.855,21.365),(72.025,21.365),(72.025,21.195),(71.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,21.555),(70.775,21.725),(70.945,21.725),(70.945,21.555),(70.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,21.555),(71.135,21.725),(71.305,21.725),(71.305,21.555),(71.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,21.555),(71.495,21.725),(71.665,21.725),(71.665,21.555),(71.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,21.555),(71.855,21.725),(72.025,21.725),(72.025,21.555),(71.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,21.915),(70.775,22.085),(70.945,22.085),(70.945,21.915),(70.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,21.915),(71.135,22.085),(71.305,22.085),(71.305,21.915),(71.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,21.915),(71.495,22.085),(71.665,22.085),(71.665,21.915),(71.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,21.915),(71.855,22.085),(72.025,22.085),(72.025,21.915),(71.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.275),(70.775,22.445),(70.945,22.445),(70.945,22.275),(70.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.275),(71.135,22.445),(71.305,22.445),(71.305,22.275),(71.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.275),(71.495,22.445),(71.665,22.445),(71.665,22.275),(71.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.275),(71.855,22.445),(72.025,22.445),(72.025,22.275),(71.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.635),(70.775,22.805),(70.945,22.805),(70.945,22.635),(70.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.635),(71.135,22.805),(71.305,22.805),(71.305,22.635),(71.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.635),(71.495,22.805),(71.665,22.805),(71.665,22.635),(71.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.635),(71.855,22.805),(72.025,22.805),(72.025,22.635),(71.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.995),(70.775,23.165),(70.945,23.165),(70.945,22.995),(70.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.995),(71.135,23.165),(71.305,23.165),(71.305,22.995),(71.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.995),(71.495,23.165),(71.665,23.165),(71.665,22.995),(71.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.995),(71.855,23.165),(72.025,23.165),(72.025,22.995),(71.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,23.355),(70.775,23.525),(70.945,23.525),(70.945,23.355),(70.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,23.355),(71.135,23.525),(71.305,23.525),(71.305,23.355),(71.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,23.355),(71.495,23.525),(71.665,23.525),(71.665,23.355),(71.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,23.355),(71.855,23.525),(72.025,23.525),(72.025,23.355),(71.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,23.715),(70.775,23.885),(70.945,23.885),(70.945,23.715),(70.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,23.715),(71.135,23.885),(71.305,23.885),(71.305,23.715),(71.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,23.715),(71.495,23.885),(71.665,23.885),(71.665,23.715),(71.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,23.715),(71.855,23.885),(72.025,23.885),(72.025,23.715),(71.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,24.075),(70.775,24.245),(70.945,24.245),(70.945,24.075),(70.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,24.075),(71.135,24.245),(71.305,24.245),(71.305,24.075),(71.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,24.075),(71.495,24.245),(71.665,24.245),(71.665,24.075),(71.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,24.075),(71.855,24.245),(72.025,24.245),(72.025,24.075),(71.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,24.435),(70.775,24.605),(70.945,24.605),(70.945,24.435),(70.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,24.435),(71.135,24.605),(71.305,24.605),(71.305,24.435),(71.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,24.435),(71.495,24.605),(71.665,24.605),(71.665,24.435),(71.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,24.435),(71.855,24.605),(72.025,24.605),(72.025,24.435),(71.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,24.795),(70.775,24.965),(70.945,24.965),(70.945,24.795),(70.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,24.795),(71.135,24.965),(71.305,24.965),(71.305,24.795),(71.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,24.795),(71.495,24.965),(71.665,24.965),(71.665,24.795),(71.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,24.795),(71.855,24.965),(72.025,24.965),(72.025,24.795),(71.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,25.155),(70.775,25.325),(70.945,25.325),(70.945,25.155),(70.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,25.155),(71.135,25.325),(71.305,25.325),(71.305,25.155),(71.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,25.155),(71.495,25.325),(71.665,25.325),(71.665,25.155),(71.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,25.155),(71.855,25.325),(72.025,25.325),(72.025,25.155),(71.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,25.515),(70.775,25.685),(70.945,25.685),(70.945,25.515),(70.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,25.515),(71.135,25.685),(71.305,25.685),(71.305,25.515),(71.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,25.515),(71.495,25.685),(71.665,25.685),(71.665,25.515),(71.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,25.515),(71.855,25.685),(72.025,25.685),(72.025,25.515),(71.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,25.875),(70.775,26.045),(70.945,26.045),(70.945,25.875),(70.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,25.875),(71.135,26.045),(71.305,26.045),(71.305,25.875),(71.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,25.875),(71.495,26.045),(71.665,26.045),(71.665,25.875),(71.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,25.875),(71.855,26.045),(72.025,26.045),(72.025,25.875),(71.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,26.235),(70.775,26.405),(70.945,26.405),(70.945,26.235),(70.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,26.235),(71.135,26.405),(71.305,26.405),(71.305,26.235),(71.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,26.235),(71.495,26.405),(71.665,26.405),(71.665,26.235),(71.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,26.235),(71.855,26.405),(72.025,26.405),(72.025,26.235),(71.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,26.595),(70.775,26.765),(70.945,26.765),(70.945,26.595),(70.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,26.595),(71.135,26.765),(71.305,26.765),(71.305,26.595),(71.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,26.595),(71.495,26.765),(71.665,26.765),(71.665,26.595),(71.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,26.595),(71.855,26.765),(72.025,26.765),(72.025,26.595),(71.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,26.955),(70.775,27.125),(70.945,27.125),(70.945,26.955),(70.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,26.955),(71.135,27.125),(71.305,27.125),(71.305,26.955),(71.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,26.955),(71.495,27.125),(71.665,27.125),(71.665,26.955),(71.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,26.955),(71.855,27.125),(72.025,27.125),(72.025,26.955),(71.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,27.315),(70.775,27.485),(70.945,27.485),(70.945,27.315),(70.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,27.315),(71.135,27.485),(71.305,27.485),(71.305,27.315),(71.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,27.315),(71.495,27.485),(71.665,27.485),(71.665,27.315),(71.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,27.315),(71.855,27.485),(72.025,27.485),(72.025,27.315),(71.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,27.675),(70.775,27.845),(70.945,27.845),(70.945,27.675),(70.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,27.675),(71.135,27.845),(71.305,27.845),(71.305,27.675),(71.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,27.675),(71.495,27.845),(71.665,27.845),(71.665,27.675),(71.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,27.675),(71.855,27.845),(72.025,27.845),(72.025,27.675),(71.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,28.035),(70.775,28.205),(70.945,28.205),(70.945,28.035),(70.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,28.035),(71.135,28.205),(71.305,28.205),(71.305,28.035),(71.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,28.035),(71.495,28.205),(71.665,28.205),(71.665,28.035),(71.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,28.035),(71.855,28.205),(72.025,28.205),(72.025,28.035),(71.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,28.395),(70.775,28.565),(70.945,28.565),(70.945,28.395),(70.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,28.395),(71.135,28.565),(71.305,28.565),(71.305,28.395),(71.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,28.395),(71.495,28.565),(71.665,28.565),(71.665,28.395),(71.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,28.395),(71.855,28.565),(72.025,28.565),(72.025,28.395),(71.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,28.755),(70.775,28.925),(70.945,28.925),(70.945,28.755),(70.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,28.755),(71.135,28.925),(71.305,28.925),(71.305,28.755),(71.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,28.755),(71.495,28.925),(71.665,28.925),(71.665,28.755),(71.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,28.755),(71.855,28.925),(72.025,28.925),(72.025,28.755),(71.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,29.115),(70.775,29.285),(70.945,29.285),(70.945,29.115),(70.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,29.115),(71.135,29.285),(71.305,29.285),(71.305,29.115),(71.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,29.115),(71.495,29.285),(71.665,29.285),(71.665,29.115),(71.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,29.115),(71.855,29.285),(72.025,29.285),(72.025,29.115),(71.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,29.475),(70.775,29.645),(70.945,29.645),(70.945,29.475),(70.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,29.475),(71.135,29.645),(71.305,29.645),(71.305,29.475),(71.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,29.475),(71.495,29.645),(71.665,29.645),(71.665,29.475),(71.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,29.475),(71.855,29.645),(72.025,29.645),(72.025,29.475),(71.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,29.835),(70.775,30.005),(70.945,30.005),(70.945,29.835),(70.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,29.835),(71.135,30.005),(71.305,30.005),(71.305,29.835),(71.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,29.835),(71.495,30.005),(71.665,30.005),(71.665,29.835),(71.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,29.835),(71.855,30.005),(72.025,30.005),(72.025,29.835),(71.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,30.195),(70.775,30.365),(70.945,30.365),(70.945,30.195),(70.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,30.195),(71.135,30.365),(71.305,30.365),(71.305,30.195),(71.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,30.195),(71.495,30.365),(71.665,30.365),(71.665,30.195),(71.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,30.195),(71.855,30.365),(72.025,30.365),(72.025,30.195),(71.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,30.555),(70.775,30.725),(70.945,30.725),(70.945,30.555),(70.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,30.555),(71.135,30.725),(71.305,30.725),(71.305,30.555),(71.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,30.555),(71.495,30.725),(71.665,30.725),(71.665,30.555),(71.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,30.555),(71.855,30.725),(72.025,30.725),(72.025,30.555),(71.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,30.915),(70.775,31.085),(70.945,31.085),(70.945,30.915),(70.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,30.915),(71.135,31.085),(71.305,31.085),(71.305,30.915),(71.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,30.915),(71.495,31.085),(71.665,31.085),(71.665,30.915),(71.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,30.915),(71.855,31.085),(72.025,31.085),(72.025,30.915),(71.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,31.275),(70.775,31.445),(70.945,31.445),(70.945,31.275),(70.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,31.275),(71.135,31.445),(71.305,31.445),(71.305,31.275),(71.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,31.275),(71.495,31.445),(71.665,31.445),(71.665,31.275),(71.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,31.275),(71.855,31.445),(72.025,31.445),(72.025,31.275),(71.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,31.635),(70.775,31.805),(70.945,31.805),(70.945,31.635),(70.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,31.635),(71.135,31.805),(71.305,31.805),(71.305,31.635),(71.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,31.635),(71.495,31.805),(71.665,31.805),(71.665,31.635),(71.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,31.635),(71.855,31.805),(72.025,31.805),(72.025,31.635),(71.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,31.995),(70.775,32.165),(70.945,32.165),(70.945,31.995),(70.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,31.995),(71.135,32.165),(71.305,32.165),(71.305,31.995),(71.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,31.995),(71.495,32.165),(71.665,32.165),(71.665,31.995),(71.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,31.995),(71.855,32.165),(72.025,32.165),(72.025,31.995),(71.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,32.355),(70.775,32.525),(70.945,32.525),(70.945,32.355),(70.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,32.355),(71.135,32.525),(71.305,32.525),(71.305,32.355),(71.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,32.355),(71.495,32.525),(71.665,32.525),(71.665,32.355),(71.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,32.355),(71.855,32.525),(72.025,32.525),(72.025,32.355),(71.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,32.715),(70.775,32.885),(70.945,32.885),(70.945,32.715),(70.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,32.715),(71.135,32.885),(71.305,32.885),(71.305,32.715),(71.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,32.715),(71.495,32.885),(71.665,32.885),(71.665,32.715),(71.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,32.715),(71.855,32.885),(72.025,32.885),(72.025,32.715),(71.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,33.075),(70.775,33.245),(70.945,33.245),(70.945,33.075),(70.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,33.075),(71.135,33.245),(71.305,33.245),(71.305,33.075),(71.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,33.075),(71.495,33.245),(71.665,33.245),(71.665,33.075),(71.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,33.075),(71.855,33.245),(72.025,33.245),(72.025,33.075),(71.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,33.435),(70.775,33.605),(70.945,33.605),(70.945,33.435),(70.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,33.435),(71.135,33.605),(71.305,33.605),(71.305,33.435),(71.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,33.435),(71.495,33.605),(71.665,33.605),(71.665,33.435),(71.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,33.435),(71.855,33.605),(72.025,33.605),(72.025,33.435),(71.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,33.795),(70.775,33.965),(70.945,33.965),(70.945,33.795),(70.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,33.795),(71.135,33.965),(71.305,33.965),(71.305,33.795),(71.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,33.795),(71.495,33.965),(71.665,33.965),(71.665,33.795),(71.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,33.795),(71.855,33.965),(72.025,33.965),(72.025,33.795),(71.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,34.155),(70.775,34.325),(70.945,34.325),(70.945,34.155),(70.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,34.155),(71.135,34.325),(71.305,34.325),(71.305,34.155),(71.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,34.155),(71.495,34.325),(71.665,34.325),(71.665,34.155),(71.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,34.155),(71.855,34.325),(72.025,34.325),(72.025,34.155),(71.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,34.515),(70.775,34.685),(70.945,34.685),(70.945,34.515),(70.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,34.515),(71.135,34.685),(71.305,34.685),(71.305,34.515),(71.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,34.515),(71.495,34.685),(71.665,34.685),(71.665,34.515),(71.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,34.515),(71.855,34.685),(72.025,34.685),(72.025,34.515),(71.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,34.875),(70.775,35.045),(70.945,35.045),(70.945,34.875),(70.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,34.875),(71.135,35.045),(71.305,35.045),(71.305,34.875),(71.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,34.875),(71.495,35.045),(71.665,35.045),(71.665,34.875),(71.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,34.875),(71.855,35.045),(72.025,35.045),(72.025,34.875),(71.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,35.235),(70.775,35.405),(70.945,35.405),(70.945,35.235),(70.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,35.235),(71.135,35.405),(71.305,35.405),(71.305,35.235),(71.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,35.235),(71.495,35.405),(71.665,35.405),(71.665,35.235),(71.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,35.235),(71.855,35.405),(72.025,35.405),(72.025,35.235),(71.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,35.595),(70.775,35.765),(70.945,35.765),(70.945,35.595),(70.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,35.595),(71.135,35.765),(71.305,35.765),(71.305,35.595),(71.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,35.595),(71.495,35.765),(71.665,35.765),(71.665,35.595),(71.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,35.595),(71.855,35.765),(72.025,35.765),(72.025,35.595),(71.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,35.955),(70.775,36.125),(70.945,36.125),(70.945,35.955),(70.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,35.955),(71.135,36.125),(71.305,36.125),(71.305,35.955),(71.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,35.955),(71.495,36.125),(71.665,36.125),(71.665,35.955),(71.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,35.955),(71.855,36.125),(72.025,36.125),(72.025,35.955),(71.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,36.315),(70.775,36.485),(70.945,36.485),(70.945,36.315),(70.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,36.315),(71.135,36.485),(71.305,36.485),(71.305,36.315),(71.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,36.315),(71.495,36.485),(71.665,36.485),(71.665,36.315),(71.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,36.315),(71.855,36.485),(72.025,36.485),(72.025,36.315),(71.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,36.675),(70.775,36.845),(70.945,36.845),(70.945,36.675),(70.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,36.675),(71.135,36.845),(71.305,36.845),(71.305,36.675),(71.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,36.675),(71.495,36.845),(71.665,36.845),(71.665,36.675),(71.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,36.675),(71.855,36.845),(72.025,36.845),(72.025,36.675),(71.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,37.035),(70.775,37.205),(70.945,37.205),(70.945,37.035),(70.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,37.035),(71.135,37.205),(71.305,37.205),(71.305,37.035),(71.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,37.035),(71.495,37.205),(71.665,37.205),(71.665,37.035),(71.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,37.035),(71.855,37.205),(72.025,37.205),(72.025,37.035),(71.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,37.395),(70.775,37.565),(70.945,37.565),(70.945,37.395),(70.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,37.395),(71.135,37.565),(71.305,37.565),(71.305,37.395),(71.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,37.395),(71.495,37.565),(71.665,37.565),(71.665,37.395),(71.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,37.395),(71.855,37.565),(72.025,37.565),(72.025,37.395),(71.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,37.755),(70.775,37.925),(70.945,37.925),(70.945,37.755),(70.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,37.755),(71.135,37.925),(71.305,37.925),(71.305,37.755),(71.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,37.755),(71.495,37.925),(71.665,37.925),(71.665,37.755),(71.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,37.755),(71.855,37.925),(72.025,37.925),(72.025,37.755),(71.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,38.115),(70.775,38.285),(70.945,38.285),(70.945,38.115),(70.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,38.115),(71.135,38.285),(71.305,38.285),(71.305,38.115),(71.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,38.115),(71.495,38.285),(71.665,38.285),(71.665,38.115),(71.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,38.115),(71.855,38.285),(72.025,38.285),(72.025,38.115),(71.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,38.475),(70.775,38.645),(70.945,38.645),(70.945,38.475),(70.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,38.475),(71.135,38.645),(71.305,38.645),(71.305,38.475),(71.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,38.475),(71.495,38.645),(71.665,38.645),(71.665,38.475),(71.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,38.475),(71.855,38.645),(72.025,38.645),(72.025,38.475),(71.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,38.835),(70.775,39.005),(70.945,39.005),(70.945,38.835),(70.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,38.835),(71.135,39.005),(71.305,39.005),(71.305,38.835),(71.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,38.835),(71.495,39.005),(71.665,39.005),(71.665,38.835),(71.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,38.835),(71.855,39.005),(72.025,39.005),(72.025,38.835),(71.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,39.195),(70.775,39.365),(70.945,39.365),(70.945,39.195),(70.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,39.195),(71.135,39.365),(71.305,39.365),(71.305,39.195),(71.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,39.195),(71.495,39.365),(71.665,39.365),(71.665,39.195),(71.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,39.195),(71.855,39.365),(72.025,39.365),(72.025,39.195),(71.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,39.555),(70.775,39.725),(70.945,39.725),(70.945,39.555),(70.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,39.555),(71.135,39.725),(71.305,39.725),(71.305,39.555),(71.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,39.555),(71.495,39.725),(71.665,39.725),(71.665,39.555),(71.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,39.555),(71.855,39.725),(72.025,39.725),(72.025,39.555),(71.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,39.915),(70.775,40.085),(70.945,40.085),(70.945,39.915),(70.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,39.915),(71.135,40.085),(71.305,40.085),(71.305,39.915),(71.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,39.915),(71.495,40.085),(71.665,40.085),(71.665,39.915),(71.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,39.915),(71.855,40.085),(72.025,40.085),(72.025,39.915),(71.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,40.275),(70.775,40.445),(70.945,40.445),(70.945,40.275),(70.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,40.275),(71.135,40.445),(71.305,40.445),(71.305,40.275),(71.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,40.275),(71.495,40.445),(71.665,40.445),(71.665,40.275),(71.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,40.275),(71.855,40.445),(72.025,40.445),(72.025,40.275),(71.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,40.635),(70.775,40.805),(70.945,40.805),(70.945,40.635),(70.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,40.635),(71.135,40.805),(71.305,40.805),(71.305,40.635),(71.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,40.635),(71.495,40.805),(71.665,40.805),(71.665,40.635),(71.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,40.635),(71.855,40.805),(72.025,40.805),(72.025,40.635),(71.855,40.635)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.775),(22.745,40.865),(24.055,40.865),(24.055,2.775),(22.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.775),(22.745,43.64),(24.055,43.64),(24.055,2.775),(22.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.775),(65.945,43.64),(67.255,43.64),(67.255,2.775),(65.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.775),(51.545,43.64),(52.855,43.64),(52.855,2.775),(51.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.775),(51.545,40.865),(52.855,40.865),(52.855,2.775),(51.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.775),(17.945,40.865),(19.255,40.865),(19.255,2.775),(17.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.775),(70.745,40.865),(72.055,40.865),(72.055,2.775),(70.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.775),(70.745,43.64),(72.055,43.64),(72.055,2.775),(70.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.775),(27.545,43.64),(28.855,43.64),(28.855,2.775),(27.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.775),(61.145,43.64),(62.455,43.64),(62.455,2.775),(61.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.775),(27.545,40.865),(28.855,40.865),(28.855,2.775),(27.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.775),(41.945,40.865),(43.255,40.865),(43.255,2.775),(41.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.775),(61.145,40.865),(62.455,40.865),(62.455,2.775),(61.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.775),(32.345,43.64),(33.655,43.64),(33.655,2.775),(32.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.775),(80.345,43.64),(81.655,43.64),(81.655,2.775),(80.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.775),(17.945,43.64),(19.255,43.64),(19.255,2.775),(17.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.775),(75.545,43.64),(76.855,43.64),(76.855,2.775),(75.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.775),(32.345,40.865),(33.655,40.865),(33.655,2.775),(32.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.775),(80.345,40.865),(81.655,40.865),(81.655,2.775),(80.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.775),(13.145,43.64),(14.455,43.64),(14.455,2.775),(13.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.775),(75.545,40.865),(76.855,40.865),(76.855,2.775),(75.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.775),(13.145,40.865),(14.455,40.865),(14.455,2.775),(13.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.775),(8.345,43.64),(9.655,43.64),(9.655,2.775),(8.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.775),(41.945,43.64),(43.255,43.64),(43.255,2.775),(41.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.775),(8.345,40.865),(9.655,40.865),(9.655,2.775),(8.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.775),(65.945,40.865),(67.255,40.865),(67.255,2.775),(65.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.775),(46.745,40.865),(48.055,40.865),(48.055,2.775),(46.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.775),(46.745,43.64),(48.055,43.64),(48.055,2.775),(46.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.775),(37.145,43.64),(38.455,43.64),(38.455,2.775),(37.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.775),(37.145,40.865),(38.455,40.865),(38.455,2.775),(37.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.775),(56.345,43.64),(57.655,43.64),(57.655,2.775),(56.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.775),(56.345,40.865),(57.655,40.865),(57.655,2.775),(56.345,2.775)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(23.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(23.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(71.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(71.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(66.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(66.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(18.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(18.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(76.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(76.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(81.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(81.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(28.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(28.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(13.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(13.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(61.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(61.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(9.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(9.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['off']
        createRL(
            tech, net, 'poly',
            ((46.2,41.08),(46.2,41.41),(46.47,41.41),(46.47,41.08),(46.2,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,41.05),(46.035,41.08),(46.635,41.08),(46.635,41.05),(46.035,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,41.08),(31.8,41.41),(32.07,41.41),(32.07,41.08),(31.8,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,41.05),(31.635,41.08),(32.235,41.08),(32.235,41.05),(31.635,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.56),(26.835,2.59),(27.435,2.59),(27.435,2.56),(26.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,41.05),(22.035,41.08),(22.635,41.08),(22.635,41.05),(22.035,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,41.08),(22.2,41.41),(22.47,41.41),(22.47,41.08),(22.2,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.59),(48.165,41.05),(48.765,41.05),(48.765,2.59),(48.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.59),(7.635,41.05),(8.235,41.05),(8.235,2.59),(7.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.59),(79.635,41.05),(80.235,41.05),(80.235,2.59),(79.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,41.08),(60.6,41.41),(60.87,41.41),(60.87,41.08),(60.6,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,41.05),(36.435,41.08),(37.035,41.08),(37.035,41.05),(36.435,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,41.05),(43.365,41.08),(43.965,41.08),(43.965,41.05),(43.365,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,41.08),(43.53,41.41),(43.8,41.41),(43.8,41.08),(43.53,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,2.23),(9.93,2.56),(10.2,2.56),(10.2,2.23),(9.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.59),(72.165,41.05),(72.765,41.05),(72.765,2.59),(72.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.56),(9.765,2.59),(10.365,2.59),(10.365,2.56),(9.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.56),(43.365,2.59),(43.965,2.59),(43.965,2.56),(43.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.56),(55.635,2.59),(56.235,2.59),(56.235,2.56),(55.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,2.23),(72.33,2.56),(72.6,2.56),(72.6,2.23),(72.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.56),(72.165,2.59),(72.765,2.59),(72.765,2.56),(72.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,41.08),(55.8,41.41),(56.07,41.41),(56.07,41.08),(55.8,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,41.05),(55.635,41.08),(56.235,41.08),(56.235,41.05),(55.635,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.59),(62.565,41.05),(63.165,41.05),(63.165,2.59),(62.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,2.23),(67.53,2.56),(67.8,2.56),(67.8,2.23),(67.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.56),(67.365,2.59),(67.965,2.59),(67.965,2.56),(67.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,2.23),(79.8,2.56),(80.07,2.56),(80.07,2.23),(79.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.56),(79.635,2.59),(80.235,2.59),(80.235,2.56),(79.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.59),(52.965,41.05),(53.565,41.05),(53.565,2.59),(52.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.56),(7.635,2.59),(8.235,2.59),(8.235,2.56),(7.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,2.23),(7.8,2.56),(8.07,2.56),(8.07,2.23),(7.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,41.05),(60.435,41.08),(61.035,41.08),(61.035,41.05),(60.435,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,41.05),(28.965,41.08),(29.565,41.08),(29.565,41.05),(28.965,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,41.08),(81.93,41.41),(82.2,41.41),(82.2,41.08),(81.93,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,41.05),(81.765,41.08),(82.365,41.08),(82.365,41.05),(81.765,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.985),(85.68,22.25),(86.01,22.25),(86.01,21.985),(85.68,21.985)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.59),(70.035,41.05),(70.635,41.05),(70.635,2.59),(70.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,41.05),(50.835,41.08),(51.435,41.08),(51.435,41.05),(50.835,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,41.05),(72.165,41.08),(72.765,41.08),(72.765,41.05),(72.165,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,41.08),(72.33,41.41),(72.6,41.41),(72.6,41.08),(72.33,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.59),(19.365,41.05),(19.965,41.05),(19.965,2.59),(19.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,41.08),(9.93,41.41),(10.2,41.41),(10.2,41.08),(9.93,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,41.05),(9.765,41.08),(10.365,41.08),(10.365,41.05),(9.765,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.56),(48.165,2.59),(48.765,2.59),(48.765,2.56),(48.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,41.08),(12.6,41.41),(12.87,41.41),(12.87,41.08),(12.6,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,2.23),(17.4,2.56),(17.67,2.56),(17.67,2.23),(17.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.56),(17.235,2.59),(17.835,2.59),(17.835,2.56),(17.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,41.08),(67.53,41.41),(67.8,41.41),(67.8,41.08),(67.53,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,41.05),(67.365,41.08),(67.965,41.08),(67.965,41.05),(67.365,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,41.08),(29.13,41.41),(29.4,41.41),(29.4,41.08),(29.13,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,21.99),(85.68,22.28),(86.01,22.28),(86.01,21.99),(85.68,21.99)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.56),(28.965,2.59),(29.565,2.59),(29.565,2.56),(28.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.56),(38.565,2.59),(39.165,2.59),(39.165,2.56),(38.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.59),(81.765,41.05),(82.365,41.05),(82.365,2.59),(81.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.59),(67.365,41.05),(67.965,41.05),(67.965,2.59),(67.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.59),(41.235,41.05),(41.835,41.05),(41.835,2.59),(41.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.56),(14.565,2.59),(15.165,2.59),(15.165,2.56),(14.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,2.23),(14.73,2.56),(15.0,2.56),(15.0,2.23),(14.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,41.08),(75.0,41.41),(75.27,41.41),(75.27,41.08),(75.0,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,41.05),(38.565,41.08),(39.165,41.08),(39.165,41.05),(38.565,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,41.05),(48.165,41.08),(48.765,41.08),(48.765,41.05),(48.165,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,41.08),(48.33,41.41),(48.6,41.41),(48.6,41.08),(48.33,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,41.05),(19.365,41.08),(19.965,41.08),(19.965,41.05),(19.365,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,41.08),(38.73,41.41),(39.0,41.41),(39.0,41.08),(38.73,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,41.08),(19.53,41.41),(19.8,41.41),(19.8,41.08),(19.53,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,41.05),(7.635,41.08),(8.235,41.08),(8.235,41.05),(7.635,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,41.08),(7.8,41.41),(8.07,41.41),(8.07,41.08),(7.8,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,41.08),(79.8,41.41),(80.07,41.41),(80.07,41.08),(79.8,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,41.05),(79.635,41.08),(80.235,41.08),(80.235,41.05),(79.635,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.59),(43.365,41.05),(43.965,41.05),(43.965,2.59),(43.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.59),(36.435,41.05),(37.035,41.05),(37.035,2.59),(36.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,41.05),(12.435,41.08),(13.035,41.08),(13.035,41.05),(12.435,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.59),(46.035,41.05),(46.635,41.05),(46.635,2.59),(46.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.59),(65.235,41.05),(65.835,41.05),(65.835,2.59),(65.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,2.23),(60.6,2.56),(60.87,2.56),(60.87,2.23),(60.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.59),(22.035,41.05),(22.635,41.05),(22.635,2.59),(22.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.59),(33.765,41.05),(34.365,41.05),(34.365,2.59),(33.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,2.23),(70.2,2.56),(70.47,2.56),(70.47,2.23),(70.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.56),(70.035,2.59),(70.635,2.59),(70.635,2.56),(70.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,2.23),(29.13,2.56),(29.4,2.56),(29.4,2.23),(29.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,2.59),(12.435,41.05),(13.035,41.05),(13.035,2.59),(12.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,41.08),(77.13,41.41),(77.4,41.41),(77.4,41.08),(77.13,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.56),(46.035,2.59),(46.635,2.59),(46.635,2.56),(46.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.56),(76.965,2.59),(77.565,2.59),(77.565,2.56),(76.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,2.23),(12.6,2.56),(12.87,2.56),(12.87,2.23),(12.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,41.08),(62.73,41.41),(63.0,41.41),(63.0,41.08),(62.73,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.56),(22.035,2.59),(22.635,2.59),(22.635,2.56),(22.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,2.23),(22.2,2.56),(22.47,2.56),(22.47,2.23),(22.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,41.05),(62.565,41.08),(63.165,41.08),(63.165,41.05),(62.565,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.59),(60.435,41.05),(61.035,41.05),(61.035,2.59),(60.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.59),(26.835,41.05),(27.435,41.05),(27.435,2.59),(26.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.59),(57.765,41.05),(58.365,41.05),(58.365,2.59),(57.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,2.23),(81.93,2.56),(82.2,2.56),(82.2,2.23),(81.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.56),(81.765,2.59),(82.365,2.59),(82.365,2.56),(81.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.59),(74.835,41.05),(75.435,41.05),(75.435,2.59),(74.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,2.23),(62.73,2.56),(63.0,2.56),(63.0,2.23),(62.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.56),(62.565,2.59),(63.165,2.59),(63.165,2.56),(62.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,41.08),(51.0,41.41),(51.27,41.41),(51.27,41.08),(51.0,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,41.08),(65.4,41.41),(65.67,41.41),(65.67,41.08),(65.4,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,41.05),(65.235,41.08),(65.835,41.08),(65.835,41.05),(65.235,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,2.23),(77.13,2.56),(77.4,2.56),(77.4,2.23),(77.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,41.08),(41.4,41.41),(41.67,41.41),(41.67,41.08),(41.4,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,41.05),(41.235,41.08),(41.835,41.08),(41.835,41.05),(41.235,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.56),(57.765,2.59),(58.365,2.59),(58.365,2.56),(57.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.56),(33.765,2.59),(34.365,2.59),(34.365,2.56),(33.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,41.08),(57.93,41.41),(58.2,41.41),(58.2,41.08),(57.93,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,41.05),(57.765,41.08),(58.365,41.08),(58.365,41.05),(57.765,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,41.05),(26.835,41.08),(27.435,41.08),(27.435,41.05),(26.835,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,41.08),(33.93,41.41),(34.2,41.41),(34.2,41.08),(33.93,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,41.05),(33.765,41.08),(34.365,41.08),(34.365,41.05),(33.765,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.56),(52.965,2.59),(53.565,2.59),(53.565,2.56),(52.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.59),(31.635,41.05),(32.235,41.05),(32.235,2.59),(31.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,2.23),(75.0,2.56),(75.27,2.56),(75.27,2.23),(75.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.59),(38.565,41.05),(39.165,41.05),(39.165,2.59),(38.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,41.05),(52.965,41.08),(53.565,41.08),(53.565,41.05),(52.965,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.59),(24.165,41.05),(24.765,41.05),(24.765,2.59),(24.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,2.23),(19.53,2.56),(19.8,2.56),(19.8,2.23),(19.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.56),(36.435,2.59),(37.035,2.59),(37.035,2.56),(36.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.59),(17.235,41.05),(17.835,41.05),(17.835,2.59),(17.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.56),(31.635,2.59),(32.235,2.59),(32.235,2.56),(31.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,41.08),(24.33,41.41),(24.6,41.41),(24.6,41.08),(24.33,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,41.05),(24.165,41.08),(24.765,41.08),(24.765,41.05),(24.165,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,2.23),(27.0,2.56),(27.27,2.56),(27.27,2.23),(27.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.59),(9.765,41.05),(10.365,41.05),(10.365,2.59),(9.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,41.05),(14.565,41.08),(15.165,41.08),(15.165,41.05),(14.565,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,41.08),(14.73,41.41),(15.0,41.41),(15.0,41.08),(14.73,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.59),(55.635,41.05),(56.235,41.05),(56.235,2.59),(55.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.59),(28.965,41.05),(29.565,41.05),(29.565,2.59),(28.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,2.23),(65.4,2.56),(65.67,2.56),(65.67,2.23),(65.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,41.05),(76.965,41.08),(77.565,41.08),(77.565,41.05),(76.965,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.56),(65.235,2.59),(65.835,2.59),(65.835,2.56),(65.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,41.08),(27.0,41.41),(27.27,41.41),(27.27,41.08),(27.0,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,41.05),(74.835,41.08),(75.435,41.08),(75.435,41.05),(74.835,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.56),(60.435,2.59),(61.035,2.59),(61.035,2.56),(60.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.59),(50.835,41.05),(51.435,41.05),(51.435,2.59),(50.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.56),(41.235,2.59),(41.835,2.59),(41.835,2.56),(41.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.59),(14.565,41.05),(15.165,41.05),(15.165,2.59),(14.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.59),(76.965,41.05),(77.565,41.05),(77.565,2.59),(76.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,41.08),(36.6,41.41),(36.87,41.41),(36.87,41.08),(36.6,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.56),(50.835,2.59),(51.435,2.59),(51.435,2.56),(50.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,41.08),(53.13,41.41),(53.4,41.41),(53.4,41.08),(53.13,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.56),(24.165,2.59),(24.765,2.59),(24.765,2.56),(24.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,2.23),(24.33,2.56),(24.6,2.56),(24.6,2.23),(24.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,41.08),(17.4,41.41),(17.67,41.41),(17.67,41.08),(17.4,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,2.56),(12.435,2.59),(13.035,2.59),(13.035,2.56),(12.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,41.05),(17.235,41.08),(17.835,41.08),(17.835,41.05),(17.235,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.56),(74.835,2.59),(75.435,2.59),(75.435,2.56),(74.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,41.08),(70.2,41.41),(70.47,41.41),(70.47,41.08),(70.2,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,41.05),(70.035,41.08),(70.635,41.08),(70.635,41.05),(70.035,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.56),(19.365,2.59),(19.965,2.59),(19.965,2.56),(19.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,2.31),(17.45,2.48),(17.62,2.48),(17.62,2.31),(17.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,41.16),(14.78,41.33),(14.95,41.33),(14.95,41.16),(14.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,41.16),(46.25,41.33),(46.42,41.33),(46.42,41.16),(46.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,41.16),(29.18,41.33),(29.35,41.33),(29.35,41.16),(29.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,41.16),(67.58,41.33),(67.75,41.33),(67.75,41.16),(67.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,2.31),(19.58,2.48),(19.75,2.48),(19.75,2.31),(19.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,41.16),(31.85,41.33),(32.02,41.33),(32.02,41.16),(31.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,41.16),(22.25,41.33),(22.42,41.33),(22.42,41.16),(22.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,2.31),(81.98,2.48),(82.15,2.48),(82.15,2.31),(81.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,41.16),(24.38,41.33),(24.55,41.33),(24.55,41.16),(24.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,2.31),(27.05,2.48),(27.22,2.48),(27.22,2.31),(27.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,2.31),(22.25,2.48),(22.42,2.48),(22.42,2.31),(22.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,41.16),(60.65,41.33),(60.82,41.33),(60.82,41.16),(60.65,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,41.16),(43.58,41.33),(43.75,41.33),(43.75,41.16),(43.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,41.16),(75.05,41.33),(75.22,41.33),(75.22,41.16),(75.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,41.16),(51.05,41.33),(51.22,41.33),(51.22,41.16),(51.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,41.16),(48.38,41.33),(48.55,41.33),(48.55,41.16),(48.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,2.31),(14.78,2.48),(14.95,2.48),(14.95,2.31),(14.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,2.31),(62.78,2.48),(62.95,2.48),(62.95,2.31),(62.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,2.31),(9.98,2.48),(10.15,2.48),(10.15,2.31),(9.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,41.16),(19.58,41.33),(19.75,41.33),(19.75,41.16),(19.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,41.16),(65.45,41.33),(65.62,41.33),(65.62,41.16),(65.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,41.16),(7.85,41.33),(8.02,41.33),(8.02,41.16),(7.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,41.16),(79.85,41.33),(80.02,41.33),(80.02,41.16),(79.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,22.03),(85.76,22.2),(85.93,22.2),(85.93,22.03),(85.76,22.03)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,2.31),(77.18,2.48),(77.35,2.48),(77.35,2.31),(77.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,41.16),(41.45,41.33),(41.62,41.33),(41.62,41.16),(41.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,2.31),(75.05,2.48),(75.22,2.48),(75.22,2.31),(75.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,2.31),(65.45,2.48),(65.62,2.48),(65.62,2.31),(65.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,41.16),(62.78,41.33),(62.95,41.33),(62.95,41.16),(62.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,41.16),(27.05,41.33),(27.22,41.33),(27.22,41.16),(27.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,2.31),(72.38,2.48),(72.55,2.48),(72.55,2.31),(72.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,41.16),(55.85,41.33),(56.02,41.33),(56.02,41.16),(55.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,2.31),(60.65,2.48),(60.82,2.48),(60.82,2.31),(60.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,2.31),(70.25,2.48),(70.42,2.48),(70.42,2.31),(70.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,2.31),(29.18,2.48),(29.35,2.48),(29.35,2.31),(29.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,41.16),(57.98,41.33),(58.15,41.33),(58.15,41.16),(57.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,2.31),(67.58,2.48),(67.75,2.48),(67.75,2.31),(67.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,2.31),(7.85,2.48),(8.02,2.48),(8.02,2.31),(7.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,2.31),(79.85,2.48),(80.02,2.48),(80.02,2.31),(79.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,41.16),(36.65,41.33),(36.82,41.33),(36.82,41.16),(36.65,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,41.16),(77.18,41.33),(77.35,41.33),(77.35,41.16),(77.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,41.16),(53.18,41.33),(53.35,41.33),(53.35,41.16),(53.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,41.16),(33.98,41.33),(34.15,41.33),(34.15,41.16),(33.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,2.31),(24.38,2.48),(24.55,2.48),(24.55,2.31),(24.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,41.16),(81.98,41.33),(82.15,41.33),(82.15,41.16),(81.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,41.16),(17.45,41.33),(17.62,41.33),(17.62,41.16),(17.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,2.31),(12.65,2.48),(12.82,2.48),(12.82,2.31),(12.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,41.16),(70.25,41.33),(70.42,41.33),(70.42,41.16),(70.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,41.16),(38.78,41.33),(38.95,41.33),(38.95,41.16),(38.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,41.16),(72.38,41.33),(72.55,41.33),(72.55,41.16),(72.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,41.16),(9.98,41.33),(10.15,41.33),(10.15,41.16),(9.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,41.16),(12.65,41.33),(12.82,41.33),(12.82,41.16),(12.65,41.16)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,41.08),(14.78,41.41),(14.95,41.41),(14.95,41.08),(14.78,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,41.08),(46.25,41.41),(46.42,41.41),(46.42,41.08),(46.25,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.56),(62.78,41.08),(62.95,41.08),(62.95,2.56),(62.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,41.08),(31.85,41.41),(32.02,41.41),(32.02,41.08),(31.85,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,41.08),(22.25,41.41),(22.42,41.41),(22.42,41.08),(22.25,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.56),(48.38,41.08),(48.55,41.08),(48.55,2.56),(48.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.56),(7.85,41.08),(8.02,41.08),(8.02,2.56),(7.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.56),(79.85,41.08),(80.02,41.08),(80.02,2.56),(79.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,41.08),(60.65,41.41),(60.82,41.41),(60.82,41.08),(60.65,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,41.08),(43.58,41.41),(43.75,41.41),(43.75,41.08),(43.58,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.23),(9.98,2.56),(10.15,2.56),(10.15,2.23),(9.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.23),(62.78,2.56),(62.95,2.56),(62.95,2.23),(62.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.56),(72.38,41.08),(72.55,41.08),(72.55,2.56),(72.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.23),(43.58,2.56),(43.75,2.56),(43.75,2.23),(43.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.23),(55.85,2.56),(56.02,2.56),(56.02,2.23),(55.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.23),(72.38,2.56),(72.55,2.56),(72.55,2.23),(72.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,41.08),(55.85,41.41),(56.02,41.41),(56.02,41.08),(55.85,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.23),(67.58,2.56),(67.75,2.56),(67.75,2.23),(67.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.23),(79.85,2.56),(80.02,2.56),(80.02,2.23),(79.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.23),(7.85,2.56),(8.02,2.56),(8.02,2.23),(7.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,41.08),(81.98,41.41),(82.15,41.41),(82.15,41.08),(81.98,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.56),(70.25,41.08),(70.42,41.08),(70.42,2.56),(70.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,41.08),(72.38,41.41),(72.55,41.41),(72.55,41.08),(72.38,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.23),(53.18,2.56),(53.35,2.56),(53.35,2.23),(53.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.56),(19.58,41.08),(19.75,41.08),(19.75,2.56),(19.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,41.08),(9.98,41.41),(10.15,41.41),(10.15,41.08),(9.98,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.23),(48.38,2.56),(48.55,2.56),(48.55,2.23),(48.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,41.08),(12.65,41.41),(12.82,41.41),(12.82,41.08),(12.65,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.23),(17.45,2.56),(17.62,2.56),(17.62,2.23),(17.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,41.08),(67.58,41.41),(67.75,41.41),(67.75,41.08),(67.58,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,41.08),(29.18,41.41),(29.35,41.41),(29.35,41.08),(29.18,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.23),(31.85,2.56),(32.02,2.56),(32.02,2.23),(31.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.23),(36.65,2.56),(36.82,2.56),(36.82,2.23),(36.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.56),(81.98,41.08),(82.15,41.08),(82.15,2.56),(81.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.56),(67.58,41.08),(67.75,41.08),(67.75,2.56),(67.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.56),(41.45,41.08),(41.62,41.08),(41.62,2.56),(41.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,41.08),(75.05,41.41),(75.22,41.41),(75.22,41.08),(75.05,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,41.08),(19.58,41.41),(19.75,41.41),(19.75,41.08),(19.58,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,41.08),(48.38,41.41),(48.55,41.41),(48.55,41.08),(48.38,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,21.95),(85.76,41.41),(85.93,41.41),(85.93,21.95),(85.76,21.95)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,41.08),(7.85,41.41),(8.02,41.41),(8.02,41.08),(7.85,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,41.08),(79.85,41.41),(80.02,41.41),(80.02,41.08),(79.85,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.56),(43.58,41.08),(43.75,41.08),(43.75,2.56),(43.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.56),(46.25,41.08),(46.42,41.08),(46.42,2.56),(46.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.56),(65.45,41.08),(65.62,41.08),(65.62,2.56),(65.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.23),(60.65,2.56),(60.82,2.56),(60.82,2.23),(60.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.56),(22.25,41.08),(22.42,41.08),(22.42,2.56),(22.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.56),(33.98,41.08),(34.15,41.08),(34.15,2.56),(33.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.23),(70.25,2.56),(70.42,2.56),(70.42,2.23),(70.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.23),(29.18,2.56),(29.35,2.56),(29.35,2.23),(29.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,41.08),(77.18,41.41),(77.35,41.41),(77.35,41.08),(77.18,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.23),(46.25,2.56),(46.42,2.56),(46.42,2.23),(46.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,41.08),(38.78,41.41),(38.95,41.41),(38.95,41.08),(38.78,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.23),(12.65,2.56),(12.82,2.56),(12.82,2.23),(12.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.23),(22.25,2.56),(22.42,2.56),(22.42,2.23),(22.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.56),(53.18,41.08),(53.35,41.08),(53.35,2.56),(53.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.56),(36.65,41.08),(36.82,41.08),(36.82,2.56),(36.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.56),(57.98,41.08),(58.15,41.08),(58.15,2.56),(57.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.23),(81.98,2.56),(82.15,2.56),(82.15,2.23),(81.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.56),(29.18,41.08),(29.35,41.08),(29.35,2.56),(29.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.56),(12.65,41.08),(12.82,41.08),(12.82,2.56),(12.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,41.08),(51.05,41.41),(51.22,41.41),(51.22,41.08),(51.05,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,41.08),(65.45,41.41),(65.62,41.41),(65.62,41.08),(65.45,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.56),(38.78,41.08),(38.95,41.08),(38.95,2.56),(38.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.23),(77.18,2.56),(77.35,2.56),(77.35,2.23),(77.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.23),(51.05,2.56),(51.22,2.56),(51.22,2.23),(51.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,41.08),(41.45,41.41),(41.62,41.41),(41.62,41.08),(41.45,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.56),(60.65,41.08),(60.82,41.08),(60.82,2.56),(60.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,41.08),(62.78,41.41),(62.95,41.41),(62.95,41.08),(62.78,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.23),(57.98,2.56),(58.15,2.56),(58.15,2.23),(57.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.23),(33.98,2.56),(34.15,2.56),(34.15,2.23),(33.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,41.08),(57.98,41.41),(58.15,41.41),(58.15,41.08),(57.98,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,41.08),(33.98,41.41),(34.15,41.41),(34.15,41.08),(33.98,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.23),(75.05,2.56),(75.22,2.56),(75.22,2.23),(75.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.56),(31.85,41.08),(32.02,41.08),(32.02,2.56),(31.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.56),(14.78,41.08),(14.95,41.08),(14.95,2.56),(14.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.56),(24.38,41.08),(24.55,41.08),(24.55,2.56),(24.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.56),(17.45,41.08),(17.62,41.08),(17.62,2.56),(17.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.23),(38.78,2.56),(38.95,2.56),(38.95,2.23),(38.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,41.08),(24.38,41.41),(24.55,41.41),(24.55,41.08),(24.38,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.23),(27.05,2.56),(27.22,2.56),(27.22,2.23),(27.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.56),(9.98,41.08),(10.15,41.08),(10.15,2.56),(9.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.23),(14.78,2.56),(14.95,2.56),(14.95,2.23),(14.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,21.95),(85.76,22.28),(85.93,22.28),(85.93,21.95),(85.76,21.95)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.56),(55.85,41.08),(56.02,41.08),(56.02,2.56),(55.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.56),(51.05,41.08),(51.22,41.08),(51.22,2.56),(51.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.56),(77.18,41.08),(77.35,41.08),(77.35,2.56),(77.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.23),(65.45,2.56),(65.62,2.56),(65.62,2.23),(65.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,41.08),(27.05,41.41),(27.22,41.41),(27.22,41.08),(27.05,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.23),(41.45,2.56),(41.62,2.56),(41.62,2.23),(41.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.56),(27.05,41.08),(27.22,41.08),(27.22,2.56),(27.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,41.24),(7.85,41.41),(82.15,41.41),(82.15,41.24),(7.85,41.24)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,41.08),(36.65,41.41),(36.82,41.41),(36.82,41.08),(36.65,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,41.08),(53.18,41.41),(53.35,41.41),(53.35,41.08),(53.18,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.23),(24.38,2.56),(24.55,2.56),(24.55,2.23),(24.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,41.08),(17.45,41.41),(17.62,41.41),(17.62,41.08),(17.45,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,41.08),(70.25,41.41),(70.42,41.41),(70.42,41.08),(70.25,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.23),(19.58,2.56),(19.75,2.56),(19.75,2.23),(19.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.56),(75.05,41.08),(75.22,41.08),(75.22,2.56),(75.05,2.56)),
        )
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_P18000W8728HFF']
        except:
            subcell = af.getCell('GuardRing_P18000W8728HFF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_N17368W8096HTF']
        except:
            subcell = af.getCell('GuardRing_N17368W8096HTF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['BulkConn_18000WUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-30.33999999999998), u(90), u(14.42),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((0.0,-0.125),(0.0,0.125),(90.0,0.125),(90.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.17,-0.125),(0.17,0.125),(2.96,0.125),(2.96,-0.125),(0.17,-0.125)),
        )
        createRL(
            tech, net, 'difftap',
            ((87.04,-0.125),(87.04,0.125),(89.83,0.125),(89.83,-0.125),(87.04,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((0.0,-0.125),(0.0,0.125),(90.0,0.125),(90.0,-0.125),(0.0,-0.125)),
        )
        createRL(
            tech, net, 'nwm',
            ((86.86,-0.305),(86.86,0.305),(90.01,0.305),(90.01,-0.305),(86.86,-0.305)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.01,-0.305),(-0.01,0.305),(3.14,0.305),(3.14,-0.305),(-0.01,-0.305)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,-0.42),(-0.18,0.42),(90.18,0.42),(90.18,-0.42),(-0.18,-0.42)),
        )
        createRL(
            tech, net, 'licon',
            ((87.16,-0.085),(87.16,0.085),(87.33,0.085),(87.33,-0.085),(87.16,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-0.085),(87.5,0.085),(87.67,0.085),(87.67,-0.085),(87.5,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((87.84,-0.085),(87.84,0.085),(88.01,0.085),(88.01,-0.085),(87.84,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((88.18,-0.085),(88.18,0.085),(88.35,0.085),(88.35,-0.085),(88.18,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-0.085),(88.52,0.085),(88.69,0.085),(88.69,-0.085),(88.52,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((88.86,-0.085),(88.86,0.085),(89.03,0.085),(89.03,-0.085),(88.86,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((89.2,-0.085),(89.2,0.085),(89.37,0.085),(89.37,-0.085),(89.2,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-0.085),(89.54,0.085),(89.71,0.085),(89.71,-0.085),(89.54,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-0.085),(0.29,0.085),(0.46,0.085),(0.46,-0.085),(0.29,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.63,-0.085),(0.63,0.085),(0.8,0.085),(0.8,-0.085),(0.63,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,-0.085),(0.97,0.085),(1.14,0.085),(1.14,-0.085),(0.97,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-0.085),(1.31,0.085),(1.48,0.085),(1.48,-0.085),(1.31,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.65,-0.085),(1.65,0.085),(1.82,0.085),(1.82,-0.085),(1.65,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((1.99,-0.085),(1.99,0.085),(2.16,0.085),(2.16,-0.085),(1.99,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-0.085),(2.33,0.085),(2.5,0.085),(2.5,-0.085),(2.33,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((2.67,-0.085),(2.67,0.085),(2.84,0.085),(2.84,-0.085),(2.67,-0.085)),
        )
        createRL(
            tech, net, 'li',
            ((0.21,-0.085),(0.21,0.085),(2.92,0.085),(2.92,-0.085),(0.21,-0.085)),
        )
        createRL(
            tech, net, 'li',
            ((89.3,-0.085),(89.3,0.085),(89.83,0.085),(89.83,-0.085),(89.3,-0.085)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,-0.13),(0.0,0.13),(90.0,0.13),(90.0,-0.13),(0.0,-0.13)),
        )
        createRL(
            tech, net, 'li',
            ((87.08,-0.085),(87.08,0.085),(89.79,0.085),(89.79,-0.085),(87.08,-0.085)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(0.0), u(0.26), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(0.0), u(0.26), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'mcon',
            ((89.3,-0.085),(89.3,0.085),(89.47,0.085),(89.47,-0.085),(89.3,-0.085)),
        )
        createRL(
            tech, net, 'mcon',
            ((89.66,-0.085),(89.66,0.085),(89.83,0.085),(89.83,-0.085),(89.66,-0.085)),
        )
        createRL(
            tech, net, 'm1',
            ((89.27,-0.145),(89.27,0.145),(89.86,0.145),(89.86,-0.145),(89.27,-0.145)),
        )
        createRL(
            tech, net, 'm1',
            ((89.275,-30.34),(89.275,-30.02),(89.855,-30.02),(89.855,-30.34),(89.275,-30.34)),
        )
        createRL(
            tech, net, 'm1',
            ((89.275,-30.34),(89.275,0.145),(89.855,0.145),(89.855,-30.34),(89.275,-30.34)),
        )
        createRL(
            tech, net, 'via',
            ((89.33,-30.255),(89.33,-30.105),(89.48,-30.105),(89.48,-30.255),(89.33,-30.255)),
        )
        createRL(
            tech, net, 'via',
            ((89.65,-30.255),(89.65,-30.105),(89.8,-30.105),(89.8,-30.255),(89.65,-30.255)),
        )
        createRL(
            tech, net, 'm2',
            ((89.275,-30.34),(89.275,-30.02),(89.855,-30.02),(89.855,-30.34),(89.275,-30.34)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,-0.25),(-0.125,0.25),(90.125,0.25),(90.125,-0.25),(-0.125,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((0.045,-0.25),(0.045,0.25),(3.085,0.25),(3.085,-0.25),(0.045,-0.25)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,13.75),(-0.125,14.25),(90.125,14.25),(90.125,13.75),(-0.125,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((86.915,13.75),(86.915,14.25),(89.955,14.25),(89.955,13.75),(86.915,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((0.045,13.75),(0.045,14.25),(3.085,14.25),(3.085,13.75),(0.045,13.75)),
        )
        createRL(
            tech, net, 'nsdm',
            ((86.915,-0.25),(86.915,0.25),(89.955,0.25),(89.955,-0.25),(86.915,-0.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,-30.085),(-0.125,-6.18),(90.125,-6.18),(90.125,-30.085),(-0.125,-30.085)),
        )
        createRL(
            tech, net, 'psdm',
            ((0.045,8.25),(0.045,8.75),(3.085,8.75),(3.085,8.25),(0.045,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((0.045,-29.91),(0.045,-6.35),(89.955,-6.35),(89.955,-29.91),(0.045,-29.91)),
        )
        createRL(
            tech, net, 'psdm',
            ((-0.125,8.25),(-0.125,8.75),(90.125,8.75),(90.125,8.25),(-0.125,8.25)),
        )
        createRL(
            tech, net, 'psdm',
            ((86.915,8.25),(86.915,8.75),(89.955,8.75),(89.955,8.25),(86.915,8.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'difftap',
            ((0.17,8.375),(0.17,8.625),(2.96,8.625),(2.96,8.375),(0.17,8.375)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,8.375),(0.0,8.625),(90.0,8.625),(90.0,8.375),(0.0,8.375)),
        )
        createRL(
            tech, net, 'difftap',
            ((87.04,8.375),(87.04,8.625),(89.83,8.625),(89.83,8.375),(87.04,8.375)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,8.415),(0.29,8.585),(0.46,8.585),(0.46,8.415),(0.29,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.63,8.415),(0.63,8.585),(0.8,8.585),(0.8,8.415),(0.63,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,8.415),(0.97,8.585),(1.14,8.585),(1.14,8.415),(0.97,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,8.415),(1.31,8.585),(1.48,8.585),(1.48,8.415),(1.31,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.65,8.415),(1.65,8.585),(1.82,8.585),(1.82,8.415),(1.65,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.99,8.415),(1.99,8.585),(2.16,8.585),(2.16,8.415),(1.99,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,8.415),(2.33,8.585),(2.5,8.585),(2.5,8.415),(2.33,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.67,8.415),(2.67,8.585),(2.84,8.585),(2.84,8.415),(2.67,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((87.16,8.415),(87.16,8.585),(87.33,8.585),(87.33,8.415),(87.16,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,8.415),(87.5,8.585),(87.67,8.585),(87.67,8.415),(87.5,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((87.84,8.415),(87.84,8.585),(88.01,8.585),(88.01,8.415),(87.84,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((88.18,8.415),(88.18,8.585),(88.35,8.585),(88.35,8.415),(88.18,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,8.415),(88.52,8.585),(88.69,8.585),(88.69,8.415),(88.52,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((88.86,8.415),(88.86,8.585),(89.03,8.585),(89.03,8.415),(88.86,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((89.2,8.415),(89.2,8.585),(89.37,8.585),(89.37,8.415),(89.2,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,8.415),(89.54,8.585),(89.71,8.585),(89.71,8.415),(89.54,8.415)),
        )
        createRL(
            tech, net, 'li',
            ((87.08,8.415),(87.08,8.585),(89.79,8.585),(89.79,8.415),(87.08,8.415)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,8.37),(0.0,8.63),(90.0,8.63),(90.0,8.37),(0.0,8.37)),
        )
        createRL(
            tech, net, 'li',
            ((87.14,8.415),(87.14,8.585),(89.83,8.585),(89.83,8.415),(87.14,8.415)),
        )
        createRL(
            tech, net, 'li',
            ((0.17,8.415),(0.17,8.585),(2.86,8.585),(2.86,8.415),(0.17,8.415)),
        )
        createRL(
            tech, net, 'li',
            ((0.21,8.415),(0.21,8.585),(2.92,8.585),(2.92,8.415),(0.21,8.415)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(8.5), u(0.26), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(8.5), u(0.26), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'mcon',
            ((87.14,8.415),(87.14,8.585),(87.31,8.585),(87.31,8.415),(87.14,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.5,8.415),(87.5,8.585),(87.67,8.585),(87.67,8.415),(87.5,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.86,8.415),(87.86,8.585),(88.03,8.585),(88.03,8.415),(87.86,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((88.22,8.415),(88.22,8.585),(88.39,8.585),(88.39,8.415),(88.22,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((88.58,8.415),(88.58,8.585),(88.75,8.585),(88.75,8.415),(88.58,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((88.94,8.415),(88.94,8.585),(89.11,8.585),(89.11,8.415),(88.94,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((89.3,8.415),(89.3,8.585),(89.47,8.585),(89.47,8.415),(89.3,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((89.66,8.415),(89.66,8.585),(89.83,8.585),(89.83,8.415),(89.66,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.17,8.415),(0.17,8.585),(0.34,8.585),(0.34,8.415),(0.17,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.53,8.415),(0.53,8.585),(0.7,8.585),(0.7,8.415),(0.53,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.89,8.415),(0.89,8.585),(1.06,8.585),(1.06,8.415),(0.89,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.25,8.415),(1.25,8.585),(1.42,8.585),(1.42,8.415),(1.25,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.61,8.415),(1.61,8.585),(1.78,8.585),(1.78,8.415),(1.61,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.97,8.415),(1.97,8.585),(2.14,8.585),(2.14,8.415),(1.97,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.33,8.415),(2.33,8.585),(2.5,8.585),(2.5,8.415),(2.33,8.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.69,8.415),(2.69,8.585),(2.86,8.585),(2.86,8.415),(2.69,8.415)),
        )
        createRL(
            tech, net, 'm1',
            ((0.14,8.355),(0.14,8.645),(2.89,8.645),(2.89,8.355),(0.14,8.355)),
        )
        createRL(
            tech, net, 'm1',
            ((0.14,8.34),(0.14,8.66),(2.64,8.66),(2.64,8.34),(0.14,8.34)),
        )
        createRL(
            tech, net, 'm1',
            ((87.36,8.34),(87.36,8.66),(89.86,8.66),(89.86,8.34),(87.36,8.34)),
        )
        createRL(
            tech, net, 'm1',
            ((87.11,8.355),(87.11,8.645),(89.86,8.645),(89.86,8.355),(87.11,8.355)),
        )
        createRL(
            tech, net, 'via',
            ((0.195,8.425),(0.195,8.575),(0.345,8.575),(0.345,8.425),(0.195,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((0.515,8.425),(0.515,8.575),(0.665,8.575),(0.665,8.425),(0.515,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((0.835,8.425),(0.835,8.575),(0.985,8.575),(0.985,8.425),(0.835,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((1.155,8.425),(1.155,8.575),(1.305,8.575),(1.305,8.425),(1.155,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((1.475,8.425),(1.475,8.575),(1.625,8.575),(1.625,8.425),(1.475,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((1.795,8.425),(1.795,8.575),(1.945,8.575),(1.945,8.425),(1.795,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((2.115,8.425),(2.115,8.575),(2.265,8.575),(2.265,8.425),(2.115,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((2.435,8.425),(2.435,8.575),(2.585,8.575),(2.585,8.425),(2.435,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((87.415,8.425),(87.415,8.575),(87.565,8.575),(87.565,8.425),(87.415,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((87.735,8.425),(87.735,8.575),(87.885,8.575),(87.885,8.425),(87.735,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((88.055,8.425),(88.055,8.575),(88.205,8.575),(88.205,8.425),(88.055,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((88.375,8.425),(88.375,8.575),(88.525,8.575),(88.525,8.425),(88.375,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((88.695,8.425),(88.695,8.575),(88.845,8.575),(88.845,8.425),(88.695,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((89.015,8.425),(89.015,8.575),(89.165,8.575),(89.165,8.425),(89.015,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((89.335,8.425),(89.335,8.575),(89.485,8.575),(89.485,8.425),(89.335,8.425)),
        )
        createRL(
            tech, net, 'via',
            ((89.655,8.425),(89.655,8.575),(89.805,8.575),(89.805,8.425),(89.655,8.425)),
        )
        createRL(
            tech, net, 'm2',
            ((0.14,8.34),(0.14,8.66),(2.64,8.66),(2.64,8.34),(0.14,8.34)),
        )
        createRL(
            tech, net, 'm2',
            ((87.36,8.34),(87.36,8.66),(89.86,8.66),(89.86,8.34),(87.36,8.34)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'difftap',
            ((87.04,13.875),(87.04,14.125),(89.83,14.125),(89.83,13.875),(87.04,13.875)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.17,13.875),(0.17,14.125),(2.96,14.125),(2.96,13.875),(0.17,13.875)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,13.875),(0.0,14.125),(90.0,14.125),(90.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.01,13.695),(-0.01,14.305),(3.14,14.305),(3.14,13.695),(-0.01,13.695)),
        )
        createRL(
            tech, net, 'nwm',
            ((86.86,13.695),(86.86,14.305),(90.01,14.305),(90.01,13.695),(86.86,13.695)),
        )
        createRL(
            tech, net, 'nwm',
            ((0.0,13.875),(0.0,14.125),(90.0,14.125),(90.0,13.875),(0.0,13.875)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,13.58),(-0.18,14.42),(90.18,14.42),(90.18,13.58),(-0.18,13.58)),
        )
        createRL(
            tech, net, 'licon',
            ((87.16,13.915),(87.16,14.085),(87.33,14.085),(87.33,13.915),(87.16,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,13.915),(87.5,14.085),(87.67,14.085),(87.67,13.915),(87.5,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((87.84,13.915),(87.84,14.085),(88.01,14.085),(88.01,13.915),(87.84,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((88.18,13.915),(88.18,14.085),(88.35,14.085),(88.35,13.915),(88.18,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,13.915),(88.52,14.085),(88.69,14.085),(88.69,13.915),(88.52,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((88.86,13.915),(88.86,14.085),(89.03,14.085),(89.03,13.915),(88.86,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((89.2,13.915),(89.2,14.085),(89.37,14.085),(89.37,13.915),(89.2,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,13.915),(89.54,14.085),(89.71,14.085),(89.71,13.915),(89.54,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,13.915),(0.29,14.085),(0.46,14.085),(0.46,13.915),(0.29,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.63,13.915),(0.63,14.085),(0.8,14.085),(0.8,13.915),(0.63,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((0.97,13.915),(0.97,14.085),(1.14,14.085),(1.14,13.915),(0.97,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,13.915),(1.31,14.085),(1.48,14.085),(1.48,13.915),(1.31,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.65,13.915),(1.65,14.085),(1.82,14.085),(1.82,13.915),(1.65,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((1.99,13.915),(1.99,14.085),(2.16,14.085),(2.16,13.915),(1.99,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,13.915),(2.33,14.085),(2.5,14.085),(2.5,13.915),(2.33,13.915)),
        )
        createRL(
            tech, net, 'licon',
            ((2.67,13.915),(2.67,14.085),(2.84,14.085),(2.84,13.915),(2.67,13.915)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,13.87),(0.0,14.13),(90.0,14.13),(90.0,13.87),(0.0,13.87)),
        )
        createRL(
            tech, net, 'li',
            ((87.08,13.915),(87.08,14.085),(89.79,14.085),(89.79,13.915),(87.08,13.915)),
        )
        createRL(
            tech, net, 'li',
            ((87.14,13.915),(87.14,14.085),(89.83,14.085),(89.83,13.915),(87.14,13.915)),
        )
        createRL(
            tech, net, 'li',
            ((0.21,13.915),(0.21,14.085),(2.92,14.085),(2.92,13.915),(0.21,13.915)),
        )
        createRL(
            tech, net, 'li',
            ((0.17,13.915),(0.17,14.085),(2.86,14.085),(2.86,13.915),(0.17,13.915)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(14.0), u(0.26), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(14.0), u(0.26), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'mcon',
            ((0.17,13.915),(0.17,14.085),(0.34,14.085),(0.34,13.915),(0.17,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.53,13.915),(0.53,14.085),(0.7,14.085),(0.7,13.915),(0.53,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((0.89,13.915),(0.89,14.085),(1.06,14.085),(1.06,13.915),(0.89,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.25,13.915),(1.25,14.085),(1.42,14.085),(1.42,13.915),(1.25,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.61,13.915),(1.61,14.085),(1.78,14.085),(1.78,13.915),(1.61,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.97,13.915),(1.97,14.085),(2.14,14.085),(2.14,13.915),(1.97,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.33,13.915),(2.33,14.085),(2.5,14.085),(2.5,13.915),(2.33,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.69,13.915),(2.69,14.085),(2.86,14.085),(2.86,13.915),(2.69,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.14,13.915),(87.14,14.085),(87.31,14.085),(87.31,13.915),(87.14,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.5,13.915),(87.5,14.085),(87.67,14.085),(87.67,13.915),(87.5,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.86,13.915),(87.86,14.085),(88.03,14.085),(88.03,13.915),(87.86,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((88.22,13.915),(88.22,14.085),(88.39,14.085),(88.39,13.915),(88.22,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((88.58,13.915),(88.58,14.085),(88.75,14.085),(88.75,13.915),(88.58,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((88.94,13.915),(88.94,14.085),(89.11,14.085),(89.11,13.915),(88.94,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((89.3,13.915),(89.3,14.085),(89.47,14.085),(89.47,13.915),(89.3,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((89.66,13.915),(89.66,14.085),(89.83,14.085),(89.83,13.915),(89.66,13.915)),
        )
        createRL(
            tech, net, 'm1',
            ((87.11,13.855),(87.11,14.145),(89.86,14.145),(89.86,13.855),(87.11,13.855)),
        )
        createRL(
            tech, net, 'm1',
            ((0.14,13.855),(0.14,14.145),(2.89,14.145),(2.89,13.855),(0.14,13.855)),
        )
        createRL(
            tech, net, 'm1',
            ((87.36,13.84),(87.36,14.16),(89.86,14.16),(89.86,13.84),(87.36,13.84)),
        )
        createRL(
            tech, net, 'm1',
            ((0.14,13.84),(0.14,14.16),(2.64,14.16),(2.64,13.84),(0.14,13.84)),
        )
        createRL(
            tech, net, 'via',
            ((0.195,13.925),(0.195,14.075),(0.345,14.075),(0.345,13.925),(0.195,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((0.515,13.925),(0.515,14.075),(0.665,14.075),(0.665,13.925),(0.515,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((0.835,13.925),(0.835,14.075),(0.985,14.075),(0.985,13.925),(0.835,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((1.155,13.925),(1.155,14.075),(1.305,14.075),(1.305,13.925),(1.155,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((1.475,13.925),(1.475,14.075),(1.625,14.075),(1.625,13.925),(1.475,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((1.795,13.925),(1.795,14.075),(1.945,14.075),(1.945,13.925),(1.795,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((2.115,13.925),(2.115,14.075),(2.265,14.075),(2.265,13.925),(2.115,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((2.435,13.925),(2.435,14.075),(2.585,14.075),(2.585,13.925),(2.435,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((87.415,13.925),(87.415,14.075),(87.565,14.075),(87.565,13.925),(87.415,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((87.735,13.925),(87.735,14.075),(87.885,14.075),(87.885,13.925),(87.735,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((88.055,13.925),(88.055,14.075),(88.205,14.075),(88.205,13.925),(88.055,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((88.375,13.925),(88.375,14.075),(88.525,14.075),(88.525,13.925),(88.375,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((88.695,13.925),(88.695,14.075),(88.845,14.075),(88.845,13.925),(88.695,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((89.015,13.925),(89.015,14.075),(89.165,14.075),(89.165,13.925),(89.015,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((89.335,13.925),(89.335,14.075),(89.485,14.075),(89.485,13.925),(89.335,13.925)),
        )
        createRL(
            tech, net, 'via',
            ((89.655,13.925),(89.655,14.075),(89.805,14.075),(89.805,13.925),(89.655,13.925)),
        )
        createRL(
            tech, net, 'm2',
            ((87.36,13.84),(87.36,14.16),(89.86,14.16),(89.86,13.84),(87.36,13.84)),
        )
        createRL(
            tech, net, 'm2',
            ((0.14,13.84),(0.14,14.16),(2.64,14.16),(2.64,13.84),(0.14,13.84)),
        )
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((0.17,-29.785),(0.17,-6.475),(89.83,-6.475),(89.83,-29.785),(0.17,-29.785)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,-29.96),(0.0,-6.305),(90.0,-6.305),(90.0,-29.96),(0.0,-29.96)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-29.435),(0.29,-29.265),(0.46,-29.265),(0.46,-29.435),(0.29,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-29.435),(0.8,-29.265),(0.97,-29.265),(0.97,-29.435),(0.8,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-29.435),(1.31,-29.265),(1.48,-29.265),(1.48,-29.435),(1.31,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-29.435),(1.82,-29.265),(1.99,-29.265),(1.99,-29.435),(1.82,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-29.435),(2.33,-29.265),(2.5,-29.265),(2.5,-29.435),(2.33,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-29.435),(2.84,-29.265),(3.01,-29.265),(3.01,-29.435),(2.84,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-29.435),(3.35,-29.265),(3.52,-29.265),(3.52,-29.435),(3.35,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-29.435),(3.86,-29.265),(4.03,-29.265),(4.03,-29.435),(3.86,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-29.435),(4.37,-29.265),(4.54,-29.265),(4.54,-29.435),(4.37,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-29.435),(4.88,-29.265),(5.05,-29.265),(5.05,-29.435),(4.88,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-29.435),(5.39,-29.265),(5.56,-29.265),(5.56,-29.435),(5.39,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-29.435),(5.9,-29.265),(6.07,-29.265),(6.07,-29.435),(5.9,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-29.435),(6.41,-29.265),(6.58,-29.265),(6.58,-29.435),(6.41,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-29.435),(6.92,-29.265),(7.09,-29.265),(7.09,-29.435),(6.92,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-29.435),(7.43,-29.265),(7.6,-29.265),(7.6,-29.435),(7.43,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-29.435),(7.94,-29.265),(8.11,-29.265),(8.11,-29.435),(7.94,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-29.435),(8.45,-29.265),(8.62,-29.265),(8.62,-29.435),(8.45,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-29.435),(8.96,-29.265),(9.13,-29.265),(9.13,-29.435),(8.96,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-29.435),(9.47,-29.265),(9.64,-29.265),(9.64,-29.435),(9.47,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-29.435),(9.98,-29.265),(10.15,-29.265),(10.15,-29.435),(9.98,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-29.435),(10.49,-29.265),(10.66,-29.265),(10.66,-29.435),(10.49,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-29.435),(11.0,-29.265),(11.17,-29.265),(11.17,-29.435),(11.0,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-29.435),(11.51,-29.265),(11.68,-29.265),(11.68,-29.435),(11.51,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-29.435),(12.02,-29.265),(12.19,-29.265),(12.19,-29.435),(12.02,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-29.435),(12.53,-29.265),(12.7,-29.265),(12.7,-29.435),(12.53,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-29.435),(13.04,-29.265),(13.21,-29.265),(13.21,-29.435),(13.04,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-29.435),(13.55,-29.265),(13.72,-29.265),(13.72,-29.435),(13.55,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-29.435),(14.06,-29.265),(14.23,-29.265),(14.23,-29.435),(14.06,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-29.435),(14.57,-29.265),(14.74,-29.265),(14.74,-29.435),(14.57,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-29.435),(15.08,-29.265),(15.25,-29.265),(15.25,-29.435),(15.08,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-29.435),(15.59,-29.265),(15.76,-29.265),(15.76,-29.435),(15.59,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-29.435),(16.1,-29.265),(16.27,-29.265),(16.27,-29.435),(16.1,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-29.435),(16.61,-29.265),(16.78,-29.265),(16.78,-29.435),(16.61,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-29.435),(17.12,-29.265),(17.29,-29.265),(17.29,-29.435),(17.12,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-29.435),(17.63,-29.265),(17.8,-29.265),(17.8,-29.435),(17.63,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-29.435),(18.14,-29.265),(18.31,-29.265),(18.31,-29.435),(18.14,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-29.435),(18.65,-29.265),(18.82,-29.265),(18.82,-29.435),(18.65,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-29.435),(19.16,-29.265),(19.33,-29.265),(19.33,-29.435),(19.16,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-29.435),(19.67,-29.265),(19.84,-29.265),(19.84,-29.435),(19.67,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-29.435),(20.18,-29.265),(20.35,-29.265),(20.35,-29.435),(20.18,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-29.435),(20.69,-29.265),(20.86,-29.265),(20.86,-29.435),(20.69,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-29.435),(21.2,-29.265),(21.37,-29.265),(21.37,-29.435),(21.2,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-29.435),(21.71,-29.265),(21.88,-29.265),(21.88,-29.435),(21.71,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-29.435),(22.22,-29.265),(22.39,-29.265),(22.39,-29.435),(22.22,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-29.435),(22.73,-29.265),(22.9,-29.265),(22.9,-29.435),(22.73,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-29.435),(23.24,-29.265),(23.41,-29.265),(23.41,-29.435),(23.24,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-29.435),(23.75,-29.265),(23.92,-29.265),(23.92,-29.435),(23.75,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-29.435),(24.26,-29.265),(24.43,-29.265),(24.43,-29.435),(24.26,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-29.435),(24.77,-29.265),(24.94,-29.265),(24.94,-29.435),(24.77,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-29.435),(25.28,-29.265),(25.45,-29.265),(25.45,-29.435),(25.28,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-29.435),(25.79,-29.265),(25.96,-29.265),(25.96,-29.435),(25.79,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-29.435),(26.3,-29.265),(26.47,-29.265),(26.47,-29.435),(26.3,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-29.435),(26.81,-29.265),(26.98,-29.265),(26.98,-29.435),(26.81,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-29.435),(27.32,-29.265),(27.49,-29.265),(27.49,-29.435),(27.32,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-29.435),(27.83,-29.265),(28.0,-29.265),(28.0,-29.435),(27.83,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-29.435),(28.34,-29.265),(28.51,-29.265),(28.51,-29.435),(28.34,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-29.435),(28.85,-29.265),(29.02,-29.265),(29.02,-29.435),(28.85,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-29.435),(29.36,-29.265),(29.53,-29.265),(29.53,-29.435),(29.36,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-29.435),(29.87,-29.265),(30.04,-29.265),(30.04,-29.435),(29.87,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-29.435),(30.38,-29.265),(30.55,-29.265),(30.55,-29.435),(30.38,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-29.435),(30.89,-29.265),(31.06,-29.265),(31.06,-29.435),(30.89,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-29.435),(31.4,-29.265),(31.57,-29.265),(31.57,-29.435),(31.4,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-29.435),(31.91,-29.265),(32.08,-29.265),(32.08,-29.435),(31.91,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-29.435),(32.42,-29.265),(32.59,-29.265),(32.59,-29.435),(32.42,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-29.435),(32.93,-29.265),(33.1,-29.265),(33.1,-29.435),(32.93,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-29.435),(33.44,-29.265),(33.61,-29.265),(33.61,-29.435),(33.44,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-29.435),(33.95,-29.265),(34.12,-29.265),(34.12,-29.435),(33.95,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-29.435),(34.46,-29.265),(34.63,-29.265),(34.63,-29.435),(34.46,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-29.435),(34.97,-29.265),(35.14,-29.265),(35.14,-29.435),(34.97,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-29.435),(35.48,-29.265),(35.65,-29.265),(35.65,-29.435),(35.48,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-29.435),(35.99,-29.265),(36.16,-29.265),(36.16,-29.435),(35.99,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-29.435),(36.5,-29.265),(36.67,-29.265),(36.67,-29.435),(36.5,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-29.435),(37.01,-29.265),(37.18,-29.265),(37.18,-29.435),(37.01,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-29.435),(37.52,-29.265),(37.69,-29.265),(37.69,-29.435),(37.52,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-29.435),(38.03,-29.265),(38.2,-29.265),(38.2,-29.435),(38.03,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-29.435),(38.54,-29.265),(38.71,-29.265),(38.71,-29.435),(38.54,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-29.435),(39.05,-29.265),(39.22,-29.265),(39.22,-29.435),(39.05,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-29.435),(39.56,-29.265),(39.73,-29.265),(39.73,-29.435),(39.56,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-29.435),(40.07,-29.265),(40.24,-29.265),(40.24,-29.435),(40.07,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-29.435),(40.58,-29.265),(40.75,-29.265),(40.75,-29.435),(40.58,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-29.435),(41.09,-29.265),(41.26,-29.265),(41.26,-29.435),(41.09,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-29.435),(41.6,-29.265),(41.77,-29.265),(41.77,-29.435),(41.6,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-29.435),(42.11,-29.265),(42.28,-29.265),(42.28,-29.435),(42.11,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-29.435),(42.62,-29.265),(42.79,-29.265),(42.79,-29.435),(42.62,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-29.435),(43.13,-29.265),(43.3,-29.265),(43.3,-29.435),(43.13,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-29.435),(43.64,-29.265),(43.81,-29.265),(43.81,-29.435),(43.64,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-29.435),(44.15,-29.265),(44.32,-29.265),(44.32,-29.435),(44.15,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-29.435),(44.66,-29.265),(44.83,-29.265),(44.83,-29.435),(44.66,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-29.435),(45.17,-29.265),(45.34,-29.265),(45.34,-29.435),(45.17,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-29.435),(45.68,-29.265),(45.85,-29.265),(45.85,-29.435),(45.68,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-29.435),(46.19,-29.265),(46.36,-29.265),(46.36,-29.435),(46.19,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-29.435),(46.7,-29.265),(46.87,-29.265),(46.87,-29.435),(46.7,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-29.435),(47.21,-29.265),(47.38,-29.265),(47.38,-29.435),(47.21,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-29.435),(47.72,-29.265),(47.89,-29.265),(47.89,-29.435),(47.72,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-29.435),(48.23,-29.265),(48.4,-29.265),(48.4,-29.435),(48.23,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-29.435),(48.74,-29.265),(48.91,-29.265),(48.91,-29.435),(48.74,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-29.435),(49.25,-29.265),(49.42,-29.265),(49.42,-29.435),(49.25,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-29.435),(49.76,-29.265),(49.93,-29.265),(49.93,-29.435),(49.76,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-29.435),(50.27,-29.265),(50.44,-29.265),(50.44,-29.435),(50.27,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-29.435),(50.78,-29.265),(50.95,-29.265),(50.95,-29.435),(50.78,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-29.435),(51.29,-29.265),(51.46,-29.265),(51.46,-29.435),(51.29,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-29.435),(51.8,-29.265),(51.97,-29.265),(51.97,-29.435),(51.8,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-29.435),(52.31,-29.265),(52.48,-29.265),(52.48,-29.435),(52.31,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-29.435),(52.82,-29.265),(52.99,-29.265),(52.99,-29.435),(52.82,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-29.435),(53.33,-29.265),(53.5,-29.265),(53.5,-29.435),(53.33,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-29.435),(53.84,-29.265),(54.01,-29.265),(54.01,-29.435),(53.84,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-29.435),(54.35,-29.265),(54.52,-29.265),(54.52,-29.435),(54.35,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-29.435),(54.86,-29.265),(55.03,-29.265),(55.03,-29.435),(54.86,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-29.435),(55.37,-29.265),(55.54,-29.265),(55.54,-29.435),(55.37,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-29.435),(55.88,-29.265),(56.05,-29.265),(56.05,-29.435),(55.88,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-29.435),(56.39,-29.265),(56.56,-29.265),(56.56,-29.435),(56.39,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-29.435),(56.9,-29.265),(57.07,-29.265),(57.07,-29.435),(56.9,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-29.435),(57.41,-29.265),(57.58,-29.265),(57.58,-29.435),(57.41,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-29.435),(57.92,-29.265),(58.09,-29.265),(58.09,-29.435),(57.92,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-29.435),(58.43,-29.265),(58.6,-29.265),(58.6,-29.435),(58.43,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-29.435),(58.94,-29.265),(59.11,-29.265),(59.11,-29.435),(58.94,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-29.435),(59.45,-29.265),(59.62,-29.265),(59.62,-29.435),(59.45,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-29.435),(59.96,-29.265),(60.13,-29.265),(60.13,-29.435),(59.96,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-29.435),(60.47,-29.265),(60.64,-29.265),(60.64,-29.435),(60.47,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-29.435),(60.98,-29.265),(61.15,-29.265),(61.15,-29.435),(60.98,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-29.435),(61.49,-29.265),(61.66,-29.265),(61.66,-29.435),(61.49,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-29.435),(62.0,-29.265),(62.17,-29.265),(62.17,-29.435),(62.0,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-29.435),(62.51,-29.265),(62.68,-29.265),(62.68,-29.435),(62.51,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-29.435),(63.02,-29.265),(63.19,-29.265),(63.19,-29.435),(63.02,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-29.435),(63.53,-29.265),(63.7,-29.265),(63.7,-29.435),(63.53,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-29.435),(64.04,-29.265),(64.21,-29.265),(64.21,-29.435),(64.04,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-29.435),(64.55,-29.265),(64.72,-29.265),(64.72,-29.435),(64.55,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-29.435),(65.06,-29.265),(65.23,-29.265),(65.23,-29.435),(65.06,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-29.435),(65.57,-29.265),(65.74,-29.265),(65.74,-29.435),(65.57,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-29.435),(66.08,-29.265),(66.25,-29.265),(66.25,-29.435),(66.08,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-29.435),(66.59,-29.265),(66.76,-29.265),(66.76,-29.435),(66.59,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-29.435),(67.1,-29.265),(67.27,-29.265),(67.27,-29.435),(67.1,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-29.435),(67.61,-29.265),(67.78,-29.265),(67.78,-29.435),(67.61,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-29.435),(68.12,-29.265),(68.29,-29.265),(68.29,-29.435),(68.12,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-29.435),(68.63,-29.265),(68.8,-29.265),(68.8,-29.435),(68.63,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-29.435),(69.14,-29.265),(69.31,-29.265),(69.31,-29.435),(69.14,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-29.435),(69.65,-29.265),(69.82,-29.265),(69.82,-29.435),(69.65,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-29.435),(70.16,-29.265),(70.33,-29.265),(70.33,-29.435),(70.16,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-29.435),(70.67,-29.265),(70.84,-29.265),(70.84,-29.435),(70.67,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-29.435),(71.18,-29.265),(71.35,-29.265),(71.35,-29.435),(71.18,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-29.435),(71.69,-29.265),(71.86,-29.265),(71.86,-29.435),(71.69,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-29.435),(72.2,-29.265),(72.37,-29.265),(72.37,-29.435),(72.2,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-29.435),(72.71,-29.265),(72.88,-29.265),(72.88,-29.435),(72.71,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-29.435),(73.22,-29.265),(73.39,-29.265),(73.39,-29.435),(73.22,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-29.435),(73.73,-29.265),(73.9,-29.265),(73.9,-29.435),(73.73,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-29.435),(74.24,-29.265),(74.41,-29.265),(74.41,-29.435),(74.24,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-29.435),(74.75,-29.265),(74.92,-29.265),(74.92,-29.435),(74.75,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-29.435),(75.26,-29.265),(75.43,-29.265),(75.43,-29.435),(75.26,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-29.435),(75.77,-29.265),(75.94,-29.265),(75.94,-29.435),(75.77,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-29.435),(76.28,-29.265),(76.45,-29.265),(76.45,-29.435),(76.28,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-29.435),(76.79,-29.265),(76.96,-29.265),(76.96,-29.435),(76.79,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-29.435),(77.3,-29.265),(77.47,-29.265),(77.47,-29.435),(77.3,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-29.435),(77.81,-29.265),(77.98,-29.265),(77.98,-29.435),(77.81,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-29.435),(78.32,-29.265),(78.49,-29.265),(78.49,-29.435),(78.32,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-29.435),(78.83,-29.265),(79.0,-29.265),(79.0,-29.435),(78.83,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-29.435),(79.34,-29.265),(79.51,-29.265),(79.51,-29.435),(79.34,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-29.435),(79.85,-29.265),(80.02,-29.265),(80.02,-29.435),(79.85,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-29.435),(80.36,-29.265),(80.53,-29.265),(80.53,-29.435),(80.36,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-29.435),(80.87,-29.265),(81.04,-29.265),(81.04,-29.435),(80.87,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-29.435),(81.38,-29.265),(81.55,-29.265),(81.55,-29.435),(81.38,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-29.435),(81.89,-29.265),(82.06,-29.265),(82.06,-29.435),(81.89,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-29.435),(82.4,-29.265),(82.57,-29.265),(82.57,-29.435),(82.4,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-29.435),(82.91,-29.265),(83.08,-29.265),(83.08,-29.435),(82.91,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-29.435),(83.42,-29.265),(83.59,-29.265),(83.59,-29.435),(83.42,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-29.435),(83.93,-29.265),(84.1,-29.265),(84.1,-29.435),(83.93,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-29.435),(84.44,-29.265),(84.61,-29.265),(84.61,-29.435),(84.44,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-29.435),(84.95,-29.265),(85.12,-29.265),(85.12,-29.435),(84.95,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-29.435),(85.46,-29.265),(85.63,-29.265),(85.63,-29.435),(85.46,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-29.435),(85.97,-29.265),(86.14,-29.265),(86.14,-29.435),(85.97,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-29.435),(86.48,-29.265),(86.65,-29.265),(86.65,-29.435),(86.48,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-29.435),(86.99,-29.265),(87.16,-29.265),(87.16,-29.435),(86.99,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-29.435),(87.5,-29.265),(87.67,-29.265),(87.67,-29.435),(87.5,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-29.435),(88.01,-29.265),(88.18,-29.265),(88.18,-29.435),(88.01,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-29.435),(88.52,-29.265),(88.69,-29.265),(88.69,-29.435),(88.52,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-29.435),(89.03,-29.265),(89.2,-29.265),(89.2,-29.435),(89.03,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-29.435),(89.54,-29.265),(89.71,-29.265),(89.71,-29.435),(89.54,-29.435)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-28.925),(0.29,-28.755),(0.46,-28.755),(0.46,-28.925),(0.29,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-28.925),(0.8,-28.755),(0.97,-28.755),(0.97,-28.925),(0.8,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-28.925),(1.31,-28.755),(1.48,-28.755),(1.48,-28.925),(1.31,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-28.925),(1.82,-28.755),(1.99,-28.755),(1.99,-28.925),(1.82,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-28.925),(2.33,-28.755),(2.5,-28.755),(2.5,-28.925),(2.33,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-28.925),(2.84,-28.755),(3.01,-28.755),(3.01,-28.925),(2.84,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-28.925),(3.35,-28.755),(3.52,-28.755),(3.52,-28.925),(3.35,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-28.925),(3.86,-28.755),(4.03,-28.755),(4.03,-28.925),(3.86,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-28.925),(4.37,-28.755),(4.54,-28.755),(4.54,-28.925),(4.37,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-28.925),(4.88,-28.755),(5.05,-28.755),(5.05,-28.925),(4.88,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-28.925),(5.39,-28.755),(5.56,-28.755),(5.56,-28.925),(5.39,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-28.925),(5.9,-28.755),(6.07,-28.755),(6.07,-28.925),(5.9,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-28.925),(6.41,-28.755),(6.58,-28.755),(6.58,-28.925),(6.41,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-28.925),(6.92,-28.755),(7.09,-28.755),(7.09,-28.925),(6.92,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-28.925),(7.43,-28.755),(7.6,-28.755),(7.6,-28.925),(7.43,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-28.925),(7.94,-28.755),(8.11,-28.755),(8.11,-28.925),(7.94,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-28.925),(8.45,-28.755),(8.62,-28.755),(8.62,-28.925),(8.45,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-28.925),(8.96,-28.755),(9.13,-28.755),(9.13,-28.925),(8.96,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-28.925),(9.47,-28.755),(9.64,-28.755),(9.64,-28.925),(9.47,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-28.925),(9.98,-28.755),(10.15,-28.755),(10.15,-28.925),(9.98,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-28.925),(10.49,-28.755),(10.66,-28.755),(10.66,-28.925),(10.49,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-28.925),(11.0,-28.755),(11.17,-28.755),(11.17,-28.925),(11.0,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-28.925),(11.51,-28.755),(11.68,-28.755),(11.68,-28.925),(11.51,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-28.925),(12.02,-28.755),(12.19,-28.755),(12.19,-28.925),(12.02,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-28.925),(12.53,-28.755),(12.7,-28.755),(12.7,-28.925),(12.53,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-28.925),(13.04,-28.755),(13.21,-28.755),(13.21,-28.925),(13.04,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-28.925),(13.55,-28.755),(13.72,-28.755),(13.72,-28.925),(13.55,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-28.925),(14.06,-28.755),(14.23,-28.755),(14.23,-28.925),(14.06,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-28.925),(14.57,-28.755),(14.74,-28.755),(14.74,-28.925),(14.57,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-28.925),(15.08,-28.755),(15.25,-28.755),(15.25,-28.925),(15.08,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-28.925),(15.59,-28.755),(15.76,-28.755),(15.76,-28.925),(15.59,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-28.925),(16.1,-28.755),(16.27,-28.755),(16.27,-28.925),(16.1,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-28.925),(16.61,-28.755),(16.78,-28.755),(16.78,-28.925),(16.61,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-28.925),(17.12,-28.755),(17.29,-28.755),(17.29,-28.925),(17.12,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-28.925),(17.63,-28.755),(17.8,-28.755),(17.8,-28.925),(17.63,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-28.925),(18.14,-28.755),(18.31,-28.755),(18.31,-28.925),(18.14,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-28.925),(18.65,-28.755),(18.82,-28.755),(18.82,-28.925),(18.65,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-28.925),(19.16,-28.755),(19.33,-28.755),(19.33,-28.925),(19.16,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-28.925),(19.67,-28.755),(19.84,-28.755),(19.84,-28.925),(19.67,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-28.925),(20.18,-28.755),(20.35,-28.755),(20.35,-28.925),(20.18,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-28.925),(20.69,-28.755),(20.86,-28.755),(20.86,-28.925),(20.69,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-28.925),(21.2,-28.755),(21.37,-28.755),(21.37,-28.925),(21.2,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-28.925),(21.71,-28.755),(21.88,-28.755),(21.88,-28.925),(21.71,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-28.925),(22.22,-28.755),(22.39,-28.755),(22.39,-28.925),(22.22,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-28.925),(22.73,-28.755),(22.9,-28.755),(22.9,-28.925),(22.73,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-28.925),(23.24,-28.755),(23.41,-28.755),(23.41,-28.925),(23.24,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-28.925),(23.75,-28.755),(23.92,-28.755),(23.92,-28.925),(23.75,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-28.925),(24.26,-28.755),(24.43,-28.755),(24.43,-28.925),(24.26,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-28.925),(24.77,-28.755),(24.94,-28.755),(24.94,-28.925),(24.77,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-28.925),(25.28,-28.755),(25.45,-28.755),(25.45,-28.925),(25.28,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-28.925),(25.79,-28.755),(25.96,-28.755),(25.96,-28.925),(25.79,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-28.925),(26.3,-28.755),(26.47,-28.755),(26.47,-28.925),(26.3,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-28.925),(26.81,-28.755),(26.98,-28.755),(26.98,-28.925),(26.81,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-28.925),(27.32,-28.755),(27.49,-28.755),(27.49,-28.925),(27.32,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-28.925),(27.83,-28.755),(28.0,-28.755),(28.0,-28.925),(27.83,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-28.925),(28.34,-28.755),(28.51,-28.755),(28.51,-28.925),(28.34,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-28.925),(28.85,-28.755),(29.02,-28.755),(29.02,-28.925),(28.85,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-28.925),(29.36,-28.755),(29.53,-28.755),(29.53,-28.925),(29.36,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-28.925),(29.87,-28.755),(30.04,-28.755),(30.04,-28.925),(29.87,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-28.925),(30.38,-28.755),(30.55,-28.755),(30.55,-28.925),(30.38,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-28.925),(30.89,-28.755),(31.06,-28.755),(31.06,-28.925),(30.89,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-28.925),(31.4,-28.755),(31.57,-28.755),(31.57,-28.925),(31.4,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-28.925),(31.91,-28.755),(32.08,-28.755),(32.08,-28.925),(31.91,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-28.925),(32.42,-28.755),(32.59,-28.755),(32.59,-28.925),(32.42,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-28.925),(32.93,-28.755),(33.1,-28.755),(33.1,-28.925),(32.93,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-28.925),(33.44,-28.755),(33.61,-28.755),(33.61,-28.925),(33.44,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-28.925),(33.95,-28.755),(34.12,-28.755),(34.12,-28.925),(33.95,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-28.925),(34.46,-28.755),(34.63,-28.755),(34.63,-28.925),(34.46,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-28.925),(34.97,-28.755),(35.14,-28.755),(35.14,-28.925),(34.97,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-28.925),(35.48,-28.755),(35.65,-28.755),(35.65,-28.925),(35.48,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-28.925),(35.99,-28.755),(36.16,-28.755),(36.16,-28.925),(35.99,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-28.925),(36.5,-28.755),(36.67,-28.755),(36.67,-28.925),(36.5,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-28.925),(37.01,-28.755),(37.18,-28.755),(37.18,-28.925),(37.01,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-28.925),(37.52,-28.755),(37.69,-28.755),(37.69,-28.925),(37.52,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-28.925),(38.03,-28.755),(38.2,-28.755),(38.2,-28.925),(38.03,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-28.925),(38.54,-28.755),(38.71,-28.755),(38.71,-28.925),(38.54,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-28.925),(39.05,-28.755),(39.22,-28.755),(39.22,-28.925),(39.05,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-28.925),(39.56,-28.755),(39.73,-28.755),(39.73,-28.925),(39.56,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-28.925),(40.07,-28.755),(40.24,-28.755),(40.24,-28.925),(40.07,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-28.925),(40.58,-28.755),(40.75,-28.755),(40.75,-28.925),(40.58,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-28.925),(41.09,-28.755),(41.26,-28.755),(41.26,-28.925),(41.09,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-28.925),(41.6,-28.755),(41.77,-28.755),(41.77,-28.925),(41.6,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-28.925),(42.11,-28.755),(42.28,-28.755),(42.28,-28.925),(42.11,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-28.925),(42.62,-28.755),(42.79,-28.755),(42.79,-28.925),(42.62,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-28.925),(43.13,-28.755),(43.3,-28.755),(43.3,-28.925),(43.13,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-28.925),(43.64,-28.755),(43.81,-28.755),(43.81,-28.925),(43.64,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-28.925),(44.15,-28.755),(44.32,-28.755),(44.32,-28.925),(44.15,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-28.925),(44.66,-28.755),(44.83,-28.755),(44.83,-28.925),(44.66,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-28.925),(45.17,-28.755),(45.34,-28.755),(45.34,-28.925),(45.17,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-28.925),(45.68,-28.755),(45.85,-28.755),(45.85,-28.925),(45.68,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-28.925),(46.19,-28.755),(46.36,-28.755),(46.36,-28.925),(46.19,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-28.925),(46.7,-28.755),(46.87,-28.755),(46.87,-28.925),(46.7,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-28.925),(47.21,-28.755),(47.38,-28.755),(47.38,-28.925),(47.21,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-28.925),(47.72,-28.755),(47.89,-28.755),(47.89,-28.925),(47.72,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-28.925),(48.23,-28.755),(48.4,-28.755),(48.4,-28.925),(48.23,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-28.925),(48.74,-28.755),(48.91,-28.755),(48.91,-28.925),(48.74,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-28.925),(49.25,-28.755),(49.42,-28.755),(49.42,-28.925),(49.25,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-28.925),(49.76,-28.755),(49.93,-28.755),(49.93,-28.925),(49.76,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-28.925),(50.27,-28.755),(50.44,-28.755),(50.44,-28.925),(50.27,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-28.925),(50.78,-28.755),(50.95,-28.755),(50.95,-28.925),(50.78,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-28.925),(51.29,-28.755),(51.46,-28.755),(51.46,-28.925),(51.29,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-28.925),(51.8,-28.755),(51.97,-28.755),(51.97,-28.925),(51.8,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-28.925),(52.31,-28.755),(52.48,-28.755),(52.48,-28.925),(52.31,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-28.925),(52.82,-28.755),(52.99,-28.755),(52.99,-28.925),(52.82,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-28.925),(53.33,-28.755),(53.5,-28.755),(53.5,-28.925),(53.33,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-28.925),(53.84,-28.755),(54.01,-28.755),(54.01,-28.925),(53.84,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-28.925),(54.35,-28.755),(54.52,-28.755),(54.52,-28.925),(54.35,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-28.925),(54.86,-28.755),(55.03,-28.755),(55.03,-28.925),(54.86,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-28.925),(55.37,-28.755),(55.54,-28.755),(55.54,-28.925),(55.37,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-28.925),(55.88,-28.755),(56.05,-28.755),(56.05,-28.925),(55.88,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-28.925),(56.39,-28.755),(56.56,-28.755),(56.56,-28.925),(56.39,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-28.925),(56.9,-28.755),(57.07,-28.755),(57.07,-28.925),(56.9,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-28.925),(57.41,-28.755),(57.58,-28.755),(57.58,-28.925),(57.41,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-28.925),(57.92,-28.755),(58.09,-28.755),(58.09,-28.925),(57.92,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-28.925),(58.43,-28.755),(58.6,-28.755),(58.6,-28.925),(58.43,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-28.925),(58.94,-28.755),(59.11,-28.755),(59.11,-28.925),(58.94,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-28.925),(59.45,-28.755),(59.62,-28.755),(59.62,-28.925),(59.45,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-28.925),(59.96,-28.755),(60.13,-28.755),(60.13,-28.925),(59.96,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-28.925),(60.47,-28.755),(60.64,-28.755),(60.64,-28.925),(60.47,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-28.925),(60.98,-28.755),(61.15,-28.755),(61.15,-28.925),(60.98,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-28.925),(61.49,-28.755),(61.66,-28.755),(61.66,-28.925),(61.49,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-28.925),(62.0,-28.755),(62.17,-28.755),(62.17,-28.925),(62.0,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-28.925),(62.51,-28.755),(62.68,-28.755),(62.68,-28.925),(62.51,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-28.925),(63.02,-28.755),(63.19,-28.755),(63.19,-28.925),(63.02,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-28.925),(63.53,-28.755),(63.7,-28.755),(63.7,-28.925),(63.53,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-28.925),(64.04,-28.755),(64.21,-28.755),(64.21,-28.925),(64.04,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-28.925),(64.55,-28.755),(64.72,-28.755),(64.72,-28.925),(64.55,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-28.925),(65.06,-28.755),(65.23,-28.755),(65.23,-28.925),(65.06,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-28.925),(65.57,-28.755),(65.74,-28.755),(65.74,-28.925),(65.57,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-28.925),(66.08,-28.755),(66.25,-28.755),(66.25,-28.925),(66.08,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-28.925),(66.59,-28.755),(66.76,-28.755),(66.76,-28.925),(66.59,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-28.925),(67.1,-28.755),(67.27,-28.755),(67.27,-28.925),(67.1,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-28.925),(67.61,-28.755),(67.78,-28.755),(67.78,-28.925),(67.61,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-28.925),(68.12,-28.755),(68.29,-28.755),(68.29,-28.925),(68.12,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-28.925),(68.63,-28.755),(68.8,-28.755),(68.8,-28.925),(68.63,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-28.925),(69.14,-28.755),(69.31,-28.755),(69.31,-28.925),(69.14,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-28.925),(69.65,-28.755),(69.82,-28.755),(69.82,-28.925),(69.65,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-28.925),(70.16,-28.755),(70.33,-28.755),(70.33,-28.925),(70.16,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-28.925),(70.67,-28.755),(70.84,-28.755),(70.84,-28.925),(70.67,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-28.925),(71.18,-28.755),(71.35,-28.755),(71.35,-28.925),(71.18,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-28.925),(71.69,-28.755),(71.86,-28.755),(71.86,-28.925),(71.69,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-28.925),(72.2,-28.755),(72.37,-28.755),(72.37,-28.925),(72.2,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-28.925),(72.71,-28.755),(72.88,-28.755),(72.88,-28.925),(72.71,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-28.925),(73.22,-28.755),(73.39,-28.755),(73.39,-28.925),(73.22,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-28.925),(73.73,-28.755),(73.9,-28.755),(73.9,-28.925),(73.73,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-28.925),(74.24,-28.755),(74.41,-28.755),(74.41,-28.925),(74.24,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-28.925),(74.75,-28.755),(74.92,-28.755),(74.92,-28.925),(74.75,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-28.925),(75.26,-28.755),(75.43,-28.755),(75.43,-28.925),(75.26,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-28.925),(75.77,-28.755),(75.94,-28.755),(75.94,-28.925),(75.77,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-28.925),(76.28,-28.755),(76.45,-28.755),(76.45,-28.925),(76.28,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-28.925),(76.79,-28.755),(76.96,-28.755),(76.96,-28.925),(76.79,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-28.925),(77.3,-28.755),(77.47,-28.755),(77.47,-28.925),(77.3,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-28.925),(77.81,-28.755),(77.98,-28.755),(77.98,-28.925),(77.81,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-28.925),(78.32,-28.755),(78.49,-28.755),(78.49,-28.925),(78.32,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-28.925),(78.83,-28.755),(79.0,-28.755),(79.0,-28.925),(78.83,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-28.925),(79.34,-28.755),(79.51,-28.755),(79.51,-28.925),(79.34,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-28.925),(79.85,-28.755),(80.02,-28.755),(80.02,-28.925),(79.85,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-28.925),(80.36,-28.755),(80.53,-28.755),(80.53,-28.925),(80.36,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-28.925),(80.87,-28.755),(81.04,-28.755),(81.04,-28.925),(80.87,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-28.925),(81.38,-28.755),(81.55,-28.755),(81.55,-28.925),(81.38,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-28.925),(81.89,-28.755),(82.06,-28.755),(82.06,-28.925),(81.89,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-28.925),(82.4,-28.755),(82.57,-28.755),(82.57,-28.925),(82.4,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-28.925),(82.91,-28.755),(83.08,-28.755),(83.08,-28.925),(82.91,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-28.925),(83.42,-28.755),(83.59,-28.755),(83.59,-28.925),(83.42,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-28.925),(83.93,-28.755),(84.1,-28.755),(84.1,-28.925),(83.93,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-28.925),(84.44,-28.755),(84.61,-28.755),(84.61,-28.925),(84.44,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-28.925),(84.95,-28.755),(85.12,-28.755),(85.12,-28.925),(84.95,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-28.925),(85.46,-28.755),(85.63,-28.755),(85.63,-28.925),(85.46,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-28.925),(85.97,-28.755),(86.14,-28.755),(86.14,-28.925),(85.97,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-28.925),(86.48,-28.755),(86.65,-28.755),(86.65,-28.925),(86.48,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-28.925),(86.99,-28.755),(87.16,-28.755),(87.16,-28.925),(86.99,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-28.925),(87.5,-28.755),(87.67,-28.755),(87.67,-28.925),(87.5,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-28.925),(88.01,-28.755),(88.18,-28.755),(88.18,-28.925),(88.01,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-28.925),(88.52,-28.755),(88.69,-28.755),(88.69,-28.925),(88.52,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-28.925),(89.03,-28.755),(89.2,-28.755),(89.2,-28.925),(89.03,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-28.925),(89.54,-28.755),(89.71,-28.755),(89.71,-28.925),(89.54,-28.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-28.415),(0.29,-28.245),(0.46,-28.245),(0.46,-28.415),(0.29,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-28.415),(0.8,-28.245),(0.97,-28.245),(0.97,-28.415),(0.8,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-28.415),(1.31,-28.245),(1.48,-28.245),(1.48,-28.415),(1.31,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-28.415),(1.82,-28.245),(1.99,-28.245),(1.99,-28.415),(1.82,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-28.415),(2.33,-28.245),(2.5,-28.245),(2.5,-28.415),(2.33,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-28.415),(2.84,-28.245),(3.01,-28.245),(3.01,-28.415),(2.84,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-28.415),(3.35,-28.245),(3.52,-28.245),(3.52,-28.415),(3.35,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-28.415),(3.86,-28.245),(4.03,-28.245),(4.03,-28.415),(3.86,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-28.415),(4.37,-28.245),(4.54,-28.245),(4.54,-28.415),(4.37,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-28.415),(4.88,-28.245),(5.05,-28.245),(5.05,-28.415),(4.88,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-28.415),(5.39,-28.245),(5.56,-28.245),(5.56,-28.415),(5.39,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-28.415),(5.9,-28.245),(6.07,-28.245),(6.07,-28.415),(5.9,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-28.415),(6.41,-28.245),(6.58,-28.245),(6.58,-28.415),(6.41,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-28.415),(6.92,-28.245),(7.09,-28.245),(7.09,-28.415),(6.92,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-28.415),(7.43,-28.245),(7.6,-28.245),(7.6,-28.415),(7.43,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-28.415),(7.94,-28.245),(8.11,-28.245),(8.11,-28.415),(7.94,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-28.415),(8.45,-28.245),(8.62,-28.245),(8.62,-28.415),(8.45,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-28.415),(8.96,-28.245),(9.13,-28.245),(9.13,-28.415),(8.96,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-28.415),(9.47,-28.245),(9.64,-28.245),(9.64,-28.415),(9.47,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-28.415),(9.98,-28.245),(10.15,-28.245),(10.15,-28.415),(9.98,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-28.415),(10.49,-28.245),(10.66,-28.245),(10.66,-28.415),(10.49,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-28.415),(11.0,-28.245),(11.17,-28.245),(11.17,-28.415),(11.0,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-28.415),(11.51,-28.245),(11.68,-28.245),(11.68,-28.415),(11.51,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-28.415),(12.02,-28.245),(12.19,-28.245),(12.19,-28.415),(12.02,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-28.415),(12.53,-28.245),(12.7,-28.245),(12.7,-28.415),(12.53,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-28.415),(13.04,-28.245),(13.21,-28.245),(13.21,-28.415),(13.04,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-28.415),(13.55,-28.245),(13.72,-28.245),(13.72,-28.415),(13.55,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-28.415),(14.06,-28.245),(14.23,-28.245),(14.23,-28.415),(14.06,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-28.415),(14.57,-28.245),(14.74,-28.245),(14.74,-28.415),(14.57,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-28.415),(15.08,-28.245),(15.25,-28.245),(15.25,-28.415),(15.08,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-28.415),(15.59,-28.245),(15.76,-28.245),(15.76,-28.415),(15.59,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-28.415),(16.1,-28.245),(16.27,-28.245),(16.27,-28.415),(16.1,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-28.415),(16.61,-28.245),(16.78,-28.245),(16.78,-28.415),(16.61,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-28.415),(17.12,-28.245),(17.29,-28.245),(17.29,-28.415),(17.12,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-28.415),(17.63,-28.245),(17.8,-28.245),(17.8,-28.415),(17.63,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-28.415),(18.14,-28.245),(18.31,-28.245),(18.31,-28.415),(18.14,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-28.415),(18.65,-28.245),(18.82,-28.245),(18.82,-28.415),(18.65,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-28.415),(19.16,-28.245),(19.33,-28.245),(19.33,-28.415),(19.16,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-28.415),(19.67,-28.245),(19.84,-28.245),(19.84,-28.415),(19.67,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-28.415),(20.18,-28.245),(20.35,-28.245),(20.35,-28.415),(20.18,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-28.415),(20.69,-28.245),(20.86,-28.245),(20.86,-28.415),(20.69,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-28.415),(21.2,-28.245),(21.37,-28.245),(21.37,-28.415),(21.2,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-28.415),(21.71,-28.245),(21.88,-28.245),(21.88,-28.415),(21.71,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-28.415),(22.22,-28.245),(22.39,-28.245),(22.39,-28.415),(22.22,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-28.415),(22.73,-28.245),(22.9,-28.245),(22.9,-28.415),(22.73,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-28.415),(23.24,-28.245),(23.41,-28.245),(23.41,-28.415),(23.24,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-28.415),(23.75,-28.245),(23.92,-28.245),(23.92,-28.415),(23.75,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-28.415),(24.26,-28.245),(24.43,-28.245),(24.43,-28.415),(24.26,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-28.415),(24.77,-28.245),(24.94,-28.245),(24.94,-28.415),(24.77,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-28.415),(25.28,-28.245),(25.45,-28.245),(25.45,-28.415),(25.28,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-28.415),(25.79,-28.245),(25.96,-28.245),(25.96,-28.415),(25.79,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-28.415),(26.3,-28.245),(26.47,-28.245),(26.47,-28.415),(26.3,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-28.415),(26.81,-28.245),(26.98,-28.245),(26.98,-28.415),(26.81,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-28.415),(27.32,-28.245),(27.49,-28.245),(27.49,-28.415),(27.32,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-28.415),(27.83,-28.245),(28.0,-28.245),(28.0,-28.415),(27.83,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-28.415),(28.34,-28.245),(28.51,-28.245),(28.51,-28.415),(28.34,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-28.415),(28.85,-28.245),(29.02,-28.245),(29.02,-28.415),(28.85,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-28.415),(29.36,-28.245),(29.53,-28.245),(29.53,-28.415),(29.36,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-28.415),(29.87,-28.245),(30.04,-28.245),(30.04,-28.415),(29.87,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-28.415),(30.38,-28.245),(30.55,-28.245),(30.55,-28.415),(30.38,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-28.415),(30.89,-28.245),(31.06,-28.245),(31.06,-28.415),(30.89,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-28.415),(31.4,-28.245),(31.57,-28.245),(31.57,-28.415),(31.4,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-28.415),(31.91,-28.245),(32.08,-28.245),(32.08,-28.415),(31.91,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-28.415),(32.42,-28.245),(32.59,-28.245),(32.59,-28.415),(32.42,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-28.415),(32.93,-28.245),(33.1,-28.245),(33.1,-28.415),(32.93,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-28.415),(33.44,-28.245),(33.61,-28.245),(33.61,-28.415),(33.44,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-28.415),(33.95,-28.245),(34.12,-28.245),(34.12,-28.415),(33.95,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-28.415),(34.46,-28.245),(34.63,-28.245),(34.63,-28.415),(34.46,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-28.415),(34.97,-28.245),(35.14,-28.245),(35.14,-28.415),(34.97,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-28.415),(35.48,-28.245),(35.65,-28.245),(35.65,-28.415),(35.48,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-28.415),(35.99,-28.245),(36.16,-28.245),(36.16,-28.415),(35.99,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-28.415),(36.5,-28.245),(36.67,-28.245),(36.67,-28.415),(36.5,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-28.415),(37.01,-28.245),(37.18,-28.245),(37.18,-28.415),(37.01,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-28.415),(37.52,-28.245),(37.69,-28.245),(37.69,-28.415),(37.52,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-28.415),(38.03,-28.245),(38.2,-28.245),(38.2,-28.415),(38.03,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-28.415),(38.54,-28.245),(38.71,-28.245),(38.71,-28.415),(38.54,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-28.415),(39.05,-28.245),(39.22,-28.245),(39.22,-28.415),(39.05,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-28.415),(39.56,-28.245),(39.73,-28.245),(39.73,-28.415),(39.56,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-28.415),(40.07,-28.245),(40.24,-28.245),(40.24,-28.415),(40.07,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-28.415),(40.58,-28.245),(40.75,-28.245),(40.75,-28.415),(40.58,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-28.415),(41.09,-28.245),(41.26,-28.245),(41.26,-28.415),(41.09,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-28.415),(41.6,-28.245),(41.77,-28.245),(41.77,-28.415),(41.6,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-28.415),(42.11,-28.245),(42.28,-28.245),(42.28,-28.415),(42.11,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-28.415),(42.62,-28.245),(42.79,-28.245),(42.79,-28.415),(42.62,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-28.415),(43.13,-28.245),(43.3,-28.245),(43.3,-28.415),(43.13,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-28.415),(43.64,-28.245),(43.81,-28.245),(43.81,-28.415),(43.64,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-28.415),(44.15,-28.245),(44.32,-28.245),(44.32,-28.415),(44.15,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-28.415),(44.66,-28.245),(44.83,-28.245),(44.83,-28.415),(44.66,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-28.415),(45.17,-28.245),(45.34,-28.245),(45.34,-28.415),(45.17,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-28.415),(45.68,-28.245),(45.85,-28.245),(45.85,-28.415),(45.68,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-28.415),(46.19,-28.245),(46.36,-28.245),(46.36,-28.415),(46.19,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-28.415),(46.7,-28.245),(46.87,-28.245),(46.87,-28.415),(46.7,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-28.415),(47.21,-28.245),(47.38,-28.245),(47.38,-28.415),(47.21,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-28.415),(47.72,-28.245),(47.89,-28.245),(47.89,-28.415),(47.72,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-28.415),(48.23,-28.245),(48.4,-28.245),(48.4,-28.415),(48.23,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-28.415),(48.74,-28.245),(48.91,-28.245),(48.91,-28.415),(48.74,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-28.415),(49.25,-28.245),(49.42,-28.245),(49.42,-28.415),(49.25,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-28.415),(49.76,-28.245),(49.93,-28.245),(49.93,-28.415),(49.76,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-28.415),(50.27,-28.245),(50.44,-28.245),(50.44,-28.415),(50.27,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-28.415),(50.78,-28.245),(50.95,-28.245),(50.95,-28.415),(50.78,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-28.415),(51.29,-28.245),(51.46,-28.245),(51.46,-28.415),(51.29,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-28.415),(51.8,-28.245),(51.97,-28.245),(51.97,-28.415),(51.8,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-28.415),(52.31,-28.245),(52.48,-28.245),(52.48,-28.415),(52.31,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-28.415),(52.82,-28.245),(52.99,-28.245),(52.99,-28.415),(52.82,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-28.415),(53.33,-28.245),(53.5,-28.245),(53.5,-28.415),(53.33,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-28.415),(53.84,-28.245),(54.01,-28.245),(54.01,-28.415),(53.84,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-28.415),(54.35,-28.245),(54.52,-28.245),(54.52,-28.415),(54.35,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-28.415),(54.86,-28.245),(55.03,-28.245),(55.03,-28.415),(54.86,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-28.415),(55.37,-28.245),(55.54,-28.245),(55.54,-28.415),(55.37,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-28.415),(55.88,-28.245),(56.05,-28.245),(56.05,-28.415),(55.88,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-28.415),(56.39,-28.245),(56.56,-28.245),(56.56,-28.415),(56.39,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-28.415),(56.9,-28.245),(57.07,-28.245),(57.07,-28.415),(56.9,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-28.415),(57.41,-28.245),(57.58,-28.245),(57.58,-28.415),(57.41,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-28.415),(57.92,-28.245),(58.09,-28.245),(58.09,-28.415),(57.92,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-28.415),(58.43,-28.245),(58.6,-28.245),(58.6,-28.415),(58.43,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-28.415),(58.94,-28.245),(59.11,-28.245),(59.11,-28.415),(58.94,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-28.415),(59.45,-28.245),(59.62,-28.245),(59.62,-28.415),(59.45,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-28.415),(59.96,-28.245),(60.13,-28.245),(60.13,-28.415),(59.96,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-28.415),(60.47,-28.245),(60.64,-28.245),(60.64,-28.415),(60.47,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-28.415),(60.98,-28.245),(61.15,-28.245),(61.15,-28.415),(60.98,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-28.415),(61.49,-28.245),(61.66,-28.245),(61.66,-28.415),(61.49,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-28.415),(62.0,-28.245),(62.17,-28.245),(62.17,-28.415),(62.0,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-28.415),(62.51,-28.245),(62.68,-28.245),(62.68,-28.415),(62.51,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-28.415),(63.02,-28.245),(63.19,-28.245),(63.19,-28.415),(63.02,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-28.415),(63.53,-28.245),(63.7,-28.245),(63.7,-28.415),(63.53,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-28.415),(64.04,-28.245),(64.21,-28.245),(64.21,-28.415),(64.04,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-28.415),(64.55,-28.245),(64.72,-28.245),(64.72,-28.415),(64.55,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-28.415),(65.06,-28.245),(65.23,-28.245),(65.23,-28.415),(65.06,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-28.415),(65.57,-28.245),(65.74,-28.245),(65.74,-28.415),(65.57,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-28.415),(66.08,-28.245),(66.25,-28.245),(66.25,-28.415),(66.08,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-28.415),(66.59,-28.245),(66.76,-28.245),(66.76,-28.415),(66.59,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-28.415),(67.1,-28.245),(67.27,-28.245),(67.27,-28.415),(67.1,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-28.415),(67.61,-28.245),(67.78,-28.245),(67.78,-28.415),(67.61,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-28.415),(68.12,-28.245),(68.29,-28.245),(68.29,-28.415),(68.12,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-28.415),(68.63,-28.245),(68.8,-28.245),(68.8,-28.415),(68.63,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-28.415),(69.14,-28.245),(69.31,-28.245),(69.31,-28.415),(69.14,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-28.415),(69.65,-28.245),(69.82,-28.245),(69.82,-28.415),(69.65,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-28.415),(70.16,-28.245),(70.33,-28.245),(70.33,-28.415),(70.16,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-28.415),(70.67,-28.245),(70.84,-28.245),(70.84,-28.415),(70.67,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-28.415),(71.18,-28.245),(71.35,-28.245),(71.35,-28.415),(71.18,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-28.415),(71.69,-28.245),(71.86,-28.245),(71.86,-28.415),(71.69,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-28.415),(72.2,-28.245),(72.37,-28.245),(72.37,-28.415),(72.2,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-28.415),(72.71,-28.245),(72.88,-28.245),(72.88,-28.415),(72.71,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-28.415),(73.22,-28.245),(73.39,-28.245),(73.39,-28.415),(73.22,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-28.415),(73.73,-28.245),(73.9,-28.245),(73.9,-28.415),(73.73,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-28.415),(74.24,-28.245),(74.41,-28.245),(74.41,-28.415),(74.24,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-28.415),(74.75,-28.245),(74.92,-28.245),(74.92,-28.415),(74.75,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-28.415),(75.26,-28.245),(75.43,-28.245),(75.43,-28.415),(75.26,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-28.415),(75.77,-28.245),(75.94,-28.245),(75.94,-28.415),(75.77,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-28.415),(76.28,-28.245),(76.45,-28.245),(76.45,-28.415),(76.28,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-28.415),(76.79,-28.245),(76.96,-28.245),(76.96,-28.415),(76.79,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-28.415),(77.3,-28.245),(77.47,-28.245),(77.47,-28.415),(77.3,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-28.415),(77.81,-28.245),(77.98,-28.245),(77.98,-28.415),(77.81,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-28.415),(78.32,-28.245),(78.49,-28.245),(78.49,-28.415),(78.32,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-28.415),(78.83,-28.245),(79.0,-28.245),(79.0,-28.415),(78.83,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-28.415),(79.34,-28.245),(79.51,-28.245),(79.51,-28.415),(79.34,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-28.415),(79.85,-28.245),(80.02,-28.245),(80.02,-28.415),(79.85,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-28.415),(80.36,-28.245),(80.53,-28.245),(80.53,-28.415),(80.36,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-28.415),(80.87,-28.245),(81.04,-28.245),(81.04,-28.415),(80.87,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-28.415),(81.38,-28.245),(81.55,-28.245),(81.55,-28.415),(81.38,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-28.415),(81.89,-28.245),(82.06,-28.245),(82.06,-28.415),(81.89,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-28.415),(82.4,-28.245),(82.57,-28.245),(82.57,-28.415),(82.4,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-28.415),(82.91,-28.245),(83.08,-28.245),(83.08,-28.415),(82.91,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-28.415),(83.42,-28.245),(83.59,-28.245),(83.59,-28.415),(83.42,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-28.415),(83.93,-28.245),(84.1,-28.245),(84.1,-28.415),(83.93,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-28.415),(84.44,-28.245),(84.61,-28.245),(84.61,-28.415),(84.44,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-28.415),(84.95,-28.245),(85.12,-28.245),(85.12,-28.415),(84.95,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-28.415),(85.46,-28.245),(85.63,-28.245),(85.63,-28.415),(85.46,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-28.415),(85.97,-28.245),(86.14,-28.245),(86.14,-28.415),(85.97,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-28.415),(86.48,-28.245),(86.65,-28.245),(86.65,-28.415),(86.48,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-28.415),(86.99,-28.245),(87.16,-28.245),(87.16,-28.415),(86.99,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-28.415),(87.5,-28.245),(87.67,-28.245),(87.67,-28.415),(87.5,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-28.415),(88.01,-28.245),(88.18,-28.245),(88.18,-28.415),(88.01,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-28.415),(88.52,-28.245),(88.69,-28.245),(88.69,-28.415),(88.52,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-28.415),(89.03,-28.245),(89.2,-28.245),(89.2,-28.415),(89.03,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-28.415),(89.54,-28.245),(89.71,-28.245),(89.71,-28.415),(89.54,-28.415)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-27.905),(0.29,-27.735),(0.46,-27.735),(0.46,-27.905),(0.29,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-27.905),(0.8,-27.735),(0.97,-27.735),(0.97,-27.905),(0.8,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-27.905),(1.31,-27.735),(1.48,-27.735),(1.48,-27.905),(1.31,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-27.905),(1.82,-27.735),(1.99,-27.735),(1.99,-27.905),(1.82,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-27.905),(2.33,-27.735),(2.5,-27.735),(2.5,-27.905),(2.33,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-27.905),(2.84,-27.735),(3.01,-27.735),(3.01,-27.905),(2.84,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-27.905),(3.35,-27.735),(3.52,-27.735),(3.52,-27.905),(3.35,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-27.905),(3.86,-27.735),(4.03,-27.735),(4.03,-27.905),(3.86,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-27.905),(4.37,-27.735),(4.54,-27.735),(4.54,-27.905),(4.37,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-27.905),(4.88,-27.735),(5.05,-27.735),(5.05,-27.905),(4.88,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-27.905),(5.39,-27.735),(5.56,-27.735),(5.56,-27.905),(5.39,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-27.905),(5.9,-27.735),(6.07,-27.735),(6.07,-27.905),(5.9,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-27.905),(6.41,-27.735),(6.58,-27.735),(6.58,-27.905),(6.41,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-27.905),(6.92,-27.735),(7.09,-27.735),(7.09,-27.905),(6.92,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-27.905),(7.43,-27.735),(7.6,-27.735),(7.6,-27.905),(7.43,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-27.905),(7.94,-27.735),(8.11,-27.735),(8.11,-27.905),(7.94,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-27.905),(8.45,-27.735),(8.62,-27.735),(8.62,-27.905),(8.45,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-27.905),(8.96,-27.735),(9.13,-27.735),(9.13,-27.905),(8.96,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-27.905),(9.47,-27.735),(9.64,-27.735),(9.64,-27.905),(9.47,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-27.905),(9.98,-27.735),(10.15,-27.735),(10.15,-27.905),(9.98,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-27.905),(10.49,-27.735),(10.66,-27.735),(10.66,-27.905),(10.49,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-27.905),(11.0,-27.735),(11.17,-27.735),(11.17,-27.905),(11.0,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-27.905),(11.51,-27.735),(11.68,-27.735),(11.68,-27.905),(11.51,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-27.905),(12.02,-27.735),(12.19,-27.735),(12.19,-27.905),(12.02,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-27.905),(12.53,-27.735),(12.7,-27.735),(12.7,-27.905),(12.53,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-27.905),(13.04,-27.735),(13.21,-27.735),(13.21,-27.905),(13.04,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-27.905),(13.55,-27.735),(13.72,-27.735),(13.72,-27.905),(13.55,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-27.905),(14.06,-27.735),(14.23,-27.735),(14.23,-27.905),(14.06,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-27.905),(14.57,-27.735),(14.74,-27.735),(14.74,-27.905),(14.57,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-27.905),(15.08,-27.735),(15.25,-27.735),(15.25,-27.905),(15.08,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-27.905),(15.59,-27.735),(15.76,-27.735),(15.76,-27.905),(15.59,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-27.905),(16.1,-27.735),(16.27,-27.735),(16.27,-27.905),(16.1,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-27.905),(16.61,-27.735),(16.78,-27.735),(16.78,-27.905),(16.61,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-27.905),(17.12,-27.735),(17.29,-27.735),(17.29,-27.905),(17.12,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-27.905),(17.63,-27.735),(17.8,-27.735),(17.8,-27.905),(17.63,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-27.905),(18.14,-27.735),(18.31,-27.735),(18.31,-27.905),(18.14,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-27.905),(18.65,-27.735),(18.82,-27.735),(18.82,-27.905),(18.65,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-27.905),(19.16,-27.735),(19.33,-27.735),(19.33,-27.905),(19.16,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-27.905),(19.67,-27.735),(19.84,-27.735),(19.84,-27.905),(19.67,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-27.905),(20.18,-27.735),(20.35,-27.735),(20.35,-27.905),(20.18,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-27.905),(20.69,-27.735),(20.86,-27.735),(20.86,-27.905),(20.69,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-27.905),(21.2,-27.735),(21.37,-27.735),(21.37,-27.905),(21.2,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-27.905),(21.71,-27.735),(21.88,-27.735),(21.88,-27.905),(21.71,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-27.905),(22.22,-27.735),(22.39,-27.735),(22.39,-27.905),(22.22,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-27.905),(22.73,-27.735),(22.9,-27.735),(22.9,-27.905),(22.73,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-27.905),(23.24,-27.735),(23.41,-27.735),(23.41,-27.905),(23.24,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-27.905),(23.75,-27.735),(23.92,-27.735),(23.92,-27.905),(23.75,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-27.905),(24.26,-27.735),(24.43,-27.735),(24.43,-27.905),(24.26,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-27.905),(24.77,-27.735),(24.94,-27.735),(24.94,-27.905),(24.77,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-27.905),(25.28,-27.735),(25.45,-27.735),(25.45,-27.905),(25.28,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-27.905),(25.79,-27.735),(25.96,-27.735),(25.96,-27.905),(25.79,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-27.905),(26.3,-27.735),(26.47,-27.735),(26.47,-27.905),(26.3,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-27.905),(26.81,-27.735),(26.98,-27.735),(26.98,-27.905),(26.81,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-27.905),(27.32,-27.735),(27.49,-27.735),(27.49,-27.905),(27.32,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-27.905),(27.83,-27.735),(28.0,-27.735),(28.0,-27.905),(27.83,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-27.905),(28.34,-27.735),(28.51,-27.735),(28.51,-27.905),(28.34,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-27.905),(28.85,-27.735),(29.02,-27.735),(29.02,-27.905),(28.85,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-27.905),(29.36,-27.735),(29.53,-27.735),(29.53,-27.905),(29.36,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-27.905),(29.87,-27.735),(30.04,-27.735),(30.04,-27.905),(29.87,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-27.905),(30.38,-27.735),(30.55,-27.735),(30.55,-27.905),(30.38,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-27.905),(30.89,-27.735),(31.06,-27.735),(31.06,-27.905),(30.89,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-27.905),(31.4,-27.735),(31.57,-27.735),(31.57,-27.905),(31.4,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-27.905),(31.91,-27.735),(32.08,-27.735),(32.08,-27.905),(31.91,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-27.905),(32.42,-27.735),(32.59,-27.735),(32.59,-27.905),(32.42,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-27.905),(32.93,-27.735),(33.1,-27.735),(33.1,-27.905),(32.93,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-27.905),(33.44,-27.735),(33.61,-27.735),(33.61,-27.905),(33.44,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-27.905),(33.95,-27.735),(34.12,-27.735),(34.12,-27.905),(33.95,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-27.905),(34.46,-27.735),(34.63,-27.735),(34.63,-27.905),(34.46,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-27.905),(34.97,-27.735),(35.14,-27.735),(35.14,-27.905),(34.97,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-27.905),(35.48,-27.735),(35.65,-27.735),(35.65,-27.905),(35.48,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-27.905),(35.99,-27.735),(36.16,-27.735),(36.16,-27.905),(35.99,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-27.905),(36.5,-27.735),(36.67,-27.735),(36.67,-27.905),(36.5,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-27.905),(37.01,-27.735),(37.18,-27.735),(37.18,-27.905),(37.01,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-27.905),(37.52,-27.735),(37.69,-27.735),(37.69,-27.905),(37.52,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-27.905),(38.03,-27.735),(38.2,-27.735),(38.2,-27.905),(38.03,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-27.905),(38.54,-27.735),(38.71,-27.735),(38.71,-27.905),(38.54,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-27.905),(39.05,-27.735),(39.22,-27.735),(39.22,-27.905),(39.05,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-27.905),(39.56,-27.735),(39.73,-27.735),(39.73,-27.905),(39.56,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-27.905),(40.07,-27.735),(40.24,-27.735),(40.24,-27.905),(40.07,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-27.905),(40.58,-27.735),(40.75,-27.735),(40.75,-27.905),(40.58,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-27.905),(41.09,-27.735),(41.26,-27.735),(41.26,-27.905),(41.09,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-27.905),(41.6,-27.735),(41.77,-27.735),(41.77,-27.905),(41.6,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-27.905),(42.11,-27.735),(42.28,-27.735),(42.28,-27.905),(42.11,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-27.905),(42.62,-27.735),(42.79,-27.735),(42.79,-27.905),(42.62,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-27.905),(43.13,-27.735),(43.3,-27.735),(43.3,-27.905),(43.13,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-27.905),(43.64,-27.735),(43.81,-27.735),(43.81,-27.905),(43.64,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-27.905),(44.15,-27.735),(44.32,-27.735),(44.32,-27.905),(44.15,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-27.905),(44.66,-27.735),(44.83,-27.735),(44.83,-27.905),(44.66,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-27.905),(45.17,-27.735),(45.34,-27.735),(45.34,-27.905),(45.17,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-27.905),(45.68,-27.735),(45.85,-27.735),(45.85,-27.905),(45.68,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-27.905),(46.19,-27.735),(46.36,-27.735),(46.36,-27.905),(46.19,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-27.905),(46.7,-27.735),(46.87,-27.735),(46.87,-27.905),(46.7,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-27.905),(47.21,-27.735),(47.38,-27.735),(47.38,-27.905),(47.21,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-27.905),(47.72,-27.735),(47.89,-27.735),(47.89,-27.905),(47.72,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-27.905),(48.23,-27.735),(48.4,-27.735),(48.4,-27.905),(48.23,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-27.905),(48.74,-27.735),(48.91,-27.735),(48.91,-27.905),(48.74,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-27.905),(49.25,-27.735),(49.42,-27.735),(49.42,-27.905),(49.25,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-27.905),(49.76,-27.735),(49.93,-27.735),(49.93,-27.905),(49.76,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-27.905),(50.27,-27.735),(50.44,-27.735),(50.44,-27.905),(50.27,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-27.905),(50.78,-27.735),(50.95,-27.735),(50.95,-27.905),(50.78,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-27.905),(51.29,-27.735),(51.46,-27.735),(51.46,-27.905),(51.29,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-27.905),(51.8,-27.735),(51.97,-27.735),(51.97,-27.905),(51.8,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-27.905),(52.31,-27.735),(52.48,-27.735),(52.48,-27.905),(52.31,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-27.905),(52.82,-27.735),(52.99,-27.735),(52.99,-27.905),(52.82,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-27.905),(53.33,-27.735),(53.5,-27.735),(53.5,-27.905),(53.33,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-27.905),(53.84,-27.735),(54.01,-27.735),(54.01,-27.905),(53.84,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-27.905),(54.35,-27.735),(54.52,-27.735),(54.52,-27.905),(54.35,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-27.905),(54.86,-27.735),(55.03,-27.735),(55.03,-27.905),(54.86,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-27.905),(55.37,-27.735),(55.54,-27.735),(55.54,-27.905),(55.37,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-27.905),(55.88,-27.735),(56.05,-27.735),(56.05,-27.905),(55.88,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-27.905),(56.39,-27.735),(56.56,-27.735),(56.56,-27.905),(56.39,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-27.905),(56.9,-27.735),(57.07,-27.735),(57.07,-27.905),(56.9,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-27.905),(57.41,-27.735),(57.58,-27.735),(57.58,-27.905),(57.41,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-27.905),(57.92,-27.735),(58.09,-27.735),(58.09,-27.905),(57.92,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-27.905),(58.43,-27.735),(58.6,-27.735),(58.6,-27.905),(58.43,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-27.905),(58.94,-27.735),(59.11,-27.735),(59.11,-27.905),(58.94,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-27.905),(59.45,-27.735),(59.62,-27.735),(59.62,-27.905),(59.45,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-27.905),(59.96,-27.735),(60.13,-27.735),(60.13,-27.905),(59.96,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-27.905),(60.47,-27.735),(60.64,-27.735),(60.64,-27.905),(60.47,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-27.905),(60.98,-27.735),(61.15,-27.735),(61.15,-27.905),(60.98,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-27.905),(61.49,-27.735),(61.66,-27.735),(61.66,-27.905),(61.49,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-27.905),(62.0,-27.735),(62.17,-27.735),(62.17,-27.905),(62.0,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-27.905),(62.51,-27.735),(62.68,-27.735),(62.68,-27.905),(62.51,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-27.905),(63.02,-27.735),(63.19,-27.735),(63.19,-27.905),(63.02,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-27.905),(63.53,-27.735),(63.7,-27.735),(63.7,-27.905),(63.53,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-27.905),(64.04,-27.735),(64.21,-27.735),(64.21,-27.905),(64.04,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-27.905),(64.55,-27.735),(64.72,-27.735),(64.72,-27.905),(64.55,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-27.905),(65.06,-27.735),(65.23,-27.735),(65.23,-27.905),(65.06,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-27.905),(65.57,-27.735),(65.74,-27.735),(65.74,-27.905),(65.57,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-27.905),(66.08,-27.735),(66.25,-27.735),(66.25,-27.905),(66.08,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-27.905),(66.59,-27.735),(66.76,-27.735),(66.76,-27.905),(66.59,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-27.905),(67.1,-27.735),(67.27,-27.735),(67.27,-27.905),(67.1,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-27.905),(67.61,-27.735),(67.78,-27.735),(67.78,-27.905),(67.61,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-27.905),(68.12,-27.735),(68.29,-27.735),(68.29,-27.905),(68.12,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-27.905),(68.63,-27.735),(68.8,-27.735),(68.8,-27.905),(68.63,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-27.905),(69.14,-27.735),(69.31,-27.735),(69.31,-27.905),(69.14,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-27.905),(69.65,-27.735),(69.82,-27.735),(69.82,-27.905),(69.65,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-27.905),(70.16,-27.735),(70.33,-27.735),(70.33,-27.905),(70.16,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-27.905),(70.67,-27.735),(70.84,-27.735),(70.84,-27.905),(70.67,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-27.905),(71.18,-27.735),(71.35,-27.735),(71.35,-27.905),(71.18,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-27.905),(71.69,-27.735),(71.86,-27.735),(71.86,-27.905),(71.69,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-27.905),(72.2,-27.735),(72.37,-27.735),(72.37,-27.905),(72.2,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-27.905),(72.71,-27.735),(72.88,-27.735),(72.88,-27.905),(72.71,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-27.905),(73.22,-27.735),(73.39,-27.735),(73.39,-27.905),(73.22,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-27.905),(73.73,-27.735),(73.9,-27.735),(73.9,-27.905),(73.73,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-27.905),(74.24,-27.735),(74.41,-27.735),(74.41,-27.905),(74.24,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-27.905),(74.75,-27.735),(74.92,-27.735),(74.92,-27.905),(74.75,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-27.905),(75.26,-27.735),(75.43,-27.735),(75.43,-27.905),(75.26,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-27.905),(75.77,-27.735),(75.94,-27.735),(75.94,-27.905),(75.77,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-27.905),(76.28,-27.735),(76.45,-27.735),(76.45,-27.905),(76.28,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-27.905),(76.79,-27.735),(76.96,-27.735),(76.96,-27.905),(76.79,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-27.905),(77.3,-27.735),(77.47,-27.735),(77.47,-27.905),(77.3,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-27.905),(77.81,-27.735),(77.98,-27.735),(77.98,-27.905),(77.81,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-27.905),(78.32,-27.735),(78.49,-27.735),(78.49,-27.905),(78.32,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-27.905),(78.83,-27.735),(79.0,-27.735),(79.0,-27.905),(78.83,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-27.905),(79.34,-27.735),(79.51,-27.735),(79.51,-27.905),(79.34,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-27.905),(79.85,-27.735),(80.02,-27.735),(80.02,-27.905),(79.85,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-27.905),(80.36,-27.735),(80.53,-27.735),(80.53,-27.905),(80.36,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-27.905),(80.87,-27.735),(81.04,-27.735),(81.04,-27.905),(80.87,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-27.905),(81.38,-27.735),(81.55,-27.735),(81.55,-27.905),(81.38,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-27.905),(81.89,-27.735),(82.06,-27.735),(82.06,-27.905),(81.89,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-27.905),(82.4,-27.735),(82.57,-27.735),(82.57,-27.905),(82.4,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-27.905),(82.91,-27.735),(83.08,-27.735),(83.08,-27.905),(82.91,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-27.905),(83.42,-27.735),(83.59,-27.735),(83.59,-27.905),(83.42,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-27.905),(83.93,-27.735),(84.1,-27.735),(84.1,-27.905),(83.93,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-27.905),(84.44,-27.735),(84.61,-27.735),(84.61,-27.905),(84.44,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-27.905),(84.95,-27.735),(85.12,-27.735),(85.12,-27.905),(84.95,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-27.905),(85.46,-27.735),(85.63,-27.735),(85.63,-27.905),(85.46,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-27.905),(85.97,-27.735),(86.14,-27.735),(86.14,-27.905),(85.97,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-27.905),(86.48,-27.735),(86.65,-27.735),(86.65,-27.905),(86.48,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-27.905),(86.99,-27.735),(87.16,-27.735),(87.16,-27.905),(86.99,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-27.905),(87.5,-27.735),(87.67,-27.735),(87.67,-27.905),(87.5,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-27.905),(88.01,-27.735),(88.18,-27.735),(88.18,-27.905),(88.01,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-27.905),(88.52,-27.735),(88.69,-27.735),(88.69,-27.905),(88.52,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-27.905),(89.03,-27.735),(89.2,-27.735),(89.2,-27.905),(89.03,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-27.905),(89.54,-27.735),(89.71,-27.735),(89.71,-27.905),(89.54,-27.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-27.395),(0.29,-27.225),(0.46,-27.225),(0.46,-27.395),(0.29,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-27.395),(0.8,-27.225),(0.97,-27.225),(0.97,-27.395),(0.8,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-27.395),(1.31,-27.225),(1.48,-27.225),(1.48,-27.395),(1.31,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-27.395),(1.82,-27.225),(1.99,-27.225),(1.99,-27.395),(1.82,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-27.395),(2.33,-27.225),(2.5,-27.225),(2.5,-27.395),(2.33,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-27.395),(2.84,-27.225),(3.01,-27.225),(3.01,-27.395),(2.84,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-27.395),(3.35,-27.225),(3.52,-27.225),(3.52,-27.395),(3.35,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-27.395),(3.86,-27.225),(4.03,-27.225),(4.03,-27.395),(3.86,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-27.395),(4.37,-27.225),(4.54,-27.225),(4.54,-27.395),(4.37,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-27.395),(4.88,-27.225),(5.05,-27.225),(5.05,-27.395),(4.88,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-27.395),(5.39,-27.225),(5.56,-27.225),(5.56,-27.395),(5.39,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-27.395),(5.9,-27.225),(6.07,-27.225),(6.07,-27.395),(5.9,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-27.395),(6.41,-27.225),(6.58,-27.225),(6.58,-27.395),(6.41,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-27.395),(6.92,-27.225),(7.09,-27.225),(7.09,-27.395),(6.92,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-27.395),(7.43,-27.225),(7.6,-27.225),(7.6,-27.395),(7.43,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-27.395),(7.94,-27.225),(8.11,-27.225),(8.11,-27.395),(7.94,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-27.395),(8.45,-27.225),(8.62,-27.225),(8.62,-27.395),(8.45,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-27.395),(8.96,-27.225),(9.13,-27.225),(9.13,-27.395),(8.96,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-27.395),(9.47,-27.225),(9.64,-27.225),(9.64,-27.395),(9.47,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-27.395),(9.98,-27.225),(10.15,-27.225),(10.15,-27.395),(9.98,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-27.395),(10.49,-27.225),(10.66,-27.225),(10.66,-27.395),(10.49,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-27.395),(11.0,-27.225),(11.17,-27.225),(11.17,-27.395),(11.0,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-27.395),(11.51,-27.225),(11.68,-27.225),(11.68,-27.395),(11.51,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-27.395),(12.02,-27.225),(12.19,-27.225),(12.19,-27.395),(12.02,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-27.395),(12.53,-27.225),(12.7,-27.225),(12.7,-27.395),(12.53,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-27.395),(13.04,-27.225),(13.21,-27.225),(13.21,-27.395),(13.04,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-27.395),(13.55,-27.225),(13.72,-27.225),(13.72,-27.395),(13.55,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-27.395),(14.06,-27.225),(14.23,-27.225),(14.23,-27.395),(14.06,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-27.395),(14.57,-27.225),(14.74,-27.225),(14.74,-27.395),(14.57,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-27.395),(15.08,-27.225),(15.25,-27.225),(15.25,-27.395),(15.08,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-27.395),(15.59,-27.225),(15.76,-27.225),(15.76,-27.395),(15.59,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-27.395),(16.1,-27.225),(16.27,-27.225),(16.27,-27.395),(16.1,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-27.395),(16.61,-27.225),(16.78,-27.225),(16.78,-27.395),(16.61,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-27.395),(17.12,-27.225),(17.29,-27.225),(17.29,-27.395),(17.12,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-27.395),(17.63,-27.225),(17.8,-27.225),(17.8,-27.395),(17.63,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-27.395),(18.14,-27.225),(18.31,-27.225),(18.31,-27.395),(18.14,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-27.395),(18.65,-27.225),(18.82,-27.225),(18.82,-27.395),(18.65,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-27.395),(19.16,-27.225),(19.33,-27.225),(19.33,-27.395),(19.16,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-27.395),(19.67,-27.225),(19.84,-27.225),(19.84,-27.395),(19.67,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-27.395),(20.18,-27.225),(20.35,-27.225),(20.35,-27.395),(20.18,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-27.395),(20.69,-27.225),(20.86,-27.225),(20.86,-27.395),(20.69,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-27.395),(21.2,-27.225),(21.37,-27.225),(21.37,-27.395),(21.2,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-27.395),(21.71,-27.225),(21.88,-27.225),(21.88,-27.395),(21.71,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-27.395),(22.22,-27.225),(22.39,-27.225),(22.39,-27.395),(22.22,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-27.395),(22.73,-27.225),(22.9,-27.225),(22.9,-27.395),(22.73,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-27.395),(23.24,-27.225),(23.41,-27.225),(23.41,-27.395),(23.24,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-27.395),(23.75,-27.225),(23.92,-27.225),(23.92,-27.395),(23.75,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-27.395),(24.26,-27.225),(24.43,-27.225),(24.43,-27.395),(24.26,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-27.395),(24.77,-27.225),(24.94,-27.225),(24.94,-27.395),(24.77,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-27.395),(25.28,-27.225),(25.45,-27.225),(25.45,-27.395),(25.28,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-27.395),(25.79,-27.225),(25.96,-27.225),(25.96,-27.395),(25.79,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-27.395),(26.3,-27.225),(26.47,-27.225),(26.47,-27.395),(26.3,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-27.395),(26.81,-27.225),(26.98,-27.225),(26.98,-27.395),(26.81,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-27.395),(27.32,-27.225),(27.49,-27.225),(27.49,-27.395),(27.32,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-27.395),(27.83,-27.225),(28.0,-27.225),(28.0,-27.395),(27.83,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-27.395),(28.34,-27.225),(28.51,-27.225),(28.51,-27.395),(28.34,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-27.395),(28.85,-27.225),(29.02,-27.225),(29.02,-27.395),(28.85,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-27.395),(29.36,-27.225),(29.53,-27.225),(29.53,-27.395),(29.36,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-27.395),(29.87,-27.225),(30.04,-27.225),(30.04,-27.395),(29.87,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-27.395),(30.38,-27.225),(30.55,-27.225),(30.55,-27.395),(30.38,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-27.395),(30.89,-27.225),(31.06,-27.225),(31.06,-27.395),(30.89,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-27.395),(31.4,-27.225),(31.57,-27.225),(31.57,-27.395),(31.4,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-27.395),(31.91,-27.225),(32.08,-27.225),(32.08,-27.395),(31.91,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-27.395),(32.42,-27.225),(32.59,-27.225),(32.59,-27.395),(32.42,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-27.395),(32.93,-27.225),(33.1,-27.225),(33.1,-27.395),(32.93,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-27.395),(33.44,-27.225),(33.61,-27.225),(33.61,-27.395),(33.44,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-27.395),(33.95,-27.225),(34.12,-27.225),(34.12,-27.395),(33.95,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-27.395),(34.46,-27.225),(34.63,-27.225),(34.63,-27.395),(34.46,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-27.395),(34.97,-27.225),(35.14,-27.225),(35.14,-27.395),(34.97,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-27.395),(35.48,-27.225),(35.65,-27.225),(35.65,-27.395),(35.48,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-27.395),(35.99,-27.225),(36.16,-27.225),(36.16,-27.395),(35.99,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-27.395),(36.5,-27.225),(36.67,-27.225),(36.67,-27.395),(36.5,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-27.395),(37.01,-27.225),(37.18,-27.225),(37.18,-27.395),(37.01,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-27.395),(37.52,-27.225),(37.69,-27.225),(37.69,-27.395),(37.52,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-27.395),(38.03,-27.225),(38.2,-27.225),(38.2,-27.395),(38.03,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-27.395),(38.54,-27.225),(38.71,-27.225),(38.71,-27.395),(38.54,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-27.395),(39.05,-27.225),(39.22,-27.225),(39.22,-27.395),(39.05,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-27.395),(39.56,-27.225),(39.73,-27.225),(39.73,-27.395),(39.56,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-27.395),(40.07,-27.225),(40.24,-27.225),(40.24,-27.395),(40.07,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-27.395),(40.58,-27.225),(40.75,-27.225),(40.75,-27.395),(40.58,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-27.395),(41.09,-27.225),(41.26,-27.225),(41.26,-27.395),(41.09,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-27.395),(41.6,-27.225),(41.77,-27.225),(41.77,-27.395),(41.6,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-27.395),(42.11,-27.225),(42.28,-27.225),(42.28,-27.395),(42.11,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-27.395),(42.62,-27.225),(42.79,-27.225),(42.79,-27.395),(42.62,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-27.395),(43.13,-27.225),(43.3,-27.225),(43.3,-27.395),(43.13,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-27.395),(43.64,-27.225),(43.81,-27.225),(43.81,-27.395),(43.64,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-27.395),(44.15,-27.225),(44.32,-27.225),(44.32,-27.395),(44.15,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-27.395),(44.66,-27.225),(44.83,-27.225),(44.83,-27.395),(44.66,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-27.395),(45.17,-27.225),(45.34,-27.225),(45.34,-27.395),(45.17,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-27.395),(45.68,-27.225),(45.85,-27.225),(45.85,-27.395),(45.68,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-27.395),(46.19,-27.225),(46.36,-27.225),(46.36,-27.395),(46.19,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-27.395),(46.7,-27.225),(46.87,-27.225),(46.87,-27.395),(46.7,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-27.395),(47.21,-27.225),(47.38,-27.225),(47.38,-27.395),(47.21,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-27.395),(47.72,-27.225),(47.89,-27.225),(47.89,-27.395),(47.72,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-27.395),(48.23,-27.225),(48.4,-27.225),(48.4,-27.395),(48.23,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-27.395),(48.74,-27.225),(48.91,-27.225),(48.91,-27.395),(48.74,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-27.395),(49.25,-27.225),(49.42,-27.225),(49.42,-27.395),(49.25,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-27.395),(49.76,-27.225),(49.93,-27.225),(49.93,-27.395),(49.76,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-27.395),(50.27,-27.225),(50.44,-27.225),(50.44,-27.395),(50.27,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-27.395),(50.78,-27.225),(50.95,-27.225),(50.95,-27.395),(50.78,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-27.395),(51.29,-27.225),(51.46,-27.225),(51.46,-27.395),(51.29,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-27.395),(51.8,-27.225),(51.97,-27.225),(51.97,-27.395),(51.8,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-27.395),(52.31,-27.225),(52.48,-27.225),(52.48,-27.395),(52.31,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-27.395),(52.82,-27.225),(52.99,-27.225),(52.99,-27.395),(52.82,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-27.395),(53.33,-27.225),(53.5,-27.225),(53.5,-27.395),(53.33,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-27.395),(53.84,-27.225),(54.01,-27.225),(54.01,-27.395),(53.84,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-27.395),(54.35,-27.225),(54.52,-27.225),(54.52,-27.395),(54.35,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-27.395),(54.86,-27.225),(55.03,-27.225),(55.03,-27.395),(54.86,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-27.395),(55.37,-27.225),(55.54,-27.225),(55.54,-27.395),(55.37,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-27.395),(55.88,-27.225),(56.05,-27.225),(56.05,-27.395),(55.88,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-27.395),(56.39,-27.225),(56.56,-27.225),(56.56,-27.395),(56.39,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-27.395),(56.9,-27.225),(57.07,-27.225),(57.07,-27.395),(56.9,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-27.395),(57.41,-27.225),(57.58,-27.225),(57.58,-27.395),(57.41,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-27.395),(57.92,-27.225),(58.09,-27.225),(58.09,-27.395),(57.92,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-27.395),(58.43,-27.225),(58.6,-27.225),(58.6,-27.395),(58.43,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-27.395),(58.94,-27.225),(59.11,-27.225),(59.11,-27.395),(58.94,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-27.395),(59.45,-27.225),(59.62,-27.225),(59.62,-27.395),(59.45,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-27.395),(59.96,-27.225),(60.13,-27.225),(60.13,-27.395),(59.96,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-27.395),(60.47,-27.225),(60.64,-27.225),(60.64,-27.395),(60.47,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-27.395),(60.98,-27.225),(61.15,-27.225),(61.15,-27.395),(60.98,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-27.395),(61.49,-27.225),(61.66,-27.225),(61.66,-27.395),(61.49,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-27.395),(62.0,-27.225),(62.17,-27.225),(62.17,-27.395),(62.0,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-27.395),(62.51,-27.225),(62.68,-27.225),(62.68,-27.395),(62.51,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-27.395),(63.02,-27.225),(63.19,-27.225),(63.19,-27.395),(63.02,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-27.395),(63.53,-27.225),(63.7,-27.225),(63.7,-27.395),(63.53,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-27.395),(64.04,-27.225),(64.21,-27.225),(64.21,-27.395),(64.04,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-27.395),(64.55,-27.225),(64.72,-27.225),(64.72,-27.395),(64.55,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-27.395),(65.06,-27.225),(65.23,-27.225),(65.23,-27.395),(65.06,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-27.395),(65.57,-27.225),(65.74,-27.225),(65.74,-27.395),(65.57,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-27.395),(66.08,-27.225),(66.25,-27.225),(66.25,-27.395),(66.08,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-27.395),(66.59,-27.225),(66.76,-27.225),(66.76,-27.395),(66.59,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-27.395),(67.1,-27.225),(67.27,-27.225),(67.27,-27.395),(67.1,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-27.395),(67.61,-27.225),(67.78,-27.225),(67.78,-27.395),(67.61,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-27.395),(68.12,-27.225),(68.29,-27.225),(68.29,-27.395),(68.12,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-27.395),(68.63,-27.225),(68.8,-27.225),(68.8,-27.395),(68.63,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-27.395),(69.14,-27.225),(69.31,-27.225),(69.31,-27.395),(69.14,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-27.395),(69.65,-27.225),(69.82,-27.225),(69.82,-27.395),(69.65,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-27.395),(70.16,-27.225),(70.33,-27.225),(70.33,-27.395),(70.16,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-27.395),(70.67,-27.225),(70.84,-27.225),(70.84,-27.395),(70.67,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-27.395),(71.18,-27.225),(71.35,-27.225),(71.35,-27.395),(71.18,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-27.395),(71.69,-27.225),(71.86,-27.225),(71.86,-27.395),(71.69,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-27.395),(72.2,-27.225),(72.37,-27.225),(72.37,-27.395),(72.2,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-27.395),(72.71,-27.225),(72.88,-27.225),(72.88,-27.395),(72.71,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-27.395),(73.22,-27.225),(73.39,-27.225),(73.39,-27.395),(73.22,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-27.395),(73.73,-27.225),(73.9,-27.225),(73.9,-27.395),(73.73,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-27.395),(74.24,-27.225),(74.41,-27.225),(74.41,-27.395),(74.24,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-27.395),(74.75,-27.225),(74.92,-27.225),(74.92,-27.395),(74.75,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-27.395),(75.26,-27.225),(75.43,-27.225),(75.43,-27.395),(75.26,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-27.395),(75.77,-27.225),(75.94,-27.225),(75.94,-27.395),(75.77,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-27.395),(76.28,-27.225),(76.45,-27.225),(76.45,-27.395),(76.28,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-27.395),(76.79,-27.225),(76.96,-27.225),(76.96,-27.395),(76.79,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-27.395),(77.3,-27.225),(77.47,-27.225),(77.47,-27.395),(77.3,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-27.395),(77.81,-27.225),(77.98,-27.225),(77.98,-27.395),(77.81,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-27.395),(78.32,-27.225),(78.49,-27.225),(78.49,-27.395),(78.32,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-27.395),(78.83,-27.225),(79.0,-27.225),(79.0,-27.395),(78.83,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-27.395),(79.34,-27.225),(79.51,-27.225),(79.51,-27.395),(79.34,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-27.395),(79.85,-27.225),(80.02,-27.225),(80.02,-27.395),(79.85,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-27.395),(80.36,-27.225),(80.53,-27.225),(80.53,-27.395),(80.36,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-27.395),(80.87,-27.225),(81.04,-27.225),(81.04,-27.395),(80.87,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-27.395),(81.38,-27.225),(81.55,-27.225),(81.55,-27.395),(81.38,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-27.395),(81.89,-27.225),(82.06,-27.225),(82.06,-27.395),(81.89,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-27.395),(82.4,-27.225),(82.57,-27.225),(82.57,-27.395),(82.4,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-27.395),(82.91,-27.225),(83.08,-27.225),(83.08,-27.395),(82.91,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-27.395),(83.42,-27.225),(83.59,-27.225),(83.59,-27.395),(83.42,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-27.395),(83.93,-27.225),(84.1,-27.225),(84.1,-27.395),(83.93,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-27.395),(84.44,-27.225),(84.61,-27.225),(84.61,-27.395),(84.44,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-27.395),(84.95,-27.225),(85.12,-27.225),(85.12,-27.395),(84.95,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-27.395),(85.46,-27.225),(85.63,-27.225),(85.63,-27.395),(85.46,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-27.395),(85.97,-27.225),(86.14,-27.225),(86.14,-27.395),(85.97,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-27.395),(86.48,-27.225),(86.65,-27.225),(86.65,-27.395),(86.48,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-27.395),(86.99,-27.225),(87.16,-27.225),(87.16,-27.395),(86.99,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-27.395),(87.5,-27.225),(87.67,-27.225),(87.67,-27.395),(87.5,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-27.395),(88.01,-27.225),(88.18,-27.225),(88.18,-27.395),(88.01,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-27.395),(88.52,-27.225),(88.69,-27.225),(88.69,-27.395),(88.52,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-27.395),(89.03,-27.225),(89.2,-27.225),(89.2,-27.395),(89.03,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-27.395),(89.54,-27.225),(89.71,-27.225),(89.71,-27.395),(89.54,-27.395)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-26.885),(0.29,-26.715),(0.46,-26.715),(0.46,-26.885),(0.29,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-26.885),(0.8,-26.715),(0.97,-26.715),(0.97,-26.885),(0.8,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-26.885),(1.31,-26.715),(1.48,-26.715),(1.48,-26.885),(1.31,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-26.885),(1.82,-26.715),(1.99,-26.715),(1.99,-26.885),(1.82,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-26.885),(2.33,-26.715),(2.5,-26.715),(2.5,-26.885),(2.33,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-26.885),(2.84,-26.715),(3.01,-26.715),(3.01,-26.885),(2.84,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-26.885),(3.35,-26.715),(3.52,-26.715),(3.52,-26.885),(3.35,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-26.885),(3.86,-26.715),(4.03,-26.715),(4.03,-26.885),(3.86,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-26.885),(4.37,-26.715),(4.54,-26.715),(4.54,-26.885),(4.37,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-26.885),(4.88,-26.715),(5.05,-26.715),(5.05,-26.885),(4.88,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-26.885),(5.39,-26.715),(5.56,-26.715),(5.56,-26.885),(5.39,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-26.885),(5.9,-26.715),(6.07,-26.715),(6.07,-26.885),(5.9,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-26.885),(6.41,-26.715),(6.58,-26.715),(6.58,-26.885),(6.41,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-26.885),(6.92,-26.715),(7.09,-26.715),(7.09,-26.885),(6.92,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-26.885),(7.43,-26.715),(7.6,-26.715),(7.6,-26.885),(7.43,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-26.885),(7.94,-26.715),(8.11,-26.715),(8.11,-26.885),(7.94,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-26.885),(8.45,-26.715),(8.62,-26.715),(8.62,-26.885),(8.45,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-26.885),(8.96,-26.715),(9.13,-26.715),(9.13,-26.885),(8.96,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-26.885),(9.47,-26.715),(9.64,-26.715),(9.64,-26.885),(9.47,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-26.885),(9.98,-26.715),(10.15,-26.715),(10.15,-26.885),(9.98,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-26.885),(10.49,-26.715),(10.66,-26.715),(10.66,-26.885),(10.49,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-26.885),(11.0,-26.715),(11.17,-26.715),(11.17,-26.885),(11.0,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-26.885),(11.51,-26.715),(11.68,-26.715),(11.68,-26.885),(11.51,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-26.885),(12.02,-26.715),(12.19,-26.715),(12.19,-26.885),(12.02,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-26.885),(12.53,-26.715),(12.7,-26.715),(12.7,-26.885),(12.53,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-26.885),(13.04,-26.715),(13.21,-26.715),(13.21,-26.885),(13.04,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-26.885),(13.55,-26.715),(13.72,-26.715),(13.72,-26.885),(13.55,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-26.885),(14.06,-26.715),(14.23,-26.715),(14.23,-26.885),(14.06,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-26.885),(14.57,-26.715),(14.74,-26.715),(14.74,-26.885),(14.57,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-26.885),(15.08,-26.715),(15.25,-26.715),(15.25,-26.885),(15.08,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-26.885),(15.59,-26.715),(15.76,-26.715),(15.76,-26.885),(15.59,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-26.885),(16.1,-26.715),(16.27,-26.715),(16.27,-26.885),(16.1,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-26.885),(16.61,-26.715),(16.78,-26.715),(16.78,-26.885),(16.61,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-26.885),(17.12,-26.715),(17.29,-26.715),(17.29,-26.885),(17.12,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-26.885),(17.63,-26.715),(17.8,-26.715),(17.8,-26.885),(17.63,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-26.885),(18.14,-26.715),(18.31,-26.715),(18.31,-26.885),(18.14,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-26.885),(18.65,-26.715),(18.82,-26.715),(18.82,-26.885),(18.65,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-26.885),(19.16,-26.715),(19.33,-26.715),(19.33,-26.885),(19.16,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-26.885),(19.67,-26.715),(19.84,-26.715),(19.84,-26.885),(19.67,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-26.885),(20.18,-26.715),(20.35,-26.715),(20.35,-26.885),(20.18,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-26.885),(20.69,-26.715),(20.86,-26.715),(20.86,-26.885),(20.69,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-26.885),(21.2,-26.715),(21.37,-26.715),(21.37,-26.885),(21.2,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-26.885),(21.71,-26.715),(21.88,-26.715),(21.88,-26.885),(21.71,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-26.885),(22.22,-26.715),(22.39,-26.715),(22.39,-26.885),(22.22,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-26.885),(22.73,-26.715),(22.9,-26.715),(22.9,-26.885),(22.73,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-26.885),(23.24,-26.715),(23.41,-26.715),(23.41,-26.885),(23.24,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-26.885),(23.75,-26.715),(23.92,-26.715),(23.92,-26.885),(23.75,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-26.885),(24.26,-26.715),(24.43,-26.715),(24.43,-26.885),(24.26,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-26.885),(24.77,-26.715),(24.94,-26.715),(24.94,-26.885),(24.77,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-26.885),(25.28,-26.715),(25.45,-26.715),(25.45,-26.885),(25.28,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-26.885),(25.79,-26.715),(25.96,-26.715),(25.96,-26.885),(25.79,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-26.885),(26.3,-26.715),(26.47,-26.715),(26.47,-26.885),(26.3,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-26.885),(26.81,-26.715),(26.98,-26.715),(26.98,-26.885),(26.81,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-26.885),(27.32,-26.715),(27.49,-26.715),(27.49,-26.885),(27.32,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-26.885),(27.83,-26.715),(28.0,-26.715),(28.0,-26.885),(27.83,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-26.885),(28.34,-26.715),(28.51,-26.715),(28.51,-26.885),(28.34,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-26.885),(28.85,-26.715),(29.02,-26.715),(29.02,-26.885),(28.85,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-26.885),(29.36,-26.715),(29.53,-26.715),(29.53,-26.885),(29.36,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-26.885),(29.87,-26.715),(30.04,-26.715),(30.04,-26.885),(29.87,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-26.885),(30.38,-26.715),(30.55,-26.715),(30.55,-26.885),(30.38,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-26.885),(30.89,-26.715),(31.06,-26.715),(31.06,-26.885),(30.89,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-26.885),(31.4,-26.715),(31.57,-26.715),(31.57,-26.885),(31.4,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-26.885),(31.91,-26.715),(32.08,-26.715),(32.08,-26.885),(31.91,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-26.885),(32.42,-26.715),(32.59,-26.715),(32.59,-26.885),(32.42,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-26.885),(32.93,-26.715),(33.1,-26.715),(33.1,-26.885),(32.93,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-26.885),(33.44,-26.715),(33.61,-26.715),(33.61,-26.885),(33.44,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-26.885),(33.95,-26.715),(34.12,-26.715),(34.12,-26.885),(33.95,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-26.885),(34.46,-26.715),(34.63,-26.715),(34.63,-26.885),(34.46,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-26.885),(34.97,-26.715),(35.14,-26.715),(35.14,-26.885),(34.97,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-26.885),(35.48,-26.715),(35.65,-26.715),(35.65,-26.885),(35.48,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-26.885),(35.99,-26.715),(36.16,-26.715),(36.16,-26.885),(35.99,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-26.885),(36.5,-26.715),(36.67,-26.715),(36.67,-26.885),(36.5,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-26.885),(37.01,-26.715),(37.18,-26.715),(37.18,-26.885),(37.01,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-26.885),(37.52,-26.715),(37.69,-26.715),(37.69,-26.885),(37.52,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-26.885),(38.03,-26.715),(38.2,-26.715),(38.2,-26.885),(38.03,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-26.885),(38.54,-26.715),(38.71,-26.715),(38.71,-26.885),(38.54,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-26.885),(39.05,-26.715),(39.22,-26.715),(39.22,-26.885),(39.05,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-26.885),(39.56,-26.715),(39.73,-26.715),(39.73,-26.885),(39.56,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-26.885),(40.07,-26.715),(40.24,-26.715),(40.24,-26.885),(40.07,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-26.885),(40.58,-26.715),(40.75,-26.715),(40.75,-26.885),(40.58,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-26.885),(41.09,-26.715),(41.26,-26.715),(41.26,-26.885),(41.09,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-26.885),(41.6,-26.715),(41.77,-26.715),(41.77,-26.885),(41.6,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-26.885),(42.11,-26.715),(42.28,-26.715),(42.28,-26.885),(42.11,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-26.885),(42.62,-26.715),(42.79,-26.715),(42.79,-26.885),(42.62,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-26.885),(43.13,-26.715),(43.3,-26.715),(43.3,-26.885),(43.13,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-26.885),(43.64,-26.715),(43.81,-26.715),(43.81,-26.885),(43.64,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-26.885),(44.15,-26.715),(44.32,-26.715),(44.32,-26.885),(44.15,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-26.885),(44.66,-26.715),(44.83,-26.715),(44.83,-26.885),(44.66,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-26.885),(45.17,-26.715),(45.34,-26.715),(45.34,-26.885),(45.17,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-26.885),(45.68,-26.715),(45.85,-26.715),(45.85,-26.885),(45.68,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-26.885),(46.19,-26.715),(46.36,-26.715),(46.36,-26.885),(46.19,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-26.885),(46.7,-26.715),(46.87,-26.715),(46.87,-26.885),(46.7,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-26.885),(47.21,-26.715),(47.38,-26.715),(47.38,-26.885),(47.21,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-26.885),(47.72,-26.715),(47.89,-26.715),(47.89,-26.885),(47.72,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-26.885),(48.23,-26.715),(48.4,-26.715),(48.4,-26.885),(48.23,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-26.885),(48.74,-26.715),(48.91,-26.715),(48.91,-26.885),(48.74,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-26.885),(49.25,-26.715),(49.42,-26.715),(49.42,-26.885),(49.25,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-26.885),(49.76,-26.715),(49.93,-26.715),(49.93,-26.885),(49.76,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-26.885),(50.27,-26.715),(50.44,-26.715),(50.44,-26.885),(50.27,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-26.885),(50.78,-26.715),(50.95,-26.715),(50.95,-26.885),(50.78,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-26.885),(51.29,-26.715),(51.46,-26.715),(51.46,-26.885),(51.29,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-26.885),(51.8,-26.715),(51.97,-26.715),(51.97,-26.885),(51.8,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-26.885),(52.31,-26.715),(52.48,-26.715),(52.48,-26.885),(52.31,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-26.885),(52.82,-26.715),(52.99,-26.715),(52.99,-26.885),(52.82,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-26.885),(53.33,-26.715),(53.5,-26.715),(53.5,-26.885),(53.33,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-26.885),(53.84,-26.715),(54.01,-26.715),(54.01,-26.885),(53.84,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-26.885),(54.35,-26.715),(54.52,-26.715),(54.52,-26.885),(54.35,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-26.885),(54.86,-26.715),(55.03,-26.715),(55.03,-26.885),(54.86,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-26.885),(55.37,-26.715),(55.54,-26.715),(55.54,-26.885),(55.37,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-26.885),(55.88,-26.715),(56.05,-26.715),(56.05,-26.885),(55.88,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-26.885),(56.39,-26.715),(56.56,-26.715),(56.56,-26.885),(56.39,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-26.885),(56.9,-26.715),(57.07,-26.715),(57.07,-26.885),(56.9,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-26.885),(57.41,-26.715),(57.58,-26.715),(57.58,-26.885),(57.41,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-26.885),(57.92,-26.715),(58.09,-26.715),(58.09,-26.885),(57.92,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-26.885),(58.43,-26.715),(58.6,-26.715),(58.6,-26.885),(58.43,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-26.885),(58.94,-26.715),(59.11,-26.715),(59.11,-26.885),(58.94,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-26.885),(59.45,-26.715),(59.62,-26.715),(59.62,-26.885),(59.45,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-26.885),(59.96,-26.715),(60.13,-26.715),(60.13,-26.885),(59.96,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-26.885),(60.47,-26.715),(60.64,-26.715),(60.64,-26.885),(60.47,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-26.885),(60.98,-26.715),(61.15,-26.715),(61.15,-26.885),(60.98,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-26.885),(61.49,-26.715),(61.66,-26.715),(61.66,-26.885),(61.49,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-26.885),(62.0,-26.715),(62.17,-26.715),(62.17,-26.885),(62.0,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-26.885),(62.51,-26.715),(62.68,-26.715),(62.68,-26.885),(62.51,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-26.885),(63.02,-26.715),(63.19,-26.715),(63.19,-26.885),(63.02,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-26.885),(63.53,-26.715),(63.7,-26.715),(63.7,-26.885),(63.53,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-26.885),(64.04,-26.715),(64.21,-26.715),(64.21,-26.885),(64.04,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-26.885),(64.55,-26.715),(64.72,-26.715),(64.72,-26.885),(64.55,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-26.885),(65.06,-26.715),(65.23,-26.715),(65.23,-26.885),(65.06,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-26.885),(65.57,-26.715),(65.74,-26.715),(65.74,-26.885),(65.57,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-26.885),(66.08,-26.715),(66.25,-26.715),(66.25,-26.885),(66.08,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-26.885),(66.59,-26.715),(66.76,-26.715),(66.76,-26.885),(66.59,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-26.885),(67.1,-26.715),(67.27,-26.715),(67.27,-26.885),(67.1,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-26.885),(67.61,-26.715),(67.78,-26.715),(67.78,-26.885),(67.61,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-26.885),(68.12,-26.715),(68.29,-26.715),(68.29,-26.885),(68.12,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-26.885),(68.63,-26.715),(68.8,-26.715),(68.8,-26.885),(68.63,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-26.885),(69.14,-26.715),(69.31,-26.715),(69.31,-26.885),(69.14,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-26.885),(69.65,-26.715),(69.82,-26.715),(69.82,-26.885),(69.65,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-26.885),(70.16,-26.715),(70.33,-26.715),(70.33,-26.885),(70.16,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-26.885),(70.67,-26.715),(70.84,-26.715),(70.84,-26.885),(70.67,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-26.885),(71.18,-26.715),(71.35,-26.715),(71.35,-26.885),(71.18,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-26.885),(71.69,-26.715),(71.86,-26.715),(71.86,-26.885),(71.69,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-26.885),(72.2,-26.715),(72.37,-26.715),(72.37,-26.885),(72.2,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-26.885),(72.71,-26.715),(72.88,-26.715),(72.88,-26.885),(72.71,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-26.885),(73.22,-26.715),(73.39,-26.715),(73.39,-26.885),(73.22,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-26.885),(73.73,-26.715),(73.9,-26.715),(73.9,-26.885),(73.73,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-26.885),(74.24,-26.715),(74.41,-26.715),(74.41,-26.885),(74.24,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-26.885),(74.75,-26.715),(74.92,-26.715),(74.92,-26.885),(74.75,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-26.885),(75.26,-26.715),(75.43,-26.715),(75.43,-26.885),(75.26,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-26.885),(75.77,-26.715),(75.94,-26.715),(75.94,-26.885),(75.77,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-26.885),(76.28,-26.715),(76.45,-26.715),(76.45,-26.885),(76.28,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-26.885),(76.79,-26.715),(76.96,-26.715),(76.96,-26.885),(76.79,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-26.885),(77.3,-26.715),(77.47,-26.715),(77.47,-26.885),(77.3,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-26.885),(77.81,-26.715),(77.98,-26.715),(77.98,-26.885),(77.81,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-26.885),(78.32,-26.715),(78.49,-26.715),(78.49,-26.885),(78.32,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-26.885),(78.83,-26.715),(79.0,-26.715),(79.0,-26.885),(78.83,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-26.885),(79.34,-26.715),(79.51,-26.715),(79.51,-26.885),(79.34,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-26.885),(79.85,-26.715),(80.02,-26.715),(80.02,-26.885),(79.85,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-26.885),(80.36,-26.715),(80.53,-26.715),(80.53,-26.885),(80.36,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-26.885),(80.87,-26.715),(81.04,-26.715),(81.04,-26.885),(80.87,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-26.885),(81.38,-26.715),(81.55,-26.715),(81.55,-26.885),(81.38,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-26.885),(81.89,-26.715),(82.06,-26.715),(82.06,-26.885),(81.89,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-26.885),(82.4,-26.715),(82.57,-26.715),(82.57,-26.885),(82.4,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-26.885),(82.91,-26.715),(83.08,-26.715),(83.08,-26.885),(82.91,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-26.885),(83.42,-26.715),(83.59,-26.715),(83.59,-26.885),(83.42,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-26.885),(83.93,-26.715),(84.1,-26.715),(84.1,-26.885),(83.93,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-26.885),(84.44,-26.715),(84.61,-26.715),(84.61,-26.885),(84.44,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-26.885),(84.95,-26.715),(85.12,-26.715),(85.12,-26.885),(84.95,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-26.885),(85.46,-26.715),(85.63,-26.715),(85.63,-26.885),(85.46,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-26.885),(85.97,-26.715),(86.14,-26.715),(86.14,-26.885),(85.97,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-26.885),(86.48,-26.715),(86.65,-26.715),(86.65,-26.885),(86.48,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-26.885),(86.99,-26.715),(87.16,-26.715),(87.16,-26.885),(86.99,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-26.885),(87.5,-26.715),(87.67,-26.715),(87.67,-26.885),(87.5,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-26.885),(88.01,-26.715),(88.18,-26.715),(88.18,-26.885),(88.01,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-26.885),(88.52,-26.715),(88.69,-26.715),(88.69,-26.885),(88.52,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-26.885),(89.03,-26.715),(89.2,-26.715),(89.2,-26.885),(89.03,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-26.885),(89.54,-26.715),(89.71,-26.715),(89.71,-26.885),(89.54,-26.885)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-26.375),(0.29,-26.205),(0.46,-26.205),(0.46,-26.375),(0.29,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-26.375),(0.8,-26.205),(0.97,-26.205),(0.97,-26.375),(0.8,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-26.375),(1.31,-26.205),(1.48,-26.205),(1.48,-26.375),(1.31,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-26.375),(1.82,-26.205),(1.99,-26.205),(1.99,-26.375),(1.82,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-26.375),(2.33,-26.205),(2.5,-26.205),(2.5,-26.375),(2.33,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-26.375),(2.84,-26.205),(3.01,-26.205),(3.01,-26.375),(2.84,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-26.375),(3.35,-26.205),(3.52,-26.205),(3.52,-26.375),(3.35,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-26.375),(3.86,-26.205),(4.03,-26.205),(4.03,-26.375),(3.86,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-26.375),(4.37,-26.205),(4.54,-26.205),(4.54,-26.375),(4.37,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-26.375),(4.88,-26.205),(5.05,-26.205),(5.05,-26.375),(4.88,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-26.375),(5.39,-26.205),(5.56,-26.205),(5.56,-26.375),(5.39,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-26.375),(5.9,-26.205),(6.07,-26.205),(6.07,-26.375),(5.9,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-26.375),(6.41,-26.205),(6.58,-26.205),(6.58,-26.375),(6.41,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-26.375),(6.92,-26.205),(7.09,-26.205),(7.09,-26.375),(6.92,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-26.375),(7.43,-26.205),(7.6,-26.205),(7.6,-26.375),(7.43,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-26.375),(7.94,-26.205),(8.11,-26.205),(8.11,-26.375),(7.94,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-26.375),(8.45,-26.205),(8.62,-26.205),(8.62,-26.375),(8.45,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-26.375),(8.96,-26.205),(9.13,-26.205),(9.13,-26.375),(8.96,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-26.375),(9.47,-26.205),(9.64,-26.205),(9.64,-26.375),(9.47,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-26.375),(9.98,-26.205),(10.15,-26.205),(10.15,-26.375),(9.98,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-26.375),(10.49,-26.205),(10.66,-26.205),(10.66,-26.375),(10.49,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-26.375),(11.0,-26.205),(11.17,-26.205),(11.17,-26.375),(11.0,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-26.375),(11.51,-26.205),(11.68,-26.205),(11.68,-26.375),(11.51,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-26.375),(12.02,-26.205),(12.19,-26.205),(12.19,-26.375),(12.02,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-26.375),(12.53,-26.205),(12.7,-26.205),(12.7,-26.375),(12.53,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-26.375),(13.04,-26.205),(13.21,-26.205),(13.21,-26.375),(13.04,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-26.375),(13.55,-26.205),(13.72,-26.205),(13.72,-26.375),(13.55,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-26.375),(14.06,-26.205),(14.23,-26.205),(14.23,-26.375),(14.06,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-26.375),(14.57,-26.205),(14.74,-26.205),(14.74,-26.375),(14.57,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-26.375),(15.08,-26.205),(15.25,-26.205),(15.25,-26.375),(15.08,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-26.375),(15.59,-26.205),(15.76,-26.205),(15.76,-26.375),(15.59,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-26.375),(16.1,-26.205),(16.27,-26.205),(16.27,-26.375),(16.1,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-26.375),(16.61,-26.205),(16.78,-26.205),(16.78,-26.375),(16.61,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-26.375),(17.12,-26.205),(17.29,-26.205),(17.29,-26.375),(17.12,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-26.375),(17.63,-26.205),(17.8,-26.205),(17.8,-26.375),(17.63,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-26.375),(18.14,-26.205),(18.31,-26.205),(18.31,-26.375),(18.14,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-26.375),(18.65,-26.205),(18.82,-26.205),(18.82,-26.375),(18.65,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-26.375),(19.16,-26.205),(19.33,-26.205),(19.33,-26.375),(19.16,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-26.375),(19.67,-26.205),(19.84,-26.205),(19.84,-26.375),(19.67,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-26.375),(20.18,-26.205),(20.35,-26.205),(20.35,-26.375),(20.18,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-26.375),(20.69,-26.205),(20.86,-26.205),(20.86,-26.375),(20.69,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-26.375),(21.2,-26.205),(21.37,-26.205),(21.37,-26.375),(21.2,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-26.375),(21.71,-26.205),(21.88,-26.205),(21.88,-26.375),(21.71,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-26.375),(22.22,-26.205),(22.39,-26.205),(22.39,-26.375),(22.22,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-26.375),(22.73,-26.205),(22.9,-26.205),(22.9,-26.375),(22.73,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-26.375),(23.24,-26.205),(23.41,-26.205),(23.41,-26.375),(23.24,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-26.375),(23.75,-26.205),(23.92,-26.205),(23.92,-26.375),(23.75,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-26.375),(24.26,-26.205),(24.43,-26.205),(24.43,-26.375),(24.26,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-26.375),(24.77,-26.205),(24.94,-26.205),(24.94,-26.375),(24.77,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-26.375),(25.28,-26.205),(25.45,-26.205),(25.45,-26.375),(25.28,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-26.375),(25.79,-26.205),(25.96,-26.205),(25.96,-26.375),(25.79,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-26.375),(26.3,-26.205),(26.47,-26.205),(26.47,-26.375),(26.3,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-26.375),(26.81,-26.205),(26.98,-26.205),(26.98,-26.375),(26.81,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-26.375),(27.32,-26.205),(27.49,-26.205),(27.49,-26.375),(27.32,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-26.375),(27.83,-26.205),(28.0,-26.205),(28.0,-26.375),(27.83,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-26.375),(28.34,-26.205),(28.51,-26.205),(28.51,-26.375),(28.34,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-26.375),(28.85,-26.205),(29.02,-26.205),(29.02,-26.375),(28.85,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-26.375),(29.36,-26.205),(29.53,-26.205),(29.53,-26.375),(29.36,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-26.375),(29.87,-26.205),(30.04,-26.205),(30.04,-26.375),(29.87,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-26.375),(30.38,-26.205),(30.55,-26.205),(30.55,-26.375),(30.38,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-26.375),(30.89,-26.205),(31.06,-26.205),(31.06,-26.375),(30.89,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-26.375),(31.4,-26.205),(31.57,-26.205),(31.57,-26.375),(31.4,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-26.375),(31.91,-26.205),(32.08,-26.205),(32.08,-26.375),(31.91,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-26.375),(32.42,-26.205),(32.59,-26.205),(32.59,-26.375),(32.42,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-26.375),(32.93,-26.205),(33.1,-26.205),(33.1,-26.375),(32.93,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-26.375),(33.44,-26.205),(33.61,-26.205),(33.61,-26.375),(33.44,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-26.375),(33.95,-26.205),(34.12,-26.205),(34.12,-26.375),(33.95,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-26.375),(34.46,-26.205),(34.63,-26.205),(34.63,-26.375),(34.46,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-26.375),(34.97,-26.205),(35.14,-26.205),(35.14,-26.375),(34.97,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-26.375),(35.48,-26.205),(35.65,-26.205),(35.65,-26.375),(35.48,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-26.375),(35.99,-26.205),(36.16,-26.205),(36.16,-26.375),(35.99,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-26.375),(36.5,-26.205),(36.67,-26.205),(36.67,-26.375),(36.5,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-26.375),(37.01,-26.205),(37.18,-26.205),(37.18,-26.375),(37.01,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-26.375),(37.52,-26.205),(37.69,-26.205),(37.69,-26.375),(37.52,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-26.375),(38.03,-26.205),(38.2,-26.205),(38.2,-26.375),(38.03,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-26.375),(38.54,-26.205),(38.71,-26.205),(38.71,-26.375),(38.54,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-26.375),(39.05,-26.205),(39.22,-26.205),(39.22,-26.375),(39.05,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-26.375),(39.56,-26.205),(39.73,-26.205),(39.73,-26.375),(39.56,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-26.375),(40.07,-26.205),(40.24,-26.205),(40.24,-26.375),(40.07,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-26.375),(40.58,-26.205),(40.75,-26.205),(40.75,-26.375),(40.58,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-26.375),(41.09,-26.205),(41.26,-26.205),(41.26,-26.375),(41.09,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-26.375),(41.6,-26.205),(41.77,-26.205),(41.77,-26.375),(41.6,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-26.375),(42.11,-26.205),(42.28,-26.205),(42.28,-26.375),(42.11,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-26.375),(42.62,-26.205),(42.79,-26.205),(42.79,-26.375),(42.62,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-26.375),(43.13,-26.205),(43.3,-26.205),(43.3,-26.375),(43.13,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-26.375),(43.64,-26.205),(43.81,-26.205),(43.81,-26.375),(43.64,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-26.375),(44.15,-26.205),(44.32,-26.205),(44.32,-26.375),(44.15,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-26.375),(44.66,-26.205),(44.83,-26.205),(44.83,-26.375),(44.66,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-26.375),(45.17,-26.205),(45.34,-26.205),(45.34,-26.375),(45.17,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-26.375),(45.68,-26.205),(45.85,-26.205),(45.85,-26.375),(45.68,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-26.375),(46.19,-26.205),(46.36,-26.205),(46.36,-26.375),(46.19,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-26.375),(46.7,-26.205),(46.87,-26.205),(46.87,-26.375),(46.7,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-26.375),(47.21,-26.205),(47.38,-26.205),(47.38,-26.375),(47.21,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-26.375),(47.72,-26.205),(47.89,-26.205),(47.89,-26.375),(47.72,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-26.375),(48.23,-26.205),(48.4,-26.205),(48.4,-26.375),(48.23,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-26.375),(48.74,-26.205),(48.91,-26.205),(48.91,-26.375),(48.74,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-26.375),(49.25,-26.205),(49.42,-26.205),(49.42,-26.375),(49.25,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-26.375),(49.76,-26.205),(49.93,-26.205),(49.93,-26.375),(49.76,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-26.375),(50.27,-26.205),(50.44,-26.205),(50.44,-26.375),(50.27,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-26.375),(50.78,-26.205),(50.95,-26.205),(50.95,-26.375),(50.78,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-26.375),(51.29,-26.205),(51.46,-26.205),(51.46,-26.375),(51.29,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-26.375),(51.8,-26.205),(51.97,-26.205),(51.97,-26.375),(51.8,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-26.375),(52.31,-26.205),(52.48,-26.205),(52.48,-26.375),(52.31,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-26.375),(52.82,-26.205),(52.99,-26.205),(52.99,-26.375),(52.82,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-26.375),(53.33,-26.205),(53.5,-26.205),(53.5,-26.375),(53.33,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-26.375),(53.84,-26.205),(54.01,-26.205),(54.01,-26.375),(53.84,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-26.375),(54.35,-26.205),(54.52,-26.205),(54.52,-26.375),(54.35,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-26.375),(54.86,-26.205),(55.03,-26.205),(55.03,-26.375),(54.86,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-26.375),(55.37,-26.205),(55.54,-26.205),(55.54,-26.375),(55.37,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-26.375),(55.88,-26.205),(56.05,-26.205),(56.05,-26.375),(55.88,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-26.375),(56.39,-26.205),(56.56,-26.205),(56.56,-26.375),(56.39,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-26.375),(56.9,-26.205),(57.07,-26.205),(57.07,-26.375),(56.9,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-26.375),(57.41,-26.205),(57.58,-26.205),(57.58,-26.375),(57.41,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-26.375),(57.92,-26.205),(58.09,-26.205),(58.09,-26.375),(57.92,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-26.375),(58.43,-26.205),(58.6,-26.205),(58.6,-26.375),(58.43,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-26.375),(58.94,-26.205),(59.11,-26.205),(59.11,-26.375),(58.94,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-26.375),(59.45,-26.205),(59.62,-26.205),(59.62,-26.375),(59.45,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-26.375),(59.96,-26.205),(60.13,-26.205),(60.13,-26.375),(59.96,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-26.375),(60.47,-26.205),(60.64,-26.205),(60.64,-26.375),(60.47,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-26.375),(60.98,-26.205),(61.15,-26.205),(61.15,-26.375),(60.98,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-26.375),(61.49,-26.205),(61.66,-26.205),(61.66,-26.375),(61.49,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-26.375),(62.0,-26.205),(62.17,-26.205),(62.17,-26.375),(62.0,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-26.375),(62.51,-26.205),(62.68,-26.205),(62.68,-26.375),(62.51,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-26.375),(63.02,-26.205),(63.19,-26.205),(63.19,-26.375),(63.02,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-26.375),(63.53,-26.205),(63.7,-26.205),(63.7,-26.375),(63.53,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-26.375),(64.04,-26.205),(64.21,-26.205),(64.21,-26.375),(64.04,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-26.375),(64.55,-26.205),(64.72,-26.205),(64.72,-26.375),(64.55,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-26.375),(65.06,-26.205),(65.23,-26.205),(65.23,-26.375),(65.06,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-26.375),(65.57,-26.205),(65.74,-26.205),(65.74,-26.375),(65.57,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-26.375),(66.08,-26.205),(66.25,-26.205),(66.25,-26.375),(66.08,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-26.375),(66.59,-26.205),(66.76,-26.205),(66.76,-26.375),(66.59,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-26.375),(67.1,-26.205),(67.27,-26.205),(67.27,-26.375),(67.1,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-26.375),(67.61,-26.205),(67.78,-26.205),(67.78,-26.375),(67.61,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-26.375),(68.12,-26.205),(68.29,-26.205),(68.29,-26.375),(68.12,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-26.375),(68.63,-26.205),(68.8,-26.205),(68.8,-26.375),(68.63,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-26.375),(69.14,-26.205),(69.31,-26.205),(69.31,-26.375),(69.14,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-26.375),(69.65,-26.205),(69.82,-26.205),(69.82,-26.375),(69.65,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-26.375),(70.16,-26.205),(70.33,-26.205),(70.33,-26.375),(70.16,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-26.375),(70.67,-26.205),(70.84,-26.205),(70.84,-26.375),(70.67,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-26.375),(71.18,-26.205),(71.35,-26.205),(71.35,-26.375),(71.18,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-26.375),(71.69,-26.205),(71.86,-26.205),(71.86,-26.375),(71.69,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-26.375),(72.2,-26.205),(72.37,-26.205),(72.37,-26.375),(72.2,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-26.375),(72.71,-26.205),(72.88,-26.205),(72.88,-26.375),(72.71,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-26.375),(73.22,-26.205),(73.39,-26.205),(73.39,-26.375),(73.22,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-26.375),(73.73,-26.205),(73.9,-26.205),(73.9,-26.375),(73.73,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-26.375),(74.24,-26.205),(74.41,-26.205),(74.41,-26.375),(74.24,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-26.375),(74.75,-26.205),(74.92,-26.205),(74.92,-26.375),(74.75,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-26.375),(75.26,-26.205),(75.43,-26.205),(75.43,-26.375),(75.26,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-26.375),(75.77,-26.205),(75.94,-26.205),(75.94,-26.375),(75.77,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-26.375),(76.28,-26.205),(76.45,-26.205),(76.45,-26.375),(76.28,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-26.375),(76.79,-26.205),(76.96,-26.205),(76.96,-26.375),(76.79,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-26.375),(77.3,-26.205),(77.47,-26.205),(77.47,-26.375),(77.3,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-26.375),(77.81,-26.205),(77.98,-26.205),(77.98,-26.375),(77.81,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-26.375),(78.32,-26.205),(78.49,-26.205),(78.49,-26.375),(78.32,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-26.375),(78.83,-26.205),(79.0,-26.205),(79.0,-26.375),(78.83,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-26.375),(79.34,-26.205),(79.51,-26.205),(79.51,-26.375),(79.34,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-26.375),(79.85,-26.205),(80.02,-26.205),(80.02,-26.375),(79.85,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-26.375),(80.36,-26.205),(80.53,-26.205),(80.53,-26.375),(80.36,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-26.375),(80.87,-26.205),(81.04,-26.205),(81.04,-26.375),(80.87,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-26.375),(81.38,-26.205),(81.55,-26.205),(81.55,-26.375),(81.38,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-26.375),(81.89,-26.205),(82.06,-26.205),(82.06,-26.375),(81.89,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-26.375),(82.4,-26.205),(82.57,-26.205),(82.57,-26.375),(82.4,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-26.375),(82.91,-26.205),(83.08,-26.205),(83.08,-26.375),(82.91,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-26.375),(83.42,-26.205),(83.59,-26.205),(83.59,-26.375),(83.42,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-26.375),(83.93,-26.205),(84.1,-26.205),(84.1,-26.375),(83.93,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-26.375),(84.44,-26.205),(84.61,-26.205),(84.61,-26.375),(84.44,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-26.375),(84.95,-26.205),(85.12,-26.205),(85.12,-26.375),(84.95,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-26.375),(85.46,-26.205),(85.63,-26.205),(85.63,-26.375),(85.46,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-26.375),(85.97,-26.205),(86.14,-26.205),(86.14,-26.375),(85.97,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-26.375),(86.48,-26.205),(86.65,-26.205),(86.65,-26.375),(86.48,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-26.375),(86.99,-26.205),(87.16,-26.205),(87.16,-26.375),(86.99,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-26.375),(87.5,-26.205),(87.67,-26.205),(87.67,-26.375),(87.5,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-26.375),(88.01,-26.205),(88.18,-26.205),(88.18,-26.375),(88.01,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-26.375),(88.52,-26.205),(88.69,-26.205),(88.69,-26.375),(88.52,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-26.375),(89.03,-26.205),(89.2,-26.205),(89.2,-26.375),(89.03,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-26.375),(89.54,-26.205),(89.71,-26.205),(89.71,-26.375),(89.54,-26.375)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-25.865),(0.29,-25.695),(0.46,-25.695),(0.46,-25.865),(0.29,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-25.865),(0.8,-25.695),(0.97,-25.695),(0.97,-25.865),(0.8,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-25.865),(1.31,-25.695),(1.48,-25.695),(1.48,-25.865),(1.31,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-25.865),(1.82,-25.695),(1.99,-25.695),(1.99,-25.865),(1.82,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-25.865),(2.33,-25.695),(2.5,-25.695),(2.5,-25.865),(2.33,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-25.865),(2.84,-25.695),(3.01,-25.695),(3.01,-25.865),(2.84,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-25.865),(3.35,-25.695),(3.52,-25.695),(3.52,-25.865),(3.35,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-25.865),(3.86,-25.695),(4.03,-25.695),(4.03,-25.865),(3.86,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-25.865),(4.37,-25.695),(4.54,-25.695),(4.54,-25.865),(4.37,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-25.865),(4.88,-25.695),(5.05,-25.695),(5.05,-25.865),(4.88,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-25.865),(5.39,-25.695),(5.56,-25.695),(5.56,-25.865),(5.39,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-25.865),(5.9,-25.695),(6.07,-25.695),(6.07,-25.865),(5.9,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-25.865),(6.41,-25.695),(6.58,-25.695),(6.58,-25.865),(6.41,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-25.865),(6.92,-25.695),(7.09,-25.695),(7.09,-25.865),(6.92,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-25.865),(7.43,-25.695),(7.6,-25.695),(7.6,-25.865),(7.43,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-25.865),(7.94,-25.695),(8.11,-25.695),(8.11,-25.865),(7.94,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-25.865),(8.45,-25.695),(8.62,-25.695),(8.62,-25.865),(8.45,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-25.865),(8.96,-25.695),(9.13,-25.695),(9.13,-25.865),(8.96,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-25.865),(9.47,-25.695),(9.64,-25.695),(9.64,-25.865),(9.47,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-25.865),(9.98,-25.695),(10.15,-25.695),(10.15,-25.865),(9.98,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-25.865),(10.49,-25.695),(10.66,-25.695),(10.66,-25.865),(10.49,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-25.865),(11.0,-25.695),(11.17,-25.695),(11.17,-25.865),(11.0,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-25.865),(11.51,-25.695),(11.68,-25.695),(11.68,-25.865),(11.51,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-25.865),(12.02,-25.695),(12.19,-25.695),(12.19,-25.865),(12.02,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-25.865),(12.53,-25.695),(12.7,-25.695),(12.7,-25.865),(12.53,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-25.865),(13.04,-25.695),(13.21,-25.695),(13.21,-25.865),(13.04,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-25.865),(13.55,-25.695),(13.72,-25.695),(13.72,-25.865),(13.55,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-25.865),(14.06,-25.695),(14.23,-25.695),(14.23,-25.865),(14.06,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-25.865),(14.57,-25.695),(14.74,-25.695),(14.74,-25.865),(14.57,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-25.865),(15.08,-25.695),(15.25,-25.695),(15.25,-25.865),(15.08,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-25.865),(15.59,-25.695),(15.76,-25.695),(15.76,-25.865),(15.59,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-25.865),(16.1,-25.695),(16.27,-25.695),(16.27,-25.865),(16.1,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-25.865),(16.61,-25.695),(16.78,-25.695),(16.78,-25.865),(16.61,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-25.865),(17.12,-25.695),(17.29,-25.695),(17.29,-25.865),(17.12,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-25.865),(17.63,-25.695),(17.8,-25.695),(17.8,-25.865),(17.63,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-25.865),(18.14,-25.695),(18.31,-25.695),(18.31,-25.865),(18.14,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-25.865),(18.65,-25.695),(18.82,-25.695),(18.82,-25.865),(18.65,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-25.865),(19.16,-25.695),(19.33,-25.695),(19.33,-25.865),(19.16,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-25.865),(19.67,-25.695),(19.84,-25.695),(19.84,-25.865),(19.67,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-25.865),(20.18,-25.695),(20.35,-25.695),(20.35,-25.865),(20.18,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-25.865),(20.69,-25.695),(20.86,-25.695),(20.86,-25.865),(20.69,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-25.865),(21.2,-25.695),(21.37,-25.695),(21.37,-25.865),(21.2,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-25.865),(21.71,-25.695),(21.88,-25.695),(21.88,-25.865),(21.71,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-25.865),(22.22,-25.695),(22.39,-25.695),(22.39,-25.865),(22.22,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-25.865),(22.73,-25.695),(22.9,-25.695),(22.9,-25.865),(22.73,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-25.865),(23.24,-25.695),(23.41,-25.695),(23.41,-25.865),(23.24,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-25.865),(23.75,-25.695),(23.92,-25.695),(23.92,-25.865),(23.75,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-25.865),(24.26,-25.695),(24.43,-25.695),(24.43,-25.865),(24.26,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-25.865),(24.77,-25.695),(24.94,-25.695),(24.94,-25.865),(24.77,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-25.865),(25.28,-25.695),(25.45,-25.695),(25.45,-25.865),(25.28,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-25.865),(25.79,-25.695),(25.96,-25.695),(25.96,-25.865),(25.79,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-25.865),(26.3,-25.695),(26.47,-25.695),(26.47,-25.865),(26.3,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-25.865),(26.81,-25.695),(26.98,-25.695),(26.98,-25.865),(26.81,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-25.865),(27.32,-25.695),(27.49,-25.695),(27.49,-25.865),(27.32,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-25.865),(27.83,-25.695),(28.0,-25.695),(28.0,-25.865),(27.83,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-25.865),(28.34,-25.695),(28.51,-25.695),(28.51,-25.865),(28.34,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-25.865),(28.85,-25.695),(29.02,-25.695),(29.02,-25.865),(28.85,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-25.865),(29.36,-25.695),(29.53,-25.695),(29.53,-25.865),(29.36,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-25.865),(29.87,-25.695),(30.04,-25.695),(30.04,-25.865),(29.87,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-25.865),(30.38,-25.695),(30.55,-25.695),(30.55,-25.865),(30.38,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-25.865),(30.89,-25.695),(31.06,-25.695),(31.06,-25.865),(30.89,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-25.865),(31.4,-25.695),(31.57,-25.695),(31.57,-25.865),(31.4,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-25.865),(31.91,-25.695),(32.08,-25.695),(32.08,-25.865),(31.91,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-25.865),(32.42,-25.695),(32.59,-25.695),(32.59,-25.865),(32.42,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-25.865),(32.93,-25.695),(33.1,-25.695),(33.1,-25.865),(32.93,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-25.865),(33.44,-25.695),(33.61,-25.695),(33.61,-25.865),(33.44,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-25.865),(33.95,-25.695),(34.12,-25.695),(34.12,-25.865),(33.95,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-25.865),(34.46,-25.695),(34.63,-25.695),(34.63,-25.865),(34.46,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-25.865),(34.97,-25.695),(35.14,-25.695),(35.14,-25.865),(34.97,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-25.865),(35.48,-25.695),(35.65,-25.695),(35.65,-25.865),(35.48,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-25.865),(35.99,-25.695),(36.16,-25.695),(36.16,-25.865),(35.99,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-25.865),(36.5,-25.695),(36.67,-25.695),(36.67,-25.865),(36.5,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-25.865),(37.01,-25.695),(37.18,-25.695),(37.18,-25.865),(37.01,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-25.865),(37.52,-25.695),(37.69,-25.695),(37.69,-25.865),(37.52,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-25.865),(38.03,-25.695),(38.2,-25.695),(38.2,-25.865),(38.03,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-25.865),(38.54,-25.695),(38.71,-25.695),(38.71,-25.865),(38.54,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-25.865),(39.05,-25.695),(39.22,-25.695),(39.22,-25.865),(39.05,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-25.865),(39.56,-25.695),(39.73,-25.695),(39.73,-25.865),(39.56,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-25.865),(40.07,-25.695),(40.24,-25.695),(40.24,-25.865),(40.07,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-25.865),(40.58,-25.695),(40.75,-25.695),(40.75,-25.865),(40.58,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-25.865),(41.09,-25.695),(41.26,-25.695),(41.26,-25.865),(41.09,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-25.865),(41.6,-25.695),(41.77,-25.695),(41.77,-25.865),(41.6,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-25.865),(42.11,-25.695),(42.28,-25.695),(42.28,-25.865),(42.11,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-25.865),(42.62,-25.695),(42.79,-25.695),(42.79,-25.865),(42.62,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-25.865),(43.13,-25.695),(43.3,-25.695),(43.3,-25.865),(43.13,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-25.865),(43.64,-25.695),(43.81,-25.695),(43.81,-25.865),(43.64,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-25.865),(44.15,-25.695),(44.32,-25.695),(44.32,-25.865),(44.15,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-25.865),(44.66,-25.695),(44.83,-25.695),(44.83,-25.865),(44.66,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-25.865),(45.17,-25.695),(45.34,-25.695),(45.34,-25.865),(45.17,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-25.865),(45.68,-25.695),(45.85,-25.695),(45.85,-25.865),(45.68,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-25.865),(46.19,-25.695),(46.36,-25.695),(46.36,-25.865),(46.19,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-25.865),(46.7,-25.695),(46.87,-25.695),(46.87,-25.865),(46.7,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-25.865),(47.21,-25.695),(47.38,-25.695),(47.38,-25.865),(47.21,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-25.865),(47.72,-25.695),(47.89,-25.695),(47.89,-25.865),(47.72,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-25.865),(48.23,-25.695),(48.4,-25.695),(48.4,-25.865),(48.23,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-25.865),(48.74,-25.695),(48.91,-25.695),(48.91,-25.865),(48.74,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-25.865),(49.25,-25.695),(49.42,-25.695),(49.42,-25.865),(49.25,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-25.865),(49.76,-25.695),(49.93,-25.695),(49.93,-25.865),(49.76,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-25.865),(50.27,-25.695),(50.44,-25.695),(50.44,-25.865),(50.27,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-25.865),(50.78,-25.695),(50.95,-25.695),(50.95,-25.865),(50.78,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-25.865),(51.29,-25.695),(51.46,-25.695),(51.46,-25.865),(51.29,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-25.865),(51.8,-25.695),(51.97,-25.695),(51.97,-25.865),(51.8,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-25.865),(52.31,-25.695),(52.48,-25.695),(52.48,-25.865),(52.31,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-25.865),(52.82,-25.695),(52.99,-25.695),(52.99,-25.865),(52.82,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-25.865),(53.33,-25.695),(53.5,-25.695),(53.5,-25.865),(53.33,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-25.865),(53.84,-25.695),(54.01,-25.695),(54.01,-25.865),(53.84,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-25.865),(54.35,-25.695),(54.52,-25.695),(54.52,-25.865),(54.35,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-25.865),(54.86,-25.695),(55.03,-25.695),(55.03,-25.865),(54.86,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-25.865),(55.37,-25.695),(55.54,-25.695),(55.54,-25.865),(55.37,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-25.865),(55.88,-25.695),(56.05,-25.695),(56.05,-25.865),(55.88,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-25.865),(56.39,-25.695),(56.56,-25.695),(56.56,-25.865),(56.39,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-25.865),(56.9,-25.695),(57.07,-25.695),(57.07,-25.865),(56.9,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-25.865),(57.41,-25.695),(57.58,-25.695),(57.58,-25.865),(57.41,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-25.865),(57.92,-25.695),(58.09,-25.695),(58.09,-25.865),(57.92,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-25.865),(58.43,-25.695),(58.6,-25.695),(58.6,-25.865),(58.43,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-25.865),(58.94,-25.695),(59.11,-25.695),(59.11,-25.865),(58.94,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-25.865),(59.45,-25.695),(59.62,-25.695),(59.62,-25.865),(59.45,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-25.865),(59.96,-25.695),(60.13,-25.695),(60.13,-25.865),(59.96,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-25.865),(60.47,-25.695),(60.64,-25.695),(60.64,-25.865),(60.47,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-25.865),(60.98,-25.695),(61.15,-25.695),(61.15,-25.865),(60.98,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-25.865),(61.49,-25.695),(61.66,-25.695),(61.66,-25.865),(61.49,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-25.865),(62.0,-25.695),(62.17,-25.695),(62.17,-25.865),(62.0,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-25.865),(62.51,-25.695),(62.68,-25.695),(62.68,-25.865),(62.51,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-25.865),(63.02,-25.695),(63.19,-25.695),(63.19,-25.865),(63.02,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-25.865),(63.53,-25.695),(63.7,-25.695),(63.7,-25.865),(63.53,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-25.865),(64.04,-25.695),(64.21,-25.695),(64.21,-25.865),(64.04,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-25.865),(64.55,-25.695),(64.72,-25.695),(64.72,-25.865),(64.55,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-25.865),(65.06,-25.695),(65.23,-25.695),(65.23,-25.865),(65.06,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-25.865),(65.57,-25.695),(65.74,-25.695),(65.74,-25.865),(65.57,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-25.865),(66.08,-25.695),(66.25,-25.695),(66.25,-25.865),(66.08,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-25.865),(66.59,-25.695),(66.76,-25.695),(66.76,-25.865),(66.59,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-25.865),(67.1,-25.695),(67.27,-25.695),(67.27,-25.865),(67.1,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-25.865),(67.61,-25.695),(67.78,-25.695),(67.78,-25.865),(67.61,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-25.865),(68.12,-25.695),(68.29,-25.695),(68.29,-25.865),(68.12,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-25.865),(68.63,-25.695),(68.8,-25.695),(68.8,-25.865),(68.63,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-25.865),(69.14,-25.695),(69.31,-25.695),(69.31,-25.865),(69.14,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-25.865),(69.65,-25.695),(69.82,-25.695),(69.82,-25.865),(69.65,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-25.865),(70.16,-25.695),(70.33,-25.695),(70.33,-25.865),(70.16,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-25.865),(70.67,-25.695),(70.84,-25.695),(70.84,-25.865),(70.67,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-25.865),(71.18,-25.695),(71.35,-25.695),(71.35,-25.865),(71.18,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-25.865),(71.69,-25.695),(71.86,-25.695),(71.86,-25.865),(71.69,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-25.865),(72.2,-25.695),(72.37,-25.695),(72.37,-25.865),(72.2,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-25.865),(72.71,-25.695),(72.88,-25.695),(72.88,-25.865),(72.71,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-25.865),(73.22,-25.695),(73.39,-25.695),(73.39,-25.865),(73.22,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-25.865),(73.73,-25.695),(73.9,-25.695),(73.9,-25.865),(73.73,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-25.865),(74.24,-25.695),(74.41,-25.695),(74.41,-25.865),(74.24,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-25.865),(74.75,-25.695),(74.92,-25.695),(74.92,-25.865),(74.75,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-25.865),(75.26,-25.695),(75.43,-25.695),(75.43,-25.865),(75.26,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-25.865),(75.77,-25.695),(75.94,-25.695),(75.94,-25.865),(75.77,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-25.865),(76.28,-25.695),(76.45,-25.695),(76.45,-25.865),(76.28,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-25.865),(76.79,-25.695),(76.96,-25.695),(76.96,-25.865),(76.79,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-25.865),(77.3,-25.695),(77.47,-25.695),(77.47,-25.865),(77.3,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-25.865),(77.81,-25.695),(77.98,-25.695),(77.98,-25.865),(77.81,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-25.865),(78.32,-25.695),(78.49,-25.695),(78.49,-25.865),(78.32,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-25.865),(78.83,-25.695),(79.0,-25.695),(79.0,-25.865),(78.83,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-25.865),(79.34,-25.695),(79.51,-25.695),(79.51,-25.865),(79.34,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-25.865),(79.85,-25.695),(80.02,-25.695),(80.02,-25.865),(79.85,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-25.865),(80.36,-25.695),(80.53,-25.695),(80.53,-25.865),(80.36,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-25.865),(80.87,-25.695),(81.04,-25.695),(81.04,-25.865),(80.87,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-25.865),(81.38,-25.695),(81.55,-25.695),(81.55,-25.865),(81.38,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-25.865),(81.89,-25.695),(82.06,-25.695),(82.06,-25.865),(81.89,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-25.865),(82.4,-25.695),(82.57,-25.695),(82.57,-25.865),(82.4,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-25.865),(82.91,-25.695),(83.08,-25.695),(83.08,-25.865),(82.91,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-25.865),(83.42,-25.695),(83.59,-25.695),(83.59,-25.865),(83.42,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-25.865),(83.93,-25.695),(84.1,-25.695),(84.1,-25.865),(83.93,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-25.865),(84.44,-25.695),(84.61,-25.695),(84.61,-25.865),(84.44,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-25.865),(84.95,-25.695),(85.12,-25.695),(85.12,-25.865),(84.95,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-25.865),(85.46,-25.695),(85.63,-25.695),(85.63,-25.865),(85.46,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-25.865),(85.97,-25.695),(86.14,-25.695),(86.14,-25.865),(85.97,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-25.865),(86.48,-25.695),(86.65,-25.695),(86.65,-25.865),(86.48,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-25.865),(86.99,-25.695),(87.16,-25.695),(87.16,-25.865),(86.99,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-25.865),(87.5,-25.695),(87.67,-25.695),(87.67,-25.865),(87.5,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-25.865),(88.01,-25.695),(88.18,-25.695),(88.18,-25.865),(88.01,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-25.865),(88.52,-25.695),(88.69,-25.695),(88.69,-25.865),(88.52,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-25.865),(89.03,-25.695),(89.2,-25.695),(89.2,-25.865),(89.03,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-25.865),(89.54,-25.695),(89.71,-25.695),(89.71,-25.865),(89.54,-25.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-25.355),(0.29,-25.185),(0.46,-25.185),(0.46,-25.355),(0.29,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-25.355),(0.8,-25.185),(0.97,-25.185),(0.97,-25.355),(0.8,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-25.355),(1.31,-25.185),(1.48,-25.185),(1.48,-25.355),(1.31,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-25.355),(1.82,-25.185),(1.99,-25.185),(1.99,-25.355),(1.82,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-25.355),(2.33,-25.185),(2.5,-25.185),(2.5,-25.355),(2.33,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-25.355),(2.84,-25.185),(3.01,-25.185),(3.01,-25.355),(2.84,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-25.355),(3.35,-25.185),(3.52,-25.185),(3.52,-25.355),(3.35,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-25.355),(3.86,-25.185),(4.03,-25.185),(4.03,-25.355),(3.86,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-25.355),(4.37,-25.185),(4.54,-25.185),(4.54,-25.355),(4.37,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-25.355),(4.88,-25.185),(5.05,-25.185),(5.05,-25.355),(4.88,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-25.355),(5.39,-25.185),(5.56,-25.185),(5.56,-25.355),(5.39,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-25.355),(5.9,-25.185),(6.07,-25.185),(6.07,-25.355),(5.9,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-25.355),(6.41,-25.185),(6.58,-25.185),(6.58,-25.355),(6.41,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-25.355),(6.92,-25.185),(7.09,-25.185),(7.09,-25.355),(6.92,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-25.355),(7.43,-25.185),(7.6,-25.185),(7.6,-25.355),(7.43,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-25.355),(7.94,-25.185),(8.11,-25.185),(8.11,-25.355),(7.94,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-25.355),(8.45,-25.185),(8.62,-25.185),(8.62,-25.355),(8.45,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-25.355),(8.96,-25.185),(9.13,-25.185),(9.13,-25.355),(8.96,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-25.355),(9.47,-25.185),(9.64,-25.185),(9.64,-25.355),(9.47,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-25.355),(9.98,-25.185),(10.15,-25.185),(10.15,-25.355),(9.98,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-25.355),(10.49,-25.185),(10.66,-25.185),(10.66,-25.355),(10.49,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-25.355),(11.0,-25.185),(11.17,-25.185),(11.17,-25.355),(11.0,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-25.355),(11.51,-25.185),(11.68,-25.185),(11.68,-25.355),(11.51,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-25.355),(12.02,-25.185),(12.19,-25.185),(12.19,-25.355),(12.02,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-25.355),(12.53,-25.185),(12.7,-25.185),(12.7,-25.355),(12.53,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-25.355),(13.04,-25.185),(13.21,-25.185),(13.21,-25.355),(13.04,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-25.355),(13.55,-25.185),(13.72,-25.185),(13.72,-25.355),(13.55,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-25.355),(14.06,-25.185),(14.23,-25.185),(14.23,-25.355),(14.06,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-25.355),(14.57,-25.185),(14.74,-25.185),(14.74,-25.355),(14.57,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-25.355),(15.08,-25.185),(15.25,-25.185),(15.25,-25.355),(15.08,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-25.355),(15.59,-25.185),(15.76,-25.185),(15.76,-25.355),(15.59,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-25.355),(16.1,-25.185),(16.27,-25.185),(16.27,-25.355),(16.1,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-25.355),(16.61,-25.185),(16.78,-25.185),(16.78,-25.355),(16.61,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-25.355),(17.12,-25.185),(17.29,-25.185),(17.29,-25.355),(17.12,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-25.355),(17.63,-25.185),(17.8,-25.185),(17.8,-25.355),(17.63,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-25.355),(18.14,-25.185),(18.31,-25.185),(18.31,-25.355),(18.14,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-25.355),(18.65,-25.185),(18.82,-25.185),(18.82,-25.355),(18.65,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-25.355),(19.16,-25.185),(19.33,-25.185),(19.33,-25.355),(19.16,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-25.355),(19.67,-25.185),(19.84,-25.185),(19.84,-25.355),(19.67,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-25.355),(20.18,-25.185),(20.35,-25.185),(20.35,-25.355),(20.18,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-25.355),(20.69,-25.185),(20.86,-25.185),(20.86,-25.355),(20.69,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-25.355),(21.2,-25.185),(21.37,-25.185),(21.37,-25.355),(21.2,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-25.355),(21.71,-25.185),(21.88,-25.185),(21.88,-25.355),(21.71,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-25.355),(22.22,-25.185),(22.39,-25.185),(22.39,-25.355),(22.22,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-25.355),(22.73,-25.185),(22.9,-25.185),(22.9,-25.355),(22.73,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-25.355),(23.24,-25.185),(23.41,-25.185),(23.41,-25.355),(23.24,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-25.355),(23.75,-25.185),(23.92,-25.185),(23.92,-25.355),(23.75,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-25.355),(24.26,-25.185),(24.43,-25.185),(24.43,-25.355),(24.26,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-25.355),(24.77,-25.185),(24.94,-25.185),(24.94,-25.355),(24.77,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-25.355),(25.28,-25.185),(25.45,-25.185),(25.45,-25.355),(25.28,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-25.355),(25.79,-25.185),(25.96,-25.185),(25.96,-25.355),(25.79,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-25.355),(26.3,-25.185),(26.47,-25.185),(26.47,-25.355),(26.3,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-25.355),(26.81,-25.185),(26.98,-25.185),(26.98,-25.355),(26.81,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-25.355),(27.32,-25.185),(27.49,-25.185),(27.49,-25.355),(27.32,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-25.355),(27.83,-25.185),(28.0,-25.185),(28.0,-25.355),(27.83,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-25.355),(28.34,-25.185),(28.51,-25.185),(28.51,-25.355),(28.34,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-25.355),(28.85,-25.185),(29.02,-25.185),(29.02,-25.355),(28.85,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-25.355),(29.36,-25.185),(29.53,-25.185),(29.53,-25.355),(29.36,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-25.355),(29.87,-25.185),(30.04,-25.185),(30.04,-25.355),(29.87,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-25.355),(30.38,-25.185),(30.55,-25.185),(30.55,-25.355),(30.38,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-25.355),(30.89,-25.185),(31.06,-25.185),(31.06,-25.355),(30.89,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-25.355),(31.4,-25.185),(31.57,-25.185),(31.57,-25.355),(31.4,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-25.355),(31.91,-25.185),(32.08,-25.185),(32.08,-25.355),(31.91,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-25.355),(32.42,-25.185),(32.59,-25.185),(32.59,-25.355),(32.42,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-25.355),(32.93,-25.185),(33.1,-25.185),(33.1,-25.355),(32.93,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-25.355),(33.44,-25.185),(33.61,-25.185),(33.61,-25.355),(33.44,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-25.355),(33.95,-25.185),(34.12,-25.185),(34.12,-25.355),(33.95,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-25.355),(34.46,-25.185),(34.63,-25.185),(34.63,-25.355),(34.46,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-25.355),(34.97,-25.185),(35.14,-25.185),(35.14,-25.355),(34.97,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-25.355),(35.48,-25.185),(35.65,-25.185),(35.65,-25.355),(35.48,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-25.355),(35.99,-25.185),(36.16,-25.185),(36.16,-25.355),(35.99,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-25.355),(36.5,-25.185),(36.67,-25.185),(36.67,-25.355),(36.5,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-25.355),(37.01,-25.185),(37.18,-25.185),(37.18,-25.355),(37.01,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-25.355),(37.52,-25.185),(37.69,-25.185),(37.69,-25.355),(37.52,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-25.355),(38.03,-25.185),(38.2,-25.185),(38.2,-25.355),(38.03,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-25.355),(38.54,-25.185),(38.71,-25.185),(38.71,-25.355),(38.54,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-25.355),(39.05,-25.185),(39.22,-25.185),(39.22,-25.355),(39.05,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-25.355),(39.56,-25.185),(39.73,-25.185),(39.73,-25.355),(39.56,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-25.355),(40.07,-25.185),(40.24,-25.185),(40.24,-25.355),(40.07,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-25.355),(40.58,-25.185),(40.75,-25.185),(40.75,-25.355),(40.58,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-25.355),(41.09,-25.185),(41.26,-25.185),(41.26,-25.355),(41.09,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-25.355),(41.6,-25.185),(41.77,-25.185),(41.77,-25.355),(41.6,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-25.355),(42.11,-25.185),(42.28,-25.185),(42.28,-25.355),(42.11,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-25.355),(42.62,-25.185),(42.79,-25.185),(42.79,-25.355),(42.62,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-25.355),(43.13,-25.185),(43.3,-25.185),(43.3,-25.355),(43.13,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-25.355),(43.64,-25.185),(43.81,-25.185),(43.81,-25.355),(43.64,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-25.355),(44.15,-25.185),(44.32,-25.185),(44.32,-25.355),(44.15,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-25.355),(44.66,-25.185),(44.83,-25.185),(44.83,-25.355),(44.66,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-25.355),(45.17,-25.185),(45.34,-25.185),(45.34,-25.355),(45.17,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-25.355),(45.68,-25.185),(45.85,-25.185),(45.85,-25.355),(45.68,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-25.355),(46.19,-25.185),(46.36,-25.185),(46.36,-25.355),(46.19,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-25.355),(46.7,-25.185),(46.87,-25.185),(46.87,-25.355),(46.7,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-25.355),(47.21,-25.185),(47.38,-25.185),(47.38,-25.355),(47.21,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-25.355),(47.72,-25.185),(47.89,-25.185),(47.89,-25.355),(47.72,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-25.355),(48.23,-25.185),(48.4,-25.185),(48.4,-25.355),(48.23,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-25.355),(48.74,-25.185),(48.91,-25.185),(48.91,-25.355),(48.74,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-25.355),(49.25,-25.185),(49.42,-25.185),(49.42,-25.355),(49.25,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-25.355),(49.76,-25.185),(49.93,-25.185),(49.93,-25.355),(49.76,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-25.355),(50.27,-25.185),(50.44,-25.185),(50.44,-25.355),(50.27,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-25.355),(50.78,-25.185),(50.95,-25.185),(50.95,-25.355),(50.78,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-25.355),(51.29,-25.185),(51.46,-25.185),(51.46,-25.355),(51.29,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-25.355),(51.8,-25.185),(51.97,-25.185),(51.97,-25.355),(51.8,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-25.355),(52.31,-25.185),(52.48,-25.185),(52.48,-25.355),(52.31,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-25.355),(52.82,-25.185),(52.99,-25.185),(52.99,-25.355),(52.82,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-25.355),(53.33,-25.185),(53.5,-25.185),(53.5,-25.355),(53.33,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-25.355),(53.84,-25.185),(54.01,-25.185),(54.01,-25.355),(53.84,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-25.355),(54.35,-25.185),(54.52,-25.185),(54.52,-25.355),(54.35,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-25.355),(54.86,-25.185),(55.03,-25.185),(55.03,-25.355),(54.86,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-25.355),(55.37,-25.185),(55.54,-25.185),(55.54,-25.355),(55.37,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-25.355),(55.88,-25.185),(56.05,-25.185),(56.05,-25.355),(55.88,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-25.355),(56.39,-25.185),(56.56,-25.185),(56.56,-25.355),(56.39,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-25.355),(56.9,-25.185),(57.07,-25.185),(57.07,-25.355),(56.9,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-25.355),(57.41,-25.185),(57.58,-25.185),(57.58,-25.355),(57.41,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-25.355),(57.92,-25.185),(58.09,-25.185),(58.09,-25.355),(57.92,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-25.355),(58.43,-25.185),(58.6,-25.185),(58.6,-25.355),(58.43,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-25.355),(58.94,-25.185),(59.11,-25.185),(59.11,-25.355),(58.94,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-25.355),(59.45,-25.185),(59.62,-25.185),(59.62,-25.355),(59.45,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-25.355),(59.96,-25.185),(60.13,-25.185),(60.13,-25.355),(59.96,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-25.355),(60.47,-25.185),(60.64,-25.185),(60.64,-25.355),(60.47,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-25.355),(60.98,-25.185),(61.15,-25.185),(61.15,-25.355),(60.98,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-25.355),(61.49,-25.185),(61.66,-25.185),(61.66,-25.355),(61.49,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-25.355),(62.0,-25.185),(62.17,-25.185),(62.17,-25.355),(62.0,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-25.355),(62.51,-25.185),(62.68,-25.185),(62.68,-25.355),(62.51,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-25.355),(63.02,-25.185),(63.19,-25.185),(63.19,-25.355),(63.02,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-25.355),(63.53,-25.185),(63.7,-25.185),(63.7,-25.355),(63.53,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-25.355),(64.04,-25.185),(64.21,-25.185),(64.21,-25.355),(64.04,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-25.355),(64.55,-25.185),(64.72,-25.185),(64.72,-25.355),(64.55,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-25.355),(65.06,-25.185),(65.23,-25.185),(65.23,-25.355),(65.06,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-25.355),(65.57,-25.185),(65.74,-25.185),(65.74,-25.355),(65.57,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-25.355),(66.08,-25.185),(66.25,-25.185),(66.25,-25.355),(66.08,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-25.355),(66.59,-25.185),(66.76,-25.185),(66.76,-25.355),(66.59,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-25.355),(67.1,-25.185),(67.27,-25.185),(67.27,-25.355),(67.1,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-25.355),(67.61,-25.185),(67.78,-25.185),(67.78,-25.355),(67.61,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-25.355),(68.12,-25.185),(68.29,-25.185),(68.29,-25.355),(68.12,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-25.355),(68.63,-25.185),(68.8,-25.185),(68.8,-25.355),(68.63,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-25.355),(69.14,-25.185),(69.31,-25.185),(69.31,-25.355),(69.14,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-25.355),(69.65,-25.185),(69.82,-25.185),(69.82,-25.355),(69.65,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-25.355),(70.16,-25.185),(70.33,-25.185),(70.33,-25.355),(70.16,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-25.355),(70.67,-25.185),(70.84,-25.185),(70.84,-25.355),(70.67,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-25.355),(71.18,-25.185),(71.35,-25.185),(71.35,-25.355),(71.18,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-25.355),(71.69,-25.185),(71.86,-25.185),(71.86,-25.355),(71.69,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-25.355),(72.2,-25.185),(72.37,-25.185),(72.37,-25.355),(72.2,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-25.355),(72.71,-25.185),(72.88,-25.185),(72.88,-25.355),(72.71,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-25.355),(73.22,-25.185),(73.39,-25.185),(73.39,-25.355),(73.22,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-25.355),(73.73,-25.185),(73.9,-25.185),(73.9,-25.355),(73.73,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-25.355),(74.24,-25.185),(74.41,-25.185),(74.41,-25.355),(74.24,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-25.355),(74.75,-25.185),(74.92,-25.185),(74.92,-25.355),(74.75,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-25.355),(75.26,-25.185),(75.43,-25.185),(75.43,-25.355),(75.26,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-25.355),(75.77,-25.185),(75.94,-25.185),(75.94,-25.355),(75.77,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-25.355),(76.28,-25.185),(76.45,-25.185),(76.45,-25.355),(76.28,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-25.355),(76.79,-25.185),(76.96,-25.185),(76.96,-25.355),(76.79,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-25.355),(77.3,-25.185),(77.47,-25.185),(77.47,-25.355),(77.3,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-25.355),(77.81,-25.185),(77.98,-25.185),(77.98,-25.355),(77.81,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-25.355),(78.32,-25.185),(78.49,-25.185),(78.49,-25.355),(78.32,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-25.355),(78.83,-25.185),(79.0,-25.185),(79.0,-25.355),(78.83,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-25.355),(79.34,-25.185),(79.51,-25.185),(79.51,-25.355),(79.34,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-25.355),(79.85,-25.185),(80.02,-25.185),(80.02,-25.355),(79.85,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-25.355),(80.36,-25.185),(80.53,-25.185),(80.53,-25.355),(80.36,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-25.355),(80.87,-25.185),(81.04,-25.185),(81.04,-25.355),(80.87,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-25.355),(81.38,-25.185),(81.55,-25.185),(81.55,-25.355),(81.38,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-25.355),(81.89,-25.185),(82.06,-25.185),(82.06,-25.355),(81.89,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-25.355),(82.4,-25.185),(82.57,-25.185),(82.57,-25.355),(82.4,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-25.355),(82.91,-25.185),(83.08,-25.185),(83.08,-25.355),(82.91,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-25.355),(83.42,-25.185),(83.59,-25.185),(83.59,-25.355),(83.42,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-25.355),(83.93,-25.185),(84.1,-25.185),(84.1,-25.355),(83.93,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-25.355),(84.44,-25.185),(84.61,-25.185),(84.61,-25.355),(84.44,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-25.355),(84.95,-25.185),(85.12,-25.185),(85.12,-25.355),(84.95,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-25.355),(85.46,-25.185),(85.63,-25.185),(85.63,-25.355),(85.46,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-25.355),(85.97,-25.185),(86.14,-25.185),(86.14,-25.355),(85.97,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-25.355),(86.48,-25.185),(86.65,-25.185),(86.65,-25.355),(86.48,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-25.355),(86.99,-25.185),(87.16,-25.185),(87.16,-25.355),(86.99,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-25.355),(87.5,-25.185),(87.67,-25.185),(87.67,-25.355),(87.5,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-25.355),(88.01,-25.185),(88.18,-25.185),(88.18,-25.355),(88.01,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-25.355),(88.52,-25.185),(88.69,-25.185),(88.69,-25.355),(88.52,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-25.355),(89.03,-25.185),(89.2,-25.185),(89.2,-25.355),(89.03,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-25.355),(89.54,-25.185),(89.71,-25.185),(89.71,-25.355),(89.54,-25.355)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-24.845),(0.29,-24.675),(0.46,-24.675),(0.46,-24.845),(0.29,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-24.845),(0.8,-24.675),(0.97,-24.675),(0.97,-24.845),(0.8,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-24.845),(1.31,-24.675),(1.48,-24.675),(1.48,-24.845),(1.31,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-24.845),(1.82,-24.675),(1.99,-24.675),(1.99,-24.845),(1.82,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-24.845),(2.33,-24.675),(2.5,-24.675),(2.5,-24.845),(2.33,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-24.845),(2.84,-24.675),(3.01,-24.675),(3.01,-24.845),(2.84,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-24.845),(3.35,-24.675),(3.52,-24.675),(3.52,-24.845),(3.35,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-24.845),(3.86,-24.675),(4.03,-24.675),(4.03,-24.845),(3.86,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-24.845),(4.37,-24.675),(4.54,-24.675),(4.54,-24.845),(4.37,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-24.845),(4.88,-24.675),(5.05,-24.675),(5.05,-24.845),(4.88,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-24.845),(5.39,-24.675),(5.56,-24.675),(5.56,-24.845),(5.39,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-24.845),(5.9,-24.675),(6.07,-24.675),(6.07,-24.845),(5.9,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-24.845),(6.41,-24.675),(6.58,-24.675),(6.58,-24.845),(6.41,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-24.845),(6.92,-24.675),(7.09,-24.675),(7.09,-24.845),(6.92,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-24.845),(7.43,-24.675),(7.6,-24.675),(7.6,-24.845),(7.43,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-24.845),(7.94,-24.675),(8.11,-24.675),(8.11,-24.845),(7.94,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-24.845),(8.45,-24.675),(8.62,-24.675),(8.62,-24.845),(8.45,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-24.845),(8.96,-24.675),(9.13,-24.675),(9.13,-24.845),(8.96,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-24.845),(9.47,-24.675),(9.64,-24.675),(9.64,-24.845),(9.47,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-24.845),(9.98,-24.675),(10.15,-24.675),(10.15,-24.845),(9.98,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-24.845),(10.49,-24.675),(10.66,-24.675),(10.66,-24.845),(10.49,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-24.845),(11.0,-24.675),(11.17,-24.675),(11.17,-24.845),(11.0,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-24.845),(11.51,-24.675),(11.68,-24.675),(11.68,-24.845),(11.51,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-24.845),(12.02,-24.675),(12.19,-24.675),(12.19,-24.845),(12.02,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-24.845),(12.53,-24.675),(12.7,-24.675),(12.7,-24.845),(12.53,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-24.845),(13.04,-24.675),(13.21,-24.675),(13.21,-24.845),(13.04,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-24.845),(13.55,-24.675),(13.72,-24.675),(13.72,-24.845),(13.55,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-24.845),(14.06,-24.675),(14.23,-24.675),(14.23,-24.845),(14.06,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-24.845),(14.57,-24.675),(14.74,-24.675),(14.74,-24.845),(14.57,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-24.845),(15.08,-24.675),(15.25,-24.675),(15.25,-24.845),(15.08,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-24.845),(15.59,-24.675),(15.76,-24.675),(15.76,-24.845),(15.59,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-24.845),(16.1,-24.675),(16.27,-24.675),(16.27,-24.845),(16.1,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-24.845),(16.61,-24.675),(16.78,-24.675),(16.78,-24.845),(16.61,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-24.845),(17.12,-24.675),(17.29,-24.675),(17.29,-24.845),(17.12,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-24.845),(17.63,-24.675),(17.8,-24.675),(17.8,-24.845),(17.63,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-24.845),(18.14,-24.675),(18.31,-24.675),(18.31,-24.845),(18.14,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-24.845),(18.65,-24.675),(18.82,-24.675),(18.82,-24.845),(18.65,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-24.845),(19.16,-24.675),(19.33,-24.675),(19.33,-24.845),(19.16,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-24.845),(19.67,-24.675),(19.84,-24.675),(19.84,-24.845),(19.67,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-24.845),(20.18,-24.675),(20.35,-24.675),(20.35,-24.845),(20.18,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-24.845),(20.69,-24.675),(20.86,-24.675),(20.86,-24.845),(20.69,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-24.845),(21.2,-24.675),(21.37,-24.675),(21.37,-24.845),(21.2,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-24.845),(21.71,-24.675),(21.88,-24.675),(21.88,-24.845),(21.71,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-24.845),(22.22,-24.675),(22.39,-24.675),(22.39,-24.845),(22.22,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-24.845),(22.73,-24.675),(22.9,-24.675),(22.9,-24.845),(22.73,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-24.845),(23.24,-24.675),(23.41,-24.675),(23.41,-24.845),(23.24,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-24.845),(23.75,-24.675),(23.92,-24.675),(23.92,-24.845),(23.75,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-24.845),(24.26,-24.675),(24.43,-24.675),(24.43,-24.845),(24.26,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-24.845),(24.77,-24.675),(24.94,-24.675),(24.94,-24.845),(24.77,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-24.845),(25.28,-24.675),(25.45,-24.675),(25.45,-24.845),(25.28,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-24.845),(25.79,-24.675),(25.96,-24.675),(25.96,-24.845),(25.79,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-24.845),(26.3,-24.675),(26.47,-24.675),(26.47,-24.845),(26.3,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-24.845),(26.81,-24.675),(26.98,-24.675),(26.98,-24.845),(26.81,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-24.845),(27.32,-24.675),(27.49,-24.675),(27.49,-24.845),(27.32,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-24.845),(27.83,-24.675),(28.0,-24.675),(28.0,-24.845),(27.83,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-24.845),(28.34,-24.675),(28.51,-24.675),(28.51,-24.845),(28.34,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-24.845),(28.85,-24.675),(29.02,-24.675),(29.02,-24.845),(28.85,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-24.845),(29.36,-24.675),(29.53,-24.675),(29.53,-24.845),(29.36,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-24.845),(29.87,-24.675),(30.04,-24.675),(30.04,-24.845),(29.87,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-24.845),(30.38,-24.675),(30.55,-24.675),(30.55,-24.845),(30.38,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-24.845),(30.89,-24.675),(31.06,-24.675),(31.06,-24.845),(30.89,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-24.845),(31.4,-24.675),(31.57,-24.675),(31.57,-24.845),(31.4,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-24.845),(31.91,-24.675),(32.08,-24.675),(32.08,-24.845),(31.91,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-24.845),(32.42,-24.675),(32.59,-24.675),(32.59,-24.845),(32.42,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-24.845),(32.93,-24.675),(33.1,-24.675),(33.1,-24.845),(32.93,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-24.845),(33.44,-24.675),(33.61,-24.675),(33.61,-24.845),(33.44,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-24.845),(33.95,-24.675),(34.12,-24.675),(34.12,-24.845),(33.95,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-24.845),(34.46,-24.675),(34.63,-24.675),(34.63,-24.845),(34.46,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-24.845),(34.97,-24.675),(35.14,-24.675),(35.14,-24.845),(34.97,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-24.845),(35.48,-24.675),(35.65,-24.675),(35.65,-24.845),(35.48,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-24.845),(35.99,-24.675),(36.16,-24.675),(36.16,-24.845),(35.99,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-24.845),(36.5,-24.675),(36.67,-24.675),(36.67,-24.845),(36.5,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-24.845),(37.01,-24.675),(37.18,-24.675),(37.18,-24.845),(37.01,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-24.845),(37.52,-24.675),(37.69,-24.675),(37.69,-24.845),(37.52,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-24.845),(38.03,-24.675),(38.2,-24.675),(38.2,-24.845),(38.03,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-24.845),(38.54,-24.675),(38.71,-24.675),(38.71,-24.845),(38.54,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-24.845),(39.05,-24.675),(39.22,-24.675),(39.22,-24.845),(39.05,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-24.845),(39.56,-24.675),(39.73,-24.675),(39.73,-24.845),(39.56,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-24.845),(40.07,-24.675),(40.24,-24.675),(40.24,-24.845),(40.07,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-24.845),(40.58,-24.675),(40.75,-24.675),(40.75,-24.845),(40.58,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-24.845),(41.09,-24.675),(41.26,-24.675),(41.26,-24.845),(41.09,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-24.845),(41.6,-24.675),(41.77,-24.675),(41.77,-24.845),(41.6,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-24.845),(42.11,-24.675),(42.28,-24.675),(42.28,-24.845),(42.11,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-24.845),(42.62,-24.675),(42.79,-24.675),(42.79,-24.845),(42.62,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-24.845),(43.13,-24.675),(43.3,-24.675),(43.3,-24.845),(43.13,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-24.845),(43.64,-24.675),(43.81,-24.675),(43.81,-24.845),(43.64,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-24.845),(44.15,-24.675),(44.32,-24.675),(44.32,-24.845),(44.15,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-24.845),(44.66,-24.675),(44.83,-24.675),(44.83,-24.845),(44.66,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-24.845),(45.17,-24.675),(45.34,-24.675),(45.34,-24.845),(45.17,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-24.845),(45.68,-24.675),(45.85,-24.675),(45.85,-24.845),(45.68,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-24.845),(46.19,-24.675),(46.36,-24.675),(46.36,-24.845),(46.19,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-24.845),(46.7,-24.675),(46.87,-24.675),(46.87,-24.845),(46.7,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-24.845),(47.21,-24.675),(47.38,-24.675),(47.38,-24.845),(47.21,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-24.845),(47.72,-24.675),(47.89,-24.675),(47.89,-24.845),(47.72,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-24.845),(48.23,-24.675),(48.4,-24.675),(48.4,-24.845),(48.23,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-24.845),(48.74,-24.675),(48.91,-24.675),(48.91,-24.845),(48.74,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-24.845),(49.25,-24.675),(49.42,-24.675),(49.42,-24.845),(49.25,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-24.845),(49.76,-24.675),(49.93,-24.675),(49.93,-24.845),(49.76,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-24.845),(50.27,-24.675),(50.44,-24.675),(50.44,-24.845),(50.27,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-24.845),(50.78,-24.675),(50.95,-24.675),(50.95,-24.845),(50.78,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-24.845),(51.29,-24.675),(51.46,-24.675),(51.46,-24.845),(51.29,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-24.845),(51.8,-24.675),(51.97,-24.675),(51.97,-24.845),(51.8,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-24.845),(52.31,-24.675),(52.48,-24.675),(52.48,-24.845),(52.31,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-24.845),(52.82,-24.675),(52.99,-24.675),(52.99,-24.845),(52.82,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-24.845),(53.33,-24.675),(53.5,-24.675),(53.5,-24.845),(53.33,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-24.845),(53.84,-24.675),(54.01,-24.675),(54.01,-24.845),(53.84,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-24.845),(54.35,-24.675),(54.52,-24.675),(54.52,-24.845),(54.35,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-24.845),(54.86,-24.675),(55.03,-24.675),(55.03,-24.845),(54.86,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-24.845),(55.37,-24.675),(55.54,-24.675),(55.54,-24.845),(55.37,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-24.845),(55.88,-24.675),(56.05,-24.675),(56.05,-24.845),(55.88,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-24.845),(56.39,-24.675),(56.56,-24.675),(56.56,-24.845),(56.39,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-24.845),(56.9,-24.675),(57.07,-24.675),(57.07,-24.845),(56.9,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-24.845),(57.41,-24.675),(57.58,-24.675),(57.58,-24.845),(57.41,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-24.845),(57.92,-24.675),(58.09,-24.675),(58.09,-24.845),(57.92,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-24.845),(58.43,-24.675),(58.6,-24.675),(58.6,-24.845),(58.43,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-24.845),(58.94,-24.675),(59.11,-24.675),(59.11,-24.845),(58.94,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-24.845),(59.45,-24.675),(59.62,-24.675),(59.62,-24.845),(59.45,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-24.845),(59.96,-24.675),(60.13,-24.675),(60.13,-24.845),(59.96,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-24.845),(60.47,-24.675),(60.64,-24.675),(60.64,-24.845),(60.47,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-24.845),(60.98,-24.675),(61.15,-24.675),(61.15,-24.845),(60.98,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-24.845),(61.49,-24.675),(61.66,-24.675),(61.66,-24.845),(61.49,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-24.845),(62.0,-24.675),(62.17,-24.675),(62.17,-24.845),(62.0,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-24.845),(62.51,-24.675),(62.68,-24.675),(62.68,-24.845),(62.51,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-24.845),(63.02,-24.675),(63.19,-24.675),(63.19,-24.845),(63.02,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-24.845),(63.53,-24.675),(63.7,-24.675),(63.7,-24.845),(63.53,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-24.845),(64.04,-24.675),(64.21,-24.675),(64.21,-24.845),(64.04,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-24.845),(64.55,-24.675),(64.72,-24.675),(64.72,-24.845),(64.55,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-24.845),(65.06,-24.675),(65.23,-24.675),(65.23,-24.845),(65.06,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-24.845),(65.57,-24.675),(65.74,-24.675),(65.74,-24.845),(65.57,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-24.845),(66.08,-24.675),(66.25,-24.675),(66.25,-24.845),(66.08,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-24.845),(66.59,-24.675),(66.76,-24.675),(66.76,-24.845),(66.59,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-24.845),(67.1,-24.675),(67.27,-24.675),(67.27,-24.845),(67.1,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-24.845),(67.61,-24.675),(67.78,-24.675),(67.78,-24.845),(67.61,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-24.845),(68.12,-24.675),(68.29,-24.675),(68.29,-24.845),(68.12,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-24.845),(68.63,-24.675),(68.8,-24.675),(68.8,-24.845),(68.63,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-24.845),(69.14,-24.675),(69.31,-24.675),(69.31,-24.845),(69.14,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-24.845),(69.65,-24.675),(69.82,-24.675),(69.82,-24.845),(69.65,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-24.845),(70.16,-24.675),(70.33,-24.675),(70.33,-24.845),(70.16,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-24.845),(70.67,-24.675),(70.84,-24.675),(70.84,-24.845),(70.67,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-24.845),(71.18,-24.675),(71.35,-24.675),(71.35,-24.845),(71.18,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-24.845),(71.69,-24.675),(71.86,-24.675),(71.86,-24.845),(71.69,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-24.845),(72.2,-24.675),(72.37,-24.675),(72.37,-24.845),(72.2,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-24.845),(72.71,-24.675),(72.88,-24.675),(72.88,-24.845),(72.71,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-24.845),(73.22,-24.675),(73.39,-24.675),(73.39,-24.845),(73.22,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-24.845),(73.73,-24.675),(73.9,-24.675),(73.9,-24.845),(73.73,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-24.845),(74.24,-24.675),(74.41,-24.675),(74.41,-24.845),(74.24,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-24.845),(74.75,-24.675),(74.92,-24.675),(74.92,-24.845),(74.75,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-24.845),(75.26,-24.675),(75.43,-24.675),(75.43,-24.845),(75.26,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-24.845),(75.77,-24.675),(75.94,-24.675),(75.94,-24.845),(75.77,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-24.845),(76.28,-24.675),(76.45,-24.675),(76.45,-24.845),(76.28,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-24.845),(76.79,-24.675),(76.96,-24.675),(76.96,-24.845),(76.79,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-24.845),(77.3,-24.675),(77.47,-24.675),(77.47,-24.845),(77.3,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-24.845),(77.81,-24.675),(77.98,-24.675),(77.98,-24.845),(77.81,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-24.845),(78.32,-24.675),(78.49,-24.675),(78.49,-24.845),(78.32,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-24.845),(78.83,-24.675),(79.0,-24.675),(79.0,-24.845),(78.83,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-24.845),(79.34,-24.675),(79.51,-24.675),(79.51,-24.845),(79.34,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-24.845),(79.85,-24.675),(80.02,-24.675),(80.02,-24.845),(79.85,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-24.845),(80.36,-24.675),(80.53,-24.675),(80.53,-24.845),(80.36,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-24.845),(80.87,-24.675),(81.04,-24.675),(81.04,-24.845),(80.87,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-24.845),(81.38,-24.675),(81.55,-24.675),(81.55,-24.845),(81.38,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-24.845),(81.89,-24.675),(82.06,-24.675),(82.06,-24.845),(81.89,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-24.845),(82.4,-24.675),(82.57,-24.675),(82.57,-24.845),(82.4,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-24.845),(82.91,-24.675),(83.08,-24.675),(83.08,-24.845),(82.91,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-24.845),(83.42,-24.675),(83.59,-24.675),(83.59,-24.845),(83.42,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-24.845),(83.93,-24.675),(84.1,-24.675),(84.1,-24.845),(83.93,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-24.845),(84.44,-24.675),(84.61,-24.675),(84.61,-24.845),(84.44,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-24.845),(84.95,-24.675),(85.12,-24.675),(85.12,-24.845),(84.95,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-24.845),(85.46,-24.675),(85.63,-24.675),(85.63,-24.845),(85.46,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-24.845),(85.97,-24.675),(86.14,-24.675),(86.14,-24.845),(85.97,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-24.845),(86.48,-24.675),(86.65,-24.675),(86.65,-24.845),(86.48,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-24.845),(86.99,-24.675),(87.16,-24.675),(87.16,-24.845),(86.99,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-24.845),(87.5,-24.675),(87.67,-24.675),(87.67,-24.845),(87.5,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-24.845),(88.01,-24.675),(88.18,-24.675),(88.18,-24.845),(88.01,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-24.845),(88.52,-24.675),(88.69,-24.675),(88.69,-24.845),(88.52,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-24.845),(89.03,-24.675),(89.2,-24.675),(89.2,-24.845),(89.03,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-24.845),(89.54,-24.675),(89.71,-24.675),(89.71,-24.845),(89.54,-24.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-24.335),(0.29,-24.165),(0.46,-24.165),(0.46,-24.335),(0.29,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-24.335),(0.8,-24.165),(0.97,-24.165),(0.97,-24.335),(0.8,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-24.335),(1.31,-24.165),(1.48,-24.165),(1.48,-24.335),(1.31,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-24.335),(1.82,-24.165),(1.99,-24.165),(1.99,-24.335),(1.82,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-24.335),(2.33,-24.165),(2.5,-24.165),(2.5,-24.335),(2.33,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-24.335),(2.84,-24.165),(3.01,-24.165),(3.01,-24.335),(2.84,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-24.335),(3.35,-24.165),(3.52,-24.165),(3.52,-24.335),(3.35,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-24.335),(3.86,-24.165),(4.03,-24.165),(4.03,-24.335),(3.86,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-24.335),(4.37,-24.165),(4.54,-24.165),(4.54,-24.335),(4.37,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-24.335),(4.88,-24.165),(5.05,-24.165),(5.05,-24.335),(4.88,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-24.335),(5.39,-24.165),(5.56,-24.165),(5.56,-24.335),(5.39,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-24.335),(5.9,-24.165),(6.07,-24.165),(6.07,-24.335),(5.9,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-24.335),(6.41,-24.165),(6.58,-24.165),(6.58,-24.335),(6.41,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-24.335),(6.92,-24.165),(7.09,-24.165),(7.09,-24.335),(6.92,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-24.335),(7.43,-24.165),(7.6,-24.165),(7.6,-24.335),(7.43,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-24.335),(7.94,-24.165),(8.11,-24.165),(8.11,-24.335),(7.94,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-24.335),(8.45,-24.165),(8.62,-24.165),(8.62,-24.335),(8.45,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-24.335),(8.96,-24.165),(9.13,-24.165),(9.13,-24.335),(8.96,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-24.335),(9.47,-24.165),(9.64,-24.165),(9.64,-24.335),(9.47,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-24.335),(9.98,-24.165),(10.15,-24.165),(10.15,-24.335),(9.98,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-24.335),(10.49,-24.165),(10.66,-24.165),(10.66,-24.335),(10.49,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-24.335),(11.0,-24.165),(11.17,-24.165),(11.17,-24.335),(11.0,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-24.335),(11.51,-24.165),(11.68,-24.165),(11.68,-24.335),(11.51,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-24.335),(12.02,-24.165),(12.19,-24.165),(12.19,-24.335),(12.02,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-24.335),(12.53,-24.165),(12.7,-24.165),(12.7,-24.335),(12.53,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-24.335),(13.04,-24.165),(13.21,-24.165),(13.21,-24.335),(13.04,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-24.335),(13.55,-24.165),(13.72,-24.165),(13.72,-24.335),(13.55,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-24.335),(14.06,-24.165),(14.23,-24.165),(14.23,-24.335),(14.06,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-24.335),(14.57,-24.165),(14.74,-24.165),(14.74,-24.335),(14.57,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-24.335),(15.08,-24.165),(15.25,-24.165),(15.25,-24.335),(15.08,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-24.335),(15.59,-24.165),(15.76,-24.165),(15.76,-24.335),(15.59,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-24.335),(16.1,-24.165),(16.27,-24.165),(16.27,-24.335),(16.1,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-24.335),(16.61,-24.165),(16.78,-24.165),(16.78,-24.335),(16.61,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-24.335),(17.12,-24.165),(17.29,-24.165),(17.29,-24.335),(17.12,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-24.335),(17.63,-24.165),(17.8,-24.165),(17.8,-24.335),(17.63,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-24.335),(18.14,-24.165),(18.31,-24.165),(18.31,-24.335),(18.14,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-24.335),(18.65,-24.165),(18.82,-24.165),(18.82,-24.335),(18.65,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-24.335),(19.16,-24.165),(19.33,-24.165),(19.33,-24.335),(19.16,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-24.335),(19.67,-24.165),(19.84,-24.165),(19.84,-24.335),(19.67,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-24.335),(20.18,-24.165),(20.35,-24.165),(20.35,-24.335),(20.18,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-24.335),(20.69,-24.165),(20.86,-24.165),(20.86,-24.335),(20.69,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-24.335),(21.2,-24.165),(21.37,-24.165),(21.37,-24.335),(21.2,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-24.335),(21.71,-24.165),(21.88,-24.165),(21.88,-24.335),(21.71,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-24.335),(22.22,-24.165),(22.39,-24.165),(22.39,-24.335),(22.22,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-24.335),(22.73,-24.165),(22.9,-24.165),(22.9,-24.335),(22.73,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-24.335),(23.24,-24.165),(23.41,-24.165),(23.41,-24.335),(23.24,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-24.335),(23.75,-24.165),(23.92,-24.165),(23.92,-24.335),(23.75,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-24.335),(24.26,-24.165),(24.43,-24.165),(24.43,-24.335),(24.26,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-24.335),(24.77,-24.165),(24.94,-24.165),(24.94,-24.335),(24.77,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-24.335),(25.28,-24.165),(25.45,-24.165),(25.45,-24.335),(25.28,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-24.335),(25.79,-24.165),(25.96,-24.165),(25.96,-24.335),(25.79,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-24.335),(26.3,-24.165),(26.47,-24.165),(26.47,-24.335),(26.3,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-24.335),(26.81,-24.165),(26.98,-24.165),(26.98,-24.335),(26.81,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-24.335),(27.32,-24.165),(27.49,-24.165),(27.49,-24.335),(27.32,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-24.335),(27.83,-24.165),(28.0,-24.165),(28.0,-24.335),(27.83,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-24.335),(28.34,-24.165),(28.51,-24.165),(28.51,-24.335),(28.34,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-24.335),(28.85,-24.165),(29.02,-24.165),(29.02,-24.335),(28.85,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-24.335),(29.36,-24.165),(29.53,-24.165),(29.53,-24.335),(29.36,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-24.335),(29.87,-24.165),(30.04,-24.165),(30.04,-24.335),(29.87,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-24.335),(30.38,-24.165),(30.55,-24.165),(30.55,-24.335),(30.38,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-24.335),(30.89,-24.165),(31.06,-24.165),(31.06,-24.335),(30.89,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-24.335),(31.4,-24.165),(31.57,-24.165),(31.57,-24.335),(31.4,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-24.335),(31.91,-24.165),(32.08,-24.165),(32.08,-24.335),(31.91,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-24.335),(32.42,-24.165),(32.59,-24.165),(32.59,-24.335),(32.42,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-24.335),(32.93,-24.165),(33.1,-24.165),(33.1,-24.335),(32.93,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-24.335),(33.44,-24.165),(33.61,-24.165),(33.61,-24.335),(33.44,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-24.335),(33.95,-24.165),(34.12,-24.165),(34.12,-24.335),(33.95,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-24.335),(34.46,-24.165),(34.63,-24.165),(34.63,-24.335),(34.46,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-24.335),(34.97,-24.165),(35.14,-24.165),(35.14,-24.335),(34.97,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-24.335),(35.48,-24.165),(35.65,-24.165),(35.65,-24.335),(35.48,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-24.335),(35.99,-24.165),(36.16,-24.165),(36.16,-24.335),(35.99,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-24.335),(36.5,-24.165),(36.67,-24.165),(36.67,-24.335),(36.5,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-24.335),(37.01,-24.165),(37.18,-24.165),(37.18,-24.335),(37.01,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-24.335),(37.52,-24.165),(37.69,-24.165),(37.69,-24.335),(37.52,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-24.335),(38.03,-24.165),(38.2,-24.165),(38.2,-24.335),(38.03,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-24.335),(38.54,-24.165),(38.71,-24.165),(38.71,-24.335),(38.54,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-24.335),(39.05,-24.165),(39.22,-24.165),(39.22,-24.335),(39.05,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-24.335),(39.56,-24.165),(39.73,-24.165),(39.73,-24.335),(39.56,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-24.335),(40.07,-24.165),(40.24,-24.165),(40.24,-24.335),(40.07,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-24.335),(40.58,-24.165),(40.75,-24.165),(40.75,-24.335),(40.58,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-24.335),(41.09,-24.165),(41.26,-24.165),(41.26,-24.335),(41.09,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-24.335),(41.6,-24.165),(41.77,-24.165),(41.77,-24.335),(41.6,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-24.335),(42.11,-24.165),(42.28,-24.165),(42.28,-24.335),(42.11,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-24.335),(42.62,-24.165),(42.79,-24.165),(42.79,-24.335),(42.62,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-24.335),(43.13,-24.165),(43.3,-24.165),(43.3,-24.335),(43.13,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-24.335),(43.64,-24.165),(43.81,-24.165),(43.81,-24.335),(43.64,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-24.335),(44.15,-24.165),(44.32,-24.165),(44.32,-24.335),(44.15,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-24.335),(44.66,-24.165),(44.83,-24.165),(44.83,-24.335),(44.66,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-24.335),(45.17,-24.165),(45.34,-24.165),(45.34,-24.335),(45.17,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-24.335),(45.68,-24.165),(45.85,-24.165),(45.85,-24.335),(45.68,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-24.335),(46.19,-24.165),(46.36,-24.165),(46.36,-24.335),(46.19,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-24.335),(46.7,-24.165),(46.87,-24.165),(46.87,-24.335),(46.7,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-24.335),(47.21,-24.165),(47.38,-24.165),(47.38,-24.335),(47.21,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-24.335),(47.72,-24.165),(47.89,-24.165),(47.89,-24.335),(47.72,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-24.335),(48.23,-24.165),(48.4,-24.165),(48.4,-24.335),(48.23,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-24.335),(48.74,-24.165),(48.91,-24.165),(48.91,-24.335),(48.74,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-24.335),(49.25,-24.165),(49.42,-24.165),(49.42,-24.335),(49.25,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-24.335),(49.76,-24.165),(49.93,-24.165),(49.93,-24.335),(49.76,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-24.335),(50.27,-24.165),(50.44,-24.165),(50.44,-24.335),(50.27,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-24.335),(50.78,-24.165),(50.95,-24.165),(50.95,-24.335),(50.78,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-24.335),(51.29,-24.165),(51.46,-24.165),(51.46,-24.335),(51.29,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-24.335),(51.8,-24.165),(51.97,-24.165),(51.97,-24.335),(51.8,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-24.335),(52.31,-24.165),(52.48,-24.165),(52.48,-24.335),(52.31,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-24.335),(52.82,-24.165),(52.99,-24.165),(52.99,-24.335),(52.82,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-24.335),(53.33,-24.165),(53.5,-24.165),(53.5,-24.335),(53.33,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-24.335),(53.84,-24.165),(54.01,-24.165),(54.01,-24.335),(53.84,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-24.335),(54.35,-24.165),(54.52,-24.165),(54.52,-24.335),(54.35,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-24.335),(54.86,-24.165),(55.03,-24.165),(55.03,-24.335),(54.86,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-24.335),(55.37,-24.165),(55.54,-24.165),(55.54,-24.335),(55.37,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-24.335),(55.88,-24.165),(56.05,-24.165),(56.05,-24.335),(55.88,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-24.335),(56.39,-24.165),(56.56,-24.165),(56.56,-24.335),(56.39,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-24.335),(56.9,-24.165),(57.07,-24.165),(57.07,-24.335),(56.9,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-24.335),(57.41,-24.165),(57.58,-24.165),(57.58,-24.335),(57.41,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-24.335),(57.92,-24.165),(58.09,-24.165),(58.09,-24.335),(57.92,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-24.335),(58.43,-24.165),(58.6,-24.165),(58.6,-24.335),(58.43,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-24.335),(58.94,-24.165),(59.11,-24.165),(59.11,-24.335),(58.94,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-24.335),(59.45,-24.165),(59.62,-24.165),(59.62,-24.335),(59.45,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-24.335),(59.96,-24.165),(60.13,-24.165),(60.13,-24.335),(59.96,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-24.335),(60.47,-24.165),(60.64,-24.165),(60.64,-24.335),(60.47,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-24.335),(60.98,-24.165),(61.15,-24.165),(61.15,-24.335),(60.98,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-24.335),(61.49,-24.165),(61.66,-24.165),(61.66,-24.335),(61.49,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-24.335),(62.0,-24.165),(62.17,-24.165),(62.17,-24.335),(62.0,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-24.335),(62.51,-24.165),(62.68,-24.165),(62.68,-24.335),(62.51,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-24.335),(63.02,-24.165),(63.19,-24.165),(63.19,-24.335),(63.02,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-24.335),(63.53,-24.165),(63.7,-24.165),(63.7,-24.335),(63.53,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-24.335),(64.04,-24.165),(64.21,-24.165),(64.21,-24.335),(64.04,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-24.335),(64.55,-24.165),(64.72,-24.165),(64.72,-24.335),(64.55,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-24.335),(65.06,-24.165),(65.23,-24.165),(65.23,-24.335),(65.06,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-24.335),(65.57,-24.165),(65.74,-24.165),(65.74,-24.335),(65.57,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-24.335),(66.08,-24.165),(66.25,-24.165),(66.25,-24.335),(66.08,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-24.335),(66.59,-24.165),(66.76,-24.165),(66.76,-24.335),(66.59,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-24.335),(67.1,-24.165),(67.27,-24.165),(67.27,-24.335),(67.1,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-24.335),(67.61,-24.165),(67.78,-24.165),(67.78,-24.335),(67.61,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-24.335),(68.12,-24.165),(68.29,-24.165),(68.29,-24.335),(68.12,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-24.335),(68.63,-24.165),(68.8,-24.165),(68.8,-24.335),(68.63,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-24.335),(69.14,-24.165),(69.31,-24.165),(69.31,-24.335),(69.14,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-24.335),(69.65,-24.165),(69.82,-24.165),(69.82,-24.335),(69.65,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-24.335),(70.16,-24.165),(70.33,-24.165),(70.33,-24.335),(70.16,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-24.335),(70.67,-24.165),(70.84,-24.165),(70.84,-24.335),(70.67,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-24.335),(71.18,-24.165),(71.35,-24.165),(71.35,-24.335),(71.18,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-24.335),(71.69,-24.165),(71.86,-24.165),(71.86,-24.335),(71.69,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-24.335),(72.2,-24.165),(72.37,-24.165),(72.37,-24.335),(72.2,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-24.335),(72.71,-24.165),(72.88,-24.165),(72.88,-24.335),(72.71,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-24.335),(73.22,-24.165),(73.39,-24.165),(73.39,-24.335),(73.22,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-24.335),(73.73,-24.165),(73.9,-24.165),(73.9,-24.335),(73.73,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-24.335),(74.24,-24.165),(74.41,-24.165),(74.41,-24.335),(74.24,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-24.335),(74.75,-24.165),(74.92,-24.165),(74.92,-24.335),(74.75,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-24.335),(75.26,-24.165),(75.43,-24.165),(75.43,-24.335),(75.26,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-24.335),(75.77,-24.165),(75.94,-24.165),(75.94,-24.335),(75.77,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-24.335),(76.28,-24.165),(76.45,-24.165),(76.45,-24.335),(76.28,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-24.335),(76.79,-24.165),(76.96,-24.165),(76.96,-24.335),(76.79,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-24.335),(77.3,-24.165),(77.47,-24.165),(77.47,-24.335),(77.3,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-24.335),(77.81,-24.165),(77.98,-24.165),(77.98,-24.335),(77.81,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-24.335),(78.32,-24.165),(78.49,-24.165),(78.49,-24.335),(78.32,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-24.335),(78.83,-24.165),(79.0,-24.165),(79.0,-24.335),(78.83,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-24.335),(79.34,-24.165),(79.51,-24.165),(79.51,-24.335),(79.34,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-24.335),(79.85,-24.165),(80.02,-24.165),(80.02,-24.335),(79.85,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-24.335),(80.36,-24.165),(80.53,-24.165),(80.53,-24.335),(80.36,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-24.335),(80.87,-24.165),(81.04,-24.165),(81.04,-24.335),(80.87,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-24.335),(81.38,-24.165),(81.55,-24.165),(81.55,-24.335),(81.38,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-24.335),(81.89,-24.165),(82.06,-24.165),(82.06,-24.335),(81.89,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-24.335),(82.4,-24.165),(82.57,-24.165),(82.57,-24.335),(82.4,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-24.335),(82.91,-24.165),(83.08,-24.165),(83.08,-24.335),(82.91,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-24.335),(83.42,-24.165),(83.59,-24.165),(83.59,-24.335),(83.42,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-24.335),(83.93,-24.165),(84.1,-24.165),(84.1,-24.335),(83.93,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-24.335),(84.44,-24.165),(84.61,-24.165),(84.61,-24.335),(84.44,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-24.335),(84.95,-24.165),(85.12,-24.165),(85.12,-24.335),(84.95,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-24.335),(85.46,-24.165),(85.63,-24.165),(85.63,-24.335),(85.46,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-24.335),(85.97,-24.165),(86.14,-24.165),(86.14,-24.335),(85.97,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-24.335),(86.48,-24.165),(86.65,-24.165),(86.65,-24.335),(86.48,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-24.335),(86.99,-24.165),(87.16,-24.165),(87.16,-24.335),(86.99,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-24.335),(87.5,-24.165),(87.67,-24.165),(87.67,-24.335),(87.5,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-24.335),(88.01,-24.165),(88.18,-24.165),(88.18,-24.335),(88.01,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-24.335),(88.52,-24.165),(88.69,-24.165),(88.69,-24.335),(88.52,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-24.335),(89.03,-24.165),(89.2,-24.165),(89.2,-24.335),(89.03,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-24.335),(89.54,-24.165),(89.71,-24.165),(89.71,-24.335),(89.54,-24.335)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-23.825),(0.29,-23.655),(0.46,-23.655),(0.46,-23.825),(0.29,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-23.825),(0.8,-23.655),(0.97,-23.655),(0.97,-23.825),(0.8,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-23.825),(1.31,-23.655),(1.48,-23.655),(1.48,-23.825),(1.31,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-23.825),(1.82,-23.655),(1.99,-23.655),(1.99,-23.825),(1.82,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-23.825),(2.33,-23.655),(2.5,-23.655),(2.5,-23.825),(2.33,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-23.825),(2.84,-23.655),(3.01,-23.655),(3.01,-23.825),(2.84,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-23.825),(3.35,-23.655),(3.52,-23.655),(3.52,-23.825),(3.35,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-23.825),(3.86,-23.655),(4.03,-23.655),(4.03,-23.825),(3.86,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-23.825),(4.37,-23.655),(4.54,-23.655),(4.54,-23.825),(4.37,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-23.825),(4.88,-23.655),(5.05,-23.655),(5.05,-23.825),(4.88,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-23.825),(5.39,-23.655),(5.56,-23.655),(5.56,-23.825),(5.39,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-23.825),(5.9,-23.655),(6.07,-23.655),(6.07,-23.825),(5.9,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-23.825),(6.41,-23.655),(6.58,-23.655),(6.58,-23.825),(6.41,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-23.825),(6.92,-23.655),(7.09,-23.655),(7.09,-23.825),(6.92,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-23.825),(7.43,-23.655),(7.6,-23.655),(7.6,-23.825),(7.43,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-23.825),(7.94,-23.655),(8.11,-23.655),(8.11,-23.825),(7.94,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-23.825),(8.45,-23.655),(8.62,-23.655),(8.62,-23.825),(8.45,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-23.825),(8.96,-23.655),(9.13,-23.655),(9.13,-23.825),(8.96,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-23.825),(9.47,-23.655),(9.64,-23.655),(9.64,-23.825),(9.47,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-23.825),(9.98,-23.655),(10.15,-23.655),(10.15,-23.825),(9.98,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-23.825),(10.49,-23.655),(10.66,-23.655),(10.66,-23.825),(10.49,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-23.825),(11.0,-23.655),(11.17,-23.655),(11.17,-23.825),(11.0,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-23.825),(11.51,-23.655),(11.68,-23.655),(11.68,-23.825),(11.51,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-23.825),(12.02,-23.655),(12.19,-23.655),(12.19,-23.825),(12.02,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-23.825),(12.53,-23.655),(12.7,-23.655),(12.7,-23.825),(12.53,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-23.825),(13.04,-23.655),(13.21,-23.655),(13.21,-23.825),(13.04,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-23.825),(13.55,-23.655),(13.72,-23.655),(13.72,-23.825),(13.55,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-23.825),(14.06,-23.655),(14.23,-23.655),(14.23,-23.825),(14.06,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-23.825),(14.57,-23.655),(14.74,-23.655),(14.74,-23.825),(14.57,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-23.825),(15.08,-23.655),(15.25,-23.655),(15.25,-23.825),(15.08,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-23.825),(15.59,-23.655),(15.76,-23.655),(15.76,-23.825),(15.59,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-23.825),(16.1,-23.655),(16.27,-23.655),(16.27,-23.825),(16.1,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-23.825),(16.61,-23.655),(16.78,-23.655),(16.78,-23.825),(16.61,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-23.825),(17.12,-23.655),(17.29,-23.655),(17.29,-23.825),(17.12,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-23.825),(17.63,-23.655),(17.8,-23.655),(17.8,-23.825),(17.63,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-23.825),(18.14,-23.655),(18.31,-23.655),(18.31,-23.825),(18.14,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-23.825),(18.65,-23.655),(18.82,-23.655),(18.82,-23.825),(18.65,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-23.825),(19.16,-23.655),(19.33,-23.655),(19.33,-23.825),(19.16,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-23.825),(19.67,-23.655),(19.84,-23.655),(19.84,-23.825),(19.67,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-23.825),(20.18,-23.655),(20.35,-23.655),(20.35,-23.825),(20.18,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-23.825),(20.69,-23.655),(20.86,-23.655),(20.86,-23.825),(20.69,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-23.825),(21.2,-23.655),(21.37,-23.655),(21.37,-23.825),(21.2,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-23.825),(21.71,-23.655),(21.88,-23.655),(21.88,-23.825),(21.71,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-23.825),(22.22,-23.655),(22.39,-23.655),(22.39,-23.825),(22.22,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-23.825),(22.73,-23.655),(22.9,-23.655),(22.9,-23.825),(22.73,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-23.825),(23.24,-23.655),(23.41,-23.655),(23.41,-23.825),(23.24,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-23.825),(23.75,-23.655),(23.92,-23.655),(23.92,-23.825),(23.75,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-23.825),(24.26,-23.655),(24.43,-23.655),(24.43,-23.825),(24.26,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-23.825),(24.77,-23.655),(24.94,-23.655),(24.94,-23.825),(24.77,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-23.825),(25.28,-23.655),(25.45,-23.655),(25.45,-23.825),(25.28,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-23.825),(25.79,-23.655),(25.96,-23.655),(25.96,-23.825),(25.79,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-23.825),(26.3,-23.655),(26.47,-23.655),(26.47,-23.825),(26.3,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-23.825),(26.81,-23.655),(26.98,-23.655),(26.98,-23.825),(26.81,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-23.825),(27.32,-23.655),(27.49,-23.655),(27.49,-23.825),(27.32,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-23.825),(27.83,-23.655),(28.0,-23.655),(28.0,-23.825),(27.83,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-23.825),(28.34,-23.655),(28.51,-23.655),(28.51,-23.825),(28.34,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-23.825),(28.85,-23.655),(29.02,-23.655),(29.02,-23.825),(28.85,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-23.825),(29.36,-23.655),(29.53,-23.655),(29.53,-23.825),(29.36,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-23.825),(29.87,-23.655),(30.04,-23.655),(30.04,-23.825),(29.87,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-23.825),(30.38,-23.655),(30.55,-23.655),(30.55,-23.825),(30.38,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-23.825),(30.89,-23.655),(31.06,-23.655),(31.06,-23.825),(30.89,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-23.825),(31.4,-23.655),(31.57,-23.655),(31.57,-23.825),(31.4,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-23.825),(31.91,-23.655),(32.08,-23.655),(32.08,-23.825),(31.91,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-23.825),(32.42,-23.655),(32.59,-23.655),(32.59,-23.825),(32.42,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-23.825),(32.93,-23.655),(33.1,-23.655),(33.1,-23.825),(32.93,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-23.825),(33.44,-23.655),(33.61,-23.655),(33.61,-23.825),(33.44,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-23.825),(33.95,-23.655),(34.12,-23.655),(34.12,-23.825),(33.95,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-23.825),(34.46,-23.655),(34.63,-23.655),(34.63,-23.825),(34.46,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-23.825),(34.97,-23.655),(35.14,-23.655),(35.14,-23.825),(34.97,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-23.825),(35.48,-23.655),(35.65,-23.655),(35.65,-23.825),(35.48,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-23.825),(35.99,-23.655),(36.16,-23.655),(36.16,-23.825),(35.99,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-23.825),(36.5,-23.655),(36.67,-23.655),(36.67,-23.825),(36.5,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-23.825),(37.01,-23.655),(37.18,-23.655),(37.18,-23.825),(37.01,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-23.825),(37.52,-23.655),(37.69,-23.655),(37.69,-23.825),(37.52,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-23.825),(38.03,-23.655),(38.2,-23.655),(38.2,-23.825),(38.03,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-23.825),(38.54,-23.655),(38.71,-23.655),(38.71,-23.825),(38.54,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-23.825),(39.05,-23.655),(39.22,-23.655),(39.22,-23.825),(39.05,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-23.825),(39.56,-23.655),(39.73,-23.655),(39.73,-23.825),(39.56,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-23.825),(40.07,-23.655),(40.24,-23.655),(40.24,-23.825),(40.07,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-23.825),(40.58,-23.655),(40.75,-23.655),(40.75,-23.825),(40.58,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-23.825),(41.09,-23.655),(41.26,-23.655),(41.26,-23.825),(41.09,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-23.825),(41.6,-23.655),(41.77,-23.655),(41.77,-23.825),(41.6,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-23.825),(42.11,-23.655),(42.28,-23.655),(42.28,-23.825),(42.11,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-23.825),(42.62,-23.655),(42.79,-23.655),(42.79,-23.825),(42.62,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-23.825),(43.13,-23.655),(43.3,-23.655),(43.3,-23.825),(43.13,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-23.825),(43.64,-23.655),(43.81,-23.655),(43.81,-23.825),(43.64,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-23.825),(44.15,-23.655),(44.32,-23.655),(44.32,-23.825),(44.15,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-23.825),(44.66,-23.655),(44.83,-23.655),(44.83,-23.825),(44.66,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-23.825),(45.17,-23.655),(45.34,-23.655),(45.34,-23.825),(45.17,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-23.825),(45.68,-23.655),(45.85,-23.655),(45.85,-23.825),(45.68,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-23.825),(46.19,-23.655),(46.36,-23.655),(46.36,-23.825),(46.19,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-23.825),(46.7,-23.655),(46.87,-23.655),(46.87,-23.825),(46.7,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-23.825),(47.21,-23.655),(47.38,-23.655),(47.38,-23.825),(47.21,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-23.825),(47.72,-23.655),(47.89,-23.655),(47.89,-23.825),(47.72,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-23.825),(48.23,-23.655),(48.4,-23.655),(48.4,-23.825),(48.23,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-23.825),(48.74,-23.655),(48.91,-23.655),(48.91,-23.825),(48.74,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-23.825),(49.25,-23.655),(49.42,-23.655),(49.42,-23.825),(49.25,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-23.825),(49.76,-23.655),(49.93,-23.655),(49.93,-23.825),(49.76,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-23.825),(50.27,-23.655),(50.44,-23.655),(50.44,-23.825),(50.27,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-23.825),(50.78,-23.655),(50.95,-23.655),(50.95,-23.825),(50.78,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-23.825),(51.29,-23.655),(51.46,-23.655),(51.46,-23.825),(51.29,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-23.825),(51.8,-23.655),(51.97,-23.655),(51.97,-23.825),(51.8,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-23.825),(52.31,-23.655),(52.48,-23.655),(52.48,-23.825),(52.31,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-23.825),(52.82,-23.655),(52.99,-23.655),(52.99,-23.825),(52.82,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-23.825),(53.33,-23.655),(53.5,-23.655),(53.5,-23.825),(53.33,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-23.825),(53.84,-23.655),(54.01,-23.655),(54.01,-23.825),(53.84,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-23.825),(54.35,-23.655),(54.52,-23.655),(54.52,-23.825),(54.35,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-23.825),(54.86,-23.655),(55.03,-23.655),(55.03,-23.825),(54.86,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-23.825),(55.37,-23.655),(55.54,-23.655),(55.54,-23.825),(55.37,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-23.825),(55.88,-23.655),(56.05,-23.655),(56.05,-23.825),(55.88,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-23.825),(56.39,-23.655),(56.56,-23.655),(56.56,-23.825),(56.39,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-23.825),(56.9,-23.655),(57.07,-23.655),(57.07,-23.825),(56.9,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-23.825),(57.41,-23.655),(57.58,-23.655),(57.58,-23.825),(57.41,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-23.825),(57.92,-23.655),(58.09,-23.655),(58.09,-23.825),(57.92,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-23.825),(58.43,-23.655),(58.6,-23.655),(58.6,-23.825),(58.43,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-23.825),(58.94,-23.655),(59.11,-23.655),(59.11,-23.825),(58.94,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-23.825),(59.45,-23.655),(59.62,-23.655),(59.62,-23.825),(59.45,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-23.825),(59.96,-23.655),(60.13,-23.655),(60.13,-23.825),(59.96,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-23.825),(60.47,-23.655),(60.64,-23.655),(60.64,-23.825),(60.47,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-23.825),(60.98,-23.655),(61.15,-23.655),(61.15,-23.825),(60.98,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-23.825),(61.49,-23.655),(61.66,-23.655),(61.66,-23.825),(61.49,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-23.825),(62.0,-23.655),(62.17,-23.655),(62.17,-23.825),(62.0,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-23.825),(62.51,-23.655),(62.68,-23.655),(62.68,-23.825),(62.51,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-23.825),(63.02,-23.655),(63.19,-23.655),(63.19,-23.825),(63.02,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-23.825),(63.53,-23.655),(63.7,-23.655),(63.7,-23.825),(63.53,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-23.825),(64.04,-23.655),(64.21,-23.655),(64.21,-23.825),(64.04,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-23.825),(64.55,-23.655),(64.72,-23.655),(64.72,-23.825),(64.55,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-23.825),(65.06,-23.655),(65.23,-23.655),(65.23,-23.825),(65.06,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-23.825),(65.57,-23.655),(65.74,-23.655),(65.74,-23.825),(65.57,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-23.825),(66.08,-23.655),(66.25,-23.655),(66.25,-23.825),(66.08,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-23.825),(66.59,-23.655),(66.76,-23.655),(66.76,-23.825),(66.59,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-23.825),(67.1,-23.655),(67.27,-23.655),(67.27,-23.825),(67.1,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-23.825),(67.61,-23.655),(67.78,-23.655),(67.78,-23.825),(67.61,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-23.825),(68.12,-23.655),(68.29,-23.655),(68.29,-23.825),(68.12,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-23.825),(68.63,-23.655),(68.8,-23.655),(68.8,-23.825),(68.63,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-23.825),(69.14,-23.655),(69.31,-23.655),(69.31,-23.825),(69.14,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-23.825),(69.65,-23.655),(69.82,-23.655),(69.82,-23.825),(69.65,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-23.825),(70.16,-23.655),(70.33,-23.655),(70.33,-23.825),(70.16,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-23.825),(70.67,-23.655),(70.84,-23.655),(70.84,-23.825),(70.67,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-23.825),(71.18,-23.655),(71.35,-23.655),(71.35,-23.825),(71.18,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-23.825),(71.69,-23.655),(71.86,-23.655),(71.86,-23.825),(71.69,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-23.825),(72.2,-23.655),(72.37,-23.655),(72.37,-23.825),(72.2,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-23.825),(72.71,-23.655),(72.88,-23.655),(72.88,-23.825),(72.71,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-23.825),(73.22,-23.655),(73.39,-23.655),(73.39,-23.825),(73.22,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-23.825),(73.73,-23.655),(73.9,-23.655),(73.9,-23.825),(73.73,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-23.825),(74.24,-23.655),(74.41,-23.655),(74.41,-23.825),(74.24,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-23.825),(74.75,-23.655),(74.92,-23.655),(74.92,-23.825),(74.75,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-23.825),(75.26,-23.655),(75.43,-23.655),(75.43,-23.825),(75.26,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-23.825),(75.77,-23.655),(75.94,-23.655),(75.94,-23.825),(75.77,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-23.825),(76.28,-23.655),(76.45,-23.655),(76.45,-23.825),(76.28,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-23.825),(76.79,-23.655),(76.96,-23.655),(76.96,-23.825),(76.79,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-23.825),(77.3,-23.655),(77.47,-23.655),(77.47,-23.825),(77.3,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-23.825),(77.81,-23.655),(77.98,-23.655),(77.98,-23.825),(77.81,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-23.825),(78.32,-23.655),(78.49,-23.655),(78.49,-23.825),(78.32,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-23.825),(78.83,-23.655),(79.0,-23.655),(79.0,-23.825),(78.83,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-23.825),(79.34,-23.655),(79.51,-23.655),(79.51,-23.825),(79.34,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-23.825),(79.85,-23.655),(80.02,-23.655),(80.02,-23.825),(79.85,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-23.825),(80.36,-23.655),(80.53,-23.655),(80.53,-23.825),(80.36,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-23.825),(80.87,-23.655),(81.04,-23.655),(81.04,-23.825),(80.87,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-23.825),(81.38,-23.655),(81.55,-23.655),(81.55,-23.825),(81.38,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-23.825),(81.89,-23.655),(82.06,-23.655),(82.06,-23.825),(81.89,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-23.825),(82.4,-23.655),(82.57,-23.655),(82.57,-23.825),(82.4,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-23.825),(82.91,-23.655),(83.08,-23.655),(83.08,-23.825),(82.91,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-23.825),(83.42,-23.655),(83.59,-23.655),(83.59,-23.825),(83.42,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-23.825),(83.93,-23.655),(84.1,-23.655),(84.1,-23.825),(83.93,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-23.825),(84.44,-23.655),(84.61,-23.655),(84.61,-23.825),(84.44,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-23.825),(84.95,-23.655),(85.12,-23.655),(85.12,-23.825),(84.95,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-23.825),(85.46,-23.655),(85.63,-23.655),(85.63,-23.825),(85.46,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-23.825),(85.97,-23.655),(86.14,-23.655),(86.14,-23.825),(85.97,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-23.825),(86.48,-23.655),(86.65,-23.655),(86.65,-23.825),(86.48,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-23.825),(86.99,-23.655),(87.16,-23.655),(87.16,-23.825),(86.99,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-23.825),(87.5,-23.655),(87.67,-23.655),(87.67,-23.825),(87.5,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-23.825),(88.01,-23.655),(88.18,-23.655),(88.18,-23.825),(88.01,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-23.825),(88.52,-23.655),(88.69,-23.655),(88.69,-23.825),(88.52,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-23.825),(89.03,-23.655),(89.2,-23.655),(89.2,-23.825),(89.03,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-23.825),(89.54,-23.655),(89.71,-23.655),(89.71,-23.825),(89.54,-23.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-23.315),(0.29,-23.145),(0.46,-23.145),(0.46,-23.315),(0.29,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-23.315),(0.8,-23.145),(0.97,-23.145),(0.97,-23.315),(0.8,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-23.315),(1.31,-23.145),(1.48,-23.145),(1.48,-23.315),(1.31,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-23.315),(1.82,-23.145),(1.99,-23.145),(1.99,-23.315),(1.82,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-23.315),(2.33,-23.145),(2.5,-23.145),(2.5,-23.315),(2.33,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-23.315),(2.84,-23.145),(3.01,-23.145),(3.01,-23.315),(2.84,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-23.315),(3.35,-23.145),(3.52,-23.145),(3.52,-23.315),(3.35,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-23.315),(3.86,-23.145),(4.03,-23.145),(4.03,-23.315),(3.86,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-23.315),(4.37,-23.145),(4.54,-23.145),(4.54,-23.315),(4.37,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-23.315),(4.88,-23.145),(5.05,-23.145),(5.05,-23.315),(4.88,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-23.315),(5.39,-23.145),(5.56,-23.145),(5.56,-23.315),(5.39,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-23.315),(5.9,-23.145),(6.07,-23.145),(6.07,-23.315),(5.9,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-23.315),(6.41,-23.145),(6.58,-23.145),(6.58,-23.315),(6.41,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-23.315),(6.92,-23.145),(7.09,-23.145),(7.09,-23.315),(6.92,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-23.315),(7.43,-23.145),(7.6,-23.145),(7.6,-23.315),(7.43,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-23.315),(7.94,-23.145),(8.11,-23.145),(8.11,-23.315),(7.94,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-23.315),(8.45,-23.145),(8.62,-23.145),(8.62,-23.315),(8.45,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-23.315),(8.96,-23.145),(9.13,-23.145),(9.13,-23.315),(8.96,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-23.315),(9.47,-23.145),(9.64,-23.145),(9.64,-23.315),(9.47,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-23.315),(9.98,-23.145),(10.15,-23.145),(10.15,-23.315),(9.98,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-23.315),(10.49,-23.145),(10.66,-23.145),(10.66,-23.315),(10.49,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-23.315),(11.0,-23.145),(11.17,-23.145),(11.17,-23.315),(11.0,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-23.315),(11.51,-23.145),(11.68,-23.145),(11.68,-23.315),(11.51,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-23.315),(12.02,-23.145),(12.19,-23.145),(12.19,-23.315),(12.02,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-23.315),(12.53,-23.145),(12.7,-23.145),(12.7,-23.315),(12.53,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-23.315),(13.04,-23.145),(13.21,-23.145),(13.21,-23.315),(13.04,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-23.315),(13.55,-23.145),(13.72,-23.145),(13.72,-23.315),(13.55,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-23.315),(14.06,-23.145),(14.23,-23.145),(14.23,-23.315),(14.06,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-23.315),(14.57,-23.145),(14.74,-23.145),(14.74,-23.315),(14.57,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-23.315),(15.08,-23.145),(15.25,-23.145),(15.25,-23.315),(15.08,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-23.315),(15.59,-23.145),(15.76,-23.145),(15.76,-23.315),(15.59,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-23.315),(16.1,-23.145),(16.27,-23.145),(16.27,-23.315),(16.1,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-23.315),(16.61,-23.145),(16.78,-23.145),(16.78,-23.315),(16.61,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-23.315),(17.12,-23.145),(17.29,-23.145),(17.29,-23.315),(17.12,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-23.315),(17.63,-23.145),(17.8,-23.145),(17.8,-23.315),(17.63,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-23.315),(18.14,-23.145),(18.31,-23.145),(18.31,-23.315),(18.14,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-23.315),(18.65,-23.145),(18.82,-23.145),(18.82,-23.315),(18.65,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-23.315),(19.16,-23.145),(19.33,-23.145),(19.33,-23.315),(19.16,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-23.315),(19.67,-23.145),(19.84,-23.145),(19.84,-23.315),(19.67,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-23.315),(20.18,-23.145),(20.35,-23.145),(20.35,-23.315),(20.18,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-23.315),(20.69,-23.145),(20.86,-23.145),(20.86,-23.315),(20.69,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-23.315),(21.2,-23.145),(21.37,-23.145),(21.37,-23.315),(21.2,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-23.315),(21.71,-23.145),(21.88,-23.145),(21.88,-23.315),(21.71,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-23.315),(22.22,-23.145),(22.39,-23.145),(22.39,-23.315),(22.22,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-23.315),(22.73,-23.145),(22.9,-23.145),(22.9,-23.315),(22.73,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-23.315),(23.24,-23.145),(23.41,-23.145),(23.41,-23.315),(23.24,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-23.315),(23.75,-23.145),(23.92,-23.145),(23.92,-23.315),(23.75,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-23.315),(24.26,-23.145),(24.43,-23.145),(24.43,-23.315),(24.26,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-23.315),(24.77,-23.145),(24.94,-23.145),(24.94,-23.315),(24.77,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-23.315),(25.28,-23.145),(25.45,-23.145),(25.45,-23.315),(25.28,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-23.315),(25.79,-23.145),(25.96,-23.145),(25.96,-23.315),(25.79,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-23.315),(26.3,-23.145),(26.47,-23.145),(26.47,-23.315),(26.3,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-23.315),(26.81,-23.145),(26.98,-23.145),(26.98,-23.315),(26.81,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-23.315),(27.32,-23.145),(27.49,-23.145),(27.49,-23.315),(27.32,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-23.315),(27.83,-23.145),(28.0,-23.145),(28.0,-23.315),(27.83,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-23.315),(28.34,-23.145),(28.51,-23.145),(28.51,-23.315),(28.34,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-23.315),(28.85,-23.145),(29.02,-23.145),(29.02,-23.315),(28.85,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-23.315),(29.36,-23.145),(29.53,-23.145),(29.53,-23.315),(29.36,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-23.315),(29.87,-23.145),(30.04,-23.145),(30.04,-23.315),(29.87,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-23.315),(30.38,-23.145),(30.55,-23.145),(30.55,-23.315),(30.38,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-23.315),(30.89,-23.145),(31.06,-23.145),(31.06,-23.315),(30.89,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-23.315),(31.4,-23.145),(31.57,-23.145),(31.57,-23.315),(31.4,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-23.315),(31.91,-23.145),(32.08,-23.145),(32.08,-23.315),(31.91,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-23.315),(32.42,-23.145),(32.59,-23.145),(32.59,-23.315),(32.42,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-23.315),(32.93,-23.145),(33.1,-23.145),(33.1,-23.315),(32.93,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-23.315),(33.44,-23.145),(33.61,-23.145),(33.61,-23.315),(33.44,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-23.315),(33.95,-23.145),(34.12,-23.145),(34.12,-23.315),(33.95,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-23.315),(34.46,-23.145),(34.63,-23.145),(34.63,-23.315),(34.46,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-23.315),(34.97,-23.145),(35.14,-23.145),(35.14,-23.315),(34.97,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-23.315),(35.48,-23.145),(35.65,-23.145),(35.65,-23.315),(35.48,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-23.315),(35.99,-23.145),(36.16,-23.145),(36.16,-23.315),(35.99,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-23.315),(36.5,-23.145),(36.67,-23.145),(36.67,-23.315),(36.5,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-23.315),(37.01,-23.145),(37.18,-23.145),(37.18,-23.315),(37.01,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-23.315),(37.52,-23.145),(37.69,-23.145),(37.69,-23.315),(37.52,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-23.315),(38.03,-23.145),(38.2,-23.145),(38.2,-23.315),(38.03,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-23.315),(38.54,-23.145),(38.71,-23.145),(38.71,-23.315),(38.54,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-23.315),(39.05,-23.145),(39.22,-23.145),(39.22,-23.315),(39.05,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-23.315),(39.56,-23.145),(39.73,-23.145),(39.73,-23.315),(39.56,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-23.315),(40.07,-23.145),(40.24,-23.145),(40.24,-23.315),(40.07,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-23.315),(40.58,-23.145),(40.75,-23.145),(40.75,-23.315),(40.58,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-23.315),(41.09,-23.145),(41.26,-23.145),(41.26,-23.315),(41.09,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-23.315),(41.6,-23.145),(41.77,-23.145),(41.77,-23.315),(41.6,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-23.315),(42.11,-23.145),(42.28,-23.145),(42.28,-23.315),(42.11,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-23.315),(42.62,-23.145),(42.79,-23.145),(42.79,-23.315),(42.62,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-23.315),(43.13,-23.145),(43.3,-23.145),(43.3,-23.315),(43.13,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-23.315),(43.64,-23.145),(43.81,-23.145),(43.81,-23.315),(43.64,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-23.315),(44.15,-23.145),(44.32,-23.145),(44.32,-23.315),(44.15,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-23.315),(44.66,-23.145),(44.83,-23.145),(44.83,-23.315),(44.66,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-23.315),(45.17,-23.145),(45.34,-23.145),(45.34,-23.315),(45.17,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-23.315),(45.68,-23.145),(45.85,-23.145),(45.85,-23.315),(45.68,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-23.315),(46.19,-23.145),(46.36,-23.145),(46.36,-23.315),(46.19,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-23.315),(46.7,-23.145),(46.87,-23.145),(46.87,-23.315),(46.7,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-23.315),(47.21,-23.145),(47.38,-23.145),(47.38,-23.315),(47.21,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-23.315),(47.72,-23.145),(47.89,-23.145),(47.89,-23.315),(47.72,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-23.315),(48.23,-23.145),(48.4,-23.145),(48.4,-23.315),(48.23,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-23.315),(48.74,-23.145),(48.91,-23.145),(48.91,-23.315),(48.74,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-23.315),(49.25,-23.145),(49.42,-23.145),(49.42,-23.315),(49.25,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-23.315),(49.76,-23.145),(49.93,-23.145),(49.93,-23.315),(49.76,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-23.315),(50.27,-23.145),(50.44,-23.145),(50.44,-23.315),(50.27,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-23.315),(50.78,-23.145),(50.95,-23.145),(50.95,-23.315),(50.78,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-23.315),(51.29,-23.145),(51.46,-23.145),(51.46,-23.315),(51.29,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-23.315),(51.8,-23.145),(51.97,-23.145),(51.97,-23.315),(51.8,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-23.315),(52.31,-23.145),(52.48,-23.145),(52.48,-23.315),(52.31,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-23.315),(52.82,-23.145),(52.99,-23.145),(52.99,-23.315),(52.82,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-23.315),(53.33,-23.145),(53.5,-23.145),(53.5,-23.315),(53.33,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-23.315),(53.84,-23.145),(54.01,-23.145),(54.01,-23.315),(53.84,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-23.315),(54.35,-23.145),(54.52,-23.145),(54.52,-23.315),(54.35,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-23.315),(54.86,-23.145),(55.03,-23.145),(55.03,-23.315),(54.86,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-23.315),(55.37,-23.145),(55.54,-23.145),(55.54,-23.315),(55.37,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-23.315),(55.88,-23.145),(56.05,-23.145),(56.05,-23.315),(55.88,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-23.315),(56.39,-23.145),(56.56,-23.145),(56.56,-23.315),(56.39,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-23.315),(56.9,-23.145),(57.07,-23.145),(57.07,-23.315),(56.9,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-23.315),(57.41,-23.145),(57.58,-23.145),(57.58,-23.315),(57.41,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-23.315),(57.92,-23.145),(58.09,-23.145),(58.09,-23.315),(57.92,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-23.315),(58.43,-23.145),(58.6,-23.145),(58.6,-23.315),(58.43,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-23.315),(58.94,-23.145),(59.11,-23.145),(59.11,-23.315),(58.94,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-23.315),(59.45,-23.145),(59.62,-23.145),(59.62,-23.315),(59.45,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-23.315),(59.96,-23.145),(60.13,-23.145),(60.13,-23.315),(59.96,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-23.315),(60.47,-23.145),(60.64,-23.145),(60.64,-23.315),(60.47,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-23.315),(60.98,-23.145),(61.15,-23.145),(61.15,-23.315),(60.98,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-23.315),(61.49,-23.145),(61.66,-23.145),(61.66,-23.315),(61.49,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-23.315),(62.0,-23.145),(62.17,-23.145),(62.17,-23.315),(62.0,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-23.315),(62.51,-23.145),(62.68,-23.145),(62.68,-23.315),(62.51,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-23.315),(63.02,-23.145),(63.19,-23.145),(63.19,-23.315),(63.02,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-23.315),(63.53,-23.145),(63.7,-23.145),(63.7,-23.315),(63.53,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-23.315),(64.04,-23.145),(64.21,-23.145),(64.21,-23.315),(64.04,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-23.315),(64.55,-23.145),(64.72,-23.145),(64.72,-23.315),(64.55,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-23.315),(65.06,-23.145),(65.23,-23.145),(65.23,-23.315),(65.06,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-23.315),(65.57,-23.145),(65.74,-23.145),(65.74,-23.315),(65.57,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-23.315),(66.08,-23.145),(66.25,-23.145),(66.25,-23.315),(66.08,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-23.315),(66.59,-23.145),(66.76,-23.145),(66.76,-23.315),(66.59,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-23.315),(67.1,-23.145),(67.27,-23.145),(67.27,-23.315),(67.1,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-23.315),(67.61,-23.145),(67.78,-23.145),(67.78,-23.315),(67.61,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-23.315),(68.12,-23.145),(68.29,-23.145),(68.29,-23.315),(68.12,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-23.315),(68.63,-23.145),(68.8,-23.145),(68.8,-23.315),(68.63,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-23.315),(69.14,-23.145),(69.31,-23.145),(69.31,-23.315),(69.14,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-23.315),(69.65,-23.145),(69.82,-23.145),(69.82,-23.315),(69.65,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-23.315),(70.16,-23.145),(70.33,-23.145),(70.33,-23.315),(70.16,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-23.315),(70.67,-23.145),(70.84,-23.145),(70.84,-23.315),(70.67,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-23.315),(71.18,-23.145),(71.35,-23.145),(71.35,-23.315),(71.18,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-23.315),(71.69,-23.145),(71.86,-23.145),(71.86,-23.315),(71.69,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-23.315),(72.2,-23.145),(72.37,-23.145),(72.37,-23.315),(72.2,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-23.315),(72.71,-23.145),(72.88,-23.145),(72.88,-23.315),(72.71,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-23.315),(73.22,-23.145),(73.39,-23.145),(73.39,-23.315),(73.22,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-23.315),(73.73,-23.145),(73.9,-23.145),(73.9,-23.315),(73.73,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-23.315),(74.24,-23.145),(74.41,-23.145),(74.41,-23.315),(74.24,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-23.315),(74.75,-23.145),(74.92,-23.145),(74.92,-23.315),(74.75,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-23.315),(75.26,-23.145),(75.43,-23.145),(75.43,-23.315),(75.26,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-23.315),(75.77,-23.145),(75.94,-23.145),(75.94,-23.315),(75.77,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-23.315),(76.28,-23.145),(76.45,-23.145),(76.45,-23.315),(76.28,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-23.315),(76.79,-23.145),(76.96,-23.145),(76.96,-23.315),(76.79,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-23.315),(77.3,-23.145),(77.47,-23.145),(77.47,-23.315),(77.3,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-23.315),(77.81,-23.145),(77.98,-23.145),(77.98,-23.315),(77.81,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-23.315),(78.32,-23.145),(78.49,-23.145),(78.49,-23.315),(78.32,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-23.315),(78.83,-23.145),(79.0,-23.145),(79.0,-23.315),(78.83,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-23.315),(79.34,-23.145),(79.51,-23.145),(79.51,-23.315),(79.34,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-23.315),(79.85,-23.145),(80.02,-23.145),(80.02,-23.315),(79.85,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-23.315),(80.36,-23.145),(80.53,-23.145),(80.53,-23.315),(80.36,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-23.315),(80.87,-23.145),(81.04,-23.145),(81.04,-23.315),(80.87,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-23.315),(81.38,-23.145),(81.55,-23.145),(81.55,-23.315),(81.38,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-23.315),(81.89,-23.145),(82.06,-23.145),(82.06,-23.315),(81.89,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-23.315),(82.4,-23.145),(82.57,-23.145),(82.57,-23.315),(82.4,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-23.315),(82.91,-23.145),(83.08,-23.145),(83.08,-23.315),(82.91,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-23.315),(83.42,-23.145),(83.59,-23.145),(83.59,-23.315),(83.42,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-23.315),(83.93,-23.145),(84.1,-23.145),(84.1,-23.315),(83.93,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-23.315),(84.44,-23.145),(84.61,-23.145),(84.61,-23.315),(84.44,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-23.315),(84.95,-23.145),(85.12,-23.145),(85.12,-23.315),(84.95,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-23.315),(85.46,-23.145),(85.63,-23.145),(85.63,-23.315),(85.46,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-23.315),(85.97,-23.145),(86.14,-23.145),(86.14,-23.315),(85.97,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-23.315),(86.48,-23.145),(86.65,-23.145),(86.65,-23.315),(86.48,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-23.315),(86.99,-23.145),(87.16,-23.145),(87.16,-23.315),(86.99,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-23.315),(87.5,-23.145),(87.67,-23.145),(87.67,-23.315),(87.5,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-23.315),(88.01,-23.145),(88.18,-23.145),(88.18,-23.315),(88.01,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-23.315),(88.52,-23.145),(88.69,-23.145),(88.69,-23.315),(88.52,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-23.315),(89.03,-23.145),(89.2,-23.145),(89.2,-23.315),(89.03,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-23.315),(89.54,-23.145),(89.71,-23.145),(89.71,-23.315),(89.54,-23.315)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-22.805),(0.29,-22.635),(0.46,-22.635),(0.46,-22.805),(0.29,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-22.805),(0.8,-22.635),(0.97,-22.635),(0.97,-22.805),(0.8,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-22.805),(1.31,-22.635),(1.48,-22.635),(1.48,-22.805),(1.31,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-22.805),(1.82,-22.635),(1.99,-22.635),(1.99,-22.805),(1.82,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-22.805),(2.33,-22.635),(2.5,-22.635),(2.5,-22.805),(2.33,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-22.805),(2.84,-22.635),(3.01,-22.635),(3.01,-22.805),(2.84,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-22.805),(3.35,-22.635),(3.52,-22.635),(3.52,-22.805),(3.35,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-22.805),(3.86,-22.635),(4.03,-22.635),(4.03,-22.805),(3.86,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-22.805),(4.37,-22.635),(4.54,-22.635),(4.54,-22.805),(4.37,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-22.805),(4.88,-22.635),(5.05,-22.635),(5.05,-22.805),(4.88,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-22.805),(5.39,-22.635),(5.56,-22.635),(5.56,-22.805),(5.39,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-22.805),(5.9,-22.635),(6.07,-22.635),(6.07,-22.805),(5.9,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-22.805),(6.41,-22.635),(6.58,-22.635),(6.58,-22.805),(6.41,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-22.805),(6.92,-22.635),(7.09,-22.635),(7.09,-22.805),(6.92,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-22.805),(7.43,-22.635),(7.6,-22.635),(7.6,-22.805),(7.43,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-22.805),(7.94,-22.635),(8.11,-22.635),(8.11,-22.805),(7.94,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-22.805),(8.45,-22.635),(8.62,-22.635),(8.62,-22.805),(8.45,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-22.805),(8.96,-22.635),(9.13,-22.635),(9.13,-22.805),(8.96,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-22.805),(9.47,-22.635),(9.64,-22.635),(9.64,-22.805),(9.47,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-22.805),(9.98,-22.635),(10.15,-22.635),(10.15,-22.805),(9.98,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-22.805),(10.49,-22.635),(10.66,-22.635),(10.66,-22.805),(10.49,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-22.805),(11.0,-22.635),(11.17,-22.635),(11.17,-22.805),(11.0,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-22.805),(11.51,-22.635),(11.68,-22.635),(11.68,-22.805),(11.51,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-22.805),(12.02,-22.635),(12.19,-22.635),(12.19,-22.805),(12.02,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-22.805),(12.53,-22.635),(12.7,-22.635),(12.7,-22.805),(12.53,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-22.805),(13.04,-22.635),(13.21,-22.635),(13.21,-22.805),(13.04,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-22.805),(13.55,-22.635),(13.72,-22.635),(13.72,-22.805),(13.55,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-22.805),(14.06,-22.635),(14.23,-22.635),(14.23,-22.805),(14.06,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-22.805),(14.57,-22.635),(14.74,-22.635),(14.74,-22.805),(14.57,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-22.805),(15.08,-22.635),(15.25,-22.635),(15.25,-22.805),(15.08,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-22.805),(15.59,-22.635),(15.76,-22.635),(15.76,-22.805),(15.59,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-22.805),(16.1,-22.635),(16.27,-22.635),(16.27,-22.805),(16.1,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-22.805),(16.61,-22.635),(16.78,-22.635),(16.78,-22.805),(16.61,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-22.805),(17.12,-22.635),(17.29,-22.635),(17.29,-22.805),(17.12,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-22.805),(17.63,-22.635),(17.8,-22.635),(17.8,-22.805),(17.63,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-22.805),(18.14,-22.635),(18.31,-22.635),(18.31,-22.805),(18.14,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-22.805),(18.65,-22.635),(18.82,-22.635),(18.82,-22.805),(18.65,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-22.805),(19.16,-22.635),(19.33,-22.635),(19.33,-22.805),(19.16,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-22.805),(19.67,-22.635),(19.84,-22.635),(19.84,-22.805),(19.67,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-22.805),(20.18,-22.635),(20.35,-22.635),(20.35,-22.805),(20.18,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-22.805),(20.69,-22.635),(20.86,-22.635),(20.86,-22.805),(20.69,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-22.805),(21.2,-22.635),(21.37,-22.635),(21.37,-22.805),(21.2,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-22.805),(21.71,-22.635),(21.88,-22.635),(21.88,-22.805),(21.71,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-22.805),(22.22,-22.635),(22.39,-22.635),(22.39,-22.805),(22.22,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-22.805),(22.73,-22.635),(22.9,-22.635),(22.9,-22.805),(22.73,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-22.805),(23.24,-22.635),(23.41,-22.635),(23.41,-22.805),(23.24,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-22.805),(23.75,-22.635),(23.92,-22.635),(23.92,-22.805),(23.75,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-22.805),(24.26,-22.635),(24.43,-22.635),(24.43,-22.805),(24.26,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-22.805),(24.77,-22.635),(24.94,-22.635),(24.94,-22.805),(24.77,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-22.805),(25.28,-22.635),(25.45,-22.635),(25.45,-22.805),(25.28,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-22.805),(25.79,-22.635),(25.96,-22.635),(25.96,-22.805),(25.79,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-22.805),(26.3,-22.635),(26.47,-22.635),(26.47,-22.805),(26.3,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-22.805),(26.81,-22.635),(26.98,-22.635),(26.98,-22.805),(26.81,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-22.805),(27.32,-22.635),(27.49,-22.635),(27.49,-22.805),(27.32,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-22.805),(27.83,-22.635),(28.0,-22.635),(28.0,-22.805),(27.83,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-22.805),(28.34,-22.635),(28.51,-22.635),(28.51,-22.805),(28.34,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-22.805),(28.85,-22.635),(29.02,-22.635),(29.02,-22.805),(28.85,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-22.805),(29.36,-22.635),(29.53,-22.635),(29.53,-22.805),(29.36,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-22.805),(29.87,-22.635),(30.04,-22.635),(30.04,-22.805),(29.87,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-22.805),(30.38,-22.635),(30.55,-22.635),(30.55,-22.805),(30.38,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-22.805),(30.89,-22.635),(31.06,-22.635),(31.06,-22.805),(30.89,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-22.805),(31.4,-22.635),(31.57,-22.635),(31.57,-22.805),(31.4,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-22.805),(31.91,-22.635),(32.08,-22.635),(32.08,-22.805),(31.91,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-22.805),(32.42,-22.635),(32.59,-22.635),(32.59,-22.805),(32.42,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-22.805),(32.93,-22.635),(33.1,-22.635),(33.1,-22.805),(32.93,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-22.805),(33.44,-22.635),(33.61,-22.635),(33.61,-22.805),(33.44,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-22.805),(33.95,-22.635),(34.12,-22.635),(34.12,-22.805),(33.95,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-22.805),(34.46,-22.635),(34.63,-22.635),(34.63,-22.805),(34.46,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-22.805),(34.97,-22.635),(35.14,-22.635),(35.14,-22.805),(34.97,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-22.805),(35.48,-22.635),(35.65,-22.635),(35.65,-22.805),(35.48,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-22.805),(35.99,-22.635),(36.16,-22.635),(36.16,-22.805),(35.99,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-22.805),(36.5,-22.635),(36.67,-22.635),(36.67,-22.805),(36.5,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-22.805),(37.01,-22.635),(37.18,-22.635),(37.18,-22.805),(37.01,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-22.805),(37.52,-22.635),(37.69,-22.635),(37.69,-22.805),(37.52,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-22.805),(38.03,-22.635),(38.2,-22.635),(38.2,-22.805),(38.03,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-22.805),(38.54,-22.635),(38.71,-22.635),(38.71,-22.805),(38.54,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-22.805),(39.05,-22.635),(39.22,-22.635),(39.22,-22.805),(39.05,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-22.805),(39.56,-22.635),(39.73,-22.635),(39.73,-22.805),(39.56,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-22.805),(40.07,-22.635),(40.24,-22.635),(40.24,-22.805),(40.07,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-22.805),(40.58,-22.635),(40.75,-22.635),(40.75,-22.805),(40.58,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-22.805),(41.09,-22.635),(41.26,-22.635),(41.26,-22.805),(41.09,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-22.805),(41.6,-22.635),(41.77,-22.635),(41.77,-22.805),(41.6,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-22.805),(42.11,-22.635),(42.28,-22.635),(42.28,-22.805),(42.11,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-22.805),(42.62,-22.635),(42.79,-22.635),(42.79,-22.805),(42.62,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-22.805),(43.13,-22.635),(43.3,-22.635),(43.3,-22.805),(43.13,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-22.805),(43.64,-22.635),(43.81,-22.635),(43.81,-22.805),(43.64,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-22.805),(44.15,-22.635),(44.32,-22.635),(44.32,-22.805),(44.15,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-22.805),(44.66,-22.635),(44.83,-22.635),(44.83,-22.805),(44.66,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-22.805),(45.17,-22.635),(45.34,-22.635),(45.34,-22.805),(45.17,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-22.805),(45.68,-22.635),(45.85,-22.635),(45.85,-22.805),(45.68,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-22.805),(46.19,-22.635),(46.36,-22.635),(46.36,-22.805),(46.19,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-22.805),(46.7,-22.635),(46.87,-22.635),(46.87,-22.805),(46.7,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-22.805),(47.21,-22.635),(47.38,-22.635),(47.38,-22.805),(47.21,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-22.805),(47.72,-22.635),(47.89,-22.635),(47.89,-22.805),(47.72,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-22.805),(48.23,-22.635),(48.4,-22.635),(48.4,-22.805),(48.23,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-22.805),(48.74,-22.635),(48.91,-22.635),(48.91,-22.805),(48.74,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-22.805),(49.25,-22.635),(49.42,-22.635),(49.42,-22.805),(49.25,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-22.805),(49.76,-22.635),(49.93,-22.635),(49.93,-22.805),(49.76,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-22.805),(50.27,-22.635),(50.44,-22.635),(50.44,-22.805),(50.27,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-22.805),(50.78,-22.635),(50.95,-22.635),(50.95,-22.805),(50.78,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-22.805),(51.29,-22.635),(51.46,-22.635),(51.46,-22.805),(51.29,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-22.805),(51.8,-22.635),(51.97,-22.635),(51.97,-22.805),(51.8,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-22.805),(52.31,-22.635),(52.48,-22.635),(52.48,-22.805),(52.31,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-22.805),(52.82,-22.635),(52.99,-22.635),(52.99,-22.805),(52.82,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-22.805),(53.33,-22.635),(53.5,-22.635),(53.5,-22.805),(53.33,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-22.805),(53.84,-22.635),(54.01,-22.635),(54.01,-22.805),(53.84,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-22.805),(54.35,-22.635),(54.52,-22.635),(54.52,-22.805),(54.35,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-22.805),(54.86,-22.635),(55.03,-22.635),(55.03,-22.805),(54.86,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-22.805),(55.37,-22.635),(55.54,-22.635),(55.54,-22.805),(55.37,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-22.805),(55.88,-22.635),(56.05,-22.635),(56.05,-22.805),(55.88,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-22.805),(56.39,-22.635),(56.56,-22.635),(56.56,-22.805),(56.39,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-22.805),(56.9,-22.635),(57.07,-22.635),(57.07,-22.805),(56.9,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-22.805),(57.41,-22.635),(57.58,-22.635),(57.58,-22.805),(57.41,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-22.805),(57.92,-22.635),(58.09,-22.635),(58.09,-22.805),(57.92,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-22.805),(58.43,-22.635),(58.6,-22.635),(58.6,-22.805),(58.43,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-22.805),(58.94,-22.635),(59.11,-22.635),(59.11,-22.805),(58.94,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-22.805),(59.45,-22.635),(59.62,-22.635),(59.62,-22.805),(59.45,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-22.805),(59.96,-22.635),(60.13,-22.635),(60.13,-22.805),(59.96,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-22.805),(60.47,-22.635),(60.64,-22.635),(60.64,-22.805),(60.47,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-22.805),(60.98,-22.635),(61.15,-22.635),(61.15,-22.805),(60.98,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-22.805),(61.49,-22.635),(61.66,-22.635),(61.66,-22.805),(61.49,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-22.805),(62.0,-22.635),(62.17,-22.635),(62.17,-22.805),(62.0,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-22.805),(62.51,-22.635),(62.68,-22.635),(62.68,-22.805),(62.51,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-22.805),(63.02,-22.635),(63.19,-22.635),(63.19,-22.805),(63.02,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-22.805),(63.53,-22.635),(63.7,-22.635),(63.7,-22.805),(63.53,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-22.805),(64.04,-22.635),(64.21,-22.635),(64.21,-22.805),(64.04,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-22.805),(64.55,-22.635),(64.72,-22.635),(64.72,-22.805),(64.55,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-22.805),(65.06,-22.635),(65.23,-22.635),(65.23,-22.805),(65.06,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-22.805),(65.57,-22.635),(65.74,-22.635),(65.74,-22.805),(65.57,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-22.805),(66.08,-22.635),(66.25,-22.635),(66.25,-22.805),(66.08,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-22.805),(66.59,-22.635),(66.76,-22.635),(66.76,-22.805),(66.59,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-22.805),(67.1,-22.635),(67.27,-22.635),(67.27,-22.805),(67.1,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-22.805),(67.61,-22.635),(67.78,-22.635),(67.78,-22.805),(67.61,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-22.805),(68.12,-22.635),(68.29,-22.635),(68.29,-22.805),(68.12,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-22.805),(68.63,-22.635),(68.8,-22.635),(68.8,-22.805),(68.63,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-22.805),(69.14,-22.635),(69.31,-22.635),(69.31,-22.805),(69.14,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-22.805),(69.65,-22.635),(69.82,-22.635),(69.82,-22.805),(69.65,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-22.805),(70.16,-22.635),(70.33,-22.635),(70.33,-22.805),(70.16,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-22.805),(70.67,-22.635),(70.84,-22.635),(70.84,-22.805),(70.67,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-22.805),(71.18,-22.635),(71.35,-22.635),(71.35,-22.805),(71.18,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-22.805),(71.69,-22.635),(71.86,-22.635),(71.86,-22.805),(71.69,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-22.805),(72.2,-22.635),(72.37,-22.635),(72.37,-22.805),(72.2,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-22.805),(72.71,-22.635),(72.88,-22.635),(72.88,-22.805),(72.71,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-22.805),(73.22,-22.635),(73.39,-22.635),(73.39,-22.805),(73.22,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-22.805),(73.73,-22.635),(73.9,-22.635),(73.9,-22.805),(73.73,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-22.805),(74.24,-22.635),(74.41,-22.635),(74.41,-22.805),(74.24,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-22.805),(74.75,-22.635),(74.92,-22.635),(74.92,-22.805),(74.75,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-22.805),(75.26,-22.635),(75.43,-22.635),(75.43,-22.805),(75.26,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-22.805),(75.77,-22.635),(75.94,-22.635),(75.94,-22.805),(75.77,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-22.805),(76.28,-22.635),(76.45,-22.635),(76.45,-22.805),(76.28,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-22.805),(76.79,-22.635),(76.96,-22.635),(76.96,-22.805),(76.79,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-22.805),(77.3,-22.635),(77.47,-22.635),(77.47,-22.805),(77.3,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-22.805),(77.81,-22.635),(77.98,-22.635),(77.98,-22.805),(77.81,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-22.805),(78.32,-22.635),(78.49,-22.635),(78.49,-22.805),(78.32,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-22.805),(78.83,-22.635),(79.0,-22.635),(79.0,-22.805),(78.83,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-22.805),(79.34,-22.635),(79.51,-22.635),(79.51,-22.805),(79.34,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-22.805),(79.85,-22.635),(80.02,-22.635),(80.02,-22.805),(79.85,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-22.805),(80.36,-22.635),(80.53,-22.635),(80.53,-22.805),(80.36,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-22.805),(80.87,-22.635),(81.04,-22.635),(81.04,-22.805),(80.87,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-22.805),(81.38,-22.635),(81.55,-22.635),(81.55,-22.805),(81.38,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-22.805),(81.89,-22.635),(82.06,-22.635),(82.06,-22.805),(81.89,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-22.805),(82.4,-22.635),(82.57,-22.635),(82.57,-22.805),(82.4,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-22.805),(82.91,-22.635),(83.08,-22.635),(83.08,-22.805),(82.91,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-22.805),(83.42,-22.635),(83.59,-22.635),(83.59,-22.805),(83.42,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-22.805),(83.93,-22.635),(84.1,-22.635),(84.1,-22.805),(83.93,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-22.805),(84.44,-22.635),(84.61,-22.635),(84.61,-22.805),(84.44,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-22.805),(84.95,-22.635),(85.12,-22.635),(85.12,-22.805),(84.95,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-22.805),(85.46,-22.635),(85.63,-22.635),(85.63,-22.805),(85.46,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-22.805),(85.97,-22.635),(86.14,-22.635),(86.14,-22.805),(85.97,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-22.805),(86.48,-22.635),(86.65,-22.635),(86.65,-22.805),(86.48,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-22.805),(86.99,-22.635),(87.16,-22.635),(87.16,-22.805),(86.99,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-22.805),(87.5,-22.635),(87.67,-22.635),(87.67,-22.805),(87.5,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-22.805),(88.01,-22.635),(88.18,-22.635),(88.18,-22.805),(88.01,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-22.805),(88.52,-22.635),(88.69,-22.635),(88.69,-22.805),(88.52,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-22.805),(89.03,-22.635),(89.2,-22.635),(89.2,-22.805),(89.03,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-22.805),(89.54,-22.635),(89.71,-22.635),(89.71,-22.805),(89.54,-22.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-22.295),(0.29,-22.125),(0.46,-22.125),(0.46,-22.295),(0.29,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-22.295),(0.8,-22.125),(0.97,-22.125),(0.97,-22.295),(0.8,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-22.295),(1.31,-22.125),(1.48,-22.125),(1.48,-22.295),(1.31,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-22.295),(1.82,-22.125),(1.99,-22.125),(1.99,-22.295),(1.82,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-22.295),(2.33,-22.125),(2.5,-22.125),(2.5,-22.295),(2.33,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-22.295),(2.84,-22.125),(3.01,-22.125),(3.01,-22.295),(2.84,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-22.295),(3.35,-22.125),(3.52,-22.125),(3.52,-22.295),(3.35,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-22.295),(3.86,-22.125),(4.03,-22.125),(4.03,-22.295),(3.86,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-22.295),(4.37,-22.125),(4.54,-22.125),(4.54,-22.295),(4.37,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-22.295),(4.88,-22.125),(5.05,-22.125),(5.05,-22.295),(4.88,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-22.295),(5.39,-22.125),(5.56,-22.125),(5.56,-22.295),(5.39,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-22.295),(5.9,-22.125),(6.07,-22.125),(6.07,-22.295),(5.9,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-22.295),(6.41,-22.125),(6.58,-22.125),(6.58,-22.295),(6.41,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-22.295),(6.92,-22.125),(7.09,-22.125),(7.09,-22.295),(6.92,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-22.295),(7.43,-22.125),(7.6,-22.125),(7.6,-22.295),(7.43,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-22.295),(7.94,-22.125),(8.11,-22.125),(8.11,-22.295),(7.94,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-22.295),(8.45,-22.125),(8.62,-22.125),(8.62,-22.295),(8.45,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-22.295),(8.96,-22.125),(9.13,-22.125),(9.13,-22.295),(8.96,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-22.295),(9.47,-22.125),(9.64,-22.125),(9.64,-22.295),(9.47,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-22.295),(9.98,-22.125),(10.15,-22.125),(10.15,-22.295),(9.98,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-22.295),(10.49,-22.125),(10.66,-22.125),(10.66,-22.295),(10.49,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-22.295),(11.0,-22.125),(11.17,-22.125),(11.17,-22.295),(11.0,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-22.295),(11.51,-22.125),(11.68,-22.125),(11.68,-22.295),(11.51,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-22.295),(12.02,-22.125),(12.19,-22.125),(12.19,-22.295),(12.02,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-22.295),(12.53,-22.125),(12.7,-22.125),(12.7,-22.295),(12.53,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-22.295),(13.04,-22.125),(13.21,-22.125),(13.21,-22.295),(13.04,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-22.295),(13.55,-22.125),(13.72,-22.125),(13.72,-22.295),(13.55,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-22.295),(14.06,-22.125),(14.23,-22.125),(14.23,-22.295),(14.06,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-22.295),(14.57,-22.125),(14.74,-22.125),(14.74,-22.295),(14.57,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-22.295),(15.08,-22.125),(15.25,-22.125),(15.25,-22.295),(15.08,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-22.295),(15.59,-22.125),(15.76,-22.125),(15.76,-22.295),(15.59,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-22.295),(16.1,-22.125),(16.27,-22.125),(16.27,-22.295),(16.1,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-22.295),(16.61,-22.125),(16.78,-22.125),(16.78,-22.295),(16.61,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-22.295),(17.12,-22.125),(17.29,-22.125),(17.29,-22.295),(17.12,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-22.295),(17.63,-22.125),(17.8,-22.125),(17.8,-22.295),(17.63,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-22.295),(18.14,-22.125),(18.31,-22.125),(18.31,-22.295),(18.14,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-22.295),(18.65,-22.125),(18.82,-22.125),(18.82,-22.295),(18.65,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-22.295),(19.16,-22.125),(19.33,-22.125),(19.33,-22.295),(19.16,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-22.295),(19.67,-22.125),(19.84,-22.125),(19.84,-22.295),(19.67,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-22.295),(20.18,-22.125),(20.35,-22.125),(20.35,-22.295),(20.18,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-22.295),(20.69,-22.125),(20.86,-22.125),(20.86,-22.295),(20.69,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-22.295),(21.2,-22.125),(21.37,-22.125),(21.37,-22.295),(21.2,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-22.295),(21.71,-22.125),(21.88,-22.125),(21.88,-22.295),(21.71,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-22.295),(22.22,-22.125),(22.39,-22.125),(22.39,-22.295),(22.22,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-22.295),(22.73,-22.125),(22.9,-22.125),(22.9,-22.295),(22.73,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-22.295),(23.24,-22.125),(23.41,-22.125),(23.41,-22.295),(23.24,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-22.295),(23.75,-22.125),(23.92,-22.125),(23.92,-22.295),(23.75,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-22.295),(24.26,-22.125),(24.43,-22.125),(24.43,-22.295),(24.26,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-22.295),(24.77,-22.125),(24.94,-22.125),(24.94,-22.295),(24.77,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-22.295),(25.28,-22.125),(25.45,-22.125),(25.45,-22.295),(25.28,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-22.295),(25.79,-22.125),(25.96,-22.125),(25.96,-22.295),(25.79,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-22.295),(26.3,-22.125),(26.47,-22.125),(26.47,-22.295),(26.3,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-22.295),(26.81,-22.125),(26.98,-22.125),(26.98,-22.295),(26.81,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-22.295),(27.32,-22.125),(27.49,-22.125),(27.49,-22.295),(27.32,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-22.295),(27.83,-22.125),(28.0,-22.125),(28.0,-22.295),(27.83,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-22.295),(28.34,-22.125),(28.51,-22.125),(28.51,-22.295),(28.34,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-22.295),(28.85,-22.125),(29.02,-22.125),(29.02,-22.295),(28.85,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-22.295),(29.36,-22.125),(29.53,-22.125),(29.53,-22.295),(29.36,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-22.295),(29.87,-22.125),(30.04,-22.125),(30.04,-22.295),(29.87,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-22.295),(30.38,-22.125),(30.55,-22.125),(30.55,-22.295),(30.38,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-22.295),(30.89,-22.125),(31.06,-22.125),(31.06,-22.295),(30.89,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-22.295),(31.4,-22.125),(31.57,-22.125),(31.57,-22.295),(31.4,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-22.295),(31.91,-22.125),(32.08,-22.125),(32.08,-22.295),(31.91,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-22.295),(32.42,-22.125),(32.59,-22.125),(32.59,-22.295),(32.42,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-22.295),(32.93,-22.125),(33.1,-22.125),(33.1,-22.295),(32.93,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-22.295),(33.44,-22.125),(33.61,-22.125),(33.61,-22.295),(33.44,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-22.295),(33.95,-22.125),(34.12,-22.125),(34.12,-22.295),(33.95,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-22.295),(34.46,-22.125),(34.63,-22.125),(34.63,-22.295),(34.46,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-22.295),(34.97,-22.125),(35.14,-22.125),(35.14,-22.295),(34.97,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-22.295),(35.48,-22.125),(35.65,-22.125),(35.65,-22.295),(35.48,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-22.295),(35.99,-22.125),(36.16,-22.125),(36.16,-22.295),(35.99,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-22.295),(36.5,-22.125),(36.67,-22.125),(36.67,-22.295),(36.5,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-22.295),(37.01,-22.125),(37.18,-22.125),(37.18,-22.295),(37.01,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-22.295),(37.52,-22.125),(37.69,-22.125),(37.69,-22.295),(37.52,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-22.295),(38.03,-22.125),(38.2,-22.125),(38.2,-22.295),(38.03,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-22.295),(38.54,-22.125),(38.71,-22.125),(38.71,-22.295),(38.54,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-22.295),(39.05,-22.125),(39.22,-22.125),(39.22,-22.295),(39.05,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-22.295),(39.56,-22.125),(39.73,-22.125),(39.73,-22.295),(39.56,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-22.295),(40.07,-22.125),(40.24,-22.125),(40.24,-22.295),(40.07,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-22.295),(40.58,-22.125),(40.75,-22.125),(40.75,-22.295),(40.58,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-22.295),(41.09,-22.125),(41.26,-22.125),(41.26,-22.295),(41.09,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-22.295),(41.6,-22.125),(41.77,-22.125),(41.77,-22.295),(41.6,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-22.295),(42.11,-22.125),(42.28,-22.125),(42.28,-22.295),(42.11,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-22.295),(42.62,-22.125),(42.79,-22.125),(42.79,-22.295),(42.62,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-22.295),(43.13,-22.125),(43.3,-22.125),(43.3,-22.295),(43.13,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-22.295),(43.64,-22.125),(43.81,-22.125),(43.81,-22.295),(43.64,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-22.295),(44.15,-22.125),(44.32,-22.125),(44.32,-22.295),(44.15,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-22.295),(44.66,-22.125),(44.83,-22.125),(44.83,-22.295),(44.66,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-22.295),(45.17,-22.125),(45.34,-22.125),(45.34,-22.295),(45.17,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-22.295),(45.68,-22.125),(45.85,-22.125),(45.85,-22.295),(45.68,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-22.295),(46.19,-22.125),(46.36,-22.125),(46.36,-22.295),(46.19,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-22.295),(46.7,-22.125),(46.87,-22.125),(46.87,-22.295),(46.7,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-22.295),(47.21,-22.125),(47.38,-22.125),(47.38,-22.295),(47.21,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-22.295),(47.72,-22.125),(47.89,-22.125),(47.89,-22.295),(47.72,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-22.295),(48.23,-22.125),(48.4,-22.125),(48.4,-22.295),(48.23,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-22.295),(48.74,-22.125),(48.91,-22.125),(48.91,-22.295),(48.74,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-22.295),(49.25,-22.125),(49.42,-22.125),(49.42,-22.295),(49.25,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-22.295),(49.76,-22.125),(49.93,-22.125),(49.93,-22.295),(49.76,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-22.295),(50.27,-22.125),(50.44,-22.125),(50.44,-22.295),(50.27,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-22.295),(50.78,-22.125),(50.95,-22.125),(50.95,-22.295),(50.78,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-22.295),(51.29,-22.125),(51.46,-22.125),(51.46,-22.295),(51.29,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-22.295),(51.8,-22.125),(51.97,-22.125),(51.97,-22.295),(51.8,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-22.295),(52.31,-22.125),(52.48,-22.125),(52.48,-22.295),(52.31,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-22.295),(52.82,-22.125),(52.99,-22.125),(52.99,-22.295),(52.82,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-22.295),(53.33,-22.125),(53.5,-22.125),(53.5,-22.295),(53.33,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-22.295),(53.84,-22.125),(54.01,-22.125),(54.01,-22.295),(53.84,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-22.295),(54.35,-22.125),(54.52,-22.125),(54.52,-22.295),(54.35,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-22.295),(54.86,-22.125),(55.03,-22.125),(55.03,-22.295),(54.86,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-22.295),(55.37,-22.125),(55.54,-22.125),(55.54,-22.295),(55.37,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-22.295),(55.88,-22.125),(56.05,-22.125),(56.05,-22.295),(55.88,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-22.295),(56.39,-22.125),(56.56,-22.125),(56.56,-22.295),(56.39,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-22.295),(56.9,-22.125),(57.07,-22.125),(57.07,-22.295),(56.9,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-22.295),(57.41,-22.125),(57.58,-22.125),(57.58,-22.295),(57.41,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-22.295),(57.92,-22.125),(58.09,-22.125),(58.09,-22.295),(57.92,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-22.295),(58.43,-22.125),(58.6,-22.125),(58.6,-22.295),(58.43,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-22.295),(58.94,-22.125),(59.11,-22.125),(59.11,-22.295),(58.94,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-22.295),(59.45,-22.125),(59.62,-22.125),(59.62,-22.295),(59.45,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-22.295),(59.96,-22.125),(60.13,-22.125),(60.13,-22.295),(59.96,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-22.295),(60.47,-22.125),(60.64,-22.125),(60.64,-22.295),(60.47,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-22.295),(60.98,-22.125),(61.15,-22.125),(61.15,-22.295),(60.98,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-22.295),(61.49,-22.125),(61.66,-22.125),(61.66,-22.295),(61.49,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-22.295),(62.0,-22.125),(62.17,-22.125),(62.17,-22.295),(62.0,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-22.295),(62.51,-22.125),(62.68,-22.125),(62.68,-22.295),(62.51,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-22.295),(63.02,-22.125),(63.19,-22.125),(63.19,-22.295),(63.02,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-22.295),(63.53,-22.125),(63.7,-22.125),(63.7,-22.295),(63.53,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-22.295),(64.04,-22.125),(64.21,-22.125),(64.21,-22.295),(64.04,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-22.295),(64.55,-22.125),(64.72,-22.125),(64.72,-22.295),(64.55,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-22.295),(65.06,-22.125),(65.23,-22.125),(65.23,-22.295),(65.06,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-22.295),(65.57,-22.125),(65.74,-22.125),(65.74,-22.295),(65.57,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-22.295),(66.08,-22.125),(66.25,-22.125),(66.25,-22.295),(66.08,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-22.295),(66.59,-22.125),(66.76,-22.125),(66.76,-22.295),(66.59,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-22.295),(67.1,-22.125),(67.27,-22.125),(67.27,-22.295),(67.1,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-22.295),(67.61,-22.125),(67.78,-22.125),(67.78,-22.295),(67.61,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-22.295),(68.12,-22.125),(68.29,-22.125),(68.29,-22.295),(68.12,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-22.295),(68.63,-22.125),(68.8,-22.125),(68.8,-22.295),(68.63,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-22.295),(69.14,-22.125),(69.31,-22.125),(69.31,-22.295),(69.14,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-22.295),(69.65,-22.125),(69.82,-22.125),(69.82,-22.295),(69.65,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-22.295),(70.16,-22.125),(70.33,-22.125),(70.33,-22.295),(70.16,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-22.295),(70.67,-22.125),(70.84,-22.125),(70.84,-22.295),(70.67,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-22.295),(71.18,-22.125),(71.35,-22.125),(71.35,-22.295),(71.18,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-22.295),(71.69,-22.125),(71.86,-22.125),(71.86,-22.295),(71.69,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-22.295),(72.2,-22.125),(72.37,-22.125),(72.37,-22.295),(72.2,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-22.295),(72.71,-22.125),(72.88,-22.125),(72.88,-22.295),(72.71,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-22.295),(73.22,-22.125),(73.39,-22.125),(73.39,-22.295),(73.22,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-22.295),(73.73,-22.125),(73.9,-22.125),(73.9,-22.295),(73.73,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-22.295),(74.24,-22.125),(74.41,-22.125),(74.41,-22.295),(74.24,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-22.295),(74.75,-22.125),(74.92,-22.125),(74.92,-22.295),(74.75,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-22.295),(75.26,-22.125),(75.43,-22.125),(75.43,-22.295),(75.26,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-22.295),(75.77,-22.125),(75.94,-22.125),(75.94,-22.295),(75.77,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-22.295),(76.28,-22.125),(76.45,-22.125),(76.45,-22.295),(76.28,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-22.295),(76.79,-22.125),(76.96,-22.125),(76.96,-22.295),(76.79,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-22.295),(77.3,-22.125),(77.47,-22.125),(77.47,-22.295),(77.3,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-22.295),(77.81,-22.125),(77.98,-22.125),(77.98,-22.295),(77.81,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-22.295),(78.32,-22.125),(78.49,-22.125),(78.49,-22.295),(78.32,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-22.295),(78.83,-22.125),(79.0,-22.125),(79.0,-22.295),(78.83,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-22.295),(79.34,-22.125),(79.51,-22.125),(79.51,-22.295),(79.34,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-22.295),(79.85,-22.125),(80.02,-22.125),(80.02,-22.295),(79.85,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-22.295),(80.36,-22.125),(80.53,-22.125),(80.53,-22.295),(80.36,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-22.295),(80.87,-22.125),(81.04,-22.125),(81.04,-22.295),(80.87,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-22.295),(81.38,-22.125),(81.55,-22.125),(81.55,-22.295),(81.38,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-22.295),(81.89,-22.125),(82.06,-22.125),(82.06,-22.295),(81.89,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-22.295),(82.4,-22.125),(82.57,-22.125),(82.57,-22.295),(82.4,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-22.295),(82.91,-22.125),(83.08,-22.125),(83.08,-22.295),(82.91,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-22.295),(83.42,-22.125),(83.59,-22.125),(83.59,-22.295),(83.42,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-22.295),(83.93,-22.125),(84.1,-22.125),(84.1,-22.295),(83.93,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-22.295),(84.44,-22.125),(84.61,-22.125),(84.61,-22.295),(84.44,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-22.295),(84.95,-22.125),(85.12,-22.125),(85.12,-22.295),(84.95,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-22.295),(85.46,-22.125),(85.63,-22.125),(85.63,-22.295),(85.46,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-22.295),(85.97,-22.125),(86.14,-22.125),(86.14,-22.295),(85.97,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-22.295),(86.48,-22.125),(86.65,-22.125),(86.65,-22.295),(86.48,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-22.295),(86.99,-22.125),(87.16,-22.125),(87.16,-22.295),(86.99,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-22.295),(87.5,-22.125),(87.67,-22.125),(87.67,-22.295),(87.5,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-22.295),(88.01,-22.125),(88.18,-22.125),(88.18,-22.295),(88.01,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-22.295),(88.52,-22.125),(88.69,-22.125),(88.69,-22.295),(88.52,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-22.295),(89.03,-22.125),(89.2,-22.125),(89.2,-22.295),(89.03,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-22.295),(89.54,-22.125),(89.71,-22.125),(89.71,-22.295),(89.54,-22.295)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-21.785),(0.29,-21.615),(0.46,-21.615),(0.46,-21.785),(0.29,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-21.785),(0.8,-21.615),(0.97,-21.615),(0.97,-21.785),(0.8,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-21.785),(1.31,-21.615),(1.48,-21.615),(1.48,-21.785),(1.31,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-21.785),(1.82,-21.615),(1.99,-21.615),(1.99,-21.785),(1.82,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-21.785),(2.33,-21.615),(2.5,-21.615),(2.5,-21.785),(2.33,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-21.785),(2.84,-21.615),(3.01,-21.615),(3.01,-21.785),(2.84,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-21.785),(3.35,-21.615),(3.52,-21.615),(3.52,-21.785),(3.35,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-21.785),(3.86,-21.615),(4.03,-21.615),(4.03,-21.785),(3.86,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-21.785),(4.37,-21.615),(4.54,-21.615),(4.54,-21.785),(4.37,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-21.785),(4.88,-21.615),(5.05,-21.615),(5.05,-21.785),(4.88,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-21.785),(5.39,-21.615),(5.56,-21.615),(5.56,-21.785),(5.39,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-21.785),(5.9,-21.615),(6.07,-21.615),(6.07,-21.785),(5.9,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-21.785),(6.41,-21.615),(6.58,-21.615),(6.58,-21.785),(6.41,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-21.785),(6.92,-21.615),(7.09,-21.615),(7.09,-21.785),(6.92,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-21.785),(7.43,-21.615),(7.6,-21.615),(7.6,-21.785),(7.43,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-21.785),(7.94,-21.615),(8.11,-21.615),(8.11,-21.785),(7.94,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-21.785),(8.45,-21.615),(8.62,-21.615),(8.62,-21.785),(8.45,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-21.785),(8.96,-21.615),(9.13,-21.615),(9.13,-21.785),(8.96,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-21.785),(9.47,-21.615),(9.64,-21.615),(9.64,-21.785),(9.47,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-21.785),(9.98,-21.615),(10.15,-21.615),(10.15,-21.785),(9.98,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-21.785),(10.49,-21.615),(10.66,-21.615),(10.66,-21.785),(10.49,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-21.785),(11.0,-21.615),(11.17,-21.615),(11.17,-21.785),(11.0,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-21.785),(11.51,-21.615),(11.68,-21.615),(11.68,-21.785),(11.51,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-21.785),(12.02,-21.615),(12.19,-21.615),(12.19,-21.785),(12.02,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-21.785),(12.53,-21.615),(12.7,-21.615),(12.7,-21.785),(12.53,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-21.785),(13.04,-21.615),(13.21,-21.615),(13.21,-21.785),(13.04,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-21.785),(13.55,-21.615),(13.72,-21.615),(13.72,-21.785),(13.55,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-21.785),(14.06,-21.615),(14.23,-21.615),(14.23,-21.785),(14.06,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-21.785),(14.57,-21.615),(14.74,-21.615),(14.74,-21.785),(14.57,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-21.785),(15.08,-21.615),(15.25,-21.615),(15.25,-21.785),(15.08,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-21.785),(15.59,-21.615),(15.76,-21.615),(15.76,-21.785),(15.59,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-21.785),(16.1,-21.615),(16.27,-21.615),(16.27,-21.785),(16.1,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-21.785),(16.61,-21.615),(16.78,-21.615),(16.78,-21.785),(16.61,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-21.785),(17.12,-21.615),(17.29,-21.615),(17.29,-21.785),(17.12,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-21.785),(17.63,-21.615),(17.8,-21.615),(17.8,-21.785),(17.63,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-21.785),(18.14,-21.615),(18.31,-21.615),(18.31,-21.785),(18.14,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-21.785),(18.65,-21.615),(18.82,-21.615),(18.82,-21.785),(18.65,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-21.785),(19.16,-21.615),(19.33,-21.615),(19.33,-21.785),(19.16,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-21.785),(19.67,-21.615),(19.84,-21.615),(19.84,-21.785),(19.67,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-21.785),(20.18,-21.615),(20.35,-21.615),(20.35,-21.785),(20.18,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-21.785),(20.69,-21.615),(20.86,-21.615),(20.86,-21.785),(20.69,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-21.785),(21.2,-21.615),(21.37,-21.615),(21.37,-21.785),(21.2,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-21.785),(21.71,-21.615),(21.88,-21.615),(21.88,-21.785),(21.71,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-21.785),(22.22,-21.615),(22.39,-21.615),(22.39,-21.785),(22.22,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-21.785),(22.73,-21.615),(22.9,-21.615),(22.9,-21.785),(22.73,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-21.785),(23.24,-21.615),(23.41,-21.615),(23.41,-21.785),(23.24,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-21.785),(23.75,-21.615),(23.92,-21.615),(23.92,-21.785),(23.75,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-21.785),(24.26,-21.615),(24.43,-21.615),(24.43,-21.785),(24.26,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-21.785),(24.77,-21.615),(24.94,-21.615),(24.94,-21.785),(24.77,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-21.785),(25.28,-21.615),(25.45,-21.615),(25.45,-21.785),(25.28,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-21.785),(25.79,-21.615),(25.96,-21.615),(25.96,-21.785),(25.79,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-21.785),(26.3,-21.615),(26.47,-21.615),(26.47,-21.785),(26.3,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-21.785),(26.81,-21.615),(26.98,-21.615),(26.98,-21.785),(26.81,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-21.785),(27.32,-21.615),(27.49,-21.615),(27.49,-21.785),(27.32,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-21.785),(27.83,-21.615),(28.0,-21.615),(28.0,-21.785),(27.83,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-21.785),(28.34,-21.615),(28.51,-21.615),(28.51,-21.785),(28.34,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-21.785),(28.85,-21.615),(29.02,-21.615),(29.02,-21.785),(28.85,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-21.785),(29.36,-21.615),(29.53,-21.615),(29.53,-21.785),(29.36,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-21.785),(29.87,-21.615),(30.04,-21.615),(30.04,-21.785),(29.87,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-21.785),(30.38,-21.615),(30.55,-21.615),(30.55,-21.785),(30.38,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-21.785),(30.89,-21.615),(31.06,-21.615),(31.06,-21.785),(30.89,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-21.785),(31.4,-21.615),(31.57,-21.615),(31.57,-21.785),(31.4,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-21.785),(31.91,-21.615),(32.08,-21.615),(32.08,-21.785),(31.91,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-21.785),(32.42,-21.615),(32.59,-21.615),(32.59,-21.785),(32.42,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-21.785),(32.93,-21.615),(33.1,-21.615),(33.1,-21.785),(32.93,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-21.785),(33.44,-21.615),(33.61,-21.615),(33.61,-21.785),(33.44,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-21.785),(33.95,-21.615),(34.12,-21.615),(34.12,-21.785),(33.95,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-21.785),(34.46,-21.615),(34.63,-21.615),(34.63,-21.785),(34.46,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-21.785),(34.97,-21.615),(35.14,-21.615),(35.14,-21.785),(34.97,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-21.785),(35.48,-21.615),(35.65,-21.615),(35.65,-21.785),(35.48,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-21.785),(35.99,-21.615),(36.16,-21.615),(36.16,-21.785),(35.99,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-21.785),(36.5,-21.615),(36.67,-21.615),(36.67,-21.785),(36.5,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-21.785),(37.01,-21.615),(37.18,-21.615),(37.18,-21.785),(37.01,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-21.785),(37.52,-21.615),(37.69,-21.615),(37.69,-21.785),(37.52,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-21.785),(38.03,-21.615),(38.2,-21.615),(38.2,-21.785),(38.03,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-21.785),(38.54,-21.615),(38.71,-21.615),(38.71,-21.785),(38.54,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-21.785),(39.05,-21.615),(39.22,-21.615),(39.22,-21.785),(39.05,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-21.785),(39.56,-21.615),(39.73,-21.615),(39.73,-21.785),(39.56,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-21.785),(40.07,-21.615),(40.24,-21.615),(40.24,-21.785),(40.07,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-21.785),(40.58,-21.615),(40.75,-21.615),(40.75,-21.785),(40.58,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-21.785),(41.09,-21.615),(41.26,-21.615),(41.26,-21.785),(41.09,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-21.785),(41.6,-21.615),(41.77,-21.615),(41.77,-21.785),(41.6,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-21.785),(42.11,-21.615),(42.28,-21.615),(42.28,-21.785),(42.11,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-21.785),(42.62,-21.615),(42.79,-21.615),(42.79,-21.785),(42.62,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-21.785),(43.13,-21.615),(43.3,-21.615),(43.3,-21.785),(43.13,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-21.785),(43.64,-21.615),(43.81,-21.615),(43.81,-21.785),(43.64,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-21.785),(44.15,-21.615),(44.32,-21.615),(44.32,-21.785),(44.15,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-21.785),(44.66,-21.615),(44.83,-21.615),(44.83,-21.785),(44.66,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-21.785),(45.17,-21.615),(45.34,-21.615),(45.34,-21.785),(45.17,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-21.785),(45.68,-21.615),(45.85,-21.615),(45.85,-21.785),(45.68,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-21.785),(46.19,-21.615),(46.36,-21.615),(46.36,-21.785),(46.19,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-21.785),(46.7,-21.615),(46.87,-21.615),(46.87,-21.785),(46.7,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-21.785),(47.21,-21.615),(47.38,-21.615),(47.38,-21.785),(47.21,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-21.785),(47.72,-21.615),(47.89,-21.615),(47.89,-21.785),(47.72,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-21.785),(48.23,-21.615),(48.4,-21.615),(48.4,-21.785),(48.23,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-21.785),(48.74,-21.615),(48.91,-21.615),(48.91,-21.785),(48.74,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-21.785),(49.25,-21.615),(49.42,-21.615),(49.42,-21.785),(49.25,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-21.785),(49.76,-21.615),(49.93,-21.615),(49.93,-21.785),(49.76,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-21.785),(50.27,-21.615),(50.44,-21.615),(50.44,-21.785),(50.27,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-21.785),(50.78,-21.615),(50.95,-21.615),(50.95,-21.785),(50.78,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-21.785),(51.29,-21.615),(51.46,-21.615),(51.46,-21.785),(51.29,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-21.785),(51.8,-21.615),(51.97,-21.615),(51.97,-21.785),(51.8,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-21.785),(52.31,-21.615),(52.48,-21.615),(52.48,-21.785),(52.31,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-21.785),(52.82,-21.615),(52.99,-21.615),(52.99,-21.785),(52.82,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-21.785),(53.33,-21.615),(53.5,-21.615),(53.5,-21.785),(53.33,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-21.785),(53.84,-21.615),(54.01,-21.615),(54.01,-21.785),(53.84,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-21.785),(54.35,-21.615),(54.52,-21.615),(54.52,-21.785),(54.35,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-21.785),(54.86,-21.615),(55.03,-21.615),(55.03,-21.785),(54.86,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-21.785),(55.37,-21.615),(55.54,-21.615),(55.54,-21.785),(55.37,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-21.785),(55.88,-21.615),(56.05,-21.615),(56.05,-21.785),(55.88,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-21.785),(56.39,-21.615),(56.56,-21.615),(56.56,-21.785),(56.39,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-21.785),(56.9,-21.615),(57.07,-21.615),(57.07,-21.785),(56.9,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-21.785),(57.41,-21.615),(57.58,-21.615),(57.58,-21.785),(57.41,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-21.785),(57.92,-21.615),(58.09,-21.615),(58.09,-21.785),(57.92,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-21.785),(58.43,-21.615),(58.6,-21.615),(58.6,-21.785),(58.43,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-21.785),(58.94,-21.615),(59.11,-21.615),(59.11,-21.785),(58.94,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-21.785),(59.45,-21.615),(59.62,-21.615),(59.62,-21.785),(59.45,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-21.785),(59.96,-21.615),(60.13,-21.615),(60.13,-21.785),(59.96,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-21.785),(60.47,-21.615),(60.64,-21.615),(60.64,-21.785),(60.47,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-21.785),(60.98,-21.615),(61.15,-21.615),(61.15,-21.785),(60.98,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-21.785),(61.49,-21.615),(61.66,-21.615),(61.66,-21.785),(61.49,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-21.785),(62.0,-21.615),(62.17,-21.615),(62.17,-21.785),(62.0,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-21.785),(62.51,-21.615),(62.68,-21.615),(62.68,-21.785),(62.51,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-21.785),(63.02,-21.615),(63.19,-21.615),(63.19,-21.785),(63.02,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-21.785),(63.53,-21.615),(63.7,-21.615),(63.7,-21.785),(63.53,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-21.785),(64.04,-21.615),(64.21,-21.615),(64.21,-21.785),(64.04,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-21.785),(64.55,-21.615),(64.72,-21.615),(64.72,-21.785),(64.55,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-21.785),(65.06,-21.615),(65.23,-21.615),(65.23,-21.785),(65.06,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-21.785),(65.57,-21.615),(65.74,-21.615),(65.74,-21.785),(65.57,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-21.785),(66.08,-21.615),(66.25,-21.615),(66.25,-21.785),(66.08,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-21.785),(66.59,-21.615),(66.76,-21.615),(66.76,-21.785),(66.59,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-21.785),(67.1,-21.615),(67.27,-21.615),(67.27,-21.785),(67.1,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-21.785),(67.61,-21.615),(67.78,-21.615),(67.78,-21.785),(67.61,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-21.785),(68.12,-21.615),(68.29,-21.615),(68.29,-21.785),(68.12,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-21.785),(68.63,-21.615),(68.8,-21.615),(68.8,-21.785),(68.63,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-21.785),(69.14,-21.615),(69.31,-21.615),(69.31,-21.785),(69.14,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-21.785),(69.65,-21.615),(69.82,-21.615),(69.82,-21.785),(69.65,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-21.785),(70.16,-21.615),(70.33,-21.615),(70.33,-21.785),(70.16,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-21.785),(70.67,-21.615),(70.84,-21.615),(70.84,-21.785),(70.67,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-21.785),(71.18,-21.615),(71.35,-21.615),(71.35,-21.785),(71.18,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-21.785),(71.69,-21.615),(71.86,-21.615),(71.86,-21.785),(71.69,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-21.785),(72.2,-21.615),(72.37,-21.615),(72.37,-21.785),(72.2,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-21.785),(72.71,-21.615),(72.88,-21.615),(72.88,-21.785),(72.71,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-21.785),(73.22,-21.615),(73.39,-21.615),(73.39,-21.785),(73.22,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-21.785),(73.73,-21.615),(73.9,-21.615),(73.9,-21.785),(73.73,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-21.785),(74.24,-21.615),(74.41,-21.615),(74.41,-21.785),(74.24,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-21.785),(74.75,-21.615),(74.92,-21.615),(74.92,-21.785),(74.75,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-21.785),(75.26,-21.615),(75.43,-21.615),(75.43,-21.785),(75.26,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-21.785),(75.77,-21.615),(75.94,-21.615),(75.94,-21.785),(75.77,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-21.785),(76.28,-21.615),(76.45,-21.615),(76.45,-21.785),(76.28,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-21.785),(76.79,-21.615),(76.96,-21.615),(76.96,-21.785),(76.79,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-21.785),(77.3,-21.615),(77.47,-21.615),(77.47,-21.785),(77.3,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-21.785),(77.81,-21.615),(77.98,-21.615),(77.98,-21.785),(77.81,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-21.785),(78.32,-21.615),(78.49,-21.615),(78.49,-21.785),(78.32,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-21.785),(78.83,-21.615),(79.0,-21.615),(79.0,-21.785),(78.83,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-21.785),(79.34,-21.615),(79.51,-21.615),(79.51,-21.785),(79.34,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-21.785),(79.85,-21.615),(80.02,-21.615),(80.02,-21.785),(79.85,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-21.785),(80.36,-21.615),(80.53,-21.615),(80.53,-21.785),(80.36,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-21.785),(80.87,-21.615),(81.04,-21.615),(81.04,-21.785),(80.87,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-21.785),(81.38,-21.615),(81.55,-21.615),(81.55,-21.785),(81.38,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-21.785),(81.89,-21.615),(82.06,-21.615),(82.06,-21.785),(81.89,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-21.785),(82.4,-21.615),(82.57,-21.615),(82.57,-21.785),(82.4,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-21.785),(82.91,-21.615),(83.08,-21.615),(83.08,-21.785),(82.91,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-21.785),(83.42,-21.615),(83.59,-21.615),(83.59,-21.785),(83.42,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-21.785),(83.93,-21.615),(84.1,-21.615),(84.1,-21.785),(83.93,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-21.785),(84.44,-21.615),(84.61,-21.615),(84.61,-21.785),(84.44,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-21.785),(84.95,-21.615),(85.12,-21.615),(85.12,-21.785),(84.95,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-21.785),(85.46,-21.615),(85.63,-21.615),(85.63,-21.785),(85.46,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-21.785),(85.97,-21.615),(86.14,-21.615),(86.14,-21.785),(85.97,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-21.785),(86.48,-21.615),(86.65,-21.615),(86.65,-21.785),(86.48,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-21.785),(86.99,-21.615),(87.16,-21.615),(87.16,-21.785),(86.99,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-21.785),(87.5,-21.615),(87.67,-21.615),(87.67,-21.785),(87.5,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-21.785),(88.01,-21.615),(88.18,-21.615),(88.18,-21.785),(88.01,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-21.785),(88.52,-21.615),(88.69,-21.615),(88.69,-21.785),(88.52,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-21.785),(89.03,-21.615),(89.2,-21.615),(89.2,-21.785),(89.03,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-21.785),(89.54,-21.615),(89.71,-21.615),(89.71,-21.785),(89.54,-21.785)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-21.275),(0.29,-21.105),(0.46,-21.105),(0.46,-21.275),(0.29,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-21.275),(0.8,-21.105),(0.97,-21.105),(0.97,-21.275),(0.8,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-21.275),(1.31,-21.105),(1.48,-21.105),(1.48,-21.275),(1.31,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-21.275),(1.82,-21.105),(1.99,-21.105),(1.99,-21.275),(1.82,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-21.275),(2.33,-21.105),(2.5,-21.105),(2.5,-21.275),(2.33,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-21.275),(2.84,-21.105),(3.01,-21.105),(3.01,-21.275),(2.84,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-21.275),(3.35,-21.105),(3.52,-21.105),(3.52,-21.275),(3.35,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-21.275),(3.86,-21.105),(4.03,-21.105),(4.03,-21.275),(3.86,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-21.275),(4.37,-21.105),(4.54,-21.105),(4.54,-21.275),(4.37,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-21.275),(4.88,-21.105),(5.05,-21.105),(5.05,-21.275),(4.88,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-21.275),(5.39,-21.105),(5.56,-21.105),(5.56,-21.275),(5.39,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-21.275),(5.9,-21.105),(6.07,-21.105),(6.07,-21.275),(5.9,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-21.275),(6.41,-21.105),(6.58,-21.105),(6.58,-21.275),(6.41,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-21.275),(6.92,-21.105),(7.09,-21.105),(7.09,-21.275),(6.92,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-21.275),(7.43,-21.105),(7.6,-21.105),(7.6,-21.275),(7.43,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-21.275),(7.94,-21.105),(8.11,-21.105),(8.11,-21.275),(7.94,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-21.275),(8.45,-21.105),(8.62,-21.105),(8.62,-21.275),(8.45,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-21.275),(8.96,-21.105),(9.13,-21.105),(9.13,-21.275),(8.96,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-21.275),(9.47,-21.105),(9.64,-21.105),(9.64,-21.275),(9.47,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-21.275),(9.98,-21.105),(10.15,-21.105),(10.15,-21.275),(9.98,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-21.275),(10.49,-21.105),(10.66,-21.105),(10.66,-21.275),(10.49,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-21.275),(11.0,-21.105),(11.17,-21.105),(11.17,-21.275),(11.0,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-21.275),(11.51,-21.105),(11.68,-21.105),(11.68,-21.275),(11.51,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-21.275),(12.02,-21.105),(12.19,-21.105),(12.19,-21.275),(12.02,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-21.275),(12.53,-21.105),(12.7,-21.105),(12.7,-21.275),(12.53,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-21.275),(13.04,-21.105),(13.21,-21.105),(13.21,-21.275),(13.04,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-21.275),(13.55,-21.105),(13.72,-21.105),(13.72,-21.275),(13.55,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-21.275),(14.06,-21.105),(14.23,-21.105),(14.23,-21.275),(14.06,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-21.275),(14.57,-21.105),(14.74,-21.105),(14.74,-21.275),(14.57,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-21.275),(15.08,-21.105),(15.25,-21.105),(15.25,-21.275),(15.08,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-21.275),(15.59,-21.105),(15.76,-21.105),(15.76,-21.275),(15.59,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-21.275),(16.1,-21.105),(16.27,-21.105),(16.27,-21.275),(16.1,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-21.275),(16.61,-21.105),(16.78,-21.105),(16.78,-21.275),(16.61,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-21.275),(17.12,-21.105),(17.29,-21.105),(17.29,-21.275),(17.12,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-21.275),(17.63,-21.105),(17.8,-21.105),(17.8,-21.275),(17.63,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-21.275),(18.14,-21.105),(18.31,-21.105),(18.31,-21.275),(18.14,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-21.275),(18.65,-21.105),(18.82,-21.105),(18.82,-21.275),(18.65,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-21.275),(19.16,-21.105),(19.33,-21.105),(19.33,-21.275),(19.16,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-21.275),(19.67,-21.105),(19.84,-21.105),(19.84,-21.275),(19.67,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-21.275),(20.18,-21.105),(20.35,-21.105),(20.35,-21.275),(20.18,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-21.275),(20.69,-21.105),(20.86,-21.105),(20.86,-21.275),(20.69,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-21.275),(21.2,-21.105),(21.37,-21.105),(21.37,-21.275),(21.2,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-21.275),(21.71,-21.105),(21.88,-21.105),(21.88,-21.275),(21.71,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-21.275),(22.22,-21.105),(22.39,-21.105),(22.39,-21.275),(22.22,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-21.275),(22.73,-21.105),(22.9,-21.105),(22.9,-21.275),(22.73,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-21.275),(23.24,-21.105),(23.41,-21.105),(23.41,-21.275),(23.24,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-21.275),(23.75,-21.105),(23.92,-21.105),(23.92,-21.275),(23.75,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-21.275),(24.26,-21.105),(24.43,-21.105),(24.43,-21.275),(24.26,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-21.275),(24.77,-21.105),(24.94,-21.105),(24.94,-21.275),(24.77,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-21.275),(25.28,-21.105),(25.45,-21.105),(25.45,-21.275),(25.28,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-21.275),(25.79,-21.105),(25.96,-21.105),(25.96,-21.275),(25.79,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-21.275),(26.3,-21.105),(26.47,-21.105),(26.47,-21.275),(26.3,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-21.275),(26.81,-21.105),(26.98,-21.105),(26.98,-21.275),(26.81,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-21.275),(27.32,-21.105),(27.49,-21.105),(27.49,-21.275),(27.32,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-21.275),(27.83,-21.105),(28.0,-21.105),(28.0,-21.275),(27.83,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-21.275),(28.34,-21.105),(28.51,-21.105),(28.51,-21.275),(28.34,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-21.275),(28.85,-21.105),(29.02,-21.105),(29.02,-21.275),(28.85,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-21.275),(29.36,-21.105),(29.53,-21.105),(29.53,-21.275),(29.36,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-21.275),(29.87,-21.105),(30.04,-21.105),(30.04,-21.275),(29.87,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-21.275),(30.38,-21.105),(30.55,-21.105),(30.55,-21.275),(30.38,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-21.275),(30.89,-21.105),(31.06,-21.105),(31.06,-21.275),(30.89,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-21.275),(31.4,-21.105),(31.57,-21.105),(31.57,-21.275),(31.4,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-21.275),(31.91,-21.105),(32.08,-21.105),(32.08,-21.275),(31.91,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-21.275),(32.42,-21.105),(32.59,-21.105),(32.59,-21.275),(32.42,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-21.275),(32.93,-21.105),(33.1,-21.105),(33.1,-21.275),(32.93,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-21.275),(33.44,-21.105),(33.61,-21.105),(33.61,-21.275),(33.44,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-21.275),(33.95,-21.105),(34.12,-21.105),(34.12,-21.275),(33.95,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-21.275),(34.46,-21.105),(34.63,-21.105),(34.63,-21.275),(34.46,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-21.275),(34.97,-21.105),(35.14,-21.105),(35.14,-21.275),(34.97,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-21.275),(35.48,-21.105),(35.65,-21.105),(35.65,-21.275),(35.48,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-21.275),(35.99,-21.105),(36.16,-21.105),(36.16,-21.275),(35.99,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-21.275),(36.5,-21.105),(36.67,-21.105),(36.67,-21.275),(36.5,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-21.275),(37.01,-21.105),(37.18,-21.105),(37.18,-21.275),(37.01,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-21.275),(37.52,-21.105),(37.69,-21.105),(37.69,-21.275),(37.52,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-21.275),(38.03,-21.105),(38.2,-21.105),(38.2,-21.275),(38.03,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-21.275),(38.54,-21.105),(38.71,-21.105),(38.71,-21.275),(38.54,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-21.275),(39.05,-21.105),(39.22,-21.105),(39.22,-21.275),(39.05,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-21.275),(39.56,-21.105),(39.73,-21.105),(39.73,-21.275),(39.56,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-21.275),(40.07,-21.105),(40.24,-21.105),(40.24,-21.275),(40.07,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-21.275),(40.58,-21.105),(40.75,-21.105),(40.75,-21.275),(40.58,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-21.275),(41.09,-21.105),(41.26,-21.105),(41.26,-21.275),(41.09,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-21.275),(41.6,-21.105),(41.77,-21.105),(41.77,-21.275),(41.6,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-21.275),(42.11,-21.105),(42.28,-21.105),(42.28,-21.275),(42.11,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-21.275),(42.62,-21.105),(42.79,-21.105),(42.79,-21.275),(42.62,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-21.275),(43.13,-21.105),(43.3,-21.105),(43.3,-21.275),(43.13,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-21.275),(43.64,-21.105),(43.81,-21.105),(43.81,-21.275),(43.64,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-21.275),(44.15,-21.105),(44.32,-21.105),(44.32,-21.275),(44.15,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-21.275),(44.66,-21.105),(44.83,-21.105),(44.83,-21.275),(44.66,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-21.275),(45.17,-21.105),(45.34,-21.105),(45.34,-21.275),(45.17,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-21.275),(45.68,-21.105),(45.85,-21.105),(45.85,-21.275),(45.68,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-21.275),(46.19,-21.105),(46.36,-21.105),(46.36,-21.275),(46.19,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-21.275),(46.7,-21.105),(46.87,-21.105),(46.87,-21.275),(46.7,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-21.275),(47.21,-21.105),(47.38,-21.105),(47.38,-21.275),(47.21,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-21.275),(47.72,-21.105),(47.89,-21.105),(47.89,-21.275),(47.72,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-21.275),(48.23,-21.105),(48.4,-21.105),(48.4,-21.275),(48.23,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-21.275),(48.74,-21.105),(48.91,-21.105),(48.91,-21.275),(48.74,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-21.275),(49.25,-21.105),(49.42,-21.105),(49.42,-21.275),(49.25,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-21.275),(49.76,-21.105),(49.93,-21.105),(49.93,-21.275),(49.76,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-21.275),(50.27,-21.105),(50.44,-21.105),(50.44,-21.275),(50.27,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-21.275),(50.78,-21.105),(50.95,-21.105),(50.95,-21.275),(50.78,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-21.275),(51.29,-21.105),(51.46,-21.105),(51.46,-21.275),(51.29,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-21.275),(51.8,-21.105),(51.97,-21.105),(51.97,-21.275),(51.8,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-21.275),(52.31,-21.105),(52.48,-21.105),(52.48,-21.275),(52.31,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-21.275),(52.82,-21.105),(52.99,-21.105),(52.99,-21.275),(52.82,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-21.275),(53.33,-21.105),(53.5,-21.105),(53.5,-21.275),(53.33,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-21.275),(53.84,-21.105),(54.01,-21.105),(54.01,-21.275),(53.84,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-21.275),(54.35,-21.105),(54.52,-21.105),(54.52,-21.275),(54.35,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-21.275),(54.86,-21.105),(55.03,-21.105),(55.03,-21.275),(54.86,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-21.275),(55.37,-21.105),(55.54,-21.105),(55.54,-21.275),(55.37,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-21.275),(55.88,-21.105),(56.05,-21.105),(56.05,-21.275),(55.88,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-21.275),(56.39,-21.105),(56.56,-21.105),(56.56,-21.275),(56.39,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-21.275),(56.9,-21.105),(57.07,-21.105),(57.07,-21.275),(56.9,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-21.275),(57.41,-21.105),(57.58,-21.105),(57.58,-21.275),(57.41,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-21.275),(57.92,-21.105),(58.09,-21.105),(58.09,-21.275),(57.92,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-21.275),(58.43,-21.105),(58.6,-21.105),(58.6,-21.275),(58.43,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-21.275),(58.94,-21.105),(59.11,-21.105),(59.11,-21.275),(58.94,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-21.275),(59.45,-21.105),(59.62,-21.105),(59.62,-21.275),(59.45,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-21.275),(59.96,-21.105),(60.13,-21.105),(60.13,-21.275),(59.96,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-21.275),(60.47,-21.105),(60.64,-21.105),(60.64,-21.275),(60.47,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-21.275),(60.98,-21.105),(61.15,-21.105),(61.15,-21.275),(60.98,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-21.275),(61.49,-21.105),(61.66,-21.105),(61.66,-21.275),(61.49,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-21.275),(62.0,-21.105),(62.17,-21.105),(62.17,-21.275),(62.0,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-21.275),(62.51,-21.105),(62.68,-21.105),(62.68,-21.275),(62.51,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-21.275),(63.02,-21.105),(63.19,-21.105),(63.19,-21.275),(63.02,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-21.275),(63.53,-21.105),(63.7,-21.105),(63.7,-21.275),(63.53,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-21.275),(64.04,-21.105),(64.21,-21.105),(64.21,-21.275),(64.04,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-21.275),(64.55,-21.105),(64.72,-21.105),(64.72,-21.275),(64.55,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-21.275),(65.06,-21.105),(65.23,-21.105),(65.23,-21.275),(65.06,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-21.275),(65.57,-21.105),(65.74,-21.105),(65.74,-21.275),(65.57,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-21.275),(66.08,-21.105),(66.25,-21.105),(66.25,-21.275),(66.08,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-21.275),(66.59,-21.105),(66.76,-21.105),(66.76,-21.275),(66.59,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-21.275),(67.1,-21.105),(67.27,-21.105),(67.27,-21.275),(67.1,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-21.275),(67.61,-21.105),(67.78,-21.105),(67.78,-21.275),(67.61,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-21.275),(68.12,-21.105),(68.29,-21.105),(68.29,-21.275),(68.12,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-21.275),(68.63,-21.105),(68.8,-21.105),(68.8,-21.275),(68.63,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-21.275),(69.14,-21.105),(69.31,-21.105),(69.31,-21.275),(69.14,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-21.275),(69.65,-21.105),(69.82,-21.105),(69.82,-21.275),(69.65,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-21.275),(70.16,-21.105),(70.33,-21.105),(70.33,-21.275),(70.16,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-21.275),(70.67,-21.105),(70.84,-21.105),(70.84,-21.275),(70.67,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-21.275),(71.18,-21.105),(71.35,-21.105),(71.35,-21.275),(71.18,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-21.275),(71.69,-21.105),(71.86,-21.105),(71.86,-21.275),(71.69,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-21.275),(72.2,-21.105),(72.37,-21.105),(72.37,-21.275),(72.2,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-21.275),(72.71,-21.105),(72.88,-21.105),(72.88,-21.275),(72.71,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-21.275),(73.22,-21.105),(73.39,-21.105),(73.39,-21.275),(73.22,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-21.275),(73.73,-21.105),(73.9,-21.105),(73.9,-21.275),(73.73,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-21.275),(74.24,-21.105),(74.41,-21.105),(74.41,-21.275),(74.24,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-21.275),(74.75,-21.105),(74.92,-21.105),(74.92,-21.275),(74.75,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-21.275),(75.26,-21.105),(75.43,-21.105),(75.43,-21.275),(75.26,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-21.275),(75.77,-21.105),(75.94,-21.105),(75.94,-21.275),(75.77,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-21.275),(76.28,-21.105),(76.45,-21.105),(76.45,-21.275),(76.28,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-21.275),(76.79,-21.105),(76.96,-21.105),(76.96,-21.275),(76.79,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-21.275),(77.3,-21.105),(77.47,-21.105),(77.47,-21.275),(77.3,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-21.275),(77.81,-21.105),(77.98,-21.105),(77.98,-21.275),(77.81,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-21.275),(78.32,-21.105),(78.49,-21.105),(78.49,-21.275),(78.32,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-21.275),(78.83,-21.105),(79.0,-21.105),(79.0,-21.275),(78.83,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-21.275),(79.34,-21.105),(79.51,-21.105),(79.51,-21.275),(79.34,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-21.275),(79.85,-21.105),(80.02,-21.105),(80.02,-21.275),(79.85,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-21.275),(80.36,-21.105),(80.53,-21.105),(80.53,-21.275),(80.36,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-21.275),(80.87,-21.105),(81.04,-21.105),(81.04,-21.275),(80.87,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-21.275),(81.38,-21.105),(81.55,-21.105),(81.55,-21.275),(81.38,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-21.275),(81.89,-21.105),(82.06,-21.105),(82.06,-21.275),(81.89,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-21.275),(82.4,-21.105),(82.57,-21.105),(82.57,-21.275),(82.4,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-21.275),(82.91,-21.105),(83.08,-21.105),(83.08,-21.275),(82.91,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-21.275),(83.42,-21.105),(83.59,-21.105),(83.59,-21.275),(83.42,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-21.275),(83.93,-21.105),(84.1,-21.105),(84.1,-21.275),(83.93,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-21.275),(84.44,-21.105),(84.61,-21.105),(84.61,-21.275),(84.44,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-21.275),(84.95,-21.105),(85.12,-21.105),(85.12,-21.275),(84.95,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-21.275),(85.46,-21.105),(85.63,-21.105),(85.63,-21.275),(85.46,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-21.275),(85.97,-21.105),(86.14,-21.105),(86.14,-21.275),(85.97,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-21.275),(86.48,-21.105),(86.65,-21.105),(86.65,-21.275),(86.48,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-21.275),(86.99,-21.105),(87.16,-21.105),(87.16,-21.275),(86.99,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-21.275),(87.5,-21.105),(87.67,-21.105),(87.67,-21.275),(87.5,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-21.275),(88.01,-21.105),(88.18,-21.105),(88.18,-21.275),(88.01,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-21.275),(88.52,-21.105),(88.69,-21.105),(88.69,-21.275),(88.52,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-21.275),(89.03,-21.105),(89.2,-21.105),(89.2,-21.275),(89.03,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-21.275),(89.54,-21.105),(89.71,-21.105),(89.71,-21.275),(89.54,-21.275)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-20.765),(0.29,-20.595),(0.46,-20.595),(0.46,-20.765),(0.29,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-20.765),(0.8,-20.595),(0.97,-20.595),(0.97,-20.765),(0.8,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-20.765),(1.31,-20.595),(1.48,-20.595),(1.48,-20.765),(1.31,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-20.765),(1.82,-20.595),(1.99,-20.595),(1.99,-20.765),(1.82,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-20.765),(2.33,-20.595),(2.5,-20.595),(2.5,-20.765),(2.33,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-20.765),(2.84,-20.595),(3.01,-20.595),(3.01,-20.765),(2.84,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-20.765),(3.35,-20.595),(3.52,-20.595),(3.52,-20.765),(3.35,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-20.765),(3.86,-20.595),(4.03,-20.595),(4.03,-20.765),(3.86,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-20.765),(4.37,-20.595),(4.54,-20.595),(4.54,-20.765),(4.37,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-20.765),(4.88,-20.595),(5.05,-20.595),(5.05,-20.765),(4.88,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-20.765),(5.39,-20.595),(5.56,-20.595),(5.56,-20.765),(5.39,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-20.765),(5.9,-20.595),(6.07,-20.595),(6.07,-20.765),(5.9,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-20.765),(6.41,-20.595),(6.58,-20.595),(6.58,-20.765),(6.41,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-20.765),(6.92,-20.595),(7.09,-20.595),(7.09,-20.765),(6.92,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-20.765),(7.43,-20.595),(7.6,-20.595),(7.6,-20.765),(7.43,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-20.765),(7.94,-20.595),(8.11,-20.595),(8.11,-20.765),(7.94,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-20.765),(8.45,-20.595),(8.62,-20.595),(8.62,-20.765),(8.45,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-20.765),(8.96,-20.595),(9.13,-20.595),(9.13,-20.765),(8.96,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-20.765),(9.47,-20.595),(9.64,-20.595),(9.64,-20.765),(9.47,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-20.765),(9.98,-20.595),(10.15,-20.595),(10.15,-20.765),(9.98,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-20.765),(10.49,-20.595),(10.66,-20.595),(10.66,-20.765),(10.49,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-20.765),(11.0,-20.595),(11.17,-20.595),(11.17,-20.765),(11.0,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-20.765),(11.51,-20.595),(11.68,-20.595),(11.68,-20.765),(11.51,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-20.765),(12.02,-20.595),(12.19,-20.595),(12.19,-20.765),(12.02,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-20.765),(12.53,-20.595),(12.7,-20.595),(12.7,-20.765),(12.53,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-20.765),(13.04,-20.595),(13.21,-20.595),(13.21,-20.765),(13.04,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-20.765),(13.55,-20.595),(13.72,-20.595),(13.72,-20.765),(13.55,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-20.765),(14.06,-20.595),(14.23,-20.595),(14.23,-20.765),(14.06,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-20.765),(14.57,-20.595),(14.74,-20.595),(14.74,-20.765),(14.57,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-20.765),(15.08,-20.595),(15.25,-20.595),(15.25,-20.765),(15.08,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-20.765),(15.59,-20.595),(15.76,-20.595),(15.76,-20.765),(15.59,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-20.765),(16.1,-20.595),(16.27,-20.595),(16.27,-20.765),(16.1,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-20.765),(16.61,-20.595),(16.78,-20.595),(16.78,-20.765),(16.61,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-20.765),(17.12,-20.595),(17.29,-20.595),(17.29,-20.765),(17.12,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-20.765),(17.63,-20.595),(17.8,-20.595),(17.8,-20.765),(17.63,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-20.765),(18.14,-20.595),(18.31,-20.595),(18.31,-20.765),(18.14,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-20.765),(18.65,-20.595),(18.82,-20.595),(18.82,-20.765),(18.65,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-20.765),(19.16,-20.595),(19.33,-20.595),(19.33,-20.765),(19.16,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-20.765),(19.67,-20.595),(19.84,-20.595),(19.84,-20.765),(19.67,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-20.765),(20.18,-20.595),(20.35,-20.595),(20.35,-20.765),(20.18,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-20.765),(20.69,-20.595),(20.86,-20.595),(20.86,-20.765),(20.69,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-20.765),(21.2,-20.595),(21.37,-20.595),(21.37,-20.765),(21.2,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-20.765),(21.71,-20.595),(21.88,-20.595),(21.88,-20.765),(21.71,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-20.765),(22.22,-20.595),(22.39,-20.595),(22.39,-20.765),(22.22,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-20.765),(22.73,-20.595),(22.9,-20.595),(22.9,-20.765),(22.73,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-20.765),(23.24,-20.595),(23.41,-20.595),(23.41,-20.765),(23.24,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-20.765),(23.75,-20.595),(23.92,-20.595),(23.92,-20.765),(23.75,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-20.765),(24.26,-20.595),(24.43,-20.595),(24.43,-20.765),(24.26,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-20.765),(24.77,-20.595),(24.94,-20.595),(24.94,-20.765),(24.77,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-20.765),(25.28,-20.595),(25.45,-20.595),(25.45,-20.765),(25.28,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-20.765),(25.79,-20.595),(25.96,-20.595),(25.96,-20.765),(25.79,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-20.765),(26.3,-20.595),(26.47,-20.595),(26.47,-20.765),(26.3,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-20.765),(26.81,-20.595),(26.98,-20.595),(26.98,-20.765),(26.81,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-20.765),(27.32,-20.595),(27.49,-20.595),(27.49,-20.765),(27.32,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-20.765),(27.83,-20.595),(28.0,-20.595),(28.0,-20.765),(27.83,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-20.765),(28.34,-20.595),(28.51,-20.595),(28.51,-20.765),(28.34,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-20.765),(28.85,-20.595),(29.02,-20.595),(29.02,-20.765),(28.85,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-20.765),(29.36,-20.595),(29.53,-20.595),(29.53,-20.765),(29.36,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-20.765),(29.87,-20.595),(30.04,-20.595),(30.04,-20.765),(29.87,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-20.765),(30.38,-20.595),(30.55,-20.595),(30.55,-20.765),(30.38,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-20.765),(30.89,-20.595),(31.06,-20.595),(31.06,-20.765),(30.89,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-20.765),(31.4,-20.595),(31.57,-20.595),(31.57,-20.765),(31.4,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-20.765),(31.91,-20.595),(32.08,-20.595),(32.08,-20.765),(31.91,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-20.765),(32.42,-20.595),(32.59,-20.595),(32.59,-20.765),(32.42,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-20.765),(32.93,-20.595),(33.1,-20.595),(33.1,-20.765),(32.93,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-20.765),(33.44,-20.595),(33.61,-20.595),(33.61,-20.765),(33.44,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-20.765),(33.95,-20.595),(34.12,-20.595),(34.12,-20.765),(33.95,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-20.765),(34.46,-20.595),(34.63,-20.595),(34.63,-20.765),(34.46,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-20.765),(34.97,-20.595),(35.14,-20.595),(35.14,-20.765),(34.97,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-20.765),(35.48,-20.595),(35.65,-20.595),(35.65,-20.765),(35.48,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-20.765),(35.99,-20.595),(36.16,-20.595),(36.16,-20.765),(35.99,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-20.765),(36.5,-20.595),(36.67,-20.595),(36.67,-20.765),(36.5,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-20.765),(37.01,-20.595),(37.18,-20.595),(37.18,-20.765),(37.01,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-20.765),(37.52,-20.595),(37.69,-20.595),(37.69,-20.765),(37.52,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-20.765),(38.03,-20.595),(38.2,-20.595),(38.2,-20.765),(38.03,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-20.765),(38.54,-20.595),(38.71,-20.595),(38.71,-20.765),(38.54,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-20.765),(39.05,-20.595),(39.22,-20.595),(39.22,-20.765),(39.05,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-20.765),(39.56,-20.595),(39.73,-20.595),(39.73,-20.765),(39.56,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-20.765),(40.07,-20.595),(40.24,-20.595),(40.24,-20.765),(40.07,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-20.765),(40.58,-20.595),(40.75,-20.595),(40.75,-20.765),(40.58,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-20.765),(41.09,-20.595),(41.26,-20.595),(41.26,-20.765),(41.09,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-20.765),(41.6,-20.595),(41.77,-20.595),(41.77,-20.765),(41.6,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-20.765),(42.11,-20.595),(42.28,-20.595),(42.28,-20.765),(42.11,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-20.765),(42.62,-20.595),(42.79,-20.595),(42.79,-20.765),(42.62,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-20.765),(43.13,-20.595),(43.3,-20.595),(43.3,-20.765),(43.13,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-20.765),(43.64,-20.595),(43.81,-20.595),(43.81,-20.765),(43.64,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-20.765),(44.15,-20.595),(44.32,-20.595),(44.32,-20.765),(44.15,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-20.765),(44.66,-20.595),(44.83,-20.595),(44.83,-20.765),(44.66,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-20.765),(45.17,-20.595),(45.34,-20.595),(45.34,-20.765),(45.17,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-20.765),(45.68,-20.595),(45.85,-20.595),(45.85,-20.765),(45.68,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-20.765),(46.19,-20.595),(46.36,-20.595),(46.36,-20.765),(46.19,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-20.765),(46.7,-20.595),(46.87,-20.595),(46.87,-20.765),(46.7,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-20.765),(47.21,-20.595),(47.38,-20.595),(47.38,-20.765),(47.21,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-20.765),(47.72,-20.595),(47.89,-20.595),(47.89,-20.765),(47.72,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-20.765),(48.23,-20.595),(48.4,-20.595),(48.4,-20.765),(48.23,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-20.765),(48.74,-20.595),(48.91,-20.595),(48.91,-20.765),(48.74,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-20.765),(49.25,-20.595),(49.42,-20.595),(49.42,-20.765),(49.25,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-20.765),(49.76,-20.595),(49.93,-20.595),(49.93,-20.765),(49.76,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-20.765),(50.27,-20.595),(50.44,-20.595),(50.44,-20.765),(50.27,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-20.765),(50.78,-20.595),(50.95,-20.595),(50.95,-20.765),(50.78,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-20.765),(51.29,-20.595),(51.46,-20.595),(51.46,-20.765),(51.29,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-20.765),(51.8,-20.595),(51.97,-20.595),(51.97,-20.765),(51.8,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-20.765),(52.31,-20.595),(52.48,-20.595),(52.48,-20.765),(52.31,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-20.765),(52.82,-20.595),(52.99,-20.595),(52.99,-20.765),(52.82,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-20.765),(53.33,-20.595),(53.5,-20.595),(53.5,-20.765),(53.33,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-20.765),(53.84,-20.595),(54.01,-20.595),(54.01,-20.765),(53.84,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-20.765),(54.35,-20.595),(54.52,-20.595),(54.52,-20.765),(54.35,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-20.765),(54.86,-20.595),(55.03,-20.595),(55.03,-20.765),(54.86,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-20.765),(55.37,-20.595),(55.54,-20.595),(55.54,-20.765),(55.37,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-20.765),(55.88,-20.595),(56.05,-20.595),(56.05,-20.765),(55.88,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-20.765),(56.39,-20.595),(56.56,-20.595),(56.56,-20.765),(56.39,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-20.765),(56.9,-20.595),(57.07,-20.595),(57.07,-20.765),(56.9,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-20.765),(57.41,-20.595),(57.58,-20.595),(57.58,-20.765),(57.41,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-20.765),(57.92,-20.595),(58.09,-20.595),(58.09,-20.765),(57.92,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-20.765),(58.43,-20.595),(58.6,-20.595),(58.6,-20.765),(58.43,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-20.765),(58.94,-20.595),(59.11,-20.595),(59.11,-20.765),(58.94,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-20.765),(59.45,-20.595),(59.62,-20.595),(59.62,-20.765),(59.45,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-20.765),(59.96,-20.595),(60.13,-20.595),(60.13,-20.765),(59.96,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-20.765),(60.47,-20.595),(60.64,-20.595),(60.64,-20.765),(60.47,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-20.765),(60.98,-20.595),(61.15,-20.595),(61.15,-20.765),(60.98,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-20.765),(61.49,-20.595),(61.66,-20.595),(61.66,-20.765),(61.49,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-20.765),(62.0,-20.595),(62.17,-20.595),(62.17,-20.765),(62.0,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-20.765),(62.51,-20.595),(62.68,-20.595),(62.68,-20.765),(62.51,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-20.765),(63.02,-20.595),(63.19,-20.595),(63.19,-20.765),(63.02,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-20.765),(63.53,-20.595),(63.7,-20.595),(63.7,-20.765),(63.53,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-20.765),(64.04,-20.595),(64.21,-20.595),(64.21,-20.765),(64.04,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-20.765),(64.55,-20.595),(64.72,-20.595),(64.72,-20.765),(64.55,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-20.765),(65.06,-20.595),(65.23,-20.595),(65.23,-20.765),(65.06,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-20.765),(65.57,-20.595),(65.74,-20.595),(65.74,-20.765),(65.57,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-20.765),(66.08,-20.595),(66.25,-20.595),(66.25,-20.765),(66.08,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-20.765),(66.59,-20.595),(66.76,-20.595),(66.76,-20.765),(66.59,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-20.765),(67.1,-20.595),(67.27,-20.595),(67.27,-20.765),(67.1,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-20.765),(67.61,-20.595),(67.78,-20.595),(67.78,-20.765),(67.61,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-20.765),(68.12,-20.595),(68.29,-20.595),(68.29,-20.765),(68.12,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-20.765),(68.63,-20.595),(68.8,-20.595),(68.8,-20.765),(68.63,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-20.765),(69.14,-20.595),(69.31,-20.595),(69.31,-20.765),(69.14,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-20.765),(69.65,-20.595),(69.82,-20.595),(69.82,-20.765),(69.65,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-20.765),(70.16,-20.595),(70.33,-20.595),(70.33,-20.765),(70.16,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-20.765),(70.67,-20.595),(70.84,-20.595),(70.84,-20.765),(70.67,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-20.765),(71.18,-20.595),(71.35,-20.595),(71.35,-20.765),(71.18,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-20.765),(71.69,-20.595),(71.86,-20.595),(71.86,-20.765),(71.69,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-20.765),(72.2,-20.595),(72.37,-20.595),(72.37,-20.765),(72.2,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-20.765),(72.71,-20.595),(72.88,-20.595),(72.88,-20.765),(72.71,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-20.765),(73.22,-20.595),(73.39,-20.595),(73.39,-20.765),(73.22,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-20.765),(73.73,-20.595),(73.9,-20.595),(73.9,-20.765),(73.73,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-20.765),(74.24,-20.595),(74.41,-20.595),(74.41,-20.765),(74.24,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-20.765),(74.75,-20.595),(74.92,-20.595),(74.92,-20.765),(74.75,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-20.765),(75.26,-20.595),(75.43,-20.595),(75.43,-20.765),(75.26,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-20.765),(75.77,-20.595),(75.94,-20.595),(75.94,-20.765),(75.77,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-20.765),(76.28,-20.595),(76.45,-20.595),(76.45,-20.765),(76.28,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-20.765),(76.79,-20.595),(76.96,-20.595),(76.96,-20.765),(76.79,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-20.765),(77.3,-20.595),(77.47,-20.595),(77.47,-20.765),(77.3,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-20.765),(77.81,-20.595),(77.98,-20.595),(77.98,-20.765),(77.81,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-20.765),(78.32,-20.595),(78.49,-20.595),(78.49,-20.765),(78.32,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-20.765),(78.83,-20.595),(79.0,-20.595),(79.0,-20.765),(78.83,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-20.765),(79.34,-20.595),(79.51,-20.595),(79.51,-20.765),(79.34,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-20.765),(79.85,-20.595),(80.02,-20.595),(80.02,-20.765),(79.85,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-20.765),(80.36,-20.595),(80.53,-20.595),(80.53,-20.765),(80.36,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-20.765),(80.87,-20.595),(81.04,-20.595),(81.04,-20.765),(80.87,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-20.765),(81.38,-20.595),(81.55,-20.595),(81.55,-20.765),(81.38,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-20.765),(81.89,-20.595),(82.06,-20.595),(82.06,-20.765),(81.89,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-20.765),(82.4,-20.595),(82.57,-20.595),(82.57,-20.765),(82.4,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-20.765),(82.91,-20.595),(83.08,-20.595),(83.08,-20.765),(82.91,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-20.765),(83.42,-20.595),(83.59,-20.595),(83.59,-20.765),(83.42,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-20.765),(83.93,-20.595),(84.1,-20.595),(84.1,-20.765),(83.93,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-20.765),(84.44,-20.595),(84.61,-20.595),(84.61,-20.765),(84.44,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-20.765),(84.95,-20.595),(85.12,-20.595),(85.12,-20.765),(84.95,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-20.765),(85.46,-20.595),(85.63,-20.595),(85.63,-20.765),(85.46,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-20.765),(85.97,-20.595),(86.14,-20.595),(86.14,-20.765),(85.97,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-20.765),(86.48,-20.595),(86.65,-20.595),(86.65,-20.765),(86.48,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-20.765),(86.99,-20.595),(87.16,-20.595),(87.16,-20.765),(86.99,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-20.765),(87.5,-20.595),(87.67,-20.595),(87.67,-20.765),(87.5,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-20.765),(88.01,-20.595),(88.18,-20.595),(88.18,-20.765),(88.01,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-20.765),(88.52,-20.595),(88.69,-20.595),(88.69,-20.765),(88.52,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-20.765),(89.03,-20.595),(89.2,-20.595),(89.2,-20.765),(89.03,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-20.765),(89.54,-20.595),(89.71,-20.595),(89.71,-20.765),(89.54,-20.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-20.255),(0.29,-20.085),(0.46,-20.085),(0.46,-20.255),(0.29,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-20.255),(0.8,-20.085),(0.97,-20.085),(0.97,-20.255),(0.8,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-20.255),(1.31,-20.085),(1.48,-20.085),(1.48,-20.255),(1.31,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-20.255),(1.82,-20.085),(1.99,-20.085),(1.99,-20.255),(1.82,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-20.255),(2.33,-20.085),(2.5,-20.085),(2.5,-20.255),(2.33,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-20.255),(2.84,-20.085),(3.01,-20.085),(3.01,-20.255),(2.84,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-20.255),(3.35,-20.085),(3.52,-20.085),(3.52,-20.255),(3.35,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-20.255),(3.86,-20.085),(4.03,-20.085),(4.03,-20.255),(3.86,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-20.255),(4.37,-20.085),(4.54,-20.085),(4.54,-20.255),(4.37,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-20.255),(4.88,-20.085),(5.05,-20.085),(5.05,-20.255),(4.88,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-20.255),(5.39,-20.085),(5.56,-20.085),(5.56,-20.255),(5.39,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-20.255),(5.9,-20.085),(6.07,-20.085),(6.07,-20.255),(5.9,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-20.255),(6.41,-20.085),(6.58,-20.085),(6.58,-20.255),(6.41,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-20.255),(6.92,-20.085),(7.09,-20.085),(7.09,-20.255),(6.92,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-20.255),(7.43,-20.085),(7.6,-20.085),(7.6,-20.255),(7.43,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-20.255),(7.94,-20.085),(8.11,-20.085),(8.11,-20.255),(7.94,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-20.255),(8.45,-20.085),(8.62,-20.085),(8.62,-20.255),(8.45,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-20.255),(8.96,-20.085),(9.13,-20.085),(9.13,-20.255),(8.96,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-20.255),(9.47,-20.085),(9.64,-20.085),(9.64,-20.255),(9.47,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-20.255),(9.98,-20.085),(10.15,-20.085),(10.15,-20.255),(9.98,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-20.255),(10.49,-20.085),(10.66,-20.085),(10.66,-20.255),(10.49,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-20.255),(11.0,-20.085),(11.17,-20.085),(11.17,-20.255),(11.0,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-20.255),(11.51,-20.085),(11.68,-20.085),(11.68,-20.255),(11.51,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-20.255),(12.02,-20.085),(12.19,-20.085),(12.19,-20.255),(12.02,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-20.255),(12.53,-20.085),(12.7,-20.085),(12.7,-20.255),(12.53,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-20.255),(13.04,-20.085),(13.21,-20.085),(13.21,-20.255),(13.04,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-20.255),(13.55,-20.085),(13.72,-20.085),(13.72,-20.255),(13.55,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-20.255),(14.06,-20.085),(14.23,-20.085),(14.23,-20.255),(14.06,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-20.255),(14.57,-20.085),(14.74,-20.085),(14.74,-20.255),(14.57,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-20.255),(15.08,-20.085),(15.25,-20.085),(15.25,-20.255),(15.08,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-20.255),(15.59,-20.085),(15.76,-20.085),(15.76,-20.255),(15.59,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-20.255),(16.1,-20.085),(16.27,-20.085),(16.27,-20.255),(16.1,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-20.255),(16.61,-20.085),(16.78,-20.085),(16.78,-20.255),(16.61,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-20.255),(17.12,-20.085),(17.29,-20.085),(17.29,-20.255),(17.12,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-20.255),(17.63,-20.085),(17.8,-20.085),(17.8,-20.255),(17.63,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-20.255),(18.14,-20.085),(18.31,-20.085),(18.31,-20.255),(18.14,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-20.255),(18.65,-20.085),(18.82,-20.085),(18.82,-20.255),(18.65,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-20.255),(19.16,-20.085),(19.33,-20.085),(19.33,-20.255),(19.16,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-20.255),(19.67,-20.085),(19.84,-20.085),(19.84,-20.255),(19.67,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-20.255),(20.18,-20.085),(20.35,-20.085),(20.35,-20.255),(20.18,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-20.255),(20.69,-20.085),(20.86,-20.085),(20.86,-20.255),(20.69,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-20.255),(21.2,-20.085),(21.37,-20.085),(21.37,-20.255),(21.2,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-20.255),(21.71,-20.085),(21.88,-20.085),(21.88,-20.255),(21.71,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-20.255),(22.22,-20.085),(22.39,-20.085),(22.39,-20.255),(22.22,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-20.255),(22.73,-20.085),(22.9,-20.085),(22.9,-20.255),(22.73,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-20.255),(23.24,-20.085),(23.41,-20.085),(23.41,-20.255),(23.24,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-20.255),(23.75,-20.085),(23.92,-20.085),(23.92,-20.255),(23.75,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-20.255),(24.26,-20.085),(24.43,-20.085),(24.43,-20.255),(24.26,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-20.255),(24.77,-20.085),(24.94,-20.085),(24.94,-20.255),(24.77,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-20.255),(25.28,-20.085),(25.45,-20.085),(25.45,-20.255),(25.28,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-20.255),(25.79,-20.085),(25.96,-20.085),(25.96,-20.255),(25.79,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-20.255),(26.3,-20.085),(26.47,-20.085),(26.47,-20.255),(26.3,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-20.255),(26.81,-20.085),(26.98,-20.085),(26.98,-20.255),(26.81,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-20.255),(27.32,-20.085),(27.49,-20.085),(27.49,-20.255),(27.32,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-20.255),(27.83,-20.085),(28.0,-20.085),(28.0,-20.255),(27.83,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-20.255),(28.34,-20.085),(28.51,-20.085),(28.51,-20.255),(28.34,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-20.255),(28.85,-20.085),(29.02,-20.085),(29.02,-20.255),(28.85,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-20.255),(29.36,-20.085),(29.53,-20.085),(29.53,-20.255),(29.36,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-20.255),(29.87,-20.085),(30.04,-20.085),(30.04,-20.255),(29.87,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-20.255),(30.38,-20.085),(30.55,-20.085),(30.55,-20.255),(30.38,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-20.255),(30.89,-20.085),(31.06,-20.085),(31.06,-20.255),(30.89,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-20.255),(31.4,-20.085),(31.57,-20.085),(31.57,-20.255),(31.4,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-20.255),(31.91,-20.085),(32.08,-20.085),(32.08,-20.255),(31.91,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-20.255),(32.42,-20.085),(32.59,-20.085),(32.59,-20.255),(32.42,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-20.255),(32.93,-20.085),(33.1,-20.085),(33.1,-20.255),(32.93,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-20.255),(33.44,-20.085),(33.61,-20.085),(33.61,-20.255),(33.44,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-20.255),(33.95,-20.085),(34.12,-20.085),(34.12,-20.255),(33.95,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-20.255),(34.46,-20.085),(34.63,-20.085),(34.63,-20.255),(34.46,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-20.255),(34.97,-20.085),(35.14,-20.085),(35.14,-20.255),(34.97,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-20.255),(35.48,-20.085),(35.65,-20.085),(35.65,-20.255),(35.48,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-20.255),(35.99,-20.085),(36.16,-20.085),(36.16,-20.255),(35.99,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-20.255),(36.5,-20.085),(36.67,-20.085),(36.67,-20.255),(36.5,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-20.255),(37.01,-20.085),(37.18,-20.085),(37.18,-20.255),(37.01,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-20.255),(37.52,-20.085),(37.69,-20.085),(37.69,-20.255),(37.52,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-20.255),(38.03,-20.085),(38.2,-20.085),(38.2,-20.255),(38.03,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-20.255),(38.54,-20.085),(38.71,-20.085),(38.71,-20.255),(38.54,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-20.255),(39.05,-20.085),(39.22,-20.085),(39.22,-20.255),(39.05,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-20.255),(39.56,-20.085),(39.73,-20.085),(39.73,-20.255),(39.56,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-20.255),(40.07,-20.085),(40.24,-20.085),(40.24,-20.255),(40.07,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-20.255),(40.58,-20.085),(40.75,-20.085),(40.75,-20.255),(40.58,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-20.255),(41.09,-20.085),(41.26,-20.085),(41.26,-20.255),(41.09,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-20.255),(41.6,-20.085),(41.77,-20.085),(41.77,-20.255),(41.6,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-20.255),(42.11,-20.085),(42.28,-20.085),(42.28,-20.255),(42.11,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-20.255),(42.62,-20.085),(42.79,-20.085),(42.79,-20.255),(42.62,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-20.255),(43.13,-20.085),(43.3,-20.085),(43.3,-20.255),(43.13,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-20.255),(43.64,-20.085),(43.81,-20.085),(43.81,-20.255),(43.64,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-20.255),(44.15,-20.085),(44.32,-20.085),(44.32,-20.255),(44.15,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-20.255),(44.66,-20.085),(44.83,-20.085),(44.83,-20.255),(44.66,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-20.255),(45.17,-20.085),(45.34,-20.085),(45.34,-20.255),(45.17,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-20.255),(45.68,-20.085),(45.85,-20.085),(45.85,-20.255),(45.68,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-20.255),(46.19,-20.085),(46.36,-20.085),(46.36,-20.255),(46.19,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-20.255),(46.7,-20.085),(46.87,-20.085),(46.87,-20.255),(46.7,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-20.255),(47.21,-20.085),(47.38,-20.085),(47.38,-20.255),(47.21,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-20.255),(47.72,-20.085),(47.89,-20.085),(47.89,-20.255),(47.72,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-20.255),(48.23,-20.085),(48.4,-20.085),(48.4,-20.255),(48.23,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-20.255),(48.74,-20.085),(48.91,-20.085),(48.91,-20.255),(48.74,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-20.255),(49.25,-20.085),(49.42,-20.085),(49.42,-20.255),(49.25,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-20.255),(49.76,-20.085),(49.93,-20.085),(49.93,-20.255),(49.76,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-20.255),(50.27,-20.085),(50.44,-20.085),(50.44,-20.255),(50.27,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-20.255),(50.78,-20.085),(50.95,-20.085),(50.95,-20.255),(50.78,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-20.255),(51.29,-20.085),(51.46,-20.085),(51.46,-20.255),(51.29,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-20.255),(51.8,-20.085),(51.97,-20.085),(51.97,-20.255),(51.8,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-20.255),(52.31,-20.085),(52.48,-20.085),(52.48,-20.255),(52.31,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-20.255),(52.82,-20.085),(52.99,-20.085),(52.99,-20.255),(52.82,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-20.255),(53.33,-20.085),(53.5,-20.085),(53.5,-20.255),(53.33,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-20.255),(53.84,-20.085),(54.01,-20.085),(54.01,-20.255),(53.84,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-20.255),(54.35,-20.085),(54.52,-20.085),(54.52,-20.255),(54.35,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-20.255),(54.86,-20.085),(55.03,-20.085),(55.03,-20.255),(54.86,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-20.255),(55.37,-20.085),(55.54,-20.085),(55.54,-20.255),(55.37,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-20.255),(55.88,-20.085),(56.05,-20.085),(56.05,-20.255),(55.88,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-20.255),(56.39,-20.085),(56.56,-20.085),(56.56,-20.255),(56.39,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-20.255),(56.9,-20.085),(57.07,-20.085),(57.07,-20.255),(56.9,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-20.255),(57.41,-20.085),(57.58,-20.085),(57.58,-20.255),(57.41,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-20.255),(57.92,-20.085),(58.09,-20.085),(58.09,-20.255),(57.92,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-20.255),(58.43,-20.085),(58.6,-20.085),(58.6,-20.255),(58.43,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-20.255),(58.94,-20.085),(59.11,-20.085),(59.11,-20.255),(58.94,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-20.255),(59.45,-20.085),(59.62,-20.085),(59.62,-20.255),(59.45,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-20.255),(59.96,-20.085),(60.13,-20.085),(60.13,-20.255),(59.96,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-20.255),(60.47,-20.085),(60.64,-20.085),(60.64,-20.255),(60.47,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-20.255),(60.98,-20.085),(61.15,-20.085),(61.15,-20.255),(60.98,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-20.255),(61.49,-20.085),(61.66,-20.085),(61.66,-20.255),(61.49,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-20.255),(62.0,-20.085),(62.17,-20.085),(62.17,-20.255),(62.0,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-20.255),(62.51,-20.085),(62.68,-20.085),(62.68,-20.255),(62.51,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-20.255),(63.02,-20.085),(63.19,-20.085),(63.19,-20.255),(63.02,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-20.255),(63.53,-20.085),(63.7,-20.085),(63.7,-20.255),(63.53,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-20.255),(64.04,-20.085),(64.21,-20.085),(64.21,-20.255),(64.04,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-20.255),(64.55,-20.085),(64.72,-20.085),(64.72,-20.255),(64.55,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-20.255),(65.06,-20.085),(65.23,-20.085),(65.23,-20.255),(65.06,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-20.255),(65.57,-20.085),(65.74,-20.085),(65.74,-20.255),(65.57,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-20.255),(66.08,-20.085),(66.25,-20.085),(66.25,-20.255),(66.08,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-20.255),(66.59,-20.085),(66.76,-20.085),(66.76,-20.255),(66.59,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-20.255),(67.1,-20.085),(67.27,-20.085),(67.27,-20.255),(67.1,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-20.255),(67.61,-20.085),(67.78,-20.085),(67.78,-20.255),(67.61,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-20.255),(68.12,-20.085),(68.29,-20.085),(68.29,-20.255),(68.12,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-20.255),(68.63,-20.085),(68.8,-20.085),(68.8,-20.255),(68.63,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-20.255),(69.14,-20.085),(69.31,-20.085),(69.31,-20.255),(69.14,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-20.255),(69.65,-20.085),(69.82,-20.085),(69.82,-20.255),(69.65,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-20.255),(70.16,-20.085),(70.33,-20.085),(70.33,-20.255),(70.16,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-20.255),(70.67,-20.085),(70.84,-20.085),(70.84,-20.255),(70.67,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-20.255),(71.18,-20.085),(71.35,-20.085),(71.35,-20.255),(71.18,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-20.255),(71.69,-20.085),(71.86,-20.085),(71.86,-20.255),(71.69,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-20.255),(72.2,-20.085),(72.37,-20.085),(72.37,-20.255),(72.2,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-20.255),(72.71,-20.085),(72.88,-20.085),(72.88,-20.255),(72.71,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-20.255),(73.22,-20.085),(73.39,-20.085),(73.39,-20.255),(73.22,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-20.255),(73.73,-20.085),(73.9,-20.085),(73.9,-20.255),(73.73,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-20.255),(74.24,-20.085),(74.41,-20.085),(74.41,-20.255),(74.24,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-20.255),(74.75,-20.085),(74.92,-20.085),(74.92,-20.255),(74.75,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-20.255),(75.26,-20.085),(75.43,-20.085),(75.43,-20.255),(75.26,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-20.255),(75.77,-20.085),(75.94,-20.085),(75.94,-20.255),(75.77,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-20.255),(76.28,-20.085),(76.45,-20.085),(76.45,-20.255),(76.28,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-20.255),(76.79,-20.085),(76.96,-20.085),(76.96,-20.255),(76.79,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-20.255),(77.3,-20.085),(77.47,-20.085),(77.47,-20.255),(77.3,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-20.255),(77.81,-20.085),(77.98,-20.085),(77.98,-20.255),(77.81,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-20.255),(78.32,-20.085),(78.49,-20.085),(78.49,-20.255),(78.32,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-20.255),(78.83,-20.085),(79.0,-20.085),(79.0,-20.255),(78.83,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-20.255),(79.34,-20.085),(79.51,-20.085),(79.51,-20.255),(79.34,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-20.255),(79.85,-20.085),(80.02,-20.085),(80.02,-20.255),(79.85,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-20.255),(80.36,-20.085),(80.53,-20.085),(80.53,-20.255),(80.36,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-20.255),(80.87,-20.085),(81.04,-20.085),(81.04,-20.255),(80.87,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-20.255),(81.38,-20.085),(81.55,-20.085),(81.55,-20.255),(81.38,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-20.255),(81.89,-20.085),(82.06,-20.085),(82.06,-20.255),(81.89,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-20.255),(82.4,-20.085),(82.57,-20.085),(82.57,-20.255),(82.4,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-20.255),(82.91,-20.085),(83.08,-20.085),(83.08,-20.255),(82.91,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-20.255),(83.42,-20.085),(83.59,-20.085),(83.59,-20.255),(83.42,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-20.255),(83.93,-20.085),(84.1,-20.085),(84.1,-20.255),(83.93,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-20.255),(84.44,-20.085),(84.61,-20.085),(84.61,-20.255),(84.44,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-20.255),(84.95,-20.085),(85.12,-20.085),(85.12,-20.255),(84.95,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-20.255),(85.46,-20.085),(85.63,-20.085),(85.63,-20.255),(85.46,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-20.255),(85.97,-20.085),(86.14,-20.085),(86.14,-20.255),(85.97,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-20.255),(86.48,-20.085),(86.65,-20.085),(86.65,-20.255),(86.48,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-20.255),(86.99,-20.085),(87.16,-20.085),(87.16,-20.255),(86.99,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-20.255),(87.5,-20.085),(87.67,-20.085),(87.67,-20.255),(87.5,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-20.255),(88.01,-20.085),(88.18,-20.085),(88.18,-20.255),(88.01,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-20.255),(88.52,-20.085),(88.69,-20.085),(88.69,-20.255),(88.52,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-20.255),(89.03,-20.085),(89.2,-20.085),(89.2,-20.255),(89.03,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-20.255),(89.54,-20.085),(89.71,-20.085),(89.71,-20.255),(89.54,-20.255)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-19.745),(0.29,-19.575),(0.46,-19.575),(0.46,-19.745),(0.29,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-19.745),(0.8,-19.575),(0.97,-19.575),(0.97,-19.745),(0.8,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-19.745),(1.31,-19.575),(1.48,-19.575),(1.48,-19.745),(1.31,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-19.745),(1.82,-19.575),(1.99,-19.575),(1.99,-19.745),(1.82,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-19.745),(2.33,-19.575),(2.5,-19.575),(2.5,-19.745),(2.33,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-19.745),(2.84,-19.575),(3.01,-19.575),(3.01,-19.745),(2.84,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-19.745),(3.35,-19.575),(3.52,-19.575),(3.52,-19.745),(3.35,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-19.745),(3.86,-19.575),(4.03,-19.575),(4.03,-19.745),(3.86,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-19.745),(4.37,-19.575),(4.54,-19.575),(4.54,-19.745),(4.37,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-19.745),(4.88,-19.575),(5.05,-19.575),(5.05,-19.745),(4.88,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-19.745),(5.39,-19.575),(5.56,-19.575),(5.56,-19.745),(5.39,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-19.745),(5.9,-19.575),(6.07,-19.575),(6.07,-19.745),(5.9,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-19.745),(6.41,-19.575),(6.58,-19.575),(6.58,-19.745),(6.41,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-19.745),(6.92,-19.575),(7.09,-19.575),(7.09,-19.745),(6.92,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-19.745),(7.43,-19.575),(7.6,-19.575),(7.6,-19.745),(7.43,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-19.745),(7.94,-19.575),(8.11,-19.575),(8.11,-19.745),(7.94,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-19.745),(8.45,-19.575),(8.62,-19.575),(8.62,-19.745),(8.45,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-19.745),(8.96,-19.575),(9.13,-19.575),(9.13,-19.745),(8.96,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-19.745),(9.47,-19.575),(9.64,-19.575),(9.64,-19.745),(9.47,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-19.745),(9.98,-19.575),(10.15,-19.575),(10.15,-19.745),(9.98,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-19.745),(10.49,-19.575),(10.66,-19.575),(10.66,-19.745),(10.49,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-19.745),(11.0,-19.575),(11.17,-19.575),(11.17,-19.745),(11.0,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-19.745),(11.51,-19.575),(11.68,-19.575),(11.68,-19.745),(11.51,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-19.745),(12.02,-19.575),(12.19,-19.575),(12.19,-19.745),(12.02,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-19.745),(12.53,-19.575),(12.7,-19.575),(12.7,-19.745),(12.53,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-19.745),(13.04,-19.575),(13.21,-19.575),(13.21,-19.745),(13.04,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-19.745),(13.55,-19.575),(13.72,-19.575),(13.72,-19.745),(13.55,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-19.745),(14.06,-19.575),(14.23,-19.575),(14.23,-19.745),(14.06,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-19.745),(14.57,-19.575),(14.74,-19.575),(14.74,-19.745),(14.57,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-19.745),(15.08,-19.575),(15.25,-19.575),(15.25,-19.745),(15.08,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-19.745),(15.59,-19.575),(15.76,-19.575),(15.76,-19.745),(15.59,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-19.745),(16.1,-19.575),(16.27,-19.575),(16.27,-19.745),(16.1,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-19.745),(16.61,-19.575),(16.78,-19.575),(16.78,-19.745),(16.61,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-19.745),(17.12,-19.575),(17.29,-19.575),(17.29,-19.745),(17.12,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-19.745),(17.63,-19.575),(17.8,-19.575),(17.8,-19.745),(17.63,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-19.745),(18.14,-19.575),(18.31,-19.575),(18.31,-19.745),(18.14,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-19.745),(18.65,-19.575),(18.82,-19.575),(18.82,-19.745),(18.65,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-19.745),(19.16,-19.575),(19.33,-19.575),(19.33,-19.745),(19.16,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-19.745),(19.67,-19.575),(19.84,-19.575),(19.84,-19.745),(19.67,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-19.745),(20.18,-19.575),(20.35,-19.575),(20.35,-19.745),(20.18,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-19.745),(20.69,-19.575),(20.86,-19.575),(20.86,-19.745),(20.69,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-19.745),(21.2,-19.575),(21.37,-19.575),(21.37,-19.745),(21.2,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-19.745),(21.71,-19.575),(21.88,-19.575),(21.88,-19.745),(21.71,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-19.745),(22.22,-19.575),(22.39,-19.575),(22.39,-19.745),(22.22,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-19.745),(22.73,-19.575),(22.9,-19.575),(22.9,-19.745),(22.73,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-19.745),(23.24,-19.575),(23.41,-19.575),(23.41,-19.745),(23.24,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-19.745),(23.75,-19.575),(23.92,-19.575),(23.92,-19.745),(23.75,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-19.745),(24.26,-19.575),(24.43,-19.575),(24.43,-19.745),(24.26,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-19.745),(24.77,-19.575),(24.94,-19.575),(24.94,-19.745),(24.77,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-19.745),(25.28,-19.575),(25.45,-19.575),(25.45,-19.745),(25.28,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-19.745),(25.79,-19.575),(25.96,-19.575),(25.96,-19.745),(25.79,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-19.745),(26.3,-19.575),(26.47,-19.575),(26.47,-19.745),(26.3,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-19.745),(26.81,-19.575),(26.98,-19.575),(26.98,-19.745),(26.81,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-19.745),(27.32,-19.575),(27.49,-19.575),(27.49,-19.745),(27.32,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-19.745),(27.83,-19.575),(28.0,-19.575),(28.0,-19.745),(27.83,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-19.745),(28.34,-19.575),(28.51,-19.575),(28.51,-19.745),(28.34,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-19.745),(28.85,-19.575),(29.02,-19.575),(29.02,-19.745),(28.85,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-19.745),(29.36,-19.575),(29.53,-19.575),(29.53,-19.745),(29.36,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-19.745),(29.87,-19.575),(30.04,-19.575),(30.04,-19.745),(29.87,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-19.745),(30.38,-19.575),(30.55,-19.575),(30.55,-19.745),(30.38,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-19.745),(30.89,-19.575),(31.06,-19.575),(31.06,-19.745),(30.89,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-19.745),(31.4,-19.575),(31.57,-19.575),(31.57,-19.745),(31.4,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-19.745),(31.91,-19.575),(32.08,-19.575),(32.08,-19.745),(31.91,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-19.745),(32.42,-19.575),(32.59,-19.575),(32.59,-19.745),(32.42,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-19.745),(32.93,-19.575),(33.1,-19.575),(33.1,-19.745),(32.93,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-19.745),(33.44,-19.575),(33.61,-19.575),(33.61,-19.745),(33.44,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-19.745),(33.95,-19.575),(34.12,-19.575),(34.12,-19.745),(33.95,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-19.745),(34.46,-19.575),(34.63,-19.575),(34.63,-19.745),(34.46,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-19.745),(34.97,-19.575),(35.14,-19.575),(35.14,-19.745),(34.97,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-19.745),(35.48,-19.575),(35.65,-19.575),(35.65,-19.745),(35.48,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-19.745),(35.99,-19.575),(36.16,-19.575),(36.16,-19.745),(35.99,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-19.745),(36.5,-19.575),(36.67,-19.575),(36.67,-19.745),(36.5,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-19.745),(37.01,-19.575),(37.18,-19.575),(37.18,-19.745),(37.01,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-19.745),(37.52,-19.575),(37.69,-19.575),(37.69,-19.745),(37.52,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-19.745),(38.03,-19.575),(38.2,-19.575),(38.2,-19.745),(38.03,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-19.745),(38.54,-19.575),(38.71,-19.575),(38.71,-19.745),(38.54,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-19.745),(39.05,-19.575),(39.22,-19.575),(39.22,-19.745),(39.05,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-19.745),(39.56,-19.575),(39.73,-19.575),(39.73,-19.745),(39.56,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-19.745),(40.07,-19.575),(40.24,-19.575),(40.24,-19.745),(40.07,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-19.745),(40.58,-19.575),(40.75,-19.575),(40.75,-19.745),(40.58,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-19.745),(41.09,-19.575),(41.26,-19.575),(41.26,-19.745),(41.09,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-19.745),(41.6,-19.575),(41.77,-19.575),(41.77,-19.745),(41.6,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-19.745),(42.11,-19.575),(42.28,-19.575),(42.28,-19.745),(42.11,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-19.745),(42.62,-19.575),(42.79,-19.575),(42.79,-19.745),(42.62,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-19.745),(43.13,-19.575),(43.3,-19.575),(43.3,-19.745),(43.13,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-19.745),(43.64,-19.575),(43.81,-19.575),(43.81,-19.745),(43.64,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-19.745),(44.15,-19.575),(44.32,-19.575),(44.32,-19.745),(44.15,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-19.745),(44.66,-19.575),(44.83,-19.575),(44.83,-19.745),(44.66,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-19.745),(45.17,-19.575),(45.34,-19.575),(45.34,-19.745),(45.17,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-19.745),(45.68,-19.575),(45.85,-19.575),(45.85,-19.745),(45.68,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-19.745),(46.19,-19.575),(46.36,-19.575),(46.36,-19.745),(46.19,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-19.745),(46.7,-19.575),(46.87,-19.575),(46.87,-19.745),(46.7,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-19.745),(47.21,-19.575),(47.38,-19.575),(47.38,-19.745),(47.21,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-19.745),(47.72,-19.575),(47.89,-19.575),(47.89,-19.745),(47.72,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-19.745),(48.23,-19.575),(48.4,-19.575),(48.4,-19.745),(48.23,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-19.745),(48.74,-19.575),(48.91,-19.575),(48.91,-19.745),(48.74,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-19.745),(49.25,-19.575),(49.42,-19.575),(49.42,-19.745),(49.25,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-19.745),(49.76,-19.575),(49.93,-19.575),(49.93,-19.745),(49.76,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-19.745),(50.27,-19.575),(50.44,-19.575),(50.44,-19.745),(50.27,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-19.745),(50.78,-19.575),(50.95,-19.575),(50.95,-19.745),(50.78,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-19.745),(51.29,-19.575),(51.46,-19.575),(51.46,-19.745),(51.29,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-19.745),(51.8,-19.575),(51.97,-19.575),(51.97,-19.745),(51.8,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-19.745),(52.31,-19.575),(52.48,-19.575),(52.48,-19.745),(52.31,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-19.745),(52.82,-19.575),(52.99,-19.575),(52.99,-19.745),(52.82,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-19.745),(53.33,-19.575),(53.5,-19.575),(53.5,-19.745),(53.33,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-19.745),(53.84,-19.575),(54.01,-19.575),(54.01,-19.745),(53.84,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-19.745),(54.35,-19.575),(54.52,-19.575),(54.52,-19.745),(54.35,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-19.745),(54.86,-19.575),(55.03,-19.575),(55.03,-19.745),(54.86,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-19.745),(55.37,-19.575),(55.54,-19.575),(55.54,-19.745),(55.37,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-19.745),(55.88,-19.575),(56.05,-19.575),(56.05,-19.745),(55.88,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-19.745),(56.39,-19.575),(56.56,-19.575),(56.56,-19.745),(56.39,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-19.745),(56.9,-19.575),(57.07,-19.575),(57.07,-19.745),(56.9,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-19.745),(57.41,-19.575),(57.58,-19.575),(57.58,-19.745),(57.41,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-19.745),(57.92,-19.575),(58.09,-19.575),(58.09,-19.745),(57.92,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-19.745),(58.43,-19.575),(58.6,-19.575),(58.6,-19.745),(58.43,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-19.745),(58.94,-19.575),(59.11,-19.575),(59.11,-19.745),(58.94,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-19.745),(59.45,-19.575),(59.62,-19.575),(59.62,-19.745),(59.45,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-19.745),(59.96,-19.575),(60.13,-19.575),(60.13,-19.745),(59.96,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-19.745),(60.47,-19.575),(60.64,-19.575),(60.64,-19.745),(60.47,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-19.745),(60.98,-19.575),(61.15,-19.575),(61.15,-19.745),(60.98,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-19.745),(61.49,-19.575),(61.66,-19.575),(61.66,-19.745),(61.49,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-19.745),(62.0,-19.575),(62.17,-19.575),(62.17,-19.745),(62.0,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-19.745),(62.51,-19.575),(62.68,-19.575),(62.68,-19.745),(62.51,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-19.745),(63.02,-19.575),(63.19,-19.575),(63.19,-19.745),(63.02,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-19.745),(63.53,-19.575),(63.7,-19.575),(63.7,-19.745),(63.53,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-19.745),(64.04,-19.575),(64.21,-19.575),(64.21,-19.745),(64.04,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-19.745),(64.55,-19.575),(64.72,-19.575),(64.72,-19.745),(64.55,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-19.745),(65.06,-19.575),(65.23,-19.575),(65.23,-19.745),(65.06,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-19.745),(65.57,-19.575),(65.74,-19.575),(65.74,-19.745),(65.57,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-19.745),(66.08,-19.575),(66.25,-19.575),(66.25,-19.745),(66.08,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-19.745),(66.59,-19.575),(66.76,-19.575),(66.76,-19.745),(66.59,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-19.745),(67.1,-19.575),(67.27,-19.575),(67.27,-19.745),(67.1,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-19.745),(67.61,-19.575),(67.78,-19.575),(67.78,-19.745),(67.61,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-19.745),(68.12,-19.575),(68.29,-19.575),(68.29,-19.745),(68.12,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-19.745),(68.63,-19.575),(68.8,-19.575),(68.8,-19.745),(68.63,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-19.745),(69.14,-19.575),(69.31,-19.575),(69.31,-19.745),(69.14,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-19.745),(69.65,-19.575),(69.82,-19.575),(69.82,-19.745),(69.65,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-19.745),(70.16,-19.575),(70.33,-19.575),(70.33,-19.745),(70.16,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-19.745),(70.67,-19.575),(70.84,-19.575),(70.84,-19.745),(70.67,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-19.745),(71.18,-19.575),(71.35,-19.575),(71.35,-19.745),(71.18,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-19.745),(71.69,-19.575),(71.86,-19.575),(71.86,-19.745),(71.69,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-19.745),(72.2,-19.575),(72.37,-19.575),(72.37,-19.745),(72.2,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-19.745),(72.71,-19.575),(72.88,-19.575),(72.88,-19.745),(72.71,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-19.745),(73.22,-19.575),(73.39,-19.575),(73.39,-19.745),(73.22,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-19.745),(73.73,-19.575),(73.9,-19.575),(73.9,-19.745),(73.73,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-19.745),(74.24,-19.575),(74.41,-19.575),(74.41,-19.745),(74.24,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-19.745),(74.75,-19.575),(74.92,-19.575),(74.92,-19.745),(74.75,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-19.745),(75.26,-19.575),(75.43,-19.575),(75.43,-19.745),(75.26,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-19.745),(75.77,-19.575),(75.94,-19.575),(75.94,-19.745),(75.77,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-19.745),(76.28,-19.575),(76.45,-19.575),(76.45,-19.745),(76.28,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-19.745),(76.79,-19.575),(76.96,-19.575),(76.96,-19.745),(76.79,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-19.745),(77.3,-19.575),(77.47,-19.575),(77.47,-19.745),(77.3,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-19.745),(77.81,-19.575),(77.98,-19.575),(77.98,-19.745),(77.81,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-19.745),(78.32,-19.575),(78.49,-19.575),(78.49,-19.745),(78.32,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-19.745),(78.83,-19.575),(79.0,-19.575),(79.0,-19.745),(78.83,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-19.745),(79.34,-19.575),(79.51,-19.575),(79.51,-19.745),(79.34,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-19.745),(79.85,-19.575),(80.02,-19.575),(80.02,-19.745),(79.85,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-19.745),(80.36,-19.575),(80.53,-19.575),(80.53,-19.745),(80.36,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-19.745),(80.87,-19.575),(81.04,-19.575),(81.04,-19.745),(80.87,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-19.745),(81.38,-19.575),(81.55,-19.575),(81.55,-19.745),(81.38,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-19.745),(81.89,-19.575),(82.06,-19.575),(82.06,-19.745),(81.89,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-19.745),(82.4,-19.575),(82.57,-19.575),(82.57,-19.745),(82.4,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-19.745),(82.91,-19.575),(83.08,-19.575),(83.08,-19.745),(82.91,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-19.745),(83.42,-19.575),(83.59,-19.575),(83.59,-19.745),(83.42,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-19.745),(83.93,-19.575),(84.1,-19.575),(84.1,-19.745),(83.93,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-19.745),(84.44,-19.575),(84.61,-19.575),(84.61,-19.745),(84.44,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-19.745),(84.95,-19.575),(85.12,-19.575),(85.12,-19.745),(84.95,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-19.745),(85.46,-19.575),(85.63,-19.575),(85.63,-19.745),(85.46,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-19.745),(85.97,-19.575),(86.14,-19.575),(86.14,-19.745),(85.97,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-19.745),(86.48,-19.575),(86.65,-19.575),(86.65,-19.745),(86.48,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-19.745),(86.99,-19.575),(87.16,-19.575),(87.16,-19.745),(86.99,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-19.745),(87.5,-19.575),(87.67,-19.575),(87.67,-19.745),(87.5,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-19.745),(88.01,-19.575),(88.18,-19.575),(88.18,-19.745),(88.01,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-19.745),(88.52,-19.575),(88.69,-19.575),(88.69,-19.745),(88.52,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-19.745),(89.03,-19.575),(89.2,-19.575),(89.2,-19.745),(89.03,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-19.745),(89.54,-19.575),(89.71,-19.575),(89.71,-19.745),(89.54,-19.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-19.235),(0.29,-19.065),(0.46,-19.065),(0.46,-19.235),(0.29,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-19.235),(0.8,-19.065),(0.97,-19.065),(0.97,-19.235),(0.8,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-19.235),(1.31,-19.065),(1.48,-19.065),(1.48,-19.235),(1.31,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-19.235),(1.82,-19.065),(1.99,-19.065),(1.99,-19.235),(1.82,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-19.235),(2.33,-19.065),(2.5,-19.065),(2.5,-19.235),(2.33,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-19.235),(2.84,-19.065),(3.01,-19.065),(3.01,-19.235),(2.84,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-19.235),(3.35,-19.065),(3.52,-19.065),(3.52,-19.235),(3.35,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-19.235),(3.86,-19.065),(4.03,-19.065),(4.03,-19.235),(3.86,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-19.235),(4.37,-19.065),(4.54,-19.065),(4.54,-19.235),(4.37,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-19.235),(4.88,-19.065),(5.05,-19.065),(5.05,-19.235),(4.88,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-19.235),(5.39,-19.065),(5.56,-19.065),(5.56,-19.235),(5.39,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-19.235),(5.9,-19.065),(6.07,-19.065),(6.07,-19.235),(5.9,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-19.235),(6.41,-19.065),(6.58,-19.065),(6.58,-19.235),(6.41,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-19.235),(6.92,-19.065),(7.09,-19.065),(7.09,-19.235),(6.92,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-19.235),(7.43,-19.065),(7.6,-19.065),(7.6,-19.235),(7.43,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-19.235),(7.94,-19.065),(8.11,-19.065),(8.11,-19.235),(7.94,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-19.235),(8.45,-19.065),(8.62,-19.065),(8.62,-19.235),(8.45,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-19.235),(8.96,-19.065),(9.13,-19.065),(9.13,-19.235),(8.96,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-19.235),(9.47,-19.065),(9.64,-19.065),(9.64,-19.235),(9.47,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-19.235),(9.98,-19.065),(10.15,-19.065),(10.15,-19.235),(9.98,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-19.235),(10.49,-19.065),(10.66,-19.065),(10.66,-19.235),(10.49,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-19.235),(11.0,-19.065),(11.17,-19.065),(11.17,-19.235),(11.0,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-19.235),(11.51,-19.065),(11.68,-19.065),(11.68,-19.235),(11.51,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-19.235),(12.02,-19.065),(12.19,-19.065),(12.19,-19.235),(12.02,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-19.235),(12.53,-19.065),(12.7,-19.065),(12.7,-19.235),(12.53,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-19.235),(13.04,-19.065),(13.21,-19.065),(13.21,-19.235),(13.04,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-19.235),(13.55,-19.065),(13.72,-19.065),(13.72,-19.235),(13.55,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-19.235),(14.06,-19.065),(14.23,-19.065),(14.23,-19.235),(14.06,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-19.235),(14.57,-19.065),(14.74,-19.065),(14.74,-19.235),(14.57,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-19.235),(15.08,-19.065),(15.25,-19.065),(15.25,-19.235),(15.08,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-19.235),(15.59,-19.065),(15.76,-19.065),(15.76,-19.235),(15.59,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-19.235),(16.1,-19.065),(16.27,-19.065),(16.27,-19.235),(16.1,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-19.235),(16.61,-19.065),(16.78,-19.065),(16.78,-19.235),(16.61,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-19.235),(17.12,-19.065),(17.29,-19.065),(17.29,-19.235),(17.12,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-19.235),(17.63,-19.065),(17.8,-19.065),(17.8,-19.235),(17.63,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-19.235),(18.14,-19.065),(18.31,-19.065),(18.31,-19.235),(18.14,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-19.235),(18.65,-19.065),(18.82,-19.065),(18.82,-19.235),(18.65,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-19.235),(19.16,-19.065),(19.33,-19.065),(19.33,-19.235),(19.16,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-19.235),(19.67,-19.065),(19.84,-19.065),(19.84,-19.235),(19.67,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-19.235),(20.18,-19.065),(20.35,-19.065),(20.35,-19.235),(20.18,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-19.235),(20.69,-19.065),(20.86,-19.065),(20.86,-19.235),(20.69,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-19.235),(21.2,-19.065),(21.37,-19.065),(21.37,-19.235),(21.2,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-19.235),(21.71,-19.065),(21.88,-19.065),(21.88,-19.235),(21.71,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-19.235),(22.22,-19.065),(22.39,-19.065),(22.39,-19.235),(22.22,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-19.235),(22.73,-19.065),(22.9,-19.065),(22.9,-19.235),(22.73,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-19.235),(23.24,-19.065),(23.41,-19.065),(23.41,-19.235),(23.24,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-19.235),(23.75,-19.065),(23.92,-19.065),(23.92,-19.235),(23.75,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-19.235),(24.26,-19.065),(24.43,-19.065),(24.43,-19.235),(24.26,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-19.235),(24.77,-19.065),(24.94,-19.065),(24.94,-19.235),(24.77,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-19.235),(25.28,-19.065),(25.45,-19.065),(25.45,-19.235),(25.28,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-19.235),(25.79,-19.065),(25.96,-19.065),(25.96,-19.235),(25.79,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-19.235),(26.3,-19.065),(26.47,-19.065),(26.47,-19.235),(26.3,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-19.235),(26.81,-19.065),(26.98,-19.065),(26.98,-19.235),(26.81,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-19.235),(27.32,-19.065),(27.49,-19.065),(27.49,-19.235),(27.32,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-19.235),(27.83,-19.065),(28.0,-19.065),(28.0,-19.235),(27.83,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-19.235),(28.34,-19.065),(28.51,-19.065),(28.51,-19.235),(28.34,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-19.235),(28.85,-19.065),(29.02,-19.065),(29.02,-19.235),(28.85,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-19.235),(29.36,-19.065),(29.53,-19.065),(29.53,-19.235),(29.36,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-19.235),(29.87,-19.065),(30.04,-19.065),(30.04,-19.235),(29.87,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-19.235),(30.38,-19.065),(30.55,-19.065),(30.55,-19.235),(30.38,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-19.235),(30.89,-19.065),(31.06,-19.065),(31.06,-19.235),(30.89,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-19.235),(31.4,-19.065),(31.57,-19.065),(31.57,-19.235),(31.4,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-19.235),(31.91,-19.065),(32.08,-19.065),(32.08,-19.235),(31.91,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-19.235),(32.42,-19.065),(32.59,-19.065),(32.59,-19.235),(32.42,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-19.235),(32.93,-19.065),(33.1,-19.065),(33.1,-19.235),(32.93,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-19.235),(33.44,-19.065),(33.61,-19.065),(33.61,-19.235),(33.44,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-19.235),(33.95,-19.065),(34.12,-19.065),(34.12,-19.235),(33.95,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-19.235),(34.46,-19.065),(34.63,-19.065),(34.63,-19.235),(34.46,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-19.235),(34.97,-19.065),(35.14,-19.065),(35.14,-19.235),(34.97,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-19.235),(35.48,-19.065),(35.65,-19.065),(35.65,-19.235),(35.48,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-19.235),(35.99,-19.065),(36.16,-19.065),(36.16,-19.235),(35.99,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-19.235),(36.5,-19.065),(36.67,-19.065),(36.67,-19.235),(36.5,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-19.235),(37.01,-19.065),(37.18,-19.065),(37.18,-19.235),(37.01,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-19.235),(37.52,-19.065),(37.69,-19.065),(37.69,-19.235),(37.52,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-19.235),(38.03,-19.065),(38.2,-19.065),(38.2,-19.235),(38.03,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-19.235),(38.54,-19.065),(38.71,-19.065),(38.71,-19.235),(38.54,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-19.235),(39.05,-19.065),(39.22,-19.065),(39.22,-19.235),(39.05,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-19.235),(39.56,-19.065),(39.73,-19.065),(39.73,-19.235),(39.56,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-19.235),(40.07,-19.065),(40.24,-19.065),(40.24,-19.235),(40.07,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-19.235),(40.58,-19.065),(40.75,-19.065),(40.75,-19.235),(40.58,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-19.235),(41.09,-19.065),(41.26,-19.065),(41.26,-19.235),(41.09,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-19.235),(41.6,-19.065),(41.77,-19.065),(41.77,-19.235),(41.6,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-19.235),(42.11,-19.065),(42.28,-19.065),(42.28,-19.235),(42.11,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-19.235),(42.62,-19.065),(42.79,-19.065),(42.79,-19.235),(42.62,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-19.235),(43.13,-19.065),(43.3,-19.065),(43.3,-19.235),(43.13,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-19.235),(43.64,-19.065),(43.81,-19.065),(43.81,-19.235),(43.64,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-19.235),(44.15,-19.065),(44.32,-19.065),(44.32,-19.235),(44.15,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-19.235),(44.66,-19.065),(44.83,-19.065),(44.83,-19.235),(44.66,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-19.235),(45.17,-19.065),(45.34,-19.065),(45.34,-19.235),(45.17,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-19.235),(45.68,-19.065),(45.85,-19.065),(45.85,-19.235),(45.68,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-19.235),(46.19,-19.065),(46.36,-19.065),(46.36,-19.235),(46.19,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-19.235),(46.7,-19.065),(46.87,-19.065),(46.87,-19.235),(46.7,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-19.235),(47.21,-19.065),(47.38,-19.065),(47.38,-19.235),(47.21,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-19.235),(47.72,-19.065),(47.89,-19.065),(47.89,-19.235),(47.72,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-19.235),(48.23,-19.065),(48.4,-19.065),(48.4,-19.235),(48.23,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-19.235),(48.74,-19.065),(48.91,-19.065),(48.91,-19.235),(48.74,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-19.235),(49.25,-19.065),(49.42,-19.065),(49.42,-19.235),(49.25,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-19.235),(49.76,-19.065),(49.93,-19.065),(49.93,-19.235),(49.76,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-19.235),(50.27,-19.065),(50.44,-19.065),(50.44,-19.235),(50.27,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-19.235),(50.78,-19.065),(50.95,-19.065),(50.95,-19.235),(50.78,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-19.235),(51.29,-19.065),(51.46,-19.065),(51.46,-19.235),(51.29,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-19.235),(51.8,-19.065),(51.97,-19.065),(51.97,-19.235),(51.8,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-19.235),(52.31,-19.065),(52.48,-19.065),(52.48,-19.235),(52.31,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-19.235),(52.82,-19.065),(52.99,-19.065),(52.99,-19.235),(52.82,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-19.235),(53.33,-19.065),(53.5,-19.065),(53.5,-19.235),(53.33,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-19.235),(53.84,-19.065),(54.01,-19.065),(54.01,-19.235),(53.84,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-19.235),(54.35,-19.065),(54.52,-19.065),(54.52,-19.235),(54.35,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-19.235),(54.86,-19.065),(55.03,-19.065),(55.03,-19.235),(54.86,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-19.235),(55.37,-19.065),(55.54,-19.065),(55.54,-19.235),(55.37,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-19.235),(55.88,-19.065),(56.05,-19.065),(56.05,-19.235),(55.88,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-19.235),(56.39,-19.065),(56.56,-19.065),(56.56,-19.235),(56.39,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-19.235),(56.9,-19.065),(57.07,-19.065),(57.07,-19.235),(56.9,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-19.235),(57.41,-19.065),(57.58,-19.065),(57.58,-19.235),(57.41,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-19.235),(57.92,-19.065),(58.09,-19.065),(58.09,-19.235),(57.92,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-19.235),(58.43,-19.065),(58.6,-19.065),(58.6,-19.235),(58.43,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-19.235),(58.94,-19.065),(59.11,-19.065),(59.11,-19.235),(58.94,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-19.235),(59.45,-19.065),(59.62,-19.065),(59.62,-19.235),(59.45,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-19.235),(59.96,-19.065),(60.13,-19.065),(60.13,-19.235),(59.96,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-19.235),(60.47,-19.065),(60.64,-19.065),(60.64,-19.235),(60.47,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-19.235),(60.98,-19.065),(61.15,-19.065),(61.15,-19.235),(60.98,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-19.235),(61.49,-19.065),(61.66,-19.065),(61.66,-19.235),(61.49,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-19.235),(62.0,-19.065),(62.17,-19.065),(62.17,-19.235),(62.0,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-19.235),(62.51,-19.065),(62.68,-19.065),(62.68,-19.235),(62.51,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-19.235),(63.02,-19.065),(63.19,-19.065),(63.19,-19.235),(63.02,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-19.235),(63.53,-19.065),(63.7,-19.065),(63.7,-19.235),(63.53,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-19.235),(64.04,-19.065),(64.21,-19.065),(64.21,-19.235),(64.04,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-19.235),(64.55,-19.065),(64.72,-19.065),(64.72,-19.235),(64.55,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-19.235),(65.06,-19.065),(65.23,-19.065),(65.23,-19.235),(65.06,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-19.235),(65.57,-19.065),(65.74,-19.065),(65.74,-19.235),(65.57,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-19.235),(66.08,-19.065),(66.25,-19.065),(66.25,-19.235),(66.08,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-19.235),(66.59,-19.065),(66.76,-19.065),(66.76,-19.235),(66.59,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-19.235),(67.1,-19.065),(67.27,-19.065),(67.27,-19.235),(67.1,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-19.235),(67.61,-19.065),(67.78,-19.065),(67.78,-19.235),(67.61,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-19.235),(68.12,-19.065),(68.29,-19.065),(68.29,-19.235),(68.12,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-19.235),(68.63,-19.065),(68.8,-19.065),(68.8,-19.235),(68.63,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-19.235),(69.14,-19.065),(69.31,-19.065),(69.31,-19.235),(69.14,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-19.235),(69.65,-19.065),(69.82,-19.065),(69.82,-19.235),(69.65,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-19.235),(70.16,-19.065),(70.33,-19.065),(70.33,-19.235),(70.16,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-19.235),(70.67,-19.065),(70.84,-19.065),(70.84,-19.235),(70.67,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-19.235),(71.18,-19.065),(71.35,-19.065),(71.35,-19.235),(71.18,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-19.235),(71.69,-19.065),(71.86,-19.065),(71.86,-19.235),(71.69,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-19.235),(72.2,-19.065),(72.37,-19.065),(72.37,-19.235),(72.2,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-19.235),(72.71,-19.065),(72.88,-19.065),(72.88,-19.235),(72.71,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-19.235),(73.22,-19.065),(73.39,-19.065),(73.39,-19.235),(73.22,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-19.235),(73.73,-19.065),(73.9,-19.065),(73.9,-19.235),(73.73,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-19.235),(74.24,-19.065),(74.41,-19.065),(74.41,-19.235),(74.24,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-19.235),(74.75,-19.065),(74.92,-19.065),(74.92,-19.235),(74.75,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-19.235),(75.26,-19.065),(75.43,-19.065),(75.43,-19.235),(75.26,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-19.235),(75.77,-19.065),(75.94,-19.065),(75.94,-19.235),(75.77,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-19.235),(76.28,-19.065),(76.45,-19.065),(76.45,-19.235),(76.28,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-19.235),(76.79,-19.065),(76.96,-19.065),(76.96,-19.235),(76.79,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-19.235),(77.3,-19.065),(77.47,-19.065),(77.47,-19.235),(77.3,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-19.235),(77.81,-19.065),(77.98,-19.065),(77.98,-19.235),(77.81,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-19.235),(78.32,-19.065),(78.49,-19.065),(78.49,-19.235),(78.32,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-19.235),(78.83,-19.065),(79.0,-19.065),(79.0,-19.235),(78.83,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-19.235),(79.34,-19.065),(79.51,-19.065),(79.51,-19.235),(79.34,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-19.235),(79.85,-19.065),(80.02,-19.065),(80.02,-19.235),(79.85,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-19.235),(80.36,-19.065),(80.53,-19.065),(80.53,-19.235),(80.36,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-19.235),(80.87,-19.065),(81.04,-19.065),(81.04,-19.235),(80.87,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-19.235),(81.38,-19.065),(81.55,-19.065),(81.55,-19.235),(81.38,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-19.235),(81.89,-19.065),(82.06,-19.065),(82.06,-19.235),(81.89,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-19.235),(82.4,-19.065),(82.57,-19.065),(82.57,-19.235),(82.4,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-19.235),(82.91,-19.065),(83.08,-19.065),(83.08,-19.235),(82.91,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-19.235),(83.42,-19.065),(83.59,-19.065),(83.59,-19.235),(83.42,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-19.235),(83.93,-19.065),(84.1,-19.065),(84.1,-19.235),(83.93,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-19.235),(84.44,-19.065),(84.61,-19.065),(84.61,-19.235),(84.44,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-19.235),(84.95,-19.065),(85.12,-19.065),(85.12,-19.235),(84.95,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-19.235),(85.46,-19.065),(85.63,-19.065),(85.63,-19.235),(85.46,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-19.235),(85.97,-19.065),(86.14,-19.065),(86.14,-19.235),(85.97,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-19.235),(86.48,-19.065),(86.65,-19.065),(86.65,-19.235),(86.48,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-19.235),(86.99,-19.065),(87.16,-19.065),(87.16,-19.235),(86.99,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-19.235),(87.5,-19.065),(87.67,-19.065),(87.67,-19.235),(87.5,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-19.235),(88.01,-19.065),(88.18,-19.065),(88.18,-19.235),(88.01,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-19.235),(88.52,-19.065),(88.69,-19.065),(88.69,-19.235),(88.52,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-19.235),(89.03,-19.065),(89.2,-19.065),(89.2,-19.235),(89.03,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-19.235),(89.54,-19.065),(89.71,-19.065),(89.71,-19.235),(89.54,-19.235)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-18.725),(0.29,-18.555),(0.46,-18.555),(0.46,-18.725),(0.29,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-18.725),(0.8,-18.555),(0.97,-18.555),(0.97,-18.725),(0.8,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-18.725),(1.31,-18.555),(1.48,-18.555),(1.48,-18.725),(1.31,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-18.725),(1.82,-18.555),(1.99,-18.555),(1.99,-18.725),(1.82,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-18.725),(2.33,-18.555),(2.5,-18.555),(2.5,-18.725),(2.33,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-18.725),(2.84,-18.555),(3.01,-18.555),(3.01,-18.725),(2.84,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-18.725),(3.35,-18.555),(3.52,-18.555),(3.52,-18.725),(3.35,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-18.725),(3.86,-18.555),(4.03,-18.555),(4.03,-18.725),(3.86,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-18.725),(4.37,-18.555),(4.54,-18.555),(4.54,-18.725),(4.37,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-18.725),(4.88,-18.555),(5.05,-18.555),(5.05,-18.725),(4.88,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-18.725),(5.39,-18.555),(5.56,-18.555),(5.56,-18.725),(5.39,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-18.725),(5.9,-18.555),(6.07,-18.555),(6.07,-18.725),(5.9,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-18.725),(6.41,-18.555),(6.58,-18.555),(6.58,-18.725),(6.41,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-18.725),(6.92,-18.555),(7.09,-18.555),(7.09,-18.725),(6.92,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-18.725),(7.43,-18.555),(7.6,-18.555),(7.6,-18.725),(7.43,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-18.725),(7.94,-18.555),(8.11,-18.555),(8.11,-18.725),(7.94,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-18.725),(8.45,-18.555),(8.62,-18.555),(8.62,-18.725),(8.45,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-18.725),(8.96,-18.555),(9.13,-18.555),(9.13,-18.725),(8.96,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-18.725),(9.47,-18.555),(9.64,-18.555),(9.64,-18.725),(9.47,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-18.725),(9.98,-18.555),(10.15,-18.555),(10.15,-18.725),(9.98,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-18.725),(10.49,-18.555),(10.66,-18.555),(10.66,-18.725),(10.49,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-18.725),(11.0,-18.555),(11.17,-18.555),(11.17,-18.725),(11.0,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-18.725),(11.51,-18.555),(11.68,-18.555),(11.68,-18.725),(11.51,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-18.725),(12.02,-18.555),(12.19,-18.555),(12.19,-18.725),(12.02,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-18.725),(12.53,-18.555),(12.7,-18.555),(12.7,-18.725),(12.53,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-18.725),(13.04,-18.555),(13.21,-18.555),(13.21,-18.725),(13.04,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-18.725),(13.55,-18.555),(13.72,-18.555),(13.72,-18.725),(13.55,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-18.725),(14.06,-18.555),(14.23,-18.555),(14.23,-18.725),(14.06,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-18.725),(14.57,-18.555),(14.74,-18.555),(14.74,-18.725),(14.57,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-18.725),(15.08,-18.555),(15.25,-18.555),(15.25,-18.725),(15.08,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-18.725),(15.59,-18.555),(15.76,-18.555),(15.76,-18.725),(15.59,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-18.725),(16.1,-18.555),(16.27,-18.555),(16.27,-18.725),(16.1,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-18.725),(16.61,-18.555),(16.78,-18.555),(16.78,-18.725),(16.61,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-18.725),(17.12,-18.555),(17.29,-18.555),(17.29,-18.725),(17.12,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-18.725),(17.63,-18.555),(17.8,-18.555),(17.8,-18.725),(17.63,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-18.725),(18.14,-18.555),(18.31,-18.555),(18.31,-18.725),(18.14,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-18.725),(18.65,-18.555),(18.82,-18.555),(18.82,-18.725),(18.65,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-18.725),(19.16,-18.555),(19.33,-18.555),(19.33,-18.725),(19.16,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-18.725),(19.67,-18.555),(19.84,-18.555),(19.84,-18.725),(19.67,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-18.725),(20.18,-18.555),(20.35,-18.555),(20.35,-18.725),(20.18,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-18.725),(20.69,-18.555),(20.86,-18.555),(20.86,-18.725),(20.69,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-18.725),(21.2,-18.555),(21.37,-18.555),(21.37,-18.725),(21.2,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-18.725),(21.71,-18.555),(21.88,-18.555),(21.88,-18.725),(21.71,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-18.725),(22.22,-18.555),(22.39,-18.555),(22.39,-18.725),(22.22,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-18.725),(22.73,-18.555),(22.9,-18.555),(22.9,-18.725),(22.73,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-18.725),(23.24,-18.555),(23.41,-18.555),(23.41,-18.725),(23.24,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-18.725),(23.75,-18.555),(23.92,-18.555),(23.92,-18.725),(23.75,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-18.725),(24.26,-18.555),(24.43,-18.555),(24.43,-18.725),(24.26,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-18.725),(24.77,-18.555),(24.94,-18.555),(24.94,-18.725),(24.77,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-18.725),(25.28,-18.555),(25.45,-18.555),(25.45,-18.725),(25.28,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-18.725),(25.79,-18.555),(25.96,-18.555),(25.96,-18.725),(25.79,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-18.725),(26.3,-18.555),(26.47,-18.555),(26.47,-18.725),(26.3,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-18.725),(26.81,-18.555),(26.98,-18.555),(26.98,-18.725),(26.81,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-18.725),(27.32,-18.555),(27.49,-18.555),(27.49,-18.725),(27.32,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-18.725),(27.83,-18.555),(28.0,-18.555),(28.0,-18.725),(27.83,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-18.725),(28.34,-18.555),(28.51,-18.555),(28.51,-18.725),(28.34,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-18.725),(28.85,-18.555),(29.02,-18.555),(29.02,-18.725),(28.85,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-18.725),(29.36,-18.555),(29.53,-18.555),(29.53,-18.725),(29.36,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-18.725),(29.87,-18.555),(30.04,-18.555),(30.04,-18.725),(29.87,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-18.725),(30.38,-18.555),(30.55,-18.555),(30.55,-18.725),(30.38,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-18.725),(30.89,-18.555),(31.06,-18.555),(31.06,-18.725),(30.89,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-18.725),(31.4,-18.555),(31.57,-18.555),(31.57,-18.725),(31.4,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-18.725),(31.91,-18.555),(32.08,-18.555),(32.08,-18.725),(31.91,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-18.725),(32.42,-18.555),(32.59,-18.555),(32.59,-18.725),(32.42,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-18.725),(32.93,-18.555),(33.1,-18.555),(33.1,-18.725),(32.93,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-18.725),(33.44,-18.555),(33.61,-18.555),(33.61,-18.725),(33.44,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-18.725),(33.95,-18.555),(34.12,-18.555),(34.12,-18.725),(33.95,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-18.725),(34.46,-18.555),(34.63,-18.555),(34.63,-18.725),(34.46,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-18.725),(34.97,-18.555),(35.14,-18.555),(35.14,-18.725),(34.97,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-18.725),(35.48,-18.555),(35.65,-18.555),(35.65,-18.725),(35.48,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-18.725),(35.99,-18.555),(36.16,-18.555),(36.16,-18.725),(35.99,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-18.725),(36.5,-18.555),(36.67,-18.555),(36.67,-18.725),(36.5,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-18.725),(37.01,-18.555),(37.18,-18.555),(37.18,-18.725),(37.01,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-18.725),(37.52,-18.555),(37.69,-18.555),(37.69,-18.725),(37.52,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-18.725),(38.03,-18.555),(38.2,-18.555),(38.2,-18.725),(38.03,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-18.725),(38.54,-18.555),(38.71,-18.555),(38.71,-18.725),(38.54,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-18.725),(39.05,-18.555),(39.22,-18.555),(39.22,-18.725),(39.05,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-18.725),(39.56,-18.555),(39.73,-18.555),(39.73,-18.725),(39.56,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-18.725),(40.07,-18.555),(40.24,-18.555),(40.24,-18.725),(40.07,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-18.725),(40.58,-18.555),(40.75,-18.555),(40.75,-18.725),(40.58,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-18.725),(41.09,-18.555),(41.26,-18.555),(41.26,-18.725),(41.09,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-18.725),(41.6,-18.555),(41.77,-18.555),(41.77,-18.725),(41.6,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-18.725),(42.11,-18.555),(42.28,-18.555),(42.28,-18.725),(42.11,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-18.725),(42.62,-18.555),(42.79,-18.555),(42.79,-18.725),(42.62,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-18.725),(43.13,-18.555),(43.3,-18.555),(43.3,-18.725),(43.13,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-18.725),(43.64,-18.555),(43.81,-18.555),(43.81,-18.725),(43.64,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-18.725),(44.15,-18.555),(44.32,-18.555),(44.32,-18.725),(44.15,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-18.725),(44.66,-18.555),(44.83,-18.555),(44.83,-18.725),(44.66,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-18.725),(45.17,-18.555),(45.34,-18.555),(45.34,-18.725),(45.17,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-18.725),(45.68,-18.555),(45.85,-18.555),(45.85,-18.725),(45.68,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-18.725),(46.19,-18.555),(46.36,-18.555),(46.36,-18.725),(46.19,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-18.725),(46.7,-18.555),(46.87,-18.555),(46.87,-18.725),(46.7,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-18.725),(47.21,-18.555),(47.38,-18.555),(47.38,-18.725),(47.21,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-18.725),(47.72,-18.555),(47.89,-18.555),(47.89,-18.725),(47.72,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-18.725),(48.23,-18.555),(48.4,-18.555),(48.4,-18.725),(48.23,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-18.725),(48.74,-18.555),(48.91,-18.555),(48.91,-18.725),(48.74,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-18.725),(49.25,-18.555),(49.42,-18.555),(49.42,-18.725),(49.25,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-18.725),(49.76,-18.555),(49.93,-18.555),(49.93,-18.725),(49.76,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-18.725),(50.27,-18.555),(50.44,-18.555),(50.44,-18.725),(50.27,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-18.725),(50.78,-18.555),(50.95,-18.555),(50.95,-18.725),(50.78,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-18.725),(51.29,-18.555),(51.46,-18.555),(51.46,-18.725),(51.29,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-18.725),(51.8,-18.555),(51.97,-18.555),(51.97,-18.725),(51.8,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-18.725),(52.31,-18.555),(52.48,-18.555),(52.48,-18.725),(52.31,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-18.725),(52.82,-18.555),(52.99,-18.555),(52.99,-18.725),(52.82,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-18.725),(53.33,-18.555),(53.5,-18.555),(53.5,-18.725),(53.33,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-18.725),(53.84,-18.555),(54.01,-18.555),(54.01,-18.725),(53.84,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-18.725),(54.35,-18.555),(54.52,-18.555),(54.52,-18.725),(54.35,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-18.725),(54.86,-18.555),(55.03,-18.555),(55.03,-18.725),(54.86,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-18.725),(55.37,-18.555),(55.54,-18.555),(55.54,-18.725),(55.37,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-18.725),(55.88,-18.555),(56.05,-18.555),(56.05,-18.725),(55.88,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-18.725),(56.39,-18.555),(56.56,-18.555),(56.56,-18.725),(56.39,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-18.725),(56.9,-18.555),(57.07,-18.555),(57.07,-18.725),(56.9,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-18.725),(57.41,-18.555),(57.58,-18.555),(57.58,-18.725),(57.41,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-18.725),(57.92,-18.555),(58.09,-18.555),(58.09,-18.725),(57.92,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-18.725),(58.43,-18.555),(58.6,-18.555),(58.6,-18.725),(58.43,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-18.725),(58.94,-18.555),(59.11,-18.555),(59.11,-18.725),(58.94,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-18.725),(59.45,-18.555),(59.62,-18.555),(59.62,-18.725),(59.45,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-18.725),(59.96,-18.555),(60.13,-18.555),(60.13,-18.725),(59.96,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-18.725),(60.47,-18.555),(60.64,-18.555),(60.64,-18.725),(60.47,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-18.725),(60.98,-18.555),(61.15,-18.555),(61.15,-18.725),(60.98,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-18.725),(61.49,-18.555),(61.66,-18.555),(61.66,-18.725),(61.49,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-18.725),(62.0,-18.555),(62.17,-18.555),(62.17,-18.725),(62.0,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-18.725),(62.51,-18.555),(62.68,-18.555),(62.68,-18.725),(62.51,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-18.725),(63.02,-18.555),(63.19,-18.555),(63.19,-18.725),(63.02,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-18.725),(63.53,-18.555),(63.7,-18.555),(63.7,-18.725),(63.53,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-18.725),(64.04,-18.555),(64.21,-18.555),(64.21,-18.725),(64.04,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-18.725),(64.55,-18.555),(64.72,-18.555),(64.72,-18.725),(64.55,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-18.725),(65.06,-18.555),(65.23,-18.555),(65.23,-18.725),(65.06,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-18.725),(65.57,-18.555),(65.74,-18.555),(65.74,-18.725),(65.57,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-18.725),(66.08,-18.555),(66.25,-18.555),(66.25,-18.725),(66.08,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-18.725),(66.59,-18.555),(66.76,-18.555),(66.76,-18.725),(66.59,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-18.725),(67.1,-18.555),(67.27,-18.555),(67.27,-18.725),(67.1,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-18.725),(67.61,-18.555),(67.78,-18.555),(67.78,-18.725),(67.61,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-18.725),(68.12,-18.555),(68.29,-18.555),(68.29,-18.725),(68.12,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-18.725),(68.63,-18.555),(68.8,-18.555),(68.8,-18.725),(68.63,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-18.725),(69.14,-18.555),(69.31,-18.555),(69.31,-18.725),(69.14,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-18.725),(69.65,-18.555),(69.82,-18.555),(69.82,-18.725),(69.65,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-18.725),(70.16,-18.555),(70.33,-18.555),(70.33,-18.725),(70.16,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-18.725),(70.67,-18.555),(70.84,-18.555),(70.84,-18.725),(70.67,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-18.725),(71.18,-18.555),(71.35,-18.555),(71.35,-18.725),(71.18,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-18.725),(71.69,-18.555),(71.86,-18.555),(71.86,-18.725),(71.69,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-18.725),(72.2,-18.555),(72.37,-18.555),(72.37,-18.725),(72.2,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-18.725),(72.71,-18.555),(72.88,-18.555),(72.88,-18.725),(72.71,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-18.725),(73.22,-18.555),(73.39,-18.555),(73.39,-18.725),(73.22,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-18.725),(73.73,-18.555),(73.9,-18.555),(73.9,-18.725),(73.73,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-18.725),(74.24,-18.555),(74.41,-18.555),(74.41,-18.725),(74.24,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-18.725),(74.75,-18.555),(74.92,-18.555),(74.92,-18.725),(74.75,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-18.725),(75.26,-18.555),(75.43,-18.555),(75.43,-18.725),(75.26,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-18.725),(75.77,-18.555),(75.94,-18.555),(75.94,-18.725),(75.77,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-18.725),(76.28,-18.555),(76.45,-18.555),(76.45,-18.725),(76.28,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-18.725),(76.79,-18.555),(76.96,-18.555),(76.96,-18.725),(76.79,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-18.725),(77.3,-18.555),(77.47,-18.555),(77.47,-18.725),(77.3,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-18.725),(77.81,-18.555),(77.98,-18.555),(77.98,-18.725),(77.81,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-18.725),(78.32,-18.555),(78.49,-18.555),(78.49,-18.725),(78.32,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-18.725),(78.83,-18.555),(79.0,-18.555),(79.0,-18.725),(78.83,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-18.725),(79.34,-18.555),(79.51,-18.555),(79.51,-18.725),(79.34,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-18.725),(79.85,-18.555),(80.02,-18.555),(80.02,-18.725),(79.85,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-18.725),(80.36,-18.555),(80.53,-18.555),(80.53,-18.725),(80.36,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-18.725),(80.87,-18.555),(81.04,-18.555),(81.04,-18.725),(80.87,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-18.725),(81.38,-18.555),(81.55,-18.555),(81.55,-18.725),(81.38,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-18.725),(81.89,-18.555),(82.06,-18.555),(82.06,-18.725),(81.89,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-18.725),(82.4,-18.555),(82.57,-18.555),(82.57,-18.725),(82.4,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-18.725),(82.91,-18.555),(83.08,-18.555),(83.08,-18.725),(82.91,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-18.725),(83.42,-18.555),(83.59,-18.555),(83.59,-18.725),(83.42,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-18.725),(83.93,-18.555),(84.1,-18.555),(84.1,-18.725),(83.93,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-18.725),(84.44,-18.555),(84.61,-18.555),(84.61,-18.725),(84.44,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-18.725),(84.95,-18.555),(85.12,-18.555),(85.12,-18.725),(84.95,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-18.725),(85.46,-18.555),(85.63,-18.555),(85.63,-18.725),(85.46,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-18.725),(85.97,-18.555),(86.14,-18.555),(86.14,-18.725),(85.97,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-18.725),(86.48,-18.555),(86.65,-18.555),(86.65,-18.725),(86.48,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-18.725),(86.99,-18.555),(87.16,-18.555),(87.16,-18.725),(86.99,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-18.725),(87.5,-18.555),(87.67,-18.555),(87.67,-18.725),(87.5,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-18.725),(88.01,-18.555),(88.18,-18.555),(88.18,-18.725),(88.01,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-18.725),(88.52,-18.555),(88.69,-18.555),(88.69,-18.725),(88.52,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-18.725),(89.03,-18.555),(89.2,-18.555),(89.2,-18.725),(89.03,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-18.725),(89.54,-18.555),(89.71,-18.555),(89.71,-18.725),(89.54,-18.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-18.215),(0.29,-18.045),(0.46,-18.045),(0.46,-18.215),(0.29,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-18.215),(0.8,-18.045),(0.97,-18.045),(0.97,-18.215),(0.8,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-18.215),(1.31,-18.045),(1.48,-18.045),(1.48,-18.215),(1.31,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-18.215),(1.82,-18.045),(1.99,-18.045),(1.99,-18.215),(1.82,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-18.215),(2.33,-18.045),(2.5,-18.045),(2.5,-18.215),(2.33,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-18.215),(2.84,-18.045),(3.01,-18.045),(3.01,-18.215),(2.84,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-18.215),(3.35,-18.045),(3.52,-18.045),(3.52,-18.215),(3.35,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-18.215),(3.86,-18.045),(4.03,-18.045),(4.03,-18.215),(3.86,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-18.215),(4.37,-18.045),(4.54,-18.045),(4.54,-18.215),(4.37,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-18.215),(4.88,-18.045),(5.05,-18.045),(5.05,-18.215),(4.88,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-18.215),(5.39,-18.045),(5.56,-18.045),(5.56,-18.215),(5.39,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-18.215),(5.9,-18.045),(6.07,-18.045),(6.07,-18.215),(5.9,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-18.215),(6.41,-18.045),(6.58,-18.045),(6.58,-18.215),(6.41,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-18.215),(6.92,-18.045),(7.09,-18.045),(7.09,-18.215),(6.92,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-18.215),(7.43,-18.045),(7.6,-18.045),(7.6,-18.215),(7.43,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-18.215),(7.94,-18.045),(8.11,-18.045),(8.11,-18.215),(7.94,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-18.215),(8.45,-18.045),(8.62,-18.045),(8.62,-18.215),(8.45,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-18.215),(8.96,-18.045),(9.13,-18.045),(9.13,-18.215),(8.96,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-18.215),(9.47,-18.045),(9.64,-18.045),(9.64,-18.215),(9.47,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-18.215),(9.98,-18.045),(10.15,-18.045),(10.15,-18.215),(9.98,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-18.215),(10.49,-18.045),(10.66,-18.045),(10.66,-18.215),(10.49,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-18.215),(11.0,-18.045),(11.17,-18.045),(11.17,-18.215),(11.0,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-18.215),(11.51,-18.045),(11.68,-18.045),(11.68,-18.215),(11.51,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-18.215),(12.02,-18.045),(12.19,-18.045),(12.19,-18.215),(12.02,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-18.215),(12.53,-18.045),(12.7,-18.045),(12.7,-18.215),(12.53,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-18.215),(13.04,-18.045),(13.21,-18.045),(13.21,-18.215),(13.04,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-18.215),(13.55,-18.045),(13.72,-18.045),(13.72,-18.215),(13.55,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-18.215),(14.06,-18.045),(14.23,-18.045),(14.23,-18.215),(14.06,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-18.215),(14.57,-18.045),(14.74,-18.045),(14.74,-18.215),(14.57,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-18.215),(15.08,-18.045),(15.25,-18.045),(15.25,-18.215),(15.08,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-18.215),(15.59,-18.045),(15.76,-18.045),(15.76,-18.215),(15.59,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-18.215),(16.1,-18.045),(16.27,-18.045),(16.27,-18.215),(16.1,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-18.215),(16.61,-18.045),(16.78,-18.045),(16.78,-18.215),(16.61,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-18.215),(17.12,-18.045),(17.29,-18.045),(17.29,-18.215),(17.12,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-18.215),(17.63,-18.045),(17.8,-18.045),(17.8,-18.215),(17.63,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-18.215),(18.14,-18.045),(18.31,-18.045),(18.31,-18.215),(18.14,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-18.215),(18.65,-18.045),(18.82,-18.045),(18.82,-18.215),(18.65,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-18.215),(19.16,-18.045),(19.33,-18.045),(19.33,-18.215),(19.16,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-18.215),(19.67,-18.045),(19.84,-18.045),(19.84,-18.215),(19.67,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-18.215),(20.18,-18.045),(20.35,-18.045),(20.35,-18.215),(20.18,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-18.215),(20.69,-18.045),(20.86,-18.045),(20.86,-18.215),(20.69,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-18.215),(21.2,-18.045),(21.37,-18.045),(21.37,-18.215),(21.2,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-18.215),(21.71,-18.045),(21.88,-18.045),(21.88,-18.215),(21.71,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-18.215),(22.22,-18.045),(22.39,-18.045),(22.39,-18.215),(22.22,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-18.215),(22.73,-18.045),(22.9,-18.045),(22.9,-18.215),(22.73,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-18.215),(23.24,-18.045),(23.41,-18.045),(23.41,-18.215),(23.24,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-18.215),(23.75,-18.045),(23.92,-18.045),(23.92,-18.215),(23.75,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-18.215),(24.26,-18.045),(24.43,-18.045),(24.43,-18.215),(24.26,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-18.215),(24.77,-18.045),(24.94,-18.045),(24.94,-18.215),(24.77,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-18.215),(25.28,-18.045),(25.45,-18.045),(25.45,-18.215),(25.28,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-18.215),(25.79,-18.045),(25.96,-18.045),(25.96,-18.215),(25.79,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-18.215),(26.3,-18.045),(26.47,-18.045),(26.47,-18.215),(26.3,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-18.215),(26.81,-18.045),(26.98,-18.045),(26.98,-18.215),(26.81,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-18.215),(27.32,-18.045),(27.49,-18.045),(27.49,-18.215),(27.32,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-18.215),(27.83,-18.045),(28.0,-18.045),(28.0,-18.215),(27.83,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-18.215),(28.34,-18.045),(28.51,-18.045),(28.51,-18.215),(28.34,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-18.215),(28.85,-18.045),(29.02,-18.045),(29.02,-18.215),(28.85,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-18.215),(29.36,-18.045),(29.53,-18.045),(29.53,-18.215),(29.36,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-18.215),(29.87,-18.045),(30.04,-18.045),(30.04,-18.215),(29.87,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-18.215),(30.38,-18.045),(30.55,-18.045),(30.55,-18.215),(30.38,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-18.215),(30.89,-18.045),(31.06,-18.045),(31.06,-18.215),(30.89,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-18.215),(31.4,-18.045),(31.57,-18.045),(31.57,-18.215),(31.4,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-18.215),(31.91,-18.045),(32.08,-18.045),(32.08,-18.215),(31.91,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-18.215),(32.42,-18.045),(32.59,-18.045),(32.59,-18.215),(32.42,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-18.215),(32.93,-18.045),(33.1,-18.045),(33.1,-18.215),(32.93,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-18.215),(33.44,-18.045),(33.61,-18.045),(33.61,-18.215),(33.44,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-18.215),(33.95,-18.045),(34.12,-18.045),(34.12,-18.215),(33.95,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-18.215),(34.46,-18.045),(34.63,-18.045),(34.63,-18.215),(34.46,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-18.215),(34.97,-18.045),(35.14,-18.045),(35.14,-18.215),(34.97,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-18.215),(35.48,-18.045),(35.65,-18.045),(35.65,-18.215),(35.48,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-18.215),(35.99,-18.045),(36.16,-18.045),(36.16,-18.215),(35.99,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-18.215),(36.5,-18.045),(36.67,-18.045),(36.67,-18.215),(36.5,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-18.215),(37.01,-18.045),(37.18,-18.045),(37.18,-18.215),(37.01,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-18.215),(37.52,-18.045),(37.69,-18.045),(37.69,-18.215),(37.52,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-18.215),(38.03,-18.045),(38.2,-18.045),(38.2,-18.215),(38.03,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-18.215),(38.54,-18.045),(38.71,-18.045),(38.71,-18.215),(38.54,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-18.215),(39.05,-18.045),(39.22,-18.045),(39.22,-18.215),(39.05,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-18.215),(39.56,-18.045),(39.73,-18.045),(39.73,-18.215),(39.56,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-18.215),(40.07,-18.045),(40.24,-18.045),(40.24,-18.215),(40.07,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-18.215),(40.58,-18.045),(40.75,-18.045),(40.75,-18.215),(40.58,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-18.215),(41.09,-18.045),(41.26,-18.045),(41.26,-18.215),(41.09,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-18.215),(41.6,-18.045),(41.77,-18.045),(41.77,-18.215),(41.6,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-18.215),(42.11,-18.045),(42.28,-18.045),(42.28,-18.215),(42.11,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-18.215),(42.62,-18.045),(42.79,-18.045),(42.79,-18.215),(42.62,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-18.215),(43.13,-18.045),(43.3,-18.045),(43.3,-18.215),(43.13,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-18.215),(43.64,-18.045),(43.81,-18.045),(43.81,-18.215),(43.64,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-18.215),(44.15,-18.045),(44.32,-18.045),(44.32,-18.215),(44.15,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-18.215),(44.66,-18.045),(44.83,-18.045),(44.83,-18.215),(44.66,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-18.215),(45.17,-18.045),(45.34,-18.045),(45.34,-18.215),(45.17,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-18.215),(45.68,-18.045),(45.85,-18.045),(45.85,-18.215),(45.68,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-18.215),(46.19,-18.045),(46.36,-18.045),(46.36,-18.215),(46.19,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-18.215),(46.7,-18.045),(46.87,-18.045),(46.87,-18.215),(46.7,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-18.215),(47.21,-18.045),(47.38,-18.045),(47.38,-18.215),(47.21,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-18.215),(47.72,-18.045),(47.89,-18.045),(47.89,-18.215),(47.72,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-18.215),(48.23,-18.045),(48.4,-18.045),(48.4,-18.215),(48.23,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-18.215),(48.74,-18.045),(48.91,-18.045),(48.91,-18.215),(48.74,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-18.215),(49.25,-18.045),(49.42,-18.045),(49.42,-18.215),(49.25,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-18.215),(49.76,-18.045),(49.93,-18.045),(49.93,-18.215),(49.76,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-18.215),(50.27,-18.045),(50.44,-18.045),(50.44,-18.215),(50.27,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-18.215),(50.78,-18.045),(50.95,-18.045),(50.95,-18.215),(50.78,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-18.215),(51.29,-18.045),(51.46,-18.045),(51.46,-18.215),(51.29,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-18.215),(51.8,-18.045),(51.97,-18.045),(51.97,-18.215),(51.8,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-18.215),(52.31,-18.045),(52.48,-18.045),(52.48,-18.215),(52.31,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-18.215),(52.82,-18.045),(52.99,-18.045),(52.99,-18.215),(52.82,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-18.215),(53.33,-18.045),(53.5,-18.045),(53.5,-18.215),(53.33,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-18.215),(53.84,-18.045),(54.01,-18.045),(54.01,-18.215),(53.84,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-18.215),(54.35,-18.045),(54.52,-18.045),(54.52,-18.215),(54.35,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-18.215),(54.86,-18.045),(55.03,-18.045),(55.03,-18.215),(54.86,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-18.215),(55.37,-18.045),(55.54,-18.045),(55.54,-18.215),(55.37,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-18.215),(55.88,-18.045),(56.05,-18.045),(56.05,-18.215),(55.88,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-18.215),(56.39,-18.045),(56.56,-18.045),(56.56,-18.215),(56.39,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-18.215),(56.9,-18.045),(57.07,-18.045),(57.07,-18.215),(56.9,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-18.215),(57.41,-18.045),(57.58,-18.045),(57.58,-18.215),(57.41,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-18.215),(57.92,-18.045),(58.09,-18.045),(58.09,-18.215),(57.92,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-18.215),(58.43,-18.045),(58.6,-18.045),(58.6,-18.215),(58.43,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-18.215),(58.94,-18.045),(59.11,-18.045),(59.11,-18.215),(58.94,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-18.215),(59.45,-18.045),(59.62,-18.045),(59.62,-18.215),(59.45,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-18.215),(59.96,-18.045),(60.13,-18.045),(60.13,-18.215),(59.96,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-18.215),(60.47,-18.045),(60.64,-18.045),(60.64,-18.215),(60.47,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-18.215),(60.98,-18.045),(61.15,-18.045),(61.15,-18.215),(60.98,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-18.215),(61.49,-18.045),(61.66,-18.045),(61.66,-18.215),(61.49,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-18.215),(62.0,-18.045),(62.17,-18.045),(62.17,-18.215),(62.0,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-18.215),(62.51,-18.045),(62.68,-18.045),(62.68,-18.215),(62.51,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-18.215),(63.02,-18.045),(63.19,-18.045),(63.19,-18.215),(63.02,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-18.215),(63.53,-18.045),(63.7,-18.045),(63.7,-18.215),(63.53,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-18.215),(64.04,-18.045),(64.21,-18.045),(64.21,-18.215),(64.04,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-18.215),(64.55,-18.045),(64.72,-18.045),(64.72,-18.215),(64.55,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-18.215),(65.06,-18.045),(65.23,-18.045),(65.23,-18.215),(65.06,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-18.215),(65.57,-18.045),(65.74,-18.045),(65.74,-18.215),(65.57,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-18.215),(66.08,-18.045),(66.25,-18.045),(66.25,-18.215),(66.08,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-18.215),(66.59,-18.045),(66.76,-18.045),(66.76,-18.215),(66.59,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-18.215),(67.1,-18.045),(67.27,-18.045),(67.27,-18.215),(67.1,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-18.215),(67.61,-18.045),(67.78,-18.045),(67.78,-18.215),(67.61,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-18.215),(68.12,-18.045),(68.29,-18.045),(68.29,-18.215),(68.12,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-18.215),(68.63,-18.045),(68.8,-18.045),(68.8,-18.215),(68.63,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-18.215),(69.14,-18.045),(69.31,-18.045),(69.31,-18.215),(69.14,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-18.215),(69.65,-18.045),(69.82,-18.045),(69.82,-18.215),(69.65,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-18.215),(70.16,-18.045),(70.33,-18.045),(70.33,-18.215),(70.16,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-18.215),(70.67,-18.045),(70.84,-18.045),(70.84,-18.215),(70.67,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-18.215),(71.18,-18.045),(71.35,-18.045),(71.35,-18.215),(71.18,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-18.215),(71.69,-18.045),(71.86,-18.045),(71.86,-18.215),(71.69,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-18.215),(72.2,-18.045),(72.37,-18.045),(72.37,-18.215),(72.2,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-18.215),(72.71,-18.045),(72.88,-18.045),(72.88,-18.215),(72.71,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-18.215),(73.22,-18.045),(73.39,-18.045),(73.39,-18.215),(73.22,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-18.215),(73.73,-18.045),(73.9,-18.045),(73.9,-18.215),(73.73,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-18.215),(74.24,-18.045),(74.41,-18.045),(74.41,-18.215),(74.24,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-18.215),(74.75,-18.045),(74.92,-18.045),(74.92,-18.215),(74.75,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-18.215),(75.26,-18.045),(75.43,-18.045),(75.43,-18.215),(75.26,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-18.215),(75.77,-18.045),(75.94,-18.045),(75.94,-18.215),(75.77,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-18.215),(76.28,-18.045),(76.45,-18.045),(76.45,-18.215),(76.28,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-18.215),(76.79,-18.045),(76.96,-18.045),(76.96,-18.215),(76.79,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-18.215),(77.3,-18.045),(77.47,-18.045),(77.47,-18.215),(77.3,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-18.215),(77.81,-18.045),(77.98,-18.045),(77.98,-18.215),(77.81,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-18.215),(78.32,-18.045),(78.49,-18.045),(78.49,-18.215),(78.32,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-18.215),(78.83,-18.045),(79.0,-18.045),(79.0,-18.215),(78.83,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-18.215),(79.34,-18.045),(79.51,-18.045),(79.51,-18.215),(79.34,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-18.215),(79.85,-18.045),(80.02,-18.045),(80.02,-18.215),(79.85,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-18.215),(80.36,-18.045),(80.53,-18.045),(80.53,-18.215),(80.36,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-18.215),(80.87,-18.045),(81.04,-18.045),(81.04,-18.215),(80.87,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-18.215),(81.38,-18.045),(81.55,-18.045),(81.55,-18.215),(81.38,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-18.215),(81.89,-18.045),(82.06,-18.045),(82.06,-18.215),(81.89,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-18.215),(82.4,-18.045),(82.57,-18.045),(82.57,-18.215),(82.4,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-18.215),(82.91,-18.045),(83.08,-18.045),(83.08,-18.215),(82.91,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-18.215),(83.42,-18.045),(83.59,-18.045),(83.59,-18.215),(83.42,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-18.215),(83.93,-18.045),(84.1,-18.045),(84.1,-18.215),(83.93,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-18.215),(84.44,-18.045),(84.61,-18.045),(84.61,-18.215),(84.44,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-18.215),(84.95,-18.045),(85.12,-18.045),(85.12,-18.215),(84.95,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-18.215),(85.46,-18.045),(85.63,-18.045),(85.63,-18.215),(85.46,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-18.215),(85.97,-18.045),(86.14,-18.045),(86.14,-18.215),(85.97,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-18.215),(86.48,-18.045),(86.65,-18.045),(86.65,-18.215),(86.48,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-18.215),(86.99,-18.045),(87.16,-18.045),(87.16,-18.215),(86.99,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-18.215),(87.5,-18.045),(87.67,-18.045),(87.67,-18.215),(87.5,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-18.215),(88.01,-18.045),(88.18,-18.045),(88.18,-18.215),(88.01,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-18.215),(88.52,-18.045),(88.69,-18.045),(88.69,-18.215),(88.52,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-18.215),(89.03,-18.045),(89.2,-18.045),(89.2,-18.215),(89.03,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-18.215),(89.54,-18.045),(89.71,-18.045),(89.71,-18.215),(89.54,-18.215)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-17.705),(0.29,-17.535),(0.46,-17.535),(0.46,-17.705),(0.29,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-17.705),(0.8,-17.535),(0.97,-17.535),(0.97,-17.705),(0.8,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-17.705),(1.31,-17.535),(1.48,-17.535),(1.48,-17.705),(1.31,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-17.705),(1.82,-17.535),(1.99,-17.535),(1.99,-17.705),(1.82,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-17.705),(2.33,-17.535),(2.5,-17.535),(2.5,-17.705),(2.33,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-17.705),(2.84,-17.535),(3.01,-17.535),(3.01,-17.705),(2.84,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-17.705),(3.35,-17.535),(3.52,-17.535),(3.52,-17.705),(3.35,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-17.705),(3.86,-17.535),(4.03,-17.535),(4.03,-17.705),(3.86,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-17.705),(4.37,-17.535),(4.54,-17.535),(4.54,-17.705),(4.37,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-17.705),(4.88,-17.535),(5.05,-17.535),(5.05,-17.705),(4.88,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-17.705),(5.39,-17.535),(5.56,-17.535),(5.56,-17.705),(5.39,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-17.705),(5.9,-17.535),(6.07,-17.535),(6.07,-17.705),(5.9,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-17.705),(6.41,-17.535),(6.58,-17.535),(6.58,-17.705),(6.41,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-17.705),(6.92,-17.535),(7.09,-17.535),(7.09,-17.705),(6.92,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-17.705),(7.43,-17.535),(7.6,-17.535),(7.6,-17.705),(7.43,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-17.705),(7.94,-17.535),(8.11,-17.535),(8.11,-17.705),(7.94,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-17.705),(8.45,-17.535),(8.62,-17.535),(8.62,-17.705),(8.45,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-17.705),(8.96,-17.535),(9.13,-17.535),(9.13,-17.705),(8.96,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-17.705),(9.47,-17.535),(9.64,-17.535),(9.64,-17.705),(9.47,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-17.705),(9.98,-17.535),(10.15,-17.535),(10.15,-17.705),(9.98,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-17.705),(10.49,-17.535),(10.66,-17.535),(10.66,-17.705),(10.49,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-17.705),(11.0,-17.535),(11.17,-17.535),(11.17,-17.705),(11.0,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-17.705),(11.51,-17.535),(11.68,-17.535),(11.68,-17.705),(11.51,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-17.705),(12.02,-17.535),(12.19,-17.535),(12.19,-17.705),(12.02,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-17.705),(12.53,-17.535),(12.7,-17.535),(12.7,-17.705),(12.53,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-17.705),(13.04,-17.535),(13.21,-17.535),(13.21,-17.705),(13.04,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-17.705),(13.55,-17.535),(13.72,-17.535),(13.72,-17.705),(13.55,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-17.705),(14.06,-17.535),(14.23,-17.535),(14.23,-17.705),(14.06,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-17.705),(14.57,-17.535),(14.74,-17.535),(14.74,-17.705),(14.57,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-17.705),(15.08,-17.535),(15.25,-17.535),(15.25,-17.705),(15.08,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-17.705),(15.59,-17.535),(15.76,-17.535),(15.76,-17.705),(15.59,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-17.705),(16.1,-17.535),(16.27,-17.535),(16.27,-17.705),(16.1,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-17.705),(16.61,-17.535),(16.78,-17.535),(16.78,-17.705),(16.61,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-17.705),(17.12,-17.535),(17.29,-17.535),(17.29,-17.705),(17.12,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-17.705),(17.63,-17.535),(17.8,-17.535),(17.8,-17.705),(17.63,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-17.705),(18.14,-17.535),(18.31,-17.535),(18.31,-17.705),(18.14,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-17.705),(18.65,-17.535),(18.82,-17.535),(18.82,-17.705),(18.65,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-17.705),(19.16,-17.535),(19.33,-17.535),(19.33,-17.705),(19.16,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-17.705),(19.67,-17.535),(19.84,-17.535),(19.84,-17.705),(19.67,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-17.705),(20.18,-17.535),(20.35,-17.535),(20.35,-17.705),(20.18,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-17.705),(20.69,-17.535),(20.86,-17.535),(20.86,-17.705),(20.69,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-17.705),(21.2,-17.535),(21.37,-17.535),(21.37,-17.705),(21.2,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-17.705),(21.71,-17.535),(21.88,-17.535),(21.88,-17.705),(21.71,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-17.705),(22.22,-17.535),(22.39,-17.535),(22.39,-17.705),(22.22,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-17.705),(22.73,-17.535),(22.9,-17.535),(22.9,-17.705),(22.73,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-17.705),(23.24,-17.535),(23.41,-17.535),(23.41,-17.705),(23.24,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-17.705),(23.75,-17.535),(23.92,-17.535),(23.92,-17.705),(23.75,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-17.705),(24.26,-17.535),(24.43,-17.535),(24.43,-17.705),(24.26,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-17.705),(24.77,-17.535),(24.94,-17.535),(24.94,-17.705),(24.77,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-17.705),(25.28,-17.535),(25.45,-17.535),(25.45,-17.705),(25.28,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-17.705),(25.79,-17.535),(25.96,-17.535),(25.96,-17.705),(25.79,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-17.705),(26.3,-17.535),(26.47,-17.535),(26.47,-17.705),(26.3,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-17.705),(26.81,-17.535),(26.98,-17.535),(26.98,-17.705),(26.81,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-17.705),(27.32,-17.535),(27.49,-17.535),(27.49,-17.705),(27.32,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-17.705),(27.83,-17.535),(28.0,-17.535),(28.0,-17.705),(27.83,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-17.705),(28.34,-17.535),(28.51,-17.535),(28.51,-17.705),(28.34,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-17.705),(28.85,-17.535),(29.02,-17.535),(29.02,-17.705),(28.85,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-17.705),(29.36,-17.535),(29.53,-17.535),(29.53,-17.705),(29.36,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-17.705),(29.87,-17.535),(30.04,-17.535),(30.04,-17.705),(29.87,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-17.705),(30.38,-17.535),(30.55,-17.535),(30.55,-17.705),(30.38,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-17.705),(30.89,-17.535),(31.06,-17.535),(31.06,-17.705),(30.89,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-17.705),(31.4,-17.535),(31.57,-17.535),(31.57,-17.705),(31.4,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-17.705),(31.91,-17.535),(32.08,-17.535),(32.08,-17.705),(31.91,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-17.705),(32.42,-17.535),(32.59,-17.535),(32.59,-17.705),(32.42,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-17.705),(32.93,-17.535),(33.1,-17.535),(33.1,-17.705),(32.93,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-17.705),(33.44,-17.535),(33.61,-17.535),(33.61,-17.705),(33.44,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-17.705),(33.95,-17.535),(34.12,-17.535),(34.12,-17.705),(33.95,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-17.705),(34.46,-17.535),(34.63,-17.535),(34.63,-17.705),(34.46,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-17.705),(34.97,-17.535),(35.14,-17.535),(35.14,-17.705),(34.97,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-17.705),(35.48,-17.535),(35.65,-17.535),(35.65,-17.705),(35.48,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-17.705),(35.99,-17.535),(36.16,-17.535),(36.16,-17.705),(35.99,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-17.705),(36.5,-17.535),(36.67,-17.535),(36.67,-17.705),(36.5,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-17.705),(37.01,-17.535),(37.18,-17.535),(37.18,-17.705),(37.01,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-17.705),(37.52,-17.535),(37.69,-17.535),(37.69,-17.705),(37.52,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-17.705),(38.03,-17.535),(38.2,-17.535),(38.2,-17.705),(38.03,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-17.705),(38.54,-17.535),(38.71,-17.535),(38.71,-17.705),(38.54,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-17.705),(39.05,-17.535),(39.22,-17.535),(39.22,-17.705),(39.05,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-17.705),(39.56,-17.535),(39.73,-17.535),(39.73,-17.705),(39.56,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-17.705),(40.07,-17.535),(40.24,-17.535),(40.24,-17.705),(40.07,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-17.705),(40.58,-17.535),(40.75,-17.535),(40.75,-17.705),(40.58,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-17.705),(41.09,-17.535),(41.26,-17.535),(41.26,-17.705),(41.09,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-17.705),(41.6,-17.535),(41.77,-17.535),(41.77,-17.705),(41.6,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-17.705),(42.11,-17.535),(42.28,-17.535),(42.28,-17.705),(42.11,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-17.705),(42.62,-17.535),(42.79,-17.535),(42.79,-17.705),(42.62,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-17.705),(43.13,-17.535),(43.3,-17.535),(43.3,-17.705),(43.13,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-17.705),(43.64,-17.535),(43.81,-17.535),(43.81,-17.705),(43.64,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-17.705),(44.15,-17.535),(44.32,-17.535),(44.32,-17.705),(44.15,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-17.705),(44.66,-17.535),(44.83,-17.535),(44.83,-17.705),(44.66,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-17.705),(45.17,-17.535),(45.34,-17.535),(45.34,-17.705),(45.17,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-17.705),(45.68,-17.535),(45.85,-17.535),(45.85,-17.705),(45.68,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-17.705),(46.19,-17.535),(46.36,-17.535),(46.36,-17.705),(46.19,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-17.705),(46.7,-17.535),(46.87,-17.535),(46.87,-17.705),(46.7,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-17.705),(47.21,-17.535),(47.38,-17.535),(47.38,-17.705),(47.21,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-17.705),(47.72,-17.535),(47.89,-17.535),(47.89,-17.705),(47.72,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-17.705),(48.23,-17.535),(48.4,-17.535),(48.4,-17.705),(48.23,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-17.705),(48.74,-17.535),(48.91,-17.535),(48.91,-17.705),(48.74,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-17.705),(49.25,-17.535),(49.42,-17.535),(49.42,-17.705),(49.25,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-17.705),(49.76,-17.535),(49.93,-17.535),(49.93,-17.705),(49.76,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-17.705),(50.27,-17.535),(50.44,-17.535),(50.44,-17.705),(50.27,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-17.705),(50.78,-17.535),(50.95,-17.535),(50.95,-17.705),(50.78,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-17.705),(51.29,-17.535),(51.46,-17.535),(51.46,-17.705),(51.29,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-17.705),(51.8,-17.535),(51.97,-17.535),(51.97,-17.705),(51.8,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-17.705),(52.31,-17.535),(52.48,-17.535),(52.48,-17.705),(52.31,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-17.705),(52.82,-17.535),(52.99,-17.535),(52.99,-17.705),(52.82,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-17.705),(53.33,-17.535),(53.5,-17.535),(53.5,-17.705),(53.33,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-17.705),(53.84,-17.535),(54.01,-17.535),(54.01,-17.705),(53.84,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-17.705),(54.35,-17.535),(54.52,-17.535),(54.52,-17.705),(54.35,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-17.705),(54.86,-17.535),(55.03,-17.535),(55.03,-17.705),(54.86,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-17.705),(55.37,-17.535),(55.54,-17.535),(55.54,-17.705),(55.37,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-17.705),(55.88,-17.535),(56.05,-17.535),(56.05,-17.705),(55.88,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-17.705),(56.39,-17.535),(56.56,-17.535),(56.56,-17.705),(56.39,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-17.705),(56.9,-17.535),(57.07,-17.535),(57.07,-17.705),(56.9,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-17.705),(57.41,-17.535),(57.58,-17.535),(57.58,-17.705),(57.41,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-17.705),(57.92,-17.535),(58.09,-17.535),(58.09,-17.705),(57.92,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-17.705),(58.43,-17.535),(58.6,-17.535),(58.6,-17.705),(58.43,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-17.705),(58.94,-17.535),(59.11,-17.535),(59.11,-17.705),(58.94,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-17.705),(59.45,-17.535),(59.62,-17.535),(59.62,-17.705),(59.45,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-17.705),(59.96,-17.535),(60.13,-17.535),(60.13,-17.705),(59.96,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-17.705),(60.47,-17.535),(60.64,-17.535),(60.64,-17.705),(60.47,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-17.705),(60.98,-17.535),(61.15,-17.535),(61.15,-17.705),(60.98,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-17.705),(61.49,-17.535),(61.66,-17.535),(61.66,-17.705),(61.49,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-17.705),(62.0,-17.535),(62.17,-17.535),(62.17,-17.705),(62.0,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-17.705),(62.51,-17.535),(62.68,-17.535),(62.68,-17.705),(62.51,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-17.705),(63.02,-17.535),(63.19,-17.535),(63.19,-17.705),(63.02,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-17.705),(63.53,-17.535),(63.7,-17.535),(63.7,-17.705),(63.53,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-17.705),(64.04,-17.535),(64.21,-17.535),(64.21,-17.705),(64.04,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-17.705),(64.55,-17.535),(64.72,-17.535),(64.72,-17.705),(64.55,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-17.705),(65.06,-17.535),(65.23,-17.535),(65.23,-17.705),(65.06,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-17.705),(65.57,-17.535),(65.74,-17.535),(65.74,-17.705),(65.57,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-17.705),(66.08,-17.535),(66.25,-17.535),(66.25,-17.705),(66.08,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-17.705),(66.59,-17.535),(66.76,-17.535),(66.76,-17.705),(66.59,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-17.705),(67.1,-17.535),(67.27,-17.535),(67.27,-17.705),(67.1,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-17.705),(67.61,-17.535),(67.78,-17.535),(67.78,-17.705),(67.61,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-17.705),(68.12,-17.535),(68.29,-17.535),(68.29,-17.705),(68.12,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-17.705),(68.63,-17.535),(68.8,-17.535),(68.8,-17.705),(68.63,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-17.705),(69.14,-17.535),(69.31,-17.535),(69.31,-17.705),(69.14,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-17.705),(69.65,-17.535),(69.82,-17.535),(69.82,-17.705),(69.65,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-17.705),(70.16,-17.535),(70.33,-17.535),(70.33,-17.705),(70.16,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-17.705),(70.67,-17.535),(70.84,-17.535),(70.84,-17.705),(70.67,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-17.705),(71.18,-17.535),(71.35,-17.535),(71.35,-17.705),(71.18,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-17.705),(71.69,-17.535),(71.86,-17.535),(71.86,-17.705),(71.69,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-17.705),(72.2,-17.535),(72.37,-17.535),(72.37,-17.705),(72.2,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-17.705),(72.71,-17.535),(72.88,-17.535),(72.88,-17.705),(72.71,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-17.705),(73.22,-17.535),(73.39,-17.535),(73.39,-17.705),(73.22,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-17.705),(73.73,-17.535),(73.9,-17.535),(73.9,-17.705),(73.73,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-17.705),(74.24,-17.535),(74.41,-17.535),(74.41,-17.705),(74.24,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-17.705),(74.75,-17.535),(74.92,-17.535),(74.92,-17.705),(74.75,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-17.705),(75.26,-17.535),(75.43,-17.535),(75.43,-17.705),(75.26,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-17.705),(75.77,-17.535),(75.94,-17.535),(75.94,-17.705),(75.77,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-17.705),(76.28,-17.535),(76.45,-17.535),(76.45,-17.705),(76.28,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-17.705),(76.79,-17.535),(76.96,-17.535),(76.96,-17.705),(76.79,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-17.705),(77.3,-17.535),(77.47,-17.535),(77.47,-17.705),(77.3,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-17.705),(77.81,-17.535),(77.98,-17.535),(77.98,-17.705),(77.81,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-17.705),(78.32,-17.535),(78.49,-17.535),(78.49,-17.705),(78.32,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-17.705),(78.83,-17.535),(79.0,-17.535),(79.0,-17.705),(78.83,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-17.705),(79.34,-17.535),(79.51,-17.535),(79.51,-17.705),(79.34,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-17.705),(79.85,-17.535),(80.02,-17.535),(80.02,-17.705),(79.85,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-17.705),(80.36,-17.535),(80.53,-17.535),(80.53,-17.705),(80.36,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-17.705),(80.87,-17.535),(81.04,-17.535),(81.04,-17.705),(80.87,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-17.705),(81.38,-17.535),(81.55,-17.535),(81.55,-17.705),(81.38,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-17.705),(81.89,-17.535),(82.06,-17.535),(82.06,-17.705),(81.89,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-17.705),(82.4,-17.535),(82.57,-17.535),(82.57,-17.705),(82.4,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-17.705),(82.91,-17.535),(83.08,-17.535),(83.08,-17.705),(82.91,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-17.705),(83.42,-17.535),(83.59,-17.535),(83.59,-17.705),(83.42,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-17.705),(83.93,-17.535),(84.1,-17.535),(84.1,-17.705),(83.93,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-17.705),(84.44,-17.535),(84.61,-17.535),(84.61,-17.705),(84.44,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-17.705),(84.95,-17.535),(85.12,-17.535),(85.12,-17.705),(84.95,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-17.705),(85.46,-17.535),(85.63,-17.535),(85.63,-17.705),(85.46,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-17.705),(85.97,-17.535),(86.14,-17.535),(86.14,-17.705),(85.97,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-17.705),(86.48,-17.535),(86.65,-17.535),(86.65,-17.705),(86.48,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-17.705),(86.99,-17.535),(87.16,-17.535),(87.16,-17.705),(86.99,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-17.705),(87.5,-17.535),(87.67,-17.535),(87.67,-17.705),(87.5,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-17.705),(88.01,-17.535),(88.18,-17.535),(88.18,-17.705),(88.01,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-17.705),(88.52,-17.535),(88.69,-17.535),(88.69,-17.705),(88.52,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-17.705),(89.03,-17.535),(89.2,-17.535),(89.2,-17.705),(89.03,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-17.705),(89.54,-17.535),(89.71,-17.535),(89.71,-17.705),(89.54,-17.705)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-17.195),(0.29,-17.025),(0.46,-17.025),(0.46,-17.195),(0.29,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-17.195),(0.8,-17.025),(0.97,-17.025),(0.97,-17.195),(0.8,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-17.195),(1.31,-17.025),(1.48,-17.025),(1.48,-17.195),(1.31,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-17.195),(1.82,-17.025),(1.99,-17.025),(1.99,-17.195),(1.82,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-17.195),(2.33,-17.025),(2.5,-17.025),(2.5,-17.195),(2.33,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-17.195),(2.84,-17.025),(3.01,-17.025),(3.01,-17.195),(2.84,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-17.195),(3.35,-17.025),(3.52,-17.025),(3.52,-17.195),(3.35,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-17.195),(3.86,-17.025),(4.03,-17.025),(4.03,-17.195),(3.86,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-17.195),(4.37,-17.025),(4.54,-17.025),(4.54,-17.195),(4.37,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-17.195),(4.88,-17.025),(5.05,-17.025),(5.05,-17.195),(4.88,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-17.195),(5.39,-17.025),(5.56,-17.025),(5.56,-17.195),(5.39,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-17.195),(5.9,-17.025),(6.07,-17.025),(6.07,-17.195),(5.9,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-17.195),(6.41,-17.025),(6.58,-17.025),(6.58,-17.195),(6.41,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-17.195),(6.92,-17.025),(7.09,-17.025),(7.09,-17.195),(6.92,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-17.195),(7.43,-17.025),(7.6,-17.025),(7.6,-17.195),(7.43,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-17.195),(7.94,-17.025),(8.11,-17.025),(8.11,-17.195),(7.94,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-17.195),(8.45,-17.025),(8.62,-17.025),(8.62,-17.195),(8.45,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-17.195),(8.96,-17.025),(9.13,-17.025),(9.13,-17.195),(8.96,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-17.195),(9.47,-17.025),(9.64,-17.025),(9.64,-17.195),(9.47,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-17.195),(9.98,-17.025),(10.15,-17.025),(10.15,-17.195),(9.98,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-17.195),(10.49,-17.025),(10.66,-17.025),(10.66,-17.195),(10.49,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-17.195),(11.0,-17.025),(11.17,-17.025),(11.17,-17.195),(11.0,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-17.195),(11.51,-17.025),(11.68,-17.025),(11.68,-17.195),(11.51,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-17.195),(12.02,-17.025),(12.19,-17.025),(12.19,-17.195),(12.02,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-17.195),(12.53,-17.025),(12.7,-17.025),(12.7,-17.195),(12.53,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-17.195),(13.04,-17.025),(13.21,-17.025),(13.21,-17.195),(13.04,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-17.195),(13.55,-17.025),(13.72,-17.025),(13.72,-17.195),(13.55,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-17.195),(14.06,-17.025),(14.23,-17.025),(14.23,-17.195),(14.06,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-17.195),(14.57,-17.025),(14.74,-17.025),(14.74,-17.195),(14.57,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-17.195),(15.08,-17.025),(15.25,-17.025),(15.25,-17.195),(15.08,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-17.195),(15.59,-17.025),(15.76,-17.025),(15.76,-17.195),(15.59,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-17.195),(16.1,-17.025),(16.27,-17.025),(16.27,-17.195),(16.1,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-17.195),(16.61,-17.025),(16.78,-17.025),(16.78,-17.195),(16.61,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-17.195),(17.12,-17.025),(17.29,-17.025),(17.29,-17.195),(17.12,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-17.195),(17.63,-17.025),(17.8,-17.025),(17.8,-17.195),(17.63,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-17.195),(18.14,-17.025),(18.31,-17.025),(18.31,-17.195),(18.14,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-17.195),(18.65,-17.025),(18.82,-17.025),(18.82,-17.195),(18.65,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-17.195),(19.16,-17.025),(19.33,-17.025),(19.33,-17.195),(19.16,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-17.195),(19.67,-17.025),(19.84,-17.025),(19.84,-17.195),(19.67,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-17.195),(20.18,-17.025),(20.35,-17.025),(20.35,-17.195),(20.18,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-17.195),(20.69,-17.025),(20.86,-17.025),(20.86,-17.195),(20.69,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-17.195),(21.2,-17.025),(21.37,-17.025),(21.37,-17.195),(21.2,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-17.195),(21.71,-17.025),(21.88,-17.025),(21.88,-17.195),(21.71,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-17.195),(22.22,-17.025),(22.39,-17.025),(22.39,-17.195),(22.22,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-17.195),(22.73,-17.025),(22.9,-17.025),(22.9,-17.195),(22.73,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-17.195),(23.24,-17.025),(23.41,-17.025),(23.41,-17.195),(23.24,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-17.195),(23.75,-17.025),(23.92,-17.025),(23.92,-17.195),(23.75,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-17.195),(24.26,-17.025),(24.43,-17.025),(24.43,-17.195),(24.26,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-17.195),(24.77,-17.025),(24.94,-17.025),(24.94,-17.195),(24.77,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-17.195),(25.28,-17.025),(25.45,-17.025),(25.45,-17.195),(25.28,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-17.195),(25.79,-17.025),(25.96,-17.025),(25.96,-17.195),(25.79,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-17.195),(26.3,-17.025),(26.47,-17.025),(26.47,-17.195),(26.3,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-17.195),(26.81,-17.025),(26.98,-17.025),(26.98,-17.195),(26.81,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-17.195),(27.32,-17.025),(27.49,-17.025),(27.49,-17.195),(27.32,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-17.195),(27.83,-17.025),(28.0,-17.025),(28.0,-17.195),(27.83,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-17.195),(28.34,-17.025),(28.51,-17.025),(28.51,-17.195),(28.34,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-17.195),(28.85,-17.025),(29.02,-17.025),(29.02,-17.195),(28.85,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-17.195),(29.36,-17.025),(29.53,-17.025),(29.53,-17.195),(29.36,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-17.195),(29.87,-17.025),(30.04,-17.025),(30.04,-17.195),(29.87,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-17.195),(30.38,-17.025),(30.55,-17.025),(30.55,-17.195),(30.38,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-17.195),(30.89,-17.025),(31.06,-17.025),(31.06,-17.195),(30.89,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-17.195),(31.4,-17.025),(31.57,-17.025),(31.57,-17.195),(31.4,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-17.195),(31.91,-17.025),(32.08,-17.025),(32.08,-17.195),(31.91,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-17.195),(32.42,-17.025),(32.59,-17.025),(32.59,-17.195),(32.42,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-17.195),(32.93,-17.025),(33.1,-17.025),(33.1,-17.195),(32.93,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-17.195),(33.44,-17.025),(33.61,-17.025),(33.61,-17.195),(33.44,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-17.195),(33.95,-17.025),(34.12,-17.025),(34.12,-17.195),(33.95,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-17.195),(34.46,-17.025),(34.63,-17.025),(34.63,-17.195),(34.46,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-17.195),(34.97,-17.025),(35.14,-17.025),(35.14,-17.195),(34.97,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-17.195),(35.48,-17.025),(35.65,-17.025),(35.65,-17.195),(35.48,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-17.195),(35.99,-17.025),(36.16,-17.025),(36.16,-17.195),(35.99,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-17.195),(36.5,-17.025),(36.67,-17.025),(36.67,-17.195),(36.5,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-17.195),(37.01,-17.025),(37.18,-17.025),(37.18,-17.195),(37.01,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-17.195),(37.52,-17.025),(37.69,-17.025),(37.69,-17.195),(37.52,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-17.195),(38.03,-17.025),(38.2,-17.025),(38.2,-17.195),(38.03,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-17.195),(38.54,-17.025),(38.71,-17.025),(38.71,-17.195),(38.54,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-17.195),(39.05,-17.025),(39.22,-17.025),(39.22,-17.195),(39.05,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-17.195),(39.56,-17.025),(39.73,-17.025),(39.73,-17.195),(39.56,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-17.195),(40.07,-17.025),(40.24,-17.025),(40.24,-17.195),(40.07,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-17.195),(40.58,-17.025),(40.75,-17.025),(40.75,-17.195),(40.58,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-17.195),(41.09,-17.025),(41.26,-17.025),(41.26,-17.195),(41.09,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-17.195),(41.6,-17.025),(41.77,-17.025),(41.77,-17.195),(41.6,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-17.195),(42.11,-17.025),(42.28,-17.025),(42.28,-17.195),(42.11,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-17.195),(42.62,-17.025),(42.79,-17.025),(42.79,-17.195),(42.62,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-17.195),(43.13,-17.025),(43.3,-17.025),(43.3,-17.195),(43.13,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-17.195),(43.64,-17.025),(43.81,-17.025),(43.81,-17.195),(43.64,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-17.195),(44.15,-17.025),(44.32,-17.025),(44.32,-17.195),(44.15,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-17.195),(44.66,-17.025),(44.83,-17.025),(44.83,-17.195),(44.66,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-17.195),(45.17,-17.025),(45.34,-17.025),(45.34,-17.195),(45.17,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-17.195),(45.68,-17.025),(45.85,-17.025),(45.85,-17.195),(45.68,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-17.195),(46.19,-17.025),(46.36,-17.025),(46.36,-17.195),(46.19,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-17.195),(46.7,-17.025),(46.87,-17.025),(46.87,-17.195),(46.7,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-17.195),(47.21,-17.025),(47.38,-17.025),(47.38,-17.195),(47.21,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-17.195),(47.72,-17.025),(47.89,-17.025),(47.89,-17.195),(47.72,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-17.195),(48.23,-17.025),(48.4,-17.025),(48.4,-17.195),(48.23,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-17.195),(48.74,-17.025),(48.91,-17.025),(48.91,-17.195),(48.74,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-17.195),(49.25,-17.025),(49.42,-17.025),(49.42,-17.195),(49.25,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-17.195),(49.76,-17.025),(49.93,-17.025),(49.93,-17.195),(49.76,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-17.195),(50.27,-17.025),(50.44,-17.025),(50.44,-17.195),(50.27,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-17.195),(50.78,-17.025),(50.95,-17.025),(50.95,-17.195),(50.78,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-17.195),(51.29,-17.025),(51.46,-17.025),(51.46,-17.195),(51.29,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-17.195),(51.8,-17.025),(51.97,-17.025),(51.97,-17.195),(51.8,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-17.195),(52.31,-17.025),(52.48,-17.025),(52.48,-17.195),(52.31,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-17.195),(52.82,-17.025),(52.99,-17.025),(52.99,-17.195),(52.82,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-17.195),(53.33,-17.025),(53.5,-17.025),(53.5,-17.195),(53.33,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-17.195),(53.84,-17.025),(54.01,-17.025),(54.01,-17.195),(53.84,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-17.195),(54.35,-17.025),(54.52,-17.025),(54.52,-17.195),(54.35,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-17.195),(54.86,-17.025),(55.03,-17.025),(55.03,-17.195),(54.86,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-17.195),(55.37,-17.025),(55.54,-17.025),(55.54,-17.195),(55.37,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-17.195),(55.88,-17.025),(56.05,-17.025),(56.05,-17.195),(55.88,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-17.195),(56.39,-17.025),(56.56,-17.025),(56.56,-17.195),(56.39,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-17.195),(56.9,-17.025),(57.07,-17.025),(57.07,-17.195),(56.9,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-17.195),(57.41,-17.025),(57.58,-17.025),(57.58,-17.195),(57.41,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-17.195),(57.92,-17.025),(58.09,-17.025),(58.09,-17.195),(57.92,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-17.195),(58.43,-17.025),(58.6,-17.025),(58.6,-17.195),(58.43,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-17.195),(58.94,-17.025),(59.11,-17.025),(59.11,-17.195),(58.94,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-17.195),(59.45,-17.025),(59.62,-17.025),(59.62,-17.195),(59.45,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-17.195),(59.96,-17.025),(60.13,-17.025),(60.13,-17.195),(59.96,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-17.195),(60.47,-17.025),(60.64,-17.025),(60.64,-17.195),(60.47,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-17.195),(60.98,-17.025),(61.15,-17.025),(61.15,-17.195),(60.98,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-17.195),(61.49,-17.025),(61.66,-17.025),(61.66,-17.195),(61.49,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-17.195),(62.0,-17.025),(62.17,-17.025),(62.17,-17.195),(62.0,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-17.195),(62.51,-17.025),(62.68,-17.025),(62.68,-17.195),(62.51,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-17.195),(63.02,-17.025),(63.19,-17.025),(63.19,-17.195),(63.02,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-17.195),(63.53,-17.025),(63.7,-17.025),(63.7,-17.195),(63.53,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-17.195),(64.04,-17.025),(64.21,-17.025),(64.21,-17.195),(64.04,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-17.195),(64.55,-17.025),(64.72,-17.025),(64.72,-17.195),(64.55,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-17.195),(65.06,-17.025),(65.23,-17.025),(65.23,-17.195),(65.06,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-17.195),(65.57,-17.025),(65.74,-17.025),(65.74,-17.195),(65.57,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-17.195),(66.08,-17.025),(66.25,-17.025),(66.25,-17.195),(66.08,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-17.195),(66.59,-17.025),(66.76,-17.025),(66.76,-17.195),(66.59,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-17.195),(67.1,-17.025),(67.27,-17.025),(67.27,-17.195),(67.1,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-17.195),(67.61,-17.025),(67.78,-17.025),(67.78,-17.195),(67.61,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-17.195),(68.12,-17.025),(68.29,-17.025),(68.29,-17.195),(68.12,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-17.195),(68.63,-17.025),(68.8,-17.025),(68.8,-17.195),(68.63,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-17.195),(69.14,-17.025),(69.31,-17.025),(69.31,-17.195),(69.14,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-17.195),(69.65,-17.025),(69.82,-17.025),(69.82,-17.195),(69.65,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-17.195),(70.16,-17.025),(70.33,-17.025),(70.33,-17.195),(70.16,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-17.195),(70.67,-17.025),(70.84,-17.025),(70.84,-17.195),(70.67,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-17.195),(71.18,-17.025),(71.35,-17.025),(71.35,-17.195),(71.18,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-17.195),(71.69,-17.025),(71.86,-17.025),(71.86,-17.195),(71.69,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-17.195),(72.2,-17.025),(72.37,-17.025),(72.37,-17.195),(72.2,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-17.195),(72.71,-17.025),(72.88,-17.025),(72.88,-17.195),(72.71,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-17.195),(73.22,-17.025),(73.39,-17.025),(73.39,-17.195),(73.22,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-17.195),(73.73,-17.025),(73.9,-17.025),(73.9,-17.195),(73.73,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-17.195),(74.24,-17.025),(74.41,-17.025),(74.41,-17.195),(74.24,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-17.195),(74.75,-17.025),(74.92,-17.025),(74.92,-17.195),(74.75,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-17.195),(75.26,-17.025),(75.43,-17.025),(75.43,-17.195),(75.26,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-17.195),(75.77,-17.025),(75.94,-17.025),(75.94,-17.195),(75.77,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-17.195),(76.28,-17.025),(76.45,-17.025),(76.45,-17.195),(76.28,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-17.195),(76.79,-17.025),(76.96,-17.025),(76.96,-17.195),(76.79,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-17.195),(77.3,-17.025),(77.47,-17.025),(77.47,-17.195),(77.3,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-17.195),(77.81,-17.025),(77.98,-17.025),(77.98,-17.195),(77.81,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-17.195),(78.32,-17.025),(78.49,-17.025),(78.49,-17.195),(78.32,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-17.195),(78.83,-17.025),(79.0,-17.025),(79.0,-17.195),(78.83,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-17.195),(79.34,-17.025),(79.51,-17.025),(79.51,-17.195),(79.34,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-17.195),(79.85,-17.025),(80.02,-17.025),(80.02,-17.195),(79.85,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-17.195),(80.36,-17.025),(80.53,-17.025),(80.53,-17.195),(80.36,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-17.195),(80.87,-17.025),(81.04,-17.025),(81.04,-17.195),(80.87,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-17.195),(81.38,-17.025),(81.55,-17.025),(81.55,-17.195),(81.38,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-17.195),(81.89,-17.025),(82.06,-17.025),(82.06,-17.195),(81.89,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-17.195),(82.4,-17.025),(82.57,-17.025),(82.57,-17.195),(82.4,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-17.195),(82.91,-17.025),(83.08,-17.025),(83.08,-17.195),(82.91,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-17.195),(83.42,-17.025),(83.59,-17.025),(83.59,-17.195),(83.42,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-17.195),(83.93,-17.025),(84.1,-17.025),(84.1,-17.195),(83.93,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-17.195),(84.44,-17.025),(84.61,-17.025),(84.61,-17.195),(84.44,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-17.195),(84.95,-17.025),(85.12,-17.025),(85.12,-17.195),(84.95,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-17.195),(85.46,-17.025),(85.63,-17.025),(85.63,-17.195),(85.46,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-17.195),(85.97,-17.025),(86.14,-17.025),(86.14,-17.195),(85.97,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-17.195),(86.48,-17.025),(86.65,-17.025),(86.65,-17.195),(86.48,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-17.195),(86.99,-17.025),(87.16,-17.025),(87.16,-17.195),(86.99,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-17.195),(87.5,-17.025),(87.67,-17.025),(87.67,-17.195),(87.5,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-17.195),(88.01,-17.025),(88.18,-17.025),(88.18,-17.195),(88.01,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-17.195),(88.52,-17.025),(88.69,-17.025),(88.69,-17.195),(88.52,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-17.195),(89.03,-17.025),(89.2,-17.025),(89.2,-17.195),(89.03,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-17.195),(89.54,-17.025),(89.71,-17.025),(89.71,-17.195),(89.54,-17.195)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-16.685),(0.29,-16.515),(0.46,-16.515),(0.46,-16.685),(0.29,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-16.685),(0.8,-16.515),(0.97,-16.515),(0.97,-16.685),(0.8,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-16.685),(1.31,-16.515),(1.48,-16.515),(1.48,-16.685),(1.31,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-16.685),(1.82,-16.515),(1.99,-16.515),(1.99,-16.685),(1.82,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-16.685),(2.33,-16.515),(2.5,-16.515),(2.5,-16.685),(2.33,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-16.685),(2.84,-16.515),(3.01,-16.515),(3.01,-16.685),(2.84,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-16.685),(3.35,-16.515),(3.52,-16.515),(3.52,-16.685),(3.35,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-16.685),(3.86,-16.515),(4.03,-16.515),(4.03,-16.685),(3.86,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-16.685),(4.37,-16.515),(4.54,-16.515),(4.54,-16.685),(4.37,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-16.685),(4.88,-16.515),(5.05,-16.515),(5.05,-16.685),(4.88,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-16.685),(5.39,-16.515),(5.56,-16.515),(5.56,-16.685),(5.39,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-16.685),(5.9,-16.515),(6.07,-16.515),(6.07,-16.685),(5.9,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-16.685),(6.41,-16.515),(6.58,-16.515),(6.58,-16.685),(6.41,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-16.685),(6.92,-16.515),(7.09,-16.515),(7.09,-16.685),(6.92,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-16.685),(7.43,-16.515),(7.6,-16.515),(7.6,-16.685),(7.43,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-16.685),(7.94,-16.515),(8.11,-16.515),(8.11,-16.685),(7.94,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-16.685),(8.45,-16.515),(8.62,-16.515),(8.62,-16.685),(8.45,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-16.685),(8.96,-16.515),(9.13,-16.515),(9.13,-16.685),(8.96,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-16.685),(9.47,-16.515),(9.64,-16.515),(9.64,-16.685),(9.47,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-16.685),(9.98,-16.515),(10.15,-16.515),(10.15,-16.685),(9.98,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-16.685),(10.49,-16.515),(10.66,-16.515),(10.66,-16.685),(10.49,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-16.685),(11.0,-16.515),(11.17,-16.515),(11.17,-16.685),(11.0,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-16.685),(11.51,-16.515),(11.68,-16.515),(11.68,-16.685),(11.51,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-16.685),(12.02,-16.515),(12.19,-16.515),(12.19,-16.685),(12.02,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-16.685),(12.53,-16.515),(12.7,-16.515),(12.7,-16.685),(12.53,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-16.685),(13.04,-16.515),(13.21,-16.515),(13.21,-16.685),(13.04,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-16.685),(13.55,-16.515),(13.72,-16.515),(13.72,-16.685),(13.55,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-16.685),(14.06,-16.515),(14.23,-16.515),(14.23,-16.685),(14.06,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-16.685),(14.57,-16.515),(14.74,-16.515),(14.74,-16.685),(14.57,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-16.685),(15.08,-16.515),(15.25,-16.515),(15.25,-16.685),(15.08,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-16.685),(15.59,-16.515),(15.76,-16.515),(15.76,-16.685),(15.59,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-16.685),(16.1,-16.515),(16.27,-16.515),(16.27,-16.685),(16.1,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-16.685),(16.61,-16.515),(16.78,-16.515),(16.78,-16.685),(16.61,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-16.685),(17.12,-16.515),(17.29,-16.515),(17.29,-16.685),(17.12,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-16.685),(17.63,-16.515),(17.8,-16.515),(17.8,-16.685),(17.63,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-16.685),(18.14,-16.515),(18.31,-16.515),(18.31,-16.685),(18.14,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-16.685),(18.65,-16.515),(18.82,-16.515),(18.82,-16.685),(18.65,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-16.685),(19.16,-16.515),(19.33,-16.515),(19.33,-16.685),(19.16,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-16.685),(19.67,-16.515),(19.84,-16.515),(19.84,-16.685),(19.67,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-16.685),(20.18,-16.515),(20.35,-16.515),(20.35,-16.685),(20.18,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-16.685),(20.69,-16.515),(20.86,-16.515),(20.86,-16.685),(20.69,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-16.685),(21.2,-16.515),(21.37,-16.515),(21.37,-16.685),(21.2,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-16.685),(21.71,-16.515),(21.88,-16.515),(21.88,-16.685),(21.71,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-16.685),(22.22,-16.515),(22.39,-16.515),(22.39,-16.685),(22.22,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-16.685),(22.73,-16.515),(22.9,-16.515),(22.9,-16.685),(22.73,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-16.685),(23.24,-16.515),(23.41,-16.515),(23.41,-16.685),(23.24,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-16.685),(23.75,-16.515),(23.92,-16.515),(23.92,-16.685),(23.75,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-16.685),(24.26,-16.515),(24.43,-16.515),(24.43,-16.685),(24.26,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-16.685),(24.77,-16.515),(24.94,-16.515),(24.94,-16.685),(24.77,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-16.685),(25.28,-16.515),(25.45,-16.515),(25.45,-16.685),(25.28,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-16.685),(25.79,-16.515),(25.96,-16.515),(25.96,-16.685),(25.79,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-16.685),(26.3,-16.515),(26.47,-16.515),(26.47,-16.685),(26.3,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-16.685),(26.81,-16.515),(26.98,-16.515),(26.98,-16.685),(26.81,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-16.685),(27.32,-16.515),(27.49,-16.515),(27.49,-16.685),(27.32,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-16.685),(27.83,-16.515),(28.0,-16.515),(28.0,-16.685),(27.83,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-16.685),(28.34,-16.515),(28.51,-16.515),(28.51,-16.685),(28.34,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-16.685),(28.85,-16.515),(29.02,-16.515),(29.02,-16.685),(28.85,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-16.685),(29.36,-16.515),(29.53,-16.515),(29.53,-16.685),(29.36,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-16.685),(29.87,-16.515),(30.04,-16.515),(30.04,-16.685),(29.87,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-16.685),(30.38,-16.515),(30.55,-16.515),(30.55,-16.685),(30.38,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-16.685),(30.89,-16.515),(31.06,-16.515),(31.06,-16.685),(30.89,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-16.685),(31.4,-16.515),(31.57,-16.515),(31.57,-16.685),(31.4,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-16.685),(31.91,-16.515),(32.08,-16.515),(32.08,-16.685),(31.91,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-16.685),(32.42,-16.515),(32.59,-16.515),(32.59,-16.685),(32.42,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-16.685),(32.93,-16.515),(33.1,-16.515),(33.1,-16.685),(32.93,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-16.685),(33.44,-16.515),(33.61,-16.515),(33.61,-16.685),(33.44,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-16.685),(33.95,-16.515),(34.12,-16.515),(34.12,-16.685),(33.95,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-16.685),(34.46,-16.515),(34.63,-16.515),(34.63,-16.685),(34.46,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-16.685),(34.97,-16.515),(35.14,-16.515),(35.14,-16.685),(34.97,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-16.685),(35.48,-16.515),(35.65,-16.515),(35.65,-16.685),(35.48,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-16.685),(35.99,-16.515),(36.16,-16.515),(36.16,-16.685),(35.99,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-16.685),(36.5,-16.515),(36.67,-16.515),(36.67,-16.685),(36.5,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-16.685),(37.01,-16.515),(37.18,-16.515),(37.18,-16.685),(37.01,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-16.685),(37.52,-16.515),(37.69,-16.515),(37.69,-16.685),(37.52,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-16.685),(38.03,-16.515),(38.2,-16.515),(38.2,-16.685),(38.03,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-16.685),(38.54,-16.515),(38.71,-16.515),(38.71,-16.685),(38.54,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-16.685),(39.05,-16.515),(39.22,-16.515),(39.22,-16.685),(39.05,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-16.685),(39.56,-16.515),(39.73,-16.515),(39.73,-16.685),(39.56,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-16.685),(40.07,-16.515),(40.24,-16.515),(40.24,-16.685),(40.07,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-16.685),(40.58,-16.515),(40.75,-16.515),(40.75,-16.685),(40.58,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-16.685),(41.09,-16.515),(41.26,-16.515),(41.26,-16.685),(41.09,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-16.685),(41.6,-16.515),(41.77,-16.515),(41.77,-16.685),(41.6,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-16.685),(42.11,-16.515),(42.28,-16.515),(42.28,-16.685),(42.11,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-16.685),(42.62,-16.515),(42.79,-16.515),(42.79,-16.685),(42.62,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-16.685),(43.13,-16.515),(43.3,-16.515),(43.3,-16.685),(43.13,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-16.685),(43.64,-16.515),(43.81,-16.515),(43.81,-16.685),(43.64,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-16.685),(44.15,-16.515),(44.32,-16.515),(44.32,-16.685),(44.15,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-16.685),(44.66,-16.515),(44.83,-16.515),(44.83,-16.685),(44.66,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-16.685),(45.17,-16.515),(45.34,-16.515),(45.34,-16.685),(45.17,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-16.685),(45.68,-16.515),(45.85,-16.515),(45.85,-16.685),(45.68,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-16.685),(46.19,-16.515),(46.36,-16.515),(46.36,-16.685),(46.19,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-16.685),(46.7,-16.515),(46.87,-16.515),(46.87,-16.685),(46.7,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-16.685),(47.21,-16.515),(47.38,-16.515),(47.38,-16.685),(47.21,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-16.685),(47.72,-16.515),(47.89,-16.515),(47.89,-16.685),(47.72,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-16.685),(48.23,-16.515),(48.4,-16.515),(48.4,-16.685),(48.23,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-16.685),(48.74,-16.515),(48.91,-16.515),(48.91,-16.685),(48.74,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-16.685),(49.25,-16.515),(49.42,-16.515),(49.42,-16.685),(49.25,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-16.685),(49.76,-16.515),(49.93,-16.515),(49.93,-16.685),(49.76,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-16.685),(50.27,-16.515),(50.44,-16.515),(50.44,-16.685),(50.27,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-16.685),(50.78,-16.515),(50.95,-16.515),(50.95,-16.685),(50.78,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-16.685),(51.29,-16.515),(51.46,-16.515),(51.46,-16.685),(51.29,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-16.685),(51.8,-16.515),(51.97,-16.515),(51.97,-16.685),(51.8,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-16.685),(52.31,-16.515),(52.48,-16.515),(52.48,-16.685),(52.31,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-16.685),(52.82,-16.515),(52.99,-16.515),(52.99,-16.685),(52.82,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-16.685),(53.33,-16.515),(53.5,-16.515),(53.5,-16.685),(53.33,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-16.685),(53.84,-16.515),(54.01,-16.515),(54.01,-16.685),(53.84,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-16.685),(54.35,-16.515),(54.52,-16.515),(54.52,-16.685),(54.35,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-16.685),(54.86,-16.515),(55.03,-16.515),(55.03,-16.685),(54.86,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-16.685),(55.37,-16.515),(55.54,-16.515),(55.54,-16.685),(55.37,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-16.685),(55.88,-16.515),(56.05,-16.515),(56.05,-16.685),(55.88,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-16.685),(56.39,-16.515),(56.56,-16.515),(56.56,-16.685),(56.39,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-16.685),(56.9,-16.515),(57.07,-16.515),(57.07,-16.685),(56.9,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-16.685),(57.41,-16.515),(57.58,-16.515),(57.58,-16.685),(57.41,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-16.685),(57.92,-16.515),(58.09,-16.515),(58.09,-16.685),(57.92,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-16.685),(58.43,-16.515),(58.6,-16.515),(58.6,-16.685),(58.43,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-16.685),(58.94,-16.515),(59.11,-16.515),(59.11,-16.685),(58.94,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-16.685),(59.45,-16.515),(59.62,-16.515),(59.62,-16.685),(59.45,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-16.685),(59.96,-16.515),(60.13,-16.515),(60.13,-16.685),(59.96,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-16.685),(60.47,-16.515),(60.64,-16.515),(60.64,-16.685),(60.47,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-16.685),(60.98,-16.515),(61.15,-16.515),(61.15,-16.685),(60.98,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-16.685),(61.49,-16.515),(61.66,-16.515),(61.66,-16.685),(61.49,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-16.685),(62.0,-16.515),(62.17,-16.515),(62.17,-16.685),(62.0,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-16.685),(62.51,-16.515),(62.68,-16.515),(62.68,-16.685),(62.51,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-16.685),(63.02,-16.515),(63.19,-16.515),(63.19,-16.685),(63.02,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-16.685),(63.53,-16.515),(63.7,-16.515),(63.7,-16.685),(63.53,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-16.685),(64.04,-16.515),(64.21,-16.515),(64.21,-16.685),(64.04,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-16.685),(64.55,-16.515),(64.72,-16.515),(64.72,-16.685),(64.55,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-16.685),(65.06,-16.515),(65.23,-16.515),(65.23,-16.685),(65.06,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-16.685),(65.57,-16.515),(65.74,-16.515),(65.74,-16.685),(65.57,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-16.685),(66.08,-16.515),(66.25,-16.515),(66.25,-16.685),(66.08,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-16.685),(66.59,-16.515),(66.76,-16.515),(66.76,-16.685),(66.59,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-16.685),(67.1,-16.515),(67.27,-16.515),(67.27,-16.685),(67.1,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-16.685),(67.61,-16.515),(67.78,-16.515),(67.78,-16.685),(67.61,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-16.685),(68.12,-16.515),(68.29,-16.515),(68.29,-16.685),(68.12,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-16.685),(68.63,-16.515),(68.8,-16.515),(68.8,-16.685),(68.63,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-16.685),(69.14,-16.515),(69.31,-16.515),(69.31,-16.685),(69.14,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-16.685),(69.65,-16.515),(69.82,-16.515),(69.82,-16.685),(69.65,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-16.685),(70.16,-16.515),(70.33,-16.515),(70.33,-16.685),(70.16,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-16.685),(70.67,-16.515),(70.84,-16.515),(70.84,-16.685),(70.67,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-16.685),(71.18,-16.515),(71.35,-16.515),(71.35,-16.685),(71.18,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-16.685),(71.69,-16.515),(71.86,-16.515),(71.86,-16.685),(71.69,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-16.685),(72.2,-16.515),(72.37,-16.515),(72.37,-16.685),(72.2,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-16.685),(72.71,-16.515),(72.88,-16.515),(72.88,-16.685),(72.71,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-16.685),(73.22,-16.515),(73.39,-16.515),(73.39,-16.685),(73.22,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-16.685),(73.73,-16.515),(73.9,-16.515),(73.9,-16.685),(73.73,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-16.685),(74.24,-16.515),(74.41,-16.515),(74.41,-16.685),(74.24,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-16.685),(74.75,-16.515),(74.92,-16.515),(74.92,-16.685),(74.75,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-16.685),(75.26,-16.515),(75.43,-16.515),(75.43,-16.685),(75.26,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-16.685),(75.77,-16.515),(75.94,-16.515),(75.94,-16.685),(75.77,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-16.685),(76.28,-16.515),(76.45,-16.515),(76.45,-16.685),(76.28,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-16.685),(76.79,-16.515),(76.96,-16.515),(76.96,-16.685),(76.79,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-16.685),(77.3,-16.515),(77.47,-16.515),(77.47,-16.685),(77.3,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-16.685),(77.81,-16.515),(77.98,-16.515),(77.98,-16.685),(77.81,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-16.685),(78.32,-16.515),(78.49,-16.515),(78.49,-16.685),(78.32,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-16.685),(78.83,-16.515),(79.0,-16.515),(79.0,-16.685),(78.83,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-16.685),(79.34,-16.515),(79.51,-16.515),(79.51,-16.685),(79.34,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-16.685),(79.85,-16.515),(80.02,-16.515),(80.02,-16.685),(79.85,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-16.685),(80.36,-16.515),(80.53,-16.515),(80.53,-16.685),(80.36,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-16.685),(80.87,-16.515),(81.04,-16.515),(81.04,-16.685),(80.87,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-16.685),(81.38,-16.515),(81.55,-16.515),(81.55,-16.685),(81.38,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-16.685),(81.89,-16.515),(82.06,-16.515),(82.06,-16.685),(81.89,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-16.685),(82.4,-16.515),(82.57,-16.515),(82.57,-16.685),(82.4,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-16.685),(82.91,-16.515),(83.08,-16.515),(83.08,-16.685),(82.91,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-16.685),(83.42,-16.515),(83.59,-16.515),(83.59,-16.685),(83.42,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-16.685),(83.93,-16.515),(84.1,-16.515),(84.1,-16.685),(83.93,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-16.685),(84.44,-16.515),(84.61,-16.515),(84.61,-16.685),(84.44,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-16.685),(84.95,-16.515),(85.12,-16.515),(85.12,-16.685),(84.95,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-16.685),(85.46,-16.515),(85.63,-16.515),(85.63,-16.685),(85.46,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-16.685),(85.97,-16.515),(86.14,-16.515),(86.14,-16.685),(85.97,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-16.685),(86.48,-16.515),(86.65,-16.515),(86.65,-16.685),(86.48,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-16.685),(86.99,-16.515),(87.16,-16.515),(87.16,-16.685),(86.99,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-16.685),(87.5,-16.515),(87.67,-16.515),(87.67,-16.685),(87.5,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-16.685),(88.01,-16.515),(88.18,-16.515),(88.18,-16.685),(88.01,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-16.685),(88.52,-16.515),(88.69,-16.515),(88.69,-16.685),(88.52,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-16.685),(89.03,-16.515),(89.2,-16.515),(89.2,-16.685),(89.03,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-16.685),(89.54,-16.515),(89.71,-16.515),(89.71,-16.685),(89.54,-16.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-16.175),(0.29,-16.005),(0.46,-16.005),(0.46,-16.175),(0.29,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-16.175),(0.8,-16.005),(0.97,-16.005),(0.97,-16.175),(0.8,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-16.175),(1.31,-16.005),(1.48,-16.005),(1.48,-16.175),(1.31,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-16.175),(1.82,-16.005),(1.99,-16.005),(1.99,-16.175),(1.82,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-16.175),(2.33,-16.005),(2.5,-16.005),(2.5,-16.175),(2.33,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-16.175),(2.84,-16.005),(3.01,-16.005),(3.01,-16.175),(2.84,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-16.175),(3.35,-16.005),(3.52,-16.005),(3.52,-16.175),(3.35,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-16.175),(3.86,-16.005),(4.03,-16.005),(4.03,-16.175),(3.86,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-16.175),(4.37,-16.005),(4.54,-16.005),(4.54,-16.175),(4.37,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-16.175),(4.88,-16.005),(5.05,-16.005),(5.05,-16.175),(4.88,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-16.175),(5.39,-16.005),(5.56,-16.005),(5.56,-16.175),(5.39,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-16.175),(5.9,-16.005),(6.07,-16.005),(6.07,-16.175),(5.9,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-16.175),(6.41,-16.005),(6.58,-16.005),(6.58,-16.175),(6.41,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-16.175),(6.92,-16.005),(7.09,-16.005),(7.09,-16.175),(6.92,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-16.175),(7.43,-16.005),(7.6,-16.005),(7.6,-16.175),(7.43,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-16.175),(7.94,-16.005),(8.11,-16.005),(8.11,-16.175),(7.94,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-16.175),(8.45,-16.005),(8.62,-16.005),(8.62,-16.175),(8.45,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-16.175),(8.96,-16.005),(9.13,-16.005),(9.13,-16.175),(8.96,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-16.175),(9.47,-16.005),(9.64,-16.005),(9.64,-16.175),(9.47,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-16.175),(9.98,-16.005),(10.15,-16.005),(10.15,-16.175),(9.98,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-16.175),(10.49,-16.005),(10.66,-16.005),(10.66,-16.175),(10.49,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-16.175),(11.0,-16.005),(11.17,-16.005),(11.17,-16.175),(11.0,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-16.175),(11.51,-16.005),(11.68,-16.005),(11.68,-16.175),(11.51,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-16.175),(12.02,-16.005),(12.19,-16.005),(12.19,-16.175),(12.02,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-16.175),(12.53,-16.005),(12.7,-16.005),(12.7,-16.175),(12.53,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-16.175),(13.04,-16.005),(13.21,-16.005),(13.21,-16.175),(13.04,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-16.175),(13.55,-16.005),(13.72,-16.005),(13.72,-16.175),(13.55,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-16.175),(14.06,-16.005),(14.23,-16.005),(14.23,-16.175),(14.06,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-16.175),(14.57,-16.005),(14.74,-16.005),(14.74,-16.175),(14.57,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-16.175),(15.08,-16.005),(15.25,-16.005),(15.25,-16.175),(15.08,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-16.175),(15.59,-16.005),(15.76,-16.005),(15.76,-16.175),(15.59,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-16.175),(16.1,-16.005),(16.27,-16.005),(16.27,-16.175),(16.1,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-16.175),(16.61,-16.005),(16.78,-16.005),(16.78,-16.175),(16.61,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-16.175),(17.12,-16.005),(17.29,-16.005),(17.29,-16.175),(17.12,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-16.175),(17.63,-16.005),(17.8,-16.005),(17.8,-16.175),(17.63,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-16.175),(18.14,-16.005),(18.31,-16.005),(18.31,-16.175),(18.14,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-16.175),(18.65,-16.005),(18.82,-16.005),(18.82,-16.175),(18.65,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-16.175),(19.16,-16.005),(19.33,-16.005),(19.33,-16.175),(19.16,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-16.175),(19.67,-16.005),(19.84,-16.005),(19.84,-16.175),(19.67,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-16.175),(20.18,-16.005),(20.35,-16.005),(20.35,-16.175),(20.18,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-16.175),(20.69,-16.005),(20.86,-16.005),(20.86,-16.175),(20.69,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-16.175),(21.2,-16.005),(21.37,-16.005),(21.37,-16.175),(21.2,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-16.175),(21.71,-16.005),(21.88,-16.005),(21.88,-16.175),(21.71,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-16.175),(22.22,-16.005),(22.39,-16.005),(22.39,-16.175),(22.22,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-16.175),(22.73,-16.005),(22.9,-16.005),(22.9,-16.175),(22.73,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-16.175),(23.24,-16.005),(23.41,-16.005),(23.41,-16.175),(23.24,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-16.175),(23.75,-16.005),(23.92,-16.005),(23.92,-16.175),(23.75,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-16.175),(24.26,-16.005),(24.43,-16.005),(24.43,-16.175),(24.26,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-16.175),(24.77,-16.005),(24.94,-16.005),(24.94,-16.175),(24.77,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-16.175),(25.28,-16.005),(25.45,-16.005),(25.45,-16.175),(25.28,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-16.175),(25.79,-16.005),(25.96,-16.005),(25.96,-16.175),(25.79,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-16.175),(26.3,-16.005),(26.47,-16.005),(26.47,-16.175),(26.3,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-16.175),(26.81,-16.005),(26.98,-16.005),(26.98,-16.175),(26.81,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-16.175),(27.32,-16.005),(27.49,-16.005),(27.49,-16.175),(27.32,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-16.175),(27.83,-16.005),(28.0,-16.005),(28.0,-16.175),(27.83,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-16.175),(28.34,-16.005),(28.51,-16.005),(28.51,-16.175),(28.34,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-16.175),(28.85,-16.005),(29.02,-16.005),(29.02,-16.175),(28.85,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-16.175),(29.36,-16.005),(29.53,-16.005),(29.53,-16.175),(29.36,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-16.175),(29.87,-16.005),(30.04,-16.005),(30.04,-16.175),(29.87,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-16.175),(30.38,-16.005),(30.55,-16.005),(30.55,-16.175),(30.38,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-16.175),(30.89,-16.005),(31.06,-16.005),(31.06,-16.175),(30.89,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-16.175),(31.4,-16.005),(31.57,-16.005),(31.57,-16.175),(31.4,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-16.175),(31.91,-16.005),(32.08,-16.005),(32.08,-16.175),(31.91,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-16.175),(32.42,-16.005),(32.59,-16.005),(32.59,-16.175),(32.42,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-16.175),(32.93,-16.005),(33.1,-16.005),(33.1,-16.175),(32.93,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-16.175),(33.44,-16.005),(33.61,-16.005),(33.61,-16.175),(33.44,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-16.175),(33.95,-16.005),(34.12,-16.005),(34.12,-16.175),(33.95,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-16.175),(34.46,-16.005),(34.63,-16.005),(34.63,-16.175),(34.46,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-16.175),(34.97,-16.005),(35.14,-16.005),(35.14,-16.175),(34.97,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-16.175),(35.48,-16.005),(35.65,-16.005),(35.65,-16.175),(35.48,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-16.175),(35.99,-16.005),(36.16,-16.005),(36.16,-16.175),(35.99,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-16.175),(36.5,-16.005),(36.67,-16.005),(36.67,-16.175),(36.5,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-16.175),(37.01,-16.005),(37.18,-16.005),(37.18,-16.175),(37.01,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-16.175),(37.52,-16.005),(37.69,-16.005),(37.69,-16.175),(37.52,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-16.175),(38.03,-16.005),(38.2,-16.005),(38.2,-16.175),(38.03,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-16.175),(38.54,-16.005),(38.71,-16.005),(38.71,-16.175),(38.54,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-16.175),(39.05,-16.005),(39.22,-16.005),(39.22,-16.175),(39.05,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-16.175),(39.56,-16.005),(39.73,-16.005),(39.73,-16.175),(39.56,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-16.175),(40.07,-16.005),(40.24,-16.005),(40.24,-16.175),(40.07,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-16.175),(40.58,-16.005),(40.75,-16.005),(40.75,-16.175),(40.58,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-16.175),(41.09,-16.005),(41.26,-16.005),(41.26,-16.175),(41.09,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-16.175),(41.6,-16.005),(41.77,-16.005),(41.77,-16.175),(41.6,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-16.175),(42.11,-16.005),(42.28,-16.005),(42.28,-16.175),(42.11,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-16.175),(42.62,-16.005),(42.79,-16.005),(42.79,-16.175),(42.62,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-16.175),(43.13,-16.005),(43.3,-16.005),(43.3,-16.175),(43.13,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-16.175),(43.64,-16.005),(43.81,-16.005),(43.81,-16.175),(43.64,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-16.175),(44.15,-16.005),(44.32,-16.005),(44.32,-16.175),(44.15,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-16.175),(44.66,-16.005),(44.83,-16.005),(44.83,-16.175),(44.66,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-16.175),(45.17,-16.005),(45.34,-16.005),(45.34,-16.175),(45.17,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-16.175),(45.68,-16.005),(45.85,-16.005),(45.85,-16.175),(45.68,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-16.175),(46.19,-16.005),(46.36,-16.005),(46.36,-16.175),(46.19,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-16.175),(46.7,-16.005),(46.87,-16.005),(46.87,-16.175),(46.7,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-16.175),(47.21,-16.005),(47.38,-16.005),(47.38,-16.175),(47.21,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-16.175),(47.72,-16.005),(47.89,-16.005),(47.89,-16.175),(47.72,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-16.175),(48.23,-16.005),(48.4,-16.005),(48.4,-16.175),(48.23,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-16.175),(48.74,-16.005),(48.91,-16.005),(48.91,-16.175),(48.74,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-16.175),(49.25,-16.005),(49.42,-16.005),(49.42,-16.175),(49.25,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-16.175),(49.76,-16.005),(49.93,-16.005),(49.93,-16.175),(49.76,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-16.175),(50.27,-16.005),(50.44,-16.005),(50.44,-16.175),(50.27,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-16.175),(50.78,-16.005),(50.95,-16.005),(50.95,-16.175),(50.78,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-16.175),(51.29,-16.005),(51.46,-16.005),(51.46,-16.175),(51.29,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-16.175),(51.8,-16.005),(51.97,-16.005),(51.97,-16.175),(51.8,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-16.175),(52.31,-16.005),(52.48,-16.005),(52.48,-16.175),(52.31,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-16.175),(52.82,-16.005),(52.99,-16.005),(52.99,-16.175),(52.82,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-16.175),(53.33,-16.005),(53.5,-16.005),(53.5,-16.175),(53.33,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-16.175),(53.84,-16.005),(54.01,-16.005),(54.01,-16.175),(53.84,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-16.175),(54.35,-16.005),(54.52,-16.005),(54.52,-16.175),(54.35,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-16.175),(54.86,-16.005),(55.03,-16.005),(55.03,-16.175),(54.86,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-16.175),(55.37,-16.005),(55.54,-16.005),(55.54,-16.175),(55.37,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-16.175),(55.88,-16.005),(56.05,-16.005),(56.05,-16.175),(55.88,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-16.175),(56.39,-16.005),(56.56,-16.005),(56.56,-16.175),(56.39,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-16.175),(56.9,-16.005),(57.07,-16.005),(57.07,-16.175),(56.9,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-16.175),(57.41,-16.005),(57.58,-16.005),(57.58,-16.175),(57.41,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-16.175),(57.92,-16.005),(58.09,-16.005),(58.09,-16.175),(57.92,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-16.175),(58.43,-16.005),(58.6,-16.005),(58.6,-16.175),(58.43,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-16.175),(58.94,-16.005),(59.11,-16.005),(59.11,-16.175),(58.94,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-16.175),(59.45,-16.005),(59.62,-16.005),(59.62,-16.175),(59.45,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-16.175),(59.96,-16.005),(60.13,-16.005),(60.13,-16.175),(59.96,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-16.175),(60.47,-16.005),(60.64,-16.005),(60.64,-16.175),(60.47,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-16.175),(60.98,-16.005),(61.15,-16.005),(61.15,-16.175),(60.98,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-16.175),(61.49,-16.005),(61.66,-16.005),(61.66,-16.175),(61.49,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-16.175),(62.0,-16.005),(62.17,-16.005),(62.17,-16.175),(62.0,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-16.175),(62.51,-16.005),(62.68,-16.005),(62.68,-16.175),(62.51,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-16.175),(63.02,-16.005),(63.19,-16.005),(63.19,-16.175),(63.02,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-16.175),(63.53,-16.005),(63.7,-16.005),(63.7,-16.175),(63.53,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-16.175),(64.04,-16.005),(64.21,-16.005),(64.21,-16.175),(64.04,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-16.175),(64.55,-16.005),(64.72,-16.005),(64.72,-16.175),(64.55,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-16.175),(65.06,-16.005),(65.23,-16.005),(65.23,-16.175),(65.06,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-16.175),(65.57,-16.005),(65.74,-16.005),(65.74,-16.175),(65.57,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-16.175),(66.08,-16.005),(66.25,-16.005),(66.25,-16.175),(66.08,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-16.175),(66.59,-16.005),(66.76,-16.005),(66.76,-16.175),(66.59,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-16.175),(67.1,-16.005),(67.27,-16.005),(67.27,-16.175),(67.1,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-16.175),(67.61,-16.005),(67.78,-16.005),(67.78,-16.175),(67.61,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-16.175),(68.12,-16.005),(68.29,-16.005),(68.29,-16.175),(68.12,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-16.175),(68.63,-16.005),(68.8,-16.005),(68.8,-16.175),(68.63,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-16.175),(69.14,-16.005),(69.31,-16.005),(69.31,-16.175),(69.14,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-16.175),(69.65,-16.005),(69.82,-16.005),(69.82,-16.175),(69.65,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-16.175),(70.16,-16.005),(70.33,-16.005),(70.33,-16.175),(70.16,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-16.175),(70.67,-16.005),(70.84,-16.005),(70.84,-16.175),(70.67,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-16.175),(71.18,-16.005),(71.35,-16.005),(71.35,-16.175),(71.18,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-16.175),(71.69,-16.005),(71.86,-16.005),(71.86,-16.175),(71.69,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-16.175),(72.2,-16.005),(72.37,-16.005),(72.37,-16.175),(72.2,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-16.175),(72.71,-16.005),(72.88,-16.005),(72.88,-16.175),(72.71,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-16.175),(73.22,-16.005),(73.39,-16.005),(73.39,-16.175),(73.22,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-16.175),(73.73,-16.005),(73.9,-16.005),(73.9,-16.175),(73.73,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-16.175),(74.24,-16.005),(74.41,-16.005),(74.41,-16.175),(74.24,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-16.175),(74.75,-16.005),(74.92,-16.005),(74.92,-16.175),(74.75,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-16.175),(75.26,-16.005),(75.43,-16.005),(75.43,-16.175),(75.26,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-16.175),(75.77,-16.005),(75.94,-16.005),(75.94,-16.175),(75.77,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-16.175),(76.28,-16.005),(76.45,-16.005),(76.45,-16.175),(76.28,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-16.175),(76.79,-16.005),(76.96,-16.005),(76.96,-16.175),(76.79,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-16.175),(77.3,-16.005),(77.47,-16.005),(77.47,-16.175),(77.3,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-16.175),(77.81,-16.005),(77.98,-16.005),(77.98,-16.175),(77.81,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-16.175),(78.32,-16.005),(78.49,-16.005),(78.49,-16.175),(78.32,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-16.175),(78.83,-16.005),(79.0,-16.005),(79.0,-16.175),(78.83,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-16.175),(79.34,-16.005),(79.51,-16.005),(79.51,-16.175),(79.34,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-16.175),(79.85,-16.005),(80.02,-16.005),(80.02,-16.175),(79.85,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-16.175),(80.36,-16.005),(80.53,-16.005),(80.53,-16.175),(80.36,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-16.175),(80.87,-16.005),(81.04,-16.005),(81.04,-16.175),(80.87,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-16.175),(81.38,-16.005),(81.55,-16.005),(81.55,-16.175),(81.38,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-16.175),(81.89,-16.005),(82.06,-16.005),(82.06,-16.175),(81.89,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-16.175),(82.4,-16.005),(82.57,-16.005),(82.57,-16.175),(82.4,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-16.175),(82.91,-16.005),(83.08,-16.005),(83.08,-16.175),(82.91,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-16.175),(83.42,-16.005),(83.59,-16.005),(83.59,-16.175),(83.42,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-16.175),(83.93,-16.005),(84.1,-16.005),(84.1,-16.175),(83.93,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-16.175),(84.44,-16.005),(84.61,-16.005),(84.61,-16.175),(84.44,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-16.175),(84.95,-16.005),(85.12,-16.005),(85.12,-16.175),(84.95,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-16.175),(85.46,-16.005),(85.63,-16.005),(85.63,-16.175),(85.46,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-16.175),(85.97,-16.005),(86.14,-16.005),(86.14,-16.175),(85.97,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-16.175),(86.48,-16.005),(86.65,-16.005),(86.65,-16.175),(86.48,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-16.175),(86.99,-16.005),(87.16,-16.005),(87.16,-16.175),(86.99,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-16.175),(87.5,-16.005),(87.67,-16.005),(87.67,-16.175),(87.5,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-16.175),(88.01,-16.005),(88.18,-16.005),(88.18,-16.175),(88.01,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-16.175),(88.52,-16.005),(88.69,-16.005),(88.69,-16.175),(88.52,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-16.175),(89.03,-16.005),(89.2,-16.005),(89.2,-16.175),(89.03,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-16.175),(89.54,-16.005),(89.71,-16.005),(89.71,-16.175),(89.54,-16.175)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-15.665),(0.29,-15.495),(0.46,-15.495),(0.46,-15.665),(0.29,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-15.665),(0.8,-15.495),(0.97,-15.495),(0.97,-15.665),(0.8,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-15.665),(1.31,-15.495),(1.48,-15.495),(1.48,-15.665),(1.31,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-15.665),(1.82,-15.495),(1.99,-15.495),(1.99,-15.665),(1.82,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-15.665),(2.33,-15.495),(2.5,-15.495),(2.5,-15.665),(2.33,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-15.665),(2.84,-15.495),(3.01,-15.495),(3.01,-15.665),(2.84,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-15.665),(3.35,-15.495),(3.52,-15.495),(3.52,-15.665),(3.35,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-15.665),(3.86,-15.495),(4.03,-15.495),(4.03,-15.665),(3.86,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-15.665),(4.37,-15.495),(4.54,-15.495),(4.54,-15.665),(4.37,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-15.665),(4.88,-15.495),(5.05,-15.495),(5.05,-15.665),(4.88,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-15.665),(5.39,-15.495),(5.56,-15.495),(5.56,-15.665),(5.39,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-15.665),(5.9,-15.495),(6.07,-15.495),(6.07,-15.665),(5.9,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-15.665),(6.41,-15.495),(6.58,-15.495),(6.58,-15.665),(6.41,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-15.665),(6.92,-15.495),(7.09,-15.495),(7.09,-15.665),(6.92,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-15.665),(7.43,-15.495),(7.6,-15.495),(7.6,-15.665),(7.43,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-15.665),(7.94,-15.495),(8.11,-15.495),(8.11,-15.665),(7.94,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-15.665),(8.45,-15.495),(8.62,-15.495),(8.62,-15.665),(8.45,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-15.665),(8.96,-15.495),(9.13,-15.495),(9.13,-15.665),(8.96,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-15.665),(9.47,-15.495),(9.64,-15.495),(9.64,-15.665),(9.47,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-15.665),(9.98,-15.495),(10.15,-15.495),(10.15,-15.665),(9.98,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-15.665),(10.49,-15.495),(10.66,-15.495),(10.66,-15.665),(10.49,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-15.665),(11.0,-15.495),(11.17,-15.495),(11.17,-15.665),(11.0,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-15.665),(11.51,-15.495),(11.68,-15.495),(11.68,-15.665),(11.51,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-15.665),(12.02,-15.495),(12.19,-15.495),(12.19,-15.665),(12.02,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-15.665),(12.53,-15.495),(12.7,-15.495),(12.7,-15.665),(12.53,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-15.665),(13.04,-15.495),(13.21,-15.495),(13.21,-15.665),(13.04,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-15.665),(13.55,-15.495),(13.72,-15.495),(13.72,-15.665),(13.55,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-15.665),(14.06,-15.495),(14.23,-15.495),(14.23,-15.665),(14.06,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-15.665),(14.57,-15.495),(14.74,-15.495),(14.74,-15.665),(14.57,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-15.665),(15.08,-15.495),(15.25,-15.495),(15.25,-15.665),(15.08,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-15.665),(15.59,-15.495),(15.76,-15.495),(15.76,-15.665),(15.59,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-15.665),(16.1,-15.495),(16.27,-15.495),(16.27,-15.665),(16.1,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-15.665),(16.61,-15.495),(16.78,-15.495),(16.78,-15.665),(16.61,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-15.665),(17.12,-15.495),(17.29,-15.495),(17.29,-15.665),(17.12,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-15.665),(17.63,-15.495),(17.8,-15.495),(17.8,-15.665),(17.63,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-15.665),(18.14,-15.495),(18.31,-15.495),(18.31,-15.665),(18.14,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-15.665),(18.65,-15.495),(18.82,-15.495),(18.82,-15.665),(18.65,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-15.665),(19.16,-15.495),(19.33,-15.495),(19.33,-15.665),(19.16,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-15.665),(19.67,-15.495),(19.84,-15.495),(19.84,-15.665),(19.67,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-15.665),(20.18,-15.495),(20.35,-15.495),(20.35,-15.665),(20.18,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-15.665),(20.69,-15.495),(20.86,-15.495),(20.86,-15.665),(20.69,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-15.665),(21.2,-15.495),(21.37,-15.495),(21.37,-15.665),(21.2,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-15.665),(21.71,-15.495),(21.88,-15.495),(21.88,-15.665),(21.71,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-15.665),(22.22,-15.495),(22.39,-15.495),(22.39,-15.665),(22.22,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-15.665),(22.73,-15.495),(22.9,-15.495),(22.9,-15.665),(22.73,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-15.665),(23.24,-15.495),(23.41,-15.495),(23.41,-15.665),(23.24,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-15.665),(23.75,-15.495),(23.92,-15.495),(23.92,-15.665),(23.75,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-15.665),(24.26,-15.495),(24.43,-15.495),(24.43,-15.665),(24.26,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-15.665),(24.77,-15.495),(24.94,-15.495),(24.94,-15.665),(24.77,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-15.665),(25.28,-15.495),(25.45,-15.495),(25.45,-15.665),(25.28,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-15.665),(25.79,-15.495),(25.96,-15.495),(25.96,-15.665),(25.79,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-15.665),(26.3,-15.495),(26.47,-15.495),(26.47,-15.665),(26.3,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-15.665),(26.81,-15.495),(26.98,-15.495),(26.98,-15.665),(26.81,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-15.665),(27.32,-15.495),(27.49,-15.495),(27.49,-15.665),(27.32,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-15.665),(27.83,-15.495),(28.0,-15.495),(28.0,-15.665),(27.83,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-15.665),(28.34,-15.495),(28.51,-15.495),(28.51,-15.665),(28.34,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-15.665),(28.85,-15.495),(29.02,-15.495),(29.02,-15.665),(28.85,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-15.665),(29.36,-15.495),(29.53,-15.495),(29.53,-15.665),(29.36,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-15.665),(29.87,-15.495),(30.04,-15.495),(30.04,-15.665),(29.87,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-15.665),(30.38,-15.495),(30.55,-15.495),(30.55,-15.665),(30.38,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-15.665),(30.89,-15.495),(31.06,-15.495),(31.06,-15.665),(30.89,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-15.665),(31.4,-15.495),(31.57,-15.495),(31.57,-15.665),(31.4,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-15.665),(31.91,-15.495),(32.08,-15.495),(32.08,-15.665),(31.91,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-15.665),(32.42,-15.495),(32.59,-15.495),(32.59,-15.665),(32.42,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-15.665),(32.93,-15.495),(33.1,-15.495),(33.1,-15.665),(32.93,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-15.665),(33.44,-15.495),(33.61,-15.495),(33.61,-15.665),(33.44,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-15.665),(33.95,-15.495),(34.12,-15.495),(34.12,-15.665),(33.95,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-15.665),(34.46,-15.495),(34.63,-15.495),(34.63,-15.665),(34.46,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-15.665),(34.97,-15.495),(35.14,-15.495),(35.14,-15.665),(34.97,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-15.665),(35.48,-15.495),(35.65,-15.495),(35.65,-15.665),(35.48,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-15.665),(35.99,-15.495),(36.16,-15.495),(36.16,-15.665),(35.99,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-15.665),(36.5,-15.495),(36.67,-15.495),(36.67,-15.665),(36.5,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-15.665),(37.01,-15.495),(37.18,-15.495),(37.18,-15.665),(37.01,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-15.665),(37.52,-15.495),(37.69,-15.495),(37.69,-15.665),(37.52,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-15.665),(38.03,-15.495),(38.2,-15.495),(38.2,-15.665),(38.03,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-15.665),(38.54,-15.495),(38.71,-15.495),(38.71,-15.665),(38.54,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-15.665),(39.05,-15.495),(39.22,-15.495),(39.22,-15.665),(39.05,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-15.665),(39.56,-15.495),(39.73,-15.495),(39.73,-15.665),(39.56,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-15.665),(40.07,-15.495),(40.24,-15.495),(40.24,-15.665),(40.07,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-15.665),(40.58,-15.495),(40.75,-15.495),(40.75,-15.665),(40.58,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-15.665),(41.09,-15.495),(41.26,-15.495),(41.26,-15.665),(41.09,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-15.665),(41.6,-15.495),(41.77,-15.495),(41.77,-15.665),(41.6,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-15.665),(42.11,-15.495),(42.28,-15.495),(42.28,-15.665),(42.11,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-15.665),(42.62,-15.495),(42.79,-15.495),(42.79,-15.665),(42.62,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-15.665),(43.13,-15.495),(43.3,-15.495),(43.3,-15.665),(43.13,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-15.665),(43.64,-15.495),(43.81,-15.495),(43.81,-15.665),(43.64,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-15.665),(44.15,-15.495),(44.32,-15.495),(44.32,-15.665),(44.15,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-15.665),(44.66,-15.495),(44.83,-15.495),(44.83,-15.665),(44.66,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-15.665),(45.17,-15.495),(45.34,-15.495),(45.34,-15.665),(45.17,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-15.665),(45.68,-15.495),(45.85,-15.495),(45.85,-15.665),(45.68,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-15.665),(46.19,-15.495),(46.36,-15.495),(46.36,-15.665),(46.19,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-15.665),(46.7,-15.495),(46.87,-15.495),(46.87,-15.665),(46.7,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-15.665),(47.21,-15.495),(47.38,-15.495),(47.38,-15.665),(47.21,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-15.665),(47.72,-15.495),(47.89,-15.495),(47.89,-15.665),(47.72,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-15.665),(48.23,-15.495),(48.4,-15.495),(48.4,-15.665),(48.23,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-15.665),(48.74,-15.495),(48.91,-15.495),(48.91,-15.665),(48.74,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-15.665),(49.25,-15.495),(49.42,-15.495),(49.42,-15.665),(49.25,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-15.665),(49.76,-15.495),(49.93,-15.495),(49.93,-15.665),(49.76,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-15.665),(50.27,-15.495),(50.44,-15.495),(50.44,-15.665),(50.27,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-15.665),(50.78,-15.495),(50.95,-15.495),(50.95,-15.665),(50.78,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-15.665),(51.29,-15.495),(51.46,-15.495),(51.46,-15.665),(51.29,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-15.665),(51.8,-15.495),(51.97,-15.495),(51.97,-15.665),(51.8,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-15.665),(52.31,-15.495),(52.48,-15.495),(52.48,-15.665),(52.31,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-15.665),(52.82,-15.495),(52.99,-15.495),(52.99,-15.665),(52.82,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-15.665),(53.33,-15.495),(53.5,-15.495),(53.5,-15.665),(53.33,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-15.665),(53.84,-15.495),(54.01,-15.495),(54.01,-15.665),(53.84,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-15.665),(54.35,-15.495),(54.52,-15.495),(54.52,-15.665),(54.35,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-15.665),(54.86,-15.495),(55.03,-15.495),(55.03,-15.665),(54.86,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-15.665),(55.37,-15.495),(55.54,-15.495),(55.54,-15.665),(55.37,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-15.665),(55.88,-15.495),(56.05,-15.495),(56.05,-15.665),(55.88,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-15.665),(56.39,-15.495),(56.56,-15.495),(56.56,-15.665),(56.39,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-15.665),(56.9,-15.495),(57.07,-15.495),(57.07,-15.665),(56.9,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-15.665),(57.41,-15.495),(57.58,-15.495),(57.58,-15.665),(57.41,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-15.665),(57.92,-15.495),(58.09,-15.495),(58.09,-15.665),(57.92,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-15.665),(58.43,-15.495),(58.6,-15.495),(58.6,-15.665),(58.43,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-15.665),(58.94,-15.495),(59.11,-15.495),(59.11,-15.665),(58.94,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-15.665),(59.45,-15.495),(59.62,-15.495),(59.62,-15.665),(59.45,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-15.665),(59.96,-15.495),(60.13,-15.495),(60.13,-15.665),(59.96,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-15.665),(60.47,-15.495),(60.64,-15.495),(60.64,-15.665),(60.47,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-15.665),(60.98,-15.495),(61.15,-15.495),(61.15,-15.665),(60.98,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-15.665),(61.49,-15.495),(61.66,-15.495),(61.66,-15.665),(61.49,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-15.665),(62.0,-15.495),(62.17,-15.495),(62.17,-15.665),(62.0,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-15.665),(62.51,-15.495),(62.68,-15.495),(62.68,-15.665),(62.51,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-15.665),(63.02,-15.495),(63.19,-15.495),(63.19,-15.665),(63.02,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-15.665),(63.53,-15.495),(63.7,-15.495),(63.7,-15.665),(63.53,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-15.665),(64.04,-15.495),(64.21,-15.495),(64.21,-15.665),(64.04,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-15.665),(64.55,-15.495),(64.72,-15.495),(64.72,-15.665),(64.55,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-15.665),(65.06,-15.495),(65.23,-15.495),(65.23,-15.665),(65.06,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-15.665),(65.57,-15.495),(65.74,-15.495),(65.74,-15.665),(65.57,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-15.665),(66.08,-15.495),(66.25,-15.495),(66.25,-15.665),(66.08,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-15.665),(66.59,-15.495),(66.76,-15.495),(66.76,-15.665),(66.59,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-15.665),(67.1,-15.495),(67.27,-15.495),(67.27,-15.665),(67.1,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-15.665),(67.61,-15.495),(67.78,-15.495),(67.78,-15.665),(67.61,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-15.665),(68.12,-15.495),(68.29,-15.495),(68.29,-15.665),(68.12,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-15.665),(68.63,-15.495),(68.8,-15.495),(68.8,-15.665),(68.63,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-15.665),(69.14,-15.495),(69.31,-15.495),(69.31,-15.665),(69.14,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-15.665),(69.65,-15.495),(69.82,-15.495),(69.82,-15.665),(69.65,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-15.665),(70.16,-15.495),(70.33,-15.495),(70.33,-15.665),(70.16,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-15.665),(70.67,-15.495),(70.84,-15.495),(70.84,-15.665),(70.67,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-15.665),(71.18,-15.495),(71.35,-15.495),(71.35,-15.665),(71.18,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-15.665),(71.69,-15.495),(71.86,-15.495),(71.86,-15.665),(71.69,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-15.665),(72.2,-15.495),(72.37,-15.495),(72.37,-15.665),(72.2,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-15.665),(72.71,-15.495),(72.88,-15.495),(72.88,-15.665),(72.71,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-15.665),(73.22,-15.495),(73.39,-15.495),(73.39,-15.665),(73.22,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-15.665),(73.73,-15.495),(73.9,-15.495),(73.9,-15.665),(73.73,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-15.665),(74.24,-15.495),(74.41,-15.495),(74.41,-15.665),(74.24,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-15.665),(74.75,-15.495),(74.92,-15.495),(74.92,-15.665),(74.75,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-15.665),(75.26,-15.495),(75.43,-15.495),(75.43,-15.665),(75.26,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-15.665),(75.77,-15.495),(75.94,-15.495),(75.94,-15.665),(75.77,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-15.665),(76.28,-15.495),(76.45,-15.495),(76.45,-15.665),(76.28,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-15.665),(76.79,-15.495),(76.96,-15.495),(76.96,-15.665),(76.79,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-15.665),(77.3,-15.495),(77.47,-15.495),(77.47,-15.665),(77.3,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-15.665),(77.81,-15.495),(77.98,-15.495),(77.98,-15.665),(77.81,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-15.665),(78.32,-15.495),(78.49,-15.495),(78.49,-15.665),(78.32,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-15.665),(78.83,-15.495),(79.0,-15.495),(79.0,-15.665),(78.83,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-15.665),(79.34,-15.495),(79.51,-15.495),(79.51,-15.665),(79.34,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-15.665),(79.85,-15.495),(80.02,-15.495),(80.02,-15.665),(79.85,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-15.665),(80.36,-15.495),(80.53,-15.495),(80.53,-15.665),(80.36,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-15.665),(80.87,-15.495),(81.04,-15.495),(81.04,-15.665),(80.87,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-15.665),(81.38,-15.495),(81.55,-15.495),(81.55,-15.665),(81.38,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-15.665),(81.89,-15.495),(82.06,-15.495),(82.06,-15.665),(81.89,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-15.665),(82.4,-15.495),(82.57,-15.495),(82.57,-15.665),(82.4,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-15.665),(82.91,-15.495),(83.08,-15.495),(83.08,-15.665),(82.91,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-15.665),(83.42,-15.495),(83.59,-15.495),(83.59,-15.665),(83.42,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-15.665),(83.93,-15.495),(84.1,-15.495),(84.1,-15.665),(83.93,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-15.665),(84.44,-15.495),(84.61,-15.495),(84.61,-15.665),(84.44,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-15.665),(84.95,-15.495),(85.12,-15.495),(85.12,-15.665),(84.95,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-15.665),(85.46,-15.495),(85.63,-15.495),(85.63,-15.665),(85.46,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-15.665),(85.97,-15.495),(86.14,-15.495),(86.14,-15.665),(85.97,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-15.665),(86.48,-15.495),(86.65,-15.495),(86.65,-15.665),(86.48,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-15.665),(86.99,-15.495),(87.16,-15.495),(87.16,-15.665),(86.99,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-15.665),(87.5,-15.495),(87.67,-15.495),(87.67,-15.665),(87.5,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-15.665),(88.01,-15.495),(88.18,-15.495),(88.18,-15.665),(88.01,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-15.665),(88.52,-15.495),(88.69,-15.495),(88.69,-15.665),(88.52,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-15.665),(89.03,-15.495),(89.2,-15.495),(89.2,-15.665),(89.03,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-15.665),(89.54,-15.495),(89.71,-15.495),(89.71,-15.665),(89.54,-15.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-15.155),(0.29,-14.985),(0.46,-14.985),(0.46,-15.155),(0.29,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-15.155),(0.8,-14.985),(0.97,-14.985),(0.97,-15.155),(0.8,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-15.155),(1.31,-14.985),(1.48,-14.985),(1.48,-15.155),(1.31,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-15.155),(1.82,-14.985),(1.99,-14.985),(1.99,-15.155),(1.82,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-15.155),(2.33,-14.985),(2.5,-14.985),(2.5,-15.155),(2.33,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-15.155),(2.84,-14.985),(3.01,-14.985),(3.01,-15.155),(2.84,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-15.155),(3.35,-14.985),(3.52,-14.985),(3.52,-15.155),(3.35,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-15.155),(3.86,-14.985),(4.03,-14.985),(4.03,-15.155),(3.86,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-15.155),(4.37,-14.985),(4.54,-14.985),(4.54,-15.155),(4.37,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-15.155),(4.88,-14.985),(5.05,-14.985),(5.05,-15.155),(4.88,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-15.155),(5.39,-14.985),(5.56,-14.985),(5.56,-15.155),(5.39,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-15.155),(5.9,-14.985),(6.07,-14.985),(6.07,-15.155),(5.9,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-15.155),(6.41,-14.985),(6.58,-14.985),(6.58,-15.155),(6.41,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-15.155),(6.92,-14.985),(7.09,-14.985),(7.09,-15.155),(6.92,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-15.155),(7.43,-14.985),(7.6,-14.985),(7.6,-15.155),(7.43,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-15.155),(7.94,-14.985),(8.11,-14.985),(8.11,-15.155),(7.94,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-15.155),(8.45,-14.985),(8.62,-14.985),(8.62,-15.155),(8.45,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-15.155),(8.96,-14.985),(9.13,-14.985),(9.13,-15.155),(8.96,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-15.155),(9.47,-14.985),(9.64,-14.985),(9.64,-15.155),(9.47,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-15.155),(9.98,-14.985),(10.15,-14.985),(10.15,-15.155),(9.98,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-15.155),(10.49,-14.985),(10.66,-14.985),(10.66,-15.155),(10.49,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-15.155),(11.0,-14.985),(11.17,-14.985),(11.17,-15.155),(11.0,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-15.155),(11.51,-14.985),(11.68,-14.985),(11.68,-15.155),(11.51,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-15.155),(12.02,-14.985),(12.19,-14.985),(12.19,-15.155),(12.02,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-15.155),(12.53,-14.985),(12.7,-14.985),(12.7,-15.155),(12.53,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-15.155),(13.04,-14.985),(13.21,-14.985),(13.21,-15.155),(13.04,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-15.155),(13.55,-14.985),(13.72,-14.985),(13.72,-15.155),(13.55,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-15.155),(14.06,-14.985),(14.23,-14.985),(14.23,-15.155),(14.06,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-15.155),(14.57,-14.985),(14.74,-14.985),(14.74,-15.155),(14.57,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-15.155),(15.08,-14.985),(15.25,-14.985),(15.25,-15.155),(15.08,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-15.155),(15.59,-14.985),(15.76,-14.985),(15.76,-15.155),(15.59,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-15.155),(16.1,-14.985),(16.27,-14.985),(16.27,-15.155),(16.1,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-15.155),(16.61,-14.985),(16.78,-14.985),(16.78,-15.155),(16.61,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-15.155),(17.12,-14.985),(17.29,-14.985),(17.29,-15.155),(17.12,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-15.155),(17.63,-14.985),(17.8,-14.985),(17.8,-15.155),(17.63,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-15.155),(18.14,-14.985),(18.31,-14.985),(18.31,-15.155),(18.14,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-15.155),(18.65,-14.985),(18.82,-14.985),(18.82,-15.155),(18.65,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-15.155),(19.16,-14.985),(19.33,-14.985),(19.33,-15.155),(19.16,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-15.155),(19.67,-14.985),(19.84,-14.985),(19.84,-15.155),(19.67,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-15.155),(20.18,-14.985),(20.35,-14.985),(20.35,-15.155),(20.18,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-15.155),(20.69,-14.985),(20.86,-14.985),(20.86,-15.155),(20.69,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-15.155),(21.2,-14.985),(21.37,-14.985),(21.37,-15.155),(21.2,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-15.155),(21.71,-14.985),(21.88,-14.985),(21.88,-15.155),(21.71,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-15.155),(22.22,-14.985),(22.39,-14.985),(22.39,-15.155),(22.22,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-15.155),(22.73,-14.985),(22.9,-14.985),(22.9,-15.155),(22.73,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-15.155),(23.24,-14.985),(23.41,-14.985),(23.41,-15.155),(23.24,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-15.155),(23.75,-14.985),(23.92,-14.985),(23.92,-15.155),(23.75,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-15.155),(24.26,-14.985),(24.43,-14.985),(24.43,-15.155),(24.26,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-15.155),(24.77,-14.985),(24.94,-14.985),(24.94,-15.155),(24.77,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-15.155),(25.28,-14.985),(25.45,-14.985),(25.45,-15.155),(25.28,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-15.155),(25.79,-14.985),(25.96,-14.985),(25.96,-15.155),(25.79,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-15.155),(26.3,-14.985),(26.47,-14.985),(26.47,-15.155),(26.3,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-15.155),(26.81,-14.985),(26.98,-14.985),(26.98,-15.155),(26.81,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-15.155),(27.32,-14.985),(27.49,-14.985),(27.49,-15.155),(27.32,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-15.155),(27.83,-14.985),(28.0,-14.985),(28.0,-15.155),(27.83,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-15.155),(28.34,-14.985),(28.51,-14.985),(28.51,-15.155),(28.34,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-15.155),(28.85,-14.985),(29.02,-14.985),(29.02,-15.155),(28.85,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-15.155),(29.36,-14.985),(29.53,-14.985),(29.53,-15.155),(29.36,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-15.155),(29.87,-14.985),(30.04,-14.985),(30.04,-15.155),(29.87,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-15.155),(30.38,-14.985),(30.55,-14.985),(30.55,-15.155),(30.38,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-15.155),(30.89,-14.985),(31.06,-14.985),(31.06,-15.155),(30.89,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-15.155),(31.4,-14.985),(31.57,-14.985),(31.57,-15.155),(31.4,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-15.155),(31.91,-14.985),(32.08,-14.985),(32.08,-15.155),(31.91,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-15.155),(32.42,-14.985),(32.59,-14.985),(32.59,-15.155),(32.42,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-15.155),(32.93,-14.985),(33.1,-14.985),(33.1,-15.155),(32.93,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-15.155),(33.44,-14.985),(33.61,-14.985),(33.61,-15.155),(33.44,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-15.155),(33.95,-14.985),(34.12,-14.985),(34.12,-15.155),(33.95,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-15.155),(34.46,-14.985),(34.63,-14.985),(34.63,-15.155),(34.46,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-15.155),(34.97,-14.985),(35.14,-14.985),(35.14,-15.155),(34.97,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-15.155),(35.48,-14.985),(35.65,-14.985),(35.65,-15.155),(35.48,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-15.155),(35.99,-14.985),(36.16,-14.985),(36.16,-15.155),(35.99,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-15.155),(36.5,-14.985),(36.67,-14.985),(36.67,-15.155),(36.5,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-15.155),(37.01,-14.985),(37.18,-14.985),(37.18,-15.155),(37.01,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-15.155),(37.52,-14.985),(37.69,-14.985),(37.69,-15.155),(37.52,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-15.155),(38.03,-14.985),(38.2,-14.985),(38.2,-15.155),(38.03,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-15.155),(38.54,-14.985),(38.71,-14.985),(38.71,-15.155),(38.54,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-15.155),(39.05,-14.985),(39.22,-14.985),(39.22,-15.155),(39.05,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-15.155),(39.56,-14.985),(39.73,-14.985),(39.73,-15.155),(39.56,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-15.155),(40.07,-14.985),(40.24,-14.985),(40.24,-15.155),(40.07,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-15.155),(40.58,-14.985),(40.75,-14.985),(40.75,-15.155),(40.58,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-15.155),(41.09,-14.985),(41.26,-14.985),(41.26,-15.155),(41.09,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-15.155),(41.6,-14.985),(41.77,-14.985),(41.77,-15.155),(41.6,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-15.155),(42.11,-14.985),(42.28,-14.985),(42.28,-15.155),(42.11,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-15.155),(42.62,-14.985),(42.79,-14.985),(42.79,-15.155),(42.62,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-15.155),(43.13,-14.985),(43.3,-14.985),(43.3,-15.155),(43.13,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-15.155),(43.64,-14.985),(43.81,-14.985),(43.81,-15.155),(43.64,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-15.155),(44.15,-14.985),(44.32,-14.985),(44.32,-15.155),(44.15,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-15.155),(44.66,-14.985),(44.83,-14.985),(44.83,-15.155),(44.66,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-15.155),(45.17,-14.985),(45.34,-14.985),(45.34,-15.155),(45.17,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-15.155),(45.68,-14.985),(45.85,-14.985),(45.85,-15.155),(45.68,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-15.155),(46.19,-14.985),(46.36,-14.985),(46.36,-15.155),(46.19,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-15.155),(46.7,-14.985),(46.87,-14.985),(46.87,-15.155),(46.7,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-15.155),(47.21,-14.985),(47.38,-14.985),(47.38,-15.155),(47.21,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-15.155),(47.72,-14.985),(47.89,-14.985),(47.89,-15.155),(47.72,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-15.155),(48.23,-14.985),(48.4,-14.985),(48.4,-15.155),(48.23,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-15.155),(48.74,-14.985),(48.91,-14.985),(48.91,-15.155),(48.74,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-15.155),(49.25,-14.985),(49.42,-14.985),(49.42,-15.155),(49.25,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-15.155),(49.76,-14.985),(49.93,-14.985),(49.93,-15.155),(49.76,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-15.155),(50.27,-14.985),(50.44,-14.985),(50.44,-15.155),(50.27,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-15.155),(50.78,-14.985),(50.95,-14.985),(50.95,-15.155),(50.78,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-15.155),(51.29,-14.985),(51.46,-14.985),(51.46,-15.155),(51.29,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-15.155),(51.8,-14.985),(51.97,-14.985),(51.97,-15.155),(51.8,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-15.155),(52.31,-14.985),(52.48,-14.985),(52.48,-15.155),(52.31,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-15.155),(52.82,-14.985),(52.99,-14.985),(52.99,-15.155),(52.82,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-15.155),(53.33,-14.985),(53.5,-14.985),(53.5,-15.155),(53.33,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-15.155),(53.84,-14.985),(54.01,-14.985),(54.01,-15.155),(53.84,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-15.155),(54.35,-14.985),(54.52,-14.985),(54.52,-15.155),(54.35,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-15.155),(54.86,-14.985),(55.03,-14.985),(55.03,-15.155),(54.86,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-15.155),(55.37,-14.985),(55.54,-14.985),(55.54,-15.155),(55.37,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-15.155),(55.88,-14.985),(56.05,-14.985),(56.05,-15.155),(55.88,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-15.155),(56.39,-14.985),(56.56,-14.985),(56.56,-15.155),(56.39,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-15.155),(56.9,-14.985),(57.07,-14.985),(57.07,-15.155),(56.9,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-15.155),(57.41,-14.985),(57.58,-14.985),(57.58,-15.155),(57.41,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-15.155),(57.92,-14.985),(58.09,-14.985),(58.09,-15.155),(57.92,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-15.155),(58.43,-14.985),(58.6,-14.985),(58.6,-15.155),(58.43,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-15.155),(58.94,-14.985),(59.11,-14.985),(59.11,-15.155),(58.94,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-15.155),(59.45,-14.985),(59.62,-14.985),(59.62,-15.155),(59.45,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-15.155),(59.96,-14.985),(60.13,-14.985),(60.13,-15.155),(59.96,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-15.155),(60.47,-14.985),(60.64,-14.985),(60.64,-15.155),(60.47,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-15.155),(60.98,-14.985),(61.15,-14.985),(61.15,-15.155),(60.98,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-15.155),(61.49,-14.985),(61.66,-14.985),(61.66,-15.155),(61.49,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-15.155),(62.0,-14.985),(62.17,-14.985),(62.17,-15.155),(62.0,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-15.155),(62.51,-14.985),(62.68,-14.985),(62.68,-15.155),(62.51,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-15.155),(63.02,-14.985),(63.19,-14.985),(63.19,-15.155),(63.02,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-15.155),(63.53,-14.985),(63.7,-14.985),(63.7,-15.155),(63.53,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-15.155),(64.04,-14.985),(64.21,-14.985),(64.21,-15.155),(64.04,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-15.155),(64.55,-14.985),(64.72,-14.985),(64.72,-15.155),(64.55,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-15.155),(65.06,-14.985),(65.23,-14.985),(65.23,-15.155),(65.06,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-15.155),(65.57,-14.985),(65.74,-14.985),(65.74,-15.155),(65.57,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-15.155),(66.08,-14.985),(66.25,-14.985),(66.25,-15.155),(66.08,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-15.155),(66.59,-14.985),(66.76,-14.985),(66.76,-15.155),(66.59,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-15.155),(67.1,-14.985),(67.27,-14.985),(67.27,-15.155),(67.1,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-15.155),(67.61,-14.985),(67.78,-14.985),(67.78,-15.155),(67.61,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-15.155),(68.12,-14.985),(68.29,-14.985),(68.29,-15.155),(68.12,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-15.155),(68.63,-14.985),(68.8,-14.985),(68.8,-15.155),(68.63,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-15.155),(69.14,-14.985),(69.31,-14.985),(69.31,-15.155),(69.14,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-15.155),(69.65,-14.985),(69.82,-14.985),(69.82,-15.155),(69.65,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-15.155),(70.16,-14.985),(70.33,-14.985),(70.33,-15.155),(70.16,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-15.155),(70.67,-14.985),(70.84,-14.985),(70.84,-15.155),(70.67,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-15.155),(71.18,-14.985),(71.35,-14.985),(71.35,-15.155),(71.18,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-15.155),(71.69,-14.985),(71.86,-14.985),(71.86,-15.155),(71.69,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-15.155),(72.2,-14.985),(72.37,-14.985),(72.37,-15.155),(72.2,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-15.155),(72.71,-14.985),(72.88,-14.985),(72.88,-15.155),(72.71,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-15.155),(73.22,-14.985),(73.39,-14.985),(73.39,-15.155),(73.22,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-15.155),(73.73,-14.985),(73.9,-14.985),(73.9,-15.155),(73.73,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-15.155),(74.24,-14.985),(74.41,-14.985),(74.41,-15.155),(74.24,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-15.155),(74.75,-14.985),(74.92,-14.985),(74.92,-15.155),(74.75,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-15.155),(75.26,-14.985),(75.43,-14.985),(75.43,-15.155),(75.26,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-15.155),(75.77,-14.985),(75.94,-14.985),(75.94,-15.155),(75.77,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-15.155),(76.28,-14.985),(76.45,-14.985),(76.45,-15.155),(76.28,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-15.155),(76.79,-14.985),(76.96,-14.985),(76.96,-15.155),(76.79,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-15.155),(77.3,-14.985),(77.47,-14.985),(77.47,-15.155),(77.3,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-15.155),(77.81,-14.985),(77.98,-14.985),(77.98,-15.155),(77.81,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-15.155),(78.32,-14.985),(78.49,-14.985),(78.49,-15.155),(78.32,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-15.155),(78.83,-14.985),(79.0,-14.985),(79.0,-15.155),(78.83,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-15.155),(79.34,-14.985),(79.51,-14.985),(79.51,-15.155),(79.34,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-15.155),(79.85,-14.985),(80.02,-14.985),(80.02,-15.155),(79.85,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-15.155),(80.36,-14.985),(80.53,-14.985),(80.53,-15.155),(80.36,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-15.155),(80.87,-14.985),(81.04,-14.985),(81.04,-15.155),(80.87,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-15.155),(81.38,-14.985),(81.55,-14.985),(81.55,-15.155),(81.38,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-15.155),(81.89,-14.985),(82.06,-14.985),(82.06,-15.155),(81.89,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-15.155),(82.4,-14.985),(82.57,-14.985),(82.57,-15.155),(82.4,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-15.155),(82.91,-14.985),(83.08,-14.985),(83.08,-15.155),(82.91,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-15.155),(83.42,-14.985),(83.59,-14.985),(83.59,-15.155),(83.42,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-15.155),(83.93,-14.985),(84.1,-14.985),(84.1,-15.155),(83.93,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-15.155),(84.44,-14.985),(84.61,-14.985),(84.61,-15.155),(84.44,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-15.155),(84.95,-14.985),(85.12,-14.985),(85.12,-15.155),(84.95,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-15.155),(85.46,-14.985),(85.63,-14.985),(85.63,-15.155),(85.46,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-15.155),(85.97,-14.985),(86.14,-14.985),(86.14,-15.155),(85.97,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-15.155),(86.48,-14.985),(86.65,-14.985),(86.65,-15.155),(86.48,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-15.155),(86.99,-14.985),(87.16,-14.985),(87.16,-15.155),(86.99,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-15.155),(87.5,-14.985),(87.67,-14.985),(87.67,-15.155),(87.5,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-15.155),(88.01,-14.985),(88.18,-14.985),(88.18,-15.155),(88.01,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-15.155),(88.52,-14.985),(88.69,-14.985),(88.69,-15.155),(88.52,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-15.155),(89.03,-14.985),(89.2,-14.985),(89.2,-15.155),(89.03,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-15.155),(89.54,-14.985),(89.71,-14.985),(89.71,-15.155),(89.54,-15.155)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-14.645),(0.29,-14.475),(0.46,-14.475),(0.46,-14.645),(0.29,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-14.645),(0.8,-14.475),(0.97,-14.475),(0.97,-14.645),(0.8,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-14.645),(1.31,-14.475),(1.48,-14.475),(1.48,-14.645),(1.31,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-14.645),(1.82,-14.475),(1.99,-14.475),(1.99,-14.645),(1.82,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-14.645),(2.33,-14.475),(2.5,-14.475),(2.5,-14.645),(2.33,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-14.645),(2.84,-14.475),(3.01,-14.475),(3.01,-14.645),(2.84,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-14.645),(3.35,-14.475),(3.52,-14.475),(3.52,-14.645),(3.35,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-14.645),(3.86,-14.475),(4.03,-14.475),(4.03,-14.645),(3.86,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-14.645),(4.37,-14.475),(4.54,-14.475),(4.54,-14.645),(4.37,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-14.645),(4.88,-14.475),(5.05,-14.475),(5.05,-14.645),(4.88,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-14.645),(5.39,-14.475),(5.56,-14.475),(5.56,-14.645),(5.39,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-14.645),(5.9,-14.475),(6.07,-14.475),(6.07,-14.645),(5.9,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-14.645),(6.41,-14.475),(6.58,-14.475),(6.58,-14.645),(6.41,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-14.645),(6.92,-14.475),(7.09,-14.475),(7.09,-14.645),(6.92,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-14.645),(7.43,-14.475),(7.6,-14.475),(7.6,-14.645),(7.43,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-14.645),(7.94,-14.475),(8.11,-14.475),(8.11,-14.645),(7.94,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-14.645),(8.45,-14.475),(8.62,-14.475),(8.62,-14.645),(8.45,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-14.645),(8.96,-14.475),(9.13,-14.475),(9.13,-14.645),(8.96,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-14.645),(9.47,-14.475),(9.64,-14.475),(9.64,-14.645),(9.47,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-14.645),(9.98,-14.475),(10.15,-14.475),(10.15,-14.645),(9.98,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-14.645),(10.49,-14.475),(10.66,-14.475),(10.66,-14.645),(10.49,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-14.645),(11.0,-14.475),(11.17,-14.475),(11.17,-14.645),(11.0,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-14.645),(11.51,-14.475),(11.68,-14.475),(11.68,-14.645),(11.51,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-14.645),(12.02,-14.475),(12.19,-14.475),(12.19,-14.645),(12.02,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-14.645),(12.53,-14.475),(12.7,-14.475),(12.7,-14.645),(12.53,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-14.645),(13.04,-14.475),(13.21,-14.475),(13.21,-14.645),(13.04,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-14.645),(13.55,-14.475),(13.72,-14.475),(13.72,-14.645),(13.55,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-14.645),(14.06,-14.475),(14.23,-14.475),(14.23,-14.645),(14.06,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-14.645),(14.57,-14.475),(14.74,-14.475),(14.74,-14.645),(14.57,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-14.645),(15.08,-14.475),(15.25,-14.475),(15.25,-14.645),(15.08,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-14.645),(15.59,-14.475),(15.76,-14.475),(15.76,-14.645),(15.59,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-14.645),(16.1,-14.475),(16.27,-14.475),(16.27,-14.645),(16.1,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-14.645),(16.61,-14.475),(16.78,-14.475),(16.78,-14.645),(16.61,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-14.645),(17.12,-14.475),(17.29,-14.475),(17.29,-14.645),(17.12,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-14.645),(17.63,-14.475),(17.8,-14.475),(17.8,-14.645),(17.63,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-14.645),(18.14,-14.475),(18.31,-14.475),(18.31,-14.645),(18.14,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-14.645),(18.65,-14.475),(18.82,-14.475),(18.82,-14.645),(18.65,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-14.645),(19.16,-14.475),(19.33,-14.475),(19.33,-14.645),(19.16,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-14.645),(19.67,-14.475),(19.84,-14.475),(19.84,-14.645),(19.67,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-14.645),(20.18,-14.475),(20.35,-14.475),(20.35,-14.645),(20.18,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-14.645),(20.69,-14.475),(20.86,-14.475),(20.86,-14.645),(20.69,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-14.645),(21.2,-14.475),(21.37,-14.475),(21.37,-14.645),(21.2,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-14.645),(21.71,-14.475),(21.88,-14.475),(21.88,-14.645),(21.71,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-14.645),(22.22,-14.475),(22.39,-14.475),(22.39,-14.645),(22.22,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-14.645),(22.73,-14.475),(22.9,-14.475),(22.9,-14.645),(22.73,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-14.645),(23.24,-14.475),(23.41,-14.475),(23.41,-14.645),(23.24,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-14.645),(23.75,-14.475),(23.92,-14.475),(23.92,-14.645),(23.75,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-14.645),(24.26,-14.475),(24.43,-14.475),(24.43,-14.645),(24.26,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-14.645),(24.77,-14.475),(24.94,-14.475),(24.94,-14.645),(24.77,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-14.645),(25.28,-14.475),(25.45,-14.475),(25.45,-14.645),(25.28,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-14.645),(25.79,-14.475),(25.96,-14.475),(25.96,-14.645),(25.79,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-14.645),(26.3,-14.475),(26.47,-14.475),(26.47,-14.645),(26.3,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-14.645),(26.81,-14.475),(26.98,-14.475),(26.98,-14.645),(26.81,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-14.645),(27.32,-14.475),(27.49,-14.475),(27.49,-14.645),(27.32,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-14.645),(27.83,-14.475),(28.0,-14.475),(28.0,-14.645),(27.83,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-14.645),(28.34,-14.475),(28.51,-14.475),(28.51,-14.645),(28.34,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-14.645),(28.85,-14.475),(29.02,-14.475),(29.02,-14.645),(28.85,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-14.645),(29.36,-14.475),(29.53,-14.475),(29.53,-14.645),(29.36,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-14.645),(29.87,-14.475),(30.04,-14.475),(30.04,-14.645),(29.87,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-14.645),(30.38,-14.475),(30.55,-14.475),(30.55,-14.645),(30.38,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-14.645),(30.89,-14.475),(31.06,-14.475),(31.06,-14.645),(30.89,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-14.645),(31.4,-14.475),(31.57,-14.475),(31.57,-14.645),(31.4,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-14.645),(31.91,-14.475),(32.08,-14.475),(32.08,-14.645),(31.91,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-14.645),(32.42,-14.475),(32.59,-14.475),(32.59,-14.645),(32.42,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-14.645),(32.93,-14.475),(33.1,-14.475),(33.1,-14.645),(32.93,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-14.645),(33.44,-14.475),(33.61,-14.475),(33.61,-14.645),(33.44,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-14.645),(33.95,-14.475),(34.12,-14.475),(34.12,-14.645),(33.95,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-14.645),(34.46,-14.475),(34.63,-14.475),(34.63,-14.645),(34.46,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-14.645),(34.97,-14.475),(35.14,-14.475),(35.14,-14.645),(34.97,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-14.645),(35.48,-14.475),(35.65,-14.475),(35.65,-14.645),(35.48,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-14.645),(35.99,-14.475),(36.16,-14.475),(36.16,-14.645),(35.99,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-14.645),(36.5,-14.475),(36.67,-14.475),(36.67,-14.645),(36.5,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-14.645),(37.01,-14.475),(37.18,-14.475),(37.18,-14.645),(37.01,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-14.645),(37.52,-14.475),(37.69,-14.475),(37.69,-14.645),(37.52,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-14.645),(38.03,-14.475),(38.2,-14.475),(38.2,-14.645),(38.03,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-14.645),(38.54,-14.475),(38.71,-14.475),(38.71,-14.645),(38.54,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-14.645),(39.05,-14.475),(39.22,-14.475),(39.22,-14.645),(39.05,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-14.645),(39.56,-14.475),(39.73,-14.475),(39.73,-14.645),(39.56,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-14.645),(40.07,-14.475),(40.24,-14.475),(40.24,-14.645),(40.07,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-14.645),(40.58,-14.475),(40.75,-14.475),(40.75,-14.645),(40.58,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-14.645),(41.09,-14.475),(41.26,-14.475),(41.26,-14.645),(41.09,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-14.645),(41.6,-14.475),(41.77,-14.475),(41.77,-14.645),(41.6,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-14.645),(42.11,-14.475),(42.28,-14.475),(42.28,-14.645),(42.11,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-14.645),(42.62,-14.475),(42.79,-14.475),(42.79,-14.645),(42.62,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-14.645),(43.13,-14.475),(43.3,-14.475),(43.3,-14.645),(43.13,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-14.645),(43.64,-14.475),(43.81,-14.475),(43.81,-14.645),(43.64,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-14.645),(44.15,-14.475),(44.32,-14.475),(44.32,-14.645),(44.15,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-14.645),(44.66,-14.475),(44.83,-14.475),(44.83,-14.645),(44.66,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-14.645),(45.17,-14.475),(45.34,-14.475),(45.34,-14.645),(45.17,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-14.645),(45.68,-14.475),(45.85,-14.475),(45.85,-14.645),(45.68,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-14.645),(46.19,-14.475),(46.36,-14.475),(46.36,-14.645),(46.19,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-14.645),(46.7,-14.475),(46.87,-14.475),(46.87,-14.645),(46.7,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-14.645),(47.21,-14.475),(47.38,-14.475),(47.38,-14.645),(47.21,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-14.645),(47.72,-14.475),(47.89,-14.475),(47.89,-14.645),(47.72,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-14.645),(48.23,-14.475),(48.4,-14.475),(48.4,-14.645),(48.23,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-14.645),(48.74,-14.475),(48.91,-14.475),(48.91,-14.645),(48.74,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-14.645),(49.25,-14.475),(49.42,-14.475),(49.42,-14.645),(49.25,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-14.645),(49.76,-14.475),(49.93,-14.475),(49.93,-14.645),(49.76,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-14.645),(50.27,-14.475),(50.44,-14.475),(50.44,-14.645),(50.27,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-14.645),(50.78,-14.475),(50.95,-14.475),(50.95,-14.645),(50.78,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-14.645),(51.29,-14.475),(51.46,-14.475),(51.46,-14.645),(51.29,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-14.645),(51.8,-14.475),(51.97,-14.475),(51.97,-14.645),(51.8,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-14.645),(52.31,-14.475),(52.48,-14.475),(52.48,-14.645),(52.31,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-14.645),(52.82,-14.475),(52.99,-14.475),(52.99,-14.645),(52.82,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-14.645),(53.33,-14.475),(53.5,-14.475),(53.5,-14.645),(53.33,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-14.645),(53.84,-14.475),(54.01,-14.475),(54.01,-14.645),(53.84,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-14.645),(54.35,-14.475),(54.52,-14.475),(54.52,-14.645),(54.35,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-14.645),(54.86,-14.475),(55.03,-14.475),(55.03,-14.645),(54.86,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-14.645),(55.37,-14.475),(55.54,-14.475),(55.54,-14.645),(55.37,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-14.645),(55.88,-14.475),(56.05,-14.475),(56.05,-14.645),(55.88,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-14.645),(56.39,-14.475),(56.56,-14.475),(56.56,-14.645),(56.39,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-14.645),(56.9,-14.475),(57.07,-14.475),(57.07,-14.645),(56.9,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-14.645),(57.41,-14.475),(57.58,-14.475),(57.58,-14.645),(57.41,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-14.645),(57.92,-14.475),(58.09,-14.475),(58.09,-14.645),(57.92,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-14.645),(58.43,-14.475),(58.6,-14.475),(58.6,-14.645),(58.43,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-14.645),(58.94,-14.475),(59.11,-14.475),(59.11,-14.645),(58.94,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-14.645),(59.45,-14.475),(59.62,-14.475),(59.62,-14.645),(59.45,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-14.645),(59.96,-14.475),(60.13,-14.475),(60.13,-14.645),(59.96,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-14.645),(60.47,-14.475),(60.64,-14.475),(60.64,-14.645),(60.47,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-14.645),(60.98,-14.475),(61.15,-14.475),(61.15,-14.645),(60.98,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-14.645),(61.49,-14.475),(61.66,-14.475),(61.66,-14.645),(61.49,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-14.645),(62.0,-14.475),(62.17,-14.475),(62.17,-14.645),(62.0,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-14.645),(62.51,-14.475),(62.68,-14.475),(62.68,-14.645),(62.51,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-14.645),(63.02,-14.475),(63.19,-14.475),(63.19,-14.645),(63.02,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-14.645),(63.53,-14.475),(63.7,-14.475),(63.7,-14.645),(63.53,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-14.645),(64.04,-14.475),(64.21,-14.475),(64.21,-14.645),(64.04,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-14.645),(64.55,-14.475),(64.72,-14.475),(64.72,-14.645),(64.55,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-14.645),(65.06,-14.475),(65.23,-14.475),(65.23,-14.645),(65.06,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-14.645),(65.57,-14.475),(65.74,-14.475),(65.74,-14.645),(65.57,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-14.645),(66.08,-14.475),(66.25,-14.475),(66.25,-14.645),(66.08,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-14.645),(66.59,-14.475),(66.76,-14.475),(66.76,-14.645),(66.59,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-14.645),(67.1,-14.475),(67.27,-14.475),(67.27,-14.645),(67.1,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-14.645),(67.61,-14.475),(67.78,-14.475),(67.78,-14.645),(67.61,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-14.645),(68.12,-14.475),(68.29,-14.475),(68.29,-14.645),(68.12,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-14.645),(68.63,-14.475),(68.8,-14.475),(68.8,-14.645),(68.63,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-14.645),(69.14,-14.475),(69.31,-14.475),(69.31,-14.645),(69.14,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-14.645),(69.65,-14.475),(69.82,-14.475),(69.82,-14.645),(69.65,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-14.645),(70.16,-14.475),(70.33,-14.475),(70.33,-14.645),(70.16,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-14.645),(70.67,-14.475),(70.84,-14.475),(70.84,-14.645),(70.67,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-14.645),(71.18,-14.475),(71.35,-14.475),(71.35,-14.645),(71.18,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-14.645),(71.69,-14.475),(71.86,-14.475),(71.86,-14.645),(71.69,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-14.645),(72.2,-14.475),(72.37,-14.475),(72.37,-14.645),(72.2,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-14.645),(72.71,-14.475),(72.88,-14.475),(72.88,-14.645),(72.71,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-14.645),(73.22,-14.475),(73.39,-14.475),(73.39,-14.645),(73.22,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-14.645),(73.73,-14.475),(73.9,-14.475),(73.9,-14.645),(73.73,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-14.645),(74.24,-14.475),(74.41,-14.475),(74.41,-14.645),(74.24,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-14.645),(74.75,-14.475),(74.92,-14.475),(74.92,-14.645),(74.75,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-14.645),(75.26,-14.475),(75.43,-14.475),(75.43,-14.645),(75.26,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-14.645),(75.77,-14.475),(75.94,-14.475),(75.94,-14.645),(75.77,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-14.645),(76.28,-14.475),(76.45,-14.475),(76.45,-14.645),(76.28,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-14.645),(76.79,-14.475),(76.96,-14.475),(76.96,-14.645),(76.79,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-14.645),(77.3,-14.475),(77.47,-14.475),(77.47,-14.645),(77.3,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-14.645),(77.81,-14.475),(77.98,-14.475),(77.98,-14.645),(77.81,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-14.645),(78.32,-14.475),(78.49,-14.475),(78.49,-14.645),(78.32,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-14.645),(78.83,-14.475),(79.0,-14.475),(79.0,-14.645),(78.83,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-14.645),(79.34,-14.475),(79.51,-14.475),(79.51,-14.645),(79.34,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-14.645),(79.85,-14.475),(80.02,-14.475),(80.02,-14.645),(79.85,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-14.645),(80.36,-14.475),(80.53,-14.475),(80.53,-14.645),(80.36,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-14.645),(80.87,-14.475),(81.04,-14.475),(81.04,-14.645),(80.87,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-14.645),(81.38,-14.475),(81.55,-14.475),(81.55,-14.645),(81.38,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-14.645),(81.89,-14.475),(82.06,-14.475),(82.06,-14.645),(81.89,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-14.645),(82.4,-14.475),(82.57,-14.475),(82.57,-14.645),(82.4,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-14.645),(82.91,-14.475),(83.08,-14.475),(83.08,-14.645),(82.91,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-14.645),(83.42,-14.475),(83.59,-14.475),(83.59,-14.645),(83.42,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-14.645),(83.93,-14.475),(84.1,-14.475),(84.1,-14.645),(83.93,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-14.645),(84.44,-14.475),(84.61,-14.475),(84.61,-14.645),(84.44,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-14.645),(84.95,-14.475),(85.12,-14.475),(85.12,-14.645),(84.95,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-14.645),(85.46,-14.475),(85.63,-14.475),(85.63,-14.645),(85.46,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-14.645),(85.97,-14.475),(86.14,-14.475),(86.14,-14.645),(85.97,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-14.645),(86.48,-14.475),(86.65,-14.475),(86.65,-14.645),(86.48,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-14.645),(86.99,-14.475),(87.16,-14.475),(87.16,-14.645),(86.99,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-14.645),(87.5,-14.475),(87.67,-14.475),(87.67,-14.645),(87.5,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-14.645),(88.01,-14.475),(88.18,-14.475),(88.18,-14.645),(88.01,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-14.645),(88.52,-14.475),(88.69,-14.475),(88.69,-14.645),(88.52,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-14.645),(89.03,-14.475),(89.2,-14.475),(89.2,-14.645),(89.03,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-14.645),(89.54,-14.475),(89.71,-14.475),(89.71,-14.645),(89.54,-14.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-14.135),(0.29,-13.965),(0.46,-13.965),(0.46,-14.135),(0.29,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-14.135),(0.8,-13.965),(0.97,-13.965),(0.97,-14.135),(0.8,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-14.135),(1.31,-13.965),(1.48,-13.965),(1.48,-14.135),(1.31,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-14.135),(1.82,-13.965),(1.99,-13.965),(1.99,-14.135),(1.82,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-14.135),(2.33,-13.965),(2.5,-13.965),(2.5,-14.135),(2.33,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-14.135),(2.84,-13.965),(3.01,-13.965),(3.01,-14.135),(2.84,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-14.135),(3.35,-13.965),(3.52,-13.965),(3.52,-14.135),(3.35,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-14.135),(3.86,-13.965),(4.03,-13.965),(4.03,-14.135),(3.86,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-14.135),(4.37,-13.965),(4.54,-13.965),(4.54,-14.135),(4.37,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-14.135),(4.88,-13.965),(5.05,-13.965),(5.05,-14.135),(4.88,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-14.135),(5.39,-13.965),(5.56,-13.965),(5.56,-14.135),(5.39,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-14.135),(5.9,-13.965),(6.07,-13.965),(6.07,-14.135),(5.9,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-14.135),(6.41,-13.965),(6.58,-13.965),(6.58,-14.135),(6.41,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-14.135),(6.92,-13.965),(7.09,-13.965),(7.09,-14.135),(6.92,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-14.135),(7.43,-13.965),(7.6,-13.965),(7.6,-14.135),(7.43,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-14.135),(7.94,-13.965),(8.11,-13.965),(8.11,-14.135),(7.94,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-14.135),(8.45,-13.965),(8.62,-13.965),(8.62,-14.135),(8.45,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-14.135),(8.96,-13.965),(9.13,-13.965),(9.13,-14.135),(8.96,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-14.135),(9.47,-13.965),(9.64,-13.965),(9.64,-14.135),(9.47,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-14.135),(9.98,-13.965),(10.15,-13.965),(10.15,-14.135),(9.98,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-14.135),(10.49,-13.965),(10.66,-13.965),(10.66,-14.135),(10.49,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-14.135),(11.0,-13.965),(11.17,-13.965),(11.17,-14.135),(11.0,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-14.135),(11.51,-13.965),(11.68,-13.965),(11.68,-14.135),(11.51,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-14.135),(12.02,-13.965),(12.19,-13.965),(12.19,-14.135),(12.02,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-14.135),(12.53,-13.965),(12.7,-13.965),(12.7,-14.135),(12.53,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-14.135),(13.04,-13.965),(13.21,-13.965),(13.21,-14.135),(13.04,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-14.135),(13.55,-13.965),(13.72,-13.965),(13.72,-14.135),(13.55,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-14.135),(14.06,-13.965),(14.23,-13.965),(14.23,-14.135),(14.06,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-14.135),(14.57,-13.965),(14.74,-13.965),(14.74,-14.135),(14.57,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-14.135),(15.08,-13.965),(15.25,-13.965),(15.25,-14.135),(15.08,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-14.135),(15.59,-13.965),(15.76,-13.965),(15.76,-14.135),(15.59,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-14.135),(16.1,-13.965),(16.27,-13.965),(16.27,-14.135),(16.1,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-14.135),(16.61,-13.965),(16.78,-13.965),(16.78,-14.135),(16.61,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-14.135),(17.12,-13.965),(17.29,-13.965),(17.29,-14.135),(17.12,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-14.135),(17.63,-13.965),(17.8,-13.965),(17.8,-14.135),(17.63,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-14.135),(18.14,-13.965),(18.31,-13.965),(18.31,-14.135),(18.14,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-14.135),(18.65,-13.965),(18.82,-13.965),(18.82,-14.135),(18.65,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-14.135),(19.16,-13.965),(19.33,-13.965),(19.33,-14.135),(19.16,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-14.135),(19.67,-13.965),(19.84,-13.965),(19.84,-14.135),(19.67,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-14.135),(20.18,-13.965),(20.35,-13.965),(20.35,-14.135),(20.18,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-14.135),(20.69,-13.965),(20.86,-13.965),(20.86,-14.135),(20.69,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-14.135),(21.2,-13.965),(21.37,-13.965),(21.37,-14.135),(21.2,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-14.135),(21.71,-13.965),(21.88,-13.965),(21.88,-14.135),(21.71,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-14.135),(22.22,-13.965),(22.39,-13.965),(22.39,-14.135),(22.22,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-14.135),(22.73,-13.965),(22.9,-13.965),(22.9,-14.135),(22.73,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-14.135),(23.24,-13.965),(23.41,-13.965),(23.41,-14.135),(23.24,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-14.135),(23.75,-13.965),(23.92,-13.965),(23.92,-14.135),(23.75,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-14.135),(24.26,-13.965),(24.43,-13.965),(24.43,-14.135),(24.26,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-14.135),(24.77,-13.965),(24.94,-13.965),(24.94,-14.135),(24.77,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-14.135),(25.28,-13.965),(25.45,-13.965),(25.45,-14.135),(25.28,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-14.135),(25.79,-13.965),(25.96,-13.965),(25.96,-14.135),(25.79,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-14.135),(26.3,-13.965),(26.47,-13.965),(26.47,-14.135),(26.3,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-14.135),(26.81,-13.965),(26.98,-13.965),(26.98,-14.135),(26.81,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-14.135),(27.32,-13.965),(27.49,-13.965),(27.49,-14.135),(27.32,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-14.135),(27.83,-13.965),(28.0,-13.965),(28.0,-14.135),(27.83,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-14.135),(28.34,-13.965),(28.51,-13.965),(28.51,-14.135),(28.34,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-14.135),(28.85,-13.965),(29.02,-13.965),(29.02,-14.135),(28.85,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-14.135),(29.36,-13.965),(29.53,-13.965),(29.53,-14.135),(29.36,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-14.135),(29.87,-13.965),(30.04,-13.965),(30.04,-14.135),(29.87,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-14.135),(30.38,-13.965),(30.55,-13.965),(30.55,-14.135),(30.38,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-14.135),(30.89,-13.965),(31.06,-13.965),(31.06,-14.135),(30.89,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-14.135),(31.4,-13.965),(31.57,-13.965),(31.57,-14.135),(31.4,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-14.135),(31.91,-13.965),(32.08,-13.965),(32.08,-14.135),(31.91,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-14.135),(32.42,-13.965),(32.59,-13.965),(32.59,-14.135),(32.42,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-14.135),(32.93,-13.965),(33.1,-13.965),(33.1,-14.135),(32.93,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-14.135),(33.44,-13.965),(33.61,-13.965),(33.61,-14.135),(33.44,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-14.135),(33.95,-13.965),(34.12,-13.965),(34.12,-14.135),(33.95,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-14.135),(34.46,-13.965),(34.63,-13.965),(34.63,-14.135),(34.46,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-14.135),(34.97,-13.965),(35.14,-13.965),(35.14,-14.135),(34.97,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-14.135),(35.48,-13.965),(35.65,-13.965),(35.65,-14.135),(35.48,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-14.135),(35.99,-13.965),(36.16,-13.965),(36.16,-14.135),(35.99,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-14.135),(36.5,-13.965),(36.67,-13.965),(36.67,-14.135),(36.5,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-14.135),(37.01,-13.965),(37.18,-13.965),(37.18,-14.135),(37.01,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-14.135),(37.52,-13.965),(37.69,-13.965),(37.69,-14.135),(37.52,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-14.135),(38.03,-13.965),(38.2,-13.965),(38.2,-14.135),(38.03,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-14.135),(38.54,-13.965),(38.71,-13.965),(38.71,-14.135),(38.54,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-14.135),(39.05,-13.965),(39.22,-13.965),(39.22,-14.135),(39.05,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-14.135),(39.56,-13.965),(39.73,-13.965),(39.73,-14.135),(39.56,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-14.135),(40.07,-13.965),(40.24,-13.965),(40.24,-14.135),(40.07,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-14.135),(40.58,-13.965),(40.75,-13.965),(40.75,-14.135),(40.58,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-14.135),(41.09,-13.965),(41.26,-13.965),(41.26,-14.135),(41.09,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-14.135),(41.6,-13.965),(41.77,-13.965),(41.77,-14.135),(41.6,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-14.135),(42.11,-13.965),(42.28,-13.965),(42.28,-14.135),(42.11,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-14.135),(42.62,-13.965),(42.79,-13.965),(42.79,-14.135),(42.62,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-14.135),(43.13,-13.965),(43.3,-13.965),(43.3,-14.135),(43.13,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-14.135),(43.64,-13.965),(43.81,-13.965),(43.81,-14.135),(43.64,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-14.135),(44.15,-13.965),(44.32,-13.965),(44.32,-14.135),(44.15,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-14.135),(44.66,-13.965),(44.83,-13.965),(44.83,-14.135),(44.66,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-14.135),(45.17,-13.965),(45.34,-13.965),(45.34,-14.135),(45.17,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-14.135),(45.68,-13.965),(45.85,-13.965),(45.85,-14.135),(45.68,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-14.135),(46.19,-13.965),(46.36,-13.965),(46.36,-14.135),(46.19,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-14.135),(46.7,-13.965),(46.87,-13.965),(46.87,-14.135),(46.7,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-14.135),(47.21,-13.965),(47.38,-13.965),(47.38,-14.135),(47.21,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-14.135),(47.72,-13.965),(47.89,-13.965),(47.89,-14.135),(47.72,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-14.135),(48.23,-13.965),(48.4,-13.965),(48.4,-14.135),(48.23,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-14.135),(48.74,-13.965),(48.91,-13.965),(48.91,-14.135),(48.74,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-14.135),(49.25,-13.965),(49.42,-13.965),(49.42,-14.135),(49.25,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-14.135),(49.76,-13.965),(49.93,-13.965),(49.93,-14.135),(49.76,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-14.135),(50.27,-13.965),(50.44,-13.965),(50.44,-14.135),(50.27,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-14.135),(50.78,-13.965),(50.95,-13.965),(50.95,-14.135),(50.78,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-14.135),(51.29,-13.965),(51.46,-13.965),(51.46,-14.135),(51.29,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-14.135),(51.8,-13.965),(51.97,-13.965),(51.97,-14.135),(51.8,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-14.135),(52.31,-13.965),(52.48,-13.965),(52.48,-14.135),(52.31,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-14.135),(52.82,-13.965),(52.99,-13.965),(52.99,-14.135),(52.82,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-14.135),(53.33,-13.965),(53.5,-13.965),(53.5,-14.135),(53.33,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-14.135),(53.84,-13.965),(54.01,-13.965),(54.01,-14.135),(53.84,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-14.135),(54.35,-13.965),(54.52,-13.965),(54.52,-14.135),(54.35,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-14.135),(54.86,-13.965),(55.03,-13.965),(55.03,-14.135),(54.86,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-14.135),(55.37,-13.965),(55.54,-13.965),(55.54,-14.135),(55.37,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-14.135),(55.88,-13.965),(56.05,-13.965),(56.05,-14.135),(55.88,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-14.135),(56.39,-13.965),(56.56,-13.965),(56.56,-14.135),(56.39,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-14.135),(56.9,-13.965),(57.07,-13.965),(57.07,-14.135),(56.9,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-14.135),(57.41,-13.965),(57.58,-13.965),(57.58,-14.135),(57.41,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-14.135),(57.92,-13.965),(58.09,-13.965),(58.09,-14.135),(57.92,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-14.135),(58.43,-13.965),(58.6,-13.965),(58.6,-14.135),(58.43,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-14.135),(58.94,-13.965),(59.11,-13.965),(59.11,-14.135),(58.94,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-14.135),(59.45,-13.965),(59.62,-13.965),(59.62,-14.135),(59.45,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-14.135),(59.96,-13.965),(60.13,-13.965),(60.13,-14.135),(59.96,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-14.135),(60.47,-13.965),(60.64,-13.965),(60.64,-14.135),(60.47,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-14.135),(60.98,-13.965),(61.15,-13.965),(61.15,-14.135),(60.98,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-14.135),(61.49,-13.965),(61.66,-13.965),(61.66,-14.135),(61.49,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-14.135),(62.0,-13.965),(62.17,-13.965),(62.17,-14.135),(62.0,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-14.135),(62.51,-13.965),(62.68,-13.965),(62.68,-14.135),(62.51,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-14.135),(63.02,-13.965),(63.19,-13.965),(63.19,-14.135),(63.02,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-14.135),(63.53,-13.965),(63.7,-13.965),(63.7,-14.135),(63.53,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-14.135),(64.04,-13.965),(64.21,-13.965),(64.21,-14.135),(64.04,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-14.135),(64.55,-13.965),(64.72,-13.965),(64.72,-14.135),(64.55,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-14.135),(65.06,-13.965),(65.23,-13.965),(65.23,-14.135),(65.06,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-14.135),(65.57,-13.965),(65.74,-13.965),(65.74,-14.135),(65.57,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-14.135),(66.08,-13.965),(66.25,-13.965),(66.25,-14.135),(66.08,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-14.135),(66.59,-13.965),(66.76,-13.965),(66.76,-14.135),(66.59,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-14.135),(67.1,-13.965),(67.27,-13.965),(67.27,-14.135),(67.1,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-14.135),(67.61,-13.965),(67.78,-13.965),(67.78,-14.135),(67.61,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-14.135),(68.12,-13.965),(68.29,-13.965),(68.29,-14.135),(68.12,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-14.135),(68.63,-13.965),(68.8,-13.965),(68.8,-14.135),(68.63,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-14.135),(69.14,-13.965),(69.31,-13.965),(69.31,-14.135),(69.14,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-14.135),(69.65,-13.965),(69.82,-13.965),(69.82,-14.135),(69.65,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-14.135),(70.16,-13.965),(70.33,-13.965),(70.33,-14.135),(70.16,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-14.135),(70.67,-13.965),(70.84,-13.965),(70.84,-14.135),(70.67,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-14.135),(71.18,-13.965),(71.35,-13.965),(71.35,-14.135),(71.18,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-14.135),(71.69,-13.965),(71.86,-13.965),(71.86,-14.135),(71.69,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-14.135),(72.2,-13.965),(72.37,-13.965),(72.37,-14.135),(72.2,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-14.135),(72.71,-13.965),(72.88,-13.965),(72.88,-14.135),(72.71,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-14.135),(73.22,-13.965),(73.39,-13.965),(73.39,-14.135),(73.22,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-14.135),(73.73,-13.965),(73.9,-13.965),(73.9,-14.135),(73.73,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-14.135),(74.24,-13.965),(74.41,-13.965),(74.41,-14.135),(74.24,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-14.135),(74.75,-13.965),(74.92,-13.965),(74.92,-14.135),(74.75,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-14.135),(75.26,-13.965),(75.43,-13.965),(75.43,-14.135),(75.26,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-14.135),(75.77,-13.965),(75.94,-13.965),(75.94,-14.135),(75.77,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-14.135),(76.28,-13.965),(76.45,-13.965),(76.45,-14.135),(76.28,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-14.135),(76.79,-13.965),(76.96,-13.965),(76.96,-14.135),(76.79,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-14.135),(77.3,-13.965),(77.47,-13.965),(77.47,-14.135),(77.3,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-14.135),(77.81,-13.965),(77.98,-13.965),(77.98,-14.135),(77.81,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-14.135),(78.32,-13.965),(78.49,-13.965),(78.49,-14.135),(78.32,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-14.135),(78.83,-13.965),(79.0,-13.965),(79.0,-14.135),(78.83,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-14.135),(79.34,-13.965),(79.51,-13.965),(79.51,-14.135),(79.34,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-14.135),(79.85,-13.965),(80.02,-13.965),(80.02,-14.135),(79.85,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-14.135),(80.36,-13.965),(80.53,-13.965),(80.53,-14.135),(80.36,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-14.135),(80.87,-13.965),(81.04,-13.965),(81.04,-14.135),(80.87,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-14.135),(81.38,-13.965),(81.55,-13.965),(81.55,-14.135),(81.38,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-14.135),(81.89,-13.965),(82.06,-13.965),(82.06,-14.135),(81.89,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-14.135),(82.4,-13.965),(82.57,-13.965),(82.57,-14.135),(82.4,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-14.135),(82.91,-13.965),(83.08,-13.965),(83.08,-14.135),(82.91,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-14.135),(83.42,-13.965),(83.59,-13.965),(83.59,-14.135),(83.42,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-14.135),(83.93,-13.965),(84.1,-13.965),(84.1,-14.135),(83.93,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-14.135),(84.44,-13.965),(84.61,-13.965),(84.61,-14.135),(84.44,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-14.135),(84.95,-13.965),(85.12,-13.965),(85.12,-14.135),(84.95,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-14.135),(85.46,-13.965),(85.63,-13.965),(85.63,-14.135),(85.46,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-14.135),(85.97,-13.965),(86.14,-13.965),(86.14,-14.135),(85.97,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-14.135),(86.48,-13.965),(86.65,-13.965),(86.65,-14.135),(86.48,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-14.135),(86.99,-13.965),(87.16,-13.965),(87.16,-14.135),(86.99,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-14.135),(87.5,-13.965),(87.67,-13.965),(87.67,-14.135),(87.5,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-14.135),(88.01,-13.965),(88.18,-13.965),(88.18,-14.135),(88.01,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-14.135),(88.52,-13.965),(88.69,-13.965),(88.69,-14.135),(88.52,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-14.135),(89.03,-13.965),(89.2,-13.965),(89.2,-14.135),(89.03,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-14.135),(89.54,-13.965),(89.71,-13.965),(89.71,-14.135),(89.54,-14.135)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-13.625),(0.29,-13.455),(0.46,-13.455),(0.46,-13.625),(0.29,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-13.625),(0.8,-13.455),(0.97,-13.455),(0.97,-13.625),(0.8,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-13.625),(1.31,-13.455),(1.48,-13.455),(1.48,-13.625),(1.31,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-13.625),(1.82,-13.455),(1.99,-13.455),(1.99,-13.625),(1.82,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-13.625),(2.33,-13.455),(2.5,-13.455),(2.5,-13.625),(2.33,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-13.625),(2.84,-13.455),(3.01,-13.455),(3.01,-13.625),(2.84,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-13.625),(3.35,-13.455),(3.52,-13.455),(3.52,-13.625),(3.35,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-13.625),(3.86,-13.455),(4.03,-13.455),(4.03,-13.625),(3.86,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-13.625),(4.37,-13.455),(4.54,-13.455),(4.54,-13.625),(4.37,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-13.625),(4.88,-13.455),(5.05,-13.455),(5.05,-13.625),(4.88,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-13.625),(5.39,-13.455),(5.56,-13.455),(5.56,-13.625),(5.39,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-13.625),(5.9,-13.455),(6.07,-13.455),(6.07,-13.625),(5.9,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-13.625),(6.41,-13.455),(6.58,-13.455),(6.58,-13.625),(6.41,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-13.625),(6.92,-13.455),(7.09,-13.455),(7.09,-13.625),(6.92,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-13.625),(7.43,-13.455),(7.6,-13.455),(7.6,-13.625),(7.43,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-13.625),(7.94,-13.455),(8.11,-13.455),(8.11,-13.625),(7.94,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-13.625),(8.45,-13.455),(8.62,-13.455),(8.62,-13.625),(8.45,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-13.625),(8.96,-13.455),(9.13,-13.455),(9.13,-13.625),(8.96,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-13.625),(9.47,-13.455),(9.64,-13.455),(9.64,-13.625),(9.47,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-13.625),(9.98,-13.455),(10.15,-13.455),(10.15,-13.625),(9.98,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-13.625),(10.49,-13.455),(10.66,-13.455),(10.66,-13.625),(10.49,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-13.625),(11.0,-13.455),(11.17,-13.455),(11.17,-13.625),(11.0,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-13.625),(11.51,-13.455),(11.68,-13.455),(11.68,-13.625),(11.51,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-13.625),(12.02,-13.455),(12.19,-13.455),(12.19,-13.625),(12.02,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-13.625),(12.53,-13.455),(12.7,-13.455),(12.7,-13.625),(12.53,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-13.625),(13.04,-13.455),(13.21,-13.455),(13.21,-13.625),(13.04,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-13.625),(13.55,-13.455),(13.72,-13.455),(13.72,-13.625),(13.55,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-13.625),(14.06,-13.455),(14.23,-13.455),(14.23,-13.625),(14.06,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-13.625),(14.57,-13.455),(14.74,-13.455),(14.74,-13.625),(14.57,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-13.625),(15.08,-13.455),(15.25,-13.455),(15.25,-13.625),(15.08,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-13.625),(15.59,-13.455),(15.76,-13.455),(15.76,-13.625),(15.59,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-13.625),(16.1,-13.455),(16.27,-13.455),(16.27,-13.625),(16.1,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-13.625),(16.61,-13.455),(16.78,-13.455),(16.78,-13.625),(16.61,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-13.625),(17.12,-13.455),(17.29,-13.455),(17.29,-13.625),(17.12,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-13.625),(17.63,-13.455),(17.8,-13.455),(17.8,-13.625),(17.63,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-13.625),(18.14,-13.455),(18.31,-13.455),(18.31,-13.625),(18.14,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-13.625),(18.65,-13.455),(18.82,-13.455),(18.82,-13.625),(18.65,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-13.625),(19.16,-13.455),(19.33,-13.455),(19.33,-13.625),(19.16,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-13.625),(19.67,-13.455),(19.84,-13.455),(19.84,-13.625),(19.67,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-13.625),(20.18,-13.455),(20.35,-13.455),(20.35,-13.625),(20.18,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-13.625),(20.69,-13.455),(20.86,-13.455),(20.86,-13.625),(20.69,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-13.625),(21.2,-13.455),(21.37,-13.455),(21.37,-13.625),(21.2,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-13.625),(21.71,-13.455),(21.88,-13.455),(21.88,-13.625),(21.71,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-13.625),(22.22,-13.455),(22.39,-13.455),(22.39,-13.625),(22.22,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-13.625),(22.73,-13.455),(22.9,-13.455),(22.9,-13.625),(22.73,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-13.625),(23.24,-13.455),(23.41,-13.455),(23.41,-13.625),(23.24,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-13.625),(23.75,-13.455),(23.92,-13.455),(23.92,-13.625),(23.75,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-13.625),(24.26,-13.455),(24.43,-13.455),(24.43,-13.625),(24.26,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-13.625),(24.77,-13.455),(24.94,-13.455),(24.94,-13.625),(24.77,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-13.625),(25.28,-13.455),(25.45,-13.455),(25.45,-13.625),(25.28,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-13.625),(25.79,-13.455),(25.96,-13.455),(25.96,-13.625),(25.79,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-13.625),(26.3,-13.455),(26.47,-13.455),(26.47,-13.625),(26.3,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-13.625),(26.81,-13.455),(26.98,-13.455),(26.98,-13.625),(26.81,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-13.625),(27.32,-13.455),(27.49,-13.455),(27.49,-13.625),(27.32,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-13.625),(27.83,-13.455),(28.0,-13.455),(28.0,-13.625),(27.83,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-13.625),(28.34,-13.455),(28.51,-13.455),(28.51,-13.625),(28.34,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-13.625),(28.85,-13.455),(29.02,-13.455),(29.02,-13.625),(28.85,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-13.625),(29.36,-13.455),(29.53,-13.455),(29.53,-13.625),(29.36,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-13.625),(29.87,-13.455),(30.04,-13.455),(30.04,-13.625),(29.87,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-13.625),(30.38,-13.455),(30.55,-13.455),(30.55,-13.625),(30.38,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-13.625),(30.89,-13.455),(31.06,-13.455),(31.06,-13.625),(30.89,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-13.625),(31.4,-13.455),(31.57,-13.455),(31.57,-13.625),(31.4,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-13.625),(31.91,-13.455),(32.08,-13.455),(32.08,-13.625),(31.91,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-13.625),(32.42,-13.455),(32.59,-13.455),(32.59,-13.625),(32.42,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-13.625),(32.93,-13.455),(33.1,-13.455),(33.1,-13.625),(32.93,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-13.625),(33.44,-13.455),(33.61,-13.455),(33.61,-13.625),(33.44,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-13.625),(33.95,-13.455),(34.12,-13.455),(34.12,-13.625),(33.95,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-13.625),(34.46,-13.455),(34.63,-13.455),(34.63,-13.625),(34.46,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-13.625),(34.97,-13.455),(35.14,-13.455),(35.14,-13.625),(34.97,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-13.625),(35.48,-13.455),(35.65,-13.455),(35.65,-13.625),(35.48,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-13.625),(35.99,-13.455),(36.16,-13.455),(36.16,-13.625),(35.99,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-13.625),(36.5,-13.455),(36.67,-13.455),(36.67,-13.625),(36.5,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-13.625),(37.01,-13.455),(37.18,-13.455),(37.18,-13.625),(37.01,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-13.625),(37.52,-13.455),(37.69,-13.455),(37.69,-13.625),(37.52,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-13.625),(38.03,-13.455),(38.2,-13.455),(38.2,-13.625),(38.03,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-13.625),(38.54,-13.455),(38.71,-13.455),(38.71,-13.625),(38.54,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-13.625),(39.05,-13.455),(39.22,-13.455),(39.22,-13.625),(39.05,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-13.625),(39.56,-13.455),(39.73,-13.455),(39.73,-13.625),(39.56,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-13.625),(40.07,-13.455),(40.24,-13.455),(40.24,-13.625),(40.07,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-13.625),(40.58,-13.455),(40.75,-13.455),(40.75,-13.625),(40.58,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-13.625),(41.09,-13.455),(41.26,-13.455),(41.26,-13.625),(41.09,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-13.625),(41.6,-13.455),(41.77,-13.455),(41.77,-13.625),(41.6,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-13.625),(42.11,-13.455),(42.28,-13.455),(42.28,-13.625),(42.11,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-13.625),(42.62,-13.455),(42.79,-13.455),(42.79,-13.625),(42.62,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-13.625),(43.13,-13.455),(43.3,-13.455),(43.3,-13.625),(43.13,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-13.625),(43.64,-13.455),(43.81,-13.455),(43.81,-13.625),(43.64,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-13.625),(44.15,-13.455),(44.32,-13.455),(44.32,-13.625),(44.15,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-13.625),(44.66,-13.455),(44.83,-13.455),(44.83,-13.625),(44.66,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-13.625),(45.17,-13.455),(45.34,-13.455),(45.34,-13.625),(45.17,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-13.625),(45.68,-13.455),(45.85,-13.455),(45.85,-13.625),(45.68,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-13.625),(46.19,-13.455),(46.36,-13.455),(46.36,-13.625),(46.19,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-13.625),(46.7,-13.455),(46.87,-13.455),(46.87,-13.625),(46.7,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-13.625),(47.21,-13.455),(47.38,-13.455),(47.38,-13.625),(47.21,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-13.625),(47.72,-13.455),(47.89,-13.455),(47.89,-13.625),(47.72,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-13.625),(48.23,-13.455),(48.4,-13.455),(48.4,-13.625),(48.23,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-13.625),(48.74,-13.455),(48.91,-13.455),(48.91,-13.625),(48.74,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-13.625),(49.25,-13.455),(49.42,-13.455),(49.42,-13.625),(49.25,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-13.625),(49.76,-13.455),(49.93,-13.455),(49.93,-13.625),(49.76,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-13.625),(50.27,-13.455),(50.44,-13.455),(50.44,-13.625),(50.27,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-13.625),(50.78,-13.455),(50.95,-13.455),(50.95,-13.625),(50.78,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-13.625),(51.29,-13.455),(51.46,-13.455),(51.46,-13.625),(51.29,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-13.625),(51.8,-13.455),(51.97,-13.455),(51.97,-13.625),(51.8,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-13.625),(52.31,-13.455),(52.48,-13.455),(52.48,-13.625),(52.31,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-13.625),(52.82,-13.455),(52.99,-13.455),(52.99,-13.625),(52.82,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-13.625),(53.33,-13.455),(53.5,-13.455),(53.5,-13.625),(53.33,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-13.625),(53.84,-13.455),(54.01,-13.455),(54.01,-13.625),(53.84,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-13.625),(54.35,-13.455),(54.52,-13.455),(54.52,-13.625),(54.35,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-13.625),(54.86,-13.455),(55.03,-13.455),(55.03,-13.625),(54.86,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-13.625),(55.37,-13.455),(55.54,-13.455),(55.54,-13.625),(55.37,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-13.625),(55.88,-13.455),(56.05,-13.455),(56.05,-13.625),(55.88,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-13.625),(56.39,-13.455),(56.56,-13.455),(56.56,-13.625),(56.39,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-13.625),(56.9,-13.455),(57.07,-13.455),(57.07,-13.625),(56.9,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-13.625),(57.41,-13.455),(57.58,-13.455),(57.58,-13.625),(57.41,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-13.625),(57.92,-13.455),(58.09,-13.455),(58.09,-13.625),(57.92,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-13.625),(58.43,-13.455),(58.6,-13.455),(58.6,-13.625),(58.43,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-13.625),(58.94,-13.455),(59.11,-13.455),(59.11,-13.625),(58.94,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-13.625),(59.45,-13.455),(59.62,-13.455),(59.62,-13.625),(59.45,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-13.625),(59.96,-13.455),(60.13,-13.455),(60.13,-13.625),(59.96,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-13.625),(60.47,-13.455),(60.64,-13.455),(60.64,-13.625),(60.47,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-13.625),(60.98,-13.455),(61.15,-13.455),(61.15,-13.625),(60.98,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-13.625),(61.49,-13.455),(61.66,-13.455),(61.66,-13.625),(61.49,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-13.625),(62.0,-13.455),(62.17,-13.455),(62.17,-13.625),(62.0,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-13.625),(62.51,-13.455),(62.68,-13.455),(62.68,-13.625),(62.51,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-13.625),(63.02,-13.455),(63.19,-13.455),(63.19,-13.625),(63.02,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-13.625),(63.53,-13.455),(63.7,-13.455),(63.7,-13.625),(63.53,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-13.625),(64.04,-13.455),(64.21,-13.455),(64.21,-13.625),(64.04,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-13.625),(64.55,-13.455),(64.72,-13.455),(64.72,-13.625),(64.55,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-13.625),(65.06,-13.455),(65.23,-13.455),(65.23,-13.625),(65.06,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-13.625),(65.57,-13.455),(65.74,-13.455),(65.74,-13.625),(65.57,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-13.625),(66.08,-13.455),(66.25,-13.455),(66.25,-13.625),(66.08,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-13.625),(66.59,-13.455),(66.76,-13.455),(66.76,-13.625),(66.59,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-13.625),(67.1,-13.455),(67.27,-13.455),(67.27,-13.625),(67.1,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-13.625),(67.61,-13.455),(67.78,-13.455),(67.78,-13.625),(67.61,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-13.625),(68.12,-13.455),(68.29,-13.455),(68.29,-13.625),(68.12,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-13.625),(68.63,-13.455),(68.8,-13.455),(68.8,-13.625),(68.63,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-13.625),(69.14,-13.455),(69.31,-13.455),(69.31,-13.625),(69.14,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-13.625),(69.65,-13.455),(69.82,-13.455),(69.82,-13.625),(69.65,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-13.625),(70.16,-13.455),(70.33,-13.455),(70.33,-13.625),(70.16,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-13.625),(70.67,-13.455),(70.84,-13.455),(70.84,-13.625),(70.67,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-13.625),(71.18,-13.455),(71.35,-13.455),(71.35,-13.625),(71.18,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-13.625),(71.69,-13.455),(71.86,-13.455),(71.86,-13.625),(71.69,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-13.625),(72.2,-13.455),(72.37,-13.455),(72.37,-13.625),(72.2,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-13.625),(72.71,-13.455),(72.88,-13.455),(72.88,-13.625),(72.71,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-13.625),(73.22,-13.455),(73.39,-13.455),(73.39,-13.625),(73.22,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-13.625),(73.73,-13.455),(73.9,-13.455),(73.9,-13.625),(73.73,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-13.625),(74.24,-13.455),(74.41,-13.455),(74.41,-13.625),(74.24,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-13.625),(74.75,-13.455),(74.92,-13.455),(74.92,-13.625),(74.75,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-13.625),(75.26,-13.455),(75.43,-13.455),(75.43,-13.625),(75.26,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-13.625),(75.77,-13.455),(75.94,-13.455),(75.94,-13.625),(75.77,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-13.625),(76.28,-13.455),(76.45,-13.455),(76.45,-13.625),(76.28,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-13.625),(76.79,-13.455),(76.96,-13.455),(76.96,-13.625),(76.79,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-13.625),(77.3,-13.455),(77.47,-13.455),(77.47,-13.625),(77.3,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-13.625),(77.81,-13.455),(77.98,-13.455),(77.98,-13.625),(77.81,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-13.625),(78.32,-13.455),(78.49,-13.455),(78.49,-13.625),(78.32,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-13.625),(78.83,-13.455),(79.0,-13.455),(79.0,-13.625),(78.83,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-13.625),(79.34,-13.455),(79.51,-13.455),(79.51,-13.625),(79.34,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-13.625),(79.85,-13.455),(80.02,-13.455),(80.02,-13.625),(79.85,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-13.625),(80.36,-13.455),(80.53,-13.455),(80.53,-13.625),(80.36,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-13.625),(80.87,-13.455),(81.04,-13.455),(81.04,-13.625),(80.87,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-13.625),(81.38,-13.455),(81.55,-13.455),(81.55,-13.625),(81.38,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-13.625),(81.89,-13.455),(82.06,-13.455),(82.06,-13.625),(81.89,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-13.625),(82.4,-13.455),(82.57,-13.455),(82.57,-13.625),(82.4,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-13.625),(82.91,-13.455),(83.08,-13.455),(83.08,-13.625),(82.91,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-13.625),(83.42,-13.455),(83.59,-13.455),(83.59,-13.625),(83.42,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-13.625),(83.93,-13.455),(84.1,-13.455),(84.1,-13.625),(83.93,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-13.625),(84.44,-13.455),(84.61,-13.455),(84.61,-13.625),(84.44,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-13.625),(84.95,-13.455),(85.12,-13.455),(85.12,-13.625),(84.95,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-13.625),(85.46,-13.455),(85.63,-13.455),(85.63,-13.625),(85.46,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-13.625),(85.97,-13.455),(86.14,-13.455),(86.14,-13.625),(85.97,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-13.625),(86.48,-13.455),(86.65,-13.455),(86.65,-13.625),(86.48,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-13.625),(86.99,-13.455),(87.16,-13.455),(87.16,-13.625),(86.99,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-13.625),(87.5,-13.455),(87.67,-13.455),(87.67,-13.625),(87.5,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-13.625),(88.01,-13.455),(88.18,-13.455),(88.18,-13.625),(88.01,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-13.625),(88.52,-13.455),(88.69,-13.455),(88.69,-13.625),(88.52,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-13.625),(89.03,-13.455),(89.2,-13.455),(89.2,-13.625),(89.03,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-13.625),(89.54,-13.455),(89.71,-13.455),(89.71,-13.625),(89.54,-13.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-13.115),(0.29,-12.945),(0.46,-12.945),(0.46,-13.115),(0.29,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-13.115),(0.8,-12.945),(0.97,-12.945),(0.97,-13.115),(0.8,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-13.115),(1.31,-12.945),(1.48,-12.945),(1.48,-13.115),(1.31,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-13.115),(1.82,-12.945),(1.99,-12.945),(1.99,-13.115),(1.82,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-13.115),(2.33,-12.945),(2.5,-12.945),(2.5,-13.115),(2.33,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-13.115),(2.84,-12.945),(3.01,-12.945),(3.01,-13.115),(2.84,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-13.115),(3.35,-12.945),(3.52,-12.945),(3.52,-13.115),(3.35,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-13.115),(3.86,-12.945),(4.03,-12.945),(4.03,-13.115),(3.86,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-13.115),(4.37,-12.945),(4.54,-12.945),(4.54,-13.115),(4.37,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-13.115),(4.88,-12.945),(5.05,-12.945),(5.05,-13.115),(4.88,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-13.115),(5.39,-12.945),(5.56,-12.945),(5.56,-13.115),(5.39,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-13.115),(5.9,-12.945),(6.07,-12.945),(6.07,-13.115),(5.9,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-13.115),(6.41,-12.945),(6.58,-12.945),(6.58,-13.115),(6.41,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-13.115),(6.92,-12.945),(7.09,-12.945),(7.09,-13.115),(6.92,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-13.115),(7.43,-12.945),(7.6,-12.945),(7.6,-13.115),(7.43,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-13.115),(7.94,-12.945),(8.11,-12.945),(8.11,-13.115),(7.94,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-13.115),(8.45,-12.945),(8.62,-12.945),(8.62,-13.115),(8.45,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-13.115),(8.96,-12.945),(9.13,-12.945),(9.13,-13.115),(8.96,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-13.115),(9.47,-12.945),(9.64,-12.945),(9.64,-13.115),(9.47,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-13.115),(9.98,-12.945),(10.15,-12.945),(10.15,-13.115),(9.98,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-13.115),(10.49,-12.945),(10.66,-12.945),(10.66,-13.115),(10.49,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-13.115),(11.0,-12.945),(11.17,-12.945),(11.17,-13.115),(11.0,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-13.115),(11.51,-12.945),(11.68,-12.945),(11.68,-13.115),(11.51,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-13.115),(12.02,-12.945),(12.19,-12.945),(12.19,-13.115),(12.02,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-13.115),(12.53,-12.945),(12.7,-12.945),(12.7,-13.115),(12.53,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-13.115),(13.04,-12.945),(13.21,-12.945),(13.21,-13.115),(13.04,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-13.115),(13.55,-12.945),(13.72,-12.945),(13.72,-13.115),(13.55,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-13.115),(14.06,-12.945),(14.23,-12.945),(14.23,-13.115),(14.06,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-13.115),(14.57,-12.945),(14.74,-12.945),(14.74,-13.115),(14.57,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-13.115),(15.08,-12.945),(15.25,-12.945),(15.25,-13.115),(15.08,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-13.115),(15.59,-12.945),(15.76,-12.945),(15.76,-13.115),(15.59,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-13.115),(16.1,-12.945),(16.27,-12.945),(16.27,-13.115),(16.1,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-13.115),(16.61,-12.945),(16.78,-12.945),(16.78,-13.115),(16.61,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-13.115),(17.12,-12.945),(17.29,-12.945),(17.29,-13.115),(17.12,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-13.115),(17.63,-12.945),(17.8,-12.945),(17.8,-13.115),(17.63,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-13.115),(18.14,-12.945),(18.31,-12.945),(18.31,-13.115),(18.14,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-13.115),(18.65,-12.945),(18.82,-12.945),(18.82,-13.115),(18.65,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-13.115),(19.16,-12.945),(19.33,-12.945),(19.33,-13.115),(19.16,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-13.115),(19.67,-12.945),(19.84,-12.945),(19.84,-13.115),(19.67,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-13.115),(20.18,-12.945),(20.35,-12.945),(20.35,-13.115),(20.18,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-13.115),(20.69,-12.945),(20.86,-12.945),(20.86,-13.115),(20.69,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-13.115),(21.2,-12.945),(21.37,-12.945),(21.37,-13.115),(21.2,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-13.115),(21.71,-12.945),(21.88,-12.945),(21.88,-13.115),(21.71,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-13.115),(22.22,-12.945),(22.39,-12.945),(22.39,-13.115),(22.22,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-13.115),(22.73,-12.945),(22.9,-12.945),(22.9,-13.115),(22.73,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-13.115),(23.24,-12.945),(23.41,-12.945),(23.41,-13.115),(23.24,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-13.115),(23.75,-12.945),(23.92,-12.945),(23.92,-13.115),(23.75,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-13.115),(24.26,-12.945),(24.43,-12.945),(24.43,-13.115),(24.26,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-13.115),(24.77,-12.945),(24.94,-12.945),(24.94,-13.115),(24.77,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-13.115),(25.28,-12.945),(25.45,-12.945),(25.45,-13.115),(25.28,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-13.115),(25.79,-12.945),(25.96,-12.945),(25.96,-13.115),(25.79,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-13.115),(26.3,-12.945),(26.47,-12.945),(26.47,-13.115),(26.3,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-13.115),(26.81,-12.945),(26.98,-12.945),(26.98,-13.115),(26.81,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-13.115),(27.32,-12.945),(27.49,-12.945),(27.49,-13.115),(27.32,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-13.115),(27.83,-12.945),(28.0,-12.945),(28.0,-13.115),(27.83,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-13.115),(28.34,-12.945),(28.51,-12.945),(28.51,-13.115),(28.34,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-13.115),(28.85,-12.945),(29.02,-12.945),(29.02,-13.115),(28.85,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-13.115),(29.36,-12.945),(29.53,-12.945),(29.53,-13.115),(29.36,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-13.115),(29.87,-12.945),(30.04,-12.945),(30.04,-13.115),(29.87,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-13.115),(30.38,-12.945),(30.55,-12.945),(30.55,-13.115),(30.38,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-13.115),(30.89,-12.945),(31.06,-12.945),(31.06,-13.115),(30.89,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-13.115),(31.4,-12.945),(31.57,-12.945),(31.57,-13.115),(31.4,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-13.115),(31.91,-12.945),(32.08,-12.945),(32.08,-13.115),(31.91,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-13.115),(32.42,-12.945),(32.59,-12.945),(32.59,-13.115),(32.42,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-13.115),(32.93,-12.945),(33.1,-12.945),(33.1,-13.115),(32.93,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-13.115),(33.44,-12.945),(33.61,-12.945),(33.61,-13.115),(33.44,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-13.115),(33.95,-12.945),(34.12,-12.945),(34.12,-13.115),(33.95,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-13.115),(34.46,-12.945),(34.63,-12.945),(34.63,-13.115),(34.46,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-13.115),(34.97,-12.945),(35.14,-12.945),(35.14,-13.115),(34.97,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-13.115),(35.48,-12.945),(35.65,-12.945),(35.65,-13.115),(35.48,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-13.115),(35.99,-12.945),(36.16,-12.945),(36.16,-13.115),(35.99,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-13.115),(36.5,-12.945),(36.67,-12.945),(36.67,-13.115),(36.5,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-13.115),(37.01,-12.945),(37.18,-12.945),(37.18,-13.115),(37.01,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-13.115),(37.52,-12.945),(37.69,-12.945),(37.69,-13.115),(37.52,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-13.115),(38.03,-12.945),(38.2,-12.945),(38.2,-13.115),(38.03,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-13.115),(38.54,-12.945),(38.71,-12.945),(38.71,-13.115),(38.54,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-13.115),(39.05,-12.945),(39.22,-12.945),(39.22,-13.115),(39.05,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-13.115),(39.56,-12.945),(39.73,-12.945),(39.73,-13.115),(39.56,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-13.115),(40.07,-12.945),(40.24,-12.945),(40.24,-13.115),(40.07,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-13.115),(40.58,-12.945),(40.75,-12.945),(40.75,-13.115),(40.58,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-13.115),(41.09,-12.945),(41.26,-12.945),(41.26,-13.115),(41.09,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-13.115),(41.6,-12.945),(41.77,-12.945),(41.77,-13.115),(41.6,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-13.115),(42.11,-12.945),(42.28,-12.945),(42.28,-13.115),(42.11,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-13.115),(42.62,-12.945),(42.79,-12.945),(42.79,-13.115),(42.62,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-13.115),(43.13,-12.945),(43.3,-12.945),(43.3,-13.115),(43.13,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-13.115),(43.64,-12.945),(43.81,-12.945),(43.81,-13.115),(43.64,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-13.115),(44.15,-12.945),(44.32,-12.945),(44.32,-13.115),(44.15,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-13.115),(44.66,-12.945),(44.83,-12.945),(44.83,-13.115),(44.66,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-13.115),(45.17,-12.945),(45.34,-12.945),(45.34,-13.115),(45.17,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-13.115),(45.68,-12.945),(45.85,-12.945),(45.85,-13.115),(45.68,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-13.115),(46.19,-12.945),(46.36,-12.945),(46.36,-13.115),(46.19,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-13.115),(46.7,-12.945),(46.87,-12.945),(46.87,-13.115),(46.7,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-13.115),(47.21,-12.945),(47.38,-12.945),(47.38,-13.115),(47.21,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-13.115),(47.72,-12.945),(47.89,-12.945),(47.89,-13.115),(47.72,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-13.115),(48.23,-12.945),(48.4,-12.945),(48.4,-13.115),(48.23,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-13.115),(48.74,-12.945),(48.91,-12.945),(48.91,-13.115),(48.74,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-13.115),(49.25,-12.945),(49.42,-12.945),(49.42,-13.115),(49.25,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-13.115),(49.76,-12.945),(49.93,-12.945),(49.93,-13.115),(49.76,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-13.115),(50.27,-12.945),(50.44,-12.945),(50.44,-13.115),(50.27,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-13.115),(50.78,-12.945),(50.95,-12.945),(50.95,-13.115),(50.78,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-13.115),(51.29,-12.945),(51.46,-12.945),(51.46,-13.115),(51.29,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-13.115),(51.8,-12.945),(51.97,-12.945),(51.97,-13.115),(51.8,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-13.115),(52.31,-12.945),(52.48,-12.945),(52.48,-13.115),(52.31,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-13.115),(52.82,-12.945),(52.99,-12.945),(52.99,-13.115),(52.82,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-13.115),(53.33,-12.945),(53.5,-12.945),(53.5,-13.115),(53.33,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-13.115),(53.84,-12.945),(54.01,-12.945),(54.01,-13.115),(53.84,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-13.115),(54.35,-12.945),(54.52,-12.945),(54.52,-13.115),(54.35,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-13.115),(54.86,-12.945),(55.03,-12.945),(55.03,-13.115),(54.86,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-13.115),(55.37,-12.945),(55.54,-12.945),(55.54,-13.115),(55.37,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-13.115),(55.88,-12.945),(56.05,-12.945),(56.05,-13.115),(55.88,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-13.115),(56.39,-12.945),(56.56,-12.945),(56.56,-13.115),(56.39,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-13.115),(56.9,-12.945),(57.07,-12.945),(57.07,-13.115),(56.9,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-13.115),(57.41,-12.945),(57.58,-12.945),(57.58,-13.115),(57.41,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-13.115),(57.92,-12.945),(58.09,-12.945),(58.09,-13.115),(57.92,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-13.115),(58.43,-12.945),(58.6,-12.945),(58.6,-13.115),(58.43,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-13.115),(58.94,-12.945),(59.11,-12.945),(59.11,-13.115),(58.94,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-13.115),(59.45,-12.945),(59.62,-12.945),(59.62,-13.115),(59.45,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-13.115),(59.96,-12.945),(60.13,-12.945),(60.13,-13.115),(59.96,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-13.115),(60.47,-12.945),(60.64,-12.945),(60.64,-13.115),(60.47,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-13.115),(60.98,-12.945),(61.15,-12.945),(61.15,-13.115),(60.98,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-13.115),(61.49,-12.945),(61.66,-12.945),(61.66,-13.115),(61.49,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-13.115),(62.0,-12.945),(62.17,-12.945),(62.17,-13.115),(62.0,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-13.115),(62.51,-12.945),(62.68,-12.945),(62.68,-13.115),(62.51,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-13.115),(63.02,-12.945),(63.19,-12.945),(63.19,-13.115),(63.02,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-13.115),(63.53,-12.945),(63.7,-12.945),(63.7,-13.115),(63.53,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-13.115),(64.04,-12.945),(64.21,-12.945),(64.21,-13.115),(64.04,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-13.115),(64.55,-12.945),(64.72,-12.945),(64.72,-13.115),(64.55,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-13.115),(65.06,-12.945),(65.23,-12.945),(65.23,-13.115),(65.06,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-13.115),(65.57,-12.945),(65.74,-12.945),(65.74,-13.115),(65.57,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-13.115),(66.08,-12.945),(66.25,-12.945),(66.25,-13.115),(66.08,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-13.115),(66.59,-12.945),(66.76,-12.945),(66.76,-13.115),(66.59,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-13.115),(67.1,-12.945),(67.27,-12.945),(67.27,-13.115),(67.1,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-13.115),(67.61,-12.945),(67.78,-12.945),(67.78,-13.115),(67.61,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-13.115),(68.12,-12.945),(68.29,-12.945),(68.29,-13.115),(68.12,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-13.115),(68.63,-12.945),(68.8,-12.945),(68.8,-13.115),(68.63,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-13.115),(69.14,-12.945),(69.31,-12.945),(69.31,-13.115),(69.14,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-13.115),(69.65,-12.945),(69.82,-12.945),(69.82,-13.115),(69.65,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-13.115),(70.16,-12.945),(70.33,-12.945),(70.33,-13.115),(70.16,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-13.115),(70.67,-12.945),(70.84,-12.945),(70.84,-13.115),(70.67,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-13.115),(71.18,-12.945),(71.35,-12.945),(71.35,-13.115),(71.18,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-13.115),(71.69,-12.945),(71.86,-12.945),(71.86,-13.115),(71.69,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-13.115),(72.2,-12.945),(72.37,-12.945),(72.37,-13.115),(72.2,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-13.115),(72.71,-12.945),(72.88,-12.945),(72.88,-13.115),(72.71,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-13.115),(73.22,-12.945),(73.39,-12.945),(73.39,-13.115),(73.22,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-13.115),(73.73,-12.945),(73.9,-12.945),(73.9,-13.115),(73.73,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-13.115),(74.24,-12.945),(74.41,-12.945),(74.41,-13.115),(74.24,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-13.115),(74.75,-12.945),(74.92,-12.945),(74.92,-13.115),(74.75,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-13.115),(75.26,-12.945),(75.43,-12.945),(75.43,-13.115),(75.26,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-13.115),(75.77,-12.945),(75.94,-12.945),(75.94,-13.115),(75.77,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-13.115),(76.28,-12.945),(76.45,-12.945),(76.45,-13.115),(76.28,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-13.115),(76.79,-12.945),(76.96,-12.945),(76.96,-13.115),(76.79,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-13.115),(77.3,-12.945),(77.47,-12.945),(77.47,-13.115),(77.3,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-13.115),(77.81,-12.945),(77.98,-12.945),(77.98,-13.115),(77.81,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-13.115),(78.32,-12.945),(78.49,-12.945),(78.49,-13.115),(78.32,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-13.115),(78.83,-12.945),(79.0,-12.945),(79.0,-13.115),(78.83,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-13.115),(79.34,-12.945),(79.51,-12.945),(79.51,-13.115),(79.34,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-13.115),(79.85,-12.945),(80.02,-12.945),(80.02,-13.115),(79.85,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-13.115),(80.36,-12.945),(80.53,-12.945),(80.53,-13.115),(80.36,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-13.115),(80.87,-12.945),(81.04,-12.945),(81.04,-13.115),(80.87,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-13.115),(81.38,-12.945),(81.55,-12.945),(81.55,-13.115),(81.38,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-13.115),(81.89,-12.945),(82.06,-12.945),(82.06,-13.115),(81.89,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-13.115),(82.4,-12.945),(82.57,-12.945),(82.57,-13.115),(82.4,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-13.115),(82.91,-12.945),(83.08,-12.945),(83.08,-13.115),(82.91,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-13.115),(83.42,-12.945),(83.59,-12.945),(83.59,-13.115),(83.42,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-13.115),(83.93,-12.945),(84.1,-12.945),(84.1,-13.115),(83.93,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-13.115),(84.44,-12.945),(84.61,-12.945),(84.61,-13.115),(84.44,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-13.115),(84.95,-12.945),(85.12,-12.945),(85.12,-13.115),(84.95,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-13.115),(85.46,-12.945),(85.63,-12.945),(85.63,-13.115),(85.46,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-13.115),(85.97,-12.945),(86.14,-12.945),(86.14,-13.115),(85.97,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-13.115),(86.48,-12.945),(86.65,-12.945),(86.65,-13.115),(86.48,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-13.115),(86.99,-12.945),(87.16,-12.945),(87.16,-13.115),(86.99,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-13.115),(87.5,-12.945),(87.67,-12.945),(87.67,-13.115),(87.5,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-13.115),(88.01,-12.945),(88.18,-12.945),(88.18,-13.115),(88.01,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-13.115),(88.52,-12.945),(88.69,-12.945),(88.69,-13.115),(88.52,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-13.115),(89.03,-12.945),(89.2,-12.945),(89.2,-13.115),(89.03,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-13.115),(89.54,-12.945),(89.71,-12.945),(89.71,-13.115),(89.54,-13.115)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-12.605),(0.29,-12.435),(0.46,-12.435),(0.46,-12.605),(0.29,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-12.605),(0.8,-12.435),(0.97,-12.435),(0.97,-12.605),(0.8,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-12.605),(1.31,-12.435),(1.48,-12.435),(1.48,-12.605),(1.31,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-12.605),(1.82,-12.435),(1.99,-12.435),(1.99,-12.605),(1.82,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-12.605),(2.33,-12.435),(2.5,-12.435),(2.5,-12.605),(2.33,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-12.605),(2.84,-12.435),(3.01,-12.435),(3.01,-12.605),(2.84,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-12.605),(3.35,-12.435),(3.52,-12.435),(3.52,-12.605),(3.35,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-12.605),(3.86,-12.435),(4.03,-12.435),(4.03,-12.605),(3.86,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-12.605),(4.37,-12.435),(4.54,-12.435),(4.54,-12.605),(4.37,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-12.605),(4.88,-12.435),(5.05,-12.435),(5.05,-12.605),(4.88,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-12.605),(5.39,-12.435),(5.56,-12.435),(5.56,-12.605),(5.39,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-12.605),(5.9,-12.435),(6.07,-12.435),(6.07,-12.605),(5.9,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-12.605),(6.41,-12.435),(6.58,-12.435),(6.58,-12.605),(6.41,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-12.605),(6.92,-12.435),(7.09,-12.435),(7.09,-12.605),(6.92,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-12.605),(7.43,-12.435),(7.6,-12.435),(7.6,-12.605),(7.43,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-12.605),(7.94,-12.435),(8.11,-12.435),(8.11,-12.605),(7.94,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-12.605),(8.45,-12.435),(8.62,-12.435),(8.62,-12.605),(8.45,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-12.605),(8.96,-12.435),(9.13,-12.435),(9.13,-12.605),(8.96,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-12.605),(9.47,-12.435),(9.64,-12.435),(9.64,-12.605),(9.47,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-12.605),(9.98,-12.435),(10.15,-12.435),(10.15,-12.605),(9.98,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-12.605),(10.49,-12.435),(10.66,-12.435),(10.66,-12.605),(10.49,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-12.605),(11.0,-12.435),(11.17,-12.435),(11.17,-12.605),(11.0,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-12.605),(11.51,-12.435),(11.68,-12.435),(11.68,-12.605),(11.51,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-12.605),(12.02,-12.435),(12.19,-12.435),(12.19,-12.605),(12.02,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-12.605),(12.53,-12.435),(12.7,-12.435),(12.7,-12.605),(12.53,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-12.605),(13.04,-12.435),(13.21,-12.435),(13.21,-12.605),(13.04,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-12.605),(13.55,-12.435),(13.72,-12.435),(13.72,-12.605),(13.55,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-12.605),(14.06,-12.435),(14.23,-12.435),(14.23,-12.605),(14.06,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-12.605),(14.57,-12.435),(14.74,-12.435),(14.74,-12.605),(14.57,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-12.605),(15.08,-12.435),(15.25,-12.435),(15.25,-12.605),(15.08,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-12.605),(15.59,-12.435),(15.76,-12.435),(15.76,-12.605),(15.59,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-12.605),(16.1,-12.435),(16.27,-12.435),(16.27,-12.605),(16.1,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-12.605),(16.61,-12.435),(16.78,-12.435),(16.78,-12.605),(16.61,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-12.605),(17.12,-12.435),(17.29,-12.435),(17.29,-12.605),(17.12,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-12.605),(17.63,-12.435),(17.8,-12.435),(17.8,-12.605),(17.63,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-12.605),(18.14,-12.435),(18.31,-12.435),(18.31,-12.605),(18.14,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-12.605),(18.65,-12.435),(18.82,-12.435),(18.82,-12.605),(18.65,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-12.605),(19.16,-12.435),(19.33,-12.435),(19.33,-12.605),(19.16,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-12.605),(19.67,-12.435),(19.84,-12.435),(19.84,-12.605),(19.67,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-12.605),(20.18,-12.435),(20.35,-12.435),(20.35,-12.605),(20.18,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-12.605),(20.69,-12.435),(20.86,-12.435),(20.86,-12.605),(20.69,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-12.605),(21.2,-12.435),(21.37,-12.435),(21.37,-12.605),(21.2,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-12.605),(21.71,-12.435),(21.88,-12.435),(21.88,-12.605),(21.71,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-12.605),(22.22,-12.435),(22.39,-12.435),(22.39,-12.605),(22.22,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-12.605),(22.73,-12.435),(22.9,-12.435),(22.9,-12.605),(22.73,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-12.605),(23.24,-12.435),(23.41,-12.435),(23.41,-12.605),(23.24,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-12.605),(23.75,-12.435),(23.92,-12.435),(23.92,-12.605),(23.75,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-12.605),(24.26,-12.435),(24.43,-12.435),(24.43,-12.605),(24.26,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-12.605),(24.77,-12.435),(24.94,-12.435),(24.94,-12.605),(24.77,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-12.605),(25.28,-12.435),(25.45,-12.435),(25.45,-12.605),(25.28,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-12.605),(25.79,-12.435),(25.96,-12.435),(25.96,-12.605),(25.79,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-12.605),(26.3,-12.435),(26.47,-12.435),(26.47,-12.605),(26.3,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-12.605),(26.81,-12.435),(26.98,-12.435),(26.98,-12.605),(26.81,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-12.605),(27.32,-12.435),(27.49,-12.435),(27.49,-12.605),(27.32,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-12.605),(27.83,-12.435),(28.0,-12.435),(28.0,-12.605),(27.83,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-12.605),(28.34,-12.435),(28.51,-12.435),(28.51,-12.605),(28.34,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-12.605),(28.85,-12.435),(29.02,-12.435),(29.02,-12.605),(28.85,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-12.605),(29.36,-12.435),(29.53,-12.435),(29.53,-12.605),(29.36,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-12.605),(29.87,-12.435),(30.04,-12.435),(30.04,-12.605),(29.87,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-12.605),(30.38,-12.435),(30.55,-12.435),(30.55,-12.605),(30.38,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-12.605),(30.89,-12.435),(31.06,-12.435),(31.06,-12.605),(30.89,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-12.605),(31.4,-12.435),(31.57,-12.435),(31.57,-12.605),(31.4,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-12.605),(31.91,-12.435),(32.08,-12.435),(32.08,-12.605),(31.91,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-12.605),(32.42,-12.435),(32.59,-12.435),(32.59,-12.605),(32.42,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-12.605),(32.93,-12.435),(33.1,-12.435),(33.1,-12.605),(32.93,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-12.605),(33.44,-12.435),(33.61,-12.435),(33.61,-12.605),(33.44,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-12.605),(33.95,-12.435),(34.12,-12.435),(34.12,-12.605),(33.95,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-12.605),(34.46,-12.435),(34.63,-12.435),(34.63,-12.605),(34.46,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-12.605),(34.97,-12.435),(35.14,-12.435),(35.14,-12.605),(34.97,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-12.605),(35.48,-12.435),(35.65,-12.435),(35.65,-12.605),(35.48,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-12.605),(35.99,-12.435),(36.16,-12.435),(36.16,-12.605),(35.99,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-12.605),(36.5,-12.435),(36.67,-12.435),(36.67,-12.605),(36.5,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-12.605),(37.01,-12.435),(37.18,-12.435),(37.18,-12.605),(37.01,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-12.605),(37.52,-12.435),(37.69,-12.435),(37.69,-12.605),(37.52,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-12.605),(38.03,-12.435),(38.2,-12.435),(38.2,-12.605),(38.03,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-12.605),(38.54,-12.435),(38.71,-12.435),(38.71,-12.605),(38.54,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-12.605),(39.05,-12.435),(39.22,-12.435),(39.22,-12.605),(39.05,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-12.605),(39.56,-12.435),(39.73,-12.435),(39.73,-12.605),(39.56,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-12.605),(40.07,-12.435),(40.24,-12.435),(40.24,-12.605),(40.07,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-12.605),(40.58,-12.435),(40.75,-12.435),(40.75,-12.605),(40.58,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-12.605),(41.09,-12.435),(41.26,-12.435),(41.26,-12.605),(41.09,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-12.605),(41.6,-12.435),(41.77,-12.435),(41.77,-12.605),(41.6,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-12.605),(42.11,-12.435),(42.28,-12.435),(42.28,-12.605),(42.11,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-12.605),(42.62,-12.435),(42.79,-12.435),(42.79,-12.605),(42.62,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-12.605),(43.13,-12.435),(43.3,-12.435),(43.3,-12.605),(43.13,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-12.605),(43.64,-12.435),(43.81,-12.435),(43.81,-12.605),(43.64,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-12.605),(44.15,-12.435),(44.32,-12.435),(44.32,-12.605),(44.15,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-12.605),(44.66,-12.435),(44.83,-12.435),(44.83,-12.605),(44.66,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-12.605),(45.17,-12.435),(45.34,-12.435),(45.34,-12.605),(45.17,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-12.605),(45.68,-12.435),(45.85,-12.435),(45.85,-12.605),(45.68,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-12.605),(46.19,-12.435),(46.36,-12.435),(46.36,-12.605),(46.19,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-12.605),(46.7,-12.435),(46.87,-12.435),(46.87,-12.605),(46.7,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-12.605),(47.21,-12.435),(47.38,-12.435),(47.38,-12.605),(47.21,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-12.605),(47.72,-12.435),(47.89,-12.435),(47.89,-12.605),(47.72,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-12.605),(48.23,-12.435),(48.4,-12.435),(48.4,-12.605),(48.23,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-12.605),(48.74,-12.435),(48.91,-12.435),(48.91,-12.605),(48.74,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-12.605),(49.25,-12.435),(49.42,-12.435),(49.42,-12.605),(49.25,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-12.605),(49.76,-12.435),(49.93,-12.435),(49.93,-12.605),(49.76,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-12.605),(50.27,-12.435),(50.44,-12.435),(50.44,-12.605),(50.27,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-12.605),(50.78,-12.435),(50.95,-12.435),(50.95,-12.605),(50.78,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-12.605),(51.29,-12.435),(51.46,-12.435),(51.46,-12.605),(51.29,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-12.605),(51.8,-12.435),(51.97,-12.435),(51.97,-12.605),(51.8,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-12.605),(52.31,-12.435),(52.48,-12.435),(52.48,-12.605),(52.31,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-12.605),(52.82,-12.435),(52.99,-12.435),(52.99,-12.605),(52.82,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-12.605),(53.33,-12.435),(53.5,-12.435),(53.5,-12.605),(53.33,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-12.605),(53.84,-12.435),(54.01,-12.435),(54.01,-12.605),(53.84,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-12.605),(54.35,-12.435),(54.52,-12.435),(54.52,-12.605),(54.35,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-12.605),(54.86,-12.435),(55.03,-12.435),(55.03,-12.605),(54.86,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-12.605),(55.37,-12.435),(55.54,-12.435),(55.54,-12.605),(55.37,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-12.605),(55.88,-12.435),(56.05,-12.435),(56.05,-12.605),(55.88,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-12.605),(56.39,-12.435),(56.56,-12.435),(56.56,-12.605),(56.39,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-12.605),(56.9,-12.435),(57.07,-12.435),(57.07,-12.605),(56.9,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-12.605),(57.41,-12.435),(57.58,-12.435),(57.58,-12.605),(57.41,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-12.605),(57.92,-12.435),(58.09,-12.435),(58.09,-12.605),(57.92,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-12.605),(58.43,-12.435),(58.6,-12.435),(58.6,-12.605),(58.43,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-12.605),(58.94,-12.435),(59.11,-12.435),(59.11,-12.605),(58.94,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-12.605),(59.45,-12.435),(59.62,-12.435),(59.62,-12.605),(59.45,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-12.605),(59.96,-12.435),(60.13,-12.435),(60.13,-12.605),(59.96,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-12.605),(60.47,-12.435),(60.64,-12.435),(60.64,-12.605),(60.47,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-12.605),(60.98,-12.435),(61.15,-12.435),(61.15,-12.605),(60.98,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-12.605),(61.49,-12.435),(61.66,-12.435),(61.66,-12.605),(61.49,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-12.605),(62.0,-12.435),(62.17,-12.435),(62.17,-12.605),(62.0,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-12.605),(62.51,-12.435),(62.68,-12.435),(62.68,-12.605),(62.51,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-12.605),(63.02,-12.435),(63.19,-12.435),(63.19,-12.605),(63.02,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-12.605),(63.53,-12.435),(63.7,-12.435),(63.7,-12.605),(63.53,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-12.605),(64.04,-12.435),(64.21,-12.435),(64.21,-12.605),(64.04,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-12.605),(64.55,-12.435),(64.72,-12.435),(64.72,-12.605),(64.55,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-12.605),(65.06,-12.435),(65.23,-12.435),(65.23,-12.605),(65.06,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-12.605),(65.57,-12.435),(65.74,-12.435),(65.74,-12.605),(65.57,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-12.605),(66.08,-12.435),(66.25,-12.435),(66.25,-12.605),(66.08,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-12.605),(66.59,-12.435),(66.76,-12.435),(66.76,-12.605),(66.59,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-12.605),(67.1,-12.435),(67.27,-12.435),(67.27,-12.605),(67.1,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-12.605),(67.61,-12.435),(67.78,-12.435),(67.78,-12.605),(67.61,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-12.605),(68.12,-12.435),(68.29,-12.435),(68.29,-12.605),(68.12,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-12.605),(68.63,-12.435),(68.8,-12.435),(68.8,-12.605),(68.63,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-12.605),(69.14,-12.435),(69.31,-12.435),(69.31,-12.605),(69.14,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-12.605),(69.65,-12.435),(69.82,-12.435),(69.82,-12.605),(69.65,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-12.605),(70.16,-12.435),(70.33,-12.435),(70.33,-12.605),(70.16,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-12.605),(70.67,-12.435),(70.84,-12.435),(70.84,-12.605),(70.67,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-12.605),(71.18,-12.435),(71.35,-12.435),(71.35,-12.605),(71.18,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-12.605),(71.69,-12.435),(71.86,-12.435),(71.86,-12.605),(71.69,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-12.605),(72.2,-12.435),(72.37,-12.435),(72.37,-12.605),(72.2,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-12.605),(72.71,-12.435),(72.88,-12.435),(72.88,-12.605),(72.71,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-12.605),(73.22,-12.435),(73.39,-12.435),(73.39,-12.605),(73.22,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-12.605),(73.73,-12.435),(73.9,-12.435),(73.9,-12.605),(73.73,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-12.605),(74.24,-12.435),(74.41,-12.435),(74.41,-12.605),(74.24,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-12.605),(74.75,-12.435),(74.92,-12.435),(74.92,-12.605),(74.75,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-12.605),(75.26,-12.435),(75.43,-12.435),(75.43,-12.605),(75.26,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-12.605),(75.77,-12.435),(75.94,-12.435),(75.94,-12.605),(75.77,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-12.605),(76.28,-12.435),(76.45,-12.435),(76.45,-12.605),(76.28,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-12.605),(76.79,-12.435),(76.96,-12.435),(76.96,-12.605),(76.79,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-12.605),(77.3,-12.435),(77.47,-12.435),(77.47,-12.605),(77.3,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-12.605),(77.81,-12.435),(77.98,-12.435),(77.98,-12.605),(77.81,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-12.605),(78.32,-12.435),(78.49,-12.435),(78.49,-12.605),(78.32,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-12.605),(78.83,-12.435),(79.0,-12.435),(79.0,-12.605),(78.83,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-12.605),(79.34,-12.435),(79.51,-12.435),(79.51,-12.605),(79.34,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-12.605),(79.85,-12.435),(80.02,-12.435),(80.02,-12.605),(79.85,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-12.605),(80.36,-12.435),(80.53,-12.435),(80.53,-12.605),(80.36,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-12.605),(80.87,-12.435),(81.04,-12.435),(81.04,-12.605),(80.87,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-12.605),(81.38,-12.435),(81.55,-12.435),(81.55,-12.605),(81.38,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-12.605),(81.89,-12.435),(82.06,-12.435),(82.06,-12.605),(81.89,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-12.605),(82.4,-12.435),(82.57,-12.435),(82.57,-12.605),(82.4,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-12.605),(82.91,-12.435),(83.08,-12.435),(83.08,-12.605),(82.91,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-12.605),(83.42,-12.435),(83.59,-12.435),(83.59,-12.605),(83.42,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-12.605),(83.93,-12.435),(84.1,-12.435),(84.1,-12.605),(83.93,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-12.605),(84.44,-12.435),(84.61,-12.435),(84.61,-12.605),(84.44,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-12.605),(84.95,-12.435),(85.12,-12.435),(85.12,-12.605),(84.95,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-12.605),(85.46,-12.435),(85.63,-12.435),(85.63,-12.605),(85.46,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-12.605),(85.97,-12.435),(86.14,-12.435),(86.14,-12.605),(85.97,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-12.605),(86.48,-12.435),(86.65,-12.435),(86.65,-12.605),(86.48,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-12.605),(86.99,-12.435),(87.16,-12.435),(87.16,-12.605),(86.99,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-12.605),(87.5,-12.435),(87.67,-12.435),(87.67,-12.605),(87.5,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-12.605),(88.01,-12.435),(88.18,-12.435),(88.18,-12.605),(88.01,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-12.605),(88.52,-12.435),(88.69,-12.435),(88.69,-12.605),(88.52,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-12.605),(89.03,-12.435),(89.2,-12.435),(89.2,-12.605),(89.03,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-12.605),(89.54,-12.435),(89.71,-12.435),(89.71,-12.605),(89.54,-12.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-12.095),(0.29,-11.925),(0.46,-11.925),(0.46,-12.095),(0.29,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-12.095),(0.8,-11.925),(0.97,-11.925),(0.97,-12.095),(0.8,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-12.095),(1.31,-11.925),(1.48,-11.925),(1.48,-12.095),(1.31,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-12.095),(1.82,-11.925),(1.99,-11.925),(1.99,-12.095),(1.82,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-12.095),(2.33,-11.925),(2.5,-11.925),(2.5,-12.095),(2.33,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-12.095),(2.84,-11.925),(3.01,-11.925),(3.01,-12.095),(2.84,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-12.095),(3.35,-11.925),(3.52,-11.925),(3.52,-12.095),(3.35,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-12.095),(3.86,-11.925),(4.03,-11.925),(4.03,-12.095),(3.86,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-12.095),(4.37,-11.925),(4.54,-11.925),(4.54,-12.095),(4.37,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-12.095),(4.88,-11.925),(5.05,-11.925),(5.05,-12.095),(4.88,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-12.095),(5.39,-11.925),(5.56,-11.925),(5.56,-12.095),(5.39,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-12.095),(5.9,-11.925),(6.07,-11.925),(6.07,-12.095),(5.9,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-12.095),(6.41,-11.925),(6.58,-11.925),(6.58,-12.095),(6.41,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-12.095),(6.92,-11.925),(7.09,-11.925),(7.09,-12.095),(6.92,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-12.095),(7.43,-11.925),(7.6,-11.925),(7.6,-12.095),(7.43,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-12.095),(7.94,-11.925),(8.11,-11.925),(8.11,-12.095),(7.94,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-12.095),(8.45,-11.925),(8.62,-11.925),(8.62,-12.095),(8.45,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-12.095),(8.96,-11.925),(9.13,-11.925),(9.13,-12.095),(8.96,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-12.095),(9.47,-11.925),(9.64,-11.925),(9.64,-12.095),(9.47,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-12.095),(9.98,-11.925),(10.15,-11.925),(10.15,-12.095),(9.98,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-12.095),(10.49,-11.925),(10.66,-11.925),(10.66,-12.095),(10.49,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-12.095),(11.0,-11.925),(11.17,-11.925),(11.17,-12.095),(11.0,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-12.095),(11.51,-11.925),(11.68,-11.925),(11.68,-12.095),(11.51,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-12.095),(12.02,-11.925),(12.19,-11.925),(12.19,-12.095),(12.02,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-12.095),(12.53,-11.925),(12.7,-11.925),(12.7,-12.095),(12.53,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-12.095),(13.04,-11.925),(13.21,-11.925),(13.21,-12.095),(13.04,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-12.095),(13.55,-11.925),(13.72,-11.925),(13.72,-12.095),(13.55,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-12.095),(14.06,-11.925),(14.23,-11.925),(14.23,-12.095),(14.06,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-12.095),(14.57,-11.925),(14.74,-11.925),(14.74,-12.095),(14.57,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-12.095),(15.08,-11.925),(15.25,-11.925),(15.25,-12.095),(15.08,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-12.095),(15.59,-11.925),(15.76,-11.925),(15.76,-12.095),(15.59,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-12.095),(16.1,-11.925),(16.27,-11.925),(16.27,-12.095),(16.1,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-12.095),(16.61,-11.925),(16.78,-11.925),(16.78,-12.095),(16.61,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-12.095),(17.12,-11.925),(17.29,-11.925),(17.29,-12.095),(17.12,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-12.095),(17.63,-11.925),(17.8,-11.925),(17.8,-12.095),(17.63,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-12.095),(18.14,-11.925),(18.31,-11.925),(18.31,-12.095),(18.14,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-12.095),(18.65,-11.925),(18.82,-11.925),(18.82,-12.095),(18.65,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-12.095),(19.16,-11.925),(19.33,-11.925),(19.33,-12.095),(19.16,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-12.095),(19.67,-11.925),(19.84,-11.925),(19.84,-12.095),(19.67,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-12.095),(20.18,-11.925),(20.35,-11.925),(20.35,-12.095),(20.18,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-12.095),(20.69,-11.925),(20.86,-11.925),(20.86,-12.095),(20.69,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-12.095),(21.2,-11.925),(21.37,-11.925),(21.37,-12.095),(21.2,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-12.095),(21.71,-11.925),(21.88,-11.925),(21.88,-12.095),(21.71,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-12.095),(22.22,-11.925),(22.39,-11.925),(22.39,-12.095),(22.22,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-12.095),(22.73,-11.925),(22.9,-11.925),(22.9,-12.095),(22.73,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-12.095),(23.24,-11.925),(23.41,-11.925),(23.41,-12.095),(23.24,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-12.095),(23.75,-11.925),(23.92,-11.925),(23.92,-12.095),(23.75,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-12.095),(24.26,-11.925),(24.43,-11.925),(24.43,-12.095),(24.26,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-12.095),(24.77,-11.925),(24.94,-11.925),(24.94,-12.095),(24.77,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-12.095),(25.28,-11.925),(25.45,-11.925),(25.45,-12.095),(25.28,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-12.095),(25.79,-11.925),(25.96,-11.925),(25.96,-12.095),(25.79,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-12.095),(26.3,-11.925),(26.47,-11.925),(26.47,-12.095),(26.3,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-12.095),(26.81,-11.925),(26.98,-11.925),(26.98,-12.095),(26.81,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-12.095),(27.32,-11.925),(27.49,-11.925),(27.49,-12.095),(27.32,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-12.095),(27.83,-11.925),(28.0,-11.925),(28.0,-12.095),(27.83,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-12.095),(28.34,-11.925),(28.51,-11.925),(28.51,-12.095),(28.34,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-12.095),(28.85,-11.925),(29.02,-11.925),(29.02,-12.095),(28.85,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-12.095),(29.36,-11.925),(29.53,-11.925),(29.53,-12.095),(29.36,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-12.095),(29.87,-11.925),(30.04,-11.925),(30.04,-12.095),(29.87,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-12.095),(30.38,-11.925),(30.55,-11.925),(30.55,-12.095),(30.38,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-12.095),(30.89,-11.925),(31.06,-11.925),(31.06,-12.095),(30.89,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-12.095),(31.4,-11.925),(31.57,-11.925),(31.57,-12.095),(31.4,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-12.095),(31.91,-11.925),(32.08,-11.925),(32.08,-12.095),(31.91,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-12.095),(32.42,-11.925),(32.59,-11.925),(32.59,-12.095),(32.42,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-12.095),(32.93,-11.925),(33.1,-11.925),(33.1,-12.095),(32.93,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-12.095),(33.44,-11.925),(33.61,-11.925),(33.61,-12.095),(33.44,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-12.095),(33.95,-11.925),(34.12,-11.925),(34.12,-12.095),(33.95,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-12.095),(34.46,-11.925),(34.63,-11.925),(34.63,-12.095),(34.46,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-12.095),(34.97,-11.925),(35.14,-11.925),(35.14,-12.095),(34.97,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-12.095),(35.48,-11.925),(35.65,-11.925),(35.65,-12.095),(35.48,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-12.095),(35.99,-11.925),(36.16,-11.925),(36.16,-12.095),(35.99,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-12.095),(36.5,-11.925),(36.67,-11.925),(36.67,-12.095),(36.5,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-12.095),(37.01,-11.925),(37.18,-11.925),(37.18,-12.095),(37.01,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-12.095),(37.52,-11.925),(37.69,-11.925),(37.69,-12.095),(37.52,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-12.095),(38.03,-11.925),(38.2,-11.925),(38.2,-12.095),(38.03,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-12.095),(38.54,-11.925),(38.71,-11.925),(38.71,-12.095),(38.54,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-12.095),(39.05,-11.925),(39.22,-11.925),(39.22,-12.095),(39.05,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-12.095),(39.56,-11.925),(39.73,-11.925),(39.73,-12.095),(39.56,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-12.095),(40.07,-11.925),(40.24,-11.925),(40.24,-12.095),(40.07,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-12.095),(40.58,-11.925),(40.75,-11.925),(40.75,-12.095),(40.58,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-12.095),(41.09,-11.925),(41.26,-11.925),(41.26,-12.095),(41.09,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-12.095),(41.6,-11.925),(41.77,-11.925),(41.77,-12.095),(41.6,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-12.095),(42.11,-11.925),(42.28,-11.925),(42.28,-12.095),(42.11,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-12.095),(42.62,-11.925),(42.79,-11.925),(42.79,-12.095),(42.62,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-12.095),(43.13,-11.925),(43.3,-11.925),(43.3,-12.095),(43.13,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-12.095),(43.64,-11.925),(43.81,-11.925),(43.81,-12.095),(43.64,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-12.095),(44.15,-11.925),(44.32,-11.925),(44.32,-12.095),(44.15,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-12.095),(44.66,-11.925),(44.83,-11.925),(44.83,-12.095),(44.66,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-12.095),(45.17,-11.925),(45.34,-11.925),(45.34,-12.095),(45.17,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-12.095),(45.68,-11.925),(45.85,-11.925),(45.85,-12.095),(45.68,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-12.095),(46.19,-11.925),(46.36,-11.925),(46.36,-12.095),(46.19,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-12.095),(46.7,-11.925),(46.87,-11.925),(46.87,-12.095),(46.7,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-12.095),(47.21,-11.925),(47.38,-11.925),(47.38,-12.095),(47.21,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-12.095),(47.72,-11.925),(47.89,-11.925),(47.89,-12.095),(47.72,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-12.095),(48.23,-11.925),(48.4,-11.925),(48.4,-12.095),(48.23,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-12.095),(48.74,-11.925),(48.91,-11.925),(48.91,-12.095),(48.74,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-12.095),(49.25,-11.925),(49.42,-11.925),(49.42,-12.095),(49.25,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-12.095),(49.76,-11.925),(49.93,-11.925),(49.93,-12.095),(49.76,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-12.095),(50.27,-11.925),(50.44,-11.925),(50.44,-12.095),(50.27,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-12.095),(50.78,-11.925),(50.95,-11.925),(50.95,-12.095),(50.78,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-12.095),(51.29,-11.925),(51.46,-11.925),(51.46,-12.095),(51.29,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-12.095),(51.8,-11.925),(51.97,-11.925),(51.97,-12.095),(51.8,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-12.095),(52.31,-11.925),(52.48,-11.925),(52.48,-12.095),(52.31,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-12.095),(52.82,-11.925),(52.99,-11.925),(52.99,-12.095),(52.82,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-12.095),(53.33,-11.925),(53.5,-11.925),(53.5,-12.095),(53.33,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-12.095),(53.84,-11.925),(54.01,-11.925),(54.01,-12.095),(53.84,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-12.095),(54.35,-11.925),(54.52,-11.925),(54.52,-12.095),(54.35,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-12.095),(54.86,-11.925),(55.03,-11.925),(55.03,-12.095),(54.86,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-12.095),(55.37,-11.925),(55.54,-11.925),(55.54,-12.095),(55.37,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-12.095),(55.88,-11.925),(56.05,-11.925),(56.05,-12.095),(55.88,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-12.095),(56.39,-11.925),(56.56,-11.925),(56.56,-12.095),(56.39,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-12.095),(56.9,-11.925),(57.07,-11.925),(57.07,-12.095),(56.9,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-12.095),(57.41,-11.925),(57.58,-11.925),(57.58,-12.095),(57.41,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-12.095),(57.92,-11.925),(58.09,-11.925),(58.09,-12.095),(57.92,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-12.095),(58.43,-11.925),(58.6,-11.925),(58.6,-12.095),(58.43,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-12.095),(58.94,-11.925),(59.11,-11.925),(59.11,-12.095),(58.94,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-12.095),(59.45,-11.925),(59.62,-11.925),(59.62,-12.095),(59.45,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-12.095),(59.96,-11.925),(60.13,-11.925),(60.13,-12.095),(59.96,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-12.095),(60.47,-11.925),(60.64,-11.925),(60.64,-12.095),(60.47,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-12.095),(60.98,-11.925),(61.15,-11.925),(61.15,-12.095),(60.98,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-12.095),(61.49,-11.925),(61.66,-11.925),(61.66,-12.095),(61.49,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-12.095),(62.0,-11.925),(62.17,-11.925),(62.17,-12.095),(62.0,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-12.095),(62.51,-11.925),(62.68,-11.925),(62.68,-12.095),(62.51,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-12.095),(63.02,-11.925),(63.19,-11.925),(63.19,-12.095),(63.02,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-12.095),(63.53,-11.925),(63.7,-11.925),(63.7,-12.095),(63.53,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-12.095),(64.04,-11.925),(64.21,-11.925),(64.21,-12.095),(64.04,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-12.095),(64.55,-11.925),(64.72,-11.925),(64.72,-12.095),(64.55,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-12.095),(65.06,-11.925),(65.23,-11.925),(65.23,-12.095),(65.06,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-12.095),(65.57,-11.925),(65.74,-11.925),(65.74,-12.095),(65.57,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-12.095),(66.08,-11.925),(66.25,-11.925),(66.25,-12.095),(66.08,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-12.095),(66.59,-11.925),(66.76,-11.925),(66.76,-12.095),(66.59,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-12.095),(67.1,-11.925),(67.27,-11.925),(67.27,-12.095),(67.1,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-12.095),(67.61,-11.925),(67.78,-11.925),(67.78,-12.095),(67.61,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-12.095),(68.12,-11.925),(68.29,-11.925),(68.29,-12.095),(68.12,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-12.095),(68.63,-11.925),(68.8,-11.925),(68.8,-12.095),(68.63,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-12.095),(69.14,-11.925),(69.31,-11.925),(69.31,-12.095),(69.14,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-12.095),(69.65,-11.925),(69.82,-11.925),(69.82,-12.095),(69.65,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-12.095),(70.16,-11.925),(70.33,-11.925),(70.33,-12.095),(70.16,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-12.095),(70.67,-11.925),(70.84,-11.925),(70.84,-12.095),(70.67,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-12.095),(71.18,-11.925),(71.35,-11.925),(71.35,-12.095),(71.18,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-12.095),(71.69,-11.925),(71.86,-11.925),(71.86,-12.095),(71.69,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-12.095),(72.2,-11.925),(72.37,-11.925),(72.37,-12.095),(72.2,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-12.095),(72.71,-11.925),(72.88,-11.925),(72.88,-12.095),(72.71,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-12.095),(73.22,-11.925),(73.39,-11.925),(73.39,-12.095),(73.22,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-12.095),(73.73,-11.925),(73.9,-11.925),(73.9,-12.095),(73.73,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-12.095),(74.24,-11.925),(74.41,-11.925),(74.41,-12.095),(74.24,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-12.095),(74.75,-11.925),(74.92,-11.925),(74.92,-12.095),(74.75,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-12.095),(75.26,-11.925),(75.43,-11.925),(75.43,-12.095),(75.26,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-12.095),(75.77,-11.925),(75.94,-11.925),(75.94,-12.095),(75.77,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-12.095),(76.28,-11.925),(76.45,-11.925),(76.45,-12.095),(76.28,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-12.095),(76.79,-11.925),(76.96,-11.925),(76.96,-12.095),(76.79,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-12.095),(77.3,-11.925),(77.47,-11.925),(77.47,-12.095),(77.3,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-12.095),(77.81,-11.925),(77.98,-11.925),(77.98,-12.095),(77.81,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-12.095),(78.32,-11.925),(78.49,-11.925),(78.49,-12.095),(78.32,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-12.095),(78.83,-11.925),(79.0,-11.925),(79.0,-12.095),(78.83,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-12.095),(79.34,-11.925),(79.51,-11.925),(79.51,-12.095),(79.34,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-12.095),(79.85,-11.925),(80.02,-11.925),(80.02,-12.095),(79.85,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-12.095),(80.36,-11.925),(80.53,-11.925),(80.53,-12.095),(80.36,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-12.095),(80.87,-11.925),(81.04,-11.925),(81.04,-12.095),(80.87,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-12.095),(81.38,-11.925),(81.55,-11.925),(81.55,-12.095),(81.38,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-12.095),(81.89,-11.925),(82.06,-11.925),(82.06,-12.095),(81.89,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-12.095),(82.4,-11.925),(82.57,-11.925),(82.57,-12.095),(82.4,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-12.095),(82.91,-11.925),(83.08,-11.925),(83.08,-12.095),(82.91,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-12.095),(83.42,-11.925),(83.59,-11.925),(83.59,-12.095),(83.42,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-12.095),(83.93,-11.925),(84.1,-11.925),(84.1,-12.095),(83.93,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-12.095),(84.44,-11.925),(84.61,-11.925),(84.61,-12.095),(84.44,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-12.095),(84.95,-11.925),(85.12,-11.925),(85.12,-12.095),(84.95,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-12.095),(85.46,-11.925),(85.63,-11.925),(85.63,-12.095),(85.46,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-12.095),(85.97,-11.925),(86.14,-11.925),(86.14,-12.095),(85.97,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-12.095),(86.48,-11.925),(86.65,-11.925),(86.65,-12.095),(86.48,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-12.095),(86.99,-11.925),(87.16,-11.925),(87.16,-12.095),(86.99,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-12.095),(87.5,-11.925),(87.67,-11.925),(87.67,-12.095),(87.5,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-12.095),(88.01,-11.925),(88.18,-11.925),(88.18,-12.095),(88.01,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-12.095),(88.52,-11.925),(88.69,-11.925),(88.69,-12.095),(88.52,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-12.095),(89.03,-11.925),(89.2,-11.925),(89.2,-12.095),(89.03,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-12.095),(89.54,-11.925),(89.71,-11.925),(89.71,-12.095),(89.54,-12.095)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-11.585),(0.29,-11.415),(0.46,-11.415),(0.46,-11.585),(0.29,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-11.585),(0.8,-11.415),(0.97,-11.415),(0.97,-11.585),(0.8,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-11.585),(1.31,-11.415),(1.48,-11.415),(1.48,-11.585),(1.31,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-11.585),(1.82,-11.415),(1.99,-11.415),(1.99,-11.585),(1.82,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-11.585),(2.33,-11.415),(2.5,-11.415),(2.5,-11.585),(2.33,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-11.585),(2.84,-11.415),(3.01,-11.415),(3.01,-11.585),(2.84,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-11.585),(3.35,-11.415),(3.52,-11.415),(3.52,-11.585),(3.35,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-11.585),(3.86,-11.415),(4.03,-11.415),(4.03,-11.585),(3.86,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-11.585),(4.37,-11.415),(4.54,-11.415),(4.54,-11.585),(4.37,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-11.585),(4.88,-11.415),(5.05,-11.415),(5.05,-11.585),(4.88,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-11.585),(5.39,-11.415),(5.56,-11.415),(5.56,-11.585),(5.39,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-11.585),(5.9,-11.415),(6.07,-11.415),(6.07,-11.585),(5.9,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-11.585),(6.41,-11.415),(6.58,-11.415),(6.58,-11.585),(6.41,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-11.585),(6.92,-11.415),(7.09,-11.415),(7.09,-11.585),(6.92,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-11.585),(7.43,-11.415),(7.6,-11.415),(7.6,-11.585),(7.43,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-11.585),(7.94,-11.415),(8.11,-11.415),(8.11,-11.585),(7.94,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-11.585),(8.45,-11.415),(8.62,-11.415),(8.62,-11.585),(8.45,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-11.585),(8.96,-11.415),(9.13,-11.415),(9.13,-11.585),(8.96,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-11.585),(9.47,-11.415),(9.64,-11.415),(9.64,-11.585),(9.47,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-11.585),(9.98,-11.415),(10.15,-11.415),(10.15,-11.585),(9.98,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-11.585),(10.49,-11.415),(10.66,-11.415),(10.66,-11.585),(10.49,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-11.585),(11.0,-11.415),(11.17,-11.415),(11.17,-11.585),(11.0,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-11.585),(11.51,-11.415),(11.68,-11.415),(11.68,-11.585),(11.51,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-11.585),(12.02,-11.415),(12.19,-11.415),(12.19,-11.585),(12.02,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-11.585),(12.53,-11.415),(12.7,-11.415),(12.7,-11.585),(12.53,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-11.585),(13.04,-11.415),(13.21,-11.415),(13.21,-11.585),(13.04,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-11.585),(13.55,-11.415),(13.72,-11.415),(13.72,-11.585),(13.55,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-11.585),(14.06,-11.415),(14.23,-11.415),(14.23,-11.585),(14.06,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-11.585),(14.57,-11.415),(14.74,-11.415),(14.74,-11.585),(14.57,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-11.585),(15.08,-11.415),(15.25,-11.415),(15.25,-11.585),(15.08,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-11.585),(15.59,-11.415),(15.76,-11.415),(15.76,-11.585),(15.59,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-11.585),(16.1,-11.415),(16.27,-11.415),(16.27,-11.585),(16.1,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-11.585),(16.61,-11.415),(16.78,-11.415),(16.78,-11.585),(16.61,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-11.585),(17.12,-11.415),(17.29,-11.415),(17.29,-11.585),(17.12,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-11.585),(17.63,-11.415),(17.8,-11.415),(17.8,-11.585),(17.63,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-11.585),(18.14,-11.415),(18.31,-11.415),(18.31,-11.585),(18.14,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-11.585),(18.65,-11.415),(18.82,-11.415),(18.82,-11.585),(18.65,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-11.585),(19.16,-11.415),(19.33,-11.415),(19.33,-11.585),(19.16,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-11.585),(19.67,-11.415),(19.84,-11.415),(19.84,-11.585),(19.67,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-11.585),(20.18,-11.415),(20.35,-11.415),(20.35,-11.585),(20.18,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-11.585),(20.69,-11.415),(20.86,-11.415),(20.86,-11.585),(20.69,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-11.585),(21.2,-11.415),(21.37,-11.415),(21.37,-11.585),(21.2,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-11.585),(21.71,-11.415),(21.88,-11.415),(21.88,-11.585),(21.71,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-11.585),(22.22,-11.415),(22.39,-11.415),(22.39,-11.585),(22.22,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-11.585),(22.73,-11.415),(22.9,-11.415),(22.9,-11.585),(22.73,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-11.585),(23.24,-11.415),(23.41,-11.415),(23.41,-11.585),(23.24,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-11.585),(23.75,-11.415),(23.92,-11.415),(23.92,-11.585),(23.75,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-11.585),(24.26,-11.415),(24.43,-11.415),(24.43,-11.585),(24.26,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-11.585),(24.77,-11.415),(24.94,-11.415),(24.94,-11.585),(24.77,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-11.585),(25.28,-11.415),(25.45,-11.415),(25.45,-11.585),(25.28,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-11.585),(25.79,-11.415),(25.96,-11.415),(25.96,-11.585),(25.79,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-11.585),(26.3,-11.415),(26.47,-11.415),(26.47,-11.585),(26.3,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-11.585),(26.81,-11.415),(26.98,-11.415),(26.98,-11.585),(26.81,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-11.585),(27.32,-11.415),(27.49,-11.415),(27.49,-11.585),(27.32,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-11.585),(27.83,-11.415),(28.0,-11.415),(28.0,-11.585),(27.83,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-11.585),(28.34,-11.415),(28.51,-11.415),(28.51,-11.585),(28.34,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-11.585),(28.85,-11.415),(29.02,-11.415),(29.02,-11.585),(28.85,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-11.585),(29.36,-11.415),(29.53,-11.415),(29.53,-11.585),(29.36,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-11.585),(29.87,-11.415),(30.04,-11.415),(30.04,-11.585),(29.87,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-11.585),(30.38,-11.415),(30.55,-11.415),(30.55,-11.585),(30.38,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-11.585),(30.89,-11.415),(31.06,-11.415),(31.06,-11.585),(30.89,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-11.585),(31.4,-11.415),(31.57,-11.415),(31.57,-11.585),(31.4,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-11.585),(31.91,-11.415),(32.08,-11.415),(32.08,-11.585),(31.91,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-11.585),(32.42,-11.415),(32.59,-11.415),(32.59,-11.585),(32.42,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-11.585),(32.93,-11.415),(33.1,-11.415),(33.1,-11.585),(32.93,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-11.585),(33.44,-11.415),(33.61,-11.415),(33.61,-11.585),(33.44,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-11.585),(33.95,-11.415),(34.12,-11.415),(34.12,-11.585),(33.95,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-11.585),(34.46,-11.415),(34.63,-11.415),(34.63,-11.585),(34.46,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-11.585),(34.97,-11.415),(35.14,-11.415),(35.14,-11.585),(34.97,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-11.585),(35.48,-11.415),(35.65,-11.415),(35.65,-11.585),(35.48,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-11.585),(35.99,-11.415),(36.16,-11.415),(36.16,-11.585),(35.99,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-11.585),(36.5,-11.415),(36.67,-11.415),(36.67,-11.585),(36.5,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-11.585),(37.01,-11.415),(37.18,-11.415),(37.18,-11.585),(37.01,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-11.585),(37.52,-11.415),(37.69,-11.415),(37.69,-11.585),(37.52,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-11.585),(38.03,-11.415),(38.2,-11.415),(38.2,-11.585),(38.03,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-11.585),(38.54,-11.415),(38.71,-11.415),(38.71,-11.585),(38.54,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-11.585),(39.05,-11.415),(39.22,-11.415),(39.22,-11.585),(39.05,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-11.585),(39.56,-11.415),(39.73,-11.415),(39.73,-11.585),(39.56,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-11.585),(40.07,-11.415),(40.24,-11.415),(40.24,-11.585),(40.07,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-11.585),(40.58,-11.415),(40.75,-11.415),(40.75,-11.585),(40.58,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-11.585),(41.09,-11.415),(41.26,-11.415),(41.26,-11.585),(41.09,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-11.585),(41.6,-11.415),(41.77,-11.415),(41.77,-11.585),(41.6,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-11.585),(42.11,-11.415),(42.28,-11.415),(42.28,-11.585),(42.11,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-11.585),(42.62,-11.415),(42.79,-11.415),(42.79,-11.585),(42.62,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-11.585),(43.13,-11.415),(43.3,-11.415),(43.3,-11.585),(43.13,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-11.585),(43.64,-11.415),(43.81,-11.415),(43.81,-11.585),(43.64,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-11.585),(44.15,-11.415),(44.32,-11.415),(44.32,-11.585),(44.15,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-11.585),(44.66,-11.415),(44.83,-11.415),(44.83,-11.585),(44.66,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-11.585),(45.17,-11.415),(45.34,-11.415),(45.34,-11.585),(45.17,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-11.585),(45.68,-11.415),(45.85,-11.415),(45.85,-11.585),(45.68,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-11.585),(46.19,-11.415),(46.36,-11.415),(46.36,-11.585),(46.19,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-11.585),(46.7,-11.415),(46.87,-11.415),(46.87,-11.585),(46.7,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-11.585),(47.21,-11.415),(47.38,-11.415),(47.38,-11.585),(47.21,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-11.585),(47.72,-11.415),(47.89,-11.415),(47.89,-11.585),(47.72,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-11.585),(48.23,-11.415),(48.4,-11.415),(48.4,-11.585),(48.23,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-11.585),(48.74,-11.415),(48.91,-11.415),(48.91,-11.585),(48.74,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-11.585),(49.25,-11.415),(49.42,-11.415),(49.42,-11.585),(49.25,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-11.585),(49.76,-11.415),(49.93,-11.415),(49.93,-11.585),(49.76,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-11.585),(50.27,-11.415),(50.44,-11.415),(50.44,-11.585),(50.27,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-11.585),(50.78,-11.415),(50.95,-11.415),(50.95,-11.585),(50.78,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-11.585),(51.29,-11.415),(51.46,-11.415),(51.46,-11.585),(51.29,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-11.585),(51.8,-11.415),(51.97,-11.415),(51.97,-11.585),(51.8,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-11.585),(52.31,-11.415),(52.48,-11.415),(52.48,-11.585),(52.31,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-11.585),(52.82,-11.415),(52.99,-11.415),(52.99,-11.585),(52.82,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-11.585),(53.33,-11.415),(53.5,-11.415),(53.5,-11.585),(53.33,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-11.585),(53.84,-11.415),(54.01,-11.415),(54.01,-11.585),(53.84,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-11.585),(54.35,-11.415),(54.52,-11.415),(54.52,-11.585),(54.35,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-11.585),(54.86,-11.415),(55.03,-11.415),(55.03,-11.585),(54.86,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-11.585),(55.37,-11.415),(55.54,-11.415),(55.54,-11.585),(55.37,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-11.585),(55.88,-11.415),(56.05,-11.415),(56.05,-11.585),(55.88,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-11.585),(56.39,-11.415),(56.56,-11.415),(56.56,-11.585),(56.39,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-11.585),(56.9,-11.415),(57.07,-11.415),(57.07,-11.585),(56.9,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-11.585),(57.41,-11.415),(57.58,-11.415),(57.58,-11.585),(57.41,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-11.585),(57.92,-11.415),(58.09,-11.415),(58.09,-11.585),(57.92,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-11.585),(58.43,-11.415),(58.6,-11.415),(58.6,-11.585),(58.43,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-11.585),(58.94,-11.415),(59.11,-11.415),(59.11,-11.585),(58.94,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-11.585),(59.45,-11.415),(59.62,-11.415),(59.62,-11.585),(59.45,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-11.585),(59.96,-11.415),(60.13,-11.415),(60.13,-11.585),(59.96,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-11.585),(60.47,-11.415),(60.64,-11.415),(60.64,-11.585),(60.47,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-11.585),(60.98,-11.415),(61.15,-11.415),(61.15,-11.585),(60.98,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-11.585),(61.49,-11.415),(61.66,-11.415),(61.66,-11.585),(61.49,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-11.585),(62.0,-11.415),(62.17,-11.415),(62.17,-11.585),(62.0,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-11.585),(62.51,-11.415),(62.68,-11.415),(62.68,-11.585),(62.51,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-11.585),(63.02,-11.415),(63.19,-11.415),(63.19,-11.585),(63.02,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-11.585),(63.53,-11.415),(63.7,-11.415),(63.7,-11.585),(63.53,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-11.585),(64.04,-11.415),(64.21,-11.415),(64.21,-11.585),(64.04,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-11.585),(64.55,-11.415),(64.72,-11.415),(64.72,-11.585),(64.55,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-11.585),(65.06,-11.415),(65.23,-11.415),(65.23,-11.585),(65.06,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-11.585),(65.57,-11.415),(65.74,-11.415),(65.74,-11.585),(65.57,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-11.585),(66.08,-11.415),(66.25,-11.415),(66.25,-11.585),(66.08,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-11.585),(66.59,-11.415),(66.76,-11.415),(66.76,-11.585),(66.59,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-11.585),(67.1,-11.415),(67.27,-11.415),(67.27,-11.585),(67.1,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-11.585),(67.61,-11.415),(67.78,-11.415),(67.78,-11.585),(67.61,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-11.585),(68.12,-11.415),(68.29,-11.415),(68.29,-11.585),(68.12,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-11.585),(68.63,-11.415),(68.8,-11.415),(68.8,-11.585),(68.63,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-11.585),(69.14,-11.415),(69.31,-11.415),(69.31,-11.585),(69.14,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-11.585),(69.65,-11.415),(69.82,-11.415),(69.82,-11.585),(69.65,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-11.585),(70.16,-11.415),(70.33,-11.415),(70.33,-11.585),(70.16,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-11.585),(70.67,-11.415),(70.84,-11.415),(70.84,-11.585),(70.67,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-11.585),(71.18,-11.415),(71.35,-11.415),(71.35,-11.585),(71.18,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-11.585),(71.69,-11.415),(71.86,-11.415),(71.86,-11.585),(71.69,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-11.585),(72.2,-11.415),(72.37,-11.415),(72.37,-11.585),(72.2,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-11.585),(72.71,-11.415),(72.88,-11.415),(72.88,-11.585),(72.71,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-11.585),(73.22,-11.415),(73.39,-11.415),(73.39,-11.585),(73.22,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-11.585),(73.73,-11.415),(73.9,-11.415),(73.9,-11.585),(73.73,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-11.585),(74.24,-11.415),(74.41,-11.415),(74.41,-11.585),(74.24,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-11.585),(74.75,-11.415),(74.92,-11.415),(74.92,-11.585),(74.75,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-11.585),(75.26,-11.415),(75.43,-11.415),(75.43,-11.585),(75.26,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-11.585),(75.77,-11.415),(75.94,-11.415),(75.94,-11.585),(75.77,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-11.585),(76.28,-11.415),(76.45,-11.415),(76.45,-11.585),(76.28,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-11.585),(76.79,-11.415),(76.96,-11.415),(76.96,-11.585),(76.79,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-11.585),(77.3,-11.415),(77.47,-11.415),(77.47,-11.585),(77.3,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-11.585),(77.81,-11.415),(77.98,-11.415),(77.98,-11.585),(77.81,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-11.585),(78.32,-11.415),(78.49,-11.415),(78.49,-11.585),(78.32,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-11.585),(78.83,-11.415),(79.0,-11.415),(79.0,-11.585),(78.83,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-11.585),(79.34,-11.415),(79.51,-11.415),(79.51,-11.585),(79.34,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-11.585),(79.85,-11.415),(80.02,-11.415),(80.02,-11.585),(79.85,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-11.585),(80.36,-11.415),(80.53,-11.415),(80.53,-11.585),(80.36,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-11.585),(80.87,-11.415),(81.04,-11.415),(81.04,-11.585),(80.87,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-11.585),(81.38,-11.415),(81.55,-11.415),(81.55,-11.585),(81.38,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-11.585),(81.89,-11.415),(82.06,-11.415),(82.06,-11.585),(81.89,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-11.585),(82.4,-11.415),(82.57,-11.415),(82.57,-11.585),(82.4,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-11.585),(82.91,-11.415),(83.08,-11.415),(83.08,-11.585),(82.91,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-11.585),(83.42,-11.415),(83.59,-11.415),(83.59,-11.585),(83.42,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-11.585),(83.93,-11.415),(84.1,-11.415),(84.1,-11.585),(83.93,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-11.585),(84.44,-11.415),(84.61,-11.415),(84.61,-11.585),(84.44,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-11.585),(84.95,-11.415),(85.12,-11.415),(85.12,-11.585),(84.95,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-11.585),(85.46,-11.415),(85.63,-11.415),(85.63,-11.585),(85.46,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-11.585),(85.97,-11.415),(86.14,-11.415),(86.14,-11.585),(85.97,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-11.585),(86.48,-11.415),(86.65,-11.415),(86.65,-11.585),(86.48,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-11.585),(86.99,-11.415),(87.16,-11.415),(87.16,-11.585),(86.99,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-11.585),(87.5,-11.415),(87.67,-11.415),(87.67,-11.585),(87.5,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-11.585),(88.01,-11.415),(88.18,-11.415),(88.18,-11.585),(88.01,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-11.585),(88.52,-11.415),(88.69,-11.415),(88.69,-11.585),(88.52,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-11.585),(89.03,-11.415),(89.2,-11.415),(89.2,-11.585),(89.03,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-11.585),(89.54,-11.415),(89.71,-11.415),(89.71,-11.585),(89.54,-11.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-11.075),(0.29,-10.905),(0.46,-10.905),(0.46,-11.075),(0.29,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-11.075),(0.8,-10.905),(0.97,-10.905),(0.97,-11.075),(0.8,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-11.075),(1.31,-10.905),(1.48,-10.905),(1.48,-11.075),(1.31,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-11.075),(1.82,-10.905),(1.99,-10.905),(1.99,-11.075),(1.82,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-11.075),(2.33,-10.905),(2.5,-10.905),(2.5,-11.075),(2.33,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-11.075),(2.84,-10.905),(3.01,-10.905),(3.01,-11.075),(2.84,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-11.075),(3.35,-10.905),(3.52,-10.905),(3.52,-11.075),(3.35,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-11.075),(3.86,-10.905),(4.03,-10.905),(4.03,-11.075),(3.86,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-11.075),(4.37,-10.905),(4.54,-10.905),(4.54,-11.075),(4.37,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-11.075),(4.88,-10.905),(5.05,-10.905),(5.05,-11.075),(4.88,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-11.075),(5.39,-10.905),(5.56,-10.905),(5.56,-11.075),(5.39,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-11.075),(5.9,-10.905),(6.07,-10.905),(6.07,-11.075),(5.9,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-11.075),(6.41,-10.905),(6.58,-10.905),(6.58,-11.075),(6.41,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-11.075),(6.92,-10.905),(7.09,-10.905),(7.09,-11.075),(6.92,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-11.075),(7.43,-10.905),(7.6,-10.905),(7.6,-11.075),(7.43,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-11.075),(7.94,-10.905),(8.11,-10.905),(8.11,-11.075),(7.94,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-11.075),(8.45,-10.905),(8.62,-10.905),(8.62,-11.075),(8.45,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-11.075),(8.96,-10.905),(9.13,-10.905),(9.13,-11.075),(8.96,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-11.075),(9.47,-10.905),(9.64,-10.905),(9.64,-11.075),(9.47,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-11.075),(9.98,-10.905),(10.15,-10.905),(10.15,-11.075),(9.98,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-11.075),(10.49,-10.905),(10.66,-10.905),(10.66,-11.075),(10.49,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-11.075),(11.0,-10.905),(11.17,-10.905),(11.17,-11.075),(11.0,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-11.075),(11.51,-10.905),(11.68,-10.905),(11.68,-11.075),(11.51,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-11.075),(12.02,-10.905),(12.19,-10.905),(12.19,-11.075),(12.02,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-11.075),(12.53,-10.905),(12.7,-10.905),(12.7,-11.075),(12.53,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-11.075),(13.04,-10.905),(13.21,-10.905),(13.21,-11.075),(13.04,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-11.075),(13.55,-10.905),(13.72,-10.905),(13.72,-11.075),(13.55,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-11.075),(14.06,-10.905),(14.23,-10.905),(14.23,-11.075),(14.06,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-11.075),(14.57,-10.905),(14.74,-10.905),(14.74,-11.075),(14.57,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-11.075),(15.08,-10.905),(15.25,-10.905),(15.25,-11.075),(15.08,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-11.075),(15.59,-10.905),(15.76,-10.905),(15.76,-11.075),(15.59,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-11.075),(16.1,-10.905),(16.27,-10.905),(16.27,-11.075),(16.1,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-11.075),(16.61,-10.905),(16.78,-10.905),(16.78,-11.075),(16.61,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-11.075),(17.12,-10.905),(17.29,-10.905),(17.29,-11.075),(17.12,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-11.075),(17.63,-10.905),(17.8,-10.905),(17.8,-11.075),(17.63,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-11.075),(18.14,-10.905),(18.31,-10.905),(18.31,-11.075),(18.14,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-11.075),(18.65,-10.905),(18.82,-10.905),(18.82,-11.075),(18.65,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-11.075),(19.16,-10.905),(19.33,-10.905),(19.33,-11.075),(19.16,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-11.075),(19.67,-10.905),(19.84,-10.905),(19.84,-11.075),(19.67,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-11.075),(20.18,-10.905),(20.35,-10.905),(20.35,-11.075),(20.18,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-11.075),(20.69,-10.905),(20.86,-10.905),(20.86,-11.075),(20.69,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-11.075),(21.2,-10.905),(21.37,-10.905),(21.37,-11.075),(21.2,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-11.075),(21.71,-10.905),(21.88,-10.905),(21.88,-11.075),(21.71,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-11.075),(22.22,-10.905),(22.39,-10.905),(22.39,-11.075),(22.22,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-11.075),(22.73,-10.905),(22.9,-10.905),(22.9,-11.075),(22.73,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-11.075),(23.24,-10.905),(23.41,-10.905),(23.41,-11.075),(23.24,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-11.075),(23.75,-10.905),(23.92,-10.905),(23.92,-11.075),(23.75,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-11.075),(24.26,-10.905),(24.43,-10.905),(24.43,-11.075),(24.26,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-11.075),(24.77,-10.905),(24.94,-10.905),(24.94,-11.075),(24.77,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-11.075),(25.28,-10.905),(25.45,-10.905),(25.45,-11.075),(25.28,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-11.075),(25.79,-10.905),(25.96,-10.905),(25.96,-11.075),(25.79,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-11.075),(26.3,-10.905),(26.47,-10.905),(26.47,-11.075),(26.3,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-11.075),(26.81,-10.905),(26.98,-10.905),(26.98,-11.075),(26.81,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-11.075),(27.32,-10.905),(27.49,-10.905),(27.49,-11.075),(27.32,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-11.075),(27.83,-10.905),(28.0,-10.905),(28.0,-11.075),(27.83,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-11.075),(28.34,-10.905),(28.51,-10.905),(28.51,-11.075),(28.34,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-11.075),(28.85,-10.905),(29.02,-10.905),(29.02,-11.075),(28.85,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-11.075),(29.36,-10.905),(29.53,-10.905),(29.53,-11.075),(29.36,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-11.075),(29.87,-10.905),(30.04,-10.905),(30.04,-11.075),(29.87,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-11.075),(30.38,-10.905),(30.55,-10.905),(30.55,-11.075),(30.38,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-11.075),(30.89,-10.905),(31.06,-10.905),(31.06,-11.075),(30.89,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-11.075),(31.4,-10.905),(31.57,-10.905),(31.57,-11.075),(31.4,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-11.075),(31.91,-10.905),(32.08,-10.905),(32.08,-11.075),(31.91,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-11.075),(32.42,-10.905),(32.59,-10.905),(32.59,-11.075),(32.42,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-11.075),(32.93,-10.905),(33.1,-10.905),(33.1,-11.075),(32.93,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-11.075),(33.44,-10.905),(33.61,-10.905),(33.61,-11.075),(33.44,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-11.075),(33.95,-10.905),(34.12,-10.905),(34.12,-11.075),(33.95,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-11.075),(34.46,-10.905),(34.63,-10.905),(34.63,-11.075),(34.46,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-11.075),(34.97,-10.905),(35.14,-10.905),(35.14,-11.075),(34.97,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-11.075),(35.48,-10.905),(35.65,-10.905),(35.65,-11.075),(35.48,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-11.075),(35.99,-10.905),(36.16,-10.905),(36.16,-11.075),(35.99,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-11.075),(36.5,-10.905),(36.67,-10.905),(36.67,-11.075),(36.5,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-11.075),(37.01,-10.905),(37.18,-10.905),(37.18,-11.075),(37.01,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-11.075),(37.52,-10.905),(37.69,-10.905),(37.69,-11.075),(37.52,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-11.075),(38.03,-10.905),(38.2,-10.905),(38.2,-11.075),(38.03,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-11.075),(38.54,-10.905),(38.71,-10.905),(38.71,-11.075),(38.54,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-11.075),(39.05,-10.905),(39.22,-10.905),(39.22,-11.075),(39.05,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-11.075),(39.56,-10.905),(39.73,-10.905),(39.73,-11.075),(39.56,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-11.075),(40.07,-10.905),(40.24,-10.905),(40.24,-11.075),(40.07,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-11.075),(40.58,-10.905),(40.75,-10.905),(40.75,-11.075),(40.58,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-11.075),(41.09,-10.905),(41.26,-10.905),(41.26,-11.075),(41.09,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-11.075),(41.6,-10.905),(41.77,-10.905),(41.77,-11.075),(41.6,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-11.075),(42.11,-10.905),(42.28,-10.905),(42.28,-11.075),(42.11,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-11.075),(42.62,-10.905),(42.79,-10.905),(42.79,-11.075),(42.62,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-11.075),(43.13,-10.905),(43.3,-10.905),(43.3,-11.075),(43.13,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-11.075),(43.64,-10.905),(43.81,-10.905),(43.81,-11.075),(43.64,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-11.075),(44.15,-10.905),(44.32,-10.905),(44.32,-11.075),(44.15,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-11.075),(44.66,-10.905),(44.83,-10.905),(44.83,-11.075),(44.66,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-11.075),(45.17,-10.905),(45.34,-10.905),(45.34,-11.075),(45.17,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-11.075),(45.68,-10.905),(45.85,-10.905),(45.85,-11.075),(45.68,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-11.075),(46.19,-10.905),(46.36,-10.905),(46.36,-11.075),(46.19,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-11.075),(46.7,-10.905),(46.87,-10.905),(46.87,-11.075),(46.7,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-11.075),(47.21,-10.905),(47.38,-10.905),(47.38,-11.075),(47.21,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-11.075),(47.72,-10.905),(47.89,-10.905),(47.89,-11.075),(47.72,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-11.075),(48.23,-10.905),(48.4,-10.905),(48.4,-11.075),(48.23,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-11.075),(48.74,-10.905),(48.91,-10.905),(48.91,-11.075),(48.74,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-11.075),(49.25,-10.905),(49.42,-10.905),(49.42,-11.075),(49.25,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-11.075),(49.76,-10.905),(49.93,-10.905),(49.93,-11.075),(49.76,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-11.075),(50.27,-10.905),(50.44,-10.905),(50.44,-11.075),(50.27,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-11.075),(50.78,-10.905),(50.95,-10.905),(50.95,-11.075),(50.78,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-11.075),(51.29,-10.905),(51.46,-10.905),(51.46,-11.075),(51.29,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-11.075),(51.8,-10.905),(51.97,-10.905),(51.97,-11.075),(51.8,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-11.075),(52.31,-10.905),(52.48,-10.905),(52.48,-11.075),(52.31,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-11.075),(52.82,-10.905),(52.99,-10.905),(52.99,-11.075),(52.82,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-11.075),(53.33,-10.905),(53.5,-10.905),(53.5,-11.075),(53.33,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-11.075),(53.84,-10.905),(54.01,-10.905),(54.01,-11.075),(53.84,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-11.075),(54.35,-10.905),(54.52,-10.905),(54.52,-11.075),(54.35,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-11.075),(54.86,-10.905),(55.03,-10.905),(55.03,-11.075),(54.86,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-11.075),(55.37,-10.905),(55.54,-10.905),(55.54,-11.075),(55.37,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-11.075),(55.88,-10.905),(56.05,-10.905),(56.05,-11.075),(55.88,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-11.075),(56.39,-10.905),(56.56,-10.905),(56.56,-11.075),(56.39,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-11.075),(56.9,-10.905),(57.07,-10.905),(57.07,-11.075),(56.9,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-11.075),(57.41,-10.905),(57.58,-10.905),(57.58,-11.075),(57.41,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-11.075),(57.92,-10.905),(58.09,-10.905),(58.09,-11.075),(57.92,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-11.075),(58.43,-10.905),(58.6,-10.905),(58.6,-11.075),(58.43,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-11.075),(58.94,-10.905),(59.11,-10.905),(59.11,-11.075),(58.94,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-11.075),(59.45,-10.905),(59.62,-10.905),(59.62,-11.075),(59.45,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-11.075),(59.96,-10.905),(60.13,-10.905),(60.13,-11.075),(59.96,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-11.075),(60.47,-10.905),(60.64,-10.905),(60.64,-11.075),(60.47,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-11.075),(60.98,-10.905),(61.15,-10.905),(61.15,-11.075),(60.98,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-11.075),(61.49,-10.905),(61.66,-10.905),(61.66,-11.075),(61.49,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-11.075),(62.0,-10.905),(62.17,-10.905),(62.17,-11.075),(62.0,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-11.075),(62.51,-10.905),(62.68,-10.905),(62.68,-11.075),(62.51,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-11.075),(63.02,-10.905),(63.19,-10.905),(63.19,-11.075),(63.02,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-11.075),(63.53,-10.905),(63.7,-10.905),(63.7,-11.075),(63.53,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-11.075),(64.04,-10.905),(64.21,-10.905),(64.21,-11.075),(64.04,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-11.075),(64.55,-10.905),(64.72,-10.905),(64.72,-11.075),(64.55,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-11.075),(65.06,-10.905),(65.23,-10.905),(65.23,-11.075),(65.06,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-11.075),(65.57,-10.905),(65.74,-10.905),(65.74,-11.075),(65.57,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-11.075),(66.08,-10.905),(66.25,-10.905),(66.25,-11.075),(66.08,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-11.075),(66.59,-10.905),(66.76,-10.905),(66.76,-11.075),(66.59,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-11.075),(67.1,-10.905),(67.27,-10.905),(67.27,-11.075),(67.1,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-11.075),(67.61,-10.905),(67.78,-10.905),(67.78,-11.075),(67.61,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-11.075),(68.12,-10.905),(68.29,-10.905),(68.29,-11.075),(68.12,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-11.075),(68.63,-10.905),(68.8,-10.905),(68.8,-11.075),(68.63,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-11.075),(69.14,-10.905),(69.31,-10.905),(69.31,-11.075),(69.14,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-11.075),(69.65,-10.905),(69.82,-10.905),(69.82,-11.075),(69.65,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-11.075),(70.16,-10.905),(70.33,-10.905),(70.33,-11.075),(70.16,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-11.075),(70.67,-10.905),(70.84,-10.905),(70.84,-11.075),(70.67,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-11.075),(71.18,-10.905),(71.35,-10.905),(71.35,-11.075),(71.18,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-11.075),(71.69,-10.905),(71.86,-10.905),(71.86,-11.075),(71.69,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-11.075),(72.2,-10.905),(72.37,-10.905),(72.37,-11.075),(72.2,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-11.075),(72.71,-10.905),(72.88,-10.905),(72.88,-11.075),(72.71,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-11.075),(73.22,-10.905),(73.39,-10.905),(73.39,-11.075),(73.22,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-11.075),(73.73,-10.905),(73.9,-10.905),(73.9,-11.075),(73.73,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-11.075),(74.24,-10.905),(74.41,-10.905),(74.41,-11.075),(74.24,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-11.075),(74.75,-10.905),(74.92,-10.905),(74.92,-11.075),(74.75,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-11.075),(75.26,-10.905),(75.43,-10.905),(75.43,-11.075),(75.26,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-11.075),(75.77,-10.905),(75.94,-10.905),(75.94,-11.075),(75.77,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-11.075),(76.28,-10.905),(76.45,-10.905),(76.45,-11.075),(76.28,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-11.075),(76.79,-10.905),(76.96,-10.905),(76.96,-11.075),(76.79,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-11.075),(77.3,-10.905),(77.47,-10.905),(77.47,-11.075),(77.3,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-11.075),(77.81,-10.905),(77.98,-10.905),(77.98,-11.075),(77.81,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-11.075),(78.32,-10.905),(78.49,-10.905),(78.49,-11.075),(78.32,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-11.075),(78.83,-10.905),(79.0,-10.905),(79.0,-11.075),(78.83,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-11.075),(79.34,-10.905),(79.51,-10.905),(79.51,-11.075),(79.34,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-11.075),(79.85,-10.905),(80.02,-10.905),(80.02,-11.075),(79.85,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-11.075),(80.36,-10.905),(80.53,-10.905),(80.53,-11.075),(80.36,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-11.075),(80.87,-10.905),(81.04,-10.905),(81.04,-11.075),(80.87,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-11.075),(81.38,-10.905),(81.55,-10.905),(81.55,-11.075),(81.38,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-11.075),(81.89,-10.905),(82.06,-10.905),(82.06,-11.075),(81.89,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-11.075),(82.4,-10.905),(82.57,-10.905),(82.57,-11.075),(82.4,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-11.075),(82.91,-10.905),(83.08,-10.905),(83.08,-11.075),(82.91,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-11.075),(83.42,-10.905),(83.59,-10.905),(83.59,-11.075),(83.42,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-11.075),(83.93,-10.905),(84.1,-10.905),(84.1,-11.075),(83.93,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-11.075),(84.44,-10.905),(84.61,-10.905),(84.61,-11.075),(84.44,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-11.075),(84.95,-10.905),(85.12,-10.905),(85.12,-11.075),(84.95,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-11.075),(85.46,-10.905),(85.63,-10.905),(85.63,-11.075),(85.46,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-11.075),(85.97,-10.905),(86.14,-10.905),(86.14,-11.075),(85.97,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-11.075),(86.48,-10.905),(86.65,-10.905),(86.65,-11.075),(86.48,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-11.075),(86.99,-10.905),(87.16,-10.905),(87.16,-11.075),(86.99,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-11.075),(87.5,-10.905),(87.67,-10.905),(87.67,-11.075),(87.5,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-11.075),(88.01,-10.905),(88.18,-10.905),(88.18,-11.075),(88.01,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-11.075),(88.52,-10.905),(88.69,-10.905),(88.69,-11.075),(88.52,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-11.075),(89.03,-10.905),(89.2,-10.905),(89.2,-11.075),(89.03,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-11.075),(89.54,-10.905),(89.71,-10.905),(89.71,-11.075),(89.54,-11.075)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-10.565),(0.29,-10.395),(0.46,-10.395),(0.46,-10.565),(0.29,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-10.565),(0.8,-10.395),(0.97,-10.395),(0.97,-10.565),(0.8,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-10.565),(1.31,-10.395),(1.48,-10.395),(1.48,-10.565),(1.31,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-10.565),(1.82,-10.395),(1.99,-10.395),(1.99,-10.565),(1.82,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-10.565),(2.33,-10.395),(2.5,-10.395),(2.5,-10.565),(2.33,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-10.565),(2.84,-10.395),(3.01,-10.395),(3.01,-10.565),(2.84,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-10.565),(3.35,-10.395),(3.52,-10.395),(3.52,-10.565),(3.35,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-10.565),(3.86,-10.395),(4.03,-10.395),(4.03,-10.565),(3.86,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-10.565),(4.37,-10.395),(4.54,-10.395),(4.54,-10.565),(4.37,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-10.565),(4.88,-10.395),(5.05,-10.395),(5.05,-10.565),(4.88,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-10.565),(5.39,-10.395),(5.56,-10.395),(5.56,-10.565),(5.39,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-10.565),(5.9,-10.395),(6.07,-10.395),(6.07,-10.565),(5.9,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-10.565),(6.41,-10.395),(6.58,-10.395),(6.58,-10.565),(6.41,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-10.565),(6.92,-10.395),(7.09,-10.395),(7.09,-10.565),(6.92,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-10.565),(7.43,-10.395),(7.6,-10.395),(7.6,-10.565),(7.43,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-10.565),(7.94,-10.395),(8.11,-10.395),(8.11,-10.565),(7.94,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-10.565),(8.45,-10.395),(8.62,-10.395),(8.62,-10.565),(8.45,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-10.565),(8.96,-10.395),(9.13,-10.395),(9.13,-10.565),(8.96,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-10.565),(9.47,-10.395),(9.64,-10.395),(9.64,-10.565),(9.47,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-10.565),(9.98,-10.395),(10.15,-10.395),(10.15,-10.565),(9.98,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-10.565),(10.49,-10.395),(10.66,-10.395),(10.66,-10.565),(10.49,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-10.565),(11.0,-10.395),(11.17,-10.395),(11.17,-10.565),(11.0,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-10.565),(11.51,-10.395),(11.68,-10.395),(11.68,-10.565),(11.51,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-10.565),(12.02,-10.395),(12.19,-10.395),(12.19,-10.565),(12.02,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-10.565),(12.53,-10.395),(12.7,-10.395),(12.7,-10.565),(12.53,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-10.565),(13.04,-10.395),(13.21,-10.395),(13.21,-10.565),(13.04,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-10.565),(13.55,-10.395),(13.72,-10.395),(13.72,-10.565),(13.55,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-10.565),(14.06,-10.395),(14.23,-10.395),(14.23,-10.565),(14.06,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-10.565),(14.57,-10.395),(14.74,-10.395),(14.74,-10.565),(14.57,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-10.565),(15.08,-10.395),(15.25,-10.395),(15.25,-10.565),(15.08,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-10.565),(15.59,-10.395),(15.76,-10.395),(15.76,-10.565),(15.59,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-10.565),(16.1,-10.395),(16.27,-10.395),(16.27,-10.565),(16.1,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-10.565),(16.61,-10.395),(16.78,-10.395),(16.78,-10.565),(16.61,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-10.565),(17.12,-10.395),(17.29,-10.395),(17.29,-10.565),(17.12,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-10.565),(17.63,-10.395),(17.8,-10.395),(17.8,-10.565),(17.63,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-10.565),(18.14,-10.395),(18.31,-10.395),(18.31,-10.565),(18.14,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-10.565),(18.65,-10.395),(18.82,-10.395),(18.82,-10.565),(18.65,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-10.565),(19.16,-10.395),(19.33,-10.395),(19.33,-10.565),(19.16,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-10.565),(19.67,-10.395),(19.84,-10.395),(19.84,-10.565),(19.67,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-10.565),(20.18,-10.395),(20.35,-10.395),(20.35,-10.565),(20.18,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-10.565),(20.69,-10.395),(20.86,-10.395),(20.86,-10.565),(20.69,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-10.565),(21.2,-10.395),(21.37,-10.395),(21.37,-10.565),(21.2,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-10.565),(21.71,-10.395),(21.88,-10.395),(21.88,-10.565),(21.71,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-10.565),(22.22,-10.395),(22.39,-10.395),(22.39,-10.565),(22.22,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-10.565),(22.73,-10.395),(22.9,-10.395),(22.9,-10.565),(22.73,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-10.565),(23.24,-10.395),(23.41,-10.395),(23.41,-10.565),(23.24,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-10.565),(23.75,-10.395),(23.92,-10.395),(23.92,-10.565),(23.75,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-10.565),(24.26,-10.395),(24.43,-10.395),(24.43,-10.565),(24.26,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-10.565),(24.77,-10.395),(24.94,-10.395),(24.94,-10.565),(24.77,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-10.565),(25.28,-10.395),(25.45,-10.395),(25.45,-10.565),(25.28,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-10.565),(25.79,-10.395),(25.96,-10.395),(25.96,-10.565),(25.79,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-10.565),(26.3,-10.395),(26.47,-10.395),(26.47,-10.565),(26.3,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-10.565),(26.81,-10.395),(26.98,-10.395),(26.98,-10.565),(26.81,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-10.565),(27.32,-10.395),(27.49,-10.395),(27.49,-10.565),(27.32,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-10.565),(27.83,-10.395),(28.0,-10.395),(28.0,-10.565),(27.83,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-10.565),(28.34,-10.395),(28.51,-10.395),(28.51,-10.565),(28.34,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-10.565),(28.85,-10.395),(29.02,-10.395),(29.02,-10.565),(28.85,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-10.565),(29.36,-10.395),(29.53,-10.395),(29.53,-10.565),(29.36,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-10.565),(29.87,-10.395),(30.04,-10.395),(30.04,-10.565),(29.87,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-10.565),(30.38,-10.395),(30.55,-10.395),(30.55,-10.565),(30.38,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-10.565),(30.89,-10.395),(31.06,-10.395),(31.06,-10.565),(30.89,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-10.565),(31.4,-10.395),(31.57,-10.395),(31.57,-10.565),(31.4,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-10.565),(31.91,-10.395),(32.08,-10.395),(32.08,-10.565),(31.91,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-10.565),(32.42,-10.395),(32.59,-10.395),(32.59,-10.565),(32.42,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-10.565),(32.93,-10.395),(33.1,-10.395),(33.1,-10.565),(32.93,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-10.565),(33.44,-10.395),(33.61,-10.395),(33.61,-10.565),(33.44,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-10.565),(33.95,-10.395),(34.12,-10.395),(34.12,-10.565),(33.95,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-10.565),(34.46,-10.395),(34.63,-10.395),(34.63,-10.565),(34.46,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-10.565),(34.97,-10.395),(35.14,-10.395),(35.14,-10.565),(34.97,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-10.565),(35.48,-10.395),(35.65,-10.395),(35.65,-10.565),(35.48,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-10.565),(35.99,-10.395),(36.16,-10.395),(36.16,-10.565),(35.99,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-10.565),(36.5,-10.395),(36.67,-10.395),(36.67,-10.565),(36.5,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-10.565),(37.01,-10.395),(37.18,-10.395),(37.18,-10.565),(37.01,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-10.565),(37.52,-10.395),(37.69,-10.395),(37.69,-10.565),(37.52,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-10.565),(38.03,-10.395),(38.2,-10.395),(38.2,-10.565),(38.03,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-10.565),(38.54,-10.395),(38.71,-10.395),(38.71,-10.565),(38.54,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-10.565),(39.05,-10.395),(39.22,-10.395),(39.22,-10.565),(39.05,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-10.565),(39.56,-10.395),(39.73,-10.395),(39.73,-10.565),(39.56,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-10.565),(40.07,-10.395),(40.24,-10.395),(40.24,-10.565),(40.07,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-10.565),(40.58,-10.395),(40.75,-10.395),(40.75,-10.565),(40.58,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-10.565),(41.09,-10.395),(41.26,-10.395),(41.26,-10.565),(41.09,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-10.565),(41.6,-10.395),(41.77,-10.395),(41.77,-10.565),(41.6,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-10.565),(42.11,-10.395),(42.28,-10.395),(42.28,-10.565),(42.11,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-10.565),(42.62,-10.395),(42.79,-10.395),(42.79,-10.565),(42.62,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-10.565),(43.13,-10.395),(43.3,-10.395),(43.3,-10.565),(43.13,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-10.565),(43.64,-10.395),(43.81,-10.395),(43.81,-10.565),(43.64,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-10.565),(44.15,-10.395),(44.32,-10.395),(44.32,-10.565),(44.15,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-10.565),(44.66,-10.395),(44.83,-10.395),(44.83,-10.565),(44.66,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-10.565),(45.17,-10.395),(45.34,-10.395),(45.34,-10.565),(45.17,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-10.565),(45.68,-10.395),(45.85,-10.395),(45.85,-10.565),(45.68,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-10.565),(46.19,-10.395),(46.36,-10.395),(46.36,-10.565),(46.19,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-10.565),(46.7,-10.395),(46.87,-10.395),(46.87,-10.565),(46.7,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-10.565),(47.21,-10.395),(47.38,-10.395),(47.38,-10.565),(47.21,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-10.565),(47.72,-10.395),(47.89,-10.395),(47.89,-10.565),(47.72,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-10.565),(48.23,-10.395),(48.4,-10.395),(48.4,-10.565),(48.23,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-10.565),(48.74,-10.395),(48.91,-10.395),(48.91,-10.565),(48.74,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-10.565),(49.25,-10.395),(49.42,-10.395),(49.42,-10.565),(49.25,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-10.565),(49.76,-10.395),(49.93,-10.395),(49.93,-10.565),(49.76,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-10.565),(50.27,-10.395),(50.44,-10.395),(50.44,-10.565),(50.27,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-10.565),(50.78,-10.395),(50.95,-10.395),(50.95,-10.565),(50.78,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-10.565),(51.29,-10.395),(51.46,-10.395),(51.46,-10.565),(51.29,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-10.565),(51.8,-10.395),(51.97,-10.395),(51.97,-10.565),(51.8,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-10.565),(52.31,-10.395),(52.48,-10.395),(52.48,-10.565),(52.31,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-10.565),(52.82,-10.395),(52.99,-10.395),(52.99,-10.565),(52.82,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-10.565),(53.33,-10.395),(53.5,-10.395),(53.5,-10.565),(53.33,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-10.565),(53.84,-10.395),(54.01,-10.395),(54.01,-10.565),(53.84,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-10.565),(54.35,-10.395),(54.52,-10.395),(54.52,-10.565),(54.35,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-10.565),(54.86,-10.395),(55.03,-10.395),(55.03,-10.565),(54.86,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-10.565),(55.37,-10.395),(55.54,-10.395),(55.54,-10.565),(55.37,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-10.565),(55.88,-10.395),(56.05,-10.395),(56.05,-10.565),(55.88,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-10.565),(56.39,-10.395),(56.56,-10.395),(56.56,-10.565),(56.39,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-10.565),(56.9,-10.395),(57.07,-10.395),(57.07,-10.565),(56.9,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-10.565),(57.41,-10.395),(57.58,-10.395),(57.58,-10.565),(57.41,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-10.565),(57.92,-10.395),(58.09,-10.395),(58.09,-10.565),(57.92,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-10.565),(58.43,-10.395),(58.6,-10.395),(58.6,-10.565),(58.43,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-10.565),(58.94,-10.395),(59.11,-10.395),(59.11,-10.565),(58.94,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-10.565),(59.45,-10.395),(59.62,-10.395),(59.62,-10.565),(59.45,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-10.565),(59.96,-10.395),(60.13,-10.395),(60.13,-10.565),(59.96,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-10.565),(60.47,-10.395),(60.64,-10.395),(60.64,-10.565),(60.47,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-10.565),(60.98,-10.395),(61.15,-10.395),(61.15,-10.565),(60.98,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-10.565),(61.49,-10.395),(61.66,-10.395),(61.66,-10.565),(61.49,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-10.565),(62.0,-10.395),(62.17,-10.395),(62.17,-10.565),(62.0,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-10.565),(62.51,-10.395),(62.68,-10.395),(62.68,-10.565),(62.51,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-10.565),(63.02,-10.395),(63.19,-10.395),(63.19,-10.565),(63.02,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-10.565),(63.53,-10.395),(63.7,-10.395),(63.7,-10.565),(63.53,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-10.565),(64.04,-10.395),(64.21,-10.395),(64.21,-10.565),(64.04,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-10.565),(64.55,-10.395),(64.72,-10.395),(64.72,-10.565),(64.55,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-10.565),(65.06,-10.395),(65.23,-10.395),(65.23,-10.565),(65.06,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-10.565),(65.57,-10.395),(65.74,-10.395),(65.74,-10.565),(65.57,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-10.565),(66.08,-10.395),(66.25,-10.395),(66.25,-10.565),(66.08,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-10.565),(66.59,-10.395),(66.76,-10.395),(66.76,-10.565),(66.59,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-10.565),(67.1,-10.395),(67.27,-10.395),(67.27,-10.565),(67.1,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-10.565),(67.61,-10.395),(67.78,-10.395),(67.78,-10.565),(67.61,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-10.565),(68.12,-10.395),(68.29,-10.395),(68.29,-10.565),(68.12,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-10.565),(68.63,-10.395),(68.8,-10.395),(68.8,-10.565),(68.63,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-10.565),(69.14,-10.395),(69.31,-10.395),(69.31,-10.565),(69.14,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-10.565),(69.65,-10.395),(69.82,-10.395),(69.82,-10.565),(69.65,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-10.565),(70.16,-10.395),(70.33,-10.395),(70.33,-10.565),(70.16,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-10.565),(70.67,-10.395),(70.84,-10.395),(70.84,-10.565),(70.67,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-10.565),(71.18,-10.395),(71.35,-10.395),(71.35,-10.565),(71.18,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-10.565),(71.69,-10.395),(71.86,-10.395),(71.86,-10.565),(71.69,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-10.565),(72.2,-10.395),(72.37,-10.395),(72.37,-10.565),(72.2,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-10.565),(72.71,-10.395),(72.88,-10.395),(72.88,-10.565),(72.71,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-10.565),(73.22,-10.395),(73.39,-10.395),(73.39,-10.565),(73.22,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-10.565),(73.73,-10.395),(73.9,-10.395),(73.9,-10.565),(73.73,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-10.565),(74.24,-10.395),(74.41,-10.395),(74.41,-10.565),(74.24,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-10.565),(74.75,-10.395),(74.92,-10.395),(74.92,-10.565),(74.75,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-10.565),(75.26,-10.395),(75.43,-10.395),(75.43,-10.565),(75.26,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-10.565),(75.77,-10.395),(75.94,-10.395),(75.94,-10.565),(75.77,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-10.565),(76.28,-10.395),(76.45,-10.395),(76.45,-10.565),(76.28,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-10.565),(76.79,-10.395),(76.96,-10.395),(76.96,-10.565),(76.79,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-10.565),(77.3,-10.395),(77.47,-10.395),(77.47,-10.565),(77.3,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-10.565),(77.81,-10.395),(77.98,-10.395),(77.98,-10.565),(77.81,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-10.565),(78.32,-10.395),(78.49,-10.395),(78.49,-10.565),(78.32,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-10.565),(78.83,-10.395),(79.0,-10.395),(79.0,-10.565),(78.83,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-10.565),(79.34,-10.395),(79.51,-10.395),(79.51,-10.565),(79.34,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-10.565),(79.85,-10.395),(80.02,-10.395),(80.02,-10.565),(79.85,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-10.565),(80.36,-10.395),(80.53,-10.395),(80.53,-10.565),(80.36,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-10.565),(80.87,-10.395),(81.04,-10.395),(81.04,-10.565),(80.87,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-10.565),(81.38,-10.395),(81.55,-10.395),(81.55,-10.565),(81.38,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-10.565),(81.89,-10.395),(82.06,-10.395),(82.06,-10.565),(81.89,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-10.565),(82.4,-10.395),(82.57,-10.395),(82.57,-10.565),(82.4,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-10.565),(82.91,-10.395),(83.08,-10.395),(83.08,-10.565),(82.91,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-10.565),(83.42,-10.395),(83.59,-10.395),(83.59,-10.565),(83.42,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-10.565),(83.93,-10.395),(84.1,-10.395),(84.1,-10.565),(83.93,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-10.565),(84.44,-10.395),(84.61,-10.395),(84.61,-10.565),(84.44,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-10.565),(84.95,-10.395),(85.12,-10.395),(85.12,-10.565),(84.95,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-10.565),(85.46,-10.395),(85.63,-10.395),(85.63,-10.565),(85.46,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-10.565),(85.97,-10.395),(86.14,-10.395),(86.14,-10.565),(85.97,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-10.565),(86.48,-10.395),(86.65,-10.395),(86.65,-10.565),(86.48,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-10.565),(86.99,-10.395),(87.16,-10.395),(87.16,-10.565),(86.99,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-10.565),(87.5,-10.395),(87.67,-10.395),(87.67,-10.565),(87.5,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-10.565),(88.01,-10.395),(88.18,-10.395),(88.18,-10.565),(88.01,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-10.565),(88.52,-10.395),(88.69,-10.395),(88.69,-10.565),(88.52,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-10.565),(89.03,-10.395),(89.2,-10.395),(89.2,-10.565),(89.03,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-10.565),(89.54,-10.395),(89.71,-10.395),(89.71,-10.565),(89.54,-10.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-10.055),(0.29,-9.885),(0.46,-9.885),(0.46,-10.055),(0.29,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-10.055),(0.8,-9.885),(0.97,-9.885),(0.97,-10.055),(0.8,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-10.055),(1.31,-9.885),(1.48,-9.885),(1.48,-10.055),(1.31,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-10.055),(1.82,-9.885),(1.99,-9.885),(1.99,-10.055),(1.82,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-10.055),(2.33,-9.885),(2.5,-9.885),(2.5,-10.055),(2.33,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-10.055),(2.84,-9.885),(3.01,-9.885),(3.01,-10.055),(2.84,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-10.055),(3.35,-9.885),(3.52,-9.885),(3.52,-10.055),(3.35,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-10.055),(3.86,-9.885),(4.03,-9.885),(4.03,-10.055),(3.86,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-10.055),(4.37,-9.885),(4.54,-9.885),(4.54,-10.055),(4.37,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-10.055),(4.88,-9.885),(5.05,-9.885),(5.05,-10.055),(4.88,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-10.055),(5.39,-9.885),(5.56,-9.885),(5.56,-10.055),(5.39,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-10.055),(5.9,-9.885),(6.07,-9.885),(6.07,-10.055),(5.9,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-10.055),(6.41,-9.885),(6.58,-9.885),(6.58,-10.055),(6.41,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-10.055),(6.92,-9.885),(7.09,-9.885),(7.09,-10.055),(6.92,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-10.055),(7.43,-9.885),(7.6,-9.885),(7.6,-10.055),(7.43,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-10.055),(7.94,-9.885),(8.11,-9.885),(8.11,-10.055),(7.94,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-10.055),(8.45,-9.885),(8.62,-9.885),(8.62,-10.055),(8.45,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-10.055),(8.96,-9.885),(9.13,-9.885),(9.13,-10.055),(8.96,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-10.055),(9.47,-9.885),(9.64,-9.885),(9.64,-10.055),(9.47,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-10.055),(9.98,-9.885),(10.15,-9.885),(10.15,-10.055),(9.98,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-10.055),(10.49,-9.885),(10.66,-9.885),(10.66,-10.055),(10.49,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-10.055),(11.0,-9.885),(11.17,-9.885),(11.17,-10.055),(11.0,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-10.055),(11.51,-9.885),(11.68,-9.885),(11.68,-10.055),(11.51,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-10.055),(12.02,-9.885),(12.19,-9.885),(12.19,-10.055),(12.02,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-10.055),(12.53,-9.885),(12.7,-9.885),(12.7,-10.055),(12.53,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-10.055),(13.04,-9.885),(13.21,-9.885),(13.21,-10.055),(13.04,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-10.055),(13.55,-9.885),(13.72,-9.885),(13.72,-10.055),(13.55,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-10.055),(14.06,-9.885),(14.23,-9.885),(14.23,-10.055),(14.06,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-10.055),(14.57,-9.885),(14.74,-9.885),(14.74,-10.055),(14.57,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-10.055),(15.08,-9.885),(15.25,-9.885),(15.25,-10.055),(15.08,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-10.055),(15.59,-9.885),(15.76,-9.885),(15.76,-10.055),(15.59,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-10.055),(16.1,-9.885),(16.27,-9.885),(16.27,-10.055),(16.1,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-10.055),(16.61,-9.885),(16.78,-9.885),(16.78,-10.055),(16.61,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-10.055),(17.12,-9.885),(17.29,-9.885),(17.29,-10.055),(17.12,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-10.055),(17.63,-9.885),(17.8,-9.885),(17.8,-10.055),(17.63,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-10.055),(18.14,-9.885),(18.31,-9.885),(18.31,-10.055),(18.14,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-10.055),(18.65,-9.885),(18.82,-9.885),(18.82,-10.055),(18.65,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-10.055),(19.16,-9.885),(19.33,-9.885),(19.33,-10.055),(19.16,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-10.055),(19.67,-9.885),(19.84,-9.885),(19.84,-10.055),(19.67,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-10.055),(20.18,-9.885),(20.35,-9.885),(20.35,-10.055),(20.18,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-10.055),(20.69,-9.885),(20.86,-9.885),(20.86,-10.055),(20.69,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-10.055),(21.2,-9.885),(21.37,-9.885),(21.37,-10.055),(21.2,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-10.055),(21.71,-9.885),(21.88,-9.885),(21.88,-10.055),(21.71,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-10.055),(22.22,-9.885),(22.39,-9.885),(22.39,-10.055),(22.22,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-10.055),(22.73,-9.885),(22.9,-9.885),(22.9,-10.055),(22.73,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-10.055),(23.24,-9.885),(23.41,-9.885),(23.41,-10.055),(23.24,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-10.055),(23.75,-9.885),(23.92,-9.885),(23.92,-10.055),(23.75,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-10.055),(24.26,-9.885),(24.43,-9.885),(24.43,-10.055),(24.26,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-10.055),(24.77,-9.885),(24.94,-9.885),(24.94,-10.055),(24.77,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-10.055),(25.28,-9.885),(25.45,-9.885),(25.45,-10.055),(25.28,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-10.055),(25.79,-9.885),(25.96,-9.885),(25.96,-10.055),(25.79,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-10.055),(26.3,-9.885),(26.47,-9.885),(26.47,-10.055),(26.3,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-10.055),(26.81,-9.885),(26.98,-9.885),(26.98,-10.055),(26.81,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-10.055),(27.32,-9.885),(27.49,-9.885),(27.49,-10.055),(27.32,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-10.055),(27.83,-9.885),(28.0,-9.885),(28.0,-10.055),(27.83,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-10.055),(28.34,-9.885),(28.51,-9.885),(28.51,-10.055),(28.34,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-10.055),(28.85,-9.885),(29.02,-9.885),(29.02,-10.055),(28.85,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-10.055),(29.36,-9.885),(29.53,-9.885),(29.53,-10.055),(29.36,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-10.055),(29.87,-9.885),(30.04,-9.885),(30.04,-10.055),(29.87,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-10.055),(30.38,-9.885),(30.55,-9.885),(30.55,-10.055),(30.38,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-10.055),(30.89,-9.885),(31.06,-9.885),(31.06,-10.055),(30.89,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-10.055),(31.4,-9.885),(31.57,-9.885),(31.57,-10.055),(31.4,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-10.055),(31.91,-9.885),(32.08,-9.885),(32.08,-10.055),(31.91,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-10.055),(32.42,-9.885),(32.59,-9.885),(32.59,-10.055),(32.42,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-10.055),(32.93,-9.885),(33.1,-9.885),(33.1,-10.055),(32.93,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-10.055),(33.44,-9.885),(33.61,-9.885),(33.61,-10.055),(33.44,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-10.055),(33.95,-9.885),(34.12,-9.885),(34.12,-10.055),(33.95,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-10.055),(34.46,-9.885),(34.63,-9.885),(34.63,-10.055),(34.46,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-10.055),(34.97,-9.885),(35.14,-9.885),(35.14,-10.055),(34.97,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-10.055),(35.48,-9.885),(35.65,-9.885),(35.65,-10.055),(35.48,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-10.055),(35.99,-9.885),(36.16,-9.885),(36.16,-10.055),(35.99,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-10.055),(36.5,-9.885),(36.67,-9.885),(36.67,-10.055),(36.5,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-10.055),(37.01,-9.885),(37.18,-9.885),(37.18,-10.055),(37.01,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-10.055),(37.52,-9.885),(37.69,-9.885),(37.69,-10.055),(37.52,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-10.055),(38.03,-9.885),(38.2,-9.885),(38.2,-10.055),(38.03,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-10.055),(38.54,-9.885),(38.71,-9.885),(38.71,-10.055),(38.54,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-10.055),(39.05,-9.885),(39.22,-9.885),(39.22,-10.055),(39.05,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-10.055),(39.56,-9.885),(39.73,-9.885),(39.73,-10.055),(39.56,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-10.055),(40.07,-9.885),(40.24,-9.885),(40.24,-10.055),(40.07,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-10.055),(40.58,-9.885),(40.75,-9.885),(40.75,-10.055),(40.58,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-10.055),(41.09,-9.885),(41.26,-9.885),(41.26,-10.055),(41.09,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-10.055),(41.6,-9.885),(41.77,-9.885),(41.77,-10.055),(41.6,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-10.055),(42.11,-9.885),(42.28,-9.885),(42.28,-10.055),(42.11,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-10.055),(42.62,-9.885),(42.79,-9.885),(42.79,-10.055),(42.62,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-10.055),(43.13,-9.885),(43.3,-9.885),(43.3,-10.055),(43.13,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-10.055),(43.64,-9.885),(43.81,-9.885),(43.81,-10.055),(43.64,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-10.055),(44.15,-9.885),(44.32,-9.885),(44.32,-10.055),(44.15,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-10.055),(44.66,-9.885),(44.83,-9.885),(44.83,-10.055),(44.66,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-10.055),(45.17,-9.885),(45.34,-9.885),(45.34,-10.055),(45.17,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-10.055),(45.68,-9.885),(45.85,-9.885),(45.85,-10.055),(45.68,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-10.055),(46.19,-9.885),(46.36,-9.885),(46.36,-10.055),(46.19,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-10.055),(46.7,-9.885),(46.87,-9.885),(46.87,-10.055),(46.7,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-10.055),(47.21,-9.885),(47.38,-9.885),(47.38,-10.055),(47.21,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-10.055),(47.72,-9.885),(47.89,-9.885),(47.89,-10.055),(47.72,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-10.055),(48.23,-9.885),(48.4,-9.885),(48.4,-10.055),(48.23,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-10.055),(48.74,-9.885),(48.91,-9.885),(48.91,-10.055),(48.74,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-10.055),(49.25,-9.885),(49.42,-9.885),(49.42,-10.055),(49.25,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-10.055),(49.76,-9.885),(49.93,-9.885),(49.93,-10.055),(49.76,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-10.055),(50.27,-9.885),(50.44,-9.885),(50.44,-10.055),(50.27,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-10.055),(50.78,-9.885),(50.95,-9.885),(50.95,-10.055),(50.78,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-10.055),(51.29,-9.885),(51.46,-9.885),(51.46,-10.055),(51.29,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-10.055),(51.8,-9.885),(51.97,-9.885),(51.97,-10.055),(51.8,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-10.055),(52.31,-9.885),(52.48,-9.885),(52.48,-10.055),(52.31,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-10.055),(52.82,-9.885),(52.99,-9.885),(52.99,-10.055),(52.82,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-10.055),(53.33,-9.885),(53.5,-9.885),(53.5,-10.055),(53.33,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-10.055),(53.84,-9.885),(54.01,-9.885),(54.01,-10.055),(53.84,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-10.055),(54.35,-9.885),(54.52,-9.885),(54.52,-10.055),(54.35,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-10.055),(54.86,-9.885),(55.03,-9.885),(55.03,-10.055),(54.86,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-10.055),(55.37,-9.885),(55.54,-9.885),(55.54,-10.055),(55.37,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-10.055),(55.88,-9.885),(56.05,-9.885),(56.05,-10.055),(55.88,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-10.055),(56.39,-9.885),(56.56,-9.885),(56.56,-10.055),(56.39,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-10.055),(56.9,-9.885),(57.07,-9.885),(57.07,-10.055),(56.9,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-10.055),(57.41,-9.885),(57.58,-9.885),(57.58,-10.055),(57.41,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-10.055),(57.92,-9.885),(58.09,-9.885),(58.09,-10.055),(57.92,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-10.055),(58.43,-9.885),(58.6,-9.885),(58.6,-10.055),(58.43,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-10.055),(58.94,-9.885),(59.11,-9.885),(59.11,-10.055),(58.94,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-10.055),(59.45,-9.885),(59.62,-9.885),(59.62,-10.055),(59.45,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-10.055),(59.96,-9.885),(60.13,-9.885),(60.13,-10.055),(59.96,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-10.055),(60.47,-9.885),(60.64,-9.885),(60.64,-10.055),(60.47,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-10.055),(60.98,-9.885),(61.15,-9.885),(61.15,-10.055),(60.98,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-10.055),(61.49,-9.885),(61.66,-9.885),(61.66,-10.055),(61.49,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-10.055),(62.0,-9.885),(62.17,-9.885),(62.17,-10.055),(62.0,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-10.055),(62.51,-9.885),(62.68,-9.885),(62.68,-10.055),(62.51,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-10.055),(63.02,-9.885),(63.19,-9.885),(63.19,-10.055),(63.02,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-10.055),(63.53,-9.885),(63.7,-9.885),(63.7,-10.055),(63.53,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-10.055),(64.04,-9.885),(64.21,-9.885),(64.21,-10.055),(64.04,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-10.055),(64.55,-9.885),(64.72,-9.885),(64.72,-10.055),(64.55,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-10.055),(65.06,-9.885),(65.23,-9.885),(65.23,-10.055),(65.06,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-10.055),(65.57,-9.885),(65.74,-9.885),(65.74,-10.055),(65.57,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-10.055),(66.08,-9.885),(66.25,-9.885),(66.25,-10.055),(66.08,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-10.055),(66.59,-9.885),(66.76,-9.885),(66.76,-10.055),(66.59,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-10.055),(67.1,-9.885),(67.27,-9.885),(67.27,-10.055),(67.1,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-10.055),(67.61,-9.885),(67.78,-9.885),(67.78,-10.055),(67.61,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-10.055),(68.12,-9.885),(68.29,-9.885),(68.29,-10.055),(68.12,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-10.055),(68.63,-9.885),(68.8,-9.885),(68.8,-10.055),(68.63,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-10.055),(69.14,-9.885),(69.31,-9.885),(69.31,-10.055),(69.14,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-10.055),(69.65,-9.885),(69.82,-9.885),(69.82,-10.055),(69.65,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-10.055),(70.16,-9.885),(70.33,-9.885),(70.33,-10.055),(70.16,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-10.055),(70.67,-9.885),(70.84,-9.885),(70.84,-10.055),(70.67,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-10.055),(71.18,-9.885),(71.35,-9.885),(71.35,-10.055),(71.18,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-10.055),(71.69,-9.885),(71.86,-9.885),(71.86,-10.055),(71.69,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-10.055),(72.2,-9.885),(72.37,-9.885),(72.37,-10.055),(72.2,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-10.055),(72.71,-9.885),(72.88,-9.885),(72.88,-10.055),(72.71,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-10.055),(73.22,-9.885),(73.39,-9.885),(73.39,-10.055),(73.22,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-10.055),(73.73,-9.885),(73.9,-9.885),(73.9,-10.055),(73.73,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-10.055),(74.24,-9.885),(74.41,-9.885),(74.41,-10.055),(74.24,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-10.055),(74.75,-9.885),(74.92,-9.885),(74.92,-10.055),(74.75,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-10.055),(75.26,-9.885),(75.43,-9.885),(75.43,-10.055),(75.26,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-10.055),(75.77,-9.885),(75.94,-9.885),(75.94,-10.055),(75.77,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-10.055),(76.28,-9.885),(76.45,-9.885),(76.45,-10.055),(76.28,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-10.055),(76.79,-9.885),(76.96,-9.885),(76.96,-10.055),(76.79,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-10.055),(77.3,-9.885),(77.47,-9.885),(77.47,-10.055),(77.3,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-10.055),(77.81,-9.885),(77.98,-9.885),(77.98,-10.055),(77.81,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-10.055),(78.32,-9.885),(78.49,-9.885),(78.49,-10.055),(78.32,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-10.055),(78.83,-9.885),(79.0,-9.885),(79.0,-10.055),(78.83,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-10.055),(79.34,-9.885),(79.51,-9.885),(79.51,-10.055),(79.34,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-10.055),(79.85,-9.885),(80.02,-9.885),(80.02,-10.055),(79.85,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-10.055),(80.36,-9.885),(80.53,-9.885),(80.53,-10.055),(80.36,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-10.055),(80.87,-9.885),(81.04,-9.885),(81.04,-10.055),(80.87,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-10.055),(81.38,-9.885),(81.55,-9.885),(81.55,-10.055),(81.38,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-10.055),(81.89,-9.885),(82.06,-9.885),(82.06,-10.055),(81.89,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-10.055),(82.4,-9.885),(82.57,-9.885),(82.57,-10.055),(82.4,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-10.055),(82.91,-9.885),(83.08,-9.885),(83.08,-10.055),(82.91,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-10.055),(83.42,-9.885),(83.59,-9.885),(83.59,-10.055),(83.42,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-10.055),(83.93,-9.885),(84.1,-9.885),(84.1,-10.055),(83.93,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-10.055),(84.44,-9.885),(84.61,-9.885),(84.61,-10.055),(84.44,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-10.055),(84.95,-9.885),(85.12,-9.885),(85.12,-10.055),(84.95,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-10.055),(85.46,-9.885),(85.63,-9.885),(85.63,-10.055),(85.46,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-10.055),(85.97,-9.885),(86.14,-9.885),(86.14,-10.055),(85.97,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-10.055),(86.48,-9.885),(86.65,-9.885),(86.65,-10.055),(86.48,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-10.055),(86.99,-9.885),(87.16,-9.885),(87.16,-10.055),(86.99,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-10.055),(87.5,-9.885),(87.67,-9.885),(87.67,-10.055),(87.5,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-10.055),(88.01,-9.885),(88.18,-9.885),(88.18,-10.055),(88.01,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-10.055),(88.52,-9.885),(88.69,-9.885),(88.69,-10.055),(88.52,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-10.055),(89.03,-9.885),(89.2,-9.885),(89.2,-10.055),(89.03,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-10.055),(89.54,-9.885),(89.71,-9.885),(89.71,-10.055),(89.54,-10.055)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-9.545),(0.29,-9.375),(0.46,-9.375),(0.46,-9.545),(0.29,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-9.545),(0.8,-9.375),(0.97,-9.375),(0.97,-9.545),(0.8,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-9.545),(1.31,-9.375),(1.48,-9.375),(1.48,-9.545),(1.31,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-9.545),(1.82,-9.375),(1.99,-9.375),(1.99,-9.545),(1.82,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-9.545),(2.33,-9.375),(2.5,-9.375),(2.5,-9.545),(2.33,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-9.545),(2.84,-9.375),(3.01,-9.375),(3.01,-9.545),(2.84,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-9.545),(3.35,-9.375),(3.52,-9.375),(3.52,-9.545),(3.35,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-9.545),(3.86,-9.375),(4.03,-9.375),(4.03,-9.545),(3.86,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-9.545),(4.37,-9.375),(4.54,-9.375),(4.54,-9.545),(4.37,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-9.545),(4.88,-9.375),(5.05,-9.375),(5.05,-9.545),(4.88,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-9.545),(5.39,-9.375),(5.56,-9.375),(5.56,-9.545),(5.39,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-9.545),(5.9,-9.375),(6.07,-9.375),(6.07,-9.545),(5.9,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-9.545),(6.41,-9.375),(6.58,-9.375),(6.58,-9.545),(6.41,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-9.545),(6.92,-9.375),(7.09,-9.375),(7.09,-9.545),(6.92,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-9.545),(7.43,-9.375),(7.6,-9.375),(7.6,-9.545),(7.43,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-9.545),(7.94,-9.375),(8.11,-9.375),(8.11,-9.545),(7.94,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-9.545),(8.45,-9.375),(8.62,-9.375),(8.62,-9.545),(8.45,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-9.545),(8.96,-9.375),(9.13,-9.375),(9.13,-9.545),(8.96,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-9.545),(9.47,-9.375),(9.64,-9.375),(9.64,-9.545),(9.47,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-9.545),(9.98,-9.375),(10.15,-9.375),(10.15,-9.545),(9.98,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-9.545),(10.49,-9.375),(10.66,-9.375),(10.66,-9.545),(10.49,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-9.545),(11.0,-9.375),(11.17,-9.375),(11.17,-9.545),(11.0,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-9.545),(11.51,-9.375),(11.68,-9.375),(11.68,-9.545),(11.51,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-9.545),(12.02,-9.375),(12.19,-9.375),(12.19,-9.545),(12.02,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-9.545),(12.53,-9.375),(12.7,-9.375),(12.7,-9.545),(12.53,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-9.545),(13.04,-9.375),(13.21,-9.375),(13.21,-9.545),(13.04,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-9.545),(13.55,-9.375),(13.72,-9.375),(13.72,-9.545),(13.55,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-9.545),(14.06,-9.375),(14.23,-9.375),(14.23,-9.545),(14.06,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-9.545),(14.57,-9.375),(14.74,-9.375),(14.74,-9.545),(14.57,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-9.545),(15.08,-9.375),(15.25,-9.375),(15.25,-9.545),(15.08,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-9.545),(15.59,-9.375),(15.76,-9.375),(15.76,-9.545),(15.59,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-9.545),(16.1,-9.375),(16.27,-9.375),(16.27,-9.545),(16.1,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-9.545),(16.61,-9.375),(16.78,-9.375),(16.78,-9.545),(16.61,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-9.545),(17.12,-9.375),(17.29,-9.375),(17.29,-9.545),(17.12,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-9.545),(17.63,-9.375),(17.8,-9.375),(17.8,-9.545),(17.63,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-9.545),(18.14,-9.375),(18.31,-9.375),(18.31,-9.545),(18.14,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-9.545),(18.65,-9.375),(18.82,-9.375),(18.82,-9.545),(18.65,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-9.545),(19.16,-9.375),(19.33,-9.375),(19.33,-9.545),(19.16,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-9.545),(19.67,-9.375),(19.84,-9.375),(19.84,-9.545),(19.67,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-9.545),(20.18,-9.375),(20.35,-9.375),(20.35,-9.545),(20.18,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-9.545),(20.69,-9.375),(20.86,-9.375),(20.86,-9.545),(20.69,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-9.545),(21.2,-9.375),(21.37,-9.375),(21.37,-9.545),(21.2,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-9.545),(21.71,-9.375),(21.88,-9.375),(21.88,-9.545),(21.71,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-9.545),(22.22,-9.375),(22.39,-9.375),(22.39,-9.545),(22.22,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-9.545),(22.73,-9.375),(22.9,-9.375),(22.9,-9.545),(22.73,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-9.545),(23.24,-9.375),(23.41,-9.375),(23.41,-9.545),(23.24,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-9.545),(23.75,-9.375),(23.92,-9.375),(23.92,-9.545),(23.75,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-9.545),(24.26,-9.375),(24.43,-9.375),(24.43,-9.545),(24.26,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-9.545),(24.77,-9.375),(24.94,-9.375),(24.94,-9.545),(24.77,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-9.545),(25.28,-9.375),(25.45,-9.375),(25.45,-9.545),(25.28,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-9.545),(25.79,-9.375),(25.96,-9.375),(25.96,-9.545),(25.79,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-9.545),(26.3,-9.375),(26.47,-9.375),(26.47,-9.545),(26.3,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-9.545),(26.81,-9.375),(26.98,-9.375),(26.98,-9.545),(26.81,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-9.545),(27.32,-9.375),(27.49,-9.375),(27.49,-9.545),(27.32,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-9.545),(27.83,-9.375),(28.0,-9.375),(28.0,-9.545),(27.83,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-9.545),(28.34,-9.375),(28.51,-9.375),(28.51,-9.545),(28.34,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-9.545),(28.85,-9.375),(29.02,-9.375),(29.02,-9.545),(28.85,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-9.545),(29.36,-9.375),(29.53,-9.375),(29.53,-9.545),(29.36,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-9.545),(29.87,-9.375),(30.04,-9.375),(30.04,-9.545),(29.87,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-9.545),(30.38,-9.375),(30.55,-9.375),(30.55,-9.545),(30.38,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-9.545),(30.89,-9.375),(31.06,-9.375),(31.06,-9.545),(30.89,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-9.545),(31.4,-9.375),(31.57,-9.375),(31.57,-9.545),(31.4,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-9.545),(31.91,-9.375),(32.08,-9.375),(32.08,-9.545),(31.91,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-9.545),(32.42,-9.375),(32.59,-9.375),(32.59,-9.545),(32.42,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-9.545),(32.93,-9.375),(33.1,-9.375),(33.1,-9.545),(32.93,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-9.545),(33.44,-9.375),(33.61,-9.375),(33.61,-9.545),(33.44,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-9.545),(33.95,-9.375),(34.12,-9.375),(34.12,-9.545),(33.95,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-9.545),(34.46,-9.375),(34.63,-9.375),(34.63,-9.545),(34.46,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-9.545),(34.97,-9.375),(35.14,-9.375),(35.14,-9.545),(34.97,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-9.545),(35.48,-9.375),(35.65,-9.375),(35.65,-9.545),(35.48,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-9.545),(35.99,-9.375),(36.16,-9.375),(36.16,-9.545),(35.99,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-9.545),(36.5,-9.375),(36.67,-9.375),(36.67,-9.545),(36.5,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-9.545),(37.01,-9.375),(37.18,-9.375),(37.18,-9.545),(37.01,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-9.545),(37.52,-9.375),(37.69,-9.375),(37.69,-9.545),(37.52,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-9.545),(38.03,-9.375),(38.2,-9.375),(38.2,-9.545),(38.03,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-9.545),(38.54,-9.375),(38.71,-9.375),(38.71,-9.545),(38.54,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-9.545),(39.05,-9.375),(39.22,-9.375),(39.22,-9.545),(39.05,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-9.545),(39.56,-9.375),(39.73,-9.375),(39.73,-9.545),(39.56,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-9.545),(40.07,-9.375),(40.24,-9.375),(40.24,-9.545),(40.07,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-9.545),(40.58,-9.375),(40.75,-9.375),(40.75,-9.545),(40.58,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-9.545),(41.09,-9.375),(41.26,-9.375),(41.26,-9.545),(41.09,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-9.545),(41.6,-9.375),(41.77,-9.375),(41.77,-9.545),(41.6,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-9.545),(42.11,-9.375),(42.28,-9.375),(42.28,-9.545),(42.11,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-9.545),(42.62,-9.375),(42.79,-9.375),(42.79,-9.545),(42.62,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-9.545),(43.13,-9.375),(43.3,-9.375),(43.3,-9.545),(43.13,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-9.545),(43.64,-9.375),(43.81,-9.375),(43.81,-9.545),(43.64,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-9.545),(44.15,-9.375),(44.32,-9.375),(44.32,-9.545),(44.15,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-9.545),(44.66,-9.375),(44.83,-9.375),(44.83,-9.545),(44.66,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-9.545),(45.17,-9.375),(45.34,-9.375),(45.34,-9.545),(45.17,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-9.545),(45.68,-9.375),(45.85,-9.375),(45.85,-9.545),(45.68,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-9.545),(46.19,-9.375),(46.36,-9.375),(46.36,-9.545),(46.19,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-9.545),(46.7,-9.375),(46.87,-9.375),(46.87,-9.545),(46.7,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-9.545),(47.21,-9.375),(47.38,-9.375),(47.38,-9.545),(47.21,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-9.545),(47.72,-9.375),(47.89,-9.375),(47.89,-9.545),(47.72,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-9.545),(48.23,-9.375),(48.4,-9.375),(48.4,-9.545),(48.23,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-9.545),(48.74,-9.375),(48.91,-9.375),(48.91,-9.545),(48.74,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-9.545),(49.25,-9.375),(49.42,-9.375),(49.42,-9.545),(49.25,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-9.545),(49.76,-9.375),(49.93,-9.375),(49.93,-9.545),(49.76,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-9.545),(50.27,-9.375),(50.44,-9.375),(50.44,-9.545),(50.27,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-9.545),(50.78,-9.375),(50.95,-9.375),(50.95,-9.545),(50.78,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-9.545),(51.29,-9.375),(51.46,-9.375),(51.46,-9.545),(51.29,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-9.545),(51.8,-9.375),(51.97,-9.375),(51.97,-9.545),(51.8,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-9.545),(52.31,-9.375),(52.48,-9.375),(52.48,-9.545),(52.31,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-9.545),(52.82,-9.375),(52.99,-9.375),(52.99,-9.545),(52.82,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-9.545),(53.33,-9.375),(53.5,-9.375),(53.5,-9.545),(53.33,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-9.545),(53.84,-9.375),(54.01,-9.375),(54.01,-9.545),(53.84,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-9.545),(54.35,-9.375),(54.52,-9.375),(54.52,-9.545),(54.35,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-9.545),(54.86,-9.375),(55.03,-9.375),(55.03,-9.545),(54.86,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-9.545),(55.37,-9.375),(55.54,-9.375),(55.54,-9.545),(55.37,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-9.545),(55.88,-9.375),(56.05,-9.375),(56.05,-9.545),(55.88,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-9.545),(56.39,-9.375),(56.56,-9.375),(56.56,-9.545),(56.39,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-9.545),(56.9,-9.375),(57.07,-9.375),(57.07,-9.545),(56.9,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-9.545),(57.41,-9.375),(57.58,-9.375),(57.58,-9.545),(57.41,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-9.545),(57.92,-9.375),(58.09,-9.375),(58.09,-9.545),(57.92,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-9.545),(58.43,-9.375),(58.6,-9.375),(58.6,-9.545),(58.43,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-9.545),(58.94,-9.375),(59.11,-9.375),(59.11,-9.545),(58.94,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-9.545),(59.45,-9.375),(59.62,-9.375),(59.62,-9.545),(59.45,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-9.545),(59.96,-9.375),(60.13,-9.375),(60.13,-9.545),(59.96,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-9.545),(60.47,-9.375),(60.64,-9.375),(60.64,-9.545),(60.47,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-9.545),(60.98,-9.375),(61.15,-9.375),(61.15,-9.545),(60.98,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-9.545),(61.49,-9.375),(61.66,-9.375),(61.66,-9.545),(61.49,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-9.545),(62.0,-9.375),(62.17,-9.375),(62.17,-9.545),(62.0,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-9.545),(62.51,-9.375),(62.68,-9.375),(62.68,-9.545),(62.51,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-9.545),(63.02,-9.375),(63.19,-9.375),(63.19,-9.545),(63.02,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-9.545),(63.53,-9.375),(63.7,-9.375),(63.7,-9.545),(63.53,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-9.545),(64.04,-9.375),(64.21,-9.375),(64.21,-9.545),(64.04,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-9.545),(64.55,-9.375),(64.72,-9.375),(64.72,-9.545),(64.55,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-9.545),(65.06,-9.375),(65.23,-9.375),(65.23,-9.545),(65.06,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-9.545),(65.57,-9.375),(65.74,-9.375),(65.74,-9.545),(65.57,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-9.545),(66.08,-9.375),(66.25,-9.375),(66.25,-9.545),(66.08,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-9.545),(66.59,-9.375),(66.76,-9.375),(66.76,-9.545),(66.59,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-9.545),(67.1,-9.375),(67.27,-9.375),(67.27,-9.545),(67.1,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-9.545),(67.61,-9.375),(67.78,-9.375),(67.78,-9.545),(67.61,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-9.545),(68.12,-9.375),(68.29,-9.375),(68.29,-9.545),(68.12,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-9.545),(68.63,-9.375),(68.8,-9.375),(68.8,-9.545),(68.63,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-9.545),(69.14,-9.375),(69.31,-9.375),(69.31,-9.545),(69.14,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-9.545),(69.65,-9.375),(69.82,-9.375),(69.82,-9.545),(69.65,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-9.545),(70.16,-9.375),(70.33,-9.375),(70.33,-9.545),(70.16,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-9.545),(70.67,-9.375),(70.84,-9.375),(70.84,-9.545),(70.67,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-9.545),(71.18,-9.375),(71.35,-9.375),(71.35,-9.545),(71.18,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-9.545),(71.69,-9.375),(71.86,-9.375),(71.86,-9.545),(71.69,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-9.545),(72.2,-9.375),(72.37,-9.375),(72.37,-9.545),(72.2,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-9.545),(72.71,-9.375),(72.88,-9.375),(72.88,-9.545),(72.71,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-9.545),(73.22,-9.375),(73.39,-9.375),(73.39,-9.545),(73.22,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-9.545),(73.73,-9.375),(73.9,-9.375),(73.9,-9.545),(73.73,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-9.545),(74.24,-9.375),(74.41,-9.375),(74.41,-9.545),(74.24,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-9.545),(74.75,-9.375),(74.92,-9.375),(74.92,-9.545),(74.75,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-9.545),(75.26,-9.375),(75.43,-9.375),(75.43,-9.545),(75.26,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-9.545),(75.77,-9.375),(75.94,-9.375),(75.94,-9.545),(75.77,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-9.545),(76.28,-9.375),(76.45,-9.375),(76.45,-9.545),(76.28,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-9.545),(76.79,-9.375),(76.96,-9.375),(76.96,-9.545),(76.79,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-9.545),(77.3,-9.375),(77.47,-9.375),(77.47,-9.545),(77.3,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-9.545),(77.81,-9.375),(77.98,-9.375),(77.98,-9.545),(77.81,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-9.545),(78.32,-9.375),(78.49,-9.375),(78.49,-9.545),(78.32,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-9.545),(78.83,-9.375),(79.0,-9.375),(79.0,-9.545),(78.83,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-9.545),(79.34,-9.375),(79.51,-9.375),(79.51,-9.545),(79.34,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-9.545),(79.85,-9.375),(80.02,-9.375),(80.02,-9.545),(79.85,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-9.545),(80.36,-9.375),(80.53,-9.375),(80.53,-9.545),(80.36,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-9.545),(80.87,-9.375),(81.04,-9.375),(81.04,-9.545),(80.87,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-9.545),(81.38,-9.375),(81.55,-9.375),(81.55,-9.545),(81.38,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-9.545),(81.89,-9.375),(82.06,-9.375),(82.06,-9.545),(81.89,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-9.545),(82.4,-9.375),(82.57,-9.375),(82.57,-9.545),(82.4,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-9.545),(82.91,-9.375),(83.08,-9.375),(83.08,-9.545),(82.91,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-9.545),(83.42,-9.375),(83.59,-9.375),(83.59,-9.545),(83.42,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-9.545),(83.93,-9.375),(84.1,-9.375),(84.1,-9.545),(83.93,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-9.545),(84.44,-9.375),(84.61,-9.375),(84.61,-9.545),(84.44,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-9.545),(84.95,-9.375),(85.12,-9.375),(85.12,-9.545),(84.95,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-9.545),(85.46,-9.375),(85.63,-9.375),(85.63,-9.545),(85.46,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-9.545),(85.97,-9.375),(86.14,-9.375),(86.14,-9.545),(85.97,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-9.545),(86.48,-9.375),(86.65,-9.375),(86.65,-9.545),(86.48,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-9.545),(86.99,-9.375),(87.16,-9.375),(87.16,-9.545),(86.99,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-9.545),(87.5,-9.375),(87.67,-9.375),(87.67,-9.545),(87.5,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-9.545),(88.01,-9.375),(88.18,-9.375),(88.18,-9.545),(88.01,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-9.545),(88.52,-9.375),(88.69,-9.375),(88.69,-9.545),(88.52,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-9.545),(89.03,-9.375),(89.2,-9.375),(89.2,-9.545),(89.03,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-9.545),(89.54,-9.375),(89.71,-9.375),(89.71,-9.545),(89.54,-9.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-9.035),(0.29,-8.865),(0.46,-8.865),(0.46,-9.035),(0.29,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-9.035),(0.8,-8.865),(0.97,-8.865),(0.97,-9.035),(0.8,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-9.035),(1.31,-8.865),(1.48,-8.865),(1.48,-9.035),(1.31,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-9.035),(1.82,-8.865),(1.99,-8.865),(1.99,-9.035),(1.82,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-9.035),(2.33,-8.865),(2.5,-8.865),(2.5,-9.035),(2.33,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-9.035),(2.84,-8.865),(3.01,-8.865),(3.01,-9.035),(2.84,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-9.035),(3.35,-8.865),(3.52,-8.865),(3.52,-9.035),(3.35,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-9.035),(3.86,-8.865),(4.03,-8.865),(4.03,-9.035),(3.86,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-9.035),(4.37,-8.865),(4.54,-8.865),(4.54,-9.035),(4.37,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-9.035),(4.88,-8.865),(5.05,-8.865),(5.05,-9.035),(4.88,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-9.035),(5.39,-8.865),(5.56,-8.865),(5.56,-9.035),(5.39,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-9.035),(5.9,-8.865),(6.07,-8.865),(6.07,-9.035),(5.9,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-9.035),(6.41,-8.865),(6.58,-8.865),(6.58,-9.035),(6.41,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-9.035),(6.92,-8.865),(7.09,-8.865),(7.09,-9.035),(6.92,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-9.035),(7.43,-8.865),(7.6,-8.865),(7.6,-9.035),(7.43,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-9.035),(7.94,-8.865),(8.11,-8.865),(8.11,-9.035),(7.94,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-9.035),(8.45,-8.865),(8.62,-8.865),(8.62,-9.035),(8.45,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-9.035),(8.96,-8.865),(9.13,-8.865),(9.13,-9.035),(8.96,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-9.035),(9.47,-8.865),(9.64,-8.865),(9.64,-9.035),(9.47,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-9.035),(9.98,-8.865),(10.15,-8.865),(10.15,-9.035),(9.98,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-9.035),(10.49,-8.865),(10.66,-8.865),(10.66,-9.035),(10.49,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-9.035),(11.0,-8.865),(11.17,-8.865),(11.17,-9.035),(11.0,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-9.035),(11.51,-8.865),(11.68,-8.865),(11.68,-9.035),(11.51,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-9.035),(12.02,-8.865),(12.19,-8.865),(12.19,-9.035),(12.02,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-9.035),(12.53,-8.865),(12.7,-8.865),(12.7,-9.035),(12.53,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-9.035),(13.04,-8.865),(13.21,-8.865),(13.21,-9.035),(13.04,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-9.035),(13.55,-8.865),(13.72,-8.865),(13.72,-9.035),(13.55,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-9.035),(14.06,-8.865),(14.23,-8.865),(14.23,-9.035),(14.06,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-9.035),(14.57,-8.865),(14.74,-8.865),(14.74,-9.035),(14.57,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-9.035),(15.08,-8.865),(15.25,-8.865),(15.25,-9.035),(15.08,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-9.035),(15.59,-8.865),(15.76,-8.865),(15.76,-9.035),(15.59,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-9.035),(16.1,-8.865),(16.27,-8.865),(16.27,-9.035),(16.1,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-9.035),(16.61,-8.865),(16.78,-8.865),(16.78,-9.035),(16.61,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-9.035),(17.12,-8.865),(17.29,-8.865),(17.29,-9.035),(17.12,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-9.035),(17.63,-8.865),(17.8,-8.865),(17.8,-9.035),(17.63,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-9.035),(18.14,-8.865),(18.31,-8.865),(18.31,-9.035),(18.14,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-9.035),(18.65,-8.865),(18.82,-8.865),(18.82,-9.035),(18.65,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-9.035),(19.16,-8.865),(19.33,-8.865),(19.33,-9.035),(19.16,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-9.035),(19.67,-8.865),(19.84,-8.865),(19.84,-9.035),(19.67,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-9.035),(20.18,-8.865),(20.35,-8.865),(20.35,-9.035),(20.18,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-9.035),(20.69,-8.865),(20.86,-8.865),(20.86,-9.035),(20.69,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-9.035),(21.2,-8.865),(21.37,-8.865),(21.37,-9.035),(21.2,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-9.035),(21.71,-8.865),(21.88,-8.865),(21.88,-9.035),(21.71,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-9.035),(22.22,-8.865),(22.39,-8.865),(22.39,-9.035),(22.22,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-9.035),(22.73,-8.865),(22.9,-8.865),(22.9,-9.035),(22.73,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-9.035),(23.24,-8.865),(23.41,-8.865),(23.41,-9.035),(23.24,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-9.035),(23.75,-8.865),(23.92,-8.865),(23.92,-9.035),(23.75,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-9.035),(24.26,-8.865),(24.43,-8.865),(24.43,-9.035),(24.26,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-9.035),(24.77,-8.865),(24.94,-8.865),(24.94,-9.035),(24.77,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-9.035),(25.28,-8.865),(25.45,-8.865),(25.45,-9.035),(25.28,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-9.035),(25.79,-8.865),(25.96,-8.865),(25.96,-9.035),(25.79,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-9.035),(26.3,-8.865),(26.47,-8.865),(26.47,-9.035),(26.3,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-9.035),(26.81,-8.865),(26.98,-8.865),(26.98,-9.035),(26.81,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-9.035),(27.32,-8.865),(27.49,-8.865),(27.49,-9.035),(27.32,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-9.035),(27.83,-8.865),(28.0,-8.865),(28.0,-9.035),(27.83,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-9.035),(28.34,-8.865),(28.51,-8.865),(28.51,-9.035),(28.34,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-9.035),(28.85,-8.865),(29.02,-8.865),(29.02,-9.035),(28.85,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-9.035),(29.36,-8.865),(29.53,-8.865),(29.53,-9.035),(29.36,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-9.035),(29.87,-8.865),(30.04,-8.865),(30.04,-9.035),(29.87,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-9.035),(30.38,-8.865),(30.55,-8.865),(30.55,-9.035),(30.38,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-9.035),(30.89,-8.865),(31.06,-8.865),(31.06,-9.035),(30.89,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-9.035),(31.4,-8.865),(31.57,-8.865),(31.57,-9.035),(31.4,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-9.035),(31.91,-8.865),(32.08,-8.865),(32.08,-9.035),(31.91,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-9.035),(32.42,-8.865),(32.59,-8.865),(32.59,-9.035),(32.42,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-9.035),(32.93,-8.865),(33.1,-8.865),(33.1,-9.035),(32.93,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-9.035),(33.44,-8.865),(33.61,-8.865),(33.61,-9.035),(33.44,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-9.035),(33.95,-8.865),(34.12,-8.865),(34.12,-9.035),(33.95,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-9.035),(34.46,-8.865),(34.63,-8.865),(34.63,-9.035),(34.46,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-9.035),(34.97,-8.865),(35.14,-8.865),(35.14,-9.035),(34.97,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-9.035),(35.48,-8.865),(35.65,-8.865),(35.65,-9.035),(35.48,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-9.035),(35.99,-8.865),(36.16,-8.865),(36.16,-9.035),(35.99,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-9.035),(36.5,-8.865),(36.67,-8.865),(36.67,-9.035),(36.5,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-9.035),(37.01,-8.865),(37.18,-8.865),(37.18,-9.035),(37.01,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-9.035),(37.52,-8.865),(37.69,-8.865),(37.69,-9.035),(37.52,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-9.035),(38.03,-8.865),(38.2,-8.865),(38.2,-9.035),(38.03,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-9.035),(38.54,-8.865),(38.71,-8.865),(38.71,-9.035),(38.54,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-9.035),(39.05,-8.865),(39.22,-8.865),(39.22,-9.035),(39.05,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-9.035),(39.56,-8.865),(39.73,-8.865),(39.73,-9.035),(39.56,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-9.035),(40.07,-8.865),(40.24,-8.865),(40.24,-9.035),(40.07,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-9.035),(40.58,-8.865),(40.75,-8.865),(40.75,-9.035),(40.58,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-9.035),(41.09,-8.865),(41.26,-8.865),(41.26,-9.035),(41.09,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-9.035),(41.6,-8.865),(41.77,-8.865),(41.77,-9.035),(41.6,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-9.035),(42.11,-8.865),(42.28,-8.865),(42.28,-9.035),(42.11,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-9.035),(42.62,-8.865),(42.79,-8.865),(42.79,-9.035),(42.62,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-9.035),(43.13,-8.865),(43.3,-8.865),(43.3,-9.035),(43.13,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-9.035),(43.64,-8.865),(43.81,-8.865),(43.81,-9.035),(43.64,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-9.035),(44.15,-8.865),(44.32,-8.865),(44.32,-9.035),(44.15,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-9.035),(44.66,-8.865),(44.83,-8.865),(44.83,-9.035),(44.66,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-9.035),(45.17,-8.865),(45.34,-8.865),(45.34,-9.035),(45.17,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-9.035),(45.68,-8.865),(45.85,-8.865),(45.85,-9.035),(45.68,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-9.035),(46.19,-8.865),(46.36,-8.865),(46.36,-9.035),(46.19,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-9.035),(46.7,-8.865),(46.87,-8.865),(46.87,-9.035),(46.7,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-9.035),(47.21,-8.865),(47.38,-8.865),(47.38,-9.035),(47.21,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-9.035),(47.72,-8.865),(47.89,-8.865),(47.89,-9.035),(47.72,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-9.035),(48.23,-8.865),(48.4,-8.865),(48.4,-9.035),(48.23,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-9.035),(48.74,-8.865),(48.91,-8.865),(48.91,-9.035),(48.74,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-9.035),(49.25,-8.865),(49.42,-8.865),(49.42,-9.035),(49.25,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-9.035),(49.76,-8.865),(49.93,-8.865),(49.93,-9.035),(49.76,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-9.035),(50.27,-8.865),(50.44,-8.865),(50.44,-9.035),(50.27,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-9.035),(50.78,-8.865),(50.95,-8.865),(50.95,-9.035),(50.78,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-9.035),(51.29,-8.865),(51.46,-8.865),(51.46,-9.035),(51.29,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-9.035),(51.8,-8.865),(51.97,-8.865),(51.97,-9.035),(51.8,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-9.035),(52.31,-8.865),(52.48,-8.865),(52.48,-9.035),(52.31,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-9.035),(52.82,-8.865),(52.99,-8.865),(52.99,-9.035),(52.82,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-9.035),(53.33,-8.865),(53.5,-8.865),(53.5,-9.035),(53.33,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-9.035),(53.84,-8.865),(54.01,-8.865),(54.01,-9.035),(53.84,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-9.035),(54.35,-8.865),(54.52,-8.865),(54.52,-9.035),(54.35,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-9.035),(54.86,-8.865),(55.03,-8.865),(55.03,-9.035),(54.86,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-9.035),(55.37,-8.865),(55.54,-8.865),(55.54,-9.035),(55.37,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-9.035),(55.88,-8.865),(56.05,-8.865),(56.05,-9.035),(55.88,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-9.035),(56.39,-8.865),(56.56,-8.865),(56.56,-9.035),(56.39,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-9.035),(56.9,-8.865),(57.07,-8.865),(57.07,-9.035),(56.9,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-9.035),(57.41,-8.865),(57.58,-8.865),(57.58,-9.035),(57.41,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-9.035),(57.92,-8.865),(58.09,-8.865),(58.09,-9.035),(57.92,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-9.035),(58.43,-8.865),(58.6,-8.865),(58.6,-9.035),(58.43,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-9.035),(58.94,-8.865),(59.11,-8.865),(59.11,-9.035),(58.94,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-9.035),(59.45,-8.865),(59.62,-8.865),(59.62,-9.035),(59.45,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-9.035),(59.96,-8.865),(60.13,-8.865),(60.13,-9.035),(59.96,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-9.035),(60.47,-8.865),(60.64,-8.865),(60.64,-9.035),(60.47,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-9.035),(60.98,-8.865),(61.15,-8.865),(61.15,-9.035),(60.98,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-9.035),(61.49,-8.865),(61.66,-8.865),(61.66,-9.035),(61.49,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-9.035),(62.0,-8.865),(62.17,-8.865),(62.17,-9.035),(62.0,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-9.035),(62.51,-8.865),(62.68,-8.865),(62.68,-9.035),(62.51,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-9.035),(63.02,-8.865),(63.19,-8.865),(63.19,-9.035),(63.02,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-9.035),(63.53,-8.865),(63.7,-8.865),(63.7,-9.035),(63.53,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-9.035),(64.04,-8.865),(64.21,-8.865),(64.21,-9.035),(64.04,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-9.035),(64.55,-8.865),(64.72,-8.865),(64.72,-9.035),(64.55,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-9.035),(65.06,-8.865),(65.23,-8.865),(65.23,-9.035),(65.06,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-9.035),(65.57,-8.865),(65.74,-8.865),(65.74,-9.035),(65.57,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-9.035),(66.08,-8.865),(66.25,-8.865),(66.25,-9.035),(66.08,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-9.035),(66.59,-8.865),(66.76,-8.865),(66.76,-9.035),(66.59,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-9.035),(67.1,-8.865),(67.27,-8.865),(67.27,-9.035),(67.1,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-9.035),(67.61,-8.865),(67.78,-8.865),(67.78,-9.035),(67.61,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-9.035),(68.12,-8.865),(68.29,-8.865),(68.29,-9.035),(68.12,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-9.035),(68.63,-8.865),(68.8,-8.865),(68.8,-9.035),(68.63,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-9.035),(69.14,-8.865),(69.31,-8.865),(69.31,-9.035),(69.14,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-9.035),(69.65,-8.865),(69.82,-8.865),(69.82,-9.035),(69.65,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-9.035),(70.16,-8.865),(70.33,-8.865),(70.33,-9.035),(70.16,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-9.035),(70.67,-8.865),(70.84,-8.865),(70.84,-9.035),(70.67,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-9.035),(71.18,-8.865),(71.35,-8.865),(71.35,-9.035),(71.18,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-9.035),(71.69,-8.865),(71.86,-8.865),(71.86,-9.035),(71.69,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-9.035),(72.2,-8.865),(72.37,-8.865),(72.37,-9.035),(72.2,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-9.035),(72.71,-8.865),(72.88,-8.865),(72.88,-9.035),(72.71,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-9.035),(73.22,-8.865),(73.39,-8.865),(73.39,-9.035),(73.22,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-9.035),(73.73,-8.865),(73.9,-8.865),(73.9,-9.035),(73.73,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-9.035),(74.24,-8.865),(74.41,-8.865),(74.41,-9.035),(74.24,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-9.035),(74.75,-8.865),(74.92,-8.865),(74.92,-9.035),(74.75,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-9.035),(75.26,-8.865),(75.43,-8.865),(75.43,-9.035),(75.26,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-9.035),(75.77,-8.865),(75.94,-8.865),(75.94,-9.035),(75.77,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-9.035),(76.28,-8.865),(76.45,-8.865),(76.45,-9.035),(76.28,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-9.035),(76.79,-8.865),(76.96,-8.865),(76.96,-9.035),(76.79,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-9.035),(77.3,-8.865),(77.47,-8.865),(77.47,-9.035),(77.3,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-9.035),(77.81,-8.865),(77.98,-8.865),(77.98,-9.035),(77.81,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-9.035),(78.32,-8.865),(78.49,-8.865),(78.49,-9.035),(78.32,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-9.035),(78.83,-8.865),(79.0,-8.865),(79.0,-9.035),(78.83,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-9.035),(79.34,-8.865),(79.51,-8.865),(79.51,-9.035),(79.34,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-9.035),(79.85,-8.865),(80.02,-8.865),(80.02,-9.035),(79.85,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-9.035),(80.36,-8.865),(80.53,-8.865),(80.53,-9.035),(80.36,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-9.035),(80.87,-8.865),(81.04,-8.865),(81.04,-9.035),(80.87,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-9.035),(81.38,-8.865),(81.55,-8.865),(81.55,-9.035),(81.38,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-9.035),(81.89,-8.865),(82.06,-8.865),(82.06,-9.035),(81.89,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-9.035),(82.4,-8.865),(82.57,-8.865),(82.57,-9.035),(82.4,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-9.035),(82.91,-8.865),(83.08,-8.865),(83.08,-9.035),(82.91,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-9.035),(83.42,-8.865),(83.59,-8.865),(83.59,-9.035),(83.42,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-9.035),(83.93,-8.865),(84.1,-8.865),(84.1,-9.035),(83.93,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-9.035),(84.44,-8.865),(84.61,-8.865),(84.61,-9.035),(84.44,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-9.035),(84.95,-8.865),(85.12,-8.865),(85.12,-9.035),(84.95,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-9.035),(85.46,-8.865),(85.63,-8.865),(85.63,-9.035),(85.46,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-9.035),(85.97,-8.865),(86.14,-8.865),(86.14,-9.035),(85.97,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-9.035),(86.48,-8.865),(86.65,-8.865),(86.65,-9.035),(86.48,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-9.035),(86.99,-8.865),(87.16,-8.865),(87.16,-9.035),(86.99,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-9.035),(87.5,-8.865),(87.67,-8.865),(87.67,-9.035),(87.5,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-9.035),(88.01,-8.865),(88.18,-8.865),(88.18,-9.035),(88.01,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-9.035),(88.52,-8.865),(88.69,-8.865),(88.69,-9.035),(88.52,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-9.035),(89.03,-8.865),(89.2,-8.865),(89.2,-9.035),(89.03,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-9.035),(89.54,-8.865),(89.71,-8.865),(89.71,-9.035),(89.54,-9.035)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-8.525),(0.29,-8.355),(0.46,-8.355),(0.46,-8.525),(0.29,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-8.525),(0.8,-8.355),(0.97,-8.355),(0.97,-8.525),(0.8,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-8.525),(1.31,-8.355),(1.48,-8.355),(1.48,-8.525),(1.31,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-8.525),(1.82,-8.355),(1.99,-8.355),(1.99,-8.525),(1.82,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-8.525),(2.33,-8.355),(2.5,-8.355),(2.5,-8.525),(2.33,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-8.525),(2.84,-8.355),(3.01,-8.355),(3.01,-8.525),(2.84,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-8.525),(3.35,-8.355),(3.52,-8.355),(3.52,-8.525),(3.35,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-8.525),(3.86,-8.355),(4.03,-8.355),(4.03,-8.525),(3.86,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-8.525),(4.37,-8.355),(4.54,-8.355),(4.54,-8.525),(4.37,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-8.525),(4.88,-8.355),(5.05,-8.355),(5.05,-8.525),(4.88,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-8.525),(5.39,-8.355),(5.56,-8.355),(5.56,-8.525),(5.39,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-8.525),(5.9,-8.355),(6.07,-8.355),(6.07,-8.525),(5.9,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-8.525),(6.41,-8.355),(6.58,-8.355),(6.58,-8.525),(6.41,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-8.525),(6.92,-8.355),(7.09,-8.355),(7.09,-8.525),(6.92,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-8.525),(7.43,-8.355),(7.6,-8.355),(7.6,-8.525),(7.43,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-8.525),(7.94,-8.355),(8.11,-8.355),(8.11,-8.525),(7.94,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-8.525),(8.45,-8.355),(8.62,-8.355),(8.62,-8.525),(8.45,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-8.525),(8.96,-8.355),(9.13,-8.355),(9.13,-8.525),(8.96,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-8.525),(9.47,-8.355),(9.64,-8.355),(9.64,-8.525),(9.47,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-8.525),(9.98,-8.355),(10.15,-8.355),(10.15,-8.525),(9.98,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-8.525),(10.49,-8.355),(10.66,-8.355),(10.66,-8.525),(10.49,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-8.525),(11.0,-8.355),(11.17,-8.355),(11.17,-8.525),(11.0,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-8.525),(11.51,-8.355),(11.68,-8.355),(11.68,-8.525),(11.51,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-8.525),(12.02,-8.355),(12.19,-8.355),(12.19,-8.525),(12.02,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-8.525),(12.53,-8.355),(12.7,-8.355),(12.7,-8.525),(12.53,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-8.525),(13.04,-8.355),(13.21,-8.355),(13.21,-8.525),(13.04,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-8.525),(13.55,-8.355),(13.72,-8.355),(13.72,-8.525),(13.55,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-8.525),(14.06,-8.355),(14.23,-8.355),(14.23,-8.525),(14.06,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-8.525),(14.57,-8.355),(14.74,-8.355),(14.74,-8.525),(14.57,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-8.525),(15.08,-8.355),(15.25,-8.355),(15.25,-8.525),(15.08,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-8.525),(15.59,-8.355),(15.76,-8.355),(15.76,-8.525),(15.59,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-8.525),(16.1,-8.355),(16.27,-8.355),(16.27,-8.525),(16.1,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-8.525),(16.61,-8.355),(16.78,-8.355),(16.78,-8.525),(16.61,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-8.525),(17.12,-8.355),(17.29,-8.355),(17.29,-8.525),(17.12,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-8.525),(17.63,-8.355),(17.8,-8.355),(17.8,-8.525),(17.63,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-8.525),(18.14,-8.355),(18.31,-8.355),(18.31,-8.525),(18.14,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-8.525),(18.65,-8.355),(18.82,-8.355),(18.82,-8.525),(18.65,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-8.525),(19.16,-8.355),(19.33,-8.355),(19.33,-8.525),(19.16,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-8.525),(19.67,-8.355),(19.84,-8.355),(19.84,-8.525),(19.67,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-8.525),(20.18,-8.355),(20.35,-8.355),(20.35,-8.525),(20.18,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-8.525),(20.69,-8.355),(20.86,-8.355),(20.86,-8.525),(20.69,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-8.525),(21.2,-8.355),(21.37,-8.355),(21.37,-8.525),(21.2,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-8.525),(21.71,-8.355),(21.88,-8.355),(21.88,-8.525),(21.71,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-8.525),(22.22,-8.355),(22.39,-8.355),(22.39,-8.525),(22.22,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-8.525),(22.73,-8.355),(22.9,-8.355),(22.9,-8.525),(22.73,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-8.525),(23.24,-8.355),(23.41,-8.355),(23.41,-8.525),(23.24,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-8.525),(23.75,-8.355),(23.92,-8.355),(23.92,-8.525),(23.75,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-8.525),(24.26,-8.355),(24.43,-8.355),(24.43,-8.525),(24.26,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-8.525),(24.77,-8.355),(24.94,-8.355),(24.94,-8.525),(24.77,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-8.525),(25.28,-8.355),(25.45,-8.355),(25.45,-8.525),(25.28,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-8.525),(25.79,-8.355),(25.96,-8.355),(25.96,-8.525),(25.79,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-8.525),(26.3,-8.355),(26.47,-8.355),(26.47,-8.525),(26.3,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-8.525),(26.81,-8.355),(26.98,-8.355),(26.98,-8.525),(26.81,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-8.525),(27.32,-8.355),(27.49,-8.355),(27.49,-8.525),(27.32,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-8.525),(27.83,-8.355),(28.0,-8.355),(28.0,-8.525),(27.83,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-8.525),(28.34,-8.355),(28.51,-8.355),(28.51,-8.525),(28.34,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-8.525),(28.85,-8.355),(29.02,-8.355),(29.02,-8.525),(28.85,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-8.525),(29.36,-8.355),(29.53,-8.355),(29.53,-8.525),(29.36,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-8.525),(29.87,-8.355),(30.04,-8.355),(30.04,-8.525),(29.87,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-8.525),(30.38,-8.355),(30.55,-8.355),(30.55,-8.525),(30.38,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-8.525),(30.89,-8.355),(31.06,-8.355),(31.06,-8.525),(30.89,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-8.525),(31.4,-8.355),(31.57,-8.355),(31.57,-8.525),(31.4,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-8.525),(31.91,-8.355),(32.08,-8.355),(32.08,-8.525),(31.91,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-8.525),(32.42,-8.355),(32.59,-8.355),(32.59,-8.525),(32.42,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-8.525),(32.93,-8.355),(33.1,-8.355),(33.1,-8.525),(32.93,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-8.525),(33.44,-8.355),(33.61,-8.355),(33.61,-8.525),(33.44,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-8.525),(33.95,-8.355),(34.12,-8.355),(34.12,-8.525),(33.95,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-8.525),(34.46,-8.355),(34.63,-8.355),(34.63,-8.525),(34.46,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-8.525),(34.97,-8.355),(35.14,-8.355),(35.14,-8.525),(34.97,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-8.525),(35.48,-8.355),(35.65,-8.355),(35.65,-8.525),(35.48,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-8.525),(35.99,-8.355),(36.16,-8.355),(36.16,-8.525),(35.99,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-8.525),(36.5,-8.355),(36.67,-8.355),(36.67,-8.525),(36.5,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-8.525),(37.01,-8.355),(37.18,-8.355),(37.18,-8.525),(37.01,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-8.525),(37.52,-8.355),(37.69,-8.355),(37.69,-8.525),(37.52,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-8.525),(38.03,-8.355),(38.2,-8.355),(38.2,-8.525),(38.03,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-8.525),(38.54,-8.355),(38.71,-8.355),(38.71,-8.525),(38.54,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-8.525),(39.05,-8.355),(39.22,-8.355),(39.22,-8.525),(39.05,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-8.525),(39.56,-8.355),(39.73,-8.355),(39.73,-8.525),(39.56,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-8.525),(40.07,-8.355),(40.24,-8.355),(40.24,-8.525),(40.07,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-8.525),(40.58,-8.355),(40.75,-8.355),(40.75,-8.525),(40.58,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-8.525),(41.09,-8.355),(41.26,-8.355),(41.26,-8.525),(41.09,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-8.525),(41.6,-8.355),(41.77,-8.355),(41.77,-8.525),(41.6,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-8.525),(42.11,-8.355),(42.28,-8.355),(42.28,-8.525),(42.11,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-8.525),(42.62,-8.355),(42.79,-8.355),(42.79,-8.525),(42.62,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-8.525),(43.13,-8.355),(43.3,-8.355),(43.3,-8.525),(43.13,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-8.525),(43.64,-8.355),(43.81,-8.355),(43.81,-8.525),(43.64,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-8.525),(44.15,-8.355),(44.32,-8.355),(44.32,-8.525),(44.15,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-8.525),(44.66,-8.355),(44.83,-8.355),(44.83,-8.525),(44.66,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-8.525),(45.17,-8.355),(45.34,-8.355),(45.34,-8.525),(45.17,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-8.525),(45.68,-8.355),(45.85,-8.355),(45.85,-8.525),(45.68,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-8.525),(46.19,-8.355),(46.36,-8.355),(46.36,-8.525),(46.19,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-8.525),(46.7,-8.355),(46.87,-8.355),(46.87,-8.525),(46.7,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-8.525),(47.21,-8.355),(47.38,-8.355),(47.38,-8.525),(47.21,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-8.525),(47.72,-8.355),(47.89,-8.355),(47.89,-8.525),(47.72,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-8.525),(48.23,-8.355),(48.4,-8.355),(48.4,-8.525),(48.23,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-8.525),(48.74,-8.355),(48.91,-8.355),(48.91,-8.525),(48.74,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-8.525),(49.25,-8.355),(49.42,-8.355),(49.42,-8.525),(49.25,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-8.525),(49.76,-8.355),(49.93,-8.355),(49.93,-8.525),(49.76,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-8.525),(50.27,-8.355),(50.44,-8.355),(50.44,-8.525),(50.27,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-8.525),(50.78,-8.355),(50.95,-8.355),(50.95,-8.525),(50.78,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-8.525),(51.29,-8.355),(51.46,-8.355),(51.46,-8.525),(51.29,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-8.525),(51.8,-8.355),(51.97,-8.355),(51.97,-8.525),(51.8,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-8.525),(52.31,-8.355),(52.48,-8.355),(52.48,-8.525),(52.31,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-8.525),(52.82,-8.355),(52.99,-8.355),(52.99,-8.525),(52.82,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-8.525),(53.33,-8.355),(53.5,-8.355),(53.5,-8.525),(53.33,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-8.525),(53.84,-8.355),(54.01,-8.355),(54.01,-8.525),(53.84,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-8.525),(54.35,-8.355),(54.52,-8.355),(54.52,-8.525),(54.35,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-8.525),(54.86,-8.355),(55.03,-8.355),(55.03,-8.525),(54.86,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-8.525),(55.37,-8.355),(55.54,-8.355),(55.54,-8.525),(55.37,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-8.525),(55.88,-8.355),(56.05,-8.355),(56.05,-8.525),(55.88,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-8.525),(56.39,-8.355),(56.56,-8.355),(56.56,-8.525),(56.39,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-8.525),(56.9,-8.355),(57.07,-8.355),(57.07,-8.525),(56.9,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-8.525),(57.41,-8.355),(57.58,-8.355),(57.58,-8.525),(57.41,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-8.525),(57.92,-8.355),(58.09,-8.355),(58.09,-8.525),(57.92,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-8.525),(58.43,-8.355),(58.6,-8.355),(58.6,-8.525),(58.43,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-8.525),(58.94,-8.355),(59.11,-8.355),(59.11,-8.525),(58.94,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-8.525),(59.45,-8.355),(59.62,-8.355),(59.62,-8.525),(59.45,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-8.525),(59.96,-8.355),(60.13,-8.355),(60.13,-8.525),(59.96,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-8.525),(60.47,-8.355),(60.64,-8.355),(60.64,-8.525),(60.47,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-8.525),(60.98,-8.355),(61.15,-8.355),(61.15,-8.525),(60.98,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-8.525),(61.49,-8.355),(61.66,-8.355),(61.66,-8.525),(61.49,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-8.525),(62.0,-8.355),(62.17,-8.355),(62.17,-8.525),(62.0,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-8.525),(62.51,-8.355),(62.68,-8.355),(62.68,-8.525),(62.51,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-8.525),(63.02,-8.355),(63.19,-8.355),(63.19,-8.525),(63.02,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-8.525),(63.53,-8.355),(63.7,-8.355),(63.7,-8.525),(63.53,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-8.525),(64.04,-8.355),(64.21,-8.355),(64.21,-8.525),(64.04,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-8.525),(64.55,-8.355),(64.72,-8.355),(64.72,-8.525),(64.55,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-8.525),(65.06,-8.355),(65.23,-8.355),(65.23,-8.525),(65.06,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-8.525),(65.57,-8.355),(65.74,-8.355),(65.74,-8.525),(65.57,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-8.525),(66.08,-8.355),(66.25,-8.355),(66.25,-8.525),(66.08,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-8.525),(66.59,-8.355),(66.76,-8.355),(66.76,-8.525),(66.59,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-8.525),(67.1,-8.355),(67.27,-8.355),(67.27,-8.525),(67.1,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-8.525),(67.61,-8.355),(67.78,-8.355),(67.78,-8.525),(67.61,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-8.525),(68.12,-8.355),(68.29,-8.355),(68.29,-8.525),(68.12,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-8.525),(68.63,-8.355),(68.8,-8.355),(68.8,-8.525),(68.63,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-8.525),(69.14,-8.355),(69.31,-8.355),(69.31,-8.525),(69.14,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-8.525),(69.65,-8.355),(69.82,-8.355),(69.82,-8.525),(69.65,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-8.525),(70.16,-8.355),(70.33,-8.355),(70.33,-8.525),(70.16,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-8.525),(70.67,-8.355),(70.84,-8.355),(70.84,-8.525),(70.67,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-8.525),(71.18,-8.355),(71.35,-8.355),(71.35,-8.525),(71.18,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-8.525),(71.69,-8.355),(71.86,-8.355),(71.86,-8.525),(71.69,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-8.525),(72.2,-8.355),(72.37,-8.355),(72.37,-8.525),(72.2,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-8.525),(72.71,-8.355),(72.88,-8.355),(72.88,-8.525),(72.71,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-8.525),(73.22,-8.355),(73.39,-8.355),(73.39,-8.525),(73.22,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-8.525),(73.73,-8.355),(73.9,-8.355),(73.9,-8.525),(73.73,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-8.525),(74.24,-8.355),(74.41,-8.355),(74.41,-8.525),(74.24,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-8.525),(74.75,-8.355),(74.92,-8.355),(74.92,-8.525),(74.75,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-8.525),(75.26,-8.355),(75.43,-8.355),(75.43,-8.525),(75.26,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-8.525),(75.77,-8.355),(75.94,-8.355),(75.94,-8.525),(75.77,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-8.525),(76.28,-8.355),(76.45,-8.355),(76.45,-8.525),(76.28,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-8.525),(76.79,-8.355),(76.96,-8.355),(76.96,-8.525),(76.79,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-8.525),(77.3,-8.355),(77.47,-8.355),(77.47,-8.525),(77.3,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-8.525),(77.81,-8.355),(77.98,-8.355),(77.98,-8.525),(77.81,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-8.525),(78.32,-8.355),(78.49,-8.355),(78.49,-8.525),(78.32,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-8.525),(78.83,-8.355),(79.0,-8.355),(79.0,-8.525),(78.83,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-8.525),(79.34,-8.355),(79.51,-8.355),(79.51,-8.525),(79.34,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-8.525),(79.85,-8.355),(80.02,-8.355),(80.02,-8.525),(79.85,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-8.525),(80.36,-8.355),(80.53,-8.355),(80.53,-8.525),(80.36,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-8.525),(80.87,-8.355),(81.04,-8.355),(81.04,-8.525),(80.87,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-8.525),(81.38,-8.355),(81.55,-8.355),(81.55,-8.525),(81.38,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-8.525),(81.89,-8.355),(82.06,-8.355),(82.06,-8.525),(81.89,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-8.525),(82.4,-8.355),(82.57,-8.355),(82.57,-8.525),(82.4,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-8.525),(82.91,-8.355),(83.08,-8.355),(83.08,-8.525),(82.91,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-8.525),(83.42,-8.355),(83.59,-8.355),(83.59,-8.525),(83.42,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-8.525),(83.93,-8.355),(84.1,-8.355),(84.1,-8.525),(83.93,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-8.525),(84.44,-8.355),(84.61,-8.355),(84.61,-8.525),(84.44,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-8.525),(84.95,-8.355),(85.12,-8.355),(85.12,-8.525),(84.95,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-8.525),(85.46,-8.355),(85.63,-8.355),(85.63,-8.525),(85.46,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-8.525),(85.97,-8.355),(86.14,-8.355),(86.14,-8.525),(85.97,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-8.525),(86.48,-8.355),(86.65,-8.355),(86.65,-8.525),(86.48,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-8.525),(86.99,-8.355),(87.16,-8.355),(87.16,-8.525),(86.99,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-8.525),(87.5,-8.355),(87.67,-8.355),(87.67,-8.525),(87.5,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-8.525),(88.01,-8.355),(88.18,-8.355),(88.18,-8.525),(88.01,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-8.525),(88.52,-8.355),(88.69,-8.355),(88.69,-8.525),(88.52,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-8.525),(89.03,-8.355),(89.2,-8.355),(89.2,-8.525),(89.03,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-8.525),(89.54,-8.355),(89.71,-8.355),(89.71,-8.525),(89.54,-8.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-8.015),(0.29,-7.845),(0.46,-7.845),(0.46,-8.015),(0.29,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-8.015),(0.8,-7.845),(0.97,-7.845),(0.97,-8.015),(0.8,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-8.015),(1.31,-7.845),(1.48,-7.845),(1.48,-8.015),(1.31,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-8.015),(1.82,-7.845),(1.99,-7.845),(1.99,-8.015),(1.82,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-8.015),(2.33,-7.845),(2.5,-7.845),(2.5,-8.015),(2.33,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-8.015),(2.84,-7.845),(3.01,-7.845),(3.01,-8.015),(2.84,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-8.015),(3.35,-7.845),(3.52,-7.845),(3.52,-8.015),(3.35,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-8.015),(3.86,-7.845),(4.03,-7.845),(4.03,-8.015),(3.86,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-8.015),(4.37,-7.845),(4.54,-7.845),(4.54,-8.015),(4.37,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-8.015),(4.88,-7.845),(5.05,-7.845),(5.05,-8.015),(4.88,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-8.015),(5.39,-7.845),(5.56,-7.845),(5.56,-8.015),(5.39,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-8.015),(5.9,-7.845),(6.07,-7.845),(6.07,-8.015),(5.9,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-8.015),(6.41,-7.845),(6.58,-7.845),(6.58,-8.015),(6.41,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-8.015),(6.92,-7.845),(7.09,-7.845),(7.09,-8.015),(6.92,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-8.015),(7.43,-7.845),(7.6,-7.845),(7.6,-8.015),(7.43,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-8.015),(7.94,-7.845),(8.11,-7.845),(8.11,-8.015),(7.94,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-8.015),(8.45,-7.845),(8.62,-7.845),(8.62,-8.015),(8.45,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-8.015),(8.96,-7.845),(9.13,-7.845),(9.13,-8.015),(8.96,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-8.015),(9.47,-7.845),(9.64,-7.845),(9.64,-8.015),(9.47,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-8.015),(9.98,-7.845),(10.15,-7.845),(10.15,-8.015),(9.98,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-8.015),(10.49,-7.845),(10.66,-7.845),(10.66,-8.015),(10.49,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-8.015),(11.0,-7.845),(11.17,-7.845),(11.17,-8.015),(11.0,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-8.015),(11.51,-7.845),(11.68,-7.845),(11.68,-8.015),(11.51,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-8.015),(12.02,-7.845),(12.19,-7.845),(12.19,-8.015),(12.02,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-8.015),(12.53,-7.845),(12.7,-7.845),(12.7,-8.015),(12.53,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-8.015),(13.04,-7.845),(13.21,-7.845),(13.21,-8.015),(13.04,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-8.015),(13.55,-7.845),(13.72,-7.845),(13.72,-8.015),(13.55,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-8.015),(14.06,-7.845),(14.23,-7.845),(14.23,-8.015),(14.06,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-8.015),(14.57,-7.845),(14.74,-7.845),(14.74,-8.015),(14.57,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-8.015),(15.08,-7.845),(15.25,-7.845),(15.25,-8.015),(15.08,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-8.015),(15.59,-7.845),(15.76,-7.845),(15.76,-8.015),(15.59,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-8.015),(16.1,-7.845),(16.27,-7.845),(16.27,-8.015),(16.1,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-8.015),(16.61,-7.845),(16.78,-7.845),(16.78,-8.015),(16.61,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-8.015),(17.12,-7.845),(17.29,-7.845),(17.29,-8.015),(17.12,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-8.015),(17.63,-7.845),(17.8,-7.845),(17.8,-8.015),(17.63,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-8.015),(18.14,-7.845),(18.31,-7.845),(18.31,-8.015),(18.14,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-8.015),(18.65,-7.845),(18.82,-7.845),(18.82,-8.015),(18.65,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-8.015),(19.16,-7.845),(19.33,-7.845),(19.33,-8.015),(19.16,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-8.015),(19.67,-7.845),(19.84,-7.845),(19.84,-8.015),(19.67,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-8.015),(20.18,-7.845),(20.35,-7.845),(20.35,-8.015),(20.18,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-8.015),(20.69,-7.845),(20.86,-7.845),(20.86,-8.015),(20.69,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-8.015),(21.2,-7.845),(21.37,-7.845),(21.37,-8.015),(21.2,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-8.015),(21.71,-7.845),(21.88,-7.845),(21.88,-8.015),(21.71,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-8.015),(22.22,-7.845),(22.39,-7.845),(22.39,-8.015),(22.22,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-8.015),(22.73,-7.845),(22.9,-7.845),(22.9,-8.015),(22.73,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-8.015),(23.24,-7.845),(23.41,-7.845),(23.41,-8.015),(23.24,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-8.015),(23.75,-7.845),(23.92,-7.845),(23.92,-8.015),(23.75,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-8.015),(24.26,-7.845),(24.43,-7.845),(24.43,-8.015),(24.26,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-8.015),(24.77,-7.845),(24.94,-7.845),(24.94,-8.015),(24.77,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-8.015),(25.28,-7.845),(25.45,-7.845),(25.45,-8.015),(25.28,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-8.015),(25.79,-7.845),(25.96,-7.845),(25.96,-8.015),(25.79,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-8.015),(26.3,-7.845),(26.47,-7.845),(26.47,-8.015),(26.3,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-8.015),(26.81,-7.845),(26.98,-7.845),(26.98,-8.015),(26.81,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-8.015),(27.32,-7.845),(27.49,-7.845),(27.49,-8.015),(27.32,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-8.015),(27.83,-7.845),(28.0,-7.845),(28.0,-8.015),(27.83,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-8.015),(28.34,-7.845),(28.51,-7.845),(28.51,-8.015),(28.34,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-8.015),(28.85,-7.845),(29.02,-7.845),(29.02,-8.015),(28.85,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-8.015),(29.36,-7.845),(29.53,-7.845),(29.53,-8.015),(29.36,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-8.015),(29.87,-7.845),(30.04,-7.845),(30.04,-8.015),(29.87,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-8.015),(30.38,-7.845),(30.55,-7.845),(30.55,-8.015),(30.38,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-8.015),(30.89,-7.845),(31.06,-7.845),(31.06,-8.015),(30.89,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-8.015),(31.4,-7.845),(31.57,-7.845),(31.57,-8.015),(31.4,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-8.015),(31.91,-7.845),(32.08,-7.845),(32.08,-8.015),(31.91,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-8.015),(32.42,-7.845),(32.59,-7.845),(32.59,-8.015),(32.42,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-8.015),(32.93,-7.845),(33.1,-7.845),(33.1,-8.015),(32.93,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-8.015),(33.44,-7.845),(33.61,-7.845),(33.61,-8.015),(33.44,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-8.015),(33.95,-7.845),(34.12,-7.845),(34.12,-8.015),(33.95,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-8.015),(34.46,-7.845),(34.63,-7.845),(34.63,-8.015),(34.46,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-8.015),(34.97,-7.845),(35.14,-7.845),(35.14,-8.015),(34.97,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-8.015),(35.48,-7.845),(35.65,-7.845),(35.65,-8.015),(35.48,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-8.015),(35.99,-7.845),(36.16,-7.845),(36.16,-8.015),(35.99,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-8.015),(36.5,-7.845),(36.67,-7.845),(36.67,-8.015),(36.5,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-8.015),(37.01,-7.845),(37.18,-7.845),(37.18,-8.015),(37.01,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-8.015),(37.52,-7.845),(37.69,-7.845),(37.69,-8.015),(37.52,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-8.015),(38.03,-7.845),(38.2,-7.845),(38.2,-8.015),(38.03,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-8.015),(38.54,-7.845),(38.71,-7.845),(38.71,-8.015),(38.54,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-8.015),(39.05,-7.845),(39.22,-7.845),(39.22,-8.015),(39.05,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-8.015),(39.56,-7.845),(39.73,-7.845),(39.73,-8.015),(39.56,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-8.015),(40.07,-7.845),(40.24,-7.845),(40.24,-8.015),(40.07,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-8.015),(40.58,-7.845),(40.75,-7.845),(40.75,-8.015),(40.58,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-8.015),(41.09,-7.845),(41.26,-7.845),(41.26,-8.015),(41.09,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-8.015),(41.6,-7.845),(41.77,-7.845),(41.77,-8.015),(41.6,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-8.015),(42.11,-7.845),(42.28,-7.845),(42.28,-8.015),(42.11,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-8.015),(42.62,-7.845),(42.79,-7.845),(42.79,-8.015),(42.62,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-8.015),(43.13,-7.845),(43.3,-7.845),(43.3,-8.015),(43.13,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-8.015),(43.64,-7.845),(43.81,-7.845),(43.81,-8.015),(43.64,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-8.015),(44.15,-7.845),(44.32,-7.845),(44.32,-8.015),(44.15,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-8.015),(44.66,-7.845),(44.83,-7.845),(44.83,-8.015),(44.66,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-8.015),(45.17,-7.845),(45.34,-7.845),(45.34,-8.015),(45.17,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-8.015),(45.68,-7.845),(45.85,-7.845),(45.85,-8.015),(45.68,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-8.015),(46.19,-7.845),(46.36,-7.845),(46.36,-8.015),(46.19,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-8.015),(46.7,-7.845),(46.87,-7.845),(46.87,-8.015),(46.7,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-8.015),(47.21,-7.845),(47.38,-7.845),(47.38,-8.015),(47.21,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-8.015),(47.72,-7.845),(47.89,-7.845),(47.89,-8.015),(47.72,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-8.015),(48.23,-7.845),(48.4,-7.845),(48.4,-8.015),(48.23,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-8.015),(48.74,-7.845),(48.91,-7.845),(48.91,-8.015),(48.74,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-8.015),(49.25,-7.845),(49.42,-7.845),(49.42,-8.015),(49.25,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-8.015),(49.76,-7.845),(49.93,-7.845),(49.93,-8.015),(49.76,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-8.015),(50.27,-7.845),(50.44,-7.845),(50.44,-8.015),(50.27,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-8.015),(50.78,-7.845),(50.95,-7.845),(50.95,-8.015),(50.78,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-8.015),(51.29,-7.845),(51.46,-7.845),(51.46,-8.015),(51.29,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-8.015),(51.8,-7.845),(51.97,-7.845),(51.97,-8.015),(51.8,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-8.015),(52.31,-7.845),(52.48,-7.845),(52.48,-8.015),(52.31,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-8.015),(52.82,-7.845),(52.99,-7.845),(52.99,-8.015),(52.82,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-8.015),(53.33,-7.845),(53.5,-7.845),(53.5,-8.015),(53.33,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-8.015),(53.84,-7.845),(54.01,-7.845),(54.01,-8.015),(53.84,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-8.015),(54.35,-7.845),(54.52,-7.845),(54.52,-8.015),(54.35,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-8.015),(54.86,-7.845),(55.03,-7.845),(55.03,-8.015),(54.86,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-8.015),(55.37,-7.845),(55.54,-7.845),(55.54,-8.015),(55.37,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-8.015),(55.88,-7.845),(56.05,-7.845),(56.05,-8.015),(55.88,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-8.015),(56.39,-7.845),(56.56,-7.845),(56.56,-8.015),(56.39,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-8.015),(56.9,-7.845),(57.07,-7.845),(57.07,-8.015),(56.9,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-8.015),(57.41,-7.845),(57.58,-7.845),(57.58,-8.015),(57.41,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-8.015),(57.92,-7.845),(58.09,-7.845),(58.09,-8.015),(57.92,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-8.015),(58.43,-7.845),(58.6,-7.845),(58.6,-8.015),(58.43,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-8.015),(58.94,-7.845),(59.11,-7.845),(59.11,-8.015),(58.94,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-8.015),(59.45,-7.845),(59.62,-7.845),(59.62,-8.015),(59.45,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-8.015),(59.96,-7.845),(60.13,-7.845),(60.13,-8.015),(59.96,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-8.015),(60.47,-7.845),(60.64,-7.845),(60.64,-8.015),(60.47,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-8.015),(60.98,-7.845),(61.15,-7.845),(61.15,-8.015),(60.98,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-8.015),(61.49,-7.845),(61.66,-7.845),(61.66,-8.015),(61.49,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-8.015),(62.0,-7.845),(62.17,-7.845),(62.17,-8.015),(62.0,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-8.015),(62.51,-7.845),(62.68,-7.845),(62.68,-8.015),(62.51,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-8.015),(63.02,-7.845),(63.19,-7.845),(63.19,-8.015),(63.02,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-8.015),(63.53,-7.845),(63.7,-7.845),(63.7,-8.015),(63.53,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-8.015),(64.04,-7.845),(64.21,-7.845),(64.21,-8.015),(64.04,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-8.015),(64.55,-7.845),(64.72,-7.845),(64.72,-8.015),(64.55,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-8.015),(65.06,-7.845),(65.23,-7.845),(65.23,-8.015),(65.06,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-8.015),(65.57,-7.845),(65.74,-7.845),(65.74,-8.015),(65.57,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-8.015),(66.08,-7.845),(66.25,-7.845),(66.25,-8.015),(66.08,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-8.015),(66.59,-7.845),(66.76,-7.845),(66.76,-8.015),(66.59,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-8.015),(67.1,-7.845),(67.27,-7.845),(67.27,-8.015),(67.1,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-8.015),(67.61,-7.845),(67.78,-7.845),(67.78,-8.015),(67.61,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-8.015),(68.12,-7.845),(68.29,-7.845),(68.29,-8.015),(68.12,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-8.015),(68.63,-7.845),(68.8,-7.845),(68.8,-8.015),(68.63,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-8.015),(69.14,-7.845),(69.31,-7.845),(69.31,-8.015),(69.14,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-8.015),(69.65,-7.845),(69.82,-7.845),(69.82,-8.015),(69.65,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-8.015),(70.16,-7.845),(70.33,-7.845),(70.33,-8.015),(70.16,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-8.015),(70.67,-7.845),(70.84,-7.845),(70.84,-8.015),(70.67,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-8.015),(71.18,-7.845),(71.35,-7.845),(71.35,-8.015),(71.18,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-8.015),(71.69,-7.845),(71.86,-7.845),(71.86,-8.015),(71.69,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-8.015),(72.2,-7.845),(72.37,-7.845),(72.37,-8.015),(72.2,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-8.015),(72.71,-7.845),(72.88,-7.845),(72.88,-8.015),(72.71,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-8.015),(73.22,-7.845),(73.39,-7.845),(73.39,-8.015),(73.22,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-8.015),(73.73,-7.845),(73.9,-7.845),(73.9,-8.015),(73.73,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-8.015),(74.24,-7.845),(74.41,-7.845),(74.41,-8.015),(74.24,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-8.015),(74.75,-7.845),(74.92,-7.845),(74.92,-8.015),(74.75,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-8.015),(75.26,-7.845),(75.43,-7.845),(75.43,-8.015),(75.26,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-8.015),(75.77,-7.845),(75.94,-7.845),(75.94,-8.015),(75.77,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-8.015),(76.28,-7.845),(76.45,-7.845),(76.45,-8.015),(76.28,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-8.015),(76.79,-7.845),(76.96,-7.845),(76.96,-8.015),(76.79,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-8.015),(77.3,-7.845),(77.47,-7.845),(77.47,-8.015),(77.3,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-8.015),(77.81,-7.845),(77.98,-7.845),(77.98,-8.015),(77.81,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-8.015),(78.32,-7.845),(78.49,-7.845),(78.49,-8.015),(78.32,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-8.015),(78.83,-7.845),(79.0,-7.845),(79.0,-8.015),(78.83,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-8.015),(79.34,-7.845),(79.51,-7.845),(79.51,-8.015),(79.34,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-8.015),(79.85,-7.845),(80.02,-7.845),(80.02,-8.015),(79.85,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-8.015),(80.36,-7.845),(80.53,-7.845),(80.53,-8.015),(80.36,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-8.015),(80.87,-7.845),(81.04,-7.845),(81.04,-8.015),(80.87,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-8.015),(81.38,-7.845),(81.55,-7.845),(81.55,-8.015),(81.38,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-8.015),(81.89,-7.845),(82.06,-7.845),(82.06,-8.015),(81.89,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-8.015),(82.4,-7.845),(82.57,-7.845),(82.57,-8.015),(82.4,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-8.015),(82.91,-7.845),(83.08,-7.845),(83.08,-8.015),(82.91,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-8.015),(83.42,-7.845),(83.59,-7.845),(83.59,-8.015),(83.42,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-8.015),(83.93,-7.845),(84.1,-7.845),(84.1,-8.015),(83.93,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-8.015),(84.44,-7.845),(84.61,-7.845),(84.61,-8.015),(84.44,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-8.015),(84.95,-7.845),(85.12,-7.845),(85.12,-8.015),(84.95,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-8.015),(85.46,-7.845),(85.63,-7.845),(85.63,-8.015),(85.46,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-8.015),(85.97,-7.845),(86.14,-7.845),(86.14,-8.015),(85.97,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-8.015),(86.48,-7.845),(86.65,-7.845),(86.65,-8.015),(86.48,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-8.015),(86.99,-7.845),(87.16,-7.845),(87.16,-8.015),(86.99,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-8.015),(87.5,-7.845),(87.67,-7.845),(87.67,-8.015),(87.5,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-8.015),(88.01,-7.845),(88.18,-7.845),(88.18,-8.015),(88.01,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-8.015),(88.52,-7.845),(88.69,-7.845),(88.69,-8.015),(88.52,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-8.015),(89.03,-7.845),(89.2,-7.845),(89.2,-8.015),(89.03,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-8.015),(89.54,-7.845),(89.71,-7.845),(89.71,-8.015),(89.54,-8.015)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-7.505),(0.29,-7.335),(0.46,-7.335),(0.46,-7.505),(0.29,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-7.505),(0.8,-7.335),(0.97,-7.335),(0.97,-7.505),(0.8,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-7.505),(1.31,-7.335),(1.48,-7.335),(1.48,-7.505),(1.31,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-7.505),(1.82,-7.335),(1.99,-7.335),(1.99,-7.505),(1.82,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-7.505),(2.33,-7.335),(2.5,-7.335),(2.5,-7.505),(2.33,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-7.505),(2.84,-7.335),(3.01,-7.335),(3.01,-7.505),(2.84,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-7.505),(3.35,-7.335),(3.52,-7.335),(3.52,-7.505),(3.35,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-7.505),(3.86,-7.335),(4.03,-7.335),(4.03,-7.505),(3.86,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-7.505),(4.37,-7.335),(4.54,-7.335),(4.54,-7.505),(4.37,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-7.505),(4.88,-7.335),(5.05,-7.335),(5.05,-7.505),(4.88,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-7.505),(5.39,-7.335),(5.56,-7.335),(5.56,-7.505),(5.39,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-7.505),(5.9,-7.335),(6.07,-7.335),(6.07,-7.505),(5.9,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-7.505),(6.41,-7.335),(6.58,-7.335),(6.58,-7.505),(6.41,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-7.505),(6.92,-7.335),(7.09,-7.335),(7.09,-7.505),(6.92,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-7.505),(7.43,-7.335),(7.6,-7.335),(7.6,-7.505),(7.43,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-7.505),(7.94,-7.335),(8.11,-7.335),(8.11,-7.505),(7.94,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-7.505),(8.45,-7.335),(8.62,-7.335),(8.62,-7.505),(8.45,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-7.505),(8.96,-7.335),(9.13,-7.335),(9.13,-7.505),(8.96,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-7.505),(9.47,-7.335),(9.64,-7.335),(9.64,-7.505),(9.47,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-7.505),(9.98,-7.335),(10.15,-7.335),(10.15,-7.505),(9.98,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-7.505),(10.49,-7.335),(10.66,-7.335),(10.66,-7.505),(10.49,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-7.505),(11.0,-7.335),(11.17,-7.335),(11.17,-7.505),(11.0,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-7.505),(11.51,-7.335),(11.68,-7.335),(11.68,-7.505),(11.51,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-7.505),(12.02,-7.335),(12.19,-7.335),(12.19,-7.505),(12.02,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-7.505),(12.53,-7.335),(12.7,-7.335),(12.7,-7.505),(12.53,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-7.505),(13.04,-7.335),(13.21,-7.335),(13.21,-7.505),(13.04,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-7.505),(13.55,-7.335),(13.72,-7.335),(13.72,-7.505),(13.55,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-7.505),(14.06,-7.335),(14.23,-7.335),(14.23,-7.505),(14.06,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-7.505),(14.57,-7.335),(14.74,-7.335),(14.74,-7.505),(14.57,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-7.505),(15.08,-7.335),(15.25,-7.335),(15.25,-7.505),(15.08,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-7.505),(15.59,-7.335),(15.76,-7.335),(15.76,-7.505),(15.59,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-7.505),(16.1,-7.335),(16.27,-7.335),(16.27,-7.505),(16.1,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-7.505),(16.61,-7.335),(16.78,-7.335),(16.78,-7.505),(16.61,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-7.505),(17.12,-7.335),(17.29,-7.335),(17.29,-7.505),(17.12,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-7.505),(17.63,-7.335),(17.8,-7.335),(17.8,-7.505),(17.63,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-7.505),(18.14,-7.335),(18.31,-7.335),(18.31,-7.505),(18.14,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-7.505),(18.65,-7.335),(18.82,-7.335),(18.82,-7.505),(18.65,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-7.505),(19.16,-7.335),(19.33,-7.335),(19.33,-7.505),(19.16,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-7.505),(19.67,-7.335),(19.84,-7.335),(19.84,-7.505),(19.67,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-7.505),(20.18,-7.335),(20.35,-7.335),(20.35,-7.505),(20.18,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-7.505),(20.69,-7.335),(20.86,-7.335),(20.86,-7.505),(20.69,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-7.505),(21.2,-7.335),(21.37,-7.335),(21.37,-7.505),(21.2,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-7.505),(21.71,-7.335),(21.88,-7.335),(21.88,-7.505),(21.71,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-7.505),(22.22,-7.335),(22.39,-7.335),(22.39,-7.505),(22.22,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-7.505),(22.73,-7.335),(22.9,-7.335),(22.9,-7.505),(22.73,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-7.505),(23.24,-7.335),(23.41,-7.335),(23.41,-7.505),(23.24,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-7.505),(23.75,-7.335),(23.92,-7.335),(23.92,-7.505),(23.75,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-7.505),(24.26,-7.335),(24.43,-7.335),(24.43,-7.505),(24.26,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-7.505),(24.77,-7.335),(24.94,-7.335),(24.94,-7.505),(24.77,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-7.505),(25.28,-7.335),(25.45,-7.335),(25.45,-7.505),(25.28,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-7.505),(25.79,-7.335),(25.96,-7.335),(25.96,-7.505),(25.79,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-7.505),(26.3,-7.335),(26.47,-7.335),(26.47,-7.505),(26.3,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-7.505),(26.81,-7.335),(26.98,-7.335),(26.98,-7.505),(26.81,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-7.505),(27.32,-7.335),(27.49,-7.335),(27.49,-7.505),(27.32,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-7.505),(27.83,-7.335),(28.0,-7.335),(28.0,-7.505),(27.83,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-7.505),(28.34,-7.335),(28.51,-7.335),(28.51,-7.505),(28.34,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-7.505),(28.85,-7.335),(29.02,-7.335),(29.02,-7.505),(28.85,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-7.505),(29.36,-7.335),(29.53,-7.335),(29.53,-7.505),(29.36,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-7.505),(29.87,-7.335),(30.04,-7.335),(30.04,-7.505),(29.87,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-7.505),(30.38,-7.335),(30.55,-7.335),(30.55,-7.505),(30.38,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-7.505),(30.89,-7.335),(31.06,-7.335),(31.06,-7.505),(30.89,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-7.505),(31.4,-7.335),(31.57,-7.335),(31.57,-7.505),(31.4,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-7.505),(31.91,-7.335),(32.08,-7.335),(32.08,-7.505),(31.91,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-7.505),(32.42,-7.335),(32.59,-7.335),(32.59,-7.505),(32.42,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-7.505),(32.93,-7.335),(33.1,-7.335),(33.1,-7.505),(32.93,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-7.505),(33.44,-7.335),(33.61,-7.335),(33.61,-7.505),(33.44,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-7.505),(33.95,-7.335),(34.12,-7.335),(34.12,-7.505),(33.95,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-7.505),(34.46,-7.335),(34.63,-7.335),(34.63,-7.505),(34.46,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-7.505),(34.97,-7.335),(35.14,-7.335),(35.14,-7.505),(34.97,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-7.505),(35.48,-7.335),(35.65,-7.335),(35.65,-7.505),(35.48,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-7.505),(35.99,-7.335),(36.16,-7.335),(36.16,-7.505),(35.99,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-7.505),(36.5,-7.335),(36.67,-7.335),(36.67,-7.505),(36.5,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-7.505),(37.01,-7.335),(37.18,-7.335),(37.18,-7.505),(37.01,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-7.505),(37.52,-7.335),(37.69,-7.335),(37.69,-7.505),(37.52,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-7.505),(38.03,-7.335),(38.2,-7.335),(38.2,-7.505),(38.03,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-7.505),(38.54,-7.335),(38.71,-7.335),(38.71,-7.505),(38.54,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-7.505),(39.05,-7.335),(39.22,-7.335),(39.22,-7.505),(39.05,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-7.505),(39.56,-7.335),(39.73,-7.335),(39.73,-7.505),(39.56,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-7.505),(40.07,-7.335),(40.24,-7.335),(40.24,-7.505),(40.07,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-7.505),(40.58,-7.335),(40.75,-7.335),(40.75,-7.505),(40.58,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-7.505),(41.09,-7.335),(41.26,-7.335),(41.26,-7.505),(41.09,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-7.505),(41.6,-7.335),(41.77,-7.335),(41.77,-7.505),(41.6,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-7.505),(42.11,-7.335),(42.28,-7.335),(42.28,-7.505),(42.11,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-7.505),(42.62,-7.335),(42.79,-7.335),(42.79,-7.505),(42.62,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-7.505),(43.13,-7.335),(43.3,-7.335),(43.3,-7.505),(43.13,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-7.505),(43.64,-7.335),(43.81,-7.335),(43.81,-7.505),(43.64,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-7.505),(44.15,-7.335),(44.32,-7.335),(44.32,-7.505),(44.15,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-7.505),(44.66,-7.335),(44.83,-7.335),(44.83,-7.505),(44.66,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-7.505),(45.17,-7.335),(45.34,-7.335),(45.34,-7.505),(45.17,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-7.505),(45.68,-7.335),(45.85,-7.335),(45.85,-7.505),(45.68,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-7.505),(46.19,-7.335),(46.36,-7.335),(46.36,-7.505),(46.19,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-7.505),(46.7,-7.335),(46.87,-7.335),(46.87,-7.505),(46.7,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-7.505),(47.21,-7.335),(47.38,-7.335),(47.38,-7.505),(47.21,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-7.505),(47.72,-7.335),(47.89,-7.335),(47.89,-7.505),(47.72,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-7.505),(48.23,-7.335),(48.4,-7.335),(48.4,-7.505),(48.23,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-7.505),(48.74,-7.335),(48.91,-7.335),(48.91,-7.505),(48.74,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-7.505),(49.25,-7.335),(49.42,-7.335),(49.42,-7.505),(49.25,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-7.505),(49.76,-7.335),(49.93,-7.335),(49.93,-7.505),(49.76,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-7.505),(50.27,-7.335),(50.44,-7.335),(50.44,-7.505),(50.27,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-7.505),(50.78,-7.335),(50.95,-7.335),(50.95,-7.505),(50.78,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-7.505),(51.29,-7.335),(51.46,-7.335),(51.46,-7.505),(51.29,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-7.505),(51.8,-7.335),(51.97,-7.335),(51.97,-7.505),(51.8,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-7.505),(52.31,-7.335),(52.48,-7.335),(52.48,-7.505),(52.31,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-7.505),(52.82,-7.335),(52.99,-7.335),(52.99,-7.505),(52.82,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-7.505),(53.33,-7.335),(53.5,-7.335),(53.5,-7.505),(53.33,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-7.505),(53.84,-7.335),(54.01,-7.335),(54.01,-7.505),(53.84,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-7.505),(54.35,-7.335),(54.52,-7.335),(54.52,-7.505),(54.35,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-7.505),(54.86,-7.335),(55.03,-7.335),(55.03,-7.505),(54.86,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-7.505),(55.37,-7.335),(55.54,-7.335),(55.54,-7.505),(55.37,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-7.505),(55.88,-7.335),(56.05,-7.335),(56.05,-7.505),(55.88,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-7.505),(56.39,-7.335),(56.56,-7.335),(56.56,-7.505),(56.39,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-7.505),(56.9,-7.335),(57.07,-7.335),(57.07,-7.505),(56.9,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-7.505),(57.41,-7.335),(57.58,-7.335),(57.58,-7.505),(57.41,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-7.505),(57.92,-7.335),(58.09,-7.335),(58.09,-7.505),(57.92,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-7.505),(58.43,-7.335),(58.6,-7.335),(58.6,-7.505),(58.43,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-7.505),(58.94,-7.335),(59.11,-7.335),(59.11,-7.505),(58.94,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-7.505),(59.45,-7.335),(59.62,-7.335),(59.62,-7.505),(59.45,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-7.505),(59.96,-7.335),(60.13,-7.335),(60.13,-7.505),(59.96,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-7.505),(60.47,-7.335),(60.64,-7.335),(60.64,-7.505),(60.47,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-7.505),(60.98,-7.335),(61.15,-7.335),(61.15,-7.505),(60.98,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-7.505),(61.49,-7.335),(61.66,-7.335),(61.66,-7.505),(61.49,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-7.505),(62.0,-7.335),(62.17,-7.335),(62.17,-7.505),(62.0,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-7.505),(62.51,-7.335),(62.68,-7.335),(62.68,-7.505),(62.51,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-7.505),(63.02,-7.335),(63.19,-7.335),(63.19,-7.505),(63.02,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-7.505),(63.53,-7.335),(63.7,-7.335),(63.7,-7.505),(63.53,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-7.505),(64.04,-7.335),(64.21,-7.335),(64.21,-7.505),(64.04,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-7.505),(64.55,-7.335),(64.72,-7.335),(64.72,-7.505),(64.55,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-7.505),(65.06,-7.335),(65.23,-7.335),(65.23,-7.505),(65.06,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-7.505),(65.57,-7.335),(65.74,-7.335),(65.74,-7.505),(65.57,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-7.505),(66.08,-7.335),(66.25,-7.335),(66.25,-7.505),(66.08,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-7.505),(66.59,-7.335),(66.76,-7.335),(66.76,-7.505),(66.59,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-7.505),(67.1,-7.335),(67.27,-7.335),(67.27,-7.505),(67.1,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-7.505),(67.61,-7.335),(67.78,-7.335),(67.78,-7.505),(67.61,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-7.505),(68.12,-7.335),(68.29,-7.335),(68.29,-7.505),(68.12,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-7.505),(68.63,-7.335),(68.8,-7.335),(68.8,-7.505),(68.63,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-7.505),(69.14,-7.335),(69.31,-7.335),(69.31,-7.505),(69.14,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-7.505),(69.65,-7.335),(69.82,-7.335),(69.82,-7.505),(69.65,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-7.505),(70.16,-7.335),(70.33,-7.335),(70.33,-7.505),(70.16,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-7.505),(70.67,-7.335),(70.84,-7.335),(70.84,-7.505),(70.67,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-7.505),(71.18,-7.335),(71.35,-7.335),(71.35,-7.505),(71.18,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-7.505),(71.69,-7.335),(71.86,-7.335),(71.86,-7.505),(71.69,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-7.505),(72.2,-7.335),(72.37,-7.335),(72.37,-7.505),(72.2,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-7.505),(72.71,-7.335),(72.88,-7.335),(72.88,-7.505),(72.71,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-7.505),(73.22,-7.335),(73.39,-7.335),(73.39,-7.505),(73.22,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-7.505),(73.73,-7.335),(73.9,-7.335),(73.9,-7.505),(73.73,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-7.505),(74.24,-7.335),(74.41,-7.335),(74.41,-7.505),(74.24,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-7.505),(74.75,-7.335),(74.92,-7.335),(74.92,-7.505),(74.75,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-7.505),(75.26,-7.335),(75.43,-7.335),(75.43,-7.505),(75.26,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-7.505),(75.77,-7.335),(75.94,-7.335),(75.94,-7.505),(75.77,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-7.505),(76.28,-7.335),(76.45,-7.335),(76.45,-7.505),(76.28,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-7.505),(76.79,-7.335),(76.96,-7.335),(76.96,-7.505),(76.79,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-7.505),(77.3,-7.335),(77.47,-7.335),(77.47,-7.505),(77.3,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-7.505),(77.81,-7.335),(77.98,-7.335),(77.98,-7.505),(77.81,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-7.505),(78.32,-7.335),(78.49,-7.335),(78.49,-7.505),(78.32,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-7.505),(78.83,-7.335),(79.0,-7.335),(79.0,-7.505),(78.83,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-7.505),(79.34,-7.335),(79.51,-7.335),(79.51,-7.505),(79.34,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-7.505),(79.85,-7.335),(80.02,-7.335),(80.02,-7.505),(79.85,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-7.505),(80.36,-7.335),(80.53,-7.335),(80.53,-7.505),(80.36,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-7.505),(80.87,-7.335),(81.04,-7.335),(81.04,-7.505),(80.87,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-7.505),(81.38,-7.335),(81.55,-7.335),(81.55,-7.505),(81.38,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-7.505),(81.89,-7.335),(82.06,-7.335),(82.06,-7.505),(81.89,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-7.505),(82.4,-7.335),(82.57,-7.335),(82.57,-7.505),(82.4,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-7.505),(82.91,-7.335),(83.08,-7.335),(83.08,-7.505),(82.91,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-7.505),(83.42,-7.335),(83.59,-7.335),(83.59,-7.505),(83.42,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-7.505),(83.93,-7.335),(84.1,-7.335),(84.1,-7.505),(83.93,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-7.505),(84.44,-7.335),(84.61,-7.335),(84.61,-7.505),(84.44,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-7.505),(84.95,-7.335),(85.12,-7.335),(85.12,-7.505),(84.95,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-7.505),(85.46,-7.335),(85.63,-7.335),(85.63,-7.505),(85.46,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-7.505),(85.97,-7.335),(86.14,-7.335),(86.14,-7.505),(85.97,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-7.505),(86.48,-7.335),(86.65,-7.335),(86.65,-7.505),(86.48,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-7.505),(86.99,-7.335),(87.16,-7.335),(87.16,-7.505),(86.99,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-7.505),(87.5,-7.335),(87.67,-7.335),(87.67,-7.505),(87.5,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-7.505),(88.01,-7.335),(88.18,-7.335),(88.18,-7.505),(88.01,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-7.505),(88.52,-7.335),(88.69,-7.335),(88.69,-7.505),(88.52,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-7.505),(89.03,-7.335),(89.2,-7.335),(89.2,-7.505),(89.03,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-7.505),(89.54,-7.335),(89.71,-7.335),(89.71,-7.505),(89.54,-7.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.29,-6.995),(0.29,-6.825),(0.46,-6.825),(0.46,-6.995),(0.29,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((0.8,-6.995),(0.8,-6.825),(0.97,-6.825),(0.97,-6.995),(0.8,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((1.31,-6.995),(1.31,-6.825),(1.48,-6.825),(1.48,-6.995),(1.31,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((1.82,-6.995),(1.82,-6.825),(1.99,-6.825),(1.99,-6.995),(1.82,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((2.33,-6.995),(2.33,-6.825),(2.5,-6.825),(2.5,-6.995),(2.33,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((2.84,-6.995),(2.84,-6.825),(3.01,-6.825),(3.01,-6.995),(2.84,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((3.35,-6.995),(3.35,-6.825),(3.52,-6.825),(3.52,-6.995),(3.35,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((3.86,-6.995),(3.86,-6.825),(4.03,-6.825),(4.03,-6.995),(3.86,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((4.37,-6.995),(4.37,-6.825),(4.54,-6.825),(4.54,-6.995),(4.37,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((4.88,-6.995),(4.88,-6.825),(5.05,-6.825),(5.05,-6.995),(4.88,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((5.39,-6.995),(5.39,-6.825),(5.56,-6.825),(5.56,-6.995),(5.39,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((5.9,-6.995),(5.9,-6.825),(6.07,-6.825),(6.07,-6.995),(5.9,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((6.41,-6.995),(6.41,-6.825),(6.58,-6.825),(6.58,-6.995),(6.41,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((6.92,-6.995),(6.92,-6.825),(7.09,-6.825),(7.09,-6.995),(6.92,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((7.43,-6.995),(7.43,-6.825),(7.6,-6.825),(7.6,-6.995),(7.43,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((7.94,-6.995),(7.94,-6.825),(8.11,-6.825),(8.11,-6.995),(7.94,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((8.45,-6.995),(8.45,-6.825),(8.62,-6.825),(8.62,-6.995),(8.45,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((8.96,-6.995),(8.96,-6.825),(9.13,-6.825),(9.13,-6.995),(8.96,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((9.47,-6.995),(9.47,-6.825),(9.64,-6.825),(9.64,-6.995),(9.47,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,-6.995),(9.98,-6.825),(10.15,-6.825),(10.15,-6.995),(9.98,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((10.49,-6.995),(10.49,-6.825),(10.66,-6.825),(10.66,-6.995),(10.49,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((11.0,-6.995),(11.0,-6.825),(11.17,-6.825),(11.17,-6.995),(11.0,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((11.51,-6.995),(11.51,-6.825),(11.68,-6.825),(11.68,-6.995),(11.51,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((12.02,-6.995),(12.02,-6.825),(12.19,-6.825),(12.19,-6.995),(12.02,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((12.53,-6.995),(12.53,-6.825),(12.7,-6.825),(12.7,-6.995),(12.53,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((13.04,-6.995),(13.04,-6.825),(13.21,-6.825),(13.21,-6.995),(13.04,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((13.55,-6.995),(13.55,-6.825),(13.72,-6.825),(13.72,-6.995),(13.55,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((14.06,-6.995),(14.06,-6.825),(14.23,-6.825),(14.23,-6.995),(14.06,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((14.57,-6.995),(14.57,-6.825),(14.74,-6.825),(14.74,-6.995),(14.57,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((15.08,-6.995),(15.08,-6.825),(15.25,-6.825),(15.25,-6.995),(15.08,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((15.59,-6.995),(15.59,-6.825),(15.76,-6.825),(15.76,-6.995),(15.59,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((16.1,-6.995),(16.1,-6.825),(16.27,-6.825),(16.27,-6.995),(16.1,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((16.61,-6.995),(16.61,-6.825),(16.78,-6.825),(16.78,-6.995),(16.61,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((17.12,-6.995),(17.12,-6.825),(17.29,-6.825),(17.29,-6.995),(17.12,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((17.63,-6.995),(17.63,-6.825),(17.8,-6.825),(17.8,-6.995),(17.63,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((18.14,-6.995),(18.14,-6.825),(18.31,-6.825),(18.31,-6.995),(18.14,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((18.65,-6.995),(18.65,-6.825),(18.82,-6.825),(18.82,-6.995),(18.65,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((19.16,-6.995),(19.16,-6.825),(19.33,-6.825),(19.33,-6.995),(19.16,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((19.67,-6.995),(19.67,-6.825),(19.84,-6.825),(19.84,-6.995),(19.67,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((20.18,-6.995),(20.18,-6.825),(20.35,-6.825),(20.35,-6.995),(20.18,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((20.69,-6.995),(20.69,-6.825),(20.86,-6.825),(20.86,-6.995),(20.69,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((21.2,-6.995),(21.2,-6.825),(21.37,-6.825),(21.37,-6.995),(21.2,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((21.71,-6.995),(21.71,-6.825),(21.88,-6.825),(21.88,-6.995),(21.71,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((22.22,-6.995),(22.22,-6.825),(22.39,-6.825),(22.39,-6.995),(22.22,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((22.73,-6.995),(22.73,-6.825),(22.9,-6.825),(22.9,-6.995),(22.73,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((23.24,-6.995),(23.24,-6.825),(23.41,-6.825),(23.41,-6.995),(23.24,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((23.75,-6.995),(23.75,-6.825),(23.92,-6.825),(23.92,-6.995),(23.75,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((24.26,-6.995),(24.26,-6.825),(24.43,-6.825),(24.43,-6.995),(24.26,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((24.77,-6.995),(24.77,-6.825),(24.94,-6.825),(24.94,-6.995),(24.77,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((25.28,-6.995),(25.28,-6.825),(25.45,-6.825),(25.45,-6.995),(25.28,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((25.79,-6.995),(25.79,-6.825),(25.96,-6.825),(25.96,-6.995),(25.79,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((26.3,-6.995),(26.3,-6.825),(26.47,-6.825),(26.47,-6.995),(26.3,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((26.81,-6.995),(26.81,-6.825),(26.98,-6.825),(26.98,-6.995),(26.81,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((27.32,-6.995),(27.32,-6.825),(27.49,-6.825),(27.49,-6.995),(27.32,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((27.83,-6.995),(27.83,-6.825),(28.0,-6.825),(28.0,-6.995),(27.83,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((28.34,-6.995),(28.34,-6.825),(28.51,-6.825),(28.51,-6.995),(28.34,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((28.85,-6.995),(28.85,-6.825),(29.02,-6.825),(29.02,-6.995),(28.85,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((29.36,-6.995),(29.36,-6.825),(29.53,-6.825),(29.53,-6.995),(29.36,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((29.87,-6.995),(29.87,-6.825),(30.04,-6.825),(30.04,-6.995),(29.87,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((30.38,-6.995),(30.38,-6.825),(30.55,-6.825),(30.55,-6.995),(30.38,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((30.89,-6.995),(30.89,-6.825),(31.06,-6.825),(31.06,-6.995),(30.89,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((31.4,-6.995),(31.4,-6.825),(31.57,-6.825),(31.57,-6.995),(31.4,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((31.91,-6.995),(31.91,-6.825),(32.08,-6.825),(32.08,-6.995),(31.91,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((32.42,-6.995),(32.42,-6.825),(32.59,-6.825),(32.59,-6.995),(32.42,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((32.93,-6.995),(32.93,-6.825),(33.1,-6.825),(33.1,-6.995),(32.93,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((33.44,-6.995),(33.44,-6.825),(33.61,-6.825),(33.61,-6.995),(33.44,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((33.95,-6.995),(33.95,-6.825),(34.12,-6.825),(34.12,-6.995),(33.95,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((34.46,-6.995),(34.46,-6.825),(34.63,-6.825),(34.63,-6.995),(34.46,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((34.97,-6.995),(34.97,-6.825),(35.14,-6.825),(35.14,-6.995),(34.97,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((35.48,-6.995),(35.48,-6.825),(35.65,-6.825),(35.65,-6.995),(35.48,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((35.99,-6.995),(35.99,-6.825),(36.16,-6.825),(36.16,-6.995),(35.99,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((36.5,-6.995),(36.5,-6.825),(36.67,-6.825),(36.67,-6.995),(36.5,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((37.01,-6.995),(37.01,-6.825),(37.18,-6.825),(37.18,-6.995),(37.01,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((37.52,-6.995),(37.52,-6.825),(37.69,-6.825),(37.69,-6.995),(37.52,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((38.03,-6.995),(38.03,-6.825),(38.2,-6.825),(38.2,-6.995),(38.03,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((38.54,-6.995),(38.54,-6.825),(38.71,-6.825),(38.71,-6.995),(38.54,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((39.05,-6.995),(39.05,-6.825),(39.22,-6.825),(39.22,-6.995),(39.05,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((39.56,-6.995),(39.56,-6.825),(39.73,-6.825),(39.73,-6.995),(39.56,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((40.07,-6.995),(40.07,-6.825),(40.24,-6.825),(40.24,-6.995),(40.07,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((40.58,-6.995),(40.58,-6.825),(40.75,-6.825),(40.75,-6.995),(40.58,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((41.09,-6.995),(41.09,-6.825),(41.26,-6.825),(41.26,-6.995),(41.09,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((41.6,-6.995),(41.6,-6.825),(41.77,-6.825),(41.77,-6.995),(41.6,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((42.11,-6.995),(42.11,-6.825),(42.28,-6.825),(42.28,-6.995),(42.11,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((42.62,-6.995),(42.62,-6.825),(42.79,-6.825),(42.79,-6.995),(42.62,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((43.13,-6.995),(43.13,-6.825),(43.3,-6.825),(43.3,-6.995),(43.13,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((43.64,-6.995),(43.64,-6.825),(43.81,-6.825),(43.81,-6.995),(43.64,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((44.15,-6.995),(44.15,-6.825),(44.32,-6.825),(44.32,-6.995),(44.15,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((44.66,-6.995),(44.66,-6.825),(44.83,-6.825),(44.83,-6.995),(44.66,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((45.17,-6.995),(45.17,-6.825),(45.34,-6.825),(45.34,-6.995),(45.17,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((45.68,-6.995),(45.68,-6.825),(45.85,-6.825),(45.85,-6.995),(45.68,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((46.19,-6.995),(46.19,-6.825),(46.36,-6.825),(46.36,-6.995),(46.19,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((46.7,-6.995),(46.7,-6.825),(46.87,-6.825),(46.87,-6.995),(46.7,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((47.21,-6.995),(47.21,-6.825),(47.38,-6.825),(47.38,-6.995),(47.21,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((47.72,-6.995),(47.72,-6.825),(47.89,-6.825),(47.89,-6.995),(47.72,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((48.23,-6.995),(48.23,-6.825),(48.4,-6.825),(48.4,-6.995),(48.23,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((48.74,-6.995),(48.74,-6.825),(48.91,-6.825),(48.91,-6.995),(48.74,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((49.25,-6.995),(49.25,-6.825),(49.42,-6.825),(49.42,-6.995),(49.25,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((49.76,-6.995),(49.76,-6.825),(49.93,-6.825),(49.93,-6.995),(49.76,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((50.27,-6.995),(50.27,-6.825),(50.44,-6.825),(50.44,-6.995),(50.27,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((50.78,-6.995),(50.78,-6.825),(50.95,-6.825),(50.95,-6.995),(50.78,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((51.29,-6.995),(51.29,-6.825),(51.46,-6.825),(51.46,-6.995),(51.29,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((51.8,-6.995),(51.8,-6.825),(51.97,-6.825),(51.97,-6.995),(51.8,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((52.31,-6.995),(52.31,-6.825),(52.48,-6.825),(52.48,-6.995),(52.31,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((52.82,-6.995),(52.82,-6.825),(52.99,-6.825),(52.99,-6.995),(52.82,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((53.33,-6.995),(53.33,-6.825),(53.5,-6.825),(53.5,-6.995),(53.33,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((53.84,-6.995),(53.84,-6.825),(54.01,-6.825),(54.01,-6.995),(53.84,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((54.35,-6.995),(54.35,-6.825),(54.52,-6.825),(54.52,-6.995),(54.35,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((54.86,-6.995),(54.86,-6.825),(55.03,-6.825),(55.03,-6.995),(54.86,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((55.37,-6.995),(55.37,-6.825),(55.54,-6.825),(55.54,-6.995),(55.37,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((55.88,-6.995),(55.88,-6.825),(56.05,-6.825),(56.05,-6.995),(55.88,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((56.39,-6.995),(56.39,-6.825),(56.56,-6.825),(56.56,-6.995),(56.39,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((56.9,-6.995),(56.9,-6.825),(57.07,-6.825),(57.07,-6.995),(56.9,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((57.41,-6.995),(57.41,-6.825),(57.58,-6.825),(57.58,-6.995),(57.41,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((57.92,-6.995),(57.92,-6.825),(58.09,-6.825),(58.09,-6.995),(57.92,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((58.43,-6.995),(58.43,-6.825),(58.6,-6.825),(58.6,-6.995),(58.43,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((58.94,-6.995),(58.94,-6.825),(59.11,-6.825),(59.11,-6.995),(58.94,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((59.45,-6.995),(59.45,-6.825),(59.62,-6.825),(59.62,-6.995),(59.45,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((59.96,-6.995),(59.96,-6.825),(60.13,-6.825),(60.13,-6.995),(59.96,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((60.47,-6.995),(60.47,-6.825),(60.64,-6.825),(60.64,-6.995),(60.47,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((60.98,-6.995),(60.98,-6.825),(61.15,-6.825),(61.15,-6.995),(60.98,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((61.49,-6.995),(61.49,-6.825),(61.66,-6.825),(61.66,-6.995),(61.49,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((62.0,-6.995),(62.0,-6.825),(62.17,-6.825),(62.17,-6.995),(62.0,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((62.51,-6.995),(62.51,-6.825),(62.68,-6.825),(62.68,-6.995),(62.51,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((63.02,-6.995),(63.02,-6.825),(63.19,-6.825),(63.19,-6.995),(63.02,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((63.53,-6.995),(63.53,-6.825),(63.7,-6.825),(63.7,-6.995),(63.53,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((64.04,-6.995),(64.04,-6.825),(64.21,-6.825),(64.21,-6.995),(64.04,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((64.55,-6.995),(64.55,-6.825),(64.72,-6.825),(64.72,-6.995),(64.55,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((65.06,-6.995),(65.06,-6.825),(65.23,-6.825),(65.23,-6.995),(65.06,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((65.57,-6.995),(65.57,-6.825),(65.74,-6.825),(65.74,-6.995),(65.57,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((66.08,-6.995),(66.08,-6.825),(66.25,-6.825),(66.25,-6.995),(66.08,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((66.59,-6.995),(66.59,-6.825),(66.76,-6.825),(66.76,-6.995),(66.59,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((67.1,-6.995),(67.1,-6.825),(67.27,-6.825),(67.27,-6.995),(67.1,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((67.61,-6.995),(67.61,-6.825),(67.78,-6.825),(67.78,-6.995),(67.61,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((68.12,-6.995),(68.12,-6.825),(68.29,-6.825),(68.29,-6.995),(68.12,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((68.63,-6.995),(68.63,-6.825),(68.8,-6.825),(68.8,-6.995),(68.63,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((69.14,-6.995),(69.14,-6.825),(69.31,-6.825),(69.31,-6.995),(69.14,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((69.65,-6.995),(69.65,-6.825),(69.82,-6.825),(69.82,-6.995),(69.65,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((70.16,-6.995),(70.16,-6.825),(70.33,-6.825),(70.33,-6.995),(70.16,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((70.67,-6.995),(70.67,-6.825),(70.84,-6.825),(70.84,-6.995),(70.67,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((71.18,-6.995),(71.18,-6.825),(71.35,-6.825),(71.35,-6.995),(71.18,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((71.69,-6.995),(71.69,-6.825),(71.86,-6.825),(71.86,-6.995),(71.69,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((72.2,-6.995),(72.2,-6.825),(72.37,-6.825),(72.37,-6.995),(72.2,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((72.71,-6.995),(72.71,-6.825),(72.88,-6.825),(72.88,-6.995),(72.71,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((73.22,-6.995),(73.22,-6.825),(73.39,-6.825),(73.39,-6.995),(73.22,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((73.73,-6.995),(73.73,-6.825),(73.9,-6.825),(73.9,-6.995),(73.73,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((74.24,-6.995),(74.24,-6.825),(74.41,-6.825),(74.41,-6.995),(74.24,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((74.75,-6.995),(74.75,-6.825),(74.92,-6.825),(74.92,-6.995),(74.75,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((75.26,-6.995),(75.26,-6.825),(75.43,-6.825),(75.43,-6.995),(75.26,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((75.77,-6.995),(75.77,-6.825),(75.94,-6.825),(75.94,-6.995),(75.77,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((76.28,-6.995),(76.28,-6.825),(76.45,-6.825),(76.45,-6.995),(76.28,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((76.79,-6.995),(76.79,-6.825),(76.96,-6.825),(76.96,-6.995),(76.79,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((77.3,-6.995),(77.3,-6.825),(77.47,-6.825),(77.47,-6.995),(77.3,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((77.81,-6.995),(77.81,-6.825),(77.98,-6.825),(77.98,-6.995),(77.81,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((78.32,-6.995),(78.32,-6.825),(78.49,-6.825),(78.49,-6.995),(78.32,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((78.83,-6.995),(78.83,-6.825),(79.0,-6.825),(79.0,-6.995),(78.83,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((79.34,-6.995),(79.34,-6.825),(79.51,-6.825),(79.51,-6.995),(79.34,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,-6.995),(79.85,-6.825),(80.02,-6.825),(80.02,-6.995),(79.85,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((80.36,-6.995),(80.36,-6.825),(80.53,-6.825),(80.53,-6.995),(80.36,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((80.87,-6.995),(80.87,-6.825),(81.04,-6.825),(81.04,-6.995),(80.87,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((81.38,-6.995),(81.38,-6.825),(81.55,-6.825),(81.55,-6.995),(81.38,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((81.89,-6.995),(81.89,-6.825),(82.06,-6.825),(82.06,-6.995),(81.89,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((82.4,-6.995),(82.4,-6.825),(82.57,-6.825),(82.57,-6.995),(82.4,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((82.91,-6.995),(82.91,-6.825),(83.08,-6.825),(83.08,-6.995),(82.91,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((83.42,-6.995),(83.42,-6.825),(83.59,-6.825),(83.59,-6.995),(83.42,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((83.93,-6.995),(83.93,-6.825),(84.1,-6.825),(84.1,-6.995),(83.93,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((84.44,-6.995),(84.44,-6.825),(84.61,-6.825),(84.61,-6.995),(84.44,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((84.95,-6.995),(84.95,-6.825),(85.12,-6.825),(85.12,-6.995),(84.95,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((85.46,-6.995),(85.46,-6.825),(85.63,-6.825),(85.63,-6.995),(85.46,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((85.97,-6.995),(85.97,-6.825),(86.14,-6.825),(86.14,-6.995),(85.97,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((86.48,-6.995),(86.48,-6.825),(86.65,-6.825),(86.65,-6.995),(86.48,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((86.99,-6.995),(86.99,-6.825),(87.16,-6.825),(87.16,-6.995),(86.99,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((87.5,-6.995),(87.5,-6.825),(87.67,-6.825),(87.67,-6.995),(87.5,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((88.01,-6.995),(88.01,-6.825),(88.18,-6.825),(88.18,-6.995),(88.01,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((88.52,-6.995),(88.52,-6.825),(88.69,-6.825),(88.69,-6.995),(88.52,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((89.03,-6.995),(89.03,-6.825),(89.2,-6.825),(89.2,-6.995),(89.03,-6.995)),
        )
        createRL(
            tech, net, 'licon',
            ((89.54,-6.995),(89.54,-6.825),(89.71,-6.825),(89.71,-6.995),(89.54,-6.995)),
        )
        createRL(
            tech, net, 'li',
            ((1.5,-21.0),(1.5,-11.0),(6.5,-11.0),(6.5,-21.0),(1.5,-21.0)),
        )
        createRL(
            tech, net, 'li',
            ((83.0,-21.0),(83.0,-11.0),(88.0,-11.0),(88.0,-21.0),(83.0,-21.0)),
        )
        createRL(
            tech, net, 'li',
            ((0.29,-29.515),(0.29,-6.745),(89.71,-6.745),(89.71,-29.515),(0.29,-29.515)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,-29.96),(0.0,-6.305),(90.0,-6.305),(90.0,-29.96),(0.0,-29.96)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(-18.1325), u(23.655), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(-18.1325), u(23.655), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'mcon',
            ((83.075,-20.945),(83.075,-20.775),(83.245,-20.775),(83.245,-20.945),(83.075,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-20.945),(83.435,-20.775),(83.605,-20.775),(83.605,-20.945),(83.435,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-20.945),(83.795,-20.775),(83.965,-20.775),(83.965,-20.945),(83.795,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-20.945),(84.155,-20.775),(84.325,-20.775),(84.325,-20.945),(84.155,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-20.945),(84.515,-20.775),(84.685,-20.775),(84.685,-20.945),(84.515,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-20.945),(84.875,-20.775),(85.045,-20.775),(85.045,-20.945),(84.875,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-20.945),(85.235,-20.775),(85.405,-20.775),(85.405,-20.945),(85.235,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-20.945),(85.595,-20.775),(85.765,-20.775),(85.765,-20.945),(85.595,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-20.945),(85.955,-20.775),(86.125,-20.775),(86.125,-20.945),(85.955,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-20.945),(86.315,-20.775),(86.485,-20.775),(86.485,-20.945),(86.315,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-20.945),(86.675,-20.775),(86.845,-20.775),(86.845,-20.945),(86.675,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-20.945),(87.035,-20.775),(87.205,-20.775),(87.205,-20.945),(87.035,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-20.945),(87.395,-20.775),(87.565,-20.775),(87.565,-20.945),(87.395,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-20.945),(87.755,-20.775),(87.925,-20.775),(87.925,-20.945),(87.755,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-20.585),(83.075,-20.415),(83.245,-20.415),(83.245,-20.585),(83.075,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-20.585),(83.435,-20.415),(83.605,-20.415),(83.605,-20.585),(83.435,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-20.585),(83.795,-20.415),(83.965,-20.415),(83.965,-20.585),(83.795,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-20.585),(84.155,-20.415),(84.325,-20.415),(84.325,-20.585),(84.155,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-20.585),(84.515,-20.415),(84.685,-20.415),(84.685,-20.585),(84.515,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-20.585),(84.875,-20.415),(85.045,-20.415),(85.045,-20.585),(84.875,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-20.585),(85.235,-20.415),(85.405,-20.415),(85.405,-20.585),(85.235,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-20.585),(85.595,-20.415),(85.765,-20.415),(85.765,-20.585),(85.595,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-20.585),(85.955,-20.415),(86.125,-20.415),(86.125,-20.585),(85.955,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-20.585),(86.315,-20.415),(86.485,-20.415),(86.485,-20.585),(86.315,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-20.585),(86.675,-20.415),(86.845,-20.415),(86.845,-20.585),(86.675,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-20.585),(87.035,-20.415),(87.205,-20.415),(87.205,-20.585),(87.035,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-20.585),(87.395,-20.415),(87.565,-20.415),(87.565,-20.585),(87.395,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-20.585),(87.755,-20.415),(87.925,-20.415),(87.925,-20.585),(87.755,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-20.225),(83.075,-20.055),(83.245,-20.055),(83.245,-20.225),(83.075,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-20.225),(83.435,-20.055),(83.605,-20.055),(83.605,-20.225),(83.435,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-20.225),(83.795,-20.055),(83.965,-20.055),(83.965,-20.225),(83.795,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-20.225),(84.155,-20.055),(84.325,-20.055),(84.325,-20.225),(84.155,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-20.225),(84.515,-20.055),(84.685,-20.055),(84.685,-20.225),(84.515,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-20.225),(84.875,-20.055),(85.045,-20.055),(85.045,-20.225),(84.875,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-20.225),(85.235,-20.055),(85.405,-20.055),(85.405,-20.225),(85.235,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-20.225),(85.595,-20.055),(85.765,-20.055),(85.765,-20.225),(85.595,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-20.225),(85.955,-20.055),(86.125,-20.055),(86.125,-20.225),(85.955,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-20.225),(86.315,-20.055),(86.485,-20.055),(86.485,-20.225),(86.315,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-20.225),(86.675,-20.055),(86.845,-20.055),(86.845,-20.225),(86.675,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-20.225),(87.035,-20.055),(87.205,-20.055),(87.205,-20.225),(87.035,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-20.225),(87.395,-20.055),(87.565,-20.055),(87.565,-20.225),(87.395,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-20.225),(87.755,-20.055),(87.925,-20.055),(87.925,-20.225),(87.755,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-19.865),(83.075,-19.695),(83.245,-19.695),(83.245,-19.865),(83.075,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-19.865),(83.435,-19.695),(83.605,-19.695),(83.605,-19.865),(83.435,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-19.865),(83.795,-19.695),(83.965,-19.695),(83.965,-19.865),(83.795,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-19.865),(84.155,-19.695),(84.325,-19.695),(84.325,-19.865),(84.155,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-19.865),(84.515,-19.695),(84.685,-19.695),(84.685,-19.865),(84.515,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-19.865),(84.875,-19.695),(85.045,-19.695),(85.045,-19.865),(84.875,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-19.865),(85.235,-19.695),(85.405,-19.695),(85.405,-19.865),(85.235,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-19.865),(85.595,-19.695),(85.765,-19.695),(85.765,-19.865),(85.595,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-19.865),(85.955,-19.695),(86.125,-19.695),(86.125,-19.865),(85.955,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-19.865),(86.315,-19.695),(86.485,-19.695),(86.485,-19.865),(86.315,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-19.865),(86.675,-19.695),(86.845,-19.695),(86.845,-19.865),(86.675,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-19.865),(87.035,-19.695),(87.205,-19.695),(87.205,-19.865),(87.035,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-19.865),(87.395,-19.695),(87.565,-19.695),(87.565,-19.865),(87.395,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-19.865),(87.755,-19.695),(87.925,-19.695),(87.925,-19.865),(87.755,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-19.505),(83.075,-19.335),(83.245,-19.335),(83.245,-19.505),(83.075,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-19.505),(83.435,-19.335),(83.605,-19.335),(83.605,-19.505),(83.435,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-19.505),(83.795,-19.335),(83.965,-19.335),(83.965,-19.505),(83.795,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-19.505),(84.155,-19.335),(84.325,-19.335),(84.325,-19.505),(84.155,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-19.505),(84.515,-19.335),(84.685,-19.335),(84.685,-19.505),(84.515,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-19.505),(84.875,-19.335),(85.045,-19.335),(85.045,-19.505),(84.875,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-19.505),(85.235,-19.335),(85.405,-19.335),(85.405,-19.505),(85.235,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-19.505),(85.595,-19.335),(85.765,-19.335),(85.765,-19.505),(85.595,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-19.505),(85.955,-19.335),(86.125,-19.335),(86.125,-19.505),(85.955,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-19.505),(86.315,-19.335),(86.485,-19.335),(86.485,-19.505),(86.315,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-19.505),(86.675,-19.335),(86.845,-19.335),(86.845,-19.505),(86.675,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-19.505),(87.035,-19.335),(87.205,-19.335),(87.205,-19.505),(87.035,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-19.505),(87.395,-19.335),(87.565,-19.335),(87.565,-19.505),(87.395,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-19.505),(87.755,-19.335),(87.925,-19.335),(87.925,-19.505),(87.755,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-19.145),(83.075,-18.975),(83.245,-18.975),(83.245,-19.145),(83.075,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-19.145),(83.435,-18.975),(83.605,-18.975),(83.605,-19.145),(83.435,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-19.145),(83.795,-18.975),(83.965,-18.975),(83.965,-19.145),(83.795,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-19.145),(84.155,-18.975),(84.325,-18.975),(84.325,-19.145),(84.155,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-19.145),(84.515,-18.975),(84.685,-18.975),(84.685,-19.145),(84.515,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-19.145),(84.875,-18.975),(85.045,-18.975),(85.045,-19.145),(84.875,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-19.145),(85.235,-18.975),(85.405,-18.975),(85.405,-19.145),(85.235,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-19.145),(85.595,-18.975),(85.765,-18.975),(85.765,-19.145),(85.595,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-19.145),(85.955,-18.975),(86.125,-18.975),(86.125,-19.145),(85.955,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-19.145),(86.315,-18.975),(86.485,-18.975),(86.485,-19.145),(86.315,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-19.145),(86.675,-18.975),(86.845,-18.975),(86.845,-19.145),(86.675,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-19.145),(87.035,-18.975),(87.205,-18.975),(87.205,-19.145),(87.035,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-19.145),(87.395,-18.975),(87.565,-18.975),(87.565,-19.145),(87.395,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-19.145),(87.755,-18.975),(87.925,-18.975),(87.925,-19.145),(87.755,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-18.785),(83.075,-18.615),(83.245,-18.615),(83.245,-18.785),(83.075,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-18.785),(83.435,-18.615),(83.605,-18.615),(83.605,-18.785),(83.435,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-18.785),(83.795,-18.615),(83.965,-18.615),(83.965,-18.785),(83.795,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-18.785),(84.155,-18.615),(84.325,-18.615),(84.325,-18.785),(84.155,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-18.785),(84.515,-18.615),(84.685,-18.615),(84.685,-18.785),(84.515,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-18.785),(84.875,-18.615),(85.045,-18.615),(85.045,-18.785),(84.875,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-18.785),(85.235,-18.615),(85.405,-18.615),(85.405,-18.785),(85.235,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-18.785),(85.595,-18.615),(85.765,-18.615),(85.765,-18.785),(85.595,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-18.785),(85.955,-18.615),(86.125,-18.615),(86.125,-18.785),(85.955,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-18.785),(86.315,-18.615),(86.485,-18.615),(86.485,-18.785),(86.315,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-18.785),(86.675,-18.615),(86.845,-18.615),(86.845,-18.785),(86.675,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-18.785),(87.035,-18.615),(87.205,-18.615),(87.205,-18.785),(87.035,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-18.785),(87.395,-18.615),(87.565,-18.615),(87.565,-18.785),(87.395,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-18.785),(87.755,-18.615),(87.925,-18.615),(87.925,-18.785),(87.755,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-18.425),(83.075,-18.255),(83.245,-18.255),(83.245,-18.425),(83.075,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-18.425),(83.435,-18.255),(83.605,-18.255),(83.605,-18.425),(83.435,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-18.425),(83.795,-18.255),(83.965,-18.255),(83.965,-18.425),(83.795,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-18.425),(84.155,-18.255),(84.325,-18.255),(84.325,-18.425),(84.155,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-18.425),(84.515,-18.255),(84.685,-18.255),(84.685,-18.425),(84.515,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-18.425),(84.875,-18.255),(85.045,-18.255),(85.045,-18.425),(84.875,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-18.425),(85.235,-18.255),(85.405,-18.255),(85.405,-18.425),(85.235,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-18.425),(85.595,-18.255),(85.765,-18.255),(85.765,-18.425),(85.595,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-18.425),(85.955,-18.255),(86.125,-18.255),(86.125,-18.425),(85.955,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-18.425),(86.315,-18.255),(86.485,-18.255),(86.485,-18.425),(86.315,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-18.425),(86.675,-18.255),(86.845,-18.255),(86.845,-18.425),(86.675,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-18.425),(87.035,-18.255),(87.205,-18.255),(87.205,-18.425),(87.035,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-18.425),(87.395,-18.255),(87.565,-18.255),(87.565,-18.425),(87.395,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-18.425),(87.755,-18.255),(87.925,-18.255),(87.925,-18.425),(87.755,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-18.065),(83.075,-17.895),(83.245,-17.895),(83.245,-18.065),(83.075,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-18.065),(83.435,-17.895),(83.605,-17.895),(83.605,-18.065),(83.435,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-18.065),(83.795,-17.895),(83.965,-17.895),(83.965,-18.065),(83.795,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-18.065),(84.155,-17.895),(84.325,-17.895),(84.325,-18.065),(84.155,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-18.065),(84.515,-17.895),(84.685,-17.895),(84.685,-18.065),(84.515,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-18.065),(84.875,-17.895),(85.045,-17.895),(85.045,-18.065),(84.875,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-18.065),(85.235,-17.895),(85.405,-17.895),(85.405,-18.065),(85.235,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-18.065),(85.595,-17.895),(85.765,-17.895),(85.765,-18.065),(85.595,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-18.065),(85.955,-17.895),(86.125,-17.895),(86.125,-18.065),(85.955,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-18.065),(86.315,-17.895),(86.485,-17.895),(86.485,-18.065),(86.315,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-18.065),(86.675,-17.895),(86.845,-17.895),(86.845,-18.065),(86.675,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-18.065),(87.035,-17.895),(87.205,-17.895),(87.205,-18.065),(87.035,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-18.065),(87.395,-17.895),(87.565,-17.895),(87.565,-18.065),(87.395,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-18.065),(87.755,-17.895),(87.925,-17.895),(87.925,-18.065),(87.755,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-17.705),(83.075,-17.535),(83.245,-17.535),(83.245,-17.705),(83.075,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-17.705),(83.435,-17.535),(83.605,-17.535),(83.605,-17.705),(83.435,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-17.705),(83.795,-17.535),(83.965,-17.535),(83.965,-17.705),(83.795,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-17.705),(84.155,-17.535),(84.325,-17.535),(84.325,-17.705),(84.155,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-17.705),(84.515,-17.535),(84.685,-17.535),(84.685,-17.705),(84.515,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-17.705),(84.875,-17.535),(85.045,-17.535),(85.045,-17.705),(84.875,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-17.705),(85.235,-17.535),(85.405,-17.535),(85.405,-17.705),(85.235,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-17.705),(85.595,-17.535),(85.765,-17.535),(85.765,-17.705),(85.595,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-17.705),(85.955,-17.535),(86.125,-17.535),(86.125,-17.705),(85.955,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-17.705),(86.315,-17.535),(86.485,-17.535),(86.485,-17.705),(86.315,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-17.705),(86.675,-17.535),(86.845,-17.535),(86.845,-17.705),(86.675,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-17.705),(87.035,-17.535),(87.205,-17.535),(87.205,-17.705),(87.035,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-17.705),(87.395,-17.535),(87.565,-17.535),(87.565,-17.705),(87.395,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-17.705),(87.755,-17.535),(87.925,-17.535),(87.925,-17.705),(87.755,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-17.345),(83.075,-17.175),(83.245,-17.175),(83.245,-17.345),(83.075,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-17.345),(83.435,-17.175),(83.605,-17.175),(83.605,-17.345),(83.435,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-17.345),(83.795,-17.175),(83.965,-17.175),(83.965,-17.345),(83.795,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-17.345),(84.155,-17.175),(84.325,-17.175),(84.325,-17.345),(84.155,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-17.345),(84.515,-17.175),(84.685,-17.175),(84.685,-17.345),(84.515,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-17.345),(84.875,-17.175),(85.045,-17.175),(85.045,-17.345),(84.875,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-17.345),(85.235,-17.175),(85.405,-17.175),(85.405,-17.345),(85.235,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-17.345),(85.595,-17.175),(85.765,-17.175),(85.765,-17.345),(85.595,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-17.345),(85.955,-17.175),(86.125,-17.175),(86.125,-17.345),(85.955,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-17.345),(86.315,-17.175),(86.485,-17.175),(86.485,-17.345),(86.315,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-17.345),(86.675,-17.175),(86.845,-17.175),(86.845,-17.345),(86.675,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-17.345),(87.035,-17.175),(87.205,-17.175),(87.205,-17.345),(87.035,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-17.345),(87.395,-17.175),(87.565,-17.175),(87.565,-17.345),(87.395,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-17.345),(87.755,-17.175),(87.925,-17.175),(87.925,-17.345),(87.755,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-16.985),(83.075,-16.815),(83.245,-16.815),(83.245,-16.985),(83.075,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-16.985),(83.435,-16.815),(83.605,-16.815),(83.605,-16.985),(83.435,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-16.985),(83.795,-16.815),(83.965,-16.815),(83.965,-16.985),(83.795,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-16.985),(84.155,-16.815),(84.325,-16.815),(84.325,-16.985),(84.155,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-16.985),(84.515,-16.815),(84.685,-16.815),(84.685,-16.985),(84.515,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-16.985),(84.875,-16.815),(85.045,-16.815),(85.045,-16.985),(84.875,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-16.985),(85.235,-16.815),(85.405,-16.815),(85.405,-16.985),(85.235,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-16.985),(85.595,-16.815),(85.765,-16.815),(85.765,-16.985),(85.595,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-16.985),(85.955,-16.815),(86.125,-16.815),(86.125,-16.985),(85.955,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-16.985),(86.315,-16.815),(86.485,-16.815),(86.485,-16.985),(86.315,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-16.985),(86.675,-16.815),(86.845,-16.815),(86.845,-16.985),(86.675,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-16.985),(87.035,-16.815),(87.205,-16.815),(87.205,-16.985),(87.035,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-16.985),(87.395,-16.815),(87.565,-16.815),(87.565,-16.985),(87.395,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-16.985),(87.755,-16.815),(87.925,-16.815),(87.925,-16.985),(87.755,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-16.625),(83.075,-16.455),(83.245,-16.455),(83.245,-16.625),(83.075,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-16.625),(83.435,-16.455),(83.605,-16.455),(83.605,-16.625),(83.435,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-16.625),(83.795,-16.455),(83.965,-16.455),(83.965,-16.625),(83.795,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-16.625),(84.155,-16.455),(84.325,-16.455),(84.325,-16.625),(84.155,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-16.625),(84.515,-16.455),(84.685,-16.455),(84.685,-16.625),(84.515,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-16.625),(84.875,-16.455),(85.045,-16.455),(85.045,-16.625),(84.875,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-16.625),(85.235,-16.455),(85.405,-16.455),(85.405,-16.625),(85.235,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-16.625),(85.595,-16.455),(85.765,-16.455),(85.765,-16.625),(85.595,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-16.625),(85.955,-16.455),(86.125,-16.455),(86.125,-16.625),(85.955,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-16.625),(86.315,-16.455),(86.485,-16.455),(86.485,-16.625),(86.315,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-16.625),(86.675,-16.455),(86.845,-16.455),(86.845,-16.625),(86.675,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-16.625),(87.035,-16.455),(87.205,-16.455),(87.205,-16.625),(87.035,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-16.625),(87.395,-16.455),(87.565,-16.455),(87.565,-16.625),(87.395,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-16.625),(87.755,-16.455),(87.925,-16.455),(87.925,-16.625),(87.755,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-16.265),(83.075,-16.095),(83.245,-16.095),(83.245,-16.265),(83.075,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-16.265),(83.435,-16.095),(83.605,-16.095),(83.605,-16.265),(83.435,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-16.265),(83.795,-16.095),(83.965,-16.095),(83.965,-16.265),(83.795,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-16.265),(84.155,-16.095),(84.325,-16.095),(84.325,-16.265),(84.155,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-16.265),(84.515,-16.095),(84.685,-16.095),(84.685,-16.265),(84.515,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-16.265),(84.875,-16.095),(85.045,-16.095),(85.045,-16.265),(84.875,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-16.265),(85.235,-16.095),(85.405,-16.095),(85.405,-16.265),(85.235,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-16.265),(85.595,-16.095),(85.765,-16.095),(85.765,-16.265),(85.595,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-16.265),(85.955,-16.095),(86.125,-16.095),(86.125,-16.265),(85.955,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-16.265),(86.315,-16.095),(86.485,-16.095),(86.485,-16.265),(86.315,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-16.265),(86.675,-16.095),(86.845,-16.095),(86.845,-16.265),(86.675,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-16.265),(87.035,-16.095),(87.205,-16.095),(87.205,-16.265),(87.035,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-16.265),(87.395,-16.095),(87.565,-16.095),(87.565,-16.265),(87.395,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-16.265),(87.755,-16.095),(87.925,-16.095),(87.925,-16.265),(87.755,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-15.905),(83.075,-15.735),(83.245,-15.735),(83.245,-15.905),(83.075,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-15.905),(83.435,-15.735),(83.605,-15.735),(83.605,-15.905),(83.435,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-15.905),(83.795,-15.735),(83.965,-15.735),(83.965,-15.905),(83.795,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-15.905),(84.155,-15.735),(84.325,-15.735),(84.325,-15.905),(84.155,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-15.905),(84.515,-15.735),(84.685,-15.735),(84.685,-15.905),(84.515,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-15.905),(84.875,-15.735),(85.045,-15.735),(85.045,-15.905),(84.875,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-15.905),(85.235,-15.735),(85.405,-15.735),(85.405,-15.905),(85.235,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-15.905),(85.595,-15.735),(85.765,-15.735),(85.765,-15.905),(85.595,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-15.905),(85.955,-15.735),(86.125,-15.735),(86.125,-15.905),(85.955,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-15.905),(86.315,-15.735),(86.485,-15.735),(86.485,-15.905),(86.315,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-15.905),(86.675,-15.735),(86.845,-15.735),(86.845,-15.905),(86.675,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-15.905),(87.035,-15.735),(87.205,-15.735),(87.205,-15.905),(87.035,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-15.905),(87.395,-15.735),(87.565,-15.735),(87.565,-15.905),(87.395,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-15.905),(87.755,-15.735),(87.925,-15.735),(87.925,-15.905),(87.755,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-15.545),(83.075,-15.375),(83.245,-15.375),(83.245,-15.545),(83.075,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-15.545),(83.435,-15.375),(83.605,-15.375),(83.605,-15.545),(83.435,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-15.545),(83.795,-15.375),(83.965,-15.375),(83.965,-15.545),(83.795,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-15.545),(84.155,-15.375),(84.325,-15.375),(84.325,-15.545),(84.155,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-15.545),(84.515,-15.375),(84.685,-15.375),(84.685,-15.545),(84.515,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-15.545),(84.875,-15.375),(85.045,-15.375),(85.045,-15.545),(84.875,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-15.545),(85.235,-15.375),(85.405,-15.375),(85.405,-15.545),(85.235,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-15.545),(85.595,-15.375),(85.765,-15.375),(85.765,-15.545),(85.595,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-15.545),(85.955,-15.375),(86.125,-15.375),(86.125,-15.545),(85.955,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-15.545),(86.315,-15.375),(86.485,-15.375),(86.485,-15.545),(86.315,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-15.545),(86.675,-15.375),(86.845,-15.375),(86.845,-15.545),(86.675,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-15.545),(87.035,-15.375),(87.205,-15.375),(87.205,-15.545),(87.035,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-15.545),(87.395,-15.375),(87.565,-15.375),(87.565,-15.545),(87.395,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-15.545),(87.755,-15.375),(87.925,-15.375),(87.925,-15.545),(87.755,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-15.185),(83.075,-15.015),(83.245,-15.015),(83.245,-15.185),(83.075,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-15.185),(83.435,-15.015),(83.605,-15.015),(83.605,-15.185),(83.435,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-15.185),(83.795,-15.015),(83.965,-15.015),(83.965,-15.185),(83.795,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-15.185),(84.155,-15.015),(84.325,-15.015),(84.325,-15.185),(84.155,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-15.185),(84.515,-15.015),(84.685,-15.015),(84.685,-15.185),(84.515,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-15.185),(84.875,-15.015),(85.045,-15.015),(85.045,-15.185),(84.875,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-15.185),(85.235,-15.015),(85.405,-15.015),(85.405,-15.185),(85.235,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-15.185),(85.595,-15.015),(85.765,-15.015),(85.765,-15.185),(85.595,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-15.185),(85.955,-15.015),(86.125,-15.015),(86.125,-15.185),(85.955,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-15.185),(86.315,-15.015),(86.485,-15.015),(86.485,-15.185),(86.315,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-15.185),(86.675,-15.015),(86.845,-15.015),(86.845,-15.185),(86.675,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-15.185),(87.035,-15.015),(87.205,-15.015),(87.205,-15.185),(87.035,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-15.185),(87.395,-15.015),(87.565,-15.015),(87.565,-15.185),(87.395,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-15.185),(87.755,-15.015),(87.925,-15.015),(87.925,-15.185),(87.755,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-14.825),(83.075,-14.655),(83.245,-14.655),(83.245,-14.825),(83.075,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-14.825),(83.435,-14.655),(83.605,-14.655),(83.605,-14.825),(83.435,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-14.825),(83.795,-14.655),(83.965,-14.655),(83.965,-14.825),(83.795,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-14.825),(84.155,-14.655),(84.325,-14.655),(84.325,-14.825),(84.155,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-14.825),(84.515,-14.655),(84.685,-14.655),(84.685,-14.825),(84.515,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-14.825),(84.875,-14.655),(85.045,-14.655),(85.045,-14.825),(84.875,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-14.825),(85.235,-14.655),(85.405,-14.655),(85.405,-14.825),(85.235,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-14.825),(85.595,-14.655),(85.765,-14.655),(85.765,-14.825),(85.595,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-14.825),(85.955,-14.655),(86.125,-14.655),(86.125,-14.825),(85.955,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-14.825),(86.315,-14.655),(86.485,-14.655),(86.485,-14.825),(86.315,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-14.825),(86.675,-14.655),(86.845,-14.655),(86.845,-14.825),(86.675,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-14.825),(87.035,-14.655),(87.205,-14.655),(87.205,-14.825),(87.035,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-14.825),(87.395,-14.655),(87.565,-14.655),(87.565,-14.825),(87.395,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-14.825),(87.755,-14.655),(87.925,-14.655),(87.925,-14.825),(87.755,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-14.465),(83.075,-14.295),(83.245,-14.295),(83.245,-14.465),(83.075,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-14.465),(83.435,-14.295),(83.605,-14.295),(83.605,-14.465),(83.435,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-14.465),(83.795,-14.295),(83.965,-14.295),(83.965,-14.465),(83.795,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-14.465),(84.155,-14.295),(84.325,-14.295),(84.325,-14.465),(84.155,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-14.465),(84.515,-14.295),(84.685,-14.295),(84.685,-14.465),(84.515,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-14.465),(84.875,-14.295),(85.045,-14.295),(85.045,-14.465),(84.875,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-14.465),(85.235,-14.295),(85.405,-14.295),(85.405,-14.465),(85.235,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-14.465),(85.595,-14.295),(85.765,-14.295),(85.765,-14.465),(85.595,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-14.465),(85.955,-14.295),(86.125,-14.295),(86.125,-14.465),(85.955,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-14.465),(86.315,-14.295),(86.485,-14.295),(86.485,-14.465),(86.315,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-14.465),(86.675,-14.295),(86.845,-14.295),(86.845,-14.465),(86.675,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-14.465),(87.035,-14.295),(87.205,-14.295),(87.205,-14.465),(87.035,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-14.465),(87.395,-14.295),(87.565,-14.295),(87.565,-14.465),(87.395,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-14.465),(87.755,-14.295),(87.925,-14.295),(87.925,-14.465),(87.755,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-14.105),(83.075,-13.935),(83.245,-13.935),(83.245,-14.105),(83.075,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-14.105),(83.435,-13.935),(83.605,-13.935),(83.605,-14.105),(83.435,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-14.105),(83.795,-13.935),(83.965,-13.935),(83.965,-14.105),(83.795,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-14.105),(84.155,-13.935),(84.325,-13.935),(84.325,-14.105),(84.155,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-14.105),(84.515,-13.935),(84.685,-13.935),(84.685,-14.105),(84.515,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-14.105),(84.875,-13.935),(85.045,-13.935),(85.045,-14.105),(84.875,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-14.105),(85.235,-13.935),(85.405,-13.935),(85.405,-14.105),(85.235,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-14.105),(85.595,-13.935),(85.765,-13.935),(85.765,-14.105),(85.595,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-14.105),(85.955,-13.935),(86.125,-13.935),(86.125,-14.105),(85.955,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-14.105),(86.315,-13.935),(86.485,-13.935),(86.485,-14.105),(86.315,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-14.105),(86.675,-13.935),(86.845,-13.935),(86.845,-14.105),(86.675,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-14.105),(87.035,-13.935),(87.205,-13.935),(87.205,-14.105),(87.035,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-14.105),(87.395,-13.935),(87.565,-13.935),(87.565,-14.105),(87.395,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-14.105),(87.755,-13.935),(87.925,-13.935),(87.925,-14.105),(87.755,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-13.745),(83.075,-13.575),(83.245,-13.575),(83.245,-13.745),(83.075,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-13.745),(83.435,-13.575),(83.605,-13.575),(83.605,-13.745),(83.435,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-13.745),(83.795,-13.575),(83.965,-13.575),(83.965,-13.745),(83.795,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-13.745),(84.155,-13.575),(84.325,-13.575),(84.325,-13.745),(84.155,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-13.745),(84.515,-13.575),(84.685,-13.575),(84.685,-13.745),(84.515,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-13.745),(84.875,-13.575),(85.045,-13.575),(85.045,-13.745),(84.875,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-13.745),(85.235,-13.575),(85.405,-13.575),(85.405,-13.745),(85.235,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-13.745),(85.595,-13.575),(85.765,-13.575),(85.765,-13.745),(85.595,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-13.745),(85.955,-13.575),(86.125,-13.575),(86.125,-13.745),(85.955,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-13.745),(86.315,-13.575),(86.485,-13.575),(86.485,-13.745),(86.315,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-13.745),(86.675,-13.575),(86.845,-13.575),(86.845,-13.745),(86.675,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-13.745),(87.035,-13.575),(87.205,-13.575),(87.205,-13.745),(87.035,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-13.745),(87.395,-13.575),(87.565,-13.575),(87.565,-13.745),(87.395,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-13.745),(87.755,-13.575),(87.925,-13.575),(87.925,-13.745),(87.755,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-13.385),(83.075,-13.215),(83.245,-13.215),(83.245,-13.385),(83.075,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-13.385),(83.435,-13.215),(83.605,-13.215),(83.605,-13.385),(83.435,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-13.385),(83.795,-13.215),(83.965,-13.215),(83.965,-13.385),(83.795,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-13.385),(84.155,-13.215),(84.325,-13.215),(84.325,-13.385),(84.155,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-13.385),(84.515,-13.215),(84.685,-13.215),(84.685,-13.385),(84.515,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-13.385),(84.875,-13.215),(85.045,-13.215),(85.045,-13.385),(84.875,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-13.385),(85.235,-13.215),(85.405,-13.215),(85.405,-13.385),(85.235,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-13.385),(85.595,-13.215),(85.765,-13.215),(85.765,-13.385),(85.595,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-13.385),(85.955,-13.215),(86.125,-13.215),(86.125,-13.385),(85.955,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-13.385),(86.315,-13.215),(86.485,-13.215),(86.485,-13.385),(86.315,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-13.385),(86.675,-13.215),(86.845,-13.215),(86.845,-13.385),(86.675,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-13.385),(87.035,-13.215),(87.205,-13.215),(87.205,-13.385),(87.035,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-13.385),(87.395,-13.215),(87.565,-13.215),(87.565,-13.385),(87.395,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-13.385),(87.755,-13.215),(87.925,-13.215),(87.925,-13.385),(87.755,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-13.025),(83.075,-12.855),(83.245,-12.855),(83.245,-13.025),(83.075,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-13.025),(83.435,-12.855),(83.605,-12.855),(83.605,-13.025),(83.435,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-13.025),(83.795,-12.855),(83.965,-12.855),(83.965,-13.025),(83.795,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-13.025),(84.155,-12.855),(84.325,-12.855),(84.325,-13.025),(84.155,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-13.025),(84.515,-12.855),(84.685,-12.855),(84.685,-13.025),(84.515,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-13.025),(84.875,-12.855),(85.045,-12.855),(85.045,-13.025),(84.875,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-13.025),(85.235,-12.855),(85.405,-12.855),(85.405,-13.025),(85.235,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-13.025),(85.595,-12.855),(85.765,-12.855),(85.765,-13.025),(85.595,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-13.025),(85.955,-12.855),(86.125,-12.855),(86.125,-13.025),(85.955,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-13.025),(86.315,-12.855),(86.485,-12.855),(86.485,-13.025),(86.315,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-13.025),(86.675,-12.855),(86.845,-12.855),(86.845,-13.025),(86.675,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-13.025),(87.035,-12.855),(87.205,-12.855),(87.205,-13.025),(87.035,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-13.025),(87.395,-12.855),(87.565,-12.855),(87.565,-13.025),(87.395,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-13.025),(87.755,-12.855),(87.925,-12.855),(87.925,-13.025),(87.755,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-12.665),(83.075,-12.495),(83.245,-12.495),(83.245,-12.665),(83.075,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-12.665),(83.435,-12.495),(83.605,-12.495),(83.605,-12.665),(83.435,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-12.665),(83.795,-12.495),(83.965,-12.495),(83.965,-12.665),(83.795,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-12.665),(84.155,-12.495),(84.325,-12.495),(84.325,-12.665),(84.155,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-12.665),(84.515,-12.495),(84.685,-12.495),(84.685,-12.665),(84.515,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-12.665),(84.875,-12.495),(85.045,-12.495),(85.045,-12.665),(84.875,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-12.665),(85.235,-12.495),(85.405,-12.495),(85.405,-12.665),(85.235,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-12.665),(85.595,-12.495),(85.765,-12.495),(85.765,-12.665),(85.595,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-12.665),(85.955,-12.495),(86.125,-12.495),(86.125,-12.665),(85.955,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-12.665),(86.315,-12.495),(86.485,-12.495),(86.485,-12.665),(86.315,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-12.665),(86.675,-12.495),(86.845,-12.495),(86.845,-12.665),(86.675,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-12.665),(87.035,-12.495),(87.205,-12.495),(87.205,-12.665),(87.035,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-12.665),(87.395,-12.495),(87.565,-12.495),(87.565,-12.665),(87.395,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-12.665),(87.755,-12.495),(87.925,-12.495),(87.925,-12.665),(87.755,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-12.305),(83.075,-12.135),(83.245,-12.135),(83.245,-12.305),(83.075,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-12.305),(83.435,-12.135),(83.605,-12.135),(83.605,-12.305),(83.435,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-12.305),(83.795,-12.135),(83.965,-12.135),(83.965,-12.305),(83.795,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-12.305),(84.155,-12.135),(84.325,-12.135),(84.325,-12.305),(84.155,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-12.305),(84.515,-12.135),(84.685,-12.135),(84.685,-12.305),(84.515,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-12.305),(84.875,-12.135),(85.045,-12.135),(85.045,-12.305),(84.875,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-12.305),(85.235,-12.135),(85.405,-12.135),(85.405,-12.305),(85.235,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-12.305),(85.595,-12.135),(85.765,-12.135),(85.765,-12.305),(85.595,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-12.305),(85.955,-12.135),(86.125,-12.135),(86.125,-12.305),(85.955,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-12.305),(86.315,-12.135),(86.485,-12.135),(86.485,-12.305),(86.315,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-12.305),(86.675,-12.135),(86.845,-12.135),(86.845,-12.305),(86.675,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-12.305),(87.035,-12.135),(87.205,-12.135),(87.205,-12.305),(87.035,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-12.305),(87.395,-12.135),(87.565,-12.135),(87.565,-12.305),(87.395,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-12.305),(87.755,-12.135),(87.925,-12.135),(87.925,-12.305),(87.755,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-11.945),(83.075,-11.775),(83.245,-11.775),(83.245,-11.945),(83.075,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-11.945),(83.435,-11.775),(83.605,-11.775),(83.605,-11.945),(83.435,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-11.945),(83.795,-11.775),(83.965,-11.775),(83.965,-11.945),(83.795,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-11.945),(84.155,-11.775),(84.325,-11.775),(84.325,-11.945),(84.155,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-11.945),(84.515,-11.775),(84.685,-11.775),(84.685,-11.945),(84.515,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-11.945),(84.875,-11.775),(85.045,-11.775),(85.045,-11.945),(84.875,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-11.945),(85.235,-11.775),(85.405,-11.775),(85.405,-11.945),(85.235,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-11.945),(85.595,-11.775),(85.765,-11.775),(85.765,-11.945),(85.595,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-11.945),(85.955,-11.775),(86.125,-11.775),(86.125,-11.945),(85.955,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-11.945),(86.315,-11.775),(86.485,-11.775),(86.485,-11.945),(86.315,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-11.945),(86.675,-11.775),(86.845,-11.775),(86.845,-11.945),(86.675,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-11.945),(87.035,-11.775),(87.205,-11.775),(87.205,-11.945),(87.035,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-11.945),(87.395,-11.775),(87.565,-11.775),(87.565,-11.945),(87.395,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-11.945),(87.755,-11.775),(87.925,-11.775),(87.925,-11.945),(87.755,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-11.585),(83.075,-11.415),(83.245,-11.415),(83.245,-11.585),(83.075,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-11.585),(83.435,-11.415),(83.605,-11.415),(83.605,-11.585),(83.435,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-11.585),(83.795,-11.415),(83.965,-11.415),(83.965,-11.585),(83.795,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-11.585),(84.155,-11.415),(84.325,-11.415),(84.325,-11.585),(84.155,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-11.585),(84.515,-11.415),(84.685,-11.415),(84.685,-11.585),(84.515,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-11.585),(84.875,-11.415),(85.045,-11.415),(85.045,-11.585),(84.875,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-11.585),(85.235,-11.415),(85.405,-11.415),(85.405,-11.585),(85.235,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-11.585),(85.595,-11.415),(85.765,-11.415),(85.765,-11.585),(85.595,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-11.585),(85.955,-11.415),(86.125,-11.415),(86.125,-11.585),(85.955,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-11.585),(86.315,-11.415),(86.485,-11.415),(86.485,-11.585),(86.315,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-11.585),(86.675,-11.415),(86.845,-11.415),(86.845,-11.585),(86.675,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-11.585),(87.035,-11.415),(87.205,-11.415),(87.205,-11.585),(87.035,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-11.585),(87.395,-11.415),(87.565,-11.415),(87.565,-11.585),(87.395,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-11.585),(87.755,-11.415),(87.925,-11.415),(87.925,-11.585),(87.755,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.075,-11.225),(83.075,-11.055),(83.245,-11.055),(83.245,-11.225),(83.075,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.435,-11.225),(83.435,-11.055),(83.605,-11.055),(83.605,-11.225),(83.435,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.795,-11.225),(83.795,-11.055),(83.965,-11.055),(83.965,-11.225),(83.795,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.155,-11.225),(84.155,-11.055),(84.325,-11.055),(84.325,-11.225),(84.155,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.515,-11.225),(84.515,-11.055),(84.685,-11.055),(84.685,-11.225),(84.515,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((84.875,-11.225),(84.875,-11.055),(85.045,-11.055),(85.045,-11.225),(84.875,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.235,-11.225),(85.235,-11.055),(85.405,-11.055),(85.405,-11.225),(85.235,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.595,-11.225),(85.595,-11.055),(85.765,-11.055),(85.765,-11.225),(85.595,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.955,-11.225),(85.955,-11.055),(86.125,-11.055),(86.125,-11.225),(85.955,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.315,-11.225),(86.315,-11.055),(86.485,-11.055),(86.485,-11.225),(86.315,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((86.675,-11.225),(86.675,-11.055),(86.845,-11.055),(86.845,-11.225),(86.675,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.035,-11.225),(87.035,-11.055),(87.205,-11.055),(87.205,-11.225),(87.035,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.395,-11.225),(87.395,-11.055),(87.565,-11.055),(87.565,-11.225),(87.395,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((87.755,-11.225),(87.755,-11.055),(87.925,-11.055),(87.925,-11.225),(87.755,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-20.945),(1.575,-20.775),(1.745,-20.775),(1.745,-20.945),(1.575,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-20.945),(1.935,-20.775),(2.105,-20.775),(2.105,-20.945),(1.935,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-20.945),(2.295,-20.775),(2.465,-20.775),(2.465,-20.945),(2.295,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-20.945),(2.655,-20.775),(2.825,-20.775),(2.825,-20.945),(2.655,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-20.945),(3.015,-20.775),(3.185,-20.775),(3.185,-20.945),(3.015,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-20.945),(3.375,-20.775),(3.545,-20.775),(3.545,-20.945),(3.375,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-20.945),(3.735,-20.775),(3.905,-20.775),(3.905,-20.945),(3.735,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-20.945),(4.095,-20.775),(4.265,-20.775),(4.265,-20.945),(4.095,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-20.945),(4.455,-20.775),(4.625,-20.775),(4.625,-20.945),(4.455,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-20.945),(4.815,-20.775),(4.985,-20.775),(4.985,-20.945),(4.815,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-20.945),(5.175,-20.775),(5.345,-20.775),(5.345,-20.945),(5.175,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-20.945),(5.535,-20.775),(5.705,-20.775),(5.705,-20.945),(5.535,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-20.945),(5.895,-20.775),(6.065,-20.775),(6.065,-20.945),(5.895,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-20.945),(6.255,-20.775),(6.425,-20.775),(6.425,-20.945),(6.255,-20.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-20.585),(1.575,-20.415),(1.745,-20.415),(1.745,-20.585),(1.575,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-20.585),(1.935,-20.415),(2.105,-20.415),(2.105,-20.585),(1.935,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-20.585),(2.295,-20.415),(2.465,-20.415),(2.465,-20.585),(2.295,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-20.585),(2.655,-20.415),(2.825,-20.415),(2.825,-20.585),(2.655,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-20.585),(3.015,-20.415),(3.185,-20.415),(3.185,-20.585),(3.015,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-20.585),(3.375,-20.415),(3.545,-20.415),(3.545,-20.585),(3.375,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-20.585),(3.735,-20.415),(3.905,-20.415),(3.905,-20.585),(3.735,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-20.585),(4.095,-20.415),(4.265,-20.415),(4.265,-20.585),(4.095,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-20.585),(4.455,-20.415),(4.625,-20.415),(4.625,-20.585),(4.455,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-20.585),(4.815,-20.415),(4.985,-20.415),(4.985,-20.585),(4.815,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-20.585),(5.175,-20.415),(5.345,-20.415),(5.345,-20.585),(5.175,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-20.585),(5.535,-20.415),(5.705,-20.415),(5.705,-20.585),(5.535,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-20.585),(5.895,-20.415),(6.065,-20.415),(6.065,-20.585),(5.895,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-20.585),(6.255,-20.415),(6.425,-20.415),(6.425,-20.585),(6.255,-20.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-20.225),(1.575,-20.055),(1.745,-20.055),(1.745,-20.225),(1.575,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-20.225),(1.935,-20.055),(2.105,-20.055),(2.105,-20.225),(1.935,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-20.225),(2.295,-20.055),(2.465,-20.055),(2.465,-20.225),(2.295,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-20.225),(2.655,-20.055),(2.825,-20.055),(2.825,-20.225),(2.655,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-20.225),(3.015,-20.055),(3.185,-20.055),(3.185,-20.225),(3.015,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-20.225),(3.375,-20.055),(3.545,-20.055),(3.545,-20.225),(3.375,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-20.225),(3.735,-20.055),(3.905,-20.055),(3.905,-20.225),(3.735,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-20.225),(4.095,-20.055),(4.265,-20.055),(4.265,-20.225),(4.095,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-20.225),(4.455,-20.055),(4.625,-20.055),(4.625,-20.225),(4.455,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-20.225),(4.815,-20.055),(4.985,-20.055),(4.985,-20.225),(4.815,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-20.225),(5.175,-20.055),(5.345,-20.055),(5.345,-20.225),(5.175,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-20.225),(5.535,-20.055),(5.705,-20.055),(5.705,-20.225),(5.535,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-20.225),(5.895,-20.055),(6.065,-20.055),(6.065,-20.225),(5.895,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-20.225),(6.255,-20.055),(6.425,-20.055),(6.425,-20.225),(6.255,-20.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-19.865),(1.575,-19.695),(1.745,-19.695),(1.745,-19.865),(1.575,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-19.865),(1.935,-19.695),(2.105,-19.695),(2.105,-19.865),(1.935,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-19.865),(2.295,-19.695),(2.465,-19.695),(2.465,-19.865),(2.295,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-19.865),(2.655,-19.695),(2.825,-19.695),(2.825,-19.865),(2.655,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-19.865),(3.015,-19.695),(3.185,-19.695),(3.185,-19.865),(3.015,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-19.865),(3.375,-19.695),(3.545,-19.695),(3.545,-19.865),(3.375,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-19.865),(3.735,-19.695),(3.905,-19.695),(3.905,-19.865),(3.735,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-19.865),(4.095,-19.695),(4.265,-19.695),(4.265,-19.865),(4.095,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-19.865),(4.455,-19.695),(4.625,-19.695),(4.625,-19.865),(4.455,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-19.865),(4.815,-19.695),(4.985,-19.695),(4.985,-19.865),(4.815,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-19.865),(5.175,-19.695),(5.345,-19.695),(5.345,-19.865),(5.175,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-19.865),(5.535,-19.695),(5.705,-19.695),(5.705,-19.865),(5.535,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-19.865),(5.895,-19.695),(6.065,-19.695),(6.065,-19.865),(5.895,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-19.865),(6.255,-19.695),(6.425,-19.695),(6.425,-19.865),(6.255,-19.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-19.505),(1.575,-19.335),(1.745,-19.335),(1.745,-19.505),(1.575,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-19.505),(1.935,-19.335),(2.105,-19.335),(2.105,-19.505),(1.935,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-19.505),(2.295,-19.335),(2.465,-19.335),(2.465,-19.505),(2.295,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-19.505),(2.655,-19.335),(2.825,-19.335),(2.825,-19.505),(2.655,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-19.505),(3.015,-19.335),(3.185,-19.335),(3.185,-19.505),(3.015,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-19.505),(3.375,-19.335),(3.545,-19.335),(3.545,-19.505),(3.375,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-19.505),(3.735,-19.335),(3.905,-19.335),(3.905,-19.505),(3.735,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-19.505),(4.095,-19.335),(4.265,-19.335),(4.265,-19.505),(4.095,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-19.505),(4.455,-19.335),(4.625,-19.335),(4.625,-19.505),(4.455,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-19.505),(4.815,-19.335),(4.985,-19.335),(4.985,-19.505),(4.815,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-19.505),(5.175,-19.335),(5.345,-19.335),(5.345,-19.505),(5.175,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-19.505),(5.535,-19.335),(5.705,-19.335),(5.705,-19.505),(5.535,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-19.505),(5.895,-19.335),(6.065,-19.335),(6.065,-19.505),(5.895,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-19.505),(6.255,-19.335),(6.425,-19.335),(6.425,-19.505),(6.255,-19.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-19.145),(1.575,-18.975),(1.745,-18.975),(1.745,-19.145),(1.575,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-19.145),(1.935,-18.975),(2.105,-18.975),(2.105,-19.145),(1.935,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-19.145),(2.295,-18.975),(2.465,-18.975),(2.465,-19.145),(2.295,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-19.145),(2.655,-18.975),(2.825,-18.975),(2.825,-19.145),(2.655,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-19.145),(3.015,-18.975),(3.185,-18.975),(3.185,-19.145),(3.015,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-19.145),(3.375,-18.975),(3.545,-18.975),(3.545,-19.145),(3.375,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-19.145),(3.735,-18.975),(3.905,-18.975),(3.905,-19.145),(3.735,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-19.145),(4.095,-18.975),(4.265,-18.975),(4.265,-19.145),(4.095,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-19.145),(4.455,-18.975),(4.625,-18.975),(4.625,-19.145),(4.455,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-19.145),(4.815,-18.975),(4.985,-18.975),(4.985,-19.145),(4.815,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-19.145),(5.175,-18.975),(5.345,-18.975),(5.345,-19.145),(5.175,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-19.145),(5.535,-18.975),(5.705,-18.975),(5.705,-19.145),(5.535,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-19.145),(5.895,-18.975),(6.065,-18.975),(6.065,-19.145),(5.895,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-19.145),(6.255,-18.975),(6.425,-18.975),(6.425,-19.145),(6.255,-19.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-18.785),(1.575,-18.615),(1.745,-18.615),(1.745,-18.785),(1.575,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-18.785),(1.935,-18.615),(2.105,-18.615),(2.105,-18.785),(1.935,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-18.785),(2.295,-18.615),(2.465,-18.615),(2.465,-18.785),(2.295,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-18.785),(2.655,-18.615),(2.825,-18.615),(2.825,-18.785),(2.655,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-18.785),(3.015,-18.615),(3.185,-18.615),(3.185,-18.785),(3.015,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-18.785),(3.375,-18.615),(3.545,-18.615),(3.545,-18.785),(3.375,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-18.785),(3.735,-18.615),(3.905,-18.615),(3.905,-18.785),(3.735,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-18.785),(4.095,-18.615),(4.265,-18.615),(4.265,-18.785),(4.095,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-18.785),(4.455,-18.615),(4.625,-18.615),(4.625,-18.785),(4.455,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-18.785),(4.815,-18.615),(4.985,-18.615),(4.985,-18.785),(4.815,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-18.785),(5.175,-18.615),(5.345,-18.615),(5.345,-18.785),(5.175,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-18.785),(5.535,-18.615),(5.705,-18.615),(5.705,-18.785),(5.535,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-18.785),(5.895,-18.615),(6.065,-18.615),(6.065,-18.785),(5.895,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-18.785),(6.255,-18.615),(6.425,-18.615),(6.425,-18.785),(6.255,-18.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-18.425),(1.575,-18.255),(1.745,-18.255),(1.745,-18.425),(1.575,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-18.425),(1.935,-18.255),(2.105,-18.255),(2.105,-18.425),(1.935,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-18.425),(2.295,-18.255),(2.465,-18.255),(2.465,-18.425),(2.295,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-18.425),(2.655,-18.255),(2.825,-18.255),(2.825,-18.425),(2.655,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-18.425),(3.015,-18.255),(3.185,-18.255),(3.185,-18.425),(3.015,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-18.425),(3.375,-18.255),(3.545,-18.255),(3.545,-18.425),(3.375,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-18.425),(3.735,-18.255),(3.905,-18.255),(3.905,-18.425),(3.735,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-18.425),(4.095,-18.255),(4.265,-18.255),(4.265,-18.425),(4.095,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-18.425),(4.455,-18.255),(4.625,-18.255),(4.625,-18.425),(4.455,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-18.425),(4.815,-18.255),(4.985,-18.255),(4.985,-18.425),(4.815,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-18.425),(5.175,-18.255),(5.345,-18.255),(5.345,-18.425),(5.175,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-18.425),(5.535,-18.255),(5.705,-18.255),(5.705,-18.425),(5.535,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-18.425),(5.895,-18.255),(6.065,-18.255),(6.065,-18.425),(5.895,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-18.425),(6.255,-18.255),(6.425,-18.255),(6.425,-18.425),(6.255,-18.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-18.065),(1.575,-17.895),(1.745,-17.895),(1.745,-18.065),(1.575,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-18.065),(1.935,-17.895),(2.105,-17.895),(2.105,-18.065),(1.935,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-18.065),(2.295,-17.895),(2.465,-17.895),(2.465,-18.065),(2.295,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-18.065),(2.655,-17.895),(2.825,-17.895),(2.825,-18.065),(2.655,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-18.065),(3.015,-17.895),(3.185,-17.895),(3.185,-18.065),(3.015,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-18.065),(3.375,-17.895),(3.545,-17.895),(3.545,-18.065),(3.375,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-18.065),(3.735,-17.895),(3.905,-17.895),(3.905,-18.065),(3.735,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-18.065),(4.095,-17.895),(4.265,-17.895),(4.265,-18.065),(4.095,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-18.065),(4.455,-17.895),(4.625,-17.895),(4.625,-18.065),(4.455,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-18.065),(4.815,-17.895),(4.985,-17.895),(4.985,-18.065),(4.815,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-18.065),(5.175,-17.895),(5.345,-17.895),(5.345,-18.065),(5.175,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-18.065),(5.535,-17.895),(5.705,-17.895),(5.705,-18.065),(5.535,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-18.065),(5.895,-17.895),(6.065,-17.895),(6.065,-18.065),(5.895,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-18.065),(6.255,-17.895),(6.425,-17.895),(6.425,-18.065),(6.255,-18.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-17.705),(1.575,-17.535),(1.745,-17.535),(1.745,-17.705),(1.575,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-17.705),(1.935,-17.535),(2.105,-17.535),(2.105,-17.705),(1.935,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-17.705),(2.295,-17.535),(2.465,-17.535),(2.465,-17.705),(2.295,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-17.705),(2.655,-17.535),(2.825,-17.535),(2.825,-17.705),(2.655,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-17.705),(3.015,-17.535),(3.185,-17.535),(3.185,-17.705),(3.015,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-17.705),(3.375,-17.535),(3.545,-17.535),(3.545,-17.705),(3.375,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-17.705),(3.735,-17.535),(3.905,-17.535),(3.905,-17.705),(3.735,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-17.705),(4.095,-17.535),(4.265,-17.535),(4.265,-17.705),(4.095,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-17.705),(4.455,-17.535),(4.625,-17.535),(4.625,-17.705),(4.455,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-17.705),(4.815,-17.535),(4.985,-17.535),(4.985,-17.705),(4.815,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-17.705),(5.175,-17.535),(5.345,-17.535),(5.345,-17.705),(5.175,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-17.705),(5.535,-17.535),(5.705,-17.535),(5.705,-17.705),(5.535,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-17.705),(5.895,-17.535),(6.065,-17.535),(6.065,-17.705),(5.895,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-17.705),(6.255,-17.535),(6.425,-17.535),(6.425,-17.705),(6.255,-17.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-17.345),(1.575,-17.175),(1.745,-17.175),(1.745,-17.345),(1.575,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-17.345),(1.935,-17.175),(2.105,-17.175),(2.105,-17.345),(1.935,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-17.345),(2.295,-17.175),(2.465,-17.175),(2.465,-17.345),(2.295,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-17.345),(2.655,-17.175),(2.825,-17.175),(2.825,-17.345),(2.655,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-17.345),(3.015,-17.175),(3.185,-17.175),(3.185,-17.345),(3.015,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-17.345),(3.375,-17.175),(3.545,-17.175),(3.545,-17.345),(3.375,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-17.345),(3.735,-17.175),(3.905,-17.175),(3.905,-17.345),(3.735,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-17.345),(4.095,-17.175),(4.265,-17.175),(4.265,-17.345),(4.095,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-17.345),(4.455,-17.175),(4.625,-17.175),(4.625,-17.345),(4.455,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-17.345),(4.815,-17.175),(4.985,-17.175),(4.985,-17.345),(4.815,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-17.345),(5.175,-17.175),(5.345,-17.175),(5.345,-17.345),(5.175,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-17.345),(5.535,-17.175),(5.705,-17.175),(5.705,-17.345),(5.535,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-17.345),(5.895,-17.175),(6.065,-17.175),(6.065,-17.345),(5.895,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-17.345),(6.255,-17.175),(6.425,-17.175),(6.425,-17.345),(6.255,-17.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-16.985),(1.575,-16.815),(1.745,-16.815),(1.745,-16.985),(1.575,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-16.985),(1.935,-16.815),(2.105,-16.815),(2.105,-16.985),(1.935,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-16.985),(2.295,-16.815),(2.465,-16.815),(2.465,-16.985),(2.295,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-16.985),(2.655,-16.815),(2.825,-16.815),(2.825,-16.985),(2.655,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-16.985),(3.015,-16.815),(3.185,-16.815),(3.185,-16.985),(3.015,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-16.985),(3.375,-16.815),(3.545,-16.815),(3.545,-16.985),(3.375,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-16.985),(3.735,-16.815),(3.905,-16.815),(3.905,-16.985),(3.735,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-16.985),(4.095,-16.815),(4.265,-16.815),(4.265,-16.985),(4.095,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-16.985),(4.455,-16.815),(4.625,-16.815),(4.625,-16.985),(4.455,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-16.985),(4.815,-16.815),(4.985,-16.815),(4.985,-16.985),(4.815,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-16.985),(5.175,-16.815),(5.345,-16.815),(5.345,-16.985),(5.175,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-16.985),(5.535,-16.815),(5.705,-16.815),(5.705,-16.985),(5.535,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-16.985),(5.895,-16.815),(6.065,-16.815),(6.065,-16.985),(5.895,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-16.985),(6.255,-16.815),(6.425,-16.815),(6.425,-16.985),(6.255,-16.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-16.625),(1.575,-16.455),(1.745,-16.455),(1.745,-16.625),(1.575,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-16.625),(1.935,-16.455),(2.105,-16.455),(2.105,-16.625),(1.935,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-16.625),(2.295,-16.455),(2.465,-16.455),(2.465,-16.625),(2.295,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-16.625),(2.655,-16.455),(2.825,-16.455),(2.825,-16.625),(2.655,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-16.625),(3.015,-16.455),(3.185,-16.455),(3.185,-16.625),(3.015,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-16.625),(3.375,-16.455),(3.545,-16.455),(3.545,-16.625),(3.375,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-16.625),(3.735,-16.455),(3.905,-16.455),(3.905,-16.625),(3.735,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-16.625),(4.095,-16.455),(4.265,-16.455),(4.265,-16.625),(4.095,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-16.625),(4.455,-16.455),(4.625,-16.455),(4.625,-16.625),(4.455,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-16.625),(4.815,-16.455),(4.985,-16.455),(4.985,-16.625),(4.815,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-16.625),(5.175,-16.455),(5.345,-16.455),(5.345,-16.625),(5.175,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-16.625),(5.535,-16.455),(5.705,-16.455),(5.705,-16.625),(5.535,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-16.625),(5.895,-16.455),(6.065,-16.455),(6.065,-16.625),(5.895,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-16.625),(6.255,-16.455),(6.425,-16.455),(6.425,-16.625),(6.255,-16.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-16.265),(1.575,-16.095),(1.745,-16.095),(1.745,-16.265),(1.575,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-16.265),(1.935,-16.095),(2.105,-16.095),(2.105,-16.265),(1.935,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-16.265),(2.295,-16.095),(2.465,-16.095),(2.465,-16.265),(2.295,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-16.265),(2.655,-16.095),(2.825,-16.095),(2.825,-16.265),(2.655,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-16.265),(3.015,-16.095),(3.185,-16.095),(3.185,-16.265),(3.015,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-16.265),(3.375,-16.095),(3.545,-16.095),(3.545,-16.265),(3.375,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-16.265),(3.735,-16.095),(3.905,-16.095),(3.905,-16.265),(3.735,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-16.265),(4.095,-16.095),(4.265,-16.095),(4.265,-16.265),(4.095,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-16.265),(4.455,-16.095),(4.625,-16.095),(4.625,-16.265),(4.455,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-16.265),(4.815,-16.095),(4.985,-16.095),(4.985,-16.265),(4.815,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-16.265),(5.175,-16.095),(5.345,-16.095),(5.345,-16.265),(5.175,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-16.265),(5.535,-16.095),(5.705,-16.095),(5.705,-16.265),(5.535,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-16.265),(5.895,-16.095),(6.065,-16.095),(6.065,-16.265),(5.895,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-16.265),(6.255,-16.095),(6.425,-16.095),(6.425,-16.265),(6.255,-16.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-15.905),(1.575,-15.735),(1.745,-15.735),(1.745,-15.905),(1.575,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-15.905),(1.935,-15.735),(2.105,-15.735),(2.105,-15.905),(1.935,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-15.905),(2.295,-15.735),(2.465,-15.735),(2.465,-15.905),(2.295,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-15.905),(2.655,-15.735),(2.825,-15.735),(2.825,-15.905),(2.655,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-15.905),(3.015,-15.735),(3.185,-15.735),(3.185,-15.905),(3.015,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-15.905),(3.375,-15.735),(3.545,-15.735),(3.545,-15.905),(3.375,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-15.905),(3.735,-15.735),(3.905,-15.735),(3.905,-15.905),(3.735,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-15.905),(4.095,-15.735),(4.265,-15.735),(4.265,-15.905),(4.095,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-15.905),(4.455,-15.735),(4.625,-15.735),(4.625,-15.905),(4.455,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-15.905),(4.815,-15.735),(4.985,-15.735),(4.985,-15.905),(4.815,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-15.905),(5.175,-15.735),(5.345,-15.735),(5.345,-15.905),(5.175,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-15.905),(5.535,-15.735),(5.705,-15.735),(5.705,-15.905),(5.535,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-15.905),(5.895,-15.735),(6.065,-15.735),(6.065,-15.905),(5.895,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-15.905),(6.255,-15.735),(6.425,-15.735),(6.425,-15.905),(6.255,-15.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-15.545),(1.575,-15.375),(1.745,-15.375),(1.745,-15.545),(1.575,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-15.545),(1.935,-15.375),(2.105,-15.375),(2.105,-15.545),(1.935,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-15.545),(2.295,-15.375),(2.465,-15.375),(2.465,-15.545),(2.295,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-15.545),(2.655,-15.375),(2.825,-15.375),(2.825,-15.545),(2.655,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-15.545),(3.015,-15.375),(3.185,-15.375),(3.185,-15.545),(3.015,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-15.545),(3.375,-15.375),(3.545,-15.375),(3.545,-15.545),(3.375,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-15.545),(3.735,-15.375),(3.905,-15.375),(3.905,-15.545),(3.735,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-15.545),(4.095,-15.375),(4.265,-15.375),(4.265,-15.545),(4.095,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-15.545),(4.455,-15.375),(4.625,-15.375),(4.625,-15.545),(4.455,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-15.545),(4.815,-15.375),(4.985,-15.375),(4.985,-15.545),(4.815,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-15.545),(5.175,-15.375),(5.345,-15.375),(5.345,-15.545),(5.175,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-15.545),(5.535,-15.375),(5.705,-15.375),(5.705,-15.545),(5.535,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-15.545),(5.895,-15.375),(6.065,-15.375),(6.065,-15.545),(5.895,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-15.545),(6.255,-15.375),(6.425,-15.375),(6.425,-15.545),(6.255,-15.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-15.185),(1.575,-15.015),(1.745,-15.015),(1.745,-15.185),(1.575,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-15.185),(1.935,-15.015),(2.105,-15.015),(2.105,-15.185),(1.935,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-15.185),(2.295,-15.015),(2.465,-15.015),(2.465,-15.185),(2.295,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-15.185),(2.655,-15.015),(2.825,-15.015),(2.825,-15.185),(2.655,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-15.185),(3.015,-15.015),(3.185,-15.015),(3.185,-15.185),(3.015,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-15.185),(3.375,-15.015),(3.545,-15.015),(3.545,-15.185),(3.375,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-15.185),(3.735,-15.015),(3.905,-15.015),(3.905,-15.185),(3.735,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-15.185),(4.095,-15.015),(4.265,-15.015),(4.265,-15.185),(4.095,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-15.185),(4.455,-15.015),(4.625,-15.015),(4.625,-15.185),(4.455,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-15.185),(4.815,-15.015),(4.985,-15.015),(4.985,-15.185),(4.815,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-15.185),(5.175,-15.015),(5.345,-15.015),(5.345,-15.185),(5.175,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-15.185),(5.535,-15.015),(5.705,-15.015),(5.705,-15.185),(5.535,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-15.185),(5.895,-15.015),(6.065,-15.015),(6.065,-15.185),(5.895,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-15.185),(6.255,-15.015),(6.425,-15.015),(6.425,-15.185),(6.255,-15.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-14.825),(1.575,-14.655),(1.745,-14.655),(1.745,-14.825),(1.575,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-14.825),(1.935,-14.655),(2.105,-14.655),(2.105,-14.825),(1.935,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-14.825),(2.295,-14.655),(2.465,-14.655),(2.465,-14.825),(2.295,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-14.825),(2.655,-14.655),(2.825,-14.655),(2.825,-14.825),(2.655,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-14.825),(3.015,-14.655),(3.185,-14.655),(3.185,-14.825),(3.015,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-14.825),(3.375,-14.655),(3.545,-14.655),(3.545,-14.825),(3.375,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-14.825),(3.735,-14.655),(3.905,-14.655),(3.905,-14.825),(3.735,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-14.825),(4.095,-14.655),(4.265,-14.655),(4.265,-14.825),(4.095,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-14.825),(4.455,-14.655),(4.625,-14.655),(4.625,-14.825),(4.455,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-14.825),(4.815,-14.655),(4.985,-14.655),(4.985,-14.825),(4.815,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-14.825),(5.175,-14.655),(5.345,-14.655),(5.345,-14.825),(5.175,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-14.825),(5.535,-14.655),(5.705,-14.655),(5.705,-14.825),(5.535,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-14.825),(5.895,-14.655),(6.065,-14.655),(6.065,-14.825),(5.895,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-14.825),(6.255,-14.655),(6.425,-14.655),(6.425,-14.825),(6.255,-14.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-14.465),(1.575,-14.295),(1.745,-14.295),(1.745,-14.465),(1.575,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-14.465),(1.935,-14.295),(2.105,-14.295),(2.105,-14.465),(1.935,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-14.465),(2.295,-14.295),(2.465,-14.295),(2.465,-14.465),(2.295,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-14.465),(2.655,-14.295),(2.825,-14.295),(2.825,-14.465),(2.655,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-14.465),(3.015,-14.295),(3.185,-14.295),(3.185,-14.465),(3.015,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-14.465),(3.375,-14.295),(3.545,-14.295),(3.545,-14.465),(3.375,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-14.465),(3.735,-14.295),(3.905,-14.295),(3.905,-14.465),(3.735,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-14.465),(4.095,-14.295),(4.265,-14.295),(4.265,-14.465),(4.095,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-14.465),(4.455,-14.295),(4.625,-14.295),(4.625,-14.465),(4.455,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-14.465),(4.815,-14.295),(4.985,-14.295),(4.985,-14.465),(4.815,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-14.465),(5.175,-14.295),(5.345,-14.295),(5.345,-14.465),(5.175,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-14.465),(5.535,-14.295),(5.705,-14.295),(5.705,-14.465),(5.535,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-14.465),(5.895,-14.295),(6.065,-14.295),(6.065,-14.465),(5.895,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-14.465),(6.255,-14.295),(6.425,-14.295),(6.425,-14.465),(6.255,-14.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-14.105),(1.575,-13.935),(1.745,-13.935),(1.745,-14.105),(1.575,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-14.105),(1.935,-13.935),(2.105,-13.935),(2.105,-14.105),(1.935,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-14.105),(2.295,-13.935),(2.465,-13.935),(2.465,-14.105),(2.295,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-14.105),(2.655,-13.935),(2.825,-13.935),(2.825,-14.105),(2.655,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-14.105),(3.015,-13.935),(3.185,-13.935),(3.185,-14.105),(3.015,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-14.105),(3.375,-13.935),(3.545,-13.935),(3.545,-14.105),(3.375,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-14.105),(3.735,-13.935),(3.905,-13.935),(3.905,-14.105),(3.735,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-14.105),(4.095,-13.935),(4.265,-13.935),(4.265,-14.105),(4.095,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-14.105),(4.455,-13.935),(4.625,-13.935),(4.625,-14.105),(4.455,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-14.105),(4.815,-13.935),(4.985,-13.935),(4.985,-14.105),(4.815,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-14.105),(5.175,-13.935),(5.345,-13.935),(5.345,-14.105),(5.175,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-14.105),(5.535,-13.935),(5.705,-13.935),(5.705,-14.105),(5.535,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-14.105),(5.895,-13.935),(6.065,-13.935),(6.065,-14.105),(5.895,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-14.105),(6.255,-13.935),(6.425,-13.935),(6.425,-14.105),(6.255,-14.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-13.745),(1.575,-13.575),(1.745,-13.575),(1.745,-13.745),(1.575,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-13.745),(1.935,-13.575),(2.105,-13.575),(2.105,-13.745),(1.935,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-13.745),(2.295,-13.575),(2.465,-13.575),(2.465,-13.745),(2.295,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-13.745),(2.655,-13.575),(2.825,-13.575),(2.825,-13.745),(2.655,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-13.745),(3.015,-13.575),(3.185,-13.575),(3.185,-13.745),(3.015,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-13.745),(3.375,-13.575),(3.545,-13.575),(3.545,-13.745),(3.375,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-13.745),(3.735,-13.575),(3.905,-13.575),(3.905,-13.745),(3.735,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-13.745),(4.095,-13.575),(4.265,-13.575),(4.265,-13.745),(4.095,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-13.745),(4.455,-13.575),(4.625,-13.575),(4.625,-13.745),(4.455,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-13.745),(4.815,-13.575),(4.985,-13.575),(4.985,-13.745),(4.815,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-13.745),(5.175,-13.575),(5.345,-13.575),(5.345,-13.745),(5.175,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-13.745),(5.535,-13.575),(5.705,-13.575),(5.705,-13.745),(5.535,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-13.745),(5.895,-13.575),(6.065,-13.575),(6.065,-13.745),(5.895,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-13.745),(6.255,-13.575),(6.425,-13.575),(6.425,-13.745),(6.255,-13.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-13.385),(1.575,-13.215),(1.745,-13.215),(1.745,-13.385),(1.575,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-13.385),(1.935,-13.215),(2.105,-13.215),(2.105,-13.385),(1.935,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-13.385),(2.295,-13.215),(2.465,-13.215),(2.465,-13.385),(2.295,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-13.385),(2.655,-13.215),(2.825,-13.215),(2.825,-13.385),(2.655,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-13.385),(3.015,-13.215),(3.185,-13.215),(3.185,-13.385),(3.015,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-13.385),(3.375,-13.215),(3.545,-13.215),(3.545,-13.385),(3.375,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-13.385),(3.735,-13.215),(3.905,-13.215),(3.905,-13.385),(3.735,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-13.385),(4.095,-13.215),(4.265,-13.215),(4.265,-13.385),(4.095,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-13.385),(4.455,-13.215),(4.625,-13.215),(4.625,-13.385),(4.455,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-13.385),(4.815,-13.215),(4.985,-13.215),(4.985,-13.385),(4.815,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-13.385),(5.175,-13.215),(5.345,-13.215),(5.345,-13.385),(5.175,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-13.385),(5.535,-13.215),(5.705,-13.215),(5.705,-13.385),(5.535,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-13.385),(5.895,-13.215),(6.065,-13.215),(6.065,-13.385),(5.895,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-13.385),(6.255,-13.215),(6.425,-13.215),(6.425,-13.385),(6.255,-13.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-13.025),(1.575,-12.855),(1.745,-12.855),(1.745,-13.025),(1.575,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-13.025),(1.935,-12.855),(2.105,-12.855),(2.105,-13.025),(1.935,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-13.025),(2.295,-12.855),(2.465,-12.855),(2.465,-13.025),(2.295,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-13.025),(2.655,-12.855),(2.825,-12.855),(2.825,-13.025),(2.655,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-13.025),(3.015,-12.855),(3.185,-12.855),(3.185,-13.025),(3.015,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-13.025),(3.375,-12.855),(3.545,-12.855),(3.545,-13.025),(3.375,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-13.025),(3.735,-12.855),(3.905,-12.855),(3.905,-13.025),(3.735,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-13.025),(4.095,-12.855),(4.265,-12.855),(4.265,-13.025),(4.095,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-13.025),(4.455,-12.855),(4.625,-12.855),(4.625,-13.025),(4.455,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-13.025),(4.815,-12.855),(4.985,-12.855),(4.985,-13.025),(4.815,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-13.025),(5.175,-12.855),(5.345,-12.855),(5.345,-13.025),(5.175,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-13.025),(5.535,-12.855),(5.705,-12.855),(5.705,-13.025),(5.535,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-13.025),(5.895,-12.855),(6.065,-12.855),(6.065,-13.025),(5.895,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-13.025),(6.255,-12.855),(6.425,-12.855),(6.425,-13.025),(6.255,-13.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-12.665),(1.575,-12.495),(1.745,-12.495),(1.745,-12.665),(1.575,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-12.665),(1.935,-12.495),(2.105,-12.495),(2.105,-12.665),(1.935,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-12.665),(2.295,-12.495),(2.465,-12.495),(2.465,-12.665),(2.295,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-12.665),(2.655,-12.495),(2.825,-12.495),(2.825,-12.665),(2.655,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-12.665),(3.015,-12.495),(3.185,-12.495),(3.185,-12.665),(3.015,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-12.665),(3.375,-12.495),(3.545,-12.495),(3.545,-12.665),(3.375,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-12.665),(3.735,-12.495),(3.905,-12.495),(3.905,-12.665),(3.735,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-12.665),(4.095,-12.495),(4.265,-12.495),(4.265,-12.665),(4.095,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-12.665),(4.455,-12.495),(4.625,-12.495),(4.625,-12.665),(4.455,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-12.665),(4.815,-12.495),(4.985,-12.495),(4.985,-12.665),(4.815,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-12.665),(5.175,-12.495),(5.345,-12.495),(5.345,-12.665),(5.175,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-12.665),(5.535,-12.495),(5.705,-12.495),(5.705,-12.665),(5.535,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-12.665),(5.895,-12.495),(6.065,-12.495),(6.065,-12.665),(5.895,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-12.665),(6.255,-12.495),(6.425,-12.495),(6.425,-12.665),(6.255,-12.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-12.305),(1.575,-12.135),(1.745,-12.135),(1.745,-12.305),(1.575,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-12.305),(1.935,-12.135),(2.105,-12.135),(2.105,-12.305),(1.935,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-12.305),(2.295,-12.135),(2.465,-12.135),(2.465,-12.305),(2.295,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-12.305),(2.655,-12.135),(2.825,-12.135),(2.825,-12.305),(2.655,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-12.305),(3.015,-12.135),(3.185,-12.135),(3.185,-12.305),(3.015,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-12.305),(3.375,-12.135),(3.545,-12.135),(3.545,-12.305),(3.375,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-12.305),(3.735,-12.135),(3.905,-12.135),(3.905,-12.305),(3.735,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-12.305),(4.095,-12.135),(4.265,-12.135),(4.265,-12.305),(4.095,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-12.305),(4.455,-12.135),(4.625,-12.135),(4.625,-12.305),(4.455,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-12.305),(4.815,-12.135),(4.985,-12.135),(4.985,-12.305),(4.815,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-12.305),(5.175,-12.135),(5.345,-12.135),(5.345,-12.305),(5.175,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-12.305),(5.535,-12.135),(5.705,-12.135),(5.705,-12.305),(5.535,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-12.305),(5.895,-12.135),(6.065,-12.135),(6.065,-12.305),(5.895,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-12.305),(6.255,-12.135),(6.425,-12.135),(6.425,-12.305),(6.255,-12.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-11.945),(1.575,-11.775),(1.745,-11.775),(1.745,-11.945),(1.575,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-11.945),(1.935,-11.775),(2.105,-11.775),(2.105,-11.945),(1.935,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-11.945),(2.295,-11.775),(2.465,-11.775),(2.465,-11.945),(2.295,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-11.945),(2.655,-11.775),(2.825,-11.775),(2.825,-11.945),(2.655,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-11.945),(3.015,-11.775),(3.185,-11.775),(3.185,-11.945),(3.015,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-11.945),(3.375,-11.775),(3.545,-11.775),(3.545,-11.945),(3.375,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-11.945),(3.735,-11.775),(3.905,-11.775),(3.905,-11.945),(3.735,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-11.945),(4.095,-11.775),(4.265,-11.775),(4.265,-11.945),(4.095,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-11.945),(4.455,-11.775),(4.625,-11.775),(4.625,-11.945),(4.455,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-11.945),(4.815,-11.775),(4.985,-11.775),(4.985,-11.945),(4.815,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-11.945),(5.175,-11.775),(5.345,-11.775),(5.345,-11.945),(5.175,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-11.945),(5.535,-11.775),(5.705,-11.775),(5.705,-11.945),(5.535,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-11.945),(5.895,-11.775),(6.065,-11.775),(6.065,-11.945),(5.895,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-11.945),(6.255,-11.775),(6.425,-11.775),(6.425,-11.945),(6.255,-11.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-11.585),(1.575,-11.415),(1.745,-11.415),(1.745,-11.585),(1.575,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-11.585),(1.935,-11.415),(2.105,-11.415),(2.105,-11.585),(1.935,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-11.585),(2.295,-11.415),(2.465,-11.415),(2.465,-11.585),(2.295,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-11.585),(2.655,-11.415),(2.825,-11.415),(2.825,-11.585),(2.655,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-11.585),(3.015,-11.415),(3.185,-11.415),(3.185,-11.585),(3.015,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-11.585),(3.375,-11.415),(3.545,-11.415),(3.545,-11.585),(3.375,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-11.585),(3.735,-11.415),(3.905,-11.415),(3.905,-11.585),(3.735,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-11.585),(4.095,-11.415),(4.265,-11.415),(4.265,-11.585),(4.095,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-11.585),(4.455,-11.415),(4.625,-11.415),(4.625,-11.585),(4.455,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-11.585),(4.815,-11.415),(4.985,-11.415),(4.985,-11.585),(4.815,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-11.585),(5.175,-11.415),(5.345,-11.415),(5.345,-11.585),(5.175,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-11.585),(5.535,-11.415),(5.705,-11.415),(5.705,-11.585),(5.535,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-11.585),(5.895,-11.415),(6.065,-11.415),(6.065,-11.585),(5.895,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-11.585),(6.255,-11.415),(6.425,-11.415),(6.425,-11.585),(6.255,-11.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.575,-11.225),(1.575,-11.055),(1.745,-11.055),(1.745,-11.225),(1.575,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((1.935,-11.225),(1.935,-11.055),(2.105,-11.055),(2.105,-11.225),(1.935,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.295,-11.225),(2.295,-11.055),(2.465,-11.055),(2.465,-11.225),(2.295,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((2.655,-11.225),(2.655,-11.055),(2.825,-11.055),(2.825,-11.225),(2.655,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.015,-11.225),(3.015,-11.055),(3.185,-11.055),(3.185,-11.225),(3.015,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.375,-11.225),(3.375,-11.055),(3.545,-11.055),(3.545,-11.225),(3.375,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((3.735,-11.225),(3.735,-11.055),(3.905,-11.055),(3.905,-11.225),(3.735,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.095,-11.225),(4.095,-11.055),(4.265,-11.055),(4.265,-11.225),(4.095,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.455,-11.225),(4.455,-11.055),(4.625,-11.055),(4.625,-11.225),(4.455,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.815,-11.225),(4.815,-11.055),(4.985,-11.055),(4.985,-11.225),(4.815,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.175,-11.225),(5.175,-11.055),(5.345,-11.055),(5.345,-11.225),(5.175,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.535,-11.225),(5.535,-11.055),(5.705,-11.055),(5.705,-11.225),(5.535,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((5.895,-11.225),(5.895,-11.055),(6.065,-11.055),(6.065,-11.225),(5.895,-11.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.255,-11.225),(6.255,-11.055),(6.425,-11.055),(6.425,-11.225),(6.255,-11.225)),
        )
        createRL(
            tech, net, 'm1',
            ((1.5,-21.0),(1.5,-11.0),(6.5,-11.0),(6.5,-21.0),(1.5,-21.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.0,-21.0),(83.0,-11.0),(88.0,-11.0),(88.0,-21.0),(83.0,-21.0)),
        )
        createRL(
            tech, net, 'm1',
            ((1.545,-21.005),(1.545,-10.995),(6.455,-10.995),(6.455,-21.005),(1.545,-21.005)),
        )
        createRL(
            tech, net, 'm1',
            ((83.045,-21.005),(83.045,-10.995),(87.955,-10.995),(87.955,-21.005),(83.045,-21.005)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-20.875),(1.685,-20.725),(1.835,-20.725),(1.835,-20.875),(1.685,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-20.875),(2.005,-20.725),(2.155,-20.725),(2.155,-20.875),(2.005,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-20.875),(2.325,-20.725),(2.475,-20.725),(2.475,-20.875),(2.325,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-20.875),(2.645,-20.725),(2.795,-20.725),(2.795,-20.875),(2.645,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-20.875),(2.965,-20.725),(3.115,-20.725),(3.115,-20.875),(2.965,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-20.875),(3.285,-20.725),(3.435,-20.725),(3.435,-20.875),(3.285,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-20.875),(3.605,-20.725),(3.755,-20.725),(3.755,-20.875),(3.605,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-20.875),(3.925,-20.725),(4.075,-20.725),(4.075,-20.875),(3.925,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-20.875),(4.245,-20.725),(4.395,-20.725),(4.395,-20.875),(4.245,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-20.875),(4.565,-20.725),(4.715,-20.725),(4.715,-20.875),(4.565,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-20.875),(4.885,-20.725),(5.035,-20.725),(5.035,-20.875),(4.885,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-20.875),(5.205,-20.725),(5.355,-20.725),(5.355,-20.875),(5.205,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-20.875),(5.525,-20.725),(5.675,-20.725),(5.675,-20.875),(5.525,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-20.875),(5.845,-20.725),(5.995,-20.725),(5.995,-20.875),(5.845,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-20.875),(6.165,-20.725),(6.315,-20.725),(6.315,-20.875),(6.165,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-20.555),(1.685,-20.405),(1.835,-20.405),(1.835,-20.555),(1.685,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-20.555),(2.005,-20.405),(2.155,-20.405),(2.155,-20.555),(2.005,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-20.555),(2.325,-20.405),(2.475,-20.405),(2.475,-20.555),(2.325,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-20.555),(2.645,-20.405),(2.795,-20.405),(2.795,-20.555),(2.645,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-20.555),(2.965,-20.405),(3.115,-20.405),(3.115,-20.555),(2.965,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-20.555),(3.285,-20.405),(3.435,-20.405),(3.435,-20.555),(3.285,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-20.555),(3.605,-20.405),(3.755,-20.405),(3.755,-20.555),(3.605,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-20.555),(3.925,-20.405),(4.075,-20.405),(4.075,-20.555),(3.925,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-20.555),(4.245,-20.405),(4.395,-20.405),(4.395,-20.555),(4.245,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-20.555),(4.565,-20.405),(4.715,-20.405),(4.715,-20.555),(4.565,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-20.555),(4.885,-20.405),(5.035,-20.405),(5.035,-20.555),(4.885,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-20.555),(5.205,-20.405),(5.355,-20.405),(5.355,-20.555),(5.205,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-20.555),(5.525,-20.405),(5.675,-20.405),(5.675,-20.555),(5.525,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-20.555),(5.845,-20.405),(5.995,-20.405),(5.995,-20.555),(5.845,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-20.555),(6.165,-20.405),(6.315,-20.405),(6.315,-20.555),(6.165,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-20.235),(1.685,-20.085),(1.835,-20.085),(1.835,-20.235),(1.685,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-20.235),(2.005,-20.085),(2.155,-20.085),(2.155,-20.235),(2.005,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-20.235),(2.325,-20.085),(2.475,-20.085),(2.475,-20.235),(2.325,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-20.235),(2.645,-20.085),(2.795,-20.085),(2.795,-20.235),(2.645,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-20.235),(2.965,-20.085),(3.115,-20.085),(3.115,-20.235),(2.965,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-20.235),(3.285,-20.085),(3.435,-20.085),(3.435,-20.235),(3.285,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-20.235),(3.605,-20.085),(3.755,-20.085),(3.755,-20.235),(3.605,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-20.235),(3.925,-20.085),(4.075,-20.085),(4.075,-20.235),(3.925,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-20.235),(4.245,-20.085),(4.395,-20.085),(4.395,-20.235),(4.245,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-20.235),(4.565,-20.085),(4.715,-20.085),(4.715,-20.235),(4.565,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-20.235),(4.885,-20.085),(5.035,-20.085),(5.035,-20.235),(4.885,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-20.235),(5.205,-20.085),(5.355,-20.085),(5.355,-20.235),(5.205,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-20.235),(5.525,-20.085),(5.675,-20.085),(5.675,-20.235),(5.525,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-20.235),(5.845,-20.085),(5.995,-20.085),(5.995,-20.235),(5.845,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-20.235),(6.165,-20.085),(6.315,-20.085),(6.315,-20.235),(6.165,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-19.915),(1.685,-19.765),(1.835,-19.765),(1.835,-19.915),(1.685,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-19.915),(2.005,-19.765),(2.155,-19.765),(2.155,-19.915),(2.005,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-19.915),(2.325,-19.765),(2.475,-19.765),(2.475,-19.915),(2.325,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-19.915),(2.645,-19.765),(2.795,-19.765),(2.795,-19.915),(2.645,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-19.915),(2.965,-19.765),(3.115,-19.765),(3.115,-19.915),(2.965,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-19.915),(3.285,-19.765),(3.435,-19.765),(3.435,-19.915),(3.285,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-19.915),(3.605,-19.765),(3.755,-19.765),(3.755,-19.915),(3.605,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-19.915),(3.925,-19.765),(4.075,-19.765),(4.075,-19.915),(3.925,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-19.915),(4.245,-19.765),(4.395,-19.765),(4.395,-19.915),(4.245,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-19.915),(4.565,-19.765),(4.715,-19.765),(4.715,-19.915),(4.565,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-19.915),(4.885,-19.765),(5.035,-19.765),(5.035,-19.915),(4.885,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-19.915),(5.205,-19.765),(5.355,-19.765),(5.355,-19.915),(5.205,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-19.915),(5.525,-19.765),(5.675,-19.765),(5.675,-19.915),(5.525,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-19.915),(5.845,-19.765),(5.995,-19.765),(5.995,-19.915),(5.845,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-19.915),(6.165,-19.765),(6.315,-19.765),(6.315,-19.915),(6.165,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-19.595),(1.685,-19.445),(1.835,-19.445),(1.835,-19.595),(1.685,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-19.595),(2.005,-19.445),(2.155,-19.445),(2.155,-19.595),(2.005,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-19.595),(2.325,-19.445),(2.475,-19.445),(2.475,-19.595),(2.325,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-19.595),(2.645,-19.445),(2.795,-19.445),(2.795,-19.595),(2.645,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-19.595),(2.965,-19.445),(3.115,-19.445),(3.115,-19.595),(2.965,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-19.595),(3.285,-19.445),(3.435,-19.445),(3.435,-19.595),(3.285,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-19.595),(3.605,-19.445),(3.755,-19.445),(3.755,-19.595),(3.605,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-19.595),(3.925,-19.445),(4.075,-19.445),(4.075,-19.595),(3.925,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-19.595),(4.245,-19.445),(4.395,-19.445),(4.395,-19.595),(4.245,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-19.595),(4.565,-19.445),(4.715,-19.445),(4.715,-19.595),(4.565,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-19.595),(4.885,-19.445),(5.035,-19.445),(5.035,-19.595),(4.885,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-19.595),(5.205,-19.445),(5.355,-19.445),(5.355,-19.595),(5.205,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-19.595),(5.525,-19.445),(5.675,-19.445),(5.675,-19.595),(5.525,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-19.595),(5.845,-19.445),(5.995,-19.445),(5.995,-19.595),(5.845,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-19.595),(6.165,-19.445),(6.315,-19.445),(6.315,-19.595),(6.165,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-19.275),(1.685,-19.125),(1.835,-19.125),(1.835,-19.275),(1.685,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-19.275),(2.005,-19.125),(2.155,-19.125),(2.155,-19.275),(2.005,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-19.275),(2.325,-19.125),(2.475,-19.125),(2.475,-19.275),(2.325,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-19.275),(2.645,-19.125),(2.795,-19.125),(2.795,-19.275),(2.645,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-19.275),(2.965,-19.125),(3.115,-19.125),(3.115,-19.275),(2.965,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-19.275),(3.285,-19.125),(3.435,-19.125),(3.435,-19.275),(3.285,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-19.275),(3.605,-19.125),(3.755,-19.125),(3.755,-19.275),(3.605,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-19.275),(3.925,-19.125),(4.075,-19.125),(4.075,-19.275),(3.925,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-19.275),(4.245,-19.125),(4.395,-19.125),(4.395,-19.275),(4.245,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-19.275),(4.565,-19.125),(4.715,-19.125),(4.715,-19.275),(4.565,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-19.275),(4.885,-19.125),(5.035,-19.125),(5.035,-19.275),(4.885,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-19.275),(5.205,-19.125),(5.355,-19.125),(5.355,-19.275),(5.205,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-19.275),(5.525,-19.125),(5.675,-19.125),(5.675,-19.275),(5.525,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-19.275),(5.845,-19.125),(5.995,-19.125),(5.995,-19.275),(5.845,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-19.275),(6.165,-19.125),(6.315,-19.125),(6.315,-19.275),(6.165,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-18.955),(1.685,-18.805),(1.835,-18.805),(1.835,-18.955),(1.685,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-18.955),(2.005,-18.805),(2.155,-18.805),(2.155,-18.955),(2.005,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-18.955),(2.325,-18.805),(2.475,-18.805),(2.475,-18.955),(2.325,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-18.955),(2.645,-18.805),(2.795,-18.805),(2.795,-18.955),(2.645,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-18.955),(2.965,-18.805),(3.115,-18.805),(3.115,-18.955),(2.965,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-18.955),(3.285,-18.805),(3.435,-18.805),(3.435,-18.955),(3.285,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-18.955),(3.605,-18.805),(3.755,-18.805),(3.755,-18.955),(3.605,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-18.955),(3.925,-18.805),(4.075,-18.805),(4.075,-18.955),(3.925,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-18.955),(4.245,-18.805),(4.395,-18.805),(4.395,-18.955),(4.245,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-18.955),(4.565,-18.805),(4.715,-18.805),(4.715,-18.955),(4.565,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-18.955),(4.885,-18.805),(5.035,-18.805),(5.035,-18.955),(4.885,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-18.955),(5.205,-18.805),(5.355,-18.805),(5.355,-18.955),(5.205,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-18.955),(5.525,-18.805),(5.675,-18.805),(5.675,-18.955),(5.525,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-18.955),(5.845,-18.805),(5.995,-18.805),(5.995,-18.955),(5.845,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-18.955),(6.165,-18.805),(6.315,-18.805),(6.315,-18.955),(6.165,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-18.635),(1.685,-18.485),(1.835,-18.485),(1.835,-18.635),(1.685,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-18.635),(2.005,-18.485),(2.155,-18.485),(2.155,-18.635),(2.005,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-18.635),(2.325,-18.485),(2.475,-18.485),(2.475,-18.635),(2.325,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-18.635),(2.645,-18.485),(2.795,-18.485),(2.795,-18.635),(2.645,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-18.635),(2.965,-18.485),(3.115,-18.485),(3.115,-18.635),(2.965,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-18.635),(3.285,-18.485),(3.435,-18.485),(3.435,-18.635),(3.285,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-18.635),(3.605,-18.485),(3.755,-18.485),(3.755,-18.635),(3.605,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-18.635),(3.925,-18.485),(4.075,-18.485),(4.075,-18.635),(3.925,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-18.635),(4.245,-18.485),(4.395,-18.485),(4.395,-18.635),(4.245,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-18.635),(4.565,-18.485),(4.715,-18.485),(4.715,-18.635),(4.565,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-18.635),(4.885,-18.485),(5.035,-18.485),(5.035,-18.635),(4.885,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-18.635),(5.205,-18.485),(5.355,-18.485),(5.355,-18.635),(5.205,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-18.635),(5.525,-18.485),(5.675,-18.485),(5.675,-18.635),(5.525,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-18.635),(5.845,-18.485),(5.995,-18.485),(5.995,-18.635),(5.845,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-18.635),(6.165,-18.485),(6.315,-18.485),(6.315,-18.635),(6.165,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-18.315),(1.685,-18.165),(1.835,-18.165),(1.835,-18.315),(1.685,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-18.315),(2.005,-18.165),(2.155,-18.165),(2.155,-18.315),(2.005,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-18.315),(2.325,-18.165),(2.475,-18.165),(2.475,-18.315),(2.325,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-18.315),(2.645,-18.165),(2.795,-18.165),(2.795,-18.315),(2.645,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-18.315),(2.965,-18.165),(3.115,-18.165),(3.115,-18.315),(2.965,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-18.315),(3.285,-18.165),(3.435,-18.165),(3.435,-18.315),(3.285,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-18.315),(3.605,-18.165),(3.755,-18.165),(3.755,-18.315),(3.605,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-18.315),(3.925,-18.165),(4.075,-18.165),(4.075,-18.315),(3.925,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-18.315),(4.245,-18.165),(4.395,-18.165),(4.395,-18.315),(4.245,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-18.315),(4.565,-18.165),(4.715,-18.165),(4.715,-18.315),(4.565,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-18.315),(4.885,-18.165),(5.035,-18.165),(5.035,-18.315),(4.885,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-18.315),(5.205,-18.165),(5.355,-18.165),(5.355,-18.315),(5.205,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-18.315),(5.525,-18.165),(5.675,-18.165),(5.675,-18.315),(5.525,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-18.315),(5.845,-18.165),(5.995,-18.165),(5.995,-18.315),(5.845,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-18.315),(6.165,-18.165),(6.315,-18.165),(6.315,-18.315),(6.165,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-17.995),(1.685,-17.845),(1.835,-17.845),(1.835,-17.995),(1.685,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-17.995),(2.005,-17.845),(2.155,-17.845),(2.155,-17.995),(2.005,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-17.995),(2.325,-17.845),(2.475,-17.845),(2.475,-17.995),(2.325,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-17.995),(2.645,-17.845),(2.795,-17.845),(2.795,-17.995),(2.645,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-17.995),(2.965,-17.845),(3.115,-17.845),(3.115,-17.995),(2.965,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-17.995),(3.285,-17.845),(3.435,-17.845),(3.435,-17.995),(3.285,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-17.995),(3.605,-17.845),(3.755,-17.845),(3.755,-17.995),(3.605,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-17.995),(3.925,-17.845),(4.075,-17.845),(4.075,-17.995),(3.925,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-17.995),(4.245,-17.845),(4.395,-17.845),(4.395,-17.995),(4.245,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-17.995),(4.565,-17.845),(4.715,-17.845),(4.715,-17.995),(4.565,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-17.995),(4.885,-17.845),(5.035,-17.845),(5.035,-17.995),(4.885,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-17.995),(5.205,-17.845),(5.355,-17.845),(5.355,-17.995),(5.205,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-17.995),(5.525,-17.845),(5.675,-17.845),(5.675,-17.995),(5.525,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-17.995),(5.845,-17.845),(5.995,-17.845),(5.995,-17.995),(5.845,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-17.995),(6.165,-17.845),(6.315,-17.845),(6.315,-17.995),(6.165,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-17.675),(1.685,-17.525),(1.835,-17.525),(1.835,-17.675),(1.685,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-17.675),(2.005,-17.525),(2.155,-17.525),(2.155,-17.675),(2.005,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-17.675),(2.325,-17.525),(2.475,-17.525),(2.475,-17.675),(2.325,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-17.675),(2.645,-17.525),(2.795,-17.525),(2.795,-17.675),(2.645,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-17.675),(2.965,-17.525),(3.115,-17.525),(3.115,-17.675),(2.965,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-17.675),(3.285,-17.525),(3.435,-17.525),(3.435,-17.675),(3.285,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-17.675),(3.605,-17.525),(3.755,-17.525),(3.755,-17.675),(3.605,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-17.675),(3.925,-17.525),(4.075,-17.525),(4.075,-17.675),(3.925,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-17.675),(4.245,-17.525),(4.395,-17.525),(4.395,-17.675),(4.245,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-17.675),(4.565,-17.525),(4.715,-17.525),(4.715,-17.675),(4.565,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-17.675),(4.885,-17.525),(5.035,-17.525),(5.035,-17.675),(4.885,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-17.675),(5.205,-17.525),(5.355,-17.525),(5.355,-17.675),(5.205,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-17.675),(5.525,-17.525),(5.675,-17.525),(5.675,-17.675),(5.525,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-17.675),(5.845,-17.525),(5.995,-17.525),(5.995,-17.675),(5.845,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-17.675),(6.165,-17.525),(6.315,-17.525),(6.315,-17.675),(6.165,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-17.355),(1.685,-17.205),(1.835,-17.205),(1.835,-17.355),(1.685,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-17.355),(2.005,-17.205),(2.155,-17.205),(2.155,-17.355),(2.005,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-17.355),(2.325,-17.205),(2.475,-17.205),(2.475,-17.355),(2.325,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-17.355),(2.645,-17.205),(2.795,-17.205),(2.795,-17.355),(2.645,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-17.355),(2.965,-17.205),(3.115,-17.205),(3.115,-17.355),(2.965,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-17.355),(3.285,-17.205),(3.435,-17.205),(3.435,-17.355),(3.285,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-17.355),(3.605,-17.205),(3.755,-17.205),(3.755,-17.355),(3.605,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-17.355),(3.925,-17.205),(4.075,-17.205),(4.075,-17.355),(3.925,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-17.355),(4.245,-17.205),(4.395,-17.205),(4.395,-17.355),(4.245,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-17.355),(4.565,-17.205),(4.715,-17.205),(4.715,-17.355),(4.565,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-17.355),(4.885,-17.205),(5.035,-17.205),(5.035,-17.355),(4.885,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-17.355),(5.205,-17.205),(5.355,-17.205),(5.355,-17.355),(5.205,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-17.355),(5.525,-17.205),(5.675,-17.205),(5.675,-17.355),(5.525,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-17.355),(5.845,-17.205),(5.995,-17.205),(5.995,-17.355),(5.845,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-17.355),(6.165,-17.205),(6.315,-17.205),(6.315,-17.355),(6.165,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-17.035),(1.685,-16.885),(1.835,-16.885),(1.835,-17.035),(1.685,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-17.035),(2.005,-16.885),(2.155,-16.885),(2.155,-17.035),(2.005,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-17.035),(2.325,-16.885),(2.475,-16.885),(2.475,-17.035),(2.325,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-17.035),(2.645,-16.885),(2.795,-16.885),(2.795,-17.035),(2.645,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-17.035),(2.965,-16.885),(3.115,-16.885),(3.115,-17.035),(2.965,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-17.035),(3.285,-16.885),(3.435,-16.885),(3.435,-17.035),(3.285,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-17.035),(3.605,-16.885),(3.755,-16.885),(3.755,-17.035),(3.605,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-17.035),(3.925,-16.885),(4.075,-16.885),(4.075,-17.035),(3.925,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-17.035),(4.245,-16.885),(4.395,-16.885),(4.395,-17.035),(4.245,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-17.035),(4.565,-16.885),(4.715,-16.885),(4.715,-17.035),(4.565,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-17.035),(4.885,-16.885),(5.035,-16.885),(5.035,-17.035),(4.885,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-17.035),(5.205,-16.885),(5.355,-16.885),(5.355,-17.035),(5.205,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-17.035),(5.525,-16.885),(5.675,-16.885),(5.675,-17.035),(5.525,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-17.035),(5.845,-16.885),(5.995,-16.885),(5.995,-17.035),(5.845,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-17.035),(6.165,-16.885),(6.315,-16.885),(6.315,-17.035),(6.165,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-16.715),(1.685,-16.565),(1.835,-16.565),(1.835,-16.715),(1.685,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-16.715),(2.005,-16.565),(2.155,-16.565),(2.155,-16.715),(2.005,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-16.715),(2.325,-16.565),(2.475,-16.565),(2.475,-16.715),(2.325,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-16.715),(2.645,-16.565),(2.795,-16.565),(2.795,-16.715),(2.645,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-16.715),(2.965,-16.565),(3.115,-16.565),(3.115,-16.715),(2.965,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-16.715),(3.285,-16.565),(3.435,-16.565),(3.435,-16.715),(3.285,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-16.715),(3.605,-16.565),(3.755,-16.565),(3.755,-16.715),(3.605,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-16.715),(3.925,-16.565),(4.075,-16.565),(4.075,-16.715),(3.925,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-16.715),(4.245,-16.565),(4.395,-16.565),(4.395,-16.715),(4.245,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-16.715),(4.565,-16.565),(4.715,-16.565),(4.715,-16.715),(4.565,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-16.715),(4.885,-16.565),(5.035,-16.565),(5.035,-16.715),(4.885,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-16.715),(5.205,-16.565),(5.355,-16.565),(5.355,-16.715),(5.205,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-16.715),(5.525,-16.565),(5.675,-16.565),(5.675,-16.715),(5.525,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-16.715),(5.845,-16.565),(5.995,-16.565),(5.995,-16.715),(5.845,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-16.715),(6.165,-16.565),(6.315,-16.565),(6.315,-16.715),(6.165,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-16.395),(1.685,-16.245),(1.835,-16.245),(1.835,-16.395),(1.685,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-16.395),(2.005,-16.245),(2.155,-16.245),(2.155,-16.395),(2.005,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-16.395),(2.325,-16.245),(2.475,-16.245),(2.475,-16.395),(2.325,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-16.395),(2.645,-16.245),(2.795,-16.245),(2.795,-16.395),(2.645,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-16.395),(2.965,-16.245),(3.115,-16.245),(3.115,-16.395),(2.965,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-16.395),(3.285,-16.245),(3.435,-16.245),(3.435,-16.395),(3.285,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-16.395),(3.605,-16.245),(3.755,-16.245),(3.755,-16.395),(3.605,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-16.395),(3.925,-16.245),(4.075,-16.245),(4.075,-16.395),(3.925,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-16.395),(4.245,-16.245),(4.395,-16.245),(4.395,-16.395),(4.245,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-16.395),(4.565,-16.245),(4.715,-16.245),(4.715,-16.395),(4.565,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-16.395),(4.885,-16.245),(5.035,-16.245),(5.035,-16.395),(4.885,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-16.395),(5.205,-16.245),(5.355,-16.245),(5.355,-16.395),(5.205,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-16.395),(5.525,-16.245),(5.675,-16.245),(5.675,-16.395),(5.525,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-16.395),(5.845,-16.245),(5.995,-16.245),(5.995,-16.395),(5.845,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-16.395),(6.165,-16.245),(6.315,-16.245),(6.315,-16.395),(6.165,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-16.075),(1.685,-15.925),(1.835,-15.925),(1.835,-16.075),(1.685,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-16.075),(2.005,-15.925),(2.155,-15.925),(2.155,-16.075),(2.005,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-16.075),(2.325,-15.925),(2.475,-15.925),(2.475,-16.075),(2.325,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-16.075),(2.645,-15.925),(2.795,-15.925),(2.795,-16.075),(2.645,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-16.075),(2.965,-15.925),(3.115,-15.925),(3.115,-16.075),(2.965,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-16.075),(3.285,-15.925),(3.435,-15.925),(3.435,-16.075),(3.285,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-16.075),(3.605,-15.925),(3.755,-15.925),(3.755,-16.075),(3.605,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-16.075),(3.925,-15.925),(4.075,-15.925),(4.075,-16.075),(3.925,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-16.075),(4.245,-15.925),(4.395,-15.925),(4.395,-16.075),(4.245,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-16.075),(4.565,-15.925),(4.715,-15.925),(4.715,-16.075),(4.565,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-16.075),(4.885,-15.925),(5.035,-15.925),(5.035,-16.075),(4.885,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-16.075),(5.205,-15.925),(5.355,-15.925),(5.355,-16.075),(5.205,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-16.075),(5.525,-15.925),(5.675,-15.925),(5.675,-16.075),(5.525,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-16.075),(5.845,-15.925),(5.995,-15.925),(5.995,-16.075),(5.845,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-16.075),(6.165,-15.925),(6.315,-15.925),(6.315,-16.075),(6.165,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-15.755),(1.685,-15.605),(1.835,-15.605),(1.835,-15.755),(1.685,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-15.755),(2.005,-15.605),(2.155,-15.605),(2.155,-15.755),(2.005,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-15.755),(2.325,-15.605),(2.475,-15.605),(2.475,-15.755),(2.325,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-15.755),(2.645,-15.605),(2.795,-15.605),(2.795,-15.755),(2.645,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-15.755),(2.965,-15.605),(3.115,-15.605),(3.115,-15.755),(2.965,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-15.755),(3.285,-15.605),(3.435,-15.605),(3.435,-15.755),(3.285,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-15.755),(3.605,-15.605),(3.755,-15.605),(3.755,-15.755),(3.605,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-15.755),(3.925,-15.605),(4.075,-15.605),(4.075,-15.755),(3.925,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-15.755),(4.245,-15.605),(4.395,-15.605),(4.395,-15.755),(4.245,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-15.755),(4.565,-15.605),(4.715,-15.605),(4.715,-15.755),(4.565,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-15.755),(4.885,-15.605),(5.035,-15.605),(5.035,-15.755),(4.885,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-15.755),(5.205,-15.605),(5.355,-15.605),(5.355,-15.755),(5.205,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-15.755),(5.525,-15.605),(5.675,-15.605),(5.675,-15.755),(5.525,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-15.755),(5.845,-15.605),(5.995,-15.605),(5.995,-15.755),(5.845,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-15.755),(6.165,-15.605),(6.315,-15.605),(6.315,-15.755),(6.165,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-15.435),(1.685,-15.285),(1.835,-15.285),(1.835,-15.435),(1.685,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-15.435),(2.005,-15.285),(2.155,-15.285),(2.155,-15.435),(2.005,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-15.435),(2.325,-15.285),(2.475,-15.285),(2.475,-15.435),(2.325,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-15.435),(2.645,-15.285),(2.795,-15.285),(2.795,-15.435),(2.645,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-15.435),(2.965,-15.285),(3.115,-15.285),(3.115,-15.435),(2.965,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-15.435),(3.285,-15.285),(3.435,-15.285),(3.435,-15.435),(3.285,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-15.435),(3.605,-15.285),(3.755,-15.285),(3.755,-15.435),(3.605,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-15.435),(3.925,-15.285),(4.075,-15.285),(4.075,-15.435),(3.925,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-15.435),(4.245,-15.285),(4.395,-15.285),(4.395,-15.435),(4.245,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-15.435),(4.565,-15.285),(4.715,-15.285),(4.715,-15.435),(4.565,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-15.435),(4.885,-15.285),(5.035,-15.285),(5.035,-15.435),(4.885,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-15.435),(5.205,-15.285),(5.355,-15.285),(5.355,-15.435),(5.205,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-15.435),(5.525,-15.285),(5.675,-15.285),(5.675,-15.435),(5.525,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-15.435),(5.845,-15.285),(5.995,-15.285),(5.995,-15.435),(5.845,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-15.435),(6.165,-15.285),(6.315,-15.285),(6.315,-15.435),(6.165,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-15.115),(1.685,-14.965),(1.835,-14.965),(1.835,-15.115),(1.685,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-15.115),(2.005,-14.965),(2.155,-14.965),(2.155,-15.115),(2.005,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-15.115),(2.325,-14.965),(2.475,-14.965),(2.475,-15.115),(2.325,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-15.115),(2.645,-14.965),(2.795,-14.965),(2.795,-15.115),(2.645,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-15.115),(2.965,-14.965),(3.115,-14.965),(3.115,-15.115),(2.965,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-15.115),(3.285,-14.965),(3.435,-14.965),(3.435,-15.115),(3.285,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-15.115),(3.605,-14.965),(3.755,-14.965),(3.755,-15.115),(3.605,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-15.115),(3.925,-14.965),(4.075,-14.965),(4.075,-15.115),(3.925,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-15.115),(4.245,-14.965),(4.395,-14.965),(4.395,-15.115),(4.245,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-15.115),(4.565,-14.965),(4.715,-14.965),(4.715,-15.115),(4.565,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-15.115),(4.885,-14.965),(5.035,-14.965),(5.035,-15.115),(4.885,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-15.115),(5.205,-14.965),(5.355,-14.965),(5.355,-15.115),(5.205,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-15.115),(5.525,-14.965),(5.675,-14.965),(5.675,-15.115),(5.525,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-15.115),(5.845,-14.965),(5.995,-14.965),(5.995,-15.115),(5.845,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-15.115),(6.165,-14.965),(6.315,-14.965),(6.315,-15.115),(6.165,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-14.795),(1.685,-14.645),(1.835,-14.645),(1.835,-14.795),(1.685,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-14.795),(2.005,-14.645),(2.155,-14.645),(2.155,-14.795),(2.005,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-14.795),(2.325,-14.645),(2.475,-14.645),(2.475,-14.795),(2.325,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-14.795),(2.645,-14.645),(2.795,-14.645),(2.795,-14.795),(2.645,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-14.795),(2.965,-14.645),(3.115,-14.645),(3.115,-14.795),(2.965,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-14.795),(3.285,-14.645),(3.435,-14.645),(3.435,-14.795),(3.285,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-14.795),(3.605,-14.645),(3.755,-14.645),(3.755,-14.795),(3.605,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-14.795),(3.925,-14.645),(4.075,-14.645),(4.075,-14.795),(3.925,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-14.795),(4.245,-14.645),(4.395,-14.645),(4.395,-14.795),(4.245,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-14.795),(4.565,-14.645),(4.715,-14.645),(4.715,-14.795),(4.565,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-14.795),(4.885,-14.645),(5.035,-14.645),(5.035,-14.795),(4.885,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-14.795),(5.205,-14.645),(5.355,-14.645),(5.355,-14.795),(5.205,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-14.795),(5.525,-14.645),(5.675,-14.645),(5.675,-14.795),(5.525,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-14.795),(5.845,-14.645),(5.995,-14.645),(5.995,-14.795),(5.845,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-14.795),(6.165,-14.645),(6.315,-14.645),(6.315,-14.795),(6.165,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-14.475),(1.685,-14.325),(1.835,-14.325),(1.835,-14.475),(1.685,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-14.475),(2.005,-14.325),(2.155,-14.325),(2.155,-14.475),(2.005,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-14.475),(2.325,-14.325),(2.475,-14.325),(2.475,-14.475),(2.325,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-14.475),(2.645,-14.325),(2.795,-14.325),(2.795,-14.475),(2.645,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-14.475),(2.965,-14.325),(3.115,-14.325),(3.115,-14.475),(2.965,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-14.475),(3.285,-14.325),(3.435,-14.325),(3.435,-14.475),(3.285,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-14.475),(3.605,-14.325),(3.755,-14.325),(3.755,-14.475),(3.605,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-14.475),(3.925,-14.325),(4.075,-14.325),(4.075,-14.475),(3.925,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-14.475),(4.245,-14.325),(4.395,-14.325),(4.395,-14.475),(4.245,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-14.475),(4.565,-14.325),(4.715,-14.325),(4.715,-14.475),(4.565,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-14.475),(4.885,-14.325),(5.035,-14.325),(5.035,-14.475),(4.885,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-14.475),(5.205,-14.325),(5.355,-14.325),(5.355,-14.475),(5.205,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-14.475),(5.525,-14.325),(5.675,-14.325),(5.675,-14.475),(5.525,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-14.475),(5.845,-14.325),(5.995,-14.325),(5.995,-14.475),(5.845,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-14.475),(6.165,-14.325),(6.315,-14.325),(6.315,-14.475),(6.165,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-14.155),(1.685,-14.005),(1.835,-14.005),(1.835,-14.155),(1.685,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-14.155),(2.005,-14.005),(2.155,-14.005),(2.155,-14.155),(2.005,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-14.155),(2.325,-14.005),(2.475,-14.005),(2.475,-14.155),(2.325,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-14.155),(2.645,-14.005),(2.795,-14.005),(2.795,-14.155),(2.645,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-14.155),(2.965,-14.005),(3.115,-14.005),(3.115,-14.155),(2.965,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-14.155),(3.285,-14.005),(3.435,-14.005),(3.435,-14.155),(3.285,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-14.155),(3.605,-14.005),(3.755,-14.005),(3.755,-14.155),(3.605,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-14.155),(3.925,-14.005),(4.075,-14.005),(4.075,-14.155),(3.925,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-14.155),(4.245,-14.005),(4.395,-14.005),(4.395,-14.155),(4.245,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-14.155),(4.565,-14.005),(4.715,-14.005),(4.715,-14.155),(4.565,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-14.155),(4.885,-14.005),(5.035,-14.005),(5.035,-14.155),(4.885,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-14.155),(5.205,-14.005),(5.355,-14.005),(5.355,-14.155),(5.205,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-14.155),(5.525,-14.005),(5.675,-14.005),(5.675,-14.155),(5.525,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-14.155),(5.845,-14.005),(5.995,-14.005),(5.995,-14.155),(5.845,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-14.155),(6.165,-14.005),(6.315,-14.005),(6.315,-14.155),(6.165,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-13.835),(1.685,-13.685),(1.835,-13.685),(1.835,-13.835),(1.685,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-13.835),(2.005,-13.685),(2.155,-13.685),(2.155,-13.835),(2.005,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-13.835),(2.325,-13.685),(2.475,-13.685),(2.475,-13.835),(2.325,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-13.835),(2.645,-13.685),(2.795,-13.685),(2.795,-13.835),(2.645,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-13.835),(2.965,-13.685),(3.115,-13.685),(3.115,-13.835),(2.965,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-13.835),(3.285,-13.685),(3.435,-13.685),(3.435,-13.835),(3.285,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-13.835),(3.605,-13.685),(3.755,-13.685),(3.755,-13.835),(3.605,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-13.835),(3.925,-13.685),(4.075,-13.685),(4.075,-13.835),(3.925,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-13.835),(4.245,-13.685),(4.395,-13.685),(4.395,-13.835),(4.245,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-13.835),(4.565,-13.685),(4.715,-13.685),(4.715,-13.835),(4.565,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-13.835),(4.885,-13.685),(5.035,-13.685),(5.035,-13.835),(4.885,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-13.835),(5.205,-13.685),(5.355,-13.685),(5.355,-13.835),(5.205,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-13.835),(5.525,-13.685),(5.675,-13.685),(5.675,-13.835),(5.525,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-13.835),(5.845,-13.685),(5.995,-13.685),(5.995,-13.835),(5.845,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-13.835),(6.165,-13.685),(6.315,-13.685),(6.315,-13.835),(6.165,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-13.515),(1.685,-13.365),(1.835,-13.365),(1.835,-13.515),(1.685,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-13.515),(2.005,-13.365),(2.155,-13.365),(2.155,-13.515),(2.005,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-13.515),(2.325,-13.365),(2.475,-13.365),(2.475,-13.515),(2.325,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-13.515),(2.645,-13.365),(2.795,-13.365),(2.795,-13.515),(2.645,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-13.515),(2.965,-13.365),(3.115,-13.365),(3.115,-13.515),(2.965,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-13.515),(3.285,-13.365),(3.435,-13.365),(3.435,-13.515),(3.285,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-13.515),(3.605,-13.365),(3.755,-13.365),(3.755,-13.515),(3.605,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-13.515),(3.925,-13.365),(4.075,-13.365),(4.075,-13.515),(3.925,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-13.515),(4.245,-13.365),(4.395,-13.365),(4.395,-13.515),(4.245,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-13.515),(4.565,-13.365),(4.715,-13.365),(4.715,-13.515),(4.565,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-13.515),(4.885,-13.365),(5.035,-13.365),(5.035,-13.515),(4.885,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-13.515),(5.205,-13.365),(5.355,-13.365),(5.355,-13.515),(5.205,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-13.515),(5.525,-13.365),(5.675,-13.365),(5.675,-13.515),(5.525,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-13.515),(5.845,-13.365),(5.995,-13.365),(5.995,-13.515),(5.845,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-13.515),(6.165,-13.365),(6.315,-13.365),(6.315,-13.515),(6.165,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-13.195),(1.685,-13.045),(1.835,-13.045),(1.835,-13.195),(1.685,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-13.195),(2.005,-13.045),(2.155,-13.045),(2.155,-13.195),(2.005,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-13.195),(2.325,-13.045),(2.475,-13.045),(2.475,-13.195),(2.325,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-13.195),(2.645,-13.045),(2.795,-13.045),(2.795,-13.195),(2.645,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-13.195),(2.965,-13.045),(3.115,-13.045),(3.115,-13.195),(2.965,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-13.195),(3.285,-13.045),(3.435,-13.045),(3.435,-13.195),(3.285,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-13.195),(3.605,-13.045),(3.755,-13.045),(3.755,-13.195),(3.605,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-13.195),(3.925,-13.045),(4.075,-13.045),(4.075,-13.195),(3.925,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-13.195),(4.245,-13.045),(4.395,-13.045),(4.395,-13.195),(4.245,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-13.195),(4.565,-13.045),(4.715,-13.045),(4.715,-13.195),(4.565,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-13.195),(4.885,-13.045),(5.035,-13.045),(5.035,-13.195),(4.885,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-13.195),(5.205,-13.045),(5.355,-13.045),(5.355,-13.195),(5.205,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-13.195),(5.525,-13.045),(5.675,-13.045),(5.675,-13.195),(5.525,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-13.195),(5.845,-13.045),(5.995,-13.045),(5.995,-13.195),(5.845,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-13.195),(6.165,-13.045),(6.315,-13.045),(6.315,-13.195),(6.165,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-12.875),(1.685,-12.725),(1.835,-12.725),(1.835,-12.875),(1.685,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-12.875),(2.005,-12.725),(2.155,-12.725),(2.155,-12.875),(2.005,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-12.875),(2.325,-12.725),(2.475,-12.725),(2.475,-12.875),(2.325,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-12.875),(2.645,-12.725),(2.795,-12.725),(2.795,-12.875),(2.645,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-12.875),(2.965,-12.725),(3.115,-12.725),(3.115,-12.875),(2.965,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-12.875),(3.285,-12.725),(3.435,-12.725),(3.435,-12.875),(3.285,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-12.875),(3.605,-12.725),(3.755,-12.725),(3.755,-12.875),(3.605,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-12.875),(3.925,-12.725),(4.075,-12.725),(4.075,-12.875),(3.925,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-12.875),(4.245,-12.725),(4.395,-12.725),(4.395,-12.875),(4.245,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-12.875),(4.565,-12.725),(4.715,-12.725),(4.715,-12.875),(4.565,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-12.875),(4.885,-12.725),(5.035,-12.725),(5.035,-12.875),(4.885,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-12.875),(5.205,-12.725),(5.355,-12.725),(5.355,-12.875),(5.205,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-12.875),(5.525,-12.725),(5.675,-12.725),(5.675,-12.875),(5.525,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-12.875),(5.845,-12.725),(5.995,-12.725),(5.995,-12.875),(5.845,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-12.875),(6.165,-12.725),(6.315,-12.725),(6.315,-12.875),(6.165,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-12.555),(1.685,-12.405),(1.835,-12.405),(1.835,-12.555),(1.685,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-12.555),(2.005,-12.405),(2.155,-12.405),(2.155,-12.555),(2.005,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-12.555),(2.325,-12.405),(2.475,-12.405),(2.475,-12.555),(2.325,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-12.555),(2.645,-12.405),(2.795,-12.405),(2.795,-12.555),(2.645,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-12.555),(2.965,-12.405),(3.115,-12.405),(3.115,-12.555),(2.965,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-12.555),(3.285,-12.405),(3.435,-12.405),(3.435,-12.555),(3.285,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-12.555),(3.605,-12.405),(3.755,-12.405),(3.755,-12.555),(3.605,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-12.555),(3.925,-12.405),(4.075,-12.405),(4.075,-12.555),(3.925,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-12.555),(4.245,-12.405),(4.395,-12.405),(4.395,-12.555),(4.245,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-12.555),(4.565,-12.405),(4.715,-12.405),(4.715,-12.555),(4.565,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-12.555),(4.885,-12.405),(5.035,-12.405),(5.035,-12.555),(4.885,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-12.555),(5.205,-12.405),(5.355,-12.405),(5.355,-12.555),(5.205,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-12.555),(5.525,-12.405),(5.675,-12.405),(5.675,-12.555),(5.525,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-12.555),(5.845,-12.405),(5.995,-12.405),(5.995,-12.555),(5.845,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-12.555),(6.165,-12.405),(6.315,-12.405),(6.315,-12.555),(6.165,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-12.235),(1.685,-12.085),(1.835,-12.085),(1.835,-12.235),(1.685,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-12.235),(2.005,-12.085),(2.155,-12.085),(2.155,-12.235),(2.005,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-12.235),(2.325,-12.085),(2.475,-12.085),(2.475,-12.235),(2.325,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-12.235),(2.645,-12.085),(2.795,-12.085),(2.795,-12.235),(2.645,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-12.235),(2.965,-12.085),(3.115,-12.085),(3.115,-12.235),(2.965,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-12.235),(3.285,-12.085),(3.435,-12.085),(3.435,-12.235),(3.285,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-12.235),(3.605,-12.085),(3.755,-12.085),(3.755,-12.235),(3.605,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-12.235),(3.925,-12.085),(4.075,-12.085),(4.075,-12.235),(3.925,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-12.235),(4.245,-12.085),(4.395,-12.085),(4.395,-12.235),(4.245,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-12.235),(4.565,-12.085),(4.715,-12.085),(4.715,-12.235),(4.565,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-12.235),(4.885,-12.085),(5.035,-12.085),(5.035,-12.235),(4.885,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-12.235),(5.205,-12.085),(5.355,-12.085),(5.355,-12.235),(5.205,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-12.235),(5.525,-12.085),(5.675,-12.085),(5.675,-12.235),(5.525,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-12.235),(5.845,-12.085),(5.995,-12.085),(5.995,-12.235),(5.845,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-12.235),(6.165,-12.085),(6.315,-12.085),(6.315,-12.235),(6.165,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-11.915),(1.685,-11.765),(1.835,-11.765),(1.835,-11.915),(1.685,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-11.915),(2.005,-11.765),(2.155,-11.765),(2.155,-11.915),(2.005,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-11.915),(2.325,-11.765),(2.475,-11.765),(2.475,-11.915),(2.325,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-11.915),(2.645,-11.765),(2.795,-11.765),(2.795,-11.915),(2.645,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-11.915),(2.965,-11.765),(3.115,-11.765),(3.115,-11.915),(2.965,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-11.915),(3.285,-11.765),(3.435,-11.765),(3.435,-11.915),(3.285,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-11.915),(3.605,-11.765),(3.755,-11.765),(3.755,-11.915),(3.605,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-11.915),(3.925,-11.765),(4.075,-11.765),(4.075,-11.915),(3.925,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-11.915),(4.245,-11.765),(4.395,-11.765),(4.395,-11.915),(4.245,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-11.915),(4.565,-11.765),(4.715,-11.765),(4.715,-11.915),(4.565,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-11.915),(4.885,-11.765),(5.035,-11.765),(5.035,-11.915),(4.885,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-11.915),(5.205,-11.765),(5.355,-11.765),(5.355,-11.915),(5.205,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-11.915),(5.525,-11.765),(5.675,-11.765),(5.675,-11.915),(5.525,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-11.915),(5.845,-11.765),(5.995,-11.765),(5.995,-11.915),(5.845,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-11.915),(6.165,-11.765),(6.315,-11.765),(6.315,-11.915),(6.165,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-11.595),(1.685,-11.445),(1.835,-11.445),(1.835,-11.595),(1.685,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-11.595),(2.005,-11.445),(2.155,-11.445),(2.155,-11.595),(2.005,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-11.595),(2.325,-11.445),(2.475,-11.445),(2.475,-11.595),(2.325,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-11.595),(2.645,-11.445),(2.795,-11.445),(2.795,-11.595),(2.645,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-11.595),(2.965,-11.445),(3.115,-11.445),(3.115,-11.595),(2.965,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-11.595),(3.285,-11.445),(3.435,-11.445),(3.435,-11.595),(3.285,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-11.595),(3.605,-11.445),(3.755,-11.445),(3.755,-11.595),(3.605,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-11.595),(3.925,-11.445),(4.075,-11.445),(4.075,-11.595),(3.925,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-11.595),(4.245,-11.445),(4.395,-11.445),(4.395,-11.595),(4.245,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-11.595),(4.565,-11.445),(4.715,-11.445),(4.715,-11.595),(4.565,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-11.595),(4.885,-11.445),(5.035,-11.445),(5.035,-11.595),(4.885,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-11.595),(5.205,-11.445),(5.355,-11.445),(5.355,-11.595),(5.205,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-11.595),(5.525,-11.445),(5.675,-11.445),(5.675,-11.595),(5.525,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-11.595),(5.845,-11.445),(5.995,-11.445),(5.995,-11.595),(5.845,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-11.595),(6.165,-11.445),(6.315,-11.445),(6.315,-11.595),(6.165,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((1.685,-11.275),(1.685,-11.125),(1.835,-11.125),(1.835,-11.275),(1.685,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.005,-11.275),(2.005,-11.125),(2.155,-11.125),(2.155,-11.275),(2.005,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.325,-11.275),(2.325,-11.125),(2.475,-11.125),(2.475,-11.275),(2.325,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.645,-11.275),(2.645,-11.125),(2.795,-11.125),(2.795,-11.275),(2.645,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((2.965,-11.275),(2.965,-11.125),(3.115,-11.125),(3.115,-11.275),(2.965,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.285,-11.275),(3.285,-11.125),(3.435,-11.125),(3.435,-11.275),(3.285,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.605,-11.275),(3.605,-11.125),(3.755,-11.125),(3.755,-11.275),(3.605,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((3.925,-11.275),(3.925,-11.125),(4.075,-11.125),(4.075,-11.275),(3.925,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.245,-11.275),(4.245,-11.125),(4.395,-11.125),(4.395,-11.275),(4.245,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.565,-11.275),(4.565,-11.125),(4.715,-11.125),(4.715,-11.275),(4.565,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((4.885,-11.275),(4.885,-11.125),(5.035,-11.125),(5.035,-11.275),(4.885,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((5.205,-11.275),(5.205,-11.125),(5.355,-11.125),(5.355,-11.275),(5.205,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((5.525,-11.275),(5.525,-11.125),(5.675,-11.125),(5.675,-11.275),(5.525,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((5.845,-11.275),(5.845,-11.125),(5.995,-11.125),(5.995,-11.275),(5.845,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((6.165,-11.275),(6.165,-11.125),(6.315,-11.125),(6.315,-11.275),(6.165,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-20.875),(83.185,-20.725),(83.335,-20.725),(83.335,-20.875),(83.185,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-20.875),(83.505,-20.725),(83.655,-20.725),(83.655,-20.875),(83.505,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-20.875),(83.825,-20.725),(83.975,-20.725),(83.975,-20.875),(83.825,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-20.875),(84.145,-20.725),(84.295,-20.725),(84.295,-20.875),(84.145,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-20.875),(84.465,-20.725),(84.615,-20.725),(84.615,-20.875),(84.465,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-20.875),(84.785,-20.725),(84.935,-20.725),(84.935,-20.875),(84.785,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-20.875),(85.105,-20.725),(85.255,-20.725),(85.255,-20.875),(85.105,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-20.875),(85.425,-20.725),(85.575,-20.725),(85.575,-20.875),(85.425,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-20.875),(85.745,-20.725),(85.895,-20.725),(85.895,-20.875),(85.745,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-20.875),(86.065,-20.725),(86.215,-20.725),(86.215,-20.875),(86.065,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-20.875),(86.385,-20.725),(86.535,-20.725),(86.535,-20.875),(86.385,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-20.875),(86.705,-20.725),(86.855,-20.725),(86.855,-20.875),(86.705,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-20.875),(87.025,-20.725),(87.175,-20.725),(87.175,-20.875),(87.025,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-20.875),(87.345,-20.725),(87.495,-20.725),(87.495,-20.875),(87.345,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-20.875),(87.665,-20.725),(87.815,-20.725),(87.815,-20.875),(87.665,-20.875)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-20.555),(83.185,-20.405),(83.335,-20.405),(83.335,-20.555),(83.185,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-20.555),(83.505,-20.405),(83.655,-20.405),(83.655,-20.555),(83.505,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-20.555),(83.825,-20.405),(83.975,-20.405),(83.975,-20.555),(83.825,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-20.555),(84.145,-20.405),(84.295,-20.405),(84.295,-20.555),(84.145,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-20.555),(84.465,-20.405),(84.615,-20.405),(84.615,-20.555),(84.465,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-20.555),(84.785,-20.405),(84.935,-20.405),(84.935,-20.555),(84.785,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-20.555),(85.105,-20.405),(85.255,-20.405),(85.255,-20.555),(85.105,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-20.555),(85.425,-20.405),(85.575,-20.405),(85.575,-20.555),(85.425,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-20.555),(85.745,-20.405),(85.895,-20.405),(85.895,-20.555),(85.745,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-20.555),(86.065,-20.405),(86.215,-20.405),(86.215,-20.555),(86.065,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-20.555),(86.385,-20.405),(86.535,-20.405),(86.535,-20.555),(86.385,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-20.555),(86.705,-20.405),(86.855,-20.405),(86.855,-20.555),(86.705,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-20.555),(87.025,-20.405),(87.175,-20.405),(87.175,-20.555),(87.025,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-20.555),(87.345,-20.405),(87.495,-20.405),(87.495,-20.555),(87.345,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-20.555),(87.665,-20.405),(87.815,-20.405),(87.815,-20.555),(87.665,-20.555)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-20.235),(83.185,-20.085),(83.335,-20.085),(83.335,-20.235),(83.185,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-20.235),(83.505,-20.085),(83.655,-20.085),(83.655,-20.235),(83.505,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-20.235),(83.825,-20.085),(83.975,-20.085),(83.975,-20.235),(83.825,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-20.235),(84.145,-20.085),(84.295,-20.085),(84.295,-20.235),(84.145,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-20.235),(84.465,-20.085),(84.615,-20.085),(84.615,-20.235),(84.465,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-20.235),(84.785,-20.085),(84.935,-20.085),(84.935,-20.235),(84.785,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-20.235),(85.105,-20.085),(85.255,-20.085),(85.255,-20.235),(85.105,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-20.235),(85.425,-20.085),(85.575,-20.085),(85.575,-20.235),(85.425,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-20.235),(85.745,-20.085),(85.895,-20.085),(85.895,-20.235),(85.745,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-20.235),(86.065,-20.085),(86.215,-20.085),(86.215,-20.235),(86.065,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-20.235),(86.385,-20.085),(86.535,-20.085),(86.535,-20.235),(86.385,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-20.235),(86.705,-20.085),(86.855,-20.085),(86.855,-20.235),(86.705,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-20.235),(87.025,-20.085),(87.175,-20.085),(87.175,-20.235),(87.025,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-20.235),(87.345,-20.085),(87.495,-20.085),(87.495,-20.235),(87.345,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-20.235),(87.665,-20.085),(87.815,-20.085),(87.815,-20.235),(87.665,-20.235)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-19.915),(83.185,-19.765),(83.335,-19.765),(83.335,-19.915),(83.185,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-19.915),(83.505,-19.765),(83.655,-19.765),(83.655,-19.915),(83.505,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-19.915),(83.825,-19.765),(83.975,-19.765),(83.975,-19.915),(83.825,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-19.915),(84.145,-19.765),(84.295,-19.765),(84.295,-19.915),(84.145,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-19.915),(84.465,-19.765),(84.615,-19.765),(84.615,-19.915),(84.465,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-19.915),(84.785,-19.765),(84.935,-19.765),(84.935,-19.915),(84.785,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-19.915),(85.105,-19.765),(85.255,-19.765),(85.255,-19.915),(85.105,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-19.915),(85.425,-19.765),(85.575,-19.765),(85.575,-19.915),(85.425,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-19.915),(85.745,-19.765),(85.895,-19.765),(85.895,-19.915),(85.745,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-19.915),(86.065,-19.765),(86.215,-19.765),(86.215,-19.915),(86.065,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-19.915),(86.385,-19.765),(86.535,-19.765),(86.535,-19.915),(86.385,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-19.915),(86.705,-19.765),(86.855,-19.765),(86.855,-19.915),(86.705,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-19.915),(87.025,-19.765),(87.175,-19.765),(87.175,-19.915),(87.025,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-19.915),(87.345,-19.765),(87.495,-19.765),(87.495,-19.915),(87.345,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-19.915),(87.665,-19.765),(87.815,-19.765),(87.815,-19.915),(87.665,-19.915)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-19.595),(83.185,-19.445),(83.335,-19.445),(83.335,-19.595),(83.185,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-19.595),(83.505,-19.445),(83.655,-19.445),(83.655,-19.595),(83.505,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-19.595),(83.825,-19.445),(83.975,-19.445),(83.975,-19.595),(83.825,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-19.595),(84.145,-19.445),(84.295,-19.445),(84.295,-19.595),(84.145,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-19.595),(84.465,-19.445),(84.615,-19.445),(84.615,-19.595),(84.465,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-19.595),(84.785,-19.445),(84.935,-19.445),(84.935,-19.595),(84.785,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-19.595),(85.105,-19.445),(85.255,-19.445),(85.255,-19.595),(85.105,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-19.595),(85.425,-19.445),(85.575,-19.445),(85.575,-19.595),(85.425,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-19.595),(85.745,-19.445),(85.895,-19.445),(85.895,-19.595),(85.745,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-19.595),(86.065,-19.445),(86.215,-19.445),(86.215,-19.595),(86.065,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-19.595),(86.385,-19.445),(86.535,-19.445),(86.535,-19.595),(86.385,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-19.595),(86.705,-19.445),(86.855,-19.445),(86.855,-19.595),(86.705,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-19.595),(87.025,-19.445),(87.175,-19.445),(87.175,-19.595),(87.025,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-19.595),(87.345,-19.445),(87.495,-19.445),(87.495,-19.595),(87.345,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-19.595),(87.665,-19.445),(87.815,-19.445),(87.815,-19.595),(87.665,-19.595)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-19.275),(83.185,-19.125),(83.335,-19.125),(83.335,-19.275),(83.185,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-19.275),(83.505,-19.125),(83.655,-19.125),(83.655,-19.275),(83.505,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-19.275),(83.825,-19.125),(83.975,-19.125),(83.975,-19.275),(83.825,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-19.275),(84.145,-19.125),(84.295,-19.125),(84.295,-19.275),(84.145,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-19.275),(84.465,-19.125),(84.615,-19.125),(84.615,-19.275),(84.465,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-19.275),(84.785,-19.125),(84.935,-19.125),(84.935,-19.275),(84.785,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-19.275),(85.105,-19.125),(85.255,-19.125),(85.255,-19.275),(85.105,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-19.275),(85.425,-19.125),(85.575,-19.125),(85.575,-19.275),(85.425,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-19.275),(85.745,-19.125),(85.895,-19.125),(85.895,-19.275),(85.745,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-19.275),(86.065,-19.125),(86.215,-19.125),(86.215,-19.275),(86.065,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-19.275),(86.385,-19.125),(86.535,-19.125),(86.535,-19.275),(86.385,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-19.275),(86.705,-19.125),(86.855,-19.125),(86.855,-19.275),(86.705,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-19.275),(87.025,-19.125),(87.175,-19.125),(87.175,-19.275),(87.025,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-19.275),(87.345,-19.125),(87.495,-19.125),(87.495,-19.275),(87.345,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-19.275),(87.665,-19.125),(87.815,-19.125),(87.815,-19.275),(87.665,-19.275)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-18.955),(83.185,-18.805),(83.335,-18.805),(83.335,-18.955),(83.185,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-18.955),(83.505,-18.805),(83.655,-18.805),(83.655,-18.955),(83.505,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-18.955),(83.825,-18.805),(83.975,-18.805),(83.975,-18.955),(83.825,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-18.955),(84.145,-18.805),(84.295,-18.805),(84.295,-18.955),(84.145,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-18.955),(84.465,-18.805),(84.615,-18.805),(84.615,-18.955),(84.465,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-18.955),(84.785,-18.805),(84.935,-18.805),(84.935,-18.955),(84.785,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-18.955),(85.105,-18.805),(85.255,-18.805),(85.255,-18.955),(85.105,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-18.955),(85.425,-18.805),(85.575,-18.805),(85.575,-18.955),(85.425,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-18.955),(85.745,-18.805),(85.895,-18.805),(85.895,-18.955),(85.745,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-18.955),(86.065,-18.805),(86.215,-18.805),(86.215,-18.955),(86.065,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-18.955),(86.385,-18.805),(86.535,-18.805),(86.535,-18.955),(86.385,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-18.955),(86.705,-18.805),(86.855,-18.805),(86.855,-18.955),(86.705,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-18.955),(87.025,-18.805),(87.175,-18.805),(87.175,-18.955),(87.025,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-18.955),(87.345,-18.805),(87.495,-18.805),(87.495,-18.955),(87.345,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-18.955),(87.665,-18.805),(87.815,-18.805),(87.815,-18.955),(87.665,-18.955)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-18.635),(83.185,-18.485),(83.335,-18.485),(83.335,-18.635),(83.185,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-18.635),(83.505,-18.485),(83.655,-18.485),(83.655,-18.635),(83.505,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-18.635),(83.825,-18.485),(83.975,-18.485),(83.975,-18.635),(83.825,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-18.635),(84.145,-18.485),(84.295,-18.485),(84.295,-18.635),(84.145,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-18.635),(84.465,-18.485),(84.615,-18.485),(84.615,-18.635),(84.465,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-18.635),(84.785,-18.485),(84.935,-18.485),(84.935,-18.635),(84.785,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-18.635),(85.105,-18.485),(85.255,-18.485),(85.255,-18.635),(85.105,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-18.635),(85.425,-18.485),(85.575,-18.485),(85.575,-18.635),(85.425,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-18.635),(85.745,-18.485),(85.895,-18.485),(85.895,-18.635),(85.745,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-18.635),(86.065,-18.485),(86.215,-18.485),(86.215,-18.635),(86.065,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-18.635),(86.385,-18.485),(86.535,-18.485),(86.535,-18.635),(86.385,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-18.635),(86.705,-18.485),(86.855,-18.485),(86.855,-18.635),(86.705,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-18.635),(87.025,-18.485),(87.175,-18.485),(87.175,-18.635),(87.025,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-18.635),(87.345,-18.485),(87.495,-18.485),(87.495,-18.635),(87.345,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-18.635),(87.665,-18.485),(87.815,-18.485),(87.815,-18.635),(87.665,-18.635)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-18.315),(83.185,-18.165),(83.335,-18.165),(83.335,-18.315),(83.185,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-18.315),(83.505,-18.165),(83.655,-18.165),(83.655,-18.315),(83.505,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-18.315),(83.825,-18.165),(83.975,-18.165),(83.975,-18.315),(83.825,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-18.315),(84.145,-18.165),(84.295,-18.165),(84.295,-18.315),(84.145,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-18.315),(84.465,-18.165),(84.615,-18.165),(84.615,-18.315),(84.465,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-18.315),(84.785,-18.165),(84.935,-18.165),(84.935,-18.315),(84.785,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-18.315),(85.105,-18.165),(85.255,-18.165),(85.255,-18.315),(85.105,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-18.315),(85.425,-18.165),(85.575,-18.165),(85.575,-18.315),(85.425,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-18.315),(85.745,-18.165),(85.895,-18.165),(85.895,-18.315),(85.745,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-18.315),(86.065,-18.165),(86.215,-18.165),(86.215,-18.315),(86.065,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-18.315),(86.385,-18.165),(86.535,-18.165),(86.535,-18.315),(86.385,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-18.315),(86.705,-18.165),(86.855,-18.165),(86.855,-18.315),(86.705,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-18.315),(87.025,-18.165),(87.175,-18.165),(87.175,-18.315),(87.025,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-18.315),(87.345,-18.165),(87.495,-18.165),(87.495,-18.315),(87.345,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-18.315),(87.665,-18.165),(87.815,-18.165),(87.815,-18.315),(87.665,-18.315)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-17.995),(83.185,-17.845),(83.335,-17.845),(83.335,-17.995),(83.185,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-17.995),(83.505,-17.845),(83.655,-17.845),(83.655,-17.995),(83.505,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-17.995),(83.825,-17.845),(83.975,-17.845),(83.975,-17.995),(83.825,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-17.995),(84.145,-17.845),(84.295,-17.845),(84.295,-17.995),(84.145,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-17.995),(84.465,-17.845),(84.615,-17.845),(84.615,-17.995),(84.465,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-17.995),(84.785,-17.845),(84.935,-17.845),(84.935,-17.995),(84.785,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-17.995),(85.105,-17.845),(85.255,-17.845),(85.255,-17.995),(85.105,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-17.995),(85.425,-17.845),(85.575,-17.845),(85.575,-17.995),(85.425,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-17.995),(85.745,-17.845),(85.895,-17.845),(85.895,-17.995),(85.745,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-17.995),(86.065,-17.845),(86.215,-17.845),(86.215,-17.995),(86.065,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-17.995),(86.385,-17.845),(86.535,-17.845),(86.535,-17.995),(86.385,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-17.995),(86.705,-17.845),(86.855,-17.845),(86.855,-17.995),(86.705,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-17.995),(87.025,-17.845),(87.175,-17.845),(87.175,-17.995),(87.025,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-17.995),(87.345,-17.845),(87.495,-17.845),(87.495,-17.995),(87.345,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-17.995),(87.665,-17.845),(87.815,-17.845),(87.815,-17.995),(87.665,-17.995)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-17.675),(83.185,-17.525),(83.335,-17.525),(83.335,-17.675),(83.185,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-17.675),(83.505,-17.525),(83.655,-17.525),(83.655,-17.675),(83.505,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-17.675),(83.825,-17.525),(83.975,-17.525),(83.975,-17.675),(83.825,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-17.675),(84.145,-17.525),(84.295,-17.525),(84.295,-17.675),(84.145,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-17.675),(84.465,-17.525),(84.615,-17.525),(84.615,-17.675),(84.465,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-17.675),(84.785,-17.525),(84.935,-17.525),(84.935,-17.675),(84.785,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-17.675),(85.105,-17.525),(85.255,-17.525),(85.255,-17.675),(85.105,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-17.675),(85.425,-17.525),(85.575,-17.525),(85.575,-17.675),(85.425,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-17.675),(85.745,-17.525),(85.895,-17.525),(85.895,-17.675),(85.745,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-17.675),(86.065,-17.525),(86.215,-17.525),(86.215,-17.675),(86.065,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-17.675),(86.385,-17.525),(86.535,-17.525),(86.535,-17.675),(86.385,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-17.675),(86.705,-17.525),(86.855,-17.525),(86.855,-17.675),(86.705,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-17.675),(87.025,-17.525),(87.175,-17.525),(87.175,-17.675),(87.025,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-17.675),(87.345,-17.525),(87.495,-17.525),(87.495,-17.675),(87.345,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-17.675),(87.665,-17.525),(87.815,-17.525),(87.815,-17.675),(87.665,-17.675)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-17.355),(83.185,-17.205),(83.335,-17.205),(83.335,-17.355),(83.185,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-17.355),(83.505,-17.205),(83.655,-17.205),(83.655,-17.355),(83.505,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-17.355),(83.825,-17.205),(83.975,-17.205),(83.975,-17.355),(83.825,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-17.355),(84.145,-17.205),(84.295,-17.205),(84.295,-17.355),(84.145,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-17.355),(84.465,-17.205),(84.615,-17.205),(84.615,-17.355),(84.465,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-17.355),(84.785,-17.205),(84.935,-17.205),(84.935,-17.355),(84.785,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-17.355),(85.105,-17.205),(85.255,-17.205),(85.255,-17.355),(85.105,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-17.355),(85.425,-17.205),(85.575,-17.205),(85.575,-17.355),(85.425,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-17.355),(85.745,-17.205),(85.895,-17.205),(85.895,-17.355),(85.745,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-17.355),(86.065,-17.205),(86.215,-17.205),(86.215,-17.355),(86.065,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-17.355),(86.385,-17.205),(86.535,-17.205),(86.535,-17.355),(86.385,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-17.355),(86.705,-17.205),(86.855,-17.205),(86.855,-17.355),(86.705,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-17.355),(87.025,-17.205),(87.175,-17.205),(87.175,-17.355),(87.025,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-17.355),(87.345,-17.205),(87.495,-17.205),(87.495,-17.355),(87.345,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-17.355),(87.665,-17.205),(87.815,-17.205),(87.815,-17.355),(87.665,-17.355)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-17.035),(83.185,-16.885),(83.335,-16.885),(83.335,-17.035),(83.185,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-17.035),(83.505,-16.885),(83.655,-16.885),(83.655,-17.035),(83.505,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-17.035),(83.825,-16.885),(83.975,-16.885),(83.975,-17.035),(83.825,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-17.035),(84.145,-16.885),(84.295,-16.885),(84.295,-17.035),(84.145,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-17.035),(84.465,-16.885),(84.615,-16.885),(84.615,-17.035),(84.465,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-17.035),(84.785,-16.885),(84.935,-16.885),(84.935,-17.035),(84.785,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-17.035),(85.105,-16.885),(85.255,-16.885),(85.255,-17.035),(85.105,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-17.035),(85.425,-16.885),(85.575,-16.885),(85.575,-17.035),(85.425,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-17.035),(85.745,-16.885),(85.895,-16.885),(85.895,-17.035),(85.745,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-17.035),(86.065,-16.885),(86.215,-16.885),(86.215,-17.035),(86.065,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-17.035),(86.385,-16.885),(86.535,-16.885),(86.535,-17.035),(86.385,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-17.035),(86.705,-16.885),(86.855,-16.885),(86.855,-17.035),(86.705,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-17.035),(87.025,-16.885),(87.175,-16.885),(87.175,-17.035),(87.025,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-17.035),(87.345,-16.885),(87.495,-16.885),(87.495,-17.035),(87.345,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-17.035),(87.665,-16.885),(87.815,-16.885),(87.815,-17.035),(87.665,-17.035)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-16.715),(83.185,-16.565),(83.335,-16.565),(83.335,-16.715),(83.185,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-16.715),(83.505,-16.565),(83.655,-16.565),(83.655,-16.715),(83.505,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-16.715),(83.825,-16.565),(83.975,-16.565),(83.975,-16.715),(83.825,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-16.715),(84.145,-16.565),(84.295,-16.565),(84.295,-16.715),(84.145,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-16.715),(84.465,-16.565),(84.615,-16.565),(84.615,-16.715),(84.465,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-16.715),(84.785,-16.565),(84.935,-16.565),(84.935,-16.715),(84.785,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-16.715),(85.105,-16.565),(85.255,-16.565),(85.255,-16.715),(85.105,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-16.715),(85.425,-16.565),(85.575,-16.565),(85.575,-16.715),(85.425,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-16.715),(85.745,-16.565),(85.895,-16.565),(85.895,-16.715),(85.745,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-16.715),(86.065,-16.565),(86.215,-16.565),(86.215,-16.715),(86.065,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-16.715),(86.385,-16.565),(86.535,-16.565),(86.535,-16.715),(86.385,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-16.715),(86.705,-16.565),(86.855,-16.565),(86.855,-16.715),(86.705,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-16.715),(87.025,-16.565),(87.175,-16.565),(87.175,-16.715),(87.025,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-16.715),(87.345,-16.565),(87.495,-16.565),(87.495,-16.715),(87.345,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-16.715),(87.665,-16.565),(87.815,-16.565),(87.815,-16.715),(87.665,-16.715)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-16.395),(83.185,-16.245),(83.335,-16.245),(83.335,-16.395),(83.185,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-16.395),(83.505,-16.245),(83.655,-16.245),(83.655,-16.395),(83.505,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-16.395),(83.825,-16.245),(83.975,-16.245),(83.975,-16.395),(83.825,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-16.395),(84.145,-16.245),(84.295,-16.245),(84.295,-16.395),(84.145,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-16.395),(84.465,-16.245),(84.615,-16.245),(84.615,-16.395),(84.465,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-16.395),(84.785,-16.245),(84.935,-16.245),(84.935,-16.395),(84.785,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-16.395),(85.105,-16.245),(85.255,-16.245),(85.255,-16.395),(85.105,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-16.395),(85.425,-16.245),(85.575,-16.245),(85.575,-16.395),(85.425,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-16.395),(85.745,-16.245),(85.895,-16.245),(85.895,-16.395),(85.745,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-16.395),(86.065,-16.245),(86.215,-16.245),(86.215,-16.395),(86.065,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-16.395),(86.385,-16.245),(86.535,-16.245),(86.535,-16.395),(86.385,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-16.395),(86.705,-16.245),(86.855,-16.245),(86.855,-16.395),(86.705,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-16.395),(87.025,-16.245),(87.175,-16.245),(87.175,-16.395),(87.025,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-16.395),(87.345,-16.245),(87.495,-16.245),(87.495,-16.395),(87.345,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-16.395),(87.665,-16.245),(87.815,-16.245),(87.815,-16.395),(87.665,-16.395)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-16.075),(83.185,-15.925),(83.335,-15.925),(83.335,-16.075),(83.185,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-16.075),(83.505,-15.925),(83.655,-15.925),(83.655,-16.075),(83.505,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-16.075),(83.825,-15.925),(83.975,-15.925),(83.975,-16.075),(83.825,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-16.075),(84.145,-15.925),(84.295,-15.925),(84.295,-16.075),(84.145,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-16.075),(84.465,-15.925),(84.615,-15.925),(84.615,-16.075),(84.465,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-16.075),(84.785,-15.925),(84.935,-15.925),(84.935,-16.075),(84.785,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-16.075),(85.105,-15.925),(85.255,-15.925),(85.255,-16.075),(85.105,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-16.075),(85.425,-15.925),(85.575,-15.925),(85.575,-16.075),(85.425,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-16.075),(85.745,-15.925),(85.895,-15.925),(85.895,-16.075),(85.745,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-16.075),(86.065,-15.925),(86.215,-15.925),(86.215,-16.075),(86.065,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-16.075),(86.385,-15.925),(86.535,-15.925),(86.535,-16.075),(86.385,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-16.075),(86.705,-15.925),(86.855,-15.925),(86.855,-16.075),(86.705,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-16.075),(87.025,-15.925),(87.175,-15.925),(87.175,-16.075),(87.025,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-16.075),(87.345,-15.925),(87.495,-15.925),(87.495,-16.075),(87.345,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-16.075),(87.665,-15.925),(87.815,-15.925),(87.815,-16.075),(87.665,-16.075)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-15.755),(83.185,-15.605),(83.335,-15.605),(83.335,-15.755),(83.185,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-15.755),(83.505,-15.605),(83.655,-15.605),(83.655,-15.755),(83.505,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-15.755),(83.825,-15.605),(83.975,-15.605),(83.975,-15.755),(83.825,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-15.755),(84.145,-15.605),(84.295,-15.605),(84.295,-15.755),(84.145,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-15.755),(84.465,-15.605),(84.615,-15.605),(84.615,-15.755),(84.465,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-15.755),(84.785,-15.605),(84.935,-15.605),(84.935,-15.755),(84.785,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-15.755),(85.105,-15.605),(85.255,-15.605),(85.255,-15.755),(85.105,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-15.755),(85.425,-15.605),(85.575,-15.605),(85.575,-15.755),(85.425,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-15.755),(85.745,-15.605),(85.895,-15.605),(85.895,-15.755),(85.745,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-15.755),(86.065,-15.605),(86.215,-15.605),(86.215,-15.755),(86.065,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-15.755),(86.385,-15.605),(86.535,-15.605),(86.535,-15.755),(86.385,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-15.755),(86.705,-15.605),(86.855,-15.605),(86.855,-15.755),(86.705,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-15.755),(87.025,-15.605),(87.175,-15.605),(87.175,-15.755),(87.025,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-15.755),(87.345,-15.605),(87.495,-15.605),(87.495,-15.755),(87.345,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-15.755),(87.665,-15.605),(87.815,-15.605),(87.815,-15.755),(87.665,-15.755)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-15.435),(83.185,-15.285),(83.335,-15.285),(83.335,-15.435),(83.185,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-15.435),(83.505,-15.285),(83.655,-15.285),(83.655,-15.435),(83.505,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-15.435),(83.825,-15.285),(83.975,-15.285),(83.975,-15.435),(83.825,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-15.435),(84.145,-15.285),(84.295,-15.285),(84.295,-15.435),(84.145,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-15.435),(84.465,-15.285),(84.615,-15.285),(84.615,-15.435),(84.465,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-15.435),(84.785,-15.285),(84.935,-15.285),(84.935,-15.435),(84.785,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-15.435),(85.105,-15.285),(85.255,-15.285),(85.255,-15.435),(85.105,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-15.435),(85.425,-15.285),(85.575,-15.285),(85.575,-15.435),(85.425,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-15.435),(85.745,-15.285),(85.895,-15.285),(85.895,-15.435),(85.745,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-15.435),(86.065,-15.285),(86.215,-15.285),(86.215,-15.435),(86.065,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-15.435),(86.385,-15.285),(86.535,-15.285),(86.535,-15.435),(86.385,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-15.435),(86.705,-15.285),(86.855,-15.285),(86.855,-15.435),(86.705,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-15.435),(87.025,-15.285),(87.175,-15.285),(87.175,-15.435),(87.025,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-15.435),(87.345,-15.285),(87.495,-15.285),(87.495,-15.435),(87.345,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-15.435),(87.665,-15.285),(87.815,-15.285),(87.815,-15.435),(87.665,-15.435)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-15.115),(83.185,-14.965),(83.335,-14.965),(83.335,-15.115),(83.185,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-15.115),(83.505,-14.965),(83.655,-14.965),(83.655,-15.115),(83.505,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-15.115),(83.825,-14.965),(83.975,-14.965),(83.975,-15.115),(83.825,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-15.115),(84.145,-14.965),(84.295,-14.965),(84.295,-15.115),(84.145,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-15.115),(84.465,-14.965),(84.615,-14.965),(84.615,-15.115),(84.465,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-15.115),(84.785,-14.965),(84.935,-14.965),(84.935,-15.115),(84.785,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-15.115),(85.105,-14.965),(85.255,-14.965),(85.255,-15.115),(85.105,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-15.115),(85.425,-14.965),(85.575,-14.965),(85.575,-15.115),(85.425,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-15.115),(85.745,-14.965),(85.895,-14.965),(85.895,-15.115),(85.745,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-15.115),(86.065,-14.965),(86.215,-14.965),(86.215,-15.115),(86.065,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-15.115),(86.385,-14.965),(86.535,-14.965),(86.535,-15.115),(86.385,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-15.115),(86.705,-14.965),(86.855,-14.965),(86.855,-15.115),(86.705,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-15.115),(87.025,-14.965),(87.175,-14.965),(87.175,-15.115),(87.025,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-15.115),(87.345,-14.965),(87.495,-14.965),(87.495,-15.115),(87.345,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-15.115),(87.665,-14.965),(87.815,-14.965),(87.815,-15.115),(87.665,-15.115)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-14.795),(83.185,-14.645),(83.335,-14.645),(83.335,-14.795),(83.185,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-14.795),(83.505,-14.645),(83.655,-14.645),(83.655,-14.795),(83.505,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-14.795),(83.825,-14.645),(83.975,-14.645),(83.975,-14.795),(83.825,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-14.795),(84.145,-14.645),(84.295,-14.645),(84.295,-14.795),(84.145,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-14.795),(84.465,-14.645),(84.615,-14.645),(84.615,-14.795),(84.465,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-14.795),(84.785,-14.645),(84.935,-14.645),(84.935,-14.795),(84.785,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-14.795),(85.105,-14.645),(85.255,-14.645),(85.255,-14.795),(85.105,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-14.795),(85.425,-14.645),(85.575,-14.645),(85.575,-14.795),(85.425,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-14.795),(85.745,-14.645),(85.895,-14.645),(85.895,-14.795),(85.745,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-14.795),(86.065,-14.645),(86.215,-14.645),(86.215,-14.795),(86.065,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-14.795),(86.385,-14.645),(86.535,-14.645),(86.535,-14.795),(86.385,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-14.795),(86.705,-14.645),(86.855,-14.645),(86.855,-14.795),(86.705,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-14.795),(87.025,-14.645),(87.175,-14.645),(87.175,-14.795),(87.025,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-14.795),(87.345,-14.645),(87.495,-14.645),(87.495,-14.795),(87.345,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-14.795),(87.665,-14.645),(87.815,-14.645),(87.815,-14.795),(87.665,-14.795)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-14.475),(83.185,-14.325),(83.335,-14.325),(83.335,-14.475),(83.185,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-14.475),(83.505,-14.325),(83.655,-14.325),(83.655,-14.475),(83.505,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-14.475),(83.825,-14.325),(83.975,-14.325),(83.975,-14.475),(83.825,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-14.475),(84.145,-14.325),(84.295,-14.325),(84.295,-14.475),(84.145,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-14.475),(84.465,-14.325),(84.615,-14.325),(84.615,-14.475),(84.465,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-14.475),(84.785,-14.325),(84.935,-14.325),(84.935,-14.475),(84.785,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-14.475),(85.105,-14.325),(85.255,-14.325),(85.255,-14.475),(85.105,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-14.475),(85.425,-14.325),(85.575,-14.325),(85.575,-14.475),(85.425,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-14.475),(85.745,-14.325),(85.895,-14.325),(85.895,-14.475),(85.745,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-14.475),(86.065,-14.325),(86.215,-14.325),(86.215,-14.475),(86.065,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-14.475),(86.385,-14.325),(86.535,-14.325),(86.535,-14.475),(86.385,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-14.475),(86.705,-14.325),(86.855,-14.325),(86.855,-14.475),(86.705,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-14.475),(87.025,-14.325),(87.175,-14.325),(87.175,-14.475),(87.025,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-14.475),(87.345,-14.325),(87.495,-14.325),(87.495,-14.475),(87.345,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-14.475),(87.665,-14.325),(87.815,-14.325),(87.815,-14.475),(87.665,-14.475)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-14.155),(83.185,-14.005),(83.335,-14.005),(83.335,-14.155),(83.185,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-14.155),(83.505,-14.005),(83.655,-14.005),(83.655,-14.155),(83.505,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-14.155),(83.825,-14.005),(83.975,-14.005),(83.975,-14.155),(83.825,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-14.155),(84.145,-14.005),(84.295,-14.005),(84.295,-14.155),(84.145,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-14.155),(84.465,-14.005),(84.615,-14.005),(84.615,-14.155),(84.465,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-14.155),(84.785,-14.005),(84.935,-14.005),(84.935,-14.155),(84.785,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-14.155),(85.105,-14.005),(85.255,-14.005),(85.255,-14.155),(85.105,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-14.155),(85.425,-14.005),(85.575,-14.005),(85.575,-14.155),(85.425,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-14.155),(85.745,-14.005),(85.895,-14.005),(85.895,-14.155),(85.745,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-14.155),(86.065,-14.005),(86.215,-14.005),(86.215,-14.155),(86.065,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-14.155),(86.385,-14.005),(86.535,-14.005),(86.535,-14.155),(86.385,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-14.155),(86.705,-14.005),(86.855,-14.005),(86.855,-14.155),(86.705,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-14.155),(87.025,-14.005),(87.175,-14.005),(87.175,-14.155),(87.025,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-14.155),(87.345,-14.005),(87.495,-14.005),(87.495,-14.155),(87.345,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-14.155),(87.665,-14.005),(87.815,-14.005),(87.815,-14.155),(87.665,-14.155)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-13.835),(83.185,-13.685),(83.335,-13.685),(83.335,-13.835),(83.185,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-13.835),(83.505,-13.685),(83.655,-13.685),(83.655,-13.835),(83.505,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-13.835),(83.825,-13.685),(83.975,-13.685),(83.975,-13.835),(83.825,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-13.835),(84.145,-13.685),(84.295,-13.685),(84.295,-13.835),(84.145,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-13.835),(84.465,-13.685),(84.615,-13.685),(84.615,-13.835),(84.465,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-13.835),(84.785,-13.685),(84.935,-13.685),(84.935,-13.835),(84.785,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-13.835),(85.105,-13.685),(85.255,-13.685),(85.255,-13.835),(85.105,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-13.835),(85.425,-13.685),(85.575,-13.685),(85.575,-13.835),(85.425,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-13.835),(85.745,-13.685),(85.895,-13.685),(85.895,-13.835),(85.745,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-13.835),(86.065,-13.685),(86.215,-13.685),(86.215,-13.835),(86.065,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-13.835),(86.385,-13.685),(86.535,-13.685),(86.535,-13.835),(86.385,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-13.835),(86.705,-13.685),(86.855,-13.685),(86.855,-13.835),(86.705,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-13.835),(87.025,-13.685),(87.175,-13.685),(87.175,-13.835),(87.025,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-13.835),(87.345,-13.685),(87.495,-13.685),(87.495,-13.835),(87.345,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-13.835),(87.665,-13.685),(87.815,-13.685),(87.815,-13.835),(87.665,-13.835)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-13.515),(83.185,-13.365),(83.335,-13.365),(83.335,-13.515),(83.185,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-13.515),(83.505,-13.365),(83.655,-13.365),(83.655,-13.515),(83.505,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-13.515),(83.825,-13.365),(83.975,-13.365),(83.975,-13.515),(83.825,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-13.515),(84.145,-13.365),(84.295,-13.365),(84.295,-13.515),(84.145,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-13.515),(84.465,-13.365),(84.615,-13.365),(84.615,-13.515),(84.465,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-13.515),(84.785,-13.365),(84.935,-13.365),(84.935,-13.515),(84.785,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-13.515),(85.105,-13.365),(85.255,-13.365),(85.255,-13.515),(85.105,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-13.515),(85.425,-13.365),(85.575,-13.365),(85.575,-13.515),(85.425,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-13.515),(85.745,-13.365),(85.895,-13.365),(85.895,-13.515),(85.745,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-13.515),(86.065,-13.365),(86.215,-13.365),(86.215,-13.515),(86.065,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-13.515),(86.385,-13.365),(86.535,-13.365),(86.535,-13.515),(86.385,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-13.515),(86.705,-13.365),(86.855,-13.365),(86.855,-13.515),(86.705,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-13.515),(87.025,-13.365),(87.175,-13.365),(87.175,-13.515),(87.025,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-13.515),(87.345,-13.365),(87.495,-13.365),(87.495,-13.515),(87.345,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-13.515),(87.665,-13.365),(87.815,-13.365),(87.815,-13.515),(87.665,-13.515)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-13.195),(83.185,-13.045),(83.335,-13.045),(83.335,-13.195),(83.185,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-13.195),(83.505,-13.045),(83.655,-13.045),(83.655,-13.195),(83.505,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-13.195),(83.825,-13.045),(83.975,-13.045),(83.975,-13.195),(83.825,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-13.195),(84.145,-13.045),(84.295,-13.045),(84.295,-13.195),(84.145,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-13.195),(84.465,-13.045),(84.615,-13.045),(84.615,-13.195),(84.465,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-13.195),(84.785,-13.045),(84.935,-13.045),(84.935,-13.195),(84.785,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-13.195),(85.105,-13.045),(85.255,-13.045),(85.255,-13.195),(85.105,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-13.195),(85.425,-13.045),(85.575,-13.045),(85.575,-13.195),(85.425,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-13.195),(85.745,-13.045),(85.895,-13.045),(85.895,-13.195),(85.745,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-13.195),(86.065,-13.045),(86.215,-13.045),(86.215,-13.195),(86.065,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-13.195),(86.385,-13.045),(86.535,-13.045),(86.535,-13.195),(86.385,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-13.195),(86.705,-13.045),(86.855,-13.045),(86.855,-13.195),(86.705,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-13.195),(87.025,-13.045),(87.175,-13.045),(87.175,-13.195),(87.025,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-13.195),(87.345,-13.045),(87.495,-13.045),(87.495,-13.195),(87.345,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-13.195),(87.665,-13.045),(87.815,-13.045),(87.815,-13.195),(87.665,-13.195)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-12.875),(83.185,-12.725),(83.335,-12.725),(83.335,-12.875),(83.185,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-12.875),(83.505,-12.725),(83.655,-12.725),(83.655,-12.875),(83.505,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-12.875),(83.825,-12.725),(83.975,-12.725),(83.975,-12.875),(83.825,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-12.875),(84.145,-12.725),(84.295,-12.725),(84.295,-12.875),(84.145,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-12.875),(84.465,-12.725),(84.615,-12.725),(84.615,-12.875),(84.465,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-12.875),(84.785,-12.725),(84.935,-12.725),(84.935,-12.875),(84.785,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-12.875),(85.105,-12.725),(85.255,-12.725),(85.255,-12.875),(85.105,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-12.875),(85.425,-12.725),(85.575,-12.725),(85.575,-12.875),(85.425,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-12.875),(85.745,-12.725),(85.895,-12.725),(85.895,-12.875),(85.745,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-12.875),(86.065,-12.725),(86.215,-12.725),(86.215,-12.875),(86.065,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-12.875),(86.385,-12.725),(86.535,-12.725),(86.535,-12.875),(86.385,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-12.875),(86.705,-12.725),(86.855,-12.725),(86.855,-12.875),(86.705,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-12.875),(87.025,-12.725),(87.175,-12.725),(87.175,-12.875),(87.025,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-12.875),(87.345,-12.725),(87.495,-12.725),(87.495,-12.875),(87.345,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-12.875),(87.665,-12.725),(87.815,-12.725),(87.815,-12.875),(87.665,-12.875)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-12.555),(83.185,-12.405),(83.335,-12.405),(83.335,-12.555),(83.185,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-12.555),(83.505,-12.405),(83.655,-12.405),(83.655,-12.555),(83.505,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-12.555),(83.825,-12.405),(83.975,-12.405),(83.975,-12.555),(83.825,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-12.555),(84.145,-12.405),(84.295,-12.405),(84.295,-12.555),(84.145,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-12.555),(84.465,-12.405),(84.615,-12.405),(84.615,-12.555),(84.465,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-12.555),(84.785,-12.405),(84.935,-12.405),(84.935,-12.555),(84.785,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-12.555),(85.105,-12.405),(85.255,-12.405),(85.255,-12.555),(85.105,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-12.555),(85.425,-12.405),(85.575,-12.405),(85.575,-12.555),(85.425,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-12.555),(85.745,-12.405),(85.895,-12.405),(85.895,-12.555),(85.745,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-12.555),(86.065,-12.405),(86.215,-12.405),(86.215,-12.555),(86.065,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-12.555),(86.385,-12.405),(86.535,-12.405),(86.535,-12.555),(86.385,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-12.555),(86.705,-12.405),(86.855,-12.405),(86.855,-12.555),(86.705,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-12.555),(87.025,-12.405),(87.175,-12.405),(87.175,-12.555),(87.025,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-12.555),(87.345,-12.405),(87.495,-12.405),(87.495,-12.555),(87.345,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-12.555),(87.665,-12.405),(87.815,-12.405),(87.815,-12.555),(87.665,-12.555)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-12.235),(83.185,-12.085),(83.335,-12.085),(83.335,-12.235),(83.185,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-12.235),(83.505,-12.085),(83.655,-12.085),(83.655,-12.235),(83.505,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-12.235),(83.825,-12.085),(83.975,-12.085),(83.975,-12.235),(83.825,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-12.235),(84.145,-12.085),(84.295,-12.085),(84.295,-12.235),(84.145,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-12.235),(84.465,-12.085),(84.615,-12.085),(84.615,-12.235),(84.465,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-12.235),(84.785,-12.085),(84.935,-12.085),(84.935,-12.235),(84.785,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-12.235),(85.105,-12.085),(85.255,-12.085),(85.255,-12.235),(85.105,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-12.235),(85.425,-12.085),(85.575,-12.085),(85.575,-12.235),(85.425,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-12.235),(85.745,-12.085),(85.895,-12.085),(85.895,-12.235),(85.745,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-12.235),(86.065,-12.085),(86.215,-12.085),(86.215,-12.235),(86.065,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-12.235),(86.385,-12.085),(86.535,-12.085),(86.535,-12.235),(86.385,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-12.235),(86.705,-12.085),(86.855,-12.085),(86.855,-12.235),(86.705,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-12.235),(87.025,-12.085),(87.175,-12.085),(87.175,-12.235),(87.025,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-12.235),(87.345,-12.085),(87.495,-12.085),(87.495,-12.235),(87.345,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-12.235),(87.665,-12.085),(87.815,-12.085),(87.815,-12.235),(87.665,-12.235)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-11.915),(83.185,-11.765),(83.335,-11.765),(83.335,-11.915),(83.185,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-11.915),(83.505,-11.765),(83.655,-11.765),(83.655,-11.915),(83.505,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-11.915),(83.825,-11.765),(83.975,-11.765),(83.975,-11.915),(83.825,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-11.915),(84.145,-11.765),(84.295,-11.765),(84.295,-11.915),(84.145,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-11.915),(84.465,-11.765),(84.615,-11.765),(84.615,-11.915),(84.465,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-11.915),(84.785,-11.765),(84.935,-11.765),(84.935,-11.915),(84.785,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-11.915),(85.105,-11.765),(85.255,-11.765),(85.255,-11.915),(85.105,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-11.915),(85.425,-11.765),(85.575,-11.765),(85.575,-11.915),(85.425,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-11.915),(85.745,-11.765),(85.895,-11.765),(85.895,-11.915),(85.745,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-11.915),(86.065,-11.765),(86.215,-11.765),(86.215,-11.915),(86.065,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-11.915),(86.385,-11.765),(86.535,-11.765),(86.535,-11.915),(86.385,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-11.915),(86.705,-11.765),(86.855,-11.765),(86.855,-11.915),(86.705,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-11.915),(87.025,-11.765),(87.175,-11.765),(87.175,-11.915),(87.025,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-11.915),(87.345,-11.765),(87.495,-11.765),(87.495,-11.915),(87.345,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-11.915),(87.665,-11.765),(87.815,-11.765),(87.815,-11.915),(87.665,-11.915)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-11.595),(83.185,-11.445),(83.335,-11.445),(83.335,-11.595),(83.185,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-11.595),(83.505,-11.445),(83.655,-11.445),(83.655,-11.595),(83.505,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-11.595),(83.825,-11.445),(83.975,-11.445),(83.975,-11.595),(83.825,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-11.595),(84.145,-11.445),(84.295,-11.445),(84.295,-11.595),(84.145,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-11.595),(84.465,-11.445),(84.615,-11.445),(84.615,-11.595),(84.465,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-11.595),(84.785,-11.445),(84.935,-11.445),(84.935,-11.595),(84.785,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-11.595),(85.105,-11.445),(85.255,-11.445),(85.255,-11.595),(85.105,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-11.595),(85.425,-11.445),(85.575,-11.445),(85.575,-11.595),(85.425,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-11.595),(85.745,-11.445),(85.895,-11.445),(85.895,-11.595),(85.745,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-11.595),(86.065,-11.445),(86.215,-11.445),(86.215,-11.595),(86.065,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-11.595),(86.385,-11.445),(86.535,-11.445),(86.535,-11.595),(86.385,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-11.595),(86.705,-11.445),(86.855,-11.445),(86.855,-11.595),(86.705,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-11.595),(87.025,-11.445),(87.175,-11.445),(87.175,-11.595),(87.025,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-11.595),(87.345,-11.445),(87.495,-11.445),(87.495,-11.595),(87.345,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-11.595),(87.665,-11.445),(87.815,-11.445),(87.815,-11.595),(87.665,-11.595)),
        )
        createRL(
            tech, net, 'via',
            ((83.185,-11.275),(83.185,-11.125),(83.335,-11.125),(83.335,-11.275),(83.185,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((83.505,-11.275),(83.505,-11.125),(83.655,-11.125),(83.655,-11.275),(83.505,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((83.825,-11.275),(83.825,-11.125),(83.975,-11.125),(83.975,-11.275),(83.825,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((84.145,-11.275),(84.145,-11.125),(84.295,-11.125),(84.295,-11.275),(84.145,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((84.465,-11.275),(84.465,-11.125),(84.615,-11.125),(84.615,-11.275),(84.465,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((84.785,-11.275),(84.785,-11.125),(84.935,-11.125),(84.935,-11.275),(84.785,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((85.105,-11.275),(85.105,-11.125),(85.255,-11.125),(85.255,-11.275),(85.105,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((85.425,-11.275),(85.425,-11.125),(85.575,-11.125),(85.575,-11.275),(85.425,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((85.745,-11.275),(85.745,-11.125),(85.895,-11.125),(85.895,-11.275),(85.745,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((86.065,-11.275),(86.065,-11.125),(86.215,-11.125),(86.215,-11.275),(86.065,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((86.385,-11.275),(86.385,-11.125),(86.535,-11.125),(86.535,-11.275),(86.385,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((86.705,-11.275),(86.705,-11.125),(86.855,-11.125),(86.855,-11.275),(86.705,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((87.025,-11.275),(87.025,-11.125),(87.175,-11.125),(87.175,-11.275),(87.025,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((87.345,-11.275),(87.345,-11.125),(87.495,-11.125),(87.495,-11.275),(87.345,-11.275)),
        )
        createRL(
            tech, net, 'via',
            ((87.665,-11.275),(87.665,-11.125),(87.815,-11.125),(87.815,-11.275),(87.665,-11.275)),
        )
        createRL(
            tech, net, 'm2',
            ((1.63,-20.96),(1.63,-11.04),(6.37,-11.04),(6.37,-20.96),(1.63,-20.96)),
        )
        createRL(
            tech, net, 'm2',
            ((83.13,-20.96),(83.13,-11.04),(87.87,-11.04),(87.87,-20.96),(83.13,-20.96)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)

    cell = new_cells['IOPadVdd']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.115,88.03),(40.115,88.2),(40.285,88.2),(40.285,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,88.03),(73.715,88.2),(73.885,88.2),(73.885,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,88.03),(25.715,88.2),(25.885,88.2),(25.885,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,88.03),(54.515,88.2),(54.685,88.2),(54.685,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,88.03),(6.77,88.2),(6.94,88.2),(6.94,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,88.03),(35.315,88.2),(35.485,88.2),(35.485,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,88.03),(11.315,88.2),(11.485,88.2),(11.485,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,88.03),(64.115,88.2),(64.285,88.2),(64.285,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,88.03),(83.06,88.2),(83.23,88.2),(83.23,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,88.03),(59.315,88.2),(59.485,88.2),(59.485,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,88.03),(20.915,88.2),(21.085,88.2),(21.085,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,88.03),(85.58,88.2),(86.11,88.2),(86.11,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,88.03),(44.915,88.2),(45.085,88.2),(45.085,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,88.03),(49.715,88.2),(49.885,88.2),(49.885,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,88.03),(68.915,88.2),(69.085,88.2),(69.085,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,88.03),(16.115,88.2),(16.285,88.2),(16.285,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,88.03),(30.515,88.2),(30.685,88.2),(30.685,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,88.03),(78.515,88.2),(78.685,88.2),(78.685,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,88.03),(85.58,88.2),(85.75,88.2),(85.75,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,88.03),(85.94,88.2),(86.11,88.2),(86.11,88.03),(85.94,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,88.03),(40.115,88.2),(40.285,88.2),(40.285,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,88.03),(73.715,88.2),(73.885,88.2),(73.885,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,88.03),(25.715,88.2),(25.885,88.2),(25.885,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,88.03),(6.77,88.2),(6.94,88.2),(6.94,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,88.03),(54.515,88.2),(54.685,88.2),(54.685,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,88.03),(35.315,88.2),(35.485,88.2),(35.485,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,88.03),(11.315,88.2),(11.485,88.2),(11.485,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,88.03),(64.115,88.2),(64.285,88.2),(64.285,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,88.03),(83.06,88.2),(83.23,88.2),(83.23,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,88.03),(59.315,88.2),(59.485,88.2),(59.485,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,88.03),(20.915,88.2),(21.085,88.2),(21.085,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,88.03),(44.915,88.2),(45.085,88.2),(45.085,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,88.03),(68.915,88.2),(69.085,88.2),(69.085,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,88.03),(49.715,88.2),(49.885,88.2),(49.885,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,88.03),(16.115,88.2),(16.285,88.2),(16.285,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,88.03),(30.515,88.2),(30.685,88.2),(30.685,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,88.03),(78.515,88.2),(78.685,88.2),(78.685,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,91.365),(16.315,91.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,88.3),(16.315,88.3),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,130.265),(11.515,130.265),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,133.04),(25.915,133.04),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,131.365),(78.715,131.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,130.265),(35.515,130.265),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,130.265),(69.115,130.265),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,88.3),(45.115,88.3),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,131.365),(83.26,131.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,132.98),(83.275,132.98),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,91.365),(83.26,91.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,133.04),(59.515,133.04),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,130.265),(21.115,130.265),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,131.365),(73.915,131.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,88.3),(69.115,88.3),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,132.98),(73.93,132.98),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,131.365),(54.715,131.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,91.365),(73.915,91.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,88.3),(11.515,88.3),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,130.265),(16.315,130.265),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,88.3),(21.115,88.3),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,132.98),(16.33,132.98),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,131.365),(6.97,131.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,88.3),(35.515,88.3),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,133.04),(49.915,133.04),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,130.265),(45.115,130.265),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,132.98),(30.73,132.98),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,131.365),(11.515,131.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,132.98),(11.53,132.98),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,130.265),(25.915,130.265),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,132.98),(78.73,132.98),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,131.365),(35.515,131.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,91.365),(49.915,91.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,133.04),(69.115,133.04),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,91.365),(45.115,91.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,132.98),(35.53,132.98),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,130.265),(40.315,130.265),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,133.04),(83.26,133.04),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,88.3),(83.26,88.3),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,132.98),(40.33,132.98),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,130.265),(59.515,130.265),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,133.04),(21.115,133.04),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,91.365),(69.115,91.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,133.04),(73.915,133.04),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,132.98),(54.73,132.98),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,91.365),(25.915,91.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,88.3),(73.915,88.3),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,131.365),(16.315,131.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,91.365),(21.115,91.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,91.365),(59.515,91.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,133.04),(16.315,133.04),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,132.98),(6.985,132.98),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,130.265),(64.315,130.265),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,133.04),(45.115,133.04),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,130.265),(49.915,130.265),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,132.98),(64.33,132.98),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,91.365),(86.14,91.365),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,133.04),(30.715,133.04),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,91.365),(64.315,91.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,130.265),(30.715,130.265),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,88.3),(64.315,88.3),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,133.04),(11.515,133.04),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,131.365),(25.915,131.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,132.98),(25.93,132.98),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,91.365),(54.715,91.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,88.3),(54.715,88.3),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,132.98),(69.13,132.98),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,88.3),(49.915,88.3),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,133.04),(78.715,133.04),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,130.265),(78.715,130.265),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,133.04),(35.515,133.04),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,131.365),(69.115,131.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,131.365),(40.315,131.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,130.265),(83.26,130.265),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,91.365),(40.315,91.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,133.04),(40.315,133.04),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,91.365),(6.97,91.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,88.3),(40.315,88.3),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,131.365),(59.515,131.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,88.3),(6.97,88.3),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,132.98),(59.53,132.98),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,132.98),(21.13,132.98),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,131.365),(21.115,131.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,91.365),(78.715,91.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,130.265),(73.915,130.265),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,88.3),(78.715,88.3),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,133.04),(54.715,133.04),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,88.3),(25.915,88.3),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,130.265),(54.715,130.265),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,91.365),(11.515,91.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,88.3),(59.515,88.3),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,133.04),(6.97,133.04),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,130.265),(6.97,130.265),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,131.365),(64.315,131.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,91.365),(35.515,91.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,132.98),(45.13,132.98),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,131.365),(49.915,131.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,133.04),(64.315,133.04),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,131.365),(45.115,131.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,91.365),(30.715,91.365),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,132.98),(49.93,132.98),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,88.3),(30.715,88.3),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,131.365),(30.715,131.365),(30.715,87.93),(30.485,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((75.59,173.76),(75.59,187.84),(76.81,187.84),(76.81,173.76),(75.59,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((65.99,173.76),(65.99,187.84),(67.21,187.84),(67.21,173.76),(65.99,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((17.99,173.76),(17.99,187.84),(19.21,187.84),(19.21,173.76),(17.99,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((22.79,173.76),(22.79,187.84),(24.01,187.84),(24.01,173.76),(22.79,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((8.39,173.76),(8.39,187.84),(9.61,187.84),(9.61,173.76),(8.39,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((70.79,173.76),(70.79,187.84),(72.01,187.84),(72.01,173.76),(70.79,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((56.39,173.76),(56.39,187.84),(57.61,187.84),(57.61,173.76),(56.39,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((27.59,173.76),(27.59,187.84),(28.81,187.84),(28.81,173.76),(27.59,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((46.79,173.76),(46.79,187.84),(48.01,187.84),(48.01,173.76),(46.79,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((13.19,173.76),(13.19,187.84),(14.41,187.84),(14.41,173.76),(13.19,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((61.19,173.76),(61.19,187.84),(62.41,187.84),(62.41,173.76),(61.19,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((37.19,173.76),(37.19,187.84),(38.41,187.84),(38.41,173.76),(37.19,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((41.99,173.76),(41.99,187.84),(43.21,187.84),(43.21,173.76),(41.99,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((80.39,173.76),(80.39,187.84),(81.61,187.84),(81.61,173.76),(80.39,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((32.39,173.76),(32.39,187.84),(33.61,187.84),(33.61,173.76),(32.39,173.76)),
        )
        createRL(
            tech, net, 'm2',
            ((51.59,173.76),(51.59,187.84),(52.81,187.84),(52.81,173.76),(51.59,173.76)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,188.0),(38.455,188.0),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,188.0),(19.255,188.0),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,188.0),(57.655,188.0),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,173.6),(80.345,188.0),(81.655,188.0),(81.655,173.6),(80.345,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,188.0),(72.055,188.0),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,173.6),(27.545,188.0),(28.855,188.0),(28.855,173.6),(27.545,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,188.0),(76.855,188.0),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,188.0),(43.255,188.0),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,188.0),(81.655,188.0),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,173.6),(70.745,188.0),(72.055,188.0),(72.055,173.6),(70.745,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,173.6),(17.945,188.0),(19.255,188.0),(19.255,173.6),(17.945,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,188.0),(33.655,188.0),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,173.6),(46.745,188.0),(48.055,188.0),(48.055,173.6),(46.745,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,173.6),(61.145,188.0),(62.455,188.0),(62.455,173.6),(61.145,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,173.6),(51.545,188.0),(52.855,188.0),(52.855,173.6),(51.545,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,173.6),(8.345,188.0),(9.655,188.0),(9.655,173.6),(8.345,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,173.6),(22.745,188.0),(24.055,188.0),(24.055,173.6),(22.745,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,173.6),(13.145,188.0),(14.455,188.0),(14.455,173.6),(13.145,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,188.0),(62.455,188.0),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,188.0),(67.255,188.0),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,173.6),(32.345,188.0),(33.655,188.0),(33.655,173.6),(32.345,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,188.0),(48.055,188.0),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,173.6),(41.945,188.0),(43.255,188.0),(43.255,173.6),(41.945,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,188.0),(52.855,188.0),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,173.6),(56.345,188.0),(57.655,188.0),(57.655,173.6),(56.345,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,173.6),(65.945,188.0),(67.255,188.0),(67.255,173.6),(65.945,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,173.6),(37.145,188.0),(38.455,188.0),(38.455,173.6),(37.145,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,188.0),(14.455,188.0),(14.455,86.32),(13.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,188.0),(24.055,188.0),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,188.0),(9.655,188.0),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,173.6),(75.545,188.0),(76.855,188.0),(76.855,173.6),(75.545,173.6)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,188.0),(28.855,188.0),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,173.845),(37.245,173.995),(37.395,173.995),(37.395,173.845),(37.245,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,173.845),(37.565,173.995),(37.715,173.995),(37.715,173.845),(37.565,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,173.845),(37.885,173.995),(38.035,173.995),(38.035,173.845),(37.885,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,173.845),(38.205,173.995),(38.355,173.995),(38.355,173.845),(38.205,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,174.165),(37.245,174.315),(37.395,174.315),(37.395,174.165),(37.245,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,174.165),(37.565,174.315),(37.715,174.315),(37.715,174.165),(37.565,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,174.165),(37.885,174.315),(38.035,174.315),(38.035,174.165),(37.885,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,174.165),(38.205,174.315),(38.355,174.315),(38.355,174.165),(38.205,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,174.485),(37.245,174.635),(37.395,174.635),(37.395,174.485),(37.245,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,174.485),(37.565,174.635),(37.715,174.635),(37.715,174.485),(37.565,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,174.485),(37.885,174.635),(38.035,174.635),(38.035,174.485),(37.885,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,174.485),(38.205,174.635),(38.355,174.635),(38.355,174.485),(38.205,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,174.805),(37.245,174.955),(37.395,174.955),(37.395,174.805),(37.245,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,174.805),(37.565,174.955),(37.715,174.955),(37.715,174.805),(37.565,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,174.805),(37.885,174.955),(38.035,174.955),(38.035,174.805),(37.885,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,174.805),(38.205,174.955),(38.355,174.955),(38.355,174.805),(38.205,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,175.125),(37.245,175.275),(37.395,175.275),(37.395,175.125),(37.245,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,175.125),(37.565,175.275),(37.715,175.275),(37.715,175.125),(37.565,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,175.125),(37.885,175.275),(38.035,175.275),(38.035,175.125),(37.885,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,175.125),(38.205,175.275),(38.355,175.275),(38.355,175.125),(38.205,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,175.445),(37.245,175.595),(37.395,175.595),(37.395,175.445),(37.245,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,175.445),(37.565,175.595),(37.715,175.595),(37.715,175.445),(37.565,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,175.445),(37.885,175.595),(38.035,175.595),(38.035,175.445),(37.885,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,175.445),(38.205,175.595),(38.355,175.595),(38.355,175.445),(38.205,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,175.765),(37.245,175.915),(37.395,175.915),(37.395,175.765),(37.245,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,175.765),(37.565,175.915),(37.715,175.915),(37.715,175.765),(37.565,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,175.765),(37.885,175.915),(38.035,175.915),(38.035,175.765),(37.885,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,175.765),(38.205,175.915),(38.355,175.915),(38.355,175.765),(38.205,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,176.085),(37.245,176.235),(37.395,176.235),(37.395,176.085),(37.245,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,176.085),(37.565,176.235),(37.715,176.235),(37.715,176.085),(37.565,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,176.085),(37.885,176.235),(38.035,176.235),(38.035,176.085),(37.885,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,176.085),(38.205,176.235),(38.355,176.235),(38.355,176.085),(38.205,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,176.405),(37.245,176.555),(37.395,176.555),(37.395,176.405),(37.245,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,176.405),(37.565,176.555),(37.715,176.555),(37.715,176.405),(37.565,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,176.405),(37.885,176.555),(38.035,176.555),(38.035,176.405),(37.885,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,176.405),(38.205,176.555),(38.355,176.555),(38.355,176.405),(38.205,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,176.725),(37.245,176.875),(37.395,176.875),(37.395,176.725),(37.245,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,176.725),(37.565,176.875),(37.715,176.875),(37.715,176.725),(37.565,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,176.725),(37.885,176.875),(38.035,176.875),(38.035,176.725),(37.885,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,176.725),(38.205,176.875),(38.355,176.875),(38.355,176.725),(38.205,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,177.045),(37.245,177.195),(37.395,177.195),(37.395,177.045),(37.245,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,177.045),(37.565,177.195),(37.715,177.195),(37.715,177.045),(37.565,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,177.045),(37.885,177.195),(38.035,177.195),(38.035,177.045),(37.885,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,177.045),(38.205,177.195),(38.355,177.195),(38.355,177.045),(38.205,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,177.365),(37.245,177.515),(37.395,177.515),(37.395,177.365),(37.245,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,177.365),(37.565,177.515),(37.715,177.515),(37.715,177.365),(37.565,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,177.365),(37.885,177.515),(38.035,177.515),(38.035,177.365),(37.885,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,177.365),(38.205,177.515),(38.355,177.515),(38.355,177.365),(38.205,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,177.685),(37.245,177.835),(37.395,177.835),(37.395,177.685),(37.245,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,177.685),(37.565,177.835),(37.715,177.835),(37.715,177.685),(37.565,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,177.685),(37.885,177.835),(38.035,177.835),(38.035,177.685),(37.885,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,177.685),(38.205,177.835),(38.355,177.835),(38.355,177.685),(38.205,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,178.005),(37.245,178.155),(37.395,178.155),(37.395,178.005),(37.245,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,178.005),(37.565,178.155),(37.715,178.155),(37.715,178.005),(37.565,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,178.005),(37.885,178.155),(38.035,178.155),(38.035,178.005),(37.885,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,178.005),(38.205,178.155),(38.355,178.155),(38.355,178.005),(38.205,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,178.325),(37.245,178.475),(37.395,178.475),(37.395,178.325),(37.245,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,178.325),(37.565,178.475),(37.715,178.475),(37.715,178.325),(37.565,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,178.325),(37.885,178.475),(38.035,178.475),(38.035,178.325),(37.885,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,178.325),(38.205,178.475),(38.355,178.475),(38.355,178.325),(38.205,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,178.645),(37.245,178.795),(37.395,178.795),(37.395,178.645),(37.245,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,178.645),(37.565,178.795),(37.715,178.795),(37.715,178.645),(37.565,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,178.645),(37.885,178.795),(38.035,178.795),(38.035,178.645),(37.885,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,178.645),(38.205,178.795),(38.355,178.795),(38.355,178.645),(38.205,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,178.965),(37.245,179.115),(37.395,179.115),(37.395,178.965),(37.245,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,178.965),(37.565,179.115),(37.715,179.115),(37.715,178.965),(37.565,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,178.965),(37.885,179.115),(38.035,179.115),(38.035,178.965),(37.885,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,178.965),(38.205,179.115),(38.355,179.115),(38.355,178.965),(38.205,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,179.285),(37.245,179.435),(37.395,179.435),(37.395,179.285),(37.245,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,179.285),(37.565,179.435),(37.715,179.435),(37.715,179.285),(37.565,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,179.285),(37.885,179.435),(38.035,179.435),(38.035,179.285),(37.885,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,179.285),(38.205,179.435),(38.355,179.435),(38.355,179.285),(38.205,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,179.605),(37.245,179.755),(37.395,179.755),(37.395,179.605),(37.245,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,179.605),(37.565,179.755),(37.715,179.755),(37.715,179.605),(37.565,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,179.605),(37.885,179.755),(38.035,179.755),(38.035,179.605),(37.885,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,179.605),(38.205,179.755),(38.355,179.755),(38.355,179.605),(38.205,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,179.925),(37.245,180.075),(37.395,180.075),(37.395,179.925),(37.245,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,179.925),(37.565,180.075),(37.715,180.075),(37.715,179.925),(37.565,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,179.925),(37.885,180.075),(38.035,180.075),(38.035,179.925),(37.885,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,179.925),(38.205,180.075),(38.355,180.075),(38.355,179.925),(38.205,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,180.245),(37.245,180.395),(37.395,180.395),(37.395,180.245),(37.245,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,180.245),(37.565,180.395),(37.715,180.395),(37.715,180.245),(37.565,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,180.245),(37.885,180.395),(38.035,180.395),(38.035,180.245),(37.885,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,180.245),(38.205,180.395),(38.355,180.395),(38.355,180.245),(38.205,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,180.565),(37.245,180.715),(37.395,180.715),(37.395,180.565),(37.245,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,180.565),(37.565,180.715),(37.715,180.715),(37.715,180.565),(37.565,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,180.565),(37.885,180.715),(38.035,180.715),(38.035,180.565),(37.885,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,180.565),(38.205,180.715),(38.355,180.715),(38.355,180.565),(38.205,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,180.885),(37.245,181.035),(37.395,181.035),(37.395,180.885),(37.245,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,180.885),(37.565,181.035),(37.715,181.035),(37.715,180.885),(37.565,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,180.885),(37.885,181.035),(38.035,181.035),(38.035,180.885),(37.885,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,180.885),(38.205,181.035),(38.355,181.035),(38.355,180.885),(38.205,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,181.205),(37.245,181.355),(37.395,181.355),(37.395,181.205),(37.245,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,181.205),(37.565,181.355),(37.715,181.355),(37.715,181.205),(37.565,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,181.205),(37.885,181.355),(38.035,181.355),(38.035,181.205),(37.885,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,181.205),(38.205,181.355),(38.355,181.355),(38.355,181.205),(38.205,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,181.525),(37.245,181.675),(37.395,181.675),(37.395,181.525),(37.245,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,181.525),(37.565,181.675),(37.715,181.675),(37.715,181.525),(37.565,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,181.525),(37.885,181.675),(38.035,181.675),(38.035,181.525),(37.885,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,181.525),(38.205,181.675),(38.355,181.675),(38.355,181.525),(38.205,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,181.845),(37.245,181.995),(37.395,181.995),(37.395,181.845),(37.245,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,181.845),(37.565,181.995),(37.715,181.995),(37.715,181.845),(37.565,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,181.845),(37.885,181.995),(38.035,181.995),(38.035,181.845),(37.885,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,181.845),(38.205,181.995),(38.355,181.995),(38.355,181.845),(38.205,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,182.165),(37.245,182.315),(37.395,182.315),(37.395,182.165),(37.245,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,182.165),(37.565,182.315),(37.715,182.315),(37.715,182.165),(37.565,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,182.165),(37.885,182.315),(38.035,182.315),(38.035,182.165),(37.885,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,182.165),(38.205,182.315),(38.355,182.315),(38.355,182.165),(38.205,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,182.485),(37.245,182.635),(37.395,182.635),(37.395,182.485),(37.245,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,182.485),(37.565,182.635),(37.715,182.635),(37.715,182.485),(37.565,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,182.485),(37.885,182.635),(38.035,182.635),(38.035,182.485),(37.885,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,182.485),(38.205,182.635),(38.355,182.635),(38.355,182.485),(38.205,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,182.805),(37.245,182.955),(37.395,182.955),(37.395,182.805),(37.245,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,182.805),(37.565,182.955),(37.715,182.955),(37.715,182.805),(37.565,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,182.805),(37.885,182.955),(38.035,182.955),(38.035,182.805),(37.885,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,182.805),(38.205,182.955),(38.355,182.955),(38.355,182.805),(38.205,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,183.125),(37.245,183.275),(37.395,183.275),(37.395,183.125),(37.245,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,183.125),(37.565,183.275),(37.715,183.275),(37.715,183.125),(37.565,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,183.125),(37.885,183.275),(38.035,183.275),(38.035,183.125),(37.885,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,183.125),(38.205,183.275),(38.355,183.275),(38.355,183.125),(38.205,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,183.445),(37.245,183.595),(37.395,183.595),(37.395,183.445),(37.245,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,183.445),(37.565,183.595),(37.715,183.595),(37.715,183.445),(37.565,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,183.445),(37.885,183.595),(38.035,183.595),(38.035,183.445),(37.885,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,183.445),(38.205,183.595),(38.355,183.595),(38.355,183.445),(38.205,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,183.765),(37.245,183.915),(37.395,183.915),(37.395,183.765),(37.245,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,183.765),(37.565,183.915),(37.715,183.915),(37.715,183.765),(37.565,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,183.765),(37.885,183.915),(38.035,183.915),(38.035,183.765),(37.885,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,183.765),(38.205,183.915),(38.355,183.915),(38.355,183.765),(38.205,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,184.085),(37.245,184.235),(37.395,184.235),(37.395,184.085),(37.245,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,184.085),(37.565,184.235),(37.715,184.235),(37.715,184.085),(37.565,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,184.085),(37.885,184.235),(38.035,184.235),(38.035,184.085),(37.885,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,184.085),(38.205,184.235),(38.355,184.235),(38.355,184.085),(38.205,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,184.405),(37.245,184.555),(37.395,184.555),(37.395,184.405),(37.245,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,184.405),(37.565,184.555),(37.715,184.555),(37.715,184.405),(37.565,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,184.405),(37.885,184.555),(38.035,184.555),(38.035,184.405),(37.885,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,184.405),(38.205,184.555),(38.355,184.555),(38.355,184.405),(38.205,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,184.725),(37.245,184.875),(37.395,184.875),(37.395,184.725),(37.245,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,184.725),(37.565,184.875),(37.715,184.875),(37.715,184.725),(37.565,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,184.725),(37.885,184.875),(38.035,184.875),(38.035,184.725),(37.885,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,184.725),(38.205,184.875),(38.355,184.875),(38.355,184.725),(38.205,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,185.045),(37.245,185.195),(37.395,185.195),(37.395,185.045),(37.245,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,185.045),(37.565,185.195),(37.715,185.195),(37.715,185.045),(37.565,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,185.045),(37.885,185.195),(38.035,185.195),(38.035,185.045),(37.885,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,185.045),(38.205,185.195),(38.355,185.195),(38.355,185.045),(38.205,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,185.365),(37.245,185.515),(37.395,185.515),(37.395,185.365),(37.245,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,185.365),(37.565,185.515),(37.715,185.515),(37.715,185.365),(37.565,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,185.365),(37.885,185.515),(38.035,185.515),(38.035,185.365),(37.885,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,185.365),(38.205,185.515),(38.355,185.515),(38.355,185.365),(38.205,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,185.685),(37.245,185.835),(37.395,185.835),(37.395,185.685),(37.245,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,185.685),(37.565,185.835),(37.715,185.835),(37.715,185.685),(37.565,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,185.685),(37.885,185.835),(38.035,185.835),(38.035,185.685),(37.885,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,185.685),(38.205,185.835),(38.355,185.835),(38.355,185.685),(38.205,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,186.005),(37.245,186.155),(37.395,186.155),(37.395,186.005),(37.245,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,186.005),(37.565,186.155),(37.715,186.155),(37.715,186.005),(37.565,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,186.005),(37.885,186.155),(38.035,186.155),(38.035,186.005),(37.885,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,186.005),(38.205,186.155),(38.355,186.155),(38.355,186.005),(38.205,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,186.325),(37.245,186.475),(37.395,186.475),(37.395,186.325),(37.245,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,186.325),(37.565,186.475),(37.715,186.475),(37.715,186.325),(37.565,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,186.325),(37.885,186.475),(38.035,186.475),(38.035,186.325),(37.885,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,186.325),(38.205,186.475),(38.355,186.475),(38.355,186.325),(38.205,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,186.645),(37.245,186.795),(37.395,186.795),(37.395,186.645),(37.245,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,186.645),(37.565,186.795),(37.715,186.795),(37.715,186.645),(37.565,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,186.645),(37.885,186.795),(38.035,186.795),(38.035,186.645),(37.885,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,186.645),(38.205,186.795),(38.355,186.795),(38.355,186.645),(38.205,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,186.965),(37.245,187.115),(37.395,187.115),(37.395,186.965),(37.245,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,186.965),(37.565,187.115),(37.715,187.115),(37.715,186.965),(37.565,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,186.965),(37.885,187.115),(38.035,187.115),(38.035,186.965),(37.885,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,186.965),(38.205,187.115),(38.355,187.115),(38.355,186.965),(38.205,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,187.285),(37.245,187.435),(37.395,187.435),(37.395,187.285),(37.245,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,187.285),(37.565,187.435),(37.715,187.435),(37.715,187.285),(37.565,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,187.285),(37.885,187.435),(38.035,187.435),(38.035,187.285),(37.885,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,187.285),(38.205,187.435),(38.355,187.435),(38.355,187.285),(38.205,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,187.605),(37.245,187.755),(37.395,187.755),(37.395,187.605),(37.245,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,187.605),(37.565,187.755),(37.715,187.755),(37.715,187.605),(37.565,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,187.605),(37.885,187.755),(38.035,187.755),(38.035,187.605),(37.885,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,187.605),(38.205,187.755),(38.355,187.755),(38.355,187.605),(38.205,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,173.845),(75.645,173.995),(75.795,173.995),(75.795,173.845),(75.645,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,173.845),(75.965,173.995),(76.115,173.995),(76.115,173.845),(75.965,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,173.845),(76.285,173.995),(76.435,173.995),(76.435,173.845),(76.285,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,173.845),(76.605,173.995),(76.755,173.995),(76.755,173.845),(76.605,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,174.165),(75.645,174.315),(75.795,174.315),(75.795,174.165),(75.645,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,174.165),(75.965,174.315),(76.115,174.315),(76.115,174.165),(75.965,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,174.165),(76.285,174.315),(76.435,174.315),(76.435,174.165),(76.285,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,174.165),(76.605,174.315),(76.755,174.315),(76.755,174.165),(76.605,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,174.485),(75.645,174.635),(75.795,174.635),(75.795,174.485),(75.645,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,174.485),(75.965,174.635),(76.115,174.635),(76.115,174.485),(75.965,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,174.485),(76.285,174.635),(76.435,174.635),(76.435,174.485),(76.285,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,174.485),(76.605,174.635),(76.755,174.635),(76.755,174.485),(76.605,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,174.805),(75.645,174.955),(75.795,174.955),(75.795,174.805),(75.645,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,174.805),(75.965,174.955),(76.115,174.955),(76.115,174.805),(75.965,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,174.805),(76.285,174.955),(76.435,174.955),(76.435,174.805),(76.285,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,174.805),(76.605,174.955),(76.755,174.955),(76.755,174.805),(76.605,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,175.125),(75.645,175.275),(75.795,175.275),(75.795,175.125),(75.645,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,175.125),(75.965,175.275),(76.115,175.275),(76.115,175.125),(75.965,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,175.125),(76.285,175.275),(76.435,175.275),(76.435,175.125),(76.285,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,175.125),(76.605,175.275),(76.755,175.275),(76.755,175.125),(76.605,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,175.445),(75.645,175.595),(75.795,175.595),(75.795,175.445),(75.645,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,175.445),(75.965,175.595),(76.115,175.595),(76.115,175.445),(75.965,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,175.445),(76.285,175.595),(76.435,175.595),(76.435,175.445),(76.285,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,175.445),(76.605,175.595),(76.755,175.595),(76.755,175.445),(76.605,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,175.765),(75.645,175.915),(75.795,175.915),(75.795,175.765),(75.645,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,175.765),(75.965,175.915),(76.115,175.915),(76.115,175.765),(75.965,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,175.765),(76.285,175.915),(76.435,175.915),(76.435,175.765),(76.285,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,175.765),(76.605,175.915),(76.755,175.915),(76.755,175.765),(76.605,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,176.085),(75.645,176.235),(75.795,176.235),(75.795,176.085),(75.645,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,176.085),(75.965,176.235),(76.115,176.235),(76.115,176.085),(75.965,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,176.085),(76.285,176.235),(76.435,176.235),(76.435,176.085),(76.285,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,176.085),(76.605,176.235),(76.755,176.235),(76.755,176.085),(76.605,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,176.405),(75.645,176.555),(75.795,176.555),(75.795,176.405),(75.645,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,176.405),(75.965,176.555),(76.115,176.555),(76.115,176.405),(75.965,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,176.405),(76.285,176.555),(76.435,176.555),(76.435,176.405),(76.285,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,176.405),(76.605,176.555),(76.755,176.555),(76.755,176.405),(76.605,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,176.725),(75.645,176.875),(75.795,176.875),(75.795,176.725),(75.645,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,176.725),(75.965,176.875),(76.115,176.875),(76.115,176.725),(75.965,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,176.725),(76.285,176.875),(76.435,176.875),(76.435,176.725),(76.285,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,176.725),(76.605,176.875),(76.755,176.875),(76.755,176.725),(76.605,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,177.045),(75.645,177.195),(75.795,177.195),(75.795,177.045),(75.645,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,177.045),(75.965,177.195),(76.115,177.195),(76.115,177.045),(75.965,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,177.045),(76.285,177.195),(76.435,177.195),(76.435,177.045),(76.285,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,177.045),(76.605,177.195),(76.755,177.195),(76.755,177.045),(76.605,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,177.365),(75.645,177.515),(75.795,177.515),(75.795,177.365),(75.645,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,177.365),(75.965,177.515),(76.115,177.515),(76.115,177.365),(75.965,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,177.365),(76.285,177.515),(76.435,177.515),(76.435,177.365),(76.285,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,177.365),(76.605,177.515),(76.755,177.515),(76.755,177.365),(76.605,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,177.685),(75.645,177.835),(75.795,177.835),(75.795,177.685),(75.645,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,177.685),(75.965,177.835),(76.115,177.835),(76.115,177.685),(75.965,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,177.685),(76.285,177.835),(76.435,177.835),(76.435,177.685),(76.285,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,177.685),(76.605,177.835),(76.755,177.835),(76.755,177.685),(76.605,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,178.005),(75.645,178.155),(75.795,178.155),(75.795,178.005),(75.645,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,178.005),(75.965,178.155),(76.115,178.155),(76.115,178.005),(75.965,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,178.005),(76.285,178.155),(76.435,178.155),(76.435,178.005),(76.285,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,178.005),(76.605,178.155),(76.755,178.155),(76.755,178.005),(76.605,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,178.325),(75.645,178.475),(75.795,178.475),(75.795,178.325),(75.645,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,178.325),(75.965,178.475),(76.115,178.475),(76.115,178.325),(75.965,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,178.325),(76.285,178.475),(76.435,178.475),(76.435,178.325),(76.285,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,178.325),(76.605,178.475),(76.755,178.475),(76.755,178.325),(76.605,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,178.645),(75.645,178.795),(75.795,178.795),(75.795,178.645),(75.645,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,178.645),(75.965,178.795),(76.115,178.795),(76.115,178.645),(75.965,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,178.645),(76.285,178.795),(76.435,178.795),(76.435,178.645),(76.285,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,178.645),(76.605,178.795),(76.755,178.795),(76.755,178.645),(76.605,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,178.965),(75.645,179.115),(75.795,179.115),(75.795,178.965),(75.645,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,178.965),(75.965,179.115),(76.115,179.115),(76.115,178.965),(75.965,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,178.965),(76.285,179.115),(76.435,179.115),(76.435,178.965),(76.285,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,178.965),(76.605,179.115),(76.755,179.115),(76.755,178.965),(76.605,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,179.285),(75.645,179.435),(75.795,179.435),(75.795,179.285),(75.645,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,179.285),(75.965,179.435),(76.115,179.435),(76.115,179.285),(75.965,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,179.285),(76.285,179.435),(76.435,179.435),(76.435,179.285),(76.285,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,179.285),(76.605,179.435),(76.755,179.435),(76.755,179.285),(76.605,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,179.605),(75.645,179.755),(75.795,179.755),(75.795,179.605),(75.645,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,179.605),(75.965,179.755),(76.115,179.755),(76.115,179.605),(75.965,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,179.605),(76.285,179.755),(76.435,179.755),(76.435,179.605),(76.285,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,179.605),(76.605,179.755),(76.755,179.755),(76.755,179.605),(76.605,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,179.925),(75.645,180.075),(75.795,180.075),(75.795,179.925),(75.645,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,179.925),(75.965,180.075),(76.115,180.075),(76.115,179.925),(75.965,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,179.925),(76.285,180.075),(76.435,180.075),(76.435,179.925),(76.285,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,179.925),(76.605,180.075),(76.755,180.075),(76.755,179.925),(76.605,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,180.245),(75.645,180.395),(75.795,180.395),(75.795,180.245),(75.645,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,180.245),(75.965,180.395),(76.115,180.395),(76.115,180.245),(75.965,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,180.245),(76.285,180.395),(76.435,180.395),(76.435,180.245),(76.285,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,180.245),(76.605,180.395),(76.755,180.395),(76.755,180.245),(76.605,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,180.565),(75.645,180.715),(75.795,180.715),(75.795,180.565),(75.645,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,180.565),(75.965,180.715),(76.115,180.715),(76.115,180.565),(75.965,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,180.565),(76.285,180.715),(76.435,180.715),(76.435,180.565),(76.285,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,180.565),(76.605,180.715),(76.755,180.715),(76.755,180.565),(76.605,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,180.885),(75.645,181.035),(75.795,181.035),(75.795,180.885),(75.645,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,180.885),(75.965,181.035),(76.115,181.035),(76.115,180.885),(75.965,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,180.885),(76.285,181.035),(76.435,181.035),(76.435,180.885),(76.285,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,180.885),(76.605,181.035),(76.755,181.035),(76.755,180.885),(76.605,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,181.205),(75.645,181.355),(75.795,181.355),(75.795,181.205),(75.645,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,181.205),(75.965,181.355),(76.115,181.355),(76.115,181.205),(75.965,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,181.205),(76.285,181.355),(76.435,181.355),(76.435,181.205),(76.285,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,181.205),(76.605,181.355),(76.755,181.355),(76.755,181.205),(76.605,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,181.525),(75.645,181.675),(75.795,181.675),(75.795,181.525),(75.645,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,181.525),(75.965,181.675),(76.115,181.675),(76.115,181.525),(75.965,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,181.525),(76.285,181.675),(76.435,181.675),(76.435,181.525),(76.285,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,181.525),(76.605,181.675),(76.755,181.675),(76.755,181.525),(76.605,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,181.845),(75.645,181.995),(75.795,181.995),(75.795,181.845),(75.645,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,181.845),(75.965,181.995),(76.115,181.995),(76.115,181.845),(75.965,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,181.845),(76.285,181.995),(76.435,181.995),(76.435,181.845),(76.285,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,181.845),(76.605,181.995),(76.755,181.995),(76.755,181.845),(76.605,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,182.165),(75.645,182.315),(75.795,182.315),(75.795,182.165),(75.645,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,182.165),(75.965,182.315),(76.115,182.315),(76.115,182.165),(75.965,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,182.165),(76.285,182.315),(76.435,182.315),(76.435,182.165),(76.285,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,182.165),(76.605,182.315),(76.755,182.315),(76.755,182.165),(76.605,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,182.485),(75.645,182.635),(75.795,182.635),(75.795,182.485),(75.645,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,182.485),(75.965,182.635),(76.115,182.635),(76.115,182.485),(75.965,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,182.485),(76.285,182.635),(76.435,182.635),(76.435,182.485),(76.285,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,182.485),(76.605,182.635),(76.755,182.635),(76.755,182.485),(76.605,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,182.805),(75.645,182.955),(75.795,182.955),(75.795,182.805),(75.645,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,182.805),(75.965,182.955),(76.115,182.955),(76.115,182.805),(75.965,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,182.805),(76.285,182.955),(76.435,182.955),(76.435,182.805),(76.285,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,182.805),(76.605,182.955),(76.755,182.955),(76.755,182.805),(76.605,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,183.125),(75.645,183.275),(75.795,183.275),(75.795,183.125),(75.645,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,183.125),(75.965,183.275),(76.115,183.275),(76.115,183.125),(75.965,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,183.125),(76.285,183.275),(76.435,183.275),(76.435,183.125),(76.285,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,183.125),(76.605,183.275),(76.755,183.275),(76.755,183.125),(76.605,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,183.445),(75.645,183.595),(75.795,183.595),(75.795,183.445),(75.645,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,183.445),(75.965,183.595),(76.115,183.595),(76.115,183.445),(75.965,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,183.445),(76.285,183.595),(76.435,183.595),(76.435,183.445),(76.285,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,183.445),(76.605,183.595),(76.755,183.595),(76.755,183.445),(76.605,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,183.765),(75.645,183.915),(75.795,183.915),(75.795,183.765),(75.645,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,183.765),(75.965,183.915),(76.115,183.915),(76.115,183.765),(75.965,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,183.765),(76.285,183.915),(76.435,183.915),(76.435,183.765),(76.285,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,183.765),(76.605,183.915),(76.755,183.915),(76.755,183.765),(76.605,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,184.085),(75.645,184.235),(75.795,184.235),(75.795,184.085),(75.645,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,184.085),(75.965,184.235),(76.115,184.235),(76.115,184.085),(75.965,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,184.085),(76.285,184.235),(76.435,184.235),(76.435,184.085),(76.285,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,184.085),(76.605,184.235),(76.755,184.235),(76.755,184.085),(76.605,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,184.405),(75.645,184.555),(75.795,184.555),(75.795,184.405),(75.645,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,184.405),(75.965,184.555),(76.115,184.555),(76.115,184.405),(75.965,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,184.405),(76.285,184.555),(76.435,184.555),(76.435,184.405),(76.285,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,184.405),(76.605,184.555),(76.755,184.555),(76.755,184.405),(76.605,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,184.725),(75.645,184.875),(75.795,184.875),(75.795,184.725),(75.645,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,184.725),(75.965,184.875),(76.115,184.875),(76.115,184.725),(75.965,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,184.725),(76.285,184.875),(76.435,184.875),(76.435,184.725),(76.285,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,184.725),(76.605,184.875),(76.755,184.875),(76.755,184.725),(76.605,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,185.045),(75.645,185.195),(75.795,185.195),(75.795,185.045),(75.645,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,185.045),(75.965,185.195),(76.115,185.195),(76.115,185.045),(75.965,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,185.045),(76.285,185.195),(76.435,185.195),(76.435,185.045),(76.285,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,185.045),(76.605,185.195),(76.755,185.195),(76.755,185.045),(76.605,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,185.365),(75.645,185.515),(75.795,185.515),(75.795,185.365),(75.645,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,185.365),(75.965,185.515),(76.115,185.515),(76.115,185.365),(75.965,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,185.365),(76.285,185.515),(76.435,185.515),(76.435,185.365),(76.285,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,185.365),(76.605,185.515),(76.755,185.515),(76.755,185.365),(76.605,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,185.685),(75.645,185.835),(75.795,185.835),(75.795,185.685),(75.645,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,185.685),(75.965,185.835),(76.115,185.835),(76.115,185.685),(75.965,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,185.685),(76.285,185.835),(76.435,185.835),(76.435,185.685),(76.285,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,185.685),(76.605,185.835),(76.755,185.835),(76.755,185.685),(76.605,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,186.005),(75.645,186.155),(75.795,186.155),(75.795,186.005),(75.645,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,186.005),(75.965,186.155),(76.115,186.155),(76.115,186.005),(75.965,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,186.005),(76.285,186.155),(76.435,186.155),(76.435,186.005),(76.285,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,186.005),(76.605,186.155),(76.755,186.155),(76.755,186.005),(76.605,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,186.325),(75.645,186.475),(75.795,186.475),(75.795,186.325),(75.645,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,186.325),(75.965,186.475),(76.115,186.475),(76.115,186.325),(75.965,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,186.325),(76.285,186.475),(76.435,186.475),(76.435,186.325),(76.285,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,186.325),(76.605,186.475),(76.755,186.475),(76.755,186.325),(76.605,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,186.645),(75.645,186.795),(75.795,186.795),(75.795,186.645),(75.645,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,186.645),(75.965,186.795),(76.115,186.795),(76.115,186.645),(75.965,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,186.645),(76.285,186.795),(76.435,186.795),(76.435,186.645),(76.285,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,186.645),(76.605,186.795),(76.755,186.795),(76.755,186.645),(76.605,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,186.965),(75.645,187.115),(75.795,187.115),(75.795,186.965),(75.645,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,186.965),(75.965,187.115),(76.115,187.115),(76.115,186.965),(75.965,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,186.965),(76.285,187.115),(76.435,187.115),(76.435,186.965),(76.285,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,186.965),(76.605,187.115),(76.755,187.115),(76.755,186.965),(76.605,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,187.285),(75.645,187.435),(75.795,187.435),(75.795,187.285),(75.645,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,187.285),(75.965,187.435),(76.115,187.435),(76.115,187.285),(75.965,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,187.285),(76.285,187.435),(76.435,187.435),(76.435,187.285),(76.285,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,187.285),(76.605,187.435),(76.755,187.435),(76.755,187.285),(76.605,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,187.605),(75.645,187.755),(75.795,187.755),(75.795,187.605),(75.645,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,187.605),(75.965,187.755),(76.115,187.755),(76.115,187.605),(75.965,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,187.605),(76.285,187.755),(76.435,187.755),(76.435,187.605),(76.285,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,187.605),(76.605,187.755),(76.755,187.755),(76.755,187.605),(76.605,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,173.845),(66.045,173.995),(66.195,173.995),(66.195,173.845),(66.045,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,173.845),(66.365,173.995),(66.515,173.995),(66.515,173.845),(66.365,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,173.845),(66.685,173.995),(66.835,173.995),(66.835,173.845),(66.685,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,173.845),(67.005,173.995),(67.155,173.995),(67.155,173.845),(67.005,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,174.165),(66.045,174.315),(66.195,174.315),(66.195,174.165),(66.045,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,174.165),(66.365,174.315),(66.515,174.315),(66.515,174.165),(66.365,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,174.165),(66.685,174.315),(66.835,174.315),(66.835,174.165),(66.685,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,174.165),(67.005,174.315),(67.155,174.315),(67.155,174.165),(67.005,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,174.485),(66.045,174.635),(66.195,174.635),(66.195,174.485),(66.045,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,174.485),(66.365,174.635),(66.515,174.635),(66.515,174.485),(66.365,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,174.485),(66.685,174.635),(66.835,174.635),(66.835,174.485),(66.685,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,174.485),(67.005,174.635),(67.155,174.635),(67.155,174.485),(67.005,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,174.805),(66.045,174.955),(66.195,174.955),(66.195,174.805),(66.045,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,174.805),(66.365,174.955),(66.515,174.955),(66.515,174.805),(66.365,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,174.805),(66.685,174.955),(66.835,174.955),(66.835,174.805),(66.685,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,174.805),(67.005,174.955),(67.155,174.955),(67.155,174.805),(67.005,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,175.125),(66.045,175.275),(66.195,175.275),(66.195,175.125),(66.045,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,175.125),(66.365,175.275),(66.515,175.275),(66.515,175.125),(66.365,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,175.125),(66.685,175.275),(66.835,175.275),(66.835,175.125),(66.685,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,175.125),(67.005,175.275),(67.155,175.275),(67.155,175.125),(67.005,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,175.445),(66.045,175.595),(66.195,175.595),(66.195,175.445),(66.045,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,175.445),(66.365,175.595),(66.515,175.595),(66.515,175.445),(66.365,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,175.445),(66.685,175.595),(66.835,175.595),(66.835,175.445),(66.685,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,175.445),(67.005,175.595),(67.155,175.595),(67.155,175.445),(67.005,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,175.765),(66.045,175.915),(66.195,175.915),(66.195,175.765),(66.045,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,175.765),(66.365,175.915),(66.515,175.915),(66.515,175.765),(66.365,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,175.765),(66.685,175.915),(66.835,175.915),(66.835,175.765),(66.685,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,175.765),(67.005,175.915),(67.155,175.915),(67.155,175.765),(67.005,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,176.085),(66.045,176.235),(66.195,176.235),(66.195,176.085),(66.045,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,176.085),(66.365,176.235),(66.515,176.235),(66.515,176.085),(66.365,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,176.085),(66.685,176.235),(66.835,176.235),(66.835,176.085),(66.685,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,176.085),(67.005,176.235),(67.155,176.235),(67.155,176.085),(67.005,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,176.405),(66.045,176.555),(66.195,176.555),(66.195,176.405),(66.045,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,176.405),(66.365,176.555),(66.515,176.555),(66.515,176.405),(66.365,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,176.405),(66.685,176.555),(66.835,176.555),(66.835,176.405),(66.685,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,176.405),(67.005,176.555),(67.155,176.555),(67.155,176.405),(67.005,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,176.725),(66.045,176.875),(66.195,176.875),(66.195,176.725),(66.045,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,176.725),(66.365,176.875),(66.515,176.875),(66.515,176.725),(66.365,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,176.725),(66.685,176.875),(66.835,176.875),(66.835,176.725),(66.685,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,176.725),(67.005,176.875),(67.155,176.875),(67.155,176.725),(67.005,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,177.045),(66.045,177.195),(66.195,177.195),(66.195,177.045),(66.045,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,177.045),(66.365,177.195),(66.515,177.195),(66.515,177.045),(66.365,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,177.045),(66.685,177.195),(66.835,177.195),(66.835,177.045),(66.685,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,177.045),(67.005,177.195),(67.155,177.195),(67.155,177.045),(67.005,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,177.365),(66.045,177.515),(66.195,177.515),(66.195,177.365),(66.045,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,177.365),(66.365,177.515),(66.515,177.515),(66.515,177.365),(66.365,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,177.365),(66.685,177.515),(66.835,177.515),(66.835,177.365),(66.685,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,177.365),(67.005,177.515),(67.155,177.515),(67.155,177.365),(67.005,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,177.685),(66.045,177.835),(66.195,177.835),(66.195,177.685),(66.045,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,177.685),(66.365,177.835),(66.515,177.835),(66.515,177.685),(66.365,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,177.685),(66.685,177.835),(66.835,177.835),(66.835,177.685),(66.685,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,177.685),(67.005,177.835),(67.155,177.835),(67.155,177.685),(67.005,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,178.005),(66.045,178.155),(66.195,178.155),(66.195,178.005),(66.045,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,178.005),(66.365,178.155),(66.515,178.155),(66.515,178.005),(66.365,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,178.005),(66.685,178.155),(66.835,178.155),(66.835,178.005),(66.685,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,178.005),(67.005,178.155),(67.155,178.155),(67.155,178.005),(67.005,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,178.325),(66.045,178.475),(66.195,178.475),(66.195,178.325),(66.045,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,178.325),(66.365,178.475),(66.515,178.475),(66.515,178.325),(66.365,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,178.325),(66.685,178.475),(66.835,178.475),(66.835,178.325),(66.685,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,178.325),(67.005,178.475),(67.155,178.475),(67.155,178.325),(67.005,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,178.645),(66.045,178.795),(66.195,178.795),(66.195,178.645),(66.045,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,178.645),(66.365,178.795),(66.515,178.795),(66.515,178.645),(66.365,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,178.645),(66.685,178.795),(66.835,178.795),(66.835,178.645),(66.685,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,178.645),(67.005,178.795),(67.155,178.795),(67.155,178.645),(67.005,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,178.965),(66.045,179.115),(66.195,179.115),(66.195,178.965),(66.045,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,178.965),(66.365,179.115),(66.515,179.115),(66.515,178.965),(66.365,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,178.965),(66.685,179.115),(66.835,179.115),(66.835,178.965),(66.685,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,178.965),(67.005,179.115),(67.155,179.115),(67.155,178.965),(67.005,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,179.285),(66.045,179.435),(66.195,179.435),(66.195,179.285),(66.045,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,179.285),(66.365,179.435),(66.515,179.435),(66.515,179.285),(66.365,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,179.285),(66.685,179.435),(66.835,179.435),(66.835,179.285),(66.685,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,179.285),(67.005,179.435),(67.155,179.435),(67.155,179.285),(67.005,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,179.605),(66.045,179.755),(66.195,179.755),(66.195,179.605),(66.045,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,179.605),(66.365,179.755),(66.515,179.755),(66.515,179.605),(66.365,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,179.605),(66.685,179.755),(66.835,179.755),(66.835,179.605),(66.685,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,179.605),(67.005,179.755),(67.155,179.755),(67.155,179.605),(67.005,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,179.925),(66.045,180.075),(66.195,180.075),(66.195,179.925),(66.045,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,179.925),(66.365,180.075),(66.515,180.075),(66.515,179.925),(66.365,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,179.925),(66.685,180.075),(66.835,180.075),(66.835,179.925),(66.685,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,179.925),(67.005,180.075),(67.155,180.075),(67.155,179.925),(67.005,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,180.245),(66.045,180.395),(66.195,180.395),(66.195,180.245),(66.045,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,180.245),(66.365,180.395),(66.515,180.395),(66.515,180.245),(66.365,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,180.245),(66.685,180.395),(66.835,180.395),(66.835,180.245),(66.685,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,180.245),(67.005,180.395),(67.155,180.395),(67.155,180.245),(67.005,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,180.565),(66.045,180.715),(66.195,180.715),(66.195,180.565),(66.045,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,180.565),(66.365,180.715),(66.515,180.715),(66.515,180.565),(66.365,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,180.565),(66.685,180.715),(66.835,180.715),(66.835,180.565),(66.685,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,180.565),(67.005,180.715),(67.155,180.715),(67.155,180.565),(67.005,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,180.885),(66.045,181.035),(66.195,181.035),(66.195,180.885),(66.045,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,180.885),(66.365,181.035),(66.515,181.035),(66.515,180.885),(66.365,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,180.885),(66.685,181.035),(66.835,181.035),(66.835,180.885),(66.685,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,180.885),(67.005,181.035),(67.155,181.035),(67.155,180.885),(67.005,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,181.205),(66.045,181.355),(66.195,181.355),(66.195,181.205),(66.045,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,181.205),(66.365,181.355),(66.515,181.355),(66.515,181.205),(66.365,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,181.205),(66.685,181.355),(66.835,181.355),(66.835,181.205),(66.685,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,181.205),(67.005,181.355),(67.155,181.355),(67.155,181.205),(67.005,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,181.525),(66.045,181.675),(66.195,181.675),(66.195,181.525),(66.045,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,181.525),(66.365,181.675),(66.515,181.675),(66.515,181.525),(66.365,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,181.525),(66.685,181.675),(66.835,181.675),(66.835,181.525),(66.685,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,181.525),(67.005,181.675),(67.155,181.675),(67.155,181.525),(67.005,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,181.845),(66.045,181.995),(66.195,181.995),(66.195,181.845),(66.045,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,181.845),(66.365,181.995),(66.515,181.995),(66.515,181.845),(66.365,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,181.845),(66.685,181.995),(66.835,181.995),(66.835,181.845),(66.685,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,181.845),(67.005,181.995),(67.155,181.995),(67.155,181.845),(67.005,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,182.165),(66.045,182.315),(66.195,182.315),(66.195,182.165),(66.045,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,182.165),(66.365,182.315),(66.515,182.315),(66.515,182.165),(66.365,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,182.165),(66.685,182.315),(66.835,182.315),(66.835,182.165),(66.685,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,182.165),(67.005,182.315),(67.155,182.315),(67.155,182.165),(67.005,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,182.485),(66.045,182.635),(66.195,182.635),(66.195,182.485),(66.045,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,182.485),(66.365,182.635),(66.515,182.635),(66.515,182.485),(66.365,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,182.485),(66.685,182.635),(66.835,182.635),(66.835,182.485),(66.685,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,182.485),(67.005,182.635),(67.155,182.635),(67.155,182.485),(67.005,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,182.805),(66.045,182.955),(66.195,182.955),(66.195,182.805),(66.045,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,182.805),(66.365,182.955),(66.515,182.955),(66.515,182.805),(66.365,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,182.805),(66.685,182.955),(66.835,182.955),(66.835,182.805),(66.685,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,182.805),(67.005,182.955),(67.155,182.955),(67.155,182.805),(67.005,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,183.125),(66.045,183.275),(66.195,183.275),(66.195,183.125),(66.045,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,183.125),(66.365,183.275),(66.515,183.275),(66.515,183.125),(66.365,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,183.125),(66.685,183.275),(66.835,183.275),(66.835,183.125),(66.685,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,183.125),(67.005,183.275),(67.155,183.275),(67.155,183.125),(67.005,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,183.445),(66.045,183.595),(66.195,183.595),(66.195,183.445),(66.045,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,183.445),(66.365,183.595),(66.515,183.595),(66.515,183.445),(66.365,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,183.445),(66.685,183.595),(66.835,183.595),(66.835,183.445),(66.685,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,183.445),(67.005,183.595),(67.155,183.595),(67.155,183.445),(67.005,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,183.765),(66.045,183.915),(66.195,183.915),(66.195,183.765),(66.045,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,183.765),(66.365,183.915),(66.515,183.915),(66.515,183.765),(66.365,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,183.765),(66.685,183.915),(66.835,183.915),(66.835,183.765),(66.685,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,183.765),(67.005,183.915),(67.155,183.915),(67.155,183.765),(67.005,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,184.085),(66.045,184.235),(66.195,184.235),(66.195,184.085),(66.045,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,184.085),(66.365,184.235),(66.515,184.235),(66.515,184.085),(66.365,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,184.085),(66.685,184.235),(66.835,184.235),(66.835,184.085),(66.685,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,184.085),(67.005,184.235),(67.155,184.235),(67.155,184.085),(67.005,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,184.405),(66.045,184.555),(66.195,184.555),(66.195,184.405),(66.045,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,184.405),(66.365,184.555),(66.515,184.555),(66.515,184.405),(66.365,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,184.405),(66.685,184.555),(66.835,184.555),(66.835,184.405),(66.685,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,184.405),(67.005,184.555),(67.155,184.555),(67.155,184.405),(67.005,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,184.725),(66.045,184.875),(66.195,184.875),(66.195,184.725),(66.045,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,184.725),(66.365,184.875),(66.515,184.875),(66.515,184.725),(66.365,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,184.725),(66.685,184.875),(66.835,184.875),(66.835,184.725),(66.685,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,184.725),(67.005,184.875),(67.155,184.875),(67.155,184.725),(67.005,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,185.045),(66.045,185.195),(66.195,185.195),(66.195,185.045),(66.045,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,185.045),(66.365,185.195),(66.515,185.195),(66.515,185.045),(66.365,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,185.045),(66.685,185.195),(66.835,185.195),(66.835,185.045),(66.685,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,185.045),(67.005,185.195),(67.155,185.195),(67.155,185.045),(67.005,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,185.365),(66.045,185.515),(66.195,185.515),(66.195,185.365),(66.045,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,185.365),(66.365,185.515),(66.515,185.515),(66.515,185.365),(66.365,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,185.365),(66.685,185.515),(66.835,185.515),(66.835,185.365),(66.685,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,185.365),(67.005,185.515),(67.155,185.515),(67.155,185.365),(67.005,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,185.685),(66.045,185.835),(66.195,185.835),(66.195,185.685),(66.045,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,185.685),(66.365,185.835),(66.515,185.835),(66.515,185.685),(66.365,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,185.685),(66.685,185.835),(66.835,185.835),(66.835,185.685),(66.685,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,185.685),(67.005,185.835),(67.155,185.835),(67.155,185.685),(67.005,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,186.005),(66.045,186.155),(66.195,186.155),(66.195,186.005),(66.045,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,186.005),(66.365,186.155),(66.515,186.155),(66.515,186.005),(66.365,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,186.005),(66.685,186.155),(66.835,186.155),(66.835,186.005),(66.685,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,186.005),(67.005,186.155),(67.155,186.155),(67.155,186.005),(67.005,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,186.325),(66.045,186.475),(66.195,186.475),(66.195,186.325),(66.045,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,186.325),(66.365,186.475),(66.515,186.475),(66.515,186.325),(66.365,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,186.325),(66.685,186.475),(66.835,186.475),(66.835,186.325),(66.685,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,186.325),(67.005,186.475),(67.155,186.475),(67.155,186.325),(67.005,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,186.645),(66.045,186.795),(66.195,186.795),(66.195,186.645),(66.045,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,186.645),(66.365,186.795),(66.515,186.795),(66.515,186.645),(66.365,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,186.645),(66.685,186.795),(66.835,186.795),(66.835,186.645),(66.685,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,186.645),(67.005,186.795),(67.155,186.795),(67.155,186.645),(67.005,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,186.965),(66.045,187.115),(66.195,187.115),(66.195,186.965),(66.045,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,186.965),(66.365,187.115),(66.515,187.115),(66.515,186.965),(66.365,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,186.965),(66.685,187.115),(66.835,187.115),(66.835,186.965),(66.685,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,186.965),(67.005,187.115),(67.155,187.115),(67.155,186.965),(67.005,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,187.285),(66.045,187.435),(66.195,187.435),(66.195,187.285),(66.045,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,187.285),(66.365,187.435),(66.515,187.435),(66.515,187.285),(66.365,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,187.285),(66.685,187.435),(66.835,187.435),(66.835,187.285),(66.685,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,187.285),(67.005,187.435),(67.155,187.435),(67.155,187.285),(67.005,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,187.605),(66.045,187.755),(66.195,187.755),(66.195,187.605),(66.045,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,187.605),(66.365,187.755),(66.515,187.755),(66.515,187.605),(66.365,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,187.605),(66.685,187.755),(66.835,187.755),(66.835,187.605),(66.685,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,187.605),(67.005,187.755),(67.155,187.755),(67.155,187.605),(67.005,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,173.845),(80.445,173.995),(80.595,173.995),(80.595,173.845),(80.445,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,173.845),(80.765,173.995),(80.915,173.995),(80.915,173.845),(80.765,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,173.845),(81.085,173.995),(81.235,173.995),(81.235,173.845),(81.085,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,173.845),(81.405,173.995),(81.555,173.995),(81.555,173.845),(81.405,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,174.165),(80.445,174.315),(80.595,174.315),(80.595,174.165),(80.445,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,174.165),(80.765,174.315),(80.915,174.315),(80.915,174.165),(80.765,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,174.165),(81.085,174.315),(81.235,174.315),(81.235,174.165),(81.085,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,174.165),(81.405,174.315),(81.555,174.315),(81.555,174.165),(81.405,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,174.485),(80.445,174.635),(80.595,174.635),(80.595,174.485),(80.445,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,174.485),(80.765,174.635),(80.915,174.635),(80.915,174.485),(80.765,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,174.485),(81.085,174.635),(81.235,174.635),(81.235,174.485),(81.085,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,174.485),(81.405,174.635),(81.555,174.635),(81.555,174.485),(81.405,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,174.805),(80.445,174.955),(80.595,174.955),(80.595,174.805),(80.445,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,174.805),(80.765,174.955),(80.915,174.955),(80.915,174.805),(80.765,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,174.805),(81.085,174.955),(81.235,174.955),(81.235,174.805),(81.085,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,174.805),(81.405,174.955),(81.555,174.955),(81.555,174.805),(81.405,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,175.125),(80.445,175.275),(80.595,175.275),(80.595,175.125),(80.445,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,175.125),(80.765,175.275),(80.915,175.275),(80.915,175.125),(80.765,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,175.125),(81.085,175.275),(81.235,175.275),(81.235,175.125),(81.085,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,175.125),(81.405,175.275),(81.555,175.275),(81.555,175.125),(81.405,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,175.445),(80.445,175.595),(80.595,175.595),(80.595,175.445),(80.445,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,175.445),(80.765,175.595),(80.915,175.595),(80.915,175.445),(80.765,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,175.445),(81.085,175.595),(81.235,175.595),(81.235,175.445),(81.085,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,175.445),(81.405,175.595),(81.555,175.595),(81.555,175.445),(81.405,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,175.765),(80.445,175.915),(80.595,175.915),(80.595,175.765),(80.445,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,175.765),(80.765,175.915),(80.915,175.915),(80.915,175.765),(80.765,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,175.765),(81.085,175.915),(81.235,175.915),(81.235,175.765),(81.085,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,175.765),(81.405,175.915),(81.555,175.915),(81.555,175.765),(81.405,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,176.085),(80.445,176.235),(80.595,176.235),(80.595,176.085),(80.445,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,176.085),(80.765,176.235),(80.915,176.235),(80.915,176.085),(80.765,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,176.085),(81.085,176.235),(81.235,176.235),(81.235,176.085),(81.085,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,176.085),(81.405,176.235),(81.555,176.235),(81.555,176.085),(81.405,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,176.405),(80.445,176.555),(80.595,176.555),(80.595,176.405),(80.445,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,176.405),(80.765,176.555),(80.915,176.555),(80.915,176.405),(80.765,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,176.405),(81.085,176.555),(81.235,176.555),(81.235,176.405),(81.085,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,176.405),(81.405,176.555),(81.555,176.555),(81.555,176.405),(81.405,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,176.725),(80.445,176.875),(80.595,176.875),(80.595,176.725),(80.445,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,176.725),(80.765,176.875),(80.915,176.875),(80.915,176.725),(80.765,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,176.725),(81.085,176.875),(81.235,176.875),(81.235,176.725),(81.085,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,176.725),(81.405,176.875),(81.555,176.875),(81.555,176.725),(81.405,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,177.045),(80.445,177.195),(80.595,177.195),(80.595,177.045),(80.445,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,177.045),(80.765,177.195),(80.915,177.195),(80.915,177.045),(80.765,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,177.045),(81.085,177.195),(81.235,177.195),(81.235,177.045),(81.085,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,177.045),(81.405,177.195),(81.555,177.195),(81.555,177.045),(81.405,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,177.365),(80.445,177.515),(80.595,177.515),(80.595,177.365),(80.445,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,177.365),(80.765,177.515),(80.915,177.515),(80.915,177.365),(80.765,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,177.365),(81.085,177.515),(81.235,177.515),(81.235,177.365),(81.085,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,177.365),(81.405,177.515),(81.555,177.515),(81.555,177.365),(81.405,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,177.685),(80.445,177.835),(80.595,177.835),(80.595,177.685),(80.445,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,177.685),(80.765,177.835),(80.915,177.835),(80.915,177.685),(80.765,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,177.685),(81.085,177.835),(81.235,177.835),(81.235,177.685),(81.085,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,177.685),(81.405,177.835),(81.555,177.835),(81.555,177.685),(81.405,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,178.005),(80.445,178.155),(80.595,178.155),(80.595,178.005),(80.445,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,178.005),(80.765,178.155),(80.915,178.155),(80.915,178.005),(80.765,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,178.005),(81.085,178.155),(81.235,178.155),(81.235,178.005),(81.085,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,178.005),(81.405,178.155),(81.555,178.155),(81.555,178.005),(81.405,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,178.325),(80.445,178.475),(80.595,178.475),(80.595,178.325),(80.445,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,178.325),(80.765,178.475),(80.915,178.475),(80.915,178.325),(80.765,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,178.325),(81.085,178.475),(81.235,178.475),(81.235,178.325),(81.085,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,178.325),(81.405,178.475),(81.555,178.475),(81.555,178.325),(81.405,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,178.645),(80.445,178.795),(80.595,178.795),(80.595,178.645),(80.445,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,178.645),(80.765,178.795),(80.915,178.795),(80.915,178.645),(80.765,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,178.645),(81.085,178.795),(81.235,178.795),(81.235,178.645),(81.085,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,178.645),(81.405,178.795),(81.555,178.795),(81.555,178.645),(81.405,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,178.965),(80.445,179.115),(80.595,179.115),(80.595,178.965),(80.445,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,178.965),(80.765,179.115),(80.915,179.115),(80.915,178.965),(80.765,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,178.965),(81.085,179.115),(81.235,179.115),(81.235,178.965),(81.085,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,178.965),(81.405,179.115),(81.555,179.115),(81.555,178.965),(81.405,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,179.285),(80.445,179.435),(80.595,179.435),(80.595,179.285),(80.445,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,179.285),(80.765,179.435),(80.915,179.435),(80.915,179.285),(80.765,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,179.285),(81.085,179.435),(81.235,179.435),(81.235,179.285),(81.085,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,179.285),(81.405,179.435),(81.555,179.435),(81.555,179.285),(81.405,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,179.605),(80.445,179.755),(80.595,179.755),(80.595,179.605),(80.445,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,179.605),(80.765,179.755),(80.915,179.755),(80.915,179.605),(80.765,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,179.605),(81.085,179.755),(81.235,179.755),(81.235,179.605),(81.085,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,179.605),(81.405,179.755),(81.555,179.755),(81.555,179.605),(81.405,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,179.925),(80.445,180.075),(80.595,180.075),(80.595,179.925),(80.445,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,179.925),(80.765,180.075),(80.915,180.075),(80.915,179.925),(80.765,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,179.925),(81.085,180.075),(81.235,180.075),(81.235,179.925),(81.085,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,179.925),(81.405,180.075),(81.555,180.075),(81.555,179.925),(81.405,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,180.245),(80.445,180.395),(80.595,180.395),(80.595,180.245),(80.445,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,180.245),(80.765,180.395),(80.915,180.395),(80.915,180.245),(80.765,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,180.245),(81.085,180.395),(81.235,180.395),(81.235,180.245),(81.085,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,180.245),(81.405,180.395),(81.555,180.395),(81.555,180.245),(81.405,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,180.565),(80.445,180.715),(80.595,180.715),(80.595,180.565),(80.445,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,180.565),(80.765,180.715),(80.915,180.715),(80.915,180.565),(80.765,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,180.565),(81.085,180.715),(81.235,180.715),(81.235,180.565),(81.085,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,180.565),(81.405,180.715),(81.555,180.715),(81.555,180.565),(81.405,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,180.885),(80.445,181.035),(80.595,181.035),(80.595,180.885),(80.445,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,180.885),(80.765,181.035),(80.915,181.035),(80.915,180.885),(80.765,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,180.885),(81.085,181.035),(81.235,181.035),(81.235,180.885),(81.085,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,180.885),(81.405,181.035),(81.555,181.035),(81.555,180.885),(81.405,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,181.205),(80.445,181.355),(80.595,181.355),(80.595,181.205),(80.445,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,181.205),(80.765,181.355),(80.915,181.355),(80.915,181.205),(80.765,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,181.205),(81.085,181.355),(81.235,181.355),(81.235,181.205),(81.085,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,181.205),(81.405,181.355),(81.555,181.355),(81.555,181.205),(81.405,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,181.525),(80.445,181.675),(80.595,181.675),(80.595,181.525),(80.445,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,181.525),(80.765,181.675),(80.915,181.675),(80.915,181.525),(80.765,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,181.525),(81.085,181.675),(81.235,181.675),(81.235,181.525),(81.085,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,181.525),(81.405,181.675),(81.555,181.675),(81.555,181.525),(81.405,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,181.845),(80.445,181.995),(80.595,181.995),(80.595,181.845),(80.445,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,181.845),(80.765,181.995),(80.915,181.995),(80.915,181.845),(80.765,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,181.845),(81.085,181.995),(81.235,181.995),(81.235,181.845),(81.085,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,181.845),(81.405,181.995),(81.555,181.995),(81.555,181.845),(81.405,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,182.165),(80.445,182.315),(80.595,182.315),(80.595,182.165),(80.445,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,182.165),(80.765,182.315),(80.915,182.315),(80.915,182.165),(80.765,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,182.165),(81.085,182.315),(81.235,182.315),(81.235,182.165),(81.085,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,182.165),(81.405,182.315),(81.555,182.315),(81.555,182.165),(81.405,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,182.485),(80.445,182.635),(80.595,182.635),(80.595,182.485),(80.445,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,182.485),(80.765,182.635),(80.915,182.635),(80.915,182.485),(80.765,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,182.485),(81.085,182.635),(81.235,182.635),(81.235,182.485),(81.085,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,182.485),(81.405,182.635),(81.555,182.635),(81.555,182.485),(81.405,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,182.805),(80.445,182.955),(80.595,182.955),(80.595,182.805),(80.445,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,182.805),(80.765,182.955),(80.915,182.955),(80.915,182.805),(80.765,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,182.805),(81.085,182.955),(81.235,182.955),(81.235,182.805),(81.085,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,182.805),(81.405,182.955),(81.555,182.955),(81.555,182.805),(81.405,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,183.125),(80.445,183.275),(80.595,183.275),(80.595,183.125),(80.445,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,183.125),(80.765,183.275),(80.915,183.275),(80.915,183.125),(80.765,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,183.125),(81.085,183.275),(81.235,183.275),(81.235,183.125),(81.085,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,183.125),(81.405,183.275),(81.555,183.275),(81.555,183.125),(81.405,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,183.445),(80.445,183.595),(80.595,183.595),(80.595,183.445),(80.445,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,183.445),(80.765,183.595),(80.915,183.595),(80.915,183.445),(80.765,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,183.445),(81.085,183.595),(81.235,183.595),(81.235,183.445),(81.085,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,183.445),(81.405,183.595),(81.555,183.595),(81.555,183.445),(81.405,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,183.765),(80.445,183.915),(80.595,183.915),(80.595,183.765),(80.445,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,183.765),(80.765,183.915),(80.915,183.915),(80.915,183.765),(80.765,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,183.765),(81.085,183.915),(81.235,183.915),(81.235,183.765),(81.085,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,183.765),(81.405,183.915),(81.555,183.915),(81.555,183.765),(81.405,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,184.085),(80.445,184.235),(80.595,184.235),(80.595,184.085),(80.445,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,184.085),(80.765,184.235),(80.915,184.235),(80.915,184.085),(80.765,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,184.085),(81.085,184.235),(81.235,184.235),(81.235,184.085),(81.085,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,184.085),(81.405,184.235),(81.555,184.235),(81.555,184.085),(81.405,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,184.405),(80.445,184.555),(80.595,184.555),(80.595,184.405),(80.445,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,184.405),(80.765,184.555),(80.915,184.555),(80.915,184.405),(80.765,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,184.405),(81.085,184.555),(81.235,184.555),(81.235,184.405),(81.085,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,184.405),(81.405,184.555),(81.555,184.555),(81.555,184.405),(81.405,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,184.725),(80.445,184.875),(80.595,184.875),(80.595,184.725),(80.445,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,184.725),(80.765,184.875),(80.915,184.875),(80.915,184.725),(80.765,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,184.725),(81.085,184.875),(81.235,184.875),(81.235,184.725),(81.085,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,184.725),(81.405,184.875),(81.555,184.875),(81.555,184.725),(81.405,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,185.045),(80.445,185.195),(80.595,185.195),(80.595,185.045),(80.445,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,185.045),(80.765,185.195),(80.915,185.195),(80.915,185.045),(80.765,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,185.045),(81.085,185.195),(81.235,185.195),(81.235,185.045),(81.085,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,185.045),(81.405,185.195),(81.555,185.195),(81.555,185.045),(81.405,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,185.365),(80.445,185.515),(80.595,185.515),(80.595,185.365),(80.445,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,185.365),(80.765,185.515),(80.915,185.515),(80.915,185.365),(80.765,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,185.365),(81.085,185.515),(81.235,185.515),(81.235,185.365),(81.085,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,185.365),(81.405,185.515),(81.555,185.515),(81.555,185.365),(81.405,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,185.685),(80.445,185.835),(80.595,185.835),(80.595,185.685),(80.445,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,185.685),(80.765,185.835),(80.915,185.835),(80.915,185.685),(80.765,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,185.685),(81.085,185.835),(81.235,185.835),(81.235,185.685),(81.085,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,185.685),(81.405,185.835),(81.555,185.835),(81.555,185.685),(81.405,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,186.005),(80.445,186.155),(80.595,186.155),(80.595,186.005),(80.445,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,186.005),(80.765,186.155),(80.915,186.155),(80.915,186.005),(80.765,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,186.005),(81.085,186.155),(81.235,186.155),(81.235,186.005),(81.085,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,186.005),(81.405,186.155),(81.555,186.155),(81.555,186.005),(81.405,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,186.325),(80.445,186.475),(80.595,186.475),(80.595,186.325),(80.445,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,186.325),(80.765,186.475),(80.915,186.475),(80.915,186.325),(80.765,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,186.325),(81.085,186.475),(81.235,186.475),(81.235,186.325),(81.085,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,186.325),(81.405,186.475),(81.555,186.475),(81.555,186.325),(81.405,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,186.645),(80.445,186.795),(80.595,186.795),(80.595,186.645),(80.445,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,186.645),(80.765,186.795),(80.915,186.795),(80.915,186.645),(80.765,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,186.645),(81.085,186.795),(81.235,186.795),(81.235,186.645),(81.085,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,186.645),(81.405,186.795),(81.555,186.795),(81.555,186.645),(81.405,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,186.965),(80.445,187.115),(80.595,187.115),(80.595,186.965),(80.445,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,186.965),(80.765,187.115),(80.915,187.115),(80.915,186.965),(80.765,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,186.965),(81.085,187.115),(81.235,187.115),(81.235,186.965),(81.085,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,186.965),(81.405,187.115),(81.555,187.115),(81.555,186.965),(81.405,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,187.285),(80.445,187.435),(80.595,187.435),(80.595,187.285),(80.445,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,187.285),(80.765,187.435),(80.915,187.435),(80.915,187.285),(80.765,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,187.285),(81.085,187.435),(81.235,187.435),(81.235,187.285),(81.085,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,187.285),(81.405,187.435),(81.555,187.435),(81.555,187.285),(81.405,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,187.605),(80.445,187.755),(80.595,187.755),(80.595,187.605),(80.445,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,187.605),(80.765,187.755),(80.915,187.755),(80.915,187.605),(80.765,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,187.605),(81.085,187.755),(81.235,187.755),(81.235,187.605),(81.085,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,187.605),(81.405,187.755),(81.555,187.755),(81.555,187.605),(81.405,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,173.845),(46.845,173.995),(46.995,173.995),(46.995,173.845),(46.845,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,173.845),(47.165,173.995),(47.315,173.995),(47.315,173.845),(47.165,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,173.845),(47.485,173.995),(47.635,173.995),(47.635,173.845),(47.485,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,173.845),(47.805,173.995),(47.955,173.995),(47.955,173.845),(47.805,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,174.165),(46.845,174.315),(46.995,174.315),(46.995,174.165),(46.845,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,174.165),(47.165,174.315),(47.315,174.315),(47.315,174.165),(47.165,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,174.165),(47.485,174.315),(47.635,174.315),(47.635,174.165),(47.485,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,174.165),(47.805,174.315),(47.955,174.315),(47.955,174.165),(47.805,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,174.485),(46.845,174.635),(46.995,174.635),(46.995,174.485),(46.845,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,174.485),(47.165,174.635),(47.315,174.635),(47.315,174.485),(47.165,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,174.485),(47.485,174.635),(47.635,174.635),(47.635,174.485),(47.485,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,174.485),(47.805,174.635),(47.955,174.635),(47.955,174.485),(47.805,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,174.805),(46.845,174.955),(46.995,174.955),(46.995,174.805),(46.845,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,174.805),(47.165,174.955),(47.315,174.955),(47.315,174.805),(47.165,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,174.805),(47.485,174.955),(47.635,174.955),(47.635,174.805),(47.485,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,174.805),(47.805,174.955),(47.955,174.955),(47.955,174.805),(47.805,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,175.125),(46.845,175.275),(46.995,175.275),(46.995,175.125),(46.845,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,175.125),(47.165,175.275),(47.315,175.275),(47.315,175.125),(47.165,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,175.125),(47.485,175.275),(47.635,175.275),(47.635,175.125),(47.485,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,175.125),(47.805,175.275),(47.955,175.275),(47.955,175.125),(47.805,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,175.445),(46.845,175.595),(46.995,175.595),(46.995,175.445),(46.845,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,175.445),(47.165,175.595),(47.315,175.595),(47.315,175.445),(47.165,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,175.445),(47.485,175.595),(47.635,175.595),(47.635,175.445),(47.485,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,175.445),(47.805,175.595),(47.955,175.595),(47.955,175.445),(47.805,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,175.765),(46.845,175.915),(46.995,175.915),(46.995,175.765),(46.845,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,175.765),(47.165,175.915),(47.315,175.915),(47.315,175.765),(47.165,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,175.765),(47.485,175.915),(47.635,175.915),(47.635,175.765),(47.485,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,175.765),(47.805,175.915),(47.955,175.915),(47.955,175.765),(47.805,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,176.085),(46.845,176.235),(46.995,176.235),(46.995,176.085),(46.845,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,176.085),(47.165,176.235),(47.315,176.235),(47.315,176.085),(47.165,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,176.085),(47.485,176.235),(47.635,176.235),(47.635,176.085),(47.485,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,176.085),(47.805,176.235),(47.955,176.235),(47.955,176.085),(47.805,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,176.405),(46.845,176.555),(46.995,176.555),(46.995,176.405),(46.845,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,176.405),(47.165,176.555),(47.315,176.555),(47.315,176.405),(47.165,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,176.405),(47.485,176.555),(47.635,176.555),(47.635,176.405),(47.485,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,176.405),(47.805,176.555),(47.955,176.555),(47.955,176.405),(47.805,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,176.725),(46.845,176.875),(46.995,176.875),(46.995,176.725),(46.845,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,176.725),(47.165,176.875),(47.315,176.875),(47.315,176.725),(47.165,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,176.725),(47.485,176.875),(47.635,176.875),(47.635,176.725),(47.485,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,176.725),(47.805,176.875),(47.955,176.875),(47.955,176.725),(47.805,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,177.045),(46.845,177.195),(46.995,177.195),(46.995,177.045),(46.845,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,177.045),(47.165,177.195),(47.315,177.195),(47.315,177.045),(47.165,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,177.045),(47.485,177.195),(47.635,177.195),(47.635,177.045),(47.485,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,177.045),(47.805,177.195),(47.955,177.195),(47.955,177.045),(47.805,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,177.365),(46.845,177.515),(46.995,177.515),(46.995,177.365),(46.845,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,177.365),(47.165,177.515),(47.315,177.515),(47.315,177.365),(47.165,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,177.365),(47.485,177.515),(47.635,177.515),(47.635,177.365),(47.485,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,177.365),(47.805,177.515),(47.955,177.515),(47.955,177.365),(47.805,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,177.685),(46.845,177.835),(46.995,177.835),(46.995,177.685),(46.845,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,177.685),(47.165,177.835),(47.315,177.835),(47.315,177.685),(47.165,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,177.685),(47.485,177.835),(47.635,177.835),(47.635,177.685),(47.485,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,177.685),(47.805,177.835),(47.955,177.835),(47.955,177.685),(47.805,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,178.005),(46.845,178.155),(46.995,178.155),(46.995,178.005),(46.845,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,178.005),(47.165,178.155),(47.315,178.155),(47.315,178.005),(47.165,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,178.005),(47.485,178.155),(47.635,178.155),(47.635,178.005),(47.485,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,178.005),(47.805,178.155),(47.955,178.155),(47.955,178.005),(47.805,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,178.325),(46.845,178.475),(46.995,178.475),(46.995,178.325),(46.845,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,178.325),(47.165,178.475),(47.315,178.475),(47.315,178.325),(47.165,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,178.325),(47.485,178.475),(47.635,178.475),(47.635,178.325),(47.485,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,178.325),(47.805,178.475),(47.955,178.475),(47.955,178.325),(47.805,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,178.645),(46.845,178.795),(46.995,178.795),(46.995,178.645),(46.845,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,178.645),(47.165,178.795),(47.315,178.795),(47.315,178.645),(47.165,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,178.645),(47.485,178.795),(47.635,178.795),(47.635,178.645),(47.485,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,178.645),(47.805,178.795),(47.955,178.795),(47.955,178.645),(47.805,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,178.965),(46.845,179.115),(46.995,179.115),(46.995,178.965),(46.845,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,178.965),(47.165,179.115),(47.315,179.115),(47.315,178.965),(47.165,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,178.965),(47.485,179.115),(47.635,179.115),(47.635,178.965),(47.485,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,178.965),(47.805,179.115),(47.955,179.115),(47.955,178.965),(47.805,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,179.285),(46.845,179.435),(46.995,179.435),(46.995,179.285),(46.845,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,179.285),(47.165,179.435),(47.315,179.435),(47.315,179.285),(47.165,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,179.285),(47.485,179.435),(47.635,179.435),(47.635,179.285),(47.485,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,179.285),(47.805,179.435),(47.955,179.435),(47.955,179.285),(47.805,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,179.605),(46.845,179.755),(46.995,179.755),(46.995,179.605),(46.845,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,179.605),(47.165,179.755),(47.315,179.755),(47.315,179.605),(47.165,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,179.605),(47.485,179.755),(47.635,179.755),(47.635,179.605),(47.485,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,179.605),(47.805,179.755),(47.955,179.755),(47.955,179.605),(47.805,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,179.925),(46.845,180.075),(46.995,180.075),(46.995,179.925),(46.845,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,179.925),(47.165,180.075),(47.315,180.075),(47.315,179.925),(47.165,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,179.925),(47.485,180.075),(47.635,180.075),(47.635,179.925),(47.485,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,179.925),(47.805,180.075),(47.955,180.075),(47.955,179.925),(47.805,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,180.245),(46.845,180.395),(46.995,180.395),(46.995,180.245),(46.845,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,180.245),(47.165,180.395),(47.315,180.395),(47.315,180.245),(47.165,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,180.245),(47.485,180.395),(47.635,180.395),(47.635,180.245),(47.485,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,180.245),(47.805,180.395),(47.955,180.395),(47.955,180.245),(47.805,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,180.565),(46.845,180.715),(46.995,180.715),(46.995,180.565),(46.845,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,180.565),(47.165,180.715),(47.315,180.715),(47.315,180.565),(47.165,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,180.565),(47.485,180.715),(47.635,180.715),(47.635,180.565),(47.485,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,180.565),(47.805,180.715),(47.955,180.715),(47.955,180.565),(47.805,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,180.885),(46.845,181.035),(46.995,181.035),(46.995,180.885),(46.845,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,180.885),(47.165,181.035),(47.315,181.035),(47.315,180.885),(47.165,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,180.885),(47.485,181.035),(47.635,181.035),(47.635,180.885),(47.485,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,180.885),(47.805,181.035),(47.955,181.035),(47.955,180.885),(47.805,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,181.205),(46.845,181.355),(46.995,181.355),(46.995,181.205),(46.845,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,181.205),(47.165,181.355),(47.315,181.355),(47.315,181.205),(47.165,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,181.205),(47.485,181.355),(47.635,181.355),(47.635,181.205),(47.485,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,181.205),(47.805,181.355),(47.955,181.355),(47.955,181.205),(47.805,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,181.525),(46.845,181.675),(46.995,181.675),(46.995,181.525),(46.845,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,181.525),(47.165,181.675),(47.315,181.675),(47.315,181.525),(47.165,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,181.525),(47.485,181.675),(47.635,181.675),(47.635,181.525),(47.485,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,181.525),(47.805,181.675),(47.955,181.675),(47.955,181.525),(47.805,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,181.845),(46.845,181.995),(46.995,181.995),(46.995,181.845),(46.845,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,181.845),(47.165,181.995),(47.315,181.995),(47.315,181.845),(47.165,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,181.845),(47.485,181.995),(47.635,181.995),(47.635,181.845),(47.485,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,181.845),(47.805,181.995),(47.955,181.995),(47.955,181.845),(47.805,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,182.165),(46.845,182.315),(46.995,182.315),(46.995,182.165),(46.845,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,182.165),(47.165,182.315),(47.315,182.315),(47.315,182.165),(47.165,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,182.165),(47.485,182.315),(47.635,182.315),(47.635,182.165),(47.485,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,182.165),(47.805,182.315),(47.955,182.315),(47.955,182.165),(47.805,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,182.485),(46.845,182.635),(46.995,182.635),(46.995,182.485),(46.845,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,182.485),(47.165,182.635),(47.315,182.635),(47.315,182.485),(47.165,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,182.485),(47.485,182.635),(47.635,182.635),(47.635,182.485),(47.485,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,182.485),(47.805,182.635),(47.955,182.635),(47.955,182.485),(47.805,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,182.805),(46.845,182.955),(46.995,182.955),(46.995,182.805),(46.845,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,182.805),(47.165,182.955),(47.315,182.955),(47.315,182.805),(47.165,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,182.805),(47.485,182.955),(47.635,182.955),(47.635,182.805),(47.485,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,182.805),(47.805,182.955),(47.955,182.955),(47.955,182.805),(47.805,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,183.125),(46.845,183.275),(46.995,183.275),(46.995,183.125),(46.845,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,183.125),(47.165,183.275),(47.315,183.275),(47.315,183.125),(47.165,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,183.125),(47.485,183.275),(47.635,183.275),(47.635,183.125),(47.485,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,183.125),(47.805,183.275),(47.955,183.275),(47.955,183.125),(47.805,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,183.445),(46.845,183.595),(46.995,183.595),(46.995,183.445),(46.845,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,183.445),(47.165,183.595),(47.315,183.595),(47.315,183.445),(47.165,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,183.445),(47.485,183.595),(47.635,183.595),(47.635,183.445),(47.485,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,183.445),(47.805,183.595),(47.955,183.595),(47.955,183.445),(47.805,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,183.765),(46.845,183.915),(46.995,183.915),(46.995,183.765),(46.845,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,183.765),(47.165,183.915),(47.315,183.915),(47.315,183.765),(47.165,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,183.765),(47.485,183.915),(47.635,183.915),(47.635,183.765),(47.485,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,183.765),(47.805,183.915),(47.955,183.915),(47.955,183.765),(47.805,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,184.085),(46.845,184.235),(46.995,184.235),(46.995,184.085),(46.845,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,184.085),(47.165,184.235),(47.315,184.235),(47.315,184.085),(47.165,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,184.085),(47.485,184.235),(47.635,184.235),(47.635,184.085),(47.485,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,184.085),(47.805,184.235),(47.955,184.235),(47.955,184.085),(47.805,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,184.405),(46.845,184.555),(46.995,184.555),(46.995,184.405),(46.845,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,184.405),(47.165,184.555),(47.315,184.555),(47.315,184.405),(47.165,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,184.405),(47.485,184.555),(47.635,184.555),(47.635,184.405),(47.485,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,184.405),(47.805,184.555),(47.955,184.555),(47.955,184.405),(47.805,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,184.725),(46.845,184.875),(46.995,184.875),(46.995,184.725),(46.845,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,184.725),(47.165,184.875),(47.315,184.875),(47.315,184.725),(47.165,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,184.725),(47.485,184.875),(47.635,184.875),(47.635,184.725),(47.485,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,184.725),(47.805,184.875),(47.955,184.875),(47.955,184.725),(47.805,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,185.045),(46.845,185.195),(46.995,185.195),(46.995,185.045),(46.845,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,185.045),(47.165,185.195),(47.315,185.195),(47.315,185.045),(47.165,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,185.045),(47.485,185.195),(47.635,185.195),(47.635,185.045),(47.485,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,185.045),(47.805,185.195),(47.955,185.195),(47.955,185.045),(47.805,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,185.365),(46.845,185.515),(46.995,185.515),(46.995,185.365),(46.845,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,185.365),(47.165,185.515),(47.315,185.515),(47.315,185.365),(47.165,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,185.365),(47.485,185.515),(47.635,185.515),(47.635,185.365),(47.485,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,185.365),(47.805,185.515),(47.955,185.515),(47.955,185.365),(47.805,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,185.685),(46.845,185.835),(46.995,185.835),(46.995,185.685),(46.845,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,185.685),(47.165,185.835),(47.315,185.835),(47.315,185.685),(47.165,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,185.685),(47.485,185.835),(47.635,185.835),(47.635,185.685),(47.485,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,185.685),(47.805,185.835),(47.955,185.835),(47.955,185.685),(47.805,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,186.005),(46.845,186.155),(46.995,186.155),(46.995,186.005),(46.845,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,186.005),(47.165,186.155),(47.315,186.155),(47.315,186.005),(47.165,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,186.005),(47.485,186.155),(47.635,186.155),(47.635,186.005),(47.485,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,186.005),(47.805,186.155),(47.955,186.155),(47.955,186.005),(47.805,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,186.325),(46.845,186.475),(46.995,186.475),(46.995,186.325),(46.845,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,186.325),(47.165,186.475),(47.315,186.475),(47.315,186.325),(47.165,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,186.325),(47.485,186.475),(47.635,186.475),(47.635,186.325),(47.485,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,186.325),(47.805,186.475),(47.955,186.475),(47.955,186.325),(47.805,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,186.645),(46.845,186.795),(46.995,186.795),(46.995,186.645),(46.845,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,186.645),(47.165,186.795),(47.315,186.795),(47.315,186.645),(47.165,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,186.645),(47.485,186.795),(47.635,186.795),(47.635,186.645),(47.485,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,186.645),(47.805,186.795),(47.955,186.795),(47.955,186.645),(47.805,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,186.965),(46.845,187.115),(46.995,187.115),(46.995,186.965),(46.845,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,186.965),(47.165,187.115),(47.315,187.115),(47.315,186.965),(47.165,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,186.965),(47.485,187.115),(47.635,187.115),(47.635,186.965),(47.485,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,186.965),(47.805,187.115),(47.955,187.115),(47.955,186.965),(47.805,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,187.285),(46.845,187.435),(46.995,187.435),(46.995,187.285),(46.845,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,187.285),(47.165,187.435),(47.315,187.435),(47.315,187.285),(47.165,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,187.285),(47.485,187.435),(47.635,187.435),(47.635,187.285),(47.485,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,187.285),(47.805,187.435),(47.955,187.435),(47.955,187.285),(47.805,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,187.605),(46.845,187.755),(46.995,187.755),(46.995,187.605),(46.845,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,187.605),(47.165,187.755),(47.315,187.755),(47.315,187.605),(47.165,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,187.605),(47.485,187.755),(47.635,187.755),(47.635,187.605),(47.485,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,187.605),(47.805,187.755),(47.955,187.755),(47.955,187.605),(47.805,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,173.845),(13.245,173.995),(13.395,173.995),(13.395,173.845),(13.245,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,173.845),(13.565,173.995),(13.715,173.995),(13.715,173.845),(13.565,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,173.845),(13.885,173.995),(14.035,173.995),(14.035,173.845),(13.885,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,173.845),(14.205,173.995),(14.355,173.995),(14.355,173.845),(14.205,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,174.165),(13.245,174.315),(13.395,174.315),(13.395,174.165),(13.245,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,174.165),(13.565,174.315),(13.715,174.315),(13.715,174.165),(13.565,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,174.165),(13.885,174.315),(14.035,174.315),(14.035,174.165),(13.885,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,174.165),(14.205,174.315),(14.355,174.315),(14.355,174.165),(14.205,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,174.485),(13.245,174.635),(13.395,174.635),(13.395,174.485),(13.245,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,174.485),(13.565,174.635),(13.715,174.635),(13.715,174.485),(13.565,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,174.485),(13.885,174.635),(14.035,174.635),(14.035,174.485),(13.885,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,174.485),(14.205,174.635),(14.355,174.635),(14.355,174.485),(14.205,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,174.805),(13.245,174.955),(13.395,174.955),(13.395,174.805),(13.245,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,174.805),(13.565,174.955),(13.715,174.955),(13.715,174.805),(13.565,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,174.805),(13.885,174.955),(14.035,174.955),(14.035,174.805),(13.885,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,174.805),(14.205,174.955),(14.355,174.955),(14.355,174.805),(14.205,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,175.125),(13.245,175.275),(13.395,175.275),(13.395,175.125),(13.245,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,175.125),(13.565,175.275),(13.715,175.275),(13.715,175.125),(13.565,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,175.125),(13.885,175.275),(14.035,175.275),(14.035,175.125),(13.885,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,175.125),(14.205,175.275),(14.355,175.275),(14.355,175.125),(14.205,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,175.445),(13.245,175.595),(13.395,175.595),(13.395,175.445),(13.245,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,175.445),(13.565,175.595),(13.715,175.595),(13.715,175.445),(13.565,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,175.445),(13.885,175.595),(14.035,175.595),(14.035,175.445),(13.885,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,175.445),(14.205,175.595),(14.355,175.595),(14.355,175.445),(14.205,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,175.765),(13.245,175.915),(13.395,175.915),(13.395,175.765),(13.245,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,175.765),(13.565,175.915),(13.715,175.915),(13.715,175.765),(13.565,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,175.765),(13.885,175.915),(14.035,175.915),(14.035,175.765),(13.885,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,175.765),(14.205,175.915),(14.355,175.915),(14.355,175.765),(14.205,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,176.085),(13.245,176.235),(13.395,176.235),(13.395,176.085),(13.245,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,176.085),(13.565,176.235),(13.715,176.235),(13.715,176.085),(13.565,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,176.085),(13.885,176.235),(14.035,176.235),(14.035,176.085),(13.885,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,176.085),(14.205,176.235),(14.355,176.235),(14.355,176.085),(14.205,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,176.405),(13.245,176.555),(13.395,176.555),(13.395,176.405),(13.245,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,176.405),(13.565,176.555),(13.715,176.555),(13.715,176.405),(13.565,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,176.405),(13.885,176.555),(14.035,176.555),(14.035,176.405),(13.885,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,176.405),(14.205,176.555),(14.355,176.555),(14.355,176.405),(14.205,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,176.725),(13.245,176.875),(13.395,176.875),(13.395,176.725),(13.245,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,176.725),(13.565,176.875),(13.715,176.875),(13.715,176.725),(13.565,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,176.725),(13.885,176.875),(14.035,176.875),(14.035,176.725),(13.885,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,176.725),(14.205,176.875),(14.355,176.875),(14.355,176.725),(14.205,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,177.045),(13.245,177.195),(13.395,177.195),(13.395,177.045),(13.245,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,177.045),(13.565,177.195),(13.715,177.195),(13.715,177.045),(13.565,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,177.045),(13.885,177.195),(14.035,177.195),(14.035,177.045),(13.885,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,177.045),(14.205,177.195),(14.355,177.195),(14.355,177.045),(14.205,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,177.365),(13.245,177.515),(13.395,177.515),(13.395,177.365),(13.245,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,177.365),(13.565,177.515),(13.715,177.515),(13.715,177.365),(13.565,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,177.365),(13.885,177.515),(14.035,177.515),(14.035,177.365),(13.885,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,177.365),(14.205,177.515),(14.355,177.515),(14.355,177.365),(14.205,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,177.685),(13.245,177.835),(13.395,177.835),(13.395,177.685),(13.245,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,177.685),(13.565,177.835),(13.715,177.835),(13.715,177.685),(13.565,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,177.685),(13.885,177.835),(14.035,177.835),(14.035,177.685),(13.885,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,177.685),(14.205,177.835),(14.355,177.835),(14.355,177.685),(14.205,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,178.005),(13.245,178.155),(13.395,178.155),(13.395,178.005),(13.245,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,178.005),(13.565,178.155),(13.715,178.155),(13.715,178.005),(13.565,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,178.005),(13.885,178.155),(14.035,178.155),(14.035,178.005),(13.885,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,178.005),(14.205,178.155),(14.355,178.155),(14.355,178.005),(14.205,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,178.325),(13.245,178.475),(13.395,178.475),(13.395,178.325),(13.245,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,178.325),(13.565,178.475),(13.715,178.475),(13.715,178.325),(13.565,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,178.325),(13.885,178.475),(14.035,178.475),(14.035,178.325),(13.885,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,178.325),(14.205,178.475),(14.355,178.475),(14.355,178.325),(14.205,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,178.645),(13.245,178.795),(13.395,178.795),(13.395,178.645),(13.245,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,178.645),(13.565,178.795),(13.715,178.795),(13.715,178.645),(13.565,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,178.645),(13.885,178.795),(14.035,178.795),(14.035,178.645),(13.885,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,178.645),(14.205,178.795),(14.355,178.795),(14.355,178.645),(14.205,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,178.965),(13.245,179.115),(13.395,179.115),(13.395,178.965),(13.245,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,178.965),(13.565,179.115),(13.715,179.115),(13.715,178.965),(13.565,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,178.965),(13.885,179.115),(14.035,179.115),(14.035,178.965),(13.885,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,178.965),(14.205,179.115),(14.355,179.115),(14.355,178.965),(14.205,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,179.285),(13.245,179.435),(13.395,179.435),(13.395,179.285),(13.245,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,179.285),(13.565,179.435),(13.715,179.435),(13.715,179.285),(13.565,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,179.285),(13.885,179.435),(14.035,179.435),(14.035,179.285),(13.885,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,179.285),(14.205,179.435),(14.355,179.435),(14.355,179.285),(14.205,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,179.605),(13.245,179.755),(13.395,179.755),(13.395,179.605),(13.245,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,179.605),(13.565,179.755),(13.715,179.755),(13.715,179.605),(13.565,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,179.605),(13.885,179.755),(14.035,179.755),(14.035,179.605),(13.885,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,179.605),(14.205,179.755),(14.355,179.755),(14.355,179.605),(14.205,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,179.925),(13.245,180.075),(13.395,180.075),(13.395,179.925),(13.245,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,179.925),(13.565,180.075),(13.715,180.075),(13.715,179.925),(13.565,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,179.925),(13.885,180.075),(14.035,180.075),(14.035,179.925),(13.885,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,179.925),(14.205,180.075),(14.355,180.075),(14.355,179.925),(14.205,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,180.245),(13.245,180.395),(13.395,180.395),(13.395,180.245),(13.245,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,180.245),(13.565,180.395),(13.715,180.395),(13.715,180.245),(13.565,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,180.245),(13.885,180.395),(14.035,180.395),(14.035,180.245),(13.885,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,180.245),(14.205,180.395),(14.355,180.395),(14.355,180.245),(14.205,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,180.565),(13.245,180.715),(13.395,180.715),(13.395,180.565),(13.245,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,180.565),(13.565,180.715),(13.715,180.715),(13.715,180.565),(13.565,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,180.565),(13.885,180.715),(14.035,180.715),(14.035,180.565),(13.885,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,180.565),(14.205,180.715),(14.355,180.715),(14.355,180.565),(14.205,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,180.885),(13.245,181.035),(13.395,181.035),(13.395,180.885),(13.245,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,180.885),(13.565,181.035),(13.715,181.035),(13.715,180.885),(13.565,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,180.885),(13.885,181.035),(14.035,181.035),(14.035,180.885),(13.885,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,180.885),(14.205,181.035),(14.355,181.035),(14.355,180.885),(14.205,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,181.205),(13.245,181.355),(13.395,181.355),(13.395,181.205),(13.245,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,181.205),(13.565,181.355),(13.715,181.355),(13.715,181.205),(13.565,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,181.205),(13.885,181.355),(14.035,181.355),(14.035,181.205),(13.885,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,181.205),(14.205,181.355),(14.355,181.355),(14.355,181.205),(14.205,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,181.525),(13.245,181.675),(13.395,181.675),(13.395,181.525),(13.245,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,181.525),(13.565,181.675),(13.715,181.675),(13.715,181.525),(13.565,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,181.525),(13.885,181.675),(14.035,181.675),(14.035,181.525),(13.885,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,181.525),(14.205,181.675),(14.355,181.675),(14.355,181.525),(14.205,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,181.845),(13.245,181.995),(13.395,181.995),(13.395,181.845),(13.245,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,181.845),(13.565,181.995),(13.715,181.995),(13.715,181.845),(13.565,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,181.845),(13.885,181.995),(14.035,181.995),(14.035,181.845),(13.885,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,181.845),(14.205,181.995),(14.355,181.995),(14.355,181.845),(14.205,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,182.165),(13.245,182.315),(13.395,182.315),(13.395,182.165),(13.245,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,182.165),(13.565,182.315),(13.715,182.315),(13.715,182.165),(13.565,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,182.165),(13.885,182.315),(14.035,182.315),(14.035,182.165),(13.885,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,182.165),(14.205,182.315),(14.355,182.315),(14.355,182.165),(14.205,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,182.485),(13.245,182.635),(13.395,182.635),(13.395,182.485),(13.245,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,182.485),(13.565,182.635),(13.715,182.635),(13.715,182.485),(13.565,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,182.485),(13.885,182.635),(14.035,182.635),(14.035,182.485),(13.885,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,182.485),(14.205,182.635),(14.355,182.635),(14.355,182.485),(14.205,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,182.805),(13.245,182.955),(13.395,182.955),(13.395,182.805),(13.245,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,182.805),(13.565,182.955),(13.715,182.955),(13.715,182.805),(13.565,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,182.805),(13.885,182.955),(14.035,182.955),(14.035,182.805),(13.885,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,182.805),(14.205,182.955),(14.355,182.955),(14.355,182.805),(14.205,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,183.125),(13.245,183.275),(13.395,183.275),(13.395,183.125),(13.245,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,183.125),(13.565,183.275),(13.715,183.275),(13.715,183.125),(13.565,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,183.125),(13.885,183.275),(14.035,183.275),(14.035,183.125),(13.885,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,183.125),(14.205,183.275),(14.355,183.275),(14.355,183.125),(14.205,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,183.445),(13.245,183.595),(13.395,183.595),(13.395,183.445),(13.245,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,183.445),(13.565,183.595),(13.715,183.595),(13.715,183.445),(13.565,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,183.445),(13.885,183.595),(14.035,183.595),(14.035,183.445),(13.885,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,183.445),(14.205,183.595),(14.355,183.595),(14.355,183.445),(14.205,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,183.765),(13.245,183.915),(13.395,183.915),(13.395,183.765),(13.245,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,183.765),(13.565,183.915),(13.715,183.915),(13.715,183.765),(13.565,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,183.765),(13.885,183.915),(14.035,183.915),(14.035,183.765),(13.885,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,183.765),(14.205,183.915),(14.355,183.915),(14.355,183.765),(14.205,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,184.085),(13.245,184.235),(13.395,184.235),(13.395,184.085),(13.245,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,184.085),(13.565,184.235),(13.715,184.235),(13.715,184.085),(13.565,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,184.085),(13.885,184.235),(14.035,184.235),(14.035,184.085),(13.885,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,184.085),(14.205,184.235),(14.355,184.235),(14.355,184.085),(14.205,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,184.405),(13.245,184.555),(13.395,184.555),(13.395,184.405),(13.245,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,184.405),(13.565,184.555),(13.715,184.555),(13.715,184.405),(13.565,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,184.405),(13.885,184.555),(14.035,184.555),(14.035,184.405),(13.885,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,184.405),(14.205,184.555),(14.355,184.555),(14.355,184.405),(14.205,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,184.725),(13.245,184.875),(13.395,184.875),(13.395,184.725),(13.245,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,184.725),(13.565,184.875),(13.715,184.875),(13.715,184.725),(13.565,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,184.725),(13.885,184.875),(14.035,184.875),(14.035,184.725),(13.885,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,184.725),(14.205,184.875),(14.355,184.875),(14.355,184.725),(14.205,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,185.045),(13.245,185.195),(13.395,185.195),(13.395,185.045),(13.245,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,185.045),(13.565,185.195),(13.715,185.195),(13.715,185.045),(13.565,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,185.045),(13.885,185.195),(14.035,185.195),(14.035,185.045),(13.885,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,185.045),(14.205,185.195),(14.355,185.195),(14.355,185.045),(14.205,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,185.365),(13.245,185.515),(13.395,185.515),(13.395,185.365),(13.245,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,185.365),(13.565,185.515),(13.715,185.515),(13.715,185.365),(13.565,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,185.365),(13.885,185.515),(14.035,185.515),(14.035,185.365),(13.885,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,185.365),(14.205,185.515),(14.355,185.515),(14.355,185.365),(14.205,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,185.685),(13.245,185.835),(13.395,185.835),(13.395,185.685),(13.245,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,185.685),(13.565,185.835),(13.715,185.835),(13.715,185.685),(13.565,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,185.685),(13.885,185.835),(14.035,185.835),(14.035,185.685),(13.885,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,185.685),(14.205,185.835),(14.355,185.835),(14.355,185.685),(14.205,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,186.005),(13.245,186.155),(13.395,186.155),(13.395,186.005),(13.245,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,186.005),(13.565,186.155),(13.715,186.155),(13.715,186.005),(13.565,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,186.005),(13.885,186.155),(14.035,186.155),(14.035,186.005),(13.885,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,186.005),(14.205,186.155),(14.355,186.155),(14.355,186.005),(14.205,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,186.325),(13.245,186.475),(13.395,186.475),(13.395,186.325),(13.245,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,186.325),(13.565,186.475),(13.715,186.475),(13.715,186.325),(13.565,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,186.325),(13.885,186.475),(14.035,186.475),(14.035,186.325),(13.885,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,186.325),(14.205,186.475),(14.355,186.475),(14.355,186.325),(14.205,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,186.645),(13.245,186.795),(13.395,186.795),(13.395,186.645),(13.245,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,186.645),(13.565,186.795),(13.715,186.795),(13.715,186.645),(13.565,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,186.645),(13.885,186.795),(14.035,186.795),(14.035,186.645),(13.885,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,186.645),(14.205,186.795),(14.355,186.795),(14.355,186.645),(14.205,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,186.965),(13.245,187.115),(13.395,187.115),(13.395,186.965),(13.245,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,186.965),(13.565,187.115),(13.715,187.115),(13.715,186.965),(13.565,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,186.965),(13.885,187.115),(14.035,187.115),(14.035,186.965),(13.885,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,186.965),(14.205,187.115),(14.355,187.115),(14.355,186.965),(14.205,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,187.285),(13.245,187.435),(13.395,187.435),(13.395,187.285),(13.245,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,187.285),(13.565,187.435),(13.715,187.435),(13.715,187.285),(13.565,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,187.285),(13.885,187.435),(14.035,187.435),(14.035,187.285),(13.885,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,187.285),(14.205,187.435),(14.355,187.435),(14.355,187.285),(14.205,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,187.605),(13.245,187.755),(13.395,187.755),(13.395,187.605),(13.245,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,187.605),(13.565,187.755),(13.715,187.755),(13.715,187.605),(13.565,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,187.605),(13.885,187.755),(14.035,187.755),(14.035,187.605),(13.885,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,187.605),(14.205,187.755),(14.355,187.755),(14.355,187.605),(14.205,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,173.845),(51.645,173.995),(51.795,173.995),(51.795,173.845),(51.645,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,173.845),(51.965,173.995),(52.115,173.995),(52.115,173.845),(51.965,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,173.845),(52.285,173.995),(52.435,173.995),(52.435,173.845),(52.285,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,173.845),(52.605,173.995),(52.755,173.995),(52.755,173.845),(52.605,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,174.165),(51.645,174.315),(51.795,174.315),(51.795,174.165),(51.645,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,174.165),(51.965,174.315),(52.115,174.315),(52.115,174.165),(51.965,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,174.165),(52.285,174.315),(52.435,174.315),(52.435,174.165),(52.285,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,174.165),(52.605,174.315),(52.755,174.315),(52.755,174.165),(52.605,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,174.485),(51.645,174.635),(51.795,174.635),(51.795,174.485),(51.645,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,174.485),(51.965,174.635),(52.115,174.635),(52.115,174.485),(51.965,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,174.485),(52.285,174.635),(52.435,174.635),(52.435,174.485),(52.285,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,174.485),(52.605,174.635),(52.755,174.635),(52.755,174.485),(52.605,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,174.805),(51.645,174.955),(51.795,174.955),(51.795,174.805),(51.645,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,174.805),(51.965,174.955),(52.115,174.955),(52.115,174.805),(51.965,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,174.805),(52.285,174.955),(52.435,174.955),(52.435,174.805),(52.285,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,174.805),(52.605,174.955),(52.755,174.955),(52.755,174.805),(52.605,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,175.125),(51.645,175.275),(51.795,175.275),(51.795,175.125),(51.645,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,175.125),(51.965,175.275),(52.115,175.275),(52.115,175.125),(51.965,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,175.125),(52.285,175.275),(52.435,175.275),(52.435,175.125),(52.285,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,175.125),(52.605,175.275),(52.755,175.275),(52.755,175.125),(52.605,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,175.445),(51.645,175.595),(51.795,175.595),(51.795,175.445),(51.645,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,175.445),(51.965,175.595),(52.115,175.595),(52.115,175.445),(51.965,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,175.445),(52.285,175.595),(52.435,175.595),(52.435,175.445),(52.285,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,175.445),(52.605,175.595),(52.755,175.595),(52.755,175.445),(52.605,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,175.765),(51.645,175.915),(51.795,175.915),(51.795,175.765),(51.645,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,175.765),(51.965,175.915),(52.115,175.915),(52.115,175.765),(51.965,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,175.765),(52.285,175.915),(52.435,175.915),(52.435,175.765),(52.285,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,175.765),(52.605,175.915),(52.755,175.915),(52.755,175.765),(52.605,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,176.085),(51.645,176.235),(51.795,176.235),(51.795,176.085),(51.645,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,176.085),(51.965,176.235),(52.115,176.235),(52.115,176.085),(51.965,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,176.085),(52.285,176.235),(52.435,176.235),(52.435,176.085),(52.285,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,176.085),(52.605,176.235),(52.755,176.235),(52.755,176.085),(52.605,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,176.405),(51.645,176.555),(51.795,176.555),(51.795,176.405),(51.645,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,176.405),(51.965,176.555),(52.115,176.555),(52.115,176.405),(51.965,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,176.405),(52.285,176.555),(52.435,176.555),(52.435,176.405),(52.285,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,176.405),(52.605,176.555),(52.755,176.555),(52.755,176.405),(52.605,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,176.725),(51.645,176.875),(51.795,176.875),(51.795,176.725),(51.645,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,176.725),(51.965,176.875),(52.115,176.875),(52.115,176.725),(51.965,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,176.725),(52.285,176.875),(52.435,176.875),(52.435,176.725),(52.285,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,176.725),(52.605,176.875),(52.755,176.875),(52.755,176.725),(52.605,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,177.045),(51.645,177.195),(51.795,177.195),(51.795,177.045),(51.645,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,177.045),(51.965,177.195),(52.115,177.195),(52.115,177.045),(51.965,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,177.045),(52.285,177.195),(52.435,177.195),(52.435,177.045),(52.285,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,177.045),(52.605,177.195),(52.755,177.195),(52.755,177.045),(52.605,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,177.365),(51.645,177.515),(51.795,177.515),(51.795,177.365),(51.645,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,177.365),(51.965,177.515),(52.115,177.515),(52.115,177.365),(51.965,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,177.365),(52.285,177.515),(52.435,177.515),(52.435,177.365),(52.285,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,177.365),(52.605,177.515),(52.755,177.515),(52.755,177.365),(52.605,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,177.685),(51.645,177.835),(51.795,177.835),(51.795,177.685),(51.645,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,177.685),(51.965,177.835),(52.115,177.835),(52.115,177.685),(51.965,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,177.685),(52.285,177.835),(52.435,177.835),(52.435,177.685),(52.285,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,177.685),(52.605,177.835),(52.755,177.835),(52.755,177.685),(52.605,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,178.005),(51.645,178.155),(51.795,178.155),(51.795,178.005),(51.645,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,178.005),(51.965,178.155),(52.115,178.155),(52.115,178.005),(51.965,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,178.005),(52.285,178.155),(52.435,178.155),(52.435,178.005),(52.285,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,178.005),(52.605,178.155),(52.755,178.155),(52.755,178.005),(52.605,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,178.325),(51.645,178.475),(51.795,178.475),(51.795,178.325),(51.645,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,178.325),(51.965,178.475),(52.115,178.475),(52.115,178.325),(51.965,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,178.325),(52.285,178.475),(52.435,178.475),(52.435,178.325),(52.285,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,178.325),(52.605,178.475),(52.755,178.475),(52.755,178.325),(52.605,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,178.645),(51.645,178.795),(51.795,178.795),(51.795,178.645),(51.645,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,178.645),(51.965,178.795),(52.115,178.795),(52.115,178.645),(51.965,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,178.645),(52.285,178.795),(52.435,178.795),(52.435,178.645),(52.285,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,178.645),(52.605,178.795),(52.755,178.795),(52.755,178.645),(52.605,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,178.965),(51.645,179.115),(51.795,179.115),(51.795,178.965),(51.645,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,178.965),(51.965,179.115),(52.115,179.115),(52.115,178.965),(51.965,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,178.965),(52.285,179.115),(52.435,179.115),(52.435,178.965),(52.285,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,178.965),(52.605,179.115),(52.755,179.115),(52.755,178.965),(52.605,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,179.285),(51.645,179.435),(51.795,179.435),(51.795,179.285),(51.645,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,179.285),(51.965,179.435),(52.115,179.435),(52.115,179.285),(51.965,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,179.285),(52.285,179.435),(52.435,179.435),(52.435,179.285),(52.285,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,179.285),(52.605,179.435),(52.755,179.435),(52.755,179.285),(52.605,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,179.605),(51.645,179.755),(51.795,179.755),(51.795,179.605),(51.645,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,179.605),(51.965,179.755),(52.115,179.755),(52.115,179.605),(51.965,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,179.605),(52.285,179.755),(52.435,179.755),(52.435,179.605),(52.285,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,179.605),(52.605,179.755),(52.755,179.755),(52.755,179.605),(52.605,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,179.925),(51.645,180.075),(51.795,180.075),(51.795,179.925),(51.645,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,179.925),(51.965,180.075),(52.115,180.075),(52.115,179.925),(51.965,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,179.925),(52.285,180.075),(52.435,180.075),(52.435,179.925),(52.285,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,179.925),(52.605,180.075),(52.755,180.075),(52.755,179.925),(52.605,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,180.245),(51.645,180.395),(51.795,180.395),(51.795,180.245),(51.645,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,180.245),(51.965,180.395),(52.115,180.395),(52.115,180.245),(51.965,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,180.245),(52.285,180.395),(52.435,180.395),(52.435,180.245),(52.285,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,180.245),(52.605,180.395),(52.755,180.395),(52.755,180.245),(52.605,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,180.565),(51.645,180.715),(51.795,180.715),(51.795,180.565),(51.645,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,180.565),(51.965,180.715),(52.115,180.715),(52.115,180.565),(51.965,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,180.565),(52.285,180.715),(52.435,180.715),(52.435,180.565),(52.285,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,180.565),(52.605,180.715),(52.755,180.715),(52.755,180.565),(52.605,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,180.885),(51.645,181.035),(51.795,181.035),(51.795,180.885),(51.645,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,180.885),(51.965,181.035),(52.115,181.035),(52.115,180.885),(51.965,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,180.885),(52.285,181.035),(52.435,181.035),(52.435,180.885),(52.285,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,180.885),(52.605,181.035),(52.755,181.035),(52.755,180.885),(52.605,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,181.205),(51.645,181.355),(51.795,181.355),(51.795,181.205),(51.645,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,181.205),(51.965,181.355),(52.115,181.355),(52.115,181.205),(51.965,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,181.205),(52.285,181.355),(52.435,181.355),(52.435,181.205),(52.285,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,181.205),(52.605,181.355),(52.755,181.355),(52.755,181.205),(52.605,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,181.525),(51.645,181.675),(51.795,181.675),(51.795,181.525),(51.645,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,181.525),(51.965,181.675),(52.115,181.675),(52.115,181.525),(51.965,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,181.525),(52.285,181.675),(52.435,181.675),(52.435,181.525),(52.285,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,181.525),(52.605,181.675),(52.755,181.675),(52.755,181.525),(52.605,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,181.845),(51.645,181.995),(51.795,181.995),(51.795,181.845),(51.645,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,181.845),(51.965,181.995),(52.115,181.995),(52.115,181.845),(51.965,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,181.845),(52.285,181.995),(52.435,181.995),(52.435,181.845),(52.285,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,181.845),(52.605,181.995),(52.755,181.995),(52.755,181.845),(52.605,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,182.165),(51.645,182.315),(51.795,182.315),(51.795,182.165),(51.645,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,182.165),(51.965,182.315),(52.115,182.315),(52.115,182.165),(51.965,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,182.165),(52.285,182.315),(52.435,182.315),(52.435,182.165),(52.285,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,182.165),(52.605,182.315),(52.755,182.315),(52.755,182.165),(52.605,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,182.485),(51.645,182.635),(51.795,182.635),(51.795,182.485),(51.645,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,182.485),(51.965,182.635),(52.115,182.635),(52.115,182.485),(51.965,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,182.485),(52.285,182.635),(52.435,182.635),(52.435,182.485),(52.285,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,182.485),(52.605,182.635),(52.755,182.635),(52.755,182.485),(52.605,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,182.805),(51.645,182.955),(51.795,182.955),(51.795,182.805),(51.645,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,182.805),(51.965,182.955),(52.115,182.955),(52.115,182.805),(51.965,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,182.805),(52.285,182.955),(52.435,182.955),(52.435,182.805),(52.285,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,182.805),(52.605,182.955),(52.755,182.955),(52.755,182.805),(52.605,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,183.125),(51.645,183.275),(51.795,183.275),(51.795,183.125),(51.645,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,183.125),(51.965,183.275),(52.115,183.275),(52.115,183.125),(51.965,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,183.125),(52.285,183.275),(52.435,183.275),(52.435,183.125),(52.285,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,183.125),(52.605,183.275),(52.755,183.275),(52.755,183.125),(52.605,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,183.445),(51.645,183.595),(51.795,183.595),(51.795,183.445),(51.645,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,183.445),(51.965,183.595),(52.115,183.595),(52.115,183.445),(51.965,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,183.445),(52.285,183.595),(52.435,183.595),(52.435,183.445),(52.285,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,183.445),(52.605,183.595),(52.755,183.595),(52.755,183.445),(52.605,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,183.765),(51.645,183.915),(51.795,183.915),(51.795,183.765),(51.645,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,183.765),(51.965,183.915),(52.115,183.915),(52.115,183.765),(51.965,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,183.765),(52.285,183.915),(52.435,183.915),(52.435,183.765),(52.285,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,183.765),(52.605,183.915),(52.755,183.915),(52.755,183.765),(52.605,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,184.085),(51.645,184.235),(51.795,184.235),(51.795,184.085),(51.645,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,184.085),(51.965,184.235),(52.115,184.235),(52.115,184.085),(51.965,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,184.085),(52.285,184.235),(52.435,184.235),(52.435,184.085),(52.285,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,184.085),(52.605,184.235),(52.755,184.235),(52.755,184.085),(52.605,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,184.405),(51.645,184.555),(51.795,184.555),(51.795,184.405),(51.645,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,184.405),(51.965,184.555),(52.115,184.555),(52.115,184.405),(51.965,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,184.405),(52.285,184.555),(52.435,184.555),(52.435,184.405),(52.285,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,184.405),(52.605,184.555),(52.755,184.555),(52.755,184.405),(52.605,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,184.725),(51.645,184.875),(51.795,184.875),(51.795,184.725),(51.645,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,184.725),(51.965,184.875),(52.115,184.875),(52.115,184.725),(51.965,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,184.725),(52.285,184.875),(52.435,184.875),(52.435,184.725),(52.285,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,184.725),(52.605,184.875),(52.755,184.875),(52.755,184.725),(52.605,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,185.045),(51.645,185.195),(51.795,185.195),(51.795,185.045),(51.645,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,185.045),(51.965,185.195),(52.115,185.195),(52.115,185.045),(51.965,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,185.045),(52.285,185.195),(52.435,185.195),(52.435,185.045),(52.285,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,185.045),(52.605,185.195),(52.755,185.195),(52.755,185.045),(52.605,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,185.365),(51.645,185.515),(51.795,185.515),(51.795,185.365),(51.645,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,185.365),(51.965,185.515),(52.115,185.515),(52.115,185.365),(51.965,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,185.365),(52.285,185.515),(52.435,185.515),(52.435,185.365),(52.285,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,185.365),(52.605,185.515),(52.755,185.515),(52.755,185.365),(52.605,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,185.685),(51.645,185.835),(51.795,185.835),(51.795,185.685),(51.645,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,185.685),(51.965,185.835),(52.115,185.835),(52.115,185.685),(51.965,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,185.685),(52.285,185.835),(52.435,185.835),(52.435,185.685),(52.285,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,185.685),(52.605,185.835),(52.755,185.835),(52.755,185.685),(52.605,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,186.005),(51.645,186.155),(51.795,186.155),(51.795,186.005),(51.645,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,186.005),(51.965,186.155),(52.115,186.155),(52.115,186.005),(51.965,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,186.005),(52.285,186.155),(52.435,186.155),(52.435,186.005),(52.285,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,186.005),(52.605,186.155),(52.755,186.155),(52.755,186.005),(52.605,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,186.325),(51.645,186.475),(51.795,186.475),(51.795,186.325),(51.645,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,186.325),(51.965,186.475),(52.115,186.475),(52.115,186.325),(51.965,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,186.325),(52.285,186.475),(52.435,186.475),(52.435,186.325),(52.285,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,186.325),(52.605,186.475),(52.755,186.475),(52.755,186.325),(52.605,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,186.645),(51.645,186.795),(51.795,186.795),(51.795,186.645),(51.645,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,186.645),(51.965,186.795),(52.115,186.795),(52.115,186.645),(51.965,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,186.645),(52.285,186.795),(52.435,186.795),(52.435,186.645),(52.285,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,186.645),(52.605,186.795),(52.755,186.795),(52.755,186.645),(52.605,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,186.965),(51.645,187.115),(51.795,187.115),(51.795,186.965),(51.645,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,186.965),(51.965,187.115),(52.115,187.115),(52.115,186.965),(51.965,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,186.965),(52.285,187.115),(52.435,187.115),(52.435,186.965),(52.285,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,186.965),(52.605,187.115),(52.755,187.115),(52.755,186.965),(52.605,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,187.285),(51.645,187.435),(51.795,187.435),(51.795,187.285),(51.645,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,187.285),(51.965,187.435),(52.115,187.435),(52.115,187.285),(51.965,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,187.285),(52.285,187.435),(52.435,187.435),(52.435,187.285),(52.285,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,187.285),(52.605,187.435),(52.755,187.435),(52.755,187.285),(52.605,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,187.605),(51.645,187.755),(51.795,187.755),(51.795,187.605),(51.645,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,187.605),(51.965,187.755),(52.115,187.755),(52.115,187.605),(51.965,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,187.605),(52.285,187.755),(52.435,187.755),(52.435,187.605),(52.285,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,187.605),(52.605,187.755),(52.755,187.755),(52.755,187.605),(52.605,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,173.845),(56.445,173.995),(56.595,173.995),(56.595,173.845),(56.445,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,173.845),(56.765,173.995),(56.915,173.995),(56.915,173.845),(56.765,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,173.845),(57.085,173.995),(57.235,173.995),(57.235,173.845),(57.085,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,173.845),(57.405,173.995),(57.555,173.995),(57.555,173.845),(57.405,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,174.165),(56.445,174.315),(56.595,174.315),(56.595,174.165),(56.445,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,174.165),(56.765,174.315),(56.915,174.315),(56.915,174.165),(56.765,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,174.165),(57.085,174.315),(57.235,174.315),(57.235,174.165),(57.085,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,174.165),(57.405,174.315),(57.555,174.315),(57.555,174.165),(57.405,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,174.485),(56.445,174.635),(56.595,174.635),(56.595,174.485),(56.445,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,174.485),(56.765,174.635),(56.915,174.635),(56.915,174.485),(56.765,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,174.485),(57.085,174.635),(57.235,174.635),(57.235,174.485),(57.085,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,174.485),(57.405,174.635),(57.555,174.635),(57.555,174.485),(57.405,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,174.805),(56.445,174.955),(56.595,174.955),(56.595,174.805),(56.445,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,174.805),(56.765,174.955),(56.915,174.955),(56.915,174.805),(56.765,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,174.805),(57.085,174.955),(57.235,174.955),(57.235,174.805),(57.085,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,174.805),(57.405,174.955),(57.555,174.955),(57.555,174.805),(57.405,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,175.125),(56.445,175.275),(56.595,175.275),(56.595,175.125),(56.445,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,175.125),(56.765,175.275),(56.915,175.275),(56.915,175.125),(56.765,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,175.125),(57.085,175.275),(57.235,175.275),(57.235,175.125),(57.085,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,175.125),(57.405,175.275),(57.555,175.275),(57.555,175.125),(57.405,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,175.445),(56.445,175.595),(56.595,175.595),(56.595,175.445),(56.445,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,175.445),(56.765,175.595),(56.915,175.595),(56.915,175.445),(56.765,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,175.445),(57.085,175.595),(57.235,175.595),(57.235,175.445),(57.085,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,175.445),(57.405,175.595),(57.555,175.595),(57.555,175.445),(57.405,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,175.765),(56.445,175.915),(56.595,175.915),(56.595,175.765),(56.445,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,175.765),(56.765,175.915),(56.915,175.915),(56.915,175.765),(56.765,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,175.765),(57.085,175.915),(57.235,175.915),(57.235,175.765),(57.085,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,175.765),(57.405,175.915),(57.555,175.915),(57.555,175.765),(57.405,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,176.085),(56.445,176.235),(56.595,176.235),(56.595,176.085),(56.445,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,176.085),(56.765,176.235),(56.915,176.235),(56.915,176.085),(56.765,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,176.085),(57.085,176.235),(57.235,176.235),(57.235,176.085),(57.085,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,176.085),(57.405,176.235),(57.555,176.235),(57.555,176.085),(57.405,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,176.405),(56.445,176.555),(56.595,176.555),(56.595,176.405),(56.445,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,176.405),(56.765,176.555),(56.915,176.555),(56.915,176.405),(56.765,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,176.405),(57.085,176.555),(57.235,176.555),(57.235,176.405),(57.085,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,176.405),(57.405,176.555),(57.555,176.555),(57.555,176.405),(57.405,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,176.725),(56.445,176.875),(56.595,176.875),(56.595,176.725),(56.445,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,176.725),(56.765,176.875),(56.915,176.875),(56.915,176.725),(56.765,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,176.725),(57.085,176.875),(57.235,176.875),(57.235,176.725),(57.085,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,176.725),(57.405,176.875),(57.555,176.875),(57.555,176.725),(57.405,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,177.045),(56.445,177.195),(56.595,177.195),(56.595,177.045),(56.445,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,177.045),(56.765,177.195),(56.915,177.195),(56.915,177.045),(56.765,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,177.045),(57.085,177.195),(57.235,177.195),(57.235,177.045),(57.085,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,177.045),(57.405,177.195),(57.555,177.195),(57.555,177.045),(57.405,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,177.365),(56.445,177.515),(56.595,177.515),(56.595,177.365),(56.445,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,177.365),(56.765,177.515),(56.915,177.515),(56.915,177.365),(56.765,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,177.365),(57.085,177.515),(57.235,177.515),(57.235,177.365),(57.085,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,177.365),(57.405,177.515),(57.555,177.515),(57.555,177.365),(57.405,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,177.685),(56.445,177.835),(56.595,177.835),(56.595,177.685),(56.445,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,177.685),(56.765,177.835),(56.915,177.835),(56.915,177.685),(56.765,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,177.685),(57.085,177.835),(57.235,177.835),(57.235,177.685),(57.085,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,177.685),(57.405,177.835),(57.555,177.835),(57.555,177.685),(57.405,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,178.005),(56.445,178.155),(56.595,178.155),(56.595,178.005),(56.445,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,178.005),(56.765,178.155),(56.915,178.155),(56.915,178.005),(56.765,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,178.005),(57.085,178.155),(57.235,178.155),(57.235,178.005),(57.085,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,178.005),(57.405,178.155),(57.555,178.155),(57.555,178.005),(57.405,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,178.325),(56.445,178.475),(56.595,178.475),(56.595,178.325),(56.445,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,178.325),(56.765,178.475),(56.915,178.475),(56.915,178.325),(56.765,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,178.325),(57.085,178.475),(57.235,178.475),(57.235,178.325),(57.085,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,178.325),(57.405,178.475),(57.555,178.475),(57.555,178.325),(57.405,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,178.645),(56.445,178.795),(56.595,178.795),(56.595,178.645),(56.445,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,178.645),(56.765,178.795),(56.915,178.795),(56.915,178.645),(56.765,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,178.645),(57.085,178.795),(57.235,178.795),(57.235,178.645),(57.085,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,178.645),(57.405,178.795),(57.555,178.795),(57.555,178.645),(57.405,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,178.965),(56.445,179.115),(56.595,179.115),(56.595,178.965),(56.445,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,178.965),(56.765,179.115),(56.915,179.115),(56.915,178.965),(56.765,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,178.965),(57.085,179.115),(57.235,179.115),(57.235,178.965),(57.085,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,178.965),(57.405,179.115),(57.555,179.115),(57.555,178.965),(57.405,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,179.285),(56.445,179.435),(56.595,179.435),(56.595,179.285),(56.445,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,179.285),(56.765,179.435),(56.915,179.435),(56.915,179.285),(56.765,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,179.285),(57.085,179.435),(57.235,179.435),(57.235,179.285),(57.085,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,179.285),(57.405,179.435),(57.555,179.435),(57.555,179.285),(57.405,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,179.605),(56.445,179.755),(56.595,179.755),(56.595,179.605),(56.445,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,179.605),(56.765,179.755),(56.915,179.755),(56.915,179.605),(56.765,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,179.605),(57.085,179.755),(57.235,179.755),(57.235,179.605),(57.085,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,179.605),(57.405,179.755),(57.555,179.755),(57.555,179.605),(57.405,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,179.925),(56.445,180.075),(56.595,180.075),(56.595,179.925),(56.445,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,179.925),(56.765,180.075),(56.915,180.075),(56.915,179.925),(56.765,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,179.925),(57.085,180.075),(57.235,180.075),(57.235,179.925),(57.085,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,179.925),(57.405,180.075),(57.555,180.075),(57.555,179.925),(57.405,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,180.245),(56.445,180.395),(56.595,180.395),(56.595,180.245),(56.445,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,180.245),(56.765,180.395),(56.915,180.395),(56.915,180.245),(56.765,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,180.245),(57.085,180.395),(57.235,180.395),(57.235,180.245),(57.085,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,180.245),(57.405,180.395),(57.555,180.395),(57.555,180.245),(57.405,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,180.565),(56.445,180.715),(56.595,180.715),(56.595,180.565),(56.445,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,180.565),(56.765,180.715),(56.915,180.715),(56.915,180.565),(56.765,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,180.565),(57.085,180.715),(57.235,180.715),(57.235,180.565),(57.085,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,180.565),(57.405,180.715),(57.555,180.715),(57.555,180.565),(57.405,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,180.885),(56.445,181.035),(56.595,181.035),(56.595,180.885),(56.445,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,180.885),(56.765,181.035),(56.915,181.035),(56.915,180.885),(56.765,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,180.885),(57.085,181.035),(57.235,181.035),(57.235,180.885),(57.085,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,180.885),(57.405,181.035),(57.555,181.035),(57.555,180.885),(57.405,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,181.205),(56.445,181.355),(56.595,181.355),(56.595,181.205),(56.445,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,181.205),(56.765,181.355),(56.915,181.355),(56.915,181.205),(56.765,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,181.205),(57.085,181.355),(57.235,181.355),(57.235,181.205),(57.085,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,181.205),(57.405,181.355),(57.555,181.355),(57.555,181.205),(57.405,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,181.525),(56.445,181.675),(56.595,181.675),(56.595,181.525),(56.445,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,181.525),(56.765,181.675),(56.915,181.675),(56.915,181.525),(56.765,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,181.525),(57.085,181.675),(57.235,181.675),(57.235,181.525),(57.085,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,181.525),(57.405,181.675),(57.555,181.675),(57.555,181.525),(57.405,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,181.845),(56.445,181.995),(56.595,181.995),(56.595,181.845),(56.445,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,181.845),(56.765,181.995),(56.915,181.995),(56.915,181.845),(56.765,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,181.845),(57.085,181.995),(57.235,181.995),(57.235,181.845),(57.085,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,181.845),(57.405,181.995),(57.555,181.995),(57.555,181.845),(57.405,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,182.165),(56.445,182.315),(56.595,182.315),(56.595,182.165),(56.445,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,182.165),(56.765,182.315),(56.915,182.315),(56.915,182.165),(56.765,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,182.165),(57.085,182.315),(57.235,182.315),(57.235,182.165),(57.085,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,182.165),(57.405,182.315),(57.555,182.315),(57.555,182.165),(57.405,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,182.485),(56.445,182.635),(56.595,182.635),(56.595,182.485),(56.445,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,182.485),(56.765,182.635),(56.915,182.635),(56.915,182.485),(56.765,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,182.485),(57.085,182.635),(57.235,182.635),(57.235,182.485),(57.085,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,182.485),(57.405,182.635),(57.555,182.635),(57.555,182.485),(57.405,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,182.805),(56.445,182.955),(56.595,182.955),(56.595,182.805),(56.445,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,182.805),(56.765,182.955),(56.915,182.955),(56.915,182.805),(56.765,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,182.805),(57.085,182.955),(57.235,182.955),(57.235,182.805),(57.085,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,182.805),(57.405,182.955),(57.555,182.955),(57.555,182.805),(57.405,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,183.125),(56.445,183.275),(56.595,183.275),(56.595,183.125),(56.445,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,183.125),(56.765,183.275),(56.915,183.275),(56.915,183.125),(56.765,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,183.125),(57.085,183.275),(57.235,183.275),(57.235,183.125),(57.085,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,183.125),(57.405,183.275),(57.555,183.275),(57.555,183.125),(57.405,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,183.445),(56.445,183.595),(56.595,183.595),(56.595,183.445),(56.445,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,183.445),(56.765,183.595),(56.915,183.595),(56.915,183.445),(56.765,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,183.445),(57.085,183.595),(57.235,183.595),(57.235,183.445),(57.085,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,183.445),(57.405,183.595),(57.555,183.595),(57.555,183.445),(57.405,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,183.765),(56.445,183.915),(56.595,183.915),(56.595,183.765),(56.445,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,183.765),(56.765,183.915),(56.915,183.915),(56.915,183.765),(56.765,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,183.765),(57.085,183.915),(57.235,183.915),(57.235,183.765),(57.085,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,183.765),(57.405,183.915),(57.555,183.915),(57.555,183.765),(57.405,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,184.085),(56.445,184.235),(56.595,184.235),(56.595,184.085),(56.445,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,184.085),(56.765,184.235),(56.915,184.235),(56.915,184.085),(56.765,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,184.085),(57.085,184.235),(57.235,184.235),(57.235,184.085),(57.085,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,184.085),(57.405,184.235),(57.555,184.235),(57.555,184.085),(57.405,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,184.405),(56.445,184.555),(56.595,184.555),(56.595,184.405),(56.445,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,184.405),(56.765,184.555),(56.915,184.555),(56.915,184.405),(56.765,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,184.405),(57.085,184.555),(57.235,184.555),(57.235,184.405),(57.085,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,184.405),(57.405,184.555),(57.555,184.555),(57.555,184.405),(57.405,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,184.725),(56.445,184.875),(56.595,184.875),(56.595,184.725),(56.445,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,184.725),(56.765,184.875),(56.915,184.875),(56.915,184.725),(56.765,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,184.725),(57.085,184.875),(57.235,184.875),(57.235,184.725),(57.085,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,184.725),(57.405,184.875),(57.555,184.875),(57.555,184.725),(57.405,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,185.045),(56.445,185.195),(56.595,185.195),(56.595,185.045),(56.445,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,185.045),(56.765,185.195),(56.915,185.195),(56.915,185.045),(56.765,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,185.045),(57.085,185.195),(57.235,185.195),(57.235,185.045),(57.085,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,185.045),(57.405,185.195),(57.555,185.195),(57.555,185.045),(57.405,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,185.365),(56.445,185.515),(56.595,185.515),(56.595,185.365),(56.445,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,185.365),(56.765,185.515),(56.915,185.515),(56.915,185.365),(56.765,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,185.365),(57.085,185.515),(57.235,185.515),(57.235,185.365),(57.085,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,185.365),(57.405,185.515),(57.555,185.515),(57.555,185.365),(57.405,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,185.685),(56.445,185.835),(56.595,185.835),(56.595,185.685),(56.445,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,185.685),(56.765,185.835),(56.915,185.835),(56.915,185.685),(56.765,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,185.685),(57.085,185.835),(57.235,185.835),(57.235,185.685),(57.085,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,185.685),(57.405,185.835),(57.555,185.835),(57.555,185.685),(57.405,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,186.005),(56.445,186.155),(56.595,186.155),(56.595,186.005),(56.445,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,186.005),(56.765,186.155),(56.915,186.155),(56.915,186.005),(56.765,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,186.005),(57.085,186.155),(57.235,186.155),(57.235,186.005),(57.085,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,186.005),(57.405,186.155),(57.555,186.155),(57.555,186.005),(57.405,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,186.325),(56.445,186.475),(56.595,186.475),(56.595,186.325),(56.445,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,186.325),(56.765,186.475),(56.915,186.475),(56.915,186.325),(56.765,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,186.325),(57.085,186.475),(57.235,186.475),(57.235,186.325),(57.085,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,186.325),(57.405,186.475),(57.555,186.475),(57.555,186.325),(57.405,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,186.645),(56.445,186.795),(56.595,186.795),(56.595,186.645),(56.445,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,186.645),(56.765,186.795),(56.915,186.795),(56.915,186.645),(56.765,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,186.645),(57.085,186.795),(57.235,186.795),(57.235,186.645),(57.085,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,186.645),(57.405,186.795),(57.555,186.795),(57.555,186.645),(57.405,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,186.965),(56.445,187.115),(56.595,187.115),(56.595,186.965),(56.445,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,186.965),(56.765,187.115),(56.915,187.115),(56.915,186.965),(56.765,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,186.965),(57.085,187.115),(57.235,187.115),(57.235,186.965),(57.085,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,186.965),(57.405,187.115),(57.555,187.115),(57.555,186.965),(57.405,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,187.285),(56.445,187.435),(56.595,187.435),(56.595,187.285),(56.445,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,187.285),(56.765,187.435),(56.915,187.435),(56.915,187.285),(56.765,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,187.285),(57.085,187.435),(57.235,187.435),(57.235,187.285),(57.085,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,187.285),(57.405,187.435),(57.555,187.435),(57.555,187.285),(57.405,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,187.605),(56.445,187.755),(56.595,187.755),(56.595,187.605),(56.445,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,187.605),(56.765,187.755),(56.915,187.755),(56.915,187.605),(56.765,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,187.605),(57.085,187.755),(57.235,187.755),(57.235,187.605),(57.085,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,187.605),(57.405,187.755),(57.555,187.755),(57.555,187.605),(57.405,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,173.845),(27.645,173.995),(27.795,173.995),(27.795,173.845),(27.645,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,173.845),(27.965,173.995),(28.115,173.995),(28.115,173.845),(27.965,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,173.845),(28.285,173.995),(28.435,173.995),(28.435,173.845),(28.285,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,173.845),(28.605,173.995),(28.755,173.995),(28.755,173.845),(28.605,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,174.165),(27.645,174.315),(27.795,174.315),(27.795,174.165),(27.645,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,174.165),(27.965,174.315),(28.115,174.315),(28.115,174.165),(27.965,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,174.165),(28.285,174.315),(28.435,174.315),(28.435,174.165),(28.285,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,174.165),(28.605,174.315),(28.755,174.315),(28.755,174.165),(28.605,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,174.485),(27.645,174.635),(27.795,174.635),(27.795,174.485),(27.645,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,174.485),(27.965,174.635),(28.115,174.635),(28.115,174.485),(27.965,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,174.485),(28.285,174.635),(28.435,174.635),(28.435,174.485),(28.285,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,174.485),(28.605,174.635),(28.755,174.635),(28.755,174.485),(28.605,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,174.805),(27.645,174.955),(27.795,174.955),(27.795,174.805),(27.645,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,174.805),(27.965,174.955),(28.115,174.955),(28.115,174.805),(27.965,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,174.805),(28.285,174.955),(28.435,174.955),(28.435,174.805),(28.285,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,174.805),(28.605,174.955),(28.755,174.955),(28.755,174.805),(28.605,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,175.125),(27.645,175.275),(27.795,175.275),(27.795,175.125),(27.645,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,175.125),(27.965,175.275),(28.115,175.275),(28.115,175.125),(27.965,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,175.125),(28.285,175.275),(28.435,175.275),(28.435,175.125),(28.285,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,175.125),(28.605,175.275),(28.755,175.275),(28.755,175.125),(28.605,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,175.445),(27.645,175.595),(27.795,175.595),(27.795,175.445),(27.645,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,175.445),(27.965,175.595),(28.115,175.595),(28.115,175.445),(27.965,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,175.445),(28.285,175.595),(28.435,175.595),(28.435,175.445),(28.285,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,175.445),(28.605,175.595),(28.755,175.595),(28.755,175.445),(28.605,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,175.765),(27.645,175.915),(27.795,175.915),(27.795,175.765),(27.645,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,175.765),(27.965,175.915),(28.115,175.915),(28.115,175.765),(27.965,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,175.765),(28.285,175.915),(28.435,175.915),(28.435,175.765),(28.285,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,175.765),(28.605,175.915),(28.755,175.915),(28.755,175.765),(28.605,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,176.085),(27.645,176.235),(27.795,176.235),(27.795,176.085),(27.645,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,176.085),(27.965,176.235),(28.115,176.235),(28.115,176.085),(27.965,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,176.085),(28.285,176.235),(28.435,176.235),(28.435,176.085),(28.285,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,176.085),(28.605,176.235),(28.755,176.235),(28.755,176.085),(28.605,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,176.405),(27.645,176.555),(27.795,176.555),(27.795,176.405),(27.645,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,176.405),(27.965,176.555),(28.115,176.555),(28.115,176.405),(27.965,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,176.405),(28.285,176.555),(28.435,176.555),(28.435,176.405),(28.285,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,176.405),(28.605,176.555),(28.755,176.555),(28.755,176.405),(28.605,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,176.725),(27.645,176.875),(27.795,176.875),(27.795,176.725),(27.645,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,176.725),(27.965,176.875),(28.115,176.875),(28.115,176.725),(27.965,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,176.725),(28.285,176.875),(28.435,176.875),(28.435,176.725),(28.285,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,176.725),(28.605,176.875),(28.755,176.875),(28.755,176.725),(28.605,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,177.045),(27.645,177.195),(27.795,177.195),(27.795,177.045),(27.645,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,177.045),(27.965,177.195),(28.115,177.195),(28.115,177.045),(27.965,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,177.045),(28.285,177.195),(28.435,177.195),(28.435,177.045),(28.285,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,177.045),(28.605,177.195),(28.755,177.195),(28.755,177.045),(28.605,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,177.365),(27.645,177.515),(27.795,177.515),(27.795,177.365),(27.645,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,177.365),(27.965,177.515),(28.115,177.515),(28.115,177.365),(27.965,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,177.365),(28.285,177.515),(28.435,177.515),(28.435,177.365),(28.285,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,177.365),(28.605,177.515),(28.755,177.515),(28.755,177.365),(28.605,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,177.685),(27.645,177.835),(27.795,177.835),(27.795,177.685),(27.645,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,177.685),(27.965,177.835),(28.115,177.835),(28.115,177.685),(27.965,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,177.685),(28.285,177.835),(28.435,177.835),(28.435,177.685),(28.285,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,177.685),(28.605,177.835),(28.755,177.835),(28.755,177.685),(28.605,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,178.005),(27.645,178.155),(27.795,178.155),(27.795,178.005),(27.645,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,178.005),(27.965,178.155),(28.115,178.155),(28.115,178.005),(27.965,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,178.005),(28.285,178.155),(28.435,178.155),(28.435,178.005),(28.285,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,178.005),(28.605,178.155),(28.755,178.155),(28.755,178.005),(28.605,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,178.325),(27.645,178.475),(27.795,178.475),(27.795,178.325),(27.645,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,178.325),(27.965,178.475),(28.115,178.475),(28.115,178.325),(27.965,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,178.325),(28.285,178.475),(28.435,178.475),(28.435,178.325),(28.285,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,178.325),(28.605,178.475),(28.755,178.475),(28.755,178.325),(28.605,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,178.645),(27.645,178.795),(27.795,178.795),(27.795,178.645),(27.645,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,178.645),(27.965,178.795),(28.115,178.795),(28.115,178.645),(27.965,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,178.645),(28.285,178.795),(28.435,178.795),(28.435,178.645),(28.285,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,178.645),(28.605,178.795),(28.755,178.795),(28.755,178.645),(28.605,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,178.965),(27.645,179.115),(27.795,179.115),(27.795,178.965),(27.645,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,178.965),(27.965,179.115),(28.115,179.115),(28.115,178.965),(27.965,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,178.965),(28.285,179.115),(28.435,179.115),(28.435,178.965),(28.285,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,178.965),(28.605,179.115),(28.755,179.115),(28.755,178.965),(28.605,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,179.285),(27.645,179.435),(27.795,179.435),(27.795,179.285),(27.645,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,179.285),(27.965,179.435),(28.115,179.435),(28.115,179.285),(27.965,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,179.285),(28.285,179.435),(28.435,179.435),(28.435,179.285),(28.285,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,179.285),(28.605,179.435),(28.755,179.435),(28.755,179.285),(28.605,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,179.605),(27.645,179.755),(27.795,179.755),(27.795,179.605),(27.645,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,179.605),(27.965,179.755),(28.115,179.755),(28.115,179.605),(27.965,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,179.605),(28.285,179.755),(28.435,179.755),(28.435,179.605),(28.285,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,179.605),(28.605,179.755),(28.755,179.755),(28.755,179.605),(28.605,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,179.925),(27.645,180.075),(27.795,180.075),(27.795,179.925),(27.645,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,179.925),(27.965,180.075),(28.115,180.075),(28.115,179.925),(27.965,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,179.925),(28.285,180.075),(28.435,180.075),(28.435,179.925),(28.285,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,179.925),(28.605,180.075),(28.755,180.075),(28.755,179.925),(28.605,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,180.245),(27.645,180.395),(27.795,180.395),(27.795,180.245),(27.645,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,180.245),(27.965,180.395),(28.115,180.395),(28.115,180.245),(27.965,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,180.245),(28.285,180.395),(28.435,180.395),(28.435,180.245),(28.285,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,180.245),(28.605,180.395),(28.755,180.395),(28.755,180.245),(28.605,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,180.565),(27.645,180.715),(27.795,180.715),(27.795,180.565),(27.645,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,180.565),(27.965,180.715),(28.115,180.715),(28.115,180.565),(27.965,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,180.565),(28.285,180.715),(28.435,180.715),(28.435,180.565),(28.285,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,180.565),(28.605,180.715),(28.755,180.715),(28.755,180.565),(28.605,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,180.885),(27.645,181.035),(27.795,181.035),(27.795,180.885),(27.645,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,180.885),(27.965,181.035),(28.115,181.035),(28.115,180.885),(27.965,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,180.885),(28.285,181.035),(28.435,181.035),(28.435,180.885),(28.285,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,180.885),(28.605,181.035),(28.755,181.035),(28.755,180.885),(28.605,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,181.205),(27.645,181.355),(27.795,181.355),(27.795,181.205),(27.645,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,181.205),(27.965,181.355),(28.115,181.355),(28.115,181.205),(27.965,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,181.205),(28.285,181.355),(28.435,181.355),(28.435,181.205),(28.285,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,181.205),(28.605,181.355),(28.755,181.355),(28.755,181.205),(28.605,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,181.525),(27.645,181.675),(27.795,181.675),(27.795,181.525),(27.645,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,181.525),(27.965,181.675),(28.115,181.675),(28.115,181.525),(27.965,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,181.525),(28.285,181.675),(28.435,181.675),(28.435,181.525),(28.285,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,181.525),(28.605,181.675),(28.755,181.675),(28.755,181.525),(28.605,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,181.845),(27.645,181.995),(27.795,181.995),(27.795,181.845),(27.645,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,181.845),(27.965,181.995),(28.115,181.995),(28.115,181.845),(27.965,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,181.845),(28.285,181.995),(28.435,181.995),(28.435,181.845),(28.285,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,181.845),(28.605,181.995),(28.755,181.995),(28.755,181.845),(28.605,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,182.165),(27.645,182.315),(27.795,182.315),(27.795,182.165),(27.645,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,182.165),(27.965,182.315),(28.115,182.315),(28.115,182.165),(27.965,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,182.165),(28.285,182.315),(28.435,182.315),(28.435,182.165),(28.285,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,182.165),(28.605,182.315),(28.755,182.315),(28.755,182.165),(28.605,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,182.485),(27.645,182.635),(27.795,182.635),(27.795,182.485),(27.645,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,182.485),(27.965,182.635),(28.115,182.635),(28.115,182.485),(27.965,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,182.485),(28.285,182.635),(28.435,182.635),(28.435,182.485),(28.285,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,182.485),(28.605,182.635),(28.755,182.635),(28.755,182.485),(28.605,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,182.805),(27.645,182.955),(27.795,182.955),(27.795,182.805),(27.645,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,182.805),(27.965,182.955),(28.115,182.955),(28.115,182.805),(27.965,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,182.805),(28.285,182.955),(28.435,182.955),(28.435,182.805),(28.285,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,182.805),(28.605,182.955),(28.755,182.955),(28.755,182.805),(28.605,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,183.125),(27.645,183.275),(27.795,183.275),(27.795,183.125),(27.645,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,183.125),(27.965,183.275),(28.115,183.275),(28.115,183.125),(27.965,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,183.125),(28.285,183.275),(28.435,183.275),(28.435,183.125),(28.285,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,183.125),(28.605,183.275),(28.755,183.275),(28.755,183.125),(28.605,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,183.445),(27.645,183.595),(27.795,183.595),(27.795,183.445),(27.645,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,183.445),(27.965,183.595),(28.115,183.595),(28.115,183.445),(27.965,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,183.445),(28.285,183.595),(28.435,183.595),(28.435,183.445),(28.285,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,183.445),(28.605,183.595),(28.755,183.595),(28.755,183.445),(28.605,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,183.765),(27.645,183.915),(27.795,183.915),(27.795,183.765),(27.645,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,183.765),(27.965,183.915),(28.115,183.915),(28.115,183.765),(27.965,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,183.765),(28.285,183.915),(28.435,183.915),(28.435,183.765),(28.285,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,183.765),(28.605,183.915),(28.755,183.915),(28.755,183.765),(28.605,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,184.085),(27.645,184.235),(27.795,184.235),(27.795,184.085),(27.645,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,184.085),(27.965,184.235),(28.115,184.235),(28.115,184.085),(27.965,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,184.085),(28.285,184.235),(28.435,184.235),(28.435,184.085),(28.285,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,184.085),(28.605,184.235),(28.755,184.235),(28.755,184.085),(28.605,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,184.405),(27.645,184.555),(27.795,184.555),(27.795,184.405),(27.645,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,184.405),(27.965,184.555),(28.115,184.555),(28.115,184.405),(27.965,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,184.405),(28.285,184.555),(28.435,184.555),(28.435,184.405),(28.285,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,184.405),(28.605,184.555),(28.755,184.555),(28.755,184.405),(28.605,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,184.725),(27.645,184.875),(27.795,184.875),(27.795,184.725),(27.645,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,184.725),(27.965,184.875),(28.115,184.875),(28.115,184.725),(27.965,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,184.725),(28.285,184.875),(28.435,184.875),(28.435,184.725),(28.285,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,184.725),(28.605,184.875),(28.755,184.875),(28.755,184.725),(28.605,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,185.045),(27.645,185.195),(27.795,185.195),(27.795,185.045),(27.645,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,185.045),(27.965,185.195),(28.115,185.195),(28.115,185.045),(27.965,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,185.045),(28.285,185.195),(28.435,185.195),(28.435,185.045),(28.285,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,185.045),(28.605,185.195),(28.755,185.195),(28.755,185.045),(28.605,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,185.365),(27.645,185.515),(27.795,185.515),(27.795,185.365),(27.645,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,185.365),(27.965,185.515),(28.115,185.515),(28.115,185.365),(27.965,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,185.365),(28.285,185.515),(28.435,185.515),(28.435,185.365),(28.285,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,185.365),(28.605,185.515),(28.755,185.515),(28.755,185.365),(28.605,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,185.685),(27.645,185.835),(27.795,185.835),(27.795,185.685),(27.645,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,185.685),(27.965,185.835),(28.115,185.835),(28.115,185.685),(27.965,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,185.685),(28.285,185.835),(28.435,185.835),(28.435,185.685),(28.285,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,185.685),(28.605,185.835),(28.755,185.835),(28.755,185.685),(28.605,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,186.005),(27.645,186.155),(27.795,186.155),(27.795,186.005),(27.645,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,186.005),(27.965,186.155),(28.115,186.155),(28.115,186.005),(27.965,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,186.005),(28.285,186.155),(28.435,186.155),(28.435,186.005),(28.285,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,186.005),(28.605,186.155),(28.755,186.155),(28.755,186.005),(28.605,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,186.325),(27.645,186.475),(27.795,186.475),(27.795,186.325),(27.645,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,186.325),(27.965,186.475),(28.115,186.475),(28.115,186.325),(27.965,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,186.325),(28.285,186.475),(28.435,186.475),(28.435,186.325),(28.285,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,186.325),(28.605,186.475),(28.755,186.475),(28.755,186.325),(28.605,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,186.645),(27.645,186.795),(27.795,186.795),(27.795,186.645),(27.645,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,186.645),(27.965,186.795),(28.115,186.795),(28.115,186.645),(27.965,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,186.645),(28.285,186.795),(28.435,186.795),(28.435,186.645),(28.285,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,186.645),(28.605,186.795),(28.755,186.795),(28.755,186.645),(28.605,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,186.965),(27.645,187.115),(27.795,187.115),(27.795,186.965),(27.645,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,186.965),(27.965,187.115),(28.115,187.115),(28.115,186.965),(27.965,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,186.965),(28.285,187.115),(28.435,187.115),(28.435,186.965),(28.285,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,186.965),(28.605,187.115),(28.755,187.115),(28.755,186.965),(28.605,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,187.285),(27.645,187.435),(27.795,187.435),(27.795,187.285),(27.645,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,187.285),(27.965,187.435),(28.115,187.435),(28.115,187.285),(27.965,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,187.285),(28.285,187.435),(28.435,187.435),(28.435,187.285),(28.285,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,187.285),(28.605,187.435),(28.755,187.435),(28.755,187.285),(28.605,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,187.605),(27.645,187.755),(27.795,187.755),(27.795,187.605),(27.645,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,187.605),(27.965,187.755),(28.115,187.755),(28.115,187.605),(27.965,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,187.605),(28.285,187.755),(28.435,187.755),(28.435,187.605),(28.285,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,187.605),(28.605,187.755),(28.755,187.755),(28.755,187.605),(28.605,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,173.845),(70.845,173.995),(70.995,173.995),(70.995,173.845),(70.845,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,173.845),(71.165,173.995),(71.315,173.995),(71.315,173.845),(71.165,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,173.845),(71.485,173.995),(71.635,173.995),(71.635,173.845),(71.485,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,173.845),(71.805,173.995),(71.955,173.995),(71.955,173.845),(71.805,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,174.165),(70.845,174.315),(70.995,174.315),(70.995,174.165),(70.845,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,174.165),(71.165,174.315),(71.315,174.315),(71.315,174.165),(71.165,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,174.165),(71.485,174.315),(71.635,174.315),(71.635,174.165),(71.485,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,174.165),(71.805,174.315),(71.955,174.315),(71.955,174.165),(71.805,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,174.485),(70.845,174.635),(70.995,174.635),(70.995,174.485),(70.845,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,174.485),(71.165,174.635),(71.315,174.635),(71.315,174.485),(71.165,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,174.485),(71.485,174.635),(71.635,174.635),(71.635,174.485),(71.485,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,174.485),(71.805,174.635),(71.955,174.635),(71.955,174.485),(71.805,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,174.805),(70.845,174.955),(70.995,174.955),(70.995,174.805),(70.845,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,174.805),(71.165,174.955),(71.315,174.955),(71.315,174.805),(71.165,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,174.805),(71.485,174.955),(71.635,174.955),(71.635,174.805),(71.485,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,174.805),(71.805,174.955),(71.955,174.955),(71.955,174.805),(71.805,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,175.125),(70.845,175.275),(70.995,175.275),(70.995,175.125),(70.845,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,175.125),(71.165,175.275),(71.315,175.275),(71.315,175.125),(71.165,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,175.125),(71.485,175.275),(71.635,175.275),(71.635,175.125),(71.485,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,175.125),(71.805,175.275),(71.955,175.275),(71.955,175.125),(71.805,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,175.445),(70.845,175.595),(70.995,175.595),(70.995,175.445),(70.845,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,175.445),(71.165,175.595),(71.315,175.595),(71.315,175.445),(71.165,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,175.445),(71.485,175.595),(71.635,175.595),(71.635,175.445),(71.485,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,175.445),(71.805,175.595),(71.955,175.595),(71.955,175.445),(71.805,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,175.765),(70.845,175.915),(70.995,175.915),(70.995,175.765),(70.845,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,175.765),(71.165,175.915),(71.315,175.915),(71.315,175.765),(71.165,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,175.765),(71.485,175.915),(71.635,175.915),(71.635,175.765),(71.485,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,175.765),(71.805,175.915),(71.955,175.915),(71.955,175.765),(71.805,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,176.085),(70.845,176.235),(70.995,176.235),(70.995,176.085),(70.845,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,176.085),(71.165,176.235),(71.315,176.235),(71.315,176.085),(71.165,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,176.085),(71.485,176.235),(71.635,176.235),(71.635,176.085),(71.485,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,176.085),(71.805,176.235),(71.955,176.235),(71.955,176.085),(71.805,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,176.405),(70.845,176.555),(70.995,176.555),(70.995,176.405),(70.845,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,176.405),(71.165,176.555),(71.315,176.555),(71.315,176.405),(71.165,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,176.405),(71.485,176.555),(71.635,176.555),(71.635,176.405),(71.485,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,176.405),(71.805,176.555),(71.955,176.555),(71.955,176.405),(71.805,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,176.725),(70.845,176.875),(70.995,176.875),(70.995,176.725),(70.845,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,176.725),(71.165,176.875),(71.315,176.875),(71.315,176.725),(71.165,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,176.725),(71.485,176.875),(71.635,176.875),(71.635,176.725),(71.485,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,176.725),(71.805,176.875),(71.955,176.875),(71.955,176.725),(71.805,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,177.045),(70.845,177.195),(70.995,177.195),(70.995,177.045),(70.845,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,177.045),(71.165,177.195),(71.315,177.195),(71.315,177.045),(71.165,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,177.045),(71.485,177.195),(71.635,177.195),(71.635,177.045),(71.485,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,177.045),(71.805,177.195),(71.955,177.195),(71.955,177.045),(71.805,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,177.365),(70.845,177.515),(70.995,177.515),(70.995,177.365),(70.845,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,177.365),(71.165,177.515),(71.315,177.515),(71.315,177.365),(71.165,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,177.365),(71.485,177.515),(71.635,177.515),(71.635,177.365),(71.485,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,177.365),(71.805,177.515),(71.955,177.515),(71.955,177.365),(71.805,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,177.685),(70.845,177.835),(70.995,177.835),(70.995,177.685),(70.845,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,177.685),(71.165,177.835),(71.315,177.835),(71.315,177.685),(71.165,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,177.685),(71.485,177.835),(71.635,177.835),(71.635,177.685),(71.485,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,177.685),(71.805,177.835),(71.955,177.835),(71.955,177.685),(71.805,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,178.005),(70.845,178.155),(70.995,178.155),(70.995,178.005),(70.845,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,178.005),(71.165,178.155),(71.315,178.155),(71.315,178.005),(71.165,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,178.005),(71.485,178.155),(71.635,178.155),(71.635,178.005),(71.485,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,178.005),(71.805,178.155),(71.955,178.155),(71.955,178.005),(71.805,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,178.325),(70.845,178.475),(70.995,178.475),(70.995,178.325),(70.845,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,178.325),(71.165,178.475),(71.315,178.475),(71.315,178.325),(71.165,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,178.325),(71.485,178.475),(71.635,178.475),(71.635,178.325),(71.485,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,178.325),(71.805,178.475),(71.955,178.475),(71.955,178.325),(71.805,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,178.645),(70.845,178.795),(70.995,178.795),(70.995,178.645),(70.845,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,178.645),(71.165,178.795),(71.315,178.795),(71.315,178.645),(71.165,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,178.645),(71.485,178.795),(71.635,178.795),(71.635,178.645),(71.485,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,178.645),(71.805,178.795),(71.955,178.795),(71.955,178.645),(71.805,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,178.965),(70.845,179.115),(70.995,179.115),(70.995,178.965),(70.845,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,178.965),(71.165,179.115),(71.315,179.115),(71.315,178.965),(71.165,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,178.965),(71.485,179.115),(71.635,179.115),(71.635,178.965),(71.485,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,178.965),(71.805,179.115),(71.955,179.115),(71.955,178.965),(71.805,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,179.285),(70.845,179.435),(70.995,179.435),(70.995,179.285),(70.845,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,179.285),(71.165,179.435),(71.315,179.435),(71.315,179.285),(71.165,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,179.285),(71.485,179.435),(71.635,179.435),(71.635,179.285),(71.485,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,179.285),(71.805,179.435),(71.955,179.435),(71.955,179.285),(71.805,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,179.605),(70.845,179.755),(70.995,179.755),(70.995,179.605),(70.845,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,179.605),(71.165,179.755),(71.315,179.755),(71.315,179.605),(71.165,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,179.605),(71.485,179.755),(71.635,179.755),(71.635,179.605),(71.485,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,179.605),(71.805,179.755),(71.955,179.755),(71.955,179.605),(71.805,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,179.925),(70.845,180.075),(70.995,180.075),(70.995,179.925),(70.845,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,179.925),(71.165,180.075),(71.315,180.075),(71.315,179.925),(71.165,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,179.925),(71.485,180.075),(71.635,180.075),(71.635,179.925),(71.485,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,179.925),(71.805,180.075),(71.955,180.075),(71.955,179.925),(71.805,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,180.245),(70.845,180.395),(70.995,180.395),(70.995,180.245),(70.845,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,180.245),(71.165,180.395),(71.315,180.395),(71.315,180.245),(71.165,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,180.245),(71.485,180.395),(71.635,180.395),(71.635,180.245),(71.485,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,180.245),(71.805,180.395),(71.955,180.395),(71.955,180.245),(71.805,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,180.565),(70.845,180.715),(70.995,180.715),(70.995,180.565),(70.845,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,180.565),(71.165,180.715),(71.315,180.715),(71.315,180.565),(71.165,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,180.565),(71.485,180.715),(71.635,180.715),(71.635,180.565),(71.485,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,180.565),(71.805,180.715),(71.955,180.715),(71.955,180.565),(71.805,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,180.885),(70.845,181.035),(70.995,181.035),(70.995,180.885),(70.845,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,180.885),(71.165,181.035),(71.315,181.035),(71.315,180.885),(71.165,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,180.885),(71.485,181.035),(71.635,181.035),(71.635,180.885),(71.485,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,180.885),(71.805,181.035),(71.955,181.035),(71.955,180.885),(71.805,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,181.205),(70.845,181.355),(70.995,181.355),(70.995,181.205),(70.845,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,181.205),(71.165,181.355),(71.315,181.355),(71.315,181.205),(71.165,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,181.205),(71.485,181.355),(71.635,181.355),(71.635,181.205),(71.485,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,181.205),(71.805,181.355),(71.955,181.355),(71.955,181.205),(71.805,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,181.525),(70.845,181.675),(70.995,181.675),(70.995,181.525),(70.845,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,181.525),(71.165,181.675),(71.315,181.675),(71.315,181.525),(71.165,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,181.525),(71.485,181.675),(71.635,181.675),(71.635,181.525),(71.485,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,181.525),(71.805,181.675),(71.955,181.675),(71.955,181.525),(71.805,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,181.845),(70.845,181.995),(70.995,181.995),(70.995,181.845),(70.845,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,181.845),(71.165,181.995),(71.315,181.995),(71.315,181.845),(71.165,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,181.845),(71.485,181.995),(71.635,181.995),(71.635,181.845),(71.485,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,181.845),(71.805,181.995),(71.955,181.995),(71.955,181.845),(71.805,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,182.165),(70.845,182.315),(70.995,182.315),(70.995,182.165),(70.845,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,182.165),(71.165,182.315),(71.315,182.315),(71.315,182.165),(71.165,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,182.165),(71.485,182.315),(71.635,182.315),(71.635,182.165),(71.485,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,182.165),(71.805,182.315),(71.955,182.315),(71.955,182.165),(71.805,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,182.485),(70.845,182.635),(70.995,182.635),(70.995,182.485),(70.845,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,182.485),(71.165,182.635),(71.315,182.635),(71.315,182.485),(71.165,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,182.485),(71.485,182.635),(71.635,182.635),(71.635,182.485),(71.485,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,182.485),(71.805,182.635),(71.955,182.635),(71.955,182.485),(71.805,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,182.805),(70.845,182.955),(70.995,182.955),(70.995,182.805),(70.845,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,182.805),(71.165,182.955),(71.315,182.955),(71.315,182.805),(71.165,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,182.805),(71.485,182.955),(71.635,182.955),(71.635,182.805),(71.485,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,182.805),(71.805,182.955),(71.955,182.955),(71.955,182.805),(71.805,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,183.125),(70.845,183.275),(70.995,183.275),(70.995,183.125),(70.845,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,183.125),(71.165,183.275),(71.315,183.275),(71.315,183.125),(71.165,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,183.125),(71.485,183.275),(71.635,183.275),(71.635,183.125),(71.485,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,183.125),(71.805,183.275),(71.955,183.275),(71.955,183.125),(71.805,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,183.445),(70.845,183.595),(70.995,183.595),(70.995,183.445),(70.845,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,183.445),(71.165,183.595),(71.315,183.595),(71.315,183.445),(71.165,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,183.445),(71.485,183.595),(71.635,183.595),(71.635,183.445),(71.485,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,183.445),(71.805,183.595),(71.955,183.595),(71.955,183.445),(71.805,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,183.765),(70.845,183.915),(70.995,183.915),(70.995,183.765),(70.845,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,183.765),(71.165,183.915),(71.315,183.915),(71.315,183.765),(71.165,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,183.765),(71.485,183.915),(71.635,183.915),(71.635,183.765),(71.485,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,183.765),(71.805,183.915),(71.955,183.915),(71.955,183.765),(71.805,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,184.085),(70.845,184.235),(70.995,184.235),(70.995,184.085),(70.845,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,184.085),(71.165,184.235),(71.315,184.235),(71.315,184.085),(71.165,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,184.085),(71.485,184.235),(71.635,184.235),(71.635,184.085),(71.485,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,184.085),(71.805,184.235),(71.955,184.235),(71.955,184.085),(71.805,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,184.405),(70.845,184.555),(70.995,184.555),(70.995,184.405),(70.845,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,184.405),(71.165,184.555),(71.315,184.555),(71.315,184.405),(71.165,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,184.405),(71.485,184.555),(71.635,184.555),(71.635,184.405),(71.485,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,184.405),(71.805,184.555),(71.955,184.555),(71.955,184.405),(71.805,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,184.725),(70.845,184.875),(70.995,184.875),(70.995,184.725),(70.845,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,184.725),(71.165,184.875),(71.315,184.875),(71.315,184.725),(71.165,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,184.725),(71.485,184.875),(71.635,184.875),(71.635,184.725),(71.485,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,184.725),(71.805,184.875),(71.955,184.875),(71.955,184.725),(71.805,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,185.045),(70.845,185.195),(70.995,185.195),(70.995,185.045),(70.845,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,185.045),(71.165,185.195),(71.315,185.195),(71.315,185.045),(71.165,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,185.045),(71.485,185.195),(71.635,185.195),(71.635,185.045),(71.485,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,185.045),(71.805,185.195),(71.955,185.195),(71.955,185.045),(71.805,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,185.365),(70.845,185.515),(70.995,185.515),(70.995,185.365),(70.845,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,185.365),(71.165,185.515),(71.315,185.515),(71.315,185.365),(71.165,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,185.365),(71.485,185.515),(71.635,185.515),(71.635,185.365),(71.485,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,185.365),(71.805,185.515),(71.955,185.515),(71.955,185.365),(71.805,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,185.685),(70.845,185.835),(70.995,185.835),(70.995,185.685),(70.845,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,185.685),(71.165,185.835),(71.315,185.835),(71.315,185.685),(71.165,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,185.685),(71.485,185.835),(71.635,185.835),(71.635,185.685),(71.485,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,185.685),(71.805,185.835),(71.955,185.835),(71.955,185.685),(71.805,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,186.005),(70.845,186.155),(70.995,186.155),(70.995,186.005),(70.845,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,186.005),(71.165,186.155),(71.315,186.155),(71.315,186.005),(71.165,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,186.005),(71.485,186.155),(71.635,186.155),(71.635,186.005),(71.485,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,186.005),(71.805,186.155),(71.955,186.155),(71.955,186.005),(71.805,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,186.325),(70.845,186.475),(70.995,186.475),(70.995,186.325),(70.845,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,186.325),(71.165,186.475),(71.315,186.475),(71.315,186.325),(71.165,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,186.325),(71.485,186.475),(71.635,186.475),(71.635,186.325),(71.485,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,186.325),(71.805,186.475),(71.955,186.475),(71.955,186.325),(71.805,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,186.645),(70.845,186.795),(70.995,186.795),(70.995,186.645),(70.845,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,186.645),(71.165,186.795),(71.315,186.795),(71.315,186.645),(71.165,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,186.645),(71.485,186.795),(71.635,186.795),(71.635,186.645),(71.485,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,186.645),(71.805,186.795),(71.955,186.795),(71.955,186.645),(71.805,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,186.965),(70.845,187.115),(70.995,187.115),(70.995,186.965),(70.845,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,186.965),(71.165,187.115),(71.315,187.115),(71.315,186.965),(71.165,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,186.965),(71.485,187.115),(71.635,187.115),(71.635,186.965),(71.485,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,186.965),(71.805,187.115),(71.955,187.115),(71.955,186.965),(71.805,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,187.285),(70.845,187.435),(70.995,187.435),(70.995,187.285),(70.845,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,187.285),(71.165,187.435),(71.315,187.435),(71.315,187.285),(71.165,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,187.285),(71.485,187.435),(71.635,187.435),(71.635,187.285),(71.485,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,187.285),(71.805,187.435),(71.955,187.435),(71.955,187.285),(71.805,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,187.605),(70.845,187.755),(70.995,187.755),(70.995,187.605),(70.845,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,187.605),(71.165,187.755),(71.315,187.755),(71.315,187.605),(71.165,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,187.605),(71.485,187.755),(71.635,187.755),(71.635,187.605),(71.485,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,187.605),(71.805,187.755),(71.955,187.755),(71.955,187.605),(71.805,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,173.845),(8.445,173.995),(8.595,173.995),(8.595,173.845),(8.445,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,173.845),(8.765,173.995),(8.915,173.995),(8.915,173.845),(8.765,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,173.845),(9.085,173.995),(9.235,173.995),(9.235,173.845),(9.085,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,173.845),(9.405,173.995),(9.555,173.995),(9.555,173.845),(9.405,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,174.165),(8.445,174.315),(8.595,174.315),(8.595,174.165),(8.445,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,174.165),(8.765,174.315),(8.915,174.315),(8.915,174.165),(8.765,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,174.165),(9.085,174.315),(9.235,174.315),(9.235,174.165),(9.085,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,174.165),(9.405,174.315),(9.555,174.315),(9.555,174.165),(9.405,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,174.485),(8.445,174.635),(8.595,174.635),(8.595,174.485),(8.445,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,174.485),(8.765,174.635),(8.915,174.635),(8.915,174.485),(8.765,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,174.485),(9.085,174.635),(9.235,174.635),(9.235,174.485),(9.085,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,174.485),(9.405,174.635),(9.555,174.635),(9.555,174.485),(9.405,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,174.805),(8.445,174.955),(8.595,174.955),(8.595,174.805),(8.445,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,174.805),(8.765,174.955),(8.915,174.955),(8.915,174.805),(8.765,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,174.805),(9.085,174.955),(9.235,174.955),(9.235,174.805),(9.085,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,174.805),(9.405,174.955),(9.555,174.955),(9.555,174.805),(9.405,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,175.125),(8.445,175.275),(8.595,175.275),(8.595,175.125),(8.445,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,175.125),(8.765,175.275),(8.915,175.275),(8.915,175.125),(8.765,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,175.125),(9.085,175.275),(9.235,175.275),(9.235,175.125),(9.085,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,175.125),(9.405,175.275),(9.555,175.275),(9.555,175.125),(9.405,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,175.445),(8.445,175.595),(8.595,175.595),(8.595,175.445),(8.445,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,175.445),(8.765,175.595),(8.915,175.595),(8.915,175.445),(8.765,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,175.445),(9.085,175.595),(9.235,175.595),(9.235,175.445),(9.085,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,175.445),(9.405,175.595),(9.555,175.595),(9.555,175.445),(9.405,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,175.765),(8.445,175.915),(8.595,175.915),(8.595,175.765),(8.445,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,175.765),(8.765,175.915),(8.915,175.915),(8.915,175.765),(8.765,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,175.765),(9.085,175.915),(9.235,175.915),(9.235,175.765),(9.085,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,175.765),(9.405,175.915),(9.555,175.915),(9.555,175.765),(9.405,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,176.085),(8.445,176.235),(8.595,176.235),(8.595,176.085),(8.445,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,176.085),(8.765,176.235),(8.915,176.235),(8.915,176.085),(8.765,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,176.085),(9.085,176.235),(9.235,176.235),(9.235,176.085),(9.085,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,176.085),(9.405,176.235),(9.555,176.235),(9.555,176.085),(9.405,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,176.405),(8.445,176.555),(8.595,176.555),(8.595,176.405),(8.445,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,176.405),(8.765,176.555),(8.915,176.555),(8.915,176.405),(8.765,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,176.405),(9.085,176.555),(9.235,176.555),(9.235,176.405),(9.085,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,176.405),(9.405,176.555),(9.555,176.555),(9.555,176.405),(9.405,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,176.725),(8.445,176.875),(8.595,176.875),(8.595,176.725),(8.445,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,176.725),(8.765,176.875),(8.915,176.875),(8.915,176.725),(8.765,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,176.725),(9.085,176.875),(9.235,176.875),(9.235,176.725),(9.085,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,176.725),(9.405,176.875),(9.555,176.875),(9.555,176.725),(9.405,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,177.045),(8.445,177.195),(8.595,177.195),(8.595,177.045),(8.445,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,177.045),(8.765,177.195),(8.915,177.195),(8.915,177.045),(8.765,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,177.045),(9.085,177.195),(9.235,177.195),(9.235,177.045),(9.085,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,177.045),(9.405,177.195),(9.555,177.195),(9.555,177.045),(9.405,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,177.365),(8.445,177.515),(8.595,177.515),(8.595,177.365),(8.445,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,177.365),(8.765,177.515),(8.915,177.515),(8.915,177.365),(8.765,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,177.365),(9.085,177.515),(9.235,177.515),(9.235,177.365),(9.085,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,177.365),(9.405,177.515),(9.555,177.515),(9.555,177.365),(9.405,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,177.685),(8.445,177.835),(8.595,177.835),(8.595,177.685),(8.445,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,177.685),(8.765,177.835),(8.915,177.835),(8.915,177.685),(8.765,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,177.685),(9.085,177.835),(9.235,177.835),(9.235,177.685),(9.085,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,177.685),(9.405,177.835),(9.555,177.835),(9.555,177.685),(9.405,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,178.005),(8.445,178.155),(8.595,178.155),(8.595,178.005),(8.445,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,178.005),(8.765,178.155),(8.915,178.155),(8.915,178.005),(8.765,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,178.005),(9.085,178.155),(9.235,178.155),(9.235,178.005),(9.085,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,178.005),(9.405,178.155),(9.555,178.155),(9.555,178.005),(9.405,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,178.325),(8.445,178.475),(8.595,178.475),(8.595,178.325),(8.445,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,178.325),(8.765,178.475),(8.915,178.475),(8.915,178.325),(8.765,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,178.325),(9.085,178.475),(9.235,178.475),(9.235,178.325),(9.085,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,178.325),(9.405,178.475),(9.555,178.475),(9.555,178.325),(9.405,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,178.645),(8.445,178.795),(8.595,178.795),(8.595,178.645),(8.445,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,178.645),(8.765,178.795),(8.915,178.795),(8.915,178.645),(8.765,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,178.645),(9.085,178.795),(9.235,178.795),(9.235,178.645),(9.085,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,178.645),(9.405,178.795),(9.555,178.795),(9.555,178.645),(9.405,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,178.965),(8.445,179.115),(8.595,179.115),(8.595,178.965),(8.445,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,178.965),(8.765,179.115),(8.915,179.115),(8.915,178.965),(8.765,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,178.965),(9.085,179.115),(9.235,179.115),(9.235,178.965),(9.085,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,178.965),(9.405,179.115),(9.555,179.115),(9.555,178.965),(9.405,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,179.285),(8.445,179.435),(8.595,179.435),(8.595,179.285),(8.445,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,179.285),(8.765,179.435),(8.915,179.435),(8.915,179.285),(8.765,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,179.285),(9.085,179.435),(9.235,179.435),(9.235,179.285),(9.085,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,179.285),(9.405,179.435),(9.555,179.435),(9.555,179.285),(9.405,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,179.605),(8.445,179.755),(8.595,179.755),(8.595,179.605),(8.445,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,179.605),(8.765,179.755),(8.915,179.755),(8.915,179.605),(8.765,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,179.605),(9.085,179.755),(9.235,179.755),(9.235,179.605),(9.085,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,179.605),(9.405,179.755),(9.555,179.755),(9.555,179.605),(9.405,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,179.925),(8.445,180.075),(8.595,180.075),(8.595,179.925),(8.445,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,179.925),(8.765,180.075),(8.915,180.075),(8.915,179.925),(8.765,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,179.925),(9.085,180.075),(9.235,180.075),(9.235,179.925),(9.085,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,179.925),(9.405,180.075),(9.555,180.075),(9.555,179.925),(9.405,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,180.245),(8.445,180.395),(8.595,180.395),(8.595,180.245),(8.445,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,180.245),(8.765,180.395),(8.915,180.395),(8.915,180.245),(8.765,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,180.245),(9.085,180.395),(9.235,180.395),(9.235,180.245),(9.085,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,180.245),(9.405,180.395),(9.555,180.395),(9.555,180.245),(9.405,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,180.565),(8.445,180.715),(8.595,180.715),(8.595,180.565),(8.445,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,180.565),(8.765,180.715),(8.915,180.715),(8.915,180.565),(8.765,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,180.565),(9.085,180.715),(9.235,180.715),(9.235,180.565),(9.085,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,180.565),(9.405,180.715),(9.555,180.715),(9.555,180.565),(9.405,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,180.885),(8.445,181.035),(8.595,181.035),(8.595,180.885),(8.445,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,180.885),(8.765,181.035),(8.915,181.035),(8.915,180.885),(8.765,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,180.885),(9.085,181.035),(9.235,181.035),(9.235,180.885),(9.085,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,180.885),(9.405,181.035),(9.555,181.035),(9.555,180.885),(9.405,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,181.205),(8.445,181.355),(8.595,181.355),(8.595,181.205),(8.445,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,181.205),(8.765,181.355),(8.915,181.355),(8.915,181.205),(8.765,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,181.205),(9.085,181.355),(9.235,181.355),(9.235,181.205),(9.085,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,181.205),(9.405,181.355),(9.555,181.355),(9.555,181.205),(9.405,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,181.525),(8.445,181.675),(8.595,181.675),(8.595,181.525),(8.445,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,181.525),(8.765,181.675),(8.915,181.675),(8.915,181.525),(8.765,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,181.525),(9.085,181.675),(9.235,181.675),(9.235,181.525),(9.085,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,181.525),(9.405,181.675),(9.555,181.675),(9.555,181.525),(9.405,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,181.845),(8.445,181.995),(8.595,181.995),(8.595,181.845),(8.445,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,181.845),(8.765,181.995),(8.915,181.995),(8.915,181.845),(8.765,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,181.845),(9.085,181.995),(9.235,181.995),(9.235,181.845),(9.085,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,181.845),(9.405,181.995),(9.555,181.995),(9.555,181.845),(9.405,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,182.165),(8.445,182.315),(8.595,182.315),(8.595,182.165),(8.445,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,182.165),(8.765,182.315),(8.915,182.315),(8.915,182.165),(8.765,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,182.165),(9.085,182.315),(9.235,182.315),(9.235,182.165),(9.085,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,182.165),(9.405,182.315),(9.555,182.315),(9.555,182.165),(9.405,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,182.485),(8.445,182.635),(8.595,182.635),(8.595,182.485),(8.445,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,182.485),(8.765,182.635),(8.915,182.635),(8.915,182.485),(8.765,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,182.485),(9.085,182.635),(9.235,182.635),(9.235,182.485),(9.085,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,182.485),(9.405,182.635),(9.555,182.635),(9.555,182.485),(9.405,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,182.805),(8.445,182.955),(8.595,182.955),(8.595,182.805),(8.445,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,182.805),(8.765,182.955),(8.915,182.955),(8.915,182.805),(8.765,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,182.805),(9.085,182.955),(9.235,182.955),(9.235,182.805),(9.085,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,182.805),(9.405,182.955),(9.555,182.955),(9.555,182.805),(9.405,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,183.125),(8.445,183.275),(8.595,183.275),(8.595,183.125),(8.445,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,183.125),(8.765,183.275),(8.915,183.275),(8.915,183.125),(8.765,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,183.125),(9.085,183.275),(9.235,183.275),(9.235,183.125),(9.085,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,183.125),(9.405,183.275),(9.555,183.275),(9.555,183.125),(9.405,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,183.445),(8.445,183.595),(8.595,183.595),(8.595,183.445),(8.445,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,183.445),(8.765,183.595),(8.915,183.595),(8.915,183.445),(8.765,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,183.445),(9.085,183.595),(9.235,183.595),(9.235,183.445),(9.085,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,183.445),(9.405,183.595),(9.555,183.595),(9.555,183.445),(9.405,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,183.765),(8.445,183.915),(8.595,183.915),(8.595,183.765),(8.445,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,183.765),(8.765,183.915),(8.915,183.915),(8.915,183.765),(8.765,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,183.765),(9.085,183.915),(9.235,183.915),(9.235,183.765),(9.085,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,183.765),(9.405,183.915),(9.555,183.915),(9.555,183.765),(9.405,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,184.085),(8.445,184.235),(8.595,184.235),(8.595,184.085),(8.445,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,184.085),(8.765,184.235),(8.915,184.235),(8.915,184.085),(8.765,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,184.085),(9.085,184.235),(9.235,184.235),(9.235,184.085),(9.085,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,184.085),(9.405,184.235),(9.555,184.235),(9.555,184.085),(9.405,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,184.405),(8.445,184.555),(8.595,184.555),(8.595,184.405),(8.445,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,184.405),(8.765,184.555),(8.915,184.555),(8.915,184.405),(8.765,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,184.405),(9.085,184.555),(9.235,184.555),(9.235,184.405),(9.085,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,184.405),(9.405,184.555),(9.555,184.555),(9.555,184.405),(9.405,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,184.725),(8.445,184.875),(8.595,184.875),(8.595,184.725),(8.445,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,184.725),(8.765,184.875),(8.915,184.875),(8.915,184.725),(8.765,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,184.725),(9.085,184.875),(9.235,184.875),(9.235,184.725),(9.085,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,184.725),(9.405,184.875),(9.555,184.875),(9.555,184.725),(9.405,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,185.045),(8.445,185.195),(8.595,185.195),(8.595,185.045),(8.445,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,185.045),(8.765,185.195),(8.915,185.195),(8.915,185.045),(8.765,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,185.045),(9.085,185.195),(9.235,185.195),(9.235,185.045),(9.085,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,185.045),(9.405,185.195),(9.555,185.195),(9.555,185.045),(9.405,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,185.365),(8.445,185.515),(8.595,185.515),(8.595,185.365),(8.445,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,185.365),(8.765,185.515),(8.915,185.515),(8.915,185.365),(8.765,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,185.365),(9.085,185.515),(9.235,185.515),(9.235,185.365),(9.085,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,185.365),(9.405,185.515),(9.555,185.515),(9.555,185.365),(9.405,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,185.685),(8.445,185.835),(8.595,185.835),(8.595,185.685),(8.445,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,185.685),(8.765,185.835),(8.915,185.835),(8.915,185.685),(8.765,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,185.685),(9.085,185.835),(9.235,185.835),(9.235,185.685),(9.085,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,185.685),(9.405,185.835),(9.555,185.835),(9.555,185.685),(9.405,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,186.005),(8.445,186.155),(8.595,186.155),(8.595,186.005),(8.445,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,186.005),(8.765,186.155),(8.915,186.155),(8.915,186.005),(8.765,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,186.005),(9.085,186.155),(9.235,186.155),(9.235,186.005),(9.085,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,186.005),(9.405,186.155),(9.555,186.155),(9.555,186.005),(9.405,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,186.325),(8.445,186.475),(8.595,186.475),(8.595,186.325),(8.445,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,186.325),(8.765,186.475),(8.915,186.475),(8.915,186.325),(8.765,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,186.325),(9.085,186.475),(9.235,186.475),(9.235,186.325),(9.085,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,186.325),(9.405,186.475),(9.555,186.475),(9.555,186.325),(9.405,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,186.645),(8.445,186.795),(8.595,186.795),(8.595,186.645),(8.445,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,186.645),(8.765,186.795),(8.915,186.795),(8.915,186.645),(8.765,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,186.645),(9.085,186.795),(9.235,186.795),(9.235,186.645),(9.085,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,186.645),(9.405,186.795),(9.555,186.795),(9.555,186.645),(9.405,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,186.965),(8.445,187.115),(8.595,187.115),(8.595,186.965),(8.445,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,186.965),(8.765,187.115),(8.915,187.115),(8.915,186.965),(8.765,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,186.965),(9.085,187.115),(9.235,187.115),(9.235,186.965),(9.085,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,186.965),(9.405,187.115),(9.555,187.115),(9.555,186.965),(9.405,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,187.285),(8.445,187.435),(8.595,187.435),(8.595,187.285),(8.445,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,187.285),(8.765,187.435),(8.915,187.435),(8.915,187.285),(8.765,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,187.285),(9.085,187.435),(9.235,187.435),(9.235,187.285),(9.085,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,187.285),(9.405,187.435),(9.555,187.435),(9.555,187.285),(9.405,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,187.605),(8.445,187.755),(8.595,187.755),(8.595,187.605),(8.445,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,187.605),(8.765,187.755),(8.915,187.755),(8.915,187.605),(8.765,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,187.605),(9.085,187.755),(9.235,187.755),(9.235,187.605),(9.085,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,187.605),(9.405,187.755),(9.555,187.755),(9.555,187.605),(9.405,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,173.845),(32.445,173.995),(32.595,173.995),(32.595,173.845),(32.445,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,173.845),(32.765,173.995),(32.915,173.995),(32.915,173.845),(32.765,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,173.845),(33.085,173.995),(33.235,173.995),(33.235,173.845),(33.085,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,173.845),(33.405,173.995),(33.555,173.995),(33.555,173.845),(33.405,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,174.165),(32.445,174.315),(32.595,174.315),(32.595,174.165),(32.445,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,174.165),(32.765,174.315),(32.915,174.315),(32.915,174.165),(32.765,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,174.165),(33.085,174.315),(33.235,174.315),(33.235,174.165),(33.085,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,174.165),(33.405,174.315),(33.555,174.315),(33.555,174.165),(33.405,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,174.485),(32.445,174.635),(32.595,174.635),(32.595,174.485),(32.445,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,174.485),(32.765,174.635),(32.915,174.635),(32.915,174.485),(32.765,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,174.485),(33.085,174.635),(33.235,174.635),(33.235,174.485),(33.085,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,174.485),(33.405,174.635),(33.555,174.635),(33.555,174.485),(33.405,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,174.805),(32.445,174.955),(32.595,174.955),(32.595,174.805),(32.445,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,174.805),(32.765,174.955),(32.915,174.955),(32.915,174.805),(32.765,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,174.805),(33.085,174.955),(33.235,174.955),(33.235,174.805),(33.085,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,174.805),(33.405,174.955),(33.555,174.955),(33.555,174.805),(33.405,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,175.125),(32.445,175.275),(32.595,175.275),(32.595,175.125),(32.445,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,175.125),(32.765,175.275),(32.915,175.275),(32.915,175.125),(32.765,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,175.125),(33.085,175.275),(33.235,175.275),(33.235,175.125),(33.085,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,175.125),(33.405,175.275),(33.555,175.275),(33.555,175.125),(33.405,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,175.445),(32.445,175.595),(32.595,175.595),(32.595,175.445),(32.445,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,175.445),(32.765,175.595),(32.915,175.595),(32.915,175.445),(32.765,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,175.445),(33.085,175.595),(33.235,175.595),(33.235,175.445),(33.085,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,175.445),(33.405,175.595),(33.555,175.595),(33.555,175.445),(33.405,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,175.765),(32.445,175.915),(32.595,175.915),(32.595,175.765),(32.445,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,175.765),(32.765,175.915),(32.915,175.915),(32.915,175.765),(32.765,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,175.765),(33.085,175.915),(33.235,175.915),(33.235,175.765),(33.085,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,175.765),(33.405,175.915),(33.555,175.915),(33.555,175.765),(33.405,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,176.085),(32.445,176.235),(32.595,176.235),(32.595,176.085),(32.445,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,176.085),(32.765,176.235),(32.915,176.235),(32.915,176.085),(32.765,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,176.085),(33.085,176.235),(33.235,176.235),(33.235,176.085),(33.085,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,176.085),(33.405,176.235),(33.555,176.235),(33.555,176.085),(33.405,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,176.405),(32.445,176.555),(32.595,176.555),(32.595,176.405),(32.445,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,176.405),(32.765,176.555),(32.915,176.555),(32.915,176.405),(32.765,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,176.405),(33.085,176.555),(33.235,176.555),(33.235,176.405),(33.085,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,176.405),(33.405,176.555),(33.555,176.555),(33.555,176.405),(33.405,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,176.725),(32.445,176.875),(32.595,176.875),(32.595,176.725),(32.445,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,176.725),(32.765,176.875),(32.915,176.875),(32.915,176.725),(32.765,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,176.725),(33.085,176.875),(33.235,176.875),(33.235,176.725),(33.085,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,176.725),(33.405,176.875),(33.555,176.875),(33.555,176.725),(33.405,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,177.045),(32.445,177.195),(32.595,177.195),(32.595,177.045),(32.445,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,177.045),(32.765,177.195),(32.915,177.195),(32.915,177.045),(32.765,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,177.045),(33.085,177.195),(33.235,177.195),(33.235,177.045),(33.085,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,177.045),(33.405,177.195),(33.555,177.195),(33.555,177.045),(33.405,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,177.365),(32.445,177.515),(32.595,177.515),(32.595,177.365),(32.445,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,177.365),(32.765,177.515),(32.915,177.515),(32.915,177.365),(32.765,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,177.365),(33.085,177.515),(33.235,177.515),(33.235,177.365),(33.085,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,177.365),(33.405,177.515),(33.555,177.515),(33.555,177.365),(33.405,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,177.685),(32.445,177.835),(32.595,177.835),(32.595,177.685),(32.445,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,177.685),(32.765,177.835),(32.915,177.835),(32.915,177.685),(32.765,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,177.685),(33.085,177.835),(33.235,177.835),(33.235,177.685),(33.085,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,177.685),(33.405,177.835),(33.555,177.835),(33.555,177.685),(33.405,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,178.005),(32.445,178.155),(32.595,178.155),(32.595,178.005),(32.445,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,178.005),(32.765,178.155),(32.915,178.155),(32.915,178.005),(32.765,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,178.005),(33.085,178.155),(33.235,178.155),(33.235,178.005),(33.085,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,178.005),(33.405,178.155),(33.555,178.155),(33.555,178.005),(33.405,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,178.325),(32.445,178.475),(32.595,178.475),(32.595,178.325),(32.445,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,178.325),(32.765,178.475),(32.915,178.475),(32.915,178.325),(32.765,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,178.325),(33.085,178.475),(33.235,178.475),(33.235,178.325),(33.085,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,178.325),(33.405,178.475),(33.555,178.475),(33.555,178.325),(33.405,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,178.645),(32.445,178.795),(32.595,178.795),(32.595,178.645),(32.445,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,178.645),(32.765,178.795),(32.915,178.795),(32.915,178.645),(32.765,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,178.645),(33.085,178.795),(33.235,178.795),(33.235,178.645),(33.085,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,178.645),(33.405,178.795),(33.555,178.795),(33.555,178.645),(33.405,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,178.965),(32.445,179.115),(32.595,179.115),(32.595,178.965),(32.445,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,178.965),(32.765,179.115),(32.915,179.115),(32.915,178.965),(32.765,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,178.965),(33.085,179.115),(33.235,179.115),(33.235,178.965),(33.085,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,178.965),(33.405,179.115),(33.555,179.115),(33.555,178.965),(33.405,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,179.285),(32.445,179.435),(32.595,179.435),(32.595,179.285),(32.445,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,179.285),(32.765,179.435),(32.915,179.435),(32.915,179.285),(32.765,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,179.285),(33.085,179.435),(33.235,179.435),(33.235,179.285),(33.085,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,179.285),(33.405,179.435),(33.555,179.435),(33.555,179.285),(33.405,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,179.605),(32.445,179.755),(32.595,179.755),(32.595,179.605),(32.445,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,179.605),(32.765,179.755),(32.915,179.755),(32.915,179.605),(32.765,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,179.605),(33.085,179.755),(33.235,179.755),(33.235,179.605),(33.085,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,179.605),(33.405,179.755),(33.555,179.755),(33.555,179.605),(33.405,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,179.925),(32.445,180.075),(32.595,180.075),(32.595,179.925),(32.445,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,179.925),(32.765,180.075),(32.915,180.075),(32.915,179.925),(32.765,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,179.925),(33.085,180.075),(33.235,180.075),(33.235,179.925),(33.085,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,179.925),(33.405,180.075),(33.555,180.075),(33.555,179.925),(33.405,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,180.245),(32.445,180.395),(32.595,180.395),(32.595,180.245),(32.445,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,180.245),(32.765,180.395),(32.915,180.395),(32.915,180.245),(32.765,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,180.245),(33.085,180.395),(33.235,180.395),(33.235,180.245),(33.085,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,180.245),(33.405,180.395),(33.555,180.395),(33.555,180.245),(33.405,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,180.565),(32.445,180.715),(32.595,180.715),(32.595,180.565),(32.445,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,180.565),(32.765,180.715),(32.915,180.715),(32.915,180.565),(32.765,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,180.565),(33.085,180.715),(33.235,180.715),(33.235,180.565),(33.085,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,180.565),(33.405,180.715),(33.555,180.715),(33.555,180.565),(33.405,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,180.885),(32.445,181.035),(32.595,181.035),(32.595,180.885),(32.445,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,180.885),(32.765,181.035),(32.915,181.035),(32.915,180.885),(32.765,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,180.885),(33.085,181.035),(33.235,181.035),(33.235,180.885),(33.085,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,180.885),(33.405,181.035),(33.555,181.035),(33.555,180.885),(33.405,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,181.205),(32.445,181.355),(32.595,181.355),(32.595,181.205),(32.445,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,181.205),(32.765,181.355),(32.915,181.355),(32.915,181.205),(32.765,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,181.205),(33.085,181.355),(33.235,181.355),(33.235,181.205),(33.085,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,181.205),(33.405,181.355),(33.555,181.355),(33.555,181.205),(33.405,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,181.525),(32.445,181.675),(32.595,181.675),(32.595,181.525),(32.445,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,181.525),(32.765,181.675),(32.915,181.675),(32.915,181.525),(32.765,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,181.525),(33.085,181.675),(33.235,181.675),(33.235,181.525),(33.085,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,181.525),(33.405,181.675),(33.555,181.675),(33.555,181.525),(33.405,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,181.845),(32.445,181.995),(32.595,181.995),(32.595,181.845),(32.445,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,181.845),(32.765,181.995),(32.915,181.995),(32.915,181.845),(32.765,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,181.845),(33.085,181.995),(33.235,181.995),(33.235,181.845),(33.085,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,181.845),(33.405,181.995),(33.555,181.995),(33.555,181.845),(33.405,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,182.165),(32.445,182.315),(32.595,182.315),(32.595,182.165),(32.445,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,182.165),(32.765,182.315),(32.915,182.315),(32.915,182.165),(32.765,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,182.165),(33.085,182.315),(33.235,182.315),(33.235,182.165),(33.085,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,182.165),(33.405,182.315),(33.555,182.315),(33.555,182.165),(33.405,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,182.485),(32.445,182.635),(32.595,182.635),(32.595,182.485),(32.445,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,182.485),(32.765,182.635),(32.915,182.635),(32.915,182.485),(32.765,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,182.485),(33.085,182.635),(33.235,182.635),(33.235,182.485),(33.085,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,182.485),(33.405,182.635),(33.555,182.635),(33.555,182.485),(33.405,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,182.805),(32.445,182.955),(32.595,182.955),(32.595,182.805),(32.445,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,182.805),(32.765,182.955),(32.915,182.955),(32.915,182.805),(32.765,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,182.805),(33.085,182.955),(33.235,182.955),(33.235,182.805),(33.085,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,182.805),(33.405,182.955),(33.555,182.955),(33.555,182.805),(33.405,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,183.125),(32.445,183.275),(32.595,183.275),(32.595,183.125),(32.445,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,183.125),(32.765,183.275),(32.915,183.275),(32.915,183.125),(32.765,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,183.125),(33.085,183.275),(33.235,183.275),(33.235,183.125),(33.085,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,183.125),(33.405,183.275),(33.555,183.275),(33.555,183.125),(33.405,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,183.445),(32.445,183.595),(32.595,183.595),(32.595,183.445),(32.445,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,183.445),(32.765,183.595),(32.915,183.595),(32.915,183.445),(32.765,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,183.445),(33.085,183.595),(33.235,183.595),(33.235,183.445),(33.085,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,183.445),(33.405,183.595),(33.555,183.595),(33.555,183.445),(33.405,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,183.765),(32.445,183.915),(32.595,183.915),(32.595,183.765),(32.445,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,183.765),(32.765,183.915),(32.915,183.915),(32.915,183.765),(32.765,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,183.765),(33.085,183.915),(33.235,183.915),(33.235,183.765),(33.085,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,183.765),(33.405,183.915),(33.555,183.915),(33.555,183.765),(33.405,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,184.085),(32.445,184.235),(32.595,184.235),(32.595,184.085),(32.445,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,184.085),(32.765,184.235),(32.915,184.235),(32.915,184.085),(32.765,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,184.085),(33.085,184.235),(33.235,184.235),(33.235,184.085),(33.085,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,184.085),(33.405,184.235),(33.555,184.235),(33.555,184.085),(33.405,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,184.405),(32.445,184.555),(32.595,184.555),(32.595,184.405),(32.445,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,184.405),(32.765,184.555),(32.915,184.555),(32.915,184.405),(32.765,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,184.405),(33.085,184.555),(33.235,184.555),(33.235,184.405),(33.085,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,184.405),(33.405,184.555),(33.555,184.555),(33.555,184.405),(33.405,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,184.725),(32.445,184.875),(32.595,184.875),(32.595,184.725),(32.445,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,184.725),(32.765,184.875),(32.915,184.875),(32.915,184.725),(32.765,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,184.725),(33.085,184.875),(33.235,184.875),(33.235,184.725),(33.085,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,184.725),(33.405,184.875),(33.555,184.875),(33.555,184.725),(33.405,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,185.045),(32.445,185.195),(32.595,185.195),(32.595,185.045),(32.445,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,185.045),(32.765,185.195),(32.915,185.195),(32.915,185.045),(32.765,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,185.045),(33.085,185.195),(33.235,185.195),(33.235,185.045),(33.085,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,185.045),(33.405,185.195),(33.555,185.195),(33.555,185.045),(33.405,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,185.365),(32.445,185.515),(32.595,185.515),(32.595,185.365),(32.445,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,185.365),(32.765,185.515),(32.915,185.515),(32.915,185.365),(32.765,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,185.365),(33.085,185.515),(33.235,185.515),(33.235,185.365),(33.085,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,185.365),(33.405,185.515),(33.555,185.515),(33.555,185.365),(33.405,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,185.685),(32.445,185.835),(32.595,185.835),(32.595,185.685),(32.445,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,185.685),(32.765,185.835),(32.915,185.835),(32.915,185.685),(32.765,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,185.685),(33.085,185.835),(33.235,185.835),(33.235,185.685),(33.085,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,185.685),(33.405,185.835),(33.555,185.835),(33.555,185.685),(33.405,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,186.005),(32.445,186.155),(32.595,186.155),(32.595,186.005),(32.445,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,186.005),(32.765,186.155),(32.915,186.155),(32.915,186.005),(32.765,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,186.005),(33.085,186.155),(33.235,186.155),(33.235,186.005),(33.085,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,186.005),(33.405,186.155),(33.555,186.155),(33.555,186.005),(33.405,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,186.325),(32.445,186.475),(32.595,186.475),(32.595,186.325),(32.445,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,186.325),(32.765,186.475),(32.915,186.475),(32.915,186.325),(32.765,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,186.325),(33.085,186.475),(33.235,186.475),(33.235,186.325),(33.085,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,186.325),(33.405,186.475),(33.555,186.475),(33.555,186.325),(33.405,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,186.645),(32.445,186.795),(32.595,186.795),(32.595,186.645),(32.445,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,186.645),(32.765,186.795),(32.915,186.795),(32.915,186.645),(32.765,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,186.645),(33.085,186.795),(33.235,186.795),(33.235,186.645),(33.085,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,186.645),(33.405,186.795),(33.555,186.795),(33.555,186.645),(33.405,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,186.965),(32.445,187.115),(32.595,187.115),(32.595,186.965),(32.445,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,186.965),(32.765,187.115),(32.915,187.115),(32.915,186.965),(32.765,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,186.965),(33.085,187.115),(33.235,187.115),(33.235,186.965),(33.085,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,186.965),(33.405,187.115),(33.555,187.115),(33.555,186.965),(33.405,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,187.285),(32.445,187.435),(32.595,187.435),(32.595,187.285),(32.445,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,187.285),(32.765,187.435),(32.915,187.435),(32.915,187.285),(32.765,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,187.285),(33.085,187.435),(33.235,187.435),(33.235,187.285),(33.085,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,187.285),(33.405,187.435),(33.555,187.435),(33.555,187.285),(33.405,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,187.605),(32.445,187.755),(32.595,187.755),(32.595,187.605),(32.445,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,187.605),(32.765,187.755),(32.915,187.755),(32.915,187.605),(32.765,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,187.605),(33.085,187.755),(33.235,187.755),(33.235,187.605),(33.085,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,187.605),(33.405,187.755),(33.555,187.755),(33.555,187.605),(33.405,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,173.845),(18.045,173.995),(18.195,173.995),(18.195,173.845),(18.045,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,173.845),(18.365,173.995),(18.515,173.995),(18.515,173.845),(18.365,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,173.845),(18.685,173.995),(18.835,173.995),(18.835,173.845),(18.685,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,173.845),(19.005,173.995),(19.155,173.995),(19.155,173.845),(19.005,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,174.165),(18.045,174.315),(18.195,174.315),(18.195,174.165),(18.045,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,174.165),(18.365,174.315),(18.515,174.315),(18.515,174.165),(18.365,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,174.165),(18.685,174.315),(18.835,174.315),(18.835,174.165),(18.685,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,174.165),(19.005,174.315),(19.155,174.315),(19.155,174.165),(19.005,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,174.485),(18.045,174.635),(18.195,174.635),(18.195,174.485),(18.045,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,174.485),(18.365,174.635),(18.515,174.635),(18.515,174.485),(18.365,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,174.485),(18.685,174.635),(18.835,174.635),(18.835,174.485),(18.685,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,174.485),(19.005,174.635),(19.155,174.635),(19.155,174.485),(19.005,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,174.805),(18.045,174.955),(18.195,174.955),(18.195,174.805),(18.045,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,174.805),(18.365,174.955),(18.515,174.955),(18.515,174.805),(18.365,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,174.805),(18.685,174.955),(18.835,174.955),(18.835,174.805),(18.685,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,174.805),(19.005,174.955),(19.155,174.955),(19.155,174.805),(19.005,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,175.125),(18.045,175.275),(18.195,175.275),(18.195,175.125),(18.045,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,175.125),(18.365,175.275),(18.515,175.275),(18.515,175.125),(18.365,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,175.125),(18.685,175.275),(18.835,175.275),(18.835,175.125),(18.685,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,175.125),(19.005,175.275),(19.155,175.275),(19.155,175.125),(19.005,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,175.445),(18.045,175.595),(18.195,175.595),(18.195,175.445),(18.045,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,175.445),(18.365,175.595),(18.515,175.595),(18.515,175.445),(18.365,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,175.445),(18.685,175.595),(18.835,175.595),(18.835,175.445),(18.685,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,175.445),(19.005,175.595),(19.155,175.595),(19.155,175.445),(19.005,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,175.765),(18.045,175.915),(18.195,175.915),(18.195,175.765),(18.045,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,175.765),(18.365,175.915),(18.515,175.915),(18.515,175.765),(18.365,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,175.765),(18.685,175.915),(18.835,175.915),(18.835,175.765),(18.685,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,175.765),(19.005,175.915),(19.155,175.915),(19.155,175.765),(19.005,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,176.085),(18.045,176.235),(18.195,176.235),(18.195,176.085),(18.045,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,176.085),(18.365,176.235),(18.515,176.235),(18.515,176.085),(18.365,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,176.085),(18.685,176.235),(18.835,176.235),(18.835,176.085),(18.685,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,176.085),(19.005,176.235),(19.155,176.235),(19.155,176.085),(19.005,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,176.405),(18.045,176.555),(18.195,176.555),(18.195,176.405),(18.045,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,176.405),(18.365,176.555),(18.515,176.555),(18.515,176.405),(18.365,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,176.405),(18.685,176.555),(18.835,176.555),(18.835,176.405),(18.685,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,176.405),(19.005,176.555),(19.155,176.555),(19.155,176.405),(19.005,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,176.725),(18.045,176.875),(18.195,176.875),(18.195,176.725),(18.045,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,176.725),(18.365,176.875),(18.515,176.875),(18.515,176.725),(18.365,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,176.725),(18.685,176.875),(18.835,176.875),(18.835,176.725),(18.685,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,176.725),(19.005,176.875),(19.155,176.875),(19.155,176.725),(19.005,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,177.045),(18.045,177.195),(18.195,177.195),(18.195,177.045),(18.045,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,177.045),(18.365,177.195),(18.515,177.195),(18.515,177.045),(18.365,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,177.045),(18.685,177.195),(18.835,177.195),(18.835,177.045),(18.685,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,177.045),(19.005,177.195),(19.155,177.195),(19.155,177.045),(19.005,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,177.365),(18.045,177.515),(18.195,177.515),(18.195,177.365),(18.045,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,177.365),(18.365,177.515),(18.515,177.515),(18.515,177.365),(18.365,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,177.365),(18.685,177.515),(18.835,177.515),(18.835,177.365),(18.685,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,177.365),(19.005,177.515),(19.155,177.515),(19.155,177.365),(19.005,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,177.685),(18.045,177.835),(18.195,177.835),(18.195,177.685),(18.045,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,177.685),(18.365,177.835),(18.515,177.835),(18.515,177.685),(18.365,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,177.685),(18.685,177.835),(18.835,177.835),(18.835,177.685),(18.685,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,177.685),(19.005,177.835),(19.155,177.835),(19.155,177.685),(19.005,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,178.005),(18.045,178.155),(18.195,178.155),(18.195,178.005),(18.045,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,178.005),(18.365,178.155),(18.515,178.155),(18.515,178.005),(18.365,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,178.005),(18.685,178.155),(18.835,178.155),(18.835,178.005),(18.685,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,178.005),(19.005,178.155),(19.155,178.155),(19.155,178.005),(19.005,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,178.325),(18.045,178.475),(18.195,178.475),(18.195,178.325),(18.045,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,178.325),(18.365,178.475),(18.515,178.475),(18.515,178.325),(18.365,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,178.325),(18.685,178.475),(18.835,178.475),(18.835,178.325),(18.685,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,178.325),(19.005,178.475),(19.155,178.475),(19.155,178.325),(19.005,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,178.645),(18.045,178.795),(18.195,178.795),(18.195,178.645),(18.045,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,178.645),(18.365,178.795),(18.515,178.795),(18.515,178.645),(18.365,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,178.645),(18.685,178.795),(18.835,178.795),(18.835,178.645),(18.685,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,178.645),(19.005,178.795),(19.155,178.795),(19.155,178.645),(19.005,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,178.965),(18.045,179.115),(18.195,179.115),(18.195,178.965),(18.045,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,178.965),(18.365,179.115),(18.515,179.115),(18.515,178.965),(18.365,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,178.965),(18.685,179.115),(18.835,179.115),(18.835,178.965),(18.685,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,178.965),(19.005,179.115),(19.155,179.115),(19.155,178.965),(19.005,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,179.285),(18.045,179.435),(18.195,179.435),(18.195,179.285),(18.045,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,179.285),(18.365,179.435),(18.515,179.435),(18.515,179.285),(18.365,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,179.285),(18.685,179.435),(18.835,179.435),(18.835,179.285),(18.685,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,179.285),(19.005,179.435),(19.155,179.435),(19.155,179.285),(19.005,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,179.605),(18.045,179.755),(18.195,179.755),(18.195,179.605),(18.045,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,179.605),(18.365,179.755),(18.515,179.755),(18.515,179.605),(18.365,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,179.605),(18.685,179.755),(18.835,179.755),(18.835,179.605),(18.685,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,179.605),(19.005,179.755),(19.155,179.755),(19.155,179.605),(19.005,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,179.925),(18.045,180.075),(18.195,180.075),(18.195,179.925),(18.045,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,179.925),(18.365,180.075),(18.515,180.075),(18.515,179.925),(18.365,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,179.925),(18.685,180.075),(18.835,180.075),(18.835,179.925),(18.685,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,179.925),(19.005,180.075),(19.155,180.075),(19.155,179.925),(19.005,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,180.245),(18.045,180.395),(18.195,180.395),(18.195,180.245),(18.045,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,180.245),(18.365,180.395),(18.515,180.395),(18.515,180.245),(18.365,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,180.245),(18.685,180.395),(18.835,180.395),(18.835,180.245),(18.685,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,180.245),(19.005,180.395),(19.155,180.395),(19.155,180.245),(19.005,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,180.565),(18.045,180.715),(18.195,180.715),(18.195,180.565),(18.045,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,180.565),(18.365,180.715),(18.515,180.715),(18.515,180.565),(18.365,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,180.565),(18.685,180.715),(18.835,180.715),(18.835,180.565),(18.685,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,180.565),(19.005,180.715),(19.155,180.715),(19.155,180.565),(19.005,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,180.885),(18.045,181.035),(18.195,181.035),(18.195,180.885),(18.045,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,180.885),(18.365,181.035),(18.515,181.035),(18.515,180.885),(18.365,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,180.885),(18.685,181.035),(18.835,181.035),(18.835,180.885),(18.685,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,180.885),(19.005,181.035),(19.155,181.035),(19.155,180.885),(19.005,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,181.205),(18.045,181.355),(18.195,181.355),(18.195,181.205),(18.045,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,181.205),(18.365,181.355),(18.515,181.355),(18.515,181.205),(18.365,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,181.205),(18.685,181.355),(18.835,181.355),(18.835,181.205),(18.685,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,181.205),(19.005,181.355),(19.155,181.355),(19.155,181.205),(19.005,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,181.525),(18.045,181.675),(18.195,181.675),(18.195,181.525),(18.045,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,181.525),(18.365,181.675),(18.515,181.675),(18.515,181.525),(18.365,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,181.525),(18.685,181.675),(18.835,181.675),(18.835,181.525),(18.685,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,181.525),(19.005,181.675),(19.155,181.675),(19.155,181.525),(19.005,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,181.845),(18.045,181.995),(18.195,181.995),(18.195,181.845),(18.045,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,181.845),(18.365,181.995),(18.515,181.995),(18.515,181.845),(18.365,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,181.845),(18.685,181.995),(18.835,181.995),(18.835,181.845),(18.685,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,181.845),(19.005,181.995),(19.155,181.995),(19.155,181.845),(19.005,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,182.165),(18.045,182.315),(18.195,182.315),(18.195,182.165),(18.045,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,182.165),(18.365,182.315),(18.515,182.315),(18.515,182.165),(18.365,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,182.165),(18.685,182.315),(18.835,182.315),(18.835,182.165),(18.685,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,182.165),(19.005,182.315),(19.155,182.315),(19.155,182.165),(19.005,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,182.485),(18.045,182.635),(18.195,182.635),(18.195,182.485),(18.045,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,182.485),(18.365,182.635),(18.515,182.635),(18.515,182.485),(18.365,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,182.485),(18.685,182.635),(18.835,182.635),(18.835,182.485),(18.685,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,182.485),(19.005,182.635),(19.155,182.635),(19.155,182.485),(19.005,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,182.805),(18.045,182.955),(18.195,182.955),(18.195,182.805),(18.045,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,182.805),(18.365,182.955),(18.515,182.955),(18.515,182.805),(18.365,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,182.805),(18.685,182.955),(18.835,182.955),(18.835,182.805),(18.685,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,182.805),(19.005,182.955),(19.155,182.955),(19.155,182.805),(19.005,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,183.125),(18.045,183.275),(18.195,183.275),(18.195,183.125),(18.045,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,183.125),(18.365,183.275),(18.515,183.275),(18.515,183.125),(18.365,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,183.125),(18.685,183.275),(18.835,183.275),(18.835,183.125),(18.685,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,183.125),(19.005,183.275),(19.155,183.275),(19.155,183.125),(19.005,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,183.445),(18.045,183.595),(18.195,183.595),(18.195,183.445),(18.045,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,183.445),(18.365,183.595),(18.515,183.595),(18.515,183.445),(18.365,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,183.445),(18.685,183.595),(18.835,183.595),(18.835,183.445),(18.685,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,183.445),(19.005,183.595),(19.155,183.595),(19.155,183.445),(19.005,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,183.765),(18.045,183.915),(18.195,183.915),(18.195,183.765),(18.045,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,183.765),(18.365,183.915),(18.515,183.915),(18.515,183.765),(18.365,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,183.765),(18.685,183.915),(18.835,183.915),(18.835,183.765),(18.685,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,183.765),(19.005,183.915),(19.155,183.915),(19.155,183.765),(19.005,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,184.085),(18.045,184.235),(18.195,184.235),(18.195,184.085),(18.045,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,184.085),(18.365,184.235),(18.515,184.235),(18.515,184.085),(18.365,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,184.085),(18.685,184.235),(18.835,184.235),(18.835,184.085),(18.685,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,184.085),(19.005,184.235),(19.155,184.235),(19.155,184.085),(19.005,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,184.405),(18.045,184.555),(18.195,184.555),(18.195,184.405),(18.045,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,184.405),(18.365,184.555),(18.515,184.555),(18.515,184.405),(18.365,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,184.405),(18.685,184.555),(18.835,184.555),(18.835,184.405),(18.685,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,184.405),(19.005,184.555),(19.155,184.555),(19.155,184.405),(19.005,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,184.725),(18.045,184.875),(18.195,184.875),(18.195,184.725),(18.045,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,184.725),(18.365,184.875),(18.515,184.875),(18.515,184.725),(18.365,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,184.725),(18.685,184.875),(18.835,184.875),(18.835,184.725),(18.685,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,184.725),(19.005,184.875),(19.155,184.875),(19.155,184.725),(19.005,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,185.045),(18.045,185.195),(18.195,185.195),(18.195,185.045),(18.045,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,185.045),(18.365,185.195),(18.515,185.195),(18.515,185.045),(18.365,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,185.045),(18.685,185.195),(18.835,185.195),(18.835,185.045),(18.685,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,185.045),(19.005,185.195),(19.155,185.195),(19.155,185.045),(19.005,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,185.365),(18.045,185.515),(18.195,185.515),(18.195,185.365),(18.045,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,185.365),(18.365,185.515),(18.515,185.515),(18.515,185.365),(18.365,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,185.365),(18.685,185.515),(18.835,185.515),(18.835,185.365),(18.685,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,185.365),(19.005,185.515),(19.155,185.515),(19.155,185.365),(19.005,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,185.685),(18.045,185.835),(18.195,185.835),(18.195,185.685),(18.045,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,185.685),(18.365,185.835),(18.515,185.835),(18.515,185.685),(18.365,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,185.685),(18.685,185.835),(18.835,185.835),(18.835,185.685),(18.685,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,185.685),(19.005,185.835),(19.155,185.835),(19.155,185.685),(19.005,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,186.005),(18.045,186.155),(18.195,186.155),(18.195,186.005),(18.045,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,186.005),(18.365,186.155),(18.515,186.155),(18.515,186.005),(18.365,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,186.005),(18.685,186.155),(18.835,186.155),(18.835,186.005),(18.685,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,186.005),(19.005,186.155),(19.155,186.155),(19.155,186.005),(19.005,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,186.325),(18.045,186.475),(18.195,186.475),(18.195,186.325),(18.045,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,186.325),(18.365,186.475),(18.515,186.475),(18.515,186.325),(18.365,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,186.325),(18.685,186.475),(18.835,186.475),(18.835,186.325),(18.685,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,186.325),(19.005,186.475),(19.155,186.475),(19.155,186.325),(19.005,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,186.645),(18.045,186.795),(18.195,186.795),(18.195,186.645),(18.045,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,186.645),(18.365,186.795),(18.515,186.795),(18.515,186.645),(18.365,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,186.645),(18.685,186.795),(18.835,186.795),(18.835,186.645),(18.685,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,186.645),(19.005,186.795),(19.155,186.795),(19.155,186.645),(19.005,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,186.965),(18.045,187.115),(18.195,187.115),(18.195,186.965),(18.045,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,186.965),(18.365,187.115),(18.515,187.115),(18.515,186.965),(18.365,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,186.965),(18.685,187.115),(18.835,187.115),(18.835,186.965),(18.685,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,186.965),(19.005,187.115),(19.155,187.115),(19.155,186.965),(19.005,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,187.285),(18.045,187.435),(18.195,187.435),(18.195,187.285),(18.045,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,187.285),(18.365,187.435),(18.515,187.435),(18.515,187.285),(18.365,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,187.285),(18.685,187.435),(18.835,187.435),(18.835,187.285),(18.685,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,187.285),(19.005,187.435),(19.155,187.435),(19.155,187.285),(19.005,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,187.605),(18.045,187.755),(18.195,187.755),(18.195,187.605),(18.045,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,187.605),(18.365,187.755),(18.515,187.755),(18.515,187.605),(18.365,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,187.605),(18.685,187.755),(18.835,187.755),(18.835,187.605),(18.685,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,187.605),(19.005,187.755),(19.155,187.755),(19.155,187.605),(19.005,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,173.845),(61.245,173.995),(61.395,173.995),(61.395,173.845),(61.245,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,173.845),(61.565,173.995),(61.715,173.995),(61.715,173.845),(61.565,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,173.845),(61.885,173.995),(62.035,173.995),(62.035,173.845),(61.885,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,173.845),(62.205,173.995),(62.355,173.995),(62.355,173.845),(62.205,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,174.165),(61.245,174.315),(61.395,174.315),(61.395,174.165),(61.245,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,174.165),(61.565,174.315),(61.715,174.315),(61.715,174.165),(61.565,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,174.165),(61.885,174.315),(62.035,174.315),(62.035,174.165),(61.885,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,174.165),(62.205,174.315),(62.355,174.315),(62.355,174.165),(62.205,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,174.485),(61.245,174.635),(61.395,174.635),(61.395,174.485),(61.245,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,174.485),(61.565,174.635),(61.715,174.635),(61.715,174.485),(61.565,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,174.485),(61.885,174.635),(62.035,174.635),(62.035,174.485),(61.885,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,174.485),(62.205,174.635),(62.355,174.635),(62.355,174.485),(62.205,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,174.805),(61.245,174.955),(61.395,174.955),(61.395,174.805),(61.245,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,174.805),(61.565,174.955),(61.715,174.955),(61.715,174.805),(61.565,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,174.805),(61.885,174.955),(62.035,174.955),(62.035,174.805),(61.885,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,174.805),(62.205,174.955),(62.355,174.955),(62.355,174.805),(62.205,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,175.125),(61.245,175.275),(61.395,175.275),(61.395,175.125),(61.245,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,175.125),(61.565,175.275),(61.715,175.275),(61.715,175.125),(61.565,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,175.125),(61.885,175.275),(62.035,175.275),(62.035,175.125),(61.885,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,175.125),(62.205,175.275),(62.355,175.275),(62.355,175.125),(62.205,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,175.445),(61.245,175.595),(61.395,175.595),(61.395,175.445),(61.245,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,175.445),(61.565,175.595),(61.715,175.595),(61.715,175.445),(61.565,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,175.445),(61.885,175.595),(62.035,175.595),(62.035,175.445),(61.885,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,175.445),(62.205,175.595),(62.355,175.595),(62.355,175.445),(62.205,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,175.765),(61.245,175.915),(61.395,175.915),(61.395,175.765),(61.245,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,175.765),(61.565,175.915),(61.715,175.915),(61.715,175.765),(61.565,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,175.765),(61.885,175.915),(62.035,175.915),(62.035,175.765),(61.885,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,175.765),(62.205,175.915),(62.355,175.915),(62.355,175.765),(62.205,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,176.085),(61.245,176.235),(61.395,176.235),(61.395,176.085),(61.245,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,176.085),(61.565,176.235),(61.715,176.235),(61.715,176.085),(61.565,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,176.085),(61.885,176.235),(62.035,176.235),(62.035,176.085),(61.885,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,176.085),(62.205,176.235),(62.355,176.235),(62.355,176.085),(62.205,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,176.405),(61.245,176.555),(61.395,176.555),(61.395,176.405),(61.245,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,176.405),(61.565,176.555),(61.715,176.555),(61.715,176.405),(61.565,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,176.405),(61.885,176.555),(62.035,176.555),(62.035,176.405),(61.885,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,176.405),(62.205,176.555),(62.355,176.555),(62.355,176.405),(62.205,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,176.725),(61.245,176.875),(61.395,176.875),(61.395,176.725),(61.245,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,176.725),(61.565,176.875),(61.715,176.875),(61.715,176.725),(61.565,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,176.725),(61.885,176.875),(62.035,176.875),(62.035,176.725),(61.885,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,176.725),(62.205,176.875),(62.355,176.875),(62.355,176.725),(62.205,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,177.045),(61.245,177.195),(61.395,177.195),(61.395,177.045),(61.245,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,177.045),(61.565,177.195),(61.715,177.195),(61.715,177.045),(61.565,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,177.045),(61.885,177.195),(62.035,177.195),(62.035,177.045),(61.885,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,177.045),(62.205,177.195),(62.355,177.195),(62.355,177.045),(62.205,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,177.365),(61.245,177.515),(61.395,177.515),(61.395,177.365),(61.245,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,177.365),(61.565,177.515),(61.715,177.515),(61.715,177.365),(61.565,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,177.365),(61.885,177.515),(62.035,177.515),(62.035,177.365),(61.885,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,177.365),(62.205,177.515),(62.355,177.515),(62.355,177.365),(62.205,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,177.685),(61.245,177.835),(61.395,177.835),(61.395,177.685),(61.245,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,177.685),(61.565,177.835),(61.715,177.835),(61.715,177.685),(61.565,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,177.685),(61.885,177.835),(62.035,177.835),(62.035,177.685),(61.885,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,177.685),(62.205,177.835),(62.355,177.835),(62.355,177.685),(62.205,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,178.005),(61.245,178.155),(61.395,178.155),(61.395,178.005),(61.245,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,178.005),(61.565,178.155),(61.715,178.155),(61.715,178.005),(61.565,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,178.005),(61.885,178.155),(62.035,178.155),(62.035,178.005),(61.885,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,178.005),(62.205,178.155),(62.355,178.155),(62.355,178.005),(62.205,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,178.325),(61.245,178.475),(61.395,178.475),(61.395,178.325),(61.245,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,178.325),(61.565,178.475),(61.715,178.475),(61.715,178.325),(61.565,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,178.325),(61.885,178.475),(62.035,178.475),(62.035,178.325),(61.885,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,178.325),(62.205,178.475),(62.355,178.475),(62.355,178.325),(62.205,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,178.645),(61.245,178.795),(61.395,178.795),(61.395,178.645),(61.245,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,178.645),(61.565,178.795),(61.715,178.795),(61.715,178.645),(61.565,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,178.645),(61.885,178.795),(62.035,178.795),(62.035,178.645),(61.885,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,178.645),(62.205,178.795),(62.355,178.795),(62.355,178.645),(62.205,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,178.965),(61.245,179.115),(61.395,179.115),(61.395,178.965),(61.245,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,178.965),(61.565,179.115),(61.715,179.115),(61.715,178.965),(61.565,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,178.965),(61.885,179.115),(62.035,179.115),(62.035,178.965),(61.885,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,178.965),(62.205,179.115),(62.355,179.115),(62.355,178.965),(62.205,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,179.285),(61.245,179.435),(61.395,179.435),(61.395,179.285),(61.245,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,179.285),(61.565,179.435),(61.715,179.435),(61.715,179.285),(61.565,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,179.285),(61.885,179.435),(62.035,179.435),(62.035,179.285),(61.885,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,179.285),(62.205,179.435),(62.355,179.435),(62.355,179.285),(62.205,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,179.605),(61.245,179.755),(61.395,179.755),(61.395,179.605),(61.245,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,179.605),(61.565,179.755),(61.715,179.755),(61.715,179.605),(61.565,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,179.605),(61.885,179.755),(62.035,179.755),(62.035,179.605),(61.885,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,179.605),(62.205,179.755),(62.355,179.755),(62.355,179.605),(62.205,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,179.925),(61.245,180.075),(61.395,180.075),(61.395,179.925),(61.245,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,179.925),(61.565,180.075),(61.715,180.075),(61.715,179.925),(61.565,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,179.925),(61.885,180.075),(62.035,180.075),(62.035,179.925),(61.885,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,179.925),(62.205,180.075),(62.355,180.075),(62.355,179.925),(62.205,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,180.245),(61.245,180.395),(61.395,180.395),(61.395,180.245),(61.245,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,180.245),(61.565,180.395),(61.715,180.395),(61.715,180.245),(61.565,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,180.245),(61.885,180.395),(62.035,180.395),(62.035,180.245),(61.885,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,180.245),(62.205,180.395),(62.355,180.395),(62.355,180.245),(62.205,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,180.565),(61.245,180.715),(61.395,180.715),(61.395,180.565),(61.245,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,180.565),(61.565,180.715),(61.715,180.715),(61.715,180.565),(61.565,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,180.565),(61.885,180.715),(62.035,180.715),(62.035,180.565),(61.885,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,180.565),(62.205,180.715),(62.355,180.715),(62.355,180.565),(62.205,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,180.885),(61.245,181.035),(61.395,181.035),(61.395,180.885),(61.245,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,180.885),(61.565,181.035),(61.715,181.035),(61.715,180.885),(61.565,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,180.885),(61.885,181.035),(62.035,181.035),(62.035,180.885),(61.885,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,180.885),(62.205,181.035),(62.355,181.035),(62.355,180.885),(62.205,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,181.205),(61.245,181.355),(61.395,181.355),(61.395,181.205),(61.245,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,181.205),(61.565,181.355),(61.715,181.355),(61.715,181.205),(61.565,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,181.205),(61.885,181.355),(62.035,181.355),(62.035,181.205),(61.885,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,181.205),(62.205,181.355),(62.355,181.355),(62.355,181.205),(62.205,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,181.525),(61.245,181.675),(61.395,181.675),(61.395,181.525),(61.245,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,181.525),(61.565,181.675),(61.715,181.675),(61.715,181.525),(61.565,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,181.525),(61.885,181.675),(62.035,181.675),(62.035,181.525),(61.885,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,181.525),(62.205,181.675),(62.355,181.675),(62.355,181.525),(62.205,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,181.845),(61.245,181.995),(61.395,181.995),(61.395,181.845),(61.245,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,181.845),(61.565,181.995),(61.715,181.995),(61.715,181.845),(61.565,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,181.845),(61.885,181.995),(62.035,181.995),(62.035,181.845),(61.885,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,181.845),(62.205,181.995),(62.355,181.995),(62.355,181.845),(62.205,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,182.165),(61.245,182.315),(61.395,182.315),(61.395,182.165),(61.245,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,182.165),(61.565,182.315),(61.715,182.315),(61.715,182.165),(61.565,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,182.165),(61.885,182.315),(62.035,182.315),(62.035,182.165),(61.885,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,182.165),(62.205,182.315),(62.355,182.315),(62.355,182.165),(62.205,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,182.485),(61.245,182.635),(61.395,182.635),(61.395,182.485),(61.245,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,182.485),(61.565,182.635),(61.715,182.635),(61.715,182.485),(61.565,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,182.485),(61.885,182.635),(62.035,182.635),(62.035,182.485),(61.885,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,182.485),(62.205,182.635),(62.355,182.635),(62.355,182.485),(62.205,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,182.805),(61.245,182.955),(61.395,182.955),(61.395,182.805),(61.245,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,182.805),(61.565,182.955),(61.715,182.955),(61.715,182.805),(61.565,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,182.805),(61.885,182.955),(62.035,182.955),(62.035,182.805),(61.885,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,182.805),(62.205,182.955),(62.355,182.955),(62.355,182.805),(62.205,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,183.125),(61.245,183.275),(61.395,183.275),(61.395,183.125),(61.245,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,183.125),(61.565,183.275),(61.715,183.275),(61.715,183.125),(61.565,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,183.125),(61.885,183.275),(62.035,183.275),(62.035,183.125),(61.885,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,183.125),(62.205,183.275),(62.355,183.275),(62.355,183.125),(62.205,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,183.445),(61.245,183.595),(61.395,183.595),(61.395,183.445),(61.245,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,183.445),(61.565,183.595),(61.715,183.595),(61.715,183.445),(61.565,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,183.445),(61.885,183.595),(62.035,183.595),(62.035,183.445),(61.885,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,183.445),(62.205,183.595),(62.355,183.595),(62.355,183.445),(62.205,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,183.765),(61.245,183.915),(61.395,183.915),(61.395,183.765),(61.245,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,183.765),(61.565,183.915),(61.715,183.915),(61.715,183.765),(61.565,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,183.765),(61.885,183.915),(62.035,183.915),(62.035,183.765),(61.885,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,183.765),(62.205,183.915),(62.355,183.915),(62.355,183.765),(62.205,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,184.085),(61.245,184.235),(61.395,184.235),(61.395,184.085),(61.245,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,184.085),(61.565,184.235),(61.715,184.235),(61.715,184.085),(61.565,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,184.085),(61.885,184.235),(62.035,184.235),(62.035,184.085),(61.885,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,184.085),(62.205,184.235),(62.355,184.235),(62.355,184.085),(62.205,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,184.405),(61.245,184.555),(61.395,184.555),(61.395,184.405),(61.245,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,184.405),(61.565,184.555),(61.715,184.555),(61.715,184.405),(61.565,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,184.405),(61.885,184.555),(62.035,184.555),(62.035,184.405),(61.885,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,184.405),(62.205,184.555),(62.355,184.555),(62.355,184.405),(62.205,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,184.725),(61.245,184.875),(61.395,184.875),(61.395,184.725),(61.245,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,184.725),(61.565,184.875),(61.715,184.875),(61.715,184.725),(61.565,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,184.725),(61.885,184.875),(62.035,184.875),(62.035,184.725),(61.885,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,184.725),(62.205,184.875),(62.355,184.875),(62.355,184.725),(62.205,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,185.045),(61.245,185.195),(61.395,185.195),(61.395,185.045),(61.245,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,185.045),(61.565,185.195),(61.715,185.195),(61.715,185.045),(61.565,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,185.045),(61.885,185.195),(62.035,185.195),(62.035,185.045),(61.885,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,185.045),(62.205,185.195),(62.355,185.195),(62.355,185.045),(62.205,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,185.365),(61.245,185.515),(61.395,185.515),(61.395,185.365),(61.245,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,185.365),(61.565,185.515),(61.715,185.515),(61.715,185.365),(61.565,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,185.365),(61.885,185.515),(62.035,185.515),(62.035,185.365),(61.885,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,185.365),(62.205,185.515),(62.355,185.515),(62.355,185.365),(62.205,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,185.685),(61.245,185.835),(61.395,185.835),(61.395,185.685),(61.245,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,185.685),(61.565,185.835),(61.715,185.835),(61.715,185.685),(61.565,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,185.685),(61.885,185.835),(62.035,185.835),(62.035,185.685),(61.885,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,185.685),(62.205,185.835),(62.355,185.835),(62.355,185.685),(62.205,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,186.005),(61.245,186.155),(61.395,186.155),(61.395,186.005),(61.245,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,186.005),(61.565,186.155),(61.715,186.155),(61.715,186.005),(61.565,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,186.005),(61.885,186.155),(62.035,186.155),(62.035,186.005),(61.885,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,186.005),(62.205,186.155),(62.355,186.155),(62.355,186.005),(62.205,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,186.325),(61.245,186.475),(61.395,186.475),(61.395,186.325),(61.245,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,186.325),(61.565,186.475),(61.715,186.475),(61.715,186.325),(61.565,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,186.325),(61.885,186.475),(62.035,186.475),(62.035,186.325),(61.885,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,186.325),(62.205,186.475),(62.355,186.475),(62.355,186.325),(62.205,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,186.645),(61.245,186.795),(61.395,186.795),(61.395,186.645),(61.245,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,186.645),(61.565,186.795),(61.715,186.795),(61.715,186.645),(61.565,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,186.645),(61.885,186.795),(62.035,186.795),(62.035,186.645),(61.885,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,186.645),(62.205,186.795),(62.355,186.795),(62.355,186.645),(62.205,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,186.965),(61.245,187.115),(61.395,187.115),(61.395,186.965),(61.245,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,186.965),(61.565,187.115),(61.715,187.115),(61.715,186.965),(61.565,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,186.965),(61.885,187.115),(62.035,187.115),(62.035,186.965),(61.885,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,186.965),(62.205,187.115),(62.355,187.115),(62.355,186.965),(62.205,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,187.285),(61.245,187.435),(61.395,187.435),(61.395,187.285),(61.245,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,187.285),(61.565,187.435),(61.715,187.435),(61.715,187.285),(61.565,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,187.285),(61.885,187.435),(62.035,187.435),(62.035,187.285),(61.885,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,187.285),(62.205,187.435),(62.355,187.435),(62.355,187.285),(62.205,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,187.605),(61.245,187.755),(61.395,187.755),(61.395,187.605),(61.245,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,187.605),(61.565,187.755),(61.715,187.755),(61.715,187.605),(61.565,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,187.605),(61.885,187.755),(62.035,187.755),(62.035,187.605),(61.885,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,187.605),(62.205,187.755),(62.355,187.755),(62.355,187.605),(62.205,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,173.845),(22.845,173.995),(22.995,173.995),(22.995,173.845),(22.845,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,173.845),(23.165,173.995),(23.315,173.995),(23.315,173.845),(23.165,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,173.845),(23.485,173.995),(23.635,173.995),(23.635,173.845),(23.485,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,173.845),(23.805,173.995),(23.955,173.995),(23.955,173.845),(23.805,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,174.165),(22.845,174.315),(22.995,174.315),(22.995,174.165),(22.845,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,174.165),(23.165,174.315),(23.315,174.315),(23.315,174.165),(23.165,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,174.165),(23.485,174.315),(23.635,174.315),(23.635,174.165),(23.485,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,174.165),(23.805,174.315),(23.955,174.315),(23.955,174.165),(23.805,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,174.485),(22.845,174.635),(22.995,174.635),(22.995,174.485),(22.845,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,174.485),(23.165,174.635),(23.315,174.635),(23.315,174.485),(23.165,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,174.485),(23.485,174.635),(23.635,174.635),(23.635,174.485),(23.485,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,174.485),(23.805,174.635),(23.955,174.635),(23.955,174.485),(23.805,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,174.805),(22.845,174.955),(22.995,174.955),(22.995,174.805),(22.845,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,174.805),(23.165,174.955),(23.315,174.955),(23.315,174.805),(23.165,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,174.805),(23.485,174.955),(23.635,174.955),(23.635,174.805),(23.485,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,174.805),(23.805,174.955),(23.955,174.955),(23.955,174.805),(23.805,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,175.125),(22.845,175.275),(22.995,175.275),(22.995,175.125),(22.845,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,175.125),(23.165,175.275),(23.315,175.275),(23.315,175.125),(23.165,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,175.125),(23.485,175.275),(23.635,175.275),(23.635,175.125),(23.485,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,175.125),(23.805,175.275),(23.955,175.275),(23.955,175.125),(23.805,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,175.445),(22.845,175.595),(22.995,175.595),(22.995,175.445),(22.845,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,175.445),(23.165,175.595),(23.315,175.595),(23.315,175.445),(23.165,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,175.445),(23.485,175.595),(23.635,175.595),(23.635,175.445),(23.485,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,175.445),(23.805,175.595),(23.955,175.595),(23.955,175.445),(23.805,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,175.765),(22.845,175.915),(22.995,175.915),(22.995,175.765),(22.845,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,175.765),(23.165,175.915),(23.315,175.915),(23.315,175.765),(23.165,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,175.765),(23.485,175.915),(23.635,175.915),(23.635,175.765),(23.485,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,175.765),(23.805,175.915),(23.955,175.915),(23.955,175.765),(23.805,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,176.085),(22.845,176.235),(22.995,176.235),(22.995,176.085),(22.845,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,176.085),(23.165,176.235),(23.315,176.235),(23.315,176.085),(23.165,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,176.085),(23.485,176.235),(23.635,176.235),(23.635,176.085),(23.485,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,176.085),(23.805,176.235),(23.955,176.235),(23.955,176.085),(23.805,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,176.405),(22.845,176.555),(22.995,176.555),(22.995,176.405),(22.845,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,176.405),(23.165,176.555),(23.315,176.555),(23.315,176.405),(23.165,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,176.405),(23.485,176.555),(23.635,176.555),(23.635,176.405),(23.485,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,176.405),(23.805,176.555),(23.955,176.555),(23.955,176.405),(23.805,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,176.725),(22.845,176.875),(22.995,176.875),(22.995,176.725),(22.845,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,176.725),(23.165,176.875),(23.315,176.875),(23.315,176.725),(23.165,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,176.725),(23.485,176.875),(23.635,176.875),(23.635,176.725),(23.485,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,176.725),(23.805,176.875),(23.955,176.875),(23.955,176.725),(23.805,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,177.045),(22.845,177.195),(22.995,177.195),(22.995,177.045),(22.845,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,177.045),(23.165,177.195),(23.315,177.195),(23.315,177.045),(23.165,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,177.045),(23.485,177.195),(23.635,177.195),(23.635,177.045),(23.485,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,177.045),(23.805,177.195),(23.955,177.195),(23.955,177.045),(23.805,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,177.365),(22.845,177.515),(22.995,177.515),(22.995,177.365),(22.845,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,177.365),(23.165,177.515),(23.315,177.515),(23.315,177.365),(23.165,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,177.365),(23.485,177.515),(23.635,177.515),(23.635,177.365),(23.485,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,177.365),(23.805,177.515),(23.955,177.515),(23.955,177.365),(23.805,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,177.685),(22.845,177.835),(22.995,177.835),(22.995,177.685),(22.845,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,177.685),(23.165,177.835),(23.315,177.835),(23.315,177.685),(23.165,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,177.685),(23.485,177.835),(23.635,177.835),(23.635,177.685),(23.485,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,177.685),(23.805,177.835),(23.955,177.835),(23.955,177.685),(23.805,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,178.005),(22.845,178.155),(22.995,178.155),(22.995,178.005),(22.845,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,178.005),(23.165,178.155),(23.315,178.155),(23.315,178.005),(23.165,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,178.005),(23.485,178.155),(23.635,178.155),(23.635,178.005),(23.485,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,178.005),(23.805,178.155),(23.955,178.155),(23.955,178.005),(23.805,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,178.325),(22.845,178.475),(22.995,178.475),(22.995,178.325),(22.845,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,178.325),(23.165,178.475),(23.315,178.475),(23.315,178.325),(23.165,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,178.325),(23.485,178.475),(23.635,178.475),(23.635,178.325),(23.485,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,178.325),(23.805,178.475),(23.955,178.475),(23.955,178.325),(23.805,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,178.645),(22.845,178.795),(22.995,178.795),(22.995,178.645),(22.845,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,178.645),(23.165,178.795),(23.315,178.795),(23.315,178.645),(23.165,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,178.645),(23.485,178.795),(23.635,178.795),(23.635,178.645),(23.485,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,178.645),(23.805,178.795),(23.955,178.795),(23.955,178.645),(23.805,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,178.965),(22.845,179.115),(22.995,179.115),(22.995,178.965),(22.845,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,178.965),(23.165,179.115),(23.315,179.115),(23.315,178.965),(23.165,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,178.965),(23.485,179.115),(23.635,179.115),(23.635,178.965),(23.485,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,178.965),(23.805,179.115),(23.955,179.115),(23.955,178.965),(23.805,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,179.285),(22.845,179.435),(22.995,179.435),(22.995,179.285),(22.845,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,179.285),(23.165,179.435),(23.315,179.435),(23.315,179.285),(23.165,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,179.285),(23.485,179.435),(23.635,179.435),(23.635,179.285),(23.485,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,179.285),(23.805,179.435),(23.955,179.435),(23.955,179.285),(23.805,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,179.605),(22.845,179.755),(22.995,179.755),(22.995,179.605),(22.845,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,179.605),(23.165,179.755),(23.315,179.755),(23.315,179.605),(23.165,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,179.605),(23.485,179.755),(23.635,179.755),(23.635,179.605),(23.485,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,179.605),(23.805,179.755),(23.955,179.755),(23.955,179.605),(23.805,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,179.925),(22.845,180.075),(22.995,180.075),(22.995,179.925),(22.845,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,179.925),(23.165,180.075),(23.315,180.075),(23.315,179.925),(23.165,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,179.925),(23.485,180.075),(23.635,180.075),(23.635,179.925),(23.485,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,179.925),(23.805,180.075),(23.955,180.075),(23.955,179.925),(23.805,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,180.245),(22.845,180.395),(22.995,180.395),(22.995,180.245),(22.845,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,180.245),(23.165,180.395),(23.315,180.395),(23.315,180.245),(23.165,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,180.245),(23.485,180.395),(23.635,180.395),(23.635,180.245),(23.485,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,180.245),(23.805,180.395),(23.955,180.395),(23.955,180.245),(23.805,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,180.565),(22.845,180.715),(22.995,180.715),(22.995,180.565),(22.845,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,180.565),(23.165,180.715),(23.315,180.715),(23.315,180.565),(23.165,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,180.565),(23.485,180.715),(23.635,180.715),(23.635,180.565),(23.485,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,180.565),(23.805,180.715),(23.955,180.715),(23.955,180.565),(23.805,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,180.885),(22.845,181.035),(22.995,181.035),(22.995,180.885),(22.845,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,180.885),(23.165,181.035),(23.315,181.035),(23.315,180.885),(23.165,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,180.885),(23.485,181.035),(23.635,181.035),(23.635,180.885),(23.485,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,180.885),(23.805,181.035),(23.955,181.035),(23.955,180.885),(23.805,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,181.205),(22.845,181.355),(22.995,181.355),(22.995,181.205),(22.845,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,181.205),(23.165,181.355),(23.315,181.355),(23.315,181.205),(23.165,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,181.205),(23.485,181.355),(23.635,181.355),(23.635,181.205),(23.485,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,181.205),(23.805,181.355),(23.955,181.355),(23.955,181.205),(23.805,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,181.525),(22.845,181.675),(22.995,181.675),(22.995,181.525),(22.845,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,181.525),(23.165,181.675),(23.315,181.675),(23.315,181.525),(23.165,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,181.525),(23.485,181.675),(23.635,181.675),(23.635,181.525),(23.485,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,181.525),(23.805,181.675),(23.955,181.675),(23.955,181.525),(23.805,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,181.845),(22.845,181.995),(22.995,181.995),(22.995,181.845),(22.845,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,181.845),(23.165,181.995),(23.315,181.995),(23.315,181.845),(23.165,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,181.845),(23.485,181.995),(23.635,181.995),(23.635,181.845),(23.485,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,181.845),(23.805,181.995),(23.955,181.995),(23.955,181.845),(23.805,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,182.165),(22.845,182.315),(22.995,182.315),(22.995,182.165),(22.845,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,182.165),(23.165,182.315),(23.315,182.315),(23.315,182.165),(23.165,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,182.165),(23.485,182.315),(23.635,182.315),(23.635,182.165),(23.485,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,182.165),(23.805,182.315),(23.955,182.315),(23.955,182.165),(23.805,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,182.485),(22.845,182.635),(22.995,182.635),(22.995,182.485),(22.845,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,182.485),(23.165,182.635),(23.315,182.635),(23.315,182.485),(23.165,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,182.485),(23.485,182.635),(23.635,182.635),(23.635,182.485),(23.485,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,182.485),(23.805,182.635),(23.955,182.635),(23.955,182.485),(23.805,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,182.805),(22.845,182.955),(22.995,182.955),(22.995,182.805),(22.845,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,182.805),(23.165,182.955),(23.315,182.955),(23.315,182.805),(23.165,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,182.805),(23.485,182.955),(23.635,182.955),(23.635,182.805),(23.485,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,182.805),(23.805,182.955),(23.955,182.955),(23.955,182.805),(23.805,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,183.125),(22.845,183.275),(22.995,183.275),(22.995,183.125),(22.845,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,183.125),(23.165,183.275),(23.315,183.275),(23.315,183.125),(23.165,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,183.125),(23.485,183.275),(23.635,183.275),(23.635,183.125),(23.485,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,183.125),(23.805,183.275),(23.955,183.275),(23.955,183.125),(23.805,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,183.445),(22.845,183.595),(22.995,183.595),(22.995,183.445),(22.845,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,183.445),(23.165,183.595),(23.315,183.595),(23.315,183.445),(23.165,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,183.445),(23.485,183.595),(23.635,183.595),(23.635,183.445),(23.485,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,183.445),(23.805,183.595),(23.955,183.595),(23.955,183.445),(23.805,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,183.765),(22.845,183.915),(22.995,183.915),(22.995,183.765),(22.845,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,183.765),(23.165,183.915),(23.315,183.915),(23.315,183.765),(23.165,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,183.765),(23.485,183.915),(23.635,183.915),(23.635,183.765),(23.485,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,183.765),(23.805,183.915),(23.955,183.915),(23.955,183.765),(23.805,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,184.085),(22.845,184.235),(22.995,184.235),(22.995,184.085),(22.845,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,184.085),(23.165,184.235),(23.315,184.235),(23.315,184.085),(23.165,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,184.085),(23.485,184.235),(23.635,184.235),(23.635,184.085),(23.485,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,184.085),(23.805,184.235),(23.955,184.235),(23.955,184.085),(23.805,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,184.405),(22.845,184.555),(22.995,184.555),(22.995,184.405),(22.845,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,184.405),(23.165,184.555),(23.315,184.555),(23.315,184.405),(23.165,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,184.405),(23.485,184.555),(23.635,184.555),(23.635,184.405),(23.485,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,184.405),(23.805,184.555),(23.955,184.555),(23.955,184.405),(23.805,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,184.725),(22.845,184.875),(22.995,184.875),(22.995,184.725),(22.845,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,184.725),(23.165,184.875),(23.315,184.875),(23.315,184.725),(23.165,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,184.725),(23.485,184.875),(23.635,184.875),(23.635,184.725),(23.485,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,184.725),(23.805,184.875),(23.955,184.875),(23.955,184.725),(23.805,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,185.045),(22.845,185.195),(22.995,185.195),(22.995,185.045),(22.845,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,185.045),(23.165,185.195),(23.315,185.195),(23.315,185.045),(23.165,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,185.045),(23.485,185.195),(23.635,185.195),(23.635,185.045),(23.485,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,185.045),(23.805,185.195),(23.955,185.195),(23.955,185.045),(23.805,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,185.365),(22.845,185.515),(22.995,185.515),(22.995,185.365),(22.845,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,185.365),(23.165,185.515),(23.315,185.515),(23.315,185.365),(23.165,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,185.365),(23.485,185.515),(23.635,185.515),(23.635,185.365),(23.485,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,185.365),(23.805,185.515),(23.955,185.515),(23.955,185.365),(23.805,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,185.685),(22.845,185.835),(22.995,185.835),(22.995,185.685),(22.845,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,185.685),(23.165,185.835),(23.315,185.835),(23.315,185.685),(23.165,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,185.685),(23.485,185.835),(23.635,185.835),(23.635,185.685),(23.485,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,185.685),(23.805,185.835),(23.955,185.835),(23.955,185.685),(23.805,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,186.005),(22.845,186.155),(22.995,186.155),(22.995,186.005),(22.845,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,186.005),(23.165,186.155),(23.315,186.155),(23.315,186.005),(23.165,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,186.005),(23.485,186.155),(23.635,186.155),(23.635,186.005),(23.485,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,186.005),(23.805,186.155),(23.955,186.155),(23.955,186.005),(23.805,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,186.325),(22.845,186.475),(22.995,186.475),(22.995,186.325),(22.845,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,186.325),(23.165,186.475),(23.315,186.475),(23.315,186.325),(23.165,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,186.325),(23.485,186.475),(23.635,186.475),(23.635,186.325),(23.485,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,186.325),(23.805,186.475),(23.955,186.475),(23.955,186.325),(23.805,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,186.645),(22.845,186.795),(22.995,186.795),(22.995,186.645),(22.845,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,186.645),(23.165,186.795),(23.315,186.795),(23.315,186.645),(23.165,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,186.645),(23.485,186.795),(23.635,186.795),(23.635,186.645),(23.485,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,186.645),(23.805,186.795),(23.955,186.795),(23.955,186.645),(23.805,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,186.965),(22.845,187.115),(22.995,187.115),(22.995,186.965),(22.845,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,186.965),(23.165,187.115),(23.315,187.115),(23.315,186.965),(23.165,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,186.965),(23.485,187.115),(23.635,187.115),(23.635,186.965),(23.485,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,186.965),(23.805,187.115),(23.955,187.115),(23.955,186.965),(23.805,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,187.285),(22.845,187.435),(22.995,187.435),(22.995,187.285),(22.845,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,187.285),(23.165,187.435),(23.315,187.435),(23.315,187.285),(23.165,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,187.285),(23.485,187.435),(23.635,187.435),(23.635,187.285),(23.485,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,187.285),(23.805,187.435),(23.955,187.435),(23.955,187.285),(23.805,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,187.605),(22.845,187.755),(22.995,187.755),(22.995,187.605),(22.845,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,187.605),(23.165,187.755),(23.315,187.755),(23.315,187.605),(23.165,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,187.605),(23.485,187.755),(23.635,187.755),(23.635,187.605),(23.485,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,187.605),(23.805,187.755),(23.955,187.755),(23.955,187.605),(23.805,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,173.845),(42.045,173.995),(42.195,173.995),(42.195,173.845),(42.045,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,173.845),(42.365,173.995),(42.515,173.995),(42.515,173.845),(42.365,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,173.845),(42.685,173.995),(42.835,173.995),(42.835,173.845),(42.685,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,173.845),(43.005,173.995),(43.155,173.995),(43.155,173.845),(43.005,173.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,174.165),(42.045,174.315),(42.195,174.315),(42.195,174.165),(42.045,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,174.165),(42.365,174.315),(42.515,174.315),(42.515,174.165),(42.365,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,174.165),(42.685,174.315),(42.835,174.315),(42.835,174.165),(42.685,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,174.165),(43.005,174.315),(43.155,174.315),(43.155,174.165),(43.005,174.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,174.485),(42.045,174.635),(42.195,174.635),(42.195,174.485),(42.045,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,174.485),(42.365,174.635),(42.515,174.635),(42.515,174.485),(42.365,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,174.485),(42.685,174.635),(42.835,174.635),(42.835,174.485),(42.685,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,174.485),(43.005,174.635),(43.155,174.635),(43.155,174.485),(43.005,174.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,174.805),(42.045,174.955),(42.195,174.955),(42.195,174.805),(42.045,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,174.805),(42.365,174.955),(42.515,174.955),(42.515,174.805),(42.365,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,174.805),(42.685,174.955),(42.835,174.955),(42.835,174.805),(42.685,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,174.805),(43.005,174.955),(43.155,174.955),(43.155,174.805),(43.005,174.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,175.125),(42.045,175.275),(42.195,175.275),(42.195,175.125),(42.045,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,175.125),(42.365,175.275),(42.515,175.275),(42.515,175.125),(42.365,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,175.125),(42.685,175.275),(42.835,175.275),(42.835,175.125),(42.685,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,175.125),(43.005,175.275),(43.155,175.275),(43.155,175.125),(43.005,175.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,175.445),(42.045,175.595),(42.195,175.595),(42.195,175.445),(42.045,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,175.445),(42.365,175.595),(42.515,175.595),(42.515,175.445),(42.365,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,175.445),(42.685,175.595),(42.835,175.595),(42.835,175.445),(42.685,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,175.445),(43.005,175.595),(43.155,175.595),(43.155,175.445),(43.005,175.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,175.765),(42.045,175.915),(42.195,175.915),(42.195,175.765),(42.045,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,175.765),(42.365,175.915),(42.515,175.915),(42.515,175.765),(42.365,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,175.765),(42.685,175.915),(42.835,175.915),(42.835,175.765),(42.685,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,175.765),(43.005,175.915),(43.155,175.915),(43.155,175.765),(43.005,175.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,176.085),(42.045,176.235),(42.195,176.235),(42.195,176.085),(42.045,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,176.085),(42.365,176.235),(42.515,176.235),(42.515,176.085),(42.365,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,176.085),(42.685,176.235),(42.835,176.235),(42.835,176.085),(42.685,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,176.085),(43.005,176.235),(43.155,176.235),(43.155,176.085),(43.005,176.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,176.405),(42.045,176.555),(42.195,176.555),(42.195,176.405),(42.045,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,176.405),(42.365,176.555),(42.515,176.555),(42.515,176.405),(42.365,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,176.405),(42.685,176.555),(42.835,176.555),(42.835,176.405),(42.685,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,176.405),(43.005,176.555),(43.155,176.555),(43.155,176.405),(43.005,176.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,176.725),(42.045,176.875),(42.195,176.875),(42.195,176.725),(42.045,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,176.725),(42.365,176.875),(42.515,176.875),(42.515,176.725),(42.365,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,176.725),(42.685,176.875),(42.835,176.875),(42.835,176.725),(42.685,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,176.725),(43.005,176.875),(43.155,176.875),(43.155,176.725),(43.005,176.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,177.045),(42.045,177.195),(42.195,177.195),(42.195,177.045),(42.045,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,177.045),(42.365,177.195),(42.515,177.195),(42.515,177.045),(42.365,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,177.045),(42.685,177.195),(42.835,177.195),(42.835,177.045),(42.685,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,177.045),(43.005,177.195),(43.155,177.195),(43.155,177.045),(43.005,177.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,177.365),(42.045,177.515),(42.195,177.515),(42.195,177.365),(42.045,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,177.365),(42.365,177.515),(42.515,177.515),(42.515,177.365),(42.365,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,177.365),(42.685,177.515),(42.835,177.515),(42.835,177.365),(42.685,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,177.365),(43.005,177.515),(43.155,177.515),(43.155,177.365),(43.005,177.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,177.685),(42.045,177.835),(42.195,177.835),(42.195,177.685),(42.045,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,177.685),(42.365,177.835),(42.515,177.835),(42.515,177.685),(42.365,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,177.685),(42.685,177.835),(42.835,177.835),(42.835,177.685),(42.685,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,177.685),(43.005,177.835),(43.155,177.835),(43.155,177.685),(43.005,177.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,178.005),(42.045,178.155),(42.195,178.155),(42.195,178.005),(42.045,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,178.005),(42.365,178.155),(42.515,178.155),(42.515,178.005),(42.365,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,178.005),(42.685,178.155),(42.835,178.155),(42.835,178.005),(42.685,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,178.005),(43.005,178.155),(43.155,178.155),(43.155,178.005),(43.005,178.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,178.325),(42.045,178.475),(42.195,178.475),(42.195,178.325),(42.045,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,178.325),(42.365,178.475),(42.515,178.475),(42.515,178.325),(42.365,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,178.325),(42.685,178.475),(42.835,178.475),(42.835,178.325),(42.685,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,178.325),(43.005,178.475),(43.155,178.475),(43.155,178.325),(43.005,178.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,178.645),(42.045,178.795),(42.195,178.795),(42.195,178.645),(42.045,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,178.645),(42.365,178.795),(42.515,178.795),(42.515,178.645),(42.365,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,178.645),(42.685,178.795),(42.835,178.795),(42.835,178.645),(42.685,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,178.645),(43.005,178.795),(43.155,178.795),(43.155,178.645),(43.005,178.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,178.965),(42.045,179.115),(42.195,179.115),(42.195,178.965),(42.045,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,178.965),(42.365,179.115),(42.515,179.115),(42.515,178.965),(42.365,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,178.965),(42.685,179.115),(42.835,179.115),(42.835,178.965),(42.685,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,178.965),(43.005,179.115),(43.155,179.115),(43.155,178.965),(43.005,178.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,179.285),(42.045,179.435),(42.195,179.435),(42.195,179.285),(42.045,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,179.285),(42.365,179.435),(42.515,179.435),(42.515,179.285),(42.365,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,179.285),(42.685,179.435),(42.835,179.435),(42.835,179.285),(42.685,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,179.285),(43.005,179.435),(43.155,179.435),(43.155,179.285),(43.005,179.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,179.605),(42.045,179.755),(42.195,179.755),(42.195,179.605),(42.045,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,179.605),(42.365,179.755),(42.515,179.755),(42.515,179.605),(42.365,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,179.605),(42.685,179.755),(42.835,179.755),(42.835,179.605),(42.685,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,179.605),(43.005,179.755),(43.155,179.755),(43.155,179.605),(43.005,179.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,179.925),(42.045,180.075),(42.195,180.075),(42.195,179.925),(42.045,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,179.925),(42.365,180.075),(42.515,180.075),(42.515,179.925),(42.365,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,179.925),(42.685,180.075),(42.835,180.075),(42.835,179.925),(42.685,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,179.925),(43.005,180.075),(43.155,180.075),(43.155,179.925),(43.005,179.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,180.245),(42.045,180.395),(42.195,180.395),(42.195,180.245),(42.045,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,180.245),(42.365,180.395),(42.515,180.395),(42.515,180.245),(42.365,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,180.245),(42.685,180.395),(42.835,180.395),(42.835,180.245),(42.685,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,180.245),(43.005,180.395),(43.155,180.395),(43.155,180.245),(43.005,180.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,180.565),(42.045,180.715),(42.195,180.715),(42.195,180.565),(42.045,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,180.565),(42.365,180.715),(42.515,180.715),(42.515,180.565),(42.365,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,180.565),(42.685,180.715),(42.835,180.715),(42.835,180.565),(42.685,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,180.565),(43.005,180.715),(43.155,180.715),(43.155,180.565),(43.005,180.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,180.885),(42.045,181.035),(42.195,181.035),(42.195,180.885),(42.045,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,180.885),(42.365,181.035),(42.515,181.035),(42.515,180.885),(42.365,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,180.885),(42.685,181.035),(42.835,181.035),(42.835,180.885),(42.685,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,180.885),(43.005,181.035),(43.155,181.035),(43.155,180.885),(43.005,180.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,181.205),(42.045,181.355),(42.195,181.355),(42.195,181.205),(42.045,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,181.205),(42.365,181.355),(42.515,181.355),(42.515,181.205),(42.365,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,181.205),(42.685,181.355),(42.835,181.355),(42.835,181.205),(42.685,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,181.205),(43.005,181.355),(43.155,181.355),(43.155,181.205),(43.005,181.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,181.525),(42.045,181.675),(42.195,181.675),(42.195,181.525),(42.045,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,181.525),(42.365,181.675),(42.515,181.675),(42.515,181.525),(42.365,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,181.525),(42.685,181.675),(42.835,181.675),(42.835,181.525),(42.685,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,181.525),(43.005,181.675),(43.155,181.675),(43.155,181.525),(43.005,181.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,181.845),(42.045,181.995),(42.195,181.995),(42.195,181.845),(42.045,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,181.845),(42.365,181.995),(42.515,181.995),(42.515,181.845),(42.365,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,181.845),(42.685,181.995),(42.835,181.995),(42.835,181.845),(42.685,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,181.845),(43.005,181.995),(43.155,181.995),(43.155,181.845),(43.005,181.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,182.165),(42.045,182.315),(42.195,182.315),(42.195,182.165),(42.045,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,182.165),(42.365,182.315),(42.515,182.315),(42.515,182.165),(42.365,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,182.165),(42.685,182.315),(42.835,182.315),(42.835,182.165),(42.685,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,182.165),(43.005,182.315),(43.155,182.315),(43.155,182.165),(43.005,182.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,182.485),(42.045,182.635),(42.195,182.635),(42.195,182.485),(42.045,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,182.485),(42.365,182.635),(42.515,182.635),(42.515,182.485),(42.365,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,182.485),(42.685,182.635),(42.835,182.635),(42.835,182.485),(42.685,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,182.485),(43.005,182.635),(43.155,182.635),(43.155,182.485),(43.005,182.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,182.805),(42.045,182.955),(42.195,182.955),(42.195,182.805),(42.045,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,182.805),(42.365,182.955),(42.515,182.955),(42.515,182.805),(42.365,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,182.805),(42.685,182.955),(42.835,182.955),(42.835,182.805),(42.685,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,182.805),(43.005,182.955),(43.155,182.955),(43.155,182.805),(43.005,182.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,183.125),(42.045,183.275),(42.195,183.275),(42.195,183.125),(42.045,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,183.125),(42.365,183.275),(42.515,183.275),(42.515,183.125),(42.365,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,183.125),(42.685,183.275),(42.835,183.275),(42.835,183.125),(42.685,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,183.125),(43.005,183.275),(43.155,183.275),(43.155,183.125),(43.005,183.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,183.445),(42.045,183.595),(42.195,183.595),(42.195,183.445),(42.045,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,183.445),(42.365,183.595),(42.515,183.595),(42.515,183.445),(42.365,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,183.445),(42.685,183.595),(42.835,183.595),(42.835,183.445),(42.685,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,183.445),(43.005,183.595),(43.155,183.595),(43.155,183.445),(43.005,183.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,183.765),(42.045,183.915),(42.195,183.915),(42.195,183.765),(42.045,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,183.765),(42.365,183.915),(42.515,183.915),(42.515,183.765),(42.365,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,183.765),(42.685,183.915),(42.835,183.915),(42.835,183.765),(42.685,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,183.765),(43.005,183.915),(43.155,183.915),(43.155,183.765),(43.005,183.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,184.085),(42.045,184.235),(42.195,184.235),(42.195,184.085),(42.045,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,184.085),(42.365,184.235),(42.515,184.235),(42.515,184.085),(42.365,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,184.085),(42.685,184.235),(42.835,184.235),(42.835,184.085),(42.685,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,184.085),(43.005,184.235),(43.155,184.235),(43.155,184.085),(43.005,184.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,184.405),(42.045,184.555),(42.195,184.555),(42.195,184.405),(42.045,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,184.405),(42.365,184.555),(42.515,184.555),(42.515,184.405),(42.365,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,184.405),(42.685,184.555),(42.835,184.555),(42.835,184.405),(42.685,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,184.405),(43.005,184.555),(43.155,184.555),(43.155,184.405),(43.005,184.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,184.725),(42.045,184.875),(42.195,184.875),(42.195,184.725),(42.045,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,184.725),(42.365,184.875),(42.515,184.875),(42.515,184.725),(42.365,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,184.725),(42.685,184.875),(42.835,184.875),(42.835,184.725),(42.685,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,184.725),(43.005,184.875),(43.155,184.875),(43.155,184.725),(43.005,184.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,185.045),(42.045,185.195),(42.195,185.195),(42.195,185.045),(42.045,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,185.045),(42.365,185.195),(42.515,185.195),(42.515,185.045),(42.365,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,185.045),(42.685,185.195),(42.835,185.195),(42.835,185.045),(42.685,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,185.045),(43.005,185.195),(43.155,185.195),(43.155,185.045),(43.005,185.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,185.365),(42.045,185.515),(42.195,185.515),(42.195,185.365),(42.045,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,185.365),(42.365,185.515),(42.515,185.515),(42.515,185.365),(42.365,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,185.365),(42.685,185.515),(42.835,185.515),(42.835,185.365),(42.685,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,185.365),(43.005,185.515),(43.155,185.515),(43.155,185.365),(43.005,185.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,185.685),(42.045,185.835),(42.195,185.835),(42.195,185.685),(42.045,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,185.685),(42.365,185.835),(42.515,185.835),(42.515,185.685),(42.365,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,185.685),(42.685,185.835),(42.835,185.835),(42.835,185.685),(42.685,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,185.685),(43.005,185.835),(43.155,185.835),(43.155,185.685),(43.005,185.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,186.005),(42.045,186.155),(42.195,186.155),(42.195,186.005),(42.045,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,186.005),(42.365,186.155),(42.515,186.155),(42.515,186.005),(42.365,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,186.005),(42.685,186.155),(42.835,186.155),(42.835,186.005),(42.685,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,186.005),(43.005,186.155),(43.155,186.155),(43.155,186.005),(43.005,186.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,186.325),(42.045,186.475),(42.195,186.475),(42.195,186.325),(42.045,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,186.325),(42.365,186.475),(42.515,186.475),(42.515,186.325),(42.365,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,186.325),(42.685,186.475),(42.835,186.475),(42.835,186.325),(42.685,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,186.325),(43.005,186.475),(43.155,186.475),(43.155,186.325),(43.005,186.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,186.645),(42.045,186.795),(42.195,186.795),(42.195,186.645),(42.045,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,186.645),(42.365,186.795),(42.515,186.795),(42.515,186.645),(42.365,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,186.645),(42.685,186.795),(42.835,186.795),(42.835,186.645),(42.685,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,186.645),(43.005,186.795),(43.155,186.795),(43.155,186.645),(43.005,186.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,186.965),(42.045,187.115),(42.195,187.115),(42.195,186.965),(42.045,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,186.965),(42.365,187.115),(42.515,187.115),(42.515,186.965),(42.365,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,186.965),(42.685,187.115),(42.835,187.115),(42.835,186.965),(42.685,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,186.965),(43.005,187.115),(43.155,187.115),(43.155,186.965),(43.005,186.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,187.285),(42.045,187.435),(42.195,187.435),(42.195,187.285),(42.045,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,187.285),(42.365,187.435),(42.515,187.435),(42.515,187.285),(42.365,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,187.285),(42.685,187.435),(42.835,187.435),(42.835,187.285),(42.685,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,187.285),(43.005,187.435),(43.155,187.435),(43.155,187.285),(43.005,187.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,187.605),(42.045,187.755),(42.195,187.755),(42.195,187.605),(42.045,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,187.605),(42.365,187.755),(42.515,187.755),(42.515,187.605),(42.365,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,187.605),(42.685,187.755),(42.835,187.755),(42.835,187.605),(42.685,187.605)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,187.605),(43.005,187.755),(43.155,187.755),(43.155,187.605),(43.005,187.605)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N0D']
        except:
            subcell = af.getCell('Clamp_N32N0D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N0D']
        except:
            subcell = af.getCell('Clamp_P32N0D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadIn']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'pad': Net.create(cell, 'pad'),
            's': Net.create(cell, 's'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((85.61,88.09),(85.61,88.26),(86.14,88.26),(86.14,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.61,88.09),(85.61,88.26),(85.78,88.26),(85.78,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.97,88.09),(85.97,88.26),(86.14,88.26),(86.14,88.09),(85.97,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,91.365),(16.315,91.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,88.3),(16.315,88.3),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.77,88.03),(6.77,88.32),(7.0,88.32),(7.0,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,130.265),(11.515,130.265),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.915,88.03),(68.915,88.32),(69.145,88.32),(69.145,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,133.04),(25.915,133.04),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.515,88.03),(78.515,88.32),(78.745,88.32),(78.745,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,131.365),(78.715,131.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,130.265),(35.515,130.265),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.315,88.03),(35.315,88.32),(35.545,88.32),(35.545,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,130.265),(69.115,130.265),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,88.3),(45.115,88.3),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.915,88.03),(44.915,88.32),(45.145,88.32),(45.145,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,131.365),(83.26,131.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,132.98),(83.275,132.98),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,91.365),(83.26,91.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,133.04),(59.515,133.04),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,130.265),(21.115,130.265),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,131.365),(73.915,131.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,88.3),(69.115,88.3),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,132.98),(73.93,132.98),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,131.365),(54.715,131.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,91.365),(73.915,91.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,88.3),(11.515,88.3),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,130.265),(16.315,130.265),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,88.3),(21.115,88.3),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,132.98),(16.33,132.98),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,131.365),(6.97,131.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,88.3),(35.515,88.3),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,133.04),(49.915,133.04),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,130.265),(45.115,130.265),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.58,88.03),(85.58,88.32),(86.17,88.32),(86.17,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,132.98),(30.73,132.98),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.715,88.03),(49.715,88.32),(49.945,88.32),(49.945,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.915,88.03),(20.915,88.32),(21.145,88.32),(21.145,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,131.365),(11.515,131.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,132.98),(11.53,132.98),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,130.265),(25.915,130.265),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.315,88.03),(11.315,88.32),(11.545,88.32),(11.545,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.06,88.03),(83.06,88.32),(83.29,88.32),(83.29,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((16.115,88.03),(16.115,88.32),(16.345,88.32),(16.345,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,132.98),(78.73,132.98),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,131.365),(35.515,131.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,91.365),(49.915,91.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,133.04),(69.115,133.04),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,91.365),(45.115,91.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,132.98),(35.53,132.98),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,130.265),(40.315,130.265),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,133.04),(83.26,133.04),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.715,88.03),(73.715,88.32),(73.945,88.32),(73.945,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,88.3),(83.26,88.3),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,132.98),(40.33,132.98),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,130.265),(59.515,130.265),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,133.04),(21.115,133.04),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,91.365),(69.115,91.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,133.04),(73.915,133.04),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,132.98),(54.73,132.98),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.715,88.03),(25.715,88.32),(25.945,88.32),(25.945,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,91.365),(25.915,91.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,88.3),(73.915,88.3),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.115,88.03),(64.115,88.32),(64.345,88.32),(64.345,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,131.365),(16.315,131.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,91.365),(21.115,91.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,91.365),(59.515,91.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,133.04),(16.315,133.04),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,132.98),(6.985,132.98),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,130.265),(64.315,130.265),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,133.04),(45.115,133.04),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,130.265),(49.915,130.265),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,132.98),(64.33,132.98),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,91.365),(86.14,91.365),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,133.04),(30.715,133.04),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,91.365),(64.315,91.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,130.265),(30.715,130.265),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,88.3),(64.315,88.3),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.515,88.03),(30.515,88.32),(30.745,88.32),(30.745,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.115,88.03),(40.115,88.32),(40.345,88.32),(40.345,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,133.04),(11.515,133.04),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.315,88.03),(59.315,88.32),(59.545,88.32),(59.545,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,131.365),(25.915,131.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,132.98),(25.93,132.98),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,91.365),(54.715,91.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,88.3),(54.715,88.3),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,132.98),(69.13,132.98),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,88.3),(49.915,88.3),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,133.04),(78.715,133.04),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,130.265),(78.715,130.265),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,133.04),(35.515,133.04),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,131.365),(69.115,131.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,131.365),(40.315,131.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,130.265),(83.26,130.265),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,91.365),(40.315,91.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,133.04),(40.315,133.04),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,91.365),(6.97,91.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,88.3),(40.315,88.3),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,131.365),(59.515,131.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,88.3),(6.97,88.3),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,132.98),(59.53,132.98),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,132.98),(21.13,132.98),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,131.365),(21.115,131.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,91.365),(78.715,91.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,130.265),(73.915,130.265),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,88.3),(78.715,88.3),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.515,88.03),(54.515,88.32),(54.745,88.32),(54.745,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,133.04),(54.715,133.04),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,88.3),(25.915,88.3),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,130.265),(54.715,130.265),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,91.365),(11.515,91.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,88.3),(59.515,88.3),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,133.04),(6.97,133.04),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,130.265),(6.97,130.265),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,131.365),(64.315,131.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,91.365),(35.515,91.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,132.98),(45.13,132.98),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,131.365),(49.915,131.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,133.04),(64.315,133.04),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,131.365),(45.115,131.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,91.365),(30.715,91.365),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,132.98),(49.93,132.98),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,88.3),(30.715,88.3),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,131.365),(30.715,131.365),(30.715,87.93),(30.485,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((32.345,19.415),(32.345,24.32),(33.655,24.32),(33.655,19.415),(32.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,92.175),(81.655,92.175),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,92.175),(33.655,92.175),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,19.415),(65.945,24.32),(67.255,24.32),(67.255,19.415),(65.945,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,22.34),(17.945,24.32),(19.255,24.32),(19.255,22.34),(17.945,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,22.34),(46.745,24.32),(48.055,24.32),(48.055,22.34),(46.745,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,22.34),(61.145,24.32),(62.455,24.32),(62.455,22.34),(61.145,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,92.175),(24.055,92.175),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,22.34),(51.545,24.32),(52.855,24.32),(52.855,22.34),(51.545,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,92.175),(28.855,92.175),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((45.895,156.325),(45.895,156.695),(47.115,156.695),(47.115,156.325),(45.895,156.325)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,19.415),(41.945,24.32),(43.255,24.32),(43.255,19.415),(41.945,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,22.34),(41.945,24.32),(43.255,24.32),(43.255,22.34),(41.945,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,22.34),(80.345,24.32),(81.655,24.32),(81.655,22.34),(80.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,19.415),(61.145,24.32),(62.455,24.32),(62.455,19.415),(61.145,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,22.34),(32.345,24.32),(33.655,24.32),(33.655,22.34),(32.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,92.175),(38.455,92.175),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,92.175),(19.255,92.175),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,92.175),(48.055,92.175),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,92.175),(57.655,92.175),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,92.175),(52.855,92.175),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,19.415),(80.345,24.32),(81.655,24.32),(81.655,19.415),(80.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,92.175),(43.255,92.175),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,19.415),(13.145,24.32),(14.455,24.32),(14.455,19.415),(13.145,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,19.415),(17.945,24.32),(19.255,24.32),(19.255,19.415),(17.945,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,22.34),(65.945,24.32),(67.255,24.32),(67.255,22.34),(65.945,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,19.415),(70.745,24.32),(72.055,24.32),(72.055,19.415),(70.745,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,19.415),(46.745,24.32),(48.055,24.32),(48.055,19.415),(46.745,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,22.34),(37.145,24.32),(38.455,24.32),(38.455,22.34),(37.145,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,19.415),(8.345,24.32),(9.655,24.32),(9.655,19.415),(8.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,22.34),(70.745,24.32),(72.055,24.32),(72.055,22.34),(70.745,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,92.175),(14.455,92.175),(14.455,86.32),(13.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,22.34),(75.545,24.32),(76.855,24.32),(76.855,22.34),(75.545,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,19.415),(75.545,24.32),(76.855,24.32),(76.855,19.415),(75.545,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,19.415),(51.545,24.32),(52.855,24.32),(52.855,19.415),(51.545,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,92.175),(9.655,92.175),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,22.34),(56.345,24.32),(57.655,24.32),(57.655,22.34),(56.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,92.175),(76.855,92.175),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,19.415),(37.145,24.32),(38.455,24.32),(38.455,19.415),(37.145,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,92.175),(62.455,92.175),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,19.415),(22.745,24.32),(24.055,24.32),(24.055,19.415),(22.745,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,22.34),(22.745,24.32),(24.055,24.32),(24.055,22.34),(22.745,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,22.34),(13.145,24.32),(14.455,24.32),(14.455,22.34),(13.145,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,19.415),(56.345,24.32),(57.655,24.32),(57.655,19.415),(56.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,92.175),(67.255,92.175),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,92.175),(72.055,92.175),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,22.34),(27.545,24.32),(28.855,24.32),(28.855,22.34),(27.545,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,19.415),(27.545,24.32),(28.855,24.32),(28.855,19.415),(27.545,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,22.34),(8.345,24.32),(9.655,24.32),(9.655,22.34),(8.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,133.04),(46.745,156.695),(48.055,156.695),(48.055,133.04),(46.745,133.04)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        net = nets['s']
        createRL(
            tech, net, 'li',
            ((44.745,171.95),(44.745,176.505),(44.915,176.505),(44.915,171.95),(44.745,171.95)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,171.985),(44.745,172.155),(44.915,172.155),(44.915,171.985),(44.745,171.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,172.345),(44.745,172.515),(44.915,172.515),(44.915,172.345),(44.745,172.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,172.705),(44.745,172.875),(44.915,172.875),(44.915,172.705),(44.745,172.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,173.065),(44.745,173.235),(44.915,173.235),(44.915,173.065),(44.745,173.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,173.425),(44.745,173.595),(44.915,173.595),(44.915,173.425),(44.745,173.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,173.785),(44.745,173.955),(44.915,173.955),(44.915,173.785),(44.745,173.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,174.145),(44.745,174.315),(44.915,174.315),(44.915,174.145),(44.745,174.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,174.505),(44.745,174.675),(44.915,174.675),(44.915,174.505),(44.745,174.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,174.865),(44.745,175.035),(44.915,175.035),(44.915,174.865),(44.745,174.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,175.225),(44.745,175.395),(44.915,175.395),(44.915,175.225),(44.745,175.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,175.585),(44.745,175.755),(44.915,175.755),(44.915,175.585),(44.745,175.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,175.945),(44.745,176.115),(44.915,176.115),(44.915,175.945),(44.745,175.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.745,176.305),(44.745,176.475),(44.915,176.475),(44.915,176.305),(44.745,176.305)),
        )
        createRL(
            tech, net, 'm1',
            ((44.685,171.955),(44.685,188.0),(44.975,188.0),(44.975,171.955),(44.685,171.955)),
        )
        createRL(
            tech, net, 'm1',
            ((44.685,171.955),(44.685,176.505),(44.975,176.505),(44.975,171.955),(44.685,171.955)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(44.83), u(0.29), u(171.955), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(44.83), u(0.29), u(171.955), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['s'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N0D']
        except:
            subcell = af.getCell('Clamp_N32N0D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N0D']
        except:
            subcell = af.getCell('Clamp_P32N0D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['LevelDown']
        except:
            subcell = af.getCell('LevelDown', 0)
        trans = Transformation(
            u(44.74), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'leveldown', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadOut']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'd': Net.create(cell, 'd'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'ngate': Net.create(cell, 'ngate'),
            'pad': Net.create(cell, 'pad'),
            'pgate': Net.create(cell, 'pgate'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((85.61,88.09),(85.61,88.26),(86.14,88.26),(86.14,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.61,88.09),(85.61,88.26),(85.78,88.26),(85.78,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.97,88.09),(85.97,88.26),(86.14,88.26),(86.14,88.09),(85.97,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.715,88.03),(25.715,88.32),(25.945,88.32),(25.945,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.77,88.03),(6.77,88.32),(7.0,88.32),(7.0,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.115,88.03),(64.115,88.32),(64.345,88.32),(64.345,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.58,88.03),(85.58,88.32),(86.17,88.32),(86.17,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.715,88.03),(49.715,88.32),(49.945,88.32),(49.945,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.915,88.03),(68.915,88.32),(69.145,88.32),(69.145,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.515,88.03),(78.515,88.32),(78.745,88.32),(78.745,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.515,88.03),(54.515,88.32),(54.745,88.32),(54.745,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.315,88.03),(35.315,88.32),(35.545,88.32),(35.545,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.915,88.03),(44.915,88.32),(45.145,88.32),(45.145,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.915,88.03),(20.915,88.32),(21.145,88.32),(21.145,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.315,88.03),(11.315,88.32),(11.545,88.32),(11.545,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.115,88.03),(16.115,88.32),(16.345,88.32),(16.345,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.06,88.03),(83.06,88.32),(83.29,88.32),(83.29,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.515,88.03),(30.515,88.32),(30.745,88.32),(30.745,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.115,88.03),(40.115,88.32),(40.345,88.32),(40.345,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.715,88.03),(73.715,88.32),(73.945,88.32),(73.945,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.315,88.03),(59.315,88.32),(59.545,88.32),(59.545,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,133.04),(48.055,133.04),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,133.04),(43.255,133.04),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,133.04),(76.855,133.04),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,133.04),(62.455,133.04),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,133.04),(19.255,133.04),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,133.04),(28.855,133.04),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,133.04),(72.055,133.04),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,133.04),(81.655,133.04),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,133.04),(33.655,133.04),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,133.04),(57.655,133.04),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,133.04),(52.855,133.04),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,133.04),(38.455,133.04),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,133.04),(67.255,133.04),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,133.04),(24.055,133.04),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,133.04),(9.655,133.04),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,133.04),(14.455,133.04),(14.455,86.32),(13.145,86.32)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        net = nets['d']
        createRL(
            tech, net, 'm1',
            ((43.165,171.925),(43.165,188.0),(46.835,188.0),(46.835,171.925),(43.165,171.925)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(45.0), u(3.67), u(171.925), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(45.0), u(3.67), u(171.925), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['pgate']
        createRL(
            tech, net, 'm1',
            ((48.56,133.32),(48.56,163.675),(48.79,163.675),(48.79,133.32),(48.56,133.32)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,133.32),(4.04,133.69),(48.79,133.69),(48.79,133.32),(4.04,133.32)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,133.04),(4.04,133.69),(4.27,133.69),(4.27,133.04),(4.04,133.04)),
        )
        net = nets['ngate']
        createRL(
            tech, net, 'm1',
            ((0.3,21.97),(0.3,22.34),(4.04,22.34),(4.04,21.97),(0.3,21.97)),
        )
        createRL(
            tech, net, 'm1',
            ((45.12,133.97),(45.12,163.675),(45.35,163.675),(45.35,133.97),(45.12,133.97)),
        )
        createRL(
            tech, net, 'm1',
            ((0.3,21.97),(0.3,134.34),(0.67,134.34),(0.67,21.97),(0.3,21.97)),
        )
        createRL(
            tech, net, 'm1',
            ((0.3,133.97),(0.3,134.34),(45.35,134.34),(45.35,133.97),(0.3,133.97)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['d'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N4D']
        except:
            subcell = af.getCell('Clamp_N32N4D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N4D']
        except:
            subcell = af.getCell('Clamp_P32N4D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GateLevelUp']
        except:
            subcell = af.getCell('GateLevelUp', 0)
        trans = Transformation(
            u(42.07), u(178.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'gatelu', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Clamp_N32N4D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(22.34),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'gate': Net.create(cell, 'gate'),
            'iovss': Net.create(cell, 'iovss'),
            'off': Net.create(cell, 'off'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((59.05,2.72),(59.05,19.62),(59.75,19.62),(59.75,2.72),(59.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.55,2.72),(16.55,19.62),(16.87,19.62),(16.87,2.72),(16.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.835,2.72),(74.835,19.62),(75.435,19.62),(75.435,2.72),(74.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.965,2.72),(67.965,19.62),(68.215,19.62),(68.215,2.72),(67.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.25,2.72),(78.25,19.62),(78.95,19.62),(78.95,2.72),(78.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.585,2.72),(74.585,19.62),(74.835,19.62),(74.835,2.72),(74.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.235,2.72),(65.235,19.62),(65.835,19.62),(65.835,2.72),(65.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,2.72),(39.415,19.62),(40.87,19.62),(40.87,2.72),(39.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(40.985,19.62),(40.985,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.85,2.72),(39.85,19.62),(40.55,19.62),(40.55,2.72),(39.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(54.25,19.62),(54.25,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.165,2.72),(24.165,19.62),(24.765,19.62),(24.765,2.72),(24.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.165,2.72),(39.165,19.62),(39.415,19.62),(39.415,2.72),(39.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.165,2.72),(63.165,19.62),(63.415,19.62),(63.415,2.72),(63.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(44.65,19.62),(44.65,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,19.62),(31.385,19.62),(31.385,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,2.72),(54.25,19.62),(54.95,19.62),(54.95,2.72),(54.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.815,2.72),(29.815,19.62),(31.27,19.62),(31.27,2.72),(29.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.035,2.72),(70.035,19.62),(70.635,19.62),(70.635,2.72),(70.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.435,2.72),(36.435,19.62),(37.035,19.62),(37.035,2.72),(36.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.965,2.72),(28.965,19.62),(29.565,19.62),(29.565,2.72),(28.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.785,2.72),(45.785,19.62),(46.035,19.62),(46.035,2.72),(45.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.365,2.72),(58.365,19.62),(58.615,19.62),(58.615,2.72),(58.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.985,2.72),(64.985,19.62),(65.235,19.62),(65.235,2.72),(64.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.185,2.72),(60.185,19.62),(60.435,19.62),(60.435,2.72),(60.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.185,2.72),(12.185,19.62),(12.435,19.62),(12.435,2.72),(12.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.95,2.72),(78.95,19.62),(79.27,19.62),(79.27,2.72),(78.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((83.05,2.72),(83.05,19.62),(83.75,19.62),(83.75,2.72),(83.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.365,2.72),(19.365,19.62),(19.965,19.62),(19.965,2.72),(19.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.585,2.72),(50.585,19.62),(50.835,19.62),(50.835,2.72),(50.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.165,2.72),(15.165,19.62),(15.415,19.62),(15.415,2.72),(15.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.385,2.72),(55.385,19.62),(55.635,19.62),(55.635,2.72),(55.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.765,2.72),(72.765,19.62),(73.015,19.62),(73.015,2.72),(72.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.635,2.72),(55.635,19.62),(56.235,19.62),(56.235,2.72),(55.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.965,2.72),(43.965,19.62),(44.215,19.62),(44.215,2.72),(43.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,19.62),(30.25,19.62),(30.25,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.65,2.72),(44.65,19.62),(45.35,19.62),(45.35,2.72),(44.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.215,2.72),(44.215,19.62),(45.67,19.62),(45.67,2.72),(44.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(45.785,19.62),(45.785,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.95,2.72),(54.95,19.62),(55.27,19.62),(55.27,2.72),(54.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,19.62),(63.85,19.62),(63.85,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,19.62),(53.565,19.62),(53.565,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.035,2.72),(46.035,19.62),(46.635,19.62),(46.635,2.72),(46.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.75,2.72),(35.75,19.62),(36.07,19.62),(36.07,2.72),(35.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.85,2.72),(15.85,19.62),(16.55,19.62),(16.55,2.72),(15.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.415,2.72),(15.415,19.62),(16.87,19.62),(16.87,2.72),(15.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,19.62),(16.985,19.62),(16.985,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.815,2.72),(77.815,19.62),(79.27,19.62),(79.27,2.72),(77.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,19.62),(79.385,19.62),(79.385,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(35.05,19.62),(35.05,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.615,2.72),(34.615,19.62),(36.07,19.62),(36.07,2.72),(34.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(36.185,19.62),(36.185,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.365,2.72),(67.365,19.62),(67.965,19.62),(67.965,2.72),(67.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.565,2.72),(29.565,19.62),(29.815,19.62),(29.815,2.72),(29.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.165,2.72),(72.165,19.62),(72.765,19.62),(72.765,2.72),(72.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,19.62),(20.65,19.62),(20.65,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.765,2.72),(81.765,19.62),(82.365,19.62),(82.365,2.72),(81.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,19.62),(34.365,19.62),(34.365,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.765,2.72),(24.765,19.62),(25.015,19.62),(25.015,2.72),(24.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,19.62),(15.85,19.62),(15.85,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.785,2.72),(21.785,19.62),(22.035,19.62),(22.035,2.72),(21.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,19.62),(30.95,19.62),(30.95,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.435,2.72),(60.435,19.62),(61.035,19.62),(61.035,2.72),(60.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.75,2.72),(59.75,19.62),(60.07,19.62),(60.07,2.72),(59.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.365,2.72),(10.365,19.62),(10.615,19.62),(10.615,2.72),(10.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.365,2.72),(82.365,19.62),(82.615,19.62),(82.615,2.72),(82.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.185,2.72),(36.185,19.62),(36.435,19.62),(36.435,2.72),(36.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.45,2.72),(25.45,19.62),(26.15,19.62),(26.15,2.72),(25.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.05,2.72),(11.05,19.62),(11.75,19.62),(11.75,2.72),(11.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.015,2.72),(25.015,19.62),(26.47,19.62),(26.47,2.72),(25.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,19.62),(26.585,19.62),(26.585,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.835,2.72),(50.835,19.62),(51.435,19.62),(51.435,2.72),(50.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.565,2.72),(14.565,19.62),(15.165,19.62),(15.165,2.72),(14.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,19.62),(78.25,19.62),(78.25,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.565,2.72),(53.565,19.62),(53.815,19.62),(53.815,2.72),(53.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.85,2.72),(63.85,19.62),(64.55,19.62),(64.55,2.72),(63.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.415,2.72),(63.415,19.62),(64.87,19.62),(64.87,2.72),(63.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,19.62),(64.985,19.62),(64.985,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.235,2.72),(41.235,19.62),(41.835,19.62),(41.835,2.72),(41.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.35,2.72),(69.35,19.62),(69.67,19.62),(69.67,2.72),(69.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.635,2.72),(7.635,19.62),(8.235,19.62),(8.235,2.72),(7.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.635,2.72),(79.635,19.62),(80.235,19.62),(80.235,2.72),(79.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.215,2.72),(20.215,19.62),(21.67,19.62),(21.67,2.72),(20.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,19.62),(21.785,19.62),(21.785,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.65,2.72),(20.65,19.62),(21.35,19.62),(21.35,2.72),(20.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.235,2.72),(17.235,19.62),(17.835,19.62),(17.835,2.72),(17.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.365,2.72),(34.365,19.62),(34.615,19.62),(34.615,2.72),(34.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.985,2.72),(40.985,19.62),(41.235,19.62),(41.235,2.72),(40.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,19.62),(25.45,19.62),(25.45,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(39.85,19.62),(39.85,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,19.62),(68.65,19.62),(68.65,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.95,2.72),(30.95,19.62),(31.27,19.62),(31.27,2.72),(30.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,19.62),(6.95,19.62),(6.95,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.35,2.72),(21.35,19.62),(21.67,19.62),(21.67,2.72),(21.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.565,2.72),(77.565,19.62),(77.815,19.62),(77.815,2.72),(77.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.765,2.72),(9.765,19.62),(10.365,19.62),(10.365,2.72),(9.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.015,2.72),(73.015,19.62),(74.47,19.62),(74.47,2.72),(73.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.45,2.72),(73.45,19.62),(74.15,19.62),(74.15,2.72),(73.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,19.62),(74.585,19.62),(74.585,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.385,2.72),(7.385,19.62),(7.635,19.62),(7.635,2.72),(7.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,19.62),(48.765,19.62),(48.765,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.385,2.72),(79.385,19.62),(79.635,19.62),(79.635,2.72),(79.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.765,2.72),(48.765,19.62),(49.015,19.62),(49.015,2.72),(48.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.35,2.72),(45.35,19.62),(45.67,19.62),(45.67,2.72),(45.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.65,2.72),(68.65,19.62),(69.35,19.62),(69.35,2.72),(68.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.215,2.72),(68.215,19.62),(69.67,19.62),(69.67,2.72),(68.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,19.62),(69.785,19.62),(69.785,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.95,2.72),(6.95,19.62),(7.27,19.62),(7.27,2.72),(6.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,19.62),(7.385,19.62),(7.385,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(59.05,19.62),(59.05,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,19.62),(73.45,19.62),(73.45,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.035,2.72),(22.035,19.62),(22.635,19.62),(22.635,2.72),(22.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.635,2.72),(31.635,19.62),(32.235,19.62),(32.235,2.72),(31.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,19.62),(39.165,19.62),(39.165,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.835,2.72),(26.835,19.62),(27.435,19.62),(27.435,2.72),(26.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.965,2.72),(19.965,19.62),(20.215,19.62),(20.215,2.72),(19.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,19.62),(11.05,19.62),(11.05,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.435,2.72),(12.435,19.62),(13.035,19.62),(13.035,2.72),(12.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.15,2.72),(50.15,19.62),(50.47,19.62),(50.47,2.72),(50.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.785,2.72),(69.785,19.62),(70.035,19.62),(70.035,2.72),(69.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.965,2.72),(76.965,19.62),(77.565,19.62),(77.565,2.72),(76.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.585,2.72),(26.585,19.62),(26.835,19.62),(26.835,2.72),(26.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.73,2.72),(82.73,19.62),(83.05,19.62),(83.05,2.72),(82.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.615,2.72),(82.615,19.62),(83.75,19.62),(83.75,2.72),(82.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.385,2.72),(31.385,19.62),(31.635,19.62),(31.635,2.72),(31.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.75,2.72),(11.75,19.62),(12.07,19.62),(12.07,2.72),(11.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.55,2.72),(40.55,19.62),(40.87,19.62),(40.87,2.72),(40.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.615,2.72),(58.615,19.62),(60.07,19.62),(60.07,2.72),(58.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(60.185,19.62),(60.185,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.15,2.72),(74.15,19.62),(74.47,19.62),(74.47,2.72),(74.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.05,2.72),(35.05,19.62),(35.75,19.62),(35.75,2.72),(35.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.55,2.72),(64.55,19.62),(64.87,19.62),(64.87,2.72),(64.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(49.45,19.62),(49.45,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.45,2.72),(49.45,19.62),(50.15,19.62),(50.15,2.72),(49.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(50.585,19.62),(50.585,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.015,2.72),(49.015,19.62),(50.47,19.62),(50.47,2.72),(49.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.985,2.72),(16.985,19.62),(17.235,19.62),(17.235,2.72),(16.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.615,2.72),(10.615,19.62),(12.07,19.62),(12.07,2.72),(10.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,19.62),(12.185,19.62),(12.185,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(55.385,19.62),(55.385,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.815,2.72),(53.815,19.62),(55.27,19.62),(55.27,2.72),(53.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.15,2.72),(26.15,19.62),(26.47,19.62),(26.47,2.72),(26.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.565,2.72),(62.565,19.62),(63.165,19.62),(63.165,2.72),(62.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,19.62),(43.965,19.62),(43.965,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,19.62),(58.365,19.62),(58.365,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.685),(83.315,7.855),(83.485,7.855),(83.485,7.685),(83.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.285),(78.515,4.455),(78.685,4.455),(78.685,4.285),(78.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.285),(78.005,4.455),(78.175,4.455),(78.175,4.285),(78.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.625),(78.515,4.795),(78.685,4.795),(78.685,4.625),(78.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.625),(78.005,4.795),(78.175,4.795),(78.175,4.625),(78.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.025),(16.115,8.195),(16.285,8.195),(16.285,8.025),(16.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.025),(16.625,8.195),(16.795,8.195),(16.795,8.025),(16.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.705),(16.625,8.875),(16.795,8.875),(16.795,8.705),(16.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.365),(16.115,8.535),(16.285,8.535),(16.285,8.365),(16.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.365),(16.625,8.535),(16.795,8.535),(16.795,8.365),(16.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.705),(16.115,8.875),(16.285,8.875),(16.285,8.705),(16.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.685),(35.315,7.855),(35.485,7.855),(35.485,7.685),(35.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.685),(35.825,7.855),(35.995,7.855),(35.995,7.685),(35.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.005),(35.825,7.175),(35.995,7.175),(35.995,7.005),(35.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.005),(35.315,7.175),(35.485,7.175),(35.485,7.005),(35.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.345),(35.825,7.515),(35.995,7.515),(35.995,7.345),(35.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.965),(40.115,5.135),(40.285,5.135),(40.285,4.965),(40.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.965),(40.625,5.135),(40.795,5.135),(40.795,4.965),(40.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.345),(35.315,7.515),(35.485,7.515),(35.485,7.345),(35.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.245),(35.825,19.415),(35.995,19.415),(35.995,19.245),(35.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.245),(35.315,19.415),(35.485,19.415),(35.485,19.245),(35.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.985),(73.715,6.155),(73.885,6.155),(73.885,5.985),(73.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.985),(73.205,6.155),(73.375,6.155),(73.375,5.985),(73.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.225),(44.405,18.395),(44.575,18.395),(44.575,18.225),(44.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.565),(44.405,18.735),(44.575,18.735),(44.575,18.565),(44.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.005),(59.825,7.175),(59.995,7.175),(59.995,7.005),(59.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.005),(59.315,7.175),(59.485,7.175),(59.485,7.005),(59.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.345),(59.825,7.515),(59.995,7.515),(59.995,7.345),(59.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.345),(59.315,7.515),(59.485,7.515),(59.485,7.345),(59.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.885),(69.425,18.055),(69.595,18.055),(69.595,17.885),(69.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.185),(16.625,16.355),(16.795,16.355),(16.795,16.185),(16.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.185),(16.115,16.355),(16.285,16.355),(16.285,16.185),(16.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.525),(16.115,16.695),(16.285,16.695),(16.285,16.525),(16.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.045),(58.805,9.215),(58.975,9.215),(58.975,9.045),(58.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.525),(16.625,16.695),(16.795,16.695),(16.795,16.525),(16.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.185),(59.825,16.355),(59.995,16.355),(59.995,16.185),(59.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.525),(59.825,16.695),(59.995,16.695),(59.995,16.525),(59.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.185),(59.315,16.355),(59.485,16.355),(59.485,16.185),(59.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.525),(59.315,16.695),(59.485,16.695),(59.485,16.525),(59.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.225),(82.805,18.395),(82.975,18.395),(82.975,18.225),(82.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.565),(82.805,18.735),(82.975,18.735),(82.975,18.565),(82.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.765),(58.805,11.935),(58.975,11.935),(58.975,11.765),(58.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.085),(58.805,11.255),(58.975,11.255),(58.975,11.085),(58.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.425),(58.805,11.595),(58.975,11.595),(58.975,11.425),(58.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.785),(73.715,12.955),(73.885,12.955),(73.885,12.785),(73.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.785),(73.205,12.955),(73.375,12.955),(73.375,12.785),(73.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.445),(73.205,12.615),(73.375,12.615),(73.375,12.445),(73.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.445),(73.715,12.615),(73.885,12.615),(73.885,12.445),(73.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.105),(73.205,12.275),(73.375,12.275),(73.375,12.105),(73.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.105),(73.715,12.275),(73.885,12.275),(73.885,12.105),(73.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.545),(31.025,17.715),(31.195,17.715),(31.195,17.545),(31.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.205),(31.025,17.375),(31.195,17.375),(31.195,17.205),(31.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.105),(25.205,12.275),(25.375,12.275),(25.375,12.105),(25.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.445),(25.715,12.615),(25.885,12.615),(25.885,12.445),(25.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.785),(25.715,12.955),(25.885,12.955),(25.885,12.785),(25.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.785),(25.205,12.955),(25.375,12.955),(25.375,12.785),(25.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.445),(25.205,12.615),(25.375,12.615),(25.375,12.445),(25.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.345),(25.205,7.515),(25.375,7.515),(25.375,7.345),(25.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.345),(25.715,7.515),(25.885,7.515),(25.885,7.345),(25.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.105),(25.715,12.275),(25.885,12.275),(25.885,12.105),(25.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.005),(25.205,7.175),(25.375,7.175),(25.375,7.005),(25.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.005),(25.715,7.175),(25.885,7.175),(25.885,7.005),(25.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.385),(64.115,9.555),(64.285,9.555),(64.285,9.385),(64.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.725),(64.115,9.895),(64.285,9.895),(64.285,9.725),(64.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.385),(64.625,9.555),(64.795,9.555),(64.795,9.385),(64.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.725),(64.625,9.895),(64.795,9.895),(64.795,9.725),(64.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.245),(68.915,19.415),(69.085,19.415),(69.085,19.245),(68.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.825),(49.205,14.995),(49.375,14.995),(49.375,14.825),(49.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.145),(49.205,14.315),(49.375,14.315),(49.375,14.145),(49.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.485),(49.205,14.655),(49.375,14.655),(49.375,14.485),(49.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.485),(49.715,14.655),(49.885,14.655),(49.885,14.485),(49.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.825),(49.715,14.995),(49.885,14.995),(49.885,14.825),(49.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.885),(16.625,18.055),(16.795,18.055),(16.795,17.885),(16.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.885),(16.115,18.055),(16.285,18.055),(16.285,17.885),(16.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.385),(69.425,9.555),(69.595,9.555),(69.595,9.385),(69.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.725),(69.425,9.895),(69.595,9.895),(69.595,9.725),(69.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.245),(15.605,19.415),(15.775,19.415),(15.775,19.245),(15.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.325),(64.115,6.495),(64.285,6.495),(64.285,6.325),(64.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.665),(64.625,6.835),(64.795,6.835),(64.795,6.665),(64.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.325),(64.625,6.495),(64.795,6.495),(64.795,6.325),(64.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.665),(64.115,6.835),(64.285,6.835),(64.285,6.665),(64.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.265),(40.625,3.435),(40.795,3.435),(40.795,3.265),(40.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.265),(40.115,3.435),(40.285,3.435),(40.285,3.265),(40.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.605),(40.115,3.775),(40.285,3.775),(40.285,3.605),(40.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.605),(40.625,3.775),(40.795,3.775),(40.795,3.605),(40.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.725),(21.425,9.895),(21.595,9.895),(21.595,9.725),(21.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.385),(21.425,9.555),(21.595,9.555),(21.595,9.385),(21.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.865),(68.915,17.035),(69.085,17.035),(69.085,16.865),(68.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.105),(64.625,12.275),(64.795,12.275),(64.795,12.105),(64.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.785),(64.625,12.955),(64.795,12.955),(64.795,12.785),(64.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.445),(64.625,12.615),(64.795,12.615),(64.795,12.445),(64.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.445),(64.115,12.615),(64.285,12.615),(64.285,12.445),(64.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.785),(64.115,12.955),(64.285,12.955),(64.285,12.785),(64.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.105),(64.115,12.275),(64.285,12.275),(64.285,12.105),(64.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.045),(44.915,9.215),(45.085,9.215),(45.085,9.045),(44.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.985),(68.405,6.155),(68.575,6.155),(68.575,5.985),(68.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.045),(68.915,9.215),(69.085,9.215),(69.085,9.045),(68.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.845),(69.425,16.015),(69.595,16.015),(69.595,15.845),(69.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.265),(16.115,3.435),(16.285,3.435),(16.285,3.265),(16.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.265),(16.625,3.435),(16.795,3.435),(16.795,3.265),(16.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.605),(16.625,3.775),(16.795,3.775),(16.795,3.605),(16.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.605),(16.115,3.775),(16.285,3.775),(16.285,3.605),(16.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.885),(39.605,18.055),(39.775,18.055),(39.775,17.885),(39.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.865),(82.805,17.035),(82.975,17.035),(82.975,16.865),(82.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.965),(11.315,5.135),(11.485,5.135),(11.485,4.965),(11.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.965),(11.825,5.135),(11.995,5.135),(11.995,4.965),(11.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.985),(68.915,6.155),(69.085,6.155),(69.085,5.985),(68.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.885),(54.515,18.055),(54.685,18.055),(54.685,17.885),(54.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.885),(54.005,18.055),(54.175,18.055),(54.175,17.885),(54.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.445),(16.115,12.615),(16.285,12.615),(16.285,12.445),(16.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.785),(16.625,12.955),(16.795,12.955),(16.795,12.785),(16.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.445),(16.625,12.615),(16.795,12.615),(16.795,12.445),(16.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.785),(16.115,12.955),(16.285,12.955),(16.285,12.785),(16.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.105),(16.625,12.275),(16.795,12.275),(16.795,12.105),(16.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.105),(16.115,12.275),(16.285,12.275),(16.285,12.105),(16.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.185),(44.405,16.355),(44.575,16.355),(44.575,16.185),(44.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.525),(44.405,16.695),(44.575,16.695),(44.575,16.525),(44.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.905),(69.425,19.075),(69.595,19.075),(69.595,18.905),(69.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.665),(39.605,6.835),(39.775,6.835),(39.775,6.665),(39.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.325),(39.605,6.495),(39.775,6.495),(39.775,6.325),(39.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.885),(20.405,18.055),(20.575,18.055),(20.575,17.885),(20.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,10.79),(85.76,10.96),(85.93,10.96),(85.93,10.79),(85.76,10.79)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.245),(74.225,19.415),(74.395,19.415),(74.395,19.245),(74.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.385),(34.805,9.555),(34.975,9.555),(34.975,9.385),(34.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.725),(34.805,9.895),(34.975,9.895),(34.975,9.725),(34.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.245),(82.805,19.415),(82.975,19.415),(82.975,19.245),(82.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.165),(74.225,15.335),(74.395,15.335),(74.395,15.165),(74.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.505),(74.225,15.675),(74.395,15.675),(74.395,15.505),(74.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.305),(69.425,5.475),(69.595,5.475),(69.595,5.305),(69.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.645),(69.425,5.815),(69.595,5.815),(69.595,5.645),(69.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.505),(26.225,15.675),(26.395,15.675),(26.395,15.505),(26.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.165),(26.225,15.335),(26.395,15.335),(26.395,15.165),(26.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.205),(64.115,17.375),(64.285,17.375),(64.285,17.205),(64.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.545),(64.625,17.715),(64.795,17.715),(64.795,17.545),(64.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.205),(64.625,17.375),(64.795,17.375),(64.795,17.205),(64.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.545),(64.115,17.715),(64.285,17.715),(64.285,17.545),(64.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.945),(68.915,4.115),(69.085,4.115),(69.085,3.945),(68.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.305),(21.425,5.475),(21.595,5.475),(21.595,5.305),(21.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.645),(21.425,5.815),(21.595,5.815),(21.595,5.645),(21.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.185),(54.515,16.355),(54.685,16.355),(54.685,16.185),(54.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.185),(54.005,16.355),(54.175,16.355),(54.175,16.185),(54.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.325),(63.605,6.495),(63.775,6.495),(63.775,6.325),(63.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.665),(63.605,6.835),(63.775,6.835),(63.775,6.665),(63.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.525),(54.515,16.695),(54.685,16.695),(54.685,16.525),(54.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.525),(54.005,16.695),(54.175,16.695),(54.175,16.525),(54.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.865),(69.425,17.035),(69.595,17.035),(69.595,16.865),(69.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.845),(45.425,16.015),(45.595,16.015),(45.595,15.845),(45.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.905),(34.805,19.075),(34.975,19.075),(34.975,18.905),(34.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.865),(63.605,17.035),(63.775,17.035),(63.775,16.865),(63.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.505),(79.025,15.675),(79.195,15.675),(79.195,15.505),(79.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.165),(79.025,15.335),(79.195,15.335),(79.195,15.165),(79.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.905),(35.825,19.075),(35.995,19.075),(35.995,18.905),(35.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.905),(35.315,19.075),(35.485,19.075),(35.485,18.905),(35.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.965),(59.315,5.135),(59.485,5.135),(59.485,4.965),(59.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.325),(11.315,6.495),(11.485,6.495),(11.485,6.325),(11.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.665),(11.315,6.835),(11.485,6.835),(11.485,6.665),(11.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.965),(59.825,5.135),(59.995,5.135),(59.995,4.965),(59.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.325),(11.825,6.495),(11.995,6.495),(11.995,6.325),(11.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.665),(11.825,6.835),(11.995,6.835),(11.995,6.665),(11.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.185),(31.025,16.355),(31.195,16.355),(31.195,16.185),(31.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.525),(31.025,16.695),(31.195,16.695),(31.195,16.525),(31.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.065),(39.605,10.235),(39.775,10.235),(39.775,10.065),(39.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.745),(39.605,10.915),(39.775,10.915),(39.775,10.745),(39.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.405),(39.605,10.575),(39.775,10.575),(39.775,10.405),(39.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.325),(78.005,6.495),(78.175,6.495),(78.175,6.325),(78.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.665),(78.005,6.835),(78.175,6.835),(78.175,6.665),(78.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.325),(78.515,6.495),(78.685,6.495),(78.685,6.325),(78.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.665),(78.515,6.835),(78.685,6.835),(78.685,6.665),(78.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.945),(44.915,4.115),(45.085,4.115),(45.085,3.945),(44.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.005),(73.205,7.175),(73.375,7.175),(73.375,7.005),(73.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.005),(73.715,7.175),(73.885,7.175),(73.885,7.005),(73.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.345),(73.205,7.515),(73.375,7.515),(73.375,7.345),(73.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.345),(73.715,7.515),(73.885,7.515),(73.885,7.345),(73.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.025),(39.605,8.195),(39.775,8.195),(39.775,8.025),(39.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.705),(39.605,8.875),(39.775,8.875),(39.775,8.705),(39.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.365),(39.605,8.535),(39.775,8.535),(39.775,8.365),(39.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.245),(69.425,19.415),(69.595,19.415),(69.595,19.245),(69.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.185),(50.225,16.355),(50.395,16.355),(50.395,16.185),(50.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.525),(50.225,16.695),(50.395,16.695),(50.395,16.525),(50.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.325),(25.715,6.495),(25.885,6.495),(25.885,6.325),(25.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.665),(25.205,6.835),(25.375,6.835),(25.375,6.665),(25.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.325),(25.205,6.495),(25.375,6.495),(25.375,6.325),(25.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.665),(25.715,6.835),(25.885,6.835),(25.885,6.665),(25.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.645),(26.225,5.815),(26.395,5.815),(26.395,5.645),(26.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.305),(26.225,5.475),(26.395,5.475),(26.395,5.305),(26.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.905),(26.225,19.075),(26.395,19.075),(26.395,18.905),(26.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.785),(26.225,12.955),(26.395,12.955),(26.395,12.785),(26.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.105),(26.225,12.275),(26.395,12.275),(26.395,12.105),(26.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.445),(26.225,12.615),(26.395,12.615),(26.395,12.445),(26.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.185),(11.825,16.355),(11.995,16.355),(11.995,16.185),(11.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.185),(11.315,16.355),(11.485,16.355),(11.485,16.185),(11.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.525),(11.315,16.695),(11.485,16.695),(11.485,16.525),(11.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.525),(11.825,16.695),(11.995,16.695),(11.995,16.525),(11.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.605),(30.005,3.775),(30.175,3.775),(30.175,3.605),(30.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.265),(30.005,3.435),(30.175,3.435),(30.175,3.265),(30.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.265),(30.515,3.435),(30.685,3.435),(30.685,3.265),(30.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.045),(31.025,9.215),(31.195,9.215),(31.195,9.045),(31.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.605),(30.515,3.775),(30.685,3.775),(30.685,3.605),(30.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.265),(7.025,3.435),(7.195,3.435),(7.195,3.265),(7.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.605),(7.025,3.775),(7.195,3.775),(7.195,3.605),(7.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.645),(44.405,5.815),(44.575,5.815),(44.575,5.645),(44.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.305),(44.405,5.475),(44.575,5.475),(44.575,5.305),(44.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.285),(68.915,4.455),(69.085,4.455),(69.085,4.285),(68.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.625),(68.915,4.795),(69.085,4.795),(69.085,4.625),(68.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.245),(44.405,19.415),(44.575,19.415),(44.575,19.245),(44.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.545),(74.225,17.715),(74.395,17.715),(74.395,17.545),(74.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.745),(16.115,10.915),(16.285,10.915),(16.285,10.745),(16.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.745),(16.625,10.915),(16.795,10.915),(16.795,10.745),(16.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.405),(16.115,10.575),(16.285,10.575),(16.285,10.405),(16.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.505),(31.025,15.675),(31.195,15.675),(31.195,15.505),(31.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.165),(31.025,15.335),(31.195,15.335),(31.195,15.165),(31.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.405),(16.625,10.575),(16.795,10.575),(16.795,10.405),(16.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.285),(20.915,4.455),(21.085,4.455),(21.085,4.285),(20.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.625),(20.915,4.795),(21.085,4.795),(21.085,4.625),(20.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.065),(16.115,10.235),(16.285,10.235),(16.285,10.065),(16.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.065),(16.625,10.235),(16.795,10.235),(16.795,10.065),(16.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.605),(11.825,3.775),(11.995,3.775),(11.995,3.605),(11.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.265),(11.315,3.435),(11.485,3.435),(11.485,3.265),(11.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.605),(11.315,3.775),(11.485,3.775),(11.485,3.605),(11.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.265),(11.825,3.435),(11.995,3.435),(11.995,3.265),(11.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.325),(30.515,6.495),(30.685,6.495),(30.685,6.325),(30.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.665),(30.515,6.835),(30.685,6.835),(30.685,6.665),(30.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.325),(30.005,6.495),(30.175,6.495),(30.175,6.325),(30.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.665),(30.005,6.835),(30.175,6.835),(30.175,6.665),(30.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.605),(25.715,3.775),(25.885,3.775),(25.885,3.605),(25.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.265),(25.205,3.435),(25.375,3.435),(25.375,3.265),(25.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.265),(25.715,3.435),(25.885,3.435),(25.885,3.265),(25.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.605),(25.205,3.775),(25.375,3.775),(25.375,3.605),(25.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.305),(39.605,5.475),(39.775,5.475),(39.775,5.305),(39.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.645),(39.605,5.815),(39.775,5.815),(39.775,5.645),(39.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.305),(15.605,5.475),(15.775,5.475),(15.775,5.305),(15.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.645),(15.605,5.815),(15.775,5.815),(15.775,5.645),(15.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.205),(83.315,17.375),(83.485,17.375),(83.485,17.205),(83.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.865),(74.225,17.035),(74.395,17.035),(74.395,16.865),(74.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.545),(83.315,17.715),(83.485,17.715),(83.485,17.545),(83.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.605),(20.915,3.775),(21.085,3.775),(21.085,3.605),(20.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.265),(20.915,3.435),(21.085,3.435),(21.085,3.265),(20.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.845),(10.805,16.015),(10.975,16.015),(10.975,15.845),(10.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.505),(64.115,15.675),(64.285,15.675),(64.285,15.505),(64.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.505),(64.625,15.675),(64.795,15.675),(64.795,15.505),(64.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.165),(64.115,15.335),(64.285,15.335),(64.285,15.165),(64.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.165),(64.625,15.335),(64.795,15.335),(64.795,15.165),(64.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.385),(82.805,9.555),(82.975,9.555),(82.975,9.385),(82.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.725),(82.805,9.895),(82.975,9.895),(82.975,9.725),(82.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.665),(58.805,6.835),(58.975,6.835),(58.975,6.665),(58.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.325),(58.805,6.495),(58.975,6.495),(58.975,6.325),(58.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.485),(40.625,14.655),(40.795,14.655),(40.795,14.485),(40.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.825),(40.625,14.995),(40.795,14.995),(40.795,14.825),(40.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.825),(40.115,14.995),(40.285,14.995),(40.285,14.825),(40.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.485),(40.115,14.655),(40.285,14.655),(40.285,14.485),(40.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.145),(40.625,14.315),(40.795,14.315),(40.795,14.145),(40.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.225),(55.025,18.395),(55.195,18.395),(55.195,18.225),(55.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.565),(55.025,18.735),(55.195,18.735),(55.195,18.565),(55.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.325),(34.805,6.495),(34.975,6.495),(34.975,6.325),(34.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.665),(34.805,6.835),(34.975,6.835),(34.975,6.665),(34.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.465),(73.715,13.635),(73.885,13.635),(73.885,13.465),(73.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.665),(54.515,6.835),(54.685,6.835),(54.685,6.665),(54.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.325),(54.515,6.495),(54.685,6.495),(54.685,6.325),(54.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.665),(54.005,6.835),(54.175,6.835),(54.175,6.665),(54.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.325),(54.005,6.495),(54.175,6.495),(54.175,6.325),(54.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.325),(10.805,6.495),(10.975,6.495),(10.975,6.325),(10.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.665),(10.805,6.835),(10.975,6.835),(10.975,6.665),(10.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.185),(39.605,16.355),(39.775,16.355),(39.775,16.185),(39.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.525),(39.605,16.695),(39.775,16.695),(39.775,16.525),(39.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.265),(49.205,3.435),(49.375,3.435),(49.375,3.265),(49.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.605),(49.205,3.775),(49.375,3.775),(49.375,3.605),(49.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.605),(49.715,3.775),(49.885,3.775),(49.885,3.605),(49.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.265),(49.715,3.435),(49.885,3.435),(49.885,3.265),(49.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.945),(83.315,4.115),(83.485,4.115),(83.485,3.945),(83.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.945),(79.025,4.115),(79.195,4.115),(79.195,3.945),(79.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.305),(63.605,5.475),(63.775,5.475),(63.775,5.305),(63.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.645),(63.605,5.815),(63.775,5.815),(63.775,5.645),(63.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.905),(79.025,19.075),(79.195,19.075),(79.195,18.905),(79.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.745),(83.315,10.915),(83.485,10.915),(83.485,10.745),(83.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.065),(83.315,10.235),(83.485,10.235),(83.485,10.065),(83.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.405),(83.315,10.575),(83.485,10.575),(83.485,10.405),(83.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.465),(83.315,13.635),(83.485,13.635),(83.485,13.465),(83.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.725),(45.425,9.895),(45.595,9.895),(45.595,9.725),(45.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.385),(45.425,9.555),(45.595,9.555),(45.595,9.385),(45.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.945),(35.315,4.115),(35.485,4.115),(35.485,3.945),(35.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.945),(35.825,4.115),(35.995,4.115),(35.995,3.945),(35.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.545),(49.205,17.715),(49.375,17.715),(49.375,17.545),(49.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.205),(49.205,17.375),(49.375,17.375),(49.375,17.205),(49.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.365),(6.515,8.535),(6.685,8.535),(6.685,8.365),(6.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.705),(6.515,8.875),(6.685,8.875),(6.685,8.705),(6.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.205),(49.715,17.375),(49.885,17.375),(49.885,17.205),(49.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.025),(6.515,8.195),(6.685,8.195),(6.685,8.025),(6.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.545),(49.715,17.715),(49.885,17.715),(49.885,17.545),(49.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.745),(6.515,10.915),(6.685,10.915),(6.685,10.745),(6.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.405),(6.515,10.575),(6.685,10.575),(6.685,10.405),(6.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.065),(6.515,10.235),(6.685,10.235),(6.685,10.065),(6.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.945),(30.005,4.115),(30.175,4.115),(30.175,3.945),(30.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.945),(30.515,4.115),(30.685,4.115),(30.685,3.945),(30.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.385),(7.025,9.555),(7.195,9.555),(7.195,9.385),(7.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.725),(7.025,9.895),(7.195,9.895),(7.195,9.725),(7.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.945),(59.315,4.115),(59.485,4.115),(59.485,3.945),(59.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.945),(59.825,4.115),(59.995,4.115),(59.995,3.945),(59.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.225),(25.205,18.395),(25.375,18.395),(25.375,18.225),(25.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.565),(25.715,18.735),(25.885,18.735),(25.885,18.565),(25.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.565),(25.205,18.735),(25.375,18.735),(25.375,18.565),(25.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.225),(25.715,18.395),(25.885,18.395),(25.885,18.225),(25.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.505),(16.625,15.675),(16.795,15.675),(16.795,15.505),(16.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.505),(16.115,15.675),(16.285,15.675),(16.285,15.505),(16.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.165),(16.115,15.335),(16.285,15.335),(16.285,15.165),(16.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.165),(16.625,15.335),(16.795,15.335),(16.795,15.165),(16.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.545),(16.115,17.715),(16.285,17.715),(16.285,17.545),(16.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.545),(16.625,17.715),(16.795,17.715),(16.795,17.545),(16.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.205),(16.115,17.375),(16.285,17.375),(16.285,17.205),(16.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.205),(16.625,17.375),(16.795,17.375),(16.795,17.205),(16.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.885),(50.225,18.055),(50.395,18.055),(50.395,17.885),(50.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.865),(64.115,17.035),(64.285,17.035),(64.285,16.865),(64.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.865),(64.625,17.035),(64.795,17.035),(64.795,16.865),(64.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.325),(49.205,6.495),(49.375,6.495),(49.375,6.325),(49.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.325),(49.715,6.495),(49.885,6.495),(49.885,6.325),(49.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.665),(49.205,6.835),(49.375,6.835),(49.375,6.665),(49.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.665),(49.715,6.835),(49.885,6.835),(49.885,6.665),(49.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.045),(79.025,9.215),(79.195,9.215),(79.195,9.045),(79.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.125),(7.025,13.295),(7.195,13.295),(7.195,13.125),(7.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.465),(7.025,13.635),(7.195,13.635),(7.195,13.465),(7.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.805),(7.025,13.975),(7.195,13.975),(7.195,13.805),(7.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.745),(69.425,10.915),(69.595,10.915),(69.595,10.745),(69.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.065),(69.425,10.235),(69.595,10.235),(69.595,10.065),(69.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.405),(69.425,10.575),(69.595,10.575),(69.595,10.405),(69.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.545),(68.915,17.715),(69.085,17.715),(69.085,17.545),(68.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.205),(68.915,17.375),(69.085,17.375),(69.085,17.205),(68.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.945),(21.425,4.115),(21.595,4.115),(21.595,3.945),(21.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.845),(58.805,16.015),(58.975,16.015),(58.975,15.845),(58.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.565),(44.915,18.735),(45.085,18.735),(45.085,18.565),(44.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.225),(44.915,18.395),(45.085,18.395),(45.085,18.225),(44.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.285),(21.425,4.455),(21.595,4.455),(21.595,4.285),(21.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.945),(31.025,4.115),(31.195,4.115),(31.195,3.945),(31.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.625),(21.425,4.795),(21.595,4.795),(21.595,4.625),(21.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.405),(21.425,10.575),(21.595,10.575),(21.595,10.405),(21.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.745),(21.425,10.915),(21.595,10.915),(21.595,10.745),(21.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.065),(21.425,10.235),(21.595,10.235),(21.595,10.065),(21.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.745),(74.225,10.915),(74.395,10.915),(74.395,10.745),(74.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.065),(74.225,10.235),(74.395,10.235),(74.395,10.065),(74.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.405),(74.225,10.575),(74.395,10.575),(74.395,10.405),(74.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.065),(64.115,10.235),(64.285,10.235),(64.285,10.065),(64.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.065),(64.625,10.235),(64.795,10.235),(64.795,10.065),(64.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.745),(64.115,10.915),(64.285,10.915),(64.285,10.745),(64.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.745),(64.625,10.915),(64.795,10.915),(64.795,10.745),(64.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.405),(64.115,10.575),(64.285,10.575),(64.285,10.405),(64.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.405),(64.625,10.575),(64.795,10.575),(64.795,10.405),(64.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.365),(26.225,8.535),(26.395,8.535),(26.395,8.365),(26.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.705),(26.225,8.875),(26.395,8.875),(26.395,8.705),(26.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.025),(26.225,8.195),(26.395,8.195),(26.395,8.025),(26.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.285),(44.405,4.455),(44.575,4.455),(44.575,4.285),(44.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.625),(44.405,4.795),(44.575,4.795),(44.575,4.625),(44.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.965),(73.205,5.135),(73.375,5.135),(73.375,4.965),(73.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.965),(73.715,5.135),(73.885,5.135),(73.885,4.965),(73.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.245),(63.605,19.415),(63.775,19.415),(63.775,19.245),(63.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.745),(26.225,10.915),(26.395,10.915),(26.395,10.745),(26.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.405),(26.225,10.575),(26.395,10.575),(26.395,10.405),(26.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.065),(26.225,10.235),(26.395,10.235),(26.395,10.065),(26.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.305),(68.405,5.475),(68.575,5.475),(68.575,5.305),(68.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.645),(68.405,5.815),(68.575,5.815),(68.575,5.645),(68.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.845),(83.315,16.015),(83.485,16.015),(83.485,15.845),(83.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.265),(26.225,3.435),(26.395,3.435),(26.395,3.265),(26.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.605),(26.225,3.775),(26.395,3.775),(26.395,3.605),(26.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.965),(25.205,5.135),(25.375,5.135),(25.375,4.965),(25.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.965),(25.715,5.135),(25.885,5.135),(25.885,4.965),(25.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.185),(6.515,16.355),(6.685,16.355),(6.685,16.185),(6.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.525),(6.515,16.695),(6.685,16.695),(6.685,16.525),(6.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.845),(35.315,16.015),(35.485,16.015),(35.485,15.845),(35.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.845),(35.825,16.015),(35.995,16.015),(35.995,15.845),(35.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.445),(74.225,12.615),(74.395,12.615),(74.395,12.445),(74.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.785),(74.225,12.955),(74.395,12.955),(74.395,12.785),(74.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.105),(74.225,12.275),(74.395,12.275),(74.395,12.105),(74.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.205),(35.825,17.375),(35.995,17.375),(35.995,17.205),(35.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.545),(35.825,17.715),(35.995,17.715),(35.995,17.545),(35.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.205),(35.315,17.375),(35.485,17.375),(35.485,17.205),(35.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.545),(35.315,17.715),(35.485,17.715),(35.485,17.545),(35.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.025),(54.005,8.195),(54.175,8.195),(54.175,8.025),(54.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.705),(54.005,8.875),(54.175,8.875),(54.175,8.705),(54.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.365),(54.005,8.535),(54.175,8.535),(54.175,8.365),(54.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.705),(54.515,8.875),(54.685,8.875),(54.685,8.705),(54.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.365),(54.515,8.535),(54.685,8.535),(54.685,8.365),(54.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.225),(59.825,18.395),(59.995,18.395),(59.995,18.225),(59.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.565),(59.315,18.735),(59.485,18.735),(59.485,18.565),(59.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.225),(59.315,18.395),(59.485,18.395),(59.485,18.225),(59.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.565),(59.825,18.735),(59.995,18.735),(59.995,18.565),(59.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.945),(55.025,4.115),(55.195,4.115),(55.195,3.945),(55.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.205),(21.425,17.375),(21.595,17.375),(21.595,17.205),(21.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.545),(21.425,17.715),(21.595,17.715),(21.595,17.545),(21.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.745),(54.005,10.915),(54.175,10.915),(54.175,10.745),(54.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.745),(54.515,10.915),(54.685,10.915),(54.685,10.745),(54.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.405),(54.515,10.575),(54.685,10.575),(54.685,10.405),(54.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.405),(54.005,10.575),(54.175,10.575),(54.175,10.405),(54.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.065),(54.005,10.235),(54.175,10.235),(54.175,10.065),(54.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.065),(54.515,10.235),(54.685,10.235),(54.685,10.065),(54.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.405),(35.825,10.575),(35.995,10.575),(35.995,10.405),(35.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.745),(35.315,10.915),(35.485,10.915),(35.485,10.745),(35.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.745),(35.825,10.915),(35.995,10.915),(35.995,10.745),(35.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.405),(35.315,10.575),(35.485,10.575),(35.485,10.405),(35.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.385),(55.025,9.555),(55.195,9.555),(55.195,9.385),(55.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.725),(55.025,9.895),(55.195,9.895),(55.195,9.725),(55.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.065),(35.825,10.235),(35.995,10.235),(35.995,10.065),(35.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.065),(35.315,10.235),(35.485,10.235),(35.485,10.065),(35.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.825),(50.225,14.995),(50.395,14.995),(50.395,14.825),(50.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.145),(50.225,14.315),(50.395,14.315),(50.395,14.145),(50.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.485),(50.225,14.655),(50.395,14.655),(50.395,14.485),(50.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.645),(11.315,5.815),(11.485,5.815),(11.485,5.645),(11.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.305),(11.825,5.475),(11.995,5.475),(11.995,5.305),(11.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.645),(11.825,5.815),(11.995,5.815),(11.995,5.645),(11.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.305),(11.315,5.475),(11.485,5.475),(11.485,5.305),(11.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.205),(54.005,17.375),(54.175,17.375),(54.175,17.205),(54.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.545),(54.005,17.715),(54.175,17.715),(54.175,17.545),(54.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.545),(54.515,17.715),(54.685,17.715),(54.685,17.545),(54.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.205),(54.515,17.375),(54.685,17.375),(54.685,17.205),(54.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.485),(31.025,14.655),(31.195,14.655),(31.195,14.485),(31.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.305),(20.915,5.475),(21.085,5.475),(21.085,5.305),(20.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.825),(31.025,14.995),(31.195,14.995),(31.195,14.825),(31.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.645),(20.915,5.815),(21.085,5.815),(21.085,5.645),(20.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.145),(31.025,14.315),(31.195,14.315),(31.195,14.145),(31.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.885),(6.515,18.055),(6.685,18.055),(6.685,17.885),(6.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.205),(20.405,17.375),(20.575,17.375),(20.575,17.205),(20.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.545),(20.405,17.715),(20.575,17.715),(20.575,17.545),(20.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.125),(55.025,13.295),(55.195,13.295),(55.195,13.125),(55.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.465),(55.025,13.635),(55.195,13.635),(55.195,13.465),(55.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.805),(55.025,13.975),(55.195,13.975),(55.195,13.805),(55.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.265),(69.425,3.435),(69.595,3.435),(69.595,3.265),(69.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.605),(69.425,3.775),(69.595,3.775),(69.595,3.605),(69.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.845),(39.605,16.015),(39.775,16.015),(39.775,15.845),(39.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.005),(78.515,7.175),(78.685,7.175),(78.685,7.005),(78.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.265),(20.405,3.435),(20.575,3.435),(20.575,3.265),(20.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.605),(20.405,3.775),(20.575,3.775),(20.575,3.605),(20.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.905),(20.915,19.075),(21.085,19.075),(21.085,18.905),(20.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.985),(55.025,6.155),(55.195,6.155),(55.195,5.985),(55.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,2.925),(16.115,3.095),(16.285,3.095),(16.285,2.925),(16.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.485),(20.405,14.655),(20.575,14.655),(20.575,14.485),(20.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.825),(20.405,14.995),(20.575,14.995),(20.575,14.825),(20.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,2.925),(16.625,3.095),(16.795,3.095),(16.795,2.925),(16.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.145),(20.405,14.315),(20.575,14.315),(20.575,14.145),(20.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.625),(15.605,4.795),(15.775,4.795),(15.775,4.625),(15.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.285),(15.605,4.455),(15.775,4.455),(15.775,4.285),(15.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.845),(25.715,16.015),(25.885,16.015),(25.885,15.845),(25.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.845),(25.205,16.015),(25.375,16.015),(25.375,15.845),(25.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.045),(73.205,9.215),(73.375,9.215),(73.375,9.045),(73.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.045),(73.715,9.215),(73.885,9.215),(73.885,9.045),(73.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.185),(20.915,16.355),(21.085,16.355),(21.085,16.185),(20.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.525),(20.915,16.695),(21.085,16.695),(21.085,16.525),(20.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.945),(45.425,4.115),(45.595,4.115),(45.595,3.945),(45.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.905),(31.025,19.075),(31.195,19.075),(31.195,18.905),(31.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.045),(25.205,9.215),(25.375,9.215),(25.375,9.045),(25.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.045),(25.715,9.215),(25.885,9.215),(25.885,9.045),(25.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.945),(26.225,4.115),(26.395,4.115),(26.395,3.945),(26.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.045),(20.405,9.215),(20.575,9.215),(20.575,9.045),(20.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.725),(78.515,9.895),(78.685,9.895),(78.685,9.725),(78.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.725),(78.005,9.895),(78.175,9.895),(78.175,9.725),(78.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.385),(78.005,9.555),(78.175,9.555),(78.175,9.385),(78.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.385),(78.515,9.555),(78.685,9.555),(78.685,9.385),(78.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.425),(35.825,11.595),(35.995,11.595),(35.995,11.425),(35.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.965),(6.515,5.135),(6.685,5.135),(6.685,4.965),(6.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.405),(11.315,10.575),(11.485,10.575),(11.485,10.405),(11.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.405),(11.825,10.575),(11.995,10.575),(11.995,10.405),(11.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.745),(11.315,10.915),(11.485,10.915),(11.485,10.745),(11.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.745),(11.825,10.915),(11.995,10.915),(11.995,10.745),(11.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.065),(11.315,10.235),(11.485,10.235),(11.485,10.065),(11.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.065),(11.825,10.235),(11.995,10.235),(11.995,10.065),(11.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.925),(40.115,3.095),(40.285,3.095),(40.285,2.925),(40.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.925),(40.625,3.095),(40.795,3.095),(40.795,2.925),(40.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.905),(74.225,19.075),(74.395,19.075),(74.395,18.905),(74.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.565),(64.115,18.735),(64.285,18.735),(64.285,18.565),(64.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.565),(64.625,18.735),(64.795,18.735),(64.795,18.565),(64.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.225),(64.625,18.395),(64.795,18.395),(64.795,18.225),(64.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.225),(64.115,18.395),(64.285,18.395),(64.285,18.225),(64.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.025),(68.915,8.195),(69.085,8.195),(69.085,8.025),(68.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.325),(82.805,6.495),(82.975,6.495),(82.975,6.325),(82.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.365),(68.915,8.535),(69.085,8.535),(69.085,8.365),(68.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.705),(68.915,8.875),(69.085,8.875),(69.085,8.705),(68.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.665),(82.805,6.835),(82.975,6.835),(82.975,6.665),(82.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.185),(45.425,16.355),(45.595,16.355),(45.595,16.185),(45.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.525),(45.425,16.695),(45.595,16.695),(45.595,16.525),(45.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.965),(49.715,5.135),(49.885,5.135),(49.885,4.965),(49.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.965),(49.205,5.135),(49.375,5.135),(49.375,4.965),(49.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.705),(20.915,8.875),(21.085,8.875),(21.085,8.705),(20.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.365),(20.915,8.535),(21.085,8.535),(21.085,8.365),(20.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.025),(20.915,8.195),(21.085,8.195),(21.085,8.025),(20.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,2.925),(78.005,3.095),(78.175,3.095),(78.175,2.925),(78.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,2.925),(78.515,3.095),(78.685,3.095),(78.685,2.925),(78.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.145),(78.005,14.315),(78.175,14.315),(78.175,14.145),(78.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.145),(78.515,14.315),(78.685,14.315),(78.685,14.145),(78.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.825),(78.005,14.995),(78.175,14.995),(78.175,14.825),(78.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.485),(78.515,14.655),(78.685,14.655),(78.685,14.485),(78.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.825),(78.515,14.995),(78.685,14.995),(78.685,14.825),(78.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.485),(78.005,14.655),(78.175,14.655),(78.175,14.485),(78.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.785),(55.025,12.955),(55.195,12.955),(55.195,12.785),(55.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.445),(55.025,12.615),(55.195,12.615),(55.195,12.445),(55.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.105),(55.025,12.275),(55.195,12.275),(55.195,12.105),(55.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.745),(45.425,10.915),(45.595,10.915),(45.595,10.745),(45.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.405),(45.425,10.575),(45.595,10.575),(45.595,10.405),(45.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.065),(45.425,10.235),(45.595,10.235),(45.595,10.065),(45.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.365),(64.625,8.535),(64.795,8.535),(64.795,8.365),(64.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.865),(79.025,17.035),(79.195,17.035),(79.195,16.865),(79.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.705),(64.115,8.875),(64.285,8.875),(64.285,8.705),(64.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.945),(73.715,4.115),(73.885,4.115),(73.885,3.945),(73.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.945),(73.205,4.115),(73.375,4.115),(73.375,3.945),(73.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.965),(30.515,5.135),(30.685,5.135),(30.685,4.965),(30.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.965),(30.005,5.135),(30.175,5.135),(30.175,4.965),(30.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.945),(64.625,4.115),(64.795,4.115),(64.795,3.945),(64.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.945),(64.115,4.115),(64.285,4.115),(64.285,3.945),(64.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,2.925),(6.515,3.095),(6.685,3.095),(6.685,2.925),(6.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.625),(69.425,4.795),(69.595,4.795),(69.595,4.625),(69.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.285),(69.425,4.455),(69.595,4.455),(69.595,4.285),(69.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.445),(7.025,12.615),(7.195,12.615),(7.195,12.445),(7.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.785),(7.025,12.955),(7.195,12.955),(7.195,12.785),(7.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.805),(26.225,13.975),(26.395,13.975),(26.395,13.805),(26.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.465),(26.225,13.635),(26.395,13.635),(26.395,13.465),(26.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.125),(26.225,13.295),(26.395,13.295),(26.395,13.125),(26.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.985),(79.025,6.155),(79.195,6.155),(79.195,5.985),(79.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.105),(7.025,12.275),(7.195,12.275),(7.195,12.105),(7.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.725),(30.515,9.895),(30.685,9.895),(30.685,9.725),(30.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.385),(30.515,9.555),(30.685,9.555),(30.685,9.385),(30.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.385),(30.005,9.555),(30.175,9.555),(30.175,9.385),(30.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.725),(30.005,9.895),(30.175,9.895),(30.175,9.725),(30.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.625),(39.605,4.795),(39.775,4.795),(39.775,4.625),(39.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.285),(39.605,4.455),(39.775,4.455),(39.775,4.285),(39.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.025),(74.225,8.195),(74.395,8.195),(74.395,8.025),(74.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.365),(74.225,8.535),(74.395,8.535),(74.395,8.365),(74.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.705),(74.225,8.875),(74.395,8.875),(74.395,8.705),(74.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.145),(79.025,14.315),(79.195,14.315),(79.195,14.145),(79.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.485),(79.025,14.655),(79.195,14.655),(79.195,14.485),(79.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.825),(79.025,14.995),(79.195,14.995),(79.195,14.825),(79.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.845),(59.315,16.015),(59.485,16.015),(59.485,15.845),(59.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.785),(68.405,12.955),(68.575,12.955),(68.575,12.785),(68.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.105),(68.405,12.275),(68.575,12.275),(68.575,12.105),(68.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.845),(59.825,16.015),(59.995,16.015),(59.995,15.845),(59.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.445),(68.405,12.615),(68.575,12.615),(68.575,12.445),(68.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.885),(15.605,18.055),(15.775,18.055),(15.775,17.885),(15.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.965),(58.805,5.135),(58.975,5.135),(58.975,4.965),(58.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.845),(11.315,16.015),(11.485,16.015),(11.485,15.845),(11.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.445),(20.405,12.615),(20.575,12.615),(20.575,12.445),(20.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.785),(20.405,12.955),(20.575,12.955),(20.575,12.785),(20.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.105),(20.405,12.275),(20.575,12.275),(20.575,12.105),(20.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.845),(11.825,16.015),(11.995,16.015),(11.995,15.845),(11.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.965),(34.805,5.135),(34.975,5.135),(34.975,4.965),(34.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.725),(15.605,9.895),(15.775,9.895),(15.775,9.725),(15.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.385),(15.605,9.555),(15.775,9.555),(15.775,9.385),(15.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.965),(54.005,5.135),(54.175,5.135),(54.175,4.965),(54.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.965),(10.805,5.135),(10.975,5.135),(10.975,4.965),(10.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.965),(54.515,5.135),(54.685,5.135),(54.685,4.965),(54.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.745),(59.825,10.915),(59.995,10.915),(59.995,10.745),(59.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.745),(59.315,10.915),(59.485,10.915),(59.485,10.745),(59.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.065),(59.315,10.235),(59.485,10.235),(59.485,10.065),(59.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.065),(59.825,10.235),(59.995,10.235),(59.995,10.065),(59.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.885),(20.915,18.055),(21.085,18.055),(21.085,17.885),(20.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,2.925),(30.005,3.095),(30.175,3.095),(30.175,2.925),(30.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.925),(30.515,3.095),(30.685,3.095),(30.685,2.925),(30.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.405),(59.825,10.575),(59.995,10.575),(59.995,10.405),(59.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.405),(59.315,10.575),(59.485,10.575),(59.485,10.405),(59.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.485),(30.515,14.655),(30.685,14.655),(30.685,14.485),(30.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.825),(30.515,14.995),(30.685,14.995),(30.685,14.825),(30.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.185),(49.715,16.355),(49.885,16.355),(49.885,16.185),(49.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.185),(49.205,16.355),(49.375,16.355),(49.375,16.185),(49.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.825),(30.005,14.995),(30.175,14.995),(30.175,14.825),(30.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.485),(30.005,14.655),(30.175,14.655),(30.175,14.485),(30.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.145),(30.005,14.315),(30.175,14.315),(30.175,14.145),(30.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.905),(39.605,19.075),(39.775,19.075),(39.775,18.905),(39.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.525),(49.205,16.695),(49.375,16.695),(49.375,16.525),(49.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.525),(49.715,16.695),(49.885,16.695),(49.885,16.525),(49.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,2.925),(64.115,3.095),(64.285,3.095),(64.285,2.925),(64.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,2.925),(64.625,3.095),(64.795,3.095),(64.795,2.925),(64.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.565),(54.515,18.735),(54.685,18.735),(54.685,18.565),(54.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.225),(54.515,18.395),(54.685,18.395),(54.685,18.225),(54.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.565),(54.005,18.735),(54.175,18.735),(54.175,18.565),(54.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.285),(63.605,4.455),(63.775,4.455),(63.775,4.285),(63.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.225),(54.005,18.395),(54.175,18.395),(54.175,18.225),(54.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.625),(63.605,4.795),(63.775,4.795),(63.775,4.625),(63.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.225),(7.025,18.395),(7.195,18.395),(7.195,18.225),(7.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.565),(7.025,18.735),(7.195,18.735),(7.195,18.565),(7.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.125),(15.605,13.295),(15.775,13.295),(15.775,13.125),(15.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.465),(15.605,13.635),(15.775,13.635),(15.775,13.465),(15.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.805),(15.605,13.975),(15.775,13.975),(15.775,13.805),(15.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.905),(49.715,19.075),(49.885,19.075),(49.885,18.905),(49.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.905),(49.205,19.075),(49.375,19.075),(49.375,18.905),(49.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.965),(82.805,5.135),(82.975,5.135),(82.975,4.965),(82.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.385),(63.605,9.555),(63.775,9.555),(63.775,9.385),(63.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.885),(59.825,18.055),(59.995,18.055),(59.995,17.885),(59.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.885),(59.315,18.055),(59.485,18.055),(59.485,17.885),(59.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.725),(63.605,9.895),(63.775,9.895),(63.775,9.725),(63.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.685),(74.225,7.855),(74.395,7.855),(74.395,7.685),(74.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.345),(74.225,7.515),(74.395,7.515),(74.395,7.345),(74.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.885),(68.405,18.055),(68.575,18.055),(68.575,17.885),(68.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.605),(39.605,3.775),(39.775,3.775),(39.775,3.605),(39.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.265),(39.605,3.435),(39.775,3.435),(39.775,3.265),(39.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.145),(58.805,14.315),(58.975,14.315),(58.975,14.145),(58.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.565),(11.315,18.735),(11.485,18.735),(11.485,18.565),(11.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.225),(11.825,18.395),(11.995,18.395),(11.995,18.225),(11.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.825),(58.805,14.995),(58.975,14.995),(58.975,14.825),(58.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.485),(58.805,14.655),(58.975,14.655),(58.975,14.485),(58.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.565),(11.825,18.735),(11.995,18.735),(11.995,18.565),(11.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.225),(11.315,18.395),(11.485,18.395),(11.485,18.225),(11.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.565),(50.225,18.735),(50.395,18.735),(50.395,18.565),(50.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.225),(50.225,18.395),(50.395,18.395),(50.395,18.225),(50.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.925),(54.515,3.095),(54.685,3.095),(54.685,2.925),(54.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.925),(54.005,3.095),(54.175,3.095),(54.175,2.925),(54.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.505),(54.515,15.675),(54.685,15.675),(54.685,15.505),(54.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.685),(26.225,7.855),(26.395,7.855),(26.395,7.685),(26.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.165),(54.515,15.335),(54.685,15.335),(54.685,15.165),(54.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.165),(54.005,15.335),(54.175,15.335),(54.175,15.165),(54.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.145),(10.805,14.315),(10.975,14.315),(10.975,14.145),(10.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.505),(54.005,15.675),(54.175,15.675),(54.175,15.505),(54.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.485),(10.805,14.655),(10.975,14.655),(10.975,14.485),(10.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.825),(10.805,14.995),(10.975,14.995),(10.975,14.825),(10.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.145),(68.405,14.315),(68.575,14.315),(68.575,14.145),(68.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.165),(6.515,15.335),(6.685,15.335),(6.685,15.165),(6.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.485),(68.405,14.655),(68.575,14.655),(68.575,14.485),(68.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.825),(68.405,14.995),(68.575,14.995),(68.575,14.825),(68.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.505),(6.515,15.675),(6.685,15.675),(6.685,15.505),(6.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.845),(73.205,16.015),(73.375,16.015),(73.375,15.845),(73.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.205),(50.225,17.375),(50.395,17.375),(50.395,17.205),(50.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.545),(50.225,17.715),(50.395,17.715),(50.395,17.545),(50.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.125),(63.605,13.295),(63.775,13.295),(63.775,13.125),(63.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.465),(63.605,13.635),(63.775,13.635),(63.775,13.465),(63.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.805),(63.605,13.975),(63.775,13.975),(63.775,13.805),(63.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.845),(73.715,16.015),(73.885,16.015),(73.885,15.845),(73.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.005),(79.025,7.175),(79.195,7.175),(79.195,7.005),(79.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.345),(79.025,7.515),(79.195,7.515),(79.195,7.345),(79.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.685),(79.025,7.855),(79.195,7.855),(79.195,7.685),(79.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.045),(54.515,9.215),(54.685,9.215),(54.685,9.045),(54.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.045),(54.005,9.215),(54.175,9.215),(54.175,9.045),(54.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.085),(54.515,11.255),(54.685,11.255),(54.685,11.085),(54.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.085),(54.005,11.255),(54.175,11.255),(54.175,11.085),(54.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.425),(54.515,11.595),(54.685,11.595),(54.685,11.425),(54.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.765),(54.515,11.935),(54.685,11.935),(54.685,11.765),(54.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.765),(54.005,11.935),(54.175,11.935),(54.175,11.765),(54.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.425),(54.005,11.595),(54.175,11.595),(54.175,11.425),(54.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.045),(6.515,9.215),(6.685,9.215),(6.685,9.045),(6.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.565),(45.425,18.735),(45.595,18.735),(45.595,18.565),(45.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.225),(45.425,18.395),(45.595,18.395),(45.595,18.225),(45.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.685),(7.025,7.855),(7.195,7.855),(7.195,7.685),(7.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.005),(7.025,7.175),(7.195,7.175),(7.195,7.005),(7.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.045),(44.405,9.215),(44.575,9.215),(44.575,9.045),(44.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.345),(7.025,7.515),(7.195,7.515),(7.195,7.345),(7.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.605),(63.605,3.775),(63.775,3.775),(63.775,3.605),(63.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.265),(63.605,3.435),(63.775,3.435),(63.775,3.265),(63.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.085),(6.515,11.255),(6.685,11.255),(6.685,11.085),(6.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.425),(6.515,11.595),(6.685,11.595),(6.685,11.425),(6.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.765),(6.515,11.935),(6.685,11.935),(6.685,11.765),(6.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.045),(68.405,9.215),(68.575,9.215),(68.575,9.045),(68.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.965),(78.005,5.135),(78.175,5.135),(78.175,4.965),(78.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.965),(78.515,5.135),(78.685,5.135),(78.685,4.965),(78.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.385),(49.715,9.555),(49.885,9.555),(49.885,9.385),(49.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.385),(49.205,9.555),(49.375,9.555),(49.375,9.385),(49.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.725),(49.205,9.895),(49.375,9.895),(49.375,9.725),(49.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.725),(49.715,9.895),(49.885,9.895),(49.885,9.725),(49.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.625),(35.315,4.795),(35.485,4.795),(35.485,4.625),(35.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.285),(35.315,4.455),(35.485,4.455),(35.485,4.285),(35.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.625),(35.825,4.795),(35.995,4.795),(35.995,4.625),(35.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.285),(35.825,4.455),(35.995,4.455),(35.995,4.285),(35.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.565),(16.625,18.735),(16.795,18.735),(16.795,18.565),(16.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.225),(16.115,18.395),(16.285,18.395),(16.285,18.225),(16.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.225),(16.625,18.395),(16.795,18.395),(16.795,18.225),(16.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.565),(16.115,18.735),(16.285,18.735),(16.285,18.565),(16.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.285),(26.225,4.455),(26.395,4.455),(26.395,4.285),(26.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.625),(26.225,4.795),(26.395,4.795),(26.395,4.625),(26.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.845),(15.605,16.015),(15.775,16.015),(15.775,15.845),(15.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.785),(6.515,12.955),(6.685,12.955),(6.685,12.785),(6.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.445),(6.515,12.615),(6.685,12.615),(6.685,12.445),(6.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.105),(6.515,12.275),(6.685,12.275),(6.685,12.105),(6.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.305),(73.715,5.475),(73.885,5.475),(73.885,5.305),(73.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.885),(55.025,18.055),(55.195,18.055),(55.195,17.885),(55.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.645),(73.715,5.815),(73.885,5.815),(73.885,5.645),(73.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.305),(73.205,5.475),(73.375,5.475),(73.375,5.305),(73.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.645),(73.205,5.815),(73.375,5.815),(73.375,5.645),(73.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.905),(44.405,19.075),(44.575,19.075),(44.575,18.905),(44.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.185),(58.805,16.355),(58.975,16.355),(58.975,16.185),(58.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.525),(58.805,16.695),(58.975,16.695),(58.975,16.525),(58.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.205),(69.425,17.375),(69.595,17.375),(69.595,17.205),(69.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.545),(69.425,17.715),(69.595,17.715),(69.595,17.545),(69.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.865),(16.115,17.035),(16.285,17.035),(16.285,16.865),(16.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.865),(16.625,17.035),(16.795,17.035),(16.795,16.865),(16.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.005),(31.025,7.175),(31.195,7.175),(31.195,7.005),(31.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.345),(31.025,7.515),(31.195,7.515),(31.195,7.345),(31.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.685),(31.025,7.855),(31.195,7.855),(31.195,7.685),(31.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,2.925),(83.315,3.095),(83.485,3.095),(83.485,2.925),(83.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.865),(59.825,17.035),(59.995,17.035),(59.995,16.865),(59.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.185),(55.025,16.355),(55.195,16.355),(55.195,16.185),(55.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.525),(55.025,16.695),(55.195,16.695),(55.195,16.525),(55.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.865),(59.315,17.035),(59.485,17.035),(59.485,16.865),(59.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.905),(82.805,19.075),(82.975,19.075),(82.975,18.905),(82.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.085),(7.025,11.255),(7.195,11.255),(7.195,11.085),(7.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.425),(7.025,11.595),(7.195,11.595),(7.195,11.425),(7.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.765),(7.025,11.935),(7.195,11.935),(7.195,11.765),(7.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.085),(74.225,11.255),(74.395,11.255),(74.395,11.085),(74.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.425),(74.225,11.595),(74.395,11.595),(74.395,11.425),(74.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.765),(74.225,11.935),(74.395,11.935),(74.395,11.765),(74.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.045),(26.225,9.215),(26.395,9.215),(26.395,9.045),(26.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.425),(26.225,11.595),(26.395,11.595),(26.395,11.425),(26.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.765),(26.225,11.935),(26.395,11.935),(26.395,11.765),(26.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.085),(26.225,11.255),(26.395,11.255),(26.395,11.085),(26.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.285),(50.225,4.455),(50.395,4.455),(50.395,4.285),(50.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.625),(50.225,4.795),(50.395,4.795),(50.395,4.625),(50.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.845),(63.605,16.015),(63.775,16.015),(63.775,15.845),(63.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.145),(44.405,14.315),(44.575,14.315),(44.575,14.145),(44.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.945),(15.605,4.115),(15.775,4.115),(15.775,3.945),(15.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.485),(44.405,14.655),(44.575,14.655),(44.575,14.485),(44.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.825),(44.405,14.995),(44.575,14.995),(44.575,14.825),(44.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.805),(74.225,13.975),(74.395,13.975),(74.395,13.805),(74.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.465),(74.225,13.635),(74.395,13.635),(74.395,13.465),(74.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.045),(39.605,9.215),(39.775,9.215),(39.775,9.045),(39.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.125),(74.225,13.295),(74.395,13.295),(74.395,13.125),(74.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.205),(6.515,17.375),(6.685,17.375),(6.685,17.205),(6.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.545),(6.515,17.715),(6.685,17.715),(6.685,17.545),(6.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.805),(73.715,13.975),(73.885,13.975),(73.885,13.805),(73.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.165),(39.605,15.335),(39.775,15.335),(39.775,15.165),(39.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.005),(55.025,7.175),(55.195,7.175),(55.195,7.005),(55.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.505),(39.605,15.675),(39.775,15.675),(39.775,15.505),(39.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.345),(55.025,7.515),(55.195,7.515),(55.195,7.345),(55.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.685),(55.025,7.855),(55.195,7.855),(55.195,7.685),(55.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,2.925),(69.425,3.095),(69.595,3.095),(69.595,2.925),(69.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.085),(68.405,11.255),(68.575,11.255),(68.575,11.085),(68.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.765),(68.405,11.935),(68.575,11.935),(68.575,11.765),(68.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.425),(68.405,11.595),(68.575,11.595),(68.575,11.425),(68.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.505),(82.805,15.675),(82.975,15.675),(82.975,15.505),(82.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.165),(82.805,15.335),(82.975,15.335),(82.975,15.165),(82.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,2.925),(21.425,3.095),(21.595,3.095),(21.595,2.925),(21.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.285),(83.315,4.455),(83.485,4.455),(83.485,4.285),(83.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.625),(83.315,4.795),(83.485,4.795),(83.485,4.625),(83.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.425),(20.405,11.595),(20.575,11.595),(20.575,11.425),(20.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.085),(20.405,11.255),(20.575,11.255),(20.575,11.085),(20.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.765),(20.405,11.935),(20.575,11.935),(20.575,11.765),(20.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.505),(25.205,15.675),(25.375,15.675),(25.375,15.505),(25.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.505),(25.715,15.675),(25.885,15.675),(25.885,15.505),(25.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.165),(25.715,15.335),(25.885,15.335),(25.885,15.165),(25.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.165),(25.205,15.335),(25.375,15.335),(25.375,15.165),(25.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.005),(50.225,7.175),(50.395,7.175),(50.395,7.005),(50.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.685),(50.225,7.855),(50.395,7.855),(50.395,7.685),(50.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.345),(50.225,7.515),(50.395,7.515),(50.395,7.345),(50.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.185),(68.915,16.355),(69.085,16.355),(69.085,16.185),(68.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.525),(68.915,16.695),(69.085,16.695),(69.085,16.525),(68.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.445),(34.805,12.615),(34.975,12.615),(34.975,12.445),(34.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.785),(34.805,12.955),(34.975,12.955),(34.975,12.785),(34.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.105),(34.805,12.275),(34.975,12.275),(34.975,12.105),(34.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.785),(54.515,12.955),(54.685,12.955),(54.685,12.785),(54.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.445),(54.515,12.615),(54.685,12.615),(54.685,12.445),(54.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.785),(54.005,12.955),(54.175,12.955),(54.175,12.785),(54.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.445),(54.005,12.615),(54.175,12.615),(54.175,12.445),(54.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.105),(54.005,12.275),(54.175,12.275),(54.175,12.105),(54.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.105),(54.515,12.275),(54.685,12.275),(54.685,12.105),(54.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.225),(20.405,18.395),(20.575,18.395),(20.575,18.225),(20.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.565),(20.405,18.735),(20.575,18.735),(20.575,18.565),(20.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.085),(40.625,11.255),(40.795,11.255),(40.795,11.085),(40.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.085),(40.115,11.255),(40.285,11.255),(40.285,11.085),(40.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.765),(40.115,11.935),(40.285,11.935),(40.285,11.765),(40.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.765),(40.625,11.935),(40.795,11.935),(40.795,11.765),(40.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.425),(40.625,11.595),(40.795,11.595),(40.795,11.425),(40.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.425),(40.115,11.595),(40.285,11.595),(40.285,11.425),(40.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.425),(49.205,11.595),(49.375,11.595),(49.375,11.425),(49.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.425),(49.715,11.595),(49.885,11.595),(49.885,11.425),(49.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.085),(49.205,11.255),(49.375,11.255),(49.375,11.085),(49.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.705),(44.915,8.875),(45.085,8.875),(45.085,8.705),(44.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.365),(44.915,8.535),(45.085,8.535),(45.085,8.365),(44.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.085),(49.715,11.255),(49.885,11.255),(49.885,11.085),(49.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.765),(49.715,11.935),(49.885,11.935),(49.885,11.765),(49.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.765),(49.205,11.935),(49.375,11.935),(49.375,11.765),(49.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.985),(45.425,6.155),(45.595,6.155),(45.595,5.985),(45.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.765),(55.025,11.935),(55.195,11.935),(55.195,11.765),(55.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.085),(55.025,11.255),(55.195,11.255),(55.195,11.085),(55.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.425),(55.025,11.595),(55.195,11.595),(55.195,11.425),(55.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.105),(15.605,12.275),(15.775,12.275),(15.775,12.105),(15.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.785),(15.605,12.955),(15.775,12.955),(15.775,12.785),(15.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.445),(15.605,12.615),(15.775,12.615),(15.775,12.445),(15.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.405),(20.915,10.575),(21.085,10.575),(21.085,10.405),(20.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.745),(20.915,10.915),(21.085,10.915),(21.085,10.745),(20.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.065),(20.915,10.235),(21.085,10.235),(21.085,10.065),(20.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.205),(39.605,17.375),(39.775,17.375),(39.775,17.205),(39.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.545),(39.605,17.715),(39.775,17.715),(39.775,17.545),(39.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.445),(82.805,12.615),(82.975,12.615),(82.975,12.445),(82.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.785),(82.805,12.955),(82.975,12.955),(82.975,12.785),(82.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.925),(35.315,3.095),(35.485,3.095),(35.485,2.925),(35.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.925),(35.825,3.095),(35.995,3.095),(35.995,2.925),(35.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.105),(82.805,12.275),(82.975,12.275),(82.975,12.105),(82.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.225),(6.515,18.395),(6.685,18.395),(6.685,18.225),(6.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.565),(6.515,18.735),(6.685,18.735),(6.685,18.565),(6.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.505),(34.805,15.675),(34.975,15.675),(34.975,15.505),(34.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.165),(34.805,15.335),(34.975,15.335),(34.975,15.165),(34.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.345),(45.425,7.515),(45.595,7.515),(45.595,7.345),(45.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.005),(45.425,7.175),(45.595,7.175),(45.595,7.005),(45.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.685),(45.425,7.855),(45.595,7.855),(45.595,7.685),(45.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,2.925),(20.405,3.095),(20.575,3.095),(20.575,2.925),(20.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.225),(73.715,18.395),(73.885,18.395),(73.885,18.225),(73.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.565),(73.715,18.735),(73.885,18.735),(73.885,18.565),(73.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.225),(73.205,18.395),(73.375,18.395),(73.375,18.225),(73.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.565),(73.205,18.735),(73.375,18.735),(73.375,18.565),(73.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.605),(82.805,3.775),(82.975,3.775),(82.975,3.605),(82.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.265),(82.805,3.435),(82.975,3.435),(82.975,3.265),(82.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.885),(58.805,18.055),(58.975,18.055),(58.975,17.885),(58.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.865),(44.405,17.035),(44.575,17.035),(44.575,16.865),(44.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.245),(79.025,19.415),(79.195,19.415),(79.195,19.245),(79.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.445),(44.405,12.615),(44.575,12.615),(44.575,12.445),(44.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.785),(44.405,12.955),(44.575,12.955),(44.575,12.785),(44.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.245),(54.515,19.415),(54.685,19.415),(54.685,19.245),(54.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.245),(54.005,19.415),(54.175,19.415),(54.175,19.245),(54.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.105),(44.405,12.275),(44.575,12.275),(44.575,12.105),(44.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.325),(55.025,6.495),(55.195,6.495),(55.195,6.325),(55.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.665),(55.025,6.835),(55.195,6.835),(55.195,6.665),(55.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.845),(82.805,16.015),(82.975,16.015),(82.975,15.845),(82.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.885),(40.115,18.055),(40.285,18.055),(40.285,17.885),(40.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.885),(40.625,18.055),(40.795,18.055),(40.795,17.885),(40.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.965),(44.915,5.135),(45.085,5.135),(45.085,4.965),(44.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.285),(74.225,4.455),(74.395,4.455),(74.395,4.285),(74.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.625),(74.225,4.795),(74.395,4.795),(74.395,4.625),(74.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.005),(68.405,7.175),(68.575,7.175),(68.575,7.005),(68.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.345),(68.405,7.515),(68.575,7.515),(68.575,7.345),(68.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.685),(68.405,7.855),(68.575,7.855),(68.575,7.685),(68.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.865),(54.005,17.035),(54.175,17.035),(54.175,16.865),(54.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.865),(54.515,17.035),(54.685,17.035),(54.685,16.865),(54.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.325),(69.425,6.495),(69.595,6.495),(69.595,6.325),(69.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.665),(69.425,6.835),(69.595,6.835),(69.595,6.665),(69.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.465),(69.425,13.635),(69.595,13.635),(69.595,13.465),(69.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.805),(69.425,13.975),(69.595,13.975),(69.595,13.805),(69.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.685),(20.405,7.855),(20.575,7.855),(20.575,7.685),(20.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.125),(69.425,13.295),(69.595,13.295),(69.595,13.125),(69.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.885),(78.515,18.055),(78.685,18.055),(78.685,17.885),(78.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.325),(21.425,6.495),(21.595,6.495),(21.595,6.325),(21.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.885),(78.005,18.055),(78.175,18.055),(78.175,17.885),(78.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.665),(21.425,6.835),(21.595,6.835),(21.595,6.665),(21.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.045),(74.225,9.215),(74.395,9.215),(74.395,9.045),(74.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.985),(35.315,6.155),(35.485,6.155),(35.485,5.985),(35.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.985),(35.825,6.155),(35.995,6.155),(35.995,5.985),(35.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.465),(21.425,13.635),(21.595,13.635),(21.595,13.465),(21.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.805),(21.425,13.975),(21.595,13.975),(21.595,13.805),(21.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.125),(21.425,13.295),(21.595,13.295),(21.595,13.125),(21.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.865),(31.025,17.035),(31.195,17.035),(31.195,16.865),(31.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.405),(55.025,10.575),(55.195,10.575),(55.195,10.405),(55.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.745),(55.025,10.915),(55.195,10.915),(55.195,10.745),(55.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.065),(55.025,10.235),(55.195,10.235),(55.195,10.065),(55.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.385),(40.115,9.555),(40.285,9.555),(40.285,9.385),(40.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.725),(40.115,9.895),(40.285,9.895),(40.285,9.725),(40.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.385),(40.625,9.555),(40.795,9.555),(40.795,9.385),(40.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.725),(40.625,9.895),(40.795,9.895),(40.795,9.725),(40.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.845),(34.805,16.015),(34.975,16.015),(34.975,15.845),(34.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.245),(59.825,19.415),(59.995,19.415),(59.995,19.245),(59.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.245),(59.315,19.415),(59.485,19.415),(59.485,19.245),(59.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.005),(44.405,7.175),(44.575,7.175),(44.575,7.005),(44.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.345),(44.405,7.515),(44.575,7.515),(44.575,7.345),(44.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.525),(40.625,16.695),(40.795,16.695),(40.795,16.525),(40.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.185),(40.115,16.355),(40.285,16.355),(40.285,16.185),(40.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.185),(40.625,16.355),(40.795,16.355),(40.795,16.185),(40.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.885),(25.715,18.055),(25.885,18.055),(25.885,17.885),(25.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.885),(25.205,18.055),(25.375,18.055),(25.375,17.885),(25.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.885),(7.025,18.055),(7.195,18.055),(7.195,17.885),(7.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.025),(55.025,8.195),(55.195,8.195),(55.195,8.025),(55.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.365),(55.025,8.535),(55.195,8.535),(55.195,8.365),(55.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.705),(55.025,8.875),(55.195,8.875),(55.195,8.705),(55.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.525),(40.115,16.695),(40.285,16.695),(40.285,16.525),(40.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.745),(7.025,10.915),(7.195,10.915),(7.195,10.745),(7.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.405),(7.025,10.575),(7.195,10.575),(7.195,10.405),(7.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.065),(7.025,10.235),(7.195,10.235),(7.195,10.065),(7.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.865),(50.225,17.035),(50.395,17.035),(50.395,16.865),(50.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.885),(63.605,18.055),(63.775,18.055),(63.775,17.885),(63.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.985),(59.825,6.155),(59.995,6.155),(59.995,5.985),(59.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.985),(59.315,6.155),(59.485,6.155),(59.485,5.985),(59.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.025),(7.025,8.195),(7.195,8.195),(7.195,8.025),(7.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.365),(7.025,8.535),(7.195,8.535),(7.195,8.365),(7.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.185),(20.405,16.355),(20.575,16.355),(20.575,16.185),(20.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.525),(20.405,16.695),(20.575,16.695),(20.575,16.525),(20.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.705),(7.025,8.875),(7.195,8.875),(7.195,8.705),(7.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.205),(68.405,17.375),(68.575,17.375),(68.575,17.205),(68.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.545),(68.405,17.715),(68.575,17.715),(68.575,17.545),(68.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.865),(11.825,17.035),(11.995,17.035),(11.995,16.865),(11.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.865),(11.315,17.035),(11.485,17.035),(11.485,16.865),(11.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.025),(34.805,8.195),(34.975,8.195),(34.975,8.025),(34.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.705),(34.805,8.875),(34.975,8.875),(34.975,8.705),(34.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.365),(34.805,8.535),(34.975,8.535),(34.975,8.365),(34.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.105),(63.605,12.275),(63.775,12.275),(63.775,12.105),(63.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.445),(63.605,12.615),(63.775,12.615),(63.775,12.445),(63.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.785),(63.605,12.955),(63.775,12.955),(63.775,12.785),(63.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.945),(82.805,4.115),(82.975,4.115),(82.975,3.945),(82.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.085),(83.315,11.255),(83.485,11.255),(83.485,11.085),(83.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.425),(83.315,11.595),(83.485,11.595),(83.485,11.425),(83.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.885),(11.315,18.055),(11.485,18.055),(11.485,17.885),(11.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.885),(11.825,18.055),(11.995,18.055),(11.995,17.885),(11.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.765),(83.315,11.935),(83.485,11.935),(83.485,11.765),(83.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.065),(34.805,10.235),(34.975,10.235),(34.975,10.065),(34.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.405),(34.805,10.575),(34.975,10.575),(34.975,10.405),(34.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.425),(44.405,11.595),(44.575,11.595),(44.575,11.425),(44.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.905),(68.915,19.075),(69.085,19.075),(69.085,18.905),(68.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.765),(44.405,11.935),(44.575,11.935),(44.575,11.765),(44.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.085),(44.405,11.255),(44.575,11.255),(44.575,11.085),(44.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.745),(34.805,10.915),(34.975,10.915),(34.975,10.745),(34.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.705),(68.405,8.875),(68.575,8.875),(68.575,8.705),(68.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.025),(68.405,8.195),(68.575,8.195),(68.575,8.025),(68.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.365),(68.405,8.535),(68.575,8.535),(68.575,8.365),(68.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.765),(35.315,11.935),(35.485,11.935),(35.485,11.765),(35.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.765),(35.825,11.935),(35.995,11.935),(35.995,11.765),(35.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.085),(35.315,11.255),(35.485,11.255),(35.485,11.085),(35.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.085),(35.825,11.255),(35.995,11.255),(35.995,11.085),(35.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.425),(35.315,11.595),(35.485,11.595),(35.485,11.425),(35.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.345),(54.515,7.515),(54.685,7.515),(54.685,7.345),(54.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.005),(54.515,7.175),(54.685,7.175),(54.685,7.005),(54.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.345),(54.005,7.515),(54.175,7.515),(54.175,7.345),(54.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.005),(54.005,7.175),(54.175,7.175),(54.175,7.005),(54.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.165),(73.205,15.335),(73.375,15.335),(73.375,15.165),(73.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.165),(73.715,15.335),(73.885,15.335),(73.885,15.165),(73.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.505),(73.205,15.675),(73.375,15.675),(73.375,15.505),(73.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.945),(68.405,4.115),(68.575,4.115),(68.575,3.945),(68.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.505),(73.715,15.675),(73.885,15.675),(73.885,15.505),(73.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.045),(35.315,9.215),(35.485,9.215),(35.485,9.045),(35.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.045),(35.825,9.215),(35.995,9.215),(35.995,9.045),(35.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.025),(20.405,8.195),(20.575,8.195),(20.575,8.025),(20.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.365),(20.405,8.535),(20.575,8.535),(20.575,8.365),(20.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.705),(20.405,8.875),(20.575,8.875),(20.575,8.705),(20.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.485),(25.715,14.655),(25.885,14.655),(25.885,14.485),(25.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.825),(25.205,14.995),(25.375,14.995),(25.375,14.825),(25.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.825),(25.715,14.995),(25.885,14.995),(25.885,14.825),(25.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.485),(25.205,14.655),(25.375,14.655),(25.375,14.485),(25.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.145),(25.205,14.315),(25.375,14.315),(25.375,14.145),(25.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.145),(25.715,14.315),(25.885,14.315),(25.885,14.145),(25.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.085),(15.605,11.255),(15.775,11.255),(15.775,11.085),(15.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.425),(15.605,11.595),(15.775,11.595),(15.775,11.425),(15.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.765),(15.605,11.935),(15.775,11.935),(15.775,11.765),(15.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.025),(82.805,8.195),(82.975,8.195),(82.975,8.025),(82.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.365),(82.805,8.535),(82.975,8.535),(82.975,8.365),(82.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.705),(82.805,8.875),(82.975,8.875),(82.975,8.705),(82.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.945),(44.405,4.115),(44.575,4.115),(44.575,3.945),(44.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.745),(68.915,10.915),(69.085,10.915),(69.085,10.745),(68.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.405),(68.915,10.575),(69.085,10.575),(69.085,10.405),(68.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.065),(68.915,10.235),(69.085,10.235),(69.085,10.065),(68.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.085),(21.425,11.255),(21.595,11.255),(21.595,11.085),(21.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.765),(21.425,11.935),(21.595,11.935),(21.595,11.765),(21.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.425),(21.425,11.595),(21.595,11.595),(21.595,11.425),(21.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.765),(68.915,11.935),(69.085,11.935),(69.085,11.765),(68.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.085),(68.915,11.255),(69.085,11.255),(69.085,11.085),(68.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.425),(68.915,11.595),(69.085,11.595),(69.085,11.425),(68.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.345),(30.515,7.515),(30.685,7.515),(30.685,7.345),(30.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.345),(30.005,7.515),(30.175,7.515),(30.175,7.345),(30.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.005),(30.005,7.175),(30.175,7.175),(30.175,7.005),(30.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.005),(30.515,7.175),(30.685,7.175),(30.685,7.005),(30.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.905),(55.025,19.075),(55.195,19.075),(55.195,18.905),(55.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,2.925),(68.405,3.095),(68.575,3.095),(68.575,2.925),(68.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.425),(63.605,11.595),(63.775,11.595),(63.775,11.425),(63.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.765),(63.605,11.935),(63.775,11.935),(63.775,11.765),(63.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.085),(63.605,11.255),(63.775,11.255),(63.775,11.085),(63.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.765),(20.915,11.935),(21.085,11.935),(21.085,11.765),(20.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.425),(20.915,11.595),(21.085,11.595),(21.085,11.425),(20.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.085),(20.915,11.255),(21.085,11.255),(21.085,11.085),(20.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.725),(50.225,9.895),(50.395,9.895),(50.395,9.725),(50.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.385),(50.225,9.555),(50.395,9.555),(50.395,9.385),(50.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.685),(64.115,7.855),(64.285,7.855),(64.285,7.685),(64.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.685),(64.625,7.855),(64.795,7.855),(64.795,7.685),(64.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.185),(10.805,16.355),(10.975,16.355),(10.975,16.185),(10.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.525),(10.805,16.695),(10.975,16.695),(10.975,16.525),(10.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.865),(39.605,17.035),(39.775,17.035),(39.775,16.865),(39.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.685),(40.115,7.855),(40.285,7.855),(40.285,7.685),(40.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.685),(40.625,7.855),(40.795,7.855),(40.795,7.685),(40.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.345),(40.625,7.515),(40.795,7.515),(40.795,7.345),(40.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.345),(40.115,7.515),(40.285,7.515),(40.285,7.345),(40.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.465),(54.515,13.635),(54.685,13.635),(54.685,13.465),(54.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.805),(54.515,13.975),(54.685,13.975),(54.685,13.805),(54.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.125),(54.005,13.295),(54.175,13.295),(54.175,13.125),(54.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.005),(40.115,7.175),(40.285,7.175),(40.285,7.005),(40.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.005),(40.625,7.175),(40.795,7.175),(40.795,7.005),(40.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.465),(54.005,13.635),(54.175,13.635),(54.175,13.465),(54.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.805),(54.005,13.975),(54.175,13.975),(54.175,13.805),(54.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.125),(54.515,13.295),(54.685,13.295),(54.685,13.125),(54.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.165),(21.425,15.335),(21.595,15.335),(21.595,15.165),(21.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.505),(21.425,15.675),(21.595,15.675),(21.595,15.505),(21.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.245),(40.115,19.415),(40.285,19.415),(40.285,19.245),(40.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.245),(40.625,19.415),(40.795,19.415),(40.795,19.245),(40.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.185),(25.205,16.355),(25.375,16.355),(25.375,16.185),(25.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.525),(7.025,16.695),(7.195,16.695),(7.195,16.525),(7.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.125),(6.515,13.295),(6.685,13.295),(6.685,13.125),(6.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.525),(25.715,16.695),(25.885,16.695),(25.885,16.525),(25.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.525),(25.205,16.695),(25.375,16.695),(25.375,16.525),(25.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.465),(6.515,13.635),(6.685,13.635),(6.685,13.465),(6.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.805),(6.515,13.975),(6.685,13.975),(6.685,13.805),(6.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.185),(25.715,16.355),(25.885,16.355),(25.885,16.185),(25.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.185),(7.025,16.355),(7.195,16.355),(7.195,16.185),(7.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.325),(79.025,6.495),(79.195,6.495),(79.195,6.325),(79.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.665),(79.025,6.835),(79.195,6.835),(79.195,6.665),(79.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.005),(11.825,7.175),(11.995,7.175),(11.995,7.005),(11.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.145),(39.605,14.315),(39.775,14.315),(39.775,14.145),(39.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.485),(39.605,14.655),(39.775,14.655),(39.775,14.485),(39.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.825),(39.605,14.995),(39.775,14.995),(39.775,14.825),(39.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.005),(10.805,7.175),(10.975,7.175),(10.975,7.005),(10.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.345),(10.805,7.515),(10.975,7.515),(10.975,7.345),(10.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.325),(44.915,6.495),(45.085,6.495),(45.085,6.325),(44.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.665),(44.915,6.835),(45.085,6.835),(45.085,6.665),(44.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.525),(78.005,16.695),(78.175,16.695),(78.175,16.525),(78.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.185),(78.515,16.355),(78.685,16.355),(78.685,16.185),(78.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.565),(15.605,18.735),(15.775,18.735),(15.775,18.565),(15.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.185),(78.005,16.355),(78.175,16.355),(78.175,16.185),(78.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.525),(78.515,16.695),(78.685,16.695),(78.685,16.525),(78.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.225),(15.605,18.395),(15.775,18.395),(15.775,18.225),(15.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.905),(25.205,19.075),(25.375,19.075),(25.375,18.905),(25.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.905),(25.715,19.075),(25.885,19.075),(25.885,18.905),(25.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.845),(49.715,16.015),(49.885,16.015),(49.885,15.845),(49.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.845),(49.205,16.015),(49.375,16.015),(49.375,15.845),(49.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.885),(10.805,18.055),(10.975,18.055),(10.975,17.885),(10.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.665),(44.405,6.835),(44.575,6.835),(44.575,6.665),(44.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.325),(44.405,6.495),(44.575,6.495),(44.575,6.325),(44.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.685),(16.625,7.855),(16.795,7.855),(16.795,7.685),(16.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.685),(16.115,7.855),(16.285,7.855),(16.285,7.685),(16.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.245),(50.225,19.415),(50.395,19.415),(50.395,19.245),(50.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.345),(15.605,7.515),(15.775,7.515),(15.775,7.345),(15.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.005),(15.605,7.175),(15.775,7.175),(15.775,7.005),(15.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.065),(44.915,10.235),(45.085,10.235),(45.085,10.065),(44.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.745),(44.915,10.915),(45.085,10.915),(45.085,10.745),(44.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.405),(44.915,10.575),(45.085,10.575),(45.085,10.405),(44.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.885),(68.915,18.055),(69.085,18.055),(69.085,17.885),(68.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.025),(40.625,8.195),(40.795,8.195),(40.795,8.025),(40.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.345),(82.805,7.515),(82.975,7.515),(82.975,7.345),(82.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.365),(40.625,8.535),(40.795,8.535),(40.795,8.365),(40.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.705),(40.115,8.875),(40.285,8.875),(40.285,8.705),(40.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.965),(21.425,5.135),(21.595,5.135),(21.595,4.965),(21.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.705),(40.625,8.875),(40.795,8.875),(40.795,8.705),(40.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.365),(40.115,8.535),(40.285,8.535),(40.285,8.365),(40.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.005),(82.805,7.175),(82.975,7.175),(82.975,7.005),(82.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.845),(74.225,16.015),(74.395,16.015),(74.395,15.845),(74.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.985),(83.315,6.155),(83.485,6.155),(83.485,5.985),(83.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.845),(26.225,16.015),(26.395,16.015),(26.395,15.845),(26.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.965),(44.405,5.135),(44.575,5.135),(44.575,4.965),(44.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.405),(49.715,10.575),(49.885,10.575),(49.885,10.405),(49.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.405),(49.205,10.575),(49.375,10.575),(49.375,10.405),(49.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.785),(21.425,12.955),(21.595,12.955),(21.595,12.785),(21.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.445),(21.425,12.615),(21.595,12.615),(21.595,12.445),(21.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.065),(49.205,10.235),(49.375,10.235),(49.375,10.065),(49.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.065),(49.715,10.235),(49.885,10.235),(49.885,10.065),(49.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.745),(49.205,10.915),(49.375,10.915),(49.375,10.745),(49.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.745),(49.715,10.915),(49.885,10.915),(49.885,10.745),(49.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.105),(21.425,12.275),(21.595,12.275),(21.595,12.105),(21.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.865),(6.515,17.035),(6.685,17.035),(6.685,16.865),(6.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.325),(26.225,6.495),(26.395,6.495),(26.395,6.325),(26.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.665),(26.225,6.835),(26.395,6.835),(26.395,6.665),(26.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.005),(63.605,7.175),(63.775,7.175),(63.775,7.005),(63.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.345),(63.605,7.515),(63.775,7.515),(63.775,7.345),(63.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.325),(68.915,6.495),(69.085,6.495),(69.085,6.325),(68.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.665),(68.915,6.835),(69.085,6.835),(69.085,6.665),(68.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.925),(44.915,3.095),(45.085,3.095),(45.085,2.925),(44.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.005),(68.915,7.175),(69.085,7.175),(69.085,7.005),(68.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.685),(68.915,7.855),(69.085,7.855),(69.085,7.685),(68.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.345),(68.915,7.515),(69.085,7.515),(69.085,7.345),(68.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.045),(16.115,9.215),(16.285,9.215),(16.285,9.045),(16.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.045),(16.625,9.215),(16.795,9.215),(16.795,9.045),(16.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.425),(59.315,11.595),(59.485,11.595),(59.485,11.425),(59.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.425),(59.825,11.595),(59.995,11.595),(59.995,11.425),(59.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.085),(59.825,11.255),(59.995,11.255),(59.995,11.085),(59.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.905),(59.825,19.075),(59.995,19.075),(59.995,18.905),(59.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.905),(59.315,19.075),(59.485,19.075),(59.485,18.905),(59.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.085),(59.315,11.255),(59.485,11.255),(59.485,11.085),(59.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.765),(59.825,11.935),(59.995,11.935),(59.995,11.765),(59.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.765),(59.315,11.935),(59.485,11.935),(59.485,11.765),(59.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.565),(58.805,18.735),(58.975,18.735),(58.975,18.565),(58.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.225),(58.805,18.395),(58.975,18.395),(58.975,18.225),(58.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.345),(20.915,7.515),(21.085,7.515),(21.085,7.345),(20.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.685),(20.915,7.855),(21.085,7.855),(21.085,7.685),(20.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.005),(20.915,7.175),(21.085,7.175),(21.085,7.005),(20.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.125),(35.825,13.295),(35.995,13.295),(35.995,13.125),(35.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.805),(35.825,13.975),(35.995,13.975),(35.995,13.805),(35.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.465),(35.825,13.635),(35.995,13.635),(35.995,13.465),(35.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.805),(35.315,13.975),(35.485,13.975),(35.485,13.805),(35.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.465),(35.315,13.635),(35.485,13.635),(35.485,13.465),(35.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.985),(20.405,6.155),(20.575,6.155),(20.575,5.985),(20.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.725),(20.915,9.895),(21.085,9.895),(21.085,9.725),(20.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.385),(20.915,9.555),(21.085,9.555),(21.085,9.385),(20.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.045),(59.825,9.215),(59.995,9.215),(59.995,9.045),(59.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.045),(59.315,9.215),(59.485,9.215),(59.485,9.045),(59.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.765),(11.825,11.935),(11.995,11.935),(11.995,11.765),(11.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.085),(11.825,11.255),(11.995,11.255),(11.995,11.085),(11.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.765),(11.315,11.935),(11.485,11.935),(11.485,11.765),(11.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.085),(11.315,11.255),(11.485,11.255),(11.485,11.085),(11.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.425),(11.315,11.595),(11.485,11.595),(11.485,11.425),(11.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.425),(11.825,11.595),(11.995,11.595),(11.995,11.425),(11.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.385),(10.805,9.555),(10.975,9.555),(10.975,9.385),(10.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.725),(10.805,9.895),(10.975,9.895),(10.975,9.725),(10.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.245),(20.405,19.415),(20.575,19.415),(20.575,19.245),(20.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,2.925),(15.605,3.095),(15.775,3.095),(15.775,2.925),(15.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.345),(78.005,7.515),(78.175,7.515),(78.175,7.345),(78.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.005),(34.805,7.175),(34.975,7.175),(34.975,7.005),(34.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.345),(78.515,7.515),(78.685,7.515),(78.685,7.345),(78.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.345),(34.805,7.515),(34.975,7.515),(34.975,7.345),(34.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.325),(68.405,6.495),(68.575,6.495),(68.575,6.325),(68.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.045),(83.315,9.215),(83.485,9.215),(83.485,9.045),(83.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.665),(68.405,6.835),(68.575,6.835),(68.575,6.665),(68.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.045),(11.315,9.215),(11.485,9.215),(11.485,9.045),(11.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.045),(11.825,9.215),(11.995,9.215),(11.995,9.045),(11.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.005),(78.005,7.175),(78.175,7.175),(78.175,7.005),(78.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.205),(58.805,17.375),(58.975,17.375),(58.975,17.205),(58.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.545),(58.805,17.715),(58.975,17.715),(58.975,17.545),(58.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.145),(73.205,14.315),(73.375,14.315),(73.375,14.145),(73.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.145),(73.715,14.315),(73.885,14.315),(73.885,14.145),(73.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.485),(73.205,14.655),(73.375,14.655),(73.375,14.485),(73.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.825),(73.205,14.995),(73.375,14.995),(73.375,14.825),(73.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.825),(73.715,14.995),(73.885,14.995),(73.885,14.825),(73.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.485),(73.715,14.655),(73.885,14.655),(73.885,14.485),(73.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.985),(20.915,6.155),(21.085,6.155),(21.085,5.985),(20.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.925),(58.805,3.095),(58.975,3.095),(58.975,2.925),(58.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.245),(6.515,19.415),(6.685,19.415),(6.685,19.245),(6.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.925),(34.805,3.095),(34.975,3.095),(34.975,2.925),(34.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.545),(40.625,17.715),(40.795,17.715),(40.795,17.545),(40.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.545),(40.115,17.715),(40.285,17.715),(40.285,17.545),(40.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.205),(40.115,17.375),(40.285,17.375),(40.285,17.205),(40.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.205),(40.625,17.375),(40.795,17.375),(40.795,17.205),(40.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,2.925),(10.805,3.095),(10.975,3.095),(10.975,2.925),(10.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.565),(20.915,18.735),(21.085,18.735),(21.085,18.565),(20.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.225),(20.915,18.395),(21.085,18.395),(21.085,18.225),(20.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.745),(82.805,10.915),(82.975,10.915),(82.975,10.745),(82.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.405),(82.805,10.575),(82.975,10.575),(82.975,10.405),(82.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.065),(82.805,10.235),(82.975,10.235),(82.975,10.065),(82.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.665),(40.115,6.835),(40.285,6.835),(40.285,6.665),(40.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.325),(40.625,6.495),(40.795,6.495),(40.795,6.325),(40.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.325),(40.115,6.495),(40.285,6.495),(40.285,6.325),(40.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.665),(40.625,6.835),(40.795,6.835),(40.795,6.665),(40.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.465),(45.425,13.635),(45.595,13.635),(45.595,13.465),(45.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.805),(45.425,13.975),(45.595,13.975),(45.595,13.805),(45.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.745),(15.605,10.915),(15.775,10.915),(15.775,10.745),(15.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.125),(45.425,13.295),(45.595,13.295),(45.595,13.125),(45.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.065),(15.605,10.235),(15.775,10.235),(15.775,10.065),(15.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.405),(15.605,10.575),(15.775,10.575),(15.775,10.405),(15.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.305),(55.025,5.475),(55.195,5.475),(55.195,5.305),(55.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.645),(55.025,5.815),(55.195,5.815),(55.195,5.645),(55.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.085),(69.425,11.255),(69.595,11.255),(69.595,11.085),(69.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.425),(69.425,11.595),(69.595,11.595),(69.595,11.425),(69.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.765),(69.425,11.935),(69.595,11.935),(69.595,11.765),(69.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.965),(15.605,5.135),(15.775,5.135),(15.775,4.965),(15.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.705),(15.605,8.875),(15.775,8.875),(15.775,8.705),(15.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.085),(44.915,11.255),(45.085,11.255),(45.085,11.085),(44.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.765),(44.915,11.935),(45.085,11.935),(45.085,11.765),(44.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.365),(15.605,8.535),(15.775,8.535),(15.775,8.365),(15.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.425),(44.915,11.595),(45.085,11.595),(45.085,11.425),(44.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.025),(15.605,8.195),(15.775,8.195),(15.775,8.025),(15.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.005),(83.315,7.175),(83.485,7.175),(83.485,7.005),(83.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.345),(83.315,7.515),(83.485,7.515),(83.485,7.345),(83.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.545),(78.515,17.715),(78.685,17.715),(78.685,17.545),(78.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.205),(78.005,17.375),(78.175,17.375),(78.175,17.205),(78.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.505),(69.425,15.675),(69.595,15.675),(69.595,15.505),(69.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.165),(69.425,15.335),(69.595,15.335),(69.595,15.165),(69.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.245),(31.025,19.415),(31.195,19.415),(31.195,19.245),(31.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.545),(78.005,17.715),(78.175,17.715),(78.175,17.545),(78.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.485),(69.425,14.655),(69.595,14.655),(69.595,14.485),(69.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.825),(69.425,14.995),(69.595,14.995),(69.595,14.825),(69.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.805),(34.805,13.975),(34.975,13.975),(34.975,13.805),(34.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.125),(34.805,13.295),(34.975,13.295),(34.975,13.125),(34.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.145),(69.425,14.315),(69.595,14.315),(69.595,14.145),(69.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.465),(34.805,13.635),(34.975,13.635),(34.975,13.465),(34.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.685),(59.315,7.855),(59.485,7.855),(59.485,7.685),(59.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.885),(73.205,18.055),(73.375,18.055),(73.375,17.885),(73.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.885),(73.715,18.055),(73.885,18.055),(73.885,17.885),(73.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.685),(59.825,7.855),(59.995,7.855),(59.995,7.685),(59.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.145),(21.425,14.315),(21.595,14.315),(21.595,14.145),(21.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.485),(21.425,14.655),(21.595,14.655),(21.595,14.485),(21.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.825),(21.425,14.995),(21.595,14.995),(21.595,14.825),(21.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.985),(25.205,6.155),(25.375,6.155),(25.375,5.985),(25.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.985),(25.715,6.155),(25.885,6.155),(25.885,5.985),(25.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.725),(58.805,9.895),(58.975,9.895),(58.975,9.725),(58.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.385),(58.805,9.555),(58.975,9.555),(58.975,9.385),(58.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.245),(39.605,19.415),(39.775,19.415),(39.775,19.245),(39.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.525),(30.515,16.695),(30.685,16.695),(30.685,16.525),(30.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.185),(30.005,16.355),(30.175,16.355),(30.175,16.185),(30.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.525),(30.005,16.695),(30.175,16.695),(30.175,16.525),(30.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.185),(30.515,16.355),(30.685,16.355),(30.685,16.185),(30.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.345),(11.315,7.515),(11.485,7.515),(11.485,7.345),(11.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.345),(11.825,7.515),(11.995,7.515),(11.995,7.345),(11.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.685),(11.315,7.855),(11.485,7.855),(11.485,7.685),(11.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.925),(39.605,3.095),(39.775,3.095),(39.775,2.925),(39.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.685),(11.825,7.855),(11.995,7.855),(11.995,7.685),(11.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.005),(11.315,7.175),(11.485,7.175),(11.485,7.005),(11.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.525),(68.405,16.695),(68.575,16.695),(68.575,16.525),(68.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.185),(68.405,16.355),(68.575,16.355),(68.575,16.185),(68.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.025),(44.405,8.195),(44.575,8.195),(44.575,8.025),(44.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.705),(44.405,8.875),(44.575,8.875),(44.575,8.705),(44.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.365),(44.405,8.535),(44.575,8.535),(44.575,8.365),(44.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.905),(64.625,19.075),(64.795,19.075),(64.795,18.905),(64.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.905),(64.115,19.075),(64.285,19.075),(64.285,18.905),(64.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.245),(11.315,19.415),(11.485,19.415),(11.485,19.245),(11.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.245),(11.825,19.415),(11.995,19.415),(11.995,19.245),(11.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.445),(40.625,12.615),(40.795,12.615),(40.795,12.445),(40.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.785),(40.115,12.955),(40.285,12.955),(40.285,12.785),(40.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.105),(40.115,12.275),(40.285,12.275),(40.285,12.105),(40.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.445),(40.115,12.615),(40.285,12.615),(40.285,12.445),(40.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.105),(40.625,12.275),(40.795,12.275),(40.795,12.105),(40.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.785),(40.625,12.955),(40.795,12.955),(40.795,12.785),(40.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.865),(45.425,17.035),(45.595,17.035),(45.595,16.865),(45.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.685),(25.205,7.855),(25.375,7.855),(25.375,7.685),(25.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.685),(25.715,7.855),(25.885,7.855),(25.885,7.685),(25.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.125),(49.715,13.295),(49.885,13.295),(49.885,13.125),(49.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.125),(49.205,13.295),(49.375,13.295),(49.375,13.125),(49.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.245),(49.205,19.415),(49.375,19.415),(49.375,19.245),(49.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.245),(49.715,19.415),(49.885,19.415),(49.885,19.245),(49.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.805),(49.715,13.975),(49.885,13.975),(49.885,13.805),(49.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.465),(49.715,13.635),(49.885,13.635),(49.885,13.465),(49.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.465),(49.205,13.635),(49.375,13.635),(49.375,13.465),(49.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.805),(49.205,13.975),(49.375,13.975),(49.375,13.805),(49.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.985),(40.625,6.155),(40.795,6.155),(40.795,5.985),(40.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.985),(40.115,6.155),(40.285,6.155),(40.285,5.985),(40.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.045),(64.625,9.215),(64.795,9.215),(64.795,9.045),(64.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.045),(64.115,9.215),(64.285,9.215),(64.285,9.045),(64.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.705),(35.825,8.875),(35.995,8.875),(35.995,8.705),(35.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.705),(35.315,8.875),(35.485,8.875),(35.485,8.705),(35.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.365),(35.825,8.535),(35.995,8.535),(35.995,8.365),(35.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.365),(35.315,8.535),(35.485,8.535),(35.485,8.365),(35.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.025),(35.825,8.195),(35.995,8.195),(35.995,8.025),(35.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.985),(49.205,6.155),(49.375,6.155),(49.375,5.985),(49.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.265),(64.625,3.435),(64.795,3.435),(64.795,3.265),(64.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.605),(64.625,3.775),(64.795,3.775),(64.795,3.605),(64.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.265),(64.115,3.435),(64.285,3.435),(64.285,3.265),(64.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.985),(49.715,6.155),(49.885,6.155),(49.885,5.985),(49.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.605),(64.115,3.775),(64.285,3.775),(64.285,3.605),(64.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.045),(69.425,9.215),(69.595,9.215),(69.595,9.045),(69.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.885),(30.515,18.055),(30.685,18.055),(30.685,17.885),(30.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.965),(69.425,5.135),(69.595,5.135),(69.595,4.965),(69.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.885),(30.005,18.055),(30.175,18.055),(30.175,17.885),(30.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.765),(45.425,11.935),(45.595,11.935),(45.595,11.765),(45.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.425),(45.425,11.595),(45.595,11.595),(45.595,11.425),(45.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.085),(45.425,11.255),(45.595,11.255),(45.595,11.085),(45.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.665),(15.605,6.835),(15.775,6.835),(15.775,6.665),(15.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.325),(15.605,6.495),(15.775,6.495),(15.775,6.325),(15.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.305),(79.025,5.475),(79.195,5.475),(79.195,5.305),(79.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.645),(79.025,5.815),(79.195,5.815),(79.195,5.645),(79.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,2.925),(63.605,3.095),(63.775,3.095),(63.775,2.925),(63.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.285),(79.025,4.455),(79.195,4.455),(79.195,4.285),(79.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.625),(79.025,4.795),(79.195,4.795),(79.195,4.625),(79.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.965),(39.605,5.135),(39.775,5.135),(39.775,4.965),(39.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.445),(45.425,12.615),(45.595,12.615),(45.595,12.445),(45.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.845),(7.025,16.015),(7.195,16.015),(7.195,15.845),(7.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.785),(45.425,12.955),(45.595,12.955),(45.595,12.785),(45.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.105),(45.425,12.275),(45.595,12.275),(45.595,12.105),(45.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.045),(21.425,9.215),(21.595,9.215),(21.595,9.045),(21.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.985),(50.225,6.155),(50.395,6.155),(50.395,5.985),(50.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.285),(55.025,4.455),(55.195,4.455),(55.195,4.285),(55.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.625),(55.025,4.795),(55.195,4.795),(55.195,4.625),(55.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.225),(68.405,18.395),(68.575,18.395),(68.575,18.225),(68.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.565),(68.405,18.735),(68.575,18.735),(68.575,18.565),(68.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.105),(69.425,12.275),(69.595,12.275),(69.595,12.105),(69.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.785),(69.425,12.955),(69.595,12.955),(69.595,12.785),(69.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.445),(69.425,12.615),(69.595,12.615),(69.595,12.445),(69.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.565),(78.515,18.735),(78.685,18.735),(78.685,18.565),(78.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.225),(78.515,18.395),(78.685,18.395),(78.685,18.225),(78.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.225),(78.005,18.395),(78.175,18.395),(78.175,18.225),(78.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.565),(78.005,18.735),(78.175,18.735),(78.175,18.565),(78.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.245),(44.915,19.415),(45.085,19.415),(45.085,19.245),(44.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.625),(7.025,4.795),(7.195,4.795),(7.195,4.625),(7.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.285),(7.025,4.455),(7.195,4.455),(7.195,4.285),(7.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.685),(49.715,7.855),(49.885,7.855),(49.885,7.685),(49.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.685),(49.205,7.855),(49.375,7.855),(49.375,7.685),(49.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.005),(49.205,7.175),(49.375,7.175),(49.375,7.005),(49.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.005),(49.715,7.175),(49.885,7.175),(49.885,7.005),(49.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.345),(49.205,7.515),(49.375,7.515),(49.375,7.345),(49.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.345),(49.715,7.515),(49.885,7.515),(49.885,7.345),(49.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.165),(83.315,15.335),(83.485,15.335),(83.485,15.165),(83.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.465),(16.625,13.635),(16.795,13.635),(16.795,13.465),(16.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.805),(16.625,13.975),(16.795,13.975),(16.795,13.805),(16.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.525),(83.315,16.695),(83.485,16.695),(83.485,16.525),(83.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.185),(83.315,16.355),(83.485,16.355),(83.485,16.185),(83.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.125),(16.625,13.295),(16.795,13.295),(16.795,13.125),(16.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.805),(16.115,13.975),(16.285,13.975),(16.285,13.805),(16.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.505),(45.425,15.675),(45.595,15.675),(45.595,15.505),(45.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.165),(45.425,15.335),(45.595,15.335),(45.595,15.165),(45.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.125),(16.115,13.295),(16.285,13.295),(16.285,13.125),(16.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.465),(16.115,13.635),(16.285,13.635),(16.285,13.465),(16.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.205),(15.605,17.375),(15.775,17.375),(15.775,17.205),(15.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.545),(15.605,17.715),(15.775,17.715),(15.775,17.545),(15.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.125),(59.315,13.295),(59.485,13.295),(59.485,13.125),(59.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.125),(59.825,13.295),(59.995,13.295),(59.995,13.125),(59.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.465),(59.825,13.635),(59.995,13.635),(59.995,13.465),(59.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.805),(59.825,13.975),(59.995,13.975),(59.995,13.805),(59.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.465),(59.315,13.635),(59.485,13.635),(59.485,13.465),(59.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.385),(44.915,9.555),(45.085,9.555),(45.085,9.385),(44.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.725),(44.915,9.895),(45.085,9.895),(45.085,9.725),(44.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.985),(16.625,6.155),(16.795,6.155),(16.795,5.985),(16.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.985),(16.115,6.155),(16.285,6.155),(16.285,5.985),(16.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.805),(59.315,13.975),(59.485,13.975),(59.485,13.805),(59.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.805),(83.315,13.975),(83.485,13.975),(83.485,13.805),(83.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.125),(11.315,13.295),(11.485,13.295),(11.485,13.125),(11.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.125),(11.825,13.295),(11.995,13.295),(11.995,13.125),(11.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.125),(83.315,13.295),(83.485,13.295),(83.485,13.125),(83.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.805),(11.315,13.975),(11.485,13.975),(11.485,13.805),(11.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.385),(68.915,9.555),(69.085,9.555),(69.085,9.385),(68.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.065),(63.605,10.235),(63.775,10.235),(63.775,10.065),(63.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.725),(68.915,9.895),(69.085,9.895),(69.085,9.725),(68.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.465),(11.315,13.635),(11.485,13.635),(11.485,13.465),(11.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.405),(63.605,10.575),(63.775,10.575),(63.775,10.405),(63.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.865),(49.715,17.035),(49.885,17.035),(49.885,16.865),(49.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.745),(63.605,10.915),(63.775,10.915),(63.775,10.745),(63.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.865),(49.205,17.035),(49.375,17.035),(49.375,16.865),(49.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.905),(54.005,19.075),(54.175,19.075),(54.175,18.905),(54.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.905),(54.515,19.075),(54.685,19.075),(54.685,18.905),(54.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.985),(74.225,6.155),(74.395,6.155),(74.395,5.985),(74.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.965),(63.605,5.135),(63.775,5.135),(63.775,4.965),(63.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.705),(63.605,8.875),(63.775,8.875),(63.775,8.705),(63.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.025),(63.605,8.195),(63.775,8.195),(63.775,8.025),(63.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.365),(63.605,8.535),(63.775,8.535),(63.775,8.365),(63.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.905),(7.025,19.075),(7.195,19.075),(7.195,18.905),(7.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.625),(31.025,4.795),(31.195,4.795),(31.195,4.625),(31.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.285),(31.025,4.455),(31.195,4.455),(31.195,4.285),(31.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.085),(82.805,11.255),(82.975,11.255),(82.975,11.085),(82.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.425),(82.805,11.595),(82.975,11.595),(82.975,11.425),(82.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.765),(82.805,11.935),(82.975,11.935),(82.975,11.765),(82.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.525),(73.715,16.695),(73.885,16.695),(73.885,16.525),(73.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.185),(73.205,16.355),(73.375,16.355),(73.375,16.185),(73.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.185),(73.715,16.355),(73.885,16.355),(73.885,16.185),(73.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.525),(73.205,16.695),(73.375,16.695),(73.375,16.525),(73.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.205),(59.315,17.375),(59.485,17.375),(59.485,17.205),(59.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.545),(59.315,17.715),(59.485,17.715),(59.485,17.545),(59.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.545),(59.825,17.715),(59.995,17.715),(59.995,17.545),(59.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.205),(59.825,17.375),(59.995,17.375),(59.995,17.205),(59.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.465),(82.805,13.635),(82.975,13.635),(82.975,13.465),(82.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.125),(82.805,13.295),(82.975,13.295),(82.975,13.125),(82.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.805),(82.805,13.975),(82.975,13.975),(82.975,13.805),(82.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.885),(45.425,18.055),(45.595,18.055),(45.595,17.885),(45.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.905),(11.825,19.075),(11.995,19.075),(11.995,18.905),(11.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.905),(11.315,19.075),(11.485,19.075),(11.485,18.905),(11.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.705),(83.315,8.875),(83.485,8.875),(83.485,8.705),(83.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.705),(11.825,8.875),(11.995,8.875),(11.995,8.705),(11.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.025),(11.825,8.195),(11.995,8.195),(11.995,8.025),(11.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.025),(83.315,8.195),(83.485,8.195),(83.485,8.025),(83.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.845),(68.915,16.015),(69.085,16.015),(69.085,15.845),(68.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.025),(11.315,8.195),(11.485,8.195),(11.485,8.025),(11.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.365),(11.825,8.535),(11.995,8.535),(11.995,8.365),(11.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.365),(11.315,8.535),(11.485,8.535),(11.485,8.365),(11.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.705),(11.315,8.875),(11.485,8.875),(11.485,8.705),(11.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.905),(50.225,19.075),(50.395,19.075),(50.395,18.905),(50.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.845),(20.915,16.015),(21.085,16.015),(21.085,15.845),(20.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.405),(40.115,10.575),(40.285,10.575),(40.285,10.405),(40.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.405),(40.625,10.575),(40.795,10.575),(40.795,10.405),(40.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.745),(40.115,10.915),(40.285,10.915),(40.285,10.745),(40.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.745),(40.625,10.915),(40.795,10.915),(40.795,10.745),(40.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.065),(40.115,10.235),(40.285,10.235),(40.285,10.065),(40.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.065),(40.625,10.235),(40.795,10.235),(40.795,10.065),(40.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.845),(55.025,16.015),(55.195,16.015),(55.195,15.845),(55.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.505),(40.115,15.675),(40.285,15.675),(40.285,15.505),(40.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.505),(40.625,15.675),(40.795,15.675),(40.795,15.505),(40.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.165),(40.115,15.335),(40.285,15.335),(40.285,15.165),(40.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.165),(40.625,15.335),(40.795,15.335),(40.795,15.165),(40.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.205),(10.805,17.375),(10.975,17.375),(10.975,17.205),(10.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.545),(10.805,17.715),(10.975,17.715),(10.975,17.545),(10.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.245),(45.425,19.415),(45.595,19.415),(45.595,19.245),(45.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.025),(49.205,8.195),(49.375,8.195),(49.375,8.025),(49.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.705),(49.715,8.875),(49.885,8.875),(49.885,8.705),(49.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.365),(49.205,8.535),(49.375,8.535),(49.375,8.365),(49.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.705),(49.205,8.875),(49.375,8.875),(49.375,8.705),(49.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.365),(49.715,8.535),(49.885,8.535),(49.885,8.365),(49.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.045),(34.805,9.215),(34.975,9.215),(34.975,9.045),(34.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.325),(83.315,6.495),(83.485,6.495),(83.485,6.325),(83.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.665),(83.315,6.835),(83.485,6.835),(83.485,6.665),(83.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.905),(45.425,19.075),(45.595,19.075),(45.595,18.905),(45.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.065),(78.515,10.235),(78.685,10.235),(78.685,10.065),(78.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.405),(78.005,10.575),(78.175,10.575),(78.175,10.405),(78.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.405),(78.515,10.575),(78.685,10.575),(78.685,10.405),(78.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.065),(78.005,10.235),(78.175,10.235),(78.175,10.065),(78.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.765),(34.805,11.935),(34.975,11.935),(34.975,11.765),(34.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.085),(34.805,11.255),(34.975,11.255),(34.975,11.085),(34.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.425),(34.805,11.595),(34.975,11.595),(34.975,11.425),(34.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.465),(11.825,13.635),(11.995,13.635),(11.995,13.465),(11.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.745),(78.005,10.915),(78.175,10.915),(78.175,10.745),(78.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.745),(78.515,10.915),(78.685,10.915),(78.685,10.745),(78.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.485),(45.425,14.655),(45.595,14.655),(45.595,14.485),(45.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.825),(45.425,14.995),(45.595,14.995),(45.595,14.825),(45.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.145),(45.425,14.315),(45.595,14.315),(45.595,14.145),(45.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.605),(54.515,3.775),(54.685,3.775),(54.685,3.605),(54.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.265),(54.005,3.435),(54.175,3.435),(54.175,3.265),(54.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.605),(54.005,3.775),(54.175,3.775),(54.175,3.605),(54.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,2.925),(82.805,3.095),(82.975,3.095),(82.975,2.925),(82.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.265),(54.515,3.435),(54.685,3.435),(54.685,3.265),(54.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.965),(35.825,5.135),(35.995,5.135),(35.995,4.965),(35.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.965),(35.315,5.135),(35.485,5.135),(35.485,4.965),(35.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.905),(16.625,19.075),(16.795,19.075),(16.795,18.905),(16.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.905),(16.115,19.075),(16.285,19.075),(16.285,18.905),(16.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.965),(26.225,5.135),(26.395,5.135),(26.395,4.965),(26.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.265),(6.515,3.435),(6.685,3.435),(6.685,3.265),(6.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.605),(6.515,3.775),(6.685,3.775),(6.685,3.605),(6.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.945),(20.915,4.115),(21.085,4.115),(21.085,3.945),(20.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.865),(44.915,17.035),(45.085,17.035),(45.085,16.865),(44.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.205),(55.025,17.375),(55.195,17.375),(55.195,17.205),(55.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.545),(55.025,17.715),(55.195,17.715),(55.195,17.545),(55.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.445),(35.315,12.615),(35.485,12.615),(35.485,12.445),(35.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.785),(35.315,12.955),(35.485,12.955),(35.485,12.785),(35.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.445),(35.825,12.615),(35.995,12.615),(35.995,12.445),(35.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.785),(35.825,12.955),(35.995,12.955),(35.995,12.785),(35.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.105),(35.825,12.275),(35.995,12.275),(35.995,12.105),(35.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.105),(35.315,12.275),(35.485,12.275),(35.485,12.105),(35.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.865),(58.805,17.035),(58.975,17.035),(58.975,16.865),(58.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.685),(73.205,7.855),(73.375,7.855),(73.375,7.685),(73.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.685),(73.715,7.855),(73.885,7.855),(73.885,7.685),(73.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.125),(64.115,13.295),(64.285,13.295),(64.285,13.125),(64.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.125),(64.625,13.295),(64.795,13.295),(64.795,13.125),(64.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.465),(64.115,13.635),(64.285,13.635),(64.285,13.465),(64.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.805),(64.115,13.975),(64.285,13.975),(64.285,13.805),(64.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.805),(64.625,13.975),(64.795,13.975),(64.795,13.805),(64.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.465),(64.625,13.635),(64.795,13.635),(64.795,13.465),(64.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.205),(44.915,17.375),(45.085,17.375),(45.085,17.205),(44.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.545),(44.915,17.715),(45.085,17.715),(45.085,17.545),(44.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.185),(21.425,16.355),(21.595,16.355),(21.595,16.185),(21.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.525),(21.425,16.695),(21.595,16.695),(21.595,16.525),(21.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.865),(55.025,17.035),(55.195,17.035),(55.195,16.865),(55.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.025),(59.825,8.195),(59.995,8.195),(59.995,8.025),(59.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.365),(59.315,8.535),(59.485,8.535),(59.485,8.365),(59.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.705),(59.315,8.875),(59.485,8.875),(59.485,8.705),(59.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.365),(59.825,8.535),(59.995,8.535),(59.995,8.365),(59.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.705),(59.825,8.875),(59.995,8.875),(59.995,8.705),(59.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.245),(68.405,19.415),(68.575,19.415),(68.575,19.245),(68.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.305),(20.405,5.475),(20.575,5.475),(20.575,5.305),(20.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.645),(20.405,5.815),(20.575,5.815),(20.575,5.645),(20.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.265),(83.315,3.435),(83.485,3.435),(83.485,3.265),(83.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.605),(83.315,3.775),(83.485,3.775),(83.485,3.605),(83.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.365),(30.515,8.535),(30.685,8.535),(30.685,8.365),(30.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.705),(30.515,8.875),(30.685,8.875),(30.685,8.705),(30.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.365),(30.005,8.535),(30.175,8.535),(30.175,8.365),(30.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.705),(30.005,8.875),(30.175,8.875),(30.175,8.705),(30.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.025),(30.005,8.195),(30.175,8.195),(30.175,8.025),(30.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.985),(64.625,6.155),(64.795,6.155),(64.795,5.985),(64.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.605),(79.025,3.775),(79.195,3.775),(79.195,3.605),(79.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.985),(64.115,6.155),(64.285,6.155),(64.285,5.985),(64.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.325),(6.515,6.495),(6.685,6.495),(6.685,6.325),(6.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.665),(6.515,6.835),(6.685,6.835),(6.685,6.665),(6.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.265),(79.025,3.435),(79.195,3.435),(79.195,3.265),(79.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.405),(30.515,10.575),(30.685,10.575),(30.685,10.405),(30.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.065),(30.515,10.235),(30.685,10.235),(30.685,10.065),(30.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.145),(74.225,14.315),(74.395,14.315),(74.395,14.145),(74.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.745),(30.515,10.915),(30.685,10.915),(30.685,10.745),(30.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.745),(30.005,10.915),(30.175,10.915),(30.175,10.745),(30.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.825),(74.225,14.995),(74.395,14.995),(74.395,14.825),(74.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.565),(10.805,18.735),(10.975,18.735),(10.975,18.565),(10.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.225),(10.805,18.395),(10.975,18.395),(10.975,18.225),(10.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.265),(35.315,3.435),(35.485,3.435),(35.485,3.265),(35.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.605),(35.315,3.775),(35.485,3.775),(35.485,3.605),(35.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.265),(35.825,3.435),(35.995,3.435),(35.995,3.265),(35.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.605),(35.825,3.775),(35.995,3.775),(35.995,3.605),(35.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.985),(78.515,6.155),(78.685,6.155),(78.685,5.985),(78.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.985),(78.005,6.155),(78.175,6.155),(78.175,5.985),(78.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.965),(50.225,5.135),(50.395,5.135),(50.395,4.965),(50.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.725),(31.025,9.895),(31.195,9.895),(31.195,9.725),(31.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.385),(31.025,9.555),(31.195,9.555),(31.195,9.385),(31.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.985),(54.515,6.155),(54.685,6.155),(54.685,5.985),(54.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.985),(54.005,6.155),(54.175,6.155),(54.175,5.985),(54.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.485),(26.225,14.655),(26.395,14.655),(26.395,14.485),(26.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.825),(26.225,14.995),(26.395,14.995),(26.395,14.825),(26.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.145),(26.225,14.315),(26.395,14.315),(26.395,14.145),(26.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.985),(6.515,6.155),(6.685,6.155),(6.685,5.985),(6.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.265),(59.825,3.435),(59.995,3.435),(59.995,3.265),(59.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.605),(59.315,3.775),(59.485,3.775),(59.485,3.605),(59.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.605),(59.825,3.775),(59.995,3.775),(59.995,3.605),(59.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.265),(59.315,3.435),(59.485,3.435),(59.485,3.265),(59.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.465),(31.025,13.635),(31.195,13.635),(31.195,13.465),(31.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.805),(31.025,13.975),(31.195,13.975),(31.195,13.805),(31.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.125),(31.025,13.295),(31.195,13.295),(31.195,13.125),(31.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.185),(15.605,16.355),(15.775,16.355),(15.775,16.185),(15.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.525),(15.605,16.695),(15.775,16.695),(15.775,16.525),(15.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.365),(21.425,8.535),(21.595,8.535),(21.595,8.365),(21.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.705),(21.425,8.875),(21.595,8.875),(21.595,8.705),(21.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.025),(21.425,8.195),(21.595,8.195),(21.595,8.025),(21.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.625),(68.405,4.795),(68.575,4.795),(68.575,4.625),(68.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.285),(68.405,4.455),(68.575,4.455),(68.575,4.285),(68.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.965),(83.315,5.135),(83.485,5.135),(83.485,4.965),(83.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.325),(35.315,6.495),(35.485,6.495),(35.485,6.325),(35.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.665),(35.315,6.835),(35.485,6.835),(35.485,6.665),(35.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.665),(35.825,6.835),(35.995,6.835),(35.995,6.665),(35.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.325),(35.825,6.495),(35.995,6.495),(35.995,6.325),(35.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.285),(20.405,4.455),(20.575,4.455),(20.575,4.285),(20.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.625),(20.405,4.795),(20.575,4.795),(20.575,4.625),(20.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.265),(21.425,3.435),(21.595,3.435),(21.595,3.265),(21.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.605),(21.425,3.775),(21.595,3.775),(21.595,3.605),(21.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.185),(34.805,16.355),(34.975,16.355),(34.975,16.185),(34.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.525),(34.805,16.695),(34.975,16.695),(34.975,16.525),(34.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.225),(63.605,18.395),(63.775,18.395),(63.775,18.225),(63.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.565),(63.605,18.735),(63.775,18.735),(63.775,18.565),(63.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.265),(31.025,3.435),(31.195,3.435),(31.195,3.265),(31.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.605),(31.025,3.775),(31.195,3.775),(31.195,3.605),(31.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.265),(68.915,3.435),(69.085,3.435),(69.085,3.265),(68.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.605),(68.915,3.775),(69.085,3.775),(69.085,3.605),(68.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.845),(79.025,16.015),(79.195,16.015),(79.195,15.845),(79.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.945),(54.005,4.115),(54.175,4.115),(54.175,3.945),(54.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.945),(54.515,4.115),(54.685,4.115),(54.685,3.945),(54.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.245),(64.625,19.415),(64.795,19.415),(64.795,19.245),(64.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.985),(30.005,6.155),(30.175,6.155),(30.175,5.985),(30.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.105),(11.315,12.275),(11.485,12.275),(11.485,12.105),(11.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.245),(64.115,19.415),(64.285,19.415),(64.285,19.245),(64.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.985),(30.515,6.155),(30.685,6.155),(30.685,5.985),(30.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.445),(83.315,12.615),(83.485,12.615),(83.485,12.445),(83.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.785),(83.315,12.955),(83.485,12.955),(83.485,12.785),(83.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.785),(11.825,12.955),(11.995,12.955),(11.995,12.785),(11.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.445),(11.315,12.615),(11.485,12.615),(11.485,12.445),(11.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.445),(11.825,12.615),(11.995,12.615),(11.995,12.445),(11.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.785),(11.315,12.955),(11.485,12.955),(11.485,12.785),(11.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.105),(83.315,12.275),(83.485,12.275),(83.485,12.105),(83.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.505),(83.315,15.675),(83.485,15.675),(83.485,15.505),(83.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.325),(59.825,6.495),(59.995,6.495),(59.995,6.325),(59.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.665),(59.825,6.835),(59.995,6.835),(59.995,6.665),(59.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.905),(20.405,19.075),(20.575,19.075),(20.575,18.905),(20.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.325),(59.315,6.495),(59.485,6.495),(59.485,6.325),(59.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.665),(59.315,6.835),(59.485,6.835),(59.485,6.665),(59.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.225),(83.315,18.395),(83.485,18.395),(83.485,18.225),(83.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.565),(83.315,18.735),(83.485,18.735),(83.485,18.565),(83.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.945),(6.515,4.115),(6.685,4.115),(6.685,3.945),(6.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.525),(35.825,16.695),(35.995,16.695),(35.995,16.525),(35.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.185),(35.315,16.355),(35.485,16.355),(35.485,16.185),(35.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.525),(35.315,16.695),(35.485,16.695),(35.485,16.525),(35.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.045),(82.805,9.215),(82.975,9.215),(82.975,9.045),(82.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.505),(35.825,15.675),(35.995,15.675),(35.995,15.505),(35.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.505),(35.315,15.675),(35.485,15.675),(35.485,15.505),(35.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.165),(35.315,15.335),(35.485,15.335),(35.485,15.165),(35.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.165),(35.825,15.335),(35.995,15.335),(35.995,15.165),(35.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.185),(35.825,16.355),(35.995,16.355),(35.995,16.185),(35.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.305),(45.425,5.475),(45.595,5.475),(45.595,5.305),(45.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.645),(45.425,5.815),(45.595,5.815),(45.595,5.645),(45.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.265),(44.915,3.435),(45.085,3.435),(45.085,3.265),(44.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.605),(44.915,3.775),(45.085,3.775),(45.085,3.605),(44.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.185),(26.225,16.355),(26.395,16.355),(26.395,16.185),(26.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.525),(26.225,16.695),(26.395,16.695),(26.395,16.525),(26.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.845),(44.915,16.015),(45.085,16.015),(45.085,15.845),(44.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.445),(49.715,12.615),(49.885,12.615),(49.885,12.445),(49.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.785),(49.205,12.955),(49.375,12.955),(49.375,12.785),(49.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.785),(49.715,12.955),(49.885,12.955),(49.885,12.785),(49.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.445),(49.205,12.615),(49.375,12.615),(49.375,12.445),(49.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.105),(49.205,12.275),(49.375,12.275),(49.375,12.105),(49.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.905),(6.515,19.075),(6.685,19.075),(6.685,18.905),(6.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.105),(49.715,12.275),(49.885,12.275),(49.885,12.105),(49.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.265),(55.025,3.435),(55.195,3.435),(55.195,3.265),(55.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.605),(55.025,3.775),(55.195,3.775),(55.195,3.605),(55.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.045),(45.425,9.215),(45.595,9.215),(45.595,9.045),(45.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.905),(73.715,19.075),(73.885,19.075),(73.885,18.905),(73.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.905),(73.205,19.075),(73.375,19.075),(73.375,18.905),(73.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.985),(10.805,6.155),(10.975,6.155),(10.975,5.985),(10.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.945),(7.025,4.115),(7.195,4.115),(7.195,3.945),(7.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.305),(40.625,5.475),(40.795,5.475),(40.795,5.305),(40.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.645),(40.625,5.815),(40.795,5.815),(40.795,5.645),(40.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.645),(40.115,5.815),(40.285,5.815),(40.285,5.645),(40.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.845),(31.025,16.015),(31.195,16.015),(31.195,15.845),(31.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.305),(40.115,5.475),(40.285,5.475),(40.285,5.305),(40.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.045),(7.025,9.215),(7.195,9.215),(7.195,9.045),(7.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.845),(54.515,16.015),(54.685,16.015),(54.685,15.845),(54.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.845),(54.005,16.015),(54.175,16.015),(54.175,15.845),(54.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.885),(26.225,18.055),(26.395,18.055),(26.395,17.885),(26.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.225),(21.425,18.395),(21.595,18.395),(21.595,18.225),(21.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.565),(21.425,18.735),(21.595,18.735),(21.595,18.565),(21.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.245),(58.805,19.415),(58.975,19.415),(58.975,19.245),(58.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.025),(78.005,8.195),(78.175,8.195),(78.175,8.025),(78.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.025),(78.515,8.195),(78.685,8.195),(78.685,8.025),(78.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.365),(78.005,8.535),(78.175,8.535),(78.175,8.365),(78.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.705),(78.005,8.875),(78.175,8.875),(78.175,8.705),(78.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.365),(78.515,8.535),(78.685,8.535),(78.685,8.365),(78.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.705),(78.515,8.875),(78.685,8.875),(78.685,8.705),(78.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.205),(30.005,17.375),(30.175,17.375),(30.175,17.205),(30.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.545),(30.005,17.715),(30.175,17.715),(30.175,17.545),(30.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.205),(30.515,17.375),(30.685,17.375),(30.685,17.205),(30.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.545),(30.515,17.715),(30.685,17.715),(30.685,17.545),(30.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.945),(11.315,4.115),(11.485,4.115),(11.485,3.945),(11.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.945),(11.825,4.115),(11.995,4.115),(11.995,3.945),(11.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.845),(6.515,16.015),(6.685,16.015),(6.685,15.845),(6.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.885),(79.025,18.055),(79.195,18.055),(79.195,17.885),(79.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.305),(50.225,5.475),(50.395,5.475),(50.395,5.305),(50.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.645),(50.225,5.815),(50.395,5.815),(50.395,5.645),(50.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.505),(7.025,15.675),(7.195,15.675),(7.195,15.505),(7.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.165),(7.025,15.335),(7.195,15.335),(7.195,15.165),(7.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.605),(78.005,3.775),(78.175,3.775),(78.175,3.605),(78.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.265),(78.515,3.435),(78.685,3.435),(78.685,3.265),(78.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.385),(79.025,9.555),(79.195,9.555),(79.195,9.385),(79.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.725),(79.025,9.895),(79.195,9.895),(79.195,9.725),(79.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.625),(44.915,4.795),(45.085,4.795),(45.085,4.625),(44.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.285),(44.915,4.455),(45.085,4.455),(45.085,4.285),(44.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.605),(78.515,3.775),(78.685,3.775),(78.685,3.605),(78.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.265),(78.005,3.435),(78.175,3.435),(78.175,3.265),(78.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.965),(74.225,5.135),(74.395,5.135),(74.395,4.965),(74.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.105),(59.315,12.275),(59.485,12.275),(59.485,12.105),(59.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.105),(59.825,12.275),(59.995,12.275),(59.995,12.105),(59.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.445),(59.825,12.615),(59.995,12.615),(59.995,12.445),(59.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.445),(59.315,12.615),(59.485,12.615),(59.485,12.445),(59.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.785),(59.315,12.955),(59.485,12.955),(59.485,12.785),(59.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.785),(59.825,12.955),(59.995,12.955),(59.995,12.785),(59.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.945),(25.715,4.115),(25.885,4.115),(25.885,3.945),(25.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.945),(25.205,4.115),(25.375,4.115),(25.375,3.945),(25.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.105),(11.825,12.275),(11.995,12.275),(11.995,12.105),(11.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.985),(7.025,6.155),(7.195,6.155),(7.195,5.985),(7.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.265),(74.225,3.435),(74.395,3.435),(74.395,3.265),(74.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.605),(74.225,3.775),(74.395,3.775),(74.395,3.605),(74.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.605),(45.425,3.775),(45.595,3.775),(45.595,3.605),(45.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.265),(45.425,3.435),(45.595,3.435),(45.595,3.265),(45.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.305),(16.625,5.475),(16.795,5.475),(16.795,5.305),(16.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.645),(16.115,5.815),(16.285,5.815),(16.285,5.645),(16.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.305),(16.115,5.475),(16.285,5.475),(16.285,5.305),(16.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.645),(16.625,5.815),(16.795,5.815),(16.795,5.645),(16.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.285),(64.115,4.455),(64.285,4.455),(64.285,4.285),(64.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.625),(64.625,4.795),(64.795,4.795),(64.795,4.625),(64.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.285),(64.625,4.455),(64.795,4.455),(64.795,4.285),(64.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.125),(79.025,13.295),(79.195,13.295),(79.195,13.125),(79.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.465),(79.025,13.635),(79.195,13.635),(79.195,13.465),(79.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.805),(79.025,13.975),(79.195,13.975),(79.195,13.805),(79.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.625),(64.115,4.795),(64.285,4.795),(64.285,4.625),(64.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.445),(79.025,12.615),(79.195,12.615),(79.195,12.445),(79.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.785),(79.025,12.955),(79.195,12.955),(79.195,12.785),(79.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.225),(40.625,18.395),(40.795,18.395),(40.795,18.225),(40.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.225),(40.115,18.395),(40.285,18.395),(40.285,18.225),(40.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.105),(79.025,12.275),(79.195,12.275),(79.195,12.105),(79.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.565),(40.625,18.735),(40.795,18.735),(40.795,18.565),(40.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.565),(40.115,18.735),(40.285,18.735),(40.285,18.565),(40.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.285),(45.425,4.455),(45.595,4.455),(45.595,4.285),(45.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.625),(45.425,4.795),(45.595,4.795),(45.595,4.625),(45.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.665),(73.715,6.835),(73.885,6.835),(73.885,6.665),(73.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.665),(73.205,6.835),(73.375,6.835),(73.375,6.665),(73.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.325),(73.205,6.495),(73.375,6.495),(73.375,6.325),(73.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.325),(73.715,6.495),(73.885,6.495),(73.885,6.325),(73.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.305),(74.225,5.475),(74.395,5.475),(74.395,5.305),(74.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.645),(74.225,5.815),(74.395,5.815),(74.395,5.645),(74.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.305),(35.315,5.475),(35.485,5.475),(35.485,5.305),(35.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.645),(35.315,5.815),(35.485,5.815),(35.485,5.645),(35.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.645),(35.825,5.815),(35.995,5.815),(35.995,5.645),(35.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.505),(68.405,15.675),(68.575,15.675),(68.575,15.505),(68.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.305),(35.825,5.475),(35.995,5.475),(35.995,5.305),(35.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.165),(68.405,15.335),(68.575,15.335),(68.575,15.165),(68.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.145),(16.115,14.315),(16.285,14.315),(16.285,14.145),(16.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.145),(16.625,14.315),(16.795,14.315),(16.795,14.145),(16.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.485),(16.115,14.655),(16.285,14.655),(16.285,14.485),(16.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.825),(16.115,14.995),(16.285,14.995),(16.285,14.825),(16.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.485),(16.625,14.655),(16.795,14.655),(16.795,14.485),(16.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.825),(16.625,14.995),(16.795,14.995),(16.795,14.825),(16.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.005),(74.225,7.175),(74.395,7.175),(74.395,7.005),(74.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.885),(34.805,18.055),(34.975,18.055),(34.975,17.885),(34.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.505),(20.405,15.675),(20.575,15.675),(20.575,15.505),(20.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.165),(20.405,15.335),(20.575,15.335),(20.575,15.165),(20.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.985),(58.805,6.155),(58.975,6.155),(58.975,5.985),(58.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.945),(49.205,4.115),(49.375,4.115),(49.375,3.945),(49.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.945),(49.715,4.115),(49.885,4.115),(49.885,3.945),(49.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.865),(40.115,17.035),(40.285,17.035),(40.285,16.865),(40.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.865),(40.625,17.035),(40.795,17.035),(40.795,16.865),(40.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.545),(25.715,17.715),(25.885,17.715),(25.885,17.545),(25.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.205),(25.715,17.375),(25.885,17.375),(25.885,17.205),(25.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.205),(25.205,17.375),(25.375,17.375),(25.375,17.205),(25.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.545),(25.205,17.715),(25.375,17.715),(25.375,17.545),(25.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.985),(34.805,6.155),(34.975,6.155),(34.975,5.985),(34.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.205),(7.025,17.375),(7.195,17.375),(7.195,17.205),(7.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.545),(7.025,17.715),(7.195,17.715),(7.195,17.545),(7.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.365),(83.315,8.535),(83.485,8.535),(83.485,8.365),(83.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.645),(59.315,5.815),(59.485,5.815),(59.485,5.645),(59.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.205),(63.605,17.375),(63.775,17.375),(63.775,17.205),(63.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.105),(50.225,12.275),(50.395,12.275),(50.395,12.105),(50.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.545),(63.605,17.715),(63.775,17.715),(63.775,17.545),(63.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.305),(59.315,5.475),(59.485,5.475),(59.485,5.305),(59.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.785),(50.225,12.955),(50.395,12.955),(50.395,12.785),(50.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.445),(50.225,12.615),(50.395,12.615),(50.395,12.445),(50.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.305),(59.825,5.475),(59.995,5.475),(59.995,5.305),(59.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.645),(59.825,5.815),(59.995,5.815),(59.995,5.645),(59.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.045),(55.025,9.215),(55.195,9.215),(55.195,9.045),(55.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.985),(31.025,6.155),(31.195,6.155),(31.195,5.985),(31.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.865),(20.405,17.035),(20.575,17.035),(20.575,16.865),(20.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.225),(30.005,18.395),(30.175,18.395),(30.175,18.225),(30.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.565),(30.005,18.735),(30.175,18.735),(30.175,18.565),(30.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.565),(30.515,18.735),(30.685,18.735),(30.685,18.565),(30.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.225),(30.515,18.395),(30.685,18.395),(30.685,18.225),(30.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.365),(45.425,8.535),(45.595,8.535),(45.595,8.365),(45.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.705),(45.425,8.875),(45.595,8.875),(45.595,8.705),(45.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.025),(45.425,8.195),(45.595,8.195),(45.595,8.025),(45.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.205),(11.315,17.375),(11.485,17.375),(11.485,17.205),(11.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.545),(11.315,17.715),(11.485,17.715),(11.485,17.545),(11.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.205),(11.825,17.375),(11.995,17.375),(11.995,17.205),(11.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.545),(11.825,17.715),(11.995,17.715),(11.995,17.545),(11.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.225),(68.915,18.395),(69.085,18.395),(69.085,18.225),(68.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.565),(68.915,18.735),(69.085,18.735),(69.085,18.565),(68.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.365),(69.425,8.535),(69.595,8.535),(69.595,8.365),(69.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.705),(69.425,8.875),(69.595,8.875),(69.595,8.705),(69.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.025),(69.425,8.195),(69.595,8.195),(69.595,8.025),(69.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.505),(55.025,15.675),(55.195,15.675),(55.195,15.505),(55.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.165),(55.025,15.335),(55.195,15.335),(55.195,15.165),(55.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.285),(16.625,4.455),(16.795,4.455),(16.795,4.285),(16.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.285),(16.115,4.455),(16.285,4.455),(16.285,4.285),(16.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.625),(16.115,4.795),(16.285,4.795),(16.285,4.625),(16.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.625),(16.625,4.795),(16.795,4.795),(16.795,4.625),(16.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.485),(20.915,14.655),(21.085,14.655),(21.085,14.485),(20.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.825),(20.915,14.995),(21.085,14.995),(21.085,14.825),(20.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.105),(31.025,12.275),(31.195,12.275),(31.195,12.105),(31.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.445),(31.025,12.615),(31.195,12.615),(31.195,12.445),(31.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.785),(31.025,12.955),(31.195,12.955),(31.195,12.785),(31.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.145),(20.915,14.315),(21.085,14.315),(21.085,14.145),(20.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.265),(73.715,3.435),(73.885,3.435),(73.885,3.265),(73.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.265),(73.205,3.435),(73.375,3.435),(73.375,3.265),(73.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.605),(73.205,3.775),(73.375,3.775),(73.375,3.605),(73.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.605),(68.405,3.775),(68.575,3.775),(68.575,3.605),(68.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.265),(68.405,3.435),(68.575,3.435),(68.575,3.265),(68.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.605),(73.715,3.775),(73.885,3.775),(73.885,3.605),(73.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.305),(44.915,5.475),(45.085,5.475),(45.085,5.305),(44.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.645),(44.915,5.815),(45.085,5.815),(45.085,5.645),(44.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.165),(50.225,15.335),(50.395,15.335),(50.395,15.165),(50.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.505),(50.225,15.675),(50.395,15.675),(50.395,15.505),(50.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.505),(59.825,15.675),(59.995,15.675),(59.995,15.505),(59.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.505),(59.315,15.675),(59.485,15.675),(59.485,15.505),(59.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.165),(59.825,15.335),(59.995,15.335),(59.995,15.165),(59.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.165),(59.315,15.335),(59.485,15.335),(59.485,15.165),(59.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.945),(78.515,4.115),(78.685,4.115),(78.685,3.945),(78.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.945),(78.005,4.115),(78.175,4.115),(78.175,3.945),(78.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.885),(44.405,18.055),(44.575,18.055),(44.575,17.885),(44.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.165),(11.315,15.335),(11.485,15.335),(11.485,15.165),(11.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.165),(11.825,15.335),(11.995,15.335),(11.995,15.165),(11.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.505),(11.315,15.675),(11.485,15.675),(11.485,15.505),(11.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.505),(11.825,15.675),(11.995,15.675),(11.995,15.505),(11.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.145),(83.315,14.315),(83.485,14.315),(83.485,14.145),(83.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.485),(83.315,14.655),(83.485,14.655),(83.485,14.485),(83.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.825),(83.315,14.995),(83.485,14.995),(83.485,14.825),(83.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.605),(44.405,3.775),(44.575,3.775),(44.575,3.605),(44.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.265),(44.405,3.435),(44.575,3.435),(44.575,3.265),(44.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.725),(73.205,9.895),(73.375,9.895),(73.375,9.725),(73.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.725),(73.715,9.895),(73.885,9.895),(73.885,9.725),(73.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.385),(73.715,9.555),(73.885,9.555),(73.885,9.385),(73.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.385),(73.205,9.555),(73.375,9.555),(73.375,9.385),(73.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.285),(40.625,4.455),(40.795,4.455),(40.795,4.285),(40.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.285),(40.115,4.455),(40.285,4.455),(40.285,4.285),(40.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.625),(40.625,4.795),(40.795,4.795),(40.795,4.625),(40.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.625),(40.115,4.795),(40.285,4.795),(40.285,4.625),(40.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.945),(74.225,4.115),(74.395,4.115),(74.395,3.945),(74.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.385),(25.715,9.555),(25.885,9.555),(25.885,9.385),(25.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.385),(25.205,9.555),(25.375,9.555),(25.375,9.385),(25.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.725),(25.715,9.895),(25.885,9.895),(25.885,9.725),(25.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.725),(25.205,9.895),(25.375,9.895),(25.375,9.725),(25.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.725),(20.405,9.895),(20.575,9.895),(20.575,9.725),(20.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.385),(20.405,9.555),(20.575,9.555),(20.575,9.385),(20.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.045),(78.005,9.215),(78.175,9.215),(78.175,9.045),(78.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.045),(78.515,9.215),(78.685,9.215),(78.685,9.045),(78.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.845),(68.405,16.015),(68.575,16.015),(68.575,15.845),(68.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.865),(10.805,17.035),(10.975,17.035),(10.975,16.865),(10.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.845),(20.405,16.015),(20.575,16.015),(20.575,15.845),(20.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.645),(64.625,5.815),(64.795,5.815),(64.795,5.645),(64.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.305),(64.115,5.475),(64.285,5.475),(64.285,5.305),(64.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.305),(64.625,5.475),(64.795,5.475),(64.795,5.305),(64.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.645),(64.115,5.815),(64.285,5.815),(64.285,5.645),(64.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.865),(25.715,17.035),(25.885,17.035),(25.885,16.865),(25.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.865),(25.205,17.035),(25.375,17.035),(25.375,16.865),(25.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.865),(7.025,17.035),(7.195,17.035),(7.195,16.865),(7.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.885),(31.025,18.055),(31.195,18.055),(31.195,17.885),(31.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.805),(20.405,13.975),(20.575,13.975),(20.575,13.805),(20.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.465),(20.405,13.635),(20.575,13.635),(20.575,13.465),(20.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.125),(20.405,13.295),(20.575,13.295),(20.575,13.125),(20.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.305),(78.515,5.475),(78.685,5.475),(78.685,5.305),(78.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.645),(78.515,5.815),(78.685,5.815),(78.685,5.645),(78.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.305),(78.005,5.475),(78.175,5.475),(78.175,5.305),(78.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.645),(78.005,5.815),(78.175,5.815),(78.175,5.645),(78.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.265),(50.225,3.435),(50.395,3.435),(50.395,3.265),(50.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.305),(54.515,5.475),(54.685,5.475),(54.685,5.305),(54.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.645),(54.515,5.815),(54.685,5.815),(54.685,5.645),(54.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.605),(50.225,3.775),(50.395,3.775),(50.395,3.605),(50.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.305),(54.005,5.475),(54.175,5.475),(54.175,5.305),(54.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.645),(54.005,5.815),(54.175,5.815),(54.175,5.645),(54.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.145),(64.625,14.315),(64.795,14.315),(64.795,14.145),(64.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.145),(64.115,14.315),(64.285,14.315),(64.285,14.145),(64.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.485),(64.115,14.655),(64.285,14.655),(64.285,14.485),(64.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.825),(64.115,14.995),(64.285,14.995),(64.285,14.825),(64.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.485),(64.625,14.655),(64.795,14.655),(64.795,14.485),(64.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.825),(64.625,14.995),(64.795,14.995),(64.795,14.825),(64.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.145),(55.025,14.315),(55.195,14.315),(55.195,14.145),(55.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.485),(55.025,14.655),(55.195,14.655),(55.195,14.485),(55.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.165),(30.515,15.335),(30.685,15.335),(30.685,15.165),(30.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.165),(30.005,15.335),(30.175,15.335),(30.175,15.165),(30.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.505),(30.515,15.675),(30.685,15.675),(30.685,15.505),(30.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.505),(30.005,15.675),(30.175,15.675),(30.175,15.505),(30.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.825),(55.025,14.995),(55.195,14.995),(55.195,14.825),(55.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.305),(6.515,5.475),(6.685,5.475),(6.685,5.305),(6.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.645),(6.515,5.815),(6.685,5.815),(6.685,5.645),(6.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.865),(78.005,17.035),(78.175,17.035),(78.175,16.865),(78.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.865),(78.515,17.035),(78.685,17.035),(78.685,16.865),(78.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.905),(15.605,19.075),(15.775,19.075),(15.775,18.905),(15.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.985),(82.805,6.155),(82.975,6.155),(82.975,5.985),(82.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.485),(7.025,14.655),(7.195,14.655),(7.195,14.485),(7.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.825),(7.025,14.995),(7.195,14.995),(7.195,14.825),(7.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.145),(7.025,14.315),(7.195,14.315),(7.195,14.145),(7.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.945),(69.425,4.115),(69.595,4.115),(69.595,3.945),(69.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.445),(68.915,12.615),(69.085,12.615),(69.085,12.445),(68.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.785),(68.915,12.955),(69.085,12.955),(69.085,12.785),(68.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.105),(68.915,12.275),(69.085,12.275),(69.085,12.105),(68.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.085),(79.025,11.255),(79.195,11.255),(79.195,11.085),(79.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.765),(79.025,11.935),(79.195,11.935),(79.195,11.765),(79.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.245),(25.205,19.415),(25.375,19.415),(25.375,19.245),(25.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.945),(40.625,4.115),(40.795,4.115),(40.795,3.945),(40.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.945),(40.115,4.115),(40.285,4.115),(40.285,3.945),(40.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.245),(25.715,19.415),(25.885,19.415),(25.885,19.245),(25.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.425),(79.025,11.595),(79.195,11.595),(79.195,11.425),(79.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.845),(50.225,16.015),(50.395,16.015),(50.395,15.845),(50.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.045),(30.515,9.215),(30.685,9.215),(30.685,9.045),(30.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.045),(30.005,9.215),(30.175,9.215),(30.175,9.045),(30.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.105),(20.915,12.275),(21.085,12.275),(21.085,12.105),(20.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.445),(20.915,12.615),(21.085,12.615),(21.085,12.445),(20.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.785),(20.915,12.955),(21.085,12.955),(21.085,12.785),(20.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.425),(30.005,11.595),(30.175,11.595),(30.175,11.425),(30.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.425),(30.515,11.595),(30.685,11.595),(30.685,11.425),(30.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.085),(30.005,11.255),(30.175,11.255),(30.175,11.085),(30.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.085),(30.515,11.255),(30.685,11.255),(30.685,11.085),(30.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.245),(10.805,19.415),(10.975,19.415),(10.975,19.245),(10.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.765),(30.005,11.935),(30.175,11.935),(30.175,11.765),(30.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.765),(30.515,11.935),(30.685,11.935),(30.685,11.765),(30.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.025),(50.225,8.195),(50.395,8.195),(50.395,8.025),(50.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.705),(50.225,8.875),(50.395,8.875),(50.395,8.705),(50.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.365),(50.225,8.535),(50.395,8.535),(50.395,8.365),(50.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.485),(35.825,14.655),(35.995,14.655),(35.995,14.485),(35.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.825),(35.825,14.995),(35.995,14.995),(35.995,14.825),(35.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.485),(35.315,14.655),(35.485,14.655),(35.485,14.485),(35.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.825),(35.315,14.995),(35.485,14.995),(35.485,14.825),(35.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.305),(83.315,5.475),(83.485,5.475),(83.485,5.305),(83.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.645),(83.315,5.815),(83.485,5.815),(83.485,5.645),(83.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.165),(44.405,15.335),(44.575,15.335),(44.575,15.165),(44.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.505),(44.405,15.675),(44.575,15.675),(44.575,15.505),(44.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.145),(35.825,14.315),(35.995,14.315),(35.995,14.145),(35.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.505),(10.805,15.675),(10.975,15.675),(10.975,15.505),(10.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.165),(10.805,15.335),(10.975,15.335),(10.975,15.165),(10.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.065),(50.225,10.235),(50.395,10.235),(50.395,10.065),(50.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.745),(50.225,10.915),(50.395,10.915),(50.395,10.745),(50.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.405),(50.225,10.575),(50.395,10.575),(50.395,10.405),(50.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.305),(30.515,5.475),(30.685,5.475),(30.685,5.305),(30.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.645),(30.005,5.815),(30.175,5.815),(30.175,5.645),(30.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.305),(30.005,5.475),(30.175,5.475),(30.175,5.305),(30.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.645),(30.515,5.815),(30.685,5.815),(30.685,5.645),(30.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.045),(15.605,9.215),(15.775,9.215),(15.775,9.045),(15.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.785),(30.515,12.955),(30.685,12.955),(30.685,12.785),(30.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.445),(30.515,12.615),(30.685,12.615),(30.685,12.445),(30.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.105),(30.515,12.275),(30.685,12.275),(30.685,12.105),(30.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.105),(30.005,12.275),(30.175,12.275),(30.175,12.105),(30.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.785),(30.005,12.955),(30.175,12.955),(30.175,12.785),(30.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.445),(30.005,12.615),(30.175,12.615),(30.175,12.445),(30.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.245),(78.005,19.415),(78.175,19.415),(78.175,19.245),(78.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.245),(78.515,19.415),(78.685,19.415),(78.685,19.245),(78.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.245),(55.025,19.415),(55.195,19.415),(55.195,19.245),(55.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.425),(25.715,11.595),(25.885,11.595),(25.885,11.425),(25.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.425),(25.205,11.595),(25.375,11.595),(25.375,11.425),(25.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.085),(25.205,11.255),(25.375,11.255),(25.375,11.085),(25.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.085),(25.715,11.255),(25.885,11.255),(25.885,11.085),(25.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.945),(16.625,4.115),(16.795,4.115),(16.795,3.945),(16.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.765),(25.715,11.935),(25.885,11.935),(25.885,11.765),(25.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.765),(25.205,11.935),(25.375,11.935),(25.375,11.765),(25.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.945),(16.115,4.115),(16.285,4.115),(16.285,3.945),(16.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.505),(15.605,15.675),(15.775,15.675),(15.775,15.505),(15.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.165),(15.605,15.335),(15.775,15.335),(15.775,15.165),(15.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.765),(31.025,11.935),(31.195,11.935),(31.195,11.765),(31.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.085),(31.025,11.255),(31.195,11.255),(31.195,11.085),(31.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.425),(31.025,11.595),(31.195,11.595),(31.195,11.425),(31.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.525),(82.805,16.695),(82.975,16.695),(82.975,16.525),(82.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.185),(82.805,16.355),(82.975,16.355),(82.975,16.185),(82.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.905),(58.805,19.075),(58.975,19.075),(58.975,18.905),(58.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.625),(11.315,4.795),(11.485,4.795),(11.485,4.625),(11.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.625),(11.825,4.795),(11.995,4.795),(11.995,4.625),(11.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.285),(11.825,4.455),(11.995,4.455),(11.995,4.285),(11.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.285),(11.315,4.455),(11.485,4.455),(11.485,4.285),(11.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.645),(68.915,5.815),(69.085,5.815),(69.085,5.645),(68.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.305),(68.915,5.475),(69.085,5.475),(69.085,5.305),(68.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.105),(58.805,12.275),(58.975,12.275),(58.975,12.105),(58.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.785),(58.805,12.955),(58.975,12.955),(58.975,12.785),(58.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.445),(58.805,12.615),(58.975,12.615),(58.975,12.445),(58.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.485),(68.915,14.655),(69.085,14.655),(69.085,14.485),(68.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.825),(68.915,14.995),(69.085,14.995),(69.085,14.825),(68.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.145),(68.915,14.315),(69.085,14.315),(69.085,14.145),(68.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.505),(68.915,15.675),(69.085,15.675),(69.085,15.505),(68.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.305),(10.805,5.475),(10.975,5.475),(10.975,5.305),(10.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.645),(10.805,5.815),(10.975,5.815),(10.975,5.645),(10.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.165),(68.915,15.335),(69.085,15.335),(69.085,15.165),(68.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.045),(63.605,9.215),(63.775,9.215),(63.775,9.045),(63.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.845),(30.005,16.015),(30.175,16.015),(30.175,15.845),(30.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.845),(30.515,16.015),(30.685,16.015),(30.685,15.845),(30.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.445),(10.805,12.615),(10.975,12.615),(10.975,12.445),(10.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.785),(10.805,12.955),(10.975,12.955),(10.975,12.785),(10.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.105),(10.805,12.275),(10.975,12.275),(10.975,12.105),(10.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.605),(15.605,3.775),(15.775,3.775),(15.775,3.605),(15.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.265),(15.605,3.435),(15.775,3.435),(15.775,3.265),(15.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.165),(20.915,15.335),(21.085,15.335),(21.085,15.165),(20.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.505),(20.915,15.675),(21.085,15.675),(21.085,15.505),(20.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.945),(50.225,4.115),(50.395,4.115),(50.395,3.945),(50.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.005),(26.225,7.175),(26.395,7.175),(26.395,7.005),(26.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.345),(26.225,7.515),(26.395,7.515),(26.395,7.345),(26.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.225),(69.425,18.395),(69.595,18.395),(69.595,18.225),(69.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.565),(69.425,18.735),(69.595,18.735),(69.595,18.565),(69.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.245),(16.115,19.415),(16.285,19.415),(16.285,19.245),(16.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.245),(16.625,19.415),(16.795,19.415),(16.795,19.245),(16.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.505),(63.605,15.675),(63.775,15.675),(63.775,15.505),(63.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.165),(63.605,15.335),(63.775,15.335),(63.775,15.165),(63.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.205),(26.225,17.375),(26.395,17.375),(26.395,17.205),(26.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.545),(26.225,17.715),(26.395,17.715),(26.395,17.545),(26.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.385),(54.515,9.555),(54.685,9.555),(54.685,9.385),(54.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.725),(54.515,9.895),(54.685,9.895),(54.685,9.725),(54.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.385),(54.005,9.555),(54.175,9.555),(54.175,9.385),(54.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.725),(54.005,9.895),(54.175,9.895),(54.175,9.725),(54.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.145),(11.825,14.315),(11.995,14.315),(11.995,14.145),(11.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.145),(11.315,14.315),(11.485,14.315),(11.485,14.145),(11.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.485),(11.315,14.655),(11.485,14.655),(11.485,14.485),(11.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.825),(11.315,14.995),(11.485,14.995),(11.485,14.825),(11.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.485),(11.825,14.655),(11.995,14.655),(11.995,14.485),(11.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.825),(11.825,14.995),(11.995,14.995),(11.995,14.825),(11.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.165),(58.805,15.335),(58.975,15.335),(58.975,15.165),(58.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.385),(6.515,9.555),(6.685,9.555),(6.685,9.385),(6.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.725),(6.515,9.895),(6.685,9.895),(6.685,9.725),(6.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.505),(58.805,15.675),(58.975,15.675),(58.975,15.505),(58.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.385),(44.405,9.555),(44.575,9.555),(44.575,9.385),(44.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.725),(44.405,9.895),(44.575,9.895),(44.575,9.725),(44.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.165),(78.005,15.335),(78.175,15.335),(78.175,15.165),(78.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.165),(78.515,15.335),(78.685,15.335),(78.685,15.165),(78.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.505),(78.515,15.675),(78.685,15.675),(78.685,15.505),(78.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.505),(78.005,15.675),(78.175,15.675),(78.175,15.505),(78.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.485),(74.225,14.655),(74.395,14.655),(74.395,14.485),(74.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.985),(69.425,6.155),(69.595,6.155),(69.595,5.985),(69.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.385),(68.405,9.555),(68.575,9.555),(68.575,9.385),(68.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.725),(68.405,9.895),(68.575,9.895),(68.575,9.725),(68.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.045),(49.205,9.215),(49.375,9.215),(49.375,9.045),(49.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.045),(49.715,9.215),(49.885,9.215),(49.885,9.045),(49.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.845),(44.405,16.015),(44.575,16.015),(44.575,15.845),(44.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.985),(21.425,6.155),(21.595,6.155),(21.595,5.985),(21.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.185),(69.425,16.355),(69.595,16.355),(69.595,16.185),(69.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.525),(69.425,16.695),(69.595,16.695),(69.595,16.525),(69.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.565),(34.805,18.735),(34.975,18.735),(34.975,18.565),(34.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.225),(34.805,18.395),(34.975,18.395),(34.975,18.225),(34.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.525),(63.605,16.695),(63.775,16.695),(63.775,16.525),(63.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.185),(63.605,16.355),(63.775,16.355),(63.775,16.185),(63.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.805),(44.405,13.975),(44.575,13.975),(44.575,13.805),(44.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.125),(44.405,13.295),(44.575,13.295),(44.575,13.125),(44.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.465),(44.405,13.635),(44.575,13.635),(44.575,13.465),(44.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.565),(35.825,18.735),(35.995,18.735),(35.995,18.565),(35.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.225),(35.825,18.395),(35.995,18.395),(35.995,18.225),(35.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.085),(78.005,11.255),(78.175,11.255),(78.175,11.085),(78.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.085),(78.515,11.255),(78.685,11.255),(78.685,11.085),(78.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.765),(78.515,11.935),(78.685,11.935),(78.685,11.765),(78.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.765),(78.005,11.935),(78.175,11.935),(78.175,11.765),(78.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.225),(35.315,18.395),(35.485,18.395),(35.485,18.225),(35.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.565),(35.315,18.735),(35.485,18.735),(35.485,18.565),(35.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.425),(78.515,11.595),(78.685,11.595),(78.685,11.425),(78.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.425),(78.005,11.595),(78.175,11.595),(78.175,11.425),(78.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.625),(59.315,4.795),(59.485,4.795),(59.485,4.625),(59.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.285),(59.825,4.455),(59.995,4.455),(59.995,4.285),(59.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.625),(59.825,4.795),(59.995,4.795),(59.995,4.625),(59.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.285),(59.315,4.455),(59.485,4.455),(59.485,4.285),(59.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.145),(6.515,14.315),(6.685,14.315),(6.685,14.145),(6.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.825),(6.515,14.995),(6.685,14.995),(6.685,14.825),(6.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.485),(6.515,14.655),(6.685,14.655),(6.685,14.485),(6.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.125),(68.405,13.295),(68.575,13.295),(68.575,13.125),(68.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.465),(68.405,13.635),(68.575,13.635),(68.575,13.465),(68.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.805),(68.405,13.975),(68.575,13.975),(68.575,13.805),(68.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.205),(73.205,17.375),(73.375,17.375),(73.375,17.205),(73.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.545),(73.715,17.715),(73.885,17.715),(73.885,17.545),(73.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.205),(73.715,17.375),(73.885,17.375),(73.885,17.205),(73.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.545),(73.205,17.715),(73.375,17.715),(73.375,17.545),(73.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.205),(34.805,17.375),(34.975,17.375),(34.975,17.205),(34.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.545),(34.805,17.715),(34.975,17.715),(34.975,17.545),(34.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.685),(21.425,7.855),(21.595,7.855),(21.595,7.685),(21.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.345),(21.425,7.515),(21.595,7.515),(21.595,7.345),(21.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.645),(25.205,5.815),(25.375,5.815),(25.375,5.645),(25.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.305),(25.205,5.475),(25.375,5.475),(25.375,5.305),(25.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.305),(25.715,5.475),(25.885,5.475),(25.885,5.305),(25.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.645),(25.715,5.815),(25.885,5.815),(25.885,5.645),(25.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.005),(21.425,7.175),(21.595,7.175),(21.595,7.005),(21.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.305),(58.805,5.475),(58.975,5.475),(58.975,5.305),(58.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.645),(58.805,5.815),(58.975,5.815),(58.975,5.645),(58.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.825),(44.915,14.995),(45.085,14.995),(45.085,14.825),(44.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.865),(30.515,17.035),(30.685,17.035),(30.685,16.865),(30.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.865),(30.005,17.035),(30.175,17.035),(30.175,16.865),(30.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.305),(34.805,5.475),(34.975,5.475),(34.975,5.305),(34.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.645),(34.805,5.815),(34.975,5.815),(34.975,5.645),(34.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.865),(68.405,17.035),(68.575,17.035),(68.575,16.865),(68.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.925),(55.025,3.095),(55.195,3.095),(55.195,2.925),(55.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.445),(78.515,12.615),(78.685,12.615),(78.685,12.445),(78.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.445),(78.005,12.615),(78.175,12.615),(78.175,12.445),(78.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.785),(78.005,12.955),(78.175,12.955),(78.175,12.785),(78.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.785),(78.515,12.955),(78.685,12.955),(78.685,12.785),(78.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.725),(26.225,9.895),(26.395,9.895),(26.395,9.725),(26.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.385),(26.225,9.555),(26.395,9.555),(26.395,9.385),(26.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.105),(78.005,12.275),(78.175,12.275),(78.175,12.105),(78.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.105),(78.515,12.275),(78.685,12.275),(78.685,12.105),(78.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.225),(26.225,18.395),(26.395,18.395),(26.395,18.225),(26.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.565),(26.225,18.735),(26.395,18.735),(26.395,18.565),(26.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.945),(39.605,4.115),(39.775,4.115),(39.775,3.945),(39.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,2.925),(7.025,3.095),(7.195,3.095),(7.195,2.925),(7.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.385),(39.605,9.555),(39.775,9.555),(39.775,9.385),(39.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.725),(39.605,9.895),(39.775,9.895),(39.775,9.725),(39.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.965),(68.915,5.135),(69.085,5.135),(69.085,4.965),(68.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.825),(59.825,14.995),(59.995,14.995),(59.995,14.825),(59.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.485),(59.825,14.655),(59.995,14.655),(59.995,14.485),(59.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.825),(59.315,14.995),(59.485,14.995),(59.485,14.825),(59.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.485),(59.315,14.655),(59.485,14.655),(59.485,14.485),(59.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.145),(59.825,14.315),(59.995,14.315),(59.995,14.145),(59.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,2.925),(74.225,3.095),(74.395,3.095),(74.395,2.925),(74.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,2.925),(11.315,3.095),(11.485,3.095),(11.485,2.925),(11.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,2.925),(11.825,3.095),(11.995,3.095),(11.995,2.925),(11.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.125),(20.915,13.295),(21.085,13.295),(21.085,13.125),(20.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.465),(20.915,13.635),(21.085,13.635),(21.085,13.465),(20.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.805),(20.915,13.975),(21.085,13.975),(21.085,13.805),(20.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.305),(49.715,5.475),(49.885,5.475),(49.885,5.305),(49.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.645),(49.715,5.815),(49.885,5.815),(49.885,5.645),(49.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.645),(49.205,5.815),(49.375,5.815),(49.375,5.645),(49.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.965),(20.915,5.135),(21.085,5.135),(21.085,4.965),(20.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.305),(49.205,5.475),(49.375,5.475),(49.375,5.305),(49.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,2.925),(26.225,3.095),(26.395,3.095),(26.395,2.925),(26.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.965),(79.025,5.135),(79.195,5.135),(79.195,4.965),(79.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.465),(39.605,13.635),(39.775,13.635),(39.775,13.465),(39.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.805),(39.605,13.975),(39.775,13.975),(39.775,13.805),(39.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.125),(39.605,13.295),(39.775,13.295),(39.775,13.125),(39.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.025),(79.025,8.195),(79.195,8.195),(79.195,8.025),(79.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.365),(79.025,8.535),(79.195,8.535),(79.195,8.365),(79.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.705),(79.025,8.875),(79.195,8.875),(79.195,8.705),(79.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.845),(78.005,16.015),(78.175,16.015),(78.175,15.845),(78.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.845),(78.515,16.015),(78.685,16.015),(78.685,15.845),(78.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.965),(55.025,5.135),(55.195,5.135),(55.195,4.965),(55.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,2.925),(25.715,3.095),(25.885,3.095),(25.885,2.925),(25.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,2.925),(25.205,3.095),(25.375,3.095),(25.375,2.925),(25.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.905),(68.405,19.075),(68.575,19.075),(68.575,18.905),(68.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.245),(30.005,19.415),(30.175,19.415),(30.175,19.245),(30.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.245),(30.515,19.415),(30.685,19.415),(30.685,19.245),(30.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.205),(44.405,17.375),(44.575,17.375),(44.575,17.205),(44.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.545),(44.405,17.715),(44.575,17.715),(44.575,17.545),(44.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.945),(63.605,4.115),(63.775,4.115),(63.775,3.945),(63.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.925),(31.025,3.095),(31.195,3.095),(31.195,2.925),(31.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.905),(78.515,19.075),(78.685,19.075),(78.685,18.905),(78.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.905),(78.005,19.075),(78.175,19.075),(78.175,18.905),(78.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.965),(7.025,5.135),(7.195,5.135),(7.195,4.965),(7.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.125),(35.315,13.295),(35.485,13.295),(35.485,13.125),(35.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.985),(39.605,6.155),(39.775,6.155),(39.775,5.985),(39.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.025),(58.805,8.195),(58.975,8.195),(58.975,8.025),(58.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.365),(58.805,8.535),(58.975,8.535),(58.975,8.365),(58.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.705),(58.805,8.875),(58.975,8.875),(58.975,8.705),(58.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.865),(83.315,17.035),(83.485,17.035),(83.485,16.865),(83.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.985),(15.605,6.155),(15.775,6.155),(15.775,5.985),(15.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.765),(73.715,11.935),(73.885,11.935),(73.885,11.765),(73.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.085),(73.715,11.255),(73.885,11.255),(73.885,11.085),(73.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.745),(58.805,10.915),(58.975,10.915),(58.975,10.745),(58.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.825),(34.805,14.995),(34.975,14.995),(34.975,14.825),(34.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.085),(73.205,11.255),(73.375,11.255),(73.375,11.085),(73.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.145),(34.805,14.315),(34.975,14.315),(34.975,14.145),(34.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.425),(73.205,11.595),(73.375,11.595),(73.375,11.425),(73.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.425),(73.715,11.595),(73.885,11.595),(73.885,11.425),(73.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.405),(58.805,10.575),(58.975,10.575),(58.975,10.405),(58.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.065),(58.805,10.235),(58.975,10.235),(58.975,10.065),(58.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.885),(83.315,18.055),(83.485,18.055),(83.485,17.885),(83.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.025),(10.805,8.195),(10.975,8.195),(10.975,8.025),(10.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.925),(45.425,3.095),(45.595,3.095),(45.595,2.925),(45.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.365),(10.805,8.535),(10.975,8.535),(10.975,8.365),(10.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.705),(10.805,8.875),(10.975,8.875),(10.975,8.705),(10.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.185),(74.225,16.355),(74.395,16.355),(74.395,16.185),(74.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.525),(74.225,16.695),(74.395,16.695),(74.395,16.525),(74.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.825),(54.005,14.995),(54.175,14.995),(54.175,14.825),(54.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.485),(54.005,14.655),(54.175,14.655),(54.175,14.485),(54.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.485),(54.515,14.655),(54.685,14.655),(54.685,14.485),(54.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.825),(54.515,14.995),(54.685,14.995),(54.685,14.825),(54.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.145),(54.005,14.315),(54.175,14.315),(54.175,14.145),(54.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.405),(10.805,10.575),(10.975,10.575),(10.975,10.405),(10.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.745),(10.805,10.915),(10.975,10.915),(10.975,10.745),(10.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.065),(10.805,10.235),(10.975,10.235),(10.975,10.065),(10.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.145),(15.605,14.315),(15.775,14.315),(15.775,14.145),(15.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.485),(15.605,14.655),(15.775,14.655),(15.775,14.485),(15.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.825),(15.605,14.995),(15.775,14.995),(15.775,14.825),(15.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.265),(10.805,3.435),(10.975,3.435),(10.975,3.265),(10.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.605),(10.805,3.775),(10.975,3.775),(10.975,3.605),(10.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.925),(50.225,3.095),(50.395,3.095),(50.395,2.925),(50.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.845),(64.115,16.015),(64.285,16.015),(64.285,15.845),(64.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.845),(64.625,16.015),(64.795,16.015),(64.795,15.845),(64.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.165),(44.915,15.335),(45.085,15.335),(45.085,15.165),(44.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.505),(44.915,15.675),(45.085,15.675),(45.085,15.505),(44.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.065),(25.205,10.235),(25.375,10.235),(25.375,10.065),(25.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.745),(25.715,10.915),(25.885,10.915),(25.885,10.745),(25.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.745),(25.205,10.915),(25.375,10.915),(25.375,10.745),(25.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.405),(25.715,10.575),(25.885,10.575),(25.885,10.405),(25.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.405),(25.205,10.575),(25.375,10.575),(25.375,10.405),(25.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.065),(25.715,10.235),(25.885,10.235),(25.885,10.065),(25.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.405),(31.025,10.575),(31.195,10.575),(31.195,10.405),(31.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.065),(31.025,10.235),(31.195,10.235),(31.195,10.065),(31.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.745),(31.025,10.915),(31.195,10.915),(31.195,10.745),(31.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.865),(73.205,17.035),(73.375,17.035),(73.375,16.865),(73.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.965),(31.025,5.135),(31.195,5.135),(31.195,4.965),(31.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.865),(73.715,17.035),(73.885,17.035),(73.885,16.865),(73.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.245),(7.025,19.415),(7.195,19.415),(7.195,19.245),(7.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.365),(31.025,8.535),(31.195,8.535),(31.195,8.365),(31.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.705),(31.025,8.875),(31.195,8.875),(31.195,8.705),(31.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.025),(31.025,8.195),(31.195,8.195),(31.195,8.025),(31.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.985),(63.605,6.155),(63.775,6.155),(63.775,5.985),(63.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.225),(79.025,18.395),(79.195,18.395),(79.195,18.225),(79.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.565),(79.025,18.735),(79.195,18.735),(79.195,18.565),(79.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.105),(44.915,12.275),(45.085,12.275),(45.085,12.105),(44.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.445),(44.915,12.615),(45.085,12.615),(45.085,12.445),(44.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.785),(44.915,12.955),(45.085,12.955),(45.085,12.785),(44.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.405),(30.005,10.575),(30.175,10.575),(30.175,10.405),(30.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.065),(30.005,10.235),(30.175,10.235),(30.175,10.065),(30.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.885),(49.205,18.055),(49.375,18.055),(49.375,17.885),(49.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.885),(49.715,18.055),(49.885,18.055),(49.885,17.885),(49.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.885),(74.225,18.055),(74.395,18.055),(74.395,17.885),(74.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.205),(45.425,17.375),(45.595,17.375),(45.595,17.205),(45.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.545),(45.425,17.715),(45.595,17.715),(45.595,17.545),(45.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,2.925),(59.825,3.095),(59.995,3.095),(59.995,2.925),(59.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.925),(59.315,3.095),(59.485,3.095),(59.485,2.925),(59.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.745),(20.405,10.915),(20.575,10.915),(20.575,10.745),(20.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.405),(20.405,10.575),(20.575,10.575),(20.575,10.405),(20.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.065),(20.405,10.235),(20.575,10.235),(20.575,10.065),(20.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.885),(82.805,18.055),(82.975,18.055),(82.975,17.885),(82.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.805),(50.225,13.975),(50.395,13.975),(50.395,13.805),(50.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.465),(50.225,13.635),(50.395,13.635),(50.395,13.465),(50.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.125),(50.225,13.295),(50.395,13.295),(50.395,13.125),(50.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.365),(64.115,8.535),(64.285,8.535),(64.285,8.365),(64.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.305),(82.805,5.475),(82.975,5.475),(82.975,5.305),(82.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.645),(82.805,5.815),(82.975,5.815),(82.975,5.645),(82.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.525),(64.625,16.695),(64.795,16.695),(64.795,16.525),(64.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.185),(64.625,16.355),(64.795,16.355),(64.795,16.185),(64.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.185),(64.115,16.355),(64.285,16.355),(64.285,16.185),(64.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.525),(64.115,16.695),(64.285,16.695),(64.285,16.525),(64.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.325),(7.025,6.495),(7.195,6.495),(7.195,6.325),(7.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.665),(7.025,6.835),(7.195,6.835),(7.195,6.665),(7.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.845),(16.625,16.015),(16.795,16.015),(16.795,15.845),(16.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.845),(16.115,16.015),(16.285,16.015),(16.285,15.845),(16.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.805),(78.515,13.975),(78.685,13.975),(78.685,13.805),(78.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.465),(78.005,13.635),(78.175,13.635),(78.175,13.465),(78.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.805),(78.005,13.975),(78.175,13.975),(78.175,13.805),(78.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.465),(78.515,13.635),(78.685,13.635),(78.685,13.465),(78.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.125),(78.005,13.295),(78.175,13.295),(78.175,13.125),(78.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.125),(78.515,13.295),(78.685,13.295),(78.685,13.125),(78.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.905),(44.915,19.075),(45.085,19.075),(45.085,18.905),(44.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.265),(58.805,3.435),(58.975,3.435),(58.975,3.265),(58.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.605),(58.805,3.775),(58.975,3.775),(58.975,3.605),(58.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.245),(83.315,19.415),(83.485,19.415),(83.485,19.245),(83.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.685),(69.425,7.855),(69.595,7.855),(69.595,7.685),(69.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.005),(69.425,7.175),(69.595,7.175),(69.595,7.005),(69.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.345),(69.425,7.515),(69.595,7.515),(69.595,7.345),(69.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.625),(73.715,4.795),(73.885,4.795),(73.885,4.625),(73.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.285),(73.715,4.455),(73.885,4.455),(73.885,4.285),(73.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.605),(34.805,3.775),(34.975,3.775),(34.975,3.605),(34.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.625),(73.205,4.795),(73.375,4.795),(73.375,4.625),(73.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.265),(34.805,3.435),(34.975,3.435),(34.975,3.265),(34.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.285),(73.205,4.455),(73.375,4.455),(73.375,4.285),(73.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.005),(20.405,7.175),(20.575,7.175),(20.575,7.005),(20.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.345),(20.405,7.515),(20.575,7.515),(20.575,7.345),(20.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.185),(44.915,16.355),(45.085,16.355),(45.085,16.185),(44.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.525),(44.915,16.695),(45.085,16.695),(45.085,16.525),(44.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.625),(25.205,4.795),(25.375,4.795),(25.375,4.625),(25.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.285),(25.205,4.455),(25.375,4.455),(25.375,4.285),(25.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.625),(25.715,4.795),(25.885,4.795),(25.885,4.625),(25.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.285),(25.715,4.455),(25.885,4.455),(25.885,4.285),(25.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.665),(31.025,6.835),(31.195,6.835),(31.195,6.665),(31.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.325),(31.025,6.495),(31.195,6.495),(31.195,6.325),(31.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.725),(74.225,9.895),(74.395,9.895),(74.395,9.725),(74.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.385),(74.225,9.555),(74.395,9.555),(74.395,9.385),(74.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.925),(49.205,3.095),(49.375,3.095),(49.375,2.925),(49.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.925),(49.715,3.095),(49.885,3.095),(49.885,2.925),(49.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,2.925),(79.025,3.095),(79.195,3.095),(79.195,2.925),(79.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.945),(10.805,4.115),(10.975,4.115),(10.975,3.945),(10.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.885),(35.825,18.055),(35.995,18.055),(35.995,17.885),(35.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.885),(35.315,18.055),(35.485,18.055),(35.485,17.885),(35.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.045),(40.115,9.215),(40.285,9.215),(40.285,9.045),(40.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.865),(21.425,17.035),(21.595,17.035),(21.595,16.865),(21.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.885),(44.915,18.055),(45.085,18.055),(45.085,17.885),(44.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.045),(40.625,9.215),(40.795,9.215),(40.795,9.045),(40.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.685),(44.405,7.855),(44.575,7.855),(44.575,7.685),(44.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.325),(45.425,6.495),(45.595,6.495),(45.595,6.325),(45.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.665),(45.425,6.835),(45.595,6.835),(45.595,6.665),(45.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.465),(30.515,13.635),(30.685,13.635),(30.685,13.465),(30.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.805),(30.515,13.975),(30.685,13.975),(30.685,13.805),(30.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.805),(30.005,13.975),(30.175,13.975),(30.175,13.805),(30.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.885),(21.425,18.055),(21.595,18.055),(21.595,17.885),(21.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.465),(30.005,13.635),(30.175,13.635),(30.175,13.465),(30.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.125),(30.005,13.295),(30.175,13.295),(30.175,13.125),(30.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.125),(30.515,13.295),(30.685,13.295),(30.685,13.125),(30.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.805),(44.915,13.975),(45.085,13.975),(45.085,13.805),(44.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.465),(44.915,13.635),(45.085,13.635),(45.085,13.465),(44.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.125),(44.915,13.295),(45.085,13.295),(45.085,13.125),(44.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.805),(11.825,13.975),(11.995,13.975),(11.995,13.805),(11.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.485),(44.915,14.655),(45.085,14.655),(45.085,14.485),(44.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.905),(10.805,19.075),(10.975,19.075),(10.975,18.905),(10.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.825),(63.605,14.995),(63.775,14.995),(63.775,14.825),(63.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.145),(63.605,14.315),(63.775,14.315),(63.775,14.145),(63.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.805),(68.915,13.975),(69.085,13.975),(69.085,13.805),(68.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.465),(68.915,13.635),(69.085,13.635),(69.085,13.465),(68.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.485),(63.605,14.655),(63.775,14.655),(63.775,14.485),(63.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.985),(11.315,6.155),(11.485,6.155),(11.485,5.985),(11.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.985),(11.825,6.155),(11.995,6.155),(11.995,5.985),(11.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.325),(20.915,6.495),(21.085,6.495),(21.085,6.325),(20.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.665),(20.915,6.835),(21.085,6.835),(21.085,6.665),(20.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.125),(68.915,13.295),(69.085,13.295),(69.085,13.125),(68.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.925),(44.405,3.095),(44.575,3.095),(44.575,2.925),(44.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.205),(78.515,17.375),(78.685,17.375),(78.685,17.205),(78.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.245),(21.425,19.415),(21.595,19.415),(21.595,19.245),(21.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.425),(64.115,11.595),(64.285,11.595),(64.285,11.425),(64.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.425),(64.625,11.595),(64.795,11.595),(64.795,11.425),(64.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.085),(64.115,11.255),(64.285,11.255),(64.285,11.085),(64.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.085),(64.625,11.255),(64.795,11.255),(64.795,11.085),(64.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.765),(64.115,11.935),(64.285,11.935),(64.285,11.765),(64.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.765),(64.625,11.935),(64.795,11.935),(64.795,11.765),(64.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.405),(79.025,10.575),(79.195,10.575),(79.195,10.405),(79.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.745),(79.025,10.915),(79.195,10.915),(79.195,10.745),(79.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.065),(79.025,10.235),(79.195,10.235),(79.195,10.065),(79.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,2.925),(73.205,3.095),(73.375,3.095),(73.375,2.925),(73.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,2.925),(73.715,3.095),(73.885,3.095),(73.885,2.925),(73.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.685),(54.515,7.855),(54.685,7.855),(54.685,7.685),(54.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.685),(54.005,7.855),(54.175,7.855),(54.175,7.685),(54.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.325),(20.405,6.495),(20.575,6.495),(20.575,6.325),(20.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.665),(20.405,6.835),(20.575,6.835),(20.575,6.665),(20.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.385),(35.825,9.555),(35.995,9.555),(35.995,9.385),(35.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.725),(35.825,9.895),(35.995,9.895),(35.995,9.725),(35.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.385),(35.315,9.555),(35.485,9.555),(35.485,9.385),(35.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.725),(35.315,9.895),(35.485,9.895),(35.485,9.725),(35.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.245),(20.915,19.415),(21.085,19.415),(21.085,19.245),(20.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.345),(6.515,7.515),(6.685,7.515),(6.685,7.345),(6.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.685),(6.515,7.855),(6.685,7.855),(6.685,7.685),(6.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.005),(6.515,7.175),(6.685,7.175),(6.685,7.005),(6.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.125),(10.805,13.295),(10.975,13.295),(10.975,13.125),(10.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.465),(10.805,13.635),(10.975,13.635),(10.975,13.465),(10.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.805),(10.805,13.975),(10.975,13.975),(10.975,13.805),(10.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.945),(20.405,4.115),(20.575,4.115),(20.575,3.945),(20.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.865),(15.605,17.035),(15.775,17.035),(15.775,16.865),(15.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.505),(49.715,15.675),(49.885,15.675),(49.885,15.505),(49.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.165),(49.715,15.335),(49.885,15.335),(49.885,15.165),(49.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.165),(49.205,15.335),(49.375,15.335),(49.375,15.165),(49.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.505),(49.205,15.675),(49.375,15.675),(49.375,15.505),(49.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.965),(68.405,5.135),(68.575,5.135),(68.575,4.965),(68.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.965),(20.405,5.135),(20.575,5.135),(20.575,4.965),(20.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.865),(34.805,17.035),(34.975,17.035),(34.975,16.865),(34.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.905),(63.605,19.075),(63.775,19.075),(63.775,18.905),(63.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.865),(20.915,17.035),(21.085,17.035),(21.085,16.865),(20.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.745),(73.205,10.915),(73.375,10.915),(73.375,10.745),(73.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.745),(73.715,10.915),(73.885,10.915),(73.885,10.745),(73.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.405),(73.715,10.575),(73.885,10.575),(73.885,10.405),(73.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.405),(73.205,10.575),(73.375,10.575),(73.375,10.405),(73.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.065),(73.205,10.235),(73.375,10.235),(73.375,10.065),(73.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.065),(73.715,10.235),(73.885,10.235),(73.885,10.065),(73.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.945),(58.805,4.115),(58.975,4.115),(58.975,3.945),(58.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.565),(31.025,18.735),(31.195,18.735),(31.195,18.565),(31.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.225),(31.025,18.395),(31.195,18.395),(31.195,18.225),(31.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.945),(34.805,4.115),(34.975,4.115),(34.975,3.945),(34.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.905),(83.315,19.075),(83.485,19.075),(83.485,18.905),(83.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,2.925),(20.915,3.095),(21.085,3.095),(21.085,2.925),(20.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.865),(35.315,17.035),(35.485,17.035),(35.485,16.865),(35.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.865),(35.825,17.035),(35.995,17.035),(35.995,16.865),(35.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.765),(16.625,11.935),(16.795,11.935),(16.795,11.765),(16.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.085),(16.115,11.255),(16.285,11.255),(16.285,11.085),(16.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.085),(16.625,11.255),(16.795,11.255),(16.795,11.085),(16.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.425),(16.115,11.595),(16.285,11.595),(16.285,11.425),(16.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.425),(16.625,11.595),(16.795,11.595),(16.795,11.425),(16.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.765),(16.115,11.935),(16.285,11.935),(16.285,11.765),(16.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.685),(30.005,7.855),(30.175,7.855),(30.175,7.685),(30.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.685),(30.515,7.855),(30.685,7.855),(30.685,7.685),(30.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.765),(73.205,11.935),(73.375,11.935),(73.375,11.765),(73.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.285),(6.515,4.455),(6.685,4.455),(6.685,4.285),(6.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.625),(6.515,4.795),(6.685,4.795),(6.685,4.625),(6.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.045),(50.225,9.215),(50.395,9.215),(50.395,9.045),(50.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.865),(26.225,17.035),(26.395,17.035),(26.395,16.865),(26.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.345),(64.115,7.515),(64.285,7.515),(64.285,7.345),(64.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.345),(64.625,7.515),(64.795,7.515),(64.795,7.345),(64.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.145),(82.805,14.315),(82.975,14.315),(82.975,14.145),(82.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.005),(64.625,7.175),(64.795,7.175),(64.795,7.005),(64.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.005),(64.115,7.175),(64.285,7.175),(64.285,7.005),(64.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.485),(82.805,14.655),(82.975,14.655),(82.975,14.485),(82.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.825),(82.805,14.995),(82.975,14.995),(82.975,14.825),(82.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.225),(74.225,18.395),(74.395,18.395),(74.395,18.225),(74.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.565),(74.225,18.735),(74.395,18.735),(74.395,18.565),(74.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.425),(50.225,11.595),(50.395,11.595),(50.395,11.425),(50.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.085),(50.225,11.255),(50.395,11.255),(50.395,11.085),(50.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.765),(50.225,11.935),(50.395,11.935),(50.395,11.765),(50.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.405),(68.405,10.575),(68.575,10.575),(68.575,10.405),(68.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.745),(68.405,10.915),(68.575,10.915),(68.575,10.745),(68.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.065),(68.405,10.235),(68.575,10.235),(68.575,10.065),(68.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.125),(73.715,13.295),(73.885,13.295),(73.885,13.125),(73.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.125),(73.205,13.295),(73.375,13.295),(73.375,13.125),(73.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.245),(73.205,19.415),(73.375,19.415),(73.375,19.245),(73.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.245),(73.715,19.415),(73.885,19.415),(73.885,19.245),(73.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.465),(73.205,13.635),(73.375,13.635),(73.375,13.465),(73.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.805),(73.205,13.975),(73.375,13.975),(73.375,13.805),(73.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.285),(49.715,4.455),(49.885,4.455),(49.885,4.285),(49.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.625),(49.715,4.795),(49.885,4.795),(49.885,4.625),(49.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.285),(49.205,4.455),(49.375,4.455),(49.375,4.285),(49.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.625),(49.205,4.795),(49.375,4.795),(49.375,4.625),(49.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.685),(10.805,7.855),(10.975,7.855),(10.975,7.685),(10.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.125),(25.715,13.295),(25.885,13.295),(25.885,13.125),(25.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.805),(25.205,13.975),(25.375,13.975),(25.375,13.805),(25.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.125),(25.205,13.295),(25.375,13.295),(25.375,13.125),(25.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.805),(25.715,13.975),(25.885,13.975),(25.885,13.805),(25.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.465),(25.205,13.635),(25.375,13.635),(25.375,13.465),(25.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.465),(25.715,13.635),(25.885,13.635),(25.885,13.465),(25.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.845),(40.115,16.015),(40.285,16.015),(40.285,15.845),(40.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.105),(39.605,12.275),(39.775,12.275),(39.775,12.105),(39.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.845),(40.625,16.015),(40.795,16.015),(40.795,15.845),(40.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.465),(58.805,13.635),(58.975,13.635),(58.975,13.465),(58.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.805),(58.805,13.975),(58.975,13.975),(58.975,13.805),(58.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.125),(58.805,13.295),(58.975,13.295),(58.975,13.125),(58.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.445),(39.605,12.615),(39.775,12.615),(39.775,12.445),(39.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.785),(39.605,12.955),(39.775,12.955),(39.775,12.785),(39.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.185),(79.025,16.355),(79.195,16.355),(79.195,16.185),(79.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.525),(79.025,16.695),(79.195,16.695),(79.195,16.525),(79.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.285),(30.005,4.455),(30.175,4.455),(30.175,4.285),(30.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.905),(21.425,19.075),(21.595,19.075),(21.595,18.905),(21.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.625),(30.005,4.795),(30.175,4.795),(30.175,4.625),(30.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.285),(30.515,4.455),(30.685,4.455),(30.685,4.285),(30.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.625),(30.515,4.795),(30.685,4.795),(30.685,4.625),(30.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.205),(79.025,17.375),(79.195,17.375),(79.195,17.205),(79.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.545),(79.025,17.715),(79.195,17.715),(79.195,17.545),(79.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.245),(26.225,19.415),(26.395,19.415),(26.395,19.245),(26.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.005),(39.605,7.175),(39.775,7.175),(39.775,7.005),(39.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.345),(39.605,7.515),(39.775,7.515),(39.775,7.345),(39.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.685),(39.605,7.855),(39.775,7.855),(39.775,7.685),(39.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.005),(16.625,7.175),(16.795,7.175),(16.795,7.005),(16.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.005),(16.115,7.175),(16.285,7.175),(16.285,7.005),(16.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.705),(73.715,8.875),(73.885,8.875),(73.885,8.705),(73.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.345),(16.115,7.515),(16.285,7.515),(16.285,7.345),(16.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.345),(16.625,7.515),(16.795,7.515),(16.795,7.345),(16.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.365),(73.205,8.535),(73.375,8.535),(73.375,8.365),(73.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.685),(15.605,7.855),(15.775,7.855),(15.775,7.685),(15.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.705),(73.205,8.875),(73.375,8.875),(73.375,8.705),(73.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.365),(73.715,8.535),(73.885,8.535),(73.885,8.365),(73.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.025),(73.205,8.195),(73.375,8.195),(73.375,8.025),(73.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.025),(73.715,8.195),(73.885,8.195),(73.885,8.025),(73.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.685),(82.805,7.855),(82.975,7.855),(82.975,7.685),(82.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.705),(25.715,8.875),(25.885,8.875),(25.885,8.705),(25.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.365),(25.715,8.535),(25.885,8.535),(25.885,8.365),(25.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.365),(25.205,8.535),(25.375,8.535),(25.375,8.365),(25.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.705),(25.205,8.875),(25.375,8.875),(25.375,8.705),(25.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.025),(25.205,8.195),(25.375,8.195),(25.375,8.025),(25.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.025),(25.715,8.195),(25.885,8.195),(25.885,8.025),(25.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.465),(40.115,13.635),(40.285,13.635),(40.285,13.465),(40.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.465),(40.625,13.635),(40.795,13.635),(40.795,13.465),(40.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.805),(40.625,13.975),(40.795,13.975),(40.795,13.805),(40.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.805),(40.115,13.975),(40.285,13.975),(40.285,13.805),(40.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.125),(40.115,13.295),(40.285,13.295),(40.285,13.125),(40.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.125),(40.625,13.295),(40.795,13.295),(40.795,13.125),(40.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.885),(64.115,18.055),(64.285,18.055),(64.285,17.885),(64.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.885),(64.625,18.055),(64.795,18.055),(64.795,17.885),(64.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.285),(58.805,4.455),(58.975,4.455),(58.975,4.285),(58.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.625),(58.805,4.795),(58.975,4.795),(58.975,4.625),(58.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.305),(7.025,5.475),(7.195,5.475),(7.195,5.305),(7.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.645),(7.025,5.815),(7.195,5.815),(7.195,5.645),(7.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.285),(34.805,4.455),(34.975,4.455),(34.975,4.285),(34.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.625),(34.805,4.795),(34.975,4.795),(34.975,4.625),(34.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.965),(64.625,5.135),(64.795,5.135),(64.795,4.965),(64.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.965),(64.115,5.135),(64.285,5.135),(64.285,4.965),(64.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.625),(10.805,4.795),(10.975,4.795),(10.975,4.625),(10.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.285),(10.805,4.455),(10.975,4.455),(10.975,4.285),(10.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.285),(54.005,4.455),(54.175,4.455),(54.175,4.285),(54.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.205),(20.915,17.375),(21.085,17.375),(21.085,17.205),(20.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.285),(54.515,4.455),(54.685,4.455),(54.685,4.285),(54.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.625),(54.515,4.795),(54.685,4.795),(54.685,4.625),(54.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.625),(54.005,4.795),(54.175,4.795),(54.175,4.625),(54.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.545),(20.915,17.715),(21.085,17.715),(21.085,17.545),(20.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.325),(74.225,6.495),(74.395,6.495),(74.395,6.325),(74.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.665),(74.225,6.835),(74.395,6.835),(74.395,6.665),(74.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.905),(40.625,19.075),(40.795,19.075),(40.795,18.905),(40.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.965),(45.425,5.135),(45.595,5.135),(45.595,4.965),(45.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.905),(40.115,19.075),(40.285,19.075),(40.285,18.905),(40.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.225),(39.605,18.395),(39.775,18.395),(39.775,18.225),(39.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.565),(39.605,18.735),(39.775,18.735),(39.775,18.565),(39.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.745),(44.405,10.915),(44.575,10.915),(44.575,10.745),(44.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.405),(44.405,10.575),(44.575,10.575),(44.575,10.405),(44.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.065),(44.405,10.235),(44.575,10.235),(44.575,10.065),(44.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.685),(63.605,7.855),(63.775,7.855),(63.775,7.685),(63.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.425),(39.605,11.595),(39.775,11.595),(39.775,11.425),(39.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.085),(39.605,11.255),(39.775,11.255),(39.775,11.085),(39.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.725),(16.115,9.895),(16.285,9.895),(16.285,9.725),(16.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.725),(16.625,9.895),(16.795,9.895),(16.795,9.725),(16.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.385),(16.625,9.555),(16.795,9.555),(16.795,9.385),(16.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.385),(16.115,9.555),(16.285,9.555),(16.285,9.385),(16.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.765),(39.605,11.935),(39.775,11.935),(39.775,11.765),(39.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.225),(49.715,18.395),(49.885,18.395),(49.885,18.225),(49.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.565),(49.715,18.735),(49.885,18.735),(49.885,18.565),(49.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.225),(49.205,18.395),(49.375,18.395),(49.375,18.225),(49.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.565),(49.205,18.735),(49.375,18.735),(49.375,18.565),(49.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.725),(59.315,9.895),(59.485,9.895),(59.485,9.725),(59.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.385),(59.825,9.555),(59.995,9.555),(59.995,9.385),(59.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.725),(59.825,9.895),(59.995,9.895),(59.995,9.725),(59.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.385),(59.315,9.555),(59.485,9.555),(59.485,9.385),(59.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.045),(20.915,9.215),(21.085,9.215),(21.085,9.045),(20.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.245),(34.805,19.415),(34.975,19.415),(34.975,19.245),(34.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.325),(16.625,6.495),(16.795,6.495),(16.795,6.325),(16.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.665),(16.625,6.835),(16.795,6.835),(16.795,6.665),(16.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.325),(16.115,6.495),(16.285,6.495),(16.285,6.325),(16.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.285),(82.805,4.455),(82.975,4.455),(82.975,4.285),(82.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.985),(26.225,6.155),(26.395,6.155),(26.395,5.985),(26.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.625),(82.805,4.795),(82.975,4.795),(82.975,4.625),(82.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.665),(16.115,6.835),(16.285,6.835),(16.285,6.665),(16.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.045),(10.805,9.215),(10.975,9.215),(10.975,9.045),(10.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.705),(64.625,8.875),(64.795,8.875),(64.795,8.705),(64.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.645),(31.025,5.815),(31.195,5.815),(31.195,5.645),(31.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.305),(31.025,5.475),(31.195,5.475),(31.195,5.305),(31.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.685),(58.805,7.855),(58.975,7.855),(58.975,7.685),(58.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.005),(58.805,7.175),(58.975,7.175),(58.975,7.005),(58.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.345),(58.805,7.515),(58.975,7.515),(58.975,7.345),(58.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.025),(64.115,8.195),(64.285,8.195),(64.285,8.025),(64.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.025),(64.625,8.195),(64.795,8.195),(64.795,8.025),(64.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.205),(74.225,17.375),(74.395,17.375),(74.395,17.205),(74.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.845),(21.425,16.015),(21.595,16.015),(21.595,15.845),(21.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.905),(30.515,19.075),(30.685,19.075),(30.685,18.905),(30.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.905),(30.005,19.075),(30.175,19.075),(30.175,18.905),(30.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.685),(78.515,7.855),(78.685,7.855),(78.685,7.685),(78.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.685),(34.805,7.855),(34.975,7.855),(34.975,7.685),(34.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.685),(78.005,7.855),(78.175,7.855),(78.175,7.685),(78.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.725),(11.825,9.895),(11.995,9.895),(11.995,9.725),(11.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.385),(83.315,9.555),(83.485,9.555),(83.485,9.385),(83.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.725),(83.315,9.895),(83.485,9.895),(83.485,9.725),(83.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.385),(11.315,9.555),(11.485,9.555),(11.485,9.385),(11.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.725),(11.315,9.895),(11.485,9.895),(11.485,9.725),(11.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.385),(11.825,9.555),(11.995,9.555),(11.995,9.385),(11.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.085),(10.805,11.255),(10.975,11.255),(10.975,11.085),(10.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.765),(10.805,11.935),(10.975,11.935),(10.975,11.765),(10.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.425),(10.805,11.595),(10.975,11.595),(10.975,11.425),(10.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.005),(44.915,7.175),(45.085,7.175),(45.085,7.005),(44.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.685),(44.915,7.855),(45.085,7.855),(45.085,7.685),(44.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.985),(44.405,6.155),(44.575,6.155),(44.575,5.985),(44.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.345),(44.915,7.515),(45.085,7.515),(45.085,7.345),(44.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.545),(82.805,17.715),(82.975,17.715),(82.975,17.545),(82.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.205),(82.805,17.375),(82.975,17.375),(82.975,17.205),(82.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.325),(50.225,6.495),(50.395,6.495),(50.395,6.325),(50.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.665),(50.225,6.835),(50.395,6.835),(50.395,6.665),(50.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.965),(16.115,5.135),(16.285,5.135),(16.285,4.965),(16.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.965),(16.625,5.135),(16.795,5.135),(16.795,4.965),(16.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.485),(34.805,14.655),(34.975,14.655),(34.975,14.485),(34.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.985),(44.915,6.155),(45.085,6.155),(45.085,5.985),(44.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,2.925),(68.915,3.095),(69.085,3.095),(69.085,2.925),(68.915,2.925)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.985),(59.315,19.355),(59.485,19.355),(59.485,2.985),(59.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.845),(59.315,19.495),(59.485,19.495),(59.485,2.845),(59.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.985),(16.115,19.355),(16.285,19.355),(16.285,2.985),(16.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.845),(16.115,19.495),(16.285,19.495),(16.285,2.845),(16.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.985),(78.515,19.355),(78.685,19.355),(78.685,2.985),(78.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.28),(44.915,20.76),(45.085,20.76),(45.085,20.28),(44.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.845),(78.515,19.495),(78.685,19.495),(78.685,2.845),(78.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.845),(39.605,19.495),(40.795,19.495),(40.795,2.845),(39.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.845),(54.515,19.495),(54.685,19.495),(54.685,2.845),(54.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.985),(54.515,19.355),(54.685,19.355),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,20.435),(78.515,20.605),(78.685,20.605),(78.685,20.435),(78.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,20.28),(78.515,20.76),(78.685,20.76),(78.685,20.28),(78.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,20.435),(83.06,20.605),(83.23,20.605),(83.23,20.435),(83.06,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,20.28),(83.06,20.76),(83.23,20.76),(83.23,20.28),(83.06,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,20.435),(11.315,20.605),(11.485,20.605),(11.485,20.435),(11.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,20.28),(11.315,20.76),(11.485,20.76),(11.485,20.28),(11.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((78.005,2.845),(78.005,19.495),(79.195,19.495),(79.195,2.845),(78.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.985),(83.06,19.355),(83.23,19.355),(83.23,2.985),(83.06,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.845),(83.06,19.495),(83.23,19.495),(83.23,2.845),(83.06,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,20.435),(68.915,20.605),(69.085,20.605),(69.085,20.435),(68.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,20.28),(68.915,20.76),(69.085,20.76),(69.085,20.28),(68.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.58),(20.915,2.06),(21.085,2.06),(21.085,1.58),(20.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.58),(64.115,2.06),(64.285,2.06),(64.285,1.58),(64.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.845),(44.405,19.495),(45.595,19.495),(45.595,2.845),(44.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.985),(44.915,19.355),(45.085,19.355),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.845),(44.915,19.495),(45.085,19.495),(45.085,2.845),(44.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.845),(54.005,19.495),(55.195,19.495),(55.195,2.845),(54.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,20.435),(20.915,20.605),(21.085,20.605),(21.085,20.435),(20.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,20.28),(20.915,20.76),(21.085,20.76),(21.085,20.28),(20.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,20.435),(30.515,20.605),(30.685,20.605),(30.685,20.435),(30.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,20.28),(30.515,20.76),(30.685,20.76),(30.685,20.28),(30.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((15.605,2.845),(15.605,19.495),(16.795,19.495),(16.795,2.845),(15.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.845),(34.805,19.495),(35.995,19.495),(35.995,2.845),(34.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.28),(54.515,20.76),(54.685,20.76),(54.685,20.28),(54.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,20.435),(64.115,20.605),(64.285,20.605),(64.285,20.435),(64.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,20.28),(64.115,20.76),(64.285,20.76),(64.285,20.28),(64.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.58),(16.115,2.06),(16.285,2.06),(16.285,1.58),(16.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.985),(30.515,19.355),(30.685,19.355),(30.685,2.985),(30.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.845),(30.515,19.495),(30.685,19.495),(30.685,2.845),(30.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.58),(68.915,2.06),(69.085,2.06),(69.085,1.58),(68.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((25.205,2.845),(25.205,19.495),(26.395,19.495),(26.395,2.845),(25.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.985),(11.315,19.355),(11.485,19.355),(11.485,2.985),(11.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.845),(11.315,19.495),(11.485,19.495),(11.485,2.845),(11.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((63.605,2.845),(63.605,19.495),(64.795,19.495),(64.795,2.845),(63.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.405,2.845),(20.405,19.495),(21.595,19.495),(21.595,2.845),(20.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.985),(20.915,19.355),(21.085,19.355),(21.085,2.985),(20.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.845),(20.915,19.495),(21.085,19.495),(21.085,2.845),(20.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,20.435),(73.715,20.605),(73.885,20.605),(73.885,20.435),(73.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,20.28),(73.715,20.76),(73.885,20.76),(73.885,20.28),(73.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.985),(25.715,19.355),(25.885,19.355),(25.885,2.985),(25.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.845),(25.715,19.495),(25.885,19.495),(25.885,2.845),(25.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.005,2.845),(30.005,19.495),(31.195,19.495),(31.195,2.845),(30.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.985),(6.77,19.355),(6.94,19.355),(6.94,2.985),(6.77,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.845),(6.77,19.495),(6.94,19.495),(6.94,2.845),(6.77,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.58),(78.515,2.06),(78.685,2.06),(78.685,1.58),(78.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,20.435),(25.715,20.605),(25.885,20.605),(25.885,20.435),(25.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,20.28),(25.715,20.76),(25.885,20.76),(25.885,20.28),(25.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.28),(35.315,20.76),(35.485,20.76),(35.485,20.28),(35.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.28),(49.715,20.76),(49.885,20.76),(49.885,20.28),(49.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((73.205,2.845),(73.205,19.495),(74.395,19.495),(74.395,2.845),(73.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,1.735),(85.58,1.905),(86.11,1.905),(86.11,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.58),(6.77,2.06),(6.94,2.06),(6.94,1.58),(6.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,20.435),(16.115,20.605),(16.285,20.605),(16.285,20.435),(16.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,20.28),(16.115,20.76),(16.285,20.76),(16.285,20.28),(16.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((68.405,2.845),(68.405,19.495),(69.595,19.495),(69.595,2.845),(68.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.985),(68.915,19.355),(69.085,19.355),(69.085,2.985),(68.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.845),(68.915,19.495),(69.085,19.495),(69.085,2.845),(68.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.845),(58.805,19.495),(59.995,19.495),(59.995,2.845),(58.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.515,2.845),(6.515,19.495),(7.195,19.495),(7.195,2.845),(6.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,20.435),(59.315,20.605),(59.485,20.605),(59.485,20.435),(59.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,20.28),(59.315,20.76),(59.485,20.76),(59.485,20.28),(59.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.985),(73.715,19.355),(73.885,19.355),(73.885,2.985),(73.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.845),(73.715,19.495),(73.885,19.495),(73.885,2.845),(73.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,20.435),(6.77,20.605),(6.94,20.605),(6.94,20.435),(6.77,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,20.28),(6.77,20.76),(6.94,20.76),(6.94,20.28),(6.77,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.58),(73.715,2.06),(73.885,2.06),(73.885,1.58),(73.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((10.805,2.845),(10.805,19.495),(11.995,19.495),(11.995,2.845),(10.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((82.805,2.845),(82.805,19.495),(83.485,19.495),(83.485,2.845),(82.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.58),(25.715,2.06),(25.885,2.06),(25.885,1.58),(25.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,10.71),(85.76,11.04),(85.93,11.04),(85.93,10.71),(85.76,10.71)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.985),(40.115,19.355),(40.285,19.355),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.845),(40.115,19.495),(40.285,19.495),(40.285,2.845),(40.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.28),(40.115,20.76),(40.285,20.76),(40.285,20.28),(40.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.985),(35.315,19.355),(35.485,19.355),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.845),(35.315,19.495),(35.485,19.495),(35.485,2.845),(35.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.985),(64.115,19.355),(64.285,19.355),(64.285,2.985),(64.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.845),(64.115,19.495),(64.285,19.495),(64.285,2.845),(64.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.985),(49.715,19.355),(49.885,19.355),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.845),(49.715,19.495),(49.885,19.495),(49.885,2.845),(49.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.58),(59.315,2.06),(59.485,2.06),(59.485,1.58),(59.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.845),(49.205,19.495),(50.395,19.495),(50.395,2.845),(49.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.58),(30.515,2.06),(30.685,2.06),(30.685,1.58),(30.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.58),(83.06,2.06),(83.23,2.06),(83.23,1.58),(83.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.58),(11.315,2.06),(11.485,2.06),(11.485,1.58),(11.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((85.58,10.79),(85.58,10.96),(86.11,10.96),(86.11,10.79),(85.58,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.985),(49.715,3.155),(49.885,3.155),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.345),(49.715,3.515),(49.885,3.515),(49.885,3.345),(49.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.705),(49.715,3.875),(49.885,3.875),(49.885,3.705),(49.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.065),(49.715,4.235),(49.885,4.235),(49.885,4.065),(49.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.425),(49.715,4.595),(49.885,4.595),(49.885,4.425),(49.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.785),(49.715,4.955),(49.885,4.955),(49.885,4.785),(49.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.145),(49.715,5.315),(49.885,5.315),(49.885,5.145),(49.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.505),(49.715,5.675),(49.885,5.675),(49.885,5.505),(49.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.865),(49.715,6.035),(49.885,6.035),(49.885,5.865),(49.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.225),(49.715,6.395),(49.885,6.395),(49.885,6.225),(49.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.585),(49.715,6.755),(49.885,6.755),(49.885,6.585),(49.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.305),(49.715,7.475),(49.885,7.475),(49.885,7.305),(49.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.665),(49.715,7.835),(49.885,7.835),(49.885,7.665),(49.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.385),(49.715,8.555),(49.885,8.555),(49.885,8.385),(49.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.745),(49.715,8.915),(49.885,8.915),(49.885,8.745),(49.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.105),(49.715,9.275),(49.885,9.275),(49.885,9.105),(49.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.465),(49.715,9.635),(49.885,9.635),(49.885,9.465),(49.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.825),(49.715,9.995),(49.885,9.995),(49.885,9.825),(49.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.185),(49.715,10.355),(49.885,10.355),(49.885,10.185),(49.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.545),(49.715,10.715),(49.885,10.715),(49.885,10.545),(49.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.905),(49.715,11.075),(49.885,11.075),(49.885,10.905),(49.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.265),(49.715,11.435),(49.885,11.435),(49.885,11.265),(49.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.625),(49.715,11.795),(49.885,11.795),(49.885,11.625),(49.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.985),(49.715,12.155),(49.885,12.155),(49.885,11.985),(49.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.345),(49.715,12.515),(49.885,12.515),(49.885,12.345),(49.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.705),(49.715,12.875),(49.885,12.875),(49.885,12.705),(49.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.425),(49.715,13.595),(49.885,13.595),(49.885,13.425),(49.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.785),(49.715,13.955),(49.885,13.955),(49.885,13.785),(49.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.505),(49.715,14.675),(49.885,14.675),(49.885,14.505),(49.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.865),(49.715,15.035),(49.885,15.035),(49.885,14.865),(49.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.225),(49.715,15.395),(49.885,15.395),(49.885,15.225),(49.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.585),(49.715,15.755),(49.885,15.755),(49.885,15.585),(49.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.945),(49.715,16.115),(49.885,16.115),(49.885,15.945),(49.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.305),(49.715,16.475),(49.885,16.475),(49.885,16.305),(49.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.665),(49.715,16.835),(49.885,16.835),(49.885,16.665),(49.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.025),(49.715,17.195),(49.885,17.195),(49.885,17.025),(49.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.385),(49.715,17.555),(49.885,17.555),(49.885,17.385),(49.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.745),(49.715,17.915),(49.885,17.915),(49.885,17.745),(49.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.105),(49.715,18.275),(49.885,18.275),(49.885,18.105),(49.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.465),(49.715,18.635),(49.885,18.635),(49.885,18.465),(49.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.825),(49.715,18.995),(49.885,18.995),(49.885,18.825),(49.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.435),(73.715,20.605),(73.885,20.605),(73.885,20.435),(73.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,2.985),(68.915,3.155),(69.085,3.155),(69.085,2.985),(68.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.345),(68.915,3.515),(69.085,3.515),(69.085,3.345),(68.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.705),(68.915,3.875),(69.085,3.875),(69.085,3.705),(68.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.065),(68.915,4.235),(69.085,4.235),(69.085,4.065),(68.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.425),(68.915,4.595),(69.085,4.595),(69.085,4.425),(68.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.785),(68.915,4.955),(69.085,4.955),(69.085,4.785),(68.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.145),(68.915,5.315),(69.085,5.315),(69.085,5.145),(68.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.505),(68.915,5.675),(69.085,5.675),(69.085,5.505),(68.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.865),(68.915,6.035),(69.085,6.035),(69.085,5.865),(68.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.225),(68.915,6.395),(69.085,6.395),(69.085,6.225),(68.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.585),(68.915,6.755),(69.085,6.755),(69.085,6.585),(68.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.945),(68.915,7.115),(69.085,7.115),(69.085,6.945),(68.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.305),(68.915,7.475),(69.085,7.475),(69.085,7.305),(68.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.665),(68.915,7.835),(69.085,7.835),(69.085,7.665),(68.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.025),(68.915,8.195),(69.085,8.195),(69.085,8.025),(68.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.385),(68.915,8.555),(69.085,8.555),(69.085,8.385),(68.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.745),(68.915,8.915),(69.085,8.915),(69.085,8.745),(68.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.105),(68.915,9.275),(69.085,9.275),(69.085,9.105),(68.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.465),(68.915,9.635),(69.085,9.635),(69.085,9.465),(68.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.825),(68.915,9.995),(69.085,9.995),(69.085,9.825),(68.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.185),(68.915,10.355),(69.085,10.355),(69.085,10.185),(68.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.545),(68.915,10.715),(69.085,10.715),(69.085,10.545),(68.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.905),(68.915,11.075),(69.085,11.075),(69.085,10.905),(68.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.265),(68.915,11.435),(69.085,11.435),(69.085,11.265),(68.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.625),(68.915,11.795),(69.085,11.795),(69.085,11.625),(68.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.985),(68.915,12.155),(69.085,12.155),(69.085,11.985),(68.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.345),(68.915,12.515),(69.085,12.515),(69.085,12.345),(68.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.705),(68.915,12.875),(69.085,12.875),(69.085,12.705),(68.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.065),(68.915,13.235),(69.085,13.235),(69.085,13.065),(68.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.425),(68.915,13.595),(69.085,13.595),(69.085,13.425),(68.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.785),(68.915,13.955),(69.085,13.955),(69.085,13.785),(68.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.145),(68.915,14.315),(69.085,14.315),(69.085,14.145),(68.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.505),(68.915,14.675),(69.085,14.675),(69.085,14.505),(68.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.865),(68.915,15.035),(69.085,15.035),(69.085,14.865),(68.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.225),(68.915,15.395),(69.085,15.395),(69.085,15.225),(68.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.585),(68.915,15.755),(69.085,15.755),(69.085,15.585),(68.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.945),(68.915,16.115),(69.085,16.115),(69.085,15.945),(68.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.305),(68.915,16.475),(69.085,16.475),(69.085,16.305),(68.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.665),(68.915,16.835),(69.085,16.835),(69.085,16.665),(68.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.025),(68.915,17.195),(69.085,17.195),(69.085,17.025),(68.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.385),(68.915,17.555),(69.085,17.555),(69.085,17.385),(68.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.745),(68.915,17.915),(69.085,17.915),(69.085,17.745),(68.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.105),(68.915,18.275),(69.085,18.275),(69.085,18.105),(68.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.465),(68.915,18.635),(69.085,18.635),(69.085,18.465),(68.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.825),(68.915,18.995),(69.085,18.995),(69.085,18.825),(68.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.185),(68.915,19.355),(69.085,19.355),(69.085,19.185),(68.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.435),(20.915,20.605),(21.085,20.605),(21.085,20.435),(20.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.985),(44.915,3.155),(45.085,3.155),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.345),(44.915,3.515),(45.085,3.515),(45.085,3.345),(44.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.705),(44.915,3.875),(45.085,3.875),(45.085,3.705),(44.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.065),(44.915,4.235),(45.085,4.235),(45.085,4.065),(44.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.425),(44.915,4.595),(45.085,4.595),(45.085,4.425),(44.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.785),(44.915,4.955),(45.085,4.955),(45.085,4.785),(44.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.145),(44.915,5.315),(45.085,5.315),(45.085,5.145),(44.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.505),(44.915,5.675),(45.085,5.675),(45.085,5.505),(44.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.865),(44.915,6.035),(45.085,6.035),(45.085,5.865),(44.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.225),(44.915,6.395),(45.085,6.395),(45.085,6.225),(44.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.585),(44.915,6.755),(45.085,6.755),(45.085,6.585),(44.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.305),(44.915,7.475),(45.085,7.475),(45.085,7.305),(44.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.665),(44.915,7.835),(45.085,7.835),(45.085,7.665),(44.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.385),(44.915,8.555),(45.085,8.555),(45.085,8.385),(44.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.745),(44.915,8.915),(45.085,8.915),(45.085,8.745),(44.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.105),(44.915,9.275),(45.085,9.275),(45.085,9.105),(44.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.465),(44.915,9.635),(45.085,9.635),(45.085,9.465),(44.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.825),(44.915,9.995),(45.085,9.995),(45.085,9.825),(44.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.185),(44.915,10.355),(45.085,10.355),(45.085,10.185),(44.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.545),(44.915,10.715),(45.085,10.715),(45.085,10.545),(44.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.905),(44.915,11.075),(45.085,11.075),(45.085,10.905),(44.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.265),(44.915,11.435),(45.085,11.435),(45.085,11.265),(44.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.625),(44.915,11.795),(45.085,11.795),(45.085,11.625),(44.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.985),(44.915,12.155),(45.085,12.155),(45.085,11.985),(44.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.345),(44.915,12.515),(45.085,12.515),(45.085,12.345),(44.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.705),(44.915,12.875),(45.085,12.875),(45.085,12.705),(44.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.425),(44.915,13.595),(45.085,13.595),(45.085,13.425),(44.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.785),(44.915,13.955),(45.085,13.955),(45.085,13.785),(44.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.505),(44.915,14.675),(45.085,14.675),(45.085,14.505),(44.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.865),(44.915,15.035),(45.085,15.035),(45.085,14.865),(44.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.225),(44.915,15.395),(45.085,15.395),(45.085,15.225),(44.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.585),(44.915,15.755),(45.085,15.755),(45.085,15.585),(44.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.945),(44.915,16.115),(45.085,16.115),(45.085,15.945),(44.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.305),(44.915,16.475),(45.085,16.475),(45.085,16.305),(44.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.665),(44.915,16.835),(45.085,16.835),(45.085,16.665),(44.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.025),(44.915,17.195),(45.085,17.195),(45.085,17.025),(44.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.385),(44.915,17.555),(45.085,17.555),(45.085,17.385),(44.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.745),(44.915,17.915),(45.085,17.915),(45.085,17.745),(44.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.105),(44.915,18.275),(45.085,18.275),(45.085,18.105),(44.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.465),(44.915,18.635),(45.085,18.635),(45.085,18.465),(44.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.825),(44.915,18.995),(45.085,18.995),(45.085,18.825),(44.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,2.985),(16.115,3.155),(16.285,3.155),(16.285,2.985),(16.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.345),(16.115,3.515),(16.285,3.515),(16.285,3.345),(16.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.705),(16.115,3.875),(16.285,3.875),(16.285,3.705),(16.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.065),(16.115,4.235),(16.285,4.235),(16.285,4.065),(16.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.425),(16.115,4.595),(16.285,4.595),(16.285,4.425),(16.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.785),(16.115,4.955),(16.285,4.955),(16.285,4.785),(16.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.145),(16.115,5.315),(16.285,5.315),(16.285,5.145),(16.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.505),(16.115,5.675),(16.285,5.675),(16.285,5.505),(16.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.865),(16.115,6.035),(16.285,6.035),(16.285,5.865),(16.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.225),(16.115,6.395),(16.285,6.395),(16.285,6.225),(16.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.585),(16.115,6.755),(16.285,6.755),(16.285,6.585),(16.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.945),(16.115,7.115),(16.285,7.115),(16.285,6.945),(16.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.305),(16.115,7.475),(16.285,7.475),(16.285,7.305),(16.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.665),(16.115,7.835),(16.285,7.835),(16.285,7.665),(16.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.025),(16.115,8.195),(16.285,8.195),(16.285,8.025),(16.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.385),(16.115,8.555),(16.285,8.555),(16.285,8.385),(16.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.745),(16.115,8.915),(16.285,8.915),(16.285,8.745),(16.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.105),(16.115,9.275),(16.285,9.275),(16.285,9.105),(16.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.465),(16.115,9.635),(16.285,9.635),(16.285,9.465),(16.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.825),(16.115,9.995),(16.285,9.995),(16.285,9.825),(16.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.185),(16.115,10.355),(16.285,10.355),(16.285,10.185),(16.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.545),(16.115,10.715),(16.285,10.715),(16.285,10.545),(16.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.905),(16.115,11.075),(16.285,11.075),(16.285,10.905),(16.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.265),(16.115,11.435),(16.285,11.435),(16.285,11.265),(16.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.625),(16.115,11.795),(16.285,11.795),(16.285,11.625),(16.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.985),(16.115,12.155),(16.285,12.155),(16.285,11.985),(16.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.345),(16.115,12.515),(16.285,12.515),(16.285,12.345),(16.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.705),(16.115,12.875),(16.285,12.875),(16.285,12.705),(16.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.065),(16.115,13.235),(16.285,13.235),(16.285,13.065),(16.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.425),(16.115,13.595),(16.285,13.595),(16.285,13.425),(16.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.785),(16.115,13.955),(16.285,13.955),(16.285,13.785),(16.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.145),(16.115,14.315),(16.285,14.315),(16.285,14.145),(16.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.505),(16.115,14.675),(16.285,14.675),(16.285,14.505),(16.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.865),(16.115,15.035),(16.285,15.035),(16.285,14.865),(16.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.225),(16.115,15.395),(16.285,15.395),(16.285,15.225),(16.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.585),(16.115,15.755),(16.285,15.755),(16.285,15.585),(16.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.945),(16.115,16.115),(16.285,16.115),(16.285,15.945),(16.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.305),(16.115,16.475),(16.285,16.475),(16.285,16.305),(16.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.665),(16.115,16.835),(16.285,16.835),(16.285,16.665),(16.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.025),(16.115,17.195),(16.285,17.195),(16.285,17.025),(16.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.385),(16.115,17.555),(16.285,17.555),(16.285,17.385),(16.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.745),(16.115,17.915),(16.285,17.915),(16.285,17.745),(16.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.105),(16.115,18.275),(16.285,18.275),(16.285,18.105),(16.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.465),(16.115,18.635),(16.285,18.635),(16.285,18.465),(16.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.825),(16.115,18.995),(16.285,18.995),(16.285,18.825),(16.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.185),(16.115,19.355),(16.285,19.355),(16.285,19.185),(16.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.435),(30.515,20.605),(30.685,20.605),(30.685,20.435),(30.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.435),(64.115,20.605),(64.285,20.605),(64.285,20.435),(64.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.435),(25.715,20.605),(25.885,20.605),(25.885,20.435),(25.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,1.735),(85.58,1.905),(85.75,1.905),(85.75,1.735),(85.58,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,1.735),(85.94,1.905),(86.11,1.905),(86.11,1.735),(85.94,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,2.985),(30.515,3.155),(30.685,3.155),(30.685,2.985),(30.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.345),(30.515,3.515),(30.685,3.515),(30.685,3.345),(30.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.705),(30.515,3.875),(30.685,3.875),(30.685,3.705),(30.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.065),(30.515,4.235),(30.685,4.235),(30.685,4.065),(30.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.425),(30.515,4.595),(30.685,4.595),(30.685,4.425),(30.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.785),(30.515,4.955),(30.685,4.955),(30.685,4.785),(30.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.145),(30.515,5.315),(30.685,5.315),(30.685,5.145),(30.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.505),(30.515,5.675),(30.685,5.675),(30.685,5.505),(30.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.865),(30.515,6.035),(30.685,6.035),(30.685,5.865),(30.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.225),(30.515,6.395),(30.685,6.395),(30.685,6.225),(30.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.585),(30.515,6.755),(30.685,6.755),(30.685,6.585),(30.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.945),(30.515,7.115),(30.685,7.115),(30.685,6.945),(30.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.305),(30.515,7.475),(30.685,7.475),(30.685,7.305),(30.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.665),(30.515,7.835),(30.685,7.835),(30.685,7.665),(30.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.385),(30.515,8.555),(30.685,8.555),(30.685,8.385),(30.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.745),(30.515,8.915),(30.685,8.915),(30.685,8.745),(30.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.105),(30.515,9.275),(30.685,9.275),(30.685,9.105),(30.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.465),(30.515,9.635),(30.685,9.635),(30.685,9.465),(30.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.825),(30.515,9.995),(30.685,9.995),(30.685,9.825),(30.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.185),(30.515,10.355),(30.685,10.355),(30.685,10.185),(30.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.545),(30.515,10.715),(30.685,10.715),(30.685,10.545),(30.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.905),(30.515,11.075),(30.685,11.075),(30.685,10.905),(30.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.265),(30.515,11.435),(30.685,11.435),(30.685,11.265),(30.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.625),(30.515,11.795),(30.685,11.795),(30.685,11.625),(30.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.985),(30.515,12.155),(30.685,12.155),(30.685,11.985),(30.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.345),(30.515,12.515),(30.685,12.515),(30.685,12.345),(30.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.705),(30.515,12.875),(30.685,12.875),(30.685,12.705),(30.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.065),(30.515,13.235),(30.685,13.235),(30.685,13.065),(30.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.425),(30.515,13.595),(30.685,13.595),(30.685,13.425),(30.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.785),(30.515,13.955),(30.685,13.955),(30.685,13.785),(30.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.505),(30.515,14.675),(30.685,14.675),(30.685,14.505),(30.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.865),(30.515,15.035),(30.685,15.035),(30.685,14.865),(30.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.225),(30.515,15.395),(30.685,15.395),(30.685,15.225),(30.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.585),(30.515,15.755),(30.685,15.755),(30.685,15.585),(30.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.945),(30.515,16.115),(30.685,16.115),(30.685,15.945),(30.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.305),(30.515,16.475),(30.685,16.475),(30.685,16.305),(30.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.665),(30.515,16.835),(30.685,16.835),(30.685,16.665),(30.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.025),(30.515,17.195),(30.685,17.195),(30.685,17.025),(30.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.385),(30.515,17.555),(30.685,17.555),(30.685,17.385),(30.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.745),(30.515,17.915),(30.685,17.915),(30.685,17.745),(30.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.105),(30.515,18.275),(30.685,18.275),(30.685,18.105),(30.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.465),(30.515,18.635),(30.685,18.635),(30.685,18.465),(30.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.825),(30.515,18.995),(30.685,18.995),(30.685,18.825),(30.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.185),(30.515,19.355),(30.685,19.355),(30.685,19.185),(30.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.985),(54.515,3.155),(54.685,3.155),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.345),(54.515,3.515),(54.685,3.515),(54.685,3.345),(54.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.705),(54.515,3.875),(54.685,3.875),(54.685,3.705),(54.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.065),(54.515,4.235),(54.685,4.235),(54.685,4.065),(54.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.425),(54.515,4.595),(54.685,4.595),(54.685,4.425),(54.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.785),(54.515,4.955),(54.685,4.955),(54.685,4.785),(54.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.145),(54.515,5.315),(54.685,5.315),(54.685,5.145),(54.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.505),(54.515,5.675),(54.685,5.675),(54.685,5.505),(54.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.865),(54.515,6.035),(54.685,6.035),(54.685,5.865),(54.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.225),(54.515,6.395),(54.685,6.395),(54.685,6.225),(54.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.585),(54.515,6.755),(54.685,6.755),(54.685,6.585),(54.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.305),(54.515,7.475),(54.685,7.475),(54.685,7.305),(54.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.665),(54.515,7.835),(54.685,7.835),(54.685,7.665),(54.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.385),(54.515,8.555),(54.685,8.555),(54.685,8.385),(54.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.745),(54.515,8.915),(54.685,8.915),(54.685,8.745),(54.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.105),(54.515,9.275),(54.685,9.275),(54.685,9.105),(54.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.465),(54.515,9.635),(54.685,9.635),(54.685,9.465),(54.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.825),(54.515,9.995),(54.685,9.995),(54.685,9.825),(54.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.185),(54.515,10.355),(54.685,10.355),(54.685,10.185),(54.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.545),(54.515,10.715),(54.685,10.715),(54.685,10.545),(54.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.905),(54.515,11.075),(54.685,11.075),(54.685,10.905),(54.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.265),(54.515,11.435),(54.685,11.435),(54.685,11.265),(54.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.625),(54.515,11.795),(54.685,11.795),(54.685,11.625),(54.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.985),(54.515,12.155),(54.685,12.155),(54.685,11.985),(54.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.345),(54.515,12.515),(54.685,12.515),(54.685,12.345),(54.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.705),(54.515,12.875),(54.685,12.875),(54.685,12.705),(54.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.425),(54.515,13.595),(54.685,13.595),(54.685,13.425),(54.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.785),(54.515,13.955),(54.685,13.955),(54.685,13.785),(54.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.505),(54.515,14.675),(54.685,14.675),(54.685,14.505),(54.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.865),(54.515,15.035),(54.685,15.035),(54.685,14.865),(54.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.225),(54.515,15.395),(54.685,15.395),(54.685,15.225),(54.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.585),(54.515,15.755),(54.685,15.755),(54.685,15.585),(54.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.945),(54.515,16.115),(54.685,16.115),(54.685,15.945),(54.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.305),(54.515,16.475),(54.685,16.475),(54.685,16.305),(54.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.665),(54.515,16.835),(54.685,16.835),(54.685,16.665),(54.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.025),(54.515,17.195),(54.685,17.195),(54.685,17.025),(54.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.385),(54.515,17.555),(54.685,17.555),(54.685,17.385),(54.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.745),(54.515,17.915),(54.685,17.915),(54.685,17.745),(54.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.105),(54.515,18.275),(54.685,18.275),(54.685,18.105),(54.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.465),(54.515,18.635),(54.685,18.635),(54.685,18.465),(54.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.825),(54.515,18.995),(54.685,18.995),(54.685,18.825),(54.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,2.985),(11.315,3.155),(11.485,3.155),(11.485,2.985),(11.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.345),(11.315,3.515),(11.485,3.515),(11.485,3.345),(11.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.705),(11.315,3.875),(11.485,3.875),(11.485,3.705),(11.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.065),(11.315,4.235),(11.485,4.235),(11.485,4.065),(11.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.425),(11.315,4.595),(11.485,4.595),(11.485,4.425),(11.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.785),(11.315,4.955),(11.485,4.955),(11.485,4.785),(11.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.145),(11.315,5.315),(11.485,5.315),(11.485,5.145),(11.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.505),(11.315,5.675),(11.485,5.675),(11.485,5.505),(11.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.865),(11.315,6.035),(11.485,6.035),(11.485,5.865),(11.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.225),(11.315,6.395),(11.485,6.395),(11.485,6.225),(11.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.585),(11.315,6.755),(11.485,6.755),(11.485,6.585),(11.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.945),(11.315,7.115),(11.485,7.115),(11.485,6.945),(11.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.305),(11.315,7.475),(11.485,7.475),(11.485,7.305),(11.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.665),(11.315,7.835),(11.485,7.835),(11.485,7.665),(11.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.025),(11.315,8.195),(11.485,8.195),(11.485,8.025),(11.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.385),(11.315,8.555),(11.485,8.555),(11.485,8.385),(11.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.745),(11.315,8.915),(11.485,8.915),(11.485,8.745),(11.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.105),(11.315,9.275),(11.485,9.275),(11.485,9.105),(11.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.465),(11.315,9.635),(11.485,9.635),(11.485,9.465),(11.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.825),(11.315,9.995),(11.485,9.995),(11.485,9.825),(11.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.185),(11.315,10.355),(11.485,10.355),(11.485,10.185),(11.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.545),(11.315,10.715),(11.485,10.715),(11.485,10.545),(11.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.905),(11.315,11.075),(11.485,11.075),(11.485,10.905),(11.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.265),(11.315,11.435),(11.485,11.435),(11.485,11.265),(11.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.625),(11.315,11.795),(11.485,11.795),(11.485,11.625),(11.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.985),(11.315,12.155),(11.485,12.155),(11.485,11.985),(11.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.345),(11.315,12.515),(11.485,12.515),(11.485,12.345),(11.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.705),(11.315,12.875),(11.485,12.875),(11.485,12.705),(11.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.065),(11.315,13.235),(11.485,13.235),(11.485,13.065),(11.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.425),(11.315,13.595),(11.485,13.595),(11.485,13.425),(11.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.785),(11.315,13.955),(11.485,13.955),(11.485,13.785),(11.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.145),(11.315,14.315),(11.485,14.315),(11.485,14.145),(11.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.505),(11.315,14.675),(11.485,14.675),(11.485,14.505),(11.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.865),(11.315,15.035),(11.485,15.035),(11.485,14.865),(11.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.225),(11.315,15.395),(11.485,15.395),(11.485,15.225),(11.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.585),(11.315,15.755),(11.485,15.755),(11.485,15.585),(11.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.945),(11.315,16.115),(11.485,16.115),(11.485,15.945),(11.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.305),(11.315,16.475),(11.485,16.475),(11.485,16.305),(11.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.665),(11.315,16.835),(11.485,16.835),(11.485,16.665),(11.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.025),(11.315,17.195),(11.485,17.195),(11.485,17.025),(11.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.385),(11.315,17.555),(11.485,17.555),(11.485,17.385),(11.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.745),(11.315,17.915),(11.485,17.915),(11.485,17.745),(11.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.105),(11.315,18.275),(11.485,18.275),(11.485,18.105),(11.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.465),(11.315,18.635),(11.485,18.635),(11.485,18.465),(11.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.825),(11.315,18.995),(11.485,18.995),(11.485,18.825),(11.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.185),(11.315,19.355),(11.485,19.355),(11.485,19.185),(11.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.435),(78.515,20.605),(78.685,20.605),(78.685,20.435),(78.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,2.985),(78.515,3.155),(78.685,3.155),(78.685,2.985),(78.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.345),(78.515,3.515),(78.685,3.515),(78.685,3.345),(78.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.705),(78.515,3.875),(78.685,3.875),(78.685,3.705),(78.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.065),(78.515,4.235),(78.685,4.235),(78.685,4.065),(78.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.425),(78.515,4.595),(78.685,4.595),(78.685,4.425),(78.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.785),(78.515,4.955),(78.685,4.955),(78.685,4.785),(78.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.145),(78.515,5.315),(78.685,5.315),(78.685,5.145),(78.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.505),(78.515,5.675),(78.685,5.675),(78.685,5.505),(78.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.865),(78.515,6.035),(78.685,6.035),(78.685,5.865),(78.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.225),(78.515,6.395),(78.685,6.395),(78.685,6.225),(78.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.585),(78.515,6.755),(78.685,6.755),(78.685,6.585),(78.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.945),(78.515,7.115),(78.685,7.115),(78.685,6.945),(78.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.305),(78.515,7.475),(78.685,7.475),(78.685,7.305),(78.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.665),(78.515,7.835),(78.685,7.835),(78.685,7.665),(78.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.025),(78.515,8.195),(78.685,8.195),(78.685,8.025),(78.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.385),(78.515,8.555),(78.685,8.555),(78.685,8.385),(78.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.745),(78.515,8.915),(78.685,8.915),(78.685,8.745),(78.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.105),(78.515,9.275),(78.685,9.275),(78.685,9.105),(78.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.465),(78.515,9.635),(78.685,9.635),(78.685,9.465),(78.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.825),(78.515,9.995),(78.685,9.995),(78.685,9.825),(78.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.185),(78.515,10.355),(78.685,10.355),(78.685,10.185),(78.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.545),(78.515,10.715),(78.685,10.715),(78.685,10.545),(78.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.905),(78.515,11.075),(78.685,11.075),(78.685,10.905),(78.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.265),(78.515,11.435),(78.685,11.435),(78.685,11.265),(78.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.625),(78.515,11.795),(78.685,11.795),(78.685,11.625),(78.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.985),(78.515,12.155),(78.685,12.155),(78.685,11.985),(78.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.345),(78.515,12.515),(78.685,12.515),(78.685,12.345),(78.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.705),(78.515,12.875),(78.685,12.875),(78.685,12.705),(78.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.065),(78.515,13.235),(78.685,13.235),(78.685,13.065),(78.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.425),(78.515,13.595),(78.685,13.595),(78.685,13.425),(78.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.785),(78.515,13.955),(78.685,13.955),(78.685,13.785),(78.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.145),(78.515,14.315),(78.685,14.315),(78.685,14.145),(78.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.505),(78.515,14.675),(78.685,14.675),(78.685,14.505),(78.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.865),(78.515,15.035),(78.685,15.035),(78.685,14.865),(78.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.225),(78.515,15.395),(78.685,15.395),(78.685,15.225),(78.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.585),(78.515,15.755),(78.685,15.755),(78.685,15.585),(78.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.945),(78.515,16.115),(78.685,16.115),(78.685,15.945),(78.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.305),(78.515,16.475),(78.685,16.475),(78.685,16.305),(78.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.665),(78.515,16.835),(78.685,16.835),(78.685,16.665),(78.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.025),(78.515,17.195),(78.685,17.195),(78.685,17.025),(78.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.385),(78.515,17.555),(78.685,17.555),(78.685,17.385),(78.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.745),(78.515,17.915),(78.685,17.915),(78.685,17.745),(78.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.105),(78.515,18.275),(78.685,18.275),(78.685,18.105),(78.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.465),(78.515,18.635),(78.685,18.635),(78.685,18.465),(78.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.825),(78.515,18.995),(78.685,18.995),(78.685,18.825),(78.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.185),(78.515,19.355),(78.685,19.355),(78.685,19.185),(78.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.435),(83.06,20.605),(83.23,20.605),(83.23,20.435),(83.06,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.435),(11.315,20.605),(11.485,20.605),(11.485,20.435),(11.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,2.985),(6.77,3.155),(6.94,3.155),(6.94,2.985),(6.77,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.345),(6.77,3.515),(6.94,3.515),(6.94,3.345),(6.77,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.705),(6.77,3.875),(6.94,3.875),(6.94,3.705),(6.77,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.065),(6.77,4.235),(6.94,4.235),(6.94,4.065),(6.77,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.425),(6.77,4.595),(6.94,4.595),(6.94,4.425),(6.77,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.785),(6.77,4.955),(6.94,4.955),(6.94,4.785),(6.77,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.145),(6.77,5.315),(6.94,5.315),(6.94,5.145),(6.77,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.505),(6.77,5.675),(6.94,5.675),(6.94,5.505),(6.77,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.865),(6.77,6.035),(6.94,6.035),(6.94,5.865),(6.77,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.225),(6.77,6.395),(6.94,6.395),(6.94,6.225),(6.77,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.585),(6.77,6.755),(6.94,6.755),(6.94,6.585),(6.77,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.945),(6.77,7.115),(6.94,7.115),(6.94,6.945),(6.77,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.305),(6.77,7.475),(6.94,7.475),(6.94,7.305),(6.77,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.665),(6.77,7.835),(6.94,7.835),(6.94,7.665),(6.77,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.025),(6.77,8.195),(6.94,8.195),(6.94,8.025),(6.77,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.385),(6.77,8.555),(6.94,8.555),(6.94,8.385),(6.77,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.745),(6.77,8.915),(6.94,8.915),(6.94,8.745),(6.77,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.105),(6.77,9.275),(6.94,9.275),(6.94,9.105),(6.77,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.465),(6.77,9.635),(6.94,9.635),(6.94,9.465),(6.77,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.825),(6.77,9.995),(6.94,9.995),(6.94,9.825),(6.77,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.185),(6.77,10.355),(6.94,10.355),(6.94,10.185),(6.77,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.545),(6.77,10.715),(6.94,10.715),(6.94,10.545),(6.77,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.905),(6.77,11.075),(6.94,11.075),(6.94,10.905),(6.77,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.265),(6.77,11.435),(6.94,11.435),(6.94,11.265),(6.77,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.625),(6.77,11.795),(6.94,11.795),(6.94,11.625),(6.77,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.985),(6.77,12.155),(6.94,12.155),(6.94,11.985),(6.77,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.345),(6.77,12.515),(6.94,12.515),(6.94,12.345),(6.77,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.705),(6.77,12.875),(6.94,12.875),(6.94,12.705),(6.77,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.065),(6.77,13.235),(6.94,13.235),(6.94,13.065),(6.77,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.425),(6.77,13.595),(6.94,13.595),(6.94,13.425),(6.77,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.785),(6.77,13.955),(6.94,13.955),(6.94,13.785),(6.77,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.145),(6.77,14.315),(6.94,14.315),(6.94,14.145),(6.77,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.505),(6.77,14.675),(6.94,14.675),(6.94,14.505),(6.77,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.865),(6.77,15.035),(6.94,15.035),(6.94,14.865),(6.77,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.225),(6.77,15.395),(6.94,15.395),(6.94,15.225),(6.77,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.585),(6.77,15.755),(6.94,15.755),(6.94,15.585),(6.77,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.945),(6.77,16.115),(6.94,16.115),(6.94,15.945),(6.77,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.305),(6.77,16.475),(6.94,16.475),(6.94,16.305),(6.77,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.665),(6.77,16.835),(6.94,16.835),(6.94,16.665),(6.77,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.025),(6.77,17.195),(6.94,17.195),(6.94,17.025),(6.77,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.385),(6.77,17.555),(6.94,17.555),(6.94,17.385),(6.77,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.745),(6.77,17.915),(6.94,17.915),(6.94,17.745),(6.77,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.105),(6.77,18.275),(6.94,18.275),(6.94,18.105),(6.77,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.465),(6.77,18.635),(6.94,18.635),(6.94,18.465),(6.77,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.825),(6.77,18.995),(6.94,18.995),(6.94,18.825),(6.77,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.185),(6.77,19.355),(6.94,19.355),(6.94,19.185),(6.77,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.58,10.79),(85.58,10.96),(85.75,10.96),(85.75,10.79),(85.58,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.94,10.79),(85.94,10.96),(86.11,10.96),(86.11,10.79),(85.94,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.435),(16.115,20.605),(16.285,20.605),(16.285,20.435),(16.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,2.985),(20.915,3.155),(21.085,3.155),(21.085,2.985),(20.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.345),(20.915,3.515),(21.085,3.515),(21.085,3.345),(20.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.705),(20.915,3.875),(21.085,3.875),(21.085,3.705),(20.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.065),(20.915,4.235),(21.085,4.235),(21.085,4.065),(20.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.425),(20.915,4.595),(21.085,4.595),(21.085,4.425),(20.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.785),(20.915,4.955),(21.085,4.955),(21.085,4.785),(20.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.145),(20.915,5.315),(21.085,5.315),(21.085,5.145),(20.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.505),(20.915,5.675),(21.085,5.675),(21.085,5.505),(20.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.865),(20.915,6.035),(21.085,6.035),(21.085,5.865),(20.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.225),(20.915,6.395),(21.085,6.395),(21.085,6.225),(20.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.585),(20.915,6.755),(21.085,6.755),(21.085,6.585),(20.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.945),(20.915,7.115),(21.085,7.115),(21.085,6.945),(20.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.305),(20.915,7.475),(21.085,7.475),(21.085,7.305),(20.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.665),(20.915,7.835),(21.085,7.835),(21.085,7.665),(20.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.025),(20.915,8.195),(21.085,8.195),(21.085,8.025),(20.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.385),(20.915,8.555),(21.085,8.555),(21.085,8.385),(20.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.745),(20.915,8.915),(21.085,8.915),(21.085,8.745),(20.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.105),(20.915,9.275),(21.085,9.275),(21.085,9.105),(20.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.465),(20.915,9.635),(21.085,9.635),(21.085,9.465),(20.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.825),(20.915,9.995),(21.085,9.995),(21.085,9.825),(20.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.185),(20.915,10.355),(21.085,10.355),(21.085,10.185),(20.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.545),(20.915,10.715),(21.085,10.715),(21.085,10.545),(20.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.905),(20.915,11.075),(21.085,11.075),(21.085,10.905),(20.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.265),(20.915,11.435),(21.085,11.435),(21.085,11.265),(20.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.625),(20.915,11.795),(21.085,11.795),(21.085,11.625),(20.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.985),(20.915,12.155),(21.085,12.155),(21.085,11.985),(20.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.345),(20.915,12.515),(21.085,12.515),(21.085,12.345),(20.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.705),(20.915,12.875),(21.085,12.875),(21.085,12.705),(20.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.065),(20.915,13.235),(21.085,13.235),(21.085,13.065),(20.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.425),(20.915,13.595),(21.085,13.595),(21.085,13.425),(20.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.785),(20.915,13.955),(21.085,13.955),(21.085,13.785),(20.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.145),(20.915,14.315),(21.085,14.315),(21.085,14.145),(20.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.505),(20.915,14.675),(21.085,14.675),(21.085,14.505),(20.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.865),(20.915,15.035),(21.085,15.035),(21.085,14.865),(20.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.225),(20.915,15.395),(21.085,15.395),(21.085,15.225),(20.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.585),(20.915,15.755),(21.085,15.755),(21.085,15.585),(20.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.945),(20.915,16.115),(21.085,16.115),(21.085,15.945),(20.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.305),(20.915,16.475),(21.085,16.475),(21.085,16.305),(20.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.665),(20.915,16.835),(21.085,16.835),(21.085,16.665),(20.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.025),(20.915,17.195),(21.085,17.195),(21.085,17.025),(20.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.385),(20.915,17.555),(21.085,17.555),(21.085,17.385),(20.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.745),(20.915,17.915),(21.085,17.915),(21.085,17.745),(20.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.105),(20.915,18.275),(21.085,18.275),(21.085,18.105),(20.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.465),(20.915,18.635),(21.085,18.635),(21.085,18.465),(20.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.825),(20.915,18.995),(21.085,18.995),(21.085,18.825),(20.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.185),(20.915,19.355),(21.085,19.355),(21.085,19.185),(20.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,2.985),(64.115,3.155),(64.285,3.155),(64.285,2.985),(64.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.345),(64.115,3.515),(64.285,3.515),(64.285,3.345),(64.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.705),(64.115,3.875),(64.285,3.875),(64.285,3.705),(64.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.065),(64.115,4.235),(64.285,4.235),(64.285,4.065),(64.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.425),(64.115,4.595),(64.285,4.595),(64.285,4.425),(64.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.785),(64.115,4.955),(64.285,4.955),(64.285,4.785),(64.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.145),(64.115,5.315),(64.285,5.315),(64.285,5.145),(64.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.505),(64.115,5.675),(64.285,5.675),(64.285,5.505),(64.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.865),(64.115,6.035),(64.285,6.035),(64.285,5.865),(64.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.225),(64.115,6.395),(64.285,6.395),(64.285,6.225),(64.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.585),(64.115,6.755),(64.285,6.755),(64.285,6.585),(64.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.945),(64.115,7.115),(64.285,7.115),(64.285,6.945),(64.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.305),(64.115,7.475),(64.285,7.475),(64.285,7.305),(64.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.665),(64.115,7.835),(64.285,7.835),(64.285,7.665),(64.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.025),(64.115,8.195),(64.285,8.195),(64.285,8.025),(64.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.385),(64.115,8.555),(64.285,8.555),(64.285,8.385),(64.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.745),(64.115,8.915),(64.285,8.915),(64.285,8.745),(64.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.105),(64.115,9.275),(64.285,9.275),(64.285,9.105),(64.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.465),(64.115,9.635),(64.285,9.635),(64.285,9.465),(64.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.825),(64.115,9.995),(64.285,9.995),(64.285,9.825),(64.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.185),(64.115,10.355),(64.285,10.355),(64.285,10.185),(64.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.545),(64.115,10.715),(64.285,10.715),(64.285,10.545),(64.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.905),(64.115,11.075),(64.285,11.075),(64.285,10.905),(64.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.265),(64.115,11.435),(64.285,11.435),(64.285,11.265),(64.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.625),(64.115,11.795),(64.285,11.795),(64.285,11.625),(64.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.985),(64.115,12.155),(64.285,12.155),(64.285,11.985),(64.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.345),(64.115,12.515),(64.285,12.515),(64.285,12.345),(64.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.705),(64.115,12.875),(64.285,12.875),(64.285,12.705),(64.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.065),(64.115,13.235),(64.285,13.235),(64.285,13.065),(64.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.425),(64.115,13.595),(64.285,13.595),(64.285,13.425),(64.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.785),(64.115,13.955),(64.285,13.955),(64.285,13.785),(64.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.145),(64.115,14.315),(64.285,14.315),(64.285,14.145),(64.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.505),(64.115,14.675),(64.285,14.675),(64.285,14.505),(64.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.865),(64.115,15.035),(64.285,15.035),(64.285,14.865),(64.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.225),(64.115,15.395),(64.285,15.395),(64.285,15.225),(64.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.585),(64.115,15.755),(64.285,15.755),(64.285,15.585),(64.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.945),(64.115,16.115),(64.285,16.115),(64.285,15.945),(64.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.305),(64.115,16.475),(64.285,16.475),(64.285,16.305),(64.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.665),(64.115,16.835),(64.285,16.835),(64.285,16.665),(64.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.025),(64.115,17.195),(64.285,17.195),(64.285,17.025),(64.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.385),(64.115,17.555),(64.285,17.555),(64.285,17.385),(64.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.745),(64.115,17.915),(64.285,17.915),(64.285,17.745),(64.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.105),(64.115,18.275),(64.285,18.275),(64.285,18.105),(64.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.465),(64.115,18.635),(64.285,18.635),(64.285,18.465),(64.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.825),(64.115,18.995),(64.285,18.995),(64.285,18.825),(64.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.185),(64.115,19.355),(64.285,19.355),(64.285,19.185),(64.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.985),(40.115,3.155),(40.285,3.155),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.345),(40.115,3.515),(40.285,3.515),(40.285,3.345),(40.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.705),(40.115,3.875),(40.285,3.875),(40.285,3.705),(40.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.065),(40.115,4.235),(40.285,4.235),(40.285,4.065),(40.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.425),(40.115,4.595),(40.285,4.595),(40.285,4.425),(40.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.785),(40.115,4.955),(40.285,4.955),(40.285,4.785),(40.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.145),(40.115,5.315),(40.285,5.315),(40.285,5.145),(40.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.505),(40.115,5.675),(40.285,5.675),(40.285,5.505),(40.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.865),(40.115,6.035),(40.285,6.035),(40.285,5.865),(40.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.225),(40.115,6.395),(40.285,6.395),(40.285,6.225),(40.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.585),(40.115,6.755),(40.285,6.755),(40.285,6.585),(40.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.305),(40.115,7.475),(40.285,7.475),(40.285,7.305),(40.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.665),(40.115,7.835),(40.285,7.835),(40.285,7.665),(40.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.385),(40.115,8.555),(40.285,8.555),(40.285,8.385),(40.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.745),(40.115,8.915),(40.285,8.915),(40.285,8.745),(40.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.105),(40.115,9.275),(40.285,9.275),(40.285,9.105),(40.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.465),(40.115,9.635),(40.285,9.635),(40.285,9.465),(40.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.825),(40.115,9.995),(40.285,9.995),(40.285,9.825),(40.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.185),(40.115,10.355),(40.285,10.355),(40.285,10.185),(40.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.545),(40.115,10.715),(40.285,10.715),(40.285,10.545),(40.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.905),(40.115,11.075),(40.285,11.075),(40.285,10.905),(40.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.265),(40.115,11.435),(40.285,11.435),(40.285,11.265),(40.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.625),(40.115,11.795),(40.285,11.795),(40.285,11.625),(40.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.985),(40.115,12.155),(40.285,12.155),(40.285,11.985),(40.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.345),(40.115,12.515),(40.285,12.515),(40.285,12.345),(40.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.705),(40.115,12.875),(40.285,12.875),(40.285,12.705),(40.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.425),(40.115,13.595),(40.285,13.595),(40.285,13.425),(40.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.785),(40.115,13.955),(40.285,13.955),(40.285,13.785),(40.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.505),(40.115,14.675),(40.285,14.675),(40.285,14.505),(40.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.865),(40.115,15.035),(40.285,15.035),(40.285,14.865),(40.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.225),(40.115,15.395),(40.285,15.395),(40.285,15.225),(40.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.585),(40.115,15.755),(40.285,15.755),(40.285,15.585),(40.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.945),(40.115,16.115),(40.285,16.115),(40.285,15.945),(40.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.305),(40.115,16.475),(40.285,16.475),(40.285,16.305),(40.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.665),(40.115,16.835),(40.285,16.835),(40.285,16.665),(40.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.025),(40.115,17.195),(40.285,17.195),(40.285,17.025),(40.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.385),(40.115,17.555),(40.285,17.555),(40.285,17.385),(40.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.745),(40.115,17.915),(40.285,17.915),(40.285,17.745),(40.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.105),(40.115,18.275),(40.285,18.275),(40.285,18.105),(40.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.465),(40.115,18.635),(40.285,18.635),(40.285,18.465),(40.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.825),(40.115,18.995),(40.285,18.995),(40.285,18.825),(40.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.435),(68.915,20.605),(69.085,20.605),(69.085,20.435),(68.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.985),(35.315,3.155),(35.485,3.155),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.345),(35.315,3.515),(35.485,3.515),(35.485,3.345),(35.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.705),(35.315,3.875),(35.485,3.875),(35.485,3.705),(35.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.065),(35.315,4.235),(35.485,4.235),(35.485,4.065),(35.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.425),(35.315,4.595),(35.485,4.595),(35.485,4.425),(35.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.785),(35.315,4.955),(35.485,4.955),(35.485,4.785),(35.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.145),(35.315,5.315),(35.485,5.315),(35.485,5.145),(35.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.505),(35.315,5.675),(35.485,5.675),(35.485,5.505),(35.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.865),(35.315,6.035),(35.485,6.035),(35.485,5.865),(35.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.225),(35.315,6.395),(35.485,6.395),(35.485,6.225),(35.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.585),(35.315,6.755),(35.485,6.755),(35.485,6.585),(35.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.305),(35.315,7.475),(35.485,7.475),(35.485,7.305),(35.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.665),(35.315,7.835),(35.485,7.835),(35.485,7.665),(35.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.385),(35.315,8.555),(35.485,8.555),(35.485,8.385),(35.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.745),(35.315,8.915),(35.485,8.915),(35.485,8.745),(35.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.105),(35.315,9.275),(35.485,9.275),(35.485,9.105),(35.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.465),(35.315,9.635),(35.485,9.635),(35.485,9.465),(35.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.825),(35.315,9.995),(35.485,9.995),(35.485,9.825),(35.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.185),(35.315,10.355),(35.485,10.355),(35.485,10.185),(35.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.545),(35.315,10.715),(35.485,10.715),(35.485,10.545),(35.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.905),(35.315,11.075),(35.485,11.075),(35.485,10.905),(35.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.265),(35.315,11.435),(35.485,11.435),(35.485,11.265),(35.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.625),(35.315,11.795),(35.485,11.795),(35.485,11.625),(35.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.985),(35.315,12.155),(35.485,12.155),(35.485,11.985),(35.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.345),(35.315,12.515),(35.485,12.515),(35.485,12.345),(35.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.705),(35.315,12.875),(35.485,12.875),(35.485,12.705),(35.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.425),(35.315,13.595),(35.485,13.595),(35.485,13.425),(35.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.785),(35.315,13.955),(35.485,13.955),(35.485,13.785),(35.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.505),(35.315,14.675),(35.485,14.675),(35.485,14.505),(35.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.865),(35.315,15.035),(35.485,15.035),(35.485,14.865),(35.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.225),(35.315,15.395),(35.485,15.395),(35.485,15.225),(35.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.585),(35.315,15.755),(35.485,15.755),(35.485,15.585),(35.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.945),(35.315,16.115),(35.485,16.115),(35.485,15.945),(35.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.305),(35.315,16.475),(35.485,16.475),(35.485,16.305),(35.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.665),(35.315,16.835),(35.485,16.835),(35.485,16.665),(35.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.025),(35.315,17.195),(35.485,17.195),(35.485,17.025),(35.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.385),(35.315,17.555),(35.485,17.555),(35.485,17.385),(35.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.745),(35.315,17.915),(35.485,17.915),(35.485,17.745),(35.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.105),(35.315,18.275),(35.485,18.275),(35.485,18.105),(35.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.465),(35.315,18.635),(35.485,18.635),(35.485,18.465),(35.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.825),(35.315,18.995),(35.485,18.995),(35.485,18.825),(35.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.435),(59.315,20.605),(59.485,20.605),(59.485,20.435),(59.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,2.985),(73.715,3.155),(73.885,3.155),(73.885,2.985),(73.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.345),(73.715,3.515),(73.885,3.515),(73.885,3.345),(73.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.705),(73.715,3.875),(73.885,3.875),(73.885,3.705),(73.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.065),(73.715,4.235),(73.885,4.235),(73.885,4.065),(73.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.425),(73.715,4.595),(73.885,4.595),(73.885,4.425),(73.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.785),(73.715,4.955),(73.885,4.955),(73.885,4.785),(73.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.145),(73.715,5.315),(73.885,5.315),(73.885,5.145),(73.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.505),(73.715,5.675),(73.885,5.675),(73.885,5.505),(73.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.865),(73.715,6.035),(73.885,6.035),(73.885,5.865),(73.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.225),(73.715,6.395),(73.885,6.395),(73.885,6.225),(73.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.585),(73.715,6.755),(73.885,6.755),(73.885,6.585),(73.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.945),(73.715,7.115),(73.885,7.115),(73.885,6.945),(73.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.305),(73.715,7.475),(73.885,7.475),(73.885,7.305),(73.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.665),(73.715,7.835),(73.885,7.835),(73.885,7.665),(73.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.025),(73.715,8.195),(73.885,8.195),(73.885,8.025),(73.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.385),(73.715,8.555),(73.885,8.555),(73.885,8.385),(73.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.745),(73.715,8.915),(73.885,8.915),(73.885,8.745),(73.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.105),(73.715,9.275),(73.885,9.275),(73.885,9.105),(73.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.465),(73.715,9.635),(73.885,9.635),(73.885,9.465),(73.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.825),(73.715,9.995),(73.885,9.995),(73.885,9.825),(73.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.185),(73.715,10.355),(73.885,10.355),(73.885,10.185),(73.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.545),(73.715,10.715),(73.885,10.715),(73.885,10.545),(73.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.905),(73.715,11.075),(73.885,11.075),(73.885,10.905),(73.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.265),(73.715,11.435),(73.885,11.435),(73.885,11.265),(73.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.625),(73.715,11.795),(73.885,11.795),(73.885,11.625),(73.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.985),(73.715,12.155),(73.885,12.155),(73.885,11.985),(73.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.345),(73.715,12.515),(73.885,12.515),(73.885,12.345),(73.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.705),(73.715,12.875),(73.885,12.875),(73.885,12.705),(73.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.065),(73.715,13.235),(73.885,13.235),(73.885,13.065),(73.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.425),(73.715,13.595),(73.885,13.595),(73.885,13.425),(73.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.785),(73.715,13.955),(73.885,13.955),(73.885,13.785),(73.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.145),(73.715,14.315),(73.885,14.315),(73.885,14.145),(73.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.505),(73.715,14.675),(73.885,14.675),(73.885,14.505),(73.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.865),(73.715,15.035),(73.885,15.035),(73.885,14.865),(73.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.225),(73.715,15.395),(73.885,15.395),(73.885,15.225),(73.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.585),(73.715,15.755),(73.885,15.755),(73.885,15.585),(73.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.945),(73.715,16.115),(73.885,16.115),(73.885,15.945),(73.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.305),(73.715,16.475),(73.885,16.475),(73.885,16.305),(73.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.665),(73.715,16.835),(73.885,16.835),(73.885,16.665),(73.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.025),(73.715,17.195),(73.885,17.195),(73.885,17.025),(73.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.385),(73.715,17.555),(73.885,17.555),(73.885,17.385),(73.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.745),(73.715,17.915),(73.885,17.915),(73.885,17.745),(73.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.105),(73.715,18.275),(73.885,18.275),(73.885,18.105),(73.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.465),(73.715,18.635),(73.885,18.635),(73.885,18.465),(73.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.825),(73.715,18.995),(73.885,18.995),(73.885,18.825),(73.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.185),(73.715,19.355),(73.885,19.355),(73.885,19.185),(73.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,2.985),(59.315,3.155),(59.485,3.155),(59.485,2.985),(59.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.345),(59.315,3.515),(59.485,3.515),(59.485,3.345),(59.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.705),(59.315,3.875),(59.485,3.875),(59.485,3.705),(59.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.065),(59.315,4.235),(59.485,4.235),(59.485,4.065),(59.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.425),(59.315,4.595),(59.485,4.595),(59.485,4.425),(59.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.785),(59.315,4.955),(59.485,4.955),(59.485,4.785),(59.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.145),(59.315,5.315),(59.485,5.315),(59.485,5.145),(59.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.505),(59.315,5.675),(59.485,5.675),(59.485,5.505),(59.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.865),(59.315,6.035),(59.485,6.035),(59.485,5.865),(59.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.225),(59.315,6.395),(59.485,6.395),(59.485,6.225),(59.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.585),(59.315,6.755),(59.485,6.755),(59.485,6.585),(59.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.945),(59.315,7.115),(59.485,7.115),(59.485,6.945),(59.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.305),(59.315,7.475),(59.485,7.475),(59.485,7.305),(59.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.665),(59.315,7.835),(59.485,7.835),(59.485,7.665),(59.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.385),(59.315,8.555),(59.485,8.555),(59.485,8.385),(59.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.745),(59.315,8.915),(59.485,8.915),(59.485,8.745),(59.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.105),(59.315,9.275),(59.485,9.275),(59.485,9.105),(59.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.465),(59.315,9.635),(59.485,9.635),(59.485,9.465),(59.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.825),(59.315,9.995),(59.485,9.995),(59.485,9.825),(59.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.185),(59.315,10.355),(59.485,10.355),(59.485,10.185),(59.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.545),(59.315,10.715),(59.485,10.715),(59.485,10.545),(59.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.905),(59.315,11.075),(59.485,11.075),(59.485,10.905),(59.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.265),(59.315,11.435),(59.485,11.435),(59.485,11.265),(59.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.625),(59.315,11.795),(59.485,11.795),(59.485,11.625),(59.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.985),(59.315,12.155),(59.485,12.155),(59.485,11.985),(59.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.345),(59.315,12.515),(59.485,12.515),(59.485,12.345),(59.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.705),(59.315,12.875),(59.485,12.875),(59.485,12.705),(59.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.065),(59.315,13.235),(59.485,13.235),(59.485,13.065),(59.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.425),(59.315,13.595),(59.485,13.595),(59.485,13.425),(59.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.785),(59.315,13.955),(59.485,13.955),(59.485,13.785),(59.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.505),(59.315,14.675),(59.485,14.675),(59.485,14.505),(59.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.865),(59.315,15.035),(59.485,15.035),(59.485,14.865),(59.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.225),(59.315,15.395),(59.485,15.395),(59.485,15.225),(59.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.585),(59.315,15.755),(59.485,15.755),(59.485,15.585),(59.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.945),(59.315,16.115),(59.485,16.115),(59.485,15.945),(59.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.305),(59.315,16.475),(59.485,16.475),(59.485,16.305),(59.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.665),(59.315,16.835),(59.485,16.835),(59.485,16.665),(59.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.025),(59.315,17.195),(59.485,17.195),(59.485,17.025),(59.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.385),(59.315,17.555),(59.485,17.555),(59.485,17.385),(59.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.745),(59.315,17.915),(59.485,17.915),(59.485,17.745),(59.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.105),(59.315,18.275),(59.485,18.275),(59.485,18.105),(59.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.465),(59.315,18.635),(59.485,18.635),(59.485,18.465),(59.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.825),(59.315,18.995),(59.485,18.995),(59.485,18.825),(59.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.185),(59.315,19.355),(59.485,19.355),(59.485,19.185),(59.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,2.985),(25.715,3.155),(25.885,3.155),(25.885,2.985),(25.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.345),(25.715,3.515),(25.885,3.515),(25.885,3.345),(25.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.705),(25.715,3.875),(25.885,3.875),(25.885,3.705),(25.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.065),(25.715,4.235),(25.885,4.235),(25.885,4.065),(25.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.425),(25.715,4.595),(25.885,4.595),(25.885,4.425),(25.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.785),(25.715,4.955),(25.885,4.955),(25.885,4.785),(25.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.145),(25.715,5.315),(25.885,5.315),(25.885,5.145),(25.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.505),(25.715,5.675),(25.885,5.675),(25.885,5.505),(25.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.865),(25.715,6.035),(25.885,6.035),(25.885,5.865),(25.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.225),(25.715,6.395),(25.885,6.395),(25.885,6.225),(25.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.585),(25.715,6.755),(25.885,6.755),(25.885,6.585),(25.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.945),(25.715,7.115),(25.885,7.115),(25.885,6.945),(25.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.305),(25.715,7.475),(25.885,7.475),(25.885,7.305),(25.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.665),(25.715,7.835),(25.885,7.835),(25.885,7.665),(25.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.025),(25.715,8.195),(25.885,8.195),(25.885,8.025),(25.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.385),(25.715,8.555),(25.885,8.555),(25.885,8.385),(25.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.745),(25.715,8.915),(25.885,8.915),(25.885,8.745),(25.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.105),(25.715,9.275),(25.885,9.275),(25.885,9.105),(25.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.465),(25.715,9.635),(25.885,9.635),(25.885,9.465),(25.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.825),(25.715,9.995),(25.885,9.995),(25.885,9.825),(25.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.185),(25.715,10.355),(25.885,10.355),(25.885,10.185),(25.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.545),(25.715,10.715),(25.885,10.715),(25.885,10.545),(25.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.905),(25.715,11.075),(25.885,11.075),(25.885,10.905),(25.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.265),(25.715,11.435),(25.885,11.435),(25.885,11.265),(25.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.625),(25.715,11.795),(25.885,11.795),(25.885,11.625),(25.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.985),(25.715,12.155),(25.885,12.155),(25.885,11.985),(25.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.345),(25.715,12.515),(25.885,12.515),(25.885,12.345),(25.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.705),(25.715,12.875),(25.885,12.875),(25.885,12.705),(25.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.065),(25.715,13.235),(25.885,13.235),(25.885,13.065),(25.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.425),(25.715,13.595),(25.885,13.595),(25.885,13.425),(25.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.785),(25.715,13.955),(25.885,13.955),(25.885,13.785),(25.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.145),(25.715,14.315),(25.885,14.315),(25.885,14.145),(25.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.505),(25.715,14.675),(25.885,14.675),(25.885,14.505),(25.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.865),(25.715,15.035),(25.885,15.035),(25.885,14.865),(25.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.225),(25.715,15.395),(25.885,15.395),(25.885,15.225),(25.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.585),(25.715,15.755),(25.885,15.755),(25.885,15.585),(25.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.945),(25.715,16.115),(25.885,16.115),(25.885,15.945),(25.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.305),(25.715,16.475),(25.885,16.475),(25.885,16.305),(25.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.665),(25.715,16.835),(25.885,16.835),(25.885,16.665),(25.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.025),(25.715,17.195),(25.885,17.195),(25.885,17.025),(25.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.385),(25.715,17.555),(25.885,17.555),(25.885,17.385),(25.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.745),(25.715,17.915),(25.885,17.915),(25.885,17.745),(25.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.105),(25.715,18.275),(25.885,18.275),(25.885,18.105),(25.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.465),(25.715,18.635),(25.885,18.635),(25.885,18.465),(25.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.825),(25.715,18.995),(25.885,18.995),(25.885,18.825),(25.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.185),(25.715,19.355),(25.885,19.355),(25.885,19.185),(25.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,2.985),(83.06,3.155),(83.23,3.155),(83.23,2.985),(83.06,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.345),(83.06,3.515),(83.23,3.515),(83.23,3.345),(83.06,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.705),(83.06,3.875),(83.23,3.875),(83.23,3.705),(83.06,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.065),(83.06,4.235),(83.23,4.235),(83.23,4.065),(83.06,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.425),(83.06,4.595),(83.23,4.595),(83.23,4.425),(83.06,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.785),(83.06,4.955),(83.23,4.955),(83.23,4.785),(83.06,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.145),(83.06,5.315),(83.23,5.315),(83.23,5.145),(83.06,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.505),(83.06,5.675),(83.23,5.675),(83.23,5.505),(83.06,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.865),(83.06,6.035),(83.23,6.035),(83.23,5.865),(83.06,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.225),(83.06,6.395),(83.23,6.395),(83.23,6.225),(83.06,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.585),(83.06,6.755),(83.23,6.755),(83.23,6.585),(83.06,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.945),(83.06,7.115),(83.23,7.115),(83.23,6.945),(83.06,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.305),(83.06,7.475),(83.23,7.475),(83.23,7.305),(83.06,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.665),(83.06,7.835),(83.23,7.835),(83.23,7.665),(83.06,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.025),(83.06,8.195),(83.23,8.195),(83.23,8.025),(83.06,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.385),(83.06,8.555),(83.23,8.555),(83.23,8.385),(83.06,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.745),(83.06,8.915),(83.23,8.915),(83.23,8.745),(83.06,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.105),(83.06,9.275),(83.23,9.275),(83.23,9.105),(83.06,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.465),(83.06,9.635),(83.23,9.635),(83.23,9.465),(83.06,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.825),(83.06,9.995),(83.23,9.995),(83.23,9.825),(83.06,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.185),(83.06,10.355),(83.23,10.355),(83.23,10.185),(83.06,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.545),(83.06,10.715),(83.23,10.715),(83.23,10.545),(83.06,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.905),(83.06,11.075),(83.23,11.075),(83.23,10.905),(83.06,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.265),(83.06,11.435),(83.23,11.435),(83.23,11.265),(83.06,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.625),(83.06,11.795),(83.23,11.795),(83.23,11.625),(83.06,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.985),(83.06,12.155),(83.23,12.155),(83.23,11.985),(83.06,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.345),(83.06,12.515),(83.23,12.515),(83.23,12.345),(83.06,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.705),(83.06,12.875),(83.23,12.875),(83.23,12.705),(83.06,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.065),(83.06,13.235),(83.23,13.235),(83.23,13.065),(83.06,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.425),(83.06,13.595),(83.23,13.595),(83.23,13.425),(83.06,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.785),(83.06,13.955),(83.23,13.955),(83.23,13.785),(83.06,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.145),(83.06,14.315),(83.23,14.315),(83.23,14.145),(83.06,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.505),(83.06,14.675),(83.23,14.675),(83.23,14.505),(83.06,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.865),(83.06,15.035),(83.23,15.035),(83.23,14.865),(83.06,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.225),(83.06,15.395),(83.23,15.395),(83.23,15.225),(83.06,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.585),(83.06,15.755),(83.23,15.755),(83.23,15.585),(83.06,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.945),(83.06,16.115),(83.23,16.115),(83.23,15.945),(83.06,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.305),(83.06,16.475),(83.23,16.475),(83.23,16.305),(83.06,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.665),(83.06,16.835),(83.23,16.835),(83.23,16.665),(83.06,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.025),(83.06,17.195),(83.23,17.195),(83.23,17.025),(83.06,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.385),(83.06,17.555),(83.23,17.555),(83.23,17.385),(83.06,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.745),(83.06,17.915),(83.23,17.915),(83.23,17.745),(83.06,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.105),(83.06,18.275),(83.23,18.275),(83.23,18.105),(83.06,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.465),(83.06,18.635),(83.23,18.635),(83.23,18.465),(83.06,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.825),(83.06,18.995),(83.23,18.995),(83.23,18.825),(83.06,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.185),(83.06,19.355),(83.23,19.355),(83.23,19.185),(83.06,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.435),(6.77,20.605),(6.94,20.605),(6.94,20.435),(6.77,20.435)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,2.925),(59.285,19.415),(59.515,19.415),(59.515,2.925),(59.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,2.925),(16.085,19.415),(16.315,19.415),(16.315,2.925),(16.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,1.675),(40.085,1.965),(40.315,1.965),(40.315,1.675),(40.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,20.375),(44.885,20.665),(45.115,20.665),(45.115,20.375),(44.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,2.925),(78.485,19.415),(78.715,19.415),(78.715,2.925),(78.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,0.0),(49.685,22.34),(49.915,22.34),(49.915,0.0),(49.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,0.0),(44.885,22.34),(45.115,22.34),(45.115,0.0),(44.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,22.34),(45.13,22.34),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,22.34),(49.93,22.34),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,2.925),(54.485,19.415),(54.715,19.415),(54.715,2.925),(54.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,20.375),(78.485,20.665),(78.715,20.665),(78.715,20.375),(78.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,20.375),(83.03,20.665),(83.26,20.665),(83.26,20.375),(83.03,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,20.375),(11.285,20.665),(11.515,20.665),(11.515,20.375),(11.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,2.925),(83.03,19.415),(83.26,19.415),(83.26,2.925),(83.03,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,20.375),(68.885,20.665),(69.115,20.665),(69.115,20.375),(68.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,1.675),(64.085,1.965),(64.315,1.965),(64.315,1.675),(64.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,2.925),(44.885,19.415),(45.115,19.415),(45.115,2.925),(44.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,0.0),(68.885,22.34),(69.115,22.34),(69.115,0.0),(68.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.13),(68.87,22.21),(69.13,22.21),(69.13,0.13),(68.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.0),(68.87,22.34),(69.13,22.34),(69.13,0.0),(68.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,20.375),(20.885,20.665),(21.115,20.665),(21.115,20.375),(20.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,20.375),(30.485,20.665),(30.715,20.665),(30.715,20.375),(30.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,10.73),(85.55,11.02),(86.14,11.02),(86.14,10.73),(85.55,10.73)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.13),(83.015,22.21),(83.275,22.21),(83.275,0.13),(83.015,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,0.0),(11.285,22.34),(11.515,22.34),(11.515,0.0),(11.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.0),(83.015,22.34),(83.275,22.34),(83.275,0.0),(83.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,0.0),(83.03,22.34),(83.26,22.34),(83.26,0.0),(83.03,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.13),(11.27,22.21),(11.53,22.21),(11.53,0.13),(11.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.0),(11.27,22.34),(11.53,22.34),(11.53,0.0),(11.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,20.375),(54.485,20.665),(54.715,20.665),(54.715,20.375),(54.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,20.375),(64.085,20.665),(64.315,20.665),(64.315,20.375),(64.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,0.0),(20.885,22.34),(21.115,22.34),(21.115,0.0),(20.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.13),(20.87,22.21),(21.13,22.21),(21.13,0.13),(20.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.0),(20.87,22.34),(21.13,22.34),(21.13,0.0),(20.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,11.02),(86.14,11.02),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,0.0),(54.485,22.34),(54.715,22.34),(54.715,0.0),(54.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,22.34),(54.73,22.34),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,1.675),(16.085,1.965),(16.315,1.965),(16.315,1.675),(16.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,2.925),(30.485,19.415),(30.715,19.415),(30.715,2.925),(30.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,1.675),(73.685,1.965),(73.915,1.965),(73.915,1.675),(73.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,2.925),(11.285,19.415),(11.515,19.415),(11.515,2.925),(11.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,1.675),(35.285,1.965),(35.515,1.965),(35.515,1.675),(35.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,0.0),(64.085,22.34),(64.315,22.34),(64.315,0.0),(64.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.13),(64.07,22.21),(64.33,22.21),(64.33,0.13),(64.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.0),(64.07,22.34),(64.33,22.34),(64.33,0.0),(64.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,1.675),(25.685,1.965),(25.915,1.965),(25.915,1.675),(25.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,0.0),(78.485,22.34),(78.715,22.34),(78.715,0.0),(78.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.0),(78.47,22.34),(78.73,22.34),(78.73,0.0),(78.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.13),(78.47,22.21),(78.73,22.21),(78.73,0.13),(78.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,2.925),(20.885,19.415),(21.115,19.415),(21.115,2.925),(20.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,20.375),(73.685,20.665),(73.915,20.665),(73.915,20.375),(73.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,2.925),(25.685,19.415),(25.915,19.415),(25.915,2.925),(25.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,2.925),(6.74,19.415),(6.97,19.415),(6.97,2.925),(6.74,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,1.675),(20.885,1.965),(21.115,1.965),(21.115,1.675),(20.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,1.675),(78.485,1.965),(78.715,1.965),(78.715,1.675),(78.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,1.675),(59.285,1.965),(59.515,1.965),(59.515,1.675),(59.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,20.375),(25.685,20.665),(25.915,20.665),(25.915,20.375),(25.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,20.375),(35.285,20.665),(35.515,20.665),(35.515,20.375),(35.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,1.675),(54.485,1.965),(54.715,1.965),(54.715,1.675),(54.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,20.375),(49.685,20.665),(49.915,20.665),(49.915,20.375),(49.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,0.0),(30.485,22.34),(30.715,22.34),(30.715,0.0),(30.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.13),(30.47,22.21),(30.73,22.21),(30.73,0.13),(30.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.0),(30.47,22.34),(30.73,22.34),(30.73,0.0),(30.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,1.675),(85.55,1.965),(86.14,1.965),(86.14,1.675),(85.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,1.675),(83.03,1.965),(83.26,1.965),(83.26,1.675),(83.03,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,1.675),(11.285,1.965),(11.515,1.965),(11.515,1.675),(11.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,1.675),(6.74,1.965),(6.97,1.965),(6.97,1.675),(6.74,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.13),(73.67,22.21),(73.93,22.21),(73.93,0.13),(73.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.0),(73.67,22.34),(73.93,22.34),(73.93,0.0),(73.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,0.0),(73.685,22.34),(73.915,22.34),(73.915,0.0),(73.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,0.0),(40.085,22.34),(40.315,22.34),(40.315,0.0),(40.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,22.34),(40.33,22.34),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,1.675),(44.885,1.965),(45.115,1.965),(45.115,1.675),(44.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,20.375),(16.085,20.665),(16.315,20.665),(16.315,20.375),(16.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,2.925),(68.885,19.415),(69.115,19.415),(69.115,2.925),(68.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,20.375),(59.285,20.665),(59.515,20.665),(59.515,20.375),(59.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,0.0),(25.685,22.34),(25.915,22.34),(25.915,0.0),(25.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.13),(25.67,22.21),(25.93,22.21),(25.93,0.13),(25.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.0),(25.67,22.34),(25.93,22.34),(25.93,0.0),(25.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,2.925),(73.685,19.415),(73.915,19.415),(73.915,2.925),(73.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,20.375),(6.74,20.665),(6.97,20.665),(6.97,20.375),(6.74,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,0.0),(35.285,22.34),(35.515,22.34),(35.515,0.0),(35.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,22.34),(35.53,22.34),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,1.675),(68.885,1.965),(69.115,1.965),(69.115,1.675),(68.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,1.675),(49.685,1.965),(49.915,1.965),(49.915,1.675),(49.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,0.0),(6.74,22.34),(6.97,22.34),(6.97,0.0),(6.74,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.13),(6.725,22.21),(6.985,22.21),(6.985,0.13),(6.725,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.0),(6.725,22.34),(6.985,22.34),(6.985,0.0),(6.725,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,0.0),(16.085,22.34),(16.315,22.34),(16.315,0.0),(16.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.13),(16.07,22.21),(16.33,22.21),(16.33,0.13),(16.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.0),(16.07,22.34),(16.33,22.34),(16.33,0.0),(16.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,2.925),(40.085,19.415),(40.315,19.415),(40.315,2.925),(40.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,20.375),(40.085,20.665),(40.315,20.665),(40.315,20.375),(40.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,0.0),(59.285,22.34),(59.515,22.34),(59.515,0.0),(59.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.13),(59.27,22.21),(59.53,22.21),(59.53,0.13),(59.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.0),(59.27,22.34),(59.53,22.34),(59.53,0.0),(59.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,2.925),(35.285,19.415),(35.515,19.415),(35.515,2.925),(35.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,2.925),(64.085,19.415),(64.315,19.415),(64.315,2.925),(64.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,2.925),(49.685,19.415),(49.915,19.415),(49.915,2.925),(49.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,1.675),(30.485,1.965),(30.715,1.965),(30.715,1.675),(30.485,1.675)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.215),(68.925,0.365),(69.075,0.365),(69.075,0.215),(68.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.535),(68.925,0.685),(69.075,0.685),(69.075,0.535),(68.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.855),(68.925,1.005),(69.075,1.005),(69.075,0.855),(68.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.175),(68.925,1.325),(69.075,1.325),(69.075,1.175),(68.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.495),(68.925,1.645),(69.075,1.645),(69.075,1.495),(68.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.815),(68.925,1.965),(69.075,1.965),(69.075,1.815),(68.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.135),(68.925,2.285),(69.075,2.285),(69.075,2.135),(68.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.455),(68.925,2.605),(69.075,2.605),(69.075,2.455),(68.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.775),(68.925,2.925),(69.075,2.925),(69.075,2.775),(68.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.095),(68.925,3.245),(69.075,3.245),(69.075,3.095),(68.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.415),(68.925,3.565),(69.075,3.565),(69.075,3.415),(68.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.735),(68.925,3.885),(69.075,3.885),(69.075,3.735),(68.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.055),(68.925,4.205),(69.075,4.205),(69.075,4.055),(68.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.375),(68.925,4.525),(69.075,4.525),(69.075,4.375),(68.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.695),(68.925,4.845),(69.075,4.845),(69.075,4.695),(68.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.015),(68.925,5.165),(69.075,5.165),(69.075,5.015),(68.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.335),(68.925,5.485),(69.075,5.485),(69.075,5.335),(68.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.655),(68.925,5.805),(69.075,5.805),(69.075,5.655),(68.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.975),(68.925,6.125),(69.075,6.125),(69.075,5.975),(68.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.295),(68.925,6.445),(69.075,6.445),(69.075,6.295),(68.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.615),(68.925,6.765),(69.075,6.765),(69.075,6.615),(68.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.935),(68.925,7.085),(69.075,7.085),(69.075,6.935),(68.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.255),(68.925,7.405),(69.075,7.405),(69.075,7.255),(68.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.575),(68.925,7.725),(69.075,7.725),(69.075,7.575),(68.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.895),(68.925,8.045),(69.075,8.045),(69.075,7.895),(68.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.215),(68.925,8.365),(69.075,8.365),(69.075,8.215),(68.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.535),(68.925,8.685),(69.075,8.685),(69.075,8.535),(68.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.855),(68.925,9.005),(69.075,9.005),(69.075,8.855),(68.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.175),(68.925,9.325),(69.075,9.325),(69.075,9.175),(68.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.495),(68.925,9.645),(69.075,9.645),(69.075,9.495),(68.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.815),(68.925,9.965),(69.075,9.965),(69.075,9.815),(68.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.135),(68.925,10.285),(69.075,10.285),(69.075,10.135),(68.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.455),(68.925,10.605),(69.075,10.605),(69.075,10.455),(68.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.775),(68.925,10.925),(69.075,10.925),(69.075,10.775),(68.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.095),(68.925,11.245),(69.075,11.245),(69.075,11.095),(68.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.415),(68.925,11.565),(69.075,11.565),(69.075,11.415),(68.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.735),(68.925,11.885),(69.075,11.885),(69.075,11.735),(68.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.055),(68.925,12.205),(69.075,12.205),(69.075,12.055),(68.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.375),(68.925,12.525),(69.075,12.525),(69.075,12.375),(68.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.695),(68.925,12.845),(69.075,12.845),(69.075,12.695),(68.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.015),(68.925,13.165),(69.075,13.165),(69.075,13.015),(68.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.335),(68.925,13.485),(69.075,13.485),(69.075,13.335),(68.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.655),(68.925,13.805),(69.075,13.805),(69.075,13.655),(68.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.975),(68.925,14.125),(69.075,14.125),(69.075,13.975),(68.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.295),(68.925,14.445),(69.075,14.445),(69.075,14.295),(68.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.615),(68.925,14.765),(69.075,14.765),(69.075,14.615),(68.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.935),(68.925,15.085),(69.075,15.085),(69.075,14.935),(68.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.255),(68.925,15.405),(69.075,15.405),(69.075,15.255),(68.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.575),(68.925,15.725),(69.075,15.725),(69.075,15.575),(68.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.895),(68.925,16.045),(69.075,16.045),(69.075,15.895),(68.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.215),(68.925,16.365),(69.075,16.365),(69.075,16.215),(68.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.535),(68.925,16.685),(69.075,16.685),(69.075,16.535),(68.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.855),(68.925,17.005),(69.075,17.005),(69.075,16.855),(68.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.175),(68.925,17.325),(69.075,17.325),(69.075,17.175),(68.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.495),(68.925,17.645),(69.075,17.645),(69.075,17.495),(68.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.815),(68.925,17.965),(69.075,17.965),(69.075,17.815),(68.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.135),(68.925,18.285),(69.075,18.285),(69.075,18.135),(68.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.455),(68.925,18.605),(69.075,18.605),(69.075,18.455),(68.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.775),(68.925,18.925),(69.075,18.925),(69.075,18.775),(68.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.095),(68.925,19.245),(69.075,19.245),(69.075,19.095),(68.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.415),(68.925,19.565),(69.075,19.565),(69.075,19.415),(68.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.735),(68.925,19.885),(69.075,19.885),(69.075,19.735),(68.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.055),(68.925,20.205),(69.075,20.205),(69.075,20.055),(68.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.375),(68.925,20.525),(69.075,20.525),(69.075,20.375),(68.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.695),(68.925,20.845),(69.075,20.845),(69.075,20.695),(68.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.015),(68.925,21.165),(69.075,21.165),(69.075,21.015),(68.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.335),(68.925,21.485),(69.075,21.485),(69.075,21.335),(68.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.655),(68.925,21.805),(69.075,21.805),(69.075,21.655),(68.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.975),(68.925,22.125),(69.075,22.125),(69.075,21.975),(68.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.215),(6.78,0.365),(6.93,0.365),(6.93,0.215),(6.78,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.535),(6.78,0.685),(6.93,0.685),(6.93,0.535),(6.78,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.855),(6.78,1.005),(6.93,1.005),(6.93,0.855),(6.78,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.175),(6.78,1.325),(6.93,1.325),(6.93,1.175),(6.78,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.495),(6.78,1.645),(6.93,1.645),(6.93,1.495),(6.78,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.815),(6.78,1.965),(6.93,1.965),(6.93,1.815),(6.78,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.135),(6.78,2.285),(6.93,2.285),(6.93,2.135),(6.78,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.455),(6.78,2.605),(6.93,2.605),(6.93,2.455),(6.78,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.775),(6.78,2.925),(6.93,2.925),(6.93,2.775),(6.78,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.095),(6.78,3.245),(6.93,3.245),(6.93,3.095),(6.78,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.415),(6.78,3.565),(6.93,3.565),(6.93,3.415),(6.78,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.735),(6.78,3.885),(6.93,3.885),(6.93,3.735),(6.78,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.055),(6.78,4.205),(6.93,4.205),(6.93,4.055),(6.78,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.375),(6.78,4.525),(6.93,4.525),(6.93,4.375),(6.78,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.695),(6.78,4.845),(6.93,4.845),(6.93,4.695),(6.78,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.015),(6.78,5.165),(6.93,5.165),(6.93,5.015),(6.78,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.335),(6.78,5.485),(6.93,5.485),(6.93,5.335),(6.78,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.655),(6.78,5.805),(6.93,5.805),(6.93,5.655),(6.78,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.975),(6.78,6.125),(6.93,6.125),(6.93,5.975),(6.78,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.295),(6.78,6.445),(6.93,6.445),(6.93,6.295),(6.78,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.615),(6.78,6.765),(6.93,6.765),(6.93,6.615),(6.78,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.935),(6.78,7.085),(6.93,7.085),(6.93,6.935),(6.78,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.255),(6.78,7.405),(6.93,7.405),(6.93,7.255),(6.78,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.575),(6.78,7.725),(6.93,7.725),(6.93,7.575),(6.78,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.895),(6.78,8.045),(6.93,8.045),(6.93,7.895),(6.78,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.215),(6.78,8.365),(6.93,8.365),(6.93,8.215),(6.78,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.535),(6.78,8.685),(6.93,8.685),(6.93,8.535),(6.78,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.855),(6.78,9.005),(6.93,9.005),(6.93,8.855),(6.78,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.175),(6.78,9.325),(6.93,9.325),(6.93,9.175),(6.78,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.495),(6.78,9.645),(6.93,9.645),(6.93,9.495),(6.78,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.815),(6.78,9.965),(6.93,9.965),(6.93,9.815),(6.78,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.135),(6.78,10.285),(6.93,10.285),(6.93,10.135),(6.78,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.455),(6.78,10.605),(6.93,10.605),(6.93,10.455),(6.78,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.775),(6.78,10.925),(6.93,10.925),(6.93,10.775),(6.78,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.095),(6.78,11.245),(6.93,11.245),(6.93,11.095),(6.78,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.415),(6.78,11.565),(6.93,11.565),(6.93,11.415),(6.78,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.735),(6.78,11.885),(6.93,11.885),(6.93,11.735),(6.78,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.055),(6.78,12.205),(6.93,12.205),(6.93,12.055),(6.78,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.375),(6.78,12.525),(6.93,12.525),(6.93,12.375),(6.78,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.695),(6.78,12.845),(6.93,12.845),(6.93,12.695),(6.78,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.015),(6.78,13.165),(6.93,13.165),(6.93,13.015),(6.78,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.335),(6.78,13.485),(6.93,13.485),(6.93,13.335),(6.78,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.655),(6.78,13.805),(6.93,13.805),(6.93,13.655),(6.78,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.975),(6.78,14.125),(6.93,14.125),(6.93,13.975),(6.78,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.295),(6.78,14.445),(6.93,14.445),(6.93,14.295),(6.78,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.615),(6.78,14.765),(6.93,14.765),(6.93,14.615),(6.78,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.935),(6.78,15.085),(6.93,15.085),(6.93,14.935),(6.78,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.255),(6.78,15.405),(6.93,15.405),(6.93,15.255),(6.78,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.575),(6.78,15.725),(6.93,15.725),(6.93,15.575),(6.78,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.895),(6.78,16.045),(6.93,16.045),(6.93,15.895),(6.78,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.215),(6.78,16.365),(6.93,16.365),(6.93,16.215),(6.78,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.535),(6.78,16.685),(6.93,16.685),(6.93,16.535),(6.78,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.855),(6.78,17.005),(6.93,17.005),(6.93,16.855),(6.78,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.175),(6.78,17.325),(6.93,17.325),(6.93,17.175),(6.78,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.495),(6.78,17.645),(6.93,17.645),(6.93,17.495),(6.78,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.815),(6.78,17.965),(6.93,17.965),(6.93,17.815),(6.78,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.135),(6.78,18.285),(6.93,18.285),(6.93,18.135),(6.78,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.455),(6.78,18.605),(6.93,18.605),(6.93,18.455),(6.78,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.775),(6.78,18.925),(6.93,18.925),(6.93,18.775),(6.78,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.095),(6.78,19.245),(6.93,19.245),(6.93,19.095),(6.78,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.415),(6.78,19.565),(6.93,19.565),(6.93,19.415),(6.78,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.735),(6.78,19.885),(6.93,19.885),(6.93,19.735),(6.78,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.055),(6.78,20.205),(6.93,20.205),(6.93,20.055),(6.78,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.375),(6.78,20.525),(6.93,20.525),(6.93,20.375),(6.78,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.695),(6.78,20.845),(6.93,20.845),(6.93,20.695),(6.78,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.015),(6.78,21.165),(6.93,21.165),(6.93,21.015),(6.78,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.335),(6.78,21.485),(6.93,21.485),(6.93,21.335),(6.78,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.655),(6.78,21.805),(6.93,21.805),(6.93,21.655),(6.78,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.975),(6.78,22.125),(6.93,22.125),(6.93,21.975),(6.78,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.215),(35.325,0.365),(35.475,0.365),(35.475,0.215),(35.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.535),(35.325,0.685),(35.475,0.685),(35.475,0.535),(35.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.855),(35.325,1.005),(35.475,1.005),(35.475,0.855),(35.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.175),(35.325,1.325),(35.475,1.325),(35.475,1.175),(35.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.495),(35.325,1.645),(35.475,1.645),(35.475,1.495),(35.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.815),(35.325,1.965),(35.475,1.965),(35.475,1.815),(35.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.135),(35.325,2.285),(35.475,2.285),(35.475,2.135),(35.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.455),(35.325,2.605),(35.475,2.605),(35.475,2.455),(35.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.775),(35.325,2.925),(35.475,2.925),(35.475,2.775),(35.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.095),(35.325,3.245),(35.475,3.245),(35.475,3.095),(35.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.415),(35.325,3.565),(35.475,3.565),(35.475,3.415),(35.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.735),(35.325,3.885),(35.475,3.885),(35.475,3.735),(35.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.055),(35.325,4.205),(35.475,4.205),(35.475,4.055),(35.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.375),(35.325,4.525),(35.475,4.525),(35.475,4.375),(35.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.695),(35.325,4.845),(35.475,4.845),(35.475,4.695),(35.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.015),(35.325,5.165),(35.475,5.165),(35.475,5.015),(35.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.335),(35.325,5.485),(35.475,5.485),(35.475,5.335),(35.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.655),(35.325,5.805),(35.475,5.805),(35.475,5.655),(35.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.975),(35.325,6.125),(35.475,6.125),(35.475,5.975),(35.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.295),(35.325,6.445),(35.475,6.445),(35.475,6.295),(35.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.615),(35.325,6.765),(35.475,6.765),(35.475,6.615),(35.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.935),(35.325,7.085),(35.475,7.085),(35.475,6.935),(35.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.255),(35.325,7.405),(35.475,7.405),(35.475,7.255),(35.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.575),(35.325,7.725),(35.475,7.725),(35.475,7.575),(35.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.895),(35.325,8.045),(35.475,8.045),(35.475,7.895),(35.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.215),(35.325,8.365),(35.475,8.365),(35.475,8.215),(35.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.535),(35.325,8.685),(35.475,8.685),(35.475,8.535),(35.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.855),(35.325,9.005),(35.475,9.005),(35.475,8.855),(35.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.175),(35.325,9.325),(35.475,9.325),(35.475,9.175),(35.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.495),(35.325,9.645),(35.475,9.645),(35.475,9.495),(35.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.815),(35.325,9.965),(35.475,9.965),(35.475,9.815),(35.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.135),(35.325,10.285),(35.475,10.285),(35.475,10.135),(35.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.455),(35.325,10.605),(35.475,10.605),(35.475,10.455),(35.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.775),(35.325,10.925),(35.475,10.925),(35.475,10.775),(35.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.095),(35.325,11.245),(35.475,11.245),(35.475,11.095),(35.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.415),(35.325,11.565),(35.475,11.565),(35.475,11.415),(35.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.735),(35.325,11.885),(35.475,11.885),(35.475,11.735),(35.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.055),(35.325,12.205),(35.475,12.205),(35.475,12.055),(35.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.375),(35.325,12.525),(35.475,12.525),(35.475,12.375),(35.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.695),(35.325,12.845),(35.475,12.845),(35.475,12.695),(35.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.015),(35.325,13.165),(35.475,13.165),(35.475,13.015),(35.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.335),(35.325,13.485),(35.475,13.485),(35.475,13.335),(35.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.655),(35.325,13.805),(35.475,13.805),(35.475,13.655),(35.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.975),(35.325,14.125),(35.475,14.125),(35.475,13.975),(35.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.295),(35.325,14.445),(35.475,14.445),(35.475,14.295),(35.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.615),(35.325,14.765),(35.475,14.765),(35.475,14.615),(35.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.935),(35.325,15.085),(35.475,15.085),(35.475,14.935),(35.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.255),(35.325,15.405),(35.475,15.405),(35.475,15.255),(35.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.575),(35.325,15.725),(35.475,15.725),(35.475,15.575),(35.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.895),(35.325,16.045),(35.475,16.045),(35.475,15.895),(35.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.215),(35.325,16.365),(35.475,16.365),(35.475,16.215),(35.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.535),(35.325,16.685),(35.475,16.685),(35.475,16.535),(35.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.855),(35.325,17.005),(35.475,17.005),(35.475,16.855),(35.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.175),(35.325,17.325),(35.475,17.325),(35.475,17.175),(35.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.495),(35.325,17.645),(35.475,17.645),(35.475,17.495),(35.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.815),(35.325,17.965),(35.475,17.965),(35.475,17.815),(35.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.135),(35.325,18.285),(35.475,18.285),(35.475,18.135),(35.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.455),(35.325,18.605),(35.475,18.605),(35.475,18.455),(35.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.775),(35.325,18.925),(35.475,18.925),(35.475,18.775),(35.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.095),(35.325,19.245),(35.475,19.245),(35.475,19.095),(35.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.415),(35.325,19.565),(35.475,19.565),(35.475,19.415),(35.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.735),(35.325,19.885),(35.475,19.885),(35.475,19.735),(35.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.055),(35.325,20.205),(35.475,20.205),(35.475,20.055),(35.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.375),(35.325,20.525),(35.475,20.525),(35.475,20.375),(35.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.695),(35.325,20.845),(35.475,20.845),(35.475,20.695),(35.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.015),(35.325,21.165),(35.475,21.165),(35.475,21.015),(35.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.335),(35.325,21.485),(35.475,21.485),(35.475,21.335),(35.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.655),(35.325,21.805),(35.475,21.805),(35.475,21.655),(35.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.975),(35.325,22.125),(35.475,22.125),(35.475,21.975),(35.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.215),(49.725,0.365),(49.875,0.365),(49.875,0.215),(49.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.535),(49.725,0.685),(49.875,0.685),(49.875,0.535),(49.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.855),(49.725,1.005),(49.875,1.005),(49.875,0.855),(49.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.175),(49.725,1.325),(49.875,1.325),(49.875,1.175),(49.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.495),(49.725,1.645),(49.875,1.645),(49.875,1.495),(49.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.815),(49.725,1.965),(49.875,1.965),(49.875,1.815),(49.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.135),(49.725,2.285),(49.875,2.285),(49.875,2.135),(49.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.455),(49.725,2.605),(49.875,2.605),(49.875,2.455),(49.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.775),(49.725,2.925),(49.875,2.925),(49.875,2.775),(49.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.095),(49.725,3.245),(49.875,3.245),(49.875,3.095),(49.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.415),(49.725,3.565),(49.875,3.565),(49.875,3.415),(49.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.735),(49.725,3.885),(49.875,3.885),(49.875,3.735),(49.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.055),(49.725,4.205),(49.875,4.205),(49.875,4.055),(49.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.375),(49.725,4.525),(49.875,4.525),(49.875,4.375),(49.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.695),(49.725,4.845),(49.875,4.845),(49.875,4.695),(49.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.015),(49.725,5.165),(49.875,5.165),(49.875,5.015),(49.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.335),(49.725,5.485),(49.875,5.485),(49.875,5.335),(49.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.655),(49.725,5.805),(49.875,5.805),(49.875,5.655),(49.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.975),(49.725,6.125),(49.875,6.125),(49.875,5.975),(49.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.295),(49.725,6.445),(49.875,6.445),(49.875,6.295),(49.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.615),(49.725,6.765),(49.875,6.765),(49.875,6.615),(49.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.935),(49.725,7.085),(49.875,7.085),(49.875,6.935),(49.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.255),(49.725,7.405),(49.875,7.405),(49.875,7.255),(49.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.575),(49.725,7.725),(49.875,7.725),(49.875,7.575),(49.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.895),(49.725,8.045),(49.875,8.045),(49.875,7.895),(49.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.215),(49.725,8.365),(49.875,8.365),(49.875,8.215),(49.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.535),(49.725,8.685),(49.875,8.685),(49.875,8.535),(49.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.855),(49.725,9.005),(49.875,9.005),(49.875,8.855),(49.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.175),(49.725,9.325),(49.875,9.325),(49.875,9.175),(49.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.495),(49.725,9.645),(49.875,9.645),(49.875,9.495),(49.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.815),(49.725,9.965),(49.875,9.965),(49.875,9.815),(49.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.135),(49.725,10.285),(49.875,10.285),(49.875,10.135),(49.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.455),(49.725,10.605),(49.875,10.605),(49.875,10.455),(49.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.775),(49.725,10.925),(49.875,10.925),(49.875,10.775),(49.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.095),(49.725,11.245),(49.875,11.245),(49.875,11.095),(49.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.415),(49.725,11.565),(49.875,11.565),(49.875,11.415),(49.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.735),(49.725,11.885),(49.875,11.885),(49.875,11.735),(49.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.055),(49.725,12.205),(49.875,12.205),(49.875,12.055),(49.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.375),(49.725,12.525),(49.875,12.525),(49.875,12.375),(49.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.695),(49.725,12.845),(49.875,12.845),(49.875,12.695),(49.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.015),(49.725,13.165),(49.875,13.165),(49.875,13.015),(49.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.335),(49.725,13.485),(49.875,13.485),(49.875,13.335),(49.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.655),(49.725,13.805),(49.875,13.805),(49.875,13.655),(49.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.975),(49.725,14.125),(49.875,14.125),(49.875,13.975),(49.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.295),(49.725,14.445),(49.875,14.445),(49.875,14.295),(49.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.615),(49.725,14.765),(49.875,14.765),(49.875,14.615),(49.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.935),(49.725,15.085),(49.875,15.085),(49.875,14.935),(49.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.255),(49.725,15.405),(49.875,15.405),(49.875,15.255),(49.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.575),(49.725,15.725),(49.875,15.725),(49.875,15.575),(49.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.895),(49.725,16.045),(49.875,16.045),(49.875,15.895),(49.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.215),(49.725,16.365),(49.875,16.365),(49.875,16.215),(49.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.535),(49.725,16.685),(49.875,16.685),(49.875,16.535),(49.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.855),(49.725,17.005),(49.875,17.005),(49.875,16.855),(49.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.175),(49.725,17.325),(49.875,17.325),(49.875,17.175),(49.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.495),(49.725,17.645),(49.875,17.645),(49.875,17.495),(49.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.815),(49.725,17.965),(49.875,17.965),(49.875,17.815),(49.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.135),(49.725,18.285),(49.875,18.285),(49.875,18.135),(49.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.455),(49.725,18.605),(49.875,18.605),(49.875,18.455),(49.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.775),(49.725,18.925),(49.875,18.925),(49.875,18.775),(49.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.095),(49.725,19.245),(49.875,19.245),(49.875,19.095),(49.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.415),(49.725,19.565),(49.875,19.565),(49.875,19.415),(49.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.735),(49.725,19.885),(49.875,19.885),(49.875,19.735),(49.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.055),(49.725,20.205),(49.875,20.205),(49.875,20.055),(49.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.375),(49.725,20.525),(49.875,20.525),(49.875,20.375),(49.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.695),(49.725,20.845),(49.875,20.845),(49.875,20.695),(49.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.015),(49.725,21.165),(49.875,21.165),(49.875,21.015),(49.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.335),(49.725,21.485),(49.875,21.485),(49.875,21.335),(49.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.655),(49.725,21.805),(49.875,21.805),(49.875,21.655),(49.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.975),(49.725,22.125),(49.875,22.125),(49.875,21.975),(49.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.215),(59.325,0.365),(59.475,0.365),(59.475,0.215),(59.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.535),(59.325,0.685),(59.475,0.685),(59.475,0.535),(59.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.855),(59.325,1.005),(59.475,1.005),(59.475,0.855),(59.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.175),(59.325,1.325),(59.475,1.325),(59.475,1.175),(59.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.495),(59.325,1.645),(59.475,1.645),(59.475,1.495),(59.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.815),(59.325,1.965),(59.475,1.965),(59.475,1.815),(59.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.135),(59.325,2.285),(59.475,2.285),(59.475,2.135),(59.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.455),(59.325,2.605),(59.475,2.605),(59.475,2.455),(59.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.775),(59.325,2.925),(59.475,2.925),(59.475,2.775),(59.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.095),(59.325,3.245),(59.475,3.245),(59.475,3.095),(59.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.415),(59.325,3.565),(59.475,3.565),(59.475,3.415),(59.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.735),(59.325,3.885),(59.475,3.885),(59.475,3.735),(59.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.055),(59.325,4.205),(59.475,4.205),(59.475,4.055),(59.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.375),(59.325,4.525),(59.475,4.525),(59.475,4.375),(59.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.695),(59.325,4.845),(59.475,4.845),(59.475,4.695),(59.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.015),(59.325,5.165),(59.475,5.165),(59.475,5.015),(59.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.335),(59.325,5.485),(59.475,5.485),(59.475,5.335),(59.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.655),(59.325,5.805),(59.475,5.805),(59.475,5.655),(59.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.975),(59.325,6.125),(59.475,6.125),(59.475,5.975),(59.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.295),(59.325,6.445),(59.475,6.445),(59.475,6.295),(59.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.615),(59.325,6.765),(59.475,6.765),(59.475,6.615),(59.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.935),(59.325,7.085),(59.475,7.085),(59.475,6.935),(59.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.255),(59.325,7.405),(59.475,7.405),(59.475,7.255),(59.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.575),(59.325,7.725),(59.475,7.725),(59.475,7.575),(59.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.895),(59.325,8.045),(59.475,8.045),(59.475,7.895),(59.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.215),(59.325,8.365),(59.475,8.365),(59.475,8.215),(59.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.535),(59.325,8.685),(59.475,8.685),(59.475,8.535),(59.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.855),(59.325,9.005),(59.475,9.005),(59.475,8.855),(59.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.175),(59.325,9.325),(59.475,9.325),(59.475,9.175),(59.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.495),(59.325,9.645),(59.475,9.645),(59.475,9.495),(59.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.815),(59.325,9.965),(59.475,9.965),(59.475,9.815),(59.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.135),(59.325,10.285),(59.475,10.285),(59.475,10.135),(59.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.455),(59.325,10.605),(59.475,10.605),(59.475,10.455),(59.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.775),(59.325,10.925),(59.475,10.925),(59.475,10.775),(59.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.095),(59.325,11.245),(59.475,11.245),(59.475,11.095),(59.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.415),(59.325,11.565),(59.475,11.565),(59.475,11.415),(59.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.735),(59.325,11.885),(59.475,11.885),(59.475,11.735),(59.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.055),(59.325,12.205),(59.475,12.205),(59.475,12.055),(59.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.375),(59.325,12.525),(59.475,12.525),(59.475,12.375),(59.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.695),(59.325,12.845),(59.475,12.845),(59.475,12.695),(59.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.015),(59.325,13.165),(59.475,13.165),(59.475,13.015),(59.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.335),(59.325,13.485),(59.475,13.485),(59.475,13.335),(59.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.655),(59.325,13.805),(59.475,13.805),(59.475,13.655),(59.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.975),(59.325,14.125),(59.475,14.125),(59.475,13.975),(59.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.295),(59.325,14.445),(59.475,14.445),(59.475,14.295),(59.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.615),(59.325,14.765),(59.475,14.765),(59.475,14.615),(59.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.935),(59.325,15.085),(59.475,15.085),(59.475,14.935),(59.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.255),(59.325,15.405),(59.475,15.405),(59.475,15.255),(59.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.575),(59.325,15.725),(59.475,15.725),(59.475,15.575),(59.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.895),(59.325,16.045),(59.475,16.045),(59.475,15.895),(59.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.215),(59.325,16.365),(59.475,16.365),(59.475,16.215),(59.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.535),(59.325,16.685),(59.475,16.685),(59.475,16.535),(59.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.855),(59.325,17.005),(59.475,17.005),(59.475,16.855),(59.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.175),(59.325,17.325),(59.475,17.325),(59.475,17.175),(59.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.495),(59.325,17.645),(59.475,17.645),(59.475,17.495),(59.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.815),(59.325,17.965),(59.475,17.965),(59.475,17.815),(59.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.135),(59.325,18.285),(59.475,18.285),(59.475,18.135),(59.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.455),(59.325,18.605),(59.475,18.605),(59.475,18.455),(59.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.775),(59.325,18.925),(59.475,18.925),(59.475,18.775),(59.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.095),(59.325,19.245),(59.475,19.245),(59.475,19.095),(59.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.415),(59.325,19.565),(59.475,19.565),(59.475,19.415),(59.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.735),(59.325,19.885),(59.475,19.885),(59.475,19.735),(59.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.055),(59.325,20.205),(59.475,20.205),(59.475,20.055),(59.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.375),(59.325,20.525),(59.475,20.525),(59.475,20.375),(59.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.695),(59.325,20.845),(59.475,20.845),(59.475,20.695),(59.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.015),(59.325,21.165),(59.475,21.165),(59.475,21.015),(59.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.335),(59.325,21.485),(59.475,21.485),(59.475,21.335),(59.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.655),(59.325,21.805),(59.475,21.805),(59.475,21.655),(59.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.975),(59.325,22.125),(59.475,22.125),(59.475,21.975),(59.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.215),(83.07,0.365),(83.22,0.365),(83.22,0.215),(83.07,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.535),(83.07,0.685),(83.22,0.685),(83.22,0.535),(83.07,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.855),(83.07,1.005),(83.22,1.005),(83.22,0.855),(83.07,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.175),(83.07,1.325),(83.22,1.325),(83.22,1.175),(83.07,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.495),(83.07,1.645),(83.22,1.645),(83.22,1.495),(83.07,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.815),(83.07,1.965),(83.22,1.965),(83.22,1.815),(83.07,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.135),(83.07,2.285),(83.22,2.285),(83.22,2.135),(83.07,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.455),(83.07,2.605),(83.22,2.605),(83.22,2.455),(83.07,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.775),(83.07,2.925),(83.22,2.925),(83.22,2.775),(83.07,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.095),(83.07,3.245),(83.22,3.245),(83.22,3.095),(83.07,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.415),(83.07,3.565),(83.22,3.565),(83.22,3.415),(83.07,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.735),(83.07,3.885),(83.22,3.885),(83.22,3.735),(83.07,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.055),(83.07,4.205),(83.22,4.205),(83.22,4.055),(83.07,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.375),(83.07,4.525),(83.22,4.525),(83.22,4.375),(83.07,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.695),(83.07,4.845),(83.22,4.845),(83.22,4.695),(83.07,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.015),(83.07,5.165),(83.22,5.165),(83.22,5.015),(83.07,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.335),(83.07,5.485),(83.22,5.485),(83.22,5.335),(83.07,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.655),(83.07,5.805),(83.22,5.805),(83.22,5.655),(83.07,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.975),(83.07,6.125),(83.22,6.125),(83.22,5.975),(83.07,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.295),(83.07,6.445),(83.22,6.445),(83.22,6.295),(83.07,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.615),(83.07,6.765),(83.22,6.765),(83.22,6.615),(83.07,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.935),(83.07,7.085),(83.22,7.085),(83.22,6.935),(83.07,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.255),(83.07,7.405),(83.22,7.405),(83.22,7.255),(83.07,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.575),(83.07,7.725),(83.22,7.725),(83.22,7.575),(83.07,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.895),(83.07,8.045),(83.22,8.045),(83.22,7.895),(83.07,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.215),(83.07,8.365),(83.22,8.365),(83.22,8.215),(83.07,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.535),(83.07,8.685),(83.22,8.685),(83.22,8.535),(83.07,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.855),(83.07,9.005),(83.22,9.005),(83.22,8.855),(83.07,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.175),(83.07,9.325),(83.22,9.325),(83.22,9.175),(83.07,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.495),(83.07,9.645),(83.22,9.645),(83.22,9.495),(83.07,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.815),(83.07,9.965),(83.22,9.965),(83.22,9.815),(83.07,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.135),(83.07,10.285),(83.22,10.285),(83.22,10.135),(83.07,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.455),(83.07,10.605),(83.22,10.605),(83.22,10.455),(83.07,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.775),(83.07,10.925),(83.22,10.925),(83.22,10.775),(83.07,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.095),(83.07,11.245),(83.22,11.245),(83.22,11.095),(83.07,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.415),(83.07,11.565),(83.22,11.565),(83.22,11.415),(83.07,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.735),(83.07,11.885),(83.22,11.885),(83.22,11.735),(83.07,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.055),(83.07,12.205),(83.22,12.205),(83.22,12.055),(83.07,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.375),(83.07,12.525),(83.22,12.525),(83.22,12.375),(83.07,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.695),(83.07,12.845),(83.22,12.845),(83.22,12.695),(83.07,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.015),(83.07,13.165),(83.22,13.165),(83.22,13.015),(83.07,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.335),(83.07,13.485),(83.22,13.485),(83.22,13.335),(83.07,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.655),(83.07,13.805),(83.22,13.805),(83.22,13.655),(83.07,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.975),(83.07,14.125),(83.22,14.125),(83.22,13.975),(83.07,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.295),(83.07,14.445),(83.22,14.445),(83.22,14.295),(83.07,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.615),(83.07,14.765),(83.22,14.765),(83.22,14.615),(83.07,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.935),(83.07,15.085),(83.22,15.085),(83.22,14.935),(83.07,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.255),(83.07,15.405),(83.22,15.405),(83.22,15.255),(83.07,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.575),(83.07,15.725),(83.22,15.725),(83.22,15.575),(83.07,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.895),(83.07,16.045),(83.22,16.045),(83.22,15.895),(83.07,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.215),(83.07,16.365),(83.22,16.365),(83.22,16.215),(83.07,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.535),(83.07,16.685),(83.22,16.685),(83.22,16.535),(83.07,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.855),(83.07,17.005),(83.22,17.005),(83.22,16.855),(83.07,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.175),(83.07,17.325),(83.22,17.325),(83.22,17.175),(83.07,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.495),(83.07,17.645),(83.22,17.645),(83.22,17.495),(83.07,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.815),(83.07,17.965),(83.22,17.965),(83.22,17.815),(83.07,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.135),(83.07,18.285),(83.22,18.285),(83.22,18.135),(83.07,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.455),(83.07,18.605),(83.22,18.605),(83.22,18.455),(83.07,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.775),(83.07,18.925),(83.22,18.925),(83.22,18.775),(83.07,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.095),(83.07,19.245),(83.22,19.245),(83.22,19.095),(83.07,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.415),(83.07,19.565),(83.22,19.565),(83.22,19.415),(83.07,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.735),(83.07,19.885),(83.22,19.885),(83.22,19.735),(83.07,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.055),(83.07,20.205),(83.22,20.205),(83.22,20.055),(83.07,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.375),(83.07,20.525),(83.22,20.525),(83.22,20.375),(83.07,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.695),(83.07,20.845),(83.22,20.845),(83.22,20.695),(83.07,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.015),(83.07,21.165),(83.22,21.165),(83.22,21.015),(83.07,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.335),(83.07,21.485),(83.22,21.485),(83.22,21.335),(83.07,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.655),(83.07,21.805),(83.22,21.805),(83.22,21.655),(83.07,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.975),(83.07,22.125),(83.22,22.125),(83.22,21.975),(83.07,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.215),(40.125,0.365),(40.275,0.365),(40.275,0.215),(40.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.535),(40.125,0.685),(40.275,0.685),(40.275,0.535),(40.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.855),(40.125,1.005),(40.275,1.005),(40.275,0.855),(40.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.175),(40.125,1.325),(40.275,1.325),(40.275,1.175),(40.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.495),(40.125,1.645),(40.275,1.645),(40.275,1.495),(40.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.815),(40.125,1.965),(40.275,1.965),(40.275,1.815),(40.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.135),(40.125,2.285),(40.275,2.285),(40.275,2.135),(40.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.455),(40.125,2.605),(40.275,2.605),(40.275,2.455),(40.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.775),(40.125,2.925),(40.275,2.925),(40.275,2.775),(40.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.095),(40.125,3.245),(40.275,3.245),(40.275,3.095),(40.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.415),(40.125,3.565),(40.275,3.565),(40.275,3.415),(40.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.735),(40.125,3.885),(40.275,3.885),(40.275,3.735),(40.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.055),(40.125,4.205),(40.275,4.205),(40.275,4.055),(40.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.375),(40.125,4.525),(40.275,4.525),(40.275,4.375),(40.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.695),(40.125,4.845),(40.275,4.845),(40.275,4.695),(40.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.015),(40.125,5.165),(40.275,5.165),(40.275,5.015),(40.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.335),(40.125,5.485),(40.275,5.485),(40.275,5.335),(40.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.655),(40.125,5.805),(40.275,5.805),(40.275,5.655),(40.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.975),(40.125,6.125),(40.275,6.125),(40.275,5.975),(40.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.295),(40.125,6.445),(40.275,6.445),(40.275,6.295),(40.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.615),(40.125,6.765),(40.275,6.765),(40.275,6.615),(40.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.935),(40.125,7.085),(40.275,7.085),(40.275,6.935),(40.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.255),(40.125,7.405),(40.275,7.405),(40.275,7.255),(40.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.575),(40.125,7.725),(40.275,7.725),(40.275,7.575),(40.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.895),(40.125,8.045),(40.275,8.045),(40.275,7.895),(40.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.215),(40.125,8.365),(40.275,8.365),(40.275,8.215),(40.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.535),(40.125,8.685),(40.275,8.685),(40.275,8.535),(40.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.855),(40.125,9.005),(40.275,9.005),(40.275,8.855),(40.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.175),(40.125,9.325),(40.275,9.325),(40.275,9.175),(40.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.495),(40.125,9.645),(40.275,9.645),(40.275,9.495),(40.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.815),(40.125,9.965),(40.275,9.965),(40.275,9.815),(40.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.135),(40.125,10.285),(40.275,10.285),(40.275,10.135),(40.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.455),(40.125,10.605),(40.275,10.605),(40.275,10.455),(40.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.775),(40.125,10.925),(40.275,10.925),(40.275,10.775),(40.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.095),(40.125,11.245),(40.275,11.245),(40.275,11.095),(40.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.415),(40.125,11.565),(40.275,11.565),(40.275,11.415),(40.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.735),(40.125,11.885),(40.275,11.885),(40.275,11.735),(40.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.055),(40.125,12.205),(40.275,12.205),(40.275,12.055),(40.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.375),(40.125,12.525),(40.275,12.525),(40.275,12.375),(40.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.695),(40.125,12.845),(40.275,12.845),(40.275,12.695),(40.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.015),(40.125,13.165),(40.275,13.165),(40.275,13.015),(40.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.335),(40.125,13.485),(40.275,13.485),(40.275,13.335),(40.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.655),(40.125,13.805),(40.275,13.805),(40.275,13.655),(40.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.975),(40.125,14.125),(40.275,14.125),(40.275,13.975),(40.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.295),(40.125,14.445),(40.275,14.445),(40.275,14.295),(40.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.615),(40.125,14.765),(40.275,14.765),(40.275,14.615),(40.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.935),(40.125,15.085),(40.275,15.085),(40.275,14.935),(40.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.255),(40.125,15.405),(40.275,15.405),(40.275,15.255),(40.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.575),(40.125,15.725),(40.275,15.725),(40.275,15.575),(40.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.895),(40.125,16.045),(40.275,16.045),(40.275,15.895),(40.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.215),(40.125,16.365),(40.275,16.365),(40.275,16.215),(40.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.535),(40.125,16.685),(40.275,16.685),(40.275,16.535),(40.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.855),(40.125,17.005),(40.275,17.005),(40.275,16.855),(40.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.175),(40.125,17.325),(40.275,17.325),(40.275,17.175),(40.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.495),(40.125,17.645),(40.275,17.645),(40.275,17.495),(40.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.815),(40.125,17.965),(40.275,17.965),(40.275,17.815),(40.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.135),(40.125,18.285),(40.275,18.285),(40.275,18.135),(40.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.455),(40.125,18.605),(40.275,18.605),(40.275,18.455),(40.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.775),(40.125,18.925),(40.275,18.925),(40.275,18.775),(40.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.095),(40.125,19.245),(40.275,19.245),(40.275,19.095),(40.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.415),(40.125,19.565),(40.275,19.565),(40.275,19.415),(40.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.735),(40.125,19.885),(40.275,19.885),(40.275,19.735),(40.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.055),(40.125,20.205),(40.275,20.205),(40.275,20.055),(40.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.375),(40.125,20.525),(40.275,20.525),(40.275,20.375),(40.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.695),(40.125,20.845),(40.275,20.845),(40.275,20.695),(40.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.015),(40.125,21.165),(40.275,21.165),(40.275,21.015),(40.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.335),(40.125,21.485),(40.275,21.485),(40.275,21.335),(40.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.655),(40.125,21.805),(40.275,21.805),(40.275,21.655),(40.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.975),(40.125,22.125),(40.275,22.125),(40.275,21.975),(40.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.215),(44.925,0.365),(45.075,0.365),(45.075,0.215),(44.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.535),(44.925,0.685),(45.075,0.685),(45.075,0.535),(44.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.855),(44.925,1.005),(45.075,1.005),(45.075,0.855),(44.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.175),(44.925,1.325),(45.075,1.325),(45.075,1.175),(44.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.495),(44.925,1.645),(45.075,1.645),(45.075,1.495),(44.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.815),(44.925,1.965),(45.075,1.965),(45.075,1.815),(44.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.135),(44.925,2.285),(45.075,2.285),(45.075,2.135),(44.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.455),(44.925,2.605),(45.075,2.605),(45.075,2.455),(44.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.775),(44.925,2.925),(45.075,2.925),(45.075,2.775),(44.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.095),(44.925,3.245),(45.075,3.245),(45.075,3.095),(44.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.415),(44.925,3.565),(45.075,3.565),(45.075,3.415),(44.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.735),(44.925,3.885),(45.075,3.885),(45.075,3.735),(44.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.055),(44.925,4.205),(45.075,4.205),(45.075,4.055),(44.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.375),(44.925,4.525),(45.075,4.525),(45.075,4.375),(44.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.695),(44.925,4.845),(45.075,4.845),(45.075,4.695),(44.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.015),(44.925,5.165),(45.075,5.165),(45.075,5.015),(44.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.335),(44.925,5.485),(45.075,5.485),(45.075,5.335),(44.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.655),(44.925,5.805),(45.075,5.805),(45.075,5.655),(44.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.975),(44.925,6.125),(45.075,6.125),(45.075,5.975),(44.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.295),(44.925,6.445),(45.075,6.445),(45.075,6.295),(44.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.615),(44.925,6.765),(45.075,6.765),(45.075,6.615),(44.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.935),(44.925,7.085),(45.075,7.085),(45.075,6.935),(44.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.255),(44.925,7.405),(45.075,7.405),(45.075,7.255),(44.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.575),(44.925,7.725),(45.075,7.725),(45.075,7.575),(44.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.895),(44.925,8.045),(45.075,8.045),(45.075,7.895),(44.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.215),(44.925,8.365),(45.075,8.365),(45.075,8.215),(44.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.535),(44.925,8.685),(45.075,8.685),(45.075,8.535),(44.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.855),(44.925,9.005),(45.075,9.005),(45.075,8.855),(44.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.175),(44.925,9.325),(45.075,9.325),(45.075,9.175),(44.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.495),(44.925,9.645),(45.075,9.645),(45.075,9.495),(44.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.815),(44.925,9.965),(45.075,9.965),(45.075,9.815),(44.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.135),(44.925,10.285),(45.075,10.285),(45.075,10.135),(44.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.455),(44.925,10.605),(45.075,10.605),(45.075,10.455),(44.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.775),(44.925,10.925),(45.075,10.925),(45.075,10.775),(44.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.095),(44.925,11.245),(45.075,11.245),(45.075,11.095),(44.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.415),(44.925,11.565),(45.075,11.565),(45.075,11.415),(44.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.735),(44.925,11.885),(45.075,11.885),(45.075,11.735),(44.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.055),(44.925,12.205),(45.075,12.205),(45.075,12.055),(44.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.375),(44.925,12.525),(45.075,12.525),(45.075,12.375),(44.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.695),(44.925,12.845),(45.075,12.845),(45.075,12.695),(44.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.015),(44.925,13.165),(45.075,13.165),(45.075,13.015),(44.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.335),(44.925,13.485),(45.075,13.485),(45.075,13.335),(44.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.655),(44.925,13.805),(45.075,13.805),(45.075,13.655),(44.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.975),(44.925,14.125),(45.075,14.125),(45.075,13.975),(44.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.295),(44.925,14.445),(45.075,14.445),(45.075,14.295),(44.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.615),(44.925,14.765),(45.075,14.765),(45.075,14.615),(44.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.935),(44.925,15.085),(45.075,15.085),(45.075,14.935),(44.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.255),(44.925,15.405),(45.075,15.405),(45.075,15.255),(44.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.575),(44.925,15.725),(45.075,15.725),(45.075,15.575),(44.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.895),(44.925,16.045),(45.075,16.045),(45.075,15.895),(44.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.215),(44.925,16.365),(45.075,16.365),(45.075,16.215),(44.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.535),(44.925,16.685),(45.075,16.685),(45.075,16.535),(44.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.855),(44.925,17.005),(45.075,17.005),(45.075,16.855),(44.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.175),(44.925,17.325),(45.075,17.325),(45.075,17.175),(44.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.495),(44.925,17.645),(45.075,17.645),(45.075,17.495),(44.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.815),(44.925,17.965),(45.075,17.965),(45.075,17.815),(44.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.135),(44.925,18.285),(45.075,18.285),(45.075,18.135),(44.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.455),(44.925,18.605),(45.075,18.605),(45.075,18.455),(44.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.775),(44.925,18.925),(45.075,18.925),(45.075,18.775),(44.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.095),(44.925,19.245),(45.075,19.245),(45.075,19.095),(44.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.415),(44.925,19.565),(45.075,19.565),(45.075,19.415),(44.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.735),(44.925,19.885),(45.075,19.885),(45.075,19.735),(44.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.055),(44.925,20.205),(45.075,20.205),(45.075,20.055),(44.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.375),(44.925,20.525),(45.075,20.525),(45.075,20.375),(44.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.695),(44.925,20.845),(45.075,20.845),(45.075,20.695),(44.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.015),(44.925,21.165),(45.075,21.165),(45.075,21.015),(44.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.335),(44.925,21.485),(45.075,21.485),(45.075,21.335),(44.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.655),(44.925,21.805),(45.075,21.805),(45.075,21.655),(44.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.975),(44.925,22.125),(45.075,22.125),(45.075,21.975),(44.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.215),(25.725,0.365),(25.875,0.365),(25.875,0.215),(25.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.535),(25.725,0.685),(25.875,0.685),(25.875,0.535),(25.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.855),(25.725,1.005),(25.875,1.005),(25.875,0.855),(25.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.175),(25.725,1.325),(25.875,1.325),(25.875,1.175),(25.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.495),(25.725,1.645),(25.875,1.645),(25.875,1.495),(25.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.815),(25.725,1.965),(25.875,1.965),(25.875,1.815),(25.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.135),(25.725,2.285),(25.875,2.285),(25.875,2.135),(25.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.455),(25.725,2.605),(25.875,2.605),(25.875,2.455),(25.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.775),(25.725,2.925),(25.875,2.925),(25.875,2.775),(25.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.095),(25.725,3.245),(25.875,3.245),(25.875,3.095),(25.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.415),(25.725,3.565),(25.875,3.565),(25.875,3.415),(25.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.735),(25.725,3.885),(25.875,3.885),(25.875,3.735),(25.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.055),(25.725,4.205),(25.875,4.205),(25.875,4.055),(25.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.375),(25.725,4.525),(25.875,4.525),(25.875,4.375),(25.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.695),(25.725,4.845),(25.875,4.845),(25.875,4.695),(25.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.015),(25.725,5.165),(25.875,5.165),(25.875,5.015),(25.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.335),(25.725,5.485),(25.875,5.485),(25.875,5.335),(25.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.655),(25.725,5.805),(25.875,5.805),(25.875,5.655),(25.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.975),(25.725,6.125),(25.875,6.125),(25.875,5.975),(25.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.295),(25.725,6.445),(25.875,6.445),(25.875,6.295),(25.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.615),(25.725,6.765),(25.875,6.765),(25.875,6.615),(25.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.935),(25.725,7.085),(25.875,7.085),(25.875,6.935),(25.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.255),(25.725,7.405),(25.875,7.405),(25.875,7.255),(25.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.575),(25.725,7.725),(25.875,7.725),(25.875,7.575),(25.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.895),(25.725,8.045),(25.875,8.045),(25.875,7.895),(25.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.215),(25.725,8.365),(25.875,8.365),(25.875,8.215),(25.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.535),(25.725,8.685),(25.875,8.685),(25.875,8.535),(25.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.855),(25.725,9.005),(25.875,9.005),(25.875,8.855),(25.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.175),(25.725,9.325),(25.875,9.325),(25.875,9.175),(25.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.495),(25.725,9.645),(25.875,9.645),(25.875,9.495),(25.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.815),(25.725,9.965),(25.875,9.965),(25.875,9.815),(25.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.135),(25.725,10.285),(25.875,10.285),(25.875,10.135),(25.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.455),(25.725,10.605),(25.875,10.605),(25.875,10.455),(25.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.775),(25.725,10.925),(25.875,10.925),(25.875,10.775),(25.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.095),(25.725,11.245),(25.875,11.245),(25.875,11.095),(25.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.415),(25.725,11.565),(25.875,11.565),(25.875,11.415),(25.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.735),(25.725,11.885),(25.875,11.885),(25.875,11.735),(25.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.055),(25.725,12.205),(25.875,12.205),(25.875,12.055),(25.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.375),(25.725,12.525),(25.875,12.525),(25.875,12.375),(25.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.695),(25.725,12.845),(25.875,12.845),(25.875,12.695),(25.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.015),(25.725,13.165),(25.875,13.165),(25.875,13.015),(25.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.335),(25.725,13.485),(25.875,13.485),(25.875,13.335),(25.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.655),(25.725,13.805),(25.875,13.805),(25.875,13.655),(25.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.975),(25.725,14.125),(25.875,14.125),(25.875,13.975),(25.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.295),(25.725,14.445),(25.875,14.445),(25.875,14.295),(25.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.615),(25.725,14.765),(25.875,14.765),(25.875,14.615),(25.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.935),(25.725,15.085),(25.875,15.085),(25.875,14.935),(25.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.255),(25.725,15.405),(25.875,15.405),(25.875,15.255),(25.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.575),(25.725,15.725),(25.875,15.725),(25.875,15.575),(25.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.895),(25.725,16.045),(25.875,16.045),(25.875,15.895),(25.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.215),(25.725,16.365),(25.875,16.365),(25.875,16.215),(25.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.535),(25.725,16.685),(25.875,16.685),(25.875,16.535),(25.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.855),(25.725,17.005),(25.875,17.005),(25.875,16.855),(25.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.175),(25.725,17.325),(25.875,17.325),(25.875,17.175),(25.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.495),(25.725,17.645),(25.875,17.645),(25.875,17.495),(25.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.815),(25.725,17.965),(25.875,17.965),(25.875,17.815),(25.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.135),(25.725,18.285),(25.875,18.285),(25.875,18.135),(25.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.455),(25.725,18.605),(25.875,18.605),(25.875,18.455),(25.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.775),(25.725,18.925),(25.875,18.925),(25.875,18.775),(25.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.095),(25.725,19.245),(25.875,19.245),(25.875,19.095),(25.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.415),(25.725,19.565),(25.875,19.565),(25.875,19.415),(25.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.735),(25.725,19.885),(25.875,19.885),(25.875,19.735),(25.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.055),(25.725,20.205),(25.875,20.205),(25.875,20.055),(25.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.375),(25.725,20.525),(25.875,20.525),(25.875,20.375),(25.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.695),(25.725,20.845),(25.875,20.845),(25.875,20.695),(25.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.015),(25.725,21.165),(25.875,21.165),(25.875,21.015),(25.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.335),(25.725,21.485),(25.875,21.485),(25.875,21.335),(25.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.655),(25.725,21.805),(25.875,21.805),(25.875,21.655),(25.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.975),(25.725,22.125),(25.875,22.125),(25.875,21.975),(25.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.215),(78.525,0.365),(78.675,0.365),(78.675,0.215),(78.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.535),(78.525,0.685),(78.675,0.685),(78.675,0.535),(78.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.855),(78.525,1.005),(78.675,1.005),(78.675,0.855),(78.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.175),(78.525,1.325),(78.675,1.325),(78.675,1.175),(78.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.495),(78.525,1.645),(78.675,1.645),(78.675,1.495),(78.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.815),(78.525,1.965),(78.675,1.965),(78.675,1.815),(78.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.135),(78.525,2.285),(78.675,2.285),(78.675,2.135),(78.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.455),(78.525,2.605),(78.675,2.605),(78.675,2.455),(78.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.775),(78.525,2.925),(78.675,2.925),(78.675,2.775),(78.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.095),(78.525,3.245),(78.675,3.245),(78.675,3.095),(78.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.415),(78.525,3.565),(78.675,3.565),(78.675,3.415),(78.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.735),(78.525,3.885),(78.675,3.885),(78.675,3.735),(78.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.055),(78.525,4.205),(78.675,4.205),(78.675,4.055),(78.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.375),(78.525,4.525),(78.675,4.525),(78.675,4.375),(78.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.695),(78.525,4.845),(78.675,4.845),(78.675,4.695),(78.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.015),(78.525,5.165),(78.675,5.165),(78.675,5.015),(78.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.335),(78.525,5.485),(78.675,5.485),(78.675,5.335),(78.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.655),(78.525,5.805),(78.675,5.805),(78.675,5.655),(78.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.975),(78.525,6.125),(78.675,6.125),(78.675,5.975),(78.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.295),(78.525,6.445),(78.675,6.445),(78.675,6.295),(78.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.615),(78.525,6.765),(78.675,6.765),(78.675,6.615),(78.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.935),(78.525,7.085),(78.675,7.085),(78.675,6.935),(78.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.255),(78.525,7.405),(78.675,7.405),(78.675,7.255),(78.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.575),(78.525,7.725),(78.675,7.725),(78.675,7.575),(78.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.895),(78.525,8.045),(78.675,8.045),(78.675,7.895),(78.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.215),(78.525,8.365),(78.675,8.365),(78.675,8.215),(78.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.535),(78.525,8.685),(78.675,8.685),(78.675,8.535),(78.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.855),(78.525,9.005),(78.675,9.005),(78.675,8.855),(78.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.175),(78.525,9.325),(78.675,9.325),(78.675,9.175),(78.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.495),(78.525,9.645),(78.675,9.645),(78.675,9.495),(78.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.815),(78.525,9.965),(78.675,9.965),(78.675,9.815),(78.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.135),(78.525,10.285),(78.675,10.285),(78.675,10.135),(78.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.455),(78.525,10.605),(78.675,10.605),(78.675,10.455),(78.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.775),(78.525,10.925),(78.675,10.925),(78.675,10.775),(78.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.095),(78.525,11.245),(78.675,11.245),(78.675,11.095),(78.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.415),(78.525,11.565),(78.675,11.565),(78.675,11.415),(78.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.735),(78.525,11.885),(78.675,11.885),(78.675,11.735),(78.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.055),(78.525,12.205),(78.675,12.205),(78.675,12.055),(78.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.375),(78.525,12.525),(78.675,12.525),(78.675,12.375),(78.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.695),(78.525,12.845),(78.675,12.845),(78.675,12.695),(78.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.015),(78.525,13.165),(78.675,13.165),(78.675,13.015),(78.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.335),(78.525,13.485),(78.675,13.485),(78.675,13.335),(78.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.655),(78.525,13.805),(78.675,13.805),(78.675,13.655),(78.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.975),(78.525,14.125),(78.675,14.125),(78.675,13.975),(78.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.295),(78.525,14.445),(78.675,14.445),(78.675,14.295),(78.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.615),(78.525,14.765),(78.675,14.765),(78.675,14.615),(78.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.935),(78.525,15.085),(78.675,15.085),(78.675,14.935),(78.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.255),(78.525,15.405),(78.675,15.405),(78.675,15.255),(78.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.575),(78.525,15.725),(78.675,15.725),(78.675,15.575),(78.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.895),(78.525,16.045),(78.675,16.045),(78.675,15.895),(78.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.215),(78.525,16.365),(78.675,16.365),(78.675,16.215),(78.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.535),(78.525,16.685),(78.675,16.685),(78.675,16.535),(78.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.855),(78.525,17.005),(78.675,17.005),(78.675,16.855),(78.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.175),(78.525,17.325),(78.675,17.325),(78.675,17.175),(78.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.495),(78.525,17.645),(78.675,17.645),(78.675,17.495),(78.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.815),(78.525,17.965),(78.675,17.965),(78.675,17.815),(78.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.135),(78.525,18.285),(78.675,18.285),(78.675,18.135),(78.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.455),(78.525,18.605),(78.675,18.605),(78.675,18.455),(78.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.775),(78.525,18.925),(78.675,18.925),(78.675,18.775),(78.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.095),(78.525,19.245),(78.675,19.245),(78.675,19.095),(78.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.415),(78.525,19.565),(78.675,19.565),(78.675,19.415),(78.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.735),(78.525,19.885),(78.675,19.885),(78.675,19.735),(78.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.055),(78.525,20.205),(78.675,20.205),(78.675,20.055),(78.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.375),(78.525,20.525),(78.675,20.525),(78.675,20.375),(78.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.695),(78.525,20.845),(78.675,20.845),(78.675,20.695),(78.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.015),(78.525,21.165),(78.675,21.165),(78.675,21.015),(78.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.335),(78.525,21.485),(78.675,21.485),(78.675,21.335),(78.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.655),(78.525,21.805),(78.675,21.805),(78.675,21.655),(78.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.975),(78.525,22.125),(78.675,22.125),(78.675,21.975),(78.525,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.215),(64.125,0.365),(64.275,0.365),(64.275,0.215),(64.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.535),(64.125,0.685),(64.275,0.685),(64.275,0.535),(64.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.855),(64.125,1.005),(64.275,1.005),(64.275,0.855),(64.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.175),(64.125,1.325),(64.275,1.325),(64.275,1.175),(64.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.495),(64.125,1.645),(64.275,1.645),(64.275,1.495),(64.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.815),(64.125,1.965),(64.275,1.965),(64.275,1.815),(64.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.135),(64.125,2.285),(64.275,2.285),(64.275,2.135),(64.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.455),(64.125,2.605),(64.275,2.605),(64.275,2.455),(64.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.775),(64.125,2.925),(64.275,2.925),(64.275,2.775),(64.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.095),(64.125,3.245),(64.275,3.245),(64.275,3.095),(64.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.415),(64.125,3.565),(64.275,3.565),(64.275,3.415),(64.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.735),(64.125,3.885),(64.275,3.885),(64.275,3.735),(64.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.055),(64.125,4.205),(64.275,4.205),(64.275,4.055),(64.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.375),(64.125,4.525),(64.275,4.525),(64.275,4.375),(64.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.695),(64.125,4.845),(64.275,4.845),(64.275,4.695),(64.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.015),(64.125,5.165),(64.275,5.165),(64.275,5.015),(64.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.335),(64.125,5.485),(64.275,5.485),(64.275,5.335),(64.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.655),(64.125,5.805),(64.275,5.805),(64.275,5.655),(64.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.975),(64.125,6.125),(64.275,6.125),(64.275,5.975),(64.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.295),(64.125,6.445),(64.275,6.445),(64.275,6.295),(64.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.615),(64.125,6.765),(64.275,6.765),(64.275,6.615),(64.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.935),(64.125,7.085),(64.275,7.085),(64.275,6.935),(64.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.255),(64.125,7.405),(64.275,7.405),(64.275,7.255),(64.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.575),(64.125,7.725),(64.275,7.725),(64.275,7.575),(64.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.895),(64.125,8.045),(64.275,8.045),(64.275,7.895),(64.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.215),(64.125,8.365),(64.275,8.365),(64.275,8.215),(64.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.535),(64.125,8.685),(64.275,8.685),(64.275,8.535),(64.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.855),(64.125,9.005),(64.275,9.005),(64.275,8.855),(64.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.175),(64.125,9.325),(64.275,9.325),(64.275,9.175),(64.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.495),(64.125,9.645),(64.275,9.645),(64.275,9.495),(64.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.815),(64.125,9.965),(64.275,9.965),(64.275,9.815),(64.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.135),(64.125,10.285),(64.275,10.285),(64.275,10.135),(64.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.455),(64.125,10.605),(64.275,10.605),(64.275,10.455),(64.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.775),(64.125,10.925),(64.275,10.925),(64.275,10.775),(64.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.095),(64.125,11.245),(64.275,11.245),(64.275,11.095),(64.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.415),(64.125,11.565),(64.275,11.565),(64.275,11.415),(64.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.735),(64.125,11.885),(64.275,11.885),(64.275,11.735),(64.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.055),(64.125,12.205),(64.275,12.205),(64.275,12.055),(64.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.375),(64.125,12.525),(64.275,12.525),(64.275,12.375),(64.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.695),(64.125,12.845),(64.275,12.845),(64.275,12.695),(64.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.015),(64.125,13.165),(64.275,13.165),(64.275,13.015),(64.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.335),(64.125,13.485),(64.275,13.485),(64.275,13.335),(64.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.655),(64.125,13.805),(64.275,13.805),(64.275,13.655),(64.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.975),(64.125,14.125),(64.275,14.125),(64.275,13.975),(64.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.295),(64.125,14.445),(64.275,14.445),(64.275,14.295),(64.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.615),(64.125,14.765),(64.275,14.765),(64.275,14.615),(64.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.935),(64.125,15.085),(64.275,15.085),(64.275,14.935),(64.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.255),(64.125,15.405),(64.275,15.405),(64.275,15.255),(64.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.575),(64.125,15.725),(64.275,15.725),(64.275,15.575),(64.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.895),(64.125,16.045),(64.275,16.045),(64.275,15.895),(64.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.215),(64.125,16.365),(64.275,16.365),(64.275,16.215),(64.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.535),(64.125,16.685),(64.275,16.685),(64.275,16.535),(64.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.855),(64.125,17.005),(64.275,17.005),(64.275,16.855),(64.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.175),(64.125,17.325),(64.275,17.325),(64.275,17.175),(64.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.495),(64.125,17.645),(64.275,17.645),(64.275,17.495),(64.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.815),(64.125,17.965),(64.275,17.965),(64.275,17.815),(64.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.135),(64.125,18.285),(64.275,18.285),(64.275,18.135),(64.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.455),(64.125,18.605),(64.275,18.605),(64.275,18.455),(64.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.775),(64.125,18.925),(64.275,18.925),(64.275,18.775),(64.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.095),(64.125,19.245),(64.275,19.245),(64.275,19.095),(64.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.415),(64.125,19.565),(64.275,19.565),(64.275,19.415),(64.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.735),(64.125,19.885),(64.275,19.885),(64.275,19.735),(64.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.055),(64.125,20.205),(64.275,20.205),(64.275,20.055),(64.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.375),(64.125,20.525),(64.275,20.525),(64.275,20.375),(64.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.695),(64.125,20.845),(64.275,20.845),(64.275,20.695),(64.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.015),(64.125,21.165),(64.275,21.165),(64.275,21.015),(64.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.335),(64.125,21.485),(64.275,21.485),(64.275,21.335),(64.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.655),(64.125,21.805),(64.275,21.805),(64.275,21.655),(64.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.975),(64.125,22.125),(64.275,22.125),(64.275,21.975),(64.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.215),(54.525,0.365),(54.675,0.365),(54.675,0.215),(54.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.535),(54.525,0.685),(54.675,0.685),(54.675,0.535),(54.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.855),(54.525,1.005),(54.675,1.005),(54.675,0.855),(54.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.175),(54.525,1.325),(54.675,1.325),(54.675,1.175),(54.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.495),(54.525,1.645),(54.675,1.645),(54.675,1.495),(54.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.815),(54.525,1.965),(54.675,1.965),(54.675,1.815),(54.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.135),(54.525,2.285),(54.675,2.285),(54.675,2.135),(54.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.455),(54.525,2.605),(54.675,2.605),(54.675,2.455),(54.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.775),(54.525,2.925),(54.675,2.925),(54.675,2.775),(54.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.095),(54.525,3.245),(54.675,3.245),(54.675,3.095),(54.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.415),(54.525,3.565),(54.675,3.565),(54.675,3.415),(54.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.735),(54.525,3.885),(54.675,3.885),(54.675,3.735),(54.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.055),(54.525,4.205),(54.675,4.205),(54.675,4.055),(54.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.375),(54.525,4.525),(54.675,4.525),(54.675,4.375),(54.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.695),(54.525,4.845),(54.675,4.845),(54.675,4.695),(54.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.015),(54.525,5.165),(54.675,5.165),(54.675,5.015),(54.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.335),(54.525,5.485),(54.675,5.485),(54.675,5.335),(54.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.655),(54.525,5.805),(54.675,5.805),(54.675,5.655),(54.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.975),(54.525,6.125),(54.675,6.125),(54.675,5.975),(54.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.295),(54.525,6.445),(54.675,6.445),(54.675,6.295),(54.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.615),(54.525,6.765),(54.675,6.765),(54.675,6.615),(54.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.935),(54.525,7.085),(54.675,7.085),(54.675,6.935),(54.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.255),(54.525,7.405),(54.675,7.405),(54.675,7.255),(54.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.575),(54.525,7.725),(54.675,7.725),(54.675,7.575),(54.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.895),(54.525,8.045),(54.675,8.045),(54.675,7.895),(54.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.215),(54.525,8.365),(54.675,8.365),(54.675,8.215),(54.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.535),(54.525,8.685),(54.675,8.685),(54.675,8.535),(54.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.855),(54.525,9.005),(54.675,9.005),(54.675,8.855),(54.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.175),(54.525,9.325),(54.675,9.325),(54.675,9.175),(54.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.495),(54.525,9.645),(54.675,9.645),(54.675,9.495),(54.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.815),(54.525,9.965),(54.675,9.965),(54.675,9.815),(54.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.135),(54.525,10.285),(54.675,10.285),(54.675,10.135),(54.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.455),(54.525,10.605),(54.675,10.605),(54.675,10.455),(54.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.775),(54.525,10.925),(54.675,10.925),(54.675,10.775),(54.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.095),(54.525,11.245),(54.675,11.245),(54.675,11.095),(54.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.415),(54.525,11.565),(54.675,11.565),(54.675,11.415),(54.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.735),(54.525,11.885),(54.675,11.885),(54.675,11.735),(54.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.055),(54.525,12.205),(54.675,12.205),(54.675,12.055),(54.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.375),(54.525,12.525),(54.675,12.525),(54.675,12.375),(54.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.695),(54.525,12.845),(54.675,12.845),(54.675,12.695),(54.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.015),(54.525,13.165),(54.675,13.165),(54.675,13.015),(54.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.335),(54.525,13.485),(54.675,13.485),(54.675,13.335),(54.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.655),(54.525,13.805),(54.675,13.805),(54.675,13.655),(54.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.975),(54.525,14.125),(54.675,14.125),(54.675,13.975),(54.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.295),(54.525,14.445),(54.675,14.445),(54.675,14.295),(54.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.615),(54.525,14.765),(54.675,14.765),(54.675,14.615),(54.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.935),(54.525,15.085),(54.675,15.085),(54.675,14.935),(54.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.255),(54.525,15.405),(54.675,15.405),(54.675,15.255),(54.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.575),(54.525,15.725),(54.675,15.725),(54.675,15.575),(54.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.895),(54.525,16.045),(54.675,16.045),(54.675,15.895),(54.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.215),(54.525,16.365),(54.675,16.365),(54.675,16.215),(54.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.535),(54.525,16.685),(54.675,16.685),(54.675,16.535),(54.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.855),(54.525,17.005),(54.675,17.005),(54.675,16.855),(54.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.175),(54.525,17.325),(54.675,17.325),(54.675,17.175),(54.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.495),(54.525,17.645),(54.675,17.645),(54.675,17.495),(54.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.815),(54.525,17.965),(54.675,17.965),(54.675,17.815),(54.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.135),(54.525,18.285),(54.675,18.285),(54.675,18.135),(54.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.455),(54.525,18.605),(54.675,18.605),(54.675,18.455),(54.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.775),(54.525,18.925),(54.675,18.925),(54.675,18.775),(54.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.095),(54.525,19.245),(54.675,19.245),(54.675,19.095),(54.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.415),(54.525,19.565),(54.675,19.565),(54.675,19.415),(54.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.735),(54.525,19.885),(54.675,19.885),(54.675,19.735),(54.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.055),(54.525,20.205),(54.675,20.205),(54.675,20.055),(54.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.375),(54.525,20.525),(54.675,20.525),(54.675,20.375),(54.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.695),(54.525,20.845),(54.675,20.845),(54.675,20.695),(54.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.015),(54.525,21.165),(54.675,21.165),(54.675,21.015),(54.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.335),(54.525,21.485),(54.675,21.485),(54.675,21.335),(54.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.655),(54.525,21.805),(54.675,21.805),(54.675,21.655),(54.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.975),(54.525,22.125),(54.675,22.125),(54.675,21.975),(54.525,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.215),(16.125,0.365),(16.275,0.365),(16.275,0.215),(16.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.535),(16.125,0.685),(16.275,0.685),(16.275,0.535),(16.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.855),(16.125,1.005),(16.275,1.005),(16.275,0.855),(16.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.175),(16.125,1.325),(16.275,1.325),(16.275,1.175),(16.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.495),(16.125,1.645),(16.275,1.645),(16.275,1.495),(16.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.815),(16.125,1.965),(16.275,1.965),(16.275,1.815),(16.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.135),(16.125,2.285),(16.275,2.285),(16.275,2.135),(16.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.455),(16.125,2.605),(16.275,2.605),(16.275,2.455),(16.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.775),(16.125,2.925),(16.275,2.925),(16.275,2.775),(16.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.095),(16.125,3.245),(16.275,3.245),(16.275,3.095),(16.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.415),(16.125,3.565),(16.275,3.565),(16.275,3.415),(16.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.735),(16.125,3.885),(16.275,3.885),(16.275,3.735),(16.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.055),(16.125,4.205),(16.275,4.205),(16.275,4.055),(16.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.375),(16.125,4.525),(16.275,4.525),(16.275,4.375),(16.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.695),(16.125,4.845),(16.275,4.845),(16.275,4.695),(16.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.015),(16.125,5.165),(16.275,5.165),(16.275,5.015),(16.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.335),(16.125,5.485),(16.275,5.485),(16.275,5.335),(16.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.655),(16.125,5.805),(16.275,5.805),(16.275,5.655),(16.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.975),(16.125,6.125),(16.275,6.125),(16.275,5.975),(16.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.295),(16.125,6.445),(16.275,6.445),(16.275,6.295),(16.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.615),(16.125,6.765),(16.275,6.765),(16.275,6.615),(16.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.935),(16.125,7.085),(16.275,7.085),(16.275,6.935),(16.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.255),(16.125,7.405),(16.275,7.405),(16.275,7.255),(16.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.575),(16.125,7.725),(16.275,7.725),(16.275,7.575),(16.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.895),(16.125,8.045),(16.275,8.045),(16.275,7.895),(16.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.215),(16.125,8.365),(16.275,8.365),(16.275,8.215),(16.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.535),(16.125,8.685),(16.275,8.685),(16.275,8.535),(16.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.855),(16.125,9.005),(16.275,9.005),(16.275,8.855),(16.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.175),(16.125,9.325),(16.275,9.325),(16.275,9.175),(16.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.495),(16.125,9.645),(16.275,9.645),(16.275,9.495),(16.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.815),(16.125,9.965),(16.275,9.965),(16.275,9.815),(16.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.135),(16.125,10.285),(16.275,10.285),(16.275,10.135),(16.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.455),(16.125,10.605),(16.275,10.605),(16.275,10.455),(16.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.775),(16.125,10.925),(16.275,10.925),(16.275,10.775),(16.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.095),(16.125,11.245),(16.275,11.245),(16.275,11.095),(16.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.415),(16.125,11.565),(16.275,11.565),(16.275,11.415),(16.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.735),(16.125,11.885),(16.275,11.885),(16.275,11.735),(16.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.055),(16.125,12.205),(16.275,12.205),(16.275,12.055),(16.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.375),(16.125,12.525),(16.275,12.525),(16.275,12.375),(16.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.695),(16.125,12.845),(16.275,12.845),(16.275,12.695),(16.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.015),(16.125,13.165),(16.275,13.165),(16.275,13.015),(16.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.335),(16.125,13.485),(16.275,13.485),(16.275,13.335),(16.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.655),(16.125,13.805),(16.275,13.805),(16.275,13.655),(16.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.975),(16.125,14.125),(16.275,14.125),(16.275,13.975),(16.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.295),(16.125,14.445),(16.275,14.445),(16.275,14.295),(16.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.615),(16.125,14.765),(16.275,14.765),(16.275,14.615),(16.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.935),(16.125,15.085),(16.275,15.085),(16.275,14.935),(16.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.255),(16.125,15.405),(16.275,15.405),(16.275,15.255),(16.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.575),(16.125,15.725),(16.275,15.725),(16.275,15.575),(16.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.895),(16.125,16.045),(16.275,16.045),(16.275,15.895),(16.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.215),(16.125,16.365),(16.275,16.365),(16.275,16.215),(16.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.535),(16.125,16.685),(16.275,16.685),(16.275,16.535),(16.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.855),(16.125,17.005),(16.275,17.005),(16.275,16.855),(16.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.175),(16.125,17.325),(16.275,17.325),(16.275,17.175),(16.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.495),(16.125,17.645),(16.275,17.645),(16.275,17.495),(16.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.815),(16.125,17.965),(16.275,17.965),(16.275,17.815),(16.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.135),(16.125,18.285),(16.275,18.285),(16.275,18.135),(16.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.455),(16.125,18.605),(16.275,18.605),(16.275,18.455),(16.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.775),(16.125,18.925),(16.275,18.925),(16.275,18.775),(16.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.095),(16.125,19.245),(16.275,19.245),(16.275,19.095),(16.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.415),(16.125,19.565),(16.275,19.565),(16.275,19.415),(16.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.735),(16.125,19.885),(16.275,19.885),(16.275,19.735),(16.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.055),(16.125,20.205),(16.275,20.205),(16.275,20.055),(16.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.375),(16.125,20.525),(16.275,20.525),(16.275,20.375),(16.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.695),(16.125,20.845),(16.275,20.845),(16.275,20.695),(16.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.015),(16.125,21.165),(16.275,21.165),(16.275,21.015),(16.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.335),(16.125,21.485),(16.275,21.485),(16.275,21.335),(16.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.655),(16.125,21.805),(16.275,21.805),(16.275,21.655),(16.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.975),(16.125,22.125),(16.275,22.125),(16.275,21.975),(16.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.215),(20.925,0.365),(21.075,0.365),(21.075,0.215),(20.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.535),(20.925,0.685),(21.075,0.685),(21.075,0.535),(20.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.855),(20.925,1.005),(21.075,1.005),(21.075,0.855),(20.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.175),(20.925,1.325),(21.075,1.325),(21.075,1.175),(20.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.495),(20.925,1.645),(21.075,1.645),(21.075,1.495),(20.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.815),(20.925,1.965),(21.075,1.965),(21.075,1.815),(20.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.135),(20.925,2.285),(21.075,2.285),(21.075,2.135),(20.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.455),(20.925,2.605),(21.075,2.605),(21.075,2.455),(20.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.775),(20.925,2.925),(21.075,2.925),(21.075,2.775),(20.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.095),(20.925,3.245),(21.075,3.245),(21.075,3.095),(20.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.415),(20.925,3.565),(21.075,3.565),(21.075,3.415),(20.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.735),(20.925,3.885),(21.075,3.885),(21.075,3.735),(20.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.055),(20.925,4.205),(21.075,4.205),(21.075,4.055),(20.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.375),(20.925,4.525),(21.075,4.525),(21.075,4.375),(20.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.695),(20.925,4.845),(21.075,4.845),(21.075,4.695),(20.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.015),(20.925,5.165),(21.075,5.165),(21.075,5.015),(20.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.335),(20.925,5.485),(21.075,5.485),(21.075,5.335),(20.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.655),(20.925,5.805),(21.075,5.805),(21.075,5.655),(20.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.975),(20.925,6.125),(21.075,6.125),(21.075,5.975),(20.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.295),(20.925,6.445),(21.075,6.445),(21.075,6.295),(20.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.615),(20.925,6.765),(21.075,6.765),(21.075,6.615),(20.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.935),(20.925,7.085),(21.075,7.085),(21.075,6.935),(20.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.255),(20.925,7.405),(21.075,7.405),(21.075,7.255),(20.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.575),(20.925,7.725),(21.075,7.725),(21.075,7.575),(20.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.895),(20.925,8.045),(21.075,8.045),(21.075,7.895),(20.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.215),(20.925,8.365),(21.075,8.365),(21.075,8.215),(20.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.535),(20.925,8.685),(21.075,8.685),(21.075,8.535),(20.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.855),(20.925,9.005),(21.075,9.005),(21.075,8.855),(20.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.175),(20.925,9.325),(21.075,9.325),(21.075,9.175),(20.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.495),(20.925,9.645),(21.075,9.645),(21.075,9.495),(20.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.815),(20.925,9.965),(21.075,9.965),(21.075,9.815),(20.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.135),(20.925,10.285),(21.075,10.285),(21.075,10.135),(20.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.455),(20.925,10.605),(21.075,10.605),(21.075,10.455),(20.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.775),(20.925,10.925),(21.075,10.925),(21.075,10.775),(20.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.095),(20.925,11.245),(21.075,11.245),(21.075,11.095),(20.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.415),(20.925,11.565),(21.075,11.565),(21.075,11.415),(20.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.735),(20.925,11.885),(21.075,11.885),(21.075,11.735),(20.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.055),(20.925,12.205),(21.075,12.205),(21.075,12.055),(20.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.375),(20.925,12.525),(21.075,12.525),(21.075,12.375),(20.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.695),(20.925,12.845),(21.075,12.845),(21.075,12.695),(20.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.015),(20.925,13.165),(21.075,13.165),(21.075,13.015),(20.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.335),(20.925,13.485),(21.075,13.485),(21.075,13.335),(20.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.655),(20.925,13.805),(21.075,13.805),(21.075,13.655),(20.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.975),(20.925,14.125),(21.075,14.125),(21.075,13.975),(20.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.295),(20.925,14.445),(21.075,14.445),(21.075,14.295),(20.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.615),(20.925,14.765),(21.075,14.765),(21.075,14.615),(20.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.935),(20.925,15.085),(21.075,15.085),(21.075,14.935),(20.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.255),(20.925,15.405),(21.075,15.405),(21.075,15.255),(20.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.575),(20.925,15.725),(21.075,15.725),(21.075,15.575),(20.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.895),(20.925,16.045),(21.075,16.045),(21.075,15.895),(20.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.215),(20.925,16.365),(21.075,16.365),(21.075,16.215),(20.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.535),(20.925,16.685),(21.075,16.685),(21.075,16.535),(20.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.855),(20.925,17.005),(21.075,17.005),(21.075,16.855),(20.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.175),(20.925,17.325),(21.075,17.325),(21.075,17.175),(20.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.495),(20.925,17.645),(21.075,17.645),(21.075,17.495),(20.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.815),(20.925,17.965),(21.075,17.965),(21.075,17.815),(20.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.135),(20.925,18.285),(21.075,18.285),(21.075,18.135),(20.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.455),(20.925,18.605),(21.075,18.605),(21.075,18.455),(20.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.775),(20.925,18.925),(21.075,18.925),(21.075,18.775),(20.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.095),(20.925,19.245),(21.075,19.245),(21.075,19.095),(20.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.415),(20.925,19.565),(21.075,19.565),(21.075,19.415),(20.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.735),(20.925,19.885),(21.075,19.885),(21.075,19.735),(20.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.055),(20.925,20.205),(21.075,20.205),(21.075,20.055),(20.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.375),(20.925,20.525),(21.075,20.525),(21.075,20.375),(20.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.695),(20.925,20.845),(21.075,20.845),(21.075,20.695),(20.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.015),(20.925,21.165),(21.075,21.165),(21.075,21.015),(20.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.335),(20.925,21.485),(21.075,21.485),(21.075,21.335),(20.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.655),(20.925,21.805),(21.075,21.805),(21.075,21.655),(20.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.975),(20.925,22.125),(21.075,22.125),(21.075,21.975),(20.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.215),(73.725,0.365),(73.875,0.365),(73.875,0.215),(73.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.535),(73.725,0.685),(73.875,0.685),(73.875,0.535),(73.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.855),(73.725,1.005),(73.875,1.005),(73.875,0.855),(73.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.175),(73.725,1.325),(73.875,1.325),(73.875,1.175),(73.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.495),(73.725,1.645),(73.875,1.645),(73.875,1.495),(73.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.815),(73.725,1.965),(73.875,1.965),(73.875,1.815),(73.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.135),(73.725,2.285),(73.875,2.285),(73.875,2.135),(73.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.455),(73.725,2.605),(73.875,2.605),(73.875,2.455),(73.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.775),(73.725,2.925),(73.875,2.925),(73.875,2.775),(73.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.095),(73.725,3.245),(73.875,3.245),(73.875,3.095),(73.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.415),(73.725,3.565),(73.875,3.565),(73.875,3.415),(73.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.735),(73.725,3.885),(73.875,3.885),(73.875,3.735),(73.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.055),(73.725,4.205),(73.875,4.205),(73.875,4.055),(73.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.375),(73.725,4.525),(73.875,4.525),(73.875,4.375),(73.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.695),(73.725,4.845),(73.875,4.845),(73.875,4.695),(73.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.015),(73.725,5.165),(73.875,5.165),(73.875,5.015),(73.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.335),(73.725,5.485),(73.875,5.485),(73.875,5.335),(73.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.655),(73.725,5.805),(73.875,5.805),(73.875,5.655),(73.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.975),(73.725,6.125),(73.875,6.125),(73.875,5.975),(73.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.295),(73.725,6.445),(73.875,6.445),(73.875,6.295),(73.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.615),(73.725,6.765),(73.875,6.765),(73.875,6.615),(73.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.935),(73.725,7.085),(73.875,7.085),(73.875,6.935),(73.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.255),(73.725,7.405),(73.875,7.405),(73.875,7.255),(73.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.575),(73.725,7.725),(73.875,7.725),(73.875,7.575),(73.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.895),(73.725,8.045),(73.875,8.045),(73.875,7.895),(73.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.215),(73.725,8.365),(73.875,8.365),(73.875,8.215),(73.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.535),(73.725,8.685),(73.875,8.685),(73.875,8.535),(73.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.855),(73.725,9.005),(73.875,9.005),(73.875,8.855),(73.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.175),(73.725,9.325),(73.875,9.325),(73.875,9.175),(73.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.495),(73.725,9.645),(73.875,9.645),(73.875,9.495),(73.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.815),(73.725,9.965),(73.875,9.965),(73.875,9.815),(73.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.135),(73.725,10.285),(73.875,10.285),(73.875,10.135),(73.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.455),(73.725,10.605),(73.875,10.605),(73.875,10.455),(73.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.775),(73.725,10.925),(73.875,10.925),(73.875,10.775),(73.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.095),(73.725,11.245),(73.875,11.245),(73.875,11.095),(73.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.415),(73.725,11.565),(73.875,11.565),(73.875,11.415),(73.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.735),(73.725,11.885),(73.875,11.885),(73.875,11.735),(73.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.055),(73.725,12.205),(73.875,12.205),(73.875,12.055),(73.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.375),(73.725,12.525),(73.875,12.525),(73.875,12.375),(73.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.695),(73.725,12.845),(73.875,12.845),(73.875,12.695),(73.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.015),(73.725,13.165),(73.875,13.165),(73.875,13.015),(73.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.335),(73.725,13.485),(73.875,13.485),(73.875,13.335),(73.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.655),(73.725,13.805),(73.875,13.805),(73.875,13.655),(73.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.975),(73.725,14.125),(73.875,14.125),(73.875,13.975),(73.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.295),(73.725,14.445),(73.875,14.445),(73.875,14.295),(73.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.615),(73.725,14.765),(73.875,14.765),(73.875,14.615),(73.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.935),(73.725,15.085),(73.875,15.085),(73.875,14.935),(73.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.255),(73.725,15.405),(73.875,15.405),(73.875,15.255),(73.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.575),(73.725,15.725),(73.875,15.725),(73.875,15.575),(73.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.895),(73.725,16.045),(73.875,16.045),(73.875,15.895),(73.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.215),(73.725,16.365),(73.875,16.365),(73.875,16.215),(73.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.535),(73.725,16.685),(73.875,16.685),(73.875,16.535),(73.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.855),(73.725,17.005),(73.875,17.005),(73.875,16.855),(73.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.175),(73.725,17.325),(73.875,17.325),(73.875,17.175),(73.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.495),(73.725,17.645),(73.875,17.645),(73.875,17.495),(73.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.815),(73.725,17.965),(73.875,17.965),(73.875,17.815),(73.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.135),(73.725,18.285),(73.875,18.285),(73.875,18.135),(73.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.455),(73.725,18.605),(73.875,18.605),(73.875,18.455),(73.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.775),(73.725,18.925),(73.875,18.925),(73.875,18.775),(73.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.095),(73.725,19.245),(73.875,19.245),(73.875,19.095),(73.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.415),(73.725,19.565),(73.875,19.565),(73.875,19.415),(73.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.735),(73.725,19.885),(73.875,19.885),(73.875,19.735),(73.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.055),(73.725,20.205),(73.875,20.205),(73.875,20.055),(73.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.375),(73.725,20.525),(73.875,20.525),(73.875,20.375),(73.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.695),(73.725,20.845),(73.875,20.845),(73.875,20.695),(73.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.015),(73.725,21.165),(73.875,21.165),(73.875,21.015),(73.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.335),(73.725,21.485),(73.875,21.485),(73.875,21.335),(73.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.655),(73.725,21.805),(73.875,21.805),(73.875,21.655),(73.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.975),(73.725,22.125),(73.875,22.125),(73.875,21.975),(73.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.215),(11.325,0.365),(11.475,0.365),(11.475,0.215),(11.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.535),(11.325,0.685),(11.475,0.685),(11.475,0.535),(11.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.855),(11.325,1.005),(11.475,1.005),(11.475,0.855),(11.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.175),(11.325,1.325),(11.475,1.325),(11.475,1.175),(11.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.495),(11.325,1.645),(11.475,1.645),(11.475,1.495),(11.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.815),(11.325,1.965),(11.475,1.965),(11.475,1.815),(11.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.135),(11.325,2.285),(11.475,2.285),(11.475,2.135),(11.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.455),(11.325,2.605),(11.475,2.605),(11.475,2.455),(11.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.775),(11.325,2.925),(11.475,2.925),(11.475,2.775),(11.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.095),(11.325,3.245),(11.475,3.245),(11.475,3.095),(11.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.415),(11.325,3.565),(11.475,3.565),(11.475,3.415),(11.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.735),(11.325,3.885),(11.475,3.885),(11.475,3.735),(11.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.055),(11.325,4.205),(11.475,4.205),(11.475,4.055),(11.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.375),(11.325,4.525),(11.475,4.525),(11.475,4.375),(11.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.695),(11.325,4.845),(11.475,4.845),(11.475,4.695),(11.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.015),(11.325,5.165),(11.475,5.165),(11.475,5.015),(11.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.335),(11.325,5.485),(11.475,5.485),(11.475,5.335),(11.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.655),(11.325,5.805),(11.475,5.805),(11.475,5.655),(11.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.975),(11.325,6.125),(11.475,6.125),(11.475,5.975),(11.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.295),(11.325,6.445),(11.475,6.445),(11.475,6.295),(11.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.615),(11.325,6.765),(11.475,6.765),(11.475,6.615),(11.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.935),(11.325,7.085),(11.475,7.085),(11.475,6.935),(11.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.255),(11.325,7.405),(11.475,7.405),(11.475,7.255),(11.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.575),(11.325,7.725),(11.475,7.725),(11.475,7.575),(11.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.895),(11.325,8.045),(11.475,8.045),(11.475,7.895),(11.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.215),(11.325,8.365),(11.475,8.365),(11.475,8.215),(11.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.535),(11.325,8.685),(11.475,8.685),(11.475,8.535),(11.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.855),(11.325,9.005),(11.475,9.005),(11.475,8.855),(11.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.175),(11.325,9.325),(11.475,9.325),(11.475,9.175),(11.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.495),(11.325,9.645),(11.475,9.645),(11.475,9.495),(11.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.815),(11.325,9.965),(11.475,9.965),(11.475,9.815),(11.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.135),(11.325,10.285),(11.475,10.285),(11.475,10.135),(11.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.455),(11.325,10.605),(11.475,10.605),(11.475,10.455),(11.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.775),(11.325,10.925),(11.475,10.925),(11.475,10.775),(11.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.095),(11.325,11.245),(11.475,11.245),(11.475,11.095),(11.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.415),(11.325,11.565),(11.475,11.565),(11.475,11.415),(11.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.735),(11.325,11.885),(11.475,11.885),(11.475,11.735),(11.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.055),(11.325,12.205),(11.475,12.205),(11.475,12.055),(11.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.375),(11.325,12.525),(11.475,12.525),(11.475,12.375),(11.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.695),(11.325,12.845),(11.475,12.845),(11.475,12.695),(11.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.015),(11.325,13.165),(11.475,13.165),(11.475,13.015),(11.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.335),(11.325,13.485),(11.475,13.485),(11.475,13.335),(11.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.655),(11.325,13.805),(11.475,13.805),(11.475,13.655),(11.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.975),(11.325,14.125),(11.475,14.125),(11.475,13.975),(11.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.295),(11.325,14.445),(11.475,14.445),(11.475,14.295),(11.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.615),(11.325,14.765),(11.475,14.765),(11.475,14.615),(11.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.935),(11.325,15.085),(11.475,15.085),(11.475,14.935),(11.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.255),(11.325,15.405),(11.475,15.405),(11.475,15.255),(11.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.575),(11.325,15.725),(11.475,15.725),(11.475,15.575),(11.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.895),(11.325,16.045),(11.475,16.045),(11.475,15.895),(11.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.215),(11.325,16.365),(11.475,16.365),(11.475,16.215),(11.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.535),(11.325,16.685),(11.475,16.685),(11.475,16.535),(11.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.855),(11.325,17.005),(11.475,17.005),(11.475,16.855),(11.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.175),(11.325,17.325),(11.475,17.325),(11.475,17.175),(11.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.495),(11.325,17.645),(11.475,17.645),(11.475,17.495),(11.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.815),(11.325,17.965),(11.475,17.965),(11.475,17.815),(11.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.135),(11.325,18.285),(11.475,18.285),(11.475,18.135),(11.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.455),(11.325,18.605),(11.475,18.605),(11.475,18.455),(11.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.775),(11.325,18.925),(11.475,18.925),(11.475,18.775),(11.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.095),(11.325,19.245),(11.475,19.245),(11.475,19.095),(11.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.415),(11.325,19.565),(11.475,19.565),(11.475,19.415),(11.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.735),(11.325,19.885),(11.475,19.885),(11.475,19.735),(11.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.055),(11.325,20.205),(11.475,20.205),(11.475,20.055),(11.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.375),(11.325,20.525),(11.475,20.525),(11.475,20.375),(11.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.695),(11.325,20.845),(11.475,20.845),(11.475,20.695),(11.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.015),(11.325,21.165),(11.475,21.165),(11.475,21.015),(11.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.335),(11.325,21.485),(11.475,21.485),(11.475,21.335),(11.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.655),(11.325,21.805),(11.475,21.805),(11.475,21.655),(11.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.975),(11.325,22.125),(11.475,22.125),(11.475,21.975),(11.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.215),(30.525,0.365),(30.675,0.365),(30.675,0.215),(30.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.535),(30.525,0.685),(30.675,0.685),(30.675,0.535),(30.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.855),(30.525,1.005),(30.675,1.005),(30.675,0.855),(30.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.175),(30.525,1.325),(30.675,1.325),(30.675,1.175),(30.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.495),(30.525,1.645),(30.675,1.645),(30.675,1.495),(30.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.815),(30.525,1.965),(30.675,1.965),(30.675,1.815),(30.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.135),(30.525,2.285),(30.675,2.285),(30.675,2.135),(30.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.455),(30.525,2.605),(30.675,2.605),(30.675,2.455),(30.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.775),(30.525,2.925),(30.675,2.925),(30.675,2.775),(30.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.095),(30.525,3.245),(30.675,3.245),(30.675,3.095),(30.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.415),(30.525,3.565),(30.675,3.565),(30.675,3.415),(30.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.735),(30.525,3.885),(30.675,3.885),(30.675,3.735),(30.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.055),(30.525,4.205),(30.675,4.205),(30.675,4.055),(30.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.375),(30.525,4.525),(30.675,4.525),(30.675,4.375),(30.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.695),(30.525,4.845),(30.675,4.845),(30.675,4.695),(30.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.015),(30.525,5.165),(30.675,5.165),(30.675,5.015),(30.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.335),(30.525,5.485),(30.675,5.485),(30.675,5.335),(30.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.655),(30.525,5.805),(30.675,5.805),(30.675,5.655),(30.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.975),(30.525,6.125),(30.675,6.125),(30.675,5.975),(30.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.295),(30.525,6.445),(30.675,6.445),(30.675,6.295),(30.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.615),(30.525,6.765),(30.675,6.765),(30.675,6.615),(30.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.935),(30.525,7.085),(30.675,7.085),(30.675,6.935),(30.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.255),(30.525,7.405),(30.675,7.405),(30.675,7.255),(30.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.575),(30.525,7.725),(30.675,7.725),(30.675,7.575),(30.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.895),(30.525,8.045),(30.675,8.045),(30.675,7.895),(30.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.215),(30.525,8.365),(30.675,8.365),(30.675,8.215),(30.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.535),(30.525,8.685),(30.675,8.685),(30.675,8.535),(30.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.855),(30.525,9.005),(30.675,9.005),(30.675,8.855),(30.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.175),(30.525,9.325),(30.675,9.325),(30.675,9.175),(30.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.495),(30.525,9.645),(30.675,9.645),(30.675,9.495),(30.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.815),(30.525,9.965),(30.675,9.965),(30.675,9.815),(30.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.135),(30.525,10.285),(30.675,10.285),(30.675,10.135),(30.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.455),(30.525,10.605),(30.675,10.605),(30.675,10.455),(30.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.775),(30.525,10.925),(30.675,10.925),(30.675,10.775),(30.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.095),(30.525,11.245),(30.675,11.245),(30.675,11.095),(30.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.415),(30.525,11.565),(30.675,11.565),(30.675,11.415),(30.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.735),(30.525,11.885),(30.675,11.885),(30.675,11.735),(30.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.055),(30.525,12.205),(30.675,12.205),(30.675,12.055),(30.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.375),(30.525,12.525),(30.675,12.525),(30.675,12.375),(30.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.695),(30.525,12.845),(30.675,12.845),(30.675,12.695),(30.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.015),(30.525,13.165),(30.675,13.165),(30.675,13.015),(30.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.335),(30.525,13.485),(30.675,13.485),(30.675,13.335),(30.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.655),(30.525,13.805),(30.675,13.805),(30.675,13.655),(30.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.975),(30.525,14.125),(30.675,14.125),(30.675,13.975),(30.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.295),(30.525,14.445),(30.675,14.445),(30.675,14.295),(30.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.615),(30.525,14.765),(30.675,14.765),(30.675,14.615),(30.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.935),(30.525,15.085),(30.675,15.085),(30.675,14.935),(30.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.255),(30.525,15.405),(30.675,15.405),(30.675,15.255),(30.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.575),(30.525,15.725),(30.675,15.725),(30.675,15.575),(30.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.895),(30.525,16.045),(30.675,16.045),(30.675,15.895),(30.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.215),(30.525,16.365),(30.675,16.365),(30.675,16.215),(30.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.535),(30.525,16.685),(30.675,16.685),(30.675,16.535),(30.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.855),(30.525,17.005),(30.675,17.005),(30.675,16.855),(30.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.175),(30.525,17.325),(30.675,17.325),(30.675,17.175),(30.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.495),(30.525,17.645),(30.675,17.645),(30.675,17.495),(30.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.815),(30.525,17.965),(30.675,17.965),(30.675,17.815),(30.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.135),(30.525,18.285),(30.675,18.285),(30.675,18.135),(30.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.455),(30.525,18.605),(30.675,18.605),(30.675,18.455),(30.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.775),(30.525,18.925),(30.675,18.925),(30.675,18.775),(30.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.095),(30.525,19.245),(30.675,19.245),(30.675,19.095),(30.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.415),(30.525,19.565),(30.675,19.565),(30.675,19.415),(30.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.735),(30.525,19.885),(30.675,19.885),(30.675,19.735),(30.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.055),(30.525,20.205),(30.675,20.205),(30.675,20.055),(30.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.375),(30.525,20.525),(30.675,20.525),(30.675,20.375),(30.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.695),(30.525,20.845),(30.675,20.845),(30.675,20.695),(30.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.015),(30.525,21.165),(30.675,21.165),(30.675,21.015),(30.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.335),(30.525,21.485),(30.675,21.485),(30.675,21.335),(30.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.655),(30.525,21.805),(30.675,21.805),(30.675,21.655),(30.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.975),(30.525,22.125),(30.675,22.125),(30.675,21.975),(30.525,21.975)),
        )
        createRL(
            tech, net, 'm2',
            ((83.015,0.13),(83.015,22.21),(83.275,22.21),(83.275,0.13),(83.015,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((30.47,0.13),(30.47,22.21),(30.73,22.21),(30.73,0.13),(30.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((78.47,0.13),(78.47,22.21),(78.73,22.21),(78.73,0.13),(78.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((68.87,0.13),(68.87,22.21),(69.13,22.21),(69.13,0.13),(68.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((20.87,0.13),(20.87,22.21),(21.13,22.21),(21.13,0.13),(20.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((16.07,0.13),(16.07,22.21),(16.33,22.21),(16.33,0.13),(16.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((64.07,0.13),(64.07,22.21),(64.33,22.21),(64.33,0.13),(64.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((25.67,0.13),(25.67,22.21),(25.93,22.21),(25.93,0.13),(25.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((11.27,0.13),(11.27,22.21),(11.53,22.21),(11.53,0.13),(11.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((6.725,0.13),(6.725,22.21),(6.985,22.21),(6.985,0.13),(6.725,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((73.67,0.13),(73.67,22.21),(73.93,22.21),(73.93,0.13),(73.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((59.27,0.13),(59.27,22.21),(59.53,22.21),(59.53,0.13),(59.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,10.74),(85.68,11.005),(86.01,11.005),(86.01,10.74),(85.68,10.74)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,10.71),(85.68,11.0),(86.01,11.0),(86.01,10.71),(85.68,10.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((11.05,2.595),(11.05,19.745),(11.75,19.745),(11.75,2.595),(11.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.05,2.595),(35.05,19.745),(35.75,19.745),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.05,2.595),(59.05,19.745),(59.75,19.745),(59.75,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((83.05,2.595),(83.05,19.745),(83.875,19.745),(83.875,2.595),(83.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((73.45,2.595),(73.45,19.745),(74.15,19.745),(74.15,2.595),(73.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.65,2.595),(44.65,19.745),(45.35,19.745),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((68.65,2.595),(68.65,19.745),(69.35,19.745),(69.35,2.595),(68.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.25,2.595),(54.25,19.745),(54.95,19.745),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((20.65,2.595),(20.65,19.745),(21.35,19.745),(21.35,2.595),(20.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((78.25,2.595),(78.25,19.745),(78.95,19.745),(78.95,2.595),(78.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.45,2.595),(49.45,19.745),(50.15,19.745),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.25,2.595),(30.25,19.745),(30.95,19.745),(30.95,2.595),(30.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.85,2.595),(39.85,19.745),(40.55,19.745),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((15.85,2.595),(15.85,19.745),(16.55,19.745),(16.55,2.595),(15.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.85,2.595),(63.85,19.745),(64.55,19.745),(64.55,2.595),(63.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((6.125,2.595),(6.125,19.745),(6.95,19.745),(6.95,2.595),(6.125,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.45,2.595),(25.45,19.745),(26.15,19.745),(26.15,2.595),(25.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.55,2.595),(16.55,19.745),(16.995,19.745),(16.995,2.595),(16.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((12.365,2.65),(12.365,19.69),(13.105,19.69),(13.105,2.65),(12.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((12.06,2.595),(12.06,19.745),(13.41,19.745),(13.41,2.595),(12.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((22.98,2.595),(22.98,19.745),(23.82,19.745),(23.82,2.595),(22.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.765,2.65),(74.765,19.69),(75.505,19.69),(75.505,2.65),(74.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.46,2.595),(74.46,19.745),(75.81,19.745),(75.81,2.595),(74.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.18,2.595),(42.18,19.745),(43.02,19.745),(43.02,2.595),(42.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((53.805,2.595),(53.805,19.745),(54.25,19.745),(54.25,2.595),(53.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.46,2.595),(26.46,19.745),(27.81,19.745),(27.81,2.595),(26.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.765,2.65),(26.765,19.69),(27.505,19.69),(27.505,2.65),(26.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((72.095,2.65),(72.095,19.69),(72.835,19.69),(72.835,2.65),(72.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((75.78,2.595),(75.78,19.745),(76.62,19.745),(76.62,2.595),(75.78,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.205,2.595),(44.205,19.745),(44.65,19.745),(44.65,2.595),(44.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((56.58,2.595),(56.58,19.745),(57.42,19.745),(57.42,2.595),(56.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((9.695,2.65),(9.695,19.69),(10.435,19.69),(10.435,2.65),(9.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((9.39,2.595),(9.39,19.745),(10.74,19.745),(10.74,2.595),(9.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.79,2.595),(71.79,19.745),(73.14,19.745),(73.14,2.595),(71.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((81.695,2.65),(81.695,19.69),(82.435,19.69),(82.435,2.65),(81.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((81.39,2.595),(81.39,19.745),(82.74,19.745),(82.74,2.595),(81.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((27.78,2.595),(27.78,19.745),(28.62,19.745),(28.62,2.595),(27.78,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.99,2.595),(42.99,19.745),(44.34,19.745),(44.34,2.595),(42.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((62.19,2.595),(62.19,19.745),(63.54,19.745),(63.54,2.595),(62.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((62.495,2.65),(62.495,19.69),(63.235,19.69),(63.235,2.65),(62.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((78.95,2.595),(78.95,19.745),(79.395,19.745),(79.395,2.595),(78.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((8.58,2.595),(8.58,19.745),(9.42,19.745),(9.42,2.595),(8.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.66,2.595),(69.66,19.745),(71.01,19.745),(71.01,2.595),(69.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((29.805,2.595),(29.805,19.745),(30.25,19.745),(30.25,2.595),(29.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((65.165,2.65),(65.165,19.69),(65.905,19.69),(65.905,2.65),(65.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((63.405,2.595),(63.405,19.745),(63.85,19.745),(63.85,2.595),(63.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.95,2.595),(54.95,19.745),(55.395,19.745),(55.395,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.695,2.65),(33.695,19.69),(34.435,19.69),(34.435,2.65),(33.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.39,2.595),(33.39,19.745),(34.74,19.745),(34.74,2.595),(33.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.75,2.595),(35.75,19.745),(36.195,19.745),(36.195,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.66,2.595),(21.66,19.745),(23.01,19.745),(23.01,2.595),(21.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((34.605,2.595),(34.605,19.745),(35.05,19.745),(35.05,2.595),(34.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((18.18,2.595),(18.18,19.745),(19.02,19.745),(19.02,2.595),(18.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((28.895,2.65),(28.895,19.69),(29.635,19.69),(29.635,2.65),(28.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((28.59,2.595),(28.59,19.745),(29.94,19.745),(29.94,2.595),(28.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((18.99,2.595),(18.99,19.745),(20.34,19.745),(20.34,2.595),(18.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.495,2.65),(38.495,19.69),(39.235,19.69),(39.235,2.65),(38.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.19,2.595),(38.19,19.745),(39.54,19.745),(39.54,2.595),(38.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((19.295,2.65),(19.295,19.69),(20.035,19.69),(20.035,2.65),(19.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((20.205,2.595),(20.205,19.745),(20.65,19.745),(20.65,2.595),(20.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.79,2.595),(47.79,19.745),(49.14,19.745),(49.14,2.595),(47.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.965,2.65),(69.965,19.69),(70.705,19.69),(70.705,2.65),(69.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((15.405,2.595),(15.405,19.745),(15.85,19.745),(15.85,2.595),(15.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((37.38,2.595),(37.38,19.745),(38.22,19.745),(38.22,2.595),(37.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((59.75,2.595),(59.75,19.745),(60.195,19.745),(60.195,2.595),(59.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.66,2.595),(45.66,19.745),(47.01,19.745),(47.01,2.595),(45.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((77.805,2.595),(77.805,19.745),(78.25,19.745),(78.25,2.595),(77.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.965,2.65),(21.965,19.69),(22.705,19.69),(22.705,2.65),(21.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((43.295,2.65),(43.295,19.69),(44.035,19.69),(44.035,2.65),(43.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.35,2.595),(69.35,19.745),(69.795,19.745),(69.795,2.595),(69.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((61.38,2.595),(61.38,19.745),(62.22,19.745),(62.22,2.595),(61.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((76.895,2.65),(76.895,19.69),(77.635,19.69),(77.635,2.65),(76.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((76.59,2.595),(76.59,19.745),(77.94,19.745),(77.94,2.595),(76.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((67.295,2.65),(67.295,19.69),(68.035,19.69),(68.035,2.65),(67.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((25.005,2.595),(25.005,19.745),(25.45,19.745),(25.45,2.595),(25.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((39.405,2.595),(39.405,19.745),(39.85,19.745),(39.85,2.595),(39.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.205,2.595),(68.205,19.745),(68.65,19.745),(68.65,2.595),(68.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((30.95,2.595),(30.95,19.745),(31.395,19.745),(31.395,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((46.98,2.595),(46.98,19.745),(47.82,19.745),(47.82,2.595),(46.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.86,2.595),(40.86,19.745),(42.21,19.745),(42.21,2.595),(40.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.35,2.595),(21.35,19.745),(21.795,19.745),(21.795,2.595),(21.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.965,2.65),(45.965,19.69),(46.705,19.69),(46.705,2.65),(45.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((64.86,2.595),(64.86,19.745),(66.21,19.745),(66.21,2.595),(64.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.565,2.65),(31.565,19.69),(32.305,19.69),(32.305,2.65),(31.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.26,2.595),(31.26,19.745),(32.61,19.745),(32.61,2.595),(31.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((48.095,2.65),(48.095,19.69),(48.835,19.69),(48.835,2.65),(48.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((3.905,18.745),(3.905,19.745),(4.405,19.745),(4.405,18.745),(3.905,18.745)),
        )
        createRL(
            tech, net, 'nsdm',
            ((17.165,2.65),(17.165,19.69),(17.905,19.69),(17.905,2.65),(17.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.695,2.65),(57.695,19.69),(58.435,19.69),(58.435,2.65),(57.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.35,2.595),(45.35,19.745),(45.795,19.745),(45.795,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.39,2.595),(57.39,19.745),(58.74,19.745),(58.74,2.595),(57.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.86,2.595),(16.86,19.745),(18.21,19.745),(18.21,2.595),(16.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((6.95,2.595),(6.95,19.745),(7.395,19.745),(7.395,2.595),(6.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((58.605,2.595),(58.605,19.745),(59.05,19.745),(59.05,2.595),(58.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((32.58,2.595),(32.58,19.745),(33.42,19.745),(33.42,2.595),(32.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.26,2.595),(55.26,19.745),(56.61,19.745),(56.61,2.595),(55.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.565,2.65),(55.565,19.69),(56.305,19.69),(56.305,2.65),(55.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((73.005,2.595),(73.005,19.745),(73.45,19.745),(73.45,2.595),(73.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.895,2.65),(52.895,19.69),(53.635,19.69),(53.635,2.65),(52.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.59,2.595),(52.59,19.745),(53.94,19.745),(53.94,2.595),(52.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((10.605,2.595),(10.605,19.745),(11.05,19.745),(11.05,2.595),(10.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.15,2.595),(50.15,19.745),(50.595,19.745),(50.595,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((79.26,2.595),(79.26,19.745),(80.61,19.745),(80.61,2.595),(79.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((79.565,2.65),(79.565,19.69),(80.305,19.69),(80.305,2.65),(79.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((7.26,2.595),(7.26,19.745),(8.61,19.745),(8.61,2.595),(7.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((7.565,2.65),(7.565,19.69),(8.305,19.69),(8.305,2.65),(7.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((82.605,2.595),(82.605,19.745),(83.05,19.745),(83.05,2.595),(82.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.365,2.65),(36.365,19.69),(37.105,19.69),(37.105,2.65),(36.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.06,2.595),(36.06,19.745),(37.41,19.745),(37.41,2.595),(36.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.55,2.595),(40.55,19.745),(40.995,19.745),(40.995,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((11.75,2.595),(11.75,19.745),(12.195,19.745),(12.195,2.595),(11.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((41.165,2.65),(41.165,19.69),(41.905,19.69),(41.905,2.65),(41.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.15,2.595),(74.15,19.745),(74.595,19.745),(74.595,2.595),(74.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((64.55,2.595),(64.55,19.745),(64.995,19.745),(64.995,2.595),(64.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.005,2.595),(49.005,19.745),(49.45,19.745),(49.45,2.595),(49.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((24.095,2.65),(24.095,19.69),(24.835,19.69),(24.835,2.65),(24.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((66.18,2.595),(66.18,19.745),(67.02,19.745),(67.02,2.595),(66.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((14.495,2.65),(14.495,19.69),(15.235,19.69),(15.235,2.65),(14.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((14.19,2.595),(14.19,19.745),(15.54,19.745),(15.54,2.595),(14.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.15,2.595),(26.15,19.745),(26.595,19.745),(26.595,2.595),(26.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.765,2.65),(50.765,19.69),(51.505,19.69),(51.505,2.65),(50.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.46,2.595),(50.46,19.745),(51.81,19.745),(51.81,2.595),(50.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((23.79,2.595),(23.79,19.745),(25.14,19.745),(25.14,2.595),(23.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((60.365,2.65),(60.365,19.69),(61.105,19.69),(61.105,2.65),(60.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((66.99,2.595),(66.99,19.745),(68.34,19.745),(68.34,2.595),(66.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((60.06,2.595),(60.06,19.745),(61.41,19.745),(61.41,2.595),(60.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((13.38,2.595),(13.38,19.745),(14.22,19.745),(14.22,2.595),(13.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.98,2.595),(70.98,19.745),(71.82,19.745),(71.82,2.595),(70.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((80.58,2.595),(80.58,19.745),(81.42,19.745),(81.42,2.595),(80.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((51.78,2.595),(51.78,19.745),(52.62,19.745),(52.62,2.595),(51.78,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.535,2.54),(76.535,19.8),(77.995,19.8),(77.995,2.54),(76.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.765,2.52),(76.765,19.82),(77.765,19.82),(77.765,2.52),(76.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.535,2.54),(52.535,19.8),(53.995,19.8),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.765,2.52),(52.765,19.82),(53.765,19.82),(53.765,2.52),(52.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.635,2.52),(74.635,19.82),(75.635,19.82),(75.635,2.52),(74.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.405,2.54),(74.405,19.8),(75.865,19.8),(75.865,2.54),(74.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.005,2.54),(12.005,19.8),(13.465,19.8),(13.465,2.54),(12.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.235,2.52),(12.235,19.82),(13.235,19.82),(13.235,2.52),(12.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.565,2.52),(33.565,19.82),(34.565,19.82),(34.565,2.52),(33.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.335,2.54),(33.335,19.8),(34.795,19.8),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((65.035,2.52),(65.035,19.82),(66.035,19.82),(66.035,2.52),(65.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.765,2.52),(28.765,19.82),(29.765,19.82),(29.765,2.52),(28.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.965,2.52),(47.965,19.82),(48.965,19.82),(48.965,2.52),(47.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.965,2.52),(71.965,19.82),(72.965,19.82),(72.965,2.52),(71.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((67.165,2.52),(67.165,19.82),(68.165,19.82),(68.165,2.52),(67.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.435,2.52),(79.435,19.82),(80.435,19.82),(80.435,2.52),(79.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.205,2.54),(79.205,19.8),(80.665,19.8),(80.665,2.54),(79.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.805,2.54),(40.805,19.8),(42.265,19.8),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.435,2.52),(7.435,19.82),(8.435,19.82),(8.435,2.52),(7.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.605,2.54),(21.605,19.8),(23.065,19.8),(23.065,2.54),(21.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.205,2.54),(7.205,19.8),(8.665,19.8),(8.665,2.54),(7.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.235,2.52),(36.235,19.82),(37.235,19.82),(37.235,2.52),(36.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((18.935,2.54),(18.935,19.8),(20.395,19.8),(20.395,2.54),(18.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((64.805,2.54),(64.805,19.8),(66.265,19.8),(66.265,2.54),(64.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.005,2.54),(36.005,19.8),(37.465,19.8),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.635,2.52),(26.635,19.82),(27.635,19.82),(27.635,2.52),(26.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.405,2.54),(26.405,19.8),(27.865,19.8),(27.865,2.54),(26.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.365,2.52),(38.365,19.82),(39.365,19.82),(39.365,2.52),(38.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.135,2.54),(38.135,19.8),(39.595,19.8),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((6.05,2.52),(6.05,19.82),(83.95,19.82),(83.95,2.52),(6.05,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.535,2.54),(28.535,19.8),(29.995,19.8),(29.995,2.54),(28.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((19.165,2.52),(19.165,19.82),(20.165,19.82),(20.165,2.52),(19.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.965,2.52),(23.965,19.82),(24.965,19.82),(24.965,2.52),(23.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.435,2.52),(31.435,19.82),(32.435,19.82),(32.435,2.52),(31.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.205,2.54),(31.205,19.8),(32.665,19.8),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.565,2.52),(9.565,19.82),(10.565,19.82),(10.565,2.52),(9.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.335,2.54),(9.335,19.8),(10.795,19.8),(10.795,2.54),(9.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.735,2.54),(47.735,19.8),(49.195,19.8),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.735,2.54),(71.735,19.8),(73.195,19.8),(73.195,2.54),(71.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.835,2.52),(69.835,19.82),(70.835,19.82),(70.835,2.52),(69.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.335,2.54),(81.335,19.8),(82.795,19.8),(82.795,2.54),(81.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.565,2.52),(81.565,19.82),(82.565,19.82),(82.565,2.52),(81.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((17.035,2.52),(17.035,19.82),(18.035,19.82),(18.035,2.52),(17.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.935,2.54),(42.935,19.8),(44.395,19.8),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.605,2.54),(45.605,19.8),(47.065,19.8),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.135,2.54),(62.135,19.8),(63.595,19.8),(63.595,2.54),(62.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.365,2.52),(62.365,19.82),(63.365,19.82),(63.365,2.52),(62.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.135,2.54),(14.135,19.8),(15.595,19.8),(15.595,2.54),(14.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.365,2.52),(14.365,19.82),(15.365,19.82),(15.365,2.52),(14.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.405,2.54),(50.405,19.8),(51.865,19.8),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.635,2.52),(50.635,19.82),(51.635,19.82),(51.635,2.52),(50.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.335,2.54),(57.335,19.8),(58.795,19.8),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.565,2.52),(57.565,19.82),(58.565,19.82),(58.565,2.52),(57.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.735,2.54),(23.735,19.8),(25.195,19.8),(25.195,2.54),(23.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.005,2.54),(60.005,19.8),(61.465,19.8),(61.465,2.54),(60.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.235,2.52),(60.235,19.82),(61.235,19.82),(61.235,2.52),(60.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.835,2.52),(21.835,19.82),(22.835,19.82),(22.835,2.52),(21.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.805,2.54),(16.805,19.8),(18.265,19.8),(18.265,2.54),(16.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((66.935,2.54),(66.935,19.8),(68.395,19.8),(68.395,2.54),(66.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.435,2.52),(55.435,19.82),(56.435,19.82),(56.435,2.52),(55.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.205,2.54),(55.205,19.8),(56.665,19.8),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.165,2.52),(43.165,19.82),(44.165,19.82),(44.165,2.52),(43.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.605,2.54),(69.605,19.8),(71.065,19.8),(71.065,2.54),(69.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.835,2.52),(45.835,19.82),(46.835,19.82),(46.835,2.52),(45.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.035,2.52),(41.035,19.82),(42.035,19.82),(42.035,2.52),(41.035,2.52)),
        )
        createRL(
            tech, net, 'areaid_diode',
            ((4.025,18.865),(4.025,19.625),(4.285,19.625),(4.285,18.865),(4.025,18.865)),
        )
        createRL(
            tech, net, 'polyres',
            ((85.675,11.005),(85.675,11.335),(86.015,11.335),(86.015,11.005),(85.675,11.005)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,11.005),(85.68,11.335),(86.01,11.335),(86.01,11.005),(85.68,11.005)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,19.62),(32.485,19.62),(32.485,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.915,2.72),(23.915,19.62),(24.165,19.62),(24.165,2.72),(23.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,19.62),(62.095,19.62),(62.095,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.285,2.72),(61.285,19.62),(62.095,19.62),(62.095,2.72),(61.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,19.62),(62.315,19.62),(62.315,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.915,2.72),(47.915,19.62),(48.165,19.62),(48.165,2.72),(47.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(43.115,19.62),(43.115,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.885,2.72),(22.885,19.62),(23.695,19.62),(23.695,2.72),(22.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,19.62),(46.885,19.62),(46.885,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,19.62),(66.895,19.62),(66.895,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.085,2.72),(66.085,19.62),(66.895,19.62),(66.895,2.72),(66.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.315,2.72),(38.315,19.62),(38.565,19.62),(38.565,2.72),(38.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.435,2.72),(27.435,19.62),(27.685,19.62),(27.685,2.72),(27.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.435,2.72),(75.435,19.62),(75.685,19.62),(75.685,2.72),(75.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.295,19.62),(33.295,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,19.62),(71.695,19.62),(71.695,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,19.62),(71.915,19.62),(71.915,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.485,2.72),(32.485,19.62),(33.295,19.62),(33.295,2.72),(32.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,19.62),(19.115,19.62),(19.115,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.885,2.72),(46.885,19.62),(47.695,19.62),(47.695,2.72),(46.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.515,19.62),(33.515,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.515,2.72),(9.515,19.62),(9.765,19.62),(9.765,2.72),(9.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.235,2.72),(80.235,19.62),(80.485,19.62),(80.485,2.72),(80.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.115,2.72),(67.115,19.62),(67.365,19.62),(67.365,2.72),(67.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.035,2.72),(13.035,19.62),(13.285,19.62),(13.285,2.72),(13.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.915,2.72),(71.915,19.62),(72.165,19.62),(72.165,2.72),(71.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,19.62),(76.495,19.62),(76.495,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,19.62),(42.085,19.62),(42.085,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.685,2.72),(75.685,19.62),(76.495,19.62),(76.495,2.72),(75.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,19.62),(76.715,19.62),(76.715,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,19.62),(56.485,19.62),(56.485,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,19.62),(23.695,19.62),(23.695,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,19.62),(23.915,19.62),(23.915,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.235,2.72),(8.235,19.62),(8.485,19.62),(8.485,2.72),(8.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.635,2.72),(70.635,19.62),(70.885,19.62),(70.885,2.72),(70.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.515,2.72),(33.515,19.62),(33.765,19.62),(33.765,2.72),(33.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.485,2.72),(56.485,19.62),(57.295,19.62),(57.295,2.72),(56.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.085,2.72),(42.085,19.62),(42.895,19.62),(42.895,2.72),(42.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.515,2.72),(81.515,19.62),(81.765,19.62),(81.765,2.72),(81.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.295,19.62),(57.295,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(42.895,19.62),(42.895,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.515,19.62),(57.515,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.095,19.62),(38.095,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.695,19.62),(47.695,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.915,19.62),(47.915,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.285,2.72),(37.285,19.62),(38.095,19.62),(38.095,2.72),(37.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.315,19.62),(38.315,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.085,2.72),(18.085,19.62),(18.895,19.62),(18.895,2.72),(18.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,19.62),(18.895,19.62),(18.895,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,19.62),(28.495,19.62),(28.495,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.685,2.72),(27.685,19.62),(28.495,19.62),(28.495,2.72),(27.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,19.62),(28.715,19.62),(28.715,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.715,2.72),(52.715,19.62),(52.965,19.62),(52.965,2.72),(52.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.715,2.72),(76.715,19.62),(76.965,19.62),(76.965,2.72),(76.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.715,2.72),(28.715,19.62),(28.965,19.62),(28.965,2.72),(28.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,19.62),(67.115,19.62),(67.115,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.515,2.72),(57.515,19.62),(57.765,19.62),(57.765,2.72),(57.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,19.62),(9.515,19.62),(9.515,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.485,2.72),(8.485,19.62),(9.295,19.62),(9.295,2.72),(8.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,19.62),(9.295,19.62),(9.295,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,19.62),(51.685,19.62),(51.685,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,19.62),(14.095,19.62),(14.095,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.285,2.72),(13.285,19.62),(14.095,19.62),(14.095,2.72),(13.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,19.62),(14.315,19.62),(14.315,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.115,2.72),(19.115,19.62),(19.365,19.62),(19.365,2.72),(19.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.885,2.72),(70.885,19.62),(71.695,19.62),(71.695,2.72),(70.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.115,2.72),(43.115,19.62),(43.365,19.62),(43.365,2.72),(43.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.035,2.72),(61.035,19.62),(61.285,19.62),(61.285,2.72),(61.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,19.62),(81.295,19.62),(81.295,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.485,2.72),(80.485,19.62),(81.295,19.62),(81.295,2.72),(80.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,19.62),(81.515,19.62),(81.515,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,19.62),(37.285,19.62),(37.285,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.315,2.72),(62.315,19.62),(62.565,19.62),(62.565,2.72),(62.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.835,2.72),(65.835,19.62),(66.085,19.62),(66.085,2.72),(65.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.835,2.72),(17.835,19.62),(18.085,19.62),(18.085,2.72),(17.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.315,2.72),(14.315,19.62),(14.565,19.62),(14.565,2.72),(14.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.495,19.62),(52.495,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.685,2.72),(51.685,19.62),(52.495,19.62),(52.495,2.72),(51.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.715,19.62),(52.715,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.635,2.72),(22.635,19.62),(22.885,19.62),(22.885,2.72),(22.635,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.165),(18.345,15.335),(18.515,15.335),(18.515,15.165),(18.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.165),(18.685,15.335),(18.855,15.335),(18.855,15.165),(18.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.505),(18.345,15.675),(18.515,15.675),(18.515,15.505),(18.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.425),(75.945,11.595),(76.115,11.595),(76.115,11.425),(75.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.765),(75.945,11.935),(76.115,11.935),(76.115,11.765),(75.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.505),(18.685,15.675),(18.855,15.675),(18.855,15.505),(18.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.085),(75.945,11.255),(76.115,11.255),(76.115,11.085),(75.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.985),(23.145,6.155),(23.315,6.155),(23.315,5.985),(23.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.985),(23.485,6.155),(23.655,6.155),(23.655,5.985),(23.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.245),(32.745,19.415),(32.915,19.415),(32.915,19.245),(32.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.085),(27.945,11.255),(28.115,11.255),(28.115,11.085),(27.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.765),(27.945,11.935),(28.115,11.935),(28.115,11.765),(27.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.425),(27.945,11.595),(28.115,11.595),(28.115,11.425),(27.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.905),(76.285,19.075),(76.455,19.075),(76.455,18.905),(76.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.945),(61.545,4.115),(61.715,4.115),(61.715,3.945),(61.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.285),(56.745,4.455),(56.915,4.455),(56.915,4.285),(56.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.625),(56.745,4.795),(56.915,4.795),(56.915,4.625),(56.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.425),(81.085,11.595),(81.255,11.595),(81.255,11.425),(81.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.085),(81.085,11.255),(81.255,11.255),(81.255,11.085),(81.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.765),(81.085,11.935),(81.255,11.935),(81.255,11.765),(81.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.145),(80.745,14.315),(80.915,14.315),(80.915,14.145),(80.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.485),(80.745,14.655),(80.915,14.655),(80.915,14.485),(80.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.825),(80.745,14.995),(80.915,14.995),(80.915,14.825),(80.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.285),(32.745,4.455),(32.915,4.455),(32.915,4.285),(32.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.625),(32.745,4.795),(32.915,4.795),(32.915,4.625),(32.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.945),(13.545,4.115),(13.715,4.115),(13.715,3.945),(13.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.285),(13.545,4.455),(13.715,4.455),(13.715,4.285),(13.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.625),(13.545,4.795),(13.715,4.795),(13.715,4.625),(13.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.285),(8.745,4.455),(8.915,4.455),(8.915,4.285),(8.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.625),(8.745,4.795),(8.915,4.795),(8.915,4.625),(8.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.305),(27.945,5.475),(28.115,5.475),(28.115,5.305),(27.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.645),(27.945,5.815),(28.115,5.815),(28.115,5.645),(27.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.385),(51.945,9.555),(52.115,9.555),(52.115,9.385),(51.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.725),(51.945,9.895),(52.115,9.895),(52.115,9.725),(51.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.485),(76.285,14.655),(76.455,14.655),(76.455,14.485),(76.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.825),(76.285,14.995),(76.455,14.995),(76.455,14.825),(76.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.145),(76.285,14.315),(76.455,14.315),(76.455,14.145),(76.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.785),(18.685,12.955),(18.855,12.955),(18.855,12.785),(18.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.445),(18.345,12.615),(18.515,12.615),(18.515,12.445),(18.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.445),(18.685,12.615),(18.855,12.615),(18.855,12.445),(18.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.785),(18.345,12.955),(18.515,12.955),(18.515,12.785),(18.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.105),(18.345,12.275),(18.515,12.275),(18.515,12.105),(18.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.105),(18.685,12.275),(18.855,12.275),(18.855,12.105),(18.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.205),(61.545,17.375),(61.715,17.375),(61.715,17.205),(61.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.545),(61.545,17.715),(61.715,17.715),(61.715,17.545),(61.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.025),(13.545,8.195),(13.715,8.195),(13.715,8.025),(13.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.365),(13.545,8.535),(13.715,8.535),(13.715,8.365),(13.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.705),(13.545,8.875),(13.715,8.875),(13.715,8.705),(13.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.265),(37.885,3.435),(38.055,3.435),(38.055,3.265),(37.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.605),(37.885,3.775),(38.055,3.775),(38.055,3.605),(37.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.865),(61.885,17.035),(62.055,17.035),(62.055,16.865),(61.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.965),(27.945,5.135),(28.115,5.135),(28.115,4.965),(27.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.385),(81.085,9.555),(81.255,9.555),(81.255,9.385),(81.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.725),(81.085,9.895),(81.255,9.895),(81.255,9.725),(81.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.845),(18.345,16.015),(18.515,16.015),(18.515,15.845),(18.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.845),(18.685,16.015),(18.855,16.015),(18.855,15.845),(18.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.565),(52.285,18.735),(52.455,18.735),(52.455,18.565),(52.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.225),(52.285,18.395),(52.455,18.395),(52.455,18.225),(52.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.305),(51.945,5.475),(52.115,5.475),(52.115,5.305),(51.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.645),(51.945,5.815),(52.115,5.815),(52.115,5.645),(51.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.285),(61.545,4.455),(61.715,4.455),(61.715,4.285),(61.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.625),(61.545,4.795),(61.715,4.795),(61.715,4.625),(61.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.005),(52.285,7.175),(52.455,7.175),(52.455,7.005),(52.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.345),(52.285,7.515),(52.455,7.515),(52.455,7.345),(52.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.685),(52.285,7.855),(52.455,7.855),(52.455,7.685),(52.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.245),(33.085,19.415),(33.255,19.415),(33.255,19.245),(33.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.445),(47.485,12.615),(47.655,12.615),(47.655,12.445),(47.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.785),(47.485,12.955),(47.655,12.955),(47.655,12.785),(47.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.445),(47.145,12.615),(47.315,12.615),(47.315,12.445),(47.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.105),(47.145,12.275),(47.315,12.275),(47.315,12.105),(47.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.105),(47.485,12.275),(47.655,12.275),(47.655,12.105),(47.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.785),(47.145,12.955),(47.315,12.955),(47.315,12.785),(47.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.385),(27.945,9.555),(28.115,9.555),(28.115,9.385),(27.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.725),(27.945,9.895),(28.115,9.895),(28.115,9.725),(27.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.045),(61.885,9.215),(62.055,9.215),(62.055,9.045),(61.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.165),(66.345,15.335),(66.515,15.335),(66.515,15.165),(66.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.165),(66.685,15.335),(66.855,15.335),(66.855,15.165),(66.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.505),(66.345,15.675),(66.515,15.675),(66.515,15.505),(66.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.885),(57.085,18.055),(57.255,18.055),(57.255,17.885),(57.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.505),(66.685,15.675),(66.855,15.675),(66.855,15.505),(66.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.925),(52.285,3.095),(52.455,3.095),(52.455,2.925),(52.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.865),(71.145,17.035),(71.315,17.035),(71.315,16.865),(71.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.865),(71.485,17.035),(71.655,17.035),(71.655,16.865),(71.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.245),(23.485,19.415),(23.655,19.415),(23.655,19.245),(23.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.245),(23.145,19.415),(23.315,19.415),(23.315,19.245),(23.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.045),(71.145,9.215),(71.315,9.215),(71.315,9.045),(71.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.045),(71.485,9.215),(71.655,9.215),(71.655,9.045),(71.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.345),(28.285,7.515),(28.455,7.515),(28.455,7.345),(28.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.005),(28.285,7.175),(28.455,7.175),(28.455,7.005),(28.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.045),(13.885,9.215),(14.055,9.215),(14.055,9.045),(13.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.365),(61.545,8.535),(61.715,8.535),(61.715,8.365),(61.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.705),(61.545,8.875),(61.715,8.875),(61.715,8.705),(61.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.025),(61.545,8.195),(61.715,8.195),(61.715,8.025),(61.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.645),(81.085,5.815),(81.255,5.815),(81.255,5.645),(81.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.305),(81.085,5.475),(81.255,5.475),(81.255,5.305),(81.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.065),(66.345,10.235),(66.515,10.235),(66.515,10.065),(66.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.065),(66.685,10.235),(66.855,10.235),(66.855,10.065),(66.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.745),(66.345,10.915),(66.515,10.915),(66.515,10.745),(66.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.745),(66.685,10.915),(66.855,10.915),(66.855,10.745),(66.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.405),(66.685,10.575),(66.855,10.575),(66.855,10.405),(66.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.405),(66.345,10.575),(66.515,10.575),(66.515,10.405),(66.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.765),(28.285,11.935),(28.455,11.935),(28.455,11.765),(28.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.085),(28.285,11.255),(28.455,11.255),(28.455,11.085),(28.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.425),(28.285,11.595),(28.455,11.595),(28.455,11.425),(28.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.145),(23.145,14.315),(23.315,14.315),(23.315,14.145),(23.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.145),(23.485,14.315),(23.655,14.315),(23.655,14.145),(23.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.485),(23.145,14.655),(23.315,14.655),(23.315,14.485),(23.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.485),(23.485,14.655),(23.655,14.655),(23.655,14.485),(23.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.825),(23.145,14.995),(23.315,14.995),(23.315,14.825),(23.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.825),(23.485,14.995),(23.655,14.995),(23.655,14.825),(23.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.065),(51.945,10.235),(52.115,10.235),(52.115,10.065),(51.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.745),(51.945,10.915),(52.115,10.915),(52.115,10.745),(51.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.405),(51.945,10.575),(52.115,10.575),(52.115,10.405),(51.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.865),(33.085,17.035),(33.255,17.035),(33.255,16.865),(33.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.105),(66.685,12.275),(66.855,12.275),(66.855,12.105),(66.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.445),(66.345,12.615),(66.515,12.615),(66.515,12.445),(66.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.445),(66.685,12.615),(66.855,12.615),(66.855,12.445),(66.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.785),(66.345,12.955),(66.515,12.955),(66.515,12.785),(66.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.785),(66.685,12.955),(66.855,12.955),(66.855,12.785),(66.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.105),(66.345,12.275),(66.515,12.275),(66.515,12.105),(66.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.765),(47.145,11.935),(47.315,11.935),(47.315,11.765),(47.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.765),(47.485,11.935),(47.655,11.935),(47.655,11.765),(47.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.425),(47.145,11.595),(47.315,11.595),(47.315,11.425),(47.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.425),(47.485,11.595),(47.655,11.595),(47.655,11.425),(47.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.085),(47.145,11.255),(47.315,11.255),(47.315,11.085),(47.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.085),(47.485,11.255),(47.655,11.255),(47.655,11.085),(47.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.145),(9.085,14.315),(9.255,14.315),(9.255,14.145),(9.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.485),(9.085,14.655),(9.255,14.655),(9.255,14.485),(9.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.825),(9.085,14.995),(9.255,14.995),(9.255,14.825),(9.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.325),(28.285,6.495),(28.455,6.495),(28.455,6.325),(28.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.665),(28.285,6.835),(28.455,6.835),(28.455,6.665),(28.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.265),(66.685,3.435),(66.855,3.435),(66.855,3.265),(66.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.265),(66.345,3.435),(66.515,3.435),(66.515,3.265),(66.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.605),(66.345,3.775),(66.515,3.775),(66.515,3.605),(66.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.605),(66.685,3.775),(66.855,3.775),(66.855,3.605),(66.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.365),(18.345,8.535),(18.515,8.535),(18.515,8.365),(18.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.365),(18.685,8.535),(18.855,8.535),(18.855,8.365),(18.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.705),(18.685,8.875),(18.855,8.875),(18.855,8.705),(18.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.705),(18.345,8.875),(18.515,8.875),(18.515,8.705),(18.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.025),(18.345,8.195),(18.515,8.195),(18.515,8.025),(18.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.025),(18.685,8.195),(18.855,8.195),(18.855,8.025),(18.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.945),(28.285,4.115),(28.455,4.115),(28.455,3.945),(28.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.965),(76.285,5.135),(76.455,5.135),(76.455,4.965),(76.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.065),(18.685,10.235),(18.855,10.235),(18.855,10.065),(18.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.745),(18.685,10.915),(18.855,10.915),(18.855,10.745),(18.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.745),(18.345,10.915),(18.515,10.915),(18.515,10.745),(18.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.405),(18.685,10.575),(18.855,10.575),(18.855,10.405),(18.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.405),(18.345,10.575),(18.515,10.575),(18.515,10.405),(18.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.065),(18.345,10.235),(18.515,10.235),(18.515,10.065),(18.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.205),(71.145,17.375),(71.315,17.375),(71.315,17.205),(71.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.205),(71.485,17.375),(71.655,17.375),(71.655,17.205),(71.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.545),(71.145,17.715),(71.315,17.715),(71.315,17.545),(71.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.545),(71.485,17.715),(71.655,17.715),(71.655,17.545),(71.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.965),(28.285,5.135),(28.455,5.135),(28.455,4.965),(28.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.845),(66.345,16.015),(66.515,16.015),(66.515,15.845),(66.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.845),(66.685,16.015),(66.855,16.015),(66.855,15.845),(66.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.185),(37.545,16.355),(37.715,16.355),(37.715,16.185),(37.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.525),(37.545,16.695),(37.715,16.695),(37.715,16.525),(37.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.845),(33.085,16.015),(33.255,16.015),(33.255,15.845),(33.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.205),(37.885,17.375),(38.055,17.375),(38.055,17.205),(37.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.545),(37.885,17.715),(38.055,17.715),(38.055,17.545),(37.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.185),(52.285,16.355),(52.455,16.355),(52.455,16.185),(52.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.525),(52.285,16.695),(52.455,16.695),(52.455,16.525),(52.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.325),(75.945,6.495),(76.115,6.495),(76.115,6.325),(75.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.665),(75.945,6.835),(76.115,6.835),(76.115,6.665),(75.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.285),(80.745,4.455),(80.915,4.455),(80.915,4.285),(80.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.625),(80.745,4.795),(80.915,4.795),(80.915,4.625),(80.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.325),(27.945,6.495),(28.115,6.495),(28.115,6.325),(27.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.665),(27.945,6.835),(28.115,6.835),(28.115,6.665),(27.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.965),(75.945,5.135),(76.115,5.135),(76.115,4.965),(75.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.105),(51.945,12.275),(52.115,12.275),(52.115,12.105),(51.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.445),(51.945,12.615),(52.115,12.615),(52.115,12.445),(51.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.785),(51.945,12.955),(52.115,12.955),(52.115,12.785),(51.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.325),(52.285,6.495),(52.455,6.495),(52.455,6.325),(52.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.665),(52.285,6.835),(52.455,6.835),(52.455,6.665),(52.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.905),(27.945,19.075),(28.115,19.075),(28.115,18.905),(27.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.025),(52.285,8.195),(52.455,8.195),(52.455,8.025),(52.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.705),(52.285,8.875),(52.455,8.875),(52.455,8.705),(52.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.365),(52.285,8.535),(52.455,8.535),(52.455,8.365),(52.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.225),(37.885,18.395),(38.055,18.395),(38.055,18.225),(37.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.565),(37.885,18.735),(38.055,18.735),(38.055,18.565),(37.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.845),(81.085,16.015),(81.255,16.015),(81.255,15.845),(81.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.885),(42.345,18.055),(42.515,18.055),(42.515,17.885),(42.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.885),(42.685,18.055),(42.855,18.055),(42.855,17.885),(42.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.745),(33.085,10.915),(33.255,10.915),(33.255,10.745),(33.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.485),(57.085,14.655),(57.255,14.655),(57.255,14.485),(57.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.825),(57.085,14.995),(57.255,14.995),(57.255,14.825),(57.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.405),(33.085,10.575),(33.255,10.575),(33.255,10.405),(33.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.065),(33.085,10.235),(33.255,10.235),(33.255,10.065),(33.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.145),(57.085,14.315),(57.255,14.315),(57.255,14.145),(57.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.345),(71.485,7.515),(71.655,7.515),(71.655,7.345),(71.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.345),(71.145,7.515),(71.315,7.515),(71.315,7.345),(71.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.005),(71.145,7.175),(71.315,7.175),(71.315,7.005),(71.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.005),(71.485,7.175),(71.655,7.175),(71.655,7.005),(71.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.865),(13.885,17.035),(14.055,17.035),(14.055,16.865),(13.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.945),(66.345,4.115),(66.515,4.115),(66.515,3.945),(66.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.945),(66.685,4.115),(66.855,4.115),(66.855,3.945),(66.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.385),(75.945,9.555),(76.115,9.555),(76.115,9.385),(75.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.725),(75.945,9.895),(76.115,9.895),(76.115,9.725),(75.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.985),(37.545,6.155),(37.715,6.155),(37.715,5.985),(37.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.885),(75.945,18.055),(76.115,18.055),(76.115,17.885),(75.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.905),(56.745,19.075),(56.915,19.075),(56.915,18.905),(56.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.465),(66.345,13.635),(66.515,13.635),(66.515,13.465),(66.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.805),(66.345,13.975),(66.515,13.975),(66.515,13.805),(66.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.465),(66.685,13.635),(66.855,13.635),(66.855,13.465),(66.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.805),(66.685,13.975),(66.855,13.975),(66.855,13.805),(66.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.125),(66.345,13.295),(66.515,13.295),(66.515,13.125),(66.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.125),(66.685,13.295),(66.855,13.295),(66.855,13.125),(66.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.185),(42.345,16.355),(42.515,16.355),(42.515,16.185),(42.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.185),(42.685,16.355),(42.855,16.355),(42.855,16.185),(42.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.525),(42.345,16.695),(42.515,16.695),(42.515,16.525),(42.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.525),(42.685,16.695),(42.855,16.695),(42.855,16.525),(42.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.685),(37.545,7.855),(37.715,7.855),(37.715,7.685),(37.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.185),(57.085,16.355),(57.255,16.355),(57.255,16.185),(57.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.525),(57.085,16.695),(57.255,16.695),(57.255,16.525),(57.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.985),(52.285,6.155),(52.455,6.155),(52.455,5.985),(52.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.365),(66.685,8.535),(66.855,8.535),(66.855,8.365),(66.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.705),(66.345,8.875),(66.515,8.875),(66.515,8.705),(66.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.025),(66.345,8.195),(66.515,8.195),(66.515,8.025),(66.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.025),(66.685,8.195),(66.855,8.195),(66.855,8.025),(66.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.365),(66.345,8.535),(66.515,8.535),(66.515,8.365),(66.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.705),(66.685,8.875),(66.855,8.875),(66.855,8.705),(66.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.745),(75.945,10.915),(76.115,10.915),(76.115,10.745),(75.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.405),(75.945,10.575),(76.115,10.575),(76.115,10.405),(75.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.025),(76.285,8.195),(76.455,8.195),(76.455,8.025),(76.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.065),(75.945,10.235),(76.115,10.235),(76.115,10.065),(75.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.365),(76.285,8.535),(76.455,8.535),(76.455,8.365),(76.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.705),(76.285,8.875),(76.455,8.875),(76.455,8.705),(76.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.385),(42.345,9.555),(42.515,9.555),(42.515,9.385),(42.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.385),(42.685,9.555),(42.855,9.555),(42.855,9.385),(42.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.725),(42.345,9.895),(42.515,9.895),(42.515,9.725),(42.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.605),(27.945,3.775),(28.115,3.775),(28.115,3.605),(27.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.765),(76.285,11.935),(76.455,11.935),(76.455,11.765),(76.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.425),(76.285,11.595),(76.455,11.595),(76.455,11.425),(76.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.085),(76.285,11.255),(76.455,11.255),(76.455,11.085),(76.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.245),(52.285,19.415),(52.455,19.415),(52.455,19.245),(52.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.265),(27.945,3.435),(28.115,3.435),(28.115,3.265),(27.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.725),(42.685,9.895),(42.855,9.895),(42.855,9.725),(42.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.485),(71.485,14.655),(71.655,14.655),(71.655,14.485),(71.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.825),(71.145,14.995),(71.315,14.995),(71.315,14.825),(71.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.825),(71.485,14.995),(71.655,14.995),(71.655,14.825),(71.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.485),(71.145,14.655),(71.315,14.655),(71.315,14.485),(71.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.145),(71.145,14.315),(71.315,14.315),(71.315,14.145),(71.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.145),(71.485,14.315),(71.655,14.315),(71.655,14.145),(71.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,2.925),(23.145,3.095),(23.315,3.095),(23.315,2.925),(23.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,2.925),(23.485,3.095),(23.655,3.095),(23.655,2.925),(23.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.745),(27.945,10.915),(28.115,10.915),(28.115,10.745),(27.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.065),(27.945,10.235),(28.115,10.235),(28.115,10.065),(27.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.405),(27.945,10.575),(28.115,10.575),(28.115,10.405),(27.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.025),(28.285,8.195),(28.455,8.195),(28.455,8.025),(28.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.365),(28.285,8.535),(28.455,8.535),(28.455,8.365),(28.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.705),(28.285,8.875),(28.455,8.875),(28.455,8.705),(28.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.985),(76.285,6.155),(76.455,6.155),(76.455,5.985),(76.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.565),(47.145,18.735),(47.315,18.735),(47.315,18.565),(47.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.225),(47.145,18.395),(47.315,18.395),(47.315,18.225),(47.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.225),(47.485,18.395),(47.655,18.395),(47.655,18.225),(47.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.565),(47.485,18.735),(47.655,18.735),(47.655,18.565),(47.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.005),(13.545,7.175),(13.715,7.175),(13.715,7.005),(13.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.345),(13.545,7.515),(13.715,7.515),(13.715,7.345),(13.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.905),(57.085,19.075),(57.255,19.075),(57.255,18.905),(57.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.225),(37.545,18.395),(37.715,18.395),(37.715,18.225),(37.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.565),(37.545,18.735),(37.715,18.735),(37.715,18.565),(37.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.205),(13.545,17.375),(13.715,17.375),(13.715,17.205),(13.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.545),(13.545,17.715),(13.715,17.715),(13.715,17.545),(13.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,2.925),(66.685,3.095),(66.855,3.095),(66.855,2.925),(66.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,2.925),(66.345,3.095),(66.515,3.095),(66.515,2.925),(66.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.125),(18.345,13.295),(18.515,13.295),(18.515,13.125),(18.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.125),(18.685,13.295),(18.855,13.295),(18.855,13.125),(18.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.465),(18.685,13.635),(18.855,13.635),(18.855,13.465),(18.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.465),(18.345,13.635),(18.515,13.635),(18.515,13.465),(18.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.805),(18.345,13.975),(18.515,13.975),(18.515,13.805),(18.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.805),(18.685,13.975),(18.855,13.975),(18.855,13.805),(18.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.965),(71.145,5.135),(71.315,5.135),(71.315,4.965),(71.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.965),(71.485,5.135),(71.655,5.135),(71.655,4.965),(71.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.965),(23.145,5.135),(23.315,5.135),(23.315,4.965),(23.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.965),(23.485,5.135),(23.655,5.135),(23.655,4.965),(23.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.205),(51.945,17.375),(52.115,17.375),(52.115,17.205),(51.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.545),(51.945,17.715),(52.115,17.715),(52.115,17.545),(51.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.445),(23.145,12.615),(23.315,12.615),(23.315,12.445),(23.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.745),(81.085,10.915),(81.255,10.915),(81.255,10.745),(81.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.405),(81.085,10.575),(81.255,10.575),(81.255,10.405),(81.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.065),(81.085,10.235),(81.255,10.235),(81.255,10.065),(81.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.465),(33.085,13.635),(33.255,13.635),(33.255,13.465),(33.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.805),(33.085,13.975),(33.255,13.975),(33.255,13.805),(33.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.125),(33.085,13.295),(33.255,13.295),(33.255,13.125),(33.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,2.925),(13.545,3.095),(13.715,3.095),(13.715,2.925),(13.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.865),(81.085,17.035),(81.255,17.035),(81.255,16.865),(81.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.985),(57.085,6.155),(57.255,6.155),(57.255,5.985),(57.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.245),(71.145,19.415),(71.315,19.415),(71.315,19.245),(71.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.245),(71.485,19.415),(71.655,19.415),(71.655,19.245),(71.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.985),(33.085,6.155),(33.255,6.155),(33.255,5.985),(33.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,2.925),(18.685,3.095),(18.855,3.095),(18.855,2.925),(18.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,2.925),(18.345,3.095),(18.515,3.095),(18.515,2.925),(18.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.985),(9.085,6.155),(9.255,6.155),(9.255,5.985),(9.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.925),(47.145,3.095),(47.315,3.095),(47.315,2.925),(47.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.925),(47.485,3.095),(47.655,3.095),(47.655,2.925),(47.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.105),(27.945,12.275),(28.115,12.275),(28.115,12.105),(27.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.445),(27.945,12.615),(28.115,12.615),(28.115,12.445),(27.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.785),(27.945,12.955),(28.115,12.955),(28.115,12.785),(27.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.245),(80.745,19.415),(80.915,19.415),(80.915,19.245),(80.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.885),(9.085,18.055),(9.255,18.055),(9.255,17.885),(9.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.345),(57.085,7.515),(57.255,7.515),(57.255,7.345),(57.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.685),(57.085,7.855),(57.255,7.855),(57.255,7.685),(57.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.005),(57.085,7.175),(57.255,7.175),(57.255,7.005),(57.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.245),(81.085,19.415),(81.255,19.415),(81.255,19.245),(81.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.825),(37.885,14.995),(38.055,14.995),(38.055,14.825),(37.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.485),(37.885,14.655),(38.055,14.655),(38.055,14.485),(37.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.145),(37.885,14.315),(38.055,14.315),(38.055,14.145),(37.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.005),(33.085,7.175),(33.255,7.175),(33.255,7.005),(33.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.345),(33.085,7.515),(33.255,7.515),(33.255,7.345),(33.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.685),(33.085,7.855),(33.255,7.855),(33.255,7.685),(33.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.285),(13.885,4.455),(14.055,4.455),(14.055,4.285),(13.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.625),(13.885,4.795),(14.055,4.795),(14.055,4.625),(13.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.685),(9.085,7.855),(9.255,7.855),(9.255,7.685),(9.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.005),(9.085,7.175),(9.255,7.175),(9.255,7.005),(9.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.345),(9.085,7.515),(9.255,7.515),(9.255,7.345),(9.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.925),(42.345,3.095),(42.515,3.095),(42.515,2.925),(42.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.925),(42.685,3.095),(42.855,3.095),(42.855,2.925),(42.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.065),(47.145,10.235),(47.315,10.235),(47.315,10.065),(47.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.065),(47.485,10.235),(47.655,10.235),(47.655,10.065),(47.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.325),(23.145,6.495),(23.315,6.495),(23.315,6.325),(23.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.325),(23.485,6.495),(23.655,6.495),(23.655,6.325),(23.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.665),(23.145,6.835),(23.315,6.835),(23.315,6.665),(23.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.665),(23.485,6.835),(23.655,6.835),(23.655,6.665),(23.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.405),(47.145,10.575),(47.315,10.575),(47.315,10.405),(47.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.405),(47.485,10.575),(47.655,10.575),(47.655,10.405),(47.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.745),(47.145,10.915),(47.315,10.915),(47.315,10.745),(47.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.745),(47.485,10.915),(47.655,10.915),(47.655,10.745),(47.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.965),(47.485,5.135),(47.655,5.135),(47.655,4.965),(47.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.965),(47.145,5.135),(47.315,5.135),(47.315,4.965),(47.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.185),(32.745,16.355),(32.915,16.355),(32.915,16.185),(32.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.525),(32.745,16.695),(32.915,16.695),(32.915,16.525),(32.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.905),(61.885,19.075),(62.055,19.075),(62.055,18.905),(61.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.025),(47.145,8.195),(47.315,8.195),(47.315,8.025),(47.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.025),(47.485,8.195),(47.655,8.195),(47.655,8.025),(47.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.365),(47.145,8.535),(47.315,8.535),(47.315,8.365),(47.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.365),(47.485,8.535),(47.655,8.535),(47.655,8.365),(47.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.705),(47.145,8.875),(47.315,8.875),(47.315,8.705),(47.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.705),(47.485,8.875),(47.655,8.875),(47.655,8.705),(47.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.365),(81.085,8.535),(81.255,8.535),(81.255,8.365),(81.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.705),(81.085,8.875),(81.255,8.875),(81.255,8.705),(81.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.025),(81.085,8.195),(81.255,8.195),(81.255,8.025),(81.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.045),(66.345,9.215),(66.515,9.215),(66.515,9.045),(66.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.045),(66.685,9.215),(66.855,9.215),(66.855,9.045),(66.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.345),(81.085,7.515),(81.255,7.515),(81.255,7.345),(81.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.685),(81.085,7.855),(81.255,7.855),(81.255,7.685),(81.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.005),(81.085,7.175),(81.255,7.175),(81.255,7.005),(81.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.205),(47.485,17.375),(47.655,17.375),(47.655,17.205),(47.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.545),(47.145,17.715),(47.315,17.715),(47.315,17.545),(47.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.205),(47.145,17.375),(47.315,17.375),(47.315,17.205),(47.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.545),(47.485,17.715),(47.655,17.715),(47.655,17.545),(47.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,2.925),(61.545,3.095),(61.715,3.095),(61.715,2.925),(61.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.305),(61.885,5.475),(62.055,5.475),(62.055,5.305),(61.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.645),(61.885,5.815),(62.055,5.815),(62.055,5.645),(61.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.305),(13.885,5.475),(14.055,5.475),(14.055,5.305),(13.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.645),(13.885,5.815),(14.055,5.815),(14.055,5.645),(13.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,2.925),(71.145,3.095),(71.315,3.095),(71.315,2.925),(71.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,2.925),(71.485,3.095),(71.655,3.095),(71.655,2.925),(71.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.845),(32.745,16.015),(32.915,16.015),(32.915,15.845),(32.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.145),(13.885,14.315),(14.055,14.315),(14.055,14.145),(13.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.485),(13.885,14.655),(14.055,14.655),(14.055,14.485),(13.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.825),(13.885,14.995),(14.055,14.995),(14.055,14.825),(13.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.285),(61.885,4.455),(62.055,4.455),(62.055,4.285),(61.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.625),(61.885,4.795),(62.055,4.795),(62.055,4.625),(61.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.045),(8.745,9.215),(8.915,9.215),(8.915,9.045),(8.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.025),(33.085,8.195),(33.255,8.195),(33.255,8.025),(33.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.365),(33.085,8.535),(33.255,8.535),(33.255,8.365),(33.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.705),(33.085,8.875),(33.255,8.875),(33.255,8.705),(33.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.045),(18.345,9.215),(18.515,9.215),(18.515,9.045),(18.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.045),(18.685,9.215),(18.855,9.215),(18.855,9.045),(18.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.325),(13.545,6.495),(13.715,6.495),(13.715,6.325),(13.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.665),(13.545,6.835),(13.715,6.835),(13.715,6.665),(13.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.785),(23.145,12.955),(23.315,12.955),(23.315,12.785),(23.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.185),(9.085,16.355),(9.255,16.355),(9.255,16.185),(9.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.525),(9.085,16.695),(9.255,16.695),(9.255,16.525),(9.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.425),(18.685,11.595),(18.855,11.595),(18.855,11.425),(18.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.425),(18.345,11.595),(18.515,11.595),(18.515,11.425),(18.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.765),(18.345,11.935),(18.515,11.935),(18.515,11.765),(18.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.765),(18.685,11.935),(18.855,11.935),(18.855,11.765),(18.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.085),(18.345,11.255),(18.515,11.255),(18.515,11.085),(18.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.085),(18.685,11.255),(18.855,11.255),(18.855,11.085),(18.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.905),(75.945,19.075),(76.115,19.075),(76.115,18.905),(75.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.325),(47.145,6.495),(47.315,6.495),(47.315,6.325),(47.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.325),(47.485,6.495),(47.655,6.495),(47.655,6.325),(47.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.665),(47.145,6.835),(47.315,6.835),(47.315,6.665),(47.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.665),(47.485,6.835),(47.655,6.835),(47.655,6.665),(47.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.205),(42.345,17.375),(42.515,17.375),(42.515,17.205),(42.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.205),(42.685,17.375),(42.855,17.375),(42.855,17.205),(42.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.545),(42.345,17.715),(42.515,17.715),(42.515,17.545),(42.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.545),(42.685,17.715),(42.855,17.715),(42.855,17.545),(42.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.905),(9.085,19.075),(9.255,19.075),(9.255,18.905),(9.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.885),(28.285,18.055),(28.455,18.055),(28.455,17.885),(28.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.105),(75.945,12.275),(76.115,12.275),(76.115,12.105),(75.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.445),(75.945,12.615),(76.115,12.615),(76.115,12.445),(75.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.785),(75.945,12.955),(76.115,12.955),(76.115,12.785),(75.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.885),(32.745,18.055),(32.915,18.055),(32.915,17.885),(32.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.145),(61.885,14.315),(62.055,14.315),(62.055,14.145),(61.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.485),(61.885,14.655),(62.055,14.655),(62.055,14.485),(61.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.825),(61.885,14.995),(62.055,14.995),(62.055,14.825),(61.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.245),(27.945,19.415),(28.115,19.415),(28.115,19.245),(27.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.045),(56.745,9.215),(56.915,9.215),(56.915,9.045),(56.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.905),(8.745,19.075),(8.915,19.075),(8.915,18.905),(8.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.325),(61.545,6.495),(61.715,6.495),(61.715,6.325),(61.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.665),(61.545,6.835),(61.715,6.835),(61.715,6.665),(61.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.645),(52.285,5.815),(52.455,5.815),(52.455,5.645),(52.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.305),(52.285,5.475),(52.455,5.475),(52.455,5.305),(52.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.125),(81.085,13.295),(81.255,13.295),(81.255,13.125),(81.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.465),(81.085,13.635),(81.255,13.635),(81.255,13.465),(81.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.805),(81.085,13.975),(81.255,13.975),(81.255,13.805),(81.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.445),(81.085,12.615),(81.255,12.615),(81.255,12.445),(81.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.785),(81.085,12.955),(81.255,12.955),(81.255,12.785),(81.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.105),(81.085,12.275),(81.255,12.275),(81.255,12.105),(81.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.945),(27.945,4.115),(28.115,4.115),(28.115,3.945),(27.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.185),(51.945,16.355),(52.115,16.355),(52.115,16.185),(51.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.525),(51.945,16.695),(52.115,16.695),(52.115,16.525),(51.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.005),(8.745,7.175),(8.915,7.175),(8.915,7.005),(8.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.345),(8.745,7.515),(8.915,7.515),(8.915,7.345),(8.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.305),(76.285,5.475),(76.455,5.475),(76.455,5.305),(76.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.645),(76.285,5.815),(76.455,5.815),(76.455,5.645),(76.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.325),(71.145,6.495),(71.315,6.495),(71.315,6.325),(71.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.325),(71.485,6.495),(71.655,6.495),(71.655,6.325),(71.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.665),(71.145,6.835),(71.315,6.835),(71.315,6.665),(71.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.665),(71.485,6.835),(71.655,6.835),(71.655,6.665),(71.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.845),(80.745,16.015),(80.915,16.015),(80.915,15.845),(80.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.765),(32.745,11.935),(32.915,11.935),(32.915,11.765),(32.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.085),(32.745,11.255),(32.915,11.255),(32.915,11.085),(32.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.425),(32.745,11.595),(32.915,11.595),(32.915,11.425),(32.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.845),(8.745,16.015),(8.915,16.015),(8.915,15.845),(8.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.425),(66.685,11.595),(66.855,11.595),(66.855,11.425),(66.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.425),(66.345,11.595),(66.515,11.595),(66.515,11.425),(66.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.765),(66.685,11.935),(66.855,11.935),(66.855,11.765),(66.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.765),(66.345,11.935),(66.515,11.935),(66.515,11.765),(66.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.085),(66.345,11.255),(66.515,11.255),(66.515,11.085),(66.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.085),(66.685,11.255),(66.855,11.255),(66.855,11.085),(66.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.105),(33.085,12.275),(33.255,12.275),(33.255,12.105),(33.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.445),(33.085,12.615),(33.255,12.615),(33.255,12.445),(33.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.785),(33.085,12.955),(33.255,12.955),(33.255,12.785),(33.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.305),(47.145,5.475),(47.315,5.475),(47.315,5.305),(47.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.305),(47.485,5.475),(47.655,5.475),(47.655,5.305),(47.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.645),(47.145,5.815),(47.315,5.815),(47.315,5.645),(47.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.645),(47.485,5.815),(47.655,5.815),(47.655,5.645),(47.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.905),(13.885,19.075),(14.055,19.075),(14.055,18.905),(13.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.325),(8.745,6.495),(8.915,6.495),(8.915,6.325),(8.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.665),(8.745,6.835),(8.915,6.835),(8.915,6.665),(8.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.305),(23.145,5.475),(23.315,5.475),(23.315,5.305),(23.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.305),(23.485,5.475),(23.655,5.475),(23.655,5.305),(23.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.645),(23.145,5.815),(23.315,5.815),(23.315,5.645),(23.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.645),(23.485,5.815),(23.655,5.815),(23.655,5.645),(23.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.465),(8.745,13.635),(8.915,13.635),(8.915,13.465),(8.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.805),(8.745,13.975),(8.915,13.975),(8.915,13.805),(8.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.125),(8.745,13.295),(8.915,13.295),(8.915,13.125),(8.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.965),(56.745,5.135),(56.915,5.135),(56.915,4.965),(56.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.325),(66.685,6.495),(66.855,6.495),(66.855,6.325),(66.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.325),(66.345,6.495),(66.515,6.495),(66.515,6.325),(66.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.665),(66.685,6.835),(66.855,6.835),(66.855,6.665),(66.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.665),(66.345,6.835),(66.515,6.835),(66.515,6.665),(66.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.965),(32.745,5.135),(32.915,5.135),(32.915,4.965),(32.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.385),(80.745,9.555),(80.915,9.555),(80.915,9.385),(80.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.965),(13.545,5.135),(13.715,5.135),(13.715,4.965),(13.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.725),(80.745,9.895),(80.915,9.895),(80.915,9.725),(80.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.965),(8.745,5.135),(8.915,5.135),(8.915,4.965),(8.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.605),(81.085,3.775),(81.255,3.775),(81.255,3.605),(81.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.265),(81.085,3.435),(81.255,3.435),(81.255,3.265),(81.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.885),(66.685,18.055),(66.855,18.055),(66.855,17.885),(66.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.885),(66.345,18.055),(66.515,18.055),(66.515,17.885),(66.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.985),(27.945,6.155),(28.115,6.155),(28.115,5.985),(27.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.565),(42.345,18.735),(42.515,18.735),(42.515,18.565),(42.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.225),(42.345,18.395),(42.515,18.395),(42.515,18.225),(42.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.565),(42.685,18.735),(42.855,18.735),(42.855,18.565),(42.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.225),(42.685,18.395),(42.855,18.395),(42.855,18.225),(42.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.845),(37.545,16.015),(37.715,16.015),(37.715,15.845),(37.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.245),(61.885,19.415),(62.055,19.415),(62.055,19.245),(61.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.365),(32.745,8.535),(32.915,8.535),(32.915,8.365),(32.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.705),(32.745,8.875),(32.915,8.875),(32.915,8.705),(32.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.025),(32.745,8.195),(32.915,8.195),(32.915,8.025),(32.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.845),(56.745,16.015),(56.915,16.015),(56.915,15.845),(56.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.185),(61.885,16.355),(62.055,16.355),(62.055,16.185),(61.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.525),(61.885,16.695),(62.055,16.695),(62.055,16.525),(61.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.525),(47.145,16.695),(47.315,16.695),(47.315,16.525),(47.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.185),(47.145,16.355),(47.315,16.355),(47.315,16.185),(47.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.525),(47.485,16.695),(47.655,16.695),(47.655,16.525),(47.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.185),(47.485,16.355),(47.655,16.355),(47.655,16.185),(47.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.285),(27.945,4.455),(28.115,4.455),(28.115,4.285),(27.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.625),(27.945,4.795),(28.115,4.795),(28.115,4.625),(27.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.665),(18.345,6.835),(18.515,6.835),(18.515,6.665),(18.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.665),(18.685,6.835),(18.855,6.835),(18.855,6.665),(18.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.325),(18.345,6.495),(18.515,6.495),(18.515,6.325),(18.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.325),(18.685,6.495),(18.855,6.495),(18.855,6.325),(18.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.685),(51.945,7.855),(52.115,7.855),(52.115,7.685),(51.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.385),(32.745,9.555),(32.915,9.555),(32.915,9.385),(32.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.725),(32.745,9.895),(32.915,9.895),(32.915,9.725),(32.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.345),(51.945,7.515),(52.115,7.515),(52.115,7.345),(51.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.005),(51.945,7.175),(52.115,7.175),(52.115,7.005),(51.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.765),(37.885,11.935),(38.055,11.935),(38.055,11.765),(37.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.085),(37.885,11.255),(38.055,11.255),(38.055,11.085),(37.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.425),(37.885,11.595),(38.055,11.595),(38.055,11.425),(37.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.285),(52.285,4.455),(52.455,4.455),(52.455,4.285),(52.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.625),(52.285,4.795),(52.455,4.795),(52.455,4.625),(52.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.945),(57.085,4.115),(57.255,4.115),(57.255,3.945),(57.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.465),(56.745,13.635),(56.915,13.635),(56.915,13.465),(56.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.805),(56.745,13.975),(56.915,13.975),(56.915,13.805),(56.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.125),(56.745,13.295),(56.915,13.295),(56.915,13.125),(56.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.945),(33.085,4.115),(33.255,4.115),(33.255,3.945),(33.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.765),(80.745,11.935),(80.915,11.935),(80.915,11.765),(80.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.985),(18.345,6.155),(18.515,6.155),(18.515,5.985),(18.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.985),(18.685,6.155),(18.855,6.155),(18.855,5.985),(18.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.945),(9.085,4.115),(9.255,4.115),(9.255,3.945),(9.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.425),(80.745,11.595),(80.915,11.595),(80.915,11.425),(80.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.085),(80.745,11.255),(80.915,11.255),(80.915,11.085),(80.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.905),(52.285,19.075),(52.455,19.075),(52.455,18.905),(52.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.985),(51.945,6.155),(52.115,6.155),(52.115,5.985),(51.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.965),(61.545,5.135),(61.715,5.135),(61.715,4.965),(61.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.325),(42.345,6.495),(42.515,6.495),(42.515,6.325),(42.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.325),(42.685,6.495),(42.855,6.495),(42.855,6.325),(42.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.665),(42.345,6.835),(42.515,6.835),(42.515,6.665),(42.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.665),(42.685,6.835),(42.855,6.835),(42.855,6.665),(42.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.445),(37.885,12.615),(38.055,12.615),(38.055,12.445),(37.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.505),(52.285,15.675),(52.455,15.675),(52.455,15.505),(52.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.165),(52.285,15.335),(52.455,15.335),(52.455,15.165),(52.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.785),(37.885,12.955),(38.055,12.955),(38.055,12.785),(37.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.105),(37.885,12.275),(38.055,12.275),(38.055,12.105),(37.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.205),(57.085,17.375),(57.255,17.375),(57.255,17.205),(57.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.545),(57.085,17.715),(57.255,17.715),(57.255,17.545),(57.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.885),(37.545,18.055),(37.715,18.055),(37.715,17.885),(37.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.885),(80.745,18.055),(80.915,18.055),(80.915,17.885),(80.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.245),(37.545,19.415),(37.715,19.415),(37.715,19.245),(37.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.005),(80.745,7.175),(80.915,7.175),(80.915,7.005),(80.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.345),(80.745,7.515),(80.915,7.515),(80.915,7.345),(80.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.325),(81.085,6.495),(81.255,6.495),(81.255,6.325),(81.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.665),(81.085,6.835),(81.255,6.835),(81.255,6.665),(81.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.185),(66.345,16.355),(66.515,16.355),(66.515,16.185),(66.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.185),(66.685,16.355),(66.855,16.355),(66.855,16.185),(66.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.525),(66.345,16.695),(66.515,16.695),(66.515,16.525),(66.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.525),(66.685,16.695),(66.855,16.695),(66.855,16.525),(66.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.385),(37.545,9.555),(37.715,9.555),(37.715,9.385),(37.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.725),(37.545,9.895),(37.715,9.895),(37.715,9.725),(37.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.885),(76.285,18.055),(76.455,18.055),(76.455,17.885),(76.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.205),(28.285,17.375),(28.455,17.375),(28.455,17.205),(28.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.545),(28.285,17.715),(28.455,17.715),(28.455,17.545),(28.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.345),(37.885,7.515),(38.055,7.515),(38.055,7.345),(37.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.685),(37.885,7.855),(38.055,7.855),(38.055,7.685),(37.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.005),(37.885,7.175),(38.055,7.175),(38.055,7.005),(37.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.985),(80.745,6.155),(80.915,6.155),(80.915,5.985),(80.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.885),(33.085,18.055),(33.255,18.055),(33.255,17.885),(33.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.265),(28.285,3.435),(28.455,3.435),(28.455,3.265),(28.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.605),(28.285,3.775),(28.455,3.775),(28.455,3.605),(28.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.385),(57.085,9.555),(57.255,9.555),(57.255,9.385),(57.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.725),(57.085,9.895),(57.255,9.895),(57.255,9.725),(57.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.105),(32.745,12.275),(32.915,12.275),(32.915,12.105),(32.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.445),(32.745,12.615),(32.915,12.615),(32.915,12.445),(32.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.785),(32.745,12.955),(32.915,12.955),(32.915,12.785),(32.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.105),(13.885,12.275),(14.055,12.275),(14.055,12.105),(13.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.445),(13.885,12.615),(14.055,12.615),(14.055,12.445),(13.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.785),(13.885,12.955),(14.055,12.955),(14.055,12.785),(13.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.245),(75.945,19.415),(76.115,19.415),(76.115,19.245),(75.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.205),(32.745,17.375),(32.915,17.375),(32.915,17.205),(32.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.545),(32.745,17.715),(32.915,17.715),(32.915,17.545),(32.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.005),(61.885,7.175),(62.055,7.175),(62.055,7.005),(61.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.845),(61.545,16.015),(61.715,16.015),(61.715,15.845),(61.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.345),(61.885,7.515),(62.055,7.515),(62.055,7.345),(61.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.385),(9.085,9.555),(9.255,9.555),(9.255,9.385),(9.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.725),(9.085,9.895),(9.255,9.895),(9.255,9.725),(9.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.385),(52.285,9.555),(52.455,9.555),(52.455,9.385),(52.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.725),(52.285,9.895),(52.455,9.895),(52.455,9.725),(52.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.865),(37.545,17.035),(37.715,17.035),(37.715,16.865),(37.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.845),(13.545,16.015),(13.715,16.015),(13.715,15.845),(13.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.845),(52.285,16.015),(52.455,16.015),(52.455,15.845),(52.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.885),(37.885,18.055),(38.055,18.055),(38.055,17.885),(37.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.865),(52.285,17.035),(52.455,17.035),(52.455,16.865),(52.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.465),(52.285,13.635),(52.455,13.635),(52.455,13.465),(52.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.805),(52.285,13.975),(52.455,13.975),(52.455,13.805),(52.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.125),(52.285,13.295),(52.455,13.295),(52.455,13.125),(52.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.965),(80.745,5.135),(80.915,5.135),(80.915,4.965),(80.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.125),(71.145,13.295),(71.315,13.295),(71.315,13.125),(71.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.285),(75.945,4.455),(76.115,4.455),(76.115,4.285),(75.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.625),(75.945,4.795),(76.115,4.795),(76.115,4.625),(75.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.985),(56.745,6.155),(56.915,6.155),(56.915,5.985),(56.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.325),(61.885,6.495),(62.055,6.495),(62.055,6.325),(61.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.665),(61.885,6.835),(62.055,6.835),(62.055,6.665),(61.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.085),(61.885,11.255),(62.055,11.255),(62.055,11.085),(61.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.425),(61.885,11.595),(62.055,11.595),(62.055,11.425),(61.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.765),(61.885,11.935),(62.055,11.935),(62.055,11.765),(61.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.985),(32.745,6.155),(32.915,6.155),(32.915,5.985),(32.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.085),(13.885,11.255),(14.055,11.255),(14.055,11.085),(13.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.765),(13.885,11.935),(14.055,11.935),(14.055,11.765),(13.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.225),(27.945,18.395),(28.115,18.395),(28.115,18.225),(27.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.565),(27.945,18.735),(28.115,18.735),(28.115,18.565),(27.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.425),(13.885,11.595),(14.055,11.595),(14.055,11.425),(13.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.245),(57.085,19.415),(57.255,19.415),(57.255,19.245),(57.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.025),(80.745,8.195),(80.915,8.195),(80.915,8.025),(80.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.365),(80.745,8.535),(80.915,8.535),(80.915,8.365),(80.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.705),(80.745,8.875),(80.915,8.875),(80.915,8.705),(80.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.245),(42.345,19.415),(42.515,19.415),(42.515,19.245),(42.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.245),(42.685,19.415),(42.855,19.415),(42.855,19.245),(42.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.185),(13.885,16.355),(14.055,16.355),(14.055,16.185),(13.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.525),(13.885,16.695),(14.055,16.695),(14.055,16.525),(13.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.445),(61.885,12.615),(62.055,12.615),(62.055,12.445),(61.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.785),(61.885,12.955),(62.055,12.955),(62.055,12.785),(61.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.105),(61.885,12.275),(62.055,12.275),(62.055,12.105),(61.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.505),(42.345,15.675),(42.515,15.675),(42.515,15.505),(42.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.505),(42.685,15.675),(42.855,15.675),(42.855,15.505),(42.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.165),(42.345,15.335),(42.515,15.335),(42.515,15.165),(42.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.165),(42.685,15.335),(42.855,15.335),(42.855,15.165),(42.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.925),(37.885,3.095),(38.055,3.095),(38.055,2.925),(37.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.045),(47.145,9.215),(47.315,9.215),(47.315,9.045),(47.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.045),(47.485,9.215),(47.655,9.215),(47.655,9.045),(47.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.505),(28.285,15.675),(28.455,15.675),(28.455,15.505),(28.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.165),(28.285,15.335),(28.455,15.335),(28.455,15.165),(28.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.305),(37.545,5.475),(37.715,5.475),(37.715,5.305),(37.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.645),(37.545,5.815),(37.715,5.815),(37.715,5.645),(37.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.185),(80.745,16.355),(80.915,16.355),(80.915,16.185),(80.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.525),(80.745,16.695),(80.915,16.695),(80.915,16.525),(80.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.965),(37.885,5.135),(38.055,5.135),(38.055,4.965),(37.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.765),(57.085,11.935),(57.255,11.935),(57.255,11.765),(57.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.865),(42.345,17.035),(42.515,17.035),(42.515,16.865),(42.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.085),(57.085,11.255),(57.255,11.255),(57.255,11.085),(57.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.425),(57.085,11.595),(57.255,11.595),(57.255,11.425),(57.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.865),(42.685,17.035),(42.855,17.035),(42.855,16.865),(42.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.745),(32.745,10.915),(32.915,10.915),(32.915,10.745),(32.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.065),(32.745,10.235),(32.915,10.235),(32.915,10.065),(32.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.145),(56.745,14.315),(56.915,14.315),(56.915,14.145),(56.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.485),(56.745,14.655),(56.915,14.655),(56.915,14.485),(56.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.825),(56.745,14.995),(56.915,14.995),(56.915,14.825),(56.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.405),(32.745,10.575),(32.915,10.575),(32.915,10.405),(32.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.165),(47.145,15.335),(47.315,15.335),(47.315,15.165),(47.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.165),(47.485,15.335),(47.655,15.335),(47.655,15.165),(47.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.505),(47.485,15.675),(47.655,15.675),(47.655,15.505),(47.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.505),(47.145,15.675),(47.315,15.675),(47.315,15.505),(47.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.545),(66.685,17.715),(66.855,17.715),(66.855,17.545),(66.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.205),(66.345,17.375),(66.515,17.375),(66.515,17.205),(66.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.765),(9.085,11.935),(9.255,11.935),(9.255,11.765),(9.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.425),(9.085,11.595),(9.255,11.595),(9.255,11.425),(9.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.205),(66.685,17.375),(66.855,17.375),(66.855,17.205),(66.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.545),(66.345,17.715),(66.515,17.715),(66.515,17.545),(66.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.085),(9.085,11.255),(9.255,11.255),(9.255,11.085),(9.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.485),(8.745,14.655),(8.915,14.655),(8.915,14.485),(8.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.825),(8.745,14.995),(8.915,14.995),(8.915,14.825),(8.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.145),(8.745,14.315),(8.915,14.315),(8.915,14.145),(8.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.865),(57.085,17.035),(57.255,17.035),(57.255,16.865),(57.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.945),(13.885,4.115),(14.055,4.115),(14.055,3.945),(13.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.265),(71.145,3.435),(71.315,3.435),(71.315,3.265),(71.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.265),(71.485,3.435),(71.655,3.435),(71.655,3.265),(71.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.605),(71.145,3.775),(71.315,3.775),(71.315,3.605),(71.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.605),(71.485,3.775),(71.655,3.775),(71.655,3.605),(71.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.525),(18.345,16.695),(18.515,16.695),(18.515,16.525),(18.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.525),(18.685,16.695),(18.855,16.695),(18.855,16.525),(18.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.185),(18.345,16.355),(18.515,16.355),(18.515,16.185),(18.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.185),(18.685,16.355),(18.855,16.355),(18.855,16.185),(18.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.385),(61.545,9.555),(61.715,9.555),(61.715,9.385),(61.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.725),(61.545,9.895),(61.715,9.895),(61.715,9.725),(61.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.265),(47.145,3.435),(47.315,3.435),(47.315,3.265),(47.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.265),(47.485,3.435),(47.655,3.435),(47.655,3.265),(47.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.605),(47.145,3.775),(47.315,3.775),(47.315,3.605),(47.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.605),(47.485,3.775),(47.655,3.775),(47.655,3.605),(47.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.265),(23.485,3.435),(23.655,3.435),(23.655,3.265),(23.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.265),(23.145,3.435),(23.315,3.435),(23.315,3.265),(23.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.605),(23.145,3.775),(23.315,3.775),(23.315,3.605),(23.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.905),(47.145,19.075),(47.315,19.075),(47.315,18.905),(47.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.905),(47.485,19.075),(47.655,19.075),(47.655,18.905),(47.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.605),(23.485,3.775),(23.655,3.775),(23.655,3.605),(23.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.725),(13.545,9.895),(13.715,9.895),(13.715,9.725),(13.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.385),(13.545,9.555),(13.715,9.555),(13.715,9.385),(13.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.245),(13.885,19.415),(14.055,19.415),(14.055,19.245),(13.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.065),(80.745,10.235),(80.915,10.235),(80.915,10.065),(80.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.405),(80.745,10.575),(80.915,10.575),(80.915,10.405),(80.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.045),(33.085,9.215),(33.255,9.215),(33.255,9.045),(33.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.745),(80.745,10.915),(80.915,10.915),(80.915,10.745),(80.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.905),(37.545,19.075),(37.715,19.075),(37.715,18.905),(37.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.725),(76.285,9.895),(76.455,9.895),(76.455,9.725),(76.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.385),(76.285,9.555),(76.455,9.555),(76.455,9.385),(76.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.885),(18.345,18.055),(18.515,18.055),(18.515,17.885),(18.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.885),(18.685,18.055),(18.855,18.055),(18.855,17.885),(18.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.305),(18.345,5.475),(18.515,5.475),(18.515,5.305),(18.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.645),(18.345,5.815),(18.515,5.815),(18.515,5.645),(18.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.645),(18.685,5.815),(18.855,5.815),(18.855,5.645),(18.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.305),(18.685,5.475),(18.855,5.475),(18.855,5.305),(18.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.385),(28.285,9.555),(28.455,9.555),(28.455,9.385),(28.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.725),(28.285,9.895),(28.455,9.895),(28.455,9.725),(28.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.885),(51.945,18.055),(52.115,18.055),(52.115,17.885),(51.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.565),(66.685,18.735),(66.855,18.735),(66.855,18.565),(66.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.225),(66.345,18.395),(66.515,18.395),(66.515,18.225),(66.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.225),(66.685,18.395),(66.855,18.395),(66.855,18.225),(66.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.565),(66.345,18.735),(66.515,18.735),(66.515,18.565),(66.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.845),(28.285,16.015),(28.455,16.015),(28.455,15.845),(28.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.125),(76.285,13.295),(76.455,13.295),(76.455,13.125),(76.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.465),(76.285,13.635),(76.455,13.635),(76.455,13.465),(76.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.805),(76.285,13.975),(76.455,13.975),(76.455,13.805),(76.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.265),(61.545,3.435),(61.715,3.435),(61.715,3.265),(61.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.605),(61.545,3.775),(61.715,3.775),(61.715,3.605),(61.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.845),(37.885,16.015),(38.055,16.015),(38.055,15.845),(37.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.125),(28.285,13.295),(28.455,13.295),(28.455,13.125),(28.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.465),(28.285,13.635),(28.455,13.635),(28.455,13.465),(28.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.805),(28.285,13.975),(28.455,13.975),(28.455,13.805),(28.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.265),(13.545,3.435),(13.715,3.435),(13.715,3.265),(13.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.605),(13.545,3.775),(13.715,3.775),(13.715,3.605),(13.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.305),(57.085,5.475),(57.255,5.475),(57.255,5.305),(57.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.645),(57.085,5.815),(57.255,5.815),(57.255,5.645),(57.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.225),(23.145,18.395),(23.315,18.395),(23.315,18.225),(23.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.225),(23.485,18.395),(23.655,18.395),(23.655,18.225),(23.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.565),(23.145,18.735),(23.315,18.735),(23.315,18.565),(23.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.565),(23.485,18.735),(23.655,18.735),(23.655,18.565),(23.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.305),(33.085,5.475),(33.255,5.475),(33.255,5.305),(33.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.645),(33.085,5.815),(33.255,5.815),(33.255,5.645),(33.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.105),(80.745,12.275),(80.915,12.275),(80.915,12.105),(80.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.445),(80.745,12.615),(80.915,12.615),(80.915,12.445),(80.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.305),(9.085,5.475),(9.255,5.475),(9.255,5.305),(9.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.645),(9.085,5.815),(9.255,5.815),(9.255,5.645),(9.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.785),(80.745,12.955),(80.915,12.955),(80.915,12.785),(80.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.205),(9.085,17.375),(9.255,17.375),(9.255,17.205),(9.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.545),(9.085,17.715),(9.255,17.715),(9.255,17.545),(9.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.105),(42.345,12.275),(42.515,12.275),(42.515,12.105),(42.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.105),(42.685,12.275),(42.855,12.275),(42.855,12.105),(42.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.185),(61.545,16.355),(61.715,16.355),(61.715,16.185),(61.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.525),(61.545,16.695),(61.715,16.695),(61.715,16.525),(61.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.445),(42.345,12.615),(42.515,12.615),(42.515,12.445),(42.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.445),(42.685,12.615),(42.855,12.615),(42.855,12.445),(42.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.785),(42.345,12.955),(42.515,12.955),(42.515,12.785),(42.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.785),(42.685,12.955),(42.855,12.955),(42.855,12.785),(42.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.785),(23.485,12.955),(23.655,12.955),(23.655,12.785),(23.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.205),(61.885,17.375),(62.055,17.375),(62.055,17.205),(61.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.545),(61.885,17.715),(62.055,17.715),(62.055,17.545),(61.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.205),(80.745,17.375),(80.915,17.375),(80.915,17.205),(80.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.545),(80.745,17.715),(80.915,17.715),(80.915,17.545),(80.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.225),(32.745,18.395),(32.915,18.395),(32.915,18.225),(32.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.565),(32.745,18.735),(32.915,18.735),(32.915,18.565),(32.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.385),(23.145,9.555),(23.315,9.555),(23.315,9.385),(23.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.385),(23.485,9.555),(23.655,9.555),(23.655,9.385),(23.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.725),(23.145,9.895),(23.315,9.895),(23.315,9.725),(23.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.725),(23.485,9.895),(23.655,9.895),(23.655,9.725),(23.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.385),(37.885,9.555),(38.055,9.555),(38.055,9.385),(37.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.725),(37.885,9.895),(38.055,9.895),(38.055,9.725),(37.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.865),(27.945,17.035),(28.115,17.035),(28.115,16.865),(27.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.945),(37.885,4.115),(38.055,4.115),(38.055,3.945),(37.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,2.925),(75.945,3.095),(76.115,3.095),(76.115,2.925),(75.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,2.925),(27.945,3.095),(28.115,3.095),(28.115,2.925),(27.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.865),(32.745,17.035),(32.915,17.035),(32.915,16.865),(32.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.225),(61.885,18.395),(62.055,18.395),(62.055,18.225),(61.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.565),(61.885,18.735),(62.055,18.735),(62.055,18.565),(61.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.505),(76.285,15.675),(76.455,15.675),(76.455,15.505),(76.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.165),(76.285,15.335),(76.455,15.335),(76.455,15.165),(76.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.545),(76.285,17.715),(76.455,17.715),(76.455,17.545),(76.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.205),(76.285,17.375),(76.455,17.375),(76.455,17.205),(76.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.805),(23.485,13.975),(23.655,13.975),(23.655,13.805),(23.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.465),(23.145,13.635),(23.315,13.635),(23.315,13.465),(23.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.465),(23.485,13.635),(23.655,13.635),(23.655,13.465),(23.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.805),(23.145,13.975),(23.315,13.975),(23.315,13.805),(23.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.125),(23.145,13.295),(23.315,13.295),(23.315,13.125),(23.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.125),(23.485,13.295),(23.655,13.295),(23.655,13.125),(23.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,2.925),(9.085,3.095),(9.255,3.095),(9.255,2.925),(9.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.945),(37.545,4.115),(37.715,4.115),(37.715,3.945),(37.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.645),(80.745,5.815),(80.915,5.815),(80.915,5.645),(80.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.305),(80.745,5.475),(80.915,5.475),(80.915,5.305),(80.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.565),(33.085,18.735),(33.255,18.735),(33.255,18.565),(33.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.225),(33.085,18.395),(33.255,18.395),(33.255,18.225),(33.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.145),(66.345,14.315),(66.515,14.315),(66.515,14.145),(66.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.145),(66.685,14.315),(66.855,14.315),(66.855,14.145),(66.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.485),(66.345,14.655),(66.515,14.655),(66.515,14.485),(66.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.485),(66.685,14.655),(66.855,14.655),(66.855,14.485),(66.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.825),(66.345,14.995),(66.515,14.995),(66.515,14.825),(66.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.825),(66.685,14.995),(66.855,14.995),(66.855,14.825),(66.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.985),(61.885,6.155),(62.055,6.155),(62.055,5.985),(61.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.985),(13.885,6.155),(14.055,6.155),(14.055,5.985),(13.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.165),(32.745,15.335),(32.915,15.335),(32.915,15.165),(32.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.505),(32.745,15.675),(32.915,15.675),(32.915,15.505),(32.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.265),(42.345,3.435),(42.515,3.435),(42.515,3.265),(42.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.265),(42.685,3.435),(42.855,3.435),(42.855,3.265),(42.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.605),(42.685,3.775),(42.855,3.775),(42.855,3.605),(42.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.605),(42.345,3.775),(42.515,3.775),(42.515,3.605),(42.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.405),(9.085,10.575),(9.255,10.575),(9.255,10.405),(9.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.065),(9.085,10.235),(9.255,10.235),(9.255,10.065),(9.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.565),(28.285,18.735),(28.455,18.735),(28.455,18.565),(28.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.745),(9.085,10.915),(9.255,10.915),(9.255,10.745),(9.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.225),(28.285,18.395),(28.455,18.395),(28.455,18.225),(28.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.925),(56.745,3.095),(56.915,3.095),(56.915,2.925),(56.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.045),(51.945,9.215),(52.115,9.215),(52.115,9.045),(51.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.925),(32.745,3.095),(32.915,3.095),(32.915,2.925),(32.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.965),(51.945,5.135),(52.115,5.135),(52.115,4.965),(51.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.125),(71.485,13.295),(71.655,13.295),(71.655,13.125),(71.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,2.925),(8.745,3.095),(8.915,3.095),(8.915,2.925),(8.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.305),(56.745,5.475),(56.915,5.475),(56.915,5.305),(56.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.865),(9.085,17.035),(9.255,17.035),(9.255,16.865),(9.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.645),(56.745,5.815),(56.915,5.815),(56.915,5.645),(56.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.225),(75.945,18.395),(76.115,18.395),(76.115,18.225),(75.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.565),(75.945,18.735),(76.115,18.735),(76.115,18.565),(75.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.305),(32.745,5.475),(32.915,5.475),(32.915,5.305),(32.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.645),(32.745,5.815),(32.915,5.815),(32.915,5.645),(32.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.825),(18.345,14.995),(18.515,14.995),(18.515,14.825),(18.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.485),(18.345,14.655),(18.515,14.655),(18.515,14.485),(18.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.485),(18.685,14.655),(18.855,14.655),(18.855,14.485),(18.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.825),(18.685,14.995),(18.855,14.995),(18.855,14.825),(18.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.145),(18.345,14.315),(18.515,14.315),(18.515,14.145),(18.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.145),(18.685,14.315),(18.855,14.315),(18.855,14.145),(18.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,2.925),(28.285,3.095),(28.455,3.095),(28.455,2.925),(28.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.265),(18.345,3.435),(18.515,3.435),(18.515,3.265),(18.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.265),(18.685,3.435),(18.855,3.435),(18.855,3.265),(18.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.605),(18.685,3.775),(18.855,3.775),(18.855,3.605),(18.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.605),(18.345,3.775),(18.515,3.775),(18.515,3.605),(18.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.925),(57.085,3.095),(57.255,3.095),(57.255,2.925),(57.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,2.925),(80.745,3.095),(80.915,3.095),(80.915,2.925),(80.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.245),(9.085,19.415),(9.255,19.415),(9.255,19.245),(9.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.925),(33.085,3.095),(33.255,3.095),(33.255,2.925),(33.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.225),(61.545,18.395),(61.715,18.395),(61.715,18.225),(61.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.565),(61.545,18.735),(61.715,18.735),(61.715,18.565),(61.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.265),(61.885,3.435),(62.055,3.435),(62.055,3.265),(61.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.605),(61.885,3.775),(62.055,3.775),(62.055,3.605),(61.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.045),(81.085,9.215),(81.255,9.215),(81.255,9.045),(81.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.845),(76.285,16.015),(76.455,16.015),(76.455,15.845),(76.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.285),(37.545,4.455),(37.715,4.455),(37.715,4.285),(37.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.625),(37.545,4.795),(37.715,4.795),(37.715,4.625),(37.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.845),(61.885,16.015),(62.055,16.015),(62.055,15.845),(61.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.405),(37.545,10.575),(37.715,10.575),(37.715,10.405),(37.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.065),(37.545,10.235),(37.715,10.235),(37.715,10.065),(37.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.745),(37.545,10.915),(37.715,10.915),(37.715,10.745),(37.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.265),(13.885,3.435),(14.055,3.435),(14.055,3.265),(13.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.605),(13.885,3.775),(14.055,3.775),(14.055,3.605),(13.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.365),(42.345,8.535),(42.515,8.535),(42.515,8.365),(42.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.365),(42.685,8.535),(42.855,8.535),(42.855,8.365),(42.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.705),(42.345,8.875),(42.515,8.875),(42.515,8.705),(42.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.705),(42.685,8.875),(42.855,8.875),(42.855,8.705),(42.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.025),(42.345,8.195),(42.515,8.195),(42.515,8.025),(42.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.025),(42.685,8.195),(42.855,8.195),(42.855,8.025),(42.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.845),(13.885,16.015),(14.055,16.015),(14.055,15.845),(13.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.065),(42.345,10.235),(42.515,10.235),(42.515,10.065),(42.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.065),(42.685,10.235),(42.855,10.235),(42.855,10.065),(42.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.405),(42.345,10.575),(42.515,10.575),(42.515,10.405),(42.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.405),(42.685,10.575),(42.855,10.575),(42.855,10.405),(42.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.745),(42.345,10.915),(42.515,10.915),(42.515,10.745),(42.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.745),(42.685,10.915),(42.855,10.915),(42.855,10.745),(42.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.825),(47.485,14.995),(47.655,14.995),(47.655,14.825),(47.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.485),(47.485,14.655),(47.655,14.655),(47.655,14.485),(47.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.485),(47.145,14.655),(47.315,14.655),(47.315,14.485),(47.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.825),(47.145,14.995),(47.315,14.995),(47.315,14.825),(47.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.145),(47.145,14.315),(47.315,14.315),(47.315,14.145),(47.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.145),(47.485,14.315),(47.655,14.315),(47.655,14.145),(47.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.405),(57.085,10.575),(57.255,10.575),(57.255,10.405),(57.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.065),(57.085,10.235),(57.255,10.235),(57.255,10.065),(57.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.745),(57.085,10.915),(57.255,10.915),(57.255,10.745),(57.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.945),(42.345,4.115),(42.515,4.115),(42.515,3.945),(42.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.945),(42.685,4.115),(42.855,4.115),(42.855,3.945),(42.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.285),(9.085,4.455),(9.255,4.455),(9.255,4.285),(9.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.625),(9.085,4.795),(9.255,4.795),(9.255,4.625),(9.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.045),(27.945,9.215),(28.115,9.215),(28.115,9.045),(27.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.385),(61.885,9.555),(62.055,9.555),(62.055,9.385),(61.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.725),(61.885,9.895),(62.055,9.895),(62.055,9.725),(61.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.385),(71.485,9.555),(71.655,9.555),(71.655,9.385),(71.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.725),(71.145,9.895),(71.315,9.895),(71.315,9.725),(71.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.725),(71.485,9.895),(71.655,9.895),(71.655,9.725),(71.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.385),(71.145,9.555),(71.315,9.555),(71.315,9.385),(71.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.685),(28.285,7.855),(28.455,7.855),(28.455,7.685),(28.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.725),(13.885,9.895),(14.055,9.895),(14.055,9.725),(13.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.525),(56.745,16.695),(56.915,16.695),(56.915,16.525),(56.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.185),(56.745,16.355),(56.915,16.355),(56.915,16.185),(56.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.385),(13.885,9.555),(14.055,9.555),(14.055,9.385),(13.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.165),(33.085,15.335),(33.255,15.335),(33.255,15.165),(33.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.505),(33.085,15.675),(33.255,15.675),(33.255,15.505),(33.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.165),(80.745,15.335),(80.915,15.335),(80.915,15.165),(80.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.505),(80.745,15.675),(80.915,15.675),(80.915,15.505),(80.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.065),(52.285,10.235),(52.455,10.235),(52.455,10.065),(52.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.405),(52.285,10.575),(52.455,10.575),(52.455,10.405),(52.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.745),(52.285,10.915),(52.455,10.915),(52.455,10.745),(52.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.285),(81.085,4.455),(81.255,4.455),(81.255,4.285),(81.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.625),(81.085,4.795),(81.255,4.795),(81.255,4.625),(81.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.185),(13.545,16.355),(13.715,16.355),(13.715,16.185),(13.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.525),(13.545,16.695),(13.715,16.695),(13.715,16.525),(13.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.805),(71.485,13.975),(71.655,13.975),(71.655,13.805),(71.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.465),(71.145,13.635),(71.315,13.635),(71.315,13.465),(71.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.465),(71.485,13.635),(71.655,13.635),(71.655,13.465),(71.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.805),(71.145,13.975),(71.315,13.975),(71.315,13.805),(71.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.445),(71.145,12.615),(71.315,12.615),(71.315,12.445),(71.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.445),(71.485,12.615),(71.655,12.615),(71.655,12.445),(71.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.785),(71.485,12.955),(71.655,12.955),(71.655,12.785),(71.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.785),(71.145,12.955),(71.315,12.955),(71.315,12.785),(71.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.105),(71.145,12.275),(71.315,12.275),(71.315,12.105),(71.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.105),(71.485,12.275),(71.655,12.275),(71.655,12.105),(71.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.185),(28.285,16.355),(28.455,16.355),(28.455,16.185),(28.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.945),(18.685,4.115),(18.855,4.115),(18.855,3.945),(18.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.525),(28.285,16.695),(28.455,16.695),(28.455,16.525),(28.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.945),(18.345,4.115),(18.515,4.115),(18.515,3.945),(18.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.405),(13.545,10.575),(13.715,10.575),(13.715,10.405),(13.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.745),(13.545,10.915),(13.715,10.915),(13.715,10.745),(13.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.465),(42.345,13.635),(42.515,13.635),(42.515,13.465),(42.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.465),(42.685,13.635),(42.855,13.635),(42.855,13.465),(42.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.805),(42.345,13.975),(42.515,13.975),(42.515,13.805),(42.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.805),(42.685,13.975),(42.855,13.975),(42.855,13.805),(42.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.105),(23.145,12.275),(23.315,12.275),(23.315,12.105),(23.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.105),(23.485,12.275),(23.655,12.275),(23.655,12.105),(23.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.065),(13.545,10.235),(13.715,10.235),(13.715,10.065),(13.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.125),(42.345,13.295),(42.515,13.295),(42.515,13.125),(42.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.125),(42.685,13.295),(42.855,13.295),(42.855,13.125),(42.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.945),(52.285,4.115),(52.455,4.115),(52.455,3.945),(52.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.165),(81.085,15.335),(81.255,15.335),(81.255,15.165),(81.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.985),(71.145,6.155),(71.315,6.155),(71.315,5.985),(71.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.985),(71.485,6.155),(71.655,6.155),(71.655,5.985),(71.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.505),(81.085,15.675),(81.255,15.675),(81.255,15.505),(81.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.945),(8.745,4.115),(8.915,4.115),(8.915,3.945),(8.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.545),(18.685,17.715),(18.855,17.715),(18.855,17.545),(18.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.205),(18.345,17.375),(18.515,17.375),(18.515,17.205),(18.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.205),(18.685,17.375),(18.855,17.375),(18.855,17.205),(18.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.545),(18.345,17.715),(18.515,17.715),(18.515,17.545),(18.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.225),(13.885,18.395),(14.055,18.395),(14.055,18.225),(13.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.565),(13.885,18.735),(14.055,18.735),(14.055,18.565),(13.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.285),(57.085,4.455),(57.255,4.455),(57.255,4.285),(57.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.625),(57.085,4.795),(57.255,4.795),(57.255,4.625),(57.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,2.925),(81.085,3.095),(81.255,3.095),(81.255,2.925),(81.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.285),(33.085,4.455),(33.255,4.455),(33.255,4.285),(33.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.625),(33.085,4.795),(33.255,4.795),(33.255,4.625),(33.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.305),(75.945,5.475),(76.115,5.475),(76.115,5.305),(75.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.645),(75.945,5.815),(76.115,5.815),(76.115,5.645),(75.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.165),(9.085,15.335),(9.255,15.335),(9.255,15.165),(9.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.325),(51.945,6.495),(52.115,6.495),(52.115,6.325),(51.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.665),(51.945,6.835),(52.115,6.835),(52.115,6.665),(51.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.885),(81.085,18.055),(81.255,18.055),(81.255,17.885),(81.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.905),(51.945,19.075),(52.115,19.075),(52.115,18.905),(51.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.745),(28.285,10.915),(28.455,10.915),(28.455,10.745),(28.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.065),(28.285,10.235),(28.455,10.235),(28.455,10.065),(28.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.885),(23.145,18.055),(23.315,18.055),(23.315,17.885),(23.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.885),(23.485,18.055),(23.655,18.055),(23.655,17.885),(23.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.405),(28.285,10.575),(28.455,10.575),(28.455,10.405),(28.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.905),(42.345,19.075),(42.515,19.075),(42.515,18.905),(42.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.905),(42.685,19.075),(42.855,19.075),(42.855,18.905),(42.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,2.925),(76.285,3.095),(76.455,3.095),(76.455,2.925),(76.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.005),(42.345,7.175),(42.515,7.175),(42.515,7.005),(42.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.005),(42.685,7.175),(42.855,7.175),(42.855,7.005),(42.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.805),(57.085,13.975),(57.255,13.975),(57.255,13.805),(57.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.465),(57.085,13.635),(57.255,13.635),(57.255,13.465),(57.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.125),(57.085,13.295),(57.255,13.295),(57.255,13.125),(57.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.345),(42.685,7.515),(42.855,7.515),(42.855,7.345),(42.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.065),(61.545,10.235),(61.715,10.235),(61.715,10.065),(61.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.405),(61.545,10.575),(61.715,10.575),(61.715,10.405),(61.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.745),(61.545,10.915),(61.715,10.915),(61.715,10.745),(61.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.345),(42.345,7.515),(42.515,7.515),(42.515,7.345),(42.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.205),(13.885,17.375),(14.055,17.375),(14.055,17.205),(13.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.545),(13.885,17.715),(14.055,17.715),(14.055,17.545),(13.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.225),(18.345,18.395),(18.515,18.395),(18.515,18.225),(18.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.225),(18.685,18.395),(18.855,18.395),(18.855,18.225),(18.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.565),(18.685,18.735),(18.855,18.735),(18.855,18.565),(18.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.565),(18.345,18.735),(18.515,18.735),(18.515,18.565),(18.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.125),(9.085,13.295),(9.255,13.295),(9.255,13.125),(9.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.465),(9.085,13.635),(9.255,13.635),(9.255,13.465),(9.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.805),(9.085,13.975),(9.255,13.975),(9.255,13.805),(9.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.945),(56.745,4.115),(56.915,4.115),(56.915,3.945),(56.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.865),(47.485,17.035),(47.655,17.035),(47.655,16.865),(47.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.865),(47.145,17.035),(47.315,17.035),(47.315,16.865),(47.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.945),(32.745,4.115),(32.915,4.115),(32.915,3.945),(32.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.885),(56.745,18.055),(56.915,18.055),(56.915,17.885),(56.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.685),(71.145,7.855),(71.315,7.855),(71.315,7.685),(71.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.685),(71.485,7.855),(71.655,7.855),(71.655,7.685),(71.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.345),(47.485,7.515),(47.655,7.515),(47.655,7.345),(47.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.345),(47.145,7.515),(47.315,7.515),(47.315,7.345),(47.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.005),(47.145,7.175),(47.315,7.175),(47.315,7.005),(47.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.005),(47.485,7.175),(47.655,7.175),(47.655,7.005),(47.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.685),(47.145,7.855),(47.315,7.855),(47.315,7.685),(47.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.365),(51.945,8.535),(52.115,8.535),(52.115,8.365),(51.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.705),(51.945,8.875),(52.115,8.875),(52.115,8.705),(51.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.025),(51.945,8.195),(52.115,8.195),(52.115,8.025),(51.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.965),(52.285,5.135),(52.455,5.135),(52.455,4.965),(52.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.685),(47.485,7.855),(47.655,7.855),(47.655,7.685),(47.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.685),(23.145,7.855),(23.315,7.855),(23.315,7.685),(23.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.685),(23.485,7.855),(23.655,7.855),(23.655,7.685),(23.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.005),(23.145,7.175),(23.315,7.175),(23.315,7.005),(23.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.005),(23.485,7.175),(23.655,7.175),(23.655,7.005),(23.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.345),(23.145,7.515),(23.315,7.515),(23.315,7.345),(23.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.345),(23.485,7.515),(23.655,7.515),(23.655,7.345),(23.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.165),(51.945,15.335),(52.115,15.335),(52.115,15.165),(51.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.505),(51.945,15.675),(52.115,15.675),(52.115,15.505),(51.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.225),(13.545,18.395),(13.715,18.395),(13.715,18.225),(13.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.565),(13.545,18.735),(13.715,18.735),(13.715,18.565),(13.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.225),(80.745,18.395),(80.915,18.395),(80.915,18.225),(80.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.565),(80.745,18.735),(80.915,18.735),(80.915,18.565),(80.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.365),(9.085,8.535),(9.255,8.535),(9.255,8.365),(9.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.705),(9.085,8.875),(9.255,8.875),(9.255,8.705),(9.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.025),(9.085,8.195),(9.255,8.195),(9.255,8.025),(9.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.045),(75.945,9.215),(76.115,9.215),(76.115,9.045),(75.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.005),(18.345,7.175),(18.515,7.175),(18.515,7.005),(18.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.005),(18.685,7.175),(18.855,7.175),(18.855,7.005),(18.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.345),(18.345,7.515),(18.515,7.515),(18.515,7.345),(18.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.345),(18.685,7.515),(18.855,7.515),(18.855,7.345),(18.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.685),(18.345,7.855),(18.515,7.855),(18.515,7.685),(18.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.685),(18.685,7.855),(18.855,7.855),(18.855,7.685),(18.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.685),(76.285,7.855),(76.455,7.855),(76.455,7.685),(76.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.345),(76.285,7.515),(76.455,7.515),(76.455,7.345),(76.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.005),(76.285,7.175),(76.455,7.175),(76.455,7.005),(76.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.985),(61.545,6.155),(61.715,6.155),(61.715,5.985),(61.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.425),(71.145,11.595),(71.315,11.595),(71.315,11.425),(71.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.425),(71.485,11.595),(71.655,11.595),(71.655,11.425),(71.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.765),(71.145,11.935),(71.315,11.935),(71.315,11.765),(71.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.765),(71.485,11.935),(71.655,11.935),(71.655,11.765),(71.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.005),(37.545,7.175),(37.715,7.175),(37.715,7.005),(37.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.345),(37.545,7.515),(37.715,7.515),(37.715,7.345),(37.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.085),(71.145,11.255),(71.315,11.255),(71.315,11.085),(71.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.085),(71.485,11.255),(71.655,11.255),(71.655,11.085),(71.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.205),(27.945,17.375),(28.115,17.375),(28.115,17.205),(27.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.545),(27.945,17.715),(28.115,17.715),(28.115,17.545),(27.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.265),(75.945,3.435),(76.115,3.435),(76.115,3.265),(75.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.605),(75.945,3.775),(76.115,3.775),(76.115,3.605),(75.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.985),(13.545,6.155),(13.715,6.155),(13.715,5.985),(13.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.425),(23.485,11.595),(23.655,11.595),(23.655,11.425),(23.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.425),(23.145,11.595),(23.315,11.595),(23.315,11.425),(23.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.765),(23.145,11.935),(23.315,11.935),(23.315,11.765),(23.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.765),(23.485,11.935),(23.655,11.935),(23.655,11.765),(23.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.085),(23.145,11.255),(23.315,11.255),(23.315,11.085),(23.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.085),(23.485,11.255),(23.655,11.255),(23.655,11.085),(23.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.205),(37.545,17.375),(37.715,17.375),(37.715,17.205),(37.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.545),(37.545,17.715),(37.715,17.715),(37.715,17.545),(37.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.045),(42.345,9.215),(42.515,9.215),(42.515,9.045),(42.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.045),(42.685,9.215),(42.855,9.215),(42.855,9.045),(42.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.185),(23.145,16.355),(23.315,16.355),(23.315,16.185),(23.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.185),(23.485,16.355),(23.655,16.355),(23.655,16.185),(23.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.525),(23.145,16.695),(23.315,16.695),(23.315,16.525),(23.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.525),(23.485,16.695),(23.655,16.695),(23.655,16.525),(23.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.345),(61.545,7.515),(61.715,7.515),(61.715,7.345),(61.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.685),(61.545,7.855),(61.715,7.855),(61.715,7.685),(61.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.005),(61.545,7.175),(61.715,7.175),(61.715,7.005),(61.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.765),(42.345,11.935),(42.515,11.935),(42.515,11.765),(42.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.765),(42.685,11.935),(42.855,11.935),(42.855,11.765),(42.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.425),(42.345,11.595),(42.515,11.595),(42.515,11.425),(42.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.425),(42.685,11.595),(42.855,11.595),(42.855,11.425),(42.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.865),(37.885,17.035),(38.055,17.035),(38.055,16.865),(37.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.085),(42.345,11.255),(42.515,11.255),(42.515,11.085),(42.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.085),(42.685,11.255),(42.855,11.255),(42.855,11.085),(42.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.685),(13.545,7.855),(13.715,7.855),(13.715,7.685),(13.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.285),(18.685,4.455),(18.855,4.455),(18.855,4.285),(18.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.625),(18.345,4.795),(18.515,4.795),(18.515,4.625),(18.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.285),(18.345,4.455),(18.515,4.455),(18.515,4.285),(18.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.625),(18.685,4.795),(18.855,4.795),(18.855,4.625),(18.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.985),(28.285,6.155),(28.455,6.155),(28.455,5.985),(28.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.505),(75.945,15.675),(76.115,15.675),(76.115,15.505),(75.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.245),(28.285,19.415),(28.455,19.415),(28.455,19.245),(28.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.165),(75.945,15.335),(76.115,15.335),(76.115,15.165),(75.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.325),(76.285,6.495),(76.455,6.495),(76.455,6.325),(76.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.665),(76.285,6.835),(76.455,6.835),(76.455,6.665),(76.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.165),(27.945,15.335),(28.115,15.335),(28.115,15.165),(27.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.865),(66.345,17.035),(66.515,17.035),(66.515,16.865),(66.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.505),(27.945,15.675),(28.115,15.675),(28.115,15.505),(27.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.865),(66.685,17.035),(66.855,17.035),(66.855,16.865),(66.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.945),(76.285,4.115),(76.455,4.115),(76.455,3.945),(76.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.365),(57.085,8.535),(57.255,8.535),(57.255,8.365),(57.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.705),(57.085,8.875),(57.255,8.875),(57.255,8.705),(57.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.025),(57.085,8.195),(57.255,8.195),(57.255,8.025),(57.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.445),(23.485,12.615),(23.655,12.615),(23.655,12.445),(23.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.285),(42.345,4.455),(42.515,4.455),(42.515,4.285),(42.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.285),(42.685,4.455),(42.855,4.455),(42.855,4.285),(42.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.625),(42.345,4.795),(42.515,4.795),(42.515,4.625),(42.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.625),(42.685,4.795),(42.855,4.795),(42.855,4.625),(42.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.945),(80.745,4.115),(80.915,4.115),(80.915,3.945),(80.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.205),(33.085,17.375),(33.255,17.375),(33.255,17.205),(33.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.545),(33.085,17.715),(33.255,17.715),(33.255,17.545),(33.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.225),(71.145,18.395),(71.315,18.395),(71.315,18.225),(71.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.225),(71.485,18.395),(71.655,18.395),(71.655,18.225),(71.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.565),(71.145,18.735),(71.315,18.735),(71.315,18.565),(71.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.565),(71.485,18.735),(71.655,18.735),(71.655,18.565),(71.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.265),(51.945,3.435),(52.115,3.435),(52.115,3.265),(51.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.605),(51.945,3.775),(52.115,3.775),(52.115,3.605),(51.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.465),(51.945,13.635),(52.115,13.635),(52.115,13.465),(51.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.805),(51.945,13.975),(52.115,13.975),(52.115,13.805),(51.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.125),(51.945,13.295),(52.115,13.295),(52.115,13.125),(51.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.065),(76.285,10.235),(76.455,10.235),(76.455,10.065),(76.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.405),(76.285,10.575),(76.455,10.575),(76.455,10.405),(76.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.745),(76.285,10.915),(76.455,10.915),(76.455,10.745),(76.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.165),(37.885,15.335),(38.055,15.335),(38.055,15.165),(37.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.505),(37.885,15.675),(38.055,15.675),(38.055,15.505),(37.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.425),(8.745,11.595),(8.915,11.595),(8.915,11.425),(8.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.085),(8.745,11.255),(8.915,11.255),(8.915,11.085),(8.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.485),(33.085,14.655),(33.255,14.655),(33.255,14.485),(33.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.825),(33.085,14.995),(33.255,14.995),(33.255,14.825),(33.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.145),(33.085,14.315),(33.255,14.315),(33.255,14.145),(33.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.765),(8.745,11.935),(8.915,11.935),(8.915,11.765),(8.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.225),(81.085,18.395),(81.255,18.395),(81.255,18.225),(81.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.565),(81.085,18.735),(81.255,18.735),(81.255,18.565),(81.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.245),(66.345,19.415),(66.515,19.415),(66.515,19.245),(66.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.245),(66.685,19.415),(66.855,19.415),(66.855,19.245),(66.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.245),(56.745,19.415),(56.915,19.415),(56.915,19.245),(56.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.005),(66.345,7.175),(66.515,7.175),(66.515,7.005),(66.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.005),(66.685,7.175),(66.855,7.175),(66.855,7.005),(66.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.345),(66.345,7.515),(66.515,7.515),(66.515,7.345),(66.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.345),(66.685,7.515),(66.855,7.515),(66.855,7.345),(66.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.685),(66.345,7.855),(66.515,7.855),(66.515,7.685),(66.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.685),(66.685,7.855),(66.855,7.855),(66.855,7.685),(66.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.865),(75.945,17.035),(76.115,17.035),(76.115,16.865),(75.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.185),(8.745,16.355),(8.915,16.355),(8.915,16.185),(8.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.525),(8.745,16.695),(8.915,16.695),(8.915,16.525),(8.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.105),(9.085,12.275),(9.255,12.275),(9.255,12.105),(9.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.445),(9.085,12.615),(9.255,12.615),(9.255,12.445),(9.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.785),(9.085,12.955),(9.255,12.955),(9.255,12.785),(9.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.185),(76.285,16.355),(76.455,16.355),(76.455,16.185),(76.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.525),(76.285,16.695),(76.455,16.695),(76.455,16.525),(76.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.365),(27.945,8.535),(28.115,8.535),(28.115,8.365),(27.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.705),(27.945,8.875),(28.115,8.875),(28.115,8.705),(27.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.025),(27.945,8.195),(28.115,8.195),(28.115,8.025),(27.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.245),(47.145,19.415),(47.315,19.415),(47.315,19.245),(47.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.245),(47.485,19.415),(47.655,19.415),(47.655,19.245),(47.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.925),(37.545,3.095),(37.715,3.095),(37.715,2.925),(37.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.305),(37.885,5.475),(38.055,5.475),(38.055,5.305),(37.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.645),(37.885,5.815),(38.055,5.815),(38.055,5.645),(37.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.385),(66.685,9.555),(66.855,9.555),(66.855,9.385),(66.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.725),(66.685,9.895),(66.855,9.895),(66.855,9.725),(66.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.385),(66.345,9.555),(66.515,9.555),(66.515,9.385),(66.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.725),(66.345,9.895),(66.515,9.895),(66.515,9.725),(66.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.885),(8.745,18.055),(8.915,18.055),(8.915,17.885),(8.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.625),(66.685,4.795),(66.855,4.795),(66.855,4.625),(66.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.285),(66.685,4.455),(66.855,4.455),(66.855,4.285),(66.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.625),(66.345,4.795),(66.515,4.795),(66.515,4.625),(66.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.285),(66.345,4.455),(66.515,4.455),(66.515,4.285),(66.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.465),(27.945,13.635),(28.115,13.635),(28.115,13.465),(27.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.805),(27.945,13.975),(28.115,13.975),(28.115,13.805),(27.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.125),(27.945,13.295),(28.115,13.295),(28.115,13.125),(27.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.865),(80.745,17.035),(80.915,17.035),(80.915,16.865),(80.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.425),(56.745,11.595),(56.915,11.595),(56.915,11.425),(56.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.085),(56.745,11.255),(56.915,11.255),(56.915,11.085),(56.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.765),(56.745,11.935),(56.915,11.935),(56.915,11.765),(56.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.565),(76.285,18.735),(76.455,18.735),(76.455,18.565),(76.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.225),(76.285,18.395),(76.455,18.395),(76.455,18.225),(76.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.285),(37.885,4.455),(38.055,4.455),(38.055,4.285),(37.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.625),(37.885,4.795),(38.055,4.795),(38.055,4.625),(37.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.125),(37.545,13.295),(37.715,13.295),(37.715,13.125),(37.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.465),(37.545,13.635),(37.715,13.635),(37.715,13.465),(37.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.805),(37.545,13.975),(37.715,13.975),(37.715,13.805),(37.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.485),(51.945,14.655),(52.115,14.655),(52.115,14.485),(51.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.825),(51.945,14.995),(52.115,14.995),(52.115,14.825),(51.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.145),(51.945,14.315),(52.115,14.315),(52.115,14.145),(51.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.025),(71.145,8.195),(71.315,8.195),(71.315,8.025),(71.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.025),(71.485,8.195),(71.655,8.195),(71.655,8.025),(71.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.705),(71.485,8.875),(71.655,8.875),(71.655,8.705),(71.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.365),(71.145,8.535),(71.315,8.535),(71.315,8.365),(71.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.365),(71.485,8.535),(71.655,8.535),(71.655,8.365),(71.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.705),(71.145,8.875),(71.315,8.875),(71.315,8.705),(71.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.745),(23.145,10.915),(23.315,10.915),(23.315,10.745),(23.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.745),(23.485,10.915),(23.655,10.915),(23.655,10.745),(23.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.405),(23.145,10.575),(23.315,10.575),(23.315,10.405),(23.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.405),(23.485,10.575),(23.655,10.575),(23.655,10.405),(23.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.065),(23.145,10.235),(23.315,10.235),(23.315,10.065),(23.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.065),(23.485,10.235),(23.655,10.235),(23.655,10.065),(23.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.385),(8.745,9.555),(8.915,9.555),(8.915,9.385),(8.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.725),(8.745,9.895),(8.915,9.895),(8.915,9.725),(8.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.785),(57.085,12.955),(57.255,12.955),(57.255,12.785),(57.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.105),(57.085,12.275),(57.255,12.275),(57.255,12.105),(57.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.445),(57.085,12.615),(57.255,12.615),(57.255,12.445),(57.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.385),(18.345,9.555),(18.515,9.555),(18.515,9.385),(18.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.385),(18.685,9.555),(18.855,9.555),(18.855,9.385),(18.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.725),(18.345,9.895),(18.515,9.895),(18.515,9.725),(18.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.725),(18.685,9.895),(18.855,9.895),(18.855,9.725),(18.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.365),(23.145,8.535),(23.315,8.535),(23.315,8.365),(23.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.365),(23.485,8.535),(23.655,8.535),(23.655,8.365),(23.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.705),(23.145,8.875),(23.315,8.875),(23.315,8.705),(23.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.705),(23.485,8.875),(23.655,8.875),(23.655,8.705),(23.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.025),(23.145,8.195),(23.315,8.195),(23.315,8.025),(23.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.025),(23.485,8.195),(23.655,8.195),(23.655,8.025),(23.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.865),(18.685,17.035),(18.855,17.035),(18.855,16.865),(18.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.865),(18.345,17.035),(18.515,17.035),(18.515,16.865),(18.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.885),(61.545,18.055),(61.715,18.055),(61.715,17.885),(61.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.485),(81.085,14.655),(81.255,14.655),(81.255,14.485),(81.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.825),(81.085,14.995),(81.255,14.995),(81.255,14.825),(81.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.145),(81.085,14.315),(81.255,14.315),(81.255,14.145),(81.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.885),(52.285,18.055),(52.455,18.055),(52.455,17.885),(52.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.205),(56.745,17.375),(56.915,17.375),(56.915,17.205),(56.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.545),(56.745,17.715),(56.915,17.715),(56.915,17.545),(56.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.245),(61.545,19.415),(61.715,19.415),(61.715,19.245),(61.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.845),(51.945,16.015),(52.115,16.015),(52.115,15.845),(51.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.165),(61.885,15.335),(62.055,15.335),(62.055,15.165),(61.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.505),(61.885,15.675),(62.055,15.675),(62.055,15.505),(61.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.165),(13.885,15.335),(14.055,15.335),(14.055,15.165),(13.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.505),(13.885,15.675),(14.055,15.675),(14.055,15.505),(13.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.025),(56.745,8.195),(56.915,8.195),(56.915,8.025),(56.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.705),(56.745,8.875),(56.915,8.875),(56.915,8.705),(56.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.365),(56.745,8.535),(56.915,8.535),(56.915,8.365),(56.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.245),(18.345,19.415),(18.515,19.415),(18.515,19.245),(18.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.245),(18.685,19.415),(18.855,19.415),(18.855,19.245),(18.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.905),(66.685,19.075),(66.855,19.075),(66.855,18.905),(66.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.905),(66.345,19.075),(66.515,19.075),(66.515,18.905),(66.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.025),(8.745,8.195),(8.915,8.195),(8.915,8.025),(8.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.365),(8.745,8.535),(8.915,8.535),(8.915,8.365),(8.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.705),(8.745,8.875),(8.915,8.875),(8.915,8.705),(8.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.665),(37.545,6.835),(37.715,6.835),(37.715,6.665),(37.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.325),(37.545,6.495),(37.715,6.495),(37.715,6.325),(37.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.085),(37.545,11.255),(37.715,11.255),(37.715,11.085),(37.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.765),(37.545,11.935),(37.715,11.935),(37.715,11.765),(37.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.425),(37.545,11.595),(37.715,11.595),(37.715,11.425),(37.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.725),(56.745,9.895),(56.915,9.895),(56.915,9.725),(56.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.385),(56.745,9.555),(56.915,9.555),(56.915,9.385),(56.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.905),(23.485,19.075),(23.655,19.075),(23.655,18.905),(23.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.905),(23.145,19.075),(23.315,19.075),(23.315,18.905),(23.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.945),(75.945,4.115),(76.115,4.115),(76.115,3.945),(75.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.185),(71.145,16.355),(71.315,16.355),(71.315,16.185),(71.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.185),(71.485,16.355),(71.655,16.355),(71.655,16.185),(71.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.525),(71.145,16.695),(71.315,16.695),(71.315,16.525),(71.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.525),(71.485,16.695),(71.655,16.695),(71.655,16.525),(71.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.505),(37.545,15.675),(37.715,15.675),(37.715,15.505),(37.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.165),(37.545,15.335),(37.715,15.335),(37.715,15.165),(37.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.365),(75.945,8.535),(76.115,8.535),(76.115,8.365),(75.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.705),(75.945,8.875),(76.115,8.875),(76.115,8.705),(75.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.025),(75.945,8.195),(76.115,8.195),(76.115,8.025),(75.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.685),(8.745,7.855),(8.915,7.855),(8.915,7.685),(8.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.865),(61.545,17.035),(61.715,17.035),(61.715,16.865),(61.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.325),(9.085,6.495),(9.255,6.495),(9.255,6.325),(9.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.665),(9.085,6.835),(9.255,6.835),(9.255,6.665),(9.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.245),(8.745,19.415),(8.915,19.415),(8.915,19.245),(8.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.885),(61.885,18.055),(62.055,18.055),(62.055,17.885),(61.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.985),(81.085,6.155),(81.255,6.155),(81.255,5.985),(81.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.845),(75.945,16.015),(76.115,16.015),(76.115,15.845),(75.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.905),(32.745,19.075),(32.915,19.075),(32.915,18.905),(32.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.305),(28.285,5.475),(28.455,5.475),(28.455,5.305),(28.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.645),(28.285,5.815),(28.455,5.815),(28.455,5.645),(28.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.845),(27.945,16.015),(28.115,16.015),(28.115,15.845),(27.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.185),(27.945,16.355),(28.115,16.355),(28.115,16.185),(27.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.525),(27.945,16.695),(28.115,16.695),(28.115,16.525),(27.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.465),(75.945,13.635),(76.115,13.635),(76.115,13.465),(75.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.805),(75.945,13.975),(76.115,13.975),(76.115,13.805),(75.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.125),(75.945,13.295),(76.115,13.295),(76.115,13.125),(75.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.185),(33.085,16.355),(33.255,16.355),(33.255,16.185),(33.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.525),(33.085,16.695),(33.255,16.695),(33.255,16.525),(33.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.265),(57.085,3.435),(57.255,3.435),(57.255,3.265),(57.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.605),(57.085,3.775),(57.255,3.775),(57.255,3.605),(57.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.245),(51.945,19.415),(52.115,19.415),(52.115,19.245),(51.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.325),(56.745,6.495),(56.915,6.495),(56.915,6.325),(56.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.665),(56.745,6.835),(56.915,6.835),(56.915,6.665),(56.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.465),(61.545,13.635),(61.715,13.635),(61.715,13.465),(61.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.805),(61.545,13.975),(61.715,13.975),(61.715,13.805),(61.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.125),(61.545,13.295),(61.715,13.295),(61.715,13.125),(61.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.265),(33.085,3.435),(33.255,3.435),(33.255,3.265),(33.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.605),(33.085,3.775),(33.255,3.775),(33.255,3.605),(33.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.325),(32.745,6.495),(32.915,6.495),(32.915,6.325),(32.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.665),(32.745,6.835),(32.915,6.835),(32.915,6.665),(32.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.485),(75.945,14.655),(76.115,14.655),(76.115,14.485),(75.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.825),(75.945,14.995),(76.115,14.995),(76.115,14.825),(75.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.145),(75.945,14.315),(76.115,14.315),(76.115,14.145),(75.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.265),(9.085,3.435),(9.255,3.435),(9.255,3.265),(9.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.605),(9.085,3.775),(9.255,3.775),(9.255,3.605),(9.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.905),(33.085,19.075),(33.255,19.075),(33.255,18.905),(33.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.465),(13.545,13.635),(13.715,13.635),(13.715,13.465),(13.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.805),(13.545,13.975),(13.715,13.975),(13.715,13.805),(13.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.125),(13.545,13.295),(13.715,13.295),(13.715,13.125),(13.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.345),(75.945,7.515),(76.115,7.515),(76.115,7.345),(75.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.685),(75.945,7.855),(76.115,7.855),(76.115,7.685),(75.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.005),(75.945,7.175),(76.115,7.175),(76.115,7.005),(75.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.845),(42.345,16.015),(42.515,16.015),(42.515,15.845),(42.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.845),(42.685,16.015),(42.855,16.015),(42.855,15.845),(42.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.945),(51.945,4.115),(52.115,4.115),(52.115,3.945),(51.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.145),(27.945,14.315),(28.115,14.315),(28.115,14.145),(27.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.485),(27.945,14.655),(28.115,14.655),(28.115,14.485),(27.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.825),(27.945,14.995),(28.115,14.995),(28.115,14.825),(27.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.285),(76.285,4.455),(76.455,4.455),(76.455,4.285),(76.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.625),(76.285,4.795),(76.455,4.795),(76.455,4.625),(76.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.345),(27.945,7.515),(28.115,7.515),(28.115,7.345),(27.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.685),(27.945,7.855),(28.115,7.855),(28.115,7.685),(27.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.885),(71.485,18.055),(71.655,18.055),(71.655,17.885),(71.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.885),(71.145,18.055),(71.315,18.055),(71.315,17.885),(71.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.005),(27.945,7.175),(28.115,7.175),(28.115,7.005),(27.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.065),(71.145,10.235),(71.315,10.235),(71.315,10.065),(71.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.065),(71.485,10.235),(71.655,10.235),(71.655,10.065),(71.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.745),(71.145,10.915),(71.315,10.915),(71.315,10.745),(71.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.745),(71.485,10.915),(71.655,10.915),(71.655,10.745),(71.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.405),(71.485,10.575),(71.655,10.575),(71.655,10.405),(71.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.405),(71.145,10.575),(71.315,10.575),(71.315,10.405),(71.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.285),(28.285,4.455),(28.455,4.455),(28.455,4.285),(28.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.625),(28.285,4.795),(28.455,4.795),(28.455,4.625),(28.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.045),(80.745,9.215),(80.915,9.215),(80.915,9.045),(80.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.005),(56.745,7.175),(56.915,7.175),(56.915,7.005),(56.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.685),(56.745,7.855),(56.915,7.855),(56.915,7.685),(56.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.345),(56.745,7.515),(56.915,7.515),(56.915,7.345),(56.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.325),(57.085,6.495),(57.255,6.495),(57.255,6.325),(57.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.665),(57.085,6.835),(57.255,6.835),(57.255,6.665),(57.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.005),(32.745,7.175),(32.915,7.175),(32.915,7.005),(32.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.345),(32.745,7.515),(32.915,7.515),(32.915,7.345),(32.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.685),(32.745,7.855),(32.915,7.855),(32.915,7.685),(32.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.905),(28.285,19.075),(28.455,19.075),(28.455,18.905),(28.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.325),(80.745,6.495),(80.915,6.495),(80.915,6.325),(80.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.665),(80.745,6.835),(80.915,6.835),(80.915,6.665),(80.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.325),(33.085,6.495),(33.255,6.495),(33.255,6.325),(33.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.665),(33.085,6.835),(33.255,6.835),(33.255,6.665),(33.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.985),(66.345,6.155),(66.515,6.155),(66.515,5.985),(66.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.985),(66.685,6.155),(66.855,6.155),(66.855,5.985),(66.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.285),(51.945,4.455),(52.115,4.455),(52.115,4.285),(51.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.625),(51.945,4.795),(52.115,4.795),(52.115,4.625),(51.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.985),(42.345,6.155),(42.515,6.155),(42.515,5.985),(42.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.985),(42.685,6.155),(42.855,6.155),(42.855,5.985),(42.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.445),(56.745,12.615),(56.915,12.615),(56.915,12.445),(56.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.105),(56.745,12.275),(56.915,12.275),(56.915,12.105),(56.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.785),(56.745,12.955),(56.915,12.955),(56.915,12.785),(56.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.445),(8.745,12.615),(8.915,12.615),(8.915,12.445),(8.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.785),(8.745,12.955),(8.915,12.955),(8.915,12.785),(8.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.105),(8.745,12.275),(8.915,12.275),(8.915,12.105),(8.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.905),(37.885,19.075),(38.055,19.075),(38.055,18.905),(37.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.045),(32.745,9.215),(32.915,9.215),(32.915,9.045),(32.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.425),(61.545,11.595),(61.715,11.595),(61.715,11.425),(61.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.085),(61.545,11.255),(61.715,11.255),(61.715,11.085),(61.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.765),(61.545,11.935),(61.715,11.935),(61.715,11.765),(61.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.905),(61.545,19.075),(61.715,19.075),(61.715,18.905),(61.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.205),(8.745,17.375),(8.915,17.375),(8.915,17.205),(8.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.545),(8.745,17.715),(8.915,17.715),(8.915,17.545),(8.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.965),(37.545,5.135),(37.715,5.135),(37.715,4.965),(37.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.765),(13.545,11.935),(13.715,11.935),(13.715,11.765),(13.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.425),(13.545,11.595),(13.715,11.595),(13.715,11.425),(13.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.085),(13.545,11.255),(13.715,11.255),(13.715,11.085),(13.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.125),(37.885,13.295),(38.055,13.295),(38.055,13.125),(37.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.465),(37.885,13.635),(38.055,13.635),(38.055,13.465),(37.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.805),(37.885,13.975),(38.055,13.975),(38.055,13.805),(37.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.365),(37.885,8.535),(38.055,8.535),(38.055,8.365),(37.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.705),(37.885,8.875),(38.055,8.875),(38.055,8.705),(37.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.025),(37.885,8.195),(38.055,8.195),(38.055,8.025),(37.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.445),(37.545,12.615),(37.715,12.615),(37.715,12.445),(37.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.785),(37.545,12.955),(37.715,12.955),(37.715,12.785),(37.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.105),(37.545,12.275),(37.715,12.275),(37.715,12.105),(37.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.505),(61.545,15.675),(61.715,15.675),(61.715,15.505),(61.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.165),(61.545,15.335),(61.715,15.335),(61.715,15.165),(61.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.405),(37.885,10.575),(38.055,10.575),(38.055,10.405),(37.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.745),(37.885,10.915),(38.055,10.915),(38.055,10.745),(37.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.065),(37.885,10.235),(38.055,10.235),(38.055,10.065),(37.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.205),(75.945,17.375),(76.115,17.375),(76.115,17.205),(75.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.545),(75.945,17.715),(76.115,17.715),(76.115,17.545),(75.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.505),(13.545,15.675),(13.715,15.675),(13.715,15.505),(13.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.165),(13.545,15.335),(13.715,15.335),(13.715,15.165),(13.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.225),(56.745,18.395),(56.915,18.395),(56.915,18.225),(56.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.565),(56.745,18.735),(56.915,18.735),(56.915,18.565),(56.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.965),(9.085,5.135),(9.255,5.135),(9.255,4.965),(9.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.945),(81.085,4.115),(81.255,4.115),(81.255,3.945),(81.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.865),(56.745,17.035),(56.915,17.035),(56.915,16.865),(56.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.245),(76.285,19.415),(76.455,19.415),(76.455,19.245),(76.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.965),(81.085,5.135),(81.255,5.135),(81.255,4.965),(81.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.225),(57.085,18.395),(57.255,18.395),(57.255,18.225),(57.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.565),(57.085,18.735),(57.255,18.735),(57.255,18.565),(57.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.865),(13.545,17.035),(13.715,17.035),(13.715,16.865),(13.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.685),(80.745,7.855),(80.915,7.855),(80.915,7.685),(80.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.885),(13.545,18.055),(13.715,18.055),(13.715,17.885),(13.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.205),(52.285,17.375),(52.455,17.375),(52.455,17.205),(52.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.545),(52.285,17.715),(52.455,17.715),(52.455,17.545),(52.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.985),(8.745,6.155),(8.915,6.155),(8.915,5.985),(8.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.325),(13.885,6.495),(14.055,6.495),(14.055,6.325),(13.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.665),(13.885,6.835),(14.055,6.835),(14.055,6.665),(13.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.745),(56.745,10.915),(56.915,10.915),(56.915,10.745),(56.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.065),(56.745,10.235),(56.915,10.235),(56.915,10.065),(56.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.405),(56.745,10.575),(56.915,10.575),(56.915,10.405),(56.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.865),(28.285,17.035),(28.455,17.035),(28.455,16.865),(28.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.845),(71.145,16.015),(71.315,16.015),(71.315,15.845),(71.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.845),(71.485,16.015),(71.655,16.015),(71.655,15.845),(71.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.265),(52.285,3.435),(52.455,3.435),(52.455,3.265),(52.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.605),(52.285,3.775),(52.455,3.775),(52.455,3.605),(52.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.745),(8.745,10.915),(8.915,10.915),(8.915,10.745),(8.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.065),(8.745,10.235),(8.915,10.235),(8.915,10.065),(8.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.405),(8.745,10.575),(8.915,10.575),(8.915,10.405),(8.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.845),(23.485,16.015),(23.655,16.015),(23.655,15.845),(23.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.845),(23.145,16.015),(23.315,16.015),(23.315,15.845),(23.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.045),(37.545,9.215),(37.715,9.215),(37.715,9.045),(37.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.305),(71.145,5.475),(71.315,5.475),(71.315,5.305),(71.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.305),(71.485,5.475),(71.655,5.475),(71.655,5.305),(71.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.645),(71.145,5.815),(71.315,5.815),(71.315,5.645),(71.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.625),(71.145,4.795),(71.315,4.795),(71.315,4.625),(71.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.645),(71.485,5.815),(71.655,5.815),(71.655,5.645),(71.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.285),(71.145,4.455),(71.315,4.455),(71.315,4.285),(71.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.625),(71.485,4.795),(71.655,4.795),(71.655,4.625),(71.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.285),(71.485,4.455),(71.655,4.455),(71.655,4.285),(71.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.265),(8.745,3.435),(8.915,3.435),(8.915,3.265),(8.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.605),(8.745,3.775),(8.915,3.775),(8.915,3.605),(8.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.365),(13.885,8.535),(14.055,8.535),(14.055,8.365),(13.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.705),(13.885,8.875),(14.055,8.875),(14.055,8.705),(13.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.025),(13.885,8.195),(14.055,8.195),(14.055,8.025),(13.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.245),(13.545,19.415),(13.715,19.415),(13.715,19.245),(13.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.465),(80.745,13.635),(80.915,13.635),(80.915,13.465),(80.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.805),(80.745,13.975),(80.915,13.975),(80.915,13.805),(80.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.105),(13.545,12.275),(13.715,12.275),(13.715,12.105),(13.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.845),(57.085,16.015),(57.255,16.015),(57.255,15.845),(57.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.445),(13.545,12.615),(13.715,12.615),(13.715,12.445),(13.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.785),(13.545,12.955),(13.715,12.955),(13.715,12.785),(13.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.125),(80.745,13.295),(80.915,13.295),(80.915,13.125),(80.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.285),(23.485,4.455),(23.655,4.455),(23.655,4.285),(23.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.625),(23.145,4.795),(23.315,4.795),(23.315,4.625),(23.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.625),(23.485,4.795),(23.655,4.795),(23.655,4.625),(23.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.285),(23.145,4.455),(23.315,4.455),(23.315,4.285),(23.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.065),(13.885,10.235),(14.055,10.235),(14.055,10.065),(13.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.405),(13.885,10.575),(14.055,10.575),(14.055,10.405),(13.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.745),(13.885,10.915),(14.055,10.915),(14.055,10.745),(13.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.985),(47.485,6.155),(47.655,6.155),(47.655,5.985),(47.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.845),(9.085,16.015),(9.255,16.015),(9.255,15.845),(9.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.045),(57.085,9.215),(57.255,9.215),(57.255,9.045),(57.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.965),(57.085,5.135),(57.255,5.135),(57.255,4.965),(57.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.965),(33.085,5.135),(33.255,5.135),(33.255,4.965),(33.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.985),(75.945,6.155),(76.115,6.155),(76.115,5.985),(75.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.685),(61.885,7.855),(62.055,7.855),(62.055,7.685),(61.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.045),(9.085,9.215),(9.255,9.215),(9.255,9.045),(9.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.045),(52.285,9.215),(52.455,9.215),(52.455,9.045),(52.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.185),(81.085,16.355),(81.255,16.355),(81.255,16.185),(81.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.825),(37.545,14.995),(37.715,14.995),(37.715,14.825),(37.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.145),(37.545,14.315),(37.715,14.315),(37.715,14.145),(37.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.525),(81.085,16.695),(81.255,16.695),(81.255,16.525),(81.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.485),(37.545,14.655),(37.715,14.655),(37.715,14.485),(37.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.005),(13.885,7.175),(14.055,7.175),(14.055,7.005),(13.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.685),(13.885,7.855),(14.055,7.855),(14.055,7.685),(13.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.345),(13.885,7.515),(14.055,7.515),(14.055,7.345),(13.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.205),(81.085,17.375),(81.255,17.375),(81.255,17.205),(81.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.545),(81.085,17.715),(81.255,17.715),(81.255,17.545),(81.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.665),(37.885,6.835),(38.055,6.835),(38.055,6.665),(37.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,2.925),(13.885,3.095),(14.055,3.095),(14.055,2.925),(13.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.325),(37.885,6.495),(38.055,6.495),(38.055,6.325),(37.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.565),(51.945,18.735),(52.115,18.735),(52.115,18.565),(51.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.225),(51.945,18.395),(52.115,18.395),(52.115,18.225),(51.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.205),(23.145,17.375),(23.315,17.375),(23.315,17.205),(23.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.205),(23.485,17.375),(23.655,17.375),(23.655,17.205),(23.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.545),(23.145,17.715),(23.315,17.715),(23.315,17.545),(23.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.545),(23.485,17.715),(23.655,17.715),(23.655,17.545),(23.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.125),(32.745,13.295),(32.915,13.295),(32.915,13.125),(32.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.465),(32.745,13.635),(32.915,13.635),(32.915,13.465),(32.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.805),(32.745,13.975),(32.915,13.975),(32.915,13.805),(32.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.965),(13.885,5.135),(14.055,5.135),(14.055,4.965),(13.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.465),(61.885,13.635),(62.055,13.635),(62.055,13.465),(61.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.805),(61.885,13.975),(62.055,13.975),(62.055,13.805),(61.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.125),(61.885,13.295),(62.055,13.295),(62.055,13.125),(61.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.885),(13.885,18.055),(14.055,18.055),(14.055,17.885),(13.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.905),(18.345,19.075),(18.515,19.075),(18.515,18.905),(18.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.905),(18.685,19.075),(18.855,19.075),(18.855,18.905),(18.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.265),(56.745,3.435),(56.915,3.435),(56.915,3.265),(56.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.605),(56.745,3.775),(56.915,3.775),(56.915,3.605),(56.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.125),(13.885,13.295),(14.055,13.295),(14.055,13.125),(13.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.465),(13.885,13.635),(14.055,13.635),(14.055,13.465),(13.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.805),(13.885,13.975),(14.055,13.975),(14.055,13.805),(13.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.025),(61.885,8.195),(62.055,8.195),(62.055,8.025),(61.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.365),(61.885,8.535),(62.055,8.535),(62.055,8.365),(61.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.705),(61.885,8.875),(62.055,8.875),(62.055,8.705),(61.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.265),(32.745,3.435),(32.915,3.435),(32.915,3.265),(32.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.605),(32.745,3.775),(32.915,3.775),(32.915,3.605),(32.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.445),(61.545,12.615),(61.715,12.615),(61.715,12.445),(61.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.785),(61.545,12.955),(61.715,12.955),(61.715,12.785),(61.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.105),(61.545,12.275),(61.715,12.275),(61.715,12.105),(61.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.165),(8.745,15.335),(8.915,15.335),(8.915,15.165),(8.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.505),(8.745,15.675),(8.915,15.675),(8.915,15.505),(8.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.065),(61.885,10.235),(62.055,10.235),(62.055,10.065),(61.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.405),(61.885,10.575),(62.055,10.575),(62.055,10.405),(61.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.745),(61.885,10.915),(62.055,10.915),(62.055,10.745),(61.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.825),(52.285,14.995),(52.455,14.995),(52.455,14.825),(52.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.145),(52.285,14.315),(52.455,14.315),(52.455,14.145),(52.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.485),(52.285,14.655),(52.455,14.655),(52.455,14.485),(52.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.625),(47.485,4.795),(47.655,4.795),(47.655,4.625),(47.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.625),(47.145,4.795),(47.315,4.795),(47.315,4.625),(47.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.285),(47.145,4.455),(47.315,4.455),(47.315,4.285),(47.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.285),(47.485,4.455),(47.655,4.455),(47.655,4.285),(47.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.905),(13.545,19.075),(13.715,19.075),(13.715,18.905),(13.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.905),(80.745,19.075),(80.915,19.075),(80.915,18.905),(80.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.885),(47.145,18.055),(47.315,18.055),(47.315,17.885),(47.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.885),(47.485,18.055),(47.655,18.055),(47.655,17.885),(47.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.485),(13.545,14.655),(13.715,14.655),(13.715,14.485),(13.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.825),(13.545,14.995),(13.715,14.995),(13.715,14.825),(13.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.145),(13.545,14.315),(13.715,14.315),(13.715,14.145),(13.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.725),(47.145,9.895),(47.315,9.895),(47.315,9.725),(47.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.725),(47.485,9.895),(47.655,9.895),(47.655,9.725),(47.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.385),(47.145,9.555),(47.315,9.555),(47.315,9.385),(47.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.385),(47.485,9.555),(47.655,9.555),(47.655,9.385),(47.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,2.925),(61.885,3.095),(62.055,3.095),(62.055,2.925),(61.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.305),(61.545,5.475),(61.715,5.475),(61.715,5.305),(61.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.645),(61.545,5.815),(61.715,5.815),(61.715,5.645),(61.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.805),(47.145,13.975),(47.315,13.975),(47.315,13.805),(47.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.885),(27.945,18.055),(28.115,18.055),(28.115,17.885),(27.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.805),(47.485,13.975),(47.655,13.975),(47.655,13.805),(47.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.465),(47.145,13.635),(47.315,13.635),(47.315,13.465),(47.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.465),(47.485,13.635),(47.655,13.635),(47.655,13.465),(47.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.245),(37.885,19.415),(38.055,19.415),(38.055,19.245),(37.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.125),(47.145,13.295),(47.315,13.295),(47.315,13.125),(47.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.125),(47.485,13.295),(47.655,13.295),(47.655,13.125),(47.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.305),(13.545,5.475),(13.715,5.475),(13.715,5.305),(13.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.645),(13.545,5.815),(13.715,5.815),(13.715,5.645),(13.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.965),(61.885,5.135),(62.055,5.135),(62.055,4.965),(61.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.305),(66.345,5.475),(66.515,5.475),(66.515,5.305),(66.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.645),(66.345,5.815),(66.515,5.815),(66.515,5.645),(66.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.645),(66.685,5.815),(66.855,5.815),(66.855,5.645),(66.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.305),(66.685,5.475),(66.855,5.475),(66.855,5.305),(66.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.305),(42.345,5.475),(42.515,5.475),(42.515,5.305),(42.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.305),(42.685,5.475),(42.855,5.475),(42.855,5.305),(42.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.645),(42.345,5.815),(42.515,5.815),(42.515,5.645),(42.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.645),(42.685,5.815),(42.855,5.815),(42.855,5.645),(42.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.865),(23.485,17.035),(23.655,17.035),(23.655,16.865),(23.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.865),(23.145,17.035),(23.315,17.035),(23.315,16.865),(23.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.045),(61.545,9.215),(61.715,9.215),(61.715,9.045),(61.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.185),(37.885,16.355),(38.055,16.355),(38.055,16.185),(37.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.525),(37.885,16.695),(38.055,16.695),(38.055,16.525),(37.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.045),(13.545,9.215),(13.715,9.215),(13.715,9.045),(13.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.965),(18.685,5.135),(18.855,5.135),(18.855,4.965),(18.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.165),(56.745,15.335),(56.915,15.335),(56.915,15.165),(56.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.505),(56.745,15.675),(56.915,15.675),(56.915,15.505),(56.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.965),(18.345,5.135),(18.515,5.135),(18.515,4.965),(18.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.385),(33.085,9.555),(33.255,9.555),(33.255,9.385),(33.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.725),(33.085,9.895),(33.255,9.895),(33.255,9.725),(33.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.485),(28.285,14.655),(28.455,14.655),(28.455,14.485),(28.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.825),(28.285,14.995),(28.455,14.995),(28.455,14.825),(28.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.145),(28.285,14.315),(28.455,14.315),(28.455,14.145),(28.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.225),(9.085,18.395),(9.255,18.395),(9.255,18.225),(9.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.565),(9.085,18.735),(9.255,18.735),(9.255,18.565),(9.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.605),(76.285,3.775),(76.455,3.775),(76.455,3.605),(76.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.265),(76.285,3.435),(76.455,3.435),(76.455,3.265),(76.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.045),(76.285,9.215),(76.455,9.215),(76.455,9.045),(76.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.485),(61.545,14.655),(61.715,14.655),(61.715,14.485),(61.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.825),(61.545,14.995),(61.715,14.995),(61.715,14.825),(61.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.145),(61.545,14.315),(61.715,14.315),(61.715,14.145),(61.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.445),(52.285,12.615),(52.455,12.615),(52.455,12.445),(52.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.785),(52.285,12.955),(52.455,12.955),(52.455,12.785),(52.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.265),(37.545,3.435),(37.715,3.435),(37.715,3.265),(37.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.605),(37.545,3.775),(37.715,3.775),(37.715,3.605),(37.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.045),(28.285,9.215),(28.455,9.215),(28.455,9.045),(28.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.105),(52.285,12.275),(52.455,12.275),(52.455,12.105),(52.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.965),(42.345,5.135),(42.515,5.135),(42.515,4.965),(42.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.965),(42.685,5.135),(42.855,5.135),(42.855,4.965),(42.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.265),(80.745,3.435),(80.915,3.435),(80.915,3.265),(80.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.605),(80.745,3.775),(80.915,3.775),(80.915,3.605),(80.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.905),(71.145,19.075),(71.315,19.075),(71.315,18.905),(71.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.905),(71.485,19.075),(71.655,19.075),(71.655,18.905),(71.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.845),(47.145,16.015),(47.315,16.015),(47.315,15.845),(47.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.845),(47.485,16.015),(47.655,16.015),(47.655,15.845),(47.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.685),(42.345,7.855),(42.515,7.855),(42.515,7.685),(42.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.685),(42.685,7.855),(42.855,7.855),(42.855,7.685),(42.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.085),(51.945,11.255),(52.115,11.255),(52.115,11.085),(51.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.425),(51.945,11.595),(52.115,11.595),(52.115,11.425),(51.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.765),(51.945,11.935),(52.115,11.935),(52.115,11.765),(51.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.225),(8.745,18.395),(8.915,18.395),(8.915,18.225),(8.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.565),(8.745,18.735),(8.915,18.735),(8.915,18.565),(8.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.905),(81.085,19.075),(81.255,19.075),(81.255,18.905),(81.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.865),(51.945,17.035),(52.115,17.035),(52.115,16.865),(51.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.945),(71.485,4.115),(71.655,4.115),(71.655,3.945),(71.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.945),(71.145,4.115),(71.315,4.115),(71.315,3.945),(71.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.525),(75.945,16.695),(76.115,16.695),(76.115,16.525),(75.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.185),(75.945,16.355),(76.115,16.355),(76.115,16.185),(75.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.945),(47.145,4.115),(47.315,4.115),(47.315,3.945),(47.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.945),(47.485,4.115),(47.655,4.115),(47.655,3.945),(47.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.825),(42.685,14.995),(42.855,14.995),(42.855,14.825),(42.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.485),(42.345,14.655),(42.515,14.655),(42.515,14.485),(42.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.485),(42.685,14.655),(42.855,14.655),(42.855,14.485),(42.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.825),(42.345,14.995),(42.515,14.995),(42.515,14.825),(42.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.145),(42.345,14.315),(42.515,14.315),(42.515,14.145),(42.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.145),(42.685,14.315),(42.855,14.315),(42.855,14.145),(42.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.865),(8.745,17.035),(8.915,17.035),(8.915,16.865),(8.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.945),(23.145,4.115),(23.315,4.115),(23.315,3.945),(23.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.945),(23.485,4.115),(23.655,4.115),(23.655,3.945),(23.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.925),(51.945,3.095),(52.115,3.095),(52.115,2.925),(51.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.045),(23.145,9.215),(23.315,9.215),(23.315,9.045),(23.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.045),(23.485,9.215),(23.655,9.215),(23.655,9.045),(23.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.045),(37.885,9.215),(38.055,9.215),(38.055,9.045),(37.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.865),(76.285,17.035),(76.455,17.035),(76.455,16.865),(76.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.305),(8.745,5.475),(8.915,5.475),(8.915,5.305),(8.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.645),(8.745,5.815),(8.915,5.815),(8.915,5.645),(8.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.445),(76.285,12.615),(76.455,12.615),(76.455,12.445),(76.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.105),(76.285,12.275),(76.455,12.275),(76.455,12.105),(76.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.505),(71.485,15.675),(71.655,15.675),(71.655,15.505),(71.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.165),(71.145,15.335),(71.315,15.335),(71.315,15.165),(71.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.165),(71.485,15.335),(71.655,15.335),(71.655,15.165),(71.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.785),(76.285,12.955),(76.455,12.955),(76.455,12.785),(76.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.505),(71.145,15.675),(71.315,15.675),(71.315,15.505),(71.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.365),(37.545,8.535),(37.715,8.535),(37.715,8.365),(37.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.705),(37.545,8.875),(37.715,8.875),(37.715,8.705),(37.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.025),(37.545,8.195),(37.715,8.195),(37.715,8.025),(37.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.425),(33.085,11.595),(33.255,11.595),(33.255,11.425),(33.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.085),(33.085,11.255),(33.255,11.255),(33.255,11.085),(33.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.765),(33.085,11.935),(33.255,11.935),(33.255,11.765),(33.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.105),(28.285,12.275),(28.455,12.275),(28.455,12.105),(28.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.145),(32.745,14.315),(32.915,14.315),(32.915,14.145),(32.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.165),(23.145,15.335),(23.315,15.335),(23.315,15.165),(23.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.165),(23.485,15.335),(23.655,15.335),(23.655,15.165),(23.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.445),(28.285,12.615),(28.455,12.615),(28.455,12.445),(28.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.785),(28.285,12.955),(28.455,12.955),(28.455,12.785),(28.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.505),(23.145,15.675),(23.315,15.675),(23.315,15.505),(23.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.505),(23.485,15.675),(23.655,15.675),(23.655,15.505),(23.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.485),(32.745,14.655),(32.915,14.655),(32.915,14.485),(32.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.825),(32.745,14.995),(32.915,14.995),(32.915,14.825),(32.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.985),(37.885,6.155),(38.055,6.155),(38.055,5.985),(37.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.085),(52.285,11.255),(52.455,11.255),(52.455,11.085),(52.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.765),(52.285,11.935),(52.455,11.935),(52.455,11.765),(52.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.425),(52.285,11.595),(52.455,11.595),(52.455,11.425),(52.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.945),(61.885,4.115),(62.055,4.115),(62.055,3.945),(61.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.505),(57.085,15.675),(57.255,15.675),(57.255,15.505),(57.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.165),(57.085,15.335),(57.255,15.335),(57.255,15.165),(57.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.965),(66.685,5.135),(66.855,5.135),(66.855,4.965),(66.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.965),(66.345,5.135),(66.515,5.135),(66.515,4.965),(66.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.505),(9.085,15.675),(9.255,15.675),(9.255,15.505),(9.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.985),(47.145,6.155),(47.315,6.155),(47.315,5.985),(47.145,5.985)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.985),(22.775,19.355),(24.025,19.355),(24.025,2.985),(22.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.845),(22.775,19.495),(24.025,19.495),(24.025,2.845),(22.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.985),(61.175,19.355),(62.425,19.355),(62.425,2.985),(61.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((61.545,2.845),(61.545,19.495),(62.055,19.495),(62.055,2.845),(61.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.845),(61.175,19.495),(62.425,19.495),(62.425,2.845),(61.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((66.345,2.845),(66.345,19.495),(66.855,19.495),(66.855,2.845),(66.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((71.145,2.845),(71.145,19.495),(71.655,19.495),(71.655,2.845),(71.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.985),(46.775,19.355),(48.025,19.355),(48.025,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.845),(46.775,19.495),(48.025,19.495),(48.025,2.845),(46.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.985),(65.975,19.355),(67.225,19.355),(67.225,2.985),(65.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.845),(65.975,19.495),(67.225,19.495),(67.225,2.845),(65.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((75.945,2.845),(75.945,19.495),(76.455,19.495),(76.455,2.845),(75.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.985),(75.575,19.355),(76.825,19.355),(76.825,2.985),(75.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.845),(75.575,19.495),(76.825,19.495),(76.825,2.845),(75.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((23.145,2.845),(23.145,19.495),(23.655,19.495),(23.655,2.845),(23.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((42.345,2.845),(42.345,19.495),(42.855,19.495),(42.855,2.845),(42.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.985),(56.375,19.355),(57.625,19.355),(57.625,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((56.745,2.845),(56.745,19.495),(57.255,19.495),(57.255,2.845),(56.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.845),(56.375,19.495),(57.625,19.495),(57.625,2.845),(56.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.545,2.845),(37.545,19.495),(38.055,19.495),(38.055,2.845),(37.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((47.145,2.845),(47.145,19.495),(47.655,19.495),(47.655,2.845),(47.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.985),(37.175,19.355),(38.425,19.355),(38.425,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.845),(37.175,19.495),(38.425,19.495),(38.425,2.845),(37.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((18.345,2.845),(18.345,19.495),(18.855,19.495),(18.855,2.845),(18.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.985),(41.975,19.355),(43.225,19.355),(43.225,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((27.945,2.845),(27.945,19.495),(28.455,19.495),(28.455,2.845),(27.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.985),(27.575,19.355),(28.825,19.355),(28.825,2.985),(27.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.845),(27.575,19.495),(28.825,19.495),(28.825,2.845),(27.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.845),(41.975,19.495),(43.225,19.495),(43.225,2.845),(41.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((8.745,2.845),(8.745,19.495),(9.255,19.495),(9.255,2.845),(8.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.985),(70.775,19.355),(72.025,19.355),(72.025,2.985),(70.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.845),(70.775,19.495),(72.025,19.495),(72.025,2.845),(70.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.985),(17.975,19.355),(19.225,19.355),(19.225,2.985),(17.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.845),(17.975,19.495),(19.225,19.495),(19.225,2.845),(17.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.985),(8.375,19.355),(9.625,19.355),(9.625,2.985),(8.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.845),(8.375,19.495),(9.625,19.495),(9.625,2.845),(8.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((13.545,2.845),(13.545,19.495),(14.055,19.495),(14.055,2.845),(13.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.985),(13.175,19.355),(14.425,19.355),(14.425,2.985),(13.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.845),(13.175,19.495),(14.425,19.495),(14.425,2.845),(13.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((80.745,2.845),(80.745,19.495),(81.255,19.495),(81.255,2.845),(80.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.745,2.845),(32.745,19.495),(33.255,19.495),(33.255,2.845),(32.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.985),(80.375,19.355),(81.625,19.355),(81.625,2.985),(80.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.845),(80.375,19.495),(81.625,19.495),(81.625,2.845),(80.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.945,2.845),(51.945,19.495),(52.455,19.495),(52.455,2.845),(51.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.985),(32.375,19.355),(33.625,19.355),(33.625,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.845),(32.375,19.495),(33.625,19.495),(33.625,2.845),(32.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.985),(51.575,19.355),(52.825,19.355),(52.825,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.845),(51.575,19.495),(52.825,19.495),(52.825,2.845),(51.575,2.845)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,2.985),(80.375,3.155),(80.545,3.155),(80.545,2.985),(80.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,2.985),(80.735,3.155),(80.905,3.155),(80.905,2.985),(80.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,2.985),(81.095,3.155),(81.265,3.155),(81.265,2.985),(81.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,2.985),(81.455,3.155),(81.625,3.155),(81.625,2.985),(81.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.345),(80.375,3.515),(80.545,3.515),(80.545,3.345),(80.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.345),(80.735,3.515),(80.905,3.515),(80.905,3.345),(80.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.345),(81.095,3.515),(81.265,3.515),(81.265,3.345),(81.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.345),(81.455,3.515),(81.625,3.515),(81.625,3.345),(81.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.705),(80.375,3.875),(80.545,3.875),(80.545,3.705),(80.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.705),(80.735,3.875),(80.905,3.875),(80.905,3.705),(80.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.705),(81.095,3.875),(81.265,3.875),(81.265,3.705),(81.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.705),(81.455,3.875),(81.625,3.875),(81.625,3.705),(81.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.065),(80.375,4.235),(80.545,4.235),(80.545,4.065),(80.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.065),(80.735,4.235),(80.905,4.235),(80.905,4.065),(80.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.065),(81.095,4.235),(81.265,4.235),(81.265,4.065),(81.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.065),(81.455,4.235),(81.625,4.235),(81.625,4.065),(81.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.425),(80.375,4.595),(80.545,4.595),(80.545,4.425),(80.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.425),(80.735,4.595),(80.905,4.595),(80.905,4.425),(80.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.425),(81.095,4.595),(81.265,4.595),(81.265,4.425),(81.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.425),(81.455,4.595),(81.625,4.595),(81.625,4.425),(81.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.785),(80.375,4.955),(80.545,4.955),(80.545,4.785),(80.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.785),(80.735,4.955),(80.905,4.955),(80.905,4.785),(80.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.785),(81.095,4.955),(81.265,4.955),(81.265,4.785),(81.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.785),(81.455,4.955),(81.625,4.955),(81.625,4.785),(81.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.145),(80.375,5.315),(80.545,5.315),(80.545,5.145),(80.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.145),(80.735,5.315),(80.905,5.315),(80.905,5.145),(80.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.145),(81.095,5.315),(81.265,5.315),(81.265,5.145),(81.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.145),(81.455,5.315),(81.625,5.315),(81.625,5.145),(81.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.505),(80.375,5.675),(80.545,5.675),(80.545,5.505),(80.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.505),(80.735,5.675),(80.905,5.675),(80.905,5.505),(80.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.505),(81.095,5.675),(81.265,5.675),(81.265,5.505),(81.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.505),(81.455,5.675),(81.625,5.675),(81.625,5.505),(81.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.865),(80.375,6.035),(80.545,6.035),(80.545,5.865),(80.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.865),(80.735,6.035),(80.905,6.035),(80.905,5.865),(80.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.865),(81.095,6.035),(81.265,6.035),(81.265,5.865),(81.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.865),(81.455,6.035),(81.625,6.035),(81.625,5.865),(81.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.225),(80.375,6.395),(80.545,6.395),(80.545,6.225),(80.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.225),(80.735,6.395),(80.905,6.395),(80.905,6.225),(80.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.225),(81.095,6.395),(81.265,6.395),(81.265,6.225),(81.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.225),(81.455,6.395),(81.625,6.395),(81.625,6.225),(81.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.585),(80.375,6.755),(80.545,6.755),(80.545,6.585),(80.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.585),(80.735,6.755),(80.905,6.755),(80.905,6.585),(80.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.585),(81.095,6.755),(81.265,6.755),(81.265,6.585),(81.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.585),(81.455,6.755),(81.625,6.755),(81.625,6.585),(81.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.945),(80.375,7.115),(80.545,7.115),(80.545,6.945),(80.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.945),(80.735,7.115),(80.905,7.115),(80.905,6.945),(80.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.945),(81.095,7.115),(81.265,7.115),(81.265,6.945),(81.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.945),(81.455,7.115),(81.625,7.115),(81.625,6.945),(81.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.305),(80.375,7.475),(80.545,7.475),(80.545,7.305),(80.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.305),(80.735,7.475),(80.905,7.475),(80.905,7.305),(80.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.305),(81.095,7.475),(81.265,7.475),(81.265,7.305),(81.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.305),(81.455,7.475),(81.625,7.475),(81.625,7.305),(81.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.665),(80.375,7.835),(80.545,7.835),(80.545,7.665),(80.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.665),(80.735,7.835),(80.905,7.835),(80.905,7.665),(80.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.665),(81.095,7.835),(81.265,7.835),(81.265,7.665),(81.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.665),(81.455,7.835),(81.625,7.835),(81.625,7.665),(81.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.025),(80.375,8.195),(80.545,8.195),(80.545,8.025),(80.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.025),(80.735,8.195),(80.905,8.195),(80.905,8.025),(80.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.025),(81.095,8.195),(81.265,8.195),(81.265,8.025),(81.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.025),(81.455,8.195),(81.625,8.195),(81.625,8.025),(81.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.385),(80.375,8.555),(80.545,8.555),(80.545,8.385),(80.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.385),(80.735,8.555),(80.905,8.555),(80.905,8.385),(80.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.385),(81.095,8.555),(81.265,8.555),(81.265,8.385),(81.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.385),(81.455,8.555),(81.625,8.555),(81.625,8.385),(81.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.745),(80.375,8.915),(80.545,8.915),(80.545,8.745),(80.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.745),(80.735,8.915),(80.905,8.915),(80.905,8.745),(80.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.745),(81.095,8.915),(81.265,8.915),(81.265,8.745),(81.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.745),(81.455,8.915),(81.625,8.915),(81.625,8.745),(81.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.105),(80.375,9.275),(80.545,9.275),(80.545,9.105),(80.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.105),(80.735,9.275),(80.905,9.275),(80.905,9.105),(80.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.105),(81.095,9.275),(81.265,9.275),(81.265,9.105),(81.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.105),(81.455,9.275),(81.625,9.275),(81.625,9.105),(81.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.465),(80.375,9.635),(80.545,9.635),(80.545,9.465),(80.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.465),(80.735,9.635),(80.905,9.635),(80.905,9.465),(80.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.465),(81.095,9.635),(81.265,9.635),(81.265,9.465),(81.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.465),(81.455,9.635),(81.625,9.635),(81.625,9.465),(81.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.825),(80.375,9.995),(80.545,9.995),(80.545,9.825),(80.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.825),(80.735,9.995),(80.905,9.995),(80.905,9.825),(80.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.825),(81.095,9.995),(81.265,9.995),(81.265,9.825),(81.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.825),(81.455,9.995),(81.625,9.995),(81.625,9.825),(81.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.185),(80.375,10.355),(80.545,10.355),(80.545,10.185),(80.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.185),(80.735,10.355),(80.905,10.355),(80.905,10.185),(80.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.185),(81.095,10.355),(81.265,10.355),(81.265,10.185),(81.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.185),(81.455,10.355),(81.625,10.355),(81.625,10.185),(81.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.545),(80.375,10.715),(80.545,10.715),(80.545,10.545),(80.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.545),(80.735,10.715),(80.905,10.715),(80.905,10.545),(80.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.545),(81.095,10.715),(81.265,10.715),(81.265,10.545),(81.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.545),(81.455,10.715),(81.625,10.715),(81.625,10.545),(81.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.905),(80.375,11.075),(80.545,11.075),(80.545,10.905),(80.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.905),(80.735,11.075),(80.905,11.075),(80.905,10.905),(80.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.905),(81.095,11.075),(81.265,11.075),(81.265,10.905),(81.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.905),(81.455,11.075),(81.625,11.075),(81.625,10.905),(81.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.265),(80.375,11.435),(80.545,11.435),(80.545,11.265),(80.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.265),(80.735,11.435),(80.905,11.435),(80.905,11.265),(80.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.265),(81.095,11.435),(81.265,11.435),(81.265,11.265),(81.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.265),(81.455,11.435),(81.625,11.435),(81.625,11.265),(81.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.625),(80.375,11.795),(80.545,11.795),(80.545,11.625),(80.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.625),(80.735,11.795),(80.905,11.795),(80.905,11.625),(80.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.625),(81.095,11.795),(81.265,11.795),(81.265,11.625),(81.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.625),(81.455,11.795),(81.625,11.795),(81.625,11.625),(81.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.985),(80.375,12.155),(80.545,12.155),(80.545,11.985),(80.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.985),(80.735,12.155),(80.905,12.155),(80.905,11.985),(80.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.985),(81.095,12.155),(81.265,12.155),(81.265,11.985),(81.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.985),(81.455,12.155),(81.625,12.155),(81.625,11.985),(81.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.345),(80.375,12.515),(80.545,12.515),(80.545,12.345),(80.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.345),(80.735,12.515),(80.905,12.515),(80.905,12.345),(80.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.345),(81.095,12.515),(81.265,12.515),(81.265,12.345),(81.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.345),(81.455,12.515),(81.625,12.515),(81.625,12.345),(81.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.705),(80.375,12.875),(80.545,12.875),(80.545,12.705),(80.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.705),(80.735,12.875),(80.905,12.875),(80.905,12.705),(80.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.705),(81.095,12.875),(81.265,12.875),(81.265,12.705),(81.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.705),(81.455,12.875),(81.625,12.875),(81.625,12.705),(81.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.065),(80.375,13.235),(80.545,13.235),(80.545,13.065),(80.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.065),(80.735,13.235),(80.905,13.235),(80.905,13.065),(80.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.065),(81.095,13.235),(81.265,13.235),(81.265,13.065),(81.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.065),(81.455,13.235),(81.625,13.235),(81.625,13.065),(81.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.425),(80.375,13.595),(80.545,13.595),(80.545,13.425),(80.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.425),(80.735,13.595),(80.905,13.595),(80.905,13.425),(80.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.425),(81.095,13.595),(81.265,13.595),(81.265,13.425),(81.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.425),(81.455,13.595),(81.625,13.595),(81.625,13.425),(81.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.785),(80.375,13.955),(80.545,13.955),(80.545,13.785),(80.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.785),(80.735,13.955),(80.905,13.955),(80.905,13.785),(80.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.785),(81.095,13.955),(81.265,13.955),(81.265,13.785),(81.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.785),(81.455,13.955),(81.625,13.955),(81.625,13.785),(81.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.145),(80.375,14.315),(80.545,14.315),(80.545,14.145),(80.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.145),(80.735,14.315),(80.905,14.315),(80.905,14.145),(80.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.145),(81.095,14.315),(81.265,14.315),(81.265,14.145),(81.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.145),(81.455,14.315),(81.625,14.315),(81.625,14.145),(81.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.505),(80.375,14.675),(80.545,14.675),(80.545,14.505),(80.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.505),(80.735,14.675),(80.905,14.675),(80.905,14.505),(80.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.505),(81.095,14.675),(81.265,14.675),(81.265,14.505),(81.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.505),(81.455,14.675),(81.625,14.675),(81.625,14.505),(81.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.865),(80.375,15.035),(80.545,15.035),(80.545,14.865),(80.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.865),(80.735,15.035),(80.905,15.035),(80.905,14.865),(80.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.865),(81.095,15.035),(81.265,15.035),(81.265,14.865),(81.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.865),(81.455,15.035),(81.625,15.035),(81.625,14.865),(81.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.225),(80.375,15.395),(80.545,15.395),(80.545,15.225),(80.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.225),(80.735,15.395),(80.905,15.395),(80.905,15.225),(80.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.225),(81.095,15.395),(81.265,15.395),(81.265,15.225),(81.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.225),(81.455,15.395),(81.625,15.395),(81.625,15.225),(81.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.585),(80.375,15.755),(80.545,15.755),(80.545,15.585),(80.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.585),(80.735,15.755),(80.905,15.755),(80.905,15.585),(80.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.585),(81.095,15.755),(81.265,15.755),(81.265,15.585),(81.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.585),(81.455,15.755),(81.625,15.755),(81.625,15.585),(81.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.945),(80.375,16.115),(80.545,16.115),(80.545,15.945),(80.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.945),(80.735,16.115),(80.905,16.115),(80.905,15.945),(80.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.945),(81.095,16.115),(81.265,16.115),(81.265,15.945),(81.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.945),(81.455,16.115),(81.625,16.115),(81.625,15.945),(81.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.305),(80.375,16.475),(80.545,16.475),(80.545,16.305),(80.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.305),(80.735,16.475),(80.905,16.475),(80.905,16.305),(80.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.305),(81.095,16.475),(81.265,16.475),(81.265,16.305),(81.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.305),(81.455,16.475),(81.625,16.475),(81.625,16.305),(81.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.665),(80.375,16.835),(80.545,16.835),(80.545,16.665),(80.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.665),(80.735,16.835),(80.905,16.835),(80.905,16.665),(80.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.665),(81.095,16.835),(81.265,16.835),(81.265,16.665),(81.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.665),(81.455,16.835),(81.625,16.835),(81.625,16.665),(81.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.025),(80.375,17.195),(80.545,17.195),(80.545,17.025),(80.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.025),(80.735,17.195),(80.905,17.195),(80.905,17.025),(80.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.025),(81.095,17.195),(81.265,17.195),(81.265,17.025),(81.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.025),(81.455,17.195),(81.625,17.195),(81.625,17.025),(81.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.385),(80.375,17.555),(80.545,17.555),(80.545,17.385),(80.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.385),(80.735,17.555),(80.905,17.555),(80.905,17.385),(80.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.385),(81.095,17.555),(81.265,17.555),(81.265,17.385),(81.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.385),(81.455,17.555),(81.625,17.555),(81.625,17.385),(81.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.745),(80.375,17.915),(80.545,17.915),(80.545,17.745),(80.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.745),(80.735,17.915),(80.905,17.915),(80.905,17.745),(80.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.745),(81.095,17.915),(81.265,17.915),(81.265,17.745),(81.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.745),(81.455,17.915),(81.625,17.915),(81.625,17.745),(81.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.105),(80.375,18.275),(80.545,18.275),(80.545,18.105),(80.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.105),(80.735,18.275),(80.905,18.275),(80.905,18.105),(80.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.105),(81.095,18.275),(81.265,18.275),(81.265,18.105),(81.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.105),(81.455,18.275),(81.625,18.275),(81.625,18.105),(81.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.465),(80.375,18.635),(80.545,18.635),(80.545,18.465),(80.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.465),(80.735,18.635),(80.905,18.635),(80.905,18.465),(80.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.465),(81.095,18.635),(81.265,18.635),(81.265,18.465),(81.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.465),(81.455,18.635),(81.625,18.635),(81.625,18.465),(81.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.825),(80.375,18.995),(80.545,18.995),(80.545,18.825),(80.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.825),(80.735,18.995),(80.905,18.995),(80.905,18.825),(80.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.825),(81.095,18.995),(81.265,18.995),(81.265,18.825),(81.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.825),(81.455,18.995),(81.625,18.995),(81.625,18.825),(81.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.185),(80.375,19.355),(80.545,19.355),(80.545,19.185),(80.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.185),(80.735,19.355),(80.905,19.355),(80.905,19.185),(80.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.185),(81.095,19.355),(81.265,19.355),(81.265,19.185),(81.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.185),(81.455,19.355),(81.625,19.355),(81.625,19.185),(81.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.985),(41.975,3.155),(42.145,3.155),(42.145,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.985),(42.335,3.155),(42.505,3.155),(42.505,2.985),(42.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.985),(42.695,3.155),(42.865,3.155),(42.865,2.985),(42.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.985),(43.055,3.155),(43.225,3.155),(43.225,2.985),(43.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.345),(41.975,3.515),(42.145,3.515),(42.145,3.345),(41.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.345),(42.335,3.515),(42.505,3.515),(42.505,3.345),(42.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.345),(42.695,3.515),(42.865,3.515),(42.865,3.345),(42.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.345),(43.055,3.515),(43.225,3.515),(43.225,3.345),(43.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.705),(41.975,3.875),(42.145,3.875),(42.145,3.705),(41.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.705),(42.335,3.875),(42.505,3.875),(42.505,3.705),(42.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.705),(42.695,3.875),(42.865,3.875),(42.865,3.705),(42.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.705),(43.055,3.875),(43.225,3.875),(43.225,3.705),(43.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.065),(41.975,4.235),(42.145,4.235),(42.145,4.065),(41.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.065),(42.335,4.235),(42.505,4.235),(42.505,4.065),(42.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.065),(42.695,4.235),(42.865,4.235),(42.865,4.065),(42.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.065),(43.055,4.235),(43.225,4.235),(43.225,4.065),(43.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.425),(41.975,4.595),(42.145,4.595),(42.145,4.425),(41.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.425),(42.335,4.595),(42.505,4.595),(42.505,4.425),(42.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.425),(42.695,4.595),(42.865,4.595),(42.865,4.425),(42.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.425),(43.055,4.595),(43.225,4.595),(43.225,4.425),(43.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.785),(41.975,4.955),(42.145,4.955),(42.145,4.785),(41.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.785),(42.335,4.955),(42.505,4.955),(42.505,4.785),(42.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.785),(42.695,4.955),(42.865,4.955),(42.865,4.785),(42.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.785),(43.055,4.955),(43.225,4.955),(43.225,4.785),(43.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.145),(41.975,5.315),(42.145,5.315),(42.145,5.145),(41.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.145),(42.335,5.315),(42.505,5.315),(42.505,5.145),(42.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.145),(42.695,5.315),(42.865,5.315),(42.865,5.145),(42.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.145),(43.055,5.315),(43.225,5.315),(43.225,5.145),(43.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.505),(41.975,5.675),(42.145,5.675),(42.145,5.505),(41.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.505),(42.335,5.675),(42.505,5.675),(42.505,5.505),(42.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.505),(42.695,5.675),(42.865,5.675),(42.865,5.505),(42.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.505),(43.055,5.675),(43.225,5.675),(43.225,5.505),(43.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.865),(41.975,6.035),(42.145,6.035),(42.145,5.865),(41.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.865),(42.335,6.035),(42.505,6.035),(42.505,5.865),(42.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.865),(42.695,6.035),(42.865,6.035),(42.865,5.865),(42.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.865),(43.055,6.035),(43.225,6.035),(43.225,5.865),(43.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.225),(41.975,6.395),(42.145,6.395),(42.145,6.225),(41.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.225),(42.335,6.395),(42.505,6.395),(42.505,6.225),(42.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.225),(42.695,6.395),(42.865,6.395),(42.865,6.225),(42.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.225),(43.055,6.395),(43.225,6.395),(43.225,6.225),(43.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.585),(41.975,6.755),(42.145,6.755),(42.145,6.585),(41.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.585),(42.335,6.755),(42.505,6.755),(42.505,6.585),(42.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.585),(42.695,6.755),(42.865,6.755),(42.865,6.585),(42.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.585),(43.055,6.755),(43.225,6.755),(43.225,6.585),(43.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.945),(41.975,7.115),(42.145,7.115),(42.145,6.945),(41.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.945),(42.335,7.115),(42.505,7.115),(42.505,6.945),(42.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.945),(42.695,7.115),(42.865,7.115),(42.865,6.945),(42.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.945),(43.055,7.115),(43.225,7.115),(43.225,6.945),(43.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.305),(41.975,7.475),(42.145,7.475),(42.145,7.305),(41.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.305),(42.335,7.475),(42.505,7.475),(42.505,7.305),(42.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.305),(42.695,7.475),(42.865,7.475),(42.865,7.305),(42.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.305),(43.055,7.475),(43.225,7.475),(43.225,7.305),(43.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.665),(41.975,7.835),(42.145,7.835),(42.145,7.665),(41.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.665),(42.335,7.835),(42.505,7.835),(42.505,7.665),(42.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.665),(42.695,7.835),(42.865,7.835),(42.865,7.665),(42.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.665),(43.055,7.835),(43.225,7.835),(43.225,7.665),(43.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.025),(41.975,8.195),(42.145,8.195),(42.145,8.025),(41.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.025),(42.335,8.195),(42.505,8.195),(42.505,8.025),(42.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.025),(42.695,8.195),(42.865,8.195),(42.865,8.025),(42.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.025),(43.055,8.195),(43.225,8.195),(43.225,8.025),(43.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.385),(41.975,8.555),(42.145,8.555),(42.145,8.385),(41.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.385),(42.335,8.555),(42.505,8.555),(42.505,8.385),(42.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.385),(42.695,8.555),(42.865,8.555),(42.865,8.385),(42.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.385),(43.055,8.555),(43.225,8.555),(43.225,8.385),(43.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.745),(41.975,8.915),(42.145,8.915),(42.145,8.745),(41.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.745),(42.335,8.915),(42.505,8.915),(42.505,8.745),(42.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.745),(42.695,8.915),(42.865,8.915),(42.865,8.745),(42.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.745),(43.055,8.915),(43.225,8.915),(43.225,8.745),(43.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.105),(41.975,9.275),(42.145,9.275),(42.145,9.105),(41.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.105),(42.335,9.275),(42.505,9.275),(42.505,9.105),(42.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.105),(42.695,9.275),(42.865,9.275),(42.865,9.105),(42.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.105),(43.055,9.275),(43.225,9.275),(43.225,9.105),(43.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.465),(41.975,9.635),(42.145,9.635),(42.145,9.465),(41.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.465),(42.335,9.635),(42.505,9.635),(42.505,9.465),(42.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.465),(42.695,9.635),(42.865,9.635),(42.865,9.465),(42.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.465),(43.055,9.635),(43.225,9.635),(43.225,9.465),(43.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.825),(41.975,9.995),(42.145,9.995),(42.145,9.825),(41.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.825),(42.335,9.995),(42.505,9.995),(42.505,9.825),(42.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.825),(42.695,9.995),(42.865,9.995),(42.865,9.825),(42.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.825),(43.055,9.995),(43.225,9.995),(43.225,9.825),(43.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.185),(41.975,10.355),(42.145,10.355),(42.145,10.185),(41.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.185),(42.335,10.355),(42.505,10.355),(42.505,10.185),(42.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.185),(42.695,10.355),(42.865,10.355),(42.865,10.185),(42.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.185),(43.055,10.355),(43.225,10.355),(43.225,10.185),(43.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.545),(41.975,10.715),(42.145,10.715),(42.145,10.545),(41.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.545),(42.335,10.715),(42.505,10.715),(42.505,10.545),(42.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.545),(42.695,10.715),(42.865,10.715),(42.865,10.545),(42.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.545),(43.055,10.715),(43.225,10.715),(43.225,10.545),(43.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.905),(41.975,11.075),(42.145,11.075),(42.145,10.905),(41.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.905),(42.335,11.075),(42.505,11.075),(42.505,10.905),(42.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.905),(42.695,11.075),(42.865,11.075),(42.865,10.905),(42.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.905),(43.055,11.075),(43.225,11.075),(43.225,10.905),(43.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.265),(41.975,11.435),(42.145,11.435),(42.145,11.265),(41.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.265),(42.335,11.435),(42.505,11.435),(42.505,11.265),(42.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.265),(42.695,11.435),(42.865,11.435),(42.865,11.265),(42.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.265),(43.055,11.435),(43.225,11.435),(43.225,11.265),(43.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.625),(41.975,11.795),(42.145,11.795),(42.145,11.625),(41.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.625),(42.335,11.795),(42.505,11.795),(42.505,11.625),(42.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.625),(42.695,11.795),(42.865,11.795),(42.865,11.625),(42.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.625),(43.055,11.795),(43.225,11.795),(43.225,11.625),(43.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.985),(41.975,12.155),(42.145,12.155),(42.145,11.985),(41.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.985),(42.335,12.155),(42.505,12.155),(42.505,11.985),(42.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.985),(42.695,12.155),(42.865,12.155),(42.865,11.985),(42.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.985),(43.055,12.155),(43.225,12.155),(43.225,11.985),(43.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.345),(41.975,12.515),(42.145,12.515),(42.145,12.345),(41.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.345),(42.335,12.515),(42.505,12.515),(42.505,12.345),(42.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.345),(42.695,12.515),(42.865,12.515),(42.865,12.345),(42.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.345),(43.055,12.515),(43.225,12.515),(43.225,12.345),(43.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.705),(41.975,12.875),(42.145,12.875),(42.145,12.705),(41.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.705),(42.335,12.875),(42.505,12.875),(42.505,12.705),(42.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.705),(42.695,12.875),(42.865,12.875),(42.865,12.705),(42.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.705),(43.055,12.875),(43.225,12.875),(43.225,12.705),(43.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.065),(41.975,13.235),(42.145,13.235),(42.145,13.065),(41.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.065),(42.335,13.235),(42.505,13.235),(42.505,13.065),(42.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.065),(42.695,13.235),(42.865,13.235),(42.865,13.065),(42.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.065),(43.055,13.235),(43.225,13.235),(43.225,13.065),(43.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.425),(41.975,13.595),(42.145,13.595),(42.145,13.425),(41.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.425),(42.335,13.595),(42.505,13.595),(42.505,13.425),(42.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.425),(42.695,13.595),(42.865,13.595),(42.865,13.425),(42.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.425),(43.055,13.595),(43.225,13.595),(43.225,13.425),(43.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.785),(41.975,13.955),(42.145,13.955),(42.145,13.785),(41.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.785),(42.335,13.955),(42.505,13.955),(42.505,13.785),(42.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.785),(42.695,13.955),(42.865,13.955),(42.865,13.785),(42.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.785),(43.055,13.955),(43.225,13.955),(43.225,13.785),(43.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.145),(41.975,14.315),(42.145,14.315),(42.145,14.145),(41.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.145),(42.335,14.315),(42.505,14.315),(42.505,14.145),(42.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.145),(42.695,14.315),(42.865,14.315),(42.865,14.145),(42.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.145),(43.055,14.315),(43.225,14.315),(43.225,14.145),(43.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.505),(41.975,14.675),(42.145,14.675),(42.145,14.505),(41.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.505),(42.335,14.675),(42.505,14.675),(42.505,14.505),(42.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.505),(42.695,14.675),(42.865,14.675),(42.865,14.505),(42.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.505),(43.055,14.675),(43.225,14.675),(43.225,14.505),(43.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.865),(41.975,15.035),(42.145,15.035),(42.145,14.865),(41.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.865),(42.335,15.035),(42.505,15.035),(42.505,14.865),(42.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.865),(42.695,15.035),(42.865,15.035),(42.865,14.865),(42.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.865),(43.055,15.035),(43.225,15.035),(43.225,14.865),(43.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.225),(41.975,15.395),(42.145,15.395),(42.145,15.225),(41.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.225),(42.335,15.395),(42.505,15.395),(42.505,15.225),(42.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.225),(42.695,15.395),(42.865,15.395),(42.865,15.225),(42.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.225),(43.055,15.395),(43.225,15.395),(43.225,15.225),(43.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.585),(41.975,15.755),(42.145,15.755),(42.145,15.585),(41.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.585),(42.335,15.755),(42.505,15.755),(42.505,15.585),(42.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.585),(42.695,15.755),(42.865,15.755),(42.865,15.585),(42.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.585),(43.055,15.755),(43.225,15.755),(43.225,15.585),(43.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.945),(41.975,16.115),(42.145,16.115),(42.145,15.945),(41.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.945),(42.335,16.115),(42.505,16.115),(42.505,15.945),(42.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.945),(42.695,16.115),(42.865,16.115),(42.865,15.945),(42.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.945),(43.055,16.115),(43.225,16.115),(43.225,15.945),(43.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.305),(41.975,16.475),(42.145,16.475),(42.145,16.305),(41.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.305),(42.335,16.475),(42.505,16.475),(42.505,16.305),(42.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.305),(42.695,16.475),(42.865,16.475),(42.865,16.305),(42.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.305),(43.055,16.475),(43.225,16.475),(43.225,16.305),(43.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.665),(41.975,16.835),(42.145,16.835),(42.145,16.665),(41.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.665),(42.335,16.835),(42.505,16.835),(42.505,16.665),(42.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.665),(42.695,16.835),(42.865,16.835),(42.865,16.665),(42.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.665),(43.055,16.835),(43.225,16.835),(43.225,16.665),(43.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.025),(41.975,17.195),(42.145,17.195),(42.145,17.025),(41.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.025),(42.335,17.195),(42.505,17.195),(42.505,17.025),(42.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.025),(42.695,17.195),(42.865,17.195),(42.865,17.025),(42.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.025),(43.055,17.195),(43.225,17.195),(43.225,17.025),(43.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.385),(41.975,17.555),(42.145,17.555),(42.145,17.385),(41.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.385),(42.335,17.555),(42.505,17.555),(42.505,17.385),(42.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.385),(42.695,17.555),(42.865,17.555),(42.865,17.385),(42.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.385),(43.055,17.555),(43.225,17.555),(43.225,17.385),(43.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.745),(41.975,17.915),(42.145,17.915),(42.145,17.745),(41.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.745),(42.335,17.915),(42.505,17.915),(42.505,17.745),(42.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.745),(42.695,17.915),(42.865,17.915),(42.865,17.745),(42.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.745),(43.055,17.915),(43.225,17.915),(43.225,17.745),(43.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.105),(41.975,18.275),(42.145,18.275),(42.145,18.105),(41.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.105),(42.335,18.275),(42.505,18.275),(42.505,18.105),(42.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.105),(42.695,18.275),(42.865,18.275),(42.865,18.105),(42.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.105),(43.055,18.275),(43.225,18.275),(43.225,18.105),(43.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.465),(41.975,18.635),(42.145,18.635),(42.145,18.465),(41.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.465),(42.335,18.635),(42.505,18.635),(42.505,18.465),(42.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.465),(42.695,18.635),(42.865,18.635),(42.865,18.465),(42.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.465),(43.055,18.635),(43.225,18.635),(43.225,18.465),(43.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.825),(41.975,18.995),(42.145,18.995),(42.145,18.825),(41.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.825),(42.335,18.995),(42.505,18.995),(42.505,18.825),(42.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.825),(42.695,18.995),(42.865,18.995),(42.865,18.825),(42.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.825),(43.055,18.995),(43.225,18.995),(43.225,18.825),(43.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.185),(41.975,19.355),(42.145,19.355),(42.145,19.185),(41.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.185),(42.335,19.355),(42.505,19.355),(42.505,19.185),(42.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.185),(42.695,19.355),(42.865,19.355),(42.865,19.185),(42.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.185),(43.055,19.355),(43.225,19.355),(43.225,19.185),(43.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.985),(46.775,3.155),(46.945,3.155),(46.945,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.985),(47.135,3.155),(47.305,3.155),(47.305,2.985),(47.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.985),(47.495,3.155),(47.665,3.155),(47.665,2.985),(47.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.985),(47.855,3.155),(48.025,3.155),(48.025,2.985),(47.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.345),(46.775,3.515),(46.945,3.515),(46.945,3.345),(46.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.345),(47.135,3.515),(47.305,3.515),(47.305,3.345),(47.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.345),(47.495,3.515),(47.665,3.515),(47.665,3.345),(47.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.345),(47.855,3.515),(48.025,3.515),(48.025,3.345),(47.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.705),(46.775,3.875),(46.945,3.875),(46.945,3.705),(46.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.705),(47.135,3.875),(47.305,3.875),(47.305,3.705),(47.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.705),(47.495,3.875),(47.665,3.875),(47.665,3.705),(47.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.705),(47.855,3.875),(48.025,3.875),(48.025,3.705),(47.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.065),(46.775,4.235),(46.945,4.235),(46.945,4.065),(46.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.065),(47.135,4.235),(47.305,4.235),(47.305,4.065),(47.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.065),(47.495,4.235),(47.665,4.235),(47.665,4.065),(47.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.065),(47.855,4.235),(48.025,4.235),(48.025,4.065),(47.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.425),(46.775,4.595),(46.945,4.595),(46.945,4.425),(46.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.425),(47.135,4.595),(47.305,4.595),(47.305,4.425),(47.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.425),(47.495,4.595),(47.665,4.595),(47.665,4.425),(47.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.425),(47.855,4.595),(48.025,4.595),(48.025,4.425),(47.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.785),(46.775,4.955),(46.945,4.955),(46.945,4.785),(46.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.785),(47.135,4.955),(47.305,4.955),(47.305,4.785),(47.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.785),(47.495,4.955),(47.665,4.955),(47.665,4.785),(47.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.785),(47.855,4.955),(48.025,4.955),(48.025,4.785),(47.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.145),(46.775,5.315),(46.945,5.315),(46.945,5.145),(46.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.145),(47.135,5.315),(47.305,5.315),(47.305,5.145),(47.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.145),(47.495,5.315),(47.665,5.315),(47.665,5.145),(47.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.145),(47.855,5.315),(48.025,5.315),(48.025,5.145),(47.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.505),(46.775,5.675),(46.945,5.675),(46.945,5.505),(46.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.505),(47.135,5.675),(47.305,5.675),(47.305,5.505),(47.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.505),(47.495,5.675),(47.665,5.675),(47.665,5.505),(47.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.505),(47.855,5.675),(48.025,5.675),(48.025,5.505),(47.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.865),(46.775,6.035),(46.945,6.035),(46.945,5.865),(46.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.865),(47.135,6.035),(47.305,6.035),(47.305,5.865),(47.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.865),(47.495,6.035),(47.665,6.035),(47.665,5.865),(47.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.865),(47.855,6.035),(48.025,6.035),(48.025,5.865),(47.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.225),(46.775,6.395),(46.945,6.395),(46.945,6.225),(46.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.225),(47.135,6.395),(47.305,6.395),(47.305,6.225),(47.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.225),(47.495,6.395),(47.665,6.395),(47.665,6.225),(47.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.225),(47.855,6.395),(48.025,6.395),(48.025,6.225),(47.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.585),(46.775,6.755),(46.945,6.755),(46.945,6.585),(46.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.585),(47.135,6.755),(47.305,6.755),(47.305,6.585),(47.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.585),(47.495,6.755),(47.665,6.755),(47.665,6.585),(47.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.585),(47.855,6.755),(48.025,6.755),(48.025,6.585),(47.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.945),(46.775,7.115),(46.945,7.115),(46.945,6.945),(46.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.945),(47.135,7.115),(47.305,7.115),(47.305,6.945),(47.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.945),(47.495,7.115),(47.665,7.115),(47.665,6.945),(47.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.945),(47.855,7.115),(48.025,7.115),(48.025,6.945),(47.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.305),(46.775,7.475),(46.945,7.475),(46.945,7.305),(46.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.305),(47.135,7.475),(47.305,7.475),(47.305,7.305),(47.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.305),(47.495,7.475),(47.665,7.475),(47.665,7.305),(47.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.305),(47.855,7.475),(48.025,7.475),(48.025,7.305),(47.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.665),(46.775,7.835),(46.945,7.835),(46.945,7.665),(46.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.665),(47.135,7.835),(47.305,7.835),(47.305,7.665),(47.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.665),(47.495,7.835),(47.665,7.835),(47.665,7.665),(47.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.665),(47.855,7.835),(48.025,7.835),(48.025,7.665),(47.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.025),(46.775,8.195),(46.945,8.195),(46.945,8.025),(46.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.025),(47.135,8.195),(47.305,8.195),(47.305,8.025),(47.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.025),(47.495,8.195),(47.665,8.195),(47.665,8.025),(47.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.025),(47.855,8.195),(48.025,8.195),(48.025,8.025),(47.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.385),(46.775,8.555),(46.945,8.555),(46.945,8.385),(46.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.385),(47.135,8.555),(47.305,8.555),(47.305,8.385),(47.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.385),(47.495,8.555),(47.665,8.555),(47.665,8.385),(47.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.385),(47.855,8.555),(48.025,8.555),(48.025,8.385),(47.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.745),(46.775,8.915),(46.945,8.915),(46.945,8.745),(46.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.745),(47.135,8.915),(47.305,8.915),(47.305,8.745),(47.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.745),(47.495,8.915),(47.665,8.915),(47.665,8.745),(47.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.745),(47.855,8.915),(48.025,8.915),(48.025,8.745),(47.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.105),(46.775,9.275),(46.945,9.275),(46.945,9.105),(46.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.105),(47.135,9.275),(47.305,9.275),(47.305,9.105),(47.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.105),(47.495,9.275),(47.665,9.275),(47.665,9.105),(47.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.105),(47.855,9.275),(48.025,9.275),(48.025,9.105),(47.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.465),(46.775,9.635),(46.945,9.635),(46.945,9.465),(46.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.465),(47.135,9.635),(47.305,9.635),(47.305,9.465),(47.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.465),(47.495,9.635),(47.665,9.635),(47.665,9.465),(47.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.465),(47.855,9.635),(48.025,9.635),(48.025,9.465),(47.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.825),(46.775,9.995),(46.945,9.995),(46.945,9.825),(46.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.825),(47.135,9.995),(47.305,9.995),(47.305,9.825),(47.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.825),(47.495,9.995),(47.665,9.995),(47.665,9.825),(47.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.825),(47.855,9.995),(48.025,9.995),(48.025,9.825),(47.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.185),(46.775,10.355),(46.945,10.355),(46.945,10.185),(46.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.185),(47.135,10.355),(47.305,10.355),(47.305,10.185),(47.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.185),(47.495,10.355),(47.665,10.355),(47.665,10.185),(47.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.185),(47.855,10.355),(48.025,10.355),(48.025,10.185),(47.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.545),(46.775,10.715),(46.945,10.715),(46.945,10.545),(46.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.545),(47.135,10.715),(47.305,10.715),(47.305,10.545),(47.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.545),(47.495,10.715),(47.665,10.715),(47.665,10.545),(47.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.545),(47.855,10.715),(48.025,10.715),(48.025,10.545),(47.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.905),(46.775,11.075),(46.945,11.075),(46.945,10.905),(46.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.905),(47.135,11.075),(47.305,11.075),(47.305,10.905),(47.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.905),(47.495,11.075),(47.665,11.075),(47.665,10.905),(47.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.905),(47.855,11.075),(48.025,11.075),(48.025,10.905),(47.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.265),(46.775,11.435),(46.945,11.435),(46.945,11.265),(46.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.265),(47.135,11.435),(47.305,11.435),(47.305,11.265),(47.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.265),(47.495,11.435),(47.665,11.435),(47.665,11.265),(47.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.265),(47.855,11.435),(48.025,11.435),(48.025,11.265),(47.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.625),(46.775,11.795),(46.945,11.795),(46.945,11.625),(46.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.625),(47.135,11.795),(47.305,11.795),(47.305,11.625),(47.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.625),(47.495,11.795),(47.665,11.795),(47.665,11.625),(47.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.625),(47.855,11.795),(48.025,11.795),(48.025,11.625),(47.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.985),(46.775,12.155),(46.945,12.155),(46.945,11.985),(46.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.985),(47.135,12.155),(47.305,12.155),(47.305,11.985),(47.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.985),(47.495,12.155),(47.665,12.155),(47.665,11.985),(47.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.985),(47.855,12.155),(48.025,12.155),(48.025,11.985),(47.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.345),(46.775,12.515),(46.945,12.515),(46.945,12.345),(46.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.345),(47.135,12.515),(47.305,12.515),(47.305,12.345),(47.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.345),(47.495,12.515),(47.665,12.515),(47.665,12.345),(47.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.345),(47.855,12.515),(48.025,12.515),(48.025,12.345),(47.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.705),(46.775,12.875),(46.945,12.875),(46.945,12.705),(46.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.705),(47.135,12.875),(47.305,12.875),(47.305,12.705),(47.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.705),(47.495,12.875),(47.665,12.875),(47.665,12.705),(47.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.705),(47.855,12.875),(48.025,12.875),(48.025,12.705),(47.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.065),(46.775,13.235),(46.945,13.235),(46.945,13.065),(46.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.065),(47.135,13.235),(47.305,13.235),(47.305,13.065),(47.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.065),(47.495,13.235),(47.665,13.235),(47.665,13.065),(47.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.065),(47.855,13.235),(48.025,13.235),(48.025,13.065),(47.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.425),(46.775,13.595),(46.945,13.595),(46.945,13.425),(46.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.425),(47.135,13.595),(47.305,13.595),(47.305,13.425),(47.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.425),(47.495,13.595),(47.665,13.595),(47.665,13.425),(47.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.425),(47.855,13.595),(48.025,13.595),(48.025,13.425),(47.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.785),(46.775,13.955),(46.945,13.955),(46.945,13.785),(46.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.785),(47.135,13.955),(47.305,13.955),(47.305,13.785),(47.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.785),(47.495,13.955),(47.665,13.955),(47.665,13.785),(47.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.785),(47.855,13.955),(48.025,13.955),(48.025,13.785),(47.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.145),(46.775,14.315),(46.945,14.315),(46.945,14.145),(46.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.145),(47.135,14.315),(47.305,14.315),(47.305,14.145),(47.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.145),(47.495,14.315),(47.665,14.315),(47.665,14.145),(47.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.145),(47.855,14.315),(48.025,14.315),(48.025,14.145),(47.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.505),(46.775,14.675),(46.945,14.675),(46.945,14.505),(46.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.505),(47.135,14.675),(47.305,14.675),(47.305,14.505),(47.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.505),(47.495,14.675),(47.665,14.675),(47.665,14.505),(47.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.505),(47.855,14.675),(48.025,14.675),(48.025,14.505),(47.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.865),(46.775,15.035),(46.945,15.035),(46.945,14.865),(46.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.865),(47.135,15.035),(47.305,15.035),(47.305,14.865),(47.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.865),(47.495,15.035),(47.665,15.035),(47.665,14.865),(47.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.865),(47.855,15.035),(48.025,15.035),(48.025,14.865),(47.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.225),(46.775,15.395),(46.945,15.395),(46.945,15.225),(46.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.225),(47.135,15.395),(47.305,15.395),(47.305,15.225),(47.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.225),(47.495,15.395),(47.665,15.395),(47.665,15.225),(47.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.225),(47.855,15.395),(48.025,15.395),(48.025,15.225),(47.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.585),(46.775,15.755),(46.945,15.755),(46.945,15.585),(46.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.585),(47.135,15.755),(47.305,15.755),(47.305,15.585),(47.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.585),(47.495,15.755),(47.665,15.755),(47.665,15.585),(47.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.585),(47.855,15.755),(48.025,15.755),(48.025,15.585),(47.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.945),(46.775,16.115),(46.945,16.115),(46.945,15.945),(46.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.945),(47.135,16.115),(47.305,16.115),(47.305,15.945),(47.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.945),(47.495,16.115),(47.665,16.115),(47.665,15.945),(47.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.945),(47.855,16.115),(48.025,16.115),(48.025,15.945),(47.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.305),(46.775,16.475),(46.945,16.475),(46.945,16.305),(46.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.305),(47.135,16.475),(47.305,16.475),(47.305,16.305),(47.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.305),(47.495,16.475),(47.665,16.475),(47.665,16.305),(47.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.305),(47.855,16.475),(48.025,16.475),(48.025,16.305),(47.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.665),(46.775,16.835),(46.945,16.835),(46.945,16.665),(46.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.665),(47.135,16.835),(47.305,16.835),(47.305,16.665),(47.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.665),(47.495,16.835),(47.665,16.835),(47.665,16.665),(47.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.665),(47.855,16.835),(48.025,16.835),(48.025,16.665),(47.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.025),(46.775,17.195),(46.945,17.195),(46.945,17.025),(46.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.025),(47.135,17.195),(47.305,17.195),(47.305,17.025),(47.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.025),(47.495,17.195),(47.665,17.195),(47.665,17.025),(47.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.025),(47.855,17.195),(48.025,17.195),(48.025,17.025),(47.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.385),(46.775,17.555),(46.945,17.555),(46.945,17.385),(46.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.385),(47.135,17.555),(47.305,17.555),(47.305,17.385),(47.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.385),(47.495,17.555),(47.665,17.555),(47.665,17.385),(47.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.385),(47.855,17.555),(48.025,17.555),(48.025,17.385),(47.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.745),(46.775,17.915),(46.945,17.915),(46.945,17.745),(46.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.745),(47.135,17.915),(47.305,17.915),(47.305,17.745),(47.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.745),(47.495,17.915),(47.665,17.915),(47.665,17.745),(47.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.745),(47.855,17.915),(48.025,17.915),(48.025,17.745),(47.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.105),(46.775,18.275),(46.945,18.275),(46.945,18.105),(46.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.105),(47.135,18.275),(47.305,18.275),(47.305,18.105),(47.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.105),(47.495,18.275),(47.665,18.275),(47.665,18.105),(47.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.105),(47.855,18.275),(48.025,18.275),(48.025,18.105),(47.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.465),(46.775,18.635),(46.945,18.635),(46.945,18.465),(46.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.465),(47.135,18.635),(47.305,18.635),(47.305,18.465),(47.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.465),(47.495,18.635),(47.665,18.635),(47.665,18.465),(47.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.465),(47.855,18.635),(48.025,18.635),(48.025,18.465),(47.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.825),(46.775,18.995),(46.945,18.995),(46.945,18.825),(46.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.825),(47.135,18.995),(47.305,18.995),(47.305,18.825),(47.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.825),(47.495,18.995),(47.665,18.995),(47.665,18.825),(47.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.825),(47.855,18.995),(48.025,18.995),(48.025,18.825),(47.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.185),(46.775,19.355),(46.945,19.355),(46.945,19.185),(46.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.185),(47.135,19.355),(47.305,19.355),(47.305,19.185),(47.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.185),(47.495,19.355),(47.665,19.355),(47.665,19.185),(47.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.185),(47.855,19.355),(48.025,19.355),(48.025,19.185),(47.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,2.985),(8.375,3.155),(8.545,3.155),(8.545,2.985),(8.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,2.985),(8.735,3.155),(8.905,3.155),(8.905,2.985),(8.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,2.985),(9.095,3.155),(9.265,3.155),(9.265,2.985),(9.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,2.985),(9.455,3.155),(9.625,3.155),(9.625,2.985),(9.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.345),(8.375,3.515),(8.545,3.515),(8.545,3.345),(8.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.345),(8.735,3.515),(8.905,3.515),(8.905,3.345),(8.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.345),(9.095,3.515),(9.265,3.515),(9.265,3.345),(9.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.345),(9.455,3.515),(9.625,3.515),(9.625,3.345),(9.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.705),(8.375,3.875),(8.545,3.875),(8.545,3.705),(8.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.705),(8.735,3.875),(8.905,3.875),(8.905,3.705),(8.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.705),(9.095,3.875),(9.265,3.875),(9.265,3.705),(9.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.705),(9.455,3.875),(9.625,3.875),(9.625,3.705),(9.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.065),(8.375,4.235),(8.545,4.235),(8.545,4.065),(8.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.065),(8.735,4.235),(8.905,4.235),(8.905,4.065),(8.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.065),(9.095,4.235),(9.265,4.235),(9.265,4.065),(9.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.065),(9.455,4.235),(9.625,4.235),(9.625,4.065),(9.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.425),(8.375,4.595),(8.545,4.595),(8.545,4.425),(8.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.425),(8.735,4.595),(8.905,4.595),(8.905,4.425),(8.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.425),(9.095,4.595),(9.265,4.595),(9.265,4.425),(9.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.425),(9.455,4.595),(9.625,4.595),(9.625,4.425),(9.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.785),(8.375,4.955),(8.545,4.955),(8.545,4.785),(8.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.785),(8.735,4.955),(8.905,4.955),(8.905,4.785),(8.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.785),(9.095,4.955),(9.265,4.955),(9.265,4.785),(9.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.785),(9.455,4.955),(9.625,4.955),(9.625,4.785),(9.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.145),(8.375,5.315),(8.545,5.315),(8.545,5.145),(8.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.145),(8.735,5.315),(8.905,5.315),(8.905,5.145),(8.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.145),(9.095,5.315),(9.265,5.315),(9.265,5.145),(9.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.145),(9.455,5.315),(9.625,5.315),(9.625,5.145),(9.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.505),(8.375,5.675),(8.545,5.675),(8.545,5.505),(8.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.505),(8.735,5.675),(8.905,5.675),(8.905,5.505),(8.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.505),(9.095,5.675),(9.265,5.675),(9.265,5.505),(9.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.505),(9.455,5.675),(9.625,5.675),(9.625,5.505),(9.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.865),(8.375,6.035),(8.545,6.035),(8.545,5.865),(8.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.865),(8.735,6.035),(8.905,6.035),(8.905,5.865),(8.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.865),(9.095,6.035),(9.265,6.035),(9.265,5.865),(9.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.865),(9.455,6.035),(9.625,6.035),(9.625,5.865),(9.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.225),(8.375,6.395),(8.545,6.395),(8.545,6.225),(8.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.225),(8.735,6.395),(8.905,6.395),(8.905,6.225),(8.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.225),(9.095,6.395),(9.265,6.395),(9.265,6.225),(9.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.225),(9.455,6.395),(9.625,6.395),(9.625,6.225),(9.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.585),(8.375,6.755),(8.545,6.755),(8.545,6.585),(8.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.585),(8.735,6.755),(8.905,6.755),(8.905,6.585),(8.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.585),(9.095,6.755),(9.265,6.755),(9.265,6.585),(9.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.585),(9.455,6.755),(9.625,6.755),(9.625,6.585),(9.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.945),(8.375,7.115),(8.545,7.115),(8.545,6.945),(8.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.945),(8.735,7.115),(8.905,7.115),(8.905,6.945),(8.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.945),(9.095,7.115),(9.265,7.115),(9.265,6.945),(9.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.945),(9.455,7.115),(9.625,7.115),(9.625,6.945),(9.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.305),(8.375,7.475),(8.545,7.475),(8.545,7.305),(8.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.305),(8.735,7.475),(8.905,7.475),(8.905,7.305),(8.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.305),(9.095,7.475),(9.265,7.475),(9.265,7.305),(9.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.305),(9.455,7.475),(9.625,7.475),(9.625,7.305),(9.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.665),(8.375,7.835),(8.545,7.835),(8.545,7.665),(8.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.665),(8.735,7.835),(8.905,7.835),(8.905,7.665),(8.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.665),(9.095,7.835),(9.265,7.835),(9.265,7.665),(9.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.665),(9.455,7.835),(9.625,7.835),(9.625,7.665),(9.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.025),(8.375,8.195),(8.545,8.195),(8.545,8.025),(8.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.025),(8.735,8.195),(8.905,8.195),(8.905,8.025),(8.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.025),(9.095,8.195),(9.265,8.195),(9.265,8.025),(9.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.025),(9.455,8.195),(9.625,8.195),(9.625,8.025),(9.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.385),(8.375,8.555),(8.545,8.555),(8.545,8.385),(8.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.385),(8.735,8.555),(8.905,8.555),(8.905,8.385),(8.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.385),(9.095,8.555),(9.265,8.555),(9.265,8.385),(9.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.385),(9.455,8.555),(9.625,8.555),(9.625,8.385),(9.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.745),(8.375,8.915),(8.545,8.915),(8.545,8.745),(8.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.745),(8.735,8.915),(8.905,8.915),(8.905,8.745),(8.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.745),(9.095,8.915),(9.265,8.915),(9.265,8.745),(9.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.745),(9.455,8.915),(9.625,8.915),(9.625,8.745),(9.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.105),(8.375,9.275),(8.545,9.275),(8.545,9.105),(8.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.105),(8.735,9.275),(8.905,9.275),(8.905,9.105),(8.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.105),(9.095,9.275),(9.265,9.275),(9.265,9.105),(9.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.105),(9.455,9.275),(9.625,9.275),(9.625,9.105),(9.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.465),(8.375,9.635),(8.545,9.635),(8.545,9.465),(8.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.465),(8.735,9.635),(8.905,9.635),(8.905,9.465),(8.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.465),(9.095,9.635),(9.265,9.635),(9.265,9.465),(9.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.465),(9.455,9.635),(9.625,9.635),(9.625,9.465),(9.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.825),(8.375,9.995),(8.545,9.995),(8.545,9.825),(8.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.825),(8.735,9.995),(8.905,9.995),(8.905,9.825),(8.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.825),(9.095,9.995),(9.265,9.995),(9.265,9.825),(9.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.825),(9.455,9.995),(9.625,9.995),(9.625,9.825),(9.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.185),(8.375,10.355),(8.545,10.355),(8.545,10.185),(8.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.185),(8.735,10.355),(8.905,10.355),(8.905,10.185),(8.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.185),(9.095,10.355),(9.265,10.355),(9.265,10.185),(9.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.185),(9.455,10.355),(9.625,10.355),(9.625,10.185),(9.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.545),(8.375,10.715),(8.545,10.715),(8.545,10.545),(8.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.545),(8.735,10.715),(8.905,10.715),(8.905,10.545),(8.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.545),(9.095,10.715),(9.265,10.715),(9.265,10.545),(9.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.545),(9.455,10.715),(9.625,10.715),(9.625,10.545),(9.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.905),(8.375,11.075),(8.545,11.075),(8.545,10.905),(8.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.905),(8.735,11.075),(8.905,11.075),(8.905,10.905),(8.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.905),(9.095,11.075),(9.265,11.075),(9.265,10.905),(9.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.905),(9.455,11.075),(9.625,11.075),(9.625,10.905),(9.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.265),(8.375,11.435),(8.545,11.435),(8.545,11.265),(8.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.265),(8.735,11.435),(8.905,11.435),(8.905,11.265),(8.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.265),(9.095,11.435),(9.265,11.435),(9.265,11.265),(9.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.265),(9.455,11.435),(9.625,11.435),(9.625,11.265),(9.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.625),(8.375,11.795),(8.545,11.795),(8.545,11.625),(8.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.625),(8.735,11.795),(8.905,11.795),(8.905,11.625),(8.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.625),(9.095,11.795),(9.265,11.795),(9.265,11.625),(9.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.625),(9.455,11.795),(9.625,11.795),(9.625,11.625),(9.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.985),(8.375,12.155),(8.545,12.155),(8.545,11.985),(8.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.985),(8.735,12.155),(8.905,12.155),(8.905,11.985),(8.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.985),(9.095,12.155),(9.265,12.155),(9.265,11.985),(9.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.985),(9.455,12.155),(9.625,12.155),(9.625,11.985),(9.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.345),(8.375,12.515),(8.545,12.515),(8.545,12.345),(8.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.345),(8.735,12.515),(8.905,12.515),(8.905,12.345),(8.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.345),(9.095,12.515),(9.265,12.515),(9.265,12.345),(9.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.345),(9.455,12.515),(9.625,12.515),(9.625,12.345),(9.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.705),(8.375,12.875),(8.545,12.875),(8.545,12.705),(8.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.705),(8.735,12.875),(8.905,12.875),(8.905,12.705),(8.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.705),(9.095,12.875),(9.265,12.875),(9.265,12.705),(9.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.705),(9.455,12.875),(9.625,12.875),(9.625,12.705),(9.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.065),(8.375,13.235),(8.545,13.235),(8.545,13.065),(8.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.065),(8.735,13.235),(8.905,13.235),(8.905,13.065),(8.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.065),(9.095,13.235),(9.265,13.235),(9.265,13.065),(9.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.065),(9.455,13.235),(9.625,13.235),(9.625,13.065),(9.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.425),(8.375,13.595),(8.545,13.595),(8.545,13.425),(8.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.425),(8.735,13.595),(8.905,13.595),(8.905,13.425),(8.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.425),(9.095,13.595),(9.265,13.595),(9.265,13.425),(9.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.425),(9.455,13.595),(9.625,13.595),(9.625,13.425),(9.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.785),(8.375,13.955),(8.545,13.955),(8.545,13.785),(8.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.785),(8.735,13.955),(8.905,13.955),(8.905,13.785),(8.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.785),(9.095,13.955),(9.265,13.955),(9.265,13.785),(9.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.785),(9.455,13.955),(9.625,13.955),(9.625,13.785),(9.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.145),(8.375,14.315),(8.545,14.315),(8.545,14.145),(8.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.145),(8.735,14.315),(8.905,14.315),(8.905,14.145),(8.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.145),(9.095,14.315),(9.265,14.315),(9.265,14.145),(9.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.145),(9.455,14.315),(9.625,14.315),(9.625,14.145),(9.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.505),(8.375,14.675),(8.545,14.675),(8.545,14.505),(8.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.505),(8.735,14.675),(8.905,14.675),(8.905,14.505),(8.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.505),(9.095,14.675),(9.265,14.675),(9.265,14.505),(9.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.505),(9.455,14.675),(9.625,14.675),(9.625,14.505),(9.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.865),(8.375,15.035),(8.545,15.035),(8.545,14.865),(8.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.865),(8.735,15.035),(8.905,15.035),(8.905,14.865),(8.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.865),(9.095,15.035),(9.265,15.035),(9.265,14.865),(9.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.865),(9.455,15.035),(9.625,15.035),(9.625,14.865),(9.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.225),(8.375,15.395),(8.545,15.395),(8.545,15.225),(8.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.225),(8.735,15.395),(8.905,15.395),(8.905,15.225),(8.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.225),(9.095,15.395),(9.265,15.395),(9.265,15.225),(9.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.225),(9.455,15.395),(9.625,15.395),(9.625,15.225),(9.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.585),(8.375,15.755),(8.545,15.755),(8.545,15.585),(8.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.585),(8.735,15.755),(8.905,15.755),(8.905,15.585),(8.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.585),(9.095,15.755),(9.265,15.755),(9.265,15.585),(9.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.585),(9.455,15.755),(9.625,15.755),(9.625,15.585),(9.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.945),(8.375,16.115),(8.545,16.115),(8.545,15.945),(8.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.945),(8.735,16.115),(8.905,16.115),(8.905,15.945),(8.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.945),(9.095,16.115),(9.265,16.115),(9.265,15.945),(9.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.945),(9.455,16.115),(9.625,16.115),(9.625,15.945),(9.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.305),(8.375,16.475),(8.545,16.475),(8.545,16.305),(8.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.305),(8.735,16.475),(8.905,16.475),(8.905,16.305),(8.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.305),(9.095,16.475),(9.265,16.475),(9.265,16.305),(9.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.305),(9.455,16.475),(9.625,16.475),(9.625,16.305),(9.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.665),(8.375,16.835),(8.545,16.835),(8.545,16.665),(8.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.665),(8.735,16.835),(8.905,16.835),(8.905,16.665),(8.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.665),(9.095,16.835),(9.265,16.835),(9.265,16.665),(9.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.665),(9.455,16.835),(9.625,16.835),(9.625,16.665),(9.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.025),(8.375,17.195),(8.545,17.195),(8.545,17.025),(8.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.025),(8.735,17.195),(8.905,17.195),(8.905,17.025),(8.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.025),(9.095,17.195),(9.265,17.195),(9.265,17.025),(9.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.025),(9.455,17.195),(9.625,17.195),(9.625,17.025),(9.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.385),(8.375,17.555),(8.545,17.555),(8.545,17.385),(8.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.385),(8.735,17.555),(8.905,17.555),(8.905,17.385),(8.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.385),(9.095,17.555),(9.265,17.555),(9.265,17.385),(9.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.385),(9.455,17.555),(9.625,17.555),(9.625,17.385),(9.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.745),(8.375,17.915),(8.545,17.915),(8.545,17.745),(8.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.745),(8.735,17.915),(8.905,17.915),(8.905,17.745),(8.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.745),(9.095,17.915),(9.265,17.915),(9.265,17.745),(9.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.745),(9.455,17.915),(9.625,17.915),(9.625,17.745),(9.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.105),(8.375,18.275),(8.545,18.275),(8.545,18.105),(8.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.105),(8.735,18.275),(8.905,18.275),(8.905,18.105),(8.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.105),(9.095,18.275),(9.265,18.275),(9.265,18.105),(9.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.105),(9.455,18.275),(9.625,18.275),(9.625,18.105),(9.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.465),(8.375,18.635),(8.545,18.635),(8.545,18.465),(8.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.465),(8.735,18.635),(8.905,18.635),(8.905,18.465),(8.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.465),(9.095,18.635),(9.265,18.635),(9.265,18.465),(9.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.465),(9.455,18.635),(9.625,18.635),(9.625,18.465),(9.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.825),(8.375,18.995),(8.545,18.995),(8.545,18.825),(8.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.825),(8.735,18.995),(8.905,18.995),(8.905,18.825),(8.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.825),(9.095,18.995),(9.265,18.995),(9.265,18.825),(9.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.825),(9.455,18.995),(9.625,18.995),(9.625,18.825),(9.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.185),(8.375,19.355),(8.545,19.355),(8.545,19.185),(8.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.185),(8.735,19.355),(8.905,19.355),(8.905,19.185),(8.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.185),(9.095,19.355),(9.265,19.355),(9.265,19.185),(9.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.185),(9.455,19.355),(9.625,19.355),(9.625,19.185),(9.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.985),(32.375,3.155),(32.545,3.155),(32.545,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.985),(32.735,3.155),(32.905,3.155),(32.905,2.985),(32.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.985),(33.095,3.155),(33.265,3.155),(33.265,2.985),(33.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.985),(33.455,3.155),(33.625,3.155),(33.625,2.985),(33.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.345),(32.375,3.515),(32.545,3.515),(32.545,3.345),(32.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.345),(32.735,3.515),(32.905,3.515),(32.905,3.345),(32.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.345),(33.095,3.515),(33.265,3.515),(33.265,3.345),(33.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.345),(33.455,3.515),(33.625,3.515),(33.625,3.345),(33.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.705),(32.375,3.875),(32.545,3.875),(32.545,3.705),(32.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.705),(32.735,3.875),(32.905,3.875),(32.905,3.705),(32.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.705),(33.095,3.875),(33.265,3.875),(33.265,3.705),(33.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.705),(33.455,3.875),(33.625,3.875),(33.625,3.705),(33.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.065),(32.375,4.235),(32.545,4.235),(32.545,4.065),(32.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.065),(32.735,4.235),(32.905,4.235),(32.905,4.065),(32.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.065),(33.095,4.235),(33.265,4.235),(33.265,4.065),(33.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.065),(33.455,4.235),(33.625,4.235),(33.625,4.065),(33.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.425),(32.375,4.595),(32.545,4.595),(32.545,4.425),(32.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.425),(32.735,4.595),(32.905,4.595),(32.905,4.425),(32.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.425),(33.095,4.595),(33.265,4.595),(33.265,4.425),(33.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.425),(33.455,4.595),(33.625,4.595),(33.625,4.425),(33.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.785),(32.375,4.955),(32.545,4.955),(32.545,4.785),(32.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.785),(32.735,4.955),(32.905,4.955),(32.905,4.785),(32.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.785),(33.095,4.955),(33.265,4.955),(33.265,4.785),(33.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.785),(33.455,4.955),(33.625,4.955),(33.625,4.785),(33.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.145),(32.375,5.315),(32.545,5.315),(32.545,5.145),(32.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.145),(32.735,5.315),(32.905,5.315),(32.905,5.145),(32.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.145),(33.095,5.315),(33.265,5.315),(33.265,5.145),(33.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.145),(33.455,5.315),(33.625,5.315),(33.625,5.145),(33.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.505),(32.375,5.675),(32.545,5.675),(32.545,5.505),(32.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.505),(32.735,5.675),(32.905,5.675),(32.905,5.505),(32.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.505),(33.095,5.675),(33.265,5.675),(33.265,5.505),(33.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.505),(33.455,5.675),(33.625,5.675),(33.625,5.505),(33.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.865),(32.375,6.035),(32.545,6.035),(32.545,5.865),(32.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.865),(32.735,6.035),(32.905,6.035),(32.905,5.865),(32.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.865),(33.095,6.035),(33.265,6.035),(33.265,5.865),(33.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.865),(33.455,6.035),(33.625,6.035),(33.625,5.865),(33.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.225),(32.375,6.395),(32.545,6.395),(32.545,6.225),(32.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.225),(32.735,6.395),(32.905,6.395),(32.905,6.225),(32.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.225),(33.095,6.395),(33.265,6.395),(33.265,6.225),(33.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.225),(33.455,6.395),(33.625,6.395),(33.625,6.225),(33.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.585),(32.375,6.755),(32.545,6.755),(32.545,6.585),(32.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.585),(32.735,6.755),(32.905,6.755),(32.905,6.585),(32.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.585),(33.095,6.755),(33.265,6.755),(33.265,6.585),(33.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.585),(33.455,6.755),(33.625,6.755),(33.625,6.585),(33.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.945),(32.375,7.115),(32.545,7.115),(32.545,6.945),(32.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.945),(32.735,7.115),(32.905,7.115),(32.905,6.945),(32.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.945),(33.095,7.115),(33.265,7.115),(33.265,6.945),(33.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.945),(33.455,7.115),(33.625,7.115),(33.625,6.945),(33.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.305),(32.375,7.475),(32.545,7.475),(32.545,7.305),(32.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.305),(32.735,7.475),(32.905,7.475),(32.905,7.305),(32.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.305),(33.095,7.475),(33.265,7.475),(33.265,7.305),(33.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.305),(33.455,7.475),(33.625,7.475),(33.625,7.305),(33.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.665),(32.375,7.835),(32.545,7.835),(32.545,7.665),(32.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.665),(32.735,7.835),(32.905,7.835),(32.905,7.665),(32.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.665),(33.095,7.835),(33.265,7.835),(33.265,7.665),(33.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.665),(33.455,7.835),(33.625,7.835),(33.625,7.665),(33.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.025),(32.375,8.195),(32.545,8.195),(32.545,8.025),(32.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.025),(32.735,8.195),(32.905,8.195),(32.905,8.025),(32.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.025),(33.095,8.195),(33.265,8.195),(33.265,8.025),(33.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.025),(33.455,8.195),(33.625,8.195),(33.625,8.025),(33.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.385),(32.375,8.555),(32.545,8.555),(32.545,8.385),(32.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.385),(32.735,8.555),(32.905,8.555),(32.905,8.385),(32.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.385),(33.095,8.555),(33.265,8.555),(33.265,8.385),(33.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.385),(33.455,8.555),(33.625,8.555),(33.625,8.385),(33.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.745),(32.375,8.915),(32.545,8.915),(32.545,8.745),(32.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.745),(32.735,8.915),(32.905,8.915),(32.905,8.745),(32.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.745),(33.095,8.915),(33.265,8.915),(33.265,8.745),(33.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.745),(33.455,8.915),(33.625,8.915),(33.625,8.745),(33.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.105),(32.375,9.275),(32.545,9.275),(32.545,9.105),(32.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.105),(32.735,9.275),(32.905,9.275),(32.905,9.105),(32.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.105),(33.095,9.275),(33.265,9.275),(33.265,9.105),(33.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.105),(33.455,9.275),(33.625,9.275),(33.625,9.105),(33.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.465),(32.375,9.635),(32.545,9.635),(32.545,9.465),(32.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.465),(32.735,9.635),(32.905,9.635),(32.905,9.465),(32.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.465),(33.095,9.635),(33.265,9.635),(33.265,9.465),(33.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.465),(33.455,9.635),(33.625,9.635),(33.625,9.465),(33.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.825),(32.375,9.995),(32.545,9.995),(32.545,9.825),(32.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.825),(32.735,9.995),(32.905,9.995),(32.905,9.825),(32.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.825),(33.095,9.995),(33.265,9.995),(33.265,9.825),(33.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.825),(33.455,9.995),(33.625,9.995),(33.625,9.825),(33.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.185),(32.375,10.355),(32.545,10.355),(32.545,10.185),(32.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.185),(32.735,10.355),(32.905,10.355),(32.905,10.185),(32.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.185),(33.095,10.355),(33.265,10.355),(33.265,10.185),(33.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.185),(33.455,10.355),(33.625,10.355),(33.625,10.185),(33.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.545),(32.375,10.715),(32.545,10.715),(32.545,10.545),(32.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.545),(32.735,10.715),(32.905,10.715),(32.905,10.545),(32.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.545),(33.095,10.715),(33.265,10.715),(33.265,10.545),(33.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.545),(33.455,10.715),(33.625,10.715),(33.625,10.545),(33.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.905),(32.375,11.075),(32.545,11.075),(32.545,10.905),(32.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.905),(32.735,11.075),(32.905,11.075),(32.905,10.905),(32.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.905),(33.095,11.075),(33.265,11.075),(33.265,10.905),(33.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.905),(33.455,11.075),(33.625,11.075),(33.625,10.905),(33.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.265),(32.375,11.435),(32.545,11.435),(32.545,11.265),(32.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.265),(32.735,11.435),(32.905,11.435),(32.905,11.265),(32.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.265),(33.095,11.435),(33.265,11.435),(33.265,11.265),(33.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.265),(33.455,11.435),(33.625,11.435),(33.625,11.265),(33.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.625),(32.375,11.795),(32.545,11.795),(32.545,11.625),(32.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.625),(32.735,11.795),(32.905,11.795),(32.905,11.625),(32.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.625),(33.095,11.795),(33.265,11.795),(33.265,11.625),(33.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.625),(33.455,11.795),(33.625,11.795),(33.625,11.625),(33.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.985),(32.375,12.155),(32.545,12.155),(32.545,11.985),(32.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.985),(32.735,12.155),(32.905,12.155),(32.905,11.985),(32.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.985),(33.095,12.155),(33.265,12.155),(33.265,11.985),(33.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.985),(33.455,12.155),(33.625,12.155),(33.625,11.985),(33.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.345),(32.375,12.515),(32.545,12.515),(32.545,12.345),(32.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.345),(32.735,12.515),(32.905,12.515),(32.905,12.345),(32.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.345),(33.095,12.515),(33.265,12.515),(33.265,12.345),(33.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.345),(33.455,12.515),(33.625,12.515),(33.625,12.345),(33.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.705),(32.375,12.875),(32.545,12.875),(32.545,12.705),(32.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.705),(32.735,12.875),(32.905,12.875),(32.905,12.705),(32.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.705),(33.095,12.875),(33.265,12.875),(33.265,12.705),(33.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.705),(33.455,12.875),(33.625,12.875),(33.625,12.705),(33.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.065),(32.375,13.235),(32.545,13.235),(32.545,13.065),(32.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.065),(32.735,13.235),(32.905,13.235),(32.905,13.065),(32.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.065),(33.095,13.235),(33.265,13.235),(33.265,13.065),(33.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.065),(33.455,13.235),(33.625,13.235),(33.625,13.065),(33.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.425),(32.375,13.595),(32.545,13.595),(32.545,13.425),(32.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.425),(32.735,13.595),(32.905,13.595),(32.905,13.425),(32.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.425),(33.095,13.595),(33.265,13.595),(33.265,13.425),(33.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.425),(33.455,13.595),(33.625,13.595),(33.625,13.425),(33.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.785),(32.375,13.955),(32.545,13.955),(32.545,13.785),(32.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.785),(32.735,13.955),(32.905,13.955),(32.905,13.785),(32.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.785),(33.095,13.955),(33.265,13.955),(33.265,13.785),(33.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.785),(33.455,13.955),(33.625,13.955),(33.625,13.785),(33.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.145),(32.375,14.315),(32.545,14.315),(32.545,14.145),(32.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.145),(32.735,14.315),(32.905,14.315),(32.905,14.145),(32.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.145),(33.095,14.315),(33.265,14.315),(33.265,14.145),(33.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.145),(33.455,14.315),(33.625,14.315),(33.625,14.145),(33.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.505),(32.375,14.675),(32.545,14.675),(32.545,14.505),(32.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.505),(32.735,14.675),(32.905,14.675),(32.905,14.505),(32.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.505),(33.095,14.675),(33.265,14.675),(33.265,14.505),(33.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.505),(33.455,14.675),(33.625,14.675),(33.625,14.505),(33.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.865),(32.375,15.035),(32.545,15.035),(32.545,14.865),(32.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.865),(32.735,15.035),(32.905,15.035),(32.905,14.865),(32.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.865),(33.095,15.035),(33.265,15.035),(33.265,14.865),(33.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.865),(33.455,15.035),(33.625,15.035),(33.625,14.865),(33.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.225),(32.375,15.395),(32.545,15.395),(32.545,15.225),(32.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.225),(32.735,15.395),(32.905,15.395),(32.905,15.225),(32.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.225),(33.095,15.395),(33.265,15.395),(33.265,15.225),(33.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.225),(33.455,15.395),(33.625,15.395),(33.625,15.225),(33.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.585),(32.375,15.755),(32.545,15.755),(32.545,15.585),(32.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.585),(32.735,15.755),(32.905,15.755),(32.905,15.585),(32.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.585),(33.095,15.755),(33.265,15.755),(33.265,15.585),(33.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.585),(33.455,15.755),(33.625,15.755),(33.625,15.585),(33.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.945),(32.375,16.115),(32.545,16.115),(32.545,15.945),(32.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.945),(32.735,16.115),(32.905,16.115),(32.905,15.945),(32.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.945),(33.095,16.115),(33.265,16.115),(33.265,15.945),(33.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.945),(33.455,16.115),(33.625,16.115),(33.625,15.945),(33.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.305),(32.375,16.475),(32.545,16.475),(32.545,16.305),(32.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.305),(32.735,16.475),(32.905,16.475),(32.905,16.305),(32.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.305),(33.095,16.475),(33.265,16.475),(33.265,16.305),(33.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.305),(33.455,16.475),(33.625,16.475),(33.625,16.305),(33.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.665),(32.375,16.835),(32.545,16.835),(32.545,16.665),(32.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.665),(32.735,16.835),(32.905,16.835),(32.905,16.665),(32.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.665),(33.095,16.835),(33.265,16.835),(33.265,16.665),(33.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.665),(33.455,16.835),(33.625,16.835),(33.625,16.665),(33.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.025),(32.375,17.195),(32.545,17.195),(32.545,17.025),(32.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.025),(32.735,17.195),(32.905,17.195),(32.905,17.025),(32.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.025),(33.095,17.195),(33.265,17.195),(33.265,17.025),(33.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.025),(33.455,17.195),(33.625,17.195),(33.625,17.025),(33.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.385),(32.375,17.555),(32.545,17.555),(32.545,17.385),(32.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.385),(32.735,17.555),(32.905,17.555),(32.905,17.385),(32.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.385),(33.095,17.555),(33.265,17.555),(33.265,17.385),(33.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.385),(33.455,17.555),(33.625,17.555),(33.625,17.385),(33.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.745),(32.375,17.915),(32.545,17.915),(32.545,17.745),(32.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.745),(32.735,17.915),(32.905,17.915),(32.905,17.745),(32.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.745),(33.095,17.915),(33.265,17.915),(33.265,17.745),(33.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.745),(33.455,17.915),(33.625,17.915),(33.625,17.745),(33.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.105),(32.375,18.275),(32.545,18.275),(32.545,18.105),(32.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.105),(32.735,18.275),(32.905,18.275),(32.905,18.105),(32.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.105),(33.095,18.275),(33.265,18.275),(33.265,18.105),(33.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.105),(33.455,18.275),(33.625,18.275),(33.625,18.105),(33.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.465),(32.375,18.635),(32.545,18.635),(32.545,18.465),(32.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.465),(32.735,18.635),(32.905,18.635),(32.905,18.465),(32.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.465),(33.095,18.635),(33.265,18.635),(33.265,18.465),(33.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.465),(33.455,18.635),(33.625,18.635),(33.625,18.465),(33.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.825),(32.375,18.995),(32.545,18.995),(32.545,18.825),(32.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.825),(32.735,18.995),(32.905,18.995),(32.905,18.825),(32.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.825),(33.095,18.995),(33.265,18.995),(33.265,18.825),(33.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.825),(33.455,18.995),(33.625,18.995),(33.625,18.825),(33.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.185),(32.375,19.355),(32.545,19.355),(32.545,19.185),(32.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.185),(32.735,19.355),(32.905,19.355),(32.905,19.185),(32.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.185),(33.095,19.355),(33.265,19.355),(33.265,19.185),(33.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.185),(33.455,19.355),(33.625,19.355),(33.625,19.185),(33.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,2.985),(61.175,3.155),(61.345,3.155),(61.345,2.985),(61.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,2.985),(61.535,3.155),(61.705,3.155),(61.705,2.985),(61.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,2.985),(61.895,3.155),(62.065,3.155),(62.065,2.985),(61.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,2.985),(62.255,3.155),(62.425,3.155),(62.425,2.985),(62.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.345),(61.175,3.515),(61.345,3.515),(61.345,3.345),(61.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.345),(61.535,3.515),(61.705,3.515),(61.705,3.345),(61.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.345),(61.895,3.515),(62.065,3.515),(62.065,3.345),(61.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.345),(62.255,3.515),(62.425,3.515),(62.425,3.345),(62.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.705),(61.175,3.875),(61.345,3.875),(61.345,3.705),(61.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.705),(61.535,3.875),(61.705,3.875),(61.705,3.705),(61.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.705),(61.895,3.875),(62.065,3.875),(62.065,3.705),(61.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.705),(62.255,3.875),(62.425,3.875),(62.425,3.705),(62.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.065),(61.175,4.235),(61.345,4.235),(61.345,4.065),(61.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.065),(61.535,4.235),(61.705,4.235),(61.705,4.065),(61.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.065),(61.895,4.235),(62.065,4.235),(62.065,4.065),(61.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.065),(62.255,4.235),(62.425,4.235),(62.425,4.065),(62.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.425),(61.175,4.595),(61.345,4.595),(61.345,4.425),(61.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.425),(61.535,4.595),(61.705,4.595),(61.705,4.425),(61.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.425),(61.895,4.595),(62.065,4.595),(62.065,4.425),(61.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.425),(62.255,4.595),(62.425,4.595),(62.425,4.425),(62.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.785),(61.175,4.955),(61.345,4.955),(61.345,4.785),(61.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.785),(61.535,4.955),(61.705,4.955),(61.705,4.785),(61.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.785),(61.895,4.955),(62.065,4.955),(62.065,4.785),(61.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.785),(62.255,4.955),(62.425,4.955),(62.425,4.785),(62.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.145),(61.175,5.315),(61.345,5.315),(61.345,5.145),(61.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.145),(61.535,5.315),(61.705,5.315),(61.705,5.145),(61.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.145),(61.895,5.315),(62.065,5.315),(62.065,5.145),(61.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.145),(62.255,5.315),(62.425,5.315),(62.425,5.145),(62.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.505),(61.175,5.675),(61.345,5.675),(61.345,5.505),(61.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.505),(61.535,5.675),(61.705,5.675),(61.705,5.505),(61.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.505),(61.895,5.675),(62.065,5.675),(62.065,5.505),(61.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.505),(62.255,5.675),(62.425,5.675),(62.425,5.505),(62.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.865),(61.175,6.035),(61.345,6.035),(61.345,5.865),(61.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.865),(61.535,6.035),(61.705,6.035),(61.705,5.865),(61.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.865),(61.895,6.035),(62.065,6.035),(62.065,5.865),(61.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.865),(62.255,6.035),(62.425,6.035),(62.425,5.865),(62.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.225),(61.175,6.395),(61.345,6.395),(61.345,6.225),(61.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.225),(61.535,6.395),(61.705,6.395),(61.705,6.225),(61.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.225),(61.895,6.395),(62.065,6.395),(62.065,6.225),(61.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.225),(62.255,6.395),(62.425,6.395),(62.425,6.225),(62.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.585),(61.175,6.755),(61.345,6.755),(61.345,6.585),(61.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.585),(61.535,6.755),(61.705,6.755),(61.705,6.585),(61.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.585),(61.895,6.755),(62.065,6.755),(62.065,6.585),(61.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.585),(62.255,6.755),(62.425,6.755),(62.425,6.585),(62.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.945),(61.175,7.115),(61.345,7.115),(61.345,6.945),(61.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.945),(61.535,7.115),(61.705,7.115),(61.705,6.945),(61.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.945),(61.895,7.115),(62.065,7.115),(62.065,6.945),(61.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.945),(62.255,7.115),(62.425,7.115),(62.425,6.945),(62.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.305),(61.175,7.475),(61.345,7.475),(61.345,7.305),(61.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.305),(61.535,7.475),(61.705,7.475),(61.705,7.305),(61.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.305),(61.895,7.475),(62.065,7.475),(62.065,7.305),(61.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.305),(62.255,7.475),(62.425,7.475),(62.425,7.305),(62.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.665),(61.175,7.835),(61.345,7.835),(61.345,7.665),(61.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.665),(61.535,7.835),(61.705,7.835),(61.705,7.665),(61.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.665),(61.895,7.835),(62.065,7.835),(62.065,7.665),(61.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.665),(62.255,7.835),(62.425,7.835),(62.425,7.665),(62.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.025),(61.175,8.195),(61.345,8.195),(61.345,8.025),(61.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.025),(61.535,8.195),(61.705,8.195),(61.705,8.025),(61.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.025),(61.895,8.195),(62.065,8.195),(62.065,8.025),(61.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.025),(62.255,8.195),(62.425,8.195),(62.425,8.025),(62.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.385),(61.175,8.555),(61.345,8.555),(61.345,8.385),(61.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.385),(61.535,8.555),(61.705,8.555),(61.705,8.385),(61.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.385),(61.895,8.555),(62.065,8.555),(62.065,8.385),(61.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.385),(62.255,8.555),(62.425,8.555),(62.425,8.385),(62.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.745),(61.175,8.915),(61.345,8.915),(61.345,8.745),(61.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.745),(61.535,8.915),(61.705,8.915),(61.705,8.745),(61.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.745),(61.895,8.915),(62.065,8.915),(62.065,8.745),(61.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.745),(62.255,8.915),(62.425,8.915),(62.425,8.745),(62.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.105),(61.175,9.275),(61.345,9.275),(61.345,9.105),(61.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.105),(61.535,9.275),(61.705,9.275),(61.705,9.105),(61.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.105),(61.895,9.275),(62.065,9.275),(62.065,9.105),(61.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.105),(62.255,9.275),(62.425,9.275),(62.425,9.105),(62.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.465),(61.175,9.635),(61.345,9.635),(61.345,9.465),(61.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.465),(61.535,9.635),(61.705,9.635),(61.705,9.465),(61.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.465),(61.895,9.635),(62.065,9.635),(62.065,9.465),(61.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.465),(62.255,9.635),(62.425,9.635),(62.425,9.465),(62.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.825),(61.175,9.995),(61.345,9.995),(61.345,9.825),(61.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.825),(61.535,9.995),(61.705,9.995),(61.705,9.825),(61.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.825),(61.895,9.995),(62.065,9.995),(62.065,9.825),(61.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.825),(62.255,9.995),(62.425,9.995),(62.425,9.825),(62.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.185),(61.175,10.355),(61.345,10.355),(61.345,10.185),(61.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.185),(61.535,10.355),(61.705,10.355),(61.705,10.185),(61.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.185),(61.895,10.355),(62.065,10.355),(62.065,10.185),(61.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.185),(62.255,10.355),(62.425,10.355),(62.425,10.185),(62.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.545),(61.175,10.715),(61.345,10.715),(61.345,10.545),(61.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.545),(61.535,10.715),(61.705,10.715),(61.705,10.545),(61.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.545),(61.895,10.715),(62.065,10.715),(62.065,10.545),(61.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.545),(62.255,10.715),(62.425,10.715),(62.425,10.545),(62.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.905),(61.175,11.075),(61.345,11.075),(61.345,10.905),(61.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.905),(61.535,11.075),(61.705,11.075),(61.705,10.905),(61.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.905),(61.895,11.075),(62.065,11.075),(62.065,10.905),(61.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.905),(62.255,11.075),(62.425,11.075),(62.425,10.905),(62.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.265),(61.175,11.435),(61.345,11.435),(61.345,11.265),(61.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.265),(61.535,11.435),(61.705,11.435),(61.705,11.265),(61.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.265),(61.895,11.435),(62.065,11.435),(62.065,11.265),(61.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.265),(62.255,11.435),(62.425,11.435),(62.425,11.265),(62.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.625),(61.175,11.795),(61.345,11.795),(61.345,11.625),(61.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.625),(61.535,11.795),(61.705,11.795),(61.705,11.625),(61.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.625),(61.895,11.795),(62.065,11.795),(62.065,11.625),(61.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.625),(62.255,11.795),(62.425,11.795),(62.425,11.625),(62.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.985),(61.175,12.155),(61.345,12.155),(61.345,11.985),(61.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.985),(61.535,12.155),(61.705,12.155),(61.705,11.985),(61.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.985),(61.895,12.155),(62.065,12.155),(62.065,11.985),(61.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.985),(62.255,12.155),(62.425,12.155),(62.425,11.985),(62.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.345),(61.175,12.515),(61.345,12.515),(61.345,12.345),(61.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.345),(61.535,12.515),(61.705,12.515),(61.705,12.345),(61.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.345),(61.895,12.515),(62.065,12.515),(62.065,12.345),(61.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.345),(62.255,12.515),(62.425,12.515),(62.425,12.345),(62.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.705),(61.175,12.875),(61.345,12.875),(61.345,12.705),(61.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.705),(61.535,12.875),(61.705,12.875),(61.705,12.705),(61.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.705),(61.895,12.875),(62.065,12.875),(62.065,12.705),(61.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.705),(62.255,12.875),(62.425,12.875),(62.425,12.705),(62.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.065),(61.175,13.235),(61.345,13.235),(61.345,13.065),(61.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.065),(61.535,13.235),(61.705,13.235),(61.705,13.065),(61.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.065),(61.895,13.235),(62.065,13.235),(62.065,13.065),(61.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.065),(62.255,13.235),(62.425,13.235),(62.425,13.065),(62.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.425),(61.175,13.595),(61.345,13.595),(61.345,13.425),(61.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.425),(61.535,13.595),(61.705,13.595),(61.705,13.425),(61.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.425),(61.895,13.595),(62.065,13.595),(62.065,13.425),(61.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.425),(62.255,13.595),(62.425,13.595),(62.425,13.425),(62.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.785),(61.175,13.955),(61.345,13.955),(61.345,13.785),(61.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.785),(61.535,13.955),(61.705,13.955),(61.705,13.785),(61.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.785),(61.895,13.955),(62.065,13.955),(62.065,13.785),(61.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.785),(62.255,13.955),(62.425,13.955),(62.425,13.785),(62.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.145),(61.175,14.315),(61.345,14.315),(61.345,14.145),(61.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.145),(61.535,14.315),(61.705,14.315),(61.705,14.145),(61.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.145),(61.895,14.315),(62.065,14.315),(62.065,14.145),(61.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.145),(62.255,14.315),(62.425,14.315),(62.425,14.145),(62.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.505),(61.175,14.675),(61.345,14.675),(61.345,14.505),(61.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.505),(61.535,14.675),(61.705,14.675),(61.705,14.505),(61.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.505),(61.895,14.675),(62.065,14.675),(62.065,14.505),(61.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.505),(62.255,14.675),(62.425,14.675),(62.425,14.505),(62.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.865),(61.175,15.035),(61.345,15.035),(61.345,14.865),(61.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.865),(61.535,15.035),(61.705,15.035),(61.705,14.865),(61.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.865),(61.895,15.035),(62.065,15.035),(62.065,14.865),(61.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.865),(62.255,15.035),(62.425,15.035),(62.425,14.865),(62.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.225),(61.175,15.395),(61.345,15.395),(61.345,15.225),(61.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.225),(61.535,15.395),(61.705,15.395),(61.705,15.225),(61.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.225),(61.895,15.395),(62.065,15.395),(62.065,15.225),(61.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.225),(62.255,15.395),(62.425,15.395),(62.425,15.225),(62.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.585),(61.175,15.755),(61.345,15.755),(61.345,15.585),(61.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.585),(61.535,15.755),(61.705,15.755),(61.705,15.585),(61.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.585),(61.895,15.755),(62.065,15.755),(62.065,15.585),(61.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.585),(62.255,15.755),(62.425,15.755),(62.425,15.585),(62.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.945),(61.175,16.115),(61.345,16.115),(61.345,15.945),(61.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.945),(61.535,16.115),(61.705,16.115),(61.705,15.945),(61.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.945),(61.895,16.115),(62.065,16.115),(62.065,15.945),(61.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.945),(62.255,16.115),(62.425,16.115),(62.425,15.945),(62.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.305),(61.175,16.475),(61.345,16.475),(61.345,16.305),(61.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.305),(61.535,16.475),(61.705,16.475),(61.705,16.305),(61.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.305),(61.895,16.475),(62.065,16.475),(62.065,16.305),(61.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.305),(62.255,16.475),(62.425,16.475),(62.425,16.305),(62.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.665),(61.175,16.835),(61.345,16.835),(61.345,16.665),(61.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.665),(61.535,16.835),(61.705,16.835),(61.705,16.665),(61.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.665),(61.895,16.835),(62.065,16.835),(62.065,16.665),(61.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.665),(62.255,16.835),(62.425,16.835),(62.425,16.665),(62.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.025),(61.175,17.195),(61.345,17.195),(61.345,17.025),(61.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.025),(61.535,17.195),(61.705,17.195),(61.705,17.025),(61.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.025),(61.895,17.195),(62.065,17.195),(62.065,17.025),(61.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.025),(62.255,17.195),(62.425,17.195),(62.425,17.025),(62.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.385),(61.175,17.555),(61.345,17.555),(61.345,17.385),(61.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.385),(61.535,17.555),(61.705,17.555),(61.705,17.385),(61.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.385),(61.895,17.555),(62.065,17.555),(62.065,17.385),(61.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.385),(62.255,17.555),(62.425,17.555),(62.425,17.385),(62.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.745),(61.175,17.915),(61.345,17.915),(61.345,17.745),(61.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.745),(61.535,17.915),(61.705,17.915),(61.705,17.745),(61.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.745),(61.895,17.915),(62.065,17.915),(62.065,17.745),(61.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.745),(62.255,17.915),(62.425,17.915),(62.425,17.745),(62.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.105),(61.175,18.275),(61.345,18.275),(61.345,18.105),(61.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.105),(61.535,18.275),(61.705,18.275),(61.705,18.105),(61.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.105),(61.895,18.275),(62.065,18.275),(62.065,18.105),(61.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.105),(62.255,18.275),(62.425,18.275),(62.425,18.105),(62.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.465),(61.175,18.635),(61.345,18.635),(61.345,18.465),(61.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.465),(61.535,18.635),(61.705,18.635),(61.705,18.465),(61.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.465),(61.895,18.635),(62.065,18.635),(62.065,18.465),(61.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.465),(62.255,18.635),(62.425,18.635),(62.425,18.465),(62.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.825),(61.175,18.995),(61.345,18.995),(61.345,18.825),(61.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.825),(61.535,18.995),(61.705,18.995),(61.705,18.825),(61.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.825),(61.895,18.995),(62.065,18.995),(62.065,18.825),(61.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.825),(62.255,18.995),(62.425,18.995),(62.425,18.825),(62.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.185),(61.175,19.355),(61.345,19.355),(61.345,19.185),(61.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.185),(61.535,19.355),(61.705,19.355),(61.705,19.185),(61.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.185),(61.895,19.355),(62.065,19.355),(62.065,19.185),(61.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.185),(62.255,19.355),(62.425,19.355),(62.425,19.185),(62.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.985),(51.575,3.155),(51.745,3.155),(51.745,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.985),(51.935,3.155),(52.105,3.155),(52.105,2.985),(51.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.985),(52.295,3.155),(52.465,3.155),(52.465,2.985),(52.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.985),(52.655,3.155),(52.825,3.155),(52.825,2.985),(52.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.345),(51.575,3.515),(51.745,3.515),(51.745,3.345),(51.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.345),(51.935,3.515),(52.105,3.515),(52.105,3.345),(51.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.345),(52.295,3.515),(52.465,3.515),(52.465,3.345),(52.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.345),(52.655,3.515),(52.825,3.515),(52.825,3.345),(52.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.705),(51.575,3.875),(51.745,3.875),(51.745,3.705),(51.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.705),(51.935,3.875),(52.105,3.875),(52.105,3.705),(51.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.705),(52.295,3.875),(52.465,3.875),(52.465,3.705),(52.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.705),(52.655,3.875),(52.825,3.875),(52.825,3.705),(52.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.065),(51.575,4.235),(51.745,4.235),(51.745,4.065),(51.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.065),(51.935,4.235),(52.105,4.235),(52.105,4.065),(51.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.065),(52.295,4.235),(52.465,4.235),(52.465,4.065),(52.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.065),(52.655,4.235),(52.825,4.235),(52.825,4.065),(52.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.425),(51.575,4.595),(51.745,4.595),(51.745,4.425),(51.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.425),(51.935,4.595),(52.105,4.595),(52.105,4.425),(51.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.425),(52.295,4.595),(52.465,4.595),(52.465,4.425),(52.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.425),(52.655,4.595),(52.825,4.595),(52.825,4.425),(52.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.785),(51.575,4.955),(51.745,4.955),(51.745,4.785),(51.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.785),(51.935,4.955),(52.105,4.955),(52.105,4.785),(51.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.785),(52.295,4.955),(52.465,4.955),(52.465,4.785),(52.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.785),(52.655,4.955),(52.825,4.955),(52.825,4.785),(52.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.145),(51.575,5.315),(51.745,5.315),(51.745,5.145),(51.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.145),(51.935,5.315),(52.105,5.315),(52.105,5.145),(51.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.145),(52.295,5.315),(52.465,5.315),(52.465,5.145),(52.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.145),(52.655,5.315),(52.825,5.315),(52.825,5.145),(52.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.505),(51.575,5.675),(51.745,5.675),(51.745,5.505),(51.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.505),(51.935,5.675),(52.105,5.675),(52.105,5.505),(51.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.505),(52.295,5.675),(52.465,5.675),(52.465,5.505),(52.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.505),(52.655,5.675),(52.825,5.675),(52.825,5.505),(52.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.865),(51.575,6.035),(51.745,6.035),(51.745,5.865),(51.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.865),(51.935,6.035),(52.105,6.035),(52.105,5.865),(51.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.865),(52.295,6.035),(52.465,6.035),(52.465,5.865),(52.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.865),(52.655,6.035),(52.825,6.035),(52.825,5.865),(52.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.225),(51.575,6.395),(51.745,6.395),(51.745,6.225),(51.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.225),(51.935,6.395),(52.105,6.395),(52.105,6.225),(51.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.225),(52.295,6.395),(52.465,6.395),(52.465,6.225),(52.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.225),(52.655,6.395),(52.825,6.395),(52.825,6.225),(52.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.585),(51.575,6.755),(51.745,6.755),(51.745,6.585),(51.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.585),(51.935,6.755),(52.105,6.755),(52.105,6.585),(51.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.585),(52.295,6.755),(52.465,6.755),(52.465,6.585),(52.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.585),(52.655,6.755),(52.825,6.755),(52.825,6.585),(52.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.945),(51.575,7.115),(51.745,7.115),(51.745,6.945),(51.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.945),(51.935,7.115),(52.105,7.115),(52.105,6.945),(51.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.945),(52.295,7.115),(52.465,7.115),(52.465,6.945),(52.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.945),(52.655,7.115),(52.825,7.115),(52.825,6.945),(52.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.305),(51.575,7.475),(51.745,7.475),(51.745,7.305),(51.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.305),(51.935,7.475),(52.105,7.475),(52.105,7.305),(51.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.305),(52.295,7.475),(52.465,7.475),(52.465,7.305),(52.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.305),(52.655,7.475),(52.825,7.475),(52.825,7.305),(52.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.665),(51.575,7.835),(51.745,7.835),(51.745,7.665),(51.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.665),(51.935,7.835),(52.105,7.835),(52.105,7.665),(51.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.665),(52.295,7.835),(52.465,7.835),(52.465,7.665),(52.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.665),(52.655,7.835),(52.825,7.835),(52.825,7.665),(52.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.025),(51.575,8.195),(51.745,8.195),(51.745,8.025),(51.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.025),(51.935,8.195),(52.105,8.195),(52.105,8.025),(51.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.025),(52.295,8.195),(52.465,8.195),(52.465,8.025),(52.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.025),(52.655,8.195),(52.825,8.195),(52.825,8.025),(52.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.385),(51.575,8.555),(51.745,8.555),(51.745,8.385),(51.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.385),(51.935,8.555),(52.105,8.555),(52.105,8.385),(51.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.385),(52.295,8.555),(52.465,8.555),(52.465,8.385),(52.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.385),(52.655,8.555),(52.825,8.555),(52.825,8.385),(52.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.745),(51.575,8.915),(51.745,8.915),(51.745,8.745),(51.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.745),(51.935,8.915),(52.105,8.915),(52.105,8.745),(51.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.745),(52.295,8.915),(52.465,8.915),(52.465,8.745),(52.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.745),(52.655,8.915),(52.825,8.915),(52.825,8.745),(52.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.105),(51.575,9.275),(51.745,9.275),(51.745,9.105),(51.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.105),(51.935,9.275),(52.105,9.275),(52.105,9.105),(51.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.105),(52.295,9.275),(52.465,9.275),(52.465,9.105),(52.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.105),(52.655,9.275),(52.825,9.275),(52.825,9.105),(52.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.465),(51.575,9.635),(51.745,9.635),(51.745,9.465),(51.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.465),(51.935,9.635),(52.105,9.635),(52.105,9.465),(51.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.465),(52.295,9.635),(52.465,9.635),(52.465,9.465),(52.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.465),(52.655,9.635),(52.825,9.635),(52.825,9.465),(52.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.825),(51.575,9.995),(51.745,9.995),(51.745,9.825),(51.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.825),(51.935,9.995),(52.105,9.995),(52.105,9.825),(51.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.825),(52.295,9.995),(52.465,9.995),(52.465,9.825),(52.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.825),(52.655,9.995),(52.825,9.995),(52.825,9.825),(52.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.185),(51.575,10.355),(51.745,10.355),(51.745,10.185),(51.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.185),(51.935,10.355),(52.105,10.355),(52.105,10.185),(51.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.185),(52.295,10.355),(52.465,10.355),(52.465,10.185),(52.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.185),(52.655,10.355),(52.825,10.355),(52.825,10.185),(52.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.545),(51.575,10.715),(51.745,10.715),(51.745,10.545),(51.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.545),(51.935,10.715),(52.105,10.715),(52.105,10.545),(51.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.545),(52.295,10.715),(52.465,10.715),(52.465,10.545),(52.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.545),(52.655,10.715),(52.825,10.715),(52.825,10.545),(52.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.905),(51.575,11.075),(51.745,11.075),(51.745,10.905),(51.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.905),(51.935,11.075),(52.105,11.075),(52.105,10.905),(51.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.905),(52.295,11.075),(52.465,11.075),(52.465,10.905),(52.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.905),(52.655,11.075),(52.825,11.075),(52.825,10.905),(52.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.265),(51.575,11.435),(51.745,11.435),(51.745,11.265),(51.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.265),(51.935,11.435),(52.105,11.435),(52.105,11.265),(51.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.265),(52.295,11.435),(52.465,11.435),(52.465,11.265),(52.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.265),(52.655,11.435),(52.825,11.435),(52.825,11.265),(52.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.625),(51.575,11.795),(51.745,11.795),(51.745,11.625),(51.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.625),(51.935,11.795),(52.105,11.795),(52.105,11.625),(51.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.625),(52.295,11.795),(52.465,11.795),(52.465,11.625),(52.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.625),(52.655,11.795),(52.825,11.795),(52.825,11.625),(52.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.985),(51.575,12.155),(51.745,12.155),(51.745,11.985),(51.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.985),(51.935,12.155),(52.105,12.155),(52.105,11.985),(51.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.985),(52.295,12.155),(52.465,12.155),(52.465,11.985),(52.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.985),(52.655,12.155),(52.825,12.155),(52.825,11.985),(52.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.345),(51.575,12.515),(51.745,12.515),(51.745,12.345),(51.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.345),(51.935,12.515),(52.105,12.515),(52.105,12.345),(51.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.345),(52.295,12.515),(52.465,12.515),(52.465,12.345),(52.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.345),(52.655,12.515),(52.825,12.515),(52.825,12.345),(52.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.705),(51.575,12.875),(51.745,12.875),(51.745,12.705),(51.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.705),(51.935,12.875),(52.105,12.875),(52.105,12.705),(51.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.705),(52.295,12.875),(52.465,12.875),(52.465,12.705),(52.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.705),(52.655,12.875),(52.825,12.875),(52.825,12.705),(52.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.065),(51.575,13.235),(51.745,13.235),(51.745,13.065),(51.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.065),(51.935,13.235),(52.105,13.235),(52.105,13.065),(51.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.065),(52.295,13.235),(52.465,13.235),(52.465,13.065),(52.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.065),(52.655,13.235),(52.825,13.235),(52.825,13.065),(52.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.425),(51.575,13.595),(51.745,13.595),(51.745,13.425),(51.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.425),(51.935,13.595),(52.105,13.595),(52.105,13.425),(51.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.425),(52.295,13.595),(52.465,13.595),(52.465,13.425),(52.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.425),(52.655,13.595),(52.825,13.595),(52.825,13.425),(52.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.785),(51.575,13.955),(51.745,13.955),(51.745,13.785),(51.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.785),(51.935,13.955),(52.105,13.955),(52.105,13.785),(51.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.785),(52.295,13.955),(52.465,13.955),(52.465,13.785),(52.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.785),(52.655,13.955),(52.825,13.955),(52.825,13.785),(52.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.145),(51.575,14.315),(51.745,14.315),(51.745,14.145),(51.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.145),(51.935,14.315),(52.105,14.315),(52.105,14.145),(51.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.145),(52.295,14.315),(52.465,14.315),(52.465,14.145),(52.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.145),(52.655,14.315),(52.825,14.315),(52.825,14.145),(52.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.505),(51.575,14.675),(51.745,14.675),(51.745,14.505),(51.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.505),(51.935,14.675),(52.105,14.675),(52.105,14.505),(51.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.505),(52.295,14.675),(52.465,14.675),(52.465,14.505),(52.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.505),(52.655,14.675),(52.825,14.675),(52.825,14.505),(52.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.865),(51.575,15.035),(51.745,15.035),(51.745,14.865),(51.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.865),(51.935,15.035),(52.105,15.035),(52.105,14.865),(51.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.865),(52.295,15.035),(52.465,15.035),(52.465,14.865),(52.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.865),(52.655,15.035),(52.825,15.035),(52.825,14.865),(52.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.225),(51.575,15.395),(51.745,15.395),(51.745,15.225),(51.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.225),(51.935,15.395),(52.105,15.395),(52.105,15.225),(51.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.225),(52.295,15.395),(52.465,15.395),(52.465,15.225),(52.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.225),(52.655,15.395),(52.825,15.395),(52.825,15.225),(52.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.585),(51.575,15.755),(51.745,15.755),(51.745,15.585),(51.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.585),(51.935,15.755),(52.105,15.755),(52.105,15.585),(51.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.585),(52.295,15.755),(52.465,15.755),(52.465,15.585),(52.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.585),(52.655,15.755),(52.825,15.755),(52.825,15.585),(52.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.945),(51.575,16.115),(51.745,16.115),(51.745,15.945),(51.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.945),(51.935,16.115),(52.105,16.115),(52.105,15.945),(51.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.945),(52.295,16.115),(52.465,16.115),(52.465,15.945),(52.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.945),(52.655,16.115),(52.825,16.115),(52.825,15.945),(52.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.305),(51.575,16.475),(51.745,16.475),(51.745,16.305),(51.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.305),(51.935,16.475),(52.105,16.475),(52.105,16.305),(51.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.305),(52.295,16.475),(52.465,16.475),(52.465,16.305),(52.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.305),(52.655,16.475),(52.825,16.475),(52.825,16.305),(52.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.665),(51.575,16.835),(51.745,16.835),(51.745,16.665),(51.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.665),(51.935,16.835),(52.105,16.835),(52.105,16.665),(51.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.665),(52.295,16.835),(52.465,16.835),(52.465,16.665),(52.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.665),(52.655,16.835),(52.825,16.835),(52.825,16.665),(52.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.025),(51.575,17.195),(51.745,17.195),(51.745,17.025),(51.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.025),(51.935,17.195),(52.105,17.195),(52.105,17.025),(51.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.025),(52.295,17.195),(52.465,17.195),(52.465,17.025),(52.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.025),(52.655,17.195),(52.825,17.195),(52.825,17.025),(52.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.385),(51.575,17.555),(51.745,17.555),(51.745,17.385),(51.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.385),(51.935,17.555),(52.105,17.555),(52.105,17.385),(51.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.385),(52.295,17.555),(52.465,17.555),(52.465,17.385),(52.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.385),(52.655,17.555),(52.825,17.555),(52.825,17.385),(52.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.745),(51.575,17.915),(51.745,17.915),(51.745,17.745),(51.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.745),(51.935,17.915),(52.105,17.915),(52.105,17.745),(51.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.745),(52.295,17.915),(52.465,17.915),(52.465,17.745),(52.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.745),(52.655,17.915),(52.825,17.915),(52.825,17.745),(52.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.105),(51.575,18.275),(51.745,18.275),(51.745,18.105),(51.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.105),(51.935,18.275),(52.105,18.275),(52.105,18.105),(51.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.105),(52.295,18.275),(52.465,18.275),(52.465,18.105),(52.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.105),(52.655,18.275),(52.825,18.275),(52.825,18.105),(52.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.465),(51.575,18.635),(51.745,18.635),(51.745,18.465),(51.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.465),(51.935,18.635),(52.105,18.635),(52.105,18.465),(51.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.465),(52.295,18.635),(52.465,18.635),(52.465,18.465),(52.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.465),(52.655,18.635),(52.825,18.635),(52.825,18.465),(52.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.825),(51.575,18.995),(51.745,18.995),(51.745,18.825),(51.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.825),(51.935,18.995),(52.105,18.995),(52.105,18.825),(51.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.825),(52.295,18.995),(52.465,18.995),(52.465,18.825),(52.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.825),(52.655,18.995),(52.825,18.995),(52.825,18.825),(52.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.185),(51.575,19.355),(51.745,19.355),(51.745,19.185),(51.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.185),(51.935,19.355),(52.105,19.355),(52.105,19.185),(51.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.185),(52.295,19.355),(52.465,19.355),(52.465,19.185),(52.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.185),(52.655,19.355),(52.825,19.355),(52.825,19.185),(52.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.985),(37.175,3.155),(37.345,3.155),(37.345,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.985),(37.535,3.155),(37.705,3.155),(37.705,2.985),(37.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.985),(37.895,3.155),(38.065,3.155),(38.065,2.985),(37.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.985),(38.255,3.155),(38.425,3.155),(38.425,2.985),(38.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.345),(37.175,3.515),(37.345,3.515),(37.345,3.345),(37.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.345),(37.535,3.515),(37.705,3.515),(37.705,3.345),(37.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.345),(37.895,3.515),(38.065,3.515),(38.065,3.345),(37.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.345),(38.255,3.515),(38.425,3.515),(38.425,3.345),(38.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.705),(37.175,3.875),(37.345,3.875),(37.345,3.705),(37.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.705),(37.535,3.875),(37.705,3.875),(37.705,3.705),(37.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.705),(37.895,3.875),(38.065,3.875),(38.065,3.705),(37.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.705),(38.255,3.875),(38.425,3.875),(38.425,3.705),(38.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.065),(37.175,4.235),(37.345,4.235),(37.345,4.065),(37.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.065),(37.535,4.235),(37.705,4.235),(37.705,4.065),(37.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.065),(37.895,4.235),(38.065,4.235),(38.065,4.065),(37.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.065),(38.255,4.235),(38.425,4.235),(38.425,4.065),(38.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.425),(37.175,4.595),(37.345,4.595),(37.345,4.425),(37.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.425),(37.535,4.595),(37.705,4.595),(37.705,4.425),(37.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.425),(37.895,4.595),(38.065,4.595),(38.065,4.425),(37.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.425),(38.255,4.595),(38.425,4.595),(38.425,4.425),(38.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.785),(37.175,4.955),(37.345,4.955),(37.345,4.785),(37.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.785),(37.535,4.955),(37.705,4.955),(37.705,4.785),(37.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.785),(37.895,4.955),(38.065,4.955),(38.065,4.785),(37.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.785),(38.255,4.955),(38.425,4.955),(38.425,4.785),(38.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.145),(37.175,5.315),(37.345,5.315),(37.345,5.145),(37.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.145),(37.535,5.315),(37.705,5.315),(37.705,5.145),(37.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.145),(37.895,5.315),(38.065,5.315),(38.065,5.145),(37.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.145),(38.255,5.315),(38.425,5.315),(38.425,5.145),(38.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.505),(37.175,5.675),(37.345,5.675),(37.345,5.505),(37.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.505),(37.535,5.675),(37.705,5.675),(37.705,5.505),(37.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.505),(37.895,5.675),(38.065,5.675),(38.065,5.505),(37.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.505),(38.255,5.675),(38.425,5.675),(38.425,5.505),(38.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.865),(37.175,6.035),(37.345,6.035),(37.345,5.865),(37.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.865),(37.535,6.035),(37.705,6.035),(37.705,5.865),(37.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.865),(37.895,6.035),(38.065,6.035),(38.065,5.865),(37.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.865),(38.255,6.035),(38.425,6.035),(38.425,5.865),(38.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.225),(37.175,6.395),(37.345,6.395),(37.345,6.225),(37.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.225),(37.535,6.395),(37.705,6.395),(37.705,6.225),(37.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.225),(37.895,6.395),(38.065,6.395),(38.065,6.225),(37.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.225),(38.255,6.395),(38.425,6.395),(38.425,6.225),(38.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.585),(37.175,6.755),(37.345,6.755),(37.345,6.585),(37.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.585),(37.535,6.755),(37.705,6.755),(37.705,6.585),(37.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.585),(37.895,6.755),(38.065,6.755),(38.065,6.585),(37.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.585),(38.255,6.755),(38.425,6.755),(38.425,6.585),(38.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.945),(37.175,7.115),(37.345,7.115),(37.345,6.945),(37.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.945),(37.535,7.115),(37.705,7.115),(37.705,6.945),(37.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.945),(37.895,7.115),(38.065,7.115),(38.065,6.945),(37.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.945),(38.255,7.115),(38.425,7.115),(38.425,6.945),(38.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.305),(37.175,7.475),(37.345,7.475),(37.345,7.305),(37.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.305),(37.535,7.475),(37.705,7.475),(37.705,7.305),(37.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.305),(37.895,7.475),(38.065,7.475),(38.065,7.305),(37.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.305),(38.255,7.475),(38.425,7.475),(38.425,7.305),(38.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.665),(37.175,7.835),(37.345,7.835),(37.345,7.665),(37.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.665),(37.535,7.835),(37.705,7.835),(37.705,7.665),(37.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.665),(37.895,7.835),(38.065,7.835),(38.065,7.665),(37.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.665),(38.255,7.835),(38.425,7.835),(38.425,7.665),(38.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.025),(37.175,8.195),(37.345,8.195),(37.345,8.025),(37.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.025),(37.535,8.195),(37.705,8.195),(37.705,8.025),(37.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.025),(37.895,8.195),(38.065,8.195),(38.065,8.025),(37.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.025),(38.255,8.195),(38.425,8.195),(38.425,8.025),(38.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.385),(37.175,8.555),(37.345,8.555),(37.345,8.385),(37.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.385),(37.535,8.555),(37.705,8.555),(37.705,8.385),(37.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.385),(37.895,8.555),(38.065,8.555),(38.065,8.385),(37.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.385),(38.255,8.555),(38.425,8.555),(38.425,8.385),(38.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.745),(37.175,8.915),(37.345,8.915),(37.345,8.745),(37.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.745),(37.535,8.915),(37.705,8.915),(37.705,8.745),(37.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.745),(37.895,8.915),(38.065,8.915),(38.065,8.745),(37.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.745),(38.255,8.915),(38.425,8.915),(38.425,8.745),(38.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.105),(37.175,9.275),(37.345,9.275),(37.345,9.105),(37.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.105),(37.535,9.275),(37.705,9.275),(37.705,9.105),(37.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.105),(37.895,9.275),(38.065,9.275),(38.065,9.105),(37.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.105),(38.255,9.275),(38.425,9.275),(38.425,9.105),(38.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.465),(37.175,9.635),(37.345,9.635),(37.345,9.465),(37.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.465),(37.535,9.635),(37.705,9.635),(37.705,9.465),(37.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.465),(37.895,9.635),(38.065,9.635),(38.065,9.465),(37.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.465),(38.255,9.635),(38.425,9.635),(38.425,9.465),(38.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.825),(37.175,9.995),(37.345,9.995),(37.345,9.825),(37.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.825),(37.535,9.995),(37.705,9.995),(37.705,9.825),(37.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.825),(37.895,9.995),(38.065,9.995),(38.065,9.825),(37.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.825),(38.255,9.995),(38.425,9.995),(38.425,9.825),(38.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.185),(37.175,10.355),(37.345,10.355),(37.345,10.185),(37.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.185),(37.535,10.355),(37.705,10.355),(37.705,10.185),(37.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.185),(37.895,10.355),(38.065,10.355),(38.065,10.185),(37.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.185),(38.255,10.355),(38.425,10.355),(38.425,10.185),(38.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.545),(37.175,10.715),(37.345,10.715),(37.345,10.545),(37.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.545),(37.535,10.715),(37.705,10.715),(37.705,10.545),(37.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.545),(37.895,10.715),(38.065,10.715),(38.065,10.545),(37.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.545),(38.255,10.715),(38.425,10.715),(38.425,10.545),(38.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.905),(37.175,11.075),(37.345,11.075),(37.345,10.905),(37.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.905),(37.535,11.075),(37.705,11.075),(37.705,10.905),(37.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.905),(37.895,11.075),(38.065,11.075),(38.065,10.905),(37.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.905),(38.255,11.075),(38.425,11.075),(38.425,10.905),(38.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.265),(37.175,11.435),(37.345,11.435),(37.345,11.265),(37.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.265),(37.535,11.435),(37.705,11.435),(37.705,11.265),(37.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.265),(37.895,11.435),(38.065,11.435),(38.065,11.265),(37.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.265),(38.255,11.435),(38.425,11.435),(38.425,11.265),(38.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.625),(37.175,11.795),(37.345,11.795),(37.345,11.625),(37.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.625),(37.535,11.795),(37.705,11.795),(37.705,11.625),(37.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.625),(37.895,11.795),(38.065,11.795),(38.065,11.625),(37.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.625),(38.255,11.795),(38.425,11.795),(38.425,11.625),(38.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.985),(37.175,12.155),(37.345,12.155),(37.345,11.985),(37.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.985),(37.535,12.155),(37.705,12.155),(37.705,11.985),(37.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.985),(37.895,12.155),(38.065,12.155),(38.065,11.985),(37.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.985),(38.255,12.155),(38.425,12.155),(38.425,11.985),(38.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.345),(37.175,12.515),(37.345,12.515),(37.345,12.345),(37.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.345),(37.535,12.515),(37.705,12.515),(37.705,12.345),(37.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.345),(37.895,12.515),(38.065,12.515),(38.065,12.345),(37.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.345),(38.255,12.515),(38.425,12.515),(38.425,12.345),(38.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.705),(37.175,12.875),(37.345,12.875),(37.345,12.705),(37.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.705),(37.535,12.875),(37.705,12.875),(37.705,12.705),(37.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.705),(37.895,12.875),(38.065,12.875),(38.065,12.705),(37.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.705),(38.255,12.875),(38.425,12.875),(38.425,12.705),(38.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.065),(37.175,13.235),(37.345,13.235),(37.345,13.065),(37.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.065),(37.535,13.235),(37.705,13.235),(37.705,13.065),(37.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.065),(37.895,13.235),(38.065,13.235),(38.065,13.065),(37.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.065),(38.255,13.235),(38.425,13.235),(38.425,13.065),(38.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.425),(37.175,13.595),(37.345,13.595),(37.345,13.425),(37.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.425),(37.535,13.595),(37.705,13.595),(37.705,13.425),(37.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.425),(37.895,13.595),(38.065,13.595),(38.065,13.425),(37.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.425),(38.255,13.595),(38.425,13.595),(38.425,13.425),(38.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.785),(37.175,13.955),(37.345,13.955),(37.345,13.785),(37.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.785),(37.535,13.955),(37.705,13.955),(37.705,13.785),(37.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.785),(37.895,13.955),(38.065,13.955),(38.065,13.785),(37.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.785),(38.255,13.955),(38.425,13.955),(38.425,13.785),(38.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.145),(37.175,14.315),(37.345,14.315),(37.345,14.145),(37.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.145),(37.535,14.315),(37.705,14.315),(37.705,14.145),(37.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.145),(37.895,14.315),(38.065,14.315),(38.065,14.145),(37.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.145),(38.255,14.315),(38.425,14.315),(38.425,14.145),(38.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.505),(37.175,14.675),(37.345,14.675),(37.345,14.505),(37.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.505),(37.535,14.675),(37.705,14.675),(37.705,14.505),(37.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.505),(37.895,14.675),(38.065,14.675),(38.065,14.505),(37.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.505),(38.255,14.675),(38.425,14.675),(38.425,14.505),(38.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.865),(37.175,15.035),(37.345,15.035),(37.345,14.865),(37.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.865),(37.535,15.035),(37.705,15.035),(37.705,14.865),(37.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.865),(37.895,15.035),(38.065,15.035),(38.065,14.865),(37.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.865),(38.255,15.035),(38.425,15.035),(38.425,14.865),(38.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.225),(37.175,15.395),(37.345,15.395),(37.345,15.225),(37.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.225),(37.535,15.395),(37.705,15.395),(37.705,15.225),(37.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.225),(37.895,15.395),(38.065,15.395),(38.065,15.225),(37.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.225),(38.255,15.395),(38.425,15.395),(38.425,15.225),(38.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.585),(37.175,15.755),(37.345,15.755),(37.345,15.585),(37.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.585),(37.535,15.755),(37.705,15.755),(37.705,15.585),(37.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.585),(37.895,15.755),(38.065,15.755),(38.065,15.585),(37.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.585),(38.255,15.755),(38.425,15.755),(38.425,15.585),(38.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.945),(37.175,16.115),(37.345,16.115),(37.345,15.945),(37.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.945),(37.535,16.115),(37.705,16.115),(37.705,15.945),(37.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.945),(37.895,16.115),(38.065,16.115),(38.065,15.945),(37.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.945),(38.255,16.115),(38.425,16.115),(38.425,15.945),(38.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.305),(37.175,16.475),(37.345,16.475),(37.345,16.305),(37.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.305),(37.535,16.475),(37.705,16.475),(37.705,16.305),(37.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.305),(37.895,16.475),(38.065,16.475),(38.065,16.305),(37.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.305),(38.255,16.475),(38.425,16.475),(38.425,16.305),(38.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.665),(37.175,16.835),(37.345,16.835),(37.345,16.665),(37.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.665),(37.535,16.835),(37.705,16.835),(37.705,16.665),(37.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.665),(37.895,16.835),(38.065,16.835),(38.065,16.665),(37.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.665),(38.255,16.835),(38.425,16.835),(38.425,16.665),(38.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.025),(37.175,17.195),(37.345,17.195),(37.345,17.025),(37.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.025),(37.535,17.195),(37.705,17.195),(37.705,17.025),(37.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.025),(37.895,17.195),(38.065,17.195),(38.065,17.025),(37.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.025),(38.255,17.195),(38.425,17.195),(38.425,17.025),(38.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.385),(37.175,17.555),(37.345,17.555),(37.345,17.385),(37.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.385),(37.535,17.555),(37.705,17.555),(37.705,17.385),(37.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.385),(37.895,17.555),(38.065,17.555),(38.065,17.385),(37.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.385),(38.255,17.555),(38.425,17.555),(38.425,17.385),(38.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.745),(37.175,17.915),(37.345,17.915),(37.345,17.745),(37.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.745),(37.535,17.915),(37.705,17.915),(37.705,17.745),(37.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.745),(37.895,17.915),(38.065,17.915),(38.065,17.745),(37.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.745),(38.255,17.915),(38.425,17.915),(38.425,17.745),(38.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.105),(37.175,18.275),(37.345,18.275),(37.345,18.105),(37.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.105),(37.535,18.275),(37.705,18.275),(37.705,18.105),(37.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.105),(37.895,18.275),(38.065,18.275),(38.065,18.105),(37.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.105),(38.255,18.275),(38.425,18.275),(38.425,18.105),(38.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.465),(37.175,18.635),(37.345,18.635),(37.345,18.465),(37.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.465),(37.535,18.635),(37.705,18.635),(37.705,18.465),(37.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.465),(37.895,18.635),(38.065,18.635),(38.065,18.465),(37.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.465),(38.255,18.635),(38.425,18.635),(38.425,18.465),(38.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.825),(37.175,18.995),(37.345,18.995),(37.345,18.825),(37.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.825),(37.535,18.995),(37.705,18.995),(37.705,18.825),(37.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.825),(37.895,18.995),(38.065,18.995),(38.065,18.825),(37.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.825),(38.255,18.995),(38.425,18.995),(38.425,18.825),(38.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.185),(37.175,19.355),(37.345,19.355),(37.345,19.185),(37.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.185),(37.535,19.355),(37.705,19.355),(37.705,19.185),(37.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.185),(37.895,19.355),(38.065,19.355),(38.065,19.185),(37.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.185),(38.255,19.355),(38.425,19.355),(38.425,19.185),(38.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,2.985),(22.775,3.155),(22.945,3.155),(22.945,2.985),(22.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,2.985),(23.135,3.155),(23.305,3.155),(23.305,2.985),(23.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,2.985),(23.495,3.155),(23.665,3.155),(23.665,2.985),(23.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,2.985),(23.855,3.155),(24.025,3.155),(24.025,2.985),(23.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.345),(22.775,3.515),(22.945,3.515),(22.945,3.345),(22.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.345),(23.135,3.515),(23.305,3.515),(23.305,3.345),(23.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.345),(23.495,3.515),(23.665,3.515),(23.665,3.345),(23.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.345),(23.855,3.515),(24.025,3.515),(24.025,3.345),(23.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.705),(22.775,3.875),(22.945,3.875),(22.945,3.705),(22.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.705),(23.135,3.875),(23.305,3.875),(23.305,3.705),(23.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.705),(23.495,3.875),(23.665,3.875),(23.665,3.705),(23.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.705),(23.855,3.875),(24.025,3.875),(24.025,3.705),(23.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.065),(22.775,4.235),(22.945,4.235),(22.945,4.065),(22.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.065),(23.135,4.235),(23.305,4.235),(23.305,4.065),(23.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.065),(23.495,4.235),(23.665,4.235),(23.665,4.065),(23.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.065),(23.855,4.235),(24.025,4.235),(24.025,4.065),(23.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.425),(22.775,4.595),(22.945,4.595),(22.945,4.425),(22.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.425),(23.135,4.595),(23.305,4.595),(23.305,4.425),(23.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.425),(23.495,4.595),(23.665,4.595),(23.665,4.425),(23.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.425),(23.855,4.595),(24.025,4.595),(24.025,4.425),(23.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.785),(22.775,4.955),(22.945,4.955),(22.945,4.785),(22.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.785),(23.135,4.955),(23.305,4.955),(23.305,4.785),(23.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.785),(23.495,4.955),(23.665,4.955),(23.665,4.785),(23.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.785),(23.855,4.955),(24.025,4.955),(24.025,4.785),(23.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.145),(22.775,5.315),(22.945,5.315),(22.945,5.145),(22.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.145),(23.135,5.315),(23.305,5.315),(23.305,5.145),(23.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.145),(23.495,5.315),(23.665,5.315),(23.665,5.145),(23.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.145),(23.855,5.315),(24.025,5.315),(24.025,5.145),(23.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.505),(22.775,5.675),(22.945,5.675),(22.945,5.505),(22.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.505),(23.135,5.675),(23.305,5.675),(23.305,5.505),(23.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.505),(23.495,5.675),(23.665,5.675),(23.665,5.505),(23.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.505),(23.855,5.675),(24.025,5.675),(24.025,5.505),(23.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.865),(22.775,6.035),(22.945,6.035),(22.945,5.865),(22.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.865),(23.135,6.035),(23.305,6.035),(23.305,5.865),(23.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.865),(23.495,6.035),(23.665,6.035),(23.665,5.865),(23.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.865),(23.855,6.035),(24.025,6.035),(24.025,5.865),(23.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.225),(22.775,6.395),(22.945,6.395),(22.945,6.225),(22.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.225),(23.135,6.395),(23.305,6.395),(23.305,6.225),(23.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.225),(23.495,6.395),(23.665,6.395),(23.665,6.225),(23.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.225),(23.855,6.395),(24.025,6.395),(24.025,6.225),(23.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.585),(22.775,6.755),(22.945,6.755),(22.945,6.585),(22.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.585),(23.135,6.755),(23.305,6.755),(23.305,6.585),(23.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.585),(23.495,6.755),(23.665,6.755),(23.665,6.585),(23.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.585),(23.855,6.755),(24.025,6.755),(24.025,6.585),(23.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.945),(22.775,7.115),(22.945,7.115),(22.945,6.945),(22.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.945),(23.135,7.115),(23.305,7.115),(23.305,6.945),(23.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.945),(23.495,7.115),(23.665,7.115),(23.665,6.945),(23.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.945),(23.855,7.115),(24.025,7.115),(24.025,6.945),(23.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.305),(22.775,7.475),(22.945,7.475),(22.945,7.305),(22.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.305),(23.135,7.475),(23.305,7.475),(23.305,7.305),(23.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.305),(23.495,7.475),(23.665,7.475),(23.665,7.305),(23.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.305),(23.855,7.475),(24.025,7.475),(24.025,7.305),(23.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.665),(22.775,7.835),(22.945,7.835),(22.945,7.665),(22.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.665),(23.135,7.835),(23.305,7.835),(23.305,7.665),(23.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.665),(23.495,7.835),(23.665,7.835),(23.665,7.665),(23.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.665),(23.855,7.835),(24.025,7.835),(24.025,7.665),(23.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.025),(22.775,8.195),(22.945,8.195),(22.945,8.025),(22.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.025),(23.135,8.195),(23.305,8.195),(23.305,8.025),(23.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.025),(23.495,8.195),(23.665,8.195),(23.665,8.025),(23.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.025),(23.855,8.195),(24.025,8.195),(24.025,8.025),(23.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.385),(22.775,8.555),(22.945,8.555),(22.945,8.385),(22.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.385),(23.135,8.555),(23.305,8.555),(23.305,8.385),(23.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.385),(23.495,8.555),(23.665,8.555),(23.665,8.385),(23.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.385),(23.855,8.555),(24.025,8.555),(24.025,8.385),(23.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.745),(22.775,8.915),(22.945,8.915),(22.945,8.745),(22.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.745),(23.135,8.915),(23.305,8.915),(23.305,8.745),(23.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.745),(23.495,8.915),(23.665,8.915),(23.665,8.745),(23.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.745),(23.855,8.915),(24.025,8.915),(24.025,8.745),(23.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.105),(22.775,9.275),(22.945,9.275),(22.945,9.105),(22.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.105),(23.135,9.275),(23.305,9.275),(23.305,9.105),(23.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.105),(23.495,9.275),(23.665,9.275),(23.665,9.105),(23.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.105),(23.855,9.275),(24.025,9.275),(24.025,9.105),(23.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.465),(22.775,9.635),(22.945,9.635),(22.945,9.465),(22.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.465),(23.135,9.635),(23.305,9.635),(23.305,9.465),(23.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.465),(23.495,9.635),(23.665,9.635),(23.665,9.465),(23.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.465),(23.855,9.635),(24.025,9.635),(24.025,9.465),(23.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.825),(22.775,9.995),(22.945,9.995),(22.945,9.825),(22.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.825),(23.135,9.995),(23.305,9.995),(23.305,9.825),(23.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.825),(23.495,9.995),(23.665,9.995),(23.665,9.825),(23.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.825),(23.855,9.995),(24.025,9.995),(24.025,9.825),(23.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.185),(22.775,10.355),(22.945,10.355),(22.945,10.185),(22.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.185),(23.135,10.355),(23.305,10.355),(23.305,10.185),(23.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.185),(23.495,10.355),(23.665,10.355),(23.665,10.185),(23.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.185),(23.855,10.355),(24.025,10.355),(24.025,10.185),(23.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.545),(22.775,10.715),(22.945,10.715),(22.945,10.545),(22.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.545),(23.135,10.715),(23.305,10.715),(23.305,10.545),(23.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.545),(23.495,10.715),(23.665,10.715),(23.665,10.545),(23.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.545),(23.855,10.715),(24.025,10.715),(24.025,10.545),(23.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.905),(22.775,11.075),(22.945,11.075),(22.945,10.905),(22.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.905),(23.135,11.075),(23.305,11.075),(23.305,10.905),(23.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.905),(23.495,11.075),(23.665,11.075),(23.665,10.905),(23.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.905),(23.855,11.075),(24.025,11.075),(24.025,10.905),(23.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.265),(22.775,11.435),(22.945,11.435),(22.945,11.265),(22.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.265),(23.135,11.435),(23.305,11.435),(23.305,11.265),(23.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.265),(23.495,11.435),(23.665,11.435),(23.665,11.265),(23.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.265),(23.855,11.435),(24.025,11.435),(24.025,11.265),(23.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.625),(22.775,11.795),(22.945,11.795),(22.945,11.625),(22.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.625),(23.135,11.795),(23.305,11.795),(23.305,11.625),(23.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.625),(23.495,11.795),(23.665,11.795),(23.665,11.625),(23.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.625),(23.855,11.795),(24.025,11.795),(24.025,11.625),(23.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.985),(22.775,12.155),(22.945,12.155),(22.945,11.985),(22.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.985),(23.135,12.155),(23.305,12.155),(23.305,11.985),(23.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.985),(23.495,12.155),(23.665,12.155),(23.665,11.985),(23.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.985),(23.855,12.155),(24.025,12.155),(24.025,11.985),(23.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.345),(22.775,12.515),(22.945,12.515),(22.945,12.345),(22.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.345),(23.135,12.515),(23.305,12.515),(23.305,12.345),(23.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.345),(23.495,12.515),(23.665,12.515),(23.665,12.345),(23.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.345),(23.855,12.515),(24.025,12.515),(24.025,12.345),(23.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.705),(22.775,12.875),(22.945,12.875),(22.945,12.705),(22.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.705),(23.135,12.875),(23.305,12.875),(23.305,12.705),(23.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.705),(23.495,12.875),(23.665,12.875),(23.665,12.705),(23.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.705),(23.855,12.875),(24.025,12.875),(24.025,12.705),(23.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.065),(22.775,13.235),(22.945,13.235),(22.945,13.065),(22.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.065),(23.135,13.235),(23.305,13.235),(23.305,13.065),(23.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.065),(23.495,13.235),(23.665,13.235),(23.665,13.065),(23.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.065),(23.855,13.235),(24.025,13.235),(24.025,13.065),(23.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.425),(22.775,13.595),(22.945,13.595),(22.945,13.425),(22.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.425),(23.135,13.595),(23.305,13.595),(23.305,13.425),(23.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.425),(23.495,13.595),(23.665,13.595),(23.665,13.425),(23.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.425),(23.855,13.595),(24.025,13.595),(24.025,13.425),(23.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.785),(22.775,13.955),(22.945,13.955),(22.945,13.785),(22.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.785),(23.135,13.955),(23.305,13.955),(23.305,13.785),(23.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.785),(23.495,13.955),(23.665,13.955),(23.665,13.785),(23.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.785),(23.855,13.955),(24.025,13.955),(24.025,13.785),(23.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.145),(22.775,14.315),(22.945,14.315),(22.945,14.145),(22.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.145),(23.135,14.315),(23.305,14.315),(23.305,14.145),(23.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.145),(23.495,14.315),(23.665,14.315),(23.665,14.145),(23.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.145),(23.855,14.315),(24.025,14.315),(24.025,14.145),(23.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.505),(22.775,14.675),(22.945,14.675),(22.945,14.505),(22.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.505),(23.135,14.675),(23.305,14.675),(23.305,14.505),(23.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.505),(23.495,14.675),(23.665,14.675),(23.665,14.505),(23.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.505),(23.855,14.675),(24.025,14.675),(24.025,14.505),(23.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.865),(22.775,15.035),(22.945,15.035),(22.945,14.865),(22.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.865),(23.135,15.035),(23.305,15.035),(23.305,14.865),(23.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.865),(23.495,15.035),(23.665,15.035),(23.665,14.865),(23.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.865),(23.855,15.035),(24.025,15.035),(24.025,14.865),(23.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.225),(22.775,15.395),(22.945,15.395),(22.945,15.225),(22.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.225),(23.135,15.395),(23.305,15.395),(23.305,15.225),(23.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.225),(23.495,15.395),(23.665,15.395),(23.665,15.225),(23.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.225),(23.855,15.395),(24.025,15.395),(24.025,15.225),(23.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.585),(22.775,15.755),(22.945,15.755),(22.945,15.585),(22.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.585),(23.135,15.755),(23.305,15.755),(23.305,15.585),(23.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.585),(23.495,15.755),(23.665,15.755),(23.665,15.585),(23.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.585),(23.855,15.755),(24.025,15.755),(24.025,15.585),(23.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.945),(22.775,16.115),(22.945,16.115),(22.945,15.945),(22.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.945),(23.135,16.115),(23.305,16.115),(23.305,15.945),(23.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.945),(23.495,16.115),(23.665,16.115),(23.665,15.945),(23.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.945),(23.855,16.115),(24.025,16.115),(24.025,15.945),(23.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.305),(22.775,16.475),(22.945,16.475),(22.945,16.305),(22.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.305),(23.135,16.475),(23.305,16.475),(23.305,16.305),(23.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.305),(23.495,16.475),(23.665,16.475),(23.665,16.305),(23.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.305),(23.855,16.475),(24.025,16.475),(24.025,16.305),(23.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.665),(22.775,16.835),(22.945,16.835),(22.945,16.665),(22.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.665),(23.135,16.835),(23.305,16.835),(23.305,16.665),(23.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.665),(23.495,16.835),(23.665,16.835),(23.665,16.665),(23.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.665),(23.855,16.835),(24.025,16.835),(24.025,16.665),(23.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.025),(22.775,17.195),(22.945,17.195),(22.945,17.025),(22.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.025),(23.135,17.195),(23.305,17.195),(23.305,17.025),(23.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.025),(23.495,17.195),(23.665,17.195),(23.665,17.025),(23.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.025),(23.855,17.195),(24.025,17.195),(24.025,17.025),(23.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.385),(22.775,17.555),(22.945,17.555),(22.945,17.385),(22.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.385),(23.135,17.555),(23.305,17.555),(23.305,17.385),(23.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.385),(23.495,17.555),(23.665,17.555),(23.665,17.385),(23.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.385),(23.855,17.555),(24.025,17.555),(24.025,17.385),(23.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.745),(22.775,17.915),(22.945,17.915),(22.945,17.745),(22.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.745),(23.135,17.915),(23.305,17.915),(23.305,17.745),(23.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.745),(23.495,17.915),(23.665,17.915),(23.665,17.745),(23.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.745),(23.855,17.915),(24.025,17.915),(24.025,17.745),(23.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.105),(22.775,18.275),(22.945,18.275),(22.945,18.105),(22.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.105),(23.135,18.275),(23.305,18.275),(23.305,18.105),(23.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.105),(23.495,18.275),(23.665,18.275),(23.665,18.105),(23.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.105),(23.855,18.275),(24.025,18.275),(24.025,18.105),(23.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.465),(22.775,18.635),(22.945,18.635),(22.945,18.465),(22.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.465),(23.135,18.635),(23.305,18.635),(23.305,18.465),(23.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.465),(23.495,18.635),(23.665,18.635),(23.665,18.465),(23.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.465),(23.855,18.635),(24.025,18.635),(24.025,18.465),(23.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.825),(22.775,18.995),(22.945,18.995),(22.945,18.825),(22.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.825),(23.135,18.995),(23.305,18.995),(23.305,18.825),(23.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.825),(23.495,18.995),(23.665,18.995),(23.665,18.825),(23.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.825),(23.855,18.995),(24.025,18.995),(24.025,18.825),(23.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.185),(22.775,19.355),(22.945,19.355),(22.945,19.185),(22.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.185),(23.135,19.355),(23.305,19.355),(23.305,19.185),(23.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.185),(23.495,19.355),(23.665,19.355),(23.665,19.185),(23.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.185),(23.855,19.355),(24.025,19.355),(24.025,19.185),(23.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.985),(56.375,3.155),(56.545,3.155),(56.545,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.985),(56.735,3.155),(56.905,3.155),(56.905,2.985),(56.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.985),(57.095,3.155),(57.265,3.155),(57.265,2.985),(57.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.985),(57.455,3.155),(57.625,3.155),(57.625,2.985),(57.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.345),(56.375,3.515),(56.545,3.515),(56.545,3.345),(56.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.345),(56.735,3.515),(56.905,3.515),(56.905,3.345),(56.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.345),(57.095,3.515),(57.265,3.515),(57.265,3.345),(57.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.345),(57.455,3.515),(57.625,3.515),(57.625,3.345),(57.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.705),(56.375,3.875),(56.545,3.875),(56.545,3.705),(56.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.705),(56.735,3.875),(56.905,3.875),(56.905,3.705),(56.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.705),(57.095,3.875),(57.265,3.875),(57.265,3.705),(57.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.705),(57.455,3.875),(57.625,3.875),(57.625,3.705),(57.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.065),(56.375,4.235),(56.545,4.235),(56.545,4.065),(56.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.065),(56.735,4.235),(56.905,4.235),(56.905,4.065),(56.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.065),(57.095,4.235),(57.265,4.235),(57.265,4.065),(57.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.065),(57.455,4.235),(57.625,4.235),(57.625,4.065),(57.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.425),(56.375,4.595),(56.545,4.595),(56.545,4.425),(56.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.425),(56.735,4.595),(56.905,4.595),(56.905,4.425),(56.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.425),(57.095,4.595),(57.265,4.595),(57.265,4.425),(57.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.425),(57.455,4.595),(57.625,4.595),(57.625,4.425),(57.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.785),(56.375,4.955),(56.545,4.955),(56.545,4.785),(56.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.785),(56.735,4.955),(56.905,4.955),(56.905,4.785),(56.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.785),(57.095,4.955),(57.265,4.955),(57.265,4.785),(57.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.785),(57.455,4.955),(57.625,4.955),(57.625,4.785),(57.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.145),(56.375,5.315),(56.545,5.315),(56.545,5.145),(56.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.145),(56.735,5.315),(56.905,5.315),(56.905,5.145),(56.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.145),(57.095,5.315),(57.265,5.315),(57.265,5.145),(57.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.145),(57.455,5.315),(57.625,5.315),(57.625,5.145),(57.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.505),(56.375,5.675),(56.545,5.675),(56.545,5.505),(56.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.505),(56.735,5.675),(56.905,5.675),(56.905,5.505),(56.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.505),(57.095,5.675),(57.265,5.675),(57.265,5.505),(57.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.505),(57.455,5.675),(57.625,5.675),(57.625,5.505),(57.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.865),(56.375,6.035),(56.545,6.035),(56.545,5.865),(56.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.865),(56.735,6.035),(56.905,6.035),(56.905,5.865),(56.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.865),(57.095,6.035),(57.265,6.035),(57.265,5.865),(57.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.865),(57.455,6.035),(57.625,6.035),(57.625,5.865),(57.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.225),(56.375,6.395),(56.545,6.395),(56.545,6.225),(56.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.225),(56.735,6.395),(56.905,6.395),(56.905,6.225),(56.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.225),(57.095,6.395),(57.265,6.395),(57.265,6.225),(57.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.225),(57.455,6.395),(57.625,6.395),(57.625,6.225),(57.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.585),(56.375,6.755),(56.545,6.755),(56.545,6.585),(56.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.585),(56.735,6.755),(56.905,6.755),(56.905,6.585),(56.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.585),(57.095,6.755),(57.265,6.755),(57.265,6.585),(57.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.585),(57.455,6.755),(57.625,6.755),(57.625,6.585),(57.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.945),(56.375,7.115),(56.545,7.115),(56.545,6.945),(56.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.945),(56.735,7.115),(56.905,7.115),(56.905,6.945),(56.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.945),(57.095,7.115),(57.265,7.115),(57.265,6.945),(57.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.945),(57.455,7.115),(57.625,7.115),(57.625,6.945),(57.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.305),(56.375,7.475),(56.545,7.475),(56.545,7.305),(56.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.305),(56.735,7.475),(56.905,7.475),(56.905,7.305),(56.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.305),(57.095,7.475),(57.265,7.475),(57.265,7.305),(57.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.305),(57.455,7.475),(57.625,7.475),(57.625,7.305),(57.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.665),(56.375,7.835),(56.545,7.835),(56.545,7.665),(56.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.665),(56.735,7.835),(56.905,7.835),(56.905,7.665),(56.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.665),(57.095,7.835),(57.265,7.835),(57.265,7.665),(57.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.665),(57.455,7.835),(57.625,7.835),(57.625,7.665),(57.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.025),(56.375,8.195),(56.545,8.195),(56.545,8.025),(56.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.025),(56.735,8.195),(56.905,8.195),(56.905,8.025),(56.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.025),(57.095,8.195),(57.265,8.195),(57.265,8.025),(57.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.025),(57.455,8.195),(57.625,8.195),(57.625,8.025),(57.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.385),(56.375,8.555),(56.545,8.555),(56.545,8.385),(56.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.385),(56.735,8.555),(56.905,8.555),(56.905,8.385),(56.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.385),(57.095,8.555),(57.265,8.555),(57.265,8.385),(57.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.385),(57.455,8.555),(57.625,8.555),(57.625,8.385),(57.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.745),(56.375,8.915),(56.545,8.915),(56.545,8.745),(56.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.745),(56.735,8.915),(56.905,8.915),(56.905,8.745),(56.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.745),(57.095,8.915),(57.265,8.915),(57.265,8.745),(57.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.745),(57.455,8.915),(57.625,8.915),(57.625,8.745),(57.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.105),(56.375,9.275),(56.545,9.275),(56.545,9.105),(56.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.105),(56.735,9.275),(56.905,9.275),(56.905,9.105),(56.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.105),(57.095,9.275),(57.265,9.275),(57.265,9.105),(57.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.105),(57.455,9.275),(57.625,9.275),(57.625,9.105),(57.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.465),(56.375,9.635),(56.545,9.635),(56.545,9.465),(56.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.465),(56.735,9.635),(56.905,9.635),(56.905,9.465),(56.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.465),(57.095,9.635),(57.265,9.635),(57.265,9.465),(57.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.465),(57.455,9.635),(57.625,9.635),(57.625,9.465),(57.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.825),(56.375,9.995),(56.545,9.995),(56.545,9.825),(56.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.825),(56.735,9.995),(56.905,9.995),(56.905,9.825),(56.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.825),(57.095,9.995),(57.265,9.995),(57.265,9.825),(57.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.825),(57.455,9.995),(57.625,9.995),(57.625,9.825),(57.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.185),(56.375,10.355),(56.545,10.355),(56.545,10.185),(56.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.185),(56.735,10.355),(56.905,10.355),(56.905,10.185),(56.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.185),(57.095,10.355),(57.265,10.355),(57.265,10.185),(57.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.185),(57.455,10.355),(57.625,10.355),(57.625,10.185),(57.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.545),(56.375,10.715),(56.545,10.715),(56.545,10.545),(56.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.545),(56.735,10.715),(56.905,10.715),(56.905,10.545),(56.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.545),(57.095,10.715),(57.265,10.715),(57.265,10.545),(57.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.545),(57.455,10.715),(57.625,10.715),(57.625,10.545),(57.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.905),(56.375,11.075),(56.545,11.075),(56.545,10.905),(56.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.905),(56.735,11.075),(56.905,11.075),(56.905,10.905),(56.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.905),(57.095,11.075),(57.265,11.075),(57.265,10.905),(57.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.905),(57.455,11.075),(57.625,11.075),(57.625,10.905),(57.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.265),(56.375,11.435),(56.545,11.435),(56.545,11.265),(56.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.265),(56.735,11.435),(56.905,11.435),(56.905,11.265),(56.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.265),(57.095,11.435),(57.265,11.435),(57.265,11.265),(57.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.265),(57.455,11.435),(57.625,11.435),(57.625,11.265),(57.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.625),(56.375,11.795),(56.545,11.795),(56.545,11.625),(56.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.625),(56.735,11.795),(56.905,11.795),(56.905,11.625),(56.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.625),(57.095,11.795),(57.265,11.795),(57.265,11.625),(57.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.625),(57.455,11.795),(57.625,11.795),(57.625,11.625),(57.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.985),(56.375,12.155),(56.545,12.155),(56.545,11.985),(56.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.985),(56.735,12.155),(56.905,12.155),(56.905,11.985),(56.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.985),(57.095,12.155),(57.265,12.155),(57.265,11.985),(57.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.985),(57.455,12.155),(57.625,12.155),(57.625,11.985),(57.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.345),(56.375,12.515),(56.545,12.515),(56.545,12.345),(56.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.345),(56.735,12.515),(56.905,12.515),(56.905,12.345),(56.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.345),(57.095,12.515),(57.265,12.515),(57.265,12.345),(57.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.345),(57.455,12.515),(57.625,12.515),(57.625,12.345),(57.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.705),(56.375,12.875),(56.545,12.875),(56.545,12.705),(56.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.705),(56.735,12.875),(56.905,12.875),(56.905,12.705),(56.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.705),(57.095,12.875),(57.265,12.875),(57.265,12.705),(57.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.705),(57.455,12.875),(57.625,12.875),(57.625,12.705),(57.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.065),(56.375,13.235),(56.545,13.235),(56.545,13.065),(56.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.065),(56.735,13.235),(56.905,13.235),(56.905,13.065),(56.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.065),(57.095,13.235),(57.265,13.235),(57.265,13.065),(57.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.065),(57.455,13.235),(57.625,13.235),(57.625,13.065),(57.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.425),(56.375,13.595),(56.545,13.595),(56.545,13.425),(56.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.425),(56.735,13.595),(56.905,13.595),(56.905,13.425),(56.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.425),(57.095,13.595),(57.265,13.595),(57.265,13.425),(57.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.425),(57.455,13.595),(57.625,13.595),(57.625,13.425),(57.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.785),(56.375,13.955),(56.545,13.955),(56.545,13.785),(56.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.785),(56.735,13.955),(56.905,13.955),(56.905,13.785),(56.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.785),(57.095,13.955),(57.265,13.955),(57.265,13.785),(57.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.785),(57.455,13.955),(57.625,13.955),(57.625,13.785),(57.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.145),(56.375,14.315),(56.545,14.315),(56.545,14.145),(56.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.145),(56.735,14.315),(56.905,14.315),(56.905,14.145),(56.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.145),(57.095,14.315),(57.265,14.315),(57.265,14.145),(57.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.145),(57.455,14.315),(57.625,14.315),(57.625,14.145),(57.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.505),(56.375,14.675),(56.545,14.675),(56.545,14.505),(56.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.505),(56.735,14.675),(56.905,14.675),(56.905,14.505),(56.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.505),(57.095,14.675),(57.265,14.675),(57.265,14.505),(57.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.505),(57.455,14.675),(57.625,14.675),(57.625,14.505),(57.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.865),(56.375,15.035),(56.545,15.035),(56.545,14.865),(56.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.865),(56.735,15.035),(56.905,15.035),(56.905,14.865),(56.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.865),(57.095,15.035),(57.265,15.035),(57.265,14.865),(57.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.865),(57.455,15.035),(57.625,15.035),(57.625,14.865),(57.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.225),(56.375,15.395),(56.545,15.395),(56.545,15.225),(56.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.225),(56.735,15.395),(56.905,15.395),(56.905,15.225),(56.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.225),(57.095,15.395),(57.265,15.395),(57.265,15.225),(57.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.225),(57.455,15.395),(57.625,15.395),(57.625,15.225),(57.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.585),(56.375,15.755),(56.545,15.755),(56.545,15.585),(56.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.585),(56.735,15.755),(56.905,15.755),(56.905,15.585),(56.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.585),(57.095,15.755),(57.265,15.755),(57.265,15.585),(57.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.585),(57.455,15.755),(57.625,15.755),(57.625,15.585),(57.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.945),(56.375,16.115),(56.545,16.115),(56.545,15.945),(56.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.945),(56.735,16.115),(56.905,16.115),(56.905,15.945),(56.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.945),(57.095,16.115),(57.265,16.115),(57.265,15.945),(57.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.945),(57.455,16.115),(57.625,16.115),(57.625,15.945),(57.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.305),(56.375,16.475),(56.545,16.475),(56.545,16.305),(56.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.305),(56.735,16.475),(56.905,16.475),(56.905,16.305),(56.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.305),(57.095,16.475),(57.265,16.475),(57.265,16.305),(57.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.305),(57.455,16.475),(57.625,16.475),(57.625,16.305),(57.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.665),(56.375,16.835),(56.545,16.835),(56.545,16.665),(56.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.665),(56.735,16.835),(56.905,16.835),(56.905,16.665),(56.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.665),(57.095,16.835),(57.265,16.835),(57.265,16.665),(57.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.665),(57.455,16.835),(57.625,16.835),(57.625,16.665),(57.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.025),(56.375,17.195),(56.545,17.195),(56.545,17.025),(56.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.025),(56.735,17.195),(56.905,17.195),(56.905,17.025),(56.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.025),(57.095,17.195),(57.265,17.195),(57.265,17.025),(57.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.025),(57.455,17.195),(57.625,17.195),(57.625,17.025),(57.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.385),(56.375,17.555),(56.545,17.555),(56.545,17.385),(56.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.385),(56.735,17.555),(56.905,17.555),(56.905,17.385),(56.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.385),(57.095,17.555),(57.265,17.555),(57.265,17.385),(57.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.385),(57.455,17.555),(57.625,17.555),(57.625,17.385),(57.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.745),(56.375,17.915),(56.545,17.915),(56.545,17.745),(56.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.745),(56.735,17.915),(56.905,17.915),(56.905,17.745),(56.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.745),(57.095,17.915),(57.265,17.915),(57.265,17.745),(57.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.745),(57.455,17.915),(57.625,17.915),(57.625,17.745),(57.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.105),(56.375,18.275),(56.545,18.275),(56.545,18.105),(56.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.105),(56.735,18.275),(56.905,18.275),(56.905,18.105),(56.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.105),(57.095,18.275),(57.265,18.275),(57.265,18.105),(57.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.105),(57.455,18.275),(57.625,18.275),(57.625,18.105),(57.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.465),(56.375,18.635),(56.545,18.635),(56.545,18.465),(56.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.465),(56.735,18.635),(56.905,18.635),(56.905,18.465),(56.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.465),(57.095,18.635),(57.265,18.635),(57.265,18.465),(57.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.465),(57.455,18.635),(57.625,18.635),(57.625,18.465),(57.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.825),(56.375,18.995),(56.545,18.995),(56.545,18.825),(56.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.825),(56.735,18.995),(56.905,18.995),(56.905,18.825),(56.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.825),(57.095,18.995),(57.265,18.995),(57.265,18.825),(57.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.825),(57.455,18.995),(57.625,18.995),(57.625,18.825),(57.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.185),(56.375,19.355),(56.545,19.355),(56.545,19.185),(56.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.185),(56.735,19.355),(56.905,19.355),(56.905,19.185),(56.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.185),(57.095,19.355),(57.265,19.355),(57.265,19.185),(57.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.185),(57.455,19.355),(57.625,19.355),(57.625,19.185),(57.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,2.985),(70.775,3.155),(70.945,3.155),(70.945,2.985),(70.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,2.985),(71.135,3.155),(71.305,3.155),(71.305,2.985),(71.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,2.985),(71.495,3.155),(71.665,3.155),(71.665,2.985),(71.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,2.985),(71.855,3.155),(72.025,3.155),(72.025,2.985),(71.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.345),(70.775,3.515),(70.945,3.515),(70.945,3.345),(70.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.345),(71.135,3.515),(71.305,3.515),(71.305,3.345),(71.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.345),(71.495,3.515),(71.665,3.515),(71.665,3.345),(71.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.345),(71.855,3.515),(72.025,3.515),(72.025,3.345),(71.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.705),(70.775,3.875),(70.945,3.875),(70.945,3.705),(70.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.705),(71.135,3.875),(71.305,3.875),(71.305,3.705),(71.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.705),(71.495,3.875),(71.665,3.875),(71.665,3.705),(71.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.705),(71.855,3.875),(72.025,3.875),(72.025,3.705),(71.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.065),(70.775,4.235),(70.945,4.235),(70.945,4.065),(70.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.065),(71.135,4.235),(71.305,4.235),(71.305,4.065),(71.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.065),(71.495,4.235),(71.665,4.235),(71.665,4.065),(71.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.065),(71.855,4.235),(72.025,4.235),(72.025,4.065),(71.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.425),(70.775,4.595),(70.945,4.595),(70.945,4.425),(70.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.425),(71.135,4.595),(71.305,4.595),(71.305,4.425),(71.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.425),(71.495,4.595),(71.665,4.595),(71.665,4.425),(71.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.425),(71.855,4.595),(72.025,4.595),(72.025,4.425),(71.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.785),(70.775,4.955),(70.945,4.955),(70.945,4.785),(70.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.785),(71.135,4.955),(71.305,4.955),(71.305,4.785),(71.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.785),(71.495,4.955),(71.665,4.955),(71.665,4.785),(71.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.785),(71.855,4.955),(72.025,4.955),(72.025,4.785),(71.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.145),(70.775,5.315),(70.945,5.315),(70.945,5.145),(70.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.145),(71.135,5.315),(71.305,5.315),(71.305,5.145),(71.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.145),(71.495,5.315),(71.665,5.315),(71.665,5.145),(71.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.145),(71.855,5.315),(72.025,5.315),(72.025,5.145),(71.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.505),(70.775,5.675),(70.945,5.675),(70.945,5.505),(70.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.505),(71.135,5.675),(71.305,5.675),(71.305,5.505),(71.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.505),(71.495,5.675),(71.665,5.675),(71.665,5.505),(71.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.505),(71.855,5.675),(72.025,5.675),(72.025,5.505),(71.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.865),(70.775,6.035),(70.945,6.035),(70.945,5.865),(70.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.865),(71.135,6.035),(71.305,6.035),(71.305,5.865),(71.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.865),(71.495,6.035),(71.665,6.035),(71.665,5.865),(71.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.865),(71.855,6.035),(72.025,6.035),(72.025,5.865),(71.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.225),(70.775,6.395),(70.945,6.395),(70.945,6.225),(70.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.225),(71.135,6.395),(71.305,6.395),(71.305,6.225),(71.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.225),(71.495,6.395),(71.665,6.395),(71.665,6.225),(71.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.225),(71.855,6.395),(72.025,6.395),(72.025,6.225),(71.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.585),(70.775,6.755),(70.945,6.755),(70.945,6.585),(70.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.585),(71.135,6.755),(71.305,6.755),(71.305,6.585),(71.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.585),(71.495,6.755),(71.665,6.755),(71.665,6.585),(71.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.585),(71.855,6.755),(72.025,6.755),(72.025,6.585),(71.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.945),(70.775,7.115),(70.945,7.115),(70.945,6.945),(70.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.945),(71.135,7.115),(71.305,7.115),(71.305,6.945),(71.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.945),(71.495,7.115),(71.665,7.115),(71.665,6.945),(71.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.945),(71.855,7.115),(72.025,7.115),(72.025,6.945),(71.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.305),(70.775,7.475),(70.945,7.475),(70.945,7.305),(70.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.305),(71.135,7.475),(71.305,7.475),(71.305,7.305),(71.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.305),(71.495,7.475),(71.665,7.475),(71.665,7.305),(71.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.305),(71.855,7.475),(72.025,7.475),(72.025,7.305),(71.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.665),(70.775,7.835),(70.945,7.835),(70.945,7.665),(70.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.665),(71.135,7.835),(71.305,7.835),(71.305,7.665),(71.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.665),(71.495,7.835),(71.665,7.835),(71.665,7.665),(71.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.665),(71.855,7.835),(72.025,7.835),(72.025,7.665),(71.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.025),(70.775,8.195),(70.945,8.195),(70.945,8.025),(70.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.025),(71.135,8.195),(71.305,8.195),(71.305,8.025),(71.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.025),(71.495,8.195),(71.665,8.195),(71.665,8.025),(71.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.025),(71.855,8.195),(72.025,8.195),(72.025,8.025),(71.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.385),(70.775,8.555),(70.945,8.555),(70.945,8.385),(70.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.385),(71.135,8.555),(71.305,8.555),(71.305,8.385),(71.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.385),(71.495,8.555),(71.665,8.555),(71.665,8.385),(71.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.385),(71.855,8.555),(72.025,8.555),(72.025,8.385),(71.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.745),(70.775,8.915),(70.945,8.915),(70.945,8.745),(70.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.745),(71.135,8.915),(71.305,8.915),(71.305,8.745),(71.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.745),(71.495,8.915),(71.665,8.915),(71.665,8.745),(71.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.745),(71.855,8.915),(72.025,8.915),(72.025,8.745),(71.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.105),(70.775,9.275),(70.945,9.275),(70.945,9.105),(70.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.105),(71.135,9.275),(71.305,9.275),(71.305,9.105),(71.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.105),(71.495,9.275),(71.665,9.275),(71.665,9.105),(71.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.105),(71.855,9.275),(72.025,9.275),(72.025,9.105),(71.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.465),(70.775,9.635),(70.945,9.635),(70.945,9.465),(70.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.465),(71.135,9.635),(71.305,9.635),(71.305,9.465),(71.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.465),(71.495,9.635),(71.665,9.635),(71.665,9.465),(71.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.465),(71.855,9.635),(72.025,9.635),(72.025,9.465),(71.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.825),(70.775,9.995),(70.945,9.995),(70.945,9.825),(70.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.825),(71.135,9.995),(71.305,9.995),(71.305,9.825),(71.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.825),(71.495,9.995),(71.665,9.995),(71.665,9.825),(71.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.825),(71.855,9.995),(72.025,9.995),(72.025,9.825),(71.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.185),(70.775,10.355),(70.945,10.355),(70.945,10.185),(70.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.185),(71.135,10.355),(71.305,10.355),(71.305,10.185),(71.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.185),(71.495,10.355),(71.665,10.355),(71.665,10.185),(71.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.185),(71.855,10.355),(72.025,10.355),(72.025,10.185),(71.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.545),(70.775,10.715),(70.945,10.715),(70.945,10.545),(70.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.545),(71.135,10.715),(71.305,10.715),(71.305,10.545),(71.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.545),(71.495,10.715),(71.665,10.715),(71.665,10.545),(71.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.545),(71.855,10.715),(72.025,10.715),(72.025,10.545),(71.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.905),(70.775,11.075),(70.945,11.075),(70.945,10.905),(70.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.905),(71.135,11.075),(71.305,11.075),(71.305,10.905),(71.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.905),(71.495,11.075),(71.665,11.075),(71.665,10.905),(71.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.905),(71.855,11.075),(72.025,11.075),(72.025,10.905),(71.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.265),(70.775,11.435),(70.945,11.435),(70.945,11.265),(70.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.265),(71.135,11.435),(71.305,11.435),(71.305,11.265),(71.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.265),(71.495,11.435),(71.665,11.435),(71.665,11.265),(71.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.265),(71.855,11.435),(72.025,11.435),(72.025,11.265),(71.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.625),(70.775,11.795),(70.945,11.795),(70.945,11.625),(70.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.625),(71.135,11.795),(71.305,11.795),(71.305,11.625),(71.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.625),(71.495,11.795),(71.665,11.795),(71.665,11.625),(71.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.625),(71.855,11.795),(72.025,11.795),(72.025,11.625),(71.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.985),(70.775,12.155),(70.945,12.155),(70.945,11.985),(70.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.985),(71.135,12.155),(71.305,12.155),(71.305,11.985),(71.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.985),(71.495,12.155),(71.665,12.155),(71.665,11.985),(71.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.985),(71.855,12.155),(72.025,12.155),(72.025,11.985),(71.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.345),(70.775,12.515),(70.945,12.515),(70.945,12.345),(70.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.345),(71.135,12.515),(71.305,12.515),(71.305,12.345),(71.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.345),(71.495,12.515),(71.665,12.515),(71.665,12.345),(71.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.345),(71.855,12.515),(72.025,12.515),(72.025,12.345),(71.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.705),(70.775,12.875),(70.945,12.875),(70.945,12.705),(70.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.705),(71.135,12.875),(71.305,12.875),(71.305,12.705),(71.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.705),(71.495,12.875),(71.665,12.875),(71.665,12.705),(71.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.705),(71.855,12.875),(72.025,12.875),(72.025,12.705),(71.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.065),(70.775,13.235),(70.945,13.235),(70.945,13.065),(70.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.065),(71.135,13.235),(71.305,13.235),(71.305,13.065),(71.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.065),(71.495,13.235),(71.665,13.235),(71.665,13.065),(71.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.065),(71.855,13.235),(72.025,13.235),(72.025,13.065),(71.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.425),(70.775,13.595),(70.945,13.595),(70.945,13.425),(70.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.425),(71.135,13.595),(71.305,13.595),(71.305,13.425),(71.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.425),(71.495,13.595),(71.665,13.595),(71.665,13.425),(71.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.425),(71.855,13.595),(72.025,13.595),(72.025,13.425),(71.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.785),(70.775,13.955),(70.945,13.955),(70.945,13.785),(70.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.785),(71.135,13.955),(71.305,13.955),(71.305,13.785),(71.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.785),(71.495,13.955),(71.665,13.955),(71.665,13.785),(71.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.785),(71.855,13.955),(72.025,13.955),(72.025,13.785),(71.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.145),(70.775,14.315),(70.945,14.315),(70.945,14.145),(70.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.145),(71.135,14.315),(71.305,14.315),(71.305,14.145),(71.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.145),(71.495,14.315),(71.665,14.315),(71.665,14.145),(71.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.145),(71.855,14.315),(72.025,14.315),(72.025,14.145),(71.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.505),(70.775,14.675),(70.945,14.675),(70.945,14.505),(70.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.505),(71.135,14.675),(71.305,14.675),(71.305,14.505),(71.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.505),(71.495,14.675),(71.665,14.675),(71.665,14.505),(71.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.505),(71.855,14.675),(72.025,14.675),(72.025,14.505),(71.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.865),(70.775,15.035),(70.945,15.035),(70.945,14.865),(70.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.865),(71.135,15.035),(71.305,15.035),(71.305,14.865),(71.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.865),(71.495,15.035),(71.665,15.035),(71.665,14.865),(71.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.865),(71.855,15.035),(72.025,15.035),(72.025,14.865),(71.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.225),(70.775,15.395),(70.945,15.395),(70.945,15.225),(70.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.225),(71.135,15.395),(71.305,15.395),(71.305,15.225),(71.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.225),(71.495,15.395),(71.665,15.395),(71.665,15.225),(71.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.225),(71.855,15.395),(72.025,15.395),(72.025,15.225),(71.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.585),(70.775,15.755),(70.945,15.755),(70.945,15.585),(70.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.585),(71.135,15.755),(71.305,15.755),(71.305,15.585),(71.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.585),(71.495,15.755),(71.665,15.755),(71.665,15.585),(71.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.585),(71.855,15.755),(72.025,15.755),(72.025,15.585),(71.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.945),(70.775,16.115),(70.945,16.115),(70.945,15.945),(70.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.945),(71.135,16.115),(71.305,16.115),(71.305,15.945),(71.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.945),(71.495,16.115),(71.665,16.115),(71.665,15.945),(71.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.945),(71.855,16.115),(72.025,16.115),(72.025,15.945),(71.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.305),(70.775,16.475),(70.945,16.475),(70.945,16.305),(70.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.305),(71.135,16.475),(71.305,16.475),(71.305,16.305),(71.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.305),(71.495,16.475),(71.665,16.475),(71.665,16.305),(71.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.305),(71.855,16.475),(72.025,16.475),(72.025,16.305),(71.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.665),(70.775,16.835),(70.945,16.835),(70.945,16.665),(70.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.665),(71.135,16.835),(71.305,16.835),(71.305,16.665),(71.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.665),(71.495,16.835),(71.665,16.835),(71.665,16.665),(71.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.665),(71.855,16.835),(72.025,16.835),(72.025,16.665),(71.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.025),(70.775,17.195),(70.945,17.195),(70.945,17.025),(70.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.025),(71.135,17.195),(71.305,17.195),(71.305,17.025),(71.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.025),(71.495,17.195),(71.665,17.195),(71.665,17.025),(71.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.025),(71.855,17.195),(72.025,17.195),(72.025,17.025),(71.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.385),(70.775,17.555),(70.945,17.555),(70.945,17.385),(70.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.385),(71.135,17.555),(71.305,17.555),(71.305,17.385),(71.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.385),(71.495,17.555),(71.665,17.555),(71.665,17.385),(71.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.385),(71.855,17.555),(72.025,17.555),(72.025,17.385),(71.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.745),(70.775,17.915),(70.945,17.915),(70.945,17.745),(70.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.745),(71.135,17.915),(71.305,17.915),(71.305,17.745),(71.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.745),(71.495,17.915),(71.665,17.915),(71.665,17.745),(71.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.745),(71.855,17.915),(72.025,17.915),(72.025,17.745),(71.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.105),(70.775,18.275),(70.945,18.275),(70.945,18.105),(70.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.105),(71.135,18.275),(71.305,18.275),(71.305,18.105),(71.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.105),(71.495,18.275),(71.665,18.275),(71.665,18.105),(71.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.105),(71.855,18.275),(72.025,18.275),(72.025,18.105),(71.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.465),(70.775,18.635),(70.945,18.635),(70.945,18.465),(70.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.465),(71.135,18.635),(71.305,18.635),(71.305,18.465),(71.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.465),(71.495,18.635),(71.665,18.635),(71.665,18.465),(71.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.465),(71.855,18.635),(72.025,18.635),(72.025,18.465),(71.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.825),(70.775,18.995),(70.945,18.995),(70.945,18.825),(70.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.825),(71.135,18.995),(71.305,18.995),(71.305,18.825),(71.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.825),(71.495,18.995),(71.665,18.995),(71.665,18.825),(71.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.825),(71.855,18.995),(72.025,18.995),(72.025,18.825),(71.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.185),(70.775,19.355),(70.945,19.355),(70.945,19.185),(70.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.185),(71.135,19.355),(71.305,19.355),(71.305,19.185),(71.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.185),(71.495,19.355),(71.665,19.355),(71.665,19.185),(71.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.185),(71.855,19.355),(72.025,19.355),(72.025,19.185),(71.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,2.985),(27.575,3.155),(27.745,3.155),(27.745,2.985),(27.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,2.985),(27.935,3.155),(28.105,3.155),(28.105,2.985),(27.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,2.985),(28.295,3.155),(28.465,3.155),(28.465,2.985),(28.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,2.985),(28.655,3.155),(28.825,3.155),(28.825,2.985),(28.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.345),(27.575,3.515),(27.745,3.515),(27.745,3.345),(27.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.345),(27.935,3.515),(28.105,3.515),(28.105,3.345),(27.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.345),(28.295,3.515),(28.465,3.515),(28.465,3.345),(28.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.345),(28.655,3.515),(28.825,3.515),(28.825,3.345),(28.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.705),(27.575,3.875),(27.745,3.875),(27.745,3.705),(27.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.705),(27.935,3.875),(28.105,3.875),(28.105,3.705),(27.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.705),(28.295,3.875),(28.465,3.875),(28.465,3.705),(28.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.705),(28.655,3.875),(28.825,3.875),(28.825,3.705),(28.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.065),(27.575,4.235),(27.745,4.235),(27.745,4.065),(27.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.065),(27.935,4.235),(28.105,4.235),(28.105,4.065),(27.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.065),(28.295,4.235),(28.465,4.235),(28.465,4.065),(28.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.065),(28.655,4.235),(28.825,4.235),(28.825,4.065),(28.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.425),(27.575,4.595),(27.745,4.595),(27.745,4.425),(27.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.425),(27.935,4.595),(28.105,4.595),(28.105,4.425),(27.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.425),(28.295,4.595),(28.465,4.595),(28.465,4.425),(28.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.425),(28.655,4.595),(28.825,4.595),(28.825,4.425),(28.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.785),(27.575,4.955),(27.745,4.955),(27.745,4.785),(27.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.785),(27.935,4.955),(28.105,4.955),(28.105,4.785),(27.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.785),(28.295,4.955),(28.465,4.955),(28.465,4.785),(28.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.785),(28.655,4.955),(28.825,4.955),(28.825,4.785),(28.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.145),(27.575,5.315),(27.745,5.315),(27.745,5.145),(27.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.145),(27.935,5.315),(28.105,5.315),(28.105,5.145),(27.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.145),(28.295,5.315),(28.465,5.315),(28.465,5.145),(28.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.145),(28.655,5.315),(28.825,5.315),(28.825,5.145),(28.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.505),(27.575,5.675),(27.745,5.675),(27.745,5.505),(27.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.505),(27.935,5.675),(28.105,5.675),(28.105,5.505),(27.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.505),(28.295,5.675),(28.465,5.675),(28.465,5.505),(28.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.505),(28.655,5.675),(28.825,5.675),(28.825,5.505),(28.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.865),(27.575,6.035),(27.745,6.035),(27.745,5.865),(27.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.865),(27.935,6.035),(28.105,6.035),(28.105,5.865),(27.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.865),(28.295,6.035),(28.465,6.035),(28.465,5.865),(28.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.865),(28.655,6.035),(28.825,6.035),(28.825,5.865),(28.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.225),(27.575,6.395),(27.745,6.395),(27.745,6.225),(27.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.225),(27.935,6.395),(28.105,6.395),(28.105,6.225),(27.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.225),(28.295,6.395),(28.465,6.395),(28.465,6.225),(28.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.225),(28.655,6.395),(28.825,6.395),(28.825,6.225),(28.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.585),(27.575,6.755),(27.745,6.755),(27.745,6.585),(27.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.585),(27.935,6.755),(28.105,6.755),(28.105,6.585),(27.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.585),(28.295,6.755),(28.465,6.755),(28.465,6.585),(28.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.585),(28.655,6.755),(28.825,6.755),(28.825,6.585),(28.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.945),(27.575,7.115),(27.745,7.115),(27.745,6.945),(27.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.945),(27.935,7.115),(28.105,7.115),(28.105,6.945),(27.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.945),(28.295,7.115),(28.465,7.115),(28.465,6.945),(28.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.945),(28.655,7.115),(28.825,7.115),(28.825,6.945),(28.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.305),(27.575,7.475),(27.745,7.475),(27.745,7.305),(27.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.305),(27.935,7.475),(28.105,7.475),(28.105,7.305),(27.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.305),(28.295,7.475),(28.465,7.475),(28.465,7.305),(28.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.305),(28.655,7.475),(28.825,7.475),(28.825,7.305),(28.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.665),(27.575,7.835),(27.745,7.835),(27.745,7.665),(27.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.665),(27.935,7.835),(28.105,7.835),(28.105,7.665),(27.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.665),(28.295,7.835),(28.465,7.835),(28.465,7.665),(28.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.665),(28.655,7.835),(28.825,7.835),(28.825,7.665),(28.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.025),(27.575,8.195),(27.745,8.195),(27.745,8.025),(27.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.025),(27.935,8.195),(28.105,8.195),(28.105,8.025),(27.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.025),(28.295,8.195),(28.465,8.195),(28.465,8.025),(28.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.025),(28.655,8.195),(28.825,8.195),(28.825,8.025),(28.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.385),(27.575,8.555),(27.745,8.555),(27.745,8.385),(27.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.385),(27.935,8.555),(28.105,8.555),(28.105,8.385),(27.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.385),(28.295,8.555),(28.465,8.555),(28.465,8.385),(28.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.385),(28.655,8.555),(28.825,8.555),(28.825,8.385),(28.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.745),(27.575,8.915),(27.745,8.915),(27.745,8.745),(27.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.745),(27.935,8.915),(28.105,8.915),(28.105,8.745),(27.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.745),(28.295,8.915),(28.465,8.915),(28.465,8.745),(28.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.745),(28.655,8.915),(28.825,8.915),(28.825,8.745),(28.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.105),(27.575,9.275),(27.745,9.275),(27.745,9.105),(27.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.105),(27.935,9.275),(28.105,9.275),(28.105,9.105),(27.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.105),(28.295,9.275),(28.465,9.275),(28.465,9.105),(28.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.105),(28.655,9.275),(28.825,9.275),(28.825,9.105),(28.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.465),(27.575,9.635),(27.745,9.635),(27.745,9.465),(27.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.465),(27.935,9.635),(28.105,9.635),(28.105,9.465),(27.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.465),(28.295,9.635),(28.465,9.635),(28.465,9.465),(28.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.465),(28.655,9.635),(28.825,9.635),(28.825,9.465),(28.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.825),(27.575,9.995),(27.745,9.995),(27.745,9.825),(27.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.825),(27.935,9.995),(28.105,9.995),(28.105,9.825),(27.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.825),(28.295,9.995),(28.465,9.995),(28.465,9.825),(28.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.825),(28.655,9.995),(28.825,9.995),(28.825,9.825),(28.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.185),(27.575,10.355),(27.745,10.355),(27.745,10.185),(27.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.185),(27.935,10.355),(28.105,10.355),(28.105,10.185),(27.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.185),(28.295,10.355),(28.465,10.355),(28.465,10.185),(28.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.185),(28.655,10.355),(28.825,10.355),(28.825,10.185),(28.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.545),(27.575,10.715),(27.745,10.715),(27.745,10.545),(27.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.545),(27.935,10.715),(28.105,10.715),(28.105,10.545),(27.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.545),(28.295,10.715),(28.465,10.715),(28.465,10.545),(28.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.545),(28.655,10.715),(28.825,10.715),(28.825,10.545),(28.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.905),(27.575,11.075),(27.745,11.075),(27.745,10.905),(27.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.905),(27.935,11.075),(28.105,11.075),(28.105,10.905),(27.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.905),(28.295,11.075),(28.465,11.075),(28.465,10.905),(28.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.905),(28.655,11.075),(28.825,11.075),(28.825,10.905),(28.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.265),(27.575,11.435),(27.745,11.435),(27.745,11.265),(27.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.265),(27.935,11.435),(28.105,11.435),(28.105,11.265),(27.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.265),(28.295,11.435),(28.465,11.435),(28.465,11.265),(28.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.265),(28.655,11.435),(28.825,11.435),(28.825,11.265),(28.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.625),(27.575,11.795),(27.745,11.795),(27.745,11.625),(27.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.625),(27.935,11.795),(28.105,11.795),(28.105,11.625),(27.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.625),(28.295,11.795),(28.465,11.795),(28.465,11.625),(28.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.625),(28.655,11.795),(28.825,11.795),(28.825,11.625),(28.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.985),(27.575,12.155),(27.745,12.155),(27.745,11.985),(27.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.985),(27.935,12.155),(28.105,12.155),(28.105,11.985),(27.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.985),(28.295,12.155),(28.465,12.155),(28.465,11.985),(28.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.985),(28.655,12.155),(28.825,12.155),(28.825,11.985),(28.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.345),(27.575,12.515),(27.745,12.515),(27.745,12.345),(27.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.345),(27.935,12.515),(28.105,12.515),(28.105,12.345),(27.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.345),(28.295,12.515),(28.465,12.515),(28.465,12.345),(28.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.345),(28.655,12.515),(28.825,12.515),(28.825,12.345),(28.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.705),(27.575,12.875),(27.745,12.875),(27.745,12.705),(27.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.705),(27.935,12.875),(28.105,12.875),(28.105,12.705),(27.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.705),(28.295,12.875),(28.465,12.875),(28.465,12.705),(28.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.705),(28.655,12.875),(28.825,12.875),(28.825,12.705),(28.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.065),(27.575,13.235),(27.745,13.235),(27.745,13.065),(27.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.065),(27.935,13.235),(28.105,13.235),(28.105,13.065),(27.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.065),(28.295,13.235),(28.465,13.235),(28.465,13.065),(28.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.065),(28.655,13.235),(28.825,13.235),(28.825,13.065),(28.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.425),(27.575,13.595),(27.745,13.595),(27.745,13.425),(27.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.425),(27.935,13.595),(28.105,13.595),(28.105,13.425),(27.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.425),(28.295,13.595),(28.465,13.595),(28.465,13.425),(28.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.425),(28.655,13.595),(28.825,13.595),(28.825,13.425),(28.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.785),(27.575,13.955),(27.745,13.955),(27.745,13.785),(27.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.785),(27.935,13.955),(28.105,13.955),(28.105,13.785),(27.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.785),(28.295,13.955),(28.465,13.955),(28.465,13.785),(28.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.785),(28.655,13.955),(28.825,13.955),(28.825,13.785),(28.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.145),(27.575,14.315),(27.745,14.315),(27.745,14.145),(27.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.145),(27.935,14.315),(28.105,14.315),(28.105,14.145),(27.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.145),(28.295,14.315),(28.465,14.315),(28.465,14.145),(28.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.145),(28.655,14.315),(28.825,14.315),(28.825,14.145),(28.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.505),(27.575,14.675),(27.745,14.675),(27.745,14.505),(27.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.505),(27.935,14.675),(28.105,14.675),(28.105,14.505),(27.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.505),(28.295,14.675),(28.465,14.675),(28.465,14.505),(28.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.505),(28.655,14.675),(28.825,14.675),(28.825,14.505),(28.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.865),(27.575,15.035),(27.745,15.035),(27.745,14.865),(27.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.865),(27.935,15.035),(28.105,15.035),(28.105,14.865),(27.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.865),(28.295,15.035),(28.465,15.035),(28.465,14.865),(28.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.865),(28.655,15.035),(28.825,15.035),(28.825,14.865),(28.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.225),(27.575,15.395),(27.745,15.395),(27.745,15.225),(27.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.225),(27.935,15.395),(28.105,15.395),(28.105,15.225),(27.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.225),(28.295,15.395),(28.465,15.395),(28.465,15.225),(28.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.225),(28.655,15.395),(28.825,15.395),(28.825,15.225),(28.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.585),(27.575,15.755),(27.745,15.755),(27.745,15.585),(27.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.585),(27.935,15.755),(28.105,15.755),(28.105,15.585),(27.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.585),(28.295,15.755),(28.465,15.755),(28.465,15.585),(28.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.585),(28.655,15.755),(28.825,15.755),(28.825,15.585),(28.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.945),(27.575,16.115),(27.745,16.115),(27.745,15.945),(27.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.945),(27.935,16.115),(28.105,16.115),(28.105,15.945),(27.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.945),(28.295,16.115),(28.465,16.115),(28.465,15.945),(28.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.945),(28.655,16.115),(28.825,16.115),(28.825,15.945),(28.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.305),(27.575,16.475),(27.745,16.475),(27.745,16.305),(27.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.305),(27.935,16.475),(28.105,16.475),(28.105,16.305),(27.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.305),(28.295,16.475),(28.465,16.475),(28.465,16.305),(28.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.305),(28.655,16.475),(28.825,16.475),(28.825,16.305),(28.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.665),(27.575,16.835),(27.745,16.835),(27.745,16.665),(27.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.665),(27.935,16.835),(28.105,16.835),(28.105,16.665),(27.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.665),(28.295,16.835),(28.465,16.835),(28.465,16.665),(28.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.665),(28.655,16.835),(28.825,16.835),(28.825,16.665),(28.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.025),(27.575,17.195),(27.745,17.195),(27.745,17.025),(27.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.025),(27.935,17.195),(28.105,17.195),(28.105,17.025),(27.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.025),(28.295,17.195),(28.465,17.195),(28.465,17.025),(28.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.025),(28.655,17.195),(28.825,17.195),(28.825,17.025),(28.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.385),(27.575,17.555),(27.745,17.555),(27.745,17.385),(27.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.385),(27.935,17.555),(28.105,17.555),(28.105,17.385),(27.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.385),(28.295,17.555),(28.465,17.555),(28.465,17.385),(28.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.385),(28.655,17.555),(28.825,17.555),(28.825,17.385),(28.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.745),(27.575,17.915),(27.745,17.915),(27.745,17.745),(27.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.745),(27.935,17.915),(28.105,17.915),(28.105,17.745),(27.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.745),(28.295,17.915),(28.465,17.915),(28.465,17.745),(28.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.745),(28.655,17.915),(28.825,17.915),(28.825,17.745),(28.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.105),(27.575,18.275),(27.745,18.275),(27.745,18.105),(27.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.105),(27.935,18.275),(28.105,18.275),(28.105,18.105),(27.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.105),(28.295,18.275),(28.465,18.275),(28.465,18.105),(28.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.105),(28.655,18.275),(28.825,18.275),(28.825,18.105),(28.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.465),(27.575,18.635),(27.745,18.635),(27.745,18.465),(27.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.465),(27.935,18.635),(28.105,18.635),(28.105,18.465),(27.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.465),(28.295,18.635),(28.465,18.635),(28.465,18.465),(28.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.465),(28.655,18.635),(28.825,18.635),(28.825,18.465),(28.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.825),(27.575,18.995),(27.745,18.995),(27.745,18.825),(27.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.825),(27.935,18.995),(28.105,18.995),(28.105,18.825),(27.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.825),(28.295,18.995),(28.465,18.995),(28.465,18.825),(28.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.825),(28.655,18.995),(28.825,18.995),(28.825,18.825),(28.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.185),(27.575,19.355),(27.745,19.355),(27.745,19.185),(27.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.185),(27.935,19.355),(28.105,19.355),(28.105,19.185),(27.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.185),(28.295,19.355),(28.465,19.355),(28.465,19.185),(28.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.185),(28.655,19.355),(28.825,19.355),(28.825,19.185),(28.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,2.985),(65.975,3.155),(66.145,3.155),(66.145,2.985),(65.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,2.985),(66.335,3.155),(66.505,3.155),(66.505,2.985),(66.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,2.985),(66.695,3.155),(66.865,3.155),(66.865,2.985),(66.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,2.985),(67.055,3.155),(67.225,3.155),(67.225,2.985),(67.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.345),(65.975,3.515),(66.145,3.515),(66.145,3.345),(65.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.345),(66.335,3.515),(66.505,3.515),(66.505,3.345),(66.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.345),(66.695,3.515),(66.865,3.515),(66.865,3.345),(66.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.345),(67.055,3.515),(67.225,3.515),(67.225,3.345),(67.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.705),(65.975,3.875),(66.145,3.875),(66.145,3.705),(65.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.705),(66.335,3.875),(66.505,3.875),(66.505,3.705),(66.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.705),(66.695,3.875),(66.865,3.875),(66.865,3.705),(66.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.705),(67.055,3.875),(67.225,3.875),(67.225,3.705),(67.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.065),(65.975,4.235),(66.145,4.235),(66.145,4.065),(65.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.065),(66.335,4.235),(66.505,4.235),(66.505,4.065),(66.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.065),(66.695,4.235),(66.865,4.235),(66.865,4.065),(66.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.065),(67.055,4.235),(67.225,4.235),(67.225,4.065),(67.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.425),(65.975,4.595),(66.145,4.595),(66.145,4.425),(65.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.425),(66.335,4.595),(66.505,4.595),(66.505,4.425),(66.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.425),(66.695,4.595),(66.865,4.595),(66.865,4.425),(66.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.425),(67.055,4.595),(67.225,4.595),(67.225,4.425),(67.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.785),(65.975,4.955),(66.145,4.955),(66.145,4.785),(65.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.785),(66.335,4.955),(66.505,4.955),(66.505,4.785),(66.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.785),(66.695,4.955),(66.865,4.955),(66.865,4.785),(66.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.785),(67.055,4.955),(67.225,4.955),(67.225,4.785),(67.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.145),(65.975,5.315),(66.145,5.315),(66.145,5.145),(65.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.145),(66.335,5.315),(66.505,5.315),(66.505,5.145),(66.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.145),(66.695,5.315),(66.865,5.315),(66.865,5.145),(66.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.145),(67.055,5.315),(67.225,5.315),(67.225,5.145),(67.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.505),(65.975,5.675),(66.145,5.675),(66.145,5.505),(65.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.505),(66.335,5.675),(66.505,5.675),(66.505,5.505),(66.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.505),(66.695,5.675),(66.865,5.675),(66.865,5.505),(66.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.505),(67.055,5.675),(67.225,5.675),(67.225,5.505),(67.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.865),(65.975,6.035),(66.145,6.035),(66.145,5.865),(65.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.865),(66.335,6.035),(66.505,6.035),(66.505,5.865),(66.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.865),(66.695,6.035),(66.865,6.035),(66.865,5.865),(66.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.865),(67.055,6.035),(67.225,6.035),(67.225,5.865),(67.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.225),(65.975,6.395),(66.145,6.395),(66.145,6.225),(65.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.225),(66.335,6.395),(66.505,6.395),(66.505,6.225),(66.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.225),(66.695,6.395),(66.865,6.395),(66.865,6.225),(66.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.225),(67.055,6.395),(67.225,6.395),(67.225,6.225),(67.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.585),(65.975,6.755),(66.145,6.755),(66.145,6.585),(65.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.585),(66.335,6.755),(66.505,6.755),(66.505,6.585),(66.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.585),(66.695,6.755),(66.865,6.755),(66.865,6.585),(66.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.585),(67.055,6.755),(67.225,6.755),(67.225,6.585),(67.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.945),(65.975,7.115),(66.145,7.115),(66.145,6.945),(65.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.945),(66.335,7.115),(66.505,7.115),(66.505,6.945),(66.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.945),(66.695,7.115),(66.865,7.115),(66.865,6.945),(66.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.945),(67.055,7.115),(67.225,7.115),(67.225,6.945),(67.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.305),(65.975,7.475),(66.145,7.475),(66.145,7.305),(65.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.305),(66.335,7.475),(66.505,7.475),(66.505,7.305),(66.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.305),(66.695,7.475),(66.865,7.475),(66.865,7.305),(66.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.305),(67.055,7.475),(67.225,7.475),(67.225,7.305),(67.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.665),(65.975,7.835),(66.145,7.835),(66.145,7.665),(65.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.665),(66.335,7.835),(66.505,7.835),(66.505,7.665),(66.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.665),(66.695,7.835),(66.865,7.835),(66.865,7.665),(66.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.665),(67.055,7.835),(67.225,7.835),(67.225,7.665),(67.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.025),(65.975,8.195),(66.145,8.195),(66.145,8.025),(65.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.025),(66.335,8.195),(66.505,8.195),(66.505,8.025),(66.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.025),(66.695,8.195),(66.865,8.195),(66.865,8.025),(66.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.025),(67.055,8.195),(67.225,8.195),(67.225,8.025),(67.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.385),(65.975,8.555),(66.145,8.555),(66.145,8.385),(65.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.385),(66.335,8.555),(66.505,8.555),(66.505,8.385),(66.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.385),(66.695,8.555),(66.865,8.555),(66.865,8.385),(66.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.385),(67.055,8.555),(67.225,8.555),(67.225,8.385),(67.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.745),(65.975,8.915),(66.145,8.915),(66.145,8.745),(65.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.745),(66.335,8.915),(66.505,8.915),(66.505,8.745),(66.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.745),(66.695,8.915),(66.865,8.915),(66.865,8.745),(66.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.745),(67.055,8.915),(67.225,8.915),(67.225,8.745),(67.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.105),(65.975,9.275),(66.145,9.275),(66.145,9.105),(65.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.105),(66.335,9.275),(66.505,9.275),(66.505,9.105),(66.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.105),(66.695,9.275),(66.865,9.275),(66.865,9.105),(66.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.105),(67.055,9.275),(67.225,9.275),(67.225,9.105),(67.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.465),(65.975,9.635),(66.145,9.635),(66.145,9.465),(65.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.465),(66.335,9.635),(66.505,9.635),(66.505,9.465),(66.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.465),(66.695,9.635),(66.865,9.635),(66.865,9.465),(66.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.465),(67.055,9.635),(67.225,9.635),(67.225,9.465),(67.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.825),(65.975,9.995),(66.145,9.995),(66.145,9.825),(65.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.825),(66.335,9.995),(66.505,9.995),(66.505,9.825),(66.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.825),(66.695,9.995),(66.865,9.995),(66.865,9.825),(66.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.825),(67.055,9.995),(67.225,9.995),(67.225,9.825),(67.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.185),(65.975,10.355),(66.145,10.355),(66.145,10.185),(65.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.185),(66.335,10.355),(66.505,10.355),(66.505,10.185),(66.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.185),(66.695,10.355),(66.865,10.355),(66.865,10.185),(66.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.185),(67.055,10.355),(67.225,10.355),(67.225,10.185),(67.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.545),(65.975,10.715),(66.145,10.715),(66.145,10.545),(65.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.545),(66.335,10.715),(66.505,10.715),(66.505,10.545),(66.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.545),(66.695,10.715),(66.865,10.715),(66.865,10.545),(66.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.545),(67.055,10.715),(67.225,10.715),(67.225,10.545),(67.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.905),(65.975,11.075),(66.145,11.075),(66.145,10.905),(65.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.905),(66.335,11.075),(66.505,11.075),(66.505,10.905),(66.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.905),(66.695,11.075),(66.865,11.075),(66.865,10.905),(66.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.905),(67.055,11.075),(67.225,11.075),(67.225,10.905),(67.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.265),(65.975,11.435),(66.145,11.435),(66.145,11.265),(65.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.265),(66.335,11.435),(66.505,11.435),(66.505,11.265),(66.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.265),(66.695,11.435),(66.865,11.435),(66.865,11.265),(66.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.265),(67.055,11.435),(67.225,11.435),(67.225,11.265),(67.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.625),(65.975,11.795),(66.145,11.795),(66.145,11.625),(65.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.625),(66.335,11.795),(66.505,11.795),(66.505,11.625),(66.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.625),(66.695,11.795),(66.865,11.795),(66.865,11.625),(66.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.625),(67.055,11.795),(67.225,11.795),(67.225,11.625),(67.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.985),(65.975,12.155),(66.145,12.155),(66.145,11.985),(65.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.985),(66.335,12.155),(66.505,12.155),(66.505,11.985),(66.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.985),(66.695,12.155),(66.865,12.155),(66.865,11.985),(66.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.985),(67.055,12.155),(67.225,12.155),(67.225,11.985),(67.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.345),(65.975,12.515),(66.145,12.515),(66.145,12.345),(65.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.345),(66.335,12.515),(66.505,12.515),(66.505,12.345),(66.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.345),(66.695,12.515),(66.865,12.515),(66.865,12.345),(66.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.345),(67.055,12.515),(67.225,12.515),(67.225,12.345),(67.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.705),(65.975,12.875),(66.145,12.875),(66.145,12.705),(65.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.705),(66.335,12.875),(66.505,12.875),(66.505,12.705),(66.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.705),(66.695,12.875),(66.865,12.875),(66.865,12.705),(66.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.705),(67.055,12.875),(67.225,12.875),(67.225,12.705),(67.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.065),(65.975,13.235),(66.145,13.235),(66.145,13.065),(65.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.065),(66.335,13.235),(66.505,13.235),(66.505,13.065),(66.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.065),(66.695,13.235),(66.865,13.235),(66.865,13.065),(66.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.065),(67.055,13.235),(67.225,13.235),(67.225,13.065),(67.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.425),(65.975,13.595),(66.145,13.595),(66.145,13.425),(65.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.425),(66.335,13.595),(66.505,13.595),(66.505,13.425),(66.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.425),(66.695,13.595),(66.865,13.595),(66.865,13.425),(66.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.425),(67.055,13.595),(67.225,13.595),(67.225,13.425),(67.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.785),(65.975,13.955),(66.145,13.955),(66.145,13.785),(65.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.785),(66.335,13.955),(66.505,13.955),(66.505,13.785),(66.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.785),(66.695,13.955),(66.865,13.955),(66.865,13.785),(66.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.785),(67.055,13.955),(67.225,13.955),(67.225,13.785),(67.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.145),(65.975,14.315),(66.145,14.315),(66.145,14.145),(65.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.145),(66.335,14.315),(66.505,14.315),(66.505,14.145),(66.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.145),(66.695,14.315),(66.865,14.315),(66.865,14.145),(66.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.145),(67.055,14.315),(67.225,14.315),(67.225,14.145),(67.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.505),(65.975,14.675),(66.145,14.675),(66.145,14.505),(65.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.505),(66.335,14.675),(66.505,14.675),(66.505,14.505),(66.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.505),(66.695,14.675),(66.865,14.675),(66.865,14.505),(66.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.505),(67.055,14.675),(67.225,14.675),(67.225,14.505),(67.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.865),(65.975,15.035),(66.145,15.035),(66.145,14.865),(65.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.865),(66.335,15.035),(66.505,15.035),(66.505,14.865),(66.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.865),(66.695,15.035),(66.865,15.035),(66.865,14.865),(66.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.865),(67.055,15.035),(67.225,15.035),(67.225,14.865),(67.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.225),(65.975,15.395),(66.145,15.395),(66.145,15.225),(65.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.225),(66.335,15.395),(66.505,15.395),(66.505,15.225),(66.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.225),(66.695,15.395),(66.865,15.395),(66.865,15.225),(66.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.225),(67.055,15.395),(67.225,15.395),(67.225,15.225),(67.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.585),(65.975,15.755),(66.145,15.755),(66.145,15.585),(65.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.585),(66.335,15.755),(66.505,15.755),(66.505,15.585),(66.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.585),(66.695,15.755),(66.865,15.755),(66.865,15.585),(66.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.585),(67.055,15.755),(67.225,15.755),(67.225,15.585),(67.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.945),(65.975,16.115),(66.145,16.115),(66.145,15.945),(65.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.945),(66.335,16.115),(66.505,16.115),(66.505,15.945),(66.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.945),(66.695,16.115),(66.865,16.115),(66.865,15.945),(66.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.945),(67.055,16.115),(67.225,16.115),(67.225,15.945),(67.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.305),(65.975,16.475),(66.145,16.475),(66.145,16.305),(65.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.305),(66.335,16.475),(66.505,16.475),(66.505,16.305),(66.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.305),(66.695,16.475),(66.865,16.475),(66.865,16.305),(66.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.305),(67.055,16.475),(67.225,16.475),(67.225,16.305),(67.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.665),(65.975,16.835),(66.145,16.835),(66.145,16.665),(65.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.665),(66.335,16.835),(66.505,16.835),(66.505,16.665),(66.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.665),(66.695,16.835),(66.865,16.835),(66.865,16.665),(66.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.665),(67.055,16.835),(67.225,16.835),(67.225,16.665),(67.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.025),(65.975,17.195),(66.145,17.195),(66.145,17.025),(65.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.025),(66.335,17.195),(66.505,17.195),(66.505,17.025),(66.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.025),(66.695,17.195),(66.865,17.195),(66.865,17.025),(66.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.025),(67.055,17.195),(67.225,17.195),(67.225,17.025),(67.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.385),(65.975,17.555),(66.145,17.555),(66.145,17.385),(65.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.385),(66.335,17.555),(66.505,17.555),(66.505,17.385),(66.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.385),(66.695,17.555),(66.865,17.555),(66.865,17.385),(66.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.385),(67.055,17.555),(67.225,17.555),(67.225,17.385),(67.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.745),(65.975,17.915),(66.145,17.915),(66.145,17.745),(65.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.745),(66.335,17.915),(66.505,17.915),(66.505,17.745),(66.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.745),(66.695,17.915),(66.865,17.915),(66.865,17.745),(66.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.745),(67.055,17.915),(67.225,17.915),(67.225,17.745),(67.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.105),(65.975,18.275),(66.145,18.275),(66.145,18.105),(65.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.105),(66.335,18.275),(66.505,18.275),(66.505,18.105),(66.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.105),(66.695,18.275),(66.865,18.275),(66.865,18.105),(66.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.105),(67.055,18.275),(67.225,18.275),(67.225,18.105),(67.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.465),(65.975,18.635),(66.145,18.635),(66.145,18.465),(65.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.465),(66.335,18.635),(66.505,18.635),(66.505,18.465),(66.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.465),(66.695,18.635),(66.865,18.635),(66.865,18.465),(66.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.465),(67.055,18.635),(67.225,18.635),(67.225,18.465),(67.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.825),(65.975,18.995),(66.145,18.995),(66.145,18.825),(65.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.825),(66.335,18.995),(66.505,18.995),(66.505,18.825),(66.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.825),(66.695,18.995),(66.865,18.995),(66.865,18.825),(66.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.825),(67.055,18.995),(67.225,18.995),(67.225,18.825),(67.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.185),(65.975,19.355),(66.145,19.355),(66.145,19.185),(65.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.185),(66.335,19.355),(66.505,19.355),(66.505,19.185),(66.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.185),(66.695,19.355),(66.865,19.355),(66.865,19.185),(66.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.185),(67.055,19.355),(67.225,19.355),(67.225,19.185),(67.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,2.985),(75.575,3.155),(75.745,3.155),(75.745,2.985),(75.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,2.985),(75.935,3.155),(76.105,3.155),(76.105,2.985),(75.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,2.985),(76.295,3.155),(76.465,3.155),(76.465,2.985),(76.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,2.985),(76.655,3.155),(76.825,3.155),(76.825,2.985),(76.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.345),(75.575,3.515),(75.745,3.515),(75.745,3.345),(75.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.345),(75.935,3.515),(76.105,3.515),(76.105,3.345),(75.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.345),(76.295,3.515),(76.465,3.515),(76.465,3.345),(76.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.345),(76.655,3.515),(76.825,3.515),(76.825,3.345),(76.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.705),(75.575,3.875),(75.745,3.875),(75.745,3.705),(75.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.705),(75.935,3.875),(76.105,3.875),(76.105,3.705),(75.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.705),(76.295,3.875),(76.465,3.875),(76.465,3.705),(76.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.705),(76.655,3.875),(76.825,3.875),(76.825,3.705),(76.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.065),(75.575,4.235),(75.745,4.235),(75.745,4.065),(75.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.065),(75.935,4.235),(76.105,4.235),(76.105,4.065),(75.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.065),(76.295,4.235),(76.465,4.235),(76.465,4.065),(76.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.065),(76.655,4.235),(76.825,4.235),(76.825,4.065),(76.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.425),(75.575,4.595),(75.745,4.595),(75.745,4.425),(75.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.425),(75.935,4.595),(76.105,4.595),(76.105,4.425),(75.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.425),(76.295,4.595),(76.465,4.595),(76.465,4.425),(76.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.425),(76.655,4.595),(76.825,4.595),(76.825,4.425),(76.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.785),(75.575,4.955),(75.745,4.955),(75.745,4.785),(75.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.785),(75.935,4.955),(76.105,4.955),(76.105,4.785),(75.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.785),(76.295,4.955),(76.465,4.955),(76.465,4.785),(76.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.785),(76.655,4.955),(76.825,4.955),(76.825,4.785),(76.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.145),(75.575,5.315),(75.745,5.315),(75.745,5.145),(75.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.145),(75.935,5.315),(76.105,5.315),(76.105,5.145),(75.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.145),(76.295,5.315),(76.465,5.315),(76.465,5.145),(76.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.145),(76.655,5.315),(76.825,5.315),(76.825,5.145),(76.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.505),(75.575,5.675),(75.745,5.675),(75.745,5.505),(75.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.505),(75.935,5.675),(76.105,5.675),(76.105,5.505),(75.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.505),(76.295,5.675),(76.465,5.675),(76.465,5.505),(76.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.505),(76.655,5.675),(76.825,5.675),(76.825,5.505),(76.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.865),(75.575,6.035),(75.745,6.035),(75.745,5.865),(75.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.865),(75.935,6.035),(76.105,6.035),(76.105,5.865),(75.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.865),(76.295,6.035),(76.465,6.035),(76.465,5.865),(76.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.865),(76.655,6.035),(76.825,6.035),(76.825,5.865),(76.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.225),(75.575,6.395),(75.745,6.395),(75.745,6.225),(75.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.225),(75.935,6.395),(76.105,6.395),(76.105,6.225),(75.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.225),(76.295,6.395),(76.465,6.395),(76.465,6.225),(76.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.225),(76.655,6.395),(76.825,6.395),(76.825,6.225),(76.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.585),(75.575,6.755),(75.745,6.755),(75.745,6.585),(75.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.585),(75.935,6.755),(76.105,6.755),(76.105,6.585),(75.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.585),(76.295,6.755),(76.465,6.755),(76.465,6.585),(76.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.585),(76.655,6.755),(76.825,6.755),(76.825,6.585),(76.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.945),(75.575,7.115),(75.745,7.115),(75.745,6.945),(75.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.945),(75.935,7.115),(76.105,7.115),(76.105,6.945),(75.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.945),(76.295,7.115),(76.465,7.115),(76.465,6.945),(76.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.945),(76.655,7.115),(76.825,7.115),(76.825,6.945),(76.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.305),(75.575,7.475),(75.745,7.475),(75.745,7.305),(75.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.305),(75.935,7.475),(76.105,7.475),(76.105,7.305),(75.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.305),(76.295,7.475),(76.465,7.475),(76.465,7.305),(76.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.305),(76.655,7.475),(76.825,7.475),(76.825,7.305),(76.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.665),(75.575,7.835),(75.745,7.835),(75.745,7.665),(75.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.665),(75.935,7.835),(76.105,7.835),(76.105,7.665),(75.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.665),(76.295,7.835),(76.465,7.835),(76.465,7.665),(76.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.665),(76.655,7.835),(76.825,7.835),(76.825,7.665),(76.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.025),(75.575,8.195),(75.745,8.195),(75.745,8.025),(75.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.025),(75.935,8.195),(76.105,8.195),(76.105,8.025),(75.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.025),(76.295,8.195),(76.465,8.195),(76.465,8.025),(76.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.025),(76.655,8.195),(76.825,8.195),(76.825,8.025),(76.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.385),(75.575,8.555),(75.745,8.555),(75.745,8.385),(75.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.385),(75.935,8.555),(76.105,8.555),(76.105,8.385),(75.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.385),(76.295,8.555),(76.465,8.555),(76.465,8.385),(76.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.385),(76.655,8.555),(76.825,8.555),(76.825,8.385),(76.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.745),(75.575,8.915),(75.745,8.915),(75.745,8.745),(75.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.745),(75.935,8.915),(76.105,8.915),(76.105,8.745),(75.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.745),(76.295,8.915),(76.465,8.915),(76.465,8.745),(76.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.745),(76.655,8.915),(76.825,8.915),(76.825,8.745),(76.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.105),(75.575,9.275),(75.745,9.275),(75.745,9.105),(75.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.105),(75.935,9.275),(76.105,9.275),(76.105,9.105),(75.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.105),(76.295,9.275),(76.465,9.275),(76.465,9.105),(76.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.105),(76.655,9.275),(76.825,9.275),(76.825,9.105),(76.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.465),(75.575,9.635),(75.745,9.635),(75.745,9.465),(75.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.465),(75.935,9.635),(76.105,9.635),(76.105,9.465),(75.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.465),(76.295,9.635),(76.465,9.635),(76.465,9.465),(76.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.465),(76.655,9.635),(76.825,9.635),(76.825,9.465),(76.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.825),(75.575,9.995),(75.745,9.995),(75.745,9.825),(75.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.825),(75.935,9.995),(76.105,9.995),(76.105,9.825),(75.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.825),(76.295,9.995),(76.465,9.995),(76.465,9.825),(76.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.825),(76.655,9.995),(76.825,9.995),(76.825,9.825),(76.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.185),(75.575,10.355),(75.745,10.355),(75.745,10.185),(75.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.185),(75.935,10.355),(76.105,10.355),(76.105,10.185),(75.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.185),(76.295,10.355),(76.465,10.355),(76.465,10.185),(76.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.185),(76.655,10.355),(76.825,10.355),(76.825,10.185),(76.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.545),(75.575,10.715),(75.745,10.715),(75.745,10.545),(75.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.545),(75.935,10.715),(76.105,10.715),(76.105,10.545),(75.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.545),(76.295,10.715),(76.465,10.715),(76.465,10.545),(76.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.545),(76.655,10.715),(76.825,10.715),(76.825,10.545),(76.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.905),(75.575,11.075),(75.745,11.075),(75.745,10.905),(75.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.905),(75.935,11.075),(76.105,11.075),(76.105,10.905),(75.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.905),(76.295,11.075),(76.465,11.075),(76.465,10.905),(76.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.905),(76.655,11.075),(76.825,11.075),(76.825,10.905),(76.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.265),(75.575,11.435),(75.745,11.435),(75.745,11.265),(75.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.265),(75.935,11.435),(76.105,11.435),(76.105,11.265),(75.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.265),(76.295,11.435),(76.465,11.435),(76.465,11.265),(76.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.265),(76.655,11.435),(76.825,11.435),(76.825,11.265),(76.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.625),(75.575,11.795),(75.745,11.795),(75.745,11.625),(75.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.625),(75.935,11.795),(76.105,11.795),(76.105,11.625),(75.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.625),(76.295,11.795),(76.465,11.795),(76.465,11.625),(76.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.625),(76.655,11.795),(76.825,11.795),(76.825,11.625),(76.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.985),(75.575,12.155),(75.745,12.155),(75.745,11.985),(75.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.985),(75.935,12.155),(76.105,12.155),(76.105,11.985),(75.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.985),(76.295,12.155),(76.465,12.155),(76.465,11.985),(76.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.985),(76.655,12.155),(76.825,12.155),(76.825,11.985),(76.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.345),(75.575,12.515),(75.745,12.515),(75.745,12.345),(75.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.345),(75.935,12.515),(76.105,12.515),(76.105,12.345),(75.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.345),(76.295,12.515),(76.465,12.515),(76.465,12.345),(76.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.345),(76.655,12.515),(76.825,12.515),(76.825,12.345),(76.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.705),(75.575,12.875),(75.745,12.875),(75.745,12.705),(75.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.705),(75.935,12.875),(76.105,12.875),(76.105,12.705),(75.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.705),(76.295,12.875),(76.465,12.875),(76.465,12.705),(76.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.705),(76.655,12.875),(76.825,12.875),(76.825,12.705),(76.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.065),(75.575,13.235),(75.745,13.235),(75.745,13.065),(75.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.065),(75.935,13.235),(76.105,13.235),(76.105,13.065),(75.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.065),(76.295,13.235),(76.465,13.235),(76.465,13.065),(76.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.065),(76.655,13.235),(76.825,13.235),(76.825,13.065),(76.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.425),(75.575,13.595),(75.745,13.595),(75.745,13.425),(75.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.425),(75.935,13.595),(76.105,13.595),(76.105,13.425),(75.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.425),(76.295,13.595),(76.465,13.595),(76.465,13.425),(76.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.425),(76.655,13.595),(76.825,13.595),(76.825,13.425),(76.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.785),(75.575,13.955),(75.745,13.955),(75.745,13.785),(75.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.785),(75.935,13.955),(76.105,13.955),(76.105,13.785),(75.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.785),(76.295,13.955),(76.465,13.955),(76.465,13.785),(76.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.785),(76.655,13.955),(76.825,13.955),(76.825,13.785),(76.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.145),(75.575,14.315),(75.745,14.315),(75.745,14.145),(75.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.145),(75.935,14.315),(76.105,14.315),(76.105,14.145),(75.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.145),(76.295,14.315),(76.465,14.315),(76.465,14.145),(76.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.145),(76.655,14.315),(76.825,14.315),(76.825,14.145),(76.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.505),(75.575,14.675),(75.745,14.675),(75.745,14.505),(75.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.505),(75.935,14.675),(76.105,14.675),(76.105,14.505),(75.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.505),(76.295,14.675),(76.465,14.675),(76.465,14.505),(76.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.505),(76.655,14.675),(76.825,14.675),(76.825,14.505),(76.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.865),(75.575,15.035),(75.745,15.035),(75.745,14.865),(75.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.865),(75.935,15.035),(76.105,15.035),(76.105,14.865),(75.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.865),(76.295,15.035),(76.465,15.035),(76.465,14.865),(76.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.865),(76.655,15.035),(76.825,15.035),(76.825,14.865),(76.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.225),(75.575,15.395),(75.745,15.395),(75.745,15.225),(75.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.225),(75.935,15.395),(76.105,15.395),(76.105,15.225),(75.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.225),(76.295,15.395),(76.465,15.395),(76.465,15.225),(76.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.225),(76.655,15.395),(76.825,15.395),(76.825,15.225),(76.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.585),(75.575,15.755),(75.745,15.755),(75.745,15.585),(75.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.585),(75.935,15.755),(76.105,15.755),(76.105,15.585),(75.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.585),(76.295,15.755),(76.465,15.755),(76.465,15.585),(76.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.585),(76.655,15.755),(76.825,15.755),(76.825,15.585),(76.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.945),(75.575,16.115),(75.745,16.115),(75.745,15.945),(75.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.945),(75.935,16.115),(76.105,16.115),(76.105,15.945),(75.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.945),(76.295,16.115),(76.465,16.115),(76.465,15.945),(76.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.945),(76.655,16.115),(76.825,16.115),(76.825,15.945),(76.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.305),(75.575,16.475),(75.745,16.475),(75.745,16.305),(75.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.305),(75.935,16.475),(76.105,16.475),(76.105,16.305),(75.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.305),(76.295,16.475),(76.465,16.475),(76.465,16.305),(76.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.305),(76.655,16.475),(76.825,16.475),(76.825,16.305),(76.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.665),(75.575,16.835),(75.745,16.835),(75.745,16.665),(75.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.665),(75.935,16.835),(76.105,16.835),(76.105,16.665),(75.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.665),(76.295,16.835),(76.465,16.835),(76.465,16.665),(76.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.665),(76.655,16.835),(76.825,16.835),(76.825,16.665),(76.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.025),(75.575,17.195),(75.745,17.195),(75.745,17.025),(75.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.025),(75.935,17.195),(76.105,17.195),(76.105,17.025),(75.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.025),(76.295,17.195),(76.465,17.195),(76.465,17.025),(76.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.025),(76.655,17.195),(76.825,17.195),(76.825,17.025),(76.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.385),(75.575,17.555),(75.745,17.555),(75.745,17.385),(75.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.385),(75.935,17.555),(76.105,17.555),(76.105,17.385),(75.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.385),(76.295,17.555),(76.465,17.555),(76.465,17.385),(76.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.385),(76.655,17.555),(76.825,17.555),(76.825,17.385),(76.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.745),(75.575,17.915),(75.745,17.915),(75.745,17.745),(75.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.745),(75.935,17.915),(76.105,17.915),(76.105,17.745),(75.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.745),(76.295,17.915),(76.465,17.915),(76.465,17.745),(76.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.745),(76.655,17.915),(76.825,17.915),(76.825,17.745),(76.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.105),(75.575,18.275),(75.745,18.275),(75.745,18.105),(75.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.105),(75.935,18.275),(76.105,18.275),(76.105,18.105),(75.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.105),(76.295,18.275),(76.465,18.275),(76.465,18.105),(76.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.105),(76.655,18.275),(76.825,18.275),(76.825,18.105),(76.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.465),(75.575,18.635),(75.745,18.635),(75.745,18.465),(75.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.465),(75.935,18.635),(76.105,18.635),(76.105,18.465),(75.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.465),(76.295,18.635),(76.465,18.635),(76.465,18.465),(76.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.465),(76.655,18.635),(76.825,18.635),(76.825,18.465),(76.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.825),(75.575,18.995),(75.745,18.995),(75.745,18.825),(75.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.825),(75.935,18.995),(76.105,18.995),(76.105,18.825),(75.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.825),(76.295,18.995),(76.465,18.995),(76.465,18.825),(76.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.825),(76.655,18.995),(76.825,18.995),(76.825,18.825),(76.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.185),(75.575,19.355),(75.745,19.355),(75.745,19.185),(75.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.185),(75.935,19.355),(76.105,19.355),(76.105,19.185),(75.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.185),(76.295,19.355),(76.465,19.355),(76.465,19.185),(76.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.185),(76.655,19.355),(76.825,19.355),(76.825,19.185),(76.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,2.985),(17.975,3.155),(18.145,3.155),(18.145,2.985),(17.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,2.985),(18.335,3.155),(18.505,3.155),(18.505,2.985),(18.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,2.985),(18.695,3.155),(18.865,3.155),(18.865,2.985),(18.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,2.985),(19.055,3.155),(19.225,3.155),(19.225,2.985),(19.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.345),(17.975,3.515),(18.145,3.515),(18.145,3.345),(17.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.345),(18.335,3.515),(18.505,3.515),(18.505,3.345),(18.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.345),(18.695,3.515),(18.865,3.515),(18.865,3.345),(18.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.345),(19.055,3.515),(19.225,3.515),(19.225,3.345),(19.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.705),(17.975,3.875),(18.145,3.875),(18.145,3.705),(17.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.705),(18.335,3.875),(18.505,3.875),(18.505,3.705),(18.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.705),(18.695,3.875),(18.865,3.875),(18.865,3.705),(18.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.705),(19.055,3.875),(19.225,3.875),(19.225,3.705),(19.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.065),(17.975,4.235),(18.145,4.235),(18.145,4.065),(17.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.065),(18.335,4.235),(18.505,4.235),(18.505,4.065),(18.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.065),(18.695,4.235),(18.865,4.235),(18.865,4.065),(18.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.065),(19.055,4.235),(19.225,4.235),(19.225,4.065),(19.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.425),(17.975,4.595),(18.145,4.595),(18.145,4.425),(17.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.425),(18.335,4.595),(18.505,4.595),(18.505,4.425),(18.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.425),(18.695,4.595),(18.865,4.595),(18.865,4.425),(18.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.425),(19.055,4.595),(19.225,4.595),(19.225,4.425),(19.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.785),(17.975,4.955),(18.145,4.955),(18.145,4.785),(17.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.785),(18.335,4.955),(18.505,4.955),(18.505,4.785),(18.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.785),(18.695,4.955),(18.865,4.955),(18.865,4.785),(18.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.785),(19.055,4.955),(19.225,4.955),(19.225,4.785),(19.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.145),(17.975,5.315),(18.145,5.315),(18.145,5.145),(17.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.145),(18.335,5.315),(18.505,5.315),(18.505,5.145),(18.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.145),(18.695,5.315),(18.865,5.315),(18.865,5.145),(18.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.145),(19.055,5.315),(19.225,5.315),(19.225,5.145),(19.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.505),(17.975,5.675),(18.145,5.675),(18.145,5.505),(17.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.505),(18.335,5.675),(18.505,5.675),(18.505,5.505),(18.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.505),(18.695,5.675),(18.865,5.675),(18.865,5.505),(18.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.505),(19.055,5.675),(19.225,5.675),(19.225,5.505),(19.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.865),(17.975,6.035),(18.145,6.035),(18.145,5.865),(17.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.865),(18.335,6.035),(18.505,6.035),(18.505,5.865),(18.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.865),(18.695,6.035),(18.865,6.035),(18.865,5.865),(18.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.865),(19.055,6.035),(19.225,6.035),(19.225,5.865),(19.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.225),(17.975,6.395),(18.145,6.395),(18.145,6.225),(17.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.225),(18.335,6.395),(18.505,6.395),(18.505,6.225),(18.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.225),(18.695,6.395),(18.865,6.395),(18.865,6.225),(18.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.225),(19.055,6.395),(19.225,6.395),(19.225,6.225),(19.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.585),(17.975,6.755),(18.145,6.755),(18.145,6.585),(17.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.585),(18.335,6.755),(18.505,6.755),(18.505,6.585),(18.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.585),(18.695,6.755),(18.865,6.755),(18.865,6.585),(18.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.585),(19.055,6.755),(19.225,6.755),(19.225,6.585),(19.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.945),(17.975,7.115),(18.145,7.115),(18.145,6.945),(17.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.945),(18.335,7.115),(18.505,7.115),(18.505,6.945),(18.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.945),(18.695,7.115),(18.865,7.115),(18.865,6.945),(18.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.945),(19.055,7.115),(19.225,7.115),(19.225,6.945),(19.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.305),(17.975,7.475),(18.145,7.475),(18.145,7.305),(17.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.305),(18.335,7.475),(18.505,7.475),(18.505,7.305),(18.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.305),(18.695,7.475),(18.865,7.475),(18.865,7.305),(18.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.305),(19.055,7.475),(19.225,7.475),(19.225,7.305),(19.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.665),(17.975,7.835),(18.145,7.835),(18.145,7.665),(17.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.665),(18.335,7.835),(18.505,7.835),(18.505,7.665),(18.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.665),(18.695,7.835),(18.865,7.835),(18.865,7.665),(18.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.665),(19.055,7.835),(19.225,7.835),(19.225,7.665),(19.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.025),(17.975,8.195),(18.145,8.195),(18.145,8.025),(17.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.025),(18.335,8.195),(18.505,8.195),(18.505,8.025),(18.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.025),(18.695,8.195),(18.865,8.195),(18.865,8.025),(18.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.025),(19.055,8.195),(19.225,8.195),(19.225,8.025),(19.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.385),(17.975,8.555),(18.145,8.555),(18.145,8.385),(17.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.385),(18.335,8.555),(18.505,8.555),(18.505,8.385),(18.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.385),(18.695,8.555),(18.865,8.555),(18.865,8.385),(18.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.385),(19.055,8.555),(19.225,8.555),(19.225,8.385),(19.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.745),(17.975,8.915),(18.145,8.915),(18.145,8.745),(17.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.745),(18.335,8.915),(18.505,8.915),(18.505,8.745),(18.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.745),(18.695,8.915),(18.865,8.915),(18.865,8.745),(18.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.745),(19.055,8.915),(19.225,8.915),(19.225,8.745),(19.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.105),(17.975,9.275),(18.145,9.275),(18.145,9.105),(17.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.105),(18.335,9.275),(18.505,9.275),(18.505,9.105),(18.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.105),(18.695,9.275),(18.865,9.275),(18.865,9.105),(18.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.105),(19.055,9.275),(19.225,9.275),(19.225,9.105),(19.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.465),(17.975,9.635),(18.145,9.635),(18.145,9.465),(17.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.465),(18.335,9.635),(18.505,9.635),(18.505,9.465),(18.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.465),(18.695,9.635),(18.865,9.635),(18.865,9.465),(18.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.465),(19.055,9.635),(19.225,9.635),(19.225,9.465),(19.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.825),(17.975,9.995),(18.145,9.995),(18.145,9.825),(17.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.825),(18.335,9.995),(18.505,9.995),(18.505,9.825),(18.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.825),(18.695,9.995),(18.865,9.995),(18.865,9.825),(18.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.825),(19.055,9.995),(19.225,9.995),(19.225,9.825),(19.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.185),(17.975,10.355),(18.145,10.355),(18.145,10.185),(17.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.185),(18.335,10.355),(18.505,10.355),(18.505,10.185),(18.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.185),(18.695,10.355),(18.865,10.355),(18.865,10.185),(18.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.185),(19.055,10.355),(19.225,10.355),(19.225,10.185),(19.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.545),(17.975,10.715),(18.145,10.715),(18.145,10.545),(17.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.545),(18.335,10.715),(18.505,10.715),(18.505,10.545),(18.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.545),(18.695,10.715),(18.865,10.715),(18.865,10.545),(18.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.545),(19.055,10.715),(19.225,10.715),(19.225,10.545),(19.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.905),(17.975,11.075),(18.145,11.075),(18.145,10.905),(17.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.905),(18.335,11.075),(18.505,11.075),(18.505,10.905),(18.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.905),(18.695,11.075),(18.865,11.075),(18.865,10.905),(18.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.905),(19.055,11.075),(19.225,11.075),(19.225,10.905),(19.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.265),(17.975,11.435),(18.145,11.435),(18.145,11.265),(17.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.265),(18.335,11.435),(18.505,11.435),(18.505,11.265),(18.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.265),(18.695,11.435),(18.865,11.435),(18.865,11.265),(18.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.265),(19.055,11.435),(19.225,11.435),(19.225,11.265),(19.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.625),(17.975,11.795),(18.145,11.795),(18.145,11.625),(17.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.625),(18.335,11.795),(18.505,11.795),(18.505,11.625),(18.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.625),(18.695,11.795),(18.865,11.795),(18.865,11.625),(18.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.625),(19.055,11.795),(19.225,11.795),(19.225,11.625),(19.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.985),(17.975,12.155),(18.145,12.155),(18.145,11.985),(17.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.985),(18.335,12.155),(18.505,12.155),(18.505,11.985),(18.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.985),(18.695,12.155),(18.865,12.155),(18.865,11.985),(18.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.985),(19.055,12.155),(19.225,12.155),(19.225,11.985),(19.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.345),(17.975,12.515),(18.145,12.515),(18.145,12.345),(17.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.345),(18.335,12.515),(18.505,12.515),(18.505,12.345),(18.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.345),(18.695,12.515),(18.865,12.515),(18.865,12.345),(18.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.345),(19.055,12.515),(19.225,12.515),(19.225,12.345),(19.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.705),(17.975,12.875),(18.145,12.875),(18.145,12.705),(17.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.705),(18.335,12.875),(18.505,12.875),(18.505,12.705),(18.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.705),(18.695,12.875),(18.865,12.875),(18.865,12.705),(18.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.705),(19.055,12.875),(19.225,12.875),(19.225,12.705),(19.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.065),(17.975,13.235),(18.145,13.235),(18.145,13.065),(17.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.065),(18.335,13.235),(18.505,13.235),(18.505,13.065),(18.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.065),(18.695,13.235),(18.865,13.235),(18.865,13.065),(18.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.065),(19.055,13.235),(19.225,13.235),(19.225,13.065),(19.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.425),(17.975,13.595),(18.145,13.595),(18.145,13.425),(17.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.425),(18.335,13.595),(18.505,13.595),(18.505,13.425),(18.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.425),(18.695,13.595),(18.865,13.595),(18.865,13.425),(18.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.425),(19.055,13.595),(19.225,13.595),(19.225,13.425),(19.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.785),(17.975,13.955),(18.145,13.955),(18.145,13.785),(17.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.785),(18.335,13.955),(18.505,13.955),(18.505,13.785),(18.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.785),(18.695,13.955),(18.865,13.955),(18.865,13.785),(18.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.785),(19.055,13.955),(19.225,13.955),(19.225,13.785),(19.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.145),(17.975,14.315),(18.145,14.315),(18.145,14.145),(17.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.145),(18.335,14.315),(18.505,14.315),(18.505,14.145),(18.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.145),(18.695,14.315),(18.865,14.315),(18.865,14.145),(18.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.145),(19.055,14.315),(19.225,14.315),(19.225,14.145),(19.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.505),(17.975,14.675),(18.145,14.675),(18.145,14.505),(17.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.505),(18.335,14.675),(18.505,14.675),(18.505,14.505),(18.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.505),(18.695,14.675),(18.865,14.675),(18.865,14.505),(18.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.505),(19.055,14.675),(19.225,14.675),(19.225,14.505),(19.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.865),(17.975,15.035),(18.145,15.035),(18.145,14.865),(17.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.865),(18.335,15.035),(18.505,15.035),(18.505,14.865),(18.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.865),(18.695,15.035),(18.865,15.035),(18.865,14.865),(18.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.865),(19.055,15.035),(19.225,15.035),(19.225,14.865),(19.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.225),(17.975,15.395),(18.145,15.395),(18.145,15.225),(17.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.225),(18.335,15.395),(18.505,15.395),(18.505,15.225),(18.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.225),(18.695,15.395),(18.865,15.395),(18.865,15.225),(18.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.225),(19.055,15.395),(19.225,15.395),(19.225,15.225),(19.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.585),(17.975,15.755),(18.145,15.755),(18.145,15.585),(17.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.585),(18.335,15.755),(18.505,15.755),(18.505,15.585),(18.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.585),(18.695,15.755),(18.865,15.755),(18.865,15.585),(18.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.585),(19.055,15.755),(19.225,15.755),(19.225,15.585),(19.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.945),(17.975,16.115),(18.145,16.115),(18.145,15.945),(17.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.945),(18.335,16.115),(18.505,16.115),(18.505,15.945),(18.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.945),(18.695,16.115),(18.865,16.115),(18.865,15.945),(18.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.945),(19.055,16.115),(19.225,16.115),(19.225,15.945),(19.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.305),(17.975,16.475),(18.145,16.475),(18.145,16.305),(17.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.305),(18.335,16.475),(18.505,16.475),(18.505,16.305),(18.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.305),(18.695,16.475),(18.865,16.475),(18.865,16.305),(18.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.305),(19.055,16.475),(19.225,16.475),(19.225,16.305),(19.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.665),(17.975,16.835),(18.145,16.835),(18.145,16.665),(17.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.665),(18.335,16.835),(18.505,16.835),(18.505,16.665),(18.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.665),(18.695,16.835),(18.865,16.835),(18.865,16.665),(18.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.665),(19.055,16.835),(19.225,16.835),(19.225,16.665),(19.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.025),(17.975,17.195),(18.145,17.195),(18.145,17.025),(17.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.025),(18.335,17.195),(18.505,17.195),(18.505,17.025),(18.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.025),(18.695,17.195),(18.865,17.195),(18.865,17.025),(18.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.025),(19.055,17.195),(19.225,17.195),(19.225,17.025),(19.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.385),(17.975,17.555),(18.145,17.555),(18.145,17.385),(17.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.385),(18.335,17.555),(18.505,17.555),(18.505,17.385),(18.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.385),(18.695,17.555),(18.865,17.555),(18.865,17.385),(18.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.385),(19.055,17.555),(19.225,17.555),(19.225,17.385),(19.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.745),(17.975,17.915),(18.145,17.915),(18.145,17.745),(17.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.745),(18.335,17.915),(18.505,17.915),(18.505,17.745),(18.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.745),(18.695,17.915),(18.865,17.915),(18.865,17.745),(18.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.745),(19.055,17.915),(19.225,17.915),(19.225,17.745),(19.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.105),(17.975,18.275),(18.145,18.275),(18.145,18.105),(17.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.105),(18.335,18.275),(18.505,18.275),(18.505,18.105),(18.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.105),(18.695,18.275),(18.865,18.275),(18.865,18.105),(18.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.105),(19.055,18.275),(19.225,18.275),(19.225,18.105),(19.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.465),(17.975,18.635),(18.145,18.635),(18.145,18.465),(17.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.465),(18.335,18.635),(18.505,18.635),(18.505,18.465),(18.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.465),(18.695,18.635),(18.865,18.635),(18.865,18.465),(18.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.465),(19.055,18.635),(19.225,18.635),(19.225,18.465),(19.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.825),(17.975,18.995),(18.145,18.995),(18.145,18.825),(17.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.825),(18.335,18.995),(18.505,18.995),(18.505,18.825),(18.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.825),(18.695,18.995),(18.865,18.995),(18.865,18.825),(18.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.825),(19.055,18.995),(19.225,18.995),(19.225,18.825),(19.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.185),(17.975,19.355),(18.145,19.355),(18.145,19.185),(17.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.185),(18.335,19.355),(18.505,19.355),(18.505,19.185),(18.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.185),(18.695,19.355),(18.865,19.355),(18.865,19.185),(18.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.185),(19.055,19.355),(19.225,19.355),(19.225,19.185),(19.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,2.985),(13.175,3.155),(13.345,3.155),(13.345,2.985),(13.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,2.985),(13.535,3.155),(13.705,3.155),(13.705,2.985),(13.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,2.985),(13.895,3.155),(14.065,3.155),(14.065,2.985),(13.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,2.985),(14.255,3.155),(14.425,3.155),(14.425,2.985),(14.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.345),(13.175,3.515),(13.345,3.515),(13.345,3.345),(13.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.345),(13.535,3.515),(13.705,3.515),(13.705,3.345),(13.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.345),(13.895,3.515),(14.065,3.515),(14.065,3.345),(13.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.345),(14.255,3.515),(14.425,3.515),(14.425,3.345),(14.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.705),(13.175,3.875),(13.345,3.875),(13.345,3.705),(13.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.705),(13.535,3.875),(13.705,3.875),(13.705,3.705),(13.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.705),(13.895,3.875),(14.065,3.875),(14.065,3.705),(13.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.705),(14.255,3.875),(14.425,3.875),(14.425,3.705),(14.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.065),(13.175,4.235),(13.345,4.235),(13.345,4.065),(13.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.065),(13.535,4.235),(13.705,4.235),(13.705,4.065),(13.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.065),(13.895,4.235),(14.065,4.235),(14.065,4.065),(13.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.065),(14.255,4.235),(14.425,4.235),(14.425,4.065),(14.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.425),(13.175,4.595),(13.345,4.595),(13.345,4.425),(13.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.425),(13.535,4.595),(13.705,4.595),(13.705,4.425),(13.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.425),(13.895,4.595),(14.065,4.595),(14.065,4.425),(13.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.425),(14.255,4.595),(14.425,4.595),(14.425,4.425),(14.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.785),(13.175,4.955),(13.345,4.955),(13.345,4.785),(13.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.785),(13.535,4.955),(13.705,4.955),(13.705,4.785),(13.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.785),(13.895,4.955),(14.065,4.955),(14.065,4.785),(13.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.785),(14.255,4.955),(14.425,4.955),(14.425,4.785),(14.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.145),(13.175,5.315),(13.345,5.315),(13.345,5.145),(13.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.145),(13.535,5.315),(13.705,5.315),(13.705,5.145),(13.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.145),(13.895,5.315),(14.065,5.315),(14.065,5.145),(13.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.145),(14.255,5.315),(14.425,5.315),(14.425,5.145),(14.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.505),(13.175,5.675),(13.345,5.675),(13.345,5.505),(13.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.505),(13.535,5.675),(13.705,5.675),(13.705,5.505),(13.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.505),(13.895,5.675),(14.065,5.675),(14.065,5.505),(13.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.505),(14.255,5.675),(14.425,5.675),(14.425,5.505),(14.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.865),(13.175,6.035),(13.345,6.035),(13.345,5.865),(13.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.865),(13.535,6.035),(13.705,6.035),(13.705,5.865),(13.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.865),(13.895,6.035),(14.065,6.035),(14.065,5.865),(13.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.865),(14.255,6.035),(14.425,6.035),(14.425,5.865),(14.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.225),(13.175,6.395),(13.345,6.395),(13.345,6.225),(13.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.225),(13.535,6.395),(13.705,6.395),(13.705,6.225),(13.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.225),(13.895,6.395),(14.065,6.395),(14.065,6.225),(13.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.225),(14.255,6.395),(14.425,6.395),(14.425,6.225),(14.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.585),(13.175,6.755),(13.345,6.755),(13.345,6.585),(13.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.585),(13.535,6.755),(13.705,6.755),(13.705,6.585),(13.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.585),(13.895,6.755),(14.065,6.755),(14.065,6.585),(13.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.585),(14.255,6.755),(14.425,6.755),(14.425,6.585),(14.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.945),(13.175,7.115),(13.345,7.115),(13.345,6.945),(13.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.945),(13.535,7.115),(13.705,7.115),(13.705,6.945),(13.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.945),(13.895,7.115),(14.065,7.115),(14.065,6.945),(13.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.945),(14.255,7.115),(14.425,7.115),(14.425,6.945),(14.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.305),(13.175,7.475),(13.345,7.475),(13.345,7.305),(13.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.305),(13.535,7.475),(13.705,7.475),(13.705,7.305),(13.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.305),(13.895,7.475),(14.065,7.475),(14.065,7.305),(13.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.305),(14.255,7.475),(14.425,7.475),(14.425,7.305),(14.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.665),(13.175,7.835),(13.345,7.835),(13.345,7.665),(13.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.665),(13.535,7.835),(13.705,7.835),(13.705,7.665),(13.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.665),(13.895,7.835),(14.065,7.835),(14.065,7.665),(13.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.665),(14.255,7.835),(14.425,7.835),(14.425,7.665),(14.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.025),(13.175,8.195),(13.345,8.195),(13.345,8.025),(13.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.025),(13.535,8.195),(13.705,8.195),(13.705,8.025),(13.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.025),(13.895,8.195),(14.065,8.195),(14.065,8.025),(13.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.025),(14.255,8.195),(14.425,8.195),(14.425,8.025),(14.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.385),(13.175,8.555),(13.345,8.555),(13.345,8.385),(13.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.385),(13.535,8.555),(13.705,8.555),(13.705,8.385),(13.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.385),(13.895,8.555),(14.065,8.555),(14.065,8.385),(13.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.385),(14.255,8.555),(14.425,8.555),(14.425,8.385),(14.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.745),(13.175,8.915),(13.345,8.915),(13.345,8.745),(13.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.745),(13.535,8.915),(13.705,8.915),(13.705,8.745),(13.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.745),(13.895,8.915),(14.065,8.915),(14.065,8.745),(13.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.745),(14.255,8.915),(14.425,8.915),(14.425,8.745),(14.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.105),(13.175,9.275),(13.345,9.275),(13.345,9.105),(13.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.105),(13.535,9.275),(13.705,9.275),(13.705,9.105),(13.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.105),(13.895,9.275),(14.065,9.275),(14.065,9.105),(13.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.105),(14.255,9.275),(14.425,9.275),(14.425,9.105),(14.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.465),(13.175,9.635),(13.345,9.635),(13.345,9.465),(13.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.465),(13.535,9.635),(13.705,9.635),(13.705,9.465),(13.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.465),(13.895,9.635),(14.065,9.635),(14.065,9.465),(13.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.465),(14.255,9.635),(14.425,9.635),(14.425,9.465),(14.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.825),(13.175,9.995),(13.345,9.995),(13.345,9.825),(13.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.825),(13.535,9.995),(13.705,9.995),(13.705,9.825),(13.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.825),(13.895,9.995),(14.065,9.995),(14.065,9.825),(13.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.825),(14.255,9.995),(14.425,9.995),(14.425,9.825),(14.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.185),(13.175,10.355),(13.345,10.355),(13.345,10.185),(13.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.185),(13.535,10.355),(13.705,10.355),(13.705,10.185),(13.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.185),(13.895,10.355),(14.065,10.355),(14.065,10.185),(13.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.185),(14.255,10.355),(14.425,10.355),(14.425,10.185),(14.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.545),(13.175,10.715),(13.345,10.715),(13.345,10.545),(13.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.545),(13.535,10.715),(13.705,10.715),(13.705,10.545),(13.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.545),(13.895,10.715),(14.065,10.715),(14.065,10.545),(13.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.545),(14.255,10.715),(14.425,10.715),(14.425,10.545),(14.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.905),(13.175,11.075),(13.345,11.075),(13.345,10.905),(13.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.905),(13.535,11.075),(13.705,11.075),(13.705,10.905),(13.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.905),(13.895,11.075),(14.065,11.075),(14.065,10.905),(13.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.905),(14.255,11.075),(14.425,11.075),(14.425,10.905),(14.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.265),(13.175,11.435),(13.345,11.435),(13.345,11.265),(13.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.265),(13.535,11.435),(13.705,11.435),(13.705,11.265),(13.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.265),(13.895,11.435),(14.065,11.435),(14.065,11.265),(13.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.265),(14.255,11.435),(14.425,11.435),(14.425,11.265),(14.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.625),(13.175,11.795),(13.345,11.795),(13.345,11.625),(13.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.625),(13.535,11.795),(13.705,11.795),(13.705,11.625),(13.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.625),(13.895,11.795),(14.065,11.795),(14.065,11.625),(13.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.625),(14.255,11.795),(14.425,11.795),(14.425,11.625),(14.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.985),(13.175,12.155),(13.345,12.155),(13.345,11.985),(13.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.985),(13.535,12.155),(13.705,12.155),(13.705,11.985),(13.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.985),(13.895,12.155),(14.065,12.155),(14.065,11.985),(13.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.985),(14.255,12.155),(14.425,12.155),(14.425,11.985),(14.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.345),(13.175,12.515),(13.345,12.515),(13.345,12.345),(13.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.345),(13.535,12.515),(13.705,12.515),(13.705,12.345),(13.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.345),(13.895,12.515),(14.065,12.515),(14.065,12.345),(13.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.345),(14.255,12.515),(14.425,12.515),(14.425,12.345),(14.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.705),(13.175,12.875),(13.345,12.875),(13.345,12.705),(13.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.705),(13.535,12.875),(13.705,12.875),(13.705,12.705),(13.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.705),(13.895,12.875),(14.065,12.875),(14.065,12.705),(13.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.705),(14.255,12.875),(14.425,12.875),(14.425,12.705),(14.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.065),(13.175,13.235),(13.345,13.235),(13.345,13.065),(13.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.065),(13.535,13.235),(13.705,13.235),(13.705,13.065),(13.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.065),(13.895,13.235),(14.065,13.235),(14.065,13.065),(13.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.065),(14.255,13.235),(14.425,13.235),(14.425,13.065),(14.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.425),(13.175,13.595),(13.345,13.595),(13.345,13.425),(13.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.425),(13.535,13.595),(13.705,13.595),(13.705,13.425),(13.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.425),(13.895,13.595),(14.065,13.595),(14.065,13.425),(13.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.425),(14.255,13.595),(14.425,13.595),(14.425,13.425),(14.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.785),(13.175,13.955),(13.345,13.955),(13.345,13.785),(13.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.785),(13.535,13.955),(13.705,13.955),(13.705,13.785),(13.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.785),(13.895,13.955),(14.065,13.955),(14.065,13.785),(13.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.785),(14.255,13.955),(14.425,13.955),(14.425,13.785),(14.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.145),(13.175,14.315),(13.345,14.315),(13.345,14.145),(13.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.145),(13.535,14.315),(13.705,14.315),(13.705,14.145),(13.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.145),(13.895,14.315),(14.065,14.315),(14.065,14.145),(13.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.145),(14.255,14.315),(14.425,14.315),(14.425,14.145),(14.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.505),(13.175,14.675),(13.345,14.675),(13.345,14.505),(13.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.505),(13.535,14.675),(13.705,14.675),(13.705,14.505),(13.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.505),(13.895,14.675),(14.065,14.675),(14.065,14.505),(13.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.505),(14.255,14.675),(14.425,14.675),(14.425,14.505),(14.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.865),(13.175,15.035),(13.345,15.035),(13.345,14.865),(13.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.865),(13.535,15.035),(13.705,15.035),(13.705,14.865),(13.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.865),(13.895,15.035),(14.065,15.035),(14.065,14.865),(13.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.865),(14.255,15.035),(14.425,15.035),(14.425,14.865),(14.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.225),(13.175,15.395),(13.345,15.395),(13.345,15.225),(13.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.225),(13.535,15.395),(13.705,15.395),(13.705,15.225),(13.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.225),(13.895,15.395),(14.065,15.395),(14.065,15.225),(13.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.225),(14.255,15.395),(14.425,15.395),(14.425,15.225),(14.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.585),(13.175,15.755),(13.345,15.755),(13.345,15.585),(13.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.585),(13.535,15.755),(13.705,15.755),(13.705,15.585),(13.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.585),(13.895,15.755),(14.065,15.755),(14.065,15.585),(13.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.585),(14.255,15.755),(14.425,15.755),(14.425,15.585),(14.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.945),(13.175,16.115),(13.345,16.115),(13.345,15.945),(13.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.945),(13.535,16.115),(13.705,16.115),(13.705,15.945),(13.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.945),(13.895,16.115),(14.065,16.115),(14.065,15.945),(13.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.945),(14.255,16.115),(14.425,16.115),(14.425,15.945),(14.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.305),(13.175,16.475),(13.345,16.475),(13.345,16.305),(13.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.305),(13.535,16.475),(13.705,16.475),(13.705,16.305),(13.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.305),(13.895,16.475),(14.065,16.475),(14.065,16.305),(13.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.305),(14.255,16.475),(14.425,16.475),(14.425,16.305),(14.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.665),(13.175,16.835),(13.345,16.835),(13.345,16.665),(13.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.665),(13.535,16.835),(13.705,16.835),(13.705,16.665),(13.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.665),(13.895,16.835),(14.065,16.835),(14.065,16.665),(13.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.665),(14.255,16.835),(14.425,16.835),(14.425,16.665),(14.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.025),(13.175,17.195),(13.345,17.195),(13.345,17.025),(13.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.025),(13.535,17.195),(13.705,17.195),(13.705,17.025),(13.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.025),(13.895,17.195),(14.065,17.195),(14.065,17.025),(13.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.025),(14.255,17.195),(14.425,17.195),(14.425,17.025),(14.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.385),(13.175,17.555),(13.345,17.555),(13.345,17.385),(13.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.385),(13.535,17.555),(13.705,17.555),(13.705,17.385),(13.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.385),(13.895,17.555),(14.065,17.555),(14.065,17.385),(13.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.385),(14.255,17.555),(14.425,17.555),(14.425,17.385),(14.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.745),(13.175,17.915),(13.345,17.915),(13.345,17.745),(13.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.745),(13.535,17.915),(13.705,17.915),(13.705,17.745),(13.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.745),(13.895,17.915),(14.065,17.915),(14.065,17.745),(13.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.745),(14.255,17.915),(14.425,17.915),(14.425,17.745),(14.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.105),(13.175,18.275),(13.345,18.275),(13.345,18.105),(13.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.105),(13.535,18.275),(13.705,18.275),(13.705,18.105),(13.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.105),(13.895,18.275),(14.065,18.275),(14.065,18.105),(13.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.105),(14.255,18.275),(14.425,18.275),(14.425,18.105),(14.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.465),(13.175,18.635),(13.345,18.635),(13.345,18.465),(13.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.465),(13.535,18.635),(13.705,18.635),(13.705,18.465),(13.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.465),(13.895,18.635),(14.065,18.635),(14.065,18.465),(13.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.465),(14.255,18.635),(14.425,18.635),(14.425,18.465),(14.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.825),(13.175,18.995),(13.345,18.995),(13.345,18.825),(13.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.825),(13.535,18.995),(13.705,18.995),(13.705,18.825),(13.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.825),(13.895,18.995),(14.065,18.995),(14.065,18.825),(13.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.825),(14.255,18.995),(14.425,18.995),(14.425,18.825),(14.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.185),(13.175,19.355),(13.345,19.355),(13.345,19.185),(13.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.185),(13.535,19.355),(13.705,19.355),(13.705,19.185),(13.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.185),(13.895,19.355),(14.065,19.355),(14.065,19.185),(13.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.185),(14.255,19.355),(14.425,19.355),(14.425,19.185),(14.255,19.185)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,19.415),(24.055,19.415),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,22.34),(62.455,22.34),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,22.34),(24.055,22.34),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,22.34),(28.855,22.34),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,19.415),(62.455,19.415),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,19.415),(48.055,19.415),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,19.415),(67.255,19.415),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,22.34),(48.055,22.34),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,22.34),(52.855,22.34),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,22.34),(67.255,22.34),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,19.415),(76.855,19.415),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,22.34),(57.655,22.34),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,19.415),(57.655,19.415),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,22.34),(38.455,22.34),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,19.415),(38.455,19.415),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,19.415),(43.255,19.415),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,19.415),(28.855,19.415),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,22.34),(43.255,22.34),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,22.34),(9.655,22.34),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,19.415),(9.655,19.415),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,19.415),(72.055,19.415),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,19.415),(19.255,19.415),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,22.34),(14.455,22.34),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,22.34),(72.055,22.34),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,22.34),(76.855,22.34),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,19.415),(14.455,19.415),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,22.34),(19.255,22.34),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,22.34),(81.655,22.34),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,22.34),(33.655,22.34),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,19.415),(81.655,19.415),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,19.415),(33.655,19.415),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,19.415),(52.855,19.415),(52.855,2.925),(51.545,2.925)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(13.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(13.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(61.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(61.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(71.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(71.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(66.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(66.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(18.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(18.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(28.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(28.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(81.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(81.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(76.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(76.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(23.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(23.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(9.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(9.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['gate']
        createRL(
            tech, net, 'poly',
            ((12.6,19.78),(12.6,20.11),(12.87,20.11),(12.87,19.78),(12.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,2.23),(14.73,2.56),(15.0,2.56),(15.0,2.23),(14.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,19.75),(9.765,19.78),(10.365,19.78),(10.365,19.75),(9.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.56),(14.565,2.59),(15.165,2.59),(15.165,2.56),(14.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,2.23),(9.93,2.56),(10.2,2.56),(10.2,2.23),(9.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,2.59),(12.435,19.75),(13.035,19.75),(13.035,2.59),(12.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.56),(9.765,2.59),(10.365,2.59),(10.365,2.56),(9.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,19.75),(12.435,19.78),(13.035,19.78),(13.035,19.75),(12.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,2.56),(12.435,2.59),(13.035,2.59),(13.035,2.56),(12.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,19.78),(7.8,20.11),(8.07,20.11),(8.07,19.78),(7.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.59),(7.635,19.75),(8.235,19.75),(8.235,2.59),(7.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,2.23),(12.6,2.56),(12.87,2.56),(12.87,2.23),(12.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.56),(7.635,2.59),(8.235,2.59),(8.235,2.56),(7.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,19.75),(7.635,19.78),(8.235,19.78),(8.235,19.75),(7.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,19.78),(9.93,20.11),(10.2,20.11),(10.2,19.78),(9.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,19.78),(14.73,20.11),(15.0,20.11),(15.0,19.78),(14.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,2.23),(7.8,2.56),(8.07,2.56),(8.07,2.23),(7.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.59),(14.565,19.75),(15.165,19.75),(15.165,2.59),(14.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,19.75),(14.565,19.78),(15.165,19.78),(15.165,19.75),(14.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.59),(9.765,19.75),(10.365,19.75),(10.365,2.59),(9.765,2.59)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,19.86),(12.65,20.03),(12.82,20.03),(12.82,19.86),(12.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,2.31),(9.98,2.48),(10.15,2.48),(10.15,2.31),(9.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,2.31),(14.78,2.48),(14.95,2.48),(14.95,2.31),(14.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,19.86),(14.78,20.03),(14.95,20.03),(14.95,19.86),(14.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((4.07,18.99),(4.07,19.16),(4.24,19.16),(4.24,18.99),(4.07,18.99)),
        )
        createRL(
            tech, net, 'licon',
            ((4.07,19.33),(4.07,19.5),(4.24,19.5),(4.24,19.33),(4.07,19.33)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,19.86),(7.85,20.03),(8.02,20.03),(8.02,19.86),(7.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,2.31),(12.65,2.48),(12.82,2.48),(12.82,2.31),(12.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,19.86),(9.98,20.03),(10.15,20.03),(10.15,19.86),(9.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,2.31),(7.85,2.48),(8.02,2.48),(8.02,2.31),(7.85,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,19.78),(12.65,20.11),(12.82,20.11),(12.82,19.78),(12.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.56),(12.65,19.78),(12.82,19.78),(12.82,2.56),(12.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,19.94),(4.07,20.11),(14.95,20.11),(14.95,19.94),(4.07,19.94)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.23),(9.98,2.56),(10.15,2.56),(10.15,2.23),(9.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.23),(14.78,2.56),(14.95,2.56),(14.95,2.23),(14.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,18.91),(4.07,19.58),(4.24,19.58),(4.24,18.91),(4.07,18.91)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,19.78),(14.78,20.11),(14.95,20.11),(14.95,19.78),(14.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.56),(14.78,19.78),(14.95,19.78),(14.95,2.56),(14.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,19.78),(7.85,20.11),(8.02,20.11),(8.02,19.78),(7.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.56),(7.85,19.78),(8.02,19.78),(8.02,2.56),(7.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.23),(12.65,2.56),(12.82,2.56),(12.82,2.23),(12.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,19.78),(9.98,20.11),(10.15,20.11),(10.15,19.78),(9.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,19.065),(4.07,19.955),(4.24,19.955),(4.24,19.065),(4.07,19.065)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.23),(7.85,2.56),(8.02,2.56),(8.02,2.23),(7.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,18.91),(4.07,20.11),(4.24,20.11),(4.24,18.91),(4.07,18.91)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.56),(9.98,19.78),(10.15,19.78),(10.15,2.56),(9.98,2.56)),
        )
        createRL(
            tech, net, 'difftap',
            ((4.03,18.87),(4.03,19.62),(4.28,19.62),(4.28,18.87),(4.03,18.87)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,19.065),(4.07,19.235),(4.24,19.235),(4.24,19.065),(4.07,19.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,19.425),(4.07,19.595),(4.24,19.595),(4.24,19.425),(4.07,19.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,19.785),(4.07,19.955),(4.24,19.955),(4.24,19.785),(4.07,19.785)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,19.005),(4.04,20.015),(4.27,20.015),(4.27,19.005),(4.04,19.005)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,19.005),(4.04,22.34),(4.27,22.34),(4.27,19.005),(4.04,19.005)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(4.155), u(0.23), u(19.005), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(4.155), u(0.23), u(19.005), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['off']
        createRL(
            tech, net, 'poly',
            ((48.33,19.78),(48.33,20.11),(48.6,20.11),(48.6,19.78),(48.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.59),(74.835,19.75),(75.435,19.75),(75.435,2.59),(74.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,19.75),(74.835,19.78),(75.435,19.78),(75.435,19.75),(74.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.56),(26.835,2.59),(27.435,2.59),(27.435,2.56),(26.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,19.78),(70.2,20.11),(70.47,20.11),(70.47,19.78),(70.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.59),(43.365,19.75),(43.965,19.75),(43.965,2.59),(43.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,19.78),(60.6,20.11),(60.87,20.11),(60.87,19.78),(60.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,19.78),(77.13,20.11),(77.4,20.11),(77.4,19.78),(77.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.59),(26.835,19.75),(27.435,19.75),(27.435,2.59),(26.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,19.75),(26.835,19.78),(27.435,19.78),(27.435,19.75),(26.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.59),(72.165,19.75),(72.765,19.75),(72.765,2.59),(72.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.56),(43.365,2.59),(43.965,2.59),(43.965,2.56),(43.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.56),(55.635,2.59),(56.235,2.59),(56.235,2.56),(55.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,19.75),(50.835,19.78),(51.435,19.78),(51.435,19.75),(50.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.59),(67.365,19.75),(67.965,19.75),(67.965,2.59),(67.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,19.75),(52.965,19.78),(53.565,19.78),(53.565,19.75),(52.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.56),(72.165,2.59),(72.765,2.59),(72.765,2.56),(72.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,2.23),(72.33,2.56),(72.6,2.56),(72.6,2.23),(72.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.59),(81.765,19.75),(82.365,19.75),(82.365,2.59),(81.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,19.75),(81.765,19.78),(82.365,19.78),(82.365,19.75),(81.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,19.78),(72.33,20.11),(72.6,20.11),(72.6,19.78),(72.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.56),(67.365,2.59),(67.965,2.59),(67.965,2.56),(67.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,2.23),(79.8,2.56),(80.07,2.56),(80.07,2.23),(79.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.56),(79.635,2.59),(80.235,2.59),(80.235,2.56),(79.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,2.23),(67.53,2.56),(67.8,2.56),(67.8,2.23),(67.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.59),(62.565,19.75),(63.165,19.75),(63.165,2.59),(62.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,19.75),(22.035,19.78),(22.635,19.78),(22.635,19.75),(22.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,19.78),(75.0,20.11),(75.27,20.11),(75.27,19.78),(75.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,19.78),(43.53,20.11),(43.8,20.11),(43.8,19.78),(43.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,19.78),(31.8,20.11),(32.07,20.11),(32.07,19.78),(31.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,19.75),(31.635,19.78),(32.235,19.78),(32.235,19.75),(31.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.56),(48.165,2.59),(48.765,2.59),(48.765,2.56),(48.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.56),(17.235,2.59),(17.835,2.59),(17.835,2.56),(17.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,2.23),(17.4,2.56),(17.67,2.56),(17.67,2.23),(17.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,19.78),(33.93,20.11),(34.2,20.11),(34.2,19.78),(33.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.59),(65.235,19.75),(65.835,19.75),(65.835,2.59),(65.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,19.78),(27.0,20.11),(27.27,20.11),(27.27,19.78),(27.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.56),(28.965,2.59),(29.565,2.59),(29.565,2.56),(28.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.59),(33.765,19.75),(34.365,19.75),(34.365,2.59),(33.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,19.78),(65.4,20.11),(65.67,20.11),(65.67,19.78),(65.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.56),(38.565,2.59),(39.165,2.59),(39.165,2.56),(38.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.56),(50.835,2.59),(51.435,2.59),(51.435,2.56),(50.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.59),(28.965,19.75),(29.565,19.75),(29.565,2.59),(28.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,19.78),(53.13,20.11),(53.4,20.11),(53.4,19.78),(53.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,19.75),(28.965,19.78),(29.565,19.78),(29.565,19.75),(28.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.59),(38.565,19.75),(39.165,19.75),(39.165,2.59),(38.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,19.78),(55.8,20.11),(56.07,20.11),(56.07,19.78),(55.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,19.75),(55.635,19.78),(56.235,19.78),(56.235,19.75),(55.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,19.78),(62.73,20.11),(63.0,20.11),(63.0,19.78),(62.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,19.75),(70.035,19.78),(70.635,19.78),(70.635,19.75),(70.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,19.75),(62.565,19.78),(63.165,19.78),(63.165,19.75),(62.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,11.335),(85.68,11.6),(86.01,11.6),(86.01,11.335),(85.68,11.335)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,19.78),(67.53,20.11),(67.8,20.11),(67.8,19.78),(67.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.59),(46.035,19.75),(46.635,19.75),(46.635,2.59),(46.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,19.78),(17.4,20.11),(17.67,20.11),(17.67,19.78),(17.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,2.23),(60.6,2.56),(60.87,2.56),(60.87,2.23),(60.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,2.23),(70.2,2.56),(70.47,2.56),(70.47,2.23),(70.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.56),(70.035,2.59),(70.635,2.59),(70.635,2.56),(70.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,2.23),(29.13,2.56),(29.4,2.56),(29.4,2.23),(29.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((85.68,11.34),(85.68,11.63),(86.01,11.63),(86.01,11.34),(85.68,11.34)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,19.78),(41.4,20.11),(41.67,20.11),(41.67,19.78),(41.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.56),(46.035,2.59),(46.635,2.59),(46.635,2.56),(46.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,19.78),(19.53,20.11),(19.8,20.11),(19.8,19.78),(19.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,19.75),(36.435,19.78),(37.035,19.78),(37.035,19.75),(36.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.56),(76.965,2.59),(77.565,2.59),(77.565,2.56),(76.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,2.23),(22.2,2.56),(22.47,2.56),(22.47,2.23),(22.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.56),(22.035,2.59),(22.635,2.59),(22.635,2.56),(22.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,19.78),(81.93,20.11),(82.2,20.11),(82.2,19.78),(81.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.59),(76.965,19.75),(77.565,19.75),(77.565,2.59),(76.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,19.75),(76.965,19.78),(77.565,19.78),(77.565,19.75),(76.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,19.78),(79.8,20.11),(80.07,20.11),(80.07,19.78),(79.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,2.23),(81.93,2.56),(82.2,2.56),(82.2,2.23),(81.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.56),(81.765,2.59),(82.365,2.59),(82.365,2.56),(81.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,19.75),(79.635,19.78),(80.235,19.78),(80.235,19.75),(79.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,19.75),(43.365,19.78),(43.965,19.78),(43.965,19.75),(43.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,2.23),(62.73,2.56),(63.0,2.56),(63.0,2.23),(62.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.56),(62.565,2.59),(63.165,2.59),(63.165,2.56),(62.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,19.75),(60.435,19.78),(61.035,19.78),(61.035,19.75),(60.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,19.78),(46.2,20.11),(46.47,20.11),(46.47,19.78),(46.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.59),(31.635,19.75),(32.235,19.75),(32.235,2.59),(31.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,2.23),(77.13,2.56),(77.4,2.56),(77.4,2.23),(77.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,19.75),(57.765,19.78),(58.365,19.78),(58.365,19.75),(57.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.59),(48.165,19.75),(48.765,19.75),(48.765,2.59),(48.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,19.75),(65.235,19.78),(65.835,19.78),(65.835,19.75),(65.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.56),(57.765,2.59),(58.365,2.59),(58.365,2.56),(57.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.59),(17.235,19.75),(17.835,19.75),(17.835,2.59),(17.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,19.75),(24.165,19.78),(24.765,19.78),(24.765,19.75),(24.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.56),(33.765,2.59),(34.365,2.59),(34.365,2.56),(33.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,19.75),(48.165,19.78),(48.765,19.78),(48.765,19.75),(48.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.59),(57.765,19.75),(58.365,19.75),(58.365,2.59),(57.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,19.78),(51.0,20.11),(51.27,20.11),(51.27,19.78),(51.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.56),(52.965,2.59),(53.565,2.59),(53.565,2.56),(52.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.59),(55.635,19.75),(56.235,19.75),(56.235,2.59),(55.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,2.23),(75.0,2.56),(75.27,2.56),(75.27,2.23),(75.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,19.75),(67.365,19.78),(67.965,19.78),(67.965,19.75),(67.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,19.75),(17.235,19.78),(17.835,19.78),(17.835,19.75),(17.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.59),(52.965,19.75),(53.565,19.75),(53.565,2.59),(52.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,2.23),(19.53,2.56),(19.8,2.56),(19.8,2.23),(19.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.56),(36.435,2.59),(37.035,2.59),(37.035,2.56),(36.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.56),(31.635,2.59),(32.235,2.59),(32.235,2.56),(31.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.59),(79.635,19.75),(80.235,19.75),(80.235,2.59),(79.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,19.75),(41.235,19.78),(41.835,19.78),(41.835,19.75),(41.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,2.23),(27.0,2.56),(27.27,2.56),(27.27,2.23),(27.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,19.75),(19.365,19.78),(19.965,19.78),(19.965,19.75),(19.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.59),(70.035,19.75),(70.635,19.75),(70.635,2.59),(70.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.59),(36.435,19.75),(37.035,19.75),(37.035,2.59),(36.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,19.75),(72.165,19.78),(72.765,19.78),(72.765,19.75),(72.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.59),(41.235,19.75),(41.835,19.75),(41.835,2.59),(41.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,19.78),(22.2,20.11),(22.47,20.11),(22.47,19.78),(22.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.59),(22.035,19.75),(22.635,19.75),(22.635,2.59),(22.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.56),(65.235,2.59),(65.835,2.59),(65.835,2.56),(65.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,2.23),(65.4,2.56),(65.67,2.56),(65.67,2.23),(65.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,19.78),(29.13,20.11),(29.4,20.11),(29.4,19.78),(29.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,19.75),(46.035,19.78),(46.635,19.78),(46.635,19.75),(46.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.56),(60.435,2.59),(61.035,2.59),(61.035,2.56),(60.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.59),(24.165,19.75),(24.765,19.75),(24.765,2.59),(24.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.56),(41.235,2.59),(41.835,2.59),(41.835,2.56),(41.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,19.75),(33.765,19.78),(34.365,19.78),(34.365,19.75),(33.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.59),(50.835,19.75),(51.435,19.75),(51.435,2.59),(50.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.59),(19.365,19.75),(19.965,19.75),(19.965,2.59),(19.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,19.78),(36.6,20.11),(36.87,20.11),(36.87,19.78),(36.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.59),(60.435,19.75),(61.035,19.75),(61.035,2.59),(60.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,19.78),(38.73,20.11),(39.0,20.11),(39.0,19.78),(38.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,2.23),(24.33,2.56),(24.6,2.56),(24.6,2.23),(24.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.56),(24.165,2.59),(24.765,2.59),(24.765,2.56),(24.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,19.75),(38.565,19.78),(39.165,19.78),(39.165,19.75),(38.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.56),(74.835,2.59),(75.435,2.59),(75.435,2.56),(74.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,19.78),(57.93,20.11),(58.2,20.11),(58.2,19.78),(57.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,19.78),(24.33,20.11),(24.6,20.11),(24.6,19.78),(24.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.56),(19.365,2.59),(19.965,2.59),(19.965,2.56),(19.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,2.31),(17.45,2.48),(17.62,2.48),(17.62,2.31),(17.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,19.86),(81.98,20.03),(82.15,20.03),(82.15,19.86),(81.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,19.86),(33.98,20.03),(34.15,20.03),(34.15,19.86),(33.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,19.86),(48.38,20.03),(48.55,20.03),(48.55,19.86),(48.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,19.86),(27.05,20.03),(27.22,20.03),(27.22,19.86),(27.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,2.31),(19.58,2.48),(19.75,2.48),(19.75,2.31),(19.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((85.76,11.38),(85.76,11.55),(85.93,11.55),(85.93,11.38),(85.76,11.38)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,19.86),(79.85,20.03),(80.02,20.03),(80.02,19.86),(79.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,19.86),(65.45,20.03),(65.62,20.03),(65.62,19.86),(65.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,2.31),(81.98,2.48),(82.15,2.48),(82.15,2.31),(81.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,2.31),(27.05,2.48),(27.22,2.48),(27.22,2.31),(27.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,19.86),(38.78,20.03),(38.95,20.03),(38.95,19.86),(38.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,19.86),(70.25,20.03),(70.42,20.03),(70.42,19.86),(70.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,19.86),(60.65,20.03),(60.82,20.03),(60.82,19.86),(60.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,2.31),(62.78,2.48),(62.95,2.48),(62.95,2.31),(62.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,19.86),(77.18,20.03),(77.35,20.03),(77.35,19.86),(77.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,19.86),(53.18,20.03),(53.35,20.03),(53.35,19.86),(53.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,19.86),(46.25,20.03),(46.42,20.03),(46.42,19.86),(46.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,19.86),(55.85,20.03),(56.02,20.03),(56.02,19.86),(55.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,2.31),(77.18,2.48),(77.35,2.48),(77.35,2.31),(77.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,19.86),(22.25,20.03),(22.42,20.03),(22.42,19.86),(22.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,2.31),(75.05,2.48),(75.22,2.48),(75.22,2.31),(75.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,2.31),(65.45,2.48),(65.62,2.48),(65.62,2.31),(65.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,19.86),(67.58,20.03),(67.75,20.03),(67.75,19.86),(67.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,19.86),(29.18,20.03),(29.35,20.03),(29.35,19.86),(29.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,2.31),(72.38,2.48),(72.55,2.48),(72.55,2.31),(72.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,19.86),(17.45,20.03),(17.62,20.03),(17.62,19.86),(17.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,2.31),(60.65,2.48),(60.82,2.48),(60.82,2.31),(60.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,2.31),(70.25,2.48),(70.42,2.48),(70.42,2.31),(70.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,19.86),(72.38,20.03),(72.55,20.03),(72.55,19.86),(72.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,2.31),(29.18,2.48),(29.35,2.48),(29.35,2.31),(29.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,2.31),(79.85,2.48),(80.02,2.48),(80.02,2.31),(79.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,2.31),(67.58,2.48),(67.75,2.48),(67.75,2.31),(67.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,19.86),(36.65,20.03),(36.82,20.03),(36.82,19.86),(36.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,19.86),(41.45,20.03),(41.62,20.03),(41.62,19.86),(41.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,19.86),(19.58,20.03),(19.75,20.03),(19.75,19.86),(19.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,2.31),(24.38,2.48),(24.55,2.48),(24.55,2.31),(24.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,19.86),(51.05,20.03),(51.22,20.03),(51.22,19.86),(51.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,19.86),(43.58,20.03),(43.75,20.03),(43.75,19.86),(43.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,19.86),(75.05,20.03),(75.22,20.03),(75.22,19.86),(75.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,19.86),(62.78,20.03),(62.95,20.03),(62.95,19.86),(62.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,19.86),(31.85,20.03),(32.02,20.03),(32.02,19.86),(31.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,19.86),(57.98,20.03),(58.15,20.03),(58.15,19.86),(57.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,2.31),(22.25,2.48),(22.42,2.48),(22.42,2.31),(22.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,19.86),(24.38,20.03),(24.55,20.03),(24.55,19.86),(24.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,19.78),(48.38,20.11),(48.55,20.11),(48.55,19.78),(48.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.56),(62.78,19.78),(62.95,19.78),(62.95,2.56),(62.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,19.78),(70.25,20.11),(70.42,20.11),(70.42,19.78),(70.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.56),(43.58,19.78),(43.75,19.78),(43.75,2.56),(43.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,19.78),(60.65,20.11),(60.82,20.11),(60.82,19.78),(60.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.23),(62.78,2.56),(62.95,2.56),(62.95,2.23),(62.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,19.78),(77.18,20.11),(77.35,20.11),(77.35,19.78),(77.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.56),(72.38,19.78),(72.55,19.78),(72.55,2.56),(72.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.23),(43.58,2.56),(43.75,2.56),(43.75,2.23),(43.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.23),(55.85,2.56),(56.02,2.56),(56.02,2.23),(55.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.56),(67.58,19.78),(67.75,19.78),(67.75,2.56),(67.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.23),(72.38,2.56),(72.55,2.56),(72.55,2.23),(72.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.56),(81.98,19.78),(82.15,19.78),(82.15,2.56),(81.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,19.78),(72.38,20.11),(72.55,20.11),(72.55,19.78),(72.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.23),(67.58,2.56),(67.75,2.56),(67.75,2.23),(67.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.23),(79.85,2.56),(80.02,2.56),(80.02,2.23),(79.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.56),(38.78,19.78),(38.95,19.78),(38.95,2.56),(38.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.56),(53.18,19.78),(53.35,19.78),(53.35,2.56),(53.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,19.78),(43.58,20.11),(43.75,20.11),(43.75,19.78),(43.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,19.78),(75.05,20.11),(75.22,20.11),(75.22,19.78),(75.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,19.78),(62.78,20.11),(62.95,20.11),(62.95,19.78),(62.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,19.78),(31.85,20.11),(32.02,20.11),(32.02,19.78),(31.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.23),(53.18,2.56),(53.35,2.56),(53.35,2.23),(53.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.23),(48.38,2.56),(48.55,2.56),(48.55,2.23),(48.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.23),(17.45,2.56),(17.62,2.56),(17.62,2.23),(17.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,19.78),(33.98,20.11),(34.15,20.11),(34.15,19.78),(33.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.56),(65.45,19.78),(65.62,19.78),(65.62,2.56),(65.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,19.78),(27.05,20.11),(27.22,20.11),(27.22,19.78),(27.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,11.3),(85.76,11.63),(85.93,11.63),(85.93,11.3),(85.76,11.3)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.56),(33.98,19.78),(34.15,19.78),(34.15,2.56),(33.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,19.78),(65.45,20.11),(65.62,20.11),(65.62,19.78),(65.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.23),(36.65,2.56),(36.82,2.56),(36.82,2.23),(36.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,19.78),(53.18,20.11),(53.35,20.11),(53.35,19.78),(53.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,19.78),(55.85,20.11),(56.02,20.11),(56.02,19.78),(55.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.56),(29.18,19.78),(29.35,19.78),(29.35,2.56),(29.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,19.78),(67.58,20.11),(67.75,20.11),(67.75,19.78),(67.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.56),(46.25,19.78),(46.42,19.78),(46.42,2.56),(46.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,19.78),(17.45,20.11),(17.62,20.11),(17.62,19.78),(17.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.23),(60.65,2.56),(60.82,2.56),(60.82,2.23),(60.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.23),(70.25,2.56),(70.42,2.56),(70.42,2.23),(70.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.23),(29.18,2.56),(29.35,2.56),(29.35,2.23),(29.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,19.78),(41.45,20.11),(41.62,20.11),(41.62,19.78),(41.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.23),(46.25,2.56),(46.42,2.56),(46.42,2.23),(46.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,19.78),(19.58,20.11),(19.75,20.11),(19.75,19.78),(19.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.23),(22.25,2.56),(22.42,2.56),(22.42,2.23),(22.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,19.78),(81.98,20.11),(82.15,20.11),(82.15,19.78),(81.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,19.78),(79.85,20.11),(80.02,20.11),(80.02,19.78),(79.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.23),(81.98,2.56),(82.15,2.56),(82.15,2.23),(81.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.56),(77.18,19.78),(77.35,19.78),(77.35,2.56),(77.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.56),(51.05,19.78),(51.22,19.78),(51.22,2.56),(51.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,19.78),(46.25,20.11),(46.42,20.11),(46.42,19.78),(46.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.56),(31.85,19.78),(32.02,19.78),(32.02,2.56),(31.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.23),(51.05,2.56),(51.22,2.56),(51.22,2.23),(51.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.23),(77.18,2.56),(77.35,2.56),(77.35,2.23),(77.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.56),(48.38,19.78),(48.55,19.78),(48.55,2.56),(48.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.23),(57.98,2.56),(58.15,2.56),(58.15,2.23),(57.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.56),(17.45,19.78),(17.62,19.78),(17.62,2.56),(17.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.23),(33.98,2.56),(34.15,2.56),(34.15,2.23),(33.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.56),(36.65,19.78),(36.82,19.78),(36.82,2.56),(36.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.56),(57.98,19.78),(58.15,19.78),(58.15,2.56),(57.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.56),(75.05,19.78),(75.22,19.78),(75.22,2.56),(75.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,19.78),(51.05,20.11),(51.22,20.11),(51.22,19.78),(51.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.56),(55.85,19.78),(56.02,19.78),(56.02,2.56),(55.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.23),(75.05,2.56),(75.22,2.56),(75.22,2.23),(75.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.56),(27.05,19.78),(27.22,19.78),(27.22,2.56),(27.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.56),(79.85,19.78),(80.02,19.78),(80.02,2.56),(79.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.23),(38.78,2.56),(38.95,2.56),(38.95,2.23),(38.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.23),(27.05,2.56),(27.22,2.56),(27.22,2.23),(27.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.56),(60.65,19.78),(60.82,19.78),(60.82,2.56),(60.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,19.78),(38.78,20.11),(38.95,20.11),(38.95,19.78),(38.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.56),(70.25,19.78),(70.42,19.78),(70.42,2.56),(70.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((85.76,11.3),(85.76,20.11),(85.93,20.11),(85.93,11.3),(85.76,11.3)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.56),(41.45,19.78),(41.62,19.78),(41.62,2.56),(41.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,19.78),(22.25,20.11),(22.42,20.11),(22.42,19.78),(22.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.56),(22.25,19.78),(22.42,19.78),(22.42,2.56),(22.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.23),(65.45,2.56),(65.62,2.56),(65.62,2.23),(65.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,19.94),(17.45,20.11),(82.15,20.11),(82.15,19.94),(17.45,19.94)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,19.78),(29.18,20.11),(29.35,20.11),(29.35,19.78),(29.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.23),(41.45,2.56),(41.62,2.56),(41.62,2.23),(41.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.56),(24.38,19.78),(24.55,19.78),(24.55,2.56),(24.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,19.78),(36.65,20.11),(36.82,20.11),(36.82,19.78),(36.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.56),(19.58,19.78),(19.75,19.78),(19.75,2.56),(19.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.23),(24.38,2.56),(24.55,2.56),(24.55,2.23),(24.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,19.78),(57.98,20.11),(58.15,20.11),(58.15,19.78),(57.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,19.78),(24.38,20.11),(24.55,20.11),(24.55,19.78),(24.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.23),(19.58,2.56),(19.75,2.56),(19.75,2.23),(19.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.23),(31.85,2.56),(32.02,2.56),(32.02,2.23),(31.85,2.23)),
        )
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        nets['gate'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_N18000W4468HFF']
        except:
            subcell = af.getCell('GuardRing_N18000W4468HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_P17368W3836HFF']
        except:
            subcell = af.getCell('GuardRing_P17368W3836HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['GateLevelUp']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-15.0), u(6.88), u(-1.0),
        ))
        nets = {
            'd': Net.create(cell, 'd'),
            'iovdd': Net.create(cell, 'iovdd'),
            'ngate': Net.create(cell, 'ngate'),
            'pgate': Net.create(cell, 'pgate'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['d']
        createRL(
            tech, net, 'm1',
            ((1.095,-6.075),(1.095,-1.0),(1.325,-1.0),(1.325,-6.075),(1.095,-6.075)),
        )
        createRL(
            tech, net, 'm1',
            ((1.095,-1.0),(1.095,-0.72),(4.765,-0.72),(4.765,-1.0),(1.095,-1.0)),
        )
        createRL(
            tech, net, 'm1',
            ((4.535,-6.075),(4.535,-1.0),(4.765,-1.0),(4.765,-6.075),(4.535,-6.075)),
        )
        Horizontal.create(
            net, tech.getLayer('m1.pin'),
            u(-0.86), u(0.28), u(1.0949999999999998), u(4.765),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m1'),
            u(-0.86), u(0.28), u(1.0949999999999998), u(4.765),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['ngate']
        createRL(
            tech, net, 'm1',
            ((3.05,-14.325),(3.05,-7.195),(3.28,-7.195),(3.28,-14.325),(3.05,-14.325)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(3.165), u(0.23), u(-14.325), u(-7.195),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(3.165), u(0.23), u(-14.325), u(-7.195),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['pgate']
        createRL(
            tech, net, 'm1',
            ((6.49,-14.325),(6.49,-7.195),(6.72,-7.195),(6.72,-14.325),(6.49,-14.325)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(6.605), u(0.23), u(-14.325), u(-7.195),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(6.605), u(0.23), u(-14.325), u(-7.195),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'li',
            ((0.0,-6.63),(0.0,-6.37),(6.88,-6.37),(6.88,-6.63),(0.0,-6.63)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(-6.5), u(0.26), u(0.0), u(6.88),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(-6.5), u(0.26), u(0.0), u(6.88),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'li',
            ((0.0,-1.13),(0.0,-0.87),(6.88,-0.87),(6.88,-1.13),(0.0,-1.13)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(-1.0), u(0.26), u(0.0), u(6.88),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(-1.0), u(0.26), u(0.0), u(6.88),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['iovdd']
        createRL(
            tech, net, 'li',
            ((0.0,-15.13),(0.0,-14.87),(6.88,-14.87),(6.88,-15.13),(0.0,-15.13)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(-15.0), u(0.26), u(0.0), u(6.88),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(-15.0), u(0.26), u(0.0), u(6.88),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['d'].setDirection(Net.Direction.IN)
        nets['ngate'].setDirection(Net.Direction.IN)
        nets['pgate'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['LevelUp']
        except:
            subcell = af.getCell('LevelUp', 0)
        trans = Transformation(
            u(0.0), u(-15.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'ngate_levelup', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['LevelUp']
        except:
            subcell = af.getCell('LevelUp', 0)
        trans = Transformation(
            u(3.44), u(-15.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pgate_levelup', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadTriOut']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'd': Net.create(cell, 'd'),
            'de': Net.create(cell, 'de'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'ngate': Net.create(cell, 'ngate'),
            'pad': Net.create(cell, 'pad'),
            'pgate': Net.create(cell, 'pgate'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((85.61,88.09),(85.61,88.26),(86.14,88.26),(86.14,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.61,88.09),(85.61,88.26),(85.78,88.26),(85.78,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.97,88.09),(85.97,88.26),(86.14,88.26),(86.14,88.09),(85.97,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.715,88.03),(25.715,88.32),(25.945,88.32),(25.945,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.77,88.03),(6.77,88.32),(7.0,88.32),(7.0,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.115,88.03),(64.115,88.32),(64.345,88.32),(64.345,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.58,88.03),(85.58,88.32),(86.17,88.32),(86.17,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.715,88.03),(49.715,88.32),(49.945,88.32),(49.945,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.915,88.03),(68.915,88.32),(69.145,88.32),(69.145,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.515,88.03),(78.515,88.32),(78.745,88.32),(78.745,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.515,88.03),(54.515,88.32),(54.745,88.32),(54.745,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.315,88.03),(35.315,88.32),(35.545,88.32),(35.545,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.915,88.03),(44.915,88.32),(45.145,88.32),(45.145,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.915,88.03),(20.915,88.32),(21.145,88.32),(21.145,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.315,88.03),(11.315,88.32),(11.545,88.32),(11.545,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.115,88.03),(16.115,88.32),(16.345,88.32),(16.345,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.06,88.03),(83.06,88.32),(83.29,88.32),(83.29,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.515,88.03),(30.515,88.32),(30.745,88.32),(30.745,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.115,88.03),(40.115,88.32),(40.345,88.32),(40.345,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.715,88.03),(73.715,88.32),(73.945,88.32),(73.945,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.315,88.03),(59.315,88.32),(59.545,88.32),(59.545,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,133.04),(48.055,133.04),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,133.04),(43.255,133.04),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,133.04),(76.855,133.04),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,133.04),(62.455,133.04),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,133.04),(19.255,133.04),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,133.04),(28.855,133.04),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,133.04),(72.055,133.04),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,133.04),(81.655,133.04),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,133.04),(33.655,133.04),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,133.04),(57.655,133.04),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,133.04),(52.855,133.04),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,133.04),(38.455,133.04),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,133.04),(67.255,133.04),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,133.04),(24.055,133.04),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,133.04),(9.655,133.04),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,133.04),(14.455,133.04),(14.455,86.32),(13.145,86.32)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        net = nets['d']
        createRL(
            tech, net, 'm1',
            ((43.535,183.8),(43.535,188.0),(43.905,188.0),(43.905,183.8),(43.535,183.8)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(43.72), u(0.37), u(183.8), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(43.72), u(0.37), u(183.8), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['de']
        createRL(
            tech, net, 'm1',
            ((46.09,184.23),(46.09,188.0),(46.46,188.0),(46.46,184.23),(46.09,184.23)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(46.275), u(0.37), u(184.23), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(46.275), u(0.37), u(184.23), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['pgate']
        createRL(
            tech, net, 'm1',
            ((4.04,133.32),(4.04,133.69),(50.79,133.69),(50.79,133.32),(4.04,133.32)),
        )
        createRL(
            tech, net, 'm1',
            ((50.56,133.32),(50.56,163.675),(50.79,163.675),(50.79,133.32),(50.56,133.32)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,133.04),(4.04,133.69),(4.27,133.69),(4.27,133.04),(4.04,133.04)),
        )
        net = nets['ngate']
        createRL(
            tech, net, 'm1',
            ((0.3,21.97),(0.3,22.34),(4.04,22.34),(4.04,21.97),(0.3,21.97)),
        )
        createRL(
            tech, net, 'm1',
            ((47.12,133.97),(47.12,163.675),(47.35,163.675),(47.35,133.97),(47.12,133.97)),
        )
        createRL(
            tech, net, 'm1',
            ((0.3,21.97),(0.3,134.34),(0.67,134.34),(0.67,21.97),(0.3,21.97)),
        )
        createRL(
            tech, net, 'm1',
            ((0.3,133.97),(0.3,134.34),(47.35,134.34),(47.35,133.97),(0.3,133.97)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['d'].setDirection(Net.Direction.IN)
        nets['de'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N4D']
        except:
            subcell = af.getCell('Clamp_N32N4D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N4D']
        except:
            subcell = af.getCell('Clamp_P32N4D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GateDecode']
        except:
            subcell = af.getCell('GateDecode', 0)
        trans = Transformation(
            u(43.07), u(178.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'gatedec', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadInOut']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'd': Net.create(cell, 'd'),
            'de': Net.create(cell, 'de'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'ngate': Net.create(cell, 'ngate'),
            'pad': Net.create(cell, 'pad'),
            'pgate': Net.create(cell, 'pgate'),
            's': Net.create(cell, 's'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((85.61,88.09),(85.61,88.26),(86.14,88.26),(86.14,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.61,88.09),(85.61,88.26),(85.78,88.26),(85.78,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.97,88.09),(85.97,88.26),(86.14,88.26),(86.14,88.09),(85.97,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.715,88.03),(25.715,88.32),(25.945,88.32),(25.945,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.77,88.03),(6.77,88.32),(7.0,88.32),(7.0,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.115,88.03),(64.115,88.32),(64.345,88.32),(64.345,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.58,88.03),(85.58,88.32),(86.17,88.32),(86.17,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.715,88.03),(49.715,88.32),(49.945,88.32),(49.945,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.915,88.03),(68.915,88.32),(69.145,88.32),(69.145,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.515,88.03),(78.515,88.32),(78.745,88.32),(78.745,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.515,88.03),(54.515,88.32),(54.745,88.32),(54.745,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.315,88.03),(35.315,88.32),(35.545,88.32),(35.545,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.915,88.03),(44.915,88.32),(45.145,88.32),(45.145,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.915,88.03),(20.915,88.32),(21.145,88.32),(21.145,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.315,88.03),(11.315,88.32),(11.545,88.32),(11.545,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.115,88.03),(16.115,88.32),(16.345,88.32),(16.345,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.06,88.03),(83.06,88.32),(83.29,88.32),(83.29,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.515,88.03),(30.515,88.32),(30.745,88.32),(30.745,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.115,88.03),(40.115,88.32),(40.345,88.32),(40.345,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.715,88.03),(73.715,88.32),(73.945,88.32),(73.945,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.315,88.03),(59.315,88.32),(59.545,88.32),(59.545,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((32.345,19.415),(32.345,24.32),(33.655,24.32),(33.655,19.415),(32.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,92.175),(81.655,92.175),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,92.175),(33.655,92.175),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,19.415),(65.945,24.32),(67.255,24.32),(67.255,19.415),(65.945,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,22.34),(17.945,24.32),(19.255,24.32),(19.255,22.34),(17.945,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,22.34),(46.745,24.32),(48.055,24.32),(48.055,22.34),(46.745,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,22.34),(61.145,24.32),(62.455,24.32),(62.455,22.34),(61.145,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,92.175),(24.055,92.175),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,22.34),(51.545,24.32),(52.855,24.32),(52.855,22.34),(51.545,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,92.175),(28.855,92.175),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,19.415),(41.945,24.32),(43.255,24.32),(43.255,19.415),(41.945,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,22.34),(41.945,24.32),(43.255,24.32),(43.255,22.34),(41.945,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,22.34),(80.345,24.32),(81.655,24.32),(81.655,22.34),(80.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,19.415),(61.145,24.32),(62.455,24.32),(62.455,19.415),(61.145,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,22.34),(32.345,24.32),(33.655,24.32),(33.655,22.34),(32.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,92.175),(38.455,92.175),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,92.175),(19.255,92.175),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,92.175),(48.055,92.175),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,92.175),(57.655,92.175),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,92.175),(52.855,92.175),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,19.415),(80.345,24.32),(81.655,24.32),(81.655,19.415),(80.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,92.175),(43.255,92.175),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,19.415),(13.145,24.32),(14.455,24.32),(14.455,19.415),(13.145,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,19.415),(17.945,24.32),(19.255,24.32),(19.255,19.415),(17.945,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,22.34),(65.945,24.32),(67.255,24.32),(67.255,22.34),(65.945,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,19.415),(70.745,24.32),(72.055,24.32),(72.055,19.415),(70.745,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,19.415),(46.745,24.32),(48.055,24.32),(48.055,19.415),(46.745,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,22.34),(37.145,24.32),(38.455,24.32),(38.455,22.34),(37.145,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,19.415),(8.345,24.32),(9.655,24.32),(9.655,19.415),(8.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,22.34),(70.745,24.32),(72.055,24.32),(72.055,22.34),(70.745,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,92.175),(14.455,92.175),(14.455,86.32),(13.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,22.34),(75.545,24.32),(76.855,24.32),(76.855,22.34),(75.545,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,19.415),(75.545,24.32),(76.855,24.32),(76.855,19.415),(75.545,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,19.415),(51.545,24.32),(52.855,24.32),(52.855,19.415),(51.545,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,92.175),(9.655,92.175),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,22.34),(56.345,24.32),(57.655,24.32),(57.655,22.34),(56.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,92.175),(76.855,92.175),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,19.415),(37.145,24.32),(38.455,24.32),(38.455,19.415),(37.145,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,92.175),(62.455,92.175),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,19.415),(22.745,24.32),(24.055,24.32),(24.055,19.415),(22.745,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,22.34),(22.745,24.32),(24.055,24.32),(24.055,22.34),(22.745,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,22.34),(13.145,24.32),(14.455,24.32),(14.455,22.34),(13.145,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,19.415),(56.345,24.32),(57.655,24.32),(57.655,19.415),(56.345,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,92.175),(67.255,92.175),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,92.175),(72.055,92.175),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,22.34),(27.545,24.32),(28.855,24.32),(28.855,22.34),(27.545,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,19.415),(27.545,24.32),(28.855,24.32),(28.855,19.415),(27.545,19.415)),
        )
        createRL(
            tech, net, 'm1',
            ((68.395,156.325),(68.395,156.695),(71.115,156.695),(71.115,156.325),(68.395,156.325)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,22.34),(8.345,24.32),(9.655,24.32),(9.655,22.34),(8.345,22.34)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,133.04),(70.745,156.695),(72.055,156.695),(72.055,133.04),(70.745,133.04)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        net = nets['d']
        createRL(
            tech, net, 'm1',
            ((21.035,183.8),(21.035,188.0),(21.405,188.0),(21.405,183.8),(21.035,183.8)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(21.22), u(0.37), u(183.8), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(21.22), u(0.37), u(183.8), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['de']
        createRL(
            tech, net, 'm1',
            ((23.59,184.23),(23.59,188.0),(23.96,188.0),(23.96,184.23),(23.59,184.23)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(23.775), u(0.37), u(184.23), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(23.775), u(0.37), u(184.23), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['pgate']
        createRL(
            tech, net, 'm1',
            ((4.04,133.04),(4.04,133.69),(4.27,133.69),(4.27,133.04),(4.04,133.04)),
        )
        createRL(
            tech, net, 'm1',
            ((28.06,133.32),(28.06,163.675),(28.29,163.675),(28.29,133.32),(28.06,133.32)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,133.32),(4.04,133.69),(28.29,133.69),(28.29,133.32),(4.04,133.32)),
        )
        net = nets['ngate']
        createRL(
            tech, net, 'm1',
            ((0.3,21.97),(0.3,22.34),(4.04,22.34),(4.04,21.97),(0.3,21.97)),
        )
        createRL(
            tech, net, 'm1',
            ((24.62,133.97),(24.62,163.675),(24.85,163.675),(24.85,133.97),(24.62,133.97)),
        )
        createRL(
            tech, net, 'm1',
            ((0.3,21.97),(0.3,134.34),(0.67,134.34),(0.67,21.97),(0.3,21.97)),
        )
        createRL(
            tech, net, 'm1',
            ((0.3,133.97),(0.3,134.34),(24.85,134.34),(24.85,133.97),(0.3,133.97)),
        )
        net = nets['s']
        createRL(
            tech, net, 'li',
            ((67.245,171.95),(67.245,176.505),(67.415,176.505),(67.415,171.95),(67.245,171.95)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,171.985),(67.245,172.155),(67.415,172.155),(67.415,171.985),(67.245,171.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,172.345),(67.245,172.515),(67.415,172.515),(67.415,172.345),(67.245,172.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,172.705),(67.245,172.875),(67.415,172.875),(67.415,172.705),(67.245,172.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,173.065),(67.245,173.235),(67.415,173.235),(67.415,173.065),(67.245,173.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,173.425),(67.245,173.595),(67.415,173.595),(67.415,173.425),(67.245,173.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,173.785),(67.245,173.955),(67.415,173.955),(67.415,173.785),(67.245,173.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,174.145),(67.245,174.315),(67.415,174.315),(67.415,174.145),(67.245,174.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,174.505),(67.245,174.675),(67.415,174.675),(67.415,174.505),(67.245,174.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,174.865),(67.245,175.035),(67.415,175.035),(67.415,174.865),(67.245,174.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,175.225),(67.245,175.395),(67.415,175.395),(67.415,175.225),(67.245,175.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,175.585),(67.245,175.755),(67.415,175.755),(67.415,175.585),(67.245,175.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,175.945),(67.245,176.115),(67.415,176.115),(67.415,175.945),(67.245,175.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.245,176.305),(67.245,176.475),(67.415,176.475),(67.415,176.305),(67.245,176.305)),
        )
        createRL(
            tech, net, 'm1',
            ((67.185,171.955),(67.185,188.0),(67.475,188.0),(67.475,171.955),(67.185,171.955)),
        )
        createRL(
            tech, net, 'm1',
            ((67.185,171.955),(67.185,176.505),(67.475,176.505),(67.475,171.955),(67.185,171.955)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(67.33), u(0.29), u(171.955), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(67.33), u(0.29), u(171.955), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['s'].setDirection(Net.Direction.IN)
        nets['d'].setDirection(Net.Direction.IN)
        nets['de'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N4D']
        except:
            subcell = af.getCell('Clamp_N32N4D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N4D']
        except:
            subcell = af.getCell('Clamp_P32N4D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GateDecode']
        except:
            subcell = af.getCell('GateDecode', 0)
        trans = Transformation(
            u(20.57), u(178.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'gatedec', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['LevelDown']
        except:
            subcell = af.getCell('LevelDown', 0)
        trans = Transformation(
            u(67.24), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'leveldown', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadIOVss']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((13.19,142.04),(13.19,151.96),(14.41,151.96),(14.41,142.04),(13.19,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((41.99,142.04),(41.99,151.96),(43.21,151.96),(43.21,142.04),(41.99,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((17.99,142.04),(17.99,151.96),(19.21,151.96),(19.21,142.04),(17.99,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((75.59,142.04),(75.59,151.96),(76.81,151.96),(76.81,142.04),(75.59,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((61.19,142.04),(61.19,151.96),(62.41,151.96),(62.41,142.04),(61.19,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((70.79,142.04),(70.79,151.96),(72.01,151.96),(72.01,142.04),(70.79,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((80.39,142.04),(80.39,151.96),(81.61,151.96),(81.61,142.04),(80.39,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((32.39,142.04),(32.39,151.96),(33.61,151.96),(33.61,142.04),(32.39,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((27.59,142.04),(27.59,151.96),(28.81,151.96),(28.81,142.04),(27.59,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm2',
            ((22.79,142.04),(22.79,151.96),(24.01,151.96),(24.01,142.04),(22.79,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((56.39,142.04),(56.39,151.96),(57.61,151.96),(57.61,142.04),(56.39,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((65.99,142.04),(65.99,151.96),(67.21,151.96),(67.21,142.04),(65.99,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm2',
            ((51.59,142.04),(51.59,151.96),(52.81,151.96),(52.81,142.04),(51.59,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((37.19,142.04),(37.19,151.96),(38.41,151.96),(38.41,142.04),(37.19,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((46.79,142.04),(46.79,151.96),(48.01,151.96),(48.01,142.04),(46.79,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((8.39,142.04),(8.39,151.96),(9.61,151.96),(9.61,142.04),(8.39,142.04)),
        )
        createRL(
            tech, net, 'm2',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm3',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm4',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,142.0),(41.945,152.0),(43.255,152.0),(43.255,142.0),(41.945,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,142.0),(46.745,152.0),(48.055,152.0),(48.055,142.0),(46.745,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,142.0),(61.145,152.0),(62.455,152.0),(62.455,142.0),(61.145,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,86.32),(65.945,152.0),(67.255,152.0),(67.255,86.32),(65.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,142.0),(51.545,152.0),(52.855,152.0),(52.855,142.0),(51.545,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,86.32),(70.745,152.0),(72.055,152.0),(72.055,86.32),(70.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,152.0),(38.455,152.0),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,86.32),(75.545,152.0),(76.855,152.0),(76.855,86.32),(75.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,142.0),(17.945,152.0),(19.255,152.0),(19.255,142.0),(17.945,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,152.0),(57.655,152.0),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,86.32),(22.745,152.0),(24.055,152.0),(24.055,86.32),(22.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,142.0),(80.345,152.0),(81.655,152.0),(81.655,142.0),(80.345,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,86.32),(13.145,152.0),(14.455,152.0),(14.455,86.32),(13.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,86.32),(27.545,152.0),(28.855,152.0),(28.855,86.32),(27.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,142.0),(32.345,152.0),(33.655,152.0),(33.655,142.0),(32.345,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,86.32),(8.345,152.0),(9.655,152.0),(9.655,86.32),(8.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,142.0),(56.345,152.0),(57.655,152.0),(57.655,142.0),(56.345,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,142.0),(70.745,152.0),(72.055,152.0),(72.055,142.0),(70.745,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,142.0),(37.145,152.0),(38.455,152.0),(38.455,142.0),(37.145,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,142.0),(75.545,152.0),(76.855,152.0),(76.855,142.0),(75.545,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,86.32),(17.945,152.0),(19.255,152.0),(19.255,86.32),(17.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,152.0),(48.055,152.0),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,86.32),(61.145,152.0),(62.455,152.0),(62.455,86.32),(61.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,152.0),(52.855,152.0),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,142.0),(65.945,152.0),(67.255,152.0),(67.255,142.0),(65.945,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,152.0),(43.255,152.0),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,142.0),(8.345,152.0),(9.655,152.0),(9.655,142.0),(8.345,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,142.0),(22.745,152.0),(24.055,152.0),(24.055,142.0),(22.745,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,86.32),(80.345,152.0),(81.655,152.0),(81.655,86.32),(80.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,142.0),(13.145,152.0),(14.455,152.0),(14.455,142.0),(13.145,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,152.0),(33.655,152.0),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,142.0),(27.545,152.0),(28.855,152.0),(28.855,142.0),(27.545,142.0)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,142.125),(22.845,142.275),(22.995,142.275),(22.995,142.125),(22.845,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,142.125),(23.165,142.275),(23.315,142.275),(23.315,142.125),(23.165,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,142.125),(23.485,142.275),(23.635,142.275),(23.635,142.125),(23.485,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,142.125),(23.805,142.275),(23.955,142.275),(23.955,142.125),(23.805,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,142.445),(22.845,142.595),(22.995,142.595),(22.995,142.445),(22.845,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,142.445),(23.165,142.595),(23.315,142.595),(23.315,142.445),(23.165,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,142.445),(23.485,142.595),(23.635,142.595),(23.635,142.445),(23.485,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,142.445),(23.805,142.595),(23.955,142.595),(23.955,142.445),(23.805,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,142.765),(22.845,142.915),(22.995,142.915),(22.995,142.765),(22.845,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,142.765),(23.165,142.915),(23.315,142.915),(23.315,142.765),(23.165,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,142.765),(23.485,142.915),(23.635,142.915),(23.635,142.765),(23.485,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,142.765),(23.805,142.915),(23.955,142.915),(23.955,142.765),(23.805,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,143.085),(22.845,143.235),(22.995,143.235),(22.995,143.085),(22.845,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,143.085),(23.165,143.235),(23.315,143.235),(23.315,143.085),(23.165,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,143.085),(23.485,143.235),(23.635,143.235),(23.635,143.085),(23.485,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,143.085),(23.805,143.235),(23.955,143.235),(23.955,143.085),(23.805,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,143.405),(22.845,143.555),(22.995,143.555),(22.995,143.405),(22.845,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,143.405),(23.165,143.555),(23.315,143.555),(23.315,143.405),(23.165,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,143.405),(23.485,143.555),(23.635,143.555),(23.635,143.405),(23.485,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,143.405),(23.805,143.555),(23.955,143.555),(23.955,143.405),(23.805,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,143.725),(22.845,143.875),(22.995,143.875),(22.995,143.725),(22.845,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,143.725),(23.165,143.875),(23.315,143.875),(23.315,143.725),(23.165,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,143.725),(23.485,143.875),(23.635,143.875),(23.635,143.725),(23.485,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,143.725),(23.805,143.875),(23.955,143.875),(23.955,143.725),(23.805,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,144.045),(22.845,144.195),(22.995,144.195),(22.995,144.045),(22.845,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,144.045),(23.165,144.195),(23.315,144.195),(23.315,144.045),(23.165,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,144.045),(23.485,144.195),(23.635,144.195),(23.635,144.045),(23.485,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,144.045),(23.805,144.195),(23.955,144.195),(23.955,144.045),(23.805,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,144.365),(22.845,144.515),(22.995,144.515),(22.995,144.365),(22.845,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,144.365),(23.165,144.515),(23.315,144.515),(23.315,144.365),(23.165,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,144.365),(23.485,144.515),(23.635,144.515),(23.635,144.365),(23.485,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,144.365),(23.805,144.515),(23.955,144.515),(23.955,144.365),(23.805,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,144.685),(22.845,144.835),(22.995,144.835),(22.995,144.685),(22.845,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,144.685),(23.165,144.835),(23.315,144.835),(23.315,144.685),(23.165,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,144.685),(23.485,144.835),(23.635,144.835),(23.635,144.685),(23.485,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,144.685),(23.805,144.835),(23.955,144.835),(23.955,144.685),(23.805,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,145.005),(22.845,145.155),(22.995,145.155),(22.995,145.005),(22.845,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,145.005),(23.165,145.155),(23.315,145.155),(23.315,145.005),(23.165,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,145.005),(23.485,145.155),(23.635,145.155),(23.635,145.005),(23.485,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,145.005),(23.805,145.155),(23.955,145.155),(23.955,145.005),(23.805,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,145.325),(22.845,145.475),(22.995,145.475),(22.995,145.325),(22.845,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,145.325),(23.165,145.475),(23.315,145.475),(23.315,145.325),(23.165,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,145.325),(23.485,145.475),(23.635,145.475),(23.635,145.325),(23.485,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,145.325),(23.805,145.475),(23.955,145.475),(23.955,145.325),(23.805,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,145.645),(22.845,145.795),(22.995,145.795),(22.995,145.645),(22.845,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,145.645),(23.165,145.795),(23.315,145.795),(23.315,145.645),(23.165,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,145.645),(23.485,145.795),(23.635,145.795),(23.635,145.645),(23.485,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,145.645),(23.805,145.795),(23.955,145.795),(23.955,145.645),(23.805,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,145.965),(22.845,146.115),(22.995,146.115),(22.995,145.965),(22.845,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,145.965),(23.165,146.115),(23.315,146.115),(23.315,145.965),(23.165,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,145.965),(23.485,146.115),(23.635,146.115),(23.635,145.965),(23.485,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,145.965),(23.805,146.115),(23.955,146.115),(23.955,145.965),(23.805,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,146.285),(22.845,146.435),(22.995,146.435),(22.995,146.285),(22.845,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,146.285),(23.165,146.435),(23.315,146.435),(23.315,146.285),(23.165,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,146.285),(23.485,146.435),(23.635,146.435),(23.635,146.285),(23.485,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,146.285),(23.805,146.435),(23.955,146.435),(23.955,146.285),(23.805,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,146.605),(22.845,146.755),(22.995,146.755),(22.995,146.605),(22.845,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,146.605),(23.165,146.755),(23.315,146.755),(23.315,146.605),(23.165,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,146.605),(23.485,146.755),(23.635,146.755),(23.635,146.605),(23.485,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,146.605),(23.805,146.755),(23.955,146.755),(23.955,146.605),(23.805,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,146.925),(22.845,147.075),(22.995,147.075),(22.995,146.925),(22.845,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,146.925),(23.165,147.075),(23.315,147.075),(23.315,146.925),(23.165,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,146.925),(23.485,147.075),(23.635,147.075),(23.635,146.925),(23.485,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,146.925),(23.805,147.075),(23.955,147.075),(23.955,146.925),(23.805,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,147.245),(22.845,147.395),(22.995,147.395),(22.995,147.245),(22.845,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,147.245),(23.165,147.395),(23.315,147.395),(23.315,147.245),(23.165,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,147.245),(23.485,147.395),(23.635,147.395),(23.635,147.245),(23.485,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,147.245),(23.805,147.395),(23.955,147.395),(23.955,147.245),(23.805,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,147.565),(22.845,147.715),(22.995,147.715),(22.995,147.565),(22.845,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,147.565),(23.165,147.715),(23.315,147.715),(23.315,147.565),(23.165,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,147.565),(23.485,147.715),(23.635,147.715),(23.635,147.565),(23.485,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,147.565),(23.805,147.715),(23.955,147.715),(23.955,147.565),(23.805,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,147.885),(22.845,148.035),(22.995,148.035),(22.995,147.885),(22.845,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,147.885),(23.165,148.035),(23.315,148.035),(23.315,147.885),(23.165,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,147.885),(23.485,148.035),(23.635,148.035),(23.635,147.885),(23.485,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,147.885),(23.805,148.035),(23.955,148.035),(23.955,147.885),(23.805,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,148.205),(22.845,148.355),(22.995,148.355),(22.995,148.205),(22.845,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,148.205),(23.165,148.355),(23.315,148.355),(23.315,148.205),(23.165,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,148.205),(23.485,148.355),(23.635,148.355),(23.635,148.205),(23.485,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,148.205),(23.805,148.355),(23.955,148.355),(23.955,148.205),(23.805,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,148.525),(22.845,148.675),(22.995,148.675),(22.995,148.525),(22.845,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,148.525),(23.165,148.675),(23.315,148.675),(23.315,148.525),(23.165,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,148.525),(23.485,148.675),(23.635,148.675),(23.635,148.525),(23.485,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,148.525),(23.805,148.675),(23.955,148.675),(23.955,148.525),(23.805,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,148.845),(22.845,148.995),(22.995,148.995),(22.995,148.845),(22.845,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,148.845),(23.165,148.995),(23.315,148.995),(23.315,148.845),(23.165,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,148.845),(23.485,148.995),(23.635,148.995),(23.635,148.845),(23.485,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,148.845),(23.805,148.995),(23.955,148.995),(23.955,148.845),(23.805,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,149.165),(22.845,149.315),(22.995,149.315),(22.995,149.165),(22.845,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,149.165),(23.165,149.315),(23.315,149.315),(23.315,149.165),(23.165,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,149.165),(23.485,149.315),(23.635,149.315),(23.635,149.165),(23.485,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,149.165),(23.805,149.315),(23.955,149.315),(23.955,149.165),(23.805,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,149.485),(22.845,149.635),(22.995,149.635),(22.995,149.485),(22.845,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,149.485),(23.165,149.635),(23.315,149.635),(23.315,149.485),(23.165,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,149.485),(23.485,149.635),(23.635,149.635),(23.635,149.485),(23.485,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,149.485),(23.805,149.635),(23.955,149.635),(23.955,149.485),(23.805,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,149.805),(22.845,149.955),(22.995,149.955),(22.995,149.805),(22.845,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,149.805),(23.165,149.955),(23.315,149.955),(23.315,149.805),(23.165,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,149.805),(23.485,149.955),(23.635,149.955),(23.635,149.805),(23.485,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,149.805),(23.805,149.955),(23.955,149.955),(23.955,149.805),(23.805,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,150.125),(22.845,150.275),(22.995,150.275),(22.995,150.125),(22.845,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,150.125),(23.165,150.275),(23.315,150.275),(23.315,150.125),(23.165,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,150.125),(23.485,150.275),(23.635,150.275),(23.635,150.125),(23.485,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,150.125),(23.805,150.275),(23.955,150.275),(23.955,150.125),(23.805,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,150.445),(22.845,150.595),(22.995,150.595),(22.995,150.445),(22.845,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,150.445),(23.165,150.595),(23.315,150.595),(23.315,150.445),(23.165,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,150.445),(23.485,150.595),(23.635,150.595),(23.635,150.445),(23.485,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,150.445),(23.805,150.595),(23.955,150.595),(23.955,150.445),(23.805,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,150.765),(22.845,150.915),(22.995,150.915),(22.995,150.765),(22.845,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,150.765),(23.165,150.915),(23.315,150.915),(23.315,150.765),(23.165,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,150.765),(23.485,150.915),(23.635,150.915),(23.635,150.765),(23.485,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,150.765),(23.805,150.915),(23.955,150.915),(23.955,150.765),(23.805,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,151.085),(22.845,151.235),(22.995,151.235),(22.995,151.085),(22.845,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,151.085),(23.165,151.235),(23.315,151.235),(23.315,151.085),(23.165,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,151.085),(23.485,151.235),(23.635,151.235),(23.635,151.085),(23.485,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,151.085),(23.805,151.235),(23.955,151.235),(23.955,151.085),(23.805,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,151.405),(22.845,151.555),(22.995,151.555),(22.995,151.405),(22.845,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,151.405),(23.165,151.555),(23.315,151.555),(23.315,151.405),(23.165,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,151.405),(23.485,151.555),(23.635,151.555),(23.635,151.405),(23.485,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,151.405),(23.805,151.555),(23.955,151.555),(23.955,151.405),(23.805,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((22.845,151.725),(22.845,151.875),(22.995,151.875),(22.995,151.725),(22.845,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.165,151.725),(23.165,151.875),(23.315,151.875),(23.315,151.725),(23.165,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,151.725),(23.485,151.875),(23.635,151.875),(23.635,151.725),(23.485,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,151.725),(23.805,151.875),(23.955,151.875),(23.955,151.725),(23.805,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,142.125),(37.245,142.275),(37.395,142.275),(37.395,142.125),(37.245,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,142.125),(37.565,142.275),(37.715,142.275),(37.715,142.125),(37.565,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,142.125),(37.885,142.275),(38.035,142.275),(38.035,142.125),(37.885,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,142.125),(38.205,142.275),(38.355,142.275),(38.355,142.125),(38.205,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,142.445),(37.245,142.595),(37.395,142.595),(37.395,142.445),(37.245,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,142.445),(37.565,142.595),(37.715,142.595),(37.715,142.445),(37.565,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,142.445),(37.885,142.595),(38.035,142.595),(38.035,142.445),(37.885,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,142.445),(38.205,142.595),(38.355,142.595),(38.355,142.445),(38.205,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,142.765),(37.245,142.915),(37.395,142.915),(37.395,142.765),(37.245,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,142.765),(37.565,142.915),(37.715,142.915),(37.715,142.765),(37.565,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,142.765),(37.885,142.915),(38.035,142.915),(38.035,142.765),(37.885,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,142.765),(38.205,142.915),(38.355,142.915),(38.355,142.765),(38.205,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,143.085),(37.245,143.235),(37.395,143.235),(37.395,143.085),(37.245,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,143.085),(37.565,143.235),(37.715,143.235),(37.715,143.085),(37.565,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,143.085),(37.885,143.235),(38.035,143.235),(38.035,143.085),(37.885,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,143.085),(38.205,143.235),(38.355,143.235),(38.355,143.085),(38.205,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,143.405),(37.245,143.555),(37.395,143.555),(37.395,143.405),(37.245,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,143.405),(37.565,143.555),(37.715,143.555),(37.715,143.405),(37.565,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,143.405),(37.885,143.555),(38.035,143.555),(38.035,143.405),(37.885,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,143.405),(38.205,143.555),(38.355,143.555),(38.355,143.405),(38.205,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,143.725),(37.245,143.875),(37.395,143.875),(37.395,143.725),(37.245,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,143.725),(37.565,143.875),(37.715,143.875),(37.715,143.725),(37.565,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,143.725),(37.885,143.875),(38.035,143.875),(38.035,143.725),(37.885,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,143.725),(38.205,143.875),(38.355,143.875),(38.355,143.725),(38.205,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,144.045),(37.245,144.195),(37.395,144.195),(37.395,144.045),(37.245,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,144.045),(37.565,144.195),(37.715,144.195),(37.715,144.045),(37.565,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,144.045),(37.885,144.195),(38.035,144.195),(38.035,144.045),(37.885,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,144.045),(38.205,144.195),(38.355,144.195),(38.355,144.045),(38.205,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,144.365),(37.245,144.515),(37.395,144.515),(37.395,144.365),(37.245,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,144.365),(37.565,144.515),(37.715,144.515),(37.715,144.365),(37.565,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,144.365),(37.885,144.515),(38.035,144.515),(38.035,144.365),(37.885,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,144.365),(38.205,144.515),(38.355,144.515),(38.355,144.365),(38.205,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,144.685),(37.245,144.835),(37.395,144.835),(37.395,144.685),(37.245,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,144.685),(37.565,144.835),(37.715,144.835),(37.715,144.685),(37.565,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,144.685),(37.885,144.835),(38.035,144.835),(38.035,144.685),(37.885,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,144.685),(38.205,144.835),(38.355,144.835),(38.355,144.685),(38.205,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,145.005),(37.245,145.155),(37.395,145.155),(37.395,145.005),(37.245,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,145.005),(37.565,145.155),(37.715,145.155),(37.715,145.005),(37.565,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,145.005),(37.885,145.155),(38.035,145.155),(38.035,145.005),(37.885,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,145.005),(38.205,145.155),(38.355,145.155),(38.355,145.005),(38.205,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,145.325),(37.245,145.475),(37.395,145.475),(37.395,145.325),(37.245,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,145.325),(37.565,145.475),(37.715,145.475),(37.715,145.325),(37.565,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,145.325),(37.885,145.475),(38.035,145.475),(38.035,145.325),(37.885,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,145.325),(38.205,145.475),(38.355,145.475),(38.355,145.325),(38.205,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,145.645),(37.245,145.795),(37.395,145.795),(37.395,145.645),(37.245,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,145.645),(37.565,145.795),(37.715,145.795),(37.715,145.645),(37.565,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,145.645),(37.885,145.795),(38.035,145.795),(38.035,145.645),(37.885,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,145.645),(38.205,145.795),(38.355,145.795),(38.355,145.645),(38.205,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,145.965),(37.245,146.115),(37.395,146.115),(37.395,145.965),(37.245,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,145.965),(37.565,146.115),(37.715,146.115),(37.715,145.965),(37.565,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,145.965),(37.885,146.115),(38.035,146.115),(38.035,145.965),(37.885,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,145.965),(38.205,146.115),(38.355,146.115),(38.355,145.965),(38.205,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,146.285),(37.245,146.435),(37.395,146.435),(37.395,146.285),(37.245,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,146.285),(37.565,146.435),(37.715,146.435),(37.715,146.285),(37.565,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,146.285),(37.885,146.435),(38.035,146.435),(38.035,146.285),(37.885,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,146.285),(38.205,146.435),(38.355,146.435),(38.355,146.285),(38.205,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,146.605),(37.245,146.755),(37.395,146.755),(37.395,146.605),(37.245,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,146.605),(37.565,146.755),(37.715,146.755),(37.715,146.605),(37.565,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,146.605),(37.885,146.755),(38.035,146.755),(38.035,146.605),(37.885,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,146.605),(38.205,146.755),(38.355,146.755),(38.355,146.605),(38.205,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,146.925),(37.245,147.075),(37.395,147.075),(37.395,146.925),(37.245,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,146.925),(37.565,147.075),(37.715,147.075),(37.715,146.925),(37.565,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,146.925),(37.885,147.075),(38.035,147.075),(38.035,146.925),(37.885,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,146.925),(38.205,147.075),(38.355,147.075),(38.355,146.925),(38.205,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,147.245),(37.245,147.395),(37.395,147.395),(37.395,147.245),(37.245,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,147.245),(37.565,147.395),(37.715,147.395),(37.715,147.245),(37.565,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,147.245),(37.885,147.395),(38.035,147.395),(38.035,147.245),(37.885,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,147.245),(38.205,147.395),(38.355,147.395),(38.355,147.245),(38.205,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,147.565),(37.245,147.715),(37.395,147.715),(37.395,147.565),(37.245,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,147.565),(37.565,147.715),(37.715,147.715),(37.715,147.565),(37.565,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,147.565),(37.885,147.715),(38.035,147.715),(38.035,147.565),(37.885,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,147.565),(38.205,147.715),(38.355,147.715),(38.355,147.565),(38.205,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,147.885),(37.245,148.035),(37.395,148.035),(37.395,147.885),(37.245,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,147.885),(37.565,148.035),(37.715,148.035),(37.715,147.885),(37.565,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,147.885),(37.885,148.035),(38.035,148.035),(38.035,147.885),(37.885,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,147.885),(38.205,148.035),(38.355,148.035),(38.355,147.885),(38.205,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,148.205),(37.245,148.355),(37.395,148.355),(37.395,148.205),(37.245,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,148.205),(37.565,148.355),(37.715,148.355),(37.715,148.205),(37.565,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,148.205),(37.885,148.355),(38.035,148.355),(38.035,148.205),(37.885,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,148.205),(38.205,148.355),(38.355,148.355),(38.355,148.205),(38.205,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,148.525),(37.245,148.675),(37.395,148.675),(37.395,148.525),(37.245,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,148.525),(37.565,148.675),(37.715,148.675),(37.715,148.525),(37.565,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,148.525),(37.885,148.675),(38.035,148.675),(38.035,148.525),(37.885,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,148.525),(38.205,148.675),(38.355,148.675),(38.355,148.525),(38.205,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,148.845),(37.245,148.995),(37.395,148.995),(37.395,148.845),(37.245,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,148.845),(37.565,148.995),(37.715,148.995),(37.715,148.845),(37.565,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,148.845),(37.885,148.995),(38.035,148.995),(38.035,148.845),(37.885,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,148.845),(38.205,148.995),(38.355,148.995),(38.355,148.845),(38.205,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,149.165),(37.245,149.315),(37.395,149.315),(37.395,149.165),(37.245,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,149.165),(37.565,149.315),(37.715,149.315),(37.715,149.165),(37.565,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,149.165),(37.885,149.315),(38.035,149.315),(38.035,149.165),(37.885,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,149.165),(38.205,149.315),(38.355,149.315),(38.355,149.165),(38.205,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,149.485),(37.245,149.635),(37.395,149.635),(37.395,149.485),(37.245,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,149.485),(37.565,149.635),(37.715,149.635),(37.715,149.485),(37.565,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,149.485),(37.885,149.635),(38.035,149.635),(38.035,149.485),(37.885,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,149.485),(38.205,149.635),(38.355,149.635),(38.355,149.485),(38.205,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,149.805),(37.245,149.955),(37.395,149.955),(37.395,149.805),(37.245,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,149.805),(37.565,149.955),(37.715,149.955),(37.715,149.805),(37.565,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,149.805),(37.885,149.955),(38.035,149.955),(38.035,149.805),(37.885,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,149.805),(38.205,149.955),(38.355,149.955),(38.355,149.805),(38.205,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,150.125),(37.245,150.275),(37.395,150.275),(37.395,150.125),(37.245,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,150.125),(37.565,150.275),(37.715,150.275),(37.715,150.125),(37.565,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,150.125),(37.885,150.275),(38.035,150.275),(38.035,150.125),(37.885,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,150.125),(38.205,150.275),(38.355,150.275),(38.355,150.125),(38.205,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,150.445),(37.245,150.595),(37.395,150.595),(37.395,150.445),(37.245,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,150.445),(37.565,150.595),(37.715,150.595),(37.715,150.445),(37.565,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,150.445),(37.885,150.595),(38.035,150.595),(38.035,150.445),(37.885,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,150.445),(38.205,150.595),(38.355,150.595),(38.355,150.445),(38.205,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,150.765),(37.245,150.915),(37.395,150.915),(37.395,150.765),(37.245,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,150.765),(37.565,150.915),(37.715,150.915),(37.715,150.765),(37.565,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,150.765),(37.885,150.915),(38.035,150.915),(38.035,150.765),(37.885,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,150.765),(38.205,150.915),(38.355,150.915),(38.355,150.765),(38.205,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,151.085),(37.245,151.235),(37.395,151.235),(37.395,151.085),(37.245,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,151.085),(37.565,151.235),(37.715,151.235),(37.715,151.085),(37.565,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,151.085),(37.885,151.235),(38.035,151.235),(38.035,151.085),(37.885,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,151.085),(38.205,151.235),(38.355,151.235),(38.355,151.085),(38.205,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,151.405),(37.245,151.555),(37.395,151.555),(37.395,151.405),(37.245,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,151.405),(37.565,151.555),(37.715,151.555),(37.715,151.405),(37.565,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,151.405),(37.885,151.555),(38.035,151.555),(38.035,151.405),(37.885,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,151.405),(38.205,151.555),(38.355,151.555),(38.355,151.405),(38.205,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,151.725),(37.245,151.875),(37.395,151.875),(37.395,151.725),(37.245,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,151.725),(37.565,151.875),(37.715,151.875),(37.715,151.725),(37.565,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,151.725),(37.885,151.875),(38.035,151.875),(38.035,151.725),(37.885,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,151.725),(38.205,151.875),(38.355,151.875),(38.355,151.725),(38.205,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,142.125),(56.445,142.275),(56.595,142.275),(56.595,142.125),(56.445,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,142.125),(56.765,142.275),(56.915,142.275),(56.915,142.125),(56.765,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,142.125),(57.085,142.275),(57.235,142.275),(57.235,142.125),(57.085,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,142.125),(57.405,142.275),(57.555,142.275),(57.555,142.125),(57.405,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,142.445),(56.445,142.595),(56.595,142.595),(56.595,142.445),(56.445,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,142.445),(56.765,142.595),(56.915,142.595),(56.915,142.445),(56.765,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,142.445),(57.085,142.595),(57.235,142.595),(57.235,142.445),(57.085,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,142.445),(57.405,142.595),(57.555,142.595),(57.555,142.445),(57.405,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,142.765),(56.445,142.915),(56.595,142.915),(56.595,142.765),(56.445,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,142.765),(56.765,142.915),(56.915,142.915),(56.915,142.765),(56.765,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,142.765),(57.085,142.915),(57.235,142.915),(57.235,142.765),(57.085,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,142.765),(57.405,142.915),(57.555,142.915),(57.555,142.765),(57.405,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,143.085),(56.445,143.235),(56.595,143.235),(56.595,143.085),(56.445,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,143.085),(56.765,143.235),(56.915,143.235),(56.915,143.085),(56.765,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,143.085),(57.085,143.235),(57.235,143.235),(57.235,143.085),(57.085,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,143.085),(57.405,143.235),(57.555,143.235),(57.555,143.085),(57.405,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,143.405),(56.445,143.555),(56.595,143.555),(56.595,143.405),(56.445,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,143.405),(56.765,143.555),(56.915,143.555),(56.915,143.405),(56.765,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,143.405),(57.085,143.555),(57.235,143.555),(57.235,143.405),(57.085,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,143.405),(57.405,143.555),(57.555,143.555),(57.555,143.405),(57.405,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,143.725),(56.445,143.875),(56.595,143.875),(56.595,143.725),(56.445,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,143.725),(56.765,143.875),(56.915,143.875),(56.915,143.725),(56.765,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,143.725),(57.085,143.875),(57.235,143.875),(57.235,143.725),(57.085,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,143.725),(57.405,143.875),(57.555,143.875),(57.555,143.725),(57.405,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,144.045),(56.445,144.195),(56.595,144.195),(56.595,144.045),(56.445,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,144.045),(56.765,144.195),(56.915,144.195),(56.915,144.045),(56.765,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,144.045),(57.085,144.195),(57.235,144.195),(57.235,144.045),(57.085,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,144.045),(57.405,144.195),(57.555,144.195),(57.555,144.045),(57.405,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,144.365),(56.445,144.515),(56.595,144.515),(56.595,144.365),(56.445,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,144.365),(56.765,144.515),(56.915,144.515),(56.915,144.365),(56.765,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,144.365),(57.085,144.515),(57.235,144.515),(57.235,144.365),(57.085,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,144.365),(57.405,144.515),(57.555,144.515),(57.555,144.365),(57.405,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,144.685),(56.445,144.835),(56.595,144.835),(56.595,144.685),(56.445,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,144.685),(56.765,144.835),(56.915,144.835),(56.915,144.685),(56.765,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,144.685),(57.085,144.835),(57.235,144.835),(57.235,144.685),(57.085,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,144.685),(57.405,144.835),(57.555,144.835),(57.555,144.685),(57.405,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,145.005),(56.445,145.155),(56.595,145.155),(56.595,145.005),(56.445,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,145.005),(56.765,145.155),(56.915,145.155),(56.915,145.005),(56.765,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,145.005),(57.085,145.155),(57.235,145.155),(57.235,145.005),(57.085,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,145.005),(57.405,145.155),(57.555,145.155),(57.555,145.005),(57.405,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,145.325),(56.445,145.475),(56.595,145.475),(56.595,145.325),(56.445,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,145.325),(56.765,145.475),(56.915,145.475),(56.915,145.325),(56.765,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,145.325),(57.085,145.475),(57.235,145.475),(57.235,145.325),(57.085,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,145.325),(57.405,145.475),(57.555,145.475),(57.555,145.325),(57.405,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,145.645),(56.445,145.795),(56.595,145.795),(56.595,145.645),(56.445,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,145.645),(56.765,145.795),(56.915,145.795),(56.915,145.645),(56.765,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,145.645),(57.085,145.795),(57.235,145.795),(57.235,145.645),(57.085,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,145.645),(57.405,145.795),(57.555,145.795),(57.555,145.645),(57.405,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,145.965),(56.445,146.115),(56.595,146.115),(56.595,145.965),(56.445,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,145.965),(56.765,146.115),(56.915,146.115),(56.915,145.965),(56.765,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,145.965),(57.085,146.115),(57.235,146.115),(57.235,145.965),(57.085,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,145.965),(57.405,146.115),(57.555,146.115),(57.555,145.965),(57.405,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,146.285),(56.445,146.435),(56.595,146.435),(56.595,146.285),(56.445,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,146.285),(56.765,146.435),(56.915,146.435),(56.915,146.285),(56.765,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,146.285),(57.085,146.435),(57.235,146.435),(57.235,146.285),(57.085,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,146.285),(57.405,146.435),(57.555,146.435),(57.555,146.285),(57.405,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,146.605),(56.445,146.755),(56.595,146.755),(56.595,146.605),(56.445,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,146.605),(56.765,146.755),(56.915,146.755),(56.915,146.605),(56.765,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,146.605),(57.085,146.755),(57.235,146.755),(57.235,146.605),(57.085,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,146.605),(57.405,146.755),(57.555,146.755),(57.555,146.605),(57.405,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,146.925),(56.445,147.075),(56.595,147.075),(56.595,146.925),(56.445,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,146.925),(56.765,147.075),(56.915,147.075),(56.915,146.925),(56.765,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,146.925),(57.085,147.075),(57.235,147.075),(57.235,146.925),(57.085,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,146.925),(57.405,147.075),(57.555,147.075),(57.555,146.925),(57.405,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,147.245),(56.445,147.395),(56.595,147.395),(56.595,147.245),(56.445,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,147.245),(56.765,147.395),(56.915,147.395),(56.915,147.245),(56.765,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,147.245),(57.085,147.395),(57.235,147.395),(57.235,147.245),(57.085,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,147.245),(57.405,147.395),(57.555,147.395),(57.555,147.245),(57.405,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,147.565),(56.445,147.715),(56.595,147.715),(56.595,147.565),(56.445,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,147.565),(56.765,147.715),(56.915,147.715),(56.915,147.565),(56.765,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,147.565),(57.085,147.715),(57.235,147.715),(57.235,147.565),(57.085,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,147.565),(57.405,147.715),(57.555,147.715),(57.555,147.565),(57.405,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,147.885),(56.445,148.035),(56.595,148.035),(56.595,147.885),(56.445,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,147.885),(56.765,148.035),(56.915,148.035),(56.915,147.885),(56.765,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,147.885),(57.085,148.035),(57.235,148.035),(57.235,147.885),(57.085,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,147.885),(57.405,148.035),(57.555,148.035),(57.555,147.885),(57.405,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,148.205),(56.445,148.355),(56.595,148.355),(56.595,148.205),(56.445,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,148.205),(56.765,148.355),(56.915,148.355),(56.915,148.205),(56.765,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,148.205),(57.085,148.355),(57.235,148.355),(57.235,148.205),(57.085,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,148.205),(57.405,148.355),(57.555,148.355),(57.555,148.205),(57.405,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,148.525),(56.445,148.675),(56.595,148.675),(56.595,148.525),(56.445,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,148.525),(56.765,148.675),(56.915,148.675),(56.915,148.525),(56.765,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,148.525),(57.085,148.675),(57.235,148.675),(57.235,148.525),(57.085,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,148.525),(57.405,148.675),(57.555,148.675),(57.555,148.525),(57.405,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,148.845),(56.445,148.995),(56.595,148.995),(56.595,148.845),(56.445,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,148.845),(56.765,148.995),(56.915,148.995),(56.915,148.845),(56.765,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,148.845),(57.085,148.995),(57.235,148.995),(57.235,148.845),(57.085,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,148.845),(57.405,148.995),(57.555,148.995),(57.555,148.845),(57.405,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,149.165),(56.445,149.315),(56.595,149.315),(56.595,149.165),(56.445,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,149.165),(56.765,149.315),(56.915,149.315),(56.915,149.165),(56.765,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,149.165),(57.085,149.315),(57.235,149.315),(57.235,149.165),(57.085,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,149.165),(57.405,149.315),(57.555,149.315),(57.555,149.165),(57.405,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,149.485),(56.445,149.635),(56.595,149.635),(56.595,149.485),(56.445,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,149.485),(56.765,149.635),(56.915,149.635),(56.915,149.485),(56.765,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,149.485),(57.085,149.635),(57.235,149.635),(57.235,149.485),(57.085,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,149.485),(57.405,149.635),(57.555,149.635),(57.555,149.485),(57.405,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,149.805),(56.445,149.955),(56.595,149.955),(56.595,149.805),(56.445,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,149.805),(56.765,149.955),(56.915,149.955),(56.915,149.805),(56.765,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,149.805),(57.085,149.955),(57.235,149.955),(57.235,149.805),(57.085,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,149.805),(57.405,149.955),(57.555,149.955),(57.555,149.805),(57.405,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,150.125),(56.445,150.275),(56.595,150.275),(56.595,150.125),(56.445,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,150.125),(56.765,150.275),(56.915,150.275),(56.915,150.125),(56.765,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,150.125),(57.085,150.275),(57.235,150.275),(57.235,150.125),(57.085,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,150.125),(57.405,150.275),(57.555,150.275),(57.555,150.125),(57.405,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,150.445),(56.445,150.595),(56.595,150.595),(56.595,150.445),(56.445,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,150.445),(56.765,150.595),(56.915,150.595),(56.915,150.445),(56.765,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,150.445),(57.085,150.595),(57.235,150.595),(57.235,150.445),(57.085,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,150.445),(57.405,150.595),(57.555,150.595),(57.555,150.445),(57.405,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,150.765),(56.445,150.915),(56.595,150.915),(56.595,150.765),(56.445,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,150.765),(56.765,150.915),(56.915,150.915),(56.915,150.765),(56.765,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,150.765),(57.085,150.915),(57.235,150.915),(57.235,150.765),(57.085,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,150.765),(57.405,150.915),(57.555,150.915),(57.555,150.765),(57.405,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,151.085),(56.445,151.235),(56.595,151.235),(56.595,151.085),(56.445,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,151.085),(56.765,151.235),(56.915,151.235),(56.915,151.085),(56.765,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,151.085),(57.085,151.235),(57.235,151.235),(57.235,151.085),(57.085,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,151.085),(57.405,151.235),(57.555,151.235),(57.555,151.085),(57.405,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,151.405),(56.445,151.555),(56.595,151.555),(56.595,151.405),(56.445,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,151.405),(56.765,151.555),(56.915,151.555),(56.915,151.405),(56.765,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,151.405),(57.085,151.555),(57.235,151.555),(57.235,151.405),(57.085,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,151.405),(57.405,151.555),(57.555,151.555),(57.555,151.405),(57.405,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,151.725),(56.445,151.875),(56.595,151.875),(56.595,151.725),(56.445,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,151.725),(56.765,151.875),(56.915,151.875),(56.915,151.725),(56.765,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,151.725),(57.085,151.875),(57.235,151.875),(57.235,151.725),(57.085,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,151.725),(57.405,151.875),(57.555,151.875),(57.555,151.725),(57.405,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,142.125),(32.445,142.275),(32.595,142.275),(32.595,142.125),(32.445,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,142.125),(32.765,142.275),(32.915,142.275),(32.915,142.125),(32.765,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,142.125),(33.085,142.275),(33.235,142.275),(33.235,142.125),(33.085,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,142.125),(33.405,142.275),(33.555,142.275),(33.555,142.125),(33.405,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,142.445),(32.445,142.595),(32.595,142.595),(32.595,142.445),(32.445,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,142.445),(32.765,142.595),(32.915,142.595),(32.915,142.445),(32.765,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,142.445),(33.085,142.595),(33.235,142.595),(33.235,142.445),(33.085,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,142.445),(33.405,142.595),(33.555,142.595),(33.555,142.445),(33.405,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,142.765),(32.445,142.915),(32.595,142.915),(32.595,142.765),(32.445,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,142.765),(32.765,142.915),(32.915,142.915),(32.915,142.765),(32.765,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,142.765),(33.085,142.915),(33.235,142.915),(33.235,142.765),(33.085,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,142.765),(33.405,142.915),(33.555,142.915),(33.555,142.765),(33.405,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,143.085),(32.445,143.235),(32.595,143.235),(32.595,143.085),(32.445,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,143.085),(32.765,143.235),(32.915,143.235),(32.915,143.085),(32.765,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,143.085),(33.085,143.235),(33.235,143.235),(33.235,143.085),(33.085,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,143.085),(33.405,143.235),(33.555,143.235),(33.555,143.085),(33.405,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,143.405),(32.445,143.555),(32.595,143.555),(32.595,143.405),(32.445,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,143.405),(32.765,143.555),(32.915,143.555),(32.915,143.405),(32.765,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,143.405),(33.085,143.555),(33.235,143.555),(33.235,143.405),(33.085,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,143.405),(33.405,143.555),(33.555,143.555),(33.555,143.405),(33.405,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,143.725),(32.445,143.875),(32.595,143.875),(32.595,143.725),(32.445,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,143.725),(32.765,143.875),(32.915,143.875),(32.915,143.725),(32.765,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,143.725),(33.085,143.875),(33.235,143.875),(33.235,143.725),(33.085,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,143.725),(33.405,143.875),(33.555,143.875),(33.555,143.725),(33.405,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,144.045),(32.445,144.195),(32.595,144.195),(32.595,144.045),(32.445,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,144.045),(32.765,144.195),(32.915,144.195),(32.915,144.045),(32.765,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,144.045),(33.085,144.195),(33.235,144.195),(33.235,144.045),(33.085,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,144.045),(33.405,144.195),(33.555,144.195),(33.555,144.045),(33.405,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,144.365),(32.445,144.515),(32.595,144.515),(32.595,144.365),(32.445,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,144.365),(32.765,144.515),(32.915,144.515),(32.915,144.365),(32.765,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,144.365),(33.085,144.515),(33.235,144.515),(33.235,144.365),(33.085,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,144.365),(33.405,144.515),(33.555,144.515),(33.555,144.365),(33.405,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,144.685),(32.445,144.835),(32.595,144.835),(32.595,144.685),(32.445,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,144.685),(32.765,144.835),(32.915,144.835),(32.915,144.685),(32.765,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,144.685),(33.085,144.835),(33.235,144.835),(33.235,144.685),(33.085,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,144.685),(33.405,144.835),(33.555,144.835),(33.555,144.685),(33.405,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,145.005),(32.445,145.155),(32.595,145.155),(32.595,145.005),(32.445,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,145.005),(32.765,145.155),(32.915,145.155),(32.915,145.005),(32.765,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,145.005),(33.085,145.155),(33.235,145.155),(33.235,145.005),(33.085,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,145.005),(33.405,145.155),(33.555,145.155),(33.555,145.005),(33.405,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,145.325),(32.445,145.475),(32.595,145.475),(32.595,145.325),(32.445,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,145.325),(32.765,145.475),(32.915,145.475),(32.915,145.325),(32.765,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,145.325),(33.085,145.475),(33.235,145.475),(33.235,145.325),(33.085,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,145.325),(33.405,145.475),(33.555,145.475),(33.555,145.325),(33.405,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,145.645),(32.445,145.795),(32.595,145.795),(32.595,145.645),(32.445,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,145.645),(32.765,145.795),(32.915,145.795),(32.915,145.645),(32.765,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,145.645),(33.085,145.795),(33.235,145.795),(33.235,145.645),(33.085,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,145.645),(33.405,145.795),(33.555,145.795),(33.555,145.645),(33.405,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,145.965),(32.445,146.115),(32.595,146.115),(32.595,145.965),(32.445,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,145.965),(32.765,146.115),(32.915,146.115),(32.915,145.965),(32.765,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,145.965),(33.085,146.115),(33.235,146.115),(33.235,145.965),(33.085,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,145.965),(33.405,146.115),(33.555,146.115),(33.555,145.965),(33.405,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,146.285),(32.445,146.435),(32.595,146.435),(32.595,146.285),(32.445,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,146.285),(32.765,146.435),(32.915,146.435),(32.915,146.285),(32.765,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,146.285),(33.085,146.435),(33.235,146.435),(33.235,146.285),(33.085,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,146.285),(33.405,146.435),(33.555,146.435),(33.555,146.285),(33.405,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,146.605),(32.445,146.755),(32.595,146.755),(32.595,146.605),(32.445,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,146.605),(32.765,146.755),(32.915,146.755),(32.915,146.605),(32.765,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,146.605),(33.085,146.755),(33.235,146.755),(33.235,146.605),(33.085,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,146.605),(33.405,146.755),(33.555,146.755),(33.555,146.605),(33.405,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,146.925),(32.445,147.075),(32.595,147.075),(32.595,146.925),(32.445,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,146.925),(32.765,147.075),(32.915,147.075),(32.915,146.925),(32.765,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,146.925),(33.085,147.075),(33.235,147.075),(33.235,146.925),(33.085,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,146.925),(33.405,147.075),(33.555,147.075),(33.555,146.925),(33.405,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,147.245),(32.445,147.395),(32.595,147.395),(32.595,147.245),(32.445,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,147.245),(32.765,147.395),(32.915,147.395),(32.915,147.245),(32.765,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,147.245),(33.085,147.395),(33.235,147.395),(33.235,147.245),(33.085,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,147.245),(33.405,147.395),(33.555,147.395),(33.555,147.245),(33.405,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,147.565),(32.445,147.715),(32.595,147.715),(32.595,147.565),(32.445,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,147.565),(32.765,147.715),(32.915,147.715),(32.915,147.565),(32.765,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,147.565),(33.085,147.715),(33.235,147.715),(33.235,147.565),(33.085,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,147.565),(33.405,147.715),(33.555,147.715),(33.555,147.565),(33.405,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,147.885),(32.445,148.035),(32.595,148.035),(32.595,147.885),(32.445,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,147.885),(32.765,148.035),(32.915,148.035),(32.915,147.885),(32.765,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,147.885),(33.085,148.035),(33.235,148.035),(33.235,147.885),(33.085,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,147.885),(33.405,148.035),(33.555,148.035),(33.555,147.885),(33.405,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,148.205),(32.445,148.355),(32.595,148.355),(32.595,148.205),(32.445,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,148.205),(32.765,148.355),(32.915,148.355),(32.915,148.205),(32.765,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,148.205),(33.085,148.355),(33.235,148.355),(33.235,148.205),(33.085,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,148.205),(33.405,148.355),(33.555,148.355),(33.555,148.205),(33.405,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,148.525),(32.445,148.675),(32.595,148.675),(32.595,148.525),(32.445,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,148.525),(32.765,148.675),(32.915,148.675),(32.915,148.525),(32.765,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,148.525),(33.085,148.675),(33.235,148.675),(33.235,148.525),(33.085,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,148.525),(33.405,148.675),(33.555,148.675),(33.555,148.525),(33.405,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,148.845),(32.445,148.995),(32.595,148.995),(32.595,148.845),(32.445,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,148.845),(32.765,148.995),(32.915,148.995),(32.915,148.845),(32.765,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,148.845),(33.085,148.995),(33.235,148.995),(33.235,148.845),(33.085,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,148.845),(33.405,148.995),(33.555,148.995),(33.555,148.845),(33.405,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,149.165),(32.445,149.315),(32.595,149.315),(32.595,149.165),(32.445,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,149.165),(32.765,149.315),(32.915,149.315),(32.915,149.165),(32.765,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,149.165),(33.085,149.315),(33.235,149.315),(33.235,149.165),(33.085,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,149.165),(33.405,149.315),(33.555,149.315),(33.555,149.165),(33.405,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,149.485),(32.445,149.635),(32.595,149.635),(32.595,149.485),(32.445,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,149.485),(32.765,149.635),(32.915,149.635),(32.915,149.485),(32.765,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,149.485),(33.085,149.635),(33.235,149.635),(33.235,149.485),(33.085,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,149.485),(33.405,149.635),(33.555,149.635),(33.555,149.485),(33.405,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,149.805),(32.445,149.955),(32.595,149.955),(32.595,149.805),(32.445,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,149.805),(32.765,149.955),(32.915,149.955),(32.915,149.805),(32.765,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,149.805),(33.085,149.955),(33.235,149.955),(33.235,149.805),(33.085,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,149.805),(33.405,149.955),(33.555,149.955),(33.555,149.805),(33.405,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,150.125),(32.445,150.275),(32.595,150.275),(32.595,150.125),(32.445,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,150.125),(32.765,150.275),(32.915,150.275),(32.915,150.125),(32.765,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,150.125),(33.085,150.275),(33.235,150.275),(33.235,150.125),(33.085,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,150.125),(33.405,150.275),(33.555,150.275),(33.555,150.125),(33.405,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,150.445),(32.445,150.595),(32.595,150.595),(32.595,150.445),(32.445,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,150.445),(32.765,150.595),(32.915,150.595),(32.915,150.445),(32.765,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,150.445),(33.085,150.595),(33.235,150.595),(33.235,150.445),(33.085,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,150.445),(33.405,150.595),(33.555,150.595),(33.555,150.445),(33.405,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,150.765),(32.445,150.915),(32.595,150.915),(32.595,150.765),(32.445,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,150.765),(32.765,150.915),(32.915,150.915),(32.915,150.765),(32.765,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,150.765),(33.085,150.915),(33.235,150.915),(33.235,150.765),(33.085,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,150.765),(33.405,150.915),(33.555,150.915),(33.555,150.765),(33.405,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,151.085),(32.445,151.235),(32.595,151.235),(32.595,151.085),(32.445,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,151.085),(32.765,151.235),(32.915,151.235),(32.915,151.085),(32.765,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,151.085),(33.085,151.235),(33.235,151.235),(33.235,151.085),(33.085,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,151.085),(33.405,151.235),(33.555,151.235),(33.555,151.085),(33.405,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,151.405),(32.445,151.555),(32.595,151.555),(32.595,151.405),(32.445,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,151.405),(32.765,151.555),(32.915,151.555),(32.915,151.405),(32.765,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,151.405),(33.085,151.555),(33.235,151.555),(33.235,151.405),(33.085,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,151.405),(33.405,151.555),(33.555,151.555),(33.555,151.405),(33.405,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,151.725),(32.445,151.875),(32.595,151.875),(32.595,151.725),(32.445,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,151.725),(32.765,151.875),(32.915,151.875),(32.915,151.725),(32.765,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,151.725),(33.085,151.875),(33.235,151.875),(33.235,151.725),(33.085,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,151.725),(33.405,151.875),(33.555,151.875),(33.555,151.725),(33.405,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,142.125),(27.645,142.275),(27.795,142.275),(27.795,142.125),(27.645,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,142.125),(27.965,142.275),(28.115,142.275),(28.115,142.125),(27.965,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,142.125),(28.285,142.275),(28.435,142.275),(28.435,142.125),(28.285,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,142.125),(28.605,142.275),(28.755,142.275),(28.755,142.125),(28.605,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,142.445),(27.645,142.595),(27.795,142.595),(27.795,142.445),(27.645,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,142.445),(27.965,142.595),(28.115,142.595),(28.115,142.445),(27.965,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,142.445),(28.285,142.595),(28.435,142.595),(28.435,142.445),(28.285,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,142.445),(28.605,142.595),(28.755,142.595),(28.755,142.445),(28.605,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,142.765),(27.645,142.915),(27.795,142.915),(27.795,142.765),(27.645,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,142.765),(27.965,142.915),(28.115,142.915),(28.115,142.765),(27.965,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,142.765),(28.285,142.915),(28.435,142.915),(28.435,142.765),(28.285,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,142.765),(28.605,142.915),(28.755,142.915),(28.755,142.765),(28.605,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,143.085),(27.645,143.235),(27.795,143.235),(27.795,143.085),(27.645,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,143.085),(27.965,143.235),(28.115,143.235),(28.115,143.085),(27.965,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,143.085),(28.285,143.235),(28.435,143.235),(28.435,143.085),(28.285,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,143.085),(28.605,143.235),(28.755,143.235),(28.755,143.085),(28.605,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,143.405),(27.645,143.555),(27.795,143.555),(27.795,143.405),(27.645,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,143.405),(27.965,143.555),(28.115,143.555),(28.115,143.405),(27.965,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,143.405),(28.285,143.555),(28.435,143.555),(28.435,143.405),(28.285,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,143.405),(28.605,143.555),(28.755,143.555),(28.755,143.405),(28.605,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,143.725),(27.645,143.875),(27.795,143.875),(27.795,143.725),(27.645,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,143.725),(27.965,143.875),(28.115,143.875),(28.115,143.725),(27.965,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,143.725),(28.285,143.875),(28.435,143.875),(28.435,143.725),(28.285,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,143.725),(28.605,143.875),(28.755,143.875),(28.755,143.725),(28.605,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,144.045),(27.645,144.195),(27.795,144.195),(27.795,144.045),(27.645,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,144.045),(27.965,144.195),(28.115,144.195),(28.115,144.045),(27.965,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,144.045),(28.285,144.195),(28.435,144.195),(28.435,144.045),(28.285,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,144.045),(28.605,144.195),(28.755,144.195),(28.755,144.045),(28.605,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,144.365),(27.645,144.515),(27.795,144.515),(27.795,144.365),(27.645,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,144.365),(27.965,144.515),(28.115,144.515),(28.115,144.365),(27.965,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,144.365),(28.285,144.515),(28.435,144.515),(28.435,144.365),(28.285,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,144.365),(28.605,144.515),(28.755,144.515),(28.755,144.365),(28.605,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,144.685),(27.645,144.835),(27.795,144.835),(27.795,144.685),(27.645,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,144.685),(27.965,144.835),(28.115,144.835),(28.115,144.685),(27.965,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,144.685),(28.285,144.835),(28.435,144.835),(28.435,144.685),(28.285,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,144.685),(28.605,144.835),(28.755,144.835),(28.755,144.685),(28.605,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,145.005),(27.645,145.155),(27.795,145.155),(27.795,145.005),(27.645,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,145.005),(27.965,145.155),(28.115,145.155),(28.115,145.005),(27.965,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,145.005),(28.285,145.155),(28.435,145.155),(28.435,145.005),(28.285,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,145.005),(28.605,145.155),(28.755,145.155),(28.755,145.005),(28.605,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,145.325),(27.645,145.475),(27.795,145.475),(27.795,145.325),(27.645,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,145.325),(27.965,145.475),(28.115,145.475),(28.115,145.325),(27.965,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,145.325),(28.285,145.475),(28.435,145.475),(28.435,145.325),(28.285,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,145.325),(28.605,145.475),(28.755,145.475),(28.755,145.325),(28.605,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,145.645),(27.645,145.795),(27.795,145.795),(27.795,145.645),(27.645,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,145.645),(27.965,145.795),(28.115,145.795),(28.115,145.645),(27.965,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,145.645),(28.285,145.795),(28.435,145.795),(28.435,145.645),(28.285,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,145.645),(28.605,145.795),(28.755,145.795),(28.755,145.645),(28.605,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,145.965),(27.645,146.115),(27.795,146.115),(27.795,145.965),(27.645,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,145.965),(27.965,146.115),(28.115,146.115),(28.115,145.965),(27.965,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,145.965),(28.285,146.115),(28.435,146.115),(28.435,145.965),(28.285,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,145.965),(28.605,146.115),(28.755,146.115),(28.755,145.965),(28.605,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,146.285),(27.645,146.435),(27.795,146.435),(27.795,146.285),(27.645,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,146.285),(27.965,146.435),(28.115,146.435),(28.115,146.285),(27.965,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,146.285),(28.285,146.435),(28.435,146.435),(28.435,146.285),(28.285,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,146.285),(28.605,146.435),(28.755,146.435),(28.755,146.285),(28.605,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,146.605),(27.645,146.755),(27.795,146.755),(27.795,146.605),(27.645,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,146.605),(27.965,146.755),(28.115,146.755),(28.115,146.605),(27.965,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,146.605),(28.285,146.755),(28.435,146.755),(28.435,146.605),(28.285,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,146.605),(28.605,146.755),(28.755,146.755),(28.755,146.605),(28.605,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,146.925),(27.645,147.075),(27.795,147.075),(27.795,146.925),(27.645,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,146.925),(27.965,147.075),(28.115,147.075),(28.115,146.925),(27.965,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,146.925),(28.285,147.075),(28.435,147.075),(28.435,146.925),(28.285,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,146.925),(28.605,147.075),(28.755,147.075),(28.755,146.925),(28.605,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,147.245),(27.645,147.395),(27.795,147.395),(27.795,147.245),(27.645,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,147.245),(27.965,147.395),(28.115,147.395),(28.115,147.245),(27.965,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,147.245),(28.285,147.395),(28.435,147.395),(28.435,147.245),(28.285,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,147.245),(28.605,147.395),(28.755,147.395),(28.755,147.245),(28.605,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,147.565),(27.645,147.715),(27.795,147.715),(27.795,147.565),(27.645,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,147.565),(27.965,147.715),(28.115,147.715),(28.115,147.565),(27.965,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,147.565),(28.285,147.715),(28.435,147.715),(28.435,147.565),(28.285,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,147.565),(28.605,147.715),(28.755,147.715),(28.755,147.565),(28.605,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,147.885),(27.645,148.035),(27.795,148.035),(27.795,147.885),(27.645,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,147.885),(27.965,148.035),(28.115,148.035),(28.115,147.885),(27.965,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,147.885),(28.285,148.035),(28.435,148.035),(28.435,147.885),(28.285,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,147.885),(28.605,148.035),(28.755,148.035),(28.755,147.885),(28.605,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,148.205),(27.645,148.355),(27.795,148.355),(27.795,148.205),(27.645,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,148.205),(27.965,148.355),(28.115,148.355),(28.115,148.205),(27.965,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,148.205),(28.285,148.355),(28.435,148.355),(28.435,148.205),(28.285,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,148.205),(28.605,148.355),(28.755,148.355),(28.755,148.205),(28.605,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,148.525),(27.645,148.675),(27.795,148.675),(27.795,148.525),(27.645,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,148.525),(27.965,148.675),(28.115,148.675),(28.115,148.525),(27.965,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,148.525),(28.285,148.675),(28.435,148.675),(28.435,148.525),(28.285,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,148.525),(28.605,148.675),(28.755,148.675),(28.755,148.525),(28.605,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,148.845),(27.645,148.995),(27.795,148.995),(27.795,148.845),(27.645,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,148.845),(27.965,148.995),(28.115,148.995),(28.115,148.845),(27.965,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,148.845),(28.285,148.995),(28.435,148.995),(28.435,148.845),(28.285,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,148.845),(28.605,148.995),(28.755,148.995),(28.755,148.845),(28.605,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,149.165),(27.645,149.315),(27.795,149.315),(27.795,149.165),(27.645,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,149.165),(27.965,149.315),(28.115,149.315),(28.115,149.165),(27.965,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,149.165),(28.285,149.315),(28.435,149.315),(28.435,149.165),(28.285,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,149.165),(28.605,149.315),(28.755,149.315),(28.755,149.165),(28.605,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,149.485),(27.645,149.635),(27.795,149.635),(27.795,149.485),(27.645,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,149.485),(27.965,149.635),(28.115,149.635),(28.115,149.485),(27.965,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,149.485),(28.285,149.635),(28.435,149.635),(28.435,149.485),(28.285,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,149.485),(28.605,149.635),(28.755,149.635),(28.755,149.485),(28.605,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,149.805),(27.645,149.955),(27.795,149.955),(27.795,149.805),(27.645,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,149.805),(27.965,149.955),(28.115,149.955),(28.115,149.805),(27.965,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,149.805),(28.285,149.955),(28.435,149.955),(28.435,149.805),(28.285,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,149.805),(28.605,149.955),(28.755,149.955),(28.755,149.805),(28.605,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,150.125),(27.645,150.275),(27.795,150.275),(27.795,150.125),(27.645,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,150.125),(27.965,150.275),(28.115,150.275),(28.115,150.125),(27.965,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,150.125),(28.285,150.275),(28.435,150.275),(28.435,150.125),(28.285,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,150.125),(28.605,150.275),(28.755,150.275),(28.755,150.125),(28.605,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,150.445),(27.645,150.595),(27.795,150.595),(27.795,150.445),(27.645,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,150.445),(27.965,150.595),(28.115,150.595),(28.115,150.445),(27.965,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,150.445),(28.285,150.595),(28.435,150.595),(28.435,150.445),(28.285,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,150.445),(28.605,150.595),(28.755,150.595),(28.755,150.445),(28.605,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,150.765),(27.645,150.915),(27.795,150.915),(27.795,150.765),(27.645,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,150.765),(27.965,150.915),(28.115,150.915),(28.115,150.765),(27.965,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,150.765),(28.285,150.915),(28.435,150.915),(28.435,150.765),(28.285,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,150.765),(28.605,150.915),(28.755,150.915),(28.755,150.765),(28.605,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,151.085),(27.645,151.235),(27.795,151.235),(27.795,151.085),(27.645,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,151.085),(27.965,151.235),(28.115,151.235),(28.115,151.085),(27.965,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,151.085),(28.285,151.235),(28.435,151.235),(28.435,151.085),(28.285,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,151.085),(28.605,151.235),(28.755,151.235),(28.755,151.085),(28.605,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,151.405),(27.645,151.555),(27.795,151.555),(27.795,151.405),(27.645,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,151.405),(27.965,151.555),(28.115,151.555),(28.115,151.405),(27.965,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,151.405),(28.285,151.555),(28.435,151.555),(28.435,151.405),(28.285,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,151.405),(28.605,151.555),(28.755,151.555),(28.755,151.405),(28.605,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,151.725),(27.645,151.875),(27.795,151.875),(27.795,151.725),(27.645,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,151.725),(27.965,151.875),(28.115,151.875),(28.115,151.725),(27.965,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,151.725),(28.285,151.875),(28.435,151.875),(28.435,151.725),(28.285,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,151.725),(28.605,151.875),(28.755,151.875),(28.755,151.725),(28.605,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,142.125),(75.645,142.275),(75.795,142.275),(75.795,142.125),(75.645,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,142.125),(75.965,142.275),(76.115,142.275),(76.115,142.125),(75.965,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,142.125),(76.285,142.275),(76.435,142.275),(76.435,142.125),(76.285,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,142.125),(76.605,142.275),(76.755,142.275),(76.755,142.125),(76.605,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,142.445),(75.645,142.595),(75.795,142.595),(75.795,142.445),(75.645,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,142.445),(75.965,142.595),(76.115,142.595),(76.115,142.445),(75.965,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,142.445),(76.285,142.595),(76.435,142.595),(76.435,142.445),(76.285,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,142.445),(76.605,142.595),(76.755,142.595),(76.755,142.445),(76.605,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,142.765),(75.645,142.915),(75.795,142.915),(75.795,142.765),(75.645,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,142.765),(75.965,142.915),(76.115,142.915),(76.115,142.765),(75.965,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,142.765),(76.285,142.915),(76.435,142.915),(76.435,142.765),(76.285,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,142.765),(76.605,142.915),(76.755,142.915),(76.755,142.765),(76.605,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,143.085),(75.645,143.235),(75.795,143.235),(75.795,143.085),(75.645,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,143.085),(75.965,143.235),(76.115,143.235),(76.115,143.085),(75.965,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,143.085),(76.285,143.235),(76.435,143.235),(76.435,143.085),(76.285,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,143.085),(76.605,143.235),(76.755,143.235),(76.755,143.085),(76.605,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,143.405),(75.645,143.555),(75.795,143.555),(75.795,143.405),(75.645,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,143.405),(75.965,143.555),(76.115,143.555),(76.115,143.405),(75.965,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,143.405),(76.285,143.555),(76.435,143.555),(76.435,143.405),(76.285,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,143.405),(76.605,143.555),(76.755,143.555),(76.755,143.405),(76.605,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,143.725),(75.645,143.875),(75.795,143.875),(75.795,143.725),(75.645,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,143.725),(75.965,143.875),(76.115,143.875),(76.115,143.725),(75.965,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,143.725),(76.285,143.875),(76.435,143.875),(76.435,143.725),(76.285,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,143.725),(76.605,143.875),(76.755,143.875),(76.755,143.725),(76.605,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,144.045),(75.645,144.195),(75.795,144.195),(75.795,144.045),(75.645,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,144.045),(75.965,144.195),(76.115,144.195),(76.115,144.045),(75.965,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,144.045),(76.285,144.195),(76.435,144.195),(76.435,144.045),(76.285,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,144.045),(76.605,144.195),(76.755,144.195),(76.755,144.045),(76.605,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,144.365),(75.645,144.515),(75.795,144.515),(75.795,144.365),(75.645,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,144.365),(75.965,144.515),(76.115,144.515),(76.115,144.365),(75.965,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,144.365),(76.285,144.515),(76.435,144.515),(76.435,144.365),(76.285,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,144.365),(76.605,144.515),(76.755,144.515),(76.755,144.365),(76.605,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,144.685),(75.645,144.835),(75.795,144.835),(75.795,144.685),(75.645,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,144.685),(75.965,144.835),(76.115,144.835),(76.115,144.685),(75.965,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,144.685),(76.285,144.835),(76.435,144.835),(76.435,144.685),(76.285,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,144.685),(76.605,144.835),(76.755,144.835),(76.755,144.685),(76.605,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,145.005),(75.645,145.155),(75.795,145.155),(75.795,145.005),(75.645,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,145.005),(75.965,145.155),(76.115,145.155),(76.115,145.005),(75.965,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,145.005),(76.285,145.155),(76.435,145.155),(76.435,145.005),(76.285,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,145.005),(76.605,145.155),(76.755,145.155),(76.755,145.005),(76.605,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,145.325),(75.645,145.475),(75.795,145.475),(75.795,145.325),(75.645,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,145.325),(75.965,145.475),(76.115,145.475),(76.115,145.325),(75.965,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,145.325),(76.285,145.475),(76.435,145.475),(76.435,145.325),(76.285,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,145.325),(76.605,145.475),(76.755,145.475),(76.755,145.325),(76.605,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,145.645),(75.645,145.795),(75.795,145.795),(75.795,145.645),(75.645,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,145.645),(75.965,145.795),(76.115,145.795),(76.115,145.645),(75.965,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,145.645),(76.285,145.795),(76.435,145.795),(76.435,145.645),(76.285,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,145.645),(76.605,145.795),(76.755,145.795),(76.755,145.645),(76.605,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,145.965),(75.645,146.115),(75.795,146.115),(75.795,145.965),(75.645,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,145.965),(75.965,146.115),(76.115,146.115),(76.115,145.965),(75.965,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,145.965),(76.285,146.115),(76.435,146.115),(76.435,145.965),(76.285,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,145.965),(76.605,146.115),(76.755,146.115),(76.755,145.965),(76.605,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,146.285),(75.645,146.435),(75.795,146.435),(75.795,146.285),(75.645,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,146.285),(75.965,146.435),(76.115,146.435),(76.115,146.285),(75.965,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,146.285),(76.285,146.435),(76.435,146.435),(76.435,146.285),(76.285,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,146.285),(76.605,146.435),(76.755,146.435),(76.755,146.285),(76.605,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,146.605),(75.645,146.755),(75.795,146.755),(75.795,146.605),(75.645,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,146.605),(75.965,146.755),(76.115,146.755),(76.115,146.605),(75.965,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,146.605),(76.285,146.755),(76.435,146.755),(76.435,146.605),(76.285,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,146.605),(76.605,146.755),(76.755,146.755),(76.755,146.605),(76.605,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,146.925),(75.645,147.075),(75.795,147.075),(75.795,146.925),(75.645,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,146.925),(75.965,147.075),(76.115,147.075),(76.115,146.925),(75.965,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,146.925),(76.285,147.075),(76.435,147.075),(76.435,146.925),(76.285,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,146.925),(76.605,147.075),(76.755,147.075),(76.755,146.925),(76.605,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,147.245),(75.645,147.395),(75.795,147.395),(75.795,147.245),(75.645,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,147.245),(75.965,147.395),(76.115,147.395),(76.115,147.245),(75.965,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,147.245),(76.285,147.395),(76.435,147.395),(76.435,147.245),(76.285,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,147.245),(76.605,147.395),(76.755,147.395),(76.755,147.245),(76.605,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,147.565),(75.645,147.715),(75.795,147.715),(75.795,147.565),(75.645,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,147.565),(75.965,147.715),(76.115,147.715),(76.115,147.565),(75.965,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,147.565),(76.285,147.715),(76.435,147.715),(76.435,147.565),(76.285,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,147.565),(76.605,147.715),(76.755,147.715),(76.755,147.565),(76.605,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,147.885),(75.645,148.035),(75.795,148.035),(75.795,147.885),(75.645,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,147.885),(75.965,148.035),(76.115,148.035),(76.115,147.885),(75.965,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,147.885),(76.285,148.035),(76.435,148.035),(76.435,147.885),(76.285,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,147.885),(76.605,148.035),(76.755,148.035),(76.755,147.885),(76.605,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,148.205),(75.645,148.355),(75.795,148.355),(75.795,148.205),(75.645,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,148.205),(75.965,148.355),(76.115,148.355),(76.115,148.205),(75.965,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,148.205),(76.285,148.355),(76.435,148.355),(76.435,148.205),(76.285,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,148.205),(76.605,148.355),(76.755,148.355),(76.755,148.205),(76.605,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,148.525),(75.645,148.675),(75.795,148.675),(75.795,148.525),(75.645,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,148.525),(75.965,148.675),(76.115,148.675),(76.115,148.525),(75.965,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,148.525),(76.285,148.675),(76.435,148.675),(76.435,148.525),(76.285,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,148.525),(76.605,148.675),(76.755,148.675),(76.755,148.525),(76.605,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,148.845),(75.645,148.995),(75.795,148.995),(75.795,148.845),(75.645,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,148.845),(75.965,148.995),(76.115,148.995),(76.115,148.845),(75.965,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,148.845),(76.285,148.995),(76.435,148.995),(76.435,148.845),(76.285,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,148.845),(76.605,148.995),(76.755,148.995),(76.755,148.845),(76.605,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,149.165),(75.645,149.315),(75.795,149.315),(75.795,149.165),(75.645,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,149.165),(75.965,149.315),(76.115,149.315),(76.115,149.165),(75.965,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,149.165),(76.285,149.315),(76.435,149.315),(76.435,149.165),(76.285,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,149.165),(76.605,149.315),(76.755,149.315),(76.755,149.165),(76.605,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,149.485),(75.645,149.635),(75.795,149.635),(75.795,149.485),(75.645,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,149.485),(75.965,149.635),(76.115,149.635),(76.115,149.485),(75.965,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,149.485),(76.285,149.635),(76.435,149.635),(76.435,149.485),(76.285,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,149.485),(76.605,149.635),(76.755,149.635),(76.755,149.485),(76.605,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,149.805),(75.645,149.955),(75.795,149.955),(75.795,149.805),(75.645,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,149.805),(75.965,149.955),(76.115,149.955),(76.115,149.805),(75.965,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,149.805),(76.285,149.955),(76.435,149.955),(76.435,149.805),(76.285,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,149.805),(76.605,149.955),(76.755,149.955),(76.755,149.805),(76.605,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,150.125),(75.645,150.275),(75.795,150.275),(75.795,150.125),(75.645,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,150.125),(75.965,150.275),(76.115,150.275),(76.115,150.125),(75.965,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,150.125),(76.285,150.275),(76.435,150.275),(76.435,150.125),(76.285,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,150.125),(76.605,150.275),(76.755,150.275),(76.755,150.125),(76.605,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,150.445),(75.645,150.595),(75.795,150.595),(75.795,150.445),(75.645,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,150.445),(75.965,150.595),(76.115,150.595),(76.115,150.445),(75.965,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,150.445),(76.285,150.595),(76.435,150.595),(76.435,150.445),(76.285,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,150.445),(76.605,150.595),(76.755,150.595),(76.755,150.445),(76.605,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,150.765),(75.645,150.915),(75.795,150.915),(75.795,150.765),(75.645,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,150.765),(75.965,150.915),(76.115,150.915),(76.115,150.765),(75.965,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,150.765),(76.285,150.915),(76.435,150.915),(76.435,150.765),(76.285,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,150.765),(76.605,150.915),(76.755,150.915),(76.755,150.765),(76.605,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,151.085),(75.645,151.235),(75.795,151.235),(75.795,151.085),(75.645,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,151.085),(75.965,151.235),(76.115,151.235),(76.115,151.085),(75.965,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,151.085),(76.285,151.235),(76.435,151.235),(76.435,151.085),(76.285,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,151.085),(76.605,151.235),(76.755,151.235),(76.755,151.085),(76.605,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,151.405),(75.645,151.555),(75.795,151.555),(75.795,151.405),(75.645,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,151.405),(75.965,151.555),(76.115,151.555),(76.115,151.405),(75.965,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,151.405),(76.285,151.555),(76.435,151.555),(76.435,151.405),(76.285,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,151.405),(76.605,151.555),(76.755,151.555),(76.755,151.405),(76.605,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((75.645,151.725),(75.645,151.875),(75.795,151.875),(75.795,151.725),(75.645,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((75.965,151.725),(75.965,151.875),(76.115,151.875),(76.115,151.725),(75.965,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.285,151.725),(76.285,151.875),(76.435,151.875),(76.435,151.725),(76.285,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((76.605,151.725),(76.605,151.875),(76.755,151.875),(76.755,151.725),(76.605,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,142.125),(70.845,142.275),(70.995,142.275),(70.995,142.125),(70.845,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,142.125),(71.165,142.275),(71.315,142.275),(71.315,142.125),(71.165,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,142.125),(71.485,142.275),(71.635,142.275),(71.635,142.125),(71.485,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,142.125),(71.805,142.275),(71.955,142.275),(71.955,142.125),(71.805,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,142.445),(70.845,142.595),(70.995,142.595),(70.995,142.445),(70.845,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,142.445),(71.165,142.595),(71.315,142.595),(71.315,142.445),(71.165,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,142.445),(71.485,142.595),(71.635,142.595),(71.635,142.445),(71.485,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,142.445),(71.805,142.595),(71.955,142.595),(71.955,142.445),(71.805,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,142.765),(70.845,142.915),(70.995,142.915),(70.995,142.765),(70.845,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,142.765),(71.165,142.915),(71.315,142.915),(71.315,142.765),(71.165,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,142.765),(71.485,142.915),(71.635,142.915),(71.635,142.765),(71.485,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,142.765),(71.805,142.915),(71.955,142.915),(71.955,142.765),(71.805,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,143.085),(70.845,143.235),(70.995,143.235),(70.995,143.085),(70.845,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,143.085),(71.165,143.235),(71.315,143.235),(71.315,143.085),(71.165,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,143.085),(71.485,143.235),(71.635,143.235),(71.635,143.085),(71.485,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,143.085),(71.805,143.235),(71.955,143.235),(71.955,143.085),(71.805,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,143.405),(70.845,143.555),(70.995,143.555),(70.995,143.405),(70.845,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,143.405),(71.165,143.555),(71.315,143.555),(71.315,143.405),(71.165,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,143.405),(71.485,143.555),(71.635,143.555),(71.635,143.405),(71.485,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,143.405),(71.805,143.555),(71.955,143.555),(71.955,143.405),(71.805,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,143.725),(70.845,143.875),(70.995,143.875),(70.995,143.725),(70.845,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,143.725),(71.165,143.875),(71.315,143.875),(71.315,143.725),(71.165,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,143.725),(71.485,143.875),(71.635,143.875),(71.635,143.725),(71.485,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,143.725),(71.805,143.875),(71.955,143.875),(71.955,143.725),(71.805,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,144.045),(70.845,144.195),(70.995,144.195),(70.995,144.045),(70.845,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,144.045),(71.165,144.195),(71.315,144.195),(71.315,144.045),(71.165,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,144.045),(71.485,144.195),(71.635,144.195),(71.635,144.045),(71.485,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,144.045),(71.805,144.195),(71.955,144.195),(71.955,144.045),(71.805,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,144.365),(70.845,144.515),(70.995,144.515),(70.995,144.365),(70.845,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,144.365),(71.165,144.515),(71.315,144.515),(71.315,144.365),(71.165,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,144.365),(71.485,144.515),(71.635,144.515),(71.635,144.365),(71.485,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,144.365),(71.805,144.515),(71.955,144.515),(71.955,144.365),(71.805,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,144.685),(70.845,144.835),(70.995,144.835),(70.995,144.685),(70.845,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,144.685),(71.165,144.835),(71.315,144.835),(71.315,144.685),(71.165,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,144.685),(71.485,144.835),(71.635,144.835),(71.635,144.685),(71.485,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,144.685),(71.805,144.835),(71.955,144.835),(71.955,144.685),(71.805,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,145.005),(70.845,145.155),(70.995,145.155),(70.995,145.005),(70.845,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,145.005),(71.165,145.155),(71.315,145.155),(71.315,145.005),(71.165,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,145.005),(71.485,145.155),(71.635,145.155),(71.635,145.005),(71.485,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,145.005),(71.805,145.155),(71.955,145.155),(71.955,145.005),(71.805,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,145.325),(70.845,145.475),(70.995,145.475),(70.995,145.325),(70.845,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,145.325),(71.165,145.475),(71.315,145.475),(71.315,145.325),(71.165,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,145.325),(71.485,145.475),(71.635,145.475),(71.635,145.325),(71.485,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,145.325),(71.805,145.475),(71.955,145.475),(71.955,145.325),(71.805,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,145.645),(70.845,145.795),(70.995,145.795),(70.995,145.645),(70.845,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,145.645),(71.165,145.795),(71.315,145.795),(71.315,145.645),(71.165,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,145.645),(71.485,145.795),(71.635,145.795),(71.635,145.645),(71.485,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,145.645),(71.805,145.795),(71.955,145.795),(71.955,145.645),(71.805,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,145.965),(70.845,146.115),(70.995,146.115),(70.995,145.965),(70.845,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,145.965),(71.165,146.115),(71.315,146.115),(71.315,145.965),(71.165,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,145.965),(71.485,146.115),(71.635,146.115),(71.635,145.965),(71.485,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,145.965),(71.805,146.115),(71.955,146.115),(71.955,145.965),(71.805,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,146.285),(70.845,146.435),(70.995,146.435),(70.995,146.285),(70.845,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,146.285),(71.165,146.435),(71.315,146.435),(71.315,146.285),(71.165,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,146.285),(71.485,146.435),(71.635,146.435),(71.635,146.285),(71.485,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,146.285),(71.805,146.435),(71.955,146.435),(71.955,146.285),(71.805,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,146.605),(70.845,146.755),(70.995,146.755),(70.995,146.605),(70.845,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,146.605),(71.165,146.755),(71.315,146.755),(71.315,146.605),(71.165,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,146.605),(71.485,146.755),(71.635,146.755),(71.635,146.605),(71.485,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,146.605),(71.805,146.755),(71.955,146.755),(71.955,146.605),(71.805,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,146.925),(70.845,147.075),(70.995,147.075),(70.995,146.925),(70.845,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,146.925),(71.165,147.075),(71.315,147.075),(71.315,146.925),(71.165,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,146.925),(71.485,147.075),(71.635,147.075),(71.635,146.925),(71.485,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,146.925),(71.805,147.075),(71.955,147.075),(71.955,146.925),(71.805,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,147.245),(70.845,147.395),(70.995,147.395),(70.995,147.245),(70.845,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,147.245),(71.165,147.395),(71.315,147.395),(71.315,147.245),(71.165,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,147.245),(71.485,147.395),(71.635,147.395),(71.635,147.245),(71.485,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,147.245),(71.805,147.395),(71.955,147.395),(71.955,147.245),(71.805,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,147.565),(70.845,147.715),(70.995,147.715),(70.995,147.565),(70.845,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,147.565),(71.165,147.715),(71.315,147.715),(71.315,147.565),(71.165,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,147.565),(71.485,147.715),(71.635,147.715),(71.635,147.565),(71.485,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,147.565),(71.805,147.715),(71.955,147.715),(71.955,147.565),(71.805,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,147.885),(70.845,148.035),(70.995,148.035),(70.995,147.885),(70.845,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,147.885),(71.165,148.035),(71.315,148.035),(71.315,147.885),(71.165,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,147.885),(71.485,148.035),(71.635,148.035),(71.635,147.885),(71.485,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,147.885),(71.805,148.035),(71.955,148.035),(71.955,147.885),(71.805,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,148.205),(70.845,148.355),(70.995,148.355),(70.995,148.205),(70.845,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,148.205),(71.165,148.355),(71.315,148.355),(71.315,148.205),(71.165,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,148.205),(71.485,148.355),(71.635,148.355),(71.635,148.205),(71.485,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,148.205),(71.805,148.355),(71.955,148.355),(71.955,148.205),(71.805,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,148.525),(70.845,148.675),(70.995,148.675),(70.995,148.525),(70.845,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,148.525),(71.165,148.675),(71.315,148.675),(71.315,148.525),(71.165,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,148.525),(71.485,148.675),(71.635,148.675),(71.635,148.525),(71.485,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,148.525),(71.805,148.675),(71.955,148.675),(71.955,148.525),(71.805,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,148.845),(70.845,148.995),(70.995,148.995),(70.995,148.845),(70.845,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,148.845),(71.165,148.995),(71.315,148.995),(71.315,148.845),(71.165,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,148.845),(71.485,148.995),(71.635,148.995),(71.635,148.845),(71.485,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,148.845),(71.805,148.995),(71.955,148.995),(71.955,148.845),(71.805,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,149.165),(70.845,149.315),(70.995,149.315),(70.995,149.165),(70.845,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,149.165),(71.165,149.315),(71.315,149.315),(71.315,149.165),(71.165,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,149.165),(71.485,149.315),(71.635,149.315),(71.635,149.165),(71.485,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,149.165),(71.805,149.315),(71.955,149.315),(71.955,149.165),(71.805,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,149.485),(70.845,149.635),(70.995,149.635),(70.995,149.485),(70.845,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,149.485),(71.165,149.635),(71.315,149.635),(71.315,149.485),(71.165,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,149.485),(71.485,149.635),(71.635,149.635),(71.635,149.485),(71.485,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,149.485),(71.805,149.635),(71.955,149.635),(71.955,149.485),(71.805,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,149.805),(70.845,149.955),(70.995,149.955),(70.995,149.805),(70.845,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,149.805),(71.165,149.955),(71.315,149.955),(71.315,149.805),(71.165,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,149.805),(71.485,149.955),(71.635,149.955),(71.635,149.805),(71.485,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,149.805),(71.805,149.955),(71.955,149.955),(71.955,149.805),(71.805,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,150.125),(70.845,150.275),(70.995,150.275),(70.995,150.125),(70.845,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,150.125),(71.165,150.275),(71.315,150.275),(71.315,150.125),(71.165,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,150.125),(71.485,150.275),(71.635,150.275),(71.635,150.125),(71.485,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,150.125),(71.805,150.275),(71.955,150.275),(71.955,150.125),(71.805,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,150.445),(70.845,150.595),(70.995,150.595),(70.995,150.445),(70.845,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,150.445),(71.165,150.595),(71.315,150.595),(71.315,150.445),(71.165,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,150.445),(71.485,150.595),(71.635,150.595),(71.635,150.445),(71.485,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,150.445),(71.805,150.595),(71.955,150.595),(71.955,150.445),(71.805,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,150.765),(70.845,150.915),(70.995,150.915),(70.995,150.765),(70.845,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,150.765),(71.165,150.915),(71.315,150.915),(71.315,150.765),(71.165,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,150.765),(71.485,150.915),(71.635,150.915),(71.635,150.765),(71.485,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,150.765),(71.805,150.915),(71.955,150.915),(71.955,150.765),(71.805,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,151.085),(70.845,151.235),(70.995,151.235),(70.995,151.085),(70.845,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,151.085),(71.165,151.235),(71.315,151.235),(71.315,151.085),(71.165,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,151.085),(71.485,151.235),(71.635,151.235),(71.635,151.085),(71.485,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,151.085),(71.805,151.235),(71.955,151.235),(71.955,151.085),(71.805,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,151.405),(70.845,151.555),(70.995,151.555),(70.995,151.405),(70.845,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,151.405),(71.165,151.555),(71.315,151.555),(71.315,151.405),(71.165,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,151.405),(71.485,151.555),(71.635,151.555),(71.635,151.405),(71.485,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,151.405),(71.805,151.555),(71.955,151.555),(71.955,151.405),(71.805,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((70.845,151.725),(70.845,151.875),(70.995,151.875),(70.995,151.725),(70.845,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.165,151.725),(71.165,151.875),(71.315,151.875),(71.315,151.725),(71.165,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.485,151.725),(71.485,151.875),(71.635,151.875),(71.635,151.725),(71.485,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((71.805,151.725),(71.805,151.875),(71.955,151.875),(71.955,151.725),(71.805,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,142.125),(8.445,142.275),(8.595,142.275),(8.595,142.125),(8.445,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,142.125),(8.765,142.275),(8.915,142.275),(8.915,142.125),(8.765,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,142.125),(9.085,142.275),(9.235,142.275),(9.235,142.125),(9.085,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,142.125),(9.405,142.275),(9.555,142.275),(9.555,142.125),(9.405,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,142.445),(8.445,142.595),(8.595,142.595),(8.595,142.445),(8.445,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,142.445),(8.765,142.595),(8.915,142.595),(8.915,142.445),(8.765,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,142.445),(9.085,142.595),(9.235,142.595),(9.235,142.445),(9.085,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,142.445),(9.405,142.595),(9.555,142.595),(9.555,142.445),(9.405,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,142.765),(8.445,142.915),(8.595,142.915),(8.595,142.765),(8.445,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,142.765),(8.765,142.915),(8.915,142.915),(8.915,142.765),(8.765,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,142.765),(9.085,142.915),(9.235,142.915),(9.235,142.765),(9.085,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,142.765),(9.405,142.915),(9.555,142.915),(9.555,142.765),(9.405,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,143.085),(8.445,143.235),(8.595,143.235),(8.595,143.085),(8.445,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,143.085),(8.765,143.235),(8.915,143.235),(8.915,143.085),(8.765,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,143.085),(9.085,143.235),(9.235,143.235),(9.235,143.085),(9.085,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,143.085),(9.405,143.235),(9.555,143.235),(9.555,143.085),(9.405,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,143.405),(8.445,143.555),(8.595,143.555),(8.595,143.405),(8.445,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,143.405),(8.765,143.555),(8.915,143.555),(8.915,143.405),(8.765,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,143.405),(9.085,143.555),(9.235,143.555),(9.235,143.405),(9.085,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,143.405),(9.405,143.555),(9.555,143.555),(9.555,143.405),(9.405,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,143.725),(8.445,143.875),(8.595,143.875),(8.595,143.725),(8.445,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,143.725),(8.765,143.875),(8.915,143.875),(8.915,143.725),(8.765,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,143.725),(9.085,143.875),(9.235,143.875),(9.235,143.725),(9.085,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,143.725),(9.405,143.875),(9.555,143.875),(9.555,143.725),(9.405,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,144.045),(8.445,144.195),(8.595,144.195),(8.595,144.045),(8.445,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,144.045),(8.765,144.195),(8.915,144.195),(8.915,144.045),(8.765,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,144.045),(9.085,144.195),(9.235,144.195),(9.235,144.045),(9.085,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,144.045),(9.405,144.195),(9.555,144.195),(9.555,144.045),(9.405,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,144.365),(8.445,144.515),(8.595,144.515),(8.595,144.365),(8.445,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,144.365),(8.765,144.515),(8.915,144.515),(8.915,144.365),(8.765,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,144.365),(9.085,144.515),(9.235,144.515),(9.235,144.365),(9.085,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,144.365),(9.405,144.515),(9.555,144.515),(9.555,144.365),(9.405,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,144.685),(8.445,144.835),(8.595,144.835),(8.595,144.685),(8.445,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,144.685),(8.765,144.835),(8.915,144.835),(8.915,144.685),(8.765,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,144.685),(9.085,144.835),(9.235,144.835),(9.235,144.685),(9.085,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,144.685),(9.405,144.835),(9.555,144.835),(9.555,144.685),(9.405,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,145.005),(8.445,145.155),(8.595,145.155),(8.595,145.005),(8.445,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,145.005),(8.765,145.155),(8.915,145.155),(8.915,145.005),(8.765,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,145.005),(9.085,145.155),(9.235,145.155),(9.235,145.005),(9.085,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,145.005),(9.405,145.155),(9.555,145.155),(9.555,145.005),(9.405,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,145.325),(8.445,145.475),(8.595,145.475),(8.595,145.325),(8.445,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,145.325),(8.765,145.475),(8.915,145.475),(8.915,145.325),(8.765,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,145.325),(9.085,145.475),(9.235,145.475),(9.235,145.325),(9.085,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,145.325),(9.405,145.475),(9.555,145.475),(9.555,145.325),(9.405,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,145.645),(8.445,145.795),(8.595,145.795),(8.595,145.645),(8.445,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,145.645),(8.765,145.795),(8.915,145.795),(8.915,145.645),(8.765,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,145.645),(9.085,145.795),(9.235,145.795),(9.235,145.645),(9.085,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,145.645),(9.405,145.795),(9.555,145.795),(9.555,145.645),(9.405,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,145.965),(8.445,146.115),(8.595,146.115),(8.595,145.965),(8.445,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,145.965),(8.765,146.115),(8.915,146.115),(8.915,145.965),(8.765,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,145.965),(9.085,146.115),(9.235,146.115),(9.235,145.965),(9.085,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,145.965),(9.405,146.115),(9.555,146.115),(9.555,145.965),(9.405,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,146.285),(8.445,146.435),(8.595,146.435),(8.595,146.285),(8.445,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,146.285),(8.765,146.435),(8.915,146.435),(8.915,146.285),(8.765,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,146.285),(9.085,146.435),(9.235,146.435),(9.235,146.285),(9.085,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,146.285),(9.405,146.435),(9.555,146.435),(9.555,146.285),(9.405,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,146.605),(8.445,146.755),(8.595,146.755),(8.595,146.605),(8.445,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,146.605),(8.765,146.755),(8.915,146.755),(8.915,146.605),(8.765,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,146.605),(9.085,146.755),(9.235,146.755),(9.235,146.605),(9.085,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,146.605),(9.405,146.755),(9.555,146.755),(9.555,146.605),(9.405,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,146.925),(8.445,147.075),(8.595,147.075),(8.595,146.925),(8.445,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,146.925),(8.765,147.075),(8.915,147.075),(8.915,146.925),(8.765,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,146.925),(9.085,147.075),(9.235,147.075),(9.235,146.925),(9.085,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,146.925),(9.405,147.075),(9.555,147.075),(9.555,146.925),(9.405,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,147.245),(8.445,147.395),(8.595,147.395),(8.595,147.245),(8.445,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,147.245),(8.765,147.395),(8.915,147.395),(8.915,147.245),(8.765,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,147.245),(9.085,147.395),(9.235,147.395),(9.235,147.245),(9.085,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,147.245),(9.405,147.395),(9.555,147.395),(9.555,147.245),(9.405,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,147.565),(8.445,147.715),(8.595,147.715),(8.595,147.565),(8.445,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,147.565),(8.765,147.715),(8.915,147.715),(8.915,147.565),(8.765,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,147.565),(9.085,147.715),(9.235,147.715),(9.235,147.565),(9.085,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,147.565),(9.405,147.715),(9.555,147.715),(9.555,147.565),(9.405,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,147.885),(8.445,148.035),(8.595,148.035),(8.595,147.885),(8.445,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,147.885),(8.765,148.035),(8.915,148.035),(8.915,147.885),(8.765,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,147.885),(9.085,148.035),(9.235,148.035),(9.235,147.885),(9.085,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,147.885),(9.405,148.035),(9.555,148.035),(9.555,147.885),(9.405,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,148.205),(8.445,148.355),(8.595,148.355),(8.595,148.205),(8.445,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,148.205),(8.765,148.355),(8.915,148.355),(8.915,148.205),(8.765,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,148.205),(9.085,148.355),(9.235,148.355),(9.235,148.205),(9.085,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,148.205),(9.405,148.355),(9.555,148.355),(9.555,148.205),(9.405,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,148.525),(8.445,148.675),(8.595,148.675),(8.595,148.525),(8.445,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,148.525),(8.765,148.675),(8.915,148.675),(8.915,148.525),(8.765,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,148.525),(9.085,148.675),(9.235,148.675),(9.235,148.525),(9.085,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,148.525),(9.405,148.675),(9.555,148.675),(9.555,148.525),(9.405,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,148.845),(8.445,148.995),(8.595,148.995),(8.595,148.845),(8.445,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,148.845),(8.765,148.995),(8.915,148.995),(8.915,148.845),(8.765,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,148.845),(9.085,148.995),(9.235,148.995),(9.235,148.845),(9.085,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,148.845),(9.405,148.995),(9.555,148.995),(9.555,148.845),(9.405,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,149.165),(8.445,149.315),(8.595,149.315),(8.595,149.165),(8.445,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,149.165),(8.765,149.315),(8.915,149.315),(8.915,149.165),(8.765,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,149.165),(9.085,149.315),(9.235,149.315),(9.235,149.165),(9.085,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,149.165),(9.405,149.315),(9.555,149.315),(9.555,149.165),(9.405,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,149.485),(8.445,149.635),(8.595,149.635),(8.595,149.485),(8.445,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,149.485),(8.765,149.635),(8.915,149.635),(8.915,149.485),(8.765,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,149.485),(9.085,149.635),(9.235,149.635),(9.235,149.485),(9.085,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,149.485),(9.405,149.635),(9.555,149.635),(9.555,149.485),(9.405,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,149.805),(8.445,149.955),(8.595,149.955),(8.595,149.805),(8.445,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,149.805),(8.765,149.955),(8.915,149.955),(8.915,149.805),(8.765,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,149.805),(9.085,149.955),(9.235,149.955),(9.235,149.805),(9.085,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,149.805),(9.405,149.955),(9.555,149.955),(9.555,149.805),(9.405,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,150.125),(8.445,150.275),(8.595,150.275),(8.595,150.125),(8.445,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,150.125),(8.765,150.275),(8.915,150.275),(8.915,150.125),(8.765,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,150.125),(9.085,150.275),(9.235,150.275),(9.235,150.125),(9.085,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,150.125),(9.405,150.275),(9.555,150.275),(9.555,150.125),(9.405,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,150.445),(8.445,150.595),(8.595,150.595),(8.595,150.445),(8.445,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,150.445),(8.765,150.595),(8.915,150.595),(8.915,150.445),(8.765,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,150.445),(9.085,150.595),(9.235,150.595),(9.235,150.445),(9.085,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,150.445),(9.405,150.595),(9.555,150.595),(9.555,150.445),(9.405,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,150.765),(8.445,150.915),(8.595,150.915),(8.595,150.765),(8.445,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,150.765),(8.765,150.915),(8.915,150.915),(8.915,150.765),(8.765,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,150.765),(9.085,150.915),(9.235,150.915),(9.235,150.765),(9.085,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,150.765),(9.405,150.915),(9.555,150.915),(9.555,150.765),(9.405,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,151.085),(8.445,151.235),(8.595,151.235),(8.595,151.085),(8.445,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,151.085),(8.765,151.235),(8.915,151.235),(8.915,151.085),(8.765,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,151.085),(9.085,151.235),(9.235,151.235),(9.235,151.085),(9.085,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,151.085),(9.405,151.235),(9.555,151.235),(9.555,151.085),(9.405,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,151.405),(8.445,151.555),(8.595,151.555),(8.595,151.405),(8.445,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,151.405),(8.765,151.555),(8.915,151.555),(8.915,151.405),(8.765,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,151.405),(9.085,151.555),(9.235,151.555),(9.235,151.405),(9.085,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,151.405),(9.405,151.555),(9.555,151.555),(9.555,151.405),(9.405,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((8.445,151.725),(8.445,151.875),(8.595,151.875),(8.595,151.725),(8.445,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((8.765,151.725),(8.765,151.875),(8.915,151.875),(8.915,151.725),(8.765,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.085,151.725),(9.085,151.875),(9.235,151.875),(9.235,151.725),(9.085,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((9.405,151.725),(9.405,151.875),(9.555,151.875),(9.555,151.725),(9.405,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,142.125),(66.045,142.275),(66.195,142.275),(66.195,142.125),(66.045,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,142.125),(66.365,142.275),(66.515,142.275),(66.515,142.125),(66.365,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,142.125),(66.685,142.275),(66.835,142.275),(66.835,142.125),(66.685,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,142.125),(67.005,142.275),(67.155,142.275),(67.155,142.125),(67.005,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,142.445),(66.045,142.595),(66.195,142.595),(66.195,142.445),(66.045,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,142.445),(66.365,142.595),(66.515,142.595),(66.515,142.445),(66.365,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,142.445),(66.685,142.595),(66.835,142.595),(66.835,142.445),(66.685,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,142.445),(67.005,142.595),(67.155,142.595),(67.155,142.445),(67.005,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,142.765),(66.045,142.915),(66.195,142.915),(66.195,142.765),(66.045,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,142.765),(66.365,142.915),(66.515,142.915),(66.515,142.765),(66.365,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,142.765),(66.685,142.915),(66.835,142.915),(66.835,142.765),(66.685,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,142.765),(67.005,142.915),(67.155,142.915),(67.155,142.765),(67.005,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,143.085),(66.045,143.235),(66.195,143.235),(66.195,143.085),(66.045,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,143.085),(66.365,143.235),(66.515,143.235),(66.515,143.085),(66.365,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,143.085),(66.685,143.235),(66.835,143.235),(66.835,143.085),(66.685,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,143.085),(67.005,143.235),(67.155,143.235),(67.155,143.085),(67.005,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,143.405),(66.045,143.555),(66.195,143.555),(66.195,143.405),(66.045,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,143.405),(66.365,143.555),(66.515,143.555),(66.515,143.405),(66.365,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,143.405),(66.685,143.555),(66.835,143.555),(66.835,143.405),(66.685,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,143.405),(67.005,143.555),(67.155,143.555),(67.155,143.405),(67.005,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,143.725),(66.045,143.875),(66.195,143.875),(66.195,143.725),(66.045,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,143.725),(66.365,143.875),(66.515,143.875),(66.515,143.725),(66.365,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,143.725),(66.685,143.875),(66.835,143.875),(66.835,143.725),(66.685,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,143.725),(67.005,143.875),(67.155,143.875),(67.155,143.725),(67.005,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,144.045),(66.045,144.195),(66.195,144.195),(66.195,144.045),(66.045,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,144.045),(66.365,144.195),(66.515,144.195),(66.515,144.045),(66.365,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,144.045),(66.685,144.195),(66.835,144.195),(66.835,144.045),(66.685,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,144.045),(67.005,144.195),(67.155,144.195),(67.155,144.045),(67.005,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,144.365),(66.045,144.515),(66.195,144.515),(66.195,144.365),(66.045,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,144.365),(66.365,144.515),(66.515,144.515),(66.515,144.365),(66.365,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,144.365),(66.685,144.515),(66.835,144.515),(66.835,144.365),(66.685,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,144.365),(67.005,144.515),(67.155,144.515),(67.155,144.365),(67.005,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,144.685),(66.045,144.835),(66.195,144.835),(66.195,144.685),(66.045,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,144.685),(66.365,144.835),(66.515,144.835),(66.515,144.685),(66.365,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,144.685),(66.685,144.835),(66.835,144.835),(66.835,144.685),(66.685,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,144.685),(67.005,144.835),(67.155,144.835),(67.155,144.685),(67.005,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,145.005),(66.045,145.155),(66.195,145.155),(66.195,145.005),(66.045,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,145.005),(66.365,145.155),(66.515,145.155),(66.515,145.005),(66.365,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,145.005),(66.685,145.155),(66.835,145.155),(66.835,145.005),(66.685,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,145.005),(67.005,145.155),(67.155,145.155),(67.155,145.005),(67.005,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,145.325),(66.045,145.475),(66.195,145.475),(66.195,145.325),(66.045,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,145.325),(66.365,145.475),(66.515,145.475),(66.515,145.325),(66.365,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,145.325),(66.685,145.475),(66.835,145.475),(66.835,145.325),(66.685,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,145.325),(67.005,145.475),(67.155,145.475),(67.155,145.325),(67.005,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,145.645),(66.045,145.795),(66.195,145.795),(66.195,145.645),(66.045,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,145.645),(66.365,145.795),(66.515,145.795),(66.515,145.645),(66.365,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,145.645),(66.685,145.795),(66.835,145.795),(66.835,145.645),(66.685,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,145.645),(67.005,145.795),(67.155,145.795),(67.155,145.645),(67.005,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,145.965),(66.045,146.115),(66.195,146.115),(66.195,145.965),(66.045,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,145.965),(66.365,146.115),(66.515,146.115),(66.515,145.965),(66.365,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,145.965),(66.685,146.115),(66.835,146.115),(66.835,145.965),(66.685,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,145.965),(67.005,146.115),(67.155,146.115),(67.155,145.965),(67.005,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,146.285),(66.045,146.435),(66.195,146.435),(66.195,146.285),(66.045,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,146.285),(66.365,146.435),(66.515,146.435),(66.515,146.285),(66.365,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,146.285),(66.685,146.435),(66.835,146.435),(66.835,146.285),(66.685,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,146.285),(67.005,146.435),(67.155,146.435),(67.155,146.285),(67.005,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,146.605),(66.045,146.755),(66.195,146.755),(66.195,146.605),(66.045,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,146.605),(66.365,146.755),(66.515,146.755),(66.515,146.605),(66.365,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,146.605),(66.685,146.755),(66.835,146.755),(66.835,146.605),(66.685,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,146.605),(67.005,146.755),(67.155,146.755),(67.155,146.605),(67.005,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,146.925),(66.045,147.075),(66.195,147.075),(66.195,146.925),(66.045,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,146.925),(66.365,147.075),(66.515,147.075),(66.515,146.925),(66.365,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,146.925),(66.685,147.075),(66.835,147.075),(66.835,146.925),(66.685,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,146.925),(67.005,147.075),(67.155,147.075),(67.155,146.925),(67.005,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,147.245),(66.045,147.395),(66.195,147.395),(66.195,147.245),(66.045,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,147.245),(66.365,147.395),(66.515,147.395),(66.515,147.245),(66.365,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,147.245),(66.685,147.395),(66.835,147.395),(66.835,147.245),(66.685,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,147.245),(67.005,147.395),(67.155,147.395),(67.155,147.245),(67.005,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,147.565),(66.045,147.715),(66.195,147.715),(66.195,147.565),(66.045,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,147.565),(66.365,147.715),(66.515,147.715),(66.515,147.565),(66.365,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,147.565),(66.685,147.715),(66.835,147.715),(66.835,147.565),(66.685,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,147.565),(67.005,147.715),(67.155,147.715),(67.155,147.565),(67.005,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,147.885),(66.045,148.035),(66.195,148.035),(66.195,147.885),(66.045,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,147.885),(66.365,148.035),(66.515,148.035),(66.515,147.885),(66.365,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,147.885),(66.685,148.035),(66.835,148.035),(66.835,147.885),(66.685,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,147.885),(67.005,148.035),(67.155,148.035),(67.155,147.885),(67.005,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,148.205),(66.045,148.355),(66.195,148.355),(66.195,148.205),(66.045,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,148.205),(66.365,148.355),(66.515,148.355),(66.515,148.205),(66.365,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,148.205),(66.685,148.355),(66.835,148.355),(66.835,148.205),(66.685,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,148.205),(67.005,148.355),(67.155,148.355),(67.155,148.205),(67.005,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,148.525),(66.045,148.675),(66.195,148.675),(66.195,148.525),(66.045,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,148.525),(66.365,148.675),(66.515,148.675),(66.515,148.525),(66.365,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,148.525),(66.685,148.675),(66.835,148.675),(66.835,148.525),(66.685,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,148.525),(67.005,148.675),(67.155,148.675),(67.155,148.525),(67.005,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,148.845),(66.045,148.995),(66.195,148.995),(66.195,148.845),(66.045,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,148.845),(66.365,148.995),(66.515,148.995),(66.515,148.845),(66.365,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,148.845),(66.685,148.995),(66.835,148.995),(66.835,148.845),(66.685,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,148.845),(67.005,148.995),(67.155,148.995),(67.155,148.845),(67.005,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,149.165),(66.045,149.315),(66.195,149.315),(66.195,149.165),(66.045,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,149.165),(66.365,149.315),(66.515,149.315),(66.515,149.165),(66.365,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,149.165),(66.685,149.315),(66.835,149.315),(66.835,149.165),(66.685,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,149.165),(67.005,149.315),(67.155,149.315),(67.155,149.165),(67.005,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,149.485),(66.045,149.635),(66.195,149.635),(66.195,149.485),(66.045,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,149.485),(66.365,149.635),(66.515,149.635),(66.515,149.485),(66.365,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,149.485),(66.685,149.635),(66.835,149.635),(66.835,149.485),(66.685,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,149.485),(67.005,149.635),(67.155,149.635),(67.155,149.485),(67.005,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,149.805),(66.045,149.955),(66.195,149.955),(66.195,149.805),(66.045,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,149.805),(66.365,149.955),(66.515,149.955),(66.515,149.805),(66.365,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,149.805),(66.685,149.955),(66.835,149.955),(66.835,149.805),(66.685,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,149.805),(67.005,149.955),(67.155,149.955),(67.155,149.805),(67.005,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,150.125),(66.045,150.275),(66.195,150.275),(66.195,150.125),(66.045,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,150.125),(66.365,150.275),(66.515,150.275),(66.515,150.125),(66.365,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,150.125),(66.685,150.275),(66.835,150.275),(66.835,150.125),(66.685,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,150.125),(67.005,150.275),(67.155,150.275),(67.155,150.125),(67.005,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,150.445),(66.045,150.595),(66.195,150.595),(66.195,150.445),(66.045,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,150.445),(66.365,150.595),(66.515,150.595),(66.515,150.445),(66.365,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,150.445),(66.685,150.595),(66.835,150.595),(66.835,150.445),(66.685,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,150.445),(67.005,150.595),(67.155,150.595),(67.155,150.445),(67.005,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,150.765),(66.045,150.915),(66.195,150.915),(66.195,150.765),(66.045,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,150.765),(66.365,150.915),(66.515,150.915),(66.515,150.765),(66.365,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,150.765),(66.685,150.915),(66.835,150.915),(66.835,150.765),(66.685,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,150.765),(67.005,150.915),(67.155,150.915),(67.155,150.765),(67.005,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,151.085),(66.045,151.235),(66.195,151.235),(66.195,151.085),(66.045,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,151.085),(66.365,151.235),(66.515,151.235),(66.515,151.085),(66.365,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,151.085),(66.685,151.235),(66.835,151.235),(66.835,151.085),(66.685,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,151.085),(67.005,151.235),(67.155,151.235),(67.155,151.085),(67.005,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,151.405),(66.045,151.555),(66.195,151.555),(66.195,151.405),(66.045,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,151.405),(66.365,151.555),(66.515,151.555),(66.515,151.405),(66.365,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,151.405),(66.685,151.555),(66.835,151.555),(66.835,151.405),(66.685,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,151.405),(67.005,151.555),(67.155,151.555),(67.155,151.405),(67.005,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,151.725),(66.045,151.875),(66.195,151.875),(66.195,151.725),(66.045,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,151.725),(66.365,151.875),(66.515,151.875),(66.515,151.725),(66.365,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((66.685,151.725),(66.685,151.875),(66.835,151.875),(66.835,151.725),(66.685,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((67.005,151.725),(67.005,151.875),(67.155,151.875),(67.155,151.725),(67.005,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,142.125),(80.445,142.275),(80.595,142.275),(80.595,142.125),(80.445,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,142.125),(80.765,142.275),(80.915,142.275),(80.915,142.125),(80.765,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,142.125),(81.085,142.275),(81.235,142.275),(81.235,142.125),(81.085,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,142.125),(81.405,142.275),(81.555,142.275),(81.555,142.125),(81.405,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,142.445),(80.445,142.595),(80.595,142.595),(80.595,142.445),(80.445,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,142.445),(80.765,142.595),(80.915,142.595),(80.915,142.445),(80.765,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,142.445),(81.085,142.595),(81.235,142.595),(81.235,142.445),(81.085,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,142.445),(81.405,142.595),(81.555,142.595),(81.555,142.445),(81.405,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,142.765),(80.445,142.915),(80.595,142.915),(80.595,142.765),(80.445,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,142.765),(80.765,142.915),(80.915,142.915),(80.915,142.765),(80.765,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,142.765),(81.085,142.915),(81.235,142.915),(81.235,142.765),(81.085,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,142.765),(81.405,142.915),(81.555,142.915),(81.555,142.765),(81.405,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,143.085),(80.445,143.235),(80.595,143.235),(80.595,143.085),(80.445,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,143.085),(80.765,143.235),(80.915,143.235),(80.915,143.085),(80.765,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,143.085),(81.085,143.235),(81.235,143.235),(81.235,143.085),(81.085,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,143.085),(81.405,143.235),(81.555,143.235),(81.555,143.085),(81.405,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,143.405),(80.445,143.555),(80.595,143.555),(80.595,143.405),(80.445,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,143.405),(80.765,143.555),(80.915,143.555),(80.915,143.405),(80.765,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,143.405),(81.085,143.555),(81.235,143.555),(81.235,143.405),(81.085,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,143.405),(81.405,143.555),(81.555,143.555),(81.555,143.405),(81.405,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,143.725),(80.445,143.875),(80.595,143.875),(80.595,143.725),(80.445,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,143.725),(80.765,143.875),(80.915,143.875),(80.915,143.725),(80.765,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,143.725),(81.085,143.875),(81.235,143.875),(81.235,143.725),(81.085,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,143.725),(81.405,143.875),(81.555,143.875),(81.555,143.725),(81.405,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,144.045),(80.445,144.195),(80.595,144.195),(80.595,144.045),(80.445,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,144.045),(80.765,144.195),(80.915,144.195),(80.915,144.045),(80.765,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,144.045),(81.085,144.195),(81.235,144.195),(81.235,144.045),(81.085,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,144.045),(81.405,144.195),(81.555,144.195),(81.555,144.045),(81.405,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,144.365),(80.445,144.515),(80.595,144.515),(80.595,144.365),(80.445,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,144.365),(80.765,144.515),(80.915,144.515),(80.915,144.365),(80.765,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,144.365),(81.085,144.515),(81.235,144.515),(81.235,144.365),(81.085,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,144.365),(81.405,144.515),(81.555,144.515),(81.555,144.365),(81.405,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,144.685),(80.445,144.835),(80.595,144.835),(80.595,144.685),(80.445,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,144.685),(80.765,144.835),(80.915,144.835),(80.915,144.685),(80.765,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,144.685),(81.085,144.835),(81.235,144.835),(81.235,144.685),(81.085,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,144.685),(81.405,144.835),(81.555,144.835),(81.555,144.685),(81.405,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,145.005),(80.445,145.155),(80.595,145.155),(80.595,145.005),(80.445,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,145.005),(80.765,145.155),(80.915,145.155),(80.915,145.005),(80.765,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,145.005),(81.085,145.155),(81.235,145.155),(81.235,145.005),(81.085,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,145.005),(81.405,145.155),(81.555,145.155),(81.555,145.005),(81.405,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,145.325),(80.445,145.475),(80.595,145.475),(80.595,145.325),(80.445,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,145.325),(80.765,145.475),(80.915,145.475),(80.915,145.325),(80.765,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,145.325),(81.085,145.475),(81.235,145.475),(81.235,145.325),(81.085,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,145.325),(81.405,145.475),(81.555,145.475),(81.555,145.325),(81.405,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,145.645),(80.445,145.795),(80.595,145.795),(80.595,145.645),(80.445,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,145.645),(80.765,145.795),(80.915,145.795),(80.915,145.645),(80.765,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,145.645),(81.085,145.795),(81.235,145.795),(81.235,145.645),(81.085,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,145.645),(81.405,145.795),(81.555,145.795),(81.555,145.645),(81.405,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,145.965),(80.445,146.115),(80.595,146.115),(80.595,145.965),(80.445,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,145.965),(80.765,146.115),(80.915,146.115),(80.915,145.965),(80.765,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,145.965),(81.085,146.115),(81.235,146.115),(81.235,145.965),(81.085,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,145.965),(81.405,146.115),(81.555,146.115),(81.555,145.965),(81.405,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,146.285),(80.445,146.435),(80.595,146.435),(80.595,146.285),(80.445,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,146.285),(80.765,146.435),(80.915,146.435),(80.915,146.285),(80.765,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,146.285),(81.085,146.435),(81.235,146.435),(81.235,146.285),(81.085,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,146.285),(81.405,146.435),(81.555,146.435),(81.555,146.285),(81.405,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,146.605),(80.445,146.755),(80.595,146.755),(80.595,146.605),(80.445,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,146.605),(80.765,146.755),(80.915,146.755),(80.915,146.605),(80.765,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,146.605),(81.085,146.755),(81.235,146.755),(81.235,146.605),(81.085,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,146.605),(81.405,146.755),(81.555,146.755),(81.555,146.605),(81.405,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,146.925),(80.445,147.075),(80.595,147.075),(80.595,146.925),(80.445,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,146.925),(80.765,147.075),(80.915,147.075),(80.915,146.925),(80.765,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,146.925),(81.085,147.075),(81.235,147.075),(81.235,146.925),(81.085,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,146.925),(81.405,147.075),(81.555,147.075),(81.555,146.925),(81.405,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,147.245),(80.445,147.395),(80.595,147.395),(80.595,147.245),(80.445,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,147.245),(80.765,147.395),(80.915,147.395),(80.915,147.245),(80.765,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,147.245),(81.085,147.395),(81.235,147.395),(81.235,147.245),(81.085,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,147.245),(81.405,147.395),(81.555,147.395),(81.555,147.245),(81.405,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,147.565),(80.445,147.715),(80.595,147.715),(80.595,147.565),(80.445,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,147.565),(80.765,147.715),(80.915,147.715),(80.915,147.565),(80.765,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,147.565),(81.085,147.715),(81.235,147.715),(81.235,147.565),(81.085,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,147.565),(81.405,147.715),(81.555,147.715),(81.555,147.565),(81.405,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,147.885),(80.445,148.035),(80.595,148.035),(80.595,147.885),(80.445,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,147.885),(80.765,148.035),(80.915,148.035),(80.915,147.885),(80.765,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,147.885),(81.085,148.035),(81.235,148.035),(81.235,147.885),(81.085,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,147.885),(81.405,148.035),(81.555,148.035),(81.555,147.885),(81.405,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,148.205),(80.445,148.355),(80.595,148.355),(80.595,148.205),(80.445,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,148.205),(80.765,148.355),(80.915,148.355),(80.915,148.205),(80.765,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,148.205),(81.085,148.355),(81.235,148.355),(81.235,148.205),(81.085,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,148.205),(81.405,148.355),(81.555,148.355),(81.555,148.205),(81.405,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,148.525),(80.445,148.675),(80.595,148.675),(80.595,148.525),(80.445,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,148.525),(80.765,148.675),(80.915,148.675),(80.915,148.525),(80.765,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,148.525),(81.085,148.675),(81.235,148.675),(81.235,148.525),(81.085,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,148.525),(81.405,148.675),(81.555,148.675),(81.555,148.525),(81.405,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,148.845),(80.445,148.995),(80.595,148.995),(80.595,148.845),(80.445,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,148.845),(80.765,148.995),(80.915,148.995),(80.915,148.845),(80.765,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,148.845),(81.085,148.995),(81.235,148.995),(81.235,148.845),(81.085,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,148.845),(81.405,148.995),(81.555,148.995),(81.555,148.845),(81.405,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,149.165),(80.445,149.315),(80.595,149.315),(80.595,149.165),(80.445,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,149.165),(80.765,149.315),(80.915,149.315),(80.915,149.165),(80.765,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,149.165),(81.085,149.315),(81.235,149.315),(81.235,149.165),(81.085,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,149.165),(81.405,149.315),(81.555,149.315),(81.555,149.165),(81.405,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,149.485),(80.445,149.635),(80.595,149.635),(80.595,149.485),(80.445,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,149.485),(80.765,149.635),(80.915,149.635),(80.915,149.485),(80.765,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,149.485),(81.085,149.635),(81.235,149.635),(81.235,149.485),(81.085,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,149.485),(81.405,149.635),(81.555,149.635),(81.555,149.485),(81.405,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,149.805),(80.445,149.955),(80.595,149.955),(80.595,149.805),(80.445,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,149.805),(80.765,149.955),(80.915,149.955),(80.915,149.805),(80.765,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,149.805),(81.085,149.955),(81.235,149.955),(81.235,149.805),(81.085,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,149.805),(81.405,149.955),(81.555,149.955),(81.555,149.805),(81.405,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,150.125),(80.445,150.275),(80.595,150.275),(80.595,150.125),(80.445,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,150.125),(80.765,150.275),(80.915,150.275),(80.915,150.125),(80.765,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,150.125),(81.085,150.275),(81.235,150.275),(81.235,150.125),(81.085,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,150.125),(81.405,150.275),(81.555,150.275),(81.555,150.125),(81.405,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,150.445),(80.445,150.595),(80.595,150.595),(80.595,150.445),(80.445,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,150.445),(80.765,150.595),(80.915,150.595),(80.915,150.445),(80.765,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,150.445),(81.085,150.595),(81.235,150.595),(81.235,150.445),(81.085,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,150.445),(81.405,150.595),(81.555,150.595),(81.555,150.445),(81.405,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,150.765),(80.445,150.915),(80.595,150.915),(80.595,150.765),(80.445,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,150.765),(80.765,150.915),(80.915,150.915),(80.915,150.765),(80.765,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,150.765),(81.085,150.915),(81.235,150.915),(81.235,150.765),(81.085,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,150.765),(81.405,150.915),(81.555,150.915),(81.555,150.765),(81.405,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,151.085),(80.445,151.235),(80.595,151.235),(80.595,151.085),(80.445,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,151.085),(80.765,151.235),(80.915,151.235),(80.915,151.085),(80.765,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,151.085),(81.085,151.235),(81.235,151.235),(81.235,151.085),(81.085,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,151.085),(81.405,151.235),(81.555,151.235),(81.555,151.085),(81.405,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,151.405),(80.445,151.555),(80.595,151.555),(80.595,151.405),(80.445,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,151.405),(80.765,151.555),(80.915,151.555),(80.915,151.405),(80.765,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,151.405),(81.085,151.555),(81.235,151.555),(81.235,151.405),(81.085,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,151.405),(81.405,151.555),(81.555,151.555),(81.555,151.405),(81.405,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((80.445,151.725),(80.445,151.875),(80.595,151.875),(80.595,151.725),(80.445,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((80.765,151.725),(80.765,151.875),(80.915,151.875),(80.915,151.725),(80.765,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.085,151.725),(81.085,151.875),(81.235,151.875),(81.235,151.725),(81.085,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((81.405,151.725),(81.405,151.875),(81.555,151.875),(81.555,151.725),(81.405,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,142.125),(13.245,142.275),(13.395,142.275),(13.395,142.125),(13.245,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,142.125),(13.565,142.275),(13.715,142.275),(13.715,142.125),(13.565,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,142.125),(13.885,142.275),(14.035,142.275),(14.035,142.125),(13.885,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,142.125),(14.205,142.275),(14.355,142.275),(14.355,142.125),(14.205,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,142.445),(13.245,142.595),(13.395,142.595),(13.395,142.445),(13.245,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,142.445),(13.565,142.595),(13.715,142.595),(13.715,142.445),(13.565,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,142.445),(13.885,142.595),(14.035,142.595),(14.035,142.445),(13.885,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,142.445),(14.205,142.595),(14.355,142.595),(14.355,142.445),(14.205,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,142.765),(13.245,142.915),(13.395,142.915),(13.395,142.765),(13.245,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,142.765),(13.565,142.915),(13.715,142.915),(13.715,142.765),(13.565,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,142.765),(13.885,142.915),(14.035,142.915),(14.035,142.765),(13.885,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,142.765),(14.205,142.915),(14.355,142.915),(14.355,142.765),(14.205,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,143.085),(13.245,143.235),(13.395,143.235),(13.395,143.085),(13.245,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,143.085),(13.565,143.235),(13.715,143.235),(13.715,143.085),(13.565,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,143.085),(13.885,143.235),(14.035,143.235),(14.035,143.085),(13.885,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,143.085),(14.205,143.235),(14.355,143.235),(14.355,143.085),(14.205,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,143.405),(13.245,143.555),(13.395,143.555),(13.395,143.405),(13.245,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,143.405),(13.565,143.555),(13.715,143.555),(13.715,143.405),(13.565,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,143.405),(13.885,143.555),(14.035,143.555),(14.035,143.405),(13.885,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,143.405),(14.205,143.555),(14.355,143.555),(14.355,143.405),(14.205,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,143.725),(13.245,143.875),(13.395,143.875),(13.395,143.725),(13.245,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,143.725),(13.565,143.875),(13.715,143.875),(13.715,143.725),(13.565,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,143.725),(13.885,143.875),(14.035,143.875),(14.035,143.725),(13.885,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,143.725),(14.205,143.875),(14.355,143.875),(14.355,143.725),(14.205,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,144.045),(13.245,144.195),(13.395,144.195),(13.395,144.045),(13.245,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,144.045),(13.565,144.195),(13.715,144.195),(13.715,144.045),(13.565,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,144.045),(13.885,144.195),(14.035,144.195),(14.035,144.045),(13.885,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,144.045),(14.205,144.195),(14.355,144.195),(14.355,144.045),(14.205,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,144.365),(13.245,144.515),(13.395,144.515),(13.395,144.365),(13.245,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,144.365),(13.565,144.515),(13.715,144.515),(13.715,144.365),(13.565,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,144.365),(13.885,144.515),(14.035,144.515),(14.035,144.365),(13.885,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,144.365),(14.205,144.515),(14.355,144.515),(14.355,144.365),(14.205,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,144.685),(13.245,144.835),(13.395,144.835),(13.395,144.685),(13.245,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,144.685),(13.565,144.835),(13.715,144.835),(13.715,144.685),(13.565,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,144.685),(13.885,144.835),(14.035,144.835),(14.035,144.685),(13.885,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,144.685),(14.205,144.835),(14.355,144.835),(14.355,144.685),(14.205,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,145.005),(13.245,145.155),(13.395,145.155),(13.395,145.005),(13.245,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,145.005),(13.565,145.155),(13.715,145.155),(13.715,145.005),(13.565,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,145.005),(13.885,145.155),(14.035,145.155),(14.035,145.005),(13.885,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,145.005),(14.205,145.155),(14.355,145.155),(14.355,145.005),(14.205,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,145.325),(13.245,145.475),(13.395,145.475),(13.395,145.325),(13.245,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,145.325),(13.565,145.475),(13.715,145.475),(13.715,145.325),(13.565,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,145.325),(13.885,145.475),(14.035,145.475),(14.035,145.325),(13.885,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,145.325),(14.205,145.475),(14.355,145.475),(14.355,145.325),(14.205,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,145.645),(13.245,145.795),(13.395,145.795),(13.395,145.645),(13.245,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,145.645),(13.565,145.795),(13.715,145.795),(13.715,145.645),(13.565,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,145.645),(13.885,145.795),(14.035,145.795),(14.035,145.645),(13.885,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,145.645),(14.205,145.795),(14.355,145.795),(14.355,145.645),(14.205,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,145.965),(13.245,146.115),(13.395,146.115),(13.395,145.965),(13.245,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,145.965),(13.565,146.115),(13.715,146.115),(13.715,145.965),(13.565,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,145.965),(13.885,146.115),(14.035,146.115),(14.035,145.965),(13.885,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,145.965),(14.205,146.115),(14.355,146.115),(14.355,145.965),(14.205,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,146.285),(13.245,146.435),(13.395,146.435),(13.395,146.285),(13.245,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,146.285),(13.565,146.435),(13.715,146.435),(13.715,146.285),(13.565,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,146.285),(13.885,146.435),(14.035,146.435),(14.035,146.285),(13.885,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,146.285),(14.205,146.435),(14.355,146.435),(14.355,146.285),(14.205,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,146.605),(13.245,146.755),(13.395,146.755),(13.395,146.605),(13.245,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,146.605),(13.565,146.755),(13.715,146.755),(13.715,146.605),(13.565,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,146.605),(13.885,146.755),(14.035,146.755),(14.035,146.605),(13.885,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,146.605),(14.205,146.755),(14.355,146.755),(14.355,146.605),(14.205,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,146.925),(13.245,147.075),(13.395,147.075),(13.395,146.925),(13.245,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,146.925),(13.565,147.075),(13.715,147.075),(13.715,146.925),(13.565,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,146.925),(13.885,147.075),(14.035,147.075),(14.035,146.925),(13.885,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,146.925),(14.205,147.075),(14.355,147.075),(14.355,146.925),(14.205,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,147.245),(13.245,147.395),(13.395,147.395),(13.395,147.245),(13.245,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,147.245),(13.565,147.395),(13.715,147.395),(13.715,147.245),(13.565,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,147.245),(13.885,147.395),(14.035,147.395),(14.035,147.245),(13.885,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,147.245),(14.205,147.395),(14.355,147.395),(14.355,147.245),(14.205,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,147.565),(13.245,147.715),(13.395,147.715),(13.395,147.565),(13.245,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,147.565),(13.565,147.715),(13.715,147.715),(13.715,147.565),(13.565,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,147.565),(13.885,147.715),(14.035,147.715),(14.035,147.565),(13.885,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,147.565),(14.205,147.715),(14.355,147.715),(14.355,147.565),(14.205,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,147.885),(13.245,148.035),(13.395,148.035),(13.395,147.885),(13.245,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,147.885),(13.565,148.035),(13.715,148.035),(13.715,147.885),(13.565,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,147.885),(13.885,148.035),(14.035,148.035),(14.035,147.885),(13.885,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,147.885),(14.205,148.035),(14.355,148.035),(14.355,147.885),(14.205,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,148.205),(13.245,148.355),(13.395,148.355),(13.395,148.205),(13.245,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,148.205),(13.565,148.355),(13.715,148.355),(13.715,148.205),(13.565,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,148.205),(13.885,148.355),(14.035,148.355),(14.035,148.205),(13.885,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,148.205),(14.205,148.355),(14.355,148.355),(14.355,148.205),(14.205,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,148.525),(13.245,148.675),(13.395,148.675),(13.395,148.525),(13.245,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,148.525),(13.565,148.675),(13.715,148.675),(13.715,148.525),(13.565,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,148.525),(13.885,148.675),(14.035,148.675),(14.035,148.525),(13.885,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,148.525),(14.205,148.675),(14.355,148.675),(14.355,148.525),(14.205,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,148.845),(13.245,148.995),(13.395,148.995),(13.395,148.845),(13.245,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,148.845),(13.565,148.995),(13.715,148.995),(13.715,148.845),(13.565,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,148.845),(13.885,148.995),(14.035,148.995),(14.035,148.845),(13.885,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,148.845),(14.205,148.995),(14.355,148.995),(14.355,148.845),(14.205,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,149.165),(13.245,149.315),(13.395,149.315),(13.395,149.165),(13.245,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,149.165),(13.565,149.315),(13.715,149.315),(13.715,149.165),(13.565,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,149.165),(13.885,149.315),(14.035,149.315),(14.035,149.165),(13.885,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,149.165),(14.205,149.315),(14.355,149.315),(14.355,149.165),(14.205,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,149.485),(13.245,149.635),(13.395,149.635),(13.395,149.485),(13.245,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,149.485),(13.565,149.635),(13.715,149.635),(13.715,149.485),(13.565,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,149.485),(13.885,149.635),(14.035,149.635),(14.035,149.485),(13.885,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,149.485),(14.205,149.635),(14.355,149.635),(14.355,149.485),(14.205,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,149.805),(13.245,149.955),(13.395,149.955),(13.395,149.805),(13.245,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,149.805),(13.565,149.955),(13.715,149.955),(13.715,149.805),(13.565,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,149.805),(13.885,149.955),(14.035,149.955),(14.035,149.805),(13.885,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,149.805),(14.205,149.955),(14.355,149.955),(14.355,149.805),(14.205,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,150.125),(13.245,150.275),(13.395,150.275),(13.395,150.125),(13.245,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,150.125),(13.565,150.275),(13.715,150.275),(13.715,150.125),(13.565,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,150.125),(13.885,150.275),(14.035,150.275),(14.035,150.125),(13.885,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,150.125),(14.205,150.275),(14.355,150.275),(14.355,150.125),(14.205,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,150.445),(13.245,150.595),(13.395,150.595),(13.395,150.445),(13.245,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,150.445),(13.565,150.595),(13.715,150.595),(13.715,150.445),(13.565,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,150.445),(13.885,150.595),(14.035,150.595),(14.035,150.445),(13.885,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,150.445),(14.205,150.595),(14.355,150.595),(14.355,150.445),(14.205,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,150.765),(13.245,150.915),(13.395,150.915),(13.395,150.765),(13.245,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,150.765),(13.565,150.915),(13.715,150.915),(13.715,150.765),(13.565,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,150.765),(13.885,150.915),(14.035,150.915),(14.035,150.765),(13.885,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,150.765),(14.205,150.915),(14.355,150.915),(14.355,150.765),(14.205,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,151.085),(13.245,151.235),(13.395,151.235),(13.395,151.085),(13.245,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,151.085),(13.565,151.235),(13.715,151.235),(13.715,151.085),(13.565,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,151.085),(13.885,151.235),(14.035,151.235),(14.035,151.085),(13.885,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,151.085),(14.205,151.235),(14.355,151.235),(14.355,151.085),(14.205,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,151.405),(13.245,151.555),(13.395,151.555),(13.395,151.405),(13.245,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,151.405),(13.565,151.555),(13.715,151.555),(13.715,151.405),(13.565,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,151.405),(13.885,151.555),(14.035,151.555),(14.035,151.405),(13.885,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,151.405),(14.205,151.555),(14.355,151.555),(14.355,151.405),(14.205,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((13.245,151.725),(13.245,151.875),(13.395,151.875),(13.395,151.725),(13.245,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.565,151.725),(13.565,151.875),(13.715,151.875),(13.715,151.725),(13.565,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((13.885,151.725),(13.885,151.875),(14.035,151.875),(14.035,151.725),(13.885,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((14.205,151.725),(14.205,151.875),(14.355,151.875),(14.355,151.725),(14.205,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,142.125),(18.045,142.275),(18.195,142.275),(18.195,142.125),(18.045,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,142.125),(18.365,142.275),(18.515,142.275),(18.515,142.125),(18.365,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,142.125),(18.685,142.275),(18.835,142.275),(18.835,142.125),(18.685,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,142.125),(19.005,142.275),(19.155,142.275),(19.155,142.125),(19.005,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,142.445),(18.045,142.595),(18.195,142.595),(18.195,142.445),(18.045,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,142.445),(18.365,142.595),(18.515,142.595),(18.515,142.445),(18.365,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,142.445),(18.685,142.595),(18.835,142.595),(18.835,142.445),(18.685,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,142.445),(19.005,142.595),(19.155,142.595),(19.155,142.445),(19.005,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,142.765),(18.045,142.915),(18.195,142.915),(18.195,142.765),(18.045,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,142.765),(18.365,142.915),(18.515,142.915),(18.515,142.765),(18.365,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,142.765),(18.685,142.915),(18.835,142.915),(18.835,142.765),(18.685,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,142.765),(19.005,142.915),(19.155,142.915),(19.155,142.765),(19.005,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,143.085),(18.045,143.235),(18.195,143.235),(18.195,143.085),(18.045,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,143.085),(18.365,143.235),(18.515,143.235),(18.515,143.085),(18.365,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,143.085),(18.685,143.235),(18.835,143.235),(18.835,143.085),(18.685,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,143.085),(19.005,143.235),(19.155,143.235),(19.155,143.085),(19.005,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,143.405),(18.045,143.555),(18.195,143.555),(18.195,143.405),(18.045,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,143.405),(18.365,143.555),(18.515,143.555),(18.515,143.405),(18.365,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,143.405),(18.685,143.555),(18.835,143.555),(18.835,143.405),(18.685,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,143.405),(19.005,143.555),(19.155,143.555),(19.155,143.405),(19.005,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,143.725),(18.045,143.875),(18.195,143.875),(18.195,143.725),(18.045,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,143.725),(18.365,143.875),(18.515,143.875),(18.515,143.725),(18.365,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,143.725),(18.685,143.875),(18.835,143.875),(18.835,143.725),(18.685,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,143.725),(19.005,143.875),(19.155,143.875),(19.155,143.725),(19.005,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,144.045),(18.045,144.195),(18.195,144.195),(18.195,144.045),(18.045,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,144.045),(18.365,144.195),(18.515,144.195),(18.515,144.045),(18.365,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,144.045),(18.685,144.195),(18.835,144.195),(18.835,144.045),(18.685,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,144.045),(19.005,144.195),(19.155,144.195),(19.155,144.045),(19.005,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,144.365),(18.045,144.515),(18.195,144.515),(18.195,144.365),(18.045,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,144.365),(18.365,144.515),(18.515,144.515),(18.515,144.365),(18.365,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,144.365),(18.685,144.515),(18.835,144.515),(18.835,144.365),(18.685,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,144.365),(19.005,144.515),(19.155,144.515),(19.155,144.365),(19.005,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,144.685),(18.045,144.835),(18.195,144.835),(18.195,144.685),(18.045,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,144.685),(18.365,144.835),(18.515,144.835),(18.515,144.685),(18.365,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,144.685),(18.685,144.835),(18.835,144.835),(18.835,144.685),(18.685,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,144.685),(19.005,144.835),(19.155,144.835),(19.155,144.685),(19.005,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,145.005),(18.045,145.155),(18.195,145.155),(18.195,145.005),(18.045,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,145.005),(18.365,145.155),(18.515,145.155),(18.515,145.005),(18.365,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,145.005),(18.685,145.155),(18.835,145.155),(18.835,145.005),(18.685,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,145.005),(19.005,145.155),(19.155,145.155),(19.155,145.005),(19.005,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,145.325),(18.045,145.475),(18.195,145.475),(18.195,145.325),(18.045,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,145.325),(18.365,145.475),(18.515,145.475),(18.515,145.325),(18.365,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,145.325),(18.685,145.475),(18.835,145.475),(18.835,145.325),(18.685,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,145.325),(19.005,145.475),(19.155,145.475),(19.155,145.325),(19.005,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,145.645),(18.045,145.795),(18.195,145.795),(18.195,145.645),(18.045,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,145.645),(18.365,145.795),(18.515,145.795),(18.515,145.645),(18.365,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,145.645),(18.685,145.795),(18.835,145.795),(18.835,145.645),(18.685,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,145.645),(19.005,145.795),(19.155,145.795),(19.155,145.645),(19.005,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,145.965),(18.045,146.115),(18.195,146.115),(18.195,145.965),(18.045,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,145.965),(18.365,146.115),(18.515,146.115),(18.515,145.965),(18.365,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,145.965),(18.685,146.115),(18.835,146.115),(18.835,145.965),(18.685,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,145.965),(19.005,146.115),(19.155,146.115),(19.155,145.965),(19.005,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,146.285),(18.045,146.435),(18.195,146.435),(18.195,146.285),(18.045,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,146.285),(18.365,146.435),(18.515,146.435),(18.515,146.285),(18.365,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,146.285),(18.685,146.435),(18.835,146.435),(18.835,146.285),(18.685,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,146.285),(19.005,146.435),(19.155,146.435),(19.155,146.285),(19.005,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,146.605),(18.045,146.755),(18.195,146.755),(18.195,146.605),(18.045,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,146.605),(18.365,146.755),(18.515,146.755),(18.515,146.605),(18.365,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,146.605),(18.685,146.755),(18.835,146.755),(18.835,146.605),(18.685,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,146.605),(19.005,146.755),(19.155,146.755),(19.155,146.605),(19.005,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,146.925),(18.045,147.075),(18.195,147.075),(18.195,146.925),(18.045,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,146.925),(18.365,147.075),(18.515,147.075),(18.515,146.925),(18.365,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,146.925),(18.685,147.075),(18.835,147.075),(18.835,146.925),(18.685,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,146.925),(19.005,147.075),(19.155,147.075),(19.155,146.925),(19.005,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,147.245),(18.045,147.395),(18.195,147.395),(18.195,147.245),(18.045,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,147.245),(18.365,147.395),(18.515,147.395),(18.515,147.245),(18.365,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,147.245),(18.685,147.395),(18.835,147.395),(18.835,147.245),(18.685,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,147.245),(19.005,147.395),(19.155,147.395),(19.155,147.245),(19.005,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,147.565),(18.045,147.715),(18.195,147.715),(18.195,147.565),(18.045,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,147.565),(18.365,147.715),(18.515,147.715),(18.515,147.565),(18.365,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,147.565),(18.685,147.715),(18.835,147.715),(18.835,147.565),(18.685,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,147.565),(19.005,147.715),(19.155,147.715),(19.155,147.565),(19.005,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,147.885),(18.045,148.035),(18.195,148.035),(18.195,147.885),(18.045,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,147.885),(18.365,148.035),(18.515,148.035),(18.515,147.885),(18.365,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,147.885),(18.685,148.035),(18.835,148.035),(18.835,147.885),(18.685,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,147.885),(19.005,148.035),(19.155,148.035),(19.155,147.885),(19.005,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,148.205),(18.045,148.355),(18.195,148.355),(18.195,148.205),(18.045,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,148.205),(18.365,148.355),(18.515,148.355),(18.515,148.205),(18.365,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,148.205),(18.685,148.355),(18.835,148.355),(18.835,148.205),(18.685,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,148.205),(19.005,148.355),(19.155,148.355),(19.155,148.205),(19.005,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,148.525),(18.045,148.675),(18.195,148.675),(18.195,148.525),(18.045,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,148.525),(18.365,148.675),(18.515,148.675),(18.515,148.525),(18.365,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,148.525),(18.685,148.675),(18.835,148.675),(18.835,148.525),(18.685,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,148.525),(19.005,148.675),(19.155,148.675),(19.155,148.525),(19.005,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,148.845),(18.045,148.995),(18.195,148.995),(18.195,148.845),(18.045,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,148.845),(18.365,148.995),(18.515,148.995),(18.515,148.845),(18.365,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,148.845),(18.685,148.995),(18.835,148.995),(18.835,148.845),(18.685,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,148.845),(19.005,148.995),(19.155,148.995),(19.155,148.845),(19.005,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,149.165),(18.045,149.315),(18.195,149.315),(18.195,149.165),(18.045,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,149.165),(18.365,149.315),(18.515,149.315),(18.515,149.165),(18.365,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,149.165),(18.685,149.315),(18.835,149.315),(18.835,149.165),(18.685,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,149.165),(19.005,149.315),(19.155,149.315),(19.155,149.165),(19.005,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,149.485),(18.045,149.635),(18.195,149.635),(18.195,149.485),(18.045,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,149.485),(18.365,149.635),(18.515,149.635),(18.515,149.485),(18.365,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,149.485),(18.685,149.635),(18.835,149.635),(18.835,149.485),(18.685,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,149.485),(19.005,149.635),(19.155,149.635),(19.155,149.485),(19.005,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,149.805),(18.045,149.955),(18.195,149.955),(18.195,149.805),(18.045,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,149.805),(18.365,149.955),(18.515,149.955),(18.515,149.805),(18.365,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,149.805),(18.685,149.955),(18.835,149.955),(18.835,149.805),(18.685,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,149.805),(19.005,149.955),(19.155,149.955),(19.155,149.805),(19.005,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,150.125),(18.045,150.275),(18.195,150.275),(18.195,150.125),(18.045,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,150.125),(18.365,150.275),(18.515,150.275),(18.515,150.125),(18.365,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,150.125),(18.685,150.275),(18.835,150.275),(18.835,150.125),(18.685,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,150.125),(19.005,150.275),(19.155,150.275),(19.155,150.125),(19.005,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,150.445),(18.045,150.595),(18.195,150.595),(18.195,150.445),(18.045,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,150.445),(18.365,150.595),(18.515,150.595),(18.515,150.445),(18.365,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,150.445),(18.685,150.595),(18.835,150.595),(18.835,150.445),(18.685,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,150.445),(19.005,150.595),(19.155,150.595),(19.155,150.445),(19.005,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,150.765),(18.045,150.915),(18.195,150.915),(18.195,150.765),(18.045,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,150.765),(18.365,150.915),(18.515,150.915),(18.515,150.765),(18.365,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,150.765),(18.685,150.915),(18.835,150.915),(18.835,150.765),(18.685,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,150.765),(19.005,150.915),(19.155,150.915),(19.155,150.765),(19.005,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,151.085),(18.045,151.235),(18.195,151.235),(18.195,151.085),(18.045,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,151.085),(18.365,151.235),(18.515,151.235),(18.515,151.085),(18.365,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,151.085),(18.685,151.235),(18.835,151.235),(18.835,151.085),(18.685,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,151.085),(19.005,151.235),(19.155,151.235),(19.155,151.085),(19.005,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,151.405),(18.045,151.555),(18.195,151.555),(18.195,151.405),(18.045,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,151.405),(18.365,151.555),(18.515,151.555),(18.515,151.405),(18.365,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,151.405),(18.685,151.555),(18.835,151.555),(18.835,151.405),(18.685,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,151.405),(19.005,151.555),(19.155,151.555),(19.155,151.405),(19.005,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((18.045,151.725),(18.045,151.875),(18.195,151.875),(18.195,151.725),(18.045,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.365,151.725),(18.365,151.875),(18.515,151.875),(18.515,151.725),(18.365,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((18.685,151.725),(18.685,151.875),(18.835,151.875),(18.835,151.725),(18.685,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((19.005,151.725),(19.005,151.875),(19.155,151.875),(19.155,151.725),(19.005,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,142.125),(51.645,142.275),(51.795,142.275),(51.795,142.125),(51.645,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,142.125),(51.965,142.275),(52.115,142.275),(52.115,142.125),(51.965,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,142.125),(52.285,142.275),(52.435,142.275),(52.435,142.125),(52.285,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,142.125),(52.605,142.275),(52.755,142.275),(52.755,142.125),(52.605,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,142.445),(51.645,142.595),(51.795,142.595),(51.795,142.445),(51.645,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,142.445),(51.965,142.595),(52.115,142.595),(52.115,142.445),(51.965,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,142.445),(52.285,142.595),(52.435,142.595),(52.435,142.445),(52.285,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,142.445),(52.605,142.595),(52.755,142.595),(52.755,142.445),(52.605,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,142.765),(51.645,142.915),(51.795,142.915),(51.795,142.765),(51.645,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,142.765),(51.965,142.915),(52.115,142.915),(52.115,142.765),(51.965,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,142.765),(52.285,142.915),(52.435,142.915),(52.435,142.765),(52.285,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,142.765),(52.605,142.915),(52.755,142.915),(52.755,142.765),(52.605,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,143.085),(51.645,143.235),(51.795,143.235),(51.795,143.085),(51.645,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,143.085),(51.965,143.235),(52.115,143.235),(52.115,143.085),(51.965,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,143.085),(52.285,143.235),(52.435,143.235),(52.435,143.085),(52.285,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,143.085),(52.605,143.235),(52.755,143.235),(52.755,143.085),(52.605,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,143.405),(51.645,143.555),(51.795,143.555),(51.795,143.405),(51.645,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,143.405),(51.965,143.555),(52.115,143.555),(52.115,143.405),(51.965,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,143.405),(52.285,143.555),(52.435,143.555),(52.435,143.405),(52.285,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,143.405),(52.605,143.555),(52.755,143.555),(52.755,143.405),(52.605,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,143.725),(51.645,143.875),(51.795,143.875),(51.795,143.725),(51.645,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,143.725),(51.965,143.875),(52.115,143.875),(52.115,143.725),(51.965,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,143.725),(52.285,143.875),(52.435,143.875),(52.435,143.725),(52.285,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,143.725),(52.605,143.875),(52.755,143.875),(52.755,143.725),(52.605,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,144.045),(51.645,144.195),(51.795,144.195),(51.795,144.045),(51.645,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,144.045),(51.965,144.195),(52.115,144.195),(52.115,144.045),(51.965,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,144.045),(52.285,144.195),(52.435,144.195),(52.435,144.045),(52.285,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,144.045),(52.605,144.195),(52.755,144.195),(52.755,144.045),(52.605,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,144.365),(51.645,144.515),(51.795,144.515),(51.795,144.365),(51.645,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,144.365),(51.965,144.515),(52.115,144.515),(52.115,144.365),(51.965,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,144.365),(52.285,144.515),(52.435,144.515),(52.435,144.365),(52.285,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,144.365),(52.605,144.515),(52.755,144.515),(52.755,144.365),(52.605,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,144.685),(51.645,144.835),(51.795,144.835),(51.795,144.685),(51.645,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,144.685),(51.965,144.835),(52.115,144.835),(52.115,144.685),(51.965,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,144.685),(52.285,144.835),(52.435,144.835),(52.435,144.685),(52.285,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,144.685),(52.605,144.835),(52.755,144.835),(52.755,144.685),(52.605,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,145.005),(51.645,145.155),(51.795,145.155),(51.795,145.005),(51.645,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,145.005),(51.965,145.155),(52.115,145.155),(52.115,145.005),(51.965,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,145.005),(52.285,145.155),(52.435,145.155),(52.435,145.005),(52.285,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,145.005),(52.605,145.155),(52.755,145.155),(52.755,145.005),(52.605,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,145.325),(51.645,145.475),(51.795,145.475),(51.795,145.325),(51.645,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,145.325),(51.965,145.475),(52.115,145.475),(52.115,145.325),(51.965,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,145.325),(52.285,145.475),(52.435,145.475),(52.435,145.325),(52.285,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,145.325),(52.605,145.475),(52.755,145.475),(52.755,145.325),(52.605,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,145.645),(51.645,145.795),(51.795,145.795),(51.795,145.645),(51.645,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,145.645),(51.965,145.795),(52.115,145.795),(52.115,145.645),(51.965,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,145.645),(52.285,145.795),(52.435,145.795),(52.435,145.645),(52.285,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,145.645),(52.605,145.795),(52.755,145.795),(52.755,145.645),(52.605,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,145.965),(51.645,146.115),(51.795,146.115),(51.795,145.965),(51.645,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,145.965),(51.965,146.115),(52.115,146.115),(52.115,145.965),(51.965,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,145.965),(52.285,146.115),(52.435,146.115),(52.435,145.965),(52.285,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,145.965),(52.605,146.115),(52.755,146.115),(52.755,145.965),(52.605,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,146.285),(51.645,146.435),(51.795,146.435),(51.795,146.285),(51.645,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,146.285),(51.965,146.435),(52.115,146.435),(52.115,146.285),(51.965,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,146.285),(52.285,146.435),(52.435,146.435),(52.435,146.285),(52.285,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,146.285),(52.605,146.435),(52.755,146.435),(52.755,146.285),(52.605,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,146.605),(51.645,146.755),(51.795,146.755),(51.795,146.605),(51.645,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,146.605),(51.965,146.755),(52.115,146.755),(52.115,146.605),(51.965,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,146.605),(52.285,146.755),(52.435,146.755),(52.435,146.605),(52.285,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,146.605),(52.605,146.755),(52.755,146.755),(52.755,146.605),(52.605,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,146.925),(51.645,147.075),(51.795,147.075),(51.795,146.925),(51.645,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,146.925),(51.965,147.075),(52.115,147.075),(52.115,146.925),(51.965,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,146.925),(52.285,147.075),(52.435,147.075),(52.435,146.925),(52.285,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,146.925),(52.605,147.075),(52.755,147.075),(52.755,146.925),(52.605,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,147.245),(51.645,147.395),(51.795,147.395),(51.795,147.245),(51.645,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,147.245),(51.965,147.395),(52.115,147.395),(52.115,147.245),(51.965,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,147.245),(52.285,147.395),(52.435,147.395),(52.435,147.245),(52.285,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,147.245),(52.605,147.395),(52.755,147.395),(52.755,147.245),(52.605,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,147.565),(51.645,147.715),(51.795,147.715),(51.795,147.565),(51.645,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,147.565),(51.965,147.715),(52.115,147.715),(52.115,147.565),(51.965,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,147.565),(52.285,147.715),(52.435,147.715),(52.435,147.565),(52.285,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,147.565),(52.605,147.715),(52.755,147.715),(52.755,147.565),(52.605,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,147.885),(51.645,148.035),(51.795,148.035),(51.795,147.885),(51.645,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,147.885),(51.965,148.035),(52.115,148.035),(52.115,147.885),(51.965,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,147.885),(52.285,148.035),(52.435,148.035),(52.435,147.885),(52.285,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,147.885),(52.605,148.035),(52.755,148.035),(52.755,147.885),(52.605,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,148.205),(51.645,148.355),(51.795,148.355),(51.795,148.205),(51.645,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,148.205),(51.965,148.355),(52.115,148.355),(52.115,148.205),(51.965,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,148.205),(52.285,148.355),(52.435,148.355),(52.435,148.205),(52.285,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,148.205),(52.605,148.355),(52.755,148.355),(52.755,148.205),(52.605,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,148.525),(51.645,148.675),(51.795,148.675),(51.795,148.525),(51.645,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,148.525),(51.965,148.675),(52.115,148.675),(52.115,148.525),(51.965,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,148.525),(52.285,148.675),(52.435,148.675),(52.435,148.525),(52.285,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,148.525),(52.605,148.675),(52.755,148.675),(52.755,148.525),(52.605,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,148.845),(51.645,148.995),(51.795,148.995),(51.795,148.845),(51.645,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,148.845),(51.965,148.995),(52.115,148.995),(52.115,148.845),(51.965,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,148.845),(52.285,148.995),(52.435,148.995),(52.435,148.845),(52.285,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,148.845),(52.605,148.995),(52.755,148.995),(52.755,148.845),(52.605,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,149.165),(51.645,149.315),(51.795,149.315),(51.795,149.165),(51.645,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,149.165),(51.965,149.315),(52.115,149.315),(52.115,149.165),(51.965,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,149.165),(52.285,149.315),(52.435,149.315),(52.435,149.165),(52.285,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,149.165),(52.605,149.315),(52.755,149.315),(52.755,149.165),(52.605,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,149.485),(51.645,149.635),(51.795,149.635),(51.795,149.485),(51.645,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,149.485),(51.965,149.635),(52.115,149.635),(52.115,149.485),(51.965,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,149.485),(52.285,149.635),(52.435,149.635),(52.435,149.485),(52.285,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,149.485),(52.605,149.635),(52.755,149.635),(52.755,149.485),(52.605,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,149.805),(51.645,149.955),(51.795,149.955),(51.795,149.805),(51.645,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,149.805),(51.965,149.955),(52.115,149.955),(52.115,149.805),(51.965,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,149.805),(52.285,149.955),(52.435,149.955),(52.435,149.805),(52.285,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,149.805),(52.605,149.955),(52.755,149.955),(52.755,149.805),(52.605,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,150.125),(51.645,150.275),(51.795,150.275),(51.795,150.125),(51.645,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,150.125),(51.965,150.275),(52.115,150.275),(52.115,150.125),(51.965,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,150.125),(52.285,150.275),(52.435,150.275),(52.435,150.125),(52.285,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,150.125),(52.605,150.275),(52.755,150.275),(52.755,150.125),(52.605,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,150.445),(51.645,150.595),(51.795,150.595),(51.795,150.445),(51.645,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,150.445),(51.965,150.595),(52.115,150.595),(52.115,150.445),(51.965,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,150.445),(52.285,150.595),(52.435,150.595),(52.435,150.445),(52.285,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,150.445),(52.605,150.595),(52.755,150.595),(52.755,150.445),(52.605,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,150.765),(51.645,150.915),(51.795,150.915),(51.795,150.765),(51.645,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,150.765),(51.965,150.915),(52.115,150.915),(52.115,150.765),(51.965,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,150.765),(52.285,150.915),(52.435,150.915),(52.435,150.765),(52.285,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,150.765),(52.605,150.915),(52.755,150.915),(52.755,150.765),(52.605,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,151.085),(51.645,151.235),(51.795,151.235),(51.795,151.085),(51.645,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,151.085),(51.965,151.235),(52.115,151.235),(52.115,151.085),(51.965,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,151.085),(52.285,151.235),(52.435,151.235),(52.435,151.085),(52.285,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,151.085),(52.605,151.235),(52.755,151.235),(52.755,151.085),(52.605,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,151.405),(51.645,151.555),(51.795,151.555),(51.795,151.405),(51.645,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,151.405),(51.965,151.555),(52.115,151.555),(52.115,151.405),(51.965,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,151.405),(52.285,151.555),(52.435,151.555),(52.435,151.405),(52.285,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,151.405),(52.605,151.555),(52.755,151.555),(52.755,151.405),(52.605,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,151.725),(51.645,151.875),(51.795,151.875),(51.795,151.725),(51.645,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,151.725),(51.965,151.875),(52.115,151.875),(52.115,151.725),(51.965,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,151.725),(52.285,151.875),(52.435,151.875),(52.435,151.725),(52.285,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,151.725),(52.605,151.875),(52.755,151.875),(52.755,151.725),(52.605,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,142.125),(46.845,142.275),(46.995,142.275),(46.995,142.125),(46.845,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,142.125),(47.165,142.275),(47.315,142.275),(47.315,142.125),(47.165,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,142.125),(47.485,142.275),(47.635,142.275),(47.635,142.125),(47.485,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,142.125),(47.805,142.275),(47.955,142.275),(47.955,142.125),(47.805,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,142.445),(46.845,142.595),(46.995,142.595),(46.995,142.445),(46.845,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,142.445),(47.165,142.595),(47.315,142.595),(47.315,142.445),(47.165,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,142.445),(47.485,142.595),(47.635,142.595),(47.635,142.445),(47.485,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,142.445),(47.805,142.595),(47.955,142.595),(47.955,142.445),(47.805,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,142.765),(46.845,142.915),(46.995,142.915),(46.995,142.765),(46.845,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,142.765),(47.165,142.915),(47.315,142.915),(47.315,142.765),(47.165,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,142.765),(47.485,142.915),(47.635,142.915),(47.635,142.765),(47.485,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,142.765),(47.805,142.915),(47.955,142.915),(47.955,142.765),(47.805,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,143.085),(46.845,143.235),(46.995,143.235),(46.995,143.085),(46.845,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,143.085),(47.165,143.235),(47.315,143.235),(47.315,143.085),(47.165,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,143.085),(47.485,143.235),(47.635,143.235),(47.635,143.085),(47.485,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,143.085),(47.805,143.235),(47.955,143.235),(47.955,143.085),(47.805,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,143.405),(46.845,143.555),(46.995,143.555),(46.995,143.405),(46.845,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,143.405),(47.165,143.555),(47.315,143.555),(47.315,143.405),(47.165,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,143.405),(47.485,143.555),(47.635,143.555),(47.635,143.405),(47.485,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,143.405),(47.805,143.555),(47.955,143.555),(47.955,143.405),(47.805,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,143.725),(46.845,143.875),(46.995,143.875),(46.995,143.725),(46.845,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,143.725),(47.165,143.875),(47.315,143.875),(47.315,143.725),(47.165,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,143.725),(47.485,143.875),(47.635,143.875),(47.635,143.725),(47.485,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,143.725),(47.805,143.875),(47.955,143.875),(47.955,143.725),(47.805,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,144.045),(46.845,144.195),(46.995,144.195),(46.995,144.045),(46.845,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,144.045),(47.165,144.195),(47.315,144.195),(47.315,144.045),(47.165,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,144.045),(47.485,144.195),(47.635,144.195),(47.635,144.045),(47.485,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,144.045),(47.805,144.195),(47.955,144.195),(47.955,144.045),(47.805,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,144.365),(46.845,144.515),(46.995,144.515),(46.995,144.365),(46.845,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,144.365),(47.165,144.515),(47.315,144.515),(47.315,144.365),(47.165,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,144.365),(47.485,144.515),(47.635,144.515),(47.635,144.365),(47.485,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,144.365),(47.805,144.515),(47.955,144.515),(47.955,144.365),(47.805,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,144.685),(46.845,144.835),(46.995,144.835),(46.995,144.685),(46.845,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,144.685),(47.165,144.835),(47.315,144.835),(47.315,144.685),(47.165,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,144.685),(47.485,144.835),(47.635,144.835),(47.635,144.685),(47.485,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,144.685),(47.805,144.835),(47.955,144.835),(47.955,144.685),(47.805,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,145.005),(46.845,145.155),(46.995,145.155),(46.995,145.005),(46.845,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,145.005),(47.165,145.155),(47.315,145.155),(47.315,145.005),(47.165,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,145.005),(47.485,145.155),(47.635,145.155),(47.635,145.005),(47.485,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,145.005),(47.805,145.155),(47.955,145.155),(47.955,145.005),(47.805,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,145.325),(46.845,145.475),(46.995,145.475),(46.995,145.325),(46.845,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,145.325),(47.165,145.475),(47.315,145.475),(47.315,145.325),(47.165,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,145.325),(47.485,145.475),(47.635,145.475),(47.635,145.325),(47.485,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,145.325),(47.805,145.475),(47.955,145.475),(47.955,145.325),(47.805,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,145.645),(46.845,145.795),(46.995,145.795),(46.995,145.645),(46.845,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,145.645),(47.165,145.795),(47.315,145.795),(47.315,145.645),(47.165,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,145.645),(47.485,145.795),(47.635,145.795),(47.635,145.645),(47.485,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,145.645),(47.805,145.795),(47.955,145.795),(47.955,145.645),(47.805,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,145.965),(46.845,146.115),(46.995,146.115),(46.995,145.965),(46.845,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,145.965),(47.165,146.115),(47.315,146.115),(47.315,145.965),(47.165,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,145.965),(47.485,146.115),(47.635,146.115),(47.635,145.965),(47.485,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,145.965),(47.805,146.115),(47.955,146.115),(47.955,145.965),(47.805,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,146.285),(46.845,146.435),(46.995,146.435),(46.995,146.285),(46.845,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,146.285),(47.165,146.435),(47.315,146.435),(47.315,146.285),(47.165,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,146.285),(47.485,146.435),(47.635,146.435),(47.635,146.285),(47.485,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,146.285),(47.805,146.435),(47.955,146.435),(47.955,146.285),(47.805,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,146.605),(46.845,146.755),(46.995,146.755),(46.995,146.605),(46.845,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,146.605),(47.165,146.755),(47.315,146.755),(47.315,146.605),(47.165,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,146.605),(47.485,146.755),(47.635,146.755),(47.635,146.605),(47.485,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,146.605),(47.805,146.755),(47.955,146.755),(47.955,146.605),(47.805,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,146.925),(46.845,147.075),(46.995,147.075),(46.995,146.925),(46.845,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,146.925),(47.165,147.075),(47.315,147.075),(47.315,146.925),(47.165,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,146.925),(47.485,147.075),(47.635,147.075),(47.635,146.925),(47.485,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,146.925),(47.805,147.075),(47.955,147.075),(47.955,146.925),(47.805,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,147.245),(46.845,147.395),(46.995,147.395),(46.995,147.245),(46.845,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,147.245),(47.165,147.395),(47.315,147.395),(47.315,147.245),(47.165,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,147.245),(47.485,147.395),(47.635,147.395),(47.635,147.245),(47.485,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,147.245),(47.805,147.395),(47.955,147.395),(47.955,147.245),(47.805,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,147.565),(46.845,147.715),(46.995,147.715),(46.995,147.565),(46.845,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,147.565),(47.165,147.715),(47.315,147.715),(47.315,147.565),(47.165,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,147.565),(47.485,147.715),(47.635,147.715),(47.635,147.565),(47.485,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,147.565),(47.805,147.715),(47.955,147.715),(47.955,147.565),(47.805,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,147.885),(46.845,148.035),(46.995,148.035),(46.995,147.885),(46.845,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,147.885),(47.165,148.035),(47.315,148.035),(47.315,147.885),(47.165,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,147.885),(47.485,148.035),(47.635,148.035),(47.635,147.885),(47.485,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,147.885),(47.805,148.035),(47.955,148.035),(47.955,147.885),(47.805,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,148.205),(46.845,148.355),(46.995,148.355),(46.995,148.205),(46.845,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,148.205),(47.165,148.355),(47.315,148.355),(47.315,148.205),(47.165,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,148.205),(47.485,148.355),(47.635,148.355),(47.635,148.205),(47.485,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,148.205),(47.805,148.355),(47.955,148.355),(47.955,148.205),(47.805,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,148.525),(46.845,148.675),(46.995,148.675),(46.995,148.525),(46.845,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,148.525),(47.165,148.675),(47.315,148.675),(47.315,148.525),(47.165,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,148.525),(47.485,148.675),(47.635,148.675),(47.635,148.525),(47.485,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,148.525),(47.805,148.675),(47.955,148.675),(47.955,148.525),(47.805,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,148.845),(46.845,148.995),(46.995,148.995),(46.995,148.845),(46.845,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,148.845),(47.165,148.995),(47.315,148.995),(47.315,148.845),(47.165,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,148.845),(47.485,148.995),(47.635,148.995),(47.635,148.845),(47.485,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,148.845),(47.805,148.995),(47.955,148.995),(47.955,148.845),(47.805,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,149.165),(46.845,149.315),(46.995,149.315),(46.995,149.165),(46.845,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,149.165),(47.165,149.315),(47.315,149.315),(47.315,149.165),(47.165,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,149.165),(47.485,149.315),(47.635,149.315),(47.635,149.165),(47.485,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,149.165),(47.805,149.315),(47.955,149.315),(47.955,149.165),(47.805,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,149.485),(46.845,149.635),(46.995,149.635),(46.995,149.485),(46.845,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,149.485),(47.165,149.635),(47.315,149.635),(47.315,149.485),(47.165,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,149.485),(47.485,149.635),(47.635,149.635),(47.635,149.485),(47.485,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,149.485),(47.805,149.635),(47.955,149.635),(47.955,149.485),(47.805,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,149.805),(46.845,149.955),(46.995,149.955),(46.995,149.805),(46.845,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,149.805),(47.165,149.955),(47.315,149.955),(47.315,149.805),(47.165,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,149.805),(47.485,149.955),(47.635,149.955),(47.635,149.805),(47.485,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,149.805),(47.805,149.955),(47.955,149.955),(47.955,149.805),(47.805,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,150.125),(46.845,150.275),(46.995,150.275),(46.995,150.125),(46.845,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,150.125),(47.165,150.275),(47.315,150.275),(47.315,150.125),(47.165,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,150.125),(47.485,150.275),(47.635,150.275),(47.635,150.125),(47.485,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,150.125),(47.805,150.275),(47.955,150.275),(47.955,150.125),(47.805,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,150.445),(46.845,150.595),(46.995,150.595),(46.995,150.445),(46.845,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,150.445),(47.165,150.595),(47.315,150.595),(47.315,150.445),(47.165,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,150.445),(47.485,150.595),(47.635,150.595),(47.635,150.445),(47.485,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,150.445),(47.805,150.595),(47.955,150.595),(47.955,150.445),(47.805,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,150.765),(46.845,150.915),(46.995,150.915),(46.995,150.765),(46.845,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,150.765),(47.165,150.915),(47.315,150.915),(47.315,150.765),(47.165,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,150.765),(47.485,150.915),(47.635,150.915),(47.635,150.765),(47.485,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,150.765),(47.805,150.915),(47.955,150.915),(47.955,150.765),(47.805,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,151.085),(46.845,151.235),(46.995,151.235),(46.995,151.085),(46.845,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,151.085),(47.165,151.235),(47.315,151.235),(47.315,151.085),(47.165,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,151.085),(47.485,151.235),(47.635,151.235),(47.635,151.085),(47.485,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,151.085),(47.805,151.235),(47.955,151.235),(47.955,151.085),(47.805,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,151.405),(46.845,151.555),(46.995,151.555),(46.995,151.405),(46.845,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,151.405),(47.165,151.555),(47.315,151.555),(47.315,151.405),(47.165,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,151.405),(47.485,151.555),(47.635,151.555),(47.635,151.405),(47.485,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,151.405),(47.805,151.555),(47.955,151.555),(47.955,151.405),(47.805,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,151.725),(46.845,151.875),(46.995,151.875),(46.995,151.725),(46.845,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,151.725),(47.165,151.875),(47.315,151.875),(47.315,151.725),(47.165,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,151.725),(47.485,151.875),(47.635,151.875),(47.635,151.725),(47.485,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,151.725),(47.805,151.875),(47.955,151.875),(47.955,151.725),(47.805,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,142.125),(42.045,142.275),(42.195,142.275),(42.195,142.125),(42.045,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,142.125),(42.365,142.275),(42.515,142.275),(42.515,142.125),(42.365,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,142.125),(42.685,142.275),(42.835,142.275),(42.835,142.125),(42.685,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,142.125),(43.005,142.275),(43.155,142.275),(43.155,142.125),(43.005,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,142.445),(42.045,142.595),(42.195,142.595),(42.195,142.445),(42.045,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,142.445),(42.365,142.595),(42.515,142.595),(42.515,142.445),(42.365,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,142.445),(42.685,142.595),(42.835,142.595),(42.835,142.445),(42.685,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,142.445),(43.005,142.595),(43.155,142.595),(43.155,142.445),(43.005,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,142.765),(42.045,142.915),(42.195,142.915),(42.195,142.765),(42.045,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,142.765),(42.365,142.915),(42.515,142.915),(42.515,142.765),(42.365,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,142.765),(42.685,142.915),(42.835,142.915),(42.835,142.765),(42.685,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,142.765),(43.005,142.915),(43.155,142.915),(43.155,142.765),(43.005,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,143.085),(42.045,143.235),(42.195,143.235),(42.195,143.085),(42.045,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,143.085),(42.365,143.235),(42.515,143.235),(42.515,143.085),(42.365,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,143.085),(42.685,143.235),(42.835,143.235),(42.835,143.085),(42.685,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,143.085),(43.005,143.235),(43.155,143.235),(43.155,143.085),(43.005,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,143.405),(42.045,143.555),(42.195,143.555),(42.195,143.405),(42.045,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,143.405),(42.365,143.555),(42.515,143.555),(42.515,143.405),(42.365,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,143.405),(42.685,143.555),(42.835,143.555),(42.835,143.405),(42.685,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,143.405),(43.005,143.555),(43.155,143.555),(43.155,143.405),(43.005,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,143.725),(42.045,143.875),(42.195,143.875),(42.195,143.725),(42.045,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,143.725),(42.365,143.875),(42.515,143.875),(42.515,143.725),(42.365,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,143.725),(42.685,143.875),(42.835,143.875),(42.835,143.725),(42.685,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,143.725),(43.005,143.875),(43.155,143.875),(43.155,143.725),(43.005,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,144.045),(42.045,144.195),(42.195,144.195),(42.195,144.045),(42.045,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,144.045),(42.365,144.195),(42.515,144.195),(42.515,144.045),(42.365,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,144.045),(42.685,144.195),(42.835,144.195),(42.835,144.045),(42.685,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,144.045),(43.005,144.195),(43.155,144.195),(43.155,144.045),(43.005,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,144.365),(42.045,144.515),(42.195,144.515),(42.195,144.365),(42.045,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,144.365),(42.365,144.515),(42.515,144.515),(42.515,144.365),(42.365,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,144.365),(42.685,144.515),(42.835,144.515),(42.835,144.365),(42.685,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,144.365),(43.005,144.515),(43.155,144.515),(43.155,144.365),(43.005,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,144.685),(42.045,144.835),(42.195,144.835),(42.195,144.685),(42.045,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,144.685),(42.365,144.835),(42.515,144.835),(42.515,144.685),(42.365,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,144.685),(42.685,144.835),(42.835,144.835),(42.835,144.685),(42.685,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,144.685),(43.005,144.835),(43.155,144.835),(43.155,144.685),(43.005,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,145.005),(42.045,145.155),(42.195,145.155),(42.195,145.005),(42.045,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,145.005),(42.365,145.155),(42.515,145.155),(42.515,145.005),(42.365,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,145.005),(42.685,145.155),(42.835,145.155),(42.835,145.005),(42.685,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,145.005),(43.005,145.155),(43.155,145.155),(43.155,145.005),(43.005,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,145.325),(42.045,145.475),(42.195,145.475),(42.195,145.325),(42.045,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,145.325),(42.365,145.475),(42.515,145.475),(42.515,145.325),(42.365,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,145.325),(42.685,145.475),(42.835,145.475),(42.835,145.325),(42.685,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,145.325),(43.005,145.475),(43.155,145.475),(43.155,145.325),(43.005,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,145.645),(42.045,145.795),(42.195,145.795),(42.195,145.645),(42.045,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,145.645),(42.365,145.795),(42.515,145.795),(42.515,145.645),(42.365,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,145.645),(42.685,145.795),(42.835,145.795),(42.835,145.645),(42.685,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,145.645),(43.005,145.795),(43.155,145.795),(43.155,145.645),(43.005,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,145.965),(42.045,146.115),(42.195,146.115),(42.195,145.965),(42.045,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,145.965),(42.365,146.115),(42.515,146.115),(42.515,145.965),(42.365,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,145.965),(42.685,146.115),(42.835,146.115),(42.835,145.965),(42.685,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,145.965),(43.005,146.115),(43.155,146.115),(43.155,145.965),(43.005,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,146.285),(42.045,146.435),(42.195,146.435),(42.195,146.285),(42.045,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,146.285),(42.365,146.435),(42.515,146.435),(42.515,146.285),(42.365,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,146.285),(42.685,146.435),(42.835,146.435),(42.835,146.285),(42.685,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,146.285),(43.005,146.435),(43.155,146.435),(43.155,146.285),(43.005,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,146.605),(42.045,146.755),(42.195,146.755),(42.195,146.605),(42.045,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,146.605),(42.365,146.755),(42.515,146.755),(42.515,146.605),(42.365,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,146.605),(42.685,146.755),(42.835,146.755),(42.835,146.605),(42.685,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,146.605),(43.005,146.755),(43.155,146.755),(43.155,146.605),(43.005,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,146.925),(42.045,147.075),(42.195,147.075),(42.195,146.925),(42.045,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,146.925),(42.365,147.075),(42.515,147.075),(42.515,146.925),(42.365,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,146.925),(42.685,147.075),(42.835,147.075),(42.835,146.925),(42.685,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,146.925),(43.005,147.075),(43.155,147.075),(43.155,146.925),(43.005,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,147.245),(42.045,147.395),(42.195,147.395),(42.195,147.245),(42.045,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,147.245),(42.365,147.395),(42.515,147.395),(42.515,147.245),(42.365,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,147.245),(42.685,147.395),(42.835,147.395),(42.835,147.245),(42.685,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,147.245),(43.005,147.395),(43.155,147.395),(43.155,147.245),(43.005,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,147.565),(42.045,147.715),(42.195,147.715),(42.195,147.565),(42.045,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,147.565),(42.365,147.715),(42.515,147.715),(42.515,147.565),(42.365,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,147.565),(42.685,147.715),(42.835,147.715),(42.835,147.565),(42.685,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,147.565),(43.005,147.715),(43.155,147.715),(43.155,147.565),(43.005,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,147.885),(42.045,148.035),(42.195,148.035),(42.195,147.885),(42.045,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,147.885),(42.365,148.035),(42.515,148.035),(42.515,147.885),(42.365,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,147.885),(42.685,148.035),(42.835,148.035),(42.835,147.885),(42.685,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,147.885),(43.005,148.035),(43.155,148.035),(43.155,147.885),(43.005,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,148.205),(42.045,148.355),(42.195,148.355),(42.195,148.205),(42.045,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,148.205),(42.365,148.355),(42.515,148.355),(42.515,148.205),(42.365,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,148.205),(42.685,148.355),(42.835,148.355),(42.835,148.205),(42.685,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,148.205),(43.005,148.355),(43.155,148.355),(43.155,148.205),(43.005,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,148.525),(42.045,148.675),(42.195,148.675),(42.195,148.525),(42.045,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,148.525),(42.365,148.675),(42.515,148.675),(42.515,148.525),(42.365,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,148.525),(42.685,148.675),(42.835,148.675),(42.835,148.525),(42.685,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,148.525),(43.005,148.675),(43.155,148.675),(43.155,148.525),(43.005,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,148.845),(42.045,148.995),(42.195,148.995),(42.195,148.845),(42.045,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,148.845),(42.365,148.995),(42.515,148.995),(42.515,148.845),(42.365,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,148.845),(42.685,148.995),(42.835,148.995),(42.835,148.845),(42.685,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,148.845),(43.005,148.995),(43.155,148.995),(43.155,148.845),(43.005,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,149.165),(42.045,149.315),(42.195,149.315),(42.195,149.165),(42.045,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,149.165),(42.365,149.315),(42.515,149.315),(42.515,149.165),(42.365,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,149.165),(42.685,149.315),(42.835,149.315),(42.835,149.165),(42.685,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,149.165),(43.005,149.315),(43.155,149.315),(43.155,149.165),(43.005,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,149.485),(42.045,149.635),(42.195,149.635),(42.195,149.485),(42.045,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,149.485),(42.365,149.635),(42.515,149.635),(42.515,149.485),(42.365,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,149.485),(42.685,149.635),(42.835,149.635),(42.835,149.485),(42.685,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,149.485),(43.005,149.635),(43.155,149.635),(43.155,149.485),(43.005,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,149.805),(42.045,149.955),(42.195,149.955),(42.195,149.805),(42.045,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,149.805),(42.365,149.955),(42.515,149.955),(42.515,149.805),(42.365,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,149.805),(42.685,149.955),(42.835,149.955),(42.835,149.805),(42.685,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,149.805),(43.005,149.955),(43.155,149.955),(43.155,149.805),(43.005,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,150.125),(42.045,150.275),(42.195,150.275),(42.195,150.125),(42.045,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,150.125),(42.365,150.275),(42.515,150.275),(42.515,150.125),(42.365,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,150.125),(42.685,150.275),(42.835,150.275),(42.835,150.125),(42.685,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,150.125),(43.005,150.275),(43.155,150.275),(43.155,150.125),(43.005,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,150.445),(42.045,150.595),(42.195,150.595),(42.195,150.445),(42.045,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,150.445),(42.365,150.595),(42.515,150.595),(42.515,150.445),(42.365,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,150.445),(42.685,150.595),(42.835,150.595),(42.835,150.445),(42.685,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,150.445),(43.005,150.595),(43.155,150.595),(43.155,150.445),(43.005,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,150.765),(42.045,150.915),(42.195,150.915),(42.195,150.765),(42.045,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,150.765),(42.365,150.915),(42.515,150.915),(42.515,150.765),(42.365,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,150.765),(42.685,150.915),(42.835,150.915),(42.835,150.765),(42.685,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,150.765),(43.005,150.915),(43.155,150.915),(43.155,150.765),(43.005,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,151.085),(42.045,151.235),(42.195,151.235),(42.195,151.085),(42.045,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,151.085),(42.365,151.235),(42.515,151.235),(42.515,151.085),(42.365,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,151.085),(42.685,151.235),(42.835,151.235),(42.835,151.085),(42.685,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,151.085),(43.005,151.235),(43.155,151.235),(43.155,151.085),(43.005,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,151.405),(42.045,151.555),(42.195,151.555),(42.195,151.405),(42.045,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,151.405),(42.365,151.555),(42.515,151.555),(42.515,151.405),(42.365,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,151.405),(42.685,151.555),(42.835,151.555),(42.835,151.405),(42.685,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,151.405),(43.005,151.555),(43.155,151.555),(43.155,151.405),(43.005,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,151.725),(42.045,151.875),(42.195,151.875),(42.195,151.725),(42.045,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,151.725),(42.365,151.875),(42.515,151.875),(42.515,151.725),(42.365,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,151.725),(42.685,151.875),(42.835,151.875),(42.835,151.725),(42.685,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,151.725),(43.005,151.875),(43.155,151.875),(43.155,151.725),(43.005,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,142.125),(61.245,142.275),(61.395,142.275),(61.395,142.125),(61.245,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,142.125),(61.565,142.275),(61.715,142.275),(61.715,142.125),(61.565,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,142.125),(61.885,142.275),(62.035,142.275),(62.035,142.125),(61.885,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,142.125),(62.205,142.275),(62.355,142.275),(62.355,142.125),(62.205,142.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,142.445),(61.245,142.595),(61.395,142.595),(61.395,142.445),(61.245,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,142.445),(61.565,142.595),(61.715,142.595),(61.715,142.445),(61.565,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,142.445),(61.885,142.595),(62.035,142.595),(62.035,142.445),(61.885,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,142.445),(62.205,142.595),(62.355,142.595),(62.355,142.445),(62.205,142.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,142.765),(61.245,142.915),(61.395,142.915),(61.395,142.765),(61.245,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,142.765),(61.565,142.915),(61.715,142.915),(61.715,142.765),(61.565,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,142.765),(61.885,142.915),(62.035,142.915),(62.035,142.765),(61.885,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,142.765),(62.205,142.915),(62.355,142.915),(62.355,142.765),(62.205,142.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,143.085),(61.245,143.235),(61.395,143.235),(61.395,143.085),(61.245,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,143.085),(61.565,143.235),(61.715,143.235),(61.715,143.085),(61.565,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,143.085),(61.885,143.235),(62.035,143.235),(62.035,143.085),(61.885,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,143.085),(62.205,143.235),(62.355,143.235),(62.355,143.085),(62.205,143.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,143.405),(61.245,143.555),(61.395,143.555),(61.395,143.405),(61.245,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,143.405),(61.565,143.555),(61.715,143.555),(61.715,143.405),(61.565,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,143.405),(61.885,143.555),(62.035,143.555),(62.035,143.405),(61.885,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,143.405),(62.205,143.555),(62.355,143.555),(62.355,143.405),(62.205,143.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,143.725),(61.245,143.875),(61.395,143.875),(61.395,143.725),(61.245,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,143.725),(61.565,143.875),(61.715,143.875),(61.715,143.725),(61.565,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,143.725),(61.885,143.875),(62.035,143.875),(62.035,143.725),(61.885,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,143.725),(62.205,143.875),(62.355,143.875),(62.355,143.725),(62.205,143.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,144.045),(61.245,144.195),(61.395,144.195),(61.395,144.045),(61.245,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,144.045),(61.565,144.195),(61.715,144.195),(61.715,144.045),(61.565,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,144.045),(61.885,144.195),(62.035,144.195),(62.035,144.045),(61.885,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,144.045),(62.205,144.195),(62.355,144.195),(62.355,144.045),(62.205,144.045)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,144.365),(61.245,144.515),(61.395,144.515),(61.395,144.365),(61.245,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,144.365),(61.565,144.515),(61.715,144.515),(61.715,144.365),(61.565,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,144.365),(61.885,144.515),(62.035,144.515),(62.035,144.365),(61.885,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,144.365),(62.205,144.515),(62.355,144.515),(62.355,144.365),(62.205,144.365)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,144.685),(61.245,144.835),(61.395,144.835),(61.395,144.685),(61.245,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,144.685),(61.565,144.835),(61.715,144.835),(61.715,144.685),(61.565,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,144.685),(61.885,144.835),(62.035,144.835),(62.035,144.685),(61.885,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,144.685),(62.205,144.835),(62.355,144.835),(62.355,144.685),(62.205,144.685)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,145.005),(61.245,145.155),(61.395,145.155),(61.395,145.005),(61.245,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,145.005),(61.565,145.155),(61.715,145.155),(61.715,145.005),(61.565,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,145.005),(61.885,145.155),(62.035,145.155),(62.035,145.005),(61.885,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,145.005),(62.205,145.155),(62.355,145.155),(62.355,145.005),(62.205,145.005)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,145.325),(61.245,145.475),(61.395,145.475),(61.395,145.325),(61.245,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,145.325),(61.565,145.475),(61.715,145.475),(61.715,145.325),(61.565,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,145.325),(61.885,145.475),(62.035,145.475),(62.035,145.325),(61.885,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,145.325),(62.205,145.475),(62.355,145.475),(62.355,145.325),(62.205,145.325)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,145.645),(61.245,145.795),(61.395,145.795),(61.395,145.645),(61.245,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,145.645),(61.565,145.795),(61.715,145.795),(61.715,145.645),(61.565,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,145.645),(61.885,145.795),(62.035,145.795),(62.035,145.645),(61.885,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,145.645),(62.205,145.795),(62.355,145.795),(62.355,145.645),(62.205,145.645)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,145.965),(61.245,146.115),(61.395,146.115),(61.395,145.965),(61.245,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,145.965),(61.565,146.115),(61.715,146.115),(61.715,145.965),(61.565,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,145.965),(61.885,146.115),(62.035,146.115),(62.035,145.965),(61.885,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,145.965),(62.205,146.115),(62.355,146.115),(62.355,145.965),(62.205,145.965)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,146.285),(61.245,146.435),(61.395,146.435),(61.395,146.285),(61.245,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,146.285),(61.565,146.435),(61.715,146.435),(61.715,146.285),(61.565,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,146.285),(61.885,146.435),(62.035,146.435),(62.035,146.285),(61.885,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,146.285),(62.205,146.435),(62.355,146.435),(62.355,146.285),(62.205,146.285)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,146.605),(61.245,146.755),(61.395,146.755),(61.395,146.605),(61.245,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,146.605),(61.565,146.755),(61.715,146.755),(61.715,146.605),(61.565,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,146.605),(61.885,146.755),(62.035,146.755),(62.035,146.605),(61.885,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,146.605),(62.205,146.755),(62.355,146.755),(62.355,146.605),(62.205,146.605)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,146.925),(61.245,147.075),(61.395,147.075),(61.395,146.925),(61.245,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,146.925),(61.565,147.075),(61.715,147.075),(61.715,146.925),(61.565,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,146.925),(61.885,147.075),(62.035,147.075),(62.035,146.925),(61.885,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,146.925),(62.205,147.075),(62.355,147.075),(62.355,146.925),(62.205,146.925)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,147.245),(61.245,147.395),(61.395,147.395),(61.395,147.245),(61.245,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,147.245),(61.565,147.395),(61.715,147.395),(61.715,147.245),(61.565,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,147.245),(61.885,147.395),(62.035,147.395),(62.035,147.245),(61.885,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,147.245),(62.205,147.395),(62.355,147.395),(62.355,147.245),(62.205,147.245)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,147.565),(61.245,147.715),(61.395,147.715),(61.395,147.565),(61.245,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,147.565),(61.565,147.715),(61.715,147.715),(61.715,147.565),(61.565,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,147.565),(61.885,147.715),(62.035,147.715),(62.035,147.565),(61.885,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,147.565),(62.205,147.715),(62.355,147.715),(62.355,147.565),(62.205,147.565)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,147.885),(61.245,148.035),(61.395,148.035),(61.395,147.885),(61.245,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,147.885),(61.565,148.035),(61.715,148.035),(61.715,147.885),(61.565,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,147.885),(61.885,148.035),(62.035,148.035),(62.035,147.885),(61.885,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,147.885),(62.205,148.035),(62.355,148.035),(62.355,147.885),(62.205,147.885)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,148.205),(61.245,148.355),(61.395,148.355),(61.395,148.205),(61.245,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,148.205),(61.565,148.355),(61.715,148.355),(61.715,148.205),(61.565,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,148.205),(61.885,148.355),(62.035,148.355),(62.035,148.205),(61.885,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,148.205),(62.205,148.355),(62.355,148.355),(62.355,148.205),(62.205,148.205)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,148.525),(61.245,148.675),(61.395,148.675),(61.395,148.525),(61.245,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,148.525),(61.565,148.675),(61.715,148.675),(61.715,148.525),(61.565,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,148.525),(61.885,148.675),(62.035,148.675),(62.035,148.525),(61.885,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,148.525),(62.205,148.675),(62.355,148.675),(62.355,148.525),(62.205,148.525)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,148.845),(61.245,148.995),(61.395,148.995),(61.395,148.845),(61.245,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,148.845),(61.565,148.995),(61.715,148.995),(61.715,148.845),(61.565,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,148.845),(61.885,148.995),(62.035,148.995),(62.035,148.845),(61.885,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,148.845),(62.205,148.995),(62.355,148.995),(62.355,148.845),(62.205,148.845)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,149.165),(61.245,149.315),(61.395,149.315),(61.395,149.165),(61.245,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,149.165),(61.565,149.315),(61.715,149.315),(61.715,149.165),(61.565,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,149.165),(61.885,149.315),(62.035,149.315),(62.035,149.165),(61.885,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,149.165),(62.205,149.315),(62.355,149.315),(62.355,149.165),(62.205,149.165)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,149.485),(61.245,149.635),(61.395,149.635),(61.395,149.485),(61.245,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,149.485),(61.565,149.635),(61.715,149.635),(61.715,149.485),(61.565,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,149.485),(61.885,149.635),(62.035,149.635),(62.035,149.485),(61.885,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,149.485),(62.205,149.635),(62.355,149.635),(62.355,149.485),(62.205,149.485)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,149.805),(61.245,149.955),(61.395,149.955),(61.395,149.805),(61.245,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,149.805),(61.565,149.955),(61.715,149.955),(61.715,149.805),(61.565,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,149.805),(61.885,149.955),(62.035,149.955),(62.035,149.805),(61.885,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,149.805),(62.205,149.955),(62.355,149.955),(62.355,149.805),(62.205,149.805)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,150.125),(61.245,150.275),(61.395,150.275),(61.395,150.125),(61.245,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,150.125),(61.565,150.275),(61.715,150.275),(61.715,150.125),(61.565,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,150.125),(61.885,150.275),(62.035,150.275),(62.035,150.125),(61.885,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,150.125),(62.205,150.275),(62.355,150.275),(62.355,150.125),(62.205,150.125)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,150.445),(61.245,150.595),(61.395,150.595),(61.395,150.445),(61.245,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,150.445),(61.565,150.595),(61.715,150.595),(61.715,150.445),(61.565,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,150.445),(61.885,150.595),(62.035,150.595),(62.035,150.445),(61.885,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,150.445),(62.205,150.595),(62.355,150.595),(62.355,150.445),(62.205,150.445)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,150.765),(61.245,150.915),(61.395,150.915),(61.395,150.765),(61.245,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,150.765),(61.565,150.915),(61.715,150.915),(61.715,150.765),(61.565,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,150.765),(61.885,150.915),(62.035,150.915),(62.035,150.765),(61.885,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,150.765),(62.205,150.915),(62.355,150.915),(62.355,150.765),(62.205,150.765)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,151.085),(61.245,151.235),(61.395,151.235),(61.395,151.085),(61.245,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,151.085),(61.565,151.235),(61.715,151.235),(61.715,151.085),(61.565,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,151.085),(61.885,151.235),(62.035,151.235),(62.035,151.085),(61.885,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,151.085),(62.205,151.235),(62.355,151.235),(62.355,151.085),(62.205,151.085)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,151.405),(61.245,151.555),(61.395,151.555),(61.395,151.405),(61.245,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,151.405),(61.565,151.555),(61.715,151.555),(61.715,151.405),(61.565,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,151.405),(61.885,151.555),(62.035,151.555),(62.035,151.405),(61.885,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,151.405),(62.205,151.555),(62.355,151.555),(62.355,151.405),(62.205,151.405)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,151.725),(61.245,151.875),(61.395,151.875),(61.395,151.725),(61.245,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,151.725),(61.565,151.875),(61.715,151.875),(61.715,151.725),(61.565,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,151.725),(61.885,151.875),(62.035,151.875),(62.035,151.725),(61.885,151.725)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,151.725),(62.205,151.875),(62.355,151.875),(62.355,151.725),(62.205,151.725)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((85.61,88.09),(85.61,88.26),(86.14,88.26),(86.14,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.745,88.09),(73.745,88.26),(73.915,88.26),(73.915,88.09),(73.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.745,88.09),(25.745,88.26),(25.915,88.26),(25.915,88.09),(25.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.8,88.09),(6.8,88.26),(6.97,88.26),(6.97,88.09),(6.8,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.345,88.09),(11.345,88.26),(11.515,88.26),(11.515,88.09),(11.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.145,88.09),(64.145,88.26),(64.315,88.26),(64.315,88.09),(64.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.09,88.09),(83.09,88.26),(83.26,88.26),(83.26,88.09),(83.09,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.61,88.09),(85.61,88.26),(85.78,88.26),(85.78,88.09),(85.61,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((85.97,88.09),(85.97,88.26),(86.14,88.26),(86.14,88.09),(85.97,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.945,88.09),(20.945,88.26),(21.115,88.26),(21.115,88.09),(20.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.945,88.09),(68.945,88.26),(69.115,88.26),(69.115,88.09),(68.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.345,88.09),(59.345,88.26),(59.515,88.26),(59.515,88.09),(59.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.145,88.09),(16.145,88.26),(16.315,88.26),(16.315,88.09),(16.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.545,88.09),(30.545,88.26),(30.715,88.26),(30.715,88.09),(30.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.545,88.09),(78.545,88.26),(78.715,88.26),(78.715,88.09),(78.545,88.09)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,91.365),(16.315,91.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,88.3),(16.315,88.3),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,88.3),(16.33,88.3),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.77,88.03),(6.77,88.32),(7.0,88.32),(7.0,88.03),(6.77,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,130.265),(11.515,130.265),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.915,88.03),(68.915,88.32),(69.145,88.32),(69.145,88.03),(68.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,133.04),(25.915,133.04),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,133.04),(25.93,133.04),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.515,88.03),(78.515,88.32),(78.745,88.32),(78.745,88.03),(78.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,131.365),(78.715,131.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,130.265),(35.515,130.265),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.315,88.03),(35.315,88.32),(35.545,88.32),(35.545,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,130.265),(69.115,130.265),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,88.3),(45.115,88.3),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.915,88.03),(44.915,88.32),(45.145,88.32),(45.145,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,131.365),(83.26,131.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,132.98),(83.275,132.98),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,91.365),(83.26,91.365),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,133.04),(59.515,133.04),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,133.04),(59.53,133.04),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,130.265),(21.115,130.265),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,131.365),(73.915,131.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,88.3),(69.13,88.3),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,88.3),(69.115,88.3),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,132.98),(73.93,132.98),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,131.365),(54.715,131.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,91.365),(73.915,91.365),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,88.3),(11.515,88.3),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,88.3),(11.53,88.3),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,130.265),(16.315,130.265),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,88.3),(21.13,88.3),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,88.3),(21.115,88.3),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,132.98),(16.33,132.98),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,131.365),(6.97,131.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,88.3),(35.515,88.3),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,133.04),(49.915,133.04),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,130.265),(45.115,130.265),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,88.3),(86.14,88.3),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.58,88.03),(85.58,88.32),(86.17,88.32),(86.17,88.03),(85.58,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,132.98),(30.73,132.98),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.715,88.03),(49.715,88.32),(49.945,88.32),(49.945,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((20.915,88.03),(20.915,88.32),(21.145,88.32),(21.145,88.03),(20.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,131.365),(11.515,131.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,132.98),(11.53,132.98),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,130.265),(25.915,130.265),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.315,88.03),(11.315,88.32),(11.545,88.32),(11.545,88.03),(11.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.06,88.03),(83.06,88.32),(83.29,88.32),(83.29,88.03),(83.06,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((16.115,88.03),(16.115,88.32),(16.345,88.32),(16.345,88.03),(16.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,132.98),(78.73,132.98),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,131.365),(35.515,131.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,91.365),(49.915,91.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,133.04),(69.115,133.04),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,133.04),(69.13,133.04),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,91.365),(45.115,91.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,132.98),(35.53,132.98),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,130.265),(40.315,130.265),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,133.04),(83.26,133.04),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,133.04),(83.275,133.04),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.715,88.03),(73.715,88.32),(73.945,88.32),(73.945,88.03),(73.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,88.3),(83.26,88.3),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,87.93),(83.015,88.3),(83.275,88.3),(83.275,87.93),(83.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,132.98),(40.33,132.98),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,130.265),(59.515,130.265),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,133.04),(21.115,133.04),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,133.04),(21.13,133.04),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,91.365),(69.115,91.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,133.04),(73.93,133.04),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,133.04),(73.915,133.04),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,132.98),(54.73,132.98),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.715,88.03),(25.715,88.32),(25.945,88.32),(25.945,88.03),(25.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,91.365),(25.915,91.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,88.3),(73.915,88.3),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.115,88.03),(64.115,88.32),(64.345,88.32),(64.345,88.03),(64.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,87.93),(73.67,88.3),(73.93,88.3),(73.93,87.93),(73.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,131.365),(16.315,131.365),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,91.365),(21.115,91.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,91.365),(59.515,91.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,87.93),(16.085,133.04),(16.315,133.04),(16.315,87.93),(16.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,87.93),(16.07,133.04),(16.33,133.04),(16.33,87.93),(16.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,132.98),(6.985,132.98),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,130.265),(64.315,130.265),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,133.04),(45.115,133.04),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,130.265),(49.915,130.265),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,132.98),(64.33,132.98),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,91.365),(86.14,91.365),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,133.04),(30.715,133.04),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,133.04),(30.73,133.04),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,91.365),(64.315,91.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,130.265),(30.715,130.265),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,88.3),(64.33,88.3),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,88.3),(64.315,88.3),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.515,88.03),(30.515,88.32),(30.745,88.32),(30.745,88.03),(30.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.115,88.03),(40.115,88.32),(40.345,88.32),(40.345,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,133.04),(11.515,133.04),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,87.93),(11.27,133.04),(11.53,133.04),(11.53,87.93),(11.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.315,88.03),(59.315,88.32),(59.545,88.32),(59.545,88.03),(59.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,131.365),(25.915,131.365),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,132.98),(25.93,132.98),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,91.365),(54.715,91.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,88.3),(54.715,88.3),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,87.93),(68.87,132.98),(69.13,132.98),(69.13,87.93),(68.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,88.3),(49.915,88.3),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,133.04),(78.715,133.04),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,133.04),(78.73,133.04),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,130.265),(78.715,130.265),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,133.04),(35.515,133.04),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,87.93),(68.885,131.365),(69.115,131.365),(69.115,87.93),(68.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,131.365),(40.315,131.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,87.93),(83.03,130.265),(83.26,130.265),(83.26,87.93),(83.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((85.55,87.93),(85.55,111.07),(86.14,111.07),(86.14,87.93),(85.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,91.365),(40.315,91.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,133.04),(40.315,133.04),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,91.365),(6.97,91.365),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,88.3),(40.315,88.3),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,131.365),(59.515,131.365),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,88.3),(6.97,88.3),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,88.3),(6.985,88.3),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,132.98),(59.53,132.98),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,87.93),(20.87,132.98),(21.13,132.98),(21.13,87.93),(20.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,87.93),(20.885,131.365),(21.115,131.365),(21.115,87.93),(20.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,91.365),(78.715,91.365),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,87.93),(73.685,130.265),(73.915,130.265),(73.915,87.93),(73.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,87.93),(78.485,88.3),(78.715,88.3),(78.715,87.93),(78.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,87.93),(78.47,88.3),(78.73,88.3),(78.73,87.93),(78.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.515,88.03),(54.515,88.32),(54.745,88.32),(54.745,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,133.04),(54.715,133.04),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,87.93),(25.67,88.3),(25.93,88.3),(25.93,87.93),(25.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,87.93),(25.685,88.3),(25.915,88.3),(25.915,87.93),(25.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,130.265),(54.715,130.265),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,87.93),(11.285,91.365),(11.515,91.365),(11.515,87.93),(11.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,87.93),(59.27,88.3),(59.53,88.3),(59.53,87.93),(59.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,87.93),(59.285,88.3),(59.515,88.3),(59.515,87.93),(59.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,133.04),(6.97,133.04),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,87.93),(6.725,133.04),(6.985,133.04),(6.985,87.93),(6.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,87.93),(6.74,130.265),(6.97,130.265),(6.97,87.93),(6.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,131.365),(64.315,131.365),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,91.365),(35.515,91.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,132.98),(45.13,132.98),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,131.365),(49.915,131.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,87.93),(64.085,133.04),(64.315,133.04),(64.315,87.93),(64.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,131.365),(45.115,131.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,91.365),(30.715,91.365),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,87.93),(64.07,133.04),(64.33,133.04),(64.33,87.93),(64.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,132.98),(49.93,132.98),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,88.3),(30.715,88.3),(30.715,87.93),(30.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,87.93),(30.47,88.3),(30.73,88.3),(30.73,87.93),(30.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,87.93),(30.485,131.365),(30.715,131.365),(30.715,87.93),(30.485,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N0D']
        except:
            subcell = af.getCell('Clamp_N32N0D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P32N0D']
        except:
            subcell = af.getCell('Clamp_P32N0D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadIOVdd']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovdd_res': Net.create(cell, 'iovdd_res'),
            'iovss': Net.create(cell, 'iovss'),
            'ngate': Net.create(cell, 'ngate'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((65.5,86.32),(65.5,133.04),(85.5,133.04),(85.5,86.32),(65.5,86.32)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((23.335,127.925),(23.335,128.245),(66.665,128.245),(66.665,127.925),(23.335,127.925)),
        )
        createRL(
            tech, net, 'm2',
            ((4.5,86.32),(4.5,133.04),(24.5,133.04),(24.5,86.32),(4.5,86.32)),
        )
        createRL(
            tech, net, 'm2',
            ((25.77,83.995),(25.77,84.315),(26.35,84.315),(26.35,83.995),(25.77,83.995)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((28.1,86.32),(28.1,133.04),(48.1,133.04),(48.1,86.32),(28.1,86.32)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((65.5,86.32),(65.5,133.04),(85.5,133.04),(85.5,86.32),(65.5,86.32)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((4.5,86.32),(4.5,133.04),(24.5,133.04),(24.5,86.32),(4.5,86.32)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((28.1,86.32),(28.1,133.04),(48.1,133.04),(48.1,86.32),(28.1,86.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((65.5,86.32),(65.5,133.04),(85.5,133.04),(85.5,86.32),(65.5,86.32)),
        )
        createRL(
            tech, net, 'm4',
            ((4.5,86.32),(4.5,133.04),(24.5,133.04),(24.5,86.32),(4.5,86.32)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((28.1,86.32),(28.1,133.04),(48.1,133.04),(48.1,86.32),(28.1,86.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,24.32),(76.855,24.32),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,22.195),(22.745,22.485),(24.055,22.485),(24.055,22.195),(22.745,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,22.195),(65.945,22.485),(67.255,22.485),(67.255,22.195),(65.945,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,22.195),(75.545,22.485),(76.855,22.485),(76.855,22.195),(75.545,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,24.32),(72.055,24.32),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,22.195),(32.345,22.485),(33.655,22.485),(33.655,22.195),(32.345,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,22.195),(80.345,22.485),(81.655,22.485),(81.655,22.195),(80.345,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,24.32),(28.855,24.32),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,24.32),(14.455,24.32),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,22.195),(46.745,22.485),(48.055,22.485),(48.055,22.195),(46.745,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,24.32),(9.655,24.32),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,24.32),(67.255,24.32),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,22.195),(27.545,22.485),(28.855,22.485),(28.855,22.195),(27.545,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,24.32),(24.055,24.32),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((25.77,83.995),(25.77,84.315),(26.35,84.315),(26.35,83.995),(25.77,83.995)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,22.195),(37.145,22.485),(38.455,22.485),(38.455,22.195),(37.145,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,24.32),(81.655,24.32),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,24.32),(62.455,24.32),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,22.195),(17.945,22.485),(19.255,22.485),(19.255,22.195),(17.945,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((23.335,127.94),(23.335,128.23),(66.665,128.23),(66.665,127.94),(23.335,127.94)),
        )
        createRL(
            tech, net, 'm1',
            ((23.335,127.925),(23.335,128.245),(66.665,128.245),(66.665,127.925),(23.335,127.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,22.195),(56.345,22.485),(57.655,22.485),(57.655,22.195),(56.345,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,22.195),(51.545,22.485),(52.855,22.485),(52.855,22.195),(51.545,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,22.195),(13.145,22.485),(14.455,22.485),(14.455,22.195),(13.145,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,22.195),(41.945,22.485),(43.255,22.485),(43.255,22.195),(41.945,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((25.76,84.01),(25.76,84.3),(26.35,84.3),(26.35,84.01),(25.76,84.01)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,22.195),(70.745,22.485),(72.055,22.485),(72.055,22.195),(70.745,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,22.195),(8.345,22.485),(9.655,22.485),(9.655,22.195),(8.345,22.195)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,24.32),(19.255,24.32),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,22.195),(61.145,22.485),(62.455,22.485),(62.455,22.195),(61.145,22.195)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,22.255),(22.775,22.425),(24.025,22.425),(24.025,22.255),(22.775,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((22.745,22.255),(22.745,22.425),(24.055,22.425),(24.055,22.255),(22.745,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,22.255),(65.975,22.425),(67.225,22.425),(67.225,22.255),(65.975,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((65.945,22.255),(65.945,22.425),(67.255,22.425),(67.255,22.255),(65.945,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,22.255),(75.575,22.425),(76.825,22.425),(76.825,22.255),(75.575,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((75.545,22.255),(75.545,22.425),(76.855,22.425),(76.855,22.255),(75.545,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((32.345,22.255),(32.345,22.425),(33.655,22.425),(33.655,22.255),(32.345,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,22.255),(32.375,22.425),(33.625,22.425),(33.625,22.255),(32.375,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((80.345,22.255),(80.345,22.425),(81.655,22.425),(81.655,22.255),(80.345,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,22.255),(80.375,22.425),(81.625,22.425),(81.625,22.255),(80.375,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,22.255),(46.775,22.425),(48.025,22.425),(48.025,22.255),(46.775,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((46.745,22.255),(46.745,22.425),(48.055,22.425),(48.055,22.255),(46.745,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,22.255),(27.575,22.425),(28.825,22.425),(28.825,22.255),(27.575,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((27.545,22.255),(27.545,22.425),(28.855,22.425),(28.855,22.255),(27.545,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((37.145,22.255),(37.145,22.425),(38.455,22.425),(38.455,22.255),(37.145,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,22.255),(37.175,22.425),(38.425,22.425),(38.425,22.255),(37.175,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,22.255),(17.975,22.425),(19.225,22.425),(19.225,22.255),(17.975,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((17.945,22.255),(17.945,22.425),(19.255,22.425),(19.255,22.255),(17.945,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,22.255),(56.375,22.425),(57.625,22.425),(57.625,22.255),(56.375,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((56.345,22.255),(56.345,22.425),(57.655,22.425),(57.655,22.255),(56.345,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((23.335,128.0),(23.335,128.17),(66.665,128.17),(66.665,128.0),(23.335,128.0)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,22.255),(51.575,22.425),(52.825,22.425),(52.825,22.255),(51.575,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((51.545,22.255),(51.545,22.425),(52.855,22.425),(52.855,22.255),(51.545,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((13.145,22.255),(13.145,22.425),(14.455,22.425),(14.455,22.255),(13.145,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,22.255),(13.175,22.425),(14.425,22.425),(14.425,22.255),(13.175,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,22.255),(41.975,22.425),(43.225,22.425),(43.225,22.255),(41.975,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((41.945,22.255),(41.945,22.425),(43.255,22.425),(43.255,22.255),(41.945,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((25.79,84.07),(25.79,84.24),(26.32,84.24),(26.32,84.07),(25.79,84.07)),
        )
        createRL(
            tech, net, 'li',
            ((70.745,22.255),(70.745,22.425),(72.055,22.425),(72.055,22.255),(70.745,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,22.255),(70.775,22.425),(72.025,22.425),(72.025,22.255),(70.775,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,22.255),(8.375,22.425),(9.625,22.425),(9.625,22.255),(8.375,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((8.345,22.255),(8.345,22.425),(9.655,22.425),(9.655,22.255),(8.345,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,22.255),(61.175,22.425),(62.425,22.425),(62.425,22.255),(61.175,22.255)),
        )
        createRL(
            tech, net, 'li',
            ((61.145,22.255),(61.145,22.425),(62.455,22.425),(62.455,22.255),(61.145,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,22.255),(8.375,22.425),(8.545,22.425),(8.545,22.255),(8.375,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,22.255),(8.735,22.425),(8.905,22.425),(8.905,22.255),(8.735,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,22.255),(9.095,22.425),(9.265,22.425),(9.265,22.255),(9.095,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,22.255),(9.455,22.425),(9.625,22.425),(9.625,22.255),(9.455,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.255),(51.575,22.425),(51.745,22.425),(51.745,22.255),(51.575,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.255),(51.935,22.425),(52.105,22.425),(52.105,22.255),(51.935,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.255),(52.295,22.425),(52.465,22.425),(52.465,22.255),(52.295,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.255),(52.655,22.425),(52.825,22.425),(52.825,22.255),(52.655,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,22.255),(65.975,22.425),(66.145,22.425),(66.145,22.255),(65.975,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,22.255),(66.335,22.425),(66.505,22.425),(66.505,22.255),(66.335,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,22.255),(66.695,22.425),(66.865,22.425),(66.865,22.255),(66.695,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,22.255),(67.055,22.425),(67.225,22.425),(67.225,22.255),(67.055,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.255),(37.175,22.425),(37.345,22.425),(37.345,22.255),(37.175,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.255),(37.535,22.425),(37.705,22.425),(37.705,22.255),(37.535,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.255),(37.895,22.425),(38.065,22.425),(38.065,22.255),(37.895,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.255),(38.255,22.425),(38.425,22.425),(38.425,22.255),(38.255,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.255),(41.975,22.425),(42.145,22.425),(42.145,22.255),(41.975,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.255),(42.335,22.425),(42.505,22.425),(42.505,22.255),(42.335,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.255),(42.695,22.425),(42.865,22.425),(42.865,22.255),(42.695,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.255),(43.055,22.425),(43.225,22.425),(43.225,22.255),(43.055,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,22.255),(17.975,22.425),(18.145,22.425),(18.145,22.255),(17.975,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,22.255),(18.335,22.425),(18.505,22.425),(18.505,22.255),(18.335,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,22.255),(18.695,22.425),(18.865,22.425),(18.865,22.255),(18.695,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,22.255),(19.055,22.425),(19.225,22.425),(19.225,22.255),(19.055,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,22.255),(61.175,22.425),(61.345,22.425),(61.345,22.255),(61.175,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,22.255),(61.535,22.425),(61.705,22.425),(61.705,22.255),(61.535,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,22.255),(61.895,22.425),(62.065,22.425),(62.065,22.255),(61.895,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,22.255),(62.255,22.425),(62.425,22.425),(62.425,22.255),(62.255,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,22.255),(75.575,22.425),(75.745,22.425),(75.745,22.255),(75.575,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,22.255),(75.935,22.425),(76.105,22.425),(76.105,22.255),(75.935,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,22.255),(76.295,22.425),(76.465,22.425),(76.465,22.255),(76.295,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,22.255),(76.655,22.425),(76.825,22.425),(76.825,22.255),(76.655,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,128.0),(23.495,128.17),(23.665,128.17),(23.665,128.0),(23.495,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,128.0),(23.855,128.17),(24.025,128.17),(24.025,128.0),(23.855,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((24.215,128.0),(24.215,128.17),(24.385,128.17),(24.385,128.0),(24.215,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((24.575,128.0),(24.575,128.17),(24.745,128.17),(24.745,128.0),(24.575,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((24.935,128.0),(24.935,128.17),(25.105,128.17),(25.105,128.0),(24.935,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.295,128.0),(25.295,128.17),(25.465,128.17),(25.465,128.0),(25.295,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.655,128.0),(25.655,128.17),(25.825,128.17),(25.825,128.0),(25.655,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.015,128.0),(26.015,128.17),(26.185,128.17),(26.185,128.0),(26.015,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.375,128.0),(26.375,128.17),(26.545,128.17),(26.545,128.0),(26.375,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.735,128.0),(26.735,128.17),(26.905,128.17),(26.905,128.0),(26.735,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.095,128.0),(27.095,128.17),(27.265,128.17),(27.265,128.0),(27.095,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.455,128.0),(27.455,128.17),(27.625,128.17),(27.625,128.0),(27.455,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.815,128.0),(27.815,128.17),(27.985,128.17),(27.985,128.0),(27.815,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.175,128.0),(28.175,128.17),(28.345,128.17),(28.345,128.0),(28.175,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.535,128.0),(28.535,128.17),(28.705,128.17),(28.705,128.0),(28.535,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.895,128.0),(28.895,128.17),(29.065,128.17),(29.065,128.0),(28.895,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.255,128.0),(29.255,128.17),(29.425,128.17),(29.425,128.0),(29.255,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.615,128.0),(29.615,128.17),(29.785,128.17),(29.785,128.0),(29.615,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.975,128.0),(29.975,128.17),(30.145,128.17),(30.145,128.0),(29.975,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.335,128.0),(30.335,128.17),(30.505,128.17),(30.505,128.0),(30.335,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.695,128.0),(30.695,128.17),(30.865,128.17),(30.865,128.0),(30.695,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.055,128.0),(31.055,128.17),(31.225,128.17),(31.225,128.0),(31.055,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.415,128.0),(31.415,128.17),(31.585,128.17),(31.585,128.0),(31.415,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.775,128.0),(31.775,128.17),(31.945,128.17),(31.945,128.0),(31.775,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.135,128.0),(32.135,128.17),(32.305,128.17),(32.305,128.0),(32.135,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.495,128.0),(32.495,128.17),(32.665,128.17),(32.665,128.0),(32.495,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.855,128.0),(32.855,128.17),(33.025,128.17),(33.025,128.0),(32.855,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.215,128.0),(33.215,128.17),(33.385,128.17),(33.385,128.0),(33.215,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.575,128.0),(33.575,128.17),(33.745,128.17),(33.745,128.0),(33.575,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.935,128.0),(33.935,128.17),(34.105,128.17),(34.105,128.0),(33.935,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.295,128.0),(34.295,128.17),(34.465,128.17),(34.465,128.0),(34.295,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.655,128.0),(34.655,128.17),(34.825,128.17),(34.825,128.0),(34.655,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.015,128.0),(35.015,128.17),(35.185,128.17),(35.185,128.0),(35.015,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.375,128.0),(35.375,128.17),(35.545,128.17),(35.545,128.0),(35.375,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.735,128.0),(35.735,128.17),(35.905,128.17),(35.905,128.0),(35.735,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.095,128.0),(36.095,128.17),(36.265,128.17),(36.265,128.0),(36.095,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.455,128.0),(36.455,128.17),(36.625,128.17),(36.625,128.0),(36.455,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.815,128.0),(36.815,128.17),(36.985,128.17),(36.985,128.0),(36.815,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,128.0),(37.175,128.17),(37.345,128.17),(37.345,128.0),(37.175,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,128.0),(37.535,128.17),(37.705,128.17),(37.705,128.0),(37.535,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,128.0),(37.895,128.17),(38.065,128.17),(38.065,128.0),(37.895,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,128.0),(38.255,128.17),(38.425,128.17),(38.425,128.0),(38.255,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.615,128.0),(38.615,128.17),(38.785,128.17),(38.785,128.0),(38.615,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.975,128.0),(38.975,128.17),(39.145,128.17),(39.145,128.0),(38.975,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.335,128.0),(39.335,128.17),(39.505,128.17),(39.505,128.0),(39.335,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.695,128.0),(39.695,128.17),(39.865,128.17),(39.865,128.0),(39.695,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.055,128.0),(40.055,128.17),(40.225,128.17),(40.225,128.0),(40.055,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.415,128.0),(40.415,128.17),(40.585,128.17),(40.585,128.0),(40.415,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.775,128.0),(40.775,128.17),(40.945,128.17),(40.945,128.0),(40.775,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.135,128.0),(41.135,128.17),(41.305,128.17),(41.305,128.0),(41.135,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.495,128.0),(41.495,128.17),(41.665,128.17),(41.665,128.0),(41.495,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.855,128.0),(41.855,128.17),(42.025,128.17),(42.025,128.0),(41.855,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.215,128.0),(42.215,128.17),(42.385,128.17),(42.385,128.0),(42.215,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.575,128.0),(42.575,128.17),(42.745,128.17),(42.745,128.0),(42.575,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.935,128.0),(42.935,128.17),(43.105,128.17),(43.105,128.0),(42.935,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.295,128.0),(43.295,128.17),(43.465,128.17),(43.465,128.0),(43.295,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.655,128.0),(43.655,128.17),(43.825,128.17),(43.825,128.0),(43.655,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.015,128.0),(44.015,128.17),(44.185,128.17),(44.185,128.0),(44.015,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.375,128.0),(44.375,128.17),(44.545,128.17),(44.545,128.0),(44.375,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.735,128.0),(44.735,128.17),(44.905,128.17),(44.905,128.0),(44.735,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.095,128.0),(45.095,128.17),(45.265,128.17),(45.265,128.0),(45.095,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.455,128.0),(45.455,128.17),(45.625,128.17),(45.625,128.0),(45.455,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.815,128.0),(45.815,128.17),(45.985,128.17),(45.985,128.0),(45.815,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.175,128.0),(46.175,128.17),(46.345,128.17),(46.345,128.0),(46.175,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.535,128.0),(46.535,128.17),(46.705,128.17),(46.705,128.0),(46.535,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.895,128.0),(46.895,128.17),(47.065,128.17),(47.065,128.0),(46.895,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.255,128.0),(47.255,128.17),(47.425,128.17),(47.425,128.0),(47.255,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.615,128.0),(47.615,128.17),(47.785,128.17),(47.785,128.0),(47.615,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.975,128.0),(47.975,128.17),(48.145,128.17),(48.145,128.0),(47.975,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.335,128.0),(48.335,128.17),(48.505,128.17),(48.505,128.0),(48.335,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.695,128.0),(48.695,128.17),(48.865,128.17),(48.865,128.0),(48.695,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.055,128.0),(49.055,128.17),(49.225,128.17),(49.225,128.0),(49.055,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.415,128.0),(49.415,128.17),(49.585,128.17),(49.585,128.0),(49.415,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.775,128.0),(49.775,128.17),(49.945,128.17),(49.945,128.0),(49.775,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.135,128.0),(50.135,128.17),(50.305,128.17),(50.305,128.0),(50.135,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.495,128.0),(50.495,128.17),(50.665,128.17),(50.665,128.0),(50.495,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.855,128.0),(50.855,128.17),(51.025,128.17),(51.025,128.0),(50.855,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.215,128.0),(51.215,128.17),(51.385,128.17),(51.385,128.0),(51.215,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,128.0),(51.575,128.17),(51.745,128.17),(51.745,128.0),(51.575,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,128.0),(51.935,128.17),(52.105,128.17),(52.105,128.0),(51.935,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,128.0),(52.295,128.17),(52.465,128.17),(52.465,128.0),(52.295,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,128.0),(52.655,128.17),(52.825,128.17),(52.825,128.0),(52.655,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.015,128.0),(53.015,128.17),(53.185,128.17),(53.185,128.0),(53.015,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.375,128.0),(53.375,128.17),(53.545,128.17),(53.545,128.0),(53.375,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.735,128.0),(53.735,128.17),(53.905,128.17),(53.905,128.0),(53.735,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.095,128.0),(54.095,128.17),(54.265,128.17),(54.265,128.0),(54.095,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.455,128.0),(54.455,128.17),(54.625,128.17),(54.625,128.0),(54.455,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.815,128.0),(54.815,128.17),(54.985,128.17),(54.985,128.0),(54.815,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.175,128.0),(55.175,128.17),(55.345,128.17),(55.345,128.0),(55.175,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.535,128.0),(55.535,128.17),(55.705,128.17),(55.705,128.0),(55.535,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.895,128.0),(55.895,128.17),(56.065,128.17),(56.065,128.0),(55.895,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.255,128.0),(56.255,128.17),(56.425,128.17),(56.425,128.0),(56.255,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.615,128.0),(56.615,128.17),(56.785,128.17),(56.785,128.0),(56.615,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.975,128.0),(56.975,128.17),(57.145,128.17),(57.145,128.0),(56.975,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.335,128.0),(57.335,128.17),(57.505,128.17),(57.505,128.0),(57.335,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.695,128.0),(57.695,128.17),(57.865,128.17),(57.865,128.0),(57.695,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.055,128.0),(58.055,128.17),(58.225,128.17),(58.225,128.0),(58.055,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.415,128.0),(58.415,128.17),(58.585,128.17),(58.585,128.0),(58.415,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.775,128.0),(58.775,128.17),(58.945,128.17),(58.945,128.0),(58.775,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.135,128.0),(59.135,128.17),(59.305,128.17),(59.305,128.0),(59.135,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.495,128.0),(59.495,128.17),(59.665,128.17),(59.665,128.0),(59.495,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.855,128.0),(59.855,128.17),(60.025,128.17),(60.025,128.0),(59.855,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.215,128.0),(60.215,128.17),(60.385,128.17),(60.385,128.0),(60.215,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.575,128.0),(60.575,128.17),(60.745,128.17),(60.745,128.0),(60.575,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.935,128.0),(60.935,128.17),(61.105,128.17),(61.105,128.0),(60.935,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.295,128.0),(61.295,128.17),(61.465,128.17),(61.465,128.0),(61.295,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.655,128.0),(61.655,128.17),(61.825,128.17),(61.825,128.0),(61.655,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.015,128.0),(62.015,128.17),(62.185,128.17),(62.185,128.0),(62.015,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.375,128.0),(62.375,128.17),(62.545,128.17),(62.545,128.0),(62.375,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.735,128.0),(62.735,128.17),(62.905,128.17),(62.905,128.0),(62.735,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.095,128.0),(63.095,128.17),(63.265,128.17),(63.265,128.0),(63.095,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.455,128.0),(63.455,128.17),(63.625,128.17),(63.625,128.0),(63.455,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.815,128.0),(63.815,128.17),(63.985,128.17),(63.985,128.0),(63.815,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.175,128.0),(64.175,128.17),(64.345,128.17),(64.345,128.0),(64.175,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.535,128.0),(64.535,128.17),(64.705,128.17),(64.705,128.0),(64.535,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.895,128.0),(64.895,128.17),(65.065,128.17),(65.065,128.0),(64.895,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.255,128.0),(65.255,128.17),(65.425,128.17),(65.425,128.0),(65.255,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.615,128.0),(65.615,128.17),(65.785,128.17),(65.785,128.0),(65.615,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,128.0),(65.975,128.17),(66.145,128.17),(66.145,128.0),(65.975,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,128.0),(66.335,128.17),(66.505,128.17),(66.505,128.0),(66.335,128.0)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.255),(32.375,22.425),(32.545,22.425),(32.545,22.255),(32.375,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.255),(32.735,22.425),(32.905,22.425),(32.905,22.255),(32.735,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.255),(33.095,22.425),(33.265,22.425),(33.265,22.255),(33.095,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.255),(33.455,22.425),(33.625,22.425),(33.625,22.255),(33.455,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,22.255),(13.175,22.425),(13.345,22.425),(13.345,22.255),(13.175,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,22.255),(13.535,22.425),(13.705,22.425),(13.705,22.255),(13.535,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,22.255),(13.895,22.425),(14.065,22.425),(14.065,22.255),(13.895,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,22.255),(14.255,22.425),(14.425,22.425),(14.425,22.255),(14.255,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,22.255),(70.775,22.425),(70.945,22.425),(70.945,22.255),(70.775,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,22.255),(71.135,22.425),(71.305,22.425),(71.305,22.255),(71.135,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,22.255),(71.495,22.425),(71.665,22.425),(71.665,22.255),(71.495,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,22.255),(71.855,22.425),(72.025,22.425),(72.025,22.255),(71.855,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,22.255),(22.775,22.425),(22.945,22.425),(22.945,22.255),(22.775,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,22.255),(23.135,22.425),(23.305,22.425),(23.305,22.255),(23.135,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,22.255),(23.495,22.425),(23.665,22.425),(23.665,22.255),(23.495,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,22.255),(23.855,22.425),(24.025,22.425),(24.025,22.255),(23.855,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.255),(56.375,22.425),(56.545,22.425),(56.545,22.255),(56.375,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.255),(56.735,22.425),(56.905,22.425),(56.905,22.255),(56.735,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.255),(57.095,22.425),(57.265,22.425),(57.265,22.255),(57.095,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.255),(57.455,22.425),(57.625,22.425),(57.625,22.255),(57.455,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,22.255),(27.575,22.425),(27.745,22.425),(27.745,22.255),(27.575,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,22.255),(27.935,22.425),(28.105,22.425),(28.105,22.255),(27.935,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,22.255),(28.295,22.425),(28.465,22.425),(28.465,22.255),(28.295,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,22.255),(28.655,22.425),(28.825,22.425),(28.825,22.255),(28.655,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.255),(46.775,22.425),(46.945,22.425),(46.945,22.255),(46.775,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.255),(47.135,22.425),(47.305,22.425),(47.305,22.255),(47.135,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.255),(47.495,22.425),(47.665,22.425),(47.665,22.255),(47.495,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.255),(47.855,22.425),(48.025,22.425),(48.025,22.255),(47.855,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,22.255),(80.375,22.425),(80.545,22.425),(80.545,22.255),(80.375,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,22.255),(80.735,22.425),(80.905,22.425),(80.905,22.255),(80.735,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,22.255),(81.095,22.425),(81.265,22.425),(81.265,22.255),(81.095,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,22.255),(81.455,22.425),(81.625,22.425),(81.625,22.255),(81.455,22.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.79,84.07),(25.79,84.24),(25.96,84.24),(25.96,84.07),(25.79,84.07)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.15,84.07),(26.15,84.24),(26.32,84.24),(26.32,84.07),(26.15,84.07)),
        )
        createRL(
            tech, net, 'via',
            ((23.485,128.01),(23.485,128.16),(23.635,128.16),(23.635,128.01),(23.485,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((23.805,128.01),(23.805,128.16),(23.955,128.16),(23.955,128.01),(23.805,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((24.125,128.01),(24.125,128.16),(24.275,128.16),(24.275,128.01),(24.125,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((24.445,128.01),(24.445,128.16),(24.595,128.16),(24.595,128.01),(24.445,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((24.765,128.01),(24.765,128.16),(24.915,128.16),(24.915,128.01),(24.765,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((25.085,128.01),(25.085,128.16),(25.235,128.16),(25.235,128.01),(25.085,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((25.405,128.01),(25.405,128.16),(25.555,128.16),(25.555,128.01),(25.405,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,128.01),(25.725,128.16),(25.875,128.16),(25.875,128.01),(25.725,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((26.045,128.01),(26.045,128.16),(26.195,128.16),(26.195,128.01),(26.045,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((26.365,128.01),(26.365,128.16),(26.515,128.16),(26.515,128.01),(26.365,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((26.685,128.01),(26.685,128.16),(26.835,128.16),(26.835,128.01),(26.685,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((27.005,128.01),(27.005,128.16),(27.155,128.16),(27.155,128.01),(27.005,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((27.325,128.01),(27.325,128.16),(27.475,128.16),(27.475,128.01),(27.325,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((27.645,128.01),(27.645,128.16),(27.795,128.16),(27.795,128.01),(27.645,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((27.965,128.01),(27.965,128.16),(28.115,128.16),(28.115,128.01),(27.965,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((28.285,128.01),(28.285,128.16),(28.435,128.16),(28.435,128.01),(28.285,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((28.605,128.01),(28.605,128.16),(28.755,128.16),(28.755,128.01),(28.605,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((28.925,128.01),(28.925,128.16),(29.075,128.16),(29.075,128.01),(28.925,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((29.245,128.01),(29.245,128.16),(29.395,128.16),(29.395,128.01),(29.245,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((29.565,128.01),(29.565,128.16),(29.715,128.16),(29.715,128.01),(29.565,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((29.885,128.01),(29.885,128.16),(30.035,128.16),(30.035,128.01),(29.885,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((30.205,128.01),(30.205,128.16),(30.355,128.16),(30.355,128.01),(30.205,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,128.01),(30.525,128.16),(30.675,128.16),(30.675,128.01),(30.525,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((30.845,128.01),(30.845,128.16),(30.995,128.16),(30.995,128.01),(30.845,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((31.165,128.01),(31.165,128.16),(31.315,128.16),(31.315,128.01),(31.165,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((31.485,128.01),(31.485,128.16),(31.635,128.16),(31.635,128.01),(31.485,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((31.805,128.01),(31.805,128.16),(31.955,128.16),(31.955,128.01),(31.805,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((32.125,128.01),(32.125,128.16),(32.275,128.16),(32.275,128.01),(32.125,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((32.445,128.01),(32.445,128.16),(32.595,128.16),(32.595,128.01),(32.445,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((32.765,128.01),(32.765,128.16),(32.915,128.16),(32.915,128.01),(32.765,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((33.085,128.01),(33.085,128.16),(33.235,128.16),(33.235,128.01),(33.085,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((33.405,128.01),(33.405,128.16),(33.555,128.16),(33.555,128.01),(33.405,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((33.725,128.01),(33.725,128.16),(33.875,128.16),(33.875,128.01),(33.725,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((34.045,128.01),(34.045,128.16),(34.195,128.16),(34.195,128.01),(34.045,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((34.365,128.01),(34.365,128.16),(34.515,128.16),(34.515,128.01),(34.365,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((34.685,128.01),(34.685,128.16),(34.835,128.16),(34.835,128.01),(34.685,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((35.005,128.01),(35.005,128.16),(35.155,128.16),(35.155,128.01),(35.005,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,128.01),(35.325,128.16),(35.475,128.16),(35.475,128.01),(35.325,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((35.645,128.01),(35.645,128.16),(35.795,128.16),(35.795,128.01),(35.645,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((35.965,128.01),(35.965,128.16),(36.115,128.16),(36.115,128.01),(35.965,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((36.285,128.01),(36.285,128.16),(36.435,128.16),(36.435,128.01),(36.285,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((36.605,128.01),(36.605,128.16),(36.755,128.16),(36.755,128.01),(36.605,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((36.925,128.01),(36.925,128.16),(37.075,128.16),(37.075,128.01),(36.925,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((37.245,128.01),(37.245,128.16),(37.395,128.16),(37.395,128.01),(37.245,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((37.565,128.01),(37.565,128.16),(37.715,128.16),(37.715,128.01),(37.565,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((37.885,128.01),(37.885,128.16),(38.035,128.16),(38.035,128.01),(37.885,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((38.205,128.01),(38.205,128.16),(38.355,128.16),(38.355,128.01),(38.205,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((38.525,128.01),(38.525,128.16),(38.675,128.16),(38.675,128.01),(38.525,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((38.845,128.01),(38.845,128.16),(38.995,128.16),(38.995,128.01),(38.845,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((39.165,128.01),(39.165,128.16),(39.315,128.16),(39.315,128.01),(39.165,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((39.485,128.01),(39.485,128.16),(39.635,128.16),(39.635,128.01),(39.485,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((39.805,128.01),(39.805,128.16),(39.955,128.16),(39.955,128.01),(39.805,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,128.01),(40.125,128.16),(40.275,128.16),(40.275,128.01),(40.125,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((40.445,128.01),(40.445,128.16),(40.595,128.16),(40.595,128.01),(40.445,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((40.765,128.01),(40.765,128.16),(40.915,128.16),(40.915,128.01),(40.765,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((41.085,128.01),(41.085,128.16),(41.235,128.16),(41.235,128.01),(41.085,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((41.405,128.01),(41.405,128.16),(41.555,128.16),(41.555,128.01),(41.405,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((41.725,128.01),(41.725,128.16),(41.875,128.16),(41.875,128.01),(41.725,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((42.045,128.01),(42.045,128.16),(42.195,128.16),(42.195,128.01),(42.045,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((42.365,128.01),(42.365,128.16),(42.515,128.16),(42.515,128.01),(42.365,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((42.685,128.01),(42.685,128.16),(42.835,128.16),(42.835,128.01),(42.685,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((43.005,128.01),(43.005,128.16),(43.155,128.16),(43.155,128.01),(43.005,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((43.325,128.01),(43.325,128.16),(43.475,128.16),(43.475,128.01),(43.325,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((43.645,128.01),(43.645,128.16),(43.795,128.16),(43.795,128.01),(43.645,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((43.965,128.01),(43.965,128.16),(44.115,128.16),(44.115,128.01),(43.965,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((44.285,128.01),(44.285,128.16),(44.435,128.16),(44.435,128.01),(44.285,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((44.605,128.01),(44.605,128.16),(44.755,128.16),(44.755,128.01),(44.605,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,128.01),(44.925,128.16),(45.075,128.16),(45.075,128.01),(44.925,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((45.245,128.01),(45.245,128.16),(45.395,128.16),(45.395,128.01),(45.245,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((45.565,128.01),(45.565,128.16),(45.715,128.16),(45.715,128.01),(45.565,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((45.885,128.01),(45.885,128.16),(46.035,128.16),(46.035,128.01),(45.885,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((46.205,128.01),(46.205,128.16),(46.355,128.16),(46.355,128.01),(46.205,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((46.525,128.01),(46.525,128.16),(46.675,128.16),(46.675,128.01),(46.525,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((46.845,128.01),(46.845,128.16),(46.995,128.16),(46.995,128.01),(46.845,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((47.165,128.01),(47.165,128.16),(47.315,128.16),(47.315,128.01),(47.165,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((47.485,128.01),(47.485,128.16),(47.635,128.16),(47.635,128.01),(47.485,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((47.805,128.01),(47.805,128.16),(47.955,128.16),(47.955,128.01),(47.805,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((48.125,128.01),(48.125,128.16),(48.275,128.16),(48.275,128.01),(48.125,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((48.445,128.01),(48.445,128.16),(48.595,128.16),(48.595,128.01),(48.445,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((48.765,128.01),(48.765,128.16),(48.915,128.16),(48.915,128.01),(48.765,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((49.085,128.01),(49.085,128.16),(49.235,128.16),(49.235,128.01),(49.085,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((49.405,128.01),(49.405,128.16),(49.555,128.16),(49.555,128.01),(49.405,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,128.01),(49.725,128.16),(49.875,128.16),(49.875,128.01),(49.725,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((50.045,128.01),(50.045,128.16),(50.195,128.16),(50.195,128.01),(50.045,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((50.365,128.01),(50.365,128.16),(50.515,128.16),(50.515,128.01),(50.365,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((50.685,128.01),(50.685,128.16),(50.835,128.16),(50.835,128.01),(50.685,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((51.005,128.01),(51.005,128.16),(51.155,128.16),(51.155,128.01),(51.005,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((51.325,128.01),(51.325,128.16),(51.475,128.16),(51.475,128.01),(51.325,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((51.645,128.01),(51.645,128.16),(51.795,128.16),(51.795,128.01),(51.645,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((51.965,128.01),(51.965,128.16),(52.115,128.16),(52.115,128.01),(51.965,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((52.285,128.01),(52.285,128.16),(52.435,128.16),(52.435,128.01),(52.285,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((52.605,128.01),(52.605,128.16),(52.755,128.16),(52.755,128.01),(52.605,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((52.925,128.01),(52.925,128.16),(53.075,128.16),(53.075,128.01),(52.925,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((53.245,128.01),(53.245,128.16),(53.395,128.16),(53.395,128.01),(53.245,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((53.565,128.01),(53.565,128.16),(53.715,128.16),(53.715,128.01),(53.565,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((53.885,128.01),(53.885,128.16),(54.035,128.16),(54.035,128.01),(53.885,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((54.205,128.01),(54.205,128.16),(54.355,128.16),(54.355,128.01),(54.205,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,128.01),(54.525,128.16),(54.675,128.16),(54.675,128.01),(54.525,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((54.845,128.01),(54.845,128.16),(54.995,128.16),(54.995,128.01),(54.845,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((55.165,128.01),(55.165,128.16),(55.315,128.16),(55.315,128.01),(55.165,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((55.485,128.01),(55.485,128.16),(55.635,128.16),(55.635,128.01),(55.485,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((55.805,128.01),(55.805,128.16),(55.955,128.16),(55.955,128.01),(55.805,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((56.125,128.01),(56.125,128.16),(56.275,128.16),(56.275,128.01),(56.125,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((56.445,128.01),(56.445,128.16),(56.595,128.16),(56.595,128.01),(56.445,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((56.765,128.01),(56.765,128.16),(56.915,128.16),(56.915,128.01),(56.765,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((57.085,128.01),(57.085,128.16),(57.235,128.16),(57.235,128.01),(57.085,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((57.405,128.01),(57.405,128.16),(57.555,128.16),(57.555,128.01),(57.405,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((57.725,128.01),(57.725,128.16),(57.875,128.16),(57.875,128.01),(57.725,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((58.045,128.01),(58.045,128.16),(58.195,128.16),(58.195,128.01),(58.045,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((58.365,128.01),(58.365,128.16),(58.515,128.16),(58.515,128.01),(58.365,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((58.685,128.01),(58.685,128.16),(58.835,128.16),(58.835,128.01),(58.685,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((59.005,128.01),(59.005,128.16),(59.155,128.16),(59.155,128.01),(59.005,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,128.01),(59.325,128.16),(59.475,128.16),(59.475,128.01),(59.325,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((59.645,128.01),(59.645,128.16),(59.795,128.16),(59.795,128.01),(59.645,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((59.965,128.01),(59.965,128.16),(60.115,128.16),(60.115,128.01),(59.965,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((60.285,128.01),(60.285,128.16),(60.435,128.16),(60.435,128.01),(60.285,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((60.605,128.01),(60.605,128.16),(60.755,128.16),(60.755,128.01),(60.605,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((60.925,128.01),(60.925,128.16),(61.075,128.16),(61.075,128.01),(60.925,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((61.245,128.01),(61.245,128.16),(61.395,128.16),(61.395,128.01),(61.245,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((61.565,128.01),(61.565,128.16),(61.715,128.16),(61.715,128.01),(61.565,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((61.885,128.01),(61.885,128.16),(62.035,128.16),(62.035,128.01),(61.885,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((62.205,128.01),(62.205,128.16),(62.355,128.16),(62.355,128.01),(62.205,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((62.525,128.01),(62.525,128.16),(62.675,128.16),(62.675,128.01),(62.525,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((62.845,128.01),(62.845,128.16),(62.995,128.16),(62.995,128.01),(62.845,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((63.165,128.01),(63.165,128.16),(63.315,128.16),(63.315,128.01),(63.165,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((63.485,128.01),(63.485,128.16),(63.635,128.16),(63.635,128.01),(63.485,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((63.805,128.01),(63.805,128.16),(63.955,128.16),(63.955,128.01),(63.805,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,128.01),(64.125,128.16),(64.275,128.16),(64.275,128.01),(64.125,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((64.445,128.01),(64.445,128.16),(64.595,128.16),(64.595,128.01),(64.445,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((64.765,128.01),(64.765,128.16),(64.915,128.16),(64.915,128.01),(64.765,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((65.085,128.01),(65.085,128.16),(65.235,128.16),(65.235,128.01),(65.085,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((65.405,128.01),(65.405,128.16),(65.555,128.16),(65.555,128.01),(65.405,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((65.725,128.01),(65.725,128.16),(65.875,128.16),(65.875,128.01),(65.725,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((66.045,128.01),(66.045,128.16),(66.195,128.16),(66.195,128.01),(66.045,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((66.365,128.01),(66.365,128.16),(66.515,128.16),(66.515,128.01),(66.365,128.01)),
        )
        createRL(
            tech, net, 'via',
            ((25.825,84.08),(25.825,84.23),(25.975,84.23),(25.975,84.08),(25.825,84.08)),
        )
        createRL(
            tech, net, 'via',
            ((26.145,84.08),(26.145,84.23),(26.295,84.23),(26.295,84.08),(26.145,84.08)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        net = nets['iovdd_res']
        createRL(
            tech, net, 'li',
            ((63.815,83.99),(63.815,87.48),(63.985,87.48),(63.985,83.99),(63.815,83.99)),
        )
        createRL(
            tech, net, 'li',
            ((63.815,87.31),(63.815,87.48),(73.29,87.48),(73.29,87.31),(63.815,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.97,87.31),(63.97,87.48),(64.14,87.48),(64.14,87.31),(63.97,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.33,87.31),(64.33,87.48),(64.5,87.48),(64.5,87.31),(64.33,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.69,87.31),(64.69,87.48),(64.86,87.48),(64.86,87.31),(64.69,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.05,87.31),(65.05,87.48),(65.22,87.48),(65.22,87.31),(65.05,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.41,87.31),(65.41,87.48),(65.58,87.48),(65.58,87.31),(65.41,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.77,87.31),(65.77,87.48),(65.94,87.48),(65.94,87.31),(65.77,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.13,87.31),(66.13,87.48),(66.3,87.48),(66.3,87.31),(66.13,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.49,87.31),(66.49,87.48),(66.66,87.48),(66.66,87.31),(66.49,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.85,87.31),(66.85,87.48),(67.02,87.48),(67.02,87.31),(66.85,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.21,87.31),(67.21,87.48),(67.38,87.48),(67.38,87.31),(67.21,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.57,87.31),(67.57,87.48),(67.74,87.48),(67.74,87.31),(67.57,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.93,87.31),(67.93,87.48),(68.1,87.48),(68.1,87.31),(67.93,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.29,87.31),(68.29,87.48),(68.46,87.48),(68.46,87.31),(68.29,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.65,87.31),(68.65,87.48),(68.82,87.48),(68.82,87.31),(68.65,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((69.01,87.31),(69.01,87.48),(69.18,87.48),(69.18,87.31),(69.01,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((69.37,87.31),(69.37,87.48),(69.54,87.48),(69.54,87.31),(69.37,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((69.73,87.31),(69.73,87.48),(69.9,87.48),(69.9,87.31),(69.73,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.09,87.31),(70.09,87.48),(70.26,87.48),(70.26,87.31),(70.09,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.45,87.31),(70.45,87.48),(70.62,87.48),(70.62,87.31),(70.45,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.81,87.31),(70.81,87.48),(70.98,87.48),(70.98,87.31),(70.81,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.17,87.31),(71.17,87.48),(71.34,87.48),(71.34,87.31),(71.17,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.53,87.31),(71.53,87.48),(71.7,87.48),(71.7,87.31),(71.53,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.89,87.31),(71.89,87.48),(72.06,87.48),(72.06,87.31),(71.89,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((72.25,87.31),(72.25,87.48),(72.42,87.48),(72.42,87.31),(72.25,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((72.61,87.31),(72.61,87.48),(72.78,87.48),(72.78,87.31),(72.61,87.31)),
        )
        createRL(
            tech, net, 'mcon',
            ((72.97,87.31),(72.97,87.48),(73.14,87.48),(73.14,87.31),(72.97,87.31)),
        )
        createRL(
            tech, net, 'm1',
            ((64.255,87.25),(64.255,126.165),(73.29,126.165),(73.29,87.25),(64.255,87.25)),
        )
        createRL(
            tech, net, 'm1',
            ((63.815,87.25),(63.815,87.54),(73.29,87.54),(73.29,87.25),(63.815,87.25)),
        )
        net = nets['ngate']
        createRL(
            tech, net, 'm1',
            ((0.28,19.005),(0.28,125.655),(0.56,125.655),(0.56,19.005),(0.28,19.005)),
        )
        createRL(
            tech, net, 'm1',
            ((0.28,19.005),(0.28,22.34),(4.27,22.34),(4.27,19.005),(0.28,19.005)),
        )
        createRL(
            tech, net, 'm1',
            ((0.28,96.605),(0.28,125.655),(21.365,125.655),(21.365,96.605),(0.28,96.605)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N32N32D']
        except:
            subcell = af.getCell('Clamp_N32N32D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['RCClampInverter']
        except:
            subcell = af.getCell('RCClampInverter', 0)
        trans = Transformation(
            u(90), u(89.4), Transformation.Orientation.MY,
        )
        Instance.create(
            cell, 'rcinv', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['RCClampResistor']
        except:
            subcell = af.getCell('RCClampResistor', 0)
        trans = Transformation(
            u(26.37), u(84.32), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'rcres', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Clamp_N32N32D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(22.34),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'gate': Net.create(cell, 'gate'),
            'iovss': Net.create(cell, 'iovss'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((59.05,2.72),(59.05,19.62),(59.75,19.62),(59.75,2.72),(59.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.55,2.72),(16.55,19.62),(16.87,19.62),(16.87,2.72),(16.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.835,2.72),(74.835,19.62),(75.435,19.62),(75.435,2.72),(74.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.965,2.72),(67.965,19.62),(68.215,19.62),(68.215,2.72),(67.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.25,2.72),(78.25,19.62),(78.95,19.62),(78.95,2.72),(78.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.585,2.72),(74.585,19.62),(74.835,19.62),(74.835,2.72),(74.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.235,2.72),(65.235,19.62),(65.835,19.62),(65.835,2.72),(65.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,2.72),(39.415,19.62),(40.87,19.62),(40.87,2.72),(39.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(40.985,19.62),(40.985,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.85,2.72),(39.85,19.62),(40.55,19.62),(40.55,2.72),(39.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(54.25,19.62),(54.25,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.165,2.72),(24.165,19.62),(24.765,19.62),(24.765,2.72),(24.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.165,2.72),(39.165,19.62),(39.415,19.62),(39.415,2.72),(39.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.165,2.72),(63.165,19.62),(63.415,19.62),(63.415,2.72),(63.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(44.65,19.62),(44.65,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,19.62),(31.385,19.62),(31.385,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,2.72),(54.25,19.62),(54.95,19.62),(54.95,2.72),(54.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.815,2.72),(29.815,19.62),(31.27,19.62),(31.27,2.72),(29.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.035,2.72),(70.035,19.62),(70.635,19.62),(70.635,2.72),(70.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.435,2.72),(36.435,19.62),(37.035,19.62),(37.035,2.72),(36.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.965,2.72),(28.965,19.62),(29.565,19.62),(29.565,2.72),(28.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.785,2.72),(45.785,19.62),(46.035,19.62),(46.035,2.72),(45.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.365,2.72),(58.365,19.62),(58.615,19.62),(58.615,2.72),(58.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.985,2.72),(64.985,19.62),(65.235,19.62),(65.235,2.72),(64.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.185,2.72),(60.185,19.62),(60.435,19.62),(60.435,2.72),(60.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.185,2.72),(12.185,19.62),(12.435,19.62),(12.435,2.72),(12.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((78.95,2.72),(78.95,19.62),(79.27,19.62),(79.27,2.72),(78.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((83.05,2.72),(83.05,19.62),(83.75,19.62),(83.75,2.72),(83.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.365,2.72),(19.365,19.62),(19.965,19.62),(19.965,2.72),(19.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.585,2.72),(50.585,19.62),(50.835,19.62),(50.835,2.72),(50.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.165,2.72),(15.165,19.62),(15.415,19.62),(15.415,2.72),(15.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.385,2.72),(55.385,19.62),(55.635,19.62),(55.635,2.72),(55.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.765,2.72),(72.765,19.62),(73.015,19.62),(73.015,2.72),(72.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.635,2.72),(55.635,19.62),(56.235,19.62),(56.235,2.72),(55.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.965,2.72),(43.965,19.62),(44.215,19.62),(44.215,2.72),(43.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.93,2.72),(29.93,19.62),(30.25,19.62),(30.25,2.72),(29.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.65,2.72),(44.65,19.62),(45.35,19.62),(45.35,2.72),(44.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.215,2.72),(44.215,19.62),(45.67,19.62),(45.67,2.72),(44.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(45.785,19.62),(45.785,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.95,2.72),(54.95,19.62),(55.27,19.62),(55.27,2.72),(54.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,19.62),(63.85,19.62),(63.85,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,19.62),(53.565,19.62),(53.565,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.035,2.72),(46.035,19.62),(46.635,19.62),(46.635,2.72),(46.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.75,2.72),(35.75,19.62),(36.07,19.62),(36.07,2.72),(35.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.85,2.72),(15.85,19.62),(16.55,19.62),(16.55,2.72),(15.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.415,2.72),(15.415,19.62),(16.87,19.62),(16.87,2.72),(15.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,19.62),(16.985,19.62),(16.985,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.815,2.72),(77.815,19.62),(79.27,19.62),(79.27,2.72),(77.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,19.62),(79.385,19.62),(79.385,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(35.05,19.62),(35.05,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.615,2.72),(34.615,19.62),(36.07,19.62),(36.07,2.72),(34.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(36.185,19.62),(36.185,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.365,2.72),(67.365,19.62),(67.965,19.62),(67.965,2.72),(67.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.565,2.72),(29.565,19.62),(29.815,19.62),(29.815,2.72),(29.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.165,2.72),(72.165,19.62),(72.765,19.62),(72.765,2.72),(72.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,19.62),(20.65,19.62),(20.65,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.765,2.72),(81.765,19.62),(82.365,19.62),(82.365,2.72),(81.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,19.62),(34.365,19.62),(34.365,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((24.765,2.72),(24.765,19.62),(25.015,19.62),(25.015,2.72),(24.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((15.53,2.72),(15.53,19.62),(15.85,19.62),(15.85,2.72),(15.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.785,2.72),(21.785,19.62),(22.035,19.62),(22.035,2.72),(21.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,19.62),(30.95,19.62),(30.95,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.435,2.72),(60.435,19.62),(61.035,19.62),(61.035,2.72),(60.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.75,2.72),(59.75,19.62),(60.07,19.62),(60.07,2.72),(59.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.365,2.72),(10.365,19.62),(10.615,19.62),(10.615,2.72),(10.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.365,2.72),(82.365,19.62),(82.615,19.62),(82.615,2.72),(82.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.185,2.72),(36.185,19.62),(36.435,19.62),(36.435,2.72),(36.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.45,2.72),(25.45,19.62),(26.15,19.62),(26.15,2.72),(25.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.05,2.72),(11.05,19.62),(11.75,19.62),(11.75,2.72),(11.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.015,2.72),(25.015,19.62),(26.47,19.62),(26.47,2.72),(25.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,19.62),(26.585,19.62),(26.585,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.835,2.72),(50.835,19.62),(51.435,19.62),(51.435,2.72),(50.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.565,2.72),(14.565,19.62),(15.165,19.62),(15.165,2.72),(14.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.93,2.72),(77.93,19.62),(78.25,19.62),(78.25,2.72),(77.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.565,2.72),(53.565,19.62),(53.815,19.62),(53.815,2.72),(53.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.85,2.72),(63.85,19.62),(64.55,19.62),(64.55,2.72),(63.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.415,2.72),(63.415,19.62),(64.87,19.62),(64.87,2.72),(63.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.53,2.72),(63.53,19.62),(64.985,19.62),(64.985,2.72),(63.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.235,2.72),(41.235,19.62),(41.835,19.62),(41.835,2.72),(41.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.35,2.72),(69.35,19.62),(69.67,19.62),(69.67,2.72),(69.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.635,2.72),(7.635,19.62),(8.235,19.62),(8.235,2.72),(7.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.635,2.72),(79.635,19.62),(80.235,19.62),(80.235,2.72),(79.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.215,2.72),(20.215,19.62),(21.67,19.62),(21.67,2.72),(20.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.33,2.72),(20.33,19.62),(21.785,19.62),(21.785,2.72),(20.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((20.65,2.72),(20.65,19.62),(21.35,19.62),(21.35,2.72),(20.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.235,2.72),(17.235,19.62),(17.835,19.62),(17.835,2.72),(17.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.365,2.72),(34.365,19.62),(34.615,19.62),(34.615,2.72),(34.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.985,2.72),(40.985,19.62),(41.235,19.62),(41.235,2.72),(40.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.13,2.72),(25.13,19.62),(25.45,19.62),(25.45,2.72),(25.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(39.85,19.62),(39.85,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,19.62),(68.65,19.62),(68.65,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.95,2.72),(30.95,19.62),(31.27,19.62),(31.27,2.72),(30.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,19.62),(6.95,19.62),(6.95,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.35,2.72),(21.35,19.62),(21.67,19.62),(21.67,2.72),(21.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((77.565,2.72),(77.565,19.62),(77.815,19.62),(77.815,2.72),(77.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.765,2.72),(9.765,19.62),(10.365,19.62),(10.365,2.72),(9.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.015,2.72),(73.015,19.62),(74.47,19.62),(74.47,2.72),(73.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.45,2.72),(73.45,19.62),(74.15,19.62),(74.15,2.72),(73.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,19.62),(74.585,19.62),(74.585,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((7.385,2.72),(7.385,19.62),(7.635,19.62),(7.635,2.72),(7.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,19.62),(48.765,19.62),(48.765,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((79.385,2.72),(79.385,19.62),(79.635,19.62),(79.635,2.72),(79.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.765,2.72),(48.765,19.62),(49.015,19.62),(49.015,2.72),(48.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.35,2.72),(45.35,19.62),(45.67,19.62),(45.67,2.72),(45.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.65,2.72),(68.65,19.62),(69.35,19.62),(69.35,2.72),(68.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.215,2.72),(68.215,19.62),(69.67,19.62),(69.67,2.72),(68.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.33,2.72),(68.33,19.62),(69.785,19.62),(69.785,2.72),(68.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.95,2.72),(6.95,19.62),(7.27,19.62),(7.27,2.72),(6.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((6.25,2.72),(6.25,19.62),(7.385,19.62),(7.385,2.72),(6.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(59.05,19.62),(59.05,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.13,2.72),(73.13,19.62),(73.45,19.62),(73.45,2.72),(73.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.035,2.72),(22.035,19.62),(22.635,19.62),(22.635,2.72),(22.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.635,2.72),(31.635,19.62),(32.235,19.62),(32.235,2.72),(31.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,19.62),(39.165,19.62),(39.165,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.835,2.72),(26.835,19.62),(27.435,19.62),(27.435,2.72),(26.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.965,2.72),(19.965,19.62),(20.215,19.62),(20.215,2.72),(19.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,19.62),(11.05,19.62),(11.05,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((12.435,2.72),(12.435,19.62),(13.035,19.62),(13.035,2.72),(12.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.15,2.72),(50.15,19.62),(50.47,19.62),(50.47,2.72),(50.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.785,2.72),(69.785,19.62),(70.035,19.62),(70.035,2.72),(69.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.965,2.72),(76.965,19.62),(77.565,19.62),(77.565,2.72),(76.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.585,2.72),(26.585,19.62),(26.835,19.62),(26.835,2.72),(26.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.73,2.72),(82.73,19.62),(83.05,19.62),(83.05,2.72),(82.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((82.615,2.72),(82.615,19.62),(83.75,19.62),(83.75,2.72),(82.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.385,2.72),(31.385,19.62),(31.635,19.62),(31.635,2.72),(31.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((11.75,2.72),(11.75,19.62),(12.07,19.62),(12.07,2.72),(11.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.55,2.72),(40.55,19.62),(40.87,19.62),(40.87,2.72),(40.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.615,2.72),(58.615,19.62),(60.07,19.62),(60.07,2.72),(58.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(60.185,19.62),(60.185,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((74.15,2.72),(74.15,19.62),(74.47,19.62),(74.47,2.72),(74.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.05,2.72),(35.05,19.62),(35.75,19.62),(35.75,2.72),(35.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.55,2.72),(64.55,19.62),(64.87,19.62),(64.87,2.72),(64.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(49.45,19.62),(49.45,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.45,2.72),(49.45,19.62),(50.15,19.62),(50.15,2.72),(49.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(50.585,19.62),(50.585,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.015,2.72),(49.015,19.62),(50.47,19.62),(50.47,2.72),(49.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.985,2.72),(16.985,19.62),(17.235,19.62),(17.235,2.72),(16.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.615,2.72),(10.615,19.62),(12.07,19.62),(12.07,2.72),(10.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((10.73,2.72),(10.73,19.62),(12.185,19.62),(12.185,2.72),(10.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(55.385,19.62),(55.385,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.815,2.72),(53.815,19.62),(55.27,19.62),(55.27,2.72),(53.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.15,2.72),(26.15,19.62),(26.47,19.62),(26.47,2.72),(26.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.565,2.72),(62.565,19.62),(63.165,19.62),(63.165,2.72),(62.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,19.62),(43.965,19.62),(43.965,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,19.62),(58.365,19.62),(58.365,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.685),(83.315,7.855),(83.485,7.855),(83.485,7.685),(83.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.625),(78.005,4.795),(78.175,4.795),(78.175,4.625),(78.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.285),(78.005,4.455),(78.175,4.455),(78.175,4.285),(78.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.285),(78.515,4.455),(78.685,4.455),(78.685,4.285),(78.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.625),(78.515,4.795),(78.685,4.795),(78.685,4.625),(78.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.025),(16.115,8.195),(16.285,8.195),(16.285,8.025),(16.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.025),(16.625,8.195),(16.795,8.195),(16.795,8.025),(16.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.705),(16.625,8.875),(16.795,8.875),(16.795,8.705),(16.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.365),(16.115,8.535),(16.285,8.535),(16.285,8.365),(16.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,8.365),(16.625,8.535),(16.795,8.535),(16.795,8.365),(16.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,8.705),(16.115,8.875),(16.285,8.875),(16.285,8.705),(16.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.685),(35.315,7.855),(35.485,7.855),(35.485,7.685),(35.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.685),(35.825,7.855),(35.995,7.855),(35.995,7.685),(35.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.005),(35.825,7.175),(35.995,7.175),(35.995,7.005),(35.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.005),(35.315,7.175),(35.485,7.175),(35.485,7.005),(35.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.345),(35.825,7.515),(35.995,7.515),(35.995,7.345),(35.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.965),(40.115,5.135),(40.285,5.135),(40.285,4.965),(40.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.965),(40.625,5.135),(40.795,5.135),(40.795,4.965),(40.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.345),(35.315,7.515),(35.485,7.515),(35.485,7.345),(35.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.245),(35.315,19.415),(35.485,19.415),(35.485,19.245),(35.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.245),(35.825,19.415),(35.995,19.415),(35.995,19.245),(35.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.985),(73.715,6.155),(73.885,6.155),(73.885,5.985),(73.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.985),(73.205,6.155),(73.375,6.155),(73.375,5.985),(73.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.225),(44.405,18.395),(44.575,18.395),(44.575,18.225),(44.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.565),(44.405,18.735),(44.575,18.735),(44.575,18.565),(44.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.005),(59.825,7.175),(59.995,7.175),(59.995,7.005),(59.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.005),(59.315,7.175),(59.485,7.175),(59.485,7.005),(59.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.345),(59.825,7.515),(59.995,7.515),(59.995,7.345),(59.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.345),(59.315,7.515),(59.485,7.515),(59.485,7.345),(59.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.885),(69.425,18.055),(69.595,18.055),(69.595,17.885),(69.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.185),(16.625,16.355),(16.795,16.355),(16.795,16.185),(16.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.185),(16.115,16.355),(16.285,16.355),(16.285,16.185),(16.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.525),(16.115,16.695),(16.285,16.695),(16.285,16.525),(16.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.045),(58.805,9.215),(58.975,9.215),(58.975,9.045),(58.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.525),(16.625,16.695),(16.795,16.695),(16.795,16.525),(16.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.185),(59.825,16.355),(59.995,16.355),(59.995,16.185),(59.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.525),(59.825,16.695),(59.995,16.695),(59.995,16.525),(59.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.185),(59.315,16.355),(59.485,16.355),(59.485,16.185),(59.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.525),(59.315,16.695),(59.485,16.695),(59.485,16.525),(59.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.225),(82.805,18.395),(82.975,18.395),(82.975,18.225),(82.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.565),(82.805,18.735),(82.975,18.735),(82.975,18.565),(82.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.765),(58.805,11.935),(58.975,11.935),(58.975,11.765),(58.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.085),(58.805,11.255),(58.975,11.255),(58.975,11.085),(58.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.425),(58.805,11.595),(58.975,11.595),(58.975,11.425),(58.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.785),(73.715,12.955),(73.885,12.955),(73.885,12.785),(73.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.785),(73.205,12.955),(73.375,12.955),(73.375,12.785),(73.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.445),(73.205,12.615),(73.375,12.615),(73.375,12.445),(73.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.445),(73.715,12.615),(73.885,12.615),(73.885,12.445),(73.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,12.105),(73.205,12.275),(73.375,12.275),(73.375,12.105),(73.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,12.105),(73.715,12.275),(73.885,12.275),(73.885,12.105),(73.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.125),(11.315,13.295),(11.485,13.295),(11.485,13.125),(11.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.545),(31.025,17.715),(31.195,17.715),(31.195,17.545),(31.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.205),(31.025,17.375),(31.195,17.375),(31.195,17.205),(31.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.445),(25.715,12.615),(25.885,12.615),(25.885,12.445),(25.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.785),(25.715,12.955),(25.885,12.955),(25.885,12.785),(25.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.785),(25.205,12.955),(25.375,12.955),(25.375,12.785),(25.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.445),(25.205,12.615),(25.375,12.615),(25.375,12.445),(25.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.345),(25.205,7.515),(25.375,7.515),(25.375,7.345),(25.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.345),(25.715,7.515),(25.885,7.515),(25.885,7.345),(25.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,12.105),(25.715,12.275),(25.885,12.275),(25.885,12.105),(25.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.005),(25.205,7.175),(25.375,7.175),(25.375,7.005),(25.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.005),(25.715,7.175),(25.885,7.175),(25.885,7.005),(25.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,12.105),(25.205,12.275),(25.375,12.275),(25.375,12.105),(25.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.385),(64.115,9.555),(64.285,9.555),(64.285,9.385),(64.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.725),(64.115,9.895),(64.285,9.895),(64.285,9.725),(64.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.385),(64.625,9.555),(64.795,9.555),(64.795,9.385),(64.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.725),(64.625,9.895),(64.795,9.895),(64.795,9.725),(64.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,19.245),(68.915,19.415),(69.085,19.415),(69.085,19.245),(68.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.145),(49.205,14.315),(49.375,14.315),(49.375,14.145),(49.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.485),(49.205,14.655),(49.375,14.655),(49.375,14.485),(49.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.485),(49.715,14.655),(49.885,14.655),(49.885,14.485),(49.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.825),(49.715,14.995),(49.885,14.995),(49.885,14.825),(49.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.825),(49.205,14.995),(49.375,14.995),(49.375,14.825),(49.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.885),(16.115,18.055),(16.285,18.055),(16.285,17.885),(16.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.885),(16.625,18.055),(16.795,18.055),(16.795,17.885),(16.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.385),(69.425,9.555),(69.595,9.555),(69.595,9.385),(69.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.725),(69.425,9.895),(69.595,9.895),(69.595,9.725),(69.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,19.245),(15.605,19.415),(15.775,19.415),(15.775,19.245),(15.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.325),(64.115,6.495),(64.285,6.495),(64.285,6.325),(64.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.665),(64.625,6.835),(64.795,6.835),(64.795,6.665),(64.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,6.325),(64.625,6.495),(64.795,6.495),(64.795,6.325),(64.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,6.665),(64.115,6.835),(64.285,6.835),(64.285,6.665),(64.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.265),(40.625,3.435),(40.795,3.435),(40.795,3.265),(40.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.265),(40.115,3.435),(40.285,3.435),(40.285,3.265),(40.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.605),(40.115,3.775),(40.285,3.775),(40.285,3.605),(40.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.605),(40.625,3.775),(40.795,3.775),(40.795,3.605),(40.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.725),(21.425,9.895),(21.595,9.895),(21.595,9.725),(21.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.385),(21.425,9.555),(21.595,9.555),(21.595,9.385),(21.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.685),(74.225,7.855),(74.395,7.855),(74.395,7.685),(74.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.865),(68.915,17.035),(69.085,17.035),(69.085,16.865),(68.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.105),(64.625,12.275),(64.795,12.275),(64.795,12.105),(64.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.785),(64.625,12.955),(64.795,12.955),(64.795,12.785),(64.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,12.445),(64.625,12.615),(64.795,12.615),(64.795,12.445),(64.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.445),(64.115,12.615),(64.285,12.615),(64.285,12.445),(64.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.785),(64.115,12.955),(64.285,12.955),(64.285,12.785),(64.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,12.105),(64.115,12.275),(64.285,12.275),(64.285,12.105),(64.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.045),(44.915,9.215),(45.085,9.215),(45.085,9.045),(44.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.985),(68.405,6.155),(68.575,6.155),(68.575,5.985),(68.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.045),(68.915,9.215),(69.085,9.215),(69.085,9.045),(68.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.845),(69.425,16.015),(69.595,16.015),(69.595,15.845),(69.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.265),(16.115,3.435),(16.285,3.435),(16.285,3.265),(16.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.265),(16.625,3.435),(16.795,3.435),(16.795,3.265),(16.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.605),(16.625,3.775),(16.795,3.775),(16.795,3.605),(16.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.605),(16.115,3.775),(16.285,3.775),(16.285,3.605),(16.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.885),(39.605,18.055),(39.775,18.055),(39.775,17.885),(39.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.865),(82.805,17.035),(82.975,17.035),(82.975,16.865),(82.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.025),(11.825,8.195),(11.995,8.195),(11.995,8.025),(11.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.965),(11.315,5.135),(11.485,5.135),(11.485,4.965),(11.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.965),(11.825,5.135),(11.995,5.135),(11.995,4.965),(11.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.985),(68.915,6.155),(69.085,6.155),(69.085,5.985),(68.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.885),(54.515,18.055),(54.685,18.055),(54.685,17.885),(54.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.885),(54.005,18.055),(54.175,18.055),(54.175,17.885),(54.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.445),(16.115,12.615),(16.285,12.615),(16.285,12.445),(16.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.785),(16.625,12.955),(16.795,12.955),(16.795,12.785),(16.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.445),(16.625,12.615),(16.795,12.615),(16.795,12.445),(16.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.785),(16.115,12.955),(16.285,12.955),(16.285,12.785),(16.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,12.105),(16.625,12.275),(16.795,12.275),(16.795,12.105),(16.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,12.105),(16.115,12.275),(16.285,12.275),(16.285,12.105),(16.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.185),(44.405,16.355),(44.575,16.355),(44.575,16.185),(44.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.525),(44.405,16.695),(44.575,16.695),(44.575,16.525),(44.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.905),(69.425,19.075),(69.595,19.075),(69.595,18.905),(69.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.665),(39.605,6.835),(39.775,6.835),(39.775,6.665),(39.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.325),(39.605,6.495),(39.775,6.495),(39.775,6.325),(39.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.885),(20.405,18.055),(20.575,18.055),(20.575,17.885),(20.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,19.245),(74.225,19.415),(74.395,19.415),(74.395,19.245),(74.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.385),(34.805,9.555),(34.975,9.555),(34.975,9.385),(34.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.725),(34.805,9.895),(34.975,9.895),(34.975,9.725),(34.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,19.245),(82.805,19.415),(82.975,19.415),(82.975,19.245),(82.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.165),(74.225,15.335),(74.395,15.335),(74.395,15.165),(74.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.505),(74.225,15.675),(74.395,15.675),(74.395,15.505),(74.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.305),(69.425,5.475),(69.595,5.475),(69.595,5.305),(69.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.645),(69.425,5.815),(69.595,5.815),(69.595,5.645),(69.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.505),(26.225,15.675),(26.395,15.675),(26.395,15.505),(26.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.165),(26.225,15.335),(26.395,15.335),(26.395,15.165),(26.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.205),(64.115,17.375),(64.285,17.375),(64.285,17.205),(64.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.545),(64.625,17.715),(64.795,17.715),(64.795,17.545),(64.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.205),(64.625,17.375),(64.795,17.375),(64.795,17.205),(64.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.545),(64.115,17.715),(64.285,17.715),(64.285,17.545),(64.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.945),(68.915,4.115),(69.085,4.115),(69.085,3.945),(68.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.305),(21.425,5.475),(21.595,5.475),(21.595,5.305),(21.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.645),(21.425,5.815),(21.595,5.815),(21.595,5.645),(21.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.185),(54.515,16.355),(54.685,16.355),(54.685,16.185),(54.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.185),(54.005,16.355),(54.175,16.355),(54.175,16.185),(54.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.325),(63.605,6.495),(63.775,6.495),(63.775,6.325),(63.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,6.665),(63.605,6.835),(63.775,6.835),(63.775,6.665),(63.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.525),(54.515,16.695),(54.685,16.695),(54.685,16.525),(54.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.525),(54.005,16.695),(54.175,16.695),(54.175,16.525),(54.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.865),(69.425,17.035),(69.595,17.035),(69.595,16.865),(69.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.845),(45.425,16.015),(45.595,16.015),(45.595,15.845),(45.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.905),(34.805,19.075),(34.975,19.075),(34.975,18.905),(34.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.865),(63.605,17.035),(63.775,17.035),(63.775,16.865),(63.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.505),(79.025,15.675),(79.195,15.675),(79.195,15.505),(79.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.165),(79.025,15.335),(79.195,15.335),(79.195,15.165),(79.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.905),(35.825,19.075),(35.995,19.075),(35.995,18.905),(35.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.905),(35.315,19.075),(35.485,19.075),(35.485,18.905),(35.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.965),(59.315,5.135),(59.485,5.135),(59.485,4.965),(59.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.325),(11.315,6.495),(11.485,6.495),(11.485,6.325),(11.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,6.665),(11.315,6.835),(11.485,6.835),(11.485,6.665),(11.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.325),(11.825,6.495),(11.995,6.495),(11.995,6.325),(11.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,6.665),(11.825,6.835),(11.995,6.835),(11.995,6.665),(11.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.185),(31.025,16.355),(31.195,16.355),(31.195,16.185),(31.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.525),(31.025,16.695),(31.195,16.695),(31.195,16.525),(31.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.965),(59.825,5.135),(59.995,5.135),(59.995,4.965),(59.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.065),(39.605,10.235),(39.775,10.235),(39.775,10.065),(39.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.745),(39.605,10.915),(39.775,10.915),(39.775,10.745),(39.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.405),(39.605,10.575),(39.775,10.575),(39.775,10.405),(39.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.325),(78.005,6.495),(78.175,6.495),(78.175,6.325),(78.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,6.665),(78.005,6.835),(78.175,6.835),(78.175,6.665),(78.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.325),(78.515,6.495),(78.685,6.495),(78.685,6.325),(78.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,6.665),(78.515,6.835),(78.685,6.835),(78.685,6.665),(78.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.945),(44.915,4.115),(45.085,4.115),(45.085,3.945),(44.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.005),(73.205,7.175),(73.375,7.175),(73.375,7.005),(73.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.005),(73.715,7.175),(73.885,7.175),(73.885,7.005),(73.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.345),(73.205,7.515),(73.375,7.515),(73.375,7.345),(73.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.345),(73.715,7.515),(73.885,7.515),(73.885,7.345),(73.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.025),(39.605,8.195),(39.775,8.195),(39.775,8.025),(39.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.705),(39.605,8.875),(39.775,8.875),(39.775,8.705),(39.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.365),(39.605,8.535),(39.775,8.535),(39.775,8.365),(39.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,19.245),(64.625,19.415),(64.795,19.415),(64.795,19.245),(64.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,19.245),(69.425,19.415),(69.595,19.415),(69.595,19.245),(69.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.185),(50.225,16.355),(50.395,16.355),(50.395,16.185),(50.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.525),(50.225,16.695),(50.395,16.695),(50.395,16.525),(50.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.325),(25.715,6.495),(25.885,6.495),(25.885,6.325),(25.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.665),(25.205,6.835),(25.375,6.835),(25.375,6.665),(25.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,6.325),(25.205,6.495),(25.375,6.495),(25.375,6.325),(25.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,6.665),(25.715,6.835),(25.885,6.835),(25.885,6.665),(25.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.645),(26.225,5.815),(26.395,5.815),(26.395,5.645),(26.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.305),(26.225,5.475),(26.395,5.475),(26.395,5.305),(26.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.905),(26.225,19.075),(26.395,19.075),(26.395,18.905),(26.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.105),(26.225,12.275),(26.395,12.275),(26.395,12.105),(26.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.445),(26.225,12.615),(26.395,12.615),(26.395,12.445),(26.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.185),(11.825,16.355),(11.995,16.355),(11.995,16.185),(11.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.185),(11.315,16.355),(11.485,16.355),(11.485,16.185),(11.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.525),(11.315,16.695),(11.485,16.695),(11.485,16.525),(11.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,12.785),(26.225,12.955),(26.395,12.955),(26.395,12.785),(26.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.525),(11.825,16.695),(11.995,16.695),(11.995,16.525),(11.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.605),(30.005,3.775),(30.175,3.775),(30.175,3.605),(30.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.265),(30.005,3.435),(30.175,3.435),(30.175,3.265),(30.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.265),(30.515,3.435),(30.685,3.435),(30.685,3.265),(30.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.045),(31.025,9.215),(31.195,9.215),(31.195,9.045),(31.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.605),(30.515,3.775),(30.685,3.775),(30.685,3.605),(30.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.265),(7.025,3.435),(7.195,3.435),(7.195,3.265),(7.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.605),(7.025,3.775),(7.195,3.775),(7.195,3.605),(7.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.645),(44.405,5.815),(44.575,5.815),(44.575,5.645),(44.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.305),(44.405,5.475),(44.575,5.475),(44.575,5.305),(44.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.285),(68.915,4.455),(69.085,4.455),(69.085,4.285),(68.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.625),(68.915,4.795),(69.085,4.795),(69.085,4.625),(68.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.245),(44.405,19.415),(44.575,19.415),(44.575,19.245),(44.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.045),(10.805,9.215),(10.975,9.215),(10.975,9.045),(10.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.745),(16.115,10.915),(16.285,10.915),(16.285,10.745),(16.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.745),(16.625,10.915),(16.795,10.915),(16.795,10.745),(16.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.405),(16.115,10.575),(16.285,10.575),(16.285,10.405),(16.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.505),(31.025,15.675),(31.195,15.675),(31.195,15.505),(31.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.165),(31.025,15.335),(31.195,15.335),(31.195,15.165),(31.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.405),(16.625,10.575),(16.795,10.575),(16.795,10.405),(16.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.285),(20.915,4.455),(21.085,4.455),(21.085,4.285),(20.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.625),(20.915,4.795),(21.085,4.795),(21.085,4.625),(20.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,10.065),(16.115,10.235),(16.285,10.235),(16.285,10.065),(16.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,10.065),(16.625,10.235),(16.795,10.235),(16.795,10.065),(16.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.605),(11.825,3.775),(11.995,3.775),(11.995,3.605),(11.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.265),(11.315,3.435),(11.485,3.435),(11.485,3.265),(11.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.605),(11.315,3.775),(11.485,3.775),(11.485,3.605),(11.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.265),(11.825,3.435),(11.995,3.435),(11.995,3.265),(11.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.325),(30.515,6.495),(30.685,6.495),(30.685,6.325),(30.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.665),(30.515,6.835),(30.685,6.835),(30.685,6.665),(30.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.325),(30.005,6.495),(30.175,6.495),(30.175,6.325),(30.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,6.665),(30.005,6.835),(30.175,6.835),(30.175,6.665),(30.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.605),(25.715,3.775),(25.885,3.775),(25.885,3.605),(25.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.265),(25.205,3.435),(25.375,3.435),(25.375,3.265),(25.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.265),(25.715,3.435),(25.885,3.435),(25.885,3.265),(25.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.605),(25.205,3.775),(25.375,3.775),(25.375,3.605),(25.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.305),(39.605,5.475),(39.775,5.475),(39.775,5.305),(39.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.645),(39.605,5.815),(39.775,5.815),(39.775,5.645),(39.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.305),(15.605,5.475),(15.775,5.475),(15.775,5.305),(15.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.645),(15.605,5.815),(15.775,5.815),(15.775,5.645),(15.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.205),(83.315,17.375),(83.485,17.375),(83.485,17.205),(83.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.545),(83.315,17.715),(83.485,17.715),(83.485,17.545),(83.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.865),(74.225,17.035),(74.395,17.035),(74.395,16.865),(74.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.605),(20.915,3.775),(21.085,3.775),(21.085,3.605),(20.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.265),(20.915,3.435),(21.085,3.435),(21.085,3.265),(20.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.845),(10.805,16.015),(10.975,16.015),(10.975,15.845),(10.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.505),(64.115,15.675),(64.285,15.675),(64.285,15.505),(64.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.505),(64.625,15.675),(64.795,15.675),(64.795,15.505),(64.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.165),(64.115,15.335),(64.285,15.335),(64.285,15.165),(64.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.165),(64.625,15.335),(64.795,15.335),(64.795,15.165),(64.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.385),(82.805,9.555),(82.975,9.555),(82.975,9.385),(82.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.725),(82.805,9.895),(82.975,9.895),(82.975,9.725),(82.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.665),(58.805,6.835),(58.975,6.835),(58.975,6.665),(58.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.325),(58.805,6.495),(58.975,6.495),(58.975,6.325),(58.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.485),(40.625,14.655),(40.795,14.655),(40.795,14.485),(40.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.825),(40.625,14.995),(40.795,14.995),(40.795,14.825),(40.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.825),(40.115,14.995),(40.285,14.995),(40.285,14.825),(40.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.485),(40.115,14.655),(40.285,14.655),(40.285,14.485),(40.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.145),(40.625,14.315),(40.795,14.315),(40.795,14.145),(40.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.225),(55.025,18.395),(55.195,18.395),(55.195,18.225),(55.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.565),(55.025,18.735),(55.195,18.735),(55.195,18.565),(55.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.325),(34.805,6.495),(34.975,6.495),(34.975,6.325),(34.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.665),(34.805,6.835),(34.975,6.835),(34.975,6.665),(34.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.665),(54.515,6.835),(54.685,6.835),(54.685,6.665),(54.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.325),(54.515,6.495),(54.685,6.495),(54.685,6.325),(54.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.665),(54.005,6.835),(54.175,6.835),(54.175,6.665),(54.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.325),(54.005,6.495),(54.175,6.495),(54.175,6.325),(54.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.325),(10.805,6.495),(10.975,6.495),(10.975,6.325),(10.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,6.665),(10.805,6.835),(10.975,6.835),(10.975,6.665),(10.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.345),(78.515,7.515),(78.685,7.515),(78.685,7.345),(78.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.185),(39.605,16.355),(39.775,16.355),(39.775,16.185),(39.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.525),(39.605,16.695),(39.775,16.695),(39.775,16.525),(39.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.265),(49.205,3.435),(49.375,3.435),(49.375,3.265),(49.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.605),(49.205,3.775),(49.375,3.775),(49.375,3.605),(49.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.605),(49.715,3.775),(49.885,3.775),(49.885,3.605),(49.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.265),(49.715,3.435),(49.885,3.435),(49.885,3.265),(49.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.945),(83.315,4.115),(83.485,4.115),(83.485,3.945),(83.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.945),(79.025,4.115),(79.195,4.115),(79.195,3.945),(79.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.305),(63.605,5.475),(63.775,5.475),(63.775,5.305),(63.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.645),(63.605,5.815),(63.775,5.815),(63.775,5.645),(63.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.905),(79.025,19.075),(79.195,19.075),(79.195,18.905),(79.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.745),(83.315,10.915),(83.485,10.915),(83.485,10.745),(83.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.065),(83.315,10.235),(83.485,10.235),(83.485,10.065),(83.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,10.405),(83.315,10.575),(83.485,10.575),(83.485,10.405),(83.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.725),(45.425,9.895),(45.595,9.895),(45.595,9.725),(45.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.385),(45.425,9.555),(45.595,9.555),(45.595,9.385),(45.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.945),(35.315,4.115),(35.485,4.115),(35.485,3.945),(35.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.945),(35.825,4.115),(35.995,4.115),(35.995,3.945),(35.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.545),(49.205,17.715),(49.375,17.715),(49.375,17.545),(49.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.205),(49.205,17.375),(49.375,17.375),(49.375,17.205),(49.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.205),(49.715,17.375),(49.885,17.375),(49.885,17.205),(49.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.365),(6.515,8.535),(6.685,8.535),(6.685,8.365),(6.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.705),(6.515,8.875),(6.685,8.875),(6.685,8.705),(6.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.545),(49.715,17.715),(49.885,17.715),(49.885,17.545),(49.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,8.025),(6.515,8.195),(6.685,8.195),(6.685,8.025),(6.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.805),(44.405,13.975),(44.575,13.975),(44.575,13.805),(44.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.745),(6.515,10.915),(6.685,10.915),(6.685,10.745),(6.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.405),(6.515,10.575),(6.685,10.575),(6.685,10.405),(6.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,10.065),(6.515,10.235),(6.685,10.235),(6.685,10.065),(6.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,3.945),(30.005,4.115),(30.175,4.115),(30.175,3.945),(30.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.945),(30.515,4.115),(30.685,4.115),(30.685,3.945),(30.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.385),(7.025,9.555),(7.195,9.555),(7.195,9.385),(7.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.725),(7.025,9.895),(7.195,9.895),(7.195,9.725),(7.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.945),(59.315,4.115),(59.485,4.115),(59.485,3.945),(59.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.945),(59.825,4.115),(59.995,4.115),(59.995,3.945),(59.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.565),(25.205,18.735),(25.375,18.735),(25.375,18.565),(25.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.225),(25.715,18.395),(25.885,18.395),(25.885,18.225),(25.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.225),(25.205,18.395),(25.375,18.395),(25.375,18.225),(25.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.565),(25.715,18.735),(25.885,18.735),(25.885,18.565),(25.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.505),(16.625,15.675),(16.795,15.675),(16.795,15.505),(16.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.505),(16.115,15.675),(16.285,15.675),(16.285,15.505),(16.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.165),(16.115,15.335),(16.285,15.335),(16.285,15.165),(16.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.165),(16.625,15.335),(16.795,15.335),(16.795,15.165),(16.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.545),(16.115,17.715),(16.285,17.715),(16.285,17.545),(16.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.545),(16.625,17.715),(16.795,17.715),(16.795,17.545),(16.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,17.205),(16.115,17.375),(16.285,17.375),(16.285,17.205),(16.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,17.205),(16.625,17.375),(16.795,17.375),(16.795,17.205),(16.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.885),(50.225,18.055),(50.395,18.055),(50.395,17.885),(50.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.865),(64.115,17.035),(64.285,17.035),(64.285,16.865),(64.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.865),(64.625,17.035),(64.795,17.035),(64.795,16.865),(64.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.665),(49.715,6.835),(49.885,6.835),(49.885,6.665),(49.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.325),(49.205,6.495),(49.375,6.495),(49.375,6.325),(49.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.325),(49.715,6.495),(49.885,6.495),(49.885,6.325),(49.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.665),(49.205,6.835),(49.375,6.835),(49.375,6.665),(49.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.045),(79.025,9.215),(79.195,9.215),(79.195,9.045),(79.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.125),(7.025,13.295),(7.195,13.295),(7.195,13.125),(7.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.465),(7.025,13.635),(7.195,13.635),(7.195,13.465),(7.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,13.805),(7.025,13.975),(7.195,13.975),(7.195,13.805),(7.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.745),(69.425,10.915),(69.595,10.915),(69.595,10.745),(69.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.065),(69.425,10.235),(69.595,10.235),(69.595,10.065),(69.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,10.405),(69.425,10.575),(69.595,10.575),(69.595,10.405),(69.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.205),(68.915,17.375),(69.085,17.375),(69.085,17.205),(68.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.545),(68.915,17.715),(69.085,17.715),(69.085,17.545),(68.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.945),(21.425,4.115),(21.595,4.115),(21.595,3.945),(21.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.845),(58.805,16.015),(58.975,16.015),(58.975,15.845),(58.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.565),(44.915,18.735),(45.085,18.735),(45.085,18.565),(44.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.225),(44.915,18.395),(45.085,18.395),(45.085,18.225),(44.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.285),(21.425,4.455),(21.595,4.455),(21.595,4.285),(21.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.945),(31.025,4.115),(31.195,4.115),(31.195,3.945),(31.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.625),(21.425,4.795),(21.595,4.795),(21.595,4.625),(21.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.405),(21.425,10.575),(21.595,10.575),(21.595,10.405),(21.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.745),(21.425,10.915),(21.595,10.915),(21.595,10.745),(21.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,10.065),(21.425,10.235),(21.595,10.235),(21.595,10.065),(21.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.745),(74.225,10.915),(74.395,10.915),(74.395,10.745),(74.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.065),(74.225,10.235),(74.395,10.235),(74.395,10.065),(74.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,10.405),(74.225,10.575),(74.395,10.575),(74.395,10.405),(74.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.065),(64.115,10.235),(64.285,10.235),(64.285,10.065),(64.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.065),(64.625,10.235),(64.795,10.235),(64.795,10.065),(64.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.745),(64.115,10.915),(64.285,10.915),(64.285,10.745),(64.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.745),(64.625,10.915),(64.795,10.915),(64.795,10.745),(64.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,10.405),(64.115,10.575),(64.285,10.575),(64.285,10.405),(64.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,10.405),(64.625,10.575),(64.795,10.575),(64.795,10.405),(64.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.365),(26.225,8.535),(26.395,8.535),(26.395,8.365),(26.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.705),(26.225,8.875),(26.395,8.875),(26.395,8.705),(26.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,8.025),(26.225,8.195),(26.395,8.195),(26.395,8.025),(26.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.285),(44.405,4.455),(44.575,4.455),(44.575,4.285),(44.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.625),(44.405,4.795),(44.575,4.795),(44.575,4.625),(44.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.965),(73.205,5.135),(73.375,5.135),(73.375,4.965),(73.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.965),(73.715,5.135),(73.885,5.135),(73.885,4.965),(73.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,19.245),(63.605,19.415),(63.775,19.415),(63.775,19.245),(63.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.745),(26.225,10.915),(26.395,10.915),(26.395,10.745),(26.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.405),(26.225,10.575),(26.395,10.575),(26.395,10.405),(26.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,10.065),(26.225,10.235),(26.395,10.235),(26.395,10.065),(26.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.305),(68.405,5.475),(68.575,5.475),(68.575,5.305),(68.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,5.645),(68.405,5.815),(68.575,5.815),(68.575,5.645),(68.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.845),(83.315,16.015),(83.485,16.015),(83.485,15.845),(83.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.265),(26.225,3.435),(26.395,3.435),(26.395,3.265),(26.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.605),(26.225,3.775),(26.395,3.775),(26.395,3.605),(26.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.965),(25.205,5.135),(25.375,5.135),(25.375,4.965),(25.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.965),(25.715,5.135),(25.885,5.135),(25.885,4.965),(25.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.645),(31.025,5.815),(31.195,5.815),(31.195,5.645),(31.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.185),(6.515,16.355),(6.685,16.355),(6.685,16.185),(6.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.525),(6.515,16.695),(6.685,16.695),(6.685,16.525),(6.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.845),(35.315,16.015),(35.485,16.015),(35.485,15.845),(35.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.845),(35.825,16.015),(35.995,16.015),(35.995,15.845),(35.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.445),(74.225,12.615),(74.395,12.615),(74.395,12.445),(74.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.785),(74.225,12.955),(74.395,12.955),(74.395,12.785),(74.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,12.105),(74.225,12.275),(74.395,12.275),(74.395,12.105),(74.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.205),(35.825,17.375),(35.995,17.375),(35.995,17.205),(35.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.545),(35.825,17.715),(35.995,17.715),(35.995,17.545),(35.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.205),(35.315,17.375),(35.485,17.375),(35.485,17.205),(35.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.545),(35.315,17.715),(35.485,17.715),(35.485,17.545),(35.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.025),(54.005,8.195),(54.175,8.195),(54.175,8.025),(54.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.705),(54.005,8.875),(54.175,8.875),(54.175,8.705),(54.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.365),(54.005,8.535),(54.175,8.535),(54.175,8.365),(54.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.705),(54.515,8.875),(54.685,8.875),(54.685,8.705),(54.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.365),(54.515,8.535),(54.685,8.535),(54.685,8.365),(54.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.225),(59.825,18.395),(59.995,18.395),(59.995,18.225),(59.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.565),(59.315,18.735),(59.485,18.735),(59.485,18.565),(59.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.225),(59.315,18.395),(59.485,18.395),(59.485,18.225),(59.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.565),(59.825,18.735),(59.995,18.735),(59.995,18.565),(59.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.945),(55.025,4.115),(55.195,4.115),(55.195,3.945),(55.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.205),(21.425,17.375),(21.595,17.375),(21.595,17.205),(21.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.545),(21.425,17.715),(21.595,17.715),(21.595,17.545),(21.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.745),(54.005,10.915),(54.175,10.915),(54.175,10.745),(54.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.745),(54.515,10.915),(54.685,10.915),(54.685,10.745),(54.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.405),(54.515,10.575),(54.685,10.575),(54.685,10.405),(54.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.405),(54.005,10.575),(54.175,10.575),(54.175,10.405),(54.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.065),(54.005,10.235),(54.175,10.235),(54.175,10.065),(54.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.065),(54.515,10.235),(54.685,10.235),(54.685,10.065),(54.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.405),(35.825,10.575),(35.995,10.575),(35.995,10.405),(35.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.745),(35.315,10.915),(35.485,10.915),(35.485,10.745),(35.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.745),(35.825,10.915),(35.995,10.915),(35.995,10.745),(35.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.405),(35.315,10.575),(35.485,10.575),(35.485,10.405),(35.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.385),(55.025,9.555),(55.195,9.555),(55.195,9.385),(55.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.725),(55.025,9.895),(55.195,9.895),(55.195,9.725),(55.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.065),(35.825,10.235),(35.995,10.235),(35.995,10.065),(35.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.065),(35.315,10.235),(35.485,10.235),(35.485,10.065),(35.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.825),(50.225,14.995),(50.395,14.995),(50.395,14.825),(50.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.145),(50.225,14.315),(50.395,14.315),(50.395,14.145),(50.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.485),(50.225,14.655),(50.395,14.655),(50.395,14.485),(50.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.645),(11.315,5.815),(11.485,5.815),(11.485,5.645),(11.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.305),(11.825,5.475),(11.995,5.475),(11.995,5.305),(11.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.645),(11.825,5.815),(11.995,5.815),(11.995,5.645),(11.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.305),(11.315,5.475),(11.485,5.475),(11.485,5.305),(11.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.205),(54.005,17.375),(54.175,17.375),(54.175,17.205),(54.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.545),(54.005,17.715),(54.175,17.715),(54.175,17.545),(54.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.545),(54.515,17.715),(54.685,17.715),(54.685,17.545),(54.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.205),(54.515,17.375),(54.685,17.375),(54.685,17.205),(54.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.485),(31.025,14.655),(31.195,14.655),(31.195,14.485),(31.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.305),(20.915,5.475),(21.085,5.475),(21.085,5.305),(20.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.825),(31.025,14.995),(31.195,14.995),(31.195,14.825),(31.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.645),(20.915,5.815),(21.085,5.815),(21.085,5.645),(20.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.145),(31.025,14.315),(31.195,14.315),(31.195,14.145),(31.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.885),(6.515,18.055),(6.685,18.055),(6.685,17.885),(6.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.205),(20.405,17.375),(20.575,17.375),(20.575,17.205),(20.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,17.545),(20.405,17.715),(20.575,17.715),(20.575,17.545),(20.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.125),(55.025,13.295),(55.195,13.295),(55.195,13.125),(55.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.465),(55.025,13.635),(55.195,13.635),(55.195,13.465),(55.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.805),(55.025,13.975),(55.195,13.975),(55.195,13.805),(55.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.265),(69.425,3.435),(69.595,3.435),(69.595,3.265),(69.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.605),(69.425,3.775),(69.595,3.775),(69.595,3.605),(69.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.845),(39.605,16.015),(39.775,16.015),(39.775,15.845),(39.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.265),(20.405,3.435),(20.575,3.435),(20.575,3.265),(20.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.605),(20.405,3.775),(20.575,3.775),(20.575,3.605),(20.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.905),(20.915,19.075),(21.085,19.075),(21.085,18.905),(20.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.985),(55.025,6.155),(55.195,6.155),(55.195,5.985),(55.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,2.925),(16.115,3.095),(16.285,3.095),(16.285,2.925),(16.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.485),(20.405,14.655),(20.575,14.655),(20.575,14.485),(20.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.825),(20.405,14.995),(20.575,14.995),(20.575,14.825),(20.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,2.925),(16.625,3.095),(16.795,3.095),(16.795,2.925),(16.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,14.145),(20.405,14.315),(20.575,14.315),(20.575,14.145),(20.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.625),(15.605,4.795),(15.775,4.795),(15.775,4.625),(15.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.285),(15.605,4.455),(15.775,4.455),(15.775,4.285),(15.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.845),(25.715,16.015),(25.885,16.015),(25.885,15.845),(25.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.845),(25.205,16.015),(25.375,16.015),(25.375,15.845),(25.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.045),(73.205,9.215),(73.375,9.215),(73.375,9.045),(73.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.045),(73.715,9.215),(73.885,9.215),(73.885,9.045),(73.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.185),(20.915,16.355),(21.085,16.355),(21.085,16.185),(20.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.525),(20.915,16.695),(21.085,16.695),(21.085,16.525),(20.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.945),(45.425,4.115),(45.595,4.115),(45.595,3.945),(45.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.905),(31.025,19.075),(31.195,19.075),(31.195,18.905),(31.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.045),(25.205,9.215),(25.375,9.215),(25.375,9.045),(25.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.045),(25.715,9.215),(25.885,9.215),(25.885,9.045),(25.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,3.945),(26.225,4.115),(26.395,4.115),(26.395,3.945),(26.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.045),(20.405,9.215),(20.575,9.215),(20.575,9.045),(20.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.725),(78.515,9.895),(78.685,9.895),(78.685,9.725),(78.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.725),(78.005,9.895),(78.175,9.895),(78.175,9.725),(78.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.385),(78.005,9.555),(78.175,9.555),(78.175,9.385),(78.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.385),(78.515,9.555),(78.685,9.555),(78.685,9.385),(78.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.965),(6.515,5.135),(6.685,5.135),(6.685,4.965),(6.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.405),(11.315,10.575),(11.485,10.575),(11.485,10.405),(11.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.405),(11.825,10.575),(11.995,10.575),(11.995,10.405),(11.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.745),(11.315,10.915),(11.485,10.915),(11.485,10.745),(11.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.745),(11.825,10.915),(11.995,10.915),(11.995,10.745),(11.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,10.065),(11.315,10.235),(11.485,10.235),(11.485,10.065),(11.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,10.065),(11.825,10.235),(11.995,10.235),(11.995,10.065),(11.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.925),(40.115,3.095),(40.285,3.095),(40.285,2.925),(40.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.925),(40.625,3.095),(40.795,3.095),(40.795,2.925),(40.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.905),(74.225,19.075),(74.395,19.075),(74.395,18.905),(74.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.565),(64.115,18.735),(64.285,18.735),(64.285,18.565),(64.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.565),(64.625,18.735),(64.795,18.735),(64.795,18.565),(64.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.225),(64.625,18.395),(64.795,18.395),(64.795,18.225),(64.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.225),(64.115,18.395),(64.285,18.395),(64.285,18.225),(64.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.985),(30.005,6.155),(30.175,6.155),(30.175,5.985),(30.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.405),(30.515,10.575),(30.685,10.575),(30.685,10.405),(30.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.025),(68.915,8.195),(69.085,8.195),(69.085,8.025),(68.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.325),(82.805,6.495),(82.975,6.495),(82.975,6.325),(82.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.365),(68.915,8.535),(69.085,8.535),(69.085,8.365),(68.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,8.705),(68.915,8.875),(69.085,8.875),(69.085,8.705),(68.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,6.665),(82.805,6.835),(82.975,6.835),(82.975,6.665),(82.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.185),(45.425,16.355),(45.595,16.355),(45.595,16.185),(45.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.525),(45.425,16.695),(45.595,16.695),(45.595,16.525),(45.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.965),(49.715,5.135),(49.885,5.135),(49.885,4.965),(49.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.965),(49.205,5.135),(49.375,5.135),(49.375,4.965),(49.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.705),(20.915,8.875),(21.085,8.875),(21.085,8.705),(20.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.365),(20.915,8.535),(21.085,8.535),(21.085,8.365),(20.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,8.025),(20.915,8.195),(21.085,8.195),(21.085,8.025),(20.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,2.925),(78.005,3.095),(78.175,3.095),(78.175,2.925),(78.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,2.925),(78.515,3.095),(78.685,3.095),(78.685,2.925),(78.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.145),(78.005,14.315),(78.175,14.315),(78.175,14.145),(78.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.145),(78.515,14.315),(78.685,14.315),(78.685,14.145),(78.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.825),(78.005,14.995),(78.175,14.995),(78.175,14.825),(78.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.485),(78.515,14.655),(78.685,14.655),(78.685,14.485),(78.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,14.825),(78.515,14.995),(78.685,14.995),(78.685,14.825),(78.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,14.485),(78.005,14.655),(78.175,14.655),(78.175,14.485),(78.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.785),(55.025,12.955),(55.195,12.955),(55.195,12.785),(55.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.445),(55.025,12.615),(55.195,12.615),(55.195,12.445),(55.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.105),(55.025,12.275),(55.195,12.275),(55.195,12.105),(55.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.745),(45.425,10.915),(45.595,10.915),(45.595,10.745),(45.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.405),(45.425,10.575),(45.595,10.575),(45.595,10.405),(45.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.065),(45.425,10.235),(45.595,10.235),(45.595,10.065),(45.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.865),(79.025,17.035),(79.195,17.035),(79.195,16.865),(79.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.945),(73.715,4.115),(73.885,4.115),(73.885,3.945),(73.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.945),(73.205,4.115),(73.375,4.115),(73.375,3.945),(73.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.965),(30.515,5.135),(30.685,5.135),(30.685,4.965),(30.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.965),(30.005,5.135),(30.175,5.135),(30.175,4.965),(30.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.945),(64.625,4.115),(64.795,4.115),(64.795,3.945),(64.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.945),(64.115,4.115),(64.285,4.115),(64.285,3.945),(64.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,2.925),(6.515,3.095),(6.685,3.095),(6.685,2.925),(6.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.625),(69.425,4.795),(69.595,4.795),(69.595,4.625),(69.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.285),(69.425,4.455),(69.595,4.455),(69.595,4.285),(69.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.445),(7.025,12.615),(7.195,12.615),(7.195,12.445),(7.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.785),(7.025,12.955),(7.195,12.955),(7.195,12.785),(7.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.805),(26.225,13.975),(26.395,13.975),(26.395,13.805),(26.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.465),(26.225,13.635),(26.395,13.635),(26.395,13.465),(26.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,13.125),(26.225,13.295),(26.395,13.295),(26.395,13.125),(26.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.985),(79.025,6.155),(79.195,6.155),(79.195,5.985),(79.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,12.105),(7.025,12.275),(7.195,12.275),(7.195,12.105),(7.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.725),(30.515,9.895),(30.685,9.895),(30.685,9.725),(30.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.385),(30.515,9.555),(30.685,9.555),(30.685,9.385),(30.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.385),(30.005,9.555),(30.175,9.555),(30.175,9.385),(30.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.725),(30.005,9.895),(30.175,9.895),(30.175,9.725),(30.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.625),(39.605,4.795),(39.775,4.795),(39.775,4.625),(39.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.285),(39.605,4.455),(39.775,4.455),(39.775,4.285),(39.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.025),(74.225,8.195),(74.395,8.195),(74.395,8.025),(74.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.365),(74.225,8.535),(74.395,8.535),(74.395,8.365),(74.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,8.705),(74.225,8.875),(74.395,8.875),(74.395,8.705),(74.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.145),(79.025,14.315),(79.195,14.315),(79.195,14.145),(79.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.485),(79.025,14.655),(79.195,14.655),(79.195,14.485),(79.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,14.825),(79.025,14.995),(79.195,14.995),(79.195,14.825),(79.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.845),(59.825,16.015),(59.995,16.015),(59.995,15.845),(59.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.445),(68.405,12.615),(68.575,12.615),(68.575,12.445),(68.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.785),(68.405,12.955),(68.575,12.955),(68.575,12.785),(68.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.845),(59.315,16.015),(59.485,16.015),(59.485,15.845),(59.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,12.105),(68.405,12.275),(68.575,12.275),(68.575,12.105),(68.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.885),(15.605,18.055),(15.775,18.055),(15.775,17.885),(15.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.965),(58.805,5.135),(58.975,5.135),(58.975,4.965),(58.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.845),(11.315,16.015),(11.485,16.015),(11.485,15.845),(11.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.445),(20.405,12.615),(20.575,12.615),(20.575,12.445),(20.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.785),(20.405,12.955),(20.575,12.955),(20.575,12.785),(20.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,12.105),(20.405,12.275),(20.575,12.275),(20.575,12.105),(20.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.845),(11.825,16.015),(11.995,16.015),(11.995,15.845),(11.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.345),(11.825,7.515),(11.995,7.515),(11.995,7.345),(11.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.965),(34.805,5.135),(34.975,5.135),(34.975,4.965),(34.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.725),(15.605,9.895),(15.775,9.895),(15.775,9.725),(15.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.385),(15.605,9.555),(15.775,9.555),(15.775,9.385),(15.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.965),(54.005,5.135),(54.175,5.135),(54.175,4.965),(54.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.965),(10.805,5.135),(10.975,5.135),(10.975,4.965),(10.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.965),(54.515,5.135),(54.685,5.135),(54.685,4.965),(54.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.745),(59.825,10.915),(59.995,10.915),(59.995,10.745),(59.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.745),(59.315,10.915),(59.485,10.915),(59.485,10.745),(59.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.065),(59.315,10.235),(59.485,10.235),(59.485,10.065),(59.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.065),(59.825,10.235),(59.995,10.235),(59.995,10.065),(59.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.885),(20.915,18.055),(21.085,18.055),(21.085,17.885),(20.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,2.925),(30.005,3.095),(30.175,3.095),(30.175,2.925),(30.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.925),(30.515,3.095),(30.685,3.095),(30.685,2.925),(30.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,10.405),(59.825,10.575),(59.995,10.575),(59.995,10.405),(59.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.405),(59.315,10.575),(59.485,10.575),(59.485,10.405),(59.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.485),(30.515,14.655),(30.685,14.655),(30.685,14.485),(30.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.825),(30.515,14.995),(30.685,14.995),(30.685,14.825),(30.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.185),(49.715,16.355),(49.885,16.355),(49.885,16.185),(49.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.185),(49.205,16.355),(49.375,16.355),(49.375,16.185),(49.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.825),(30.005,14.995),(30.175,14.995),(30.175,14.825),(30.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.485),(30.005,14.655),(30.175,14.655),(30.175,14.485),(30.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,14.145),(30.005,14.315),(30.175,14.315),(30.175,14.145),(30.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.905),(39.605,19.075),(39.775,19.075),(39.775,18.905),(39.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.525),(49.205,16.695),(49.375,16.695),(49.375,16.525),(49.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.525),(49.715,16.695),(49.885,16.695),(49.885,16.525),(49.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,2.925),(64.115,3.095),(64.285,3.095),(64.285,2.925),(64.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,2.925),(64.625,3.095),(64.795,3.095),(64.795,2.925),(64.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.565),(54.515,18.735),(54.685,18.735),(54.685,18.565),(54.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.225),(54.515,18.395),(54.685,18.395),(54.685,18.225),(54.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.565),(54.005,18.735),(54.175,18.735),(54.175,18.565),(54.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.285),(63.605,4.455),(63.775,4.455),(63.775,4.285),(63.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.225),(54.005,18.395),(54.175,18.395),(54.175,18.225),(54.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.625),(63.605,4.795),(63.775,4.795),(63.775,4.625),(63.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.225),(7.025,18.395),(7.195,18.395),(7.195,18.225),(7.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.565),(7.025,18.735),(7.195,18.735),(7.195,18.565),(7.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.125),(15.605,13.295),(15.775,13.295),(15.775,13.125),(15.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.465),(15.605,13.635),(15.775,13.635),(15.775,13.465),(15.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,13.805),(15.605,13.975),(15.775,13.975),(15.775,13.805),(15.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.905),(49.715,19.075),(49.885,19.075),(49.885,18.905),(49.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.905),(49.205,19.075),(49.375,19.075),(49.375,18.905),(49.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.965),(82.805,5.135),(82.975,5.135),(82.975,4.965),(82.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.385),(63.605,9.555),(63.775,9.555),(63.775,9.385),(63.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.885),(59.825,18.055),(59.995,18.055),(59.995,17.885),(59.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.885),(59.315,18.055),(59.485,18.055),(59.485,17.885),(59.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.725),(63.605,9.895),(63.775,9.895),(63.775,9.725),(63.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.345),(74.225,7.515),(74.395,7.515),(74.395,7.345),(74.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.885),(68.405,18.055),(68.575,18.055),(68.575,17.885),(68.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.605),(39.605,3.775),(39.775,3.775),(39.775,3.605),(39.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.265),(39.605,3.435),(39.775,3.435),(39.775,3.265),(39.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.825),(58.805,14.995),(58.975,14.995),(58.975,14.825),(58.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.485),(58.805,14.655),(58.975,14.655),(58.975,14.485),(58.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.145),(58.805,14.315),(58.975,14.315),(58.975,14.145),(58.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,7.005),(74.225,7.175),(74.395,7.175),(74.395,7.005),(74.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.565),(11.825,18.735),(11.995,18.735),(11.995,18.565),(11.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.225),(11.315,18.395),(11.485,18.395),(11.485,18.225),(11.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.565),(11.315,18.735),(11.485,18.735),(11.485,18.565),(11.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.225),(11.825,18.395),(11.995,18.395),(11.995,18.225),(11.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.565),(50.225,18.735),(50.395,18.735),(50.395,18.565),(50.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.225),(50.225,18.395),(50.395,18.395),(50.395,18.225),(50.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.925),(54.515,3.095),(54.685,3.095),(54.685,2.925),(54.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.925),(54.005,3.095),(54.175,3.095),(54.175,2.925),(54.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.505),(54.515,15.675),(54.685,15.675),(54.685,15.505),(54.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.685),(26.225,7.855),(26.395,7.855),(26.395,7.685),(26.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.165),(54.515,15.335),(54.685,15.335),(54.685,15.165),(54.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.165),(54.005,15.335),(54.175,15.335),(54.175,15.165),(54.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.145),(10.805,14.315),(10.975,14.315),(10.975,14.145),(10.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.505),(54.005,15.675),(54.175,15.675),(54.175,15.505),(54.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.485),(10.805,14.655),(10.975,14.655),(10.975,14.485),(10.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,14.825),(10.805,14.995),(10.975,14.995),(10.975,14.825),(10.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.145),(68.405,14.315),(68.575,14.315),(68.575,14.145),(68.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.165),(6.515,15.335),(6.685,15.335),(6.685,15.165),(6.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.485),(68.405,14.655),(68.575,14.655),(68.575,14.485),(68.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,14.825),(68.405,14.995),(68.575,14.995),(68.575,14.825),(68.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.505),(6.515,15.675),(6.685,15.675),(6.685,15.505),(6.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.125),(25.715,13.295),(25.885,13.295),(25.885,13.125),(25.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.805),(25.205,13.975),(25.375,13.975),(25.375,13.805),(25.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.845),(73.205,16.015),(73.375,16.015),(73.375,15.845),(73.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.205),(50.225,17.375),(50.395,17.375),(50.395,17.205),(50.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.545),(50.225,17.715),(50.395,17.715),(50.395,17.545),(50.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.125),(63.605,13.295),(63.775,13.295),(63.775,13.125),(63.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.465),(63.605,13.635),(63.775,13.635),(63.775,13.465),(63.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,13.805),(63.605,13.975),(63.775,13.975),(63.775,13.805),(63.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.845),(73.715,16.015),(73.885,16.015),(73.885,15.845),(73.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.005),(79.025,7.175),(79.195,7.175),(79.195,7.005),(79.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.345),(79.025,7.515),(79.195,7.515),(79.195,7.345),(79.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,7.685),(79.025,7.855),(79.195,7.855),(79.195,7.685),(79.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.045),(54.515,9.215),(54.685,9.215),(54.685,9.045),(54.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.045),(54.005,9.215),(54.175,9.215),(54.175,9.045),(54.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.085),(54.515,11.255),(54.685,11.255),(54.685,11.085),(54.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.085),(54.005,11.255),(54.175,11.255),(54.175,11.085),(54.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.425),(54.515,11.595),(54.685,11.595),(54.685,11.425),(54.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.765),(54.515,11.935),(54.685,11.935),(54.685,11.765),(54.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.765),(54.005,11.935),(54.175,11.935),(54.175,11.765),(54.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.425),(54.005,11.595),(54.175,11.595),(54.175,11.425),(54.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.045),(6.515,9.215),(6.685,9.215),(6.685,9.045),(6.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.565),(45.425,18.735),(45.595,18.735),(45.595,18.565),(45.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.225),(45.425,18.395),(45.595,18.395),(45.595,18.225),(45.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.685),(7.025,7.855),(7.195,7.855),(7.195,7.685),(7.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.005),(7.025,7.175),(7.195,7.175),(7.195,7.005),(7.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.045),(44.405,9.215),(44.575,9.215),(44.575,9.045),(44.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,7.345),(7.025,7.515),(7.195,7.515),(7.195,7.345),(7.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.605),(63.605,3.775),(63.775,3.775),(63.775,3.605),(63.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.265),(63.605,3.435),(63.775,3.435),(63.775,3.265),(63.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.085),(6.515,11.255),(6.685,11.255),(6.685,11.085),(6.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.425),(6.515,11.595),(6.685,11.595),(6.685,11.425),(6.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,11.765),(6.515,11.935),(6.685,11.935),(6.685,11.765),(6.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.045),(68.405,9.215),(68.575,9.215),(68.575,9.045),(68.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,4.965),(78.005,5.135),(78.175,5.135),(78.175,4.965),(78.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,4.965),(78.515,5.135),(78.685,5.135),(78.685,4.965),(78.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.385),(49.715,9.555),(49.885,9.555),(49.885,9.385),(49.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.385),(49.205,9.555),(49.375,9.555),(49.375,9.385),(49.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.725),(49.205,9.895),(49.375,9.895),(49.375,9.725),(49.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.725),(49.715,9.895),(49.885,9.895),(49.885,9.725),(49.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.625),(35.315,4.795),(35.485,4.795),(35.485,4.625),(35.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.285),(35.315,4.455),(35.485,4.455),(35.485,4.285),(35.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.625),(35.825,4.795),(35.995,4.795),(35.995,4.625),(35.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.285),(35.825,4.455),(35.995,4.455),(35.995,4.285),(35.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.565),(16.625,18.735),(16.795,18.735),(16.795,18.565),(16.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.225),(16.115,18.395),(16.285,18.395),(16.285,18.225),(16.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.225),(16.625,18.395),(16.795,18.395),(16.795,18.225),(16.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.565),(16.115,18.735),(16.285,18.735),(16.285,18.565),(16.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.285),(26.225,4.455),(26.395,4.455),(26.395,4.285),(26.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.625),(26.225,4.795),(26.395,4.795),(26.395,4.625),(26.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.845),(15.605,16.015),(15.775,16.015),(15.775,15.845),(15.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.785),(6.515,12.955),(6.685,12.955),(6.685,12.785),(6.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.445),(6.515,12.615),(6.685,12.615),(6.685,12.445),(6.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,12.105),(6.515,12.275),(6.685,12.275),(6.685,12.105),(6.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.305),(73.715,5.475),(73.885,5.475),(73.885,5.305),(73.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.885),(55.025,18.055),(55.195,18.055),(55.195,17.885),(55.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,5.645),(73.715,5.815),(73.885,5.815),(73.885,5.645),(73.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.305),(73.205,5.475),(73.375,5.475),(73.375,5.305),(73.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,5.645),(73.205,5.815),(73.375,5.815),(73.375,5.645),(73.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.905),(44.405,19.075),(44.575,19.075),(44.575,18.905),(44.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.185),(58.805,16.355),(58.975,16.355),(58.975,16.185),(58.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.525),(58.805,16.695),(58.975,16.695),(58.975,16.525),(58.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.745),(58.805,10.915),(58.975,10.915),(58.975,10.745),(58.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.205),(69.425,17.375),(69.595,17.375),(69.595,17.205),(69.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,17.545),(69.425,17.715),(69.595,17.715),(69.595,17.545),(69.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,16.865),(16.115,17.035),(16.285,17.035),(16.285,16.865),(16.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,16.865),(16.625,17.035),(16.795,17.035),(16.795,16.865),(16.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.005),(31.025,7.175),(31.195,7.175),(31.195,7.005),(31.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.345),(31.025,7.515),(31.195,7.515),(31.195,7.345),(31.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.685),(31.025,7.855),(31.195,7.855),(31.195,7.685),(31.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,2.925),(83.315,3.095),(83.485,3.095),(83.485,2.925),(83.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,16.865),(59.825,17.035),(59.995,17.035),(59.995,16.865),(59.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.185),(55.025,16.355),(55.195,16.355),(55.195,16.185),(55.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.525),(55.025,16.695),(55.195,16.695),(55.195,16.525),(55.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.865),(59.315,17.035),(59.485,17.035),(59.485,16.865),(59.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,18.905),(82.805,19.075),(82.975,19.075),(82.975,18.905),(82.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.085),(7.025,11.255),(7.195,11.255),(7.195,11.085),(7.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.425),(7.025,11.595),(7.195,11.595),(7.195,11.425),(7.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,11.765),(7.025,11.935),(7.195,11.935),(7.195,11.765),(7.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.085),(74.225,11.255),(74.395,11.255),(74.395,11.085),(74.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.425),(74.225,11.595),(74.395,11.595),(74.395,11.425),(74.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,11.765),(74.225,11.935),(74.395,11.935),(74.395,11.765),(74.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.045),(26.225,9.215),(26.395,9.215),(26.395,9.045),(26.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.425),(26.225,11.595),(26.395,11.595),(26.395,11.425),(26.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.765),(26.225,11.935),(26.395,11.935),(26.395,11.765),(26.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,11.085),(26.225,11.255),(26.395,11.255),(26.395,11.085),(26.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.285),(50.225,4.455),(50.395,4.455),(50.395,4.285),(50.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.625),(50.225,4.795),(50.395,4.795),(50.395,4.625),(50.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.845),(63.605,16.015),(63.775,16.015),(63.775,15.845),(63.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.145),(44.405,14.315),(44.575,14.315),(44.575,14.145),(44.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.945),(15.605,4.115),(15.775,4.115),(15.775,3.945),(15.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.485),(44.405,14.655),(44.575,14.655),(44.575,14.485),(44.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.825),(44.405,14.995),(44.575,14.995),(44.575,14.825),(44.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.805),(74.225,13.975),(74.395,13.975),(74.395,13.805),(74.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.465),(74.225,13.635),(74.395,13.635),(74.395,13.465),(74.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.045),(39.605,9.215),(39.775,9.215),(39.775,9.045),(39.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,13.125),(74.225,13.295),(74.395,13.295),(74.395,13.125),(74.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.205),(6.515,17.375),(6.685,17.375),(6.685,17.205),(6.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,17.545),(6.515,17.715),(6.685,17.715),(6.685,17.545),(6.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.165),(39.605,15.335),(39.775,15.335),(39.775,15.165),(39.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.005),(55.025,7.175),(55.195,7.175),(55.195,7.005),(55.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.505),(39.605,15.675),(39.775,15.675),(39.775,15.505),(39.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.345),(55.025,7.515),(55.195,7.515),(55.195,7.345),(55.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.685),(55.025,7.855),(55.195,7.855),(55.195,7.685),(55.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,2.925),(69.425,3.095),(69.595,3.095),(69.595,2.925),(69.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.085),(68.405,11.255),(68.575,11.255),(68.575,11.085),(68.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.765),(68.405,11.935),(68.575,11.935),(68.575,11.765),(68.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,11.425),(68.405,11.595),(68.575,11.595),(68.575,11.425),(68.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.505),(82.805,15.675),(82.975,15.675),(82.975,15.505),(82.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.165),(82.805,15.335),(82.975,15.335),(82.975,15.165),(82.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,2.925),(21.425,3.095),(21.595,3.095),(21.595,2.925),(21.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.285),(83.315,4.455),(83.485,4.455),(83.485,4.285),(83.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.625),(83.315,4.795),(83.485,4.795),(83.485,4.625),(83.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.425),(20.405,11.595),(20.575,11.595),(20.575,11.425),(20.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.085),(20.405,11.255),(20.575,11.255),(20.575,11.085),(20.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,11.765),(20.405,11.935),(20.575,11.935),(20.575,11.765),(20.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.505),(25.205,15.675),(25.375,15.675),(25.375,15.505),(25.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.505),(25.715,15.675),(25.885,15.675),(25.885,15.505),(25.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,15.165),(25.715,15.335),(25.885,15.335),(25.885,15.165),(25.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,15.165),(25.205,15.335),(25.375,15.335),(25.375,15.165),(25.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.005),(50.225,7.175),(50.395,7.175),(50.395,7.005),(50.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.685),(50.225,7.855),(50.395,7.855),(50.395,7.685),(50.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.345),(50.225,7.515),(50.395,7.515),(50.395,7.345),(50.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.185),(68.915,16.355),(69.085,16.355),(69.085,16.185),(68.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,16.525),(68.915,16.695),(69.085,16.695),(69.085,16.525),(68.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.445),(34.805,12.615),(34.975,12.615),(34.975,12.445),(34.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.785),(34.805,12.955),(34.975,12.955),(34.975,12.785),(34.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.105),(34.805,12.275),(34.975,12.275),(34.975,12.105),(34.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.785),(54.515,12.955),(54.685,12.955),(54.685,12.785),(54.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.445),(54.515,12.615),(54.685,12.615),(54.685,12.445),(54.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.785),(54.005,12.955),(54.175,12.955),(54.175,12.785),(54.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.445),(54.005,12.615),(54.175,12.615),(54.175,12.445),(54.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.105),(54.005,12.275),(54.175,12.275),(54.175,12.105),(54.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.105),(54.515,12.275),(54.685,12.275),(54.685,12.105),(54.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.225),(20.405,18.395),(20.575,18.395),(20.575,18.225),(20.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.565),(20.405,18.735),(20.575,18.735),(20.575,18.565),(20.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.085),(40.625,11.255),(40.795,11.255),(40.795,11.085),(40.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.085),(40.115,11.255),(40.285,11.255),(40.285,11.085),(40.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.765),(40.115,11.935),(40.285,11.935),(40.285,11.765),(40.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.765),(40.625,11.935),(40.795,11.935),(40.795,11.765),(40.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.425),(40.625,11.595),(40.795,11.595),(40.795,11.425),(40.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.425),(40.115,11.595),(40.285,11.595),(40.285,11.425),(40.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.085),(49.205,11.255),(49.375,11.255),(49.375,11.085),(49.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.705),(44.915,8.875),(45.085,8.875),(45.085,8.705),(44.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.365),(44.915,8.535),(45.085,8.535),(45.085,8.365),(44.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.085),(49.715,11.255),(49.885,11.255),(49.885,11.085),(49.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.765),(49.715,11.935),(49.885,11.935),(49.885,11.765),(49.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.765),(49.205,11.935),(49.375,11.935),(49.375,11.765),(49.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.985),(45.425,6.155),(45.595,6.155),(45.595,5.985),(45.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.425),(49.205,11.595),(49.375,11.595),(49.375,11.425),(49.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.425),(49.715,11.595),(49.885,11.595),(49.885,11.425),(49.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.765),(55.025,11.935),(55.195,11.935),(55.195,11.765),(55.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.085),(55.025,11.255),(55.195,11.255),(55.195,11.085),(55.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.425),(55.025,11.595),(55.195,11.595),(55.195,11.425),(55.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.105),(15.605,12.275),(15.775,12.275),(15.775,12.105),(15.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.445),(15.605,12.615),(15.775,12.615),(15.775,12.445),(15.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,12.785),(15.605,12.955),(15.775,12.955),(15.775,12.785),(15.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.405),(20.915,10.575),(21.085,10.575),(21.085,10.405),(20.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.745),(20.915,10.915),(21.085,10.915),(21.085,10.745),(20.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,10.065),(20.915,10.235),(21.085,10.235),(21.085,10.065),(20.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.205),(39.605,17.375),(39.775,17.375),(39.775,17.205),(39.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.545),(39.605,17.715),(39.775,17.715),(39.775,17.545),(39.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.445),(82.805,12.615),(82.975,12.615),(82.975,12.445),(82.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.785),(82.805,12.955),(82.975,12.955),(82.975,12.785),(82.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.925),(35.315,3.095),(35.485,3.095),(35.485,2.925),(35.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.925),(35.825,3.095),(35.995,3.095),(35.995,2.925),(35.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,12.105),(82.805,12.275),(82.975,12.275),(82.975,12.105),(82.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.225),(6.515,18.395),(6.685,18.395),(6.685,18.225),(6.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.565),(6.515,18.735),(6.685,18.735),(6.685,18.565),(6.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.505),(34.805,15.675),(34.975,15.675),(34.975,15.505),(34.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.165),(34.805,15.335),(34.975,15.335),(34.975,15.165),(34.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.345),(45.425,7.515),(45.595,7.515),(45.595,7.345),(45.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.005),(45.425,7.175),(45.595,7.175),(45.595,7.005),(45.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.685),(45.425,7.855),(45.595,7.855),(45.595,7.685),(45.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,2.925),(20.405,3.095),(20.575,3.095),(20.575,2.925),(20.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.225),(73.715,18.395),(73.885,18.395),(73.885,18.225),(73.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.565),(73.715,18.735),(73.885,18.735),(73.885,18.565),(73.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.225),(73.205,18.395),(73.375,18.395),(73.375,18.225),(73.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.565),(73.205,18.735),(73.375,18.735),(73.375,18.565),(73.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.605),(82.805,3.775),(82.975,3.775),(82.975,3.605),(82.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.265),(82.805,3.435),(82.975,3.435),(82.975,3.265),(82.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.885),(58.805,18.055),(58.975,18.055),(58.975,17.885),(58.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.865),(44.405,17.035),(44.575,17.035),(44.575,16.865),(44.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,19.245),(79.025,19.415),(79.195,19.415),(79.195,19.245),(79.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.445),(44.405,12.615),(44.575,12.615),(44.575,12.445),(44.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.785),(44.405,12.955),(44.575,12.955),(44.575,12.785),(44.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.245),(54.515,19.415),(54.685,19.415),(54.685,19.245),(54.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.245),(54.005,19.415),(54.175,19.415),(54.175,19.245),(54.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.105),(44.405,12.275),(44.575,12.275),(44.575,12.105),(44.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.325),(55.025,6.495),(55.195,6.495),(55.195,6.325),(55.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.665),(55.025,6.835),(55.195,6.835),(55.195,6.665),(55.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,15.845),(82.805,16.015),(82.975,16.015),(82.975,15.845),(82.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.885),(40.115,18.055),(40.285,18.055),(40.285,17.885),(40.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.885),(40.625,18.055),(40.795,18.055),(40.795,17.885),(40.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.965),(44.915,5.135),(45.085,5.135),(45.085,4.965),(44.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.285),(74.225,4.455),(74.395,4.455),(74.395,4.285),(74.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.625),(74.225,4.795),(74.395,4.795),(74.395,4.625),(74.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.005),(68.405,7.175),(68.575,7.175),(68.575,7.005),(68.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.345),(68.405,7.515),(68.575,7.515),(68.575,7.345),(68.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,7.685),(68.405,7.855),(68.575,7.855),(68.575,7.685),(68.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.865),(54.005,17.035),(54.175,17.035),(54.175,16.865),(54.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.865),(54.515,17.035),(54.685,17.035),(54.685,16.865),(54.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.325),(69.425,6.495),(69.595,6.495),(69.595,6.325),(69.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,6.665),(69.425,6.835),(69.595,6.835),(69.595,6.665),(69.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.465),(69.425,13.635),(69.595,13.635),(69.595,13.465),(69.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.805),(69.425,13.975),(69.595,13.975),(69.595,13.805),(69.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.685),(20.405,7.855),(20.575,7.855),(20.575,7.685),(20.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,13.125),(69.425,13.295),(69.595,13.295),(69.595,13.125),(69.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.885),(78.005,18.055),(78.175,18.055),(78.175,17.885),(78.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.665),(21.425,6.835),(21.595,6.835),(21.595,6.665),(21.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,6.325),(21.425,6.495),(21.595,6.495),(21.595,6.325),(21.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.885),(78.515,18.055),(78.685,18.055),(78.685,17.885),(78.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.045),(74.225,9.215),(74.395,9.215),(74.395,9.045),(74.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.985),(35.315,6.155),(35.485,6.155),(35.485,5.985),(35.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.985),(35.825,6.155),(35.995,6.155),(35.995,5.985),(35.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.465),(21.425,13.635),(21.595,13.635),(21.595,13.465),(21.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.805),(21.425,13.975),(21.595,13.975),(21.595,13.805),(21.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,13.125),(21.425,13.295),(21.595,13.295),(21.595,13.125),(21.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.865),(31.025,17.035),(31.195,17.035),(31.195,16.865),(31.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.405),(55.025,10.575),(55.195,10.575),(55.195,10.405),(55.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.745),(55.025,10.915),(55.195,10.915),(55.195,10.745),(55.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.065),(55.025,10.235),(55.195,10.235),(55.195,10.065),(55.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.385),(40.115,9.555),(40.285,9.555),(40.285,9.385),(40.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.725),(40.115,9.895),(40.285,9.895),(40.285,9.725),(40.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.385),(40.625,9.555),(40.795,9.555),(40.795,9.385),(40.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.725),(40.625,9.895),(40.795,9.895),(40.795,9.725),(40.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.845),(34.805,16.015),(34.975,16.015),(34.975,15.845),(34.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,19.245),(59.825,19.415),(59.995,19.415),(59.995,19.245),(59.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.245),(59.315,19.415),(59.485,19.415),(59.485,19.245),(59.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.005),(44.405,7.175),(44.575,7.175),(44.575,7.005),(44.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.345),(44.405,7.515),(44.575,7.515),(44.575,7.345),(44.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.525),(40.625,16.695),(40.795,16.695),(40.795,16.525),(40.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.185),(40.115,16.355),(40.285,16.355),(40.285,16.185),(40.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.185),(40.625,16.355),(40.795,16.355),(40.795,16.185),(40.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.885),(25.715,18.055),(25.885,18.055),(25.885,17.885),(25.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.885),(25.205,18.055),(25.375,18.055),(25.375,17.885),(25.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.885),(7.025,18.055),(7.195,18.055),(7.195,17.885),(7.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.025),(55.025,8.195),(55.195,8.195),(55.195,8.025),(55.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.365),(55.025,8.535),(55.195,8.535),(55.195,8.365),(55.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.705),(55.025,8.875),(55.195,8.875),(55.195,8.705),(55.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.525),(40.115,16.695),(40.285,16.695),(40.285,16.525),(40.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.745),(7.025,10.915),(7.195,10.915),(7.195,10.745),(7.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.405),(7.025,10.575),(7.195,10.575),(7.195,10.405),(7.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,10.065),(7.025,10.235),(7.195,10.235),(7.195,10.065),(7.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.865),(50.225,17.035),(50.395,17.035),(50.395,16.865),(50.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.885),(63.605,18.055),(63.775,18.055),(63.775,17.885),(63.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.985),(59.825,6.155),(59.995,6.155),(59.995,5.985),(59.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.985),(59.315,6.155),(59.485,6.155),(59.485,5.985),(59.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.125),(11.825,13.295),(11.995,13.295),(11.995,13.125),(11.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.125),(83.315,13.295),(83.485,13.295),(83.485,13.125),(83.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.025),(7.025,8.195),(7.195,8.195),(7.195,8.025),(7.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.365),(7.025,8.535),(7.195,8.535),(7.195,8.365),(7.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.525),(20.405,16.695),(20.575,16.695),(20.575,16.525),(20.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.185),(20.405,16.355),(20.575,16.355),(20.575,16.185),(20.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,8.705),(7.025,8.875),(7.195,8.875),(7.195,8.705),(7.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.205),(68.405,17.375),(68.575,17.375),(68.575,17.205),(68.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,17.545),(68.405,17.715),(68.575,17.715),(68.575,17.545),(68.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,16.865),(11.825,17.035),(11.995,17.035),(11.995,16.865),(11.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,16.865),(11.315,17.035),(11.485,17.035),(11.485,16.865),(11.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.025),(34.805,8.195),(34.975,8.195),(34.975,8.025),(34.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.705),(34.805,8.875),(34.975,8.875),(34.975,8.705),(34.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.365),(34.805,8.535),(34.975,8.535),(34.975,8.365),(34.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.105),(63.605,12.275),(63.775,12.275),(63.775,12.105),(63.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.445),(63.605,12.615),(63.775,12.615),(63.775,12.445),(63.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,12.785),(63.605,12.955),(63.775,12.955),(63.775,12.785),(63.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,3.945),(82.805,4.115),(82.975,4.115),(82.975,3.945),(82.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.085),(83.315,11.255),(83.485,11.255),(83.485,11.085),(83.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.425),(83.315,11.595),(83.485,11.595),(83.485,11.425),(83.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.885),(11.315,18.055),(11.485,18.055),(11.485,17.885),(11.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.885),(11.825,18.055),(11.995,18.055),(11.995,17.885),(11.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,11.765),(83.315,11.935),(83.485,11.935),(83.485,11.765),(83.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.405),(34.805,10.575),(34.975,10.575),(34.975,10.405),(34.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.425),(44.405,11.595),(44.575,11.595),(44.575,11.425),(44.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.905),(68.915,19.075),(69.085,19.075),(69.085,18.905),(68.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.765),(44.405,11.935),(44.575,11.935),(44.575,11.765),(44.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.085),(44.405,11.255),(44.575,11.255),(44.575,11.085),(44.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.745),(34.805,10.915),(34.975,10.915),(34.975,10.745),(34.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.065),(34.805,10.235),(34.975,10.235),(34.975,10.065),(34.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.025),(68.405,8.195),(68.575,8.195),(68.575,8.025),(68.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.365),(68.405,8.535),(68.575,8.535),(68.575,8.365),(68.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.765),(35.315,11.935),(35.485,11.935),(35.485,11.765),(35.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.765),(35.825,11.935),(35.995,11.935),(35.995,11.765),(35.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.085),(35.315,11.255),(35.485,11.255),(35.485,11.085),(35.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.085),(35.825,11.255),(35.995,11.255),(35.995,11.085),(35.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,8.705),(68.405,8.875),(68.575,8.875),(68.575,8.705),(68.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.425),(35.315,11.595),(35.485,11.595),(35.485,11.425),(35.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.345),(54.515,7.515),(54.685,7.515),(54.685,7.345),(54.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.425),(35.825,11.595),(35.995,11.595),(35.995,11.425),(35.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.005),(54.005,7.175),(54.175,7.175),(54.175,7.005),(54.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.005),(54.515,7.175),(54.685,7.175),(54.685,7.005),(54.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.345),(54.005,7.515),(54.175,7.515),(54.175,7.345),(54.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.165),(73.205,15.335),(73.375,15.335),(73.375,15.165),(73.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.165),(73.715,15.335),(73.885,15.335),(73.885,15.165),(73.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,15.505),(73.205,15.675),(73.375,15.675),(73.375,15.505),(73.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.945),(68.405,4.115),(68.575,4.115),(68.575,3.945),(68.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,15.505),(73.715,15.675),(73.885,15.675),(73.885,15.505),(73.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.045),(35.315,9.215),(35.485,9.215),(35.485,9.045),(35.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.045),(35.825,9.215),(35.995,9.215),(35.995,9.045),(35.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.025),(20.405,8.195),(20.575,8.195),(20.575,8.025),(20.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.365),(20.405,8.535),(20.575,8.535),(20.575,8.365),(20.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,8.705),(20.405,8.875),(20.575,8.875),(20.575,8.705),(20.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.485),(25.715,14.655),(25.885,14.655),(25.885,14.485),(25.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.825),(25.205,14.995),(25.375,14.995),(25.375,14.825),(25.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.825),(25.715,14.995),(25.885,14.995),(25.885,14.825),(25.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.485),(25.205,14.655),(25.375,14.655),(25.375,14.485),(25.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,14.145),(25.205,14.315),(25.375,14.315),(25.375,14.145),(25.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,14.145),(25.715,14.315),(25.885,14.315),(25.885,14.145),(25.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.085),(15.605,11.255),(15.775,11.255),(15.775,11.085),(15.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.425),(15.605,11.595),(15.775,11.595),(15.775,11.425),(15.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,11.765),(15.605,11.935),(15.775,11.935),(15.775,11.765),(15.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.025),(82.805,8.195),(82.975,8.195),(82.975,8.025),(82.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.365),(82.805,8.535),(82.975,8.535),(82.975,8.365),(82.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,8.705),(82.805,8.875),(82.975,8.875),(82.975,8.705),(82.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.105),(11.315,12.275),(11.485,12.275),(11.485,12.105),(11.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.945),(44.405,4.115),(44.575,4.115),(44.575,3.945),(44.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.745),(68.915,10.915),(69.085,10.915),(69.085,10.745),(68.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.405),(68.915,10.575),(69.085,10.575),(69.085,10.405),(68.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,10.065),(68.915,10.235),(69.085,10.235),(69.085,10.065),(68.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.085),(21.425,11.255),(21.595,11.255),(21.595,11.085),(21.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.765),(21.425,11.935),(21.595,11.935),(21.595,11.765),(21.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,11.425),(21.425,11.595),(21.595,11.595),(21.595,11.425),(21.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.765),(68.915,11.935),(69.085,11.935),(69.085,11.765),(68.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.085),(68.915,11.255),(69.085,11.255),(69.085,11.085),(68.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,11.425),(68.915,11.595),(69.085,11.595),(69.085,11.425),(68.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.345),(30.515,7.515),(30.685,7.515),(30.685,7.345),(30.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.345),(30.005,7.515),(30.175,7.515),(30.175,7.345),(30.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.005),(30.005,7.175),(30.175,7.175),(30.175,7.005),(30.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.005),(30.515,7.175),(30.685,7.175),(30.685,7.005),(30.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.905),(55.025,19.075),(55.195,19.075),(55.195,18.905),(55.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,2.925),(68.405,3.095),(68.575,3.095),(68.575,2.925),(68.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.425),(63.605,11.595),(63.775,11.595),(63.775,11.425),(63.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.765),(63.605,11.935),(63.775,11.935),(63.775,11.765),(63.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,11.085),(63.605,11.255),(63.775,11.255),(63.775,11.085),(63.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.825),(34.805,14.995),(34.975,14.995),(34.975,14.825),(34.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.765),(20.915,11.935),(21.085,11.935),(21.085,11.765),(20.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.425),(20.915,11.595),(21.085,11.595),(21.085,11.425),(20.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,11.085),(20.915,11.255),(21.085,11.255),(21.085,11.085),(20.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.725),(50.225,9.895),(50.395,9.895),(50.395,9.725),(50.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.385),(50.225,9.555),(50.395,9.555),(50.395,9.385),(50.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.685),(64.115,7.855),(64.285,7.855),(64.285,7.685),(64.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.685),(64.625,7.855),(64.795,7.855),(64.795,7.685),(64.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.185),(10.805,16.355),(10.975,16.355),(10.975,16.185),(10.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.525),(10.805,16.695),(10.975,16.695),(10.975,16.525),(10.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.865),(39.605,17.035),(39.775,17.035),(39.775,16.865),(39.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.345),(40.625,7.515),(40.795,7.515),(40.795,7.345),(40.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.345),(40.115,7.515),(40.285,7.515),(40.285,7.345),(40.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.005),(40.115,7.175),(40.285,7.175),(40.285,7.005),(40.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.005),(40.625,7.175),(40.795,7.175),(40.795,7.005),(40.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.465),(54.005,13.635),(54.175,13.635),(54.175,13.465),(54.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.805),(54.005,13.975),(54.175,13.975),(54.175,13.805),(54.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.465),(54.515,13.635),(54.685,13.635),(54.685,13.465),(54.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.805),(54.515,13.975),(54.685,13.975),(54.685,13.805),(54.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.685),(40.115,7.855),(40.285,7.855),(40.285,7.685),(40.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.685),(40.625,7.855),(40.795,7.855),(40.795,7.685),(40.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.125),(54.005,13.295),(54.175,13.295),(54.175,13.125),(54.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.125),(54.515,13.295),(54.685,13.295),(54.685,13.125),(54.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.165),(21.425,15.335),(21.595,15.335),(21.595,15.165),(21.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.505),(21.425,15.675),(21.595,15.675),(21.595,15.505),(21.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.245),(40.115,19.415),(40.285,19.415),(40.285,19.245),(40.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.245),(40.625,19.415),(40.795,19.415),(40.795,19.245),(40.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.525),(25.205,16.695),(25.375,16.695),(25.375,16.525),(25.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.185),(25.205,16.355),(25.375,16.355),(25.375,16.185),(25.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.185),(25.715,16.355),(25.885,16.355),(25.885,16.185),(25.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.525),(25.715,16.695),(25.885,16.695),(25.885,16.525),(25.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.465),(6.515,13.635),(6.685,13.635),(6.685,13.465),(6.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.805),(6.515,13.975),(6.685,13.975),(6.685,13.805),(6.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,13.125),(6.515,13.295),(6.685,13.295),(6.685,13.125),(6.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.185),(7.025,16.355),(7.195,16.355),(7.195,16.185),(7.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.525),(7.025,16.695),(7.195,16.695),(7.195,16.525),(7.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.325),(79.025,6.495),(79.195,6.495),(79.195,6.325),(79.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,6.665),(79.025,6.835),(79.195,6.835),(79.195,6.665),(79.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.145),(39.605,14.315),(39.775,14.315),(39.775,14.145),(39.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.485),(39.605,14.655),(39.775,14.655),(39.775,14.485),(39.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.825),(39.605,14.995),(39.775,14.995),(39.775,14.825),(39.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.005),(10.805,7.175),(10.975,7.175),(10.975,7.005),(10.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.345),(10.805,7.515),(10.975,7.515),(10.975,7.345),(10.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.325),(44.915,6.495),(45.085,6.495),(45.085,6.325),(44.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.665),(44.915,6.835),(45.085,6.835),(45.085,6.665),(44.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.525),(78.005,16.695),(78.175,16.695),(78.175,16.525),(78.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.185),(78.515,16.355),(78.685,16.355),(78.685,16.185),(78.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.565),(15.605,18.735),(15.775,18.735),(15.775,18.565),(15.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.185),(78.005,16.355),(78.175,16.355),(78.175,16.185),(78.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.525),(78.515,16.695),(78.685,16.695),(78.685,16.525),(78.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.225),(15.605,18.395),(15.775,18.395),(15.775,18.225),(15.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,18.905),(25.205,19.075),(25.375,19.075),(25.375,18.905),(25.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,18.905),(25.715,19.075),(25.885,19.075),(25.885,18.905),(25.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.845),(49.715,16.015),(49.885,16.015),(49.885,15.845),(49.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.845),(49.205,16.015),(49.375,16.015),(49.375,15.845),(49.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.885),(10.805,18.055),(10.975,18.055),(10.975,17.885),(10.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.665),(44.405,6.835),(44.575,6.835),(44.575,6.665),(44.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.325),(44.405,6.495),(44.575,6.495),(44.575,6.325),(44.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.685),(16.625,7.855),(16.795,7.855),(16.795,7.685),(16.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.685),(16.115,7.855),(16.285,7.855),(16.285,7.685),(16.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.245),(50.225,19.415),(50.395,19.415),(50.395,19.245),(50.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.005),(15.605,7.175),(15.775,7.175),(15.775,7.005),(15.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.065),(44.915,10.235),(45.085,10.235),(45.085,10.065),(44.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.745),(44.915,10.915),(45.085,10.915),(45.085,10.745),(44.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.405),(44.915,10.575),(45.085,10.575),(45.085,10.405),(44.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.345),(15.605,7.515),(15.775,7.515),(15.775,7.345),(15.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,17.885),(68.915,18.055),(69.085,18.055),(69.085,17.885),(68.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.025),(40.625,8.195),(40.795,8.195),(40.795,8.025),(40.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.345),(82.805,7.515),(82.975,7.515),(82.975,7.345),(82.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.365),(40.625,8.535),(40.795,8.535),(40.795,8.365),(40.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.705),(40.115,8.875),(40.285,8.875),(40.285,8.705),(40.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,4.965),(21.425,5.135),(21.595,5.135),(21.595,4.965),(21.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.705),(40.625,8.875),(40.795,8.875),(40.795,8.705),(40.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.365),(40.115,8.535),(40.285,8.535),(40.285,8.365),(40.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.005),(82.805,7.175),(82.975,7.175),(82.975,7.005),(82.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,15.845),(74.225,16.015),(74.395,16.015),(74.395,15.845),(74.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.985),(83.315,6.155),(83.485,6.155),(83.485,5.985),(83.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,15.845),(26.225,16.015),(26.395,16.015),(26.395,15.845),(26.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.965),(44.405,5.135),(44.575,5.135),(44.575,4.965),(44.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.405),(49.715,10.575),(49.885,10.575),(49.885,10.405),(49.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.405),(49.205,10.575),(49.375,10.575),(49.375,10.405),(49.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.785),(21.425,12.955),(21.595,12.955),(21.595,12.785),(21.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.445),(21.425,12.615),(21.595,12.615),(21.595,12.445),(21.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.065),(49.205,10.235),(49.375,10.235),(49.375,10.065),(49.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.065),(49.715,10.235),(49.885,10.235),(49.885,10.065),(49.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.745),(49.205,10.915),(49.375,10.915),(49.375,10.745),(49.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.745),(49.715,10.915),(49.885,10.915),(49.885,10.745),(49.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,12.105),(21.425,12.275),(21.595,12.275),(21.595,12.105),(21.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.685),(78.515,7.855),(78.685,7.855),(78.685,7.685),(78.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,16.865),(6.515,17.035),(6.685,17.035),(6.685,16.865),(6.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.325),(26.225,6.495),(26.395,6.495),(26.395,6.325),(26.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,6.665),(26.225,6.835),(26.395,6.835),(26.395,6.665),(26.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.005),(63.605,7.175),(63.775,7.175),(63.775,7.005),(63.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.345),(63.605,7.515),(63.775,7.515),(63.775,7.345),(63.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.325),(68.915,6.495),(69.085,6.495),(69.085,6.325),(68.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,6.665),(68.915,6.835),(69.085,6.835),(69.085,6.665),(68.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.925),(44.915,3.095),(45.085,3.095),(45.085,2.925),(44.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.685),(68.915,7.855),(69.085,7.855),(69.085,7.685),(68.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.345),(68.915,7.515),(69.085,7.515),(69.085,7.345),(68.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,7.005),(68.915,7.175),(69.085,7.175),(69.085,7.005),(68.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.045),(16.115,9.215),(16.285,9.215),(16.285,9.045),(16.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.045),(16.625,9.215),(16.795,9.215),(16.795,9.045),(16.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.425),(59.315,11.595),(59.485,11.595),(59.485,11.425),(59.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.425),(59.825,11.595),(59.995,11.595),(59.995,11.425),(59.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.085),(59.825,11.255),(59.995,11.255),(59.995,11.085),(59.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,18.905),(59.825,19.075),(59.995,19.075),(59.995,18.905),(59.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.905),(59.315,19.075),(59.485,19.075),(59.485,18.905),(59.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.085),(59.315,11.255),(59.485,11.255),(59.485,11.085),(59.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,11.765),(59.825,11.935),(59.995,11.935),(59.995,11.765),(59.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.765),(59.315,11.935),(59.485,11.935),(59.485,11.765),(59.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.565),(58.805,18.735),(58.975,18.735),(58.975,18.565),(58.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.225),(58.805,18.395),(58.975,18.395),(58.975,18.225),(58.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.345),(20.915,7.515),(21.085,7.515),(21.085,7.345),(20.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.685),(20.915,7.855),(21.085,7.855),(21.085,7.685),(20.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,7.005),(20.915,7.175),(21.085,7.175),(21.085,7.005),(20.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.805),(35.825,13.975),(35.995,13.975),(35.995,13.805),(35.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.465),(35.825,13.635),(35.995,13.635),(35.995,13.465),(35.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.805),(35.315,13.975),(35.485,13.975),(35.485,13.805),(35.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.465),(35.315,13.635),(35.485,13.635),(35.485,13.465),(35.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.985),(20.405,6.155),(20.575,6.155),(20.575,5.985),(20.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.725),(20.915,9.895),(21.085,9.895),(21.085,9.725),(20.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.385),(20.915,9.555),(21.085,9.555),(21.085,9.385),(20.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.125),(35.825,13.295),(35.995,13.295),(35.995,13.125),(35.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.045),(59.825,9.215),(59.995,9.215),(59.995,9.045),(59.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.045),(59.315,9.215),(59.485,9.215),(59.485,9.045),(59.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.765),(11.825,11.935),(11.995,11.935),(11.995,11.765),(11.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.085),(11.825,11.255),(11.995,11.255),(11.995,11.085),(11.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.765),(11.315,11.935),(11.485,11.935),(11.485,11.765),(11.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.085),(11.315,11.255),(11.485,11.255),(11.485,11.085),(11.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,11.425),(11.315,11.595),(11.485,11.595),(11.485,11.425),(11.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,11.425),(11.825,11.595),(11.995,11.595),(11.995,11.425),(11.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.385),(10.805,9.555),(10.975,9.555),(10.975,9.385),(10.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,9.725),(10.805,9.895),(10.975,9.895),(10.975,9.725),(10.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.065),(30.515,10.235),(30.685,10.235),(30.685,10.065),(30.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,19.245),(20.405,19.415),(20.575,19.415),(20.575,19.245),(20.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,2.925),(15.605,3.095),(15.775,3.095),(15.775,2.925),(15.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.345),(34.805,7.515),(34.975,7.515),(34.975,7.345),(34.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.325),(68.405,6.495),(68.575,6.495),(68.575,6.325),(68.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.045),(83.315,9.215),(83.485,9.215),(83.485,9.045),(83.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,6.665),(68.405,6.835),(68.575,6.835),(68.575,6.665),(68.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.045),(11.315,9.215),(11.485,9.215),(11.485,9.045),(11.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.045),(11.825,9.215),(11.995,9.215),(11.995,9.045),(11.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.005),(78.005,7.175),(78.175,7.175),(78.175,7.005),(78.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,7.005),(78.515,7.175),(78.685,7.175),(78.685,7.005),(78.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.005),(34.805,7.175),(34.975,7.175),(34.975,7.005),(34.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.345),(78.005,7.515),(78.175,7.515),(78.175,7.345),(78.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.205),(58.805,17.375),(58.975,17.375),(58.975,17.205),(58.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.545),(58.805,17.715),(58.975,17.715),(58.975,17.545),(58.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.145),(73.205,14.315),(73.375,14.315),(73.375,14.145),(73.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.145),(73.715,14.315),(73.885,14.315),(73.885,14.145),(73.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.485),(73.205,14.655),(73.375,14.655),(73.375,14.485),(73.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,14.825),(73.205,14.995),(73.375,14.995),(73.375,14.825),(73.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.825),(73.715,14.995),(73.885,14.995),(73.885,14.825),(73.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,14.485),(73.715,14.655),(73.885,14.655),(73.885,14.485),(73.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,5.985),(20.915,6.155),(21.085,6.155),(21.085,5.985),(20.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.925),(58.805,3.095),(58.975,3.095),(58.975,2.925),(58.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,19.245),(6.515,19.415),(6.685,19.415),(6.685,19.245),(6.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.925),(34.805,3.095),(34.975,3.095),(34.975,2.925),(34.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.545),(40.625,17.715),(40.795,17.715),(40.795,17.545),(40.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.545),(40.115,17.715),(40.285,17.715),(40.285,17.545),(40.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.205),(40.115,17.375),(40.285,17.375),(40.285,17.205),(40.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.205),(40.625,17.375),(40.795,17.375),(40.795,17.205),(40.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,2.925),(10.805,3.095),(10.975,3.095),(10.975,2.925),(10.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.565),(20.915,18.735),(21.085,18.735),(21.085,18.565),(20.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,18.225),(20.915,18.395),(21.085,18.395),(21.085,18.225),(20.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.745),(82.805,10.915),(82.975,10.915),(82.975,10.745),(82.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.405),(82.805,10.575),(82.975,10.575),(82.975,10.405),(82.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,10.065),(82.805,10.235),(82.975,10.235),(82.975,10.065),(82.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.665),(40.115,6.835),(40.285,6.835),(40.285,6.665),(40.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.325),(40.625,6.495),(40.795,6.495),(40.795,6.325),(40.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.325),(40.115,6.495),(40.285,6.495),(40.285,6.325),(40.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.665),(40.625,6.835),(40.795,6.835),(40.795,6.665),(40.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.465),(45.425,13.635),(45.595,13.635),(45.595,13.465),(45.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.805),(45.425,13.975),(45.595,13.975),(45.595,13.805),(45.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.745),(15.605,10.915),(15.775,10.915),(15.775,10.745),(15.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.125),(45.425,13.295),(45.595,13.295),(45.595,13.125),(45.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.065),(15.605,10.235),(15.775,10.235),(15.775,10.065),(15.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,10.405),(15.605,10.575),(15.775,10.575),(15.775,10.405),(15.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.305),(55.025,5.475),(55.195,5.475),(55.195,5.305),(55.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.645),(55.025,5.815),(55.195,5.815),(55.195,5.645),(55.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.085),(69.425,11.255),(69.595,11.255),(69.595,11.085),(69.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.425),(69.425,11.595),(69.595,11.595),(69.595,11.425),(69.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,11.765),(69.425,11.935),(69.595,11.935),(69.595,11.765),(69.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,4.965),(15.605,5.135),(15.775,5.135),(15.775,4.965),(15.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.025),(15.605,8.195),(15.775,8.195),(15.775,8.025),(15.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.425),(44.915,11.595),(45.085,11.595),(45.085,11.425),(44.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.085),(44.915,11.255),(45.085,11.255),(45.085,11.085),(44.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.705),(15.605,8.875),(15.775,8.875),(15.775,8.705),(15.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,8.365),(15.605,8.535),(15.775,8.535),(15.775,8.365),(15.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.765),(44.915,11.935),(45.085,11.935),(45.085,11.765),(44.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.005),(83.315,7.175),(83.485,7.175),(83.485,7.005),(83.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,7.345),(83.315,7.515),(83.485,7.515),(83.485,7.345),(83.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.545),(78.515,17.715),(78.685,17.715),(78.685,17.545),(78.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.205),(78.005,17.375),(78.175,17.375),(78.175,17.205),(78.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.505),(69.425,15.675),(69.595,15.675),(69.595,15.505),(69.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,15.165),(69.425,15.335),(69.595,15.335),(69.595,15.165),(69.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.245),(31.025,19.415),(31.195,19.415),(31.195,19.245),(31.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,17.545),(78.005,17.715),(78.175,17.715),(78.175,17.545),(78.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.145),(69.425,14.315),(69.595,14.315),(69.595,14.145),(69.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.485),(69.425,14.655),(69.595,14.655),(69.595,14.485),(69.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,14.825),(69.425,14.995),(69.595,14.995),(69.595,14.825),(69.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,17.205),(78.515,17.375),(78.685,17.375),(78.685,17.205),(78.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.465),(34.805,13.635),(34.975,13.635),(34.975,13.465),(34.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.805),(34.805,13.975),(34.975,13.975),(34.975,13.805),(34.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.125),(34.805,13.295),(34.975,13.295),(34.975,13.125),(34.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.685),(59.315,7.855),(59.485,7.855),(59.485,7.685),(59.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.885),(73.205,18.055),(73.375,18.055),(73.375,17.885),(73.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.885),(73.715,18.055),(73.885,18.055),(73.885,17.885),(73.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,7.685),(59.825,7.855),(59.995,7.855),(59.995,7.685),(59.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.145),(21.425,14.315),(21.595,14.315),(21.595,14.145),(21.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.485),(21.425,14.655),(21.595,14.655),(21.595,14.485),(21.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,14.825),(21.425,14.995),(21.595,14.995),(21.595,14.825),(21.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.985),(25.205,6.155),(25.375,6.155),(25.375,5.985),(25.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.985),(25.715,6.155),(25.885,6.155),(25.885,5.985),(25.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.725),(58.805,9.895),(58.975,9.895),(58.975,9.725),(58.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.385),(58.805,9.555),(58.975,9.555),(58.975,9.385),(58.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.245),(39.605,19.415),(39.775,19.415),(39.775,19.245),(39.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.525),(30.515,16.695),(30.685,16.695),(30.685,16.525),(30.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.185),(30.005,16.355),(30.175,16.355),(30.175,16.185),(30.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.525),(30.005,16.695),(30.175,16.695),(30.175,16.525),(30.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.185),(30.515,16.355),(30.685,16.355),(30.685,16.185),(30.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.685),(11.315,7.855),(11.485,7.855),(11.485,7.685),(11.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.685),(11.825,7.855),(11.995,7.855),(11.995,7.685),(11.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.005),(11.315,7.175),(11.485,7.175),(11.485,7.005),(11.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.925),(39.605,3.095),(39.775,3.095),(39.775,2.925),(39.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,7.005),(11.825,7.175),(11.995,7.175),(11.995,7.005),(11.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,7.345),(11.315,7.515),(11.485,7.515),(11.485,7.345),(11.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.525),(68.405,16.695),(68.575,16.695),(68.575,16.525),(68.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.185),(68.405,16.355),(68.575,16.355),(68.575,16.185),(68.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.025),(44.405,8.195),(44.575,8.195),(44.575,8.025),(44.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.705),(44.405,8.875),(44.575,8.875),(44.575,8.705),(44.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.365),(44.405,8.535),(44.575,8.535),(44.575,8.365),(44.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,18.905),(64.625,19.075),(64.795,19.075),(64.795,18.905),(64.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,18.905),(64.115,19.075),(64.285,19.075),(64.285,18.905),(64.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,19.245),(11.315,19.415),(11.485,19.415),(11.485,19.245),(11.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,19.245),(11.825,19.415),(11.995,19.415),(11.995,19.245),(11.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.445),(40.115,12.615),(40.285,12.615),(40.285,12.445),(40.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.785),(40.115,12.955),(40.285,12.955),(40.285,12.785),(40.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.445),(40.625,12.615),(40.795,12.615),(40.795,12.445),(40.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.105),(40.115,12.275),(40.285,12.275),(40.285,12.105),(40.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.105),(40.625,12.275),(40.795,12.275),(40.795,12.105),(40.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.865),(45.425,17.035),(45.595,17.035),(45.595,16.865),(45.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.785),(40.625,12.955),(40.795,12.955),(40.795,12.785),(40.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,7.685),(25.205,7.855),(25.375,7.855),(25.375,7.685),(25.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,7.685),(25.715,7.855),(25.885,7.855),(25.885,7.685),(25.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.125),(49.715,13.295),(49.885,13.295),(49.885,13.125),(49.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.125),(49.205,13.295),(49.375,13.295),(49.375,13.125),(49.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.245),(49.205,19.415),(49.375,19.415),(49.375,19.245),(49.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.245),(49.715,19.415),(49.885,19.415),(49.885,19.245),(49.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.805),(49.715,13.975),(49.885,13.975),(49.885,13.805),(49.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.465),(49.715,13.635),(49.885,13.635),(49.885,13.465),(49.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.465),(49.205,13.635),(49.375,13.635),(49.375,13.465),(49.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.805),(49.205,13.975),(49.375,13.975),(49.375,13.805),(49.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.985),(40.625,6.155),(40.795,6.155),(40.795,5.985),(40.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.985),(40.115,6.155),(40.285,6.155),(40.285,5.985),(40.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,9.045),(64.625,9.215),(64.795,9.215),(64.795,9.045),(64.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,9.045),(64.115,9.215),(64.285,9.215),(64.285,9.045),(64.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.365),(35.825,8.535),(35.995,8.535),(35.995,8.365),(35.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.705),(35.825,8.875),(35.995,8.875),(35.995,8.705),(35.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.365),(35.315,8.535),(35.485,8.535),(35.485,8.365),(35.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.705),(35.315,8.875),(35.485,8.875),(35.485,8.705),(35.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.025),(35.825,8.195),(35.995,8.195),(35.995,8.025),(35.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.985),(49.205,6.155),(49.375,6.155),(49.375,5.985),(49.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.265),(64.625,3.435),(64.795,3.435),(64.795,3.265),(64.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,3.605),(64.625,3.775),(64.795,3.775),(64.795,3.605),(64.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.265),(64.115,3.435),(64.285,3.435),(64.285,3.265),(64.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,3.605),(64.115,3.775),(64.285,3.775),(64.285,3.605),(64.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.985),(49.715,6.155),(49.885,6.155),(49.885,5.985),(49.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,9.045),(69.425,9.215),(69.595,9.215),(69.595,9.045),(69.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,4.965),(69.425,5.135),(69.595,5.135),(69.595,4.965),(69.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.885),(30.005,18.055),(30.175,18.055),(30.175,17.885),(30.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.885),(30.515,18.055),(30.685,18.055),(30.685,17.885),(30.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.085),(45.425,11.255),(45.595,11.255),(45.595,11.085),(45.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.425),(45.425,11.595),(45.595,11.595),(45.595,11.425),(45.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.765),(45.425,11.935),(45.595,11.935),(45.595,11.765),(45.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.665),(15.605,6.835),(15.775,6.835),(15.775,6.665),(15.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,6.325),(15.605,6.495),(15.775,6.495),(15.775,6.325),(15.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.305),(79.025,5.475),(79.195,5.475),(79.195,5.305),(79.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,5.645),(79.025,5.815),(79.195,5.815),(79.195,5.645),(79.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,2.925),(63.605,3.095),(63.775,3.095),(63.775,2.925),(63.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.285),(79.025,4.455),(79.195,4.455),(79.195,4.285),(79.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.625),(79.025,4.795),(79.195,4.795),(79.195,4.625),(79.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.965),(39.605,5.135),(39.775,5.135),(39.775,4.965),(39.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.445),(45.425,12.615),(45.595,12.615),(45.595,12.445),(45.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.845),(7.025,16.015),(7.195,16.015),(7.195,15.845),(7.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.785),(45.425,12.955),(45.595,12.955),(45.595,12.785),(45.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.105),(45.425,12.275),(45.595,12.275),(45.595,12.105),(45.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,9.045),(21.425,9.215),(21.595,9.215),(21.595,9.045),(21.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.985),(50.225,6.155),(50.395,6.155),(50.395,5.985),(50.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.285),(55.025,4.455),(55.195,4.455),(55.195,4.285),(55.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.625),(55.025,4.795),(55.195,4.795),(55.195,4.625),(55.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.225),(68.405,18.395),(68.575,18.395),(68.575,18.225),(68.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.565),(68.405,18.735),(68.575,18.735),(68.575,18.565),(68.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.105),(69.425,12.275),(69.595,12.275),(69.595,12.105),(69.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.785),(69.425,12.955),(69.595,12.955),(69.595,12.785),(69.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,12.445),(69.425,12.615),(69.595,12.615),(69.595,12.445),(69.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.565),(78.515,18.735),(78.685,18.735),(78.685,18.565),(78.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.225),(78.515,18.395),(78.685,18.395),(78.685,18.225),(78.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.225),(78.005,18.395),(78.175,18.395),(78.175,18.225),(78.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.565),(78.005,18.735),(78.175,18.735),(78.175,18.565),(78.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.245),(44.915,19.415),(45.085,19.415),(45.085,19.245),(44.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.625),(7.025,4.795),(7.195,4.795),(7.195,4.625),(7.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.285),(7.025,4.455),(7.195,4.455),(7.195,4.285),(7.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.685),(49.715,7.855),(49.885,7.855),(49.885,7.685),(49.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.685),(49.205,7.855),(49.375,7.855),(49.375,7.685),(49.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.005),(49.205,7.175),(49.375,7.175),(49.375,7.005),(49.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.005),(49.715,7.175),(49.885,7.175),(49.885,7.005),(49.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.345),(49.205,7.515),(49.375,7.515),(49.375,7.345),(49.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.345),(49.715,7.515),(49.885,7.515),(49.885,7.345),(49.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.465),(16.625,13.635),(16.795,13.635),(16.795,13.465),(16.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.805),(16.625,13.975),(16.795,13.975),(16.795,13.805),(16.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.805),(16.115,13.975),(16.285,13.975),(16.285,13.805),(16.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.465),(16.115,13.635),(16.285,13.635),(16.285,13.465),(16.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.525),(83.315,16.695),(83.485,16.695),(83.485,16.525),(83.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,13.125),(16.115,13.295),(16.285,13.295),(16.285,13.125),(16.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.505),(45.425,15.675),(45.595,15.675),(45.595,15.505),(45.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.165),(45.425,15.335),(45.595,15.335),(45.595,15.165),(45.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,13.125),(16.625,13.295),(16.795,13.295),(16.795,13.125),(16.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.185),(83.315,16.355),(83.485,16.355),(83.485,16.185),(83.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.545),(15.605,17.715),(15.775,17.715),(15.775,17.545),(15.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,17.205),(15.605,17.375),(15.775,17.375),(15.775,17.205),(15.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.125),(59.315,13.295),(59.485,13.295),(59.485,13.125),(59.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.125),(59.825,13.295),(59.995,13.295),(59.995,13.125),(59.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.465),(59.825,13.635),(59.995,13.635),(59.995,13.465),(59.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,13.805),(59.825,13.975),(59.995,13.975),(59.995,13.805),(59.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.465),(59.315,13.635),(59.485,13.635),(59.485,13.465),(59.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.385),(44.915,9.555),(45.085,9.555),(45.085,9.385),(44.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.725),(44.915,9.895),(45.085,9.895),(45.085,9.725),(44.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.985),(16.625,6.155),(16.795,6.155),(16.795,5.985),(16.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.985),(16.115,6.155),(16.285,6.155),(16.285,5.985),(16.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.805),(59.315,13.975),(59.485,13.975),(59.485,13.805),(59.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.805),(11.315,13.975),(11.485,13.975),(11.485,13.805),(11.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.805),(83.315,13.975),(83.485,13.975),(83.485,13.805),(83.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,13.465),(83.315,13.635),(83.485,13.635),(83.485,13.465),(83.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,13.465),(11.315,13.635),(11.485,13.635),(11.485,13.465),(11.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.745),(63.605,10.915),(63.775,10.915),(63.775,10.745),(63.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.065),(63.605,10.235),(63.775,10.235),(63.775,10.065),(63.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,10.405),(63.605,10.575),(63.775,10.575),(63.775,10.405),(63.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.865),(49.205,17.035),(49.375,17.035),(49.375,16.865),(49.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.865),(49.715,17.035),(49.885,17.035),(49.885,16.865),(49.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.385),(68.915,9.555),(69.085,9.555),(69.085,9.385),(68.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,9.725),(68.915,9.895),(69.085,9.895),(69.085,9.725),(68.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.905),(54.005,19.075),(54.175,19.075),(54.175,18.905),(54.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.905),(54.515,19.075),(54.685,19.075),(54.685,18.905),(54.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.985),(74.225,6.155),(74.395,6.155),(74.395,5.985),(74.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,4.965),(63.605,5.135),(63.775,5.135),(63.775,4.965),(63.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.705),(63.605,8.875),(63.775,8.875),(63.775,8.705),(63.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.025),(63.605,8.195),(63.775,8.195),(63.775,8.025),(63.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,8.365),(63.605,8.535),(63.775,8.535),(63.775,8.365),(63.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,18.905),(7.025,19.075),(7.195,19.075),(7.195,18.905),(7.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.625),(31.025,4.795),(31.195,4.795),(31.195,4.625),(31.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.285),(31.025,4.455),(31.195,4.455),(31.195,4.285),(31.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.085),(82.805,11.255),(82.975,11.255),(82.975,11.085),(82.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.425),(82.805,11.595),(82.975,11.595),(82.975,11.425),(82.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,11.765),(82.805,11.935),(82.975,11.935),(82.975,11.765),(82.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.525),(73.715,16.695),(73.885,16.695),(73.885,16.525),(73.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.185),(73.205,16.355),(73.375,16.355),(73.375,16.185),(73.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.525),(73.205,16.695),(73.375,16.695),(73.375,16.525),(73.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.185),(73.715,16.355),(73.885,16.355),(73.885,16.185),(73.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.205),(59.315,17.375),(59.485,17.375),(59.485,17.205),(59.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.545),(59.315,17.715),(59.485,17.715),(59.485,17.545),(59.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.545),(59.825,17.715),(59.995,17.715),(59.995,17.545),(59.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,17.205),(59.825,17.375),(59.995,17.375),(59.995,17.205),(59.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.465),(82.805,13.635),(82.975,13.635),(82.975,13.465),(82.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.805),(82.805,13.975),(82.975,13.975),(82.975,13.805),(82.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,13.125),(82.805,13.295),(82.975,13.295),(82.975,13.125),(82.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.885),(45.425,18.055),(45.595,18.055),(45.595,17.885),(45.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,18.905),(11.825,19.075),(11.995,19.075),(11.995,18.905),(11.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.025),(83.315,8.195),(83.485,8.195),(83.485,8.025),(83.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.365),(83.315,8.535),(83.485,8.535),(83.485,8.365),(83.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,8.705),(83.315,8.875),(83.485,8.875),(83.485,8.705),(83.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,18.905),(11.315,19.075),(11.485,19.075),(11.485,18.905),(11.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.845),(68.915,16.015),(69.085,16.015),(69.085,15.845),(68.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.705),(11.825,8.875),(11.995,8.875),(11.995,8.705),(11.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,8.365),(11.825,8.535),(11.995,8.535),(11.995,8.365),(11.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.365),(11.315,8.535),(11.485,8.535),(11.485,8.365),(11.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.705),(11.315,8.875),(11.485,8.875),(11.485,8.705),(11.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,8.025),(11.315,8.195),(11.485,8.195),(11.485,8.025),(11.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.905),(50.225,19.075),(50.395,19.075),(50.395,18.905),(50.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.845),(20.915,16.015),(21.085,16.015),(21.085,15.845),(20.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.405),(40.115,10.575),(40.285,10.575),(40.285,10.405),(40.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.405),(40.625,10.575),(40.795,10.575),(40.795,10.405),(40.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.745),(40.115,10.915),(40.285,10.915),(40.285,10.745),(40.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.745),(40.625,10.915),(40.795,10.915),(40.795,10.745),(40.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.285),(64.115,4.455),(64.285,4.455),(64.285,4.285),(64.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.065),(40.115,10.235),(40.285,10.235),(40.285,10.065),(40.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.065),(40.625,10.235),(40.795,10.235),(40.795,10.065),(40.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.845),(55.025,16.015),(55.195,16.015),(55.195,15.845),(55.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.505),(40.115,15.675),(40.285,15.675),(40.285,15.505),(40.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.505),(40.625,15.675),(40.795,15.675),(40.795,15.505),(40.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.165),(40.115,15.335),(40.285,15.335),(40.285,15.165),(40.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.165),(40.625,15.335),(40.795,15.335),(40.795,15.165),(40.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.205),(10.805,17.375),(10.975,17.375),(10.975,17.205),(10.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,17.545),(10.805,17.715),(10.975,17.715),(10.975,17.545),(10.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.125),(73.715,13.295),(73.885,13.295),(73.885,13.125),(73.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.245),(45.425,19.415),(45.595,19.415),(45.595,19.245),(45.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.025),(49.205,8.195),(49.375,8.195),(49.375,8.025),(49.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.705),(49.715,8.875),(49.885,8.875),(49.885,8.705),(49.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.365),(49.205,8.535),(49.375,8.535),(49.375,8.365),(49.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.705),(49.205,8.875),(49.375,8.875),(49.375,8.705),(49.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.365),(49.715,8.535),(49.885,8.535),(49.885,8.365),(49.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.045),(34.805,9.215),(34.975,9.215),(34.975,9.045),(34.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.325),(83.315,6.495),(83.485,6.495),(83.485,6.325),(83.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,6.665),(83.315,6.835),(83.485,6.835),(83.485,6.665),(83.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.905),(45.425,19.075),(45.595,19.075),(45.595,18.905),(45.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.405),(78.005,10.575),(78.175,10.575),(78.175,10.405),(78.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.405),(78.515,10.575),(78.685,10.575),(78.685,10.405),(78.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.065),(78.005,10.235),(78.175,10.235),(78.175,10.065),(78.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.065),(78.515,10.235),(78.685,10.235),(78.685,10.065),(78.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.765),(34.805,11.935),(34.975,11.935),(34.975,11.765),(34.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.085),(34.805,11.255),(34.975,11.255),(34.975,11.085),(34.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.425),(34.805,11.595),(34.975,11.595),(34.975,11.425),(34.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.465),(11.825,13.635),(11.995,13.635),(11.995,13.465),(11.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,10.745),(78.005,10.915),(78.175,10.915),(78.175,10.745),(78.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,10.745),(78.515,10.915),(78.685,10.915),(78.685,10.745),(78.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.485),(45.425,14.655),(45.595,14.655),(45.595,14.485),(45.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.825),(45.425,14.995),(45.595,14.995),(45.595,14.825),(45.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.145),(45.425,14.315),(45.595,14.315),(45.595,14.145),(45.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.605),(54.515,3.775),(54.685,3.775),(54.685,3.605),(54.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.265),(54.005,3.435),(54.175,3.435),(54.175,3.265),(54.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.605),(54.005,3.775),(54.175,3.775),(54.175,3.605),(54.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,2.925),(82.805,3.095),(82.975,3.095),(82.975,2.925),(82.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.265),(54.515,3.435),(54.685,3.435),(54.685,3.265),(54.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.965),(35.825,5.135),(35.995,5.135),(35.995,4.965),(35.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.965),(35.315,5.135),(35.485,5.135),(35.485,4.965),(35.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,18.905),(16.625,19.075),(16.795,19.075),(16.795,18.905),(16.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,18.905),(16.115,19.075),(16.285,19.075),(16.285,18.905),(16.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,4.965),(26.225,5.135),(26.395,5.135),(26.395,4.965),(26.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.265),(6.515,3.435),(6.685,3.435),(6.685,3.265),(6.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.605),(6.515,3.775),(6.685,3.775),(6.685,3.605),(6.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,3.945),(20.915,4.115),(21.085,4.115),(21.085,3.945),(20.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.865),(44.915,17.035),(45.085,17.035),(45.085,16.865),(44.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.205),(55.025,17.375),(55.195,17.375),(55.195,17.205),(55.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.545),(55.025,17.715),(55.195,17.715),(55.195,17.545),(55.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.445),(35.315,12.615),(35.485,12.615),(35.485,12.445),(35.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.785),(35.315,12.955),(35.485,12.955),(35.485,12.785),(35.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.445),(35.825,12.615),(35.995,12.615),(35.995,12.445),(35.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.785),(35.825,12.955),(35.995,12.955),(35.995,12.785),(35.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.105),(35.825,12.275),(35.995,12.275),(35.995,12.105),(35.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.105),(35.315,12.275),(35.485,12.275),(35.485,12.105),(35.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.865),(58.805,17.035),(58.975,17.035),(58.975,16.865),(58.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,7.685),(73.205,7.855),(73.375,7.855),(73.375,7.685),(73.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,7.685),(73.715,7.855),(73.885,7.855),(73.885,7.685),(73.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.125),(64.115,13.295),(64.285,13.295),(64.285,13.125),(64.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.125),(64.625,13.295),(64.795,13.295),(64.795,13.125),(64.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.465),(64.115,13.635),(64.285,13.635),(64.285,13.465),(64.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,13.805),(64.115,13.975),(64.285,13.975),(64.285,13.805),(64.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.805),(64.625,13.975),(64.795,13.975),(64.795,13.805),(64.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,13.465),(64.625,13.635),(64.795,13.635),(64.795,13.465),(64.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.205),(44.915,17.375),(45.085,17.375),(45.085,17.205),(44.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.545),(44.915,17.715),(45.085,17.715),(45.085,17.545),(44.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.185),(21.425,16.355),(21.595,16.355),(21.595,16.185),(21.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.525),(21.425,16.695),(21.595,16.695),(21.595,16.525),(21.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.865),(55.025,17.035),(55.195,17.035),(55.195,16.865),(55.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.025),(59.825,8.195),(59.995,8.195),(59.995,8.025),(59.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.365),(59.315,8.535),(59.485,8.535),(59.485,8.365),(59.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.705),(59.315,8.875),(59.485,8.875),(59.485,8.705),(59.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.365),(59.825,8.535),(59.995,8.535),(59.995,8.365),(59.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,8.705),(59.825,8.875),(59.995,8.875),(59.995,8.705),(59.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,19.245),(68.405,19.415),(68.575,19.415),(68.575,19.245),(68.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.305),(20.405,5.475),(20.575,5.475),(20.575,5.305),(20.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,5.645),(20.405,5.815),(20.575,5.815),(20.575,5.645),(20.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.265),(83.315,3.435),(83.485,3.435),(83.485,3.265),(83.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,3.605),(83.315,3.775),(83.485,3.775),(83.485,3.605),(83.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.365),(30.515,8.535),(30.685,8.535),(30.685,8.365),(30.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.705),(30.515,8.875),(30.685,8.875),(30.685,8.705),(30.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.365),(30.005,8.535),(30.175,8.535),(30.175,8.365),(30.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.705),(30.005,8.875),(30.175,8.875),(30.175,8.705),(30.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,8.025),(30.005,8.195),(30.175,8.195),(30.175,8.025),(30.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.985),(64.625,6.155),(64.795,6.155),(64.795,5.985),(64.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.605),(79.025,3.775),(79.195,3.775),(79.195,3.605),(79.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.985),(64.115,6.155),(64.285,6.155),(64.285,5.985),(64.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.325),(6.515,6.495),(6.685,6.495),(6.685,6.325),(6.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,6.665),(6.515,6.835),(6.685,6.835),(6.685,6.665),(6.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,3.265),(79.025,3.435),(79.195,3.435),(79.195,3.265),(79.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.145),(74.225,14.315),(74.395,14.315),(74.395,14.145),(74.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.745),(30.515,10.915),(30.685,10.915),(30.685,10.745),(30.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.745),(30.005,10.915),(30.175,10.915),(30.175,10.745),(30.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.825),(74.225,14.995),(74.395,14.995),(74.395,14.825),(74.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.565),(10.805,18.735),(10.975,18.735),(10.975,18.565),(10.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.225),(10.805,18.395),(10.975,18.395),(10.975,18.225),(10.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.265),(35.315,3.435),(35.485,3.435),(35.485,3.265),(35.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.605),(35.315,3.775),(35.485,3.775),(35.485,3.605),(35.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.265),(35.825,3.435),(35.995,3.435),(35.995,3.265),(35.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.605),(35.825,3.775),(35.995,3.775),(35.995,3.605),(35.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.985),(78.515,6.155),(78.685,6.155),(78.685,5.985),(78.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.985),(78.005,6.155),(78.175,6.155),(78.175,5.985),(78.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.965),(50.225,5.135),(50.395,5.135),(50.395,4.965),(50.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.725),(31.025,9.895),(31.195,9.895),(31.195,9.725),(31.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.385),(31.025,9.555),(31.195,9.555),(31.195,9.385),(31.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.985),(54.515,6.155),(54.685,6.155),(54.685,5.985),(54.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.985),(54.005,6.155),(54.175,6.155),(54.175,5.985),(54.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.485),(26.225,14.655),(26.395,14.655),(26.395,14.485),(26.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.825),(26.225,14.995),(26.395,14.995),(26.395,14.825),(26.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,14.145),(26.225,14.315),(26.395,14.315),(26.395,14.145),(26.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.985),(6.515,6.155),(6.685,6.155),(6.685,5.985),(6.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.705),(64.625,8.875),(64.795,8.875),(64.795,8.705),(64.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.265),(59.825,3.435),(59.995,3.435),(59.995,3.265),(59.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.605),(59.315,3.775),(59.485,3.775),(59.485,3.605),(59.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,3.605),(59.825,3.775),(59.995,3.775),(59.995,3.605),(59.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.265),(59.315,3.435),(59.485,3.435),(59.485,3.265),(59.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.465),(31.025,13.635),(31.195,13.635),(31.195,13.465),(31.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.805),(31.025,13.975),(31.195,13.975),(31.195,13.805),(31.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.125),(31.025,13.295),(31.195,13.295),(31.195,13.125),(31.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.185),(15.605,16.355),(15.775,16.355),(15.775,16.185),(15.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.525),(15.605,16.695),(15.775,16.695),(15.775,16.525),(15.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.365),(21.425,8.535),(21.595,8.535),(21.595,8.365),(21.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.705),(21.425,8.875),(21.595,8.875),(21.595,8.705),(21.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,8.025),(21.425,8.195),(21.595,8.195),(21.595,8.025),(21.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.625),(68.405,4.795),(68.575,4.795),(68.575,4.625),(68.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.285),(68.405,4.455),(68.575,4.455),(68.575,4.285),(68.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,4.965),(83.315,5.135),(83.485,5.135),(83.485,4.965),(83.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.325),(35.315,6.495),(35.485,6.495),(35.485,6.325),(35.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.665),(35.315,6.835),(35.485,6.835),(35.485,6.665),(35.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.665),(35.825,6.835),(35.995,6.835),(35.995,6.665),(35.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.325),(35.825,6.495),(35.995,6.495),(35.995,6.325),(35.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.285),(20.405,4.455),(20.575,4.455),(20.575,4.285),(20.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.625),(20.405,4.795),(20.575,4.795),(20.575,4.625),(20.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.265),(21.425,3.435),(21.595,3.435),(21.595,3.265),(21.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,3.605),(21.425,3.775),(21.595,3.775),(21.595,3.605),(21.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.185),(34.805,16.355),(34.975,16.355),(34.975,16.185),(34.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.525),(34.805,16.695),(34.975,16.695),(34.975,16.525),(34.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.225),(63.605,18.395),(63.775,18.395),(63.775,18.225),(63.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.565),(63.605,18.735),(63.775,18.735),(63.775,18.565),(63.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.265),(31.025,3.435),(31.195,3.435),(31.195,3.265),(31.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.605),(31.025,3.775),(31.195,3.775),(31.195,3.605),(31.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.265),(68.915,3.435),(69.085,3.435),(69.085,3.265),(68.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,3.605),(68.915,3.775),(69.085,3.775),(69.085,3.605),(68.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,15.845),(79.025,16.015),(79.195,16.015),(79.195,15.845),(79.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.945),(54.005,4.115),(54.175,4.115),(54.175,3.945),(54.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.945),(54.515,4.115),(54.685,4.115),(54.685,3.945),(54.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,19.245),(64.115,19.415),(64.285,19.415),(64.285,19.245),(64.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.985),(30.515,6.155),(30.685,6.155),(30.685,5.985),(30.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.445),(83.315,12.615),(83.485,12.615),(83.485,12.445),(83.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.785),(83.315,12.955),(83.485,12.955),(83.485,12.785),(83.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.785),(11.825,12.955),(11.995,12.955),(11.995,12.785),(11.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.445),(11.315,12.615),(11.485,12.615),(11.485,12.445),(11.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.445),(11.825,12.615),(11.995,12.615),(11.995,12.445),(11.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,12.785),(11.315,12.955),(11.485,12.955),(11.485,12.785),(11.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,12.105),(83.315,12.275),(83.485,12.275),(83.485,12.105),(83.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.505),(83.315,15.675),(83.485,15.675),(83.485,15.505),(83.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.325),(59.825,6.495),(59.995,6.495),(59.995,6.325),(59.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,6.665),(59.825,6.835),(59.995,6.835),(59.995,6.665),(59.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,18.905),(20.405,19.075),(20.575,19.075),(20.575,18.905),(20.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.325),(59.315,6.495),(59.485,6.495),(59.485,6.325),(59.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.665),(59.315,6.835),(59.485,6.835),(59.485,6.665),(59.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,15.165),(83.315,15.335),(83.485,15.335),(83.485,15.165),(83.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.225),(83.315,18.395),(83.485,18.395),(83.485,18.225),(83.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.565),(83.315,18.735),(83.485,18.735),(83.485,18.565),(83.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,3.945),(6.515,4.115),(6.685,4.115),(6.685,3.945),(6.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.525),(35.825,16.695),(35.995,16.695),(35.995,16.525),(35.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.185),(35.315,16.355),(35.485,16.355),(35.485,16.185),(35.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.525),(35.315,16.695),(35.485,16.695),(35.485,16.525),(35.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,9.045),(82.805,9.215),(82.975,9.215),(82.975,9.045),(82.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.505),(35.825,15.675),(35.995,15.675),(35.995,15.505),(35.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.505),(35.315,15.675),(35.485,15.675),(35.485,15.505),(35.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.165),(35.315,15.335),(35.485,15.335),(35.485,15.165),(35.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.165),(35.825,15.335),(35.995,15.335),(35.995,15.165),(35.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.185),(35.825,16.355),(35.995,16.355),(35.995,16.185),(35.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.305),(45.425,5.475),(45.595,5.475),(45.595,5.305),(45.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.645),(45.425,5.815),(45.595,5.815),(45.595,5.645),(45.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.265),(44.915,3.435),(45.085,3.435),(45.085,3.265),(44.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.605),(44.915,3.775),(45.085,3.775),(45.085,3.605),(44.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.185),(26.225,16.355),(26.395,16.355),(26.395,16.185),(26.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.525),(26.225,16.695),(26.395,16.695),(26.395,16.525),(26.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.845),(44.915,16.015),(45.085,16.015),(45.085,15.845),(44.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.445),(49.715,12.615),(49.885,12.615),(49.885,12.445),(49.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.785),(49.205,12.955),(49.375,12.955),(49.375,12.785),(49.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.785),(49.715,12.955),(49.885,12.955),(49.885,12.785),(49.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.445),(49.205,12.615),(49.375,12.615),(49.375,12.445),(49.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.105),(49.205,12.275),(49.375,12.275),(49.375,12.105),(49.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,18.905),(6.515,19.075),(6.685,19.075),(6.685,18.905),(6.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.105),(49.715,12.275),(49.885,12.275),(49.885,12.105),(49.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.265),(55.025,3.435),(55.195,3.435),(55.195,3.265),(55.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.605),(55.025,3.775),(55.195,3.775),(55.195,3.605),(55.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.045),(45.425,9.215),(45.595,9.215),(45.595,9.045),(45.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,18.905),(73.715,19.075),(73.885,19.075),(73.885,18.905),(73.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,18.905),(73.205,19.075),(73.375,19.075),(73.375,18.905),(73.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.985),(10.805,6.155),(10.975,6.155),(10.975,5.985),(10.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,3.945),(7.025,4.115),(7.195,4.115),(7.195,3.945),(7.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.305),(40.625,5.475),(40.795,5.475),(40.795,5.305),(40.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.645),(40.625,5.815),(40.795,5.815),(40.795,5.645),(40.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.645),(40.115,5.815),(40.285,5.815),(40.285,5.645),(40.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.845),(31.025,16.015),(31.195,16.015),(31.195,15.845),(31.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.305),(40.115,5.475),(40.285,5.475),(40.285,5.305),(40.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,9.045),(7.025,9.215),(7.195,9.215),(7.195,9.045),(7.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.845),(54.515,16.015),(54.685,16.015),(54.685,15.845),(54.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.845),(54.005,16.015),(54.175,16.015),(54.175,15.845),(54.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.885),(26.225,18.055),(26.395,18.055),(26.395,17.885),(26.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.225),(21.425,18.395),(21.595,18.395),(21.595,18.225),(21.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.565),(21.425,18.735),(21.595,18.735),(21.595,18.565),(21.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.245),(58.805,19.415),(58.975,19.415),(58.975,19.245),(58.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.025),(78.005,8.195),(78.175,8.195),(78.175,8.025),(78.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.025),(78.515,8.195),(78.685,8.195),(78.685,8.025),(78.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.365),(78.005,8.535),(78.175,8.535),(78.175,8.365),(78.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,8.705),(78.005,8.875),(78.175,8.875),(78.175,8.705),(78.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.365),(78.515,8.535),(78.685,8.535),(78.685,8.365),(78.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,8.705),(78.515,8.875),(78.685,8.875),(78.685,8.705),(78.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.205),(30.005,17.375),(30.175,17.375),(30.175,17.205),(30.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,17.545),(30.005,17.715),(30.175,17.715),(30.175,17.545),(30.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.205),(30.515,17.375),(30.685,17.375),(30.685,17.205),(30.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.545),(30.515,17.715),(30.685,17.715),(30.685,17.545),(30.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,3.945),(11.315,4.115),(11.485,4.115),(11.485,3.945),(11.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,3.945),(11.825,4.115),(11.995,4.115),(11.995,3.945),(11.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,15.845),(6.515,16.015),(6.685,16.015),(6.685,15.845),(6.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.885),(79.025,18.055),(79.195,18.055),(79.195,17.885),(79.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.305),(50.225,5.475),(50.395,5.475),(50.395,5.305),(50.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.645),(50.225,5.815),(50.395,5.815),(50.395,5.645),(50.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.505),(7.025,15.675),(7.195,15.675),(7.195,15.505),(7.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,15.165),(7.025,15.335),(7.195,15.335),(7.195,15.165),(7.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.605),(78.005,3.775),(78.175,3.775),(78.175,3.605),(78.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.265),(78.515,3.435),(78.685,3.435),(78.685,3.265),(78.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.385),(79.025,9.555),(79.195,9.555),(79.195,9.385),(79.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,9.725),(79.025,9.895),(79.195,9.895),(79.195,9.725),(79.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.625),(44.915,4.795),(45.085,4.795),(45.085,4.625),(44.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.285),(44.915,4.455),(45.085,4.455),(45.085,4.285),(44.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.605),(78.515,3.775),(78.685,3.775),(78.685,3.605),(78.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.265),(78.005,3.435),(78.175,3.435),(78.175,3.265),(78.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,4.965),(74.225,5.135),(74.395,5.135),(74.395,4.965),(74.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.105),(59.315,12.275),(59.485,12.275),(59.485,12.105),(59.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.105),(59.825,12.275),(59.995,12.275),(59.995,12.105),(59.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.445),(59.825,12.615),(59.995,12.615),(59.995,12.445),(59.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.445),(59.315,12.615),(59.485,12.615),(59.485,12.445),(59.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.785),(59.315,12.955),(59.485,12.955),(59.485,12.785),(59.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,12.785),(59.825,12.955),(59.995,12.955),(59.995,12.785),(59.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,3.945),(25.715,4.115),(25.885,4.115),(25.885,3.945),(25.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,3.945),(25.205,4.115),(25.375,4.115),(25.375,3.945),(25.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,12.105),(11.825,12.275),(11.995,12.275),(11.995,12.105),(11.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.985),(7.025,6.155),(7.195,6.155),(7.195,5.985),(7.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.265),(74.225,3.435),(74.395,3.435),(74.395,3.265),(74.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.605),(74.225,3.775),(74.395,3.775),(74.395,3.605),(74.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.605),(45.425,3.775),(45.595,3.775),(45.595,3.605),(45.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.265),(45.425,3.435),(45.595,3.435),(45.595,3.265),(45.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.305),(16.625,5.475),(16.795,5.475),(16.795,5.305),(16.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.645),(16.115,5.815),(16.285,5.815),(16.285,5.645),(16.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,5.305),(16.115,5.475),(16.285,5.475),(16.285,5.305),(16.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,5.645),(16.625,5.815),(16.795,5.815),(16.795,5.645),(16.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.625),(64.625,4.795),(64.795,4.795),(64.795,4.625),(64.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.285),(64.625,4.455),(64.795,4.455),(64.795,4.285),(64.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.125),(79.025,13.295),(79.195,13.295),(79.195,13.125),(79.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.465),(79.025,13.635),(79.195,13.635),(79.195,13.465),(79.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,13.805),(79.025,13.975),(79.195,13.975),(79.195,13.805),(79.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.625),(64.115,4.795),(64.285,4.795),(64.285,4.625),(64.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.445),(79.025,12.615),(79.195,12.615),(79.195,12.445),(79.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.785),(79.025,12.955),(79.195,12.955),(79.195,12.785),(79.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.225),(40.625,18.395),(40.795,18.395),(40.795,18.225),(40.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.225),(40.115,18.395),(40.285,18.395),(40.285,18.225),(40.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,12.105),(79.025,12.275),(79.195,12.275),(79.195,12.105),(79.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.565),(40.625,18.735),(40.795,18.735),(40.795,18.565),(40.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.565),(40.115,18.735),(40.285,18.735),(40.285,18.565),(40.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.285),(45.425,4.455),(45.595,4.455),(45.595,4.285),(45.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.625),(45.425,4.795),(45.595,4.795),(45.595,4.625),(45.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.665),(73.715,6.835),(73.885,6.835),(73.885,6.665),(73.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.665),(73.205,6.835),(73.375,6.835),(73.375,6.665),(73.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,6.325),(73.205,6.495),(73.375,6.495),(73.375,6.325),(73.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,6.325),(73.715,6.495),(73.885,6.495),(73.885,6.325),(73.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.305),(74.225,5.475),(74.395,5.475),(74.395,5.305),(74.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,5.645),(74.225,5.815),(74.395,5.815),(74.395,5.645),(74.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.305),(35.315,5.475),(35.485,5.475),(35.485,5.305),(35.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.645),(35.315,5.815),(35.485,5.815),(35.485,5.645),(35.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.645),(35.825,5.815),(35.995,5.815),(35.995,5.645),(35.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.505),(68.405,15.675),(68.575,15.675),(68.575,15.505),(68.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.305),(35.825,5.475),(35.995,5.475),(35.995,5.305),(35.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.165),(68.405,15.335),(68.575,15.335),(68.575,15.165),(68.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.145),(16.115,14.315),(16.285,14.315),(16.285,14.145),(16.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.145),(16.625,14.315),(16.795,14.315),(16.795,14.145),(16.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.485),(16.115,14.655),(16.285,14.655),(16.285,14.485),(16.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,14.825),(16.115,14.995),(16.285,14.995),(16.285,14.825),(16.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.485),(16.625,14.655),(16.795,14.655),(16.795,14.485),(16.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,14.825),(16.625,14.995),(16.795,14.995),(16.795,14.825),(16.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.885),(34.805,18.055),(34.975,18.055),(34.975,17.885),(34.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.505),(20.405,15.675),(20.575,15.675),(20.575,15.505),(20.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.165),(20.405,15.335),(20.575,15.335),(20.575,15.165),(20.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.985),(58.805,6.155),(58.975,6.155),(58.975,5.985),(58.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.945),(49.205,4.115),(49.375,4.115),(49.375,3.945),(49.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.945),(49.715,4.115),(49.885,4.115),(49.885,3.945),(49.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.865),(40.115,17.035),(40.285,17.035),(40.285,16.865),(40.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.865),(40.625,17.035),(40.795,17.035),(40.795,16.865),(40.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.545),(25.715,17.715),(25.885,17.715),(25.885,17.545),(25.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,17.205),(25.715,17.375),(25.885,17.375),(25.885,17.205),(25.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.205),(25.205,17.375),(25.375,17.375),(25.375,17.205),(25.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,17.545),(25.205,17.715),(25.375,17.715),(25.375,17.545),(25.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.985),(34.805,6.155),(34.975,6.155),(34.975,5.985),(34.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.205),(7.025,17.375),(7.195,17.375),(7.195,17.205),(7.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,17.545),(7.025,17.715),(7.195,17.715),(7.195,17.545),(7.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.645),(59.315,5.815),(59.485,5.815),(59.485,5.645),(59.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.205),(63.605,17.375),(63.775,17.375),(63.775,17.205),(63.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.105),(50.225,12.275),(50.395,12.275),(50.395,12.105),(50.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,17.545),(63.605,17.715),(63.775,17.715),(63.775,17.545),(63.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.305),(59.315,5.475),(59.485,5.475),(59.485,5.305),(59.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.785),(50.225,12.955),(50.395,12.955),(50.395,12.785),(50.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.445),(50.225,12.615),(50.395,12.615),(50.395,12.445),(50.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.305),(59.825,5.475),(59.995,5.475),(59.995,5.305),(59.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,5.645),(59.825,5.815),(59.995,5.815),(59.995,5.645),(59.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.045),(55.025,9.215),(55.195,9.215),(55.195,9.045),(55.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.985),(31.025,6.155),(31.195,6.155),(31.195,5.985),(31.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,16.865),(20.405,17.035),(20.575,17.035),(20.575,16.865),(20.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.225),(30.005,18.395),(30.175,18.395),(30.175,18.225),(30.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.565),(30.005,18.735),(30.175,18.735),(30.175,18.565),(30.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.565),(30.515,18.735),(30.685,18.735),(30.685,18.565),(30.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.225),(30.515,18.395),(30.685,18.395),(30.685,18.225),(30.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.365),(45.425,8.535),(45.595,8.535),(45.595,8.365),(45.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.705),(45.425,8.875),(45.595,8.875),(45.595,8.705),(45.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.025),(45.425,8.195),(45.595,8.195),(45.595,8.025),(45.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.205),(11.315,17.375),(11.485,17.375),(11.485,17.205),(11.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,17.545),(11.315,17.715),(11.485,17.715),(11.485,17.545),(11.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.205),(11.825,17.375),(11.995,17.375),(11.995,17.205),(11.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,17.545),(11.825,17.715),(11.995,17.715),(11.995,17.545),(11.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.225),(68.915,18.395),(69.085,18.395),(69.085,18.225),(68.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,18.565),(68.915,18.735),(69.085,18.735),(69.085,18.565),(68.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.365),(69.425,8.535),(69.595,8.535),(69.595,8.365),(69.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.705),(69.425,8.875),(69.595,8.875),(69.595,8.705),(69.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,8.025),(69.425,8.195),(69.595,8.195),(69.595,8.025),(69.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.505),(55.025,15.675),(55.195,15.675),(55.195,15.505),(55.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.165),(55.025,15.335),(55.195,15.335),(55.195,15.165),(55.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.285),(16.625,4.455),(16.795,4.455),(16.795,4.285),(16.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.285),(16.115,4.455),(16.285,4.455),(16.285,4.285),(16.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.625),(16.115,4.795),(16.285,4.795),(16.285,4.625),(16.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.625),(16.625,4.795),(16.795,4.795),(16.795,4.625),(16.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.485),(20.915,14.655),(21.085,14.655),(21.085,14.485),(20.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.825),(20.915,14.995),(21.085,14.995),(21.085,14.825),(20.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.105),(31.025,12.275),(31.195,12.275),(31.195,12.105),(31.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.445),(31.025,12.615),(31.195,12.615),(31.195,12.445),(31.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.785),(31.025,12.955),(31.195,12.955),(31.195,12.785),(31.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,14.145),(20.915,14.315),(21.085,14.315),(21.085,14.145),(20.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.265),(73.715,3.435),(73.885,3.435),(73.885,3.265),(73.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.265),(73.205,3.435),(73.375,3.435),(73.375,3.265),(73.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,3.605),(73.205,3.775),(73.375,3.775),(73.375,3.605),(73.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.605),(68.405,3.775),(68.575,3.775),(68.575,3.605),(68.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,3.265),(68.405,3.435),(68.575,3.435),(68.575,3.265),(68.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,3.605),(73.715,3.775),(73.885,3.775),(73.885,3.605),(73.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.125),(73.205,13.295),(73.375,13.295),(73.375,13.125),(73.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.305),(44.915,5.475),(45.085,5.475),(45.085,5.305),(44.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.645),(44.915,5.815),(45.085,5.815),(45.085,5.645),(44.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.165),(50.225,15.335),(50.395,15.335),(50.395,15.165),(50.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.505),(50.225,15.675),(50.395,15.675),(50.395,15.505),(50.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.505),(59.825,15.675),(59.995,15.675),(59.995,15.505),(59.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.505),(59.315,15.675),(59.485,15.675),(59.485,15.505),(59.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,15.165),(59.825,15.335),(59.995,15.335),(59.995,15.165),(59.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.165),(59.315,15.335),(59.485,15.335),(59.485,15.165),(59.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,3.945),(78.515,4.115),(78.685,4.115),(78.685,3.945),(78.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,3.945),(78.005,4.115),(78.175,4.115),(78.175,3.945),(78.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.885),(44.405,18.055),(44.575,18.055),(44.575,17.885),(44.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.165),(11.315,15.335),(11.485,15.335),(11.485,15.165),(11.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.165),(11.825,15.335),(11.995,15.335),(11.995,15.165),(11.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,15.505),(11.315,15.675),(11.485,15.675),(11.485,15.505),(11.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,15.505),(11.825,15.675),(11.995,15.675),(11.995,15.505),(11.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.145),(83.315,14.315),(83.485,14.315),(83.485,14.145),(83.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.485),(83.315,14.655),(83.485,14.655),(83.485,14.485),(83.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,14.825),(83.315,14.995),(83.485,14.995),(83.485,14.825),(83.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.685),(21.425,7.855),(21.595,7.855),(21.595,7.685),(21.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.605),(44.405,3.775),(44.575,3.775),(44.575,3.605),(44.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.265),(44.405,3.435),(44.575,3.435),(44.575,3.265),(44.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.725),(73.205,9.895),(73.375,9.895),(73.375,9.725),(73.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.725),(73.715,9.895),(73.885,9.895),(73.885,9.725),(73.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,9.385),(73.715,9.555),(73.885,9.555),(73.885,9.385),(73.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,9.385),(73.205,9.555),(73.375,9.555),(73.375,9.385),(73.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.285),(40.625,4.455),(40.795,4.455),(40.795,4.285),(40.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.285),(40.115,4.455),(40.285,4.455),(40.285,4.285),(40.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.625),(40.625,4.795),(40.795,4.795),(40.795,4.625),(40.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.625),(40.115,4.795),(40.285,4.795),(40.285,4.625),(40.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,3.945),(74.225,4.115),(74.395,4.115),(74.395,3.945),(74.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.385),(25.715,9.555),(25.885,9.555),(25.885,9.385),(25.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.385),(25.205,9.555),(25.375,9.555),(25.375,9.385),(25.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,9.725),(25.715,9.895),(25.885,9.895),(25.885,9.725),(25.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,9.725),(25.205,9.895),(25.375,9.895),(25.375,9.725),(25.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.725),(20.405,9.895),(20.575,9.895),(20.575,9.725),(20.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,9.385),(20.405,9.555),(20.575,9.555),(20.575,9.385),(20.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,9.045),(78.005,9.215),(78.175,9.215),(78.175,9.045),(78.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,9.045),(78.515,9.215),(78.685,9.215),(78.685,9.045),(78.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,15.845),(68.405,16.015),(68.575,16.015),(68.575,15.845),(68.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,16.865),(10.805,17.035),(10.975,17.035),(10.975,16.865),(10.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,15.845),(20.405,16.015),(20.575,16.015),(20.575,15.845),(20.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.645),(64.625,5.815),(64.795,5.815),(64.795,5.645),(64.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.305),(64.115,5.475),(64.285,5.475),(64.285,5.305),(64.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,5.305),(64.625,5.475),(64.795,5.475),(64.795,5.305),(64.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,5.645),(64.115,5.815),(64.285,5.815),(64.285,5.645),(64.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,16.865),(25.715,17.035),(25.885,17.035),(25.885,16.865),(25.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,16.865),(25.205,17.035),(25.375,17.035),(25.375,16.865),(25.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,16.865),(7.025,17.035),(7.195,17.035),(7.195,16.865),(7.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.885),(31.025,18.055),(31.195,18.055),(31.195,17.885),(31.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.805),(20.405,13.975),(20.575,13.975),(20.575,13.805),(20.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.465),(20.405,13.635),(20.575,13.635),(20.575,13.465),(20.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,13.125),(20.405,13.295),(20.575,13.295),(20.575,13.125),(20.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.305),(78.515,5.475),(78.685,5.475),(78.685,5.305),(78.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,5.645),(78.515,5.815),(78.685,5.815),(78.685,5.645),(78.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.305),(78.005,5.475),(78.175,5.475),(78.175,5.305),(78.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,5.645),(78.005,5.815),(78.175,5.815),(78.175,5.645),(78.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.265),(50.225,3.435),(50.395,3.435),(50.395,3.265),(50.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.305),(54.515,5.475),(54.685,5.475),(54.685,5.305),(54.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.645),(54.515,5.815),(54.685,5.815),(54.685,5.645),(54.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.605),(50.225,3.775),(50.395,3.775),(50.395,3.605),(50.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.305),(54.005,5.475),(54.175,5.475),(54.175,5.305),(54.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.645),(54.005,5.815),(54.175,5.815),(54.175,5.645),(54.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.145),(64.625,14.315),(64.795,14.315),(64.795,14.145),(64.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.145),(64.115,14.315),(64.285,14.315),(64.285,14.145),(64.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.485),(64.115,14.655),(64.285,14.655),(64.285,14.485),(64.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,14.825),(64.115,14.995),(64.285,14.995),(64.285,14.825),(64.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.485),(64.625,14.655),(64.795,14.655),(64.795,14.485),(64.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,14.825),(64.625,14.995),(64.795,14.995),(64.795,14.825),(64.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.145),(55.025,14.315),(55.195,14.315),(55.195,14.145),(55.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.485),(55.025,14.655),(55.195,14.655),(55.195,14.485),(55.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.165),(30.515,15.335),(30.685,15.335),(30.685,15.165),(30.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.165),(30.005,15.335),(30.175,15.335),(30.175,15.165),(30.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.505),(30.515,15.675),(30.685,15.675),(30.685,15.505),(30.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.505),(30.005,15.675),(30.175,15.675),(30.175,15.505),(30.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.825),(55.025,14.995),(55.195,14.995),(55.195,14.825),(55.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.305),(6.515,5.475),(6.685,5.475),(6.685,5.305),(6.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,5.645),(6.515,5.815),(6.685,5.815),(6.685,5.645),(6.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,16.865),(78.005,17.035),(78.175,17.035),(78.175,16.865),(78.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,16.865),(78.515,17.035),(78.685,17.035),(78.685,16.865),(78.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,18.905),(15.605,19.075),(15.775,19.075),(15.775,18.905),(15.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.985),(82.805,6.155),(82.975,6.155),(82.975,5.985),(82.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.485),(7.025,14.655),(7.195,14.655),(7.195,14.485),(7.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.825),(7.025,14.995),(7.195,14.995),(7.195,14.825),(7.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,14.145),(7.025,14.315),(7.195,14.315),(7.195,14.145),(7.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,3.945),(69.425,4.115),(69.595,4.115),(69.595,3.945),(69.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.445),(68.915,12.615),(69.085,12.615),(69.085,12.445),(68.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.785),(68.915,12.955),(69.085,12.955),(69.085,12.785),(68.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,12.105),(68.915,12.275),(69.085,12.275),(69.085,12.105),(68.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.085),(79.025,11.255),(79.195,11.255),(79.195,11.085),(79.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.765),(79.025,11.935),(79.195,11.935),(79.195,11.765),(79.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,19.245),(25.205,19.415),(25.375,19.415),(25.375,19.245),(25.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.945),(40.625,4.115),(40.795,4.115),(40.795,3.945),(40.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.945),(40.115,4.115),(40.285,4.115),(40.285,3.945),(40.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,19.245),(25.715,19.415),(25.885,19.415),(25.885,19.245),(25.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,11.425),(79.025,11.595),(79.195,11.595),(79.195,11.425),(79.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.845),(50.225,16.015),(50.395,16.015),(50.395,15.845),(50.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.045),(30.515,9.215),(30.685,9.215),(30.685,9.045),(30.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.045),(30.005,9.215),(30.175,9.215),(30.175,9.045),(30.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.105),(20.915,12.275),(21.085,12.275),(21.085,12.105),(20.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.445),(20.915,12.615),(21.085,12.615),(21.085,12.445),(20.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,12.785),(20.915,12.955),(21.085,12.955),(21.085,12.785),(20.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.425),(30.005,11.595),(30.175,11.595),(30.175,11.425),(30.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.425),(30.515,11.595),(30.685,11.595),(30.685,11.425),(30.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.085),(30.005,11.255),(30.175,11.255),(30.175,11.085),(30.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.085),(30.515,11.255),(30.685,11.255),(30.685,11.085),(30.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,19.245),(10.805,19.415),(10.975,19.415),(10.975,19.245),(10.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,11.765),(30.005,11.935),(30.175,11.935),(30.175,11.765),(30.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.765),(30.515,11.935),(30.685,11.935),(30.685,11.765),(30.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.025),(50.225,8.195),(50.395,8.195),(50.395,8.025),(50.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.705),(50.225,8.875),(50.395,8.875),(50.395,8.705),(50.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.365),(50.225,8.535),(50.395,8.535),(50.395,8.365),(50.225,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.485),(35.825,14.655),(35.995,14.655),(35.995,14.485),(35.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.825),(35.825,14.995),(35.995,14.995),(35.995,14.825),(35.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.485),(35.315,14.655),(35.485,14.655),(35.485,14.485),(35.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.825),(35.315,14.995),(35.485,14.995),(35.485,14.825),(35.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.305),(83.315,5.475),(83.485,5.475),(83.485,5.305),(83.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,5.645),(83.315,5.815),(83.485,5.815),(83.485,5.645),(83.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.165),(44.405,15.335),(44.575,15.335),(44.575,15.165),(44.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.505),(44.405,15.675),(44.575,15.675),(44.575,15.505),(44.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.145),(35.825,14.315),(35.995,14.315),(35.995,14.145),(35.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.505),(10.805,15.675),(10.975,15.675),(10.975,15.505),(10.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,15.165),(10.805,15.335),(10.975,15.335),(10.975,15.165),(10.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.065),(50.225,10.235),(50.395,10.235),(50.395,10.065),(50.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.745),(50.225,10.915),(50.395,10.915),(50.395,10.745),(50.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.405),(50.225,10.575),(50.395,10.575),(50.395,10.405),(50.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.305),(30.515,5.475),(30.685,5.475),(30.685,5.305),(30.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.645),(30.005,5.815),(30.175,5.815),(30.175,5.645),(30.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,5.305),(30.005,5.475),(30.175,5.475),(30.175,5.305),(30.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.645),(30.515,5.815),(30.685,5.815),(30.685,5.645),(30.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,9.045),(15.605,9.215),(15.775,9.215),(15.775,9.045),(15.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.785),(30.515,12.955),(30.685,12.955),(30.685,12.785),(30.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.445),(30.515,12.615),(30.685,12.615),(30.685,12.445),(30.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.105),(30.515,12.275),(30.685,12.275),(30.685,12.105),(30.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.105),(30.005,12.275),(30.175,12.275),(30.175,12.105),(30.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.785),(30.005,12.955),(30.175,12.955),(30.175,12.785),(30.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,12.445),(30.005,12.615),(30.175,12.615),(30.175,12.445),(30.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,19.245),(78.005,19.415),(78.175,19.415),(78.175,19.245),(78.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,19.245),(78.515,19.415),(78.685,19.415),(78.685,19.245),(78.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.245),(55.025,19.415),(55.195,19.415),(55.195,19.245),(55.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.425),(25.715,11.595),(25.885,11.595),(25.885,11.425),(25.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.425),(25.205,11.595),(25.375,11.595),(25.375,11.425),(25.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.085),(25.205,11.255),(25.375,11.255),(25.375,11.085),(25.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.085),(25.715,11.255),(25.885,11.255),(25.885,11.085),(25.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,3.945),(16.625,4.115),(16.795,4.115),(16.795,3.945),(16.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,11.765),(25.715,11.935),(25.885,11.935),(25.885,11.765),(25.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,11.765),(25.205,11.935),(25.375,11.935),(25.375,11.765),(25.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,3.945),(16.115,4.115),(16.285,4.115),(16.285,3.945),(16.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.505),(15.605,15.675),(15.775,15.675),(15.775,15.505),(15.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,15.165),(15.605,15.335),(15.775,15.335),(15.775,15.165),(15.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.765),(31.025,11.935),(31.195,11.935),(31.195,11.765),(31.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.085),(31.025,11.255),(31.195,11.255),(31.195,11.085),(31.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.425),(31.025,11.595),(31.195,11.595),(31.195,11.425),(31.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.525),(82.805,16.695),(82.975,16.695),(82.975,16.525),(82.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,16.185),(82.805,16.355),(82.975,16.355),(82.975,16.185),(82.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.905),(58.805,19.075),(58.975,19.075),(58.975,18.905),(58.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.625),(11.315,4.795),(11.485,4.795),(11.485,4.625),(11.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.625),(11.825,4.795),(11.995,4.795),(11.995,4.625),(11.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,4.285),(11.825,4.455),(11.995,4.455),(11.995,4.285),(11.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,4.285),(11.315,4.455),(11.485,4.455),(11.485,4.285),(11.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.645),(68.915,5.815),(69.085,5.815),(69.085,5.645),(68.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,5.305),(68.915,5.475),(69.085,5.475),(69.085,5.305),(68.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.105),(58.805,12.275),(58.975,12.275),(58.975,12.105),(58.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.785),(58.805,12.955),(58.975,12.955),(58.975,12.785),(58.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.445),(58.805,12.615),(58.975,12.615),(58.975,12.445),(58.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.485),(68.915,14.655),(69.085,14.655),(69.085,14.485),(68.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.825),(68.915,14.995),(69.085,14.995),(69.085,14.825),(68.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,14.145),(68.915,14.315),(69.085,14.315),(69.085,14.145),(68.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.505),(68.915,15.675),(69.085,15.675),(69.085,15.505),(68.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.305),(10.805,5.475),(10.975,5.475),(10.975,5.305),(10.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,5.645),(10.805,5.815),(10.975,5.815),(10.975,5.645),(10.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,15.165),(68.915,15.335),(69.085,15.335),(69.085,15.165),(68.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,9.045),(63.605,9.215),(63.775,9.215),(63.775,9.045),(63.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,15.845),(30.005,16.015),(30.175,16.015),(30.175,15.845),(30.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.845),(30.515,16.015),(30.685,16.015),(30.685,15.845),(30.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.445),(10.805,12.615),(10.975,12.615),(10.975,12.445),(10.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.785),(10.805,12.955),(10.975,12.955),(10.975,12.785),(10.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,12.105),(10.805,12.275),(10.975,12.275),(10.975,12.105),(10.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.605),(15.605,3.775),(15.775,3.775),(15.775,3.605),(15.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,3.265),(15.605,3.435),(15.775,3.435),(15.775,3.265),(15.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.165),(20.915,15.335),(21.085,15.335),(21.085,15.165),(20.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,15.505),(20.915,15.675),(21.085,15.675),(21.085,15.505),(20.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.945),(50.225,4.115),(50.395,4.115),(50.395,3.945),(50.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.005),(26.225,7.175),(26.395,7.175),(26.395,7.005),(26.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,7.345),(26.225,7.515),(26.395,7.515),(26.395,7.345),(26.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.225),(69.425,18.395),(69.595,18.395),(69.595,18.225),(69.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,18.565),(69.425,18.735),(69.595,18.735),(69.595,18.565),(69.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,19.245),(16.115,19.415),(16.285,19.415),(16.285,19.245),(16.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,19.245),(16.625,19.415),(16.795,19.415),(16.795,19.245),(16.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.505),(63.605,15.675),(63.775,15.675),(63.775,15.505),(63.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,15.165),(63.605,15.335),(63.775,15.335),(63.775,15.165),(63.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.205),(26.225,17.375),(26.395,17.375),(26.395,17.205),(26.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,17.545),(26.225,17.715),(26.395,17.715),(26.395,17.545),(26.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.125),(25.205,13.295),(25.375,13.295),(25.375,13.125),(25.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.385),(54.515,9.555),(54.685,9.555),(54.685,9.385),(54.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.725),(54.515,9.895),(54.685,9.895),(54.685,9.725),(54.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.385),(54.005,9.555),(54.175,9.555),(54.175,9.385),(54.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.725),(54.005,9.895),(54.175,9.895),(54.175,9.725),(54.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.145),(11.825,14.315),(11.995,14.315),(11.995,14.145),(11.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.145),(11.315,14.315),(11.485,14.315),(11.485,14.145),(11.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.485),(11.315,14.655),(11.485,14.655),(11.485,14.485),(11.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,14.825),(11.315,14.995),(11.485,14.995),(11.485,14.825),(11.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.485),(11.825,14.655),(11.995,14.655),(11.995,14.485),(11.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,14.825),(11.825,14.995),(11.995,14.995),(11.995,14.825),(11.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.165),(58.805,15.335),(58.975,15.335),(58.975,15.165),(58.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.385),(6.515,9.555),(6.685,9.555),(6.685,9.385),(6.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,9.725),(6.515,9.895),(6.685,9.895),(6.685,9.725),(6.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.505),(58.805,15.675),(58.975,15.675),(58.975,15.505),(58.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.385),(44.405,9.555),(44.575,9.555),(44.575,9.385),(44.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.725),(44.405,9.895),(44.575,9.895),(44.575,9.725),(44.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.165),(78.005,15.335),(78.175,15.335),(78.175,15.165),(78.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.165),(78.515,15.335),(78.685,15.335),(78.685,15.165),(78.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.505),(78.515,15.675),(78.685,15.675),(78.685,15.505),(78.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.505),(78.005,15.675),(78.175,15.675),(78.175,15.505),(78.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,14.485),(74.225,14.655),(74.395,14.655),(74.395,14.485),(74.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,5.985),(69.425,6.155),(69.595,6.155),(69.595,5.985),(69.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.385),(68.405,9.555),(68.575,9.555),(68.575,9.385),(68.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,9.725),(68.405,9.895),(68.575,9.895),(68.575,9.725),(68.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.045),(49.205,9.215),(49.375,9.215),(49.375,9.045),(49.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.045),(49.715,9.215),(49.885,9.215),(49.885,9.045),(49.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.845),(44.405,16.015),(44.575,16.015),(44.575,15.845),(44.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,5.985),(21.425,6.155),(21.595,6.155),(21.595,5.985),(21.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.185),(69.425,16.355),(69.595,16.355),(69.595,16.185),(69.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,16.525),(69.425,16.695),(69.595,16.695),(69.595,16.525),(69.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.565),(34.805,18.735),(34.975,18.735),(34.975,18.565),(34.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.225),(34.805,18.395),(34.975,18.395),(34.975,18.225),(34.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.525),(63.605,16.695),(63.775,16.695),(63.775,16.525),(63.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,16.185),(63.605,16.355),(63.775,16.355),(63.775,16.185),(63.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.125),(44.405,13.295),(44.575,13.295),(44.575,13.125),(44.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.465),(44.405,13.635),(44.575,13.635),(44.575,13.465),(44.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.565),(35.825,18.735),(35.995,18.735),(35.995,18.565),(35.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.225),(35.825,18.395),(35.995,18.395),(35.995,18.225),(35.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.085),(78.005,11.255),(78.175,11.255),(78.175,11.085),(78.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.085),(78.515,11.255),(78.685,11.255),(78.685,11.085),(78.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.765),(78.515,11.935),(78.685,11.935),(78.685,11.765),(78.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.765),(78.005,11.935),(78.175,11.935),(78.175,11.765),(78.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.225),(35.315,18.395),(35.485,18.395),(35.485,18.225),(35.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.565),(35.315,18.735),(35.485,18.735),(35.485,18.565),(35.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,11.425),(78.515,11.595),(78.685,11.595),(78.685,11.425),(78.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,11.425),(78.005,11.595),(78.175,11.595),(78.175,11.425),(78.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.625),(59.315,4.795),(59.485,4.795),(59.485,4.625),(59.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.285),(59.825,4.455),(59.995,4.455),(59.995,4.285),(59.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,4.625),(59.825,4.795),(59.995,4.795),(59.995,4.625),(59.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.285),(59.315,4.455),(59.485,4.455),(59.485,4.285),(59.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.145),(6.515,14.315),(6.685,14.315),(6.685,14.145),(6.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.825),(6.515,14.995),(6.685,14.995),(6.685,14.825),(6.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,14.485),(6.515,14.655),(6.685,14.655),(6.685,14.485),(6.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.125),(68.405,13.295),(68.575,13.295),(68.575,13.125),(68.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.465),(68.405,13.635),(68.575,13.635),(68.575,13.465),(68.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,13.805),(68.405,13.975),(68.575,13.975),(68.575,13.805),(68.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.205),(73.205,17.375),(73.375,17.375),(73.375,17.205),(73.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.545),(73.715,17.715),(73.885,17.715),(73.885,17.545),(73.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,17.205),(73.715,17.375),(73.885,17.375),(73.885,17.205),(73.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,17.545),(73.205,17.715),(73.375,17.715),(73.375,17.545),(73.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.205),(34.805,17.375),(34.975,17.375),(34.975,17.205),(34.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.545),(34.805,17.715),(34.975,17.715),(34.975,17.545),(34.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.345),(21.425,7.515),(21.595,7.515),(21.595,7.345),(21.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.645),(25.205,5.815),(25.375,5.815),(25.375,5.645),(25.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,5.305),(25.205,5.475),(25.375,5.475),(25.375,5.305),(25.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.305),(25.715,5.475),(25.885,5.475),(25.885,5.305),(25.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,5.645),(25.715,5.815),(25.885,5.815),(25.885,5.645),(25.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,7.005),(21.425,7.175),(21.595,7.175),(21.595,7.005),(21.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.305),(58.805,5.475),(58.975,5.475),(58.975,5.305),(58.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.645),(58.805,5.815),(58.975,5.815),(58.975,5.645),(58.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.825),(44.915,14.995),(45.085,14.995),(45.085,14.825),(44.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.485),(44.915,14.655),(45.085,14.655),(45.085,14.485),(44.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.865),(30.515,17.035),(30.685,17.035),(30.685,16.865),(30.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,16.865),(30.005,17.035),(30.175,17.035),(30.175,16.865),(30.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.305),(34.805,5.475),(34.975,5.475),(34.975,5.305),(34.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.645),(34.805,5.815),(34.975,5.815),(34.975,5.645),(34.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,16.865),(68.405,17.035),(68.575,17.035),(68.575,16.865),(68.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.925),(55.025,3.095),(55.195,3.095),(55.195,2.925),(55.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.445),(78.515,12.615),(78.685,12.615),(78.685,12.445),(78.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.445),(78.005,12.615),(78.175,12.615),(78.175,12.445),(78.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.785),(78.005,12.955),(78.175,12.955),(78.175,12.785),(78.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.785),(78.515,12.955),(78.685,12.955),(78.685,12.785),(78.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.725),(26.225,9.895),(26.395,9.895),(26.395,9.725),(26.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,9.385),(26.225,9.555),(26.395,9.555),(26.395,9.385),(26.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,12.105),(78.005,12.275),(78.175,12.275),(78.175,12.105),(78.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,12.105),(78.515,12.275),(78.685,12.275),(78.685,12.105),(78.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.225),(26.225,18.395),(26.395,18.395),(26.395,18.225),(26.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,18.565),(26.225,18.735),(26.395,18.735),(26.395,18.565),(26.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.945),(39.605,4.115),(39.775,4.115),(39.775,3.945),(39.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,2.925),(7.025,3.095),(7.195,3.095),(7.195,2.925),(7.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.385),(39.605,9.555),(39.775,9.555),(39.775,9.385),(39.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.725),(39.605,9.895),(39.775,9.895),(39.775,9.725),(39.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,4.965),(68.915,5.135),(69.085,5.135),(69.085,4.965),(68.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.825),(59.825,14.995),(59.995,14.995),(59.995,14.825),(59.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.485),(59.825,14.655),(59.995,14.655),(59.995,14.485),(59.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.825),(59.315,14.995),(59.485,14.995),(59.485,14.825),(59.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.485),(59.315,14.655),(59.485,14.655),(59.485,14.485),(59.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,14.145),(59.825,14.315),(59.995,14.315),(59.995,14.145),(59.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,2.925),(74.225,3.095),(74.395,3.095),(74.395,2.925),(74.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,2.925),(11.315,3.095),(11.485,3.095),(11.485,2.925),(11.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,2.925),(11.825,3.095),(11.995,3.095),(11.995,2.925),(11.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.125),(20.915,13.295),(21.085,13.295),(21.085,13.125),(20.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.465),(20.915,13.635),(21.085,13.635),(21.085,13.465),(20.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,13.805),(20.915,13.975),(21.085,13.975),(21.085,13.805),(20.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.305),(49.715,5.475),(49.885,5.475),(49.885,5.305),(49.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.645),(49.715,5.815),(49.885,5.815),(49.885,5.645),(49.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.645),(49.205,5.815),(49.375,5.815),(49.375,5.645),(49.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,4.965),(20.915,5.135),(21.085,5.135),(21.085,4.965),(20.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.305),(49.205,5.475),(49.375,5.475),(49.375,5.305),(49.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,2.925),(26.225,3.095),(26.395,3.095),(26.395,2.925),(26.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,4.965),(79.025,5.135),(79.195,5.135),(79.195,4.965),(79.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.465),(39.605,13.635),(39.775,13.635),(39.775,13.465),(39.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.805),(39.605,13.975),(39.775,13.975),(39.775,13.805),(39.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.125),(39.605,13.295),(39.775,13.295),(39.775,13.125),(39.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.025),(79.025,8.195),(79.195,8.195),(79.195,8.025),(79.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.365),(79.025,8.535),(79.195,8.535),(79.195,8.365),(79.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,8.705),(79.025,8.875),(79.195,8.875),(79.195,8.705),(79.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,15.845),(78.005,16.015),(78.175,16.015),(78.175,15.845),(78.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,15.845),(78.515,16.015),(78.685,16.015),(78.685,15.845),(78.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.965),(55.025,5.135),(55.195,5.135),(55.195,4.965),(55.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,2.925),(25.715,3.095),(25.885,3.095),(25.885,2.925),(25.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,2.925),(25.205,3.095),(25.375,3.095),(25.375,2.925),(25.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,18.905),(68.405,19.075),(68.575,19.075),(68.575,18.905),(68.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,19.245),(30.005,19.415),(30.175,19.415),(30.175,19.245),(30.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.245),(30.515,19.415),(30.685,19.415),(30.685,19.245),(30.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.205),(44.405,17.375),(44.575,17.375),(44.575,17.205),(44.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.545),(44.405,17.715),(44.575,17.715),(44.575,17.545),(44.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,3.945),(63.605,4.115),(63.775,4.115),(63.775,3.945),(63.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.925),(31.025,3.095),(31.195,3.095),(31.195,2.925),(31.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,18.905),(78.515,19.075),(78.685,19.075),(78.685,18.905),(78.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,18.905),(78.005,19.075),(78.175,19.075),(78.175,18.905),(78.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,4.965),(7.025,5.135),(7.195,5.135),(7.195,4.965),(7.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.125),(35.315,13.295),(35.485,13.295),(35.485,13.125),(35.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.985),(39.605,6.155),(39.775,6.155),(39.775,5.985),(39.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.025),(58.805,8.195),(58.975,8.195),(58.975,8.025),(58.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.365),(58.805,8.535),(58.975,8.535),(58.975,8.365),(58.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.705),(58.805,8.875),(58.975,8.875),(58.975,8.705),(58.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,16.865),(83.315,17.035),(83.485,17.035),(83.485,16.865),(83.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,5.985),(15.605,6.155),(15.775,6.155),(15.775,5.985),(15.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.765),(73.715,11.935),(73.885,11.935),(73.885,11.765),(73.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.085),(73.715,11.255),(73.885,11.255),(73.885,11.085),(73.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.085),(73.205,11.255),(73.375,11.255),(73.375,11.085),(73.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.145),(34.805,14.315),(34.975,14.315),(34.975,14.145),(34.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.425),(73.205,11.595),(73.375,11.595),(73.375,11.425),(73.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,11.425),(73.715,11.595),(73.885,11.595),(73.885,11.425),(73.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.405),(58.805,10.575),(58.975,10.575),(58.975,10.405),(58.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.065),(58.805,10.235),(58.975,10.235),(58.975,10.065),(58.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,11.765),(73.205,11.935),(73.375,11.935),(73.375,11.765),(73.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,17.885),(83.315,18.055),(83.485,18.055),(83.485,17.885),(83.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.025),(10.805,8.195),(10.975,8.195),(10.975,8.025),(10.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.925),(45.425,3.095),(45.595,3.095),(45.595,2.925),(45.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.365),(10.805,8.535),(10.975,8.535),(10.975,8.365),(10.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,8.705),(10.805,8.875),(10.975,8.875),(10.975,8.705),(10.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.185),(74.225,16.355),(74.395,16.355),(74.395,16.185),(74.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,16.525),(74.225,16.695),(74.395,16.695),(74.395,16.525),(74.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.825),(54.005,14.995),(54.175,14.995),(54.175,14.825),(54.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.485),(54.005,14.655),(54.175,14.655),(54.175,14.485),(54.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.485),(54.515,14.655),(54.685,14.655),(54.685,14.485),(54.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.825),(54.515,14.995),(54.685,14.995),(54.685,14.825),(54.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.145),(54.005,14.315),(54.175,14.315),(54.175,14.145),(54.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.405),(10.805,10.575),(10.975,10.575),(10.975,10.405),(10.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.745),(10.805,10.915),(10.975,10.915),(10.975,10.745),(10.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,10.065),(10.805,10.235),(10.975,10.235),(10.975,10.065),(10.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.145),(15.605,14.315),(15.775,14.315),(15.775,14.145),(15.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.485),(15.605,14.655),(15.775,14.655),(15.775,14.485),(15.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,14.825),(15.605,14.995),(15.775,14.995),(15.775,14.825),(15.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.265),(10.805,3.435),(10.975,3.435),(10.975,3.265),(10.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.605),(10.805,3.775),(10.975,3.775),(10.975,3.605),(10.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.925),(50.225,3.095),(50.395,3.095),(50.395,2.925),(50.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,15.845),(64.115,16.015),(64.285,16.015),(64.285,15.845),(64.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,15.845),(64.625,16.015),(64.795,16.015),(64.795,15.845),(64.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.165),(44.915,15.335),(45.085,15.335),(45.085,15.165),(44.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.505),(44.915,15.675),(45.085,15.675),(45.085,15.505),(44.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.065),(25.205,10.235),(25.375,10.235),(25.375,10.065),(25.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.745),(25.715,10.915),(25.885,10.915),(25.885,10.745),(25.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.745),(25.205,10.915),(25.375,10.915),(25.375,10.745),(25.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.405),(25.715,10.575),(25.885,10.575),(25.885,10.405),(25.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,10.405),(25.205,10.575),(25.375,10.575),(25.375,10.405),(25.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,10.065),(25.715,10.235),(25.885,10.235),(25.885,10.065),(25.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.405),(31.025,10.575),(31.195,10.575),(31.195,10.405),(31.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.065),(31.025,10.235),(31.195,10.235),(31.195,10.065),(31.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.745),(31.025,10.915),(31.195,10.915),(31.195,10.745),(31.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,16.865),(73.205,17.035),(73.375,17.035),(73.375,16.865),(73.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.965),(31.025,5.135),(31.195,5.135),(31.195,4.965),(31.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,16.865),(73.715,17.035),(73.885,17.035),(73.885,16.865),(73.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,19.245),(7.025,19.415),(7.195,19.415),(7.195,19.245),(7.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.365),(31.025,8.535),(31.195,8.535),(31.195,8.365),(31.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.705),(31.025,8.875),(31.195,8.875),(31.195,8.705),(31.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.025),(31.025,8.195),(31.195,8.195),(31.195,8.025),(31.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,5.985),(63.605,6.155),(63.775,6.155),(63.775,5.985),(63.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.225),(79.025,18.395),(79.195,18.395),(79.195,18.225),(79.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,18.565),(79.025,18.735),(79.195,18.735),(79.195,18.565),(79.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.105),(44.915,12.275),(45.085,12.275),(45.085,12.105),(44.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.445),(44.915,12.615),(45.085,12.615),(45.085,12.445),(44.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.785),(44.915,12.955),(45.085,12.955),(45.085,12.785),(44.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.405),(30.005,10.575),(30.175,10.575),(30.175,10.405),(30.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,10.065),(30.005,10.235),(30.175,10.235),(30.175,10.065),(30.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.885),(49.205,18.055),(49.375,18.055),(49.375,17.885),(49.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.885),(49.715,18.055),(49.885,18.055),(49.885,17.885),(49.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.885),(74.225,18.055),(74.395,18.055),(74.395,17.885),(74.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.205),(45.425,17.375),(45.595,17.375),(45.595,17.205),(45.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.545),(45.425,17.715),(45.595,17.715),(45.595,17.545),(45.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,2.925),(59.825,3.095),(59.995,3.095),(59.995,2.925),(59.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.925),(59.315,3.095),(59.485,3.095),(59.485,2.925),(59.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.745),(20.405,10.915),(20.575,10.915),(20.575,10.745),(20.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.405),(20.405,10.575),(20.575,10.575),(20.575,10.405),(20.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,10.065),(20.405,10.235),(20.575,10.235),(20.575,10.065),(20.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.885),(82.805,18.055),(82.975,18.055),(82.975,17.885),(82.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.805),(50.225,13.975),(50.395,13.975),(50.395,13.805),(50.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.465),(50.225,13.635),(50.395,13.635),(50.395,13.465),(50.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.125),(50.225,13.295),(50.395,13.295),(50.395,13.125),(50.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.305),(82.805,5.475),(82.975,5.475),(82.975,5.305),(82.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,5.645),(82.805,5.815),(82.975,5.815),(82.975,5.645),(82.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.525),(64.625,16.695),(64.795,16.695),(64.795,16.525),(64.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,16.185),(64.625,16.355),(64.795,16.355),(64.795,16.185),(64.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.185),(64.115,16.355),(64.285,16.355),(64.285,16.185),(64.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,16.525),(64.115,16.695),(64.285,16.695),(64.285,16.525),(64.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.325),(7.025,6.495),(7.195,6.495),(7.195,6.325),(7.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,6.665),(7.025,6.835),(7.195,6.835),(7.195,6.665),(7.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,15.845),(16.625,16.015),(16.795,16.015),(16.795,15.845),(16.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,15.845),(16.115,16.015),(16.285,16.015),(16.285,15.845),(16.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.805),(78.515,13.975),(78.685,13.975),(78.685,13.805),(78.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.465),(78.005,13.635),(78.175,13.635),(78.175,13.465),(78.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.805),(78.005,13.975),(78.175,13.975),(78.175,13.805),(78.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.465),(78.515,13.635),(78.685,13.635),(78.685,13.465),(78.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,13.125),(78.005,13.295),(78.175,13.295),(78.175,13.125),(78.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((78.515,13.125),(78.515,13.295),(78.685,13.295),(78.685,13.125),(78.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.905),(44.915,19.075),(45.085,19.075),(45.085,18.905),(44.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.265),(58.805,3.435),(58.975,3.435),(58.975,3.265),(58.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.605),(58.805,3.775),(58.975,3.775),(58.975,3.605),(58.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,19.245),(83.315,19.415),(83.485,19.415),(83.485,19.245),(83.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.685),(69.425,7.855),(69.595,7.855),(69.595,7.685),(69.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.005),(69.425,7.175),(69.595,7.175),(69.595,7.005),(69.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.425,7.345),(69.425,7.515),(69.595,7.515),(69.595,7.345),(69.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.625),(73.715,4.795),(73.885,4.795),(73.885,4.625),(73.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,4.285),(73.715,4.455),(73.885,4.455),(73.885,4.285),(73.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.605),(34.805,3.775),(34.975,3.775),(34.975,3.605),(34.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.625),(73.205,4.795),(73.375,4.795),(73.375,4.625),(73.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.265),(34.805,3.435),(34.975,3.435),(34.975,3.265),(34.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,4.285),(73.205,4.455),(73.375,4.455),(73.375,4.285),(73.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.005),(20.405,7.175),(20.575,7.175),(20.575,7.005),(20.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,7.345),(20.405,7.515),(20.575,7.515),(20.575,7.345),(20.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.185),(44.915,16.355),(45.085,16.355),(45.085,16.185),(44.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.525),(44.915,16.695),(45.085,16.695),(45.085,16.525),(44.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.625),(25.205,4.795),(25.375,4.795),(25.375,4.625),(25.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,4.285),(25.205,4.455),(25.375,4.455),(25.375,4.285),(25.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.625),(25.715,4.795),(25.885,4.795),(25.885,4.625),(25.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,4.285),(25.715,4.455),(25.885,4.455),(25.885,4.285),(25.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.665),(31.025,6.835),(31.195,6.835),(31.195,6.665),(31.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.325),(31.025,6.495),(31.195,6.495),(31.195,6.325),(31.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.725),(74.225,9.895),(74.395,9.895),(74.395,9.725),(74.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,9.385),(74.225,9.555),(74.395,9.555),(74.395,9.385),(74.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.925),(49.205,3.095),(49.375,3.095),(49.375,2.925),(49.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.925),(49.715,3.095),(49.885,3.095),(49.885,2.925),(49.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,2.925),(79.025,3.095),(79.195,3.095),(79.195,2.925),(79.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,3.945),(10.805,4.115),(10.975,4.115),(10.975,3.945),(10.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.885),(35.825,18.055),(35.995,18.055),(35.995,17.885),(35.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.885),(35.315,18.055),(35.485,18.055),(35.485,17.885),(35.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.045),(40.115,9.215),(40.285,9.215),(40.285,9.045),(40.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,16.865),(21.425,17.035),(21.595,17.035),(21.595,16.865),(21.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.885),(44.915,18.055),(45.085,18.055),(45.085,17.885),(44.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.045),(40.625,9.215),(40.795,9.215),(40.795,9.045),(40.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.685),(44.405,7.855),(44.575,7.855),(44.575,7.685),(44.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.325),(45.425,6.495),(45.595,6.495),(45.595,6.325),(45.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.665),(45.425,6.835),(45.595,6.835),(45.595,6.665),(45.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.465),(30.515,13.635),(30.685,13.635),(30.685,13.465),(30.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.805),(30.515,13.975),(30.685,13.975),(30.685,13.805),(30.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.805),(30.005,13.975),(30.175,13.975),(30.175,13.805),(30.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,17.885),(21.425,18.055),(21.595,18.055),(21.595,17.885),(21.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.465),(30.005,13.635),(30.175,13.635),(30.175,13.465),(30.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,13.125),(30.005,13.295),(30.175,13.295),(30.175,13.125),(30.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.125),(30.515,13.295),(30.685,13.295),(30.685,13.125),(30.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.805),(44.915,13.975),(45.085,13.975),(45.085,13.805),(44.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.465),(44.915,13.635),(45.085,13.635),(45.085,13.465),(44.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.125),(44.915,13.295),(45.085,13.295),(45.085,13.125),(44.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,13.805),(11.825,13.975),(11.995,13.975),(11.995,13.805),(11.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,18.905),(10.805,19.075),(10.975,19.075),(10.975,18.905),(10.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.825),(63.605,14.995),(63.775,14.995),(63.775,14.825),(63.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.145),(63.605,14.315),(63.775,14.315),(63.775,14.145),(63.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.805),(68.915,13.975),(69.085,13.975),(69.085,13.805),(68.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.465),(68.915,13.635),(69.085,13.635),(69.085,13.465),(68.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,14.485),(63.605,14.655),(63.775,14.655),(63.775,14.485),(63.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,5.985),(11.315,6.155),(11.485,6.155),(11.485,5.985),(11.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,5.985),(11.825,6.155),(11.995,6.155),(11.995,5.985),(11.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.325),(20.915,6.495),(21.085,6.495),(21.085,6.325),(20.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,6.665),(20.915,6.835),(21.085,6.835),(21.085,6.665),(20.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,13.125),(68.915,13.295),(69.085,13.295),(69.085,13.125),(68.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.925),(44.405,3.095),(44.575,3.095),(44.575,2.925),(44.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,19.245),(21.425,19.415),(21.595,19.415),(21.595,19.245),(21.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.425),(64.115,11.595),(64.285,11.595),(64.285,11.425),(64.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.425),(64.625,11.595),(64.795,11.595),(64.795,11.425),(64.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.085),(64.115,11.255),(64.285,11.255),(64.285,11.085),(64.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.085),(64.625,11.255),(64.795,11.255),(64.795,11.085),(64.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,11.765),(64.115,11.935),(64.285,11.935),(64.285,11.765),(64.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,11.765),(64.625,11.935),(64.795,11.935),(64.795,11.765),(64.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.405),(79.025,10.575),(79.195,10.575),(79.195,10.405),(79.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.745),(79.025,10.915),(79.195,10.915),(79.195,10.745),(79.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,10.065),(79.025,10.235),(79.195,10.235),(79.195,10.065),(79.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,2.925),(73.205,3.095),(73.375,3.095),(73.375,2.925),(73.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,2.925),(73.715,3.095),(73.885,3.095),(73.885,2.925),(73.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.685),(54.515,7.855),(54.685,7.855),(54.685,7.685),(54.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.685),(54.005,7.855),(54.175,7.855),(54.175,7.685),(54.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.325),(20.405,6.495),(20.575,6.495),(20.575,6.325),(20.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,6.665),(20.405,6.835),(20.575,6.835),(20.575,6.665),(20.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.385),(35.825,9.555),(35.995,9.555),(35.995,9.385),(35.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.725),(35.825,9.895),(35.995,9.895),(35.995,9.725),(35.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.385),(35.315,9.555),(35.485,9.555),(35.485,9.385),(35.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.725),(35.315,9.895),(35.485,9.895),(35.485,9.725),(35.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,19.245),(20.915,19.415),(21.085,19.415),(21.085,19.245),(20.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.345),(6.515,7.515),(6.685,7.515),(6.685,7.345),(6.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.685),(6.515,7.855),(6.685,7.855),(6.685,7.685),(6.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,7.005),(6.515,7.175),(6.685,7.175),(6.685,7.005),(6.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.125),(10.805,13.295),(10.975,13.295),(10.975,13.125),(10.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.465),(10.805,13.635),(10.975,13.635),(10.975,13.465),(10.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,13.805),(10.805,13.975),(10.975,13.975),(10.975,13.805),(10.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,3.945),(20.405,4.115),(20.575,4.115),(20.575,3.945),(20.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,16.865),(15.605,17.035),(15.775,17.035),(15.775,16.865),(15.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.505),(49.715,15.675),(49.885,15.675),(49.885,15.505),(49.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.165),(49.715,15.335),(49.885,15.335),(49.885,15.165),(49.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.165),(49.205,15.335),(49.375,15.335),(49.375,15.165),(49.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.505),(49.205,15.675),(49.375,15.675),(49.375,15.505),(49.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,4.965),(68.405,5.135),(68.575,5.135),(68.575,4.965),(68.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((20.405,4.965),(20.405,5.135),(20.575,5.135),(20.575,4.965),(20.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.865),(34.805,17.035),(34.975,17.035),(34.975,16.865),(34.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,18.905),(63.605,19.075),(63.775,19.075),(63.775,18.905),(63.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,16.865),(20.915,17.035),(21.085,17.035),(21.085,16.865),(20.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.745),(73.205,10.915),(73.375,10.915),(73.375,10.745),(73.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.745),(73.715,10.915),(73.885,10.915),(73.885,10.745),(73.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.405),(73.715,10.575),(73.885,10.575),(73.885,10.405),(73.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.405),(73.205,10.575),(73.375,10.575),(73.375,10.405),(73.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,10.065),(73.205,10.235),(73.375,10.235),(73.375,10.065),(73.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,10.065),(73.715,10.235),(73.885,10.235),(73.885,10.065),(73.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.945),(58.805,4.115),(58.975,4.115),(58.975,3.945),(58.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.565),(31.025,18.735),(31.195,18.735),(31.195,18.565),(31.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.225),(31.025,18.395),(31.195,18.395),(31.195,18.225),(31.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.945),(34.805,4.115),(34.975,4.115),(34.975,3.945),(34.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,18.905),(83.315,19.075),(83.485,19.075),(83.485,18.905),(83.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,2.925),(20.915,3.095),(21.085,3.095),(21.085,2.925),(20.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.865),(35.315,17.035),(35.485,17.035),(35.485,16.865),(35.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.865),(35.825,17.035),(35.995,17.035),(35.995,16.865),(35.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.765),(16.625,11.935),(16.795,11.935),(16.795,11.765),(16.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.085),(16.115,11.255),(16.285,11.255),(16.285,11.085),(16.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.085),(16.625,11.255),(16.795,11.255),(16.795,11.085),(16.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.425),(16.115,11.595),(16.285,11.595),(16.285,11.425),(16.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,11.425),(16.625,11.595),(16.795,11.595),(16.795,11.425),(16.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,11.765),(16.115,11.935),(16.285,11.935),(16.285,11.765),(16.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,7.685),(30.005,7.855),(30.175,7.855),(30.175,7.685),(30.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.685),(30.515,7.855),(30.685,7.855),(30.685,7.685),(30.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.305),(31.025,5.475),(31.195,5.475),(31.195,5.305),(31.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.285),(6.515,4.455),(6.685,4.455),(6.685,4.285),(6.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((6.515,4.625),(6.515,4.795),(6.685,4.795),(6.685,4.625),(6.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.045),(50.225,9.215),(50.395,9.215),(50.395,9.045),(50.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,16.865),(26.225,17.035),(26.395,17.035),(26.395,16.865),(26.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.345),(64.115,7.515),(64.285,7.515),(64.285,7.345),(64.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.345),(64.625,7.515),(64.795,7.515),(64.795,7.345),(64.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.145),(82.805,14.315),(82.975,14.315),(82.975,14.145),(82.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,7.005),(64.625,7.175),(64.795,7.175),(64.795,7.005),(64.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,7.005),(64.115,7.175),(64.285,7.175),(64.285,7.005),(64.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.485),(82.805,14.655),(82.975,14.655),(82.975,14.485),(82.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,14.825),(82.805,14.995),(82.975,14.995),(82.975,14.825),(82.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.225),(74.225,18.395),(74.395,18.395),(74.395,18.225),(74.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,18.565),(74.225,18.735),(74.395,18.735),(74.395,18.565),(74.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.425),(50.225,11.595),(50.395,11.595),(50.395,11.425),(50.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.085),(50.225,11.255),(50.395,11.255),(50.395,11.085),(50.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.765),(50.225,11.935),(50.395,11.935),(50.395,11.765),(50.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.405),(68.405,10.575),(68.575,10.575),(68.575,10.405),(68.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.745),(68.405,10.915),(68.575,10.915),(68.575,10.745),(68.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((68.405,10.065),(68.405,10.235),(68.575,10.235),(68.575,10.065),(68.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,19.245),(73.205,19.415),(73.375,19.415),(73.375,19.245),(73.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,19.245),(73.715,19.415),(73.885,19.415),(73.885,19.245),(73.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.465),(73.205,13.635),(73.375,13.635),(73.375,13.465),(73.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,13.805),(73.205,13.975),(73.375,13.975),(73.375,13.805),(73.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.285),(49.715,4.455),(49.885,4.455),(49.885,4.285),(49.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.625),(49.715,4.795),(49.885,4.795),(49.885,4.625),(49.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.285),(49.205,4.455),(49.375,4.455),(49.375,4.285),(49.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.625),(49.205,4.795),(49.375,4.795),(49.375,4.625),(49.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.465),(73.715,13.635),(73.885,13.635),(73.885,13.465),(73.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,13.805),(73.715,13.975),(73.885,13.975),(73.885,13.805),(73.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,7.685),(10.805,7.855),(10.975,7.855),(10.975,7.685),(10.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.805),(25.715,13.975),(25.885,13.975),(25.885,13.805),(25.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,13.465),(25.205,13.635),(25.375,13.635),(25.375,13.465),(25.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,13.465),(25.715,13.635),(25.885,13.635),(25.885,13.465),(25.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.845),(40.115,16.015),(40.285,16.015),(40.285,15.845),(40.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.105),(39.605,12.275),(39.775,12.275),(39.775,12.105),(39.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.845),(40.625,16.015),(40.795,16.015),(40.795,15.845),(40.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.465),(58.805,13.635),(58.975,13.635),(58.975,13.465),(58.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.805),(58.805,13.975),(58.975,13.975),(58.975,13.805),(58.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.125),(58.805,13.295),(58.975,13.295),(58.975,13.125),(58.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.445),(39.605,12.615),(39.775,12.615),(39.775,12.445),(39.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.785),(39.605,12.955),(39.775,12.955),(39.775,12.785),(39.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.185),(79.025,16.355),(79.195,16.355),(79.195,16.185),(79.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,16.525),(79.025,16.695),(79.195,16.695),(79.195,16.525),(79.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.285),(30.005,4.455),(30.175,4.455),(30.175,4.285),(30.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,18.905),(21.425,19.075),(21.595,19.075),(21.595,18.905),(21.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,4.625),(30.005,4.795),(30.175,4.795),(30.175,4.625),(30.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.285),(30.515,4.455),(30.685,4.455),(30.685,4.285),(30.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.625),(30.515,4.795),(30.685,4.795),(30.685,4.625),(30.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.205),(79.025,17.375),(79.195,17.375),(79.195,17.205),(79.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((79.025,17.545),(79.025,17.715),(79.195,17.715),(79.195,17.545),(79.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,19.245),(26.225,19.415),(26.395,19.415),(26.395,19.245),(26.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.005),(39.605,7.175),(39.775,7.175),(39.775,7.005),(39.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.345),(39.605,7.515),(39.775,7.515),(39.775,7.345),(39.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.685),(39.605,7.855),(39.775,7.855),(39.775,7.685),(39.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.005),(16.625,7.175),(16.795,7.175),(16.795,7.005),(16.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.005),(16.115,7.175),(16.285,7.175),(16.285,7.005),(16.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.705),(73.715,8.875),(73.885,8.875),(73.885,8.705),(73.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,7.345),(16.115,7.515),(16.285,7.515),(16.285,7.345),(16.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,7.345),(16.625,7.515),(16.795,7.515),(16.795,7.345),(16.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.365),(73.205,8.535),(73.375,8.535),(73.375,8.365),(73.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((15.605,7.685),(15.605,7.855),(15.775,7.855),(15.775,7.685),(15.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.705),(73.205,8.875),(73.375,8.875),(73.375,8.705),(73.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.365),(73.715,8.535),(73.885,8.535),(73.885,8.365),(73.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.205,8.025),(73.205,8.195),(73.375,8.195),(73.375,8.025),(73.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.715,8.025),(73.715,8.195),(73.885,8.195),(73.885,8.025),(73.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,7.685),(82.805,7.855),(82.975,7.855),(82.975,7.685),(82.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.705),(25.715,8.875),(25.885,8.875),(25.885,8.705),(25.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.365),(25.715,8.535),(25.885,8.535),(25.885,8.365),(25.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.365),(25.205,8.535),(25.375,8.535),(25.375,8.365),(25.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.705),(25.205,8.875),(25.375,8.875),(25.375,8.705),(25.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((25.205,8.025),(25.205,8.195),(25.375,8.195),(25.375,8.025),(25.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((25.715,8.025),(25.715,8.195),(25.885,8.195),(25.885,8.025),(25.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.465),(40.115,13.635),(40.285,13.635),(40.285,13.465),(40.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.465),(40.625,13.635),(40.795,13.635),(40.795,13.465),(40.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.805),(40.625,13.975),(40.795,13.975),(40.795,13.805),(40.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.805),(40.115,13.975),(40.285,13.975),(40.285,13.805),(40.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.125),(40.115,13.295),(40.285,13.295),(40.285,13.125),(40.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.125),(40.625,13.295),(40.795,13.295),(40.795,13.125),(40.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,17.885),(64.115,18.055),(64.285,18.055),(64.285,17.885),(64.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,17.885),(64.625,18.055),(64.795,18.055),(64.795,17.885),(64.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.285),(58.805,4.455),(58.975,4.455),(58.975,4.285),(58.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.625),(58.805,4.795),(58.975,4.795),(58.975,4.625),(58.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.305),(7.025,5.475),(7.195,5.475),(7.195,5.305),(7.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((7.025,5.645),(7.025,5.815),(7.195,5.815),(7.195,5.645),(7.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.285),(34.805,4.455),(34.975,4.455),(34.975,4.285),(34.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.625),(34.805,4.795),(34.975,4.795),(34.975,4.625),(34.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,4.965),(64.625,5.135),(64.795,5.135),(64.795,4.965),(64.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,4.965),(64.115,5.135),(64.285,5.135),(64.285,4.965),(64.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.625),(10.805,4.795),(10.975,4.795),(10.975,4.625),(10.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,4.285),(10.805,4.455),(10.975,4.455),(10.975,4.285),(10.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.285),(54.005,4.455),(54.175,4.455),(54.175,4.285),(54.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.205),(20.915,17.375),(21.085,17.375),(21.085,17.205),(20.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.285),(54.515,4.455),(54.685,4.455),(54.685,4.285),(54.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.625),(54.515,4.795),(54.685,4.795),(54.685,4.625),(54.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.625),(54.005,4.795),(54.175,4.795),(54.175,4.625),(54.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,17.545),(20.915,17.715),(21.085,17.715),(21.085,17.545),(20.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.325),(74.225,6.495),(74.395,6.495),(74.395,6.325),(74.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,6.665),(74.225,6.835),(74.395,6.835),(74.395,6.665),(74.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.905),(40.625,19.075),(40.795,19.075),(40.795,18.905),(40.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.965),(45.425,5.135),(45.595,5.135),(45.595,4.965),(45.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.905),(40.115,19.075),(40.285,19.075),(40.285,18.905),(40.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.225),(39.605,18.395),(39.775,18.395),(39.775,18.225),(39.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.565),(39.605,18.735),(39.775,18.735),(39.775,18.565),(39.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.745),(44.405,10.915),(44.575,10.915),(44.575,10.745),(44.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.405),(44.405,10.575),(44.575,10.575),(44.575,10.405),(44.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.065),(44.405,10.235),(44.575,10.235),(44.575,10.065),(44.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((63.605,7.685),(63.605,7.855),(63.775,7.855),(63.775,7.685),(63.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.425),(39.605,11.595),(39.775,11.595),(39.775,11.425),(39.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.085),(39.605,11.255),(39.775,11.255),(39.775,11.085),(39.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.725),(16.115,9.895),(16.285,9.895),(16.285,9.725),(16.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.725),(16.625,9.895),(16.795,9.895),(16.795,9.725),(16.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,9.385),(16.625,9.555),(16.795,9.555),(16.795,9.385),(16.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,9.385),(16.115,9.555),(16.285,9.555),(16.285,9.385),(16.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.765),(39.605,11.935),(39.775,11.935),(39.775,11.765),(39.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.225),(49.715,18.395),(49.885,18.395),(49.885,18.225),(49.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.565),(49.715,18.735),(49.885,18.735),(49.885,18.565),(49.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.225),(49.205,18.395),(49.375,18.395),(49.375,18.225),(49.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.565),(49.205,18.735),(49.375,18.735),(49.375,18.565),(49.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.725),(59.315,9.895),(59.485,9.895),(59.485,9.725),(59.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.385),(59.825,9.555),(59.995,9.555),(59.995,9.385),(59.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.825,9.725),(59.825,9.895),(59.995,9.895),(59.995,9.725),(59.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.385),(59.315,9.555),(59.485,9.555),(59.485,9.385),(59.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((20.915,9.045),(20.915,9.215),(21.085,9.215),(21.085,9.045),(20.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.245),(34.805,19.415),(34.975,19.415),(34.975,19.245),(34.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.325),(16.625,6.495),(16.795,6.495),(16.795,6.325),(16.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,6.665),(16.625,6.835),(16.795,6.835),(16.795,6.665),(16.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.325),(16.115,6.495),(16.285,6.495),(16.285,6.325),(16.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.285),(82.805,4.455),(82.975,4.455),(82.975,4.285),(82.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.225,5.985),(26.225,6.155),(26.395,6.155),(26.395,5.985),(26.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,4.625),(82.805,4.795),(82.975,4.795),(82.975,4.625),(82.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,6.665),(16.115,6.835),(16.285,6.835),(16.285,6.665),(16.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.685),(58.805,7.855),(58.975,7.855),(58.975,7.685),(58.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.005),(58.805,7.175),(58.975,7.175),(58.975,7.005),(58.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.345),(58.805,7.515),(58.975,7.515),(58.975,7.345),(58.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.025),(64.115,8.195),(64.285,8.195),(64.285,8.025),(64.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.025),(64.625,8.195),(64.795,8.195),(64.795,8.025),(64.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.205),(74.225,17.375),(74.395,17.375),(74.395,17.205),(74.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((74.225,17.545),(74.225,17.715),(74.395,17.715),(74.395,17.545),(74.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((64.625,8.365),(64.625,8.535),(64.795,8.535),(64.795,8.365),(64.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.365),(64.115,8.535),(64.285,8.535),(64.285,8.365),(64.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((64.115,8.705),(64.115,8.875),(64.285,8.875),(64.285,8.705),(64.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((21.425,15.845),(21.425,16.015),(21.595,16.015),(21.595,15.845),(21.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.905),(30.515,19.075),(30.685,19.075),(30.685,18.905),(30.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,18.905),(30.005,19.075),(30.175,19.075),(30.175,18.905),(30.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.685),(34.805,7.855),(34.975,7.855),(34.975,7.685),(34.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((78.005,7.685),(78.005,7.855),(78.175,7.855),(78.175,7.685),(78.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.725),(11.825,9.895),(11.995,9.895),(11.995,9.725),(11.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.385),(83.315,9.555),(83.485,9.555),(83.485,9.385),(83.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((83.315,9.725),(83.315,9.895),(83.485,9.895),(83.485,9.725),(83.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.385),(11.315,9.555),(11.485,9.555),(11.485,9.385),(11.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((11.315,9.725),(11.315,9.895),(11.485,9.895),(11.485,9.725),(11.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((11.825,9.385),(11.825,9.555),(11.995,9.555),(11.995,9.385),(11.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.085),(10.805,11.255),(10.975,11.255),(10.975,11.085),(10.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.765),(10.805,11.935),(10.975,11.935),(10.975,11.765),(10.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.805,11.425),(10.805,11.595),(10.975,11.595),(10.975,11.425),(10.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.005),(44.915,7.175),(45.085,7.175),(45.085,7.005),(44.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.685),(44.915,7.855),(45.085,7.855),(45.085,7.685),(44.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.985),(44.405,6.155),(44.575,6.155),(44.575,5.985),(44.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.345),(44.915,7.515),(45.085,7.515),(45.085,7.345),(44.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.545),(82.805,17.715),(82.975,17.715),(82.975,17.545),(82.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((82.805,17.205),(82.805,17.375),(82.975,17.375),(82.975,17.205),(82.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.325),(50.225,6.495),(50.395,6.495),(50.395,6.325),(50.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.665),(50.225,6.835),(50.395,6.835),(50.395,6.665),(50.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((16.115,4.965),(16.115,5.135),(16.285,5.135),(16.285,4.965),(16.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.625,4.965),(16.625,5.135),(16.795,5.135),(16.795,4.965),(16.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.485),(34.805,14.655),(34.975,14.655),(34.975,14.485),(34.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.985),(44.915,6.155),(45.085,6.155),(45.085,5.985),(44.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.915,2.925),(68.915,3.095),(69.085,3.095),(69.085,2.925),(68.915,2.925)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.985),(59.315,19.355),(59.485,19.355),(59.485,2.985),(59.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,2.845),(59.315,19.495),(59.485,19.495),(59.485,2.845),(59.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.985),(16.115,19.355),(16.285,19.355),(16.285,2.985),(16.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,2.845),(16.115,19.495),(16.285,19.495),(16.285,2.845),(16.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.985),(78.515,19.355),(78.685,19.355),(78.685,2.985),(78.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.28),(44.915,20.76),(45.085,20.76),(45.085,20.28),(44.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,2.845),(78.515,19.495),(78.685,19.495),(78.685,2.845),(78.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.845),(39.605,19.495),(40.795,19.495),(40.795,2.845),(39.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.985),(54.515,19.355),(54.685,19.355),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.845),(54.515,19.495),(54.685,19.495),(54.685,2.845),(54.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,20.435),(78.515,20.605),(78.685,20.605),(78.685,20.435),(78.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,20.28),(78.515,20.76),(78.685,20.76),(78.685,20.28),(78.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,20.435),(83.06,20.605),(83.23,20.605),(83.23,20.435),(83.06,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,20.28),(83.06,20.76),(83.23,20.76),(83.23,20.28),(83.06,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,20.435),(11.315,20.605),(11.485,20.605),(11.485,20.435),(11.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,20.28),(11.315,20.76),(11.485,20.76),(11.485,20.28),(11.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((78.005,2.845),(78.005,19.495),(79.195,19.495),(79.195,2.845),(78.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.985),(83.06,19.355),(83.23,19.355),(83.23,2.985),(83.06,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,2.845),(83.06,19.495),(83.23,19.495),(83.23,2.845),(83.06,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,20.435),(68.915,20.605),(69.085,20.605),(69.085,20.435),(68.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,20.28),(68.915,20.76),(69.085,20.76),(69.085,20.28),(68.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.58),(20.915,2.06),(21.085,2.06),(21.085,1.58),(20.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,1.58),(64.115,2.06),(64.285,2.06),(64.285,1.58),(64.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.845),(44.405,19.495),(45.595,19.495),(45.595,2.845),(44.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.985),(44.915,19.355),(45.085,19.355),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.845),(44.915,19.495),(45.085,19.495),(45.085,2.845),(44.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.845),(54.005,19.495),(55.195,19.495),(55.195,2.845),(54.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,20.435),(20.915,20.605),(21.085,20.605),(21.085,20.435),(20.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,20.28),(20.915,20.76),(21.085,20.76),(21.085,20.28),(20.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,20.435),(30.515,20.605),(30.685,20.605),(30.685,20.435),(30.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,20.28),(30.515,20.76),(30.685,20.76),(30.685,20.28),(30.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((15.605,2.845),(15.605,19.495),(16.795,19.495),(16.795,2.845),(15.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.845),(34.805,19.495),(35.995,19.495),(35.995,2.845),(34.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.28),(54.515,20.76),(54.685,20.76),(54.685,20.28),(54.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,20.435),(64.115,20.605),(64.285,20.605),(64.285,20.435),(64.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,20.28),(64.115,20.76),(64.285,20.76),(64.285,20.28),(64.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,1.58),(16.115,2.06),(16.285,2.06),(16.285,1.58),(16.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.985),(30.515,19.355),(30.685,19.355),(30.685,2.985),(30.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.845),(30.515,19.495),(30.685,19.495),(30.685,2.845),(30.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.58),(68.915,2.06),(69.085,2.06),(69.085,1.58),(68.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((25.205,2.845),(25.205,19.495),(26.395,19.495),(26.395,2.845),(25.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.985),(11.315,19.355),(11.485,19.355),(11.485,2.985),(11.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,2.845),(11.315,19.495),(11.485,19.495),(11.485,2.845),(11.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((63.605,2.845),(63.605,19.495),(64.795,19.495),(64.795,2.845),(63.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((20.405,2.845),(20.405,19.495),(21.595,19.495),(21.595,2.845),(20.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.985),(20.915,19.355),(21.085,19.355),(21.085,2.985),(20.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,2.845),(20.915,19.495),(21.085,19.495),(21.085,2.845),(20.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,20.435),(73.715,20.605),(73.885,20.605),(73.885,20.435),(73.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,20.28),(73.715,20.76),(73.885,20.76),(73.885,20.28),(73.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.985),(25.715,19.355),(25.885,19.355),(25.885,2.985),(25.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,2.845),(25.715,19.495),(25.885,19.495),(25.885,2.845),(25.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.005,2.845),(30.005,19.495),(31.195,19.495),(31.195,2.845),(30.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.985),(6.77,19.355),(6.94,19.355),(6.94,2.985),(6.77,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,2.845),(6.77,19.495),(6.94,19.495),(6.94,2.845),(6.77,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((78.515,1.58),(78.515,2.06),(78.685,2.06),(78.685,1.58),(78.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,20.435),(25.715,20.605),(25.885,20.605),(25.885,20.435),(25.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,20.28),(25.715,20.76),(25.885,20.76),(25.885,20.28),(25.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.28),(35.315,20.76),(35.485,20.76),(35.485,20.28),(35.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.28),(49.715,20.76),(49.885,20.76),(49.885,20.28),(49.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((73.205,2.845),(73.205,19.495),(74.395,19.495),(74.395,2.845),(73.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,1.58),(6.77,2.06),(6.94,2.06),(6.94,1.58),(6.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,20.435),(16.115,20.605),(16.285,20.605),(16.285,20.435),(16.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((16.115,20.28),(16.115,20.76),(16.285,20.76),(16.285,20.28),(16.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((68.405,2.845),(68.405,19.495),(69.595,19.495),(69.595,2.845),(68.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.985),(68.915,19.355),(69.085,19.355),(69.085,2.985),(68.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,2.845),(68.915,19.495),(69.085,19.495),(69.085,2.845),(68.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.845),(58.805,19.495),(59.995,19.495),(59.995,2.845),(58.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.515,2.845),(6.515,19.495),(7.195,19.495),(7.195,2.845),(6.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,20.435),(59.315,20.605),(59.485,20.605),(59.485,20.435),(59.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,20.28),(59.315,20.76),(59.485,20.76),(59.485,20.28),(59.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.985),(73.715,19.355),(73.885,19.355),(73.885,2.985),(73.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,2.845),(73.715,19.495),(73.885,19.495),(73.885,2.845),(73.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,20.435),(6.77,20.605),(6.94,20.605),(6.94,20.435),(6.77,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((6.77,20.28),(6.77,20.76),(6.94,20.76),(6.94,20.28),(6.77,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.715,1.58),(73.715,2.06),(73.885,2.06),(73.885,1.58),(73.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((10.805,2.845),(10.805,19.495),(11.995,19.495),(11.995,2.845),(10.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((82.805,2.845),(82.805,19.495),(83.485,19.495),(83.485,2.845),(82.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((25.715,1.58),(25.715,2.06),(25.885,2.06),(25.885,1.58),(25.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.985),(40.115,19.355),(40.285,19.355),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.845),(40.115,19.495),(40.285,19.495),(40.285,2.845),(40.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.28),(40.115,20.76),(40.285,20.76),(40.285,20.28),(40.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.985),(35.315,19.355),(35.485,19.355),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.845),(35.315,19.495),(35.485,19.495),(35.485,2.845),(35.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.985),(64.115,19.355),(64.285,19.355),(64.285,2.985),(64.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((64.115,2.845),(64.115,19.495),(64.285,19.495),(64.285,2.845),(64.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.985),(49.715,19.355),(49.885,19.355),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.845),(49.715,19.495),(49.885,19.495),(49.885,2.845),(49.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.315,1.58),(59.315,2.06),(59.485,2.06),(59.485,1.58),(59.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.845),(49.205,19.495),(50.395,19.495),(50.395,2.845),(49.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,1.58),(30.515,2.06),(30.685,2.06),(30.685,1.58),(30.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((83.06,1.58),(83.06,2.06),(83.23,2.06),(83.23,1.58),(83.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((11.315,1.58),(11.315,2.06),(11.485,2.06),(11.485,1.58),(11.315,1.58)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,1.735),(68.915,1.905),(69.085,1.905),(69.085,1.735),(68.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.985),(49.715,3.155),(49.885,3.155),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.345),(49.715,3.515),(49.885,3.515),(49.885,3.345),(49.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.705),(49.715,3.875),(49.885,3.875),(49.885,3.705),(49.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.065),(49.715,4.235),(49.885,4.235),(49.885,4.065),(49.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.425),(49.715,4.595),(49.885,4.595),(49.885,4.425),(49.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.785),(49.715,4.955),(49.885,4.955),(49.885,4.785),(49.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.145),(49.715,5.315),(49.885,5.315),(49.885,5.145),(49.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.505),(49.715,5.675),(49.885,5.675),(49.885,5.505),(49.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.865),(49.715,6.035),(49.885,6.035),(49.885,5.865),(49.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.225),(49.715,6.395),(49.885,6.395),(49.885,6.225),(49.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.585),(49.715,6.755),(49.885,6.755),(49.885,6.585),(49.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.305),(49.715,7.475),(49.885,7.475),(49.885,7.305),(49.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.665),(49.715,7.835),(49.885,7.835),(49.885,7.665),(49.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.385),(49.715,8.555),(49.885,8.555),(49.885,8.385),(49.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.745),(49.715,8.915),(49.885,8.915),(49.885,8.745),(49.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.105),(49.715,9.275),(49.885,9.275),(49.885,9.105),(49.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.465),(49.715,9.635),(49.885,9.635),(49.885,9.465),(49.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.825),(49.715,9.995),(49.885,9.995),(49.885,9.825),(49.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.185),(49.715,10.355),(49.885,10.355),(49.885,10.185),(49.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.545),(49.715,10.715),(49.885,10.715),(49.885,10.545),(49.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.905),(49.715,11.075),(49.885,11.075),(49.885,10.905),(49.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.265),(49.715,11.435),(49.885,11.435),(49.885,11.265),(49.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.625),(49.715,11.795),(49.885,11.795),(49.885,11.625),(49.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.985),(49.715,12.155),(49.885,12.155),(49.885,11.985),(49.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.345),(49.715,12.515),(49.885,12.515),(49.885,12.345),(49.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.705),(49.715,12.875),(49.885,12.875),(49.885,12.705),(49.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.425),(49.715,13.595),(49.885,13.595),(49.885,13.425),(49.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.785),(49.715,13.955),(49.885,13.955),(49.885,13.785),(49.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.505),(49.715,14.675),(49.885,14.675),(49.885,14.505),(49.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.865),(49.715,15.035),(49.885,15.035),(49.885,14.865),(49.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.225),(49.715,15.395),(49.885,15.395),(49.885,15.225),(49.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.585),(49.715,15.755),(49.885,15.755),(49.885,15.585),(49.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.945),(49.715,16.115),(49.885,16.115),(49.885,15.945),(49.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.305),(49.715,16.475),(49.885,16.475),(49.885,16.305),(49.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.665),(49.715,16.835),(49.885,16.835),(49.885,16.665),(49.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.025),(49.715,17.195),(49.885,17.195),(49.885,17.025),(49.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.385),(49.715,17.555),(49.885,17.555),(49.885,17.385),(49.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.745),(49.715,17.915),(49.885,17.915),(49.885,17.745),(49.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.105),(49.715,18.275),(49.885,18.275),(49.885,18.105),(49.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.465),(49.715,18.635),(49.885,18.635),(49.885,18.465),(49.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.825),(49.715,18.995),(49.885,18.995),(49.885,18.825),(49.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,20.435),(73.715,20.605),(73.885,20.605),(73.885,20.435),(73.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,2.985),(68.915,3.155),(69.085,3.155),(69.085,2.985),(68.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.345),(68.915,3.515),(69.085,3.515),(69.085,3.345),(68.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,3.705),(68.915,3.875),(69.085,3.875),(69.085,3.705),(68.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.065),(68.915,4.235),(69.085,4.235),(69.085,4.065),(68.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.425),(68.915,4.595),(69.085,4.595),(69.085,4.425),(68.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,4.785),(68.915,4.955),(69.085,4.955),(69.085,4.785),(68.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.145),(68.915,5.315),(69.085,5.315),(69.085,5.145),(68.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.505),(68.915,5.675),(69.085,5.675),(69.085,5.505),(68.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,5.865),(68.915,6.035),(69.085,6.035),(69.085,5.865),(68.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.225),(68.915,6.395),(69.085,6.395),(69.085,6.225),(68.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.585),(68.915,6.755),(69.085,6.755),(69.085,6.585),(68.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,6.945),(68.915,7.115),(69.085,7.115),(69.085,6.945),(68.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.305),(68.915,7.475),(69.085,7.475),(69.085,7.305),(68.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,7.665),(68.915,7.835),(69.085,7.835),(69.085,7.665),(68.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.025),(68.915,8.195),(69.085,8.195),(69.085,8.025),(68.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.385),(68.915,8.555),(69.085,8.555),(69.085,8.385),(68.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,8.745),(68.915,8.915),(69.085,8.915),(69.085,8.745),(68.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.105),(68.915,9.275),(69.085,9.275),(69.085,9.105),(68.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.465),(68.915,9.635),(69.085,9.635),(69.085,9.465),(68.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,9.825),(68.915,9.995),(69.085,9.995),(69.085,9.825),(68.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.185),(68.915,10.355),(69.085,10.355),(69.085,10.185),(68.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.545),(68.915,10.715),(69.085,10.715),(69.085,10.545),(68.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,10.905),(68.915,11.075),(69.085,11.075),(69.085,10.905),(68.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.265),(68.915,11.435),(69.085,11.435),(69.085,11.265),(68.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.625),(68.915,11.795),(69.085,11.795),(69.085,11.625),(68.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,11.985),(68.915,12.155),(69.085,12.155),(69.085,11.985),(68.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.345),(68.915,12.515),(69.085,12.515),(69.085,12.345),(68.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,12.705),(68.915,12.875),(69.085,12.875),(69.085,12.705),(68.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.065),(68.915,13.235),(69.085,13.235),(69.085,13.065),(68.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.425),(68.915,13.595),(69.085,13.595),(69.085,13.425),(68.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,13.785),(68.915,13.955),(69.085,13.955),(69.085,13.785),(68.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.145),(68.915,14.315),(69.085,14.315),(69.085,14.145),(68.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.505),(68.915,14.675),(69.085,14.675),(69.085,14.505),(68.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,14.865),(68.915,15.035),(69.085,15.035),(69.085,14.865),(68.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.225),(68.915,15.395),(69.085,15.395),(69.085,15.225),(68.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.585),(68.915,15.755),(69.085,15.755),(69.085,15.585),(68.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,15.945),(68.915,16.115),(69.085,16.115),(69.085,15.945),(68.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.305),(68.915,16.475),(69.085,16.475),(69.085,16.305),(68.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,16.665),(68.915,16.835),(69.085,16.835),(69.085,16.665),(68.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.025),(68.915,17.195),(69.085,17.195),(69.085,17.025),(68.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.385),(68.915,17.555),(69.085,17.555),(69.085,17.385),(68.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,17.745),(68.915,17.915),(69.085,17.915),(69.085,17.745),(68.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.105),(68.915,18.275),(69.085,18.275),(69.085,18.105),(68.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.465),(68.915,18.635),(69.085,18.635),(69.085,18.465),(68.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,18.825),(68.915,18.995),(69.085,18.995),(69.085,18.825),(68.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,19.185),(68.915,19.355),(69.085,19.355),(69.085,19.185),(68.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,20.435),(20.915,20.605),(21.085,20.605),(21.085,20.435),(20.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.985),(44.915,3.155),(45.085,3.155),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.345),(44.915,3.515),(45.085,3.515),(45.085,3.345),(44.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.705),(44.915,3.875),(45.085,3.875),(45.085,3.705),(44.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.065),(44.915,4.235),(45.085,4.235),(45.085,4.065),(44.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.425),(44.915,4.595),(45.085,4.595),(45.085,4.425),(44.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.785),(44.915,4.955),(45.085,4.955),(45.085,4.785),(44.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.145),(44.915,5.315),(45.085,5.315),(45.085,5.145),(44.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.505),(44.915,5.675),(45.085,5.675),(45.085,5.505),(44.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.865),(44.915,6.035),(45.085,6.035),(45.085,5.865),(44.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.225),(44.915,6.395),(45.085,6.395),(45.085,6.225),(44.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.585),(44.915,6.755),(45.085,6.755),(45.085,6.585),(44.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.305),(44.915,7.475),(45.085,7.475),(45.085,7.305),(44.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.665),(44.915,7.835),(45.085,7.835),(45.085,7.665),(44.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.385),(44.915,8.555),(45.085,8.555),(45.085,8.385),(44.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.745),(44.915,8.915),(45.085,8.915),(45.085,8.745),(44.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.105),(44.915,9.275),(45.085,9.275),(45.085,9.105),(44.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.465),(44.915,9.635),(45.085,9.635),(45.085,9.465),(44.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.825),(44.915,9.995),(45.085,9.995),(45.085,9.825),(44.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.185),(44.915,10.355),(45.085,10.355),(45.085,10.185),(44.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.545),(44.915,10.715),(45.085,10.715),(45.085,10.545),(44.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.905),(44.915,11.075),(45.085,11.075),(45.085,10.905),(44.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.265),(44.915,11.435),(45.085,11.435),(45.085,11.265),(44.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.625),(44.915,11.795),(45.085,11.795),(45.085,11.625),(44.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.985),(44.915,12.155),(45.085,12.155),(45.085,11.985),(44.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.345),(44.915,12.515),(45.085,12.515),(45.085,12.345),(44.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.705),(44.915,12.875),(45.085,12.875),(45.085,12.705),(44.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.425),(44.915,13.595),(45.085,13.595),(45.085,13.425),(44.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.785),(44.915,13.955),(45.085,13.955),(45.085,13.785),(44.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.505),(44.915,14.675),(45.085,14.675),(45.085,14.505),(44.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.865),(44.915,15.035),(45.085,15.035),(45.085,14.865),(44.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.225),(44.915,15.395),(45.085,15.395),(45.085,15.225),(44.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.585),(44.915,15.755),(45.085,15.755),(45.085,15.585),(44.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.945),(44.915,16.115),(45.085,16.115),(45.085,15.945),(44.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.305),(44.915,16.475),(45.085,16.475),(45.085,16.305),(44.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.665),(44.915,16.835),(45.085,16.835),(45.085,16.665),(44.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.025),(44.915,17.195),(45.085,17.195),(45.085,17.025),(44.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.385),(44.915,17.555),(45.085,17.555),(45.085,17.385),(44.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.745),(44.915,17.915),(45.085,17.915),(45.085,17.745),(44.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.105),(44.915,18.275),(45.085,18.275),(45.085,18.105),(44.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.465),(44.915,18.635),(45.085,18.635),(45.085,18.465),(44.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.825),(44.915,18.995),(45.085,18.995),(45.085,18.825),(44.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,2.985),(16.115,3.155),(16.285,3.155),(16.285,2.985),(16.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.345),(16.115,3.515),(16.285,3.515),(16.285,3.345),(16.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,3.705),(16.115,3.875),(16.285,3.875),(16.285,3.705),(16.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.065),(16.115,4.235),(16.285,4.235),(16.285,4.065),(16.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.425),(16.115,4.595),(16.285,4.595),(16.285,4.425),(16.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,4.785),(16.115,4.955),(16.285,4.955),(16.285,4.785),(16.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.145),(16.115,5.315),(16.285,5.315),(16.285,5.145),(16.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.505),(16.115,5.675),(16.285,5.675),(16.285,5.505),(16.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,5.865),(16.115,6.035),(16.285,6.035),(16.285,5.865),(16.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.225),(16.115,6.395),(16.285,6.395),(16.285,6.225),(16.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.585),(16.115,6.755),(16.285,6.755),(16.285,6.585),(16.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,6.945),(16.115,7.115),(16.285,7.115),(16.285,6.945),(16.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.305),(16.115,7.475),(16.285,7.475),(16.285,7.305),(16.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,7.665),(16.115,7.835),(16.285,7.835),(16.285,7.665),(16.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.025),(16.115,8.195),(16.285,8.195),(16.285,8.025),(16.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.385),(16.115,8.555),(16.285,8.555),(16.285,8.385),(16.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,8.745),(16.115,8.915),(16.285,8.915),(16.285,8.745),(16.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.105),(16.115,9.275),(16.285,9.275),(16.285,9.105),(16.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.465),(16.115,9.635),(16.285,9.635),(16.285,9.465),(16.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,9.825),(16.115,9.995),(16.285,9.995),(16.285,9.825),(16.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.185),(16.115,10.355),(16.285,10.355),(16.285,10.185),(16.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.545),(16.115,10.715),(16.285,10.715),(16.285,10.545),(16.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,10.905),(16.115,11.075),(16.285,11.075),(16.285,10.905),(16.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.265),(16.115,11.435),(16.285,11.435),(16.285,11.265),(16.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.625),(16.115,11.795),(16.285,11.795),(16.285,11.625),(16.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,11.985),(16.115,12.155),(16.285,12.155),(16.285,11.985),(16.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.345),(16.115,12.515),(16.285,12.515),(16.285,12.345),(16.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,12.705),(16.115,12.875),(16.285,12.875),(16.285,12.705),(16.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.065),(16.115,13.235),(16.285,13.235),(16.285,13.065),(16.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.425),(16.115,13.595),(16.285,13.595),(16.285,13.425),(16.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,13.785),(16.115,13.955),(16.285,13.955),(16.285,13.785),(16.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.145),(16.115,14.315),(16.285,14.315),(16.285,14.145),(16.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.505),(16.115,14.675),(16.285,14.675),(16.285,14.505),(16.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,14.865),(16.115,15.035),(16.285,15.035),(16.285,14.865),(16.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.225),(16.115,15.395),(16.285,15.395),(16.285,15.225),(16.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.585),(16.115,15.755),(16.285,15.755),(16.285,15.585),(16.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,15.945),(16.115,16.115),(16.285,16.115),(16.285,15.945),(16.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.305),(16.115,16.475),(16.285,16.475),(16.285,16.305),(16.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,16.665),(16.115,16.835),(16.285,16.835),(16.285,16.665),(16.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.025),(16.115,17.195),(16.285,17.195),(16.285,17.025),(16.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.385),(16.115,17.555),(16.285,17.555),(16.285,17.385),(16.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,17.745),(16.115,17.915),(16.285,17.915),(16.285,17.745),(16.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.105),(16.115,18.275),(16.285,18.275),(16.285,18.105),(16.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.465),(16.115,18.635),(16.285,18.635),(16.285,18.465),(16.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,18.825),(16.115,18.995),(16.285,18.995),(16.285,18.825),(16.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,19.185),(16.115,19.355),(16.285,19.355),(16.285,19.185),(16.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,20.435),(30.515,20.605),(30.685,20.605),(30.685,20.435),(30.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,1.735),(20.915,1.905),(21.085,1.905),(21.085,1.735),(20.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,1.735),(78.515,1.905),(78.685,1.905),(78.685,1.735),(78.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,20.435),(64.115,20.605),(64.285,20.605),(64.285,20.435),(64.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,1.735),(59.315,1.905),(59.485,1.905),(59.485,1.735),(59.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,20.435),(25.715,20.605),(25.885,20.605),(25.885,20.435),(25.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,2.985),(30.515,3.155),(30.685,3.155),(30.685,2.985),(30.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.345),(30.515,3.515),(30.685,3.515),(30.685,3.345),(30.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,3.705),(30.515,3.875),(30.685,3.875),(30.685,3.705),(30.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.065),(30.515,4.235),(30.685,4.235),(30.685,4.065),(30.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.425),(30.515,4.595),(30.685,4.595),(30.685,4.425),(30.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,4.785),(30.515,4.955),(30.685,4.955),(30.685,4.785),(30.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.145),(30.515,5.315),(30.685,5.315),(30.685,5.145),(30.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.505),(30.515,5.675),(30.685,5.675),(30.685,5.505),(30.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,5.865),(30.515,6.035),(30.685,6.035),(30.685,5.865),(30.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.225),(30.515,6.395),(30.685,6.395),(30.685,6.225),(30.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.585),(30.515,6.755),(30.685,6.755),(30.685,6.585),(30.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.945),(30.515,7.115),(30.685,7.115),(30.685,6.945),(30.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.305),(30.515,7.475),(30.685,7.475),(30.685,7.305),(30.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,7.665),(30.515,7.835),(30.685,7.835),(30.685,7.665),(30.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.385),(30.515,8.555),(30.685,8.555),(30.685,8.385),(30.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,8.745),(30.515,8.915),(30.685,8.915),(30.685,8.745),(30.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.105),(30.515,9.275),(30.685,9.275),(30.685,9.105),(30.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.465),(30.515,9.635),(30.685,9.635),(30.685,9.465),(30.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,9.825),(30.515,9.995),(30.685,9.995),(30.685,9.825),(30.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.185),(30.515,10.355),(30.685,10.355),(30.685,10.185),(30.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.545),(30.515,10.715),(30.685,10.715),(30.685,10.545),(30.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,10.905),(30.515,11.075),(30.685,11.075),(30.685,10.905),(30.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.265),(30.515,11.435),(30.685,11.435),(30.685,11.265),(30.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.625),(30.515,11.795),(30.685,11.795),(30.685,11.625),(30.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,11.985),(30.515,12.155),(30.685,12.155),(30.685,11.985),(30.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.345),(30.515,12.515),(30.685,12.515),(30.685,12.345),(30.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,12.705),(30.515,12.875),(30.685,12.875),(30.685,12.705),(30.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.065),(30.515,13.235),(30.685,13.235),(30.685,13.065),(30.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.425),(30.515,13.595),(30.685,13.595),(30.685,13.425),(30.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,13.785),(30.515,13.955),(30.685,13.955),(30.685,13.785),(30.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.505),(30.515,14.675),(30.685,14.675),(30.685,14.505),(30.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,14.865),(30.515,15.035),(30.685,15.035),(30.685,14.865),(30.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.225),(30.515,15.395),(30.685,15.395),(30.685,15.225),(30.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.585),(30.515,15.755),(30.685,15.755),(30.685,15.585),(30.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,15.945),(30.515,16.115),(30.685,16.115),(30.685,15.945),(30.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.305),(30.515,16.475),(30.685,16.475),(30.685,16.305),(30.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,16.665),(30.515,16.835),(30.685,16.835),(30.685,16.665),(30.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.025),(30.515,17.195),(30.685,17.195),(30.685,17.025),(30.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.385),(30.515,17.555),(30.685,17.555),(30.685,17.385),(30.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,17.745),(30.515,17.915),(30.685,17.915),(30.685,17.745),(30.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.105),(30.515,18.275),(30.685,18.275),(30.685,18.105),(30.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.465),(30.515,18.635),(30.685,18.635),(30.685,18.465),(30.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,18.825),(30.515,18.995),(30.685,18.995),(30.685,18.825),(30.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,19.185),(30.515,19.355),(30.685,19.355),(30.685,19.185),(30.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,1.735),(16.115,1.905),(16.285,1.905),(16.285,1.735),(16.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.985),(54.515,3.155),(54.685,3.155),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.345),(54.515,3.515),(54.685,3.515),(54.685,3.345),(54.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.705),(54.515,3.875),(54.685,3.875),(54.685,3.705),(54.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.065),(54.515,4.235),(54.685,4.235),(54.685,4.065),(54.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.425),(54.515,4.595),(54.685,4.595),(54.685,4.425),(54.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.785),(54.515,4.955),(54.685,4.955),(54.685,4.785),(54.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.145),(54.515,5.315),(54.685,5.315),(54.685,5.145),(54.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.505),(54.515,5.675),(54.685,5.675),(54.685,5.505),(54.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.865),(54.515,6.035),(54.685,6.035),(54.685,5.865),(54.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.225),(54.515,6.395),(54.685,6.395),(54.685,6.225),(54.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.585),(54.515,6.755),(54.685,6.755),(54.685,6.585),(54.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.305),(54.515,7.475),(54.685,7.475),(54.685,7.305),(54.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.665),(54.515,7.835),(54.685,7.835),(54.685,7.665),(54.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.385),(54.515,8.555),(54.685,8.555),(54.685,8.385),(54.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.745),(54.515,8.915),(54.685,8.915),(54.685,8.745),(54.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.105),(54.515,9.275),(54.685,9.275),(54.685,9.105),(54.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.465),(54.515,9.635),(54.685,9.635),(54.685,9.465),(54.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.825),(54.515,9.995),(54.685,9.995),(54.685,9.825),(54.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.185),(54.515,10.355),(54.685,10.355),(54.685,10.185),(54.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.545),(54.515,10.715),(54.685,10.715),(54.685,10.545),(54.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.905),(54.515,11.075),(54.685,11.075),(54.685,10.905),(54.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.265),(54.515,11.435),(54.685,11.435),(54.685,11.265),(54.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.625),(54.515,11.795),(54.685,11.795),(54.685,11.625),(54.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.985),(54.515,12.155),(54.685,12.155),(54.685,11.985),(54.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.345),(54.515,12.515),(54.685,12.515),(54.685,12.345),(54.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.705),(54.515,12.875),(54.685,12.875),(54.685,12.705),(54.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.425),(54.515,13.595),(54.685,13.595),(54.685,13.425),(54.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.785),(54.515,13.955),(54.685,13.955),(54.685,13.785),(54.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.505),(54.515,14.675),(54.685,14.675),(54.685,14.505),(54.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.865),(54.515,15.035),(54.685,15.035),(54.685,14.865),(54.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.225),(54.515,15.395),(54.685,15.395),(54.685,15.225),(54.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.585),(54.515,15.755),(54.685,15.755),(54.685,15.585),(54.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.945),(54.515,16.115),(54.685,16.115),(54.685,15.945),(54.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.305),(54.515,16.475),(54.685,16.475),(54.685,16.305),(54.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.665),(54.515,16.835),(54.685,16.835),(54.685,16.665),(54.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.025),(54.515,17.195),(54.685,17.195),(54.685,17.025),(54.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.385),(54.515,17.555),(54.685,17.555),(54.685,17.385),(54.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.745),(54.515,17.915),(54.685,17.915),(54.685,17.745),(54.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.105),(54.515,18.275),(54.685,18.275),(54.685,18.105),(54.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.465),(54.515,18.635),(54.685,18.635),(54.685,18.465),(54.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.825),(54.515,18.995),(54.685,18.995),(54.685,18.825),(54.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,1.735),(83.06,1.905),(83.23,1.905),(83.23,1.735),(83.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,2.985),(11.315,3.155),(11.485,3.155),(11.485,2.985),(11.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.345),(11.315,3.515),(11.485,3.515),(11.485,3.345),(11.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,3.705),(11.315,3.875),(11.485,3.875),(11.485,3.705),(11.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.065),(11.315,4.235),(11.485,4.235),(11.485,4.065),(11.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.425),(11.315,4.595),(11.485,4.595),(11.485,4.425),(11.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,4.785),(11.315,4.955),(11.485,4.955),(11.485,4.785),(11.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.145),(11.315,5.315),(11.485,5.315),(11.485,5.145),(11.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.505),(11.315,5.675),(11.485,5.675),(11.485,5.505),(11.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,5.865),(11.315,6.035),(11.485,6.035),(11.485,5.865),(11.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.225),(11.315,6.395),(11.485,6.395),(11.485,6.225),(11.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.585),(11.315,6.755),(11.485,6.755),(11.485,6.585),(11.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,6.945),(11.315,7.115),(11.485,7.115),(11.485,6.945),(11.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.305),(11.315,7.475),(11.485,7.475),(11.485,7.305),(11.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,7.665),(11.315,7.835),(11.485,7.835),(11.485,7.665),(11.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.025),(11.315,8.195),(11.485,8.195),(11.485,8.025),(11.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.385),(11.315,8.555),(11.485,8.555),(11.485,8.385),(11.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,8.745),(11.315,8.915),(11.485,8.915),(11.485,8.745),(11.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.105),(11.315,9.275),(11.485,9.275),(11.485,9.105),(11.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.465),(11.315,9.635),(11.485,9.635),(11.485,9.465),(11.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,9.825),(11.315,9.995),(11.485,9.995),(11.485,9.825),(11.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.185),(11.315,10.355),(11.485,10.355),(11.485,10.185),(11.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.545),(11.315,10.715),(11.485,10.715),(11.485,10.545),(11.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,10.905),(11.315,11.075),(11.485,11.075),(11.485,10.905),(11.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.265),(11.315,11.435),(11.485,11.435),(11.485,11.265),(11.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.625),(11.315,11.795),(11.485,11.795),(11.485,11.625),(11.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,11.985),(11.315,12.155),(11.485,12.155),(11.485,11.985),(11.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.345),(11.315,12.515),(11.485,12.515),(11.485,12.345),(11.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,12.705),(11.315,12.875),(11.485,12.875),(11.485,12.705),(11.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.065),(11.315,13.235),(11.485,13.235),(11.485,13.065),(11.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.425),(11.315,13.595),(11.485,13.595),(11.485,13.425),(11.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,13.785),(11.315,13.955),(11.485,13.955),(11.485,13.785),(11.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.145),(11.315,14.315),(11.485,14.315),(11.485,14.145),(11.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.505),(11.315,14.675),(11.485,14.675),(11.485,14.505),(11.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,14.865),(11.315,15.035),(11.485,15.035),(11.485,14.865),(11.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.225),(11.315,15.395),(11.485,15.395),(11.485,15.225),(11.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.585),(11.315,15.755),(11.485,15.755),(11.485,15.585),(11.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,15.945),(11.315,16.115),(11.485,16.115),(11.485,15.945),(11.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.305),(11.315,16.475),(11.485,16.475),(11.485,16.305),(11.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,16.665),(11.315,16.835),(11.485,16.835),(11.485,16.665),(11.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.025),(11.315,17.195),(11.485,17.195),(11.485,17.025),(11.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.385),(11.315,17.555),(11.485,17.555),(11.485,17.385),(11.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,17.745),(11.315,17.915),(11.485,17.915),(11.485,17.745),(11.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.105),(11.315,18.275),(11.485,18.275),(11.485,18.105),(11.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.465),(11.315,18.635),(11.485,18.635),(11.485,18.465),(11.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,18.825),(11.315,18.995),(11.485,18.995),(11.485,18.825),(11.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,19.185),(11.315,19.355),(11.485,19.355),(11.485,19.185),(11.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,1.735),(11.315,1.905),(11.485,1.905),(11.485,1.735),(11.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,20.435),(78.515,20.605),(78.685,20.605),(78.685,20.435),(78.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,2.985),(78.515,3.155),(78.685,3.155),(78.685,2.985),(78.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.345),(78.515,3.515),(78.685,3.515),(78.685,3.345),(78.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,3.705),(78.515,3.875),(78.685,3.875),(78.685,3.705),(78.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.065),(78.515,4.235),(78.685,4.235),(78.685,4.065),(78.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.425),(78.515,4.595),(78.685,4.595),(78.685,4.425),(78.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,4.785),(78.515,4.955),(78.685,4.955),(78.685,4.785),(78.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.145),(78.515,5.315),(78.685,5.315),(78.685,5.145),(78.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.505),(78.515,5.675),(78.685,5.675),(78.685,5.505),(78.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,5.865),(78.515,6.035),(78.685,6.035),(78.685,5.865),(78.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.225),(78.515,6.395),(78.685,6.395),(78.685,6.225),(78.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.585),(78.515,6.755),(78.685,6.755),(78.685,6.585),(78.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,6.945),(78.515,7.115),(78.685,7.115),(78.685,6.945),(78.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.305),(78.515,7.475),(78.685,7.475),(78.685,7.305),(78.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,7.665),(78.515,7.835),(78.685,7.835),(78.685,7.665),(78.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.025),(78.515,8.195),(78.685,8.195),(78.685,8.025),(78.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.385),(78.515,8.555),(78.685,8.555),(78.685,8.385),(78.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,8.745),(78.515,8.915),(78.685,8.915),(78.685,8.745),(78.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.105),(78.515,9.275),(78.685,9.275),(78.685,9.105),(78.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.465),(78.515,9.635),(78.685,9.635),(78.685,9.465),(78.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,9.825),(78.515,9.995),(78.685,9.995),(78.685,9.825),(78.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.185),(78.515,10.355),(78.685,10.355),(78.685,10.185),(78.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.545),(78.515,10.715),(78.685,10.715),(78.685,10.545),(78.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,10.905),(78.515,11.075),(78.685,11.075),(78.685,10.905),(78.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.265),(78.515,11.435),(78.685,11.435),(78.685,11.265),(78.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.625),(78.515,11.795),(78.685,11.795),(78.685,11.625),(78.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,11.985),(78.515,12.155),(78.685,12.155),(78.685,11.985),(78.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.345),(78.515,12.515),(78.685,12.515),(78.685,12.345),(78.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,12.705),(78.515,12.875),(78.685,12.875),(78.685,12.705),(78.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.065),(78.515,13.235),(78.685,13.235),(78.685,13.065),(78.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.425),(78.515,13.595),(78.685,13.595),(78.685,13.425),(78.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,13.785),(78.515,13.955),(78.685,13.955),(78.685,13.785),(78.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.145),(78.515,14.315),(78.685,14.315),(78.685,14.145),(78.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.505),(78.515,14.675),(78.685,14.675),(78.685,14.505),(78.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,14.865),(78.515,15.035),(78.685,15.035),(78.685,14.865),(78.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.225),(78.515,15.395),(78.685,15.395),(78.685,15.225),(78.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.585),(78.515,15.755),(78.685,15.755),(78.685,15.585),(78.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,15.945),(78.515,16.115),(78.685,16.115),(78.685,15.945),(78.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.305),(78.515,16.475),(78.685,16.475),(78.685,16.305),(78.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,16.665),(78.515,16.835),(78.685,16.835),(78.685,16.665),(78.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.025),(78.515,17.195),(78.685,17.195),(78.685,17.025),(78.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.385),(78.515,17.555),(78.685,17.555),(78.685,17.385),(78.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,17.745),(78.515,17.915),(78.685,17.915),(78.685,17.745),(78.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.105),(78.515,18.275),(78.685,18.275),(78.685,18.105),(78.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.465),(78.515,18.635),(78.685,18.635),(78.685,18.465),(78.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,18.825),(78.515,18.995),(78.685,18.995),(78.685,18.825),(78.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((78.515,19.185),(78.515,19.355),(78.685,19.355),(78.685,19.185),(78.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,20.435),(83.06,20.605),(83.23,20.605),(83.23,20.435),(83.06,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((11.315,20.435),(11.315,20.605),(11.485,20.605),(11.485,20.435),(11.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,2.985),(6.77,3.155),(6.94,3.155),(6.94,2.985),(6.77,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.345),(6.77,3.515),(6.94,3.515),(6.94,3.345),(6.77,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,3.705),(6.77,3.875),(6.94,3.875),(6.94,3.705),(6.77,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.065),(6.77,4.235),(6.94,4.235),(6.94,4.065),(6.77,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.425),(6.77,4.595),(6.94,4.595),(6.94,4.425),(6.77,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,4.785),(6.77,4.955),(6.94,4.955),(6.94,4.785),(6.77,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.145),(6.77,5.315),(6.94,5.315),(6.94,5.145),(6.77,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.505),(6.77,5.675),(6.94,5.675),(6.94,5.505),(6.77,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,5.865),(6.77,6.035),(6.94,6.035),(6.94,5.865),(6.77,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.225),(6.77,6.395),(6.94,6.395),(6.94,6.225),(6.77,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.585),(6.77,6.755),(6.94,6.755),(6.94,6.585),(6.77,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,6.945),(6.77,7.115),(6.94,7.115),(6.94,6.945),(6.77,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.305),(6.77,7.475),(6.94,7.475),(6.94,7.305),(6.77,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,7.665),(6.77,7.835),(6.94,7.835),(6.94,7.665),(6.77,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.025),(6.77,8.195),(6.94,8.195),(6.94,8.025),(6.77,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.385),(6.77,8.555),(6.94,8.555),(6.94,8.385),(6.77,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,8.745),(6.77,8.915),(6.94,8.915),(6.94,8.745),(6.77,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.105),(6.77,9.275),(6.94,9.275),(6.94,9.105),(6.77,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.465),(6.77,9.635),(6.94,9.635),(6.94,9.465),(6.77,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,9.825),(6.77,9.995),(6.94,9.995),(6.94,9.825),(6.77,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.185),(6.77,10.355),(6.94,10.355),(6.94,10.185),(6.77,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.545),(6.77,10.715),(6.94,10.715),(6.94,10.545),(6.77,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,10.905),(6.77,11.075),(6.94,11.075),(6.94,10.905),(6.77,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.265),(6.77,11.435),(6.94,11.435),(6.94,11.265),(6.77,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.625),(6.77,11.795),(6.94,11.795),(6.94,11.625),(6.77,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,11.985),(6.77,12.155),(6.94,12.155),(6.94,11.985),(6.77,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.345),(6.77,12.515),(6.94,12.515),(6.94,12.345),(6.77,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,12.705),(6.77,12.875),(6.94,12.875),(6.94,12.705),(6.77,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.065),(6.77,13.235),(6.94,13.235),(6.94,13.065),(6.77,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.425),(6.77,13.595),(6.94,13.595),(6.94,13.425),(6.77,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,13.785),(6.77,13.955),(6.94,13.955),(6.94,13.785),(6.77,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.145),(6.77,14.315),(6.94,14.315),(6.94,14.145),(6.77,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.505),(6.77,14.675),(6.94,14.675),(6.94,14.505),(6.77,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,14.865),(6.77,15.035),(6.94,15.035),(6.94,14.865),(6.77,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.225),(6.77,15.395),(6.94,15.395),(6.94,15.225),(6.77,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.585),(6.77,15.755),(6.94,15.755),(6.94,15.585),(6.77,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,15.945),(6.77,16.115),(6.94,16.115),(6.94,15.945),(6.77,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.305),(6.77,16.475),(6.94,16.475),(6.94,16.305),(6.77,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,16.665),(6.77,16.835),(6.94,16.835),(6.94,16.665),(6.77,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.025),(6.77,17.195),(6.94,17.195),(6.94,17.025),(6.77,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.385),(6.77,17.555),(6.94,17.555),(6.94,17.385),(6.77,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,17.745),(6.77,17.915),(6.94,17.915),(6.94,17.745),(6.77,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.105),(6.77,18.275),(6.94,18.275),(6.94,18.105),(6.77,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.465),(6.77,18.635),(6.94,18.635),(6.94,18.465),(6.77,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,18.825),(6.77,18.995),(6.94,18.995),(6.94,18.825),(6.77,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,19.185),(6.77,19.355),(6.94,19.355),(6.94,19.185),(6.77,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,1.735),(6.77,1.905),(6.94,1.905),(6.94,1.735),(6.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,1.735),(73.715,1.905),(73.885,1.905),(73.885,1.735),(73.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.115,20.435),(16.115,20.605),(16.285,20.605),(16.285,20.435),(16.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,2.985),(20.915,3.155),(21.085,3.155),(21.085,2.985),(20.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.345),(20.915,3.515),(21.085,3.515),(21.085,3.345),(20.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,3.705),(20.915,3.875),(21.085,3.875),(21.085,3.705),(20.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.065),(20.915,4.235),(21.085,4.235),(21.085,4.065),(20.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.425),(20.915,4.595),(21.085,4.595),(21.085,4.425),(20.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,4.785),(20.915,4.955),(21.085,4.955),(21.085,4.785),(20.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.145),(20.915,5.315),(21.085,5.315),(21.085,5.145),(20.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.505),(20.915,5.675),(21.085,5.675),(21.085,5.505),(20.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,5.865),(20.915,6.035),(21.085,6.035),(21.085,5.865),(20.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.225),(20.915,6.395),(21.085,6.395),(21.085,6.225),(20.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.585),(20.915,6.755),(21.085,6.755),(21.085,6.585),(20.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,6.945),(20.915,7.115),(21.085,7.115),(21.085,6.945),(20.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.305),(20.915,7.475),(21.085,7.475),(21.085,7.305),(20.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,7.665),(20.915,7.835),(21.085,7.835),(21.085,7.665),(20.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.025),(20.915,8.195),(21.085,8.195),(21.085,8.025),(20.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.385),(20.915,8.555),(21.085,8.555),(21.085,8.385),(20.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,8.745),(20.915,8.915),(21.085,8.915),(21.085,8.745),(20.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.105),(20.915,9.275),(21.085,9.275),(21.085,9.105),(20.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.465),(20.915,9.635),(21.085,9.635),(21.085,9.465),(20.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,9.825),(20.915,9.995),(21.085,9.995),(21.085,9.825),(20.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.185),(20.915,10.355),(21.085,10.355),(21.085,10.185),(20.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.545),(20.915,10.715),(21.085,10.715),(21.085,10.545),(20.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,10.905),(20.915,11.075),(21.085,11.075),(21.085,10.905),(20.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.265),(20.915,11.435),(21.085,11.435),(21.085,11.265),(20.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.625),(20.915,11.795),(21.085,11.795),(21.085,11.625),(20.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,11.985),(20.915,12.155),(21.085,12.155),(21.085,11.985),(20.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.345),(20.915,12.515),(21.085,12.515),(21.085,12.345),(20.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,12.705),(20.915,12.875),(21.085,12.875),(21.085,12.705),(20.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.065),(20.915,13.235),(21.085,13.235),(21.085,13.065),(20.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.425),(20.915,13.595),(21.085,13.595),(21.085,13.425),(20.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,13.785),(20.915,13.955),(21.085,13.955),(21.085,13.785),(20.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.145),(20.915,14.315),(21.085,14.315),(21.085,14.145),(20.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.505),(20.915,14.675),(21.085,14.675),(21.085,14.505),(20.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,14.865),(20.915,15.035),(21.085,15.035),(21.085,14.865),(20.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.225),(20.915,15.395),(21.085,15.395),(21.085,15.225),(20.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.585),(20.915,15.755),(21.085,15.755),(21.085,15.585),(20.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,15.945),(20.915,16.115),(21.085,16.115),(21.085,15.945),(20.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.305),(20.915,16.475),(21.085,16.475),(21.085,16.305),(20.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,16.665),(20.915,16.835),(21.085,16.835),(21.085,16.665),(20.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.025),(20.915,17.195),(21.085,17.195),(21.085,17.025),(20.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.385),(20.915,17.555),(21.085,17.555),(21.085,17.385),(20.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,17.745),(20.915,17.915),(21.085,17.915),(21.085,17.745),(20.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.105),(20.915,18.275),(21.085,18.275),(21.085,18.105),(20.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.465),(20.915,18.635),(21.085,18.635),(21.085,18.465),(20.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,18.825),(20.915,18.995),(21.085,18.995),(21.085,18.825),(20.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.915,19.185),(20.915,19.355),(21.085,19.355),(21.085,19.185),(20.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,1.735),(30.515,1.905),(30.685,1.905),(30.685,1.735),(30.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,2.985),(64.115,3.155),(64.285,3.155),(64.285,2.985),(64.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.345),(64.115,3.515),(64.285,3.515),(64.285,3.345),(64.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,3.705),(64.115,3.875),(64.285,3.875),(64.285,3.705),(64.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.065),(64.115,4.235),(64.285,4.235),(64.285,4.065),(64.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.425),(64.115,4.595),(64.285,4.595),(64.285,4.425),(64.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,4.785),(64.115,4.955),(64.285,4.955),(64.285,4.785),(64.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.145),(64.115,5.315),(64.285,5.315),(64.285,5.145),(64.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.505),(64.115,5.675),(64.285,5.675),(64.285,5.505),(64.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,5.865),(64.115,6.035),(64.285,6.035),(64.285,5.865),(64.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.225),(64.115,6.395),(64.285,6.395),(64.285,6.225),(64.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.585),(64.115,6.755),(64.285,6.755),(64.285,6.585),(64.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,6.945),(64.115,7.115),(64.285,7.115),(64.285,6.945),(64.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.305),(64.115,7.475),(64.285,7.475),(64.285,7.305),(64.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,7.665),(64.115,7.835),(64.285,7.835),(64.285,7.665),(64.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.025),(64.115,8.195),(64.285,8.195),(64.285,8.025),(64.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.385),(64.115,8.555),(64.285,8.555),(64.285,8.385),(64.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,8.745),(64.115,8.915),(64.285,8.915),(64.285,8.745),(64.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.105),(64.115,9.275),(64.285,9.275),(64.285,9.105),(64.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.465),(64.115,9.635),(64.285,9.635),(64.285,9.465),(64.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,9.825),(64.115,9.995),(64.285,9.995),(64.285,9.825),(64.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.185),(64.115,10.355),(64.285,10.355),(64.285,10.185),(64.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.545),(64.115,10.715),(64.285,10.715),(64.285,10.545),(64.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,10.905),(64.115,11.075),(64.285,11.075),(64.285,10.905),(64.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.265),(64.115,11.435),(64.285,11.435),(64.285,11.265),(64.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.625),(64.115,11.795),(64.285,11.795),(64.285,11.625),(64.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,11.985),(64.115,12.155),(64.285,12.155),(64.285,11.985),(64.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.345),(64.115,12.515),(64.285,12.515),(64.285,12.345),(64.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,12.705),(64.115,12.875),(64.285,12.875),(64.285,12.705),(64.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.065),(64.115,13.235),(64.285,13.235),(64.285,13.065),(64.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.425),(64.115,13.595),(64.285,13.595),(64.285,13.425),(64.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,13.785),(64.115,13.955),(64.285,13.955),(64.285,13.785),(64.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.145),(64.115,14.315),(64.285,14.315),(64.285,14.145),(64.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.505),(64.115,14.675),(64.285,14.675),(64.285,14.505),(64.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,14.865),(64.115,15.035),(64.285,15.035),(64.285,14.865),(64.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.225),(64.115,15.395),(64.285,15.395),(64.285,15.225),(64.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.585),(64.115,15.755),(64.285,15.755),(64.285,15.585),(64.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,15.945),(64.115,16.115),(64.285,16.115),(64.285,15.945),(64.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.305),(64.115,16.475),(64.285,16.475),(64.285,16.305),(64.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,16.665),(64.115,16.835),(64.285,16.835),(64.285,16.665),(64.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.025),(64.115,17.195),(64.285,17.195),(64.285,17.025),(64.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.385),(64.115,17.555),(64.285,17.555),(64.285,17.385),(64.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,17.745),(64.115,17.915),(64.285,17.915),(64.285,17.745),(64.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.105),(64.115,18.275),(64.285,18.275),(64.285,18.105),(64.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.465),(64.115,18.635),(64.285,18.635),(64.285,18.465),(64.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,18.825),(64.115,18.995),(64.285,18.995),(64.285,18.825),(64.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,19.185),(64.115,19.355),(64.285,19.355),(64.285,19.185),(64.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.985),(40.115,3.155),(40.285,3.155),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.345),(40.115,3.515),(40.285,3.515),(40.285,3.345),(40.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.705),(40.115,3.875),(40.285,3.875),(40.285,3.705),(40.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.065),(40.115,4.235),(40.285,4.235),(40.285,4.065),(40.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.425),(40.115,4.595),(40.285,4.595),(40.285,4.425),(40.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.785),(40.115,4.955),(40.285,4.955),(40.285,4.785),(40.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.145),(40.115,5.315),(40.285,5.315),(40.285,5.145),(40.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.505),(40.115,5.675),(40.285,5.675),(40.285,5.505),(40.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.865),(40.115,6.035),(40.285,6.035),(40.285,5.865),(40.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.225),(40.115,6.395),(40.285,6.395),(40.285,6.225),(40.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.585),(40.115,6.755),(40.285,6.755),(40.285,6.585),(40.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.305),(40.115,7.475),(40.285,7.475),(40.285,7.305),(40.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.665),(40.115,7.835),(40.285,7.835),(40.285,7.665),(40.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.385),(40.115,8.555),(40.285,8.555),(40.285,8.385),(40.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.745),(40.115,8.915),(40.285,8.915),(40.285,8.745),(40.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.105),(40.115,9.275),(40.285,9.275),(40.285,9.105),(40.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.465),(40.115,9.635),(40.285,9.635),(40.285,9.465),(40.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.825),(40.115,9.995),(40.285,9.995),(40.285,9.825),(40.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.185),(40.115,10.355),(40.285,10.355),(40.285,10.185),(40.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.545),(40.115,10.715),(40.285,10.715),(40.285,10.545),(40.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.905),(40.115,11.075),(40.285,11.075),(40.285,10.905),(40.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.265),(40.115,11.435),(40.285,11.435),(40.285,11.265),(40.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.625),(40.115,11.795),(40.285,11.795),(40.285,11.625),(40.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.985),(40.115,12.155),(40.285,12.155),(40.285,11.985),(40.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.345),(40.115,12.515),(40.285,12.515),(40.285,12.345),(40.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.705),(40.115,12.875),(40.285,12.875),(40.285,12.705),(40.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.425),(40.115,13.595),(40.285,13.595),(40.285,13.425),(40.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.785),(40.115,13.955),(40.285,13.955),(40.285,13.785),(40.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.505),(40.115,14.675),(40.285,14.675),(40.285,14.505),(40.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.865),(40.115,15.035),(40.285,15.035),(40.285,14.865),(40.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.225),(40.115,15.395),(40.285,15.395),(40.285,15.225),(40.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.585),(40.115,15.755),(40.285,15.755),(40.285,15.585),(40.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.945),(40.115,16.115),(40.285,16.115),(40.285,15.945),(40.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.305),(40.115,16.475),(40.285,16.475),(40.285,16.305),(40.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.665),(40.115,16.835),(40.285,16.835),(40.285,16.665),(40.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.025),(40.115,17.195),(40.285,17.195),(40.285,17.025),(40.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.385),(40.115,17.555),(40.285,17.555),(40.285,17.385),(40.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.745),(40.115,17.915),(40.285,17.915),(40.285,17.745),(40.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.105),(40.115,18.275),(40.285,18.275),(40.285,18.105),(40.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.465),(40.115,18.635),(40.285,18.635),(40.285,18.465),(40.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.825),(40.115,18.995),(40.285,18.995),(40.285,18.825),(40.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.915,20.435),(68.915,20.605),(69.085,20.605),(69.085,20.435),(68.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.985),(35.315,3.155),(35.485,3.155),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.345),(35.315,3.515),(35.485,3.515),(35.485,3.345),(35.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.705),(35.315,3.875),(35.485,3.875),(35.485,3.705),(35.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.065),(35.315,4.235),(35.485,4.235),(35.485,4.065),(35.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.425),(35.315,4.595),(35.485,4.595),(35.485,4.425),(35.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.785),(35.315,4.955),(35.485,4.955),(35.485,4.785),(35.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.145),(35.315,5.315),(35.485,5.315),(35.485,5.145),(35.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.505),(35.315,5.675),(35.485,5.675),(35.485,5.505),(35.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.865),(35.315,6.035),(35.485,6.035),(35.485,5.865),(35.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.225),(35.315,6.395),(35.485,6.395),(35.485,6.225),(35.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.585),(35.315,6.755),(35.485,6.755),(35.485,6.585),(35.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.305),(35.315,7.475),(35.485,7.475),(35.485,7.305),(35.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.665),(35.315,7.835),(35.485,7.835),(35.485,7.665),(35.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.385),(35.315,8.555),(35.485,8.555),(35.485,8.385),(35.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.745),(35.315,8.915),(35.485,8.915),(35.485,8.745),(35.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.105),(35.315,9.275),(35.485,9.275),(35.485,9.105),(35.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.465),(35.315,9.635),(35.485,9.635),(35.485,9.465),(35.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.825),(35.315,9.995),(35.485,9.995),(35.485,9.825),(35.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.185),(35.315,10.355),(35.485,10.355),(35.485,10.185),(35.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.545),(35.315,10.715),(35.485,10.715),(35.485,10.545),(35.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.905),(35.315,11.075),(35.485,11.075),(35.485,10.905),(35.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.265),(35.315,11.435),(35.485,11.435),(35.485,11.265),(35.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.625),(35.315,11.795),(35.485,11.795),(35.485,11.625),(35.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.985),(35.315,12.155),(35.485,12.155),(35.485,11.985),(35.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.345),(35.315,12.515),(35.485,12.515),(35.485,12.345),(35.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.705),(35.315,12.875),(35.485,12.875),(35.485,12.705),(35.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.425),(35.315,13.595),(35.485,13.595),(35.485,13.425),(35.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.785),(35.315,13.955),(35.485,13.955),(35.485,13.785),(35.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.505),(35.315,14.675),(35.485,14.675),(35.485,14.505),(35.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.865),(35.315,15.035),(35.485,15.035),(35.485,14.865),(35.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.225),(35.315,15.395),(35.485,15.395),(35.485,15.225),(35.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.585),(35.315,15.755),(35.485,15.755),(35.485,15.585),(35.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.945),(35.315,16.115),(35.485,16.115),(35.485,15.945),(35.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.305),(35.315,16.475),(35.485,16.475),(35.485,16.305),(35.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.665),(35.315,16.835),(35.485,16.835),(35.485,16.665),(35.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.025),(35.315,17.195),(35.485,17.195),(35.485,17.025),(35.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.385),(35.315,17.555),(35.485,17.555),(35.485,17.385),(35.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.745),(35.315,17.915),(35.485,17.915),(35.485,17.745),(35.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.105),(35.315,18.275),(35.485,18.275),(35.485,18.105),(35.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.465),(35.315,18.635),(35.485,18.635),(35.485,18.465),(35.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.825),(35.315,18.995),(35.485,18.995),(35.485,18.825),(35.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,20.435),(59.315,20.605),(59.485,20.605),(59.485,20.435),(59.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,2.985),(73.715,3.155),(73.885,3.155),(73.885,2.985),(73.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.345),(73.715,3.515),(73.885,3.515),(73.885,3.345),(73.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,3.705),(73.715,3.875),(73.885,3.875),(73.885,3.705),(73.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.065),(73.715,4.235),(73.885,4.235),(73.885,4.065),(73.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.425),(73.715,4.595),(73.885,4.595),(73.885,4.425),(73.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,4.785),(73.715,4.955),(73.885,4.955),(73.885,4.785),(73.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.145),(73.715,5.315),(73.885,5.315),(73.885,5.145),(73.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.505),(73.715,5.675),(73.885,5.675),(73.885,5.505),(73.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,5.865),(73.715,6.035),(73.885,6.035),(73.885,5.865),(73.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.225),(73.715,6.395),(73.885,6.395),(73.885,6.225),(73.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.585),(73.715,6.755),(73.885,6.755),(73.885,6.585),(73.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,6.945),(73.715,7.115),(73.885,7.115),(73.885,6.945),(73.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.305),(73.715,7.475),(73.885,7.475),(73.885,7.305),(73.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,7.665),(73.715,7.835),(73.885,7.835),(73.885,7.665),(73.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.025),(73.715,8.195),(73.885,8.195),(73.885,8.025),(73.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.385),(73.715,8.555),(73.885,8.555),(73.885,8.385),(73.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,8.745),(73.715,8.915),(73.885,8.915),(73.885,8.745),(73.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.105),(73.715,9.275),(73.885,9.275),(73.885,9.105),(73.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.465),(73.715,9.635),(73.885,9.635),(73.885,9.465),(73.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,9.825),(73.715,9.995),(73.885,9.995),(73.885,9.825),(73.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.185),(73.715,10.355),(73.885,10.355),(73.885,10.185),(73.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.545),(73.715,10.715),(73.885,10.715),(73.885,10.545),(73.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,10.905),(73.715,11.075),(73.885,11.075),(73.885,10.905),(73.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.265),(73.715,11.435),(73.885,11.435),(73.885,11.265),(73.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.625),(73.715,11.795),(73.885,11.795),(73.885,11.625),(73.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,11.985),(73.715,12.155),(73.885,12.155),(73.885,11.985),(73.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.345),(73.715,12.515),(73.885,12.515),(73.885,12.345),(73.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,12.705),(73.715,12.875),(73.885,12.875),(73.885,12.705),(73.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.065),(73.715,13.235),(73.885,13.235),(73.885,13.065),(73.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.425),(73.715,13.595),(73.885,13.595),(73.885,13.425),(73.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,13.785),(73.715,13.955),(73.885,13.955),(73.885,13.785),(73.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.145),(73.715,14.315),(73.885,14.315),(73.885,14.145),(73.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.505),(73.715,14.675),(73.885,14.675),(73.885,14.505),(73.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,14.865),(73.715,15.035),(73.885,15.035),(73.885,14.865),(73.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.225),(73.715,15.395),(73.885,15.395),(73.885,15.225),(73.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.585),(73.715,15.755),(73.885,15.755),(73.885,15.585),(73.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,15.945),(73.715,16.115),(73.885,16.115),(73.885,15.945),(73.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.305),(73.715,16.475),(73.885,16.475),(73.885,16.305),(73.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,16.665),(73.715,16.835),(73.885,16.835),(73.885,16.665),(73.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.025),(73.715,17.195),(73.885,17.195),(73.885,17.025),(73.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.385),(73.715,17.555),(73.885,17.555),(73.885,17.385),(73.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,17.745),(73.715,17.915),(73.885,17.915),(73.885,17.745),(73.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.105),(73.715,18.275),(73.885,18.275),(73.885,18.105),(73.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.465),(73.715,18.635),(73.885,18.635),(73.885,18.465),(73.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,18.825),(73.715,18.995),(73.885,18.995),(73.885,18.825),(73.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.715,19.185),(73.715,19.355),(73.885,19.355),(73.885,19.185),(73.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,2.985),(59.315,3.155),(59.485,3.155),(59.485,2.985),(59.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.345),(59.315,3.515),(59.485,3.515),(59.485,3.345),(59.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,3.705),(59.315,3.875),(59.485,3.875),(59.485,3.705),(59.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.065),(59.315,4.235),(59.485,4.235),(59.485,4.065),(59.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.425),(59.315,4.595),(59.485,4.595),(59.485,4.425),(59.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,4.785),(59.315,4.955),(59.485,4.955),(59.485,4.785),(59.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.145),(59.315,5.315),(59.485,5.315),(59.485,5.145),(59.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.505),(59.315,5.675),(59.485,5.675),(59.485,5.505),(59.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,5.865),(59.315,6.035),(59.485,6.035),(59.485,5.865),(59.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.225),(59.315,6.395),(59.485,6.395),(59.485,6.225),(59.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.585),(59.315,6.755),(59.485,6.755),(59.485,6.585),(59.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.945),(59.315,7.115),(59.485,7.115),(59.485,6.945),(59.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.305),(59.315,7.475),(59.485,7.475),(59.485,7.305),(59.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,7.665),(59.315,7.835),(59.485,7.835),(59.485,7.665),(59.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.385),(59.315,8.555),(59.485,8.555),(59.485,8.385),(59.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,8.745),(59.315,8.915),(59.485,8.915),(59.485,8.745),(59.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.105),(59.315,9.275),(59.485,9.275),(59.485,9.105),(59.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.465),(59.315,9.635),(59.485,9.635),(59.485,9.465),(59.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,9.825),(59.315,9.995),(59.485,9.995),(59.485,9.825),(59.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.185),(59.315,10.355),(59.485,10.355),(59.485,10.185),(59.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.545),(59.315,10.715),(59.485,10.715),(59.485,10.545),(59.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,10.905),(59.315,11.075),(59.485,11.075),(59.485,10.905),(59.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.265),(59.315,11.435),(59.485,11.435),(59.485,11.265),(59.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.625),(59.315,11.795),(59.485,11.795),(59.485,11.625),(59.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,11.985),(59.315,12.155),(59.485,12.155),(59.485,11.985),(59.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.345),(59.315,12.515),(59.485,12.515),(59.485,12.345),(59.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,12.705),(59.315,12.875),(59.485,12.875),(59.485,12.705),(59.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.065),(59.315,13.235),(59.485,13.235),(59.485,13.065),(59.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.425),(59.315,13.595),(59.485,13.595),(59.485,13.425),(59.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,13.785),(59.315,13.955),(59.485,13.955),(59.485,13.785),(59.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.505),(59.315,14.675),(59.485,14.675),(59.485,14.505),(59.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,14.865),(59.315,15.035),(59.485,15.035),(59.485,14.865),(59.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.225),(59.315,15.395),(59.485,15.395),(59.485,15.225),(59.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.585),(59.315,15.755),(59.485,15.755),(59.485,15.585),(59.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,15.945),(59.315,16.115),(59.485,16.115),(59.485,15.945),(59.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.305),(59.315,16.475),(59.485,16.475),(59.485,16.305),(59.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,16.665),(59.315,16.835),(59.485,16.835),(59.485,16.665),(59.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.025),(59.315,17.195),(59.485,17.195),(59.485,17.025),(59.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.385),(59.315,17.555),(59.485,17.555),(59.485,17.385),(59.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,17.745),(59.315,17.915),(59.485,17.915),(59.485,17.745),(59.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.105),(59.315,18.275),(59.485,18.275),(59.485,18.105),(59.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.465),(59.315,18.635),(59.485,18.635),(59.485,18.465),(59.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,18.825),(59.315,18.995),(59.485,18.995),(59.485,18.825),(59.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,19.185),(59.315,19.355),(59.485,19.355),(59.485,19.185),(59.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,2.985),(25.715,3.155),(25.885,3.155),(25.885,2.985),(25.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.345),(25.715,3.515),(25.885,3.515),(25.885,3.345),(25.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,3.705),(25.715,3.875),(25.885,3.875),(25.885,3.705),(25.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.065),(25.715,4.235),(25.885,4.235),(25.885,4.065),(25.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.425),(25.715,4.595),(25.885,4.595),(25.885,4.425),(25.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,4.785),(25.715,4.955),(25.885,4.955),(25.885,4.785),(25.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.145),(25.715,5.315),(25.885,5.315),(25.885,5.145),(25.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.505),(25.715,5.675),(25.885,5.675),(25.885,5.505),(25.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,5.865),(25.715,6.035),(25.885,6.035),(25.885,5.865),(25.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.225),(25.715,6.395),(25.885,6.395),(25.885,6.225),(25.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.585),(25.715,6.755),(25.885,6.755),(25.885,6.585),(25.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,6.945),(25.715,7.115),(25.885,7.115),(25.885,6.945),(25.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.305),(25.715,7.475),(25.885,7.475),(25.885,7.305),(25.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,7.665),(25.715,7.835),(25.885,7.835),(25.885,7.665),(25.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.025),(25.715,8.195),(25.885,8.195),(25.885,8.025),(25.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.385),(25.715,8.555),(25.885,8.555),(25.885,8.385),(25.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,8.745),(25.715,8.915),(25.885,8.915),(25.885,8.745),(25.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.105),(25.715,9.275),(25.885,9.275),(25.885,9.105),(25.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.465),(25.715,9.635),(25.885,9.635),(25.885,9.465),(25.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,9.825),(25.715,9.995),(25.885,9.995),(25.885,9.825),(25.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.185),(25.715,10.355),(25.885,10.355),(25.885,10.185),(25.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.545),(25.715,10.715),(25.885,10.715),(25.885,10.545),(25.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,10.905),(25.715,11.075),(25.885,11.075),(25.885,10.905),(25.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.265),(25.715,11.435),(25.885,11.435),(25.885,11.265),(25.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.625),(25.715,11.795),(25.885,11.795),(25.885,11.625),(25.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,11.985),(25.715,12.155),(25.885,12.155),(25.885,11.985),(25.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.345),(25.715,12.515),(25.885,12.515),(25.885,12.345),(25.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,12.705),(25.715,12.875),(25.885,12.875),(25.885,12.705),(25.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.065),(25.715,13.235),(25.885,13.235),(25.885,13.065),(25.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.425),(25.715,13.595),(25.885,13.595),(25.885,13.425),(25.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,13.785),(25.715,13.955),(25.885,13.955),(25.885,13.785),(25.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.145),(25.715,14.315),(25.885,14.315),(25.885,14.145),(25.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.505),(25.715,14.675),(25.885,14.675),(25.885,14.505),(25.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,14.865),(25.715,15.035),(25.885,15.035),(25.885,14.865),(25.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.225),(25.715,15.395),(25.885,15.395),(25.885,15.225),(25.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.585),(25.715,15.755),(25.885,15.755),(25.885,15.585),(25.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,15.945),(25.715,16.115),(25.885,16.115),(25.885,15.945),(25.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.305),(25.715,16.475),(25.885,16.475),(25.885,16.305),(25.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,16.665),(25.715,16.835),(25.885,16.835),(25.885,16.665),(25.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.025),(25.715,17.195),(25.885,17.195),(25.885,17.025),(25.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.385),(25.715,17.555),(25.885,17.555),(25.885,17.385),(25.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,17.745),(25.715,17.915),(25.885,17.915),(25.885,17.745),(25.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.105),(25.715,18.275),(25.885,18.275),(25.885,18.105),(25.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.465),(25.715,18.635),(25.885,18.635),(25.885,18.465),(25.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,18.825),(25.715,18.995),(25.885,18.995),(25.885,18.825),(25.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,19.185),(25.715,19.355),(25.885,19.355),(25.885,19.185),(25.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.115,1.735),(64.115,1.905),(64.285,1.905),(64.285,1.735),(64.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.715,1.735),(25.715,1.905),(25.885,1.905),(25.885,1.735),(25.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,2.985),(83.06,3.155),(83.23,3.155),(83.23,2.985),(83.06,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.345),(83.06,3.515),(83.23,3.515),(83.23,3.345),(83.06,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,3.705),(83.06,3.875),(83.23,3.875),(83.23,3.705),(83.06,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.065),(83.06,4.235),(83.23,4.235),(83.23,4.065),(83.06,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.425),(83.06,4.595),(83.23,4.595),(83.23,4.425),(83.06,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,4.785),(83.06,4.955),(83.23,4.955),(83.23,4.785),(83.06,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.145),(83.06,5.315),(83.23,5.315),(83.23,5.145),(83.06,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.505),(83.06,5.675),(83.23,5.675),(83.23,5.505),(83.06,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,5.865),(83.06,6.035),(83.23,6.035),(83.23,5.865),(83.06,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.225),(83.06,6.395),(83.23,6.395),(83.23,6.225),(83.06,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.585),(83.06,6.755),(83.23,6.755),(83.23,6.585),(83.06,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,6.945),(83.06,7.115),(83.23,7.115),(83.23,6.945),(83.06,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.305),(83.06,7.475),(83.23,7.475),(83.23,7.305),(83.06,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,7.665),(83.06,7.835),(83.23,7.835),(83.23,7.665),(83.06,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.025),(83.06,8.195),(83.23,8.195),(83.23,8.025),(83.06,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.385),(83.06,8.555),(83.23,8.555),(83.23,8.385),(83.06,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,8.745),(83.06,8.915),(83.23,8.915),(83.23,8.745),(83.06,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.105),(83.06,9.275),(83.23,9.275),(83.23,9.105),(83.06,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.465),(83.06,9.635),(83.23,9.635),(83.23,9.465),(83.06,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,9.825),(83.06,9.995),(83.23,9.995),(83.23,9.825),(83.06,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.185),(83.06,10.355),(83.23,10.355),(83.23,10.185),(83.06,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.545),(83.06,10.715),(83.23,10.715),(83.23,10.545),(83.06,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,10.905),(83.06,11.075),(83.23,11.075),(83.23,10.905),(83.06,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.265),(83.06,11.435),(83.23,11.435),(83.23,11.265),(83.06,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.625),(83.06,11.795),(83.23,11.795),(83.23,11.625),(83.06,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,11.985),(83.06,12.155),(83.23,12.155),(83.23,11.985),(83.06,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.345),(83.06,12.515),(83.23,12.515),(83.23,12.345),(83.06,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,12.705),(83.06,12.875),(83.23,12.875),(83.23,12.705),(83.06,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.065),(83.06,13.235),(83.23,13.235),(83.23,13.065),(83.06,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.425),(83.06,13.595),(83.23,13.595),(83.23,13.425),(83.06,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,13.785),(83.06,13.955),(83.23,13.955),(83.23,13.785),(83.06,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.145),(83.06,14.315),(83.23,14.315),(83.23,14.145),(83.06,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.505),(83.06,14.675),(83.23,14.675),(83.23,14.505),(83.06,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,14.865),(83.06,15.035),(83.23,15.035),(83.23,14.865),(83.06,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.225),(83.06,15.395),(83.23,15.395),(83.23,15.225),(83.06,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.585),(83.06,15.755),(83.23,15.755),(83.23,15.585),(83.06,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,15.945),(83.06,16.115),(83.23,16.115),(83.23,15.945),(83.06,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.305),(83.06,16.475),(83.23,16.475),(83.23,16.305),(83.06,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,16.665),(83.06,16.835),(83.23,16.835),(83.23,16.665),(83.06,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.025),(83.06,17.195),(83.23,17.195),(83.23,17.025),(83.06,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.385),(83.06,17.555),(83.23,17.555),(83.23,17.385),(83.06,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,17.745),(83.06,17.915),(83.23,17.915),(83.23,17.745),(83.06,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.105),(83.06,18.275),(83.23,18.275),(83.23,18.105),(83.06,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.465),(83.06,18.635),(83.23,18.635),(83.23,18.465),(83.06,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,18.825),(83.06,18.995),(83.23,18.995),(83.23,18.825),(83.06,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((83.06,19.185),(83.06,19.355),(83.23,19.355),(83.23,19.185),(83.06,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((6.77,20.435),(6.77,20.605),(6.94,20.605),(6.94,20.435),(6.77,20.435)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,2.925),(59.285,19.415),(59.515,19.415),(59.515,2.925),(59.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,2.925),(16.085,19.415),(16.315,19.415),(16.315,2.925),(16.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,1.675),(40.085,1.965),(40.315,1.965),(40.315,1.675),(40.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,2.925),(78.485,19.415),(78.715,19.415),(78.715,2.925),(78.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,20.375),(44.885,20.665),(45.115,20.665),(45.115,20.375),(44.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,0.0),(49.685,22.34),(49.915,22.34),(49.915,0.0),(49.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,0.0),(44.885,22.34),(45.115,22.34),(45.115,0.0),(44.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,22.34),(45.13,22.34),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,22.34),(49.93,22.34),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,2.925),(54.485,19.415),(54.715,19.415),(54.715,2.925),(54.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,20.375),(78.485,20.665),(78.715,20.665),(78.715,20.375),(78.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,20.375),(83.03,20.665),(83.26,20.665),(83.26,20.375),(83.03,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,20.375),(11.285,20.665),(11.515,20.665),(11.515,20.375),(11.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,2.925),(83.03,19.415),(83.26,19.415),(83.26,2.925),(83.03,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,20.375),(68.885,20.665),(69.115,20.665),(69.115,20.375),(68.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,1.675),(64.085,1.965),(64.315,1.965),(64.315,1.675),(64.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,2.925),(44.885,19.415),(45.115,19.415),(45.115,2.925),(44.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,0.0),(68.885,22.34),(69.115,22.34),(69.115,0.0),(68.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.13),(68.87,22.21),(69.13,22.21),(69.13,0.13),(68.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((68.87,0.0),(68.87,22.34),(69.13,22.34),(69.13,0.0),(68.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,20.375),(20.885,20.665),(21.115,20.665),(21.115,20.375),(20.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,20.375),(30.485,20.665),(30.715,20.665),(30.715,20.375),(30.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.13),(83.015,22.21),(83.275,22.21),(83.275,0.13),(83.015,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,0.0),(11.285,22.34),(11.515,22.34),(11.515,0.0),(11.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.015,0.0),(83.015,22.34),(83.275,22.34),(83.275,0.0),(83.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,0.0),(83.03,22.34),(83.26,22.34),(83.26,0.0),(83.03,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.13),(11.27,22.21),(11.53,22.21),(11.53,0.13),(11.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((11.27,0.0),(11.27,22.34),(11.53,22.34),(11.53,0.0),(11.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,20.375),(54.485,20.665),(54.715,20.665),(54.715,20.375),(54.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,20.375),(64.085,20.665),(64.315,20.665),(64.315,20.375),(64.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,0.0),(20.885,22.34),(21.115,22.34),(21.115,0.0),(20.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.13),(20.87,22.21),(21.13,22.21),(21.13,0.13),(20.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((20.87,0.0),(20.87,22.34),(21.13,22.34),(21.13,0.0),(20.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,0.0),(54.485,22.34),(54.715,22.34),(54.715,0.0),(54.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,22.34),(54.73,22.34),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,1.675),(16.085,1.965),(16.315,1.965),(16.315,1.675),(16.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,2.925),(30.485,19.415),(30.715,19.415),(30.715,2.925),(30.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,1.675),(73.685,1.965),(73.915,1.965),(73.915,1.675),(73.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,2.925),(11.285,19.415),(11.515,19.415),(11.515,2.925),(11.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,1.675),(35.285,1.965),(35.515,1.965),(35.515,1.675),(35.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,0.0),(64.085,22.34),(64.315,22.34),(64.315,0.0),(64.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.13),(64.07,22.21),(64.33,22.21),(64.33,0.13),(64.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((64.07,0.0),(64.07,22.34),(64.33,22.34),(64.33,0.0),(64.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,1.675),(25.685,1.965),(25.915,1.965),(25.915,1.675),(25.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,0.0),(78.485,22.34),(78.715,22.34),(78.715,0.0),(78.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.0),(78.47,22.34),(78.73,22.34),(78.73,0.0),(78.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((78.47,0.13),(78.47,22.21),(78.73,22.21),(78.73,0.13),(78.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,2.925),(20.885,19.415),(21.115,19.415),(21.115,2.925),(20.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,20.375),(73.685,20.665),(73.915,20.665),(73.915,20.375),(73.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,2.925),(25.685,19.415),(25.915,19.415),(25.915,2.925),(25.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,2.925),(6.74,19.415),(6.97,19.415),(6.97,2.925),(6.74,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((20.885,1.675),(20.885,1.965),(21.115,1.965),(21.115,1.675),(20.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((78.485,1.675),(78.485,1.965),(78.715,1.965),(78.715,1.675),(78.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,1.675),(59.285,1.965),(59.515,1.965),(59.515,1.675),(59.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,20.375),(25.685,20.665),(25.915,20.665),(25.915,20.375),(25.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,20.375),(35.285,20.665),(35.515,20.665),(35.515,20.375),(35.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,1.675),(54.485,1.965),(54.715,1.965),(54.715,1.675),(54.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,20.375),(49.685,20.665),(49.915,20.665),(49.915,20.375),(49.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,0.0),(30.485,22.34),(30.715,22.34),(30.715,0.0),(30.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.13),(30.47,22.21),(30.73,22.21),(30.73,0.13),(30.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((30.47,0.0),(30.47,22.34),(30.73,22.34),(30.73,0.0),(30.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((83.03,1.675),(83.03,1.965),(83.26,1.965),(83.26,1.675),(83.03,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((11.285,1.675),(11.285,1.965),(11.515,1.965),(11.515,1.675),(11.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,1.675),(6.74,1.965),(6.97,1.965),(6.97,1.675),(6.74,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.13),(73.67,22.21),(73.93,22.21),(73.93,0.13),(73.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((73.67,0.0),(73.67,22.34),(73.93,22.34),(73.93,0.0),(73.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,0.0),(73.685,22.34),(73.915,22.34),(73.915,0.0),(73.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,0.0),(40.085,22.34),(40.315,22.34),(40.315,0.0),(40.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,22.34),(40.33,22.34),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,1.675),(44.885,1.965),(45.115,1.965),(45.115,1.675),(44.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,20.375),(16.085,20.665),(16.315,20.665),(16.315,20.375),(16.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,2.925),(68.885,19.415),(69.115,19.415),(69.115,2.925),(68.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,20.375),(59.285,20.665),(59.515,20.665),(59.515,20.375),(59.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((25.685,0.0),(25.685,22.34),(25.915,22.34),(25.915,0.0),(25.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.13),(25.67,22.21),(25.93,22.21),(25.93,0.13),(25.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((73.685,2.925),(73.685,19.415),(73.915,19.415),(73.915,2.925),(73.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((25.67,0.0),(25.67,22.34),(25.93,22.34),(25.93,0.0),(25.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,20.375),(6.74,20.665),(6.97,20.665),(6.97,20.375),(6.74,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,22.34),(35.53,22.34),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,0.0),(35.285,22.34),(35.515,22.34),(35.515,0.0),(35.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((68.885,1.675),(68.885,1.965),(69.115,1.965),(69.115,1.675),(68.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,1.675),(49.685,1.965),(49.915,1.965),(49.915,1.675),(49.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((6.74,0.0),(6.74,22.34),(6.97,22.34),(6.97,0.0),(6.74,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.13),(6.725,22.21),(6.985,22.21),(6.985,0.13),(6.725,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((6.725,0.0),(6.725,22.34),(6.985,22.34),(6.985,0.0),(6.725,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.085,0.0),(16.085,22.34),(16.315,22.34),(16.315,0.0),(16.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.13),(16.07,22.21),(16.33,22.21),(16.33,0.13),(16.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((16.07,0.0),(16.07,22.34),(16.33,22.34),(16.33,0.0),(16.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,2.925),(40.085,19.415),(40.315,19.415),(40.315,2.925),(40.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,20.375),(40.085,20.665),(40.315,20.665),(40.315,20.375),(40.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((59.285,0.0),(59.285,22.34),(59.515,22.34),(59.515,0.0),(59.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.13),(59.27,22.21),(59.53,22.21),(59.53,0.13),(59.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((59.27,0.0),(59.27,22.34),(59.53,22.34),(59.53,0.0),(59.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,2.925),(35.285,19.415),(35.515,19.415),(35.515,2.925),(35.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((64.085,2.925),(64.085,19.415),(64.315,19.415),(64.315,2.925),(64.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,2.925),(49.685,19.415),(49.915,19.415),(49.915,2.925),(49.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((30.485,1.675),(30.485,1.965),(30.715,1.965),(30.715,1.675),(30.485,1.675)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.215),(68.925,0.365),(69.075,0.365),(69.075,0.215),(68.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.535),(68.925,0.685),(69.075,0.685),(69.075,0.535),(68.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,0.855),(68.925,1.005),(69.075,1.005),(69.075,0.855),(68.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.175),(68.925,1.325),(69.075,1.325),(69.075,1.175),(68.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.495),(68.925,1.645),(69.075,1.645),(69.075,1.495),(68.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,1.815),(68.925,1.965),(69.075,1.965),(69.075,1.815),(68.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.135),(68.925,2.285),(69.075,2.285),(69.075,2.135),(68.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.455),(68.925,2.605),(69.075,2.605),(69.075,2.455),(68.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,2.775),(68.925,2.925),(69.075,2.925),(69.075,2.775),(68.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.095),(68.925,3.245),(69.075,3.245),(69.075,3.095),(68.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.415),(68.925,3.565),(69.075,3.565),(69.075,3.415),(68.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,3.735),(68.925,3.885),(69.075,3.885),(69.075,3.735),(68.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.055),(68.925,4.205),(69.075,4.205),(69.075,4.055),(68.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.375),(68.925,4.525),(69.075,4.525),(69.075,4.375),(68.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,4.695),(68.925,4.845),(69.075,4.845),(69.075,4.695),(68.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.015),(68.925,5.165),(69.075,5.165),(69.075,5.015),(68.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.335),(68.925,5.485),(69.075,5.485),(69.075,5.335),(68.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.655),(68.925,5.805),(69.075,5.805),(69.075,5.655),(68.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,5.975),(68.925,6.125),(69.075,6.125),(69.075,5.975),(68.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.295),(68.925,6.445),(69.075,6.445),(69.075,6.295),(68.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.615),(68.925,6.765),(69.075,6.765),(69.075,6.615),(68.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,6.935),(68.925,7.085),(69.075,7.085),(69.075,6.935),(68.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.255),(68.925,7.405),(69.075,7.405),(69.075,7.255),(68.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.575),(68.925,7.725),(69.075,7.725),(69.075,7.575),(68.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,7.895),(68.925,8.045),(69.075,8.045),(69.075,7.895),(68.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.215),(68.925,8.365),(69.075,8.365),(69.075,8.215),(68.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.535),(68.925,8.685),(69.075,8.685),(69.075,8.535),(68.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,8.855),(68.925,9.005),(69.075,9.005),(69.075,8.855),(68.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.175),(68.925,9.325),(69.075,9.325),(69.075,9.175),(68.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.495),(68.925,9.645),(69.075,9.645),(69.075,9.495),(68.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,9.815),(68.925,9.965),(69.075,9.965),(69.075,9.815),(68.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.135),(68.925,10.285),(69.075,10.285),(69.075,10.135),(68.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.455),(68.925,10.605),(69.075,10.605),(69.075,10.455),(68.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,10.775),(68.925,10.925),(69.075,10.925),(69.075,10.775),(68.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.095),(68.925,11.245),(69.075,11.245),(69.075,11.095),(68.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.415),(68.925,11.565),(69.075,11.565),(69.075,11.415),(68.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,11.735),(68.925,11.885),(69.075,11.885),(69.075,11.735),(68.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.055),(68.925,12.205),(69.075,12.205),(69.075,12.055),(68.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.375),(68.925,12.525),(69.075,12.525),(69.075,12.375),(68.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,12.695),(68.925,12.845),(69.075,12.845),(69.075,12.695),(68.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.015),(68.925,13.165),(69.075,13.165),(69.075,13.015),(68.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.335),(68.925,13.485),(69.075,13.485),(69.075,13.335),(68.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.655),(68.925,13.805),(69.075,13.805),(69.075,13.655),(68.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,13.975),(68.925,14.125),(69.075,14.125),(69.075,13.975),(68.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.295),(68.925,14.445),(69.075,14.445),(69.075,14.295),(68.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.615),(68.925,14.765),(69.075,14.765),(69.075,14.615),(68.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,14.935),(68.925,15.085),(69.075,15.085),(69.075,14.935),(68.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.255),(68.925,15.405),(69.075,15.405),(69.075,15.255),(68.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.575),(68.925,15.725),(69.075,15.725),(69.075,15.575),(68.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,15.895),(68.925,16.045),(69.075,16.045),(69.075,15.895),(68.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.215),(68.925,16.365),(69.075,16.365),(69.075,16.215),(68.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.535),(68.925,16.685),(69.075,16.685),(69.075,16.535),(68.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,16.855),(68.925,17.005),(69.075,17.005),(69.075,16.855),(68.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.175),(68.925,17.325),(69.075,17.325),(69.075,17.175),(68.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.495),(68.925,17.645),(69.075,17.645),(69.075,17.495),(68.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,17.815),(68.925,17.965),(69.075,17.965),(69.075,17.815),(68.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.135),(68.925,18.285),(69.075,18.285),(69.075,18.135),(68.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.455),(68.925,18.605),(69.075,18.605),(69.075,18.455),(68.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,18.775),(68.925,18.925),(69.075,18.925),(69.075,18.775),(68.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.095),(68.925,19.245),(69.075,19.245),(69.075,19.095),(68.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.415),(68.925,19.565),(69.075,19.565),(69.075,19.415),(68.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,19.735),(68.925,19.885),(69.075,19.885),(69.075,19.735),(68.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.055),(68.925,20.205),(69.075,20.205),(69.075,20.055),(68.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.375),(68.925,20.525),(69.075,20.525),(69.075,20.375),(68.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,20.695),(68.925,20.845),(69.075,20.845),(69.075,20.695),(68.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.015),(68.925,21.165),(69.075,21.165),(69.075,21.015),(68.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.335),(68.925,21.485),(69.075,21.485),(69.075,21.335),(68.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.655),(68.925,21.805),(69.075,21.805),(69.075,21.655),(68.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((68.925,21.975),(68.925,22.125),(69.075,22.125),(69.075,21.975),(68.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.215),(6.78,0.365),(6.93,0.365),(6.93,0.215),(6.78,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.535),(6.78,0.685),(6.93,0.685),(6.93,0.535),(6.78,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,0.855),(6.78,1.005),(6.93,1.005),(6.93,0.855),(6.78,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.175),(6.78,1.325),(6.93,1.325),(6.93,1.175),(6.78,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.495),(6.78,1.645),(6.93,1.645),(6.93,1.495),(6.78,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,1.815),(6.78,1.965),(6.93,1.965),(6.93,1.815),(6.78,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.135),(6.78,2.285),(6.93,2.285),(6.93,2.135),(6.78,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.455),(6.78,2.605),(6.93,2.605),(6.93,2.455),(6.78,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,2.775),(6.78,2.925),(6.93,2.925),(6.93,2.775),(6.78,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.095),(6.78,3.245),(6.93,3.245),(6.93,3.095),(6.78,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.415),(6.78,3.565),(6.93,3.565),(6.93,3.415),(6.78,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,3.735),(6.78,3.885),(6.93,3.885),(6.93,3.735),(6.78,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.055),(6.78,4.205),(6.93,4.205),(6.93,4.055),(6.78,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.375),(6.78,4.525),(6.93,4.525),(6.93,4.375),(6.78,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,4.695),(6.78,4.845),(6.93,4.845),(6.93,4.695),(6.78,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.015),(6.78,5.165),(6.93,5.165),(6.93,5.015),(6.78,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.335),(6.78,5.485),(6.93,5.485),(6.93,5.335),(6.78,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.655),(6.78,5.805),(6.93,5.805),(6.93,5.655),(6.78,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,5.975),(6.78,6.125),(6.93,6.125),(6.93,5.975),(6.78,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.295),(6.78,6.445),(6.93,6.445),(6.93,6.295),(6.78,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.615),(6.78,6.765),(6.93,6.765),(6.93,6.615),(6.78,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,6.935),(6.78,7.085),(6.93,7.085),(6.93,6.935),(6.78,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.255),(6.78,7.405),(6.93,7.405),(6.93,7.255),(6.78,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.575),(6.78,7.725),(6.93,7.725),(6.93,7.575),(6.78,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,7.895),(6.78,8.045),(6.93,8.045),(6.93,7.895),(6.78,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.215),(6.78,8.365),(6.93,8.365),(6.93,8.215),(6.78,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.535),(6.78,8.685),(6.93,8.685),(6.93,8.535),(6.78,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,8.855),(6.78,9.005),(6.93,9.005),(6.93,8.855),(6.78,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.175),(6.78,9.325),(6.93,9.325),(6.93,9.175),(6.78,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.495),(6.78,9.645),(6.93,9.645),(6.93,9.495),(6.78,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,9.815),(6.78,9.965),(6.93,9.965),(6.93,9.815),(6.78,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.135),(6.78,10.285),(6.93,10.285),(6.93,10.135),(6.78,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.455),(6.78,10.605),(6.93,10.605),(6.93,10.455),(6.78,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,10.775),(6.78,10.925),(6.93,10.925),(6.93,10.775),(6.78,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.095),(6.78,11.245),(6.93,11.245),(6.93,11.095),(6.78,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.415),(6.78,11.565),(6.93,11.565),(6.93,11.415),(6.78,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,11.735),(6.78,11.885),(6.93,11.885),(6.93,11.735),(6.78,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.055),(6.78,12.205),(6.93,12.205),(6.93,12.055),(6.78,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.375),(6.78,12.525),(6.93,12.525),(6.93,12.375),(6.78,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,12.695),(6.78,12.845),(6.93,12.845),(6.93,12.695),(6.78,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.015),(6.78,13.165),(6.93,13.165),(6.93,13.015),(6.78,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.335),(6.78,13.485),(6.93,13.485),(6.93,13.335),(6.78,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.655),(6.78,13.805),(6.93,13.805),(6.93,13.655),(6.78,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,13.975),(6.78,14.125),(6.93,14.125),(6.93,13.975),(6.78,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.295),(6.78,14.445),(6.93,14.445),(6.93,14.295),(6.78,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.615),(6.78,14.765),(6.93,14.765),(6.93,14.615),(6.78,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,14.935),(6.78,15.085),(6.93,15.085),(6.93,14.935),(6.78,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.255),(6.78,15.405),(6.93,15.405),(6.93,15.255),(6.78,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.575),(6.78,15.725),(6.93,15.725),(6.93,15.575),(6.78,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,15.895),(6.78,16.045),(6.93,16.045),(6.93,15.895),(6.78,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.215),(6.78,16.365),(6.93,16.365),(6.93,16.215),(6.78,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.535),(6.78,16.685),(6.93,16.685),(6.93,16.535),(6.78,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,16.855),(6.78,17.005),(6.93,17.005),(6.93,16.855),(6.78,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.175),(6.78,17.325),(6.93,17.325),(6.93,17.175),(6.78,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.495),(6.78,17.645),(6.93,17.645),(6.93,17.495),(6.78,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,17.815),(6.78,17.965),(6.93,17.965),(6.93,17.815),(6.78,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.135),(6.78,18.285),(6.93,18.285),(6.93,18.135),(6.78,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.455),(6.78,18.605),(6.93,18.605),(6.93,18.455),(6.78,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,18.775),(6.78,18.925),(6.93,18.925),(6.93,18.775),(6.78,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.095),(6.78,19.245),(6.93,19.245),(6.93,19.095),(6.78,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.415),(6.78,19.565),(6.93,19.565),(6.93,19.415),(6.78,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,19.735),(6.78,19.885),(6.93,19.885),(6.93,19.735),(6.78,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.055),(6.78,20.205),(6.93,20.205),(6.93,20.055),(6.78,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.375),(6.78,20.525),(6.93,20.525),(6.93,20.375),(6.78,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,20.695),(6.78,20.845),(6.93,20.845),(6.93,20.695),(6.78,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.015),(6.78,21.165),(6.93,21.165),(6.93,21.015),(6.78,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.335),(6.78,21.485),(6.93,21.485),(6.93,21.335),(6.78,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.655),(6.78,21.805),(6.93,21.805),(6.93,21.655),(6.78,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((6.78,21.975),(6.78,22.125),(6.93,22.125),(6.93,21.975),(6.78,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.215),(35.325,0.365),(35.475,0.365),(35.475,0.215),(35.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.535),(35.325,0.685),(35.475,0.685),(35.475,0.535),(35.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.855),(35.325,1.005),(35.475,1.005),(35.475,0.855),(35.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.175),(35.325,1.325),(35.475,1.325),(35.475,1.175),(35.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.495),(35.325,1.645),(35.475,1.645),(35.475,1.495),(35.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.815),(35.325,1.965),(35.475,1.965),(35.475,1.815),(35.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.135),(35.325,2.285),(35.475,2.285),(35.475,2.135),(35.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.455),(35.325,2.605),(35.475,2.605),(35.475,2.455),(35.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.775),(35.325,2.925),(35.475,2.925),(35.475,2.775),(35.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.095),(35.325,3.245),(35.475,3.245),(35.475,3.095),(35.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.415),(35.325,3.565),(35.475,3.565),(35.475,3.415),(35.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.735),(35.325,3.885),(35.475,3.885),(35.475,3.735),(35.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.055),(35.325,4.205),(35.475,4.205),(35.475,4.055),(35.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.375),(35.325,4.525),(35.475,4.525),(35.475,4.375),(35.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.695),(35.325,4.845),(35.475,4.845),(35.475,4.695),(35.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.015),(35.325,5.165),(35.475,5.165),(35.475,5.015),(35.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.335),(35.325,5.485),(35.475,5.485),(35.475,5.335),(35.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.655),(35.325,5.805),(35.475,5.805),(35.475,5.655),(35.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.975),(35.325,6.125),(35.475,6.125),(35.475,5.975),(35.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.295),(35.325,6.445),(35.475,6.445),(35.475,6.295),(35.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.615),(35.325,6.765),(35.475,6.765),(35.475,6.615),(35.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.935),(35.325,7.085),(35.475,7.085),(35.475,6.935),(35.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.255),(35.325,7.405),(35.475,7.405),(35.475,7.255),(35.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.575),(35.325,7.725),(35.475,7.725),(35.475,7.575),(35.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.895),(35.325,8.045),(35.475,8.045),(35.475,7.895),(35.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.215),(35.325,8.365),(35.475,8.365),(35.475,8.215),(35.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.535),(35.325,8.685),(35.475,8.685),(35.475,8.535),(35.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.855),(35.325,9.005),(35.475,9.005),(35.475,8.855),(35.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.175),(35.325,9.325),(35.475,9.325),(35.475,9.175),(35.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.495),(35.325,9.645),(35.475,9.645),(35.475,9.495),(35.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.815),(35.325,9.965),(35.475,9.965),(35.475,9.815),(35.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.135),(35.325,10.285),(35.475,10.285),(35.475,10.135),(35.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.455),(35.325,10.605),(35.475,10.605),(35.475,10.455),(35.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.775),(35.325,10.925),(35.475,10.925),(35.475,10.775),(35.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.095),(35.325,11.245),(35.475,11.245),(35.475,11.095),(35.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.415),(35.325,11.565),(35.475,11.565),(35.475,11.415),(35.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.735),(35.325,11.885),(35.475,11.885),(35.475,11.735),(35.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.055),(35.325,12.205),(35.475,12.205),(35.475,12.055),(35.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.375),(35.325,12.525),(35.475,12.525),(35.475,12.375),(35.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.695),(35.325,12.845),(35.475,12.845),(35.475,12.695),(35.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.015),(35.325,13.165),(35.475,13.165),(35.475,13.015),(35.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.335),(35.325,13.485),(35.475,13.485),(35.475,13.335),(35.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.655),(35.325,13.805),(35.475,13.805),(35.475,13.655),(35.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.975),(35.325,14.125),(35.475,14.125),(35.475,13.975),(35.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.295),(35.325,14.445),(35.475,14.445),(35.475,14.295),(35.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.615),(35.325,14.765),(35.475,14.765),(35.475,14.615),(35.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.935),(35.325,15.085),(35.475,15.085),(35.475,14.935),(35.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.255),(35.325,15.405),(35.475,15.405),(35.475,15.255),(35.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.575),(35.325,15.725),(35.475,15.725),(35.475,15.575),(35.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.895),(35.325,16.045),(35.475,16.045),(35.475,15.895),(35.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.215),(35.325,16.365),(35.475,16.365),(35.475,16.215),(35.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.535),(35.325,16.685),(35.475,16.685),(35.475,16.535),(35.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.855),(35.325,17.005),(35.475,17.005),(35.475,16.855),(35.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.175),(35.325,17.325),(35.475,17.325),(35.475,17.175),(35.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.495),(35.325,17.645),(35.475,17.645),(35.475,17.495),(35.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.815),(35.325,17.965),(35.475,17.965),(35.475,17.815),(35.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.135),(35.325,18.285),(35.475,18.285),(35.475,18.135),(35.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.455),(35.325,18.605),(35.475,18.605),(35.475,18.455),(35.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.775),(35.325,18.925),(35.475,18.925),(35.475,18.775),(35.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.095),(35.325,19.245),(35.475,19.245),(35.475,19.095),(35.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.415),(35.325,19.565),(35.475,19.565),(35.475,19.415),(35.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.735),(35.325,19.885),(35.475,19.885),(35.475,19.735),(35.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.055),(35.325,20.205),(35.475,20.205),(35.475,20.055),(35.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.375),(35.325,20.525),(35.475,20.525),(35.475,20.375),(35.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.695),(35.325,20.845),(35.475,20.845),(35.475,20.695),(35.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.015),(35.325,21.165),(35.475,21.165),(35.475,21.015),(35.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.335),(35.325,21.485),(35.475,21.485),(35.475,21.335),(35.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.655),(35.325,21.805),(35.475,21.805),(35.475,21.655),(35.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.975),(35.325,22.125),(35.475,22.125),(35.475,21.975),(35.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.215),(49.725,0.365),(49.875,0.365),(49.875,0.215),(49.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.535),(49.725,0.685),(49.875,0.685),(49.875,0.535),(49.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.855),(49.725,1.005),(49.875,1.005),(49.875,0.855),(49.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.175),(49.725,1.325),(49.875,1.325),(49.875,1.175),(49.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.495),(49.725,1.645),(49.875,1.645),(49.875,1.495),(49.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.815),(49.725,1.965),(49.875,1.965),(49.875,1.815),(49.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.135),(49.725,2.285),(49.875,2.285),(49.875,2.135),(49.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.455),(49.725,2.605),(49.875,2.605),(49.875,2.455),(49.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.775),(49.725,2.925),(49.875,2.925),(49.875,2.775),(49.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.095),(49.725,3.245),(49.875,3.245),(49.875,3.095),(49.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.415),(49.725,3.565),(49.875,3.565),(49.875,3.415),(49.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.735),(49.725,3.885),(49.875,3.885),(49.875,3.735),(49.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.055),(49.725,4.205),(49.875,4.205),(49.875,4.055),(49.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.375),(49.725,4.525),(49.875,4.525),(49.875,4.375),(49.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.695),(49.725,4.845),(49.875,4.845),(49.875,4.695),(49.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.015),(49.725,5.165),(49.875,5.165),(49.875,5.015),(49.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.335),(49.725,5.485),(49.875,5.485),(49.875,5.335),(49.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.655),(49.725,5.805),(49.875,5.805),(49.875,5.655),(49.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.975),(49.725,6.125),(49.875,6.125),(49.875,5.975),(49.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.295),(49.725,6.445),(49.875,6.445),(49.875,6.295),(49.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.615),(49.725,6.765),(49.875,6.765),(49.875,6.615),(49.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.935),(49.725,7.085),(49.875,7.085),(49.875,6.935),(49.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.255),(49.725,7.405),(49.875,7.405),(49.875,7.255),(49.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.575),(49.725,7.725),(49.875,7.725),(49.875,7.575),(49.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.895),(49.725,8.045),(49.875,8.045),(49.875,7.895),(49.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.215),(49.725,8.365),(49.875,8.365),(49.875,8.215),(49.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.535),(49.725,8.685),(49.875,8.685),(49.875,8.535),(49.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.855),(49.725,9.005),(49.875,9.005),(49.875,8.855),(49.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.175),(49.725,9.325),(49.875,9.325),(49.875,9.175),(49.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.495),(49.725,9.645),(49.875,9.645),(49.875,9.495),(49.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.815),(49.725,9.965),(49.875,9.965),(49.875,9.815),(49.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.135),(49.725,10.285),(49.875,10.285),(49.875,10.135),(49.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.455),(49.725,10.605),(49.875,10.605),(49.875,10.455),(49.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.775),(49.725,10.925),(49.875,10.925),(49.875,10.775),(49.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.095),(49.725,11.245),(49.875,11.245),(49.875,11.095),(49.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.415),(49.725,11.565),(49.875,11.565),(49.875,11.415),(49.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.735),(49.725,11.885),(49.875,11.885),(49.875,11.735),(49.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.055),(49.725,12.205),(49.875,12.205),(49.875,12.055),(49.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.375),(49.725,12.525),(49.875,12.525),(49.875,12.375),(49.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.695),(49.725,12.845),(49.875,12.845),(49.875,12.695),(49.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.015),(49.725,13.165),(49.875,13.165),(49.875,13.015),(49.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.335),(49.725,13.485),(49.875,13.485),(49.875,13.335),(49.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.655),(49.725,13.805),(49.875,13.805),(49.875,13.655),(49.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.975),(49.725,14.125),(49.875,14.125),(49.875,13.975),(49.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.295),(49.725,14.445),(49.875,14.445),(49.875,14.295),(49.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.615),(49.725,14.765),(49.875,14.765),(49.875,14.615),(49.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.935),(49.725,15.085),(49.875,15.085),(49.875,14.935),(49.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.255),(49.725,15.405),(49.875,15.405),(49.875,15.255),(49.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.575),(49.725,15.725),(49.875,15.725),(49.875,15.575),(49.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.895),(49.725,16.045),(49.875,16.045),(49.875,15.895),(49.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.215),(49.725,16.365),(49.875,16.365),(49.875,16.215),(49.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.535),(49.725,16.685),(49.875,16.685),(49.875,16.535),(49.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.855),(49.725,17.005),(49.875,17.005),(49.875,16.855),(49.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.175),(49.725,17.325),(49.875,17.325),(49.875,17.175),(49.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.495),(49.725,17.645),(49.875,17.645),(49.875,17.495),(49.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.815),(49.725,17.965),(49.875,17.965),(49.875,17.815),(49.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.135),(49.725,18.285),(49.875,18.285),(49.875,18.135),(49.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.455),(49.725,18.605),(49.875,18.605),(49.875,18.455),(49.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.775),(49.725,18.925),(49.875,18.925),(49.875,18.775),(49.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.095),(49.725,19.245),(49.875,19.245),(49.875,19.095),(49.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.415),(49.725,19.565),(49.875,19.565),(49.875,19.415),(49.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.735),(49.725,19.885),(49.875,19.885),(49.875,19.735),(49.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.055),(49.725,20.205),(49.875,20.205),(49.875,20.055),(49.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.375),(49.725,20.525),(49.875,20.525),(49.875,20.375),(49.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.695),(49.725,20.845),(49.875,20.845),(49.875,20.695),(49.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.015),(49.725,21.165),(49.875,21.165),(49.875,21.015),(49.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.335),(49.725,21.485),(49.875,21.485),(49.875,21.335),(49.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.655),(49.725,21.805),(49.875,21.805),(49.875,21.655),(49.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.975),(49.725,22.125),(49.875,22.125),(49.875,21.975),(49.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.215),(59.325,0.365),(59.475,0.365),(59.475,0.215),(59.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.535),(59.325,0.685),(59.475,0.685),(59.475,0.535),(59.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,0.855),(59.325,1.005),(59.475,1.005),(59.475,0.855),(59.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.175),(59.325,1.325),(59.475,1.325),(59.475,1.175),(59.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.495),(59.325,1.645),(59.475,1.645),(59.475,1.495),(59.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,1.815),(59.325,1.965),(59.475,1.965),(59.475,1.815),(59.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.135),(59.325,2.285),(59.475,2.285),(59.475,2.135),(59.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.455),(59.325,2.605),(59.475,2.605),(59.475,2.455),(59.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,2.775),(59.325,2.925),(59.475,2.925),(59.475,2.775),(59.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.095),(59.325,3.245),(59.475,3.245),(59.475,3.095),(59.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.415),(59.325,3.565),(59.475,3.565),(59.475,3.415),(59.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,3.735),(59.325,3.885),(59.475,3.885),(59.475,3.735),(59.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.055),(59.325,4.205),(59.475,4.205),(59.475,4.055),(59.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.375),(59.325,4.525),(59.475,4.525),(59.475,4.375),(59.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,4.695),(59.325,4.845),(59.475,4.845),(59.475,4.695),(59.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.015),(59.325,5.165),(59.475,5.165),(59.475,5.015),(59.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.335),(59.325,5.485),(59.475,5.485),(59.475,5.335),(59.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.655),(59.325,5.805),(59.475,5.805),(59.475,5.655),(59.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,5.975),(59.325,6.125),(59.475,6.125),(59.475,5.975),(59.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.295),(59.325,6.445),(59.475,6.445),(59.475,6.295),(59.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.615),(59.325,6.765),(59.475,6.765),(59.475,6.615),(59.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,6.935),(59.325,7.085),(59.475,7.085),(59.475,6.935),(59.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.255),(59.325,7.405),(59.475,7.405),(59.475,7.255),(59.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.575),(59.325,7.725),(59.475,7.725),(59.475,7.575),(59.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,7.895),(59.325,8.045),(59.475,8.045),(59.475,7.895),(59.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.215),(59.325,8.365),(59.475,8.365),(59.475,8.215),(59.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.535),(59.325,8.685),(59.475,8.685),(59.475,8.535),(59.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,8.855),(59.325,9.005),(59.475,9.005),(59.475,8.855),(59.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.175),(59.325,9.325),(59.475,9.325),(59.475,9.175),(59.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.495),(59.325,9.645),(59.475,9.645),(59.475,9.495),(59.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,9.815),(59.325,9.965),(59.475,9.965),(59.475,9.815),(59.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.135),(59.325,10.285),(59.475,10.285),(59.475,10.135),(59.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.455),(59.325,10.605),(59.475,10.605),(59.475,10.455),(59.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,10.775),(59.325,10.925),(59.475,10.925),(59.475,10.775),(59.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.095),(59.325,11.245),(59.475,11.245),(59.475,11.095),(59.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.415),(59.325,11.565),(59.475,11.565),(59.475,11.415),(59.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,11.735),(59.325,11.885),(59.475,11.885),(59.475,11.735),(59.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.055),(59.325,12.205),(59.475,12.205),(59.475,12.055),(59.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.375),(59.325,12.525),(59.475,12.525),(59.475,12.375),(59.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,12.695),(59.325,12.845),(59.475,12.845),(59.475,12.695),(59.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.015),(59.325,13.165),(59.475,13.165),(59.475,13.015),(59.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.335),(59.325,13.485),(59.475,13.485),(59.475,13.335),(59.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.655),(59.325,13.805),(59.475,13.805),(59.475,13.655),(59.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,13.975),(59.325,14.125),(59.475,14.125),(59.475,13.975),(59.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.295),(59.325,14.445),(59.475,14.445),(59.475,14.295),(59.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.615),(59.325,14.765),(59.475,14.765),(59.475,14.615),(59.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,14.935),(59.325,15.085),(59.475,15.085),(59.475,14.935),(59.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.255),(59.325,15.405),(59.475,15.405),(59.475,15.255),(59.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.575),(59.325,15.725),(59.475,15.725),(59.475,15.575),(59.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,15.895),(59.325,16.045),(59.475,16.045),(59.475,15.895),(59.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.215),(59.325,16.365),(59.475,16.365),(59.475,16.215),(59.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.535),(59.325,16.685),(59.475,16.685),(59.475,16.535),(59.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,16.855),(59.325,17.005),(59.475,17.005),(59.475,16.855),(59.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.175),(59.325,17.325),(59.475,17.325),(59.475,17.175),(59.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.495),(59.325,17.645),(59.475,17.645),(59.475,17.495),(59.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,17.815),(59.325,17.965),(59.475,17.965),(59.475,17.815),(59.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.135),(59.325,18.285),(59.475,18.285),(59.475,18.135),(59.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.455),(59.325,18.605),(59.475,18.605),(59.475,18.455),(59.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,18.775),(59.325,18.925),(59.475,18.925),(59.475,18.775),(59.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.095),(59.325,19.245),(59.475,19.245),(59.475,19.095),(59.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.415),(59.325,19.565),(59.475,19.565),(59.475,19.415),(59.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,19.735),(59.325,19.885),(59.475,19.885),(59.475,19.735),(59.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.055),(59.325,20.205),(59.475,20.205),(59.475,20.055),(59.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.375),(59.325,20.525),(59.475,20.525),(59.475,20.375),(59.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,20.695),(59.325,20.845),(59.475,20.845),(59.475,20.695),(59.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.015),(59.325,21.165),(59.475,21.165),(59.475,21.015),(59.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.335),(59.325,21.485),(59.475,21.485),(59.475,21.335),(59.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.655),(59.325,21.805),(59.475,21.805),(59.475,21.655),(59.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.325,21.975),(59.325,22.125),(59.475,22.125),(59.475,21.975),(59.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.215),(83.07,0.365),(83.22,0.365),(83.22,0.215),(83.07,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.535),(83.07,0.685),(83.22,0.685),(83.22,0.535),(83.07,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,0.855),(83.07,1.005),(83.22,1.005),(83.22,0.855),(83.07,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.175),(83.07,1.325),(83.22,1.325),(83.22,1.175),(83.07,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.495),(83.07,1.645),(83.22,1.645),(83.22,1.495),(83.07,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,1.815),(83.07,1.965),(83.22,1.965),(83.22,1.815),(83.07,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.135),(83.07,2.285),(83.22,2.285),(83.22,2.135),(83.07,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.455),(83.07,2.605),(83.22,2.605),(83.22,2.455),(83.07,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,2.775),(83.07,2.925),(83.22,2.925),(83.22,2.775),(83.07,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.095),(83.07,3.245),(83.22,3.245),(83.22,3.095),(83.07,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.415),(83.07,3.565),(83.22,3.565),(83.22,3.415),(83.07,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,3.735),(83.07,3.885),(83.22,3.885),(83.22,3.735),(83.07,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.055),(83.07,4.205),(83.22,4.205),(83.22,4.055),(83.07,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.375),(83.07,4.525),(83.22,4.525),(83.22,4.375),(83.07,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,4.695),(83.07,4.845),(83.22,4.845),(83.22,4.695),(83.07,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.015),(83.07,5.165),(83.22,5.165),(83.22,5.015),(83.07,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.335),(83.07,5.485),(83.22,5.485),(83.22,5.335),(83.07,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.655),(83.07,5.805),(83.22,5.805),(83.22,5.655),(83.07,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,5.975),(83.07,6.125),(83.22,6.125),(83.22,5.975),(83.07,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.295),(83.07,6.445),(83.22,6.445),(83.22,6.295),(83.07,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.615),(83.07,6.765),(83.22,6.765),(83.22,6.615),(83.07,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,6.935),(83.07,7.085),(83.22,7.085),(83.22,6.935),(83.07,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.255),(83.07,7.405),(83.22,7.405),(83.22,7.255),(83.07,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.575),(83.07,7.725),(83.22,7.725),(83.22,7.575),(83.07,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,7.895),(83.07,8.045),(83.22,8.045),(83.22,7.895),(83.07,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.215),(83.07,8.365),(83.22,8.365),(83.22,8.215),(83.07,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.535),(83.07,8.685),(83.22,8.685),(83.22,8.535),(83.07,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,8.855),(83.07,9.005),(83.22,9.005),(83.22,8.855),(83.07,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.175),(83.07,9.325),(83.22,9.325),(83.22,9.175),(83.07,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.495),(83.07,9.645),(83.22,9.645),(83.22,9.495),(83.07,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,9.815),(83.07,9.965),(83.22,9.965),(83.22,9.815),(83.07,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.135),(83.07,10.285),(83.22,10.285),(83.22,10.135),(83.07,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.455),(83.07,10.605),(83.22,10.605),(83.22,10.455),(83.07,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,10.775),(83.07,10.925),(83.22,10.925),(83.22,10.775),(83.07,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.095),(83.07,11.245),(83.22,11.245),(83.22,11.095),(83.07,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.415),(83.07,11.565),(83.22,11.565),(83.22,11.415),(83.07,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,11.735),(83.07,11.885),(83.22,11.885),(83.22,11.735),(83.07,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.055),(83.07,12.205),(83.22,12.205),(83.22,12.055),(83.07,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.375),(83.07,12.525),(83.22,12.525),(83.22,12.375),(83.07,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,12.695),(83.07,12.845),(83.22,12.845),(83.22,12.695),(83.07,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.015),(83.07,13.165),(83.22,13.165),(83.22,13.015),(83.07,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.335),(83.07,13.485),(83.22,13.485),(83.22,13.335),(83.07,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.655),(83.07,13.805),(83.22,13.805),(83.22,13.655),(83.07,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,13.975),(83.07,14.125),(83.22,14.125),(83.22,13.975),(83.07,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.295),(83.07,14.445),(83.22,14.445),(83.22,14.295),(83.07,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.615),(83.07,14.765),(83.22,14.765),(83.22,14.615),(83.07,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,14.935),(83.07,15.085),(83.22,15.085),(83.22,14.935),(83.07,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.255),(83.07,15.405),(83.22,15.405),(83.22,15.255),(83.07,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.575),(83.07,15.725),(83.22,15.725),(83.22,15.575),(83.07,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,15.895),(83.07,16.045),(83.22,16.045),(83.22,15.895),(83.07,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.215),(83.07,16.365),(83.22,16.365),(83.22,16.215),(83.07,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.535),(83.07,16.685),(83.22,16.685),(83.22,16.535),(83.07,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,16.855),(83.07,17.005),(83.22,17.005),(83.22,16.855),(83.07,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.175),(83.07,17.325),(83.22,17.325),(83.22,17.175),(83.07,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.495),(83.07,17.645),(83.22,17.645),(83.22,17.495),(83.07,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,17.815),(83.07,17.965),(83.22,17.965),(83.22,17.815),(83.07,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.135),(83.07,18.285),(83.22,18.285),(83.22,18.135),(83.07,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.455),(83.07,18.605),(83.22,18.605),(83.22,18.455),(83.07,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,18.775),(83.07,18.925),(83.22,18.925),(83.22,18.775),(83.07,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.095),(83.07,19.245),(83.22,19.245),(83.22,19.095),(83.07,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.415),(83.07,19.565),(83.22,19.565),(83.22,19.415),(83.07,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,19.735),(83.07,19.885),(83.22,19.885),(83.22,19.735),(83.07,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.055),(83.07,20.205),(83.22,20.205),(83.22,20.055),(83.07,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.375),(83.07,20.525),(83.22,20.525),(83.22,20.375),(83.07,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,20.695),(83.07,20.845),(83.22,20.845),(83.22,20.695),(83.07,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.015),(83.07,21.165),(83.22,21.165),(83.22,21.015),(83.07,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.335),(83.07,21.485),(83.22,21.485),(83.22,21.335),(83.07,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.655),(83.07,21.805),(83.22,21.805),(83.22,21.655),(83.07,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((83.07,21.975),(83.07,22.125),(83.22,22.125),(83.22,21.975),(83.07,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.215),(40.125,0.365),(40.275,0.365),(40.275,0.215),(40.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.535),(40.125,0.685),(40.275,0.685),(40.275,0.535),(40.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.855),(40.125,1.005),(40.275,1.005),(40.275,0.855),(40.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.175),(40.125,1.325),(40.275,1.325),(40.275,1.175),(40.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.495),(40.125,1.645),(40.275,1.645),(40.275,1.495),(40.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.815),(40.125,1.965),(40.275,1.965),(40.275,1.815),(40.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.135),(40.125,2.285),(40.275,2.285),(40.275,2.135),(40.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.455),(40.125,2.605),(40.275,2.605),(40.275,2.455),(40.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.775),(40.125,2.925),(40.275,2.925),(40.275,2.775),(40.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.095),(40.125,3.245),(40.275,3.245),(40.275,3.095),(40.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.415),(40.125,3.565),(40.275,3.565),(40.275,3.415),(40.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.735),(40.125,3.885),(40.275,3.885),(40.275,3.735),(40.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.055),(40.125,4.205),(40.275,4.205),(40.275,4.055),(40.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.375),(40.125,4.525),(40.275,4.525),(40.275,4.375),(40.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.695),(40.125,4.845),(40.275,4.845),(40.275,4.695),(40.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.015),(40.125,5.165),(40.275,5.165),(40.275,5.015),(40.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.335),(40.125,5.485),(40.275,5.485),(40.275,5.335),(40.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.655),(40.125,5.805),(40.275,5.805),(40.275,5.655),(40.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.975),(40.125,6.125),(40.275,6.125),(40.275,5.975),(40.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.295),(40.125,6.445),(40.275,6.445),(40.275,6.295),(40.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.615),(40.125,6.765),(40.275,6.765),(40.275,6.615),(40.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.935),(40.125,7.085),(40.275,7.085),(40.275,6.935),(40.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.255),(40.125,7.405),(40.275,7.405),(40.275,7.255),(40.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.575),(40.125,7.725),(40.275,7.725),(40.275,7.575),(40.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.895),(40.125,8.045),(40.275,8.045),(40.275,7.895),(40.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.215),(40.125,8.365),(40.275,8.365),(40.275,8.215),(40.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.535),(40.125,8.685),(40.275,8.685),(40.275,8.535),(40.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.855),(40.125,9.005),(40.275,9.005),(40.275,8.855),(40.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.175),(40.125,9.325),(40.275,9.325),(40.275,9.175),(40.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.495),(40.125,9.645),(40.275,9.645),(40.275,9.495),(40.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.815),(40.125,9.965),(40.275,9.965),(40.275,9.815),(40.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.135),(40.125,10.285),(40.275,10.285),(40.275,10.135),(40.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.455),(40.125,10.605),(40.275,10.605),(40.275,10.455),(40.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.775),(40.125,10.925),(40.275,10.925),(40.275,10.775),(40.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.095),(40.125,11.245),(40.275,11.245),(40.275,11.095),(40.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.415),(40.125,11.565),(40.275,11.565),(40.275,11.415),(40.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.735),(40.125,11.885),(40.275,11.885),(40.275,11.735),(40.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.055),(40.125,12.205),(40.275,12.205),(40.275,12.055),(40.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.375),(40.125,12.525),(40.275,12.525),(40.275,12.375),(40.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.695),(40.125,12.845),(40.275,12.845),(40.275,12.695),(40.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.015),(40.125,13.165),(40.275,13.165),(40.275,13.015),(40.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.335),(40.125,13.485),(40.275,13.485),(40.275,13.335),(40.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.655),(40.125,13.805),(40.275,13.805),(40.275,13.655),(40.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.975),(40.125,14.125),(40.275,14.125),(40.275,13.975),(40.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.295),(40.125,14.445),(40.275,14.445),(40.275,14.295),(40.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.615),(40.125,14.765),(40.275,14.765),(40.275,14.615),(40.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.935),(40.125,15.085),(40.275,15.085),(40.275,14.935),(40.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.255),(40.125,15.405),(40.275,15.405),(40.275,15.255),(40.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.575),(40.125,15.725),(40.275,15.725),(40.275,15.575),(40.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.895),(40.125,16.045),(40.275,16.045),(40.275,15.895),(40.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.215),(40.125,16.365),(40.275,16.365),(40.275,16.215),(40.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.535),(40.125,16.685),(40.275,16.685),(40.275,16.535),(40.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.855),(40.125,17.005),(40.275,17.005),(40.275,16.855),(40.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.175),(40.125,17.325),(40.275,17.325),(40.275,17.175),(40.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.495),(40.125,17.645),(40.275,17.645),(40.275,17.495),(40.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.815),(40.125,17.965),(40.275,17.965),(40.275,17.815),(40.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.135),(40.125,18.285),(40.275,18.285),(40.275,18.135),(40.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.455),(40.125,18.605),(40.275,18.605),(40.275,18.455),(40.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.775),(40.125,18.925),(40.275,18.925),(40.275,18.775),(40.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.095),(40.125,19.245),(40.275,19.245),(40.275,19.095),(40.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.415),(40.125,19.565),(40.275,19.565),(40.275,19.415),(40.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.735),(40.125,19.885),(40.275,19.885),(40.275,19.735),(40.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.055),(40.125,20.205),(40.275,20.205),(40.275,20.055),(40.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.375),(40.125,20.525),(40.275,20.525),(40.275,20.375),(40.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.695),(40.125,20.845),(40.275,20.845),(40.275,20.695),(40.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.015),(40.125,21.165),(40.275,21.165),(40.275,21.015),(40.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.335),(40.125,21.485),(40.275,21.485),(40.275,21.335),(40.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.655),(40.125,21.805),(40.275,21.805),(40.275,21.655),(40.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.975),(40.125,22.125),(40.275,22.125),(40.275,21.975),(40.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.215),(44.925,0.365),(45.075,0.365),(45.075,0.215),(44.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.535),(44.925,0.685),(45.075,0.685),(45.075,0.535),(44.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.855),(44.925,1.005),(45.075,1.005),(45.075,0.855),(44.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.175),(44.925,1.325),(45.075,1.325),(45.075,1.175),(44.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.495),(44.925,1.645),(45.075,1.645),(45.075,1.495),(44.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.815),(44.925,1.965),(45.075,1.965),(45.075,1.815),(44.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.135),(44.925,2.285),(45.075,2.285),(45.075,2.135),(44.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.455),(44.925,2.605),(45.075,2.605),(45.075,2.455),(44.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.775),(44.925,2.925),(45.075,2.925),(45.075,2.775),(44.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.095),(44.925,3.245),(45.075,3.245),(45.075,3.095),(44.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.415),(44.925,3.565),(45.075,3.565),(45.075,3.415),(44.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.735),(44.925,3.885),(45.075,3.885),(45.075,3.735),(44.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.055),(44.925,4.205),(45.075,4.205),(45.075,4.055),(44.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.375),(44.925,4.525),(45.075,4.525),(45.075,4.375),(44.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.695),(44.925,4.845),(45.075,4.845),(45.075,4.695),(44.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.015),(44.925,5.165),(45.075,5.165),(45.075,5.015),(44.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.335),(44.925,5.485),(45.075,5.485),(45.075,5.335),(44.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.655),(44.925,5.805),(45.075,5.805),(45.075,5.655),(44.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.975),(44.925,6.125),(45.075,6.125),(45.075,5.975),(44.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.295),(44.925,6.445),(45.075,6.445),(45.075,6.295),(44.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.615),(44.925,6.765),(45.075,6.765),(45.075,6.615),(44.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.935),(44.925,7.085),(45.075,7.085),(45.075,6.935),(44.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.255),(44.925,7.405),(45.075,7.405),(45.075,7.255),(44.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.575),(44.925,7.725),(45.075,7.725),(45.075,7.575),(44.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.895),(44.925,8.045),(45.075,8.045),(45.075,7.895),(44.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.215),(44.925,8.365),(45.075,8.365),(45.075,8.215),(44.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.535),(44.925,8.685),(45.075,8.685),(45.075,8.535),(44.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.855),(44.925,9.005),(45.075,9.005),(45.075,8.855),(44.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.175),(44.925,9.325),(45.075,9.325),(45.075,9.175),(44.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.495),(44.925,9.645),(45.075,9.645),(45.075,9.495),(44.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.815),(44.925,9.965),(45.075,9.965),(45.075,9.815),(44.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.135),(44.925,10.285),(45.075,10.285),(45.075,10.135),(44.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.455),(44.925,10.605),(45.075,10.605),(45.075,10.455),(44.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.775),(44.925,10.925),(45.075,10.925),(45.075,10.775),(44.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.095),(44.925,11.245),(45.075,11.245),(45.075,11.095),(44.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.415),(44.925,11.565),(45.075,11.565),(45.075,11.415),(44.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.735),(44.925,11.885),(45.075,11.885),(45.075,11.735),(44.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.055),(44.925,12.205),(45.075,12.205),(45.075,12.055),(44.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.375),(44.925,12.525),(45.075,12.525),(45.075,12.375),(44.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.695),(44.925,12.845),(45.075,12.845),(45.075,12.695),(44.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.015),(44.925,13.165),(45.075,13.165),(45.075,13.015),(44.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.335),(44.925,13.485),(45.075,13.485),(45.075,13.335),(44.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.655),(44.925,13.805),(45.075,13.805),(45.075,13.655),(44.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.975),(44.925,14.125),(45.075,14.125),(45.075,13.975),(44.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.295),(44.925,14.445),(45.075,14.445),(45.075,14.295),(44.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.615),(44.925,14.765),(45.075,14.765),(45.075,14.615),(44.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.935),(44.925,15.085),(45.075,15.085),(45.075,14.935),(44.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.255),(44.925,15.405),(45.075,15.405),(45.075,15.255),(44.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.575),(44.925,15.725),(45.075,15.725),(45.075,15.575),(44.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.895),(44.925,16.045),(45.075,16.045),(45.075,15.895),(44.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.215),(44.925,16.365),(45.075,16.365),(45.075,16.215),(44.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.535),(44.925,16.685),(45.075,16.685),(45.075,16.535),(44.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.855),(44.925,17.005),(45.075,17.005),(45.075,16.855),(44.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.175),(44.925,17.325),(45.075,17.325),(45.075,17.175),(44.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.495),(44.925,17.645),(45.075,17.645),(45.075,17.495),(44.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.815),(44.925,17.965),(45.075,17.965),(45.075,17.815),(44.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.135),(44.925,18.285),(45.075,18.285),(45.075,18.135),(44.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.455),(44.925,18.605),(45.075,18.605),(45.075,18.455),(44.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.775),(44.925,18.925),(45.075,18.925),(45.075,18.775),(44.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.095),(44.925,19.245),(45.075,19.245),(45.075,19.095),(44.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.415),(44.925,19.565),(45.075,19.565),(45.075,19.415),(44.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.735),(44.925,19.885),(45.075,19.885),(45.075,19.735),(44.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.055),(44.925,20.205),(45.075,20.205),(45.075,20.055),(44.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.375),(44.925,20.525),(45.075,20.525),(45.075,20.375),(44.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.695),(44.925,20.845),(45.075,20.845),(45.075,20.695),(44.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.015),(44.925,21.165),(45.075,21.165),(45.075,21.015),(44.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.335),(44.925,21.485),(45.075,21.485),(45.075,21.335),(44.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.655),(44.925,21.805),(45.075,21.805),(45.075,21.655),(44.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.975),(44.925,22.125),(45.075,22.125),(45.075,21.975),(44.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.215),(25.725,0.365),(25.875,0.365),(25.875,0.215),(25.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.535),(25.725,0.685),(25.875,0.685),(25.875,0.535),(25.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,0.855),(25.725,1.005),(25.875,1.005),(25.875,0.855),(25.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.175),(25.725,1.325),(25.875,1.325),(25.875,1.175),(25.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.495),(25.725,1.645),(25.875,1.645),(25.875,1.495),(25.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,1.815),(25.725,1.965),(25.875,1.965),(25.875,1.815),(25.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.135),(25.725,2.285),(25.875,2.285),(25.875,2.135),(25.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.455),(25.725,2.605),(25.875,2.605),(25.875,2.455),(25.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,2.775),(25.725,2.925),(25.875,2.925),(25.875,2.775),(25.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.095),(25.725,3.245),(25.875,3.245),(25.875,3.095),(25.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.415),(25.725,3.565),(25.875,3.565),(25.875,3.415),(25.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,3.735),(25.725,3.885),(25.875,3.885),(25.875,3.735),(25.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.055),(25.725,4.205),(25.875,4.205),(25.875,4.055),(25.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.375),(25.725,4.525),(25.875,4.525),(25.875,4.375),(25.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,4.695),(25.725,4.845),(25.875,4.845),(25.875,4.695),(25.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.015),(25.725,5.165),(25.875,5.165),(25.875,5.015),(25.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.335),(25.725,5.485),(25.875,5.485),(25.875,5.335),(25.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.655),(25.725,5.805),(25.875,5.805),(25.875,5.655),(25.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,5.975),(25.725,6.125),(25.875,6.125),(25.875,5.975),(25.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.295),(25.725,6.445),(25.875,6.445),(25.875,6.295),(25.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.615),(25.725,6.765),(25.875,6.765),(25.875,6.615),(25.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,6.935),(25.725,7.085),(25.875,7.085),(25.875,6.935),(25.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.255),(25.725,7.405),(25.875,7.405),(25.875,7.255),(25.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.575),(25.725,7.725),(25.875,7.725),(25.875,7.575),(25.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,7.895),(25.725,8.045),(25.875,8.045),(25.875,7.895),(25.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.215),(25.725,8.365),(25.875,8.365),(25.875,8.215),(25.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.535),(25.725,8.685),(25.875,8.685),(25.875,8.535),(25.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,8.855),(25.725,9.005),(25.875,9.005),(25.875,8.855),(25.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.175),(25.725,9.325),(25.875,9.325),(25.875,9.175),(25.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.495),(25.725,9.645),(25.875,9.645),(25.875,9.495),(25.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,9.815),(25.725,9.965),(25.875,9.965),(25.875,9.815),(25.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.135),(25.725,10.285),(25.875,10.285),(25.875,10.135),(25.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.455),(25.725,10.605),(25.875,10.605),(25.875,10.455),(25.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,10.775),(25.725,10.925),(25.875,10.925),(25.875,10.775),(25.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.095),(25.725,11.245),(25.875,11.245),(25.875,11.095),(25.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.415),(25.725,11.565),(25.875,11.565),(25.875,11.415),(25.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,11.735),(25.725,11.885),(25.875,11.885),(25.875,11.735),(25.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.055),(25.725,12.205),(25.875,12.205),(25.875,12.055),(25.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.375),(25.725,12.525),(25.875,12.525),(25.875,12.375),(25.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,12.695),(25.725,12.845),(25.875,12.845),(25.875,12.695),(25.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.015),(25.725,13.165),(25.875,13.165),(25.875,13.015),(25.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.335),(25.725,13.485),(25.875,13.485),(25.875,13.335),(25.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.655),(25.725,13.805),(25.875,13.805),(25.875,13.655),(25.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,13.975),(25.725,14.125),(25.875,14.125),(25.875,13.975),(25.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.295),(25.725,14.445),(25.875,14.445),(25.875,14.295),(25.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.615),(25.725,14.765),(25.875,14.765),(25.875,14.615),(25.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,14.935),(25.725,15.085),(25.875,15.085),(25.875,14.935),(25.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.255),(25.725,15.405),(25.875,15.405),(25.875,15.255),(25.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.575),(25.725,15.725),(25.875,15.725),(25.875,15.575),(25.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,15.895),(25.725,16.045),(25.875,16.045),(25.875,15.895),(25.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.215),(25.725,16.365),(25.875,16.365),(25.875,16.215),(25.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.535),(25.725,16.685),(25.875,16.685),(25.875,16.535),(25.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,16.855),(25.725,17.005),(25.875,17.005),(25.875,16.855),(25.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.175),(25.725,17.325),(25.875,17.325),(25.875,17.175),(25.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.495),(25.725,17.645),(25.875,17.645),(25.875,17.495),(25.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,17.815),(25.725,17.965),(25.875,17.965),(25.875,17.815),(25.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.135),(25.725,18.285),(25.875,18.285),(25.875,18.135),(25.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.455),(25.725,18.605),(25.875,18.605),(25.875,18.455),(25.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,18.775),(25.725,18.925),(25.875,18.925),(25.875,18.775),(25.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.095),(25.725,19.245),(25.875,19.245),(25.875,19.095),(25.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.415),(25.725,19.565),(25.875,19.565),(25.875,19.415),(25.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,19.735),(25.725,19.885),(25.875,19.885),(25.875,19.735),(25.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.055),(25.725,20.205),(25.875,20.205),(25.875,20.055),(25.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.375),(25.725,20.525),(25.875,20.525),(25.875,20.375),(25.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,20.695),(25.725,20.845),(25.875,20.845),(25.875,20.695),(25.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.015),(25.725,21.165),(25.875,21.165),(25.875,21.015),(25.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.335),(25.725,21.485),(25.875,21.485),(25.875,21.335),(25.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.655),(25.725,21.805),(25.875,21.805),(25.875,21.655),(25.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((25.725,21.975),(25.725,22.125),(25.875,22.125),(25.875,21.975),(25.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.215),(78.525,0.365),(78.675,0.365),(78.675,0.215),(78.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.535),(78.525,0.685),(78.675,0.685),(78.675,0.535),(78.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,0.855),(78.525,1.005),(78.675,1.005),(78.675,0.855),(78.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.175),(78.525,1.325),(78.675,1.325),(78.675,1.175),(78.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.495),(78.525,1.645),(78.675,1.645),(78.675,1.495),(78.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,1.815),(78.525,1.965),(78.675,1.965),(78.675,1.815),(78.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.135),(78.525,2.285),(78.675,2.285),(78.675,2.135),(78.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.455),(78.525,2.605),(78.675,2.605),(78.675,2.455),(78.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,2.775),(78.525,2.925),(78.675,2.925),(78.675,2.775),(78.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.095),(78.525,3.245),(78.675,3.245),(78.675,3.095),(78.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.415),(78.525,3.565),(78.675,3.565),(78.675,3.415),(78.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,3.735),(78.525,3.885),(78.675,3.885),(78.675,3.735),(78.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.055),(78.525,4.205),(78.675,4.205),(78.675,4.055),(78.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.375),(78.525,4.525),(78.675,4.525),(78.675,4.375),(78.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,4.695),(78.525,4.845),(78.675,4.845),(78.675,4.695),(78.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.015),(78.525,5.165),(78.675,5.165),(78.675,5.015),(78.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.335),(78.525,5.485),(78.675,5.485),(78.675,5.335),(78.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.655),(78.525,5.805),(78.675,5.805),(78.675,5.655),(78.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,5.975),(78.525,6.125),(78.675,6.125),(78.675,5.975),(78.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.295),(78.525,6.445),(78.675,6.445),(78.675,6.295),(78.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.615),(78.525,6.765),(78.675,6.765),(78.675,6.615),(78.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,6.935),(78.525,7.085),(78.675,7.085),(78.675,6.935),(78.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.255),(78.525,7.405),(78.675,7.405),(78.675,7.255),(78.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.575),(78.525,7.725),(78.675,7.725),(78.675,7.575),(78.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,7.895),(78.525,8.045),(78.675,8.045),(78.675,7.895),(78.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.215),(78.525,8.365),(78.675,8.365),(78.675,8.215),(78.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.535),(78.525,8.685),(78.675,8.685),(78.675,8.535),(78.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,8.855),(78.525,9.005),(78.675,9.005),(78.675,8.855),(78.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.175),(78.525,9.325),(78.675,9.325),(78.675,9.175),(78.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.495),(78.525,9.645),(78.675,9.645),(78.675,9.495),(78.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,9.815),(78.525,9.965),(78.675,9.965),(78.675,9.815),(78.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.135),(78.525,10.285),(78.675,10.285),(78.675,10.135),(78.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.455),(78.525,10.605),(78.675,10.605),(78.675,10.455),(78.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,10.775),(78.525,10.925),(78.675,10.925),(78.675,10.775),(78.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.095),(78.525,11.245),(78.675,11.245),(78.675,11.095),(78.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.415),(78.525,11.565),(78.675,11.565),(78.675,11.415),(78.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,11.735),(78.525,11.885),(78.675,11.885),(78.675,11.735),(78.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.055),(78.525,12.205),(78.675,12.205),(78.675,12.055),(78.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.375),(78.525,12.525),(78.675,12.525),(78.675,12.375),(78.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,12.695),(78.525,12.845),(78.675,12.845),(78.675,12.695),(78.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.015),(78.525,13.165),(78.675,13.165),(78.675,13.015),(78.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.335),(78.525,13.485),(78.675,13.485),(78.675,13.335),(78.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.655),(78.525,13.805),(78.675,13.805),(78.675,13.655),(78.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,13.975),(78.525,14.125),(78.675,14.125),(78.675,13.975),(78.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.295),(78.525,14.445),(78.675,14.445),(78.675,14.295),(78.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.615),(78.525,14.765),(78.675,14.765),(78.675,14.615),(78.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,14.935),(78.525,15.085),(78.675,15.085),(78.675,14.935),(78.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.255),(78.525,15.405),(78.675,15.405),(78.675,15.255),(78.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.575),(78.525,15.725),(78.675,15.725),(78.675,15.575),(78.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,15.895),(78.525,16.045),(78.675,16.045),(78.675,15.895),(78.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.215),(78.525,16.365),(78.675,16.365),(78.675,16.215),(78.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.535),(78.525,16.685),(78.675,16.685),(78.675,16.535),(78.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,16.855),(78.525,17.005),(78.675,17.005),(78.675,16.855),(78.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.175),(78.525,17.325),(78.675,17.325),(78.675,17.175),(78.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.495),(78.525,17.645),(78.675,17.645),(78.675,17.495),(78.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,17.815),(78.525,17.965),(78.675,17.965),(78.675,17.815),(78.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.135),(78.525,18.285),(78.675,18.285),(78.675,18.135),(78.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.455),(78.525,18.605),(78.675,18.605),(78.675,18.455),(78.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,18.775),(78.525,18.925),(78.675,18.925),(78.675,18.775),(78.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.095),(78.525,19.245),(78.675,19.245),(78.675,19.095),(78.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.415),(78.525,19.565),(78.675,19.565),(78.675,19.415),(78.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,19.735),(78.525,19.885),(78.675,19.885),(78.675,19.735),(78.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.055),(78.525,20.205),(78.675,20.205),(78.675,20.055),(78.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.375),(78.525,20.525),(78.675,20.525),(78.675,20.375),(78.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,20.695),(78.525,20.845),(78.675,20.845),(78.675,20.695),(78.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.015),(78.525,21.165),(78.675,21.165),(78.675,21.015),(78.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.335),(78.525,21.485),(78.675,21.485),(78.675,21.335),(78.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.655),(78.525,21.805),(78.675,21.805),(78.675,21.655),(78.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((78.525,21.975),(78.525,22.125),(78.675,22.125),(78.675,21.975),(78.525,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.215),(64.125,0.365),(64.275,0.365),(64.275,0.215),(64.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.535),(64.125,0.685),(64.275,0.685),(64.275,0.535),(64.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,0.855),(64.125,1.005),(64.275,1.005),(64.275,0.855),(64.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.175),(64.125,1.325),(64.275,1.325),(64.275,1.175),(64.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.495),(64.125,1.645),(64.275,1.645),(64.275,1.495),(64.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,1.815),(64.125,1.965),(64.275,1.965),(64.275,1.815),(64.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.135),(64.125,2.285),(64.275,2.285),(64.275,2.135),(64.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.455),(64.125,2.605),(64.275,2.605),(64.275,2.455),(64.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,2.775),(64.125,2.925),(64.275,2.925),(64.275,2.775),(64.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.095),(64.125,3.245),(64.275,3.245),(64.275,3.095),(64.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.415),(64.125,3.565),(64.275,3.565),(64.275,3.415),(64.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,3.735),(64.125,3.885),(64.275,3.885),(64.275,3.735),(64.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.055),(64.125,4.205),(64.275,4.205),(64.275,4.055),(64.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.375),(64.125,4.525),(64.275,4.525),(64.275,4.375),(64.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,4.695),(64.125,4.845),(64.275,4.845),(64.275,4.695),(64.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.015),(64.125,5.165),(64.275,5.165),(64.275,5.015),(64.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.335),(64.125,5.485),(64.275,5.485),(64.275,5.335),(64.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.655),(64.125,5.805),(64.275,5.805),(64.275,5.655),(64.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,5.975),(64.125,6.125),(64.275,6.125),(64.275,5.975),(64.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.295),(64.125,6.445),(64.275,6.445),(64.275,6.295),(64.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.615),(64.125,6.765),(64.275,6.765),(64.275,6.615),(64.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,6.935),(64.125,7.085),(64.275,7.085),(64.275,6.935),(64.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.255),(64.125,7.405),(64.275,7.405),(64.275,7.255),(64.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.575),(64.125,7.725),(64.275,7.725),(64.275,7.575),(64.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,7.895),(64.125,8.045),(64.275,8.045),(64.275,7.895),(64.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.215),(64.125,8.365),(64.275,8.365),(64.275,8.215),(64.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.535),(64.125,8.685),(64.275,8.685),(64.275,8.535),(64.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,8.855),(64.125,9.005),(64.275,9.005),(64.275,8.855),(64.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.175),(64.125,9.325),(64.275,9.325),(64.275,9.175),(64.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.495),(64.125,9.645),(64.275,9.645),(64.275,9.495),(64.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,9.815),(64.125,9.965),(64.275,9.965),(64.275,9.815),(64.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.135),(64.125,10.285),(64.275,10.285),(64.275,10.135),(64.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.455),(64.125,10.605),(64.275,10.605),(64.275,10.455),(64.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,10.775),(64.125,10.925),(64.275,10.925),(64.275,10.775),(64.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.095),(64.125,11.245),(64.275,11.245),(64.275,11.095),(64.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.415),(64.125,11.565),(64.275,11.565),(64.275,11.415),(64.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,11.735),(64.125,11.885),(64.275,11.885),(64.275,11.735),(64.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.055),(64.125,12.205),(64.275,12.205),(64.275,12.055),(64.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.375),(64.125,12.525),(64.275,12.525),(64.275,12.375),(64.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,12.695),(64.125,12.845),(64.275,12.845),(64.275,12.695),(64.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.015),(64.125,13.165),(64.275,13.165),(64.275,13.015),(64.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.335),(64.125,13.485),(64.275,13.485),(64.275,13.335),(64.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.655),(64.125,13.805),(64.275,13.805),(64.275,13.655),(64.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,13.975),(64.125,14.125),(64.275,14.125),(64.275,13.975),(64.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.295),(64.125,14.445),(64.275,14.445),(64.275,14.295),(64.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.615),(64.125,14.765),(64.275,14.765),(64.275,14.615),(64.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,14.935),(64.125,15.085),(64.275,15.085),(64.275,14.935),(64.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.255),(64.125,15.405),(64.275,15.405),(64.275,15.255),(64.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.575),(64.125,15.725),(64.275,15.725),(64.275,15.575),(64.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,15.895),(64.125,16.045),(64.275,16.045),(64.275,15.895),(64.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.215),(64.125,16.365),(64.275,16.365),(64.275,16.215),(64.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.535),(64.125,16.685),(64.275,16.685),(64.275,16.535),(64.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,16.855),(64.125,17.005),(64.275,17.005),(64.275,16.855),(64.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.175),(64.125,17.325),(64.275,17.325),(64.275,17.175),(64.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.495),(64.125,17.645),(64.275,17.645),(64.275,17.495),(64.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,17.815),(64.125,17.965),(64.275,17.965),(64.275,17.815),(64.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.135),(64.125,18.285),(64.275,18.285),(64.275,18.135),(64.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.455),(64.125,18.605),(64.275,18.605),(64.275,18.455),(64.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,18.775),(64.125,18.925),(64.275,18.925),(64.275,18.775),(64.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.095),(64.125,19.245),(64.275,19.245),(64.275,19.095),(64.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.415),(64.125,19.565),(64.275,19.565),(64.275,19.415),(64.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,19.735),(64.125,19.885),(64.275,19.885),(64.275,19.735),(64.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.055),(64.125,20.205),(64.275,20.205),(64.275,20.055),(64.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.375),(64.125,20.525),(64.275,20.525),(64.275,20.375),(64.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,20.695),(64.125,20.845),(64.275,20.845),(64.275,20.695),(64.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.015),(64.125,21.165),(64.275,21.165),(64.275,21.015),(64.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.335),(64.125,21.485),(64.275,21.485),(64.275,21.335),(64.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.655),(64.125,21.805),(64.275,21.805),(64.275,21.655),(64.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((64.125,21.975),(64.125,22.125),(64.275,22.125),(64.275,21.975),(64.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.215),(54.525,0.365),(54.675,0.365),(54.675,0.215),(54.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.535),(54.525,0.685),(54.675,0.685),(54.675,0.535),(54.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.855),(54.525,1.005),(54.675,1.005),(54.675,0.855),(54.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.175),(54.525,1.325),(54.675,1.325),(54.675,1.175),(54.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.495),(54.525,1.645),(54.675,1.645),(54.675,1.495),(54.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.815),(54.525,1.965),(54.675,1.965),(54.675,1.815),(54.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.135),(54.525,2.285),(54.675,2.285),(54.675,2.135),(54.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.455),(54.525,2.605),(54.675,2.605),(54.675,2.455),(54.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.775),(54.525,2.925),(54.675,2.925),(54.675,2.775),(54.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.095),(54.525,3.245),(54.675,3.245),(54.675,3.095),(54.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.415),(54.525,3.565),(54.675,3.565),(54.675,3.415),(54.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.735),(54.525,3.885),(54.675,3.885),(54.675,3.735),(54.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.055),(54.525,4.205),(54.675,4.205),(54.675,4.055),(54.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.375),(54.525,4.525),(54.675,4.525),(54.675,4.375),(54.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.695),(54.525,4.845),(54.675,4.845),(54.675,4.695),(54.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.015),(54.525,5.165),(54.675,5.165),(54.675,5.015),(54.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.335),(54.525,5.485),(54.675,5.485),(54.675,5.335),(54.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.655),(54.525,5.805),(54.675,5.805),(54.675,5.655),(54.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.975),(54.525,6.125),(54.675,6.125),(54.675,5.975),(54.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.295),(54.525,6.445),(54.675,6.445),(54.675,6.295),(54.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.615),(54.525,6.765),(54.675,6.765),(54.675,6.615),(54.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.935),(54.525,7.085),(54.675,7.085),(54.675,6.935),(54.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.255),(54.525,7.405),(54.675,7.405),(54.675,7.255),(54.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.575),(54.525,7.725),(54.675,7.725),(54.675,7.575),(54.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.895),(54.525,8.045),(54.675,8.045),(54.675,7.895),(54.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.215),(54.525,8.365),(54.675,8.365),(54.675,8.215),(54.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.535),(54.525,8.685),(54.675,8.685),(54.675,8.535),(54.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.855),(54.525,9.005),(54.675,9.005),(54.675,8.855),(54.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.175),(54.525,9.325),(54.675,9.325),(54.675,9.175),(54.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.495),(54.525,9.645),(54.675,9.645),(54.675,9.495),(54.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.815),(54.525,9.965),(54.675,9.965),(54.675,9.815),(54.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.135),(54.525,10.285),(54.675,10.285),(54.675,10.135),(54.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.455),(54.525,10.605),(54.675,10.605),(54.675,10.455),(54.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.775),(54.525,10.925),(54.675,10.925),(54.675,10.775),(54.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.095),(54.525,11.245),(54.675,11.245),(54.675,11.095),(54.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.415),(54.525,11.565),(54.675,11.565),(54.675,11.415),(54.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.735),(54.525,11.885),(54.675,11.885),(54.675,11.735),(54.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.055),(54.525,12.205),(54.675,12.205),(54.675,12.055),(54.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.375),(54.525,12.525),(54.675,12.525),(54.675,12.375),(54.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.695),(54.525,12.845),(54.675,12.845),(54.675,12.695),(54.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.015),(54.525,13.165),(54.675,13.165),(54.675,13.015),(54.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.335),(54.525,13.485),(54.675,13.485),(54.675,13.335),(54.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.655),(54.525,13.805),(54.675,13.805),(54.675,13.655),(54.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.975),(54.525,14.125),(54.675,14.125),(54.675,13.975),(54.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.295),(54.525,14.445),(54.675,14.445),(54.675,14.295),(54.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.615),(54.525,14.765),(54.675,14.765),(54.675,14.615),(54.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.935),(54.525,15.085),(54.675,15.085),(54.675,14.935),(54.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.255),(54.525,15.405),(54.675,15.405),(54.675,15.255),(54.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.575),(54.525,15.725),(54.675,15.725),(54.675,15.575),(54.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.895),(54.525,16.045),(54.675,16.045),(54.675,15.895),(54.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.215),(54.525,16.365),(54.675,16.365),(54.675,16.215),(54.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.535),(54.525,16.685),(54.675,16.685),(54.675,16.535),(54.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.855),(54.525,17.005),(54.675,17.005),(54.675,16.855),(54.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.175),(54.525,17.325),(54.675,17.325),(54.675,17.175),(54.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.495),(54.525,17.645),(54.675,17.645),(54.675,17.495),(54.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.815),(54.525,17.965),(54.675,17.965),(54.675,17.815),(54.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.135),(54.525,18.285),(54.675,18.285),(54.675,18.135),(54.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.455),(54.525,18.605),(54.675,18.605),(54.675,18.455),(54.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.775),(54.525,18.925),(54.675,18.925),(54.675,18.775),(54.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.095),(54.525,19.245),(54.675,19.245),(54.675,19.095),(54.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.415),(54.525,19.565),(54.675,19.565),(54.675,19.415),(54.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.735),(54.525,19.885),(54.675,19.885),(54.675,19.735),(54.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.055),(54.525,20.205),(54.675,20.205),(54.675,20.055),(54.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.375),(54.525,20.525),(54.675,20.525),(54.675,20.375),(54.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.695),(54.525,20.845),(54.675,20.845),(54.675,20.695),(54.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.015),(54.525,21.165),(54.675,21.165),(54.675,21.015),(54.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.335),(54.525,21.485),(54.675,21.485),(54.675,21.335),(54.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.655),(54.525,21.805),(54.675,21.805),(54.675,21.655),(54.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.975),(54.525,22.125),(54.675,22.125),(54.675,21.975),(54.525,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.215),(16.125,0.365),(16.275,0.365),(16.275,0.215),(16.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.535),(16.125,0.685),(16.275,0.685),(16.275,0.535),(16.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,0.855),(16.125,1.005),(16.275,1.005),(16.275,0.855),(16.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.175),(16.125,1.325),(16.275,1.325),(16.275,1.175),(16.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.495),(16.125,1.645),(16.275,1.645),(16.275,1.495),(16.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,1.815),(16.125,1.965),(16.275,1.965),(16.275,1.815),(16.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.135),(16.125,2.285),(16.275,2.285),(16.275,2.135),(16.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.455),(16.125,2.605),(16.275,2.605),(16.275,2.455),(16.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,2.775),(16.125,2.925),(16.275,2.925),(16.275,2.775),(16.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.095),(16.125,3.245),(16.275,3.245),(16.275,3.095),(16.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.415),(16.125,3.565),(16.275,3.565),(16.275,3.415),(16.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,3.735),(16.125,3.885),(16.275,3.885),(16.275,3.735),(16.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.055),(16.125,4.205),(16.275,4.205),(16.275,4.055),(16.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.375),(16.125,4.525),(16.275,4.525),(16.275,4.375),(16.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,4.695),(16.125,4.845),(16.275,4.845),(16.275,4.695),(16.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.015),(16.125,5.165),(16.275,5.165),(16.275,5.015),(16.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.335),(16.125,5.485),(16.275,5.485),(16.275,5.335),(16.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.655),(16.125,5.805),(16.275,5.805),(16.275,5.655),(16.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,5.975),(16.125,6.125),(16.275,6.125),(16.275,5.975),(16.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.295),(16.125,6.445),(16.275,6.445),(16.275,6.295),(16.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.615),(16.125,6.765),(16.275,6.765),(16.275,6.615),(16.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,6.935),(16.125,7.085),(16.275,7.085),(16.275,6.935),(16.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.255),(16.125,7.405),(16.275,7.405),(16.275,7.255),(16.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.575),(16.125,7.725),(16.275,7.725),(16.275,7.575),(16.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,7.895),(16.125,8.045),(16.275,8.045),(16.275,7.895),(16.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.215),(16.125,8.365),(16.275,8.365),(16.275,8.215),(16.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.535),(16.125,8.685),(16.275,8.685),(16.275,8.535),(16.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,8.855),(16.125,9.005),(16.275,9.005),(16.275,8.855),(16.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.175),(16.125,9.325),(16.275,9.325),(16.275,9.175),(16.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.495),(16.125,9.645),(16.275,9.645),(16.275,9.495),(16.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,9.815),(16.125,9.965),(16.275,9.965),(16.275,9.815),(16.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.135),(16.125,10.285),(16.275,10.285),(16.275,10.135),(16.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.455),(16.125,10.605),(16.275,10.605),(16.275,10.455),(16.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,10.775),(16.125,10.925),(16.275,10.925),(16.275,10.775),(16.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.095),(16.125,11.245),(16.275,11.245),(16.275,11.095),(16.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.415),(16.125,11.565),(16.275,11.565),(16.275,11.415),(16.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,11.735),(16.125,11.885),(16.275,11.885),(16.275,11.735),(16.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.055),(16.125,12.205),(16.275,12.205),(16.275,12.055),(16.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.375),(16.125,12.525),(16.275,12.525),(16.275,12.375),(16.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,12.695),(16.125,12.845),(16.275,12.845),(16.275,12.695),(16.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.015),(16.125,13.165),(16.275,13.165),(16.275,13.015),(16.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.335),(16.125,13.485),(16.275,13.485),(16.275,13.335),(16.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.655),(16.125,13.805),(16.275,13.805),(16.275,13.655),(16.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,13.975),(16.125,14.125),(16.275,14.125),(16.275,13.975),(16.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.295),(16.125,14.445),(16.275,14.445),(16.275,14.295),(16.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.615),(16.125,14.765),(16.275,14.765),(16.275,14.615),(16.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,14.935),(16.125,15.085),(16.275,15.085),(16.275,14.935),(16.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.255),(16.125,15.405),(16.275,15.405),(16.275,15.255),(16.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.575),(16.125,15.725),(16.275,15.725),(16.275,15.575),(16.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,15.895),(16.125,16.045),(16.275,16.045),(16.275,15.895),(16.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.215),(16.125,16.365),(16.275,16.365),(16.275,16.215),(16.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.535),(16.125,16.685),(16.275,16.685),(16.275,16.535),(16.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,16.855),(16.125,17.005),(16.275,17.005),(16.275,16.855),(16.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.175),(16.125,17.325),(16.275,17.325),(16.275,17.175),(16.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.495),(16.125,17.645),(16.275,17.645),(16.275,17.495),(16.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,17.815),(16.125,17.965),(16.275,17.965),(16.275,17.815),(16.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.135),(16.125,18.285),(16.275,18.285),(16.275,18.135),(16.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.455),(16.125,18.605),(16.275,18.605),(16.275,18.455),(16.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,18.775),(16.125,18.925),(16.275,18.925),(16.275,18.775),(16.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.095),(16.125,19.245),(16.275,19.245),(16.275,19.095),(16.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.415),(16.125,19.565),(16.275,19.565),(16.275,19.415),(16.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,19.735),(16.125,19.885),(16.275,19.885),(16.275,19.735),(16.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.055),(16.125,20.205),(16.275,20.205),(16.275,20.055),(16.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.375),(16.125,20.525),(16.275,20.525),(16.275,20.375),(16.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,20.695),(16.125,20.845),(16.275,20.845),(16.275,20.695),(16.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.015),(16.125,21.165),(16.275,21.165),(16.275,21.015),(16.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.335),(16.125,21.485),(16.275,21.485),(16.275,21.335),(16.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.655),(16.125,21.805),(16.275,21.805),(16.275,21.655),(16.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((16.125,21.975),(16.125,22.125),(16.275,22.125),(16.275,21.975),(16.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.215),(20.925,0.365),(21.075,0.365),(21.075,0.215),(20.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.535),(20.925,0.685),(21.075,0.685),(21.075,0.535),(20.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,0.855),(20.925,1.005),(21.075,1.005),(21.075,0.855),(20.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.175),(20.925,1.325),(21.075,1.325),(21.075,1.175),(20.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.495),(20.925,1.645),(21.075,1.645),(21.075,1.495),(20.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,1.815),(20.925,1.965),(21.075,1.965),(21.075,1.815),(20.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.135),(20.925,2.285),(21.075,2.285),(21.075,2.135),(20.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.455),(20.925,2.605),(21.075,2.605),(21.075,2.455),(20.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,2.775),(20.925,2.925),(21.075,2.925),(21.075,2.775),(20.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.095),(20.925,3.245),(21.075,3.245),(21.075,3.095),(20.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.415),(20.925,3.565),(21.075,3.565),(21.075,3.415),(20.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,3.735),(20.925,3.885),(21.075,3.885),(21.075,3.735),(20.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.055),(20.925,4.205),(21.075,4.205),(21.075,4.055),(20.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.375),(20.925,4.525),(21.075,4.525),(21.075,4.375),(20.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,4.695),(20.925,4.845),(21.075,4.845),(21.075,4.695),(20.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.015),(20.925,5.165),(21.075,5.165),(21.075,5.015),(20.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.335),(20.925,5.485),(21.075,5.485),(21.075,5.335),(20.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.655),(20.925,5.805),(21.075,5.805),(21.075,5.655),(20.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,5.975),(20.925,6.125),(21.075,6.125),(21.075,5.975),(20.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.295),(20.925,6.445),(21.075,6.445),(21.075,6.295),(20.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.615),(20.925,6.765),(21.075,6.765),(21.075,6.615),(20.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,6.935),(20.925,7.085),(21.075,7.085),(21.075,6.935),(20.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.255),(20.925,7.405),(21.075,7.405),(21.075,7.255),(20.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.575),(20.925,7.725),(21.075,7.725),(21.075,7.575),(20.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,7.895),(20.925,8.045),(21.075,8.045),(21.075,7.895),(20.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.215),(20.925,8.365),(21.075,8.365),(21.075,8.215),(20.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.535),(20.925,8.685),(21.075,8.685),(21.075,8.535),(20.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,8.855),(20.925,9.005),(21.075,9.005),(21.075,8.855),(20.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.175),(20.925,9.325),(21.075,9.325),(21.075,9.175),(20.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.495),(20.925,9.645),(21.075,9.645),(21.075,9.495),(20.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,9.815),(20.925,9.965),(21.075,9.965),(21.075,9.815),(20.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.135),(20.925,10.285),(21.075,10.285),(21.075,10.135),(20.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.455),(20.925,10.605),(21.075,10.605),(21.075,10.455),(20.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,10.775),(20.925,10.925),(21.075,10.925),(21.075,10.775),(20.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.095),(20.925,11.245),(21.075,11.245),(21.075,11.095),(20.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.415),(20.925,11.565),(21.075,11.565),(21.075,11.415),(20.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,11.735),(20.925,11.885),(21.075,11.885),(21.075,11.735),(20.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.055),(20.925,12.205),(21.075,12.205),(21.075,12.055),(20.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.375),(20.925,12.525),(21.075,12.525),(21.075,12.375),(20.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,12.695),(20.925,12.845),(21.075,12.845),(21.075,12.695),(20.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.015),(20.925,13.165),(21.075,13.165),(21.075,13.015),(20.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.335),(20.925,13.485),(21.075,13.485),(21.075,13.335),(20.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.655),(20.925,13.805),(21.075,13.805),(21.075,13.655),(20.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,13.975),(20.925,14.125),(21.075,14.125),(21.075,13.975),(20.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.295),(20.925,14.445),(21.075,14.445),(21.075,14.295),(20.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.615),(20.925,14.765),(21.075,14.765),(21.075,14.615),(20.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,14.935),(20.925,15.085),(21.075,15.085),(21.075,14.935),(20.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.255),(20.925,15.405),(21.075,15.405),(21.075,15.255),(20.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.575),(20.925,15.725),(21.075,15.725),(21.075,15.575),(20.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,15.895),(20.925,16.045),(21.075,16.045),(21.075,15.895),(20.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.215),(20.925,16.365),(21.075,16.365),(21.075,16.215),(20.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.535),(20.925,16.685),(21.075,16.685),(21.075,16.535),(20.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,16.855),(20.925,17.005),(21.075,17.005),(21.075,16.855),(20.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.175),(20.925,17.325),(21.075,17.325),(21.075,17.175),(20.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.495),(20.925,17.645),(21.075,17.645),(21.075,17.495),(20.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,17.815),(20.925,17.965),(21.075,17.965),(21.075,17.815),(20.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.135),(20.925,18.285),(21.075,18.285),(21.075,18.135),(20.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.455),(20.925,18.605),(21.075,18.605),(21.075,18.455),(20.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,18.775),(20.925,18.925),(21.075,18.925),(21.075,18.775),(20.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.095),(20.925,19.245),(21.075,19.245),(21.075,19.095),(20.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.415),(20.925,19.565),(21.075,19.565),(21.075,19.415),(20.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,19.735),(20.925,19.885),(21.075,19.885),(21.075,19.735),(20.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.055),(20.925,20.205),(21.075,20.205),(21.075,20.055),(20.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.375),(20.925,20.525),(21.075,20.525),(21.075,20.375),(20.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,20.695),(20.925,20.845),(21.075,20.845),(21.075,20.695),(20.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.015),(20.925,21.165),(21.075,21.165),(21.075,21.015),(20.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.335),(20.925,21.485),(21.075,21.485),(21.075,21.335),(20.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.655),(20.925,21.805),(21.075,21.805),(21.075,21.655),(20.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((20.925,21.975),(20.925,22.125),(21.075,22.125),(21.075,21.975),(20.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.215),(73.725,0.365),(73.875,0.365),(73.875,0.215),(73.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.535),(73.725,0.685),(73.875,0.685),(73.875,0.535),(73.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,0.855),(73.725,1.005),(73.875,1.005),(73.875,0.855),(73.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.175),(73.725,1.325),(73.875,1.325),(73.875,1.175),(73.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.495),(73.725,1.645),(73.875,1.645),(73.875,1.495),(73.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,1.815),(73.725,1.965),(73.875,1.965),(73.875,1.815),(73.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.135),(73.725,2.285),(73.875,2.285),(73.875,2.135),(73.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.455),(73.725,2.605),(73.875,2.605),(73.875,2.455),(73.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,2.775),(73.725,2.925),(73.875,2.925),(73.875,2.775),(73.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.095),(73.725,3.245),(73.875,3.245),(73.875,3.095),(73.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.415),(73.725,3.565),(73.875,3.565),(73.875,3.415),(73.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,3.735),(73.725,3.885),(73.875,3.885),(73.875,3.735),(73.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.055),(73.725,4.205),(73.875,4.205),(73.875,4.055),(73.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.375),(73.725,4.525),(73.875,4.525),(73.875,4.375),(73.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,4.695),(73.725,4.845),(73.875,4.845),(73.875,4.695),(73.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.015),(73.725,5.165),(73.875,5.165),(73.875,5.015),(73.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.335),(73.725,5.485),(73.875,5.485),(73.875,5.335),(73.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.655),(73.725,5.805),(73.875,5.805),(73.875,5.655),(73.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,5.975),(73.725,6.125),(73.875,6.125),(73.875,5.975),(73.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.295),(73.725,6.445),(73.875,6.445),(73.875,6.295),(73.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.615),(73.725,6.765),(73.875,6.765),(73.875,6.615),(73.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,6.935),(73.725,7.085),(73.875,7.085),(73.875,6.935),(73.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.255),(73.725,7.405),(73.875,7.405),(73.875,7.255),(73.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.575),(73.725,7.725),(73.875,7.725),(73.875,7.575),(73.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,7.895),(73.725,8.045),(73.875,8.045),(73.875,7.895),(73.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.215),(73.725,8.365),(73.875,8.365),(73.875,8.215),(73.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.535),(73.725,8.685),(73.875,8.685),(73.875,8.535),(73.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,8.855),(73.725,9.005),(73.875,9.005),(73.875,8.855),(73.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.175),(73.725,9.325),(73.875,9.325),(73.875,9.175),(73.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.495),(73.725,9.645),(73.875,9.645),(73.875,9.495),(73.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,9.815),(73.725,9.965),(73.875,9.965),(73.875,9.815),(73.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.135),(73.725,10.285),(73.875,10.285),(73.875,10.135),(73.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.455),(73.725,10.605),(73.875,10.605),(73.875,10.455),(73.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,10.775),(73.725,10.925),(73.875,10.925),(73.875,10.775),(73.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.095),(73.725,11.245),(73.875,11.245),(73.875,11.095),(73.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.415),(73.725,11.565),(73.875,11.565),(73.875,11.415),(73.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,11.735),(73.725,11.885),(73.875,11.885),(73.875,11.735),(73.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.055),(73.725,12.205),(73.875,12.205),(73.875,12.055),(73.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.375),(73.725,12.525),(73.875,12.525),(73.875,12.375),(73.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,12.695),(73.725,12.845),(73.875,12.845),(73.875,12.695),(73.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.015),(73.725,13.165),(73.875,13.165),(73.875,13.015),(73.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.335),(73.725,13.485),(73.875,13.485),(73.875,13.335),(73.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.655),(73.725,13.805),(73.875,13.805),(73.875,13.655),(73.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,13.975),(73.725,14.125),(73.875,14.125),(73.875,13.975),(73.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.295),(73.725,14.445),(73.875,14.445),(73.875,14.295),(73.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.615),(73.725,14.765),(73.875,14.765),(73.875,14.615),(73.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,14.935),(73.725,15.085),(73.875,15.085),(73.875,14.935),(73.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.255),(73.725,15.405),(73.875,15.405),(73.875,15.255),(73.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.575),(73.725,15.725),(73.875,15.725),(73.875,15.575),(73.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,15.895),(73.725,16.045),(73.875,16.045),(73.875,15.895),(73.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.215),(73.725,16.365),(73.875,16.365),(73.875,16.215),(73.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.535),(73.725,16.685),(73.875,16.685),(73.875,16.535),(73.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,16.855),(73.725,17.005),(73.875,17.005),(73.875,16.855),(73.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.175),(73.725,17.325),(73.875,17.325),(73.875,17.175),(73.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.495),(73.725,17.645),(73.875,17.645),(73.875,17.495),(73.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,17.815),(73.725,17.965),(73.875,17.965),(73.875,17.815),(73.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.135),(73.725,18.285),(73.875,18.285),(73.875,18.135),(73.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.455),(73.725,18.605),(73.875,18.605),(73.875,18.455),(73.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,18.775),(73.725,18.925),(73.875,18.925),(73.875,18.775),(73.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.095),(73.725,19.245),(73.875,19.245),(73.875,19.095),(73.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.415),(73.725,19.565),(73.875,19.565),(73.875,19.415),(73.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,19.735),(73.725,19.885),(73.875,19.885),(73.875,19.735),(73.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.055),(73.725,20.205),(73.875,20.205),(73.875,20.055),(73.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.375),(73.725,20.525),(73.875,20.525),(73.875,20.375),(73.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,20.695),(73.725,20.845),(73.875,20.845),(73.875,20.695),(73.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.015),(73.725,21.165),(73.875,21.165),(73.875,21.015),(73.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.335),(73.725,21.485),(73.875,21.485),(73.875,21.335),(73.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.655),(73.725,21.805),(73.875,21.805),(73.875,21.655),(73.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((73.725,21.975),(73.725,22.125),(73.875,22.125),(73.875,21.975),(73.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.215),(11.325,0.365),(11.475,0.365),(11.475,0.215),(11.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.535),(11.325,0.685),(11.475,0.685),(11.475,0.535),(11.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,0.855),(11.325,1.005),(11.475,1.005),(11.475,0.855),(11.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.175),(11.325,1.325),(11.475,1.325),(11.475,1.175),(11.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.495),(11.325,1.645),(11.475,1.645),(11.475,1.495),(11.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,1.815),(11.325,1.965),(11.475,1.965),(11.475,1.815),(11.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.135),(11.325,2.285),(11.475,2.285),(11.475,2.135),(11.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.455),(11.325,2.605),(11.475,2.605),(11.475,2.455),(11.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,2.775),(11.325,2.925),(11.475,2.925),(11.475,2.775),(11.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.095),(11.325,3.245),(11.475,3.245),(11.475,3.095),(11.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.415),(11.325,3.565),(11.475,3.565),(11.475,3.415),(11.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,3.735),(11.325,3.885),(11.475,3.885),(11.475,3.735),(11.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.055),(11.325,4.205),(11.475,4.205),(11.475,4.055),(11.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.375),(11.325,4.525),(11.475,4.525),(11.475,4.375),(11.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,4.695),(11.325,4.845),(11.475,4.845),(11.475,4.695),(11.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.015),(11.325,5.165),(11.475,5.165),(11.475,5.015),(11.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.335),(11.325,5.485),(11.475,5.485),(11.475,5.335),(11.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.655),(11.325,5.805),(11.475,5.805),(11.475,5.655),(11.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,5.975),(11.325,6.125),(11.475,6.125),(11.475,5.975),(11.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.295),(11.325,6.445),(11.475,6.445),(11.475,6.295),(11.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.615),(11.325,6.765),(11.475,6.765),(11.475,6.615),(11.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,6.935),(11.325,7.085),(11.475,7.085),(11.475,6.935),(11.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.255),(11.325,7.405),(11.475,7.405),(11.475,7.255),(11.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.575),(11.325,7.725),(11.475,7.725),(11.475,7.575),(11.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,7.895),(11.325,8.045),(11.475,8.045),(11.475,7.895),(11.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.215),(11.325,8.365),(11.475,8.365),(11.475,8.215),(11.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.535),(11.325,8.685),(11.475,8.685),(11.475,8.535),(11.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,8.855),(11.325,9.005),(11.475,9.005),(11.475,8.855),(11.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.175),(11.325,9.325),(11.475,9.325),(11.475,9.175),(11.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.495),(11.325,9.645),(11.475,9.645),(11.475,9.495),(11.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,9.815),(11.325,9.965),(11.475,9.965),(11.475,9.815),(11.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.135),(11.325,10.285),(11.475,10.285),(11.475,10.135),(11.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.455),(11.325,10.605),(11.475,10.605),(11.475,10.455),(11.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,10.775),(11.325,10.925),(11.475,10.925),(11.475,10.775),(11.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.095),(11.325,11.245),(11.475,11.245),(11.475,11.095),(11.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.415),(11.325,11.565),(11.475,11.565),(11.475,11.415),(11.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,11.735),(11.325,11.885),(11.475,11.885),(11.475,11.735),(11.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.055),(11.325,12.205),(11.475,12.205),(11.475,12.055),(11.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.375),(11.325,12.525),(11.475,12.525),(11.475,12.375),(11.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,12.695),(11.325,12.845),(11.475,12.845),(11.475,12.695),(11.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.015),(11.325,13.165),(11.475,13.165),(11.475,13.015),(11.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.335),(11.325,13.485),(11.475,13.485),(11.475,13.335),(11.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.655),(11.325,13.805),(11.475,13.805),(11.475,13.655),(11.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,13.975),(11.325,14.125),(11.475,14.125),(11.475,13.975),(11.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.295),(11.325,14.445),(11.475,14.445),(11.475,14.295),(11.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.615),(11.325,14.765),(11.475,14.765),(11.475,14.615),(11.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,14.935),(11.325,15.085),(11.475,15.085),(11.475,14.935),(11.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.255),(11.325,15.405),(11.475,15.405),(11.475,15.255),(11.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.575),(11.325,15.725),(11.475,15.725),(11.475,15.575),(11.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,15.895),(11.325,16.045),(11.475,16.045),(11.475,15.895),(11.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.215),(11.325,16.365),(11.475,16.365),(11.475,16.215),(11.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.535),(11.325,16.685),(11.475,16.685),(11.475,16.535),(11.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,16.855),(11.325,17.005),(11.475,17.005),(11.475,16.855),(11.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.175),(11.325,17.325),(11.475,17.325),(11.475,17.175),(11.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.495),(11.325,17.645),(11.475,17.645),(11.475,17.495),(11.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,17.815),(11.325,17.965),(11.475,17.965),(11.475,17.815),(11.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.135),(11.325,18.285),(11.475,18.285),(11.475,18.135),(11.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.455),(11.325,18.605),(11.475,18.605),(11.475,18.455),(11.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,18.775),(11.325,18.925),(11.475,18.925),(11.475,18.775),(11.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.095),(11.325,19.245),(11.475,19.245),(11.475,19.095),(11.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.415),(11.325,19.565),(11.475,19.565),(11.475,19.415),(11.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,19.735),(11.325,19.885),(11.475,19.885),(11.475,19.735),(11.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.055),(11.325,20.205),(11.475,20.205),(11.475,20.055),(11.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.375),(11.325,20.525),(11.475,20.525),(11.475,20.375),(11.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,20.695),(11.325,20.845),(11.475,20.845),(11.475,20.695),(11.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.015),(11.325,21.165),(11.475,21.165),(11.475,21.015),(11.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.335),(11.325,21.485),(11.475,21.485),(11.475,21.335),(11.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.655),(11.325,21.805),(11.475,21.805),(11.475,21.655),(11.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((11.325,21.975),(11.325,22.125),(11.475,22.125),(11.475,21.975),(11.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.215),(30.525,0.365),(30.675,0.365),(30.675,0.215),(30.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.535),(30.525,0.685),(30.675,0.685),(30.675,0.535),(30.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,0.855),(30.525,1.005),(30.675,1.005),(30.675,0.855),(30.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.175),(30.525,1.325),(30.675,1.325),(30.675,1.175),(30.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.495),(30.525,1.645),(30.675,1.645),(30.675,1.495),(30.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,1.815),(30.525,1.965),(30.675,1.965),(30.675,1.815),(30.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.135),(30.525,2.285),(30.675,2.285),(30.675,2.135),(30.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.455),(30.525,2.605),(30.675,2.605),(30.675,2.455),(30.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,2.775),(30.525,2.925),(30.675,2.925),(30.675,2.775),(30.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.095),(30.525,3.245),(30.675,3.245),(30.675,3.095),(30.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.415),(30.525,3.565),(30.675,3.565),(30.675,3.415),(30.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,3.735),(30.525,3.885),(30.675,3.885),(30.675,3.735),(30.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.055),(30.525,4.205),(30.675,4.205),(30.675,4.055),(30.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.375),(30.525,4.525),(30.675,4.525),(30.675,4.375),(30.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,4.695),(30.525,4.845),(30.675,4.845),(30.675,4.695),(30.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.015),(30.525,5.165),(30.675,5.165),(30.675,5.015),(30.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.335),(30.525,5.485),(30.675,5.485),(30.675,5.335),(30.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.655),(30.525,5.805),(30.675,5.805),(30.675,5.655),(30.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,5.975),(30.525,6.125),(30.675,6.125),(30.675,5.975),(30.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.295),(30.525,6.445),(30.675,6.445),(30.675,6.295),(30.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.615),(30.525,6.765),(30.675,6.765),(30.675,6.615),(30.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,6.935),(30.525,7.085),(30.675,7.085),(30.675,6.935),(30.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.255),(30.525,7.405),(30.675,7.405),(30.675,7.255),(30.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.575),(30.525,7.725),(30.675,7.725),(30.675,7.575),(30.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,7.895),(30.525,8.045),(30.675,8.045),(30.675,7.895),(30.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.215),(30.525,8.365),(30.675,8.365),(30.675,8.215),(30.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.535),(30.525,8.685),(30.675,8.685),(30.675,8.535),(30.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,8.855),(30.525,9.005),(30.675,9.005),(30.675,8.855),(30.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.175),(30.525,9.325),(30.675,9.325),(30.675,9.175),(30.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.495),(30.525,9.645),(30.675,9.645),(30.675,9.495),(30.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,9.815),(30.525,9.965),(30.675,9.965),(30.675,9.815),(30.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.135),(30.525,10.285),(30.675,10.285),(30.675,10.135),(30.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.455),(30.525,10.605),(30.675,10.605),(30.675,10.455),(30.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,10.775),(30.525,10.925),(30.675,10.925),(30.675,10.775),(30.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.095),(30.525,11.245),(30.675,11.245),(30.675,11.095),(30.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.415),(30.525,11.565),(30.675,11.565),(30.675,11.415),(30.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,11.735),(30.525,11.885),(30.675,11.885),(30.675,11.735),(30.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.055),(30.525,12.205),(30.675,12.205),(30.675,12.055),(30.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.375),(30.525,12.525),(30.675,12.525),(30.675,12.375),(30.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,12.695),(30.525,12.845),(30.675,12.845),(30.675,12.695),(30.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.015),(30.525,13.165),(30.675,13.165),(30.675,13.015),(30.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.335),(30.525,13.485),(30.675,13.485),(30.675,13.335),(30.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.655),(30.525,13.805),(30.675,13.805),(30.675,13.655),(30.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,13.975),(30.525,14.125),(30.675,14.125),(30.675,13.975),(30.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.295),(30.525,14.445),(30.675,14.445),(30.675,14.295),(30.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.615),(30.525,14.765),(30.675,14.765),(30.675,14.615),(30.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,14.935),(30.525,15.085),(30.675,15.085),(30.675,14.935),(30.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.255),(30.525,15.405),(30.675,15.405),(30.675,15.255),(30.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.575),(30.525,15.725),(30.675,15.725),(30.675,15.575),(30.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,15.895),(30.525,16.045),(30.675,16.045),(30.675,15.895),(30.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.215),(30.525,16.365),(30.675,16.365),(30.675,16.215),(30.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.535),(30.525,16.685),(30.675,16.685),(30.675,16.535),(30.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,16.855),(30.525,17.005),(30.675,17.005),(30.675,16.855),(30.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.175),(30.525,17.325),(30.675,17.325),(30.675,17.175),(30.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.495),(30.525,17.645),(30.675,17.645),(30.675,17.495),(30.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,17.815),(30.525,17.965),(30.675,17.965),(30.675,17.815),(30.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.135),(30.525,18.285),(30.675,18.285),(30.675,18.135),(30.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.455),(30.525,18.605),(30.675,18.605),(30.675,18.455),(30.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,18.775),(30.525,18.925),(30.675,18.925),(30.675,18.775),(30.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.095),(30.525,19.245),(30.675,19.245),(30.675,19.095),(30.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.415),(30.525,19.565),(30.675,19.565),(30.675,19.415),(30.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,19.735),(30.525,19.885),(30.675,19.885),(30.675,19.735),(30.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.055),(30.525,20.205),(30.675,20.205),(30.675,20.055),(30.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.375),(30.525,20.525),(30.675,20.525),(30.675,20.375),(30.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,20.695),(30.525,20.845),(30.675,20.845),(30.675,20.695),(30.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.015),(30.525,21.165),(30.675,21.165),(30.675,21.015),(30.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.335),(30.525,21.485),(30.675,21.485),(30.675,21.335),(30.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.655),(30.525,21.805),(30.675,21.805),(30.675,21.655),(30.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.525,21.975),(30.525,22.125),(30.675,22.125),(30.675,21.975),(30.525,21.975)),
        )
        createRL(
            tech, net, 'm2',
            ((83.015,0.13),(83.015,22.21),(83.275,22.21),(83.275,0.13),(83.015,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((30.47,0.13),(30.47,22.21),(30.73,22.21),(30.73,0.13),(30.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((78.47,0.13),(78.47,22.21),(78.73,22.21),(78.73,0.13),(78.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((68.87,0.13),(68.87,22.21),(69.13,22.21),(69.13,0.13),(68.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((20.87,0.13),(20.87,22.21),(21.13,22.21),(21.13,0.13),(20.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((16.07,0.13),(16.07,22.21),(16.33,22.21),(16.33,0.13),(16.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((64.07,0.13),(64.07,22.21),(64.33,22.21),(64.33,0.13),(64.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((25.67,0.13),(25.67,22.21),(25.93,22.21),(25.93,0.13),(25.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((11.27,0.13),(11.27,22.21),(11.53,22.21),(11.53,0.13),(11.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((6.725,0.13),(6.725,22.21),(6.985,22.21),(6.985,0.13),(6.725,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((73.67,0.13),(73.67,22.21),(73.93,22.21),(73.93,0.13),(73.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((59.27,0.13),(59.27,22.21),(59.53,22.21),(59.53,0.13),(59.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((11.05,2.595),(11.05,19.745),(11.75,19.745),(11.75,2.595),(11.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.05,2.595),(35.05,19.745),(35.75,19.745),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.05,2.595),(59.05,19.745),(59.75,19.745),(59.75,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((83.05,2.595),(83.05,19.745),(83.875,19.745),(83.875,2.595),(83.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((73.45,2.595),(73.45,19.745),(74.15,19.745),(74.15,2.595),(73.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.65,2.595),(44.65,19.745),(45.35,19.745),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((68.65,2.595),(68.65,19.745),(69.35,19.745),(69.35,2.595),(68.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.25,2.595),(54.25,19.745),(54.95,19.745),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((20.65,2.595),(20.65,19.745),(21.35,19.745),(21.35,2.595),(20.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((78.25,2.595),(78.25,19.745),(78.95,19.745),(78.95,2.595),(78.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.45,2.595),(49.45,19.745),(50.15,19.745),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.25,2.595),(30.25,19.745),(30.95,19.745),(30.95,2.595),(30.25,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.85,2.595),(39.85,19.745),(40.55,19.745),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((15.85,2.595),(15.85,19.745),(16.55,19.745),(16.55,2.595),(15.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.85,2.595),(63.85,19.745),(64.55,19.745),(64.55,2.595),(63.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((6.125,2.595),(6.125,19.745),(6.95,19.745),(6.95,2.595),(6.125,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.45,2.595),(25.45,19.745),(26.15,19.745),(26.15,2.595),(25.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.55,2.595),(16.55,19.745),(16.995,19.745),(16.995,2.595),(16.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((12.365,2.65),(12.365,19.69),(13.105,19.69),(13.105,2.65),(12.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((12.06,2.595),(12.06,19.745),(13.41,19.745),(13.41,2.595),(12.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((22.98,2.595),(22.98,19.745),(23.82,19.745),(23.82,2.595),(22.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.765,2.65),(74.765,19.69),(75.505,19.69),(75.505,2.65),(74.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.46,2.595),(74.46,19.745),(75.81,19.745),(75.81,2.595),(74.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.18,2.595),(42.18,19.745),(43.02,19.745),(43.02,2.595),(42.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((53.805,2.595),(53.805,19.745),(54.25,19.745),(54.25,2.595),(53.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.46,2.595),(26.46,19.745),(27.81,19.745),(27.81,2.595),(26.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.765,2.65),(26.765,19.69),(27.505,19.69),(27.505,2.65),(26.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((72.095,2.65),(72.095,19.69),(72.835,19.69),(72.835,2.65),(72.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((75.78,2.595),(75.78,19.745),(76.62,19.745),(76.62,2.595),(75.78,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.205,2.595),(44.205,19.745),(44.65,19.745),(44.65,2.595),(44.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((56.58,2.595),(56.58,19.745),(57.42,19.745),(57.42,2.595),(56.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((9.695,2.65),(9.695,19.69),(10.435,19.69),(10.435,2.65),(9.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((9.39,2.595),(9.39,19.745),(10.74,19.745),(10.74,2.595),(9.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.79,2.595),(71.79,19.745),(73.14,19.745),(73.14,2.595),(71.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((81.695,2.65),(81.695,19.69),(82.435,19.69),(82.435,2.65),(81.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((81.39,2.595),(81.39,19.745),(82.74,19.745),(82.74,2.595),(81.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((27.78,2.595),(27.78,19.745),(28.62,19.745),(28.62,2.595),(27.78,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.99,2.595),(42.99,19.745),(44.34,19.745),(44.34,2.595),(42.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((62.19,2.595),(62.19,19.745),(63.54,19.745),(63.54,2.595),(62.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((62.495,2.65),(62.495,19.69),(63.235,19.69),(63.235,2.65),(62.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((78.95,2.595),(78.95,19.745),(79.395,19.745),(79.395,2.595),(78.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((8.58,2.595),(8.58,19.745),(9.42,19.745),(9.42,2.595),(8.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.66,2.595),(69.66,19.745),(71.01,19.745),(71.01,2.595),(69.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((29.805,2.595),(29.805,19.745),(30.25,19.745),(30.25,2.595),(29.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((65.165,2.65),(65.165,19.69),(65.905,19.69),(65.905,2.65),(65.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((63.405,2.595),(63.405,19.745),(63.85,19.745),(63.85,2.595),(63.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.95,2.595),(54.95,19.745),(55.395,19.745),(55.395,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.695,2.65),(33.695,19.69),(34.435,19.69),(34.435,2.65),(33.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.39,2.595),(33.39,19.745),(34.74,19.745),(34.74,2.595),(33.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.75,2.595),(35.75,19.745),(36.195,19.745),(36.195,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.66,2.595),(21.66,19.745),(23.01,19.745),(23.01,2.595),(21.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((34.605,2.595),(34.605,19.745),(35.05,19.745),(35.05,2.595),(34.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((18.18,2.595),(18.18,19.745),(19.02,19.745),(19.02,2.595),(18.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((28.895,2.65),(28.895,19.69),(29.635,19.69),(29.635,2.65),(28.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((28.59,2.595),(28.59,19.745),(29.94,19.745),(29.94,2.595),(28.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((18.99,2.595),(18.99,19.745),(20.34,19.745),(20.34,2.595),(18.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.495,2.65),(38.495,19.69),(39.235,19.69),(39.235,2.65),(38.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.19,2.595),(38.19,19.745),(39.54,19.745),(39.54,2.595),(38.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((19.295,2.65),(19.295,19.69),(20.035,19.69),(20.035,2.65),(19.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((20.205,2.595),(20.205,19.745),(20.65,19.745),(20.65,2.595),(20.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.79,2.595),(47.79,19.745),(49.14,19.745),(49.14,2.595),(47.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.965,2.65),(69.965,19.69),(70.705,19.69),(70.705,2.65),(69.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((15.405,2.595),(15.405,19.745),(15.85,19.745),(15.85,2.595),(15.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((37.38,2.595),(37.38,19.745),(38.22,19.745),(38.22,2.595),(37.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((59.75,2.595),(59.75,19.745),(60.195,19.745),(60.195,2.595),(59.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.66,2.595),(45.66,19.745),(47.01,19.745),(47.01,2.595),(45.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((77.805,2.595),(77.805,19.745),(78.25,19.745),(78.25,2.595),(77.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.965,2.65),(21.965,19.69),(22.705,19.69),(22.705,2.65),(21.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((43.295,2.65),(43.295,19.69),(44.035,19.69),(44.035,2.65),(43.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.35,2.595),(69.35,19.745),(69.795,19.745),(69.795,2.595),(69.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((61.38,2.595),(61.38,19.745),(62.22,19.745),(62.22,2.595),(61.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((76.895,2.65),(76.895,19.69),(77.635,19.69),(77.635,2.65),(76.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((76.59,2.595),(76.59,19.745),(77.94,19.745),(77.94,2.595),(76.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((67.295,2.65),(67.295,19.69),(68.035,19.69),(68.035,2.65),(67.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((25.005,2.595),(25.005,19.745),(25.45,19.745),(25.45,2.595),(25.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((39.405,2.595),(39.405,19.745),(39.85,19.745),(39.85,2.595),(39.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.205,2.595),(68.205,19.745),(68.65,19.745),(68.65,2.595),(68.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((30.95,2.595),(30.95,19.745),(31.395,19.745),(31.395,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((46.98,2.595),(46.98,19.745),(47.82,19.745),(47.82,2.595),(46.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.86,2.595),(40.86,19.745),(42.21,19.745),(42.21,2.595),(40.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.35,2.595),(21.35,19.745),(21.795,19.745),(21.795,2.595),(21.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.965,2.65),(45.965,19.69),(46.705,19.69),(46.705,2.65),(45.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((64.86,2.595),(64.86,19.745),(66.21,19.745),(66.21,2.595),(64.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.565,2.65),(31.565,19.69),(32.305,19.69),(32.305,2.65),(31.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.26,2.595),(31.26,19.745),(32.61,19.745),(32.61,2.595),(31.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((48.095,2.65),(48.095,19.69),(48.835,19.69),(48.835,2.65),(48.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((3.905,18.745),(3.905,19.745),(4.405,19.745),(4.405,18.745),(3.905,18.745)),
        )
        createRL(
            tech, net, 'nsdm',
            ((17.165,2.65),(17.165,19.69),(17.905,19.69),(17.905,2.65),(17.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.695,2.65),(57.695,19.69),(58.435,19.69),(58.435,2.65),(57.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.35,2.595),(45.35,19.745),(45.795,19.745),(45.795,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.39,2.595),(57.39,19.745),(58.74,19.745),(58.74,2.595),(57.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.86,2.595),(16.86,19.745),(18.21,19.745),(18.21,2.595),(16.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((6.95,2.595),(6.95,19.745),(7.395,19.745),(7.395,2.595),(6.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((58.605,2.595),(58.605,19.745),(59.05,19.745),(59.05,2.595),(58.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((32.58,2.595),(32.58,19.745),(33.42,19.745),(33.42,2.595),(32.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.26,2.595),(55.26,19.745),(56.61,19.745),(56.61,2.595),(55.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.565,2.65),(55.565,19.69),(56.305,19.69),(56.305,2.65),(55.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((73.005,2.595),(73.005,19.745),(73.45,19.745),(73.45,2.595),(73.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.895,2.65),(52.895,19.69),(53.635,19.69),(53.635,2.65),(52.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.59,2.595),(52.59,19.745),(53.94,19.745),(53.94,2.595),(52.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((10.605,2.595),(10.605,19.745),(11.05,19.745),(11.05,2.595),(10.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.15,2.595),(50.15,19.745),(50.595,19.745),(50.595,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((79.26,2.595),(79.26,19.745),(80.61,19.745),(80.61,2.595),(79.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((79.565,2.65),(79.565,19.69),(80.305,19.69),(80.305,2.65),(79.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((7.26,2.595),(7.26,19.745),(8.61,19.745),(8.61,2.595),(7.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((7.565,2.65),(7.565,19.69),(8.305,19.69),(8.305,2.65),(7.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((82.605,2.595),(82.605,19.745),(83.05,19.745),(83.05,2.595),(82.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.365,2.65),(36.365,19.69),(37.105,19.69),(37.105,2.65),(36.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.06,2.595),(36.06,19.745),(37.41,19.745),(37.41,2.595),(36.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.55,2.595),(40.55,19.745),(40.995,19.745),(40.995,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((11.75,2.595),(11.75,19.745),(12.195,19.745),(12.195,2.595),(11.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((41.165,2.65),(41.165,19.69),(41.905,19.69),(41.905,2.65),(41.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((74.15,2.595),(74.15,19.745),(74.595,19.745),(74.595,2.595),(74.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((64.55,2.595),(64.55,19.745),(64.995,19.745),(64.995,2.595),(64.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.005,2.595),(49.005,19.745),(49.45,19.745),(49.45,2.595),(49.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((24.095,2.65),(24.095,19.69),(24.835,19.69),(24.835,2.65),(24.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((66.18,2.595),(66.18,19.745),(67.02,19.745),(67.02,2.595),(66.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((14.495,2.65),(14.495,19.69),(15.235,19.69),(15.235,2.65),(14.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((14.19,2.595),(14.19,19.745),(15.54,19.745),(15.54,2.595),(14.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.15,2.595),(26.15,19.745),(26.595,19.745),(26.595,2.595),(26.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.765,2.65),(50.765,19.69),(51.505,19.69),(51.505,2.65),(50.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.46,2.595),(50.46,19.745),(51.81,19.745),(51.81,2.595),(50.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((23.79,2.595),(23.79,19.745),(25.14,19.745),(25.14,2.595),(23.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((60.365,2.65),(60.365,19.69),(61.105,19.69),(61.105,2.65),(60.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((66.99,2.595),(66.99,19.745),(68.34,19.745),(68.34,2.595),(66.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((60.06,2.595),(60.06,19.745),(61.41,19.745),(61.41,2.595),(60.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((13.38,2.595),(13.38,19.745),(14.22,19.745),(14.22,2.595),(13.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.98,2.595),(70.98,19.745),(71.82,19.745),(71.82,2.595),(70.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((80.58,2.595),(80.58,19.745),(81.42,19.745),(81.42,2.595),(80.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((51.78,2.595),(51.78,19.745),(52.62,19.745),(52.62,2.595),(51.78,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.535,2.54),(76.535,19.8),(77.995,19.8),(77.995,2.54),(76.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((76.765,2.52),(76.765,19.82),(77.765,19.82),(77.765,2.52),(76.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.535,2.54),(52.535,19.8),(53.995,19.8),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.765,2.52),(52.765,19.82),(53.765,19.82),(53.765,2.52),(52.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.635,2.52),(74.635,19.82),(75.635,19.82),(75.635,2.52),(74.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((74.405,2.54),(74.405,19.8),(75.865,19.8),(75.865,2.54),(74.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.005,2.54),(12.005,19.8),(13.465,19.8),(13.465,2.54),(12.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((12.235,2.52),(12.235,19.82),(13.235,19.82),(13.235,2.52),(12.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.565,2.52),(33.565,19.82),(34.565,19.82),(34.565,2.52),(33.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.335,2.54),(33.335,19.8),(34.795,19.8),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((65.035,2.52),(65.035,19.82),(66.035,19.82),(66.035,2.52),(65.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.765,2.52),(28.765,19.82),(29.765,19.82),(29.765,2.52),(28.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.965,2.52),(47.965,19.82),(48.965,19.82),(48.965,2.52),(47.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.965,2.52),(71.965,19.82),(72.965,19.82),(72.965,2.52),(71.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((67.165,2.52),(67.165,19.82),(68.165,19.82),(68.165,2.52),(67.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.435,2.52),(79.435,19.82),(80.435,19.82),(80.435,2.52),(79.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((79.205,2.54),(79.205,19.8),(80.665,19.8),(80.665,2.54),(79.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.805,2.54),(40.805,19.8),(42.265,19.8),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.435,2.52),(7.435,19.82),(8.435,19.82),(8.435,2.52),(7.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.605,2.54),(21.605,19.8),(23.065,19.8),(23.065,2.54),(21.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((7.205,2.54),(7.205,19.8),(8.665,19.8),(8.665,2.54),(7.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.235,2.52),(36.235,19.82),(37.235,19.82),(37.235,2.52),(36.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((18.935,2.54),(18.935,19.8),(20.395,19.8),(20.395,2.54),(18.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((64.805,2.54),(64.805,19.8),(66.265,19.8),(66.265,2.54),(64.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.005,2.54),(36.005,19.8),(37.465,19.8),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.635,2.52),(26.635,19.82),(27.635,19.82),(27.635,2.52),(26.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.405,2.54),(26.405,19.8),(27.865,19.8),(27.865,2.54),(26.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.365,2.52),(38.365,19.82),(39.365,19.82),(39.365,2.52),(38.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.135,2.54),(38.135,19.8),(39.595,19.8),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((6.05,2.52),(6.05,19.82),(83.95,19.82),(83.95,2.52),(6.05,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.535,2.54),(28.535,19.8),(29.995,19.8),(29.995,2.54),(28.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((19.165,2.52),(19.165,19.82),(20.165,19.82),(20.165,2.52),(19.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.965,2.52),(23.965,19.82),(24.965,19.82),(24.965,2.52),(23.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.435,2.52),(31.435,19.82),(32.435,19.82),(32.435,2.52),(31.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.205,2.54),(31.205,19.8),(32.665,19.8),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.565,2.52),(9.565,19.82),(10.565,19.82),(10.565,2.52),(9.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((9.335,2.54),(9.335,19.8),(10.795,19.8),(10.795,2.54),(9.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.735,2.54),(47.735,19.8),(49.195,19.8),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.735,2.54),(71.735,19.8),(73.195,19.8),(73.195,2.54),(71.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.835,2.52),(69.835,19.82),(70.835,19.82),(70.835,2.52),(69.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.335,2.54),(81.335,19.8),(82.795,19.8),(82.795,2.54),(81.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((81.565,2.52),(81.565,19.82),(82.565,19.82),(82.565,2.52),(81.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((17.035,2.52),(17.035,19.82),(18.035,19.82),(18.035,2.52),(17.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.935,2.54),(42.935,19.8),(44.395,19.8),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.605,2.54),(45.605,19.8),(47.065,19.8),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.135,2.54),(62.135,19.8),(63.595,19.8),(63.595,2.54),(62.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.365,2.52),(62.365,19.82),(63.365,19.82),(63.365,2.52),(62.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.135,2.54),(14.135,19.8),(15.595,19.8),(15.595,2.54),(14.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((14.365,2.52),(14.365,19.82),(15.365,19.82),(15.365,2.52),(14.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.405,2.54),(50.405,19.8),(51.865,19.8),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.635,2.52),(50.635,19.82),(51.635,19.82),(51.635,2.52),(50.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.335,2.54),(57.335,19.8),(58.795,19.8),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.565,2.52),(57.565,19.82),(58.565,19.82),(58.565,2.52),(57.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((23.735,2.54),(23.735,19.8),(25.195,19.8),(25.195,2.54),(23.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.005,2.54),(60.005,19.8),(61.465,19.8),(61.465,2.54),(60.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.235,2.52),(60.235,19.82),(61.235,19.82),(61.235,2.52),(60.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((21.835,2.52),(21.835,19.82),(22.835,19.82),(22.835,2.52),(21.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.805,2.54),(16.805,19.8),(18.265,19.8),(18.265,2.54),(16.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((66.935,2.54),(66.935,19.8),(68.395,19.8),(68.395,2.54),(66.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.435,2.52),(55.435,19.82),(56.435,19.82),(56.435,2.52),(55.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.205,2.54),(55.205,19.8),(56.665,19.8),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.165,2.52),(43.165,19.82),(44.165,19.82),(44.165,2.52),(43.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.605,2.54),(69.605,19.8),(71.065,19.8),(71.065,2.54),(69.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.835,2.52),(45.835,19.82),(46.835,19.82),(46.835,2.52),(45.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.035,2.52),(41.035,19.82),(42.035,19.82),(42.035,2.52),(41.035,2.52)),
        )
        createRL(
            tech, net, 'areaid_diode',
            ((4.025,18.865),(4.025,19.625),(4.285,19.625),(4.285,18.865),(4.025,18.865)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,19.62),(32.485,19.62),(32.485,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.915,2.72),(23.915,19.62),(24.165,19.62),(24.165,2.72),(23.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,19.62),(62.095,19.62),(62.095,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.285,2.72),(61.285,19.62),(62.095,19.62),(62.095,2.72),(61.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.505,2.72),(61.505,19.62),(62.315,19.62),(62.315,2.72),(61.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.915,2.72),(47.915,19.62),(48.165,19.62),(48.165,2.72),(47.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(43.115,19.62),(43.115,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.885,2.72),(22.885,19.62),(23.695,19.62),(23.695,2.72),(22.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,19.62),(46.885,19.62),(46.885,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,19.62),(66.895,19.62),(66.895,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.085,2.72),(66.085,19.62),(66.895,19.62),(66.895,2.72),(66.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.315,2.72),(38.315,19.62),(38.565,19.62),(38.565,2.72),(38.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.435,2.72),(27.435,19.62),(27.685,19.62),(27.685,2.72),(27.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.435,2.72),(75.435,19.62),(75.685,19.62),(75.685,2.72),(75.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.295,19.62),(33.295,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,19.62),(71.695,19.62),(71.695,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.105,2.72),(71.105,19.62),(71.915,19.62),(71.915,2.72),(71.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.485,2.72),(32.485,19.62),(33.295,19.62),(33.295,2.72),(32.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,19.62),(19.115,19.62),(19.115,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.885,2.72),(46.885,19.62),(47.695,19.62),(47.695,2.72),(46.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.515,19.62),(33.515,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((9.515,2.72),(9.515,19.62),(9.765,19.62),(9.765,2.72),(9.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.235,2.72),(80.235,19.62),(80.485,19.62),(80.485,2.72),(80.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.115,2.72),(67.115,19.62),(67.365,19.62),(67.365,2.72),(67.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.035,2.72),(13.035,19.62),(13.285,19.62),(13.285,2.72),(13.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.915,2.72),(71.915,19.62),(72.165,19.62),(72.165,2.72),(71.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,19.62),(76.495,19.62),(76.495,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,19.62),(42.085,19.62),(42.085,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.685,2.72),(75.685,19.62),(76.495,19.62),(76.495,2.72),(75.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((75.905,2.72),(75.905,19.62),(76.715,19.62),(76.715,2.72),(75.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,19.62),(56.485,19.62),(56.485,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,19.62),(23.695,19.62),(23.695,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((23.105,2.72),(23.105,19.62),(23.915,19.62),(23.915,2.72),(23.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.235,2.72),(8.235,19.62),(8.485,19.62),(8.485,2.72),(8.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.635,2.72),(70.635,19.62),(70.885,19.62),(70.885,2.72),(70.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.515,2.72),(33.515,19.62),(33.765,19.62),(33.765,2.72),(33.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.485,2.72),(56.485,19.62),(57.295,19.62),(57.295,2.72),(56.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.085,2.72),(42.085,19.62),(42.895,19.62),(42.895,2.72),(42.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((81.515,2.72),(81.515,19.62),(81.765,19.62),(81.765,2.72),(81.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.295,19.62),(57.295,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(42.895,19.62),(42.895,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.515,19.62),(57.515,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.095,19.62),(38.095,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.695,19.62),(47.695,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.915,19.62),(47.915,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.285,2.72),(37.285,19.62),(38.095,19.62),(38.095,2.72),(37.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.315,19.62),(38.315,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.085,2.72),(18.085,19.62),(18.895,19.62),(18.895,2.72),(18.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((18.305,2.72),(18.305,19.62),(18.895,19.62),(18.895,2.72),(18.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,19.62),(28.495,19.62),(28.495,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.685,2.72),(27.685,19.62),(28.495,19.62),(28.495,2.72),(27.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.905,2.72),(27.905,19.62),(28.715,19.62),(28.715,2.72),(27.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.715,2.72),(52.715,19.62),(52.965,19.62),(52.965,2.72),(52.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((76.715,2.72),(76.715,19.62),(76.965,19.62),(76.965,2.72),(76.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.715,2.72),(28.715,19.62),(28.965,19.62),(28.965,2.72),(28.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((66.305,2.72),(66.305,19.62),(67.115,19.62),(67.115,2.72),(66.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.515,2.72),(57.515,19.62),(57.765,19.62),(57.765,2.72),(57.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,19.62),(9.515,19.62),(9.515,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.485,2.72),(8.485,19.62),(9.295,19.62),(9.295,2.72),(8.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((8.705,2.72),(8.705,19.62),(9.295,19.62),(9.295,2.72),(8.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,19.62),(51.685,19.62),(51.685,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,19.62),(14.095,19.62),(14.095,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.285,2.72),(13.285,19.62),(14.095,19.62),(14.095,2.72),(13.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((13.505,2.72),(13.505,19.62),(14.315,19.62),(14.315,2.72),(13.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((19.115,2.72),(19.115,19.62),(19.365,19.62),(19.365,2.72),(19.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.885,2.72),(70.885,19.62),(71.695,19.62),(71.695,2.72),(70.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.115,2.72),(43.115,19.62),(43.365,19.62),(43.365,2.72),(43.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.035,2.72),(61.035,19.62),(61.285,19.62),(61.285,2.72),(61.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,19.62),(81.295,19.62),(81.295,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.485,2.72),(80.485,19.62),(81.295,19.62),(81.295,2.72),(80.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((80.705,2.72),(80.705,19.62),(81.515,19.62),(81.515,2.72),(80.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,19.62),(37.285,19.62),(37.285,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.315,2.72),(62.315,19.62),(62.565,19.62),(62.565,2.72),(62.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((65.835,2.72),(65.835,19.62),(66.085,19.62),(66.085,2.72),(65.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((17.835,2.72),(17.835,19.62),(18.085,19.62),(18.085,2.72),(17.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((14.315,2.72),(14.315,19.62),(14.565,19.62),(14.565,2.72),(14.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.495,19.62),(52.495,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.685,2.72),(51.685,19.62),(52.495,19.62),(52.495,2.72),(51.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.715,19.62),(52.715,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((22.635,2.72),(22.635,19.62),(22.885,19.62),(22.885,2.72),(22.635,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.165),(18.345,15.335),(18.515,15.335),(18.515,15.165),(18.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.165),(18.685,15.335),(18.855,15.335),(18.855,15.165),(18.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.505),(18.345,15.675),(18.515,15.675),(18.515,15.505),(18.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.425),(75.945,11.595),(76.115,11.595),(76.115,11.425),(75.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.765),(75.945,11.935),(76.115,11.935),(76.115,11.765),(75.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.505),(18.685,15.675),(18.855,15.675),(18.855,15.505),(18.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,11.085),(75.945,11.255),(76.115,11.255),(76.115,11.085),(75.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.985),(23.145,6.155),(23.315,6.155),(23.315,5.985),(23.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.985),(23.485,6.155),(23.655,6.155),(23.655,5.985),(23.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.245),(32.745,19.415),(32.915,19.415),(32.915,19.245),(32.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.085),(27.945,11.255),(28.115,11.255),(28.115,11.085),(27.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.765),(27.945,11.935),(28.115,11.935),(28.115,11.765),(27.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,11.425),(27.945,11.595),(28.115,11.595),(28.115,11.425),(27.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.905),(76.285,19.075),(76.455,19.075),(76.455,18.905),(76.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.945),(61.545,4.115),(61.715,4.115),(61.715,3.945),(61.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.285),(56.745,4.455),(56.915,4.455),(56.915,4.285),(56.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.625),(56.745,4.795),(56.915,4.795),(56.915,4.625),(56.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.425),(81.085,11.595),(81.255,11.595),(81.255,11.425),(81.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.085),(81.085,11.255),(81.255,11.255),(81.255,11.085),(81.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,11.765),(81.085,11.935),(81.255,11.935),(81.255,11.765),(81.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.145),(80.745,14.315),(80.915,14.315),(80.915,14.145),(80.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.485),(80.745,14.655),(80.915,14.655),(80.915,14.485),(80.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,14.825),(80.745,14.995),(80.915,14.995),(80.915,14.825),(80.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.285),(32.745,4.455),(32.915,4.455),(32.915,4.285),(32.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.625),(32.745,4.795),(32.915,4.795),(32.915,4.625),(32.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.945),(13.545,4.115),(13.715,4.115),(13.715,3.945),(13.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.285),(13.545,4.455),(13.715,4.455),(13.715,4.285),(13.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.625),(13.545,4.795),(13.715,4.795),(13.715,4.625),(13.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.285),(8.745,4.455),(8.915,4.455),(8.915,4.285),(8.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.625),(8.745,4.795),(8.915,4.795),(8.915,4.625),(8.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.305),(27.945,5.475),(28.115,5.475),(28.115,5.305),(27.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.645),(27.945,5.815),(28.115,5.815),(28.115,5.645),(27.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.385),(51.945,9.555),(52.115,9.555),(52.115,9.385),(51.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.725),(51.945,9.895),(52.115,9.895),(52.115,9.725),(51.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.485),(76.285,14.655),(76.455,14.655),(76.455,14.485),(76.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.825),(76.285,14.995),(76.455,14.995),(76.455,14.825),(76.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,14.145),(76.285,14.315),(76.455,14.315),(76.455,14.145),(76.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.785),(18.685,12.955),(18.855,12.955),(18.855,12.785),(18.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.445),(18.345,12.615),(18.515,12.615),(18.515,12.445),(18.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.445),(18.685,12.615),(18.855,12.615),(18.855,12.445),(18.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.785),(18.345,12.955),(18.515,12.955),(18.515,12.785),(18.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,12.105),(18.345,12.275),(18.515,12.275),(18.515,12.105),(18.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,12.105),(18.685,12.275),(18.855,12.275),(18.855,12.105),(18.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.205),(61.545,17.375),(61.715,17.375),(61.715,17.205),(61.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.545),(61.545,17.715),(61.715,17.715),(61.715,17.545),(61.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.025),(13.545,8.195),(13.715,8.195),(13.715,8.025),(13.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.365),(13.545,8.535),(13.715,8.535),(13.715,8.365),(13.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,8.705),(13.545,8.875),(13.715,8.875),(13.715,8.705),(13.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.265),(37.885,3.435),(38.055,3.435),(38.055,3.265),(37.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.605),(37.885,3.775),(38.055,3.775),(38.055,3.605),(37.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.865),(61.885,17.035),(62.055,17.035),(62.055,16.865),(61.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.965),(27.945,5.135),(28.115,5.135),(28.115,4.965),(27.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.385),(81.085,9.555),(81.255,9.555),(81.255,9.385),(81.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.725),(81.085,9.895),(81.255,9.895),(81.255,9.725),(81.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,15.845),(18.345,16.015),(18.515,16.015),(18.515,15.845),(18.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,15.845),(18.685,16.015),(18.855,16.015),(18.855,15.845),(18.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.565),(52.285,18.735),(52.455,18.735),(52.455,18.565),(52.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.225),(52.285,18.395),(52.455,18.395),(52.455,18.225),(52.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.305),(51.945,5.475),(52.115,5.475),(52.115,5.305),(51.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.645),(51.945,5.815),(52.115,5.815),(52.115,5.645),(51.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.285),(61.545,4.455),(61.715,4.455),(61.715,4.285),(61.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.625),(61.545,4.795),(61.715,4.795),(61.715,4.625),(61.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.005),(52.285,7.175),(52.455,7.175),(52.455,7.005),(52.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.345),(52.285,7.515),(52.455,7.515),(52.455,7.345),(52.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.685),(52.285,7.855),(52.455,7.855),(52.455,7.685),(52.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.245),(33.085,19.415),(33.255,19.415),(33.255,19.245),(33.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.445),(47.485,12.615),(47.655,12.615),(47.655,12.445),(47.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.785),(47.485,12.955),(47.655,12.955),(47.655,12.785),(47.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.445),(47.145,12.615),(47.315,12.615),(47.315,12.445),(47.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.105),(47.145,12.275),(47.315,12.275),(47.315,12.105),(47.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.105),(47.485,12.275),(47.655,12.275),(47.655,12.105),(47.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.785),(47.145,12.955),(47.315,12.955),(47.315,12.785),(47.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.385),(27.945,9.555),(28.115,9.555),(28.115,9.385),(27.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.725),(27.945,9.895),(28.115,9.895),(28.115,9.725),(27.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.045),(61.885,9.215),(62.055,9.215),(62.055,9.045),(61.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.165),(66.345,15.335),(66.515,15.335),(66.515,15.165),(66.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.165),(66.685,15.335),(66.855,15.335),(66.855,15.165),(66.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.505),(66.345,15.675),(66.515,15.675),(66.515,15.505),(66.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.885),(57.085,18.055),(57.255,18.055),(57.255,17.885),(57.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.505),(66.685,15.675),(66.855,15.675),(66.855,15.505),(66.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.925),(52.285,3.095),(52.455,3.095),(52.455,2.925),(52.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.865),(71.145,17.035),(71.315,17.035),(71.315,16.865),(71.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.865),(71.485,17.035),(71.655,17.035),(71.655,16.865),(71.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,19.245),(23.485,19.415),(23.655,19.415),(23.655,19.245),(23.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,19.245),(23.145,19.415),(23.315,19.415),(23.315,19.245),(23.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.045),(71.145,9.215),(71.315,9.215),(71.315,9.045),(71.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.045),(71.485,9.215),(71.655,9.215),(71.655,9.045),(71.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.345),(28.285,7.515),(28.455,7.515),(28.455,7.345),(28.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.005),(28.285,7.175),(28.455,7.175),(28.455,7.005),(28.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.045),(13.885,9.215),(14.055,9.215),(14.055,9.045),(13.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.365),(61.545,8.535),(61.715,8.535),(61.715,8.365),(61.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.705),(61.545,8.875),(61.715,8.875),(61.715,8.705),(61.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,8.025),(61.545,8.195),(61.715,8.195),(61.715,8.025),(61.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.645),(81.085,5.815),(81.255,5.815),(81.255,5.645),(81.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.305),(81.085,5.475),(81.255,5.475),(81.255,5.305),(81.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.065),(66.345,10.235),(66.515,10.235),(66.515,10.065),(66.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.065),(66.685,10.235),(66.855,10.235),(66.855,10.065),(66.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.745),(66.345,10.915),(66.515,10.915),(66.515,10.745),(66.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.745),(66.685,10.915),(66.855,10.915),(66.855,10.745),(66.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,10.405),(66.685,10.575),(66.855,10.575),(66.855,10.405),(66.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,10.405),(66.345,10.575),(66.515,10.575),(66.515,10.405),(66.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.765),(28.285,11.935),(28.455,11.935),(28.455,11.765),(28.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.085),(28.285,11.255),(28.455,11.255),(28.455,11.085),(28.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,11.425),(28.285,11.595),(28.455,11.595),(28.455,11.425),(28.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.145),(23.145,14.315),(23.315,14.315),(23.315,14.145),(23.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.145),(23.485,14.315),(23.655,14.315),(23.655,14.145),(23.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.485),(23.145,14.655),(23.315,14.655),(23.315,14.485),(23.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.485),(23.485,14.655),(23.655,14.655),(23.655,14.485),(23.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,14.825),(23.145,14.995),(23.315,14.995),(23.315,14.825),(23.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,14.825),(23.485,14.995),(23.655,14.995),(23.655,14.825),(23.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.065),(51.945,10.235),(52.115,10.235),(52.115,10.065),(51.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.745),(51.945,10.915),(52.115,10.915),(52.115,10.745),(51.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.405),(51.945,10.575),(52.115,10.575),(52.115,10.405),(51.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.865),(33.085,17.035),(33.255,17.035),(33.255,16.865),(33.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.105),(66.685,12.275),(66.855,12.275),(66.855,12.105),(66.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.445),(66.345,12.615),(66.515,12.615),(66.515,12.445),(66.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.445),(66.685,12.615),(66.855,12.615),(66.855,12.445),(66.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.785),(66.345,12.955),(66.515,12.955),(66.515,12.785),(66.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,12.785),(66.685,12.955),(66.855,12.955),(66.855,12.785),(66.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,12.105),(66.345,12.275),(66.515,12.275),(66.515,12.105),(66.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.765),(47.145,11.935),(47.315,11.935),(47.315,11.765),(47.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.765),(47.485,11.935),(47.655,11.935),(47.655,11.765),(47.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.425),(47.145,11.595),(47.315,11.595),(47.315,11.425),(47.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.425),(47.485,11.595),(47.655,11.595),(47.655,11.425),(47.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.085),(47.145,11.255),(47.315,11.255),(47.315,11.085),(47.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.085),(47.485,11.255),(47.655,11.255),(47.655,11.085),(47.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.145),(9.085,14.315),(9.255,14.315),(9.255,14.145),(9.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.485),(9.085,14.655),(9.255,14.655),(9.255,14.485),(9.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,14.825),(9.085,14.995),(9.255,14.995),(9.255,14.825),(9.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.325),(28.285,6.495),(28.455,6.495),(28.455,6.325),(28.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,6.665),(28.285,6.835),(28.455,6.835),(28.455,6.665),(28.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.265),(66.685,3.435),(66.855,3.435),(66.855,3.265),(66.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.265),(66.345,3.435),(66.515,3.435),(66.515,3.265),(66.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.605),(66.345,3.775),(66.515,3.775),(66.515,3.605),(66.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.605),(66.685,3.775),(66.855,3.775),(66.855,3.605),(66.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.365),(18.345,8.535),(18.515,8.535),(18.515,8.365),(18.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.365),(18.685,8.535),(18.855,8.535),(18.855,8.365),(18.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.705),(18.685,8.875),(18.855,8.875),(18.855,8.705),(18.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.705),(18.345,8.875),(18.515,8.875),(18.515,8.705),(18.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,8.025),(18.345,8.195),(18.515,8.195),(18.515,8.025),(18.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,8.025),(18.685,8.195),(18.855,8.195),(18.855,8.025),(18.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.945),(28.285,4.115),(28.455,4.115),(28.455,3.945),(28.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.965),(76.285,5.135),(76.455,5.135),(76.455,4.965),(76.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.065),(18.685,10.235),(18.855,10.235),(18.855,10.065),(18.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.745),(18.685,10.915),(18.855,10.915),(18.855,10.745),(18.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.745),(18.345,10.915),(18.515,10.915),(18.515,10.745),(18.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,10.405),(18.685,10.575),(18.855,10.575),(18.855,10.405),(18.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.405),(18.345,10.575),(18.515,10.575),(18.515,10.405),(18.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,10.065),(18.345,10.235),(18.515,10.235),(18.515,10.065),(18.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.205),(71.145,17.375),(71.315,17.375),(71.315,17.205),(71.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.205),(71.485,17.375),(71.655,17.375),(71.655,17.205),(71.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.545),(71.145,17.715),(71.315,17.715),(71.315,17.545),(71.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.545),(71.485,17.715),(71.655,17.715),(71.655,17.545),(71.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.965),(28.285,5.135),(28.455,5.135),(28.455,4.965),(28.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,15.845),(66.345,16.015),(66.515,16.015),(66.515,15.845),(66.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,15.845),(66.685,16.015),(66.855,16.015),(66.855,15.845),(66.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.185),(37.545,16.355),(37.715,16.355),(37.715,16.185),(37.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.525),(37.545,16.695),(37.715,16.695),(37.715,16.525),(37.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.845),(33.085,16.015),(33.255,16.015),(33.255,15.845),(33.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.205),(37.885,17.375),(38.055,17.375),(38.055,17.205),(37.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.545),(37.885,17.715),(38.055,17.715),(38.055,17.545),(37.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.185),(52.285,16.355),(52.455,16.355),(52.455,16.185),(52.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.525),(52.285,16.695),(52.455,16.695),(52.455,16.525),(52.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.325),(75.945,6.495),(76.115,6.495),(76.115,6.325),(75.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,6.665),(75.945,6.835),(76.115,6.835),(76.115,6.665),(75.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.285),(80.745,4.455),(80.915,4.455),(80.915,4.285),(80.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.625),(80.745,4.795),(80.915,4.795),(80.915,4.625),(80.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.325),(27.945,6.495),(28.115,6.495),(28.115,6.325),(27.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,6.665),(27.945,6.835),(28.115,6.835),(28.115,6.665),(27.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.965),(75.945,5.135),(76.115,5.135),(76.115,4.965),(75.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.105),(51.945,12.275),(52.115,12.275),(52.115,12.105),(51.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.445),(51.945,12.615),(52.115,12.615),(52.115,12.445),(51.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.785),(51.945,12.955),(52.115,12.955),(52.115,12.785),(51.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.325),(52.285,6.495),(52.455,6.495),(52.455,6.325),(52.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.665),(52.285,6.835),(52.455,6.835),(52.455,6.665),(52.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.905),(27.945,19.075),(28.115,19.075),(28.115,18.905),(27.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.025),(52.285,8.195),(52.455,8.195),(52.455,8.025),(52.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.705),(52.285,8.875),(52.455,8.875),(52.455,8.705),(52.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.365),(52.285,8.535),(52.455,8.535),(52.455,8.365),(52.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.225),(37.885,18.395),(38.055,18.395),(38.055,18.225),(37.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.565),(37.885,18.735),(38.055,18.735),(38.055,18.565),(37.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.845),(81.085,16.015),(81.255,16.015),(81.255,15.845),(81.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.885),(42.345,18.055),(42.515,18.055),(42.515,17.885),(42.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.885),(42.685,18.055),(42.855,18.055),(42.855,17.885),(42.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.745),(33.085,10.915),(33.255,10.915),(33.255,10.745),(33.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.485),(57.085,14.655),(57.255,14.655),(57.255,14.485),(57.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.825),(57.085,14.995),(57.255,14.995),(57.255,14.825),(57.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.405),(33.085,10.575),(33.255,10.575),(33.255,10.405),(33.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.065),(33.085,10.235),(33.255,10.235),(33.255,10.065),(33.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.145),(57.085,14.315),(57.255,14.315),(57.255,14.145),(57.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.345),(71.485,7.515),(71.655,7.515),(71.655,7.345),(71.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.345),(71.145,7.515),(71.315,7.515),(71.315,7.345),(71.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.005),(71.145,7.175),(71.315,7.175),(71.315,7.005),(71.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.005),(71.485,7.175),(71.655,7.175),(71.655,7.005),(71.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.865),(13.885,17.035),(14.055,17.035),(14.055,16.865),(13.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,3.945),(66.345,4.115),(66.515,4.115),(66.515,3.945),(66.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,3.945),(66.685,4.115),(66.855,4.115),(66.855,3.945),(66.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.385),(75.945,9.555),(76.115,9.555),(76.115,9.385),(75.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.725),(75.945,9.895),(76.115,9.895),(76.115,9.725),(75.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.985),(37.545,6.155),(37.715,6.155),(37.715,5.985),(37.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.885),(75.945,18.055),(76.115,18.055),(76.115,17.885),(75.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.905),(56.745,19.075),(56.915,19.075),(56.915,18.905),(56.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.465),(66.345,13.635),(66.515,13.635),(66.515,13.465),(66.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.805),(66.345,13.975),(66.515,13.975),(66.515,13.805),(66.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.465),(66.685,13.635),(66.855,13.635),(66.855,13.465),(66.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.805),(66.685,13.975),(66.855,13.975),(66.855,13.805),(66.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,13.125),(66.345,13.295),(66.515,13.295),(66.515,13.125),(66.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,13.125),(66.685,13.295),(66.855,13.295),(66.855,13.125),(66.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.185),(42.345,16.355),(42.515,16.355),(42.515,16.185),(42.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.185),(42.685,16.355),(42.855,16.355),(42.855,16.185),(42.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.525),(42.345,16.695),(42.515,16.695),(42.515,16.525),(42.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.525),(42.685,16.695),(42.855,16.695),(42.855,16.525),(42.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.685),(37.545,7.855),(37.715,7.855),(37.715,7.685),(37.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.185),(57.085,16.355),(57.255,16.355),(57.255,16.185),(57.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.525),(57.085,16.695),(57.255,16.695),(57.255,16.525),(57.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.985),(52.285,6.155),(52.455,6.155),(52.455,5.985),(52.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.365),(66.685,8.535),(66.855,8.535),(66.855,8.365),(66.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.705),(66.345,8.875),(66.515,8.875),(66.515,8.705),(66.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.025),(66.345,8.195),(66.515,8.195),(66.515,8.025),(66.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.025),(66.685,8.195),(66.855,8.195),(66.855,8.025),(66.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,8.365),(66.345,8.535),(66.515,8.535),(66.515,8.365),(66.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,8.705),(66.685,8.875),(66.855,8.875),(66.855,8.705),(66.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.745),(75.945,10.915),(76.115,10.915),(76.115,10.745),(75.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.405),(75.945,10.575),(76.115,10.575),(76.115,10.405),(75.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.025),(76.285,8.195),(76.455,8.195),(76.455,8.025),(76.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,10.065),(75.945,10.235),(76.115,10.235),(76.115,10.065),(75.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.365),(76.285,8.535),(76.455,8.535),(76.455,8.365),(76.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,8.705),(76.285,8.875),(76.455,8.875),(76.455,8.705),(76.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.385),(42.345,9.555),(42.515,9.555),(42.515,9.385),(42.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.385),(42.685,9.555),(42.855,9.555),(42.855,9.385),(42.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.725),(42.345,9.895),(42.515,9.895),(42.515,9.725),(42.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.605),(27.945,3.775),(28.115,3.775),(28.115,3.605),(27.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.765),(76.285,11.935),(76.455,11.935),(76.455,11.765),(76.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.425),(76.285,11.595),(76.455,11.595),(76.455,11.425),(76.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,11.085),(76.285,11.255),(76.455,11.255),(76.455,11.085),(76.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.245),(52.285,19.415),(52.455,19.415),(52.455,19.245),(52.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.265),(27.945,3.435),(28.115,3.435),(28.115,3.265),(27.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.725),(42.685,9.895),(42.855,9.895),(42.855,9.725),(42.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.485),(71.485,14.655),(71.655,14.655),(71.655,14.485),(71.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.825),(71.145,14.995),(71.315,14.995),(71.315,14.825),(71.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.825),(71.485,14.995),(71.655,14.995),(71.655,14.825),(71.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.485),(71.145,14.655),(71.315,14.655),(71.315,14.485),(71.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,14.145),(71.145,14.315),(71.315,14.315),(71.315,14.145),(71.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,14.145),(71.485,14.315),(71.655,14.315),(71.655,14.145),(71.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,2.925),(23.145,3.095),(23.315,3.095),(23.315,2.925),(23.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,2.925),(23.485,3.095),(23.655,3.095),(23.655,2.925),(23.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.745),(27.945,10.915),(28.115,10.915),(28.115,10.745),(27.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.065),(27.945,10.235),(28.115,10.235),(28.115,10.065),(27.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,10.405),(27.945,10.575),(28.115,10.575),(28.115,10.405),(27.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.025),(28.285,8.195),(28.455,8.195),(28.455,8.025),(28.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.365),(28.285,8.535),(28.455,8.535),(28.455,8.365),(28.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,8.705),(28.285,8.875),(28.455,8.875),(28.455,8.705),(28.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.985),(76.285,6.155),(76.455,6.155),(76.455,5.985),(76.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.565),(47.145,18.735),(47.315,18.735),(47.315,18.565),(47.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.225),(47.145,18.395),(47.315,18.395),(47.315,18.225),(47.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.225),(47.485,18.395),(47.655,18.395),(47.655,18.225),(47.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.565),(47.485,18.735),(47.655,18.735),(47.655,18.565),(47.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.005),(13.545,7.175),(13.715,7.175),(13.715,7.005),(13.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.345),(13.545,7.515),(13.715,7.515),(13.715,7.345),(13.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.905),(57.085,19.075),(57.255,19.075),(57.255,18.905),(57.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.225),(37.545,18.395),(37.715,18.395),(37.715,18.225),(37.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.565),(37.545,18.735),(37.715,18.735),(37.715,18.565),(37.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.205),(13.545,17.375),(13.715,17.375),(13.715,17.205),(13.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.545),(13.545,17.715),(13.715,17.715),(13.715,17.545),(13.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,2.925),(66.685,3.095),(66.855,3.095),(66.855,2.925),(66.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,2.925),(66.345,3.095),(66.515,3.095),(66.515,2.925),(66.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.125),(18.345,13.295),(18.515,13.295),(18.515,13.125),(18.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.125),(18.685,13.295),(18.855,13.295),(18.855,13.125),(18.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.465),(18.685,13.635),(18.855,13.635),(18.855,13.465),(18.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.465),(18.345,13.635),(18.515,13.635),(18.515,13.465),(18.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,13.805),(18.345,13.975),(18.515,13.975),(18.515,13.805),(18.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,13.805),(18.685,13.975),(18.855,13.975),(18.855,13.805),(18.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.965),(71.145,5.135),(71.315,5.135),(71.315,4.965),(71.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.965),(71.485,5.135),(71.655,5.135),(71.655,4.965),(71.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.965),(23.145,5.135),(23.315,5.135),(23.315,4.965),(23.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.965),(23.485,5.135),(23.655,5.135),(23.655,4.965),(23.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.205),(51.945,17.375),(52.115,17.375),(52.115,17.205),(51.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.545),(51.945,17.715),(52.115,17.715),(52.115,17.545),(51.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.445),(23.145,12.615),(23.315,12.615),(23.315,12.445),(23.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.745),(81.085,10.915),(81.255,10.915),(81.255,10.745),(81.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.405),(81.085,10.575),(81.255,10.575),(81.255,10.405),(81.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,10.065),(81.085,10.235),(81.255,10.235),(81.255,10.065),(81.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.465),(33.085,13.635),(33.255,13.635),(33.255,13.465),(33.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.805),(33.085,13.975),(33.255,13.975),(33.255,13.805),(33.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.125),(33.085,13.295),(33.255,13.295),(33.255,13.125),(33.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,2.925),(13.545,3.095),(13.715,3.095),(13.715,2.925),(13.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.865),(81.085,17.035),(81.255,17.035),(81.255,16.865),(81.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.985),(57.085,6.155),(57.255,6.155),(57.255,5.985),(57.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,19.245),(71.145,19.415),(71.315,19.415),(71.315,19.245),(71.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,19.245),(71.485,19.415),(71.655,19.415),(71.655,19.245),(71.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.985),(33.085,6.155),(33.255,6.155),(33.255,5.985),(33.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,2.925),(18.685,3.095),(18.855,3.095),(18.855,2.925),(18.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,2.925),(18.345,3.095),(18.515,3.095),(18.515,2.925),(18.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.985),(9.085,6.155),(9.255,6.155),(9.255,5.985),(9.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.925),(47.145,3.095),(47.315,3.095),(47.315,2.925),(47.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.925),(47.485,3.095),(47.655,3.095),(47.655,2.925),(47.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.105),(27.945,12.275),(28.115,12.275),(28.115,12.105),(27.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.445),(27.945,12.615),(28.115,12.615),(28.115,12.445),(27.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,12.785),(27.945,12.955),(28.115,12.955),(28.115,12.785),(27.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,19.245),(80.745,19.415),(80.915,19.415),(80.915,19.245),(80.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.885),(9.085,18.055),(9.255,18.055),(9.255,17.885),(9.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.345),(57.085,7.515),(57.255,7.515),(57.255,7.345),(57.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.685),(57.085,7.855),(57.255,7.855),(57.255,7.685),(57.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.005),(57.085,7.175),(57.255,7.175),(57.255,7.005),(57.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,19.245),(81.085,19.415),(81.255,19.415),(81.255,19.245),(81.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.825),(37.885,14.995),(38.055,14.995),(38.055,14.825),(37.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.485),(37.885,14.655),(38.055,14.655),(38.055,14.485),(37.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.145),(37.885,14.315),(38.055,14.315),(38.055,14.145),(37.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.005),(33.085,7.175),(33.255,7.175),(33.255,7.005),(33.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.345),(33.085,7.515),(33.255,7.515),(33.255,7.345),(33.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.685),(33.085,7.855),(33.255,7.855),(33.255,7.685),(33.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.285),(13.885,4.455),(14.055,4.455),(14.055,4.285),(13.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.625),(13.885,4.795),(14.055,4.795),(14.055,4.625),(13.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.685),(9.085,7.855),(9.255,7.855),(9.255,7.685),(9.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.005),(9.085,7.175),(9.255,7.175),(9.255,7.005),(9.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,7.345),(9.085,7.515),(9.255,7.515),(9.255,7.345),(9.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.925),(42.345,3.095),(42.515,3.095),(42.515,2.925),(42.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.925),(42.685,3.095),(42.855,3.095),(42.855,2.925),(42.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.065),(47.145,10.235),(47.315,10.235),(47.315,10.065),(47.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.065),(47.485,10.235),(47.655,10.235),(47.655,10.065),(47.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.325),(23.145,6.495),(23.315,6.495),(23.315,6.325),(23.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.325),(23.485,6.495),(23.655,6.495),(23.655,6.325),(23.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,6.665),(23.145,6.835),(23.315,6.835),(23.315,6.665),(23.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,6.665),(23.485,6.835),(23.655,6.835),(23.655,6.665),(23.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.405),(47.145,10.575),(47.315,10.575),(47.315,10.405),(47.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.405),(47.485,10.575),(47.655,10.575),(47.655,10.405),(47.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.745),(47.145,10.915),(47.315,10.915),(47.315,10.745),(47.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.745),(47.485,10.915),(47.655,10.915),(47.655,10.745),(47.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.965),(47.485,5.135),(47.655,5.135),(47.655,4.965),(47.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.965),(47.145,5.135),(47.315,5.135),(47.315,4.965),(47.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.185),(32.745,16.355),(32.915,16.355),(32.915,16.185),(32.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.525),(32.745,16.695),(32.915,16.695),(32.915,16.525),(32.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.905),(61.885,19.075),(62.055,19.075),(62.055,18.905),(61.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.025),(47.145,8.195),(47.315,8.195),(47.315,8.025),(47.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.025),(47.485,8.195),(47.655,8.195),(47.655,8.025),(47.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.365),(47.145,8.535),(47.315,8.535),(47.315,8.365),(47.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.365),(47.485,8.535),(47.655,8.535),(47.655,8.365),(47.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.705),(47.145,8.875),(47.315,8.875),(47.315,8.705),(47.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.705),(47.485,8.875),(47.655,8.875),(47.655,8.705),(47.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.365),(81.085,8.535),(81.255,8.535),(81.255,8.365),(81.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.705),(81.085,8.875),(81.255,8.875),(81.255,8.705),(81.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,8.025),(81.085,8.195),(81.255,8.195),(81.255,8.025),(81.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.045),(66.345,9.215),(66.515,9.215),(66.515,9.045),(66.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.045),(66.685,9.215),(66.855,9.215),(66.855,9.045),(66.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.345),(81.085,7.515),(81.255,7.515),(81.255,7.345),(81.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.685),(81.085,7.855),(81.255,7.855),(81.255,7.685),(81.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,7.005),(81.085,7.175),(81.255,7.175),(81.255,7.005),(81.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.205),(47.485,17.375),(47.655,17.375),(47.655,17.205),(47.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.545),(47.145,17.715),(47.315,17.715),(47.315,17.545),(47.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.205),(47.145,17.375),(47.315,17.375),(47.315,17.205),(47.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.545),(47.485,17.715),(47.655,17.715),(47.655,17.545),(47.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,2.925),(61.545,3.095),(61.715,3.095),(61.715,2.925),(61.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.305),(61.885,5.475),(62.055,5.475),(62.055,5.305),(61.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.645),(61.885,5.815),(62.055,5.815),(62.055,5.645),(61.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.305),(13.885,5.475),(14.055,5.475),(14.055,5.305),(13.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.645),(13.885,5.815),(14.055,5.815),(14.055,5.645),(13.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,2.925),(71.145,3.095),(71.315,3.095),(71.315,2.925),(71.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,2.925),(71.485,3.095),(71.655,3.095),(71.655,2.925),(71.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.845),(32.745,16.015),(32.915,16.015),(32.915,15.845),(32.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.145),(13.885,14.315),(14.055,14.315),(14.055,14.145),(13.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.485),(13.885,14.655),(14.055,14.655),(14.055,14.485),(13.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,14.825),(13.885,14.995),(14.055,14.995),(14.055,14.825),(13.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.285),(61.885,4.455),(62.055,4.455),(62.055,4.285),(61.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.625),(61.885,4.795),(62.055,4.795),(62.055,4.625),(61.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.045),(8.745,9.215),(8.915,9.215),(8.915,9.045),(8.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.025),(33.085,8.195),(33.255,8.195),(33.255,8.025),(33.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.365),(33.085,8.535),(33.255,8.535),(33.255,8.365),(33.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.705),(33.085,8.875),(33.255,8.875),(33.255,8.705),(33.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.045),(18.345,9.215),(18.515,9.215),(18.515,9.045),(18.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.045),(18.685,9.215),(18.855,9.215),(18.855,9.045),(18.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.325),(13.545,6.495),(13.715,6.495),(13.715,6.325),(13.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,6.665),(13.545,6.835),(13.715,6.835),(13.715,6.665),(13.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.785),(23.145,12.955),(23.315,12.955),(23.315,12.785),(23.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.185),(9.085,16.355),(9.255,16.355),(9.255,16.185),(9.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.525),(9.085,16.695),(9.255,16.695),(9.255,16.525),(9.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.425),(18.685,11.595),(18.855,11.595),(18.855,11.425),(18.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.425),(18.345,11.595),(18.515,11.595),(18.515,11.425),(18.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.765),(18.345,11.935),(18.515,11.935),(18.515,11.765),(18.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.765),(18.685,11.935),(18.855,11.935),(18.855,11.765),(18.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,11.085),(18.345,11.255),(18.515,11.255),(18.515,11.085),(18.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,11.085),(18.685,11.255),(18.855,11.255),(18.855,11.085),(18.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.905),(75.945,19.075),(76.115,19.075),(76.115,18.905),(75.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.325),(47.145,6.495),(47.315,6.495),(47.315,6.325),(47.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.325),(47.485,6.495),(47.655,6.495),(47.655,6.325),(47.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.665),(47.145,6.835),(47.315,6.835),(47.315,6.665),(47.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.665),(47.485,6.835),(47.655,6.835),(47.655,6.665),(47.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.205),(42.345,17.375),(42.515,17.375),(42.515,17.205),(42.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.205),(42.685,17.375),(42.855,17.375),(42.855,17.205),(42.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.545),(42.345,17.715),(42.515,17.715),(42.515,17.545),(42.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.545),(42.685,17.715),(42.855,17.715),(42.855,17.545),(42.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.905),(9.085,19.075),(9.255,19.075),(9.255,18.905),(9.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.885),(28.285,18.055),(28.455,18.055),(28.455,17.885),(28.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.105),(75.945,12.275),(76.115,12.275),(76.115,12.105),(75.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.445),(75.945,12.615),(76.115,12.615),(76.115,12.445),(75.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,12.785),(75.945,12.955),(76.115,12.955),(76.115,12.785),(75.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.885),(32.745,18.055),(32.915,18.055),(32.915,17.885),(32.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.145),(61.885,14.315),(62.055,14.315),(62.055,14.145),(61.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.485),(61.885,14.655),(62.055,14.655),(62.055,14.485),(61.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,14.825),(61.885,14.995),(62.055,14.995),(62.055,14.825),(61.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,19.245),(27.945,19.415),(28.115,19.415),(28.115,19.245),(27.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.045),(56.745,9.215),(56.915,9.215),(56.915,9.045),(56.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.905),(8.745,19.075),(8.915,19.075),(8.915,18.905),(8.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.325),(61.545,6.495),(61.715,6.495),(61.715,6.325),(61.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,6.665),(61.545,6.835),(61.715,6.835),(61.715,6.665),(61.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.645),(52.285,5.815),(52.455,5.815),(52.455,5.645),(52.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.305),(52.285,5.475),(52.455,5.475),(52.455,5.305),(52.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.125),(81.085,13.295),(81.255,13.295),(81.255,13.125),(81.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.465),(81.085,13.635),(81.255,13.635),(81.255,13.465),(81.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,13.805),(81.085,13.975),(81.255,13.975),(81.255,13.805),(81.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.445),(81.085,12.615),(81.255,12.615),(81.255,12.445),(81.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.785),(81.085,12.955),(81.255,12.955),(81.255,12.785),(81.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,12.105),(81.085,12.275),(81.255,12.275),(81.255,12.105),(81.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,3.945),(27.945,4.115),(28.115,4.115),(28.115,3.945),(27.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.185),(51.945,16.355),(52.115,16.355),(52.115,16.185),(51.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.525),(51.945,16.695),(52.115,16.695),(52.115,16.525),(51.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.005),(8.745,7.175),(8.915,7.175),(8.915,7.005),(8.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.345),(8.745,7.515),(8.915,7.515),(8.915,7.345),(8.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.305),(76.285,5.475),(76.455,5.475),(76.455,5.305),(76.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,5.645),(76.285,5.815),(76.455,5.815),(76.455,5.645),(76.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.325),(71.145,6.495),(71.315,6.495),(71.315,6.325),(71.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.325),(71.485,6.495),(71.655,6.495),(71.655,6.325),(71.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,6.665),(71.145,6.835),(71.315,6.835),(71.315,6.665),(71.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,6.665),(71.485,6.835),(71.655,6.835),(71.655,6.665),(71.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.845),(80.745,16.015),(80.915,16.015),(80.915,15.845),(80.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.765),(32.745,11.935),(32.915,11.935),(32.915,11.765),(32.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.085),(32.745,11.255),(32.915,11.255),(32.915,11.085),(32.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.425),(32.745,11.595),(32.915,11.595),(32.915,11.425),(32.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.845),(8.745,16.015),(8.915,16.015),(8.915,15.845),(8.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.425),(66.685,11.595),(66.855,11.595),(66.855,11.425),(66.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.425),(66.345,11.595),(66.515,11.595),(66.515,11.425),(66.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.765),(66.685,11.935),(66.855,11.935),(66.855,11.765),(66.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.765),(66.345,11.935),(66.515,11.935),(66.515,11.765),(66.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,11.085),(66.345,11.255),(66.515,11.255),(66.515,11.085),(66.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,11.085),(66.685,11.255),(66.855,11.255),(66.855,11.085),(66.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.105),(33.085,12.275),(33.255,12.275),(33.255,12.105),(33.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.445),(33.085,12.615),(33.255,12.615),(33.255,12.445),(33.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.785),(33.085,12.955),(33.255,12.955),(33.255,12.785),(33.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.305),(47.145,5.475),(47.315,5.475),(47.315,5.305),(47.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.305),(47.485,5.475),(47.655,5.475),(47.655,5.305),(47.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.645),(47.145,5.815),(47.315,5.815),(47.315,5.645),(47.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.645),(47.485,5.815),(47.655,5.815),(47.655,5.645),(47.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.905),(13.885,19.075),(14.055,19.075),(14.055,18.905),(13.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.325),(8.745,6.495),(8.915,6.495),(8.915,6.325),(8.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,6.665),(8.745,6.835),(8.915,6.835),(8.915,6.665),(8.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.305),(23.145,5.475),(23.315,5.475),(23.315,5.305),(23.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.305),(23.485,5.475),(23.655,5.475),(23.655,5.305),(23.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,5.645),(23.145,5.815),(23.315,5.815),(23.315,5.645),(23.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,5.645),(23.485,5.815),(23.655,5.815),(23.655,5.645),(23.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.465),(8.745,13.635),(8.915,13.635),(8.915,13.465),(8.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.805),(8.745,13.975),(8.915,13.975),(8.915,13.805),(8.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,13.125),(8.745,13.295),(8.915,13.295),(8.915,13.125),(8.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.965),(56.745,5.135),(56.915,5.135),(56.915,4.965),(56.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.325),(66.685,6.495),(66.855,6.495),(66.855,6.325),(66.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.325),(66.345,6.495),(66.515,6.495),(66.515,6.325),(66.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,6.665),(66.685,6.835),(66.855,6.835),(66.855,6.665),(66.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,6.665),(66.345,6.835),(66.515,6.835),(66.515,6.665),(66.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.965),(32.745,5.135),(32.915,5.135),(32.915,4.965),(32.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.385),(80.745,9.555),(80.915,9.555),(80.915,9.385),(80.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,4.965),(13.545,5.135),(13.715,5.135),(13.715,4.965),(13.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.725),(80.745,9.895),(80.915,9.895),(80.915,9.725),(80.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,4.965),(8.745,5.135),(8.915,5.135),(8.915,4.965),(8.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.605),(81.085,3.775),(81.255,3.775),(81.255,3.605),(81.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.265),(81.085,3.435),(81.255,3.435),(81.255,3.265),(81.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.885),(66.685,18.055),(66.855,18.055),(66.855,17.885),(66.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.885),(66.345,18.055),(66.515,18.055),(66.515,17.885),(66.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,5.985),(27.945,6.155),(28.115,6.155),(28.115,5.985),(27.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.565),(42.345,18.735),(42.515,18.735),(42.515,18.565),(42.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.225),(42.345,18.395),(42.515,18.395),(42.515,18.225),(42.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.565),(42.685,18.735),(42.855,18.735),(42.855,18.565),(42.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.225),(42.685,18.395),(42.855,18.395),(42.855,18.225),(42.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.845),(37.545,16.015),(37.715,16.015),(37.715,15.845),(37.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,19.245),(61.885,19.415),(62.055,19.415),(62.055,19.245),(61.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.365),(32.745,8.535),(32.915,8.535),(32.915,8.365),(32.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.705),(32.745,8.875),(32.915,8.875),(32.915,8.705),(32.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.025),(32.745,8.195),(32.915,8.195),(32.915,8.025),(32.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.845),(56.745,16.015),(56.915,16.015),(56.915,15.845),(56.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.185),(61.885,16.355),(62.055,16.355),(62.055,16.185),(61.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,16.525),(61.885,16.695),(62.055,16.695),(62.055,16.525),(61.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.525),(47.145,16.695),(47.315,16.695),(47.315,16.525),(47.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.185),(47.145,16.355),(47.315,16.355),(47.315,16.185),(47.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.525),(47.485,16.695),(47.655,16.695),(47.655,16.525),(47.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.185),(47.485,16.355),(47.655,16.355),(47.655,16.185),(47.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.285),(27.945,4.455),(28.115,4.455),(28.115,4.285),(27.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,4.625),(27.945,4.795),(28.115,4.795),(28.115,4.625),(27.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.665),(18.345,6.835),(18.515,6.835),(18.515,6.665),(18.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.665),(18.685,6.835),(18.855,6.835),(18.855,6.665),(18.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,6.325),(18.345,6.495),(18.515,6.495),(18.515,6.325),(18.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,6.325),(18.685,6.495),(18.855,6.495),(18.855,6.325),(18.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.685),(51.945,7.855),(52.115,7.855),(52.115,7.685),(51.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.385),(32.745,9.555),(32.915,9.555),(32.915,9.385),(32.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.725),(32.745,9.895),(32.915,9.895),(32.915,9.725),(32.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.345),(51.945,7.515),(52.115,7.515),(52.115,7.345),(51.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.005),(51.945,7.175),(52.115,7.175),(52.115,7.005),(51.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.765),(37.885,11.935),(38.055,11.935),(38.055,11.765),(37.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.085),(37.885,11.255),(38.055,11.255),(38.055,11.085),(37.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.425),(37.885,11.595),(38.055,11.595),(38.055,11.425),(37.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.285),(52.285,4.455),(52.455,4.455),(52.455,4.285),(52.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.625),(52.285,4.795),(52.455,4.795),(52.455,4.625),(52.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.945),(57.085,4.115),(57.255,4.115),(57.255,3.945),(57.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.465),(56.745,13.635),(56.915,13.635),(56.915,13.465),(56.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.805),(56.745,13.975),(56.915,13.975),(56.915,13.805),(56.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.125),(56.745,13.295),(56.915,13.295),(56.915,13.125),(56.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.945),(33.085,4.115),(33.255,4.115),(33.255,3.945),(33.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.765),(80.745,11.935),(80.915,11.935),(80.915,11.765),(80.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.985),(18.345,6.155),(18.515,6.155),(18.515,5.985),(18.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.985),(18.685,6.155),(18.855,6.155),(18.855,5.985),(18.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.945),(9.085,4.115),(9.255,4.115),(9.255,3.945),(9.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.425),(80.745,11.595),(80.915,11.595),(80.915,11.425),(80.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,11.085),(80.745,11.255),(80.915,11.255),(80.915,11.085),(80.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.905),(52.285,19.075),(52.455,19.075),(52.455,18.905),(52.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.985),(51.945,6.155),(52.115,6.155),(52.115,5.985),(51.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,4.965),(61.545,5.135),(61.715,5.135),(61.715,4.965),(61.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.325),(42.345,6.495),(42.515,6.495),(42.515,6.325),(42.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.325),(42.685,6.495),(42.855,6.495),(42.855,6.325),(42.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.665),(42.345,6.835),(42.515,6.835),(42.515,6.665),(42.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.665),(42.685,6.835),(42.855,6.835),(42.855,6.665),(42.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.445),(37.885,12.615),(38.055,12.615),(38.055,12.445),(37.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.505),(52.285,15.675),(52.455,15.675),(52.455,15.505),(52.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.165),(52.285,15.335),(52.455,15.335),(52.455,15.165),(52.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.785),(37.885,12.955),(38.055,12.955),(38.055,12.785),(37.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.105),(37.885,12.275),(38.055,12.275),(38.055,12.105),(37.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.205),(57.085,17.375),(57.255,17.375),(57.255,17.205),(57.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.545),(57.085,17.715),(57.255,17.715),(57.255,17.545),(57.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.885),(37.545,18.055),(37.715,18.055),(37.715,17.885),(37.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.885),(80.745,18.055),(80.915,18.055),(80.915,17.885),(80.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.245),(37.545,19.415),(37.715,19.415),(37.715,19.245),(37.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.005),(80.745,7.175),(80.915,7.175),(80.915,7.005),(80.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.345),(80.745,7.515),(80.915,7.515),(80.915,7.345),(80.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.325),(81.085,6.495),(81.255,6.495),(81.255,6.325),(81.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,6.665),(81.085,6.835),(81.255,6.835),(81.255,6.665),(81.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.185),(66.345,16.355),(66.515,16.355),(66.515,16.185),(66.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.185),(66.685,16.355),(66.855,16.355),(66.855,16.185),(66.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.525),(66.345,16.695),(66.515,16.695),(66.515,16.525),(66.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.525),(66.685,16.695),(66.855,16.695),(66.855,16.525),(66.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.385),(37.545,9.555),(37.715,9.555),(37.715,9.385),(37.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.725),(37.545,9.895),(37.715,9.895),(37.715,9.725),(37.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.885),(76.285,18.055),(76.455,18.055),(76.455,17.885),(76.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.205),(28.285,17.375),(28.455,17.375),(28.455,17.205),(28.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,17.545),(28.285,17.715),(28.455,17.715),(28.455,17.545),(28.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.345),(37.885,7.515),(38.055,7.515),(38.055,7.345),(37.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.685),(37.885,7.855),(38.055,7.855),(38.055,7.685),(37.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.005),(37.885,7.175),(38.055,7.175),(38.055,7.005),(37.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.985),(80.745,6.155),(80.915,6.155),(80.915,5.985),(80.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.885),(33.085,18.055),(33.255,18.055),(33.255,17.885),(33.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.265),(28.285,3.435),(28.455,3.435),(28.455,3.265),(28.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,3.605),(28.285,3.775),(28.455,3.775),(28.455,3.605),(28.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.385),(57.085,9.555),(57.255,9.555),(57.255,9.385),(57.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.725),(57.085,9.895),(57.255,9.895),(57.255,9.725),(57.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.105),(32.745,12.275),(32.915,12.275),(32.915,12.105),(32.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.445),(32.745,12.615),(32.915,12.615),(32.915,12.445),(32.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.785),(32.745,12.955),(32.915,12.955),(32.915,12.785),(32.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.105),(13.885,12.275),(14.055,12.275),(14.055,12.105),(13.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.445),(13.885,12.615),(14.055,12.615),(14.055,12.445),(13.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,12.785),(13.885,12.955),(14.055,12.955),(14.055,12.785),(13.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,19.245),(75.945,19.415),(76.115,19.415),(76.115,19.245),(75.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.205),(32.745,17.375),(32.915,17.375),(32.915,17.205),(32.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.545),(32.745,17.715),(32.915,17.715),(32.915,17.545),(32.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.005),(61.885,7.175),(62.055,7.175),(62.055,7.005),(61.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.845),(61.545,16.015),(61.715,16.015),(61.715,15.845),(61.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.345),(61.885,7.515),(62.055,7.515),(62.055,7.345),(61.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.385),(9.085,9.555),(9.255,9.555),(9.255,9.385),(9.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.725),(9.085,9.895),(9.255,9.895),(9.255,9.725),(9.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.385),(52.285,9.555),(52.455,9.555),(52.455,9.385),(52.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.725),(52.285,9.895),(52.455,9.895),(52.455,9.725),(52.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.865),(37.545,17.035),(37.715,17.035),(37.715,16.865),(37.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.845),(13.545,16.015),(13.715,16.015),(13.715,15.845),(13.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.845),(52.285,16.015),(52.455,16.015),(52.455,15.845),(52.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.885),(37.885,18.055),(38.055,18.055),(38.055,17.885),(37.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.865),(52.285,17.035),(52.455,17.035),(52.455,16.865),(52.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.465),(52.285,13.635),(52.455,13.635),(52.455,13.465),(52.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.805),(52.285,13.975),(52.455,13.975),(52.455,13.805),(52.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.125),(52.285,13.295),(52.455,13.295),(52.455,13.125),(52.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,4.965),(80.745,5.135),(80.915,5.135),(80.915,4.965),(80.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.125),(71.145,13.295),(71.315,13.295),(71.315,13.125),(71.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.285),(75.945,4.455),(76.115,4.455),(76.115,4.285),(75.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,4.625),(75.945,4.795),(76.115,4.795),(76.115,4.625),(75.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.985),(56.745,6.155),(56.915,6.155),(56.915,5.985),(56.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.325),(61.885,6.495),(62.055,6.495),(62.055,6.325),(61.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,6.665),(61.885,6.835),(62.055,6.835),(62.055,6.665),(61.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.085),(61.885,11.255),(62.055,11.255),(62.055,11.085),(61.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.425),(61.885,11.595),(62.055,11.595),(62.055,11.425),(61.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,11.765),(61.885,11.935),(62.055,11.935),(62.055,11.765),(61.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.985),(32.745,6.155),(32.915,6.155),(32.915,5.985),(32.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.085),(13.885,11.255),(14.055,11.255),(14.055,11.085),(13.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.765),(13.885,11.935),(14.055,11.935),(14.055,11.765),(13.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.225),(27.945,18.395),(28.115,18.395),(28.115,18.225),(27.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,18.565),(27.945,18.735),(28.115,18.735),(28.115,18.565),(27.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,11.425),(13.885,11.595),(14.055,11.595),(14.055,11.425),(13.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.245),(57.085,19.415),(57.255,19.415),(57.255,19.245),(57.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.025),(80.745,8.195),(80.915,8.195),(80.915,8.025),(80.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.365),(80.745,8.535),(80.915,8.535),(80.915,8.365),(80.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,8.705),(80.745,8.875),(80.915,8.875),(80.915,8.705),(80.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.245),(42.345,19.415),(42.515,19.415),(42.515,19.245),(42.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.245),(42.685,19.415),(42.855,19.415),(42.855,19.245),(42.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.185),(13.885,16.355),(14.055,16.355),(14.055,16.185),(13.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,16.525),(13.885,16.695),(14.055,16.695),(14.055,16.525),(13.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.445),(61.885,12.615),(62.055,12.615),(62.055,12.445),(61.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.785),(61.885,12.955),(62.055,12.955),(62.055,12.785),(61.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,12.105),(61.885,12.275),(62.055,12.275),(62.055,12.105),(61.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.505),(42.345,15.675),(42.515,15.675),(42.515,15.505),(42.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.505),(42.685,15.675),(42.855,15.675),(42.855,15.505),(42.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.165),(42.345,15.335),(42.515,15.335),(42.515,15.165),(42.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.165),(42.685,15.335),(42.855,15.335),(42.855,15.165),(42.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.925),(37.885,3.095),(38.055,3.095),(38.055,2.925),(37.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.045),(47.145,9.215),(47.315,9.215),(47.315,9.045),(47.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.045),(47.485,9.215),(47.655,9.215),(47.655,9.045),(47.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.505),(28.285,15.675),(28.455,15.675),(28.455,15.505),(28.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.165),(28.285,15.335),(28.455,15.335),(28.455,15.165),(28.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.305),(37.545,5.475),(37.715,5.475),(37.715,5.305),(37.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.645),(37.545,5.815),(37.715,5.815),(37.715,5.645),(37.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.185),(80.745,16.355),(80.915,16.355),(80.915,16.185),(80.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.525),(80.745,16.695),(80.915,16.695),(80.915,16.525),(80.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.965),(37.885,5.135),(38.055,5.135),(38.055,4.965),(37.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.765),(57.085,11.935),(57.255,11.935),(57.255,11.765),(57.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.865),(42.345,17.035),(42.515,17.035),(42.515,16.865),(42.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.085),(57.085,11.255),(57.255,11.255),(57.255,11.085),(57.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.425),(57.085,11.595),(57.255,11.595),(57.255,11.425),(57.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.865),(42.685,17.035),(42.855,17.035),(42.855,16.865),(42.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.745),(32.745,10.915),(32.915,10.915),(32.915,10.745),(32.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.065),(32.745,10.235),(32.915,10.235),(32.915,10.065),(32.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.145),(56.745,14.315),(56.915,14.315),(56.915,14.145),(56.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.485),(56.745,14.655),(56.915,14.655),(56.915,14.485),(56.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.825),(56.745,14.995),(56.915,14.995),(56.915,14.825),(56.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.405),(32.745,10.575),(32.915,10.575),(32.915,10.405),(32.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.165),(47.145,15.335),(47.315,15.335),(47.315,15.165),(47.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.165),(47.485,15.335),(47.655,15.335),(47.655,15.165),(47.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.505),(47.485,15.675),(47.655,15.675),(47.655,15.505),(47.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.505),(47.145,15.675),(47.315,15.675),(47.315,15.505),(47.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.545),(66.685,17.715),(66.855,17.715),(66.855,17.545),(66.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.205),(66.345,17.375),(66.515,17.375),(66.515,17.205),(66.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.765),(9.085,11.935),(9.255,11.935),(9.255,11.765),(9.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.425),(9.085,11.595),(9.255,11.595),(9.255,11.425),(9.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,17.205),(66.685,17.375),(66.855,17.375),(66.855,17.205),(66.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,17.545),(66.345,17.715),(66.515,17.715),(66.515,17.545),(66.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,11.085),(9.085,11.255),(9.255,11.255),(9.255,11.085),(9.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.485),(8.745,14.655),(8.915,14.655),(8.915,14.485),(8.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.825),(8.745,14.995),(8.915,14.995),(8.915,14.825),(8.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,14.145),(8.745,14.315),(8.915,14.315),(8.915,14.145),(8.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.865),(57.085,17.035),(57.255,17.035),(57.255,16.865),(57.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.945),(13.885,4.115),(14.055,4.115),(14.055,3.945),(13.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.265),(71.145,3.435),(71.315,3.435),(71.315,3.265),(71.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.265),(71.485,3.435),(71.655,3.435),(71.655,3.265),(71.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.605),(71.145,3.775),(71.315,3.775),(71.315,3.605),(71.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.605),(71.485,3.775),(71.655,3.775),(71.655,3.605),(71.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.525),(18.345,16.695),(18.515,16.695),(18.515,16.525),(18.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.525),(18.685,16.695),(18.855,16.695),(18.855,16.525),(18.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.185),(18.345,16.355),(18.515,16.355),(18.515,16.185),(18.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.185),(18.685,16.355),(18.855,16.355),(18.855,16.185),(18.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.385),(61.545,9.555),(61.715,9.555),(61.715,9.385),(61.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.725),(61.545,9.895),(61.715,9.895),(61.715,9.725),(61.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.265),(47.145,3.435),(47.315,3.435),(47.315,3.265),(47.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.265),(47.485,3.435),(47.655,3.435),(47.655,3.265),(47.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.605),(47.145,3.775),(47.315,3.775),(47.315,3.605),(47.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.605),(47.485,3.775),(47.655,3.775),(47.655,3.605),(47.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.265),(23.485,3.435),(23.655,3.435),(23.655,3.265),(23.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.265),(23.145,3.435),(23.315,3.435),(23.315,3.265),(23.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.605),(23.145,3.775),(23.315,3.775),(23.315,3.605),(23.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.905),(47.145,19.075),(47.315,19.075),(47.315,18.905),(47.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.905),(47.485,19.075),(47.655,19.075),(47.655,18.905),(47.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.605),(23.485,3.775),(23.655,3.775),(23.655,3.605),(23.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.725),(13.545,9.895),(13.715,9.895),(13.715,9.725),(13.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.385),(13.545,9.555),(13.715,9.555),(13.715,9.385),(13.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,19.245),(13.885,19.415),(14.055,19.415),(14.055,19.245),(13.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.065),(80.745,10.235),(80.915,10.235),(80.915,10.065),(80.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.405),(80.745,10.575),(80.915,10.575),(80.915,10.405),(80.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.045),(33.085,9.215),(33.255,9.215),(33.255,9.045),(33.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,10.745),(80.745,10.915),(80.915,10.915),(80.915,10.745),(80.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.905),(37.545,19.075),(37.715,19.075),(37.715,18.905),(37.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.725),(76.285,9.895),(76.455,9.895),(76.455,9.725),(76.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.385),(76.285,9.555),(76.455,9.555),(76.455,9.385),(76.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.885),(18.345,18.055),(18.515,18.055),(18.515,17.885),(18.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.885),(18.685,18.055),(18.855,18.055),(18.855,17.885),(18.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.305),(18.345,5.475),(18.515,5.475),(18.515,5.305),(18.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,5.645),(18.345,5.815),(18.515,5.815),(18.515,5.645),(18.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.645),(18.685,5.815),(18.855,5.815),(18.855,5.645),(18.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,5.305),(18.685,5.475),(18.855,5.475),(18.855,5.305),(18.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.385),(28.285,9.555),(28.455,9.555),(28.455,9.385),(28.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.725),(28.285,9.895),(28.455,9.895),(28.455,9.725),(28.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.885),(51.945,18.055),(52.115,18.055),(52.115,17.885),(51.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.565),(66.685,18.735),(66.855,18.735),(66.855,18.565),(66.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.225),(66.345,18.395),(66.515,18.395),(66.515,18.225),(66.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.225),(66.685,18.395),(66.855,18.395),(66.855,18.225),(66.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.565),(66.345,18.735),(66.515,18.735),(66.515,18.565),(66.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,15.845),(28.285,16.015),(28.455,16.015),(28.455,15.845),(28.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.125),(76.285,13.295),(76.455,13.295),(76.455,13.125),(76.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.465),(76.285,13.635),(76.455,13.635),(76.455,13.465),(76.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,13.805),(76.285,13.975),(76.455,13.975),(76.455,13.805),(76.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.265),(61.545,3.435),(61.715,3.435),(61.715,3.265),(61.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,3.605),(61.545,3.775),(61.715,3.775),(61.715,3.605),(61.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.845),(37.885,16.015),(38.055,16.015),(38.055,15.845),(37.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.125),(28.285,13.295),(28.455,13.295),(28.455,13.125),(28.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.465),(28.285,13.635),(28.455,13.635),(28.455,13.465),(28.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,13.805),(28.285,13.975),(28.455,13.975),(28.455,13.805),(28.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.265),(13.545,3.435),(13.715,3.435),(13.715,3.265),(13.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,3.605),(13.545,3.775),(13.715,3.775),(13.715,3.605),(13.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.305),(57.085,5.475),(57.255,5.475),(57.255,5.305),(57.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.645),(57.085,5.815),(57.255,5.815),(57.255,5.645),(57.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.225),(23.145,18.395),(23.315,18.395),(23.315,18.225),(23.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.225),(23.485,18.395),(23.655,18.395),(23.655,18.225),(23.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.565),(23.145,18.735),(23.315,18.735),(23.315,18.565),(23.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.565),(23.485,18.735),(23.655,18.735),(23.655,18.565),(23.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.305),(33.085,5.475),(33.255,5.475),(33.255,5.305),(33.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.645),(33.085,5.815),(33.255,5.815),(33.255,5.645),(33.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.105),(80.745,12.275),(80.915,12.275),(80.915,12.105),(80.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.445),(80.745,12.615),(80.915,12.615),(80.915,12.445),(80.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.305),(9.085,5.475),(9.255,5.475),(9.255,5.305),(9.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,5.645),(9.085,5.815),(9.255,5.815),(9.255,5.645),(9.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,12.785),(80.745,12.955),(80.915,12.955),(80.915,12.785),(80.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.205),(9.085,17.375),(9.255,17.375),(9.255,17.205),(9.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,17.545),(9.085,17.715),(9.255,17.715),(9.255,17.545),(9.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.105),(42.345,12.275),(42.515,12.275),(42.515,12.105),(42.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.105),(42.685,12.275),(42.855,12.275),(42.855,12.105),(42.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.185),(61.545,16.355),(61.715,16.355),(61.715,16.185),(61.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.525),(61.545,16.695),(61.715,16.695),(61.715,16.525),(61.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.445),(42.345,12.615),(42.515,12.615),(42.515,12.445),(42.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.445),(42.685,12.615),(42.855,12.615),(42.855,12.445),(42.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.785),(42.345,12.955),(42.515,12.955),(42.515,12.785),(42.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.785),(42.685,12.955),(42.855,12.955),(42.855,12.785),(42.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.785),(23.485,12.955),(23.655,12.955),(23.655,12.785),(23.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.205),(61.885,17.375),(62.055,17.375),(62.055,17.205),(61.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.545),(61.885,17.715),(62.055,17.715),(62.055,17.545),(61.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.205),(80.745,17.375),(80.915,17.375),(80.915,17.205),(80.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,17.545),(80.745,17.715),(80.915,17.715),(80.915,17.545),(80.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.225),(32.745,18.395),(32.915,18.395),(32.915,18.225),(32.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.565),(32.745,18.735),(32.915,18.735),(32.915,18.565),(32.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.385),(23.145,9.555),(23.315,9.555),(23.315,9.385),(23.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.385),(23.485,9.555),(23.655,9.555),(23.655,9.385),(23.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.725),(23.145,9.895),(23.315,9.895),(23.315,9.725),(23.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.725),(23.485,9.895),(23.655,9.895),(23.655,9.725),(23.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.385),(37.885,9.555),(38.055,9.555),(38.055,9.385),(37.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.725),(37.885,9.895),(38.055,9.895),(38.055,9.725),(37.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.865),(27.945,17.035),(28.115,17.035),(28.115,16.865),(27.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.945),(37.885,4.115),(38.055,4.115),(38.055,3.945),(37.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,2.925),(75.945,3.095),(76.115,3.095),(76.115,2.925),(75.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,2.925),(27.945,3.095),(28.115,3.095),(28.115,2.925),(27.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.865),(32.745,17.035),(32.915,17.035),(32.915,16.865),(32.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.225),(61.885,18.395),(62.055,18.395),(62.055,18.225),(61.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,18.565),(61.885,18.735),(62.055,18.735),(62.055,18.565),(61.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.505),(76.285,15.675),(76.455,15.675),(76.455,15.505),(76.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.165),(76.285,15.335),(76.455,15.335),(76.455,15.165),(76.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.545),(76.285,17.715),(76.455,17.715),(76.455,17.545),(76.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,17.205),(76.285,17.375),(76.455,17.375),(76.455,17.205),(76.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.805),(23.485,13.975),(23.655,13.975),(23.655,13.805),(23.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.465),(23.145,13.635),(23.315,13.635),(23.315,13.465),(23.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.465),(23.485,13.635),(23.655,13.635),(23.655,13.465),(23.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.805),(23.145,13.975),(23.315,13.975),(23.315,13.805),(23.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,13.125),(23.145,13.295),(23.315,13.295),(23.315,13.125),(23.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,13.125),(23.485,13.295),(23.655,13.295),(23.655,13.125),(23.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,2.925),(9.085,3.095),(9.255,3.095),(9.255,2.925),(9.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.945),(37.545,4.115),(37.715,4.115),(37.715,3.945),(37.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.645),(80.745,5.815),(80.915,5.815),(80.915,5.645),(80.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,5.305),(80.745,5.475),(80.915,5.475),(80.915,5.305),(80.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.565),(33.085,18.735),(33.255,18.735),(33.255,18.565),(33.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.225),(33.085,18.395),(33.255,18.395),(33.255,18.225),(33.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.145),(66.345,14.315),(66.515,14.315),(66.515,14.145),(66.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.145),(66.685,14.315),(66.855,14.315),(66.855,14.145),(66.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.485),(66.345,14.655),(66.515,14.655),(66.515,14.485),(66.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.485),(66.685,14.655),(66.855,14.655),(66.855,14.485),(66.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,14.825),(66.345,14.995),(66.515,14.995),(66.515,14.825),(66.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,14.825),(66.685,14.995),(66.855,14.995),(66.855,14.825),(66.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,5.985),(61.885,6.155),(62.055,6.155),(62.055,5.985),(61.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,5.985),(13.885,6.155),(14.055,6.155),(14.055,5.985),(13.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.165),(32.745,15.335),(32.915,15.335),(32.915,15.165),(32.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.505),(32.745,15.675),(32.915,15.675),(32.915,15.505),(32.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.265),(42.345,3.435),(42.515,3.435),(42.515,3.265),(42.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.265),(42.685,3.435),(42.855,3.435),(42.855,3.265),(42.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.605),(42.685,3.775),(42.855,3.775),(42.855,3.605),(42.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.605),(42.345,3.775),(42.515,3.775),(42.515,3.605),(42.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.405),(9.085,10.575),(9.255,10.575),(9.255,10.405),(9.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.065),(9.085,10.235),(9.255,10.235),(9.255,10.065),(9.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.565),(28.285,18.735),(28.455,18.735),(28.455,18.565),(28.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,10.745),(9.085,10.915),(9.255,10.915),(9.255,10.745),(9.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.225),(28.285,18.395),(28.455,18.395),(28.455,18.225),(28.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.925),(56.745,3.095),(56.915,3.095),(56.915,2.925),(56.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.045),(51.945,9.215),(52.115,9.215),(52.115,9.045),(51.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.925),(32.745,3.095),(32.915,3.095),(32.915,2.925),(32.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.965),(51.945,5.135),(52.115,5.135),(52.115,4.965),(51.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.125),(71.485,13.295),(71.655,13.295),(71.655,13.125),(71.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,2.925),(8.745,3.095),(8.915,3.095),(8.915,2.925),(8.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.305),(56.745,5.475),(56.915,5.475),(56.915,5.305),(56.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,16.865),(9.085,17.035),(9.255,17.035),(9.255,16.865),(9.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.645),(56.745,5.815),(56.915,5.815),(56.915,5.645),(56.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.225),(75.945,18.395),(76.115,18.395),(76.115,18.225),(75.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,18.565),(75.945,18.735),(76.115,18.735),(76.115,18.565),(75.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.305),(32.745,5.475),(32.915,5.475),(32.915,5.305),(32.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.645),(32.745,5.815),(32.915,5.815),(32.915,5.645),(32.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.825),(18.345,14.995),(18.515,14.995),(18.515,14.825),(18.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.485),(18.345,14.655),(18.515,14.655),(18.515,14.485),(18.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.485),(18.685,14.655),(18.855,14.655),(18.855,14.485),(18.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.825),(18.685,14.995),(18.855,14.995),(18.855,14.825),(18.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,14.145),(18.345,14.315),(18.515,14.315),(18.515,14.145),(18.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,14.145),(18.685,14.315),(18.855,14.315),(18.855,14.145),(18.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,2.925),(28.285,3.095),(28.455,3.095),(28.455,2.925),(28.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.265),(18.345,3.435),(18.515,3.435),(18.515,3.265),(18.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.265),(18.685,3.435),(18.855,3.435),(18.855,3.265),(18.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.605),(18.685,3.775),(18.855,3.775),(18.855,3.605),(18.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.605),(18.345,3.775),(18.515,3.775),(18.515,3.605),(18.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.925),(57.085,3.095),(57.255,3.095),(57.255,2.925),(57.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,2.925),(80.745,3.095),(80.915,3.095),(80.915,2.925),(80.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,19.245),(9.085,19.415),(9.255,19.415),(9.255,19.245),(9.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.925),(33.085,3.095),(33.255,3.095),(33.255,2.925),(33.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.225),(61.545,18.395),(61.715,18.395),(61.715,18.225),(61.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.565),(61.545,18.735),(61.715,18.735),(61.715,18.565),(61.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.265),(61.885,3.435),(62.055,3.435),(62.055,3.265),(61.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.605),(61.885,3.775),(62.055,3.775),(62.055,3.605),(61.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,9.045),(81.085,9.215),(81.255,9.215),(81.255,9.045),(81.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,15.845),(76.285,16.015),(76.455,16.015),(76.455,15.845),(76.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.285),(37.545,4.455),(37.715,4.455),(37.715,4.285),(37.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.625),(37.545,4.795),(37.715,4.795),(37.715,4.625),(37.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.845),(61.885,16.015),(62.055,16.015),(62.055,15.845),(61.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.405),(37.545,10.575),(37.715,10.575),(37.715,10.405),(37.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.065),(37.545,10.235),(37.715,10.235),(37.715,10.065),(37.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.745),(37.545,10.915),(37.715,10.915),(37.715,10.745),(37.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.265),(13.885,3.435),(14.055,3.435),(14.055,3.265),(13.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,3.605),(13.885,3.775),(14.055,3.775),(14.055,3.605),(13.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.365),(42.345,8.535),(42.515,8.535),(42.515,8.365),(42.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.365),(42.685,8.535),(42.855,8.535),(42.855,8.365),(42.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.705),(42.345,8.875),(42.515,8.875),(42.515,8.705),(42.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.705),(42.685,8.875),(42.855,8.875),(42.855,8.705),(42.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.025),(42.345,8.195),(42.515,8.195),(42.515,8.025),(42.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.025),(42.685,8.195),(42.855,8.195),(42.855,8.025),(42.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.845),(13.885,16.015),(14.055,16.015),(14.055,15.845),(13.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.065),(42.345,10.235),(42.515,10.235),(42.515,10.065),(42.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.065),(42.685,10.235),(42.855,10.235),(42.855,10.065),(42.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.405),(42.345,10.575),(42.515,10.575),(42.515,10.405),(42.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.405),(42.685,10.575),(42.855,10.575),(42.855,10.405),(42.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.745),(42.345,10.915),(42.515,10.915),(42.515,10.745),(42.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.745),(42.685,10.915),(42.855,10.915),(42.855,10.745),(42.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.825),(47.485,14.995),(47.655,14.995),(47.655,14.825),(47.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.485),(47.485,14.655),(47.655,14.655),(47.655,14.485),(47.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.485),(47.145,14.655),(47.315,14.655),(47.315,14.485),(47.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.825),(47.145,14.995),(47.315,14.995),(47.315,14.825),(47.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.145),(47.145,14.315),(47.315,14.315),(47.315,14.145),(47.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.145),(47.485,14.315),(47.655,14.315),(47.655,14.145),(47.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.405),(57.085,10.575),(57.255,10.575),(57.255,10.405),(57.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.065),(57.085,10.235),(57.255,10.235),(57.255,10.065),(57.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.745),(57.085,10.915),(57.255,10.915),(57.255,10.745),(57.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.945),(42.345,4.115),(42.515,4.115),(42.515,3.945),(42.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.945),(42.685,4.115),(42.855,4.115),(42.855,3.945),(42.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.285),(9.085,4.455),(9.255,4.455),(9.255,4.285),(9.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.625),(9.085,4.795),(9.255,4.795),(9.255,4.625),(9.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,9.045),(27.945,9.215),(28.115,9.215),(28.115,9.045),(27.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.385),(61.885,9.555),(62.055,9.555),(62.055,9.385),(61.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,9.725),(61.885,9.895),(62.055,9.895),(62.055,9.725),(61.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.385),(71.485,9.555),(71.655,9.555),(71.655,9.385),(71.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.725),(71.145,9.895),(71.315,9.895),(71.315,9.725),(71.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,9.725),(71.485,9.895),(71.655,9.895),(71.655,9.725),(71.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,9.385),(71.145,9.555),(71.315,9.555),(71.315,9.385),(71.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,7.685),(28.285,7.855),(28.455,7.855),(28.455,7.685),(28.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.725),(13.885,9.895),(14.055,9.895),(14.055,9.725),(13.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.525),(56.745,16.695),(56.915,16.695),(56.915,16.525),(56.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.185),(56.745,16.355),(56.915,16.355),(56.915,16.185),(56.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,9.385),(13.885,9.555),(14.055,9.555),(14.055,9.385),(13.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.165),(33.085,15.335),(33.255,15.335),(33.255,15.165),(33.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.505),(33.085,15.675),(33.255,15.675),(33.255,15.505),(33.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.165),(80.745,15.335),(80.915,15.335),(80.915,15.165),(80.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,15.505),(80.745,15.675),(80.915,15.675),(80.915,15.505),(80.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.065),(52.285,10.235),(52.455,10.235),(52.455,10.065),(52.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.405),(52.285,10.575),(52.455,10.575),(52.455,10.405),(52.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.745),(52.285,10.915),(52.455,10.915),(52.455,10.745),(52.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.285),(81.085,4.455),(81.255,4.455),(81.255,4.285),(81.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.625),(81.085,4.795),(81.255,4.795),(81.255,4.625),(81.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.185),(13.545,16.355),(13.715,16.355),(13.715,16.185),(13.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.525),(13.545,16.695),(13.715,16.695),(13.715,16.525),(13.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.805),(71.485,13.975),(71.655,13.975),(71.655,13.805),(71.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.465),(71.145,13.635),(71.315,13.635),(71.315,13.465),(71.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,13.465),(71.485,13.635),(71.655,13.635),(71.655,13.465),(71.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,13.805),(71.145,13.975),(71.315,13.975),(71.315,13.805),(71.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.445),(71.145,12.615),(71.315,12.615),(71.315,12.445),(71.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.445),(71.485,12.615),(71.655,12.615),(71.655,12.445),(71.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.785),(71.485,12.955),(71.655,12.955),(71.655,12.785),(71.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.785),(71.145,12.955),(71.315,12.955),(71.315,12.785),(71.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,12.105),(71.145,12.275),(71.315,12.275),(71.315,12.105),(71.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,12.105),(71.485,12.275),(71.655,12.275),(71.655,12.105),(71.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.185),(28.285,16.355),(28.455,16.355),(28.455,16.185),(28.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,3.945),(18.685,4.115),(18.855,4.115),(18.855,3.945),(18.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.525),(28.285,16.695),(28.455,16.695),(28.455,16.525),(28.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,3.945),(18.345,4.115),(18.515,4.115),(18.515,3.945),(18.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.405),(13.545,10.575),(13.715,10.575),(13.715,10.405),(13.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.745),(13.545,10.915),(13.715,10.915),(13.715,10.745),(13.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.465),(42.345,13.635),(42.515,13.635),(42.515,13.465),(42.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.465),(42.685,13.635),(42.855,13.635),(42.855,13.465),(42.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.805),(42.345,13.975),(42.515,13.975),(42.515,13.805),(42.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.805),(42.685,13.975),(42.855,13.975),(42.855,13.805),(42.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,12.105),(23.145,12.275),(23.315,12.275),(23.315,12.105),(23.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.105),(23.485,12.275),(23.655,12.275),(23.655,12.105),(23.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,10.065),(13.545,10.235),(13.715,10.235),(13.715,10.065),(13.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.125),(42.345,13.295),(42.515,13.295),(42.515,13.125),(42.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.125),(42.685,13.295),(42.855,13.295),(42.855,13.125),(42.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.945),(52.285,4.115),(52.455,4.115),(52.455,3.945),(52.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.165),(81.085,15.335),(81.255,15.335),(81.255,15.165),(81.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.985),(71.145,6.155),(71.315,6.155),(71.315,5.985),(71.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.985),(71.485,6.155),(71.655,6.155),(71.655,5.985),(71.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,15.505),(81.085,15.675),(81.255,15.675),(81.255,15.505),(81.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.945),(8.745,4.115),(8.915,4.115),(8.915,3.945),(8.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.545),(18.685,17.715),(18.855,17.715),(18.855,17.545),(18.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.205),(18.345,17.375),(18.515,17.375),(18.515,17.205),(18.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,17.205),(18.685,17.375),(18.855,17.375),(18.855,17.205),(18.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,17.545),(18.345,17.715),(18.515,17.715),(18.515,17.545),(18.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.225),(13.885,18.395),(14.055,18.395),(14.055,18.225),(13.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,18.565),(13.885,18.735),(14.055,18.735),(14.055,18.565),(13.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.285),(57.085,4.455),(57.255,4.455),(57.255,4.285),(57.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.625),(57.085,4.795),(57.255,4.795),(57.255,4.625),(57.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,2.925),(81.085,3.095),(81.255,3.095),(81.255,2.925),(81.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.285),(33.085,4.455),(33.255,4.455),(33.255,4.285),(33.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.625),(33.085,4.795),(33.255,4.795),(33.255,4.625),(33.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.305),(75.945,5.475),(76.115,5.475),(76.115,5.305),(75.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.645),(75.945,5.815),(76.115,5.815),(76.115,5.645),(75.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.165),(9.085,15.335),(9.255,15.335),(9.255,15.165),(9.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.325),(51.945,6.495),(52.115,6.495),(52.115,6.325),(51.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.665),(51.945,6.835),(52.115,6.835),(52.115,6.665),(51.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.885),(81.085,18.055),(81.255,18.055),(81.255,17.885),(81.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.905),(51.945,19.075),(52.115,19.075),(52.115,18.905),(51.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.745),(28.285,10.915),(28.455,10.915),(28.455,10.745),(28.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.065),(28.285,10.235),(28.455,10.235),(28.455,10.065),(28.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.885),(23.145,18.055),(23.315,18.055),(23.315,17.885),(23.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.885),(23.485,18.055),(23.655,18.055),(23.655,17.885),(23.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,10.405),(28.285,10.575),(28.455,10.575),(28.455,10.405),(28.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.905),(42.345,19.075),(42.515,19.075),(42.515,18.905),(42.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.905),(42.685,19.075),(42.855,19.075),(42.855,18.905),(42.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,2.925),(76.285,3.095),(76.455,3.095),(76.455,2.925),(76.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.005),(42.345,7.175),(42.515,7.175),(42.515,7.005),(42.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.005),(42.685,7.175),(42.855,7.175),(42.855,7.005),(42.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.805),(57.085,13.975),(57.255,13.975),(57.255,13.805),(57.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.465),(57.085,13.635),(57.255,13.635),(57.255,13.465),(57.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.125),(57.085,13.295),(57.255,13.295),(57.255,13.125),(57.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.345),(42.685,7.515),(42.855,7.515),(42.855,7.345),(42.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.065),(61.545,10.235),(61.715,10.235),(61.715,10.065),(61.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.405),(61.545,10.575),(61.715,10.575),(61.715,10.405),(61.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,10.745),(61.545,10.915),(61.715,10.915),(61.715,10.745),(61.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.345),(42.345,7.515),(42.515,7.515),(42.515,7.345),(42.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.205),(13.885,17.375),(14.055,17.375),(14.055,17.205),(13.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.545),(13.885,17.715),(14.055,17.715),(14.055,17.545),(13.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.225),(18.345,18.395),(18.515,18.395),(18.515,18.225),(18.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.225),(18.685,18.395),(18.855,18.395),(18.855,18.225),(18.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.565),(18.685,18.735),(18.855,18.735),(18.855,18.565),(18.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.565),(18.345,18.735),(18.515,18.735),(18.515,18.565),(18.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.125),(9.085,13.295),(9.255,13.295),(9.255,13.125),(9.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.465),(9.085,13.635),(9.255,13.635),(9.255,13.465),(9.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,13.805),(9.085,13.975),(9.255,13.975),(9.255,13.805),(9.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.945),(56.745,4.115),(56.915,4.115),(56.915,3.945),(56.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.865),(47.485,17.035),(47.655,17.035),(47.655,16.865),(47.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.865),(47.145,17.035),(47.315,17.035),(47.315,16.865),(47.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.945),(32.745,4.115),(32.915,4.115),(32.915,3.945),(32.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.885),(56.745,18.055),(56.915,18.055),(56.915,17.885),(56.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,7.685),(71.145,7.855),(71.315,7.855),(71.315,7.685),(71.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,7.685),(71.485,7.855),(71.655,7.855),(71.655,7.685),(71.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.345),(47.485,7.515),(47.655,7.515),(47.655,7.345),(47.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.345),(47.145,7.515),(47.315,7.515),(47.315,7.345),(47.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.005),(47.145,7.175),(47.315,7.175),(47.315,7.005),(47.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.005),(47.485,7.175),(47.655,7.175),(47.655,7.005),(47.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.685),(47.145,7.855),(47.315,7.855),(47.315,7.685),(47.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.365),(51.945,8.535),(52.115,8.535),(52.115,8.365),(51.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.705),(51.945,8.875),(52.115,8.875),(52.115,8.705),(51.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.025),(51.945,8.195),(52.115,8.195),(52.115,8.025),(51.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.965),(52.285,5.135),(52.455,5.135),(52.455,4.965),(52.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.685),(47.485,7.855),(47.655,7.855),(47.655,7.685),(47.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.685),(23.145,7.855),(23.315,7.855),(23.315,7.685),(23.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.685),(23.485,7.855),(23.655,7.855),(23.655,7.685),(23.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.005),(23.145,7.175),(23.315,7.175),(23.315,7.005),(23.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.005),(23.485,7.175),(23.655,7.175),(23.655,7.005),(23.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,7.345),(23.145,7.515),(23.315,7.515),(23.315,7.345),(23.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,7.345),(23.485,7.515),(23.655,7.515),(23.655,7.345),(23.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.165),(51.945,15.335),(52.115,15.335),(52.115,15.165),(51.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.505),(51.945,15.675),(52.115,15.675),(52.115,15.505),(51.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.225),(13.545,18.395),(13.715,18.395),(13.715,18.225),(13.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.565),(13.545,18.735),(13.715,18.735),(13.715,18.565),(13.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.225),(80.745,18.395),(80.915,18.395),(80.915,18.225),(80.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.565),(80.745,18.735),(80.915,18.735),(80.915,18.565),(80.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.365),(9.085,8.535),(9.255,8.535),(9.255,8.365),(9.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.705),(9.085,8.875),(9.255,8.875),(9.255,8.705),(9.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,8.025),(9.085,8.195),(9.255,8.195),(9.255,8.025),(9.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,9.045),(75.945,9.215),(76.115,9.215),(76.115,9.045),(75.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.005),(18.345,7.175),(18.515,7.175),(18.515,7.005),(18.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.005),(18.685,7.175),(18.855,7.175),(18.855,7.005),(18.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.345),(18.345,7.515),(18.515,7.515),(18.515,7.345),(18.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.345),(18.685,7.515),(18.855,7.515),(18.855,7.345),(18.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,7.685),(18.345,7.855),(18.515,7.855),(18.515,7.685),(18.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,7.685),(18.685,7.855),(18.855,7.855),(18.855,7.685),(18.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.685),(76.285,7.855),(76.455,7.855),(76.455,7.685),(76.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.345),(76.285,7.515),(76.455,7.515),(76.455,7.345),(76.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,7.005),(76.285,7.175),(76.455,7.175),(76.455,7.005),(76.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.985),(61.545,6.155),(61.715,6.155),(61.715,5.985),(61.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.425),(71.145,11.595),(71.315,11.595),(71.315,11.425),(71.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.425),(71.485,11.595),(71.655,11.595),(71.655,11.425),(71.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.765),(71.145,11.935),(71.315,11.935),(71.315,11.765),(71.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.765),(71.485,11.935),(71.655,11.935),(71.655,11.765),(71.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.005),(37.545,7.175),(37.715,7.175),(37.715,7.005),(37.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.345),(37.545,7.515),(37.715,7.515),(37.715,7.345),(37.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,11.085),(71.145,11.255),(71.315,11.255),(71.315,11.085),(71.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,11.085),(71.485,11.255),(71.655,11.255),(71.655,11.085),(71.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.205),(27.945,17.375),(28.115,17.375),(28.115,17.205),(27.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.545),(27.945,17.715),(28.115,17.715),(28.115,17.545),(27.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.265),(75.945,3.435),(76.115,3.435),(76.115,3.265),(75.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.605),(75.945,3.775),(76.115,3.775),(76.115,3.605),(75.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.985),(13.545,6.155),(13.715,6.155),(13.715,5.985),(13.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.425),(23.485,11.595),(23.655,11.595),(23.655,11.425),(23.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.425),(23.145,11.595),(23.315,11.595),(23.315,11.425),(23.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.765),(23.145,11.935),(23.315,11.935),(23.315,11.765),(23.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.765),(23.485,11.935),(23.655,11.935),(23.655,11.765),(23.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,11.085),(23.145,11.255),(23.315,11.255),(23.315,11.085),(23.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,11.085),(23.485,11.255),(23.655,11.255),(23.655,11.085),(23.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.205),(37.545,17.375),(37.715,17.375),(37.715,17.205),(37.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.545),(37.545,17.715),(37.715,17.715),(37.715,17.545),(37.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.045),(42.345,9.215),(42.515,9.215),(42.515,9.045),(42.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.045),(42.685,9.215),(42.855,9.215),(42.855,9.045),(42.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.185),(23.145,16.355),(23.315,16.355),(23.315,16.185),(23.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.185),(23.485,16.355),(23.655,16.355),(23.655,16.185),(23.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.525),(23.145,16.695),(23.315,16.695),(23.315,16.525),(23.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.525),(23.485,16.695),(23.655,16.695),(23.655,16.525),(23.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.345),(61.545,7.515),(61.715,7.515),(61.715,7.345),(61.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.685),(61.545,7.855),(61.715,7.855),(61.715,7.685),(61.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,7.005),(61.545,7.175),(61.715,7.175),(61.715,7.005),(61.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.765),(42.345,11.935),(42.515,11.935),(42.515,11.765),(42.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.765),(42.685,11.935),(42.855,11.935),(42.855,11.765),(42.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.425),(42.345,11.595),(42.515,11.595),(42.515,11.425),(42.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.425),(42.685,11.595),(42.855,11.595),(42.855,11.425),(42.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.865),(37.885,17.035),(38.055,17.035),(38.055,16.865),(37.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.085),(42.345,11.255),(42.515,11.255),(42.515,11.085),(42.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.085),(42.685,11.255),(42.855,11.255),(42.855,11.085),(42.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,7.685),(13.545,7.855),(13.715,7.855),(13.715,7.685),(13.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.285),(18.685,4.455),(18.855,4.455),(18.855,4.285),(18.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.625),(18.345,4.795),(18.515,4.795),(18.515,4.625),(18.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.285),(18.345,4.455),(18.515,4.455),(18.515,4.285),(18.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.625),(18.685,4.795),(18.855,4.795),(18.855,4.625),(18.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.985),(28.285,6.155),(28.455,6.155),(28.455,5.985),(28.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.505),(75.945,15.675),(76.115,15.675),(76.115,15.505),(75.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,19.245),(28.285,19.415),(28.455,19.415),(28.455,19.245),(28.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.165),(75.945,15.335),(76.115,15.335),(76.115,15.165),(75.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.325),(76.285,6.495),(76.455,6.495),(76.455,6.325),(76.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,6.665),(76.285,6.835),(76.455,6.835),(76.455,6.665),(76.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.165),(27.945,15.335),(28.115,15.335),(28.115,15.165),(27.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,16.865),(66.345,17.035),(66.515,17.035),(66.515,16.865),(66.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.505),(27.945,15.675),(28.115,15.675),(28.115,15.505),(27.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,16.865),(66.685,17.035),(66.855,17.035),(66.855,16.865),(66.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.945),(76.285,4.115),(76.455,4.115),(76.455,3.945),(76.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.365),(57.085,8.535),(57.255,8.535),(57.255,8.365),(57.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.705),(57.085,8.875),(57.255,8.875),(57.255,8.705),(57.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.025),(57.085,8.195),(57.255,8.195),(57.255,8.025),(57.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,12.445),(23.485,12.615),(23.655,12.615),(23.655,12.445),(23.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.285),(42.345,4.455),(42.515,4.455),(42.515,4.285),(42.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.285),(42.685,4.455),(42.855,4.455),(42.855,4.285),(42.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.625),(42.345,4.795),(42.515,4.795),(42.515,4.625),(42.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.625),(42.685,4.795),(42.855,4.795),(42.855,4.625),(42.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.945),(80.745,4.115),(80.915,4.115),(80.915,3.945),(80.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.205),(33.085,17.375),(33.255,17.375),(33.255,17.205),(33.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.545),(33.085,17.715),(33.255,17.715),(33.255,17.545),(33.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.225),(71.145,18.395),(71.315,18.395),(71.315,18.225),(71.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.225),(71.485,18.395),(71.655,18.395),(71.655,18.225),(71.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.565),(71.145,18.735),(71.315,18.735),(71.315,18.565),(71.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.565),(71.485,18.735),(71.655,18.735),(71.655,18.565),(71.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.265),(51.945,3.435),(52.115,3.435),(52.115,3.265),(51.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.605),(51.945,3.775),(52.115,3.775),(52.115,3.605),(51.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.465),(51.945,13.635),(52.115,13.635),(52.115,13.465),(51.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.805),(51.945,13.975),(52.115,13.975),(52.115,13.805),(51.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.125),(51.945,13.295),(52.115,13.295),(52.115,13.125),(51.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.065),(76.285,10.235),(76.455,10.235),(76.455,10.065),(76.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.405),(76.285,10.575),(76.455,10.575),(76.455,10.405),(76.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,10.745),(76.285,10.915),(76.455,10.915),(76.455,10.745),(76.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.165),(37.885,15.335),(38.055,15.335),(38.055,15.165),(37.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.505),(37.885,15.675),(38.055,15.675),(38.055,15.505),(37.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.425),(8.745,11.595),(8.915,11.595),(8.915,11.425),(8.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.085),(8.745,11.255),(8.915,11.255),(8.915,11.085),(8.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.485),(33.085,14.655),(33.255,14.655),(33.255,14.485),(33.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.825),(33.085,14.995),(33.255,14.995),(33.255,14.825),(33.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.145),(33.085,14.315),(33.255,14.315),(33.255,14.145),(33.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,11.765),(8.745,11.935),(8.915,11.935),(8.915,11.765),(8.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.225),(81.085,18.395),(81.255,18.395),(81.255,18.225),(81.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.565),(81.085,18.735),(81.255,18.735),(81.255,18.565),(81.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,19.245),(66.345,19.415),(66.515,19.415),(66.515,19.245),(66.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,19.245),(66.685,19.415),(66.855,19.415),(66.855,19.245),(66.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.245),(56.745,19.415),(56.915,19.415),(56.915,19.245),(56.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.005),(66.345,7.175),(66.515,7.175),(66.515,7.005),(66.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.005),(66.685,7.175),(66.855,7.175),(66.855,7.005),(66.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.345),(66.345,7.515),(66.515,7.515),(66.515,7.345),(66.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.345),(66.685,7.515),(66.855,7.515),(66.855,7.345),(66.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,7.685),(66.345,7.855),(66.515,7.855),(66.515,7.685),(66.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,7.685),(66.685,7.855),(66.855,7.855),(66.855,7.685),(66.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.865),(75.945,17.035),(76.115,17.035),(76.115,16.865),(75.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.185),(8.745,16.355),(8.915,16.355),(8.915,16.185),(8.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.525),(8.745,16.695),(8.915,16.695),(8.915,16.525),(8.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.105),(9.085,12.275),(9.255,12.275),(9.255,12.105),(9.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.445),(9.085,12.615),(9.255,12.615),(9.255,12.445),(9.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,12.785),(9.085,12.955),(9.255,12.955),(9.255,12.785),(9.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.185),(76.285,16.355),(76.455,16.355),(76.455,16.185),(76.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.525),(76.285,16.695),(76.455,16.695),(76.455,16.525),(76.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.365),(27.945,8.535),(28.115,8.535),(28.115,8.365),(27.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.705),(27.945,8.875),(28.115,8.875),(28.115,8.705),(27.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,8.025),(27.945,8.195),(28.115,8.195),(28.115,8.025),(27.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.245),(47.145,19.415),(47.315,19.415),(47.315,19.245),(47.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.245),(47.485,19.415),(47.655,19.415),(47.655,19.245),(47.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.925),(37.545,3.095),(37.715,3.095),(37.715,2.925),(37.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.305),(37.885,5.475),(38.055,5.475),(38.055,5.305),(37.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.645),(37.885,5.815),(38.055,5.815),(38.055,5.645),(37.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.385),(66.685,9.555),(66.855,9.555),(66.855,9.385),(66.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,9.725),(66.685,9.895),(66.855,9.895),(66.855,9.725),(66.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.385),(66.345,9.555),(66.515,9.555),(66.515,9.385),(66.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,9.725),(66.345,9.895),(66.515,9.895),(66.515,9.725),(66.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.885),(8.745,18.055),(8.915,18.055),(8.915,17.885),(8.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.625),(66.685,4.795),(66.855,4.795),(66.855,4.625),(66.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.285),(66.685,4.455),(66.855,4.455),(66.855,4.285),(66.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.625),(66.345,4.795),(66.515,4.795),(66.515,4.625),(66.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.285),(66.345,4.455),(66.515,4.455),(66.515,4.285),(66.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.465),(27.945,13.635),(28.115,13.635),(28.115,13.465),(27.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.805),(27.945,13.975),(28.115,13.975),(28.115,13.805),(27.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,13.125),(27.945,13.295),(28.115,13.295),(28.115,13.125),(27.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,16.865),(80.745,17.035),(80.915,17.035),(80.915,16.865),(80.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.425),(56.745,11.595),(56.915,11.595),(56.915,11.425),(56.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.085),(56.745,11.255),(56.915,11.255),(56.915,11.085),(56.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.765),(56.745,11.935),(56.915,11.935),(56.915,11.765),(56.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.565),(76.285,18.735),(76.455,18.735),(76.455,18.565),(76.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,18.225),(76.285,18.395),(76.455,18.395),(76.455,18.225),(76.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.285),(37.885,4.455),(38.055,4.455),(38.055,4.285),(37.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.625),(37.885,4.795),(38.055,4.795),(38.055,4.625),(37.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.125),(37.545,13.295),(37.715,13.295),(37.715,13.125),(37.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.465),(37.545,13.635),(37.715,13.635),(37.715,13.465),(37.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.805),(37.545,13.975),(37.715,13.975),(37.715,13.805),(37.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.485),(51.945,14.655),(52.115,14.655),(52.115,14.485),(51.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.825),(51.945,14.995),(52.115,14.995),(52.115,14.825),(51.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.145),(51.945,14.315),(52.115,14.315),(52.115,14.145),(51.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.025),(71.145,8.195),(71.315,8.195),(71.315,8.025),(71.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.025),(71.485,8.195),(71.655,8.195),(71.655,8.025),(71.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.705),(71.485,8.875),(71.655,8.875),(71.655,8.705),(71.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.365),(71.145,8.535),(71.315,8.535),(71.315,8.365),(71.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,8.365),(71.485,8.535),(71.655,8.535),(71.655,8.365),(71.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,8.705),(71.145,8.875),(71.315,8.875),(71.315,8.705),(71.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.745),(23.145,10.915),(23.315,10.915),(23.315,10.745),(23.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.745),(23.485,10.915),(23.655,10.915),(23.655,10.745),(23.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.405),(23.145,10.575),(23.315,10.575),(23.315,10.405),(23.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.405),(23.485,10.575),(23.655,10.575),(23.655,10.405),(23.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,10.065),(23.145,10.235),(23.315,10.235),(23.315,10.065),(23.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,10.065),(23.485,10.235),(23.655,10.235),(23.655,10.065),(23.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.385),(8.745,9.555),(8.915,9.555),(8.915,9.385),(8.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,9.725),(8.745,9.895),(8.915,9.895),(8.915,9.725),(8.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.785),(57.085,12.955),(57.255,12.955),(57.255,12.785),(57.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.105),(57.085,12.275),(57.255,12.275),(57.255,12.105),(57.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.445),(57.085,12.615),(57.255,12.615),(57.255,12.445),(57.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.385),(18.345,9.555),(18.515,9.555),(18.515,9.385),(18.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.385),(18.685,9.555),(18.855,9.555),(18.855,9.385),(18.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,9.725),(18.345,9.895),(18.515,9.895),(18.515,9.725),(18.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,9.725),(18.685,9.895),(18.855,9.895),(18.855,9.725),(18.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.365),(23.145,8.535),(23.315,8.535),(23.315,8.365),(23.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.365),(23.485,8.535),(23.655,8.535),(23.655,8.365),(23.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.705),(23.145,8.875),(23.315,8.875),(23.315,8.705),(23.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.705),(23.485,8.875),(23.655,8.875),(23.655,8.705),(23.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,8.025),(23.145,8.195),(23.315,8.195),(23.315,8.025),(23.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,8.025),(23.485,8.195),(23.655,8.195),(23.655,8.025),(23.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,16.865),(18.685,17.035),(18.855,17.035),(18.855,16.865),(18.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,16.865),(18.345,17.035),(18.515,17.035),(18.515,16.865),(18.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,17.885),(61.545,18.055),(61.715,18.055),(61.715,17.885),(61.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.485),(81.085,14.655),(81.255,14.655),(81.255,14.485),(81.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.825),(81.085,14.995),(81.255,14.995),(81.255,14.825),(81.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,14.145),(81.085,14.315),(81.255,14.315),(81.255,14.145),(81.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.885),(52.285,18.055),(52.455,18.055),(52.455,17.885),(52.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.205),(56.745,17.375),(56.915,17.375),(56.915,17.205),(56.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.545),(56.745,17.715),(56.915,17.715),(56.915,17.545),(56.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,19.245),(61.545,19.415),(61.715,19.415),(61.715,19.245),(61.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.845),(51.945,16.015),(52.115,16.015),(52.115,15.845),(51.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.165),(61.885,15.335),(62.055,15.335),(62.055,15.165),(61.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,15.505),(61.885,15.675),(62.055,15.675),(62.055,15.505),(61.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.165),(13.885,15.335),(14.055,15.335),(14.055,15.165),(13.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,15.505),(13.885,15.675),(14.055,15.675),(14.055,15.505),(13.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.025),(56.745,8.195),(56.915,8.195),(56.915,8.025),(56.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.705),(56.745,8.875),(56.915,8.875),(56.915,8.705),(56.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.365),(56.745,8.535),(56.915,8.535),(56.915,8.365),(56.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,19.245),(18.345,19.415),(18.515,19.415),(18.515,19.245),(18.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,19.245),(18.685,19.415),(18.855,19.415),(18.855,19.245),(18.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,18.905),(66.685,19.075),(66.855,19.075),(66.855,18.905),(66.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,18.905),(66.345,19.075),(66.515,19.075),(66.515,18.905),(66.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.025),(8.745,8.195),(8.915,8.195),(8.915,8.025),(8.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.365),(8.745,8.535),(8.915,8.535),(8.915,8.365),(8.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,8.705),(8.745,8.875),(8.915,8.875),(8.915,8.705),(8.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.665),(37.545,6.835),(37.715,6.835),(37.715,6.665),(37.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.325),(37.545,6.495),(37.715,6.495),(37.715,6.325),(37.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.085),(37.545,11.255),(37.715,11.255),(37.715,11.085),(37.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.765),(37.545,11.935),(37.715,11.935),(37.715,11.765),(37.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.425),(37.545,11.595),(37.715,11.595),(37.715,11.425),(37.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.725),(56.745,9.895),(56.915,9.895),(56.915,9.725),(56.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.385),(56.745,9.555),(56.915,9.555),(56.915,9.385),(56.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,18.905),(23.485,19.075),(23.655,19.075),(23.655,18.905),(23.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,18.905),(23.145,19.075),(23.315,19.075),(23.315,18.905),(23.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,3.945),(75.945,4.115),(76.115,4.115),(76.115,3.945),(75.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.185),(71.145,16.355),(71.315,16.355),(71.315,16.185),(71.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.185),(71.485,16.355),(71.655,16.355),(71.655,16.185),(71.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,16.525),(71.145,16.695),(71.315,16.695),(71.315,16.525),(71.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,16.525),(71.485,16.695),(71.655,16.695),(71.655,16.525),(71.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.505),(37.545,15.675),(37.715,15.675),(37.715,15.505),(37.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.165),(37.545,15.335),(37.715,15.335),(37.715,15.165),(37.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.365),(75.945,8.535),(76.115,8.535),(76.115,8.365),(75.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.705),(75.945,8.875),(76.115,8.875),(76.115,8.705),(75.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,8.025),(75.945,8.195),(76.115,8.195),(76.115,8.025),(75.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,7.685),(8.745,7.855),(8.915,7.855),(8.915,7.685),(8.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,16.865),(61.545,17.035),(61.715,17.035),(61.715,16.865),(61.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.325),(9.085,6.495),(9.255,6.495),(9.255,6.325),(9.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,6.665),(9.085,6.835),(9.255,6.835),(9.255,6.665),(9.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,19.245),(8.745,19.415),(8.915,19.415),(8.915,19.245),(8.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,17.885),(61.885,18.055),(62.055,18.055),(62.055,17.885),(61.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,5.985),(81.085,6.155),(81.255,6.155),(81.255,5.985),(81.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,15.845),(75.945,16.015),(76.115,16.015),(76.115,15.845),(75.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.905),(32.745,19.075),(32.915,19.075),(32.915,18.905),(32.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.305),(28.285,5.475),(28.455,5.475),(28.455,5.305),(28.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,5.645),(28.285,5.815),(28.455,5.815),(28.455,5.645),(28.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,15.845),(27.945,16.015),(28.115,16.015),(28.115,15.845),(27.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.185),(27.945,16.355),(28.115,16.355),(28.115,16.185),(27.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,16.525),(27.945,16.695),(28.115,16.695),(28.115,16.525),(27.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.465),(75.945,13.635),(76.115,13.635),(76.115,13.465),(75.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.805),(75.945,13.975),(76.115,13.975),(76.115,13.805),(75.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,13.125),(75.945,13.295),(76.115,13.295),(76.115,13.125),(75.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.185),(33.085,16.355),(33.255,16.355),(33.255,16.185),(33.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.525),(33.085,16.695),(33.255,16.695),(33.255,16.525),(33.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.265),(57.085,3.435),(57.255,3.435),(57.255,3.265),(57.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.605),(57.085,3.775),(57.255,3.775),(57.255,3.605),(57.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.245),(51.945,19.415),(52.115,19.415),(52.115,19.245),(51.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.325),(56.745,6.495),(56.915,6.495),(56.915,6.325),(56.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.665),(56.745,6.835),(56.915,6.835),(56.915,6.665),(56.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.465),(61.545,13.635),(61.715,13.635),(61.715,13.465),(61.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.805),(61.545,13.975),(61.715,13.975),(61.715,13.805),(61.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,13.125),(61.545,13.295),(61.715,13.295),(61.715,13.125),(61.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.265),(33.085,3.435),(33.255,3.435),(33.255,3.265),(33.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.605),(33.085,3.775),(33.255,3.775),(33.255,3.605),(33.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.325),(32.745,6.495),(32.915,6.495),(32.915,6.325),(32.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.665),(32.745,6.835),(32.915,6.835),(32.915,6.665),(32.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.485),(75.945,14.655),(76.115,14.655),(76.115,14.485),(75.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.825),(75.945,14.995),(76.115,14.995),(76.115,14.825),(75.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,14.145),(75.945,14.315),(76.115,14.315),(76.115,14.145),(75.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.265),(9.085,3.435),(9.255,3.435),(9.255,3.265),(9.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,3.605),(9.085,3.775),(9.255,3.775),(9.255,3.605),(9.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.905),(33.085,19.075),(33.255,19.075),(33.255,18.905),(33.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.465),(13.545,13.635),(13.715,13.635),(13.715,13.465),(13.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.805),(13.545,13.975),(13.715,13.975),(13.715,13.805),(13.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,13.125),(13.545,13.295),(13.715,13.295),(13.715,13.125),(13.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.345),(75.945,7.515),(76.115,7.515),(76.115,7.345),(75.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.685),(75.945,7.855),(76.115,7.855),(76.115,7.685),(75.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,7.005),(75.945,7.175),(76.115,7.175),(76.115,7.005),(75.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.845),(42.345,16.015),(42.515,16.015),(42.515,15.845),(42.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.845),(42.685,16.015),(42.855,16.015),(42.855,15.845),(42.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.945),(51.945,4.115),(52.115,4.115),(52.115,3.945),(51.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.145),(27.945,14.315),(28.115,14.315),(28.115,14.145),(27.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.485),(27.945,14.655),(28.115,14.655),(28.115,14.485),(27.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,14.825),(27.945,14.995),(28.115,14.995),(28.115,14.825),(27.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.285),(76.285,4.455),(76.455,4.455),(76.455,4.285),(76.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,4.625),(76.285,4.795),(76.455,4.795),(76.455,4.625),(76.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.345),(27.945,7.515),(28.115,7.515),(28.115,7.345),(27.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.685),(27.945,7.855),(28.115,7.855),(28.115,7.685),(27.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,17.885),(71.485,18.055),(71.655,18.055),(71.655,17.885),(71.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,17.885),(71.145,18.055),(71.315,18.055),(71.315,17.885),(71.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,7.005),(27.945,7.175),(28.115,7.175),(28.115,7.005),(27.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.065),(71.145,10.235),(71.315,10.235),(71.315,10.065),(71.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.065),(71.485,10.235),(71.655,10.235),(71.655,10.065),(71.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.745),(71.145,10.915),(71.315,10.915),(71.315,10.745),(71.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.745),(71.485,10.915),(71.655,10.915),(71.655,10.745),(71.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,10.405),(71.485,10.575),(71.655,10.575),(71.655,10.405),(71.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,10.405),(71.145,10.575),(71.315,10.575),(71.315,10.405),(71.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.285),(28.285,4.455),(28.455,4.455),(28.455,4.285),(28.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,4.625),(28.285,4.795),(28.455,4.795),(28.455,4.625),(28.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,9.045),(80.745,9.215),(80.915,9.215),(80.915,9.045),(80.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.005),(56.745,7.175),(56.915,7.175),(56.915,7.005),(56.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.685),(56.745,7.855),(56.915,7.855),(56.915,7.685),(56.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.345),(56.745,7.515),(56.915,7.515),(56.915,7.345),(56.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.325),(57.085,6.495),(57.255,6.495),(57.255,6.325),(57.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.665),(57.085,6.835),(57.255,6.835),(57.255,6.665),(57.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.005),(32.745,7.175),(32.915,7.175),(32.915,7.005),(32.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.345),(32.745,7.515),(32.915,7.515),(32.915,7.345),(32.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.685),(32.745,7.855),(32.915,7.855),(32.915,7.685),(32.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,18.905),(28.285,19.075),(28.455,19.075),(28.455,18.905),(28.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.325),(80.745,6.495),(80.915,6.495),(80.915,6.325),(80.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,6.665),(80.745,6.835),(80.915,6.835),(80.915,6.665),(80.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.325),(33.085,6.495),(33.255,6.495),(33.255,6.325),(33.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.665),(33.085,6.835),(33.255,6.835),(33.255,6.665),(33.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.985),(66.345,6.155),(66.515,6.155),(66.515,5.985),(66.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.985),(66.685,6.155),(66.855,6.155),(66.855,5.985),(66.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.285),(51.945,4.455),(52.115,4.455),(52.115,4.285),(51.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.625),(51.945,4.795),(52.115,4.795),(52.115,4.625),(51.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.985),(42.345,6.155),(42.515,6.155),(42.515,5.985),(42.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.985),(42.685,6.155),(42.855,6.155),(42.855,5.985),(42.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.445),(56.745,12.615),(56.915,12.615),(56.915,12.445),(56.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.105),(56.745,12.275),(56.915,12.275),(56.915,12.105),(56.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.785),(56.745,12.955),(56.915,12.955),(56.915,12.785),(56.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.445),(8.745,12.615),(8.915,12.615),(8.915,12.445),(8.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.785),(8.745,12.955),(8.915,12.955),(8.915,12.785),(8.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,12.105),(8.745,12.275),(8.915,12.275),(8.915,12.105),(8.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.905),(37.885,19.075),(38.055,19.075),(38.055,18.905),(37.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.045),(32.745,9.215),(32.915,9.215),(32.915,9.045),(32.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.425),(61.545,11.595),(61.715,11.595),(61.715,11.425),(61.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.085),(61.545,11.255),(61.715,11.255),(61.715,11.085),(61.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,11.765),(61.545,11.935),(61.715,11.935),(61.715,11.765),(61.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,18.905),(61.545,19.075),(61.715,19.075),(61.715,18.905),(61.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.205),(8.745,17.375),(8.915,17.375),(8.915,17.205),(8.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,17.545),(8.745,17.715),(8.915,17.715),(8.915,17.545),(8.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.965),(37.545,5.135),(37.715,5.135),(37.715,4.965),(37.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.765),(13.545,11.935),(13.715,11.935),(13.715,11.765),(13.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.425),(13.545,11.595),(13.715,11.595),(13.715,11.425),(13.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,11.085),(13.545,11.255),(13.715,11.255),(13.715,11.085),(13.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.125),(37.885,13.295),(38.055,13.295),(38.055,13.125),(37.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.465),(37.885,13.635),(38.055,13.635),(38.055,13.465),(37.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.805),(37.885,13.975),(38.055,13.975),(38.055,13.805),(37.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.365),(37.885,8.535),(38.055,8.535),(38.055,8.365),(37.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.705),(37.885,8.875),(38.055,8.875),(38.055,8.705),(37.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.025),(37.885,8.195),(38.055,8.195),(38.055,8.025),(37.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.445),(37.545,12.615),(37.715,12.615),(37.715,12.445),(37.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.785),(37.545,12.955),(37.715,12.955),(37.715,12.785),(37.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.105),(37.545,12.275),(37.715,12.275),(37.715,12.105),(37.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.505),(61.545,15.675),(61.715,15.675),(61.715,15.505),(61.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,15.165),(61.545,15.335),(61.715,15.335),(61.715,15.165),(61.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.405),(37.885,10.575),(38.055,10.575),(38.055,10.405),(37.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.745),(37.885,10.915),(38.055,10.915),(38.055,10.745),(37.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.065),(37.885,10.235),(38.055,10.235),(38.055,10.065),(37.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.205),(75.945,17.375),(76.115,17.375),(76.115,17.205),(75.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,17.545),(75.945,17.715),(76.115,17.715),(76.115,17.545),(75.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.505),(13.545,15.675),(13.715,15.675),(13.715,15.505),(13.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,15.165),(13.545,15.335),(13.715,15.335),(13.715,15.165),(13.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.225),(56.745,18.395),(56.915,18.395),(56.915,18.225),(56.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.565),(56.745,18.735),(56.915,18.735),(56.915,18.565),(56.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,4.965),(9.085,5.135),(9.255,5.135),(9.255,4.965),(9.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,3.945),(81.085,4.115),(81.255,4.115),(81.255,3.945),(81.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.865),(56.745,17.035),(56.915,17.035),(56.915,16.865),(56.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,19.245),(76.285,19.415),(76.455,19.415),(76.455,19.245),(76.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,4.965),(81.085,5.135),(81.255,5.135),(81.255,4.965),(81.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.225),(57.085,18.395),(57.255,18.395),(57.255,18.225),(57.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.565),(57.085,18.735),(57.255,18.735),(57.255,18.565),(57.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,16.865),(13.545,17.035),(13.715,17.035),(13.715,16.865),(13.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,7.685),(80.745,7.855),(80.915,7.855),(80.915,7.685),(80.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,17.885),(13.545,18.055),(13.715,18.055),(13.715,17.885),(13.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.205),(52.285,17.375),(52.455,17.375),(52.455,17.205),(52.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.545),(52.285,17.715),(52.455,17.715),(52.455,17.545),(52.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.985),(8.745,6.155),(8.915,6.155),(8.915,5.985),(8.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.325),(13.885,6.495),(14.055,6.495),(14.055,6.325),(13.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,6.665),(13.885,6.835),(14.055,6.835),(14.055,6.665),(13.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.745),(56.745,10.915),(56.915,10.915),(56.915,10.745),(56.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.065),(56.745,10.235),(56.915,10.235),(56.915,10.065),(56.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.405),(56.745,10.575),(56.915,10.575),(56.915,10.405),(56.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,16.865),(28.285,17.035),(28.455,17.035),(28.455,16.865),(28.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.845),(71.145,16.015),(71.315,16.015),(71.315,15.845),(71.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.845),(71.485,16.015),(71.655,16.015),(71.655,15.845),(71.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.265),(52.285,3.435),(52.455,3.435),(52.455,3.265),(52.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.605),(52.285,3.775),(52.455,3.775),(52.455,3.605),(52.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.745),(8.745,10.915),(8.915,10.915),(8.915,10.745),(8.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.065),(8.745,10.235),(8.915,10.235),(8.915,10.065),(8.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,10.405),(8.745,10.575),(8.915,10.575),(8.915,10.405),(8.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.845),(23.485,16.015),(23.655,16.015),(23.655,15.845),(23.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.845),(23.145,16.015),(23.315,16.015),(23.315,15.845),(23.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.045),(37.545,9.215),(37.715,9.215),(37.715,9.045),(37.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.305),(71.145,5.475),(71.315,5.475),(71.315,5.305),(71.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.305),(71.485,5.475),(71.655,5.475),(71.655,5.305),(71.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,5.645),(71.145,5.815),(71.315,5.815),(71.315,5.645),(71.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.625),(71.145,4.795),(71.315,4.795),(71.315,4.625),(71.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,5.645),(71.485,5.815),(71.655,5.815),(71.655,5.645),(71.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,4.285),(71.145,4.455),(71.315,4.455),(71.315,4.285),(71.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.625),(71.485,4.795),(71.655,4.795),(71.655,4.625),(71.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,4.285),(71.485,4.455),(71.655,4.455),(71.655,4.285),(71.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.265),(8.745,3.435),(8.915,3.435),(8.915,3.265),(8.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,3.605),(8.745,3.775),(8.915,3.775),(8.915,3.605),(8.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.365),(13.885,8.535),(14.055,8.535),(14.055,8.365),(13.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.705),(13.885,8.875),(14.055,8.875),(14.055,8.705),(13.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,8.025),(13.885,8.195),(14.055,8.195),(14.055,8.025),(13.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,19.245),(13.545,19.415),(13.715,19.415),(13.715,19.245),(13.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.465),(80.745,13.635),(80.915,13.635),(80.915,13.465),(80.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.805),(80.745,13.975),(80.915,13.975),(80.915,13.805),(80.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.105),(13.545,12.275),(13.715,12.275),(13.715,12.105),(13.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.845),(57.085,16.015),(57.255,16.015),(57.255,15.845),(57.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.445),(13.545,12.615),(13.715,12.615),(13.715,12.445),(13.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,12.785),(13.545,12.955),(13.715,12.955),(13.715,12.785),(13.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,13.125),(80.745,13.295),(80.915,13.295),(80.915,13.125),(80.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.285),(23.485,4.455),(23.655,4.455),(23.655,4.285),(23.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.625),(23.145,4.795),(23.315,4.795),(23.315,4.625),(23.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,4.625),(23.485,4.795),(23.655,4.795),(23.655,4.625),(23.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,4.285),(23.145,4.455),(23.315,4.455),(23.315,4.285),(23.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.065),(13.885,10.235),(14.055,10.235),(14.055,10.065),(13.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.405),(13.885,10.575),(14.055,10.575),(14.055,10.405),(13.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,10.745),(13.885,10.915),(14.055,10.915),(14.055,10.745),(13.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.985),(47.485,6.155),(47.655,6.155),(47.655,5.985),(47.485,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.845),(9.085,16.015),(9.255,16.015),(9.255,15.845),(9.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.045),(57.085,9.215),(57.255,9.215),(57.255,9.045),(57.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.965),(57.085,5.135),(57.255,5.135),(57.255,4.965),(57.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.965),(33.085,5.135),(33.255,5.135),(33.255,4.965),(33.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,5.985),(75.945,6.155),(76.115,6.155),(76.115,5.985),(75.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,7.685),(61.885,7.855),(62.055,7.855),(62.055,7.685),(61.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,9.045),(9.085,9.215),(9.255,9.215),(9.255,9.045),(9.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.045),(52.285,9.215),(52.455,9.215),(52.455,9.045),(52.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.185),(81.085,16.355),(81.255,16.355),(81.255,16.185),(81.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.825),(37.545,14.995),(37.715,14.995),(37.715,14.825),(37.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.145),(37.545,14.315),(37.715,14.315),(37.715,14.145),(37.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,16.525),(81.085,16.695),(81.255,16.695),(81.255,16.525),(81.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.485),(37.545,14.655),(37.715,14.655),(37.715,14.485),(37.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.005),(13.885,7.175),(14.055,7.175),(14.055,7.005),(13.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.685),(13.885,7.855),(14.055,7.855),(14.055,7.685),(13.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,7.345),(13.885,7.515),(14.055,7.515),(14.055,7.345),(13.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.205),(81.085,17.375),(81.255,17.375),(81.255,17.205),(81.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,17.545),(81.085,17.715),(81.255,17.715),(81.255,17.545),(81.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.665),(37.885,6.835),(38.055,6.835),(38.055,6.665),(37.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,2.925),(13.885,3.095),(14.055,3.095),(14.055,2.925),(13.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.325),(37.885,6.495),(38.055,6.495),(38.055,6.325),(37.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.565),(51.945,18.735),(52.115,18.735),(52.115,18.565),(51.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.225),(51.945,18.395),(52.115,18.395),(52.115,18.225),(51.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.205),(23.145,17.375),(23.315,17.375),(23.315,17.205),(23.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.205),(23.485,17.375),(23.655,17.375),(23.655,17.205),(23.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,17.545),(23.145,17.715),(23.315,17.715),(23.315,17.545),(23.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,17.545),(23.485,17.715),(23.655,17.715),(23.655,17.545),(23.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.125),(32.745,13.295),(32.915,13.295),(32.915,13.125),(32.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.465),(32.745,13.635),(32.915,13.635),(32.915,13.465),(32.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.805),(32.745,13.975),(32.915,13.975),(32.915,13.805),(32.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,4.965),(13.885,5.135),(14.055,5.135),(14.055,4.965),(13.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.465),(61.885,13.635),(62.055,13.635),(62.055,13.465),(61.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.805),(61.885,13.975),(62.055,13.975),(62.055,13.805),(61.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,13.125),(61.885,13.295),(62.055,13.295),(62.055,13.125),(61.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,17.885),(13.885,18.055),(14.055,18.055),(14.055,17.885),(13.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,18.905),(18.345,19.075),(18.515,19.075),(18.515,18.905),(18.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,18.905),(18.685,19.075),(18.855,19.075),(18.855,18.905),(18.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.265),(56.745,3.435),(56.915,3.435),(56.915,3.265),(56.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.605),(56.745,3.775),(56.915,3.775),(56.915,3.605),(56.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.125),(13.885,13.295),(14.055,13.295),(14.055,13.125),(13.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.465),(13.885,13.635),(14.055,13.635),(14.055,13.465),(13.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((13.885,13.805),(13.885,13.975),(14.055,13.975),(14.055,13.805),(13.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.025),(61.885,8.195),(62.055,8.195),(62.055,8.025),(61.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.365),(61.885,8.535),(62.055,8.535),(62.055,8.365),(61.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,8.705),(61.885,8.875),(62.055,8.875),(62.055,8.705),(61.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.265),(32.745,3.435),(32.915,3.435),(32.915,3.265),(32.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.605),(32.745,3.775),(32.915,3.775),(32.915,3.605),(32.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.445),(61.545,12.615),(61.715,12.615),(61.715,12.445),(61.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.785),(61.545,12.955),(61.715,12.955),(61.715,12.785),(61.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,12.105),(61.545,12.275),(61.715,12.275),(61.715,12.105),(61.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.165),(8.745,15.335),(8.915,15.335),(8.915,15.165),(8.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,15.505),(8.745,15.675),(8.915,15.675),(8.915,15.505),(8.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.065),(61.885,10.235),(62.055,10.235),(62.055,10.065),(61.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.405),(61.885,10.575),(62.055,10.575),(62.055,10.405),(61.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,10.745),(61.885,10.915),(62.055,10.915),(62.055,10.745),(61.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.825),(52.285,14.995),(52.455,14.995),(52.455,14.825),(52.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.145),(52.285,14.315),(52.455,14.315),(52.455,14.145),(52.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.485),(52.285,14.655),(52.455,14.655),(52.455,14.485),(52.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.625),(47.485,4.795),(47.655,4.795),(47.655,4.625),(47.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.625),(47.145,4.795),(47.315,4.795),(47.315,4.625),(47.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.285),(47.145,4.455),(47.315,4.455),(47.315,4.285),(47.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.285),(47.485,4.455),(47.655,4.455),(47.655,4.285),(47.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,18.905),(13.545,19.075),(13.715,19.075),(13.715,18.905),(13.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,18.905),(80.745,19.075),(80.915,19.075),(80.915,18.905),(80.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.885),(47.145,18.055),(47.315,18.055),(47.315,17.885),(47.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.885),(47.485,18.055),(47.655,18.055),(47.655,17.885),(47.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.485),(13.545,14.655),(13.715,14.655),(13.715,14.485),(13.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.825),(13.545,14.995),(13.715,14.995),(13.715,14.825),(13.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,14.145),(13.545,14.315),(13.715,14.315),(13.715,14.145),(13.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.725),(47.145,9.895),(47.315,9.895),(47.315,9.725),(47.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.725),(47.485,9.895),(47.655,9.895),(47.655,9.725),(47.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.385),(47.145,9.555),(47.315,9.555),(47.315,9.385),(47.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.385),(47.485,9.555),(47.655,9.555),(47.655,9.385),(47.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,2.925),(61.885,3.095),(62.055,3.095),(62.055,2.925),(61.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.305),(61.545,5.475),(61.715,5.475),(61.715,5.305),(61.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,5.645),(61.545,5.815),(61.715,5.815),(61.715,5.645),(61.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.805),(47.145,13.975),(47.315,13.975),(47.315,13.805),(47.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((27.945,17.885),(27.945,18.055),(28.115,18.055),(28.115,17.885),(27.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.805),(47.485,13.975),(47.655,13.975),(47.655,13.805),(47.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.465),(47.145,13.635),(47.315,13.635),(47.315,13.465),(47.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.465),(47.485,13.635),(47.655,13.635),(47.655,13.465),(47.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.245),(37.885,19.415),(38.055,19.415),(38.055,19.245),(37.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.125),(47.145,13.295),(47.315,13.295),(47.315,13.125),(47.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.125),(47.485,13.295),(47.655,13.295),(47.655,13.125),(47.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.305),(13.545,5.475),(13.715,5.475),(13.715,5.305),(13.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,5.645),(13.545,5.815),(13.715,5.815),(13.715,5.645),(13.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,4.965),(61.885,5.135),(62.055,5.135),(62.055,4.965),(61.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.305),(66.345,5.475),(66.515,5.475),(66.515,5.305),(66.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,5.645),(66.345,5.815),(66.515,5.815),(66.515,5.645),(66.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.645),(66.685,5.815),(66.855,5.815),(66.855,5.645),(66.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,5.305),(66.685,5.475),(66.855,5.475),(66.855,5.305),(66.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.305),(42.345,5.475),(42.515,5.475),(42.515,5.305),(42.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.305),(42.685,5.475),(42.855,5.475),(42.855,5.305),(42.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.645),(42.345,5.815),(42.515,5.815),(42.515,5.645),(42.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.645),(42.685,5.815),(42.855,5.815),(42.855,5.645),(42.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,16.865),(23.485,17.035),(23.655,17.035),(23.655,16.865),(23.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,16.865),(23.145,17.035),(23.315,17.035),(23.315,16.865),(23.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,9.045),(61.545,9.215),(61.715,9.215),(61.715,9.045),(61.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.185),(37.885,16.355),(38.055,16.355),(38.055,16.185),(37.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.525),(37.885,16.695),(38.055,16.695),(38.055,16.525),(37.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((13.545,9.045),(13.545,9.215),(13.715,9.215),(13.715,9.045),(13.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((18.685,4.965),(18.685,5.135),(18.855,5.135),(18.855,4.965),(18.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.165),(56.745,15.335),(56.915,15.335),(56.915,15.165),(56.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.505),(56.745,15.675),(56.915,15.675),(56.915,15.505),(56.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((18.345,4.965),(18.345,5.135),(18.515,5.135),(18.515,4.965),(18.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.385),(33.085,9.555),(33.255,9.555),(33.255,9.385),(33.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.725),(33.085,9.895),(33.255,9.895),(33.255,9.725),(33.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.485),(28.285,14.655),(28.455,14.655),(28.455,14.485),(28.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.825),(28.285,14.995),(28.455,14.995),(28.455,14.825),(28.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,14.145),(28.285,14.315),(28.455,14.315),(28.455,14.145),(28.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.225),(9.085,18.395),(9.255,18.395),(9.255,18.225),(9.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,18.565),(9.085,18.735),(9.255,18.735),(9.255,18.565),(9.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.605),(76.285,3.775),(76.455,3.775),(76.455,3.605),(76.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,3.265),(76.285,3.435),(76.455,3.435),(76.455,3.265),(76.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,9.045),(76.285,9.215),(76.455,9.215),(76.455,9.045),(76.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.485),(61.545,14.655),(61.715,14.655),(61.715,14.485),(61.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.825),(61.545,14.995),(61.715,14.995),(61.715,14.825),(61.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((61.545,14.145),(61.545,14.315),(61.715,14.315),(61.715,14.145),(61.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.445),(52.285,12.615),(52.455,12.615),(52.455,12.445),(52.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.785),(52.285,12.955),(52.455,12.955),(52.455,12.785),(52.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.265),(37.545,3.435),(37.715,3.435),(37.715,3.265),(37.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.605),(37.545,3.775),(37.715,3.775),(37.715,3.605),(37.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,9.045),(28.285,9.215),(28.455,9.215),(28.455,9.045),(28.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.105),(52.285,12.275),(52.455,12.275),(52.455,12.105),(52.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.965),(42.345,5.135),(42.515,5.135),(42.515,4.965),(42.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.965),(42.685,5.135),(42.855,5.135),(42.855,4.965),(42.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.265),(80.745,3.435),(80.915,3.435),(80.915,3.265),(80.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((80.745,3.605),(80.745,3.775),(80.915,3.775),(80.915,3.605),(80.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,18.905),(71.145,19.075),(71.315,19.075),(71.315,18.905),(71.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,18.905),(71.485,19.075),(71.655,19.075),(71.655,18.905),(71.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.845),(47.145,16.015),(47.315,16.015),(47.315,15.845),(47.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.845),(47.485,16.015),(47.655,16.015),(47.655,15.845),(47.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.685),(42.345,7.855),(42.515,7.855),(42.515,7.685),(42.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.685),(42.685,7.855),(42.855,7.855),(42.855,7.685),(42.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.085),(51.945,11.255),(52.115,11.255),(52.115,11.085),(51.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.425),(51.945,11.595),(52.115,11.595),(52.115,11.425),(51.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.765),(51.945,11.935),(52.115,11.935),(52.115,11.765),(51.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.225),(8.745,18.395),(8.915,18.395),(8.915,18.225),(8.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,18.565),(8.745,18.735),(8.915,18.735),(8.915,18.565),(8.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((81.085,18.905),(81.085,19.075),(81.255,19.075),(81.255,18.905),(81.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.865),(51.945,17.035),(52.115,17.035),(52.115,16.865),(51.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,3.945),(71.485,4.115),(71.655,4.115),(71.655,3.945),(71.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,3.945),(71.145,4.115),(71.315,4.115),(71.315,3.945),(71.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.525),(75.945,16.695),(76.115,16.695),(76.115,16.525),(75.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((75.945,16.185),(75.945,16.355),(76.115,16.355),(76.115,16.185),(75.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.945),(47.145,4.115),(47.315,4.115),(47.315,3.945),(47.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.945),(47.485,4.115),(47.655,4.115),(47.655,3.945),(47.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.825),(42.685,14.995),(42.855,14.995),(42.855,14.825),(42.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.485),(42.345,14.655),(42.515,14.655),(42.515,14.485),(42.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.485),(42.685,14.655),(42.855,14.655),(42.855,14.485),(42.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.825),(42.345,14.995),(42.515,14.995),(42.515,14.825),(42.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.145),(42.345,14.315),(42.515,14.315),(42.515,14.145),(42.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.145),(42.685,14.315),(42.855,14.315),(42.855,14.145),(42.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,16.865),(8.745,17.035),(8.915,17.035),(8.915,16.865),(8.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,3.945),(23.145,4.115),(23.315,4.115),(23.315,3.945),(23.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,3.945),(23.485,4.115),(23.655,4.115),(23.655,3.945),(23.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.925),(51.945,3.095),(52.115,3.095),(52.115,2.925),(51.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,9.045),(23.145,9.215),(23.315,9.215),(23.315,9.045),(23.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,9.045),(23.485,9.215),(23.655,9.215),(23.655,9.045),(23.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.045),(37.885,9.215),(38.055,9.215),(38.055,9.045),(37.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,16.865),(76.285,17.035),(76.455,17.035),(76.455,16.865),(76.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.305),(8.745,5.475),(8.915,5.475),(8.915,5.305),(8.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((8.745,5.645),(8.745,5.815),(8.915,5.815),(8.915,5.645),(8.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.445),(76.285,12.615),(76.455,12.615),(76.455,12.445),(76.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.105),(76.285,12.275),(76.455,12.275),(76.455,12.105),(76.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.505),(71.485,15.675),(71.655,15.675),(71.655,15.505),(71.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.165),(71.145,15.335),(71.315,15.335),(71.315,15.165),(71.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.485,15.165),(71.485,15.335),(71.655,15.335),(71.655,15.165),(71.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((76.285,12.785),(76.285,12.955),(76.455,12.955),(76.455,12.785),(76.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.145,15.505),(71.145,15.675),(71.315,15.675),(71.315,15.505),(71.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.365),(37.545,8.535),(37.715,8.535),(37.715,8.365),(37.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.705),(37.545,8.875),(37.715,8.875),(37.715,8.705),(37.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.025),(37.545,8.195),(37.715,8.195),(37.715,8.025),(37.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.425),(33.085,11.595),(33.255,11.595),(33.255,11.425),(33.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.085),(33.085,11.255),(33.255,11.255),(33.255,11.085),(33.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.765),(33.085,11.935),(33.255,11.935),(33.255,11.765),(33.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.105),(28.285,12.275),(28.455,12.275),(28.455,12.105),(28.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.145),(32.745,14.315),(32.915,14.315),(32.915,14.145),(32.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.165),(23.145,15.335),(23.315,15.335),(23.315,15.165),(23.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.165),(23.485,15.335),(23.655,15.335),(23.655,15.165),(23.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.445),(28.285,12.615),(28.455,12.615),(28.455,12.445),(28.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((28.285,12.785),(28.285,12.955),(28.455,12.955),(28.455,12.785),(28.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((23.145,15.505),(23.145,15.675),(23.315,15.675),(23.315,15.505),(23.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((23.485,15.505),(23.485,15.675),(23.655,15.675),(23.655,15.505),(23.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.485),(32.745,14.655),(32.915,14.655),(32.915,14.485),(32.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.825),(32.745,14.995),(32.915,14.995),(32.915,14.825),(32.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.985),(37.885,6.155),(38.055,6.155),(38.055,5.985),(37.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.085),(52.285,11.255),(52.455,11.255),(52.455,11.085),(52.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.765),(52.285,11.935),(52.455,11.935),(52.455,11.765),(52.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.425),(52.285,11.595),(52.455,11.595),(52.455,11.425),(52.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((61.885,3.945),(61.885,4.115),(62.055,4.115),(62.055,3.945),(61.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.505),(57.085,15.675),(57.255,15.675),(57.255,15.505),(57.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.165),(57.085,15.335),(57.255,15.335),(57.255,15.165),(57.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((66.685,4.965),(66.685,5.135),(66.855,5.135),(66.855,4.965),(66.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((66.345,4.965),(66.345,5.135),(66.515,5.135),(66.515,4.965),(66.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((9.085,15.505),(9.085,15.675),(9.255,15.675),(9.255,15.505),(9.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.985),(47.145,6.155),(47.315,6.155),(47.315,5.985),(47.145,5.985)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.985),(22.775,19.355),(24.025,19.355),(24.025,2.985),(22.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((22.775,2.845),(22.775,19.495),(24.025,19.495),(24.025,2.845),(22.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.985),(61.175,19.355),(62.425,19.355),(62.425,2.985),(61.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((61.545,2.845),(61.545,19.495),(62.055,19.495),(62.055,2.845),(61.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((61.175,2.845),(61.175,19.495),(62.425,19.495),(62.425,2.845),(61.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((66.345,2.845),(66.345,19.495),(66.855,19.495),(66.855,2.845),(66.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((71.145,2.845),(71.145,19.495),(71.655,19.495),(71.655,2.845),(71.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.985),(46.775,19.355),(48.025,19.355),(48.025,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.845),(46.775,19.495),(48.025,19.495),(48.025,2.845),(46.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.985),(65.975,19.355),(67.225,19.355),(67.225,2.985),(65.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((65.975,2.845),(65.975,19.495),(67.225,19.495),(67.225,2.845),(65.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((75.945,2.845),(75.945,19.495),(76.455,19.495),(76.455,2.845),(75.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.985),(75.575,19.355),(76.825,19.355),(76.825,2.985),(75.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((75.575,2.845),(75.575,19.495),(76.825,19.495),(76.825,2.845),(75.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((23.145,2.845),(23.145,19.495),(23.655,19.495),(23.655,2.845),(23.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((42.345,2.845),(42.345,19.495),(42.855,19.495),(42.855,2.845),(42.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.985),(56.375,19.355),(57.625,19.355),(57.625,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((56.745,2.845),(56.745,19.495),(57.255,19.495),(57.255,2.845),(56.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.845),(56.375,19.495),(57.625,19.495),(57.625,2.845),(56.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.545,2.845),(37.545,19.495),(38.055,19.495),(38.055,2.845),(37.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((47.145,2.845),(47.145,19.495),(47.655,19.495),(47.655,2.845),(47.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.985),(37.175,19.355),(38.425,19.355),(38.425,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.845),(37.175,19.495),(38.425,19.495),(38.425,2.845),(37.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((18.345,2.845),(18.345,19.495),(18.855,19.495),(18.855,2.845),(18.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.985),(41.975,19.355),(43.225,19.355),(43.225,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((27.945,2.845),(27.945,19.495),(28.455,19.495),(28.455,2.845),(27.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.985),(27.575,19.355),(28.825,19.355),(28.825,2.985),(27.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((27.575,2.845),(27.575,19.495),(28.825,19.495),(28.825,2.845),(27.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.845),(41.975,19.495),(43.225,19.495),(43.225,2.845),(41.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((8.745,2.845),(8.745,19.495),(9.255,19.495),(9.255,2.845),(8.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.985),(70.775,19.355),(72.025,19.355),(72.025,2.985),(70.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((70.775,2.845),(70.775,19.495),(72.025,19.495),(72.025,2.845),(70.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.985),(17.975,19.355),(19.225,19.355),(19.225,2.985),(17.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((17.975,2.845),(17.975,19.495),(19.225,19.495),(19.225,2.845),(17.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.985),(8.375,19.355),(9.625,19.355),(9.625,2.985),(8.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((8.375,2.845),(8.375,19.495),(9.625,19.495),(9.625,2.845),(8.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((13.545,2.845),(13.545,19.495),(14.055,19.495),(14.055,2.845),(13.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.985),(13.175,19.355),(14.425,19.355),(14.425,2.985),(13.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((13.175,2.845),(13.175,19.495),(14.425,19.495),(14.425,2.845),(13.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((80.745,2.845),(80.745,19.495),(81.255,19.495),(81.255,2.845),(80.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.745,2.845),(32.745,19.495),(33.255,19.495),(33.255,2.845),(32.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.985),(80.375,19.355),(81.625,19.355),(81.625,2.985),(80.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((80.375,2.845),(80.375,19.495),(81.625,19.495),(81.625,2.845),(80.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.945,2.845),(51.945,19.495),(52.455,19.495),(52.455,2.845),(51.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.985),(32.375,19.355),(33.625,19.355),(33.625,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.845),(32.375,19.495),(33.625,19.495),(33.625,2.845),(32.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.985),(51.575,19.355),(52.825,19.355),(52.825,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.845),(51.575,19.495),(52.825,19.495),(52.825,2.845),(51.575,2.845)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,2.985),(80.375,3.155),(80.545,3.155),(80.545,2.985),(80.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,2.985),(80.735,3.155),(80.905,3.155),(80.905,2.985),(80.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,2.985),(81.095,3.155),(81.265,3.155),(81.265,2.985),(81.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,2.985),(81.455,3.155),(81.625,3.155),(81.625,2.985),(81.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.345),(80.375,3.515),(80.545,3.515),(80.545,3.345),(80.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.345),(80.735,3.515),(80.905,3.515),(80.905,3.345),(80.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.345),(81.095,3.515),(81.265,3.515),(81.265,3.345),(81.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.345),(81.455,3.515),(81.625,3.515),(81.625,3.345),(81.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,3.705),(80.375,3.875),(80.545,3.875),(80.545,3.705),(80.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,3.705),(80.735,3.875),(80.905,3.875),(80.905,3.705),(80.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,3.705),(81.095,3.875),(81.265,3.875),(81.265,3.705),(81.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,3.705),(81.455,3.875),(81.625,3.875),(81.625,3.705),(81.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.065),(80.375,4.235),(80.545,4.235),(80.545,4.065),(80.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.065),(80.735,4.235),(80.905,4.235),(80.905,4.065),(80.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.065),(81.095,4.235),(81.265,4.235),(81.265,4.065),(81.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.065),(81.455,4.235),(81.625,4.235),(81.625,4.065),(81.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.425),(80.375,4.595),(80.545,4.595),(80.545,4.425),(80.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.425),(80.735,4.595),(80.905,4.595),(80.905,4.425),(80.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.425),(81.095,4.595),(81.265,4.595),(81.265,4.425),(81.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.425),(81.455,4.595),(81.625,4.595),(81.625,4.425),(81.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,4.785),(80.375,4.955),(80.545,4.955),(80.545,4.785),(80.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,4.785),(80.735,4.955),(80.905,4.955),(80.905,4.785),(80.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,4.785),(81.095,4.955),(81.265,4.955),(81.265,4.785),(81.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,4.785),(81.455,4.955),(81.625,4.955),(81.625,4.785),(81.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.145),(80.375,5.315),(80.545,5.315),(80.545,5.145),(80.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.145),(80.735,5.315),(80.905,5.315),(80.905,5.145),(80.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.145),(81.095,5.315),(81.265,5.315),(81.265,5.145),(81.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.145),(81.455,5.315),(81.625,5.315),(81.625,5.145),(81.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.505),(80.375,5.675),(80.545,5.675),(80.545,5.505),(80.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.505),(80.735,5.675),(80.905,5.675),(80.905,5.505),(80.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.505),(81.095,5.675),(81.265,5.675),(81.265,5.505),(81.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.505),(81.455,5.675),(81.625,5.675),(81.625,5.505),(81.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,5.865),(80.375,6.035),(80.545,6.035),(80.545,5.865),(80.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,5.865),(80.735,6.035),(80.905,6.035),(80.905,5.865),(80.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,5.865),(81.095,6.035),(81.265,6.035),(81.265,5.865),(81.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,5.865),(81.455,6.035),(81.625,6.035),(81.625,5.865),(81.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.225),(80.375,6.395),(80.545,6.395),(80.545,6.225),(80.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.225),(80.735,6.395),(80.905,6.395),(80.905,6.225),(80.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.225),(81.095,6.395),(81.265,6.395),(81.265,6.225),(81.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.225),(81.455,6.395),(81.625,6.395),(81.625,6.225),(81.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.585),(80.375,6.755),(80.545,6.755),(80.545,6.585),(80.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.585),(80.735,6.755),(80.905,6.755),(80.905,6.585),(80.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.585),(81.095,6.755),(81.265,6.755),(81.265,6.585),(81.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.585),(81.455,6.755),(81.625,6.755),(81.625,6.585),(81.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,6.945),(80.375,7.115),(80.545,7.115),(80.545,6.945),(80.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,6.945),(80.735,7.115),(80.905,7.115),(80.905,6.945),(80.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,6.945),(81.095,7.115),(81.265,7.115),(81.265,6.945),(81.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,6.945),(81.455,7.115),(81.625,7.115),(81.625,6.945),(81.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.305),(80.375,7.475),(80.545,7.475),(80.545,7.305),(80.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.305),(80.735,7.475),(80.905,7.475),(80.905,7.305),(80.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.305),(81.095,7.475),(81.265,7.475),(81.265,7.305),(81.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.305),(81.455,7.475),(81.625,7.475),(81.625,7.305),(81.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,7.665),(80.375,7.835),(80.545,7.835),(80.545,7.665),(80.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,7.665),(80.735,7.835),(80.905,7.835),(80.905,7.665),(80.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,7.665),(81.095,7.835),(81.265,7.835),(81.265,7.665),(81.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,7.665),(81.455,7.835),(81.625,7.835),(81.625,7.665),(81.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.025),(80.375,8.195),(80.545,8.195),(80.545,8.025),(80.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.025),(80.735,8.195),(80.905,8.195),(80.905,8.025),(80.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.025),(81.095,8.195),(81.265,8.195),(81.265,8.025),(81.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.025),(81.455,8.195),(81.625,8.195),(81.625,8.025),(81.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.385),(80.375,8.555),(80.545,8.555),(80.545,8.385),(80.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.385),(80.735,8.555),(80.905,8.555),(80.905,8.385),(80.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.385),(81.095,8.555),(81.265,8.555),(81.265,8.385),(81.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.385),(81.455,8.555),(81.625,8.555),(81.625,8.385),(81.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,8.745),(80.375,8.915),(80.545,8.915),(80.545,8.745),(80.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,8.745),(80.735,8.915),(80.905,8.915),(80.905,8.745),(80.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,8.745),(81.095,8.915),(81.265,8.915),(81.265,8.745),(81.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,8.745),(81.455,8.915),(81.625,8.915),(81.625,8.745),(81.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.105),(80.375,9.275),(80.545,9.275),(80.545,9.105),(80.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.105),(80.735,9.275),(80.905,9.275),(80.905,9.105),(80.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.105),(81.095,9.275),(81.265,9.275),(81.265,9.105),(81.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.105),(81.455,9.275),(81.625,9.275),(81.625,9.105),(81.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.465),(80.375,9.635),(80.545,9.635),(80.545,9.465),(80.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.465),(80.735,9.635),(80.905,9.635),(80.905,9.465),(80.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.465),(81.095,9.635),(81.265,9.635),(81.265,9.465),(81.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.465),(81.455,9.635),(81.625,9.635),(81.625,9.465),(81.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,9.825),(80.375,9.995),(80.545,9.995),(80.545,9.825),(80.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,9.825),(80.735,9.995),(80.905,9.995),(80.905,9.825),(80.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,9.825),(81.095,9.995),(81.265,9.995),(81.265,9.825),(81.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,9.825),(81.455,9.995),(81.625,9.995),(81.625,9.825),(81.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.185),(80.375,10.355),(80.545,10.355),(80.545,10.185),(80.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.185),(80.735,10.355),(80.905,10.355),(80.905,10.185),(80.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.185),(81.095,10.355),(81.265,10.355),(81.265,10.185),(81.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.185),(81.455,10.355),(81.625,10.355),(81.625,10.185),(81.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.545),(80.375,10.715),(80.545,10.715),(80.545,10.545),(80.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.545),(80.735,10.715),(80.905,10.715),(80.905,10.545),(80.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.545),(81.095,10.715),(81.265,10.715),(81.265,10.545),(81.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.545),(81.455,10.715),(81.625,10.715),(81.625,10.545),(81.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,10.905),(80.375,11.075),(80.545,11.075),(80.545,10.905),(80.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,10.905),(80.735,11.075),(80.905,11.075),(80.905,10.905),(80.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,10.905),(81.095,11.075),(81.265,11.075),(81.265,10.905),(81.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,10.905),(81.455,11.075),(81.625,11.075),(81.625,10.905),(81.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.265),(80.375,11.435),(80.545,11.435),(80.545,11.265),(80.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.265),(80.735,11.435),(80.905,11.435),(80.905,11.265),(80.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.265),(81.095,11.435),(81.265,11.435),(81.265,11.265),(81.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.265),(81.455,11.435),(81.625,11.435),(81.625,11.265),(81.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.625),(80.375,11.795),(80.545,11.795),(80.545,11.625),(80.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.625),(80.735,11.795),(80.905,11.795),(80.905,11.625),(80.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.625),(81.095,11.795),(81.265,11.795),(81.265,11.625),(81.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.625),(81.455,11.795),(81.625,11.795),(81.625,11.625),(81.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,11.985),(80.375,12.155),(80.545,12.155),(80.545,11.985),(80.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,11.985),(80.735,12.155),(80.905,12.155),(80.905,11.985),(80.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,11.985),(81.095,12.155),(81.265,12.155),(81.265,11.985),(81.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,11.985),(81.455,12.155),(81.625,12.155),(81.625,11.985),(81.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.345),(80.375,12.515),(80.545,12.515),(80.545,12.345),(80.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.345),(80.735,12.515),(80.905,12.515),(80.905,12.345),(80.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.345),(81.095,12.515),(81.265,12.515),(81.265,12.345),(81.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.345),(81.455,12.515),(81.625,12.515),(81.625,12.345),(81.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,12.705),(80.375,12.875),(80.545,12.875),(80.545,12.705),(80.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,12.705),(80.735,12.875),(80.905,12.875),(80.905,12.705),(80.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,12.705),(81.095,12.875),(81.265,12.875),(81.265,12.705),(81.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,12.705),(81.455,12.875),(81.625,12.875),(81.625,12.705),(81.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.065),(80.375,13.235),(80.545,13.235),(80.545,13.065),(80.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.065),(80.735,13.235),(80.905,13.235),(80.905,13.065),(80.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.065),(81.095,13.235),(81.265,13.235),(81.265,13.065),(81.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.065),(81.455,13.235),(81.625,13.235),(81.625,13.065),(81.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.425),(80.375,13.595),(80.545,13.595),(80.545,13.425),(80.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.425),(80.735,13.595),(80.905,13.595),(80.905,13.425),(80.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.425),(81.095,13.595),(81.265,13.595),(81.265,13.425),(81.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.425),(81.455,13.595),(81.625,13.595),(81.625,13.425),(81.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,13.785),(80.375,13.955),(80.545,13.955),(80.545,13.785),(80.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,13.785),(80.735,13.955),(80.905,13.955),(80.905,13.785),(80.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,13.785),(81.095,13.955),(81.265,13.955),(81.265,13.785),(81.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,13.785),(81.455,13.955),(81.625,13.955),(81.625,13.785),(81.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.145),(80.375,14.315),(80.545,14.315),(80.545,14.145),(80.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.145),(80.735,14.315),(80.905,14.315),(80.905,14.145),(80.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.145),(81.095,14.315),(81.265,14.315),(81.265,14.145),(81.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.145),(81.455,14.315),(81.625,14.315),(81.625,14.145),(81.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.505),(80.375,14.675),(80.545,14.675),(80.545,14.505),(80.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.505),(80.735,14.675),(80.905,14.675),(80.905,14.505),(80.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.505),(81.095,14.675),(81.265,14.675),(81.265,14.505),(81.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.505),(81.455,14.675),(81.625,14.675),(81.625,14.505),(81.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,14.865),(80.375,15.035),(80.545,15.035),(80.545,14.865),(80.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,14.865),(80.735,15.035),(80.905,15.035),(80.905,14.865),(80.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,14.865),(81.095,15.035),(81.265,15.035),(81.265,14.865),(81.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,14.865),(81.455,15.035),(81.625,15.035),(81.625,14.865),(81.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.225),(80.375,15.395),(80.545,15.395),(80.545,15.225),(80.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.225),(80.735,15.395),(80.905,15.395),(80.905,15.225),(80.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.225),(81.095,15.395),(81.265,15.395),(81.265,15.225),(81.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.225),(81.455,15.395),(81.625,15.395),(81.625,15.225),(81.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.585),(80.375,15.755),(80.545,15.755),(80.545,15.585),(80.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.585),(80.735,15.755),(80.905,15.755),(80.905,15.585),(80.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.585),(81.095,15.755),(81.265,15.755),(81.265,15.585),(81.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.585),(81.455,15.755),(81.625,15.755),(81.625,15.585),(81.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,15.945),(80.375,16.115),(80.545,16.115),(80.545,15.945),(80.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,15.945),(80.735,16.115),(80.905,16.115),(80.905,15.945),(80.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,15.945),(81.095,16.115),(81.265,16.115),(81.265,15.945),(81.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,15.945),(81.455,16.115),(81.625,16.115),(81.625,15.945),(81.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.305),(80.375,16.475),(80.545,16.475),(80.545,16.305),(80.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.305),(80.735,16.475),(80.905,16.475),(80.905,16.305),(80.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.305),(81.095,16.475),(81.265,16.475),(81.265,16.305),(81.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.305),(81.455,16.475),(81.625,16.475),(81.625,16.305),(81.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,16.665),(80.375,16.835),(80.545,16.835),(80.545,16.665),(80.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,16.665),(80.735,16.835),(80.905,16.835),(80.905,16.665),(80.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,16.665),(81.095,16.835),(81.265,16.835),(81.265,16.665),(81.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,16.665),(81.455,16.835),(81.625,16.835),(81.625,16.665),(81.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.025),(80.375,17.195),(80.545,17.195),(80.545,17.025),(80.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.025),(80.735,17.195),(80.905,17.195),(80.905,17.025),(80.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.025),(81.095,17.195),(81.265,17.195),(81.265,17.025),(81.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.025),(81.455,17.195),(81.625,17.195),(81.625,17.025),(81.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.385),(80.375,17.555),(80.545,17.555),(80.545,17.385),(80.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.385),(80.735,17.555),(80.905,17.555),(80.905,17.385),(80.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.385),(81.095,17.555),(81.265,17.555),(81.265,17.385),(81.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.385),(81.455,17.555),(81.625,17.555),(81.625,17.385),(81.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,17.745),(80.375,17.915),(80.545,17.915),(80.545,17.745),(80.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,17.745),(80.735,17.915),(80.905,17.915),(80.905,17.745),(80.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,17.745),(81.095,17.915),(81.265,17.915),(81.265,17.745),(81.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,17.745),(81.455,17.915),(81.625,17.915),(81.625,17.745),(81.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.105),(80.375,18.275),(80.545,18.275),(80.545,18.105),(80.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.105),(80.735,18.275),(80.905,18.275),(80.905,18.105),(80.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.105),(81.095,18.275),(81.265,18.275),(81.265,18.105),(81.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.105),(81.455,18.275),(81.625,18.275),(81.625,18.105),(81.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.465),(80.375,18.635),(80.545,18.635),(80.545,18.465),(80.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.465),(80.735,18.635),(80.905,18.635),(80.905,18.465),(80.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.465),(81.095,18.635),(81.265,18.635),(81.265,18.465),(81.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.465),(81.455,18.635),(81.625,18.635),(81.625,18.465),(81.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,18.825),(80.375,18.995),(80.545,18.995),(80.545,18.825),(80.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,18.825),(80.735,18.995),(80.905,18.995),(80.905,18.825),(80.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,18.825),(81.095,18.995),(81.265,18.995),(81.265,18.825),(81.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,18.825),(81.455,18.995),(81.625,18.995),(81.625,18.825),(81.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.375,19.185),(80.375,19.355),(80.545,19.355),(80.545,19.185),(80.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((80.735,19.185),(80.735,19.355),(80.905,19.355),(80.905,19.185),(80.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.095,19.185),(81.095,19.355),(81.265,19.355),(81.265,19.185),(81.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((81.455,19.185),(81.455,19.355),(81.625,19.355),(81.625,19.185),(81.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.985),(41.975,3.155),(42.145,3.155),(42.145,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.985),(42.335,3.155),(42.505,3.155),(42.505,2.985),(42.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.985),(42.695,3.155),(42.865,3.155),(42.865,2.985),(42.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.985),(43.055,3.155),(43.225,3.155),(43.225,2.985),(43.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.345),(41.975,3.515),(42.145,3.515),(42.145,3.345),(41.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.345),(42.335,3.515),(42.505,3.515),(42.505,3.345),(42.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.345),(42.695,3.515),(42.865,3.515),(42.865,3.345),(42.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.345),(43.055,3.515),(43.225,3.515),(43.225,3.345),(43.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.705),(41.975,3.875),(42.145,3.875),(42.145,3.705),(41.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.705),(42.335,3.875),(42.505,3.875),(42.505,3.705),(42.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.705),(42.695,3.875),(42.865,3.875),(42.865,3.705),(42.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.705),(43.055,3.875),(43.225,3.875),(43.225,3.705),(43.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.065),(41.975,4.235),(42.145,4.235),(42.145,4.065),(41.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.065),(42.335,4.235),(42.505,4.235),(42.505,4.065),(42.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.065),(42.695,4.235),(42.865,4.235),(42.865,4.065),(42.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.065),(43.055,4.235),(43.225,4.235),(43.225,4.065),(43.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.425),(41.975,4.595),(42.145,4.595),(42.145,4.425),(41.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.425),(42.335,4.595),(42.505,4.595),(42.505,4.425),(42.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.425),(42.695,4.595),(42.865,4.595),(42.865,4.425),(42.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.425),(43.055,4.595),(43.225,4.595),(43.225,4.425),(43.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.785),(41.975,4.955),(42.145,4.955),(42.145,4.785),(41.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.785),(42.335,4.955),(42.505,4.955),(42.505,4.785),(42.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.785),(42.695,4.955),(42.865,4.955),(42.865,4.785),(42.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.785),(43.055,4.955),(43.225,4.955),(43.225,4.785),(43.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.145),(41.975,5.315),(42.145,5.315),(42.145,5.145),(41.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.145),(42.335,5.315),(42.505,5.315),(42.505,5.145),(42.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.145),(42.695,5.315),(42.865,5.315),(42.865,5.145),(42.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.145),(43.055,5.315),(43.225,5.315),(43.225,5.145),(43.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.505),(41.975,5.675),(42.145,5.675),(42.145,5.505),(41.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.505),(42.335,5.675),(42.505,5.675),(42.505,5.505),(42.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.505),(42.695,5.675),(42.865,5.675),(42.865,5.505),(42.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.505),(43.055,5.675),(43.225,5.675),(43.225,5.505),(43.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.865),(41.975,6.035),(42.145,6.035),(42.145,5.865),(41.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.865),(42.335,6.035),(42.505,6.035),(42.505,5.865),(42.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.865),(42.695,6.035),(42.865,6.035),(42.865,5.865),(42.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.865),(43.055,6.035),(43.225,6.035),(43.225,5.865),(43.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.225),(41.975,6.395),(42.145,6.395),(42.145,6.225),(41.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.225),(42.335,6.395),(42.505,6.395),(42.505,6.225),(42.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.225),(42.695,6.395),(42.865,6.395),(42.865,6.225),(42.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.225),(43.055,6.395),(43.225,6.395),(43.225,6.225),(43.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.585),(41.975,6.755),(42.145,6.755),(42.145,6.585),(41.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.585),(42.335,6.755),(42.505,6.755),(42.505,6.585),(42.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.585),(42.695,6.755),(42.865,6.755),(42.865,6.585),(42.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.585),(43.055,6.755),(43.225,6.755),(43.225,6.585),(43.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.945),(41.975,7.115),(42.145,7.115),(42.145,6.945),(41.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.945),(42.335,7.115),(42.505,7.115),(42.505,6.945),(42.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.945),(42.695,7.115),(42.865,7.115),(42.865,6.945),(42.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.945),(43.055,7.115),(43.225,7.115),(43.225,6.945),(43.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.305),(41.975,7.475),(42.145,7.475),(42.145,7.305),(41.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.305),(42.335,7.475),(42.505,7.475),(42.505,7.305),(42.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.305),(42.695,7.475),(42.865,7.475),(42.865,7.305),(42.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.305),(43.055,7.475),(43.225,7.475),(43.225,7.305),(43.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.665),(41.975,7.835),(42.145,7.835),(42.145,7.665),(41.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.665),(42.335,7.835),(42.505,7.835),(42.505,7.665),(42.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.665),(42.695,7.835),(42.865,7.835),(42.865,7.665),(42.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.665),(43.055,7.835),(43.225,7.835),(43.225,7.665),(43.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.025),(41.975,8.195),(42.145,8.195),(42.145,8.025),(41.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.025),(42.335,8.195),(42.505,8.195),(42.505,8.025),(42.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.025),(42.695,8.195),(42.865,8.195),(42.865,8.025),(42.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.025),(43.055,8.195),(43.225,8.195),(43.225,8.025),(43.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.385),(41.975,8.555),(42.145,8.555),(42.145,8.385),(41.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.385),(42.335,8.555),(42.505,8.555),(42.505,8.385),(42.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.385),(42.695,8.555),(42.865,8.555),(42.865,8.385),(42.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.385),(43.055,8.555),(43.225,8.555),(43.225,8.385),(43.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.745),(41.975,8.915),(42.145,8.915),(42.145,8.745),(41.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.745),(42.335,8.915),(42.505,8.915),(42.505,8.745),(42.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.745),(42.695,8.915),(42.865,8.915),(42.865,8.745),(42.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.745),(43.055,8.915),(43.225,8.915),(43.225,8.745),(43.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.105),(41.975,9.275),(42.145,9.275),(42.145,9.105),(41.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.105),(42.335,9.275),(42.505,9.275),(42.505,9.105),(42.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.105),(42.695,9.275),(42.865,9.275),(42.865,9.105),(42.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.105),(43.055,9.275),(43.225,9.275),(43.225,9.105),(43.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.465),(41.975,9.635),(42.145,9.635),(42.145,9.465),(41.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.465),(42.335,9.635),(42.505,9.635),(42.505,9.465),(42.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.465),(42.695,9.635),(42.865,9.635),(42.865,9.465),(42.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.465),(43.055,9.635),(43.225,9.635),(43.225,9.465),(43.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.825),(41.975,9.995),(42.145,9.995),(42.145,9.825),(41.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.825),(42.335,9.995),(42.505,9.995),(42.505,9.825),(42.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.825),(42.695,9.995),(42.865,9.995),(42.865,9.825),(42.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.825),(43.055,9.995),(43.225,9.995),(43.225,9.825),(43.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.185),(41.975,10.355),(42.145,10.355),(42.145,10.185),(41.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.185),(42.335,10.355),(42.505,10.355),(42.505,10.185),(42.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.185),(42.695,10.355),(42.865,10.355),(42.865,10.185),(42.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.185),(43.055,10.355),(43.225,10.355),(43.225,10.185),(43.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.545),(41.975,10.715),(42.145,10.715),(42.145,10.545),(41.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.545),(42.335,10.715),(42.505,10.715),(42.505,10.545),(42.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.545),(42.695,10.715),(42.865,10.715),(42.865,10.545),(42.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.545),(43.055,10.715),(43.225,10.715),(43.225,10.545),(43.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.905),(41.975,11.075),(42.145,11.075),(42.145,10.905),(41.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.905),(42.335,11.075),(42.505,11.075),(42.505,10.905),(42.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.905),(42.695,11.075),(42.865,11.075),(42.865,10.905),(42.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.905),(43.055,11.075),(43.225,11.075),(43.225,10.905),(43.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.265),(41.975,11.435),(42.145,11.435),(42.145,11.265),(41.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.265),(42.335,11.435),(42.505,11.435),(42.505,11.265),(42.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.265),(42.695,11.435),(42.865,11.435),(42.865,11.265),(42.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.265),(43.055,11.435),(43.225,11.435),(43.225,11.265),(43.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.625),(41.975,11.795),(42.145,11.795),(42.145,11.625),(41.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.625),(42.335,11.795),(42.505,11.795),(42.505,11.625),(42.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.625),(42.695,11.795),(42.865,11.795),(42.865,11.625),(42.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.625),(43.055,11.795),(43.225,11.795),(43.225,11.625),(43.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.985),(41.975,12.155),(42.145,12.155),(42.145,11.985),(41.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.985),(42.335,12.155),(42.505,12.155),(42.505,11.985),(42.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.985),(42.695,12.155),(42.865,12.155),(42.865,11.985),(42.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.985),(43.055,12.155),(43.225,12.155),(43.225,11.985),(43.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.345),(41.975,12.515),(42.145,12.515),(42.145,12.345),(41.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.345),(42.335,12.515),(42.505,12.515),(42.505,12.345),(42.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.345),(42.695,12.515),(42.865,12.515),(42.865,12.345),(42.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.345),(43.055,12.515),(43.225,12.515),(43.225,12.345),(43.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.705),(41.975,12.875),(42.145,12.875),(42.145,12.705),(41.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.705),(42.335,12.875),(42.505,12.875),(42.505,12.705),(42.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.705),(42.695,12.875),(42.865,12.875),(42.865,12.705),(42.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.705),(43.055,12.875),(43.225,12.875),(43.225,12.705),(43.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.065),(41.975,13.235),(42.145,13.235),(42.145,13.065),(41.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.065),(42.335,13.235),(42.505,13.235),(42.505,13.065),(42.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.065),(42.695,13.235),(42.865,13.235),(42.865,13.065),(42.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.065),(43.055,13.235),(43.225,13.235),(43.225,13.065),(43.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.425),(41.975,13.595),(42.145,13.595),(42.145,13.425),(41.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.425),(42.335,13.595),(42.505,13.595),(42.505,13.425),(42.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.425),(42.695,13.595),(42.865,13.595),(42.865,13.425),(42.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.425),(43.055,13.595),(43.225,13.595),(43.225,13.425),(43.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.785),(41.975,13.955),(42.145,13.955),(42.145,13.785),(41.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.785),(42.335,13.955),(42.505,13.955),(42.505,13.785),(42.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.785),(42.695,13.955),(42.865,13.955),(42.865,13.785),(42.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.785),(43.055,13.955),(43.225,13.955),(43.225,13.785),(43.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.145),(41.975,14.315),(42.145,14.315),(42.145,14.145),(41.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.145),(42.335,14.315),(42.505,14.315),(42.505,14.145),(42.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.145),(42.695,14.315),(42.865,14.315),(42.865,14.145),(42.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.145),(43.055,14.315),(43.225,14.315),(43.225,14.145),(43.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.505),(41.975,14.675),(42.145,14.675),(42.145,14.505),(41.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.505),(42.335,14.675),(42.505,14.675),(42.505,14.505),(42.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.505),(42.695,14.675),(42.865,14.675),(42.865,14.505),(42.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.505),(43.055,14.675),(43.225,14.675),(43.225,14.505),(43.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.865),(41.975,15.035),(42.145,15.035),(42.145,14.865),(41.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.865),(42.335,15.035),(42.505,15.035),(42.505,14.865),(42.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.865),(42.695,15.035),(42.865,15.035),(42.865,14.865),(42.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.865),(43.055,15.035),(43.225,15.035),(43.225,14.865),(43.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.225),(41.975,15.395),(42.145,15.395),(42.145,15.225),(41.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.225),(42.335,15.395),(42.505,15.395),(42.505,15.225),(42.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.225),(42.695,15.395),(42.865,15.395),(42.865,15.225),(42.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.225),(43.055,15.395),(43.225,15.395),(43.225,15.225),(43.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.585),(41.975,15.755),(42.145,15.755),(42.145,15.585),(41.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.585),(42.335,15.755),(42.505,15.755),(42.505,15.585),(42.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.585),(42.695,15.755),(42.865,15.755),(42.865,15.585),(42.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.585),(43.055,15.755),(43.225,15.755),(43.225,15.585),(43.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.945),(41.975,16.115),(42.145,16.115),(42.145,15.945),(41.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.945),(42.335,16.115),(42.505,16.115),(42.505,15.945),(42.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.945),(42.695,16.115),(42.865,16.115),(42.865,15.945),(42.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.945),(43.055,16.115),(43.225,16.115),(43.225,15.945),(43.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.305),(41.975,16.475),(42.145,16.475),(42.145,16.305),(41.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.305),(42.335,16.475),(42.505,16.475),(42.505,16.305),(42.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.305),(42.695,16.475),(42.865,16.475),(42.865,16.305),(42.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.305),(43.055,16.475),(43.225,16.475),(43.225,16.305),(43.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.665),(41.975,16.835),(42.145,16.835),(42.145,16.665),(41.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.665),(42.335,16.835),(42.505,16.835),(42.505,16.665),(42.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.665),(42.695,16.835),(42.865,16.835),(42.865,16.665),(42.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.665),(43.055,16.835),(43.225,16.835),(43.225,16.665),(43.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.025),(41.975,17.195),(42.145,17.195),(42.145,17.025),(41.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.025),(42.335,17.195),(42.505,17.195),(42.505,17.025),(42.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.025),(42.695,17.195),(42.865,17.195),(42.865,17.025),(42.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.025),(43.055,17.195),(43.225,17.195),(43.225,17.025),(43.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.385),(41.975,17.555),(42.145,17.555),(42.145,17.385),(41.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.385),(42.335,17.555),(42.505,17.555),(42.505,17.385),(42.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.385),(42.695,17.555),(42.865,17.555),(42.865,17.385),(42.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.385),(43.055,17.555),(43.225,17.555),(43.225,17.385),(43.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.745),(41.975,17.915),(42.145,17.915),(42.145,17.745),(41.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.745),(42.335,17.915),(42.505,17.915),(42.505,17.745),(42.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.745),(42.695,17.915),(42.865,17.915),(42.865,17.745),(42.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.745),(43.055,17.915),(43.225,17.915),(43.225,17.745),(43.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.105),(41.975,18.275),(42.145,18.275),(42.145,18.105),(41.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.105),(42.335,18.275),(42.505,18.275),(42.505,18.105),(42.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.105),(42.695,18.275),(42.865,18.275),(42.865,18.105),(42.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.105),(43.055,18.275),(43.225,18.275),(43.225,18.105),(43.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.465),(41.975,18.635),(42.145,18.635),(42.145,18.465),(41.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.465),(42.335,18.635),(42.505,18.635),(42.505,18.465),(42.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.465),(42.695,18.635),(42.865,18.635),(42.865,18.465),(42.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.465),(43.055,18.635),(43.225,18.635),(43.225,18.465),(43.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.825),(41.975,18.995),(42.145,18.995),(42.145,18.825),(41.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.825),(42.335,18.995),(42.505,18.995),(42.505,18.825),(42.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.825),(42.695,18.995),(42.865,18.995),(42.865,18.825),(42.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.825),(43.055,18.995),(43.225,18.995),(43.225,18.825),(43.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.185),(41.975,19.355),(42.145,19.355),(42.145,19.185),(41.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.185),(42.335,19.355),(42.505,19.355),(42.505,19.185),(42.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.185),(42.695,19.355),(42.865,19.355),(42.865,19.185),(42.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.185),(43.055,19.355),(43.225,19.355),(43.225,19.185),(43.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.985),(46.775,3.155),(46.945,3.155),(46.945,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.985),(47.135,3.155),(47.305,3.155),(47.305,2.985),(47.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.985),(47.495,3.155),(47.665,3.155),(47.665,2.985),(47.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.985),(47.855,3.155),(48.025,3.155),(48.025,2.985),(47.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.345),(46.775,3.515),(46.945,3.515),(46.945,3.345),(46.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.345),(47.135,3.515),(47.305,3.515),(47.305,3.345),(47.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.345),(47.495,3.515),(47.665,3.515),(47.665,3.345),(47.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.345),(47.855,3.515),(48.025,3.515),(48.025,3.345),(47.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.705),(46.775,3.875),(46.945,3.875),(46.945,3.705),(46.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.705),(47.135,3.875),(47.305,3.875),(47.305,3.705),(47.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.705),(47.495,3.875),(47.665,3.875),(47.665,3.705),(47.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.705),(47.855,3.875),(48.025,3.875),(48.025,3.705),(47.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.065),(46.775,4.235),(46.945,4.235),(46.945,4.065),(46.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.065),(47.135,4.235),(47.305,4.235),(47.305,4.065),(47.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.065),(47.495,4.235),(47.665,4.235),(47.665,4.065),(47.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.065),(47.855,4.235),(48.025,4.235),(48.025,4.065),(47.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.425),(46.775,4.595),(46.945,4.595),(46.945,4.425),(46.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.425),(47.135,4.595),(47.305,4.595),(47.305,4.425),(47.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.425),(47.495,4.595),(47.665,4.595),(47.665,4.425),(47.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.425),(47.855,4.595),(48.025,4.595),(48.025,4.425),(47.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.785),(46.775,4.955),(46.945,4.955),(46.945,4.785),(46.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.785),(47.135,4.955),(47.305,4.955),(47.305,4.785),(47.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.785),(47.495,4.955),(47.665,4.955),(47.665,4.785),(47.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.785),(47.855,4.955),(48.025,4.955),(48.025,4.785),(47.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.145),(46.775,5.315),(46.945,5.315),(46.945,5.145),(46.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.145),(47.135,5.315),(47.305,5.315),(47.305,5.145),(47.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.145),(47.495,5.315),(47.665,5.315),(47.665,5.145),(47.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.145),(47.855,5.315),(48.025,5.315),(48.025,5.145),(47.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.505),(46.775,5.675),(46.945,5.675),(46.945,5.505),(46.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.505),(47.135,5.675),(47.305,5.675),(47.305,5.505),(47.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.505),(47.495,5.675),(47.665,5.675),(47.665,5.505),(47.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.505),(47.855,5.675),(48.025,5.675),(48.025,5.505),(47.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.865),(46.775,6.035),(46.945,6.035),(46.945,5.865),(46.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.865),(47.135,6.035),(47.305,6.035),(47.305,5.865),(47.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.865),(47.495,6.035),(47.665,6.035),(47.665,5.865),(47.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.865),(47.855,6.035),(48.025,6.035),(48.025,5.865),(47.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.225),(46.775,6.395),(46.945,6.395),(46.945,6.225),(46.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.225),(47.135,6.395),(47.305,6.395),(47.305,6.225),(47.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.225),(47.495,6.395),(47.665,6.395),(47.665,6.225),(47.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.225),(47.855,6.395),(48.025,6.395),(48.025,6.225),(47.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.585),(46.775,6.755),(46.945,6.755),(46.945,6.585),(46.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.585),(47.135,6.755),(47.305,6.755),(47.305,6.585),(47.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.585),(47.495,6.755),(47.665,6.755),(47.665,6.585),(47.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.585),(47.855,6.755),(48.025,6.755),(48.025,6.585),(47.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.945),(46.775,7.115),(46.945,7.115),(46.945,6.945),(46.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.945),(47.135,7.115),(47.305,7.115),(47.305,6.945),(47.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.945),(47.495,7.115),(47.665,7.115),(47.665,6.945),(47.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.945),(47.855,7.115),(48.025,7.115),(48.025,6.945),(47.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.305),(46.775,7.475),(46.945,7.475),(46.945,7.305),(46.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.305),(47.135,7.475),(47.305,7.475),(47.305,7.305),(47.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.305),(47.495,7.475),(47.665,7.475),(47.665,7.305),(47.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.305),(47.855,7.475),(48.025,7.475),(48.025,7.305),(47.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.665),(46.775,7.835),(46.945,7.835),(46.945,7.665),(46.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.665),(47.135,7.835),(47.305,7.835),(47.305,7.665),(47.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.665),(47.495,7.835),(47.665,7.835),(47.665,7.665),(47.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.665),(47.855,7.835),(48.025,7.835),(48.025,7.665),(47.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.025),(46.775,8.195),(46.945,8.195),(46.945,8.025),(46.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.025),(47.135,8.195),(47.305,8.195),(47.305,8.025),(47.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.025),(47.495,8.195),(47.665,8.195),(47.665,8.025),(47.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.025),(47.855,8.195),(48.025,8.195),(48.025,8.025),(47.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.385),(46.775,8.555),(46.945,8.555),(46.945,8.385),(46.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.385),(47.135,8.555),(47.305,8.555),(47.305,8.385),(47.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.385),(47.495,8.555),(47.665,8.555),(47.665,8.385),(47.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.385),(47.855,8.555),(48.025,8.555),(48.025,8.385),(47.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.745),(46.775,8.915),(46.945,8.915),(46.945,8.745),(46.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.745),(47.135,8.915),(47.305,8.915),(47.305,8.745),(47.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.745),(47.495,8.915),(47.665,8.915),(47.665,8.745),(47.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.745),(47.855,8.915),(48.025,8.915),(48.025,8.745),(47.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.105),(46.775,9.275),(46.945,9.275),(46.945,9.105),(46.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.105),(47.135,9.275),(47.305,9.275),(47.305,9.105),(47.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.105),(47.495,9.275),(47.665,9.275),(47.665,9.105),(47.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.105),(47.855,9.275),(48.025,9.275),(48.025,9.105),(47.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.465),(46.775,9.635),(46.945,9.635),(46.945,9.465),(46.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.465),(47.135,9.635),(47.305,9.635),(47.305,9.465),(47.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.465),(47.495,9.635),(47.665,9.635),(47.665,9.465),(47.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.465),(47.855,9.635),(48.025,9.635),(48.025,9.465),(47.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.825),(46.775,9.995),(46.945,9.995),(46.945,9.825),(46.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.825),(47.135,9.995),(47.305,9.995),(47.305,9.825),(47.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.825),(47.495,9.995),(47.665,9.995),(47.665,9.825),(47.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.825),(47.855,9.995),(48.025,9.995),(48.025,9.825),(47.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.185),(46.775,10.355),(46.945,10.355),(46.945,10.185),(46.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.185),(47.135,10.355),(47.305,10.355),(47.305,10.185),(47.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.185),(47.495,10.355),(47.665,10.355),(47.665,10.185),(47.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.185),(47.855,10.355),(48.025,10.355),(48.025,10.185),(47.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.545),(46.775,10.715),(46.945,10.715),(46.945,10.545),(46.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.545),(47.135,10.715),(47.305,10.715),(47.305,10.545),(47.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.545),(47.495,10.715),(47.665,10.715),(47.665,10.545),(47.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.545),(47.855,10.715),(48.025,10.715),(48.025,10.545),(47.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.905),(46.775,11.075),(46.945,11.075),(46.945,10.905),(46.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.905),(47.135,11.075),(47.305,11.075),(47.305,10.905),(47.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.905),(47.495,11.075),(47.665,11.075),(47.665,10.905),(47.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.905),(47.855,11.075),(48.025,11.075),(48.025,10.905),(47.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.265),(46.775,11.435),(46.945,11.435),(46.945,11.265),(46.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.265),(47.135,11.435),(47.305,11.435),(47.305,11.265),(47.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.265),(47.495,11.435),(47.665,11.435),(47.665,11.265),(47.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.265),(47.855,11.435),(48.025,11.435),(48.025,11.265),(47.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.625),(46.775,11.795),(46.945,11.795),(46.945,11.625),(46.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.625),(47.135,11.795),(47.305,11.795),(47.305,11.625),(47.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.625),(47.495,11.795),(47.665,11.795),(47.665,11.625),(47.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.625),(47.855,11.795),(48.025,11.795),(48.025,11.625),(47.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.985),(46.775,12.155),(46.945,12.155),(46.945,11.985),(46.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.985),(47.135,12.155),(47.305,12.155),(47.305,11.985),(47.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.985),(47.495,12.155),(47.665,12.155),(47.665,11.985),(47.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.985),(47.855,12.155),(48.025,12.155),(48.025,11.985),(47.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.345),(46.775,12.515),(46.945,12.515),(46.945,12.345),(46.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.345),(47.135,12.515),(47.305,12.515),(47.305,12.345),(47.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.345),(47.495,12.515),(47.665,12.515),(47.665,12.345),(47.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.345),(47.855,12.515),(48.025,12.515),(48.025,12.345),(47.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.705),(46.775,12.875),(46.945,12.875),(46.945,12.705),(46.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.705),(47.135,12.875),(47.305,12.875),(47.305,12.705),(47.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.705),(47.495,12.875),(47.665,12.875),(47.665,12.705),(47.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.705),(47.855,12.875),(48.025,12.875),(48.025,12.705),(47.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.065),(46.775,13.235),(46.945,13.235),(46.945,13.065),(46.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.065),(47.135,13.235),(47.305,13.235),(47.305,13.065),(47.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.065),(47.495,13.235),(47.665,13.235),(47.665,13.065),(47.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.065),(47.855,13.235),(48.025,13.235),(48.025,13.065),(47.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.425),(46.775,13.595),(46.945,13.595),(46.945,13.425),(46.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.425),(47.135,13.595),(47.305,13.595),(47.305,13.425),(47.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.425),(47.495,13.595),(47.665,13.595),(47.665,13.425),(47.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.425),(47.855,13.595),(48.025,13.595),(48.025,13.425),(47.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.785),(46.775,13.955),(46.945,13.955),(46.945,13.785),(46.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.785),(47.135,13.955),(47.305,13.955),(47.305,13.785),(47.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.785),(47.495,13.955),(47.665,13.955),(47.665,13.785),(47.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.785),(47.855,13.955),(48.025,13.955),(48.025,13.785),(47.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.145),(46.775,14.315),(46.945,14.315),(46.945,14.145),(46.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.145),(47.135,14.315),(47.305,14.315),(47.305,14.145),(47.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.145),(47.495,14.315),(47.665,14.315),(47.665,14.145),(47.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.145),(47.855,14.315),(48.025,14.315),(48.025,14.145),(47.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.505),(46.775,14.675),(46.945,14.675),(46.945,14.505),(46.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.505),(47.135,14.675),(47.305,14.675),(47.305,14.505),(47.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.505),(47.495,14.675),(47.665,14.675),(47.665,14.505),(47.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.505),(47.855,14.675),(48.025,14.675),(48.025,14.505),(47.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.865),(46.775,15.035),(46.945,15.035),(46.945,14.865),(46.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.865),(47.135,15.035),(47.305,15.035),(47.305,14.865),(47.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.865),(47.495,15.035),(47.665,15.035),(47.665,14.865),(47.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.865),(47.855,15.035),(48.025,15.035),(48.025,14.865),(47.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.225),(46.775,15.395),(46.945,15.395),(46.945,15.225),(46.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.225),(47.135,15.395),(47.305,15.395),(47.305,15.225),(47.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.225),(47.495,15.395),(47.665,15.395),(47.665,15.225),(47.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.225),(47.855,15.395),(48.025,15.395),(48.025,15.225),(47.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.585),(46.775,15.755),(46.945,15.755),(46.945,15.585),(46.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.585),(47.135,15.755),(47.305,15.755),(47.305,15.585),(47.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.585),(47.495,15.755),(47.665,15.755),(47.665,15.585),(47.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.585),(47.855,15.755),(48.025,15.755),(48.025,15.585),(47.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.945),(46.775,16.115),(46.945,16.115),(46.945,15.945),(46.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.945),(47.135,16.115),(47.305,16.115),(47.305,15.945),(47.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.945),(47.495,16.115),(47.665,16.115),(47.665,15.945),(47.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.945),(47.855,16.115),(48.025,16.115),(48.025,15.945),(47.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.305),(46.775,16.475),(46.945,16.475),(46.945,16.305),(46.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.305),(47.135,16.475),(47.305,16.475),(47.305,16.305),(47.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.305),(47.495,16.475),(47.665,16.475),(47.665,16.305),(47.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.305),(47.855,16.475),(48.025,16.475),(48.025,16.305),(47.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.665),(46.775,16.835),(46.945,16.835),(46.945,16.665),(46.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.665),(47.135,16.835),(47.305,16.835),(47.305,16.665),(47.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.665),(47.495,16.835),(47.665,16.835),(47.665,16.665),(47.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.665),(47.855,16.835),(48.025,16.835),(48.025,16.665),(47.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.025),(46.775,17.195),(46.945,17.195),(46.945,17.025),(46.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.025),(47.135,17.195),(47.305,17.195),(47.305,17.025),(47.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.025),(47.495,17.195),(47.665,17.195),(47.665,17.025),(47.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.025),(47.855,17.195),(48.025,17.195),(48.025,17.025),(47.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.385),(46.775,17.555),(46.945,17.555),(46.945,17.385),(46.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.385),(47.135,17.555),(47.305,17.555),(47.305,17.385),(47.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.385),(47.495,17.555),(47.665,17.555),(47.665,17.385),(47.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.385),(47.855,17.555),(48.025,17.555),(48.025,17.385),(47.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.745),(46.775,17.915),(46.945,17.915),(46.945,17.745),(46.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.745),(47.135,17.915),(47.305,17.915),(47.305,17.745),(47.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.745),(47.495,17.915),(47.665,17.915),(47.665,17.745),(47.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.745),(47.855,17.915),(48.025,17.915),(48.025,17.745),(47.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.105),(46.775,18.275),(46.945,18.275),(46.945,18.105),(46.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.105),(47.135,18.275),(47.305,18.275),(47.305,18.105),(47.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.105),(47.495,18.275),(47.665,18.275),(47.665,18.105),(47.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.105),(47.855,18.275),(48.025,18.275),(48.025,18.105),(47.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.465),(46.775,18.635),(46.945,18.635),(46.945,18.465),(46.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.465),(47.135,18.635),(47.305,18.635),(47.305,18.465),(47.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.465),(47.495,18.635),(47.665,18.635),(47.665,18.465),(47.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.465),(47.855,18.635),(48.025,18.635),(48.025,18.465),(47.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.825),(46.775,18.995),(46.945,18.995),(46.945,18.825),(46.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.825),(47.135,18.995),(47.305,18.995),(47.305,18.825),(47.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.825),(47.495,18.995),(47.665,18.995),(47.665,18.825),(47.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.825),(47.855,18.995),(48.025,18.995),(48.025,18.825),(47.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.185),(46.775,19.355),(46.945,19.355),(46.945,19.185),(46.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.185),(47.135,19.355),(47.305,19.355),(47.305,19.185),(47.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.185),(47.495,19.355),(47.665,19.355),(47.665,19.185),(47.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.185),(47.855,19.355),(48.025,19.355),(48.025,19.185),(47.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,2.985),(8.375,3.155),(8.545,3.155),(8.545,2.985),(8.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,2.985),(8.735,3.155),(8.905,3.155),(8.905,2.985),(8.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,2.985),(9.095,3.155),(9.265,3.155),(9.265,2.985),(9.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,2.985),(9.455,3.155),(9.625,3.155),(9.625,2.985),(9.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.345),(8.375,3.515),(8.545,3.515),(8.545,3.345),(8.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.345),(8.735,3.515),(8.905,3.515),(8.905,3.345),(8.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.345),(9.095,3.515),(9.265,3.515),(9.265,3.345),(9.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.345),(9.455,3.515),(9.625,3.515),(9.625,3.345),(9.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,3.705),(8.375,3.875),(8.545,3.875),(8.545,3.705),(8.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,3.705),(8.735,3.875),(8.905,3.875),(8.905,3.705),(8.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,3.705),(9.095,3.875),(9.265,3.875),(9.265,3.705),(9.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,3.705),(9.455,3.875),(9.625,3.875),(9.625,3.705),(9.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.065),(8.375,4.235),(8.545,4.235),(8.545,4.065),(8.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.065),(8.735,4.235),(8.905,4.235),(8.905,4.065),(8.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.065),(9.095,4.235),(9.265,4.235),(9.265,4.065),(9.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.065),(9.455,4.235),(9.625,4.235),(9.625,4.065),(9.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.425),(8.375,4.595),(8.545,4.595),(8.545,4.425),(8.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.425),(8.735,4.595),(8.905,4.595),(8.905,4.425),(8.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.425),(9.095,4.595),(9.265,4.595),(9.265,4.425),(9.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.425),(9.455,4.595),(9.625,4.595),(9.625,4.425),(9.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,4.785),(8.375,4.955),(8.545,4.955),(8.545,4.785),(8.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,4.785),(8.735,4.955),(8.905,4.955),(8.905,4.785),(8.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,4.785),(9.095,4.955),(9.265,4.955),(9.265,4.785),(9.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,4.785),(9.455,4.955),(9.625,4.955),(9.625,4.785),(9.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.145),(8.375,5.315),(8.545,5.315),(8.545,5.145),(8.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.145),(8.735,5.315),(8.905,5.315),(8.905,5.145),(8.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.145),(9.095,5.315),(9.265,5.315),(9.265,5.145),(9.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.145),(9.455,5.315),(9.625,5.315),(9.625,5.145),(9.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.505),(8.375,5.675),(8.545,5.675),(8.545,5.505),(8.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.505),(8.735,5.675),(8.905,5.675),(8.905,5.505),(8.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.505),(9.095,5.675),(9.265,5.675),(9.265,5.505),(9.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.505),(9.455,5.675),(9.625,5.675),(9.625,5.505),(9.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,5.865),(8.375,6.035),(8.545,6.035),(8.545,5.865),(8.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,5.865),(8.735,6.035),(8.905,6.035),(8.905,5.865),(8.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,5.865),(9.095,6.035),(9.265,6.035),(9.265,5.865),(9.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,5.865),(9.455,6.035),(9.625,6.035),(9.625,5.865),(9.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.225),(8.375,6.395),(8.545,6.395),(8.545,6.225),(8.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.225),(8.735,6.395),(8.905,6.395),(8.905,6.225),(8.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.225),(9.095,6.395),(9.265,6.395),(9.265,6.225),(9.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.225),(9.455,6.395),(9.625,6.395),(9.625,6.225),(9.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.585),(8.375,6.755),(8.545,6.755),(8.545,6.585),(8.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.585),(8.735,6.755),(8.905,6.755),(8.905,6.585),(8.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.585),(9.095,6.755),(9.265,6.755),(9.265,6.585),(9.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.585),(9.455,6.755),(9.625,6.755),(9.625,6.585),(9.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,6.945),(8.375,7.115),(8.545,7.115),(8.545,6.945),(8.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,6.945),(8.735,7.115),(8.905,7.115),(8.905,6.945),(8.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,6.945),(9.095,7.115),(9.265,7.115),(9.265,6.945),(9.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,6.945),(9.455,7.115),(9.625,7.115),(9.625,6.945),(9.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.305),(8.375,7.475),(8.545,7.475),(8.545,7.305),(8.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.305),(8.735,7.475),(8.905,7.475),(8.905,7.305),(8.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.305),(9.095,7.475),(9.265,7.475),(9.265,7.305),(9.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.305),(9.455,7.475),(9.625,7.475),(9.625,7.305),(9.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,7.665),(8.375,7.835),(8.545,7.835),(8.545,7.665),(8.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,7.665),(8.735,7.835),(8.905,7.835),(8.905,7.665),(8.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,7.665),(9.095,7.835),(9.265,7.835),(9.265,7.665),(9.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,7.665),(9.455,7.835),(9.625,7.835),(9.625,7.665),(9.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.025),(8.375,8.195),(8.545,8.195),(8.545,8.025),(8.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.025),(8.735,8.195),(8.905,8.195),(8.905,8.025),(8.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.025),(9.095,8.195),(9.265,8.195),(9.265,8.025),(9.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.025),(9.455,8.195),(9.625,8.195),(9.625,8.025),(9.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.385),(8.375,8.555),(8.545,8.555),(8.545,8.385),(8.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.385),(8.735,8.555),(8.905,8.555),(8.905,8.385),(8.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.385),(9.095,8.555),(9.265,8.555),(9.265,8.385),(9.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.385),(9.455,8.555),(9.625,8.555),(9.625,8.385),(9.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,8.745),(8.375,8.915),(8.545,8.915),(8.545,8.745),(8.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,8.745),(8.735,8.915),(8.905,8.915),(8.905,8.745),(8.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,8.745),(9.095,8.915),(9.265,8.915),(9.265,8.745),(9.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,8.745),(9.455,8.915),(9.625,8.915),(9.625,8.745),(9.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.105),(8.375,9.275),(8.545,9.275),(8.545,9.105),(8.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.105),(8.735,9.275),(8.905,9.275),(8.905,9.105),(8.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.105),(9.095,9.275),(9.265,9.275),(9.265,9.105),(9.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.105),(9.455,9.275),(9.625,9.275),(9.625,9.105),(9.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.465),(8.375,9.635),(8.545,9.635),(8.545,9.465),(8.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.465),(8.735,9.635),(8.905,9.635),(8.905,9.465),(8.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.465),(9.095,9.635),(9.265,9.635),(9.265,9.465),(9.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.465),(9.455,9.635),(9.625,9.635),(9.625,9.465),(9.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,9.825),(8.375,9.995),(8.545,9.995),(8.545,9.825),(8.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,9.825),(8.735,9.995),(8.905,9.995),(8.905,9.825),(8.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,9.825),(9.095,9.995),(9.265,9.995),(9.265,9.825),(9.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,9.825),(9.455,9.995),(9.625,9.995),(9.625,9.825),(9.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.185),(8.375,10.355),(8.545,10.355),(8.545,10.185),(8.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.185),(8.735,10.355),(8.905,10.355),(8.905,10.185),(8.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.185),(9.095,10.355),(9.265,10.355),(9.265,10.185),(9.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.185),(9.455,10.355),(9.625,10.355),(9.625,10.185),(9.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.545),(8.375,10.715),(8.545,10.715),(8.545,10.545),(8.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.545),(8.735,10.715),(8.905,10.715),(8.905,10.545),(8.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.545),(9.095,10.715),(9.265,10.715),(9.265,10.545),(9.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.545),(9.455,10.715),(9.625,10.715),(9.625,10.545),(9.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,10.905),(8.375,11.075),(8.545,11.075),(8.545,10.905),(8.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,10.905),(8.735,11.075),(8.905,11.075),(8.905,10.905),(8.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,10.905),(9.095,11.075),(9.265,11.075),(9.265,10.905),(9.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,10.905),(9.455,11.075),(9.625,11.075),(9.625,10.905),(9.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.265),(8.375,11.435),(8.545,11.435),(8.545,11.265),(8.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.265),(8.735,11.435),(8.905,11.435),(8.905,11.265),(8.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.265),(9.095,11.435),(9.265,11.435),(9.265,11.265),(9.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.265),(9.455,11.435),(9.625,11.435),(9.625,11.265),(9.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.625),(8.375,11.795),(8.545,11.795),(8.545,11.625),(8.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.625),(8.735,11.795),(8.905,11.795),(8.905,11.625),(8.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.625),(9.095,11.795),(9.265,11.795),(9.265,11.625),(9.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.625),(9.455,11.795),(9.625,11.795),(9.625,11.625),(9.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,11.985),(8.375,12.155),(8.545,12.155),(8.545,11.985),(8.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,11.985),(8.735,12.155),(8.905,12.155),(8.905,11.985),(8.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,11.985),(9.095,12.155),(9.265,12.155),(9.265,11.985),(9.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,11.985),(9.455,12.155),(9.625,12.155),(9.625,11.985),(9.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.345),(8.375,12.515),(8.545,12.515),(8.545,12.345),(8.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.345),(8.735,12.515),(8.905,12.515),(8.905,12.345),(8.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.345),(9.095,12.515),(9.265,12.515),(9.265,12.345),(9.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.345),(9.455,12.515),(9.625,12.515),(9.625,12.345),(9.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,12.705),(8.375,12.875),(8.545,12.875),(8.545,12.705),(8.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,12.705),(8.735,12.875),(8.905,12.875),(8.905,12.705),(8.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,12.705),(9.095,12.875),(9.265,12.875),(9.265,12.705),(9.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,12.705),(9.455,12.875),(9.625,12.875),(9.625,12.705),(9.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.065),(8.375,13.235),(8.545,13.235),(8.545,13.065),(8.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.065),(8.735,13.235),(8.905,13.235),(8.905,13.065),(8.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.065),(9.095,13.235),(9.265,13.235),(9.265,13.065),(9.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.065),(9.455,13.235),(9.625,13.235),(9.625,13.065),(9.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.425),(8.375,13.595),(8.545,13.595),(8.545,13.425),(8.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.425),(8.735,13.595),(8.905,13.595),(8.905,13.425),(8.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.425),(9.095,13.595),(9.265,13.595),(9.265,13.425),(9.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.425),(9.455,13.595),(9.625,13.595),(9.625,13.425),(9.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,13.785),(8.375,13.955),(8.545,13.955),(8.545,13.785),(8.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,13.785),(8.735,13.955),(8.905,13.955),(8.905,13.785),(8.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,13.785),(9.095,13.955),(9.265,13.955),(9.265,13.785),(9.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,13.785),(9.455,13.955),(9.625,13.955),(9.625,13.785),(9.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.145),(8.375,14.315),(8.545,14.315),(8.545,14.145),(8.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.145),(8.735,14.315),(8.905,14.315),(8.905,14.145),(8.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.145),(9.095,14.315),(9.265,14.315),(9.265,14.145),(9.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.145),(9.455,14.315),(9.625,14.315),(9.625,14.145),(9.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.505),(8.375,14.675),(8.545,14.675),(8.545,14.505),(8.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.505),(8.735,14.675),(8.905,14.675),(8.905,14.505),(8.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.505),(9.095,14.675),(9.265,14.675),(9.265,14.505),(9.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.505),(9.455,14.675),(9.625,14.675),(9.625,14.505),(9.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,14.865),(8.375,15.035),(8.545,15.035),(8.545,14.865),(8.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,14.865),(8.735,15.035),(8.905,15.035),(8.905,14.865),(8.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,14.865),(9.095,15.035),(9.265,15.035),(9.265,14.865),(9.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,14.865),(9.455,15.035),(9.625,15.035),(9.625,14.865),(9.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.225),(8.375,15.395),(8.545,15.395),(8.545,15.225),(8.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.225),(8.735,15.395),(8.905,15.395),(8.905,15.225),(8.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.225),(9.095,15.395),(9.265,15.395),(9.265,15.225),(9.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.225),(9.455,15.395),(9.625,15.395),(9.625,15.225),(9.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.585),(8.375,15.755),(8.545,15.755),(8.545,15.585),(8.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.585),(8.735,15.755),(8.905,15.755),(8.905,15.585),(8.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.585),(9.095,15.755),(9.265,15.755),(9.265,15.585),(9.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.585),(9.455,15.755),(9.625,15.755),(9.625,15.585),(9.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,15.945),(8.375,16.115),(8.545,16.115),(8.545,15.945),(8.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,15.945),(8.735,16.115),(8.905,16.115),(8.905,15.945),(8.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,15.945),(9.095,16.115),(9.265,16.115),(9.265,15.945),(9.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,15.945),(9.455,16.115),(9.625,16.115),(9.625,15.945),(9.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.305),(8.375,16.475),(8.545,16.475),(8.545,16.305),(8.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.305),(8.735,16.475),(8.905,16.475),(8.905,16.305),(8.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.305),(9.095,16.475),(9.265,16.475),(9.265,16.305),(9.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.305),(9.455,16.475),(9.625,16.475),(9.625,16.305),(9.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,16.665),(8.375,16.835),(8.545,16.835),(8.545,16.665),(8.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,16.665),(8.735,16.835),(8.905,16.835),(8.905,16.665),(8.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,16.665),(9.095,16.835),(9.265,16.835),(9.265,16.665),(9.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,16.665),(9.455,16.835),(9.625,16.835),(9.625,16.665),(9.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.025),(8.375,17.195),(8.545,17.195),(8.545,17.025),(8.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.025),(8.735,17.195),(8.905,17.195),(8.905,17.025),(8.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.025),(9.095,17.195),(9.265,17.195),(9.265,17.025),(9.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.025),(9.455,17.195),(9.625,17.195),(9.625,17.025),(9.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.385),(8.375,17.555),(8.545,17.555),(8.545,17.385),(8.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.385),(8.735,17.555),(8.905,17.555),(8.905,17.385),(8.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.385),(9.095,17.555),(9.265,17.555),(9.265,17.385),(9.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.385),(9.455,17.555),(9.625,17.555),(9.625,17.385),(9.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,17.745),(8.375,17.915),(8.545,17.915),(8.545,17.745),(8.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,17.745),(8.735,17.915),(8.905,17.915),(8.905,17.745),(8.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,17.745),(9.095,17.915),(9.265,17.915),(9.265,17.745),(9.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,17.745),(9.455,17.915),(9.625,17.915),(9.625,17.745),(9.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.105),(8.375,18.275),(8.545,18.275),(8.545,18.105),(8.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.105),(8.735,18.275),(8.905,18.275),(8.905,18.105),(8.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.105),(9.095,18.275),(9.265,18.275),(9.265,18.105),(9.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.105),(9.455,18.275),(9.625,18.275),(9.625,18.105),(9.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.465),(8.375,18.635),(8.545,18.635),(8.545,18.465),(8.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.465),(8.735,18.635),(8.905,18.635),(8.905,18.465),(8.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.465),(9.095,18.635),(9.265,18.635),(9.265,18.465),(9.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.465),(9.455,18.635),(9.625,18.635),(9.625,18.465),(9.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,18.825),(8.375,18.995),(8.545,18.995),(8.545,18.825),(8.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,18.825),(8.735,18.995),(8.905,18.995),(8.905,18.825),(8.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,18.825),(9.095,18.995),(9.265,18.995),(9.265,18.825),(9.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,18.825),(9.455,18.995),(9.625,18.995),(9.625,18.825),(9.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.375,19.185),(8.375,19.355),(8.545,19.355),(8.545,19.185),(8.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((8.735,19.185),(8.735,19.355),(8.905,19.355),(8.905,19.185),(8.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.095,19.185),(9.095,19.355),(9.265,19.355),(9.265,19.185),(9.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((9.455,19.185),(9.455,19.355),(9.625,19.355),(9.625,19.185),(9.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.985),(32.375,3.155),(32.545,3.155),(32.545,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.985),(32.735,3.155),(32.905,3.155),(32.905,2.985),(32.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.985),(33.095,3.155),(33.265,3.155),(33.265,2.985),(33.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.985),(33.455,3.155),(33.625,3.155),(33.625,2.985),(33.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.345),(32.375,3.515),(32.545,3.515),(32.545,3.345),(32.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.345),(32.735,3.515),(32.905,3.515),(32.905,3.345),(32.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.345),(33.095,3.515),(33.265,3.515),(33.265,3.345),(33.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.345),(33.455,3.515),(33.625,3.515),(33.625,3.345),(33.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.705),(32.375,3.875),(32.545,3.875),(32.545,3.705),(32.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.705),(32.735,3.875),(32.905,3.875),(32.905,3.705),(32.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.705),(33.095,3.875),(33.265,3.875),(33.265,3.705),(33.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.705),(33.455,3.875),(33.625,3.875),(33.625,3.705),(33.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.065),(32.375,4.235),(32.545,4.235),(32.545,4.065),(32.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.065),(32.735,4.235),(32.905,4.235),(32.905,4.065),(32.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.065),(33.095,4.235),(33.265,4.235),(33.265,4.065),(33.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.065),(33.455,4.235),(33.625,4.235),(33.625,4.065),(33.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.425),(32.375,4.595),(32.545,4.595),(32.545,4.425),(32.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.425),(32.735,4.595),(32.905,4.595),(32.905,4.425),(32.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.425),(33.095,4.595),(33.265,4.595),(33.265,4.425),(33.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.425),(33.455,4.595),(33.625,4.595),(33.625,4.425),(33.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.785),(32.375,4.955),(32.545,4.955),(32.545,4.785),(32.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.785),(32.735,4.955),(32.905,4.955),(32.905,4.785),(32.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.785),(33.095,4.955),(33.265,4.955),(33.265,4.785),(33.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.785),(33.455,4.955),(33.625,4.955),(33.625,4.785),(33.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.145),(32.375,5.315),(32.545,5.315),(32.545,5.145),(32.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.145),(32.735,5.315),(32.905,5.315),(32.905,5.145),(32.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.145),(33.095,5.315),(33.265,5.315),(33.265,5.145),(33.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.145),(33.455,5.315),(33.625,5.315),(33.625,5.145),(33.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.505),(32.375,5.675),(32.545,5.675),(32.545,5.505),(32.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.505),(32.735,5.675),(32.905,5.675),(32.905,5.505),(32.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.505),(33.095,5.675),(33.265,5.675),(33.265,5.505),(33.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.505),(33.455,5.675),(33.625,5.675),(33.625,5.505),(33.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.865),(32.375,6.035),(32.545,6.035),(32.545,5.865),(32.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.865),(32.735,6.035),(32.905,6.035),(32.905,5.865),(32.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.865),(33.095,6.035),(33.265,6.035),(33.265,5.865),(33.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.865),(33.455,6.035),(33.625,6.035),(33.625,5.865),(33.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.225),(32.375,6.395),(32.545,6.395),(32.545,6.225),(32.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.225),(32.735,6.395),(32.905,6.395),(32.905,6.225),(32.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.225),(33.095,6.395),(33.265,6.395),(33.265,6.225),(33.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.225),(33.455,6.395),(33.625,6.395),(33.625,6.225),(33.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.585),(32.375,6.755),(32.545,6.755),(32.545,6.585),(32.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.585),(32.735,6.755),(32.905,6.755),(32.905,6.585),(32.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.585),(33.095,6.755),(33.265,6.755),(33.265,6.585),(33.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.585),(33.455,6.755),(33.625,6.755),(33.625,6.585),(33.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.945),(32.375,7.115),(32.545,7.115),(32.545,6.945),(32.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.945),(32.735,7.115),(32.905,7.115),(32.905,6.945),(32.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.945),(33.095,7.115),(33.265,7.115),(33.265,6.945),(33.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.945),(33.455,7.115),(33.625,7.115),(33.625,6.945),(33.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.305),(32.375,7.475),(32.545,7.475),(32.545,7.305),(32.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.305),(32.735,7.475),(32.905,7.475),(32.905,7.305),(32.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.305),(33.095,7.475),(33.265,7.475),(33.265,7.305),(33.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.305),(33.455,7.475),(33.625,7.475),(33.625,7.305),(33.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.665),(32.375,7.835),(32.545,7.835),(32.545,7.665),(32.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.665),(32.735,7.835),(32.905,7.835),(32.905,7.665),(32.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.665),(33.095,7.835),(33.265,7.835),(33.265,7.665),(33.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.665),(33.455,7.835),(33.625,7.835),(33.625,7.665),(33.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.025),(32.375,8.195),(32.545,8.195),(32.545,8.025),(32.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.025),(32.735,8.195),(32.905,8.195),(32.905,8.025),(32.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.025),(33.095,8.195),(33.265,8.195),(33.265,8.025),(33.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.025),(33.455,8.195),(33.625,8.195),(33.625,8.025),(33.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.385),(32.375,8.555),(32.545,8.555),(32.545,8.385),(32.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.385),(32.735,8.555),(32.905,8.555),(32.905,8.385),(32.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.385),(33.095,8.555),(33.265,8.555),(33.265,8.385),(33.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.385),(33.455,8.555),(33.625,8.555),(33.625,8.385),(33.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.745),(32.375,8.915),(32.545,8.915),(32.545,8.745),(32.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.745),(32.735,8.915),(32.905,8.915),(32.905,8.745),(32.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.745),(33.095,8.915),(33.265,8.915),(33.265,8.745),(33.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.745),(33.455,8.915),(33.625,8.915),(33.625,8.745),(33.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.105),(32.375,9.275),(32.545,9.275),(32.545,9.105),(32.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.105),(32.735,9.275),(32.905,9.275),(32.905,9.105),(32.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.105),(33.095,9.275),(33.265,9.275),(33.265,9.105),(33.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.105),(33.455,9.275),(33.625,9.275),(33.625,9.105),(33.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.465),(32.375,9.635),(32.545,9.635),(32.545,9.465),(32.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.465),(32.735,9.635),(32.905,9.635),(32.905,9.465),(32.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.465),(33.095,9.635),(33.265,9.635),(33.265,9.465),(33.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.465),(33.455,9.635),(33.625,9.635),(33.625,9.465),(33.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.825),(32.375,9.995),(32.545,9.995),(32.545,9.825),(32.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.825),(32.735,9.995),(32.905,9.995),(32.905,9.825),(32.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.825),(33.095,9.995),(33.265,9.995),(33.265,9.825),(33.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.825),(33.455,9.995),(33.625,9.995),(33.625,9.825),(33.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.185),(32.375,10.355),(32.545,10.355),(32.545,10.185),(32.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.185),(32.735,10.355),(32.905,10.355),(32.905,10.185),(32.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.185),(33.095,10.355),(33.265,10.355),(33.265,10.185),(33.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.185),(33.455,10.355),(33.625,10.355),(33.625,10.185),(33.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.545),(32.375,10.715),(32.545,10.715),(32.545,10.545),(32.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.545),(32.735,10.715),(32.905,10.715),(32.905,10.545),(32.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.545),(33.095,10.715),(33.265,10.715),(33.265,10.545),(33.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.545),(33.455,10.715),(33.625,10.715),(33.625,10.545),(33.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.905),(32.375,11.075),(32.545,11.075),(32.545,10.905),(32.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.905),(32.735,11.075),(32.905,11.075),(32.905,10.905),(32.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.905),(33.095,11.075),(33.265,11.075),(33.265,10.905),(33.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.905),(33.455,11.075),(33.625,11.075),(33.625,10.905),(33.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.265),(32.375,11.435),(32.545,11.435),(32.545,11.265),(32.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.265),(32.735,11.435),(32.905,11.435),(32.905,11.265),(32.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.265),(33.095,11.435),(33.265,11.435),(33.265,11.265),(33.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.265),(33.455,11.435),(33.625,11.435),(33.625,11.265),(33.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.625),(32.375,11.795),(32.545,11.795),(32.545,11.625),(32.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.625),(32.735,11.795),(32.905,11.795),(32.905,11.625),(32.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.625),(33.095,11.795),(33.265,11.795),(33.265,11.625),(33.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.625),(33.455,11.795),(33.625,11.795),(33.625,11.625),(33.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.985),(32.375,12.155),(32.545,12.155),(32.545,11.985),(32.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.985),(32.735,12.155),(32.905,12.155),(32.905,11.985),(32.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.985),(33.095,12.155),(33.265,12.155),(33.265,11.985),(33.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.985),(33.455,12.155),(33.625,12.155),(33.625,11.985),(33.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.345),(32.375,12.515),(32.545,12.515),(32.545,12.345),(32.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.345),(32.735,12.515),(32.905,12.515),(32.905,12.345),(32.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.345),(33.095,12.515),(33.265,12.515),(33.265,12.345),(33.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.345),(33.455,12.515),(33.625,12.515),(33.625,12.345),(33.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.705),(32.375,12.875),(32.545,12.875),(32.545,12.705),(32.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.705),(32.735,12.875),(32.905,12.875),(32.905,12.705),(32.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.705),(33.095,12.875),(33.265,12.875),(33.265,12.705),(33.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.705),(33.455,12.875),(33.625,12.875),(33.625,12.705),(33.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.065),(32.375,13.235),(32.545,13.235),(32.545,13.065),(32.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.065),(32.735,13.235),(32.905,13.235),(32.905,13.065),(32.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.065),(33.095,13.235),(33.265,13.235),(33.265,13.065),(33.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.065),(33.455,13.235),(33.625,13.235),(33.625,13.065),(33.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.425),(32.375,13.595),(32.545,13.595),(32.545,13.425),(32.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.425),(32.735,13.595),(32.905,13.595),(32.905,13.425),(32.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.425),(33.095,13.595),(33.265,13.595),(33.265,13.425),(33.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.425),(33.455,13.595),(33.625,13.595),(33.625,13.425),(33.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.785),(32.375,13.955),(32.545,13.955),(32.545,13.785),(32.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.785),(32.735,13.955),(32.905,13.955),(32.905,13.785),(32.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.785),(33.095,13.955),(33.265,13.955),(33.265,13.785),(33.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.785),(33.455,13.955),(33.625,13.955),(33.625,13.785),(33.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.145),(32.375,14.315),(32.545,14.315),(32.545,14.145),(32.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.145),(32.735,14.315),(32.905,14.315),(32.905,14.145),(32.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.145),(33.095,14.315),(33.265,14.315),(33.265,14.145),(33.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.145),(33.455,14.315),(33.625,14.315),(33.625,14.145),(33.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.505),(32.375,14.675),(32.545,14.675),(32.545,14.505),(32.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.505),(32.735,14.675),(32.905,14.675),(32.905,14.505),(32.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.505),(33.095,14.675),(33.265,14.675),(33.265,14.505),(33.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.505),(33.455,14.675),(33.625,14.675),(33.625,14.505),(33.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.865),(32.375,15.035),(32.545,15.035),(32.545,14.865),(32.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.865),(32.735,15.035),(32.905,15.035),(32.905,14.865),(32.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.865),(33.095,15.035),(33.265,15.035),(33.265,14.865),(33.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.865),(33.455,15.035),(33.625,15.035),(33.625,14.865),(33.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.225),(32.375,15.395),(32.545,15.395),(32.545,15.225),(32.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.225),(32.735,15.395),(32.905,15.395),(32.905,15.225),(32.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.225),(33.095,15.395),(33.265,15.395),(33.265,15.225),(33.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.225),(33.455,15.395),(33.625,15.395),(33.625,15.225),(33.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.585),(32.375,15.755),(32.545,15.755),(32.545,15.585),(32.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.585),(32.735,15.755),(32.905,15.755),(32.905,15.585),(32.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.585),(33.095,15.755),(33.265,15.755),(33.265,15.585),(33.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.585),(33.455,15.755),(33.625,15.755),(33.625,15.585),(33.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.945),(32.375,16.115),(32.545,16.115),(32.545,15.945),(32.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.945),(32.735,16.115),(32.905,16.115),(32.905,15.945),(32.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.945),(33.095,16.115),(33.265,16.115),(33.265,15.945),(33.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.945),(33.455,16.115),(33.625,16.115),(33.625,15.945),(33.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.305),(32.375,16.475),(32.545,16.475),(32.545,16.305),(32.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.305),(32.735,16.475),(32.905,16.475),(32.905,16.305),(32.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.305),(33.095,16.475),(33.265,16.475),(33.265,16.305),(33.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.305),(33.455,16.475),(33.625,16.475),(33.625,16.305),(33.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.665),(32.375,16.835),(32.545,16.835),(32.545,16.665),(32.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.665),(32.735,16.835),(32.905,16.835),(32.905,16.665),(32.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.665),(33.095,16.835),(33.265,16.835),(33.265,16.665),(33.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.665),(33.455,16.835),(33.625,16.835),(33.625,16.665),(33.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.025),(32.375,17.195),(32.545,17.195),(32.545,17.025),(32.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.025),(32.735,17.195),(32.905,17.195),(32.905,17.025),(32.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.025),(33.095,17.195),(33.265,17.195),(33.265,17.025),(33.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.025),(33.455,17.195),(33.625,17.195),(33.625,17.025),(33.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.385),(32.375,17.555),(32.545,17.555),(32.545,17.385),(32.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.385),(32.735,17.555),(32.905,17.555),(32.905,17.385),(32.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.385),(33.095,17.555),(33.265,17.555),(33.265,17.385),(33.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.385),(33.455,17.555),(33.625,17.555),(33.625,17.385),(33.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.745),(32.375,17.915),(32.545,17.915),(32.545,17.745),(32.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.745),(32.735,17.915),(32.905,17.915),(32.905,17.745),(32.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.745),(33.095,17.915),(33.265,17.915),(33.265,17.745),(33.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.745),(33.455,17.915),(33.625,17.915),(33.625,17.745),(33.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.105),(32.375,18.275),(32.545,18.275),(32.545,18.105),(32.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.105),(32.735,18.275),(32.905,18.275),(32.905,18.105),(32.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.105),(33.095,18.275),(33.265,18.275),(33.265,18.105),(33.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.105),(33.455,18.275),(33.625,18.275),(33.625,18.105),(33.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.465),(32.375,18.635),(32.545,18.635),(32.545,18.465),(32.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.465),(32.735,18.635),(32.905,18.635),(32.905,18.465),(32.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.465),(33.095,18.635),(33.265,18.635),(33.265,18.465),(33.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.465),(33.455,18.635),(33.625,18.635),(33.625,18.465),(33.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.825),(32.375,18.995),(32.545,18.995),(32.545,18.825),(32.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.825),(32.735,18.995),(32.905,18.995),(32.905,18.825),(32.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.825),(33.095,18.995),(33.265,18.995),(33.265,18.825),(33.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.825),(33.455,18.995),(33.625,18.995),(33.625,18.825),(33.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.185),(32.375,19.355),(32.545,19.355),(32.545,19.185),(32.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.185),(32.735,19.355),(32.905,19.355),(32.905,19.185),(32.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.185),(33.095,19.355),(33.265,19.355),(33.265,19.185),(33.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.185),(33.455,19.355),(33.625,19.355),(33.625,19.185),(33.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,2.985),(61.175,3.155),(61.345,3.155),(61.345,2.985),(61.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,2.985),(61.535,3.155),(61.705,3.155),(61.705,2.985),(61.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,2.985),(61.895,3.155),(62.065,3.155),(62.065,2.985),(61.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,2.985),(62.255,3.155),(62.425,3.155),(62.425,2.985),(62.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.345),(61.175,3.515),(61.345,3.515),(61.345,3.345),(61.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.345),(61.535,3.515),(61.705,3.515),(61.705,3.345),(61.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.345),(61.895,3.515),(62.065,3.515),(62.065,3.345),(61.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.345),(62.255,3.515),(62.425,3.515),(62.425,3.345),(62.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,3.705),(61.175,3.875),(61.345,3.875),(61.345,3.705),(61.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,3.705),(61.535,3.875),(61.705,3.875),(61.705,3.705),(61.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,3.705),(61.895,3.875),(62.065,3.875),(62.065,3.705),(61.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,3.705),(62.255,3.875),(62.425,3.875),(62.425,3.705),(62.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.065),(61.175,4.235),(61.345,4.235),(61.345,4.065),(61.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.065),(61.535,4.235),(61.705,4.235),(61.705,4.065),(61.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.065),(61.895,4.235),(62.065,4.235),(62.065,4.065),(61.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.065),(62.255,4.235),(62.425,4.235),(62.425,4.065),(62.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.425),(61.175,4.595),(61.345,4.595),(61.345,4.425),(61.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.425),(61.535,4.595),(61.705,4.595),(61.705,4.425),(61.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.425),(61.895,4.595),(62.065,4.595),(62.065,4.425),(61.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.425),(62.255,4.595),(62.425,4.595),(62.425,4.425),(62.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,4.785),(61.175,4.955),(61.345,4.955),(61.345,4.785),(61.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,4.785),(61.535,4.955),(61.705,4.955),(61.705,4.785),(61.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,4.785),(61.895,4.955),(62.065,4.955),(62.065,4.785),(61.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,4.785),(62.255,4.955),(62.425,4.955),(62.425,4.785),(62.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.145),(61.175,5.315),(61.345,5.315),(61.345,5.145),(61.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.145),(61.535,5.315),(61.705,5.315),(61.705,5.145),(61.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.145),(61.895,5.315),(62.065,5.315),(62.065,5.145),(61.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.145),(62.255,5.315),(62.425,5.315),(62.425,5.145),(62.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.505),(61.175,5.675),(61.345,5.675),(61.345,5.505),(61.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.505),(61.535,5.675),(61.705,5.675),(61.705,5.505),(61.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.505),(61.895,5.675),(62.065,5.675),(62.065,5.505),(61.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.505),(62.255,5.675),(62.425,5.675),(62.425,5.505),(62.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,5.865),(61.175,6.035),(61.345,6.035),(61.345,5.865),(61.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,5.865),(61.535,6.035),(61.705,6.035),(61.705,5.865),(61.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,5.865),(61.895,6.035),(62.065,6.035),(62.065,5.865),(61.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,5.865),(62.255,6.035),(62.425,6.035),(62.425,5.865),(62.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.225),(61.175,6.395),(61.345,6.395),(61.345,6.225),(61.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.225),(61.535,6.395),(61.705,6.395),(61.705,6.225),(61.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.225),(61.895,6.395),(62.065,6.395),(62.065,6.225),(61.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.225),(62.255,6.395),(62.425,6.395),(62.425,6.225),(62.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.585),(61.175,6.755),(61.345,6.755),(61.345,6.585),(61.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.585),(61.535,6.755),(61.705,6.755),(61.705,6.585),(61.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.585),(61.895,6.755),(62.065,6.755),(62.065,6.585),(61.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.585),(62.255,6.755),(62.425,6.755),(62.425,6.585),(62.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,6.945),(61.175,7.115),(61.345,7.115),(61.345,6.945),(61.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,6.945),(61.535,7.115),(61.705,7.115),(61.705,6.945),(61.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,6.945),(61.895,7.115),(62.065,7.115),(62.065,6.945),(61.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,6.945),(62.255,7.115),(62.425,7.115),(62.425,6.945),(62.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.305),(61.175,7.475),(61.345,7.475),(61.345,7.305),(61.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.305),(61.535,7.475),(61.705,7.475),(61.705,7.305),(61.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.305),(61.895,7.475),(62.065,7.475),(62.065,7.305),(61.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.305),(62.255,7.475),(62.425,7.475),(62.425,7.305),(62.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,7.665),(61.175,7.835),(61.345,7.835),(61.345,7.665),(61.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,7.665),(61.535,7.835),(61.705,7.835),(61.705,7.665),(61.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,7.665),(61.895,7.835),(62.065,7.835),(62.065,7.665),(61.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,7.665),(62.255,7.835),(62.425,7.835),(62.425,7.665),(62.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.025),(61.175,8.195),(61.345,8.195),(61.345,8.025),(61.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.025),(61.535,8.195),(61.705,8.195),(61.705,8.025),(61.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.025),(61.895,8.195),(62.065,8.195),(62.065,8.025),(61.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.025),(62.255,8.195),(62.425,8.195),(62.425,8.025),(62.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.385),(61.175,8.555),(61.345,8.555),(61.345,8.385),(61.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.385),(61.535,8.555),(61.705,8.555),(61.705,8.385),(61.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.385),(61.895,8.555),(62.065,8.555),(62.065,8.385),(61.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.385),(62.255,8.555),(62.425,8.555),(62.425,8.385),(62.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,8.745),(61.175,8.915),(61.345,8.915),(61.345,8.745),(61.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,8.745),(61.535,8.915),(61.705,8.915),(61.705,8.745),(61.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,8.745),(61.895,8.915),(62.065,8.915),(62.065,8.745),(61.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,8.745),(62.255,8.915),(62.425,8.915),(62.425,8.745),(62.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.105),(61.175,9.275),(61.345,9.275),(61.345,9.105),(61.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.105),(61.535,9.275),(61.705,9.275),(61.705,9.105),(61.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.105),(61.895,9.275),(62.065,9.275),(62.065,9.105),(61.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.105),(62.255,9.275),(62.425,9.275),(62.425,9.105),(62.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.465),(61.175,9.635),(61.345,9.635),(61.345,9.465),(61.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.465),(61.535,9.635),(61.705,9.635),(61.705,9.465),(61.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.465),(61.895,9.635),(62.065,9.635),(62.065,9.465),(61.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.465),(62.255,9.635),(62.425,9.635),(62.425,9.465),(62.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,9.825),(61.175,9.995),(61.345,9.995),(61.345,9.825),(61.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,9.825),(61.535,9.995),(61.705,9.995),(61.705,9.825),(61.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,9.825),(61.895,9.995),(62.065,9.995),(62.065,9.825),(61.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,9.825),(62.255,9.995),(62.425,9.995),(62.425,9.825),(62.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.185),(61.175,10.355),(61.345,10.355),(61.345,10.185),(61.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.185),(61.535,10.355),(61.705,10.355),(61.705,10.185),(61.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.185),(61.895,10.355),(62.065,10.355),(62.065,10.185),(61.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.185),(62.255,10.355),(62.425,10.355),(62.425,10.185),(62.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.545),(61.175,10.715),(61.345,10.715),(61.345,10.545),(61.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.545),(61.535,10.715),(61.705,10.715),(61.705,10.545),(61.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.545),(61.895,10.715),(62.065,10.715),(62.065,10.545),(61.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.545),(62.255,10.715),(62.425,10.715),(62.425,10.545),(62.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,10.905),(61.175,11.075),(61.345,11.075),(61.345,10.905),(61.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,10.905),(61.535,11.075),(61.705,11.075),(61.705,10.905),(61.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,10.905),(61.895,11.075),(62.065,11.075),(62.065,10.905),(61.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,10.905),(62.255,11.075),(62.425,11.075),(62.425,10.905),(62.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.265),(61.175,11.435),(61.345,11.435),(61.345,11.265),(61.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.265),(61.535,11.435),(61.705,11.435),(61.705,11.265),(61.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.265),(61.895,11.435),(62.065,11.435),(62.065,11.265),(61.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.265),(62.255,11.435),(62.425,11.435),(62.425,11.265),(62.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.625),(61.175,11.795),(61.345,11.795),(61.345,11.625),(61.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.625),(61.535,11.795),(61.705,11.795),(61.705,11.625),(61.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.625),(61.895,11.795),(62.065,11.795),(62.065,11.625),(61.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.625),(62.255,11.795),(62.425,11.795),(62.425,11.625),(62.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,11.985),(61.175,12.155),(61.345,12.155),(61.345,11.985),(61.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,11.985),(61.535,12.155),(61.705,12.155),(61.705,11.985),(61.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,11.985),(61.895,12.155),(62.065,12.155),(62.065,11.985),(61.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,11.985),(62.255,12.155),(62.425,12.155),(62.425,11.985),(62.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.345),(61.175,12.515),(61.345,12.515),(61.345,12.345),(61.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.345),(61.535,12.515),(61.705,12.515),(61.705,12.345),(61.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.345),(61.895,12.515),(62.065,12.515),(62.065,12.345),(61.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.345),(62.255,12.515),(62.425,12.515),(62.425,12.345),(62.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,12.705),(61.175,12.875),(61.345,12.875),(61.345,12.705),(61.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,12.705),(61.535,12.875),(61.705,12.875),(61.705,12.705),(61.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,12.705),(61.895,12.875),(62.065,12.875),(62.065,12.705),(61.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,12.705),(62.255,12.875),(62.425,12.875),(62.425,12.705),(62.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.065),(61.175,13.235),(61.345,13.235),(61.345,13.065),(61.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.065),(61.535,13.235),(61.705,13.235),(61.705,13.065),(61.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.065),(61.895,13.235),(62.065,13.235),(62.065,13.065),(61.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.065),(62.255,13.235),(62.425,13.235),(62.425,13.065),(62.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.425),(61.175,13.595),(61.345,13.595),(61.345,13.425),(61.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.425),(61.535,13.595),(61.705,13.595),(61.705,13.425),(61.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.425),(61.895,13.595),(62.065,13.595),(62.065,13.425),(61.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.425),(62.255,13.595),(62.425,13.595),(62.425,13.425),(62.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,13.785),(61.175,13.955),(61.345,13.955),(61.345,13.785),(61.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,13.785),(61.535,13.955),(61.705,13.955),(61.705,13.785),(61.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,13.785),(61.895,13.955),(62.065,13.955),(62.065,13.785),(61.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,13.785),(62.255,13.955),(62.425,13.955),(62.425,13.785),(62.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.145),(61.175,14.315),(61.345,14.315),(61.345,14.145),(61.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.145),(61.535,14.315),(61.705,14.315),(61.705,14.145),(61.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.145),(61.895,14.315),(62.065,14.315),(62.065,14.145),(61.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.145),(62.255,14.315),(62.425,14.315),(62.425,14.145),(62.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.505),(61.175,14.675),(61.345,14.675),(61.345,14.505),(61.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.505),(61.535,14.675),(61.705,14.675),(61.705,14.505),(61.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.505),(61.895,14.675),(62.065,14.675),(62.065,14.505),(61.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.505),(62.255,14.675),(62.425,14.675),(62.425,14.505),(62.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,14.865),(61.175,15.035),(61.345,15.035),(61.345,14.865),(61.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,14.865),(61.535,15.035),(61.705,15.035),(61.705,14.865),(61.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,14.865),(61.895,15.035),(62.065,15.035),(62.065,14.865),(61.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,14.865),(62.255,15.035),(62.425,15.035),(62.425,14.865),(62.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.225),(61.175,15.395),(61.345,15.395),(61.345,15.225),(61.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.225),(61.535,15.395),(61.705,15.395),(61.705,15.225),(61.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.225),(61.895,15.395),(62.065,15.395),(62.065,15.225),(61.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.225),(62.255,15.395),(62.425,15.395),(62.425,15.225),(62.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.585),(61.175,15.755),(61.345,15.755),(61.345,15.585),(61.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.585),(61.535,15.755),(61.705,15.755),(61.705,15.585),(61.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.585),(61.895,15.755),(62.065,15.755),(62.065,15.585),(61.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.585),(62.255,15.755),(62.425,15.755),(62.425,15.585),(62.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,15.945),(61.175,16.115),(61.345,16.115),(61.345,15.945),(61.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,15.945),(61.535,16.115),(61.705,16.115),(61.705,15.945),(61.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,15.945),(61.895,16.115),(62.065,16.115),(62.065,15.945),(61.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,15.945),(62.255,16.115),(62.425,16.115),(62.425,15.945),(62.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.305),(61.175,16.475),(61.345,16.475),(61.345,16.305),(61.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.305),(61.535,16.475),(61.705,16.475),(61.705,16.305),(61.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.305),(61.895,16.475),(62.065,16.475),(62.065,16.305),(61.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.305),(62.255,16.475),(62.425,16.475),(62.425,16.305),(62.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,16.665),(61.175,16.835),(61.345,16.835),(61.345,16.665),(61.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,16.665),(61.535,16.835),(61.705,16.835),(61.705,16.665),(61.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,16.665),(61.895,16.835),(62.065,16.835),(62.065,16.665),(61.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,16.665),(62.255,16.835),(62.425,16.835),(62.425,16.665),(62.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.025),(61.175,17.195),(61.345,17.195),(61.345,17.025),(61.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.025),(61.535,17.195),(61.705,17.195),(61.705,17.025),(61.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.025),(61.895,17.195),(62.065,17.195),(62.065,17.025),(61.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.025),(62.255,17.195),(62.425,17.195),(62.425,17.025),(62.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.385),(61.175,17.555),(61.345,17.555),(61.345,17.385),(61.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.385),(61.535,17.555),(61.705,17.555),(61.705,17.385),(61.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.385),(61.895,17.555),(62.065,17.555),(62.065,17.385),(61.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.385),(62.255,17.555),(62.425,17.555),(62.425,17.385),(62.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,17.745),(61.175,17.915),(61.345,17.915),(61.345,17.745),(61.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,17.745),(61.535,17.915),(61.705,17.915),(61.705,17.745),(61.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,17.745),(61.895,17.915),(62.065,17.915),(62.065,17.745),(61.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,17.745),(62.255,17.915),(62.425,17.915),(62.425,17.745),(62.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.105),(61.175,18.275),(61.345,18.275),(61.345,18.105),(61.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.105),(61.535,18.275),(61.705,18.275),(61.705,18.105),(61.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.105),(61.895,18.275),(62.065,18.275),(62.065,18.105),(61.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.105),(62.255,18.275),(62.425,18.275),(62.425,18.105),(62.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.465),(61.175,18.635),(61.345,18.635),(61.345,18.465),(61.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.465),(61.535,18.635),(61.705,18.635),(61.705,18.465),(61.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.465),(61.895,18.635),(62.065,18.635),(62.065,18.465),(61.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.465),(62.255,18.635),(62.425,18.635),(62.425,18.465),(62.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,18.825),(61.175,18.995),(61.345,18.995),(61.345,18.825),(61.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,18.825),(61.535,18.995),(61.705,18.995),(61.705,18.825),(61.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,18.825),(61.895,18.995),(62.065,18.995),(62.065,18.825),(61.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,18.825),(62.255,18.995),(62.425,18.995),(62.425,18.825),(62.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.175,19.185),(61.175,19.355),(61.345,19.355),(61.345,19.185),(61.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.535,19.185),(61.535,19.355),(61.705,19.355),(61.705,19.185),(61.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.895,19.185),(61.895,19.355),(62.065,19.355),(62.065,19.185),(61.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.255,19.185),(62.255,19.355),(62.425,19.355),(62.425,19.185),(62.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.985),(51.575,3.155),(51.745,3.155),(51.745,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.985),(51.935,3.155),(52.105,3.155),(52.105,2.985),(51.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.985),(52.295,3.155),(52.465,3.155),(52.465,2.985),(52.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.985),(52.655,3.155),(52.825,3.155),(52.825,2.985),(52.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.345),(51.575,3.515),(51.745,3.515),(51.745,3.345),(51.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.345),(51.935,3.515),(52.105,3.515),(52.105,3.345),(51.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.345),(52.295,3.515),(52.465,3.515),(52.465,3.345),(52.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.345),(52.655,3.515),(52.825,3.515),(52.825,3.345),(52.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.705),(51.575,3.875),(51.745,3.875),(51.745,3.705),(51.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.705),(51.935,3.875),(52.105,3.875),(52.105,3.705),(51.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.705),(52.295,3.875),(52.465,3.875),(52.465,3.705),(52.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.705),(52.655,3.875),(52.825,3.875),(52.825,3.705),(52.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.065),(51.575,4.235),(51.745,4.235),(51.745,4.065),(51.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.065),(51.935,4.235),(52.105,4.235),(52.105,4.065),(51.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.065),(52.295,4.235),(52.465,4.235),(52.465,4.065),(52.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.065),(52.655,4.235),(52.825,4.235),(52.825,4.065),(52.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.425),(51.575,4.595),(51.745,4.595),(51.745,4.425),(51.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.425),(51.935,4.595),(52.105,4.595),(52.105,4.425),(51.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.425),(52.295,4.595),(52.465,4.595),(52.465,4.425),(52.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.425),(52.655,4.595),(52.825,4.595),(52.825,4.425),(52.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.785),(51.575,4.955),(51.745,4.955),(51.745,4.785),(51.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.785),(51.935,4.955),(52.105,4.955),(52.105,4.785),(51.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.785),(52.295,4.955),(52.465,4.955),(52.465,4.785),(52.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.785),(52.655,4.955),(52.825,4.955),(52.825,4.785),(52.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.145),(51.575,5.315),(51.745,5.315),(51.745,5.145),(51.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.145),(51.935,5.315),(52.105,5.315),(52.105,5.145),(51.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.145),(52.295,5.315),(52.465,5.315),(52.465,5.145),(52.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.145),(52.655,5.315),(52.825,5.315),(52.825,5.145),(52.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.505),(51.575,5.675),(51.745,5.675),(51.745,5.505),(51.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.505),(51.935,5.675),(52.105,5.675),(52.105,5.505),(51.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.505),(52.295,5.675),(52.465,5.675),(52.465,5.505),(52.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.505),(52.655,5.675),(52.825,5.675),(52.825,5.505),(52.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.865),(51.575,6.035),(51.745,6.035),(51.745,5.865),(51.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.865),(51.935,6.035),(52.105,6.035),(52.105,5.865),(51.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.865),(52.295,6.035),(52.465,6.035),(52.465,5.865),(52.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.865),(52.655,6.035),(52.825,6.035),(52.825,5.865),(52.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.225),(51.575,6.395),(51.745,6.395),(51.745,6.225),(51.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.225),(51.935,6.395),(52.105,6.395),(52.105,6.225),(51.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.225),(52.295,6.395),(52.465,6.395),(52.465,6.225),(52.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.225),(52.655,6.395),(52.825,6.395),(52.825,6.225),(52.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.585),(51.575,6.755),(51.745,6.755),(51.745,6.585),(51.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.585),(51.935,6.755),(52.105,6.755),(52.105,6.585),(51.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.585),(52.295,6.755),(52.465,6.755),(52.465,6.585),(52.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.585),(52.655,6.755),(52.825,6.755),(52.825,6.585),(52.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.945),(51.575,7.115),(51.745,7.115),(51.745,6.945),(51.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.945),(51.935,7.115),(52.105,7.115),(52.105,6.945),(51.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.945),(52.295,7.115),(52.465,7.115),(52.465,6.945),(52.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.945),(52.655,7.115),(52.825,7.115),(52.825,6.945),(52.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.305),(51.575,7.475),(51.745,7.475),(51.745,7.305),(51.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.305),(51.935,7.475),(52.105,7.475),(52.105,7.305),(51.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.305),(52.295,7.475),(52.465,7.475),(52.465,7.305),(52.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.305),(52.655,7.475),(52.825,7.475),(52.825,7.305),(52.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.665),(51.575,7.835),(51.745,7.835),(51.745,7.665),(51.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.665),(51.935,7.835),(52.105,7.835),(52.105,7.665),(51.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.665),(52.295,7.835),(52.465,7.835),(52.465,7.665),(52.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.665),(52.655,7.835),(52.825,7.835),(52.825,7.665),(52.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.025),(51.575,8.195),(51.745,8.195),(51.745,8.025),(51.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.025),(51.935,8.195),(52.105,8.195),(52.105,8.025),(51.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.025),(52.295,8.195),(52.465,8.195),(52.465,8.025),(52.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.025),(52.655,8.195),(52.825,8.195),(52.825,8.025),(52.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.385),(51.575,8.555),(51.745,8.555),(51.745,8.385),(51.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.385),(51.935,8.555),(52.105,8.555),(52.105,8.385),(51.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.385),(52.295,8.555),(52.465,8.555),(52.465,8.385),(52.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.385),(52.655,8.555),(52.825,8.555),(52.825,8.385),(52.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.745),(51.575,8.915),(51.745,8.915),(51.745,8.745),(51.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.745),(51.935,8.915),(52.105,8.915),(52.105,8.745),(51.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.745),(52.295,8.915),(52.465,8.915),(52.465,8.745),(52.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.745),(52.655,8.915),(52.825,8.915),(52.825,8.745),(52.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.105),(51.575,9.275),(51.745,9.275),(51.745,9.105),(51.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.105),(51.935,9.275),(52.105,9.275),(52.105,9.105),(51.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.105),(52.295,9.275),(52.465,9.275),(52.465,9.105),(52.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.105),(52.655,9.275),(52.825,9.275),(52.825,9.105),(52.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.465),(51.575,9.635),(51.745,9.635),(51.745,9.465),(51.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.465),(51.935,9.635),(52.105,9.635),(52.105,9.465),(51.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.465),(52.295,9.635),(52.465,9.635),(52.465,9.465),(52.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.465),(52.655,9.635),(52.825,9.635),(52.825,9.465),(52.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.825),(51.575,9.995),(51.745,9.995),(51.745,9.825),(51.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.825),(51.935,9.995),(52.105,9.995),(52.105,9.825),(51.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.825),(52.295,9.995),(52.465,9.995),(52.465,9.825),(52.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.825),(52.655,9.995),(52.825,9.995),(52.825,9.825),(52.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.185),(51.575,10.355),(51.745,10.355),(51.745,10.185),(51.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.185),(51.935,10.355),(52.105,10.355),(52.105,10.185),(51.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.185),(52.295,10.355),(52.465,10.355),(52.465,10.185),(52.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.185),(52.655,10.355),(52.825,10.355),(52.825,10.185),(52.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.545),(51.575,10.715),(51.745,10.715),(51.745,10.545),(51.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.545),(51.935,10.715),(52.105,10.715),(52.105,10.545),(51.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.545),(52.295,10.715),(52.465,10.715),(52.465,10.545),(52.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.545),(52.655,10.715),(52.825,10.715),(52.825,10.545),(52.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.905),(51.575,11.075),(51.745,11.075),(51.745,10.905),(51.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.905),(51.935,11.075),(52.105,11.075),(52.105,10.905),(51.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.905),(52.295,11.075),(52.465,11.075),(52.465,10.905),(52.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.905),(52.655,11.075),(52.825,11.075),(52.825,10.905),(52.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.265),(51.575,11.435),(51.745,11.435),(51.745,11.265),(51.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.265),(51.935,11.435),(52.105,11.435),(52.105,11.265),(51.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.265),(52.295,11.435),(52.465,11.435),(52.465,11.265),(52.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.265),(52.655,11.435),(52.825,11.435),(52.825,11.265),(52.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.625),(51.575,11.795),(51.745,11.795),(51.745,11.625),(51.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.625),(51.935,11.795),(52.105,11.795),(52.105,11.625),(51.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.625),(52.295,11.795),(52.465,11.795),(52.465,11.625),(52.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.625),(52.655,11.795),(52.825,11.795),(52.825,11.625),(52.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.985),(51.575,12.155),(51.745,12.155),(51.745,11.985),(51.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.985),(51.935,12.155),(52.105,12.155),(52.105,11.985),(51.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.985),(52.295,12.155),(52.465,12.155),(52.465,11.985),(52.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.985),(52.655,12.155),(52.825,12.155),(52.825,11.985),(52.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.345),(51.575,12.515),(51.745,12.515),(51.745,12.345),(51.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.345),(51.935,12.515),(52.105,12.515),(52.105,12.345),(51.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.345),(52.295,12.515),(52.465,12.515),(52.465,12.345),(52.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.345),(52.655,12.515),(52.825,12.515),(52.825,12.345),(52.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.705),(51.575,12.875),(51.745,12.875),(51.745,12.705),(51.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.705),(51.935,12.875),(52.105,12.875),(52.105,12.705),(51.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.705),(52.295,12.875),(52.465,12.875),(52.465,12.705),(52.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.705),(52.655,12.875),(52.825,12.875),(52.825,12.705),(52.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.065),(51.575,13.235),(51.745,13.235),(51.745,13.065),(51.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.065),(51.935,13.235),(52.105,13.235),(52.105,13.065),(51.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.065),(52.295,13.235),(52.465,13.235),(52.465,13.065),(52.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.065),(52.655,13.235),(52.825,13.235),(52.825,13.065),(52.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.425),(51.575,13.595),(51.745,13.595),(51.745,13.425),(51.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.425),(51.935,13.595),(52.105,13.595),(52.105,13.425),(51.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.425),(52.295,13.595),(52.465,13.595),(52.465,13.425),(52.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.425),(52.655,13.595),(52.825,13.595),(52.825,13.425),(52.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.785),(51.575,13.955),(51.745,13.955),(51.745,13.785),(51.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.785),(51.935,13.955),(52.105,13.955),(52.105,13.785),(51.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.785),(52.295,13.955),(52.465,13.955),(52.465,13.785),(52.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.785),(52.655,13.955),(52.825,13.955),(52.825,13.785),(52.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.145),(51.575,14.315),(51.745,14.315),(51.745,14.145),(51.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.145),(51.935,14.315),(52.105,14.315),(52.105,14.145),(51.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.145),(52.295,14.315),(52.465,14.315),(52.465,14.145),(52.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.145),(52.655,14.315),(52.825,14.315),(52.825,14.145),(52.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.505),(51.575,14.675),(51.745,14.675),(51.745,14.505),(51.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.505),(51.935,14.675),(52.105,14.675),(52.105,14.505),(51.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.505),(52.295,14.675),(52.465,14.675),(52.465,14.505),(52.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.505),(52.655,14.675),(52.825,14.675),(52.825,14.505),(52.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.865),(51.575,15.035),(51.745,15.035),(51.745,14.865),(51.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.865),(51.935,15.035),(52.105,15.035),(52.105,14.865),(51.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.865),(52.295,15.035),(52.465,15.035),(52.465,14.865),(52.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.865),(52.655,15.035),(52.825,15.035),(52.825,14.865),(52.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.225),(51.575,15.395),(51.745,15.395),(51.745,15.225),(51.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.225),(51.935,15.395),(52.105,15.395),(52.105,15.225),(51.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.225),(52.295,15.395),(52.465,15.395),(52.465,15.225),(52.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.225),(52.655,15.395),(52.825,15.395),(52.825,15.225),(52.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.585),(51.575,15.755),(51.745,15.755),(51.745,15.585),(51.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.585),(51.935,15.755),(52.105,15.755),(52.105,15.585),(51.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.585),(52.295,15.755),(52.465,15.755),(52.465,15.585),(52.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.585),(52.655,15.755),(52.825,15.755),(52.825,15.585),(52.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.945),(51.575,16.115),(51.745,16.115),(51.745,15.945),(51.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.945),(51.935,16.115),(52.105,16.115),(52.105,15.945),(51.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.945),(52.295,16.115),(52.465,16.115),(52.465,15.945),(52.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.945),(52.655,16.115),(52.825,16.115),(52.825,15.945),(52.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.305),(51.575,16.475),(51.745,16.475),(51.745,16.305),(51.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.305),(51.935,16.475),(52.105,16.475),(52.105,16.305),(51.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.305),(52.295,16.475),(52.465,16.475),(52.465,16.305),(52.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.305),(52.655,16.475),(52.825,16.475),(52.825,16.305),(52.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.665),(51.575,16.835),(51.745,16.835),(51.745,16.665),(51.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.665),(51.935,16.835),(52.105,16.835),(52.105,16.665),(51.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.665),(52.295,16.835),(52.465,16.835),(52.465,16.665),(52.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.665),(52.655,16.835),(52.825,16.835),(52.825,16.665),(52.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.025),(51.575,17.195),(51.745,17.195),(51.745,17.025),(51.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.025),(51.935,17.195),(52.105,17.195),(52.105,17.025),(51.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.025),(52.295,17.195),(52.465,17.195),(52.465,17.025),(52.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.025),(52.655,17.195),(52.825,17.195),(52.825,17.025),(52.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.385),(51.575,17.555),(51.745,17.555),(51.745,17.385),(51.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.385),(51.935,17.555),(52.105,17.555),(52.105,17.385),(51.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.385),(52.295,17.555),(52.465,17.555),(52.465,17.385),(52.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.385),(52.655,17.555),(52.825,17.555),(52.825,17.385),(52.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.745),(51.575,17.915),(51.745,17.915),(51.745,17.745),(51.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.745),(51.935,17.915),(52.105,17.915),(52.105,17.745),(51.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.745),(52.295,17.915),(52.465,17.915),(52.465,17.745),(52.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.745),(52.655,17.915),(52.825,17.915),(52.825,17.745),(52.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.105),(51.575,18.275),(51.745,18.275),(51.745,18.105),(51.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.105),(51.935,18.275),(52.105,18.275),(52.105,18.105),(51.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.105),(52.295,18.275),(52.465,18.275),(52.465,18.105),(52.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.105),(52.655,18.275),(52.825,18.275),(52.825,18.105),(52.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.465),(51.575,18.635),(51.745,18.635),(51.745,18.465),(51.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.465),(51.935,18.635),(52.105,18.635),(52.105,18.465),(51.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.465),(52.295,18.635),(52.465,18.635),(52.465,18.465),(52.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.465),(52.655,18.635),(52.825,18.635),(52.825,18.465),(52.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.825),(51.575,18.995),(51.745,18.995),(51.745,18.825),(51.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.825),(51.935,18.995),(52.105,18.995),(52.105,18.825),(51.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.825),(52.295,18.995),(52.465,18.995),(52.465,18.825),(52.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.825),(52.655,18.995),(52.825,18.995),(52.825,18.825),(52.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.185),(51.575,19.355),(51.745,19.355),(51.745,19.185),(51.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.185),(51.935,19.355),(52.105,19.355),(52.105,19.185),(51.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.185),(52.295,19.355),(52.465,19.355),(52.465,19.185),(52.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.185),(52.655,19.355),(52.825,19.355),(52.825,19.185),(52.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.985),(37.175,3.155),(37.345,3.155),(37.345,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.985),(37.535,3.155),(37.705,3.155),(37.705,2.985),(37.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.985),(37.895,3.155),(38.065,3.155),(38.065,2.985),(37.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.985),(38.255,3.155),(38.425,3.155),(38.425,2.985),(38.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.345),(37.175,3.515),(37.345,3.515),(37.345,3.345),(37.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.345),(37.535,3.515),(37.705,3.515),(37.705,3.345),(37.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.345),(37.895,3.515),(38.065,3.515),(38.065,3.345),(37.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.345),(38.255,3.515),(38.425,3.515),(38.425,3.345),(38.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.705),(37.175,3.875),(37.345,3.875),(37.345,3.705),(37.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.705),(37.535,3.875),(37.705,3.875),(37.705,3.705),(37.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.705),(37.895,3.875),(38.065,3.875),(38.065,3.705),(37.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.705),(38.255,3.875),(38.425,3.875),(38.425,3.705),(38.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.065),(37.175,4.235),(37.345,4.235),(37.345,4.065),(37.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.065),(37.535,4.235),(37.705,4.235),(37.705,4.065),(37.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.065),(37.895,4.235),(38.065,4.235),(38.065,4.065),(37.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.065),(38.255,4.235),(38.425,4.235),(38.425,4.065),(38.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.425),(37.175,4.595),(37.345,4.595),(37.345,4.425),(37.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.425),(37.535,4.595),(37.705,4.595),(37.705,4.425),(37.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.425),(37.895,4.595),(38.065,4.595),(38.065,4.425),(37.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.425),(38.255,4.595),(38.425,4.595),(38.425,4.425),(38.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.785),(37.175,4.955),(37.345,4.955),(37.345,4.785),(37.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.785),(37.535,4.955),(37.705,4.955),(37.705,4.785),(37.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.785),(37.895,4.955),(38.065,4.955),(38.065,4.785),(37.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.785),(38.255,4.955),(38.425,4.955),(38.425,4.785),(38.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.145),(37.175,5.315),(37.345,5.315),(37.345,5.145),(37.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.145),(37.535,5.315),(37.705,5.315),(37.705,5.145),(37.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.145),(37.895,5.315),(38.065,5.315),(38.065,5.145),(37.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.145),(38.255,5.315),(38.425,5.315),(38.425,5.145),(38.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.505),(37.175,5.675),(37.345,5.675),(37.345,5.505),(37.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.505),(37.535,5.675),(37.705,5.675),(37.705,5.505),(37.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.505),(37.895,5.675),(38.065,5.675),(38.065,5.505),(37.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.505),(38.255,5.675),(38.425,5.675),(38.425,5.505),(38.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.865),(37.175,6.035),(37.345,6.035),(37.345,5.865),(37.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.865),(37.535,6.035),(37.705,6.035),(37.705,5.865),(37.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.865),(37.895,6.035),(38.065,6.035),(38.065,5.865),(37.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.865),(38.255,6.035),(38.425,6.035),(38.425,5.865),(38.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.225),(37.175,6.395),(37.345,6.395),(37.345,6.225),(37.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.225),(37.535,6.395),(37.705,6.395),(37.705,6.225),(37.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.225),(37.895,6.395),(38.065,6.395),(38.065,6.225),(37.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.225),(38.255,6.395),(38.425,6.395),(38.425,6.225),(38.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.585),(37.175,6.755),(37.345,6.755),(37.345,6.585),(37.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.585),(37.535,6.755),(37.705,6.755),(37.705,6.585),(37.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.585),(37.895,6.755),(38.065,6.755),(38.065,6.585),(37.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.585),(38.255,6.755),(38.425,6.755),(38.425,6.585),(38.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.945),(37.175,7.115),(37.345,7.115),(37.345,6.945),(37.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.945),(37.535,7.115),(37.705,7.115),(37.705,6.945),(37.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.945),(37.895,7.115),(38.065,7.115),(38.065,6.945),(37.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.945),(38.255,7.115),(38.425,7.115),(38.425,6.945),(38.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.305),(37.175,7.475),(37.345,7.475),(37.345,7.305),(37.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.305),(37.535,7.475),(37.705,7.475),(37.705,7.305),(37.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.305),(37.895,7.475),(38.065,7.475),(38.065,7.305),(37.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.305),(38.255,7.475),(38.425,7.475),(38.425,7.305),(38.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.665),(37.175,7.835),(37.345,7.835),(37.345,7.665),(37.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.665),(37.535,7.835),(37.705,7.835),(37.705,7.665),(37.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.665),(37.895,7.835),(38.065,7.835),(38.065,7.665),(37.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.665),(38.255,7.835),(38.425,7.835),(38.425,7.665),(38.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.025),(37.175,8.195),(37.345,8.195),(37.345,8.025),(37.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.025),(37.535,8.195),(37.705,8.195),(37.705,8.025),(37.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.025),(37.895,8.195),(38.065,8.195),(38.065,8.025),(37.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.025),(38.255,8.195),(38.425,8.195),(38.425,8.025),(38.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.385),(37.175,8.555),(37.345,8.555),(37.345,8.385),(37.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.385),(37.535,8.555),(37.705,8.555),(37.705,8.385),(37.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.385),(37.895,8.555),(38.065,8.555),(38.065,8.385),(37.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.385),(38.255,8.555),(38.425,8.555),(38.425,8.385),(38.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.745),(37.175,8.915),(37.345,8.915),(37.345,8.745),(37.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.745),(37.535,8.915),(37.705,8.915),(37.705,8.745),(37.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.745),(37.895,8.915),(38.065,8.915),(38.065,8.745),(37.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.745),(38.255,8.915),(38.425,8.915),(38.425,8.745),(38.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.105),(37.175,9.275),(37.345,9.275),(37.345,9.105),(37.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.105),(37.535,9.275),(37.705,9.275),(37.705,9.105),(37.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.105),(37.895,9.275),(38.065,9.275),(38.065,9.105),(37.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.105),(38.255,9.275),(38.425,9.275),(38.425,9.105),(38.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.465),(37.175,9.635),(37.345,9.635),(37.345,9.465),(37.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.465),(37.535,9.635),(37.705,9.635),(37.705,9.465),(37.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.465),(37.895,9.635),(38.065,9.635),(38.065,9.465),(37.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.465),(38.255,9.635),(38.425,9.635),(38.425,9.465),(38.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.825),(37.175,9.995),(37.345,9.995),(37.345,9.825),(37.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.825),(37.535,9.995),(37.705,9.995),(37.705,9.825),(37.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.825),(37.895,9.995),(38.065,9.995),(38.065,9.825),(37.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.825),(38.255,9.995),(38.425,9.995),(38.425,9.825),(38.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.185),(37.175,10.355),(37.345,10.355),(37.345,10.185),(37.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.185),(37.535,10.355),(37.705,10.355),(37.705,10.185),(37.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.185),(37.895,10.355),(38.065,10.355),(38.065,10.185),(37.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.185),(38.255,10.355),(38.425,10.355),(38.425,10.185),(38.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.545),(37.175,10.715),(37.345,10.715),(37.345,10.545),(37.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.545),(37.535,10.715),(37.705,10.715),(37.705,10.545),(37.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.545),(37.895,10.715),(38.065,10.715),(38.065,10.545),(37.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.545),(38.255,10.715),(38.425,10.715),(38.425,10.545),(38.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.905),(37.175,11.075),(37.345,11.075),(37.345,10.905),(37.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.905),(37.535,11.075),(37.705,11.075),(37.705,10.905),(37.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.905),(37.895,11.075),(38.065,11.075),(38.065,10.905),(37.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.905),(38.255,11.075),(38.425,11.075),(38.425,10.905),(38.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.265),(37.175,11.435),(37.345,11.435),(37.345,11.265),(37.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.265),(37.535,11.435),(37.705,11.435),(37.705,11.265),(37.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.265),(37.895,11.435),(38.065,11.435),(38.065,11.265),(37.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.265),(38.255,11.435),(38.425,11.435),(38.425,11.265),(38.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.625),(37.175,11.795),(37.345,11.795),(37.345,11.625),(37.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.625),(37.535,11.795),(37.705,11.795),(37.705,11.625),(37.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.625),(37.895,11.795),(38.065,11.795),(38.065,11.625),(37.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.625),(38.255,11.795),(38.425,11.795),(38.425,11.625),(38.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.985),(37.175,12.155),(37.345,12.155),(37.345,11.985),(37.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.985),(37.535,12.155),(37.705,12.155),(37.705,11.985),(37.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.985),(37.895,12.155),(38.065,12.155),(38.065,11.985),(37.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.985),(38.255,12.155),(38.425,12.155),(38.425,11.985),(38.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.345),(37.175,12.515),(37.345,12.515),(37.345,12.345),(37.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.345),(37.535,12.515),(37.705,12.515),(37.705,12.345),(37.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.345),(37.895,12.515),(38.065,12.515),(38.065,12.345),(37.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.345),(38.255,12.515),(38.425,12.515),(38.425,12.345),(38.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.705),(37.175,12.875),(37.345,12.875),(37.345,12.705),(37.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.705),(37.535,12.875),(37.705,12.875),(37.705,12.705),(37.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.705),(37.895,12.875),(38.065,12.875),(38.065,12.705),(37.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.705),(38.255,12.875),(38.425,12.875),(38.425,12.705),(38.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.065),(37.175,13.235),(37.345,13.235),(37.345,13.065),(37.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.065),(37.535,13.235),(37.705,13.235),(37.705,13.065),(37.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.065),(37.895,13.235),(38.065,13.235),(38.065,13.065),(37.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.065),(38.255,13.235),(38.425,13.235),(38.425,13.065),(38.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.425),(37.175,13.595),(37.345,13.595),(37.345,13.425),(37.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.425),(37.535,13.595),(37.705,13.595),(37.705,13.425),(37.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.425),(37.895,13.595),(38.065,13.595),(38.065,13.425),(37.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.425),(38.255,13.595),(38.425,13.595),(38.425,13.425),(38.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.785),(37.175,13.955),(37.345,13.955),(37.345,13.785),(37.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.785),(37.535,13.955),(37.705,13.955),(37.705,13.785),(37.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.785),(37.895,13.955),(38.065,13.955),(38.065,13.785),(37.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.785),(38.255,13.955),(38.425,13.955),(38.425,13.785),(38.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.145),(37.175,14.315),(37.345,14.315),(37.345,14.145),(37.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.145),(37.535,14.315),(37.705,14.315),(37.705,14.145),(37.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.145),(37.895,14.315),(38.065,14.315),(38.065,14.145),(37.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.145),(38.255,14.315),(38.425,14.315),(38.425,14.145),(38.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.505),(37.175,14.675),(37.345,14.675),(37.345,14.505),(37.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.505),(37.535,14.675),(37.705,14.675),(37.705,14.505),(37.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.505),(37.895,14.675),(38.065,14.675),(38.065,14.505),(37.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.505),(38.255,14.675),(38.425,14.675),(38.425,14.505),(38.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.865),(37.175,15.035),(37.345,15.035),(37.345,14.865),(37.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.865),(37.535,15.035),(37.705,15.035),(37.705,14.865),(37.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.865),(37.895,15.035),(38.065,15.035),(38.065,14.865),(37.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.865),(38.255,15.035),(38.425,15.035),(38.425,14.865),(38.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.225),(37.175,15.395),(37.345,15.395),(37.345,15.225),(37.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.225),(37.535,15.395),(37.705,15.395),(37.705,15.225),(37.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.225),(37.895,15.395),(38.065,15.395),(38.065,15.225),(37.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.225),(38.255,15.395),(38.425,15.395),(38.425,15.225),(38.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.585),(37.175,15.755),(37.345,15.755),(37.345,15.585),(37.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.585),(37.535,15.755),(37.705,15.755),(37.705,15.585),(37.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.585),(37.895,15.755),(38.065,15.755),(38.065,15.585),(37.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.585),(38.255,15.755),(38.425,15.755),(38.425,15.585),(38.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.945),(37.175,16.115),(37.345,16.115),(37.345,15.945),(37.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.945),(37.535,16.115),(37.705,16.115),(37.705,15.945),(37.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.945),(37.895,16.115),(38.065,16.115),(38.065,15.945),(37.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.945),(38.255,16.115),(38.425,16.115),(38.425,15.945),(38.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.305),(37.175,16.475),(37.345,16.475),(37.345,16.305),(37.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.305),(37.535,16.475),(37.705,16.475),(37.705,16.305),(37.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.305),(37.895,16.475),(38.065,16.475),(38.065,16.305),(37.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.305),(38.255,16.475),(38.425,16.475),(38.425,16.305),(38.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.665),(37.175,16.835),(37.345,16.835),(37.345,16.665),(37.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.665),(37.535,16.835),(37.705,16.835),(37.705,16.665),(37.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.665),(37.895,16.835),(38.065,16.835),(38.065,16.665),(37.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.665),(38.255,16.835),(38.425,16.835),(38.425,16.665),(38.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.025),(37.175,17.195),(37.345,17.195),(37.345,17.025),(37.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.025),(37.535,17.195),(37.705,17.195),(37.705,17.025),(37.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.025),(37.895,17.195),(38.065,17.195),(38.065,17.025),(37.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.025),(38.255,17.195),(38.425,17.195),(38.425,17.025),(38.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.385),(37.175,17.555),(37.345,17.555),(37.345,17.385),(37.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.385),(37.535,17.555),(37.705,17.555),(37.705,17.385),(37.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.385),(37.895,17.555),(38.065,17.555),(38.065,17.385),(37.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.385),(38.255,17.555),(38.425,17.555),(38.425,17.385),(38.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.745),(37.175,17.915),(37.345,17.915),(37.345,17.745),(37.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.745),(37.535,17.915),(37.705,17.915),(37.705,17.745),(37.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.745),(37.895,17.915),(38.065,17.915),(38.065,17.745),(37.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.745),(38.255,17.915),(38.425,17.915),(38.425,17.745),(38.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.105),(37.175,18.275),(37.345,18.275),(37.345,18.105),(37.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.105),(37.535,18.275),(37.705,18.275),(37.705,18.105),(37.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.105),(37.895,18.275),(38.065,18.275),(38.065,18.105),(37.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.105),(38.255,18.275),(38.425,18.275),(38.425,18.105),(38.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.465),(37.175,18.635),(37.345,18.635),(37.345,18.465),(37.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.465),(37.535,18.635),(37.705,18.635),(37.705,18.465),(37.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.465),(37.895,18.635),(38.065,18.635),(38.065,18.465),(37.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.465),(38.255,18.635),(38.425,18.635),(38.425,18.465),(38.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.825),(37.175,18.995),(37.345,18.995),(37.345,18.825),(37.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.825),(37.535,18.995),(37.705,18.995),(37.705,18.825),(37.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.825),(37.895,18.995),(38.065,18.995),(38.065,18.825),(37.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.825),(38.255,18.995),(38.425,18.995),(38.425,18.825),(38.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.185),(37.175,19.355),(37.345,19.355),(37.345,19.185),(37.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.185),(37.535,19.355),(37.705,19.355),(37.705,19.185),(37.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.185),(37.895,19.355),(38.065,19.355),(38.065,19.185),(37.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.185),(38.255,19.355),(38.425,19.355),(38.425,19.185),(38.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,2.985),(22.775,3.155),(22.945,3.155),(22.945,2.985),(22.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,2.985),(23.135,3.155),(23.305,3.155),(23.305,2.985),(23.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,2.985),(23.495,3.155),(23.665,3.155),(23.665,2.985),(23.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,2.985),(23.855,3.155),(24.025,3.155),(24.025,2.985),(23.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.345),(22.775,3.515),(22.945,3.515),(22.945,3.345),(22.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.345),(23.135,3.515),(23.305,3.515),(23.305,3.345),(23.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.345),(23.495,3.515),(23.665,3.515),(23.665,3.345),(23.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.345),(23.855,3.515),(24.025,3.515),(24.025,3.345),(23.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,3.705),(22.775,3.875),(22.945,3.875),(22.945,3.705),(22.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,3.705),(23.135,3.875),(23.305,3.875),(23.305,3.705),(23.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,3.705),(23.495,3.875),(23.665,3.875),(23.665,3.705),(23.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,3.705),(23.855,3.875),(24.025,3.875),(24.025,3.705),(23.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.065),(22.775,4.235),(22.945,4.235),(22.945,4.065),(22.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.065),(23.135,4.235),(23.305,4.235),(23.305,4.065),(23.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.065),(23.495,4.235),(23.665,4.235),(23.665,4.065),(23.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.065),(23.855,4.235),(24.025,4.235),(24.025,4.065),(23.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.425),(22.775,4.595),(22.945,4.595),(22.945,4.425),(22.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.425),(23.135,4.595),(23.305,4.595),(23.305,4.425),(23.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.425),(23.495,4.595),(23.665,4.595),(23.665,4.425),(23.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.425),(23.855,4.595),(24.025,4.595),(24.025,4.425),(23.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,4.785),(22.775,4.955),(22.945,4.955),(22.945,4.785),(22.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,4.785),(23.135,4.955),(23.305,4.955),(23.305,4.785),(23.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,4.785),(23.495,4.955),(23.665,4.955),(23.665,4.785),(23.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,4.785),(23.855,4.955),(24.025,4.955),(24.025,4.785),(23.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.145),(22.775,5.315),(22.945,5.315),(22.945,5.145),(22.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.145),(23.135,5.315),(23.305,5.315),(23.305,5.145),(23.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.145),(23.495,5.315),(23.665,5.315),(23.665,5.145),(23.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.145),(23.855,5.315),(24.025,5.315),(24.025,5.145),(23.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.505),(22.775,5.675),(22.945,5.675),(22.945,5.505),(22.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.505),(23.135,5.675),(23.305,5.675),(23.305,5.505),(23.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.505),(23.495,5.675),(23.665,5.675),(23.665,5.505),(23.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.505),(23.855,5.675),(24.025,5.675),(24.025,5.505),(23.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,5.865),(22.775,6.035),(22.945,6.035),(22.945,5.865),(22.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,5.865),(23.135,6.035),(23.305,6.035),(23.305,5.865),(23.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,5.865),(23.495,6.035),(23.665,6.035),(23.665,5.865),(23.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,5.865),(23.855,6.035),(24.025,6.035),(24.025,5.865),(23.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.225),(22.775,6.395),(22.945,6.395),(22.945,6.225),(22.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.225),(23.135,6.395),(23.305,6.395),(23.305,6.225),(23.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.225),(23.495,6.395),(23.665,6.395),(23.665,6.225),(23.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.225),(23.855,6.395),(24.025,6.395),(24.025,6.225),(23.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.585),(22.775,6.755),(22.945,6.755),(22.945,6.585),(22.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.585),(23.135,6.755),(23.305,6.755),(23.305,6.585),(23.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.585),(23.495,6.755),(23.665,6.755),(23.665,6.585),(23.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.585),(23.855,6.755),(24.025,6.755),(24.025,6.585),(23.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,6.945),(22.775,7.115),(22.945,7.115),(22.945,6.945),(22.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,6.945),(23.135,7.115),(23.305,7.115),(23.305,6.945),(23.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,6.945),(23.495,7.115),(23.665,7.115),(23.665,6.945),(23.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,6.945),(23.855,7.115),(24.025,7.115),(24.025,6.945),(23.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.305),(22.775,7.475),(22.945,7.475),(22.945,7.305),(22.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.305),(23.135,7.475),(23.305,7.475),(23.305,7.305),(23.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.305),(23.495,7.475),(23.665,7.475),(23.665,7.305),(23.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.305),(23.855,7.475),(24.025,7.475),(24.025,7.305),(23.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,7.665),(22.775,7.835),(22.945,7.835),(22.945,7.665),(22.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,7.665),(23.135,7.835),(23.305,7.835),(23.305,7.665),(23.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,7.665),(23.495,7.835),(23.665,7.835),(23.665,7.665),(23.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,7.665),(23.855,7.835),(24.025,7.835),(24.025,7.665),(23.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.025),(22.775,8.195),(22.945,8.195),(22.945,8.025),(22.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.025),(23.135,8.195),(23.305,8.195),(23.305,8.025),(23.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.025),(23.495,8.195),(23.665,8.195),(23.665,8.025),(23.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.025),(23.855,8.195),(24.025,8.195),(24.025,8.025),(23.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.385),(22.775,8.555),(22.945,8.555),(22.945,8.385),(22.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.385),(23.135,8.555),(23.305,8.555),(23.305,8.385),(23.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.385),(23.495,8.555),(23.665,8.555),(23.665,8.385),(23.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.385),(23.855,8.555),(24.025,8.555),(24.025,8.385),(23.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,8.745),(22.775,8.915),(22.945,8.915),(22.945,8.745),(22.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,8.745),(23.135,8.915),(23.305,8.915),(23.305,8.745),(23.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,8.745),(23.495,8.915),(23.665,8.915),(23.665,8.745),(23.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,8.745),(23.855,8.915),(24.025,8.915),(24.025,8.745),(23.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.105),(22.775,9.275),(22.945,9.275),(22.945,9.105),(22.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.105),(23.135,9.275),(23.305,9.275),(23.305,9.105),(23.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.105),(23.495,9.275),(23.665,9.275),(23.665,9.105),(23.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.105),(23.855,9.275),(24.025,9.275),(24.025,9.105),(23.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.465),(22.775,9.635),(22.945,9.635),(22.945,9.465),(22.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.465),(23.135,9.635),(23.305,9.635),(23.305,9.465),(23.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.465),(23.495,9.635),(23.665,9.635),(23.665,9.465),(23.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.465),(23.855,9.635),(24.025,9.635),(24.025,9.465),(23.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,9.825),(22.775,9.995),(22.945,9.995),(22.945,9.825),(22.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,9.825),(23.135,9.995),(23.305,9.995),(23.305,9.825),(23.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,9.825),(23.495,9.995),(23.665,9.995),(23.665,9.825),(23.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,9.825),(23.855,9.995),(24.025,9.995),(24.025,9.825),(23.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.185),(22.775,10.355),(22.945,10.355),(22.945,10.185),(22.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.185),(23.135,10.355),(23.305,10.355),(23.305,10.185),(23.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.185),(23.495,10.355),(23.665,10.355),(23.665,10.185),(23.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.185),(23.855,10.355),(24.025,10.355),(24.025,10.185),(23.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.545),(22.775,10.715),(22.945,10.715),(22.945,10.545),(22.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.545),(23.135,10.715),(23.305,10.715),(23.305,10.545),(23.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.545),(23.495,10.715),(23.665,10.715),(23.665,10.545),(23.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.545),(23.855,10.715),(24.025,10.715),(24.025,10.545),(23.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,10.905),(22.775,11.075),(22.945,11.075),(22.945,10.905),(22.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,10.905),(23.135,11.075),(23.305,11.075),(23.305,10.905),(23.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,10.905),(23.495,11.075),(23.665,11.075),(23.665,10.905),(23.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,10.905),(23.855,11.075),(24.025,11.075),(24.025,10.905),(23.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.265),(22.775,11.435),(22.945,11.435),(22.945,11.265),(22.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.265),(23.135,11.435),(23.305,11.435),(23.305,11.265),(23.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.265),(23.495,11.435),(23.665,11.435),(23.665,11.265),(23.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.265),(23.855,11.435),(24.025,11.435),(24.025,11.265),(23.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.625),(22.775,11.795),(22.945,11.795),(22.945,11.625),(22.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.625),(23.135,11.795),(23.305,11.795),(23.305,11.625),(23.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.625),(23.495,11.795),(23.665,11.795),(23.665,11.625),(23.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.625),(23.855,11.795),(24.025,11.795),(24.025,11.625),(23.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,11.985),(22.775,12.155),(22.945,12.155),(22.945,11.985),(22.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,11.985),(23.135,12.155),(23.305,12.155),(23.305,11.985),(23.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,11.985),(23.495,12.155),(23.665,12.155),(23.665,11.985),(23.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,11.985),(23.855,12.155),(24.025,12.155),(24.025,11.985),(23.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.345),(22.775,12.515),(22.945,12.515),(22.945,12.345),(22.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.345),(23.135,12.515),(23.305,12.515),(23.305,12.345),(23.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.345),(23.495,12.515),(23.665,12.515),(23.665,12.345),(23.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.345),(23.855,12.515),(24.025,12.515),(24.025,12.345),(23.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,12.705),(22.775,12.875),(22.945,12.875),(22.945,12.705),(22.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,12.705),(23.135,12.875),(23.305,12.875),(23.305,12.705),(23.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,12.705),(23.495,12.875),(23.665,12.875),(23.665,12.705),(23.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,12.705),(23.855,12.875),(24.025,12.875),(24.025,12.705),(23.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.065),(22.775,13.235),(22.945,13.235),(22.945,13.065),(22.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.065),(23.135,13.235),(23.305,13.235),(23.305,13.065),(23.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.065),(23.495,13.235),(23.665,13.235),(23.665,13.065),(23.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.065),(23.855,13.235),(24.025,13.235),(24.025,13.065),(23.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.425),(22.775,13.595),(22.945,13.595),(22.945,13.425),(22.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.425),(23.135,13.595),(23.305,13.595),(23.305,13.425),(23.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.425),(23.495,13.595),(23.665,13.595),(23.665,13.425),(23.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.425),(23.855,13.595),(24.025,13.595),(24.025,13.425),(23.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,13.785),(22.775,13.955),(22.945,13.955),(22.945,13.785),(22.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,13.785),(23.135,13.955),(23.305,13.955),(23.305,13.785),(23.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,13.785),(23.495,13.955),(23.665,13.955),(23.665,13.785),(23.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,13.785),(23.855,13.955),(24.025,13.955),(24.025,13.785),(23.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.145),(22.775,14.315),(22.945,14.315),(22.945,14.145),(22.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.145),(23.135,14.315),(23.305,14.315),(23.305,14.145),(23.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.145),(23.495,14.315),(23.665,14.315),(23.665,14.145),(23.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.145),(23.855,14.315),(24.025,14.315),(24.025,14.145),(23.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.505),(22.775,14.675),(22.945,14.675),(22.945,14.505),(22.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.505),(23.135,14.675),(23.305,14.675),(23.305,14.505),(23.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.505),(23.495,14.675),(23.665,14.675),(23.665,14.505),(23.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.505),(23.855,14.675),(24.025,14.675),(24.025,14.505),(23.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,14.865),(22.775,15.035),(22.945,15.035),(22.945,14.865),(22.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,14.865),(23.135,15.035),(23.305,15.035),(23.305,14.865),(23.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,14.865),(23.495,15.035),(23.665,15.035),(23.665,14.865),(23.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,14.865),(23.855,15.035),(24.025,15.035),(24.025,14.865),(23.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.225),(22.775,15.395),(22.945,15.395),(22.945,15.225),(22.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.225),(23.135,15.395),(23.305,15.395),(23.305,15.225),(23.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.225),(23.495,15.395),(23.665,15.395),(23.665,15.225),(23.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.225),(23.855,15.395),(24.025,15.395),(24.025,15.225),(23.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.585),(22.775,15.755),(22.945,15.755),(22.945,15.585),(22.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.585),(23.135,15.755),(23.305,15.755),(23.305,15.585),(23.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.585),(23.495,15.755),(23.665,15.755),(23.665,15.585),(23.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.585),(23.855,15.755),(24.025,15.755),(24.025,15.585),(23.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,15.945),(22.775,16.115),(22.945,16.115),(22.945,15.945),(22.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,15.945),(23.135,16.115),(23.305,16.115),(23.305,15.945),(23.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,15.945),(23.495,16.115),(23.665,16.115),(23.665,15.945),(23.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,15.945),(23.855,16.115),(24.025,16.115),(24.025,15.945),(23.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.305),(22.775,16.475),(22.945,16.475),(22.945,16.305),(22.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.305),(23.135,16.475),(23.305,16.475),(23.305,16.305),(23.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.305),(23.495,16.475),(23.665,16.475),(23.665,16.305),(23.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.305),(23.855,16.475),(24.025,16.475),(24.025,16.305),(23.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,16.665),(22.775,16.835),(22.945,16.835),(22.945,16.665),(22.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,16.665),(23.135,16.835),(23.305,16.835),(23.305,16.665),(23.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,16.665),(23.495,16.835),(23.665,16.835),(23.665,16.665),(23.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,16.665),(23.855,16.835),(24.025,16.835),(24.025,16.665),(23.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.025),(22.775,17.195),(22.945,17.195),(22.945,17.025),(22.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.025),(23.135,17.195),(23.305,17.195),(23.305,17.025),(23.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.025),(23.495,17.195),(23.665,17.195),(23.665,17.025),(23.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.025),(23.855,17.195),(24.025,17.195),(24.025,17.025),(23.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.385),(22.775,17.555),(22.945,17.555),(22.945,17.385),(22.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.385),(23.135,17.555),(23.305,17.555),(23.305,17.385),(23.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.385),(23.495,17.555),(23.665,17.555),(23.665,17.385),(23.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.385),(23.855,17.555),(24.025,17.555),(24.025,17.385),(23.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,17.745),(22.775,17.915),(22.945,17.915),(22.945,17.745),(22.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,17.745),(23.135,17.915),(23.305,17.915),(23.305,17.745),(23.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,17.745),(23.495,17.915),(23.665,17.915),(23.665,17.745),(23.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,17.745),(23.855,17.915),(24.025,17.915),(24.025,17.745),(23.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.105),(22.775,18.275),(22.945,18.275),(22.945,18.105),(22.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.105),(23.135,18.275),(23.305,18.275),(23.305,18.105),(23.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.105),(23.495,18.275),(23.665,18.275),(23.665,18.105),(23.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.105),(23.855,18.275),(24.025,18.275),(24.025,18.105),(23.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.465),(22.775,18.635),(22.945,18.635),(22.945,18.465),(22.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.465),(23.135,18.635),(23.305,18.635),(23.305,18.465),(23.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.465),(23.495,18.635),(23.665,18.635),(23.665,18.465),(23.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.465),(23.855,18.635),(24.025,18.635),(24.025,18.465),(23.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,18.825),(22.775,18.995),(22.945,18.995),(22.945,18.825),(22.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,18.825),(23.135,18.995),(23.305,18.995),(23.305,18.825),(23.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,18.825),(23.495,18.995),(23.665,18.995),(23.665,18.825),(23.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,18.825),(23.855,18.995),(24.025,18.995),(24.025,18.825),(23.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.775,19.185),(22.775,19.355),(22.945,19.355),(22.945,19.185),(22.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.135,19.185),(23.135,19.355),(23.305,19.355),(23.305,19.185),(23.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.495,19.185),(23.495,19.355),(23.665,19.355),(23.665,19.185),(23.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.855,19.185),(23.855,19.355),(24.025,19.355),(24.025,19.185),(23.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.985),(56.375,3.155),(56.545,3.155),(56.545,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.985),(56.735,3.155),(56.905,3.155),(56.905,2.985),(56.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.985),(57.095,3.155),(57.265,3.155),(57.265,2.985),(57.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.985),(57.455,3.155),(57.625,3.155),(57.625,2.985),(57.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.345),(56.375,3.515),(56.545,3.515),(56.545,3.345),(56.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.345),(56.735,3.515),(56.905,3.515),(56.905,3.345),(56.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.345),(57.095,3.515),(57.265,3.515),(57.265,3.345),(57.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.345),(57.455,3.515),(57.625,3.515),(57.625,3.345),(57.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.705),(56.375,3.875),(56.545,3.875),(56.545,3.705),(56.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.705),(56.735,3.875),(56.905,3.875),(56.905,3.705),(56.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.705),(57.095,3.875),(57.265,3.875),(57.265,3.705),(57.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.705),(57.455,3.875),(57.625,3.875),(57.625,3.705),(57.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.065),(56.375,4.235),(56.545,4.235),(56.545,4.065),(56.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.065),(56.735,4.235),(56.905,4.235),(56.905,4.065),(56.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.065),(57.095,4.235),(57.265,4.235),(57.265,4.065),(57.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.065),(57.455,4.235),(57.625,4.235),(57.625,4.065),(57.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.425),(56.375,4.595),(56.545,4.595),(56.545,4.425),(56.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.425),(56.735,4.595),(56.905,4.595),(56.905,4.425),(56.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.425),(57.095,4.595),(57.265,4.595),(57.265,4.425),(57.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.425),(57.455,4.595),(57.625,4.595),(57.625,4.425),(57.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.785),(56.375,4.955),(56.545,4.955),(56.545,4.785),(56.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.785),(56.735,4.955),(56.905,4.955),(56.905,4.785),(56.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.785),(57.095,4.955),(57.265,4.955),(57.265,4.785),(57.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.785),(57.455,4.955),(57.625,4.955),(57.625,4.785),(57.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.145),(56.375,5.315),(56.545,5.315),(56.545,5.145),(56.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.145),(56.735,5.315),(56.905,5.315),(56.905,5.145),(56.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.145),(57.095,5.315),(57.265,5.315),(57.265,5.145),(57.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.145),(57.455,5.315),(57.625,5.315),(57.625,5.145),(57.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.505),(56.375,5.675),(56.545,5.675),(56.545,5.505),(56.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.505),(56.735,5.675),(56.905,5.675),(56.905,5.505),(56.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.505),(57.095,5.675),(57.265,5.675),(57.265,5.505),(57.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.505),(57.455,5.675),(57.625,5.675),(57.625,5.505),(57.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.865),(56.375,6.035),(56.545,6.035),(56.545,5.865),(56.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.865),(56.735,6.035),(56.905,6.035),(56.905,5.865),(56.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.865),(57.095,6.035),(57.265,6.035),(57.265,5.865),(57.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.865),(57.455,6.035),(57.625,6.035),(57.625,5.865),(57.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.225),(56.375,6.395),(56.545,6.395),(56.545,6.225),(56.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.225),(56.735,6.395),(56.905,6.395),(56.905,6.225),(56.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.225),(57.095,6.395),(57.265,6.395),(57.265,6.225),(57.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.225),(57.455,6.395),(57.625,6.395),(57.625,6.225),(57.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.585),(56.375,6.755),(56.545,6.755),(56.545,6.585),(56.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.585),(56.735,6.755),(56.905,6.755),(56.905,6.585),(56.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.585),(57.095,6.755),(57.265,6.755),(57.265,6.585),(57.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.585),(57.455,6.755),(57.625,6.755),(57.625,6.585),(57.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.945),(56.375,7.115),(56.545,7.115),(56.545,6.945),(56.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.945),(56.735,7.115),(56.905,7.115),(56.905,6.945),(56.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.945),(57.095,7.115),(57.265,7.115),(57.265,6.945),(57.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.945),(57.455,7.115),(57.625,7.115),(57.625,6.945),(57.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.305),(56.375,7.475),(56.545,7.475),(56.545,7.305),(56.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.305),(56.735,7.475),(56.905,7.475),(56.905,7.305),(56.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.305),(57.095,7.475),(57.265,7.475),(57.265,7.305),(57.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.305),(57.455,7.475),(57.625,7.475),(57.625,7.305),(57.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.665),(56.375,7.835),(56.545,7.835),(56.545,7.665),(56.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.665),(56.735,7.835),(56.905,7.835),(56.905,7.665),(56.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.665),(57.095,7.835),(57.265,7.835),(57.265,7.665),(57.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.665),(57.455,7.835),(57.625,7.835),(57.625,7.665),(57.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.025),(56.375,8.195),(56.545,8.195),(56.545,8.025),(56.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.025),(56.735,8.195),(56.905,8.195),(56.905,8.025),(56.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.025),(57.095,8.195),(57.265,8.195),(57.265,8.025),(57.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.025),(57.455,8.195),(57.625,8.195),(57.625,8.025),(57.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.385),(56.375,8.555),(56.545,8.555),(56.545,8.385),(56.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.385),(56.735,8.555),(56.905,8.555),(56.905,8.385),(56.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.385),(57.095,8.555),(57.265,8.555),(57.265,8.385),(57.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.385),(57.455,8.555),(57.625,8.555),(57.625,8.385),(57.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.745),(56.375,8.915),(56.545,8.915),(56.545,8.745),(56.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.745),(56.735,8.915),(56.905,8.915),(56.905,8.745),(56.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.745),(57.095,8.915),(57.265,8.915),(57.265,8.745),(57.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.745),(57.455,8.915),(57.625,8.915),(57.625,8.745),(57.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.105),(56.375,9.275),(56.545,9.275),(56.545,9.105),(56.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.105),(56.735,9.275),(56.905,9.275),(56.905,9.105),(56.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.105),(57.095,9.275),(57.265,9.275),(57.265,9.105),(57.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.105),(57.455,9.275),(57.625,9.275),(57.625,9.105),(57.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.465),(56.375,9.635),(56.545,9.635),(56.545,9.465),(56.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.465),(56.735,9.635),(56.905,9.635),(56.905,9.465),(56.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.465),(57.095,9.635),(57.265,9.635),(57.265,9.465),(57.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.465),(57.455,9.635),(57.625,9.635),(57.625,9.465),(57.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.825),(56.375,9.995),(56.545,9.995),(56.545,9.825),(56.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.825),(56.735,9.995),(56.905,9.995),(56.905,9.825),(56.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.825),(57.095,9.995),(57.265,9.995),(57.265,9.825),(57.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.825),(57.455,9.995),(57.625,9.995),(57.625,9.825),(57.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.185),(56.375,10.355),(56.545,10.355),(56.545,10.185),(56.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.185),(56.735,10.355),(56.905,10.355),(56.905,10.185),(56.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.185),(57.095,10.355),(57.265,10.355),(57.265,10.185),(57.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.185),(57.455,10.355),(57.625,10.355),(57.625,10.185),(57.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.545),(56.375,10.715),(56.545,10.715),(56.545,10.545),(56.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.545),(56.735,10.715),(56.905,10.715),(56.905,10.545),(56.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.545),(57.095,10.715),(57.265,10.715),(57.265,10.545),(57.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.545),(57.455,10.715),(57.625,10.715),(57.625,10.545),(57.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.905),(56.375,11.075),(56.545,11.075),(56.545,10.905),(56.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.905),(56.735,11.075),(56.905,11.075),(56.905,10.905),(56.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.905),(57.095,11.075),(57.265,11.075),(57.265,10.905),(57.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.905),(57.455,11.075),(57.625,11.075),(57.625,10.905),(57.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.265),(56.375,11.435),(56.545,11.435),(56.545,11.265),(56.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.265),(56.735,11.435),(56.905,11.435),(56.905,11.265),(56.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.265),(57.095,11.435),(57.265,11.435),(57.265,11.265),(57.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.265),(57.455,11.435),(57.625,11.435),(57.625,11.265),(57.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.625),(56.375,11.795),(56.545,11.795),(56.545,11.625),(56.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.625),(56.735,11.795),(56.905,11.795),(56.905,11.625),(56.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.625),(57.095,11.795),(57.265,11.795),(57.265,11.625),(57.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.625),(57.455,11.795),(57.625,11.795),(57.625,11.625),(57.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.985),(56.375,12.155),(56.545,12.155),(56.545,11.985),(56.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.985),(56.735,12.155),(56.905,12.155),(56.905,11.985),(56.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.985),(57.095,12.155),(57.265,12.155),(57.265,11.985),(57.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.985),(57.455,12.155),(57.625,12.155),(57.625,11.985),(57.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.345),(56.375,12.515),(56.545,12.515),(56.545,12.345),(56.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.345),(56.735,12.515),(56.905,12.515),(56.905,12.345),(56.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.345),(57.095,12.515),(57.265,12.515),(57.265,12.345),(57.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.345),(57.455,12.515),(57.625,12.515),(57.625,12.345),(57.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.705),(56.375,12.875),(56.545,12.875),(56.545,12.705),(56.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.705),(56.735,12.875),(56.905,12.875),(56.905,12.705),(56.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.705),(57.095,12.875),(57.265,12.875),(57.265,12.705),(57.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.705),(57.455,12.875),(57.625,12.875),(57.625,12.705),(57.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.065),(56.375,13.235),(56.545,13.235),(56.545,13.065),(56.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.065),(56.735,13.235),(56.905,13.235),(56.905,13.065),(56.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.065),(57.095,13.235),(57.265,13.235),(57.265,13.065),(57.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.065),(57.455,13.235),(57.625,13.235),(57.625,13.065),(57.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.425),(56.375,13.595),(56.545,13.595),(56.545,13.425),(56.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.425),(56.735,13.595),(56.905,13.595),(56.905,13.425),(56.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.425),(57.095,13.595),(57.265,13.595),(57.265,13.425),(57.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.425),(57.455,13.595),(57.625,13.595),(57.625,13.425),(57.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.785),(56.375,13.955),(56.545,13.955),(56.545,13.785),(56.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.785),(56.735,13.955),(56.905,13.955),(56.905,13.785),(56.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.785),(57.095,13.955),(57.265,13.955),(57.265,13.785),(57.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.785),(57.455,13.955),(57.625,13.955),(57.625,13.785),(57.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.145),(56.375,14.315),(56.545,14.315),(56.545,14.145),(56.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.145),(56.735,14.315),(56.905,14.315),(56.905,14.145),(56.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.145),(57.095,14.315),(57.265,14.315),(57.265,14.145),(57.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.145),(57.455,14.315),(57.625,14.315),(57.625,14.145),(57.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.505),(56.375,14.675),(56.545,14.675),(56.545,14.505),(56.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.505),(56.735,14.675),(56.905,14.675),(56.905,14.505),(56.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.505),(57.095,14.675),(57.265,14.675),(57.265,14.505),(57.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.505),(57.455,14.675),(57.625,14.675),(57.625,14.505),(57.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.865),(56.375,15.035),(56.545,15.035),(56.545,14.865),(56.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.865),(56.735,15.035),(56.905,15.035),(56.905,14.865),(56.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.865),(57.095,15.035),(57.265,15.035),(57.265,14.865),(57.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.865),(57.455,15.035),(57.625,15.035),(57.625,14.865),(57.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.225),(56.375,15.395),(56.545,15.395),(56.545,15.225),(56.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.225),(56.735,15.395),(56.905,15.395),(56.905,15.225),(56.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.225),(57.095,15.395),(57.265,15.395),(57.265,15.225),(57.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.225),(57.455,15.395),(57.625,15.395),(57.625,15.225),(57.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.585),(56.375,15.755),(56.545,15.755),(56.545,15.585),(56.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.585),(56.735,15.755),(56.905,15.755),(56.905,15.585),(56.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.585),(57.095,15.755),(57.265,15.755),(57.265,15.585),(57.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.585),(57.455,15.755),(57.625,15.755),(57.625,15.585),(57.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.945),(56.375,16.115),(56.545,16.115),(56.545,15.945),(56.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.945),(56.735,16.115),(56.905,16.115),(56.905,15.945),(56.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.945),(57.095,16.115),(57.265,16.115),(57.265,15.945),(57.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.945),(57.455,16.115),(57.625,16.115),(57.625,15.945),(57.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.305),(56.375,16.475),(56.545,16.475),(56.545,16.305),(56.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.305),(56.735,16.475),(56.905,16.475),(56.905,16.305),(56.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.305),(57.095,16.475),(57.265,16.475),(57.265,16.305),(57.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.305),(57.455,16.475),(57.625,16.475),(57.625,16.305),(57.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.665),(56.375,16.835),(56.545,16.835),(56.545,16.665),(56.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.665),(56.735,16.835),(56.905,16.835),(56.905,16.665),(56.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.665),(57.095,16.835),(57.265,16.835),(57.265,16.665),(57.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.665),(57.455,16.835),(57.625,16.835),(57.625,16.665),(57.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.025),(56.375,17.195),(56.545,17.195),(56.545,17.025),(56.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.025),(56.735,17.195),(56.905,17.195),(56.905,17.025),(56.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.025),(57.095,17.195),(57.265,17.195),(57.265,17.025),(57.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.025),(57.455,17.195),(57.625,17.195),(57.625,17.025),(57.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.385),(56.375,17.555),(56.545,17.555),(56.545,17.385),(56.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.385),(56.735,17.555),(56.905,17.555),(56.905,17.385),(56.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.385),(57.095,17.555),(57.265,17.555),(57.265,17.385),(57.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.385),(57.455,17.555),(57.625,17.555),(57.625,17.385),(57.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.745),(56.375,17.915),(56.545,17.915),(56.545,17.745),(56.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.745),(56.735,17.915),(56.905,17.915),(56.905,17.745),(56.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.745),(57.095,17.915),(57.265,17.915),(57.265,17.745),(57.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.745),(57.455,17.915),(57.625,17.915),(57.625,17.745),(57.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.105),(56.375,18.275),(56.545,18.275),(56.545,18.105),(56.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.105),(56.735,18.275),(56.905,18.275),(56.905,18.105),(56.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.105),(57.095,18.275),(57.265,18.275),(57.265,18.105),(57.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.105),(57.455,18.275),(57.625,18.275),(57.625,18.105),(57.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.465),(56.375,18.635),(56.545,18.635),(56.545,18.465),(56.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.465),(56.735,18.635),(56.905,18.635),(56.905,18.465),(56.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.465),(57.095,18.635),(57.265,18.635),(57.265,18.465),(57.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.465),(57.455,18.635),(57.625,18.635),(57.625,18.465),(57.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.825),(56.375,18.995),(56.545,18.995),(56.545,18.825),(56.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.825),(56.735,18.995),(56.905,18.995),(56.905,18.825),(56.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.825),(57.095,18.995),(57.265,18.995),(57.265,18.825),(57.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.825),(57.455,18.995),(57.625,18.995),(57.625,18.825),(57.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.185),(56.375,19.355),(56.545,19.355),(56.545,19.185),(56.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.185),(56.735,19.355),(56.905,19.355),(56.905,19.185),(56.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.185),(57.095,19.355),(57.265,19.355),(57.265,19.185),(57.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.185),(57.455,19.355),(57.625,19.355),(57.625,19.185),(57.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,2.985),(70.775,3.155),(70.945,3.155),(70.945,2.985),(70.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,2.985),(71.135,3.155),(71.305,3.155),(71.305,2.985),(71.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,2.985),(71.495,3.155),(71.665,3.155),(71.665,2.985),(71.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,2.985),(71.855,3.155),(72.025,3.155),(72.025,2.985),(71.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.345),(70.775,3.515),(70.945,3.515),(70.945,3.345),(70.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.345),(71.135,3.515),(71.305,3.515),(71.305,3.345),(71.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.345),(71.495,3.515),(71.665,3.515),(71.665,3.345),(71.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.345),(71.855,3.515),(72.025,3.515),(72.025,3.345),(71.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,3.705),(70.775,3.875),(70.945,3.875),(70.945,3.705),(70.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,3.705),(71.135,3.875),(71.305,3.875),(71.305,3.705),(71.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,3.705),(71.495,3.875),(71.665,3.875),(71.665,3.705),(71.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,3.705),(71.855,3.875),(72.025,3.875),(72.025,3.705),(71.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.065),(70.775,4.235),(70.945,4.235),(70.945,4.065),(70.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.065),(71.135,4.235),(71.305,4.235),(71.305,4.065),(71.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.065),(71.495,4.235),(71.665,4.235),(71.665,4.065),(71.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.065),(71.855,4.235),(72.025,4.235),(72.025,4.065),(71.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.425),(70.775,4.595),(70.945,4.595),(70.945,4.425),(70.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.425),(71.135,4.595),(71.305,4.595),(71.305,4.425),(71.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.425),(71.495,4.595),(71.665,4.595),(71.665,4.425),(71.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.425),(71.855,4.595),(72.025,4.595),(72.025,4.425),(71.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,4.785),(70.775,4.955),(70.945,4.955),(70.945,4.785),(70.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,4.785),(71.135,4.955),(71.305,4.955),(71.305,4.785),(71.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,4.785),(71.495,4.955),(71.665,4.955),(71.665,4.785),(71.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,4.785),(71.855,4.955),(72.025,4.955),(72.025,4.785),(71.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.145),(70.775,5.315),(70.945,5.315),(70.945,5.145),(70.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.145),(71.135,5.315),(71.305,5.315),(71.305,5.145),(71.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.145),(71.495,5.315),(71.665,5.315),(71.665,5.145),(71.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.145),(71.855,5.315),(72.025,5.315),(72.025,5.145),(71.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.505),(70.775,5.675),(70.945,5.675),(70.945,5.505),(70.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.505),(71.135,5.675),(71.305,5.675),(71.305,5.505),(71.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.505),(71.495,5.675),(71.665,5.675),(71.665,5.505),(71.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.505),(71.855,5.675),(72.025,5.675),(72.025,5.505),(71.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,5.865),(70.775,6.035),(70.945,6.035),(70.945,5.865),(70.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,5.865),(71.135,6.035),(71.305,6.035),(71.305,5.865),(71.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,5.865),(71.495,6.035),(71.665,6.035),(71.665,5.865),(71.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,5.865),(71.855,6.035),(72.025,6.035),(72.025,5.865),(71.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.225),(70.775,6.395),(70.945,6.395),(70.945,6.225),(70.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.225),(71.135,6.395),(71.305,6.395),(71.305,6.225),(71.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.225),(71.495,6.395),(71.665,6.395),(71.665,6.225),(71.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.225),(71.855,6.395),(72.025,6.395),(72.025,6.225),(71.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.585),(70.775,6.755),(70.945,6.755),(70.945,6.585),(70.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.585),(71.135,6.755),(71.305,6.755),(71.305,6.585),(71.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.585),(71.495,6.755),(71.665,6.755),(71.665,6.585),(71.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.585),(71.855,6.755),(72.025,6.755),(72.025,6.585),(71.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,6.945),(70.775,7.115),(70.945,7.115),(70.945,6.945),(70.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,6.945),(71.135,7.115),(71.305,7.115),(71.305,6.945),(71.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,6.945),(71.495,7.115),(71.665,7.115),(71.665,6.945),(71.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,6.945),(71.855,7.115),(72.025,7.115),(72.025,6.945),(71.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.305),(70.775,7.475),(70.945,7.475),(70.945,7.305),(70.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.305),(71.135,7.475),(71.305,7.475),(71.305,7.305),(71.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.305),(71.495,7.475),(71.665,7.475),(71.665,7.305),(71.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.305),(71.855,7.475),(72.025,7.475),(72.025,7.305),(71.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,7.665),(70.775,7.835),(70.945,7.835),(70.945,7.665),(70.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,7.665),(71.135,7.835),(71.305,7.835),(71.305,7.665),(71.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,7.665),(71.495,7.835),(71.665,7.835),(71.665,7.665),(71.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,7.665),(71.855,7.835),(72.025,7.835),(72.025,7.665),(71.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.025),(70.775,8.195),(70.945,8.195),(70.945,8.025),(70.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.025),(71.135,8.195),(71.305,8.195),(71.305,8.025),(71.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.025),(71.495,8.195),(71.665,8.195),(71.665,8.025),(71.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.025),(71.855,8.195),(72.025,8.195),(72.025,8.025),(71.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.385),(70.775,8.555),(70.945,8.555),(70.945,8.385),(70.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.385),(71.135,8.555),(71.305,8.555),(71.305,8.385),(71.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.385),(71.495,8.555),(71.665,8.555),(71.665,8.385),(71.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.385),(71.855,8.555),(72.025,8.555),(72.025,8.385),(71.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,8.745),(70.775,8.915),(70.945,8.915),(70.945,8.745),(70.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,8.745),(71.135,8.915),(71.305,8.915),(71.305,8.745),(71.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,8.745),(71.495,8.915),(71.665,8.915),(71.665,8.745),(71.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,8.745),(71.855,8.915),(72.025,8.915),(72.025,8.745),(71.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.105),(70.775,9.275),(70.945,9.275),(70.945,9.105),(70.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.105),(71.135,9.275),(71.305,9.275),(71.305,9.105),(71.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.105),(71.495,9.275),(71.665,9.275),(71.665,9.105),(71.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.105),(71.855,9.275),(72.025,9.275),(72.025,9.105),(71.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.465),(70.775,9.635),(70.945,9.635),(70.945,9.465),(70.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.465),(71.135,9.635),(71.305,9.635),(71.305,9.465),(71.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.465),(71.495,9.635),(71.665,9.635),(71.665,9.465),(71.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.465),(71.855,9.635),(72.025,9.635),(72.025,9.465),(71.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,9.825),(70.775,9.995),(70.945,9.995),(70.945,9.825),(70.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,9.825),(71.135,9.995),(71.305,9.995),(71.305,9.825),(71.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,9.825),(71.495,9.995),(71.665,9.995),(71.665,9.825),(71.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,9.825),(71.855,9.995),(72.025,9.995),(72.025,9.825),(71.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.185),(70.775,10.355),(70.945,10.355),(70.945,10.185),(70.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.185),(71.135,10.355),(71.305,10.355),(71.305,10.185),(71.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.185),(71.495,10.355),(71.665,10.355),(71.665,10.185),(71.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.185),(71.855,10.355),(72.025,10.355),(72.025,10.185),(71.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.545),(70.775,10.715),(70.945,10.715),(70.945,10.545),(70.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.545),(71.135,10.715),(71.305,10.715),(71.305,10.545),(71.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.545),(71.495,10.715),(71.665,10.715),(71.665,10.545),(71.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.545),(71.855,10.715),(72.025,10.715),(72.025,10.545),(71.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,10.905),(70.775,11.075),(70.945,11.075),(70.945,10.905),(70.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,10.905),(71.135,11.075),(71.305,11.075),(71.305,10.905),(71.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,10.905),(71.495,11.075),(71.665,11.075),(71.665,10.905),(71.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,10.905),(71.855,11.075),(72.025,11.075),(72.025,10.905),(71.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.265),(70.775,11.435),(70.945,11.435),(70.945,11.265),(70.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.265),(71.135,11.435),(71.305,11.435),(71.305,11.265),(71.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.265),(71.495,11.435),(71.665,11.435),(71.665,11.265),(71.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.265),(71.855,11.435),(72.025,11.435),(72.025,11.265),(71.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.625),(70.775,11.795),(70.945,11.795),(70.945,11.625),(70.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.625),(71.135,11.795),(71.305,11.795),(71.305,11.625),(71.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.625),(71.495,11.795),(71.665,11.795),(71.665,11.625),(71.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.625),(71.855,11.795),(72.025,11.795),(72.025,11.625),(71.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,11.985),(70.775,12.155),(70.945,12.155),(70.945,11.985),(70.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,11.985),(71.135,12.155),(71.305,12.155),(71.305,11.985),(71.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,11.985),(71.495,12.155),(71.665,12.155),(71.665,11.985),(71.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,11.985),(71.855,12.155),(72.025,12.155),(72.025,11.985),(71.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.345),(70.775,12.515),(70.945,12.515),(70.945,12.345),(70.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.345),(71.135,12.515),(71.305,12.515),(71.305,12.345),(71.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.345),(71.495,12.515),(71.665,12.515),(71.665,12.345),(71.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.345),(71.855,12.515),(72.025,12.515),(72.025,12.345),(71.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,12.705),(70.775,12.875),(70.945,12.875),(70.945,12.705),(70.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,12.705),(71.135,12.875),(71.305,12.875),(71.305,12.705),(71.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,12.705),(71.495,12.875),(71.665,12.875),(71.665,12.705),(71.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,12.705),(71.855,12.875),(72.025,12.875),(72.025,12.705),(71.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.065),(70.775,13.235),(70.945,13.235),(70.945,13.065),(70.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.065),(71.135,13.235),(71.305,13.235),(71.305,13.065),(71.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.065),(71.495,13.235),(71.665,13.235),(71.665,13.065),(71.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.065),(71.855,13.235),(72.025,13.235),(72.025,13.065),(71.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.425),(70.775,13.595),(70.945,13.595),(70.945,13.425),(70.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.425),(71.135,13.595),(71.305,13.595),(71.305,13.425),(71.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.425),(71.495,13.595),(71.665,13.595),(71.665,13.425),(71.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.425),(71.855,13.595),(72.025,13.595),(72.025,13.425),(71.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,13.785),(70.775,13.955),(70.945,13.955),(70.945,13.785),(70.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,13.785),(71.135,13.955),(71.305,13.955),(71.305,13.785),(71.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,13.785),(71.495,13.955),(71.665,13.955),(71.665,13.785),(71.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,13.785),(71.855,13.955),(72.025,13.955),(72.025,13.785),(71.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.145),(70.775,14.315),(70.945,14.315),(70.945,14.145),(70.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.145),(71.135,14.315),(71.305,14.315),(71.305,14.145),(71.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.145),(71.495,14.315),(71.665,14.315),(71.665,14.145),(71.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.145),(71.855,14.315),(72.025,14.315),(72.025,14.145),(71.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.505),(70.775,14.675),(70.945,14.675),(70.945,14.505),(70.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.505),(71.135,14.675),(71.305,14.675),(71.305,14.505),(71.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.505),(71.495,14.675),(71.665,14.675),(71.665,14.505),(71.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.505),(71.855,14.675),(72.025,14.675),(72.025,14.505),(71.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,14.865),(70.775,15.035),(70.945,15.035),(70.945,14.865),(70.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,14.865),(71.135,15.035),(71.305,15.035),(71.305,14.865),(71.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,14.865),(71.495,15.035),(71.665,15.035),(71.665,14.865),(71.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,14.865),(71.855,15.035),(72.025,15.035),(72.025,14.865),(71.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.225),(70.775,15.395),(70.945,15.395),(70.945,15.225),(70.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.225),(71.135,15.395),(71.305,15.395),(71.305,15.225),(71.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.225),(71.495,15.395),(71.665,15.395),(71.665,15.225),(71.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.225),(71.855,15.395),(72.025,15.395),(72.025,15.225),(71.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.585),(70.775,15.755),(70.945,15.755),(70.945,15.585),(70.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.585),(71.135,15.755),(71.305,15.755),(71.305,15.585),(71.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.585),(71.495,15.755),(71.665,15.755),(71.665,15.585),(71.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.585),(71.855,15.755),(72.025,15.755),(72.025,15.585),(71.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,15.945),(70.775,16.115),(70.945,16.115),(70.945,15.945),(70.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,15.945),(71.135,16.115),(71.305,16.115),(71.305,15.945),(71.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,15.945),(71.495,16.115),(71.665,16.115),(71.665,15.945),(71.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,15.945),(71.855,16.115),(72.025,16.115),(72.025,15.945),(71.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.305),(70.775,16.475),(70.945,16.475),(70.945,16.305),(70.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.305),(71.135,16.475),(71.305,16.475),(71.305,16.305),(71.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.305),(71.495,16.475),(71.665,16.475),(71.665,16.305),(71.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.305),(71.855,16.475),(72.025,16.475),(72.025,16.305),(71.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,16.665),(70.775,16.835),(70.945,16.835),(70.945,16.665),(70.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,16.665),(71.135,16.835),(71.305,16.835),(71.305,16.665),(71.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,16.665),(71.495,16.835),(71.665,16.835),(71.665,16.665),(71.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,16.665),(71.855,16.835),(72.025,16.835),(72.025,16.665),(71.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.025),(70.775,17.195),(70.945,17.195),(70.945,17.025),(70.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.025),(71.135,17.195),(71.305,17.195),(71.305,17.025),(71.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.025),(71.495,17.195),(71.665,17.195),(71.665,17.025),(71.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.025),(71.855,17.195),(72.025,17.195),(72.025,17.025),(71.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.385),(70.775,17.555),(70.945,17.555),(70.945,17.385),(70.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.385),(71.135,17.555),(71.305,17.555),(71.305,17.385),(71.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.385),(71.495,17.555),(71.665,17.555),(71.665,17.385),(71.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.385),(71.855,17.555),(72.025,17.555),(72.025,17.385),(71.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,17.745),(70.775,17.915),(70.945,17.915),(70.945,17.745),(70.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,17.745),(71.135,17.915),(71.305,17.915),(71.305,17.745),(71.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,17.745),(71.495,17.915),(71.665,17.915),(71.665,17.745),(71.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,17.745),(71.855,17.915),(72.025,17.915),(72.025,17.745),(71.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.105),(70.775,18.275),(70.945,18.275),(70.945,18.105),(70.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.105),(71.135,18.275),(71.305,18.275),(71.305,18.105),(71.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.105),(71.495,18.275),(71.665,18.275),(71.665,18.105),(71.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.105),(71.855,18.275),(72.025,18.275),(72.025,18.105),(71.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.465),(70.775,18.635),(70.945,18.635),(70.945,18.465),(70.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.465),(71.135,18.635),(71.305,18.635),(71.305,18.465),(71.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.465),(71.495,18.635),(71.665,18.635),(71.665,18.465),(71.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.465),(71.855,18.635),(72.025,18.635),(72.025,18.465),(71.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,18.825),(70.775,18.995),(70.945,18.995),(70.945,18.825),(70.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,18.825),(71.135,18.995),(71.305,18.995),(71.305,18.825),(71.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,18.825),(71.495,18.995),(71.665,18.995),(71.665,18.825),(71.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,18.825),(71.855,18.995),(72.025,18.995),(72.025,18.825),(71.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.775,19.185),(70.775,19.355),(70.945,19.355),(70.945,19.185),(70.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.135,19.185),(71.135,19.355),(71.305,19.355),(71.305,19.185),(71.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.495,19.185),(71.495,19.355),(71.665,19.355),(71.665,19.185),(71.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.855,19.185),(71.855,19.355),(72.025,19.355),(72.025,19.185),(71.855,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,2.985),(27.575,3.155),(27.745,3.155),(27.745,2.985),(27.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,2.985),(27.935,3.155),(28.105,3.155),(28.105,2.985),(27.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,2.985),(28.295,3.155),(28.465,3.155),(28.465,2.985),(28.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,2.985),(28.655,3.155),(28.825,3.155),(28.825,2.985),(28.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.345),(27.575,3.515),(27.745,3.515),(27.745,3.345),(27.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.345),(27.935,3.515),(28.105,3.515),(28.105,3.345),(27.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.345),(28.295,3.515),(28.465,3.515),(28.465,3.345),(28.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.345),(28.655,3.515),(28.825,3.515),(28.825,3.345),(28.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,3.705),(27.575,3.875),(27.745,3.875),(27.745,3.705),(27.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,3.705),(27.935,3.875),(28.105,3.875),(28.105,3.705),(27.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,3.705),(28.295,3.875),(28.465,3.875),(28.465,3.705),(28.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,3.705),(28.655,3.875),(28.825,3.875),(28.825,3.705),(28.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.065),(27.575,4.235),(27.745,4.235),(27.745,4.065),(27.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.065),(27.935,4.235),(28.105,4.235),(28.105,4.065),(27.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.065),(28.295,4.235),(28.465,4.235),(28.465,4.065),(28.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.065),(28.655,4.235),(28.825,4.235),(28.825,4.065),(28.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.425),(27.575,4.595),(27.745,4.595),(27.745,4.425),(27.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.425),(27.935,4.595),(28.105,4.595),(28.105,4.425),(27.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.425),(28.295,4.595),(28.465,4.595),(28.465,4.425),(28.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.425),(28.655,4.595),(28.825,4.595),(28.825,4.425),(28.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,4.785),(27.575,4.955),(27.745,4.955),(27.745,4.785),(27.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,4.785),(27.935,4.955),(28.105,4.955),(28.105,4.785),(27.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,4.785),(28.295,4.955),(28.465,4.955),(28.465,4.785),(28.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,4.785),(28.655,4.955),(28.825,4.955),(28.825,4.785),(28.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.145),(27.575,5.315),(27.745,5.315),(27.745,5.145),(27.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.145),(27.935,5.315),(28.105,5.315),(28.105,5.145),(27.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.145),(28.295,5.315),(28.465,5.315),(28.465,5.145),(28.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.145),(28.655,5.315),(28.825,5.315),(28.825,5.145),(28.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.505),(27.575,5.675),(27.745,5.675),(27.745,5.505),(27.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.505),(27.935,5.675),(28.105,5.675),(28.105,5.505),(27.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.505),(28.295,5.675),(28.465,5.675),(28.465,5.505),(28.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.505),(28.655,5.675),(28.825,5.675),(28.825,5.505),(28.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,5.865),(27.575,6.035),(27.745,6.035),(27.745,5.865),(27.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,5.865),(27.935,6.035),(28.105,6.035),(28.105,5.865),(27.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,5.865),(28.295,6.035),(28.465,6.035),(28.465,5.865),(28.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,5.865),(28.655,6.035),(28.825,6.035),(28.825,5.865),(28.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.225),(27.575,6.395),(27.745,6.395),(27.745,6.225),(27.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.225),(27.935,6.395),(28.105,6.395),(28.105,6.225),(27.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.225),(28.295,6.395),(28.465,6.395),(28.465,6.225),(28.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.225),(28.655,6.395),(28.825,6.395),(28.825,6.225),(28.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.585),(27.575,6.755),(27.745,6.755),(27.745,6.585),(27.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.585),(27.935,6.755),(28.105,6.755),(28.105,6.585),(27.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.585),(28.295,6.755),(28.465,6.755),(28.465,6.585),(28.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.585),(28.655,6.755),(28.825,6.755),(28.825,6.585),(28.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,6.945),(27.575,7.115),(27.745,7.115),(27.745,6.945),(27.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,6.945),(27.935,7.115),(28.105,7.115),(28.105,6.945),(27.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,6.945),(28.295,7.115),(28.465,7.115),(28.465,6.945),(28.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,6.945),(28.655,7.115),(28.825,7.115),(28.825,6.945),(28.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.305),(27.575,7.475),(27.745,7.475),(27.745,7.305),(27.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.305),(27.935,7.475),(28.105,7.475),(28.105,7.305),(27.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.305),(28.295,7.475),(28.465,7.475),(28.465,7.305),(28.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.305),(28.655,7.475),(28.825,7.475),(28.825,7.305),(28.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,7.665),(27.575,7.835),(27.745,7.835),(27.745,7.665),(27.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,7.665),(27.935,7.835),(28.105,7.835),(28.105,7.665),(27.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,7.665),(28.295,7.835),(28.465,7.835),(28.465,7.665),(28.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,7.665),(28.655,7.835),(28.825,7.835),(28.825,7.665),(28.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.025),(27.575,8.195),(27.745,8.195),(27.745,8.025),(27.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.025),(27.935,8.195),(28.105,8.195),(28.105,8.025),(27.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.025),(28.295,8.195),(28.465,8.195),(28.465,8.025),(28.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.025),(28.655,8.195),(28.825,8.195),(28.825,8.025),(28.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.385),(27.575,8.555),(27.745,8.555),(27.745,8.385),(27.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.385),(27.935,8.555),(28.105,8.555),(28.105,8.385),(27.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.385),(28.295,8.555),(28.465,8.555),(28.465,8.385),(28.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.385),(28.655,8.555),(28.825,8.555),(28.825,8.385),(28.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,8.745),(27.575,8.915),(27.745,8.915),(27.745,8.745),(27.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,8.745),(27.935,8.915),(28.105,8.915),(28.105,8.745),(27.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,8.745),(28.295,8.915),(28.465,8.915),(28.465,8.745),(28.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,8.745),(28.655,8.915),(28.825,8.915),(28.825,8.745),(28.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.105),(27.575,9.275),(27.745,9.275),(27.745,9.105),(27.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.105),(27.935,9.275),(28.105,9.275),(28.105,9.105),(27.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.105),(28.295,9.275),(28.465,9.275),(28.465,9.105),(28.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.105),(28.655,9.275),(28.825,9.275),(28.825,9.105),(28.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.465),(27.575,9.635),(27.745,9.635),(27.745,9.465),(27.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.465),(27.935,9.635),(28.105,9.635),(28.105,9.465),(27.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.465),(28.295,9.635),(28.465,9.635),(28.465,9.465),(28.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.465),(28.655,9.635),(28.825,9.635),(28.825,9.465),(28.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,9.825),(27.575,9.995),(27.745,9.995),(27.745,9.825),(27.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,9.825),(27.935,9.995),(28.105,9.995),(28.105,9.825),(27.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,9.825),(28.295,9.995),(28.465,9.995),(28.465,9.825),(28.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,9.825),(28.655,9.995),(28.825,9.995),(28.825,9.825),(28.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.185),(27.575,10.355),(27.745,10.355),(27.745,10.185),(27.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.185),(27.935,10.355),(28.105,10.355),(28.105,10.185),(27.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.185),(28.295,10.355),(28.465,10.355),(28.465,10.185),(28.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.185),(28.655,10.355),(28.825,10.355),(28.825,10.185),(28.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.545),(27.575,10.715),(27.745,10.715),(27.745,10.545),(27.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.545),(27.935,10.715),(28.105,10.715),(28.105,10.545),(27.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.545),(28.295,10.715),(28.465,10.715),(28.465,10.545),(28.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.545),(28.655,10.715),(28.825,10.715),(28.825,10.545),(28.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,10.905),(27.575,11.075),(27.745,11.075),(27.745,10.905),(27.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,10.905),(27.935,11.075),(28.105,11.075),(28.105,10.905),(27.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,10.905),(28.295,11.075),(28.465,11.075),(28.465,10.905),(28.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,10.905),(28.655,11.075),(28.825,11.075),(28.825,10.905),(28.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.265),(27.575,11.435),(27.745,11.435),(27.745,11.265),(27.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.265),(27.935,11.435),(28.105,11.435),(28.105,11.265),(27.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.265),(28.295,11.435),(28.465,11.435),(28.465,11.265),(28.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.265),(28.655,11.435),(28.825,11.435),(28.825,11.265),(28.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.625),(27.575,11.795),(27.745,11.795),(27.745,11.625),(27.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.625),(27.935,11.795),(28.105,11.795),(28.105,11.625),(27.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.625),(28.295,11.795),(28.465,11.795),(28.465,11.625),(28.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.625),(28.655,11.795),(28.825,11.795),(28.825,11.625),(28.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,11.985),(27.575,12.155),(27.745,12.155),(27.745,11.985),(27.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,11.985),(27.935,12.155),(28.105,12.155),(28.105,11.985),(27.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,11.985),(28.295,12.155),(28.465,12.155),(28.465,11.985),(28.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,11.985),(28.655,12.155),(28.825,12.155),(28.825,11.985),(28.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.345),(27.575,12.515),(27.745,12.515),(27.745,12.345),(27.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.345),(27.935,12.515),(28.105,12.515),(28.105,12.345),(27.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.345),(28.295,12.515),(28.465,12.515),(28.465,12.345),(28.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.345),(28.655,12.515),(28.825,12.515),(28.825,12.345),(28.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,12.705),(27.575,12.875),(27.745,12.875),(27.745,12.705),(27.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,12.705),(27.935,12.875),(28.105,12.875),(28.105,12.705),(27.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,12.705),(28.295,12.875),(28.465,12.875),(28.465,12.705),(28.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,12.705),(28.655,12.875),(28.825,12.875),(28.825,12.705),(28.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.065),(27.575,13.235),(27.745,13.235),(27.745,13.065),(27.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.065),(27.935,13.235),(28.105,13.235),(28.105,13.065),(27.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.065),(28.295,13.235),(28.465,13.235),(28.465,13.065),(28.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.065),(28.655,13.235),(28.825,13.235),(28.825,13.065),(28.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.425),(27.575,13.595),(27.745,13.595),(27.745,13.425),(27.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.425),(27.935,13.595),(28.105,13.595),(28.105,13.425),(27.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.425),(28.295,13.595),(28.465,13.595),(28.465,13.425),(28.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.425),(28.655,13.595),(28.825,13.595),(28.825,13.425),(28.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,13.785),(27.575,13.955),(27.745,13.955),(27.745,13.785),(27.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,13.785),(27.935,13.955),(28.105,13.955),(28.105,13.785),(27.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,13.785),(28.295,13.955),(28.465,13.955),(28.465,13.785),(28.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,13.785),(28.655,13.955),(28.825,13.955),(28.825,13.785),(28.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.145),(27.575,14.315),(27.745,14.315),(27.745,14.145),(27.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.145),(27.935,14.315),(28.105,14.315),(28.105,14.145),(27.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.145),(28.295,14.315),(28.465,14.315),(28.465,14.145),(28.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.145),(28.655,14.315),(28.825,14.315),(28.825,14.145),(28.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.505),(27.575,14.675),(27.745,14.675),(27.745,14.505),(27.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.505),(27.935,14.675),(28.105,14.675),(28.105,14.505),(27.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.505),(28.295,14.675),(28.465,14.675),(28.465,14.505),(28.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.505),(28.655,14.675),(28.825,14.675),(28.825,14.505),(28.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,14.865),(27.575,15.035),(27.745,15.035),(27.745,14.865),(27.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,14.865),(27.935,15.035),(28.105,15.035),(28.105,14.865),(27.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,14.865),(28.295,15.035),(28.465,15.035),(28.465,14.865),(28.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,14.865),(28.655,15.035),(28.825,15.035),(28.825,14.865),(28.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.225),(27.575,15.395),(27.745,15.395),(27.745,15.225),(27.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.225),(27.935,15.395),(28.105,15.395),(28.105,15.225),(27.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.225),(28.295,15.395),(28.465,15.395),(28.465,15.225),(28.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.225),(28.655,15.395),(28.825,15.395),(28.825,15.225),(28.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.585),(27.575,15.755),(27.745,15.755),(27.745,15.585),(27.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.585),(27.935,15.755),(28.105,15.755),(28.105,15.585),(27.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.585),(28.295,15.755),(28.465,15.755),(28.465,15.585),(28.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.585),(28.655,15.755),(28.825,15.755),(28.825,15.585),(28.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,15.945),(27.575,16.115),(27.745,16.115),(27.745,15.945),(27.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,15.945),(27.935,16.115),(28.105,16.115),(28.105,15.945),(27.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,15.945),(28.295,16.115),(28.465,16.115),(28.465,15.945),(28.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,15.945),(28.655,16.115),(28.825,16.115),(28.825,15.945),(28.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.305),(27.575,16.475),(27.745,16.475),(27.745,16.305),(27.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.305),(27.935,16.475),(28.105,16.475),(28.105,16.305),(27.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.305),(28.295,16.475),(28.465,16.475),(28.465,16.305),(28.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.305),(28.655,16.475),(28.825,16.475),(28.825,16.305),(28.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,16.665),(27.575,16.835),(27.745,16.835),(27.745,16.665),(27.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,16.665),(27.935,16.835),(28.105,16.835),(28.105,16.665),(27.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,16.665),(28.295,16.835),(28.465,16.835),(28.465,16.665),(28.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,16.665),(28.655,16.835),(28.825,16.835),(28.825,16.665),(28.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.025),(27.575,17.195),(27.745,17.195),(27.745,17.025),(27.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.025),(27.935,17.195),(28.105,17.195),(28.105,17.025),(27.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.025),(28.295,17.195),(28.465,17.195),(28.465,17.025),(28.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.025),(28.655,17.195),(28.825,17.195),(28.825,17.025),(28.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.385),(27.575,17.555),(27.745,17.555),(27.745,17.385),(27.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.385),(27.935,17.555),(28.105,17.555),(28.105,17.385),(27.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.385),(28.295,17.555),(28.465,17.555),(28.465,17.385),(28.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.385),(28.655,17.555),(28.825,17.555),(28.825,17.385),(28.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,17.745),(27.575,17.915),(27.745,17.915),(27.745,17.745),(27.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,17.745),(27.935,17.915),(28.105,17.915),(28.105,17.745),(27.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,17.745),(28.295,17.915),(28.465,17.915),(28.465,17.745),(28.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,17.745),(28.655,17.915),(28.825,17.915),(28.825,17.745),(28.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.105),(27.575,18.275),(27.745,18.275),(27.745,18.105),(27.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.105),(27.935,18.275),(28.105,18.275),(28.105,18.105),(27.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.105),(28.295,18.275),(28.465,18.275),(28.465,18.105),(28.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.105),(28.655,18.275),(28.825,18.275),(28.825,18.105),(28.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.465),(27.575,18.635),(27.745,18.635),(27.745,18.465),(27.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.465),(27.935,18.635),(28.105,18.635),(28.105,18.465),(27.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.465),(28.295,18.635),(28.465,18.635),(28.465,18.465),(28.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.465),(28.655,18.635),(28.825,18.635),(28.825,18.465),(28.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,18.825),(27.575,18.995),(27.745,18.995),(27.745,18.825),(27.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,18.825),(27.935,18.995),(28.105,18.995),(28.105,18.825),(27.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,18.825),(28.295,18.995),(28.465,18.995),(28.465,18.825),(28.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,18.825),(28.655,18.995),(28.825,18.995),(28.825,18.825),(28.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.575,19.185),(27.575,19.355),(27.745,19.355),(27.745,19.185),(27.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.935,19.185),(27.935,19.355),(28.105,19.355),(28.105,19.185),(27.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.295,19.185),(28.295,19.355),(28.465,19.355),(28.465,19.185),(28.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.655,19.185),(28.655,19.355),(28.825,19.355),(28.825,19.185),(28.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,2.985),(65.975,3.155),(66.145,3.155),(66.145,2.985),(65.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,2.985),(66.335,3.155),(66.505,3.155),(66.505,2.985),(66.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,2.985),(66.695,3.155),(66.865,3.155),(66.865,2.985),(66.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,2.985),(67.055,3.155),(67.225,3.155),(67.225,2.985),(67.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.345),(65.975,3.515),(66.145,3.515),(66.145,3.345),(65.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.345),(66.335,3.515),(66.505,3.515),(66.505,3.345),(66.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.345),(66.695,3.515),(66.865,3.515),(66.865,3.345),(66.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.345),(67.055,3.515),(67.225,3.515),(67.225,3.345),(67.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,3.705),(65.975,3.875),(66.145,3.875),(66.145,3.705),(65.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,3.705),(66.335,3.875),(66.505,3.875),(66.505,3.705),(66.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,3.705),(66.695,3.875),(66.865,3.875),(66.865,3.705),(66.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,3.705),(67.055,3.875),(67.225,3.875),(67.225,3.705),(67.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.065),(65.975,4.235),(66.145,4.235),(66.145,4.065),(65.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.065),(66.335,4.235),(66.505,4.235),(66.505,4.065),(66.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.065),(66.695,4.235),(66.865,4.235),(66.865,4.065),(66.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.065),(67.055,4.235),(67.225,4.235),(67.225,4.065),(67.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.425),(65.975,4.595),(66.145,4.595),(66.145,4.425),(65.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.425),(66.335,4.595),(66.505,4.595),(66.505,4.425),(66.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.425),(66.695,4.595),(66.865,4.595),(66.865,4.425),(66.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.425),(67.055,4.595),(67.225,4.595),(67.225,4.425),(67.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,4.785),(65.975,4.955),(66.145,4.955),(66.145,4.785),(65.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,4.785),(66.335,4.955),(66.505,4.955),(66.505,4.785),(66.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,4.785),(66.695,4.955),(66.865,4.955),(66.865,4.785),(66.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,4.785),(67.055,4.955),(67.225,4.955),(67.225,4.785),(67.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.145),(65.975,5.315),(66.145,5.315),(66.145,5.145),(65.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.145),(66.335,5.315),(66.505,5.315),(66.505,5.145),(66.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.145),(66.695,5.315),(66.865,5.315),(66.865,5.145),(66.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.145),(67.055,5.315),(67.225,5.315),(67.225,5.145),(67.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.505),(65.975,5.675),(66.145,5.675),(66.145,5.505),(65.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.505),(66.335,5.675),(66.505,5.675),(66.505,5.505),(66.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.505),(66.695,5.675),(66.865,5.675),(66.865,5.505),(66.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.505),(67.055,5.675),(67.225,5.675),(67.225,5.505),(67.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,5.865),(65.975,6.035),(66.145,6.035),(66.145,5.865),(65.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,5.865),(66.335,6.035),(66.505,6.035),(66.505,5.865),(66.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,5.865),(66.695,6.035),(66.865,6.035),(66.865,5.865),(66.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,5.865),(67.055,6.035),(67.225,6.035),(67.225,5.865),(67.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.225),(65.975,6.395),(66.145,6.395),(66.145,6.225),(65.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.225),(66.335,6.395),(66.505,6.395),(66.505,6.225),(66.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.225),(66.695,6.395),(66.865,6.395),(66.865,6.225),(66.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.225),(67.055,6.395),(67.225,6.395),(67.225,6.225),(67.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.585),(65.975,6.755),(66.145,6.755),(66.145,6.585),(65.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.585),(66.335,6.755),(66.505,6.755),(66.505,6.585),(66.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.585),(66.695,6.755),(66.865,6.755),(66.865,6.585),(66.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.585),(67.055,6.755),(67.225,6.755),(67.225,6.585),(67.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,6.945),(65.975,7.115),(66.145,7.115),(66.145,6.945),(65.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,6.945),(66.335,7.115),(66.505,7.115),(66.505,6.945),(66.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,6.945),(66.695,7.115),(66.865,7.115),(66.865,6.945),(66.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,6.945),(67.055,7.115),(67.225,7.115),(67.225,6.945),(67.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.305),(65.975,7.475),(66.145,7.475),(66.145,7.305),(65.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.305),(66.335,7.475),(66.505,7.475),(66.505,7.305),(66.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.305),(66.695,7.475),(66.865,7.475),(66.865,7.305),(66.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.305),(67.055,7.475),(67.225,7.475),(67.225,7.305),(67.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,7.665),(65.975,7.835),(66.145,7.835),(66.145,7.665),(65.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,7.665),(66.335,7.835),(66.505,7.835),(66.505,7.665),(66.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,7.665),(66.695,7.835),(66.865,7.835),(66.865,7.665),(66.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,7.665),(67.055,7.835),(67.225,7.835),(67.225,7.665),(67.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.025),(65.975,8.195),(66.145,8.195),(66.145,8.025),(65.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.025),(66.335,8.195),(66.505,8.195),(66.505,8.025),(66.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.025),(66.695,8.195),(66.865,8.195),(66.865,8.025),(66.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.025),(67.055,8.195),(67.225,8.195),(67.225,8.025),(67.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.385),(65.975,8.555),(66.145,8.555),(66.145,8.385),(65.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.385),(66.335,8.555),(66.505,8.555),(66.505,8.385),(66.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.385),(66.695,8.555),(66.865,8.555),(66.865,8.385),(66.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.385),(67.055,8.555),(67.225,8.555),(67.225,8.385),(67.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,8.745),(65.975,8.915),(66.145,8.915),(66.145,8.745),(65.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,8.745),(66.335,8.915),(66.505,8.915),(66.505,8.745),(66.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,8.745),(66.695,8.915),(66.865,8.915),(66.865,8.745),(66.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,8.745),(67.055,8.915),(67.225,8.915),(67.225,8.745),(67.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.105),(65.975,9.275),(66.145,9.275),(66.145,9.105),(65.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.105),(66.335,9.275),(66.505,9.275),(66.505,9.105),(66.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.105),(66.695,9.275),(66.865,9.275),(66.865,9.105),(66.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.105),(67.055,9.275),(67.225,9.275),(67.225,9.105),(67.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.465),(65.975,9.635),(66.145,9.635),(66.145,9.465),(65.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.465),(66.335,9.635),(66.505,9.635),(66.505,9.465),(66.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.465),(66.695,9.635),(66.865,9.635),(66.865,9.465),(66.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.465),(67.055,9.635),(67.225,9.635),(67.225,9.465),(67.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,9.825),(65.975,9.995),(66.145,9.995),(66.145,9.825),(65.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,9.825),(66.335,9.995),(66.505,9.995),(66.505,9.825),(66.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,9.825),(66.695,9.995),(66.865,9.995),(66.865,9.825),(66.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,9.825),(67.055,9.995),(67.225,9.995),(67.225,9.825),(67.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.185),(65.975,10.355),(66.145,10.355),(66.145,10.185),(65.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.185),(66.335,10.355),(66.505,10.355),(66.505,10.185),(66.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.185),(66.695,10.355),(66.865,10.355),(66.865,10.185),(66.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.185),(67.055,10.355),(67.225,10.355),(67.225,10.185),(67.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.545),(65.975,10.715),(66.145,10.715),(66.145,10.545),(65.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.545),(66.335,10.715),(66.505,10.715),(66.505,10.545),(66.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.545),(66.695,10.715),(66.865,10.715),(66.865,10.545),(66.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.545),(67.055,10.715),(67.225,10.715),(67.225,10.545),(67.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,10.905),(65.975,11.075),(66.145,11.075),(66.145,10.905),(65.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,10.905),(66.335,11.075),(66.505,11.075),(66.505,10.905),(66.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,10.905),(66.695,11.075),(66.865,11.075),(66.865,10.905),(66.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,10.905),(67.055,11.075),(67.225,11.075),(67.225,10.905),(67.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.265),(65.975,11.435),(66.145,11.435),(66.145,11.265),(65.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.265),(66.335,11.435),(66.505,11.435),(66.505,11.265),(66.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.265),(66.695,11.435),(66.865,11.435),(66.865,11.265),(66.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.265),(67.055,11.435),(67.225,11.435),(67.225,11.265),(67.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.625),(65.975,11.795),(66.145,11.795),(66.145,11.625),(65.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.625),(66.335,11.795),(66.505,11.795),(66.505,11.625),(66.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.625),(66.695,11.795),(66.865,11.795),(66.865,11.625),(66.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.625),(67.055,11.795),(67.225,11.795),(67.225,11.625),(67.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,11.985),(65.975,12.155),(66.145,12.155),(66.145,11.985),(65.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,11.985),(66.335,12.155),(66.505,12.155),(66.505,11.985),(66.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,11.985),(66.695,12.155),(66.865,12.155),(66.865,11.985),(66.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,11.985),(67.055,12.155),(67.225,12.155),(67.225,11.985),(67.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.345),(65.975,12.515),(66.145,12.515),(66.145,12.345),(65.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.345),(66.335,12.515),(66.505,12.515),(66.505,12.345),(66.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.345),(66.695,12.515),(66.865,12.515),(66.865,12.345),(66.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.345),(67.055,12.515),(67.225,12.515),(67.225,12.345),(67.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,12.705),(65.975,12.875),(66.145,12.875),(66.145,12.705),(65.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,12.705),(66.335,12.875),(66.505,12.875),(66.505,12.705),(66.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,12.705),(66.695,12.875),(66.865,12.875),(66.865,12.705),(66.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,12.705),(67.055,12.875),(67.225,12.875),(67.225,12.705),(67.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.065),(65.975,13.235),(66.145,13.235),(66.145,13.065),(65.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.065),(66.335,13.235),(66.505,13.235),(66.505,13.065),(66.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.065),(66.695,13.235),(66.865,13.235),(66.865,13.065),(66.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.065),(67.055,13.235),(67.225,13.235),(67.225,13.065),(67.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.425),(65.975,13.595),(66.145,13.595),(66.145,13.425),(65.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.425),(66.335,13.595),(66.505,13.595),(66.505,13.425),(66.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.425),(66.695,13.595),(66.865,13.595),(66.865,13.425),(66.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.425),(67.055,13.595),(67.225,13.595),(67.225,13.425),(67.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,13.785),(65.975,13.955),(66.145,13.955),(66.145,13.785),(65.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,13.785),(66.335,13.955),(66.505,13.955),(66.505,13.785),(66.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,13.785),(66.695,13.955),(66.865,13.955),(66.865,13.785),(66.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,13.785),(67.055,13.955),(67.225,13.955),(67.225,13.785),(67.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.145),(65.975,14.315),(66.145,14.315),(66.145,14.145),(65.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.145),(66.335,14.315),(66.505,14.315),(66.505,14.145),(66.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.145),(66.695,14.315),(66.865,14.315),(66.865,14.145),(66.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.145),(67.055,14.315),(67.225,14.315),(67.225,14.145),(67.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.505),(65.975,14.675),(66.145,14.675),(66.145,14.505),(65.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.505),(66.335,14.675),(66.505,14.675),(66.505,14.505),(66.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.505),(66.695,14.675),(66.865,14.675),(66.865,14.505),(66.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.505),(67.055,14.675),(67.225,14.675),(67.225,14.505),(67.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,14.865),(65.975,15.035),(66.145,15.035),(66.145,14.865),(65.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,14.865),(66.335,15.035),(66.505,15.035),(66.505,14.865),(66.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,14.865),(66.695,15.035),(66.865,15.035),(66.865,14.865),(66.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,14.865),(67.055,15.035),(67.225,15.035),(67.225,14.865),(67.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.225),(65.975,15.395),(66.145,15.395),(66.145,15.225),(65.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.225),(66.335,15.395),(66.505,15.395),(66.505,15.225),(66.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.225),(66.695,15.395),(66.865,15.395),(66.865,15.225),(66.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.225),(67.055,15.395),(67.225,15.395),(67.225,15.225),(67.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.585),(65.975,15.755),(66.145,15.755),(66.145,15.585),(65.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.585),(66.335,15.755),(66.505,15.755),(66.505,15.585),(66.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.585),(66.695,15.755),(66.865,15.755),(66.865,15.585),(66.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.585),(67.055,15.755),(67.225,15.755),(67.225,15.585),(67.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,15.945),(65.975,16.115),(66.145,16.115),(66.145,15.945),(65.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,15.945),(66.335,16.115),(66.505,16.115),(66.505,15.945),(66.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,15.945),(66.695,16.115),(66.865,16.115),(66.865,15.945),(66.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,15.945),(67.055,16.115),(67.225,16.115),(67.225,15.945),(67.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.305),(65.975,16.475),(66.145,16.475),(66.145,16.305),(65.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.305),(66.335,16.475),(66.505,16.475),(66.505,16.305),(66.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.305),(66.695,16.475),(66.865,16.475),(66.865,16.305),(66.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.305),(67.055,16.475),(67.225,16.475),(67.225,16.305),(67.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,16.665),(65.975,16.835),(66.145,16.835),(66.145,16.665),(65.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,16.665),(66.335,16.835),(66.505,16.835),(66.505,16.665),(66.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,16.665),(66.695,16.835),(66.865,16.835),(66.865,16.665),(66.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,16.665),(67.055,16.835),(67.225,16.835),(67.225,16.665),(67.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.025),(65.975,17.195),(66.145,17.195),(66.145,17.025),(65.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.025),(66.335,17.195),(66.505,17.195),(66.505,17.025),(66.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.025),(66.695,17.195),(66.865,17.195),(66.865,17.025),(66.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.025),(67.055,17.195),(67.225,17.195),(67.225,17.025),(67.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.385),(65.975,17.555),(66.145,17.555),(66.145,17.385),(65.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.385),(66.335,17.555),(66.505,17.555),(66.505,17.385),(66.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.385),(66.695,17.555),(66.865,17.555),(66.865,17.385),(66.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.385),(67.055,17.555),(67.225,17.555),(67.225,17.385),(67.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,17.745),(65.975,17.915),(66.145,17.915),(66.145,17.745),(65.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,17.745),(66.335,17.915),(66.505,17.915),(66.505,17.745),(66.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,17.745),(66.695,17.915),(66.865,17.915),(66.865,17.745),(66.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,17.745),(67.055,17.915),(67.225,17.915),(67.225,17.745),(67.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.105),(65.975,18.275),(66.145,18.275),(66.145,18.105),(65.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.105),(66.335,18.275),(66.505,18.275),(66.505,18.105),(66.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.105),(66.695,18.275),(66.865,18.275),(66.865,18.105),(66.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.105),(67.055,18.275),(67.225,18.275),(67.225,18.105),(67.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.465),(65.975,18.635),(66.145,18.635),(66.145,18.465),(65.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.465),(66.335,18.635),(66.505,18.635),(66.505,18.465),(66.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.465),(66.695,18.635),(66.865,18.635),(66.865,18.465),(66.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.465),(67.055,18.635),(67.225,18.635),(67.225,18.465),(67.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,18.825),(65.975,18.995),(66.145,18.995),(66.145,18.825),(65.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,18.825),(66.335,18.995),(66.505,18.995),(66.505,18.825),(66.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,18.825),(66.695,18.995),(66.865,18.995),(66.865,18.825),(66.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,18.825),(67.055,18.995),(67.225,18.995),(67.225,18.825),(67.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.975,19.185),(65.975,19.355),(66.145,19.355),(66.145,19.185),(65.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.335,19.185),(66.335,19.355),(66.505,19.355),(66.505,19.185),(66.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.695,19.185),(66.695,19.355),(66.865,19.355),(66.865,19.185),(66.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.055,19.185),(67.055,19.355),(67.225,19.355),(67.225,19.185),(67.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,2.985),(75.575,3.155),(75.745,3.155),(75.745,2.985),(75.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,2.985),(75.935,3.155),(76.105,3.155),(76.105,2.985),(75.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,2.985),(76.295,3.155),(76.465,3.155),(76.465,2.985),(76.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,2.985),(76.655,3.155),(76.825,3.155),(76.825,2.985),(76.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.345),(75.575,3.515),(75.745,3.515),(75.745,3.345),(75.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.345),(75.935,3.515),(76.105,3.515),(76.105,3.345),(75.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.345),(76.295,3.515),(76.465,3.515),(76.465,3.345),(76.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.345),(76.655,3.515),(76.825,3.515),(76.825,3.345),(76.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,3.705),(75.575,3.875),(75.745,3.875),(75.745,3.705),(75.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,3.705),(75.935,3.875),(76.105,3.875),(76.105,3.705),(75.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,3.705),(76.295,3.875),(76.465,3.875),(76.465,3.705),(76.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,3.705),(76.655,3.875),(76.825,3.875),(76.825,3.705),(76.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.065),(75.575,4.235),(75.745,4.235),(75.745,4.065),(75.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.065),(75.935,4.235),(76.105,4.235),(76.105,4.065),(75.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.065),(76.295,4.235),(76.465,4.235),(76.465,4.065),(76.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.065),(76.655,4.235),(76.825,4.235),(76.825,4.065),(76.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.425),(75.575,4.595),(75.745,4.595),(75.745,4.425),(75.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.425),(75.935,4.595),(76.105,4.595),(76.105,4.425),(75.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.425),(76.295,4.595),(76.465,4.595),(76.465,4.425),(76.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.425),(76.655,4.595),(76.825,4.595),(76.825,4.425),(76.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,4.785),(75.575,4.955),(75.745,4.955),(75.745,4.785),(75.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,4.785),(75.935,4.955),(76.105,4.955),(76.105,4.785),(75.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,4.785),(76.295,4.955),(76.465,4.955),(76.465,4.785),(76.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,4.785),(76.655,4.955),(76.825,4.955),(76.825,4.785),(76.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.145),(75.575,5.315),(75.745,5.315),(75.745,5.145),(75.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.145),(75.935,5.315),(76.105,5.315),(76.105,5.145),(75.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.145),(76.295,5.315),(76.465,5.315),(76.465,5.145),(76.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.145),(76.655,5.315),(76.825,5.315),(76.825,5.145),(76.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.505),(75.575,5.675),(75.745,5.675),(75.745,5.505),(75.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.505),(75.935,5.675),(76.105,5.675),(76.105,5.505),(75.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.505),(76.295,5.675),(76.465,5.675),(76.465,5.505),(76.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.505),(76.655,5.675),(76.825,5.675),(76.825,5.505),(76.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,5.865),(75.575,6.035),(75.745,6.035),(75.745,5.865),(75.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,5.865),(75.935,6.035),(76.105,6.035),(76.105,5.865),(75.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,5.865),(76.295,6.035),(76.465,6.035),(76.465,5.865),(76.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,5.865),(76.655,6.035),(76.825,6.035),(76.825,5.865),(76.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.225),(75.575,6.395),(75.745,6.395),(75.745,6.225),(75.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.225),(75.935,6.395),(76.105,6.395),(76.105,6.225),(75.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.225),(76.295,6.395),(76.465,6.395),(76.465,6.225),(76.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.225),(76.655,6.395),(76.825,6.395),(76.825,6.225),(76.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.585),(75.575,6.755),(75.745,6.755),(75.745,6.585),(75.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.585),(75.935,6.755),(76.105,6.755),(76.105,6.585),(75.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.585),(76.295,6.755),(76.465,6.755),(76.465,6.585),(76.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.585),(76.655,6.755),(76.825,6.755),(76.825,6.585),(76.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,6.945),(75.575,7.115),(75.745,7.115),(75.745,6.945),(75.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,6.945),(75.935,7.115),(76.105,7.115),(76.105,6.945),(75.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,6.945),(76.295,7.115),(76.465,7.115),(76.465,6.945),(76.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,6.945),(76.655,7.115),(76.825,7.115),(76.825,6.945),(76.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.305),(75.575,7.475),(75.745,7.475),(75.745,7.305),(75.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.305),(75.935,7.475),(76.105,7.475),(76.105,7.305),(75.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.305),(76.295,7.475),(76.465,7.475),(76.465,7.305),(76.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.305),(76.655,7.475),(76.825,7.475),(76.825,7.305),(76.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,7.665),(75.575,7.835),(75.745,7.835),(75.745,7.665),(75.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,7.665),(75.935,7.835),(76.105,7.835),(76.105,7.665),(75.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,7.665),(76.295,7.835),(76.465,7.835),(76.465,7.665),(76.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,7.665),(76.655,7.835),(76.825,7.835),(76.825,7.665),(76.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.025),(75.575,8.195),(75.745,8.195),(75.745,8.025),(75.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.025),(75.935,8.195),(76.105,8.195),(76.105,8.025),(75.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.025),(76.295,8.195),(76.465,8.195),(76.465,8.025),(76.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.025),(76.655,8.195),(76.825,8.195),(76.825,8.025),(76.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.385),(75.575,8.555),(75.745,8.555),(75.745,8.385),(75.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.385),(75.935,8.555),(76.105,8.555),(76.105,8.385),(75.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.385),(76.295,8.555),(76.465,8.555),(76.465,8.385),(76.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.385),(76.655,8.555),(76.825,8.555),(76.825,8.385),(76.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,8.745),(75.575,8.915),(75.745,8.915),(75.745,8.745),(75.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,8.745),(75.935,8.915),(76.105,8.915),(76.105,8.745),(75.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,8.745),(76.295,8.915),(76.465,8.915),(76.465,8.745),(76.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,8.745),(76.655,8.915),(76.825,8.915),(76.825,8.745),(76.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.105),(75.575,9.275),(75.745,9.275),(75.745,9.105),(75.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.105),(75.935,9.275),(76.105,9.275),(76.105,9.105),(75.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.105),(76.295,9.275),(76.465,9.275),(76.465,9.105),(76.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.105),(76.655,9.275),(76.825,9.275),(76.825,9.105),(76.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.465),(75.575,9.635),(75.745,9.635),(75.745,9.465),(75.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.465),(75.935,9.635),(76.105,9.635),(76.105,9.465),(75.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.465),(76.295,9.635),(76.465,9.635),(76.465,9.465),(76.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.465),(76.655,9.635),(76.825,9.635),(76.825,9.465),(76.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,9.825),(75.575,9.995),(75.745,9.995),(75.745,9.825),(75.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,9.825),(75.935,9.995),(76.105,9.995),(76.105,9.825),(75.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,9.825),(76.295,9.995),(76.465,9.995),(76.465,9.825),(76.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,9.825),(76.655,9.995),(76.825,9.995),(76.825,9.825),(76.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.185),(75.575,10.355),(75.745,10.355),(75.745,10.185),(75.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.185),(75.935,10.355),(76.105,10.355),(76.105,10.185),(75.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.185),(76.295,10.355),(76.465,10.355),(76.465,10.185),(76.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.185),(76.655,10.355),(76.825,10.355),(76.825,10.185),(76.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.545),(75.575,10.715),(75.745,10.715),(75.745,10.545),(75.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.545),(75.935,10.715),(76.105,10.715),(76.105,10.545),(75.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.545),(76.295,10.715),(76.465,10.715),(76.465,10.545),(76.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.545),(76.655,10.715),(76.825,10.715),(76.825,10.545),(76.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,10.905),(75.575,11.075),(75.745,11.075),(75.745,10.905),(75.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,10.905),(75.935,11.075),(76.105,11.075),(76.105,10.905),(75.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,10.905),(76.295,11.075),(76.465,11.075),(76.465,10.905),(76.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,10.905),(76.655,11.075),(76.825,11.075),(76.825,10.905),(76.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.265),(75.575,11.435),(75.745,11.435),(75.745,11.265),(75.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.265),(75.935,11.435),(76.105,11.435),(76.105,11.265),(75.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.265),(76.295,11.435),(76.465,11.435),(76.465,11.265),(76.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.265),(76.655,11.435),(76.825,11.435),(76.825,11.265),(76.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.625),(75.575,11.795),(75.745,11.795),(75.745,11.625),(75.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.625),(75.935,11.795),(76.105,11.795),(76.105,11.625),(75.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.625),(76.295,11.795),(76.465,11.795),(76.465,11.625),(76.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.625),(76.655,11.795),(76.825,11.795),(76.825,11.625),(76.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,11.985),(75.575,12.155),(75.745,12.155),(75.745,11.985),(75.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,11.985),(75.935,12.155),(76.105,12.155),(76.105,11.985),(75.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,11.985),(76.295,12.155),(76.465,12.155),(76.465,11.985),(76.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,11.985),(76.655,12.155),(76.825,12.155),(76.825,11.985),(76.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.345),(75.575,12.515),(75.745,12.515),(75.745,12.345),(75.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.345),(75.935,12.515),(76.105,12.515),(76.105,12.345),(75.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.345),(76.295,12.515),(76.465,12.515),(76.465,12.345),(76.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.345),(76.655,12.515),(76.825,12.515),(76.825,12.345),(76.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,12.705),(75.575,12.875),(75.745,12.875),(75.745,12.705),(75.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,12.705),(75.935,12.875),(76.105,12.875),(76.105,12.705),(75.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,12.705),(76.295,12.875),(76.465,12.875),(76.465,12.705),(76.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,12.705),(76.655,12.875),(76.825,12.875),(76.825,12.705),(76.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.065),(75.575,13.235),(75.745,13.235),(75.745,13.065),(75.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.065),(75.935,13.235),(76.105,13.235),(76.105,13.065),(75.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.065),(76.295,13.235),(76.465,13.235),(76.465,13.065),(76.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.065),(76.655,13.235),(76.825,13.235),(76.825,13.065),(76.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.425),(75.575,13.595),(75.745,13.595),(75.745,13.425),(75.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.425),(75.935,13.595),(76.105,13.595),(76.105,13.425),(75.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.425),(76.295,13.595),(76.465,13.595),(76.465,13.425),(76.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.425),(76.655,13.595),(76.825,13.595),(76.825,13.425),(76.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,13.785),(75.575,13.955),(75.745,13.955),(75.745,13.785),(75.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,13.785),(75.935,13.955),(76.105,13.955),(76.105,13.785),(75.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,13.785),(76.295,13.955),(76.465,13.955),(76.465,13.785),(76.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,13.785),(76.655,13.955),(76.825,13.955),(76.825,13.785),(76.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.145),(75.575,14.315),(75.745,14.315),(75.745,14.145),(75.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.145),(75.935,14.315),(76.105,14.315),(76.105,14.145),(75.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.145),(76.295,14.315),(76.465,14.315),(76.465,14.145),(76.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.145),(76.655,14.315),(76.825,14.315),(76.825,14.145),(76.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.505),(75.575,14.675),(75.745,14.675),(75.745,14.505),(75.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.505),(75.935,14.675),(76.105,14.675),(76.105,14.505),(75.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.505),(76.295,14.675),(76.465,14.675),(76.465,14.505),(76.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.505),(76.655,14.675),(76.825,14.675),(76.825,14.505),(76.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,14.865),(75.575,15.035),(75.745,15.035),(75.745,14.865),(75.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,14.865),(75.935,15.035),(76.105,15.035),(76.105,14.865),(75.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,14.865),(76.295,15.035),(76.465,15.035),(76.465,14.865),(76.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,14.865),(76.655,15.035),(76.825,15.035),(76.825,14.865),(76.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.225),(75.575,15.395),(75.745,15.395),(75.745,15.225),(75.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.225),(75.935,15.395),(76.105,15.395),(76.105,15.225),(75.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.225),(76.295,15.395),(76.465,15.395),(76.465,15.225),(76.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.225),(76.655,15.395),(76.825,15.395),(76.825,15.225),(76.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.585),(75.575,15.755),(75.745,15.755),(75.745,15.585),(75.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.585),(75.935,15.755),(76.105,15.755),(76.105,15.585),(75.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.585),(76.295,15.755),(76.465,15.755),(76.465,15.585),(76.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.585),(76.655,15.755),(76.825,15.755),(76.825,15.585),(76.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,15.945),(75.575,16.115),(75.745,16.115),(75.745,15.945),(75.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,15.945),(75.935,16.115),(76.105,16.115),(76.105,15.945),(75.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,15.945),(76.295,16.115),(76.465,16.115),(76.465,15.945),(76.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,15.945),(76.655,16.115),(76.825,16.115),(76.825,15.945),(76.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.305),(75.575,16.475),(75.745,16.475),(75.745,16.305),(75.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.305),(75.935,16.475),(76.105,16.475),(76.105,16.305),(75.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.305),(76.295,16.475),(76.465,16.475),(76.465,16.305),(76.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.305),(76.655,16.475),(76.825,16.475),(76.825,16.305),(76.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,16.665),(75.575,16.835),(75.745,16.835),(75.745,16.665),(75.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,16.665),(75.935,16.835),(76.105,16.835),(76.105,16.665),(75.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,16.665),(76.295,16.835),(76.465,16.835),(76.465,16.665),(76.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,16.665),(76.655,16.835),(76.825,16.835),(76.825,16.665),(76.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.025),(75.575,17.195),(75.745,17.195),(75.745,17.025),(75.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.025),(75.935,17.195),(76.105,17.195),(76.105,17.025),(75.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.025),(76.295,17.195),(76.465,17.195),(76.465,17.025),(76.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.025),(76.655,17.195),(76.825,17.195),(76.825,17.025),(76.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.385),(75.575,17.555),(75.745,17.555),(75.745,17.385),(75.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.385),(75.935,17.555),(76.105,17.555),(76.105,17.385),(75.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.385),(76.295,17.555),(76.465,17.555),(76.465,17.385),(76.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.385),(76.655,17.555),(76.825,17.555),(76.825,17.385),(76.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,17.745),(75.575,17.915),(75.745,17.915),(75.745,17.745),(75.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,17.745),(75.935,17.915),(76.105,17.915),(76.105,17.745),(75.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,17.745),(76.295,17.915),(76.465,17.915),(76.465,17.745),(76.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,17.745),(76.655,17.915),(76.825,17.915),(76.825,17.745),(76.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.105),(75.575,18.275),(75.745,18.275),(75.745,18.105),(75.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.105),(75.935,18.275),(76.105,18.275),(76.105,18.105),(75.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.105),(76.295,18.275),(76.465,18.275),(76.465,18.105),(76.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.105),(76.655,18.275),(76.825,18.275),(76.825,18.105),(76.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.465),(75.575,18.635),(75.745,18.635),(75.745,18.465),(75.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.465),(75.935,18.635),(76.105,18.635),(76.105,18.465),(75.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.465),(76.295,18.635),(76.465,18.635),(76.465,18.465),(76.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.465),(76.655,18.635),(76.825,18.635),(76.825,18.465),(76.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,18.825),(75.575,18.995),(75.745,18.995),(75.745,18.825),(75.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,18.825),(75.935,18.995),(76.105,18.995),(76.105,18.825),(75.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,18.825),(76.295,18.995),(76.465,18.995),(76.465,18.825),(76.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,18.825),(76.655,18.995),(76.825,18.995),(76.825,18.825),(76.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.575,19.185),(75.575,19.355),(75.745,19.355),(75.745,19.185),(75.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((75.935,19.185),(75.935,19.355),(76.105,19.355),(76.105,19.185),(75.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.295,19.185),(76.295,19.355),(76.465,19.355),(76.465,19.185),(76.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((76.655,19.185),(76.655,19.355),(76.825,19.355),(76.825,19.185),(76.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,2.985),(17.975,3.155),(18.145,3.155),(18.145,2.985),(17.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,2.985),(18.335,3.155),(18.505,3.155),(18.505,2.985),(18.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,2.985),(18.695,3.155),(18.865,3.155),(18.865,2.985),(18.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,2.985),(19.055,3.155),(19.225,3.155),(19.225,2.985),(19.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.345),(17.975,3.515),(18.145,3.515),(18.145,3.345),(17.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.345),(18.335,3.515),(18.505,3.515),(18.505,3.345),(18.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.345),(18.695,3.515),(18.865,3.515),(18.865,3.345),(18.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.345),(19.055,3.515),(19.225,3.515),(19.225,3.345),(19.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,3.705),(17.975,3.875),(18.145,3.875),(18.145,3.705),(17.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,3.705),(18.335,3.875),(18.505,3.875),(18.505,3.705),(18.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,3.705),(18.695,3.875),(18.865,3.875),(18.865,3.705),(18.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,3.705),(19.055,3.875),(19.225,3.875),(19.225,3.705),(19.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.065),(17.975,4.235),(18.145,4.235),(18.145,4.065),(17.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.065),(18.335,4.235),(18.505,4.235),(18.505,4.065),(18.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.065),(18.695,4.235),(18.865,4.235),(18.865,4.065),(18.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.065),(19.055,4.235),(19.225,4.235),(19.225,4.065),(19.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.425),(17.975,4.595),(18.145,4.595),(18.145,4.425),(17.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.425),(18.335,4.595),(18.505,4.595),(18.505,4.425),(18.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.425),(18.695,4.595),(18.865,4.595),(18.865,4.425),(18.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.425),(19.055,4.595),(19.225,4.595),(19.225,4.425),(19.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,4.785),(17.975,4.955),(18.145,4.955),(18.145,4.785),(17.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,4.785),(18.335,4.955),(18.505,4.955),(18.505,4.785),(18.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,4.785),(18.695,4.955),(18.865,4.955),(18.865,4.785),(18.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,4.785),(19.055,4.955),(19.225,4.955),(19.225,4.785),(19.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.145),(17.975,5.315),(18.145,5.315),(18.145,5.145),(17.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.145),(18.335,5.315),(18.505,5.315),(18.505,5.145),(18.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.145),(18.695,5.315),(18.865,5.315),(18.865,5.145),(18.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.145),(19.055,5.315),(19.225,5.315),(19.225,5.145),(19.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.505),(17.975,5.675),(18.145,5.675),(18.145,5.505),(17.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.505),(18.335,5.675),(18.505,5.675),(18.505,5.505),(18.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.505),(18.695,5.675),(18.865,5.675),(18.865,5.505),(18.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.505),(19.055,5.675),(19.225,5.675),(19.225,5.505),(19.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,5.865),(17.975,6.035),(18.145,6.035),(18.145,5.865),(17.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,5.865),(18.335,6.035),(18.505,6.035),(18.505,5.865),(18.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,5.865),(18.695,6.035),(18.865,6.035),(18.865,5.865),(18.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,5.865),(19.055,6.035),(19.225,6.035),(19.225,5.865),(19.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.225),(17.975,6.395),(18.145,6.395),(18.145,6.225),(17.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.225),(18.335,6.395),(18.505,6.395),(18.505,6.225),(18.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.225),(18.695,6.395),(18.865,6.395),(18.865,6.225),(18.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.225),(19.055,6.395),(19.225,6.395),(19.225,6.225),(19.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.585),(17.975,6.755),(18.145,6.755),(18.145,6.585),(17.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.585),(18.335,6.755),(18.505,6.755),(18.505,6.585),(18.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.585),(18.695,6.755),(18.865,6.755),(18.865,6.585),(18.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.585),(19.055,6.755),(19.225,6.755),(19.225,6.585),(19.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,6.945),(17.975,7.115),(18.145,7.115),(18.145,6.945),(17.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,6.945),(18.335,7.115),(18.505,7.115),(18.505,6.945),(18.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,6.945),(18.695,7.115),(18.865,7.115),(18.865,6.945),(18.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,6.945),(19.055,7.115),(19.225,7.115),(19.225,6.945),(19.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.305),(17.975,7.475),(18.145,7.475),(18.145,7.305),(17.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.305),(18.335,7.475),(18.505,7.475),(18.505,7.305),(18.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.305),(18.695,7.475),(18.865,7.475),(18.865,7.305),(18.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.305),(19.055,7.475),(19.225,7.475),(19.225,7.305),(19.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,7.665),(17.975,7.835),(18.145,7.835),(18.145,7.665),(17.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,7.665),(18.335,7.835),(18.505,7.835),(18.505,7.665),(18.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,7.665),(18.695,7.835),(18.865,7.835),(18.865,7.665),(18.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,7.665),(19.055,7.835),(19.225,7.835),(19.225,7.665),(19.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.025),(17.975,8.195),(18.145,8.195),(18.145,8.025),(17.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.025),(18.335,8.195),(18.505,8.195),(18.505,8.025),(18.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.025),(18.695,8.195),(18.865,8.195),(18.865,8.025),(18.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.025),(19.055,8.195),(19.225,8.195),(19.225,8.025),(19.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.385),(17.975,8.555),(18.145,8.555),(18.145,8.385),(17.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.385),(18.335,8.555),(18.505,8.555),(18.505,8.385),(18.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.385),(18.695,8.555),(18.865,8.555),(18.865,8.385),(18.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.385),(19.055,8.555),(19.225,8.555),(19.225,8.385),(19.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,8.745),(17.975,8.915),(18.145,8.915),(18.145,8.745),(17.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,8.745),(18.335,8.915),(18.505,8.915),(18.505,8.745),(18.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,8.745),(18.695,8.915),(18.865,8.915),(18.865,8.745),(18.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,8.745),(19.055,8.915),(19.225,8.915),(19.225,8.745),(19.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.105),(17.975,9.275),(18.145,9.275),(18.145,9.105),(17.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.105),(18.335,9.275),(18.505,9.275),(18.505,9.105),(18.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.105),(18.695,9.275),(18.865,9.275),(18.865,9.105),(18.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.105),(19.055,9.275),(19.225,9.275),(19.225,9.105),(19.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.465),(17.975,9.635),(18.145,9.635),(18.145,9.465),(17.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.465),(18.335,9.635),(18.505,9.635),(18.505,9.465),(18.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.465),(18.695,9.635),(18.865,9.635),(18.865,9.465),(18.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.465),(19.055,9.635),(19.225,9.635),(19.225,9.465),(19.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,9.825),(17.975,9.995),(18.145,9.995),(18.145,9.825),(17.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,9.825),(18.335,9.995),(18.505,9.995),(18.505,9.825),(18.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,9.825),(18.695,9.995),(18.865,9.995),(18.865,9.825),(18.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,9.825),(19.055,9.995),(19.225,9.995),(19.225,9.825),(19.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.185),(17.975,10.355),(18.145,10.355),(18.145,10.185),(17.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.185),(18.335,10.355),(18.505,10.355),(18.505,10.185),(18.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.185),(18.695,10.355),(18.865,10.355),(18.865,10.185),(18.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.185),(19.055,10.355),(19.225,10.355),(19.225,10.185),(19.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.545),(17.975,10.715),(18.145,10.715),(18.145,10.545),(17.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.545),(18.335,10.715),(18.505,10.715),(18.505,10.545),(18.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.545),(18.695,10.715),(18.865,10.715),(18.865,10.545),(18.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.545),(19.055,10.715),(19.225,10.715),(19.225,10.545),(19.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,10.905),(17.975,11.075),(18.145,11.075),(18.145,10.905),(17.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,10.905),(18.335,11.075),(18.505,11.075),(18.505,10.905),(18.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,10.905),(18.695,11.075),(18.865,11.075),(18.865,10.905),(18.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,10.905),(19.055,11.075),(19.225,11.075),(19.225,10.905),(19.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.265),(17.975,11.435),(18.145,11.435),(18.145,11.265),(17.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.265),(18.335,11.435),(18.505,11.435),(18.505,11.265),(18.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.265),(18.695,11.435),(18.865,11.435),(18.865,11.265),(18.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.265),(19.055,11.435),(19.225,11.435),(19.225,11.265),(19.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.625),(17.975,11.795),(18.145,11.795),(18.145,11.625),(17.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.625),(18.335,11.795),(18.505,11.795),(18.505,11.625),(18.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.625),(18.695,11.795),(18.865,11.795),(18.865,11.625),(18.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.625),(19.055,11.795),(19.225,11.795),(19.225,11.625),(19.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,11.985),(17.975,12.155),(18.145,12.155),(18.145,11.985),(17.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,11.985),(18.335,12.155),(18.505,12.155),(18.505,11.985),(18.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,11.985),(18.695,12.155),(18.865,12.155),(18.865,11.985),(18.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,11.985),(19.055,12.155),(19.225,12.155),(19.225,11.985),(19.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.345),(17.975,12.515),(18.145,12.515),(18.145,12.345),(17.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.345),(18.335,12.515),(18.505,12.515),(18.505,12.345),(18.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.345),(18.695,12.515),(18.865,12.515),(18.865,12.345),(18.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.345),(19.055,12.515),(19.225,12.515),(19.225,12.345),(19.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,12.705),(17.975,12.875),(18.145,12.875),(18.145,12.705),(17.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,12.705),(18.335,12.875),(18.505,12.875),(18.505,12.705),(18.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,12.705),(18.695,12.875),(18.865,12.875),(18.865,12.705),(18.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,12.705),(19.055,12.875),(19.225,12.875),(19.225,12.705),(19.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.065),(17.975,13.235),(18.145,13.235),(18.145,13.065),(17.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.065),(18.335,13.235),(18.505,13.235),(18.505,13.065),(18.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.065),(18.695,13.235),(18.865,13.235),(18.865,13.065),(18.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.065),(19.055,13.235),(19.225,13.235),(19.225,13.065),(19.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.425),(17.975,13.595),(18.145,13.595),(18.145,13.425),(17.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.425),(18.335,13.595),(18.505,13.595),(18.505,13.425),(18.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.425),(18.695,13.595),(18.865,13.595),(18.865,13.425),(18.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.425),(19.055,13.595),(19.225,13.595),(19.225,13.425),(19.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,13.785),(17.975,13.955),(18.145,13.955),(18.145,13.785),(17.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,13.785),(18.335,13.955),(18.505,13.955),(18.505,13.785),(18.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,13.785),(18.695,13.955),(18.865,13.955),(18.865,13.785),(18.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,13.785),(19.055,13.955),(19.225,13.955),(19.225,13.785),(19.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.145),(17.975,14.315),(18.145,14.315),(18.145,14.145),(17.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.145),(18.335,14.315),(18.505,14.315),(18.505,14.145),(18.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.145),(18.695,14.315),(18.865,14.315),(18.865,14.145),(18.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.145),(19.055,14.315),(19.225,14.315),(19.225,14.145),(19.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.505),(17.975,14.675),(18.145,14.675),(18.145,14.505),(17.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.505),(18.335,14.675),(18.505,14.675),(18.505,14.505),(18.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.505),(18.695,14.675),(18.865,14.675),(18.865,14.505),(18.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.505),(19.055,14.675),(19.225,14.675),(19.225,14.505),(19.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,14.865),(17.975,15.035),(18.145,15.035),(18.145,14.865),(17.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,14.865),(18.335,15.035),(18.505,15.035),(18.505,14.865),(18.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,14.865),(18.695,15.035),(18.865,15.035),(18.865,14.865),(18.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,14.865),(19.055,15.035),(19.225,15.035),(19.225,14.865),(19.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.225),(17.975,15.395),(18.145,15.395),(18.145,15.225),(17.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.225),(18.335,15.395),(18.505,15.395),(18.505,15.225),(18.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.225),(18.695,15.395),(18.865,15.395),(18.865,15.225),(18.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.225),(19.055,15.395),(19.225,15.395),(19.225,15.225),(19.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.585),(17.975,15.755),(18.145,15.755),(18.145,15.585),(17.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.585),(18.335,15.755),(18.505,15.755),(18.505,15.585),(18.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.585),(18.695,15.755),(18.865,15.755),(18.865,15.585),(18.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.585),(19.055,15.755),(19.225,15.755),(19.225,15.585),(19.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,15.945),(17.975,16.115),(18.145,16.115),(18.145,15.945),(17.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,15.945),(18.335,16.115),(18.505,16.115),(18.505,15.945),(18.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,15.945),(18.695,16.115),(18.865,16.115),(18.865,15.945),(18.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,15.945),(19.055,16.115),(19.225,16.115),(19.225,15.945),(19.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.305),(17.975,16.475),(18.145,16.475),(18.145,16.305),(17.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.305),(18.335,16.475),(18.505,16.475),(18.505,16.305),(18.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.305),(18.695,16.475),(18.865,16.475),(18.865,16.305),(18.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.305),(19.055,16.475),(19.225,16.475),(19.225,16.305),(19.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,16.665),(17.975,16.835),(18.145,16.835),(18.145,16.665),(17.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,16.665),(18.335,16.835),(18.505,16.835),(18.505,16.665),(18.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,16.665),(18.695,16.835),(18.865,16.835),(18.865,16.665),(18.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,16.665),(19.055,16.835),(19.225,16.835),(19.225,16.665),(19.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.025),(17.975,17.195),(18.145,17.195),(18.145,17.025),(17.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.025),(18.335,17.195),(18.505,17.195),(18.505,17.025),(18.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.025),(18.695,17.195),(18.865,17.195),(18.865,17.025),(18.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.025),(19.055,17.195),(19.225,17.195),(19.225,17.025),(19.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.385),(17.975,17.555),(18.145,17.555),(18.145,17.385),(17.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.385),(18.335,17.555),(18.505,17.555),(18.505,17.385),(18.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.385),(18.695,17.555),(18.865,17.555),(18.865,17.385),(18.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.385),(19.055,17.555),(19.225,17.555),(19.225,17.385),(19.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,17.745),(17.975,17.915),(18.145,17.915),(18.145,17.745),(17.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,17.745),(18.335,17.915),(18.505,17.915),(18.505,17.745),(18.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,17.745),(18.695,17.915),(18.865,17.915),(18.865,17.745),(18.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,17.745),(19.055,17.915),(19.225,17.915),(19.225,17.745),(19.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.105),(17.975,18.275),(18.145,18.275),(18.145,18.105),(17.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.105),(18.335,18.275),(18.505,18.275),(18.505,18.105),(18.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.105),(18.695,18.275),(18.865,18.275),(18.865,18.105),(18.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.105),(19.055,18.275),(19.225,18.275),(19.225,18.105),(19.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.465),(17.975,18.635),(18.145,18.635),(18.145,18.465),(17.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.465),(18.335,18.635),(18.505,18.635),(18.505,18.465),(18.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.465),(18.695,18.635),(18.865,18.635),(18.865,18.465),(18.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.465),(19.055,18.635),(19.225,18.635),(19.225,18.465),(19.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,18.825),(17.975,18.995),(18.145,18.995),(18.145,18.825),(17.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,18.825),(18.335,18.995),(18.505,18.995),(18.505,18.825),(18.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,18.825),(18.695,18.995),(18.865,18.995),(18.865,18.825),(18.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,18.825),(19.055,18.995),(19.225,18.995),(19.225,18.825),(19.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.975,19.185),(17.975,19.355),(18.145,19.355),(18.145,19.185),(17.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.335,19.185),(18.335,19.355),(18.505,19.355),(18.505,19.185),(18.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.695,19.185),(18.695,19.355),(18.865,19.355),(18.865,19.185),(18.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.055,19.185),(19.055,19.355),(19.225,19.355),(19.225,19.185),(19.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,2.985),(13.175,3.155),(13.345,3.155),(13.345,2.985),(13.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,2.985),(13.535,3.155),(13.705,3.155),(13.705,2.985),(13.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,2.985),(13.895,3.155),(14.065,3.155),(14.065,2.985),(13.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,2.985),(14.255,3.155),(14.425,3.155),(14.425,2.985),(14.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.345),(13.175,3.515),(13.345,3.515),(13.345,3.345),(13.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.345),(13.535,3.515),(13.705,3.515),(13.705,3.345),(13.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.345),(13.895,3.515),(14.065,3.515),(14.065,3.345),(13.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.345),(14.255,3.515),(14.425,3.515),(14.425,3.345),(14.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,3.705),(13.175,3.875),(13.345,3.875),(13.345,3.705),(13.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,3.705),(13.535,3.875),(13.705,3.875),(13.705,3.705),(13.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,3.705),(13.895,3.875),(14.065,3.875),(14.065,3.705),(13.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,3.705),(14.255,3.875),(14.425,3.875),(14.425,3.705),(14.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.065),(13.175,4.235),(13.345,4.235),(13.345,4.065),(13.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.065),(13.535,4.235),(13.705,4.235),(13.705,4.065),(13.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.065),(13.895,4.235),(14.065,4.235),(14.065,4.065),(13.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.065),(14.255,4.235),(14.425,4.235),(14.425,4.065),(14.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.425),(13.175,4.595),(13.345,4.595),(13.345,4.425),(13.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.425),(13.535,4.595),(13.705,4.595),(13.705,4.425),(13.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.425),(13.895,4.595),(14.065,4.595),(14.065,4.425),(13.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.425),(14.255,4.595),(14.425,4.595),(14.425,4.425),(14.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,4.785),(13.175,4.955),(13.345,4.955),(13.345,4.785),(13.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,4.785),(13.535,4.955),(13.705,4.955),(13.705,4.785),(13.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,4.785),(13.895,4.955),(14.065,4.955),(14.065,4.785),(13.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,4.785),(14.255,4.955),(14.425,4.955),(14.425,4.785),(14.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.145),(13.175,5.315),(13.345,5.315),(13.345,5.145),(13.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.145),(13.535,5.315),(13.705,5.315),(13.705,5.145),(13.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.145),(13.895,5.315),(14.065,5.315),(14.065,5.145),(13.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.145),(14.255,5.315),(14.425,5.315),(14.425,5.145),(14.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.505),(13.175,5.675),(13.345,5.675),(13.345,5.505),(13.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.505),(13.535,5.675),(13.705,5.675),(13.705,5.505),(13.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.505),(13.895,5.675),(14.065,5.675),(14.065,5.505),(13.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.505),(14.255,5.675),(14.425,5.675),(14.425,5.505),(14.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,5.865),(13.175,6.035),(13.345,6.035),(13.345,5.865),(13.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,5.865),(13.535,6.035),(13.705,6.035),(13.705,5.865),(13.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,5.865),(13.895,6.035),(14.065,6.035),(14.065,5.865),(13.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,5.865),(14.255,6.035),(14.425,6.035),(14.425,5.865),(14.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.225),(13.175,6.395),(13.345,6.395),(13.345,6.225),(13.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.225),(13.535,6.395),(13.705,6.395),(13.705,6.225),(13.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.225),(13.895,6.395),(14.065,6.395),(14.065,6.225),(13.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.225),(14.255,6.395),(14.425,6.395),(14.425,6.225),(14.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.585),(13.175,6.755),(13.345,6.755),(13.345,6.585),(13.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.585),(13.535,6.755),(13.705,6.755),(13.705,6.585),(13.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.585),(13.895,6.755),(14.065,6.755),(14.065,6.585),(13.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.585),(14.255,6.755),(14.425,6.755),(14.425,6.585),(14.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,6.945),(13.175,7.115),(13.345,7.115),(13.345,6.945),(13.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,6.945),(13.535,7.115),(13.705,7.115),(13.705,6.945),(13.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,6.945),(13.895,7.115),(14.065,7.115),(14.065,6.945),(13.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,6.945),(14.255,7.115),(14.425,7.115),(14.425,6.945),(14.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.305),(13.175,7.475),(13.345,7.475),(13.345,7.305),(13.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.305),(13.535,7.475),(13.705,7.475),(13.705,7.305),(13.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.305),(13.895,7.475),(14.065,7.475),(14.065,7.305),(13.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.305),(14.255,7.475),(14.425,7.475),(14.425,7.305),(14.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,7.665),(13.175,7.835),(13.345,7.835),(13.345,7.665),(13.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,7.665),(13.535,7.835),(13.705,7.835),(13.705,7.665),(13.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,7.665),(13.895,7.835),(14.065,7.835),(14.065,7.665),(13.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,7.665),(14.255,7.835),(14.425,7.835),(14.425,7.665),(14.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.025),(13.175,8.195),(13.345,8.195),(13.345,8.025),(13.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.025),(13.535,8.195),(13.705,8.195),(13.705,8.025),(13.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.025),(13.895,8.195),(14.065,8.195),(14.065,8.025),(13.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.025),(14.255,8.195),(14.425,8.195),(14.425,8.025),(14.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.385),(13.175,8.555),(13.345,8.555),(13.345,8.385),(13.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.385),(13.535,8.555),(13.705,8.555),(13.705,8.385),(13.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.385),(13.895,8.555),(14.065,8.555),(14.065,8.385),(13.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.385),(14.255,8.555),(14.425,8.555),(14.425,8.385),(14.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,8.745),(13.175,8.915),(13.345,8.915),(13.345,8.745),(13.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,8.745),(13.535,8.915),(13.705,8.915),(13.705,8.745),(13.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,8.745),(13.895,8.915),(14.065,8.915),(14.065,8.745),(13.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,8.745),(14.255,8.915),(14.425,8.915),(14.425,8.745),(14.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.105),(13.175,9.275),(13.345,9.275),(13.345,9.105),(13.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.105),(13.535,9.275),(13.705,9.275),(13.705,9.105),(13.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.105),(13.895,9.275),(14.065,9.275),(14.065,9.105),(13.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.105),(14.255,9.275),(14.425,9.275),(14.425,9.105),(14.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.465),(13.175,9.635),(13.345,9.635),(13.345,9.465),(13.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.465),(13.535,9.635),(13.705,9.635),(13.705,9.465),(13.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.465),(13.895,9.635),(14.065,9.635),(14.065,9.465),(13.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.465),(14.255,9.635),(14.425,9.635),(14.425,9.465),(14.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,9.825),(13.175,9.995),(13.345,9.995),(13.345,9.825),(13.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,9.825),(13.535,9.995),(13.705,9.995),(13.705,9.825),(13.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,9.825),(13.895,9.995),(14.065,9.995),(14.065,9.825),(13.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,9.825),(14.255,9.995),(14.425,9.995),(14.425,9.825),(14.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.185),(13.175,10.355),(13.345,10.355),(13.345,10.185),(13.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.185),(13.535,10.355),(13.705,10.355),(13.705,10.185),(13.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.185),(13.895,10.355),(14.065,10.355),(14.065,10.185),(13.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.185),(14.255,10.355),(14.425,10.355),(14.425,10.185),(14.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.545),(13.175,10.715),(13.345,10.715),(13.345,10.545),(13.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.545),(13.535,10.715),(13.705,10.715),(13.705,10.545),(13.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.545),(13.895,10.715),(14.065,10.715),(14.065,10.545),(13.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.545),(14.255,10.715),(14.425,10.715),(14.425,10.545),(14.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,10.905),(13.175,11.075),(13.345,11.075),(13.345,10.905),(13.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,10.905),(13.535,11.075),(13.705,11.075),(13.705,10.905),(13.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,10.905),(13.895,11.075),(14.065,11.075),(14.065,10.905),(13.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,10.905),(14.255,11.075),(14.425,11.075),(14.425,10.905),(14.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.265),(13.175,11.435),(13.345,11.435),(13.345,11.265),(13.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.265),(13.535,11.435),(13.705,11.435),(13.705,11.265),(13.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.265),(13.895,11.435),(14.065,11.435),(14.065,11.265),(13.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.265),(14.255,11.435),(14.425,11.435),(14.425,11.265),(14.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.625),(13.175,11.795),(13.345,11.795),(13.345,11.625),(13.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.625),(13.535,11.795),(13.705,11.795),(13.705,11.625),(13.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.625),(13.895,11.795),(14.065,11.795),(14.065,11.625),(13.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.625),(14.255,11.795),(14.425,11.795),(14.425,11.625),(14.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,11.985),(13.175,12.155),(13.345,12.155),(13.345,11.985),(13.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,11.985),(13.535,12.155),(13.705,12.155),(13.705,11.985),(13.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,11.985),(13.895,12.155),(14.065,12.155),(14.065,11.985),(13.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,11.985),(14.255,12.155),(14.425,12.155),(14.425,11.985),(14.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.345),(13.175,12.515),(13.345,12.515),(13.345,12.345),(13.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.345),(13.535,12.515),(13.705,12.515),(13.705,12.345),(13.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.345),(13.895,12.515),(14.065,12.515),(14.065,12.345),(13.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.345),(14.255,12.515),(14.425,12.515),(14.425,12.345),(14.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,12.705),(13.175,12.875),(13.345,12.875),(13.345,12.705),(13.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,12.705),(13.535,12.875),(13.705,12.875),(13.705,12.705),(13.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,12.705),(13.895,12.875),(14.065,12.875),(14.065,12.705),(13.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,12.705),(14.255,12.875),(14.425,12.875),(14.425,12.705),(14.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.065),(13.175,13.235),(13.345,13.235),(13.345,13.065),(13.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.065),(13.535,13.235),(13.705,13.235),(13.705,13.065),(13.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.065),(13.895,13.235),(14.065,13.235),(14.065,13.065),(13.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.065),(14.255,13.235),(14.425,13.235),(14.425,13.065),(14.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.425),(13.175,13.595),(13.345,13.595),(13.345,13.425),(13.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.425),(13.535,13.595),(13.705,13.595),(13.705,13.425),(13.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.425),(13.895,13.595),(14.065,13.595),(14.065,13.425),(13.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.425),(14.255,13.595),(14.425,13.595),(14.425,13.425),(14.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,13.785),(13.175,13.955),(13.345,13.955),(13.345,13.785),(13.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,13.785),(13.535,13.955),(13.705,13.955),(13.705,13.785),(13.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,13.785),(13.895,13.955),(14.065,13.955),(14.065,13.785),(13.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,13.785),(14.255,13.955),(14.425,13.955),(14.425,13.785),(14.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.145),(13.175,14.315),(13.345,14.315),(13.345,14.145),(13.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.145),(13.535,14.315),(13.705,14.315),(13.705,14.145),(13.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.145),(13.895,14.315),(14.065,14.315),(14.065,14.145),(13.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.145),(14.255,14.315),(14.425,14.315),(14.425,14.145),(14.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.505),(13.175,14.675),(13.345,14.675),(13.345,14.505),(13.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.505),(13.535,14.675),(13.705,14.675),(13.705,14.505),(13.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.505),(13.895,14.675),(14.065,14.675),(14.065,14.505),(13.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.505),(14.255,14.675),(14.425,14.675),(14.425,14.505),(14.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,14.865),(13.175,15.035),(13.345,15.035),(13.345,14.865),(13.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,14.865),(13.535,15.035),(13.705,15.035),(13.705,14.865),(13.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,14.865),(13.895,15.035),(14.065,15.035),(14.065,14.865),(13.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,14.865),(14.255,15.035),(14.425,15.035),(14.425,14.865),(14.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.225),(13.175,15.395),(13.345,15.395),(13.345,15.225),(13.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.225),(13.535,15.395),(13.705,15.395),(13.705,15.225),(13.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.225),(13.895,15.395),(14.065,15.395),(14.065,15.225),(13.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.225),(14.255,15.395),(14.425,15.395),(14.425,15.225),(14.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.585),(13.175,15.755),(13.345,15.755),(13.345,15.585),(13.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.585),(13.535,15.755),(13.705,15.755),(13.705,15.585),(13.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.585),(13.895,15.755),(14.065,15.755),(14.065,15.585),(13.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.585),(14.255,15.755),(14.425,15.755),(14.425,15.585),(14.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,15.945),(13.175,16.115),(13.345,16.115),(13.345,15.945),(13.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,15.945),(13.535,16.115),(13.705,16.115),(13.705,15.945),(13.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,15.945),(13.895,16.115),(14.065,16.115),(14.065,15.945),(13.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,15.945),(14.255,16.115),(14.425,16.115),(14.425,15.945),(14.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.305),(13.175,16.475),(13.345,16.475),(13.345,16.305),(13.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.305),(13.535,16.475),(13.705,16.475),(13.705,16.305),(13.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.305),(13.895,16.475),(14.065,16.475),(14.065,16.305),(13.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.305),(14.255,16.475),(14.425,16.475),(14.425,16.305),(14.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,16.665),(13.175,16.835),(13.345,16.835),(13.345,16.665),(13.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,16.665),(13.535,16.835),(13.705,16.835),(13.705,16.665),(13.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,16.665),(13.895,16.835),(14.065,16.835),(14.065,16.665),(13.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,16.665),(14.255,16.835),(14.425,16.835),(14.425,16.665),(14.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.025),(13.175,17.195),(13.345,17.195),(13.345,17.025),(13.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.025),(13.535,17.195),(13.705,17.195),(13.705,17.025),(13.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.025),(13.895,17.195),(14.065,17.195),(14.065,17.025),(13.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.025),(14.255,17.195),(14.425,17.195),(14.425,17.025),(14.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.385),(13.175,17.555),(13.345,17.555),(13.345,17.385),(13.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.385),(13.535,17.555),(13.705,17.555),(13.705,17.385),(13.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.385),(13.895,17.555),(14.065,17.555),(14.065,17.385),(13.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.385),(14.255,17.555),(14.425,17.555),(14.425,17.385),(14.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,17.745),(13.175,17.915),(13.345,17.915),(13.345,17.745),(13.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,17.745),(13.535,17.915),(13.705,17.915),(13.705,17.745),(13.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,17.745),(13.895,17.915),(14.065,17.915),(14.065,17.745),(13.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,17.745),(14.255,17.915),(14.425,17.915),(14.425,17.745),(14.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.105),(13.175,18.275),(13.345,18.275),(13.345,18.105),(13.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.105),(13.535,18.275),(13.705,18.275),(13.705,18.105),(13.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.105),(13.895,18.275),(14.065,18.275),(14.065,18.105),(13.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.105),(14.255,18.275),(14.425,18.275),(14.425,18.105),(14.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.465),(13.175,18.635),(13.345,18.635),(13.345,18.465),(13.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.465),(13.535,18.635),(13.705,18.635),(13.705,18.465),(13.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.465),(13.895,18.635),(14.065,18.635),(14.065,18.465),(13.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.465),(14.255,18.635),(14.425,18.635),(14.425,18.465),(14.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,18.825),(13.175,18.995),(13.345,18.995),(13.345,18.825),(13.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,18.825),(13.535,18.995),(13.705,18.995),(13.705,18.825),(13.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,18.825),(13.895,18.995),(14.065,18.995),(14.065,18.825),(13.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,18.825),(14.255,18.995),(14.425,18.995),(14.425,18.825),(14.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.175,19.185),(13.175,19.355),(13.345,19.355),(13.345,19.185),(13.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.535,19.185),(13.535,19.355),(13.705,19.355),(13.705,19.185),(13.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((13.895,19.185),(13.895,19.355),(14.065,19.355),(14.065,19.185),(13.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((14.255,19.185),(14.255,19.355),(14.425,19.355),(14.425,19.185),(14.255,19.185)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,19.415),(24.055,19.415),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,22.34),(62.455,22.34),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((22.745,2.925),(22.745,22.34),(24.055,22.34),(24.055,2.925),(22.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,22.34),(28.855,22.34),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((61.145,2.925),(61.145,19.415),(62.455,19.415),(62.455,2.925),(61.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,19.415),(48.055,19.415),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,19.415),(67.255,19.415),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,22.34),(48.055,22.34),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,22.34),(52.855,22.34),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((65.945,2.925),(65.945,22.34),(67.255,22.34),(67.255,2.925),(65.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,19.415),(76.855,19.415),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,22.34),(57.655,22.34),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,19.415),(57.655,19.415),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,22.34),(38.455,22.34),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,19.415),(38.455,19.415),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,19.415),(43.255,19.415),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((27.545,2.925),(27.545,19.415),(28.855,19.415),(28.855,2.925),(27.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,22.34),(43.255,22.34),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,22.34),(9.655,22.34),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((8.345,2.925),(8.345,19.415),(9.655,19.415),(9.655,2.925),(8.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,19.415),(72.055,19.415),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,19.415),(19.255,19.415),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,22.34),(14.455,22.34),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((70.745,2.925),(70.745,22.34),(72.055,22.34),(72.055,2.925),(70.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((75.545,2.925),(75.545,22.34),(76.855,22.34),(76.855,2.925),(75.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((13.145,2.925),(13.145,19.415),(14.455,19.415),(14.455,2.925),(13.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((17.945,2.925),(17.945,22.34),(19.255,22.34),(19.255,2.925),(17.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,22.34),(81.655,22.34),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,22.34),(33.655,22.34),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((80.345,2.925),(80.345,19.415),(81.655,19.415),(81.655,2.925),(80.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,19.415),(33.655,19.415),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,19.415),(52.855,19.415),(52.855,2.925),(51.545,2.925)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(13.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(13.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(61.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(61.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(71.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(71.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(66.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(66.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(18.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(18.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(28.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(28.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(81.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(81.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(76.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(76.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(23.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(23.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(9.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(9.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['gate']
        createRL(
            tech, net, 'poly',
            ((12.435,2.59),(12.435,19.75),(13.035,19.75),(13.035,2.59),(12.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,19.78),(48.33,20.11),(48.6,20.11),(48.6,19.78),(48.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,19.75),(12.435,19.78),(13.035,19.78),(13.035,19.75),(12.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.59),(74.835,19.75),(75.435,19.75),(75.435,2.59),(74.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,19.75),(74.835,19.78),(75.435,19.78),(75.435,19.75),(74.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.56),(26.835,2.59),(27.435,2.59),(27.435,2.56),(26.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,19.78),(9.93,20.11),(10.2,20.11),(10.2,19.78),(9.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,19.78),(70.2,20.11),(70.47,20.11),(70.47,19.78),(70.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,19.78),(60.6,20.11),(60.87,20.11),(60.87,19.78),(60.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.59),(43.365,19.75),(43.965,19.75),(43.965,2.59),(43.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.93,2.23),(9.93,2.56),(10.2,2.56),(10.2,2.23),(9.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.56),(9.765,2.59),(10.365,2.59),(10.365,2.56),(9.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,19.78),(77.13,20.11),(77.4,20.11),(77.4,19.78),(77.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,2.59),(26.835,19.75),(27.435,19.75),(27.435,2.59),(26.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((26.835,19.75),(26.835,19.78),(27.435,19.78),(27.435,19.75),(26.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.59),(72.165,19.75),(72.765,19.75),(72.765,2.59),(72.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.56),(55.635,2.59),(56.235,2.59),(56.235,2.56),(55.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.56),(43.365,2.59),(43.965,2.59),(43.965,2.56),(43.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,19.75),(50.835,19.78),(51.435,19.78),(51.435,19.75),(50.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,2.59),(9.765,19.75),(10.365,19.75),(10.365,2.59),(9.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.59),(67.365,19.75),(67.965,19.75),(67.965,2.59),(67.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,19.75),(52.965,19.78),(53.565,19.78),(53.565,19.75),(52.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,2.56),(72.165,2.59),(72.765,2.59),(72.765,2.56),(72.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,2.23),(72.33,2.56),(72.6,2.56),(72.6,2.23),(72.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.59),(81.765,19.75),(82.365,19.75),(82.365,2.59),(81.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,19.75),(81.765,19.78),(82.365,19.78),(82.365,19.75),(81.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((72.33,19.78),(72.33,20.11),(72.6,20.11),(72.6,19.78),(72.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,2.23),(67.53,2.56),(67.8,2.56),(67.8,2.23),(67.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,2.23),(79.8,2.56),(80.07,2.56),(80.07,2.23),(79.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.56),(79.635,2.59),(80.235,2.59),(80.235,2.56),(79.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,2.56),(67.365,2.59),(67.965,2.59),(67.965,2.56),(67.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.59),(62.565,19.75),(63.165,19.75),(63.165,2.59),(62.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,19.75),(22.035,19.78),(22.635,19.78),(22.635,19.75),(22.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,2.23),(7.8,2.56),(8.07,2.56),(8.07,2.23),(7.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.56),(7.635,2.59),(8.235,2.59),(8.235,2.56),(7.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,19.78),(75.0,20.11),(75.27,20.11),(75.27,19.78),(75.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,19.78),(43.53,20.11),(43.8,20.11),(43.8,19.78),(43.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,19.78),(31.8,20.11),(32.07,20.11),(32.07,19.78),(31.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,19.75),(31.635,19.78),(32.235,19.78),(32.235,19.75),(31.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.56),(48.165,2.59),(48.765,2.59),(48.765,2.56),(48.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.56),(17.235,2.59),(17.835,2.59),(17.835,2.56),(17.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,2.23),(17.4,2.56),(17.67,2.56),(17.67,2.23),(17.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,19.78),(33.93,20.11),(34.2,20.11),(34.2,19.78),(33.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.59),(65.235,19.75),(65.835,19.75),(65.835,2.59),(65.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,19.78),(27.0,20.11),(27.27,20.11),(27.27,19.78),(27.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.56),(28.965,2.59),(29.565,2.59),(29.565,2.56),(28.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.59),(33.765,19.75),(34.365,19.75),(34.365,2.59),(33.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,19.78),(65.4,20.11),(65.67,20.11),(65.67,19.78),(65.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.56),(38.565,2.59),(39.165,2.59),(39.165,2.56),(38.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,2.23),(14.73,2.56),(15.0,2.56),(15.0,2.23),(14.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.56),(14.565,2.59),(15.165,2.59),(15.165,2.56),(14.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.56),(50.835,2.59),(51.435,2.59),(51.435,2.56),(50.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,2.59),(28.965,19.75),(29.565,19.75),(29.565,2.59),(28.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,19.78),(53.13,20.11),(53.4,20.11),(53.4,19.78),(53.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((28.965,19.75),(28.965,19.78),(29.565,19.78),(29.565,19.75),(28.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.59),(38.565,19.75),(39.165,19.75),(39.165,2.59),(38.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,19.78),(55.8,20.11),(56.07,20.11),(56.07,19.78),(55.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,19.75),(55.635,19.78),(56.235,19.78),(56.235,19.75),(55.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,19.78),(62.73,20.11),(63.0,20.11),(63.0,19.78),(62.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,19.75),(70.035,19.78),(70.635,19.78),(70.635,19.75),(70.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,19.75),(62.565,19.78),(63.165,19.78),(63.165,19.75),(62.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((67.53,19.78),(67.53,20.11),(67.8,20.11),(67.8,19.78),(67.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.59),(46.035,19.75),(46.635,19.75),(46.635,2.59),(46.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((17.4,19.78),(17.4,20.11),(17.67,20.11),(17.67,19.78),(17.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.6,2.23),(60.6,2.56),(60.87,2.56),(60.87,2.23),(60.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.2,2.23),(70.2,2.56),(70.47,2.56),(70.47,2.23),(70.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.56),(70.035,2.59),(70.635,2.59),(70.635,2.56),(70.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,2.23),(29.13,2.56),(29.4,2.56),(29.4,2.23),(29.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,19.78),(41.4,20.11),(41.67,20.11),(41.67,19.78),(41.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.56),(46.035,2.59),(46.635,2.59),(46.635,2.56),(46.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,19.78),(19.53,20.11),(19.8,20.11),(19.8,19.78),(19.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,19.75),(36.435,19.78),(37.035,19.78),(37.035,19.75),(36.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.56),(76.965,2.59),(77.565,2.59),(77.565,2.56),(76.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,2.23),(12.6,2.56),(12.87,2.56),(12.87,2.23),(12.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.56),(22.035,2.59),(22.635,2.59),(22.635,2.56),(22.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,2.23),(22.2,2.56),(22.47,2.56),(22.47,2.23),(22.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((14.73,19.78),(14.73,20.11),(15.0,20.11),(15.0,19.78),(14.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,19.75),(14.565,19.78),(15.165,19.78),(15.165,19.75),(14.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((12.6,19.78),(12.6,20.11),(12.87,20.11),(12.87,19.78),(12.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,19.78),(81.93,20.11),(82.2,20.11),(82.2,19.78),(81.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,2.59),(76.965,19.75),(77.565,19.75),(77.565,2.59),(76.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((76.965,19.75),(76.965,19.78),(77.565,19.78),(77.565,19.75),(76.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((79.8,19.78),(79.8,20.11),(80.07,20.11),(80.07,19.78),(79.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((81.93,2.23),(81.93,2.56),(82.2,2.56),(82.2,2.23),(81.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((81.765,2.56),(81.765,2.59),(82.365,2.59),(82.365,2.56),(81.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,19.75),(79.635,19.78),(80.235,19.78),(80.235,19.75),(79.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,19.75),(43.365,19.78),(43.965,19.78),(43.965,19.75),(43.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((62.73,2.23),(62.73,2.56),(63.0,2.56),(63.0,2.23),(62.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.565,2.56),(62.565,2.59),(63.165,2.59),(63.165,2.56),(62.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,19.75),(60.435,19.78),(61.035,19.78),(61.035,19.75),(60.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,19.78),(46.2,20.11),(46.47,20.11),(46.47,19.78),(46.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.59),(31.635,19.75),(32.235,19.75),(32.235,2.59),(31.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((77.13,2.23),(77.13,2.56),(77.4,2.56),(77.4,2.23),(77.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,19.75),(57.765,19.78),(58.365,19.78),(58.365,19.75),(57.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.59),(48.165,19.75),(48.765,19.75),(48.765,2.59),(48.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,19.75),(65.235,19.78),(65.835,19.78),(65.835,19.75),(65.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.56),(57.765,2.59),(58.365,2.59),(58.365,2.56),(57.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,2.59),(17.235,19.75),(17.835,19.75),(17.835,2.59),(17.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,19.75),(24.165,19.78),(24.765,19.78),(24.765,19.75),(24.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.56),(33.765,2.59),(34.365,2.59),(34.365,2.56),(33.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,19.75),(48.165,19.78),(48.765,19.78),(48.765,19.75),(48.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.59),(57.765,19.75),(58.365,19.75),(58.365,2.59),(57.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((9.765,19.75),(9.765,19.78),(10.365,19.78),(10.365,19.75),(9.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,19.78),(51.0,20.11),(51.27,20.11),(51.27,19.78),(51.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.56),(52.965,2.59),(53.565,2.59),(53.565,2.56),(52.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.59),(55.635,19.75),(56.235,19.75),(56.235,2.59),(55.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((75.0,2.23),(75.0,2.56),(75.27,2.56),(75.27,2.23),(75.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((67.365,19.75),(67.365,19.78),(67.965,19.78),(67.965,19.75),(67.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((17.235,19.75),(17.235,19.78),(17.835,19.78),(17.835,19.75),(17.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.59),(52.965,19.75),(53.565,19.75),(53.565,2.59),(52.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.56),(19.365,2.59),(19.965,2.59),(19.965,2.56),(19.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.56),(36.435,2.59),(37.035,2.59),(37.035,2.56),(36.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((7.8,19.78),(7.8,20.11),(8.07,20.11),(8.07,19.78),(7.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.56),(31.635,2.59),(32.235,2.59),(32.235,2.56),(31.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((79.635,2.59),(79.635,19.75),(80.235,19.75),(80.235,2.59),(79.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,2.59),(7.635,19.75),(8.235,19.75),(8.235,2.59),(7.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,19.75),(41.235,19.78),(41.835,19.78),(41.835,19.75),(41.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((7.635,19.75),(7.635,19.78),(8.235,19.78),(8.235,19.75),(7.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((27.0,2.23),(27.0,2.56),(27.27,2.56),(27.27,2.23),(27.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,19.75),(19.365,19.78),(19.965,19.78),(19.965,19.75),(19.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((70.035,2.59),(70.035,19.75),(70.635,19.75),(70.635,2.59),(70.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.59),(36.435,19.75),(37.035,19.75),(37.035,2.59),(36.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((72.165,19.75),(72.165,19.78),(72.765,19.78),(72.765,19.75),(72.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.59),(41.235,19.75),(41.835,19.75),(41.835,2.59),(41.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((22.2,19.78),(22.2,20.11),(22.47,20.11),(22.47,19.78),(22.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((22.035,2.59),(22.035,19.75),(22.635,19.75),(22.635,2.59),(22.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((65.235,2.56),(65.235,2.59),(65.835,2.59),(65.835,2.56),(65.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((65.4,2.23),(65.4,2.56),(65.67,2.56),(65.67,2.23),(65.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((29.13,19.78),(29.13,20.11),(29.4,20.11),(29.4,19.78),(29.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,19.75),(46.035,19.78),(46.635,19.78),(46.635,19.75),(46.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.56),(60.435,2.59),(61.035,2.59),(61.035,2.56),(60.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.59),(24.165,19.75),(24.765,19.75),(24.765,2.59),(24.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.56),(41.235,2.59),(41.835,2.59),(41.835,2.56),(41.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,19.75),(33.765,19.78),(34.365,19.78),(34.365,19.75),(33.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((14.565,2.59),(14.565,19.75),(15.165,19.75),(15.165,2.59),(14.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.59),(50.835,19.75),(51.435,19.75),(51.435,2.59),(50.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((19.365,2.59),(19.365,19.75),(19.965,19.75),(19.965,2.59),(19.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,19.78),(36.6,20.11),(36.87,20.11),(36.87,19.78),(36.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((60.435,2.59),(60.435,19.75),(61.035,19.75),(61.035,2.59),(60.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,19.78),(38.73,20.11),(39.0,20.11),(39.0,19.78),(38.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,2.23),(24.33,2.56),(24.6,2.56),(24.6,2.23),(24.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((24.165,2.56),(24.165,2.59),(24.765,2.59),(24.765,2.56),(24.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((12.435,2.56),(12.435,2.59),(13.035,2.59),(13.035,2.56),(12.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,19.75),(38.565,19.78),(39.165,19.78),(39.165,19.75),(38.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((74.835,2.56),(74.835,2.59),(75.435,2.59),(75.435,2.56),(74.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,19.78),(57.93,20.11),(58.2,20.11),(58.2,19.78),(57.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((24.33,19.78),(24.33,20.11),(24.6,20.11),(24.6,19.78),(24.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((19.53,2.23),(19.53,2.56),(19.8,2.56),(19.8,2.23),(19.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,19.86),(12.65,20.03),(12.82,20.03),(12.82,19.86),(12.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,2.31),(17.45,2.48),(17.62,2.48),(17.62,2.31),(17.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,19.86),(81.98,20.03),(82.15,20.03),(82.15,19.86),(81.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,19.86),(33.98,20.03),(34.15,20.03),(34.15,19.86),(33.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,19.86),(48.38,20.03),(48.55,20.03),(48.55,19.86),(48.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,19.86),(27.05,20.03),(27.22,20.03),(27.22,19.86),(27.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,2.31),(19.58,2.48),(19.75,2.48),(19.75,2.31),(19.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,19.86),(7.85,20.03),(8.02,20.03),(8.02,19.86),(7.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,19.86),(65.45,20.03),(65.62,20.03),(65.62,19.86),(65.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,19.86),(79.85,20.03),(80.02,20.03),(80.02,19.86),(79.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,19.86),(9.98,20.03),(10.15,20.03),(10.15,19.86),(9.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((81.98,2.31),(81.98,2.48),(82.15,2.48),(82.15,2.31),(81.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((27.05,2.31),(27.05,2.48),(27.22,2.48),(27.22,2.31),(27.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,19.86),(38.78,20.03),(38.95,20.03),(38.95,19.86),(38.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,19.86),(70.25,20.03),(70.42,20.03),(70.42,19.86),(70.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,19.86),(60.65,20.03),(60.82,20.03),(60.82,19.86),(60.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((9.98,2.31),(9.98,2.48),(10.15,2.48),(10.15,2.31),(9.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,2.31),(62.78,2.48),(62.95,2.48),(62.95,2.31),(62.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,2.31),(14.78,2.48),(14.95,2.48),(14.95,2.31),(14.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,19.86),(77.18,20.03),(77.35,20.03),(77.35,19.86),(77.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,19.86),(53.18,20.03),(53.35,20.03),(53.35,19.86),(53.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,19.86),(46.25,20.03),(46.42,20.03),(46.42,19.86),(46.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((14.78,19.86),(14.78,20.03),(14.95,20.03),(14.95,19.86),(14.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,19.86),(55.85,20.03),(56.02,20.03),(56.02,19.86),(55.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((77.18,2.31),(77.18,2.48),(77.35,2.48),(77.35,2.31),(77.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,19.86),(22.25,20.03),(22.42,20.03),(22.42,19.86),(22.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,2.31),(75.05,2.48),(75.22,2.48),(75.22,2.31),(75.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((65.45,2.31),(65.45,2.48),(65.62,2.48),(65.62,2.31),(65.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,19.86),(67.58,20.03),(67.75,20.03),(67.75,19.86),(67.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,19.86),(29.18,20.03),(29.35,20.03),(29.35,19.86),(29.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,2.31),(72.38,2.48),(72.55,2.48),(72.55,2.31),(72.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((4.07,18.99),(4.07,19.16),(4.24,19.16),(4.24,18.99),(4.07,18.99)),
        )
        createRL(
            tech, net, 'licon',
            ((4.07,19.33),(4.07,19.5),(4.24,19.5),(4.24,19.33),(4.07,19.33)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((17.45,19.86),(17.45,20.03),(17.62,20.03),(17.62,19.86),(17.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((60.65,2.31),(60.65,2.48),(60.82,2.48),(60.82,2.31),(60.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((70.25,2.31),(70.25,2.48),(70.42,2.48),(70.42,2.31),(70.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((72.38,19.86),(72.38,20.03),(72.55,20.03),(72.55,19.86),(72.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((29.18,2.31),(29.18,2.48),(29.35,2.48),(29.35,2.31),(29.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((7.85,2.31),(7.85,2.48),(8.02,2.48),(8.02,2.31),(7.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((79.85,2.31),(79.85,2.48),(80.02,2.48),(80.02,2.31),(79.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((67.58,2.31),(67.58,2.48),(67.75,2.48),(67.75,2.31),(67.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,19.86),(36.65,20.03),(36.82,20.03),(36.82,19.86),(36.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,19.86),(41.45,20.03),(41.62,20.03),(41.62,19.86),(41.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((19.58,19.86),(19.58,20.03),(19.75,20.03),(19.75,19.86),(19.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,2.31),(24.38,2.48),(24.55,2.48),(24.55,2.31),(24.38,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,19.86),(51.05,20.03),(51.22,20.03),(51.22,19.86),(51.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,19.86),(43.58,20.03),(43.75,20.03),(43.75,19.86),(43.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((75.05,19.86),(75.05,20.03),(75.22,20.03),(75.22,19.86),(75.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((62.78,19.86),(62.78,20.03),(62.95,20.03),(62.95,19.86),(62.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,19.86),(31.85,20.03),(32.02,20.03),(32.02,19.86),(31.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((12.65,2.31),(12.65,2.48),(12.82,2.48),(12.82,2.31),(12.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,19.86),(57.98,20.03),(58.15,20.03),(58.15,19.86),(57.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((22.25,2.31),(22.25,2.48),(22.42,2.48),(22.42,2.31),(22.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((24.38,19.86),(24.38,20.03),(24.55,20.03),(24.55,19.86),(24.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,19.78),(48.38,20.11),(48.55,20.11),(48.55,19.78),(48.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.56),(62.78,19.78),(62.95,19.78),(62.95,2.56),(62.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,19.78),(9.98,20.11),(10.15,20.11),(10.15,19.78),(9.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,19.78),(70.25,20.11),(70.42,20.11),(70.42,19.78),(70.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.56),(43.58,19.78),(43.75,19.78),(43.75,2.56),(43.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,19.78),(60.65,20.11),(60.82,20.11),(60.82,19.78),(60.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.23),(9.98,2.56),(10.15,2.56),(10.15,2.23),(9.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,2.23),(62.78,2.56),(62.95,2.56),(62.95,2.23),(62.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,19.78),(77.18,20.11),(77.35,20.11),(77.35,19.78),(77.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.56),(72.38,19.78),(72.55,19.78),(72.55,2.56),(72.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.23),(43.58,2.56),(43.75,2.56),(43.75,2.23),(43.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.23),(55.85,2.56),(56.02,2.56),(56.02,2.23),(55.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,18.91),(4.07,20.11),(4.24,20.11),(4.24,18.91),(4.07,18.91)),
        )
        createRL(
            tech, net, 'li',
            ((9.98,2.56),(9.98,19.78),(10.15,19.78),(10.15,2.56),(9.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.56),(67.58,19.78),(67.75,19.78),(67.75,2.56),(67.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,2.23),(72.38,2.56),(72.55,2.56),(72.55,2.23),(72.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.56),(81.98,19.78),(82.15,19.78),(82.15,2.56),(81.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((72.38,19.78),(72.38,20.11),(72.55,20.11),(72.55,19.78),(72.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,2.23),(67.58,2.56),(67.75,2.56),(67.75,2.23),(67.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.23),(79.85,2.56),(80.02,2.56),(80.02,2.23),(79.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.23),(7.85,2.56),(8.02,2.56),(8.02,2.23),(7.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.56),(38.78,19.78),(38.95,19.78),(38.95,2.56),(38.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.56),(53.18,19.78),(53.35,19.78),(53.35,2.56),(53.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,19.78),(43.58,20.11),(43.75,20.11),(43.75,19.78),(43.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,19.78),(75.05,20.11),(75.22,20.11),(75.22,19.78),(75.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((62.78,19.78),(62.78,20.11),(62.95,20.11),(62.95,19.78),(62.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,19.78),(31.85,20.11),(32.02,20.11),(32.02,19.78),(31.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.23),(53.18,2.56),(53.35,2.56),(53.35,2.23),(53.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.23),(48.38,2.56),(48.55,2.56),(48.55,2.23),(48.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.23),(17.45,2.56),(17.62,2.56),(17.62,2.23),(17.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,19.78),(33.98,20.11),(34.15,20.11),(34.15,19.78),(33.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.56),(65.45,19.78),(65.62,19.78),(65.62,2.56),(65.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,19.78),(27.05,20.11),(27.22,20.11),(27.22,19.78),(27.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.56),(33.98,19.78),(34.15,19.78),(34.15,2.56),(33.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,19.78),(65.45,20.11),(65.62,20.11),(65.62,19.78),(65.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.23),(36.65,2.56),(36.82,2.56),(36.82,2.23),(36.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,19.78),(53.18,20.11),(53.35,20.11),(53.35,19.78),(53.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,19.78),(14.78,20.11),(14.95,20.11),(14.95,19.78),(14.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,19.78),(55.85,20.11),(56.02,20.11),(56.02,19.78),(55.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,19.065),(4.07,19.955),(4.24,19.955),(4.24,19.065),(4.07,19.065)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.56),(29.18,19.78),(29.35,19.78),(29.35,2.56),(29.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((67.58,19.78),(67.58,20.11),(67.75,20.11),(67.75,19.78),(67.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.56),(46.25,19.78),(46.42,19.78),(46.42,2.56),(46.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,19.78),(17.45,20.11),(17.62,20.11),(17.62,19.78),(17.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.23),(60.65,2.56),(60.82,2.56),(60.82,2.23),(60.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.23),(70.25,2.56),(70.42,2.56),(70.42,2.23),(70.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,2.23),(29.18,2.56),(29.35,2.56),(29.35,2.23),(29.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,19.78),(41.45,20.11),(41.62,20.11),(41.62,19.78),(41.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.23),(46.25,2.56),(46.42,2.56),(46.42,2.23),(46.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,19.78),(19.58,20.11),(19.75,20.11),(19.75,19.78),(19.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.23),(12.65,2.56),(12.82,2.56),(12.82,2.23),(12.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.23),(22.25,2.56),(22.42,2.56),(22.42,2.23),(22.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,19.78),(12.65,20.11),(12.82,20.11),(12.82,19.78),(12.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,19.78),(81.98,20.11),(82.15,20.11),(82.15,19.78),(81.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,19.78),(79.85,20.11),(80.02,20.11),(80.02,19.78),(79.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((81.98,2.23),(81.98,2.56),(82.15,2.56),(82.15,2.23),(81.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.56),(51.05,19.78),(51.22,19.78),(51.22,2.56),(51.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.56),(77.18,19.78),(77.35,19.78),(77.35,2.56),(77.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,19.78),(46.25,20.11),(46.42,20.11),(46.42,19.78),(46.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.56),(31.85,19.78),(32.02,19.78),(32.02,2.56),(31.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.23),(51.05,2.56),(51.22,2.56),(51.22,2.23),(51.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((77.18,2.23),(77.18,2.56),(77.35,2.56),(77.35,2.23),(77.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.56),(48.38,19.78),(48.55,19.78),(48.55,2.56),(48.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.23),(57.98,2.56),(58.15,2.56),(58.15,2.23),(57.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((17.45,2.56),(17.45,19.78),(17.62,19.78),(17.62,2.56),(17.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.23),(33.98,2.56),(34.15,2.56),(34.15,2.23),(33.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.56),(36.65,19.78),(36.82,19.78),(36.82,2.56),(36.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.56),(57.98,19.78),(58.15,19.78),(58.15,2.56),(57.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.56),(75.05,19.78),(75.22,19.78),(75.22,2.56),(75.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,19.78),(51.05,20.11),(51.22,20.11),(51.22,19.78),(51.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.56),(55.85,19.78),(56.02,19.78),(56.02,2.56),(55.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((75.05,2.23),(75.05,2.56),(75.22,2.56),(75.22,2.23),(75.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.56),(27.05,19.78),(27.22,19.78),(27.22,2.56),(27.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,18.91),(4.07,19.58),(4.24,19.58),(4.24,18.91),(4.07,18.91)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.56),(14.78,19.78),(14.95,19.78),(14.95,2.56),(14.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,19.78),(7.85,20.11),(8.02,20.11),(8.02,19.78),(7.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((79.85,2.56),(79.85,19.78),(80.02,19.78),(80.02,2.56),(79.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((7.85,2.56),(7.85,19.78),(8.02,19.78),(8.02,2.56),(7.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.23),(38.78,2.56),(38.95,2.56),(38.95,2.23),(38.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((27.05,2.23),(27.05,2.56),(27.22,2.56),(27.22,2.23),(27.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((60.65,2.56),(60.65,19.78),(60.82,19.78),(60.82,2.56),(60.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,19.78),(38.78,20.11),(38.95,20.11),(38.95,19.78),(38.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((70.25,2.56),(70.25,19.78),(70.42,19.78),(70.42,2.56),(70.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((14.78,2.23),(14.78,2.56),(14.95,2.56),(14.95,2.23),(14.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.56),(41.45,19.78),(41.62,19.78),(41.62,2.56),(41.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((12.65,2.56),(12.65,19.78),(12.82,19.78),(12.82,2.56),(12.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,19.78),(22.25,20.11),(22.42,20.11),(22.42,19.78),(22.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((22.25,2.56),(22.25,19.78),(22.42,19.78),(22.42,2.56),(22.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((65.45,2.23),(65.45,2.56),(65.62,2.56),(65.62,2.23),(65.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((29.18,19.78),(29.18,20.11),(29.35,20.11),(29.35,19.78),(29.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.23),(41.45,2.56),(41.62,2.56),(41.62,2.23),(41.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.56),(24.38,19.78),(24.55,19.78),(24.55,2.56),(24.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((4.07,19.94),(4.07,20.11),(82.15,20.11),(82.15,19.94),(4.07,19.94)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.56),(19.58,19.78),(19.75,19.78),(19.75,2.56),(19.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,19.78),(36.65,20.11),(36.82,20.11),(36.82,19.78),(36.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,2.23),(24.38,2.56),(24.55,2.56),(24.55,2.23),(24.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,19.78),(57.98,20.11),(58.15,20.11),(58.15,19.78),(57.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((24.38,19.78),(24.38,20.11),(24.55,20.11),(24.55,19.78),(24.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((19.58,2.23),(19.58,2.56),(19.75,2.56),(19.75,2.23),(19.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.23),(31.85,2.56),(32.02,2.56),(32.02,2.23),(31.85,2.23)),
        )
        createRL(
            tech, net, 'difftap',
            ((4.03,18.87),(4.03,19.62),(4.28,19.62),(4.28,18.87),(4.03,18.87)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,19.065),(4.07,19.235),(4.24,19.235),(4.24,19.065),(4.07,19.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,19.425),(4.07,19.595),(4.24,19.595),(4.24,19.425),(4.07,19.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((4.07,19.785),(4.07,19.955),(4.24,19.955),(4.24,19.785),(4.07,19.785)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,19.005),(4.04,20.015),(4.27,20.015),(4.27,19.005),(4.04,19.005)),
        )
        createRL(
            tech, net, 'm1',
            ((4.04,19.005),(4.04,22.34),(4.27,22.34),(4.27,19.005),(4.04,19.005)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(4.155), u(0.23), u(19.005), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(4.155), u(0.23), u(19.005), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        nets['gate'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_N18000W4468HFF']
        except:
            subcell = af.getCell('GuardRing_N18000W4468HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_P17368W3836HFF']
        except:
            subcell = af.getCell('GuardRing_P17368W3836HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['RCClampResistor']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(37.26), u(58.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'pin1': Net.create(cell, 'pin1'),
            'pin2': Net.create(cell, 'pin2'),
            'res': Net.create(cell, 'res'),
        }
        net = nets['pin1']
        createRL(
            tech, net, 'poly',
            ((-0.27,0.0),(-0.27,0.33),(0.0,0.33),(0.0,0.0),(-0.27,0.0)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.22,0.08),(-0.22,0.25),(-0.05,0.25),(-0.05,0.08),(-0.22,0.08)),
        )
        createRL(
            tech, net, 'li',
            ((-0.22,0.0),(-0.22,0.33),(-0.05,0.33),(-0.05,0.0),(-0.22,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('li.pin'),
            u(-0.135), u(0.17), u(0.0), u(0.33),
        )
        pin = Vertical.create(
            net, tech.getLayer('li'),
            u(-0.135), u(0.17), u(0.0), u(0.33),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['res']
        createRL(
            tech, net, 'poly',
            ((0.0,0.0),(0.0,0.33),(0.48,0.33),(0.48,58.0),(1.62,58.0),(1.62,0.33),(2.1,0.33),(2.1,58.0),(3.24,58.0),(3.24,0.33),(3.72,0.33),(3.72,58.0),(4.86,58.0),(4.86,0.33),(5.34,0.33),(5.34,58.0),(6.48,58.0),(6.48,0.33),(6.96,0.33),(6.96,58.0),(8.1,58.0),(8.1,0.33),(8.58,0.33),(8.58,58.0),(9.72,58.0),(9.72,0.33),(10.2,0.33),(10.2,58.0),(11.34,58.0),(11.34,0.33),(11.82,0.33),(11.82,58.0),(12.96,58.0),(12.96,0.33),(13.44,0.33),(13.44,58.0),(14.58,58.0),(14.58,0.33),(15.06,0.33),(15.06,58.0),(16.2,58.0),(16.2,0.33),(16.68,0.33),(16.68,58.0),(17.82,58.0),(17.82,0.33),(18.3,0.33),(18.3,58.0),(19.44,58.0),(19.44,0.33),(19.92,0.33),(19.92,58.0),(21.06,58.0),(21.06,0.33),(21.54,0.33),(21.54,58.0),(22.68,58.0),(22.68,0.33),(23.16,0.33),(23.16,58.0),(24.3,58.0),(24.3,0.33),(24.78,0.33),(24.78,58.0),(25.92,58.0),(25.92,0.33),(26.4,0.33),(26.4,58.0),(27.54,58.0),(27.54,0.33),(28.02,0.33),(28.02,58.0),(29.16,58.0),(29.16,0.33),(29.64,0.33),(29.64,58.0),(30.78,58.0),(30.78,0.33),(31.26,0.33),(31.26,58.0),(32.4,58.0),(32.4,0.33),(32.88,0.33),(32.88,58.0),(34.02,58.0),(34.02,0.33),(34.5,0.33),(34.5,58.0),(35.64,58.0),(35.64,0.33),(36.12,0.33),(36.12,58.0),(37.26,58.0),(37.26,0.0),(36.93,0.0),(36.93,57.67),(36.45,57.67),(36.45,0.0),(35.31,0.0),(35.31,57.67),(34.83,57.67),(34.83,0.0),(33.69,0.0),(33.69,57.67),(33.21,57.67),(33.21,0.0),(32.07,0.0),(32.07,57.67),(31.59,57.67),(31.59,0.0),(30.45,0.0),(30.45,57.67),(29.97,57.67),(29.97,0.0),(28.83,0.0),(28.83,57.67),(28.35,57.67),(28.35,0.0),(27.21,0.0),(27.21,57.67),(26.73,57.67),(26.73,0.0),(25.59,0.0),(25.59,57.67),(25.11,57.67),(25.11,0.0),(23.97,0.0),(23.97,57.67),(23.49,57.67),(23.49,0.0),(22.35,0.0),(22.35,57.67),(21.87,57.67),(21.87,0.0),(20.73,0.0),(20.73,57.67),(20.25,57.67),(20.25,0.0),(19.11,0.0),(19.11,57.67),(18.63,57.67),(18.63,0.0),(17.49,0.0),(17.49,57.67),(17.01,57.67),(17.01,0.0),(15.87,0.0),(15.87,57.67),(15.39,57.67),(15.39,0.0),(14.25,0.0),(14.25,57.67),(13.77,57.67),(13.77,0.0),(12.63,0.0),(12.63,57.67),(12.15,57.67),(12.15,0.0),(11.01,0.0),(11.01,57.67),(10.53,57.67),(10.53,0.0),(9.39,0.0),(9.39,57.67),(8.91,57.67),(8.91,0.0),(7.77,0.0),(7.77,57.67),(7.29,57.67),(7.29,0.0),(6.15,0.0),(6.15,57.67),(5.67,57.67),(5.67,0.0),(4.53,0.0),(4.53,57.67),(4.05,57.67),(4.05,0.0),(2.91,0.0),(2.91,57.67),(2.43,57.67),(2.43,0.0),(1.29,0.0),(1.29,57.67),(0.81,57.67),(0.81,0.0),(0.0,0.0)),
        )
        net = nets['*']
        createRL(
            tech, net, 'polyres',
            ((0.0,0.0),(0.0,0.33),(0.48,0.33),(0.48,58.0),(1.62,58.0),(1.62,0.33),(2.1,0.33),(2.1,58.0),(3.24,58.0),(3.24,0.33),(3.72,0.33),(3.72,58.0),(4.86,58.0),(4.86,0.33),(5.34,0.33),(5.34,58.0),(6.48,58.0),(6.48,0.33),(6.96,0.33),(6.96,58.0),(8.1,58.0),(8.1,0.33),(8.58,0.33),(8.58,58.0),(9.72,58.0),(9.72,0.33),(10.2,0.33),(10.2,58.0),(11.34,58.0),(11.34,0.33),(11.82,0.33),(11.82,58.0),(12.96,58.0),(12.96,0.33),(13.44,0.33),(13.44,58.0),(14.58,58.0),(14.58,0.33),(15.06,0.33),(15.06,58.0),(16.2,58.0),(16.2,0.33),(16.68,0.33),(16.68,58.0),(17.82,58.0),(17.82,0.33),(18.3,0.33),(18.3,58.0),(19.44,58.0),(19.44,0.33),(19.92,0.33),(19.92,58.0),(21.06,58.0),(21.06,0.33),(21.54,0.33),(21.54,58.0),(22.68,58.0),(22.68,0.33),(23.16,0.33),(23.16,58.0),(24.3,58.0),(24.3,0.33),(24.78,0.33),(24.78,58.0),(25.92,58.0),(25.92,0.33),(26.4,0.33),(26.4,58.0),(27.54,58.0),(27.54,0.33),(28.02,0.33),(28.02,58.0),(29.16,58.0),(29.16,0.33),(29.64,0.33),(29.64,58.0),(30.78,58.0),(30.78,0.33),(31.26,0.33),(31.26,58.0),(32.4,58.0),(32.4,0.33),(32.88,0.33),(32.88,58.0),(34.02,58.0),(34.02,0.33),(34.5,0.33),(34.5,58.0),(35.64,58.0),(35.64,0.33),(36.12,0.33),(36.12,58.0),(37.26,58.0),(37.26,0.0),(36.93,0.0),(36.93,57.67),(36.45,57.67),(36.45,0.0),(35.31,0.0),(35.31,57.67),(34.83,57.67),(34.83,0.0),(33.69,0.0),(33.69,57.67),(33.21,57.67),(33.21,0.0),(32.07,0.0),(32.07,57.67),(31.59,57.67),(31.59,0.0),(30.45,0.0),(30.45,57.67),(29.97,57.67),(29.97,0.0),(28.83,0.0),(28.83,57.67),(28.35,57.67),(28.35,0.0),(27.21,0.0),(27.21,57.67),(26.73,57.67),(26.73,0.0),(25.59,0.0),(25.59,57.67),(25.11,57.67),(25.11,0.0),(23.97,0.0),(23.97,57.67),(23.49,57.67),(23.49,0.0),(22.35,0.0),(22.35,57.67),(21.87,57.67),(21.87,0.0),(20.73,0.0),(20.73,57.67),(20.25,57.67),(20.25,0.0),(19.11,0.0),(19.11,57.67),(18.63,57.67),(18.63,0.0),(17.49,0.0),(17.49,57.67),(17.01,57.67),(17.01,0.0),(15.87,0.0),(15.87,57.67),(15.39,57.67),(15.39,0.0),(14.25,0.0),(14.25,57.67),(13.77,57.67),(13.77,0.0),(12.63,0.0),(12.63,57.67),(12.15,57.67),(12.15,0.0),(11.01,0.0),(11.01,57.67),(10.53,57.67),(10.53,0.0),(9.39,0.0),(9.39,57.67),(8.91,57.67),(8.91,0.0),(7.77,0.0),(7.77,57.67),(7.29,57.67),(7.29,0.0),(6.15,0.0),(6.15,57.67),(5.67,57.67),(5.67,0.0),(4.53,0.0),(4.53,57.67),(4.05,57.67),(4.05,0.0),(2.91,0.0),(2.91,57.67),(2.43,57.67),(2.43,0.0),(1.29,0.0),(1.29,57.67),(0.81,57.67),(0.81,0.0),(0.0,0.0)),
        )
        net = nets['pin2']
        createRL(
            tech, net, 'poly',
            ((37.395,0.0),(37.395,0.33),(37.665,0.33),(37.665,0.0),(37.395,0.0)),
        )
        createRL(
            tech, net, 'poly',
            ((37.26,0.0),(37.26,0.33),(37.665,0.33),(37.665,0.0),(37.26,0.0)),
        )
        createRL(
            tech, net, 'licon',
            ((37.445,0.08),(37.445,0.25),(37.615,0.25),(37.615,0.08),(37.445,0.08)),
        )
        createRL(
            tech, net, 'li',
            ((37.445,0.0),(37.445,0.33),(37.615,0.33),(37.615,0.0),(37.445,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('li.pin'),
            u(37.53), u(0.17), u(0.0), u(0.33),
        )
        pin = Vertical.create(
            net, tech.getLayer('li'),
            u(37.53), u(0.17), u(0.0), u(0.33),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['pin1'].setDirection(Net.Direction.IN)
        nets['pin2'].setDirection(Net.Direction.IN)

    cell = new_cells['GuardRing_P12310W3968HFT']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-30.775000000000002), u(-9.92), u(30.775000000000002), u(9.92),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'conn': Net.create(cell, 'conn'),
        }
        net = nets['conn']
        createRL(
            tech, net, 'difftap',
            ((-30.775,9.44),(-30.775,9.92),(30.775,9.92),(30.775,9.44),(-30.775,9.44)),
        )
        createRL(
            tech, net, 'difftap',
            ((-30.775,-9.44),(-30.775,9.44),(-30.295,9.44),(-30.295,-9.44),(-30.775,-9.44)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.295,-9.44),(30.295,9.44),(30.775,9.44),(30.775,-9.44),(30.295,-9.44)),
        )
        createRL(
            tech, net, 'difftap',
            ((-30.775,-9.92),(-30.775,-9.44),(30.775,-9.44),(30.775,-9.92),(-30.775,-9.92)),
        )
        createRL(
            tech, net, 'licon',
            ((23.885,-9.765),(23.885,-9.595),(24.055,-9.595),(24.055,-9.765),(23.885,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.095,9.595),(-9.095,9.765),(-8.925,9.765),(-8.925,9.595),(-9.095,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-5.865),(30.45,-5.695),(30.62,-5.695),(30.62,-5.865),(30.45,-5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-5.185),(30.45,-5.015),(30.62,-5.015),(30.62,-5.185),(30.45,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,5.015),(30.45,5.185),(30.62,5.185),(30.62,5.015),(30.45,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,5.355),(30.45,5.525),(30.62,5.525),(30.62,5.355),(30.45,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,5.695),(30.45,5.865),(30.62,5.865),(30.62,5.695),(30.45,5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-5.525),(30.45,-5.355),(30.62,-5.355),(30.62,-5.525),(30.45,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((27.965,-9.765),(27.965,-9.595),(28.135,-9.595),(28.135,-9.765),(27.965,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.915,9.595),(-16.915,9.765),(-16.745,9.765),(-16.745,9.595),(-16.915,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,1.955),(-30.62,2.125),(-30.45,2.125),(-30.45,1.955),(-30.62,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.915,-9.765),(-16.915,-9.595),(-16.745,-9.595),(-16.745,-9.765),(-16.915,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.575,-9.765),(-16.575,-9.595),(-16.405,-9.595),(-16.405,-9.765),(-16.575,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.235,-9.765),(-16.235,-9.595),(-16.065,-9.595),(-16.065,-9.765),(-16.235,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.575,9.595),(-16.575,9.765),(-16.405,9.765),(-16.405,9.595),(-16.575,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((15.725,9.595),(15.725,9.765),(15.895,9.765),(15.895,9.595),(15.725,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.235,9.595),(-16.235,9.765),(-16.065,9.765),(-16.065,9.595),(-16.235,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.895,-9.765),(-15.895,-9.595),(-15.725,-9.595),(-15.725,-9.765),(-15.895,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.555,-9.765),(-15.555,-9.595),(-15.385,-9.595),(-15.385,-9.765),(-15.555,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.215,-9.765),(-15.215,-9.595),(-15.045,-9.595),(-15.045,-9.765),(-15.215,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.045,9.595),(15.045,9.765),(15.215,9.765),(15.215,9.595),(15.045,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((15.385,9.595),(15.385,9.765),(15.555,9.765),(15.555,9.595),(15.385,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.775,-9.765),(-26.775,-9.595),(-26.605,-9.595),(-26.605,-9.765),(-26.775,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.435,-9.765),(-26.435,-9.595),(-26.265,-9.595),(-26.265,-9.765),(-26.435,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.775,9.595),(-26.775,9.765),(-26.605,9.765),(-26.605,9.595),(-26.775,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.435,9.595),(-26.435,9.765),(-26.265,9.765),(-26.265,9.595),(-26.435,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-2.125),(-30.62,-1.955),(-30.45,-1.955),(-30.45,-2.125),(-30.62,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,2.975),(30.45,3.145),(30.62,3.145),(30.62,2.975),(30.45,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.185,-9.765),(5.185,-9.595),(5.355,-9.595),(5.355,-9.765),(5.185,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((5.525,-9.765),(5.525,-9.595),(5.695,-9.595),(5.695,-9.765),(5.525,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.695,9.595),(-5.695,9.765),(-5.525,9.765),(-5.525,9.595),(-5.695,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.355,9.595),(-5.355,9.765),(-5.185,9.765),(-5.185,9.595),(-5.355,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((25.245,-9.765),(25.245,-9.595),(25.415,-9.595),(25.415,-9.765),(25.245,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.585,-9.765),(25.585,-9.595),(25.755,-9.595),(25.755,-9.765),(25.585,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.755,9.595),(-25.755,9.765),(-25.585,9.765),(-25.585,9.595),(-25.755,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.415,9.595),(-25.415,9.765),(-25.245,9.765),(-25.245,9.595),(-25.415,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((5.865,-9.765),(5.865,-9.595),(6.035,-9.595),(6.035,-9.765),(5.865,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.885,-9.765),(6.885,-9.595),(7.055,-9.595),(7.055,-9.765),(6.885,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.835,-9.765),(-29.835,-9.595),(-29.665,-9.595),(-29.665,-9.765),(-29.835,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.495,-9.765),(-29.495,-9.595),(-29.325,-9.595),(-29.325,-9.765),(-29.495,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((29.325,9.595),(29.325,9.765),(29.495,9.765),(29.495,9.595),(29.325,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((29.665,9.595),(29.665,9.765),(29.835,9.765),(29.835,9.595),(29.665,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.955,-9.765),(-1.955,-9.595),(-1.785,-9.595),(-1.785,-9.765),(-1.955,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.615,-9.765),(-1.615,-9.595),(-1.445,-9.595),(-1.445,-9.765),(-1.615,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.275,-9.765),(-1.275,-9.595),(-1.105,-9.595),(-1.105,-9.765),(-1.275,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((1.105,9.595),(1.105,9.765),(1.275,9.765),(1.275,9.595),(1.105,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((1.445,9.595),(1.445,9.765),(1.615,9.765),(1.615,9.595),(1.445,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((1.785,9.595),(1.785,9.765),(1.955,9.765),(1.955,9.595),(1.785,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.475,9.595),(-11.475,9.765),(-11.305,9.765),(-11.305,9.595),(-11.475,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.675,-9.765),(-21.675,-9.595),(-21.505,-9.595),(-21.505,-9.765),(-21.675,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.335,-9.765),(-21.335,-9.595),(-21.165,-9.595),(-21.165,-9.765),(-21.335,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.165,9.595),(21.165,9.765),(21.335,9.765),(21.335,9.595),(21.165,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((11.305,-9.765),(11.305,-9.595),(11.475,-9.595),(11.475,-9.765),(11.305,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((11.645,-9.765),(11.645,-9.595),(11.815,-9.595),(11.815,-9.765),(11.645,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.505,9.595),(21.505,9.765),(21.675,9.765),(21.675,9.595),(21.505,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.815,9.595),(-11.815,9.765),(-11.645,9.765),(-11.645,9.595),(-11.815,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-3.145),(-30.62,-2.975),(-30.45,-2.975),(-30.45,-3.145),(-30.62,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((6.205,-9.765),(6.205,-9.595),(6.375,-9.595),(6.375,-9.765),(6.205,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.545,-9.765),(6.545,-9.595),(6.715,-9.595),(6.715,-9.765),(6.545,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((6.205,9.595),(6.205,9.765),(6.375,9.765),(6.375,9.595),(6.205,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((6.545,9.595),(6.545,9.765),(6.715,9.765),(6.715,9.595),(6.545,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((23.545,-9.765),(23.545,-9.595),(23.715,-9.595),(23.715,-9.765),(23.545,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.715,9.595),(-23.715,9.765),(-23.545,9.765),(-23.545,9.595),(-23.715,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.375,9.595),(-23.375,9.765),(-23.205,9.765),(-23.205,9.595),(-23.375,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((23.205,-9.765),(23.205,-9.595),(23.375,-9.595),(23.375,-9.765),(23.205,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-4.165),(-30.62,-3.995),(-30.45,-3.995),(-30.45,-4.165),(-30.62,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-4.165),(30.45,-3.995),(30.62,-3.995),(30.62,-4.165),(30.45,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((4.845,-9.765),(4.845,-9.595),(5.015,-9.595),(5.015,-9.765),(4.845,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-0.765),(-30.62,-0.595),(-30.45,-0.595),(-30.45,-0.765),(-30.62,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,0.595),(-30.62,0.765),(-30.45,0.765),(-30.45,0.595),(-30.62,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-0.765),(30.45,-0.595),(30.62,-0.595),(30.62,-0.765),(30.45,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,0.595),(30.45,0.765),(30.62,0.765),(30.62,0.595),(30.45,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((26.945,-9.765),(26.945,-9.595),(27.115,-9.595),(27.115,-9.765),(26.945,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.315,9.595),(-3.315,9.765),(-3.145,9.765),(-3.145,9.595),(-3.315,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((3.145,-9.765),(3.145,-9.595),(3.315,-9.595),(3.315,-9.765),(3.145,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((3.485,-9.765),(3.485,-9.595),(3.655,-9.595),(3.655,-9.765),(3.485,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((3.825,-9.765),(3.825,-9.595),(3.995,-9.595),(3.995,-9.765),(3.825,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.995,9.595),(-3.995,9.765),(-3.825,9.765),(-3.825,9.595),(-3.995,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.655,9.595),(-3.655,9.765),(-3.485,9.765),(-3.485,9.595),(-3.655,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((22.865,9.595),(22.865,9.765),(23.035,9.765),(23.035,9.595),(22.865,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((23.885,9.595),(23.885,9.765),(24.055,9.765),(24.055,9.595),(23.885,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.015,-9.765),(-22.015,-9.595),(-21.845,-9.595),(-21.845,-9.765),(-22.015,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.965,9.595),(27.965,9.765),(28.135,9.765),(28.135,9.595),(27.965,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.075,-9.765),(-8.075,-9.595),(-7.905,-9.595),(-7.905,-9.765),(-8.075,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((24.225,-9.765),(24.225,-9.595),(24.395,-9.595),(24.395,-9.765),(24.225,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((24.565,-9.765),(24.565,-9.595),(24.735,-9.595),(24.735,-9.765),(24.565,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((24.225,9.595),(24.225,9.765),(24.395,9.765),(24.395,9.595),(24.225,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.135,-9.765),(-28.135,-9.595),(-27.965,-9.595),(-27.965,-9.765),(-28.135,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((24.565,9.595),(24.565,9.765),(24.735,9.765),(24.735,9.595),(24.565,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.255,9.595),(-0.255,9.765),(-0.085,9.765),(-0.085,9.595),(-0.255,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((0.085,9.595),(0.085,9.765),(0.255,9.765),(0.255,9.595),(0.085,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.255,-9.765),(-0.255,-9.595),(-0.085,-9.595),(-0.085,-9.765),(-0.255,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.085,-9.765),(0.085,-9.595),(0.255,-9.595),(0.255,-9.765),(0.085,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,1.955),(30.45,2.125),(30.62,2.125),(30.62,1.955),(30.45,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.895,9.595),(-15.895,9.765),(-15.725,9.765),(-15.725,9.595),(-15.895,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.555,9.595),(-15.555,9.765),(-15.385,9.765),(-15.385,9.595),(-15.555,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.215,9.595),(-15.215,9.765),(-15.045,9.765),(-15.045,9.595),(-15.215,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((15.045,-9.765),(15.045,-9.595),(15.215,-9.595),(15.215,-9.765),(15.045,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.385,-9.765),(15.385,-9.595),(15.555,-9.595),(15.555,-9.765),(15.385,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((15.725,-9.765),(15.725,-9.595),(15.895,-9.595),(15.895,-9.765),(15.725,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.265,-9.765),(26.265,-9.595),(26.435,-9.595),(26.435,-9.765),(26.265,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.605,-9.765),(26.605,-9.595),(26.775,-9.595),(26.775,-9.765),(26.605,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.265,9.595),(26.265,9.765),(26.435,9.765),(26.435,9.595),(26.265,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((26.605,9.595),(26.605,9.765),(26.775,9.765),(26.775,9.595),(26.605,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.795,-9.765),(-27.795,-9.595),(-27.625,-9.595),(-27.625,-9.765),(-27.795,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.455,-9.765),(-27.455,-9.595),(-27.285,-9.595),(-27.285,-9.765),(-27.455,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.285,9.595),(27.285,9.765),(27.455,9.765),(27.455,9.595),(27.285,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((27.625,9.595),(27.625,9.765),(27.795,9.765),(27.795,9.595),(27.625,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,9.595),(30.005,9.765),(30.175,9.765),(30.175,9.595),(30.005,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.695,-9.765),(-22.695,-9.595),(-22.525,-9.595),(-22.525,-9.765),(-22.695,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.355,-9.765),(-22.355,-9.595),(-22.185,-9.595),(-22.185,-9.765),(-22.355,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.695,9.595),(-22.695,9.765),(-22.525,9.765),(-22.525,9.595),(-22.695,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.355,9.595),(-22.355,9.765),(-22.185,9.765),(-22.185,9.595),(-22.355,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.155,9.595),(-29.155,9.765),(-28.985,9.765),(-28.985,9.595),(-29.155,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.835,-9.765),(-12.835,-9.595),(-12.665,-9.595),(-12.665,-9.765),(-12.835,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.495,-9.765),(-12.495,-9.595),(-12.325,-9.595),(-12.325,-9.765),(-12.495,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.835,9.595),(-12.835,9.765),(-12.665,9.765),(-12.665,9.595),(-12.835,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.495,9.595),(-12.495,9.765),(-12.325,9.765),(-12.325,9.595),(-12.495,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.635,-9.765),(-2.635,-9.595),(-2.465,-9.595),(-2.465,-9.765),(-2.635,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.295,-9.765),(-2.295,-9.595),(-2.125,-9.595),(-2.125,-9.765),(-2.295,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.975,-9.765),(-2.975,-9.595),(-2.805,-9.595),(-2.805,-9.765),(-2.975,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.975,9.595),(-2.975,9.765),(-2.805,9.765),(-2.805,9.595),(-2.975,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.635,9.595),(-2.635,9.765),(-2.465,9.765),(-2.465,9.595),(-2.635,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((5.865,9.595),(5.865,9.765),(6.035,9.765),(6.035,9.595),(5.865,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.295,9.595),(-2.295,9.765),(-2.125,9.765),(-2.125,9.595),(-2.295,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.055,9.595),(-7.055,9.765),(-6.885,9.765),(-6.885,9.595),(-7.055,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((8.925,9.595),(8.925,9.765),(9.095,9.765),(9.095,9.595),(8.925,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.975,-9.765),(-19.975,-9.595),(-19.805,-9.595),(-19.805,-9.765),(-19.975,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.635,-9.765),(-19.635,-9.595),(-19.465,-9.595),(-19.465,-9.765),(-19.635,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.295,-9.765),(-19.295,-9.595),(-19.125,-9.595),(-19.125,-9.765),(-19.295,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,2.295),(-30.62,2.465),(-30.45,2.465),(-30.45,2.295),(-30.62,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,2.635),(-30.62,2.805),(-30.45,2.805),(-30.45,2.635),(-30.62,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((19.125,9.595),(19.125,9.765),(19.295,9.765),(19.295,9.595),(19.125,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((19.465,9.595),(19.465,9.765),(19.635,9.765),(19.635,9.595),(19.465,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((19.805,9.595),(19.805,9.765),(19.975,9.765),(19.975,9.595),(19.805,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-2.805),(30.45,-2.635),(30.62,-2.635),(30.62,-2.805),(30.45,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-2.465),(30.45,-2.295),(30.62,-2.295),(30.62,-2.465),(30.45,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.055,-9.765),(-7.055,-9.595),(-6.885,-9.595),(-6.885,-9.765),(-7.055,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.115,-9.765),(-27.115,-9.595),(-26.945,-9.595),(-26.945,-9.765),(-27.115,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.155,9.595),(-12.155,9.765),(-11.985,9.765),(-11.985,9.595),(-12.155,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((29.325,-9.765),(29.325,-9.595),(29.495,-9.595),(29.495,-9.765),(29.325,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((29.665,-9.765),(29.665,-9.595),(29.835,-9.595),(29.835,-9.765),(29.665,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.835,9.595),(-29.835,9.765),(-29.665,9.765),(-29.665,9.595),(-29.835,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.495,9.595),(-29.495,9.765),(-29.325,9.765),(-29.325,9.595),(-29.495,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.055,9.595),(-24.055,9.765),(-23.885,9.765),(-23.885,9.595),(-24.055,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((25.925,9.595),(25.925,9.765),(26.095,9.765),(26.095,9.595),(25.925,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.675,-9.765),(-4.675,-9.595),(-4.505,-9.595),(-4.505,-9.765),(-4.675,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.335,-9.765),(-4.335,-9.595),(-4.165,-9.595),(-4.165,-9.765),(-4.335,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.675,9.595),(-4.675,9.765),(-4.505,9.765),(-4.505,9.595),(-4.675,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.335,9.595),(-4.335,9.765),(-4.165,9.765),(-4.165,9.595),(-4.335,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((1.105,-9.765),(1.105,-9.595),(1.275,-9.595),(1.275,-9.765),(1.105,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((1.445,-9.765),(1.445,-9.595),(1.615,-9.595),(1.615,-9.765),(1.445,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((1.785,-9.765),(1.785,-9.595),(1.955,-9.595),(1.955,-9.765),(1.785,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.075,9.595),(-25.075,9.765),(-24.905,9.765),(-24.905,9.595),(-25.075,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.955,9.595),(-1.955,9.765),(-1.785,9.765),(-1.785,9.595),(-1.955,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.615,9.595),(-1.615,9.765),(-1.445,9.765),(-1.445,9.595),(-1.615,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.275,9.595),(-1.275,9.765),(-1.105,9.765),(-1.105,9.595),(-1.275,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,0.935),(-30.62,1.105),(-30.45,1.105),(-30.45,0.935),(-30.62,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,0.935),(30.45,1.105),(30.62,1.105),(30.62,0.935),(30.45,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-1.105),(30.45,-0.935),(30.62,-0.935),(30.62,-1.105),(30.45,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.875,-9.765),(-14.875,-9.595),(-14.705,-9.595),(-14.705,-9.765),(-14.875,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.535,-9.765),(-14.535,-9.595),(-14.365,-9.595),(-14.365,-9.765),(-14.535,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.195,-9.765),(-14.195,-9.595),(-14.025,-9.595),(-14.025,-9.765),(-14.195,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.875,9.595),(-14.875,9.765),(-14.705,9.765),(-14.705,9.595),(-14.875,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.535,9.595),(-14.535,9.765),(-14.365,9.765),(-14.365,9.595),(-14.535,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.195,9.595),(-14.195,9.765),(-14.025,9.765),(-14.025,9.595),(-14.195,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((21.165,-9.765),(21.165,-9.595),(21.335,-9.595),(21.335,-9.765),(21.165,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.015,-9.765),(-5.015,-9.595),(-4.845,-9.595),(-4.845,-9.765),(-5.015,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.505,-9.765),(21.505,-9.595),(21.675,-9.595),(21.675,-9.765),(21.505,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.675,9.595),(-21.675,9.765),(-21.505,9.765),(-21.505,9.595),(-21.675,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.335,9.595),(-21.335,9.765),(-21.165,9.765),(-21.165,9.595),(-21.335,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.095,-9.765),(-9.095,-9.595),(-8.925,-9.595),(-8.925,-9.765),(-9.095,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,8.075),(-30.62,8.245),(-30.45,8.245),(-30.45,8.075),(-30.62,8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,8.415),(-30.62,8.585),(-30.45,8.585),(-30.45,8.415),(-30.62,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,8.755),(-30.62,8.925),(-30.45,8.925),(-30.45,8.755),(-30.62,8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,8.075),(30.45,8.245),(30.62,8.245),(30.62,8.075),(30.45,8.075)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,8.415),(30.45,8.585),(30.62,8.585),(30.62,8.415),(30.45,8.415)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,8.755),(30.45,8.925),(30.62,8.925),(30.62,8.755),(30.45,8.755)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.815,9.595),(-28.815,9.765),(-28.645,9.765),(-28.645,9.595),(-28.815,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.115,9.595),(-10.115,9.765),(-9.945,9.765),(-9.945,9.595),(-10.115,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((21.845,-9.765),(21.845,-9.595),(22.015,-9.595),(22.015,-9.765),(21.845,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((22.865,-9.765),(22.865,-9.595),(23.035,-9.595),(23.035,-9.765),(22.865,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-3.825),(30.45,-3.655),(30.62,-3.655),(30.62,-3.825),(30.45,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-3.485),(30.45,-3.315),(30.62,-3.315),(30.62,-3.485),(30.45,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,3.315),(30.45,3.485),(30.62,3.485),(30.62,3.315),(30.45,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,3.655),(30.45,3.825),(30.62,3.825),(30.62,3.655),(30.45,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((9.945,-9.765),(9.945,-9.595),(10.115,-9.595),(10.115,-9.765),(9.945,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.985,-9.765),(28.985,-9.595),(29.155,-9.595),(29.155,-9.765),(28.985,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,2.975),(-30.62,3.145),(-30.45,3.145),(-30.45,2.975),(-30.62,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-2.125),(30.45,-1.955),(30.62,-1.955),(30.62,-2.125),(30.45,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.285,-9.765),(27.285,-9.595),(27.455,-9.595),(27.455,-9.765),(27.285,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((27.625,-9.765),(27.625,-9.595),(27.795,-9.595),(27.795,-9.765),(27.625,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.795,9.595),(-27.795,9.765),(-27.625,9.765),(-27.625,9.595),(-27.795,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.455,9.595),(-27.455,9.765),(-27.285,9.765),(-27.285,9.595),(-27.455,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((22.185,-9.765),(22.185,-9.595),(22.355,-9.595),(22.355,-9.765),(22.185,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((22.525,-9.765),(22.525,-9.595),(22.695,-9.595),(22.695,-9.765),(22.525,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((22.185,9.595),(22.185,9.765),(22.355,9.765),(22.355,9.595),(22.185,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((22.525,9.595),(22.525,9.765),(22.695,9.765),(22.695,9.595),(22.525,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,6.715),(30.45,6.885),(30.62,6.885),(30.62,6.715),(30.45,6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-6.885),(-30.62,-6.715),(-30.45,-6.715),(-30.45,-6.885),(-30.62,-6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-6.545),(-30.62,-6.375),(-30.45,-6.375),(-30.45,-6.545),(-30.62,-6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-6.205),(-30.62,-6.035),(-30.45,-6.035),(-30.45,-6.205),(-30.62,-6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,6.035),(30.45,6.205),(30.62,6.205),(30.62,6.035),(30.45,6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,6.375),(30.45,6.545),(30.62,6.545),(30.62,6.375),(30.45,6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.595,-9.765),(-0.595,-9.595),(-0.425,-9.595),(-0.425,-9.765),(-0.595,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.765,-9.765),(0.765,-9.595),(0.935,-9.595),(0.935,-9.765),(0.765,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.935,9.595),(-0.935,9.765),(-0.765,9.765),(-0.765,9.595),(-0.935,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.595,9.595),(-0.595,9.765),(-0.425,9.765),(-0.425,9.595),(-0.595,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((0.425,9.595),(0.425,9.765),(0.595,9.765),(0.595,9.595),(0.425,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((0.425,-9.765),(0.425,-9.595),(0.595,-9.595),(0.595,-9.765),(0.425,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.935,-9.765),(-0.935,-9.595),(-0.765,-9.595),(-0.765,-9.765),(-0.935,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.765,9.595),(0.765,9.765),(0.935,9.765),(0.935,9.595),(0.765,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((12.325,-9.765),(12.325,-9.595),(12.495,-9.595),(12.495,-9.765),(12.325,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((12.325,9.595),(12.325,9.765),(12.495,9.765),(12.495,9.595),(12.325,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((12.665,9.595),(12.665,9.765),(12.835,9.765),(12.835,9.595),(12.665,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((12.665,-9.765),(12.665,-9.595),(12.835,-9.595),(12.835,-9.765),(12.665,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((2.125,-9.765),(2.125,-9.595),(2.295,-9.595),(2.295,-9.765),(2.125,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((2.465,-9.765),(2.465,-9.595),(2.635,-9.595),(2.635,-9.765),(2.465,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((2.805,-9.765),(2.805,-9.595),(2.975,-9.595),(2.975,-9.765),(2.805,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((2.125,9.595),(2.125,9.765),(2.295,9.765),(2.295,9.595),(2.125,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((2.465,9.595),(2.465,9.765),(2.635,9.765),(2.635,9.595),(2.465,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((2.805,9.595),(2.805,9.765),(2.975,9.765),(2.975,9.595),(2.805,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-1.785),(-30.62,-1.615),(-30.45,-1.615),(-30.45,-1.785),(-30.62,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-1.445),(-30.62,-1.275),(-30.45,-1.275),(-30.45,-1.445),(-30.62,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,1.275),(-30.62,1.445),(-30.45,1.445),(-30.45,1.275),(-30.62,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,1.615),(-30.62,1.785),(-30.45,1.785),(-30.45,1.615),(-30.62,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((19.125,-9.765),(19.125,-9.595),(19.295,-9.595),(19.295,-9.765),(19.125,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((19.465,-9.765),(19.465,-9.595),(19.635,-9.595),(19.635,-9.765),(19.465,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.295,9.595),(-19.295,9.765),(-19.125,9.765),(-19.125,9.595),(-19.295,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.635,9.595),(-19.635,9.765),(-19.465,9.765),(-19.465,9.595),(-19.635,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((19.805,-9.765),(19.805,-9.595),(19.975,-9.595),(19.975,-9.765),(19.805,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.975,9.595),(-19.975,9.765),(-19.805,9.765),(-19.805,9.595),(-19.975,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((17.085,9.595),(17.085,9.765),(17.255,9.765),(17.255,9.595),(17.085,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((17.765,9.595),(17.765,9.765),(17.935,9.765),(17.935,9.595),(17.765,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((17.425,9.595),(17.425,9.765),(17.595,9.765),(17.595,9.595),(17.425,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.935,-9.765),(-17.935,-9.595),(-17.765,-9.595),(-17.765,-9.765),(-17.935,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.595,-9.765),(-17.595,-9.595),(-17.425,-9.595),(-17.425,-9.765),(-17.595,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.925,-9.765),(8.925,-9.595),(9.095,-9.595),(9.095,-9.765),(8.925,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.255,-9.765),(-17.255,-9.595),(-17.085,-9.595),(-17.085,-9.765),(-17.255,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.435,-9.765),(-9.435,-9.595),(-9.265,-9.595),(-9.265,-9.765),(-9.435,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.775,-9.765),(-9.775,-9.595),(-9.605,-9.595),(-9.605,-9.765),(-9.775,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.265,9.595),(9.265,9.765),(9.435,9.765),(9.435,9.595),(9.265,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((9.605,9.595),(9.605,9.765),(9.775,9.765),(9.775,9.595),(9.605,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((4.165,-9.765),(4.165,-9.595),(4.335,-9.595),(4.335,-9.765),(4.165,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((4.505,-9.765),(4.505,-9.595),(4.675,-9.595),(4.675,-9.765),(4.505,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((4.165,9.595),(4.165,9.765),(4.335,9.765),(4.335,9.595),(4.165,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((4.505,9.595),(4.505,9.765),(4.675,9.765),(4.675,9.595),(4.505,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.075,9.595),(-8.075,9.765),(-7.905,9.765),(-7.905,9.595),(-8.075,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.055,-9.765),(-24.055,-9.595),(-23.885,-9.595),(-23.885,-9.765),(-24.055,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-1.105),(-30.62,-0.935),(-30.45,-0.935),(-30.45,-1.105),(-30.62,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((14.025,-9.765),(14.025,-9.595),(14.195,-9.595),(14.195,-9.765),(14.025,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((14.365,-9.765),(14.365,-9.595),(14.535,-9.595),(14.535,-9.765),(14.365,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((14.705,-9.765),(14.705,-9.595),(14.875,-9.595),(14.875,-9.765),(14.705,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((14.025,9.595),(14.025,9.765),(14.195,9.765),(14.195,9.595),(14.025,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((14.365,9.595),(14.365,9.765),(14.535,9.765),(14.535,9.595),(14.365,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((14.705,9.595),(14.705,9.765),(14.875,9.765),(14.875,9.595),(14.705,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((4.845,9.595),(4.845,9.765),(5.015,9.765),(5.015,9.595),(4.845,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,3.995),(30.45,4.165),(30.62,4.165),(30.62,3.995),(30.45,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.755,-9.765),(-8.755,-9.595),(-8.585,-9.595),(-8.585,-9.765),(-8.755,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.415,-9.765),(-8.415,-9.595),(-8.245,-9.595),(-8.245,-9.765),(-8.415,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.755,9.595),(-8.755,9.765),(-8.585,9.765),(-8.585,9.595),(-8.755,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.415,9.595),(-8.415,9.765),(-8.245,9.765),(-8.245,9.595),(-8.415,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((7.225,9.595),(7.225,9.765),(7.395,9.765),(7.395,9.595),(7.225,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((7.565,9.595),(7.565,9.765),(7.735,9.765),(7.735,9.595),(7.565,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-8.925),(-30.62,-8.755),(-30.45,-8.755),(-30.45,-8.925),(-30.62,-8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.815,-9.765),(-28.815,-9.595),(-28.645,-9.595),(-28.645,-9.765),(-28.815,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-8.925),(30.45,-8.755),(30.62,-8.755),(30.62,-8.925),(30.45,-8.925)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.735,-9.765),(-7.735,-9.595),(-7.565,-9.595),(-7.565,-9.765),(-7.735,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.395,-9.765),(-7.395,-9.595),(-7.225,-9.595),(-7.225,-9.765),(-7.395,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.135,9.595),(-11.135,9.765),(-10.965,9.765),(-10.965,9.595),(-11.135,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((21.845,9.595),(21.845,9.765),(22.015,9.765),(22.015,9.595),(21.845,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.475,9.595),(-28.475,9.765),(-28.305,9.765),(-28.305,9.595),(-28.475,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-8.245),(-30.62,-8.075),(-30.45,-8.075),(-30.45,-8.245),(-30.62,-8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.475,-9.765),(-28.475,-9.595),(-28.305,-9.595),(-28.305,-9.765),(-28.475,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.035,9.595),(-23.035,9.765),(-22.865,9.765),(-22.865,9.595),(-23.035,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((24.905,9.595),(24.905,9.765),(25.075,9.765),(25.075,9.595),(24.905,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((10.965,9.595),(10.965,9.765),(11.135,9.765),(11.135,9.595),(10.965,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.035,-9.765),(-23.035,-9.595),(-22.865,-9.595),(-22.865,-9.765),(-23.035,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.115,-9.765),(-10.115,-9.595),(-9.945,-9.595),(-9.945,-9.765),(-10.115,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-28.135,9.595),(-28.135,9.765),(-27.965,9.765),(-27.965,9.595),(-28.135,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-29.155,-9.765),(-29.155,-9.595),(-28.985,-9.595),(-28.985,-9.765),(-29.155,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.035,9.595),(-6.035,9.765),(-5.865,9.765),(-5.865,9.595),(-6.035,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,3.315),(-30.62,3.485),(-30.45,3.485),(-30.45,3.315),(-30.62,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,3.655),(-30.62,3.825),(-30.45,3.825),(-30.45,3.655),(-30.62,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-3.825),(-30.62,-3.655),(-30.45,-3.655),(-30.45,-3.825),(-30.62,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-3.485),(-30.62,-3.315),(-30.45,-3.315),(-30.45,-3.485),(-30.62,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.995,-9.765),(-20.995,-9.595),(-20.825,-9.595),(-20.825,-9.765),(-20.995,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.995,9.595),(-20.995,9.765),(-20.825,9.765),(-20.825,9.595),(-20.995,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.655,9.595),(-20.655,9.765),(-20.485,9.765),(-20.485,9.595),(-20.655,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.655,-9.765),(-20.655,-9.595),(-20.485,-9.595),(-20.485,-9.765),(-20.655,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.315,-9.765),(-20.315,-9.595),(-20.145,-9.595),(-20.145,-9.765),(-20.315,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-8.585),(30.45,-8.415),(30.62,-8.415),(30.62,-8.585),(30.45,-8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.315,9.595),(-20.315,9.765),(-20.145,9.765),(-20.145,9.595),(-20.315,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-8.585),(-30.62,-8.415),(-30.45,-8.415),(-30.45,-8.585),(-30.62,-8.585)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-0.425),(-30.62,-0.255),(-30.45,-0.255),(-30.45,-0.425),(-30.62,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,0.255),(-30.62,0.425),(-30.45,0.425),(-30.45,0.255),(-30.62,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-0.425),(30.45,-0.255),(30.62,-0.255),(30.62,-0.425),(30.45,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,0.255),(30.45,0.425),(30.62,0.425),(30.62,0.255),(30.45,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((7.905,-9.765),(7.905,-9.595),(8.075,-9.595),(8.075,-9.765),(7.905,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.615,9.595),(-18.615,9.765),(-18.445,9.765),(-18.445,9.595),(-18.615,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.275,9.595),(-18.275,9.765),(-18.105,9.765),(-18.105,9.595),(-18.275,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.955,-9.765),(-18.955,-9.595),(-18.785,-9.595),(-18.785,-9.765),(-18.955,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.615,-9.765),(-18.615,-9.595),(-18.445,-9.595),(-18.445,-9.765),(-18.615,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.275,-9.765),(-18.275,-9.595),(-18.105,-9.595),(-18.105,-9.765),(-18.275,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.955,9.595),(-18.955,9.765),(-18.785,9.765),(-18.785,9.595),(-18.955,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((11.985,-9.765),(11.985,-9.595),(12.155,-9.595),(12.155,-9.765),(11.985,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.795,-9.765),(-10.795,-9.595),(-10.625,-9.595),(-10.625,-9.765),(-10.795,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.455,-9.765),(-10.455,-9.595),(-10.285,-9.595),(-10.285,-9.765),(-10.455,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.795,9.595),(-10.795,9.765),(-10.625,9.765),(-10.625,9.595),(-10.795,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.455,9.595),(-10.455,9.765),(-10.285,9.765),(-10.285,9.595),(-10.455,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-7.905),(30.45,-7.735),(30.62,-7.735),(30.62,-7.905),(30.45,-7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-7.565),(30.45,-7.395),(30.62,-7.395),(30.62,-7.565),(30.45,-7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-7.225),(30.45,-7.055),(30.62,-7.055),(30.62,-7.225),(30.45,-7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.075,-9.765),(-25.075,-9.595),(-24.905,-9.595),(-24.905,-9.765),(-25.075,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,7.055),(30.45,7.225),(30.62,7.225),(30.62,7.055),(30.45,7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,7.395),(30.45,7.565),(30.62,7.565),(30.62,7.395),(30.45,7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,7.735),(30.45,7.905),(30.62,7.905),(30.62,7.735),(30.45,7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,1.615),(30.45,1.785),(30.62,1.785),(30.62,1.615),(30.45,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-1.785),(30.45,-1.615),(30.62,-1.615),(30.62,-1.785),(30.45,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-1.445),(30.45,-1.275),(30.62,-1.275),(30.62,-1.445),(30.45,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,1.275),(30.45,1.445),(30.62,1.445),(30.62,1.275),(30.45,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.095,9.595),(-26.095,9.765),(-25.925,9.765),(-25.925,9.595),(-26.095,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.935,9.595),(-17.935,9.765),(-17.765,9.765),(-17.765,9.595),(-17.935,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.595,9.595),(-17.595,9.765),(-17.425,9.765),(-17.425,9.595),(-17.595,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.255,9.595),(-17.255,9.765),(-17.085,9.765),(-17.085,9.595),(-17.255,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((17.085,-9.765),(17.085,-9.595),(17.255,-9.595),(17.255,-9.765),(17.085,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((17.425,-9.765),(17.425,-9.595),(17.595,-9.595),(17.595,-9.765),(17.425,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((17.765,-9.765),(17.765,-9.595),(17.935,-9.595),(17.935,-9.765),(17.765,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.435,9.595),(-9.435,9.765),(-9.265,9.765),(-9.265,9.595),(-9.435,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.775,9.595),(-9.775,9.765),(-9.605,9.765),(-9.605,9.595),(-9.775,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((9.265,-9.765),(9.265,-9.595),(9.435,-9.595),(9.435,-9.765),(9.265,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((9.605,-9.765),(9.605,-9.595),(9.775,-9.595),(9.775,-9.765),(9.605,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.515,-9.765),(-30.515,-9.595),(-30.345,-9.595),(-30.345,-9.765),(-30.515,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,9.095),(-30.62,9.265),(-30.45,9.265),(-30.45,9.095),(-30.62,9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.175,9.595),(-30.175,9.765),(-30.005,9.765),(-30.005,9.595),(-30.175,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.175,-9.765),(-30.175,-9.595),(-30.005,-9.595),(-30.005,-9.765),(-30.175,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.515,9.595),(-30.515,9.765),(-30.345,9.765),(-30.345,9.595),(-30.515,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-9.265),(-30.62,-9.095),(-30.45,-9.095),(-30.45,-9.265),(-30.62,-9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-0.085),(-30.62,0.085),(-30.45,0.085),(-30.45,-0.085),(-30.62,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-0.085),(30.45,0.085),(30.62,0.085),(30.62,-0.085),(30.45,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.515,-9.765),(-13.515,-9.595),(-13.345,-9.595),(-13.345,-9.765),(-13.515,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.855,-9.765),(-13.855,-9.595),(-13.685,-9.595),(-13.685,-9.765),(-13.855,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.175,-9.765),(-13.175,-9.595),(-13.005,-9.595),(-13.005,-9.765),(-13.175,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.005,9.595),(13.005,9.765),(13.175,9.765),(13.175,9.595),(13.005,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((13.345,9.595),(13.345,9.765),(13.515,9.765),(13.515,9.595),(13.345,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((13.685,9.595),(13.685,9.765),(13.855,9.765),(13.855,9.595),(13.685,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((25.925,-9.765),(25.925,-9.595),(26.095,-9.595),(26.095,-9.765),(25.925,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,4.335),(-30.62,4.505),(-30.45,4.505),(-30.45,4.335),(-30.62,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,4.675),(-30.62,4.845),(-30.45,4.845),(-30.45,4.675),(-30.62,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,4.335),(30.45,4.505),(30.62,4.505),(30.62,4.335),(30.45,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,4.675),(30.45,4.845),(30.62,4.845),(30.62,4.675),(30.45,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-5.865),(-30.62,-5.695),(-30.45,-5.695),(-30.45,-5.865),(-30.62,-5.865)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-5.525),(-30.62,-5.355),(-30.45,-5.355),(-30.45,-5.525),(-30.62,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-5.185),(-30.62,-5.015),(-30.45,-5.015),(-30.45,-5.185),(-30.62,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,5.015),(-30.62,5.185),(-30.45,5.185),(-30.45,5.015),(-30.62,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,5.355),(-30.62,5.525),(-30.45,5.525),(-30.45,5.355),(-30.62,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,5.695),(-30.62,5.865),(-30.45,5.865),(-30.45,5.695),(-30.62,5.695)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.695,-9.765),(-5.695,-9.595),(-5.525,-9.595),(-5.525,-9.765),(-5.695,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.355,-9.765),(-5.355,-9.595),(-5.185,-9.595),(-5.185,-9.765),(-5.355,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((5.185,9.595),(5.185,9.765),(5.355,9.765),(5.355,9.595),(5.185,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((5.525,9.595),(5.525,9.765),(5.695,9.765),(5.695,9.595),(5.525,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,3.995),(-30.62,4.165),(-30.45,4.165),(-30.45,3.995),(-30.62,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((7.225,-9.765),(7.225,-9.595),(7.395,-9.595),(7.395,-9.765),(7.225,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((7.565,-9.765),(7.565,-9.595),(7.735,-9.595),(7.735,-9.765),(7.565,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.305,-9.765),(28.305,-9.595),(28.475,-9.595),(28.475,-9.765),(28.305,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((28.645,-9.765),(28.645,-9.595),(28.815,-9.595),(28.815,-9.765),(28.645,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.735,9.595),(-7.735,9.765),(-7.565,9.765),(-7.565,9.595),(-7.735,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.395,9.595),(-7.395,9.765),(-7.225,9.765),(-7.225,9.595),(-7.395,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((28.305,9.595),(28.305,9.765),(28.475,9.765),(28.475,9.595),(28.305,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((28.645,9.595),(28.645,9.765),(28.815,9.765),(28.815,9.595),(28.645,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((24.905,-9.765),(24.905,-9.595),(25.075,-9.595),(25.075,-9.765),(24.905,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.415,-9.765),(-25.415,-9.595),(-25.245,-9.595),(-25.245,-9.765),(-25.415,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-25.755,-9.765),(-25.755,-9.595),(-25.585,-9.595),(-25.585,-9.765),(-25.755,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.965,-9.765),(10.965,-9.595),(11.135,-9.595),(11.135,-9.765),(10.965,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((25.245,9.595),(25.245,9.765),(25.415,9.765),(25.415,9.595),(25.245,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((25.585,9.595),(25.585,9.765),(25.755,9.765),(25.755,9.595),(25.585,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((28.985,9.595),(28.985,9.765),(29.155,9.765),(29.155,9.595),(28.985,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((6.885,9.595),(6.885,9.765),(7.055,9.765),(7.055,9.595),(6.885,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-2.805),(-30.62,-2.635),(-30.45,-2.635),(-30.45,-2.805),(-30.62,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-2.465),(-30.62,-2.295),(-30.45,-2.295),(-30.45,-2.465),(-30.62,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,2.295),(30.45,2.465),(30.62,2.465),(30.62,2.295),(30.45,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,2.635),(30.45,2.805),(30.62,2.805),(30.62,2.635),(30.45,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((7.905,9.595),(7.905,9.765),(8.075,9.765),(8.075,9.595),(7.905,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.035,-9.765),(-6.035,-9.595),(-5.865,-9.595),(-5.865,-9.765),(-6.035,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.145,-9.765),(20.145,-9.595),(20.315,-9.595),(20.315,-9.765),(20.145,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.485,-9.765),(20.485,-9.595),(20.655,-9.595),(20.655,-9.765),(20.485,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.825,-9.765),(20.825,-9.595),(20.995,-9.595),(20.995,-9.765),(20.825,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((20.145,9.595),(20.145,9.765),(20.315,9.765),(20.315,9.595),(20.145,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((20.485,9.595),(20.485,9.765),(20.655,9.765),(20.655,9.595),(20.485,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((20.825,9.595),(20.825,9.765),(20.995,9.765),(20.995,9.595),(20.825,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((11.985,9.595),(11.985,9.765),(12.155,9.765),(12.155,9.595),(11.985,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((16.065,-9.765),(16.065,-9.595),(16.235,-9.595),(16.235,-9.765),(16.065,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.405,-9.765),(16.405,-9.595),(16.575,-9.595),(16.575,-9.765),(16.405,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.745,-9.765),(16.745,-9.595),(16.915,-9.595),(16.915,-9.765),(16.745,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.065,9.595),(16.065,9.765),(16.235,9.765),(16.235,9.595),(16.065,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((16.405,9.595),(16.405,9.765),(16.575,9.765),(16.575,9.595),(16.405,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((16.745,9.595),(16.745,9.765),(16.915,9.765),(16.915,9.595),(16.745,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((8.245,-9.765),(8.245,-9.595),(8.415,-9.595),(8.415,-9.765),(8.245,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.585,-9.765),(8.585,-9.595),(8.755,-9.595),(8.755,-9.765),(8.585,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.245,9.595),(8.245,9.765),(8.415,9.765),(8.415,9.595),(8.245,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.155,-9.765),(-12.155,-9.595),(-11.985,-9.595),(-11.985,-9.765),(-12.155,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((8.585,9.595),(8.585,9.765),(8.755,9.765),(8.755,9.595),(8.585,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-8.245),(30.45,-8.075),(30.62,-8.075),(30.62,-8.245),(30.45,-8.245)),
        )
        createRL(
            tech, net, 'licon',
            ((18.105,-9.765),(18.105,-9.595),(18.275,-9.595),(18.275,-9.765),(18.105,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.445,-9.765),(18.445,-9.595),(18.615,-9.595),(18.615,-9.765),(18.445,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.785,-9.765),(18.785,-9.595),(18.955,-9.595),(18.955,-9.765),(18.785,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((18.105,9.595),(18.105,9.765),(18.275,9.765),(18.275,9.595),(18.105,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((18.445,9.595),(18.445,9.765),(18.615,9.765),(18.615,9.595),(18.445,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((18.785,9.595),(18.785,9.765),(18.955,9.765),(18.955,9.595),(18.785,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((10.285,-9.765),(10.285,-9.595),(10.455,-9.595),(10.455,-9.765),(10.285,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.625,-9.765),(10.625,-9.595),(10.795,-9.595),(10.795,-9.765),(10.625,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((10.285,9.595),(10.285,9.765),(10.455,9.765),(10.455,9.595),(10.285,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((10.625,9.595),(10.625,9.765),(10.795,9.765),(10.795,9.595),(10.625,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,6.035),(-30.62,6.205),(-30.45,6.205),(-30.45,6.035),(-30.62,6.035)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,6.375),(-30.62,6.545),(-30.45,6.545),(-30.45,6.375),(-30.62,6.375)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,6.715),(-30.62,6.885),(-30.45,6.885),(-30.45,6.715),(-30.62,6.715)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-6.885),(30.45,-6.715),(30.62,-6.715),(30.62,-6.885),(30.45,-6.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-6.545),(30.45,-6.375),(30.62,-6.375),(30.62,-6.545),(30.45,-6.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-6.205),(30.45,-6.035),(30.62,-6.035),(30.62,-6.205),(30.45,-6.205)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-7.905),(-30.62,-7.735),(-30.45,-7.735),(-30.45,-7.905),(-30.62,-7.905)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-7.565),(-30.62,-7.395),(-30.45,-7.395),(-30.45,-7.565),(-30.62,-7.565)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.815,-9.765),(-11.815,-9.595),(-11.645,-9.595),(-11.645,-9.765),(-11.815,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.475,-9.765),(-11.475,-9.595),(-11.305,-9.595),(-11.305,-9.765),(-11.475,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-7.225),(-30.62,-7.055),(-30.45,-7.055),(-30.45,-7.225),(-30.62,-7.225)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,7.055),(-30.62,7.225),(-30.45,7.225),(-30.45,7.055),(-30.62,7.055)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,7.395),(-30.62,7.565),(-30.45,7.565),(-30.45,7.395),(-30.62,7.395)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,7.735),(-30.62,7.905),(-30.45,7.905),(-30.45,7.735),(-30.62,7.735)),
        )
        createRL(
            tech, net, 'licon',
            ((11.305,9.595),(11.305,9.765),(11.475,9.765),(11.475,9.595),(11.305,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((11.645,9.595),(11.645,9.765),(11.815,9.765),(11.815,9.595),(11.645,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-3.145),(30.45,-2.975),(30.62,-2.975),(30.62,-3.145),(30.45,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.715,-9.765),(-6.715,-9.595),(-6.545,-9.595),(-6.545,-9.765),(-6.715,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.375,-9.765),(-6.375,-9.595),(-6.205,-9.595),(-6.205,-9.765),(-6.375,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.715,9.595),(-6.715,9.765),(-6.545,9.765),(-6.545,9.595),(-6.715,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.375,9.595),(-6.375,9.765),(-6.205,9.765),(-6.205,9.595),(-6.375,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.735,-9.765),(-24.735,-9.595),(-24.565,-9.595),(-24.565,-9.765),(-24.735,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.395,-9.765),(-24.395,-9.595),(-24.225,-9.595),(-24.225,-9.765),(-24.395,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.735,9.595),(-24.735,9.765),(-24.565,9.765),(-24.565,9.595),(-24.735,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-24.395,9.595),(-24.395,9.765),(-24.225,9.765),(-24.225,9.595),(-24.395,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.375,-9.765),(-23.375,-9.595),(-23.205,-9.595),(-23.205,-9.765),(-23.375,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-23.715,-9.765),(-23.715,-9.595),(-23.545,-9.595),(-23.545,-9.765),(-23.715,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((23.205,9.595),(23.205,9.765),(23.375,9.765),(23.375,9.595),(23.205,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((23.545,9.595),(23.545,9.765),(23.715,9.765),(23.715,9.595),(23.545,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-27.115,9.595),(-27.115,9.765),(-26.945,9.765),(-26.945,9.595),(-27.115,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((26.945,9.595),(26.945,9.765),(27.115,9.765),(27.115,9.595),(26.945,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-26.095,-9.765),(-26.095,-9.595),(-25.925,-9.595),(-25.925,-9.765),(-26.095,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.345,9.595),(30.345,9.765),(30.515,9.765),(30.515,9.595),(30.345,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,9.095),(30.45,9.265),(30.62,9.265),(30.62,9.095),(30.45,9.095)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-9.265),(30.45,-9.095),(30.62,-9.095),(30.62,-9.265),(30.45,-9.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.005,-9.765),(30.005,-9.595),(30.175,-9.595),(30.175,-9.765),(30.005,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.345,-9.765),(30.345,-9.595),(30.515,-9.595),(30.515,-9.765),(30.345,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((3.485,9.595),(3.485,9.765),(3.655,9.765),(3.655,9.595),(3.485,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((3.825,9.595),(3.825,9.765),(3.995,9.765),(3.995,9.595),(3.825,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.995,-9.765),(-3.995,-9.595),(-3.825,-9.595),(-3.825,-9.765),(-3.995,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.655,-9.765),(-3.655,-9.595),(-3.485,-9.595),(-3.485,-9.765),(-3.655,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.315,-9.765),(-3.315,-9.595),(-3.145,-9.595),(-3.145,-9.765),(-3.315,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-22.015,9.595),(-22.015,9.765),(-21.845,9.765),(-21.845,9.595),(-22.015,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((3.145,9.595),(3.145,9.765),(3.315,9.765),(3.315,9.595),(3.145,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.135,-9.765),(-11.135,-9.595),(-10.965,-9.595),(-10.965,-9.765),(-11.135,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.855,9.595),(-13.855,9.765),(-13.685,9.765),(-13.685,9.595),(-13.855,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.515,9.595),(-13.515,9.765),(-13.345,9.765),(-13.345,9.595),(-13.515,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.175,9.595),(-13.175,9.765),(-13.005,9.765),(-13.005,9.595),(-13.175,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((13.005,-9.765),(13.005,-9.595),(13.175,-9.595),(13.175,-9.765),(13.005,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.345,-9.765),(13.345,-9.595),(13.515,-9.595),(13.515,-9.765),(13.345,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((13.685,-9.765),(13.685,-9.595),(13.855,-9.595),(13.855,-9.765),(13.685,-9.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.015,9.595),(-5.015,9.765),(-4.845,9.765),(-4.845,9.595),(-5.015,9.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-4.845),(-30.62,-4.675),(-30.45,-4.675),(-30.45,-4.845),(-30.62,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-30.62,-4.505),(-30.62,-4.335),(-30.45,-4.335),(-30.45,-4.505),(-30.62,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-4.845),(30.45,-4.675),(30.62,-4.675),(30.62,-4.845),(30.45,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.45,-4.505),(30.45,-4.335),(30.62,-4.335),(30.62,-4.505),(30.45,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((9.945,9.595),(9.945,9.765),(10.115,9.765),(10.115,9.595),(9.945,9.595)),
        )
        createRL(
            tech, net, 'li',
            ((-30.775,9.44),(-30.775,9.92),(30.775,9.92),(30.775,9.44),(-30.775,9.44)),
        )
        createRL(
            tech, net, 'li',
            ((-30.515,9.515),(-30.515,9.845),(30.515,9.845),(30.515,9.515),(-30.515,9.515)),
        )
        createRL(
            tech, net, 'li',
            ((-30.515,-9.845),(-30.515,-9.515),(30.515,-9.515),(30.515,-9.845),(-30.515,-9.845)),
        )
        createRL(
            tech, net, 'li',
            ((-30.775,-9.92),(-30.775,9.92),(-30.295,9.92),(-30.295,-9.92),(-30.775,-9.92)),
        )
        createRL(
            tech, net, 'li',
            ((-30.62,-9.345),(-30.62,9.345),(-30.45,9.345),(-30.45,-9.345),(-30.62,-9.345)),
        )
        createRL(
            tech, net, 'li',
            ((30.45,-9.345),(30.45,9.345),(30.62,9.345),(30.62,-9.345),(30.45,-9.345)),
        )
        createRL(
            tech, net, 'li',
            ((30.295,-9.92),(30.295,9.92),(30.775,9.92),(30.775,-9.92),(30.295,-9.92)),
        )
        createRL(
            tech, net, 'li',
            ((-30.775,-9.92),(-30.775,-9.44),(30.775,-9.44),(30.775,-9.92),(-30.775,-9.92)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((-30.9,-10.045),(-30.9,-9.315),(30.9,-9.315),(30.9,-10.045),(-30.9,-10.045)),
        )
        createRL(
            tech, net, 'psdm',
            ((-30.9,9.315),(-30.9,10.045),(30.9,10.045),(30.9,9.315),(-30.9,9.315)),
        )
        createRL(
            tech, net, 'psdm',
            ((-30.9,-9.565),(-30.9,9.565),(-30.17,9.565),(-30.17,-9.565),(-30.9,-9.565)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.17,-9.565),(30.17,9.565),(30.9,9.565),(30.9,-9.565),(30.17,-9.565)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-30.17,-9.315),(-30.17,9.315),(30.17,9.315),(30.17,-9.315),(-30.17,-9.315)),
        )
        nets['conn'].setDirection(Net.Direction.IN)

    cell = new_cells['GuardRing_N8666W2488HTT']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(-21.66500000000002), u(-6.220000000000001), u(21.66500000000002), u(6.220000000000001),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'conn': Net.create(cell, 'conn'),
        }
        net = nets['conn']
        createRL(
            tech, net, 'difftap',
            ((-21.665,5.74),(-21.665,6.22),(21.665,6.22),(21.665,5.74),(-21.665,5.74)),
        )
        createRL(
            tech, net, 'difftap',
            ((-21.665,-5.74),(-21.665,5.74),(-21.185,5.74),(-21.185,-5.74),(-21.665,-5.74)),
        )
        createRL(
            tech, net, 'difftap',
            ((21.185,-5.74),(21.185,5.74),(21.665,5.74),(21.665,-5.74),(21.185,-5.74)),
        )
        createRL(
            tech, net, 'difftap',
            ((-21.665,-6.22),(-21.665,-5.74),(21.665,-5.74),(21.665,-6.22),(-21.665,-6.22)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.005,-6.065),(-13.005,-5.895),(-12.835,-5.895),(-12.835,-6.065),(-13.005,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.995,-6.065),(20.995,-5.895),(21.165,-5.895),(21.165,-6.065),(20.995,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.145,-6.065),(-20.145,-5.895),(-19.975,-5.895),(-19.975,-6.065),(-20.145,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.375,-6.065),(6.375,-5.895),(6.545,-5.895),(6.545,-6.065),(6.375,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.715,-6.065),(6.715,-5.895),(6.885,-5.895),(6.885,-6.065),(6.715,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.035,-6.065),(6.035,-5.895),(6.205,-5.895),(6.205,-6.065),(6.035,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.165,5.895),(-4.165,6.065),(-3.995,6.065),(-3.995,5.895),(-4.165,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((13.855,5.895),(13.855,6.065),(14.025,6.065),(14.025,5.895),(13.855,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.805,-6.065),(-19.805,-5.895),(-19.635,-5.895),(-19.635,-6.065),(-19.805,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.045,5.895),(-15.045,6.065),(-14.875,6.065),(-14.875,5.895),(-15.045,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((1.955,5.895),(1.955,6.065),(2.125,6.065),(2.125,5.895),(1.955,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.465,-6.065),(-19.465,-5.895),(-19.295,-5.895),(-19.295,-6.065),(-19.465,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.245,5.895),(-8.245,6.065),(-8.075,6.065),(-8.075,5.895),(-8.245,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((19.975,5.895),(19.975,6.065),(20.145,6.065),(20.145,5.895),(19.975,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.925,5.895),(-8.925,6.065),(-8.755,6.065),(-8.755,5.895),(-8.925,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.585,5.895),(-8.585,6.065),(-8.415,6.065),(-8.415,5.895),(-8.585,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.765,-6.065),(-17.765,-5.895),(-17.595,-5.895),(-17.595,-6.065),(-17.765,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.685,5.895),(-13.685,6.065),(-13.515,6.065),(-13.515,5.895),(-13.685,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.345,5.895),(-13.345,6.065),(-13.175,6.065),(-13.175,5.895),(-13.345,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((2.975,-6.065),(2.975,-5.895),(3.145,-5.895),(3.145,-6.065),(2.975,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.425,-6.065),(-17.425,-5.895),(-17.255,-5.895),(-17.255,-6.065),(-17.425,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((12.155,5.895),(12.155,6.065),(12.325,6.065),(12.325,5.895),(12.155,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((12.495,5.895),(12.495,6.065),(12.665,6.065),(12.665,5.895),(12.495,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.785,5.895),(-1.785,6.065),(-1.615,6.065),(-1.615,5.895),(-1.785,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.445,5.895),(-1.445,6.065),(-1.275,6.065),(-1.275,5.895),(-1.445,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.025,-6.065),(-14.025,-5.895),(-13.855,-5.895),(-13.855,-6.065),(-14.025,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-0.765),(21.34,-0.595),(21.51,-0.595),(21.51,-0.765),(21.34,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-0.425),(21.34,-0.255),(21.51,-0.255),(21.51,-0.425),(21.34,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-0.085),(21.34,0.085),(21.51,0.085),(21.51,-0.085),(21.34,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,0.255),(21.34,0.425),(21.51,0.425),(21.51,0.255),(21.34,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,0.595),(21.34,0.765),(21.51,0.765),(21.51,0.595),(21.34,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.765,5.895),(-0.765,6.065),(-0.595,6.065),(-0.595,5.895),(-0.765,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,5.895),(0.595,6.065),(0.765,6.065),(0.765,5.895),(0.595,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-0.765),(-21.51,-0.595),(-21.34,-0.595),(-21.34,-0.765),(-21.51,-0.765)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.945,-6.065),(-9.945,-5.895),(-9.775,-5.895),(-9.775,-6.065),(-9.945,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.605,-6.065),(-9.605,-5.895),(-9.435,-5.895),(-9.435,-6.065),(-9.605,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.265,-6.065),(-9.265,-5.895),(-9.095,-5.895),(-9.095,-6.065),(-9.265,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.095,-6.065),(9.095,-5.895),(9.265,-5.895),(9.265,-6.065),(9.095,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.435,-6.065),(9.435,-5.895),(9.605,-5.895),(9.605,-6.065),(9.435,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.775,-6.065),(9.775,-5.895),(9.945,-5.895),(9.945,-6.065),(9.775,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.315,-6.065),(20.315,-5.895),(20.485,-5.895),(20.485,-6.065),(20.315,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((20.655,-6.065),(20.655,-5.895),(20.825,-5.895),(20.825,-6.065),(20.655,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.955,5.895),(18.955,6.065),(19.125,6.065),(19.125,5.895),(18.955,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((16.915,-6.065),(16.915,-5.895),(17.085,-5.895),(17.085,-6.065),(16.915,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.895,-6.065),(15.895,-5.895),(16.065,-5.895),(16.065,-6.065),(15.895,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-3.145),(21.34,-2.975),(21.51,-2.975),(21.51,-3.145),(21.34,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.805,-6.065),(-2.805,-5.895),(-2.635,-5.895),(-2.635,-6.065),(-2.805,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.465,-6.065),(-2.465,-5.895),(-2.295,-5.895),(-2.295,-6.065),(-2.465,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.985,5.895),(-11.985,6.065),(-11.815,6.065),(-11.815,5.895),(-11.985,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.645,5.895),(-11.645,6.065),(-11.475,6.065),(-11.475,5.895),(-11.645,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.305,5.895),(-11.305,6.065),(-11.135,6.065),(-11.135,5.895),(-11.305,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((13.175,5.895),(13.175,6.065),(13.345,6.065),(13.345,5.895),(13.175,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((13.515,5.895),(13.515,6.065),(13.685,6.065),(13.685,5.895),(13.515,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.825,5.895),(-20.825,6.065),(-20.655,6.065),(-20.655,5.895),(-20.825,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.485,5.895),(-20.485,6.065),(-20.315,6.065),(-20.315,5.895),(-20.485,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((1.615,5.895),(1.615,6.065),(1.785,6.065),(1.785,5.895),(1.615,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.385,5.895),(-15.385,6.065),(-15.215,6.065),(-15.215,5.895),(-15.385,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,5.895),(1.275,6.065),(1.445,6.065),(1.445,5.895),(1.275,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-4.845),(21.34,-4.675),(21.51,-4.675),(21.51,-4.845),(21.34,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-4.505),(21.34,-4.335),(21.51,-4.335),(21.51,-4.505),(21.34,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-4.845),(-21.51,-4.675),(-21.34,-4.675),(-21.34,-4.845),(-21.51,-4.845)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-4.505),(-21.51,-4.335),(-21.34,-4.335),(-21.34,-4.505),(-21.51,-4.505)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.725,5.895),(-15.725,6.065),(-15.555,6.065),(-15.555,5.895),(-15.725,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.145,5.895),(-3.145,6.065),(-2.975,6.065),(-2.975,5.895),(-3.145,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((12.835,5.895),(12.835,6.065),(13.005,6.065),(13.005,5.895),(12.835,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-5.525),(21.34,-5.355),(21.51,-5.355),(21.51,-5.525),(21.34,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-5.185),(21.34,-5.015),(21.51,-5.015),(21.51,-5.185),(21.34,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,5.015),(-21.51,5.185),(-21.34,5.185),(-21.34,5.015),(-21.51,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,2.975),(21.34,3.145),(21.51,3.145),(21.51,2.975),(21.34,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.935,5.895),(0.935,6.065),(1.105,6.065),(1.105,5.895),(0.935,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,2.975),(-21.51,3.145),(-21.34,3.145),(-21.34,2.975),(-21.51,2.975)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.105,-6.065),(-1.105,-5.895),(-0.935,-5.895),(-0.935,-6.065),(-1.105,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,5.355),(-21.51,5.525),(-21.34,5.525),(-21.34,5.355),(-21.51,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-3.825),(-21.51,-3.655),(-21.34,-3.655),(-21.34,-3.825),(-21.51,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.865,5.895),(-5.865,6.065),(-5.695,6.065),(-5.695,5.895),(-5.865,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.525,5.895),(-5.525,6.065),(-5.355,6.065),(-5.355,5.895),(-5.525,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.185,5.895),(-5.185,6.065),(-5.015,6.065),(-5.015,5.895),(-5.185,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((4.335,5.895),(4.335,6.065),(4.505,6.065),(4.505,5.895),(4.335,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.105,5.895),(-18.105,6.065),(-17.935,6.065),(-17.935,5.895),(-18.105,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((4.675,5.895),(4.675,6.065),(4.845,6.065),(4.845,5.895),(4.675,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((14.875,5.895),(14.875,6.065),(15.045,6.065),(15.045,5.895),(14.875,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((18.275,5.895),(18.275,6.065),(18.445,6.065),(18.445,5.895),(18.275,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((18.615,5.895),(18.615,6.065),(18.785,6.065),(18.785,5.895),(18.615,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.065,-6.065),(-16.065,-5.895),(-15.895,-5.895),(-15.895,-6.065),(-16.065,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.885,-6.065),(-6.885,-5.895),(-6.715,-5.895),(-6.715,-6.065),(-6.885,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.545,-6.065),(-6.545,-5.895),(-6.375,-5.895),(-6.375,-6.065),(-6.545,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.205,-6.065),(-6.205,-5.895),(-6.035,-5.895),(-6.035,-6.065),(-6.205,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-3.145),(-21.51,-2.975),(-21.34,-2.975),(-21.34,-3.145),(-21.51,-3.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.235,-6.065),(16.235,-5.895),(16.405,-5.895),(16.405,-6.065),(16.235,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.575,-6.065),(16.575,-5.895),(16.745,-5.895),(16.745,-6.065),(16.575,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.115,5.895),(10.115,6.065),(10.285,6.065),(10.285,5.895),(10.115,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((10.455,5.895),(10.455,6.065),(10.625,6.065),(10.625,5.895),(10.455,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((10.795,5.895),(10.795,6.065),(10.965,6.065),(10.965,5.895),(10.795,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((3.995,-6.065),(3.995,-5.895),(4.165,-5.895),(4.165,-6.065),(3.995,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.075,-6.065),(8.075,-5.895),(8.245,-5.895),(8.245,-6.065),(8.075,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.005,5.895),(-13.005,6.065),(-12.835,6.065),(-12.835,5.895),(-13.005,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((11.135,5.895),(11.135,6.065),(11.305,6.065),(11.305,5.895),(11.135,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((11.475,5.895),(11.475,6.065),(11.645,6.065),(11.645,5.895),(11.475,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((11.815,5.895),(11.815,6.065),(11.985,6.065),(11.985,5.895),(11.815,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((8.415,-6.065),(8.415,-5.895),(8.585,-5.895),(8.585,-6.065),(8.415,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((8.755,-6.065),(8.755,-5.895),(8.925,-5.895),(8.925,-6.065),(8.755,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.125,-6.065),(-2.125,-5.895),(-1.955,-5.895),(-1.955,-6.065),(-2.125,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.855,-6.065),(13.855,-5.895),(14.025,-5.895),(14.025,-6.065),(13.855,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.475,-6.065),(11.475,-5.895),(11.645,-5.895),(11.645,-6.065),(11.475,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.215,5.895),(15.215,6.065),(15.385,6.065),(15.385,5.895),(15.215,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((15.555,5.895),(15.555,6.065),(15.725,6.065),(15.725,5.895),(15.555,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((1.955,-6.065),(1.955,-5.895),(2.125,-5.895),(2.125,-6.065),(1.955,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-1.785),(21.34,-1.615),(21.51,-1.615),(21.51,-1.785),(21.34,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-1.445),(21.34,-1.275),(21.51,-1.275),(21.51,-1.445),(21.34,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,1.275),(-21.51,1.445),(-21.34,1.445),(-21.34,1.275),(-21.51,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,1.615),(-21.51,1.785),(-21.34,1.785),(-21.34,1.615),(-21.51,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.145,5.895),(-20.145,6.065),(-19.975,6.065),(-19.975,5.895),(-20.145,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,5.015),(21.34,5.185),(21.51,5.185),(21.51,5.015),(21.34,5.015)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,5.355),(21.34,5.525),(21.51,5.525),(21.51,5.355),(21.34,5.355)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-5.525),(-21.51,-5.355),(-21.34,-5.355),(-21.34,-5.525),(-21.51,-5.525)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-5.185),(-21.51,-5.015),(-21.34,-5.015),(-21.34,-5.185),(-21.51,-5.185)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.825,5.895),(-3.825,6.065),(-3.655,6.065),(-3.655,5.895),(-3.825,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.485,5.895),(-3.485,6.065),(-3.315,6.065),(-3.315,5.895),(-3.485,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((5.015,5.895),(5.015,6.065),(5.185,6.065),(5.185,5.895),(5.015,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((5.355,5.895),(5.355,6.065),(5.525,6.065),(5.525,5.895),(5.355,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((5.695,5.895),(5.695,6.065),(5.865,6.065),(5.865,5.895),(5.695,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.665,-6.065),(-12.665,-5.895),(-12.495,-5.895),(-12.495,-6.065),(-12.665,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.325,-6.065),(-12.325,-5.895),(-12.155,-5.895),(-12.155,-6.065),(-12.325,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.025,5.895),(-14.025,6.065),(-13.855,6.065),(-13.855,5.895),(-14.025,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-2.125),(21.34,-1.955),(21.51,-1.955),(21.51,-2.125),(21.34,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.785,5.895),(-18.785,6.065),(-18.615,6.065),(-18.615,5.895),(-18.785,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.445,5.895),(-18.445,6.065),(-18.275,6.065),(-18.275,5.895),(-18.445,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((14.195,5.895),(14.195,6.065),(14.365,6.065),(14.365,5.895),(14.195,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((14.535,5.895),(14.535,6.065),(14.705,6.065),(14.705,5.895),(14.535,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-2.125),(-21.51,-1.955),(-21.34,-1.955),(-21.34,-2.125),(-21.51,-2.125)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.745,-6.065),(-16.745,-5.895),(-16.575,-5.895),(-16.575,-6.065),(-16.745,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.405,-6.065),(-16.405,-5.895),(-16.235,-5.895),(-16.235,-6.065),(-16.405,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((19.295,-6.065),(19.295,-5.895),(19.465,-5.895),(19.465,-6.065),(19.295,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((19.635,-6.065),(19.635,-5.895),(19.805,-5.895),(19.805,-6.065),(19.635,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((5.015,-6.065),(5.015,-5.895),(5.185,-5.895),(5.185,-6.065),(5.015,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((5.355,-6.065),(5.355,-5.895),(5.525,-5.895),(5.525,-6.065),(5.355,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.515,-6.065),(13.515,-5.895),(13.685,-5.895),(13.685,-6.065),(13.515,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.965,5.895),(-10.965,6.065),(-10.795,6.065),(-10.795,5.895),(-10.965,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.625,5.895),(-10.625,6.065),(-10.455,6.065),(-10.455,5.895),(-10.625,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.285,5.895),(-10.285,6.065),(-10.115,6.065),(-10.115,5.895),(-10.285,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.685,-6.065),(-13.685,-5.895),(-13.515,-5.895),(-13.515,-6.065),(-13.685,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-13.345,-6.065),(-13.345,-5.895),(-13.175,-5.895),(-13.175,-6.065),(-13.345,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((13.175,-6.065),(13.175,-5.895),(13.345,-5.895),(13.345,-6.065),(13.175,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.165,-6.065),(-4.165,-5.895),(-3.995,-5.895),(-3.995,-6.065),(-4.165,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.785,-6.065),(-1.785,-5.895),(-1.615,-5.895),(-1.615,-6.065),(-1.785,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.445,-6.065),(-1.445,-5.895),(-1.275,-5.895),(-1.275,-6.065),(-1.445,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((1.275,-6.065),(1.275,-5.895),(1.445,-5.895),(1.445,-6.065),(1.275,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((1.615,-6.065),(1.615,-5.895),(1.785,-5.895),(1.785,-6.065),(1.615,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.045,-6.065),(-15.045,-5.895),(-14.875,-5.895),(-14.875,-6.065),(-15.045,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.085,5.895),(-0.085,6.065),(0.085,6.065),(0.085,5.895),(-0.085,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,1.275),(21.34,1.445),(21.51,1.445),(21.51,1.275),(21.34,1.275)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,1.615),(21.34,1.785),(21.51,1.785),(21.51,1.615),(21.34,1.615)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-1.785),(-21.51,-1.615),(-21.34,-1.615),(-21.34,-1.785),(-21.51,-1.785)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-1.445),(-21.51,-1.275),(-21.34,-1.275),(-21.34,-1.445),(-21.51,-1.445)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,3.995),(-21.51,4.165),(-21.34,4.165),(-21.34,3.995),(-21.51,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,3.315),(21.34,3.485),(21.51,3.485),(21.51,3.315),(21.34,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,3.655),(21.34,3.825),(21.51,3.825),(21.51,3.655),(21.34,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.165,-6.065),(-21.165,-5.895),(-20.995,-5.895),(-20.995,-6.065),(-21.165,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.895,5.895),(15.895,6.065),(16.065,6.065),(16.065,5.895),(15.895,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((3.315,5.895),(3.315,6.065),(3.485,6.065),(3.485,5.895),(3.315,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((3.655,5.895),(3.655,6.065),(3.825,6.065),(3.825,5.895),(3.655,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((12.835,-6.065),(12.835,-5.895),(13.005,-5.895),(13.005,-6.065),(12.835,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((2.975,5.895),(2.975,6.065),(3.145,6.065),(3.145,5.895),(2.975,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.935,-6.065),(0.935,-5.895),(1.105,-5.895),(1.105,-6.065),(0.935,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.705,5.895),(-14.705,6.065),(-14.535,6.065),(-14.535,5.895),(-14.705,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.365,5.895),(-14.365,6.065),(-14.195,6.065),(-14.195,5.895),(-14.365,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.125,5.895),(-19.125,6.065),(-18.955,6.065),(-18.955,5.895),(-19.125,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((18.275,-6.065),(18.275,-5.895),(18.445,-5.895),(18.445,-6.065),(18.275,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.615,-6.065),(18.615,-5.895),(18.785,-5.895),(18.785,-6.065),(18.615,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.815,-6.065),(11.815,-5.895),(11.985,-5.895),(11.985,-6.065),(11.815,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.905,5.895),(-7.905,6.065),(-7.735,6.065),(-7.735,5.895),(-7.905,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.565,5.895),(-7.565,6.065),(-7.395,6.065),(-7.395,5.895),(-7.565,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.225,5.895),(-7.225,6.065),(-7.055,6.065),(-7.055,5.895),(-7.225,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.985,-6.065),(-11.985,-5.895),(-11.815,-5.895),(-11.815,-6.065),(-11.985,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.645,-6.065),(-11.645,-5.895),(-11.475,-5.895),(-11.475,-6.065),(-11.645,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.085,-6.065),(-17.085,-5.895),(-16.915,-5.895),(-16.915,-6.065),(-17.085,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-11.305,-6.065),(-11.305,-5.895),(-11.135,-5.895),(-11.135,-6.065),(-11.305,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.215,-6.065),(15.215,-5.895),(15.385,-5.895),(15.385,-6.065),(15.215,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((11.135,-6.065),(11.135,-5.895),(11.305,-5.895),(11.305,-6.065),(11.135,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.505,5.895),(-21.505,6.065),(-21.335,6.065),(-21.335,5.895),(-21.505,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.725,-6.065),(-15.725,-5.895),(-15.555,-5.895),(-15.555,-6.065),(-15.725,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,2.295),(21.34,2.465),(21.51,2.465),(21.51,2.295),(21.34,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,2.635),(21.34,2.805),(21.51,2.805),(21.51,2.635),(21.34,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,2.295),(-21.51,2.465),(-21.34,2.465),(-21.34,2.295),(-21.51,2.295)),
        )
        createRL(
            tech, net, 'licon',
            ((20.315,5.895),(20.315,6.065),(20.485,6.065),(20.485,5.895),(20.315,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((20.655,5.895),(20.655,6.065),(20.825,6.065),(20.825,5.895),(20.655,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,2.635),(-21.51,2.805),(-21.34,2.805),(-21.34,2.635),(-21.51,2.635)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.845,-6.065),(-4.845,-5.895),(-4.675,-5.895),(-4.675,-6.065),(-4.845,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.505,-6.065),(-4.505,-5.895),(-4.335,-5.895),(-4.335,-6.065),(-4.505,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.115,-6.065),(10.115,-5.895),(10.285,-5.895),(10.285,-6.065),(10.115,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((10.455,-6.065),(10.455,-5.895),(10.625,-5.895),(10.625,-6.065),(10.455,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.425,5.895),(-0.425,6.065),(-0.255,6.065),(-0.255,5.895),(-0.425,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((0.255,5.895),(0.255,6.065),(0.425,6.065),(0.425,5.895),(0.255,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((10.795,-6.065),(10.795,-5.895),(10.965,-5.895),(10.965,-6.065),(10.795,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,3.995),(21.34,4.165),(21.51,4.165),(21.51,3.995),(21.34,3.995)),
        )
        createRL(
            tech, net, 'licon',
            ((5.695,-6.065),(5.695,-5.895),(5.865,-5.895),(5.865,-6.065),(5.695,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.865,-6.065),(-5.865,-5.895),(-5.695,-5.895),(-5.695,-6.065),(-5.865,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-15.385,-6.065),(-15.385,-5.895),(-15.215,-5.895),(-15.215,-6.065),(-15.385,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((15.555,-6.065),(15.555,-5.895),(15.725,-5.895),(15.725,-6.065),(15.555,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,4.335),(21.34,4.505),(21.51,4.505),(21.51,4.335),(21.34,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,4.675),(21.34,4.845),(21.51,4.845),(21.51,4.675),(21.34,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,4.335),(-21.51,4.505),(-21.34,4.505),(-21.34,4.335),(-21.51,4.335)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,4.675),(-21.51,4.845),(-21.34,4.845),(-21.34,4.675),(-21.51,4.675)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.525,-6.065),(-5.525,-5.895),(-5.355,-5.895),(-5.355,-6.065),(-5.525,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-5.185,-6.065),(-5.185,-5.895),(-5.015,-5.895),(-5.015,-6.065),(-5.185,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.145,-6.065),(-3.145,-5.895),(-2.975,-5.895),(-2.975,-6.065),(-3.145,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((12.155,-6.065),(12.155,-5.895),(12.325,-5.895),(12.325,-6.065),(12.155,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((12.495,-6.065),(12.495,-5.895),(12.665,-5.895),(12.665,-6.065),(12.495,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.255,-6.065),(17.255,-5.895),(17.425,-5.895),(17.425,-6.065),(17.255,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.125,5.895),(-2.125,6.065),(-1.955,6.065),(-1.955,5.895),(-2.125,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((17.595,-6.065),(17.595,-5.895),(17.765,-5.895),(17.765,-6.065),(17.595,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((2.295,5.895),(2.295,6.065),(2.465,6.065),(2.465,5.895),(2.295,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((2.635,5.895),(2.635,6.065),(2.805,6.065),(2.805,5.895),(2.635,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.765,-6.065),(-0.765,-5.895),(-0.595,-5.895),(-0.595,-6.065),(-0.765,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.425,-6.065),(-0.425,-5.895),(-0.255,-5.895),(-0.255,-6.065),(-0.425,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-0.085,-6.065),(-0.085,-5.895),(0.085,-5.895),(0.085,-6.065),(-0.085,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.255,-6.065),(0.255,-5.895),(0.425,-5.895),(0.425,-6.065),(0.255,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.595,-6.065),(0.595,-5.895),(0.765,-5.895),(0.765,-6.065),(0.595,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.055,5.895),(7.055,6.065),(7.225,6.065),(7.225,5.895),(7.055,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((7.395,5.895),(7.395,6.065),(7.565,6.065),(7.565,5.895),(7.395,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((7.735,5.895),(7.735,6.065),(7.905,6.065),(7.905,5.895),(7.735,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((17.935,5.895),(17.935,6.065),(18.105,6.065),(18.105,5.895),(17.935,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,1.955),(-21.51,2.125),(-21.34,2.125),(-21.34,1.955),(-21.51,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((14.195,-6.065),(14.195,-5.895),(14.365,-5.895),(14.365,-6.065),(14.195,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((14.535,-6.065),(14.535,-5.895),(14.705,-5.895),(14.705,-6.065),(14.535,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-1.105,5.895),(-1.105,6.065),(-0.935,6.065),(-0.935,5.895),(-1.105,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.805,5.895),(-19.805,6.065),(-19.635,6.065),(-19.635,5.895),(-19.805,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.465,5.895),(-19.465,6.065),(-19.295,6.065),(-19.295,5.895),(-19.465,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-0.425),(-21.51,-0.255),(-21.34,-0.255),(-21.34,-0.425),(-21.51,-0.425)),
        )
        createRL(
            tech, net, 'licon',
            ((21.335,5.895),(21.335,6.065),(21.505,6.065),(21.505,5.895),(21.335,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,0.255),(-21.51,0.425),(-21.34,0.425),(-21.34,0.255),(-21.51,0.255)),
        )
        createRL(
            tech, net, 'licon',
            ((19.975,-6.065),(19.975,-5.895),(20.145,-5.895),(20.145,-6.065),(19.975,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((18.955,-6.065),(18.955,-5.895),(19.125,-5.895),(19.125,-6.065),(18.955,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.665,5.895),(-12.665,6.065),(-12.495,6.065),(-12.495,5.895),(-12.665,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-12.325,5.895),(-12.325,6.065),(-12.155,6.065),(-12.155,5.895),(-12.325,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.425,5.895),(-17.425,6.065),(-17.255,6.065),(-17.255,5.895),(-17.425,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.765,5.895),(-17.765,6.065),(-17.595,6.065),(-17.595,5.895),(-17.765,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.745,5.895),(-16.745,6.065),(-16.575,6.065),(-16.575,5.895),(-16.745,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.405,5.895),(-16.405,6.065),(-16.235,6.065),(-16.235,5.895),(-16.405,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((16.235,5.895),(16.235,6.065),(16.405,6.065),(16.405,5.895),(16.235,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((16.575,5.895),(16.575,6.065),(16.745,6.065),(16.745,5.895),(16.575,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-2.805),(21.34,-2.635),(21.51,-2.635),(21.51,-2.805),(21.34,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-2.465),(21.34,-2.295),(21.51,-2.295),(21.51,-2.465),(21.34,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((20.995,5.895),(20.995,6.065),(21.165,6.065),(21.165,5.895),(20.995,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-2.805),(-21.51,-2.635),(-21.34,-2.635),(-21.34,-2.805),(-21.51,-2.805)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-2.465),(-21.51,-2.295),(-21.34,-2.295),(-21.34,-2.465),(-21.51,-2.465)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.945,5.895),(-9.945,6.065),(-9.775,6.065),(-9.775,5.895),(-9.945,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.605,5.895),(-9.605,6.065),(-9.435,6.065),(-9.435,5.895),(-9.605,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.825,-6.065),(-3.825,-5.895),(-3.655,-5.895),(-3.655,-6.065),(-3.825,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-3.485,-6.065),(-3.485,-5.895),(-3.315,-5.895),(-3.315,-6.065),(-3.485,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.585,-6.065),(-8.585,-5.895),(-8.415,-5.895),(-8.415,-6.065),(-8.585,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.245,-6.065),(-8.245,-5.895),(-8.075,-5.895),(-8.075,-6.065),(-8.245,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((3.315,-6.065),(3.315,-5.895),(3.485,-5.895),(3.485,-6.065),(3.315,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((3.655,-6.065),(3.655,-5.895),(3.825,-5.895),(3.825,-6.065),(3.655,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-8.925,-6.065),(-8.925,-5.895),(-8.755,-5.895),(-8.755,-6.065),(-8.925,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-9.265,5.895),(-9.265,6.065),(-9.095,6.065),(-9.095,5.895),(-9.265,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((6.035,5.895),(6.035,6.065),(6.205,6.065),(6.205,5.895),(6.035,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((6.375,5.895),(6.375,6.065),(6.545,6.065),(6.545,5.895),(6.375,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((8.075,5.895),(8.075,6.065),(8.245,6.065),(8.245,5.895),(8.075,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((3.995,5.895),(3.995,6.065),(4.165,6.065),(4.165,5.895),(3.995,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((8.415,5.895),(8.415,6.065),(8.585,6.065),(8.585,5.895),(8.415,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((8.755,5.895),(8.755,6.065),(8.925,6.065),(8.925,5.895),(8.755,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,0.935),(21.34,1.105),(21.51,1.105),(21.51,0.935),(21.34,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,0.595),(-21.51,0.765),(-21.34,0.765),(-21.34,0.595),(-21.51,0.595)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-1.105),(-21.51,-0.935),(-21.34,-0.935),(-21.34,-1.105),(-21.51,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,0.935),(-21.51,1.105),(-21.34,1.105),(-21.34,0.935),(-21.51,0.935)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.805,5.895),(-2.805,6.065),(-2.635,6.065),(-2.635,5.895),(-2.805,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-2.465,5.895),(-2.465,6.065),(-2.295,6.065),(-2.295,5.895),(-2.465,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,1.955),(21.34,2.125),(21.51,2.125),(21.51,1.955),(21.34,1.955)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.785,-6.065),(-18.785,-5.895),(-18.615,-5.895),(-18.615,-6.065),(-18.785,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.445,-6.065),(-18.445,-5.895),(-18.275,-5.895),(-18.275,-6.065),(-18.445,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.165,5.895),(-21.165,6.065),(-20.995,6.065),(-20.995,5.895),(-21.165,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((19.295,5.895),(19.295,6.065),(19.465,6.065),(19.465,5.895),(19.295,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((19.635,5.895),(19.635,6.065),(19.805,6.065),(19.805,5.895),(19.635,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((4.335,-6.065),(4.335,-5.895),(4.505,-5.895),(4.505,-6.065),(4.335,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((4.675,-6.065),(4.675,-5.895),(4.845,-5.895),(4.845,-6.065),(4.675,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((14.875,-6.065),(14.875,-5.895),(15.045,-5.895),(15.045,-6.065),(14.875,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-3.825),(21.34,-3.655),(21.51,-3.655),(21.51,-3.825),(21.34,-3.825)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-3.485),(21.34,-3.315),(21.51,-3.315),(21.51,-3.485),(21.34,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((17.255,5.895),(17.255,6.065),(17.425,6.065),(17.425,5.895),(17.255,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((17.595,5.895),(17.595,6.065),(17.765,6.065),(17.765,5.895),(17.595,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,3.315),(-21.51,3.485),(-21.34,3.485),(-21.34,3.315),(-21.51,3.315)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,3.655),(-21.51,3.825),(-21.34,3.825),(-21.34,3.655),(-21.51,3.655)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.965,-6.065),(-10.965,-5.895),(-10.795,-5.895),(-10.795,-6.065),(-10.965,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.625,-6.065),(-10.625,-5.895),(-10.455,-5.895),(-10.455,-6.065),(-10.625,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-10.285,-6.065),(-10.285,-5.895),(-10.115,-5.895),(-10.115,-6.065),(-10.285,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((9.095,5.895),(9.095,6.065),(9.265,6.065),(9.265,5.895),(9.095,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((9.435,5.895),(9.435,6.065),(9.605,6.065),(9.605,5.895),(9.435,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.885,5.895),(-6.885,6.065),(-6.715,6.065),(-6.715,5.895),(-6.885,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-16.065,5.895),(-16.065,6.065),(-15.895,6.065),(-15.895,5.895),(-16.065,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.545,5.895),(-6.545,6.065),(-6.375,6.065),(-6.375,5.895),(-6.545,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-6.205,5.895),(-6.205,6.065),(-6.035,6.065),(-6.035,5.895),(-6.205,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((9.775,5.895),(9.775,6.065),(9.945,6.065),(9.945,5.895),(9.775,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-17.085,5.895),(-17.085,6.065),(-16.915,6.065),(-16.915,5.895),(-17.085,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((16.915,5.895),(16.915,6.065),(17.085,6.065),(17.085,5.895),(16.915,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-0.085),(-21.51,0.085),(-21.34,0.085),(-21.34,-0.085),(-21.51,-0.085)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-4.165),(21.34,-3.995),(21.51,-3.995),(21.51,-4.165),(21.34,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-4.165),(-21.51,-3.995),(-21.34,-3.995),(-21.34,-4.165),(-21.51,-4.165)),
        )
        createRL(
            tech, net, 'licon',
            ((21.34,-1.105),(21.34,-0.935),(21.51,-0.935),(21.51,-1.105),(21.34,-1.105)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.825,-6.065),(-20.825,-5.895),(-20.655,-5.895),(-20.655,-6.065),(-20.825,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.845,5.895),(-4.845,6.065),(-4.675,6.065),(-4.675,5.895),(-4.845,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-4.505,5.895),(-4.505,6.065),(-4.335,6.065),(-4.335,5.895),(-4.505,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((-20.485,-6.065),(-20.485,-5.895),(-20.315,-5.895),(-20.315,-6.065),(-20.485,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.905,-6.065),(-7.905,-5.895),(-7.735,-5.895),(-7.735,-6.065),(-7.905,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.565,-6.065),(-7.565,-5.895),(-7.395,-5.895),(-7.395,-6.065),(-7.565,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-7.225,-6.065),(-7.225,-5.895),(-7.055,-5.895),(-7.055,-6.065),(-7.225,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.055,-6.065),(7.055,-5.895),(7.225,-5.895),(7.225,-6.065),(7.055,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((7.395,-6.065),(7.395,-5.895),(7.565,-5.895),(7.565,-6.065),(7.395,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((6.715,5.895),(6.715,6.065),(6.885,6.065),(6.885,5.895),(6.715,5.895)),
        )
        createRL(
            tech, net, 'licon',
            ((7.735,-6.065),(7.735,-5.895),(7.905,-5.895),(7.905,-6.065),(7.735,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.705,-6.065),(-14.705,-5.895),(-14.535,-5.895),(-14.535,-6.065),(-14.705,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-14.365,-6.065),(-14.365,-5.895),(-14.195,-5.895),(-14.195,-6.065),(-14.365,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.505,-6.065),(-21.505,-5.895),(-21.335,-5.895),(-21.335,-6.065),(-21.505,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((2.295,-6.065),(2.295,-5.895),(2.465,-5.895),(2.465,-6.065),(2.295,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((2.635,-6.065),(2.635,-5.895),(2.805,-5.895),(2.805,-6.065),(2.635,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((21.335,-6.065),(21.335,-5.895),(21.505,-5.895),(21.505,-6.065),(21.335,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-19.125,-6.065),(-19.125,-5.895),(-18.955,-5.895),(-18.955,-6.065),(-19.125,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-18.105,-6.065),(-18.105,-5.895),(-17.935,-5.895),(-17.935,-6.065),(-18.105,-6.065)),
        )
        createRL(
            tech, net, 'licon',
            ((-21.51,-3.485),(-21.51,-3.315),(-21.34,-3.315),(-21.34,-3.485),(-21.51,-3.485)),
        )
        createRL(
            tech, net, 'licon',
            ((17.935,-6.065),(17.935,-5.895),(18.105,-5.895),(18.105,-6.065),(17.935,-6.065)),
        )
        createRL(
            tech, net, 'li',
            ((-21.505,5.815),(-21.505,6.145),(21.505,6.145),(21.505,5.815),(-21.505,5.815)),
        )
        createRL(
            tech, net, 'li',
            ((-21.665,5.74),(-21.665,6.22),(21.665,6.22),(21.665,5.74),(-21.665,5.74)),
        )
        createRL(
            tech, net, 'li',
            ((21.34,-5.605),(21.34,5.605),(21.51,5.605),(21.51,-5.605),(21.34,-5.605)),
        )
        createRL(
            tech, net, 'li',
            ((-21.665,-6.22),(-21.665,-5.74),(21.665,-5.74),(21.665,-6.22),(-21.665,-6.22)),
        )
        createRL(
            tech, net, 'li',
            ((-21.505,-6.145),(-21.505,-5.815),(21.505,-5.815),(21.505,-6.145),(-21.505,-6.145)),
        )
        createRL(
            tech, net, 'li',
            ((-21.51,-5.605),(-21.51,5.605),(-21.34,5.605),(-21.34,-5.605),(-21.51,-5.605)),
        )
        createRL(
            tech, net, 'li',
            ((21.185,-6.22),(21.185,6.22),(21.665,6.22),(21.665,-6.22),(21.185,-6.22)),
        )
        createRL(
            tech, net, 'li',
            ((-21.665,-6.22),(-21.665,6.22),(-21.185,6.22),(-21.185,-6.22),(-21.665,-6.22)),
        )
        createRL(
            tech, net, 'nwm',
            ((-21.845,5.56),(-21.845,6.4),(21.845,6.4),(21.845,5.56),(-21.845,5.56)),
        )
        createRL(
            tech, net, 'nwm',
            ((-21.665,-6.22),(-21.665,6.22),(21.665,6.22),(21.665,-6.22),(-21.665,-6.22)),
        )
        createRL(
            tech, net, 'nwm',
            ((-21.845,-5.92),(-21.845,5.92),(-21.005,5.92),(-21.005,-5.92),(-21.845,-5.92)),
        )
        createRL(
            tech, net, 'nwm',
            ((-21.845,-6.4),(-21.845,-5.56),(21.845,-5.56),(21.845,-6.4),(-21.845,-6.4)),
        )
        createRL(
            tech, net, 'nwm',
            ((21.005,-5.92),(21.005,5.92),(21.845,5.92),(21.845,-5.92),(21.005,-5.92)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-21.79,5.615),(-21.79,6.345),(21.79,6.345),(21.79,5.615),(-21.79,5.615)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-21.79,-5.865),(-21.79,5.865),(-21.06,5.865),(-21.06,-5.865),(-21.79,-5.865)),
        )
        createRL(
            tech, net, 'nsdm',
            ((21.06,-5.865),(21.06,5.865),(21.79,5.865),(21.79,-5.865),(21.06,-5.865)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-21.79,-6.345),(-21.79,-5.615),(21.79,-5.615),(21.79,-6.345),(-21.79,-6.345)),
        )
        createRL(
            tech, net, 'psdm',
            ((-21.06,-5.615),(-21.06,5.615),(21.06,5.615),(21.06,-5.615),(-21.06,-5.615)),
        )
        nets['conn'].setDirection(Net.Direction.IN)

    cell = new_cells['RCClampInverter']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90.0), u(43.64),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'bulk': Net.create(cell, 'bulk'),
            'ground': Net.create(cell, 'ground'),
            'in': Net.create(cell, 'in'),
            'out': Net.create(cell, 'out'),
            'supply': Net.create(cell, 'supply'),
        }
        net = nets['ground']
        createRL(
            tech, net, 'difftap',
            ((37.02,7.0),(37.02,21.0),(37.27,21.0),(37.27,7.0),(37.02,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.27,7.0),(37.27,21.0),(47.27,21.0),(47.27,7.0),(37.27,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.01,7.0),(72.01,21.0),(72.51,21.0),(72.51,7.0),(72.01,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.67,7.0),(69.67,21.0),(70.17,21.0),(70.17,7.0),(69.67,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.11,7.0),(68.11,21.0),(68.61,21.0),(68.61,7.0),(68.11,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.51,7.0),(72.51,21.0),(72.76,21.0),(72.76,7.0),(72.51,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.54,7.0),(72.54,21.0),(72.79,21.0),(72.79,7.0),(72.54,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.83,7.0),(67.83,21.0),(68.08,21.0),(68.08,7.0),(67.83,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.005,7.0),(37.005,21.0),(37.255,21.0),(37.255,7.0),(37.005,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.98,7.0),(70.98,21.0),(71.23,21.0),(71.23,7.0),(70.98,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.95,7.0),(70.95,21.0),(71.2,21.0),(71.2,7.0),(70.95,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.285,7.0),(47.285,21.0),(47.535,21.0),(47.535,7.0),(47.285,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.525,7.0),(72.525,21.0),(72.775,21.0),(72.775,7.0),(72.525,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.965,7.0),(70.965,21.0),(71.215,21.0),(71.215,7.0),(70.965,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.565,7.0),(57.565,21.0),(57.815,21.0),(57.815,7.0),(57.565,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.74,7.0),(26.74,21.0),(26.99,21.0),(26.99,7.0),(26.74,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((72.79,7.0),(72.79,21.0),(73.29,21.0),(73.29,7.0),(72.79,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.445,7.0),(16.445,21.0),(16.695,21.0),(16.695,7.0),(16.445,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.39,7.0),(69.39,21.0),(69.64,21.0),(69.64,7.0),(69.39,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.89,7.0),(68.89,21.0),(69.39,21.0),(69.39,7.0),(68.89,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.83,7.0),(57.83,21.0),(67.83,21.0),(67.83,7.0),(57.83,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.23,7.0),(71.23,21.0),(71.73,21.0),(71.73,7.0),(71.23,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.845,7.0),(67.845,21.0),(68.095,21.0),(68.095,7.0),(67.845,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.99,7.0),(36.99,21.0),(37.24,21.0),(37.24,7.0),(36.99,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.45,7.0),(70.45,21.0),(70.95,21.0),(70.95,7.0),(70.45,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.405,7.0),(69.405,21.0),(69.655,21.0),(69.655,7.0),(69.405,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.27,7.0),(47.27,21.0),(47.52,21.0),(47.52,7.0),(47.27,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((69.42,7.0),(69.42,21.0),(69.67,21.0),(69.67,7.0),(69.42,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.71,7.0),(16.71,21.0),(26.71,21.0),(26.71,7.0),(16.71,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((67.86,7.0),(67.86,21.0),(68.11,21.0),(68.11,7.0),(67.86,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.55,7.0),(57.55,21.0),(57.8,21.0),(57.8,7.0),(57.55,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.725,7.0),(26.725,21.0),(26.975,21.0),(26.975,7.0),(26.725,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.71,7.0),(26.71,21.0),(26.96,21.0),(26.96,7.0),(26.71,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.58,7.0),(57.58,21.0),(57.83,21.0),(57.83,7.0),(57.58,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((16.46,7.0),(16.46,21.0),(16.71,21.0),(16.71,7.0),(16.46,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.55,7.0),(47.55,21.0),(57.55,21.0),(57.55,7.0),(47.55,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.99,7.0),(26.99,21.0),(36.99,21.0),(36.99,7.0),(26.99,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.3,7.0),(47.3,21.0),(47.55,21.0),(47.55,7.0),(47.3,7.0)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,8.305),(16.485,8.475),(16.655,8.475),(16.655,8.305),(16.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,8.645),(16.485,8.815),(16.655,8.815),(16.655,8.645),(16.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,7.965),(69.445,8.135),(69.615,8.135),(69.615,7.965),(69.445,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,11.025),(37.045,11.195),(37.215,11.195),(37.215,11.025),(37.045,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,11.365),(37.045,11.535),(37.215,11.535),(37.215,11.365),(37.045,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,11.705),(37.045,11.875),(37.215,11.875),(37.215,11.705),(37.045,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,20.205),(47.325,20.375),(47.495,20.375),(47.495,20.205),(47.325,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,20.545),(47.325,20.715),(47.495,20.715),(47.495,20.545),(47.325,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,15.105),(69.445,15.275),(69.615,15.275),(69.615,15.105),(69.445,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,15.445),(69.445,15.615),(69.615,15.615),(69.615,15.445),(69.445,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,15.785),(69.445,15.955),(69.615,15.955),(69.615,15.785),(69.445,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,14.085),(69.445,14.255),(69.615,14.255),(69.615,14.085),(69.445,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,14.425),(69.445,14.595),(69.615,14.595),(69.615,14.425),(69.445,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,14.765),(69.445,14.935),(69.615,14.935),(69.615,14.765),(69.445,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,11.705),(67.885,11.875),(68.055,11.875),(68.055,11.705),(67.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,11.365),(67.885,11.535),(68.055,11.535),(68.055,11.365),(67.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,11.025),(67.885,11.195),(68.055,11.195),(68.055,11.025),(67.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,7.965),(37.045,8.135),(37.215,8.135),(37.215,7.965),(37.045,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,16.125),(16.485,16.295),(16.655,16.295),(16.655,16.125),(16.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,16.465),(16.485,16.635),(16.655,16.635),(16.655,16.465),(16.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,16.805),(16.485,16.975),(16.655,16.975),(16.655,16.805),(16.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,16.465),(71.005,16.635),(71.175,16.635),(71.175,16.465),(71.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,16.805),(71.005,16.975),(71.175,16.975),(71.175,16.805),(71.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,16.125),(71.005,16.295),(71.175,16.295),(71.175,16.125),(71.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,8.985),(71.005,9.155),(71.175,9.155),(71.175,8.985),(71.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,16.125),(72.565,16.295),(72.735,16.295),(72.735,16.125),(72.565,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,16.465),(72.565,16.635),(72.735,16.635),(72.735,16.465),(72.565,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,15.445),(37.045,15.615),(37.215,15.615),(37.215,15.445),(37.045,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,15.785),(37.045,15.955),(37.215,15.955),(37.215,15.785),(37.045,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,15.105),(37.045,15.275),(37.215,15.275),(37.215,15.105),(37.045,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,16.805),(72.565,16.975),(72.735,16.975),(72.735,16.805),(72.565,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,20.205),(71.005,20.375),(71.175,20.375),(71.175,20.205),(71.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,20.545),(71.005,20.715),(71.175,20.715),(71.175,20.545),(71.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,10.345),(72.565,10.515),(72.735,10.515),(72.735,10.345),(72.565,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,10.685),(72.565,10.855),(72.735,10.855),(72.735,10.685),(72.565,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,10.005),(72.565,10.175),(72.735,10.175),(72.735,10.005),(72.565,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,7.625),(26.765,7.795),(26.935,7.795),(26.935,7.625),(26.765,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,7.285),(26.765,7.455),(26.935,7.455),(26.935,7.285),(26.765,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,18.165),(69.445,18.335),(69.615,18.335),(69.615,18.165),(69.445,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,18.505),(69.445,18.675),(69.615,18.675),(69.615,18.505),(69.445,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,19.185),(16.485,19.355),(16.655,19.355),(16.655,19.185),(16.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,19.525),(16.485,19.695),(16.655,19.695),(16.655,19.525),(16.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,20.205),(37.045,20.375),(37.215,20.375),(37.215,20.205),(37.045,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,20.545),(37.045,20.715),(37.215,20.715),(37.215,20.545),(37.045,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,17.145),(26.765,17.315),(26.935,17.315),(26.935,17.145),(26.765,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,17.485),(26.765,17.655),(26.935,17.655),(26.935,17.485),(26.765,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,17.825),(26.765,17.995),(26.935,17.995),(26.935,17.825),(26.765,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,9.325),(69.445,9.495),(69.615,9.495),(69.615,9.325),(69.445,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,9.665),(69.445,9.835),(69.615,9.835),(69.615,9.665),(69.445,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,8.985),(37.045,9.155),(37.215,9.155),(37.215,8.985),(37.045,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,10.685),(37.045,10.855),(37.215,10.855),(37.215,10.685),(37.045,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,10.345),(37.045,10.515),(37.215,10.515),(37.215,10.345),(37.045,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,10.005),(37.045,10.175),(37.215,10.175),(37.215,10.005),(37.045,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,12.045),(69.445,12.215),(69.615,12.215),(69.615,12.045),(69.445,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,12.385),(69.445,12.555),(69.615,12.555),(69.615,12.385),(69.445,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,12.725),(69.445,12.895),(69.615,12.895),(69.615,12.725),(69.445,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,13.065),(67.885,13.235),(68.055,13.235),(68.055,13.065),(67.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,13.405),(16.485,13.575),(16.655,13.575),(16.655,13.405),(16.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,13.065),(16.485,13.235),(16.655,13.235),(16.655,13.065),(16.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,13.405),(67.885,13.575),(68.055,13.575),(68.055,13.405),(67.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,13.745),(67.885,13.915),(68.055,13.915),(68.055,13.745),(67.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,13.745),(16.485,13.915),(16.655,13.915),(16.655,13.745),(16.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,20.545),(67.885,20.715),(68.055,20.715),(68.055,20.545),(67.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,8.985),(16.485,9.155),(16.655,9.155),(16.655,8.985),(16.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,20.205),(67.885,20.375),(68.055,20.375),(68.055,20.205),(67.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,14.425),(47.325,14.595),(47.495,14.595),(47.495,14.425),(47.325,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,14.765),(47.325,14.935),(47.495,14.935),(47.495,14.765),(47.325,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,14.085),(47.325,14.255),(47.495,14.255),(47.495,14.085),(47.325,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,18.165),(16.485,18.335),(16.655,18.335),(16.655,18.165),(16.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,18.505),(16.485,18.675),(16.655,18.675),(16.655,18.505),(16.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,16.465),(69.445,16.635),(69.615,16.635),(69.615,16.465),(69.445,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,16.805),(69.445,16.975),(69.615,16.975),(69.615,16.805),(69.445,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,16.125),(69.445,16.295),(69.615,16.295),(69.615,16.125),(69.445,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,12.045),(47.325,12.215),(47.495,12.215),(47.495,12.045),(47.325,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,12.385),(47.325,12.555),(47.495,12.555),(47.495,12.385),(47.325,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,12.725),(47.325,12.895),(47.495,12.895),(47.495,12.725),(47.325,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,10.005),(57.605,10.175),(57.775,10.175),(57.775,10.005),(57.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,10.345),(57.605,10.515),(57.775,10.515),(57.775,10.345),(57.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,10.685),(57.605,10.855),(57.775,10.855),(57.775,10.685),(57.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,10.005),(71.005,10.175),(71.175,10.175),(71.175,10.005),(71.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,10.345),(71.005,10.515),(71.175,10.515),(71.175,10.345),(71.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,10.685),(71.005,10.855),(71.175,10.855),(71.175,10.685),(71.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,9.325),(72.565,9.495),(72.735,9.495),(72.735,9.325),(72.565,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,9.665),(72.565,9.835),(72.735,9.835),(72.735,9.665),(72.565,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,17.145),(69.445,17.315),(69.615,17.315),(69.615,17.145),(69.445,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,17.485),(69.445,17.655),(69.615,17.655),(69.615,17.485),(69.445,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,17.825),(69.445,17.995),(69.615,17.995),(69.615,17.825),(69.445,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,9.325),(71.005,9.495),(71.175,9.495),(71.175,9.325),(71.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,9.665),(71.005,9.835),(71.175,9.835),(71.175,9.665),(71.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,9.325),(26.765,9.495),(26.935,9.495),(26.935,9.325),(26.765,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,9.665),(26.765,9.835),(26.935,9.835),(26.935,9.665),(26.765,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,18.505),(26.765,18.675),(26.935,18.675),(26.935,18.505),(26.765,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,18.165),(26.765,18.335),(26.935,18.335),(26.935,18.165),(26.765,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,15.105),(72.565,15.275),(72.735,15.275),(72.735,15.105),(72.565,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,15.785),(72.565,15.955),(72.735,15.955),(72.735,15.785),(72.565,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,15.445),(72.565,15.615),(72.735,15.615),(72.735,15.445),(72.565,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,11.025),(26.765,11.195),(26.935,11.195),(26.935,11.025),(26.765,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,11.365),(26.765,11.535),(26.935,11.535),(26.935,11.365),(26.765,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,11.705),(26.765,11.875),(26.935,11.875),(26.935,11.705),(26.765,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,12.045),(16.485,12.215),(16.655,12.215),(16.655,12.045),(16.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,12.385),(16.485,12.555),(16.655,12.555),(16.655,12.385),(16.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,12.725),(16.485,12.895),(16.655,12.895),(16.655,12.725),(16.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,18.845),(69.445,19.015),(69.615,19.015),(69.615,18.845),(69.445,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,13.405),(71.005,13.575),(71.175,13.575),(71.175,13.405),(71.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,13.065),(71.005,13.235),(71.175,13.235),(71.175,13.065),(71.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,13.745),(71.005,13.915),(71.175,13.915),(71.175,13.745),(71.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,12.045),(71.005,12.215),(71.175,12.215),(71.175,12.045),(71.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,12.385),(71.005,12.555),(71.175,12.555),(71.175,12.385),(71.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,12.725),(71.005,12.895),(71.175,12.895),(71.175,12.725),(71.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,16.125),(47.325,16.295),(47.495,16.295),(47.495,16.125),(47.325,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,16.465),(47.325,16.635),(47.495,16.635),(47.495,16.465),(47.325,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,16.805),(47.325,16.975),(47.495,16.975),(47.495,16.805),(47.325,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,7.965),(71.005,8.135),(71.175,8.135),(71.175,7.965),(71.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,7.965),(47.325,8.135),(47.495,8.135),(47.495,7.965),(47.325,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,11.025),(47.325,11.195),(47.495,11.195),(47.495,11.025),(47.325,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,11.365),(47.325,11.535),(47.495,11.535),(47.495,11.365),(47.325,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,11.705),(47.325,11.875),(47.495,11.875),(47.495,11.705),(47.325,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,19.865),(67.885,20.035),(68.055,20.035),(68.055,19.865),(67.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,8.305),(72.565,8.475),(72.735,8.475),(72.735,8.305),(72.565,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,8.645),(72.565,8.815),(72.735,8.815),(72.735,8.645),(72.565,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,11.705),(72.565,11.875),(72.735,11.875),(72.735,11.705),(72.565,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,11.365),(72.565,11.535),(72.735,11.535),(72.735,11.365),(72.565,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,11.025),(72.565,11.195),(72.735,11.195),(72.735,11.025),(72.565,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,15.105),(26.765,15.275),(26.935,15.275),(26.935,15.105),(26.765,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,15.445),(26.765,15.615),(26.935,15.615),(26.935,15.445),(26.765,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,15.785),(26.765,15.955),(26.935,15.955),(26.935,15.785),(26.765,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,12.045),(37.045,12.215),(37.215,12.215),(37.215,12.045),(37.045,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,12.385),(37.045,12.555),(37.215,12.555),(37.215,12.385),(37.045,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,12.725),(37.045,12.895),(37.215,12.895),(37.215,12.725),(37.045,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,14.085),(72.565,14.255),(72.735,14.255),(72.735,14.085),(72.565,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,14.765),(72.565,14.935),(72.735,14.935),(72.735,14.765),(72.565,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,14.425),(72.565,14.595),(72.735,14.595),(72.735,14.425),(72.565,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,18.845),(16.485,19.015),(16.655,19.015),(16.655,18.845),(16.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,17.145),(71.005,17.315),(71.175,17.315),(71.175,17.145),(71.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,17.485),(71.005,17.655),(71.175,17.655),(71.175,17.485),(71.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,17.825),(71.005,17.995),(71.175,17.995),(71.175,17.825),(71.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,16.125),(37.045,16.295),(37.215,16.295),(37.215,16.125),(37.045,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,16.465),(37.045,16.635),(37.215,16.635),(37.215,16.465),(37.045,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,16.805),(37.045,16.975),(37.215,16.975),(37.215,16.805),(37.045,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,17.145),(57.605,17.315),(57.775,17.315),(57.775,17.145),(57.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,17.485),(57.605,17.655),(57.775,17.655),(57.775,17.485),(57.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,17.825),(57.605,17.995),(57.775,17.995),(57.775,17.825),(57.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,19.525),(69.445,19.695),(69.615,19.695),(69.615,19.525),(69.445,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,19.185),(69.445,19.355),(69.615,19.355),(69.615,19.185),(69.445,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,18.845),(26.765,19.015),(26.935,19.015),(26.935,18.845),(26.765,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,12.045),(26.765,12.215),(26.935,12.215),(26.935,12.045),(26.765,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,12.385),(26.765,12.555),(26.935,12.555),(26.935,12.385),(26.765,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,12.725),(26.765,12.895),(26.935,12.895),(26.935,12.725),(26.765,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,18.505),(57.605,18.675),(57.775,18.675),(57.775,18.505),(57.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,18.165),(57.605,18.335),(57.775,18.335),(57.775,18.165),(57.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,13.745),(57.605,13.915),(57.775,13.915),(57.775,13.745),(57.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,13.065),(57.605,13.235),(57.775,13.235),(57.775,13.065),(57.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,13.405),(57.605,13.575),(57.775,13.575),(57.775,13.405),(57.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,14.765),(26.765,14.935),(26.935,14.935),(26.935,14.765),(26.765,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,14.425),(26.765,14.595),(26.935,14.595),(26.935,14.425),(26.765,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,14.085),(26.765,14.255),(26.935,14.255),(26.935,14.085),(26.765,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,19.185),(37.045,19.355),(37.215,19.355),(37.215,19.185),(37.045,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,19.525),(37.045,19.695),(37.215,19.695),(37.215,19.525),(37.045,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,14.425),(57.605,14.595),(57.775,14.595),(57.775,14.425),(57.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,14.765),(57.605,14.935),(57.775,14.935),(57.775,14.765),(57.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,14.085),(57.605,14.255),(57.775,14.255),(57.775,14.085),(57.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,20.205),(57.605,20.375),(57.775,20.375),(57.775,20.205),(57.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,20.545),(57.605,20.715),(57.775,20.715),(57.775,20.545),(57.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,10.005),(16.485,10.175),(16.655,10.175),(16.655,10.005),(16.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,10.345),(16.485,10.515),(16.655,10.515),(16.655,10.345),(16.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,10.685),(16.485,10.855),(16.655,10.855),(16.655,10.685),(16.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,7.285),(71.005,7.455),(71.175,7.455),(71.175,7.285),(71.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,7.625),(71.005,7.795),(71.175,7.795),(71.175,7.625),(71.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,9.665),(37.045,9.835),(37.215,9.835),(37.215,9.665),(37.045,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,7.285),(67.885,7.455),(68.055,7.455),(68.055,7.285),(67.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,7.625),(67.885,7.795),(68.055,7.795),(68.055,7.625),(67.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,9.325),(37.045,9.495),(37.215,9.495),(37.215,9.325),(37.045,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,7.285),(47.325,7.455),(47.495,7.455),(47.495,7.285),(47.325,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,7.625),(47.325,7.795),(47.495,7.795),(47.495,7.625),(47.325,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,13.745),(72.565,13.915),(72.735,13.915),(72.735,13.745),(72.565,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,13.405),(72.565,13.575),(72.735,13.575),(72.735,13.405),(72.565,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,13.065),(72.565,13.235),(72.735,13.235),(72.735,13.065),(72.565,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,8.985),(72.565,9.155),(72.735,9.155),(72.735,8.985),(72.565,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,18.165),(72.565,18.335),(72.735,18.335),(72.735,18.165),(72.565,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,18.505),(72.565,18.675),(72.735,18.675),(72.735,18.505),(72.565,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,9.665),(57.605,9.835),(57.775,9.835),(57.775,9.665),(57.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,9.325),(57.605,9.495),(57.775,9.495),(57.775,9.325),(57.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,7.285),(69.445,7.455),(69.615,7.455),(69.615,7.285),(69.445,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,7.625),(69.445,7.795),(69.615,7.795),(69.615,7.625),(69.445,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,14.425),(67.885,14.595),(68.055,14.595),(68.055,14.425),(67.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,14.765),(67.885,14.935),(68.055,14.935),(68.055,14.765),(67.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,14.085),(67.885,14.255),(68.055,14.255),(68.055,14.085),(67.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,13.745),(69.445,13.915),(69.615,13.915),(69.615,13.745),(69.445,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,13.065),(69.445,13.235),(69.615,13.235),(69.615,13.065),(69.445,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,13.405),(69.445,13.575),(69.615,13.575),(69.615,13.405),(69.445,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,18.845),(67.885,19.015),(68.055,19.015),(68.055,18.845),(67.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,14.765),(37.045,14.935),(37.215,14.935),(37.215,14.765),(37.045,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,14.425),(37.045,14.595),(37.215,14.595),(37.215,14.425),(37.045,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,14.085),(37.045,14.255),(37.215,14.255),(37.215,14.085),(37.045,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,19.865),(72.565,20.035),(72.735,20.035),(72.735,19.865),(72.565,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,11.705),(71.005,11.875),(71.175,11.875),(71.175,11.705),(71.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,11.025),(71.005,11.195),(71.175,11.195),(71.175,11.025),(71.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,11.365),(71.005,11.535),(71.175,11.535),(71.175,11.365),(71.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,7.285),(37.045,7.455),(37.215,7.455),(37.215,7.285),(37.045,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,7.625),(37.045,7.795),(37.215,7.795),(37.215,7.625),(37.045,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,9.325),(67.885,9.495),(68.055,9.495),(68.055,9.325),(67.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,9.665),(67.885,9.835),(68.055,9.835),(68.055,9.665),(67.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,16.125),(26.765,16.295),(26.935,16.295),(26.935,16.125),(26.765,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,16.465),(26.765,16.635),(26.935,16.635),(26.935,16.465),(26.765,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,16.805),(26.765,16.975),(26.935,16.975),(26.935,16.805),(26.765,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,16.125),(57.605,16.295),(57.775,16.295),(57.775,16.125),(57.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,16.465),(57.605,16.635),(57.775,16.635),(57.775,16.465),(57.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,16.805),(57.605,16.975),(57.775,16.975),(57.775,16.805),(57.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,17.145),(37.045,17.315),(37.215,17.315),(37.215,17.145),(37.045,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,17.485),(37.045,17.655),(37.215,17.655),(37.215,17.485),(37.045,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,17.825),(37.045,17.995),(37.215,17.995),(37.215,17.825),(37.045,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,19.865),(69.445,20.035),(69.615,20.035),(69.615,19.865),(69.445,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,7.965),(57.605,8.135),(57.775,8.135),(57.775,7.965),(57.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,14.765),(71.005,14.935),(71.175,14.935),(71.175,14.765),(71.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,14.425),(71.005,14.595),(71.175,14.595),(71.175,14.425),(71.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,14.085),(71.005,14.255),(71.175,14.255),(71.175,14.085),(71.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,12.725),(72.565,12.895),(72.735,12.895),(72.735,12.725),(72.565,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,12.385),(72.565,12.555),(72.735,12.555),(72.735,12.385),(72.565,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,12.045),(72.565,12.215),(72.735,12.215),(72.735,12.045),(72.565,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,18.165),(47.325,18.335),(47.495,18.335),(47.495,18.165),(47.325,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,18.505),(47.325,18.675),(47.495,18.675),(47.495,18.505),(47.325,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,18.845),(57.605,19.015),(57.775,19.015),(57.775,18.845),(57.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,19.865),(37.045,20.035),(37.215,20.035),(37.215,19.865),(37.045,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,18.505),(37.045,18.675),(37.215,18.675),(37.215,18.505),(37.045,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,18.165),(37.045,18.335),(37.215,18.335),(37.215,18.165),(37.045,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,19.185),(57.605,19.355),(57.775,19.355),(57.775,19.185),(57.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,19.525),(57.605,19.695),(57.775,19.695),(57.775,19.525),(57.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,17.485),(16.485,17.655),(16.655,17.655),(16.655,17.485),(16.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,17.145),(16.485,17.315),(16.655,17.315),(16.655,17.145),(16.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,17.825),(16.485,17.995),(16.655,17.995),(16.655,17.825),(16.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,15.105),(16.485,15.275),(16.655,15.275),(16.655,15.105),(16.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,15.445),(16.485,15.615),(16.655,15.615),(16.655,15.445),(16.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,15.785),(16.485,15.955),(16.655,15.955),(16.655,15.785),(16.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,17.485),(72.565,17.655),(72.735,17.655),(72.735,17.485),(72.565,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,17.825),(72.565,17.995),(72.735,17.995),(72.735,17.825),(72.565,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,7.965),(67.885,8.135),(68.055,8.135),(68.055,7.965),(67.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,17.145),(72.565,17.315),(72.735,17.315),(72.735,17.145),(72.565,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,8.985),(67.885,9.155),(68.055,9.155),(68.055,8.985),(67.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,8.645),(57.605,8.815),(57.775,8.815),(57.775,8.645),(57.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,8.305),(57.605,8.475),(57.775,8.475),(57.775,8.305),(57.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,17.145),(67.885,17.315),(68.055,17.315),(68.055,17.145),(67.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,17.485),(67.885,17.655),(68.055,17.655),(68.055,17.485),(67.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,17.825),(67.885,17.995),(68.055,17.995),(68.055,17.825),(67.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,10.005),(69.445,10.175),(69.615,10.175),(69.615,10.005),(69.445,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,10.345),(69.445,10.515),(69.615,10.515),(69.615,10.345),(69.445,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,10.685),(69.445,10.855),(69.615,10.855),(69.615,10.685),(69.445,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,20.205),(26.765,20.375),(26.935,20.375),(26.935,20.205),(26.765,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,20.545),(26.765,20.715),(26.935,20.715),(26.935,20.545),(26.765,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,15.105),(67.885,15.275),(68.055,15.275),(68.055,15.105),(67.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,15.445),(67.885,15.615),(68.055,15.615),(68.055,15.445),(67.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,15.785),(67.885,15.955),(68.055,15.955),(68.055,15.785),(67.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,18.845),(72.565,19.015),(72.735,19.015),(72.735,18.845),(72.565,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,20.205),(16.485,20.375),(16.655,20.375),(16.655,20.205),(16.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,20.545),(16.485,20.715),(16.655,20.715),(16.655,20.545),(16.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,9.325),(47.325,9.495),(47.495,9.495),(47.495,9.325),(47.325,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,9.665),(47.325,9.835),(47.495,9.835),(47.495,9.665),(47.325,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,8.305),(26.765,8.475),(26.935,8.475),(26.935,8.305),(26.765,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,8.645),(26.765,8.815),(26.935,8.815),(26.935,8.645),(26.765,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,18.165),(71.005,18.335),(71.175,18.335),(71.175,18.165),(71.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,18.505),(71.005,18.675),(71.175,18.675),(71.175,18.505),(71.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,10.005),(26.765,10.175),(26.935,10.175),(26.935,10.005),(26.765,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,10.345),(26.765,10.515),(26.935,10.515),(26.935,10.345),(26.765,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,10.685),(26.765,10.855),(26.935,10.855),(26.935,10.685),(26.765,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,7.625),(72.565,7.795),(72.735,7.795),(72.735,7.625),(72.565,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,7.285),(72.565,7.455),(72.735,7.455),(72.735,7.285),(72.565,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,18.165),(67.885,18.335),(68.055,18.335),(68.055,18.165),(67.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,18.505),(67.885,18.675),(68.055,18.675),(68.055,18.505),(67.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,11.025),(16.485,11.195),(16.655,11.195),(16.655,11.025),(16.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,11.365),(16.485,11.535),(16.655,11.535),(16.655,11.365),(16.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,11.705),(16.485,11.875),(16.655,11.875),(16.655,11.705),(16.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,11.025),(57.605,11.195),(57.775,11.195),(57.775,11.025),(57.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,11.365),(57.605,11.535),(57.775,11.535),(57.775,11.365),(57.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,11.705),(57.605,11.875),(57.775,11.875),(57.775,11.705),(57.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,15.105),(47.325,15.275),(47.495,15.275),(47.495,15.105),(47.325,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,15.445),(47.325,15.615),(47.495,15.615),(47.495,15.445),(47.325,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,15.785),(47.325,15.955),(47.495,15.955),(47.495,15.785),(47.325,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,19.185),(72.565,19.355),(72.735,19.355),(72.735,19.185),(72.565,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,19.525),(72.565,19.695),(72.735,19.695),(72.735,19.525),(72.565,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,19.185),(71.005,19.355),(71.175,19.355),(71.175,19.185),(71.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,19.525),(71.005,19.695),(71.175,19.695),(71.175,19.525),(71.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,14.425),(16.485,14.595),(16.655,14.595),(16.655,14.425),(16.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,14.765),(16.485,14.935),(16.655,14.935),(16.655,14.765),(16.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,14.085),(16.485,14.255),(16.655,14.255),(16.655,14.085),(16.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,13.405),(47.325,13.575),(47.495,13.575),(47.495,13.405),(47.325,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,13.065),(47.325,13.235),(47.495,13.235),(47.495,13.065),(47.325,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,13.745),(47.325,13.915),(47.495,13.915),(47.495,13.745),(47.325,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,7.625),(57.605,7.795),(57.775,7.795),(57.775,7.625),(57.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,7.285),(57.605,7.455),(57.775,7.455),(57.775,7.285),(57.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,18.845),(47.325,19.015),(47.495,19.015),(47.495,18.845),(47.325,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,12.045),(67.885,12.215),(68.055,12.215),(68.055,12.045),(67.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,12.385),(67.885,12.555),(68.055,12.555),(68.055,12.385),(67.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,12.725),(67.885,12.895),(68.055,12.895),(68.055,12.725),(67.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,18.845),(37.045,19.015),(37.215,19.015),(37.215,18.845),(37.045,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,8.305),(69.445,8.475),(69.615,8.475),(69.615,8.305),(69.445,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,8.645),(69.445,8.815),(69.615,8.815),(69.615,8.645),(69.445,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,19.865),(57.605,20.035),(57.775,20.035),(57.775,19.865),(57.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,19.185),(47.325,19.355),(47.495,19.355),(47.495,19.185),(47.325,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,19.525),(47.325,19.695),(47.495,19.695),(47.495,19.525),(47.325,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,10.685),(47.325,10.855),(47.495,10.855),(47.495,10.685),(47.325,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,10.005),(47.325,10.175),(47.495,10.175),(47.495,10.005),(47.325,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,10.345),(47.325,10.515),(47.495,10.515),(47.495,10.345),(47.325,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,8.305),(67.885,8.475),(68.055,8.475),(68.055,8.305),(67.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,8.645),(67.885,8.815),(68.055,8.815),(68.055,8.645),(67.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,8.305),(47.325,8.475),(47.495,8.475),(47.495,8.305),(47.325,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,8.645),(47.325,8.815),(47.495,8.815),(47.495,8.645),(47.325,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,19.525),(26.765,19.695),(26.935,19.695),(26.935,19.525),(26.765,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,19.185),(26.765,19.355),(26.935,19.355),(26.935,19.185),(26.765,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,8.985),(57.605,9.155),(57.775,9.155),(57.775,8.985),(57.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,7.285),(16.485,7.455),(16.655,7.455),(16.655,7.285),(16.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,7.625),(16.485,7.795),(16.655,7.795),(16.655,7.625),(16.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,19.185),(67.885,19.355),(68.055,19.355),(68.055,19.185),(67.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,19.525),(67.885,19.695),(68.055,19.695),(68.055,19.525),(67.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,17.145),(47.325,17.315),(47.495,17.315),(47.495,17.145),(47.325,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,17.485),(47.325,17.655),(47.495,17.655),(47.495,17.485),(47.325,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,17.825),(47.325,17.995),(47.495,17.995),(47.495,17.825),(47.325,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,8.985),(26.765,9.155),(26.935,9.155),(26.935,8.985),(26.765,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,18.845),(71.005,19.015),(71.175,19.015),(71.175,18.845),(71.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,7.965),(72.565,8.135),(72.735,8.135),(72.735,7.965),(72.565,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,13.405),(37.045,13.575),(37.215,13.575),(37.215,13.405),(37.045,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,13.065),(37.045,13.235),(37.215,13.235),(37.215,13.065),(37.045,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,13.745),(37.045,13.915),(37.215,13.915),(37.215,13.745),(37.045,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,19.865),(71.005,20.035),(71.175,20.035),(71.175,19.865),(71.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,9.325),(16.485,9.495),(16.655,9.495),(16.655,9.325),(16.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,9.665),(16.485,9.835),(16.655,9.835),(16.655,9.665),(16.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,8.305),(71.005,8.475),(71.175,8.475),(71.175,8.305),(71.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,8.645),(71.005,8.815),(71.175,8.815),(71.175,8.645),(71.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,16.125),(67.885,16.295),(68.055,16.295),(68.055,16.125),(67.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,16.465),(67.885,16.635),(68.055,16.635),(68.055,16.465),(67.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,16.805),(67.885,16.975),(68.055,16.975),(68.055,16.805),(67.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,12.385),(57.605,12.555),(57.775,12.555),(57.775,12.385),(57.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,12.725),(57.605,12.895),(57.775,12.895),(57.775,12.725),(57.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,12.045),(57.605,12.215),(57.775,12.215),(57.775,12.045),(57.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,10.345),(67.885,10.515),(68.055,10.515),(68.055,10.345),(67.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,10.005),(67.885,10.175),(68.055,10.175),(68.055,10.005),(67.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((67.885,10.685),(67.885,10.855),(68.055,10.855),(68.055,10.685),(67.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,20.545),(69.445,20.715),(69.615,20.715),(69.615,20.545),(69.445,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,20.205),(69.445,20.375),(69.615,20.375),(69.615,20.205),(69.445,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,7.965),(26.765,8.135),(26.935,8.135),(26.935,7.965),(26.765,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,8.985),(69.445,9.155),(69.615,9.155),(69.615,8.985),(69.445,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,19.865),(16.485,20.035),(16.655,20.035),(16.655,19.865),(16.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,19.865),(47.325,20.035),(47.495,20.035),(47.495,19.865),(47.325,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,15.445),(71.005,15.615),(71.175,15.615),(71.175,15.445),(71.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,15.785),(71.005,15.955),(71.175,15.955),(71.175,15.785),(71.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.005,15.105),(71.005,15.275),(71.175,15.275),(71.175,15.105),(71.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,8.305),(37.045,8.475),(37.215,8.475),(37.215,8.305),(37.045,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.045,8.645),(37.045,8.815),(37.215,8.815),(37.215,8.645),(37.045,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,20.205),(72.565,20.375),(72.735,20.375),(72.735,20.205),(72.565,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((72.565,20.545),(72.565,20.715),(72.735,20.715),(72.735,20.545),(72.565,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,13.065),(26.765,13.235),(26.935,13.235),(26.935,13.065),(26.765,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,13.405),(26.765,13.575),(26.935,13.575),(26.935,13.405),(26.765,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,13.745),(26.765,13.915),(26.935,13.915),(26.935,13.745),(26.765,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.325,8.985),(47.325,9.155),(47.495,9.155),(47.495,8.985),(47.325,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.765,19.865),(26.765,20.035),(26.935,20.035),(26.935,19.865),(26.765,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,15.785),(57.605,15.955),(57.775,15.955),(57.775,15.785),(57.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,15.105),(57.605,15.275),(57.775,15.275),(57.775,15.105),(57.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.605,15.445),(57.605,15.615),(57.775,15.615),(57.775,15.445),(57.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.485,7.965),(16.485,8.135),(16.655,8.135),(16.655,7.965),(16.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,11.025),(69.445,11.195),(69.615,11.195),(69.615,11.025),(69.445,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,11.365),(69.445,11.535),(69.615,11.535),(69.615,11.365),(69.445,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((69.445,11.705),(69.445,11.875),(69.615,11.875),(69.615,11.705),(69.445,11.705)),
        )
        createRL(
            tech, net, 'li',
            ((26.765,7.205),(26.765,23.92),(26.935,23.92),(26.935,7.205),(26.765,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((47.325,7.205),(47.325,20.795),(47.495,20.795),(47.495,7.205),(47.325,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((72.565,7.205),(72.565,23.92),(72.735,23.92),(72.735,7.205),(72.565,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((26.765,7.205),(26.765,20.795),(26.935,20.795),(26.935,7.205),(26.765,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((72.565,7.205),(72.565,20.795),(72.735,20.795),(72.735,7.205),(72.565,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((67.885,7.205),(67.885,20.795),(68.055,20.795),(68.055,7.205),(67.885,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((71.005,7.205),(71.005,23.92),(71.175,23.92),(71.175,7.205),(71.005,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((57.605,7.205),(57.605,23.92),(57.775,23.92),(57.775,7.205),(57.605,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((14.225,0.0),(14.225,4.08),(75.775,4.08),(75.775,0.0),(14.225,0.0)),
        )
        createRL(
            tech, net, 'li',
            ((69.445,7.205),(69.445,20.795),(69.615,20.795),(69.615,7.205),(69.445,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((69.445,7.205),(69.445,23.92),(69.615,23.92),(69.615,7.205),(69.445,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((71.005,7.205),(71.005,20.795),(71.175,20.795),(71.175,7.205),(71.005,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((57.605,7.205),(57.605,20.795),(57.775,20.795),(57.775,7.205),(57.605,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((67.885,7.205),(67.885,23.92),(68.055,23.92),(68.055,7.205),(67.885,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((37.045,7.205),(37.045,23.92),(37.215,23.92),(37.215,7.205),(37.045,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((16.485,7.205),(16.485,20.795),(16.655,20.795),(16.655,7.205),(16.485,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((47.325,7.205),(47.325,23.92),(47.495,23.92),(47.495,7.205),(47.325,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((37.045,7.205),(37.045,20.795),(37.215,20.795),(37.215,7.205),(37.045,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((16.485,7.205),(16.485,23.92),(16.655,23.92),(16.655,7.205),(16.485,7.205)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(2.04), u(4.08), u(14.224999999999994), u(75.775),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(2.04), u(4.08), u(14.224999999999994), u(75.775),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((68.515,6.875),(68.515,21.125),(69.765,21.125),(69.765,6.875),(68.515,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.82,6.93),(68.82,21.07),(69.46,21.07),(69.46,6.93),(68.82,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((37.2,6.93),(37.2,21.07),(47.34,21.07),(47.34,6.93),(37.2,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.6,6.875),(26.6,21.125),(27.1,21.125),(27.1,6.875),(26.6,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.64,6.93),(16.64,21.07),(26.78,21.07),(26.78,6.93),(16.64,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.335,6.875),(16.335,21.125),(27.085,21.125),(27.085,6.875),(16.335,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.855,6.875),(70.855,21.125),(72.105,21.125),(72.105,6.875),(70.855,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.92,6.93),(26.92,21.07),(37.06,21.07),(37.06,6.93),(26.92,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((73.18,6.875),(73.18,21.125),(73.68,21.125),(73.68,6.875),(73.18,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.175,6.875),(47.175,21.125),(57.925,21.125),(57.925,6.875),(47.175,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.88,6.875),(36.88,21.125),(37.38,21.125),(37.38,6.875),(36.88,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.48,6.93),(47.48,21.07),(57.62,21.07),(57.62,6.93),(47.48,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.28,6.875),(69.28,21.125),(69.78,21.125),(69.78,6.875),(69.28,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.16,6.875),(47.16,21.125),(47.66,21.125),(47.66,6.875),(47.16,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((72.4,6.875),(72.4,21.125),(72.9,21.125),(72.9,6.875),(72.4,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.075,6.875),(70.075,21.125),(71.325,21.125),(71.325,6.875),(70.075,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.38,6.93),(70.38,21.07),(71.02,21.07),(71.02,6.93),(70.38,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.84,6.875),(70.84,21.125),(71.34,21.125),(71.34,6.875),(70.84,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((72.415,6.875),(72.415,21.125),(73.665,21.125),(73.665,6.875),(72.415,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((72.72,6.93),(72.72,21.07),(73.36,21.07),(73.36,6.93),(72.72,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.635,6.875),(71.635,21.125),(72.885,21.125),(72.885,6.875),(71.635,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.94,6.93),(71.94,21.07),(72.58,21.07),(72.58,6.93),(71.94,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.62,6.875),(71.62,21.125),(72.12,21.125),(72.12,6.875),(71.62,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((67.735,6.875),(67.735,21.125),(68.985,21.125),(68.985,6.875),(67.735,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((67.72,6.875),(67.72,21.125),(68.22,21.125),(68.22,6.875),(67.72,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.295,6.875),(69.295,21.125),(70.545,21.125),(70.545,6.875),(69.295,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((69.6,6.93),(69.6,21.07),(70.24,21.07),(70.24,6.93),(69.6,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((16.32,6.875),(16.32,21.125),(16.82,21.125),(16.82,6.875),(16.32,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((70.06,6.875),(70.06,21.125),(70.56,21.125),(70.56,6.875),(70.06,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((71.16,6.93),(71.16,21.07),(71.8,21.07),(71.8,6.93),(71.16,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.44,6.875),(57.44,21.125),(57.94,21.125),(57.94,6.875),(57.44,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.76,6.93),(57.76,21.07),(67.9,21.07),(67.9,6.93),(57.76,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.455,6.875),(57.455,21.125),(68.205,21.125),(68.205,6.875),(57.455,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((26.615,6.875),(26.615,21.125),(37.365,21.125),(37.365,6.875),(26.615,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.04,6.93),(68.04,21.07),(68.68,21.07),(68.68,6.93),(68.04,6.93)),
        )
        createRL(
            tech, net, 'nsdm',
            ((68.5,6.875),(68.5,21.125),(69.0,21.125),(69.0,6.875),(68.5,6.875)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.895,6.875),(36.895,21.125),(47.645,21.125),(47.645,6.875),(36.895,6.875)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.49,29.18),(45.49,36.54),(46.85,36.54),(46.85,29.18),(45.49,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.72,29.16),(45.72,36.56),(46.62,36.56),(46.62,29.16),(45.72,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((37.07,6.8),(37.07,21.2),(47.47,21.2),(47.47,6.8),(37.07,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.51,6.8),(16.51,21.2),(26.91,21.2),(26.91,6.8),(16.51,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((29.89,29.18),(29.89,36.54),(31.25,36.54),(31.25,29.18),(29.89,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((32.46,29.16),(32.46,36.56),(33.36,36.56),(33.36,29.16),(32.46,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((32.23,29.18),(32.23,36.54),(33.59,36.54),(33.59,29.18),(32.23,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((46.27,29.18),(46.27,36.54),(47.63,36.54),(47.63,29.18),(46.27,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((46.5,29.16),(46.5,36.56),(47.4,36.56),(47.4,29.16),(46.5,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((35.58,29.16),(35.58,36.56),(36.48,36.56),(36.48,29.16),(35.58,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((35.35,29.18),(35.35,36.54),(36.71,36.54),(36.71,29.18),(35.35,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((64.195,29.18),(64.195,36.54),(64.805,36.54),(64.805,29.18),(64.195,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((51.18,29.16),(51.18,36.56),(52.08,36.56),(52.08,29.16),(51.18,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((51.96,29.16),(51.96,36.56),(52.86,36.56),(52.86,29.16),(51.96,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((58.75,29.18),(58.75,36.54),(60.11,36.54),(60.11,29.18),(58.75,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.24,6.82),(69.24,21.18),(70.6,21.18),(70.6,6.82),(69.24,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((69.47,6.8),(69.47,21.2),(70.37,21.2),(70.37,6.8),(69.47,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.74,29.16),(52.74,36.56),(53.64,36.56),(53.64,29.16),(52.74,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.51,29.18),(52.51,36.54),(53.87,36.54),(53.87,29.18),(52.51,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((29.34,29.16),(29.34,36.56),(30.24,36.56),(30.24,29.16),(29.34,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((29.11,29.18),(29.11,36.54),(30.47,36.54),(30.47,29.18),(29.11,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.91,29.18),(36.91,36.54),(38.27,36.54),(38.27,29.18),(36.91,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.79,29.18),(33.79,36.54),(35.15,36.54),(35.15,29.18),(33.79,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((59.76,29.16),(59.76,36.56),(60.66,36.56),(60.66,29.16),(59.76,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((59.53,29.18),(59.53,36.54),(60.89,36.54),(60.89,29.18),(59.53,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.81,29.18),(40.81,36.54),(42.17,36.54),(42.17,29.18),(40.81,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.33,29.18),(28.33,36.54),(29.69,36.54),(29.69,29.18),(28.33,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((28.56,29.16),(28.56,36.56),(29.46,36.56),(29.46,29.16),(28.56,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.68,29.16),(31.68,36.56),(32.58,36.56),(32.58,29.16),(31.68,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((63.43,29.18),(63.43,36.54),(64.79,36.54),(64.79,29.18),(63.43,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.45,29.18),(31.45,36.54),(32.81,36.54),(32.81,29.18),(31.45,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((51.73,29.18),(51.73,36.54),(53.09,36.54),(53.09,29.18),(51.73,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((63.66,29.16),(63.66,36.56),(64.56,36.56),(64.56,29.16),(63.66,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((70.8,6.82),(70.8,21.18),(72.16,21.18),(72.16,6.82),(70.8,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((34.8,29.16),(34.8,36.56),(35.7,36.56),(35.7,29.16),(34.8,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((34.57,29.18),(34.57,36.54),(35.93,36.54),(35.93,29.18),(34.57,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((39.48,29.16),(39.48,36.56),(40.38,36.56),(40.38,29.16),(39.48,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((39.25,29.18),(39.25,36.54),(40.61,36.54),(40.61,29.18),(39.25,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.22,29.16),(26.22,36.56),(27.12,36.56),(27.12,29.16),(26.22,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((27.0,29.16),(27.0,36.56),(27.9,36.56),(27.9,29.16),(27.0,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.24,29.16),(33.24,36.56),(34.14,36.56),(34.14,29.16),(33.24,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.01,29.18),(33.01,36.54),(34.37,36.54),(34.37,29.18),(33.01,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.97,29.18),(57.97,36.54),(59.33,36.54),(59.33,29.18),(57.97,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.36,29.16),(36.36,36.56),(37.26,36.56),(37.26,29.16),(36.36,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.13,29.18),(36.13,36.54),(37.49,36.54),(37.49,29.18),(36.13,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.26,29.16),(40.26,36.56),(41.16,36.56),(41.16,29.16),(40.26,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.65,29.18),(62.65,36.54),(64.01,36.54),(64.01,29.18),(62.65,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.03,29.18),(40.03,36.54),(41.39,36.54),(41.39,29.18),(40.03,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.86,29.16),(55.86,36.56),(56.76,36.56),(56.76,29.16),(55.86,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.63,29.18),(55.63,36.54),(56.99,36.54),(56.99,29.18),(55.63,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((70.25,6.8),(70.25,21.2),(71.15,21.2),(71.15,6.8),(70.25,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((70.02,6.82),(70.02,21.18),(71.38,21.18),(71.38,6.82),(70.02,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((72.36,6.82),(72.36,21.18),(73.72,21.18),(73.72,6.82),(72.36,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((72.59,6.8),(72.59,21.2),(73.49,21.2),(73.49,6.8),(72.59,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((67.91,6.8),(67.91,21.2),(68.81,21.2),(68.81,6.8),(67.91,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.03,6.8),(71.03,21.2),(71.93,21.2),(71.93,6.8),(71.03,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((30.9,29.16),(30.9,36.56),(31.8,36.56),(31.8,29.16),(30.9,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((30.12,29.16),(30.12,36.56),(31.02,36.56),(31.02,29.16),(30.12,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((34.02,29.16),(34.02,36.56),(34.92,36.56),(34.92,29.16),(34.02,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((56.64,29.16),(56.64,36.56),(57.54,36.56),(57.54,29.16),(56.64,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((56.41,29.18),(56.41,36.54),(57.77,36.54),(57.77,29.18),(56.41,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.79,6.8),(26.79,21.2),(37.19,21.2),(37.19,6.8),(26.79,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.56,6.82),(26.56,21.18),(37.42,21.18),(37.42,6.82),(26.56,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((68.69,6.8),(68.69,21.2),(69.59,21.2),(69.59,6.8),(68.69,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((68.46,6.82),(68.46,21.18),(69.82,21.18),(69.82,6.82),(68.46,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.54,29.16),(60.54,36.56),(61.44,36.56),(61.44,29.16),(60.54,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((53.29,29.18),(53.29,36.54),(54.65,36.54),(54.65,29.18),(53.29,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.95,29.18),(50.95,36.54),(52.31,36.54),(52.31,29.18),(50.95,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((53.52,29.16),(53.52,36.56),(54.42,36.56),(54.42,29.16),(53.52,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((60.31,29.18),(60.31,36.54),(61.67,36.54),(61.67,29.18),(60.31,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.42,29.16),(57.42,36.56),(58.32,36.56),(58.32,29.16),(57.42,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.19,29.18),(57.19,36.54),(58.55,36.54),(58.55,29.18),(57.19,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((44.71,29.18),(44.71,36.54),(46.07,36.54),(46.07,29.18),(44.71,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((48.06,29.16),(48.06,36.56),(48.96,36.56),(48.96,29.16),(48.06,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((37.69,29.18),(37.69,36.54),(39.05,36.54),(39.05,29.18),(37.69,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.28,6.82),(16.28,21.18),(27.14,21.18),(27.14,6.82),(16.28,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((54.07,29.18),(54.07,36.54),(55.43,36.54),(55.43,29.18),(54.07,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((54.3,29.16),(54.3,36.56),(55.2,36.56),(55.2,29.16),(54.3,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((27.78,29.16),(27.78,36.56),(28.68,36.56),(28.68,29.16),(27.78,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((27.55,29.18),(27.55,36.54),(28.91,36.54),(28.91,29.18),(27.55,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((58.98,29.16),(58.98,36.56),(59.88,36.56),(59.88,29.16),(58.98,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((58.2,29.16),(58.2,36.56),(59.1,36.56),(59.1,29.16),(58.2,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.12,6.82),(47.12,21.18),(57.98,21.18),(57.98,6.82),(47.12,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.35,6.8),(47.35,21.2),(57.75,21.2),(57.75,6.8),(47.35,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((67.68,6.82),(67.68,21.18),(69.04,21.18),(69.04,6.82),(67.68,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.38,29.16),(43.38,36.56),(44.28,36.56),(44.28,29.16),(43.38,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.15,29.18),(43.15,36.54),(44.51,36.54),(44.51,29.18),(43.15,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((61.87,29.18),(61.87,36.54),(63.23,36.54),(63.23,29.18),(61.87,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.81,6.8),(71.81,21.2),(72.71,21.2),(72.71,6.8),(71.81,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((71.58,6.82),(71.58,21.18),(72.94,21.18),(72.94,6.82),(71.58,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((48.61,29.18),(48.61,36.54),(49.97,36.54),(49.97,29.18),(48.61,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((48.84,29.16),(48.84,36.56),(49.74,36.56),(49.74,29.16),(48.84,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((37.14,29.16),(37.14,36.56),(38.04,36.56),(38.04,29.16),(37.14,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((44.16,29.16),(44.16,36.56),(45.06,36.56),(45.06,29.16),(44.16,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((44.94,29.16),(44.94,36.56),(45.84,36.56),(45.84,29.16),(44.94,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((37.92,29.16),(37.92,36.56),(38.82,36.56),(38.82,29.16),(37.92,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.88,29.16),(62.88,36.56),(63.78,36.56),(63.78,29.16),(62.88,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((62.1,29.16),(62.1,36.56),(63.0,36.56),(63.0,29.16),(62.1,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((25.195,29.18),(25.195,36.54),(25.805,36.54),(25.805,29.18),(25.195,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.47,29.18),(38.47,36.54),(39.83,36.54),(39.83,29.18),(38.47,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.7,29.16),(38.7,36.56),(39.6,36.56),(39.6,29.16),(38.7,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((25.99,29.18),(25.99,36.54),(27.35,36.54),(27.35,29.18),(25.99,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((30.67,29.18),(30.67,36.54),(32.03,36.54),(32.03,29.18),(30.67,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.93,29.18),(43.93,36.54),(45.29,36.54),(45.29,29.18),(43.93,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.04,29.16),(41.04,36.56),(41.94,36.56),(41.94,29.16),(41.04,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.37,29.18),(42.37,36.54),(43.73,36.54),(43.73,29.18),(42.37,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.6,29.16),(42.6,36.56),(43.5,36.56),(43.5,29.16),(42.6,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((61.32,29.16),(61.32,36.56),(62.22,36.56),(62.22,29.16),(61.32,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((61.09,29.18),(61.09,36.54),(62.45,36.54),(62.45,29.18),(61.09,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.05,29.18),(47.05,36.54),(48.41,36.54),(48.41,29.18),(47.05,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.28,29.16),(47.28,36.56),(48.18,36.56),(48.18,29.16),(47.28,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((73.125,6.82),(73.125,21.18),(73.735,21.18),(73.735,6.82),(73.125,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((25.44,29.16),(25.44,36.56),(26.34,36.56),(26.34,29.16),(25.44,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((54.85,29.18),(54.85,36.54),(56.21,36.54),(56.21,29.18),(54.85,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((25.21,29.18),(25.21,36.54),(26.57,36.54),(26.57,29.18),(25.21,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((26.77,29.18),(26.77,36.54),(28.13,36.54),(28.13,29.18),(26.77,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.08,29.16),(55.08,36.56),(55.98,36.56),(55.98,29.16),(55.08,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((16.265,6.82),(16.265,21.18),(16.875,21.18),(16.875,6.82),(16.265,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.17,29.18),(50.17,36.54),(51.53,36.54),(51.53,29.18),(50.17,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.4,29.16),(50.4,36.56),(51.3,36.56),(51.3,29.16),(50.4,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.82,29.16),(41.82,36.56),(42.72,36.56),(42.72,29.16),(41.82,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.59,29.18),(41.59,36.54),(42.95,36.54),(42.95,29.18),(41.59,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.83,29.18),(47.83,36.54),(49.19,36.54),(49.19,29.18),(47.83,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.63,6.8),(57.63,21.2),(68.03,21.2),(68.03,6.8),(57.63,6.8)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.4,6.82),(57.4,21.18),(68.26,21.18),(68.26,6.82),(57.4,6.82)),
        )
        createRL(
            tech, net, 'hvi',
            ((49.39,29.18),(49.39,36.54),(50.75,36.54),(50.75,29.18),(49.39,29.18)),
        )
        createRL(
            tech, net, 'hvi',
            ((49.62,29.16),(49.62,36.56),(50.52,36.56),(50.52,29.16),(49.62,29.16)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.84,6.82),(36.84,21.18),(47.7,21.18),(47.7,6.82),(36.84,6.82)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.545,29.235),(45.545,36.485),(46.795,36.485),(46.795,29.235),(45.545,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.53,29.235),(45.53,36.485),(46.03,36.485),(46.03,29.235),(45.53,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.85,29.29),(45.85,36.43),(46.49,36.43),(46.49,29.29),(45.85,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((29.15,29.235),(29.15,36.485),(29.65,36.485),(29.65,29.235),(29.15,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((29.945,29.235),(29.945,36.485),(31.195,36.485),(31.195,29.235),(29.945,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.09,29.29),(52.09,36.43),(52.73,36.43),(52.73,29.29),(52.09,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((32.59,29.29),(32.59,36.43),(33.23,36.43),(33.23,29.29),(32.59,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((32.285,29.235),(32.285,36.485),(33.535,36.485),(33.535,29.235),(32.285,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.05,29.235),(33.05,36.485),(33.55,36.485),(33.55,29.235),(33.05,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((46.325,29.235),(46.325,36.485),(47.575,36.485),(47.575,29.235),(46.325,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((46.63,29.29),(46.63,36.43),(47.27,36.43),(47.27,29.29),(46.63,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.21,29.235),(50.21,36.485),(50.71,36.485),(50.71,29.235),(50.21,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.71,29.29),(35.71,36.43),(36.35,36.43),(36.35,29.29),(35.71,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.405,29.235),(35.405,36.485),(36.655,36.485),(36.655,29.235),(35.405,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((28.37,29.235),(28.37,36.485),(28.87,36.485),(28.87,29.235),(28.37,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((27.13,29.29),(27.13,36.43),(27.77,36.43),(27.77,29.29),(27.13,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((64.25,29.235),(64.25,36.485),(64.75,36.485),(64.75,29.235),(64.25,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((51.005,29.235),(51.005,36.485),(52.255,36.485),(52.255,29.235),(51.005,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((51.77,29.235),(51.77,36.485),(52.27,36.485),(52.27,29.235),(51.77,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.805,29.235),(58.805,36.485),(60.055,36.485),(60.055,29.235),(58.805,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.87,29.29),(52.87,36.43),(53.51,36.43),(53.51,29.29),(52.87,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.565,29.235),(52.565,36.485),(53.815,36.485),(53.815,29.235),(52.565,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((29.47,29.29),(29.47,36.43),(30.11,36.43),(30.11,29.29),(29.47,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((29.165,29.235),(29.165,36.485),(30.415,36.485),(30.415,29.235),(29.165,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.09,29.235),(47.09,36.485),(47.59,36.485),(47.59,29.235),(47.09,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.55,29.235),(52.55,36.485),(53.05,36.485),(53.05,29.235),(52.55,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.03,29.29),(31.03,36.43),(31.67,36.43),(31.67,29.29),(31.03,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((46.31,29.235),(46.31,36.485),(46.81,36.485),(46.81,29.235),(46.31,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.49,29.235),(31.49,36.485),(31.99,36.485),(31.99,29.235),(31.49,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.965,29.235),(36.965,36.485),(38.215,36.485),(38.215,29.235),(36.965,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.845,29.235),(33.845,36.485),(35.095,36.485),(35.095,29.235),(33.845,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.585,29.235),(59.585,36.485),(60.835,36.485),(60.835,29.235),(59.585,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.89,29.29),(59.89,36.43),(60.53,36.43),(60.53,29.29),(59.89,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.57,29.235),(59.57,36.485),(60.07,36.485),(60.07,29.235),(59.57,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.865,29.235),(40.865,36.485),(42.115,36.485),(42.115,29.235),(40.865,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.17,29.235),(36.17,36.485),(36.67,36.485),(36.67,29.235),(36.17,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.07,29.235),(40.07,36.485),(40.57,36.485),(40.57,29.235),(40.07,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((28.385,29.235),(28.385,36.485),(29.635,36.485),(29.635,29.235),(28.385,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((28.69,29.29),(28.69,36.43),(29.33,36.43),(29.33,29.29),(28.69,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.505,29.235),(31.505,36.485),(32.755,36.485),(32.755,29.235),(31.505,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.485,29.235),(63.485,36.485),(64.735,36.485),(64.735,29.235),(63.485,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.81,29.29),(31.81,36.43),(32.45,36.43),(32.45,29.29),(31.81,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((51.785,29.235),(51.785,36.485),(53.035,36.485),(53.035,29.235),(51.785,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.79,29.29),(63.79,36.43),(64.43,36.43),(64.43,29.29),(63.79,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((56.45,29.235),(56.45,36.485),(56.95,36.485),(56.95,29.235),(56.45,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((34.61,29.235),(34.61,36.485),(35.11,36.485),(35.11,29.235),(34.61,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((34.625,29.235),(34.625,36.485),(35.875,36.485),(35.875,29.235),(34.625,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((34.93,29.29),(34.93,36.43),(35.57,36.43),(35.57,29.29),(34.93,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((53.33,29.235),(53.33,36.485),(53.83,36.485),(53.83,29.235),(53.33,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.61,29.29),(39.61,36.43),(40.25,36.43),(40.25,29.29),(39.61,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.305,29.235),(39.305,36.485),(40.555,36.485),(40.555,29.235),(39.305,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.23,29.235),(57.23,36.485),(57.73,36.485),(57.73,29.235),(57.23,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((60.35,29.235),(60.35,36.485),(60.85,36.485),(60.85,29.235),(60.35,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.045,29.235),(26.045,36.485),(27.295,36.485),(27.295,29.235),(26.045,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.81,29.235),(26.81,36.485),(27.31,36.485),(27.31,29.235),(26.81,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.065,29.235),(33.065,36.485),(34.315,36.485),(34.315,29.235),(33.065,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.37,29.29),(33.37,36.43),(34.01,36.43),(34.01,29.29),(33.37,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.83,29.235),(33.83,36.485),(34.33,36.485),(34.33,29.235),(33.83,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.185,29.235),(36.185,36.485),(37.435,36.485),(37.435,29.235),(36.185,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.49,29.29),(36.49,36.43),(37.13,36.43),(37.13,29.29),(36.49,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.95,29.235),(36.95,36.485),(37.45,36.485),(37.45,29.235),(36.95,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.85,29.235),(40.85,36.485),(41.35,36.485),(41.35,29.235),(40.85,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.085,29.235),(40.085,36.485),(41.335,36.485),(41.335,29.235),(40.085,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.39,29.29),(40.39,36.43),(41.03,36.43),(41.03,29.29),(40.39,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.685,29.235),(55.685,36.485),(56.935,36.485),(56.935,29.235),(55.685,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.99,29.29),(55.99,36.43),(56.63,36.43),(56.63,29.29),(55.99,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.67,29.235),(55.67,36.485),(56.17,36.485),(56.17,29.235),(55.67,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.71,29.235),(30.71,36.485),(31.21,36.485),(31.21,29.235),(30.71,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.725,29.235),(30.725,36.485),(31.975,36.485),(31.975,29.235),(30.725,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((34.15,29.29),(34.15,36.43),(34.79,36.43),(34.79,29.29),(34.15,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((56.465,29.235),(56.465,36.485),(57.715,36.485),(57.715,29.235),(56.465,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((51.31,29.29),(51.31,36.43),(51.95,36.43),(51.95,29.29),(51.31,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((56.77,29.29),(56.77,36.43),(57.41,36.43),(57.41,29.29),(56.77,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((60.67,29.29),(60.67,36.43),(61.31,36.43),(61.31,29.29),(60.67,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((53.345,29.235),(53.345,36.485),(54.595,36.485),(54.595,29.235),(53.345,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((53.65,29.29),(53.65,36.43),(54.29,36.43),(54.29,29.29),(53.65,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((60.365,29.235),(60.365,36.485),(61.615,36.485),(61.615,29.235),(60.365,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.245,29.235),(57.245,36.485),(58.495,36.485),(58.495,29.235),(57.245,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.55,29.29),(57.55,36.43),(58.19,36.43),(58.19,29.29),(57.55,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((37.27,29.29),(37.27,36.43),(37.91,36.43),(37.91,29.29),(37.27,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((48.19,29.29),(48.19,36.43),(48.83,36.43),(48.83,29.29),(48.19,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.765,29.235),(44.765,36.485),(46.015,36.485),(46.015,29.235),(44.765,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.29,29.29),(44.29,36.43),(44.93,36.43),(44.93,29.29),(44.29,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.125,29.235),(54.125,36.485),(55.375,36.485),(55.375,29.235),(54.125,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.43,29.29),(54.43,36.43),(55.07,36.43),(55.07,29.29),(54.43,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.89,29.235),(54.89,36.485),(55.39,36.485),(55.39,29.235),(54.89,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.11,29.235),(54.11,36.485),(54.61,36.485),(54.61,29.235),(54.11,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.25,29.29),(30.25,36.43),(30.89,36.43),(30.89,29.29),(30.25,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((27.605,29.235),(27.605,36.485),(28.855,36.485),(28.855,29.235),(27.605,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((27.91,29.29),(27.91,36.43),(28.55,36.43),(28.55,29.29),(27.91,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((27.59,29.235),(27.59,36.485),(28.09,36.485),(28.09,29.235),(27.59,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.79,29.235),(58.79,36.485),(59.29,36.485),(59.29,29.235),(58.79,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.025,29.235),(58.025,36.485),(59.275,36.485),(59.275,29.235),(58.025,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.35,29.29),(26.35,36.43),(26.99,36.43),(26.99,29.29),(26.35,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.03,29.235),(26.03,36.485),(26.53,36.485),(26.53,29.235),(26.03,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.39,29.235),(35.39,36.485),(35.89,36.485),(35.89,29.235),(35.39,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((61.13,29.235),(61.13,36.485),(61.63,36.485),(61.63,29.235),(61.13,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.51,29.29),(43.51,36.43),(44.15,36.43),(44.15,29.29),(43.51,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.97,29.235),(43.97,36.485),(44.47,36.485),(44.47,29.235),(43.97,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.205,29.235),(43.205,36.485),(44.455,36.485),(44.455,29.235),(43.205,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((61.925,29.235),(61.925,36.485),(63.175,36.485),(63.175,29.235),(61.925,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((48.97,29.29),(48.97,36.43),(49.61,36.43),(49.61,29.29),(48.97,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((48.665,29.235),(48.665,36.485),(49.915,36.485),(49.915,29.235),(48.665,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((48.65,29.235),(48.65,36.485),(49.15,36.485),(49.15,29.235),(48.65,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.75,29.235),(44.75,36.485),(45.25,36.485),(45.25,29.235),(44.75,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.43,29.235),(49.43,36.485),(49.93,36.485),(49.93,29.235),(49.43,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((37.745,29.235),(37.745,36.485),(38.995,36.485),(38.995,29.235),(37.745,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((37.73,29.235),(37.73,36.485),(38.23,36.485),(38.23,29.235),(37.73,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((62.705,29.235),(62.705,36.485),(63.955,36.485),(63.955,29.235),(62.705,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((62.69,29.235),(62.69,36.485),(63.19,36.485),(63.19,29.235),(62.69,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.25,29.235),(25.25,36.485),(25.75,36.485),(25.75,29.235),(25.25,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.83,29.29),(38.83,36.43),(39.47,36.43),(39.47,29.29),(38.83,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.51,29.235),(38.51,36.485),(39.01,36.485),(39.01,29.235),(38.51,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.525,29.235),(38.525,36.485),(39.775,36.485),(39.775,29.235),(38.525,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((59.11,29.29),(59.11,36.43),(59.75,36.43),(59.75,29.29),(59.11,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.985,29.235),(43.985,36.485),(45.235,36.485),(45.235,29.235),(43.985,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((41.17,29.29),(41.17,36.43),(41.81,36.43),(41.81,29.29),(41.17,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.425,29.235),(42.425,36.485),(43.675,36.485),(43.675,29.235),(42.425,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.73,29.29),(42.73,36.43),(43.37,36.43),(43.37,29.29),(42.73,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.41,29.235),(42.41,36.485),(42.91,36.485),(42.91,29.235),(42.41,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((61.91,29.235),(61.91,36.485),(62.41,36.485),(62.41,29.235),(61.91,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.01,29.29),(63.01,36.43),(63.65,36.43),(63.65,29.29),(63.01,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((63.47,29.235),(63.47,36.485),(63.97,36.485),(63.97,29.235),(63.47,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((61.145,29.235),(61.145,36.485),(62.395,36.485),(62.395,29.235),(61.145,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((61.45,29.29),(61.45,36.43),(62.09,36.43),(62.09,29.29),(61.45,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((62.23,29.29),(62.23,36.43),(62.87,36.43),(62.87,29.29),(62.23,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.07,29.29),(45.07,36.43),(45.71,36.43),(45.71,29.29),(45.07,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.41,29.29),(47.41,36.43),(48.05,36.43),(48.05,29.29),(47.41,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.105,29.235),(47.105,36.485),(48.355,36.485),(48.355,29.235),(47.105,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.87,29.235),(47.87,36.485),(48.37,36.485),(48.37,29.235),(47.87,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.29,29.235),(39.29,36.485),(39.79,36.485),(39.79,29.235),(39.29,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.33,29.29),(58.33,36.43),(58.97,36.43),(58.97,29.29),(58.33,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.01,29.235),(58.01,36.485),(58.51,36.485),(58.51,29.235),(58.01,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.265,29.235),(25.265,36.485),(26.515,36.485),(26.515,29.235),(25.265,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((25.57,29.29),(25.57,36.43),(26.21,36.43),(26.21,29.29),(25.57,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.905,29.235),(54.905,36.485),(56.155,36.485),(56.155,29.235),(54.905,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((32.27,29.235),(32.27,36.485),(32.77,36.485),(32.77,29.235),(32.27,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((29.93,29.235),(29.93,36.485),(30.43,36.485),(30.43,29.235),(29.93,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((26.825,29.235),(26.825,36.485),(28.075,36.485),(28.075,29.235),(26.825,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.21,29.29),(55.21,36.43),(55.85,36.43),(55.85,29.29),(55.21,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.225,29.235),(50.225,36.485),(51.475,36.485),(51.475,29.235),(50.225,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.53,29.29),(50.53,36.43),(51.17,36.43),(51.17,29.29),(50.53,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.99,29.235),(50.99,36.485),(51.49,36.485),(51.49,29.235),(50.99,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((41.645,29.235),(41.645,36.485),(42.895,36.485),(42.895,29.235),(41.645,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((41.95,29.29),(41.95,36.43),(42.59,36.43),(42.59,29.29),(41.95,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.19,29.235),(43.19,36.485),(43.69,36.485),(43.69,29.235),(43.19,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((41.63,29.235),(41.63,36.485),(42.13,36.485),(42.13,29.235),(41.63,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.885,29.235),(47.885,36.485),(49.135,36.485),(49.135,29.235),(47.885,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.445,29.235),(49.445,36.485),(50.695,36.485),(50.695,29.235),(49.445,29.235)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.05,29.29),(38.05,36.43),(38.69,36.43),(38.69,29.29),(38.05,29.29)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.75,29.29),(49.75,36.43),(50.39,36.43),(50.39,29.29),(49.75,29.29)),
        )
        net = nets['in']
        createRL(
            tech, net, 'poly',
            ((45.92,29.23),(45.92,36.77),(46.42,36.77),(46.42,29.23),(45.92,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((45.92,29.23),(45.92,36.49),(46.42,36.49),(46.42,29.23),(45.92,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((37.27,6.87),(37.27,21.13),(47.27,21.13),(47.27,6.87),(37.27,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((37.27,6.59),(37.27,21.13),(47.27,21.13),(47.27,6.59),(37.27,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((16.71,6.87),(16.71,21.13),(26.71,21.13),(26.71,6.87),(16.71,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((16.71,6.59),(16.71,21.13),(26.71,21.13),(26.71,6.59),(16.71,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((16.71,6.59),(16.71,6.86),(73.29,6.86),(73.29,6.59),(16.71,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((52.16,29.23),(52.16,36.49),(52.66,36.49),(52.66,29.23),(52.16,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((52.16,29.23),(52.16,36.77),(52.66,36.77),(52.66,29.23),(52.16,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((32.66,29.23),(32.66,36.77),(33.16,36.77),(33.16,29.23),(32.66,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((32.66,29.23),(32.66,36.49),(33.16,36.49),(33.16,29.23),(32.66,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.44,29.23),(33.44,36.49),(33.94,36.49),(33.94,29.23),(33.44,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.44,29.23),(33.44,36.77),(33.94,36.77),(33.94,29.23),(33.44,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((46.7,29.23),(46.7,36.49),(47.2,36.49),(47.2,29.23),(46.7,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((46.7,29.23),(46.7,36.77),(47.2,36.77),(47.2,29.23),(46.7,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((35.78,29.23),(35.78,36.49),(36.28,36.49),(36.28,29.23),(35.78,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((35.78,29.23),(35.78,36.77),(36.28,36.77),(36.28,29.23),(35.78,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((27.2,29.23),(27.2,36.49),(27.7,36.49),(27.7,29.23),(27.2,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((27.2,29.23),(27.2,36.77),(27.7,36.77),(27.7,29.23),(27.2,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((70.45,6.59),(70.45,21.13),(70.95,21.13),(70.95,6.59),(70.45,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((70.45,6.87),(70.45,21.13),(70.95,21.13),(70.95,6.87),(70.45,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((69.67,6.59),(69.67,21.13),(70.17,21.13),(70.17,6.59),(69.67,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((69.67,6.87),(69.67,21.13),(70.17,21.13),(70.17,6.87),(69.67,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((38.12,29.23),(38.12,36.77),(38.62,36.77),(38.62,29.23),(38.12,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((52.94,29.23),(52.94,36.49),(53.44,36.49),(53.44,29.23),(52.94,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((47.48,29.23),(47.48,36.49),(47.98,36.49),(47.98,29.23),(47.48,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.1,29.23),(31.1,36.49),(31.6,36.49),(31.6,29.23),(31.1,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((29.54,29.23),(29.54,36.49),(30.04,36.49),(30.04,29.23),(29.54,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((52.94,29.23),(52.94,36.77),(53.44,36.77),(53.44,29.23),(52.94,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.83,6.87),(57.83,21.13),(67.83,21.13),(67.83,6.87),(57.83,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((57.83,6.59),(57.83,21.13),(67.83,21.13),(67.83,6.59),(57.83,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((47.48,29.23),(47.48,36.77),(47.98,36.77),(47.98,29.23),(47.48,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.1,29.23),(31.1,36.77),(31.6,36.77),(31.6,29.23),(31.1,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((29.54,29.23),(29.54,36.77),(30.04,36.77),(30.04,29.23),(29.54,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((59.96,29.23),(59.96,36.49),(60.46,36.49),(60.46,29.23),(59.96,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((59.96,29.23),(59.96,36.77),(60.46,36.77),(60.46,29.23),(59.96,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((40.46,29.23),(40.46,36.49),(40.96,36.49),(40.96,29.23),(40.46,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((40.46,29.23),(40.46,36.77),(40.96,36.77),(40.96,29.23),(40.46,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((28.76,29.23),(28.76,36.49),(29.26,36.49),(29.26,29.23),(28.76,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((28.76,29.23),(28.76,36.77),(29.26,36.77),(29.26,29.23),(28.76,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.88,29.23),(31.88,36.49),(32.38,36.49),(32.38,29.23),(31.88,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((63.86,29.23),(63.86,36.49),(64.36,36.49),(64.36,29.23),(63.86,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.88,29.23),(31.88,36.77),(32.38,36.77),(32.38,29.23),(31.88,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((63.86,29.23),(63.86,36.77),(64.36,36.77),(64.36,29.23),(63.86,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((56.06,29.23),(56.06,36.49),(56.56,36.49),(56.56,29.23),(56.06,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((56.06,29.23),(56.06,36.77),(56.56,36.77),(56.56,29.23),(56.06,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((35.0,29.23),(35.0,36.49),(35.5,36.49),(35.5,29.23),(35.0,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((35.0,29.23),(35.0,36.77),(35.5,36.77),(35.5,29.23),(35.0,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((39.68,29.23),(39.68,36.49),(40.18,36.49),(40.18,29.23),(39.68,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((39.68,29.23),(39.68,36.77),(40.18,36.77),(40.18,29.23),(39.68,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((25.64,36.5),(25.64,36.77),(64.36,36.77),(64.36,36.5),(25.64,36.5)),
        )
        createRL(
            tech, net, 'poly',
            ((36.56,29.23),(36.56,36.49),(37.06,36.49),(37.06,29.23),(36.56,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.56,29.23),(36.56,36.77),(37.06,36.77),(37.06,29.23),(36.56,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((72.79,6.87),(72.79,21.13),(73.29,21.13),(73.29,6.87),(72.79,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((72.79,6.59),(72.79,21.13),(73.29,21.13),(73.29,6.59),(72.79,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((71.23,6.59),(71.23,21.13),(71.73,21.13),(71.73,6.59),(71.23,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((71.23,6.87),(71.23,21.13),(71.73,21.13),(71.73,6.87),(71.23,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((34.22,29.23),(34.22,36.49),(34.72,36.49),(34.72,29.23),(34.22,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((56.84,29.23),(56.84,36.49),(57.34,36.49),(57.34,29.23),(56.84,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.38,29.23),(51.38,36.49),(51.88,36.49),(51.88,29.23),(51.38,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((34.22,29.23),(34.22,36.77),(34.72,36.77),(34.72,29.23),(34.22,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((56.84,29.23),(56.84,36.77),(57.34,36.77),(57.34,29.23),(56.84,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((51.38,29.23),(51.38,36.77),(51.88,36.77),(51.88,29.23),(51.38,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((49.82,29.23),(49.82,36.49),(50.32,36.49),(50.32,29.23),(49.82,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((68.89,6.59),(68.89,21.13),(69.39,21.13),(69.39,6.59),(68.89,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((68.89,6.87),(68.89,21.13),(69.39,21.13),(69.39,6.87),(68.89,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((60.74,29.23),(60.74,36.49),(61.24,36.49),(61.24,29.23),(60.74,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((60.74,29.23),(60.74,36.77),(61.24,36.77),(61.24,29.23),(60.74,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((53.72,29.23),(53.72,36.49),(54.22,36.49),(54.22,29.23),(53.72,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((53.72,29.23),(53.72,36.77),(54.22,36.77),(54.22,29.23),(53.72,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.62,29.23),(57.62,36.49),(58.12,36.49),(58.12,29.23),(57.62,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((37.34,29.23),(37.34,36.49),(37.84,36.49),(37.84,29.23),(37.34,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((37.34,29.23),(37.34,36.77),(37.84,36.77),(37.84,29.23),(37.34,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.26,29.23),(48.26,36.49),(48.76,36.49),(48.76,29.23),(48.26,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.26,29.23),(48.26,36.77),(48.76,36.77),(48.76,29.23),(48.26,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.62,29.23),(57.62,36.77),(58.12,36.77),(58.12,29.23),(57.62,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((44.36,29.23),(44.36,36.49),(44.86,36.49),(44.86,29.23),(44.36,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((54.5,29.23),(54.5,36.49),(55.0,36.49),(55.0,29.23),(54.5,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((44.36,29.23),(44.36,36.77),(44.86,36.77),(44.86,29.23),(44.36,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((54.5,29.23),(54.5,36.77),(55.0,36.77),(55.0,29.23),(54.5,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((30.32,29.23),(30.32,36.49),(30.82,36.49),(30.82,29.23),(30.32,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((30.32,29.23),(30.32,36.77),(30.82,36.77),(30.82,29.23),(30.32,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((27.98,29.23),(27.98,36.49),(28.48,36.49),(28.48,29.23),(27.98,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((27.98,29.23),(27.98,36.77),(28.48,36.77),(28.48,29.23),(27.98,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((26.42,29.23),(26.42,36.49),(26.92,36.49),(26.92,29.23),(26.42,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((26.42,29.23),(26.42,36.77),(26.92,36.77),(26.92,29.23),(26.42,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((47.55,6.87),(47.55,21.13),(57.55,21.13),(57.55,6.87),(47.55,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((47.55,6.59),(47.55,21.13),(57.55,21.13),(57.55,6.59),(47.55,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((43.58,29.23),(43.58,36.49),(44.08,36.49),(44.08,29.23),(43.58,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((43.58,29.23),(43.58,36.77),(44.08,36.77),(44.08,29.23),(43.58,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((49.04,29.23),(49.04,36.49),(49.54,36.49),(49.54,29.23),(49.04,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((49.04,29.23),(49.04,36.77),(49.54,36.77),(49.54,29.23),(49.04,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.9,29.23),(38.9,36.49),(39.4,36.49),(39.4,29.23),(38.9,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.9,29.23),(38.9,36.77),(39.4,36.77),(39.4,29.23),(38.9,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((68.11,6.59),(68.11,21.13),(68.61,21.13),(68.61,6.59),(68.11,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((59.18,29.23),(59.18,36.49),(59.68,36.49),(59.68,29.23),(59.18,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((59.18,29.23),(59.18,36.77),(59.68,36.77),(59.68,29.23),(59.18,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((41.24,29.23),(41.24,36.77),(41.74,36.77),(41.74,29.23),(41.24,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((41.24,29.23),(41.24,36.49),(41.74,36.49),(41.74,29.23),(41.24,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((42.8,29.23),(42.8,36.49),(43.3,36.49),(43.3,29.23),(42.8,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((42.8,29.23),(42.8,36.77),(43.3,36.77),(43.3,29.23),(42.8,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((42.02,29.23),(42.02,36.49),(42.52,36.49),(42.52,29.23),(42.02,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((42.02,29.23),(42.02,36.77),(42.52,36.77),(42.52,29.23),(42.02,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((61.52,29.23),(61.52,36.49),(62.02,36.49),(62.02,29.23),(61.52,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((63.08,29.23),(63.08,36.49),(63.58,36.49),(63.58,29.23),(63.08,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((61.52,29.23),(61.52,36.77),(62.02,36.77),(62.02,29.23),(61.52,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((63.08,29.23),(63.08,36.77),(63.58,36.77),(63.58,29.23),(63.08,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.3,29.23),(62.3,36.49),(62.8,36.49),(62.8,29.23),(62.3,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((62.3,29.23),(62.3,36.77),(62.8,36.77),(62.8,29.23),(62.3,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((45.14,29.23),(45.14,36.49),(45.64,36.49),(45.64,29.23),(45.14,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((45.14,29.23),(45.14,36.77),(45.64,36.77),(45.64,29.23),(45.14,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((58.4,29.23),(58.4,36.49),(58.9,36.49),(58.9,29.23),(58.4,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((58.4,29.23),(58.4,36.77),(58.9,36.77),(58.9,29.23),(58.4,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((25.64,29.23),(25.64,36.49),(26.14,36.49),(26.14,29.23),(25.64,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((25.64,29.23),(25.64,36.77),(26.14,36.77),(26.14,29.23),(25.64,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((72.01,6.59),(72.01,21.13),(72.51,21.13),(72.51,6.59),(72.01,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((72.01,6.87),(72.01,21.13),(72.51,21.13),(72.51,6.87),(72.01,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((55.28,29.23),(55.28,36.49),(55.78,36.49),(55.78,29.23),(55.28,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.28,29.23),(55.28,36.77),(55.78,36.77),(55.78,29.23),(55.28,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((50.6,29.23),(50.6,36.49),(51.1,36.49),(51.1,29.23),(50.6,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((50.6,29.23),(50.6,36.77),(51.1,36.77),(51.1,29.23),(50.6,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((26.99,6.87),(26.99,21.13),(36.99,21.13),(36.99,6.87),(26.99,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((26.99,6.59),(26.99,21.13),(36.99,21.13),(36.99,6.59),(26.99,6.59)),
        )
        createRL(
            tech, net, 'poly',
            ((68.11,6.87),(68.11,21.13),(68.61,21.13),(68.61,6.87),(68.11,6.87)),
        )
        createRL(
            tech, net, 'poly',
            ((38.12,29.23),(38.12,36.49),(38.62,36.49),(38.62,29.23),(38.12,29.23)),
        )
        createRL(
            tech, net, 'poly',
            ((49.82,29.23),(49.82,36.77),(50.32,36.77),(50.32,29.23),(49.82,29.23)),
        )
        createRL(
            tech, net, 'licon',
            ((25.875,36.55),(25.875,36.72),(26.045,36.72),(26.045,36.55),(25.875,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((26.215,36.55),(26.215,36.72),(26.385,36.72),(26.385,36.55),(26.215,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((26.555,36.55),(26.555,36.72),(26.725,36.72),(26.725,36.55),(26.555,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((26.895,36.55),(26.895,36.72),(27.065,36.72),(27.065,36.55),(26.895,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((27.235,36.55),(27.235,36.72),(27.405,36.72),(27.405,36.55),(27.235,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((27.575,36.55),(27.575,36.72),(27.745,36.72),(27.745,36.55),(27.575,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((27.915,36.55),(27.915,36.72),(28.085,36.72),(28.085,36.55),(27.915,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((28.255,36.55),(28.255,36.72),(28.425,36.72),(28.425,36.55),(28.255,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((28.595,36.55),(28.595,36.72),(28.765,36.72),(28.765,36.55),(28.595,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((28.935,36.55),(28.935,36.72),(29.105,36.72),(29.105,36.55),(28.935,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((29.275,36.55),(29.275,36.72),(29.445,36.72),(29.445,36.55),(29.275,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((29.615,36.55),(29.615,36.72),(29.785,36.72),(29.785,36.55),(29.615,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((29.955,36.55),(29.955,36.72),(30.125,36.72),(30.125,36.55),(29.955,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((30.295,36.55),(30.295,36.72),(30.465,36.72),(30.465,36.55),(30.295,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((30.635,36.55),(30.635,36.72),(30.805,36.72),(30.805,36.55),(30.635,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((30.975,36.55),(30.975,36.72),(31.145,36.72),(31.145,36.55),(30.975,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((31.315,36.55),(31.315,36.72),(31.485,36.72),(31.485,36.55),(31.315,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,36.55),(31.655,36.72),(31.825,36.72),(31.825,36.55),(31.655,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((31.995,36.55),(31.995,36.72),(32.165,36.72),(32.165,36.55),(31.995,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((32.335,36.55),(32.335,36.72),(32.505,36.72),(32.505,36.55),(32.335,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((32.675,36.55),(32.675,36.72),(32.845,36.72),(32.845,36.55),(32.675,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((33.015,36.55),(33.015,36.72),(33.185,36.72),(33.185,36.55),(33.015,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((33.355,36.55),(33.355,36.72),(33.525,36.72),(33.525,36.55),(33.355,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((33.695,36.55),(33.695,36.72),(33.865,36.72),(33.865,36.55),(33.695,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((34.035,36.55),(34.035,36.72),(34.205,36.72),(34.205,36.55),(34.035,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((34.375,36.55),(34.375,36.72),(34.545,36.72),(34.545,36.55),(34.375,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((34.715,36.55),(34.715,36.72),(34.885,36.72),(34.885,36.55),(34.715,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((35.055,36.55),(35.055,36.72),(35.225,36.72),(35.225,36.55),(35.055,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((35.395,36.55),(35.395,36.72),(35.565,36.72),(35.565,36.55),(35.395,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((35.735,36.55),(35.735,36.72),(35.905,36.72),(35.905,36.55),(35.735,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((36.075,36.55),(36.075,36.72),(36.245,36.72),(36.245,36.55),(36.075,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((36.415,36.55),(36.415,36.72),(36.585,36.72),(36.585,36.55),(36.415,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((36.755,36.55),(36.755,36.72),(36.925,36.72),(36.925,36.55),(36.755,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((37.095,36.55),(37.095,36.72),(37.265,36.72),(37.265,36.55),(37.095,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((37.435,36.55),(37.435,36.72),(37.605,36.72),(37.605,36.55),(37.435,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((37.775,36.55),(37.775,36.72),(37.945,36.72),(37.945,36.55),(37.775,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((38.115,36.55),(38.115,36.72),(38.285,36.72),(38.285,36.55),(38.115,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((38.455,36.55),(38.455,36.72),(38.625,36.72),(38.625,36.55),(38.455,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((38.795,36.55),(38.795,36.72),(38.965,36.72),(38.965,36.55),(38.795,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((39.135,36.55),(39.135,36.72),(39.305,36.72),(39.305,36.55),(39.135,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((39.475,36.55),(39.475,36.72),(39.645,36.72),(39.645,36.55),(39.475,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((39.815,36.55),(39.815,36.72),(39.985,36.72),(39.985,36.55),(39.815,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((40.155,36.55),(40.155,36.72),(40.325,36.72),(40.325,36.55),(40.155,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((40.495,36.55),(40.495,36.72),(40.665,36.72),(40.665,36.55),(40.495,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((40.835,36.55),(40.835,36.72),(41.005,36.72),(41.005,36.55),(40.835,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((41.175,36.55),(41.175,36.72),(41.345,36.72),(41.345,36.55),(41.175,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((41.515,36.55),(41.515,36.72),(41.685,36.72),(41.685,36.55),(41.515,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((41.855,36.55),(41.855,36.72),(42.025,36.72),(42.025,36.55),(41.855,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((42.195,36.55),(42.195,36.72),(42.365,36.72),(42.365,36.55),(42.195,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((42.535,36.55),(42.535,36.72),(42.705,36.72),(42.705,36.55),(42.535,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((42.875,36.55),(42.875,36.72),(43.045,36.72),(43.045,36.55),(42.875,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((43.215,36.55),(43.215,36.72),(43.385,36.72),(43.385,36.55),(43.215,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((43.555,36.55),(43.555,36.72),(43.725,36.72),(43.725,36.55),(43.555,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((43.895,36.55),(43.895,36.72),(44.065,36.72),(44.065,36.55),(43.895,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((44.235,36.55),(44.235,36.72),(44.405,36.72),(44.405,36.55),(44.235,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((44.575,36.55),(44.575,36.72),(44.745,36.72),(44.745,36.55),(44.575,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.55),(44.915,36.72),(45.085,36.72),(45.085,36.55),(44.915,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((45.255,36.55),(45.255,36.72),(45.425,36.72),(45.425,36.55),(45.255,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((45.595,36.55),(45.595,36.72),(45.765,36.72),(45.765,36.55),(45.595,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((45.935,36.55),(45.935,36.72),(46.105,36.72),(46.105,36.55),(45.935,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((46.275,36.55),(46.275,36.72),(46.445,36.72),(46.445,36.55),(46.275,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((46.615,36.55),(46.615,36.72),(46.785,36.72),(46.785,36.55),(46.615,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((46.955,36.55),(46.955,36.72),(47.125,36.72),(47.125,36.55),(46.955,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((47.295,36.55),(47.295,36.72),(47.465,36.72),(47.465,36.55),(47.295,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((47.635,36.55),(47.635,36.72),(47.805,36.72),(47.805,36.55),(47.635,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((47.975,36.55),(47.975,36.72),(48.145,36.72),(48.145,36.55),(47.975,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((48.315,36.55),(48.315,36.72),(48.485,36.72),(48.485,36.55),(48.315,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((48.655,36.55),(48.655,36.72),(48.825,36.72),(48.825,36.55),(48.655,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((48.995,36.55),(48.995,36.72),(49.165,36.72),(49.165,36.55),(48.995,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((49.335,36.55),(49.335,36.72),(49.505,36.72),(49.505,36.55),(49.335,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((49.675,36.55),(49.675,36.72),(49.845,36.72),(49.845,36.55),(49.675,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((50.015,36.55),(50.015,36.72),(50.185,36.72),(50.185,36.55),(50.015,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((50.355,36.55),(50.355,36.72),(50.525,36.72),(50.525,36.55),(50.355,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((50.695,36.55),(50.695,36.72),(50.865,36.72),(50.865,36.55),(50.695,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((51.035,36.55),(51.035,36.72),(51.205,36.72),(51.205,36.55),(51.035,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((51.375,36.55),(51.375,36.72),(51.545,36.72),(51.545,36.55),(51.375,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((51.715,36.55),(51.715,36.72),(51.885,36.72),(51.885,36.55),(51.715,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((52.055,36.55),(52.055,36.72),(52.225,36.72),(52.225,36.55),(52.055,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((52.395,36.55),(52.395,36.72),(52.565,36.72),(52.565,36.55),(52.395,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((52.735,36.55),(52.735,36.72),(52.905,36.72),(52.905,36.55),(52.735,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((53.075,36.55),(53.075,36.72),(53.245,36.72),(53.245,36.55),(53.075,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((53.415,36.55),(53.415,36.72),(53.585,36.72),(53.585,36.55),(53.415,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((53.755,36.55),(53.755,36.72),(53.925,36.72),(53.925,36.55),(53.755,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((54.095,36.55),(54.095,36.72),(54.265,36.72),(54.265,36.55),(54.095,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((54.435,36.55),(54.435,36.72),(54.605,36.72),(54.605,36.55),(54.435,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((54.775,36.55),(54.775,36.72),(54.945,36.72),(54.945,36.55),(54.775,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((55.115,36.55),(55.115,36.72),(55.285,36.72),(55.285,36.55),(55.115,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((55.455,36.55),(55.455,36.72),(55.625,36.72),(55.625,36.55),(55.455,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((55.795,36.55),(55.795,36.72),(55.965,36.72),(55.965,36.55),(55.795,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((56.135,36.55),(56.135,36.72),(56.305,36.72),(56.305,36.55),(56.135,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((56.475,36.55),(56.475,36.72),(56.645,36.72),(56.645,36.55),(56.475,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((56.815,36.55),(56.815,36.72),(56.985,36.72),(56.985,36.55),(56.815,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((57.155,36.55),(57.155,36.72),(57.325,36.72),(57.325,36.55),(57.155,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((57.495,36.55),(57.495,36.72),(57.665,36.72),(57.665,36.55),(57.495,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((57.835,36.55),(57.835,36.72),(58.005,36.72),(58.005,36.55),(57.835,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,36.55),(58.175,36.72),(58.345,36.72),(58.345,36.55),(58.175,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((58.515,36.55),(58.515,36.72),(58.685,36.72),(58.685,36.55),(58.515,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((58.855,36.55),(58.855,36.72),(59.025,36.72),(59.025,36.55),(58.855,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((59.195,36.55),(59.195,36.72),(59.365,36.72),(59.365,36.55),(59.195,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((59.535,36.55),(59.535,36.72),(59.705,36.72),(59.705,36.55),(59.535,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((59.875,36.55),(59.875,36.72),(60.045,36.72),(60.045,36.55),(59.875,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((60.215,36.55),(60.215,36.72),(60.385,36.72),(60.385,36.55),(60.215,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((60.555,36.55),(60.555,36.72),(60.725,36.72),(60.725,36.55),(60.555,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((60.895,36.55),(60.895,36.72),(61.065,36.72),(61.065,36.55),(60.895,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((61.235,36.55),(61.235,36.72),(61.405,36.72),(61.405,36.55),(61.235,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((61.575,36.55),(61.575,36.72),(61.745,36.72),(61.745,36.55),(61.575,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((61.915,36.55),(61.915,36.72),(62.085,36.72),(62.085,36.55),(61.915,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((62.255,36.55),(62.255,36.72),(62.425,36.72),(62.425,36.55),(62.255,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((62.595,36.55),(62.595,36.72),(62.765,36.72),(62.765,36.55),(62.595,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((62.935,36.55),(62.935,36.72),(63.105,36.72),(63.105,36.55),(62.935,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((63.275,36.55),(63.275,36.72),(63.445,36.72),(63.445,36.55),(63.275,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((63.615,36.55),(63.615,36.72),(63.785,36.72),(63.785,36.55),(63.615,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((63.955,36.55),(63.955,36.72),(64.125,36.72),(64.125,36.55),(63.955,36.55)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,6.64),(16.865,6.81),(17.035,6.81),(17.035,6.64),(16.865,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,6.64),(17.205,6.81),(17.375,6.81),(17.375,6.64),(17.205,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,6.64),(17.545,6.81),(17.715,6.81),(17.715,6.64),(17.545,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,6.64),(17.885,6.81),(18.055,6.81),(18.055,6.64),(17.885,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,6.64),(18.225,6.81),(18.395,6.81),(18.395,6.64),(18.225,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,6.64),(18.565,6.81),(18.735,6.81),(18.735,6.64),(18.565,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,6.64),(18.905,6.81),(19.075,6.81),(19.075,6.64),(18.905,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,6.64),(19.245,6.81),(19.415,6.81),(19.415,6.64),(19.245,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,6.64),(19.585,6.81),(19.755,6.81),(19.755,6.64),(19.585,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,6.64),(19.925,6.81),(20.095,6.81),(20.095,6.64),(19.925,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,6.64),(20.265,6.81),(20.435,6.81),(20.435,6.64),(20.265,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,6.64),(20.605,6.81),(20.775,6.81),(20.775,6.64),(20.605,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,6.64),(20.945,6.81),(21.115,6.81),(21.115,6.64),(20.945,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,6.64),(21.285,6.81),(21.455,6.81),(21.455,6.64),(21.285,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,6.64),(21.625,6.81),(21.795,6.81),(21.795,6.64),(21.625,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,6.64),(21.965,6.81),(22.135,6.81),(22.135,6.64),(21.965,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,6.64),(22.305,6.81),(22.475,6.81),(22.475,6.64),(22.305,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,6.64),(22.645,6.81),(22.815,6.81),(22.815,6.64),(22.645,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,6.64),(22.985,6.81),(23.155,6.81),(23.155,6.64),(22.985,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,6.64),(23.325,6.81),(23.495,6.81),(23.495,6.64),(23.325,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,6.64),(23.665,6.81),(23.835,6.81),(23.835,6.64),(23.665,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,6.64),(24.005,6.81),(24.175,6.81),(24.175,6.64),(24.005,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,6.64),(24.345,6.81),(24.515,6.81),(24.515,6.64),(24.345,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,6.64),(24.685,6.81),(24.855,6.81),(24.855,6.64),(24.685,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,6.64),(25.025,6.81),(25.195,6.81),(25.195,6.64),(25.025,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,6.64),(25.365,6.81),(25.535,6.81),(25.535,6.64),(25.365,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,6.64),(25.705,6.81),(25.875,6.81),(25.875,6.64),(25.705,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,6.64),(26.045,6.81),(26.215,6.81),(26.215,6.64),(26.045,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,6.64),(26.385,6.81),(26.555,6.81),(26.555,6.64),(26.385,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,6.64),(26.725,6.81),(26.895,6.81),(26.895,6.64),(26.725,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,6.64),(27.065,6.81),(27.235,6.81),(27.235,6.64),(27.065,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,6.64),(27.405,6.81),(27.575,6.81),(27.575,6.64),(27.405,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,6.64),(27.745,6.81),(27.915,6.81),(27.915,6.64),(27.745,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,6.64),(28.085,6.81),(28.255,6.81),(28.255,6.64),(28.085,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,6.64),(28.425,6.81),(28.595,6.81),(28.595,6.64),(28.425,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,6.64),(28.765,6.81),(28.935,6.81),(28.935,6.64),(28.765,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,6.64),(29.105,6.81),(29.275,6.81),(29.275,6.64),(29.105,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,6.64),(29.445,6.81),(29.615,6.81),(29.615,6.64),(29.445,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,6.64),(29.785,6.81),(29.955,6.81),(29.955,6.64),(29.785,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,6.64),(30.125,6.81),(30.295,6.81),(30.295,6.64),(30.125,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,6.64),(30.465,6.81),(30.635,6.81),(30.635,6.64),(30.465,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,6.64),(30.805,6.81),(30.975,6.81),(30.975,6.64),(30.805,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,6.64),(31.145,6.81),(31.315,6.81),(31.315,6.64),(31.145,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,6.64),(31.485,6.81),(31.655,6.81),(31.655,6.64),(31.485,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,6.64),(31.825,6.81),(31.995,6.81),(31.995,6.64),(31.825,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,6.64),(32.165,6.81),(32.335,6.81),(32.335,6.64),(32.165,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,6.64),(32.505,6.81),(32.675,6.81),(32.675,6.64),(32.505,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,6.64),(32.845,6.81),(33.015,6.81),(33.015,6.64),(32.845,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,6.64),(33.185,6.81),(33.355,6.81),(33.355,6.64),(33.185,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,6.64),(33.525,6.81),(33.695,6.81),(33.695,6.64),(33.525,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,6.64),(33.865,6.81),(34.035,6.81),(34.035,6.64),(33.865,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,6.64),(34.205,6.81),(34.375,6.81),(34.375,6.64),(34.205,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,6.64),(34.545,6.81),(34.715,6.81),(34.715,6.64),(34.545,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,6.64),(34.885,6.81),(35.055,6.81),(35.055,6.64),(34.885,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,6.64),(35.225,6.81),(35.395,6.81),(35.395,6.64),(35.225,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,6.64),(35.565,6.81),(35.735,6.81),(35.735,6.64),(35.565,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,6.64),(35.905,6.81),(36.075,6.81),(36.075,6.64),(35.905,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,6.64),(36.245,6.81),(36.415,6.81),(36.415,6.64),(36.245,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,6.64),(36.585,6.81),(36.755,6.81),(36.755,6.64),(36.585,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,6.64),(36.925,6.81),(37.095,6.81),(37.095,6.64),(36.925,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,6.64),(37.265,6.81),(37.435,6.81),(37.435,6.64),(37.265,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,6.64),(37.605,6.81),(37.775,6.81),(37.775,6.64),(37.605,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,6.64),(37.945,6.81),(38.115,6.81),(38.115,6.64),(37.945,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,6.64),(38.285,6.81),(38.455,6.81),(38.455,6.64),(38.285,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,6.64),(38.625,6.81),(38.795,6.81),(38.795,6.64),(38.625,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,6.64),(38.965,6.81),(39.135,6.81),(39.135,6.64),(38.965,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,6.64),(39.305,6.81),(39.475,6.81),(39.475,6.64),(39.305,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,6.64),(39.645,6.81),(39.815,6.81),(39.815,6.64),(39.645,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,6.64),(39.985,6.81),(40.155,6.81),(40.155,6.64),(39.985,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,6.64),(40.325,6.81),(40.495,6.81),(40.495,6.64),(40.325,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,6.64),(40.665,6.81),(40.835,6.81),(40.835,6.64),(40.665,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,6.64),(41.005,6.81),(41.175,6.81),(41.175,6.64),(41.005,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,6.64),(41.345,6.81),(41.515,6.81),(41.515,6.64),(41.345,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,6.64),(41.685,6.81),(41.855,6.81),(41.855,6.64),(41.685,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,6.64),(42.025,6.81),(42.195,6.81),(42.195,6.64),(42.025,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,6.64),(42.365,6.81),(42.535,6.81),(42.535,6.64),(42.365,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,6.64),(42.705,6.81),(42.875,6.81),(42.875,6.64),(42.705,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,6.64),(43.045,6.81),(43.215,6.81),(43.215,6.64),(43.045,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,6.64),(43.385,6.81),(43.555,6.81),(43.555,6.64),(43.385,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,6.64),(43.725,6.81),(43.895,6.81),(43.895,6.64),(43.725,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,6.64),(44.065,6.81),(44.235,6.81),(44.235,6.64),(44.065,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.64),(44.405,6.81),(44.575,6.81),(44.575,6.64),(44.405,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,6.64),(44.745,6.81),(44.915,6.81),(44.915,6.64),(44.745,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,6.64),(45.085,6.81),(45.255,6.81),(45.255,6.64),(45.085,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.64),(45.425,6.81),(45.595,6.81),(45.595,6.64),(45.425,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,6.64),(45.765,6.81),(45.935,6.81),(45.935,6.64),(45.765,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,6.64),(46.105,6.81),(46.275,6.81),(46.275,6.64),(46.105,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,6.64),(46.445,6.81),(46.615,6.81),(46.615,6.64),(46.445,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,6.64),(46.785,6.81),(46.955,6.81),(46.955,6.64),(46.785,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,6.64),(47.125,6.81),(47.295,6.81),(47.295,6.64),(47.125,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,6.64),(47.465,6.81),(47.635,6.81),(47.635,6.64),(47.465,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,6.64),(47.805,6.81),(47.975,6.81),(47.975,6.64),(47.805,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,6.64),(48.145,6.81),(48.315,6.81),(48.315,6.64),(48.145,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,6.64),(48.485,6.81),(48.655,6.81),(48.655,6.64),(48.485,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,6.64),(48.825,6.81),(48.995,6.81),(48.995,6.64),(48.825,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,6.64),(49.165,6.81),(49.335,6.81),(49.335,6.64),(49.165,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,6.64),(49.505,6.81),(49.675,6.81),(49.675,6.64),(49.505,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,6.64),(49.845,6.81),(50.015,6.81),(50.015,6.64),(49.845,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,6.64),(50.185,6.81),(50.355,6.81),(50.355,6.64),(50.185,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,6.64),(50.525,6.81),(50.695,6.81),(50.695,6.64),(50.525,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,6.64),(50.865,6.81),(51.035,6.81),(51.035,6.64),(50.865,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,6.64),(51.205,6.81),(51.375,6.81),(51.375,6.64),(51.205,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,6.64),(51.545,6.81),(51.715,6.81),(51.715,6.64),(51.545,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,6.64),(51.885,6.81),(52.055,6.81),(52.055,6.64),(51.885,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,6.64),(52.225,6.81),(52.395,6.81),(52.395,6.64),(52.225,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,6.64),(52.565,6.81),(52.735,6.81),(52.735,6.64),(52.565,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,6.64),(52.905,6.81),(53.075,6.81),(53.075,6.64),(52.905,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,6.64),(53.245,6.81),(53.415,6.81),(53.415,6.64),(53.245,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,6.64),(53.585,6.81),(53.755,6.81),(53.755,6.64),(53.585,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,6.64),(53.925,6.81),(54.095,6.81),(54.095,6.64),(53.925,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,6.64),(54.265,6.81),(54.435,6.81),(54.435,6.64),(54.265,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,6.64),(54.605,6.81),(54.775,6.81),(54.775,6.64),(54.605,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,6.64),(54.945,6.81),(55.115,6.81),(55.115,6.64),(54.945,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,6.64),(55.285,6.81),(55.455,6.81),(55.455,6.64),(55.285,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,6.64),(55.625,6.81),(55.795,6.81),(55.795,6.64),(55.625,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,6.64),(55.965,6.81),(56.135,6.81),(56.135,6.64),(55.965,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,6.64),(56.305,6.81),(56.475,6.81),(56.475,6.64),(56.305,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,6.64),(56.645,6.81),(56.815,6.81),(56.815,6.64),(56.645,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,6.64),(56.985,6.81),(57.155,6.81),(57.155,6.64),(56.985,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,6.64),(57.325,6.81),(57.495,6.81),(57.495,6.64),(57.325,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,6.64),(57.665,6.81),(57.835,6.81),(57.835,6.64),(57.665,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,6.64),(58.005,6.81),(58.175,6.81),(58.175,6.64),(58.005,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,6.64),(58.345,6.81),(58.515,6.81),(58.515,6.64),(58.345,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,6.64),(58.685,6.81),(58.855,6.81),(58.855,6.64),(58.685,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,6.64),(59.025,6.81),(59.195,6.81),(59.195,6.64),(59.025,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,6.64),(59.365,6.81),(59.535,6.81),(59.535,6.64),(59.365,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,6.64),(59.705,6.81),(59.875,6.81),(59.875,6.64),(59.705,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,6.64),(60.045,6.81),(60.215,6.81),(60.215,6.64),(60.045,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,6.64),(60.385,6.81),(60.555,6.81),(60.555,6.64),(60.385,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,6.64),(60.725,6.81),(60.895,6.81),(60.895,6.64),(60.725,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,6.64),(61.065,6.81),(61.235,6.81),(61.235,6.64),(61.065,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,6.64),(61.405,6.81),(61.575,6.81),(61.575,6.64),(61.405,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,6.64),(61.745,6.81),(61.915,6.81),(61.915,6.64),(61.745,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,6.64),(62.085,6.81),(62.255,6.81),(62.255,6.64),(62.085,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,6.64),(62.425,6.81),(62.595,6.81),(62.595,6.64),(62.425,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,6.64),(62.765,6.81),(62.935,6.81),(62.935,6.64),(62.765,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,6.64),(63.105,6.81),(63.275,6.81),(63.275,6.64),(63.105,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,6.64),(63.445,6.81),(63.615,6.81),(63.615,6.64),(63.445,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,6.64),(63.785,6.81),(63.955,6.81),(63.955,6.64),(63.785,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,6.64),(64.125,6.81),(64.295,6.81),(64.295,6.64),(64.125,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,6.64),(64.465,6.81),(64.635,6.81),(64.635,6.64),(64.465,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,6.64),(64.805,6.81),(64.975,6.81),(64.975,6.64),(64.805,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,6.64),(65.145,6.81),(65.315,6.81),(65.315,6.64),(65.145,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,6.64),(65.485,6.81),(65.655,6.81),(65.655,6.64),(65.485,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,6.64),(65.825,6.81),(65.995,6.81),(65.995,6.64),(65.825,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,6.64),(66.165,6.81),(66.335,6.81),(66.335,6.64),(66.165,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,6.64),(66.505,6.81),(66.675,6.81),(66.675,6.64),(66.505,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,6.64),(66.845,6.81),(67.015,6.81),(67.015,6.64),(66.845,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,6.64),(67.185,6.81),(67.355,6.81),(67.355,6.64),(67.185,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,6.64),(67.525,6.81),(67.695,6.81),(67.695,6.64),(67.525,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,6.64),(67.865,6.81),(68.035,6.81),(68.035,6.64),(67.865,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,6.64),(68.205,6.81),(68.375,6.81),(68.375,6.64),(68.205,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,6.64),(68.545,6.81),(68.715,6.81),(68.715,6.64),(68.545,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,6.64),(68.885,6.81),(69.055,6.81),(69.055,6.64),(68.885,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,6.64),(69.225,6.81),(69.395,6.81),(69.395,6.64),(69.225,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,6.64),(69.565,6.81),(69.735,6.81),(69.735,6.64),(69.565,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,6.64),(69.905,6.81),(70.075,6.81),(70.075,6.64),(69.905,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,6.64),(70.245,6.81),(70.415,6.81),(70.415,6.64),(70.245,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,6.64),(70.585,6.81),(70.755,6.81),(70.755,6.64),(70.585,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,6.64),(70.925,6.81),(71.095,6.81),(71.095,6.64),(70.925,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,6.64),(71.265,6.81),(71.435,6.81),(71.435,6.64),(71.265,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,6.64),(71.605,6.81),(71.775,6.81),(71.775,6.64),(71.605,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,6.64),(71.945,6.81),(72.115,6.81),(72.115,6.64),(71.945,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,6.64),(72.285,6.81),(72.455,6.81),(72.455,6.64),(72.285,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,6.64),(72.625,6.81),(72.795,6.81),(72.795,6.64),(72.625,6.64)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,6.64),(72.965,6.81),(73.135,6.81),(73.135,6.64),(72.965,6.64)),
        )
        createRL(
            tech, net, 'li',
            ((25.64,36.565),(25.64,36.735),(64.36,36.735),(64.36,36.565),(25.64,36.565)),
        )
        createRL(
            tech, net, 'li',
            ((25.64,36.55),(25.64,36.72),(64.36,36.72),(64.36,36.55),(25.64,36.55)),
        )
        createRL(
            tech, net, 'li',
            ((16.71,6.64),(16.71,6.81),(73.29,6.81),(73.29,6.64),(16.71,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.835,36.565),(25.835,36.735),(26.005,36.735),(26.005,36.565),(25.835,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,36.565),(26.195,36.735),(26.365,36.735),(26.365,36.565),(26.195,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.555,36.565),(26.555,36.735),(26.725,36.735),(26.725,36.565),(26.555,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.915,36.565),(26.915,36.735),(27.085,36.735),(27.085,36.565),(26.915,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.275,36.565),(27.275,36.735),(27.445,36.735),(27.445,36.565),(27.275,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.635,36.565),(27.635,36.735),(27.805,36.735),(27.805,36.565),(27.635,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.995,36.565),(27.995,36.735),(28.165,36.735),(28.165,36.565),(27.995,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.355,36.565),(28.355,36.735),(28.525,36.735),(28.525,36.565),(28.355,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.715,36.565),(28.715,36.735),(28.885,36.735),(28.885,36.565),(28.715,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.075,36.565),(29.075,36.735),(29.245,36.735),(29.245,36.565),(29.075,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.435,36.565),(29.435,36.735),(29.605,36.735),(29.605,36.565),(29.435,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.795,36.565),(29.795,36.735),(29.965,36.735),(29.965,36.565),(29.795,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.155,36.565),(30.155,36.735),(30.325,36.735),(30.325,36.565),(30.155,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,36.565),(30.515,36.735),(30.685,36.735),(30.685,36.565),(30.515,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,36.565),(30.875,36.735),(31.045,36.735),(31.045,36.565),(30.875,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.235,36.565),(31.235,36.735),(31.405,36.735),(31.405,36.565),(31.235,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.595,36.565),(31.595,36.735),(31.765,36.735),(31.765,36.565),(31.595,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.955,36.565),(31.955,36.735),(32.125,36.735),(32.125,36.565),(31.955,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.315,36.565),(32.315,36.735),(32.485,36.735),(32.485,36.565),(32.315,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.675,36.565),(32.675,36.735),(32.845,36.735),(32.845,36.565),(32.675,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.035,36.565),(33.035,36.735),(33.205,36.735),(33.205,36.565),(33.035,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.395,36.565),(33.395,36.735),(33.565,36.735),(33.565,36.565),(33.395,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.755,36.565),(33.755,36.735),(33.925,36.735),(33.925,36.565),(33.755,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.115,36.565),(34.115,36.735),(34.285,36.735),(34.285,36.565),(34.115,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.475,36.565),(34.475,36.735),(34.645,36.735),(34.645,36.565),(34.475,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.835,36.565),(34.835,36.735),(35.005,36.735),(35.005,36.565),(34.835,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.195,36.565),(35.195,36.735),(35.365,36.735),(35.365,36.565),(35.195,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,36.565),(35.555,36.735),(35.725,36.735),(35.725,36.565),(35.555,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.915,36.565),(35.915,36.735),(36.085,36.735),(36.085,36.565),(35.915,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.275,36.565),(36.275,36.735),(36.445,36.735),(36.445,36.565),(36.275,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.635,36.565),(36.635,36.735),(36.805,36.735),(36.805,36.565),(36.635,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.995,36.565),(36.995,36.735),(37.165,36.735),(37.165,36.565),(36.995,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.355,36.565),(37.355,36.735),(37.525,36.735),(37.525,36.565),(37.355,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.715,36.565),(37.715,36.735),(37.885,36.735),(37.885,36.565),(37.715,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.075,36.565),(38.075,36.735),(38.245,36.735),(38.245,36.565),(38.075,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.435,36.565),(38.435,36.735),(38.605,36.735),(38.605,36.565),(38.435,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.795,36.565),(38.795,36.735),(38.965,36.735),(38.965,36.565),(38.795,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.155,36.565),(39.155,36.735),(39.325,36.735),(39.325,36.565),(39.155,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.515,36.565),(39.515,36.735),(39.685,36.735),(39.685,36.565),(39.515,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.875,36.565),(39.875,36.735),(40.045,36.735),(40.045,36.565),(39.875,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,36.565),(40.235,36.735),(40.405,36.735),(40.405,36.565),(40.235,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.595,36.565),(40.595,36.735),(40.765,36.735),(40.765,36.565),(40.595,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.955,36.565),(40.955,36.735),(41.125,36.735),(41.125,36.565),(40.955,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.315,36.565),(41.315,36.735),(41.485,36.735),(41.485,36.565),(41.315,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.675,36.565),(41.675,36.735),(41.845,36.735),(41.845,36.565),(41.675,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.035,36.565),(42.035,36.735),(42.205,36.735),(42.205,36.565),(42.035,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.395,36.565),(42.395,36.735),(42.565,36.735),(42.565,36.565),(42.395,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.755,36.565),(42.755,36.735),(42.925,36.735),(42.925,36.565),(42.755,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.115,36.565),(43.115,36.735),(43.285,36.735),(43.285,36.565),(43.115,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.475,36.565),(43.475,36.735),(43.645,36.735),(43.645,36.565),(43.475,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.835,36.565),(43.835,36.735),(44.005,36.735),(44.005,36.565),(43.835,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.195,36.565),(44.195,36.735),(44.365,36.735),(44.365,36.565),(44.195,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.555,36.565),(44.555,36.735),(44.725,36.735),(44.725,36.565),(44.555,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.565),(44.915,36.735),(45.085,36.735),(45.085,36.565),(44.915,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.275,36.565),(45.275,36.735),(45.445,36.735),(45.445,36.565),(45.275,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.635,36.565),(45.635,36.735),(45.805,36.735),(45.805,36.565),(45.635,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.995,36.565),(45.995,36.735),(46.165,36.735),(46.165,36.565),(45.995,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.355,36.565),(46.355,36.735),(46.525,36.735),(46.525,36.565),(46.355,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.715,36.565),(46.715,36.735),(46.885,36.735),(46.885,36.565),(46.715,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.075,36.565),(47.075,36.735),(47.245,36.735),(47.245,36.565),(47.075,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.435,36.565),(47.435,36.735),(47.605,36.735),(47.605,36.565),(47.435,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.795,36.565),(47.795,36.735),(47.965,36.735),(47.965,36.565),(47.795,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.155,36.565),(48.155,36.735),(48.325,36.735),(48.325,36.565),(48.155,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.515,36.565),(48.515,36.735),(48.685,36.735),(48.685,36.565),(48.515,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.875,36.565),(48.875,36.735),(49.045,36.735),(49.045,36.565),(48.875,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.235,36.565),(49.235,36.735),(49.405,36.735),(49.405,36.565),(49.235,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,36.565),(49.595,36.735),(49.765,36.735),(49.765,36.565),(49.595,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.955,36.565),(49.955,36.735),(50.125,36.735),(50.125,36.565),(49.955,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.315,36.565),(50.315,36.735),(50.485,36.735),(50.485,36.565),(50.315,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.675,36.565),(50.675,36.735),(50.845,36.735),(50.845,36.565),(50.675,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.035,36.565),(51.035,36.735),(51.205,36.735),(51.205,36.565),(51.035,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.395,36.565),(51.395,36.735),(51.565,36.735),(51.565,36.565),(51.395,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.755,36.565),(51.755,36.735),(51.925,36.735),(51.925,36.565),(51.755,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.115,36.565),(52.115,36.735),(52.285,36.735),(52.285,36.565),(52.115,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.475,36.565),(52.475,36.735),(52.645,36.735),(52.645,36.565),(52.475,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.835,36.565),(52.835,36.735),(53.005,36.735),(53.005,36.565),(52.835,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.195,36.565),(53.195,36.735),(53.365,36.735),(53.365,36.565),(53.195,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.555,36.565),(53.555,36.735),(53.725,36.735),(53.725,36.565),(53.555,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.915,36.565),(53.915,36.735),(54.085,36.735),(54.085,36.565),(53.915,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,36.565),(54.275,36.735),(54.445,36.735),(54.445,36.565),(54.275,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.635,36.565),(54.635,36.735),(54.805,36.735),(54.805,36.565),(54.635,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.995,36.565),(54.995,36.735),(55.165,36.735),(55.165,36.565),(54.995,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.355,36.565),(55.355,36.735),(55.525,36.735),(55.525,36.565),(55.355,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.715,36.565),(55.715,36.735),(55.885,36.735),(55.885,36.565),(55.715,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.075,36.565),(56.075,36.735),(56.245,36.735),(56.245,36.565),(56.075,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.435,36.565),(56.435,36.735),(56.605,36.735),(56.605,36.565),(56.435,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.795,36.565),(56.795,36.735),(56.965,36.735),(56.965,36.565),(56.795,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.155,36.565),(57.155,36.735),(57.325,36.735),(57.325,36.565),(57.155,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.515,36.565),(57.515,36.735),(57.685,36.735),(57.685,36.565),(57.515,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.875,36.565),(57.875,36.735),(58.045,36.735),(58.045,36.565),(57.875,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.235,36.565),(58.235,36.735),(58.405,36.735),(58.405,36.565),(58.235,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.595,36.565),(58.595,36.735),(58.765,36.735),(58.765,36.565),(58.595,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,36.565),(58.955,36.735),(59.125,36.735),(59.125,36.565),(58.955,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,36.565),(59.315,36.735),(59.485,36.735),(59.485,36.565),(59.315,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.675,36.565),(59.675,36.735),(59.845,36.735),(59.845,36.565),(59.675,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.035,36.565),(60.035,36.735),(60.205,36.735),(60.205,36.565),(60.035,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.395,36.565),(60.395,36.735),(60.565,36.735),(60.565,36.565),(60.395,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.755,36.565),(60.755,36.735),(60.925,36.735),(60.925,36.565),(60.755,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.115,36.565),(61.115,36.735),(61.285,36.735),(61.285,36.565),(61.115,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.475,36.565),(61.475,36.735),(61.645,36.735),(61.645,36.565),(61.475,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.835,36.565),(61.835,36.735),(62.005,36.735),(62.005,36.565),(61.835,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.195,36.565),(62.195,36.735),(62.365,36.735),(62.365,36.565),(62.195,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.555,36.565),(62.555,36.735),(62.725,36.735),(62.725,36.565),(62.555,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.915,36.565),(62.915,36.735),(63.085,36.735),(63.085,36.565),(62.915,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.275,36.565),(63.275,36.735),(63.445,36.735),(63.445,36.565),(63.275,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,36.565),(63.635,36.735),(63.805,36.735),(63.805,36.565),(63.635,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.995,36.565),(63.995,36.735),(64.165,36.735),(64.165,36.565),(63.995,36.565)),
        )
        createRL(
            tech, net, 'mcon',
            ((16.835,6.64),(16.835,6.81),(17.005,6.81),(17.005,6.64),(16.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.195,6.64),(17.195,6.81),(17.365,6.81),(17.365,6.64),(17.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.555,6.64),(17.555,6.81),(17.725,6.81),(17.725,6.64),(17.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((17.915,6.64),(17.915,6.81),(18.085,6.81),(18.085,6.64),(17.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.275,6.64),(18.275,6.81),(18.445,6.81),(18.445,6.64),(18.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.635,6.64),(18.635,6.81),(18.805,6.81),(18.805,6.64),(18.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((18.995,6.64),(18.995,6.81),(19.165,6.81),(19.165,6.64),(18.995,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.355,6.64),(19.355,6.81),(19.525,6.81),(19.525,6.64),(19.355,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((19.715,6.64),(19.715,6.81),(19.885,6.81),(19.885,6.64),(19.715,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.075,6.64),(20.075,6.81),(20.245,6.81),(20.245,6.64),(20.075,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.435,6.64),(20.435,6.81),(20.605,6.81),(20.605,6.64),(20.435,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((20.795,6.64),(20.795,6.81),(20.965,6.81),(20.965,6.64),(20.795,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((21.155,6.64),(21.155,6.81),(21.325,6.81),(21.325,6.64),(21.155,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((21.515,6.64),(21.515,6.81),(21.685,6.81),(21.685,6.64),(21.515,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((21.875,6.64),(21.875,6.81),(22.045,6.81),(22.045,6.64),(21.875,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.235,6.64),(22.235,6.81),(22.405,6.81),(22.405,6.64),(22.235,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.595,6.64),(22.595,6.81),(22.765,6.81),(22.765,6.64),(22.595,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((22.955,6.64),(22.955,6.81),(23.125,6.81),(23.125,6.64),(22.955,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.315,6.64),(23.315,6.81),(23.485,6.81),(23.485,6.64),(23.315,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((23.675,6.64),(23.675,6.81),(23.845,6.81),(23.845,6.64),(23.675,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((24.035,6.64),(24.035,6.81),(24.205,6.81),(24.205,6.64),(24.035,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((24.395,6.64),(24.395,6.81),(24.565,6.81),(24.565,6.64),(24.395,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((24.755,6.64),(24.755,6.81),(24.925,6.81),(24.925,6.64),(24.755,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.115,6.64),(25.115,6.81),(25.285,6.81),(25.285,6.64),(25.115,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.475,6.64),(25.475,6.81),(25.645,6.81),(25.645,6.64),(25.475,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((25.835,6.64),(25.835,6.81),(26.005,6.81),(26.005,6.64),(25.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,6.64),(26.195,6.81),(26.365,6.81),(26.365,6.64),(26.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.555,6.64),(26.555,6.81),(26.725,6.81),(26.725,6.64),(26.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.915,6.64),(26.915,6.81),(27.085,6.81),(27.085,6.64),(26.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.275,6.64),(27.275,6.81),(27.445,6.81),(27.445,6.64),(27.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.635,6.64),(27.635,6.81),(27.805,6.81),(27.805,6.64),(27.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.995,6.64),(27.995,6.81),(28.165,6.81),(28.165,6.64),(27.995,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.355,6.64),(28.355,6.81),(28.525,6.81),(28.525,6.64),(28.355,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((28.715,6.64),(28.715,6.81),(28.885,6.81),(28.885,6.64),(28.715,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.075,6.64),(29.075,6.81),(29.245,6.81),(29.245,6.64),(29.075,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.435,6.64),(29.435,6.81),(29.605,6.81),(29.605,6.64),(29.435,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.795,6.64),(29.795,6.81),(29.965,6.81),(29.965,6.64),(29.795,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.155,6.64),(30.155,6.81),(30.325,6.81),(30.325,6.64),(30.155,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.515,6.64),(30.515,6.81),(30.685,6.81),(30.685,6.64),(30.515,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,6.64),(30.875,6.81),(31.045,6.81),(31.045,6.64),(30.875,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.235,6.64),(31.235,6.81),(31.405,6.81),(31.405,6.64),(31.235,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.595,6.64),(31.595,6.81),(31.765,6.81),(31.765,6.64),(31.595,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((31.955,6.64),(31.955,6.81),(32.125,6.81),(32.125,6.64),(31.955,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.315,6.64),(32.315,6.81),(32.485,6.81),(32.485,6.64),(32.315,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.675,6.64),(32.675,6.81),(32.845,6.81),(32.845,6.64),(32.675,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.035,6.64),(33.035,6.81),(33.205,6.81),(33.205,6.64),(33.035,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.395,6.64),(33.395,6.81),(33.565,6.81),(33.565,6.64),(33.395,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.755,6.64),(33.755,6.81),(33.925,6.81),(33.925,6.64),(33.755,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.115,6.64),(34.115,6.81),(34.285,6.81),(34.285,6.64),(34.115,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.475,6.64),(34.475,6.81),(34.645,6.81),(34.645,6.64),(34.475,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((34.835,6.64),(34.835,6.81),(35.005,6.81),(35.005,6.64),(34.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.195,6.64),(35.195,6.81),(35.365,6.81),(35.365,6.64),(35.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,6.64),(35.555,6.81),(35.725,6.81),(35.725,6.64),(35.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.915,6.64),(35.915,6.81),(36.085,6.81),(36.085,6.64),(35.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.275,6.64),(36.275,6.81),(36.445,6.81),(36.445,6.64),(36.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.635,6.64),(36.635,6.81),(36.805,6.81),(36.805,6.64),(36.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((36.995,6.64),(36.995,6.81),(37.165,6.81),(37.165,6.64),(36.995,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.355,6.64),(37.355,6.81),(37.525,6.81),(37.525,6.64),(37.355,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.715,6.64),(37.715,6.81),(37.885,6.81),(37.885,6.64),(37.715,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.075,6.64),(38.075,6.81),(38.245,6.81),(38.245,6.64),(38.075,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.435,6.64),(38.435,6.81),(38.605,6.81),(38.605,6.64),(38.435,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.795,6.64),(38.795,6.81),(38.965,6.81),(38.965,6.64),(38.795,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.155,6.64),(39.155,6.81),(39.325,6.81),(39.325,6.64),(39.155,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.515,6.64),(39.515,6.81),(39.685,6.81),(39.685,6.64),(39.515,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((39.875,6.64),(39.875,6.81),(40.045,6.81),(40.045,6.64),(39.875,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,6.64),(40.235,6.81),(40.405,6.81),(40.405,6.64),(40.235,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.595,6.64),(40.595,6.81),(40.765,6.81),(40.765,6.64),(40.595,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.955,6.64),(40.955,6.81),(41.125,6.81),(41.125,6.64),(40.955,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.315,6.64),(41.315,6.81),(41.485,6.81),(41.485,6.64),(41.315,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.675,6.64),(41.675,6.81),(41.845,6.81),(41.845,6.64),(41.675,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.035,6.64),(42.035,6.81),(42.205,6.81),(42.205,6.64),(42.035,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.395,6.64),(42.395,6.81),(42.565,6.81),(42.565,6.64),(42.395,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.755,6.64),(42.755,6.81),(42.925,6.81),(42.925,6.64),(42.755,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.115,6.64),(43.115,6.81),(43.285,6.81),(43.285,6.64),(43.115,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.475,6.64),(43.475,6.81),(43.645,6.81),(43.645,6.64),(43.475,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.835,6.64),(43.835,6.81),(44.005,6.81),(44.005,6.64),(43.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.195,6.64),(44.195,6.81),(44.365,6.81),(44.365,6.64),(44.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.555,6.64),(44.555,6.81),(44.725,6.81),(44.725,6.64),(44.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.64),(44.915,6.81),(45.085,6.81),(45.085,6.64),(44.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.275,6.64),(45.275,6.81),(45.445,6.81),(45.445,6.64),(45.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.635,6.64),(45.635,6.81),(45.805,6.81),(45.805,6.64),(45.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((45.995,6.64),(45.995,6.81),(46.165,6.81),(46.165,6.64),(45.995,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.355,6.64),(46.355,6.81),(46.525,6.81),(46.525,6.64),(46.355,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.715,6.64),(46.715,6.81),(46.885,6.81),(46.885,6.64),(46.715,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.075,6.64),(47.075,6.81),(47.245,6.81),(47.245,6.64),(47.075,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.435,6.64),(47.435,6.81),(47.605,6.81),(47.605,6.64),(47.435,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.795,6.64),(47.795,6.81),(47.965,6.81),(47.965,6.64),(47.795,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.155,6.64),(48.155,6.81),(48.325,6.81),(48.325,6.64),(48.155,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.515,6.64),(48.515,6.81),(48.685,6.81),(48.685,6.64),(48.515,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.875,6.64),(48.875,6.81),(49.045,6.81),(49.045,6.64),(48.875,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.235,6.64),(49.235,6.81),(49.405,6.81),(49.405,6.64),(49.235,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,6.64),(49.595,6.81),(49.765,6.81),(49.765,6.64),(49.595,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.955,6.64),(49.955,6.81),(50.125,6.81),(50.125,6.64),(49.955,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.315,6.64),(50.315,6.81),(50.485,6.81),(50.485,6.64),(50.315,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((50.675,6.64),(50.675,6.81),(50.845,6.81),(50.845,6.64),(50.675,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.035,6.64),(51.035,6.81),(51.205,6.81),(51.205,6.64),(51.035,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.395,6.64),(51.395,6.81),(51.565,6.81),(51.565,6.64),(51.395,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.755,6.64),(51.755,6.81),(51.925,6.81),(51.925,6.64),(51.755,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.115,6.64),(52.115,6.81),(52.285,6.81),(52.285,6.64),(52.115,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.475,6.64),(52.475,6.81),(52.645,6.81),(52.645,6.64),(52.475,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.835,6.64),(52.835,6.81),(53.005,6.81),(53.005,6.64),(52.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.195,6.64),(53.195,6.81),(53.365,6.81),(53.365,6.64),(53.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.555,6.64),(53.555,6.81),(53.725,6.81),(53.725,6.64),(53.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((53.915,6.64),(53.915,6.81),(54.085,6.81),(54.085,6.64),(53.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,6.64),(54.275,6.81),(54.445,6.81),(54.445,6.64),(54.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.635,6.64),(54.635,6.81),(54.805,6.81),(54.805,6.64),(54.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.995,6.64),(54.995,6.81),(55.165,6.81),(55.165,6.64),(54.995,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.355,6.64),(55.355,6.81),(55.525,6.81),(55.525,6.64),(55.355,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.715,6.64),(55.715,6.81),(55.885,6.81),(55.885,6.64),(55.715,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.075,6.64),(56.075,6.81),(56.245,6.81),(56.245,6.64),(56.075,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.435,6.64),(56.435,6.81),(56.605,6.81),(56.605,6.64),(56.435,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.795,6.64),(56.795,6.81),(56.965,6.81),(56.965,6.64),(56.795,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.155,6.64),(57.155,6.81),(57.325,6.81),(57.325,6.64),(57.155,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.515,6.64),(57.515,6.81),(57.685,6.81),(57.685,6.64),(57.515,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.875,6.64),(57.875,6.81),(58.045,6.81),(58.045,6.64),(57.875,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.235,6.64),(58.235,6.81),(58.405,6.81),(58.405,6.64),(58.235,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.595,6.64),(58.595,6.81),(58.765,6.81),(58.765,6.64),(58.595,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,6.64),(58.955,6.81),(59.125,6.81),(59.125,6.64),(58.955,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.315,6.64),(59.315,6.81),(59.485,6.81),(59.485,6.64),(59.315,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.675,6.64),(59.675,6.81),(59.845,6.81),(59.845,6.64),(59.675,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.035,6.64),(60.035,6.81),(60.205,6.81),(60.205,6.64),(60.035,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.395,6.64),(60.395,6.81),(60.565,6.81),(60.565,6.64),(60.395,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.755,6.64),(60.755,6.81),(60.925,6.81),(60.925,6.64),(60.755,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.115,6.64),(61.115,6.81),(61.285,6.81),(61.285,6.64),(61.115,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.475,6.64),(61.475,6.81),(61.645,6.81),(61.645,6.64),(61.475,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((61.835,6.64),(61.835,6.81),(62.005,6.81),(62.005,6.64),(61.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.195,6.64),(62.195,6.81),(62.365,6.81),(62.365,6.64),(62.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.555,6.64),(62.555,6.81),(62.725,6.81),(62.725,6.64),(62.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.915,6.64),(62.915,6.81),(63.085,6.81),(63.085,6.64),(62.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.275,6.64),(63.275,6.81),(63.445,6.81),(63.445,6.64),(63.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,6.64),(63.635,6.81),(63.805,6.81),(63.805,6.64),(63.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.995,6.64),(63.995,6.81),(64.165,6.81),(64.165,6.64),(63.995,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.355,6.64),(64.355,6.81),(64.525,6.81),(64.525,6.64),(64.355,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((64.715,6.64),(64.715,6.81),(64.885,6.81),(64.885,6.64),(64.715,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.075,6.64),(65.075,6.81),(65.245,6.81),(65.245,6.64),(65.075,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.435,6.64),(65.435,6.81),(65.605,6.81),(65.605,6.64),(65.435,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((65.795,6.64),(65.795,6.81),(65.965,6.81),(65.965,6.64),(65.795,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.155,6.64),(66.155,6.81),(66.325,6.81),(66.325,6.64),(66.155,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.515,6.64),(66.515,6.81),(66.685,6.81),(66.685,6.64),(66.515,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((66.875,6.64),(66.875,6.81),(67.045,6.81),(67.045,6.64),(66.875,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.235,6.64),(67.235,6.81),(67.405,6.81),(67.405,6.64),(67.235,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.595,6.64),(67.595,6.81),(67.765,6.81),(67.765,6.64),(67.595,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((67.955,6.64),(67.955,6.81),(68.125,6.81),(68.125,6.64),(67.955,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.315,6.64),(68.315,6.81),(68.485,6.81),(68.485,6.64),(68.315,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.675,6.64),(68.675,6.81),(68.845,6.81),(68.845,6.64),(68.675,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((69.035,6.64),(69.035,6.81),(69.205,6.81),(69.205,6.64),(69.035,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((69.395,6.64),(69.395,6.81),(69.565,6.81),(69.565,6.64),(69.395,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((69.755,6.64),(69.755,6.81),(69.925,6.81),(69.925,6.64),(69.755,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.115,6.64),(70.115,6.81),(70.285,6.81),(70.285,6.64),(70.115,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.475,6.64),(70.475,6.81),(70.645,6.81),(70.645,6.64),(70.475,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.835,6.64),(70.835,6.81),(71.005,6.81),(71.005,6.64),(70.835,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.195,6.64),(71.195,6.81),(71.365,6.81),(71.365,6.64),(71.195,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.555,6.64),(71.555,6.81),(71.725,6.81),(71.725,6.64),(71.555,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.915,6.64),(71.915,6.81),(72.085,6.81),(72.085,6.64),(71.915,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((72.275,6.64),(72.275,6.81),(72.445,6.81),(72.445,6.64),(72.275,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((72.635,6.64),(72.635,6.81),(72.805,6.81),(72.805,6.64),(72.635,6.64)),
        )
        createRL(
            tech, net, 'mcon',
            ((72.995,6.64),(72.995,6.81),(73.165,6.81),(73.165,6.64),(72.995,6.64)),
        )
        createRL(
            tech, net, 'm1',
            ((16.71,6.61),(16.71,36.765),(25.745,36.765),(25.745,6.61),(16.71,6.61)),
        )
        createRL(
            tech, net, 'm1',
            ((16.71,36.535),(16.71,36.765),(64.36,36.765),(64.36,36.535),(16.71,36.535)),
        )
        createRL(
            tech, net, 'm1',
            ((25.64,36.535),(25.64,36.765),(64.36,36.765),(64.36,36.535),(25.64,36.535)),
        )
        createRL(
            tech, net, 'm1',
            ((16.71,6.61),(16.71,6.84),(73.29,6.84),(73.29,6.61),(16.71,6.61)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(21.2275), u(9.035), u(6.61), u(36.765),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(21.2275), u(9.035), u(6.61), u(36.765),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['out']
        createRL(
            tech, net, 'difftap',
            ((51.13,29.36),(51.13,36.36),(51.38,36.36),(51.38,29.36),(51.13,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.33,29.36),(43.33,36.36),(43.58,36.36),(43.58,29.36),(43.33,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.29,7.0),(73.29,21.0),(73.54,21.0),(73.54,7.0),(73.29,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.275,29.36),(29.275,36.36),(29.525,36.36),(29.525,29.36),(29.275,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.675,29.36),(52.675,36.36),(52.925,36.36),(52.925,29.36),(52.675,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.74,29.36),(41.74,36.36),(41.99,36.36),(41.99,29.36),(41.74,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.185,7.0),(70.185,21.0),(70.435,21.0),(70.435,7.0),(70.185,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.65,29.36),(38.65,36.36),(38.9,36.36),(38.9,29.36),(38.65,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.715,29.36),(27.715,36.36),(27.965,36.36),(27.965,29.36),(27.715,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.7,29.36),(27.7,36.36),(27.95,36.36),(27.95,29.36),(27.7,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.435,29.36),(46.435,36.36),(46.685,36.36),(46.685,29.36),(46.435,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.41,29.36),(32.41,36.36),(32.66,36.36),(32.66,29.36),(32.41,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.01,29.36),(48.01,36.36),(48.26,36.36),(48.26,29.36),(48.01,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.14,29.36),(26.14,36.36),(26.39,36.36),(26.39,29.36),(26.14,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.64,7.0),(68.64,21.0),(68.89,21.0),(68.89,7.0),(68.64,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.98,29.36),(47.98,36.36),(48.23,36.36),(48.23,29.36),(47.98,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.195,29.36),(40.195,36.36),(40.445,36.36),(40.445,29.36),(40.195,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.745,7.0),(71.745,21.0),(71.995,21.0),(71.995,7.0),(71.745,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.77,29.36),(41.77,36.36),(42.02,36.36),(42.02,29.36),(41.77,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,29.36),(54.25,36.36),(54.5,36.36),(54.5,29.36),(54.25,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.66,29.36),(52.66,36.36),(52.91,36.36),(52.91,29.36),(52.66,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.21,29.36),(40.21,36.36),(40.46,36.36),(40.46,29.36),(40.21,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.38,29.36),(32.38,36.36),(32.63,36.36),(32.63,29.36),(32.38,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.69,29.36),(52.69,36.36),(52.94,36.36),(52.94,29.36),(52.69,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.355,29.36),(57.355,36.36),(57.605,36.36),(57.605,29.36),(57.355,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.475,29.36),(60.475,36.36),(60.725,36.36),(60.725,29.36),(60.475,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.955,29.36),(33.955,36.36),(34.205,36.36),(34.205,29.36),(33.955,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.73,29.36),(27.73,36.36),(27.98,36.36),(27.98,29.36),(27.73,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.53,29.36),(35.53,36.36),(35.78,36.36),(35.78,29.36),(35.53,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.17,29.36),(26.17,36.36),(26.42,36.36),(26.42,29.36),(26.17,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.85,29.36),(30.85,36.36),(31.1,36.36),(31.1,29.36),(30.85,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.82,29.36),(30.82,36.36),(31.07,36.36),(31.07,29.36),(30.82,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.795,29.36),(55.795,36.36),(56.045,36.36),(56.045,29.36),(55.795,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.835,29.36),(30.835,36.36),(31.085,36.36),(31.085,29.36),(30.835,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.115,29.36),(51.115,36.36),(51.365,36.36),(51.365,29.36),(51.115,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.62,29.36),(38.62,36.36),(38.87,36.36),(38.87,29.36),(38.62,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.58,29.36),(63.58,36.36),(63.83,36.36),(63.83,29.36),(63.58,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.075,29.36),(37.075,36.36),(37.325,36.36),(37.325,29.36),(37.075,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.37,29.36),(57.37,36.36),(57.62,36.36),(57.62,29.36),(57.37,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.235,29.36),(54.235,36.36),(54.485,36.36),(54.485,29.36),(54.235,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.02,29.36),(62.02,36.36),(62.27,36.36),(62.27,29.36),(62.02,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.97,29.36),(33.97,36.36),(34.22,36.36),(34.22,29.36),(33.97,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.94,29.36),(33.94,36.36),(34.19,36.36),(34.19,29.36),(33.94,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.5,29.36),(35.5,36.36),(35.75,36.36),(35.75,29.36),(35.5,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.22,29.36),(54.22,36.36),(54.47,36.36),(54.47,29.36),(54.22,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.54,29.36),(49.54,36.36),(49.79,36.36),(49.79,29.36),(49.54,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.17,7.0),(70.17,21.0),(70.42,21.0),(70.42,7.0),(70.17,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.915,29.36),(58.915,36.36),(59.165,36.36),(59.165,29.36),(58.915,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.155,29.36),(26.155,36.36),(26.405,36.36),(26.405,29.36),(26.155,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.515,29.36),(35.515,36.36),(35.765,36.36),(35.765,29.36),(35.515,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.57,29.36),(49.57,36.36),(49.82,36.36),(49.82,29.36),(49.57,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.3,29.36),(43.3,36.36),(43.55,36.36),(43.55,29.36),(43.3,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.625,7.0),(68.625,21.0),(68.875,21.0),(68.875,7.0),(68.625,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.73,7.0),(71.73,21.0),(71.98,21.0),(71.98,7.0),(71.73,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.875,29.36),(44.875,36.36),(45.125,36.36),(45.125,29.36),(44.875,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.18,29.36),(40.18,36.36),(40.43,36.36),(40.43,29.36),(40.18,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.555,29.36),(49.555,36.36),(49.805,36.36),(49.805,29.36),(49.555,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((70.2,7.0),(70.2,21.0),(70.45,21.0),(70.45,7.0),(70.2,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((71.76,7.0),(71.76,21.0),(72.01,21.0),(72.01,7.0),(71.76,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.93,29.36),(58.93,36.36),(59.18,36.36),(59.18,29.36),(58.93,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.9,29.36),(58.9,36.36),(59.15,36.36),(59.15,29.36),(58.9,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.06,29.36),(37.06,36.36),(37.31,36.36),(37.31,29.36),(37.06,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.61,29.36),(63.61,36.36),(63.86,36.36),(63.86,29.36),(63.61,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.46,29.36),(60.46,36.36),(60.71,36.36),(60.71,29.36),(60.46,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((68.61,7.0),(68.61,21.0),(68.86,21.0),(68.86,7.0),(68.61,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.09,29.36),(37.09,36.36),(37.34,36.36),(37.34,29.36),(37.09,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.29,29.36),(29.29,36.36),(29.54,36.36),(29.54,29.36),(29.29,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.595,29.36),(63.595,36.36),(63.845,36.36),(63.845,29.36),(63.595,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.035,29.36),(62.035,36.36),(62.285,36.36),(62.285,29.36),(62.035,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.34,29.36),(57.34,36.36),(57.59,36.36),(57.59,29.36),(57.34,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.995,29.36),(47.995,36.36),(48.245,36.36),(48.245,29.36),(47.995,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.81,29.36),(55.81,36.36),(56.06,36.36),(56.06,29.36),(55.81,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.26,29.36),(29.26,36.36),(29.51,36.36),(29.51,29.36),(29.26,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.78,29.36),(55.78,36.36),(56.03,36.36),(56.03,29.36),(55.78,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.1,29.36),(51.1,36.36),(51.35,36.36),(51.35,29.36),(51.1,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.395,29.36),(32.395,36.36),(32.645,36.36),(32.645,29.36),(32.395,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((73.305,7.0),(73.305,21.0),(73.555,21.0),(73.555,7.0),(73.305,7.0)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.49,29.36),(60.49,36.36),(60.74,36.36),(60.74,29.36),(60.49,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.89,29.36),(44.89,36.36),(45.14,36.36),(45.14,29.36),(44.89,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.86,29.36),(44.86,36.36),(45.11,36.36),(45.11,29.36),(44.86,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.45,29.36),(46.45,36.36),(46.7,36.36),(46.7,29.36),(46.45,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.05,29.36),(62.05,36.36),(62.3,36.36),(62.3,29.36),(62.05,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.755,29.36),(41.755,36.36),(42.005,36.36),(42.005,29.36),(41.755,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.315,29.36),(43.315,36.36),(43.565,36.36),(43.565,29.36),(43.315,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.635,29.36),(38.635,36.36),(38.885,36.36),(38.885,29.36),(38.635,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.42,29.36),(46.42,36.36),(46.67,36.36),(46.67,29.36),(46.42,29.36)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,34.645),(49.595,34.815),(49.765,34.815),(49.765,34.645),(49.595,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,34.305),(49.595,34.475),(49.765,34.475),(49.765,34.305),(49.595,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,31.245),(63.635,31.415),(63.805,31.415),(63.805,31.245),(63.635,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,31.585),(63.635,31.755),(63.805,31.755),(63.805,31.585),(63.635,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,7.965),(68.665,8.135),(68.835,8.135),(68.835,7.965),(68.665,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,30.565),(49.595,30.735),(49.765,30.735),(49.765,30.565),(49.595,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,30.225),(49.595,30.395),(49.765,30.395),(49.765,30.225),(49.595,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,34.985),(41.795,35.155),(41.965,35.155),(41.965,34.985),(41.795,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,32.605),(54.275,32.775),(54.445,32.775),(54.445,32.605),(54.275,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,32.265),(54.275,32.435),(54.445,32.435),(54.445,32.265),(54.275,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,33.285),(54.275,33.455),(54.445,33.455),(54.445,33.285),(54.275,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,33.625),(54.275,33.795),(54.445,33.795),(54.445,33.625),(54.275,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,31.245),(55.835,31.415),(56.005,31.415),(56.005,31.245),(55.835,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,31.585),(55.835,31.755),(56.005,31.755),(56.005,31.585),(55.835,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,33.965),(48.035,34.135),(48.205,34.135),(48.205,33.965),(48.035,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,33.285),(43.355,33.455),(43.525,33.455),(43.525,33.285),(43.355,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,33.625),(43.355,33.795),(43.525,33.795),(43.525,33.625),(43.355,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,34.985),(43.355,35.155),(43.525,35.155),(43.525,34.985),(43.355,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,33.285),(46.475,33.455),(46.645,33.455),(46.645,33.285),(46.475,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,33.625),(46.475,33.795),(46.645,33.795),(46.645,33.625),(46.475,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,33.285),(35.555,33.455),(35.725,33.455),(35.725,33.285),(35.555,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,33.625),(35.555,33.795),(35.725,33.795),(35.725,33.625),(35.555,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,34.305),(46.475,34.475),(46.645,34.475),(46.645,34.305),(46.475,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,34.645),(46.475,34.815),(46.645,34.815),(46.645,34.645),(46.475,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,29.885),(33.995,30.055),(34.165,30.055),(34.165,29.885),(33.995,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,30.225),(55.835,30.395),(56.005,30.395),(56.005,30.225),(55.835,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,30.565),(55.835,30.735),(56.005,30.735),(56.005,30.565),(55.835,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,31.245),(32.435,31.415),(32.605,31.415),(32.605,31.245),(32.435,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,31.585),(32.435,31.755),(32.605,31.755),(32.605,31.585),(32.435,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,16.805),(71.785,16.975),(71.955,16.975),(71.955,16.805),(71.785,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,16.125),(71.785,16.295),(71.955,16.295),(71.955,16.125),(71.785,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,13.405),(70.225,13.575),(70.395,13.575),(70.395,13.405),(70.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,13.745),(70.225,13.915),(70.395,13.915),(70.395,13.745),(70.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,16.465),(71.785,16.635),(71.955,16.635),(71.955,16.465),(71.785,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,13.065),(70.225,13.235),(70.395,13.235),(70.395,13.065),(70.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,29.885),(41.795,30.055),(41.965,30.055),(41.965,29.885),(41.795,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,8.985),(71.785,9.155),(71.955,9.155),(71.955,8.985),(71.785,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,16.805),(68.665,16.975),(68.835,16.975),(68.835,16.805),(68.665,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,16.125),(68.665,16.295),(68.835,16.295),(68.835,16.125),(68.665,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,16.465),(68.665,16.635),(68.835,16.635),(68.835,16.465),(68.665,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,30.905),(48.035,31.075),(48.205,31.075),(48.205,30.905),(48.035,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,34.305),(33.995,34.475),(34.165,34.475),(34.165,34.305),(33.995,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,34.645),(33.995,34.815),(34.165,34.815),(34.165,34.645),(33.995,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,12.045),(73.345,12.215),(73.515,12.215),(73.515,12.045),(73.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,12.385),(73.345,12.555),(73.515,12.555),(73.515,12.385),(73.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,12.725),(73.345,12.895),(73.515,12.895),(73.515,12.725),(73.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,34.305),(29.315,34.475),(29.485,34.475),(29.485,34.305),(29.315,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,34.645),(29.315,34.815),(29.485,34.815),(29.485,34.645),(29.315,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,29.545),(26.195,29.715),(26.365,29.715),(26.365,29.545),(26.195,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,20.205),(71.785,20.375),(71.955,20.375),(71.955,20.205),(71.785,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,20.545),(71.785,20.715),(71.955,20.715),(71.955,20.545),(71.785,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,31.925),(54.275,32.095),(54.445,32.095),(54.445,31.925),(54.275,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,31.925),(27.755,32.095),(27.925,32.095),(27.925,31.925),(27.755,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,20.205),(68.665,20.375),(68.835,20.375),(68.835,20.205),(68.665,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,7.965),(70.225,8.135),(70.395,8.135),(70.395,7.965),(70.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,20.545),(68.665,20.715),(68.835,20.715),(68.835,20.545),(68.665,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,31.245),(57.395,31.415),(57.565,31.415),(57.565,31.245),(57.395,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,31.585),(57.395,31.755),(57.565,31.755),(57.565,31.585),(57.395,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,32.605),(33.995,32.775),(34.165,32.775),(34.165,32.605),(33.995,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,33.965),(29.315,34.135),(29.485,34.135),(29.485,33.965),(29.315,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,32.265),(33.995,32.435),(34.165,32.435),(34.165,32.265),(33.995,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,36.005),(43.355,36.175),(43.525,36.175),(43.525,36.005),(43.355,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,33.285),(60.515,33.455),(60.685,33.455),(60.685,33.285),(60.515,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,33.285),(38.675,33.455),(38.845,33.455),(38.845,33.285),(38.675,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,33.625),(38.675,33.795),(38.845,33.795),(38.845,33.625),(38.675,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,33.625),(60.515,33.795),(60.685,33.795),(60.685,33.625),(60.515,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,31.925),(40.235,32.095),(40.405,32.095),(40.405,31.925),(40.235,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,30.225),(29.315,30.395),(29.485,30.395),(29.485,30.225),(29.315,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,30.565),(29.315,30.735),(29.485,30.735),(29.485,30.565),(29.315,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.305),(44.915,34.475),(45.085,34.475),(45.085,34.305),(44.915,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.645),(44.915,34.815),(45.085,34.815),(45.085,34.645),(44.915,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,14.085),(68.665,14.255),(68.835,14.255),(68.835,14.085),(68.665,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,14.425),(68.665,14.595),(68.835,14.595),(68.835,14.425),(68.665,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,14.765),(68.665,14.935),(68.835,14.935),(68.835,14.765),(68.665,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,34.305),(52.715,34.475),(52.885,34.475),(52.885,34.305),(52.715,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,34.645),(52.715,34.815),(52.885,34.815),(52.885,34.645),(52.715,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,33.285),(32.435,33.455),(32.605,33.455),(32.605,33.285),(32.435,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,33.625),(32.435,33.795),(32.605,33.795),(32.605,33.625),(32.435,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,34.305),(32.435,34.475),(32.605,34.475),(32.605,34.305),(32.435,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,34.645),(32.435,34.815),(32.605,34.815),(32.605,34.645),(32.435,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,31.245),(51.155,31.415),(51.325,31.415),(51.325,31.245),(51.155,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,31.585),(51.155,31.755),(51.325,31.755),(51.325,31.585),(51.155,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,20.205),(73.345,20.375),(73.515,20.375),(73.515,20.205),(73.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,20.545),(73.345,20.715),(73.515,20.715),(73.515,20.545),(73.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,32.265),(49.595,32.435),(49.765,32.435),(49.765,32.265),(49.595,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,32.605),(49.595,32.775),(49.765,32.775),(49.765,32.605),(49.595,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,31.925),(60.515,32.095),(60.685,32.095),(60.685,31.925),(60.515,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,34.305),(35.555,34.475),(35.725,34.475),(35.725,34.305),(35.555,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,34.645),(35.555,34.815),(35.725,34.815),(35.725,34.645),(35.555,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,35.325),(29.315,35.495),(29.485,35.495),(29.485,35.325),(29.315,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,35.665),(29.315,35.835),(29.485,35.835),(29.485,35.665),(29.315,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,33.965),(33.995,34.135),(34.165,34.135),(34.165,33.965),(33.995,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,31.245),(35.555,31.415),(35.725,31.415),(35.725,31.245),(35.555,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,32.945),(38.675,33.115),(38.845,33.115),(38.845,32.945),(38.675,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,31.585),(35.555,31.755),(35.725,31.755),(35.725,31.585),(35.555,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,31.925),(55.835,32.095),(56.005,32.095),(56.005,31.925),(55.835,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,36.005),(55.835,36.175),(56.005,36.175),(56.005,36.005),(55.835,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,35.325),(62.075,35.495),(62.245,35.495),(62.245,35.325),(62.075,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,35.665),(62.075,35.835),(62.245,35.835),(62.245,35.665),(62.075,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,29.885),(58.955,30.055),(59.125,30.055),(59.125,29.885),(58.955,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,30.225),(37.115,30.395),(37.285,30.395),(37.285,30.225),(37.115,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,30.565),(37.115,30.735),(37.285,30.735),(37.285,30.565),(37.115,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,32.945),(41.795,33.115),(41.965,33.115),(41.965,32.945),(41.795,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,18.165),(68.665,18.335),(68.835,18.335),(68.835,18.165),(68.665,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,18.505),(68.665,18.675),(68.835,18.675),(68.835,18.505),(68.665,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,35.325),(55.835,35.495),(56.005,35.495),(56.005,35.325),(55.835,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,35.665),(55.835,35.835),(56.005,35.835),(56.005,35.665),(55.835,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,34.645),(55.835,34.815),(56.005,34.815),(56.005,34.645),(55.835,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,34.305),(55.835,34.475),(56.005,34.475),(56.005,34.305),(55.835,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,31.925),(62.075,32.095),(62.245,32.095),(62.245,31.925),(62.075,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,32.945),(52.715,33.115),(52.885,33.115),(52.885,32.945),(52.715,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,33.285),(58.955,33.455),(59.125,33.455),(59.125,33.285),(58.955,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,33.625),(58.955,33.795),(59.125,33.795),(59.125,33.625),(58.955,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,30.225),(58.955,30.395),(59.125,30.395),(59.125,30.225),(58.955,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,30.565),(58.955,30.735),(59.125,30.735),(59.125,30.565),(58.955,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,32.945),(32.435,33.115),(32.605,33.115),(32.605,32.945),(32.435,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,30.905),(32.435,31.075),(32.605,31.075),(32.605,30.905),(32.435,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,34.985),(49.595,35.155),(49.765,35.155),(49.765,34.985),(49.595,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,29.545),(38.675,29.715),(38.845,29.715),(38.845,29.545),(38.675,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,9.325),(68.665,9.495),(68.835,9.495),(68.835,9.325),(68.665,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,9.665),(68.665,9.835),(68.835,9.835),(68.835,9.665),(68.665,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,30.905),(49.595,31.075),(49.765,31.075),(49.765,30.905),(49.595,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.545),(44.915,29.715),(45.085,29.715),(45.085,29.545),(44.915,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,29.885),(52.715,30.055),(52.885,30.055),(52.885,29.885),(52.715,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,32.265),(51.155,32.435),(51.325,32.435),(51.325,32.265),(51.155,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,32.605),(51.155,32.775),(51.325,32.775),(51.325,32.605),(51.155,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,32.945),(54.275,33.115),(54.445,33.115),(54.445,32.945),(54.275,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,10.005),(71.785,10.175),(71.955,10.175),(71.955,10.005),(71.785,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,10.345),(71.785,10.515),(71.955,10.515),(71.955,10.345),(71.785,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,10.685),(71.785,10.855),(71.955,10.855),(71.955,10.685),(71.785,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,31.245),(30.875,31.415),(31.045,31.415),(31.045,31.245),(30.875,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,31.585),(30.875,31.755),(31.045,31.755),(31.045,31.585),(30.875,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,32.265),(29.315,32.435),(29.485,32.435),(29.485,32.265),(29.315,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,32.605),(29.315,32.775),(29.485,32.775),(29.485,32.605),(29.315,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,8.645),(70.225,8.815),(70.395,8.815),(70.395,8.645),(70.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,8.305),(70.225,8.475),(70.395,8.475),(70.395,8.305),(70.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,7.965),(73.345,8.135),(73.515,8.135),(73.515,7.965),(73.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,31.245),(54.275,31.415),(54.445,31.415),(54.445,31.245),(54.275,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,31.585),(54.275,31.755),(54.445,31.755),(54.445,31.585),(54.275,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,13.065),(68.665,13.235),(68.835,13.235),(68.835,13.065),(68.665,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,13.405),(68.665,13.575),(68.835,13.575),(68.835,13.405),(68.665,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,13.745),(68.665,13.915),(68.835,13.915),(68.835,13.745),(68.665,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,17.145),(73.345,17.315),(73.515,17.315),(73.515,17.145),(73.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,17.485),(73.345,17.655),(73.515,17.655),(73.515,17.485),(73.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,17.825),(73.345,17.995),(73.515,17.995),(73.515,17.825),(73.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,29.545),(55.835,29.715),(56.005,29.715),(56.005,29.545),(55.835,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,34.985),(46.475,35.155),(46.645,35.155),(46.645,34.985),(46.475,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,29.545),(41.795,29.715),(41.965,29.715),(41.965,29.545),(41.795,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,35.325),(60.515,35.495),(60.685,35.495),(60.685,35.325),(60.515,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,35.665),(60.515,35.835),(60.685,35.835),(60.685,35.665),(60.515,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,16.805),(73.345,16.975),(73.515,16.975),(73.515,16.805),(73.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,16.125),(73.345,16.295),(73.515,16.295),(73.515,16.125),(73.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,16.465),(73.345,16.635),(73.515,16.635),(73.515,16.465),(73.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,9.325),(71.785,9.495),(71.955,9.495),(71.955,9.325),(71.785,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,9.665),(71.785,9.835),(71.955,9.835),(71.955,9.665),(71.785,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,19.865),(68.665,20.035),(68.835,20.035),(68.835,19.865),(68.665,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,36.005),(41.795,36.175),(41.965,36.175),(41.965,36.005),(41.795,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,34.985),(29.315,35.155),(29.485,35.155),(29.485,34.985),(29.315,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,31.925),(46.475,32.095),(46.645,32.095),(46.645,31.925),(46.475,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,31.245),(43.355,31.415),(43.525,31.415),(43.525,31.245),(43.355,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,31.585),(43.355,31.755),(43.525,31.755),(43.525,31.585),(43.355,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,31.245),(40.235,31.415),(40.405,31.415),(40.405,31.245),(40.235,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,31.585),(40.235,31.755),(40.405,31.755),(40.405,31.585),(40.235,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,34.985),(30.875,35.155),(31.045,35.155),(31.045,34.985),(30.875,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,33.965),(27.755,34.135),(27.925,34.135),(27.925,33.965),(27.755,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,36.005),(46.475,36.175),(46.645,36.175),(46.645,36.005),(46.475,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,7.625),(70.225,7.795),(70.395,7.795),(70.395,7.625),(70.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,7.285),(70.225,7.455),(70.395,7.455),(70.395,7.285),(70.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,31.245),(27.755,31.415),(27.925,31.415),(27.925,31.245),(27.755,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,31.585),(27.755,31.755),(27.925,31.755),(27.925,31.585),(27.755,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,33.285),(29.315,33.455),(29.485,33.455),(29.485,33.285),(29.315,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,33.625),(29.315,33.795),(29.485,33.795),(29.485,33.625),(29.315,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,29.545),(62.075,29.715),(62.245,29.715),(62.245,29.545),(62.075,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,13.745),(71.785,13.915),(71.955,13.915),(71.955,13.745),(71.785,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,13.065),(71.785,13.235),(71.955,13.235),(71.955,13.065),(71.785,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,13.405),(71.785,13.575),(71.955,13.575),(71.955,13.405),(71.785,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,12.385),(71.785,12.555),(71.955,12.555),(71.955,12.385),(71.785,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,12.045),(71.785,12.215),(71.955,12.215),(71.955,12.045),(71.785,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,12.725),(71.785,12.895),(71.955,12.895),(71.955,12.725),(71.785,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,30.905),(29.315,31.075),(29.485,31.075),(29.485,30.905),(29.315,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,30.225),(51.155,30.395),(51.325,30.395),(51.325,30.225),(51.155,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,30.565),(51.155,30.735),(51.325,30.735),(51.325,30.565),(51.155,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,34.985),(52.715,35.155),(52.885,35.155),(52.885,34.985),(52.715,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,32.265),(63.635,32.435),(63.805,32.435),(63.805,32.265),(63.635,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,32.605),(63.635,32.775),(63.805,32.775),(63.805,32.605),(63.635,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,7.965),(71.785,8.135),(71.955,8.135),(71.955,7.965),(71.785,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,36.005),(30.875,36.175),(31.045,36.175),(31.045,36.005),(30.875,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,34.985),(32.435,35.155),(32.605,35.155),(32.605,34.985),(32.435,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,29.885),(60.515,30.055),(60.685,30.055),(60.685,29.885),(60.515,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,32.945),(49.595,33.115),(49.765,33.115),(49.765,32.945),(49.595,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,33.285),(55.835,33.455),(56.005,33.455),(56.005,33.285),(55.835,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,33.625),(55.835,33.795),(56.005,33.795),(56.005,33.625),(55.835,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,31.925),(52.715,32.095),(52.885,32.095),(52.885,31.925),(52.715,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,36.005),(29.315,36.175),(29.485,36.175),(29.485,36.005),(29.315,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,34.985),(35.555,35.155),(35.725,35.155),(35.725,34.985),(35.555,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,11.705),(68.665,11.875),(68.835,11.875),(68.835,11.705),(68.665,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,11.025),(68.665,11.195),(68.835,11.195),(68.835,11.025),(68.665,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,11.365),(68.665,11.535),(68.835,11.535),(68.835,11.365),(68.665,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,20.545),(70.225,20.715),(70.395,20.715),(70.395,20.545),(70.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,20.205),(70.225,20.375),(70.395,20.375),(70.395,20.205),(70.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,30.905),(37.115,31.075),(37.285,31.075),(37.285,30.905),(37.115,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,29.885),(37.115,30.055),(37.285,30.055),(37.285,29.885),(37.115,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,18.845),(68.665,19.015),(68.835,19.015),(68.835,18.845),(68.665,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,31.925),(49.595,32.095),(49.765,32.095),(49.765,31.925),(49.595,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,33.965),(58.955,34.135),(59.125,34.135),(59.125,33.965),(58.955,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,29.885),(51.155,30.055),(51.325,30.055),(51.325,29.885),(51.155,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,33.965),(57.395,34.135),(57.565,34.135),(57.565,33.965),(57.395,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,16.465),(70.225,16.635),(70.395,16.635),(70.395,16.465),(70.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,16.805),(70.225,16.975),(70.395,16.975),(70.395,16.805),(70.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,16.125),(70.225,16.295),(70.395,16.295),(70.395,16.125),(70.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,36.005),(27.755,36.175),(27.925,36.175),(27.925,36.005),(27.755,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,35.665),(43.355,35.835),(43.525,35.835),(43.525,35.665),(43.355,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,35.325),(43.355,35.495),(43.525,35.495),(43.525,35.325),(43.355,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,29.885),(54.275,30.055),(54.445,30.055),(54.445,29.885),(54.275,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,36.005),(58.955,36.175),(59.125,36.175),(59.125,36.005),(58.955,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,11.025),(73.345,11.195),(73.515,11.195),(73.515,11.025),(73.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,11.365),(73.345,11.535),(73.515,11.535),(73.515,11.365),(73.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,11.705),(73.345,11.875),(73.515,11.875),(73.515,11.705),(73.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,29.885),(35.555,30.055),(35.725,30.055),(35.725,29.885),(35.555,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.885),(44.915,30.055),(45.085,30.055),(45.085,29.885),(44.915,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,34.305),(26.195,34.475),(26.365,34.475),(26.365,34.305),(26.195,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,34.645),(26.195,34.815),(26.365,34.815),(26.365,34.645),(26.195,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,32.945),(51.155,33.115),(51.325,33.115),(51.325,32.945),(51.155,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,17.145),(71.785,17.315),(71.955,17.315),(71.955,17.145),(71.785,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,17.485),(71.785,17.655),(71.955,17.655),(71.955,17.485),(71.785,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,17.825),(71.785,17.995),(71.955,17.995),(71.955,17.825),(71.785,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,35.325),(35.555,35.495),(35.725,35.495),(35.725,35.325),(35.555,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,35.665),(35.555,35.835),(35.725,35.835),(35.725,35.665),(35.555,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,32.265),(46.475,32.435),(46.645,32.435),(46.645,32.265),(46.475,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,35.325),(30.875,35.495),(31.045,35.495),(31.045,35.325),(30.875,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,32.605),(27.755,32.775),(27.925,32.775),(27.925,32.605),(27.755,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,32.265),(27.755,32.435),(27.925,32.435),(27.925,32.265),(27.755,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,35.665),(30.875,35.835),(31.045,35.835),(31.045,35.665),(30.875,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,32.605),(46.475,32.775),(46.645,32.775),(46.645,32.605),(46.475,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,29.545),(46.475,29.715),(46.645,29.715),(46.645,29.545),(46.475,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,35.665),(57.395,35.835),(57.565,35.835),(57.565,35.665),(57.395,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,35.325),(57.395,35.495),(57.565,35.495),(57.565,35.325),(57.395,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,32.945),(29.315,33.115),(29.485,33.115),(29.485,32.945),(29.315,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,36.005),(52.715,36.175),(52.885,36.175),(52.885,36.005),(52.715,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,32.265),(40.235,32.435),(40.405,32.435),(40.405,32.265),(40.235,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,36.005),(48.035,36.175),(48.205,36.175),(48.205,36.005),(48.035,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,32.605),(40.235,32.775),(40.405,32.775),(40.405,32.605),(40.235,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,29.885),(48.035,30.055),(48.205,30.055),(48.205,29.885),(48.035,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,8.985),(70.225,9.155),(70.395,9.155),(70.395,8.985),(70.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,35.325),(63.635,35.495),(63.805,35.495),(63.805,35.325),(63.635,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,35.665),(63.635,35.835),(63.805,35.835),(63.805,35.665),(63.635,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,33.285),(40.235,33.455),(40.405,33.455),(40.405,33.285),(40.235,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,33.625),(40.235,33.795),(40.405,33.795),(40.405,33.625),(40.235,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,29.885),(55.835,30.055),(56.005,30.055),(56.005,29.885),(55.835,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,7.285),(73.345,7.455),(73.515,7.455),(73.515,7.285),(73.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,7.625),(73.345,7.795),(73.515,7.795),(73.515,7.625),(73.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,12.725),(68.665,12.895),(68.835,12.895),(68.835,12.725),(68.665,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,32.605),(48.035,32.775),(48.205,32.775),(48.205,32.605),(48.035,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,32.265),(48.035,32.435),(48.205,32.435),(48.205,32.265),(48.035,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,19.525),(68.665,19.695),(68.835,19.695),(68.835,19.525),(68.665,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,19.185),(68.665,19.355),(68.835,19.355),(68.835,19.185),(68.665,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,36.005),(26.195,36.175),(26.365,36.175),(26.365,36.005),(26.195,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,30.225),(43.355,30.395),(43.525,30.395),(43.525,30.225),(43.355,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,30.565),(43.355,30.735),(43.525,30.735),(43.525,30.565),(43.355,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,32.605),(60.515,32.775),(60.685,32.775),(60.685,32.605),(60.515,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,32.265),(60.515,32.435),(60.685,32.435),(60.685,32.265),(60.515,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,18.165),(73.345,18.335),(73.515,18.335),(73.515,18.165),(73.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,18.505),(73.345,18.675),(73.515,18.675),(73.515,18.505),(73.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,31.245),(41.795,31.415),(41.965,31.415),(41.965,31.245),(41.795,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,31.585),(41.795,31.755),(41.965,31.755),(41.965,31.585),(41.795,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,34.305),(30.875,34.475),(31.045,34.475),(31.045,34.305),(30.875,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,34.645),(30.875,34.815),(31.045,34.815),(31.045,34.645),(30.875,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,33.285),(27.755,33.455),(27.925,33.455),(27.925,33.285),(27.755,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,33.625),(27.755,33.795),(27.925,33.795),(27.925,33.625),(27.755,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,33.285),(52.715,33.455),(52.885,33.455),(52.885,33.285),(52.715,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,33.625),(52.715,33.795),(52.885,33.795),(52.885,33.625),(52.715,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,30.905),(33.995,31.075),(34.165,31.075),(34.165,30.905),(33.995,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,29.885),(29.315,30.055),(29.485,30.055),(29.485,29.885),(29.315,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,29.545),(40.235,29.715),(40.405,29.715),(40.405,29.545),(40.235,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,31.245),(26.195,31.415),(26.365,31.415),(26.365,31.245),(26.195,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,31.585),(26.195,31.755),(26.365,31.755),(26.365,31.585),(26.195,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,33.965),(26.195,34.135),(26.365,34.135),(26.365,33.965),(26.195,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,32.945),(63.635,33.115),(63.805,33.115),(63.805,32.945),(63.635,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,30.905),(51.155,31.075),(51.325,31.075),(51.325,30.905),(51.155,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,33.625),(62.075,33.795),(62.245,33.795),(62.245,33.625),(62.075,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,33.285),(62.075,33.455),(62.245,33.455),(62.245,33.285),(62.075,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,29.885),(43.355,30.055),(43.525,30.055),(43.525,29.885),(43.355,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,34.305),(62.075,34.475),(62.245,34.475),(62.245,34.305),(62.075,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,34.645),(62.075,34.815),(62.245,34.815),(62.245,34.645),(62.075,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,31.925),(48.035,32.095),(48.205,32.095),(48.205,31.925),(48.035,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,29.885),(49.595,30.055),(49.765,30.055),(49.765,29.885),(49.595,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,9.325),(70.225,9.495),(70.395,9.495),(70.395,9.325),(70.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,9.665),(70.225,9.835),(70.395,9.835),(70.395,9.665),(70.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,33.965),(49.595,34.135),(49.765,34.135),(49.765,33.965),(49.595,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,30.225),(54.275,30.395),(54.445,30.395),(54.445,30.225),(54.275,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,30.565),(54.275,30.735),(54.445,30.735),(54.445,30.565),(54.275,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,34.985),(58.955,35.155),(59.125,35.155),(59.125,34.985),(58.955,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,7.285),(71.785,7.455),(71.955,7.455),(71.955,7.285),(71.785,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,7.625),(71.785,7.795),(71.955,7.795),(71.955,7.625),(71.785,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,29.885),(32.435,30.055),(32.605,30.055),(32.605,29.885),(32.435,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,33.965),(55.835,34.135),(56.005,34.135),(56.005,33.965),(55.835,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,29.885),(27.755,30.055),(27.925,30.055),(27.925,29.885),(27.755,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,30.225),(63.635,30.395),(63.805,30.395),(63.805,30.225),(63.635,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,30.565),(63.635,30.735),(63.805,30.735),(63.805,30.565),(63.635,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,30.225),(38.675,30.395),(38.845,30.395),(38.845,30.225),(38.675,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,30.565),(38.675,30.735),(38.845,30.735),(38.845,30.565),(38.675,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,29.545),(37.115,29.715),(37.285,29.715),(37.285,29.545),(37.115,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,33.965),(51.155,34.135),(51.325,34.135),(51.325,33.965),(51.155,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,31.585),(52.715,31.755),(52.885,31.755),(52.885,31.585),(52.715,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,31.245),(52.715,31.415),(52.885,31.415),(52.885,31.245),(52.715,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,29.885),(63.635,30.055),(63.805,30.055),(63.805,29.885),(63.635,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,34.645),(51.155,34.815),(51.325,34.815),(51.325,34.645),(51.155,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,34.305),(51.155,34.475),(51.325,34.475),(51.325,34.305),(51.155,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,31.925),(37.115,32.095),(37.285,32.095),(37.285,31.925),(37.115,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,33.625),(57.395,33.795),(57.565,33.795),(57.565,33.625),(57.395,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,33.285),(57.395,33.455),(57.565,33.455),(57.565,33.285),(57.395,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,29.545),(51.155,29.715),(51.325,29.715),(51.325,29.545),(51.155,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,34.305),(40.235,34.475),(40.405,34.475),(40.405,34.305),(40.235,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,34.645),(40.235,34.815),(40.405,34.815),(40.405,34.645),(40.235,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,30.225),(40.235,30.395),(40.405,30.395),(40.405,30.225),(40.235,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,30.565),(40.235,30.735),(40.405,30.735),(40.405,30.565),(40.235,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,35.325),(40.235,35.495),(40.405,35.495),(40.405,35.325),(40.235,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,35.665),(40.235,35.835),(40.405,35.835),(40.405,35.665),(40.235,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,29.545),(35.555,29.715),(35.725,29.715),(35.725,29.545),(35.555,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,7.625),(68.665,7.795),(68.835,7.795),(68.835,7.625),(68.665,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,7.285),(68.665,7.455),(68.835,7.455),(68.835,7.285),(68.665,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.285),(44.915,33.455),(45.085,33.455),(45.085,33.285),(44.915,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.625),(44.915,33.795),(45.085,33.795),(45.085,33.625),(44.915,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,34.985),(26.195,35.155),(26.365,35.155),(26.365,34.985),(26.195,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,32.945),(46.475,33.115),(46.645,33.115),(46.645,32.945),(46.475,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,14.425),(70.225,14.595),(70.395,14.595),(70.395,14.425),(70.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,14.765),(70.225,14.935),(70.395,14.935),(70.395,14.765),(70.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,14.085),(70.225,14.255),(70.395,14.255),(70.395,14.085),(70.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,33.625),(48.035,33.795),(48.205,33.795),(48.205,33.625),(48.035,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,32.945),(27.755,33.115),(27.925,33.115),(27.925,32.945),(27.755,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,33.965),(54.275,34.135),(54.445,34.135),(54.445,33.965),(54.275,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,33.285),(48.035,33.455),(48.205,33.455),(48.205,33.285),(48.035,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,34.305),(48.035,34.475),(48.205,34.475),(48.205,34.305),(48.035,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,34.645),(48.035,34.815),(48.205,34.815),(48.205,34.645),(48.035,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,35.325),(32.435,35.495),(32.605,35.495),(32.605,35.325),(32.435,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,35.665),(32.435,35.835),(32.605,35.835),(32.605,35.665),(32.435,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,31.585),(49.595,31.755),(49.765,31.755),(49.765,31.585),(49.595,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,31.245),(49.595,31.415),(49.765,31.415),(49.765,31.245),(49.595,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,31.245),(33.995,31.415),(34.165,31.415),(34.165,31.245),(33.995,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,34.305),(60.515,34.475),(60.685,34.475),(60.685,34.305),(60.515,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,34.645),(60.515,34.815),(60.685,34.815),(60.685,34.645),(60.515,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,31.245),(38.675,31.415),(38.845,31.415),(38.845,31.245),(38.675,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,31.585),(38.675,31.755),(38.845,31.755),(38.845,31.585),(38.675,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,31.585),(33.995,31.755),(34.165,31.755),(34.165,31.585),(33.995,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,30.225),(26.195,30.395),(26.365,30.395),(26.365,30.225),(26.195,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,34.305),(37.115,34.475),(37.285,34.475),(37.285,34.305),(37.115,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,34.645),(37.115,34.815),(37.285,34.815),(37.285,34.645),(37.115,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,32.945),(40.235,33.115),(40.405,33.115),(40.405,32.945),(40.235,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,30.565),(26.195,30.735),(26.365,30.735),(26.365,30.565),(26.195,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,11.025),(71.785,11.195),(71.955,11.195),(71.955,11.025),(71.785,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,11.365),(71.785,11.535),(71.955,11.535),(71.955,11.365),(71.785,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,11.705),(71.785,11.875),(71.955,11.875),(71.955,11.705),(71.785,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,33.965),(46.475,34.135),(46.645,34.135),(46.645,33.965),(46.475,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,31.925),(32.435,32.095),(32.605,32.095),(32.605,31.925),(32.435,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,35.325),(52.715,35.495),(52.885,35.495),(52.885,35.325),(52.715,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,35.665),(52.715,35.835),(52.885,35.835),(52.885,35.665),(52.715,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,32.265),(43.355,32.435),(43.525,32.435),(43.525,32.265),(43.355,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,31.925),(41.795,32.095),(41.965,32.095),(41.965,31.925),(41.795,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,32.945),(30.875,33.115),(31.045,33.115),(31.045,32.945),(30.875,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,30.225),(57.395,30.395),(57.565,30.395),(57.565,30.225),(57.395,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,30.565),(57.395,30.735),(57.565,30.735),(57.565,30.565),(57.395,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,32.605),(43.355,32.775),(43.525,32.775),(43.525,32.605),(43.355,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,30.225),(60.515,30.395),(60.685,30.395),(60.685,30.225),(60.515,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,32.945),(48.035,33.115),(48.205,33.115),(48.205,32.945),(48.035,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,32.945),(55.835,33.115),(56.005,33.115),(56.005,32.945),(55.835,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,30.905),(43.355,31.075),(43.525,31.075),(43.525,30.905),(43.355,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,14.085),(71.785,14.255),(71.955,14.255),(71.955,14.085),(71.785,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,14.425),(71.785,14.595),(71.955,14.595),(71.955,14.425),(71.785,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,14.765),(71.785,14.935),(71.955,14.935),(71.955,14.765),(71.785,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,30.225),(41.795,30.395),(41.965,30.395),(41.965,30.225),(41.795,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,32.945),(60.515,33.115),(60.685,33.115),(60.685,32.945),(60.515,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,30.565),(41.795,30.735),(41.965,30.735),(41.965,30.565),(41.795,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,29.885),(26.195,30.055),(26.365,30.055),(26.365,29.885),(26.195,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,18.845),(73.345,19.015),(73.515,19.015),(73.515,18.845),(73.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,30.225),(62.075,30.395),(62.245,30.395),(62.245,30.225),(62.075,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,30.565),(62.075,30.735),(62.245,30.735),(62.245,30.565),(62.075,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,30.565),(27.755,30.735),(27.925,30.735),(27.925,30.565),(27.755,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,30.225),(27.755,30.395),(27.925,30.395),(27.925,30.225),(27.755,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,17.145),(68.665,17.315),(68.835,17.315),(68.835,17.145),(68.665,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,17.485),(68.665,17.655),(68.835,17.655),(68.835,17.485),(68.665,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,17.825),(68.665,17.995),(68.835,17.995),(68.835,17.825),(68.665,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,34.305),(57.395,34.475),(57.565,34.475),(57.565,34.305),(57.395,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,17.145),(70.225,17.315),(70.395,17.315),(70.395,17.145),(70.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,17.485),(70.225,17.655),(70.395,17.655),(70.395,17.485),(70.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,17.825),(70.225,17.995),(70.395,17.995),(70.395,17.825),(70.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,34.645),(57.395,34.815),(57.565,34.815),(57.565,34.645),(57.395,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,19.525),(70.225,19.695),(70.395,19.695),(70.395,19.525),(70.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,19.185),(70.225,19.355),(70.395,19.355),(70.395,19.185),(70.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,36.005),(38.675,36.175),(38.845,36.175),(38.845,36.005),(38.675,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,34.305),(63.635,34.475),(63.805,34.475),(63.805,34.305),(63.635,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,34.645),(63.635,34.815),(63.805,34.815),(63.805,34.645),(63.635,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,31.925),(26.195,32.095),(26.365,32.095),(26.365,31.925),(26.195,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,30.225),(33.995,30.395),(34.165,30.395),(34.165,30.225),(33.995,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,31.245),(60.515,31.415),(60.685,31.415),(60.685,31.245),(60.515,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,31.585),(60.515,31.755),(60.685,31.755),(60.685,31.585),(60.515,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,30.565),(33.995,30.735),(34.165,30.735),(34.165,30.565),(33.995,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,33.965),(60.515,34.135),(60.685,34.135),(60.685,33.965),(60.515,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,33.965),(38.675,34.135),(38.845,34.135),(38.845,33.965),(38.675,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,29.545),(29.315,29.715),(29.485,29.715),(29.485,29.545),(29.315,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,30.225),(35.555,30.395),(35.725,30.395),(35.725,30.225),(35.555,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,30.565),(35.555,30.735),(35.725,30.735),(35.725,30.565),(35.555,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,8.645),(68.665,8.815),(68.835,8.815),(68.835,8.645),(68.665,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,8.305),(68.665,8.475),(68.835,8.475),(68.835,8.305),(68.665,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,33.965),(63.635,34.135),(63.805,34.135),(63.805,33.965),(63.635,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,31.925),(29.315,32.095),(29.485,32.095),(29.485,31.925),(29.315,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,33.965),(32.435,34.135),(32.605,34.135),(32.605,33.965),(32.435,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,15.105),(73.345,15.275),(73.515,15.275),(73.515,15.105),(73.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,15.445),(73.345,15.615),(73.515,15.615),(73.515,15.445),(73.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,15.785),(73.345,15.955),(73.515,15.955),(73.515,15.785),(73.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,29.545),(43.355,29.715),(43.525,29.715),(43.525,29.545),(43.355,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,34.985),(62.075,35.155),(62.245,35.155),(62.245,34.985),(62.075,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,29.545),(49.595,29.715),(49.765,29.715),(49.765,29.545),(49.595,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,33.285),(49.595,33.455),(49.765,33.455),(49.765,33.285),(49.595,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,33.625),(49.595,33.795),(49.765,33.795),(49.765,33.625),(49.595,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,31.245),(58.955,31.415),(59.125,31.415),(59.125,31.245),(58.955,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,31.585),(58.955,31.755),(59.125,31.755),(59.125,31.585),(58.955,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,30.905),(54.275,31.075),(54.445,31.075),(54.445,30.905),(54.275,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,34.305),(58.955,34.475),(59.125,34.475),(59.125,34.305),(58.955,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,36.005),(40.235,36.175),(40.405,36.175),(40.405,36.005),(40.235,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,34.645),(58.955,34.815),(59.125,34.815),(59.125,34.645),(58.955,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,35.325),(26.195,35.495),(26.365,35.495),(26.365,35.325),(26.195,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,35.665),(26.195,35.835),(26.365,35.835),(26.365,35.665),(26.195,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,29.545),(27.755,29.715),(27.925,29.715),(27.925,29.545),(27.755,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,36.005),(54.275,36.175),(54.445,36.175),(54.445,36.005),(54.275,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,31.245),(62.075,31.415),(62.245,31.415),(62.245,31.245),(62.075,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,31.585),(62.075,31.755),(62.245,31.755),(62.245,31.585),(62.075,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,30.565),(32.435,30.735),(32.605,30.735),(32.605,30.565),(32.435,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,30.905),(63.635,31.075),(63.805,31.075),(63.805,30.905),(63.635,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.325),(44.915,35.495),(45.085,35.495),(45.085,35.325),(44.915,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.665),(44.915,35.835),(45.085,35.835),(45.085,35.665),(44.915,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,30.905),(38.675,31.075),(38.845,31.075),(38.845,30.905),(38.675,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,29.545),(63.635,29.715),(63.805,29.715),(63.805,29.545),(63.635,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,33.285),(51.155,33.455),(51.325,33.455),(51.325,33.285),(51.155,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,33.625),(51.155,33.795),(51.325,33.795),(51.325,33.625),(51.155,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.905),(44.915,31.075),(45.085,31.075),(45.085,30.905),(44.915,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,34.985),(51.155,35.155),(51.325,35.155),(51.325,34.985),(51.155,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,32.605),(26.195,32.775),(26.365,32.775),(26.365,32.605),(26.195,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,36.005),(62.075,36.175),(62.245,36.175),(62.245,36.005),(62.075,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,32.265),(26.195,32.435),(26.365,32.435),(26.365,32.265),(26.195,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,35.325),(33.995,35.495),(34.165,35.495),(34.165,35.325),(33.995,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,35.665),(33.995,35.835),(34.165,35.835),(34.165,35.665),(33.995,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,33.285),(30.875,33.455),(31.045,33.455),(31.045,33.285),(30.875,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,34.305),(38.675,34.475),(38.845,34.475),(38.845,34.305),(38.675,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,34.645),(38.675,34.815),(38.845,34.815),(38.845,34.645),(38.675,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,34.645),(27.755,34.815),(27.925,34.815),(27.925,34.645),(27.755,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,34.305),(27.755,34.475),(27.925,34.475),(27.925,34.305),(27.755,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,31.925),(51.155,32.095),(51.325,32.095),(51.325,31.925),(51.155,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,36.005),(49.595,36.175),(49.765,36.175),(49.765,36.005),(49.595,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,33.625),(30.875,33.795),(31.045,33.795),(31.045,33.625),(30.875,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,29.885),(38.675,30.055),(38.845,30.055),(38.845,29.885),(38.675,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,32.605),(37.115,32.775),(37.285,32.775),(37.285,32.605),(37.115,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,34.985),(40.235,35.155),(40.405,35.155),(40.405,34.985),(40.235,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,32.265),(37.115,32.435),(37.285,32.435),(37.285,32.265),(37.115,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,30.905),(40.235,31.075),(40.405,31.075),(40.405,30.905),(40.235,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,31.245),(37.115,31.415),(37.285,31.415),(37.285,31.245),(37.115,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,31.585),(37.115,31.755),(37.285,31.755),(37.285,31.585),(37.115,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,30.225),(46.475,30.395),(46.645,30.395),(46.645,30.225),(46.475,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,30.565),(46.475,30.735),(46.645,30.735),(46.645,30.565),(46.475,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,10.005),(73.345,10.175),(73.515,10.175),(73.515,10.005),(73.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,10.345),(73.345,10.515),(73.515,10.515),(73.515,10.345),(73.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,10.685),(73.345,10.855),(73.515,10.855),(73.515,10.685),(73.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,18.165),(71.785,18.335),(71.955,18.335),(71.955,18.165),(71.785,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,18.505),(71.785,18.675),(71.955,18.675),(71.955,18.505),(71.785,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,29.545),(52.715,29.715),(52.885,29.715),(52.885,29.545),(52.715,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.965),(44.915,34.135),(45.085,34.135),(45.085,33.965),(44.915,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,30.565),(60.515,30.735),(60.685,30.735),(60.685,30.565),(60.515,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,31.925),(38.675,32.095),(38.845,32.095),(38.845,31.925),(38.675,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,34.985),(48.035,35.155),(48.205,35.155),(48.205,34.985),(48.035,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,34.985),(60.515,35.155),(60.685,35.155),(60.685,34.985),(60.515,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,30.905),(60.515,31.075),(60.685,31.075),(60.685,30.905),(60.515,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.005),(44.915,36.175),(45.085,36.175),(45.085,36.005),(44.915,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,15.105),(68.665,15.275),(68.835,15.275),(68.835,15.105),(68.665,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,15.445),(68.665,15.615),(68.835,15.615),(68.835,15.445),(68.665,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,15.785),(68.665,15.955),(68.835,15.955),(68.835,15.785),(68.665,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,30.905),(26.195,31.075),(26.365,31.075),(26.365,30.905),(26.195,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,34.985),(37.115,35.155),(37.285,35.155),(37.285,34.985),(37.115,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,19.525),(71.785,19.695),(71.955,19.695),(71.955,19.525),(71.785,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,19.185),(71.785,19.355),(71.955,19.355),(71.955,19.185),(71.785,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,18.165),(70.225,18.335),(70.395,18.335),(70.395,18.165),(70.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,18.505),(70.225,18.675),(70.395,18.675),(70.395,18.505),(70.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,34.305),(54.275,34.475),(54.445,34.475),(54.445,34.305),(54.275,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,34.645),(54.275,34.815),(54.445,34.815),(54.445,34.645),(54.275,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,32.265),(57.395,32.435),(57.565,32.435),(57.565,32.265),(57.395,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,32.605),(57.395,32.775),(57.565,32.775),(57.565,32.605),(57.395,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,35.325),(54.275,35.495),(54.445,35.495),(54.445,35.325),(54.275,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,35.665),(54.275,35.835),(54.445,35.835),(54.445,35.665),(54.275,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,31.925),(30.875,32.095),(31.045,32.095),(31.045,31.925),(30.875,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,30.905),(30.875,31.075),(31.045,31.075),(31.045,30.905),(30.875,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,33.965),(41.795,34.135),(41.965,34.135),(41.965,33.965),(41.795,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,33.965),(37.115,34.135),(37.285,34.135),(37.285,33.965),(37.115,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,36.005),(51.155,36.175),(51.325,36.175),(51.325,36.005),(51.155,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,32.945),(43.355,33.115),(43.525,33.115),(43.525,32.945),(43.355,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,30.905),(57.395,31.075),(57.565,31.075),(57.565,30.905),(57.395,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,32.605),(30.875,32.775),(31.045,32.775),(31.045,32.605),(30.875,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,32.265),(30.875,32.435),(31.045,32.435),(31.045,32.265),(30.875,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,35.325),(27.755,35.495),(27.925,35.495),(27.925,35.325),(27.755,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,35.665),(27.755,35.835),(27.925,35.835),(27.925,35.665),(27.755,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,29.885),(57.395,30.055),(57.565,30.055),(57.565,29.885),(57.395,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,10.005),(68.665,10.175),(68.835,10.175),(68.835,10.005),(68.665,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,10.345),(68.665,10.515),(68.835,10.515),(68.835,10.345),(68.665,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,10.685),(68.665,10.855),(68.835,10.855),(68.835,10.685),(68.665,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,31.245),(46.475,31.415),(46.645,31.415),(46.645,31.245),(46.475,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,31.585),(46.475,31.755),(46.645,31.755),(46.645,31.585),(46.475,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,35.665),(46.475,35.835),(46.645,35.835),(46.645,35.665),(46.475,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,35.325),(46.475,35.495),(46.645,35.495),(46.645,35.325),(46.475,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,32.265),(55.835,32.435),(56.005,32.435),(56.005,32.265),(55.835,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,15.105),(70.225,15.275),(70.395,15.275),(70.395,15.105),(70.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,15.445),(70.225,15.615),(70.395,15.615),(70.395,15.445),(70.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,15.785),(70.225,15.955),(70.395,15.955),(70.395,15.785),(70.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,30.225),(52.715,30.395),(52.885,30.395),(52.885,30.225),(52.715,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,30.565),(52.715,30.735),(52.885,30.735),(52.885,30.565),(52.715,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,32.605),(55.835,32.775),(56.005,32.775),(56.005,32.605),(55.835,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,30.905),(41.795,31.075),(41.965,31.075),(41.965,30.905),(41.795,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,30.905),(62.075,31.075),(62.245,31.075),(62.245,30.905),(62.075,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,30.905),(27.755,31.075),(27.925,31.075),(27.925,30.905),(27.755,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,34.985),(57.395,35.155),(57.565,35.155),(57.565,34.985),(57.395,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,31.925),(33.995,32.095),(34.165,32.095),(34.165,31.925),(33.995,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,13.405),(73.345,13.575),(73.515,13.575),(73.515,13.405),(73.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,13.065),(73.345,13.235),(73.515,13.235),(73.515,13.065),(73.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,13.745),(73.345,13.915),(73.515,13.915),(73.515,13.745),(73.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,19.185),(73.345,19.355),(73.515,19.355),(73.515,19.185),(73.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,19.525),(73.345,19.695),(73.515,19.695),(73.515,19.525),(73.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,35.325),(41.795,35.495),(41.965,35.495),(41.965,35.325),(41.795,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,35.665),(41.795,35.835),(41.965,35.835),(41.965,35.665),(41.795,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,19.865),(70.225,20.035),(70.395,20.035),(70.395,19.865),(70.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,34.985),(63.635,35.155),(63.805,35.155),(63.805,34.985),(63.635,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,35.325),(37.115,35.495),(37.285,35.495),(37.285,35.325),(37.115,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,35.665),(37.115,35.835),(37.285,35.835),(37.285,35.665),(37.115,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,32.265),(62.075,32.435),(62.245,32.435),(62.245,32.265),(62.075,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,32.605),(62.075,32.775),(62.245,32.775),(62.245,32.605),(62.075,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,30.225),(32.435,30.395),(32.605,30.395),(32.605,30.225),(32.435,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,29.885),(62.075,30.055),(62.245,30.055),(62.245,29.885),(62.075,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,36.005),(37.115,36.175),(37.285,36.175),(37.285,36.005),(37.115,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,32.945),(58.955,33.115),(59.125,33.115),(59.125,32.945),(58.955,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,30.905),(35.555,31.075),(35.725,31.075),(35.725,30.905),(35.555,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,8.985),(68.665,9.155),(68.835,9.155),(68.835,8.985),(68.665,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,35.665),(49.595,35.835),(49.765,35.835),(49.765,35.665),(49.595,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.595,35.325),(49.595,35.495),(49.765,35.495),(49.765,35.325),(49.595,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,11.025),(70.225,11.195),(70.395,11.195),(70.395,11.025),(70.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,11.365),(70.225,11.535),(70.395,11.535),(70.395,11.365),(70.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,11.705),(70.225,11.875),(70.395,11.875),(70.395,11.705),(70.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,33.285),(63.635,33.455),(63.805,33.455),(63.805,33.285),(63.635,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,33.625),(63.635,33.795),(63.805,33.795),(63.805,33.625),(63.635,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,31.925),(58.955,32.095),(59.125,32.095),(59.125,31.925),(58.955,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,31.925),(63.635,32.095),(63.805,32.095),(63.805,31.925),(63.635,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,29.545),(60.515,29.715),(60.685,29.715),(60.685,29.545),(60.515,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,31.925),(43.355,32.095),(43.525,32.095),(43.525,31.925),(43.355,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((60.515,36.005),(60.515,36.175),(60.685,36.175),(60.685,36.005),(60.515,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,35.325),(38.675,35.495),(38.845,35.495),(38.845,35.325),(38.675,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,35.665),(38.675,35.835),(38.845,35.835),(38.845,35.665),(38.675,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,31.245),(29.315,31.415),(29.485,31.415),(29.485,31.245),(29.315,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((29.315,31.585),(29.315,31.755),(29.485,31.755),(29.485,31.585),(29.315,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,36.005),(35.555,36.175),(35.725,36.175),(35.725,36.005),(35.555,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.925),(44.915,32.095),(45.085,32.095),(45.085,31.925),(44.915,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,8.305),(73.345,8.475),(73.515,8.475),(73.515,8.305),(73.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,8.645),(73.345,8.815),(73.515,8.815),(73.515,8.645),(73.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.945),(44.915,33.115),(45.085,33.115),(45.085,32.945),(44.915,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,12.045),(70.225,12.215),(70.395,12.215),(70.395,12.045),(70.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,12.385),(70.225,12.555),(70.395,12.555),(70.395,12.385),(70.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,12.725),(70.225,12.895),(70.395,12.895),(70.395,12.725),(70.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,32.265),(35.555,32.435),(35.725,32.435),(35.725,32.265),(35.555,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,32.605),(35.555,32.775),(35.725,32.775),(35.725,32.605),(35.555,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,32.945),(26.195,33.115),(26.365,33.115),(26.365,32.945),(26.195,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.225),(44.915,30.395),(45.085,30.395),(45.085,30.225),(44.915,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.565),(44.915,30.735),(45.085,30.735),(45.085,30.565),(44.915,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,29.545),(30.875,29.715),(31.045,29.715),(31.045,29.545),(30.875,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,33.965),(30.875,34.135),(31.045,34.135),(31.045,33.965),(30.875,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,34.985),(38.675,35.155),(38.845,35.155),(38.845,34.985),(38.675,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((27.755,34.985),(27.755,35.155),(27.925,35.155),(27.925,34.985),(27.755,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,32.945),(37.115,33.115),(37.285,33.115),(37.285,32.945),(37.115,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,29.545),(54.275,29.715),(54.445,29.715),(54.445,29.545),(54.275,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,9.325),(73.345,9.495),(73.515,9.495),(73.515,9.325),(73.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,9.665),(73.345,9.835),(73.515,9.835),(73.515,9.665),(73.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,30.905),(46.475,31.075),(46.645,31.075),(46.645,30.905),(46.475,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,18.845),(71.785,19.015),(71.955,19.015),(71.955,18.845),(71.785,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,35.325),(58.955,35.495),(59.125,35.495),(59.125,35.325),(58.955,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,35.665),(58.955,35.835),(59.125,35.835),(59.125,35.665),(58.955,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,34.305),(41.795,34.475),(41.965,34.475),(41.965,34.305),(41.795,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,34.645),(41.795,34.815),(41.965,34.815),(41.965,34.645),(41.795,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,33.965),(43.355,34.135),(43.525,34.135),(43.525,33.965),(43.355,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((46.475,29.885),(46.475,30.055),(46.645,30.055),(46.645,29.885),(46.475,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,34.305),(43.355,34.475),(43.525,34.475),(43.525,34.305),(43.355,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((43.355,34.645),(43.355,34.815),(43.525,34.815),(43.525,34.645),(43.355,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,29.545),(48.035,29.715),(48.205,29.715),(48.205,29.545),(48.035,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,19.865),(71.785,20.035),(71.955,20.035),(71.955,19.865),(71.785,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,33.965),(40.235,34.135),(40.405,34.135),(40.405,33.965),(40.235,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,18.845),(70.225,19.015),(70.395,19.015),(70.395,18.845),(70.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,33.965),(35.555,34.135),(35.725,34.135),(35.725,33.965),(35.555,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.275,34.985),(54.275,35.155),(54.445,35.155),(54.445,34.985),(54.275,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,32.945),(57.395,33.115),(57.565,33.115),(57.565,32.945),(57.395,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,29.545),(33.995,29.715),(34.165,29.715),(34.165,29.545),(33.995,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,30.905),(55.835,31.075),(56.005,31.075),(56.005,30.905),(55.835,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,30.225),(30.875,30.395),(31.045,30.395),(31.045,30.225),(30.875,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,33.285),(41.795,33.455),(41.965,33.455),(41.965,33.285),(41.795,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,33.625),(41.795,33.795),(41.965,33.795),(41.965,33.625),(41.795,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,30.565),(30.875,30.735),(31.045,30.735),(31.045,30.565),(30.875,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,33.285),(37.115,33.455),(37.285,33.455),(37.285,33.285),(37.115,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.115,33.625),(37.115,33.795),(37.285,33.795),(37.285,33.625),(37.115,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,12.385),(68.665,12.555),(68.835,12.555),(68.835,12.385),(68.665,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,8.305),(71.785,8.475),(71.955,8.475),(71.955,8.305),(71.785,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,8.645),(71.785,8.815),(71.955,8.815),(71.955,8.645),(71.785,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,29.545),(57.395,29.715),(57.565,29.715),(57.565,29.545),(57.395,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,30.225),(48.035,30.395),(48.205,30.395),(48.205,30.225),(48.035,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,30.565),(48.035,30.735),(48.205,30.735),(48.205,30.565),(48.035,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,34.985),(33.995,35.155),(34.165,35.155),(34.165,34.985),(33.995,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,10.345),(70.225,10.515),(70.395,10.515),(70.395,10.345),(70.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,10.685),(70.225,10.855),(70.395,10.855),(70.395,10.685),(70.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((70.225,10.005),(70.225,10.175),(70.395,10.175),(70.395,10.005),(70.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,30.905),(52.715,31.075),(52.885,31.075),(52.885,30.905),(52.715,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,19.865),(73.345,20.035),(73.515,20.035),(73.515,19.865),(73.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,33.965),(52.715,34.135),(52.885,34.135),(52.885,33.965),(52.715,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,32.945),(62.075,33.115),(62.245,33.115),(62.245,32.945),(62.075,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,32.945),(33.995,33.115),(34.165,33.115),(34.165,32.945),(33.995,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,35.665),(48.035,35.835),(48.205,35.835),(48.205,35.665),(48.035,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,35.325),(48.035,35.495),(48.205,35.495),(48.205,35.325),(48.035,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,14.085),(73.345,14.255),(73.515,14.255),(73.515,14.085),(73.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,14.425),(73.345,14.595),(73.515,14.595),(73.515,14.425),(73.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,14.765),(73.345,14.935),(73.515,14.935),(73.515,14.765),(73.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,32.265),(58.955,32.435),(59.125,32.435),(59.125,32.265),(58.955,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,32.605),(58.955,32.775),(59.125,32.775),(59.125,32.605),(58.955,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,33.285),(26.195,33.455),(26.365,33.455),(26.365,33.285),(26.195,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.235,29.885),(40.235,30.055),(40.405,30.055),(40.405,29.885),(40.235,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.195,33.625),(26.195,33.795),(26.365,33.795),(26.365,33.625),(26.195,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.985),(44.915,35.155),(45.085,35.155),(45.085,34.985),(44.915,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((63.635,36.005),(63.635,36.175),(63.805,36.175),(63.805,36.005),(63.635,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,15.445),(71.785,15.615),(71.955,15.615),(71.955,15.445),(71.785,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,15.785),(71.785,15.955),(71.955,15.955),(71.955,15.785),(71.785,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((71.785,15.105),(71.785,15.275),(71.955,15.275),(71.955,15.105),(71.785,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,31.925),(57.395,32.095),(57.565,32.095),(57.565,31.925),(57.395,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((62.075,33.965),(62.075,34.135),(62.245,34.135),(62.245,33.965),(62.075,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,31.245),(48.035,31.415),(48.205,31.415),(48.205,31.245),(48.035,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((48.035,31.585),(48.035,31.755),(48.205,31.755),(48.205,31.585),(48.035,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,31.925),(35.555,32.095),(35.725,32.095),(35.725,31.925),(35.555,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,35.325),(51.155,35.495),(51.325,35.495),(51.325,35.325),(51.155,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.155,35.665),(51.155,35.835),(51.325,35.835),(51.325,35.665),(51.155,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,29.545),(32.435,29.715),(32.605,29.715),(32.605,29.545),(32.435,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,36.005),(32.435,36.175),(32.605,36.175),(32.605,36.005),(32.435,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.395,36.005),(57.395,36.175),(57.565,36.175),(57.565,36.005),(57.395,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,33.285),(33.995,33.455),(34.165,33.455),(34.165,33.285),(33.995,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,33.625),(33.995,33.795),(34.165,33.795),(34.165,33.625),(33.995,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,32.265),(38.675,32.435),(38.845,32.435),(38.845,32.265),(38.675,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((38.675,32.605),(38.675,32.775),(38.845,32.775),(38.845,32.605),(38.675,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,29.545),(58.955,29.715),(59.125,29.715),(59.125,29.545),(58.955,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.995,36.005),(33.995,36.175),(34.165,36.175),(34.165,36.005),(33.995,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,32.265),(41.795,32.435),(41.965,32.435),(41.965,32.265),(41.795,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((41.795,32.605),(41.795,32.775),(41.965,32.775),(41.965,32.605),(41.795,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.345,8.985),(73.345,9.155),(73.515,9.155),(73.515,8.985),(73.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.835,34.985),(55.835,35.155),(56.005,35.155),(56.005,34.985),(55.835,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.605),(44.915,32.775),(45.085,32.775),(45.085,32.605),(44.915,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.265),(44.915,32.435),(45.085,32.435),(45.085,32.265),(44.915,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.245),(44.915,31.415),(45.085,31.415),(45.085,31.245),(44.915,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.585),(44.915,31.755),(45.085,31.755),(45.085,31.585),(44.915,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,32.265),(52.715,32.435),(52.885,32.435),(52.885,32.265),(52.715,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.715,32.605),(52.715,32.775),(52.885,32.775),(52.885,32.605),(52.715,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.955,30.905),(58.955,31.075),(59.125,31.075),(59.125,30.905),(58.955,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,32.265),(32.435,32.435),(32.605,32.435),(32.605,32.265),(32.435,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.435,32.605),(32.435,32.775),(32.605,32.775),(32.605,32.605),(32.435,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.555,32.945),(35.555,33.115),(35.725,33.115),(35.725,32.945),(35.555,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((68.665,12.045),(68.665,12.215),(68.835,12.215),(68.835,12.045),(68.665,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.875,29.885),(30.875,30.055),(31.045,30.055),(31.045,29.885),(30.875,29.885)),
        )
        createRL(
            tech, net, 'li',
            ((29.315,29.465),(29.315,36.255),(29.485,36.255),(29.485,29.465),(29.315,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((29.315,29.535),(29.315,36.185),(29.485,36.185),(29.485,29.535),(29.315,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((29.315,29.465),(29.315,36.255),(29.485,36.255),(29.485,29.465),(29.315,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((52.715,29.465),(52.715,36.255),(52.885,36.255),(52.885,29.465),(52.715,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((52.715,29.535),(52.715,36.185),(52.885,36.185),(52.885,29.535),(52.715,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((52.715,29.465),(52.715,36.255),(52.885,36.255),(52.885,29.465),(52.715,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((27.755,29.465),(27.755,36.255),(27.925,36.255),(27.925,29.465),(27.755,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((27.755,29.535),(27.755,36.185),(27.925,36.185),(27.925,29.535),(27.755,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((27.755,29.465),(27.755,36.255),(27.925,36.255),(27.925,29.465),(27.755,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((38.675,29.465),(38.675,36.255),(38.845,36.255),(38.845,29.465),(38.675,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((46.475,29.465),(46.475,36.255),(46.645,36.255),(46.645,29.465),(46.475,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((46.475,29.535),(46.475,36.185),(46.645,36.185),(46.645,29.535),(46.475,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((46.475,29.465),(46.475,36.255),(46.645,36.255),(46.645,29.465),(46.475,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((40.235,29.465),(40.235,36.255),(40.405,36.255),(40.405,29.465),(40.235,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((40.235,29.535),(40.235,36.185),(40.405,36.185),(40.405,29.535),(40.235,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((40.235,29.465),(40.235,36.255),(40.405,36.255),(40.405,29.465),(40.235,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((68.665,7.435),(68.665,20.565),(68.835,20.565),(68.835,7.435),(68.665,7.435)),
        )
        createRL(
            tech, net, 'li',
            ((57.395,29.465),(57.395,36.255),(57.565,36.255),(57.565,29.465),(57.395,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((57.395,29.535),(57.395,36.185),(57.565,36.185),(57.565,29.535),(57.395,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((60.515,29.465),(60.515,36.255),(60.685,36.255),(60.685,29.465),(60.515,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((60.515,29.465),(60.515,36.255),(60.685,36.255),(60.685,29.465),(60.515,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((60.515,29.535),(60.515,36.185),(60.685,36.185),(60.685,29.535),(60.515,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((57.395,29.465),(57.395,36.255),(57.565,36.255),(57.565,29.465),(57.395,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((68.665,7.205),(68.665,20.795),(68.835,20.795),(68.835,7.205),(68.665,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((33.995,29.465),(33.995,36.255),(34.165,36.255),(34.165,29.465),(33.995,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((33.995,29.535),(33.995,36.185),(34.165,36.185),(34.165,29.535),(33.995,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((33.995,29.465),(33.995,36.255),(34.165,36.255),(34.165,29.465),(33.995,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((55.835,29.465),(55.835,36.255),(56.005,36.255),(56.005,29.465),(55.835,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((55.835,29.535),(55.835,36.185),(56.005,36.185),(56.005,29.535),(55.835,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((55.835,29.465),(55.835,36.255),(56.005,36.255),(56.005,29.465),(55.835,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((68.665,7.205),(68.665,20.795),(68.835,20.795),(68.835,7.205),(68.665,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((30.875,29.465),(30.875,36.255),(31.045,36.255),(31.045,29.465),(30.875,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((30.875,29.535),(30.875,36.185),(31.045,36.185),(31.045,29.535),(30.875,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((30.875,29.465),(30.875,36.255),(31.045,36.255),(31.045,29.465),(30.875,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((51.155,29.465),(51.155,36.255),(51.325,36.255),(51.325,29.465),(51.155,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((51.155,29.535),(51.155,36.185),(51.325,36.185),(51.325,29.535),(51.155,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((51.155,29.465),(51.155,36.255),(51.325,36.255),(51.325,29.465),(51.155,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((37.115,29.465),(37.115,36.255),(37.285,36.255),(37.285,29.465),(37.115,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((37.115,29.535),(37.115,36.185),(37.285,36.185),(37.285,29.535),(37.115,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((48.035,29.465),(48.035,36.255),(48.205,36.255),(48.205,29.465),(48.035,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((37.115,29.465),(37.115,36.255),(37.285,36.255),(37.285,29.465),(37.115,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((48.035,29.535),(48.035,36.185),(48.205,36.185),(48.205,29.535),(48.035,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((48.035,29.465),(48.035,36.255),(48.205,36.255),(48.205,29.465),(48.035,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((54.275,29.535),(54.275,36.185),(54.445,36.185),(54.445,29.535),(54.275,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((54.275,29.465),(54.275,36.255),(54.445,36.255),(54.445,29.465),(54.275,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((54.275,29.465),(54.275,36.255),(54.445,36.255),(54.445,29.465),(54.275,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((73.345,7.205),(73.345,20.795),(73.515,20.795),(73.515,7.205),(73.345,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((58.955,29.465),(58.955,36.255),(59.125,36.255),(59.125,29.465),(58.955,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((58.955,29.465),(58.955,36.255),(59.125,36.255),(59.125,29.465),(58.955,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((58.955,29.535),(58.955,36.185),(59.125,36.185),(59.125,29.535),(58.955,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((26.195,29.465),(26.195,36.255),(26.365,36.255),(26.365,29.465),(26.195,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((26.195,29.535),(26.195,36.185),(26.365,36.185),(26.365,29.535),(26.195,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((26.195,29.465),(26.195,36.255),(26.365,36.255),(26.365,29.465),(26.195,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((73.345,7.435),(73.345,20.565),(73.515,20.565),(73.515,7.435),(73.345,7.435)),
        )
        createRL(
            tech, net, 'li',
            ((73.345,7.205),(73.345,20.795),(73.515,20.795),(73.515,7.205),(73.345,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((35.555,29.465),(35.555,36.255),(35.725,36.255),(35.725,29.465),(35.555,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((35.555,29.535),(35.555,36.185),(35.725,36.185),(35.725,29.535),(35.555,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((35.555,29.465),(35.555,36.255),(35.725,36.255),(35.725,29.465),(35.555,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((38.675,29.535),(38.675,36.185),(38.845,36.185),(38.845,29.535),(38.675,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,29.535),(44.915,36.185),(45.085,36.185),(45.085,29.535),(44.915,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,29.465),(44.915,36.255),(45.085,36.255),(45.085,29.465),(44.915,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,29.465),(44.915,36.255),(45.085,36.255),(45.085,29.465),(44.915,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((49.595,29.535),(49.595,36.185),(49.765,36.185),(49.765,29.535),(49.595,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((49.595,29.465),(49.595,36.255),(49.765,36.255),(49.765,29.465),(49.595,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((49.595,29.465),(49.595,36.255),(49.765,36.255),(49.765,29.465),(49.595,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((70.225,7.205),(70.225,20.795),(70.395,20.795),(70.395,7.205),(70.225,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((70.225,7.435),(70.225,20.565),(70.395,20.565),(70.395,7.435),(70.225,7.435)),
        )
        createRL(
            tech, net, 'li',
            ((70.225,7.205),(70.225,20.795),(70.395,20.795),(70.395,7.205),(70.225,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((41.795,29.465),(41.795,36.255),(41.965,36.255),(41.965,29.465),(41.795,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((41.795,29.535),(41.795,36.185),(41.965,36.185),(41.965,29.535),(41.795,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((41.795,29.465),(41.795,36.255),(41.965,36.255),(41.965,29.465),(41.795,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((63.635,29.465),(63.635,36.255),(63.805,36.255),(63.805,29.465),(63.635,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((63.635,29.535),(63.635,36.185),(63.805,36.185),(63.805,29.535),(63.635,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((63.635,29.465),(63.635,36.255),(63.805,36.255),(63.805,29.465),(63.635,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((62.075,29.465),(62.075,36.255),(62.245,36.255),(62.245,29.465),(62.075,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((62.075,29.535),(62.075,36.185),(62.245,36.185),(62.245,29.535),(62.075,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((62.075,29.465),(62.075,36.255),(62.245,36.255),(62.245,29.465),(62.075,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((32.435,29.465),(32.435,36.255),(32.605,36.255),(32.605,29.465),(32.435,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((32.435,29.535),(32.435,36.185),(32.605,36.185),(32.605,29.535),(32.435,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((32.435,29.465),(32.435,36.255),(32.605,36.255),(32.605,29.465),(32.435,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((71.785,7.205),(71.785,20.795),(71.955,20.795),(71.955,7.205),(71.785,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((71.785,7.435),(71.785,20.565),(71.955,20.565),(71.955,7.435),(71.785,7.435)),
        )
        createRL(
            tech, net, 'li',
            ((71.785,7.205),(71.785,20.795),(71.955,20.795),(71.955,7.205),(71.785,7.205)),
        )
        createRL(
            tech, net, 'li',
            ((43.355,29.465),(43.355,36.255),(43.525,36.255),(43.525,29.465),(43.355,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((43.355,29.535),(43.355,36.185),(43.525,36.185),(43.525,29.535),(43.355,29.535)),
        )
        createRL(
            tech, net, 'li',
            ((43.355,29.465),(43.355,36.255),(43.525,36.255),(43.525,29.465),(43.355,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((38.675,29.465),(38.675,36.255),(38.845,36.255),(38.845,29.465),(38.675,29.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,29.535),(55.835,29.705),(56.005,29.705),(56.005,29.535),(55.835,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,29.895),(55.835,30.065),(56.005,30.065),(56.005,29.895),(55.835,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,30.255),(55.835,30.425),(56.005,30.425),(56.005,30.255),(55.835,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,30.615),(55.835,30.785),(56.005,30.785),(56.005,30.615),(55.835,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,30.975),(55.835,31.145),(56.005,31.145),(56.005,30.975),(55.835,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,31.335),(55.835,31.505),(56.005,31.505),(56.005,31.335),(55.835,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,31.695),(55.835,31.865),(56.005,31.865),(56.005,31.695),(55.835,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,32.055),(55.835,32.225),(56.005,32.225),(56.005,32.055),(55.835,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,32.415),(55.835,32.585),(56.005,32.585),(56.005,32.415),(55.835,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,32.775),(55.835,32.945),(56.005,32.945),(56.005,32.775),(55.835,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,33.135),(55.835,33.305),(56.005,33.305),(56.005,33.135),(55.835,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,33.495),(55.835,33.665),(56.005,33.665),(56.005,33.495),(55.835,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,33.855),(55.835,34.025),(56.005,34.025),(56.005,33.855),(55.835,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,34.215),(55.835,34.385),(56.005,34.385),(56.005,34.215),(55.835,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,34.575),(55.835,34.745),(56.005,34.745),(56.005,34.575),(55.835,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,34.935),(55.835,35.105),(56.005,35.105),(56.005,34.935),(55.835,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,35.295),(55.835,35.465),(56.005,35.465),(56.005,35.295),(55.835,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,35.655),(55.835,35.825),(56.005,35.825),(56.005,35.655),(55.835,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((55.835,36.015),(55.835,36.185),(56.005,36.185),(56.005,36.015),(55.835,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,29.535),(27.755,29.705),(27.925,29.705),(27.925,29.535),(27.755,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,29.895),(27.755,30.065),(27.925,30.065),(27.925,29.895),(27.755,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,30.255),(27.755,30.425),(27.925,30.425),(27.925,30.255),(27.755,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,30.615),(27.755,30.785),(27.925,30.785),(27.925,30.615),(27.755,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,30.975),(27.755,31.145),(27.925,31.145),(27.925,30.975),(27.755,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,31.335),(27.755,31.505),(27.925,31.505),(27.925,31.335),(27.755,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,31.695),(27.755,31.865),(27.925,31.865),(27.925,31.695),(27.755,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,32.055),(27.755,32.225),(27.925,32.225),(27.925,32.055),(27.755,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,32.415),(27.755,32.585),(27.925,32.585),(27.925,32.415),(27.755,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,32.775),(27.755,32.945),(27.925,32.945),(27.925,32.775),(27.755,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,33.135),(27.755,33.305),(27.925,33.305),(27.925,33.135),(27.755,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,33.495),(27.755,33.665),(27.925,33.665),(27.925,33.495),(27.755,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,33.855),(27.755,34.025),(27.925,34.025),(27.925,33.855),(27.755,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,34.215),(27.755,34.385),(27.925,34.385),(27.925,34.215),(27.755,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,34.575),(27.755,34.745),(27.925,34.745),(27.925,34.575),(27.755,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,34.935),(27.755,35.105),(27.925,35.105),(27.925,34.935),(27.755,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,35.295),(27.755,35.465),(27.925,35.465),(27.925,35.295),(27.755,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,35.655),(27.755,35.825),(27.925,35.825),(27.925,35.655),(27.755,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((27.755,36.015),(27.755,36.185),(27.925,36.185),(27.925,36.015),(27.755,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,29.535),(33.995,29.705),(34.165,29.705),(34.165,29.535),(33.995,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,29.895),(33.995,30.065),(34.165,30.065),(34.165,29.895),(33.995,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,30.255),(33.995,30.425),(34.165,30.425),(34.165,30.255),(33.995,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,30.615),(33.995,30.785),(34.165,30.785),(34.165,30.615),(33.995,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,30.975),(33.995,31.145),(34.165,31.145),(34.165,30.975),(33.995,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,31.335),(33.995,31.505),(34.165,31.505),(34.165,31.335),(33.995,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,31.695),(33.995,31.865),(34.165,31.865),(34.165,31.695),(33.995,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,32.055),(33.995,32.225),(34.165,32.225),(34.165,32.055),(33.995,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,32.415),(33.995,32.585),(34.165,32.585),(34.165,32.415),(33.995,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,32.775),(33.995,32.945),(34.165,32.945),(34.165,32.775),(33.995,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,33.135),(33.995,33.305),(34.165,33.305),(34.165,33.135),(33.995,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,33.495),(33.995,33.665),(34.165,33.665),(34.165,33.495),(33.995,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,33.855),(33.995,34.025),(34.165,34.025),(34.165,33.855),(33.995,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,34.215),(33.995,34.385),(34.165,34.385),(34.165,34.215),(33.995,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,34.575),(33.995,34.745),(34.165,34.745),(34.165,34.575),(33.995,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,34.935),(33.995,35.105),(34.165,35.105),(34.165,34.935),(33.995,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,35.295),(33.995,35.465),(34.165,35.465),(34.165,35.295),(33.995,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,35.655),(33.995,35.825),(34.165,35.825),(34.165,35.655),(33.995,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.995,36.015),(33.995,36.185),(34.165,36.185),(34.165,36.015),(33.995,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,29.535),(40.235,29.705),(40.405,29.705),(40.405,29.535),(40.235,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,29.895),(40.235,30.065),(40.405,30.065),(40.405,29.895),(40.235,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,30.255),(40.235,30.425),(40.405,30.425),(40.405,30.255),(40.235,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,30.615),(40.235,30.785),(40.405,30.785),(40.405,30.615),(40.235,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,30.975),(40.235,31.145),(40.405,31.145),(40.405,30.975),(40.235,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,31.335),(40.235,31.505),(40.405,31.505),(40.405,31.335),(40.235,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,31.695),(40.235,31.865),(40.405,31.865),(40.405,31.695),(40.235,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,32.055),(40.235,32.225),(40.405,32.225),(40.405,32.055),(40.235,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,32.415),(40.235,32.585),(40.405,32.585),(40.405,32.415),(40.235,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,32.775),(40.235,32.945),(40.405,32.945),(40.405,32.775),(40.235,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,33.135),(40.235,33.305),(40.405,33.305),(40.405,33.135),(40.235,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,33.495),(40.235,33.665),(40.405,33.665),(40.405,33.495),(40.235,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,33.855),(40.235,34.025),(40.405,34.025),(40.405,33.855),(40.235,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,34.215),(40.235,34.385),(40.405,34.385),(40.405,34.215),(40.235,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,34.575),(40.235,34.745),(40.405,34.745),(40.405,34.575),(40.235,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,34.935),(40.235,35.105),(40.405,35.105),(40.405,34.935),(40.235,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,35.295),(40.235,35.465),(40.405,35.465),(40.405,35.295),(40.235,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,35.655),(40.235,35.825),(40.405,35.825),(40.405,35.655),(40.235,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.235,36.015),(40.235,36.185),(40.405,36.185),(40.405,36.015),(40.235,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,29.535),(52.715,29.705),(52.885,29.705),(52.885,29.535),(52.715,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,29.895),(52.715,30.065),(52.885,30.065),(52.885,29.895),(52.715,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,30.255),(52.715,30.425),(52.885,30.425),(52.885,30.255),(52.715,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,30.615),(52.715,30.785),(52.885,30.785),(52.885,30.615),(52.715,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,30.975),(52.715,31.145),(52.885,31.145),(52.885,30.975),(52.715,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,31.335),(52.715,31.505),(52.885,31.505),(52.885,31.335),(52.715,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,31.695),(52.715,31.865),(52.885,31.865),(52.885,31.695),(52.715,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,32.055),(52.715,32.225),(52.885,32.225),(52.885,32.055),(52.715,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,32.415),(52.715,32.585),(52.885,32.585),(52.885,32.415),(52.715,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,32.775),(52.715,32.945),(52.885,32.945),(52.885,32.775),(52.715,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,33.135),(52.715,33.305),(52.885,33.305),(52.885,33.135),(52.715,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,33.495),(52.715,33.665),(52.885,33.665),(52.885,33.495),(52.715,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,33.855),(52.715,34.025),(52.885,34.025),(52.885,33.855),(52.715,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,34.215),(52.715,34.385),(52.885,34.385),(52.885,34.215),(52.715,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,34.575),(52.715,34.745),(52.885,34.745),(52.885,34.575),(52.715,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,34.935),(52.715,35.105),(52.885,35.105),(52.885,34.935),(52.715,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,35.295),(52.715,35.465),(52.885,35.465),(52.885,35.295),(52.715,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,35.655),(52.715,35.825),(52.885,35.825),(52.885,35.655),(52.715,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.715,36.015),(52.715,36.185),(52.885,36.185),(52.885,36.015),(52.715,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,29.535),(48.035,29.705),(48.205,29.705),(48.205,29.535),(48.035,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,29.895),(48.035,30.065),(48.205,30.065),(48.205,29.895),(48.035,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,30.255),(48.035,30.425),(48.205,30.425),(48.205,30.255),(48.035,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,30.615),(48.035,30.785),(48.205,30.785),(48.205,30.615),(48.035,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,30.975),(48.035,31.145),(48.205,31.145),(48.205,30.975),(48.035,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,31.335),(48.035,31.505),(48.205,31.505),(48.205,31.335),(48.035,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,31.695),(48.035,31.865),(48.205,31.865),(48.205,31.695),(48.035,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,32.055),(48.035,32.225),(48.205,32.225),(48.205,32.055),(48.035,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,32.415),(48.035,32.585),(48.205,32.585),(48.205,32.415),(48.035,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,32.775),(48.035,32.945),(48.205,32.945),(48.205,32.775),(48.035,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,33.135),(48.035,33.305),(48.205,33.305),(48.205,33.135),(48.035,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,33.495),(48.035,33.665),(48.205,33.665),(48.205,33.495),(48.035,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,33.855),(48.035,34.025),(48.205,34.025),(48.205,33.855),(48.035,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,34.215),(48.035,34.385),(48.205,34.385),(48.205,34.215),(48.035,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,34.575),(48.035,34.745),(48.205,34.745),(48.205,34.575),(48.035,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,34.935),(48.035,35.105),(48.205,35.105),(48.205,34.935),(48.035,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,35.295),(48.035,35.465),(48.205,35.465),(48.205,35.295),(48.035,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,35.655),(48.035,35.825),(48.205,35.825),(48.205,35.655),(48.035,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((48.035,36.015),(48.035,36.185),(48.205,36.185),(48.205,36.015),(48.035,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,29.535),(32.435,29.705),(32.605,29.705),(32.605,29.535),(32.435,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,29.895),(32.435,30.065),(32.605,30.065),(32.605,29.895),(32.435,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,30.255),(32.435,30.425),(32.605,30.425),(32.605,30.255),(32.435,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,30.615),(32.435,30.785),(32.605,30.785),(32.605,30.615),(32.435,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,30.975),(32.435,31.145),(32.605,31.145),(32.605,30.975),(32.435,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,31.335),(32.435,31.505),(32.605,31.505),(32.605,31.335),(32.435,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,31.695),(32.435,31.865),(32.605,31.865),(32.605,31.695),(32.435,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,32.055),(32.435,32.225),(32.605,32.225),(32.605,32.055),(32.435,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,32.415),(32.435,32.585),(32.605,32.585),(32.605,32.415),(32.435,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,32.775),(32.435,32.945),(32.605,32.945),(32.605,32.775),(32.435,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,33.135),(32.435,33.305),(32.605,33.305),(32.605,33.135),(32.435,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,33.495),(32.435,33.665),(32.605,33.665),(32.605,33.495),(32.435,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,33.855),(32.435,34.025),(32.605,34.025),(32.605,33.855),(32.435,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,34.215),(32.435,34.385),(32.605,34.385),(32.605,34.215),(32.435,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,34.575),(32.435,34.745),(32.605,34.745),(32.605,34.575),(32.435,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,34.935),(32.435,35.105),(32.605,35.105),(32.605,34.935),(32.435,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,35.295),(32.435,35.465),(32.605,35.465),(32.605,35.295),(32.435,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,35.655),(32.435,35.825),(32.605,35.825),(32.605,35.655),(32.435,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.435,36.015),(32.435,36.185),(32.605,36.185),(32.605,36.015),(32.435,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,7.435),(70.225,7.605),(70.395,7.605),(70.395,7.435),(70.225,7.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,7.795),(70.225,7.965),(70.395,7.965),(70.395,7.795),(70.225,7.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,8.155),(70.225,8.325),(70.395,8.325),(70.395,8.155),(70.225,8.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,8.515),(70.225,8.685),(70.395,8.685),(70.395,8.515),(70.225,8.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,8.875),(70.225,9.045),(70.395,9.045),(70.395,8.875),(70.225,8.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,9.235),(70.225,9.405),(70.395,9.405),(70.395,9.235),(70.225,9.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,9.595),(70.225,9.765),(70.395,9.765),(70.395,9.595),(70.225,9.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,9.955),(70.225,10.125),(70.395,10.125),(70.395,9.955),(70.225,9.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,10.315),(70.225,10.485),(70.395,10.485),(70.395,10.315),(70.225,10.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,10.675),(70.225,10.845),(70.395,10.845),(70.395,10.675),(70.225,10.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,11.035),(70.225,11.205),(70.395,11.205),(70.395,11.035),(70.225,11.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,11.395),(70.225,11.565),(70.395,11.565),(70.395,11.395),(70.225,11.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,11.755),(70.225,11.925),(70.395,11.925),(70.395,11.755),(70.225,11.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,12.115),(70.225,12.285),(70.395,12.285),(70.395,12.115),(70.225,12.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,12.475),(70.225,12.645),(70.395,12.645),(70.395,12.475),(70.225,12.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,12.835),(70.225,13.005),(70.395,13.005),(70.395,12.835),(70.225,12.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,13.195),(70.225,13.365),(70.395,13.365),(70.395,13.195),(70.225,13.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,13.555),(70.225,13.725),(70.395,13.725),(70.395,13.555),(70.225,13.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,13.915),(70.225,14.085),(70.395,14.085),(70.395,13.915),(70.225,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,14.275),(70.225,14.445),(70.395,14.445),(70.395,14.275),(70.225,14.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,14.635),(70.225,14.805),(70.395,14.805),(70.395,14.635),(70.225,14.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,14.995),(70.225,15.165),(70.395,15.165),(70.395,14.995),(70.225,14.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,15.355),(70.225,15.525),(70.395,15.525),(70.395,15.355),(70.225,15.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,15.715),(70.225,15.885),(70.395,15.885),(70.395,15.715),(70.225,15.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,16.075),(70.225,16.245),(70.395,16.245),(70.395,16.075),(70.225,16.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,16.435),(70.225,16.605),(70.395,16.605),(70.395,16.435),(70.225,16.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,16.795),(70.225,16.965),(70.395,16.965),(70.395,16.795),(70.225,16.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,17.155),(70.225,17.325),(70.395,17.325),(70.395,17.155),(70.225,17.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,17.515),(70.225,17.685),(70.395,17.685),(70.395,17.515),(70.225,17.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,17.875),(70.225,18.045),(70.395,18.045),(70.395,17.875),(70.225,17.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,18.235),(70.225,18.405),(70.395,18.405),(70.395,18.235),(70.225,18.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,18.595),(70.225,18.765),(70.395,18.765),(70.395,18.595),(70.225,18.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,18.955),(70.225,19.125),(70.395,19.125),(70.395,18.955),(70.225,18.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,19.315),(70.225,19.485),(70.395,19.485),(70.395,19.315),(70.225,19.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,19.675),(70.225,19.845),(70.395,19.845),(70.395,19.675),(70.225,19.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,20.035),(70.225,20.205),(70.395,20.205),(70.395,20.035),(70.225,20.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((70.225,20.395),(70.225,20.565),(70.395,20.565),(70.395,20.395),(70.225,20.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,29.535),(35.555,29.705),(35.725,29.705),(35.725,29.535),(35.555,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,29.895),(35.555,30.065),(35.725,30.065),(35.725,29.895),(35.555,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,30.255),(35.555,30.425),(35.725,30.425),(35.725,30.255),(35.555,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,30.615),(35.555,30.785),(35.725,30.785),(35.725,30.615),(35.555,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,30.975),(35.555,31.145),(35.725,31.145),(35.725,30.975),(35.555,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,31.335),(35.555,31.505),(35.725,31.505),(35.725,31.335),(35.555,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,31.695),(35.555,31.865),(35.725,31.865),(35.725,31.695),(35.555,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,32.055),(35.555,32.225),(35.725,32.225),(35.725,32.055),(35.555,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,32.415),(35.555,32.585),(35.725,32.585),(35.725,32.415),(35.555,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,32.775),(35.555,32.945),(35.725,32.945),(35.725,32.775),(35.555,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,33.135),(35.555,33.305),(35.725,33.305),(35.725,33.135),(35.555,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,33.495),(35.555,33.665),(35.725,33.665),(35.725,33.495),(35.555,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,33.855),(35.555,34.025),(35.725,34.025),(35.725,33.855),(35.555,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,34.215),(35.555,34.385),(35.725,34.385),(35.725,34.215),(35.555,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,34.575),(35.555,34.745),(35.725,34.745),(35.725,34.575),(35.555,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,34.935),(35.555,35.105),(35.725,35.105),(35.725,34.935),(35.555,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,35.295),(35.555,35.465),(35.725,35.465),(35.725,35.295),(35.555,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,35.655),(35.555,35.825),(35.725,35.825),(35.725,35.655),(35.555,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.555,36.015),(35.555,36.185),(35.725,36.185),(35.725,36.015),(35.555,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,29.535),(58.955,29.705),(59.125,29.705),(59.125,29.535),(58.955,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,29.895),(58.955,30.065),(59.125,30.065),(59.125,29.895),(58.955,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,30.255),(58.955,30.425),(59.125,30.425),(59.125,30.255),(58.955,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,30.615),(58.955,30.785),(59.125,30.785),(59.125,30.615),(58.955,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,30.975),(58.955,31.145),(59.125,31.145),(59.125,30.975),(58.955,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,31.335),(58.955,31.505),(59.125,31.505),(59.125,31.335),(58.955,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,31.695),(58.955,31.865),(59.125,31.865),(59.125,31.695),(58.955,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,32.055),(58.955,32.225),(59.125,32.225),(59.125,32.055),(58.955,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,32.415),(58.955,32.585),(59.125,32.585),(59.125,32.415),(58.955,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,32.775),(58.955,32.945),(59.125,32.945),(59.125,32.775),(58.955,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,33.135),(58.955,33.305),(59.125,33.305),(59.125,33.135),(58.955,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,33.495),(58.955,33.665),(59.125,33.665),(59.125,33.495),(58.955,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,33.855),(58.955,34.025),(59.125,34.025),(59.125,33.855),(58.955,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,34.215),(58.955,34.385),(59.125,34.385),(59.125,34.215),(58.955,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,34.575),(58.955,34.745),(59.125,34.745),(59.125,34.575),(58.955,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,34.935),(58.955,35.105),(59.125,35.105),(59.125,34.935),(58.955,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,35.295),(58.955,35.465),(59.125,35.465),(59.125,35.295),(58.955,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,35.655),(58.955,35.825),(59.125,35.825),(59.125,35.655),(58.955,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((58.955,36.015),(58.955,36.185),(59.125,36.185),(59.125,36.015),(58.955,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,29.535),(41.795,29.705),(41.965,29.705),(41.965,29.535),(41.795,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,29.895),(41.795,30.065),(41.965,30.065),(41.965,29.895),(41.795,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,30.255),(41.795,30.425),(41.965,30.425),(41.965,30.255),(41.795,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,30.615),(41.795,30.785),(41.965,30.785),(41.965,30.615),(41.795,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,30.975),(41.795,31.145),(41.965,31.145),(41.965,30.975),(41.795,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,31.335),(41.795,31.505),(41.965,31.505),(41.965,31.335),(41.795,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,31.695),(41.795,31.865),(41.965,31.865),(41.965,31.695),(41.795,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,32.055),(41.795,32.225),(41.965,32.225),(41.965,32.055),(41.795,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,32.415),(41.795,32.585),(41.965,32.585),(41.965,32.415),(41.795,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,32.775),(41.795,32.945),(41.965,32.945),(41.965,32.775),(41.795,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,33.135),(41.795,33.305),(41.965,33.305),(41.965,33.135),(41.795,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,33.495),(41.795,33.665),(41.965,33.665),(41.965,33.495),(41.795,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,33.855),(41.795,34.025),(41.965,34.025),(41.965,33.855),(41.795,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,34.215),(41.795,34.385),(41.965,34.385),(41.965,34.215),(41.795,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,34.575),(41.795,34.745),(41.965,34.745),(41.965,34.575),(41.795,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,34.935),(41.795,35.105),(41.965,35.105),(41.965,34.935),(41.795,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,35.295),(41.795,35.465),(41.965,35.465),(41.965,35.295),(41.795,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,35.655),(41.795,35.825),(41.965,35.825),(41.965,35.655),(41.795,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.795,36.015),(41.795,36.185),(41.965,36.185),(41.965,36.015),(41.795,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,29.535),(54.275,29.705),(54.445,29.705),(54.445,29.535),(54.275,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,29.895),(54.275,30.065),(54.445,30.065),(54.445,29.895),(54.275,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,30.255),(54.275,30.425),(54.445,30.425),(54.445,30.255),(54.275,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,30.615),(54.275,30.785),(54.445,30.785),(54.445,30.615),(54.275,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,30.975),(54.275,31.145),(54.445,31.145),(54.445,30.975),(54.275,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,31.335),(54.275,31.505),(54.445,31.505),(54.445,31.335),(54.275,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,31.695),(54.275,31.865),(54.445,31.865),(54.445,31.695),(54.275,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,32.055),(54.275,32.225),(54.445,32.225),(54.445,32.055),(54.275,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,32.415),(54.275,32.585),(54.445,32.585),(54.445,32.415),(54.275,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,32.775),(54.275,32.945),(54.445,32.945),(54.445,32.775),(54.275,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,33.135),(54.275,33.305),(54.445,33.305),(54.445,33.135),(54.275,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,33.495),(54.275,33.665),(54.445,33.665),(54.445,33.495),(54.275,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,33.855),(54.275,34.025),(54.445,34.025),(54.445,33.855),(54.275,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,34.215),(54.275,34.385),(54.445,34.385),(54.445,34.215),(54.275,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,34.575),(54.275,34.745),(54.445,34.745),(54.445,34.575),(54.275,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,34.935),(54.275,35.105),(54.445,35.105),(54.445,34.935),(54.275,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,35.295),(54.275,35.465),(54.445,35.465),(54.445,35.295),(54.275,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,35.655),(54.275,35.825),(54.445,35.825),(54.445,35.655),(54.275,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.275,36.015),(54.275,36.185),(54.445,36.185),(54.445,36.015),(54.275,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,29.535),(29.315,29.705),(29.485,29.705),(29.485,29.535),(29.315,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,29.895),(29.315,30.065),(29.485,30.065),(29.485,29.895),(29.315,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,30.255),(29.315,30.425),(29.485,30.425),(29.485,30.255),(29.315,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,30.615),(29.315,30.785),(29.485,30.785),(29.485,30.615),(29.315,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,30.975),(29.315,31.145),(29.485,31.145),(29.485,30.975),(29.315,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,31.335),(29.315,31.505),(29.485,31.505),(29.485,31.335),(29.315,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,31.695),(29.315,31.865),(29.485,31.865),(29.485,31.695),(29.315,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,32.055),(29.315,32.225),(29.485,32.225),(29.485,32.055),(29.315,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,32.415),(29.315,32.585),(29.485,32.585),(29.485,32.415),(29.315,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,32.775),(29.315,32.945),(29.485,32.945),(29.485,32.775),(29.315,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,33.135),(29.315,33.305),(29.485,33.305),(29.485,33.135),(29.315,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,33.495),(29.315,33.665),(29.485,33.665),(29.485,33.495),(29.315,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,33.855),(29.315,34.025),(29.485,34.025),(29.485,33.855),(29.315,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,34.215),(29.315,34.385),(29.485,34.385),(29.485,34.215),(29.315,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,34.575),(29.315,34.745),(29.485,34.745),(29.485,34.575),(29.315,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,34.935),(29.315,35.105),(29.485,35.105),(29.485,34.935),(29.315,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,35.295),(29.315,35.465),(29.485,35.465),(29.485,35.295),(29.315,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,35.655),(29.315,35.825),(29.485,35.825),(29.485,35.655),(29.315,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((29.315,36.015),(29.315,36.185),(29.485,36.185),(29.485,36.015),(29.315,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,29.535),(63.635,29.705),(63.805,29.705),(63.805,29.535),(63.635,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,29.895),(63.635,30.065),(63.805,30.065),(63.805,29.895),(63.635,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,30.255),(63.635,30.425),(63.805,30.425),(63.805,30.255),(63.635,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,30.615),(63.635,30.785),(63.805,30.785),(63.805,30.615),(63.635,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,30.975),(63.635,31.145),(63.805,31.145),(63.805,30.975),(63.635,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,31.335),(63.635,31.505),(63.805,31.505),(63.805,31.335),(63.635,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,31.695),(63.635,31.865),(63.805,31.865),(63.805,31.695),(63.635,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,32.055),(63.635,32.225),(63.805,32.225),(63.805,32.055),(63.635,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,32.415),(63.635,32.585),(63.805,32.585),(63.805,32.415),(63.635,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,32.775),(63.635,32.945),(63.805,32.945),(63.805,32.775),(63.635,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,33.135),(63.635,33.305),(63.805,33.305),(63.805,33.135),(63.635,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,33.495),(63.635,33.665),(63.805,33.665),(63.805,33.495),(63.635,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,33.855),(63.635,34.025),(63.805,34.025),(63.805,33.855),(63.635,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,34.215),(63.635,34.385),(63.805,34.385),(63.805,34.215),(63.635,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,34.575),(63.635,34.745),(63.805,34.745),(63.805,34.575),(63.635,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,34.935),(63.635,35.105),(63.805,35.105),(63.805,34.935),(63.635,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,35.295),(63.635,35.465),(63.805,35.465),(63.805,35.295),(63.635,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,35.655),(63.635,35.825),(63.805,35.825),(63.805,35.655),(63.635,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((63.635,36.015),(63.635,36.185),(63.805,36.185),(63.805,36.015),(63.635,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,29.535),(49.595,29.705),(49.765,29.705),(49.765,29.535),(49.595,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,29.895),(49.595,30.065),(49.765,30.065),(49.765,29.895),(49.595,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,30.255),(49.595,30.425),(49.765,30.425),(49.765,30.255),(49.595,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,30.615),(49.595,30.785),(49.765,30.785),(49.765,30.615),(49.595,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,30.975),(49.595,31.145),(49.765,31.145),(49.765,30.975),(49.595,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,31.335),(49.595,31.505),(49.765,31.505),(49.765,31.335),(49.595,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,31.695),(49.595,31.865),(49.765,31.865),(49.765,31.695),(49.595,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,32.055),(49.595,32.225),(49.765,32.225),(49.765,32.055),(49.595,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,32.415),(49.595,32.585),(49.765,32.585),(49.765,32.415),(49.595,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,32.775),(49.595,32.945),(49.765,32.945),(49.765,32.775),(49.595,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,33.135),(49.595,33.305),(49.765,33.305),(49.765,33.135),(49.595,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,33.495),(49.595,33.665),(49.765,33.665),(49.765,33.495),(49.595,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,33.855),(49.595,34.025),(49.765,34.025),(49.765,33.855),(49.595,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,34.215),(49.595,34.385),(49.765,34.385),(49.765,34.215),(49.595,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,34.575),(49.595,34.745),(49.765,34.745),(49.765,34.575),(49.595,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,34.935),(49.595,35.105),(49.765,35.105),(49.765,34.935),(49.595,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,35.295),(49.595,35.465),(49.765,35.465),(49.765,35.295),(49.595,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,35.655),(49.595,35.825),(49.765,35.825),(49.765,35.655),(49.595,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.595,36.015),(49.595,36.185),(49.765,36.185),(49.765,36.015),(49.595,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,29.535),(51.155,29.705),(51.325,29.705),(51.325,29.535),(51.155,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,29.895),(51.155,30.065),(51.325,30.065),(51.325,29.895),(51.155,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,30.255),(51.155,30.425),(51.325,30.425),(51.325,30.255),(51.155,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,30.615),(51.155,30.785),(51.325,30.785),(51.325,30.615),(51.155,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,30.975),(51.155,31.145),(51.325,31.145),(51.325,30.975),(51.155,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,31.335),(51.155,31.505),(51.325,31.505),(51.325,31.335),(51.155,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,31.695),(51.155,31.865),(51.325,31.865),(51.325,31.695),(51.155,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,32.055),(51.155,32.225),(51.325,32.225),(51.325,32.055),(51.155,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,32.415),(51.155,32.585),(51.325,32.585),(51.325,32.415),(51.155,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,32.775),(51.155,32.945),(51.325,32.945),(51.325,32.775),(51.155,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,33.135),(51.155,33.305),(51.325,33.305),(51.325,33.135),(51.155,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,33.495),(51.155,33.665),(51.325,33.665),(51.325,33.495),(51.155,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,33.855),(51.155,34.025),(51.325,34.025),(51.325,33.855),(51.155,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,34.215),(51.155,34.385),(51.325,34.385),(51.325,34.215),(51.155,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,34.575),(51.155,34.745),(51.325,34.745),(51.325,34.575),(51.155,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,34.935),(51.155,35.105),(51.325,35.105),(51.325,34.935),(51.155,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,35.295),(51.155,35.465),(51.325,35.465),(51.325,35.295),(51.155,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,35.655),(51.155,35.825),(51.325,35.825),(51.325,35.655),(51.155,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.155,36.015),(51.155,36.185),(51.325,36.185),(51.325,36.015),(51.155,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,29.535),(57.395,29.705),(57.565,29.705),(57.565,29.535),(57.395,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,29.895),(57.395,30.065),(57.565,30.065),(57.565,29.895),(57.395,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,30.255),(57.395,30.425),(57.565,30.425),(57.565,30.255),(57.395,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,30.615),(57.395,30.785),(57.565,30.785),(57.565,30.615),(57.395,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,30.975),(57.395,31.145),(57.565,31.145),(57.565,30.975),(57.395,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,31.335),(57.395,31.505),(57.565,31.505),(57.565,31.335),(57.395,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,31.695),(57.395,31.865),(57.565,31.865),(57.565,31.695),(57.395,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,32.055),(57.395,32.225),(57.565,32.225),(57.565,32.055),(57.395,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,32.415),(57.395,32.585),(57.565,32.585),(57.565,32.415),(57.395,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,32.775),(57.395,32.945),(57.565,32.945),(57.565,32.775),(57.395,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,33.135),(57.395,33.305),(57.565,33.305),(57.565,33.135),(57.395,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,33.495),(57.395,33.665),(57.565,33.665),(57.565,33.495),(57.395,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,33.855),(57.395,34.025),(57.565,34.025),(57.565,33.855),(57.395,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,34.215),(57.395,34.385),(57.565,34.385),(57.565,34.215),(57.395,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,34.575),(57.395,34.745),(57.565,34.745),(57.565,34.575),(57.395,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,34.935),(57.395,35.105),(57.565,35.105),(57.565,34.935),(57.395,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,35.295),(57.395,35.465),(57.565,35.465),(57.565,35.295),(57.395,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,35.655),(57.395,35.825),(57.565,35.825),(57.565,35.655),(57.395,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.395,36.015),(57.395,36.185),(57.565,36.185),(57.565,36.015),(57.395,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,29.535),(26.195,29.705),(26.365,29.705),(26.365,29.535),(26.195,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,29.895),(26.195,30.065),(26.365,30.065),(26.365,29.895),(26.195,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,30.255),(26.195,30.425),(26.365,30.425),(26.365,30.255),(26.195,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,30.615),(26.195,30.785),(26.365,30.785),(26.365,30.615),(26.195,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,30.975),(26.195,31.145),(26.365,31.145),(26.365,30.975),(26.195,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,31.335),(26.195,31.505),(26.365,31.505),(26.365,31.335),(26.195,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,31.695),(26.195,31.865),(26.365,31.865),(26.365,31.695),(26.195,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,32.055),(26.195,32.225),(26.365,32.225),(26.365,32.055),(26.195,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,32.415),(26.195,32.585),(26.365,32.585),(26.365,32.415),(26.195,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,32.775),(26.195,32.945),(26.365,32.945),(26.365,32.775),(26.195,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,33.135),(26.195,33.305),(26.365,33.305),(26.365,33.135),(26.195,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,33.495),(26.195,33.665),(26.365,33.665),(26.365,33.495),(26.195,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,33.855),(26.195,34.025),(26.365,34.025),(26.365,33.855),(26.195,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,34.215),(26.195,34.385),(26.365,34.385),(26.365,34.215),(26.195,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,34.575),(26.195,34.745),(26.365,34.745),(26.365,34.575),(26.195,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,34.935),(26.195,35.105),(26.365,35.105),(26.365,34.935),(26.195,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,35.295),(26.195,35.465),(26.365,35.465),(26.365,35.295),(26.195,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,35.655),(26.195,35.825),(26.365,35.825),(26.365,35.655),(26.195,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((26.195,36.015),(26.195,36.185),(26.365,36.185),(26.365,36.015),(26.195,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,29.535),(62.075,29.705),(62.245,29.705),(62.245,29.535),(62.075,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,29.895),(62.075,30.065),(62.245,30.065),(62.245,29.895),(62.075,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,30.255),(62.075,30.425),(62.245,30.425),(62.245,30.255),(62.075,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,30.615),(62.075,30.785),(62.245,30.785),(62.245,30.615),(62.075,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,30.975),(62.075,31.145),(62.245,31.145),(62.245,30.975),(62.075,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,31.335),(62.075,31.505),(62.245,31.505),(62.245,31.335),(62.075,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,31.695),(62.075,31.865),(62.245,31.865),(62.245,31.695),(62.075,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,32.055),(62.075,32.225),(62.245,32.225),(62.245,32.055),(62.075,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,32.415),(62.075,32.585),(62.245,32.585),(62.245,32.415),(62.075,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,32.775),(62.075,32.945),(62.245,32.945),(62.245,32.775),(62.075,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,33.135),(62.075,33.305),(62.245,33.305),(62.245,33.135),(62.075,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,33.495),(62.075,33.665),(62.245,33.665),(62.245,33.495),(62.075,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,33.855),(62.075,34.025),(62.245,34.025),(62.245,33.855),(62.075,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,34.215),(62.075,34.385),(62.245,34.385),(62.245,34.215),(62.075,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,34.575),(62.075,34.745),(62.245,34.745),(62.245,34.575),(62.075,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,34.935),(62.075,35.105),(62.245,35.105),(62.245,34.935),(62.075,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,35.295),(62.075,35.465),(62.245,35.465),(62.245,35.295),(62.075,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,35.655),(62.075,35.825),(62.245,35.825),(62.245,35.655),(62.075,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((62.075,36.015),(62.075,36.185),(62.245,36.185),(62.245,36.015),(62.075,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,7.435),(68.665,7.605),(68.835,7.605),(68.835,7.435),(68.665,7.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,7.795),(68.665,7.965),(68.835,7.965),(68.835,7.795),(68.665,7.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,8.155),(68.665,8.325),(68.835,8.325),(68.835,8.155),(68.665,8.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,8.515),(68.665,8.685),(68.835,8.685),(68.835,8.515),(68.665,8.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,8.875),(68.665,9.045),(68.835,9.045),(68.835,8.875),(68.665,8.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,9.235),(68.665,9.405),(68.835,9.405),(68.835,9.235),(68.665,9.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,9.595),(68.665,9.765),(68.835,9.765),(68.835,9.595),(68.665,9.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,9.955),(68.665,10.125),(68.835,10.125),(68.835,9.955),(68.665,9.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,10.315),(68.665,10.485),(68.835,10.485),(68.835,10.315),(68.665,10.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,10.675),(68.665,10.845),(68.835,10.845),(68.835,10.675),(68.665,10.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,11.035),(68.665,11.205),(68.835,11.205),(68.835,11.035),(68.665,11.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,11.395),(68.665,11.565),(68.835,11.565),(68.835,11.395),(68.665,11.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,11.755),(68.665,11.925),(68.835,11.925),(68.835,11.755),(68.665,11.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,12.115),(68.665,12.285),(68.835,12.285),(68.835,12.115),(68.665,12.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,12.475),(68.665,12.645),(68.835,12.645),(68.835,12.475),(68.665,12.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,12.835),(68.665,13.005),(68.835,13.005),(68.835,12.835),(68.665,12.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,13.195),(68.665,13.365),(68.835,13.365),(68.835,13.195),(68.665,13.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,13.555),(68.665,13.725),(68.835,13.725),(68.835,13.555),(68.665,13.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,13.915),(68.665,14.085),(68.835,14.085),(68.835,13.915),(68.665,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,14.275),(68.665,14.445),(68.835,14.445),(68.835,14.275),(68.665,14.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,14.635),(68.665,14.805),(68.835,14.805),(68.835,14.635),(68.665,14.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,14.995),(68.665,15.165),(68.835,15.165),(68.835,14.995),(68.665,14.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,15.355),(68.665,15.525),(68.835,15.525),(68.835,15.355),(68.665,15.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,15.715),(68.665,15.885),(68.835,15.885),(68.835,15.715),(68.665,15.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,16.075),(68.665,16.245),(68.835,16.245),(68.835,16.075),(68.665,16.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,16.435),(68.665,16.605),(68.835,16.605),(68.835,16.435),(68.665,16.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,16.795),(68.665,16.965),(68.835,16.965),(68.835,16.795),(68.665,16.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,17.155),(68.665,17.325),(68.835,17.325),(68.835,17.155),(68.665,17.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,17.515),(68.665,17.685),(68.835,17.685),(68.835,17.515),(68.665,17.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,17.875),(68.665,18.045),(68.835,18.045),(68.835,17.875),(68.665,17.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,18.235),(68.665,18.405),(68.835,18.405),(68.835,18.235),(68.665,18.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,18.595),(68.665,18.765),(68.835,18.765),(68.835,18.595),(68.665,18.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,18.955),(68.665,19.125),(68.835,19.125),(68.835,18.955),(68.665,18.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,19.315),(68.665,19.485),(68.835,19.485),(68.835,19.315),(68.665,19.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,19.675),(68.665,19.845),(68.835,19.845),(68.835,19.675),(68.665,19.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,20.035),(68.665,20.205),(68.835,20.205),(68.835,20.035),(68.665,20.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((68.665,20.395),(68.665,20.565),(68.835,20.565),(68.835,20.395),(68.665,20.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,29.535),(37.115,29.705),(37.285,29.705),(37.285,29.535),(37.115,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,29.895),(37.115,30.065),(37.285,30.065),(37.285,29.895),(37.115,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,30.255),(37.115,30.425),(37.285,30.425),(37.285,30.255),(37.115,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,30.615),(37.115,30.785),(37.285,30.785),(37.285,30.615),(37.115,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,30.975),(37.115,31.145),(37.285,31.145),(37.285,30.975),(37.115,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,31.335),(37.115,31.505),(37.285,31.505),(37.285,31.335),(37.115,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,31.695),(37.115,31.865),(37.285,31.865),(37.285,31.695),(37.115,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,32.055),(37.115,32.225),(37.285,32.225),(37.285,32.055),(37.115,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,32.415),(37.115,32.585),(37.285,32.585),(37.285,32.415),(37.115,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,32.775),(37.115,32.945),(37.285,32.945),(37.285,32.775),(37.115,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,33.135),(37.115,33.305),(37.285,33.305),(37.285,33.135),(37.115,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,33.495),(37.115,33.665),(37.285,33.665),(37.285,33.495),(37.115,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,33.855),(37.115,34.025),(37.285,34.025),(37.285,33.855),(37.115,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,34.215),(37.115,34.385),(37.285,34.385),(37.285,34.215),(37.115,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,34.575),(37.115,34.745),(37.285,34.745),(37.285,34.575),(37.115,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,34.935),(37.115,35.105),(37.285,35.105),(37.285,34.935),(37.115,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,35.295),(37.115,35.465),(37.285,35.465),(37.285,35.295),(37.115,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,35.655),(37.115,35.825),(37.285,35.825),(37.285,35.655),(37.115,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.115,36.015),(37.115,36.185),(37.285,36.185),(37.285,36.015),(37.115,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,7.435),(71.785,7.605),(71.955,7.605),(71.955,7.435),(71.785,7.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,7.795),(71.785,7.965),(71.955,7.965),(71.955,7.795),(71.785,7.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,8.155),(71.785,8.325),(71.955,8.325),(71.955,8.155),(71.785,8.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,8.515),(71.785,8.685),(71.955,8.685),(71.955,8.515),(71.785,8.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,8.875),(71.785,9.045),(71.955,9.045),(71.955,8.875),(71.785,8.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,9.235),(71.785,9.405),(71.955,9.405),(71.955,9.235),(71.785,9.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,9.595),(71.785,9.765),(71.955,9.765),(71.955,9.595),(71.785,9.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,9.955),(71.785,10.125),(71.955,10.125),(71.955,9.955),(71.785,9.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,10.315),(71.785,10.485),(71.955,10.485),(71.955,10.315),(71.785,10.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,10.675),(71.785,10.845),(71.955,10.845),(71.955,10.675),(71.785,10.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,11.035),(71.785,11.205),(71.955,11.205),(71.955,11.035),(71.785,11.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,11.395),(71.785,11.565),(71.955,11.565),(71.955,11.395),(71.785,11.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,11.755),(71.785,11.925),(71.955,11.925),(71.955,11.755),(71.785,11.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,12.115),(71.785,12.285),(71.955,12.285),(71.955,12.115),(71.785,12.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,12.475),(71.785,12.645),(71.955,12.645),(71.955,12.475),(71.785,12.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,12.835),(71.785,13.005),(71.955,13.005),(71.955,12.835),(71.785,12.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,13.195),(71.785,13.365),(71.955,13.365),(71.955,13.195),(71.785,13.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,13.555),(71.785,13.725),(71.955,13.725),(71.955,13.555),(71.785,13.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,13.915),(71.785,14.085),(71.955,14.085),(71.955,13.915),(71.785,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,14.275),(71.785,14.445),(71.955,14.445),(71.955,14.275),(71.785,14.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,14.635),(71.785,14.805),(71.955,14.805),(71.955,14.635),(71.785,14.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,14.995),(71.785,15.165),(71.955,15.165),(71.955,14.995),(71.785,14.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,15.355),(71.785,15.525),(71.955,15.525),(71.955,15.355),(71.785,15.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,15.715),(71.785,15.885),(71.955,15.885),(71.955,15.715),(71.785,15.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,16.075),(71.785,16.245),(71.955,16.245),(71.955,16.075),(71.785,16.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,16.435),(71.785,16.605),(71.955,16.605),(71.955,16.435),(71.785,16.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,16.795),(71.785,16.965),(71.955,16.965),(71.955,16.795),(71.785,16.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,17.155),(71.785,17.325),(71.955,17.325),(71.955,17.155),(71.785,17.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,17.515),(71.785,17.685),(71.955,17.685),(71.955,17.515),(71.785,17.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,17.875),(71.785,18.045),(71.955,18.045),(71.955,17.875),(71.785,17.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,18.235),(71.785,18.405),(71.955,18.405),(71.955,18.235),(71.785,18.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,18.595),(71.785,18.765),(71.955,18.765),(71.955,18.595),(71.785,18.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,18.955),(71.785,19.125),(71.955,19.125),(71.955,18.955),(71.785,18.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,19.315),(71.785,19.485),(71.955,19.485),(71.955,19.315),(71.785,19.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,19.675),(71.785,19.845),(71.955,19.845),(71.955,19.675),(71.785,19.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,20.035),(71.785,20.205),(71.955,20.205),(71.955,20.035),(71.785,20.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((71.785,20.395),(71.785,20.565),(71.955,20.565),(71.955,20.395),(71.785,20.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,29.535),(46.475,29.705),(46.645,29.705),(46.645,29.535),(46.475,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,29.895),(46.475,30.065),(46.645,30.065),(46.645,29.895),(46.475,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,30.255),(46.475,30.425),(46.645,30.425),(46.645,30.255),(46.475,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,30.615),(46.475,30.785),(46.645,30.785),(46.645,30.615),(46.475,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,30.975),(46.475,31.145),(46.645,31.145),(46.645,30.975),(46.475,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,31.335),(46.475,31.505),(46.645,31.505),(46.645,31.335),(46.475,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,31.695),(46.475,31.865),(46.645,31.865),(46.645,31.695),(46.475,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,32.055),(46.475,32.225),(46.645,32.225),(46.645,32.055),(46.475,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,32.415),(46.475,32.585),(46.645,32.585),(46.645,32.415),(46.475,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,32.775),(46.475,32.945),(46.645,32.945),(46.645,32.775),(46.475,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,33.135),(46.475,33.305),(46.645,33.305),(46.645,33.135),(46.475,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,33.495),(46.475,33.665),(46.645,33.665),(46.645,33.495),(46.475,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,33.855),(46.475,34.025),(46.645,34.025),(46.645,33.855),(46.475,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,34.215),(46.475,34.385),(46.645,34.385),(46.645,34.215),(46.475,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,34.575),(46.475,34.745),(46.645,34.745),(46.645,34.575),(46.475,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,34.935),(46.475,35.105),(46.645,35.105),(46.645,34.935),(46.475,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,35.295),(46.475,35.465),(46.645,35.465),(46.645,35.295),(46.475,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,35.655),(46.475,35.825),(46.645,35.825),(46.645,35.655),(46.475,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.475,36.015),(46.475,36.185),(46.645,36.185),(46.645,36.015),(46.475,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,29.535),(30.875,29.705),(31.045,29.705),(31.045,29.535),(30.875,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,29.895),(30.875,30.065),(31.045,30.065),(31.045,29.895),(30.875,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,30.255),(30.875,30.425),(31.045,30.425),(31.045,30.255),(30.875,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,30.615),(30.875,30.785),(31.045,30.785),(31.045,30.615),(30.875,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,30.975),(30.875,31.145),(31.045,31.145),(31.045,30.975),(30.875,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,31.335),(30.875,31.505),(31.045,31.505),(31.045,31.335),(30.875,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,31.695),(30.875,31.865),(31.045,31.865),(31.045,31.695),(30.875,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,32.055),(30.875,32.225),(31.045,32.225),(31.045,32.055),(30.875,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,32.415),(30.875,32.585),(31.045,32.585),(31.045,32.415),(30.875,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,32.775),(30.875,32.945),(31.045,32.945),(31.045,32.775),(30.875,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,33.135),(30.875,33.305),(31.045,33.305),(31.045,33.135),(30.875,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,33.495),(30.875,33.665),(31.045,33.665),(31.045,33.495),(30.875,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,33.855),(30.875,34.025),(31.045,34.025),(31.045,33.855),(30.875,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,34.215),(30.875,34.385),(31.045,34.385),(31.045,34.215),(30.875,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,34.575),(30.875,34.745),(31.045,34.745),(31.045,34.575),(30.875,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,34.935),(30.875,35.105),(31.045,35.105),(31.045,34.935),(30.875,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,35.295),(30.875,35.465),(31.045,35.465),(31.045,35.295),(30.875,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,35.655),(30.875,35.825),(31.045,35.825),(31.045,35.655),(30.875,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.875,36.015),(30.875,36.185),(31.045,36.185),(31.045,36.015),(30.875,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.535),(44.915,29.705),(45.085,29.705),(45.085,29.535),(44.915,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.895),(44.915,30.065),(45.085,30.065),(45.085,29.895),(44.915,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.255),(44.915,30.425),(45.085,30.425),(45.085,30.255),(44.915,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.615),(44.915,30.785),(45.085,30.785),(45.085,30.615),(44.915,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.975),(44.915,31.145),(45.085,31.145),(45.085,30.975),(44.915,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.335),(44.915,31.505),(45.085,31.505),(45.085,31.335),(44.915,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.695),(44.915,31.865),(45.085,31.865),(45.085,31.695),(44.915,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.055),(44.915,32.225),(45.085,32.225),(45.085,32.055),(44.915,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.415),(44.915,32.585),(45.085,32.585),(45.085,32.415),(44.915,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.775),(44.915,32.945),(45.085,32.945),(45.085,32.775),(44.915,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.135),(44.915,33.305),(45.085,33.305),(45.085,33.135),(44.915,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.495),(44.915,33.665),(45.085,33.665),(45.085,33.495),(44.915,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.855),(44.915,34.025),(45.085,34.025),(45.085,33.855),(44.915,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.215),(44.915,34.385),(45.085,34.385),(45.085,34.215),(44.915,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.575),(44.915,34.745),(45.085,34.745),(45.085,34.575),(44.915,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.935),(44.915,35.105),(45.085,35.105),(45.085,34.935),(44.915,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.295),(44.915,35.465),(45.085,35.465),(45.085,35.295),(44.915,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.655),(44.915,35.825),(45.085,35.825),(45.085,35.655),(44.915,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.015),(44.915,36.185),(45.085,36.185),(45.085,36.015),(44.915,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,29.535),(43.355,29.705),(43.525,29.705),(43.525,29.535),(43.355,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,29.895),(43.355,30.065),(43.525,30.065),(43.525,29.895),(43.355,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,30.255),(43.355,30.425),(43.525,30.425),(43.525,30.255),(43.355,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,30.615),(43.355,30.785),(43.525,30.785),(43.525,30.615),(43.355,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,30.975),(43.355,31.145),(43.525,31.145),(43.525,30.975),(43.355,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,31.335),(43.355,31.505),(43.525,31.505),(43.525,31.335),(43.355,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,31.695),(43.355,31.865),(43.525,31.865),(43.525,31.695),(43.355,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,32.055),(43.355,32.225),(43.525,32.225),(43.525,32.055),(43.355,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,32.415),(43.355,32.585),(43.525,32.585),(43.525,32.415),(43.355,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,32.775),(43.355,32.945),(43.525,32.945),(43.525,32.775),(43.355,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,33.135),(43.355,33.305),(43.525,33.305),(43.525,33.135),(43.355,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,33.495),(43.355,33.665),(43.525,33.665),(43.525,33.495),(43.355,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,33.855),(43.355,34.025),(43.525,34.025),(43.525,33.855),(43.355,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,34.215),(43.355,34.385),(43.525,34.385),(43.525,34.215),(43.355,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,34.575),(43.355,34.745),(43.525,34.745),(43.525,34.575),(43.355,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,34.935),(43.355,35.105),(43.525,35.105),(43.525,34.935),(43.355,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,35.295),(43.355,35.465),(43.525,35.465),(43.525,35.295),(43.355,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,35.655),(43.355,35.825),(43.525,35.825),(43.525,35.655),(43.355,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.355,36.015),(43.355,36.185),(43.525,36.185),(43.525,36.015),(43.355,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,7.435),(73.345,7.605),(73.515,7.605),(73.515,7.435),(73.345,7.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,7.795),(73.345,7.965),(73.515,7.965),(73.515,7.795),(73.345,7.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,8.155),(73.345,8.325),(73.515,8.325),(73.515,8.155),(73.345,8.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,8.515),(73.345,8.685),(73.515,8.685),(73.515,8.515),(73.345,8.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,8.875),(73.345,9.045),(73.515,9.045),(73.515,8.875),(73.345,8.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,9.235),(73.345,9.405),(73.515,9.405),(73.515,9.235),(73.345,9.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,9.595),(73.345,9.765),(73.515,9.765),(73.515,9.595),(73.345,9.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,9.955),(73.345,10.125),(73.515,10.125),(73.515,9.955),(73.345,9.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,10.315),(73.345,10.485),(73.515,10.485),(73.515,10.315),(73.345,10.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,10.675),(73.345,10.845),(73.515,10.845),(73.515,10.675),(73.345,10.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,11.035),(73.345,11.205),(73.515,11.205),(73.515,11.035),(73.345,11.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,11.395),(73.345,11.565),(73.515,11.565),(73.515,11.395),(73.345,11.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,11.755),(73.345,11.925),(73.515,11.925),(73.515,11.755),(73.345,11.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,12.115),(73.345,12.285),(73.515,12.285),(73.515,12.115),(73.345,12.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,12.475),(73.345,12.645),(73.515,12.645),(73.515,12.475),(73.345,12.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,12.835),(73.345,13.005),(73.515,13.005),(73.515,12.835),(73.345,12.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,13.195),(73.345,13.365),(73.515,13.365),(73.515,13.195),(73.345,13.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,13.555),(73.345,13.725),(73.515,13.725),(73.515,13.555),(73.345,13.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,13.915),(73.345,14.085),(73.515,14.085),(73.515,13.915),(73.345,13.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,14.275),(73.345,14.445),(73.515,14.445),(73.515,14.275),(73.345,14.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,14.635),(73.345,14.805),(73.515,14.805),(73.515,14.635),(73.345,14.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,14.995),(73.345,15.165),(73.515,15.165),(73.515,14.995),(73.345,14.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,15.355),(73.345,15.525),(73.515,15.525),(73.515,15.355),(73.345,15.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,15.715),(73.345,15.885),(73.515,15.885),(73.515,15.715),(73.345,15.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,16.075),(73.345,16.245),(73.515,16.245),(73.515,16.075),(73.345,16.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,16.435),(73.345,16.605),(73.515,16.605),(73.515,16.435),(73.345,16.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,16.795),(73.345,16.965),(73.515,16.965),(73.515,16.795),(73.345,16.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,17.155),(73.345,17.325),(73.515,17.325),(73.515,17.155),(73.345,17.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,17.515),(73.345,17.685),(73.515,17.685),(73.515,17.515),(73.345,17.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,17.875),(73.345,18.045),(73.515,18.045),(73.515,17.875),(73.345,17.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,18.235),(73.345,18.405),(73.515,18.405),(73.515,18.235),(73.345,18.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,18.595),(73.345,18.765),(73.515,18.765),(73.515,18.595),(73.345,18.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,18.955),(73.345,19.125),(73.515,19.125),(73.515,18.955),(73.345,18.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,19.315),(73.345,19.485),(73.515,19.485),(73.515,19.315),(73.345,19.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,19.675),(73.345,19.845),(73.515,19.845),(73.515,19.675),(73.345,19.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,20.035),(73.345,20.205),(73.515,20.205),(73.515,20.035),(73.345,20.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.345,20.395),(73.345,20.565),(73.515,20.565),(73.515,20.395),(73.345,20.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,29.535),(60.515,29.705),(60.685,29.705),(60.685,29.535),(60.515,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,29.895),(60.515,30.065),(60.685,30.065),(60.685,29.895),(60.515,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,30.255),(60.515,30.425),(60.685,30.425),(60.685,30.255),(60.515,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,30.615),(60.515,30.785),(60.685,30.785),(60.685,30.615),(60.515,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,30.975),(60.515,31.145),(60.685,31.145),(60.685,30.975),(60.515,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,31.335),(60.515,31.505),(60.685,31.505),(60.685,31.335),(60.515,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,31.695),(60.515,31.865),(60.685,31.865),(60.685,31.695),(60.515,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,32.055),(60.515,32.225),(60.685,32.225),(60.685,32.055),(60.515,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,32.415),(60.515,32.585),(60.685,32.585),(60.685,32.415),(60.515,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,32.775),(60.515,32.945),(60.685,32.945),(60.685,32.775),(60.515,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,33.135),(60.515,33.305),(60.685,33.305),(60.685,33.135),(60.515,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,33.495),(60.515,33.665),(60.685,33.665),(60.685,33.495),(60.515,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,33.855),(60.515,34.025),(60.685,34.025),(60.685,33.855),(60.515,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,34.215),(60.515,34.385),(60.685,34.385),(60.685,34.215),(60.515,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,34.575),(60.515,34.745),(60.685,34.745),(60.685,34.575),(60.515,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,34.935),(60.515,35.105),(60.685,35.105),(60.685,34.935),(60.515,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,35.295),(60.515,35.465),(60.685,35.465),(60.685,35.295),(60.515,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,35.655),(60.515,35.825),(60.685,35.825),(60.685,35.655),(60.515,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((60.515,36.015),(60.515,36.185),(60.685,36.185),(60.685,36.015),(60.515,36.015)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,29.535),(38.675,29.705),(38.845,29.705),(38.845,29.535),(38.675,29.535)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,29.895),(38.675,30.065),(38.845,30.065),(38.845,29.895),(38.675,29.895)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,30.255),(38.675,30.425),(38.845,30.425),(38.845,30.255),(38.675,30.255)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,30.615),(38.675,30.785),(38.845,30.785),(38.845,30.615),(38.675,30.615)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,30.975),(38.675,31.145),(38.845,31.145),(38.845,30.975),(38.675,30.975)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,31.335),(38.675,31.505),(38.845,31.505),(38.845,31.335),(38.675,31.335)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,31.695),(38.675,31.865),(38.845,31.865),(38.845,31.695),(38.675,31.695)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,32.055),(38.675,32.225),(38.845,32.225),(38.845,32.055),(38.675,32.055)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,32.415),(38.675,32.585),(38.845,32.585),(38.845,32.415),(38.675,32.415)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,32.775),(38.675,32.945),(38.845,32.945),(38.845,32.775),(38.675,32.775)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,33.135),(38.675,33.305),(38.845,33.305),(38.845,33.135),(38.675,33.135)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,33.495),(38.675,33.665),(38.845,33.665),(38.845,33.495),(38.675,33.495)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,33.855),(38.675,34.025),(38.845,34.025),(38.845,33.855),(38.675,33.855)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,34.215),(38.675,34.385),(38.845,34.385),(38.845,34.215),(38.675,34.215)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,34.575),(38.675,34.745),(38.845,34.745),(38.845,34.575),(38.675,34.575)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,34.935),(38.675,35.105),(38.845,35.105),(38.845,34.935),(38.675,34.935)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,35.295),(38.675,35.465),(38.845,35.465),(38.845,35.295),(38.675,35.295)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,35.655),(38.675,35.825),(38.845,35.825),(38.845,35.655),(38.675,35.655)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.675,36.015),(38.675,36.185),(38.845,36.185),(38.845,36.015),(38.675,36.015)),
        )
        createRL(
            tech, net, 'm1',
            ((70.195,7.375),(70.195,20.625),(70.425,20.625),(70.425,7.375),(70.195,7.375)),
        )
        createRL(
            tech, net, 'm1',
            ((70.195,7.205),(70.195,20.795),(70.425,20.795),(70.425,7.205),(70.195,7.205)),
        )
        createRL(
            tech, net, 'm1',
            ((37.085,29.475),(37.085,36.245),(37.315,36.245),(37.315,29.475),(37.085,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((37.085,29.465),(37.085,36.255),(37.315,36.255),(37.315,29.465),(37.085,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((29.285,29.475),(29.285,36.245),(29.515,36.245),(29.515,29.475),(29.285,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((29.285,29.465),(29.285,36.255),(29.515,36.255),(29.515,29.465),(29.285,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((48.005,29.475),(48.005,36.245),(48.235,36.245),(48.235,29.475),(48.005,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((48.005,29.465),(48.005,36.255),(48.235,36.255),(48.235,29.465),(48.005,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((41.765,29.465),(41.765,36.255),(41.995,36.255),(41.995,29.465),(41.765,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((41.765,29.475),(41.765,36.245),(41.995,36.245),(41.995,29.475),(41.765,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((52.685,29.475),(52.685,36.245),(52.915,36.245),(52.915,29.475),(52.685,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((52.685,29.465),(52.685,36.255),(52.915,36.255),(52.915,29.465),(52.685,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((54.245,29.465),(54.245,36.255),(54.475,36.255),(54.475,29.465),(54.245,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((54.245,29.475),(54.245,36.245),(54.475,36.245),(54.475,29.475),(54.245,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((26.165,29.465),(26.165,36.255),(73.545,36.255),(73.545,29.465),(26.165,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((63.605,29.465),(63.605,36.255),(63.835,36.255),(63.835,29.465),(63.605,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((63.605,29.475),(63.605,36.245),(63.835,36.245),(63.835,29.475),(63.605,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((62.045,29.465),(62.045,36.255),(62.275,36.255),(62.275,29.465),(62.045,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((62.045,29.475),(62.045,36.245),(62.275,36.245),(62.275,29.475),(62.045,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((68.635,7.205),(68.635,20.795),(68.865,20.795),(68.865,7.205),(68.635,7.205)),
        )
        createRL(
            tech, net, 'm1',
            ((68.635,7.375),(68.635,20.625),(68.865,20.625),(68.865,7.375),(68.635,7.375)),
        )
        createRL(
            tech, net, 'm1',
            ((73.315,7.205),(73.315,20.795),(73.545,20.795),(73.545,7.205),(73.315,7.205)),
        )
        createRL(
            tech, net, 'm1',
            ((73.315,7.375),(73.315,20.625),(73.545,20.625),(73.545,7.375),(73.315,7.375)),
        )
        createRL(
            tech, net, 'm1',
            ((57.365,29.465),(57.365,36.255),(57.595,36.255),(57.595,29.465),(57.365,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((57.365,29.475),(57.365,36.245),(57.595,36.245),(57.595,29.475),(57.365,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((60.485,29.465),(60.485,36.255),(60.715,36.255),(60.715,29.465),(60.485,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((60.485,29.475),(60.485,36.245),(60.715,36.245),(60.715,29.475),(60.485,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((58.925,29.465),(58.925,36.255),(59.155,36.255),(59.155,29.465),(58.925,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((58.925,29.475),(58.925,36.245),(59.155,36.245),(59.155,29.475),(58.925,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((26.165,29.475),(26.165,36.245),(26.395,36.245),(26.395,29.475),(26.165,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((26.165,29.465),(26.165,36.255),(26.395,36.255),(26.395,29.465),(26.165,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((33.965,29.475),(33.965,36.245),(34.195,36.245),(34.195,29.475),(33.965,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((33.965,29.465),(33.965,36.255),(34.195,36.255),(34.195,29.465),(33.965,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((40.205,29.475),(40.205,36.245),(40.435,36.245),(40.435,29.475),(40.205,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((27.725,29.475),(27.725,36.245),(27.955,36.245),(27.955,29.475),(27.725,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((27.725,29.465),(27.725,36.255),(27.955,36.255),(27.955,29.465),(27.725,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((35.525,29.475),(35.525,36.245),(35.755,36.245),(35.755,29.475),(35.525,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((35.525,29.465),(35.525,36.255),(35.755,36.255),(35.755,29.465),(35.525,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((32.405,29.465),(32.405,36.255),(32.635,36.255),(32.635,29.465),(32.405,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((32.405,29.475),(32.405,36.245),(32.635,36.245),(32.635,29.475),(32.405,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((55.805,29.465),(55.805,36.255),(56.035,36.255),(56.035,29.465),(55.805,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((55.805,29.475),(55.805,36.245),(56.035,36.245),(56.035,29.475),(55.805,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((71.755,7.205),(71.755,20.795),(71.985,20.795),(71.985,7.205),(71.755,7.205)),
        )
        createRL(
            tech, net, 'm1',
            ((71.755,7.375),(71.755,20.625),(71.985,20.625),(71.985,7.375),(71.755,7.375)),
        )
        createRL(
            tech, net, 'm1',
            ((38.645,29.475),(38.645,36.245),(38.875,36.245),(38.875,29.475),(38.645,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,29.475),(44.885,36.245),(45.115,36.245),(45.115,29.475),(44.885,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,29.465),(44.885,36.255),(45.115,36.255),(45.115,29.465),(44.885,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((49.565,29.465),(49.565,36.255),(49.795,36.255),(49.795,29.465),(49.565,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((49.565,29.475),(49.565,36.245),(49.795,36.245),(49.795,29.475),(49.565,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((30.845,29.465),(30.845,36.255),(31.075,36.255),(31.075,29.465),(30.845,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((30.845,29.475),(30.845,36.245),(31.075,36.245),(31.075,29.475),(30.845,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((46.445,29.475),(46.445,36.245),(46.675,36.245),(46.675,29.475),(46.445,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((46.445,29.465),(46.445,36.255),(46.675,36.255),(46.675,29.465),(46.445,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((51.125,29.475),(51.125,36.245),(51.355,36.245),(51.355,29.475),(51.125,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((51.125,29.465),(51.125,36.255),(51.355,36.255),(51.355,29.465),(51.125,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((43.325,29.465),(43.325,36.255),(43.555,36.255),(43.555,29.465),(43.325,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((43.325,29.475),(43.325,36.245),(43.555,36.245),(43.555,29.475),(43.325,29.475)),
        )
        createRL(
            tech, net, 'm1',
            ((68.635,7.205),(68.635,36.255),(73.545,36.255),(73.545,7.205),(68.635,7.205)),
        )
        createRL(
            tech, net, 'm1',
            ((38.645,29.465),(38.645,36.255),(38.875,36.255),(38.875,29.465),(38.645,29.465)),
        )
        createRL(
            tech, net, 'm1',
            ((40.205,29.465),(40.205,36.255),(40.435,36.255),(40.435,29.465),(40.205,29.465)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(71.09), u(4.91), u(7.205), u(36.255),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(71.09), u(4.91), u(7.205), u(36.255),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['supply']
        createRL(
            tech, net, 'difftap',
            ((51.38,29.36),(51.38,36.36),(51.88,36.36),(51.88,29.36),(51.38,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.62,29.36),(57.62,36.36),(58.12,36.36),(58.12,29.36),(57.62,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.96,29.36),(40.96,36.36),(41.21,36.36),(41.21,29.36),(40.96,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.64,29.36),(25.64,36.36),(26.14,36.36),(26.14,29.36),(25.64,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.99,29.36),(40.99,36.36),(41.24,36.36),(41.24,29.36),(40.99,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.59,29.36),(56.59,36.36),(56.84,36.36),(56.84,29.36),(56.59,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.68,29.36),(59.68,36.36),(59.93,36.36),(59.93,29.36),(59.68,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.18,29.36),(59.18,36.36),(59.68,36.36),(59.68,29.36),(59.18,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.175,29.36),(33.175,36.36),(33.425,36.36),(33.425,29.36),(33.175,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.56,29.36),(56.56,36.36),(56.81,36.36),(56.81,29.36),(56.56,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.82,29.36),(49.82,36.36),(50.32,36.36),(50.32,29.36),(49.82,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.06,29.36),(56.06,36.36),(56.56,36.36),(56.56,29.36),(56.06,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.335,29.36),(50.335,36.36),(50.585,36.36),(50.585,29.36),(50.335,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.24,29.36),(41.24,36.36),(41.74,36.36),(41.74,29.36),(41.24,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.16,29.36),(33.16,36.36),(33.41,36.36),(33.41,29.36),(33.16,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.495,29.36),(28.495,36.36),(28.745,36.36),(28.745,29.36),(28.495,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.63,29.36),(31.63,36.36),(31.88,36.36),(31.88,29.36),(31.63,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.48,29.36),(28.48,36.36),(28.73,36.36),(28.73,29.36),(28.48,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.7,29.36),(46.7,36.36),(47.2,36.36),(47.2,29.36),(46.7,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.44,29.36),(33.44,36.36),(33.94,36.36),(33.94,29.36),(33.44,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.19,29.36),(33.19,36.36),(33.44,36.36),(33.44,29.36),(33.19,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.0,29.36),(35.0,36.36),(35.5,36.36),(35.5,29.36),(35.0,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.375,29.36),(64.375,36.36),(64.625,36.36),(64.625,29.36),(64.375,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.895,29.36),(51.895,36.36),(52.145,36.36),(52.145,29.36),(51.895,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.2,29.36),(27.2,36.36),(27.7,36.36),(27.7,29.36),(27.2,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.31,29.36),(36.31,36.36),(36.56,36.36),(36.56,29.36),(36.31,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.615,29.36),(31.615,36.36),(31.865,36.36),(31.865,29.36),(31.615,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.66,29.36),(32.66,36.36),(33.16,36.36),(33.16,29.36),(32.66,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.52,29.36),(61.52,36.36),(62.02,36.36),(62.02,29.36),(61.52,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.215,29.36),(47.215,36.36),(47.465,36.36),(47.465,29.36),(47.215,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.9,29.36),(38.9,36.36),(39.4,36.36),(39.4,29.36),(38.9,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.26,29.36),(48.26,36.36),(48.76,36.36),(48.76,29.36),(48.26,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.295,29.36),(36.295,36.36),(36.545,36.36),(36.545,29.36),(36.295,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((27.98,29.36),(27.98,36.36),(28.48,36.36),(28.48,29.36),(27.98,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.78,29.36),(35.78,36.36),(36.28,36.36),(36.28,29.36),(35.78,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.68,29.36),(39.68,36.36),(40.18,36.36),(40.18,29.36),(39.68,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.2,29.36),(47.2,36.36),(47.45,36.36),(47.45,29.36),(47.2,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.84,29.36),(56.84,36.36),(57.34,36.36),(57.34,29.36),(56.84,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.55,29.36),(42.55,36.36),(42.8,36.36),(42.8,29.36),(42.55,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.08,29.36),(44.08,36.36),(44.33,36.36),(44.33,29.36),(44.08,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.16,29.36),(52.16,36.36),(52.66,36.36),(52.66,29.36),(52.16,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.39,29.36),(25.39,36.36),(25.64,36.36),(25.64,29.36),(25.39,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.46,29.36),(40.46,36.36),(40.96,36.36),(40.96,29.36),(40.46,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.27,29.36),(61.27,36.36),(61.52,36.36),(61.52,29.36),(61.27,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.575,29.36),(56.575,36.36),(56.825,36.36),(56.825,29.36),(56.575,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.36,29.36),(44.36,36.36),(44.86,36.36),(44.86,29.36),(44.36,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.11,29.36),(44.11,36.36),(44.36,36.36),(44.36,29.36),(44.11,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.76,29.36),(28.76,36.36),(29.26,36.36),(29.26,29.36),(28.76,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.455,29.36),(53.455,36.36),(53.705,36.36),(53.705,29.36),(53.455,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.12,29.36),(58.12,36.36),(58.37,36.36),(58.37,29.36),(58.12,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.935,29.36),(26.935,36.36),(27.185,36.36),(27.185,29.36),(26.935,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.88,29.36),(31.88,36.36),(32.38,36.36),(32.38,29.36),(31.88,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.58,29.36),(43.58,36.36),(44.08,36.36),(44.08,29.36),(43.58,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.88,29.36),(51.88,36.36),(52.13,36.36),(52.13,29.36),(51.88,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.91,29.36),(51.91,36.36),(52.16,36.36),(52.16,29.36),(51.91,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.86,29.36),(63.86,36.36),(64.36,36.36),(64.36,29.36),(63.86,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.71,29.36),(59.71,36.36),(59.96,36.36),(59.96,29.36),(59.71,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.42,29.36),(26.42,36.36),(26.92,36.36),(26.92,29.36),(26.42,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.15,29.36),(58.15,36.36),(58.4,36.36),(58.4,29.36),(58.15,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.4,29.36),(58.4,36.36),(58.9,36.36),(58.9,29.36),(58.4,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.975,29.36),(40.975,36.36),(41.225,36.36),(41.225,29.36),(40.975,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.6,29.36),(50.6,36.36),(51.1,36.36),(51.1,29.36),(50.6,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.67,29.36),(45.67,36.36),(45.92,36.36),(45.92,29.36),(45.67,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.47,29.36),(53.47,36.36),(53.72,36.36),(53.72,29.36),(53.47,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.735,29.36),(34.735,36.36),(34.985,36.36),(34.985,29.36),(34.735,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.23,29.36),(47.23,36.36),(47.48,36.36),(47.48,29.36),(47.23,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.12,29.36),(38.12,36.36),(38.62,36.36),(38.62,29.36),(38.12,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.8,29.36),(42.8,36.36),(43.3,36.36),(43.3,29.36),(42.8,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.48,29.36),(47.48,36.36),(47.98,36.36),(47.98,29.36),(47.48,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.44,29.36),(53.44,36.36),(53.69,36.36),(53.69,29.36),(53.44,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.14,29.36),(45.14,36.36),(45.64,36.36),(45.64,29.36),(45.14,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.64,29.36),(45.64,36.36),(45.89,36.36),(45.89,29.36),(45.64,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((63.08,29.36),(63.08,36.36),(63.58,36.36),(63.58,29.36),(63.08,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((64.36,29.36),(64.36,36.36),(64.61,36.36),(64.61,29.36),(64.36,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.095,29.36),(44.095,36.36),(44.345,36.36),(44.345,29.36),(44.095,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.055,29.36),(30.055,36.36),(30.305,36.36),(30.305,29.36),(30.055,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.04,29.36),(49.04,36.36),(49.54,36.36),(49.54,29.36),(49.04,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.255,29.36),(61.255,36.36),(61.505,36.36),(61.505,29.36),(61.255,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.775,29.36),(48.775,36.36),(49.025,36.36),(49.025,29.36),(48.775,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.855,29.36),(37.855,36.36),(38.105,36.36),(38.105,29.36),(37.855,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.815,29.36),(62.815,36.36),(63.065,36.36),(63.065,29.36),(62.815,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.95,29.36),(26.95,36.36),(27.2,36.36),(27.2,29.36),(26.95,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((26.92,29.36),(26.92,36.36),(27.17,36.36),(27.17,29.36),(26.92,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((25.375,29.36),(25.375,36.36),(25.625,36.36),(25.625,29.36),(25.375,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.32,29.36),(50.32,36.36),(50.57,36.36),(50.57,29.36),(50.32,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.72,29.36),(34.72,36.36),(34.97,36.36),(34.97,29.36),(34.72,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.22,29.36),(34.22,36.36),(34.72,36.36),(34.72,29.36),(34.22,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.43,29.36),(39.43,36.36),(39.68,36.36),(39.68,29.36),(39.43,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.03,29.36),(55.03,36.36),(55.28,36.36),(55.28,29.36),(55.03,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.28,29.36),(55.28,36.36),(55.78,36.36),(55.78,29.36),(55.28,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((61.24,29.36),(61.24,36.36),(61.49,36.36),(61.49,29.36),(61.24,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.695,29.36),(59.695,36.36),(59.945,36.36),(59.945,29.36),(59.695,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.28,29.36),(36.28,36.36),(36.53,36.36),(36.53,29.36),(36.28,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.79,29.36),(48.79,36.36),(49.04,36.36),(49.04,29.36),(48.79,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.535,29.36),(42.535,36.36),(42.785,36.36),(42.785,29.36),(42.535,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.34,29.36),(37.34,36.36),(37.84,36.36),(37.84,29.36),(37.34,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.0,29.36),(55.0,36.36),(55.25,36.36),(55.25,29.36),(55.0,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.4,29.36),(39.4,36.36),(39.65,36.36),(39.65,29.36),(39.4,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.56,29.36),(36.56,36.36),(37.06,36.36),(37.06,29.36),(36.56,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.72,29.36),(53.72,36.36),(54.22,36.36),(54.22,29.36),(53.72,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.92,29.36),(45.92,36.36),(46.42,36.36),(46.42,29.36),(45.92,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((60.74,29.36),(60.74,36.36),(61.24,36.36),(61.24,29.36),(60.74,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.655,29.36),(45.655,36.36),(45.905,36.36),(45.905,29.36),(45.655,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.52,29.36),(42.52,36.36),(42.77,36.36),(42.77,29.36),(42.52,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.02,29.36),(42.02,36.36),(42.52,36.36),(42.52,29.36),(42.02,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,29.36),(39.415,36.36),(39.665,36.36),(39.665,29.36),(39.415,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.135,29.36),(58.135,36.36),(58.385,36.36),(58.385,29.36),(58.135,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.6,29.36),(31.6,36.36),(31.85,36.36),(31.85,29.36),(31.6,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.1,29.36),(31.1,36.36),(31.6,36.36),(31.6,29.36),(31.1,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.8,29.36),(62.8,36.36),(63.05,36.36),(63.05,29.36),(62.8,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.83,29.36),(62.83,36.36),(63.08,36.36),(63.08,29.36),(62.83,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.015,29.36),(55.015,36.36),(55.265,36.36),(55.265,29.36),(55.015,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.04,29.36),(30.04,36.36),(30.29,36.36),(30.29,29.36),(30.04,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((28.51,29.36),(28.51,36.36),(28.76,36.36),(28.76,29.36),(28.51,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.94,29.36),(52.94,36.36),(53.44,36.36),(53.44,29.36),(52.94,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.87,29.36),(37.87,36.36),(38.12,36.36),(38.12,29.36),(37.87,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.76,29.36),(48.76,36.36),(49.01,36.36),(49.01,29.36),(48.76,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.07,29.36),(30.07,36.36),(30.32,36.36),(30.32,29.36),(30.07,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.35,29.36),(50.35,36.36),(50.6,36.36),(50.6,29.36),(50.35,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((62.3,29.36),(62.3,36.36),(62.8,36.36),(62.8,29.36),(62.3,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.75,29.36),(34.75,36.36),(35.0,36.36),(35.0,29.36),(34.75,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.32,29.36),(30.32,36.36),(30.82,36.36),(30.82,29.36),(30.32,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.5,29.36),(54.5,36.36),(55.0,36.36),(55.0,29.36),(54.5,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((29.54,29.36),(29.54,36.36),(30.04,36.36),(30.04,29.36),(29.54,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.84,29.36),(37.84,36.36),(38.09,36.36),(38.09,29.36),(37.84,29.36)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.96,29.36),(59.96,36.36),(60.46,36.36),(60.46,29.36),(59.96,29.36)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,29.545),(31.655,29.715),(31.825,29.715),(31.825,29.545),(31.655,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,36.005),(30.095,36.175),(30.265,36.175),(30.265,36.005),(30.095,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,34.305),(58.175,34.475),(58.345,34.475),(58.345,34.305),(58.175,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,34.645),(58.175,34.815),(58.345,34.815),(58.345,34.645),(58.175,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,29.545),(36.335,29.715),(36.505,29.715),(36.505,29.545),(36.335,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,31.245),(62.855,31.415),(63.025,31.415),(63.025,31.245),(62.855,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,31.585),(62.855,31.755),(63.025,31.755),(63.025,31.585),(62.855,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,34.985),(41.015,35.155),(41.185,35.155),(41.185,34.985),(41.015,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,32.945),(59.735,33.115),(59.905,33.115),(59.905,32.945),(59.735,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,33.965),(48.815,34.135),(48.985,34.135),(48.985,33.965),(48.815,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,32.265),(53.495,32.435),(53.665,32.435),(53.665,32.265),(53.495,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,32.605),(53.495,32.775),(53.665,32.775),(53.665,32.605),(53.495,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,31.925),(55.055,32.095),(55.225,32.095),(55.225,31.925),(55.055,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,30.905),(44.135,31.075),(44.305,31.075),(44.305,30.905),(44.135,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,33.625),(55.055,33.795),(55.225,33.795),(55.225,33.625),(55.055,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,33.285),(55.055,33.455),(55.225,33.455),(55.225,33.285),(55.055,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,32.605),(34.775,32.775),(34.945,32.775),(34.945,32.605),(34.775,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,32.945),(47.255,33.115),(47.425,33.115),(47.425,32.945),(47.255,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,30.225),(55.055,30.395),(55.225,30.395),(55.225,30.225),(55.055,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,30.565),(55.055,30.735),(55.225,30.735),(55.225,30.565),(55.055,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,32.265),(34.775,32.435),(34.945,32.435),(34.945,32.265),(34.775,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,32.605),(37.895,32.775),(38.065,32.775),(38.065,32.605),(37.895,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,32.265),(37.895,32.435),(38.065,32.435),(38.065,32.265),(37.895,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,31.925),(64.415,32.095),(64.585,32.095),(64.585,31.925),(64.415,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,30.905),(28.535,31.075),(28.705,31.075),(28.705,30.905),(28.535,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,34.985),(28.535,35.155),(28.705,35.155),(28.705,34.985),(28.535,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,35.325),(37.895,35.495),(38.065,35.495),(38.065,35.325),(37.895,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,35.665),(37.895,35.835),(38.065,35.835),(38.065,35.665),(37.895,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,32.265),(51.935,32.435),(52.105,32.435),(52.105,32.265),(51.935,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,32.605),(51.935,32.775),(52.105,32.775),(52.105,32.605),(51.935,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,33.965),(33.215,34.135),(33.385,34.135),(33.385,33.965),(33.215,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,29.885),(41.015,30.055),(41.185,30.055),(41.185,29.885),(41.015,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,36.005),(58.175,36.175),(58.345,36.175),(58.345,36.005),(58.175,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,36.005),(34.775,36.175),(34.945,36.175),(34.945,36.005),(34.775,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,34.985),(53.495,35.155),(53.665,35.155),(53.665,34.985),(53.495,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,33.285),(36.335,33.455),(36.505,33.455),(36.505,33.285),(36.335,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,30.905),(48.815,31.075),(48.985,31.075),(48.985,30.905),(48.815,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,33.625),(36.335,33.795),(36.505,33.795),(36.505,33.625),(36.335,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,36.005),(45.695,36.175),(45.865,36.175),(45.865,36.005),(45.695,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,29.885),(25.415,30.055),(25.585,30.055),(25.585,29.885),(25.415,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,34.305),(62.855,34.475),(63.025,34.475),(63.025,34.305),(62.855,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,34.645),(62.855,34.815),(63.025,34.815),(63.025,34.645),(62.855,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,33.285),(59.735,33.455),(59.905,33.455),(59.905,33.285),(59.735,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,33.625),(59.735,33.795),(59.905,33.795),(59.905,33.625),(59.735,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,31.925),(51.935,32.095),(52.105,32.095),(52.105,31.925),(51.935,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,34.305),(25.415,34.475),(25.585,34.475),(25.585,34.305),(25.415,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,34.645),(25.415,34.815),(25.585,34.815),(25.585,34.645),(25.415,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,34.305),(64.415,34.475),(64.585,34.475),(64.585,34.305),(64.415,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,34.645),(64.415,34.815),(64.585,34.815),(64.585,34.645),(64.415,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,30.905),(30.095,31.075),(30.265,31.075),(30.265,30.905),(30.095,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,29.885),(55.055,30.055),(55.225,30.055),(55.225,29.885),(55.055,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,30.905),(61.295,31.075),(61.465,31.075),(61.465,30.905),(61.295,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,34.305),(31.655,34.475),(31.825,34.475),(31.825,34.305),(31.655,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,34.645),(31.655,34.815),(31.825,34.815),(31.825,34.645),(31.655,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,29.885),(61.295,30.055),(61.465,30.055),(61.465,29.885),(61.295,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,29.885),(37.895,30.055),(38.065,30.055),(38.065,29.885),(37.895,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,31.245),(47.255,31.415),(47.425,31.415),(47.425,31.245),(47.255,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,31.585),(47.255,31.755),(47.425,31.755),(47.425,31.585),(47.255,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,30.225),(33.215,30.395),(33.385,30.395),(33.385,30.225),(33.215,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,30.565),(33.215,30.735),(33.385,30.735),(33.385,30.565),(33.215,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,33.965),(28.535,34.135),(28.705,34.135),(28.705,33.965),(28.535,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,29.885),(39.455,30.055),(39.625,30.055),(39.625,29.885),(39.455,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,32.605),(30.095,32.775),(30.265,32.775),(30.265,32.605),(30.095,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,30.905),(45.695,31.075),(45.865,31.075),(45.865,30.905),(45.695,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,32.265),(30.095,32.435),(30.265,32.435),(30.265,32.265),(30.095,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,33.285),(56.615,33.455),(56.785,33.455),(56.785,33.285),(56.615,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,33.625),(56.615,33.795),(56.785,33.795),(56.785,33.625),(56.615,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,34.305),(56.615,34.475),(56.785,34.475),(56.785,34.305),(56.615,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,34.645),(56.615,34.815),(56.785,34.815),(56.785,34.645),(56.615,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,32.945),(26.975,33.115),(27.145,33.115),(27.145,32.945),(26.975,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,31.925),(37.895,32.095),(38.065,32.095),(38.065,31.925),(37.895,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,29.885),(59.735,30.055),(59.905,30.055),(59.905,29.885),(59.735,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,33.285),(31.655,33.455),(31.825,33.455),(31.825,33.285),(31.655,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,33.625),(31.655,33.795),(31.825,33.795),(31.825,33.625),(31.655,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,30.905),(64.415,31.075),(64.585,31.075),(64.585,30.905),(64.415,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,31.925),(31.655,32.095),(31.825,32.095),(31.825,31.925),(31.655,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,32.605),(55.055,32.775),(55.225,32.775),(55.225,32.605),(55.055,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,32.265),(55.055,32.435),(55.225,32.435),(55.225,32.265),(55.055,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,36.005),(28.535,36.175),(28.705,36.175),(28.705,36.005),(28.535,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,35.325),(58.175,35.495),(58.345,35.495),(58.345,35.325),(58.175,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,35.665),(58.175,35.835),(58.345,35.835),(58.345,35.665),(58.175,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,33.285),(50.375,33.455),(50.545,33.455),(50.545,33.285),(50.375,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,33.625),(50.375,33.795),(50.545,33.795),(50.545,33.625),(50.375,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,34.305),(50.375,34.475),(50.545,34.475),(50.545,34.305),(50.375,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,34.645),(50.375,34.815),(50.545,34.815),(50.545,34.645),(50.375,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,31.925),(42.575,32.095),(42.745,32.095),(42.745,31.925),(42.575,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,32.945),(41.015,33.115),(41.185,33.115),(41.185,32.945),(41.015,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,32.945),(56.615,33.115),(56.785,33.115),(56.785,32.945),(56.615,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,29.545),(51.935,29.715),(52.105,29.715),(52.105,29.545),(51.935,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,29.545),(26.975,29.715),(27.145,29.715),(27.145,29.545),(26.975,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,33.285),(62.855,33.455),(63.025,33.455),(63.025,33.285),(62.855,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,33.625),(62.855,33.795),(63.025,33.795),(63.025,33.625),(62.855,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,34.305),(59.735,34.475),(59.905,34.475),(59.905,34.305),(59.735,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,34.645),(59.735,34.815),(59.905,34.815),(59.905,34.645),(59.735,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,30.225),(56.615,30.395),(56.785,30.395),(56.785,30.225),(56.615,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,30.565),(56.615,30.735),(56.785,30.735),(56.785,30.565),(56.615,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,34.985),(58.175,35.155),(58.345,35.155),(58.345,34.985),(58.175,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,34.305),(47.255,34.475),(47.425,34.475),(47.425,34.305),(47.255,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,34.645),(47.255,34.815),(47.425,34.815),(47.425,34.645),(47.255,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,30.905),(37.895,31.075),(38.065,31.075),(38.065,30.905),(37.895,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,35.325),(36.335,35.495),(36.505,35.495),(36.505,35.325),(36.335,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,35.665),(36.335,35.835),(36.505,35.835),(36.505,35.665),(36.335,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,32.945),(53.495,33.115),(53.665,33.115),(53.665,32.945),(53.495,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,31.925),(53.495,32.095),(53.665,32.095),(53.665,31.925),(53.495,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,30.225),(58.175,30.395),(58.345,30.395),(58.345,30.225),(58.175,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,30.565),(58.175,30.735),(58.345,30.735),(58.345,30.565),(58.175,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,32.945),(34.775,33.115),(34.945,33.115),(34.945,32.945),(34.775,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,33.965),(47.255,34.135),(47.425,34.135),(47.425,33.965),(47.255,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,33.965),(42.575,34.135),(42.745,34.135),(42.745,33.965),(42.575,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,32.265),(39.455,32.435),(39.625,32.435),(39.625,32.265),(39.455,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,32.605),(39.455,32.775),(39.625,32.775),(39.625,32.605),(39.455,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,32.265),(25.415,32.435),(25.585,32.435),(25.585,32.265),(25.415,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,32.605),(25.415,32.775),(25.585,32.775),(25.585,32.605),(25.415,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,30.905),(55.055,31.075),(55.225,31.075),(55.225,30.905),(55.055,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,31.925),(50.375,32.095),(50.545,32.095),(50.545,31.925),(50.375,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,32.945),(62.855,33.115),(63.025,33.115),(63.025,32.945),(62.855,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,33.285),(33.215,33.455),(33.385,33.455),(33.385,33.285),(33.215,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,33.625),(33.215,33.795),(33.385,33.795),(33.385,33.625),(33.215,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,29.545),(41.015,29.715),(41.185,29.715),(41.185,29.545),(41.015,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,31.245),(56.615,31.415),(56.785,31.415),(56.785,31.245),(56.615,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,33.965),(34.775,34.135),(34.945,34.135),(34.945,33.965),(34.775,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,36.005),(41.015,36.175),(41.185,36.175),(41.185,36.005),(41.015,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,31.585),(56.615,31.755),(56.785,31.755),(56.785,31.585),(56.615,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,35.325),(56.615,35.495),(56.785,35.495),(56.785,35.325),(56.615,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,35.665),(56.615,35.835),(56.785,35.835),(56.785,35.665),(56.615,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,36.005),(56.615,36.175),(56.785,36.175),(56.785,36.005),(56.615,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,29.545),(25.415,29.715),(25.585,29.715),(25.585,29.545),(25.415,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,34.985),(25.415,35.155),(25.585,35.155),(25.585,34.985),(25.415,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,34.985),(64.415,35.155),(64.585,35.155),(64.585,34.985),(64.415,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,31.245),(58.175,31.415),(58.345,31.415),(58.345,31.245),(58.175,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,31.585),(58.175,31.755),(58.345,31.755),(58.345,31.585),(58.175,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,29.545),(55.055,29.715),(55.225,29.715),(55.225,29.545),(55.055,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,34.985),(31.655,35.155),(31.825,35.155),(31.825,34.985),(31.655,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,36.005),(33.215,36.175),(33.385,36.175),(33.385,36.005),(33.215,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,29.545),(61.295,29.715),(61.465,29.715),(61.465,29.545),(61.295,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,30.905),(33.215,31.075),(33.385,31.075),(33.385,30.905),(33.215,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,31.245),(42.575,31.415),(42.745,31.415),(42.745,31.245),(42.575,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,31.585),(42.575,31.755),(42.745,31.755),(42.745,31.585),(42.575,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,29.545),(39.455,29.715),(39.625,29.715),(39.625,29.545),(39.455,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,32.945),(30.095,33.115),(30.265,33.115),(30.265,32.945),(30.095,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,34.305),(45.695,34.475),(45.865,34.475),(45.865,34.305),(45.695,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,34.645),(45.695,34.815),(45.865,34.815),(45.865,34.645),(45.695,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,31.925),(61.295,32.095),(61.465,32.095),(61.465,31.925),(61.295,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,34.985),(56.615,35.155),(56.785,35.155),(56.785,34.985),(56.615,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,29.885),(64.415,30.055),(64.585,30.055),(64.585,29.885),(64.415,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,32.265),(26.975,32.435),(27.145,32.435),(27.145,32.265),(26.975,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,32.605),(26.975,32.775),(27.145,32.775),(27.145,32.605),(26.975,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,29.545),(59.735,29.715),(59.905,29.715),(59.905,29.545),(59.735,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,31.925),(25.415,32.095),(25.585,32.095),(25.585,31.925),(25.415,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,34.985),(51.935,35.155),(52.105,35.155),(52.105,34.985),(51.935,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,29.885),(53.495,30.055),(53.665,30.055),(53.665,29.885),(53.495,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,31.245),(37.895,31.415),(38.065,31.415),(38.065,31.245),(37.895,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,31.585),(37.895,31.755),(38.065,31.755),(38.065,31.585),(37.895,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,32.945),(55.055,33.115),(55.225,33.115),(55.225,32.945),(55.055,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,33.285),(39.455,33.455),(39.625,33.455),(39.625,33.285),(39.455,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,33.965),(44.135,34.135),(44.305,34.135),(44.305,33.965),(44.135,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,35.325),(39.455,35.495),(39.625,35.495),(39.625,35.325),(39.455,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,35.665),(39.455,35.835),(39.625,35.835),(39.625,35.665),(39.455,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,31.925),(34.775,32.095),(34.945,32.095),(34.945,31.925),(34.775,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,29.885),(44.135,30.055),(44.305,30.055),(44.305,29.885),(44.135,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,34.985),(50.375,35.155),(50.545,35.155),(50.545,34.985),(50.375,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,32.265),(58.175,32.435),(58.345,32.435),(58.345,32.265),(58.175,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,31.925),(28.535,32.095),(28.705,32.095),(28.705,31.925),(28.535,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,32.605),(58.175,32.775),(58.345,32.775),(58.345,32.605),(58.175,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,29.885),(51.935,30.055),(52.105,30.055),(52.105,29.885),(51.935,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,31.925),(45.695,32.095),(45.865,32.095),(45.865,31.925),(45.695,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,36.005),(51.935,36.175),(52.105,36.175),(52.105,36.005),(51.935,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,29.545),(50.375,29.715),(50.545,29.715),(50.545,29.545),(50.375,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,29.885),(26.975,30.055),(27.145,30.055),(27.145,29.885),(26.975,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,33.965),(53.495,34.135),(53.665,34.135),(53.665,33.965),(53.495,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,33.965),(62.855,34.135),(63.025,34.135),(63.025,33.965),(62.855,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,34.985),(59.735,35.155),(59.905,35.155),(59.905,34.985),(59.735,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,30.905),(26.975,31.075),(27.145,31.075),(27.145,30.905),(26.975,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,31.925),(30.095,32.095),(30.265,32.095),(30.265,31.925),(30.095,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,30.905),(56.615,31.075),(56.785,31.075),(56.785,30.905),(56.615,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,31.245),(31.655,31.415),(31.825,31.415),(31.825,31.245),(31.655,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,35.325),(26.975,35.495),(27.145,35.495),(27.145,35.325),(26.975,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,35.665),(26.975,35.835),(27.145,35.835),(27.145,35.665),(26.975,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,31.585),(31.655,31.755),(31.825,31.755),(31.825,31.585),(31.655,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,31.925),(36.335,32.095),(36.505,32.095),(36.505,31.925),(36.335,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,35.665),(55.055,35.835),(55.225,35.835),(55.225,35.665),(55.055,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,35.325),(55.055,35.495),(55.225,35.495),(55.225,35.325),(55.055,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,34.985),(47.255,35.155),(47.425,35.155),(47.425,34.985),(47.255,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,33.285),(37.895,33.455),(38.065,33.455),(38.065,33.285),(37.895,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,33.625),(37.895,33.795),(38.065,33.795),(38.065,33.625),(37.895,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,30.225),(37.895,30.395),(38.065,30.395),(38.065,30.225),(37.895,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,30.565),(37.895,30.735),(38.065,30.735),(38.065,30.565),(37.895,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,32.605),(44.135,32.775),(44.305,32.775),(44.305,32.605),(44.135,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,32.265),(44.135,32.435),(44.305,32.435),(44.305,32.265),(44.135,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,30.905),(58.175,31.075),(58.345,31.075),(58.345,30.905),(58.175,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,31.925),(56.615,32.095),(56.785,32.095),(56.785,31.925),(56.615,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,35.325),(53.495,35.495),(53.665,35.495),(53.665,35.325),(53.495,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,35.665),(53.495,35.835),(53.665,35.835),(53.665,35.665),(53.495,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,30.225),(39.455,30.395),(39.625,30.395),(39.625,30.225),(39.455,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,30.565),(39.455,30.735),(39.625,30.735),(39.625,30.565),(39.455,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,30.905),(62.855,31.075),(63.025,31.075),(63.025,30.905),(62.855,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,29.885),(48.815,30.055),(48.985,30.055),(48.985,29.885),(48.815,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,35.325),(33.215,35.495),(33.385,35.495),(33.385,35.325),(33.215,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,35.665),(33.215,35.835),(33.385,35.835),(33.385,35.665),(33.215,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,36.005),(48.815,36.175),(48.985,36.175),(48.985,36.005),(48.815,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,32.265),(36.335,32.435),(36.505,32.435),(36.505,32.265),(36.335,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,32.605),(36.335,32.775),(36.505,32.775),(36.505,32.605),(36.335,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,33.625),(47.255,33.795),(47.425,33.795),(47.425,33.625),(47.255,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,33.285),(47.255,33.455),(47.425,33.455),(47.425,33.285),(47.255,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,32.945),(39.455,33.115),(39.625,33.115),(39.625,32.945),(39.455,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,32.945),(25.415,33.115),(25.585,33.115),(25.585,32.945),(25.415,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,32.605),(62.855,32.775),(63.025,32.775),(63.025,32.605),(62.855,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,32.265),(62.855,32.435),(63.025,32.435),(63.025,32.265),(62.855,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,35.325),(59.735,35.495),(59.905,35.495),(59.905,35.325),(59.735,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,35.665),(59.735,35.835),(59.905,35.835),(59.905,35.665),(59.735,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,29.885),(58.175,30.055),(58.345,30.055),(58.345,29.885),(58.175,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,30.225),(59.735,30.395),(59.905,30.395),(59.905,30.225),(59.735,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,30.565),(59.735,30.735),(59.905,30.735),(59.905,30.565),(59.735,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,32.265),(48.815,32.435),(48.985,32.435),(48.985,32.265),(48.815,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,32.605),(48.815,32.775),(48.985,32.775),(48.985,32.605),(48.815,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,34.305),(42.575,34.475),(42.745,34.475),(42.745,34.305),(42.575,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,34.645),(42.575,34.815),(42.745,34.815),(42.745,34.645),(42.575,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,35.325),(42.575,35.495),(42.745,35.495),(42.745,35.325),(42.575,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,35.665),(42.575,35.835),(42.745,35.835),(42.745,35.665),(42.575,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,29.885),(42.575,30.055),(42.745,30.055),(42.745,29.885),(42.575,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,32.265),(45.695,32.435),(45.865,32.435),(45.865,32.265),(45.695,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,32.605),(45.695,32.775),(45.865,32.775),(45.865,32.605),(45.695,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,31.925),(58.175,32.095),(58.345,32.095),(58.345,31.925),(58.175,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,31.925),(33.215,32.095),(33.385,32.095),(33.385,31.925),(33.215,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,31.245),(41.015,31.415),(41.185,31.415),(41.185,31.245),(41.015,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,31.585),(41.015,31.755),(41.185,31.755),(41.185,31.585),(41.015,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,29.885),(45.695,30.055),(45.865,30.055),(45.865,29.885),(45.695,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,29.545),(34.775,29.715),(34.945,29.715),(34.945,29.545),(34.775,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,35.325),(34.775,35.495),(34.945,35.495),(34.945,35.325),(34.775,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,35.665),(34.775,35.835),(34.945,35.835),(34.945,35.665),(34.775,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,29.545),(56.615,29.715),(56.785,29.715),(56.785,29.545),(56.615,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,31.925),(44.135,32.095),(44.305,32.095),(44.305,31.925),(44.135,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,33.965),(64.415,34.135),(64.585,34.135),(64.585,33.965),(64.415,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,31.245),(25.415,31.415),(25.585,31.415),(25.585,31.245),(25.415,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,31.585),(25.415,31.755),(25.585,31.755),(25.585,31.585),(25.415,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,34.985),(45.695,35.155),(45.865,35.155),(45.865,34.985),(45.695,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,34.305),(55.055,34.475),(55.225,34.475),(55.225,34.305),(55.055,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,34.645),(55.055,34.815),(55.225,34.815),(55.225,34.645),(55.055,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,33.285),(58.175,33.455),(58.345,33.455),(58.345,33.285),(58.175,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,33.625),(58.175,33.795),(58.345,33.795),(58.345,33.625),(58.175,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,36.005),(31.655,36.175),(31.825,36.175),(31.825,36.005),(31.655,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,32.605),(50.375,32.775),(50.545,32.775),(50.545,32.605),(50.375,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,32.265),(50.375,32.435),(50.545,32.435),(50.545,32.265),(50.375,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,36.005),(42.575,36.175),(42.745,36.175),(42.745,36.005),(42.575,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,31.245),(61.295,31.415),(61.465,31.415),(61.465,31.245),(61.295,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,31.585),(61.295,31.755),(61.465,31.755),(61.465,31.585),(61.295,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,31.925),(48.815,32.095),(48.985,32.095),(48.985,31.925),(48.815,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,33.965),(30.095,34.135),(30.265,34.135),(30.265,33.965),(30.095,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,29.545),(30.095,29.715),(30.265,29.715),(30.265,29.545),(30.095,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,35.325),(51.935,35.495),(52.105,35.495),(52.105,35.325),(51.935,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,35.665),(51.935,35.835),(52.105,35.835),(52.105,35.665),(51.935,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,34.305),(51.935,34.475),(52.105,34.475),(52.105,34.305),(51.935,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,34.645),(51.935,34.815),(52.105,34.815),(52.105,34.645),(51.935,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,29.545),(53.495,29.715),(53.665,29.715),(53.665,29.545),(53.495,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,36.005),(25.415,36.175),(25.585,36.175),(25.585,36.005),(25.415,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,36.005),(50.375,36.175),(50.545,36.175),(50.545,36.005),(50.375,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,29.885),(28.535,30.055),(28.705,30.055),(28.705,29.885),(28.535,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,32.945),(58.175,33.115),(58.345,33.115),(58.345,32.945),(58.175,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,34.305),(44.135,34.475),(44.305,34.475),(44.305,34.305),(44.135,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,34.645),(44.135,34.815),(44.305,34.815),(44.305,34.645),(44.135,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,33.285),(53.495,33.455),(53.665,33.455),(53.665,33.285),(53.495,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,33.625),(53.495,33.795),(53.665,33.795),(53.665,33.625),(53.495,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,30.225),(26.975,30.395),(27.145,30.395),(27.145,30.225),(26.975,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,30.565),(26.975,30.735),(27.145,30.735),(27.145,30.565),(26.975,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,34.305),(36.335,34.475),(36.505,34.475),(36.505,34.305),(36.335,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,34.645),(36.335,34.815),(36.505,34.815),(36.505,34.645),(36.335,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,29.885),(36.335,30.055),(36.505,30.055),(36.505,29.885),(36.335,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,36.005),(55.055,36.175),(55.225,36.175),(55.225,36.005),(55.055,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,34.305),(39.455,34.475),(39.625,34.475),(39.625,34.305),(39.455,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,34.645),(39.455,34.815),(39.625,34.815),(39.625,34.645),(39.455,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,33.285),(48.815,33.455),(48.985,33.455),(48.985,33.285),(48.815,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,33.625),(48.815,33.795),(48.985,33.795),(48.985,33.625),(48.815,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,33.965),(37.895,34.135),(38.065,34.135),(38.065,33.965),(37.895,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,30.225),(42.575,30.395),(42.745,30.395),(42.745,30.225),(42.575,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,34.305),(48.815,34.475),(48.985,34.475),(48.985,34.305),(48.815,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,34.645),(48.815,34.815),(48.985,34.815),(48.985,34.645),(48.815,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,30.565),(42.575,30.735),(42.745,30.735),(42.745,30.565),(42.575,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,31.925),(62.855,32.095),(63.025,32.095),(63.025,31.925),(62.855,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,32.945),(44.135,33.115),(44.305,33.115),(44.305,32.945),(44.135,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,30.905),(39.455,31.075),(39.625,31.075),(39.625,30.905),(39.455,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,36.005),(47.255,36.175),(47.425,36.175),(47.425,36.005),(47.255,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,30.225),(62.855,30.395),(63.025,30.395),(63.025,30.225),(62.855,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,30.565),(62.855,30.735),(63.025,30.735),(63.025,30.565),(62.855,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,32.945),(36.335,33.115),(36.505,33.115),(36.505,32.945),(36.335,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,29.885),(33.215,30.055),(33.385,30.055),(33.385,29.885),(33.215,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,31.245),(64.415,31.415),(64.585,31.415),(64.585,31.245),(64.415,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,31.585),(64.415,31.755),(64.585,31.755),(64.585,31.585),(64.415,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,30.905),(59.735,31.075),(59.905,31.075),(59.905,30.905),(59.735,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,31.925),(41.015,32.095),(41.185,32.095),(41.185,31.925),(41.015,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,32.945),(48.815,33.115),(48.985,33.115),(48.985,32.945),(48.815,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,34.985),(42.575,35.155),(42.745,35.155),(42.745,34.985),(42.575,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,30.225),(47.255,30.395),(47.425,30.395),(47.425,30.225),(47.255,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,30.565),(47.255,30.735),(47.425,30.735),(47.425,30.565),(47.255,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,33.965),(36.335,34.135),(36.505,34.135),(36.505,33.965),(36.335,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,34.985),(37.895,35.155),(38.065,35.155),(38.065,34.985),(37.895,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,32.945),(45.695,33.115),(45.865,33.115),(45.865,32.945),(45.695,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,34.305),(61.295,34.475),(61.465,34.475),(61.465,34.305),(61.295,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,34.645),(61.295,34.815),(61.465,34.815),(61.465,34.645),(61.295,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,30.225),(41.015,30.395),(41.185,30.395),(41.185,30.225),(41.015,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,30.565),(41.015,30.735),(41.185,30.735),(41.185,30.565),(41.015,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,29.885),(47.255,30.055),(47.425,30.055),(47.425,29.885),(47.255,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,29.545),(45.695,29.715),(45.865,29.715),(45.865,29.545),(45.695,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,34.305),(33.215,34.475),(33.385,34.475),(33.385,34.305),(33.215,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,34.645),(33.215,34.815),(33.385,34.815),(33.385,34.645),(33.215,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,36.005),(39.455,36.175),(39.625,36.175),(39.625,36.005),(39.455,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,33.285),(28.535,33.455),(28.705,33.455),(28.705,33.285),(28.535,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,33.625),(28.535,33.795),(28.705,33.795),(28.705,33.625),(28.535,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,34.985),(55.055,35.155),(55.225,35.155),(55.225,34.985),(55.055,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,33.965),(56.615,34.135),(56.785,34.135),(56.785,33.965),(56.615,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,33.285),(51.935,33.455),(52.105,33.455),(52.105,33.285),(51.935,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,31.245),(44.135,31.415),(44.305,31.415),(44.305,31.245),(44.135,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,31.585),(44.135,31.755),(44.305,31.755),(44.305,31.585),(44.135,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,33.625),(51.935,33.795),(52.105,33.795),(52.105,33.625),(51.935,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,32.945),(50.375,33.115),(50.545,33.115),(50.545,32.945),(50.375,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,36.005),(64.415,36.175),(64.585,36.175),(64.585,36.005),(64.415,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,31.245),(33.215,31.415),(33.385,31.415),(33.385,31.245),(33.215,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,31.585),(33.215,31.755),(33.385,31.755),(33.385,31.585),(33.215,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,29.545),(62.855,29.715),(63.025,29.715),(63.025,29.545),(62.855,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,30.565),(50.375,30.735),(50.545,30.735),(50.545,30.565),(50.375,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,33.965),(50.375,34.135),(50.545,34.135),(50.545,33.965),(50.375,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,30.225),(50.375,30.395),(50.545,30.395),(50.545,30.225),(50.375,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,35.325),(30.095,35.495),(30.265,35.495),(30.265,35.325),(30.095,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,35.665),(30.095,35.835),(30.265,35.835),(30.265,35.665),(30.095,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,32.265),(64.415,32.435),(64.585,32.435),(64.585,32.265),(64.415,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,32.605),(64.415,32.775),(64.585,32.775),(64.585,32.605),(64.415,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,35.325),(64.415,35.495),(64.585,35.495),(64.585,35.325),(64.415,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,35.665),(64.415,35.835),(64.585,35.835),(64.585,35.665),(64.415,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,31.245),(53.495,31.415),(53.665,31.415),(53.665,31.245),(53.495,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,33.285),(26.975,33.455),(27.145,33.455),(27.145,33.285),(26.975,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,33.625),(26.975,33.795),(27.145,33.795),(27.145,33.625),(26.975,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,31.585),(53.495,31.755),(53.665,31.755),(53.665,31.585),(53.495,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,34.985),(44.135,35.155),(44.305,35.155),(44.305,34.985),(44.135,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,30.225),(31.655,30.395),(31.825,30.395),(31.825,30.225),(31.655,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,30.565),(31.655,30.735),(31.825,30.735),(31.825,30.565),(31.655,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,33.965),(25.415,34.135),(25.585,34.135),(25.585,33.965),(25.415,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,34.985),(36.335,35.155),(36.505,35.155),(36.505,34.985),(36.335,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,36.005),(26.975,36.175),(27.145,36.175),(27.145,36.005),(26.975,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,34.985),(39.455,35.155),(39.625,35.155),(39.625,34.985),(39.455,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,30.905),(42.575,31.075),(42.745,31.075),(42.745,30.905),(42.575,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,36.005),(53.495,36.175),(53.665,36.175),(53.665,36.005),(53.495,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,34.985),(48.815,35.155),(48.985,35.155),(48.985,34.985),(48.815,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,32.605),(61.295,32.775),(61.465,32.775),(61.465,32.605),(61.295,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,32.265),(61.295,32.435),(61.465,32.435),(61.465,32.265),(61.295,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,31.245),(50.375,31.415),(50.545,31.415),(50.545,31.245),(50.375,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,31.585),(50.375,31.755),(50.545,31.755),(50.545,31.585),(50.375,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,33.965),(45.695,34.135),(45.865,34.135),(45.865,33.965),(45.695,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,32.605),(42.575,32.775),(42.745,32.775),(42.745,32.605),(42.575,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,32.265),(42.575,32.435),(42.745,32.435),(42.745,32.265),(42.575,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,33.285),(42.575,33.455),(42.745,33.455),(42.745,33.285),(42.575,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,33.625),(42.575,33.795),(42.745,33.795),(42.745,33.625),(42.575,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,35.665),(25.415,35.835),(25.585,35.835),(25.585,35.665),(25.415,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,35.325),(25.415,35.495),(25.585,35.495),(25.585,35.325),(25.415,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,29.545),(33.215,29.715),(33.385,29.715),(33.385,29.545),(33.215,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,33.965),(41.015,34.135),(41.185,34.135),(41.185,33.965),(41.015,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,35.325),(31.655,35.495),(31.825,35.495),(31.825,35.325),(31.655,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,35.665),(31.655,35.835),(31.825,35.835),(31.825,35.665),(31.655,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,32.605),(33.215,32.775),(33.385,32.775),(33.385,32.605),(33.215,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,32.265),(33.215,32.435),(33.385,32.435),(33.385,32.265),(33.215,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,35.325),(28.535,35.495),(28.705,35.495),(28.705,35.325),(28.535,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,35.665),(28.535,35.835),(28.705,35.835),(28.705,35.665),(28.535,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,33.285),(34.775,33.455),(34.945,33.455),(34.945,33.285),(34.775,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,33.625),(34.775,33.795),(34.945,33.795),(34.945,33.625),(34.775,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,34.305),(34.775,34.475),(34.945,34.475),(34.945,34.305),(34.775,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,34.645),(34.775,34.815),(34.945,34.815),(34.945,34.645),(34.775,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,30.905),(47.255,31.075),(47.425,31.075),(47.425,30.905),(47.255,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,30.225),(34.775,30.395),(34.945,30.395),(34.945,30.225),(34.775,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,30.565),(34.775,30.735),(34.945,30.735),(34.945,30.565),(34.775,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,34.645),(37.895,34.815),(38.065,34.815),(38.065,34.645),(37.895,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,34.305),(37.895,34.475),(38.065,34.475),(38.065,34.305),(37.895,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,34.985),(61.295,35.155),(61.465,35.155),(61.465,34.985),(61.295,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,30.905),(41.015,31.075),(41.185,31.075),(41.185,30.905),(41.015,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,31.925),(59.735,32.095),(59.905,32.095),(59.905,31.925),(59.735,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,36.005),(44.135,36.175),(44.305,36.175),(44.305,36.005),(44.135,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,35.325),(45.695,35.495),(45.865,35.495),(45.865,35.325),(45.695,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,35.665),(45.695,35.835),(45.865,35.835),(45.865,35.665),(45.695,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,30.225),(25.415,30.395),(25.585,30.395),(25.585,30.225),(25.415,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,30.565),(25.415,30.735),(25.585,30.735),(25.585,30.565),(25.415,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,29.545),(47.255,29.715),(47.425,29.715),(47.425,29.545),(47.255,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,32.265),(28.535,32.435),(28.705,32.435),(28.705,32.265),(28.535,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,32.605),(28.535,32.775),(28.705,32.775),(28.705,32.605),(28.535,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,33.965),(61.295,34.135),(61.465,34.135),(61.465,33.965),(61.295,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,30.225),(36.335,30.395),(36.505,30.395),(36.505,30.225),(36.335,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,30.565),(36.335,30.735),(36.505,30.735),(36.505,30.565),(36.335,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,35.325),(41.015,35.495),(41.185,35.495),(41.185,35.325),(41.015,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,35.665),(41.015,35.835),(41.185,35.835),(41.185,35.665),(41.015,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,34.985),(33.215,35.155),(33.385,35.155),(33.385,34.985),(33.215,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,36.005),(36.335,36.175),(36.505,36.175),(36.505,36.005),(36.335,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,31.925),(39.455,32.095),(39.625,32.095),(39.625,31.925),(39.455,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,36.005),(37.895,36.175),(38.065,36.175),(38.065,36.005),(37.895,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,29.545),(64.415,29.715),(64.585,29.715),(64.585,29.545),(64.415,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,33.965),(51.935,34.135),(52.105,34.135),(52.105,33.965),(51.935,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,31.245),(45.695,31.415),(45.865,31.415),(45.865,31.245),(45.695,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,31.585),(45.695,31.755),(45.865,31.755),(45.865,31.585),(45.695,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,32.265),(31.655,32.435),(31.825,32.435),(31.825,32.265),(31.655,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,32.605),(31.655,32.775),(31.825,32.775),(31.825,32.605),(31.655,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,31.245),(28.535,31.415),(28.705,31.415),(28.705,31.245),(28.535,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,31.585),(28.535,31.755),(28.705,31.755),(28.705,31.585),(28.535,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,35.325),(61.295,35.495),(61.465,35.495),(61.465,35.325),(61.295,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,35.665),(61.295,35.835),(61.465,35.835),(61.465,35.665),(61.295,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,31.245),(34.775,31.415),(34.945,31.415),(34.945,31.245),(34.775,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,31.585),(34.775,31.755),(34.945,31.755),(34.945,31.585),(34.775,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,34.305),(30.095,34.475),(30.265,34.475),(30.265,34.305),(30.095,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,34.645),(30.095,34.815),(30.265,34.815),(30.265,34.645),(30.095,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,33.285),(44.135,33.455),(44.305,33.455),(44.305,33.285),(44.135,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,33.625),(44.135,33.795),(44.305,33.795),(44.305,33.625),(44.135,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,36.005),(61.295,36.175),(61.465,36.175),(61.465,36.005),(61.295,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,29.545),(44.135,29.715),(44.305,29.715),(44.305,29.545),(44.135,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,34.985),(26.975,35.155),(27.145,35.155),(27.145,34.985),(26.975,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,29.885),(62.855,30.055),(63.025,30.055),(63.025,29.885),(62.855,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,30.905),(50.375,31.075),(50.545,31.075),(50.545,30.905),(50.375,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,30.225),(53.495,30.395),(53.665,30.395),(53.665,30.225),(53.495,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,30.565),(53.495,30.735),(53.665,30.735),(53.665,30.565),(53.495,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,32.945),(64.415,33.115),(64.585,33.115),(64.585,32.945),(64.415,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,31.245),(26.975,31.415),(27.145,31.415),(27.145,31.245),(26.975,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,31.245),(36.335,31.415),(36.505,31.415),(36.505,31.245),(36.335,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,31.585),(36.335,31.755),(36.505,31.755),(36.505,31.585),(36.335,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,31.585),(26.975,31.755),(27.145,31.755),(27.145,31.585),(26.975,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,30.905),(51.935,31.075),(52.105,31.075),(52.105,30.905),(51.935,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,33.965),(26.975,34.135),(27.145,34.135),(27.145,33.965),(26.975,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,31.245),(30.095,31.415),(30.265,31.415),(30.265,31.245),(30.095,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,31.585),(30.095,31.755),(30.265,31.755),(30.265,31.585),(30.095,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,33.965),(39.455,34.135),(39.625,34.135),(39.625,33.965),(39.455,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,30.905),(31.655,31.075),(31.825,31.075),(31.825,30.905),(31.655,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,35.325),(50.375,35.495),(50.545,35.495),(50.545,35.325),(50.375,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,35.665),(50.375,35.835),(50.545,35.835),(50.545,35.665),(50.375,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,29.885),(31.655,30.055),(31.825,30.055),(31.825,29.885),(31.655,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.375,29.885),(50.375,30.055),(50.545,30.055),(50.545,29.885),(50.375,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,36.005),(59.735,36.175),(59.905,36.175),(59.905,36.005),(59.735,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,33.285),(25.415,33.455),(25.585,33.455),(25.585,33.285),(25.415,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,33.625),(25.415,33.795),(25.585,33.795),(25.585,33.625),(25.415,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,34.305),(41.015,34.475),(41.185,34.475),(41.185,34.305),(41.015,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,34.645),(41.015,34.815),(41.185,34.815),(41.185,34.645),(41.015,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,35.325),(62.855,35.495),(63.025,35.495),(63.025,35.325),(62.855,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,35.665),(62.855,35.835),(63.025,35.835),(63.025,35.665),(62.855,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,32.265),(59.735,32.435),(59.905,32.435),(59.905,32.265),(59.735,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,32.605),(59.735,32.775),(59.905,32.775),(59.905,32.605),(59.735,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,30.225),(44.135,30.395),(44.305,30.395),(44.305,30.225),(44.135,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,30.565),(44.135,30.735),(44.305,30.735),(44.305,30.565),(44.135,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,32.945),(61.295,33.115),(61.465,33.115),(61.465,32.945),(61.295,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,29.545),(48.815,29.715),(48.985,29.715),(48.985,29.545),(48.815,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,33.285),(45.695,33.455),(45.865,33.455),(45.865,33.285),(45.695,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,33.625),(45.695,33.795),(45.865,33.795),(45.865,33.625),(45.695,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,32.945),(42.575,33.115),(42.745,33.115),(42.745,32.945),(42.575,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,33.965),(55.055,34.135),(55.225,34.135),(55.225,33.965),(55.055,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,32.265),(47.255,32.435),(47.425,32.435),(47.425,32.265),(47.255,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,32.605),(47.255,32.775),(47.425,32.775),(47.425,32.605),(47.255,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,32.945),(37.895,33.115),(38.065,33.115),(38.065,32.945),(37.895,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,31.925),(47.255,32.095),(47.425,32.095),(47.425,31.925),(47.255,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,30.225),(28.535,30.395),(28.705,30.395),(28.705,30.225),(28.535,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,30.565),(28.535,30.735),(28.705,30.735),(28.705,30.565),(28.535,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,34.305),(28.535,34.475),(28.705,34.475),(28.705,34.305),(28.535,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,34.645),(28.535,34.815),(28.705,34.815),(28.705,34.645),(28.535,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,32.945),(51.935,33.115),(52.105,33.115),(52.105,32.945),(51.935,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,29.545),(58.175,29.715),(58.345,29.715),(58.345,29.545),(58.175,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,33.285),(41.015,33.455),(41.185,33.455),(41.185,33.285),(41.015,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,33.625),(41.015,33.795),(41.185,33.795),(41.185,33.625),(41.015,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,31.245),(55.055,31.415),(55.225,31.415),(55.225,31.245),(55.055,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.215,32.945),(33.215,33.115),(33.385,33.115),(33.385,32.945),(33.215,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.055,31.585),(55.055,31.755),(55.225,31.755),(55.225,31.585),(55.055,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,34.305),(53.495,34.475),(53.665,34.475),(53.665,34.305),(53.495,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,34.645),(53.495,34.815),(53.665,34.815),(53.665,34.645),(53.495,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.575,29.545),(42.575,29.715),(42.745,29.715),(42.745,29.545),(42.575,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,30.225),(48.815,30.395),(48.985,30.395),(48.985,30.225),(48.815,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,31.585),(39.455,31.755),(39.625,31.755),(39.625,31.585),(39.455,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,30.565),(48.815,30.735),(48.985,30.735),(48.985,30.565),(48.815,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,30.905),(34.775,31.075),(34.945,31.075),(34.945,30.905),(34.775,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,31.245),(39.455,31.415),(39.625,31.415),(39.625,31.245),(39.455,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,34.985),(34.775,35.155),(34.945,35.155),(34.945,34.985),(34.775,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,34.985),(62.855,35.155),(63.025,35.155),(63.025,34.985),(62.855,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,33.965),(59.735,34.135),(59.905,34.135),(59.905,33.965),(59.735,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((25.415,30.905),(25.415,31.075),(25.585,31.075),(25.585,30.905),(25.415,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,32.945),(28.535,33.115),(28.705,33.115),(28.705,32.945),(28.535,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,31.245),(59.735,31.415),(59.905,31.415),(59.905,31.245),(59.735,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.735,31.585),(59.735,31.755),(59.905,31.755),(59.905,31.585),(59.735,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,30.565),(30.095,30.735),(30.265,30.735),(30.265,30.565),(30.095,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,30.225),(30.095,30.395),(30.265,30.395),(30.265,30.225),(30.095,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,30.225),(61.295,30.395),(61.465,30.395),(61.465,30.225),(61.295,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((36.335,30.905),(36.335,31.075),(36.505,31.075),(36.505,30.905),(36.335,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,30.565),(61.295,30.735),(61.465,30.735),(61.465,30.565),(61.295,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,33.285),(61.295,33.455),(61.465,33.455),(61.465,33.285),(61.295,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((61.295,33.625),(61.295,33.795),(61.465,33.795),(61.465,33.625),(61.295,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.775,29.885),(34.775,30.055),(34.945,30.055),(34.945,29.885),(34.775,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.895,29.545),(37.895,29.715),(38.065,29.715),(38.065,29.545),(37.895,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,29.885),(56.615,30.055),(56.785,30.055),(56.785,29.885),(56.615,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,33.285),(64.415,33.455),(64.585,33.455),(64.585,33.285),(64.415,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,33.625),(64.415,33.795),(64.585,33.795),(64.585,33.625),(64.415,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,35.325),(44.135,35.495),(44.305,35.495),(44.305,35.325),(44.135,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.135,35.665),(44.135,35.835),(44.305,35.835),(44.305,35.665),(44.135,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,35.325),(48.815,35.495),(48.985,35.495),(48.985,35.325),(48.815,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,35.665),(48.815,35.835),(48.985,35.835),(48.985,35.665),(48.815,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,30.225),(45.695,30.395),(45.865,30.395),(45.865,30.225),(45.695,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.695,30.565),(45.695,30.735),(45.865,30.735),(45.865,30.565),(45.695,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((62.855,36.005),(62.855,36.175),(63.025,36.175),(63.025,36.005),(62.855,36.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.175,33.965),(58.175,34.135),(58.345,34.135),(58.345,33.965),(58.175,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,32.945),(31.655,33.115),(31.825,33.115),(31.825,32.945),(31.655,32.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,33.625),(30.095,33.795),(30.265,33.795),(30.265,33.625),(30.095,33.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,33.285),(30.095,33.455),(30.265,33.455),(30.265,33.285),(30.095,33.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,29.885),(30.095,30.055),(30.265,30.055),(30.265,29.885),(30.095,29.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.655,33.965),(31.655,34.135),(31.825,34.135),(31.825,33.965),(31.655,33.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,31.245),(51.935,31.415),(52.105,31.415),(52.105,31.245),(51.935,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,31.585),(51.935,31.755),(52.105,31.755),(52.105,31.585),(51.935,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,31.245),(48.815,31.415),(48.985,31.415),(48.985,31.245),(48.815,31.245)),
        )
        createRL(
            tech, net, 'licon',
            ((48.815,31.585),(48.815,31.755),(48.985,31.755),(48.985,31.585),(48.815,31.585)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,30.225),(64.415,30.395),(64.585,30.395),(64.585,30.225),(64.415,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((64.415,30.565),(64.415,30.735),(64.585,30.735),(64.585,30.565),(64.415,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.095,34.985),(30.095,35.155),(30.265,35.155),(30.265,34.985),(30.095,34.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,35.325),(47.255,35.495),(47.425,35.495),(47.425,35.325),(47.255,35.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.255,35.665),(47.255,35.835),(47.425,35.835),(47.425,35.665),(47.255,35.665)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,31.925),(26.975,32.095),(27.145,32.095),(27.145,31.925),(26.975,31.925)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,34.305),(26.975,34.475),(27.145,34.475),(27.145,34.305),(26.975,34.305)),
        )
        createRL(
            tech, net, 'licon',
            ((26.975,34.645),(26.975,34.815),(27.145,34.815),(27.145,34.645),(26.975,34.645)),
        )
        createRL(
            tech, net, 'licon',
            ((28.535,29.545),(28.535,29.715),(28.705,29.715),(28.705,29.545),(28.535,29.545)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,32.605),(41.015,32.775),(41.185,32.775),(41.185,32.605),(41.015,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((41.015,32.265),(41.015,32.435),(41.185,32.435),(41.185,32.265),(41.015,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((53.495,30.905),(53.495,31.075),(53.665,31.075),(53.665,30.905),(53.495,30.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,32.605),(56.615,32.775),(56.785,32.775),(56.785,32.605),(56.615,32.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.615,32.265),(56.615,32.435),(56.785,32.435),(56.785,32.265),(56.615,32.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,30.225),(51.935,30.395),(52.105,30.395),(52.105,30.225),(51.935,30.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.935,30.565),(51.935,30.735),(52.105,30.735),(52.105,30.565),(51.935,30.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.455,33.625),(39.455,33.795),(39.625,33.795),(39.625,33.625),(39.455,33.625)),
        )
        createRL(
            tech, net, 'li',
            ((58.175,26.64),(58.175,36.255),(58.345,36.255),(58.345,26.64),(58.175,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((37.895,26.64),(37.895,36.255),(38.065,36.255),(38.065,26.64),(37.895,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((59.735,29.465),(59.735,36.255),(59.905,36.255),(59.905,29.465),(59.735,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((56.615,26.64),(56.615,36.255),(56.785,36.255),(56.785,26.64),(56.615,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((48.815,29.465),(48.815,36.255),(48.985,36.255),(48.985,29.465),(48.815,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((59.735,26.64),(59.735,36.255),(59.905,36.255),(59.905,26.64),(59.735,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((51.935,26.64),(51.935,36.255),(52.105,36.255),(52.105,26.64),(51.935,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((41.015,29.465),(41.015,36.255),(41.185,36.255),(41.185,29.465),(41.015,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((44.135,29.465),(44.135,36.255),(44.305,36.255),(44.305,29.465),(44.135,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((41.015,26.64),(41.015,36.255),(41.185,36.255),(41.185,26.64),(41.015,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((42.575,29.465),(42.575,36.255),(42.745,36.255),(42.745,29.465),(42.575,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((56.615,29.465),(56.615,36.255),(56.785,36.255),(56.785,29.465),(56.615,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((33.215,29.465),(33.215,36.255),(33.385,36.255),(33.385,29.465),(33.215,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((28.535,26.64),(28.535,36.255),(28.705,36.255),(28.705,26.64),(28.535,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((36.335,26.64),(36.335,36.255),(36.505,36.255),(36.505,26.64),(36.335,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((33.215,26.64),(33.215,36.255),(33.385,36.255),(33.385,26.64),(33.215,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((31.655,26.64),(31.655,36.255),(31.825,36.255),(31.825,26.64),(31.655,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((23.335,38.6),(23.335,39.08),(66.665,39.08),(66.665,38.6),(23.335,38.6)),
        )
        createRL(
            tech, net, 'li',
            ((50.375,29.465),(50.375,36.255),(50.545,36.255),(50.545,29.465),(50.375,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((30.095,29.465),(30.095,36.255),(30.265,36.255),(30.265,29.465),(30.095,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((45.695,29.465),(45.695,36.255),(45.865,36.255),(45.865,29.465),(45.695,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((53.495,29.465),(53.495,36.255),(53.665,36.255),(53.665,29.465),(53.495,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((45.695,26.64),(45.695,36.255),(45.865,36.255),(45.865,26.64),(45.695,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((53.495,26.64),(53.495,36.255),(53.665,36.255),(53.665,26.64),(53.495,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((50.375,26.64),(50.375,36.255),(50.545,36.255),(50.545,26.64),(50.375,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((39.455,29.465),(39.455,36.255),(39.625,36.255),(39.625,29.465),(39.455,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((28.535,29.465),(28.535,36.255),(28.705,36.255),(28.705,29.465),(28.535,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((26.975,29.465),(26.975,36.255),(27.145,36.255),(27.145,29.465),(26.975,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((39.455,26.64),(39.455,36.255),(39.625,36.255),(39.625,26.64),(39.455,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((25.415,26.64),(25.415,36.255),(25.585,36.255),(25.585,26.64),(25.415,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((58.175,29.465),(58.175,36.255),(58.345,36.255),(58.345,29.465),(58.175,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((44.135,26.64),(44.135,36.255),(44.305,36.255),(44.305,26.64),(44.135,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((64.415,26.64),(64.415,36.255),(64.585,36.255),(64.585,26.64),(64.415,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((61.295,29.465),(61.295,36.255),(61.465,36.255),(61.465,29.465),(61.295,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((64.415,29.465),(64.415,36.255),(64.585,36.255),(64.585,29.465),(64.415,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((51.935,29.465),(51.935,36.255),(52.105,36.255),(52.105,29.465),(51.935,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((61.295,26.64),(61.295,36.255),(61.465,36.255),(61.465,26.64),(61.295,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((55.055,29.465),(55.055,36.255),(55.225,36.255),(55.225,29.465),(55.055,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((55.055,26.64),(55.055,36.255),(55.225,36.255),(55.225,26.64),(55.055,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((42.575,26.64),(42.575,36.255),(42.745,36.255),(42.745,26.64),(42.575,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((37.895,29.465),(37.895,36.255),(38.065,36.255),(38.065,29.465),(37.895,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((47.255,29.465),(47.255,36.255),(47.425,36.255),(47.425,29.465),(47.255,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((31.655,29.465),(31.655,36.255),(31.825,36.255),(31.825,29.465),(31.655,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((62.855,26.64),(62.855,36.255),(63.025,36.255),(63.025,26.64),(62.855,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((62.855,29.465),(62.855,36.255),(63.025,36.255),(63.025,29.465),(62.855,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((47.255,26.64),(47.255,36.255),(47.425,36.255),(47.425,26.64),(47.255,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((34.775,29.465),(34.775,36.255),(34.945,36.255),(34.945,29.465),(34.775,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((30.095,26.64),(30.095,36.255),(30.265,36.255),(30.265,26.64),(30.095,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((34.775,26.64),(34.775,36.255),(34.945,36.255),(34.945,26.64),(34.775,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((25.415,29.465),(25.415,36.255),(25.585,36.255),(25.585,29.465),(25.415,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((26.975,26.64),(26.975,36.255),(27.145,36.255),(27.145,26.64),(26.975,26.64)),
        )
        createRL(
            tech, net, 'li',
            ((36.335,29.465),(36.335,36.255),(36.505,36.255),(36.505,29.465),(36.335,29.465)),
        )
        createRL(
            tech, net, 'li',
            ((48.815,26.64),(48.815,36.255),(48.985,36.255),(48.985,26.64),(48.815,26.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((28.33,29.18),(28.33,36.54),(29.69,36.54),(29.69,29.18),(28.33,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((53.29,29.18),(53.29,36.54),(54.65,36.54),(54.65,29.18),(53.29,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((60.31,29.18),(60.31,36.54),(61.67,36.54),(61.67,29.18),(60.31,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((50.95,29.18),(50.95,36.54),(52.31,36.54),(52.31,29.18),(50.95,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((45.49,29.18),(45.49,36.54),(46.85,36.54),(46.85,29.18),(45.49,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((57.19,29.18),(57.19,36.54),(58.55,36.54),(58.55,29.18),(57.19,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((30.67,29.18),(30.67,36.54),(32.03,36.54),(32.03,29.18),(30.67,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((44.71,29.18),(44.71,36.54),(46.07,36.54),(46.07,29.18),(44.71,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((31.45,29.18),(31.45,36.54),(32.81,36.54),(32.81,29.18),(31.45,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((63.43,29.18),(63.43,36.54),(64.79,36.54),(64.79,29.18),(63.43,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((43.93,29.18),(43.93,36.54),(45.29,36.54),(45.29,29.18),(43.93,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((51.73,29.18),(51.73,36.54),(53.09,36.54),(53.09,29.18),(51.73,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((37.69,29.18),(37.69,36.54),(39.05,36.54),(39.05,29.18),(37.69,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((29.89,29.18),(29.89,36.54),(31.25,36.54),(31.25,29.18),(29.89,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((42.37,29.18),(42.37,36.54),(43.73,36.54),(43.73,29.18),(42.37,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((54.07,29.18),(54.07,36.54),(55.43,36.54),(55.43,29.18),(54.07,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((32.23,29.18),(32.23,36.54),(33.59,36.54),(33.59,29.18),(32.23,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((61.09,29.18),(61.09,36.54),(62.45,36.54),(62.45,29.18),(61.09,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((34.57,29.18),(34.57,36.54),(35.93,36.54),(35.93,29.18),(34.57,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((46.27,29.18),(46.27,36.54),(47.63,36.54),(47.63,29.18),(46.27,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((47.05,29.18),(47.05,36.54),(48.41,36.54),(48.41,29.18),(47.05,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((35.35,29.18),(35.35,36.54),(36.71,36.54),(36.71,29.18),(35.35,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((27.55,29.18),(27.55,36.54),(28.91,36.54),(28.91,29.18),(27.55,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((39.25,29.18),(39.25,36.54),(40.61,36.54),(40.61,29.18),(39.25,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((33.01,29.18),(33.01,36.54),(34.37,36.54),(34.37,29.18),(33.01,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((57.97,29.18),(57.97,36.54),(59.33,36.54),(59.33,29.18),(57.97,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((36.13,29.18),(36.13,36.54),(37.49,36.54),(37.49,29.18),(36.13,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((40.03,29.18),(40.03,36.54),(41.39,36.54),(41.39,29.18),(40.03,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((54.85,29.18),(54.85,36.54),(56.21,36.54),(56.21,29.18),(54.85,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((62.65,29.18),(62.65,36.54),(64.01,36.54),(64.01,29.18),(62.65,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((25.21,29.18),(25.21,36.54),(26.57,36.54),(26.57,29.18),(25.21,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((43.15,29.18),(43.15,36.54),(44.51,36.54),(44.51,29.18),(43.15,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((55.63,29.18),(55.63,36.54),(56.99,36.54),(56.99,29.18),(55.63,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((26.77,29.18),(26.77,36.54),(28.13,36.54),(28.13,29.18),(26.77,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((58.75,29.18),(58.75,36.54),(60.11,36.54),(60.11,29.18),(58.75,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((61.87,29.18),(61.87,36.54),(63.23,36.54),(63.23,29.18),(61.87,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((48.61,29.18),(48.61,36.54),(49.97,36.54),(49.97,29.18),(48.61,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((29.11,29.18),(29.11,36.54),(30.47,36.54),(30.47,29.18),(29.11,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((52.51,29.18),(52.51,36.54),(53.87,36.54),(53.87,29.18),(52.51,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((50.17,29.18),(50.17,36.54),(51.53,36.54),(51.53,29.18),(50.17,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((56.41,29.18),(56.41,36.54),(57.77,36.54),(57.77,29.18),(56.41,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((41.59,29.18),(41.59,36.54),(42.95,36.54),(42.95,29.18),(41.59,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((36.91,29.18),(36.91,36.54),(38.27,36.54),(38.27,29.18),(36.91,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((33.79,29.18),(33.79,36.54),(35.15,36.54),(35.15,29.18),(33.79,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((59.53,29.18),(59.53,36.54),(60.89,36.54),(60.89,29.18),(59.53,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((47.83,29.18),(47.83,36.54),(49.19,36.54),(49.19,29.18),(47.83,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((40.81,29.18),(40.81,36.54),(42.17,36.54),(42.17,29.18),(40.81,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((38.47,29.18),(38.47,36.54),(39.83,36.54),(39.83,29.18),(38.47,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((49.39,29.18),(49.39,36.54),(50.75,36.54),(50.75,29.18),(49.39,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((25.99,29.18),(25.99,36.54),(27.35,36.54),(27.35,29.18),(25.99,29.18)),
        )
        Horizontal.create(
            net, tech.getLayer('li.pin'),
            u(38.84), u(0.48), u(23.33499999999998), u(66.66500000000002),
        )
        pin = Horizontal.create(
            net, tech.getLayer('li'),
            u(38.84), u(0.48), u(23.33499999999998), u(66.66500000000002),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((25.195,29.18),(25.195,36.54),(25.805,36.54),(25.805,29.18),(25.195,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((25.975,29.18),(25.975,36.54),(26.585,36.54),(26.585,29.18),(25.975,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((26.755,29.18),(26.755,36.54),(27.365,36.54),(27.365,29.18),(26.755,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((27.535,29.18),(27.535,36.54),(28.145,36.54),(28.145,29.18),(27.535,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((28.315,29.18),(28.315,36.54),(28.925,36.54),(28.925,29.18),(28.315,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((29.095,29.18),(29.095,36.54),(29.705,36.54),(29.705,29.18),(29.095,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((29.875,29.18),(29.875,36.54),(30.485,36.54),(30.485,29.18),(29.875,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((30.655,29.18),(30.655,36.54),(31.265,36.54),(31.265,29.18),(30.655,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((31.435,29.18),(31.435,36.54),(32.045,36.54),(32.045,29.18),(31.435,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((32.215,29.18),(32.215,36.54),(32.825,36.54),(32.825,29.18),(32.215,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((32.995,29.18),(32.995,36.54),(33.605,36.54),(33.605,29.18),(32.995,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((33.775,29.18),(33.775,36.54),(34.385,36.54),(34.385,29.18),(33.775,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((34.555,29.18),(34.555,36.54),(35.165,36.54),(35.165,29.18),(34.555,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((35.335,29.18),(35.335,36.54),(35.945,36.54),(35.945,29.18),(35.335,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((36.115,29.18),(36.115,36.54),(36.725,36.54),(36.725,29.18),(36.115,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((36.895,29.18),(36.895,36.54),(37.505,36.54),(37.505,29.18),(36.895,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((37.675,29.18),(37.675,36.54),(38.285,36.54),(38.285,29.18),(37.675,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((38.455,29.18),(38.455,36.54),(39.065,36.54),(39.065,29.18),(38.455,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((39.235,29.18),(39.235,36.54),(39.845,36.54),(39.845,29.18),(39.235,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((40.015,29.18),(40.015,36.54),(40.625,36.54),(40.625,29.18),(40.015,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((40.795,29.18),(40.795,36.54),(41.405,36.54),(41.405,29.18),(40.795,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((41.575,29.18),(41.575,36.54),(42.185,36.54),(42.185,29.18),(41.575,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((42.355,29.18),(42.355,36.54),(42.965,36.54),(42.965,29.18),(42.355,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((43.135,29.18),(43.135,36.54),(43.745,36.54),(43.745,29.18),(43.135,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((43.915,29.18),(43.915,36.54),(44.525,36.54),(44.525,29.18),(43.915,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((44.695,29.18),(44.695,36.54),(45.305,36.54),(45.305,29.18),(44.695,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((45.475,29.18),(45.475,36.54),(46.085,36.54),(46.085,29.18),(45.475,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((46.255,29.18),(46.255,36.54),(46.865,36.54),(46.865,29.18),(46.255,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((47.035,29.18),(47.035,36.54),(47.645,36.54),(47.645,29.18),(47.035,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((47.815,29.18),(47.815,36.54),(48.425,36.54),(48.425,29.18),(47.815,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((48.595,29.18),(48.595,36.54),(49.205,36.54),(49.205,29.18),(48.595,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((49.375,29.18),(49.375,36.54),(49.985,36.54),(49.985,29.18),(49.375,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((50.155,29.18),(50.155,36.54),(50.765,36.54),(50.765,29.18),(50.155,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((50.935,29.18),(50.935,36.54),(51.545,36.54),(51.545,29.18),(50.935,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((51.715,29.18),(51.715,36.54),(52.325,36.54),(52.325,29.18),(51.715,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((52.495,29.18),(52.495,36.54),(53.105,36.54),(53.105,29.18),(52.495,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((53.275,29.18),(53.275,36.54),(53.885,36.54),(53.885,29.18),(53.275,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((54.055,29.18),(54.055,36.54),(54.665,36.54),(54.665,29.18),(54.055,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((54.835,29.18),(54.835,36.54),(55.445,36.54),(55.445,29.18),(54.835,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((55.615,29.18),(55.615,36.54),(56.225,36.54),(56.225,29.18),(55.615,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((56.395,29.18),(56.395,36.54),(57.005,36.54),(57.005,29.18),(56.395,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((57.175,29.18),(57.175,36.54),(57.785,36.54),(57.785,29.18),(57.175,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((57.955,29.18),(57.955,36.54),(58.565,36.54),(58.565,29.18),(57.955,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((58.735,29.18),(58.735,36.54),(59.345,36.54),(59.345,29.18),(58.735,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((59.515,29.18),(59.515,36.54),(60.125,36.54),(60.125,29.18),(59.515,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((60.295,29.18),(60.295,36.54),(60.905,36.54),(60.905,29.18),(60.295,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((61.075,29.18),(61.075,36.54),(61.685,36.54),(61.685,29.18),(61.075,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((61.855,29.18),(61.855,36.54),(62.465,36.54),(62.465,29.18),(61.855,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((62.635,29.18),(62.635,36.54),(63.245,36.54),(63.245,29.18),(62.635,29.18)),
        )
        net = nets['bulk']
        createRL(
            tech, net, 'nwm',
            ((64.195,29.18),(64.195,36.54),(64.805,36.54),(64.805,29.18),(64.195,29.18)),
        )
        createRL(
            tech, net, 'nwm',
            ((63.415,29.18),(63.415,36.54),(64.025,36.54),(64.025,29.18),(63.415,29.18)),
        )
        nets['supply'].setDirection(Net.Direction.IN)
        nets['ground'].setDirection(Net.Direction.IN)
        nets['in'].setDirection(Net.Direction.IN)
        nets['out'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_P18000W8728HFF']
        except:
            subcell = af.getCell('GuardRing_P18000W8728HFF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'outerguard', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_P12310W3968HFT']
        except:
            subcell = af.getCell('GuardRing_P12310W3968HFT', 0)
        trans = Transformation(
            u(45.0), u(14.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nmosguardring', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_N8666W2488HTT']
        except:
            subcell = af.getCell('GuardRing_N8666W2488HTT', 0)
        trans = Transformation(
            u(45.0), u(32.86), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pmosguardring', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['IOPadAnalog']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(188),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'iovss': Net.create(cell, 'iovss'),
            'pad': Net.create(cell, 'pad'),
            'padres': Net.create(cell, 'padres'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'm2',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,1.985),(1.7,2.185),(1.9,2.185),(1.9,1.985),(1.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,1.985),(3.3,2.185),(3.5,2.185),(3.5,1.985),(3.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,1.985),(4.9,2.185),(5.1,2.185),(5.1,1.985),(4.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,1.985),(6.5,2.185),(6.7,2.185),(6.7,1.985),(6.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,1.985),(8.1,2.185),(8.3,2.185),(8.3,1.985),(8.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,1.985),(9.7,2.185),(9.9,2.185),(9.9,1.985),(9.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,1.985),(11.3,2.185),(11.5,2.185),(11.5,1.985),(11.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,1.985),(12.9,2.185),(13.1,2.185),(13.1,1.985),(12.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,1.985),(14.5,2.185),(14.7,2.185),(14.7,1.985),(14.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,1.985),(16.1,2.185),(16.3,2.185),(16.3,1.985),(16.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,1.985),(17.7,2.185),(17.9,2.185),(17.9,1.985),(17.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,1.985),(19.3,2.185),(19.5,2.185),(19.5,1.985),(19.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,1.985),(20.9,2.185),(21.1,2.185),(21.1,1.985),(20.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,1.985),(22.5,2.185),(22.7,2.185),(22.7,1.985),(22.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,1.985),(24.1,2.185),(24.3,2.185),(24.3,1.985),(24.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,1.985),(25.7,2.185),(25.9,2.185),(25.9,1.985),(25.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,1.985),(27.3,2.185),(27.5,2.185),(27.5,1.985),(27.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,1.985),(28.9,2.185),(29.1,2.185),(29.1,1.985),(28.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,1.985),(30.5,2.185),(30.7,2.185),(30.7,1.985),(30.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,1.985),(32.1,2.185),(32.3,2.185),(32.3,1.985),(32.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,1.985),(33.7,2.185),(33.9,2.185),(33.9,1.985),(33.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,1.985),(35.3,2.185),(35.5,2.185),(35.5,1.985),(35.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,1.985),(36.9,2.185),(37.1,2.185),(37.1,1.985),(36.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,1.985),(38.5,2.185),(38.7,2.185),(38.7,1.985),(38.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,1.985),(40.1,2.185),(40.3,2.185),(40.3,1.985),(40.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,1.985),(41.7,2.185),(41.9,2.185),(41.9,1.985),(41.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,1.985),(43.3,2.185),(43.5,2.185),(43.5,1.985),(43.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,1.985),(44.9,2.185),(45.1,2.185),(45.1,1.985),(44.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,1.985),(46.5,2.185),(46.7,2.185),(46.7,1.985),(46.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,1.985),(48.1,2.185),(48.3,2.185),(48.3,1.985),(48.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,1.985),(49.7,2.185),(49.9,2.185),(49.9,1.985),(49.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,1.985),(51.3,2.185),(51.5,2.185),(51.5,1.985),(51.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,1.985),(52.9,2.185),(53.1,2.185),(53.1,1.985),(52.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,1.985),(54.5,2.185),(54.7,2.185),(54.7,1.985),(54.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,1.985),(56.1,2.185),(56.3,2.185),(56.3,1.985),(56.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,1.985),(57.7,2.185),(57.9,2.185),(57.9,1.985),(57.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,1.985),(59.3,2.185),(59.5,2.185),(59.5,1.985),(59.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,1.985),(60.9,2.185),(61.1,2.185),(61.1,1.985),(60.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,1.985),(62.5,2.185),(62.7,2.185),(62.7,1.985),(62.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,1.985),(64.1,2.185),(64.3,2.185),(64.3,1.985),(64.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,1.985),(65.7,2.185),(65.9,2.185),(65.9,1.985),(65.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,1.985),(67.3,2.185),(67.5,2.185),(67.5,1.985),(67.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,1.985),(68.9,2.185),(69.1,2.185),(69.1,1.985),(68.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,1.985),(70.5,2.185),(70.7,2.185),(70.7,1.985),(70.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,1.985),(72.1,2.185),(72.3,2.185),(72.3,1.985),(72.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,1.985),(73.7,2.185),(73.9,2.185),(73.9,1.985),(73.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,1.985),(75.3,2.185),(75.5,2.185),(75.5,1.985),(75.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,1.985),(76.9,2.185),(77.1,2.185),(77.1,1.985),(76.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,1.985),(78.5,2.185),(78.7,2.185),(78.7,1.985),(78.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,1.985),(80.1,2.185),(80.3,2.185),(80.3,1.985),(80.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,1.985),(81.7,2.185),(81.9,2.185),(81.9,1.985),(81.7,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,1.985),(83.3,2.185),(83.5,2.185),(83.5,1.985),(83.3,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,1.985),(84.9,2.185),(85.1,2.185),(85.1,1.985),(84.9,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,1.985),(86.5,2.185),(86.7,2.185),(86.7,1.985),(86.5,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,1.985),(88.1,2.185),(88.3,2.185),(88.3,1.985),(88.1,1.985)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,3.585),(1.7,3.785),(1.9,3.785),(1.9,3.585),(1.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,3.585),(3.3,3.785),(3.5,3.785),(3.5,3.585),(3.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,3.585),(4.9,3.785),(5.1,3.785),(5.1,3.585),(4.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,3.585),(6.5,3.785),(6.7,3.785),(6.7,3.585),(6.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,3.585),(8.1,3.785),(8.3,3.785),(8.3,3.585),(8.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,3.585),(9.7,3.785),(9.9,3.785),(9.9,3.585),(9.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,3.585),(11.3,3.785),(11.5,3.785),(11.5,3.585),(11.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,3.585),(12.9,3.785),(13.1,3.785),(13.1,3.585),(12.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,3.585),(14.5,3.785),(14.7,3.785),(14.7,3.585),(14.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,3.585),(16.1,3.785),(16.3,3.785),(16.3,3.585),(16.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,3.585),(17.7,3.785),(17.9,3.785),(17.9,3.585),(17.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,3.585),(19.3,3.785),(19.5,3.785),(19.5,3.585),(19.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,3.585),(20.9,3.785),(21.1,3.785),(21.1,3.585),(20.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,3.585),(22.5,3.785),(22.7,3.785),(22.7,3.585),(22.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,3.585),(24.1,3.785),(24.3,3.785),(24.3,3.585),(24.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,3.585),(25.7,3.785),(25.9,3.785),(25.9,3.585),(25.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,3.585),(27.3,3.785),(27.5,3.785),(27.5,3.585),(27.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,3.585),(28.9,3.785),(29.1,3.785),(29.1,3.585),(28.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,3.585),(30.5,3.785),(30.7,3.785),(30.7,3.585),(30.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,3.585),(32.1,3.785),(32.3,3.785),(32.3,3.585),(32.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,3.585),(33.7,3.785),(33.9,3.785),(33.9,3.585),(33.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,3.585),(35.3,3.785),(35.5,3.785),(35.5,3.585),(35.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,3.585),(36.9,3.785),(37.1,3.785),(37.1,3.585),(36.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,3.585),(38.5,3.785),(38.7,3.785),(38.7,3.585),(38.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,3.585),(40.1,3.785),(40.3,3.785),(40.3,3.585),(40.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,3.585),(41.7,3.785),(41.9,3.785),(41.9,3.585),(41.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,3.585),(43.3,3.785),(43.5,3.785),(43.5,3.585),(43.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,3.585),(44.9,3.785),(45.1,3.785),(45.1,3.585),(44.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,3.585),(46.5,3.785),(46.7,3.785),(46.7,3.585),(46.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,3.585),(48.1,3.785),(48.3,3.785),(48.3,3.585),(48.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,3.585),(49.7,3.785),(49.9,3.785),(49.9,3.585),(49.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,3.585),(51.3,3.785),(51.5,3.785),(51.5,3.585),(51.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,3.585),(52.9,3.785),(53.1,3.785),(53.1,3.585),(52.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,3.585),(54.5,3.785),(54.7,3.785),(54.7,3.585),(54.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,3.585),(56.1,3.785),(56.3,3.785),(56.3,3.585),(56.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,3.585),(57.7,3.785),(57.9,3.785),(57.9,3.585),(57.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,3.585),(59.3,3.785),(59.5,3.785),(59.5,3.585),(59.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,3.585),(60.9,3.785),(61.1,3.785),(61.1,3.585),(60.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,3.585),(62.5,3.785),(62.7,3.785),(62.7,3.585),(62.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,3.585),(64.1,3.785),(64.3,3.785),(64.3,3.585),(64.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,3.585),(65.7,3.785),(65.9,3.785),(65.9,3.585),(65.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,3.585),(67.3,3.785),(67.5,3.785),(67.5,3.585),(67.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,3.585),(68.9,3.785),(69.1,3.785),(69.1,3.585),(68.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,3.585),(70.5,3.785),(70.7,3.785),(70.7,3.585),(70.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,3.585),(72.1,3.785),(72.3,3.785),(72.3,3.585),(72.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,3.585),(73.7,3.785),(73.9,3.785),(73.9,3.585),(73.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,3.585),(75.3,3.785),(75.5,3.785),(75.5,3.585),(75.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,3.585),(76.9,3.785),(77.1,3.785),(77.1,3.585),(76.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,3.585),(78.5,3.785),(78.7,3.785),(78.7,3.585),(78.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,3.585),(80.1,3.785),(80.3,3.785),(80.3,3.585),(80.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,3.585),(81.7,3.785),(81.9,3.785),(81.9,3.585),(81.7,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,3.585),(83.3,3.785),(83.5,3.785),(83.5,3.585),(83.3,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,3.585),(84.9,3.785),(85.1,3.785),(85.1,3.585),(84.9,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,3.585),(86.5,3.785),(86.7,3.785),(86.7,3.585),(86.5,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,3.585),(88.1,3.785),(88.3,3.785),(88.3,3.585),(88.1,3.585)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,5.185),(1.7,5.385),(1.9,5.385),(1.9,5.185),(1.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,5.185),(3.3,5.385),(3.5,5.385),(3.5,5.185),(3.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,5.185),(4.9,5.385),(5.1,5.385),(5.1,5.185),(4.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,5.185),(6.5,5.385),(6.7,5.385),(6.7,5.185),(6.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,5.185),(8.1,5.385),(8.3,5.385),(8.3,5.185),(8.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,5.185),(9.7,5.385),(9.9,5.385),(9.9,5.185),(9.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,5.185),(11.3,5.385),(11.5,5.385),(11.5,5.185),(11.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,5.185),(12.9,5.385),(13.1,5.385),(13.1,5.185),(12.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,5.185),(14.5,5.385),(14.7,5.385),(14.7,5.185),(14.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,5.185),(16.1,5.385),(16.3,5.385),(16.3,5.185),(16.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,5.185),(17.7,5.385),(17.9,5.385),(17.9,5.185),(17.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,5.185),(19.3,5.385),(19.5,5.385),(19.5,5.185),(19.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,5.185),(20.9,5.385),(21.1,5.385),(21.1,5.185),(20.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,5.185),(22.5,5.385),(22.7,5.385),(22.7,5.185),(22.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,5.185),(24.1,5.385),(24.3,5.385),(24.3,5.185),(24.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,5.185),(25.7,5.385),(25.9,5.385),(25.9,5.185),(25.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,5.185),(27.3,5.385),(27.5,5.385),(27.5,5.185),(27.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,5.185),(28.9,5.385),(29.1,5.385),(29.1,5.185),(28.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,5.185),(30.5,5.385),(30.7,5.385),(30.7,5.185),(30.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,5.185),(32.1,5.385),(32.3,5.385),(32.3,5.185),(32.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,5.185),(33.7,5.385),(33.9,5.385),(33.9,5.185),(33.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,5.185),(35.3,5.385),(35.5,5.385),(35.5,5.185),(35.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,5.185),(36.9,5.385),(37.1,5.385),(37.1,5.185),(36.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,5.185),(38.5,5.385),(38.7,5.385),(38.7,5.185),(38.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,5.185),(40.1,5.385),(40.3,5.385),(40.3,5.185),(40.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,5.185),(41.7,5.385),(41.9,5.385),(41.9,5.185),(41.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,5.185),(43.3,5.385),(43.5,5.385),(43.5,5.185),(43.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,5.185),(44.9,5.385),(45.1,5.385),(45.1,5.185),(44.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,5.185),(46.5,5.385),(46.7,5.385),(46.7,5.185),(46.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,5.185),(48.1,5.385),(48.3,5.385),(48.3,5.185),(48.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,5.185),(49.7,5.385),(49.9,5.385),(49.9,5.185),(49.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,5.185),(51.3,5.385),(51.5,5.385),(51.5,5.185),(51.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,5.185),(52.9,5.385),(53.1,5.385),(53.1,5.185),(52.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,5.185),(54.5,5.385),(54.7,5.385),(54.7,5.185),(54.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,5.185),(56.1,5.385),(56.3,5.385),(56.3,5.185),(56.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,5.185),(57.7,5.385),(57.9,5.385),(57.9,5.185),(57.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,5.185),(59.3,5.385),(59.5,5.385),(59.5,5.185),(59.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,5.185),(60.9,5.385),(61.1,5.385),(61.1,5.185),(60.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,5.185),(62.5,5.385),(62.7,5.385),(62.7,5.185),(62.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,5.185),(64.1,5.385),(64.3,5.385),(64.3,5.185),(64.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,5.185),(65.7,5.385),(65.9,5.385),(65.9,5.185),(65.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,5.185),(67.3,5.385),(67.5,5.385),(67.5,5.185),(67.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,5.185),(68.9,5.385),(69.1,5.385),(69.1,5.185),(68.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,5.185),(70.5,5.385),(70.7,5.385),(70.7,5.185),(70.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,5.185),(72.1,5.385),(72.3,5.385),(72.3,5.185),(72.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,5.185),(73.7,5.385),(73.9,5.385),(73.9,5.185),(73.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,5.185),(75.3,5.385),(75.5,5.385),(75.5,5.185),(75.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,5.185),(76.9,5.385),(77.1,5.385),(77.1,5.185),(76.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,5.185),(78.5,5.385),(78.7,5.385),(78.7,5.185),(78.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,5.185),(80.1,5.385),(80.3,5.385),(80.3,5.185),(80.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,5.185),(81.7,5.385),(81.9,5.385),(81.9,5.185),(81.7,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,5.185),(83.3,5.385),(83.5,5.385),(83.5,5.185),(83.3,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,5.185),(84.9,5.385),(85.1,5.385),(85.1,5.185),(84.9,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,5.185),(86.5,5.385),(86.7,5.385),(86.7,5.185),(86.5,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,5.185),(88.1,5.385),(88.3,5.385),(88.3,5.185),(88.1,5.185)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,6.785),(1.7,6.985),(1.9,6.985),(1.9,6.785),(1.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,6.785),(3.3,6.985),(3.5,6.985),(3.5,6.785),(3.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,6.785),(4.9,6.985),(5.1,6.985),(5.1,6.785),(4.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,6.785),(6.5,6.985),(6.7,6.985),(6.7,6.785),(6.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,6.785),(8.1,6.985),(8.3,6.985),(8.3,6.785),(8.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,6.785),(9.7,6.985),(9.9,6.985),(9.9,6.785),(9.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,6.785),(11.3,6.985),(11.5,6.985),(11.5,6.785),(11.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,6.785),(12.9,6.985),(13.1,6.985),(13.1,6.785),(12.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,6.785),(14.5,6.985),(14.7,6.985),(14.7,6.785),(14.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,6.785),(16.1,6.985),(16.3,6.985),(16.3,6.785),(16.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,6.785),(17.7,6.985),(17.9,6.985),(17.9,6.785),(17.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,6.785),(19.3,6.985),(19.5,6.985),(19.5,6.785),(19.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,6.785),(20.9,6.985),(21.1,6.985),(21.1,6.785),(20.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,6.785),(22.5,6.985),(22.7,6.985),(22.7,6.785),(22.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,6.785),(24.1,6.985),(24.3,6.985),(24.3,6.785),(24.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,6.785),(25.7,6.985),(25.9,6.985),(25.9,6.785),(25.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,6.785),(27.3,6.985),(27.5,6.985),(27.5,6.785),(27.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,6.785),(28.9,6.985),(29.1,6.985),(29.1,6.785),(28.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,6.785),(30.5,6.985),(30.7,6.985),(30.7,6.785),(30.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,6.785),(32.1,6.985),(32.3,6.985),(32.3,6.785),(32.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,6.785),(33.7,6.985),(33.9,6.985),(33.9,6.785),(33.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,6.785),(35.3,6.985),(35.5,6.985),(35.5,6.785),(35.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,6.785),(36.9,6.985),(37.1,6.985),(37.1,6.785),(36.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,6.785),(38.5,6.985),(38.7,6.985),(38.7,6.785),(38.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,6.785),(40.1,6.985),(40.3,6.985),(40.3,6.785),(40.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,6.785),(41.7,6.985),(41.9,6.985),(41.9,6.785),(41.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,6.785),(43.3,6.985),(43.5,6.985),(43.5,6.785),(43.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,6.785),(44.9,6.985),(45.1,6.985),(45.1,6.785),(44.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,6.785),(46.5,6.985),(46.7,6.985),(46.7,6.785),(46.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,6.785),(48.1,6.985),(48.3,6.985),(48.3,6.785),(48.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,6.785),(49.7,6.985),(49.9,6.985),(49.9,6.785),(49.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,6.785),(51.3,6.985),(51.5,6.985),(51.5,6.785),(51.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,6.785),(52.9,6.985),(53.1,6.985),(53.1,6.785),(52.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,6.785),(54.5,6.985),(54.7,6.985),(54.7,6.785),(54.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,6.785),(56.1,6.985),(56.3,6.985),(56.3,6.785),(56.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,6.785),(57.7,6.985),(57.9,6.985),(57.9,6.785),(57.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,6.785),(59.3,6.985),(59.5,6.985),(59.5,6.785),(59.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,6.785),(60.9,6.985),(61.1,6.985),(61.1,6.785),(60.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,6.785),(62.5,6.985),(62.7,6.985),(62.7,6.785),(62.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,6.785),(64.1,6.985),(64.3,6.985),(64.3,6.785),(64.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,6.785),(65.7,6.985),(65.9,6.985),(65.9,6.785),(65.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,6.785),(67.3,6.985),(67.5,6.985),(67.5,6.785),(67.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,6.785),(68.9,6.985),(69.1,6.985),(69.1,6.785),(68.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,6.785),(70.5,6.985),(70.7,6.985),(70.7,6.785),(70.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,6.785),(72.1,6.985),(72.3,6.985),(72.3,6.785),(72.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,6.785),(73.7,6.985),(73.9,6.985),(73.9,6.785),(73.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,6.785),(75.3,6.985),(75.5,6.985),(75.5,6.785),(75.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,6.785),(76.9,6.985),(77.1,6.985),(77.1,6.785),(76.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,6.785),(78.5,6.985),(78.7,6.985),(78.7,6.785),(78.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,6.785),(80.1,6.985),(80.3,6.985),(80.3,6.785),(80.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,6.785),(81.7,6.985),(81.9,6.985),(81.9,6.785),(81.7,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,6.785),(83.3,6.985),(83.5,6.985),(83.5,6.785),(83.3,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,6.785),(84.9,6.985),(85.1,6.985),(85.1,6.785),(84.9,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,6.785),(86.5,6.985),(86.7,6.985),(86.7,6.785),(86.5,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,6.785),(88.1,6.985),(88.3,6.985),(88.3,6.785),(88.1,6.785)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,8.385),(1.7,8.585),(1.9,8.585),(1.9,8.385),(1.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,8.385),(3.3,8.585),(3.5,8.585),(3.5,8.385),(3.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,8.385),(4.9,8.585),(5.1,8.585),(5.1,8.385),(4.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,8.385),(6.5,8.585),(6.7,8.585),(6.7,8.385),(6.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,8.385),(8.1,8.585),(8.3,8.585),(8.3,8.385),(8.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,8.385),(9.7,8.585),(9.9,8.585),(9.9,8.385),(9.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,8.385),(11.3,8.585),(11.5,8.585),(11.5,8.385),(11.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,8.385),(12.9,8.585),(13.1,8.585),(13.1,8.385),(12.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,8.385),(14.5,8.585),(14.7,8.585),(14.7,8.385),(14.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,8.385),(16.1,8.585),(16.3,8.585),(16.3,8.385),(16.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,8.385),(17.7,8.585),(17.9,8.585),(17.9,8.385),(17.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,8.385),(19.3,8.585),(19.5,8.585),(19.5,8.385),(19.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,8.385),(20.9,8.585),(21.1,8.585),(21.1,8.385),(20.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,8.385),(22.5,8.585),(22.7,8.585),(22.7,8.385),(22.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,8.385),(24.1,8.585),(24.3,8.585),(24.3,8.385),(24.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,8.385),(25.7,8.585),(25.9,8.585),(25.9,8.385),(25.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,8.385),(27.3,8.585),(27.5,8.585),(27.5,8.385),(27.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,8.385),(28.9,8.585),(29.1,8.585),(29.1,8.385),(28.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,8.385),(30.5,8.585),(30.7,8.585),(30.7,8.385),(30.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,8.385),(32.1,8.585),(32.3,8.585),(32.3,8.385),(32.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,8.385),(33.7,8.585),(33.9,8.585),(33.9,8.385),(33.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,8.385),(35.3,8.585),(35.5,8.585),(35.5,8.385),(35.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,8.385),(36.9,8.585),(37.1,8.585),(37.1,8.385),(36.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,8.385),(38.5,8.585),(38.7,8.585),(38.7,8.385),(38.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,8.385),(40.1,8.585),(40.3,8.585),(40.3,8.385),(40.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,8.385),(41.7,8.585),(41.9,8.585),(41.9,8.385),(41.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,8.385),(43.3,8.585),(43.5,8.585),(43.5,8.385),(43.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,8.385),(44.9,8.585),(45.1,8.585),(45.1,8.385),(44.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,8.385),(46.5,8.585),(46.7,8.585),(46.7,8.385),(46.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,8.385),(48.1,8.585),(48.3,8.585),(48.3,8.385),(48.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,8.385),(49.7,8.585),(49.9,8.585),(49.9,8.385),(49.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,8.385),(51.3,8.585),(51.5,8.585),(51.5,8.385),(51.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,8.385),(52.9,8.585),(53.1,8.585),(53.1,8.385),(52.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,8.385),(54.5,8.585),(54.7,8.585),(54.7,8.385),(54.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,8.385),(56.1,8.585),(56.3,8.585),(56.3,8.385),(56.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,8.385),(57.7,8.585),(57.9,8.585),(57.9,8.385),(57.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,8.385),(59.3,8.585),(59.5,8.585),(59.5,8.385),(59.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,8.385),(60.9,8.585),(61.1,8.585),(61.1,8.385),(60.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,8.385),(62.5,8.585),(62.7,8.585),(62.7,8.385),(62.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,8.385),(64.1,8.585),(64.3,8.585),(64.3,8.385),(64.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,8.385),(65.7,8.585),(65.9,8.585),(65.9,8.385),(65.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,8.385),(67.3,8.585),(67.5,8.585),(67.5,8.385),(67.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,8.385),(68.9,8.585),(69.1,8.585),(69.1,8.385),(68.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,8.385),(70.5,8.585),(70.7,8.585),(70.7,8.385),(70.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,8.385),(72.1,8.585),(72.3,8.585),(72.3,8.385),(72.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,8.385),(73.7,8.585),(73.9,8.585),(73.9,8.385),(73.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,8.385),(75.3,8.585),(75.5,8.585),(75.5,8.385),(75.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,8.385),(76.9,8.585),(77.1,8.585),(77.1,8.385),(76.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,8.385),(78.5,8.585),(78.7,8.585),(78.7,8.385),(78.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,8.385),(80.1,8.585),(80.3,8.585),(80.3,8.385),(80.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,8.385),(81.7,8.585),(81.9,8.585),(81.9,8.385),(81.7,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,8.385),(83.3,8.585),(83.5,8.585),(83.5,8.385),(83.3,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,8.385),(84.9,8.585),(85.1,8.585),(85.1,8.385),(84.9,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,8.385),(86.5,8.585),(86.7,8.585),(86.7,8.385),(86.5,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,8.385),(88.1,8.585),(88.3,8.585),(88.3,8.385),(88.1,8.385)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,13.755),(1.7,13.955),(1.9,13.955),(1.9,13.755),(1.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,13.755),(3.3,13.955),(3.5,13.955),(3.5,13.755),(3.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,13.755),(4.9,13.955),(5.1,13.955),(5.1,13.755),(4.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,13.755),(6.5,13.955),(6.7,13.955),(6.7,13.755),(6.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,13.755),(8.1,13.955),(8.3,13.955),(8.3,13.755),(8.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,13.755),(9.7,13.955),(9.9,13.955),(9.9,13.755),(9.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,13.755),(11.3,13.955),(11.5,13.955),(11.5,13.755),(11.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,13.755),(12.9,13.955),(13.1,13.955),(13.1,13.755),(12.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,13.755),(14.5,13.955),(14.7,13.955),(14.7,13.755),(14.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,13.755),(16.1,13.955),(16.3,13.955),(16.3,13.755),(16.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,13.755),(17.7,13.955),(17.9,13.955),(17.9,13.755),(17.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,13.755),(19.3,13.955),(19.5,13.955),(19.5,13.755),(19.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,13.755),(20.9,13.955),(21.1,13.955),(21.1,13.755),(20.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,13.755),(22.5,13.955),(22.7,13.955),(22.7,13.755),(22.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,13.755),(24.1,13.955),(24.3,13.955),(24.3,13.755),(24.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,13.755),(25.7,13.955),(25.9,13.955),(25.9,13.755),(25.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,13.755),(27.3,13.955),(27.5,13.955),(27.5,13.755),(27.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,13.755),(28.9,13.955),(29.1,13.955),(29.1,13.755),(28.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,13.755),(30.5,13.955),(30.7,13.955),(30.7,13.755),(30.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,13.755),(32.1,13.955),(32.3,13.955),(32.3,13.755),(32.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,13.755),(33.7,13.955),(33.9,13.955),(33.9,13.755),(33.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,13.755),(35.3,13.955),(35.5,13.955),(35.5,13.755),(35.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,13.755),(36.9,13.955),(37.1,13.955),(37.1,13.755),(36.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,13.755),(38.5,13.955),(38.7,13.955),(38.7,13.755),(38.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,13.755),(40.1,13.955),(40.3,13.955),(40.3,13.755),(40.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,13.755),(41.7,13.955),(41.9,13.955),(41.9,13.755),(41.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,13.755),(43.3,13.955),(43.5,13.955),(43.5,13.755),(43.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,13.755),(44.9,13.955),(45.1,13.955),(45.1,13.755),(44.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,13.755),(46.5,13.955),(46.7,13.955),(46.7,13.755),(46.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,13.755),(48.1,13.955),(48.3,13.955),(48.3,13.755),(48.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,13.755),(49.7,13.955),(49.9,13.955),(49.9,13.755),(49.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,13.755),(51.3,13.955),(51.5,13.955),(51.5,13.755),(51.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,13.755),(52.9,13.955),(53.1,13.955),(53.1,13.755),(52.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,13.755),(54.5,13.955),(54.7,13.955),(54.7,13.755),(54.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,13.755),(56.1,13.955),(56.3,13.955),(56.3,13.755),(56.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,13.755),(57.7,13.955),(57.9,13.955),(57.9,13.755),(57.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,13.755),(59.3,13.955),(59.5,13.955),(59.5,13.755),(59.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,13.755),(60.9,13.955),(61.1,13.955),(61.1,13.755),(60.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,13.755),(62.5,13.955),(62.7,13.955),(62.7,13.755),(62.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,13.755),(64.1,13.955),(64.3,13.955),(64.3,13.755),(64.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,13.755),(65.7,13.955),(65.9,13.955),(65.9,13.755),(65.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,13.755),(67.3,13.955),(67.5,13.955),(67.5,13.755),(67.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,13.755),(68.9,13.955),(69.1,13.955),(69.1,13.755),(68.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,13.755),(70.5,13.955),(70.7,13.955),(70.7,13.755),(70.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,13.755),(72.1,13.955),(72.3,13.955),(72.3,13.755),(72.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,13.755),(73.7,13.955),(73.9,13.955),(73.9,13.755),(73.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,13.755),(75.3,13.955),(75.5,13.955),(75.5,13.755),(75.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,13.755),(76.9,13.955),(77.1,13.955),(77.1,13.755),(76.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,13.755),(78.5,13.955),(78.7,13.955),(78.7,13.755),(78.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,13.755),(80.1,13.955),(80.3,13.955),(80.3,13.755),(80.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,13.755),(81.7,13.955),(81.9,13.955),(81.9,13.755),(81.7,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,13.755),(83.3,13.955),(83.5,13.955),(83.5,13.755),(83.3,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,13.755),(84.9,13.955),(85.1,13.955),(85.1,13.755),(84.9,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,13.755),(86.5,13.955),(86.7,13.955),(86.7,13.755),(86.5,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,13.755),(88.1,13.955),(88.3,13.955),(88.3,13.755),(88.1,13.755)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,15.355),(1.7,15.555),(1.9,15.555),(1.9,15.355),(1.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,15.355),(3.3,15.555),(3.5,15.555),(3.5,15.355),(3.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,15.355),(4.9,15.555),(5.1,15.555),(5.1,15.355),(4.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,15.355),(6.5,15.555),(6.7,15.555),(6.7,15.355),(6.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,15.355),(8.1,15.555),(8.3,15.555),(8.3,15.355),(8.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,15.355),(9.7,15.555),(9.9,15.555),(9.9,15.355),(9.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,15.355),(11.3,15.555),(11.5,15.555),(11.5,15.355),(11.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,15.355),(12.9,15.555),(13.1,15.555),(13.1,15.355),(12.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,15.355),(14.5,15.555),(14.7,15.555),(14.7,15.355),(14.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,15.355),(16.1,15.555),(16.3,15.555),(16.3,15.355),(16.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,15.355),(17.7,15.555),(17.9,15.555),(17.9,15.355),(17.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,15.355),(19.3,15.555),(19.5,15.555),(19.5,15.355),(19.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,15.355),(20.9,15.555),(21.1,15.555),(21.1,15.355),(20.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,15.355),(22.5,15.555),(22.7,15.555),(22.7,15.355),(22.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,15.355),(24.1,15.555),(24.3,15.555),(24.3,15.355),(24.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,15.355),(25.7,15.555),(25.9,15.555),(25.9,15.355),(25.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,15.355),(27.3,15.555),(27.5,15.555),(27.5,15.355),(27.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,15.355),(28.9,15.555),(29.1,15.555),(29.1,15.355),(28.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,15.355),(30.5,15.555),(30.7,15.555),(30.7,15.355),(30.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,15.355),(32.1,15.555),(32.3,15.555),(32.3,15.355),(32.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,15.355),(33.7,15.555),(33.9,15.555),(33.9,15.355),(33.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,15.355),(35.3,15.555),(35.5,15.555),(35.5,15.355),(35.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,15.355),(36.9,15.555),(37.1,15.555),(37.1,15.355),(36.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,15.355),(38.5,15.555),(38.7,15.555),(38.7,15.355),(38.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,15.355),(40.1,15.555),(40.3,15.555),(40.3,15.355),(40.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,15.355),(41.7,15.555),(41.9,15.555),(41.9,15.355),(41.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,15.355),(43.3,15.555),(43.5,15.555),(43.5,15.355),(43.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,15.355),(44.9,15.555),(45.1,15.555),(45.1,15.355),(44.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,15.355),(46.5,15.555),(46.7,15.555),(46.7,15.355),(46.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,15.355),(48.1,15.555),(48.3,15.555),(48.3,15.355),(48.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,15.355),(49.7,15.555),(49.9,15.555),(49.9,15.355),(49.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,15.355),(51.3,15.555),(51.5,15.555),(51.5,15.355),(51.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,15.355),(52.9,15.555),(53.1,15.555),(53.1,15.355),(52.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,15.355),(54.5,15.555),(54.7,15.555),(54.7,15.355),(54.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,15.355),(56.1,15.555),(56.3,15.555),(56.3,15.355),(56.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,15.355),(57.7,15.555),(57.9,15.555),(57.9,15.355),(57.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,15.355),(59.3,15.555),(59.5,15.555),(59.5,15.355),(59.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,15.355),(60.9,15.555),(61.1,15.555),(61.1,15.355),(60.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,15.355),(62.5,15.555),(62.7,15.555),(62.7,15.355),(62.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,15.355),(64.1,15.555),(64.3,15.555),(64.3,15.355),(64.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,15.355),(65.7,15.555),(65.9,15.555),(65.9,15.355),(65.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,15.355),(67.3,15.555),(67.5,15.555),(67.5,15.355),(67.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,15.355),(68.9,15.555),(69.1,15.555),(69.1,15.355),(68.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,15.355),(70.5,15.555),(70.7,15.555),(70.7,15.355),(70.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,15.355),(72.1,15.555),(72.3,15.555),(72.3,15.355),(72.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,15.355),(73.7,15.555),(73.9,15.555),(73.9,15.355),(73.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,15.355),(75.3,15.555),(75.5,15.555),(75.5,15.355),(75.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,15.355),(76.9,15.555),(77.1,15.555),(77.1,15.355),(76.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,15.355),(78.5,15.555),(78.7,15.555),(78.7,15.355),(78.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,15.355),(80.1,15.555),(80.3,15.555),(80.3,15.355),(80.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,15.355),(81.7,15.555),(81.9,15.555),(81.9,15.355),(81.7,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,15.355),(83.3,15.555),(83.5,15.555),(83.5,15.355),(83.3,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,15.355),(84.9,15.555),(85.1,15.555),(85.1,15.355),(84.9,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,15.355),(86.5,15.555),(86.7,15.555),(86.7,15.355),(86.5,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,15.355),(88.1,15.555),(88.3,15.555),(88.3,15.355),(88.1,15.355)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,16.955),(1.7,17.155),(1.9,17.155),(1.9,16.955),(1.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,16.955),(3.3,17.155),(3.5,17.155),(3.5,16.955),(3.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,16.955),(4.9,17.155),(5.1,17.155),(5.1,16.955),(4.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,16.955),(6.5,17.155),(6.7,17.155),(6.7,16.955),(6.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,16.955),(8.1,17.155),(8.3,17.155),(8.3,16.955),(8.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,16.955),(9.7,17.155),(9.9,17.155),(9.9,16.955),(9.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,16.955),(11.3,17.155),(11.5,17.155),(11.5,16.955),(11.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,16.955),(12.9,17.155),(13.1,17.155),(13.1,16.955),(12.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,16.955),(14.5,17.155),(14.7,17.155),(14.7,16.955),(14.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,16.955),(16.1,17.155),(16.3,17.155),(16.3,16.955),(16.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,16.955),(17.7,17.155),(17.9,17.155),(17.9,16.955),(17.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,16.955),(19.3,17.155),(19.5,17.155),(19.5,16.955),(19.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,16.955),(20.9,17.155),(21.1,17.155),(21.1,16.955),(20.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,16.955),(22.5,17.155),(22.7,17.155),(22.7,16.955),(22.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,16.955),(24.1,17.155),(24.3,17.155),(24.3,16.955),(24.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,16.955),(25.7,17.155),(25.9,17.155),(25.9,16.955),(25.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,16.955),(27.3,17.155),(27.5,17.155),(27.5,16.955),(27.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,16.955),(28.9,17.155),(29.1,17.155),(29.1,16.955),(28.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,16.955),(30.5,17.155),(30.7,17.155),(30.7,16.955),(30.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,16.955),(32.1,17.155),(32.3,17.155),(32.3,16.955),(32.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,16.955),(33.7,17.155),(33.9,17.155),(33.9,16.955),(33.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,16.955),(35.3,17.155),(35.5,17.155),(35.5,16.955),(35.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,16.955),(36.9,17.155),(37.1,17.155),(37.1,16.955),(36.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,16.955),(38.5,17.155),(38.7,17.155),(38.7,16.955),(38.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,16.955),(40.1,17.155),(40.3,17.155),(40.3,16.955),(40.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,16.955),(41.7,17.155),(41.9,17.155),(41.9,16.955),(41.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,16.955),(43.3,17.155),(43.5,17.155),(43.5,16.955),(43.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,16.955),(44.9,17.155),(45.1,17.155),(45.1,16.955),(44.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,16.955),(46.5,17.155),(46.7,17.155),(46.7,16.955),(46.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,16.955),(48.1,17.155),(48.3,17.155),(48.3,16.955),(48.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,16.955),(49.7,17.155),(49.9,17.155),(49.9,16.955),(49.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,16.955),(51.3,17.155),(51.5,17.155),(51.5,16.955),(51.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,16.955),(52.9,17.155),(53.1,17.155),(53.1,16.955),(52.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,16.955),(54.5,17.155),(54.7,17.155),(54.7,16.955),(54.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,16.955),(56.1,17.155),(56.3,17.155),(56.3,16.955),(56.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,16.955),(57.7,17.155),(57.9,17.155),(57.9,16.955),(57.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,16.955),(59.3,17.155),(59.5,17.155),(59.5,16.955),(59.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,16.955),(60.9,17.155),(61.1,17.155),(61.1,16.955),(60.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,16.955),(62.5,17.155),(62.7,17.155),(62.7,16.955),(62.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,16.955),(64.1,17.155),(64.3,17.155),(64.3,16.955),(64.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,16.955),(65.7,17.155),(65.9,17.155),(65.9,16.955),(65.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,16.955),(67.3,17.155),(67.5,17.155),(67.5,16.955),(67.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,16.955),(68.9,17.155),(69.1,17.155),(69.1,16.955),(68.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,16.955),(70.5,17.155),(70.7,17.155),(70.7,16.955),(70.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,16.955),(72.1,17.155),(72.3,17.155),(72.3,16.955),(72.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,16.955),(73.7,17.155),(73.9,17.155),(73.9,16.955),(73.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,16.955),(75.3,17.155),(75.5,17.155),(75.5,16.955),(75.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,16.955),(76.9,17.155),(77.1,17.155),(77.1,16.955),(76.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,16.955),(78.5,17.155),(78.7,17.155),(78.7,16.955),(78.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,16.955),(80.1,17.155),(80.3,17.155),(80.3,16.955),(80.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,16.955),(81.7,17.155),(81.9,17.155),(81.9,16.955),(81.7,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,16.955),(83.3,17.155),(83.5,17.155),(83.5,16.955),(83.3,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,16.955),(84.9,17.155),(85.1,17.155),(85.1,16.955),(84.9,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,16.955),(86.5,17.155),(86.7,17.155),(86.7,16.955),(86.5,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,16.955),(88.1,17.155),(88.3,17.155),(88.3,16.955),(88.1,16.955)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,18.555),(1.7,18.755),(1.9,18.755),(1.9,18.555),(1.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,18.555),(3.3,18.755),(3.5,18.755),(3.5,18.555),(3.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,18.555),(4.9,18.755),(5.1,18.755),(5.1,18.555),(4.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,18.555),(6.5,18.755),(6.7,18.755),(6.7,18.555),(6.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,18.555),(8.1,18.755),(8.3,18.755),(8.3,18.555),(8.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,18.555),(9.7,18.755),(9.9,18.755),(9.9,18.555),(9.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,18.555),(11.3,18.755),(11.5,18.755),(11.5,18.555),(11.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,18.555),(12.9,18.755),(13.1,18.755),(13.1,18.555),(12.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,18.555),(14.5,18.755),(14.7,18.755),(14.7,18.555),(14.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,18.555),(16.1,18.755),(16.3,18.755),(16.3,18.555),(16.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,18.555),(17.7,18.755),(17.9,18.755),(17.9,18.555),(17.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,18.555),(19.3,18.755),(19.5,18.755),(19.5,18.555),(19.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,18.555),(20.9,18.755),(21.1,18.755),(21.1,18.555),(20.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,18.555),(22.5,18.755),(22.7,18.755),(22.7,18.555),(22.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,18.555),(24.1,18.755),(24.3,18.755),(24.3,18.555),(24.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,18.555),(25.7,18.755),(25.9,18.755),(25.9,18.555),(25.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,18.555),(27.3,18.755),(27.5,18.755),(27.5,18.555),(27.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,18.555),(28.9,18.755),(29.1,18.755),(29.1,18.555),(28.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,18.555),(30.5,18.755),(30.7,18.755),(30.7,18.555),(30.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,18.555),(32.1,18.755),(32.3,18.755),(32.3,18.555),(32.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,18.555),(33.7,18.755),(33.9,18.755),(33.9,18.555),(33.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,18.555),(35.3,18.755),(35.5,18.755),(35.5,18.555),(35.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,18.555),(36.9,18.755),(37.1,18.755),(37.1,18.555),(36.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,18.555),(38.5,18.755),(38.7,18.755),(38.7,18.555),(38.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,18.555),(40.1,18.755),(40.3,18.755),(40.3,18.555),(40.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,18.555),(41.7,18.755),(41.9,18.755),(41.9,18.555),(41.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,18.555),(43.3,18.755),(43.5,18.755),(43.5,18.555),(43.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,18.555),(44.9,18.755),(45.1,18.755),(45.1,18.555),(44.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,18.555),(46.5,18.755),(46.7,18.755),(46.7,18.555),(46.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,18.555),(48.1,18.755),(48.3,18.755),(48.3,18.555),(48.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,18.555),(49.7,18.755),(49.9,18.755),(49.9,18.555),(49.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,18.555),(51.3,18.755),(51.5,18.755),(51.5,18.555),(51.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,18.555),(52.9,18.755),(53.1,18.755),(53.1,18.555),(52.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,18.555),(54.5,18.755),(54.7,18.755),(54.7,18.555),(54.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,18.555),(56.1,18.755),(56.3,18.755),(56.3,18.555),(56.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,18.555),(57.7,18.755),(57.9,18.755),(57.9,18.555),(57.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,18.555),(59.3,18.755),(59.5,18.755),(59.5,18.555),(59.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,18.555),(60.9,18.755),(61.1,18.755),(61.1,18.555),(60.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,18.555),(62.5,18.755),(62.7,18.755),(62.7,18.555),(62.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,18.555),(64.1,18.755),(64.3,18.755),(64.3,18.555),(64.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,18.555),(65.7,18.755),(65.9,18.755),(65.9,18.555),(65.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,18.555),(67.3,18.755),(67.5,18.755),(67.5,18.555),(67.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,18.555),(68.9,18.755),(69.1,18.755),(69.1,18.555),(68.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,18.555),(70.5,18.755),(70.7,18.755),(70.7,18.555),(70.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,18.555),(72.1,18.755),(72.3,18.755),(72.3,18.555),(72.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,18.555),(73.7,18.755),(73.9,18.755),(73.9,18.555),(73.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,18.555),(75.3,18.755),(75.5,18.755),(75.5,18.555),(75.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,18.555),(76.9,18.755),(77.1,18.755),(77.1,18.555),(76.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,18.555),(78.5,18.755),(78.7,18.755),(78.7,18.555),(78.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,18.555),(80.1,18.755),(80.3,18.755),(80.3,18.555),(80.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,18.555),(81.7,18.755),(81.9,18.755),(81.9,18.555),(81.7,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,18.555),(83.3,18.755),(83.5,18.755),(83.5,18.555),(83.3,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,18.555),(84.9,18.755),(85.1,18.755),(85.1,18.555),(84.9,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,18.555),(86.5,18.755),(86.7,18.755),(86.7,18.555),(86.5,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,18.555),(88.1,18.755),(88.3,18.755),(88.3,18.555),(88.1,18.555)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,20.155),(1.7,20.355),(1.9,20.355),(1.9,20.155),(1.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,20.155),(3.3,20.355),(3.5,20.355),(3.5,20.155),(3.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,20.155),(4.9,20.355),(5.1,20.355),(5.1,20.155),(4.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,20.155),(6.5,20.355),(6.7,20.355),(6.7,20.155),(6.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,20.155),(8.1,20.355),(8.3,20.355),(8.3,20.155),(8.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,20.155),(9.7,20.355),(9.9,20.355),(9.9,20.155),(9.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,20.155),(11.3,20.355),(11.5,20.355),(11.5,20.155),(11.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,20.155),(12.9,20.355),(13.1,20.355),(13.1,20.155),(12.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,20.155),(14.5,20.355),(14.7,20.355),(14.7,20.155),(14.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,20.155),(16.1,20.355),(16.3,20.355),(16.3,20.155),(16.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,20.155),(17.7,20.355),(17.9,20.355),(17.9,20.155),(17.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,20.155),(19.3,20.355),(19.5,20.355),(19.5,20.155),(19.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,20.155),(20.9,20.355),(21.1,20.355),(21.1,20.155),(20.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,20.155),(22.5,20.355),(22.7,20.355),(22.7,20.155),(22.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,20.155),(24.1,20.355),(24.3,20.355),(24.3,20.155),(24.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,20.155),(25.7,20.355),(25.9,20.355),(25.9,20.155),(25.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,20.155),(27.3,20.355),(27.5,20.355),(27.5,20.155),(27.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,20.155),(28.9,20.355),(29.1,20.355),(29.1,20.155),(28.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,20.155),(30.5,20.355),(30.7,20.355),(30.7,20.155),(30.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,20.155),(32.1,20.355),(32.3,20.355),(32.3,20.155),(32.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,20.155),(33.7,20.355),(33.9,20.355),(33.9,20.155),(33.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,20.155),(35.3,20.355),(35.5,20.355),(35.5,20.155),(35.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,20.155),(36.9,20.355),(37.1,20.355),(37.1,20.155),(36.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,20.155),(38.5,20.355),(38.7,20.355),(38.7,20.155),(38.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,20.155),(40.1,20.355),(40.3,20.355),(40.3,20.155),(40.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,20.155),(41.7,20.355),(41.9,20.355),(41.9,20.155),(41.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,20.155),(43.3,20.355),(43.5,20.355),(43.5,20.155),(43.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,20.155),(44.9,20.355),(45.1,20.355),(45.1,20.155),(44.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,20.155),(46.5,20.355),(46.7,20.355),(46.7,20.155),(46.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,20.155),(48.1,20.355),(48.3,20.355),(48.3,20.155),(48.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,20.155),(49.7,20.355),(49.9,20.355),(49.9,20.155),(49.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,20.155),(51.3,20.355),(51.5,20.355),(51.5,20.155),(51.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,20.155),(52.9,20.355),(53.1,20.355),(53.1,20.155),(52.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,20.155),(54.5,20.355),(54.7,20.355),(54.7,20.155),(54.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,20.155),(56.1,20.355),(56.3,20.355),(56.3,20.155),(56.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,20.155),(57.7,20.355),(57.9,20.355),(57.9,20.155),(57.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,20.155),(59.3,20.355),(59.5,20.355),(59.5,20.155),(59.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,20.155),(60.9,20.355),(61.1,20.355),(61.1,20.155),(60.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,20.155),(62.5,20.355),(62.7,20.355),(62.7,20.155),(62.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,20.155),(64.1,20.355),(64.3,20.355),(64.3,20.155),(64.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,20.155),(65.7,20.355),(65.9,20.355),(65.9,20.155),(65.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,20.155),(67.3,20.355),(67.5,20.355),(67.5,20.155),(67.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,20.155),(68.9,20.355),(69.1,20.355),(69.1,20.155),(68.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,20.155),(70.5,20.355),(70.7,20.355),(70.7,20.155),(70.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,20.155),(72.1,20.355),(72.3,20.355),(72.3,20.155),(72.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,20.155),(73.7,20.355),(73.9,20.355),(73.9,20.155),(73.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,20.155),(75.3,20.355),(75.5,20.355),(75.5,20.155),(75.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,20.155),(76.9,20.355),(77.1,20.355),(77.1,20.155),(76.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,20.155),(78.5,20.355),(78.7,20.355),(78.7,20.155),(78.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,20.155),(80.1,20.355),(80.3,20.355),(80.3,20.155),(80.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,20.155),(81.7,20.355),(81.9,20.355),(81.9,20.155),(81.7,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,20.155),(83.3,20.355),(83.5,20.355),(83.5,20.155),(83.3,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,20.155),(84.9,20.355),(85.1,20.355),(85.1,20.155),(84.9,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,20.155),(86.5,20.355),(86.7,20.355),(86.7,20.155),(86.5,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,20.155),(88.1,20.355),(88.3,20.355),(88.3,20.155),(88.1,20.155)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,143.7),(1.7,143.9),(1.9,143.9),(1.9,143.7),(1.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,143.7),(3.3,143.9),(3.5,143.9),(3.5,143.7),(3.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,143.7),(4.9,143.9),(5.1,143.9),(5.1,143.7),(4.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,143.7),(6.5,143.9),(6.7,143.9),(6.7,143.7),(6.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,143.7),(8.1,143.9),(8.3,143.9),(8.3,143.7),(8.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,143.7),(9.7,143.9),(9.9,143.9),(9.9,143.7),(9.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,143.7),(11.3,143.9),(11.5,143.9),(11.5,143.7),(11.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,143.7),(12.9,143.9),(13.1,143.9),(13.1,143.7),(12.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,143.7),(14.5,143.9),(14.7,143.9),(14.7,143.7),(14.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,143.7),(16.1,143.9),(16.3,143.9),(16.3,143.7),(16.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,143.7),(17.7,143.9),(17.9,143.9),(17.9,143.7),(17.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,143.7),(19.3,143.9),(19.5,143.9),(19.5,143.7),(19.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,143.7),(20.9,143.9),(21.1,143.9),(21.1,143.7),(20.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,143.7),(22.5,143.9),(22.7,143.9),(22.7,143.7),(22.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,143.7),(24.1,143.9),(24.3,143.9),(24.3,143.7),(24.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,143.7),(25.7,143.9),(25.9,143.9),(25.9,143.7),(25.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,143.7),(27.3,143.9),(27.5,143.9),(27.5,143.7),(27.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,143.7),(28.9,143.9),(29.1,143.9),(29.1,143.7),(28.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,143.7),(30.5,143.9),(30.7,143.9),(30.7,143.7),(30.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,143.7),(32.1,143.9),(32.3,143.9),(32.3,143.7),(32.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,143.7),(33.7,143.9),(33.9,143.9),(33.9,143.7),(33.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,143.7),(35.3,143.9),(35.5,143.9),(35.5,143.7),(35.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,143.7),(36.9,143.9),(37.1,143.9),(37.1,143.7),(36.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,143.7),(38.5,143.9),(38.7,143.9),(38.7,143.7),(38.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,143.7),(40.1,143.9),(40.3,143.9),(40.3,143.7),(40.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,143.7),(41.7,143.9),(41.9,143.9),(41.9,143.7),(41.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,143.7),(43.3,143.9),(43.5,143.9),(43.5,143.7),(43.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,143.7),(44.9,143.9),(45.1,143.9),(45.1,143.7),(44.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,143.7),(46.5,143.9),(46.7,143.9),(46.7,143.7),(46.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,143.7),(48.1,143.9),(48.3,143.9),(48.3,143.7),(48.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,143.7),(49.7,143.9),(49.9,143.9),(49.9,143.7),(49.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,143.7),(51.3,143.9),(51.5,143.9),(51.5,143.7),(51.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,143.7),(52.9,143.9),(53.1,143.9),(53.1,143.7),(52.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,143.7),(54.5,143.9),(54.7,143.9),(54.7,143.7),(54.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,143.7),(56.1,143.9),(56.3,143.9),(56.3,143.7),(56.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,143.7),(57.7,143.9),(57.9,143.9),(57.9,143.7),(57.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,143.7),(59.3,143.9),(59.5,143.9),(59.5,143.7),(59.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,143.7),(60.9,143.9),(61.1,143.9),(61.1,143.7),(60.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,143.7),(62.5,143.9),(62.7,143.9),(62.7,143.7),(62.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,143.7),(64.1,143.9),(64.3,143.9),(64.3,143.7),(64.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,143.7),(65.7,143.9),(65.9,143.9),(65.9,143.7),(65.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,143.7),(67.3,143.9),(67.5,143.9),(67.5,143.7),(67.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,143.7),(68.9,143.9),(69.1,143.9),(69.1,143.7),(68.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,143.7),(70.5,143.9),(70.7,143.9),(70.7,143.7),(70.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,143.7),(72.1,143.9),(72.3,143.9),(72.3,143.7),(72.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,143.7),(73.7,143.9),(73.9,143.9),(73.9,143.7),(73.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,143.7),(75.3,143.9),(75.5,143.9),(75.5,143.7),(75.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,143.7),(76.9,143.9),(77.1,143.9),(77.1,143.7),(76.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,143.7),(78.5,143.9),(78.7,143.9),(78.7,143.7),(78.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,143.7),(80.1,143.9),(80.3,143.9),(80.3,143.7),(80.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,143.7),(81.7,143.9),(81.9,143.9),(81.9,143.7),(81.7,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,143.7),(83.3,143.9),(83.5,143.9),(83.5,143.7),(83.3,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,143.7),(84.9,143.9),(85.1,143.9),(85.1,143.7),(84.9,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,143.7),(86.5,143.9),(86.7,143.9),(86.7,143.7),(86.5,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,143.7),(88.1,143.9),(88.3,143.9),(88.3,143.7),(88.1,143.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,145.3),(1.7,145.5),(1.9,145.5),(1.9,145.3),(1.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,145.3),(3.3,145.5),(3.5,145.5),(3.5,145.3),(3.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,145.3),(4.9,145.5),(5.1,145.5),(5.1,145.3),(4.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,145.3),(6.5,145.5),(6.7,145.5),(6.7,145.3),(6.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,145.3),(8.1,145.5),(8.3,145.5),(8.3,145.3),(8.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,145.3),(9.7,145.5),(9.9,145.5),(9.9,145.3),(9.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,145.3),(11.3,145.5),(11.5,145.5),(11.5,145.3),(11.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,145.3),(12.9,145.5),(13.1,145.5),(13.1,145.3),(12.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,145.3),(14.5,145.5),(14.7,145.5),(14.7,145.3),(14.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,145.3),(16.1,145.5),(16.3,145.5),(16.3,145.3),(16.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,145.3),(17.7,145.5),(17.9,145.5),(17.9,145.3),(17.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,145.3),(19.3,145.5),(19.5,145.5),(19.5,145.3),(19.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,145.3),(20.9,145.5),(21.1,145.5),(21.1,145.3),(20.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,145.3),(22.5,145.5),(22.7,145.5),(22.7,145.3),(22.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,145.3),(24.1,145.5),(24.3,145.5),(24.3,145.3),(24.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,145.3),(25.7,145.5),(25.9,145.5),(25.9,145.3),(25.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,145.3),(27.3,145.5),(27.5,145.5),(27.5,145.3),(27.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,145.3),(28.9,145.5),(29.1,145.5),(29.1,145.3),(28.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,145.3),(30.5,145.5),(30.7,145.5),(30.7,145.3),(30.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,145.3),(32.1,145.5),(32.3,145.5),(32.3,145.3),(32.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,145.3),(33.7,145.5),(33.9,145.5),(33.9,145.3),(33.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,145.3),(35.3,145.5),(35.5,145.5),(35.5,145.3),(35.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,145.3),(36.9,145.5),(37.1,145.5),(37.1,145.3),(36.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,145.3),(38.5,145.5),(38.7,145.5),(38.7,145.3),(38.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,145.3),(40.1,145.5),(40.3,145.5),(40.3,145.3),(40.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,145.3),(41.7,145.5),(41.9,145.5),(41.9,145.3),(41.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,145.3),(43.3,145.5),(43.5,145.5),(43.5,145.3),(43.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,145.3),(44.9,145.5),(45.1,145.5),(45.1,145.3),(44.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,145.3),(46.5,145.5),(46.7,145.5),(46.7,145.3),(46.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,145.3),(48.1,145.5),(48.3,145.5),(48.3,145.3),(48.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,145.3),(49.7,145.5),(49.9,145.5),(49.9,145.3),(49.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,145.3),(51.3,145.5),(51.5,145.5),(51.5,145.3),(51.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,145.3),(52.9,145.5),(53.1,145.5),(53.1,145.3),(52.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,145.3),(54.5,145.5),(54.7,145.5),(54.7,145.3),(54.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,145.3),(56.1,145.5),(56.3,145.5),(56.3,145.3),(56.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,145.3),(57.7,145.5),(57.9,145.5),(57.9,145.3),(57.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,145.3),(59.3,145.5),(59.5,145.5),(59.5,145.3),(59.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,145.3),(60.9,145.5),(61.1,145.5),(61.1,145.3),(60.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,145.3),(62.5,145.5),(62.7,145.5),(62.7,145.3),(62.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,145.3),(64.1,145.5),(64.3,145.5),(64.3,145.3),(64.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,145.3),(65.7,145.5),(65.9,145.5),(65.9,145.3),(65.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,145.3),(67.3,145.5),(67.5,145.5),(67.5,145.3),(67.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,145.3),(68.9,145.5),(69.1,145.5),(69.1,145.3),(68.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,145.3),(70.5,145.5),(70.7,145.5),(70.7,145.3),(70.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,145.3),(72.1,145.5),(72.3,145.5),(72.3,145.3),(72.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,145.3),(73.7,145.5),(73.9,145.5),(73.9,145.3),(73.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,145.3),(75.3,145.5),(75.5,145.5),(75.5,145.3),(75.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,145.3),(76.9,145.5),(77.1,145.5),(77.1,145.3),(76.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,145.3),(78.5,145.5),(78.7,145.5),(78.7,145.3),(78.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,145.3),(80.1,145.5),(80.3,145.5),(80.3,145.3),(80.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,145.3),(81.7,145.5),(81.9,145.5),(81.9,145.3),(81.7,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,145.3),(83.3,145.5),(83.5,145.5),(83.5,145.3),(83.3,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,145.3),(84.9,145.5),(85.1,145.5),(85.1,145.3),(84.9,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,145.3),(86.5,145.5),(86.7,145.5),(86.7,145.3),(86.5,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,145.3),(88.1,145.5),(88.3,145.5),(88.3,145.3),(88.1,145.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,146.9),(1.7,147.1),(1.9,147.1),(1.9,146.9),(1.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,146.9),(3.3,147.1),(3.5,147.1),(3.5,146.9),(3.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,146.9),(4.9,147.1),(5.1,147.1),(5.1,146.9),(4.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,146.9),(6.5,147.1),(6.7,147.1),(6.7,146.9),(6.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,146.9),(8.1,147.1),(8.3,147.1),(8.3,146.9),(8.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,146.9),(9.7,147.1),(9.9,147.1),(9.9,146.9),(9.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,146.9),(11.3,147.1),(11.5,147.1),(11.5,146.9),(11.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,146.9),(12.9,147.1),(13.1,147.1),(13.1,146.9),(12.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,146.9),(14.5,147.1),(14.7,147.1),(14.7,146.9),(14.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,146.9),(16.1,147.1),(16.3,147.1),(16.3,146.9),(16.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,146.9),(17.7,147.1),(17.9,147.1),(17.9,146.9),(17.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,146.9),(19.3,147.1),(19.5,147.1),(19.5,146.9),(19.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,146.9),(20.9,147.1),(21.1,147.1),(21.1,146.9),(20.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,146.9),(22.5,147.1),(22.7,147.1),(22.7,146.9),(22.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,146.9),(24.1,147.1),(24.3,147.1),(24.3,146.9),(24.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,146.9),(25.7,147.1),(25.9,147.1),(25.9,146.9),(25.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,146.9),(27.3,147.1),(27.5,147.1),(27.5,146.9),(27.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,146.9),(28.9,147.1),(29.1,147.1),(29.1,146.9),(28.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,146.9),(30.5,147.1),(30.7,147.1),(30.7,146.9),(30.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,146.9),(32.1,147.1),(32.3,147.1),(32.3,146.9),(32.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,146.9),(33.7,147.1),(33.9,147.1),(33.9,146.9),(33.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,146.9),(35.3,147.1),(35.5,147.1),(35.5,146.9),(35.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,146.9),(36.9,147.1),(37.1,147.1),(37.1,146.9),(36.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,146.9),(38.5,147.1),(38.7,147.1),(38.7,146.9),(38.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,146.9),(40.1,147.1),(40.3,147.1),(40.3,146.9),(40.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,146.9),(41.7,147.1),(41.9,147.1),(41.9,146.9),(41.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,146.9),(43.3,147.1),(43.5,147.1),(43.5,146.9),(43.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,146.9),(44.9,147.1),(45.1,147.1),(45.1,146.9),(44.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,146.9),(46.5,147.1),(46.7,147.1),(46.7,146.9),(46.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,146.9),(48.1,147.1),(48.3,147.1),(48.3,146.9),(48.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,146.9),(49.7,147.1),(49.9,147.1),(49.9,146.9),(49.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,146.9),(51.3,147.1),(51.5,147.1),(51.5,146.9),(51.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,146.9),(52.9,147.1),(53.1,147.1),(53.1,146.9),(52.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,146.9),(54.5,147.1),(54.7,147.1),(54.7,146.9),(54.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,146.9),(56.1,147.1),(56.3,147.1),(56.3,146.9),(56.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,146.9),(57.7,147.1),(57.9,147.1),(57.9,146.9),(57.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,146.9),(59.3,147.1),(59.5,147.1),(59.5,146.9),(59.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,146.9),(60.9,147.1),(61.1,147.1),(61.1,146.9),(60.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,146.9),(62.5,147.1),(62.7,147.1),(62.7,146.9),(62.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,146.9),(64.1,147.1),(64.3,147.1),(64.3,146.9),(64.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,146.9),(65.7,147.1),(65.9,147.1),(65.9,146.9),(65.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,146.9),(67.3,147.1),(67.5,147.1),(67.5,146.9),(67.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,146.9),(68.9,147.1),(69.1,147.1),(69.1,146.9),(68.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,146.9),(70.5,147.1),(70.7,147.1),(70.7,146.9),(70.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,146.9),(72.1,147.1),(72.3,147.1),(72.3,146.9),(72.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,146.9),(73.7,147.1),(73.9,147.1),(73.9,146.9),(73.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,146.9),(75.3,147.1),(75.5,147.1),(75.5,146.9),(75.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,146.9),(76.9,147.1),(77.1,147.1),(77.1,146.9),(76.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,146.9),(78.5,147.1),(78.7,147.1),(78.7,146.9),(78.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,146.9),(80.1,147.1),(80.3,147.1),(80.3,146.9),(80.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,146.9),(81.7,147.1),(81.9,147.1),(81.9,146.9),(81.7,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,146.9),(83.3,147.1),(83.5,147.1),(83.5,146.9),(83.3,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,146.9),(84.9,147.1),(85.1,147.1),(85.1,146.9),(84.9,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,146.9),(86.5,147.1),(86.7,147.1),(86.7,146.9),(86.5,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,146.9),(88.1,147.1),(88.3,147.1),(88.3,146.9),(88.1,146.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,148.5),(1.7,148.7),(1.9,148.7),(1.9,148.5),(1.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,148.5),(3.3,148.7),(3.5,148.7),(3.5,148.5),(3.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,148.5),(4.9,148.7),(5.1,148.7),(5.1,148.5),(4.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,148.5),(6.5,148.7),(6.7,148.7),(6.7,148.5),(6.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,148.5),(8.1,148.7),(8.3,148.7),(8.3,148.5),(8.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,148.5),(9.7,148.7),(9.9,148.7),(9.9,148.5),(9.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,148.5),(11.3,148.7),(11.5,148.7),(11.5,148.5),(11.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,148.5),(12.9,148.7),(13.1,148.7),(13.1,148.5),(12.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,148.5),(14.5,148.7),(14.7,148.7),(14.7,148.5),(14.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,148.5),(16.1,148.7),(16.3,148.7),(16.3,148.5),(16.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,148.5),(17.7,148.7),(17.9,148.7),(17.9,148.5),(17.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,148.5),(19.3,148.7),(19.5,148.7),(19.5,148.5),(19.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,148.5),(20.9,148.7),(21.1,148.7),(21.1,148.5),(20.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,148.5),(22.5,148.7),(22.7,148.7),(22.7,148.5),(22.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,148.5),(24.1,148.7),(24.3,148.7),(24.3,148.5),(24.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,148.5),(25.7,148.7),(25.9,148.7),(25.9,148.5),(25.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,148.5),(27.3,148.7),(27.5,148.7),(27.5,148.5),(27.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,148.5),(28.9,148.7),(29.1,148.7),(29.1,148.5),(28.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,148.5),(30.5,148.7),(30.7,148.7),(30.7,148.5),(30.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,148.5),(32.1,148.7),(32.3,148.7),(32.3,148.5),(32.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,148.5),(33.7,148.7),(33.9,148.7),(33.9,148.5),(33.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,148.5),(35.3,148.7),(35.5,148.7),(35.5,148.5),(35.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,148.5),(36.9,148.7),(37.1,148.7),(37.1,148.5),(36.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,148.5),(38.5,148.7),(38.7,148.7),(38.7,148.5),(38.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,148.5),(40.1,148.7),(40.3,148.7),(40.3,148.5),(40.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,148.5),(41.7,148.7),(41.9,148.7),(41.9,148.5),(41.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,148.5),(43.3,148.7),(43.5,148.7),(43.5,148.5),(43.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,148.5),(44.9,148.7),(45.1,148.7),(45.1,148.5),(44.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,148.5),(46.5,148.7),(46.7,148.7),(46.7,148.5),(46.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,148.5),(48.1,148.7),(48.3,148.7),(48.3,148.5),(48.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,148.5),(49.7,148.7),(49.9,148.7),(49.9,148.5),(49.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,148.5),(51.3,148.7),(51.5,148.7),(51.5,148.5),(51.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,148.5),(52.9,148.7),(53.1,148.7),(53.1,148.5),(52.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,148.5),(54.5,148.7),(54.7,148.7),(54.7,148.5),(54.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,148.5),(56.1,148.7),(56.3,148.7),(56.3,148.5),(56.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,148.5),(57.7,148.7),(57.9,148.7),(57.9,148.5),(57.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,148.5),(59.3,148.7),(59.5,148.7),(59.5,148.5),(59.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,148.5),(60.9,148.7),(61.1,148.7),(61.1,148.5),(60.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,148.5),(62.5,148.7),(62.7,148.7),(62.7,148.5),(62.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,148.5),(64.1,148.7),(64.3,148.7),(64.3,148.5),(64.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,148.5),(65.7,148.7),(65.9,148.7),(65.9,148.5),(65.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,148.5),(67.3,148.7),(67.5,148.7),(67.5,148.5),(67.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,148.5),(68.9,148.7),(69.1,148.7),(69.1,148.5),(68.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,148.5),(70.5,148.7),(70.7,148.7),(70.7,148.5),(70.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,148.5),(72.1,148.7),(72.3,148.7),(72.3,148.5),(72.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,148.5),(73.7,148.7),(73.9,148.7),(73.9,148.5),(73.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,148.5),(75.3,148.7),(75.5,148.7),(75.5,148.5),(75.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,148.5),(76.9,148.7),(77.1,148.7),(77.1,148.5),(76.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,148.5),(78.5,148.7),(78.7,148.7),(78.7,148.5),(78.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,148.5),(80.1,148.7),(80.3,148.7),(80.3,148.5),(80.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,148.5),(81.7,148.7),(81.9,148.7),(81.9,148.5),(81.7,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,148.5),(83.3,148.7),(83.5,148.7),(83.5,148.5),(83.3,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,148.5),(84.9,148.7),(85.1,148.7),(85.1,148.5),(84.9,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,148.5),(86.5,148.7),(86.7,148.7),(86.7,148.5),(86.5,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,148.5),(88.1,148.7),(88.3,148.7),(88.3,148.5),(88.1,148.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,150.1),(1.7,150.3),(1.9,150.3),(1.9,150.1),(1.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,150.1),(3.3,150.3),(3.5,150.3),(3.5,150.1),(3.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,150.1),(4.9,150.3),(5.1,150.3),(5.1,150.1),(4.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,150.1),(6.5,150.3),(6.7,150.3),(6.7,150.1),(6.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,150.1),(8.1,150.3),(8.3,150.3),(8.3,150.1),(8.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,150.1),(9.7,150.3),(9.9,150.3),(9.9,150.1),(9.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,150.1),(11.3,150.3),(11.5,150.3),(11.5,150.1),(11.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,150.1),(12.9,150.3),(13.1,150.3),(13.1,150.1),(12.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,150.1),(14.5,150.3),(14.7,150.3),(14.7,150.1),(14.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,150.1),(16.1,150.3),(16.3,150.3),(16.3,150.1),(16.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,150.1),(17.7,150.3),(17.9,150.3),(17.9,150.1),(17.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,150.1),(19.3,150.3),(19.5,150.3),(19.5,150.1),(19.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,150.1),(20.9,150.3),(21.1,150.3),(21.1,150.1),(20.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,150.1),(22.5,150.3),(22.7,150.3),(22.7,150.1),(22.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,150.1),(24.1,150.3),(24.3,150.3),(24.3,150.1),(24.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,150.1),(25.7,150.3),(25.9,150.3),(25.9,150.1),(25.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,150.1),(27.3,150.3),(27.5,150.3),(27.5,150.1),(27.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,150.1),(28.9,150.3),(29.1,150.3),(29.1,150.1),(28.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,150.1),(30.5,150.3),(30.7,150.3),(30.7,150.1),(30.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,150.1),(32.1,150.3),(32.3,150.3),(32.3,150.1),(32.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,150.1),(33.7,150.3),(33.9,150.3),(33.9,150.1),(33.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,150.1),(35.3,150.3),(35.5,150.3),(35.5,150.1),(35.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,150.1),(36.9,150.3),(37.1,150.3),(37.1,150.1),(36.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,150.1),(38.5,150.3),(38.7,150.3),(38.7,150.1),(38.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,150.1),(40.1,150.3),(40.3,150.3),(40.3,150.1),(40.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,150.1),(41.7,150.3),(41.9,150.3),(41.9,150.1),(41.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,150.1),(43.3,150.3),(43.5,150.3),(43.5,150.1),(43.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,150.1),(44.9,150.3),(45.1,150.3),(45.1,150.1),(44.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,150.1),(46.5,150.3),(46.7,150.3),(46.7,150.1),(46.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,150.1),(48.1,150.3),(48.3,150.3),(48.3,150.1),(48.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,150.1),(49.7,150.3),(49.9,150.3),(49.9,150.1),(49.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,150.1),(51.3,150.3),(51.5,150.3),(51.5,150.1),(51.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,150.1),(52.9,150.3),(53.1,150.3),(53.1,150.1),(52.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,150.1),(54.5,150.3),(54.7,150.3),(54.7,150.1),(54.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,150.1),(56.1,150.3),(56.3,150.3),(56.3,150.1),(56.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,150.1),(57.7,150.3),(57.9,150.3),(57.9,150.1),(57.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,150.1),(59.3,150.3),(59.5,150.3),(59.5,150.1),(59.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,150.1),(60.9,150.3),(61.1,150.3),(61.1,150.1),(60.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,150.1),(62.5,150.3),(62.7,150.3),(62.7,150.1),(62.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,150.1),(64.1,150.3),(64.3,150.3),(64.3,150.1),(64.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,150.1),(65.7,150.3),(65.9,150.3),(65.9,150.1),(65.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,150.1),(67.3,150.3),(67.5,150.3),(67.5,150.1),(67.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,150.1),(68.9,150.3),(69.1,150.3),(69.1,150.1),(68.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,150.1),(70.5,150.3),(70.7,150.3),(70.7,150.1),(70.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,150.1),(72.1,150.3),(72.3,150.3),(72.3,150.1),(72.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,150.1),(73.7,150.3),(73.9,150.3),(73.9,150.1),(73.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,150.1),(75.3,150.3),(75.5,150.3),(75.5,150.1),(75.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,150.1),(76.9,150.3),(77.1,150.3),(77.1,150.1),(76.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,150.1),(78.5,150.3),(78.7,150.3),(78.7,150.1),(78.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,150.1),(80.1,150.3),(80.3,150.3),(80.3,150.1),(80.1,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,150.1),(81.7,150.3),(81.9,150.3),(81.9,150.1),(81.7,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,150.1),(83.3,150.3),(83.5,150.3),(83.5,150.1),(83.3,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,150.1),(84.9,150.3),(85.1,150.3),(85.1,150.1),(84.9,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,150.1),(86.5,150.3),(86.7,150.3),(86.7,150.1),(86.5,150.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,150.1),(88.1,150.3),(88.3,150.3),(88.3,150.1),(88.1,150.1)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,11.77),(0.0,22.34),(90.0,22.34),(90.0,11.77),(0.0,11.77)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,142.0),(0.0,152.0),(90.0,152.0),(90.0,142.0),(0.0,142.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,0.0),(0.0,10.57),(90.0,10.57),(90.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,2.485),(1.4,3.285),(2.2,3.285),(2.2,2.485),(1.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,2.485),(3.0,3.285),(3.8,3.285),(3.8,2.485),(3.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,2.485),(4.6,3.285),(5.4,3.285),(5.4,2.485),(4.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,2.485),(6.2,3.285),(7.0,3.285),(7.0,2.485),(6.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,2.485),(7.8,3.285),(8.6,3.285),(8.6,2.485),(7.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,2.485),(9.4,3.285),(10.2,3.285),(10.2,2.485),(9.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,2.485),(11.0,3.285),(11.8,3.285),(11.8,2.485),(11.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,2.485),(12.6,3.285),(13.4,3.285),(13.4,2.485),(12.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,2.485),(14.2,3.285),(15.0,3.285),(15.0,2.485),(14.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,2.485),(15.8,3.285),(16.6,3.285),(16.6,2.485),(15.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,2.485),(17.4,3.285),(18.2,3.285),(18.2,2.485),(17.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,2.485),(19.0,3.285),(19.8,3.285),(19.8,2.485),(19.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,2.485),(20.6,3.285),(21.4,3.285),(21.4,2.485),(20.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,2.485),(22.2,3.285),(23.0,3.285),(23.0,2.485),(22.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,2.485),(23.8,3.285),(24.6,3.285),(24.6,2.485),(23.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,2.485),(25.4,3.285),(26.2,3.285),(26.2,2.485),(25.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,2.485),(27.0,3.285),(27.8,3.285),(27.8,2.485),(27.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,2.485),(28.6,3.285),(29.4,3.285),(29.4,2.485),(28.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,2.485),(30.2,3.285),(31.0,3.285),(31.0,2.485),(30.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,2.485),(31.8,3.285),(32.6,3.285),(32.6,2.485),(31.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,2.485),(33.4,3.285),(34.2,3.285),(34.2,2.485),(33.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,2.485),(35.0,3.285),(35.8,3.285),(35.8,2.485),(35.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,2.485),(36.6,3.285),(37.4,3.285),(37.4,2.485),(36.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,2.485),(38.2,3.285),(39.0,3.285),(39.0,2.485),(38.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,2.485),(39.8,3.285),(40.6,3.285),(40.6,2.485),(39.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,2.485),(41.4,3.285),(42.2,3.285),(42.2,2.485),(41.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,2.485),(43.0,3.285),(43.8,3.285),(43.8,2.485),(43.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,2.485),(44.6,3.285),(45.4,3.285),(45.4,2.485),(44.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,2.485),(46.2,3.285),(47.0,3.285),(47.0,2.485),(46.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,2.485),(47.8,3.285),(48.6,3.285),(48.6,2.485),(47.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,2.485),(49.4,3.285),(50.2,3.285),(50.2,2.485),(49.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,2.485),(51.0,3.285),(51.8,3.285),(51.8,2.485),(51.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,2.485),(52.6,3.285),(53.4,3.285),(53.4,2.485),(52.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,2.485),(54.2,3.285),(55.0,3.285),(55.0,2.485),(54.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,2.485),(55.8,3.285),(56.6,3.285),(56.6,2.485),(55.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,2.485),(57.4,3.285),(58.2,3.285),(58.2,2.485),(57.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,2.485),(59.0,3.285),(59.8,3.285),(59.8,2.485),(59.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,2.485),(60.6,3.285),(61.4,3.285),(61.4,2.485),(60.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,2.485),(62.2,3.285),(63.0,3.285),(63.0,2.485),(62.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,2.485),(63.8,3.285),(64.6,3.285),(64.6,2.485),(63.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,2.485),(65.4,3.285),(66.2,3.285),(66.2,2.485),(65.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,2.485),(67.0,3.285),(67.8,3.285),(67.8,2.485),(67.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,2.485),(68.6,3.285),(69.4,3.285),(69.4,2.485),(68.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,2.485),(70.2,3.285),(71.0,3.285),(71.0,2.485),(70.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,2.485),(71.8,3.285),(72.6,3.285),(72.6,2.485),(71.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,2.485),(73.4,3.285),(74.2,3.285),(74.2,2.485),(73.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,2.485),(75.0,3.285),(75.8,3.285),(75.8,2.485),(75.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,2.485),(76.6,3.285),(77.4,3.285),(77.4,2.485),(76.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,2.485),(78.2,3.285),(79.0,3.285),(79.0,2.485),(78.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,2.485),(79.8,3.285),(80.6,3.285),(80.6,2.485),(79.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,2.485),(81.4,3.285),(82.2,3.285),(82.2,2.485),(81.4,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,2.485),(83.0,3.285),(83.8,3.285),(83.8,2.485),(83.0,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,2.485),(84.6,3.285),(85.4,3.285),(85.4,2.485),(84.6,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,2.485),(86.2,3.285),(87.0,3.285),(87.0,2.485),(86.2,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,2.485),(87.8,3.285),(88.6,3.285),(88.6,2.485),(87.8,2.485)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,4.085),(1.4,4.885),(2.2,4.885),(2.2,4.085),(1.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,4.085),(3.0,4.885),(3.8,4.885),(3.8,4.085),(3.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,4.085),(4.6,4.885),(5.4,4.885),(5.4,4.085),(4.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,4.085),(6.2,4.885),(7.0,4.885),(7.0,4.085),(6.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,4.085),(7.8,4.885),(8.6,4.885),(8.6,4.085),(7.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,4.085),(9.4,4.885),(10.2,4.885),(10.2,4.085),(9.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,4.085),(11.0,4.885),(11.8,4.885),(11.8,4.085),(11.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,4.085),(12.6,4.885),(13.4,4.885),(13.4,4.085),(12.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,4.085),(14.2,4.885),(15.0,4.885),(15.0,4.085),(14.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,4.085),(15.8,4.885),(16.6,4.885),(16.6,4.085),(15.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,4.085),(17.4,4.885),(18.2,4.885),(18.2,4.085),(17.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,4.085),(19.0,4.885),(19.8,4.885),(19.8,4.085),(19.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,4.085),(20.6,4.885),(21.4,4.885),(21.4,4.085),(20.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,4.085),(22.2,4.885),(23.0,4.885),(23.0,4.085),(22.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,4.085),(23.8,4.885),(24.6,4.885),(24.6,4.085),(23.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,4.085),(25.4,4.885),(26.2,4.885),(26.2,4.085),(25.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,4.085),(27.0,4.885),(27.8,4.885),(27.8,4.085),(27.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,4.085),(28.6,4.885),(29.4,4.885),(29.4,4.085),(28.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,4.085),(30.2,4.885),(31.0,4.885),(31.0,4.085),(30.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,4.085),(31.8,4.885),(32.6,4.885),(32.6,4.085),(31.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,4.085),(33.4,4.885),(34.2,4.885),(34.2,4.085),(33.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,4.085),(35.0,4.885),(35.8,4.885),(35.8,4.085),(35.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,4.085),(36.6,4.885),(37.4,4.885),(37.4,4.085),(36.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,4.085),(38.2,4.885),(39.0,4.885),(39.0,4.085),(38.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,4.085),(39.8,4.885),(40.6,4.885),(40.6,4.085),(39.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,4.085),(41.4,4.885),(42.2,4.885),(42.2,4.085),(41.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,4.085),(43.0,4.885),(43.8,4.885),(43.8,4.085),(43.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,4.085),(44.6,4.885),(45.4,4.885),(45.4,4.085),(44.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,4.085),(46.2,4.885),(47.0,4.885),(47.0,4.085),(46.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,4.085),(47.8,4.885),(48.6,4.885),(48.6,4.085),(47.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,4.085),(49.4,4.885),(50.2,4.885),(50.2,4.085),(49.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,4.085),(51.0,4.885),(51.8,4.885),(51.8,4.085),(51.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,4.085),(52.6,4.885),(53.4,4.885),(53.4,4.085),(52.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,4.085),(54.2,4.885),(55.0,4.885),(55.0,4.085),(54.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,4.085),(55.8,4.885),(56.6,4.885),(56.6,4.085),(55.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,4.085),(57.4,4.885),(58.2,4.885),(58.2,4.085),(57.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,4.085),(59.0,4.885),(59.8,4.885),(59.8,4.085),(59.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,4.085),(60.6,4.885),(61.4,4.885),(61.4,4.085),(60.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,4.085),(62.2,4.885),(63.0,4.885),(63.0,4.085),(62.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,4.085),(63.8,4.885),(64.6,4.885),(64.6,4.085),(63.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,4.085),(65.4,4.885),(66.2,4.885),(66.2,4.085),(65.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,4.085),(67.0,4.885),(67.8,4.885),(67.8,4.085),(67.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,4.085),(68.6,4.885),(69.4,4.885),(69.4,4.085),(68.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,4.085),(70.2,4.885),(71.0,4.885),(71.0,4.085),(70.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,4.085),(71.8,4.885),(72.6,4.885),(72.6,4.085),(71.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,4.085),(73.4,4.885),(74.2,4.885),(74.2,4.085),(73.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,4.085),(75.0,4.885),(75.8,4.885),(75.8,4.085),(75.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,4.085),(76.6,4.885),(77.4,4.885),(77.4,4.085),(76.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,4.085),(78.2,4.885),(79.0,4.885),(79.0,4.085),(78.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,4.085),(79.8,4.885),(80.6,4.885),(80.6,4.085),(79.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,4.085),(81.4,4.885),(82.2,4.885),(82.2,4.085),(81.4,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,4.085),(83.0,4.885),(83.8,4.885),(83.8,4.085),(83.0,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,4.085),(84.6,4.885),(85.4,4.885),(85.4,4.085),(84.6,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,4.085),(86.2,4.885),(87.0,4.885),(87.0,4.085),(86.2,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,4.085),(87.8,4.885),(88.6,4.885),(88.6,4.085),(87.8,4.085)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,5.685),(1.4,6.485),(2.2,6.485),(2.2,5.685),(1.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,5.685),(3.0,6.485),(3.8,6.485),(3.8,5.685),(3.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,5.685),(4.6,6.485),(5.4,6.485),(5.4,5.685),(4.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,5.685),(6.2,6.485),(7.0,6.485),(7.0,5.685),(6.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,5.685),(7.8,6.485),(8.6,6.485),(8.6,5.685),(7.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,5.685),(9.4,6.485),(10.2,6.485),(10.2,5.685),(9.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,5.685),(11.0,6.485),(11.8,6.485),(11.8,5.685),(11.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,5.685),(12.6,6.485),(13.4,6.485),(13.4,5.685),(12.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,5.685),(14.2,6.485),(15.0,6.485),(15.0,5.685),(14.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,5.685),(15.8,6.485),(16.6,6.485),(16.6,5.685),(15.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,5.685),(17.4,6.485),(18.2,6.485),(18.2,5.685),(17.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,5.685),(19.0,6.485),(19.8,6.485),(19.8,5.685),(19.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,5.685),(20.6,6.485),(21.4,6.485),(21.4,5.685),(20.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,5.685),(22.2,6.485),(23.0,6.485),(23.0,5.685),(22.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,5.685),(23.8,6.485),(24.6,6.485),(24.6,5.685),(23.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,5.685),(25.4,6.485),(26.2,6.485),(26.2,5.685),(25.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,5.685),(27.0,6.485),(27.8,6.485),(27.8,5.685),(27.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,5.685),(28.6,6.485),(29.4,6.485),(29.4,5.685),(28.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,5.685),(30.2,6.485),(31.0,6.485),(31.0,5.685),(30.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,5.685),(31.8,6.485),(32.6,6.485),(32.6,5.685),(31.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,5.685),(33.4,6.485),(34.2,6.485),(34.2,5.685),(33.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,5.685),(35.0,6.485),(35.8,6.485),(35.8,5.685),(35.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,5.685),(36.6,6.485),(37.4,6.485),(37.4,5.685),(36.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,5.685),(38.2,6.485),(39.0,6.485),(39.0,5.685),(38.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,5.685),(39.8,6.485),(40.6,6.485),(40.6,5.685),(39.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,5.685),(41.4,6.485),(42.2,6.485),(42.2,5.685),(41.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,5.685),(43.0,6.485),(43.8,6.485),(43.8,5.685),(43.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,5.685),(44.6,6.485),(45.4,6.485),(45.4,5.685),(44.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,5.685),(46.2,6.485),(47.0,6.485),(47.0,5.685),(46.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,5.685),(47.8,6.485),(48.6,6.485),(48.6,5.685),(47.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,5.685),(49.4,6.485),(50.2,6.485),(50.2,5.685),(49.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,5.685),(51.0,6.485),(51.8,6.485),(51.8,5.685),(51.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,5.685),(52.6,6.485),(53.4,6.485),(53.4,5.685),(52.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,5.685),(54.2,6.485),(55.0,6.485),(55.0,5.685),(54.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,5.685),(55.8,6.485),(56.6,6.485),(56.6,5.685),(55.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,5.685),(57.4,6.485),(58.2,6.485),(58.2,5.685),(57.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,5.685),(59.0,6.485),(59.8,6.485),(59.8,5.685),(59.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,5.685),(60.6,6.485),(61.4,6.485),(61.4,5.685),(60.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,5.685),(62.2,6.485),(63.0,6.485),(63.0,5.685),(62.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,5.685),(63.8,6.485),(64.6,6.485),(64.6,5.685),(63.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,5.685),(65.4,6.485),(66.2,6.485),(66.2,5.685),(65.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,5.685),(67.0,6.485),(67.8,6.485),(67.8,5.685),(67.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,5.685),(68.6,6.485),(69.4,6.485),(69.4,5.685),(68.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,5.685),(70.2,6.485),(71.0,6.485),(71.0,5.685),(70.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,5.685),(71.8,6.485),(72.6,6.485),(72.6,5.685),(71.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,5.685),(73.4,6.485),(74.2,6.485),(74.2,5.685),(73.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,5.685),(75.0,6.485),(75.8,6.485),(75.8,5.685),(75.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,5.685),(76.6,6.485),(77.4,6.485),(77.4,5.685),(76.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,5.685),(78.2,6.485),(79.0,6.485),(79.0,5.685),(78.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,5.685),(79.8,6.485),(80.6,6.485),(80.6,5.685),(79.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,5.685),(81.4,6.485),(82.2,6.485),(82.2,5.685),(81.4,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,5.685),(83.0,6.485),(83.8,6.485),(83.8,5.685),(83.0,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,5.685),(84.6,6.485),(85.4,6.485),(85.4,5.685),(84.6,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,5.685),(86.2,6.485),(87.0,6.485),(87.0,5.685),(86.2,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,5.685),(87.8,6.485),(88.6,6.485),(88.6,5.685),(87.8,5.685)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,7.285),(1.4,8.085),(2.2,8.085),(2.2,7.285),(1.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,7.285),(3.0,8.085),(3.8,8.085),(3.8,7.285),(3.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,7.285),(4.6,8.085),(5.4,8.085),(5.4,7.285),(4.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,7.285),(6.2,8.085),(7.0,8.085),(7.0,7.285),(6.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,7.285),(7.8,8.085),(8.6,8.085),(8.6,7.285),(7.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,7.285),(9.4,8.085),(10.2,8.085),(10.2,7.285),(9.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,7.285),(11.0,8.085),(11.8,8.085),(11.8,7.285),(11.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,7.285),(12.6,8.085),(13.4,8.085),(13.4,7.285),(12.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,7.285),(14.2,8.085),(15.0,8.085),(15.0,7.285),(14.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,7.285),(15.8,8.085),(16.6,8.085),(16.6,7.285),(15.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,7.285),(17.4,8.085),(18.2,8.085),(18.2,7.285),(17.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,7.285),(19.0,8.085),(19.8,8.085),(19.8,7.285),(19.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,7.285),(20.6,8.085),(21.4,8.085),(21.4,7.285),(20.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,7.285),(22.2,8.085),(23.0,8.085),(23.0,7.285),(22.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,7.285),(23.8,8.085),(24.6,8.085),(24.6,7.285),(23.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,7.285),(25.4,8.085),(26.2,8.085),(26.2,7.285),(25.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,7.285),(27.0,8.085),(27.8,8.085),(27.8,7.285),(27.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,7.285),(28.6,8.085),(29.4,8.085),(29.4,7.285),(28.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,7.285),(30.2,8.085),(31.0,8.085),(31.0,7.285),(30.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,7.285),(31.8,8.085),(32.6,8.085),(32.6,7.285),(31.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,7.285),(33.4,8.085),(34.2,8.085),(34.2,7.285),(33.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,7.285),(35.0,8.085),(35.8,8.085),(35.8,7.285),(35.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,7.285),(36.6,8.085),(37.4,8.085),(37.4,7.285),(36.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,7.285),(38.2,8.085),(39.0,8.085),(39.0,7.285),(38.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,7.285),(39.8,8.085),(40.6,8.085),(40.6,7.285),(39.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,7.285),(41.4,8.085),(42.2,8.085),(42.2,7.285),(41.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,7.285),(43.0,8.085),(43.8,8.085),(43.8,7.285),(43.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,7.285),(44.6,8.085),(45.4,8.085),(45.4,7.285),(44.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,7.285),(46.2,8.085),(47.0,8.085),(47.0,7.285),(46.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,7.285),(47.8,8.085),(48.6,8.085),(48.6,7.285),(47.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,7.285),(49.4,8.085),(50.2,8.085),(50.2,7.285),(49.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,7.285),(51.0,8.085),(51.8,8.085),(51.8,7.285),(51.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,7.285),(52.6,8.085),(53.4,8.085),(53.4,7.285),(52.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,7.285),(54.2,8.085),(55.0,8.085),(55.0,7.285),(54.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,7.285),(55.8,8.085),(56.6,8.085),(56.6,7.285),(55.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,7.285),(57.4,8.085),(58.2,8.085),(58.2,7.285),(57.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,7.285),(59.0,8.085),(59.8,8.085),(59.8,7.285),(59.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,7.285),(60.6,8.085),(61.4,8.085),(61.4,7.285),(60.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,7.285),(62.2,8.085),(63.0,8.085),(63.0,7.285),(62.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,7.285),(63.8,8.085),(64.6,8.085),(64.6,7.285),(63.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,7.285),(65.4,8.085),(66.2,8.085),(66.2,7.285),(65.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,7.285),(67.0,8.085),(67.8,8.085),(67.8,7.285),(67.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,7.285),(68.6,8.085),(69.4,8.085),(69.4,7.285),(68.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,7.285),(70.2,8.085),(71.0,8.085),(71.0,7.285),(70.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,7.285),(71.8,8.085),(72.6,8.085),(72.6,7.285),(71.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,7.285),(73.4,8.085),(74.2,8.085),(74.2,7.285),(73.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,7.285),(75.0,8.085),(75.8,8.085),(75.8,7.285),(75.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,7.285),(76.6,8.085),(77.4,8.085),(77.4,7.285),(76.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,7.285),(78.2,8.085),(79.0,8.085),(79.0,7.285),(78.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,7.285),(79.8,8.085),(80.6,8.085),(80.6,7.285),(79.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,7.285),(81.4,8.085),(82.2,8.085),(82.2,7.285),(81.4,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,7.285),(83.0,8.085),(83.8,8.085),(83.8,7.285),(83.0,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,7.285),(84.6,8.085),(85.4,8.085),(85.4,7.285),(84.6,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,7.285),(86.2,8.085),(87.0,8.085),(87.0,7.285),(86.2,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,7.285),(87.8,8.085),(88.6,8.085),(88.6,7.285),(87.8,7.285)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,145.0),(1.4,145.8),(2.2,145.8),(2.2,145.0),(1.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,145.0),(3.0,145.8),(3.8,145.8),(3.8,145.0),(3.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,145.0),(4.6,145.8),(5.4,145.8),(5.4,145.0),(4.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,145.0),(6.2,145.8),(7.0,145.8),(7.0,145.0),(6.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,145.0),(7.8,145.8),(8.6,145.8),(8.6,145.0),(7.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,145.0),(9.4,145.8),(10.2,145.8),(10.2,145.0),(9.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,145.0),(11.0,145.8),(11.8,145.8),(11.8,145.0),(11.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,145.0),(12.6,145.8),(13.4,145.8),(13.4,145.0),(12.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,145.0),(14.2,145.8),(15.0,145.8),(15.0,145.0),(14.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,145.0),(15.8,145.8),(16.6,145.8),(16.6,145.0),(15.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,145.0),(17.4,145.8),(18.2,145.8),(18.2,145.0),(17.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,145.0),(19.0,145.8),(19.8,145.8),(19.8,145.0),(19.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,145.0),(20.6,145.8),(21.4,145.8),(21.4,145.0),(20.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,145.0),(22.2,145.8),(23.0,145.8),(23.0,145.0),(22.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,145.0),(23.8,145.8),(24.6,145.8),(24.6,145.0),(23.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,145.0),(25.4,145.8),(26.2,145.8),(26.2,145.0),(25.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,145.0),(27.0,145.8),(27.8,145.8),(27.8,145.0),(27.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,145.0),(28.6,145.8),(29.4,145.8),(29.4,145.0),(28.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,145.0),(30.2,145.8),(31.0,145.8),(31.0,145.0),(30.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,145.0),(31.8,145.8),(32.6,145.8),(32.6,145.0),(31.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,145.0),(33.4,145.8),(34.2,145.8),(34.2,145.0),(33.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,145.0),(35.0,145.8),(35.8,145.8),(35.8,145.0),(35.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,145.0),(36.6,145.8),(37.4,145.8),(37.4,145.0),(36.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,145.0),(38.2,145.8),(39.0,145.8),(39.0,145.0),(38.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,145.0),(39.8,145.8),(40.6,145.8),(40.6,145.0),(39.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,145.0),(41.4,145.8),(42.2,145.8),(42.2,145.0),(41.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,145.0),(43.0,145.8),(43.8,145.8),(43.8,145.0),(43.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,145.0),(44.6,145.8),(45.4,145.8),(45.4,145.0),(44.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,145.0),(46.2,145.8),(47.0,145.8),(47.0,145.0),(46.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,145.0),(47.8,145.8),(48.6,145.8),(48.6,145.0),(47.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,145.0),(49.4,145.8),(50.2,145.8),(50.2,145.0),(49.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,145.0),(51.0,145.8),(51.8,145.8),(51.8,145.0),(51.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,145.0),(52.6,145.8),(53.4,145.8),(53.4,145.0),(52.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,145.0),(54.2,145.8),(55.0,145.8),(55.0,145.0),(54.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,145.0),(55.8,145.8),(56.6,145.8),(56.6,145.0),(55.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,145.0),(57.4,145.8),(58.2,145.8),(58.2,145.0),(57.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,145.0),(59.0,145.8),(59.8,145.8),(59.8,145.0),(59.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,145.0),(60.6,145.8),(61.4,145.8),(61.4,145.0),(60.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,145.0),(62.2,145.8),(63.0,145.8),(63.0,145.0),(62.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,145.0),(63.8,145.8),(64.6,145.8),(64.6,145.0),(63.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,145.0),(65.4,145.8),(66.2,145.8),(66.2,145.0),(65.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,145.0),(67.0,145.8),(67.8,145.8),(67.8,145.0),(67.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,145.0),(68.6,145.8),(69.4,145.8),(69.4,145.0),(68.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,145.0),(70.2,145.8),(71.0,145.8),(71.0,145.0),(70.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,145.0),(71.8,145.8),(72.6,145.8),(72.6,145.0),(71.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,145.0),(73.4,145.8),(74.2,145.8),(74.2,145.0),(73.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,145.0),(75.0,145.8),(75.8,145.8),(75.8,145.0),(75.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,145.0),(76.6,145.8),(77.4,145.8),(77.4,145.0),(76.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,145.0),(78.2,145.8),(79.0,145.8),(79.0,145.0),(78.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,145.0),(79.8,145.8),(80.6,145.8),(80.6,145.0),(79.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,145.0),(81.4,145.8),(82.2,145.8),(82.2,145.0),(81.4,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,145.0),(83.0,145.8),(83.8,145.8),(83.8,145.0),(83.0,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,145.0),(84.6,145.8),(85.4,145.8),(85.4,145.0),(84.6,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,145.0),(86.2,145.8),(87.0,145.8),(87.0,145.0),(86.2,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,145.0),(87.8,145.8),(88.6,145.8),(88.6,145.0),(87.8,145.0)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,146.6),(1.4,147.4),(2.2,147.4),(2.2,146.6),(1.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,146.6),(3.0,147.4),(3.8,147.4),(3.8,146.6),(3.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,146.6),(4.6,147.4),(5.4,147.4),(5.4,146.6),(4.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,146.6),(6.2,147.4),(7.0,147.4),(7.0,146.6),(6.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,146.6),(7.8,147.4),(8.6,147.4),(8.6,146.6),(7.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,146.6),(9.4,147.4),(10.2,147.4),(10.2,146.6),(9.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,146.6),(11.0,147.4),(11.8,147.4),(11.8,146.6),(11.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,146.6),(12.6,147.4),(13.4,147.4),(13.4,146.6),(12.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,146.6),(14.2,147.4),(15.0,147.4),(15.0,146.6),(14.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,146.6),(15.8,147.4),(16.6,147.4),(16.6,146.6),(15.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,146.6),(17.4,147.4),(18.2,147.4),(18.2,146.6),(17.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,146.6),(19.0,147.4),(19.8,147.4),(19.8,146.6),(19.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,146.6),(20.6,147.4),(21.4,147.4),(21.4,146.6),(20.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,146.6),(22.2,147.4),(23.0,147.4),(23.0,146.6),(22.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,146.6),(23.8,147.4),(24.6,147.4),(24.6,146.6),(23.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,146.6),(25.4,147.4),(26.2,147.4),(26.2,146.6),(25.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,146.6),(27.0,147.4),(27.8,147.4),(27.8,146.6),(27.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,146.6),(28.6,147.4),(29.4,147.4),(29.4,146.6),(28.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,146.6),(30.2,147.4),(31.0,147.4),(31.0,146.6),(30.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,146.6),(31.8,147.4),(32.6,147.4),(32.6,146.6),(31.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,146.6),(33.4,147.4),(34.2,147.4),(34.2,146.6),(33.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,146.6),(35.0,147.4),(35.8,147.4),(35.8,146.6),(35.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,146.6),(36.6,147.4),(37.4,147.4),(37.4,146.6),(36.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,146.6),(38.2,147.4),(39.0,147.4),(39.0,146.6),(38.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,146.6),(39.8,147.4),(40.6,147.4),(40.6,146.6),(39.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,146.6),(41.4,147.4),(42.2,147.4),(42.2,146.6),(41.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,146.6),(43.0,147.4),(43.8,147.4),(43.8,146.6),(43.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,146.6),(44.6,147.4),(45.4,147.4),(45.4,146.6),(44.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,146.6),(46.2,147.4),(47.0,147.4),(47.0,146.6),(46.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,146.6),(47.8,147.4),(48.6,147.4),(48.6,146.6),(47.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,146.6),(49.4,147.4),(50.2,147.4),(50.2,146.6),(49.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,146.6),(51.0,147.4),(51.8,147.4),(51.8,146.6),(51.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,146.6),(52.6,147.4),(53.4,147.4),(53.4,146.6),(52.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,146.6),(54.2,147.4),(55.0,147.4),(55.0,146.6),(54.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,146.6),(55.8,147.4),(56.6,147.4),(56.6,146.6),(55.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,146.6),(57.4,147.4),(58.2,147.4),(58.2,146.6),(57.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,146.6),(59.0,147.4),(59.8,147.4),(59.8,146.6),(59.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,146.6),(60.6,147.4),(61.4,147.4),(61.4,146.6),(60.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,146.6),(62.2,147.4),(63.0,147.4),(63.0,146.6),(62.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,146.6),(63.8,147.4),(64.6,147.4),(64.6,146.6),(63.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,146.6),(65.4,147.4),(66.2,147.4),(66.2,146.6),(65.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,146.6),(67.0,147.4),(67.8,147.4),(67.8,146.6),(67.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,146.6),(68.6,147.4),(69.4,147.4),(69.4,146.6),(68.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,146.6),(70.2,147.4),(71.0,147.4),(71.0,146.6),(70.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,146.6),(71.8,147.4),(72.6,147.4),(72.6,146.6),(71.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,146.6),(73.4,147.4),(74.2,147.4),(74.2,146.6),(73.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,146.6),(75.0,147.4),(75.8,147.4),(75.8,146.6),(75.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,146.6),(76.6,147.4),(77.4,147.4),(77.4,146.6),(76.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,146.6),(78.2,147.4),(79.0,147.4),(79.0,146.6),(78.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,146.6),(79.8,147.4),(80.6,147.4),(80.6,146.6),(79.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,146.6),(81.4,147.4),(82.2,147.4),(82.2,146.6),(81.4,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,146.6),(83.0,147.4),(83.8,147.4),(83.8,146.6),(83.0,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,146.6),(84.6,147.4),(85.4,147.4),(85.4,146.6),(84.6,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,146.6),(86.2,147.4),(87.0,147.4),(87.0,146.6),(86.2,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,146.6),(87.8,147.4),(88.6,147.4),(88.6,146.6),(87.8,146.6)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,148.2),(1.4,149.0),(2.2,149.0),(2.2,148.2),(1.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,148.2),(3.0,149.0),(3.8,149.0),(3.8,148.2),(3.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,148.2),(4.6,149.0),(5.4,149.0),(5.4,148.2),(4.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,148.2),(6.2,149.0),(7.0,149.0),(7.0,148.2),(6.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,148.2),(7.8,149.0),(8.6,149.0),(8.6,148.2),(7.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,148.2),(9.4,149.0),(10.2,149.0),(10.2,148.2),(9.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,148.2),(11.0,149.0),(11.8,149.0),(11.8,148.2),(11.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,148.2),(12.6,149.0),(13.4,149.0),(13.4,148.2),(12.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,148.2),(14.2,149.0),(15.0,149.0),(15.0,148.2),(14.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,148.2),(15.8,149.0),(16.6,149.0),(16.6,148.2),(15.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,148.2),(17.4,149.0),(18.2,149.0),(18.2,148.2),(17.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,148.2),(19.0,149.0),(19.8,149.0),(19.8,148.2),(19.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,148.2),(20.6,149.0),(21.4,149.0),(21.4,148.2),(20.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,148.2),(22.2,149.0),(23.0,149.0),(23.0,148.2),(22.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,148.2),(23.8,149.0),(24.6,149.0),(24.6,148.2),(23.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,148.2),(25.4,149.0),(26.2,149.0),(26.2,148.2),(25.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,148.2),(27.0,149.0),(27.8,149.0),(27.8,148.2),(27.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,148.2),(28.6,149.0),(29.4,149.0),(29.4,148.2),(28.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,148.2),(30.2,149.0),(31.0,149.0),(31.0,148.2),(30.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,148.2),(31.8,149.0),(32.6,149.0),(32.6,148.2),(31.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,148.2),(33.4,149.0),(34.2,149.0),(34.2,148.2),(33.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,148.2),(35.0,149.0),(35.8,149.0),(35.8,148.2),(35.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,148.2),(36.6,149.0),(37.4,149.0),(37.4,148.2),(36.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,148.2),(38.2,149.0),(39.0,149.0),(39.0,148.2),(38.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,148.2),(39.8,149.0),(40.6,149.0),(40.6,148.2),(39.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,148.2),(41.4,149.0),(42.2,149.0),(42.2,148.2),(41.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,148.2),(43.0,149.0),(43.8,149.0),(43.8,148.2),(43.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,148.2),(44.6,149.0),(45.4,149.0),(45.4,148.2),(44.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,148.2),(46.2,149.0),(47.0,149.0),(47.0,148.2),(46.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,148.2),(47.8,149.0),(48.6,149.0),(48.6,148.2),(47.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,148.2),(49.4,149.0),(50.2,149.0),(50.2,148.2),(49.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,148.2),(51.0,149.0),(51.8,149.0),(51.8,148.2),(51.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,148.2),(52.6,149.0),(53.4,149.0),(53.4,148.2),(52.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,148.2),(54.2,149.0),(55.0,149.0),(55.0,148.2),(54.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,148.2),(55.8,149.0),(56.6,149.0),(56.6,148.2),(55.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,148.2),(57.4,149.0),(58.2,149.0),(58.2,148.2),(57.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,148.2),(59.0,149.0),(59.8,149.0),(59.8,148.2),(59.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,148.2),(60.6,149.0),(61.4,149.0),(61.4,148.2),(60.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,148.2),(62.2,149.0),(63.0,149.0),(63.0,148.2),(62.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,148.2),(63.8,149.0),(64.6,149.0),(64.6,148.2),(63.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,148.2),(65.4,149.0),(66.2,149.0),(66.2,148.2),(65.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,148.2),(67.0,149.0),(67.8,149.0),(67.8,148.2),(67.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,148.2),(68.6,149.0),(69.4,149.0),(69.4,148.2),(68.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,148.2),(70.2,149.0),(71.0,149.0),(71.0,148.2),(70.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,148.2),(71.8,149.0),(72.6,149.0),(72.6,148.2),(71.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,148.2),(73.4,149.0),(74.2,149.0),(74.2,148.2),(73.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,148.2),(75.0,149.0),(75.8,149.0),(75.8,148.2),(75.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,148.2),(76.6,149.0),(77.4,149.0),(77.4,148.2),(76.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,148.2),(78.2,149.0),(79.0,149.0),(79.0,148.2),(78.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,148.2),(79.8,149.0),(80.6,149.0),(80.6,148.2),(79.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,148.2),(81.4,149.0),(82.2,149.0),(82.2,148.2),(81.4,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,148.2),(83.0,149.0),(83.8,149.0),(83.8,148.2),(83.0,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,148.2),(84.6,149.0),(85.4,149.0),(85.4,148.2),(84.6,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,148.2),(86.2,149.0),(87.0,149.0),(87.0,148.2),(86.2,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,148.2),(87.8,149.0),(88.6,149.0),(88.6,148.2),(87.8,148.2)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,14.255),(1.4,15.055),(2.2,15.055),(2.2,14.255),(1.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,14.255),(3.0,15.055),(3.8,15.055),(3.8,14.255),(3.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,14.255),(4.6,15.055),(5.4,15.055),(5.4,14.255),(4.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,14.255),(6.2,15.055),(7.0,15.055),(7.0,14.255),(6.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,14.255),(7.8,15.055),(8.6,15.055),(8.6,14.255),(7.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,14.255),(9.4,15.055),(10.2,15.055),(10.2,14.255),(9.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,14.255),(11.0,15.055),(11.8,15.055),(11.8,14.255),(11.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,14.255),(12.6,15.055),(13.4,15.055),(13.4,14.255),(12.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,14.255),(14.2,15.055),(15.0,15.055),(15.0,14.255),(14.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,14.255),(15.8,15.055),(16.6,15.055),(16.6,14.255),(15.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,14.255),(17.4,15.055),(18.2,15.055),(18.2,14.255),(17.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,14.255),(19.0,15.055),(19.8,15.055),(19.8,14.255),(19.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,14.255),(20.6,15.055),(21.4,15.055),(21.4,14.255),(20.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,14.255),(22.2,15.055),(23.0,15.055),(23.0,14.255),(22.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,14.255),(23.8,15.055),(24.6,15.055),(24.6,14.255),(23.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,14.255),(25.4,15.055),(26.2,15.055),(26.2,14.255),(25.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,14.255),(27.0,15.055),(27.8,15.055),(27.8,14.255),(27.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,14.255),(28.6,15.055),(29.4,15.055),(29.4,14.255),(28.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,14.255),(30.2,15.055),(31.0,15.055),(31.0,14.255),(30.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,14.255),(31.8,15.055),(32.6,15.055),(32.6,14.255),(31.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,14.255),(33.4,15.055),(34.2,15.055),(34.2,14.255),(33.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,14.255),(35.0,15.055),(35.8,15.055),(35.8,14.255),(35.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,14.255),(36.6,15.055),(37.4,15.055),(37.4,14.255),(36.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,14.255),(38.2,15.055),(39.0,15.055),(39.0,14.255),(38.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,14.255),(39.8,15.055),(40.6,15.055),(40.6,14.255),(39.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,14.255),(41.4,15.055),(42.2,15.055),(42.2,14.255),(41.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,14.255),(43.0,15.055),(43.8,15.055),(43.8,14.255),(43.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,14.255),(44.6,15.055),(45.4,15.055),(45.4,14.255),(44.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,14.255),(46.2,15.055),(47.0,15.055),(47.0,14.255),(46.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,14.255),(47.8,15.055),(48.6,15.055),(48.6,14.255),(47.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,14.255),(49.4,15.055),(50.2,15.055),(50.2,14.255),(49.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,14.255),(51.0,15.055),(51.8,15.055),(51.8,14.255),(51.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,14.255),(52.6,15.055),(53.4,15.055),(53.4,14.255),(52.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,14.255),(54.2,15.055),(55.0,15.055),(55.0,14.255),(54.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,14.255),(55.8,15.055),(56.6,15.055),(56.6,14.255),(55.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,14.255),(57.4,15.055),(58.2,15.055),(58.2,14.255),(57.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,14.255),(59.0,15.055),(59.8,15.055),(59.8,14.255),(59.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,14.255),(60.6,15.055),(61.4,15.055),(61.4,14.255),(60.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,14.255),(62.2,15.055),(63.0,15.055),(63.0,14.255),(62.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,14.255),(63.8,15.055),(64.6,15.055),(64.6,14.255),(63.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,14.255),(65.4,15.055),(66.2,15.055),(66.2,14.255),(65.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,14.255),(67.0,15.055),(67.8,15.055),(67.8,14.255),(67.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,14.255),(68.6,15.055),(69.4,15.055),(69.4,14.255),(68.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,14.255),(70.2,15.055),(71.0,15.055),(71.0,14.255),(70.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,14.255),(71.8,15.055),(72.6,15.055),(72.6,14.255),(71.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,14.255),(73.4,15.055),(74.2,15.055),(74.2,14.255),(73.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,14.255),(75.0,15.055),(75.8,15.055),(75.8,14.255),(75.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,14.255),(76.6,15.055),(77.4,15.055),(77.4,14.255),(76.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,14.255),(78.2,15.055),(79.0,15.055),(79.0,14.255),(78.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,14.255),(79.8,15.055),(80.6,15.055),(80.6,14.255),(79.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,14.255),(81.4,15.055),(82.2,15.055),(82.2,14.255),(81.4,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,14.255),(83.0,15.055),(83.8,15.055),(83.8,14.255),(83.0,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,14.255),(84.6,15.055),(85.4,15.055),(85.4,14.255),(84.6,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,14.255),(86.2,15.055),(87.0,15.055),(87.0,14.255),(86.2,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,14.255),(87.8,15.055),(88.6,15.055),(88.6,14.255),(87.8,14.255)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,15.855),(1.4,16.655),(2.2,16.655),(2.2,15.855),(1.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,15.855),(3.0,16.655),(3.8,16.655),(3.8,15.855),(3.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,15.855),(4.6,16.655),(5.4,16.655),(5.4,15.855),(4.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,15.855),(6.2,16.655),(7.0,16.655),(7.0,15.855),(6.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,15.855),(7.8,16.655),(8.6,16.655),(8.6,15.855),(7.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,15.855),(9.4,16.655),(10.2,16.655),(10.2,15.855),(9.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,15.855),(11.0,16.655),(11.8,16.655),(11.8,15.855),(11.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,15.855),(12.6,16.655),(13.4,16.655),(13.4,15.855),(12.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,15.855),(14.2,16.655),(15.0,16.655),(15.0,15.855),(14.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,15.855),(15.8,16.655),(16.6,16.655),(16.6,15.855),(15.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,15.855),(17.4,16.655),(18.2,16.655),(18.2,15.855),(17.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,15.855),(19.0,16.655),(19.8,16.655),(19.8,15.855),(19.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,15.855),(20.6,16.655),(21.4,16.655),(21.4,15.855),(20.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,15.855),(22.2,16.655),(23.0,16.655),(23.0,15.855),(22.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,15.855),(23.8,16.655),(24.6,16.655),(24.6,15.855),(23.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,15.855),(25.4,16.655),(26.2,16.655),(26.2,15.855),(25.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,15.855),(27.0,16.655),(27.8,16.655),(27.8,15.855),(27.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,15.855),(28.6,16.655),(29.4,16.655),(29.4,15.855),(28.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,15.855),(30.2,16.655),(31.0,16.655),(31.0,15.855),(30.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,15.855),(31.8,16.655),(32.6,16.655),(32.6,15.855),(31.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,15.855),(33.4,16.655),(34.2,16.655),(34.2,15.855),(33.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,15.855),(35.0,16.655),(35.8,16.655),(35.8,15.855),(35.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,15.855),(36.6,16.655),(37.4,16.655),(37.4,15.855),(36.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,15.855),(38.2,16.655),(39.0,16.655),(39.0,15.855),(38.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,15.855),(39.8,16.655),(40.6,16.655),(40.6,15.855),(39.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,15.855),(41.4,16.655),(42.2,16.655),(42.2,15.855),(41.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,15.855),(43.0,16.655),(43.8,16.655),(43.8,15.855),(43.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,15.855),(44.6,16.655),(45.4,16.655),(45.4,15.855),(44.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,15.855),(46.2,16.655),(47.0,16.655),(47.0,15.855),(46.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,15.855),(47.8,16.655),(48.6,16.655),(48.6,15.855),(47.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,15.855),(49.4,16.655),(50.2,16.655),(50.2,15.855),(49.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,15.855),(51.0,16.655),(51.8,16.655),(51.8,15.855),(51.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,15.855),(52.6,16.655),(53.4,16.655),(53.4,15.855),(52.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,15.855),(54.2,16.655),(55.0,16.655),(55.0,15.855),(54.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,15.855),(55.8,16.655),(56.6,16.655),(56.6,15.855),(55.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,15.855),(57.4,16.655),(58.2,16.655),(58.2,15.855),(57.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,15.855),(59.0,16.655),(59.8,16.655),(59.8,15.855),(59.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,15.855),(60.6,16.655),(61.4,16.655),(61.4,15.855),(60.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,15.855),(62.2,16.655),(63.0,16.655),(63.0,15.855),(62.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,15.855),(63.8,16.655),(64.6,16.655),(64.6,15.855),(63.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,15.855),(65.4,16.655),(66.2,16.655),(66.2,15.855),(65.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,15.855),(67.0,16.655),(67.8,16.655),(67.8,15.855),(67.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,15.855),(68.6,16.655),(69.4,16.655),(69.4,15.855),(68.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,15.855),(70.2,16.655),(71.0,16.655),(71.0,15.855),(70.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,15.855),(71.8,16.655),(72.6,16.655),(72.6,15.855),(71.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,15.855),(73.4,16.655),(74.2,16.655),(74.2,15.855),(73.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,15.855),(75.0,16.655),(75.8,16.655),(75.8,15.855),(75.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,15.855),(76.6,16.655),(77.4,16.655),(77.4,15.855),(76.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,15.855),(78.2,16.655),(79.0,16.655),(79.0,15.855),(78.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,15.855),(79.8,16.655),(80.6,16.655),(80.6,15.855),(79.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,15.855),(81.4,16.655),(82.2,16.655),(82.2,15.855),(81.4,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,15.855),(83.0,16.655),(83.8,16.655),(83.8,15.855),(83.0,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,15.855),(84.6,16.655),(85.4,16.655),(85.4,15.855),(84.6,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,15.855),(86.2,16.655),(87.0,16.655),(87.0,15.855),(86.2,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,15.855),(87.8,16.655),(88.6,16.655),(88.6,15.855),(87.8,15.855)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,17.455),(1.4,18.255),(2.2,18.255),(2.2,17.455),(1.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,17.455),(3.0,18.255),(3.8,18.255),(3.8,17.455),(3.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,17.455),(4.6,18.255),(5.4,18.255),(5.4,17.455),(4.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,17.455),(6.2,18.255),(7.0,18.255),(7.0,17.455),(6.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,17.455),(7.8,18.255),(8.6,18.255),(8.6,17.455),(7.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,17.455),(9.4,18.255),(10.2,18.255),(10.2,17.455),(9.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,17.455),(11.0,18.255),(11.8,18.255),(11.8,17.455),(11.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,17.455),(12.6,18.255),(13.4,18.255),(13.4,17.455),(12.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,17.455),(14.2,18.255),(15.0,18.255),(15.0,17.455),(14.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,17.455),(15.8,18.255),(16.6,18.255),(16.6,17.455),(15.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,17.455),(17.4,18.255),(18.2,18.255),(18.2,17.455),(17.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,17.455),(19.0,18.255),(19.8,18.255),(19.8,17.455),(19.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,17.455),(20.6,18.255),(21.4,18.255),(21.4,17.455),(20.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,17.455),(22.2,18.255),(23.0,18.255),(23.0,17.455),(22.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,17.455),(23.8,18.255),(24.6,18.255),(24.6,17.455),(23.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,17.455),(25.4,18.255),(26.2,18.255),(26.2,17.455),(25.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,17.455),(27.0,18.255),(27.8,18.255),(27.8,17.455),(27.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,17.455),(28.6,18.255),(29.4,18.255),(29.4,17.455),(28.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,17.455),(30.2,18.255),(31.0,18.255),(31.0,17.455),(30.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,17.455),(31.8,18.255),(32.6,18.255),(32.6,17.455),(31.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,17.455),(33.4,18.255),(34.2,18.255),(34.2,17.455),(33.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,17.455),(35.0,18.255),(35.8,18.255),(35.8,17.455),(35.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,17.455),(36.6,18.255),(37.4,18.255),(37.4,17.455),(36.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,17.455),(38.2,18.255),(39.0,18.255),(39.0,17.455),(38.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,17.455),(39.8,18.255),(40.6,18.255),(40.6,17.455),(39.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,17.455),(41.4,18.255),(42.2,18.255),(42.2,17.455),(41.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,17.455),(43.0,18.255),(43.8,18.255),(43.8,17.455),(43.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,17.455),(44.6,18.255),(45.4,18.255),(45.4,17.455),(44.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,17.455),(46.2,18.255),(47.0,18.255),(47.0,17.455),(46.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,17.455),(47.8,18.255),(48.6,18.255),(48.6,17.455),(47.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,17.455),(49.4,18.255),(50.2,18.255),(50.2,17.455),(49.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,17.455),(51.0,18.255),(51.8,18.255),(51.8,17.455),(51.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,17.455),(52.6,18.255),(53.4,18.255),(53.4,17.455),(52.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,17.455),(54.2,18.255),(55.0,18.255),(55.0,17.455),(54.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,17.455),(55.8,18.255),(56.6,18.255),(56.6,17.455),(55.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,17.455),(57.4,18.255),(58.2,18.255),(58.2,17.455),(57.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,17.455),(59.0,18.255),(59.8,18.255),(59.8,17.455),(59.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,17.455),(60.6,18.255),(61.4,18.255),(61.4,17.455),(60.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,17.455),(62.2,18.255),(63.0,18.255),(63.0,17.455),(62.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,17.455),(63.8,18.255),(64.6,18.255),(64.6,17.455),(63.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,17.455),(65.4,18.255),(66.2,18.255),(66.2,17.455),(65.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,17.455),(67.0,18.255),(67.8,18.255),(67.8,17.455),(67.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,17.455),(68.6,18.255),(69.4,18.255),(69.4,17.455),(68.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,17.455),(70.2,18.255),(71.0,18.255),(71.0,17.455),(70.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,17.455),(71.8,18.255),(72.6,18.255),(72.6,17.455),(71.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,17.455),(73.4,18.255),(74.2,18.255),(74.2,17.455),(73.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,17.455),(75.0,18.255),(75.8,18.255),(75.8,17.455),(75.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,17.455),(76.6,18.255),(77.4,18.255),(77.4,17.455),(76.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,17.455),(78.2,18.255),(79.0,18.255),(79.0,17.455),(78.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,17.455),(79.8,18.255),(80.6,18.255),(80.6,17.455),(79.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,17.455),(81.4,18.255),(82.2,18.255),(82.2,17.455),(81.4,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,17.455),(83.0,18.255),(83.8,18.255),(83.8,17.455),(83.0,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,17.455),(84.6,18.255),(85.4,18.255),(85.4,17.455),(84.6,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,17.455),(86.2,18.255),(87.0,18.255),(87.0,17.455),(86.2,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,17.455),(87.8,18.255),(88.6,18.255),(88.6,17.455),(87.8,17.455)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,19.055),(1.4,19.855),(2.2,19.855),(2.2,19.055),(1.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,19.055),(3.0,19.855),(3.8,19.855),(3.8,19.055),(3.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,19.055),(4.6,19.855),(5.4,19.855),(5.4,19.055),(4.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,19.055),(6.2,19.855),(7.0,19.855),(7.0,19.055),(6.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,19.055),(7.8,19.855),(8.6,19.855),(8.6,19.055),(7.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,19.055),(9.4,19.855),(10.2,19.855),(10.2,19.055),(9.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,19.055),(11.0,19.855),(11.8,19.855),(11.8,19.055),(11.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,19.055),(12.6,19.855),(13.4,19.855),(13.4,19.055),(12.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,19.055),(14.2,19.855),(15.0,19.855),(15.0,19.055),(14.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,19.055),(15.8,19.855),(16.6,19.855),(16.6,19.055),(15.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,19.055),(17.4,19.855),(18.2,19.855),(18.2,19.055),(17.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,19.055),(19.0,19.855),(19.8,19.855),(19.8,19.055),(19.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,19.055),(20.6,19.855),(21.4,19.855),(21.4,19.055),(20.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,19.055),(22.2,19.855),(23.0,19.855),(23.0,19.055),(22.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,19.055),(23.8,19.855),(24.6,19.855),(24.6,19.055),(23.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,19.055),(25.4,19.855),(26.2,19.855),(26.2,19.055),(25.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,19.055),(27.0,19.855),(27.8,19.855),(27.8,19.055),(27.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,19.055),(28.6,19.855),(29.4,19.855),(29.4,19.055),(28.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,19.055),(30.2,19.855),(31.0,19.855),(31.0,19.055),(30.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,19.055),(31.8,19.855),(32.6,19.855),(32.6,19.055),(31.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,19.055),(33.4,19.855),(34.2,19.855),(34.2,19.055),(33.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,19.055),(35.0,19.855),(35.8,19.855),(35.8,19.055),(35.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,19.055),(36.6,19.855),(37.4,19.855),(37.4,19.055),(36.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,19.055),(38.2,19.855),(39.0,19.855),(39.0,19.055),(38.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,19.055),(39.8,19.855),(40.6,19.855),(40.6,19.055),(39.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,19.055),(41.4,19.855),(42.2,19.855),(42.2,19.055),(41.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,19.055),(43.0,19.855),(43.8,19.855),(43.8,19.055),(43.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,19.055),(44.6,19.855),(45.4,19.855),(45.4,19.055),(44.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,19.055),(46.2,19.855),(47.0,19.855),(47.0,19.055),(46.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,19.055),(47.8,19.855),(48.6,19.855),(48.6,19.055),(47.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,19.055),(49.4,19.855),(50.2,19.855),(50.2,19.055),(49.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,19.055),(51.0,19.855),(51.8,19.855),(51.8,19.055),(51.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,19.055),(52.6,19.855),(53.4,19.855),(53.4,19.055),(52.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,19.055),(54.2,19.855),(55.0,19.855),(55.0,19.055),(54.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,19.055),(55.8,19.855),(56.6,19.855),(56.6,19.055),(55.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,19.055),(57.4,19.855),(58.2,19.855),(58.2,19.055),(57.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,19.055),(59.0,19.855),(59.8,19.855),(59.8,19.055),(59.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,19.055),(60.6,19.855),(61.4,19.855),(61.4,19.055),(60.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,19.055),(62.2,19.855),(63.0,19.855),(63.0,19.055),(62.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,19.055),(63.8,19.855),(64.6,19.855),(64.6,19.055),(63.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,19.055),(65.4,19.855),(66.2,19.855),(66.2,19.055),(65.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,19.055),(67.0,19.855),(67.8,19.855),(67.8,19.055),(67.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,19.055),(68.6,19.855),(69.4,19.855),(69.4,19.055),(68.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,19.055),(70.2,19.855),(71.0,19.855),(71.0,19.055),(70.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,19.055),(71.8,19.855),(72.6,19.855),(72.6,19.055),(71.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,19.055),(73.4,19.855),(74.2,19.855),(74.2,19.055),(73.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,19.055),(75.0,19.855),(75.8,19.855),(75.8,19.055),(75.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,19.055),(76.6,19.855),(77.4,19.855),(77.4,19.055),(76.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,19.055),(78.2,19.855),(79.0,19.855),(79.0,19.055),(78.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,19.055),(79.8,19.855),(80.6,19.855),(80.6,19.055),(79.8,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,19.055),(81.4,19.855),(82.2,19.855),(82.2,19.055),(81.4,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,19.055),(83.0,19.855),(83.8,19.855),(83.8,19.055),(83.0,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,19.055),(84.6,19.855),(85.4,19.855),(85.4,19.055),(84.6,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,19.055),(86.2,19.855),(87.0,19.855),(87.0,19.055),(86.2,19.055)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,19.055),(87.8,19.855),(88.6,19.855),(88.6,19.055),(87.8,19.055)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,13.17),(0.0,20.94),(90.0,20.94),(90.0,13.17),(0.0,13.17)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,1.4),(0.0,9.17),(90.0,9.17),(90.0,1.4),(0.0,1.4)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,143.4),(0.0,150.6),(90.0,150.6),(90.0,143.4),(0.0,143.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(17.055), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(5.285), u(10.57), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(147.0), u(10.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(147.0), u(7.2), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(17.055), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(5.285), u(7.77), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'difftap',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,22.82),(0.0,87.82),(0.48,87.82),(0.48,22.82),(0.0,22.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'difftap',
            ((89.52,22.82),(89.52,87.82),(90.0,87.82),(90.0,22.82),(89.52,22.82)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.545),(89.675,62.715),(89.845,62.715),(89.845,62.545),(89.675,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.205),(89.675,62.375),(89.845,62.375),(89.845,62.205),(89.675,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,22.495),(63.785,22.665),(63.955,22.665),(63.955,22.495),(63.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,22.495),(58.005,22.665),(58.175,22.665),(58.175,22.495),(58.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,87.975),(16.185,88.145),(16.355,88.145),(16.355,87.975),(16.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,87.975),(16.525,88.145),(16.695,88.145),(16.695,87.975),(16.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.925),(0.155,48.095),(0.325,48.095),(0.325,47.925),(0.155,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,22.495),(58.345,22.665),(58.515,22.665),(58.515,22.495),(58.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,22.495),(58.685,22.665),(58.855,22.665),(58.855,22.495),(58.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.965),(89.675,33.135),(89.845,33.135),(89.845,32.965),(89.675,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,22.495),(30.125,22.665),(30.295,22.665),(30.295,22.495),(30.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,22.495),(30.465,22.665),(30.635,22.665),(30.635,22.495),(30.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,22.495),(30.805,22.665),(30.975,22.665),(30.975,22.495),(30.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,22.495),(54.265,22.665),(54.435,22.665),(54.435,22.495),(54.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,22.495),(54.605,22.665),(54.775,22.665),(54.775,22.495),(54.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,87.975),(35.905,88.145),(36.075,88.145),(36.075,87.975),(35.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,87.975),(85.205,88.145),(85.375,88.145),(85.375,87.975),(85.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,87.975),(85.545,88.145),(85.715,88.145),(85.715,87.975),(85.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,87.975),(52.225,88.145),(52.395,88.145),(52.395,87.975),(52.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,87.975),(52.565,88.145),(52.735,88.145),(52.735,87.975),(52.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.005),(89.675,35.175),(89.845,35.175),(89.845,35.005),(89.675,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.345),(89.675,35.515),(89.845,35.515),(89.845,35.345),(89.675,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,35.685),(89.675,35.855),(89.845,35.855),(89.845,35.685),(89.675,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,22.495),(69.905,22.665),(70.075,22.665),(70.075,22.495),(69.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.005),(0.155,35.175),(0.325,35.175),(0.325,35.005),(0.155,35.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.345),(0.155,35.515),(0.325,35.515),(0.325,35.345),(0.155,35.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,35.685),(0.155,35.855),(0.325,35.855),(0.325,35.685),(0.155,35.685)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,22.495),(38.285,22.665),(38.455,22.665),(38.455,22.495),(38.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.985),(89.675,51.155),(89.845,51.155),(89.845,50.985),(89.675,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,22.495),(38.625,22.665),(38.795,22.665),(38.795,22.495),(38.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,87.975),(3.265,88.145),(3.435,88.145),(3.435,87.975),(3.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,87.975),(3.605,88.145),(3.775,88.145),(3.775,87.975),(3.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.885),(89.675,29.055),(89.845,29.055),(89.845,28.885),(89.675,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.385),(89.675,54.555),(89.845,54.555),(89.845,54.385),(89.675,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.725),(89.675,54.895),(89.845,54.895),(89.845,54.725),(89.675,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,54.045),(89.675,54.215),(89.845,54.215),(89.845,54.045),(89.675,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((69.905,87.975),(69.905,88.145),(70.075,88.145),(70.075,87.975),(69.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,22.495),(20.945,22.665),(21.115,22.665),(21.115,22.495),(20.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.945),(0.155,66.115),(0.325,66.115),(0.325,65.945),(0.155,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,22.495),(49.845,22.665),(50.015,22.665),(50.015,22.495),(49.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.045),(89.675,37.215),(89.845,37.215),(89.845,37.045),(89.675,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.385),(89.675,37.555),(89.845,37.555),(89.845,37.385),(89.675,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,37.725),(89.675,37.895),(89.845,37.895),(89.845,37.725),(89.675,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.845),(0.155,44.015),(0.325,44.015),(0.325,43.845),(0.155,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.205),(89.675,79.375),(89.845,79.375),(89.845,79.205),(89.675,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.545),(89.675,79.715),(89.845,79.715),(89.845,79.545),(89.675,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.285),(0.155,83.455),(0.325,83.455),(0.325,83.285),(0.155,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.625),(0.155,83.795),(0.325,83.795),(0.325,83.625),(0.155,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,22.495),(7.005,22.665),(7.175,22.665),(7.175,22.495),(7.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.925),(89.675,48.095),(89.845,48.095),(89.845,47.925),(89.675,47.925)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.525),(0.155,44.695),(0.325,44.695),(0.325,44.525),(0.155,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.185),(0.155,44.355),(0.325,44.355),(0.325,44.185),(0.155,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,22.495),(7.345,22.665),(7.515,22.665),(7.515,22.495),(7.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,22.495),(7.685,22.665),(7.855,22.665),(7.855,22.495),(7.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.985),(0.155,68.155),(0.325,68.155),(0.325,67.985),(0.155,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,87.975),(45.085,88.145),(45.255,88.145),(45.255,87.975),(45.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,87.975),(45.765,88.145),(45.935,88.145),(45.935,87.975),(45.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,87.975),(45.425,88.145),(45.595,88.145),(45.595,87.975),(45.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.525),(89.675,61.695),(89.845,61.695),(89.845,61.525),(89.675,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.185),(89.675,61.355),(89.845,61.355),(89.845,61.185),(89.675,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,87.975),(79.085,88.145),(79.255,88.145),(79.255,87.975),(79.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,87.975),(79.425,88.145),(79.595,88.145),(79.595,87.975),(79.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,87.975),(79.765,88.145),(79.935,88.145),(79.935,87.975),(79.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.005),(89.675,69.175),(89.845,69.175),(89.845,69.005),(89.675,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.345),(89.675,69.515),(89.845,69.515),(89.845,69.345),(89.675,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,69.685),(89.675,69.855),(89.845,69.855),(89.845,69.685),(89.675,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.105),(0.155,57.275),(0.325,57.275),(0.325,57.105),(0.155,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.365),(89.675,36.535),(89.845,36.535),(89.845,36.365),(89.675,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.705),(89.675,36.875),(89.845,36.875),(89.845,36.705),(89.675,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,36.025),(89.675,36.195),(89.845,36.195),(89.845,36.025),(89.675,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,22.495),(20.265,22.665),(20.435,22.665),(20.435,22.495),(20.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,22.495),(35.225,22.665),(35.395,22.665),(35.395,22.495),(35.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,22.495),(35.565,22.665),(35.735,22.665),(35.735,22.495),(35.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.445),(0.155,57.615),(0.325,57.615),(0.325,57.445),(0.155,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,87.975),(4.285,88.145),(4.455,88.145),(4.455,87.975),(4.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,87.975),(4.625,88.145),(4.795,88.145),(4.795,87.975),(4.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,22.495),(14.145,22.665),(14.315,22.665),(14.315,22.495),(14.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,22.495),(14.485,22.665),(14.655,22.665),(14.655,22.495),(14.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,22.495),(14.825,22.665),(14.995,22.665),(14.995,22.495),(14.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,87.975),(72.965,88.145),(73.135,88.145),(73.135,87.975),(72.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.325),(0.155,85.495),(0.325,85.495),(0.325,85.325),(0.155,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,85.665),(0.155,85.835),(0.325,85.835),(0.325,85.665),(0.155,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,22.495),(19.585,22.665),(19.755,22.665),(19.755,22.495),(19.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,22.495),(19.245,22.665),(19.415,22.665),(19.415,22.495),(19.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,87.975),(43.045,88.145),(43.215,88.145),(43.215,87.975),(43.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,22.495),(80.105,22.665),(80.275,22.665),(80.275,22.495),(80.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,22.495),(80.445,22.665),(80.615,22.665),(80.615,22.495),(80.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,22.495),(80.785,22.665),(80.955,22.665),(80.955,22.495),(80.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,87.975),(43.385,88.145),(43.555,88.145),(43.555,87.975),(43.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,87.975),(43.725,88.145),(43.895,88.145),(43.895,87.975),(43.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.385),(0.155,54.555),(0.325,54.555),(0.325,54.385),(0.155,54.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,87.975),(39.305,88.145),(39.475,88.145),(39.475,87.975),(39.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,87.975),(39.645,88.145),(39.815,88.145),(39.815,87.975),(39.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.725),(0.155,54.895),(0.325,54.895),(0.325,54.725),(0.155,54.725)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,87.975),(62.765,88.145),(62.935,88.145),(62.935,87.975),(62.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,22.495),(65.145,22.665),(65.315,22.665),(65.315,22.495),(65.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,22.495),(65.485,22.665),(65.655,22.665),(65.655,22.495),(65.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,22.495),(65.825,22.665),(65.995,22.665),(65.995,22.495),(65.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.505),(89.675,60.675),(89.845,60.675),(89.845,60.505),(89.675,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,22.495),(50.865,22.665),(51.035,22.665),(51.035,22.495),(50.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.165),(89.675,60.335),(89.845,60.335),(89.845,60.165),(89.675,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.985),(0.155,34.155),(0.325,34.155),(0.325,33.985),(0.155,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.965),(89.675,50.135),(89.845,50.135),(89.845,49.965),(89.675,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,87.975),(48.145,88.145),(48.315,88.145),(48.315,87.975),(48.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,22.495),(69.225,22.665),(69.395,22.665),(69.395,22.495),(69.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,22.495),(69.565,22.665),(69.735,22.665),(69.735,22.495),(69.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,87.975),(5.305,88.145),(5.475,88.145),(5.475,87.975),(5.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,87.975),(5.645,88.145),(5.815,88.145),(5.815,87.975),(5.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,87.975),(48.825,88.145),(48.995,88.145),(48.995,87.975),(48.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,87.975),(48.485,88.145),(48.655,88.145),(48.655,87.975),(48.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,22.495),(22.985,22.665),(23.155,22.665),(23.155,22.495),(22.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,22.495),(83.845,22.665),(84.015,22.665),(84.015,22.495),(83.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.325),(0.155,51.495),(0.325,51.495),(0.325,51.325),(0.155,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,51.665),(0.155,51.835),(0.325,51.835),(0.325,51.665),(0.155,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,22.495),(89.285,22.665),(89.455,22.665),(89.455,22.495),(89.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,22.495),(89.625,22.665),(89.795,22.665),(89.795,22.495),(89.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.845),(0.155,78.015),(0.325,78.015),(0.325,77.845),(0.155,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,22.495),(77.045,22.665),(77.215,22.665),(77.215,22.495),(77.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,22.495),(77.385,22.665),(77.555,22.665),(77.555,22.495),(77.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,22.495),(77.725,22.665),(77.895,22.665),(77.895,22.495),(77.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.085,22.495),(79.085,22.665),(79.255,22.665),(79.255,22.495),(79.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.425,22.495),(79.425,22.665),(79.595,22.665),(79.595,22.495),(79.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((79.765,22.495),(79.765,22.665),(79.935,22.665),(79.935,22.495),(79.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.285),(89.675,83.455),(89.845,83.455),(89.845,83.285),(89.675,83.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.625),(89.675,83.795),(89.845,83.795),(89.845,83.625),(89.675,83.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.245),(0.155,47.415),(0.325,47.415),(0.325,47.245),(0.155,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.245),(0.155,81.415),(0.325,81.415),(0.325,81.245),(0.155,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.585),(0.155,81.755),(0.325,81.755),(0.325,81.585),(0.155,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,47.585),(0.155,47.755),(0.325,47.755),(0.325,47.585),(0.155,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.605),(0.155,82.775),(0.325,82.775),(0.325,82.605),(0.155,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.965),(0.155,50.135),(0.325,50.135),(0.325,49.965),(0.155,49.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.265),(0.155,82.435),(0.325,82.435),(0.325,82.265),(0.155,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,22.495),(33.865,22.665),(34.035,22.665),(34.035,22.495),(33.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.225),(0.155,29.395),(0.325,29.395),(0.325,29.225),(0.155,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.345),(0.155,69.515),(0.325,69.515),(0.325,69.345),(0.155,69.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.685),(0.155,69.855),(0.325,69.855),(0.325,69.685),(0.155,69.685)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,87.975),(15.165,88.145),(15.335,88.145),(15.335,87.975),(15.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,87.975),(15.505,88.145),(15.675,88.145),(15.675,87.975),(15.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,69.005),(0.155,69.175),(0.325,69.175),(0.325,69.005),(0.155,69.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.565),(0.155,29.735),(0.325,29.735),(0.325,29.565),(0.155,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,87.975),(64.125,88.145),(64.295,88.145),(64.295,87.975),(64.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,22.495),(61.065,22.665),(61.235,22.665),(61.235,22.495),(61.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,22.495),(61.405,22.665),(61.575,22.665),(61.575,22.495),(61.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,22.495),(61.745,22.665),(61.915,22.665),(61.915,22.495),(61.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,87.975),(64.465,88.145),(64.635,88.145),(64.635,87.975),(64.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,87.975),(64.805,88.145),(64.975,88.145),(64.975,87.975),(64.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.925),(0.155,65.095),(0.325,65.095),(0.325,64.925),(0.155,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,22.495),(85.885,22.665),(86.055,22.665),(86.055,22.495),(85.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,62.885),(89.675,63.055),(89.845,63.055),(89.845,62.885),(89.675,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,87.975),(26.045,88.145),(26.215,88.145),(26.215,87.975),(26.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,87.975),(26.385,88.145),(26.555,88.145),(26.555,87.975),(26.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,87.975),(26.725,88.145),(26.895,88.145),(26.895,87.975),(26.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.225),(89.675,46.395),(89.845,46.395),(89.845,46.225),(89.675,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.565),(89.675,46.735),(89.845,46.735),(89.845,46.565),(89.675,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.765,22.495),(45.765,22.665),(45.935,22.665),(45.935,22.495),(45.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.495),(45.425,22.665),(45.595,22.665),(45.595,22.495),(45.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((45.085,22.495),(45.085,22.665),(45.255,22.665),(45.255,22.495),(45.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,87.975),(1.905,88.145),(2.075,88.145),(2.075,87.975),(1.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.565),(0.155,63.735),(0.325,63.735),(0.325,63.565),(0.155,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.225),(0.155,63.395),(0.325,63.395),(0.325,63.225),(0.155,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.505),(0.155,60.675),(0.325,60.675),(0.325,60.505),(0.155,60.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.165),(0.155,60.335),(0.325,60.335),(0.325,60.165),(0.155,60.165)),
        )
        createRL(
            tech, net, 'licon',
            ((22.985,87.975),(22.985,88.145),(23.155,88.145),(23.155,87.975),(22.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,22.495),(53.925,22.665),(54.095,22.665),(54.095,22.495),(53.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.305),(0.155,84.475),(0.325,84.475),(0.325,84.305),(0.155,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.645),(0.155,84.815),(0.325,84.815),(0.325,84.645),(0.155,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.325),(89.675,85.495),(89.845,85.495),(89.845,85.325),(89.675,85.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,85.665),(89.675,85.835),(89.845,85.835),(89.845,85.665),(89.675,85.665)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,22.495),(22.305,22.665),(22.475,22.665),(22.475,22.495),(22.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,22.495),(22.645,22.665),(22.815,22.665),(22.815,22.495),(22.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.885),(0.155,46.055),(0.325,46.055),(0.325,45.885),(0.155,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,87.975),(53.245,88.145),(53.415,88.145),(53.415,87.975),(53.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,87.975),(53.585,88.145),(53.755,88.145),(53.755,87.975),(53.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,22.495),(34.885,22.665),(35.055,22.665),(35.055,22.495),(34.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,22.495),(87.245,22.665),(87.415,22.665),(87.415,22.495),(87.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,22.495),(87.585,22.665),(87.755,22.665),(87.755,22.495),(87.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,87.975),(59.705,88.145),(59.875,88.145),(59.875,87.975),(59.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,87.975),(59.025,88.145),(59.195,88.145),(59.195,87.975),(59.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,87.975),(59.365,88.145),(59.535,88.145),(59.535,87.975),(59.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,87.975),(0.885,88.145),(1.055,88.145),(1.055,87.975),(0.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,22.495),(56.985,22.665),(57.155,22.665),(57.155,22.495),(56.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,22.495),(4.965,22.665),(5.135,22.665),(5.135,22.495),(4.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,22.495),(66.165,22.665),(66.335,22.665),(66.335,22.495),(66.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,22.495),(66.505,22.665),(66.675,22.665),(66.675,22.495),(66.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.165),(0.155,43.335),(0.325,43.335),(0.325,43.165),(0.155,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,43.505),(0.155,43.675),(0.325,43.675),(0.325,43.505),(0.155,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,87.975),(71.945,88.145),(72.115,88.145),(72.115,87.975),(71.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,87.975),(75.005,88.145),(75.175,88.145),(75.175,87.975),(75.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,87.975),(75.345,88.145),(75.515,88.145),(75.515,87.975),(75.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,87.975),(75.685,88.145),(75.855,88.145),(75.855,87.975),(75.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,87.975),(51.205,88.145),(51.375,88.145),(51.375,87.975),(51.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,87.975),(51.545,88.145),(51.715,88.145),(51.715,87.975),(51.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,22.495),(63.105,22.665),(63.275,22.665),(63.275,22.495),(63.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,87.975),(57.325,88.145),(57.495,88.145),(57.495,87.975),(57.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,87.975),(57.665,88.145),(57.835,88.145),(57.835,87.975),(57.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,22.495),(63.445,22.665),(63.615,22.665),(63.615,22.495),(63.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.305),(89.675,67.475),(89.845,67.475),(89.845,67.305),(89.675,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.645),(89.675,67.815),(89.845,67.815),(89.845,67.645),(89.675,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.265),(0.155,31.435),(0.325,31.435),(0.325,31.265),(0.155,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,87.975),(24.345,88.145),(24.515,88.145),(24.515,87.975),(24.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,87.975),(24.685,88.145),(24.855,88.145),(24.855,87.975),(24.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,87.975),(24.005,88.145),(24.175,88.145),(24.175,87.975),(24.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,44.865),(0.155,45.035),(0.325,45.035),(0.325,44.865),(0.155,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.605),(0.155,31.775),(0.325,31.775),(0.325,31.605),(0.155,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,87.975),(88.945,88.145),(89.115,88.145),(89.115,87.975),(88.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,22.495),(17.885,22.665),(18.055,22.665),(18.055,22.495),(17.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.645),(0.155,67.815),(0.325,67.815),(0.325,67.645),(0.155,67.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,67.305),(0.155,67.475),(0.325,67.475),(0.325,67.305),(0.155,67.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.205),(0.155,28.375),(0.325,28.375),(0.325,28.205),(0.155,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.545),(0.155,28.715),(0.325,28.715),(0.325,28.545),(0.155,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.125),(89.675,24.295),(89.845,24.295),(89.845,24.125),(89.675,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.465),(89.675,24.635),(89.845,24.635),(89.845,24.465),(89.675,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,24.805),(89.675,24.975),(89.845,24.975),(89.845,24.805),(89.675,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.125),(0.155,58.295),(0.325,58.295),(0.325,58.125),(0.155,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.105),(89.675,74.275),(89.845,74.275),(89.845,74.105),(89.675,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.445),(89.675,74.615),(89.845,74.615),(89.845,74.445),(89.675,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,74.785),(89.675,74.955),(89.845,74.955),(89.845,74.785),(89.675,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,22.495),(56.305,22.665),(56.475,22.665),(56.475,22.495),(56.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,22.495),(56.645,22.665),(56.815,22.665),(56.815,22.495),(56.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.285,22.495),(4.285,22.665),(4.455,22.665),(4.455,22.495),(4.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.625,22.495),(4.625,22.665),(4.795,22.665),(4.795,22.495),(4.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.205,22.495),(85.205,22.665),(85.375,22.665),(85.375,22.495),(85.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((85.545,22.495),(85.545,22.665),(85.715,22.665),(85.715,22.495),(85.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.485),(0.155,42.655),(0.325,42.655),(0.325,42.485),(0.155,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.825),(0.155,42.995),(0.325,42.995),(0.325,42.825),(0.155,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,87.975),(13.125,88.145),(13.295,88.145),(13.295,87.975),(13.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,87.975),(13.465,88.145),(13.635,88.145),(13.635,87.975),(13.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,87.975),(13.805,88.145),(13.975,88.145),(13.975,87.975),(13.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,42.145),(0.155,42.315),(0.325,42.315),(0.325,42.145),(0.155,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,87.975),(34.205,88.145),(34.375,88.145),(34.375,87.975),(34.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,87.975),(34.545,88.145),(34.715,88.145),(34.715,87.975),(34.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.485),(89.675,76.655),(89.845,76.655),(89.845,76.485),(89.675,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.825),(89.675,76.995),(89.845,76.995),(89.845,76.825),(89.675,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,76.145),(89.675,76.315),(89.845,76.315),(89.845,76.145),(89.675,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((3.605,22.495),(3.605,22.665),(3.775,22.665),(3.775,22.495),(3.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((3.265,22.495),(3.265,22.665),(3.435,22.665),(3.435,22.495),(3.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,60.845),(89.675,61.015),(89.845,61.015),(89.845,60.845),(89.675,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,22.495),(55.965,22.665),(56.135,22.665),(56.135,22.495),(55.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((58.685,87.975),(58.685,88.145),(58.855,88.145),(58.855,87.975),(58.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.625),(89.675,49.795),(89.845,49.795),(89.845,49.625),(89.675,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.005,87.975),(58.005,88.145),(58.175,88.145),(58.175,87.975),(58.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((58.345,87.975),(58.345,88.145),(58.515,88.145),(58.515,87.975),(58.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,49.285),(89.675,49.455),(89.845,49.455),(89.845,49.285),(89.675,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.165),(89.675,43.335),(89.845,43.335),(89.845,43.165),(89.675,43.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.985),(89.675,34.155),(89.845,34.155),(89.845,33.985),(89.675,33.985)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.505),(89.675,43.675),(89.845,43.675),(89.845,43.505),(89.675,43.505)),
        )
        createRL(
            tech, net, 'licon',
            ((53.245,22.495),(53.245,22.665),(53.415,22.665),(53.415,22.495),(53.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((53.585,22.495),(53.585,22.665),(53.755,22.665),(53.755,22.495),(53.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,87.975),(11.085,88.145),(11.255,88.145),(11.255,87.975),(11.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,87.975),(11.425,88.145),(11.595,88.145),(11.595,87.975),(11.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,87.975),(11.765,88.145),(11.935,88.145),(11.935,87.975),(11.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((75.005,22.495),(75.005,22.665),(75.175,22.665),(75.175,22.495),(75.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.345,22.495),(75.345,22.665),(75.515,22.665),(75.515,22.495),(75.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((75.685,22.495),(75.685,22.665),(75.855,22.665),(75.855,22.495),(75.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((20.945,87.975),(20.945,88.145),(21.115,88.145),(21.115,87.975),(20.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,87.975),(84.865,88.145),(85.035,88.145),(85.035,87.975),(84.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.265),(89.675,48.435),(89.845,48.435),(89.845,48.265),(89.675,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.605),(89.675,48.775),(89.845,48.775),(89.845,48.605),(89.675,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,22.495),(73.305,22.665),(73.475,22.665),(73.475,22.495),(73.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,83.965),(89.675,84.135),(89.845,84.135),(89.845,83.965),(89.675,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.365),(0.155,36.535),(0.325,36.535),(0.325,36.365),(0.155,36.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.705),(0.155,36.875),(0.325,36.875),(0.325,36.705),(0.155,36.705)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,22.495),(73.645,22.665),(73.815,22.665),(73.815,22.495),(73.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,36.025),(0.155,36.195),(0.325,36.195),(0.325,36.025),(0.155,36.025)),
        )
        createRL(
            tech, net, 'licon',
            ((61.065,87.975),(61.065,88.145),(61.235,88.145),(61.235,87.975),(61.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.405,87.975),(61.405,88.145),(61.575,88.145),(61.575,87.975),(61.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((61.745,87.975),(61.745,88.145),(61.915,88.145),(61.915,87.975),(61.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,82.945),(0.155,83.115),(0.325,83.115),(0.325,82.945),(0.155,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((85.885,87.975),(85.885,88.145),(86.055,88.145),(86.055,87.975),(85.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((57.325,22.495),(57.325,22.665),(57.495,22.665),(57.495,22.495),(57.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((57.665,22.495),(57.665,22.665),(57.835,22.665),(57.835,22.495),(57.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.945),(89.675,66.115),(89.845,66.115),(89.845,65.945),(89.675,65.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,22.495),(42.025,22.665),(42.195,22.665),(42.195,22.495),(42.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,22.495),(42.365,22.665),(42.535,22.665),(42.535,22.495),(42.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,22.495),(42.705,22.665),(42.875,22.665),(42.875,22.495),(42.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,22.495),(81.125,22.665),(81.295,22.665),(81.295,22.495),(81.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,22.495),(81.465,22.665),(81.635,22.665),(81.635,22.495),(81.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.625),(0.155,32.795),(0.325,32.795),(0.325,32.625),(0.155,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.285),(0.155,32.455),(0.325,32.455),(0.325,32.285),(0.155,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,22.495),(81.805,22.665),(81.975,22.665),(81.975,22.495),(81.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,22.495),(47.125,22.665),(47.295,22.665),(47.295,22.495),(47.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,22.495),(47.465,22.665),(47.635,22.665),(47.635,22.495),(47.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,22.495),(47.805,22.665),(47.975,22.665),(47.975,22.495),(47.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,46.905),(89.675,47.075),(89.845,47.075),(89.845,46.905),(89.675,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.245),(0.155,30.415),(0.325,30.415),(0.325,30.245),(0.155,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((22.305,87.975),(22.305,88.145),(22.475,88.145),(22.475,87.975),(22.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((22.645,87.975),(22.645,88.145),(22.815,88.145),(22.815,87.975),(22.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.905,22.495),(1.905,22.665),(2.075,22.665),(2.075,22.495),(1.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.585),(0.155,30.755),(0.325,30.755),(0.325,30.585),(0.155,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,22.495),(41.005,22.665),(41.175,22.665),(41.175,22.495),(41.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,22.495),(41.345,22.665),(41.515,22.665),(41.515,22.495),(41.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,22.495),(41.685,22.665),(41.855,22.665),(41.855,22.495),(41.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.045,22.495),(26.045,22.665),(26.215,22.665),(26.215,22.495),(26.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,87.975),(32.165,88.145),(32.335,88.145),(32.335,87.975),(32.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,87.975),(32.505,88.145),(32.675,88.145),(32.675,87.975),(32.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,22.495),(29.105,22.665),(29.275,22.665),(29.275,22.495),(29.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,22.495),(29.445,22.665),(29.615,22.665),(29.615,22.495),(29.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,22.495),(29.785,22.665),(29.955,22.665),(29.955,22.495),(29.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.385,22.495),(26.385,22.665),(26.555,22.665),(26.555,22.495),(26.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((26.725,22.495),(26.725,22.665),(26.895,22.665),(26.895,22.495),(26.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,87.975),(55.285,88.145),(55.455,88.145),(55.455,87.975),(55.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,87.975),(55.625,88.145),(55.795,88.145),(55.795,87.975),(55.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,60.845),(0.155,61.015),(0.325,61.015),(0.325,60.845),(0.155,60.845)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.085),(0.155,73.255),(0.325,73.255),(0.325,73.085),(0.155,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.425),(0.155,73.595),(0.325,73.595),(0.325,73.425),(0.155,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,73.765),(0.155,73.935),(0.325,73.935),(0.325,73.765),(0.155,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,87.975),(83.165,88.145),(83.335,88.145),(83.335,87.975),(83.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,87.975),(83.505,88.145),(83.675,88.145),(83.675,87.975),(83.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.965,22.495),(72.965,22.665),(73.135,22.665),(73.135,22.495),(72.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,87.975),(70.925,88.145),(71.095,88.145),(71.095,87.975),(70.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.605),(0.155,48.775),(0.325,48.775),(0.325,48.605),(0.155,48.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.265),(0.155,48.435),(0.325,48.435),(0.325,48.265),(0.155,48.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.305,87.975),(56.305,88.145),(56.475,88.145),(56.475,87.975),(56.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.645,87.975),(56.645,88.145),(56.815,88.145),(56.815,87.975),(56.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,84.985),(0.155,85.155),(0.325,85.155),(0.325,84.985),(0.155,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.525),(0.155,61.695),(0.325,61.695),(0.325,61.525),(0.155,61.525)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.185),(0.155,61.355),(0.325,61.355),(0.325,61.185),(0.155,61.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.245),(89.675,30.415),(89.845,30.415),(89.845,30.245),(89.675,30.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.585),(89.675,30.755),(89.845,30.755),(89.845,30.585),(89.675,30.585)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,22.495),(6.325,22.665),(6.495,22.665),(6.495,22.495),(6.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,22.495),(6.665,22.665),(6.835,22.665),(6.835,22.495),(6.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.465),(0.155,58.635),(0.325,58.635),(0.325,58.465),(0.155,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,58.805),(0.155,58.975),(0.325,58.975),(0.325,58.805),(0.155,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.365),(0.155,70.535),(0.325,70.535),(0.325,70.365),(0.155,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.705),(0.155,70.875),(0.325,70.875),(0.325,70.705),(0.155,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,87.975),(16.865,88.145),(17.035,88.145),(17.035,87.975),(16.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,70.025),(0.155,70.195),(0.325,70.195),(0.325,70.025),(0.155,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.125),(89.675,58.295),(89.845,58.295),(89.845,58.125),(89.675,58.125)),
        )
        createRL(
            tech, net, 'licon',
            ((73.305,87.975),(73.305,88.145),(73.475,88.145),(73.475,87.975),(73.305,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.645,87.975),(73.645,88.145),(73.815,88.145),(73.815,87.975),(73.645,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.465),(89.675,58.635),(89.845,58.635),(89.845,58.465),(89.675,58.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,58.805),(89.675,58.975),(89.845,58.975),(89.845,58.805),(89.675,58.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.345),(89.675,86.515),(89.845,86.515),(89.845,86.345),(89.675,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.685),(89.675,86.855),(89.845,86.855),(89.845,86.685),(89.675,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,86.005),(89.675,86.175),(89.845,86.175),(89.845,86.005),(89.675,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,22.495),(10.745,22.665),(10.915,22.665),(10.915,22.495),(10.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.305),(89.675,84.475),(89.845,84.475),(89.845,84.305),(89.675,84.305)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,87.975),(21.285,88.145),(21.455,88.145),(21.455,87.975),(21.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,87.975),(21.625,88.145),(21.795,88.145),(21.795,87.975),(21.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.645),(89.675,84.815),(89.845,84.815),(89.845,84.645),(89.675,84.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.325),(89.675,34.495),(89.845,34.495),(89.845,34.325),(89.675,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,34.665),(89.675,34.835),(89.845,34.835),(89.845,34.665),(89.675,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,87.975),(52.905,88.145),(53.075,88.145),(53.075,87.975),(52.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,22.495),(72.285,22.665),(72.455,22.665),(72.455,22.495),(72.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,22.495),(72.625,22.665),(72.795,22.665),(72.795,22.495),(72.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,67.985),(89.675,68.155),(89.845,68.155),(89.845,67.985),(89.675,67.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,87.975),(33.185,88.145),(33.355,88.145),(33.355,87.975),(33.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,87.975),(33.525,88.145),(33.695,88.145),(33.695,87.975),(33.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.105,87.975),(29.105,88.145),(29.275,88.145),(29.275,87.975),(29.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.445,87.975),(29.445,88.145),(29.615,88.145),(29.615,87.975),(29.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((29.785,87.975),(29.785,88.145),(29.955,88.145),(29.955,87.975),(29.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,87.975),(68.205,88.145),(68.375,88.145),(68.375,87.975),(68.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,87.975),(54.945,88.145),(55.115,88.145),(55.115,87.975),(54.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,87.975),(68.545,88.145),(68.715,88.145),(68.715,87.975),(68.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,22.495),(78.065,22.665),(78.235,22.665),(78.235,22.495),(78.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,22.495),(78.405,22.665),(78.575,22.665),(78.575,22.495),(78.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,22.495),(78.745,22.665),(78.915,22.665),(78.915,22.495),(78.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,28.885),(0.155,29.055),(0.325,29.055),(0.325,28.885),(0.155,28.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.465),(89.675,41.635),(89.845,41.635),(89.845,41.465),(89.675,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.805),(89.675,41.975),(89.845,41.975),(89.845,41.805),(89.675,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,41.125),(89.675,41.295),(89.845,41.295),(89.845,41.125),(89.675,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.125),(0.155,41.295),(0.325,41.295),(0.325,41.125),(0.155,41.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.465),(0.155,41.635),(0.325,41.635),(0.325,41.465),(0.155,41.465)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,87.975),(15.845,88.145),(16.015,88.145),(16.015,87.975),(15.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.245,87.975),(19.245,88.145),(19.415,88.145),(19.415,87.975),(19.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((19.585,87.975),(19.585,88.145),(19.755,88.145),(19.755,87.975),(19.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((83.165,22.495),(83.165,22.665),(83.335,22.665),(83.335,22.495),(83.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.505,22.495),(83.505,22.665),(83.675,22.665),(83.675,22.495),(83.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,87.975),(67.865,88.145),(68.035,88.145),(68.035,87.975),(67.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,41.805),(0.155,41.975),(0.325,41.975),(0.325,41.805),(0.155,41.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,22.495),(31.145,22.665),(31.315,22.665),(31.315,22.495),(31.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.945,22.495),(71.945,22.665),(72.115,22.665),(72.115,22.495),(71.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,22.495),(31.485,22.665),(31.655,22.665),(31.655,22.495),(31.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,22.495),(31.825,22.665),(31.995,22.665),(31.995,22.495),(31.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,87.975),(5.985,88.145),(6.155,88.145),(6.155,87.975),(5.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.265,87.975),(54.265,88.145),(54.435,88.145),(54.435,87.975),(54.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((54.605,87.975),(54.605,88.145),(54.775,88.145),(54.775,87.975),(54.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,87.975),(49.165,88.145),(49.335,88.145),(49.335,87.975),(49.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,87.975),(49.505,88.145),(49.675,88.145),(49.675,87.975),(49.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.925),(89.675,82.095),(89.845,82.095),(89.845,81.925),(89.675,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,87.975),(27.065,88.145),(27.235,88.145),(27.235,87.975),(27.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.505),(0.155,26.675),(0.325,26.675),(0.325,26.505),(0.155,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.065),(0.155,38.235),(0.325,38.235),(0.325,38.065),(0.155,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,87.975),(27.745,88.145),(27.915,88.145),(27.915,87.975),(27.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.745),(0.155,38.915),(0.325,38.915),(0.325,38.745),(0.155,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.165),(0.155,26.335),(0.325,26.335),(0.325,26.165),(0.155,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,87.975),(27.405,88.145),(27.575,88.145),(27.575,87.975),(27.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,22.495),(86.905,22.665),(87.075,22.665),(87.075,22.495),(86.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,38.405),(0.155,38.575),(0.325,38.575),(0.325,38.405),(0.155,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,22.495),(82.825,22.665),(82.995,22.665),(82.995,22.495),(82.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,22.495),(82.145,22.665),(82.315,22.665),(82.315,22.495),(82.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,22.495),(82.485,22.665),(82.655,22.665),(82.655,22.495),(82.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((38.285,87.975),(38.285,88.145),(38.455,88.145),(38.455,87.975),(38.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.745),(89.675,55.915),(89.845,55.915),(89.845,55.745),(89.675,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.885),(89.675,46.055),(89.845,46.055),(89.845,45.885),(89.675,45.885)),
        )
        createRL(
            tech, net, 'licon',
            ((38.625,87.975),(38.625,88.145),(38.795,88.145),(38.795,87.975),(38.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.065),(89.675,55.235),(89.845,55.235),(89.845,55.065),(89.675,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,55.405),(89.675,55.575),(89.845,55.575),(89.845,55.405),(89.675,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,22.495),(60.045,22.665),(60.215,22.665),(60.215,22.495),(60.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,22.495),(60.385,22.665),(60.555,22.665),(60.555,22.495),(60.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,22.495),(60.725,22.665),(60.895,22.665),(60.895,22.495),(60.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.825,22.495),(48.825,22.665),(48.995,22.665),(48.995,22.495),(48.825,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.145,22.495),(48.145,22.665),(48.315,22.665),(48.315,22.495),(48.145,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((48.485,22.495),(48.485,22.665),(48.655,22.665),(48.655,22.495),(48.485,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,87.975),(46.785,88.145),(46.955,88.145),(46.955,87.975),(46.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,87.975),(46.105,88.145),(46.275,88.145),(46.275,87.975),(46.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,87.975),(46.445,88.145),(46.615,88.145),(46.615,87.975),(46.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,87.975),(25.705,88.145),(25.875,88.145),(25.875,87.975),(25.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,87.975),(25.025,88.145),(25.195,88.145),(25.195,87.975),(25.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,43.845),(89.675,44.015),(89.845,44.015),(89.845,43.845),(89.675,43.845)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,87.975),(25.365,88.145),(25.535,88.145),(25.535,87.975),(25.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.585),(89.675,64.755),(89.845,64.755),(89.845,64.585),(89.675,64.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.245),(89.675,64.415),(89.845,64.415),(89.845,64.245),(89.675,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.665),(0.155,34.835),(0.325,34.835),(0.325,34.665),(0.155,34.665)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,34.325),(0.155,34.495),(0.325,34.495),(0.325,34.325),(0.155,34.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.645),(89.675,33.815),(89.845,33.815),(89.845,33.645),(89.675,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,22.495),(18.905,22.665),(19.075,22.665),(19.075,22.495),(18.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,33.305),(89.675,33.475),(89.845,33.475),(89.845,33.305),(89.675,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,87.975),(2.925,88.145),(3.095,88.145),(3.095,87.975),(2.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,87.975),(66.845,88.145),(67.015,88.145),(67.015,87.975),(66.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.185),(89.675,27.355),(89.845,27.355),(89.845,27.185),(89.675,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.525),(89.675,27.695),(89.845,27.695),(89.845,27.525),(89.675,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,48.945),(89.675,49.115),(89.845,49.115),(89.845,48.945),(89.675,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.165),(89.675,26.335),(89.845,26.335),(89.845,26.165),(89.675,26.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,22.495),(51.885,22.665),(52.055,22.665),(52.055,22.495),(51.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.405),(0.155,72.575),(0.325,72.575),(0.325,72.405),(0.155,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.745),(0.155,72.915),(0.325,72.915),(0.325,72.745),(0.155,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,72.065),(0.155,72.235),(0.325,72.235),(0.325,72.065),(0.155,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((87.245,87.975),(87.245,88.145),(87.415,88.145),(87.415,87.975),(87.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((87.585,87.975),(87.585,88.145),(87.755,88.145),(87.755,87.975),(87.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.105,87.975),(80.105,88.145),(80.275,88.145),(80.275,87.975),(80.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((80.445,87.975),(80.445,88.145),(80.615,88.145),(80.615,87.975),(80.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,22.495),(50.185,22.665),(50.355,22.665),(50.355,22.495),(50.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,22.495),(50.525,22.665),(50.695,22.665),(50.695,22.495),(50.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((4.965,87.975),(4.965,88.145),(5.135,88.145),(5.135,87.975),(4.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.845),(89.675,78.015),(89.845,78.015),(89.845,77.845),(89.675,77.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.345),(89.675,52.515),(89.845,52.515),(89.845,52.345),(89.675,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.685),(89.675,52.855),(89.845,52.855),(89.845,52.685),(89.675,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,87.975),(3.945,88.145),(4.115,88.145),(4.115,87.975),(3.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.105),(0.155,74.275),(0.325,74.275),(0.325,74.105),(0.155,74.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.445),(0.155,74.615),(0.325,74.615),(0.325,74.445),(0.155,74.445)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,74.785),(0.155,74.955),(0.325,74.955),(0.325,74.785),(0.155,74.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,52.005),(89.675,52.175),(89.845,52.175),(89.845,52.005),(89.675,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,57.785),(0.155,57.955),(0.325,57.955),(0.325,57.785),(0.155,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.265),(89.675,82.435),(89.845,82.435),(89.845,82.265),(89.675,82.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.605),(89.675,82.775),(89.845,82.775),(89.845,82.605),(89.675,82.605)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.325),(89.675,51.495),(89.845,51.495),(89.845,51.325),(89.675,51.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,51.665),(89.675,51.835),(89.845,51.835),(89.845,51.665),(89.675,51.665)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.225),(89.675,80.395),(89.845,80.395),(89.845,80.225),(89.675,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.565),(89.675,80.735),(89.845,80.735),(89.845,80.565),(89.675,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.645),(0.155,50.815),(0.325,50.815),(0.325,50.645),(0.155,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.305),(0.155,50.475),(0.325,50.475),(0.325,50.305),(0.155,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.265),(89.675,65.435),(89.845,65.435),(89.845,65.265),(89.675,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,65.605),(89.675,65.775),(89.845,65.775),(89.845,65.605),(89.675,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.725),(0.155,37.895),(0.325,37.895),(0.325,37.725),(0.155,37.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.385),(0.155,37.555),(0.325,37.555),(0.325,37.385),(0.155,37.385)),
        )
        createRL(
            tech, net, 'licon',
            ((18.905,87.975),(18.905,88.145),(19.075,88.145),(19.075,87.975),(18.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.145,87.975),(65.145,88.145),(65.315,88.145),(65.315,87.975),(65.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.485,87.975),(65.485,88.145),(65.655,88.145),(65.655,87.975),(65.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((65.825,87.975),(65.825,88.145),(65.995,88.145),(65.995,87.975),(65.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,37.045),(0.155,37.215),(0.325,37.215),(0.325,37.045),(0.155,37.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.885),(0.155,80.055),(0.325,80.055),(0.325,79.885),(0.155,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.085),(89.675,56.255),(89.845,56.255),(89.845,56.085),(89.675,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,32.965),(0.155,33.135),(0.325,33.135),(0.325,32.965),(0.155,32.965)),
        )
        createRL(
            tech, net, 'licon',
            ((55.965,87.975),(55.965,88.145),(56.135,88.145),(56.135,87.975),(55.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.425),(89.675,56.595),(89.845,56.595),(89.845,56.425),(89.675,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,56.765),(89.675,56.935),(89.845,56.935),(89.845,56.765),(89.675,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((86.905,87.975),(86.905,88.145),(87.075,88.145),(87.075,87.975),(86.905,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,30.925),(0.155,31.095),(0.325,31.095),(0.325,30.925),(0.155,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((53.925,87.975),(53.925,88.145),(54.095,88.145),(54.095,87.975),(53.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.445),(89.675,23.615),(89.845,23.615),(89.845,23.445),(89.675,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,22.495),(32.845,22.665),(33.015,22.665),(33.015,22.495),(32.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.785),(89.675,23.955),(89.845,23.955),(89.845,23.785),(89.675,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,23.105),(89.675,23.275),(89.845,23.275),(89.845,23.105),(89.675,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((25.025,22.495),(25.025,22.665),(25.195,22.665),(25.195,22.495),(25.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.365,22.495),(25.365,22.665),(25.535,22.665),(25.535,22.495),(25.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((25.705,22.495),(25.705,22.665),(25.875,22.665),(25.875,22.495),(25.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.525),(89.675,78.695),(89.845,78.695),(89.845,78.525),(89.675,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.185),(89.675,78.355),(89.845,78.355),(89.845,78.185),(89.675,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,22.495),(86.225,22.665),(86.395,22.665),(86.395,22.495),(86.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,22.495),(86.565,22.665),(86.735,22.665),(86.735,22.495),(86.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.125,22.495),(13.125,22.665),(13.295,22.665),(13.295,22.495),(13.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.465,22.495),(13.465,22.665),(13.635,22.665),(13.635,22.495),(13.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.125,22.495),(64.125,22.665),(64.295,22.665),(64.295,22.495),(64.125,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.465,22.495),(64.465,22.665),(64.635,22.665),(64.635,22.495),(64.465,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((64.805,22.495),(64.805,22.665),(64.975,22.665),(64.975,22.495),(64.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((13.805,22.495),(13.805,22.665),(13.975,22.665),(13.975,22.495),(13.805,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,22.495),(10.065,22.665),(10.235,22.665),(10.235,22.495),(10.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,22.495),(10.405,22.665),(10.575,22.665),(10.575,22.495),(10.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.865),(0.155,28.035),(0.325,28.035),(0.325,27.865),(0.155,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((15.165,22.495),(15.165,22.665),(15.335,22.665),(15.335,22.495),(15.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((15.505,22.495),(15.505,22.665),(15.675,22.665),(15.675,22.495),(15.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.165,22.495),(49.165,22.665),(49.335,22.665),(49.335,22.495),(49.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((49.505,22.495),(49.505,22.665),(49.675,22.665),(49.675,22.495),(49.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,22.495),(37.945,22.665),(38.115,22.665),(38.115,22.495),(37.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.225),(0.155,46.395),(0.325,46.395),(0.325,46.225),(0.155,46.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.565),(0.155,46.735),(0.325,46.735),(0.325,46.565),(0.155,46.565)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,48.945),(0.155,49.115),(0.325,49.115),(0.325,48.945),(0.155,48.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,87.975),(37.265,88.145),(37.435,88.145),(37.435,87.975),(37.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,87.975),(37.605,88.145),(37.775,88.145),(37.775,87.975),(37.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,87.975),(23.325,88.145),(23.495,88.145),(23.495,87.975),(23.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,87.975),(23.665,88.145),(23.835,88.145),(23.835,87.975),(23.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.105),(0.155,40.275),(0.325,40.275),(0.325,40.105),(0.155,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.445),(0.155,40.615),(0.325,40.615),(0.325,40.445),(0.155,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,22.495),(21.965,22.665),(22.135,22.665),(22.135,22.495),(21.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,40.785),(0.155,40.955),(0.325,40.955),(0.325,40.785),(0.155,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,30.925),(89.675,31.095),(89.845,31.095),(89.845,30.925),(89.675,30.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.905),(89.675,64.075),(89.845,64.075),(89.845,63.905),(89.675,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.165,22.495),(32.165,22.665),(32.335,22.665),(32.335,22.495),(32.165,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((32.505,22.495),(32.505,22.665),(32.675,22.665),(32.675,22.495),(32.505,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.265),(0.155,65.435),(0.325,65.435),(0.325,65.265),(0.155,65.265)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,65.605),(0.155,65.775),(0.325,65.775),(0.325,65.605),(0.155,65.605)),
        )
        createRL(
            tech, net, 'licon',
            ((2.925,22.495),(2.925,22.665),(3.095,22.665),(3.095,22.495),(2.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.205),(0.155,62.375),(0.325,62.375),(0.325,62.205),(0.155,62.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.545),(0.155,62.715),(0.325,62.715),(0.325,62.545),(0.155,62.545)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,84.985),(89.675,85.155),(89.845,85.155),(89.845,84.985),(89.675,84.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.285,22.495),(55.285,22.665),(55.455,22.665),(55.455,22.495),(55.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.125,87.975),(47.125,88.145),(47.295,88.145),(47.295,87.975),(47.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((47.465,87.975),(47.465,88.145),(47.635,88.145),(47.635,87.975),(47.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((55.625,22.495),(55.625,22.665),(55.795,22.665),(55.795,22.495),(55.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((47.805,87.975),(47.805,88.145),(47.975,88.145),(47.975,87.975),(47.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.225,87.975),(35.225,88.145),(35.395,88.145),(35.395,87.975),(35.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.565,87.975),(35.565,88.145),(35.735,88.145),(35.735,87.975),(35.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.005,87.975),(41.005,88.145),(41.175,88.145),(41.175,87.975),(41.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.085),(0.155,56.255),(0.325,56.255),(0.325,56.085),(0.155,56.085)),
        )
        createRL(
            tech, net, 'licon',
            ((41.345,87.975),(41.345,88.145),(41.515,88.145),(41.515,87.975),(41.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((41.685,87.975),(41.685,88.145),(41.855,88.145),(41.855,87.975),(41.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.425),(0.155,56.595),(0.325,56.595),(0.325,56.425),(0.155,56.425)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,56.765),(0.155,56.935),(0.325,56.935),(0.325,56.765),(0.155,56.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.205,22.495),(34.205,22.665),(34.375,22.665),(34.375,22.495),(34.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((34.545,22.495),(34.545,22.665),(34.715,22.665),(34.715,22.495),(34.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.245),(89.675,47.415),(89.845,47.415),(89.845,47.245),(89.675,47.245)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,47.585),(89.675,47.755),(89.845,47.755),(89.845,47.585),(89.675,47.585)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,79.885),(89.675,80.055),(89.845,80.055),(89.845,79.885),(89.675,79.885)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.065),(89.675,72.235),(89.845,72.235),(89.845,72.065),(89.675,72.065)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.405),(89.675,72.575),(89.845,72.575),(89.845,72.405),(89.675,72.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,72.745),(89.675,72.915),(89.845,72.915),(89.845,72.745),(89.675,72.745)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.285),(89.675,66.455),(89.845,66.455),(89.845,66.285),(89.675,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.625),(89.675,66.795),(89.845,66.795),(89.845,66.625),(89.675,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.225),(0.155,80.395),(0.325,80.395),(0.325,80.225),(0.155,80.225)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.565),(0.155,80.735),(0.325,80.735),(0.325,80.565),(0.155,80.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,22.495),(40.325,22.665),(40.495,22.665),(40.495,22.495),(40.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,22.495),(40.665,22.665),(40.835,22.665),(40.835,22.495),(40.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.485),(89.675,25.655),(89.845,25.655),(89.845,25.485),(89.675,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.825),(89.675,25.995),(89.845,25.995),(89.845,25.825),(89.675,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,25.145),(89.675,25.315),(89.845,25.315),(89.845,25.145),(89.675,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,22.495),(76.025,22.665),(76.195,22.665),(76.195,22.495),(76.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,22.495),(76.365,22.665),(76.535,22.665),(76.535,22.495),(76.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,22.495),(76.705,22.665),(76.875,22.665),(76.875,22.495),(76.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,87.975),(36.245,88.145),(36.415,88.145),(36.415,87.975),(36.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,87.975),(36.585,88.145),(36.755,88.145),(36.755,87.975),(36.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((24.005,22.495),(24.005,22.665),(24.175,22.665),(24.175,22.495),(24.005,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((24.345,22.495),(24.345,22.665),(24.515,22.665),(24.515,22.495),(24.345,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.245),(89.675,81.415),(89.845,81.415),(89.845,81.245),(89.675,81.245)),
        )
        createRL(
            tech, net, 'licon',
            ((24.685,22.495),(24.685,22.665),(24.855,22.665),(24.855,22.495),(24.685,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.365),(0.155,53.535),(0.325,53.535),(0.325,53.365),(0.155,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.705),(0.155,53.875),(0.325,53.875),(0.325,53.705),(0.155,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,81.585),(89.675,81.755),(89.845,81.755),(89.845,81.585),(89.675,81.585)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,26.845),(0.155,27.015),(0.325,27.015),(0.325,26.845),(0.155,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.945),(89.675,32.115),(89.845,32.115),(89.845,31.945),(89.675,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,53.025),(0.155,53.195),(0.325,53.195),(0.325,53.025),(0.155,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((70.925,22.495),(70.925,22.665),(71.095,22.665),(71.095,22.495),(70.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.185,22.495),(33.185,22.665),(33.355,22.665),(33.355,22.495),(33.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,22.495),(39.985,22.665),(40.155,22.665),(40.155,22.495),(39.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.525,22.495),(33.525,22.665),(33.695,22.665),(33.695,22.495),(33.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.865,22.495),(67.865,22.665),(68.035,22.665),(68.035,22.495),(67.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.205),(89.675,45.375),(89.845,45.375),(89.845,45.205),(89.675,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,45.545),(89.675,45.715),(89.845,45.715),(89.845,45.545),(89.675,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.305),(0.155,33.475),(0.325,33.475),(0.325,33.305),(0.155,33.305)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,33.645),(0.155,33.815),(0.325,33.815),(0.325,33.645),(0.155,33.645)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.425),(89.675,39.595),(89.845,39.595),(89.845,39.425),(89.675,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.765),(89.675,39.935),(89.845,39.935),(89.845,39.765),(89.675,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,39.085),(89.675,39.255),(89.845,39.255),(89.845,39.085),(89.675,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.865,87.975),(50.865,88.145),(51.035,88.145),(51.035,87.975),(50.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.765),(0.155,39.935),(0.325,39.935),(0.325,39.765),(0.155,39.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.425),(0.155,39.595),(0.325,39.595),(0.325,39.425),(0.155,39.425)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,87.975),(87.925,88.145),(88.095,88.145),(88.095,87.975),(87.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.265,22.495),(37.265,22.665),(37.435,22.665),(37.435,22.495),(37.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((37.605,22.495),(37.605,22.665),(37.775,22.665),(37.775,22.495),(37.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,39.085),(0.155,39.255),(0.325,39.255),(0.325,39.085),(0.155,39.085)),
        )
        createRL(
            tech, net, 'licon',
            ((80.785,87.975),(80.785,88.145),(80.955,88.145),(80.955,87.975),(80.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((59.025,22.495),(59.025,22.665),(59.195,22.665),(59.195,22.495),(59.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((59.365,22.495),(59.365,22.665),(59.535,22.665),(59.535,22.495),(59.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,64.925),(89.675,65.095),(89.845,65.095),(89.845,64.925),(89.675,64.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.705,22.495),(59.705,22.665),(59.875,22.665),(59.875,22.495),(59.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,27.865),(89.675,28.035),(89.845,28.035),(89.845,27.865),(89.675,27.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.465),(0.155,24.635),(0.325,24.635),(0.325,24.465),(0.155,24.465)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.805),(0.155,24.975),(0.325,24.975),(0.325,24.805),(0.155,24.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,24.125),(0.155,24.295),(0.325,24.295),(0.325,24.125),(0.155,24.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.165),(0.155,77.335),(0.325,77.335),(0.325,77.165),(0.155,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,77.505),(0.155,77.675),(0.325,77.675),(0.325,77.505),(0.155,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,54.045),(0.155,54.215),(0.325,54.215),(0.325,54.045),(0.155,54.045)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,87.975),(62.425,88.145),(62.595,88.145),(62.595,87.975),(62.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,87.975),(62.085,88.145),(62.255,88.145),(62.255,87.975),(62.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.845),(89.675,27.015),(89.845,27.015),(89.845,26.845),(89.675,26.845)),
        )
        createRL(
            tech, net, 'licon',
            ((43.045,22.495),(43.045,22.665),(43.215,22.665),(43.215,22.495),(43.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.385,22.495),(43.385,22.665),(43.555,22.665),(43.555,22.495),(43.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((43.725,22.495),(43.725,22.665),(43.895,22.665),(43.895,22.495),(43.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.285,22.495),(21.285,22.665),(21.455,22.665),(21.455,22.495),(21.285,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((21.625,22.495),(21.625,22.665),(21.795,22.665),(21.795,22.495),(21.625,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,87.975),(71.265,88.145),(71.435,88.145),(71.435,87.975),(71.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,87.975),(71.605,88.145),(71.775,88.145),(71.775,87.975),(71.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.165),(89.675,77.335),(89.845,77.335),(89.845,77.165),(89.675,77.165)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,77.505),(89.675,77.675),(89.845,77.675),(89.845,77.505),(89.675,77.505)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.205),(0.155,79.375),(0.325,79.375),(0.325,79.205),(0.155,79.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,79.545),(0.155,79.715),(0.325,79.715),(0.325,79.545),(0.155,79.545)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.625),(0.155,49.795),(0.325,49.795),(0.325,49.625),(0.155,49.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.185),(89.675,44.355),(89.845,44.355),(89.845,44.185),(89.675,44.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,49.285),(0.155,49.455),(0.325,49.455),(0.325,49.285),(0.155,49.285)),
        )
        createRL(
            tech, net, 'licon',
            ((10.065,87.975),(10.065,88.145),(10.235,88.145),(10.235,87.975),(10.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.405,87.975),(10.405,88.145),(10.575,88.145),(10.575,87.975),(10.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((10.745,87.975),(10.745,88.145),(10.915,88.145),(10.915,87.975),(10.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,81.925),(0.155,82.095),(0.325,82.095),(0.325,81.925),(0.155,81.925)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.525),(89.675,44.695),(89.845,44.695),(89.845,44.525),(89.675,44.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.065),(89.675,38.235),(89.845,38.235),(89.845,38.065),(89.675,38.065)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,87.975),(17.205,88.145),(17.375,88.145),(17.375,87.975),(17.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,87.975),(17.545,88.145),(17.715,88.145),(17.715,87.975),(17.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.405),(89.675,38.575),(89.845,38.575),(89.845,38.405),(89.675,38.405)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,38.745),(89.675,38.915),(89.845,38.915),(89.845,38.745),(89.675,38.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,29.905),(0.155,30.075),(0.325,30.075),(0.325,29.905),(0.155,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,82.945),(89.675,83.115),(89.845,83.115),(89.845,82.945),(89.675,82.945)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,80.905),(89.675,81.075),(89.845,81.075),(89.845,80.905),(89.675,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,50.985),(0.155,51.155),(0.325,51.155),(0.325,50.985),(0.155,50.985)),
        )
        createRL(
            tech, net, 'licon',
            ((86.225,87.975),(86.225,88.145),(86.395,88.145),(86.395,87.975),(86.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((62.085,22.495),(62.085,22.665),(62.255,22.665),(62.255,22.495),(62.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.425,22.495),(62.425,22.665),(62.595,22.665),(62.595,22.495),(62.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((62.765,22.495),(62.765,22.665),(62.935,22.665),(62.935,22.495),(62.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((86.565,87.975),(86.565,88.145),(86.735,88.145),(86.735,87.975),(86.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.365),(0.155,87.535),(0.325,87.535),(0.325,87.365),(0.155,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,87.025),(0.155,87.195),(0.325,87.195),(0.325,87.025),(0.155,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.445),(89.675,40.615),(89.845,40.615),(89.845,40.445),(89.675,40.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.785),(89.675,40.955),(89.845,40.955),(89.845,40.785),(89.675,40.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,40.105),(89.675,40.275),(89.845,40.275),(89.845,40.105),(89.675,40.105)),
        )
        createRL(
            tech, net, 'licon',
            ((84.865,22.495),(84.865,22.665),(85.035,22.665),(85.035,22.495),(84.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,78.865),(89.675,79.035),(89.845,79.035),(89.845,78.865),(89.675,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.285),(0.155,66.455),(0.325,66.455),(0.325,66.285),(0.155,66.285)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.625),(0.155,66.795),(0.325,66.795),(0.325,66.625),(0.155,66.625)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,87.975),(73.985,88.145),(74.155,88.145),(74.155,87.975),(73.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.185),(0.155,27.355),(0.325,27.355),(0.325,27.185),(0.155,27.185)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,27.525),(0.155,27.695),(0.325,27.695),(0.325,27.525),(0.155,27.525)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,22.495),(9.045,22.665),(9.215,22.665),(9.215,22.495),(9.045,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,22.495),(9.385,22.665),(9.555,22.665),(9.555,22.495),(9.385,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,22.495),(9.725,22.665),(9.895,22.665),(9.895,22.495),(9.725,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.485),(89.675,59.655),(89.845,59.655),(89.845,59.485),(89.675,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.825),(89.675,59.995),(89.845,59.995),(89.845,59.825),(89.675,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,22.495),(70.245,22.665),(70.415,22.665),(70.415,22.495),(70.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,22.495),(70.585,22.665),(70.755,22.665),(70.755,22.495),(70.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,59.145),(89.675,59.315),(89.845,59.315),(89.845,59.145),(89.675,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.885,87.975),(51.885,88.145),(52.055,88.145),(52.055,87.975),(51.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,46.905),(0.155,47.075),(0.325,47.075),(0.325,46.905),(0.155,46.905)),
        )
        createRL(
            tech, net, 'licon',
            ((21.965,87.975),(21.965,88.145),(22.135,88.145),(22.135,87.975),(21.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.905),(89.675,30.075),(89.845,30.075),(89.845,29.905),(89.675,29.905)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.205),(0.155,45.375),(0.325,45.375),(0.325,45.205),(0.155,45.205)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,45.545),(0.155,45.715),(0.325,45.715),(0.325,45.545),(0.155,45.545)),
        )
        createRL(
            tech, net, 'licon',
            ((71.265,22.495),(71.265,22.665),(71.435,22.665),(71.435,22.495),(71.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((71.605,22.495),(71.605,22.665),(71.775,22.665),(71.775,22.495),(71.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((33.865,87.975),(33.865,88.145),(34.035,88.145),(34.035,87.975),(33.865,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.205,22.495),(17.205,22.665),(17.375,22.665),(17.375,22.495),(17.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((17.545,22.495),(17.545,22.665),(17.715,22.665),(17.715,22.495),(17.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((7.005,87.975),(7.005,88.145),(7.175,88.145),(7.175,87.975),(7.005,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.345,87.975),(7.345,88.145),(7.515,88.145),(7.515,87.975),(7.345,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((7.685,87.975),(7.685,88.145),(7.855,88.145),(7.855,87.975),(7.685,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.985,22.495),(5.985,22.665),(6.155,22.665),(6.155,22.495),(5.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((63.105,87.975),(63.105,88.145),(63.275,88.145),(63.275,87.975),(63.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.445,87.975),(63.445,88.145),(63.615,88.145),(63.615,87.975),(63.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((63.785,87.975),(63.785,88.145),(63.955,88.145),(63.955,87.975),(63.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,22.495),(84.185,22.665),(84.355,22.665),(84.355,22.495),(84.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,22.495),(84.525,22.665),(84.695,22.665),(84.695,22.495),(84.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.325),(89.675,68.495),(89.845,68.495),(89.845,68.325),(89.675,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,68.665),(89.675,68.835),(89.845,68.835),(89.845,68.665),(89.675,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.845,87.975),(32.845,88.145),(33.015,88.145),(33.015,87.975),(32.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,62.885),(0.155,63.055),(0.325,63.055),(0.325,62.885),(0.155,62.885)),
        )
        createRL(
            tech, net, 'licon',
            ((72.285,87.975),(72.285,88.145),(72.455,88.145),(72.455,87.975),(72.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((72.625,87.975),(72.625,88.145),(72.795,88.145),(72.795,87.975),(72.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,87.975),(8.025,88.145),(8.195,88.145),(8.195,87.975),(8.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,87.975),(8.365,88.145),(8.535,88.145),(8.535,87.975),(8.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,87.975),(8.705,88.145),(8.875,88.145),(8.875,87.975),(8.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.425),(89.675,73.595),(89.845,73.595),(89.845,73.425),(89.675,73.425)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.765),(89.675,73.935),(89.845,73.935),(89.845,73.765),(89.675,73.765)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.805),(0.155,75.975),(0.325,75.975),(0.325,75.805),(0.155,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.465),(0.155,75.635),(0.325,75.635),(0.325,75.465),(0.155,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,73.085),(89.675,73.255),(89.845,73.255),(89.845,73.085),(89.675,73.085)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,75.125),(0.155,75.295),(0.325,75.295),(0.325,75.125),(0.155,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.145),(0.155,76.315),(0.325,76.315),(0.325,76.145),(0.155,76.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.485),(0.155,76.655),(0.325,76.655),(0.325,76.485),(0.155,76.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,76.825),(0.155,76.995),(0.325,76.995),(0.325,76.825),(0.155,76.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.745),(0.155,55.915),(0.325,55.915),(0.325,55.745),(0.155,55.745)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.065),(0.155,55.235),(0.325,55.235),(0.325,55.065),(0.155,55.065)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,55.405),(0.155,55.575),(0.325,55.575),(0.325,55.405),(0.155,55.405)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,31.945),(0.155,32.115),(0.325,32.115),(0.325,31.945),(0.155,31.945)),
        )
        createRL(
            tech, net, 'licon',
            ((82.145,87.975),(82.145,88.145),(82.315,88.145),(82.315,87.975),(82.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((49.845,87.975),(49.845,88.145),(50.015,88.145),(50.015,87.975),(49.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.485,87.975),(82.485,88.145),(82.655,88.145),(82.655,87.975),(82.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((82.825,87.975),(82.825,88.145),(82.995,88.145),(82.995,87.975),(82.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.185),(0.155,78.355),(0.325,78.355),(0.325,78.185),(0.155,78.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.025,87.975),(42.025,88.145),(42.195,88.145),(42.195,87.975),(42.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.265),(89.675,31.435),(89.845,31.435),(89.845,31.265),(89.675,31.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.365,87.975),(42.365,88.145),(42.535,88.145),(42.535,87.975),(42.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((42.705,87.975),(42.705,88.145),(42.875,88.145),(42.875,87.975),(42.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((56.985,87.975),(56.985,88.145),(57.155,88.145),(57.155,87.975),(56.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,31.605),(89.675,31.775),(89.845,31.775),(89.845,31.605),(89.675,31.605)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.525),(0.155,78.695),(0.325,78.695),(0.325,78.525),(0.155,78.525)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,66.965),(89.675,67.135),(89.845,67.135),(89.845,66.965),(89.675,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((69.225,87.975),(69.225,88.145),(69.395,88.145),(69.395,87.975),(69.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((69.565,87.975),(69.565,88.145),(69.735,88.145),(69.735,87.975),(69.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,80.905),(0.155,81.075),(0.325,81.075),(0.325,80.905),(0.155,80.905)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,87.975),(28.085,88.145),(28.255,88.145),(28.255,87.975),(28.085,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,87.975),(28.425,88.145),(28.595,88.145),(28.595,87.975),(28.425,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,87.975),(28.765,88.145),(28.935,88.145),(28.935,87.975),(28.765,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.045,87.975),(9.045,88.145),(9.215,88.145),(9.215,87.975),(9.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.385,87.975),(9.385,88.145),(9.555,88.145),(9.555,87.975),(9.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((9.725,87.975),(9.725,88.145),(9.895,88.145),(9.895,87.975),(9.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((46.105,22.495),(46.105,22.665),(46.275,22.665),(46.275,22.495),(46.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.445,22.495),(46.445,22.665),(46.615,22.665),(46.615,22.495),(46.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((46.785,22.495),(46.785,22.665),(46.955,22.665),(46.955,22.495),(46.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((16.865,22.495),(16.865,22.665),(17.035,22.665),(17.035,22.495),(16.865,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.205,22.495),(51.205,22.665),(51.375,22.665),(51.375,22.495),(51.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((51.545,22.495),(51.545,22.665),(51.715,22.665),(51.715,22.495),(51.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.005),(0.155,86.175),(0.325,86.175),(0.325,86.005),(0.155,86.005)),
        )
        createRL(
            tech, net, 'licon',
            ((66.165,87.975),(66.165,88.145),(66.335,88.145),(66.335,87.975),(66.165,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.505,87.975),(66.505,88.145),(66.675,88.145),(66.675,87.975),(66.505,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,87.975),(2.245,88.145),(2.415,88.145),(2.415,87.975),(2.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,87.975),(2.585,88.145),(2.755,88.145),(2.755,87.975),(2.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.345),(0.155,86.515),(0.325,86.515),(0.325,86.345),(0.155,86.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,86.685),(0.155,86.855),(0.325,86.855),(0.325,86.685),(0.155,86.685)),
        )
        createRL(
            tech, net, 'licon',
            ((89.285,87.975),(89.285,88.145),(89.455,88.145),(89.455,87.975),(89.285,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.625,87.975),(89.625,88.145),(89.795,88.145),(89.795,87.975),(89.625,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((8.025,22.495),(8.025,22.665),(8.195,22.665),(8.195,22.495),(8.025,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.365,22.495),(8.365,22.665),(8.535,22.665),(8.535,22.495),(8.365,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((8.705,22.495),(8.705,22.665),(8.875,22.665),(8.875,22.495),(8.705,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,22.495),(44.065,22.665),(44.235,22.665),(44.235,22.495),(44.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.495),(44.405,22.665),(44.575,22.665),(44.575,22.495),(44.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,22.495),(44.745,22.665),(44.915,22.665),(44.915,22.495),(44.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,87.975),(68.885,88.145),(69.055,88.145),(69.055,87.975),(68.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((28.085,22.495),(28.085,22.665),(28.255,22.665),(28.255,22.495),(28.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.425,22.495),(28.425,22.665),(28.595,22.665),(28.595,22.495),(28.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((28.765,22.495),(28.765,22.665),(28.935,22.665),(28.935,22.495),(28.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.465),(89.675,75.635),(89.845,75.635),(89.845,75.465),(89.675,75.465)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.805),(89.675,75.975),(89.845,75.975),(89.845,75.805),(89.675,75.805)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,75.125),(89.675,75.295),(89.845,75.295),(89.845,75.125),(89.675,75.125)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.105),(0.155,23.275),(0.325,23.275),(0.325,23.105),(0.155,23.105)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.445),(0.155,23.615),(0.325,23.615),(0.325,23.445),(0.155,23.445)),
        )
        createRL(
            tech, net, 'licon',
            ((16.185,22.495),(16.185,22.665),(16.355,22.665),(16.355,22.495),(16.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,87.975),(18.225,88.145),(18.395,88.145),(18.395,87.975),(18.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,87.975),(18.565,88.145),(18.735,88.145),(18.735,87.975),(18.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((16.525,22.495),(16.525,22.665),(16.695,22.665),(16.695,22.495),(16.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,23.785),(0.155,23.955),(0.325,23.955),(0.325,23.785),(0.155,23.785)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,87.975),(12.105,88.145),(12.275,88.145),(12.275,87.975),(12.105,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,22.495),(1.225,22.665),(1.395,22.665),(1.395,22.495),(1.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,22.495),(1.565,22.665),(1.735,22.665),(1.735,22.495),(1.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,87.975),(12.445,88.145),(12.615,88.145),(12.615,87.975),(12.445,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,87.975),(12.785,88.145),(12.955,88.145),(12.955,87.975),(12.785,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.025,87.975),(76.025,88.145),(76.195,88.145),(76.195,87.975),(76.025,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.365,87.975),(76.365,88.145),(76.535,88.145),(76.535,87.975),(76.365,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((76.705,87.975),(76.705,88.145),(76.875,88.145),(76.875,87.975),(76.705,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((35.905,22.495),(35.905,22.665),(36.075,22.665),(36.075,22.495),(35.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.445),(89.675,57.615),(89.845,57.615),(89.845,57.445),(89.675,57.445)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.785),(89.675,57.955),(89.845,57.955),(89.845,57.785),(89.675,57.785)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,57.105),(89.675,57.275),(89.845,57.275),(89.845,57.105),(89.675,57.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.145,87.975),(31.145,88.145),(31.315,88.145),(31.315,87.975),(31.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.485,87.975),(31.485,88.145),(31.655,88.145),(31.655,87.975),(31.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((31.825,87.975),(31.825,88.145),(31.995,88.145),(31.995,87.975),(31.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.325),(0.155,68.495),(0.325,68.495),(0.325,68.325),(0.155,68.325)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,68.665),(0.155,68.835),(0.325,68.835),(0.325,68.665),(0.155,68.665)),
        )
        createRL(
            tech, net, 'licon',
            ((27.065,22.495),(27.065,22.665),(27.235,22.665),(27.235,22.495),(27.065,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.405,22.495),(27.405,22.665),(27.575,22.665),(27.575,22.495),(27.405,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((27.745,22.495),(27.745,22.665),(27.915,22.665),(27.915,22.495),(27.745,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((83.845,87.975),(83.845,88.145),(84.015,88.145),(84.015,87.975),(83.845,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((5.645,22.495),(5.645,22.665),(5.815,22.665),(5.815,22.495),(5.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((5.305,22.495),(5.305,22.665),(5.475,22.665),(5.475,22.495),(5.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,44.865),(89.675,45.035),(89.845,45.035),(89.845,44.865),(89.675,44.865)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,22.495),(19.925,22.665),(20.095,22.665),(20.095,22.495),(19.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.225,22.495),(18.225,22.665),(18.395,22.665),(18.395,22.495),(18.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((18.565,22.495),(18.565,22.665),(18.735,22.665),(18.735,22.495),(18.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,22.495),(74.325,22.665),(74.495,22.665),(74.495,22.495),(74.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,22.495),(74.665,22.665),(74.835,22.665),(74.835,22.495),(74.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.985,87.975),(39.985,88.145),(40.155,88.145),(40.155,87.975),(39.985,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((37.945,87.975),(37.945,88.145),(38.115,88.145),(38.115,87.975),(37.945,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.285),(89.675,32.455),(89.845,32.455),(89.845,32.285),(89.675,32.285)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,32.625),(89.675,32.795),(89.845,32.795),(89.845,32.625),(89.675,32.625)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.045),(89.675,71.215),(89.845,71.215),(89.845,71.045),(89.675,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.385),(89.675,71.555),(89.845,71.555),(89.845,71.385),(89.675,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,71.725),(89.675,71.895),(89.845,71.895),(89.845,71.725),(89.675,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.365),(89.675,70.535),(89.845,70.535),(89.845,70.365),(89.675,70.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.705),(89.675,70.875),(89.845,70.875),(89.845,70.705),(89.675,70.705)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,70.025),(89.675,70.195),(89.845,70.195),(89.845,70.025),(89.675,70.025)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.045),(0.155,71.215),(0.325,71.215),(0.325,71.045),(0.155,71.045)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.385),(0.155,71.555),(0.325,71.555),(0.325,71.385),(0.155,71.385)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,71.725),(0.155,71.895),(0.325,71.895),(0.325,71.725),(0.155,71.725)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,87.975),(0.205,88.145),(0.375,88.145),(0.375,87.975),(0.205,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,87.975),(0.545,88.145),(0.715,88.145),(0.715,87.975),(0.545,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((73.985,22.495),(73.985,22.665),(74.155,22.665),(74.155,22.495),(73.985,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,66.965),(0.155,67.135),(0.325,67.135),(0.325,66.965),(0.155,66.965)),
        )
        createRL(
            tech, net, 'licon',
            ((68.885,22.495),(68.885,22.665),(69.055,22.665),(69.055,22.495),(68.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.885,22.495),(0.885,22.665),(1.055,22.665),(1.055,22.495),(0.885,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.305),(89.675,50.475),(89.845,50.475),(89.845,50.305),(89.675,50.305)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,50.645),(89.675,50.815),(89.845,50.815),(89.845,50.645),(89.675,50.645)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,87.975),(38.965,88.145),(39.135,88.145),(39.135,87.975),(38.965,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,26.505),(89.675,26.675),(89.845,26.675),(89.845,26.505),(89.675,26.505)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.225),(89.675,29.395),(89.845,29.395),(89.845,29.225),(89.675,29.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,29.565),(89.675,29.735),(89.845,29.735),(89.845,29.565),(89.675,29.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.905,22.495),(52.905,22.665),(53.075,22.665),(53.075,22.495),(52.905,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,87.975),(88.265,88.145),(88.435,88.145),(88.435,87.975),(88.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,87.975),(88.605,88.145),(88.775,88.145),(88.775,87.975),(88.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((66.845,22.495),(66.845,22.665),(67.015,22.665),(67.015,22.495),(66.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.205),(89.675,28.375),(89.845,28.375),(89.845,28.205),(89.675,28.205)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,28.545),(89.675,28.715),(89.845,28.715),(89.845,28.545),(89.675,28.545)),
        )
        createRL(
            tech, net, 'licon',
            ((1.225,87.975),(1.225,88.145),(1.395,88.145),(1.395,87.975),(1.225,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((1.565,87.975),(1.565,88.145),(1.735,88.145),(1.735,87.975),(1.565,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,61.865),(0.155,62.035),(0.325,62.035),(0.325,61.865),(0.155,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.145),(0.155,25.315),(0.325,25.315),(0.325,25.145),(0.155,25.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.485),(0.155,25.655),(0.325,25.655),(0.325,25.485),(0.155,25.485)),
        )
        createRL(
            tech, net, 'licon',
            ((19.925,87.975),(19.925,88.145),(20.095,88.145),(20.095,87.975),(19.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,25.825),(0.155,25.995),(0.325,25.995),(0.325,25.825),(0.155,25.825)),
        )
        createRL(
            tech, net, 'licon',
            ((88.945,22.495),(88.945,22.665),(89.115,22.665),(89.115,22.495),(88.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((60.045,87.975),(60.045,88.145),(60.215,88.145),(60.215,87.975),(60.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.385,87.975),(60.385,88.145),(60.555,88.145),(60.555,87.975),(60.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((60.725,87.975),(60.725,88.145),(60.895,88.145),(60.895,87.975),(60.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,22.495),(36.925,22.665),(37.095,22.665),(37.095,22.495),(36.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.305,22.495),(39.305,22.665),(39.475,22.665),(39.475,22.495),(39.305,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((39.645,22.495),(39.645,22.665),(39.815,22.665),(39.815,22.495),(39.645,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.205,22.495),(68.205,22.665),(68.375,22.665),(68.375,22.495),(68.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((68.545,22.495),(68.545,22.665),(68.715,22.665),(68.715,22.495),(68.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.025),(89.675,53.195),(89.845,53.195),(89.845,53.025),(89.675,53.025)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.365),(89.675,53.535),(89.845,53.535),(89.845,53.365),(89.675,53.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,53.705),(89.675,53.875),(89.845,53.875),(89.845,53.705),(89.675,53.705)),
        )
        createRL(
            tech, net, 'licon',
            ((77.045,87.975),(77.045,88.145),(77.215,88.145),(77.215,87.975),(77.045,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.205,22.495),(0.205,22.665),(0.375,22.665),(0.375,22.495),(0.205,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.545,22.495),(0.545,22.665),(0.715,22.665),(0.715,22.495),(0.545,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((77.385,87.975),(77.385,88.145),(77.555,88.145),(77.555,87.975),(77.385,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((77.725,87.975),(77.725,88.145),(77.895,88.145),(77.895,87.975),(77.725,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.745,87.975),(44.745,88.145),(44.915,88.145),(44.915,87.975),(44.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.065,87.975),(44.065,88.145),(44.235,88.145),(44.235,87.975),(44.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,87.975),(44.405,88.145),(44.575,88.145),(44.575,87.975),(44.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.145),(0.155,59.315),(0.325,59.315),(0.325,59.145),(0.155,59.145)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.485),(0.155,59.655),(0.325,59.655),(0.325,59.485),(0.155,59.485)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,59.825),(0.155,59.995),(0.325,59.995),(0.325,59.825),(0.155,59.825)),
        )
        createRL(
            tech, net, 'licon',
            ((23.325,22.495),(23.325,22.665),(23.495,22.665),(23.495,22.495),(23.325,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.225,22.495),(52.225,22.665),(52.395,22.665),(52.395,22.495),(52.225,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((52.565,22.495),(52.565,22.665),(52.735,22.665),(52.735,22.495),(52.565,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((23.665,22.495),(23.665,22.665),(23.835,22.665),(23.835,22.495),(23.665,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,83.965),(0.155,84.135),(0.325,84.135),(0.325,83.965),(0.155,83.965)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,22.495),(67.185,22.665),(67.355,22.665),(67.355,22.495),(67.185,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,22.495),(67.525,22.665),(67.695,22.665),(67.695,22.495),(67.525,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.145),(89.675,42.315),(89.845,42.315),(89.845,42.145),(89.675,42.145)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.485),(89.675,42.655),(89.845,42.655),(89.845,42.485),(89.675,42.485)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,42.825),(89.675,42.995),(89.845,42.995),(89.845,42.825),(89.675,42.825)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,78.865),(0.155,79.035),(0.325,79.035),(0.325,78.865),(0.155,78.865)),
        )
        createRL(
            tech, net, 'licon',
            ((2.245,22.495),(2.245,22.665),(2.415,22.665),(2.415,22.495),(2.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((2.585,22.495),(2.585,22.665),(2.755,22.665),(2.755,22.495),(2.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.265,22.495),(88.265,22.665),(88.435,22.665),(88.435,22.495),(88.265,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((88.605,22.495),(88.605,22.665),(88.775,22.665),(88.775,22.495),(88.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,61.865),(89.675,62.035),(89.845,62.035),(89.845,61.865),(89.675,61.865)),
        )
        createRL(
            tech, net, 'licon',
            ((36.245,22.495),(36.245,22.665),(36.415,22.665),(36.415,22.495),(36.245,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((36.585,22.495),(36.585,22.665),(36.755,22.665),(36.755,22.495),(36.585,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((50.185,87.975),(50.185,88.145),(50.355,88.145),(50.355,87.975),(50.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((50.525,87.975),(50.525,88.145),(50.695,88.145),(50.695,87.975),(50.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.185,87.975),(84.185,88.145),(84.355,88.145),(84.355,87.975),(84.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((84.525,87.975),(84.525,88.145),(84.695,88.145),(84.695,87.975),(84.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.265,87.975),(20.265,88.145),(20.435,88.145),(20.435,87.975),(20.265,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,87.975),(20.605,88.145),(20.775,88.145),(20.775,87.975),(20.605,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((15.845,22.495),(15.845,22.665),(16.015,22.665),(16.015,22.495),(15.845,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((54.945,22.495),(54.945,22.665),(55.115,22.665),(55.115,22.495),(54.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((87.925,22.495),(87.925,22.665),(88.095,22.665),(88.095,22.495),(87.925,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((40.325,87.975),(40.325,88.145),(40.495,88.145),(40.495,87.975),(40.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((40.665,87.975),(40.665,88.145),(40.835,88.145),(40.835,87.975),(40.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.245,87.975),(70.245,88.145),(70.415,88.145),(70.415,87.975),(70.245,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((70.585,87.975),(70.585,88.145),(70.755,88.145),(70.755,87.975),(70.585,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.365),(89.675,87.535),(89.845,87.535),(89.845,87.365),(89.675,87.365)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,87.025),(89.675,87.195),(89.845,87.195),(89.845,87.025),(89.675,87.025)),
        )
        createRL(
            tech, net, 'licon',
            ((6.325,87.975),(6.325,88.145),(6.495,88.145),(6.495,87.975),(6.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((6.665,87.975),(6.665,88.145),(6.835,88.145),(6.835,87.975),(6.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,63.905),(0.155,64.075),(0.325,64.075),(0.325,63.905),(0.155,63.905)),
        )
        createRL(
            tech, net, 'licon',
            ((38.965,22.495),(38.965,22.665),(39.135,22.665),(39.135,22.495),(38.965,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((78.065,87.975),(78.065,88.145),(78.235,88.145),(78.235,87.975),(78.065,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.405,87.975),(78.405,88.145),(78.575,88.145),(78.575,87.975),(78.405,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((78.745,87.975),(78.745,88.145),(78.915,88.145),(78.915,87.975),(78.745,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.145,87.975),(14.145,88.145),(14.315,88.145),(14.315,87.975),(14.145,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.485,87.975),(14.485,88.145),(14.655,88.145),(14.655,87.975),(14.485,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((14.825,87.975),(14.825,88.145),(14.995,88.145),(14.995,87.975),(14.825,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((17.885,87.975),(17.885,88.145),(18.055,88.145),(18.055,87.975),(17.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((74.325,87.975),(74.325,88.145),(74.495,88.145),(74.495,87.975),(74.325,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.225),(89.675,63.395),(89.845,63.395),(89.845,63.225),(89.675,63.225)),
        )
        createRL(
            tech, net, 'licon',
            ((89.675,63.565),(89.675,63.735),(89.845,63.735),(89.845,63.565),(89.675,63.565)),
        )
        createRL(
            tech, net, 'licon',
            ((74.665,87.975),(74.665,88.145),(74.835,88.145),(74.835,87.975),(74.665,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((34.885,87.975),(34.885,88.145),(35.055,88.145),(35.055,87.975),(34.885,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.125,87.975),(81.125,88.145),(81.295,88.145),(81.295,87.975),(81.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((12.105,22.495),(12.105,22.665),(12.275,22.665),(12.275,22.495),(12.105,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.445,22.495),(12.445,22.665),(12.615,22.665),(12.615,22.495),(12.445,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((12.785,22.495),(12.785,22.665),(12.955,22.665),(12.955,22.495),(12.785,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((81.465,87.975),(81.465,88.145),(81.635,88.145),(81.635,87.975),(81.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((81.805,87.975),(81.805,88.145),(81.975,88.145),(81.975,87.975),(81.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.185,87.975),(67.185,88.145),(67.355,88.145),(67.355,87.975),(67.185,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((67.525,87.975),(67.525,88.145),(67.695,88.145),(67.695,87.975),(67.525,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((36.925,87.975),(36.925,88.145),(37.095,88.145),(37.095,87.975),(36.925,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((20.605,22.495),(20.605,22.665),(20.775,22.665),(20.775,22.495),(20.605,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.005),(0.155,52.175),(0.325,52.175),(0.325,52.005),(0.155,52.005)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.345),(0.155,52.515),(0.325,52.515),(0.325,52.345),(0.155,52.345)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,52.685),(0.155,52.855),(0.325,52.855),(0.325,52.685),(0.155,52.685)),
        )
        createRL(
            tech, net, 'licon',
            ((11.085,22.495),(11.085,22.665),(11.255,22.665),(11.255,22.495),(11.085,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.425,22.495),(11.425,22.665),(11.595,22.665),(11.595,22.495),(11.425,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((11.765,22.495),(11.765,22.665),(11.935,22.665),(11.935,22.495),(11.765,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((30.125,87.975),(30.125,88.145),(30.295,88.145),(30.295,87.975),(30.125,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.465,87.975),(30.465,88.145),(30.635,88.145),(30.635,87.975),(30.465,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((30.805,87.975),(30.805,88.145),(30.975,88.145),(30.975,87.975),(30.805,87.975)),
        )
        createRL(
            tech, net, 'licon',
            ((3.945,22.495),(3.945,22.665),(4.115,22.665),(4.115,22.495),(3.945,22.495)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.245),(0.155,64.415),(0.325,64.415),(0.325,64.245),(0.155,64.245)),
        )
        createRL(
            tech, net, 'licon',
            ((0.155,64.585),(0.155,64.755),(0.325,64.755),(0.325,64.585),(0.155,64.585)),
        )
        createRL(
            tech, net, 'li',
            ((0.155,23.025),(0.155,87.615),(0.325,87.615),(0.325,23.025),(0.155,23.025)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,22.82),(90.0,22.82),(90.0,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,87.82),(0.0,88.3),(90.0,88.3),(90.0,87.82),(0.0,87.82)),
        )
        createRL(
            tech, net, 'li',
            ((0.0,22.34),(0.0,88.3),(0.48,88.3),(0.48,22.34),(0.0,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,87.895),(0.205,88.225),(89.795,88.225),(89.795,87.895),(0.205,87.895)),
        )
        createRL(
            tech, net, 'li',
            ((0.205,22.415),(0.205,22.745),(89.795,22.745),(89.795,22.415),(0.205,22.415)),
        )
        createRL(
            tech, net, 'li',
            ((89.52,22.34),(89.52,88.3),(90.0,88.3),(90.0,22.34),(89.52,22.34)),
        )
        createRL(
            tech, net, 'li',
            ((89.675,23.025),(89.675,87.615),(89.845,87.615),(89.845,23.025),(89.675,23.025)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.16),(-0.18,23.0),(90.18,23.0),(90.18,22.16),(-0.18,22.16)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,87.64),(-0.18,88.48),(90.18,88.48),(90.18,87.64),(-0.18,87.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((-0.18,22.64),(-0.18,88.0),(0.66,88.0),(0.66,22.64),(-0.18,22.64)),
        )
        createRL(
            tech, net, 'nwm',
            ((89.34,22.64),(89.34,88.0),(90.18,88.0),(90.18,22.64),(89.34,22.64)),
        )
        net = nets['iovdd']
        createRL(
            tech, net, 'm2',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm2',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via3',
            ((1.7,91.37),(1.7,91.57),(1.9,91.57),(1.9,91.37),(1.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,91.37),(3.3,91.57),(3.5,91.57),(3.5,91.37),(3.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,91.37),(4.9,91.57),(5.1,91.57),(5.1,91.37),(4.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,91.37),(6.5,91.57),(6.7,91.57),(6.7,91.37),(6.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,91.37),(8.1,91.57),(8.3,91.57),(8.3,91.37),(8.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,91.37),(9.7,91.57),(9.9,91.57),(9.9,91.37),(9.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,91.37),(11.3,91.57),(11.5,91.57),(11.5,91.37),(11.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,91.37),(12.9,91.57),(13.1,91.57),(13.1,91.37),(12.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,91.37),(14.5,91.57),(14.7,91.57),(14.7,91.37),(14.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,91.37),(16.1,91.57),(16.3,91.57),(16.3,91.37),(16.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,91.37),(17.7,91.57),(17.9,91.57),(17.9,91.37),(17.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,91.37),(19.3,91.57),(19.5,91.57),(19.5,91.37),(19.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,91.37),(20.9,91.57),(21.1,91.57),(21.1,91.37),(20.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,91.37),(22.5,91.57),(22.7,91.57),(22.7,91.37),(22.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,91.37),(24.1,91.57),(24.3,91.57),(24.3,91.37),(24.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,91.37),(25.7,91.57),(25.9,91.57),(25.9,91.37),(25.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,91.37),(27.3,91.57),(27.5,91.57),(27.5,91.37),(27.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,91.37),(28.9,91.57),(29.1,91.57),(29.1,91.37),(28.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,91.37),(30.5,91.57),(30.7,91.57),(30.7,91.37),(30.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,91.37),(32.1,91.57),(32.3,91.57),(32.3,91.37),(32.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,91.37),(33.7,91.57),(33.9,91.57),(33.9,91.37),(33.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,91.37),(35.3,91.57),(35.5,91.57),(35.5,91.37),(35.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,91.37),(36.9,91.57),(37.1,91.57),(37.1,91.37),(36.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,91.37),(38.5,91.57),(38.7,91.57),(38.7,91.37),(38.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,91.37),(40.1,91.57),(40.3,91.57),(40.3,91.37),(40.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,91.37),(41.7,91.57),(41.9,91.57),(41.9,91.37),(41.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,91.37),(43.3,91.57),(43.5,91.57),(43.5,91.37),(43.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,91.37),(44.9,91.57),(45.1,91.57),(45.1,91.37),(44.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,91.37),(46.5,91.57),(46.7,91.57),(46.7,91.37),(46.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,91.37),(48.1,91.57),(48.3,91.57),(48.3,91.37),(48.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,91.37),(49.7,91.57),(49.9,91.57),(49.9,91.37),(49.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,91.37),(51.3,91.57),(51.5,91.57),(51.5,91.37),(51.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,91.37),(52.9,91.57),(53.1,91.57),(53.1,91.37),(52.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,91.37),(54.5,91.57),(54.7,91.57),(54.7,91.37),(54.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,91.37),(56.1,91.57),(56.3,91.57),(56.3,91.37),(56.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,91.37),(57.7,91.57),(57.9,91.57),(57.9,91.37),(57.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,91.37),(59.3,91.57),(59.5,91.57),(59.5,91.37),(59.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,91.37),(60.9,91.57),(61.1,91.57),(61.1,91.37),(60.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,91.37),(62.5,91.57),(62.7,91.57),(62.7,91.37),(62.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,91.37),(64.1,91.57),(64.3,91.57),(64.3,91.37),(64.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,91.37),(65.7,91.57),(65.9,91.57),(65.9,91.37),(65.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,91.37),(67.3,91.57),(67.5,91.57),(67.5,91.37),(67.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,91.37),(68.9,91.57),(69.1,91.57),(69.1,91.37),(68.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,91.37),(70.5,91.57),(70.7,91.57),(70.7,91.37),(70.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,91.37),(72.1,91.57),(72.3,91.57),(72.3,91.37),(72.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,91.37),(73.7,91.57),(73.9,91.57),(73.9,91.37),(73.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,91.37),(75.3,91.57),(75.5,91.57),(75.5,91.37),(75.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,91.37),(76.9,91.57),(77.1,91.57),(77.1,91.37),(76.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,91.37),(78.5,91.57),(78.7,91.57),(78.7,91.37),(78.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,91.37),(80.1,91.57),(80.3,91.57),(80.3,91.37),(80.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,91.37),(81.7,91.57),(81.9,91.57),(81.9,91.37),(81.7,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,91.37),(83.3,91.57),(83.5,91.57),(83.5,91.37),(83.3,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,91.37),(84.9,91.57),(85.1,91.57),(85.1,91.37),(84.9,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,91.37),(86.5,91.57),(86.7,91.57),(86.7,91.37),(86.5,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,91.37),(88.1,91.57),(88.3,91.57),(88.3,91.37),(88.1,91.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,92.97),(1.7,93.17),(1.9,93.17),(1.9,92.97),(1.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,92.97),(3.3,93.17),(3.5,93.17),(3.5,92.97),(3.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,92.97),(4.9,93.17),(5.1,93.17),(5.1,92.97),(4.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,92.97),(6.5,93.17),(6.7,93.17),(6.7,92.97),(6.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,92.97),(8.1,93.17),(8.3,93.17),(8.3,92.97),(8.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,92.97),(9.7,93.17),(9.9,93.17),(9.9,92.97),(9.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,92.97),(11.3,93.17),(11.5,93.17),(11.5,92.97),(11.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,92.97),(12.9,93.17),(13.1,93.17),(13.1,92.97),(12.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,92.97),(14.5,93.17),(14.7,93.17),(14.7,92.97),(14.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,92.97),(16.1,93.17),(16.3,93.17),(16.3,92.97),(16.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,92.97),(17.7,93.17),(17.9,93.17),(17.9,92.97),(17.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,92.97),(19.3,93.17),(19.5,93.17),(19.5,92.97),(19.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,92.97),(20.9,93.17),(21.1,93.17),(21.1,92.97),(20.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,92.97),(22.5,93.17),(22.7,93.17),(22.7,92.97),(22.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,92.97),(24.1,93.17),(24.3,93.17),(24.3,92.97),(24.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,92.97),(25.7,93.17),(25.9,93.17),(25.9,92.97),(25.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,92.97),(27.3,93.17),(27.5,93.17),(27.5,92.97),(27.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,92.97),(28.9,93.17),(29.1,93.17),(29.1,92.97),(28.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,92.97),(30.5,93.17),(30.7,93.17),(30.7,92.97),(30.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,92.97),(32.1,93.17),(32.3,93.17),(32.3,92.97),(32.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,92.97),(33.7,93.17),(33.9,93.17),(33.9,92.97),(33.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,92.97),(35.3,93.17),(35.5,93.17),(35.5,92.97),(35.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,92.97),(36.9,93.17),(37.1,93.17),(37.1,92.97),(36.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,92.97),(38.5,93.17),(38.7,93.17),(38.7,92.97),(38.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,92.97),(40.1,93.17),(40.3,93.17),(40.3,92.97),(40.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,92.97),(41.7,93.17),(41.9,93.17),(41.9,92.97),(41.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,92.97),(43.3,93.17),(43.5,93.17),(43.5,92.97),(43.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,92.97),(44.9,93.17),(45.1,93.17),(45.1,92.97),(44.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,92.97),(46.5,93.17),(46.7,93.17),(46.7,92.97),(46.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,92.97),(48.1,93.17),(48.3,93.17),(48.3,92.97),(48.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,92.97),(49.7,93.17),(49.9,93.17),(49.9,92.97),(49.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,92.97),(51.3,93.17),(51.5,93.17),(51.5,92.97),(51.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,92.97),(52.9,93.17),(53.1,93.17),(53.1,92.97),(52.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,92.97),(54.5,93.17),(54.7,93.17),(54.7,92.97),(54.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,92.97),(56.1,93.17),(56.3,93.17),(56.3,92.97),(56.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,92.97),(57.7,93.17),(57.9,93.17),(57.9,92.97),(57.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,92.97),(59.3,93.17),(59.5,93.17),(59.5,92.97),(59.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,92.97),(60.9,93.17),(61.1,93.17),(61.1,92.97),(60.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,92.97),(62.5,93.17),(62.7,93.17),(62.7,92.97),(62.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,92.97),(64.1,93.17),(64.3,93.17),(64.3,92.97),(64.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,92.97),(65.7,93.17),(65.9,93.17),(65.9,92.97),(65.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,92.97),(67.3,93.17),(67.5,93.17),(67.5,92.97),(67.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,92.97),(68.9,93.17),(69.1,93.17),(69.1,92.97),(68.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,92.97),(70.5,93.17),(70.7,93.17),(70.7,92.97),(70.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,92.97),(72.1,93.17),(72.3,93.17),(72.3,92.97),(72.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,92.97),(73.7,93.17),(73.9,93.17),(73.9,92.97),(73.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,92.97),(75.3,93.17),(75.5,93.17),(75.5,92.97),(75.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,92.97),(76.9,93.17),(77.1,93.17),(77.1,92.97),(76.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,92.97),(78.5,93.17),(78.7,93.17),(78.7,92.97),(78.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,92.97),(80.1,93.17),(80.3,93.17),(80.3,92.97),(80.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,92.97),(81.7,93.17),(81.9,93.17),(81.9,92.97),(81.7,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,92.97),(83.3,93.17),(83.5,93.17),(83.5,92.97),(83.3,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,92.97),(84.9,93.17),(85.1,93.17),(85.1,92.97),(84.9,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,92.97),(86.5,93.17),(86.7,93.17),(86.7,92.97),(86.5,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,92.97),(88.1,93.17),(88.3,93.17),(88.3,92.97),(88.1,92.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,94.57),(1.7,94.77),(1.9,94.77),(1.9,94.57),(1.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,94.57),(3.3,94.77),(3.5,94.77),(3.5,94.57),(3.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,94.57),(4.9,94.77),(5.1,94.77),(5.1,94.57),(4.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,94.57),(6.5,94.77),(6.7,94.77),(6.7,94.57),(6.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,94.57),(8.1,94.77),(8.3,94.77),(8.3,94.57),(8.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,94.57),(9.7,94.77),(9.9,94.77),(9.9,94.57),(9.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,94.57),(11.3,94.77),(11.5,94.77),(11.5,94.57),(11.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,94.57),(12.9,94.77),(13.1,94.77),(13.1,94.57),(12.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,94.57),(14.5,94.77),(14.7,94.77),(14.7,94.57),(14.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,94.57),(16.1,94.77),(16.3,94.77),(16.3,94.57),(16.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,94.57),(17.7,94.77),(17.9,94.77),(17.9,94.57),(17.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,94.57),(19.3,94.77),(19.5,94.77),(19.5,94.57),(19.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,94.57),(20.9,94.77),(21.1,94.77),(21.1,94.57),(20.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,94.57),(22.5,94.77),(22.7,94.77),(22.7,94.57),(22.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,94.57),(24.1,94.77),(24.3,94.77),(24.3,94.57),(24.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,94.57),(25.7,94.77),(25.9,94.77),(25.9,94.57),(25.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,94.57),(27.3,94.77),(27.5,94.77),(27.5,94.57),(27.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,94.57),(28.9,94.77),(29.1,94.77),(29.1,94.57),(28.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,94.57),(30.5,94.77),(30.7,94.77),(30.7,94.57),(30.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,94.57),(32.1,94.77),(32.3,94.77),(32.3,94.57),(32.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,94.57),(33.7,94.77),(33.9,94.77),(33.9,94.57),(33.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,94.57),(35.3,94.77),(35.5,94.77),(35.5,94.57),(35.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,94.57),(36.9,94.77),(37.1,94.77),(37.1,94.57),(36.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,94.57),(38.5,94.77),(38.7,94.77),(38.7,94.57),(38.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,94.57),(40.1,94.77),(40.3,94.77),(40.3,94.57),(40.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,94.57),(41.7,94.77),(41.9,94.77),(41.9,94.57),(41.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,94.57),(43.3,94.77),(43.5,94.77),(43.5,94.57),(43.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,94.57),(44.9,94.77),(45.1,94.77),(45.1,94.57),(44.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,94.57),(46.5,94.77),(46.7,94.77),(46.7,94.57),(46.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,94.57),(48.1,94.77),(48.3,94.77),(48.3,94.57),(48.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,94.57),(49.7,94.77),(49.9,94.77),(49.9,94.57),(49.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,94.57),(51.3,94.77),(51.5,94.77),(51.5,94.57),(51.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,94.57),(52.9,94.77),(53.1,94.77),(53.1,94.57),(52.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,94.57),(54.5,94.77),(54.7,94.77),(54.7,94.57),(54.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,94.57),(56.1,94.77),(56.3,94.77),(56.3,94.57),(56.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,94.57),(57.7,94.77),(57.9,94.77),(57.9,94.57),(57.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,94.57),(59.3,94.77),(59.5,94.77),(59.5,94.57),(59.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,94.57),(60.9,94.77),(61.1,94.77),(61.1,94.57),(60.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,94.57),(62.5,94.77),(62.7,94.77),(62.7,94.57),(62.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,94.57),(64.1,94.77),(64.3,94.77),(64.3,94.57),(64.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,94.57),(65.7,94.77),(65.9,94.77),(65.9,94.57),(65.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,94.57),(67.3,94.77),(67.5,94.77),(67.5,94.57),(67.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,94.57),(68.9,94.77),(69.1,94.77),(69.1,94.57),(68.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,94.57),(70.5,94.77),(70.7,94.77),(70.7,94.57),(70.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,94.57),(72.1,94.77),(72.3,94.77),(72.3,94.57),(72.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,94.57),(73.7,94.77),(73.9,94.77),(73.9,94.57),(73.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,94.57),(75.3,94.77),(75.5,94.77),(75.5,94.57),(75.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,94.57),(76.9,94.77),(77.1,94.77),(77.1,94.57),(76.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,94.57),(78.5,94.77),(78.7,94.77),(78.7,94.57),(78.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,94.57),(80.1,94.77),(80.3,94.77),(80.3,94.57),(80.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,94.57),(81.7,94.77),(81.9,94.77),(81.9,94.57),(81.7,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,94.57),(83.3,94.77),(83.5,94.77),(83.5,94.57),(83.3,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,94.57),(84.9,94.77),(85.1,94.77),(85.1,94.57),(84.9,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,94.57),(86.5,94.77),(86.7,94.77),(86.7,94.57),(86.5,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,94.57),(88.1,94.77),(88.3,94.77),(88.3,94.57),(88.1,94.57)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,96.17),(1.7,96.37),(1.9,96.37),(1.9,96.17),(1.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,96.17),(3.3,96.37),(3.5,96.37),(3.5,96.17),(3.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,96.17),(4.9,96.37),(5.1,96.37),(5.1,96.17),(4.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,96.17),(6.5,96.37),(6.7,96.37),(6.7,96.17),(6.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,96.17),(8.1,96.37),(8.3,96.37),(8.3,96.17),(8.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,96.17),(9.7,96.37),(9.9,96.37),(9.9,96.17),(9.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,96.17),(11.3,96.37),(11.5,96.37),(11.5,96.17),(11.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,96.17),(12.9,96.37),(13.1,96.37),(13.1,96.17),(12.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,96.17),(14.5,96.37),(14.7,96.37),(14.7,96.17),(14.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,96.17),(16.1,96.37),(16.3,96.37),(16.3,96.17),(16.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,96.17),(17.7,96.37),(17.9,96.37),(17.9,96.17),(17.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,96.17),(19.3,96.37),(19.5,96.37),(19.5,96.17),(19.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,96.17),(20.9,96.37),(21.1,96.37),(21.1,96.17),(20.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,96.17),(22.5,96.37),(22.7,96.37),(22.7,96.17),(22.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,96.17),(24.1,96.37),(24.3,96.37),(24.3,96.17),(24.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,96.17),(25.7,96.37),(25.9,96.37),(25.9,96.17),(25.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,96.17),(27.3,96.37),(27.5,96.37),(27.5,96.17),(27.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,96.17),(28.9,96.37),(29.1,96.37),(29.1,96.17),(28.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,96.17),(30.5,96.37),(30.7,96.37),(30.7,96.17),(30.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,96.17),(32.1,96.37),(32.3,96.37),(32.3,96.17),(32.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,96.17),(33.7,96.37),(33.9,96.37),(33.9,96.17),(33.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,96.17),(35.3,96.37),(35.5,96.37),(35.5,96.17),(35.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,96.17),(36.9,96.37),(37.1,96.37),(37.1,96.17),(36.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,96.17),(38.5,96.37),(38.7,96.37),(38.7,96.17),(38.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,96.17),(40.1,96.37),(40.3,96.37),(40.3,96.17),(40.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,96.17),(41.7,96.37),(41.9,96.37),(41.9,96.17),(41.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,96.17),(43.3,96.37),(43.5,96.37),(43.5,96.17),(43.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,96.17),(44.9,96.37),(45.1,96.37),(45.1,96.17),(44.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,96.17),(46.5,96.37),(46.7,96.37),(46.7,96.17),(46.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,96.17),(48.1,96.37),(48.3,96.37),(48.3,96.17),(48.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,96.17),(49.7,96.37),(49.9,96.37),(49.9,96.17),(49.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,96.17),(51.3,96.37),(51.5,96.37),(51.5,96.17),(51.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,96.17),(52.9,96.37),(53.1,96.37),(53.1,96.17),(52.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,96.17),(54.5,96.37),(54.7,96.37),(54.7,96.17),(54.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,96.17),(56.1,96.37),(56.3,96.37),(56.3,96.17),(56.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,96.17),(57.7,96.37),(57.9,96.37),(57.9,96.17),(57.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,96.17),(59.3,96.37),(59.5,96.37),(59.5,96.17),(59.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,96.17),(60.9,96.37),(61.1,96.37),(61.1,96.17),(60.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,96.17),(62.5,96.37),(62.7,96.37),(62.7,96.17),(62.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,96.17),(64.1,96.37),(64.3,96.37),(64.3,96.17),(64.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,96.17),(65.7,96.37),(65.9,96.37),(65.9,96.17),(65.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,96.17),(67.3,96.37),(67.5,96.37),(67.5,96.17),(67.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,96.17),(68.9,96.37),(69.1,96.37),(69.1,96.17),(68.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,96.17),(70.5,96.37),(70.7,96.37),(70.7,96.17),(70.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,96.17),(72.1,96.37),(72.3,96.37),(72.3,96.17),(72.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,96.17),(73.7,96.37),(73.9,96.37),(73.9,96.17),(73.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,96.17),(75.3,96.37),(75.5,96.37),(75.5,96.17),(75.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,96.17),(76.9,96.37),(77.1,96.37),(77.1,96.17),(76.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,96.17),(78.5,96.37),(78.7,96.37),(78.7,96.17),(78.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,96.17),(80.1,96.37),(80.3,96.37),(80.3,96.17),(80.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,96.17),(81.7,96.37),(81.9,96.37),(81.9,96.17),(81.7,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,96.17),(83.3,96.37),(83.5,96.37),(83.5,96.17),(83.3,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,96.17),(84.9,96.37),(85.1,96.37),(85.1,96.17),(84.9,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,96.17),(86.5,96.37),(86.7,96.37),(86.7,96.17),(86.5,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,96.17),(88.1,96.37),(88.3,96.37),(88.3,96.17),(88.1,96.17)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,97.77),(1.7,97.97),(1.9,97.97),(1.9,97.77),(1.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,97.77),(3.3,97.97),(3.5,97.97),(3.5,97.77),(3.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,97.77),(4.9,97.97),(5.1,97.97),(5.1,97.77),(4.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,97.77),(6.5,97.97),(6.7,97.97),(6.7,97.77),(6.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,97.77),(8.1,97.97),(8.3,97.97),(8.3,97.77),(8.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,97.77),(9.7,97.97),(9.9,97.97),(9.9,97.77),(9.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,97.77),(11.3,97.97),(11.5,97.97),(11.5,97.77),(11.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,97.77),(12.9,97.97),(13.1,97.97),(13.1,97.77),(12.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,97.77),(14.5,97.97),(14.7,97.97),(14.7,97.77),(14.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,97.77),(16.1,97.97),(16.3,97.97),(16.3,97.77),(16.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,97.77),(17.7,97.97),(17.9,97.97),(17.9,97.77),(17.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,97.77),(19.3,97.97),(19.5,97.97),(19.5,97.77),(19.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,97.77),(20.9,97.97),(21.1,97.97),(21.1,97.77),(20.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,97.77),(22.5,97.97),(22.7,97.97),(22.7,97.77),(22.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,97.77),(24.1,97.97),(24.3,97.97),(24.3,97.77),(24.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,97.77),(25.7,97.97),(25.9,97.97),(25.9,97.77),(25.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,97.77),(27.3,97.97),(27.5,97.97),(27.5,97.77),(27.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,97.77),(28.9,97.97),(29.1,97.97),(29.1,97.77),(28.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,97.77),(30.5,97.97),(30.7,97.97),(30.7,97.77),(30.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,97.77),(32.1,97.97),(32.3,97.97),(32.3,97.77),(32.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,97.77),(33.7,97.97),(33.9,97.97),(33.9,97.77),(33.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,97.77),(35.3,97.97),(35.5,97.97),(35.5,97.77),(35.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,97.77),(36.9,97.97),(37.1,97.97),(37.1,97.77),(36.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,97.77),(38.5,97.97),(38.7,97.97),(38.7,97.77),(38.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,97.77),(40.1,97.97),(40.3,97.97),(40.3,97.77),(40.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,97.77),(41.7,97.97),(41.9,97.97),(41.9,97.77),(41.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,97.77),(43.3,97.97),(43.5,97.97),(43.5,97.77),(43.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,97.77),(44.9,97.97),(45.1,97.97),(45.1,97.77),(44.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,97.77),(46.5,97.97),(46.7,97.97),(46.7,97.77),(46.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,97.77),(48.1,97.97),(48.3,97.97),(48.3,97.77),(48.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,97.77),(49.7,97.97),(49.9,97.97),(49.9,97.77),(49.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,97.77),(51.3,97.97),(51.5,97.97),(51.5,97.77),(51.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,97.77),(52.9,97.97),(53.1,97.97),(53.1,97.77),(52.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,97.77),(54.5,97.97),(54.7,97.97),(54.7,97.77),(54.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,97.77),(56.1,97.97),(56.3,97.97),(56.3,97.77),(56.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,97.77),(57.7,97.97),(57.9,97.97),(57.9,97.77),(57.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,97.77),(59.3,97.97),(59.5,97.97),(59.5,97.77),(59.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,97.77),(60.9,97.97),(61.1,97.97),(61.1,97.77),(60.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,97.77),(62.5,97.97),(62.7,97.97),(62.7,97.77),(62.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,97.77),(64.1,97.97),(64.3,97.97),(64.3,97.77),(64.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,97.77),(65.7,97.97),(65.9,97.97),(65.9,97.77),(65.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,97.77),(67.3,97.97),(67.5,97.97),(67.5,97.77),(67.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,97.77),(68.9,97.97),(69.1,97.97),(69.1,97.77),(68.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,97.77),(70.5,97.97),(70.7,97.97),(70.7,97.77),(70.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,97.77),(72.1,97.97),(72.3,97.97),(72.3,97.77),(72.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,97.77),(73.7,97.97),(73.9,97.97),(73.9,97.77),(73.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,97.77),(75.3,97.97),(75.5,97.97),(75.5,97.77),(75.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,97.77),(76.9,97.97),(77.1,97.97),(77.1,97.77),(76.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,97.77),(78.5,97.97),(78.7,97.97),(78.7,97.77),(78.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,97.77),(80.1,97.97),(80.3,97.97),(80.3,97.77),(80.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,97.77),(81.7,97.97),(81.9,97.97),(81.9,97.77),(81.7,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,97.77),(83.3,97.97),(83.5,97.97),(83.5,97.77),(83.3,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,97.77),(84.9,97.97),(85.1,97.97),(85.1,97.77),(84.9,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,97.77),(86.5,97.97),(86.7,97.97),(86.7,97.77),(86.5,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,97.77),(88.1,97.97),(88.3,97.97),(88.3,97.77),(88.1,97.77)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,99.37),(1.7,99.57),(1.9,99.57),(1.9,99.37),(1.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,99.37),(3.3,99.57),(3.5,99.57),(3.5,99.37),(3.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,99.37),(4.9,99.57),(5.1,99.57),(5.1,99.37),(4.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,99.37),(6.5,99.57),(6.7,99.57),(6.7,99.37),(6.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,99.37),(8.1,99.57),(8.3,99.57),(8.3,99.37),(8.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,99.37),(9.7,99.57),(9.9,99.57),(9.9,99.37),(9.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,99.37),(11.3,99.57),(11.5,99.57),(11.5,99.37),(11.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,99.37),(12.9,99.57),(13.1,99.57),(13.1,99.37),(12.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,99.37),(14.5,99.57),(14.7,99.57),(14.7,99.37),(14.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,99.37),(16.1,99.57),(16.3,99.57),(16.3,99.37),(16.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,99.37),(17.7,99.57),(17.9,99.57),(17.9,99.37),(17.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,99.37),(19.3,99.57),(19.5,99.57),(19.5,99.37),(19.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,99.37),(20.9,99.57),(21.1,99.57),(21.1,99.37),(20.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,99.37),(22.5,99.57),(22.7,99.57),(22.7,99.37),(22.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,99.37),(24.1,99.57),(24.3,99.57),(24.3,99.37),(24.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,99.37),(25.7,99.57),(25.9,99.57),(25.9,99.37),(25.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,99.37),(27.3,99.57),(27.5,99.57),(27.5,99.37),(27.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,99.37),(28.9,99.57),(29.1,99.57),(29.1,99.37),(28.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,99.37),(30.5,99.57),(30.7,99.57),(30.7,99.37),(30.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,99.37),(32.1,99.57),(32.3,99.57),(32.3,99.37),(32.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,99.37),(33.7,99.57),(33.9,99.57),(33.9,99.37),(33.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,99.37),(35.3,99.57),(35.5,99.57),(35.5,99.37),(35.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,99.37),(36.9,99.57),(37.1,99.57),(37.1,99.37),(36.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,99.37),(38.5,99.57),(38.7,99.57),(38.7,99.37),(38.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,99.37),(40.1,99.57),(40.3,99.57),(40.3,99.37),(40.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,99.37),(41.7,99.57),(41.9,99.57),(41.9,99.37),(41.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,99.37),(43.3,99.57),(43.5,99.57),(43.5,99.37),(43.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,99.37),(44.9,99.57),(45.1,99.57),(45.1,99.37),(44.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,99.37),(46.5,99.57),(46.7,99.57),(46.7,99.37),(46.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,99.37),(48.1,99.57),(48.3,99.57),(48.3,99.37),(48.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,99.37),(49.7,99.57),(49.9,99.57),(49.9,99.37),(49.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,99.37),(51.3,99.57),(51.5,99.57),(51.5,99.37),(51.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,99.37),(52.9,99.57),(53.1,99.57),(53.1,99.37),(52.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,99.37),(54.5,99.57),(54.7,99.57),(54.7,99.37),(54.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,99.37),(56.1,99.57),(56.3,99.57),(56.3,99.37),(56.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,99.37),(57.7,99.57),(57.9,99.57),(57.9,99.37),(57.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,99.37),(59.3,99.57),(59.5,99.57),(59.5,99.37),(59.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,99.37),(60.9,99.57),(61.1,99.57),(61.1,99.37),(60.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,99.37),(62.5,99.57),(62.7,99.57),(62.7,99.37),(62.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,99.37),(64.1,99.57),(64.3,99.57),(64.3,99.37),(64.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,99.37),(65.7,99.57),(65.9,99.57),(65.9,99.37),(65.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,99.37),(67.3,99.57),(67.5,99.57),(67.5,99.37),(67.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,99.37),(68.9,99.57),(69.1,99.57),(69.1,99.37),(68.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,99.37),(70.5,99.57),(70.7,99.57),(70.7,99.37),(70.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,99.37),(72.1,99.57),(72.3,99.57),(72.3,99.37),(72.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,99.37),(73.7,99.57),(73.9,99.57),(73.9,99.37),(73.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,99.37),(75.3,99.57),(75.5,99.57),(75.5,99.37),(75.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,99.37),(76.9,99.57),(77.1,99.57),(77.1,99.37),(76.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,99.37),(78.5,99.57),(78.7,99.57),(78.7,99.37),(78.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,99.37),(80.1,99.57),(80.3,99.57),(80.3,99.37),(80.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,99.37),(81.7,99.57),(81.9,99.57),(81.9,99.37),(81.7,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,99.37),(83.3,99.57),(83.5,99.57),(83.5,99.37),(83.3,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,99.37),(84.9,99.57),(85.1,99.57),(85.1,99.37),(84.9,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,99.37),(86.5,99.57),(86.7,99.57),(86.7,99.37),(86.5,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,99.37),(88.1,99.57),(88.3,99.57),(88.3,99.37),(88.1,99.37)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,100.97),(1.7,101.17),(1.9,101.17),(1.9,100.97),(1.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,100.97),(3.3,101.17),(3.5,101.17),(3.5,100.97),(3.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,100.97),(4.9,101.17),(5.1,101.17),(5.1,100.97),(4.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,100.97),(6.5,101.17),(6.7,101.17),(6.7,100.97),(6.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,100.97),(8.1,101.17),(8.3,101.17),(8.3,100.97),(8.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,100.97),(9.7,101.17),(9.9,101.17),(9.9,100.97),(9.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,100.97),(11.3,101.17),(11.5,101.17),(11.5,100.97),(11.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,100.97),(12.9,101.17),(13.1,101.17),(13.1,100.97),(12.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,100.97),(14.5,101.17),(14.7,101.17),(14.7,100.97),(14.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,100.97),(16.1,101.17),(16.3,101.17),(16.3,100.97),(16.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,100.97),(17.7,101.17),(17.9,101.17),(17.9,100.97),(17.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,100.97),(19.3,101.17),(19.5,101.17),(19.5,100.97),(19.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,100.97),(20.9,101.17),(21.1,101.17),(21.1,100.97),(20.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,100.97),(22.5,101.17),(22.7,101.17),(22.7,100.97),(22.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,100.97),(24.1,101.17),(24.3,101.17),(24.3,100.97),(24.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,100.97),(25.7,101.17),(25.9,101.17),(25.9,100.97),(25.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,100.97),(27.3,101.17),(27.5,101.17),(27.5,100.97),(27.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,100.97),(28.9,101.17),(29.1,101.17),(29.1,100.97),(28.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,100.97),(30.5,101.17),(30.7,101.17),(30.7,100.97),(30.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,100.97),(32.1,101.17),(32.3,101.17),(32.3,100.97),(32.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,100.97),(33.7,101.17),(33.9,101.17),(33.9,100.97),(33.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,100.97),(35.3,101.17),(35.5,101.17),(35.5,100.97),(35.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,100.97),(36.9,101.17),(37.1,101.17),(37.1,100.97),(36.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,100.97),(38.5,101.17),(38.7,101.17),(38.7,100.97),(38.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,100.97),(40.1,101.17),(40.3,101.17),(40.3,100.97),(40.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,100.97),(41.7,101.17),(41.9,101.17),(41.9,100.97),(41.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,100.97),(43.3,101.17),(43.5,101.17),(43.5,100.97),(43.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,100.97),(44.9,101.17),(45.1,101.17),(45.1,100.97),(44.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,100.97),(46.5,101.17),(46.7,101.17),(46.7,100.97),(46.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,100.97),(48.1,101.17),(48.3,101.17),(48.3,100.97),(48.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,100.97),(49.7,101.17),(49.9,101.17),(49.9,100.97),(49.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,100.97),(51.3,101.17),(51.5,101.17),(51.5,100.97),(51.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,100.97),(52.9,101.17),(53.1,101.17),(53.1,100.97),(52.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,100.97),(54.5,101.17),(54.7,101.17),(54.7,100.97),(54.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,100.97),(56.1,101.17),(56.3,101.17),(56.3,100.97),(56.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,100.97),(57.7,101.17),(57.9,101.17),(57.9,100.97),(57.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,100.97),(59.3,101.17),(59.5,101.17),(59.5,100.97),(59.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,100.97),(60.9,101.17),(61.1,101.17),(61.1,100.97),(60.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,100.97),(62.5,101.17),(62.7,101.17),(62.7,100.97),(62.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,100.97),(64.1,101.17),(64.3,101.17),(64.3,100.97),(64.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,100.97),(65.7,101.17),(65.9,101.17),(65.9,100.97),(65.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,100.97),(67.3,101.17),(67.5,101.17),(67.5,100.97),(67.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,100.97),(68.9,101.17),(69.1,101.17),(69.1,100.97),(68.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,100.97),(70.5,101.17),(70.7,101.17),(70.7,100.97),(70.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,100.97),(72.1,101.17),(72.3,101.17),(72.3,100.97),(72.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,100.97),(73.7,101.17),(73.9,101.17),(73.9,100.97),(73.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,100.97),(75.3,101.17),(75.5,101.17),(75.5,100.97),(75.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,100.97),(76.9,101.17),(77.1,101.17),(77.1,100.97),(76.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,100.97),(78.5,101.17),(78.7,101.17),(78.7,100.97),(78.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,100.97),(80.1,101.17),(80.3,101.17),(80.3,100.97),(80.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,100.97),(81.7,101.17),(81.9,101.17),(81.9,100.97),(81.7,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,100.97),(83.3,101.17),(83.5,101.17),(83.5,100.97),(83.3,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,100.97),(84.9,101.17),(85.1,101.17),(85.1,100.97),(84.9,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,100.97),(86.5,101.17),(86.7,101.17),(86.7,100.97),(86.5,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,100.97),(88.1,101.17),(88.3,101.17),(88.3,100.97),(88.1,100.97)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,121.27),(1.7,121.47),(1.9,121.47),(1.9,121.27),(1.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,121.27),(3.3,121.47),(3.5,121.47),(3.5,121.27),(3.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,121.27),(4.9,121.47),(5.1,121.47),(5.1,121.27),(4.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,121.27),(6.5,121.47),(6.7,121.47),(6.7,121.27),(6.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,121.27),(8.1,121.47),(8.3,121.47),(8.3,121.27),(8.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,121.27),(9.7,121.47),(9.9,121.47),(9.9,121.27),(9.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,121.27),(11.3,121.47),(11.5,121.47),(11.5,121.27),(11.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,121.27),(12.9,121.47),(13.1,121.47),(13.1,121.27),(12.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,121.27),(14.5,121.47),(14.7,121.47),(14.7,121.27),(14.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,121.27),(16.1,121.47),(16.3,121.47),(16.3,121.27),(16.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,121.27),(17.7,121.47),(17.9,121.47),(17.9,121.27),(17.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,121.27),(19.3,121.47),(19.5,121.47),(19.5,121.27),(19.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,121.27),(20.9,121.47),(21.1,121.47),(21.1,121.27),(20.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,121.27),(22.5,121.47),(22.7,121.47),(22.7,121.27),(22.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,121.27),(24.1,121.47),(24.3,121.47),(24.3,121.27),(24.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,121.27),(25.7,121.47),(25.9,121.47),(25.9,121.27),(25.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,121.27),(27.3,121.47),(27.5,121.47),(27.5,121.27),(27.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,121.27),(28.9,121.47),(29.1,121.47),(29.1,121.27),(28.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,121.27),(30.5,121.47),(30.7,121.47),(30.7,121.27),(30.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,121.27),(32.1,121.47),(32.3,121.47),(32.3,121.27),(32.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,121.27),(33.7,121.47),(33.9,121.47),(33.9,121.27),(33.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,121.27),(35.3,121.47),(35.5,121.47),(35.5,121.27),(35.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,121.27),(36.9,121.47),(37.1,121.47),(37.1,121.27),(36.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,121.27),(38.5,121.47),(38.7,121.47),(38.7,121.27),(38.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,121.27),(40.1,121.47),(40.3,121.47),(40.3,121.27),(40.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,121.27),(41.7,121.47),(41.9,121.47),(41.9,121.27),(41.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,121.27),(43.3,121.47),(43.5,121.47),(43.5,121.27),(43.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,121.27),(44.9,121.47),(45.1,121.47),(45.1,121.27),(44.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,121.27),(46.5,121.47),(46.7,121.47),(46.7,121.27),(46.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,121.27),(48.1,121.47),(48.3,121.47),(48.3,121.27),(48.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,121.27),(49.7,121.47),(49.9,121.47),(49.9,121.27),(49.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,121.27),(51.3,121.47),(51.5,121.47),(51.5,121.27),(51.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,121.27),(52.9,121.47),(53.1,121.47),(53.1,121.27),(52.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,121.27),(54.5,121.47),(54.7,121.47),(54.7,121.27),(54.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,121.27),(56.1,121.47),(56.3,121.47),(56.3,121.27),(56.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,121.27),(57.7,121.47),(57.9,121.47),(57.9,121.27),(57.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,121.27),(59.3,121.47),(59.5,121.47),(59.5,121.27),(59.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,121.27),(60.9,121.47),(61.1,121.47),(61.1,121.27),(60.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,121.27),(62.5,121.47),(62.7,121.47),(62.7,121.27),(62.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,121.27),(64.1,121.47),(64.3,121.47),(64.3,121.27),(64.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,121.27),(65.7,121.47),(65.9,121.47),(65.9,121.27),(65.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,121.27),(67.3,121.47),(67.5,121.47),(67.5,121.27),(67.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,121.27),(68.9,121.47),(69.1,121.47),(69.1,121.27),(68.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,121.27),(70.5,121.47),(70.7,121.47),(70.7,121.27),(70.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,121.27),(72.1,121.47),(72.3,121.47),(72.3,121.27),(72.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,121.27),(73.7,121.47),(73.9,121.47),(73.9,121.27),(73.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,121.27),(75.3,121.47),(75.5,121.47),(75.5,121.27),(75.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,121.27),(76.9,121.47),(77.1,121.47),(77.1,121.27),(76.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,121.27),(78.5,121.47),(78.7,121.47),(78.7,121.27),(78.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,121.27),(80.1,121.47),(80.3,121.47),(80.3,121.27),(80.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,121.27),(81.7,121.47),(81.9,121.47),(81.9,121.27),(81.7,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,121.27),(83.3,121.47),(83.5,121.47),(83.5,121.27),(83.3,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,121.27),(84.9,121.47),(85.1,121.47),(85.1,121.27),(84.9,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,121.27),(86.5,121.47),(86.7,121.47),(86.7,121.27),(86.5,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,121.27),(88.1,121.47),(88.3,121.47),(88.3,121.27),(88.1,121.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,122.87),(1.7,123.07),(1.9,123.07),(1.9,122.87),(1.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,122.87),(3.3,123.07),(3.5,123.07),(3.5,122.87),(3.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,122.87),(4.9,123.07),(5.1,123.07),(5.1,122.87),(4.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,122.87),(6.5,123.07),(6.7,123.07),(6.7,122.87),(6.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,122.87),(8.1,123.07),(8.3,123.07),(8.3,122.87),(8.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,122.87),(9.7,123.07),(9.9,123.07),(9.9,122.87),(9.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,122.87),(11.3,123.07),(11.5,123.07),(11.5,122.87),(11.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,122.87),(12.9,123.07),(13.1,123.07),(13.1,122.87),(12.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,122.87),(14.5,123.07),(14.7,123.07),(14.7,122.87),(14.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,122.87),(16.1,123.07),(16.3,123.07),(16.3,122.87),(16.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,122.87),(17.7,123.07),(17.9,123.07),(17.9,122.87),(17.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,122.87),(19.3,123.07),(19.5,123.07),(19.5,122.87),(19.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,122.87),(20.9,123.07),(21.1,123.07),(21.1,122.87),(20.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,122.87),(22.5,123.07),(22.7,123.07),(22.7,122.87),(22.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,122.87),(24.1,123.07),(24.3,123.07),(24.3,122.87),(24.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,122.87),(25.7,123.07),(25.9,123.07),(25.9,122.87),(25.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,122.87),(27.3,123.07),(27.5,123.07),(27.5,122.87),(27.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,122.87),(28.9,123.07),(29.1,123.07),(29.1,122.87),(28.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,122.87),(30.5,123.07),(30.7,123.07),(30.7,122.87),(30.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,122.87),(32.1,123.07),(32.3,123.07),(32.3,122.87),(32.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,122.87),(33.7,123.07),(33.9,123.07),(33.9,122.87),(33.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,122.87),(35.3,123.07),(35.5,123.07),(35.5,122.87),(35.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,122.87),(36.9,123.07),(37.1,123.07),(37.1,122.87),(36.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,122.87),(38.5,123.07),(38.7,123.07),(38.7,122.87),(38.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,122.87),(40.1,123.07),(40.3,123.07),(40.3,122.87),(40.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,122.87),(41.7,123.07),(41.9,123.07),(41.9,122.87),(41.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,122.87),(43.3,123.07),(43.5,123.07),(43.5,122.87),(43.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,122.87),(44.9,123.07),(45.1,123.07),(45.1,122.87),(44.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,122.87),(46.5,123.07),(46.7,123.07),(46.7,122.87),(46.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,122.87),(48.1,123.07),(48.3,123.07),(48.3,122.87),(48.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,122.87),(49.7,123.07),(49.9,123.07),(49.9,122.87),(49.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,122.87),(51.3,123.07),(51.5,123.07),(51.5,122.87),(51.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,122.87),(52.9,123.07),(53.1,123.07),(53.1,122.87),(52.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,122.87),(54.5,123.07),(54.7,123.07),(54.7,122.87),(54.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,122.87),(56.1,123.07),(56.3,123.07),(56.3,122.87),(56.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,122.87),(57.7,123.07),(57.9,123.07),(57.9,122.87),(57.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,122.87),(59.3,123.07),(59.5,123.07),(59.5,122.87),(59.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,122.87),(60.9,123.07),(61.1,123.07),(61.1,122.87),(60.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,122.87),(62.5,123.07),(62.7,123.07),(62.7,122.87),(62.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,122.87),(64.1,123.07),(64.3,123.07),(64.3,122.87),(64.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,122.87),(65.7,123.07),(65.9,123.07),(65.9,122.87),(65.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,122.87),(67.3,123.07),(67.5,123.07),(67.5,122.87),(67.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,122.87),(68.9,123.07),(69.1,123.07),(69.1,122.87),(68.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,122.87),(70.5,123.07),(70.7,123.07),(70.7,122.87),(70.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,122.87),(72.1,123.07),(72.3,123.07),(72.3,122.87),(72.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,122.87),(73.7,123.07),(73.9,123.07),(73.9,122.87),(73.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,122.87),(75.3,123.07),(75.5,123.07),(75.5,122.87),(75.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,122.87),(76.9,123.07),(77.1,123.07),(77.1,122.87),(76.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,122.87),(78.5,123.07),(78.7,123.07),(78.7,122.87),(78.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,122.87),(80.1,123.07),(80.3,123.07),(80.3,122.87),(80.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,122.87),(81.7,123.07),(81.9,123.07),(81.9,122.87),(81.7,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,122.87),(83.3,123.07),(83.5,123.07),(83.5,122.87),(83.3,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,122.87),(84.9,123.07),(85.1,123.07),(85.1,122.87),(84.9,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,122.87),(86.5,123.07),(86.7,123.07),(86.7,122.87),(86.5,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,122.87),(88.1,123.07),(88.3,123.07),(88.3,122.87),(88.1,122.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,124.47),(1.7,124.67),(1.9,124.67),(1.9,124.47),(1.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,124.47),(3.3,124.67),(3.5,124.67),(3.5,124.47),(3.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,124.47),(4.9,124.67),(5.1,124.67),(5.1,124.47),(4.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,124.47),(6.5,124.67),(6.7,124.67),(6.7,124.47),(6.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,124.47),(8.1,124.67),(8.3,124.67),(8.3,124.47),(8.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,124.47),(9.7,124.67),(9.9,124.67),(9.9,124.47),(9.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,124.47),(11.3,124.67),(11.5,124.67),(11.5,124.47),(11.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,124.47),(12.9,124.67),(13.1,124.67),(13.1,124.47),(12.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,124.47),(14.5,124.67),(14.7,124.67),(14.7,124.47),(14.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,124.47),(16.1,124.67),(16.3,124.67),(16.3,124.47),(16.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,124.47),(17.7,124.67),(17.9,124.67),(17.9,124.47),(17.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,124.47),(19.3,124.67),(19.5,124.67),(19.5,124.47),(19.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,124.47),(20.9,124.67),(21.1,124.67),(21.1,124.47),(20.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,124.47),(22.5,124.67),(22.7,124.67),(22.7,124.47),(22.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,124.47),(24.1,124.67),(24.3,124.67),(24.3,124.47),(24.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,124.47),(25.7,124.67),(25.9,124.67),(25.9,124.47),(25.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,124.47),(27.3,124.67),(27.5,124.67),(27.5,124.47),(27.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,124.47),(28.9,124.67),(29.1,124.67),(29.1,124.47),(28.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,124.47),(30.5,124.67),(30.7,124.67),(30.7,124.47),(30.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,124.47),(32.1,124.67),(32.3,124.67),(32.3,124.47),(32.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,124.47),(33.7,124.67),(33.9,124.67),(33.9,124.47),(33.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,124.47),(35.3,124.67),(35.5,124.67),(35.5,124.47),(35.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,124.47),(36.9,124.67),(37.1,124.67),(37.1,124.47),(36.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,124.47),(38.5,124.67),(38.7,124.67),(38.7,124.47),(38.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,124.47),(40.1,124.67),(40.3,124.67),(40.3,124.47),(40.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,124.47),(41.7,124.67),(41.9,124.67),(41.9,124.47),(41.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,124.47),(43.3,124.67),(43.5,124.67),(43.5,124.47),(43.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,124.47),(44.9,124.67),(45.1,124.67),(45.1,124.47),(44.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,124.47),(46.5,124.67),(46.7,124.67),(46.7,124.47),(46.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,124.47),(48.1,124.67),(48.3,124.67),(48.3,124.47),(48.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,124.47),(49.7,124.67),(49.9,124.67),(49.9,124.47),(49.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,124.47),(51.3,124.67),(51.5,124.67),(51.5,124.47),(51.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,124.47),(52.9,124.67),(53.1,124.67),(53.1,124.47),(52.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,124.47),(54.5,124.67),(54.7,124.67),(54.7,124.47),(54.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,124.47),(56.1,124.67),(56.3,124.67),(56.3,124.47),(56.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,124.47),(57.7,124.67),(57.9,124.67),(57.9,124.47),(57.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,124.47),(59.3,124.67),(59.5,124.67),(59.5,124.47),(59.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,124.47),(60.9,124.67),(61.1,124.67),(61.1,124.47),(60.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,124.47),(62.5,124.67),(62.7,124.67),(62.7,124.47),(62.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,124.47),(64.1,124.67),(64.3,124.67),(64.3,124.47),(64.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,124.47),(65.7,124.67),(65.9,124.67),(65.9,124.47),(65.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,124.47),(67.3,124.67),(67.5,124.67),(67.5,124.47),(67.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,124.47),(68.9,124.67),(69.1,124.67),(69.1,124.47),(68.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,124.47),(70.5,124.67),(70.7,124.67),(70.7,124.47),(70.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,124.47),(72.1,124.67),(72.3,124.67),(72.3,124.47),(72.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,124.47),(73.7,124.67),(73.9,124.67),(73.9,124.47),(73.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,124.47),(75.3,124.67),(75.5,124.67),(75.5,124.47),(75.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,124.47),(76.9,124.67),(77.1,124.67),(77.1,124.47),(76.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,124.47),(78.5,124.67),(78.7,124.67),(78.7,124.47),(78.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,124.47),(80.1,124.67),(80.3,124.67),(80.3,124.47),(80.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,124.47),(81.7,124.67),(81.9,124.67),(81.9,124.47),(81.7,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,124.47),(83.3,124.67),(83.5,124.67),(83.5,124.47),(83.3,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,124.47),(84.9,124.67),(85.1,124.67),(85.1,124.47),(84.9,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,124.47),(86.5,124.67),(86.7,124.67),(86.7,124.47),(86.5,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,124.47),(88.1,124.67),(88.3,124.67),(88.3,124.47),(88.1,124.47)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,126.07),(1.7,126.27),(1.9,126.27),(1.9,126.07),(1.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,126.07),(3.3,126.27),(3.5,126.27),(3.5,126.07),(3.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,126.07),(4.9,126.27),(5.1,126.27),(5.1,126.07),(4.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,126.07),(6.5,126.27),(6.7,126.27),(6.7,126.07),(6.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,126.07),(8.1,126.27),(8.3,126.27),(8.3,126.07),(8.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,126.07),(9.7,126.27),(9.9,126.27),(9.9,126.07),(9.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,126.07),(11.3,126.27),(11.5,126.27),(11.5,126.07),(11.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,126.07),(12.9,126.27),(13.1,126.27),(13.1,126.07),(12.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,126.07),(14.5,126.27),(14.7,126.27),(14.7,126.07),(14.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,126.07),(16.1,126.27),(16.3,126.27),(16.3,126.07),(16.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,126.07),(17.7,126.27),(17.9,126.27),(17.9,126.07),(17.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,126.07),(19.3,126.27),(19.5,126.27),(19.5,126.07),(19.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,126.07),(20.9,126.27),(21.1,126.27),(21.1,126.07),(20.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,126.07),(22.5,126.27),(22.7,126.27),(22.7,126.07),(22.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,126.07),(24.1,126.27),(24.3,126.27),(24.3,126.07),(24.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,126.07),(25.7,126.27),(25.9,126.27),(25.9,126.07),(25.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,126.07),(27.3,126.27),(27.5,126.27),(27.5,126.07),(27.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,126.07),(28.9,126.27),(29.1,126.27),(29.1,126.07),(28.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,126.07),(30.5,126.27),(30.7,126.27),(30.7,126.07),(30.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,126.07),(32.1,126.27),(32.3,126.27),(32.3,126.07),(32.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,126.07),(33.7,126.27),(33.9,126.27),(33.9,126.07),(33.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,126.07),(35.3,126.27),(35.5,126.27),(35.5,126.07),(35.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,126.07),(36.9,126.27),(37.1,126.27),(37.1,126.07),(36.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,126.07),(38.5,126.27),(38.7,126.27),(38.7,126.07),(38.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,126.07),(40.1,126.27),(40.3,126.27),(40.3,126.07),(40.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,126.07),(41.7,126.27),(41.9,126.27),(41.9,126.07),(41.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,126.07),(43.3,126.27),(43.5,126.27),(43.5,126.07),(43.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,126.07),(44.9,126.27),(45.1,126.27),(45.1,126.07),(44.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,126.07),(46.5,126.27),(46.7,126.27),(46.7,126.07),(46.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,126.07),(48.1,126.27),(48.3,126.27),(48.3,126.07),(48.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,126.07),(49.7,126.27),(49.9,126.27),(49.9,126.07),(49.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,126.07),(51.3,126.27),(51.5,126.27),(51.5,126.07),(51.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,126.07),(52.9,126.27),(53.1,126.27),(53.1,126.07),(52.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,126.07),(54.5,126.27),(54.7,126.27),(54.7,126.07),(54.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,126.07),(56.1,126.27),(56.3,126.27),(56.3,126.07),(56.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,126.07),(57.7,126.27),(57.9,126.27),(57.9,126.07),(57.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,126.07),(59.3,126.27),(59.5,126.27),(59.5,126.07),(59.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,126.07),(60.9,126.27),(61.1,126.27),(61.1,126.07),(60.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,126.07),(62.5,126.27),(62.7,126.27),(62.7,126.07),(62.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,126.07),(64.1,126.27),(64.3,126.27),(64.3,126.07),(64.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,126.07),(65.7,126.27),(65.9,126.27),(65.9,126.07),(65.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,126.07),(67.3,126.27),(67.5,126.27),(67.5,126.07),(67.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,126.07),(68.9,126.27),(69.1,126.27),(69.1,126.07),(68.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,126.07),(70.5,126.27),(70.7,126.27),(70.7,126.07),(70.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,126.07),(72.1,126.27),(72.3,126.27),(72.3,126.07),(72.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,126.07),(73.7,126.27),(73.9,126.27),(73.9,126.07),(73.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,126.07),(75.3,126.27),(75.5,126.27),(75.5,126.07),(75.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,126.07),(76.9,126.27),(77.1,126.27),(77.1,126.07),(76.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,126.07),(78.5,126.27),(78.7,126.27),(78.7,126.07),(78.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,126.07),(80.1,126.27),(80.3,126.27),(80.3,126.07),(80.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,126.07),(81.7,126.27),(81.9,126.27),(81.9,126.07),(81.7,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,126.07),(83.3,126.27),(83.5,126.27),(83.5,126.07),(83.3,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,126.07),(84.9,126.27),(85.1,126.27),(85.1,126.07),(84.9,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,126.07),(86.5,126.27),(86.7,126.27),(86.7,126.07),(86.5,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,126.07),(88.1,126.27),(88.3,126.27),(88.3,126.07),(88.1,126.07)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,127.67),(1.7,127.87),(1.9,127.87),(1.9,127.67),(1.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,127.67),(3.3,127.87),(3.5,127.87),(3.5,127.67),(3.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,127.67),(4.9,127.87),(5.1,127.87),(5.1,127.67),(4.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,127.67),(6.5,127.87),(6.7,127.87),(6.7,127.67),(6.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,127.67),(8.1,127.87),(8.3,127.87),(8.3,127.67),(8.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,127.67),(9.7,127.87),(9.9,127.87),(9.9,127.67),(9.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,127.67),(11.3,127.87),(11.5,127.87),(11.5,127.67),(11.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,127.67),(12.9,127.87),(13.1,127.87),(13.1,127.67),(12.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,127.67),(14.5,127.87),(14.7,127.87),(14.7,127.67),(14.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,127.67),(16.1,127.87),(16.3,127.87),(16.3,127.67),(16.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,127.67),(17.7,127.87),(17.9,127.87),(17.9,127.67),(17.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,127.67),(19.3,127.87),(19.5,127.87),(19.5,127.67),(19.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,127.67),(20.9,127.87),(21.1,127.87),(21.1,127.67),(20.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,127.67),(22.5,127.87),(22.7,127.87),(22.7,127.67),(22.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,127.67),(24.1,127.87),(24.3,127.87),(24.3,127.67),(24.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,127.67),(25.7,127.87),(25.9,127.87),(25.9,127.67),(25.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,127.67),(27.3,127.87),(27.5,127.87),(27.5,127.67),(27.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,127.67),(28.9,127.87),(29.1,127.87),(29.1,127.67),(28.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,127.67),(30.5,127.87),(30.7,127.87),(30.7,127.67),(30.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,127.67),(32.1,127.87),(32.3,127.87),(32.3,127.67),(32.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,127.67),(33.7,127.87),(33.9,127.87),(33.9,127.67),(33.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,127.67),(35.3,127.87),(35.5,127.87),(35.5,127.67),(35.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,127.67),(36.9,127.87),(37.1,127.87),(37.1,127.67),(36.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,127.67),(38.5,127.87),(38.7,127.87),(38.7,127.67),(38.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,127.67),(40.1,127.87),(40.3,127.87),(40.3,127.67),(40.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,127.67),(41.7,127.87),(41.9,127.87),(41.9,127.67),(41.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,127.67),(43.3,127.87),(43.5,127.87),(43.5,127.67),(43.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,127.67),(44.9,127.87),(45.1,127.87),(45.1,127.67),(44.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,127.67),(46.5,127.87),(46.7,127.87),(46.7,127.67),(46.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,127.67),(48.1,127.87),(48.3,127.87),(48.3,127.67),(48.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,127.67),(49.7,127.87),(49.9,127.87),(49.9,127.67),(49.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,127.67),(51.3,127.87),(51.5,127.87),(51.5,127.67),(51.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,127.67),(52.9,127.87),(53.1,127.87),(53.1,127.67),(52.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,127.67),(54.5,127.87),(54.7,127.87),(54.7,127.67),(54.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,127.67),(56.1,127.87),(56.3,127.87),(56.3,127.67),(56.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,127.67),(57.7,127.87),(57.9,127.87),(57.9,127.67),(57.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,127.67),(59.3,127.87),(59.5,127.87),(59.5,127.67),(59.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,127.67),(60.9,127.87),(61.1,127.87),(61.1,127.67),(60.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,127.67),(62.5,127.87),(62.7,127.87),(62.7,127.67),(62.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,127.67),(64.1,127.87),(64.3,127.87),(64.3,127.67),(64.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,127.67),(65.7,127.87),(65.9,127.87),(65.9,127.67),(65.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,127.67),(67.3,127.87),(67.5,127.87),(67.5,127.67),(67.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,127.67),(68.9,127.87),(69.1,127.87),(69.1,127.67),(68.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,127.67),(70.5,127.87),(70.7,127.87),(70.7,127.67),(70.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,127.67),(72.1,127.87),(72.3,127.87),(72.3,127.67),(72.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,127.67),(73.7,127.87),(73.9,127.87),(73.9,127.67),(73.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,127.67),(75.3,127.87),(75.5,127.87),(75.5,127.67),(75.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,127.67),(76.9,127.87),(77.1,127.87),(77.1,127.67),(76.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,127.67),(78.5,127.87),(78.7,127.87),(78.7,127.67),(78.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,127.67),(80.1,127.87),(80.3,127.87),(80.3,127.67),(80.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,127.67),(81.7,127.87),(81.9,127.87),(81.9,127.67),(81.7,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,127.67),(83.3,127.87),(83.5,127.87),(83.5,127.67),(83.3,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,127.67),(84.9,127.87),(85.1,127.87),(85.1,127.67),(84.9,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,127.67),(86.5,127.87),(86.7,127.87),(86.7,127.67),(86.5,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,127.67),(88.1,127.87),(88.3,127.87),(88.3,127.67),(88.1,127.67)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,129.27),(1.7,129.47),(1.9,129.47),(1.9,129.27),(1.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,129.27),(3.3,129.47),(3.5,129.47),(3.5,129.27),(3.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,129.27),(4.9,129.47),(5.1,129.47),(5.1,129.27),(4.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,129.27),(6.5,129.47),(6.7,129.47),(6.7,129.27),(6.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,129.27),(8.1,129.47),(8.3,129.47),(8.3,129.27),(8.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,129.27),(9.7,129.47),(9.9,129.47),(9.9,129.27),(9.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,129.27),(11.3,129.47),(11.5,129.47),(11.5,129.27),(11.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,129.27),(12.9,129.47),(13.1,129.47),(13.1,129.27),(12.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,129.27),(14.5,129.47),(14.7,129.47),(14.7,129.27),(14.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,129.27),(16.1,129.47),(16.3,129.47),(16.3,129.27),(16.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,129.27),(17.7,129.47),(17.9,129.47),(17.9,129.27),(17.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,129.27),(19.3,129.47),(19.5,129.47),(19.5,129.27),(19.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,129.27),(20.9,129.47),(21.1,129.47),(21.1,129.27),(20.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,129.27),(22.5,129.47),(22.7,129.47),(22.7,129.27),(22.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,129.27),(24.1,129.47),(24.3,129.47),(24.3,129.27),(24.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,129.27),(25.7,129.47),(25.9,129.47),(25.9,129.27),(25.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,129.27),(27.3,129.47),(27.5,129.47),(27.5,129.27),(27.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,129.27),(28.9,129.47),(29.1,129.47),(29.1,129.27),(28.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,129.27),(30.5,129.47),(30.7,129.47),(30.7,129.27),(30.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,129.27),(32.1,129.47),(32.3,129.47),(32.3,129.27),(32.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,129.27),(33.7,129.47),(33.9,129.47),(33.9,129.27),(33.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,129.27),(35.3,129.47),(35.5,129.47),(35.5,129.27),(35.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,129.27),(36.9,129.47),(37.1,129.47),(37.1,129.27),(36.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,129.27),(38.5,129.47),(38.7,129.47),(38.7,129.27),(38.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,129.27),(40.1,129.47),(40.3,129.47),(40.3,129.27),(40.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,129.27),(41.7,129.47),(41.9,129.47),(41.9,129.27),(41.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,129.27),(43.3,129.47),(43.5,129.47),(43.5,129.27),(43.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,129.27),(44.9,129.47),(45.1,129.47),(45.1,129.27),(44.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,129.27),(46.5,129.47),(46.7,129.47),(46.7,129.27),(46.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,129.27),(48.1,129.47),(48.3,129.47),(48.3,129.27),(48.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,129.27),(49.7,129.47),(49.9,129.47),(49.9,129.27),(49.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,129.27),(51.3,129.47),(51.5,129.47),(51.5,129.27),(51.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,129.27),(52.9,129.47),(53.1,129.47),(53.1,129.27),(52.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,129.27),(54.5,129.47),(54.7,129.47),(54.7,129.27),(54.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,129.27),(56.1,129.47),(56.3,129.47),(56.3,129.27),(56.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,129.27),(57.7,129.47),(57.9,129.47),(57.9,129.27),(57.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,129.27),(59.3,129.47),(59.5,129.47),(59.5,129.27),(59.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,129.27),(60.9,129.47),(61.1,129.47),(61.1,129.27),(60.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,129.27),(62.5,129.47),(62.7,129.47),(62.7,129.27),(62.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,129.27),(64.1,129.47),(64.3,129.47),(64.3,129.27),(64.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,129.27),(65.7,129.47),(65.9,129.47),(65.9,129.27),(65.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,129.27),(67.3,129.47),(67.5,129.47),(67.5,129.27),(67.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,129.27),(68.9,129.47),(69.1,129.47),(69.1,129.27),(68.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,129.27),(70.5,129.47),(70.7,129.47),(70.7,129.27),(70.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,129.27),(72.1,129.47),(72.3,129.47),(72.3,129.27),(72.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,129.27),(73.7,129.47),(73.9,129.47),(73.9,129.27),(73.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,129.27),(75.3,129.47),(75.5,129.47),(75.5,129.27),(75.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,129.27),(76.9,129.47),(77.1,129.47),(77.1,129.27),(76.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,129.27),(78.5,129.47),(78.7,129.47),(78.7,129.27),(78.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,129.27),(80.1,129.47),(80.3,129.47),(80.3,129.27),(80.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,129.27),(81.7,129.47),(81.9,129.47),(81.9,129.27),(81.7,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,129.27),(83.3,129.47),(83.5,129.47),(83.5,129.27),(83.3,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,129.27),(84.9,129.47),(85.1,129.47),(85.1,129.27),(84.9,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,129.27),(86.5,129.47),(86.7,129.47),(86.7,129.27),(86.5,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,129.27),(88.1,129.47),(88.3,129.47),(88.3,129.27),(88.1,129.27)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,130.87),(1.7,131.07),(1.9,131.07),(1.9,130.87),(1.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,130.87),(3.3,131.07),(3.5,131.07),(3.5,130.87),(3.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,130.87),(4.9,131.07),(5.1,131.07),(5.1,130.87),(4.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,130.87),(6.5,131.07),(6.7,131.07),(6.7,130.87),(6.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,130.87),(8.1,131.07),(8.3,131.07),(8.3,130.87),(8.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,130.87),(9.7,131.07),(9.9,131.07),(9.9,130.87),(9.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,130.87),(11.3,131.07),(11.5,131.07),(11.5,130.87),(11.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,130.87),(12.9,131.07),(13.1,131.07),(13.1,130.87),(12.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,130.87),(14.5,131.07),(14.7,131.07),(14.7,130.87),(14.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,130.87),(16.1,131.07),(16.3,131.07),(16.3,130.87),(16.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,130.87),(17.7,131.07),(17.9,131.07),(17.9,130.87),(17.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,130.87),(19.3,131.07),(19.5,131.07),(19.5,130.87),(19.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,130.87),(20.9,131.07),(21.1,131.07),(21.1,130.87),(20.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,130.87),(22.5,131.07),(22.7,131.07),(22.7,130.87),(22.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,130.87),(24.1,131.07),(24.3,131.07),(24.3,130.87),(24.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,130.87),(25.7,131.07),(25.9,131.07),(25.9,130.87),(25.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,130.87),(27.3,131.07),(27.5,131.07),(27.5,130.87),(27.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,130.87),(28.9,131.07),(29.1,131.07),(29.1,130.87),(28.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,130.87),(30.5,131.07),(30.7,131.07),(30.7,130.87),(30.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,130.87),(32.1,131.07),(32.3,131.07),(32.3,130.87),(32.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,130.87),(33.7,131.07),(33.9,131.07),(33.9,130.87),(33.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,130.87),(35.3,131.07),(35.5,131.07),(35.5,130.87),(35.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,130.87),(36.9,131.07),(37.1,131.07),(37.1,130.87),(36.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,130.87),(38.5,131.07),(38.7,131.07),(38.7,130.87),(38.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,130.87),(40.1,131.07),(40.3,131.07),(40.3,130.87),(40.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,130.87),(41.7,131.07),(41.9,131.07),(41.9,130.87),(41.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,130.87),(43.3,131.07),(43.5,131.07),(43.5,130.87),(43.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,130.87),(44.9,131.07),(45.1,131.07),(45.1,130.87),(44.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,130.87),(46.5,131.07),(46.7,131.07),(46.7,130.87),(46.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,130.87),(48.1,131.07),(48.3,131.07),(48.3,130.87),(48.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,130.87),(49.7,131.07),(49.9,131.07),(49.9,130.87),(49.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,130.87),(51.3,131.07),(51.5,131.07),(51.5,130.87),(51.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,130.87),(52.9,131.07),(53.1,131.07),(53.1,130.87),(52.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,130.87),(54.5,131.07),(54.7,131.07),(54.7,130.87),(54.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,130.87),(56.1,131.07),(56.3,131.07),(56.3,130.87),(56.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,130.87),(57.7,131.07),(57.9,131.07),(57.9,130.87),(57.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,130.87),(59.3,131.07),(59.5,131.07),(59.5,130.87),(59.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,130.87),(60.9,131.07),(61.1,131.07),(61.1,130.87),(60.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,130.87),(62.5,131.07),(62.7,131.07),(62.7,130.87),(62.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,130.87),(64.1,131.07),(64.3,131.07),(64.3,130.87),(64.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,130.87),(65.7,131.07),(65.9,131.07),(65.9,130.87),(65.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,130.87),(67.3,131.07),(67.5,131.07),(67.5,130.87),(67.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,130.87),(68.9,131.07),(69.1,131.07),(69.1,130.87),(68.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,130.87),(70.5,131.07),(70.7,131.07),(70.7,130.87),(70.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,130.87),(72.1,131.07),(72.3,131.07),(72.3,130.87),(72.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,130.87),(73.7,131.07),(73.9,131.07),(73.9,130.87),(73.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,130.87),(75.3,131.07),(75.5,131.07),(75.5,130.87),(75.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,130.87),(76.9,131.07),(77.1,131.07),(77.1,130.87),(76.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,130.87),(78.5,131.07),(78.7,131.07),(78.7,130.87),(78.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,130.87),(80.1,131.07),(80.3,131.07),(80.3,130.87),(80.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,130.87),(81.7,131.07),(81.9,131.07),(81.9,130.87),(81.7,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,130.87),(83.3,131.07),(83.5,131.07),(83.5,130.87),(83.3,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,130.87),(84.9,131.07),(85.1,131.07),(85.1,130.87),(84.9,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,130.87),(86.5,131.07),(86.7,131.07),(86.7,130.87),(86.5,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,130.87),(88.1,131.07),(88.3,131.07),(88.3,130.87),(88.1,130.87)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,106.31),(1.7,106.51),(1.9,106.51),(1.9,106.31),(1.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,106.31),(3.3,106.51),(3.5,106.51),(3.5,106.31),(3.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,106.31),(4.9,106.51),(5.1,106.51),(5.1,106.31),(4.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,106.31),(6.5,106.51),(6.7,106.51),(6.7,106.31),(6.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,106.31),(8.1,106.51),(8.3,106.51),(8.3,106.31),(8.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,106.31),(9.7,106.51),(9.9,106.51),(9.9,106.31),(9.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,106.31),(11.3,106.51),(11.5,106.51),(11.5,106.31),(11.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,106.31),(12.9,106.51),(13.1,106.51),(13.1,106.31),(12.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,106.31),(14.5,106.51),(14.7,106.51),(14.7,106.31),(14.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,106.31),(16.1,106.51),(16.3,106.51),(16.3,106.31),(16.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,106.31),(17.7,106.51),(17.9,106.51),(17.9,106.31),(17.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,106.31),(19.3,106.51),(19.5,106.51),(19.5,106.31),(19.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,106.31),(20.9,106.51),(21.1,106.51),(21.1,106.31),(20.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,106.31),(22.5,106.51),(22.7,106.51),(22.7,106.31),(22.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,106.31),(24.1,106.51),(24.3,106.51),(24.3,106.31),(24.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,106.31),(25.7,106.51),(25.9,106.51),(25.9,106.31),(25.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,106.31),(27.3,106.51),(27.5,106.51),(27.5,106.31),(27.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,106.31),(28.9,106.51),(29.1,106.51),(29.1,106.31),(28.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,106.31),(30.5,106.51),(30.7,106.51),(30.7,106.31),(30.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,106.31),(32.1,106.51),(32.3,106.51),(32.3,106.31),(32.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,106.31),(33.7,106.51),(33.9,106.51),(33.9,106.31),(33.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,106.31),(35.3,106.51),(35.5,106.51),(35.5,106.31),(35.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,106.31),(36.9,106.51),(37.1,106.51),(37.1,106.31),(36.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,106.31),(38.5,106.51),(38.7,106.51),(38.7,106.31),(38.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,106.31),(40.1,106.51),(40.3,106.51),(40.3,106.31),(40.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,106.31),(41.7,106.51),(41.9,106.51),(41.9,106.31),(41.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,106.31),(43.3,106.51),(43.5,106.51),(43.5,106.31),(43.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,106.31),(44.9,106.51),(45.1,106.51),(45.1,106.31),(44.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,106.31),(46.5,106.51),(46.7,106.51),(46.7,106.31),(46.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,106.31),(48.1,106.51),(48.3,106.51),(48.3,106.31),(48.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,106.31),(49.7,106.51),(49.9,106.51),(49.9,106.31),(49.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,106.31),(51.3,106.51),(51.5,106.51),(51.5,106.31),(51.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,106.31),(52.9,106.51),(53.1,106.51),(53.1,106.31),(52.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,106.31),(54.5,106.51),(54.7,106.51),(54.7,106.31),(54.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,106.31),(56.1,106.51),(56.3,106.51),(56.3,106.31),(56.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,106.31),(57.7,106.51),(57.9,106.51),(57.9,106.31),(57.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,106.31),(59.3,106.51),(59.5,106.51),(59.5,106.31),(59.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,106.31),(60.9,106.51),(61.1,106.51),(61.1,106.31),(60.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,106.31),(62.5,106.51),(62.7,106.51),(62.7,106.31),(62.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,106.31),(64.1,106.51),(64.3,106.51),(64.3,106.31),(64.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,106.31),(65.7,106.51),(65.9,106.51),(65.9,106.31),(65.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,106.31),(67.3,106.51),(67.5,106.51),(67.5,106.31),(67.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,106.31),(68.9,106.51),(69.1,106.51),(69.1,106.31),(68.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,106.31),(70.5,106.51),(70.7,106.51),(70.7,106.31),(70.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,106.31),(72.1,106.51),(72.3,106.51),(72.3,106.31),(72.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,106.31),(73.7,106.51),(73.9,106.51),(73.9,106.31),(73.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,106.31),(75.3,106.51),(75.5,106.51),(75.5,106.31),(75.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,106.31),(76.9,106.51),(77.1,106.51),(77.1,106.31),(76.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,106.31),(78.5,106.51),(78.7,106.51),(78.7,106.31),(78.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,106.31),(80.1,106.51),(80.3,106.51),(80.3,106.31),(80.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,106.31),(81.7,106.51),(81.9,106.51),(81.9,106.31),(81.7,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,106.31),(83.3,106.51),(83.5,106.51),(83.5,106.31),(83.3,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,106.31),(84.9,106.51),(85.1,106.51),(85.1,106.31),(84.9,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,106.31),(86.5,106.51),(86.7,106.51),(86.7,106.31),(86.5,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,106.31),(88.1,106.51),(88.3,106.51),(88.3,106.31),(88.1,106.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,107.91),(1.7,108.11),(1.9,108.11),(1.9,107.91),(1.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,107.91),(3.3,108.11),(3.5,108.11),(3.5,107.91),(3.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,107.91),(4.9,108.11),(5.1,108.11),(5.1,107.91),(4.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,107.91),(6.5,108.11),(6.7,108.11),(6.7,107.91),(6.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,107.91),(8.1,108.11),(8.3,108.11),(8.3,107.91),(8.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,107.91),(9.7,108.11),(9.9,108.11),(9.9,107.91),(9.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,107.91),(11.3,108.11),(11.5,108.11),(11.5,107.91),(11.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,107.91),(12.9,108.11),(13.1,108.11),(13.1,107.91),(12.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,107.91),(14.5,108.11),(14.7,108.11),(14.7,107.91),(14.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,107.91),(16.1,108.11),(16.3,108.11),(16.3,107.91),(16.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,107.91),(17.7,108.11),(17.9,108.11),(17.9,107.91),(17.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,107.91),(19.3,108.11),(19.5,108.11),(19.5,107.91),(19.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,107.91),(20.9,108.11),(21.1,108.11),(21.1,107.91),(20.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,107.91),(22.5,108.11),(22.7,108.11),(22.7,107.91),(22.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,107.91),(24.1,108.11),(24.3,108.11),(24.3,107.91),(24.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,107.91),(25.7,108.11),(25.9,108.11),(25.9,107.91),(25.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,107.91),(27.3,108.11),(27.5,108.11),(27.5,107.91),(27.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,107.91),(28.9,108.11),(29.1,108.11),(29.1,107.91),(28.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,107.91),(30.5,108.11),(30.7,108.11),(30.7,107.91),(30.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,107.91),(32.1,108.11),(32.3,108.11),(32.3,107.91),(32.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,107.91),(33.7,108.11),(33.9,108.11),(33.9,107.91),(33.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,107.91),(35.3,108.11),(35.5,108.11),(35.5,107.91),(35.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,107.91),(36.9,108.11),(37.1,108.11),(37.1,107.91),(36.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,107.91),(38.5,108.11),(38.7,108.11),(38.7,107.91),(38.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,107.91),(40.1,108.11),(40.3,108.11),(40.3,107.91),(40.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,107.91),(41.7,108.11),(41.9,108.11),(41.9,107.91),(41.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,107.91),(43.3,108.11),(43.5,108.11),(43.5,107.91),(43.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,107.91),(44.9,108.11),(45.1,108.11),(45.1,107.91),(44.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,107.91),(46.5,108.11),(46.7,108.11),(46.7,107.91),(46.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,107.91),(48.1,108.11),(48.3,108.11),(48.3,107.91),(48.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,107.91),(49.7,108.11),(49.9,108.11),(49.9,107.91),(49.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,107.91),(51.3,108.11),(51.5,108.11),(51.5,107.91),(51.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,107.91),(52.9,108.11),(53.1,108.11),(53.1,107.91),(52.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,107.91),(54.5,108.11),(54.7,108.11),(54.7,107.91),(54.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,107.91),(56.1,108.11),(56.3,108.11),(56.3,107.91),(56.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,107.91),(57.7,108.11),(57.9,108.11),(57.9,107.91),(57.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,107.91),(59.3,108.11),(59.5,108.11),(59.5,107.91),(59.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,107.91),(60.9,108.11),(61.1,108.11),(61.1,107.91),(60.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,107.91),(62.5,108.11),(62.7,108.11),(62.7,107.91),(62.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,107.91),(64.1,108.11),(64.3,108.11),(64.3,107.91),(64.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,107.91),(65.7,108.11),(65.9,108.11),(65.9,107.91),(65.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,107.91),(67.3,108.11),(67.5,108.11),(67.5,107.91),(67.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,107.91),(68.9,108.11),(69.1,108.11),(69.1,107.91),(68.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,107.91),(70.5,108.11),(70.7,108.11),(70.7,107.91),(70.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,107.91),(72.1,108.11),(72.3,108.11),(72.3,107.91),(72.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,107.91),(73.7,108.11),(73.9,108.11),(73.9,107.91),(73.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,107.91),(75.3,108.11),(75.5,108.11),(75.5,107.91),(75.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,107.91),(76.9,108.11),(77.1,108.11),(77.1,107.91),(76.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,107.91),(78.5,108.11),(78.7,108.11),(78.7,107.91),(78.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,107.91),(80.1,108.11),(80.3,108.11),(80.3,107.91),(80.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,107.91),(81.7,108.11),(81.9,108.11),(81.9,107.91),(81.7,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,107.91),(83.3,108.11),(83.5,108.11),(83.5,107.91),(83.3,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,107.91),(84.9,108.11),(85.1,108.11),(85.1,107.91),(84.9,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,107.91),(86.5,108.11),(86.7,108.11),(86.7,107.91),(86.5,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,107.91),(88.1,108.11),(88.3,108.11),(88.3,107.91),(88.1,107.91)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,109.51),(1.7,109.71),(1.9,109.71),(1.9,109.51),(1.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,109.51),(3.3,109.71),(3.5,109.71),(3.5,109.51),(3.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,109.51),(4.9,109.71),(5.1,109.71),(5.1,109.51),(4.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,109.51),(6.5,109.71),(6.7,109.71),(6.7,109.51),(6.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,109.51),(8.1,109.71),(8.3,109.71),(8.3,109.51),(8.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,109.51),(9.7,109.71),(9.9,109.71),(9.9,109.51),(9.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,109.51),(11.3,109.71),(11.5,109.71),(11.5,109.51),(11.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,109.51),(12.9,109.71),(13.1,109.71),(13.1,109.51),(12.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,109.51),(14.5,109.71),(14.7,109.71),(14.7,109.51),(14.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,109.51),(16.1,109.71),(16.3,109.71),(16.3,109.51),(16.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,109.51),(17.7,109.71),(17.9,109.71),(17.9,109.51),(17.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,109.51),(19.3,109.71),(19.5,109.71),(19.5,109.51),(19.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,109.51),(20.9,109.71),(21.1,109.71),(21.1,109.51),(20.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,109.51),(22.5,109.71),(22.7,109.71),(22.7,109.51),(22.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,109.51),(24.1,109.71),(24.3,109.71),(24.3,109.51),(24.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,109.51),(25.7,109.71),(25.9,109.71),(25.9,109.51),(25.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,109.51),(27.3,109.71),(27.5,109.71),(27.5,109.51),(27.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,109.51),(28.9,109.71),(29.1,109.71),(29.1,109.51),(28.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,109.51),(30.5,109.71),(30.7,109.71),(30.7,109.51),(30.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,109.51),(32.1,109.71),(32.3,109.71),(32.3,109.51),(32.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,109.51),(33.7,109.71),(33.9,109.71),(33.9,109.51),(33.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,109.51),(35.3,109.71),(35.5,109.71),(35.5,109.51),(35.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,109.51),(36.9,109.71),(37.1,109.71),(37.1,109.51),(36.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,109.51),(38.5,109.71),(38.7,109.71),(38.7,109.51),(38.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,109.51),(40.1,109.71),(40.3,109.71),(40.3,109.51),(40.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,109.51),(41.7,109.71),(41.9,109.71),(41.9,109.51),(41.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,109.51),(43.3,109.71),(43.5,109.71),(43.5,109.51),(43.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,109.51),(44.9,109.71),(45.1,109.71),(45.1,109.51),(44.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,109.51),(46.5,109.71),(46.7,109.71),(46.7,109.51),(46.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,109.51),(48.1,109.71),(48.3,109.71),(48.3,109.51),(48.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,109.51),(49.7,109.71),(49.9,109.71),(49.9,109.51),(49.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,109.51),(51.3,109.71),(51.5,109.71),(51.5,109.51),(51.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,109.51),(52.9,109.71),(53.1,109.71),(53.1,109.51),(52.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,109.51),(54.5,109.71),(54.7,109.71),(54.7,109.51),(54.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,109.51),(56.1,109.71),(56.3,109.71),(56.3,109.51),(56.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,109.51),(57.7,109.71),(57.9,109.71),(57.9,109.51),(57.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,109.51),(59.3,109.71),(59.5,109.71),(59.5,109.51),(59.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,109.51),(60.9,109.71),(61.1,109.71),(61.1,109.51),(60.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,109.51),(62.5,109.71),(62.7,109.71),(62.7,109.51),(62.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,109.51),(64.1,109.71),(64.3,109.71),(64.3,109.51),(64.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,109.51),(65.7,109.71),(65.9,109.71),(65.9,109.51),(65.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,109.51),(67.3,109.71),(67.5,109.71),(67.5,109.51),(67.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,109.51),(68.9,109.71),(69.1,109.71),(69.1,109.51),(68.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,109.51),(70.5,109.71),(70.7,109.71),(70.7,109.51),(70.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,109.51),(72.1,109.71),(72.3,109.71),(72.3,109.51),(72.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,109.51),(73.7,109.71),(73.9,109.71),(73.9,109.51),(73.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,109.51),(75.3,109.71),(75.5,109.71),(75.5,109.51),(75.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,109.51),(76.9,109.71),(77.1,109.71),(77.1,109.51),(76.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,109.51),(78.5,109.71),(78.7,109.71),(78.7,109.51),(78.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,109.51),(80.1,109.71),(80.3,109.71),(80.3,109.51),(80.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,109.51),(81.7,109.71),(81.9,109.71),(81.9,109.51),(81.7,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,109.51),(83.3,109.71),(83.5,109.71),(83.5,109.51),(83.3,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,109.51),(84.9,109.71),(85.1,109.71),(85.1,109.51),(84.9,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,109.51),(86.5,109.71),(86.7,109.71),(86.7,109.51),(86.5,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,109.51),(88.1,109.71),(88.3,109.71),(88.3,109.51),(88.1,109.51)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,111.11),(1.7,111.31),(1.9,111.31),(1.9,111.11),(1.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,111.11),(3.3,111.31),(3.5,111.31),(3.5,111.11),(3.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,111.11),(4.9,111.31),(5.1,111.31),(5.1,111.11),(4.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,111.11),(6.5,111.31),(6.7,111.31),(6.7,111.11),(6.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,111.11),(8.1,111.31),(8.3,111.31),(8.3,111.11),(8.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,111.11),(9.7,111.31),(9.9,111.31),(9.9,111.11),(9.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,111.11),(11.3,111.31),(11.5,111.31),(11.5,111.11),(11.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,111.11),(12.9,111.31),(13.1,111.31),(13.1,111.11),(12.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,111.11),(14.5,111.31),(14.7,111.31),(14.7,111.11),(14.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,111.11),(16.1,111.31),(16.3,111.31),(16.3,111.11),(16.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,111.11),(17.7,111.31),(17.9,111.31),(17.9,111.11),(17.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,111.11),(19.3,111.31),(19.5,111.31),(19.5,111.11),(19.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,111.11),(20.9,111.31),(21.1,111.31),(21.1,111.11),(20.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,111.11),(22.5,111.31),(22.7,111.31),(22.7,111.11),(22.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,111.11),(24.1,111.31),(24.3,111.31),(24.3,111.11),(24.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,111.11),(25.7,111.31),(25.9,111.31),(25.9,111.11),(25.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,111.11),(27.3,111.31),(27.5,111.31),(27.5,111.11),(27.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,111.11),(28.9,111.31),(29.1,111.31),(29.1,111.11),(28.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,111.11),(30.5,111.31),(30.7,111.31),(30.7,111.11),(30.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,111.11),(32.1,111.31),(32.3,111.31),(32.3,111.11),(32.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,111.11),(33.7,111.31),(33.9,111.31),(33.9,111.11),(33.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,111.11),(35.3,111.31),(35.5,111.31),(35.5,111.11),(35.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,111.11),(36.9,111.31),(37.1,111.31),(37.1,111.11),(36.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,111.11),(38.5,111.31),(38.7,111.31),(38.7,111.11),(38.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,111.11),(40.1,111.31),(40.3,111.31),(40.3,111.11),(40.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,111.11),(41.7,111.31),(41.9,111.31),(41.9,111.11),(41.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,111.11),(43.3,111.31),(43.5,111.31),(43.5,111.11),(43.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,111.11),(44.9,111.31),(45.1,111.31),(45.1,111.11),(44.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,111.11),(46.5,111.31),(46.7,111.31),(46.7,111.11),(46.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,111.11),(48.1,111.31),(48.3,111.31),(48.3,111.11),(48.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,111.11),(49.7,111.31),(49.9,111.31),(49.9,111.11),(49.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,111.11),(51.3,111.31),(51.5,111.31),(51.5,111.11),(51.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,111.11),(52.9,111.31),(53.1,111.31),(53.1,111.11),(52.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,111.11),(54.5,111.31),(54.7,111.31),(54.7,111.11),(54.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,111.11),(56.1,111.31),(56.3,111.31),(56.3,111.11),(56.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,111.11),(57.7,111.31),(57.9,111.31),(57.9,111.11),(57.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,111.11),(59.3,111.31),(59.5,111.31),(59.5,111.11),(59.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,111.11),(60.9,111.31),(61.1,111.31),(61.1,111.11),(60.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,111.11),(62.5,111.31),(62.7,111.31),(62.7,111.11),(62.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,111.11),(64.1,111.31),(64.3,111.31),(64.3,111.11),(64.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,111.11),(65.7,111.31),(65.9,111.31),(65.9,111.11),(65.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,111.11),(67.3,111.31),(67.5,111.31),(67.5,111.11),(67.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,111.11),(68.9,111.31),(69.1,111.31),(69.1,111.11),(68.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,111.11),(70.5,111.31),(70.7,111.31),(70.7,111.11),(70.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,111.11),(72.1,111.31),(72.3,111.31),(72.3,111.11),(72.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,111.11),(73.7,111.31),(73.9,111.31),(73.9,111.11),(73.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,111.11),(75.3,111.31),(75.5,111.31),(75.5,111.11),(75.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,111.11),(76.9,111.31),(77.1,111.31),(77.1,111.11),(76.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,111.11),(78.5,111.31),(78.7,111.31),(78.7,111.11),(78.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,111.11),(80.1,111.31),(80.3,111.31),(80.3,111.11),(80.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,111.11),(81.7,111.31),(81.9,111.31),(81.9,111.11),(81.7,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,111.11),(83.3,111.31),(83.5,111.31),(83.5,111.11),(83.3,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,111.11),(84.9,111.31),(85.1,111.31),(85.1,111.11),(84.9,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,111.11),(86.5,111.31),(86.7,111.31),(86.7,111.11),(86.5,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,111.11),(88.1,111.31),(88.3,111.31),(88.3,111.11),(88.1,111.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,112.71),(1.7,112.91),(1.9,112.91),(1.9,112.71),(1.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,112.71),(3.3,112.91),(3.5,112.91),(3.5,112.71),(3.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,112.71),(4.9,112.91),(5.1,112.91),(5.1,112.71),(4.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,112.71),(6.5,112.91),(6.7,112.91),(6.7,112.71),(6.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,112.71),(8.1,112.91),(8.3,112.91),(8.3,112.71),(8.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,112.71),(9.7,112.91),(9.9,112.91),(9.9,112.71),(9.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,112.71),(11.3,112.91),(11.5,112.91),(11.5,112.71),(11.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,112.71),(12.9,112.91),(13.1,112.91),(13.1,112.71),(12.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,112.71),(14.5,112.91),(14.7,112.91),(14.7,112.71),(14.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,112.71),(16.1,112.91),(16.3,112.91),(16.3,112.71),(16.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,112.71),(17.7,112.91),(17.9,112.91),(17.9,112.71),(17.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,112.71),(19.3,112.91),(19.5,112.91),(19.5,112.71),(19.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,112.71),(20.9,112.91),(21.1,112.91),(21.1,112.71),(20.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,112.71),(22.5,112.91),(22.7,112.91),(22.7,112.71),(22.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,112.71),(24.1,112.91),(24.3,112.91),(24.3,112.71),(24.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,112.71),(25.7,112.91),(25.9,112.91),(25.9,112.71),(25.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,112.71),(27.3,112.91),(27.5,112.91),(27.5,112.71),(27.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,112.71),(28.9,112.91),(29.1,112.91),(29.1,112.71),(28.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,112.71),(30.5,112.91),(30.7,112.91),(30.7,112.71),(30.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,112.71),(32.1,112.91),(32.3,112.91),(32.3,112.71),(32.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,112.71),(33.7,112.91),(33.9,112.91),(33.9,112.71),(33.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,112.71),(35.3,112.91),(35.5,112.91),(35.5,112.71),(35.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,112.71),(36.9,112.91),(37.1,112.91),(37.1,112.71),(36.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,112.71),(38.5,112.91),(38.7,112.91),(38.7,112.71),(38.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,112.71),(40.1,112.91),(40.3,112.91),(40.3,112.71),(40.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,112.71),(41.7,112.91),(41.9,112.91),(41.9,112.71),(41.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,112.71),(43.3,112.91),(43.5,112.91),(43.5,112.71),(43.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,112.71),(44.9,112.91),(45.1,112.91),(45.1,112.71),(44.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,112.71),(46.5,112.91),(46.7,112.91),(46.7,112.71),(46.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,112.71),(48.1,112.91),(48.3,112.91),(48.3,112.71),(48.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,112.71),(49.7,112.91),(49.9,112.91),(49.9,112.71),(49.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,112.71),(51.3,112.91),(51.5,112.91),(51.5,112.71),(51.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,112.71),(52.9,112.91),(53.1,112.91),(53.1,112.71),(52.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,112.71),(54.5,112.91),(54.7,112.91),(54.7,112.71),(54.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,112.71),(56.1,112.91),(56.3,112.91),(56.3,112.71),(56.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,112.71),(57.7,112.91),(57.9,112.91),(57.9,112.71),(57.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,112.71),(59.3,112.91),(59.5,112.91),(59.5,112.71),(59.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,112.71),(60.9,112.91),(61.1,112.91),(61.1,112.71),(60.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,112.71),(62.5,112.91),(62.7,112.91),(62.7,112.71),(62.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,112.71),(64.1,112.91),(64.3,112.91),(64.3,112.71),(64.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,112.71),(65.7,112.91),(65.9,112.91),(65.9,112.71),(65.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,112.71),(67.3,112.91),(67.5,112.91),(67.5,112.71),(67.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,112.71),(68.9,112.91),(69.1,112.91),(69.1,112.71),(68.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,112.71),(70.5,112.91),(70.7,112.91),(70.7,112.71),(70.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,112.71),(72.1,112.91),(72.3,112.91),(72.3,112.71),(72.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,112.71),(73.7,112.91),(73.9,112.91),(73.9,112.71),(73.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,112.71),(75.3,112.91),(75.5,112.91),(75.5,112.71),(75.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,112.71),(76.9,112.91),(77.1,112.91),(77.1,112.71),(76.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,112.71),(78.5,112.91),(78.7,112.91),(78.7,112.71),(78.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,112.71),(80.1,112.91),(80.3,112.91),(80.3,112.71),(80.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,112.71),(81.7,112.91),(81.9,112.91),(81.9,112.71),(81.7,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,112.71),(83.3,112.91),(83.5,112.91),(83.5,112.71),(83.3,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,112.71),(84.9,112.91),(85.1,112.91),(85.1,112.71),(84.9,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,112.71),(86.5,112.91),(86.7,112.91),(86.7,112.71),(86.5,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,112.71),(88.1,112.91),(88.3,112.91),(88.3,112.71),(88.1,112.71)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,114.31),(1.7,114.51),(1.9,114.51),(1.9,114.31),(1.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,114.31),(3.3,114.51),(3.5,114.51),(3.5,114.31),(3.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,114.31),(4.9,114.51),(5.1,114.51),(5.1,114.31),(4.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,114.31),(6.5,114.51),(6.7,114.51),(6.7,114.31),(6.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,114.31),(8.1,114.51),(8.3,114.51),(8.3,114.31),(8.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,114.31),(9.7,114.51),(9.9,114.51),(9.9,114.31),(9.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,114.31),(11.3,114.51),(11.5,114.51),(11.5,114.31),(11.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,114.31),(12.9,114.51),(13.1,114.51),(13.1,114.31),(12.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,114.31),(14.5,114.51),(14.7,114.51),(14.7,114.31),(14.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,114.31),(16.1,114.51),(16.3,114.51),(16.3,114.31),(16.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,114.31),(17.7,114.51),(17.9,114.51),(17.9,114.31),(17.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,114.31),(19.3,114.51),(19.5,114.51),(19.5,114.31),(19.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,114.31),(20.9,114.51),(21.1,114.51),(21.1,114.31),(20.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,114.31),(22.5,114.51),(22.7,114.51),(22.7,114.31),(22.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,114.31),(24.1,114.51),(24.3,114.51),(24.3,114.31),(24.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,114.31),(25.7,114.51),(25.9,114.51),(25.9,114.31),(25.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,114.31),(27.3,114.51),(27.5,114.51),(27.5,114.31),(27.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,114.31),(28.9,114.51),(29.1,114.51),(29.1,114.31),(28.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,114.31),(30.5,114.51),(30.7,114.51),(30.7,114.31),(30.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,114.31),(32.1,114.51),(32.3,114.51),(32.3,114.31),(32.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,114.31),(33.7,114.51),(33.9,114.51),(33.9,114.31),(33.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,114.31),(35.3,114.51),(35.5,114.51),(35.5,114.31),(35.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,114.31),(36.9,114.51),(37.1,114.51),(37.1,114.31),(36.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,114.31),(38.5,114.51),(38.7,114.51),(38.7,114.31),(38.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,114.31),(40.1,114.51),(40.3,114.51),(40.3,114.31),(40.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,114.31),(41.7,114.51),(41.9,114.51),(41.9,114.31),(41.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,114.31),(43.3,114.51),(43.5,114.51),(43.5,114.31),(43.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,114.31),(44.9,114.51),(45.1,114.51),(45.1,114.31),(44.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,114.31),(46.5,114.51),(46.7,114.51),(46.7,114.31),(46.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,114.31),(48.1,114.51),(48.3,114.51),(48.3,114.31),(48.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,114.31),(49.7,114.51),(49.9,114.51),(49.9,114.31),(49.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,114.31),(51.3,114.51),(51.5,114.51),(51.5,114.31),(51.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,114.31),(52.9,114.51),(53.1,114.51),(53.1,114.31),(52.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,114.31),(54.5,114.51),(54.7,114.51),(54.7,114.31),(54.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,114.31),(56.1,114.51),(56.3,114.51),(56.3,114.31),(56.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,114.31),(57.7,114.51),(57.9,114.51),(57.9,114.31),(57.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,114.31),(59.3,114.51),(59.5,114.51),(59.5,114.31),(59.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,114.31),(60.9,114.51),(61.1,114.51),(61.1,114.31),(60.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,114.31),(62.5,114.51),(62.7,114.51),(62.7,114.31),(62.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,114.31),(64.1,114.51),(64.3,114.51),(64.3,114.31),(64.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,114.31),(65.7,114.51),(65.9,114.51),(65.9,114.31),(65.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,114.31),(67.3,114.51),(67.5,114.51),(67.5,114.31),(67.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,114.31),(68.9,114.51),(69.1,114.51),(69.1,114.31),(68.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,114.31),(70.5,114.51),(70.7,114.51),(70.7,114.31),(70.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,114.31),(72.1,114.51),(72.3,114.51),(72.3,114.31),(72.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,114.31),(73.7,114.51),(73.9,114.51),(73.9,114.31),(73.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,114.31),(75.3,114.51),(75.5,114.51),(75.5,114.31),(75.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,114.31),(76.9,114.51),(77.1,114.51),(77.1,114.31),(76.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,114.31),(78.5,114.51),(78.7,114.51),(78.7,114.31),(78.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,114.31),(80.1,114.51),(80.3,114.51),(80.3,114.31),(80.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,114.31),(81.7,114.51),(81.9,114.51),(81.9,114.31),(81.7,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,114.31),(83.3,114.51),(83.5,114.51),(83.5,114.31),(83.3,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,114.31),(84.9,114.51),(85.1,114.51),(85.1,114.31),(84.9,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,114.31),(86.5,114.51),(86.7,114.51),(86.7,114.31),(86.5,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,114.31),(88.1,114.51),(88.3,114.51),(88.3,114.31),(88.1,114.31)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,115.91),(1.7,116.11),(1.9,116.11),(1.9,115.91),(1.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,115.91),(3.3,116.11),(3.5,116.11),(3.5,115.91),(3.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,115.91),(4.9,116.11),(5.1,116.11),(5.1,115.91),(4.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,115.91),(6.5,116.11),(6.7,116.11),(6.7,115.91),(6.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,115.91),(8.1,116.11),(8.3,116.11),(8.3,115.91),(8.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,115.91),(9.7,116.11),(9.9,116.11),(9.9,115.91),(9.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,115.91),(11.3,116.11),(11.5,116.11),(11.5,115.91),(11.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,115.91),(12.9,116.11),(13.1,116.11),(13.1,115.91),(12.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,115.91),(14.5,116.11),(14.7,116.11),(14.7,115.91),(14.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,115.91),(16.1,116.11),(16.3,116.11),(16.3,115.91),(16.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,115.91),(17.7,116.11),(17.9,116.11),(17.9,115.91),(17.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,115.91),(19.3,116.11),(19.5,116.11),(19.5,115.91),(19.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,115.91),(20.9,116.11),(21.1,116.11),(21.1,115.91),(20.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,115.91),(22.5,116.11),(22.7,116.11),(22.7,115.91),(22.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,115.91),(24.1,116.11),(24.3,116.11),(24.3,115.91),(24.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,115.91),(25.7,116.11),(25.9,116.11),(25.9,115.91),(25.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,115.91),(27.3,116.11),(27.5,116.11),(27.5,115.91),(27.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,115.91),(28.9,116.11),(29.1,116.11),(29.1,115.91),(28.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,115.91),(30.5,116.11),(30.7,116.11),(30.7,115.91),(30.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,115.91),(32.1,116.11),(32.3,116.11),(32.3,115.91),(32.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,115.91),(33.7,116.11),(33.9,116.11),(33.9,115.91),(33.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,115.91),(35.3,116.11),(35.5,116.11),(35.5,115.91),(35.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,115.91),(36.9,116.11),(37.1,116.11),(37.1,115.91),(36.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,115.91),(38.5,116.11),(38.7,116.11),(38.7,115.91),(38.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,115.91),(40.1,116.11),(40.3,116.11),(40.3,115.91),(40.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,115.91),(41.7,116.11),(41.9,116.11),(41.9,115.91),(41.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,115.91),(43.3,116.11),(43.5,116.11),(43.5,115.91),(43.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,115.91),(44.9,116.11),(45.1,116.11),(45.1,115.91),(44.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,115.91),(46.5,116.11),(46.7,116.11),(46.7,115.91),(46.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,115.91),(48.1,116.11),(48.3,116.11),(48.3,115.91),(48.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,115.91),(49.7,116.11),(49.9,116.11),(49.9,115.91),(49.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,115.91),(51.3,116.11),(51.5,116.11),(51.5,115.91),(51.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,115.91),(52.9,116.11),(53.1,116.11),(53.1,115.91),(52.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,115.91),(54.5,116.11),(54.7,116.11),(54.7,115.91),(54.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,115.91),(56.1,116.11),(56.3,116.11),(56.3,115.91),(56.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,115.91),(57.7,116.11),(57.9,116.11),(57.9,115.91),(57.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,115.91),(59.3,116.11),(59.5,116.11),(59.5,115.91),(59.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,115.91),(60.9,116.11),(61.1,116.11),(61.1,115.91),(60.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,115.91),(62.5,116.11),(62.7,116.11),(62.7,115.91),(62.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,115.91),(64.1,116.11),(64.3,116.11),(64.3,115.91),(64.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,115.91),(65.7,116.11),(65.9,116.11),(65.9,115.91),(65.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,115.91),(67.3,116.11),(67.5,116.11),(67.5,115.91),(67.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,115.91),(68.9,116.11),(69.1,116.11),(69.1,115.91),(68.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,115.91),(70.5,116.11),(70.7,116.11),(70.7,115.91),(70.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,115.91),(72.1,116.11),(72.3,116.11),(72.3,115.91),(72.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,115.91),(73.7,116.11),(73.9,116.11),(73.9,115.91),(73.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,115.91),(75.3,116.11),(75.5,116.11),(75.5,115.91),(75.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,115.91),(76.9,116.11),(77.1,116.11),(77.1,115.91),(76.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,115.91),(78.5,116.11),(78.7,116.11),(78.7,115.91),(78.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,115.91),(80.1,116.11),(80.3,116.11),(80.3,115.91),(80.1,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,115.91),(81.7,116.11),(81.9,116.11),(81.9,115.91),(81.7,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,115.91),(83.3,116.11),(83.5,116.11),(83.5,115.91),(83.3,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,115.91),(84.9,116.11),(85.1,116.11),(85.1,115.91),(84.9,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,115.91),(86.5,116.11),(86.7,116.11),(86.7,115.91),(86.5,115.91)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,115.91),(88.1,116.11),(88.3,116.11),(88.3,115.91),(88.1,115.91)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,89.4),(0.0,103.14),(90.0,103.14),(90.0,89.4),(0.0,89.4)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,119.3),(0.0,133.04),(90.0,133.04),(90.0,119.3),(0.0,119.3)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,104.34),(0.0,118.08),(90.0,118.08),(90.0,104.34),(0.0,104.34)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via4',
            ((1.4,91.87),(1.4,92.67),(2.2,92.67),(2.2,91.87),(1.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,91.87),(3.0,92.67),(3.8,92.67),(3.8,91.87),(3.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,91.87),(4.6,92.67),(5.4,92.67),(5.4,91.87),(4.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,91.87),(6.2,92.67),(7.0,92.67),(7.0,91.87),(6.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,91.87),(7.8,92.67),(8.6,92.67),(8.6,91.87),(7.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,91.87),(9.4,92.67),(10.2,92.67),(10.2,91.87),(9.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,91.87),(11.0,92.67),(11.8,92.67),(11.8,91.87),(11.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,91.87),(12.6,92.67),(13.4,92.67),(13.4,91.87),(12.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,91.87),(14.2,92.67),(15.0,92.67),(15.0,91.87),(14.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,91.87),(15.8,92.67),(16.6,92.67),(16.6,91.87),(15.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,91.87),(17.4,92.67),(18.2,92.67),(18.2,91.87),(17.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,91.87),(19.0,92.67),(19.8,92.67),(19.8,91.87),(19.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,91.87),(20.6,92.67),(21.4,92.67),(21.4,91.87),(20.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,91.87),(22.2,92.67),(23.0,92.67),(23.0,91.87),(22.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,91.87),(23.8,92.67),(24.6,92.67),(24.6,91.87),(23.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,91.87),(25.4,92.67),(26.2,92.67),(26.2,91.87),(25.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,91.87),(27.0,92.67),(27.8,92.67),(27.8,91.87),(27.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,91.87),(28.6,92.67),(29.4,92.67),(29.4,91.87),(28.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,91.87),(30.2,92.67),(31.0,92.67),(31.0,91.87),(30.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,91.87),(31.8,92.67),(32.6,92.67),(32.6,91.87),(31.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,91.87),(33.4,92.67),(34.2,92.67),(34.2,91.87),(33.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,91.87),(35.0,92.67),(35.8,92.67),(35.8,91.87),(35.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,91.87),(36.6,92.67),(37.4,92.67),(37.4,91.87),(36.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,91.87),(38.2,92.67),(39.0,92.67),(39.0,91.87),(38.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,91.87),(39.8,92.67),(40.6,92.67),(40.6,91.87),(39.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,91.87),(41.4,92.67),(42.2,92.67),(42.2,91.87),(41.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,91.87),(43.0,92.67),(43.8,92.67),(43.8,91.87),(43.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,91.87),(44.6,92.67),(45.4,92.67),(45.4,91.87),(44.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,91.87),(46.2,92.67),(47.0,92.67),(47.0,91.87),(46.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,91.87),(47.8,92.67),(48.6,92.67),(48.6,91.87),(47.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,91.87),(49.4,92.67),(50.2,92.67),(50.2,91.87),(49.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,91.87),(51.0,92.67),(51.8,92.67),(51.8,91.87),(51.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,91.87),(52.6,92.67),(53.4,92.67),(53.4,91.87),(52.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,91.87),(54.2,92.67),(55.0,92.67),(55.0,91.87),(54.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,91.87),(55.8,92.67),(56.6,92.67),(56.6,91.87),(55.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,91.87),(57.4,92.67),(58.2,92.67),(58.2,91.87),(57.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,91.87),(59.0,92.67),(59.8,92.67),(59.8,91.87),(59.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,91.87),(60.6,92.67),(61.4,92.67),(61.4,91.87),(60.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,91.87),(62.2,92.67),(63.0,92.67),(63.0,91.87),(62.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,91.87),(63.8,92.67),(64.6,92.67),(64.6,91.87),(63.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,91.87),(65.4,92.67),(66.2,92.67),(66.2,91.87),(65.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,91.87),(67.0,92.67),(67.8,92.67),(67.8,91.87),(67.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,91.87),(68.6,92.67),(69.4,92.67),(69.4,91.87),(68.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,91.87),(70.2,92.67),(71.0,92.67),(71.0,91.87),(70.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,91.87),(71.8,92.67),(72.6,92.67),(72.6,91.87),(71.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,91.87),(73.4,92.67),(74.2,92.67),(74.2,91.87),(73.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,91.87),(75.0,92.67),(75.8,92.67),(75.8,91.87),(75.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,91.87),(76.6,92.67),(77.4,92.67),(77.4,91.87),(76.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,91.87),(78.2,92.67),(79.0,92.67),(79.0,91.87),(78.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,91.87),(79.8,92.67),(80.6,92.67),(80.6,91.87),(79.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,91.87),(81.4,92.67),(82.2,92.67),(82.2,91.87),(81.4,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,91.87),(83.0,92.67),(83.8,92.67),(83.8,91.87),(83.0,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,91.87),(84.6,92.67),(85.4,92.67),(85.4,91.87),(84.6,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,91.87),(86.2,92.67),(87.0,92.67),(87.0,91.87),(86.2,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,91.87),(87.8,92.67),(88.6,92.67),(88.6,91.87),(87.8,91.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,93.47),(1.4,94.27),(2.2,94.27),(2.2,93.47),(1.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,93.47),(3.0,94.27),(3.8,94.27),(3.8,93.47),(3.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,93.47),(4.6,94.27),(5.4,94.27),(5.4,93.47),(4.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,93.47),(6.2,94.27),(7.0,94.27),(7.0,93.47),(6.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,93.47),(7.8,94.27),(8.6,94.27),(8.6,93.47),(7.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,93.47),(9.4,94.27),(10.2,94.27),(10.2,93.47),(9.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,93.47),(11.0,94.27),(11.8,94.27),(11.8,93.47),(11.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,93.47),(12.6,94.27),(13.4,94.27),(13.4,93.47),(12.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,93.47),(14.2,94.27),(15.0,94.27),(15.0,93.47),(14.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,93.47),(15.8,94.27),(16.6,94.27),(16.6,93.47),(15.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,93.47),(17.4,94.27),(18.2,94.27),(18.2,93.47),(17.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,93.47),(19.0,94.27),(19.8,94.27),(19.8,93.47),(19.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,93.47),(20.6,94.27),(21.4,94.27),(21.4,93.47),(20.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,93.47),(22.2,94.27),(23.0,94.27),(23.0,93.47),(22.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,93.47),(23.8,94.27),(24.6,94.27),(24.6,93.47),(23.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,93.47),(25.4,94.27),(26.2,94.27),(26.2,93.47),(25.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,93.47),(27.0,94.27),(27.8,94.27),(27.8,93.47),(27.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,93.47),(28.6,94.27),(29.4,94.27),(29.4,93.47),(28.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,93.47),(30.2,94.27),(31.0,94.27),(31.0,93.47),(30.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,93.47),(31.8,94.27),(32.6,94.27),(32.6,93.47),(31.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,93.47),(33.4,94.27),(34.2,94.27),(34.2,93.47),(33.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,93.47),(35.0,94.27),(35.8,94.27),(35.8,93.47),(35.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,93.47),(36.6,94.27),(37.4,94.27),(37.4,93.47),(36.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,93.47),(38.2,94.27),(39.0,94.27),(39.0,93.47),(38.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,93.47),(39.8,94.27),(40.6,94.27),(40.6,93.47),(39.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,93.47),(41.4,94.27),(42.2,94.27),(42.2,93.47),(41.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,93.47),(43.0,94.27),(43.8,94.27),(43.8,93.47),(43.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,93.47),(44.6,94.27),(45.4,94.27),(45.4,93.47),(44.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,93.47),(46.2,94.27),(47.0,94.27),(47.0,93.47),(46.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,93.47),(47.8,94.27),(48.6,94.27),(48.6,93.47),(47.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,93.47),(49.4,94.27),(50.2,94.27),(50.2,93.47),(49.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,93.47),(51.0,94.27),(51.8,94.27),(51.8,93.47),(51.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,93.47),(52.6,94.27),(53.4,94.27),(53.4,93.47),(52.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,93.47),(54.2,94.27),(55.0,94.27),(55.0,93.47),(54.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,93.47),(55.8,94.27),(56.6,94.27),(56.6,93.47),(55.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,93.47),(57.4,94.27),(58.2,94.27),(58.2,93.47),(57.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,93.47),(59.0,94.27),(59.8,94.27),(59.8,93.47),(59.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,93.47),(60.6,94.27),(61.4,94.27),(61.4,93.47),(60.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,93.47),(62.2,94.27),(63.0,94.27),(63.0,93.47),(62.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,93.47),(63.8,94.27),(64.6,94.27),(64.6,93.47),(63.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,93.47),(65.4,94.27),(66.2,94.27),(66.2,93.47),(65.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,93.47),(67.0,94.27),(67.8,94.27),(67.8,93.47),(67.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,93.47),(68.6,94.27),(69.4,94.27),(69.4,93.47),(68.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,93.47),(70.2,94.27),(71.0,94.27),(71.0,93.47),(70.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,93.47),(71.8,94.27),(72.6,94.27),(72.6,93.47),(71.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,93.47),(73.4,94.27),(74.2,94.27),(74.2,93.47),(73.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,93.47),(75.0,94.27),(75.8,94.27),(75.8,93.47),(75.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,93.47),(76.6,94.27),(77.4,94.27),(77.4,93.47),(76.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,93.47),(78.2,94.27),(79.0,94.27),(79.0,93.47),(78.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,93.47),(79.8,94.27),(80.6,94.27),(80.6,93.47),(79.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,93.47),(81.4,94.27),(82.2,94.27),(82.2,93.47),(81.4,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,93.47),(83.0,94.27),(83.8,94.27),(83.8,93.47),(83.0,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,93.47),(84.6,94.27),(85.4,94.27),(85.4,93.47),(84.6,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,93.47),(86.2,94.27),(87.0,94.27),(87.0,93.47),(86.2,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,93.47),(87.8,94.27),(88.6,94.27),(88.6,93.47),(87.8,93.47)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,95.07),(1.4,95.87),(2.2,95.87),(2.2,95.07),(1.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,95.07),(3.0,95.87),(3.8,95.87),(3.8,95.07),(3.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,95.07),(4.6,95.87),(5.4,95.87),(5.4,95.07),(4.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,95.07),(6.2,95.87),(7.0,95.87),(7.0,95.07),(6.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,95.07),(7.8,95.87),(8.6,95.87),(8.6,95.07),(7.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,95.07),(9.4,95.87),(10.2,95.87),(10.2,95.07),(9.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,95.07),(11.0,95.87),(11.8,95.87),(11.8,95.07),(11.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,95.07),(12.6,95.87),(13.4,95.87),(13.4,95.07),(12.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,95.07),(14.2,95.87),(15.0,95.87),(15.0,95.07),(14.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,95.07),(15.8,95.87),(16.6,95.87),(16.6,95.07),(15.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,95.07),(17.4,95.87),(18.2,95.87),(18.2,95.07),(17.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,95.07),(19.0,95.87),(19.8,95.87),(19.8,95.07),(19.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,95.07),(20.6,95.87),(21.4,95.87),(21.4,95.07),(20.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,95.07),(22.2,95.87),(23.0,95.87),(23.0,95.07),(22.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,95.07),(23.8,95.87),(24.6,95.87),(24.6,95.07),(23.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,95.07),(25.4,95.87),(26.2,95.87),(26.2,95.07),(25.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,95.07),(27.0,95.87),(27.8,95.87),(27.8,95.07),(27.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,95.07),(28.6,95.87),(29.4,95.87),(29.4,95.07),(28.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,95.07),(30.2,95.87),(31.0,95.87),(31.0,95.07),(30.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,95.07),(31.8,95.87),(32.6,95.87),(32.6,95.07),(31.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,95.07),(33.4,95.87),(34.2,95.87),(34.2,95.07),(33.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,95.07),(35.0,95.87),(35.8,95.87),(35.8,95.07),(35.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,95.07),(36.6,95.87),(37.4,95.87),(37.4,95.07),(36.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,95.07),(38.2,95.87),(39.0,95.87),(39.0,95.07),(38.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,95.07),(39.8,95.87),(40.6,95.87),(40.6,95.07),(39.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,95.07),(41.4,95.87),(42.2,95.87),(42.2,95.07),(41.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,95.07),(43.0,95.87),(43.8,95.87),(43.8,95.07),(43.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,95.07),(44.6,95.87),(45.4,95.87),(45.4,95.07),(44.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,95.07),(46.2,95.87),(47.0,95.87),(47.0,95.07),(46.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,95.07),(47.8,95.87),(48.6,95.87),(48.6,95.07),(47.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,95.07),(49.4,95.87),(50.2,95.87),(50.2,95.07),(49.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,95.07),(51.0,95.87),(51.8,95.87),(51.8,95.07),(51.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,95.07),(52.6,95.87),(53.4,95.87),(53.4,95.07),(52.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,95.07),(54.2,95.87),(55.0,95.87),(55.0,95.07),(54.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,95.07),(55.8,95.87),(56.6,95.87),(56.6,95.07),(55.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,95.07),(57.4,95.87),(58.2,95.87),(58.2,95.07),(57.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,95.07),(59.0,95.87),(59.8,95.87),(59.8,95.07),(59.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,95.07),(60.6,95.87),(61.4,95.87),(61.4,95.07),(60.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,95.07),(62.2,95.87),(63.0,95.87),(63.0,95.07),(62.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,95.07),(63.8,95.87),(64.6,95.87),(64.6,95.07),(63.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,95.07),(65.4,95.87),(66.2,95.87),(66.2,95.07),(65.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,95.07),(67.0,95.87),(67.8,95.87),(67.8,95.07),(67.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,95.07),(68.6,95.87),(69.4,95.87),(69.4,95.07),(68.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,95.07),(70.2,95.87),(71.0,95.87),(71.0,95.07),(70.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,95.07),(71.8,95.87),(72.6,95.87),(72.6,95.07),(71.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,95.07),(73.4,95.87),(74.2,95.87),(74.2,95.07),(73.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,95.07),(75.0,95.87),(75.8,95.87),(75.8,95.07),(75.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,95.07),(76.6,95.87),(77.4,95.87),(77.4,95.07),(76.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,95.07),(78.2,95.87),(79.0,95.87),(79.0,95.07),(78.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,95.07),(79.8,95.87),(80.6,95.87),(80.6,95.07),(79.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,95.07),(81.4,95.87),(82.2,95.87),(82.2,95.07),(81.4,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,95.07),(83.0,95.87),(83.8,95.87),(83.8,95.07),(83.0,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,95.07),(84.6,95.87),(85.4,95.87),(85.4,95.07),(84.6,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,95.07),(86.2,95.87),(87.0,95.87),(87.0,95.07),(86.2,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,95.07),(87.8,95.87),(88.6,95.87),(88.6,95.07),(87.8,95.07)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,96.67),(1.4,97.47),(2.2,97.47),(2.2,96.67),(1.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,96.67),(3.0,97.47),(3.8,97.47),(3.8,96.67),(3.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,96.67),(4.6,97.47),(5.4,97.47),(5.4,96.67),(4.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,96.67),(6.2,97.47),(7.0,97.47),(7.0,96.67),(6.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,96.67),(7.8,97.47),(8.6,97.47),(8.6,96.67),(7.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,96.67),(9.4,97.47),(10.2,97.47),(10.2,96.67),(9.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,96.67),(11.0,97.47),(11.8,97.47),(11.8,96.67),(11.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,96.67),(12.6,97.47),(13.4,97.47),(13.4,96.67),(12.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,96.67),(14.2,97.47),(15.0,97.47),(15.0,96.67),(14.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,96.67),(15.8,97.47),(16.6,97.47),(16.6,96.67),(15.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,96.67),(17.4,97.47),(18.2,97.47),(18.2,96.67),(17.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,96.67),(19.0,97.47),(19.8,97.47),(19.8,96.67),(19.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,96.67),(20.6,97.47),(21.4,97.47),(21.4,96.67),(20.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,96.67),(22.2,97.47),(23.0,97.47),(23.0,96.67),(22.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,96.67),(23.8,97.47),(24.6,97.47),(24.6,96.67),(23.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,96.67),(25.4,97.47),(26.2,97.47),(26.2,96.67),(25.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,96.67),(27.0,97.47),(27.8,97.47),(27.8,96.67),(27.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,96.67),(28.6,97.47),(29.4,97.47),(29.4,96.67),(28.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,96.67),(30.2,97.47),(31.0,97.47),(31.0,96.67),(30.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,96.67),(31.8,97.47),(32.6,97.47),(32.6,96.67),(31.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,96.67),(33.4,97.47),(34.2,97.47),(34.2,96.67),(33.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,96.67),(35.0,97.47),(35.8,97.47),(35.8,96.67),(35.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,96.67),(36.6,97.47),(37.4,97.47),(37.4,96.67),(36.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,96.67),(38.2,97.47),(39.0,97.47),(39.0,96.67),(38.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,96.67),(39.8,97.47),(40.6,97.47),(40.6,96.67),(39.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,96.67),(41.4,97.47),(42.2,97.47),(42.2,96.67),(41.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,96.67),(43.0,97.47),(43.8,97.47),(43.8,96.67),(43.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,96.67),(44.6,97.47),(45.4,97.47),(45.4,96.67),(44.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,96.67),(46.2,97.47),(47.0,97.47),(47.0,96.67),(46.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,96.67),(47.8,97.47),(48.6,97.47),(48.6,96.67),(47.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,96.67),(49.4,97.47),(50.2,97.47),(50.2,96.67),(49.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,96.67),(51.0,97.47),(51.8,97.47),(51.8,96.67),(51.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,96.67),(52.6,97.47),(53.4,97.47),(53.4,96.67),(52.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,96.67),(54.2,97.47),(55.0,97.47),(55.0,96.67),(54.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,96.67),(55.8,97.47),(56.6,97.47),(56.6,96.67),(55.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,96.67),(57.4,97.47),(58.2,97.47),(58.2,96.67),(57.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,96.67),(59.0,97.47),(59.8,97.47),(59.8,96.67),(59.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,96.67),(60.6,97.47),(61.4,97.47),(61.4,96.67),(60.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,96.67),(62.2,97.47),(63.0,97.47),(63.0,96.67),(62.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,96.67),(63.8,97.47),(64.6,97.47),(64.6,96.67),(63.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,96.67),(65.4,97.47),(66.2,97.47),(66.2,96.67),(65.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,96.67),(67.0,97.47),(67.8,97.47),(67.8,96.67),(67.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,96.67),(68.6,97.47),(69.4,97.47),(69.4,96.67),(68.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,96.67),(70.2,97.47),(71.0,97.47),(71.0,96.67),(70.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,96.67),(71.8,97.47),(72.6,97.47),(72.6,96.67),(71.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,96.67),(73.4,97.47),(74.2,97.47),(74.2,96.67),(73.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,96.67),(75.0,97.47),(75.8,97.47),(75.8,96.67),(75.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,96.67),(76.6,97.47),(77.4,97.47),(77.4,96.67),(76.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,96.67),(78.2,97.47),(79.0,97.47),(79.0,96.67),(78.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,96.67),(79.8,97.47),(80.6,97.47),(80.6,96.67),(79.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,96.67),(81.4,97.47),(82.2,97.47),(82.2,96.67),(81.4,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,96.67),(83.0,97.47),(83.8,97.47),(83.8,96.67),(83.0,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,96.67),(84.6,97.47),(85.4,97.47),(85.4,96.67),(84.6,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,96.67),(86.2,97.47),(87.0,97.47),(87.0,96.67),(86.2,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,96.67),(87.8,97.47),(88.6,97.47),(88.6,96.67),(87.8,96.67)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,98.27),(1.4,99.07),(2.2,99.07),(2.2,98.27),(1.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,98.27),(3.0,99.07),(3.8,99.07),(3.8,98.27),(3.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,98.27),(4.6,99.07),(5.4,99.07),(5.4,98.27),(4.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,98.27),(6.2,99.07),(7.0,99.07),(7.0,98.27),(6.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,98.27),(7.8,99.07),(8.6,99.07),(8.6,98.27),(7.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,98.27),(9.4,99.07),(10.2,99.07),(10.2,98.27),(9.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,98.27),(11.0,99.07),(11.8,99.07),(11.8,98.27),(11.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,98.27),(12.6,99.07),(13.4,99.07),(13.4,98.27),(12.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,98.27),(14.2,99.07),(15.0,99.07),(15.0,98.27),(14.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,98.27),(15.8,99.07),(16.6,99.07),(16.6,98.27),(15.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,98.27),(17.4,99.07),(18.2,99.07),(18.2,98.27),(17.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,98.27),(19.0,99.07),(19.8,99.07),(19.8,98.27),(19.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,98.27),(20.6,99.07),(21.4,99.07),(21.4,98.27),(20.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,98.27),(22.2,99.07),(23.0,99.07),(23.0,98.27),(22.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,98.27),(23.8,99.07),(24.6,99.07),(24.6,98.27),(23.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,98.27),(25.4,99.07),(26.2,99.07),(26.2,98.27),(25.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,98.27),(27.0,99.07),(27.8,99.07),(27.8,98.27),(27.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,98.27),(28.6,99.07),(29.4,99.07),(29.4,98.27),(28.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,98.27),(30.2,99.07),(31.0,99.07),(31.0,98.27),(30.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,98.27),(31.8,99.07),(32.6,99.07),(32.6,98.27),(31.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,98.27),(33.4,99.07),(34.2,99.07),(34.2,98.27),(33.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,98.27),(35.0,99.07),(35.8,99.07),(35.8,98.27),(35.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,98.27),(36.6,99.07),(37.4,99.07),(37.4,98.27),(36.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,98.27),(38.2,99.07),(39.0,99.07),(39.0,98.27),(38.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,98.27),(39.8,99.07),(40.6,99.07),(40.6,98.27),(39.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,98.27),(41.4,99.07),(42.2,99.07),(42.2,98.27),(41.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,98.27),(43.0,99.07),(43.8,99.07),(43.8,98.27),(43.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,98.27),(44.6,99.07),(45.4,99.07),(45.4,98.27),(44.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,98.27),(46.2,99.07),(47.0,99.07),(47.0,98.27),(46.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,98.27),(47.8,99.07),(48.6,99.07),(48.6,98.27),(47.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,98.27),(49.4,99.07),(50.2,99.07),(50.2,98.27),(49.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,98.27),(51.0,99.07),(51.8,99.07),(51.8,98.27),(51.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,98.27),(52.6,99.07),(53.4,99.07),(53.4,98.27),(52.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,98.27),(54.2,99.07),(55.0,99.07),(55.0,98.27),(54.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,98.27),(55.8,99.07),(56.6,99.07),(56.6,98.27),(55.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,98.27),(57.4,99.07),(58.2,99.07),(58.2,98.27),(57.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,98.27),(59.0,99.07),(59.8,99.07),(59.8,98.27),(59.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,98.27),(60.6,99.07),(61.4,99.07),(61.4,98.27),(60.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,98.27),(62.2,99.07),(63.0,99.07),(63.0,98.27),(62.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,98.27),(63.8,99.07),(64.6,99.07),(64.6,98.27),(63.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,98.27),(65.4,99.07),(66.2,99.07),(66.2,98.27),(65.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,98.27),(67.0,99.07),(67.8,99.07),(67.8,98.27),(67.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,98.27),(68.6,99.07),(69.4,99.07),(69.4,98.27),(68.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,98.27),(70.2,99.07),(71.0,99.07),(71.0,98.27),(70.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,98.27),(71.8,99.07),(72.6,99.07),(72.6,98.27),(71.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,98.27),(73.4,99.07),(74.2,99.07),(74.2,98.27),(73.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,98.27),(75.0,99.07),(75.8,99.07),(75.8,98.27),(75.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,98.27),(76.6,99.07),(77.4,99.07),(77.4,98.27),(76.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,98.27),(78.2,99.07),(79.0,99.07),(79.0,98.27),(78.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,98.27),(79.8,99.07),(80.6,99.07),(80.6,98.27),(79.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,98.27),(81.4,99.07),(82.2,99.07),(82.2,98.27),(81.4,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,98.27),(83.0,99.07),(83.8,99.07),(83.8,98.27),(83.0,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,98.27),(84.6,99.07),(85.4,99.07),(85.4,98.27),(84.6,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,98.27),(86.2,99.07),(87.0,99.07),(87.0,98.27),(86.2,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,98.27),(87.8,99.07),(88.6,99.07),(88.6,98.27),(87.8,98.27)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,99.87),(1.4,100.67),(2.2,100.67),(2.2,99.87),(1.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,99.87),(3.0,100.67),(3.8,100.67),(3.8,99.87),(3.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,99.87),(4.6,100.67),(5.4,100.67),(5.4,99.87),(4.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,99.87),(6.2,100.67),(7.0,100.67),(7.0,99.87),(6.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,99.87),(7.8,100.67),(8.6,100.67),(8.6,99.87),(7.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,99.87),(9.4,100.67),(10.2,100.67),(10.2,99.87),(9.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,99.87),(11.0,100.67),(11.8,100.67),(11.8,99.87),(11.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,99.87),(12.6,100.67),(13.4,100.67),(13.4,99.87),(12.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,99.87),(14.2,100.67),(15.0,100.67),(15.0,99.87),(14.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,99.87),(15.8,100.67),(16.6,100.67),(16.6,99.87),(15.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,99.87),(17.4,100.67),(18.2,100.67),(18.2,99.87),(17.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,99.87),(19.0,100.67),(19.8,100.67),(19.8,99.87),(19.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,99.87),(20.6,100.67),(21.4,100.67),(21.4,99.87),(20.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,99.87),(22.2,100.67),(23.0,100.67),(23.0,99.87),(22.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,99.87),(23.8,100.67),(24.6,100.67),(24.6,99.87),(23.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,99.87),(25.4,100.67),(26.2,100.67),(26.2,99.87),(25.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,99.87),(27.0,100.67),(27.8,100.67),(27.8,99.87),(27.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,99.87),(28.6,100.67),(29.4,100.67),(29.4,99.87),(28.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,99.87),(30.2,100.67),(31.0,100.67),(31.0,99.87),(30.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,99.87),(31.8,100.67),(32.6,100.67),(32.6,99.87),(31.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,99.87),(33.4,100.67),(34.2,100.67),(34.2,99.87),(33.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,99.87),(35.0,100.67),(35.8,100.67),(35.8,99.87),(35.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,99.87),(36.6,100.67),(37.4,100.67),(37.4,99.87),(36.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,99.87),(38.2,100.67),(39.0,100.67),(39.0,99.87),(38.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,99.87),(39.8,100.67),(40.6,100.67),(40.6,99.87),(39.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,99.87),(41.4,100.67),(42.2,100.67),(42.2,99.87),(41.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,99.87),(43.0,100.67),(43.8,100.67),(43.8,99.87),(43.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,99.87),(44.6,100.67),(45.4,100.67),(45.4,99.87),(44.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,99.87),(46.2,100.67),(47.0,100.67),(47.0,99.87),(46.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,99.87),(47.8,100.67),(48.6,100.67),(48.6,99.87),(47.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,99.87),(49.4,100.67),(50.2,100.67),(50.2,99.87),(49.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,99.87),(51.0,100.67),(51.8,100.67),(51.8,99.87),(51.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,99.87),(52.6,100.67),(53.4,100.67),(53.4,99.87),(52.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,99.87),(54.2,100.67),(55.0,100.67),(55.0,99.87),(54.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,99.87),(55.8,100.67),(56.6,100.67),(56.6,99.87),(55.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,99.87),(57.4,100.67),(58.2,100.67),(58.2,99.87),(57.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,99.87),(59.0,100.67),(59.8,100.67),(59.8,99.87),(59.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,99.87),(60.6,100.67),(61.4,100.67),(61.4,99.87),(60.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,99.87),(62.2,100.67),(63.0,100.67),(63.0,99.87),(62.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,99.87),(63.8,100.67),(64.6,100.67),(64.6,99.87),(63.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,99.87),(65.4,100.67),(66.2,100.67),(66.2,99.87),(65.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,99.87),(67.0,100.67),(67.8,100.67),(67.8,99.87),(67.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,99.87),(68.6,100.67),(69.4,100.67),(69.4,99.87),(68.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,99.87),(70.2,100.67),(71.0,100.67),(71.0,99.87),(70.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,99.87),(71.8,100.67),(72.6,100.67),(72.6,99.87),(71.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,99.87),(73.4,100.67),(74.2,100.67),(74.2,99.87),(73.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,99.87),(75.0,100.67),(75.8,100.67),(75.8,99.87),(75.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,99.87),(76.6,100.67),(77.4,100.67),(77.4,99.87),(76.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,99.87),(78.2,100.67),(79.0,100.67),(79.0,99.87),(78.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,99.87),(79.8,100.67),(80.6,100.67),(80.6,99.87),(79.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,99.87),(81.4,100.67),(82.2,100.67),(82.2,99.87),(81.4,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,99.87),(83.0,100.67),(83.8,100.67),(83.8,99.87),(83.0,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,99.87),(84.6,100.67),(85.4,100.67),(85.4,99.87),(84.6,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,99.87),(86.2,100.67),(87.0,100.67),(87.0,99.87),(86.2,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,99.87),(87.8,100.67),(88.6,100.67),(88.6,99.87),(87.8,99.87)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,106.81),(1.4,107.61),(2.2,107.61),(2.2,106.81),(1.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,106.81),(3.0,107.61),(3.8,107.61),(3.8,106.81),(3.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,106.81),(4.6,107.61),(5.4,107.61),(5.4,106.81),(4.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,106.81),(6.2,107.61),(7.0,107.61),(7.0,106.81),(6.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,106.81),(7.8,107.61),(8.6,107.61),(8.6,106.81),(7.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,106.81),(9.4,107.61),(10.2,107.61),(10.2,106.81),(9.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,106.81),(11.0,107.61),(11.8,107.61),(11.8,106.81),(11.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,106.81),(12.6,107.61),(13.4,107.61),(13.4,106.81),(12.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,106.81),(14.2,107.61),(15.0,107.61),(15.0,106.81),(14.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,106.81),(15.8,107.61),(16.6,107.61),(16.6,106.81),(15.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,106.81),(17.4,107.61),(18.2,107.61),(18.2,106.81),(17.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,106.81),(19.0,107.61),(19.8,107.61),(19.8,106.81),(19.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,106.81),(20.6,107.61),(21.4,107.61),(21.4,106.81),(20.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,106.81),(22.2,107.61),(23.0,107.61),(23.0,106.81),(22.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,106.81),(23.8,107.61),(24.6,107.61),(24.6,106.81),(23.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,106.81),(25.4,107.61),(26.2,107.61),(26.2,106.81),(25.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,106.81),(27.0,107.61),(27.8,107.61),(27.8,106.81),(27.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,106.81),(28.6,107.61),(29.4,107.61),(29.4,106.81),(28.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,106.81),(30.2,107.61),(31.0,107.61),(31.0,106.81),(30.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,106.81),(31.8,107.61),(32.6,107.61),(32.6,106.81),(31.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,106.81),(33.4,107.61),(34.2,107.61),(34.2,106.81),(33.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,106.81),(35.0,107.61),(35.8,107.61),(35.8,106.81),(35.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,106.81),(36.6,107.61),(37.4,107.61),(37.4,106.81),(36.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,106.81),(38.2,107.61),(39.0,107.61),(39.0,106.81),(38.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,106.81),(39.8,107.61),(40.6,107.61),(40.6,106.81),(39.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,106.81),(41.4,107.61),(42.2,107.61),(42.2,106.81),(41.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,106.81),(43.0,107.61),(43.8,107.61),(43.8,106.81),(43.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,106.81),(44.6,107.61),(45.4,107.61),(45.4,106.81),(44.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,106.81),(46.2,107.61),(47.0,107.61),(47.0,106.81),(46.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,106.81),(47.8,107.61),(48.6,107.61),(48.6,106.81),(47.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,106.81),(49.4,107.61),(50.2,107.61),(50.2,106.81),(49.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,106.81),(51.0,107.61),(51.8,107.61),(51.8,106.81),(51.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,106.81),(52.6,107.61),(53.4,107.61),(53.4,106.81),(52.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,106.81),(54.2,107.61),(55.0,107.61),(55.0,106.81),(54.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,106.81),(55.8,107.61),(56.6,107.61),(56.6,106.81),(55.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,106.81),(57.4,107.61),(58.2,107.61),(58.2,106.81),(57.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,106.81),(59.0,107.61),(59.8,107.61),(59.8,106.81),(59.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,106.81),(60.6,107.61),(61.4,107.61),(61.4,106.81),(60.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,106.81),(62.2,107.61),(63.0,107.61),(63.0,106.81),(62.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,106.81),(63.8,107.61),(64.6,107.61),(64.6,106.81),(63.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,106.81),(65.4,107.61),(66.2,107.61),(66.2,106.81),(65.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,106.81),(67.0,107.61),(67.8,107.61),(67.8,106.81),(67.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,106.81),(68.6,107.61),(69.4,107.61),(69.4,106.81),(68.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,106.81),(70.2,107.61),(71.0,107.61),(71.0,106.81),(70.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,106.81),(71.8,107.61),(72.6,107.61),(72.6,106.81),(71.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,106.81),(73.4,107.61),(74.2,107.61),(74.2,106.81),(73.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,106.81),(75.0,107.61),(75.8,107.61),(75.8,106.81),(75.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,106.81),(76.6,107.61),(77.4,107.61),(77.4,106.81),(76.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,106.81),(78.2,107.61),(79.0,107.61),(79.0,106.81),(78.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,106.81),(79.8,107.61),(80.6,107.61),(80.6,106.81),(79.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,106.81),(81.4,107.61),(82.2,107.61),(82.2,106.81),(81.4,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,106.81),(83.0,107.61),(83.8,107.61),(83.8,106.81),(83.0,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,106.81),(84.6,107.61),(85.4,107.61),(85.4,106.81),(84.6,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,106.81),(86.2,107.61),(87.0,107.61),(87.0,106.81),(86.2,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,106.81),(87.8,107.61),(88.6,107.61),(88.6,106.81),(87.8,106.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,108.41),(1.4,109.21),(2.2,109.21),(2.2,108.41),(1.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,108.41),(3.0,109.21),(3.8,109.21),(3.8,108.41),(3.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,108.41),(4.6,109.21),(5.4,109.21),(5.4,108.41),(4.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,108.41),(6.2,109.21),(7.0,109.21),(7.0,108.41),(6.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,108.41),(7.8,109.21),(8.6,109.21),(8.6,108.41),(7.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,108.41),(9.4,109.21),(10.2,109.21),(10.2,108.41),(9.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,108.41),(11.0,109.21),(11.8,109.21),(11.8,108.41),(11.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,108.41),(12.6,109.21),(13.4,109.21),(13.4,108.41),(12.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,108.41),(14.2,109.21),(15.0,109.21),(15.0,108.41),(14.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,108.41),(15.8,109.21),(16.6,109.21),(16.6,108.41),(15.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,108.41),(17.4,109.21),(18.2,109.21),(18.2,108.41),(17.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,108.41),(19.0,109.21),(19.8,109.21),(19.8,108.41),(19.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,108.41),(20.6,109.21),(21.4,109.21),(21.4,108.41),(20.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,108.41),(22.2,109.21),(23.0,109.21),(23.0,108.41),(22.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,108.41),(23.8,109.21),(24.6,109.21),(24.6,108.41),(23.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,108.41),(25.4,109.21),(26.2,109.21),(26.2,108.41),(25.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,108.41),(27.0,109.21),(27.8,109.21),(27.8,108.41),(27.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,108.41),(28.6,109.21),(29.4,109.21),(29.4,108.41),(28.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,108.41),(30.2,109.21),(31.0,109.21),(31.0,108.41),(30.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,108.41),(31.8,109.21),(32.6,109.21),(32.6,108.41),(31.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,108.41),(33.4,109.21),(34.2,109.21),(34.2,108.41),(33.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,108.41),(35.0,109.21),(35.8,109.21),(35.8,108.41),(35.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,108.41),(36.6,109.21),(37.4,109.21),(37.4,108.41),(36.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,108.41),(38.2,109.21),(39.0,109.21),(39.0,108.41),(38.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,108.41),(39.8,109.21),(40.6,109.21),(40.6,108.41),(39.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,108.41),(41.4,109.21),(42.2,109.21),(42.2,108.41),(41.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,108.41),(43.0,109.21),(43.8,109.21),(43.8,108.41),(43.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,108.41),(44.6,109.21),(45.4,109.21),(45.4,108.41),(44.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,108.41),(46.2,109.21),(47.0,109.21),(47.0,108.41),(46.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,108.41),(47.8,109.21),(48.6,109.21),(48.6,108.41),(47.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,108.41),(49.4,109.21),(50.2,109.21),(50.2,108.41),(49.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,108.41),(51.0,109.21),(51.8,109.21),(51.8,108.41),(51.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,108.41),(52.6,109.21),(53.4,109.21),(53.4,108.41),(52.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,108.41),(54.2,109.21),(55.0,109.21),(55.0,108.41),(54.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,108.41),(55.8,109.21),(56.6,109.21),(56.6,108.41),(55.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,108.41),(57.4,109.21),(58.2,109.21),(58.2,108.41),(57.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,108.41),(59.0,109.21),(59.8,109.21),(59.8,108.41),(59.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,108.41),(60.6,109.21),(61.4,109.21),(61.4,108.41),(60.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,108.41),(62.2,109.21),(63.0,109.21),(63.0,108.41),(62.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,108.41),(63.8,109.21),(64.6,109.21),(64.6,108.41),(63.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,108.41),(65.4,109.21),(66.2,109.21),(66.2,108.41),(65.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,108.41),(67.0,109.21),(67.8,109.21),(67.8,108.41),(67.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,108.41),(68.6,109.21),(69.4,109.21),(69.4,108.41),(68.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,108.41),(70.2,109.21),(71.0,109.21),(71.0,108.41),(70.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,108.41),(71.8,109.21),(72.6,109.21),(72.6,108.41),(71.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,108.41),(73.4,109.21),(74.2,109.21),(74.2,108.41),(73.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,108.41),(75.0,109.21),(75.8,109.21),(75.8,108.41),(75.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,108.41),(76.6,109.21),(77.4,109.21),(77.4,108.41),(76.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,108.41),(78.2,109.21),(79.0,109.21),(79.0,108.41),(78.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,108.41),(79.8,109.21),(80.6,109.21),(80.6,108.41),(79.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,108.41),(81.4,109.21),(82.2,109.21),(82.2,108.41),(81.4,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,108.41),(83.0,109.21),(83.8,109.21),(83.8,108.41),(83.0,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,108.41),(84.6,109.21),(85.4,109.21),(85.4,108.41),(84.6,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,108.41),(86.2,109.21),(87.0,109.21),(87.0,108.41),(86.2,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,108.41),(87.8,109.21),(88.6,109.21),(88.6,108.41),(87.8,108.41)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,110.01),(1.4,110.81),(2.2,110.81),(2.2,110.01),(1.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,110.01),(3.0,110.81),(3.8,110.81),(3.8,110.01),(3.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,110.01),(4.6,110.81),(5.4,110.81),(5.4,110.01),(4.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,110.01),(6.2,110.81),(7.0,110.81),(7.0,110.01),(6.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,110.01),(7.8,110.81),(8.6,110.81),(8.6,110.01),(7.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,110.01),(9.4,110.81),(10.2,110.81),(10.2,110.01),(9.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,110.01),(11.0,110.81),(11.8,110.81),(11.8,110.01),(11.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,110.01),(12.6,110.81),(13.4,110.81),(13.4,110.01),(12.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,110.01),(14.2,110.81),(15.0,110.81),(15.0,110.01),(14.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,110.01),(15.8,110.81),(16.6,110.81),(16.6,110.01),(15.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,110.01),(17.4,110.81),(18.2,110.81),(18.2,110.01),(17.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,110.01),(19.0,110.81),(19.8,110.81),(19.8,110.01),(19.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,110.01),(20.6,110.81),(21.4,110.81),(21.4,110.01),(20.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,110.01),(22.2,110.81),(23.0,110.81),(23.0,110.01),(22.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,110.01),(23.8,110.81),(24.6,110.81),(24.6,110.01),(23.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,110.01),(25.4,110.81),(26.2,110.81),(26.2,110.01),(25.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,110.01),(27.0,110.81),(27.8,110.81),(27.8,110.01),(27.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,110.01),(28.6,110.81),(29.4,110.81),(29.4,110.01),(28.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,110.01),(30.2,110.81),(31.0,110.81),(31.0,110.01),(30.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,110.01),(31.8,110.81),(32.6,110.81),(32.6,110.01),(31.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,110.01),(33.4,110.81),(34.2,110.81),(34.2,110.01),(33.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,110.01),(35.0,110.81),(35.8,110.81),(35.8,110.01),(35.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,110.01),(36.6,110.81),(37.4,110.81),(37.4,110.01),(36.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,110.01),(38.2,110.81),(39.0,110.81),(39.0,110.01),(38.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,110.01),(39.8,110.81),(40.6,110.81),(40.6,110.01),(39.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,110.01),(41.4,110.81),(42.2,110.81),(42.2,110.01),(41.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,110.01),(43.0,110.81),(43.8,110.81),(43.8,110.01),(43.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,110.01),(44.6,110.81),(45.4,110.81),(45.4,110.01),(44.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,110.01),(46.2,110.81),(47.0,110.81),(47.0,110.01),(46.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,110.01),(47.8,110.81),(48.6,110.81),(48.6,110.01),(47.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,110.01),(49.4,110.81),(50.2,110.81),(50.2,110.01),(49.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,110.01),(51.0,110.81),(51.8,110.81),(51.8,110.01),(51.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,110.01),(52.6,110.81),(53.4,110.81),(53.4,110.01),(52.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,110.01),(54.2,110.81),(55.0,110.81),(55.0,110.01),(54.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,110.01),(55.8,110.81),(56.6,110.81),(56.6,110.01),(55.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,110.01),(57.4,110.81),(58.2,110.81),(58.2,110.01),(57.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,110.01),(59.0,110.81),(59.8,110.81),(59.8,110.01),(59.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,110.01),(60.6,110.81),(61.4,110.81),(61.4,110.01),(60.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,110.01),(62.2,110.81),(63.0,110.81),(63.0,110.01),(62.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,110.01),(63.8,110.81),(64.6,110.81),(64.6,110.01),(63.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,110.01),(65.4,110.81),(66.2,110.81),(66.2,110.01),(65.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,110.01),(67.0,110.81),(67.8,110.81),(67.8,110.01),(67.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,110.01),(68.6,110.81),(69.4,110.81),(69.4,110.01),(68.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,110.01),(70.2,110.81),(71.0,110.81),(71.0,110.01),(70.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,110.01),(71.8,110.81),(72.6,110.81),(72.6,110.01),(71.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,110.01),(73.4,110.81),(74.2,110.81),(74.2,110.01),(73.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,110.01),(75.0,110.81),(75.8,110.81),(75.8,110.01),(75.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,110.01),(76.6,110.81),(77.4,110.81),(77.4,110.01),(76.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,110.01),(78.2,110.81),(79.0,110.81),(79.0,110.01),(78.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,110.01),(79.8,110.81),(80.6,110.81),(80.6,110.01),(79.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,110.01),(81.4,110.81),(82.2,110.81),(82.2,110.01),(81.4,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,110.01),(83.0,110.81),(83.8,110.81),(83.8,110.01),(83.0,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,110.01),(84.6,110.81),(85.4,110.81),(85.4,110.01),(84.6,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,110.01),(86.2,110.81),(87.0,110.81),(87.0,110.01),(86.2,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,110.01),(87.8,110.81),(88.6,110.81),(88.6,110.01),(87.8,110.01)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,111.61),(1.4,112.41),(2.2,112.41),(2.2,111.61),(1.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,111.61),(3.0,112.41),(3.8,112.41),(3.8,111.61),(3.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,111.61),(4.6,112.41),(5.4,112.41),(5.4,111.61),(4.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,111.61),(6.2,112.41),(7.0,112.41),(7.0,111.61),(6.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,111.61),(7.8,112.41),(8.6,112.41),(8.6,111.61),(7.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,111.61),(9.4,112.41),(10.2,112.41),(10.2,111.61),(9.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,111.61),(11.0,112.41),(11.8,112.41),(11.8,111.61),(11.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,111.61),(12.6,112.41),(13.4,112.41),(13.4,111.61),(12.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,111.61),(14.2,112.41),(15.0,112.41),(15.0,111.61),(14.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,111.61),(15.8,112.41),(16.6,112.41),(16.6,111.61),(15.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,111.61),(17.4,112.41),(18.2,112.41),(18.2,111.61),(17.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,111.61),(19.0,112.41),(19.8,112.41),(19.8,111.61),(19.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,111.61),(20.6,112.41),(21.4,112.41),(21.4,111.61),(20.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,111.61),(22.2,112.41),(23.0,112.41),(23.0,111.61),(22.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,111.61),(23.8,112.41),(24.6,112.41),(24.6,111.61),(23.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,111.61),(25.4,112.41),(26.2,112.41),(26.2,111.61),(25.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,111.61),(27.0,112.41),(27.8,112.41),(27.8,111.61),(27.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,111.61),(28.6,112.41),(29.4,112.41),(29.4,111.61),(28.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,111.61),(30.2,112.41),(31.0,112.41),(31.0,111.61),(30.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,111.61),(31.8,112.41),(32.6,112.41),(32.6,111.61),(31.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,111.61),(33.4,112.41),(34.2,112.41),(34.2,111.61),(33.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,111.61),(35.0,112.41),(35.8,112.41),(35.8,111.61),(35.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,111.61),(36.6,112.41),(37.4,112.41),(37.4,111.61),(36.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,111.61),(38.2,112.41),(39.0,112.41),(39.0,111.61),(38.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,111.61),(39.8,112.41),(40.6,112.41),(40.6,111.61),(39.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,111.61),(41.4,112.41),(42.2,112.41),(42.2,111.61),(41.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,111.61),(43.0,112.41),(43.8,112.41),(43.8,111.61),(43.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,111.61),(44.6,112.41),(45.4,112.41),(45.4,111.61),(44.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,111.61),(46.2,112.41),(47.0,112.41),(47.0,111.61),(46.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,111.61),(47.8,112.41),(48.6,112.41),(48.6,111.61),(47.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,111.61),(49.4,112.41),(50.2,112.41),(50.2,111.61),(49.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,111.61),(51.0,112.41),(51.8,112.41),(51.8,111.61),(51.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,111.61),(52.6,112.41),(53.4,112.41),(53.4,111.61),(52.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,111.61),(54.2,112.41),(55.0,112.41),(55.0,111.61),(54.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,111.61),(55.8,112.41),(56.6,112.41),(56.6,111.61),(55.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,111.61),(57.4,112.41),(58.2,112.41),(58.2,111.61),(57.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,111.61),(59.0,112.41),(59.8,112.41),(59.8,111.61),(59.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,111.61),(60.6,112.41),(61.4,112.41),(61.4,111.61),(60.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,111.61),(62.2,112.41),(63.0,112.41),(63.0,111.61),(62.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,111.61),(63.8,112.41),(64.6,112.41),(64.6,111.61),(63.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,111.61),(65.4,112.41),(66.2,112.41),(66.2,111.61),(65.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,111.61),(67.0,112.41),(67.8,112.41),(67.8,111.61),(67.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,111.61),(68.6,112.41),(69.4,112.41),(69.4,111.61),(68.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,111.61),(70.2,112.41),(71.0,112.41),(71.0,111.61),(70.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,111.61),(71.8,112.41),(72.6,112.41),(72.6,111.61),(71.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,111.61),(73.4,112.41),(74.2,112.41),(74.2,111.61),(73.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,111.61),(75.0,112.41),(75.8,112.41),(75.8,111.61),(75.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,111.61),(76.6,112.41),(77.4,112.41),(77.4,111.61),(76.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,111.61),(78.2,112.41),(79.0,112.41),(79.0,111.61),(78.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,111.61),(79.8,112.41),(80.6,112.41),(80.6,111.61),(79.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,111.61),(81.4,112.41),(82.2,112.41),(82.2,111.61),(81.4,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,111.61),(83.0,112.41),(83.8,112.41),(83.8,111.61),(83.0,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,111.61),(84.6,112.41),(85.4,112.41),(85.4,111.61),(84.6,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,111.61),(86.2,112.41),(87.0,112.41),(87.0,111.61),(86.2,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,111.61),(87.8,112.41),(88.6,112.41),(88.6,111.61),(87.8,111.61)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,113.21),(1.4,114.01),(2.2,114.01),(2.2,113.21),(1.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,113.21),(3.0,114.01),(3.8,114.01),(3.8,113.21),(3.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,113.21),(4.6,114.01),(5.4,114.01),(5.4,113.21),(4.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,113.21),(6.2,114.01),(7.0,114.01),(7.0,113.21),(6.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,113.21),(7.8,114.01),(8.6,114.01),(8.6,113.21),(7.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,113.21),(9.4,114.01),(10.2,114.01),(10.2,113.21),(9.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,113.21),(11.0,114.01),(11.8,114.01),(11.8,113.21),(11.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,113.21),(12.6,114.01),(13.4,114.01),(13.4,113.21),(12.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,113.21),(14.2,114.01),(15.0,114.01),(15.0,113.21),(14.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,113.21),(15.8,114.01),(16.6,114.01),(16.6,113.21),(15.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,113.21),(17.4,114.01),(18.2,114.01),(18.2,113.21),(17.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,113.21),(19.0,114.01),(19.8,114.01),(19.8,113.21),(19.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,113.21),(20.6,114.01),(21.4,114.01),(21.4,113.21),(20.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,113.21),(22.2,114.01),(23.0,114.01),(23.0,113.21),(22.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,113.21),(23.8,114.01),(24.6,114.01),(24.6,113.21),(23.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,113.21),(25.4,114.01),(26.2,114.01),(26.2,113.21),(25.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,113.21),(27.0,114.01),(27.8,114.01),(27.8,113.21),(27.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,113.21),(28.6,114.01),(29.4,114.01),(29.4,113.21),(28.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,113.21),(30.2,114.01),(31.0,114.01),(31.0,113.21),(30.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,113.21),(31.8,114.01),(32.6,114.01),(32.6,113.21),(31.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,113.21),(33.4,114.01),(34.2,114.01),(34.2,113.21),(33.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,113.21),(35.0,114.01),(35.8,114.01),(35.8,113.21),(35.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,113.21),(36.6,114.01),(37.4,114.01),(37.4,113.21),(36.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,113.21),(38.2,114.01),(39.0,114.01),(39.0,113.21),(38.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,113.21),(39.8,114.01),(40.6,114.01),(40.6,113.21),(39.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,113.21),(41.4,114.01),(42.2,114.01),(42.2,113.21),(41.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,113.21),(43.0,114.01),(43.8,114.01),(43.8,113.21),(43.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,113.21),(44.6,114.01),(45.4,114.01),(45.4,113.21),(44.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,113.21),(46.2,114.01),(47.0,114.01),(47.0,113.21),(46.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,113.21),(47.8,114.01),(48.6,114.01),(48.6,113.21),(47.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,113.21),(49.4,114.01),(50.2,114.01),(50.2,113.21),(49.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,113.21),(51.0,114.01),(51.8,114.01),(51.8,113.21),(51.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,113.21),(52.6,114.01),(53.4,114.01),(53.4,113.21),(52.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,113.21),(54.2,114.01),(55.0,114.01),(55.0,113.21),(54.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,113.21),(55.8,114.01),(56.6,114.01),(56.6,113.21),(55.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,113.21),(57.4,114.01),(58.2,114.01),(58.2,113.21),(57.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,113.21),(59.0,114.01),(59.8,114.01),(59.8,113.21),(59.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,113.21),(60.6,114.01),(61.4,114.01),(61.4,113.21),(60.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,113.21),(62.2,114.01),(63.0,114.01),(63.0,113.21),(62.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,113.21),(63.8,114.01),(64.6,114.01),(64.6,113.21),(63.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,113.21),(65.4,114.01),(66.2,114.01),(66.2,113.21),(65.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,113.21),(67.0,114.01),(67.8,114.01),(67.8,113.21),(67.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,113.21),(68.6,114.01),(69.4,114.01),(69.4,113.21),(68.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,113.21),(70.2,114.01),(71.0,114.01),(71.0,113.21),(70.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,113.21),(71.8,114.01),(72.6,114.01),(72.6,113.21),(71.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,113.21),(73.4,114.01),(74.2,114.01),(74.2,113.21),(73.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,113.21),(75.0,114.01),(75.8,114.01),(75.8,113.21),(75.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,113.21),(76.6,114.01),(77.4,114.01),(77.4,113.21),(76.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,113.21),(78.2,114.01),(79.0,114.01),(79.0,113.21),(78.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,113.21),(79.8,114.01),(80.6,114.01),(80.6,113.21),(79.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,113.21),(81.4,114.01),(82.2,114.01),(82.2,113.21),(81.4,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,113.21),(83.0,114.01),(83.8,114.01),(83.8,113.21),(83.0,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,113.21),(84.6,114.01),(85.4,114.01),(85.4,113.21),(84.6,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,113.21),(86.2,114.01),(87.0,114.01),(87.0,113.21),(86.2,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,113.21),(87.8,114.01),(88.6,114.01),(88.6,113.21),(87.8,113.21)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,114.81),(1.4,115.61),(2.2,115.61),(2.2,114.81),(1.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,114.81),(3.0,115.61),(3.8,115.61),(3.8,114.81),(3.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,114.81),(4.6,115.61),(5.4,115.61),(5.4,114.81),(4.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,114.81),(6.2,115.61),(7.0,115.61),(7.0,114.81),(6.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,114.81),(7.8,115.61),(8.6,115.61),(8.6,114.81),(7.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,114.81),(9.4,115.61),(10.2,115.61),(10.2,114.81),(9.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,114.81),(11.0,115.61),(11.8,115.61),(11.8,114.81),(11.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,114.81),(12.6,115.61),(13.4,115.61),(13.4,114.81),(12.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,114.81),(14.2,115.61),(15.0,115.61),(15.0,114.81),(14.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,114.81),(15.8,115.61),(16.6,115.61),(16.6,114.81),(15.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,114.81),(17.4,115.61),(18.2,115.61),(18.2,114.81),(17.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,114.81),(19.0,115.61),(19.8,115.61),(19.8,114.81),(19.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,114.81),(20.6,115.61),(21.4,115.61),(21.4,114.81),(20.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,114.81),(22.2,115.61),(23.0,115.61),(23.0,114.81),(22.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,114.81),(23.8,115.61),(24.6,115.61),(24.6,114.81),(23.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,114.81),(25.4,115.61),(26.2,115.61),(26.2,114.81),(25.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,114.81),(27.0,115.61),(27.8,115.61),(27.8,114.81),(27.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,114.81),(28.6,115.61),(29.4,115.61),(29.4,114.81),(28.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,114.81),(30.2,115.61),(31.0,115.61),(31.0,114.81),(30.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,114.81),(31.8,115.61),(32.6,115.61),(32.6,114.81),(31.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,114.81),(33.4,115.61),(34.2,115.61),(34.2,114.81),(33.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,114.81),(35.0,115.61),(35.8,115.61),(35.8,114.81),(35.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,114.81),(36.6,115.61),(37.4,115.61),(37.4,114.81),(36.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,114.81),(38.2,115.61),(39.0,115.61),(39.0,114.81),(38.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,114.81),(39.8,115.61),(40.6,115.61),(40.6,114.81),(39.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,114.81),(41.4,115.61),(42.2,115.61),(42.2,114.81),(41.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,114.81),(43.0,115.61),(43.8,115.61),(43.8,114.81),(43.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,114.81),(44.6,115.61),(45.4,115.61),(45.4,114.81),(44.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,114.81),(46.2,115.61),(47.0,115.61),(47.0,114.81),(46.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,114.81),(47.8,115.61),(48.6,115.61),(48.6,114.81),(47.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,114.81),(49.4,115.61),(50.2,115.61),(50.2,114.81),(49.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,114.81),(51.0,115.61),(51.8,115.61),(51.8,114.81),(51.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,114.81),(52.6,115.61),(53.4,115.61),(53.4,114.81),(52.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,114.81),(54.2,115.61),(55.0,115.61),(55.0,114.81),(54.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,114.81),(55.8,115.61),(56.6,115.61),(56.6,114.81),(55.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,114.81),(57.4,115.61),(58.2,115.61),(58.2,114.81),(57.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,114.81),(59.0,115.61),(59.8,115.61),(59.8,114.81),(59.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,114.81),(60.6,115.61),(61.4,115.61),(61.4,114.81),(60.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,114.81),(62.2,115.61),(63.0,115.61),(63.0,114.81),(62.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,114.81),(63.8,115.61),(64.6,115.61),(64.6,114.81),(63.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,114.81),(65.4,115.61),(66.2,115.61),(66.2,114.81),(65.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,114.81),(67.0,115.61),(67.8,115.61),(67.8,114.81),(67.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,114.81),(68.6,115.61),(69.4,115.61),(69.4,114.81),(68.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,114.81),(70.2,115.61),(71.0,115.61),(71.0,114.81),(70.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,114.81),(71.8,115.61),(72.6,115.61),(72.6,114.81),(71.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,114.81),(73.4,115.61),(74.2,115.61),(74.2,114.81),(73.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,114.81),(75.0,115.61),(75.8,115.61),(75.8,114.81),(75.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,114.81),(76.6,115.61),(77.4,115.61),(77.4,114.81),(76.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,114.81),(78.2,115.61),(79.0,115.61),(79.0,114.81),(78.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,114.81),(79.8,115.61),(80.6,115.61),(80.6,114.81),(79.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,114.81),(81.4,115.61),(82.2,115.61),(82.2,114.81),(81.4,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,114.81),(83.0,115.61),(83.8,115.61),(83.8,114.81),(83.0,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,114.81),(84.6,115.61),(85.4,115.61),(85.4,114.81),(84.6,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,114.81),(86.2,115.61),(87.0,115.61),(87.0,114.81),(86.2,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,114.81),(87.8,115.61),(88.6,115.61),(88.6,114.81),(87.8,114.81)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,121.77),(1.4,122.57),(2.2,122.57),(2.2,121.77),(1.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,121.77),(3.0,122.57),(3.8,122.57),(3.8,121.77),(3.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,121.77),(4.6,122.57),(5.4,122.57),(5.4,121.77),(4.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,121.77),(6.2,122.57),(7.0,122.57),(7.0,121.77),(6.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,121.77),(7.8,122.57),(8.6,122.57),(8.6,121.77),(7.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,121.77),(9.4,122.57),(10.2,122.57),(10.2,121.77),(9.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,121.77),(11.0,122.57),(11.8,122.57),(11.8,121.77),(11.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,121.77),(12.6,122.57),(13.4,122.57),(13.4,121.77),(12.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,121.77),(14.2,122.57),(15.0,122.57),(15.0,121.77),(14.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,121.77),(15.8,122.57),(16.6,122.57),(16.6,121.77),(15.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,121.77),(17.4,122.57),(18.2,122.57),(18.2,121.77),(17.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,121.77),(19.0,122.57),(19.8,122.57),(19.8,121.77),(19.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,121.77),(20.6,122.57),(21.4,122.57),(21.4,121.77),(20.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,121.77),(22.2,122.57),(23.0,122.57),(23.0,121.77),(22.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,121.77),(23.8,122.57),(24.6,122.57),(24.6,121.77),(23.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,121.77),(25.4,122.57),(26.2,122.57),(26.2,121.77),(25.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,121.77),(27.0,122.57),(27.8,122.57),(27.8,121.77),(27.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,121.77),(28.6,122.57),(29.4,122.57),(29.4,121.77),(28.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,121.77),(30.2,122.57),(31.0,122.57),(31.0,121.77),(30.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,121.77),(31.8,122.57),(32.6,122.57),(32.6,121.77),(31.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,121.77),(33.4,122.57),(34.2,122.57),(34.2,121.77),(33.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,121.77),(35.0,122.57),(35.8,122.57),(35.8,121.77),(35.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,121.77),(36.6,122.57),(37.4,122.57),(37.4,121.77),(36.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,121.77),(38.2,122.57),(39.0,122.57),(39.0,121.77),(38.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,121.77),(39.8,122.57),(40.6,122.57),(40.6,121.77),(39.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,121.77),(41.4,122.57),(42.2,122.57),(42.2,121.77),(41.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,121.77),(43.0,122.57),(43.8,122.57),(43.8,121.77),(43.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,121.77),(44.6,122.57),(45.4,122.57),(45.4,121.77),(44.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,121.77),(46.2,122.57),(47.0,122.57),(47.0,121.77),(46.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,121.77),(47.8,122.57),(48.6,122.57),(48.6,121.77),(47.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,121.77),(49.4,122.57),(50.2,122.57),(50.2,121.77),(49.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,121.77),(51.0,122.57),(51.8,122.57),(51.8,121.77),(51.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,121.77),(52.6,122.57),(53.4,122.57),(53.4,121.77),(52.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,121.77),(54.2,122.57),(55.0,122.57),(55.0,121.77),(54.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,121.77),(55.8,122.57),(56.6,122.57),(56.6,121.77),(55.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,121.77),(57.4,122.57),(58.2,122.57),(58.2,121.77),(57.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,121.77),(59.0,122.57),(59.8,122.57),(59.8,121.77),(59.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,121.77),(60.6,122.57),(61.4,122.57),(61.4,121.77),(60.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,121.77),(62.2,122.57),(63.0,122.57),(63.0,121.77),(62.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,121.77),(63.8,122.57),(64.6,122.57),(64.6,121.77),(63.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,121.77),(65.4,122.57),(66.2,122.57),(66.2,121.77),(65.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,121.77),(67.0,122.57),(67.8,122.57),(67.8,121.77),(67.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,121.77),(68.6,122.57),(69.4,122.57),(69.4,121.77),(68.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,121.77),(70.2,122.57),(71.0,122.57),(71.0,121.77),(70.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,121.77),(71.8,122.57),(72.6,122.57),(72.6,121.77),(71.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,121.77),(73.4,122.57),(74.2,122.57),(74.2,121.77),(73.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,121.77),(75.0,122.57),(75.8,122.57),(75.8,121.77),(75.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,121.77),(76.6,122.57),(77.4,122.57),(77.4,121.77),(76.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,121.77),(78.2,122.57),(79.0,122.57),(79.0,121.77),(78.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,121.77),(79.8,122.57),(80.6,122.57),(80.6,121.77),(79.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,121.77),(81.4,122.57),(82.2,122.57),(82.2,121.77),(81.4,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,121.77),(83.0,122.57),(83.8,122.57),(83.8,121.77),(83.0,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,121.77),(84.6,122.57),(85.4,122.57),(85.4,121.77),(84.6,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,121.77),(86.2,122.57),(87.0,122.57),(87.0,121.77),(86.2,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,121.77),(87.8,122.57),(88.6,122.57),(88.6,121.77),(87.8,121.77)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,123.37),(1.4,124.17),(2.2,124.17),(2.2,123.37),(1.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,123.37),(3.0,124.17),(3.8,124.17),(3.8,123.37),(3.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,123.37),(4.6,124.17),(5.4,124.17),(5.4,123.37),(4.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,123.37),(6.2,124.17),(7.0,124.17),(7.0,123.37),(6.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,123.37),(7.8,124.17),(8.6,124.17),(8.6,123.37),(7.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,123.37),(9.4,124.17),(10.2,124.17),(10.2,123.37),(9.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,123.37),(11.0,124.17),(11.8,124.17),(11.8,123.37),(11.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,123.37),(12.6,124.17),(13.4,124.17),(13.4,123.37),(12.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,123.37),(14.2,124.17),(15.0,124.17),(15.0,123.37),(14.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,123.37),(15.8,124.17),(16.6,124.17),(16.6,123.37),(15.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,123.37),(17.4,124.17),(18.2,124.17),(18.2,123.37),(17.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,123.37),(19.0,124.17),(19.8,124.17),(19.8,123.37),(19.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,123.37),(20.6,124.17),(21.4,124.17),(21.4,123.37),(20.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,123.37),(22.2,124.17),(23.0,124.17),(23.0,123.37),(22.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,123.37),(23.8,124.17),(24.6,124.17),(24.6,123.37),(23.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,123.37),(25.4,124.17),(26.2,124.17),(26.2,123.37),(25.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,123.37),(27.0,124.17),(27.8,124.17),(27.8,123.37),(27.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,123.37),(28.6,124.17),(29.4,124.17),(29.4,123.37),(28.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,123.37),(30.2,124.17),(31.0,124.17),(31.0,123.37),(30.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,123.37),(31.8,124.17),(32.6,124.17),(32.6,123.37),(31.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,123.37),(33.4,124.17),(34.2,124.17),(34.2,123.37),(33.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,123.37),(35.0,124.17),(35.8,124.17),(35.8,123.37),(35.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,123.37),(36.6,124.17),(37.4,124.17),(37.4,123.37),(36.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,123.37),(38.2,124.17),(39.0,124.17),(39.0,123.37),(38.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,123.37),(39.8,124.17),(40.6,124.17),(40.6,123.37),(39.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,123.37),(41.4,124.17),(42.2,124.17),(42.2,123.37),(41.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,123.37),(43.0,124.17),(43.8,124.17),(43.8,123.37),(43.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,123.37),(44.6,124.17),(45.4,124.17),(45.4,123.37),(44.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,123.37),(46.2,124.17),(47.0,124.17),(47.0,123.37),(46.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,123.37),(47.8,124.17),(48.6,124.17),(48.6,123.37),(47.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,123.37),(49.4,124.17),(50.2,124.17),(50.2,123.37),(49.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,123.37),(51.0,124.17),(51.8,124.17),(51.8,123.37),(51.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,123.37),(52.6,124.17),(53.4,124.17),(53.4,123.37),(52.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,123.37),(54.2,124.17),(55.0,124.17),(55.0,123.37),(54.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,123.37),(55.8,124.17),(56.6,124.17),(56.6,123.37),(55.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,123.37),(57.4,124.17),(58.2,124.17),(58.2,123.37),(57.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,123.37),(59.0,124.17),(59.8,124.17),(59.8,123.37),(59.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,123.37),(60.6,124.17),(61.4,124.17),(61.4,123.37),(60.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,123.37),(62.2,124.17),(63.0,124.17),(63.0,123.37),(62.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,123.37),(63.8,124.17),(64.6,124.17),(64.6,123.37),(63.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,123.37),(65.4,124.17),(66.2,124.17),(66.2,123.37),(65.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,123.37),(67.0,124.17),(67.8,124.17),(67.8,123.37),(67.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,123.37),(68.6,124.17),(69.4,124.17),(69.4,123.37),(68.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,123.37),(70.2,124.17),(71.0,124.17),(71.0,123.37),(70.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,123.37),(71.8,124.17),(72.6,124.17),(72.6,123.37),(71.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,123.37),(73.4,124.17),(74.2,124.17),(74.2,123.37),(73.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,123.37),(75.0,124.17),(75.8,124.17),(75.8,123.37),(75.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,123.37),(76.6,124.17),(77.4,124.17),(77.4,123.37),(76.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,123.37),(78.2,124.17),(79.0,124.17),(79.0,123.37),(78.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,123.37),(79.8,124.17),(80.6,124.17),(80.6,123.37),(79.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,123.37),(81.4,124.17),(82.2,124.17),(82.2,123.37),(81.4,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,123.37),(83.0,124.17),(83.8,124.17),(83.8,123.37),(83.0,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,123.37),(84.6,124.17),(85.4,124.17),(85.4,123.37),(84.6,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,123.37),(86.2,124.17),(87.0,124.17),(87.0,123.37),(86.2,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,123.37),(87.8,124.17),(88.6,124.17),(88.6,123.37),(87.8,123.37)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,124.97),(1.4,125.77),(2.2,125.77),(2.2,124.97),(1.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,124.97),(3.0,125.77),(3.8,125.77),(3.8,124.97),(3.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,124.97),(4.6,125.77),(5.4,125.77),(5.4,124.97),(4.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,124.97),(6.2,125.77),(7.0,125.77),(7.0,124.97),(6.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,124.97),(7.8,125.77),(8.6,125.77),(8.6,124.97),(7.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,124.97),(9.4,125.77),(10.2,125.77),(10.2,124.97),(9.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,124.97),(11.0,125.77),(11.8,125.77),(11.8,124.97),(11.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,124.97),(12.6,125.77),(13.4,125.77),(13.4,124.97),(12.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,124.97),(14.2,125.77),(15.0,125.77),(15.0,124.97),(14.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,124.97),(15.8,125.77),(16.6,125.77),(16.6,124.97),(15.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,124.97),(17.4,125.77),(18.2,125.77),(18.2,124.97),(17.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,124.97),(19.0,125.77),(19.8,125.77),(19.8,124.97),(19.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,124.97),(20.6,125.77),(21.4,125.77),(21.4,124.97),(20.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,124.97),(22.2,125.77),(23.0,125.77),(23.0,124.97),(22.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,124.97),(23.8,125.77),(24.6,125.77),(24.6,124.97),(23.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,124.97),(25.4,125.77),(26.2,125.77),(26.2,124.97),(25.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,124.97),(27.0,125.77),(27.8,125.77),(27.8,124.97),(27.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,124.97),(28.6,125.77),(29.4,125.77),(29.4,124.97),(28.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,124.97),(30.2,125.77),(31.0,125.77),(31.0,124.97),(30.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,124.97),(31.8,125.77),(32.6,125.77),(32.6,124.97),(31.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,124.97),(33.4,125.77),(34.2,125.77),(34.2,124.97),(33.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,124.97),(35.0,125.77),(35.8,125.77),(35.8,124.97),(35.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,124.97),(36.6,125.77),(37.4,125.77),(37.4,124.97),(36.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,124.97),(38.2,125.77),(39.0,125.77),(39.0,124.97),(38.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,124.97),(39.8,125.77),(40.6,125.77),(40.6,124.97),(39.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,124.97),(41.4,125.77),(42.2,125.77),(42.2,124.97),(41.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,124.97),(43.0,125.77),(43.8,125.77),(43.8,124.97),(43.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,124.97),(44.6,125.77),(45.4,125.77),(45.4,124.97),(44.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,124.97),(46.2,125.77),(47.0,125.77),(47.0,124.97),(46.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,124.97),(47.8,125.77),(48.6,125.77),(48.6,124.97),(47.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,124.97),(49.4,125.77),(50.2,125.77),(50.2,124.97),(49.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,124.97),(51.0,125.77),(51.8,125.77),(51.8,124.97),(51.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,124.97),(52.6,125.77),(53.4,125.77),(53.4,124.97),(52.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,124.97),(54.2,125.77),(55.0,125.77),(55.0,124.97),(54.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,124.97),(55.8,125.77),(56.6,125.77),(56.6,124.97),(55.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,124.97),(57.4,125.77),(58.2,125.77),(58.2,124.97),(57.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,124.97),(59.0,125.77),(59.8,125.77),(59.8,124.97),(59.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,124.97),(60.6,125.77),(61.4,125.77),(61.4,124.97),(60.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,124.97),(62.2,125.77),(63.0,125.77),(63.0,124.97),(62.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,124.97),(63.8,125.77),(64.6,125.77),(64.6,124.97),(63.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,124.97),(65.4,125.77),(66.2,125.77),(66.2,124.97),(65.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,124.97),(67.0,125.77),(67.8,125.77),(67.8,124.97),(67.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,124.97),(68.6,125.77),(69.4,125.77),(69.4,124.97),(68.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,124.97),(70.2,125.77),(71.0,125.77),(71.0,124.97),(70.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,124.97),(71.8,125.77),(72.6,125.77),(72.6,124.97),(71.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,124.97),(73.4,125.77),(74.2,125.77),(74.2,124.97),(73.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,124.97),(75.0,125.77),(75.8,125.77),(75.8,124.97),(75.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,124.97),(76.6,125.77),(77.4,125.77),(77.4,124.97),(76.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,124.97),(78.2,125.77),(79.0,125.77),(79.0,124.97),(78.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,124.97),(79.8,125.77),(80.6,125.77),(80.6,124.97),(79.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,124.97),(81.4,125.77),(82.2,125.77),(82.2,124.97),(81.4,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,124.97),(83.0,125.77),(83.8,125.77),(83.8,124.97),(83.0,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,124.97),(84.6,125.77),(85.4,125.77),(85.4,124.97),(84.6,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,124.97),(86.2,125.77),(87.0,125.77),(87.0,124.97),(86.2,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,124.97),(87.8,125.77),(88.6,125.77),(88.6,124.97),(87.8,124.97)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,126.57),(1.4,127.37),(2.2,127.37),(2.2,126.57),(1.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,126.57),(3.0,127.37),(3.8,127.37),(3.8,126.57),(3.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,126.57),(4.6,127.37),(5.4,127.37),(5.4,126.57),(4.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,126.57),(6.2,127.37),(7.0,127.37),(7.0,126.57),(6.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,126.57),(7.8,127.37),(8.6,127.37),(8.6,126.57),(7.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,126.57),(9.4,127.37),(10.2,127.37),(10.2,126.57),(9.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,126.57),(11.0,127.37),(11.8,127.37),(11.8,126.57),(11.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,126.57),(12.6,127.37),(13.4,127.37),(13.4,126.57),(12.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,126.57),(14.2,127.37),(15.0,127.37),(15.0,126.57),(14.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,126.57),(15.8,127.37),(16.6,127.37),(16.6,126.57),(15.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,126.57),(17.4,127.37),(18.2,127.37),(18.2,126.57),(17.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,126.57),(19.0,127.37),(19.8,127.37),(19.8,126.57),(19.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,126.57),(20.6,127.37),(21.4,127.37),(21.4,126.57),(20.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,126.57),(22.2,127.37),(23.0,127.37),(23.0,126.57),(22.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,126.57),(23.8,127.37),(24.6,127.37),(24.6,126.57),(23.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,126.57),(25.4,127.37),(26.2,127.37),(26.2,126.57),(25.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,126.57),(27.0,127.37),(27.8,127.37),(27.8,126.57),(27.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,126.57),(28.6,127.37),(29.4,127.37),(29.4,126.57),(28.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,126.57),(30.2,127.37),(31.0,127.37),(31.0,126.57),(30.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,126.57),(31.8,127.37),(32.6,127.37),(32.6,126.57),(31.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,126.57),(33.4,127.37),(34.2,127.37),(34.2,126.57),(33.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,126.57),(35.0,127.37),(35.8,127.37),(35.8,126.57),(35.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,126.57),(36.6,127.37),(37.4,127.37),(37.4,126.57),(36.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,126.57),(38.2,127.37),(39.0,127.37),(39.0,126.57),(38.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,126.57),(39.8,127.37),(40.6,127.37),(40.6,126.57),(39.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,126.57),(41.4,127.37),(42.2,127.37),(42.2,126.57),(41.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,126.57),(43.0,127.37),(43.8,127.37),(43.8,126.57),(43.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,126.57),(44.6,127.37),(45.4,127.37),(45.4,126.57),(44.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,126.57),(46.2,127.37),(47.0,127.37),(47.0,126.57),(46.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,126.57),(47.8,127.37),(48.6,127.37),(48.6,126.57),(47.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,126.57),(49.4,127.37),(50.2,127.37),(50.2,126.57),(49.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,126.57),(51.0,127.37),(51.8,127.37),(51.8,126.57),(51.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,126.57),(52.6,127.37),(53.4,127.37),(53.4,126.57),(52.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,126.57),(54.2,127.37),(55.0,127.37),(55.0,126.57),(54.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,126.57),(55.8,127.37),(56.6,127.37),(56.6,126.57),(55.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,126.57),(57.4,127.37),(58.2,127.37),(58.2,126.57),(57.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,126.57),(59.0,127.37),(59.8,127.37),(59.8,126.57),(59.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,126.57),(60.6,127.37),(61.4,127.37),(61.4,126.57),(60.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,126.57),(62.2,127.37),(63.0,127.37),(63.0,126.57),(62.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,126.57),(63.8,127.37),(64.6,127.37),(64.6,126.57),(63.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,126.57),(65.4,127.37),(66.2,127.37),(66.2,126.57),(65.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,126.57),(67.0,127.37),(67.8,127.37),(67.8,126.57),(67.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,126.57),(68.6,127.37),(69.4,127.37),(69.4,126.57),(68.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,126.57),(70.2,127.37),(71.0,127.37),(71.0,126.57),(70.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,126.57),(71.8,127.37),(72.6,127.37),(72.6,126.57),(71.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,126.57),(73.4,127.37),(74.2,127.37),(74.2,126.57),(73.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,126.57),(75.0,127.37),(75.8,127.37),(75.8,126.57),(75.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,126.57),(76.6,127.37),(77.4,127.37),(77.4,126.57),(76.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,126.57),(78.2,127.37),(79.0,127.37),(79.0,126.57),(78.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,126.57),(79.8,127.37),(80.6,127.37),(80.6,126.57),(79.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,126.57),(81.4,127.37),(82.2,127.37),(82.2,126.57),(81.4,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,126.57),(83.0,127.37),(83.8,127.37),(83.8,126.57),(83.0,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,126.57),(84.6,127.37),(85.4,127.37),(85.4,126.57),(84.6,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,126.57),(86.2,127.37),(87.0,127.37),(87.0,126.57),(86.2,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,126.57),(87.8,127.37),(88.6,127.37),(88.6,126.57),(87.8,126.57)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,128.17),(1.4,128.97),(2.2,128.97),(2.2,128.17),(1.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,128.17),(3.0,128.97),(3.8,128.97),(3.8,128.17),(3.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,128.17),(4.6,128.97),(5.4,128.97),(5.4,128.17),(4.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,128.17),(6.2,128.97),(7.0,128.97),(7.0,128.17),(6.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,128.17),(7.8,128.97),(8.6,128.97),(8.6,128.17),(7.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,128.17),(9.4,128.97),(10.2,128.97),(10.2,128.17),(9.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,128.17),(11.0,128.97),(11.8,128.97),(11.8,128.17),(11.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,128.17),(12.6,128.97),(13.4,128.97),(13.4,128.17),(12.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,128.17),(14.2,128.97),(15.0,128.97),(15.0,128.17),(14.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,128.17),(15.8,128.97),(16.6,128.97),(16.6,128.17),(15.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,128.17),(17.4,128.97),(18.2,128.97),(18.2,128.17),(17.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,128.17),(19.0,128.97),(19.8,128.97),(19.8,128.17),(19.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,128.17),(20.6,128.97),(21.4,128.97),(21.4,128.17),(20.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,128.17),(22.2,128.97),(23.0,128.97),(23.0,128.17),(22.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,128.17),(23.8,128.97),(24.6,128.97),(24.6,128.17),(23.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,128.17),(25.4,128.97),(26.2,128.97),(26.2,128.17),(25.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,128.17),(27.0,128.97),(27.8,128.97),(27.8,128.17),(27.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,128.17),(28.6,128.97),(29.4,128.97),(29.4,128.17),(28.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,128.17),(30.2,128.97),(31.0,128.97),(31.0,128.17),(30.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,128.17),(31.8,128.97),(32.6,128.97),(32.6,128.17),(31.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,128.17),(33.4,128.97),(34.2,128.97),(34.2,128.17),(33.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,128.17),(35.0,128.97),(35.8,128.97),(35.8,128.17),(35.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,128.17),(36.6,128.97),(37.4,128.97),(37.4,128.17),(36.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,128.17),(38.2,128.97),(39.0,128.97),(39.0,128.17),(38.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,128.17),(39.8,128.97),(40.6,128.97),(40.6,128.17),(39.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,128.17),(41.4,128.97),(42.2,128.97),(42.2,128.17),(41.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,128.17),(43.0,128.97),(43.8,128.97),(43.8,128.17),(43.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,128.17),(44.6,128.97),(45.4,128.97),(45.4,128.17),(44.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,128.17),(46.2,128.97),(47.0,128.97),(47.0,128.17),(46.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,128.17),(47.8,128.97),(48.6,128.97),(48.6,128.17),(47.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,128.17),(49.4,128.97),(50.2,128.97),(50.2,128.17),(49.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,128.17),(51.0,128.97),(51.8,128.97),(51.8,128.17),(51.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,128.17),(52.6,128.97),(53.4,128.97),(53.4,128.17),(52.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,128.17),(54.2,128.97),(55.0,128.97),(55.0,128.17),(54.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,128.17),(55.8,128.97),(56.6,128.97),(56.6,128.17),(55.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,128.17),(57.4,128.97),(58.2,128.97),(58.2,128.17),(57.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,128.17),(59.0,128.97),(59.8,128.97),(59.8,128.17),(59.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,128.17),(60.6,128.97),(61.4,128.97),(61.4,128.17),(60.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,128.17),(62.2,128.97),(63.0,128.97),(63.0,128.17),(62.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,128.17),(63.8,128.97),(64.6,128.97),(64.6,128.17),(63.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,128.17),(65.4,128.97),(66.2,128.97),(66.2,128.17),(65.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,128.17),(67.0,128.97),(67.8,128.97),(67.8,128.17),(67.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,128.17),(68.6,128.97),(69.4,128.97),(69.4,128.17),(68.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,128.17),(70.2,128.97),(71.0,128.97),(71.0,128.17),(70.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,128.17),(71.8,128.97),(72.6,128.97),(72.6,128.17),(71.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,128.17),(73.4,128.97),(74.2,128.97),(74.2,128.17),(73.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,128.17),(75.0,128.97),(75.8,128.97),(75.8,128.17),(75.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,128.17),(76.6,128.97),(77.4,128.97),(77.4,128.17),(76.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,128.17),(78.2,128.97),(79.0,128.97),(79.0,128.17),(78.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,128.17),(79.8,128.97),(80.6,128.97),(80.6,128.17),(79.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,128.17),(81.4,128.97),(82.2,128.97),(82.2,128.17),(81.4,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,128.17),(83.0,128.97),(83.8,128.97),(83.8,128.17),(83.0,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,128.17),(84.6,128.97),(85.4,128.97),(85.4,128.17),(84.6,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,128.17),(86.2,128.97),(87.0,128.97),(87.0,128.17),(86.2,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,128.17),(87.8,128.97),(88.6,128.97),(88.6,128.17),(87.8,128.17)),
        )
        createRL(
            tech, net, 'via4',
            ((1.4,129.77),(1.4,130.57),(2.2,130.57),(2.2,129.77),(1.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((3.0,129.77),(3.0,130.57),(3.8,130.57),(3.8,129.77),(3.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((4.6,129.77),(4.6,130.57),(5.4,130.57),(5.4,129.77),(4.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((6.2,129.77),(6.2,130.57),(7.0,130.57),(7.0,129.77),(6.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((7.8,129.77),(7.8,130.57),(8.6,130.57),(8.6,129.77),(7.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((9.4,129.77),(9.4,130.57),(10.2,130.57),(10.2,129.77),(9.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((11.0,129.77),(11.0,130.57),(11.8,130.57),(11.8,129.77),(11.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((12.6,129.77),(12.6,130.57),(13.4,130.57),(13.4,129.77),(12.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((14.2,129.77),(14.2,130.57),(15.0,130.57),(15.0,129.77),(14.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((15.8,129.77),(15.8,130.57),(16.6,130.57),(16.6,129.77),(15.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((17.4,129.77),(17.4,130.57),(18.2,130.57),(18.2,129.77),(17.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((19.0,129.77),(19.0,130.57),(19.8,130.57),(19.8,129.77),(19.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((20.6,129.77),(20.6,130.57),(21.4,130.57),(21.4,129.77),(20.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((22.2,129.77),(22.2,130.57),(23.0,130.57),(23.0,129.77),(22.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((23.8,129.77),(23.8,130.57),(24.6,130.57),(24.6,129.77),(23.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((25.4,129.77),(25.4,130.57),(26.2,130.57),(26.2,129.77),(25.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((27.0,129.77),(27.0,130.57),(27.8,130.57),(27.8,129.77),(27.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((28.6,129.77),(28.6,130.57),(29.4,130.57),(29.4,129.77),(28.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((30.2,129.77),(30.2,130.57),(31.0,130.57),(31.0,129.77),(30.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((31.8,129.77),(31.8,130.57),(32.6,130.57),(32.6,129.77),(31.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((33.4,129.77),(33.4,130.57),(34.2,130.57),(34.2,129.77),(33.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((35.0,129.77),(35.0,130.57),(35.8,130.57),(35.8,129.77),(35.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((36.6,129.77),(36.6,130.57),(37.4,130.57),(37.4,129.77),(36.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((38.2,129.77),(38.2,130.57),(39.0,130.57),(39.0,129.77),(38.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((39.8,129.77),(39.8,130.57),(40.6,130.57),(40.6,129.77),(39.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((41.4,129.77),(41.4,130.57),(42.2,130.57),(42.2,129.77),(41.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((43.0,129.77),(43.0,130.57),(43.8,130.57),(43.8,129.77),(43.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((44.6,129.77),(44.6,130.57),(45.4,130.57),(45.4,129.77),(44.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((46.2,129.77),(46.2,130.57),(47.0,130.57),(47.0,129.77),(46.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((47.8,129.77),(47.8,130.57),(48.6,130.57),(48.6,129.77),(47.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((49.4,129.77),(49.4,130.57),(50.2,130.57),(50.2,129.77),(49.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((51.0,129.77),(51.0,130.57),(51.8,130.57),(51.8,129.77),(51.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((52.6,129.77),(52.6,130.57),(53.4,130.57),(53.4,129.77),(52.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((54.2,129.77),(54.2,130.57),(55.0,130.57),(55.0,129.77),(54.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((55.8,129.77),(55.8,130.57),(56.6,130.57),(56.6,129.77),(55.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((57.4,129.77),(57.4,130.57),(58.2,130.57),(58.2,129.77),(57.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((59.0,129.77),(59.0,130.57),(59.8,130.57),(59.8,129.77),(59.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((60.6,129.77),(60.6,130.57),(61.4,130.57),(61.4,129.77),(60.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((62.2,129.77),(62.2,130.57),(63.0,130.57),(63.0,129.77),(62.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((63.8,129.77),(63.8,130.57),(64.6,130.57),(64.6,129.77),(63.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((65.4,129.77),(65.4,130.57),(66.2,130.57),(66.2,129.77),(65.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((67.0,129.77),(67.0,130.57),(67.8,130.57),(67.8,129.77),(67.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((68.6,129.77),(68.6,130.57),(69.4,130.57),(69.4,129.77),(68.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((70.2,129.77),(70.2,130.57),(71.0,130.57),(71.0,129.77),(70.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((71.8,129.77),(71.8,130.57),(72.6,130.57),(72.6,129.77),(71.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((73.4,129.77),(73.4,130.57),(74.2,130.57),(74.2,129.77),(73.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((75.0,129.77),(75.0,130.57),(75.8,130.57),(75.8,129.77),(75.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((76.6,129.77),(76.6,130.57),(77.4,130.57),(77.4,129.77),(76.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((78.2,129.77),(78.2,130.57),(79.0,130.57),(79.0,129.77),(78.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((79.8,129.77),(79.8,130.57),(80.6,130.57),(80.6,129.77),(79.8,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((81.4,129.77),(81.4,130.57),(82.2,130.57),(82.2,129.77),(81.4,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((83.0,129.77),(83.0,130.57),(83.8,130.57),(83.8,129.77),(83.0,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((84.6,129.77),(84.6,130.57),(85.4,130.57),(85.4,129.77),(84.6,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((86.2,129.77),(86.2,130.57),(87.0,130.57),(87.0,129.77),(86.2,129.77)),
        )
        createRL(
            tech, net, 'via4',
            ((87.8,129.77),(87.8,130.57),(88.6,130.57),(88.6,129.77),(87.8,129.77)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,90.8),(0.0,101.74),(90.0,101.74),(90.0,90.8),(0.0,90.8)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,105.74),(0.0,116.68),(90.0,116.68),(90.0,105.74),(0.0,105.74)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        createRL(
            tech, net, 'm5',
            ((0.0,120.7),(0.0,131.64),(90.0,131.64),(90.0,120.7),(0.0,120.7)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(126.17), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(96.27), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(111.21), u(13.74), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(111.21), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(126.17), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(96.27), u(10.94), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'li',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((73.61,88.09),(73.61,88.26),(74.14,88.26),(74.14,88.09),(73.61,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((59.09,88.09),(59.09,88.26),(59.26,88.26),(59.26,88.09),(59.09,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'li',
            ((30.8,88.09),(30.8,88.26),(30.97,88.26),(30.97,88.09),(30.8,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.145,88.09),(40.145,88.26),(40.315,88.26),(40.315,88.09),(40.145,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.61,88.09),(73.61,88.26),(73.78,88.26),(73.78,88.09),(73.61,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.97,88.09),(73.97,88.26),(74.14,88.26),(74.14,88.09),(73.97,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.545,88.09),(54.545,88.26),(54.715,88.26),(54.715,88.09),(54.545,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.345,88.09),(35.345,88.26),(35.515,88.26),(35.515,88.09),(35.345,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.09,88.09),(59.09,88.26),(59.26,88.26),(59.26,88.09),(59.09,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.945,88.09),(44.945,88.26),(45.115,88.26),(45.115,88.09),(44.945,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.745,88.09),(49.745,88.26),(49.915,88.26),(49.915,88.09),(49.745,88.09)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.8,88.09),(30.8,88.26),(30.97,88.26),(30.97,88.09),(30.8,88.09)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,88.3),(49.915,88.3),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,88.3),(49.93,88.3),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,133.04),(35.515,133.04),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,132.98),(54.73,132.98),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,133.04),(35.53,133.04),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,88.3),(35.515,88.3),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,131.365),(40.315,131.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,88.3),(35.53,88.3),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,133.04),(49.915,133.04),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,133.04),(49.93,133.04),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,130.265),(45.115,130.265),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,91.365),(40.315,91.365),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,133.04),(40.315,133.04),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,133.04),(40.33,133.04),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,88.3),(40.315,88.3),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.715,88.03),(49.715,88.32),(49.945,88.32),(49.945,88.03),(49.715,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,87.93),(30.725,132.98),(30.985,132.98),(30.985,87.93),(30.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,88.3),(40.33,88.3),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,87.93),(59.03,131.365),(59.26,131.365),(59.26,87.93),(59.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,87.93),(73.55,111.07),(74.14,111.07),(74.14,87.93),(73.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,87.93),(59.015,132.98),(59.275,132.98),(59.275,87.93),(59.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,87.93),(59.03,91.365),(59.26,91.365),(59.26,87.93),(59.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,87.93),(73.55,91.365),(74.14,91.365),(74.14,87.93),(73.55,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.515,88.03),(54.515,88.32),(54.745,88.32),(54.745,88.03),(54.515,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,130.265),(35.515,130.265),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.315,88.03),(35.315,88.32),(35.545,88.32),(35.545,88.03),(35.315,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,133.04),(54.715,133.04),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,133.04),(54.73,133.04),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,88.3),(45.115,88.3),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.915,88.03),(44.915,88.32),(45.145,88.32),(45.145,88.03),(44.915,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,88.3),(45.13,88.3),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,133.04),(45.115,133.04),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,133.04),(45.13,133.04),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,130.265),(49.915,130.265),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,130.265),(54.715,130.265),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,87.93),(30.725,133.04),(30.985,133.04),(30.985,87.93),(30.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,87.93),(30.74,133.04),(30.97,133.04),(30.97,87.93),(30.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,87.93),(30.74,130.265),(30.97,130.265),(30.97,87.93),(30.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,87.93),(59.03,133.04),(59.26,133.04),(59.26,87.93),(59.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,87.93),(59.015,133.04),(59.275,133.04),(59.275,87.93),(59.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,87.93),(54.47,88.3),(54.73,88.3),(54.73,87.93),(54.47,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,87.93),(59.015,88.3),(59.275,88.3),(59.275,87.93),(59.015,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,87.93),(59.03,88.3),(59.26,88.3),(59.26,87.93),(59.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,91.365),(49.915,91.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.77,88.03),(30.77,88.32),(31.0,88.32),(31.0,88.03),(30.77,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,131.365),(35.515,131.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,91.365),(45.115,91.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,131.365),(54.715,131.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,87.93),(35.27,132.98),(35.53,132.98),(35.53,87.93),(35.27,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,87.93),(49.685,131.365),(49.915,131.365),(49.915,87.93),(49.685,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,87.93),(40.085,130.265),(40.315,130.265),(40.315,87.93),(40.085,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((40.115,88.03),(40.115,88.32),(40.345,88.32),(40.345,88.03),(40.115,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,87.93),(35.285,91.365),(35.515,91.365),(35.515,87.93),(35.285,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,87.93),(44.87,132.98),(45.13,132.98),(45.13,87.93),(44.87,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,87.93),(49.67,132.98),(49.93,132.98),(49.93,87.93),(49.67,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,87.93),(30.74,91.365),(30.97,91.365),(30.97,87.93),(30.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,87.93),(44.885,131.365),(45.115,131.365),(45.115,87.93),(44.885,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,87.93),(30.74,88.3),(30.97,88.3),(30.97,87.93),(30.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,87.93),(30.725,88.3),(30.985,88.3),(30.985,87.93),(30.725,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.58,88.03),(73.58,88.32),(74.17,88.32),(74.17,88.03),(73.58,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,87.93),(40.07,132.98),(40.33,132.98),(40.33,87.93),(40.07,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,87.93),(59.03,130.265),(59.26,130.265),(59.26,87.93),(59.03,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((59.06,88.03),(59.06,88.32),(59.29,88.32),(59.29,88.03),(59.06,88.03)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,87.93),(30.74,131.365),(30.97,131.365),(30.97,87.93),(30.74,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,91.365),(54.715,91.365),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,87.93),(54.485,88.3),(54.715,88.3),(54.715,87.93),(54.485,87.93)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,87.93),(73.55,88.3),(74.14,88.3),(74.14,87.93),(73.55,87.93)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'm2',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm2',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((1.635,177.835),(1.635,186.165),(88.365,186.165),(88.365,177.835),(1.635,177.835)),
        )
        createRL(
            tech, net, 'm4',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((0.0,176.0),(0.0,188.0),(90.0,188.0),(90.0,176.0),(0.0,176.0)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,172.4),(44.4,172.4),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.2,171.22),(1.2,176.005),(44.4,176.005),(44.4,171.22),(1.2,171.22)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,177.81),(1.64,186.19),(88.36,186.19),(88.36,177.81),(1.64,177.81)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,177.4),(1.4,186.6),(88.6,186.6),(88.6,177.4),(1.4,177.4)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(182.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((1.3,171.31),(1.3,171.51),(1.5,171.51),(1.5,171.31),(1.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.31),(1.7,171.51),(1.9,171.51),(1.9,171.31),(1.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.31),(2.1,171.51),(2.3,171.51),(2.3,171.31),(2.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.31),(2.5,171.51),(2.7,171.51),(2.7,171.31),(2.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.31),(2.9,171.51),(3.1,171.51),(3.1,171.31),(2.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.31),(3.3,171.51),(3.5,171.51),(3.5,171.31),(3.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.31),(3.7,171.51),(3.9,171.51),(3.9,171.31),(3.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.31),(4.1,171.51),(4.3,171.51),(4.3,171.31),(4.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.31),(4.5,171.51),(4.7,171.51),(4.7,171.31),(4.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.31),(4.9,171.51),(5.1,171.51),(5.1,171.31),(4.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.31),(5.3,171.51),(5.5,171.51),(5.5,171.31),(5.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.31),(5.7,171.51),(5.9,171.51),(5.9,171.31),(5.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.31),(6.1,171.51),(6.3,171.51),(6.3,171.31),(6.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.31),(6.5,171.51),(6.7,171.51),(6.7,171.31),(6.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.31),(6.9,171.51),(7.1,171.51),(7.1,171.31),(6.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.31),(7.3,171.51),(7.5,171.51),(7.5,171.31),(7.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.31),(7.7,171.51),(7.9,171.51),(7.9,171.31),(7.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.31),(8.1,171.51),(8.3,171.51),(8.3,171.31),(8.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.31),(8.5,171.51),(8.7,171.51),(8.7,171.31),(8.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.31),(8.9,171.51),(9.1,171.51),(9.1,171.31),(8.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.31),(9.3,171.51),(9.5,171.51),(9.5,171.31),(9.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.31),(9.7,171.51),(9.9,171.51),(9.9,171.31),(9.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.31),(10.1,171.51),(10.3,171.51),(10.3,171.31),(10.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.31),(10.5,171.51),(10.7,171.51),(10.7,171.31),(10.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.31),(10.9,171.51),(11.1,171.51),(11.1,171.31),(10.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.31),(11.3,171.51),(11.5,171.51),(11.5,171.31),(11.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.31),(11.7,171.51),(11.9,171.51),(11.9,171.31),(11.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.31),(12.1,171.51),(12.3,171.51),(12.3,171.31),(12.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.31),(12.5,171.51),(12.7,171.51),(12.7,171.31),(12.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.31),(12.9,171.51),(13.1,171.51),(13.1,171.31),(12.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.31),(13.3,171.51),(13.5,171.51),(13.5,171.31),(13.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.31),(13.7,171.51),(13.9,171.51),(13.9,171.31),(13.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.31),(14.1,171.51),(14.3,171.51),(14.3,171.31),(14.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.31),(14.5,171.51),(14.7,171.51),(14.7,171.31),(14.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.31),(14.9,171.51),(15.1,171.51),(15.1,171.31),(14.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.31),(15.3,171.51),(15.5,171.51),(15.5,171.31),(15.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.31),(15.7,171.51),(15.9,171.51),(15.9,171.31),(15.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.31),(16.1,171.51),(16.3,171.51),(16.3,171.31),(16.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.31),(16.5,171.51),(16.7,171.51),(16.7,171.31),(16.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.31),(16.9,171.51),(17.1,171.51),(17.1,171.31),(16.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.31),(17.3,171.51),(17.5,171.51),(17.5,171.31),(17.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.31),(17.7,171.51),(17.9,171.51),(17.9,171.31),(17.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.31),(18.1,171.51),(18.3,171.51),(18.3,171.31),(18.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.31),(18.5,171.51),(18.7,171.51),(18.7,171.31),(18.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.31),(18.9,171.51),(19.1,171.51),(19.1,171.31),(18.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.31),(19.3,171.51),(19.5,171.51),(19.5,171.31),(19.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.31),(19.7,171.51),(19.9,171.51),(19.9,171.31),(19.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.31),(20.1,171.51),(20.3,171.51),(20.3,171.31),(20.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.31),(20.5,171.51),(20.7,171.51),(20.7,171.31),(20.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.31),(20.9,171.51),(21.1,171.51),(21.1,171.31),(20.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.31),(21.3,171.51),(21.5,171.51),(21.5,171.31),(21.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.31),(21.7,171.51),(21.9,171.51),(21.9,171.31),(21.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.31),(22.1,171.51),(22.3,171.51),(22.3,171.31),(22.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.31),(22.5,171.51),(22.7,171.51),(22.7,171.31),(22.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.31),(22.9,171.51),(23.1,171.51),(23.1,171.31),(22.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.31),(23.3,171.51),(23.5,171.51),(23.5,171.31),(23.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.31),(23.7,171.51),(23.9,171.51),(23.9,171.31),(23.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.31),(24.1,171.51),(24.3,171.51),(24.3,171.31),(24.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.31),(24.5,171.51),(24.7,171.51),(24.7,171.31),(24.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.31),(24.9,171.51),(25.1,171.51),(25.1,171.31),(24.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.31),(25.3,171.51),(25.5,171.51),(25.5,171.31),(25.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.31),(25.7,171.51),(25.9,171.51),(25.9,171.31),(25.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.31),(26.1,171.51),(26.3,171.51),(26.3,171.31),(26.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.31),(26.5,171.51),(26.7,171.51),(26.7,171.31),(26.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.31),(26.9,171.51),(27.1,171.51),(27.1,171.31),(26.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.31),(27.3,171.51),(27.5,171.51),(27.5,171.31),(27.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.31),(27.7,171.51),(27.9,171.51),(27.9,171.31),(27.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.31),(28.1,171.51),(28.3,171.51),(28.3,171.31),(28.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.31),(28.5,171.51),(28.7,171.51),(28.7,171.31),(28.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.31),(28.9,171.51),(29.1,171.51),(29.1,171.31),(28.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.31),(29.3,171.51),(29.5,171.51),(29.5,171.31),(29.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.31),(29.7,171.51),(29.9,171.51),(29.9,171.31),(29.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.31),(30.1,171.51),(30.3,171.51),(30.3,171.31),(30.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.31),(30.5,171.51),(30.7,171.51),(30.7,171.31),(30.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.31),(30.9,171.51),(31.1,171.51),(31.1,171.31),(30.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.31),(31.3,171.51),(31.5,171.51),(31.5,171.31),(31.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.31),(31.7,171.51),(31.9,171.51),(31.9,171.31),(31.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.31),(32.1,171.51),(32.3,171.51),(32.3,171.31),(32.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.31),(32.5,171.51),(32.7,171.51),(32.7,171.31),(32.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.31),(32.9,171.51),(33.1,171.51),(33.1,171.31),(32.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.31),(33.3,171.51),(33.5,171.51),(33.5,171.31),(33.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.31),(33.7,171.51),(33.9,171.51),(33.9,171.31),(33.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.31),(34.1,171.51),(34.3,171.51),(34.3,171.31),(34.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.31),(34.5,171.51),(34.7,171.51),(34.7,171.31),(34.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.31),(34.9,171.51),(35.1,171.51),(35.1,171.31),(34.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.31),(35.3,171.51),(35.5,171.51),(35.5,171.31),(35.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.31),(35.7,171.51),(35.9,171.51),(35.9,171.31),(35.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.31),(36.1,171.51),(36.3,171.51),(36.3,171.31),(36.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.31),(36.5,171.51),(36.7,171.51),(36.7,171.31),(36.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.31),(36.9,171.51),(37.1,171.51),(37.1,171.31),(36.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.31),(37.3,171.51),(37.5,171.51),(37.5,171.31),(37.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.31),(37.7,171.51),(37.9,171.51),(37.9,171.31),(37.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.31),(38.1,171.51),(38.3,171.51),(38.3,171.31),(38.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.31),(38.5,171.51),(38.7,171.51),(38.7,171.31),(38.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.31),(38.9,171.51),(39.1,171.51),(39.1,171.31),(38.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.31),(39.3,171.51),(39.5,171.51),(39.5,171.31),(39.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.31),(39.7,171.51),(39.9,171.51),(39.9,171.31),(39.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.31),(40.1,171.51),(40.3,171.51),(40.3,171.31),(40.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.31),(40.5,171.51),(40.7,171.51),(40.7,171.31),(40.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.31),(40.9,171.51),(41.1,171.51),(41.1,171.31),(40.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.31),(41.3,171.51),(41.5,171.51),(41.5,171.31),(41.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.31),(41.7,171.51),(41.9,171.51),(41.9,171.31),(41.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.31),(42.1,171.51),(42.3,171.51),(42.3,171.31),(42.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.31),(42.5,171.51),(42.7,171.51),(42.7,171.31),(42.5,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.31),(42.9,171.51),(43.1,171.51),(43.1,171.31),(42.9,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.31),(43.3,171.51),(43.5,171.51),(43.5,171.31),(43.3,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.31),(43.7,171.51),(43.9,171.51),(43.9,171.31),(43.7,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.31),(44.1,171.51),(44.3,171.51),(44.3,171.31),(44.1,171.31)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,171.71),(1.3,171.91),(1.5,171.91),(1.5,171.71),(1.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,171.71),(1.7,171.91),(1.9,171.91),(1.9,171.71),(1.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,171.71),(2.1,171.91),(2.3,171.91),(2.3,171.71),(2.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,171.71),(2.5,171.91),(2.7,171.91),(2.7,171.71),(2.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,171.71),(2.9,171.91),(3.1,171.91),(3.1,171.71),(2.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,171.71),(3.3,171.91),(3.5,171.91),(3.5,171.71),(3.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,171.71),(3.7,171.91),(3.9,171.91),(3.9,171.71),(3.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,171.71),(4.1,171.91),(4.3,171.91),(4.3,171.71),(4.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,171.71),(4.5,171.91),(4.7,171.91),(4.7,171.71),(4.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,171.71),(4.9,171.91),(5.1,171.91),(5.1,171.71),(4.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,171.71),(5.3,171.91),(5.5,171.91),(5.5,171.71),(5.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,171.71),(5.7,171.91),(5.9,171.91),(5.9,171.71),(5.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,171.71),(6.1,171.91),(6.3,171.91),(6.3,171.71),(6.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,171.71),(6.5,171.91),(6.7,171.91),(6.7,171.71),(6.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,171.71),(6.9,171.91),(7.1,171.91),(7.1,171.71),(6.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,171.71),(7.3,171.91),(7.5,171.91),(7.5,171.71),(7.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,171.71),(7.7,171.91),(7.9,171.91),(7.9,171.71),(7.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,171.71),(8.1,171.91),(8.3,171.91),(8.3,171.71),(8.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,171.71),(8.5,171.91),(8.7,171.91),(8.7,171.71),(8.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,171.71),(8.9,171.91),(9.1,171.91),(9.1,171.71),(8.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,171.71),(9.3,171.91),(9.5,171.91),(9.5,171.71),(9.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,171.71),(9.7,171.91),(9.9,171.91),(9.9,171.71),(9.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,171.71),(10.1,171.91),(10.3,171.91),(10.3,171.71),(10.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,171.71),(10.5,171.91),(10.7,171.91),(10.7,171.71),(10.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,171.71),(10.9,171.91),(11.1,171.91),(11.1,171.71),(10.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,171.71),(11.3,171.91),(11.5,171.91),(11.5,171.71),(11.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,171.71),(11.7,171.91),(11.9,171.91),(11.9,171.71),(11.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,171.71),(12.1,171.91),(12.3,171.91),(12.3,171.71),(12.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,171.71),(12.5,171.91),(12.7,171.91),(12.7,171.71),(12.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,171.71),(12.9,171.91),(13.1,171.91),(13.1,171.71),(12.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,171.71),(13.3,171.91),(13.5,171.91),(13.5,171.71),(13.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,171.71),(13.7,171.91),(13.9,171.91),(13.9,171.71),(13.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,171.71),(14.1,171.91),(14.3,171.91),(14.3,171.71),(14.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,171.71),(14.5,171.91),(14.7,171.91),(14.7,171.71),(14.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,171.71),(14.9,171.91),(15.1,171.91),(15.1,171.71),(14.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,171.71),(15.3,171.91),(15.5,171.91),(15.5,171.71),(15.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,171.71),(15.7,171.91),(15.9,171.91),(15.9,171.71),(15.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,171.71),(16.1,171.91),(16.3,171.91),(16.3,171.71),(16.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,171.71),(16.5,171.91),(16.7,171.91),(16.7,171.71),(16.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,171.71),(16.9,171.91),(17.1,171.91),(17.1,171.71),(16.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,171.71),(17.3,171.91),(17.5,171.91),(17.5,171.71),(17.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,171.71),(17.7,171.91),(17.9,171.91),(17.9,171.71),(17.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,171.71),(18.1,171.91),(18.3,171.91),(18.3,171.71),(18.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,171.71),(18.5,171.91),(18.7,171.91),(18.7,171.71),(18.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,171.71),(18.9,171.91),(19.1,171.91),(19.1,171.71),(18.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,171.71),(19.3,171.91),(19.5,171.91),(19.5,171.71),(19.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,171.71),(19.7,171.91),(19.9,171.91),(19.9,171.71),(19.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,171.71),(20.1,171.91),(20.3,171.91),(20.3,171.71),(20.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,171.71),(20.5,171.91),(20.7,171.91),(20.7,171.71),(20.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,171.71),(20.9,171.91),(21.1,171.91),(21.1,171.71),(20.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,171.71),(21.3,171.91),(21.5,171.91),(21.5,171.71),(21.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,171.71),(21.7,171.91),(21.9,171.91),(21.9,171.71),(21.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,171.71),(22.1,171.91),(22.3,171.91),(22.3,171.71),(22.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,171.71),(22.5,171.91),(22.7,171.91),(22.7,171.71),(22.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,171.71),(22.9,171.91),(23.1,171.91),(23.1,171.71),(22.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,171.71),(23.3,171.91),(23.5,171.91),(23.5,171.71),(23.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,171.71),(23.7,171.91),(23.9,171.91),(23.9,171.71),(23.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,171.71),(24.1,171.91),(24.3,171.91),(24.3,171.71),(24.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,171.71),(24.5,171.91),(24.7,171.91),(24.7,171.71),(24.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,171.71),(24.9,171.91),(25.1,171.91),(25.1,171.71),(24.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,171.71),(25.3,171.91),(25.5,171.91),(25.5,171.71),(25.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,171.71),(25.7,171.91),(25.9,171.91),(25.9,171.71),(25.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,171.71),(26.1,171.91),(26.3,171.91),(26.3,171.71),(26.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,171.71),(26.5,171.91),(26.7,171.91),(26.7,171.71),(26.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,171.71),(26.9,171.91),(27.1,171.91),(27.1,171.71),(26.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,171.71),(27.3,171.91),(27.5,171.91),(27.5,171.71),(27.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,171.71),(27.7,171.91),(27.9,171.91),(27.9,171.71),(27.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,171.71),(28.1,171.91),(28.3,171.91),(28.3,171.71),(28.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,171.71),(28.5,171.91),(28.7,171.91),(28.7,171.71),(28.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,171.71),(28.9,171.91),(29.1,171.91),(29.1,171.71),(28.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,171.71),(29.3,171.91),(29.5,171.91),(29.5,171.71),(29.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,171.71),(29.7,171.91),(29.9,171.91),(29.9,171.71),(29.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,171.71),(30.1,171.91),(30.3,171.91),(30.3,171.71),(30.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,171.71),(30.5,171.91),(30.7,171.91),(30.7,171.71),(30.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,171.71),(30.9,171.91),(31.1,171.91),(31.1,171.71),(30.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,171.71),(31.3,171.91),(31.5,171.91),(31.5,171.71),(31.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,171.71),(31.7,171.91),(31.9,171.91),(31.9,171.71),(31.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,171.71),(32.1,171.91),(32.3,171.91),(32.3,171.71),(32.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,171.71),(32.5,171.91),(32.7,171.91),(32.7,171.71),(32.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,171.71),(32.9,171.91),(33.1,171.91),(33.1,171.71),(32.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,171.71),(33.3,171.91),(33.5,171.91),(33.5,171.71),(33.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,171.71),(33.7,171.91),(33.9,171.91),(33.9,171.71),(33.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,171.71),(34.1,171.91),(34.3,171.91),(34.3,171.71),(34.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,171.71),(34.5,171.91),(34.7,171.91),(34.7,171.71),(34.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,171.71),(34.9,171.91),(35.1,171.91),(35.1,171.71),(34.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,171.71),(35.3,171.91),(35.5,171.91),(35.5,171.71),(35.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,171.71),(35.7,171.91),(35.9,171.91),(35.9,171.71),(35.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,171.71),(36.1,171.91),(36.3,171.91),(36.3,171.71),(36.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,171.71),(36.5,171.91),(36.7,171.91),(36.7,171.71),(36.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,171.71),(36.9,171.91),(37.1,171.91),(37.1,171.71),(36.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,171.71),(37.3,171.91),(37.5,171.91),(37.5,171.71),(37.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,171.71),(37.7,171.91),(37.9,171.91),(37.9,171.71),(37.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,171.71),(38.1,171.91),(38.3,171.91),(38.3,171.71),(38.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,171.71),(38.5,171.91),(38.7,171.91),(38.7,171.71),(38.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,171.71),(38.9,171.91),(39.1,171.91),(39.1,171.71),(38.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,171.71),(39.3,171.91),(39.5,171.91),(39.5,171.71),(39.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,171.71),(39.7,171.91),(39.9,171.91),(39.9,171.71),(39.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,171.71),(40.1,171.91),(40.3,171.91),(40.3,171.71),(40.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,171.71),(40.5,171.91),(40.7,171.91),(40.7,171.71),(40.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,171.71),(40.9,171.91),(41.1,171.91),(41.1,171.71),(40.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,171.71),(41.3,171.91),(41.5,171.91),(41.5,171.71),(41.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,171.71),(41.7,171.91),(41.9,171.91),(41.9,171.71),(41.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,171.71),(42.1,171.91),(42.3,171.91),(42.3,171.71),(42.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,171.71),(42.5,171.91),(42.7,171.91),(42.7,171.71),(42.5,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,171.71),(42.9,171.91),(43.1,171.91),(43.1,171.71),(42.9,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,171.71),(43.3,171.91),(43.5,171.91),(43.5,171.71),(43.3,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,171.71),(43.7,171.91),(43.9,171.91),(43.9,171.71),(43.7,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,171.71),(44.1,171.91),(44.3,171.91),(44.3,171.71),(44.1,171.71)),
        )
        createRL(
            tech, net, 'via2',
            ((1.3,172.11),(1.3,172.31),(1.5,172.31),(1.5,172.11),(1.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((1.7,172.11),(1.7,172.31),(1.9,172.31),(1.9,172.11),(1.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.1,172.11),(2.1,172.31),(2.3,172.31),(2.3,172.11),(2.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.5,172.11),(2.5,172.31),(2.7,172.31),(2.7,172.11),(2.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((2.9,172.11),(2.9,172.31),(3.1,172.31),(3.1,172.11),(2.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.3,172.11),(3.3,172.31),(3.5,172.31),(3.5,172.11),(3.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((3.7,172.11),(3.7,172.31),(3.9,172.31),(3.9,172.11),(3.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.1,172.11),(4.1,172.31),(4.3,172.31),(4.3,172.11),(4.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.5,172.11),(4.5,172.31),(4.7,172.31),(4.7,172.11),(4.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((4.9,172.11),(4.9,172.31),(5.1,172.31),(5.1,172.11),(4.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.3,172.11),(5.3,172.31),(5.5,172.31),(5.5,172.11),(5.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((5.7,172.11),(5.7,172.31),(5.9,172.31),(5.9,172.11),(5.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.1,172.11),(6.1,172.31),(6.3,172.31),(6.3,172.11),(6.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.5,172.11),(6.5,172.31),(6.7,172.31),(6.7,172.11),(6.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((6.9,172.11),(6.9,172.31),(7.1,172.31),(7.1,172.11),(6.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.3,172.11),(7.3,172.31),(7.5,172.31),(7.5,172.11),(7.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((7.7,172.11),(7.7,172.31),(7.9,172.31),(7.9,172.11),(7.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.1,172.11),(8.1,172.31),(8.3,172.31),(8.3,172.11),(8.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.5,172.11),(8.5,172.31),(8.7,172.31),(8.7,172.11),(8.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((8.9,172.11),(8.9,172.31),(9.1,172.31),(9.1,172.11),(8.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.3,172.11),(9.3,172.31),(9.5,172.31),(9.5,172.11),(9.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((9.7,172.11),(9.7,172.31),(9.9,172.31),(9.9,172.11),(9.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.1,172.11),(10.1,172.31),(10.3,172.31),(10.3,172.11),(10.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.5,172.11),(10.5,172.31),(10.7,172.31),(10.7,172.11),(10.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((10.9,172.11),(10.9,172.31),(11.1,172.31),(11.1,172.11),(10.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.3,172.11),(11.3,172.31),(11.5,172.31),(11.5,172.11),(11.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((11.7,172.11),(11.7,172.31),(11.9,172.31),(11.9,172.11),(11.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.1,172.11),(12.1,172.31),(12.3,172.31),(12.3,172.11),(12.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.5,172.11),(12.5,172.31),(12.7,172.31),(12.7,172.11),(12.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((12.9,172.11),(12.9,172.31),(13.1,172.31),(13.1,172.11),(12.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.3,172.11),(13.3,172.31),(13.5,172.31),(13.5,172.11),(13.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((13.7,172.11),(13.7,172.31),(13.9,172.31),(13.9,172.11),(13.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.1,172.11),(14.1,172.31),(14.3,172.31),(14.3,172.11),(14.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.5,172.11),(14.5,172.31),(14.7,172.31),(14.7,172.11),(14.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((14.9,172.11),(14.9,172.31),(15.1,172.31),(15.1,172.11),(14.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.3,172.11),(15.3,172.31),(15.5,172.31),(15.5,172.11),(15.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((15.7,172.11),(15.7,172.31),(15.9,172.31),(15.9,172.11),(15.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.1,172.11),(16.1,172.31),(16.3,172.31),(16.3,172.11),(16.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.5,172.11),(16.5,172.31),(16.7,172.31),(16.7,172.11),(16.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((16.9,172.11),(16.9,172.31),(17.1,172.31),(17.1,172.11),(16.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.3,172.11),(17.3,172.31),(17.5,172.31),(17.5,172.11),(17.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((17.7,172.11),(17.7,172.31),(17.9,172.31),(17.9,172.11),(17.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.1,172.11),(18.1,172.31),(18.3,172.31),(18.3,172.11),(18.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.5,172.11),(18.5,172.31),(18.7,172.31),(18.7,172.11),(18.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((18.9,172.11),(18.9,172.31),(19.1,172.31),(19.1,172.11),(18.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.3,172.11),(19.3,172.31),(19.5,172.31),(19.5,172.11),(19.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((19.7,172.11),(19.7,172.31),(19.9,172.31),(19.9,172.11),(19.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.1,172.11),(20.1,172.31),(20.3,172.31),(20.3,172.11),(20.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.5,172.11),(20.5,172.31),(20.7,172.31),(20.7,172.11),(20.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((20.9,172.11),(20.9,172.31),(21.1,172.31),(21.1,172.11),(20.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.3,172.11),(21.3,172.31),(21.5,172.31),(21.5,172.11),(21.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((21.7,172.11),(21.7,172.31),(21.9,172.31),(21.9,172.11),(21.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.1,172.11),(22.1,172.31),(22.3,172.31),(22.3,172.11),(22.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.5,172.11),(22.5,172.31),(22.7,172.31),(22.7,172.11),(22.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((22.9,172.11),(22.9,172.31),(23.1,172.31),(23.1,172.11),(22.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.3,172.11),(23.3,172.31),(23.5,172.31),(23.5,172.11),(23.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((23.7,172.11),(23.7,172.31),(23.9,172.31),(23.9,172.11),(23.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.1,172.11),(24.1,172.31),(24.3,172.31),(24.3,172.11),(24.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.5,172.11),(24.5,172.31),(24.7,172.31),(24.7,172.11),(24.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((24.9,172.11),(24.9,172.31),(25.1,172.31),(25.1,172.11),(24.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.3,172.11),(25.3,172.31),(25.5,172.31),(25.5,172.11),(25.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((25.7,172.11),(25.7,172.31),(25.9,172.31),(25.9,172.11),(25.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.1,172.11),(26.1,172.31),(26.3,172.31),(26.3,172.11),(26.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.5,172.11),(26.5,172.31),(26.7,172.31),(26.7,172.11),(26.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((26.9,172.11),(26.9,172.31),(27.1,172.31),(27.1,172.11),(26.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.3,172.11),(27.3,172.31),(27.5,172.31),(27.5,172.11),(27.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((27.7,172.11),(27.7,172.31),(27.9,172.31),(27.9,172.11),(27.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.1,172.11),(28.1,172.31),(28.3,172.31),(28.3,172.11),(28.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.5,172.11),(28.5,172.31),(28.7,172.31),(28.7,172.11),(28.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((28.9,172.11),(28.9,172.31),(29.1,172.31),(29.1,172.11),(28.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.3,172.11),(29.3,172.31),(29.5,172.31),(29.5,172.11),(29.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((29.7,172.11),(29.7,172.31),(29.9,172.31),(29.9,172.11),(29.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.1,172.11),(30.1,172.31),(30.3,172.31),(30.3,172.11),(30.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.5,172.11),(30.5,172.31),(30.7,172.31),(30.7,172.11),(30.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((30.9,172.11),(30.9,172.31),(31.1,172.31),(31.1,172.11),(30.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.3,172.11),(31.3,172.31),(31.5,172.31),(31.5,172.11),(31.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((31.7,172.11),(31.7,172.31),(31.9,172.31),(31.9,172.11),(31.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.1,172.11),(32.1,172.31),(32.3,172.31),(32.3,172.11),(32.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.5,172.11),(32.5,172.31),(32.7,172.31),(32.7,172.11),(32.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((32.9,172.11),(32.9,172.31),(33.1,172.31),(33.1,172.11),(32.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.3,172.11),(33.3,172.31),(33.5,172.31),(33.5,172.11),(33.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((33.7,172.11),(33.7,172.31),(33.9,172.31),(33.9,172.11),(33.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.1,172.11),(34.1,172.31),(34.3,172.31),(34.3,172.11),(34.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.5,172.11),(34.5,172.31),(34.7,172.31),(34.7,172.11),(34.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((34.9,172.11),(34.9,172.31),(35.1,172.31),(35.1,172.11),(34.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.3,172.11),(35.3,172.31),(35.5,172.31),(35.5,172.11),(35.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((35.7,172.11),(35.7,172.31),(35.9,172.31),(35.9,172.11),(35.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.1,172.11),(36.1,172.31),(36.3,172.31),(36.3,172.11),(36.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.5,172.11),(36.5,172.31),(36.7,172.31),(36.7,172.11),(36.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((36.9,172.11),(36.9,172.31),(37.1,172.31),(37.1,172.11),(36.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.3,172.11),(37.3,172.31),(37.5,172.31),(37.5,172.11),(37.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((37.7,172.11),(37.7,172.31),(37.9,172.31),(37.9,172.11),(37.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.1,172.11),(38.1,172.31),(38.3,172.31),(38.3,172.11),(38.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.5,172.11),(38.5,172.31),(38.7,172.31),(38.7,172.11),(38.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((38.9,172.11),(38.9,172.31),(39.1,172.31),(39.1,172.11),(38.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.3,172.11),(39.3,172.31),(39.5,172.31),(39.5,172.11),(39.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((39.7,172.11),(39.7,172.31),(39.9,172.31),(39.9,172.11),(39.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.1,172.11),(40.1,172.31),(40.3,172.31),(40.3,172.11),(40.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.5,172.11),(40.5,172.31),(40.7,172.31),(40.7,172.11),(40.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((40.9,172.11),(40.9,172.31),(41.1,172.31),(41.1,172.11),(40.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.3,172.11),(41.3,172.31),(41.5,172.31),(41.5,172.11),(41.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((41.7,172.11),(41.7,172.31),(41.9,172.31),(41.9,172.11),(41.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.1,172.11),(42.1,172.31),(42.3,172.31),(42.3,172.11),(42.1,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.5,172.11),(42.5,172.31),(42.7,172.31),(42.7,172.11),(42.5,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((42.9,172.11),(42.9,172.31),(43.1,172.31),(43.1,172.11),(42.9,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.3,172.11),(43.3,172.31),(43.5,172.31),(43.5,172.11),(43.3,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((43.7,172.11),(43.7,172.31),(43.9,172.31),(43.9,172.11),(43.7,172.11)),
        )
        createRL(
            tech, net, 'via2',
            ((44.1,172.11),(44.1,172.31),(44.3,172.31),(44.3,172.11),(44.1,172.11)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,177.9),(1.7,178.1),(1.9,178.1),(1.9,177.9),(1.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,177.9),(3.3,178.1),(3.5,178.1),(3.5,177.9),(3.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,177.9),(4.9,178.1),(5.1,178.1),(5.1,177.9),(4.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,177.9),(6.5,178.1),(6.7,178.1),(6.7,177.9),(6.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,177.9),(8.1,178.1),(8.3,178.1),(8.3,177.9),(8.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,177.9),(9.7,178.1),(9.9,178.1),(9.9,177.9),(9.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,177.9),(11.3,178.1),(11.5,178.1),(11.5,177.9),(11.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,177.9),(12.9,178.1),(13.1,178.1),(13.1,177.9),(12.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,177.9),(14.5,178.1),(14.7,178.1),(14.7,177.9),(14.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,177.9),(16.1,178.1),(16.3,178.1),(16.3,177.9),(16.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,177.9),(17.7,178.1),(17.9,178.1),(17.9,177.9),(17.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,177.9),(19.3,178.1),(19.5,178.1),(19.5,177.9),(19.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,177.9),(20.9,178.1),(21.1,178.1),(21.1,177.9),(20.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,177.9),(22.5,178.1),(22.7,178.1),(22.7,177.9),(22.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,177.9),(24.1,178.1),(24.3,178.1),(24.3,177.9),(24.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,177.9),(25.7,178.1),(25.9,178.1),(25.9,177.9),(25.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,177.9),(27.3,178.1),(27.5,178.1),(27.5,177.9),(27.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,177.9),(28.9,178.1),(29.1,178.1),(29.1,177.9),(28.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,177.9),(30.5,178.1),(30.7,178.1),(30.7,177.9),(30.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,177.9),(32.1,178.1),(32.3,178.1),(32.3,177.9),(32.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,177.9),(33.7,178.1),(33.9,178.1),(33.9,177.9),(33.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,177.9),(35.3,178.1),(35.5,178.1),(35.5,177.9),(35.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,177.9),(36.9,178.1),(37.1,178.1),(37.1,177.9),(36.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,177.9),(38.5,178.1),(38.7,178.1),(38.7,177.9),(38.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,177.9),(40.1,178.1),(40.3,178.1),(40.3,177.9),(40.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,177.9),(41.7,178.1),(41.9,178.1),(41.9,177.9),(41.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,177.9),(43.3,178.1),(43.5,178.1),(43.5,177.9),(43.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,177.9),(44.9,178.1),(45.1,178.1),(45.1,177.9),(44.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,177.9),(46.5,178.1),(46.7,178.1),(46.7,177.9),(46.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,177.9),(48.1,178.1),(48.3,178.1),(48.3,177.9),(48.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,177.9),(49.7,178.1),(49.9,178.1),(49.9,177.9),(49.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,177.9),(51.3,178.1),(51.5,178.1),(51.5,177.9),(51.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,177.9),(52.9,178.1),(53.1,178.1),(53.1,177.9),(52.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,177.9),(54.5,178.1),(54.7,178.1),(54.7,177.9),(54.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,177.9),(56.1,178.1),(56.3,178.1),(56.3,177.9),(56.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,177.9),(57.7,178.1),(57.9,178.1),(57.9,177.9),(57.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,177.9),(59.3,178.1),(59.5,178.1),(59.5,177.9),(59.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,177.9),(60.9,178.1),(61.1,178.1),(61.1,177.9),(60.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,177.9),(62.5,178.1),(62.7,178.1),(62.7,177.9),(62.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,177.9),(64.1,178.1),(64.3,178.1),(64.3,177.9),(64.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,177.9),(65.7,178.1),(65.9,178.1),(65.9,177.9),(65.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,177.9),(67.3,178.1),(67.5,178.1),(67.5,177.9),(67.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,177.9),(68.9,178.1),(69.1,178.1),(69.1,177.9),(68.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,177.9),(70.5,178.1),(70.7,178.1),(70.7,177.9),(70.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,177.9),(72.1,178.1),(72.3,178.1),(72.3,177.9),(72.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,177.9),(73.7,178.1),(73.9,178.1),(73.9,177.9),(73.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,177.9),(75.3,178.1),(75.5,178.1),(75.5,177.9),(75.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,177.9),(76.9,178.1),(77.1,178.1),(77.1,177.9),(76.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,177.9),(78.5,178.1),(78.7,178.1),(78.7,177.9),(78.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,177.9),(80.1,178.1),(80.3,178.1),(80.3,177.9),(80.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,177.9),(81.7,178.1),(81.9,178.1),(81.9,177.9),(81.7,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,177.9),(83.3,178.1),(83.5,178.1),(83.5,177.9),(83.3,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,177.9),(84.9,178.1),(85.1,178.1),(85.1,177.9),(84.9,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,177.9),(86.5,178.1),(86.7,178.1),(86.7,177.9),(86.5,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,177.9),(88.1,178.1),(88.3,178.1),(88.3,177.9),(88.1,177.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,179.5),(1.7,179.7),(1.9,179.7),(1.9,179.5),(1.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,179.5),(3.3,179.7),(3.5,179.7),(3.5,179.5),(3.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,179.5),(4.9,179.7),(5.1,179.7),(5.1,179.5),(4.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,179.5),(6.5,179.7),(6.7,179.7),(6.7,179.5),(6.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,179.5),(8.1,179.7),(8.3,179.7),(8.3,179.5),(8.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,179.5),(9.7,179.7),(9.9,179.7),(9.9,179.5),(9.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,179.5),(11.3,179.7),(11.5,179.7),(11.5,179.5),(11.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,179.5),(12.9,179.7),(13.1,179.7),(13.1,179.5),(12.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,179.5),(14.5,179.7),(14.7,179.7),(14.7,179.5),(14.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,179.5),(16.1,179.7),(16.3,179.7),(16.3,179.5),(16.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,179.5),(17.7,179.7),(17.9,179.7),(17.9,179.5),(17.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,179.5),(19.3,179.7),(19.5,179.7),(19.5,179.5),(19.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,179.5),(20.9,179.7),(21.1,179.7),(21.1,179.5),(20.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,179.5),(22.5,179.7),(22.7,179.7),(22.7,179.5),(22.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,179.5),(24.1,179.7),(24.3,179.7),(24.3,179.5),(24.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,179.5),(25.7,179.7),(25.9,179.7),(25.9,179.5),(25.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,179.5),(27.3,179.7),(27.5,179.7),(27.5,179.5),(27.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,179.5),(28.9,179.7),(29.1,179.7),(29.1,179.5),(28.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,179.5),(30.5,179.7),(30.7,179.7),(30.7,179.5),(30.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,179.5),(32.1,179.7),(32.3,179.7),(32.3,179.5),(32.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,179.5),(33.7,179.7),(33.9,179.7),(33.9,179.5),(33.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,179.5),(35.3,179.7),(35.5,179.7),(35.5,179.5),(35.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,179.5),(36.9,179.7),(37.1,179.7),(37.1,179.5),(36.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,179.5),(38.5,179.7),(38.7,179.7),(38.7,179.5),(38.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,179.5),(40.1,179.7),(40.3,179.7),(40.3,179.5),(40.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,179.5),(41.7,179.7),(41.9,179.7),(41.9,179.5),(41.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,179.5),(43.3,179.7),(43.5,179.7),(43.5,179.5),(43.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,179.5),(44.9,179.7),(45.1,179.7),(45.1,179.5),(44.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,179.5),(46.5,179.7),(46.7,179.7),(46.7,179.5),(46.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,179.5),(48.1,179.7),(48.3,179.7),(48.3,179.5),(48.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,179.5),(49.7,179.7),(49.9,179.7),(49.9,179.5),(49.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,179.5),(51.3,179.7),(51.5,179.7),(51.5,179.5),(51.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,179.5),(52.9,179.7),(53.1,179.7),(53.1,179.5),(52.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,179.5),(54.5,179.7),(54.7,179.7),(54.7,179.5),(54.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,179.5),(56.1,179.7),(56.3,179.7),(56.3,179.5),(56.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,179.5),(57.7,179.7),(57.9,179.7),(57.9,179.5),(57.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,179.5),(59.3,179.7),(59.5,179.7),(59.5,179.5),(59.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,179.5),(60.9,179.7),(61.1,179.7),(61.1,179.5),(60.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,179.5),(62.5,179.7),(62.7,179.7),(62.7,179.5),(62.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,179.5),(64.1,179.7),(64.3,179.7),(64.3,179.5),(64.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,179.5),(65.7,179.7),(65.9,179.7),(65.9,179.5),(65.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,179.5),(67.3,179.7),(67.5,179.7),(67.5,179.5),(67.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,179.5),(68.9,179.7),(69.1,179.7),(69.1,179.5),(68.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,179.5),(70.5,179.7),(70.7,179.7),(70.7,179.5),(70.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,179.5),(72.1,179.7),(72.3,179.7),(72.3,179.5),(72.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,179.5),(73.7,179.7),(73.9,179.7),(73.9,179.5),(73.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,179.5),(75.3,179.7),(75.5,179.7),(75.5,179.5),(75.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,179.5),(76.9,179.7),(77.1,179.7),(77.1,179.5),(76.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,179.5),(78.5,179.7),(78.7,179.7),(78.7,179.5),(78.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,179.5),(80.1,179.7),(80.3,179.7),(80.3,179.5),(80.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,179.5),(81.7,179.7),(81.9,179.7),(81.9,179.5),(81.7,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,179.5),(83.3,179.7),(83.5,179.7),(83.5,179.5),(83.3,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,179.5),(84.9,179.7),(85.1,179.7),(85.1,179.5),(84.9,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,179.5),(86.5,179.7),(86.7,179.7),(86.7,179.5),(86.5,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,179.5),(88.1,179.7),(88.3,179.7),(88.3,179.5),(88.1,179.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,181.1),(1.7,181.3),(1.9,181.3),(1.9,181.1),(1.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,181.1),(3.3,181.3),(3.5,181.3),(3.5,181.1),(3.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,181.1),(4.9,181.3),(5.1,181.3),(5.1,181.1),(4.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,181.1),(6.5,181.3),(6.7,181.3),(6.7,181.1),(6.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,181.1),(8.1,181.3),(8.3,181.3),(8.3,181.1),(8.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,181.1),(9.7,181.3),(9.9,181.3),(9.9,181.1),(9.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,181.1),(11.3,181.3),(11.5,181.3),(11.5,181.1),(11.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,181.1),(12.9,181.3),(13.1,181.3),(13.1,181.1),(12.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,181.1),(14.5,181.3),(14.7,181.3),(14.7,181.1),(14.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,181.1),(16.1,181.3),(16.3,181.3),(16.3,181.1),(16.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,181.1),(17.7,181.3),(17.9,181.3),(17.9,181.1),(17.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,181.1),(19.3,181.3),(19.5,181.3),(19.5,181.1),(19.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,181.1),(20.9,181.3),(21.1,181.3),(21.1,181.1),(20.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,181.1),(22.5,181.3),(22.7,181.3),(22.7,181.1),(22.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,181.1),(24.1,181.3),(24.3,181.3),(24.3,181.1),(24.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,181.1),(25.7,181.3),(25.9,181.3),(25.9,181.1),(25.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,181.1),(27.3,181.3),(27.5,181.3),(27.5,181.1),(27.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,181.1),(28.9,181.3),(29.1,181.3),(29.1,181.1),(28.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,181.1),(30.5,181.3),(30.7,181.3),(30.7,181.1),(30.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,181.1),(32.1,181.3),(32.3,181.3),(32.3,181.1),(32.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,181.1),(33.7,181.3),(33.9,181.3),(33.9,181.1),(33.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,181.1),(35.3,181.3),(35.5,181.3),(35.5,181.1),(35.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,181.1),(36.9,181.3),(37.1,181.3),(37.1,181.1),(36.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,181.1),(38.5,181.3),(38.7,181.3),(38.7,181.1),(38.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,181.1),(40.1,181.3),(40.3,181.3),(40.3,181.1),(40.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,181.1),(41.7,181.3),(41.9,181.3),(41.9,181.1),(41.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,181.1),(43.3,181.3),(43.5,181.3),(43.5,181.1),(43.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,181.1),(44.9,181.3),(45.1,181.3),(45.1,181.1),(44.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,181.1),(46.5,181.3),(46.7,181.3),(46.7,181.1),(46.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,181.1),(48.1,181.3),(48.3,181.3),(48.3,181.1),(48.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,181.1),(49.7,181.3),(49.9,181.3),(49.9,181.1),(49.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,181.1),(51.3,181.3),(51.5,181.3),(51.5,181.1),(51.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,181.1),(52.9,181.3),(53.1,181.3),(53.1,181.1),(52.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,181.1),(54.5,181.3),(54.7,181.3),(54.7,181.1),(54.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,181.1),(56.1,181.3),(56.3,181.3),(56.3,181.1),(56.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,181.1),(57.7,181.3),(57.9,181.3),(57.9,181.1),(57.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,181.1),(59.3,181.3),(59.5,181.3),(59.5,181.1),(59.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,181.1),(60.9,181.3),(61.1,181.3),(61.1,181.1),(60.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,181.1),(62.5,181.3),(62.7,181.3),(62.7,181.1),(62.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,181.1),(64.1,181.3),(64.3,181.3),(64.3,181.1),(64.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,181.1),(65.7,181.3),(65.9,181.3),(65.9,181.1),(65.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,181.1),(67.3,181.3),(67.5,181.3),(67.5,181.1),(67.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,181.1),(68.9,181.3),(69.1,181.3),(69.1,181.1),(68.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,181.1),(70.5,181.3),(70.7,181.3),(70.7,181.1),(70.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,181.1),(72.1,181.3),(72.3,181.3),(72.3,181.1),(72.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,181.1),(73.7,181.3),(73.9,181.3),(73.9,181.1),(73.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,181.1),(75.3,181.3),(75.5,181.3),(75.5,181.1),(75.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,181.1),(76.9,181.3),(77.1,181.3),(77.1,181.1),(76.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,181.1),(78.5,181.3),(78.7,181.3),(78.7,181.1),(78.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,181.1),(80.1,181.3),(80.3,181.3),(80.3,181.1),(80.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,181.1),(81.7,181.3),(81.9,181.3),(81.9,181.1),(81.7,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,181.1),(83.3,181.3),(83.5,181.3),(83.5,181.1),(83.3,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,181.1),(84.9,181.3),(85.1,181.3),(85.1,181.1),(84.9,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,181.1),(86.5,181.3),(86.7,181.3),(86.7,181.1),(86.5,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,181.1),(88.1,181.3),(88.3,181.3),(88.3,181.1),(88.1,181.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,182.7),(1.7,182.9),(1.9,182.9),(1.9,182.7),(1.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,182.7),(3.3,182.9),(3.5,182.9),(3.5,182.7),(3.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,182.7),(4.9,182.9),(5.1,182.9),(5.1,182.7),(4.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,182.7),(6.5,182.9),(6.7,182.9),(6.7,182.7),(6.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,182.7),(8.1,182.9),(8.3,182.9),(8.3,182.7),(8.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,182.7),(9.7,182.9),(9.9,182.9),(9.9,182.7),(9.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,182.7),(11.3,182.9),(11.5,182.9),(11.5,182.7),(11.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,182.7),(12.9,182.9),(13.1,182.9),(13.1,182.7),(12.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,182.7),(14.5,182.9),(14.7,182.9),(14.7,182.7),(14.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,182.7),(16.1,182.9),(16.3,182.9),(16.3,182.7),(16.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,182.7),(17.7,182.9),(17.9,182.9),(17.9,182.7),(17.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,182.7),(19.3,182.9),(19.5,182.9),(19.5,182.7),(19.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,182.7),(20.9,182.9),(21.1,182.9),(21.1,182.7),(20.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,182.7),(22.5,182.9),(22.7,182.9),(22.7,182.7),(22.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,182.7),(24.1,182.9),(24.3,182.9),(24.3,182.7),(24.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,182.7),(25.7,182.9),(25.9,182.9),(25.9,182.7),(25.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,182.7),(27.3,182.9),(27.5,182.9),(27.5,182.7),(27.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,182.7),(28.9,182.9),(29.1,182.9),(29.1,182.7),(28.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,182.7),(30.5,182.9),(30.7,182.9),(30.7,182.7),(30.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,182.7),(32.1,182.9),(32.3,182.9),(32.3,182.7),(32.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,182.7),(33.7,182.9),(33.9,182.9),(33.9,182.7),(33.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,182.7),(35.3,182.9),(35.5,182.9),(35.5,182.7),(35.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,182.7),(36.9,182.9),(37.1,182.9),(37.1,182.7),(36.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,182.7),(38.5,182.9),(38.7,182.9),(38.7,182.7),(38.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,182.7),(40.1,182.9),(40.3,182.9),(40.3,182.7),(40.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,182.7),(41.7,182.9),(41.9,182.9),(41.9,182.7),(41.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,182.7),(43.3,182.9),(43.5,182.9),(43.5,182.7),(43.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,182.7),(44.9,182.9),(45.1,182.9),(45.1,182.7),(44.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,182.7),(46.5,182.9),(46.7,182.9),(46.7,182.7),(46.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,182.7),(48.1,182.9),(48.3,182.9),(48.3,182.7),(48.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,182.7),(49.7,182.9),(49.9,182.9),(49.9,182.7),(49.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,182.7),(51.3,182.9),(51.5,182.9),(51.5,182.7),(51.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,182.7),(52.9,182.9),(53.1,182.9),(53.1,182.7),(52.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,182.7),(54.5,182.9),(54.7,182.9),(54.7,182.7),(54.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,182.7),(56.1,182.9),(56.3,182.9),(56.3,182.7),(56.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,182.7),(57.7,182.9),(57.9,182.9),(57.9,182.7),(57.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,182.7),(59.3,182.9),(59.5,182.9),(59.5,182.7),(59.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,182.7),(60.9,182.9),(61.1,182.9),(61.1,182.7),(60.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,182.7),(62.5,182.9),(62.7,182.9),(62.7,182.7),(62.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,182.7),(64.1,182.9),(64.3,182.9),(64.3,182.7),(64.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,182.7),(65.7,182.9),(65.9,182.9),(65.9,182.7),(65.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,182.7),(67.3,182.9),(67.5,182.9),(67.5,182.7),(67.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,182.7),(68.9,182.9),(69.1,182.9),(69.1,182.7),(68.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,182.7),(70.5,182.9),(70.7,182.9),(70.7,182.7),(70.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,182.7),(72.1,182.9),(72.3,182.9),(72.3,182.7),(72.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,182.7),(73.7,182.9),(73.9,182.9),(73.9,182.7),(73.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,182.7),(75.3,182.9),(75.5,182.9),(75.5,182.7),(75.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,182.7),(76.9,182.9),(77.1,182.9),(77.1,182.7),(76.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,182.7),(78.5,182.9),(78.7,182.9),(78.7,182.7),(78.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,182.7),(80.1,182.9),(80.3,182.9),(80.3,182.7),(80.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,182.7),(81.7,182.9),(81.9,182.9),(81.9,182.7),(81.7,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,182.7),(83.3,182.9),(83.5,182.9),(83.5,182.7),(83.3,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,182.7),(84.9,182.9),(85.1,182.9),(85.1,182.7),(84.9,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,182.7),(86.5,182.9),(86.7,182.9),(86.7,182.7),(86.5,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,182.7),(88.1,182.9),(88.3,182.9),(88.3,182.7),(88.1,182.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,184.3),(1.7,184.5),(1.9,184.5),(1.9,184.3),(1.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,184.3),(3.3,184.5),(3.5,184.5),(3.5,184.3),(3.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,184.3),(4.9,184.5),(5.1,184.5),(5.1,184.3),(4.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,184.3),(6.5,184.5),(6.7,184.5),(6.7,184.3),(6.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,184.3),(8.1,184.5),(8.3,184.5),(8.3,184.3),(8.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,184.3),(9.7,184.5),(9.9,184.5),(9.9,184.3),(9.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,184.3),(11.3,184.5),(11.5,184.5),(11.5,184.3),(11.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,184.3),(12.9,184.5),(13.1,184.5),(13.1,184.3),(12.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,184.3),(14.5,184.5),(14.7,184.5),(14.7,184.3),(14.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,184.3),(16.1,184.5),(16.3,184.5),(16.3,184.3),(16.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,184.3),(17.7,184.5),(17.9,184.5),(17.9,184.3),(17.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,184.3),(19.3,184.5),(19.5,184.5),(19.5,184.3),(19.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,184.3),(20.9,184.5),(21.1,184.5),(21.1,184.3),(20.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,184.3),(22.5,184.5),(22.7,184.5),(22.7,184.3),(22.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,184.3),(24.1,184.5),(24.3,184.5),(24.3,184.3),(24.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,184.3),(25.7,184.5),(25.9,184.5),(25.9,184.3),(25.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,184.3),(27.3,184.5),(27.5,184.5),(27.5,184.3),(27.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,184.3),(28.9,184.5),(29.1,184.5),(29.1,184.3),(28.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,184.3),(30.5,184.5),(30.7,184.5),(30.7,184.3),(30.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,184.3),(32.1,184.5),(32.3,184.5),(32.3,184.3),(32.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,184.3),(33.7,184.5),(33.9,184.5),(33.9,184.3),(33.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,184.3),(35.3,184.5),(35.5,184.5),(35.5,184.3),(35.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,184.3),(36.9,184.5),(37.1,184.5),(37.1,184.3),(36.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,184.3),(38.5,184.5),(38.7,184.5),(38.7,184.3),(38.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,184.3),(40.1,184.5),(40.3,184.5),(40.3,184.3),(40.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,184.3),(41.7,184.5),(41.9,184.5),(41.9,184.3),(41.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,184.3),(43.3,184.5),(43.5,184.5),(43.5,184.3),(43.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,184.3),(44.9,184.5),(45.1,184.5),(45.1,184.3),(44.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,184.3),(46.5,184.5),(46.7,184.5),(46.7,184.3),(46.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,184.3),(48.1,184.5),(48.3,184.5),(48.3,184.3),(48.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,184.3),(49.7,184.5),(49.9,184.5),(49.9,184.3),(49.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,184.3),(51.3,184.5),(51.5,184.5),(51.5,184.3),(51.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,184.3),(52.9,184.5),(53.1,184.5),(53.1,184.3),(52.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,184.3),(54.5,184.5),(54.7,184.5),(54.7,184.3),(54.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,184.3),(56.1,184.5),(56.3,184.5),(56.3,184.3),(56.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,184.3),(57.7,184.5),(57.9,184.5),(57.9,184.3),(57.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,184.3),(59.3,184.5),(59.5,184.5),(59.5,184.3),(59.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,184.3),(60.9,184.5),(61.1,184.5),(61.1,184.3),(60.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,184.3),(62.5,184.5),(62.7,184.5),(62.7,184.3),(62.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,184.3),(64.1,184.5),(64.3,184.5),(64.3,184.3),(64.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,184.3),(65.7,184.5),(65.9,184.5),(65.9,184.3),(65.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,184.3),(67.3,184.5),(67.5,184.5),(67.5,184.3),(67.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,184.3),(68.9,184.5),(69.1,184.5),(69.1,184.3),(68.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,184.3),(70.5,184.5),(70.7,184.5),(70.7,184.3),(70.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,184.3),(72.1,184.5),(72.3,184.5),(72.3,184.3),(72.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,184.3),(73.7,184.5),(73.9,184.5),(73.9,184.3),(73.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,184.3),(75.3,184.5),(75.5,184.5),(75.5,184.3),(75.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,184.3),(76.9,184.5),(77.1,184.5),(77.1,184.3),(76.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,184.3),(78.5,184.5),(78.7,184.5),(78.7,184.3),(78.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,184.3),(80.1,184.5),(80.3,184.5),(80.3,184.3),(80.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,184.3),(81.7,184.5),(81.9,184.5),(81.9,184.3),(81.7,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,184.3),(83.3,184.5),(83.5,184.5),(83.5,184.3),(83.3,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,184.3),(84.9,184.5),(85.1,184.5),(85.1,184.3),(84.9,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,184.3),(86.5,184.5),(86.7,184.5),(86.7,184.3),(86.5,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,184.3),(88.1,184.5),(88.3,184.5),(88.3,184.3),(88.1,184.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,185.9),(1.7,186.1),(1.9,186.1),(1.9,185.9),(1.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,185.9),(3.3,186.1),(3.5,186.1),(3.5,185.9),(3.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,185.9),(4.9,186.1),(5.1,186.1),(5.1,185.9),(4.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,185.9),(6.5,186.1),(6.7,186.1),(6.7,185.9),(6.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,185.9),(8.1,186.1),(8.3,186.1),(8.3,185.9),(8.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,185.9),(9.7,186.1),(9.9,186.1),(9.9,185.9),(9.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,185.9),(11.3,186.1),(11.5,186.1),(11.5,185.9),(11.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,185.9),(12.9,186.1),(13.1,186.1),(13.1,185.9),(12.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,185.9),(14.5,186.1),(14.7,186.1),(14.7,185.9),(14.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,185.9),(16.1,186.1),(16.3,186.1),(16.3,185.9),(16.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,185.9),(17.7,186.1),(17.9,186.1),(17.9,185.9),(17.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,185.9),(19.3,186.1),(19.5,186.1),(19.5,185.9),(19.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,185.9),(20.9,186.1),(21.1,186.1),(21.1,185.9),(20.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,185.9),(22.5,186.1),(22.7,186.1),(22.7,185.9),(22.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,185.9),(24.1,186.1),(24.3,186.1),(24.3,185.9),(24.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,185.9),(25.7,186.1),(25.9,186.1),(25.9,185.9),(25.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,185.9),(27.3,186.1),(27.5,186.1),(27.5,185.9),(27.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,185.9),(28.9,186.1),(29.1,186.1),(29.1,185.9),(28.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,185.9),(30.5,186.1),(30.7,186.1),(30.7,185.9),(30.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,185.9),(32.1,186.1),(32.3,186.1),(32.3,185.9),(32.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,185.9),(33.7,186.1),(33.9,186.1),(33.9,185.9),(33.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,185.9),(35.3,186.1),(35.5,186.1),(35.5,185.9),(35.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,185.9),(36.9,186.1),(37.1,186.1),(37.1,185.9),(36.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,185.9),(38.5,186.1),(38.7,186.1),(38.7,185.9),(38.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,185.9),(40.1,186.1),(40.3,186.1),(40.3,185.9),(40.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,185.9),(41.7,186.1),(41.9,186.1),(41.9,185.9),(41.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,185.9),(43.3,186.1),(43.5,186.1),(43.5,185.9),(43.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,185.9),(44.9,186.1),(45.1,186.1),(45.1,185.9),(44.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,185.9),(46.5,186.1),(46.7,186.1),(46.7,185.9),(46.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,185.9),(48.1,186.1),(48.3,186.1),(48.3,185.9),(48.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,185.9),(49.7,186.1),(49.9,186.1),(49.9,185.9),(49.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,185.9),(51.3,186.1),(51.5,186.1),(51.5,185.9),(51.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,185.9),(52.9,186.1),(53.1,186.1),(53.1,185.9),(52.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,185.9),(54.5,186.1),(54.7,186.1),(54.7,185.9),(54.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,185.9),(56.1,186.1),(56.3,186.1),(56.3,185.9),(56.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,185.9),(57.7,186.1),(57.9,186.1),(57.9,185.9),(57.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,185.9),(59.3,186.1),(59.5,186.1),(59.5,185.9),(59.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,185.9),(60.9,186.1),(61.1,186.1),(61.1,185.9),(60.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,185.9),(62.5,186.1),(62.7,186.1),(62.7,185.9),(62.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,185.9),(64.1,186.1),(64.3,186.1),(64.3,185.9),(64.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,185.9),(65.7,186.1),(65.9,186.1),(65.9,185.9),(65.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,185.9),(67.3,186.1),(67.5,186.1),(67.5,185.9),(67.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,185.9),(68.9,186.1),(69.1,186.1),(69.1,185.9),(68.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,185.9),(70.5,186.1),(70.7,186.1),(70.7,185.9),(70.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,185.9),(72.1,186.1),(72.3,186.1),(72.3,185.9),(72.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,185.9),(73.7,186.1),(73.9,186.1),(73.9,185.9),(73.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,185.9),(75.3,186.1),(75.5,186.1),(75.5,185.9),(75.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,185.9),(76.9,186.1),(77.1,186.1),(77.1,185.9),(76.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,185.9),(78.5,186.1),(78.7,186.1),(78.7,185.9),(78.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,185.9),(80.1,186.1),(80.3,186.1),(80.3,185.9),(80.1,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,185.9),(81.7,186.1),(81.9,186.1),(81.9,185.9),(81.7,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,185.9),(83.3,186.1),(83.5,186.1),(83.5,185.9),(83.3,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,185.9),(84.9,186.1),(85.1,186.1),(85.1,185.9),(84.9,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,185.9),(86.5,186.1),(86.7,186.1),(86.7,185.9),(86.5,185.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,185.9),(88.1,186.1),(88.3,186.1),(88.3,185.9),(88.1,185.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'm2',
            ((0.0,173.6),(0.0,188.0),(90.0,188.0),(90.0,173.6),(0.0,173.6)),
        )
        createRL(
            tech, net, 'm2',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        Horizontal.create(
            net, tech.getLayer('m2.pin'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m2'),
            u(180.8), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm4',
            ((0.0,158.0),(0.0,172.4),(90.0,172.4),(90.0,158.0),(0.0,158.0)),
        )
        createRL(
            tech, net, 'm4',
            ((1.635,159.835),(1.635,168.165),(88.365,168.165),(88.365,159.835),(1.635,159.835)),
        )
        Horizontal.create(
            net, tech.getLayer('m4.pin'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m4'),
            u(165.2), u(14.4), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm3',
            ((45.6,169.995),(45.6,174.78),(88.8,174.78),(88.8,169.995),(45.6,169.995)),
        )
        createRL(
            tech, net, 'm3',
            ((1.4,159.4),(1.4,168.6),(88.6,168.6),(88.6,159.4),(1.4,159.4)),
        )
        createRL(
            tech, net, 'm3',
            ((1.64,159.81),(1.64,168.19),(88.36,168.19),(88.36,159.81),(1.64,159.81)),
        )
        createRL(
            tech, net, 'm3',
            ((45.6,173.6),(45.6,174.78),(88.8,174.78),(88.8,173.6),(45.6,173.6)),
        )
        createRL(
            tech, net, 'm3',
            ((0.0,158.0),(0.0,170.0),(90.0,170.0),(90.0,158.0),(0.0,158.0)),
        )
        Horizontal.create(
            net, tech.getLayer('m3.pin'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m3'),
            u(164.0), u(12.0), u(0.0), u(90.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'via2',
            ((45.7,173.69),(45.7,173.89),(45.9,173.89),(45.9,173.69),(45.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,173.69),(46.1,173.89),(46.3,173.89),(46.3,173.69),(46.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,173.69),(46.5,173.89),(46.7,173.89),(46.7,173.69),(46.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,173.69),(46.9,173.89),(47.1,173.89),(47.1,173.69),(46.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,173.69),(47.3,173.89),(47.5,173.89),(47.5,173.69),(47.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,173.69),(47.7,173.89),(47.9,173.89),(47.9,173.69),(47.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,173.69),(48.1,173.89),(48.3,173.89),(48.3,173.69),(48.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,173.69),(48.5,173.89),(48.7,173.89),(48.7,173.69),(48.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,173.69),(48.9,173.89),(49.1,173.89),(49.1,173.69),(48.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,173.69),(49.3,173.89),(49.5,173.89),(49.5,173.69),(49.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,173.69),(49.7,173.89),(49.9,173.89),(49.9,173.69),(49.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,173.69),(50.1,173.89),(50.3,173.89),(50.3,173.69),(50.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,173.69),(50.5,173.89),(50.7,173.89),(50.7,173.69),(50.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,173.69),(50.9,173.89),(51.1,173.89),(51.1,173.69),(50.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,173.69),(51.3,173.89),(51.5,173.89),(51.5,173.69),(51.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,173.69),(51.7,173.89),(51.9,173.89),(51.9,173.69),(51.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,173.69),(52.1,173.89),(52.3,173.89),(52.3,173.69),(52.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,173.69),(52.5,173.89),(52.7,173.89),(52.7,173.69),(52.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,173.69),(52.9,173.89),(53.1,173.89),(53.1,173.69),(52.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,173.69),(53.3,173.89),(53.5,173.89),(53.5,173.69),(53.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,173.69),(53.7,173.89),(53.9,173.89),(53.9,173.69),(53.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,173.69),(54.1,173.89),(54.3,173.89),(54.3,173.69),(54.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,173.69),(54.5,173.89),(54.7,173.89),(54.7,173.69),(54.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,173.69),(54.9,173.89),(55.1,173.89),(55.1,173.69),(54.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,173.69),(55.3,173.89),(55.5,173.89),(55.5,173.69),(55.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,173.69),(55.7,173.89),(55.9,173.89),(55.9,173.69),(55.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,173.69),(56.1,173.89),(56.3,173.89),(56.3,173.69),(56.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,173.69),(56.5,173.89),(56.7,173.89),(56.7,173.69),(56.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,173.69),(56.9,173.89),(57.1,173.89),(57.1,173.69),(56.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,173.69),(57.3,173.89),(57.5,173.89),(57.5,173.69),(57.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,173.69),(57.7,173.89),(57.9,173.89),(57.9,173.69),(57.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,173.69),(58.1,173.89),(58.3,173.89),(58.3,173.69),(58.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,173.69),(58.5,173.89),(58.7,173.89),(58.7,173.69),(58.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,173.69),(58.9,173.89),(59.1,173.89),(59.1,173.69),(58.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,173.69),(59.3,173.89),(59.5,173.89),(59.5,173.69),(59.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,173.69),(59.7,173.89),(59.9,173.89),(59.9,173.69),(59.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,173.69),(60.1,173.89),(60.3,173.89),(60.3,173.69),(60.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,173.69),(60.5,173.89),(60.7,173.89),(60.7,173.69),(60.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,173.69),(60.9,173.89),(61.1,173.89),(61.1,173.69),(60.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,173.69),(61.3,173.89),(61.5,173.89),(61.5,173.69),(61.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,173.69),(61.7,173.89),(61.9,173.89),(61.9,173.69),(61.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,173.69),(62.1,173.89),(62.3,173.89),(62.3,173.69),(62.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,173.69),(62.5,173.89),(62.7,173.89),(62.7,173.69),(62.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,173.69),(62.9,173.89),(63.1,173.89),(63.1,173.69),(62.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,173.69),(63.3,173.89),(63.5,173.89),(63.5,173.69),(63.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,173.69),(63.7,173.89),(63.9,173.89),(63.9,173.69),(63.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,173.69),(64.1,173.89),(64.3,173.89),(64.3,173.69),(64.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,173.69),(64.5,173.89),(64.7,173.89),(64.7,173.69),(64.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,173.69),(64.9,173.89),(65.1,173.89),(65.1,173.69),(64.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,173.69),(65.3,173.89),(65.5,173.89),(65.5,173.69),(65.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,173.69),(65.7,173.89),(65.9,173.89),(65.9,173.69),(65.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,173.69),(66.1,173.89),(66.3,173.89),(66.3,173.69),(66.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,173.69),(66.5,173.89),(66.7,173.89),(66.7,173.69),(66.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,173.69),(66.9,173.89),(67.1,173.89),(67.1,173.69),(66.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,173.69),(67.3,173.89),(67.5,173.89),(67.5,173.69),(67.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,173.69),(67.7,173.89),(67.9,173.89),(67.9,173.69),(67.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,173.69),(68.1,173.89),(68.3,173.89),(68.3,173.69),(68.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,173.69),(68.5,173.89),(68.7,173.89),(68.7,173.69),(68.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,173.69),(68.9,173.89),(69.1,173.89),(69.1,173.69),(68.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,173.69),(69.3,173.89),(69.5,173.89),(69.5,173.69),(69.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,173.69),(69.7,173.89),(69.9,173.89),(69.9,173.69),(69.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,173.69),(70.1,173.89),(70.3,173.89),(70.3,173.69),(70.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,173.69),(70.5,173.89),(70.7,173.89),(70.7,173.69),(70.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,173.69),(70.9,173.89),(71.1,173.89),(71.1,173.69),(70.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,173.69),(71.3,173.89),(71.5,173.89),(71.5,173.69),(71.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,173.69),(71.7,173.89),(71.9,173.89),(71.9,173.69),(71.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,173.69),(72.1,173.89),(72.3,173.89),(72.3,173.69),(72.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,173.69),(72.5,173.89),(72.7,173.89),(72.7,173.69),(72.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,173.69),(72.9,173.89),(73.1,173.89),(73.1,173.69),(72.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,173.69),(73.3,173.89),(73.5,173.89),(73.5,173.69),(73.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,173.69),(73.7,173.89),(73.9,173.89),(73.9,173.69),(73.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,173.69),(74.1,173.89),(74.3,173.89),(74.3,173.69),(74.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,173.69),(74.5,173.89),(74.7,173.89),(74.7,173.69),(74.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,173.69),(74.9,173.89),(75.1,173.89),(75.1,173.69),(74.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,173.69),(75.3,173.89),(75.5,173.89),(75.5,173.69),(75.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,173.69),(75.7,173.89),(75.9,173.89),(75.9,173.69),(75.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,173.69),(76.1,173.89),(76.3,173.89),(76.3,173.69),(76.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,173.69),(76.5,173.89),(76.7,173.89),(76.7,173.69),(76.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,173.69),(76.9,173.89),(77.1,173.89),(77.1,173.69),(76.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,173.69),(77.3,173.89),(77.5,173.89),(77.5,173.69),(77.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,173.69),(77.7,173.89),(77.9,173.89),(77.9,173.69),(77.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,173.69),(78.1,173.89),(78.3,173.89),(78.3,173.69),(78.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,173.69),(78.5,173.89),(78.7,173.89),(78.7,173.69),(78.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,173.69),(78.9,173.89),(79.1,173.89),(79.1,173.69),(78.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,173.69),(79.3,173.89),(79.5,173.89),(79.5,173.69),(79.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,173.69),(79.7,173.89),(79.9,173.89),(79.9,173.69),(79.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,173.69),(80.1,173.89),(80.3,173.89),(80.3,173.69),(80.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,173.69),(80.5,173.89),(80.7,173.89),(80.7,173.69),(80.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,173.69),(80.9,173.89),(81.1,173.89),(81.1,173.69),(80.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,173.69),(81.3,173.89),(81.5,173.89),(81.5,173.69),(81.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,173.69),(81.7,173.89),(81.9,173.89),(81.9,173.69),(81.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,173.69),(82.1,173.89),(82.3,173.89),(82.3,173.69),(82.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,173.69),(82.5,173.89),(82.7,173.89),(82.7,173.69),(82.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,173.69),(82.9,173.89),(83.1,173.89),(83.1,173.69),(82.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,173.69),(83.3,173.89),(83.5,173.89),(83.5,173.69),(83.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,173.69),(83.7,173.89),(83.9,173.89),(83.9,173.69),(83.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,173.69),(84.1,173.89),(84.3,173.89),(84.3,173.69),(84.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,173.69),(84.5,173.89),(84.7,173.89),(84.7,173.69),(84.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,173.69),(84.9,173.89),(85.1,173.89),(85.1,173.69),(84.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,173.69),(85.3,173.89),(85.5,173.89),(85.5,173.69),(85.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,173.69),(85.7,173.89),(85.9,173.89),(85.9,173.69),(85.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,173.69),(86.1,173.89),(86.3,173.89),(86.3,173.69),(86.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,173.69),(86.5,173.89),(86.7,173.89),(86.7,173.69),(86.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,173.69),(86.9,173.89),(87.1,173.89),(87.1,173.69),(86.9,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,173.69),(87.3,173.89),(87.5,173.89),(87.5,173.69),(87.3,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,173.69),(87.7,173.89),(87.9,173.89),(87.9,173.69),(87.7,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,173.69),(88.1,173.89),(88.3,173.89),(88.3,173.69),(88.1,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,173.69),(88.5,173.89),(88.7,173.89),(88.7,173.69),(88.5,173.69)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.09),(45.7,174.29),(45.9,174.29),(45.9,174.09),(45.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.09),(46.1,174.29),(46.3,174.29),(46.3,174.09),(46.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.09),(46.5,174.29),(46.7,174.29),(46.7,174.09),(46.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.09),(46.9,174.29),(47.1,174.29),(47.1,174.09),(46.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.09),(47.3,174.29),(47.5,174.29),(47.5,174.09),(47.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.09),(47.7,174.29),(47.9,174.29),(47.9,174.09),(47.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.09),(48.1,174.29),(48.3,174.29),(48.3,174.09),(48.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.09),(48.5,174.29),(48.7,174.29),(48.7,174.09),(48.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.09),(48.9,174.29),(49.1,174.29),(49.1,174.09),(48.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.09),(49.3,174.29),(49.5,174.29),(49.5,174.09),(49.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.09),(49.7,174.29),(49.9,174.29),(49.9,174.09),(49.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.09),(50.1,174.29),(50.3,174.29),(50.3,174.09),(50.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.09),(50.5,174.29),(50.7,174.29),(50.7,174.09),(50.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.09),(50.9,174.29),(51.1,174.29),(51.1,174.09),(50.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.09),(51.3,174.29),(51.5,174.29),(51.5,174.09),(51.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.09),(51.7,174.29),(51.9,174.29),(51.9,174.09),(51.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.09),(52.1,174.29),(52.3,174.29),(52.3,174.09),(52.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.09),(52.5,174.29),(52.7,174.29),(52.7,174.09),(52.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.09),(52.9,174.29),(53.1,174.29),(53.1,174.09),(52.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.09),(53.3,174.29),(53.5,174.29),(53.5,174.09),(53.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.09),(53.7,174.29),(53.9,174.29),(53.9,174.09),(53.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.09),(54.1,174.29),(54.3,174.29),(54.3,174.09),(54.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.09),(54.5,174.29),(54.7,174.29),(54.7,174.09),(54.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.09),(54.9,174.29),(55.1,174.29),(55.1,174.09),(54.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.09),(55.3,174.29),(55.5,174.29),(55.5,174.09),(55.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.09),(55.7,174.29),(55.9,174.29),(55.9,174.09),(55.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.09),(56.1,174.29),(56.3,174.29),(56.3,174.09),(56.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.09),(56.5,174.29),(56.7,174.29),(56.7,174.09),(56.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.09),(56.9,174.29),(57.1,174.29),(57.1,174.09),(56.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.09),(57.3,174.29),(57.5,174.29),(57.5,174.09),(57.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.09),(57.7,174.29),(57.9,174.29),(57.9,174.09),(57.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.09),(58.1,174.29),(58.3,174.29),(58.3,174.09),(58.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.09),(58.5,174.29),(58.7,174.29),(58.7,174.09),(58.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.09),(58.9,174.29),(59.1,174.29),(59.1,174.09),(58.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.09),(59.3,174.29),(59.5,174.29),(59.5,174.09),(59.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.09),(59.7,174.29),(59.9,174.29),(59.9,174.09),(59.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.09),(60.1,174.29),(60.3,174.29),(60.3,174.09),(60.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.09),(60.5,174.29),(60.7,174.29),(60.7,174.09),(60.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.09),(60.9,174.29),(61.1,174.29),(61.1,174.09),(60.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.09),(61.3,174.29),(61.5,174.29),(61.5,174.09),(61.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.09),(61.7,174.29),(61.9,174.29),(61.9,174.09),(61.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.09),(62.1,174.29),(62.3,174.29),(62.3,174.09),(62.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.09),(62.5,174.29),(62.7,174.29),(62.7,174.09),(62.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.09),(62.9,174.29),(63.1,174.29),(63.1,174.09),(62.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.09),(63.3,174.29),(63.5,174.29),(63.5,174.09),(63.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.09),(63.7,174.29),(63.9,174.29),(63.9,174.09),(63.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.09),(64.1,174.29),(64.3,174.29),(64.3,174.09),(64.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.09),(64.5,174.29),(64.7,174.29),(64.7,174.09),(64.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.09),(64.9,174.29),(65.1,174.29),(65.1,174.09),(64.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.09),(65.3,174.29),(65.5,174.29),(65.5,174.09),(65.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.09),(65.7,174.29),(65.9,174.29),(65.9,174.09),(65.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.09),(66.1,174.29),(66.3,174.29),(66.3,174.09),(66.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.09),(66.5,174.29),(66.7,174.29),(66.7,174.09),(66.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.09),(66.9,174.29),(67.1,174.29),(67.1,174.09),(66.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.09),(67.3,174.29),(67.5,174.29),(67.5,174.09),(67.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.09),(67.7,174.29),(67.9,174.29),(67.9,174.09),(67.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.09),(68.1,174.29),(68.3,174.29),(68.3,174.09),(68.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.09),(68.5,174.29),(68.7,174.29),(68.7,174.09),(68.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.09),(68.9,174.29),(69.1,174.29),(69.1,174.09),(68.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.09),(69.3,174.29),(69.5,174.29),(69.5,174.09),(69.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.09),(69.7,174.29),(69.9,174.29),(69.9,174.09),(69.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.09),(70.1,174.29),(70.3,174.29),(70.3,174.09),(70.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.09),(70.5,174.29),(70.7,174.29),(70.7,174.09),(70.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.09),(70.9,174.29),(71.1,174.29),(71.1,174.09),(70.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.09),(71.3,174.29),(71.5,174.29),(71.5,174.09),(71.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.09),(71.7,174.29),(71.9,174.29),(71.9,174.09),(71.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.09),(72.1,174.29),(72.3,174.29),(72.3,174.09),(72.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.09),(72.5,174.29),(72.7,174.29),(72.7,174.09),(72.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.09),(72.9,174.29),(73.1,174.29),(73.1,174.09),(72.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.09),(73.3,174.29),(73.5,174.29),(73.5,174.09),(73.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.09),(73.7,174.29),(73.9,174.29),(73.9,174.09),(73.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.09),(74.1,174.29),(74.3,174.29),(74.3,174.09),(74.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.09),(74.5,174.29),(74.7,174.29),(74.7,174.09),(74.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.09),(74.9,174.29),(75.1,174.29),(75.1,174.09),(74.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.09),(75.3,174.29),(75.5,174.29),(75.5,174.09),(75.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.09),(75.7,174.29),(75.9,174.29),(75.9,174.09),(75.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.09),(76.1,174.29),(76.3,174.29),(76.3,174.09),(76.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.09),(76.5,174.29),(76.7,174.29),(76.7,174.09),(76.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.09),(76.9,174.29),(77.1,174.29),(77.1,174.09),(76.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.09),(77.3,174.29),(77.5,174.29),(77.5,174.09),(77.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.09),(77.7,174.29),(77.9,174.29),(77.9,174.09),(77.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.09),(78.1,174.29),(78.3,174.29),(78.3,174.09),(78.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.09),(78.5,174.29),(78.7,174.29),(78.7,174.09),(78.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.09),(78.9,174.29),(79.1,174.29),(79.1,174.09),(78.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.09),(79.3,174.29),(79.5,174.29),(79.5,174.09),(79.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.09),(79.7,174.29),(79.9,174.29),(79.9,174.09),(79.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.09),(80.1,174.29),(80.3,174.29),(80.3,174.09),(80.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.09),(80.5,174.29),(80.7,174.29),(80.7,174.09),(80.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.09),(80.9,174.29),(81.1,174.29),(81.1,174.09),(80.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.09),(81.3,174.29),(81.5,174.29),(81.5,174.09),(81.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.09),(81.7,174.29),(81.9,174.29),(81.9,174.09),(81.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.09),(82.1,174.29),(82.3,174.29),(82.3,174.09),(82.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.09),(82.5,174.29),(82.7,174.29),(82.7,174.09),(82.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.09),(82.9,174.29),(83.1,174.29),(83.1,174.09),(82.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.09),(83.3,174.29),(83.5,174.29),(83.5,174.09),(83.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.09),(83.7,174.29),(83.9,174.29),(83.9,174.09),(83.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.09),(84.1,174.29),(84.3,174.29),(84.3,174.09),(84.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.09),(84.5,174.29),(84.7,174.29),(84.7,174.09),(84.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.09),(84.9,174.29),(85.1,174.29),(85.1,174.09),(84.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.09),(85.3,174.29),(85.5,174.29),(85.5,174.09),(85.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.09),(85.7,174.29),(85.9,174.29),(85.9,174.09),(85.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.09),(86.1,174.29),(86.3,174.29),(86.3,174.09),(86.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.09),(86.5,174.29),(86.7,174.29),(86.7,174.09),(86.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.09),(86.9,174.29),(87.1,174.29),(87.1,174.09),(86.9,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.09),(87.3,174.29),(87.5,174.29),(87.5,174.09),(87.3,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.09),(87.7,174.29),(87.9,174.29),(87.9,174.09),(87.7,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.09),(88.1,174.29),(88.3,174.29),(88.3,174.09),(88.1,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.09),(88.5,174.29),(88.7,174.29),(88.7,174.09),(88.5,174.09)),
        )
        createRL(
            tech, net, 'via2',
            ((45.7,174.49),(45.7,174.69),(45.9,174.69),(45.9,174.49),(45.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.1,174.49),(46.1,174.69),(46.3,174.69),(46.3,174.49),(46.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.5,174.49),(46.5,174.69),(46.7,174.69),(46.7,174.49),(46.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((46.9,174.49),(46.9,174.69),(47.1,174.69),(47.1,174.49),(46.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.3,174.49),(47.3,174.69),(47.5,174.69),(47.5,174.49),(47.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((47.7,174.49),(47.7,174.69),(47.9,174.69),(47.9,174.49),(47.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.1,174.49),(48.1,174.69),(48.3,174.69),(48.3,174.49),(48.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.5,174.49),(48.5,174.69),(48.7,174.69),(48.7,174.49),(48.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((48.9,174.49),(48.9,174.69),(49.1,174.69),(49.1,174.49),(48.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.3,174.49),(49.3,174.69),(49.5,174.69),(49.5,174.49),(49.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((49.7,174.49),(49.7,174.69),(49.9,174.69),(49.9,174.49),(49.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.1,174.49),(50.1,174.69),(50.3,174.69),(50.3,174.49),(50.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.5,174.49),(50.5,174.69),(50.7,174.69),(50.7,174.49),(50.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((50.9,174.49),(50.9,174.69),(51.1,174.69),(51.1,174.49),(50.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.3,174.49),(51.3,174.69),(51.5,174.69),(51.5,174.49),(51.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((51.7,174.49),(51.7,174.69),(51.9,174.69),(51.9,174.49),(51.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.1,174.49),(52.1,174.69),(52.3,174.69),(52.3,174.49),(52.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.5,174.49),(52.5,174.69),(52.7,174.69),(52.7,174.49),(52.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((52.9,174.49),(52.9,174.69),(53.1,174.69),(53.1,174.49),(52.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.3,174.49),(53.3,174.69),(53.5,174.69),(53.5,174.49),(53.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((53.7,174.49),(53.7,174.69),(53.9,174.69),(53.9,174.49),(53.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.1,174.49),(54.1,174.69),(54.3,174.69),(54.3,174.49),(54.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.5,174.49),(54.5,174.69),(54.7,174.69),(54.7,174.49),(54.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((54.9,174.49),(54.9,174.69),(55.1,174.69),(55.1,174.49),(54.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.3,174.49),(55.3,174.69),(55.5,174.69),(55.5,174.49),(55.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((55.7,174.49),(55.7,174.69),(55.9,174.69),(55.9,174.49),(55.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.1,174.49),(56.1,174.69),(56.3,174.69),(56.3,174.49),(56.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.5,174.49),(56.5,174.69),(56.7,174.69),(56.7,174.49),(56.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((56.9,174.49),(56.9,174.69),(57.1,174.69),(57.1,174.49),(56.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.3,174.49),(57.3,174.69),(57.5,174.69),(57.5,174.49),(57.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((57.7,174.49),(57.7,174.69),(57.9,174.69),(57.9,174.49),(57.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.1,174.49),(58.1,174.69),(58.3,174.69),(58.3,174.49),(58.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.5,174.49),(58.5,174.69),(58.7,174.69),(58.7,174.49),(58.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((58.9,174.49),(58.9,174.69),(59.1,174.69),(59.1,174.49),(58.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.3,174.49),(59.3,174.69),(59.5,174.69),(59.5,174.49),(59.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((59.7,174.49),(59.7,174.69),(59.9,174.69),(59.9,174.49),(59.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.1,174.49),(60.1,174.69),(60.3,174.69),(60.3,174.49),(60.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.5,174.49),(60.5,174.69),(60.7,174.69),(60.7,174.49),(60.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((60.9,174.49),(60.9,174.69),(61.1,174.69),(61.1,174.49),(60.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.3,174.49),(61.3,174.69),(61.5,174.69),(61.5,174.49),(61.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((61.7,174.49),(61.7,174.69),(61.9,174.69),(61.9,174.49),(61.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.1,174.49),(62.1,174.69),(62.3,174.69),(62.3,174.49),(62.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.5,174.49),(62.5,174.69),(62.7,174.69),(62.7,174.49),(62.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((62.9,174.49),(62.9,174.69),(63.1,174.69),(63.1,174.49),(62.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.3,174.49),(63.3,174.69),(63.5,174.69),(63.5,174.49),(63.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((63.7,174.49),(63.7,174.69),(63.9,174.69),(63.9,174.49),(63.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.1,174.49),(64.1,174.69),(64.3,174.69),(64.3,174.49),(64.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.5,174.49),(64.5,174.69),(64.7,174.69),(64.7,174.49),(64.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((64.9,174.49),(64.9,174.69),(65.1,174.69),(65.1,174.49),(64.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.3,174.49),(65.3,174.69),(65.5,174.69),(65.5,174.49),(65.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((65.7,174.49),(65.7,174.69),(65.9,174.69),(65.9,174.49),(65.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.1,174.49),(66.1,174.69),(66.3,174.69),(66.3,174.49),(66.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.5,174.49),(66.5,174.69),(66.7,174.69),(66.7,174.49),(66.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((66.9,174.49),(66.9,174.69),(67.1,174.69),(67.1,174.49),(66.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.3,174.49),(67.3,174.69),(67.5,174.69),(67.5,174.49),(67.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((67.7,174.49),(67.7,174.69),(67.9,174.69),(67.9,174.49),(67.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.1,174.49),(68.1,174.69),(68.3,174.69),(68.3,174.49),(68.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.5,174.49),(68.5,174.69),(68.7,174.69),(68.7,174.49),(68.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((68.9,174.49),(68.9,174.69),(69.1,174.69),(69.1,174.49),(68.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.3,174.49),(69.3,174.69),(69.5,174.69),(69.5,174.49),(69.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((69.7,174.49),(69.7,174.69),(69.9,174.69),(69.9,174.49),(69.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.1,174.49),(70.1,174.69),(70.3,174.69),(70.3,174.49),(70.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.5,174.49),(70.5,174.69),(70.7,174.69),(70.7,174.49),(70.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((70.9,174.49),(70.9,174.69),(71.1,174.69),(71.1,174.49),(70.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.3,174.49),(71.3,174.69),(71.5,174.69),(71.5,174.49),(71.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((71.7,174.49),(71.7,174.69),(71.9,174.69),(71.9,174.49),(71.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.1,174.49),(72.1,174.69),(72.3,174.69),(72.3,174.49),(72.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.5,174.49),(72.5,174.69),(72.7,174.69),(72.7,174.49),(72.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((72.9,174.49),(72.9,174.69),(73.1,174.69),(73.1,174.49),(72.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.3,174.49),(73.3,174.69),(73.5,174.69),(73.5,174.49),(73.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((73.7,174.49),(73.7,174.69),(73.9,174.69),(73.9,174.49),(73.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.1,174.49),(74.1,174.69),(74.3,174.69),(74.3,174.49),(74.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.5,174.49),(74.5,174.69),(74.7,174.69),(74.7,174.49),(74.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((74.9,174.49),(74.9,174.69),(75.1,174.69),(75.1,174.49),(74.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.3,174.49),(75.3,174.69),(75.5,174.69),(75.5,174.49),(75.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((75.7,174.49),(75.7,174.69),(75.9,174.69),(75.9,174.49),(75.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.1,174.49),(76.1,174.69),(76.3,174.69),(76.3,174.49),(76.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.5,174.49),(76.5,174.69),(76.7,174.69),(76.7,174.49),(76.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((76.9,174.49),(76.9,174.69),(77.1,174.69),(77.1,174.49),(76.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.3,174.49),(77.3,174.69),(77.5,174.69),(77.5,174.49),(77.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((77.7,174.49),(77.7,174.69),(77.9,174.69),(77.9,174.49),(77.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.1,174.49),(78.1,174.69),(78.3,174.69),(78.3,174.49),(78.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.5,174.49),(78.5,174.69),(78.7,174.69),(78.7,174.49),(78.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((78.9,174.49),(78.9,174.69),(79.1,174.69),(79.1,174.49),(78.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.3,174.49),(79.3,174.69),(79.5,174.69),(79.5,174.49),(79.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((79.7,174.49),(79.7,174.69),(79.9,174.69),(79.9,174.49),(79.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.1,174.49),(80.1,174.69),(80.3,174.69),(80.3,174.49),(80.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.5,174.49),(80.5,174.69),(80.7,174.69),(80.7,174.49),(80.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((80.9,174.49),(80.9,174.69),(81.1,174.69),(81.1,174.49),(80.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.3,174.49),(81.3,174.69),(81.5,174.69),(81.5,174.49),(81.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((81.7,174.49),(81.7,174.69),(81.9,174.69),(81.9,174.49),(81.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.1,174.49),(82.1,174.69),(82.3,174.69),(82.3,174.49),(82.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.5,174.49),(82.5,174.69),(82.7,174.69),(82.7,174.49),(82.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((82.9,174.49),(82.9,174.69),(83.1,174.69),(83.1,174.49),(82.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.3,174.49),(83.3,174.69),(83.5,174.69),(83.5,174.49),(83.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((83.7,174.49),(83.7,174.69),(83.9,174.69),(83.9,174.49),(83.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.1,174.49),(84.1,174.69),(84.3,174.69),(84.3,174.49),(84.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.5,174.49),(84.5,174.69),(84.7,174.69),(84.7,174.49),(84.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((84.9,174.49),(84.9,174.69),(85.1,174.69),(85.1,174.49),(84.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.3,174.49),(85.3,174.69),(85.5,174.69),(85.5,174.49),(85.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((85.7,174.49),(85.7,174.69),(85.9,174.69),(85.9,174.49),(85.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.1,174.49),(86.1,174.69),(86.3,174.69),(86.3,174.49),(86.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.5,174.49),(86.5,174.69),(86.7,174.69),(86.7,174.49),(86.5,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((86.9,174.49),(86.9,174.69),(87.1,174.69),(87.1,174.49),(86.9,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.3,174.49),(87.3,174.69),(87.5,174.69),(87.5,174.49),(87.3,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((87.7,174.49),(87.7,174.69),(87.9,174.69),(87.9,174.49),(87.7,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.1,174.49),(88.1,174.69),(88.3,174.69),(88.3,174.49),(88.1,174.49)),
        )
        createRL(
            tech, net, 'via2',
            ((88.5,174.49),(88.5,174.69),(88.7,174.69),(88.7,174.49),(88.5,174.49)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,159.9),(1.7,160.1),(1.9,160.1),(1.9,159.9),(1.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,159.9),(3.3,160.1),(3.5,160.1),(3.5,159.9),(3.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,159.9),(4.9,160.1),(5.1,160.1),(5.1,159.9),(4.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,159.9),(6.5,160.1),(6.7,160.1),(6.7,159.9),(6.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,159.9),(8.1,160.1),(8.3,160.1),(8.3,159.9),(8.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,159.9),(9.7,160.1),(9.9,160.1),(9.9,159.9),(9.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,159.9),(11.3,160.1),(11.5,160.1),(11.5,159.9),(11.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,159.9),(12.9,160.1),(13.1,160.1),(13.1,159.9),(12.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,159.9),(14.5,160.1),(14.7,160.1),(14.7,159.9),(14.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,159.9),(16.1,160.1),(16.3,160.1),(16.3,159.9),(16.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,159.9),(17.7,160.1),(17.9,160.1),(17.9,159.9),(17.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,159.9),(19.3,160.1),(19.5,160.1),(19.5,159.9),(19.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,159.9),(20.9,160.1),(21.1,160.1),(21.1,159.9),(20.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,159.9),(22.5,160.1),(22.7,160.1),(22.7,159.9),(22.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,159.9),(24.1,160.1),(24.3,160.1),(24.3,159.9),(24.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,159.9),(25.7,160.1),(25.9,160.1),(25.9,159.9),(25.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,159.9),(27.3,160.1),(27.5,160.1),(27.5,159.9),(27.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,159.9),(28.9,160.1),(29.1,160.1),(29.1,159.9),(28.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,159.9),(30.5,160.1),(30.7,160.1),(30.7,159.9),(30.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,159.9),(32.1,160.1),(32.3,160.1),(32.3,159.9),(32.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,159.9),(33.7,160.1),(33.9,160.1),(33.9,159.9),(33.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,159.9),(35.3,160.1),(35.5,160.1),(35.5,159.9),(35.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,159.9),(36.9,160.1),(37.1,160.1),(37.1,159.9),(36.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,159.9),(38.5,160.1),(38.7,160.1),(38.7,159.9),(38.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,159.9),(40.1,160.1),(40.3,160.1),(40.3,159.9),(40.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,159.9),(41.7,160.1),(41.9,160.1),(41.9,159.9),(41.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,159.9),(43.3,160.1),(43.5,160.1),(43.5,159.9),(43.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,159.9),(44.9,160.1),(45.1,160.1),(45.1,159.9),(44.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,159.9),(46.5,160.1),(46.7,160.1),(46.7,159.9),(46.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,159.9),(48.1,160.1),(48.3,160.1),(48.3,159.9),(48.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,159.9),(49.7,160.1),(49.9,160.1),(49.9,159.9),(49.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,159.9),(51.3,160.1),(51.5,160.1),(51.5,159.9),(51.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,159.9),(52.9,160.1),(53.1,160.1),(53.1,159.9),(52.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,159.9),(54.5,160.1),(54.7,160.1),(54.7,159.9),(54.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,159.9),(56.1,160.1),(56.3,160.1),(56.3,159.9),(56.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,159.9),(57.7,160.1),(57.9,160.1),(57.9,159.9),(57.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,159.9),(59.3,160.1),(59.5,160.1),(59.5,159.9),(59.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,159.9),(60.9,160.1),(61.1,160.1),(61.1,159.9),(60.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,159.9),(62.5,160.1),(62.7,160.1),(62.7,159.9),(62.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,159.9),(64.1,160.1),(64.3,160.1),(64.3,159.9),(64.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,159.9),(65.7,160.1),(65.9,160.1),(65.9,159.9),(65.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,159.9),(67.3,160.1),(67.5,160.1),(67.5,159.9),(67.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,159.9),(68.9,160.1),(69.1,160.1),(69.1,159.9),(68.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,159.9),(70.5,160.1),(70.7,160.1),(70.7,159.9),(70.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,159.9),(72.1,160.1),(72.3,160.1),(72.3,159.9),(72.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,159.9),(73.7,160.1),(73.9,160.1),(73.9,159.9),(73.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,159.9),(75.3,160.1),(75.5,160.1),(75.5,159.9),(75.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,159.9),(76.9,160.1),(77.1,160.1),(77.1,159.9),(76.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,159.9),(78.5,160.1),(78.7,160.1),(78.7,159.9),(78.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,159.9),(80.1,160.1),(80.3,160.1),(80.3,159.9),(80.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,159.9),(81.7,160.1),(81.9,160.1),(81.9,159.9),(81.7,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,159.9),(83.3,160.1),(83.5,160.1),(83.5,159.9),(83.3,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,159.9),(84.9,160.1),(85.1,160.1),(85.1,159.9),(84.9,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,159.9),(86.5,160.1),(86.7,160.1),(86.7,159.9),(86.5,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,159.9),(88.1,160.1),(88.3,160.1),(88.3,159.9),(88.1,159.9)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,161.5),(1.7,161.7),(1.9,161.7),(1.9,161.5),(1.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,161.5),(3.3,161.7),(3.5,161.7),(3.5,161.5),(3.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,161.5),(4.9,161.7),(5.1,161.7),(5.1,161.5),(4.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,161.5),(6.5,161.7),(6.7,161.7),(6.7,161.5),(6.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,161.5),(8.1,161.7),(8.3,161.7),(8.3,161.5),(8.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,161.5),(9.7,161.7),(9.9,161.7),(9.9,161.5),(9.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,161.5),(11.3,161.7),(11.5,161.7),(11.5,161.5),(11.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,161.5),(12.9,161.7),(13.1,161.7),(13.1,161.5),(12.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,161.5),(14.5,161.7),(14.7,161.7),(14.7,161.5),(14.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,161.5),(16.1,161.7),(16.3,161.7),(16.3,161.5),(16.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,161.5),(17.7,161.7),(17.9,161.7),(17.9,161.5),(17.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,161.5),(19.3,161.7),(19.5,161.7),(19.5,161.5),(19.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,161.5),(20.9,161.7),(21.1,161.7),(21.1,161.5),(20.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,161.5),(22.5,161.7),(22.7,161.7),(22.7,161.5),(22.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,161.5),(24.1,161.7),(24.3,161.7),(24.3,161.5),(24.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,161.5),(25.7,161.7),(25.9,161.7),(25.9,161.5),(25.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,161.5),(27.3,161.7),(27.5,161.7),(27.5,161.5),(27.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,161.5),(28.9,161.7),(29.1,161.7),(29.1,161.5),(28.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,161.5),(30.5,161.7),(30.7,161.7),(30.7,161.5),(30.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,161.5),(32.1,161.7),(32.3,161.7),(32.3,161.5),(32.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,161.5),(33.7,161.7),(33.9,161.7),(33.9,161.5),(33.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,161.5),(35.3,161.7),(35.5,161.7),(35.5,161.5),(35.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,161.5),(36.9,161.7),(37.1,161.7),(37.1,161.5),(36.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,161.5),(38.5,161.7),(38.7,161.7),(38.7,161.5),(38.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,161.5),(40.1,161.7),(40.3,161.7),(40.3,161.5),(40.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,161.5),(41.7,161.7),(41.9,161.7),(41.9,161.5),(41.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,161.5),(43.3,161.7),(43.5,161.7),(43.5,161.5),(43.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,161.5),(44.9,161.7),(45.1,161.7),(45.1,161.5),(44.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,161.5),(46.5,161.7),(46.7,161.7),(46.7,161.5),(46.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,161.5),(48.1,161.7),(48.3,161.7),(48.3,161.5),(48.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,161.5),(49.7,161.7),(49.9,161.7),(49.9,161.5),(49.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,161.5),(51.3,161.7),(51.5,161.7),(51.5,161.5),(51.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,161.5),(52.9,161.7),(53.1,161.7),(53.1,161.5),(52.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,161.5),(54.5,161.7),(54.7,161.7),(54.7,161.5),(54.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,161.5),(56.1,161.7),(56.3,161.7),(56.3,161.5),(56.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,161.5),(57.7,161.7),(57.9,161.7),(57.9,161.5),(57.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,161.5),(59.3,161.7),(59.5,161.7),(59.5,161.5),(59.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,161.5),(60.9,161.7),(61.1,161.7),(61.1,161.5),(60.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,161.5),(62.5,161.7),(62.7,161.7),(62.7,161.5),(62.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,161.5),(64.1,161.7),(64.3,161.7),(64.3,161.5),(64.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,161.5),(65.7,161.7),(65.9,161.7),(65.9,161.5),(65.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,161.5),(67.3,161.7),(67.5,161.7),(67.5,161.5),(67.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,161.5),(68.9,161.7),(69.1,161.7),(69.1,161.5),(68.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,161.5),(70.5,161.7),(70.7,161.7),(70.7,161.5),(70.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,161.5),(72.1,161.7),(72.3,161.7),(72.3,161.5),(72.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,161.5),(73.7,161.7),(73.9,161.7),(73.9,161.5),(73.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,161.5),(75.3,161.7),(75.5,161.7),(75.5,161.5),(75.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,161.5),(76.9,161.7),(77.1,161.7),(77.1,161.5),(76.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,161.5),(78.5,161.7),(78.7,161.7),(78.7,161.5),(78.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,161.5),(80.1,161.7),(80.3,161.7),(80.3,161.5),(80.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,161.5),(81.7,161.7),(81.9,161.7),(81.9,161.5),(81.7,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,161.5),(83.3,161.7),(83.5,161.7),(83.5,161.5),(83.3,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,161.5),(84.9,161.7),(85.1,161.7),(85.1,161.5),(84.9,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,161.5),(86.5,161.7),(86.7,161.7),(86.7,161.5),(86.5,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,161.5),(88.1,161.7),(88.3,161.7),(88.3,161.5),(88.1,161.5)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,163.1),(1.7,163.3),(1.9,163.3),(1.9,163.1),(1.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,163.1),(3.3,163.3),(3.5,163.3),(3.5,163.1),(3.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,163.1),(4.9,163.3),(5.1,163.3),(5.1,163.1),(4.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,163.1),(6.5,163.3),(6.7,163.3),(6.7,163.1),(6.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,163.1),(8.1,163.3),(8.3,163.3),(8.3,163.1),(8.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,163.1),(9.7,163.3),(9.9,163.3),(9.9,163.1),(9.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,163.1),(11.3,163.3),(11.5,163.3),(11.5,163.1),(11.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,163.1),(12.9,163.3),(13.1,163.3),(13.1,163.1),(12.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,163.1),(14.5,163.3),(14.7,163.3),(14.7,163.1),(14.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,163.1),(16.1,163.3),(16.3,163.3),(16.3,163.1),(16.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,163.1),(17.7,163.3),(17.9,163.3),(17.9,163.1),(17.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,163.1),(19.3,163.3),(19.5,163.3),(19.5,163.1),(19.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,163.1),(20.9,163.3),(21.1,163.3),(21.1,163.1),(20.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,163.1),(22.5,163.3),(22.7,163.3),(22.7,163.1),(22.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,163.1),(24.1,163.3),(24.3,163.3),(24.3,163.1),(24.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,163.1),(25.7,163.3),(25.9,163.3),(25.9,163.1),(25.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,163.1),(27.3,163.3),(27.5,163.3),(27.5,163.1),(27.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,163.1),(28.9,163.3),(29.1,163.3),(29.1,163.1),(28.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,163.1),(30.5,163.3),(30.7,163.3),(30.7,163.1),(30.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,163.1),(32.1,163.3),(32.3,163.3),(32.3,163.1),(32.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,163.1),(33.7,163.3),(33.9,163.3),(33.9,163.1),(33.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,163.1),(35.3,163.3),(35.5,163.3),(35.5,163.1),(35.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,163.1),(36.9,163.3),(37.1,163.3),(37.1,163.1),(36.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,163.1),(38.5,163.3),(38.7,163.3),(38.7,163.1),(38.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,163.1),(40.1,163.3),(40.3,163.3),(40.3,163.1),(40.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,163.1),(41.7,163.3),(41.9,163.3),(41.9,163.1),(41.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,163.1),(43.3,163.3),(43.5,163.3),(43.5,163.1),(43.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,163.1),(44.9,163.3),(45.1,163.3),(45.1,163.1),(44.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,163.1),(46.5,163.3),(46.7,163.3),(46.7,163.1),(46.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,163.1),(48.1,163.3),(48.3,163.3),(48.3,163.1),(48.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,163.1),(49.7,163.3),(49.9,163.3),(49.9,163.1),(49.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,163.1),(51.3,163.3),(51.5,163.3),(51.5,163.1),(51.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,163.1),(52.9,163.3),(53.1,163.3),(53.1,163.1),(52.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,163.1),(54.5,163.3),(54.7,163.3),(54.7,163.1),(54.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,163.1),(56.1,163.3),(56.3,163.3),(56.3,163.1),(56.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,163.1),(57.7,163.3),(57.9,163.3),(57.9,163.1),(57.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,163.1),(59.3,163.3),(59.5,163.3),(59.5,163.1),(59.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,163.1),(60.9,163.3),(61.1,163.3),(61.1,163.1),(60.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,163.1),(62.5,163.3),(62.7,163.3),(62.7,163.1),(62.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,163.1),(64.1,163.3),(64.3,163.3),(64.3,163.1),(64.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,163.1),(65.7,163.3),(65.9,163.3),(65.9,163.1),(65.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,163.1),(67.3,163.3),(67.5,163.3),(67.5,163.1),(67.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,163.1),(68.9,163.3),(69.1,163.3),(69.1,163.1),(68.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,163.1),(70.5,163.3),(70.7,163.3),(70.7,163.1),(70.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,163.1),(72.1,163.3),(72.3,163.3),(72.3,163.1),(72.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,163.1),(73.7,163.3),(73.9,163.3),(73.9,163.1),(73.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,163.1),(75.3,163.3),(75.5,163.3),(75.5,163.1),(75.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,163.1),(76.9,163.3),(77.1,163.3),(77.1,163.1),(76.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,163.1),(78.5,163.3),(78.7,163.3),(78.7,163.1),(78.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,163.1),(80.1,163.3),(80.3,163.3),(80.3,163.1),(80.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,163.1),(81.7,163.3),(81.9,163.3),(81.9,163.1),(81.7,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,163.1),(83.3,163.3),(83.5,163.3),(83.5,163.1),(83.3,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,163.1),(84.9,163.3),(85.1,163.3),(85.1,163.1),(84.9,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,163.1),(86.5,163.3),(86.7,163.3),(86.7,163.1),(86.5,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,163.1),(88.1,163.3),(88.3,163.3),(88.3,163.1),(88.1,163.1)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,164.7),(1.7,164.9),(1.9,164.9),(1.9,164.7),(1.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,164.7),(3.3,164.9),(3.5,164.9),(3.5,164.7),(3.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,164.7),(4.9,164.9),(5.1,164.9),(5.1,164.7),(4.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,164.7),(6.5,164.9),(6.7,164.9),(6.7,164.7),(6.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,164.7),(8.1,164.9),(8.3,164.9),(8.3,164.7),(8.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,164.7),(9.7,164.9),(9.9,164.9),(9.9,164.7),(9.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,164.7),(11.3,164.9),(11.5,164.9),(11.5,164.7),(11.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,164.7),(12.9,164.9),(13.1,164.9),(13.1,164.7),(12.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,164.7),(14.5,164.9),(14.7,164.9),(14.7,164.7),(14.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,164.7),(16.1,164.9),(16.3,164.9),(16.3,164.7),(16.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,164.7),(17.7,164.9),(17.9,164.9),(17.9,164.7),(17.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,164.7),(19.3,164.9),(19.5,164.9),(19.5,164.7),(19.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,164.7),(20.9,164.9),(21.1,164.9),(21.1,164.7),(20.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,164.7),(22.5,164.9),(22.7,164.9),(22.7,164.7),(22.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,164.7),(24.1,164.9),(24.3,164.9),(24.3,164.7),(24.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,164.7),(25.7,164.9),(25.9,164.9),(25.9,164.7),(25.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,164.7),(27.3,164.9),(27.5,164.9),(27.5,164.7),(27.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,164.7),(28.9,164.9),(29.1,164.9),(29.1,164.7),(28.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,164.7),(30.5,164.9),(30.7,164.9),(30.7,164.7),(30.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,164.7),(32.1,164.9),(32.3,164.9),(32.3,164.7),(32.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,164.7),(33.7,164.9),(33.9,164.9),(33.9,164.7),(33.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,164.7),(35.3,164.9),(35.5,164.9),(35.5,164.7),(35.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,164.7),(36.9,164.9),(37.1,164.9),(37.1,164.7),(36.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,164.7),(38.5,164.9),(38.7,164.9),(38.7,164.7),(38.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,164.7),(40.1,164.9),(40.3,164.9),(40.3,164.7),(40.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,164.7),(41.7,164.9),(41.9,164.9),(41.9,164.7),(41.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,164.7),(43.3,164.9),(43.5,164.9),(43.5,164.7),(43.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,164.7),(44.9,164.9),(45.1,164.9),(45.1,164.7),(44.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,164.7),(46.5,164.9),(46.7,164.9),(46.7,164.7),(46.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,164.7),(48.1,164.9),(48.3,164.9),(48.3,164.7),(48.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,164.7),(49.7,164.9),(49.9,164.9),(49.9,164.7),(49.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,164.7),(51.3,164.9),(51.5,164.9),(51.5,164.7),(51.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,164.7),(52.9,164.9),(53.1,164.9),(53.1,164.7),(52.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,164.7),(54.5,164.9),(54.7,164.9),(54.7,164.7),(54.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,164.7),(56.1,164.9),(56.3,164.9),(56.3,164.7),(56.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,164.7),(57.7,164.9),(57.9,164.9),(57.9,164.7),(57.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,164.7),(59.3,164.9),(59.5,164.9),(59.5,164.7),(59.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,164.7),(60.9,164.9),(61.1,164.9),(61.1,164.7),(60.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,164.7),(62.5,164.9),(62.7,164.9),(62.7,164.7),(62.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,164.7),(64.1,164.9),(64.3,164.9),(64.3,164.7),(64.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,164.7),(65.7,164.9),(65.9,164.9),(65.9,164.7),(65.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,164.7),(67.3,164.9),(67.5,164.9),(67.5,164.7),(67.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,164.7),(68.9,164.9),(69.1,164.9),(69.1,164.7),(68.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,164.7),(70.5,164.9),(70.7,164.9),(70.7,164.7),(70.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,164.7),(72.1,164.9),(72.3,164.9),(72.3,164.7),(72.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,164.7),(73.7,164.9),(73.9,164.9),(73.9,164.7),(73.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,164.7),(75.3,164.9),(75.5,164.9),(75.5,164.7),(75.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,164.7),(76.9,164.9),(77.1,164.9),(77.1,164.7),(76.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,164.7),(78.5,164.9),(78.7,164.9),(78.7,164.7),(78.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,164.7),(80.1,164.9),(80.3,164.9),(80.3,164.7),(80.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,164.7),(81.7,164.9),(81.9,164.9),(81.9,164.7),(81.7,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,164.7),(83.3,164.9),(83.5,164.9),(83.5,164.7),(83.3,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,164.7),(84.9,164.9),(85.1,164.9),(85.1,164.7),(84.9,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,164.7),(86.5,164.9),(86.7,164.9),(86.7,164.7),(86.5,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,164.7),(88.1,164.9),(88.3,164.9),(88.3,164.7),(88.1,164.7)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,166.3),(1.7,166.5),(1.9,166.5),(1.9,166.3),(1.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,166.3),(3.3,166.5),(3.5,166.5),(3.5,166.3),(3.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,166.3),(4.9,166.5),(5.1,166.5),(5.1,166.3),(4.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,166.3),(6.5,166.5),(6.7,166.5),(6.7,166.3),(6.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,166.3),(8.1,166.5),(8.3,166.5),(8.3,166.3),(8.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,166.3),(9.7,166.5),(9.9,166.5),(9.9,166.3),(9.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,166.3),(11.3,166.5),(11.5,166.5),(11.5,166.3),(11.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,166.3),(12.9,166.5),(13.1,166.5),(13.1,166.3),(12.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,166.3),(14.5,166.5),(14.7,166.5),(14.7,166.3),(14.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,166.3),(16.1,166.5),(16.3,166.5),(16.3,166.3),(16.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,166.3),(17.7,166.5),(17.9,166.5),(17.9,166.3),(17.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,166.3),(19.3,166.5),(19.5,166.5),(19.5,166.3),(19.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,166.3),(20.9,166.5),(21.1,166.5),(21.1,166.3),(20.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,166.3),(22.5,166.5),(22.7,166.5),(22.7,166.3),(22.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,166.3),(24.1,166.5),(24.3,166.5),(24.3,166.3),(24.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,166.3),(25.7,166.5),(25.9,166.5),(25.9,166.3),(25.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,166.3),(27.3,166.5),(27.5,166.5),(27.5,166.3),(27.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,166.3),(28.9,166.5),(29.1,166.5),(29.1,166.3),(28.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,166.3),(30.5,166.5),(30.7,166.5),(30.7,166.3),(30.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,166.3),(32.1,166.5),(32.3,166.5),(32.3,166.3),(32.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,166.3),(33.7,166.5),(33.9,166.5),(33.9,166.3),(33.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,166.3),(35.3,166.5),(35.5,166.5),(35.5,166.3),(35.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,166.3),(36.9,166.5),(37.1,166.5),(37.1,166.3),(36.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,166.3),(38.5,166.5),(38.7,166.5),(38.7,166.3),(38.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,166.3),(40.1,166.5),(40.3,166.5),(40.3,166.3),(40.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,166.3),(41.7,166.5),(41.9,166.5),(41.9,166.3),(41.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,166.3),(43.3,166.5),(43.5,166.5),(43.5,166.3),(43.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,166.3),(44.9,166.5),(45.1,166.5),(45.1,166.3),(44.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,166.3),(46.5,166.5),(46.7,166.5),(46.7,166.3),(46.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,166.3),(48.1,166.5),(48.3,166.5),(48.3,166.3),(48.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,166.3),(49.7,166.5),(49.9,166.5),(49.9,166.3),(49.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,166.3),(51.3,166.5),(51.5,166.5),(51.5,166.3),(51.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,166.3),(52.9,166.5),(53.1,166.5),(53.1,166.3),(52.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,166.3),(54.5,166.5),(54.7,166.5),(54.7,166.3),(54.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,166.3),(56.1,166.5),(56.3,166.5),(56.3,166.3),(56.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,166.3),(57.7,166.5),(57.9,166.5),(57.9,166.3),(57.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,166.3),(59.3,166.5),(59.5,166.5),(59.5,166.3),(59.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,166.3),(60.9,166.5),(61.1,166.5),(61.1,166.3),(60.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,166.3),(62.5,166.5),(62.7,166.5),(62.7,166.3),(62.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,166.3),(64.1,166.5),(64.3,166.5),(64.3,166.3),(64.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,166.3),(65.7,166.5),(65.9,166.5),(65.9,166.3),(65.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,166.3),(67.3,166.5),(67.5,166.5),(67.5,166.3),(67.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,166.3),(68.9,166.5),(69.1,166.5),(69.1,166.3),(68.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,166.3),(70.5,166.5),(70.7,166.5),(70.7,166.3),(70.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,166.3),(72.1,166.5),(72.3,166.5),(72.3,166.3),(72.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,166.3),(73.7,166.5),(73.9,166.5),(73.9,166.3),(73.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,166.3),(75.3,166.5),(75.5,166.5),(75.5,166.3),(75.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,166.3),(76.9,166.5),(77.1,166.5),(77.1,166.3),(76.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,166.3),(78.5,166.5),(78.7,166.5),(78.7,166.3),(78.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,166.3),(80.1,166.5),(80.3,166.5),(80.3,166.3),(80.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,166.3),(81.7,166.5),(81.9,166.5),(81.9,166.3),(81.7,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,166.3),(83.3,166.5),(83.5,166.5),(83.5,166.3),(83.3,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,166.3),(84.9,166.5),(85.1,166.5),(85.1,166.3),(84.9,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,166.3),(86.5,166.5),(86.7,166.5),(86.7,166.3),(86.5,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,166.3),(88.1,166.5),(88.3,166.5),(88.3,166.3),(88.1,166.3)),
        )
        createRL(
            tech, net, 'via3',
            ((1.7,167.9),(1.7,168.1),(1.9,168.1),(1.9,167.9),(1.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((3.3,167.9),(3.3,168.1),(3.5,168.1),(3.5,167.9),(3.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((4.9,167.9),(4.9,168.1),(5.1,168.1),(5.1,167.9),(4.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((6.5,167.9),(6.5,168.1),(6.7,168.1),(6.7,167.9),(6.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((8.1,167.9),(8.1,168.1),(8.3,168.1),(8.3,167.9),(8.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((9.7,167.9),(9.7,168.1),(9.9,168.1),(9.9,167.9),(9.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((11.3,167.9),(11.3,168.1),(11.5,168.1),(11.5,167.9),(11.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((12.9,167.9),(12.9,168.1),(13.1,168.1),(13.1,167.9),(12.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((14.5,167.9),(14.5,168.1),(14.7,168.1),(14.7,167.9),(14.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((16.1,167.9),(16.1,168.1),(16.3,168.1),(16.3,167.9),(16.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((17.7,167.9),(17.7,168.1),(17.9,168.1),(17.9,167.9),(17.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((19.3,167.9),(19.3,168.1),(19.5,168.1),(19.5,167.9),(19.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((20.9,167.9),(20.9,168.1),(21.1,168.1),(21.1,167.9),(20.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((22.5,167.9),(22.5,168.1),(22.7,168.1),(22.7,167.9),(22.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((24.1,167.9),(24.1,168.1),(24.3,168.1),(24.3,167.9),(24.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((25.7,167.9),(25.7,168.1),(25.9,168.1),(25.9,167.9),(25.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((27.3,167.9),(27.3,168.1),(27.5,168.1),(27.5,167.9),(27.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((28.9,167.9),(28.9,168.1),(29.1,168.1),(29.1,167.9),(28.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((30.5,167.9),(30.5,168.1),(30.7,168.1),(30.7,167.9),(30.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((32.1,167.9),(32.1,168.1),(32.3,168.1),(32.3,167.9),(32.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((33.7,167.9),(33.7,168.1),(33.9,168.1),(33.9,167.9),(33.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((35.3,167.9),(35.3,168.1),(35.5,168.1),(35.5,167.9),(35.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((36.9,167.9),(36.9,168.1),(37.1,168.1),(37.1,167.9),(36.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((38.5,167.9),(38.5,168.1),(38.7,168.1),(38.7,167.9),(38.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((40.1,167.9),(40.1,168.1),(40.3,168.1),(40.3,167.9),(40.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((41.7,167.9),(41.7,168.1),(41.9,168.1),(41.9,167.9),(41.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((43.3,167.9),(43.3,168.1),(43.5,168.1),(43.5,167.9),(43.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((44.9,167.9),(44.9,168.1),(45.1,168.1),(45.1,167.9),(44.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((46.5,167.9),(46.5,168.1),(46.7,168.1),(46.7,167.9),(46.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((48.1,167.9),(48.1,168.1),(48.3,168.1),(48.3,167.9),(48.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((49.7,167.9),(49.7,168.1),(49.9,168.1),(49.9,167.9),(49.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((51.3,167.9),(51.3,168.1),(51.5,168.1),(51.5,167.9),(51.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((52.9,167.9),(52.9,168.1),(53.1,168.1),(53.1,167.9),(52.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((54.5,167.9),(54.5,168.1),(54.7,168.1),(54.7,167.9),(54.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((56.1,167.9),(56.1,168.1),(56.3,168.1),(56.3,167.9),(56.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((57.7,167.9),(57.7,168.1),(57.9,168.1),(57.9,167.9),(57.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((59.3,167.9),(59.3,168.1),(59.5,168.1),(59.5,167.9),(59.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((60.9,167.9),(60.9,168.1),(61.1,168.1),(61.1,167.9),(60.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((62.5,167.9),(62.5,168.1),(62.7,168.1),(62.7,167.9),(62.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((64.1,167.9),(64.1,168.1),(64.3,168.1),(64.3,167.9),(64.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((65.7,167.9),(65.7,168.1),(65.9,168.1),(65.9,167.9),(65.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((67.3,167.9),(67.3,168.1),(67.5,168.1),(67.5,167.9),(67.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((68.9,167.9),(68.9,168.1),(69.1,168.1),(69.1,167.9),(68.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((70.5,167.9),(70.5,168.1),(70.7,168.1),(70.7,167.9),(70.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((72.1,167.9),(72.1,168.1),(72.3,168.1),(72.3,167.9),(72.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((73.7,167.9),(73.7,168.1),(73.9,168.1),(73.9,167.9),(73.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((75.3,167.9),(75.3,168.1),(75.5,168.1),(75.5,167.9),(75.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((76.9,167.9),(76.9,168.1),(77.1,168.1),(77.1,167.9),(76.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((78.5,167.9),(78.5,168.1),(78.7,168.1),(78.7,167.9),(78.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((80.1,167.9),(80.1,168.1),(80.3,168.1),(80.3,167.9),(80.1,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((81.7,167.9),(81.7,168.1),(81.9,168.1),(81.9,167.9),(81.7,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((83.3,167.9),(83.3,168.1),(83.5,168.1),(83.5,167.9),(83.3,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((84.9,167.9),(84.9,168.1),(85.1,168.1),(85.1,167.9),(84.9,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((86.5,167.9),(86.5,168.1),(86.7,168.1),(86.7,167.9),(86.5,167.9)),
        )
        createRL(
            tech, net, 'via3',
            ((88.1,167.9),(88.1,168.1),(88.3,168.1),(88.3,167.9),(88.1,167.9)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'm5',
            ((5.5,25.32),(5.5,85.32),(84.5,85.32),(84.5,25.32),(5.5,25.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m5.pin'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m5'),
            u(55.32), u(60.0), u(5.5), u(84.5),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,133.04),(48.055,133.04),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,24.32),(38.455,24.32),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,24.32),(57.655,24.32),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,92.175),(37.145,188.0),(38.455,188.0),(38.455,92.175),(37.145,92.175)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,133.04),(43.255,133.04),(43.255,86.32),(41.945,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,130.265),(33.655,130.265),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,92.175),(46.745,188.0),(48.055,188.0),(48.055,92.175),(46.745,92.175)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,130.265),(57.655,130.265),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,130.265),(38.455,130.265),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,187.3),(32.345,188.0),(52.855,188.0),(52.855,187.3),(32.345,187.3)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,86.32),(46.745,130.265),(48.055,130.265),(48.055,86.32),(46.745,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,24.32),(33.655,24.32),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,24.32),(52.855,24.32),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,86.32),(32.345,133.04),(33.655,133.04),(33.655,86.32),(32.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((56.575,133.04),(56.575,160.105),(57.425,160.105),(57.425,133.04),(56.575,133.04)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,24.32),(48.055,24.32),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,86.32),(56.345,133.04),(57.655,133.04),(57.655,86.32),(56.345,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,92.175),(41.945,188.0),(43.255,188.0),(43.255,92.175),(41.945,92.175)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,92.175),(32.345,188.0),(33.655,188.0),(33.655,92.175),(32.345,92.175)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,133.04),(52.855,133.04),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,92.175),(51.545,188.0),(52.855,188.0),(52.855,92.175),(51.545,92.175)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,86.32),(37.145,133.04),(38.455,133.04),(38.455,86.32),(37.145,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,86.32),(51.545,130.265),(52.855,130.265),(52.855,86.32),(51.545,86.32)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,24.32),(43.255,24.32),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,86.32),(41.945,130.265),(43.255,130.265),(43.255,86.32),(41.945,86.32)),
        )
        Horizontal.create(
            net, tech.getLayer('m1.pin'),
            u(187.65), u(0.7), u(32.345), u(52.855000000000004),
        )
        pin = Horizontal.create(
            net, tech.getLayer('m1'),
            u(187.65), u(0.7), u(32.345), u(52.855000000000004),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.215),(-0.125,22.945),(90.125,22.945),(90.125,22.215),(-0.125,22.215)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,22.695),(-0.125,87.945),(0.605,87.945),(0.605,22.695),(-0.125,22.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((-0.125,87.695),(-0.125,88.425),(90.125,88.425),(90.125,87.695),(-0.125,87.695)),
        )
        createRL(
            tech, net, 'nsdm',
            ((89.395,22.695),(89.395,87.945),(90.125,87.945),(90.125,22.695),(89.395,22.695)),
        )
        net = nets['padres']
        createRL(
            tech, net, 'm1',
            ((60.52,165.125),(60.52,188.0),(60.89,188.0),(60.89,165.125),(60.52,165.125)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(60.705), u(0.37), u(165.125), u(188.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(60.705), u(0.37), u(165.125), u(188.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        nets['padres'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['Pad_15800W12000H']
        except:
            subcell = af.getCell('Pad_15800W12000H', 0)
        trans = Transformation(
            u(45.0), u(55.32), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pad', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_N12N0D']
        except:
            subcell = af.getCell('Clamp_N12N0D', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['Clamp_P12N0D']
        except:
            subcell = af.getCell('Clamp_P12N0D', 0)
        trans = Transformation(
            u(0.0), u(89.4), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'pclamp', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['BulkConn_18000WUp']
        except:
            subcell = af.getCell('BulkConn_18000WUp', 0)
        trans = Transformation(
            u(0.0), u(163.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'bulkconn', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['SecondaryProtection']
        except:
            subcell = af.getCell('SecondaryProtection', 0)
        trans = Transformation(
            u(55.42), u(158.695), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'secondprot', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Clamp_N12N0D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(22.34),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovss': Net.create(cell, 'iovss'),
            'off': Net.create(cell, 'off'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovss']
        createRL(
            tech, net, 'difftap',
            ((59.05,2.72),(59.05,19.62),(59.75,19.62),(59.75,2.72),(59.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.385,2.72),(55.385,19.62),(55.635,19.62),(55.635,2.72),(55.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.635,2.72),(55.635,19.62),(56.235,19.62),(56.235,2.72),(55.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.965,2.72),(43.965,19.62),(44.215,19.62),(44.215,2.72),(43.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.635,2.72),(31.635,19.62),(32.235,19.62),(32.235,2.72),(31.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(45.785,19.62),(45.785,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,19.62),(39.165,19.62),(39.165,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.65,2.72),(44.65,19.62),(45.35,19.62),(45.35,2.72),(44.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.215,2.72),(44.215,19.62),(45.67,19.62),(45.67,2.72),(44.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.035,2.72),(46.035,19.62),(46.635,19.62),(46.635,2.72),(46.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,19.62),(53.565,19.62),(53.565,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.15,2.72),(50.15,19.62),(50.47,19.62),(50.47,2.72),(50.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.95,2.72),(54.95,19.62),(55.27,19.62),(55.27,2.72),(54.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.75,2.72),(35.75,19.62),(36.07,19.62),(36.07,2.72),(35.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.365,2.72),(34.365,19.62),(34.615,19.62),(34.615,2.72),(34.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.85,2.72),(39.85,19.62),(40.55,19.62),(40.55,2.72),(39.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,2.72),(39.415,19.62),(40.87,19.62),(40.87,2.72),(39.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(40.985,19.62),(40.985,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,19.62),(39.85,19.62),(39.85,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.985,2.72),(40.985,19.62),(41.235,19.62),(41.235,2.72),(40.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,19.62),(31.385,19.62),(31.385,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.95,2.72),(30.95,19.62),(31.27,19.62),(31.27,2.72),(30.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(35.05,19.62),(35.05,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(54.25,19.62),(54.25,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.615,2.72),(34.615,19.62),(36.07,19.62),(36.07,2.72),(34.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,19.62),(36.185,19.62),(36.185,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.55,2.72),(40.55,19.62),(40.87,19.62),(40.87,2.72),(40.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.385,2.72),(31.385,19.62),(31.635,19.62),(31.635,2.72),(31.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.165,2.72),(39.165,19.62),(39.415,19.62),(39.415,2.72),(39.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,19.62),(44.65,19.62),(44.65,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,19.62),(34.365,19.62),(34.365,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,2.72),(54.25,19.62),(54.95,19.62),(54.95,2.72),(54.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.05,2.72),(35.05,19.62),(35.75,19.62),(35.75,2.72),(35.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,19.62),(48.765,19.62),(48.765,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(49.45,19.62),(49.45,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.435,2.72),(36.435,19.62),(37.035,19.62),(37.035,2.72),(36.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,19.62),(30.95,19.62),(30.95,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.45,2.72),(49.45,19.62),(50.15,19.62),(50.15,2.72),(49.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.015,2.72),(49.015,19.62),(50.47,19.62),(50.47,2.72),(49.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,19.62),(50.585,19.62),(50.585,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.765,2.72),(48.765,19.62),(49.015,19.62),(49.015,2.72),(48.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.785,2.72),(45.785,19.62),(46.035,19.62),(46.035,2.72),(45.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.365,2.72),(58.365,19.62),(58.615,19.62),(58.615,2.72),(58.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.185,2.72),(36.185,19.62),(36.435,19.62),(36.435,2.72),(36.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,19.62),(55.385,19.62),(55.385,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.815,2.72),(53.815,19.62),(55.27,19.62),(55.27,2.72),(53.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.35,2.72),(45.35,19.62),(45.67,19.62),(45.67,2.72),(45.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.835,2.72),(50.835,19.62),(51.435,19.62),(51.435,2.72),(50.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,19.62),(43.965,19.62),(43.965,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,19.62),(59.05,19.62),(59.05,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.615,2.72),(58.615,19.62),(59.75,19.62),(59.75,2.72),(58.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.565,2.72),(53.565,19.62),(53.815,19.62),(53.815,2.72),(53.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.585,2.72),(50.585,19.62),(50.835,19.62),(50.835,2.72),(50.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.235,2.72),(41.235,19.62),(41.835,19.62),(41.835,2.72),(41.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,19.62),(58.365,19.62),(58.365,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.485),(35.315,14.655),(35.485,14.655),(35.485,14.485),(35.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.145),(35.825,14.315),(35.995,14.315),(35.995,14.145),(35.825,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.825),(35.825,14.995),(35.995,14.995),(35.995,14.825),(35.825,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.485),(35.825,14.655),(35.995,14.655),(35.995,14.485),(35.825,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.825),(35.315,14.995),(35.485,14.995),(35.485,14.825),(35.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.505),(44.405,15.675),(44.575,15.675),(44.575,15.505),(44.405,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.165),(44.405,15.335),(44.575,15.335),(44.575,15.165),(44.405,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.965),(58.805,5.135),(58.975,5.135),(58.975,4.965),(58.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.065),(50.225,10.235),(50.395,10.235),(50.395,10.065),(50.225,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.405),(50.225,10.575),(50.395,10.575),(50.395,10.405),(50.225,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.745),(50.225,10.915),(50.395,10.915),(50.395,10.745),(50.225,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.645),(30.515,5.815),(30.685,5.815),(30.685,5.645),(30.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.305),(30.515,5.475),(30.685,5.475),(30.685,5.305),(30.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.685),(35.825,7.855),(35.995,7.855),(35.995,7.685),(35.825,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.965),(34.805,5.135),(34.975,5.135),(34.975,4.965),(34.805,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.345),(35.315,7.515),(35.485,7.515),(35.485,7.345),(35.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.685),(35.315,7.855),(35.485,7.855),(35.485,7.685),(35.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.345),(35.825,7.515),(35.995,7.515),(35.995,7.345),(35.825,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.965),(40.115,5.135),(40.285,5.135),(40.285,4.965),(40.115,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.965),(40.625,5.135),(40.795,5.135),(40.795,4.965),(40.625,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.005),(35.315,7.175),(35.485,7.175),(35.485,7.005),(35.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.005),(35.825,7.175),(35.995,7.175),(35.995,7.005),(35.825,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.445),(30.515,12.615),(30.685,12.615),(30.685,12.445),(30.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.105),(30.515,12.275),(30.685,12.275),(30.685,12.105),(30.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.785),(30.515,12.955),(30.685,12.955),(30.685,12.785),(30.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.965),(54.005,5.135),(54.175,5.135),(54.175,4.965),(54.005,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.965),(54.515,5.135),(54.685,5.135),(54.685,4.965),(54.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.745),(59.315,10.915),(59.485,10.915),(59.485,10.745),(59.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.065),(59.315,10.235),(59.485,10.235),(59.485,10.065),(59.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.405),(59.315,10.575),(59.485,10.575),(59.485,10.405),(59.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.245),(35.315,19.415),(35.485,19.415),(35.485,19.245),(35.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.925),(30.515,3.095),(30.685,3.095),(30.685,2.925),(30.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.245),(35.825,19.415),(35.995,19.415),(35.995,19.245),(35.825,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.245),(31.025,19.415),(31.195,19.415),(31.195,19.245),(31.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.145),(30.515,14.315),(30.685,14.315),(30.685,14.145),(30.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.905),(39.605,19.075),(39.775,19.075),(39.775,18.905),(39.605,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.525),(49.715,16.695),(49.885,16.695),(49.885,16.525),(49.715,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.485),(30.515,14.655),(30.685,14.655),(30.685,14.485),(30.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.805),(34.805,13.975),(34.975,13.975),(34.975,13.805),(34.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.825),(30.515,14.995),(30.685,14.995),(30.685,14.825),(30.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.465),(34.805,13.635),(34.975,13.635),(34.975,13.465),(34.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.525),(49.205,16.695),(49.375,16.695),(49.375,16.525),(49.205,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.185),(49.715,16.355),(49.885,16.355),(49.885,16.185),(49.715,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.185),(49.205,16.355),(49.375,16.355),(49.375,16.185),(49.205,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.125),(34.805,13.295),(34.975,13.295),(34.975,13.125),(34.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.225),(44.405,18.395),(44.575,18.395),(44.575,18.225),(44.405,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.565),(44.405,18.735),(44.575,18.735),(44.575,18.565),(44.405,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.245),(55.025,19.415),(55.195,19.415),(55.195,19.245),(55.025,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.225),(54.005,18.395),(54.175,18.395),(54.175,18.225),(54.005,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.565),(54.005,18.735),(54.175,18.735),(54.175,18.565),(54.005,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.225),(54.515,18.395),(54.685,18.395),(54.685,18.225),(54.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.565),(54.515,18.735),(54.685,18.735),(54.685,18.565),(54.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.345),(59.315,7.515),(59.485,7.515),(59.485,7.345),(59.315,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.685),(59.315,7.855),(59.485,7.855),(59.485,7.685),(59.315,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.005),(59.315,7.175),(59.485,7.175),(59.485,7.005),(59.315,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.725),(58.805,9.895),(58.975,9.895),(58.975,9.725),(58.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.385),(58.805,9.555),(58.975,9.555),(58.975,9.385),(58.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.245),(39.605,19.415),(39.775,19.415),(39.775,19.245),(39.605,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.085),(31.025,11.255),(31.195,11.255),(31.195,11.085),(31.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.425),(31.025,11.595),(31.195,11.595),(31.195,11.425),(31.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.765),(31.025,11.935),(31.195,11.935),(31.195,11.765),(31.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.045),(58.805,9.215),(58.975,9.215),(58.975,9.045),(58.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.185),(30.515,16.355),(30.685,16.355),(30.685,16.185),(30.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.525),(30.515,16.695),(30.685,16.695),(30.685,16.525),(30.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.185),(59.315,16.355),(59.485,16.355),(59.485,16.185),(59.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.525),(59.315,16.695),(59.485,16.695),(59.485,16.525),(59.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.925),(39.605,3.095),(39.775,3.095),(39.775,2.925),(39.605,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.085),(58.805,11.255),(58.975,11.255),(58.975,11.085),(58.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.025),(44.405,8.195),(44.575,8.195),(44.575,8.025),(44.405,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.425),(58.805,11.595),(58.975,11.595),(58.975,11.425),(58.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.905),(58.805,19.075),(58.975,19.075),(58.975,18.905),(58.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.765),(58.805,11.935),(58.975,11.935),(58.975,11.765),(58.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.365),(44.405,8.535),(44.575,8.535),(44.575,8.365),(44.405,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.705),(44.405,8.875),(44.575,8.875),(44.575,8.705),(44.405,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.905),(49.715,19.075),(49.885,19.075),(49.885,18.905),(49.715,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.905),(49.205,19.075),(49.375,19.075),(49.375,18.905),(49.205,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.445),(58.805,12.615),(58.975,12.615),(58.975,12.445),(58.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.785),(58.805,12.955),(58.975,12.955),(58.975,12.785),(58.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.105),(58.805,12.275),(58.975,12.275),(58.975,12.105),(58.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.205),(31.025,17.375),(31.195,17.375),(31.195,17.205),(31.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.885),(59.315,18.055),(59.485,18.055),(59.485,17.885),(59.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.545),(31.025,17.715),(31.195,17.715),(31.195,17.545),(31.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.445),(40.625,12.615),(40.795,12.615),(40.795,12.445),(40.625,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.785),(40.625,12.955),(40.795,12.955),(40.795,12.785),(40.625,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.445),(40.115,12.615),(40.285,12.615),(40.285,12.445),(40.115,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.785),(40.115,12.955),(40.285,12.955),(40.285,12.785),(40.115,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.605),(39.605,3.775),(39.775,3.775),(39.775,3.605),(39.605,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.865),(45.425,17.035),(45.595,17.035),(45.595,16.865),(45.425,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.265),(39.605,3.435),(39.775,3.435),(39.775,3.265),(39.605,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.145),(58.805,14.315),(58.975,14.315),(58.975,14.145),(58.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.825),(58.805,14.995),(58.975,14.995),(58.975,14.825),(58.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.845),(30.515,16.015),(30.685,16.015),(30.685,15.845),(30.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.485),(58.805,14.655),(58.975,14.655),(58.975,14.485),(58.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.245),(49.205,19.415),(49.375,19.415),(49.375,19.245),(49.205,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.245),(49.715,19.415),(49.885,19.415),(49.885,19.245),(49.715,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.125),(49.715,13.295),(49.885,13.295),(49.885,13.125),(49.715,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.125),(49.205,13.295),(49.375,13.295),(49.375,13.125),(49.205,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.225),(50.225,18.395),(50.395,18.395),(50.395,18.225),(50.225,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.565),(50.225,18.735),(50.395,18.735),(50.395,18.565),(50.225,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.465),(49.715,13.635),(49.885,13.635),(49.885,13.465),(49.715,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.945),(50.225,4.115),(50.395,4.115),(50.395,3.945),(50.225,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.805),(49.715,13.975),(49.885,13.975),(49.885,13.805),(49.715,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.465),(49.205,13.635),(49.375,13.635),(49.375,13.465),(49.205,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.925),(54.005,3.095),(54.175,3.095),(54.175,2.925),(54.005,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.925),(54.515,3.095),(54.685,3.095),(54.685,2.925),(54.515,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.505),(54.005,15.675),(54.175,15.675),(54.175,15.505),(54.005,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.505),(54.515,15.675),(54.685,15.675),(54.685,15.505),(54.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.165),(54.005,15.335),(54.175,15.335),(54.175,15.165),(54.005,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.165),(54.515,15.335),(54.685,15.335),(54.685,15.165),(54.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.985),(40.625,6.155),(40.795,6.155),(40.795,5.985),(40.625,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.985),(40.115,6.155),(40.285,6.155),(40.285,5.985),(40.115,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.705),(35.825,8.875),(35.995,8.875),(35.995,8.705),(35.825,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.145),(49.205,14.315),(49.375,14.315),(49.375,14.145),(49.205,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.485),(49.715,14.655),(49.885,14.655),(49.885,14.485),(49.715,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.825),(49.715,14.995),(49.885,14.995),(49.885,14.825),(49.715,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.825),(49.205,14.995),(49.375,14.995),(49.375,14.825),(49.205,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.485),(49.205,14.655),(49.375,14.655),(49.375,14.485),(49.205,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.365),(35.315,8.535),(35.485,8.535),(35.485,8.365),(35.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.705),(35.315,8.875),(35.485,8.875),(35.485,8.705),(35.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.365),(35.825,8.535),(35.995,8.535),(35.995,8.365),(35.825,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.985),(49.205,6.155),(49.375,6.155),(49.375,5.985),(49.205,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.985),(49.715,6.155),(49.885,6.155),(49.885,5.985),(49.715,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.545),(50.225,17.715),(50.395,17.715),(50.395,17.545),(50.225,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.205),(50.225,17.375),(50.395,17.375),(50.395,17.205),(50.225,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.105),(40.115,12.275),(40.285,12.275),(40.285,12.105),(40.115,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.885),(30.515,18.055),(30.685,18.055),(30.685,17.885),(30.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.425),(45.425,11.595),(45.595,11.595),(45.595,11.425),(45.425,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.765),(45.425,11.935),(45.595,11.935),(45.595,11.765),(45.425,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.265),(40.115,3.435),(40.285,3.435),(40.285,3.265),(40.115,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.265),(40.625,3.435),(40.795,3.435),(40.795,3.265),(40.625,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.605),(40.115,3.775),(40.285,3.775),(40.285,3.605),(40.115,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.605),(40.625,3.775),(40.795,3.775),(40.795,3.605),(40.625,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.045),(54.005,9.215),(54.175,9.215),(54.175,9.045),(54.005,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.045),(54.515,9.215),(54.685,9.215),(54.685,9.045),(54.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.725),(54.005,9.895),(54.175,9.895),(54.175,9.725),(54.005,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.385),(54.515,9.555),(54.685,9.555),(54.685,9.385),(54.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.385),(54.005,9.555),(54.175,9.555),(54.175,9.385),(54.005,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.725),(54.515,9.895),(54.685,9.895),(54.685,9.725),(54.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.985),(50.225,6.155),(50.395,6.155),(50.395,5.985),(50.225,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.445),(45.425,12.615),(45.595,12.615),(45.595,12.445),(45.425,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.785),(45.425,12.955),(45.595,12.955),(45.595,12.785),(45.425,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.965),(39.605,5.135),(39.775,5.135),(39.775,4.965),(39.605,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.105),(45.425,12.275),(45.595,12.275),(45.595,12.105),(45.425,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.285),(55.025,4.455),(55.195,4.455),(55.195,4.285),(55.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.625),(55.025,4.795),(55.195,4.795),(55.195,4.625),(55.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.425),(54.005,11.595),(54.175,11.595),(54.175,11.425),(54.005,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.425),(54.515,11.595),(54.685,11.595),(54.685,11.425),(54.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.085),(54.005,11.255),(54.175,11.255),(54.175,11.085),(54.005,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.085),(54.515,11.255),(54.685,11.255),(54.685,11.085),(54.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.765),(54.515,11.935),(54.685,11.935),(54.685,11.765),(54.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.765),(54.005,11.935),(54.175,11.935),(54.175,11.765),(54.005,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.165),(58.805,15.335),(58.975,15.335),(58.975,15.165),(58.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.505),(58.805,15.675),(58.975,15.675),(58.975,15.505),(58.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.565),(45.425,18.735),(45.595,18.735),(45.595,18.565),(45.425,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.225),(45.425,18.395),(45.595,18.395),(45.595,18.225),(45.425,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.385),(44.405,9.555),(44.575,9.555),(44.575,9.385),(44.405,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.725),(44.405,9.895),(44.575,9.895),(44.575,9.725),(44.405,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.045),(44.405,9.215),(44.575,9.215),(44.575,9.045),(44.405,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.245),(44.915,19.415),(45.085,19.415),(45.085,19.245),(44.915,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.005),(49.205,7.175),(49.375,7.175),(49.375,7.005),(49.205,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.005),(49.715,7.175),(49.885,7.175),(49.885,7.005),(49.715,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.345),(49.715,7.515),(49.885,7.515),(49.885,7.345),(49.715,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.685),(49.715,7.855),(49.885,7.855),(49.885,7.685),(49.715,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.345),(49.205,7.515),(49.375,7.515),(49.375,7.345),(49.205,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.685),(49.205,7.855),(49.375,7.855),(49.375,7.685),(49.205,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.085),(44.915,11.255),(45.085,11.255),(45.085,11.085),(44.915,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.505),(45.425,15.675),(45.595,15.675),(45.595,15.505),(45.425,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.165),(45.425,15.335),(45.595,15.335),(45.595,15.165),(45.425,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.385),(49.715,9.555),(49.885,9.555),(49.885,9.385),(49.715,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.385),(49.205,9.555),(49.375,9.555),(49.375,9.385),(49.205,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.045),(49.205,9.215),(49.375,9.215),(49.375,9.045),(49.205,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.045),(49.715,9.215),(49.885,9.215),(49.885,9.045),(49.715,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.285),(35.825,4.455),(35.995,4.455),(35.995,4.285),(35.825,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.625),(35.825,4.795),(35.995,4.795),(35.995,4.625),(35.825,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.625),(35.315,4.795),(35.485,4.795),(35.485,4.625),(35.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.725),(49.205,9.895),(49.375,9.895),(49.375,9.725),(49.205,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.285),(35.315,4.455),(35.485,4.455),(35.485,4.285),(35.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.845),(44.405,16.015),(44.575,16.015),(44.575,15.845),(44.405,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.465),(59.315,13.635),(59.485,13.635),(59.485,13.465),(59.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.805),(59.315,13.975),(59.485,13.975),(59.485,13.805),(59.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.125),(59.315,13.295),(59.485,13.295),(59.485,13.125),(59.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.045),(44.915,9.215),(45.085,9.215),(45.085,9.045),(44.915,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.385),(44.915,9.555),(45.085,9.555),(45.085,9.385),(44.915,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.725),(44.915,9.895),(45.085,9.895),(45.085,9.725),(44.915,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.225),(34.805,18.395),(34.975,18.395),(34.975,18.225),(34.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.565),(34.805,18.735),(34.975,18.735),(34.975,18.565),(34.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.125),(44.405,13.295),(44.575,13.295),(44.575,13.125),(44.405,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.465),(44.405,13.635),(44.575,13.635),(44.575,13.465),(44.405,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.565),(35.825,18.735),(35.995,18.735),(35.995,18.565),(35.825,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.805),(44.405,13.975),(44.575,13.975),(44.575,13.805),(44.405,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.225),(35.315,18.395),(35.485,18.395),(35.485,18.225),(35.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.565),(35.315,18.735),(35.485,18.735),(35.485,18.565),(35.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.225),(35.825,18.395),(35.995,18.395),(35.995,18.225),(35.825,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.865),(49.715,17.035),(49.885,17.035),(49.885,16.865),(49.715,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.865),(49.205,17.035),(49.375,17.035),(49.375,16.865),(49.205,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.885),(55.025,18.055),(55.195,18.055),(55.195,17.885),(55.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.905),(44.405,19.075),(44.575,19.075),(44.575,18.905),(44.405,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.905),(54.515,19.075),(54.685,19.075),(54.685,18.905),(54.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.185),(58.805,16.355),(58.975,16.355),(58.975,16.185),(58.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.525),(58.805,16.695),(58.975,16.695),(58.975,16.525),(58.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.285),(59.315,4.455),(59.485,4.455),(59.485,4.285),(59.315,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.625),(59.315,4.795),(59.485,4.795),(59.485,4.625),(59.315,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.905),(54.005,19.075),(54.175,19.075),(54.175,18.905),(54.005,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.025),(50.225,8.195),(50.395,8.195),(50.395,8.025),(50.225,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.205),(34.805,17.375),(34.975,17.375),(34.975,17.205),(34.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.545),(34.805,17.715),(34.975,17.715),(34.975,17.545),(34.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.885),(39.605,18.055),(39.775,18.055),(39.775,17.885),(39.605,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.825),(44.915,14.995),(45.085,14.995),(45.085,14.825),(44.915,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.485),(44.915,14.655),(45.085,14.655),(45.085,14.485),(44.915,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.305),(58.805,5.475),(58.975,5.475),(58.975,5.305),(58.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.645),(58.805,5.815),(58.975,5.815),(58.975,5.645),(58.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.005),(31.025,7.175),(31.195,7.175),(31.195,7.005),(31.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.685),(31.025,7.855),(31.195,7.855),(31.195,7.685),(31.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.345),(31.025,7.515),(31.195,7.515),(31.195,7.345),(31.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.865),(30.515,17.035),(30.685,17.035),(30.685,16.865),(30.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.865),(59.315,17.035),(59.485,17.035),(59.485,16.865),(59.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.185),(55.025,16.355),(55.195,16.355),(55.195,16.185),(55.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.525),(55.025,16.695),(55.195,16.695),(55.195,16.525),(55.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.285),(31.025,4.455),(31.195,4.455),(31.195,4.285),(31.025,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.305),(34.805,5.475),(34.975,5.475),(34.975,5.305),(34.805,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.645),(34.805,5.815),(34.975,5.815),(34.975,5.645),(34.805,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.625),(31.025,4.795),(31.195,4.795),(31.195,4.625),(31.025,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.925),(55.025,3.095),(55.195,3.095),(55.195,2.925),(55.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.945),(39.605,4.115),(39.775,4.115),(39.775,3.945),(39.605,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.205),(59.315,17.375),(59.485,17.375),(59.485,17.205),(59.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.545),(59.315,17.715),(59.485,17.715),(59.485,17.545),(59.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.885),(45.425,18.055),(45.595,18.055),(45.595,17.885),(45.425,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.625),(50.225,4.795),(50.395,4.795),(50.395,4.625),(50.225,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.285),(50.225,4.455),(50.395,4.455),(50.395,4.285),(50.225,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.485),(44.405,14.655),(44.575,14.655),(44.575,14.485),(44.405,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.825),(44.405,14.995),(44.575,14.995),(44.575,14.825),(44.405,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.145),(44.405,14.315),(44.575,14.315),(44.575,14.145),(44.405,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.885),(54.005,18.055),(54.175,18.055),(54.175,17.885),(54.005,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.885),(54.515,18.055),(54.685,18.055),(54.685,17.885),(54.515,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.045),(39.605,9.215),(39.775,9.215),(39.775,9.045),(39.605,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.725),(39.605,9.895),(39.775,9.895),(39.775,9.725),(39.605,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.385),(39.605,9.555),(39.775,9.555),(39.775,9.385),(39.605,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.905),(50.225,19.075),(50.395,19.075),(50.395,18.905),(50.225,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.185),(44.405,16.355),(44.575,16.355),(44.575,16.185),(44.405,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.525),(44.405,16.695),(44.575,16.695),(44.575,16.525),(44.405,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.745),(40.115,10.915),(40.285,10.915),(40.285,10.745),(40.115,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.745),(40.625,10.915),(40.795,10.915),(40.795,10.745),(40.625,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.405),(40.115,10.575),(40.285,10.575),(40.285,10.405),(40.115,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.405),(40.625,10.575),(40.795,10.575),(40.795,10.405),(40.625,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.065),(40.115,10.235),(40.285,10.235),(40.285,10.065),(40.115,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.065),(40.625,10.235),(40.795,10.235),(40.795,10.065),(40.625,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.665),(39.605,6.835),(39.775,6.835),(39.775,6.665),(39.605,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.845),(55.025,16.015),(55.195,16.015),(55.195,15.845),(55.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.325),(39.605,6.495),(39.775,6.495),(39.775,6.325),(39.605,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.505),(40.625,15.675),(40.795,15.675),(40.795,15.505),(40.625,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.505),(40.115,15.675),(40.285,15.675),(40.285,15.505),(40.115,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.485),(59.315,14.655),(59.485,14.655),(59.485,14.485),(59.315,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.165),(40.625,15.335),(40.795,15.335),(40.795,15.165),(40.625,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.165),(40.115,15.335),(40.285,15.335),(40.285,15.165),(40.115,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.145),(59.315,14.315),(59.485,14.315),(59.485,14.145),(59.315,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.825),(59.315,14.995),(59.485,14.995),(59.485,14.825),(59.315,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.305),(49.205,5.475),(49.375,5.475),(49.375,5.305),(49.205,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.645),(49.205,5.815),(49.375,5.815),(49.375,5.645),(49.205,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.645),(49.715,5.815),(49.885,5.815),(49.885,5.645),(49.715,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.305),(49.715,5.475),(49.885,5.475),(49.885,5.305),(49.715,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.005),(55.025,7.175),(55.195,7.175),(55.195,7.005),(55.025,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.505),(39.605,15.675),(39.775,15.675),(39.775,15.505),(39.605,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.685),(55.025,7.855),(55.195,7.855),(55.195,7.685),(55.025,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.345),(55.025,7.515),(55.195,7.515),(55.195,7.345),(55.025,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.165),(39.605,15.335),(39.775,15.335),(39.775,15.165),(39.605,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.245),(45.425,19.415),(45.595,19.415),(45.595,19.245),(45.425,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.125),(39.605,13.295),(39.775,13.295),(39.775,13.125),(39.605,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.805),(39.605,13.975),(39.775,13.975),(39.775,13.805),(39.605,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.465),(39.605,13.635),(39.775,13.635),(39.775,13.465),(39.605,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.705),(49.715,8.875),(49.885,8.875),(49.885,8.705),(49.715,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.365),(49.715,8.535),(49.885,8.535),(49.885,8.365),(49.715,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.705),(49.205,8.875),(49.375,8.875),(49.375,8.705),(49.205,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.025),(49.205,8.195),(49.375,8.195),(49.375,8.025),(49.205,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.365),(49.205,8.535),(49.375,8.535),(49.375,8.365),(49.205,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.965),(55.025,5.135),(55.195,5.135),(55.195,4.965),(55.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.385),(34.805,9.555),(34.975,9.555),(34.975,9.385),(34.805,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.725),(34.805,9.895),(34.975,9.895),(34.975,9.725),(34.805,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.045),(34.805,9.215),(34.975,9.215),(34.975,9.045),(34.805,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.245),(30.515,19.415),(30.685,19.415),(30.685,19.245),(30.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.205),(44.405,17.375),(44.575,17.375),(44.575,17.205),(44.405,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.545),(44.405,17.715),(44.575,17.715),(44.575,17.545),(44.405,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.905),(45.425,19.075),(45.595,19.075),(45.595,18.905),(45.425,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.925),(31.025,3.095),(31.195,3.095),(31.195,2.925),(31.025,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.765),(34.805,11.935),(34.975,11.935),(34.975,11.765),(34.805,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.425),(34.805,11.595),(34.975,11.595),(34.975,11.425),(34.805,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.085),(34.805,11.255),(34.975,11.255),(34.975,11.085),(34.805,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.685),(50.225,7.855),(50.395,7.855),(50.395,7.685),(50.225,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.345),(50.225,7.515),(50.395,7.515),(50.395,7.345),(50.225,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.005),(50.225,7.175),(50.395,7.175),(50.395,7.005),(50.225,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.825),(45.425,14.995),(45.595,14.995),(45.595,14.825),(45.425,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.485),(45.425,14.655),(45.595,14.655),(45.595,14.485),(45.425,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.145),(45.425,14.315),(45.595,14.315),(45.595,14.145),(45.425,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.985),(39.605,6.155),(39.775,6.155),(39.775,5.985),(39.605,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.105),(34.805,12.275),(34.975,12.275),(34.975,12.105),(34.805,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.445),(34.805,12.615),(34.975,12.615),(34.975,12.445),(34.805,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.785),(34.805,12.955),(34.975,12.955),(34.975,12.785),(34.805,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.365),(58.805,8.535),(58.975,8.535),(58.975,8.365),(58.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.705),(58.805,8.875),(58.975,8.875),(58.975,8.705),(58.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.025),(58.805,8.195),(58.975,8.195),(58.975,8.025),(58.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.805),(54.515,13.975),(54.685,13.975),(54.685,13.805),(54.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.465),(54.005,13.635),(54.175,13.635),(54.175,13.465),(54.005,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.605),(54.515,3.775),(54.685,3.775),(54.685,3.605),(54.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.265),(54.515,3.435),(54.685,3.435),(54.685,3.265),(54.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.265),(54.005,3.435),(54.175,3.435),(54.175,3.265),(54.005,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.605),(54.005,3.775),(54.175,3.775),(54.175,3.605),(54.005,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.785),(54.515,12.955),(54.685,12.955),(54.685,12.785),(54.515,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.105),(54.005,12.275),(54.175,12.275),(54.175,12.105),(54.005,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.445),(54.515,12.615),(54.685,12.615),(54.685,12.445),(54.515,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.785),(54.005,12.955),(54.175,12.955),(54.175,12.785),(54.005,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.445),(54.005,12.615),(54.175,12.615),(54.175,12.445),(54.005,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.105),(54.515,12.275),(54.685,12.275),(54.685,12.105),(54.515,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.605),(49.715,3.775),(49.885,3.775),(49.885,3.605),(49.715,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.405),(58.805,10.575),(58.975,10.575),(58.975,10.405),(58.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.965),(35.315,5.135),(35.485,5.135),(35.485,4.965),(35.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.965),(35.825,5.135),(35.995,5.135),(35.995,4.965),(35.825,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.065),(58.805,10.235),(58.975,10.235),(58.975,10.065),(58.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.145),(34.805,14.315),(34.975,14.315),(34.975,14.145),(34.805,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.485),(34.805,14.655),(34.975,14.655),(34.975,14.485),(34.805,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.825),(34.805,14.995),(34.975,14.995),(34.975,14.825),(34.805,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.745),(58.805,10.915),(58.975,10.915),(58.975,10.745),(58.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.185),(54.515,16.355),(54.685,16.355),(54.685,16.185),(54.515,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.185),(54.005,16.355),(54.175,16.355),(54.175,16.185),(54.005,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.525),(54.005,16.695),(54.175,16.695),(54.175,16.525),(54.005,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.525),(54.515,16.695),(54.685,16.695),(54.685,16.525),(54.515,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.925),(45.425,3.095),(45.595,3.095),(45.595,2.925),(45.425,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.485),(54.005,14.655),(54.175,14.655),(54.175,14.485),(54.005,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.825),(54.005,14.995),(54.175,14.995),(54.175,14.825),(54.005,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.825),(54.515,14.995),(54.685,14.995),(54.685,14.825),(54.515,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.845),(45.425,16.015),(45.595,16.015),(45.595,15.845),(45.425,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.485),(54.515,14.655),(54.685,14.655),(54.685,14.485),(54.515,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.145),(54.005,14.315),(54.175,14.315),(54.175,14.145),(54.005,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.905),(34.805,19.075),(34.975,19.075),(34.975,18.905),(34.805,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.765),(40.115,11.935),(40.285,11.935),(40.285,11.765),(40.115,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.905),(35.825,19.075),(35.995,19.075),(35.995,18.905),(35.825,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.905),(35.315,19.075),(35.485,19.075),(35.485,18.905),(35.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.425),(40.115,11.595),(40.285,11.595),(40.285,11.425),(40.115,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.425),(40.625,11.595),(40.795,11.595),(40.795,11.425),(40.625,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.085),(40.115,11.255),(40.285,11.255),(40.285,11.085),(40.115,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.085),(40.625,11.255),(40.795,11.255),(40.795,11.085),(40.625,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.865),(44.915,17.035),(45.085,17.035),(45.085,16.865),(44.915,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.425),(49.715,11.595),(49.885,11.595),(49.885,11.425),(49.715,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.425),(49.205,11.595),(49.375,11.595),(49.375,11.425),(49.205,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.085),(49.205,11.255),(49.375,11.255),(49.375,11.085),(49.205,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.085),(49.715,11.255),(49.885,11.255),(49.885,11.085),(49.715,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.365),(44.915,8.535),(45.085,8.535),(45.085,8.365),(44.915,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.705),(44.915,8.875),(45.085,8.875),(45.085,8.705),(44.915,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.765),(49.205,11.935),(49.375,11.935),(49.375,11.765),(49.205,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.205),(55.025,17.375),(55.195,17.375),(55.195,17.205),(55.025,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.925),(50.225,3.095),(50.395,3.095),(50.395,2.925),(50.225,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.545),(55.025,17.715),(55.195,17.715),(55.195,17.545),(55.025,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.105),(35.825,12.275),(35.995,12.275),(35.995,12.105),(35.825,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.105),(35.315,12.275),(35.485,12.275),(35.485,12.105),(35.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.445),(35.825,12.615),(35.995,12.615),(35.995,12.445),(35.825,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.785),(35.825,12.955),(35.995,12.955),(35.995,12.785),(35.825,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.425),(55.025,11.595),(55.195,11.595),(55.195,11.425),(55.025,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.765),(55.025,11.935),(55.195,11.935),(55.195,11.765),(55.025,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.445),(35.315,12.615),(35.485,12.615),(35.485,12.445),(35.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.965),(59.315,5.135),(59.485,5.135),(59.485,4.965),(59.315,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.785),(35.315,12.955),(35.485,12.955),(35.485,12.785),(35.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.165),(44.915,15.335),(45.085,15.335),(45.085,15.165),(44.915,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.505),(44.915,15.675),(45.085,15.675),(45.085,15.505),(44.915,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.865),(58.805,17.035),(58.975,17.035),(58.975,16.865),(58.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.085),(55.025,11.255),(55.195,11.255),(55.195,11.085),(55.025,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.185),(31.025,16.355),(31.195,16.355),(31.195,16.185),(31.025,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.525),(31.025,16.695),(31.195,16.695),(31.195,16.525),(31.025,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.745),(39.605,10.915),(39.775,10.915),(39.775,10.745),(39.605,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.065),(39.605,10.235),(39.775,10.235),(39.775,10.065),(39.605,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.405),(39.605,10.575),(39.775,10.575),(39.775,10.405),(39.605,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.705),(55.025,8.875),(55.195,8.875),(55.195,8.705),(55.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.205),(39.605,17.375),(39.775,17.375),(39.775,17.205),(39.605,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.545),(39.605,17.715),(39.775,17.715),(39.775,17.545),(39.605,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.945),(44.915,4.115),(45.085,4.115),(45.085,3.945),(44.915,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.065),(31.025,10.235),(31.195,10.235),(31.195,10.065),(31.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.405),(31.025,10.575),(31.195,10.575),(31.195,10.405),(31.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.745),(31.025,10.915),(31.195,10.915),(31.195,10.745),(31.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.205),(44.915,17.375),(45.085,17.375),(45.085,17.205),(44.915,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.545),(44.915,17.715),(45.085,17.715),(45.085,17.545),(44.915,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.985),(45.425,6.155),(45.595,6.155),(45.595,5.985),(45.425,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.025),(39.605,8.195),(39.775,8.195),(39.775,8.025),(39.605,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.365),(39.605,8.535),(39.775,8.535),(39.775,8.365),(39.605,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.705),(39.605,8.875),(39.775,8.875),(39.775,8.705),(39.605,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.865),(55.025,17.035),(55.195,17.035),(55.195,16.865),(55.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.025),(59.315,8.195),(59.485,8.195),(59.485,8.025),(59.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.965),(31.025,5.135),(31.195,5.135),(31.195,4.965),(31.025,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.705),(59.315,8.875),(59.485,8.875),(59.485,8.705),(59.315,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.365),(59.315,8.535),(59.485,8.535),(59.485,8.365),(59.315,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.925),(35.315,3.095),(35.485,3.095),(35.485,2.925),(35.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.925),(35.825,3.095),(35.995,3.095),(35.995,2.925),(35.825,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.365),(31.025,8.535),(31.195,8.535),(31.195,8.365),(31.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.705),(31.025,8.875),(31.195,8.875),(31.195,8.705),(31.025,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.025),(31.025,8.195),(31.195,8.195),(31.195,8.025),(31.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.185),(50.225,16.355),(50.395,16.355),(50.395,16.185),(50.225,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.525),(50.225,16.695),(50.395,16.695),(50.395,16.525),(50.225,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.705),(30.515,8.875),(30.685,8.875),(30.685,8.705),(30.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.365),(30.515,8.535),(30.685,8.535),(30.685,8.365),(30.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.025),(30.515,8.195),(30.685,8.195),(30.685,8.025),(30.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.165),(34.805,15.335),(34.975,15.335),(34.975,15.165),(34.805,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.005),(45.425,7.175),(45.595,7.175),(45.595,7.005),(45.425,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.685),(45.425,7.855),(45.595,7.855),(45.595,7.685),(45.425,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.345),(45.425,7.515),(45.595,7.515),(45.595,7.345),(45.425,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.505),(34.805,15.675),(34.975,15.675),(34.975,15.505),(34.805,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.105),(44.915,12.275),(45.085,12.275),(45.085,12.105),(44.915,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.445),(44.915,12.615),(45.085,12.615),(45.085,12.445),(44.915,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.785),(44.915,12.955),(45.085,12.955),(45.085,12.785),(44.915,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.885),(49.205,18.055),(49.375,18.055),(49.375,17.885),(49.205,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.745),(30.515,10.915),(30.685,10.915),(30.685,10.745),(30.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.885),(49.715,18.055),(49.885,18.055),(49.885,17.885),(49.715,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.405),(30.515,10.575),(30.685,10.575),(30.685,10.405),(30.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.065),(30.515,10.235),(30.685,10.235),(30.685,10.065),(30.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.265),(35.315,3.435),(35.485,3.435),(35.485,3.265),(35.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.605),(35.315,3.775),(35.485,3.775),(35.485,3.605),(35.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.265),(35.825,3.435),(35.995,3.435),(35.995,3.265),(35.825,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.605),(35.825,3.775),(35.995,3.775),(35.995,3.605),(35.825,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.805),(49.205,13.975),(49.375,13.975),(49.375,13.805),(49.205,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.205),(45.425,17.375),(45.595,17.375),(45.595,17.205),(45.425,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.965),(50.225,5.135),(50.395,5.135),(50.395,4.965),(50.225,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.545),(45.425,17.715),(45.595,17.715),(45.595,17.545),(45.425,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.265),(30.515,3.435),(30.685,3.435),(30.685,3.265),(30.515,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.605),(30.515,3.775),(30.685,3.775),(30.685,3.605),(30.515,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.385),(31.025,9.555),(31.195,9.555),(31.195,9.385),(31.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.725),(31.025,9.895),(31.195,9.895),(31.195,9.725),(31.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.045),(31.025,9.215),(31.195,9.215),(31.195,9.045),(31.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.985),(54.515,6.155),(54.685,6.155),(54.685,5.985),(54.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.985),(54.005,6.155),(54.175,6.155),(54.175,5.985),(54.005,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.925),(59.315,3.095),(59.485,3.095),(59.485,2.925),(59.315,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.645),(44.405,5.815),(44.575,5.815),(44.575,5.645),(44.405,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.885),(58.805,18.055),(58.975,18.055),(58.975,17.885),(58.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.305),(44.405,5.475),(44.575,5.475),(44.575,5.305),(44.405,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.865),(44.405,17.035),(44.575,17.035),(44.575,16.865),(44.405,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.125),(50.225,13.295),(50.395,13.295),(50.395,13.125),(50.225,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.805),(50.225,13.975),(50.395,13.975),(50.395,13.805),(50.225,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.465),(50.225,13.635),(50.395,13.635),(50.395,13.465),(50.225,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.245),(44.405,19.415),(44.575,19.415),(44.575,19.245),(44.405,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.445),(44.405,12.615),(44.575,12.615),(44.575,12.445),(44.405,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.785),(44.405,12.955),(44.575,12.955),(44.575,12.785),(44.405,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.605),(59.315,3.775),(59.485,3.775),(59.485,3.605),(59.315,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.245),(54.005,19.415),(54.175,19.415),(54.175,19.245),(54.005,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.245),(54.515,19.415),(54.685,19.415),(54.685,19.245),(54.515,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.105),(44.405,12.275),(44.575,12.275),(44.575,12.105),(44.405,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.325),(55.025,6.495),(55.195,6.495),(55.195,6.325),(55.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.665),(55.025,6.835),(55.195,6.835),(55.195,6.665),(55.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.265),(59.315,3.435),(59.485,3.435),(59.485,3.265),(59.315,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.505),(31.025,15.675),(31.195,15.675),(31.195,15.505),(31.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.165),(31.025,15.335),(31.195,15.335),(31.195,15.165),(31.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.125),(31.025,13.295),(31.195,13.295),(31.195,13.125),(31.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.805),(31.025,13.975),(31.195,13.975),(31.195,13.805),(31.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.465),(31.025,13.635),(31.195,13.635),(31.195,13.465),(31.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.885),(40.115,18.055),(40.285,18.055),(40.285,17.885),(40.115,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.885),(40.625,18.055),(40.795,18.055),(40.795,17.885),(40.625,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.325),(30.515,6.495),(30.685,6.495),(30.685,6.325),(30.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.665),(30.515,6.835),(30.685,6.835),(30.685,6.665),(30.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.965),(44.915,5.135),(45.085,5.135),(45.085,4.965),(44.915,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.325),(35.315,6.495),(35.485,6.495),(35.485,6.325),(35.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.665),(35.825,6.835),(35.995,6.835),(35.995,6.665),(35.825,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.325),(35.825,6.495),(35.995,6.495),(35.995,6.325),(35.825,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.665),(35.315,6.835),(35.485,6.835),(35.485,6.665),(35.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.905),(44.915,19.075),(45.085,19.075),(45.085,18.905),(44.915,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.185),(34.805,16.355),(34.975,16.355),(34.975,16.185),(34.805,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.525),(34.805,16.695),(34.975,16.695),(34.975,16.525),(34.805,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.645),(39.605,5.815),(39.775,5.815),(39.775,5.645),(39.605,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.305),(39.605,5.475),(39.775,5.475),(39.775,5.305),(39.605,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.605),(31.025,3.775),(31.195,3.775),(31.195,3.605),(31.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.265),(31.025,3.435),(31.195,3.435),(31.195,3.265),(31.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.265),(58.805,3.435),(58.975,3.435),(58.975,3.265),(58.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.605),(58.805,3.775),(58.975,3.775),(58.975,3.605),(58.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.945),(54.005,4.115),(54.175,4.115),(54.175,3.945),(54.005,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.945),(54.515,4.115),(54.685,4.115),(54.685,3.945),(54.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.985),(30.515,6.155),(30.685,6.155),(30.685,5.985),(30.515,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.865),(54.005,17.035),(54.175,17.035),(54.175,16.865),(54.005,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.865),(54.515,17.035),(54.685,17.035),(54.685,16.865),(54.515,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.325),(59.315,6.495),(59.485,6.495),(59.485,6.325),(59.315,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.665),(59.315,6.835),(59.485,6.835),(59.485,6.665),(59.315,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.265),(34.805,3.435),(34.975,3.435),(34.975,3.265),(34.805,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.605),(34.805,3.775),(34.975,3.775),(34.975,3.605),(34.805,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.025),(35.825,8.195),(35.995,8.195),(35.995,8.025),(35.825,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.525),(35.315,16.695),(35.485,16.695),(35.485,16.525),(35.315,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.185),(35.825,16.355),(35.995,16.355),(35.995,16.185),(35.825,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.185),(35.315,16.355),(35.485,16.355),(35.485,16.185),(35.315,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.525),(35.825,16.695),(35.995,16.695),(35.995,16.525),(35.825,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.505),(35.315,15.675),(35.485,15.675),(35.485,15.505),(35.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.505),(35.825,15.675),(35.995,15.675),(35.995,15.505),(35.825,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.525),(44.915,16.695),(45.085,16.695),(45.085,16.525),(44.915,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.185),(44.915,16.355),(45.085,16.355),(45.085,16.185),(44.915,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.325),(58.805,6.495),(58.975,6.495),(58.975,6.325),(58.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.665),(58.805,6.835),(58.975,6.835),(58.975,6.665),(58.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.825),(40.115,14.995),(40.285,14.995),(40.285,14.825),(40.115,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.165),(35.315,15.335),(35.485,15.335),(35.485,15.165),(35.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.165),(35.825,15.335),(35.995,15.335),(35.995,15.165),(35.825,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.145),(40.625,14.315),(40.795,14.315),(40.795,14.145),(40.625,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.645),(45.425,5.815),(45.595,5.815),(45.595,5.645),(45.425,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.825),(40.625,14.995),(40.795,14.995),(40.795,14.825),(40.625,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.325),(31.025,6.495),(31.195,6.495),(31.195,6.325),(31.025,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.665),(31.025,6.835),(31.195,6.835),(31.195,6.665),(31.025,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.565),(55.025,18.735),(55.195,18.735),(55.195,18.565),(55.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.225),(55.025,18.395),(55.195,18.395),(55.195,18.225),(55.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.305),(45.425,5.475),(45.595,5.475),(45.595,5.305),(45.425,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.985),(35.315,6.155),(35.485,6.155),(35.485,5.985),(35.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.985),(35.825,6.155),(35.995,6.155),(35.995,5.985),(35.825,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.925),(49.205,3.095),(49.375,3.095),(49.375,2.925),(49.205,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.925),(49.715,3.095),(49.885,3.095),(49.885,2.925),(49.715,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.325),(34.805,6.495),(34.975,6.495),(34.975,6.325),(34.805,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.665),(34.805,6.835),(34.975,6.835),(34.975,6.665),(34.805,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.865),(31.025,17.035),(31.195,17.035),(31.195,16.865),(31.025,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.665),(54.005,6.835),(54.175,6.835),(54.175,6.665),(54.005,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.325),(54.515,6.495),(54.685,6.495),(54.685,6.325),(54.515,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.665),(54.515,6.835),(54.685,6.835),(54.685,6.665),(54.515,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.325),(54.005,6.495),(54.175,6.495),(54.175,6.325),(54.005,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.265),(44.915,3.435),(45.085,3.435),(45.085,3.265),(44.915,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.605),(44.915,3.775),(45.085,3.775),(45.085,3.605),(44.915,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.225),(59.315,18.395),(59.485,18.395),(59.485,18.225),(59.315,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.885),(35.315,18.055),(35.485,18.055),(35.485,17.885),(35.315,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.885),(35.825,18.055),(35.995,18.055),(35.995,17.885),(35.825,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.745),(55.025,10.915),(55.195,10.915),(55.195,10.745),(55.025,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.065),(55.025,10.235),(55.195,10.235),(55.195,10.065),(55.025,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.405),(55.025,10.575),(55.195,10.575),(55.195,10.405),(55.025,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.845),(44.915,16.015),(45.085,16.015),(45.085,15.845),(44.915,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.385),(40.115,9.555),(40.285,9.555),(40.285,9.385),(40.115,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.725),(40.115,9.895),(40.285,9.895),(40.285,9.725),(40.115,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.385),(40.625,9.555),(40.795,9.555),(40.795,9.385),(40.625,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.725),(40.625,9.895),(40.795,9.895),(40.795,9.725),(40.625,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.185),(39.605,16.355),(39.775,16.355),(39.775,16.185),(39.605,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.845),(34.805,16.015),(34.975,16.015),(34.975,15.845),(34.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.525),(39.605,16.695),(39.775,16.695),(39.775,16.525),(39.605,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.045),(40.625,9.215),(40.795,9.215),(40.795,9.045),(40.625,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.045),(40.115,9.215),(40.285,9.215),(40.285,9.045),(40.115,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.005),(44.405,7.175),(44.575,7.175),(44.575,7.005),(44.405,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.885),(44.915,18.055),(45.085,18.055),(45.085,17.885),(44.915,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.345),(44.405,7.515),(44.575,7.515),(44.575,7.345),(44.405,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.525),(40.115,16.695),(40.285,16.695),(40.285,16.525),(40.115,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.685),(44.405,7.855),(44.575,7.855),(44.575,7.685),(44.405,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.185),(40.625,16.355),(40.795,16.355),(40.795,16.185),(40.625,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.525),(40.625,16.695),(40.795,16.695),(40.795,16.525),(40.625,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.265),(49.205,3.435),(49.375,3.435),(49.375,3.265),(49.205,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.605),(49.205,3.775),(49.375,3.775),(49.375,3.605),(49.205,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.105),(49.715,12.275),(49.885,12.275),(49.885,12.105),(49.715,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.105),(49.205,12.275),(49.375,12.275),(49.375,12.105),(49.205,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.125),(30.515,13.295),(30.685,13.295),(30.685,13.125),(30.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.465),(30.515,13.635),(30.685,13.635),(30.685,13.465),(30.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.025),(55.025,8.195),(55.195,8.195),(55.195,8.025),(55.025,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.265),(49.715,3.435),(49.885,3.435),(49.885,3.265),(49.715,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.785),(49.205,12.955),(49.375,12.955),(49.375,12.785),(49.205,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.785),(49.715,12.955),(49.885,12.955),(49.885,12.785),(49.715,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.445),(49.205,12.615),(49.375,12.615),(49.375,12.445),(49.205,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.365),(55.025,8.535),(55.195,8.535),(55.195,8.365),(55.025,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.325),(45.425,6.495),(45.595,6.495),(45.595,6.325),(45.425,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.665),(45.425,6.835),(45.595,6.835),(45.595,6.665),(45.425,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.125),(44.915,13.295),(45.085,13.295),(45.085,13.125),(44.915,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.465),(44.915,13.635),(45.085,13.635),(45.085,13.465),(44.915,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.805),(44.915,13.975),(45.085,13.975),(45.085,13.805),(44.915,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.265),(55.025,3.435),(55.195,3.435),(55.195,3.265),(55.025,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.865),(50.225,17.035),(50.395,17.035),(50.395,16.865),(50.225,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.985),(59.315,6.155),(59.485,6.155),(59.485,5.985),(59.315,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.605),(55.025,3.775),(55.195,3.775),(55.195,3.605),(55.025,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.805),(30.515,13.975),(30.685,13.975),(30.685,13.805),(30.515,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.385),(45.425,9.555),(45.595,9.555),(45.595,9.385),(45.425,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.725),(45.425,9.895),(45.595,9.895),(45.595,9.725),(45.425,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.045),(45.425,9.215),(45.595,9.215),(45.595,9.045),(45.425,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.945),(35.825,4.115),(35.995,4.115),(35.995,3.945),(35.825,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.945),(35.315,4.115),(35.485,4.115),(35.485,3.945),(35.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.205),(49.205,17.375),(49.375,17.375),(49.375,17.205),(49.205,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.545),(49.205,17.715),(49.375,17.715),(49.375,17.545),(49.205,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.205),(49.715,17.375),(49.885,17.375),(49.885,17.205),(49.715,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.545),(49.715,17.715),(49.885,17.715),(49.885,17.545),(49.715,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.025),(34.805,8.195),(34.975,8.195),(34.975,8.025),(34.805,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.705),(34.805,8.875),(34.975,8.875),(34.975,8.705),(34.805,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.365),(34.805,8.535),(34.975,8.535),(34.975,8.365),(34.805,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.925),(44.405,3.095),(44.575,3.095),(44.575,2.925),(44.405,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.945),(30.515,4.115),(30.685,4.115),(30.685,3.945),(30.515,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.645),(40.625,5.815),(40.795,5.815),(40.795,5.645),(40.625,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.645),(40.115,5.815),(40.285,5.815),(40.285,5.645),(40.115,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.305),(40.625,5.475),(40.795,5.475),(40.795,5.305),(40.625,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.845),(31.025,16.015),(31.195,16.015),(31.195,15.845),(31.025,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.305),(40.115,5.475),(40.285,5.475),(40.285,5.305),(40.115,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.405),(34.805,10.575),(34.975,10.575),(34.975,10.405),(34.805,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.745),(34.805,10.915),(34.975,10.915),(34.975,10.745),(34.805,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.425),(44.405,11.595),(44.575,11.595),(44.575,11.425),(44.405,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.065),(34.805,10.235),(34.975,10.235),(34.975,10.065),(34.805,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.765),(44.405,11.935),(44.575,11.935),(44.575,11.765),(44.405,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.085),(44.405,11.255),(44.575,11.255),(44.575,11.085),(44.405,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.945),(59.315,4.115),(59.485,4.115),(59.485,3.945),(59.315,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.845),(54.515,16.015),(54.685,16.015),(54.685,15.845),(54.515,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.845),(54.005,16.015),(54.175,16.015),(54.175,15.845),(54.005,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.765),(35.315,11.935),(35.485,11.935),(35.485,11.765),(35.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.765),(35.825,11.935),(35.995,11.935),(35.995,11.765),(35.825,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.425),(35.825,11.595),(35.995,11.595),(35.995,11.425),(35.825,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.425),(35.315,11.595),(35.485,11.595),(35.485,11.425),(35.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.085),(35.315,11.255),(35.485,11.255),(35.485,11.085),(35.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.085),(35.825,11.255),(35.995,11.255),(35.995,11.085),(35.825,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.685),(54.515,7.855),(54.685,7.855),(54.685,7.685),(54.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.345),(54.005,7.515),(54.175,7.515),(54.175,7.345),(54.005,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.685),(54.005,7.855),(54.175,7.855),(54.175,7.685),(54.005,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.345),(54.515,7.515),(54.685,7.515),(54.685,7.345),(54.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.185),(40.115,16.355),(40.285,16.355),(40.285,16.185),(40.115,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.005),(54.005,7.175),(54.175,7.175),(54.175,7.005),(54.005,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.005),(54.515,7.175),(54.685,7.175),(54.685,7.005),(54.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.245),(58.805,19.415),(58.975,19.415),(58.975,19.245),(58.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.205),(30.515,17.375),(30.685,17.375),(30.685,17.205),(30.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.545),(30.515,17.715),(30.685,17.715),(30.685,17.545),(30.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.045),(35.825,9.215),(35.995,9.215),(35.995,9.045),(35.825,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.045),(35.315,9.215),(35.485,9.215),(35.485,9.045),(35.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.385),(35.825,9.555),(35.995,9.555),(35.995,9.385),(35.825,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.885),(50.225,18.055),(50.395,18.055),(50.395,17.885),(50.225,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.725),(35.825,9.895),(35.995,9.895),(35.995,9.725),(35.825,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.385),(35.315,9.555),(35.485,9.555),(35.485,9.385),(35.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.725),(35.315,9.895),(35.485,9.895),(35.485,9.725),(35.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.765),(40.625,11.935),(40.795,11.935),(40.795,11.765),(40.625,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.105),(40.625,12.275),(40.795,12.275),(40.795,12.105),(40.625,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.665),(49.715,6.835),(49.885,6.835),(49.885,6.665),(49.715,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.665),(49.205,6.835),(49.375,6.835),(49.375,6.665),(49.205,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.325),(49.205,6.495),(49.375,6.495),(49.375,6.325),(49.205,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.325),(49.715,6.495),(49.885,6.495),(49.885,6.325),(49.715,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.305),(50.225,5.475),(50.395,5.475),(50.395,5.305),(50.225,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.645),(50.225,5.815),(50.395,5.815),(50.395,5.645),(50.225,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.505),(49.205,15.675),(49.375,15.675),(49.375,15.505),(49.205,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.505),(49.715,15.675),(49.885,15.675),(49.885,15.505),(49.715,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.165),(49.205,15.335),(49.375,15.335),(49.375,15.165),(49.205,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.165),(49.715,15.335),(49.885,15.335),(49.885,15.165),(49.715,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.285),(44.915,4.455),(45.085,4.455),(45.085,4.285),(44.915,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.625),(44.915,4.795),(45.085,4.795),(45.085,4.625),(44.915,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.445),(59.315,12.615),(59.485,12.615),(59.485,12.445),(59.315,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.785),(59.315,12.955),(59.485,12.955),(59.485,12.785),(59.315,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.105),(59.315,12.275),(59.485,12.275),(59.485,12.105),(59.315,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.845),(58.805,16.015),(58.975,16.015),(58.975,15.845),(58.805,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.225),(44.915,18.395),(45.085,18.395),(45.085,18.225),(44.915,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.565),(44.915,18.735),(45.085,18.735),(45.085,18.565),(44.915,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.945),(31.025,4.115),(31.195,4.115),(31.195,3.945),(31.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.865),(34.805,17.035),(34.975,17.035),(34.975,16.865),(34.805,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.945),(44.405,4.115),(44.575,4.115),(44.575,3.945),(44.405,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((73.76,10.79),(73.76,10.96),(73.93,10.96),(73.93,10.79),(73.76,10.79)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.285),(44.405,4.455),(44.575,4.455),(44.575,4.285),(44.405,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.625),(44.405,4.795),(44.575,4.795),(44.575,4.625),(44.405,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.945),(58.805,4.115),(58.975,4.115),(58.975,3.945),(58.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.265),(45.425,3.435),(45.595,3.435),(45.595,3.265),(45.425,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.605),(45.425,3.775),(45.595,3.775),(45.595,3.605),(45.425,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.225),(31.025,18.395),(31.195,18.395),(31.195,18.225),(31.025,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.565),(31.025,18.735),(31.195,18.735),(31.195,18.565),(31.025,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.565),(40.625,18.735),(40.795,18.735),(40.795,18.565),(40.625,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.225),(40.115,18.395),(40.285,18.395),(40.285,18.225),(40.115,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.565),(40.115,18.735),(40.285,18.735),(40.285,18.565),(40.115,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.225),(40.625,18.395),(40.795,18.395),(40.795,18.225),(40.625,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.945),(34.805,4.115),(34.975,4.115),(34.975,3.945),(34.805,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.285),(45.425,4.455),(45.595,4.455),(45.595,4.285),(45.425,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.625),(45.425,4.795),(45.595,4.795),(45.595,4.625),(45.425,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.865),(35.825,17.035),(35.995,17.035),(35.995,16.865),(35.825,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.865),(35.315,17.035),(35.485,17.035),(35.485,16.865),(35.315,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.345),(30.515,7.515),(30.685,7.515),(30.685,7.345),(30.515,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.685),(30.515,7.855),(30.685,7.855),(30.685,7.685),(30.515,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.005),(30.515,7.175),(30.685,7.175),(30.685,7.005),(30.515,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.905),(55.025,19.075),(55.195,19.075),(55.195,18.905),(55.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.305),(35.825,5.475),(35.995,5.475),(35.995,5.305),(35.825,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.305),(35.315,5.475),(35.485,5.475),(35.485,5.305),(35.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.645),(35.825,5.815),(35.995,5.815),(35.995,5.645),(35.825,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.645),(35.315,5.815),(35.485,5.815),(35.485,5.645),(35.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.845),(35.315,16.015),(35.485,16.015),(35.485,15.845),(35.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.845),(35.825,16.015),(35.995,16.015),(35.995,15.845),(35.825,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.705),(50.225,8.875),(50.395,8.875),(50.395,8.705),(50.225,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.045),(50.225,9.215),(50.395,9.215),(50.395,9.045),(50.225,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.385),(50.225,9.555),(50.395,9.555),(50.395,9.385),(50.225,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.545),(35.315,17.715),(35.485,17.715),(35.485,17.545),(35.315,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.205),(35.825,17.375),(35.995,17.375),(35.995,17.205),(35.825,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.205),(35.315,17.375),(35.485,17.375),(35.485,17.205),(35.315,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.545),(35.825,17.715),(35.995,17.715),(35.995,17.545),(35.825,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.885),(34.805,18.055),(34.975,18.055),(34.975,17.885),(34.805,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.725),(50.225,9.895),(50.395,9.895),(50.395,9.725),(50.225,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.705),(54.515,8.875),(54.685,8.875),(54.685,8.705),(54.515,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.025),(54.005,8.195),(54.175,8.195),(54.175,8.025),(54.005,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.865),(39.605,17.035),(39.775,17.035),(39.775,16.865),(39.605,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.945),(49.715,4.115),(49.885,4.115),(49.885,3.945),(49.715,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.945),(49.205,4.115),(49.375,4.115),(49.375,3.945),(49.205,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.365),(54.005,8.535),(54.175,8.535),(54.175,8.365),(54.005,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.705),(54.005,8.875),(54.175,8.875),(54.175,8.705),(54.005,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.685),(40.115,7.855),(40.285,7.855),(40.285,7.685),(40.115,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.685),(40.625,7.855),(40.795,7.855),(40.795,7.685),(40.625,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.005),(40.115,7.175),(40.285,7.175),(40.285,7.005),(40.115,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.865),(40.115,17.035),(40.285,17.035),(40.285,16.865),(40.115,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.085),(50.225,11.255),(50.395,11.255),(50.395,11.085),(50.225,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.765),(50.225,11.935),(50.395,11.935),(50.395,11.765),(50.225,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.005),(40.625,7.175),(40.795,7.175),(40.795,7.005),(40.625,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.345),(40.115,7.515),(40.285,7.515),(40.285,7.345),(40.115,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.565),(59.315,18.735),(59.485,18.735),(59.485,18.565),(59.315,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.125),(54.005,13.295),(54.175,13.295),(54.175,13.125),(54.005,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.125),(54.515,13.295),(54.685,13.295),(54.685,13.125),(54.515,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.425),(50.225,11.595),(50.395,11.595),(50.395,11.425),(50.225,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.865),(40.625,17.035),(40.795,17.035),(40.795,16.865),(40.625,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.465),(54.515,13.635),(54.685,13.635),(54.685,13.465),(54.515,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.945),(55.025,4.115),(55.195,4.115),(55.195,3.945),(55.025,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.985),(34.805,6.155),(34.975,6.155),(34.975,5.985),(34.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.065),(54.005,10.235),(54.175,10.235),(54.175,10.065),(54.005,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.065),(54.515,10.235),(54.685,10.235),(54.685,10.065),(54.515,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.745),(54.515,10.915),(54.685,10.915),(54.685,10.745),(54.515,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.745),(54.005,10.915),(54.175,10.915),(54.175,10.745),(54.005,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.405),(54.005,10.575),(54.175,10.575),(54.175,10.405),(54.005,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.405),(54.515,10.575),(54.685,10.575),(54.685,10.405),(54.515,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.305),(59.315,5.475),(59.485,5.475),(59.485,5.305),(59.315,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.645),(59.315,5.815),(59.485,5.815),(59.485,5.645),(59.315,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.105),(50.225,12.275),(50.395,12.275),(50.395,12.105),(50.225,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.445),(50.225,12.615),(50.395,12.615),(50.395,12.445),(50.225,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.245),(40.115,19.415),(40.285,19.415),(40.285,19.245),(40.115,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.245),(40.625,19.415),(40.795,19.415),(40.795,19.245),(40.625,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.785),(50.225,12.955),(50.395,12.955),(50.395,12.785),(50.225,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.405),(35.825,10.575),(35.995,10.575),(35.995,10.405),(35.825,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.405),(35.315,10.575),(35.485,10.575),(35.485,10.405),(35.315,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.745),(35.315,10.915),(35.485,10.915),(35.485,10.745),(35.315,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.745),(35.825,10.915),(35.995,10.915),(35.995,10.745),(35.825,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.045),(55.025,9.215),(55.195,9.215),(55.195,9.045),(55.025,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.385),(55.025,9.555),(55.195,9.555),(55.195,9.385),(55.025,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.725),(55.025,9.895),(55.195,9.895),(55.195,9.725),(55.025,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.985),(31.025,6.155),(31.195,6.155),(31.195,5.985),(31.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.065),(35.315,10.235),(35.485,10.235),(35.485,10.065),(35.315,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.065),(35.825,10.235),(35.995,10.235),(35.995,10.065),(35.825,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.485),(50.225,14.655),(50.395,14.655),(50.395,14.485),(50.225,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.825),(50.225,14.995),(50.395,14.995),(50.395,14.825),(50.225,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.225),(30.515,18.395),(30.685,18.395),(30.685,18.225),(30.515,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.565),(30.515,18.735),(30.685,18.735),(30.685,18.565),(30.515,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.145),(50.225,14.315),(50.395,14.315),(50.395,14.145),(50.225,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.025),(45.425,8.195),(45.595,8.195),(45.595,8.025),(45.425,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.365),(45.425,8.535),(45.595,8.535),(45.595,8.365),(45.425,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.205),(54.005,17.375),(54.175,17.375),(54.175,17.205),(54.005,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.545),(54.005,17.715),(54.175,17.715),(54.175,17.545),(54.005,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.545),(54.515,17.715),(54.685,17.715),(54.685,17.545),(54.515,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.205),(54.515,17.375),(54.685,17.375),(54.685,17.205),(54.515,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.705),(45.425,8.875),(45.595,8.875),(45.595,8.705),(45.425,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.625),(49.205,4.795),(49.375,4.795),(49.375,4.625),(49.205,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.285),(49.205,4.455),(49.375,4.455),(49.375,4.285),(49.205,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.285),(49.715,4.455),(49.885,4.455),(49.885,4.285),(49.715,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.625),(49.715,4.795),(49.885,4.795),(49.885,4.625),(49.715,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.485),(39.605,14.655),(39.775,14.655),(39.775,14.485),(39.605,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.825),(39.605,14.995),(39.775,14.995),(39.775,14.825),(39.605,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.765),(49.715,11.935),(49.885,11.935),(49.885,11.765),(49.715,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.145),(39.605,14.315),(39.775,14.315),(39.775,14.145),(39.605,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.485),(31.025,14.655),(31.195,14.655),(31.195,14.485),(31.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.825),(31.025,14.995),(31.195,14.995),(31.195,14.825),(31.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.145),(31.025,14.315),(31.195,14.315),(31.195,14.145),(31.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.325),(44.915,6.495),(45.085,6.495),(45.085,6.325),(44.915,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.665),(44.915,6.835),(45.085,6.835),(45.085,6.665),(44.915,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.845),(40.625,16.015),(40.795,16.015),(40.795,15.845),(40.625,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.845),(40.115,16.015),(40.285,16.015),(40.285,15.845),(40.115,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.365),(54.515,8.535),(54.685,8.535),(54.685,8.365),(54.515,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.105),(39.605,12.275),(39.775,12.275),(39.775,12.105),(39.605,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.445),(39.605,12.615),(39.775,12.615),(39.775,12.445),(39.605,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.785),(39.605,12.955),(39.775,12.955),(39.775,12.785),(39.605,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.505),(55.025,15.675),(55.195,15.675),(55.195,15.505),(55.025,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.465),(58.805,13.635),(58.975,13.635),(58.975,13.465),(58.805,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.805),(58.805,13.975),(58.975,13.975),(58.975,13.805),(58.805,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.165),(55.025,15.335),(55.195,15.335),(55.195,15.165),(55.025,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.125),(58.805,13.295),(58.975,13.295),(58.975,13.125),(58.805,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.785),(31.025,12.955),(31.195,12.955),(31.195,12.785),(31.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.445),(31.025,12.615),(31.195,12.615),(31.195,12.445),(31.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.105),(31.025,12.275),(31.195,12.275),(31.195,12.105),(31.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.625),(30.515,4.795),(30.685,4.795),(30.685,4.625),(30.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.285),(30.515,4.455),(30.685,4.455),(30.685,4.285),(30.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.445),(49.715,12.615),(49.885,12.615),(49.885,12.445),(49.715,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.845),(49.205,16.015),(49.375,16.015),(49.375,15.845),(49.205,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.845),(49.715,16.015),(49.885,16.015),(49.885,15.845),(49.715,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.125),(55.025,13.295),(55.195,13.295),(55.195,13.125),(55.025,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.465),(55.025,13.635),(55.195,13.635),(55.195,13.465),(55.025,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.805),(55.025,13.975),(55.195,13.975),(55.195,13.805),(55.025,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.845),(39.605,16.015),(39.775,16.015),(39.775,15.845),(39.605,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.305),(44.915,5.475),(45.085,5.475),(45.085,5.305),(44.915,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.645),(44.915,5.815),(45.085,5.815),(45.085,5.645),(44.915,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.685),(39.605,7.855),(39.775,7.855),(39.775,7.685),(39.605,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.345),(39.605,7.515),(39.775,7.515),(39.775,7.345),(39.605,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.005),(39.605,7.175),(39.775,7.175),(39.775,7.005),(39.605,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.165),(50.225,15.335),(50.395,15.335),(50.395,15.165),(50.225,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.505),(50.225,15.675),(50.395,15.675),(50.395,15.505),(50.225,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.165),(59.315,15.335),(59.485,15.335),(59.485,15.165),(59.315,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.325),(44.405,6.495),(44.575,6.495),(44.575,6.325),(44.405,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.665),(44.405,6.835),(44.575,6.835),(44.575,6.665),(44.405,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.505),(59.315,15.675),(59.485,15.675),(59.485,15.505),(59.315,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.245),(50.225,19.415),(50.395,19.415),(50.395,19.245),(50.225,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.985),(55.025,6.155),(55.195,6.155),(55.195,5.985),(55.025,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.405),(44.915,10.575),(45.085,10.575),(45.085,10.405),(44.915,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.065),(44.915,10.235),(45.085,10.235),(45.085,10.065),(44.915,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.745),(44.915,10.915),(45.085,10.915),(45.085,10.745),(44.915,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.885),(44.405,18.055),(44.575,18.055),(44.575,17.885),(44.405,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.485),(40.115,14.655),(40.285,14.655),(40.285,14.485),(40.115,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.485),(40.625,14.655),(40.795,14.655),(40.795,14.485),(40.625,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.345),(40.625,7.515),(40.795,7.515),(40.795,7.345),(40.625,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.705),(40.115,8.875),(40.285,8.875),(40.285,8.705),(40.115,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.025),(40.625,8.195),(40.795,8.195),(40.795,8.025),(40.625,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.365),(40.625,8.535),(40.795,8.535),(40.795,8.365),(40.625,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.365),(40.115,8.535),(40.285,8.535),(40.285,8.365),(40.115,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.705),(40.625,8.875),(40.795,8.875),(40.795,8.705),(40.625,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.465),(40.625,13.635),(40.795,13.635),(40.795,13.465),(40.625,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.805),(40.625,13.975),(40.795,13.975),(40.795,13.805),(40.625,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.465),(40.115,13.635),(40.285,13.635),(40.285,13.465),(40.115,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.805),(40.115,13.975),(40.285,13.975),(40.285,13.805),(40.115,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.125),(40.115,13.295),(40.285,13.295),(40.285,13.125),(40.115,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.125),(40.625,13.295),(40.795,13.295),(40.795,13.125),(40.625,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.805),(54.005,13.975),(54.175,13.975),(54.175,13.805),(54.005,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.605),(44.405,3.775),(44.575,3.775),(44.575,3.605),(44.405,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.265),(44.405,3.435),(44.575,3.435),(44.575,3.265),(44.405,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.985),(58.805,6.155),(58.975,6.155),(58.975,5.985),(58.805,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.625),(58.805,4.795),(58.975,4.795),(58.975,4.625),(58.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.285),(58.805,4.455),(58.975,4.455),(58.975,4.285),(58.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.085),(45.425,11.255),(45.595,11.255),(45.595,11.085),(45.425,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.945),(45.425,4.115),(45.595,4.115),(45.595,3.945),(45.425,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.285),(34.805,4.455),(34.975,4.455),(34.975,4.285),(34.805,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.625),(34.805,4.795),(34.975,4.795),(34.975,4.625),(34.805,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.965),(44.405,5.135),(44.575,5.135),(44.575,4.965),(44.405,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.285),(40.625,4.455),(40.795,4.455),(40.795,4.285),(40.625,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.285),(40.115,4.455),(40.285,4.455),(40.285,4.285),(40.115,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.625),(40.625,4.795),(40.795,4.795),(40.795,4.625),(40.625,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.625),(40.115,4.795),(40.285,4.795),(40.285,4.625),(40.115,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.245),(59.315,19.415),(59.485,19.415),(59.485,19.245),(59.315,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.905),(31.025,19.075),(31.195,19.075),(31.195,18.905),(31.025,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.625),(54.515,4.795),(54.685,4.795),(54.685,4.625),(54.515,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.285),(54.005,4.455),(54.175,4.455),(54.175,4.285),(54.005,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.745),(49.715,10.915),(49.885,10.915),(49.885,10.745),(49.715,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.745),(49.205,10.915),(49.375,10.915),(49.375,10.745),(49.205,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.905),(40.115,19.075),(40.285,19.075),(40.285,18.905),(40.115,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.625),(54.005,4.795),(54.175,4.795),(54.175,4.625),(54.005,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.065),(49.205,10.235),(49.375,10.235),(49.375,10.065),(49.205,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.065),(49.715,10.235),(49.885,10.235),(49.885,10.065),(49.715,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.285),(54.515,4.455),(54.685,4.455),(54.685,4.285),(54.515,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.965),(45.425,5.135),(45.595,5.135),(45.595,4.965),(45.425,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.405),(49.205,10.575),(49.375,10.575),(49.375,10.405),(49.205,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.405),(49.715,10.575),(49.885,10.575),(49.885,10.405),(49.715,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.905),(40.625,19.075),(40.795,19.075),(40.795,18.905),(40.625,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.225),(39.605,18.395),(39.775,18.395),(39.775,18.225),(39.605,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.565),(39.605,18.735),(39.775,18.735),(39.775,18.565),(39.605,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.745),(44.405,10.915),(44.575,10.915),(44.575,10.745),(44.405,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.405),(44.405,10.575),(44.575,10.575),(44.575,10.405),(44.405,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.065),(44.405,10.235),(44.575,10.235),(44.575,10.065),(44.405,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.925),(44.915,3.095),(45.085,3.095),(45.085,2.925),(44.915,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.845),(59.315,16.015),(59.485,16.015),(59.485,15.845),(59.315,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.925),(40.115,3.095),(40.285,3.095),(40.285,2.925),(40.115,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.925),(40.625,3.095),(40.795,3.095),(40.795,2.925),(40.625,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.425),(39.605,11.595),(39.775,11.595),(39.775,11.425),(39.605,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.085),(39.605,11.255),(39.775,11.255),(39.775,11.085),(39.605,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.765),(39.605,11.935),(39.775,11.935),(39.775,11.765),(39.605,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.425),(59.315,11.595),(59.485,11.595),(59.485,11.425),(59.315,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.765),(59.315,11.935),(59.485,11.935),(59.485,11.765),(59.315,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.085),(59.315,11.255),(59.485,11.255),(59.485,11.085),(59.315,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.905),(59.315,19.075),(59.485,19.075),(59.485,18.905),(59.315,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.565),(58.805,18.735),(58.975,18.735),(58.975,18.565),(58.805,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.225),(58.805,18.395),(58.975,18.395),(58.975,18.225),(58.805,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.465),(35.315,13.635),(35.485,13.635),(35.485,13.465),(35.315,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.805),(35.825,13.975),(35.995,13.975),(35.995,13.805),(35.825,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.125),(35.315,13.295),(35.485,13.295),(35.485,13.125),(35.315,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.125),(35.825,13.295),(35.995,13.295),(35.995,13.125),(35.825,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.805),(35.315,13.975),(35.485,13.975),(35.485,13.805),(35.315,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.465),(35.825,13.635),(35.995,13.635),(35.995,13.465),(35.825,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.225),(49.205,18.395),(49.375,18.395),(49.375,18.225),(49.205,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.565),(49.205,18.735),(49.375,18.735),(49.375,18.565),(49.205,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.225),(49.715,18.395),(49.885,18.395),(49.885,18.225),(49.715,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.565),(49.715,18.735),(49.885,18.735),(49.885,18.565),(49.715,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.045),(59.315,9.215),(59.485,9.215),(59.485,9.045),(59.315,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.385),(59.315,9.555),(59.485,9.555),(59.485,9.385),(59.315,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.725),(59.315,9.895),(59.485,9.895),(59.485,9.725),(59.315,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.245),(34.805,19.415),(34.975,19.415),(34.975,19.245),(34.805,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.685),(58.805,7.855),(58.975,7.855),(58.975,7.685),(58.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.345),(58.805,7.515),(58.975,7.515),(58.975,7.345),(58.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.005),(58.805,7.175),(58.975,7.175),(58.975,7.005),(58.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.885),(31.025,18.055),(31.195,18.055),(31.195,17.885),(31.025,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.305),(31.025,5.475),(31.195,5.475),(31.195,5.305),(31.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.645),(31.025,5.815),(31.195,5.815),(31.195,5.645),(31.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.905),(30.515,19.075),(30.685,19.075),(30.685,18.905),(30.515,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.185),(45.425,16.355),(45.595,16.355),(45.595,16.185),(45.425,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.525),(45.425,16.695),(45.595,16.695),(45.595,16.525),(45.425,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.005),(34.805,7.175),(34.975,7.175),(34.975,7.005),(34.805,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.685),(34.805,7.855),(34.975,7.855),(34.975,7.685),(34.805,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.345),(34.805,7.515),(34.975,7.515),(34.975,7.345),(34.805,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.425),(44.915,11.595),(45.085,11.595),(45.085,11.425),(44.915,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.605),(50.225,3.775),(50.395,3.775),(50.395,3.605),(50.225,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.645),(54.005,5.815),(54.175,5.815),(54.175,5.645),(54.005,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.305),(54.005,5.475),(54.175,5.475),(54.175,5.305),(54.005,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.645),(54.515,5.815),(54.685,5.815),(54.685,5.645),(54.515,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.265),(50.225,3.435),(50.395,3.435),(50.395,3.265),(50.225,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.965),(49.205,5.135),(49.375,5.135),(49.375,4.965),(49.205,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.965),(49.715,5.135),(49.885,5.135),(49.885,4.965),(49.715,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.305),(54.515,5.475),(54.685,5.475),(54.685,5.305),(54.515,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.205),(58.805,17.375),(58.975,17.375),(58.975,17.205),(58.805,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.545),(58.805,17.715),(58.975,17.715),(58.975,17.545),(58.805,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.725),(49.715,9.895),(49.885,9.895),(49.885,9.725),(49.715,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.345),(44.915,7.515),(45.085,7.515),(45.085,7.345),(44.915,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.685),(44.915,7.855),(45.085,7.855),(45.085,7.685),(44.915,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.985),(44.405,6.155),(44.575,6.155),(44.575,5.985),(44.405,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.005),(44.915,7.175),(45.085,7.175),(45.085,7.005),(44.915,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.485),(55.025,14.655),(55.195,14.655),(55.195,14.485),(55.025,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.825),(55.025,14.995),(55.195,14.995),(55.195,14.825),(55.025,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.505),(30.515,15.675),(30.685,15.675),(30.685,15.505),(30.515,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.165),(30.515,15.335),(30.685,15.335),(30.685,15.165),(30.515,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.145),(55.025,14.315),(55.195,14.315),(55.195,14.145),(55.025,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.665),(50.225,6.835),(50.395,6.835),(50.395,6.665),(50.225,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.325),(50.225,6.495),(50.395,6.495),(50.395,6.325),(50.225,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.745),(45.425,10.915),(45.595,10.915),(45.595,10.745),(45.425,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.105),(55.025,12.275),(55.195,12.275),(55.195,12.105),(55.025,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.405),(45.425,10.575),(45.595,10.575),(45.595,10.405),(45.425,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.445),(55.025,12.615),(55.195,12.615),(55.195,12.445),(55.025,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.785),(55.025,12.955),(55.195,12.955),(55.195,12.785),(55.025,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.065),(45.425,10.235),(45.595,10.235),(45.595,10.065),(45.425,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.965),(30.515,5.135),(30.685,5.135),(30.685,4.965),(30.515,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.925),(58.805,3.095),(58.975,3.095),(58.975,2.925),(58.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.945),(40.115,4.115),(40.285,4.115),(40.285,3.945),(40.115,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.945),(40.625,4.115),(40.795,4.115),(40.795,3.945),(40.625,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.845),(50.225,16.015),(50.395,16.015),(50.395,15.845),(50.225,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.925),(34.805,3.095),(34.975,3.095),(34.975,2.925),(34.805,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.385),(30.515,9.555),(30.685,9.555),(30.685,9.385),(30.515,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.725),(30.515,9.895),(30.685,9.895),(30.685,9.725),(30.515,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.045),(30.515,9.215),(30.685,9.215),(30.685,9.045),(30.515,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.205),(40.625,17.375),(40.795,17.375),(40.795,17.205),(40.625,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.545),(40.625,17.715),(40.795,17.715),(40.795,17.545),(40.625,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.285),(39.605,4.455),(39.775,4.455),(39.775,4.285),(39.605,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.625),(39.605,4.795),(39.775,4.795),(39.775,4.625),(39.605,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.985),(44.915,6.155),(45.085,6.155),(45.085,5.985),(44.915,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.205),(40.115,17.375),(40.285,17.375),(40.285,17.205),(40.115,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.545),(40.115,17.715),(40.285,17.715),(40.285,17.545),(40.115,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.325),(40.625,6.495),(40.795,6.495),(40.795,6.325),(40.625,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.665),(40.625,6.835),(40.795,6.835),(40.795,6.665),(40.625,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.325),(40.115,6.495),(40.285,6.495),(40.285,6.325),(40.115,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.665),(40.115,6.835),(40.285,6.835),(40.285,6.665),(40.115,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.425),(30.515,11.595),(30.685,11.595),(30.685,11.425),(30.515,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.125),(45.425,13.295),(45.595,13.295),(45.595,13.125),(45.425,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.465),(45.425,13.635),(45.595,13.635),(45.595,13.465),(45.425,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.805),(45.425,13.975),(45.595,13.975),(45.595,13.805),(45.425,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.765),(30.515,11.935),(30.685,11.935),(30.685,11.765),(30.515,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.085),(30.515,11.255),(30.685,11.255),(30.685,11.085),(30.515,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.305),(55.025,5.475),(55.195,5.475),(55.195,5.305),(55.025,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.645),(55.025,5.815),(55.195,5.815),(55.195,5.645),(55.025,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.765),(44.915,11.935),(45.085,11.935),(45.085,11.765),(44.915,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.365),(50.225,8.535),(50.395,8.535),(50.395,8.365),(50.225,8.365)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,2.985),(59.06,19.355),(59.23,19.355),(59.23,2.985),(59.06,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,2.845),(59.06,19.495),(59.23,19.495),(59.23,2.845),(59.06,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((73.58,10.79),(73.58,10.96),(74.11,10.96),(74.11,10.79),(73.58,10.79)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.845),(44.405,19.495),(45.595,19.495),(45.595,2.845),(44.405,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.845),(44.915,19.495),(45.085,19.495),(45.085,2.845),(44.915,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.985),(44.915,19.355),(45.085,19.355),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.845),(54.005,19.495),(55.195,19.495),(55.195,2.845),(54.005,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,20.28),(44.915,20.76),(45.085,20.76),(45.085,20.28),(44.915,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,20.435),(30.77,20.605),(30.94,20.605),(30.94,20.435),(30.77,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,20.28),(30.77,20.76),(30.94,20.76),(30.94,20.28),(30.77,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.845),(39.605,19.495),(40.795,19.495),(40.795,2.845),(39.605,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((73.58,1.735),(73.58,1.905),(74.11,1.905),(74.11,1.735),(73.58,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.845),(30.515,19.495),(31.195,19.495),(31.195,2.845),(30.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.845),(34.805,19.495),(35.995,19.495),(35.995,2.845),(34.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.28),(54.515,20.76),(54.685,20.76),(54.685,20.28),(54.515,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,1.735),(59.06,1.905),(59.23,1.905),(59.23,1.735),(59.06,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,20.28),(35.315,20.76),(35.485,20.76),(35.485,20.28),(35.315,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.985),(40.115,19.355),(40.285,19.355),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.845),(40.115,19.495),(40.285,19.495),(40.285,2.845),(40.115,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,20.28),(49.715,20.76),(49.885,20.76),(49.885,20.28),(49.715,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,20.28),(40.115,20.76),(40.285,20.76),(40.285,20.28),(40.115,20.28)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.985),(54.515,19.355),(54.685,19.355),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.845),(54.515,19.495),(54.685,19.495),(54.685,2.845),(54.515,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.985),(35.315,19.355),(35.485,19.355),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.845),(35.315,19.495),(35.485,19.495),(35.485,2.845),(35.315,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.985),(49.715,19.355),(49.885,19.355),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.845),(49.715,19.495),(49.885,19.495),(49.885,2.845),(49.715,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((73.76,10.71),(73.76,11.04),(73.93,11.04),(73.93,10.71),(73.76,10.71)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,1.58),(59.06,2.06),(59.23,2.06),(59.23,1.58),(59.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.845),(49.205,19.495),(50.395,19.495),(50.395,2.845),(49.205,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,2.985),(30.77,19.355),(30.94,19.355),(30.94,2.985),(30.77,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,2.845),(30.77,19.495),(30.94,19.495),(30.94,2.845),(30.77,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,1.735),(30.77,1.905),(30.94,1.905),(30.94,1.735),(30.77,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,1.58),(30.77,2.06),(30.94,2.06),(30.94,1.58),(30.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.845),(58.805,19.495),(59.485,19.495),(59.485,2.845),(58.805,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,20.435),(59.06,20.605),(59.23,20.605),(59.23,20.435),(59.06,20.435)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,20.28),(59.06,20.76),(59.23,20.76),(59.23,20.28),(59.06,20.28)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.985),(49.715,3.155),(49.885,3.155),(49.885,2.985),(49.715,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.345),(49.715,3.515),(49.885,3.515),(49.885,3.345),(49.715,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.705),(49.715,3.875),(49.885,3.875),(49.885,3.705),(49.715,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.065),(49.715,4.235),(49.885,4.235),(49.885,4.065),(49.715,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.425),(49.715,4.595),(49.885,4.595),(49.885,4.425),(49.715,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.785),(49.715,4.955),(49.885,4.955),(49.885,4.785),(49.715,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.145),(49.715,5.315),(49.885,5.315),(49.885,5.145),(49.715,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.505),(49.715,5.675),(49.885,5.675),(49.885,5.505),(49.715,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.865),(49.715,6.035),(49.885,6.035),(49.885,5.865),(49.715,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.225),(49.715,6.395),(49.885,6.395),(49.885,6.225),(49.715,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.585),(49.715,6.755),(49.885,6.755),(49.885,6.585),(49.715,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.305),(49.715,7.475),(49.885,7.475),(49.885,7.305),(49.715,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.665),(49.715,7.835),(49.885,7.835),(49.885,7.665),(49.715,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.025),(49.715,8.195),(49.885,8.195),(49.885,8.025),(49.715,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.385),(49.715,8.555),(49.885,8.555),(49.885,8.385),(49.715,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.745),(49.715,8.915),(49.885,8.915),(49.885,8.745),(49.715,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.105),(49.715,9.275),(49.885,9.275),(49.885,9.105),(49.715,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.465),(49.715,9.635),(49.885,9.635),(49.885,9.465),(49.715,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.825),(49.715,9.995),(49.885,9.995),(49.885,9.825),(49.715,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.185),(49.715,10.355),(49.885,10.355),(49.885,10.185),(49.715,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.545),(49.715,10.715),(49.885,10.715),(49.885,10.545),(49.715,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.905),(49.715,11.075),(49.885,11.075),(49.885,10.905),(49.715,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.265),(49.715,11.435),(49.885,11.435),(49.885,11.265),(49.715,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.625),(49.715,11.795),(49.885,11.795),(49.885,11.625),(49.715,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.985),(49.715,12.155),(49.885,12.155),(49.885,11.985),(49.715,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.345),(49.715,12.515),(49.885,12.515),(49.885,12.345),(49.715,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.705),(49.715,12.875),(49.885,12.875),(49.885,12.705),(49.715,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.425),(49.715,13.595),(49.885,13.595),(49.885,13.425),(49.715,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.785),(49.715,13.955),(49.885,13.955),(49.885,13.785),(49.715,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.145),(49.715,14.315),(49.885,14.315),(49.885,14.145),(49.715,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.505),(49.715,14.675),(49.885,14.675),(49.885,14.505),(49.715,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.865),(49.715,15.035),(49.885,15.035),(49.885,14.865),(49.715,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.225),(49.715,15.395),(49.885,15.395),(49.885,15.225),(49.715,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.585),(49.715,15.755),(49.885,15.755),(49.885,15.585),(49.715,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.945),(49.715,16.115),(49.885,16.115),(49.885,15.945),(49.715,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.305),(49.715,16.475),(49.885,16.475),(49.885,16.305),(49.715,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.665),(49.715,16.835),(49.885,16.835),(49.885,16.665),(49.715,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.025),(49.715,17.195),(49.885,17.195),(49.885,17.025),(49.715,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.385),(49.715,17.555),(49.885,17.555),(49.885,17.385),(49.715,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.745),(49.715,17.915),(49.885,17.915),(49.885,17.745),(49.715,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.105),(49.715,18.275),(49.885,18.275),(49.885,18.105),(49.715,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.465),(49.715,18.635),(49.885,18.635),(49.885,18.465),(49.715,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.825),(49.715,18.995),(49.885,18.995),(49.885,18.825),(49.715,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.435),(44.915,20.605),(45.085,20.605),(45.085,20.435),(44.915,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,20.435),(30.77,20.605),(30.94,20.605),(30.94,20.435),(30.77,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.985),(44.915,3.155),(45.085,3.155),(45.085,2.985),(44.915,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.345),(44.915,3.515),(45.085,3.515),(45.085,3.345),(44.915,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.705),(44.915,3.875),(45.085,3.875),(45.085,3.705),(44.915,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.065),(44.915,4.235),(45.085,4.235),(45.085,4.065),(44.915,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.425),(44.915,4.595),(45.085,4.595),(45.085,4.425),(44.915,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.785),(44.915,4.955),(45.085,4.955),(45.085,4.785),(44.915,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.145),(44.915,5.315),(45.085,5.315),(45.085,5.145),(44.915,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.505),(44.915,5.675),(45.085,5.675),(45.085,5.505),(44.915,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.865),(44.915,6.035),(45.085,6.035),(45.085,5.865),(44.915,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.225),(44.915,6.395),(45.085,6.395),(45.085,6.225),(44.915,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.585),(44.915,6.755),(45.085,6.755),(45.085,6.585),(44.915,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.305),(44.915,7.475),(45.085,7.475),(45.085,7.305),(44.915,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.665),(44.915,7.835),(45.085,7.835),(45.085,7.665),(44.915,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.025),(44.915,8.195),(45.085,8.195),(45.085,8.025),(44.915,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.385),(44.915,8.555),(45.085,8.555),(45.085,8.385),(44.915,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.745),(44.915,8.915),(45.085,8.915),(45.085,8.745),(44.915,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.105),(44.915,9.275),(45.085,9.275),(45.085,9.105),(44.915,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.465),(44.915,9.635),(45.085,9.635),(45.085,9.465),(44.915,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.825),(44.915,9.995),(45.085,9.995),(45.085,9.825),(44.915,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.185),(44.915,10.355),(45.085,10.355),(45.085,10.185),(44.915,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.545),(44.915,10.715),(45.085,10.715),(45.085,10.545),(44.915,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.905),(44.915,11.075),(45.085,11.075),(45.085,10.905),(44.915,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.265),(44.915,11.435),(45.085,11.435),(45.085,11.265),(44.915,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.625),(44.915,11.795),(45.085,11.795),(45.085,11.625),(44.915,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.985),(44.915,12.155),(45.085,12.155),(45.085,11.985),(44.915,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.345),(44.915,12.515),(45.085,12.515),(45.085,12.345),(44.915,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.705),(44.915,12.875),(45.085,12.875),(45.085,12.705),(44.915,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.425),(44.915,13.595),(45.085,13.595),(45.085,13.425),(44.915,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.785),(44.915,13.955),(45.085,13.955),(45.085,13.785),(44.915,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.145),(44.915,14.315),(45.085,14.315),(45.085,14.145),(44.915,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.505),(44.915,14.675),(45.085,14.675),(45.085,14.505),(44.915,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.865),(44.915,15.035),(45.085,15.035),(45.085,14.865),(44.915,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.225),(44.915,15.395),(45.085,15.395),(45.085,15.225),(44.915,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.585),(44.915,15.755),(45.085,15.755),(45.085,15.585),(44.915,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.945),(44.915,16.115),(45.085,16.115),(45.085,15.945),(44.915,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.305),(44.915,16.475),(45.085,16.475),(45.085,16.305),(44.915,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.665),(44.915,16.835),(45.085,16.835),(45.085,16.665),(44.915,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.025),(44.915,17.195),(45.085,17.195),(45.085,17.025),(44.915,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.385),(44.915,17.555),(45.085,17.555),(45.085,17.385),(44.915,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.745),(44.915,17.915),(45.085,17.915),(45.085,17.745),(44.915,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.105),(44.915,18.275),(45.085,18.275),(45.085,18.105),(44.915,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.465),(44.915,18.635),(45.085,18.635),(45.085,18.465),(44.915,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.825),(44.915,18.995),(45.085,18.995),(45.085,18.825),(44.915,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.58,10.79),(73.58,10.96),(73.75,10.96),(73.75,10.79),(73.58,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.94,10.79),(73.94,10.96),(74.11,10.96),(74.11,10.79),(73.94,10.79)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.435),(54.515,20.605),(54.685,20.605),(54.685,20.435),(54.515,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,1.735),(59.06,1.905),(59.23,1.905),(59.23,1.735),(59.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.435),(35.315,20.605),(35.485,20.605),(35.485,20.435),(35.315,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.435),(40.115,20.605),(40.285,20.605),(40.285,20.435),(40.115,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.435),(49.715,20.605),(49.885,20.605),(49.885,20.435),(49.715,20.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.58,1.735),(73.58,1.905),(73.75,1.905),(73.75,1.735),(73.58,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.94,1.735),(73.94,1.905),(74.11,1.905),(74.11,1.735),(73.94,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.985),(54.515,3.155),(54.685,3.155),(54.685,2.985),(54.515,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.345),(54.515,3.515),(54.685,3.515),(54.685,3.345),(54.515,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.705),(54.515,3.875),(54.685,3.875),(54.685,3.705),(54.515,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.065),(54.515,4.235),(54.685,4.235),(54.685,4.065),(54.515,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.425),(54.515,4.595),(54.685,4.595),(54.685,4.425),(54.515,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.785),(54.515,4.955),(54.685,4.955),(54.685,4.785),(54.515,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.145),(54.515,5.315),(54.685,5.315),(54.685,5.145),(54.515,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.505),(54.515,5.675),(54.685,5.675),(54.685,5.505),(54.515,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.865),(54.515,6.035),(54.685,6.035),(54.685,5.865),(54.515,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.225),(54.515,6.395),(54.685,6.395),(54.685,6.225),(54.515,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.585),(54.515,6.755),(54.685,6.755),(54.685,6.585),(54.515,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.305),(54.515,7.475),(54.685,7.475),(54.685,7.305),(54.515,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.665),(54.515,7.835),(54.685,7.835),(54.685,7.665),(54.515,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.025),(54.515,8.195),(54.685,8.195),(54.685,8.025),(54.515,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.385),(54.515,8.555),(54.685,8.555),(54.685,8.385),(54.515,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.745),(54.515,8.915),(54.685,8.915),(54.685,8.745),(54.515,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.105),(54.515,9.275),(54.685,9.275),(54.685,9.105),(54.515,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.465),(54.515,9.635),(54.685,9.635),(54.685,9.465),(54.515,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.825),(54.515,9.995),(54.685,9.995),(54.685,9.825),(54.515,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.185),(54.515,10.355),(54.685,10.355),(54.685,10.185),(54.515,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.545),(54.515,10.715),(54.685,10.715),(54.685,10.545),(54.515,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.905),(54.515,11.075),(54.685,11.075),(54.685,10.905),(54.515,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.265),(54.515,11.435),(54.685,11.435),(54.685,11.265),(54.515,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.625),(54.515,11.795),(54.685,11.795),(54.685,11.625),(54.515,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.985),(54.515,12.155),(54.685,12.155),(54.685,11.985),(54.515,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.345),(54.515,12.515),(54.685,12.515),(54.685,12.345),(54.515,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.705),(54.515,12.875),(54.685,12.875),(54.685,12.705),(54.515,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.425),(54.515,13.595),(54.685,13.595),(54.685,13.425),(54.515,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.785),(54.515,13.955),(54.685,13.955),(54.685,13.785),(54.515,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.145),(54.515,14.315),(54.685,14.315),(54.685,14.145),(54.515,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.505),(54.515,14.675),(54.685,14.675),(54.685,14.505),(54.515,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.865),(54.515,15.035),(54.685,15.035),(54.685,14.865),(54.515,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.225),(54.515,15.395),(54.685,15.395),(54.685,15.225),(54.515,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.585),(54.515,15.755),(54.685,15.755),(54.685,15.585),(54.515,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.945),(54.515,16.115),(54.685,16.115),(54.685,15.945),(54.515,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.305),(54.515,16.475),(54.685,16.475),(54.685,16.305),(54.515,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.665),(54.515,16.835),(54.685,16.835),(54.685,16.665),(54.515,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.025),(54.515,17.195),(54.685,17.195),(54.685,17.025),(54.515,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.385),(54.515,17.555),(54.685,17.555),(54.685,17.385),(54.515,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.745),(54.515,17.915),(54.685,17.915),(54.685,17.745),(54.515,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.105),(54.515,18.275),(54.685,18.275),(54.685,18.105),(54.515,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.465),(54.515,18.635),(54.685,18.635),(54.685,18.465),(54.515,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.825),(54.515,18.995),(54.685,18.995),(54.685,18.825),(54.515,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,2.985),(30.77,3.155),(30.94,3.155),(30.94,2.985),(30.77,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,3.345),(30.77,3.515),(30.94,3.515),(30.94,3.345),(30.77,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,3.705),(30.77,3.875),(30.94,3.875),(30.94,3.705),(30.77,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,4.065),(30.77,4.235),(30.94,4.235),(30.94,4.065),(30.77,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,4.425),(30.77,4.595),(30.94,4.595),(30.94,4.425),(30.77,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,4.785),(30.77,4.955),(30.94,4.955),(30.94,4.785),(30.77,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,5.145),(30.77,5.315),(30.94,5.315),(30.94,5.145),(30.77,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,5.505),(30.77,5.675),(30.94,5.675),(30.94,5.505),(30.77,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,5.865),(30.77,6.035),(30.94,6.035),(30.94,5.865),(30.77,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,6.225),(30.77,6.395),(30.94,6.395),(30.94,6.225),(30.77,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,6.585),(30.77,6.755),(30.94,6.755),(30.94,6.585),(30.77,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,6.945),(30.77,7.115),(30.94,7.115),(30.94,6.945),(30.77,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,7.305),(30.77,7.475),(30.94,7.475),(30.94,7.305),(30.77,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,7.665),(30.77,7.835),(30.94,7.835),(30.94,7.665),(30.77,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,8.025),(30.77,8.195),(30.94,8.195),(30.94,8.025),(30.77,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,8.385),(30.77,8.555),(30.94,8.555),(30.94,8.385),(30.77,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,8.745),(30.77,8.915),(30.94,8.915),(30.94,8.745),(30.77,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,9.105),(30.77,9.275),(30.94,9.275),(30.94,9.105),(30.77,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,9.465),(30.77,9.635),(30.94,9.635),(30.94,9.465),(30.77,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,9.825),(30.77,9.995),(30.94,9.995),(30.94,9.825),(30.77,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,10.185),(30.77,10.355),(30.94,10.355),(30.94,10.185),(30.77,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,10.545),(30.77,10.715),(30.94,10.715),(30.94,10.545),(30.77,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,10.905),(30.77,11.075),(30.94,11.075),(30.94,10.905),(30.77,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,11.265),(30.77,11.435),(30.94,11.435),(30.94,11.265),(30.77,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,11.625),(30.77,11.795),(30.94,11.795),(30.94,11.625),(30.77,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,11.985),(30.77,12.155),(30.94,12.155),(30.94,11.985),(30.77,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,12.345),(30.77,12.515),(30.94,12.515),(30.94,12.345),(30.77,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,12.705),(30.77,12.875),(30.94,12.875),(30.94,12.705),(30.77,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,13.065),(30.77,13.235),(30.94,13.235),(30.94,13.065),(30.77,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,13.425),(30.77,13.595),(30.94,13.595),(30.94,13.425),(30.77,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,13.785),(30.77,13.955),(30.94,13.955),(30.94,13.785),(30.77,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,14.145),(30.77,14.315),(30.94,14.315),(30.94,14.145),(30.77,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,14.505),(30.77,14.675),(30.94,14.675),(30.94,14.505),(30.77,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,14.865),(30.77,15.035),(30.94,15.035),(30.94,14.865),(30.77,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,15.225),(30.77,15.395),(30.94,15.395),(30.94,15.225),(30.77,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,15.585),(30.77,15.755),(30.94,15.755),(30.94,15.585),(30.77,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,15.945),(30.77,16.115),(30.94,16.115),(30.94,15.945),(30.77,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,16.305),(30.77,16.475),(30.94,16.475),(30.94,16.305),(30.77,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,16.665),(30.77,16.835),(30.94,16.835),(30.94,16.665),(30.77,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,17.025),(30.77,17.195),(30.94,17.195),(30.94,17.025),(30.77,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,17.385),(30.77,17.555),(30.94,17.555),(30.94,17.385),(30.77,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,17.745),(30.77,17.915),(30.94,17.915),(30.94,17.745),(30.77,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,18.105),(30.77,18.275),(30.94,18.275),(30.94,18.105),(30.77,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,18.465),(30.77,18.635),(30.94,18.635),(30.94,18.465),(30.77,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,18.825),(30.77,18.995),(30.94,18.995),(30.94,18.825),(30.77,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,19.185),(30.77,19.355),(30.94,19.355),(30.94,19.185),(30.77,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,1.735),(30.77,1.905),(30.94,1.905),(30.94,1.735),(30.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,2.985),(59.06,3.155),(59.23,3.155),(59.23,2.985),(59.06,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,3.345),(59.06,3.515),(59.23,3.515),(59.23,3.345),(59.06,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,3.705),(59.06,3.875),(59.23,3.875),(59.23,3.705),(59.06,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,4.065),(59.06,4.235),(59.23,4.235),(59.23,4.065),(59.06,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,4.425),(59.06,4.595),(59.23,4.595),(59.23,4.425),(59.06,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,4.785),(59.06,4.955),(59.23,4.955),(59.23,4.785),(59.06,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,5.145),(59.06,5.315),(59.23,5.315),(59.23,5.145),(59.06,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,5.505),(59.06,5.675),(59.23,5.675),(59.23,5.505),(59.06,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,5.865),(59.06,6.035),(59.23,6.035),(59.23,5.865),(59.06,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,6.225),(59.06,6.395),(59.23,6.395),(59.23,6.225),(59.06,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,6.585),(59.06,6.755),(59.23,6.755),(59.23,6.585),(59.06,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,6.945),(59.06,7.115),(59.23,7.115),(59.23,6.945),(59.06,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,7.305),(59.06,7.475),(59.23,7.475),(59.23,7.305),(59.06,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,7.665),(59.06,7.835),(59.23,7.835),(59.23,7.665),(59.06,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,8.025),(59.06,8.195),(59.23,8.195),(59.23,8.025),(59.06,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,8.385),(59.06,8.555),(59.23,8.555),(59.23,8.385),(59.06,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,8.745),(59.06,8.915),(59.23,8.915),(59.23,8.745),(59.06,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,9.105),(59.06,9.275),(59.23,9.275),(59.23,9.105),(59.06,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,9.465),(59.06,9.635),(59.23,9.635),(59.23,9.465),(59.06,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,9.825),(59.06,9.995),(59.23,9.995),(59.23,9.825),(59.06,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,10.185),(59.06,10.355),(59.23,10.355),(59.23,10.185),(59.06,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,10.545),(59.06,10.715),(59.23,10.715),(59.23,10.545),(59.06,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,10.905),(59.06,11.075),(59.23,11.075),(59.23,10.905),(59.06,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,11.265),(59.06,11.435),(59.23,11.435),(59.23,11.265),(59.06,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,11.625),(59.06,11.795),(59.23,11.795),(59.23,11.625),(59.06,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,11.985),(59.06,12.155),(59.23,12.155),(59.23,11.985),(59.06,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,12.345),(59.06,12.515),(59.23,12.515),(59.23,12.345),(59.06,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,12.705),(59.06,12.875),(59.23,12.875),(59.23,12.705),(59.06,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,13.065),(59.06,13.235),(59.23,13.235),(59.23,13.065),(59.06,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,13.425),(59.06,13.595),(59.23,13.595),(59.23,13.425),(59.06,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,13.785),(59.06,13.955),(59.23,13.955),(59.23,13.785),(59.06,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,14.145),(59.06,14.315),(59.23,14.315),(59.23,14.145),(59.06,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,14.505),(59.06,14.675),(59.23,14.675),(59.23,14.505),(59.06,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,14.865),(59.06,15.035),(59.23,15.035),(59.23,14.865),(59.06,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,15.225),(59.06,15.395),(59.23,15.395),(59.23,15.225),(59.06,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,15.585),(59.06,15.755),(59.23,15.755),(59.23,15.585),(59.06,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,15.945),(59.06,16.115),(59.23,16.115),(59.23,15.945),(59.06,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,16.305),(59.06,16.475),(59.23,16.475),(59.23,16.305),(59.06,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,16.665),(59.06,16.835),(59.23,16.835),(59.23,16.665),(59.06,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,17.025),(59.06,17.195),(59.23,17.195),(59.23,17.025),(59.06,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,17.385),(59.06,17.555),(59.23,17.555),(59.23,17.385),(59.06,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,17.745),(59.06,17.915),(59.23,17.915),(59.23,17.745),(59.06,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,18.105),(59.06,18.275),(59.23,18.275),(59.23,18.105),(59.06,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,18.465),(59.06,18.635),(59.23,18.635),(59.23,18.465),(59.06,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,18.825),(59.06,18.995),(59.23,18.995),(59.23,18.825),(59.06,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,19.185),(59.06,19.355),(59.23,19.355),(59.23,19.185),(59.06,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.985),(40.115,3.155),(40.285,3.155),(40.285,2.985),(40.115,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.345),(40.115,3.515),(40.285,3.515),(40.285,3.345),(40.115,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.705),(40.115,3.875),(40.285,3.875),(40.285,3.705),(40.115,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.065),(40.115,4.235),(40.285,4.235),(40.285,4.065),(40.115,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.425),(40.115,4.595),(40.285,4.595),(40.285,4.425),(40.115,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.785),(40.115,4.955),(40.285,4.955),(40.285,4.785),(40.115,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.145),(40.115,5.315),(40.285,5.315),(40.285,5.145),(40.115,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.505),(40.115,5.675),(40.285,5.675),(40.285,5.505),(40.115,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.865),(40.115,6.035),(40.285,6.035),(40.285,5.865),(40.115,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.225),(40.115,6.395),(40.285,6.395),(40.285,6.225),(40.115,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.585),(40.115,6.755),(40.285,6.755),(40.285,6.585),(40.115,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.305),(40.115,7.475),(40.285,7.475),(40.285,7.305),(40.115,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.665),(40.115,7.835),(40.285,7.835),(40.285,7.665),(40.115,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.025),(40.115,8.195),(40.285,8.195),(40.285,8.025),(40.115,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.385),(40.115,8.555),(40.285,8.555),(40.285,8.385),(40.115,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.745),(40.115,8.915),(40.285,8.915),(40.285,8.745),(40.115,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.105),(40.115,9.275),(40.285,9.275),(40.285,9.105),(40.115,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.465),(40.115,9.635),(40.285,9.635),(40.285,9.465),(40.115,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.825),(40.115,9.995),(40.285,9.995),(40.285,9.825),(40.115,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.185),(40.115,10.355),(40.285,10.355),(40.285,10.185),(40.115,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.545),(40.115,10.715),(40.285,10.715),(40.285,10.545),(40.115,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.905),(40.115,11.075),(40.285,11.075),(40.285,10.905),(40.115,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.265),(40.115,11.435),(40.285,11.435),(40.285,11.265),(40.115,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.625),(40.115,11.795),(40.285,11.795),(40.285,11.625),(40.115,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.985),(40.115,12.155),(40.285,12.155),(40.285,11.985),(40.115,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.345),(40.115,12.515),(40.285,12.515),(40.285,12.345),(40.115,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.705),(40.115,12.875),(40.285,12.875),(40.285,12.705),(40.115,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.425),(40.115,13.595),(40.285,13.595),(40.285,13.425),(40.115,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.785),(40.115,13.955),(40.285,13.955),(40.285,13.785),(40.115,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.145),(40.115,14.315),(40.285,14.315),(40.285,14.145),(40.115,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.505),(40.115,14.675),(40.285,14.675),(40.285,14.505),(40.115,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.865),(40.115,15.035),(40.285,15.035),(40.285,14.865),(40.115,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.225),(40.115,15.395),(40.285,15.395),(40.285,15.225),(40.115,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.585),(40.115,15.755),(40.285,15.755),(40.285,15.585),(40.115,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.945),(40.115,16.115),(40.285,16.115),(40.285,15.945),(40.115,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.305),(40.115,16.475),(40.285,16.475),(40.285,16.305),(40.115,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.665),(40.115,16.835),(40.285,16.835),(40.285,16.665),(40.115,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.025),(40.115,17.195),(40.285,17.195),(40.285,17.025),(40.115,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.385),(40.115,17.555),(40.285,17.555),(40.285,17.385),(40.115,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.745),(40.115,17.915),(40.285,17.915),(40.285,17.745),(40.115,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.105),(40.115,18.275),(40.285,18.275),(40.285,18.105),(40.115,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.465),(40.115,18.635),(40.285,18.635),(40.285,18.465),(40.115,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.825),(40.115,18.995),(40.285,18.995),(40.285,18.825),(40.115,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.985),(35.315,3.155),(35.485,3.155),(35.485,2.985),(35.315,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.345),(35.315,3.515),(35.485,3.515),(35.485,3.345),(35.315,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.705),(35.315,3.875),(35.485,3.875),(35.485,3.705),(35.315,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.065),(35.315,4.235),(35.485,4.235),(35.485,4.065),(35.315,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.425),(35.315,4.595),(35.485,4.595),(35.485,4.425),(35.315,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.785),(35.315,4.955),(35.485,4.955),(35.485,4.785),(35.315,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.145),(35.315,5.315),(35.485,5.315),(35.485,5.145),(35.315,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.505),(35.315,5.675),(35.485,5.675),(35.485,5.505),(35.315,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.865),(35.315,6.035),(35.485,6.035),(35.485,5.865),(35.315,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.225),(35.315,6.395),(35.485,6.395),(35.485,6.225),(35.315,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.585),(35.315,6.755),(35.485,6.755),(35.485,6.585),(35.315,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.305),(35.315,7.475),(35.485,7.475),(35.485,7.305),(35.315,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.665),(35.315,7.835),(35.485,7.835),(35.485,7.665),(35.315,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.025),(35.315,8.195),(35.485,8.195),(35.485,8.025),(35.315,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.385),(35.315,8.555),(35.485,8.555),(35.485,8.385),(35.315,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.745),(35.315,8.915),(35.485,8.915),(35.485,8.745),(35.315,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.105),(35.315,9.275),(35.485,9.275),(35.485,9.105),(35.315,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.465),(35.315,9.635),(35.485,9.635),(35.485,9.465),(35.315,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.825),(35.315,9.995),(35.485,9.995),(35.485,9.825),(35.315,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.185),(35.315,10.355),(35.485,10.355),(35.485,10.185),(35.315,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.545),(35.315,10.715),(35.485,10.715),(35.485,10.545),(35.315,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.905),(35.315,11.075),(35.485,11.075),(35.485,10.905),(35.315,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.265),(35.315,11.435),(35.485,11.435),(35.485,11.265),(35.315,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.625),(35.315,11.795),(35.485,11.795),(35.485,11.625),(35.315,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.985),(35.315,12.155),(35.485,12.155),(35.485,11.985),(35.315,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.345),(35.315,12.515),(35.485,12.515),(35.485,12.345),(35.315,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.705),(35.315,12.875),(35.485,12.875),(35.485,12.705),(35.315,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.425),(35.315,13.595),(35.485,13.595),(35.485,13.425),(35.315,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.785),(35.315,13.955),(35.485,13.955),(35.485,13.785),(35.315,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.145),(35.315,14.315),(35.485,14.315),(35.485,14.145),(35.315,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.505),(35.315,14.675),(35.485,14.675),(35.485,14.505),(35.315,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.865),(35.315,15.035),(35.485,15.035),(35.485,14.865),(35.315,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.225),(35.315,15.395),(35.485,15.395),(35.485,15.225),(35.315,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.585),(35.315,15.755),(35.485,15.755),(35.485,15.585),(35.315,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.945),(35.315,16.115),(35.485,16.115),(35.485,15.945),(35.315,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.305),(35.315,16.475),(35.485,16.475),(35.485,16.305),(35.315,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.665),(35.315,16.835),(35.485,16.835),(35.485,16.665),(35.315,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.025),(35.315,17.195),(35.485,17.195),(35.485,17.025),(35.315,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.385),(35.315,17.555),(35.485,17.555),(35.485,17.385),(35.315,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.745),(35.315,17.915),(35.485,17.915),(35.485,17.745),(35.315,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.105),(35.315,18.275),(35.485,18.275),(35.485,18.105),(35.315,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.465),(35.315,18.635),(35.485,18.635),(35.485,18.465),(35.315,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.825),(35.315,18.995),(35.485,18.995),(35.485,18.825),(35.315,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,20.435),(59.06,20.605),(59.23,20.605),(59.23,20.435),(59.06,20.435)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,2.925),(59.03,19.415),(59.26,19.415),(59.26,2.925),(59.03,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,1.675),(40.085,1.965),(40.315,1.965),(40.315,1.675),(40.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,2.925),(44.885,19.415),(45.115,19.415),(45.115,2.925),(44.885,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,1.675),(49.685,1.965),(49.915,1.965),(49.915,1.675),(49.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,20.375),(44.885,20.665),(45.115,20.665),(45.115,20.375),(44.885,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,20.375),(30.74,20.665),(30.97,20.665),(30.97,20.375),(30.74,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,1.675),(73.55,11.02),(74.14,11.02),(74.14,1.675),(73.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,1.675),(73.55,1.965),(74.14,1.965),(74.14,1.675),(73.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,20.375),(54.485,20.665),(54.715,20.665),(54.715,20.375),(54.485,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,1.675),(59.03,1.965),(59.26,1.965),(59.26,1.675),(59.03,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,22.34),(49.93,22.34),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,0.0),(49.685,22.34),(49.915,22.34),(49.915,0.0),(49.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,22.34),(45.13,22.34),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,0.0),(44.885,22.34),(45.115,22.34),(45.115,0.0),(44.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,10.73),(73.55,11.02),(74.14,11.02),(74.14,10.73),(73.55,10.73)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,20.375),(35.285,20.665),(35.515,20.665),(35.515,20.375),(35.285,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,0.0),(54.485,22.34),(54.715,22.34),(54.715,0.0),(54.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,1.675),(54.485,1.965),(54.715,1.965),(54.715,1.675),(54.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,22.34),(54.73,22.34),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,2.925),(40.085,19.415),(40.315,19.415),(40.315,2.925),(40.085,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,20.375),(40.085,20.665),(40.315,20.665),(40.315,20.375),(40.085,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,20.375),(49.685,20.665),(49.915,20.665),(49.915,20.375),(49.685,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,2.925),(54.485,19.415),(54.715,19.415),(54.715,2.925),(54.485,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,0.0),(59.03,22.34),(59.26,22.34),(59.26,0.0),(59.03,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,2.925),(35.285,19.415),(35.515,19.415),(35.515,2.925),(35.285,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,0.0),(59.015,22.34),(59.275,22.34),(59.275,0.0),(59.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,0.13),(59.015,22.21),(59.275,22.21),(59.275,0.13),(59.015,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,0.0),(30.74,22.34),(30.97,22.34),(30.97,0.0),(30.74,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,0.13),(30.725,22.21),(30.985,22.21),(30.985,0.13),(30.725,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,0.0),(30.725,22.34),(30.985,22.34),(30.985,0.0),(30.725,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,2.925),(49.685,19.415),(49.915,19.415),(49.915,2.925),(49.685,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,2.925),(30.74,19.415),(30.97,19.415),(30.97,2.925),(30.74,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,0.0),(40.085,22.34),(40.315,22.34),(40.315,0.0),(40.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,22.34),(40.33,22.34),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,1.675),(44.885,1.965),(45.115,1.965),(45.115,1.675),(44.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,1.675),(30.74,1.965),(30.97,1.965),(30.97,1.675),(30.74,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,1.675),(35.285,1.965),(35.515,1.965),(35.515,1.675),(35.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,20.375),(59.03,20.665),(59.26,20.665),(59.26,20.375),(59.03,20.375)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,22.34),(35.53,22.34),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,0.0),(35.285,22.34),(35.515,22.34),(35.515,0.0),(35.285,0.0)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,0.215),(30.78,0.365),(30.93,0.365),(30.93,0.215),(30.78,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,0.535),(30.78,0.685),(30.93,0.685),(30.93,0.535),(30.78,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,0.855),(30.78,1.005),(30.93,1.005),(30.93,0.855),(30.78,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,1.175),(30.78,1.325),(30.93,1.325),(30.93,1.175),(30.78,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,1.495),(30.78,1.645),(30.93,1.645),(30.93,1.495),(30.78,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,1.815),(30.78,1.965),(30.93,1.965),(30.93,1.815),(30.78,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,2.135),(30.78,2.285),(30.93,2.285),(30.93,2.135),(30.78,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,2.455),(30.78,2.605),(30.93,2.605),(30.93,2.455),(30.78,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,2.775),(30.78,2.925),(30.93,2.925),(30.93,2.775),(30.78,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.095),(30.78,3.245),(30.93,3.245),(30.93,3.095),(30.78,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.415),(30.78,3.565),(30.93,3.565),(30.93,3.415),(30.78,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.735),(30.78,3.885),(30.93,3.885),(30.93,3.735),(30.78,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,4.055),(30.78,4.205),(30.93,4.205),(30.93,4.055),(30.78,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,4.375),(30.78,4.525),(30.93,4.525),(30.93,4.375),(30.78,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,4.695),(30.78,4.845),(30.93,4.845),(30.93,4.695),(30.78,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.015),(30.78,5.165),(30.93,5.165),(30.93,5.015),(30.78,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.335),(30.78,5.485),(30.93,5.485),(30.93,5.335),(30.78,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.655),(30.78,5.805),(30.93,5.805),(30.93,5.655),(30.78,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.975),(30.78,6.125),(30.93,6.125),(30.93,5.975),(30.78,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,6.295),(30.78,6.445),(30.93,6.445),(30.93,6.295),(30.78,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,6.615),(30.78,6.765),(30.93,6.765),(30.93,6.615),(30.78,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,6.935),(30.78,7.085),(30.93,7.085),(30.93,6.935),(30.78,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,7.255),(30.78,7.405),(30.93,7.405),(30.93,7.255),(30.78,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,7.575),(30.78,7.725),(30.93,7.725),(30.93,7.575),(30.78,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,7.895),(30.78,8.045),(30.93,8.045),(30.93,7.895),(30.78,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,8.215),(30.78,8.365),(30.93,8.365),(30.93,8.215),(30.78,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,8.535),(30.78,8.685),(30.93,8.685),(30.93,8.535),(30.78,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,8.855),(30.78,9.005),(30.93,9.005),(30.93,8.855),(30.78,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,9.175),(30.78,9.325),(30.93,9.325),(30.93,9.175),(30.78,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,9.495),(30.78,9.645),(30.93,9.645),(30.93,9.495),(30.78,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,9.815),(30.78,9.965),(30.93,9.965),(30.93,9.815),(30.78,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,10.135),(30.78,10.285),(30.93,10.285),(30.93,10.135),(30.78,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,10.455),(30.78,10.605),(30.93,10.605),(30.93,10.455),(30.78,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,10.775),(30.78,10.925),(30.93,10.925),(30.93,10.775),(30.78,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.095),(30.78,11.245),(30.93,11.245),(30.93,11.095),(30.78,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.415),(30.78,11.565),(30.93,11.565),(30.93,11.415),(30.78,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.735),(30.78,11.885),(30.93,11.885),(30.93,11.735),(30.78,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,12.055),(30.78,12.205),(30.93,12.205),(30.93,12.055),(30.78,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,12.375),(30.78,12.525),(30.93,12.525),(30.93,12.375),(30.78,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,12.695),(30.78,12.845),(30.93,12.845),(30.93,12.695),(30.78,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.015),(30.78,13.165),(30.93,13.165),(30.93,13.015),(30.78,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.335),(30.78,13.485),(30.93,13.485),(30.93,13.335),(30.78,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.655),(30.78,13.805),(30.93,13.805),(30.93,13.655),(30.78,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.975),(30.78,14.125),(30.93,14.125),(30.93,13.975),(30.78,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,14.295),(30.78,14.445),(30.93,14.445),(30.93,14.295),(30.78,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,14.615),(30.78,14.765),(30.93,14.765),(30.93,14.615),(30.78,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,14.935),(30.78,15.085),(30.93,15.085),(30.93,14.935),(30.78,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,15.255),(30.78,15.405),(30.93,15.405),(30.93,15.255),(30.78,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,15.575),(30.78,15.725),(30.93,15.725),(30.93,15.575),(30.78,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,15.895),(30.78,16.045),(30.93,16.045),(30.93,15.895),(30.78,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,16.215),(30.78,16.365),(30.93,16.365),(30.93,16.215),(30.78,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,16.535),(30.78,16.685),(30.93,16.685),(30.93,16.535),(30.78,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,16.855),(30.78,17.005),(30.93,17.005),(30.93,16.855),(30.78,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,17.175),(30.78,17.325),(30.93,17.325),(30.93,17.175),(30.78,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,17.495),(30.78,17.645),(30.93,17.645),(30.93,17.495),(30.78,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,17.815),(30.78,17.965),(30.93,17.965),(30.93,17.815),(30.78,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,18.135),(30.78,18.285),(30.93,18.285),(30.93,18.135),(30.78,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,18.455),(30.78,18.605),(30.93,18.605),(30.93,18.455),(30.78,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,18.775),(30.78,18.925),(30.93,18.925),(30.93,18.775),(30.78,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.095),(30.78,19.245),(30.93,19.245),(30.93,19.095),(30.78,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.415),(30.78,19.565),(30.93,19.565),(30.93,19.415),(30.78,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.735),(30.78,19.885),(30.93,19.885),(30.93,19.735),(30.78,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,20.055),(30.78,20.205),(30.93,20.205),(30.93,20.055),(30.78,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,20.375),(30.78,20.525),(30.93,20.525),(30.93,20.375),(30.78,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,20.695),(30.78,20.845),(30.93,20.845),(30.93,20.695),(30.78,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.015),(30.78,21.165),(30.93,21.165),(30.93,21.015),(30.78,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.335),(30.78,21.485),(30.93,21.485),(30.93,21.335),(30.78,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.655),(30.78,21.805),(30.93,21.805),(30.93,21.655),(30.78,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.975),(30.78,22.125),(30.93,22.125),(30.93,21.975),(30.78,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.215),(35.325,0.365),(35.475,0.365),(35.475,0.215),(35.325,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.535),(35.325,0.685),(35.475,0.685),(35.475,0.535),(35.325,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.855),(35.325,1.005),(35.475,1.005),(35.475,0.855),(35.325,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.175),(35.325,1.325),(35.475,1.325),(35.475,1.175),(35.325,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.495),(35.325,1.645),(35.475,1.645),(35.475,1.495),(35.325,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.815),(35.325,1.965),(35.475,1.965),(35.475,1.815),(35.325,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.135),(35.325,2.285),(35.475,2.285),(35.475,2.135),(35.325,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.455),(35.325,2.605),(35.475,2.605),(35.475,2.455),(35.325,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.775),(35.325,2.925),(35.475,2.925),(35.475,2.775),(35.325,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.095),(35.325,3.245),(35.475,3.245),(35.475,3.095),(35.325,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.415),(35.325,3.565),(35.475,3.565),(35.475,3.415),(35.325,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.735),(35.325,3.885),(35.475,3.885),(35.475,3.735),(35.325,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.055),(35.325,4.205),(35.475,4.205),(35.475,4.055),(35.325,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.375),(35.325,4.525),(35.475,4.525),(35.475,4.375),(35.325,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.695),(35.325,4.845),(35.475,4.845),(35.475,4.695),(35.325,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.015),(35.325,5.165),(35.475,5.165),(35.475,5.015),(35.325,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.335),(35.325,5.485),(35.475,5.485),(35.475,5.335),(35.325,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.655),(35.325,5.805),(35.475,5.805),(35.475,5.655),(35.325,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.975),(35.325,6.125),(35.475,6.125),(35.475,5.975),(35.325,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.295),(35.325,6.445),(35.475,6.445),(35.475,6.295),(35.325,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.615),(35.325,6.765),(35.475,6.765),(35.475,6.615),(35.325,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.935),(35.325,7.085),(35.475,7.085),(35.475,6.935),(35.325,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.255),(35.325,7.405),(35.475,7.405),(35.475,7.255),(35.325,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.575),(35.325,7.725),(35.475,7.725),(35.475,7.575),(35.325,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.895),(35.325,8.045),(35.475,8.045),(35.475,7.895),(35.325,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.215),(35.325,8.365),(35.475,8.365),(35.475,8.215),(35.325,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.535),(35.325,8.685),(35.475,8.685),(35.475,8.535),(35.325,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.855),(35.325,9.005),(35.475,9.005),(35.475,8.855),(35.325,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.175),(35.325,9.325),(35.475,9.325),(35.475,9.175),(35.325,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.495),(35.325,9.645),(35.475,9.645),(35.475,9.495),(35.325,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.815),(35.325,9.965),(35.475,9.965),(35.475,9.815),(35.325,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.135),(35.325,10.285),(35.475,10.285),(35.475,10.135),(35.325,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.455),(35.325,10.605),(35.475,10.605),(35.475,10.455),(35.325,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.775),(35.325,10.925),(35.475,10.925),(35.475,10.775),(35.325,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.095),(35.325,11.245),(35.475,11.245),(35.475,11.095),(35.325,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.415),(35.325,11.565),(35.475,11.565),(35.475,11.415),(35.325,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.735),(35.325,11.885),(35.475,11.885),(35.475,11.735),(35.325,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.055),(35.325,12.205),(35.475,12.205),(35.475,12.055),(35.325,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.375),(35.325,12.525),(35.475,12.525),(35.475,12.375),(35.325,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.695),(35.325,12.845),(35.475,12.845),(35.475,12.695),(35.325,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.015),(35.325,13.165),(35.475,13.165),(35.475,13.015),(35.325,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.335),(35.325,13.485),(35.475,13.485),(35.475,13.335),(35.325,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.655),(35.325,13.805),(35.475,13.805),(35.475,13.655),(35.325,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.975),(35.325,14.125),(35.475,14.125),(35.475,13.975),(35.325,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.295),(35.325,14.445),(35.475,14.445),(35.475,14.295),(35.325,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.615),(35.325,14.765),(35.475,14.765),(35.475,14.615),(35.325,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.935),(35.325,15.085),(35.475,15.085),(35.475,14.935),(35.325,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.255),(35.325,15.405),(35.475,15.405),(35.475,15.255),(35.325,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.575),(35.325,15.725),(35.475,15.725),(35.475,15.575),(35.325,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.895),(35.325,16.045),(35.475,16.045),(35.475,15.895),(35.325,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.215),(35.325,16.365),(35.475,16.365),(35.475,16.215),(35.325,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.535),(35.325,16.685),(35.475,16.685),(35.475,16.535),(35.325,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.855),(35.325,17.005),(35.475,17.005),(35.475,16.855),(35.325,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.175),(35.325,17.325),(35.475,17.325),(35.475,17.175),(35.325,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.495),(35.325,17.645),(35.475,17.645),(35.475,17.495),(35.325,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.815),(35.325,17.965),(35.475,17.965),(35.475,17.815),(35.325,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.135),(35.325,18.285),(35.475,18.285),(35.475,18.135),(35.325,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.455),(35.325,18.605),(35.475,18.605),(35.475,18.455),(35.325,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.775),(35.325,18.925),(35.475,18.925),(35.475,18.775),(35.325,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.095),(35.325,19.245),(35.475,19.245),(35.475,19.095),(35.325,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.415),(35.325,19.565),(35.475,19.565),(35.475,19.415),(35.325,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.735),(35.325,19.885),(35.475,19.885),(35.475,19.735),(35.325,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.055),(35.325,20.205),(35.475,20.205),(35.475,20.055),(35.325,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.375),(35.325,20.525),(35.475,20.525),(35.475,20.375),(35.325,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.695),(35.325,20.845),(35.475,20.845),(35.475,20.695),(35.325,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.015),(35.325,21.165),(35.475,21.165),(35.475,21.015),(35.325,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.335),(35.325,21.485),(35.475,21.485),(35.475,21.335),(35.325,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.655),(35.325,21.805),(35.475,21.805),(35.475,21.655),(35.325,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.975),(35.325,22.125),(35.475,22.125),(35.475,21.975),(35.325,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.215),(49.725,0.365),(49.875,0.365),(49.875,0.215),(49.725,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.535),(49.725,0.685),(49.875,0.685),(49.875,0.535),(49.725,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.855),(49.725,1.005),(49.875,1.005),(49.875,0.855),(49.725,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.175),(49.725,1.325),(49.875,1.325),(49.875,1.175),(49.725,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.495),(49.725,1.645),(49.875,1.645),(49.875,1.495),(49.725,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.815),(49.725,1.965),(49.875,1.965),(49.875,1.815),(49.725,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.135),(49.725,2.285),(49.875,2.285),(49.875,2.135),(49.725,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.455),(49.725,2.605),(49.875,2.605),(49.875,2.455),(49.725,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.775),(49.725,2.925),(49.875,2.925),(49.875,2.775),(49.725,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.095),(49.725,3.245),(49.875,3.245),(49.875,3.095),(49.725,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.415),(49.725,3.565),(49.875,3.565),(49.875,3.415),(49.725,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.735),(49.725,3.885),(49.875,3.885),(49.875,3.735),(49.725,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.055),(49.725,4.205),(49.875,4.205),(49.875,4.055),(49.725,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.375),(49.725,4.525),(49.875,4.525),(49.875,4.375),(49.725,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.695),(49.725,4.845),(49.875,4.845),(49.875,4.695),(49.725,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.015),(49.725,5.165),(49.875,5.165),(49.875,5.015),(49.725,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.335),(49.725,5.485),(49.875,5.485),(49.875,5.335),(49.725,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.655),(49.725,5.805),(49.875,5.805),(49.875,5.655),(49.725,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.975),(49.725,6.125),(49.875,6.125),(49.875,5.975),(49.725,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.295),(49.725,6.445),(49.875,6.445),(49.875,6.295),(49.725,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.615),(49.725,6.765),(49.875,6.765),(49.875,6.615),(49.725,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.935),(49.725,7.085),(49.875,7.085),(49.875,6.935),(49.725,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.255),(49.725,7.405),(49.875,7.405),(49.875,7.255),(49.725,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.575),(49.725,7.725),(49.875,7.725),(49.875,7.575),(49.725,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.895),(49.725,8.045),(49.875,8.045),(49.875,7.895),(49.725,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.215),(49.725,8.365),(49.875,8.365),(49.875,8.215),(49.725,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.535),(49.725,8.685),(49.875,8.685),(49.875,8.535),(49.725,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.855),(49.725,9.005),(49.875,9.005),(49.875,8.855),(49.725,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.175),(49.725,9.325),(49.875,9.325),(49.875,9.175),(49.725,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.495),(49.725,9.645),(49.875,9.645),(49.875,9.495),(49.725,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.815),(49.725,9.965),(49.875,9.965),(49.875,9.815),(49.725,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.135),(49.725,10.285),(49.875,10.285),(49.875,10.135),(49.725,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.455),(49.725,10.605),(49.875,10.605),(49.875,10.455),(49.725,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.775),(49.725,10.925),(49.875,10.925),(49.875,10.775),(49.725,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.095),(49.725,11.245),(49.875,11.245),(49.875,11.095),(49.725,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.415),(49.725,11.565),(49.875,11.565),(49.875,11.415),(49.725,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.735),(49.725,11.885),(49.875,11.885),(49.875,11.735),(49.725,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.055),(49.725,12.205),(49.875,12.205),(49.875,12.055),(49.725,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.375),(49.725,12.525),(49.875,12.525),(49.875,12.375),(49.725,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.695),(49.725,12.845),(49.875,12.845),(49.875,12.695),(49.725,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.015),(49.725,13.165),(49.875,13.165),(49.875,13.015),(49.725,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.335),(49.725,13.485),(49.875,13.485),(49.875,13.335),(49.725,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.655),(49.725,13.805),(49.875,13.805),(49.875,13.655),(49.725,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.975),(49.725,14.125),(49.875,14.125),(49.875,13.975),(49.725,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.295),(49.725,14.445),(49.875,14.445),(49.875,14.295),(49.725,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.615),(49.725,14.765),(49.875,14.765),(49.875,14.615),(49.725,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.935),(49.725,15.085),(49.875,15.085),(49.875,14.935),(49.725,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.255),(49.725,15.405),(49.875,15.405),(49.875,15.255),(49.725,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.575),(49.725,15.725),(49.875,15.725),(49.875,15.575),(49.725,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.895),(49.725,16.045),(49.875,16.045),(49.875,15.895),(49.725,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.215),(49.725,16.365),(49.875,16.365),(49.875,16.215),(49.725,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.535),(49.725,16.685),(49.875,16.685),(49.875,16.535),(49.725,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.855),(49.725,17.005),(49.875,17.005),(49.875,16.855),(49.725,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.175),(49.725,17.325),(49.875,17.325),(49.875,17.175),(49.725,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.495),(49.725,17.645),(49.875,17.645),(49.875,17.495),(49.725,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.815),(49.725,17.965),(49.875,17.965),(49.875,17.815),(49.725,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.135),(49.725,18.285),(49.875,18.285),(49.875,18.135),(49.725,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.455),(49.725,18.605),(49.875,18.605),(49.875,18.455),(49.725,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.775),(49.725,18.925),(49.875,18.925),(49.875,18.775),(49.725,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.095),(49.725,19.245),(49.875,19.245),(49.875,19.095),(49.725,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.415),(49.725,19.565),(49.875,19.565),(49.875,19.415),(49.725,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.735),(49.725,19.885),(49.875,19.885),(49.875,19.735),(49.725,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.055),(49.725,20.205),(49.875,20.205),(49.875,20.055),(49.725,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.375),(49.725,20.525),(49.875,20.525),(49.875,20.375),(49.725,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.695),(49.725,20.845),(49.875,20.845),(49.875,20.695),(49.725,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.015),(49.725,21.165),(49.875,21.165),(49.875,21.015),(49.725,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.335),(49.725,21.485),(49.875,21.485),(49.875,21.335),(49.725,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.655),(49.725,21.805),(49.875,21.805),(49.875,21.655),(49.725,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.975),(49.725,22.125),(49.875,22.125),(49.875,21.975),(49.725,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,0.215),(59.07,0.365),(59.22,0.365),(59.22,0.215),(59.07,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,0.535),(59.07,0.685),(59.22,0.685),(59.22,0.535),(59.07,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,0.855),(59.07,1.005),(59.22,1.005),(59.22,0.855),(59.07,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,1.175),(59.07,1.325),(59.22,1.325),(59.22,1.175),(59.07,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,1.495),(59.07,1.645),(59.22,1.645),(59.22,1.495),(59.07,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,1.815),(59.07,1.965),(59.22,1.965),(59.22,1.815),(59.07,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,2.135),(59.07,2.285),(59.22,2.285),(59.22,2.135),(59.07,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,2.455),(59.07,2.605),(59.22,2.605),(59.22,2.455),(59.07,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,2.775),(59.07,2.925),(59.22,2.925),(59.22,2.775),(59.07,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.095),(59.07,3.245),(59.22,3.245),(59.22,3.095),(59.07,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.415),(59.07,3.565),(59.22,3.565),(59.22,3.415),(59.07,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.735),(59.07,3.885),(59.22,3.885),(59.22,3.735),(59.07,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,4.055),(59.07,4.205),(59.22,4.205),(59.22,4.055),(59.07,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,4.375),(59.07,4.525),(59.22,4.525),(59.22,4.375),(59.07,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,4.695),(59.07,4.845),(59.22,4.845),(59.22,4.695),(59.07,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.015),(59.07,5.165),(59.22,5.165),(59.22,5.015),(59.07,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.335),(59.07,5.485),(59.22,5.485),(59.22,5.335),(59.07,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.655),(59.07,5.805),(59.22,5.805),(59.22,5.655),(59.07,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.975),(59.07,6.125),(59.22,6.125),(59.22,5.975),(59.07,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,6.295),(59.07,6.445),(59.22,6.445),(59.22,6.295),(59.07,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,6.615),(59.07,6.765),(59.22,6.765),(59.22,6.615),(59.07,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,6.935),(59.07,7.085),(59.22,7.085),(59.22,6.935),(59.07,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,7.255),(59.07,7.405),(59.22,7.405),(59.22,7.255),(59.07,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,7.575),(59.07,7.725),(59.22,7.725),(59.22,7.575),(59.07,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,7.895),(59.07,8.045),(59.22,8.045),(59.22,7.895),(59.07,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,8.215),(59.07,8.365),(59.22,8.365),(59.22,8.215),(59.07,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,8.535),(59.07,8.685),(59.22,8.685),(59.22,8.535),(59.07,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,8.855),(59.07,9.005),(59.22,9.005),(59.22,8.855),(59.07,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,9.175),(59.07,9.325),(59.22,9.325),(59.22,9.175),(59.07,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,9.495),(59.07,9.645),(59.22,9.645),(59.22,9.495),(59.07,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,9.815),(59.07,9.965),(59.22,9.965),(59.22,9.815),(59.07,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,10.135),(59.07,10.285),(59.22,10.285),(59.22,10.135),(59.07,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,10.455),(59.07,10.605),(59.22,10.605),(59.22,10.455),(59.07,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,10.775),(59.07,10.925),(59.22,10.925),(59.22,10.775),(59.07,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.095),(59.07,11.245),(59.22,11.245),(59.22,11.095),(59.07,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.415),(59.07,11.565),(59.22,11.565),(59.22,11.415),(59.07,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.735),(59.07,11.885),(59.22,11.885),(59.22,11.735),(59.07,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,12.055),(59.07,12.205),(59.22,12.205),(59.22,12.055),(59.07,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,12.375),(59.07,12.525),(59.22,12.525),(59.22,12.375),(59.07,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,12.695),(59.07,12.845),(59.22,12.845),(59.22,12.695),(59.07,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.015),(59.07,13.165),(59.22,13.165),(59.22,13.015),(59.07,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.335),(59.07,13.485),(59.22,13.485),(59.22,13.335),(59.07,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.655),(59.07,13.805),(59.22,13.805),(59.22,13.655),(59.07,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.975),(59.07,14.125),(59.22,14.125),(59.22,13.975),(59.07,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,14.295),(59.07,14.445),(59.22,14.445),(59.22,14.295),(59.07,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,14.615),(59.07,14.765),(59.22,14.765),(59.22,14.615),(59.07,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,14.935),(59.07,15.085),(59.22,15.085),(59.22,14.935),(59.07,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,15.255),(59.07,15.405),(59.22,15.405),(59.22,15.255),(59.07,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,15.575),(59.07,15.725),(59.22,15.725),(59.22,15.575),(59.07,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,15.895),(59.07,16.045),(59.22,16.045),(59.22,15.895),(59.07,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,16.215),(59.07,16.365),(59.22,16.365),(59.22,16.215),(59.07,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,16.535),(59.07,16.685),(59.22,16.685),(59.22,16.535),(59.07,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,16.855),(59.07,17.005),(59.22,17.005),(59.22,16.855),(59.07,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,17.175),(59.07,17.325),(59.22,17.325),(59.22,17.175),(59.07,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,17.495),(59.07,17.645),(59.22,17.645),(59.22,17.495),(59.07,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,17.815),(59.07,17.965),(59.22,17.965),(59.22,17.815),(59.07,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,18.135),(59.07,18.285),(59.22,18.285),(59.22,18.135),(59.07,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,18.455),(59.07,18.605),(59.22,18.605),(59.22,18.455),(59.07,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,18.775),(59.07,18.925),(59.22,18.925),(59.22,18.775),(59.07,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.095),(59.07,19.245),(59.22,19.245),(59.22,19.095),(59.07,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.415),(59.07,19.565),(59.22,19.565),(59.22,19.415),(59.07,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.735),(59.07,19.885),(59.22,19.885),(59.22,19.735),(59.07,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,20.055),(59.07,20.205),(59.22,20.205),(59.22,20.055),(59.07,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,20.375),(59.07,20.525),(59.22,20.525),(59.22,20.375),(59.07,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,20.695),(59.07,20.845),(59.22,20.845),(59.22,20.695),(59.07,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.015),(59.07,21.165),(59.22,21.165),(59.22,21.015),(59.07,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.335),(59.07,21.485),(59.22,21.485),(59.22,21.335),(59.07,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.655),(59.07,21.805),(59.22,21.805),(59.22,21.655),(59.07,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.975),(59.07,22.125),(59.22,22.125),(59.22,21.975),(59.07,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.215),(40.125,0.365),(40.275,0.365),(40.275,0.215),(40.125,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.535),(40.125,0.685),(40.275,0.685),(40.275,0.535),(40.125,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.855),(40.125,1.005),(40.275,1.005),(40.275,0.855),(40.125,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.175),(40.125,1.325),(40.275,1.325),(40.275,1.175),(40.125,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.495),(40.125,1.645),(40.275,1.645),(40.275,1.495),(40.125,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.815),(40.125,1.965),(40.275,1.965),(40.275,1.815),(40.125,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.135),(40.125,2.285),(40.275,2.285),(40.275,2.135),(40.125,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.455),(40.125,2.605),(40.275,2.605),(40.275,2.455),(40.125,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.775),(40.125,2.925),(40.275,2.925),(40.275,2.775),(40.125,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.095),(40.125,3.245),(40.275,3.245),(40.275,3.095),(40.125,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.415),(40.125,3.565),(40.275,3.565),(40.275,3.415),(40.125,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.735),(40.125,3.885),(40.275,3.885),(40.275,3.735),(40.125,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.055),(40.125,4.205),(40.275,4.205),(40.275,4.055),(40.125,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.375),(40.125,4.525),(40.275,4.525),(40.275,4.375),(40.125,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.695),(40.125,4.845),(40.275,4.845),(40.275,4.695),(40.125,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.015),(40.125,5.165),(40.275,5.165),(40.275,5.015),(40.125,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.335),(40.125,5.485),(40.275,5.485),(40.275,5.335),(40.125,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.655),(40.125,5.805),(40.275,5.805),(40.275,5.655),(40.125,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.975),(40.125,6.125),(40.275,6.125),(40.275,5.975),(40.125,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.295),(40.125,6.445),(40.275,6.445),(40.275,6.295),(40.125,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.615),(40.125,6.765),(40.275,6.765),(40.275,6.615),(40.125,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.935),(40.125,7.085),(40.275,7.085),(40.275,6.935),(40.125,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.255),(40.125,7.405),(40.275,7.405),(40.275,7.255),(40.125,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.575),(40.125,7.725),(40.275,7.725),(40.275,7.575),(40.125,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.895),(40.125,8.045),(40.275,8.045),(40.275,7.895),(40.125,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.215),(40.125,8.365),(40.275,8.365),(40.275,8.215),(40.125,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.535),(40.125,8.685),(40.275,8.685),(40.275,8.535),(40.125,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.855),(40.125,9.005),(40.275,9.005),(40.275,8.855),(40.125,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.175),(40.125,9.325),(40.275,9.325),(40.275,9.175),(40.125,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.495),(40.125,9.645),(40.275,9.645),(40.275,9.495),(40.125,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.815),(40.125,9.965),(40.275,9.965),(40.275,9.815),(40.125,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.135),(40.125,10.285),(40.275,10.285),(40.275,10.135),(40.125,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.455),(40.125,10.605),(40.275,10.605),(40.275,10.455),(40.125,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.775),(40.125,10.925),(40.275,10.925),(40.275,10.775),(40.125,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.095),(40.125,11.245),(40.275,11.245),(40.275,11.095),(40.125,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.415),(40.125,11.565),(40.275,11.565),(40.275,11.415),(40.125,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.735),(40.125,11.885),(40.275,11.885),(40.275,11.735),(40.125,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.055),(40.125,12.205),(40.275,12.205),(40.275,12.055),(40.125,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.375),(40.125,12.525),(40.275,12.525),(40.275,12.375),(40.125,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.695),(40.125,12.845),(40.275,12.845),(40.275,12.695),(40.125,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.015),(40.125,13.165),(40.275,13.165),(40.275,13.015),(40.125,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.335),(40.125,13.485),(40.275,13.485),(40.275,13.335),(40.125,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.655),(40.125,13.805),(40.275,13.805),(40.275,13.655),(40.125,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.975),(40.125,14.125),(40.275,14.125),(40.275,13.975),(40.125,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.295),(40.125,14.445),(40.275,14.445),(40.275,14.295),(40.125,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.615),(40.125,14.765),(40.275,14.765),(40.275,14.615),(40.125,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.935),(40.125,15.085),(40.275,15.085),(40.275,14.935),(40.125,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.255),(40.125,15.405),(40.275,15.405),(40.275,15.255),(40.125,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.575),(40.125,15.725),(40.275,15.725),(40.275,15.575),(40.125,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.895),(40.125,16.045),(40.275,16.045),(40.275,15.895),(40.125,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.215),(40.125,16.365),(40.275,16.365),(40.275,16.215),(40.125,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.535),(40.125,16.685),(40.275,16.685),(40.275,16.535),(40.125,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.855),(40.125,17.005),(40.275,17.005),(40.275,16.855),(40.125,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.175),(40.125,17.325),(40.275,17.325),(40.275,17.175),(40.125,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.495),(40.125,17.645),(40.275,17.645),(40.275,17.495),(40.125,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.815),(40.125,17.965),(40.275,17.965),(40.275,17.815),(40.125,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.135),(40.125,18.285),(40.275,18.285),(40.275,18.135),(40.125,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.455),(40.125,18.605),(40.275,18.605),(40.275,18.455),(40.125,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.775),(40.125,18.925),(40.275,18.925),(40.275,18.775),(40.125,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.095),(40.125,19.245),(40.275,19.245),(40.275,19.095),(40.125,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.415),(40.125,19.565),(40.275,19.565),(40.275,19.415),(40.125,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.735),(40.125,19.885),(40.275,19.885),(40.275,19.735),(40.125,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.055),(40.125,20.205),(40.275,20.205),(40.275,20.055),(40.125,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.375),(40.125,20.525),(40.275,20.525),(40.275,20.375),(40.125,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.695),(40.125,20.845),(40.275,20.845),(40.275,20.695),(40.125,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.015),(40.125,21.165),(40.275,21.165),(40.275,21.015),(40.125,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.335),(40.125,21.485),(40.275,21.485),(40.275,21.335),(40.125,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.655),(40.125,21.805),(40.275,21.805),(40.275,21.655),(40.125,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.975),(40.125,22.125),(40.275,22.125),(40.275,21.975),(40.125,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.215),(44.925,0.365),(45.075,0.365),(45.075,0.215),(44.925,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.535),(44.925,0.685),(45.075,0.685),(45.075,0.535),(44.925,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.855),(44.925,1.005),(45.075,1.005),(45.075,0.855),(44.925,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.175),(44.925,1.325),(45.075,1.325),(45.075,1.175),(44.925,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.495),(44.925,1.645),(45.075,1.645),(45.075,1.495),(44.925,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.815),(44.925,1.965),(45.075,1.965),(45.075,1.815),(44.925,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.135),(44.925,2.285),(45.075,2.285),(45.075,2.135),(44.925,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.455),(44.925,2.605),(45.075,2.605),(45.075,2.455),(44.925,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.775),(44.925,2.925),(45.075,2.925),(45.075,2.775),(44.925,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.095),(44.925,3.245),(45.075,3.245),(45.075,3.095),(44.925,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.415),(44.925,3.565),(45.075,3.565),(45.075,3.415),(44.925,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.735),(44.925,3.885),(45.075,3.885),(45.075,3.735),(44.925,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.055),(44.925,4.205),(45.075,4.205),(45.075,4.055),(44.925,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.375),(44.925,4.525),(45.075,4.525),(45.075,4.375),(44.925,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.695),(44.925,4.845),(45.075,4.845),(45.075,4.695),(44.925,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.015),(44.925,5.165),(45.075,5.165),(45.075,5.015),(44.925,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.335),(44.925,5.485),(45.075,5.485),(45.075,5.335),(44.925,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.655),(44.925,5.805),(45.075,5.805),(45.075,5.655),(44.925,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.975),(44.925,6.125),(45.075,6.125),(45.075,5.975),(44.925,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.295),(44.925,6.445),(45.075,6.445),(45.075,6.295),(44.925,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.615),(44.925,6.765),(45.075,6.765),(45.075,6.615),(44.925,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.935),(44.925,7.085),(45.075,7.085),(45.075,6.935),(44.925,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.255),(44.925,7.405),(45.075,7.405),(45.075,7.255),(44.925,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.575),(44.925,7.725),(45.075,7.725),(45.075,7.575),(44.925,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.895),(44.925,8.045),(45.075,8.045),(45.075,7.895),(44.925,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.215),(44.925,8.365),(45.075,8.365),(45.075,8.215),(44.925,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.535),(44.925,8.685),(45.075,8.685),(45.075,8.535),(44.925,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.855),(44.925,9.005),(45.075,9.005),(45.075,8.855),(44.925,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.175),(44.925,9.325),(45.075,9.325),(45.075,9.175),(44.925,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.495),(44.925,9.645),(45.075,9.645),(45.075,9.495),(44.925,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.815),(44.925,9.965),(45.075,9.965),(45.075,9.815),(44.925,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.135),(44.925,10.285),(45.075,10.285),(45.075,10.135),(44.925,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.455),(44.925,10.605),(45.075,10.605),(45.075,10.455),(44.925,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.775),(44.925,10.925),(45.075,10.925),(45.075,10.775),(44.925,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.095),(44.925,11.245),(45.075,11.245),(45.075,11.095),(44.925,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.415),(44.925,11.565),(45.075,11.565),(45.075,11.415),(44.925,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.735),(44.925,11.885),(45.075,11.885),(45.075,11.735),(44.925,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.055),(44.925,12.205),(45.075,12.205),(45.075,12.055),(44.925,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.375),(44.925,12.525),(45.075,12.525),(45.075,12.375),(44.925,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.695),(44.925,12.845),(45.075,12.845),(45.075,12.695),(44.925,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.015),(44.925,13.165),(45.075,13.165),(45.075,13.015),(44.925,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.335),(44.925,13.485),(45.075,13.485),(45.075,13.335),(44.925,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.655),(44.925,13.805),(45.075,13.805),(45.075,13.655),(44.925,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.975),(44.925,14.125),(45.075,14.125),(45.075,13.975),(44.925,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.295),(44.925,14.445),(45.075,14.445),(45.075,14.295),(44.925,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.615),(44.925,14.765),(45.075,14.765),(45.075,14.615),(44.925,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.935),(44.925,15.085),(45.075,15.085),(45.075,14.935),(44.925,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.255),(44.925,15.405),(45.075,15.405),(45.075,15.255),(44.925,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.575),(44.925,15.725),(45.075,15.725),(45.075,15.575),(44.925,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.895),(44.925,16.045),(45.075,16.045),(45.075,15.895),(44.925,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.215),(44.925,16.365),(45.075,16.365),(45.075,16.215),(44.925,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.535),(44.925,16.685),(45.075,16.685),(45.075,16.535),(44.925,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.855),(44.925,17.005),(45.075,17.005),(45.075,16.855),(44.925,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.175),(44.925,17.325),(45.075,17.325),(45.075,17.175),(44.925,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.495),(44.925,17.645),(45.075,17.645),(45.075,17.495),(44.925,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.815),(44.925,17.965),(45.075,17.965),(45.075,17.815),(44.925,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.135),(44.925,18.285),(45.075,18.285),(45.075,18.135),(44.925,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.455),(44.925,18.605),(45.075,18.605),(45.075,18.455),(44.925,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.775),(44.925,18.925),(45.075,18.925),(45.075,18.775),(44.925,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.095),(44.925,19.245),(45.075,19.245),(45.075,19.095),(44.925,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.415),(44.925,19.565),(45.075,19.565),(45.075,19.415),(44.925,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.735),(44.925,19.885),(45.075,19.885),(45.075,19.735),(44.925,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.055),(44.925,20.205),(45.075,20.205),(45.075,20.055),(44.925,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.375),(44.925,20.525),(45.075,20.525),(45.075,20.375),(44.925,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.695),(44.925,20.845),(45.075,20.845),(45.075,20.695),(44.925,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.015),(44.925,21.165),(45.075,21.165),(45.075,21.015),(44.925,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.335),(44.925,21.485),(45.075,21.485),(45.075,21.335),(44.925,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.655),(44.925,21.805),(45.075,21.805),(45.075,21.655),(44.925,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.975),(44.925,22.125),(45.075,22.125),(45.075,21.975),(44.925,21.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.215),(54.525,0.365),(54.675,0.365),(54.675,0.215),(54.525,0.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.535),(54.525,0.685),(54.675,0.685),(54.675,0.535),(54.525,0.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.855),(54.525,1.005),(54.675,1.005),(54.675,0.855),(54.525,0.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.175),(54.525,1.325),(54.675,1.325),(54.675,1.175),(54.525,1.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.495),(54.525,1.645),(54.675,1.645),(54.675,1.495),(54.525,1.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.815),(54.525,1.965),(54.675,1.965),(54.675,1.815),(54.525,1.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.135),(54.525,2.285),(54.675,2.285),(54.675,2.135),(54.525,2.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.455),(54.525,2.605),(54.675,2.605),(54.675,2.455),(54.525,2.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.775),(54.525,2.925),(54.675,2.925),(54.675,2.775),(54.525,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.095),(54.525,3.245),(54.675,3.245),(54.675,3.095),(54.525,3.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.415),(54.525,3.565),(54.675,3.565),(54.675,3.415),(54.525,3.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.735),(54.525,3.885),(54.675,3.885),(54.675,3.735),(54.525,3.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.055),(54.525,4.205),(54.675,4.205),(54.675,4.055),(54.525,4.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.375),(54.525,4.525),(54.675,4.525),(54.675,4.375),(54.525,4.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.695),(54.525,4.845),(54.675,4.845),(54.675,4.695),(54.525,4.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.015),(54.525,5.165),(54.675,5.165),(54.675,5.015),(54.525,5.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.335),(54.525,5.485),(54.675,5.485),(54.675,5.335),(54.525,5.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.655),(54.525,5.805),(54.675,5.805),(54.675,5.655),(54.525,5.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.975),(54.525,6.125),(54.675,6.125),(54.675,5.975),(54.525,5.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.295),(54.525,6.445),(54.675,6.445),(54.675,6.295),(54.525,6.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.615),(54.525,6.765),(54.675,6.765),(54.675,6.615),(54.525,6.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.935),(54.525,7.085),(54.675,7.085),(54.675,6.935),(54.525,6.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.255),(54.525,7.405),(54.675,7.405),(54.675,7.255),(54.525,7.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.575),(54.525,7.725),(54.675,7.725),(54.675,7.575),(54.525,7.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.895),(54.525,8.045),(54.675,8.045),(54.675,7.895),(54.525,7.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.215),(54.525,8.365),(54.675,8.365),(54.675,8.215),(54.525,8.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.535),(54.525,8.685),(54.675,8.685),(54.675,8.535),(54.525,8.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.855),(54.525,9.005),(54.675,9.005),(54.675,8.855),(54.525,8.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.175),(54.525,9.325),(54.675,9.325),(54.675,9.175),(54.525,9.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.495),(54.525,9.645),(54.675,9.645),(54.675,9.495),(54.525,9.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.815),(54.525,9.965),(54.675,9.965),(54.675,9.815),(54.525,9.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.135),(54.525,10.285),(54.675,10.285),(54.675,10.135),(54.525,10.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.455),(54.525,10.605),(54.675,10.605),(54.675,10.455),(54.525,10.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.775),(54.525,10.925),(54.675,10.925),(54.675,10.775),(54.525,10.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.095),(54.525,11.245),(54.675,11.245),(54.675,11.095),(54.525,11.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.415),(54.525,11.565),(54.675,11.565),(54.675,11.415),(54.525,11.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.735),(54.525,11.885),(54.675,11.885),(54.675,11.735),(54.525,11.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.055),(54.525,12.205),(54.675,12.205),(54.675,12.055),(54.525,12.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.375),(54.525,12.525),(54.675,12.525),(54.675,12.375),(54.525,12.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.695),(54.525,12.845),(54.675,12.845),(54.675,12.695),(54.525,12.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.015),(54.525,13.165),(54.675,13.165),(54.675,13.015),(54.525,13.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.335),(54.525,13.485),(54.675,13.485),(54.675,13.335),(54.525,13.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.655),(54.525,13.805),(54.675,13.805),(54.675,13.655),(54.525,13.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.975),(54.525,14.125),(54.675,14.125),(54.675,13.975),(54.525,13.975)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.295),(54.525,14.445),(54.675,14.445),(54.675,14.295),(54.525,14.295)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.615),(54.525,14.765),(54.675,14.765),(54.675,14.615),(54.525,14.615)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.935),(54.525,15.085),(54.675,15.085),(54.675,14.935),(54.525,14.935)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.255),(54.525,15.405),(54.675,15.405),(54.675,15.255),(54.525,15.255)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.575),(54.525,15.725),(54.675,15.725),(54.675,15.575),(54.525,15.575)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.895),(54.525,16.045),(54.675,16.045),(54.675,15.895),(54.525,15.895)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.215),(54.525,16.365),(54.675,16.365),(54.675,16.215),(54.525,16.215)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.535),(54.525,16.685),(54.675,16.685),(54.675,16.535),(54.525,16.535)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.855),(54.525,17.005),(54.675,17.005),(54.675,16.855),(54.525,16.855)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.175),(54.525,17.325),(54.675,17.325),(54.675,17.175),(54.525,17.175)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.495),(54.525,17.645),(54.675,17.645),(54.675,17.495),(54.525,17.495)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.815),(54.525,17.965),(54.675,17.965),(54.675,17.815),(54.525,17.815)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.135),(54.525,18.285),(54.675,18.285),(54.675,18.135),(54.525,18.135)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.455),(54.525,18.605),(54.675,18.605),(54.675,18.455),(54.525,18.455)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.775),(54.525,18.925),(54.675,18.925),(54.675,18.775),(54.525,18.775)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.095),(54.525,19.245),(54.675,19.245),(54.675,19.095),(54.525,19.095)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.415),(54.525,19.565),(54.675,19.565),(54.675,19.415),(54.525,19.415)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.735),(54.525,19.885),(54.675,19.885),(54.675,19.735),(54.525,19.735)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.055),(54.525,20.205),(54.675,20.205),(54.675,20.055),(54.525,20.055)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.375),(54.525,20.525),(54.675,20.525),(54.675,20.375),(54.525,20.375)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.695),(54.525,20.845),(54.675,20.845),(54.675,20.695),(54.525,20.695)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.015),(54.525,21.165),(54.675,21.165),(54.675,21.015),(54.525,21.015)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.335),(54.525,21.485),(54.675,21.485),(54.675,21.335),(54.525,21.335)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.655),(54.525,21.805),(54.675,21.805),(54.675,21.655),(54.525,21.655)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.975),(54.525,22.125),(54.675,22.125),(54.675,21.975),(54.525,21.975)),
        )
        createRL(
            tech, net, 'm2',
            ((30.725,0.13),(30.725,22.21),(30.985,22.21),(30.985,0.13),(30.725,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.13),(49.67,22.21),(49.93,22.21),(49.93,0.13),(49.67,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.13),(44.87,22.21),(45.13,22.21),(45.13,0.13),(44.87,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.13),(54.47,22.21),(54.73,22.21),(54.73,0.13),(54.47,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.13),(35.27,22.21),(35.53,22.21),(35.53,0.13),(35.27,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.13),(40.07,22.21),(40.33,22.21),(40.33,0.13),(40.07,0.13)),
        )
        createRL(
            tech, net, 'm2',
            ((59.015,0.13),(59.015,22.21),(59.275,22.21),(59.275,0.13),(59.015,0.13)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,10.74),(73.68,11.005),(74.01,11.005),(74.01,10.74),(73.68,10.74)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,10.71),(73.68,11.0),(74.01,11.0),(74.01,10.71),(73.68,10.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'psdm',
            ((59.05,2.595),(59.05,19.745),(59.875,19.745),(59.875,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.05,2.595),(35.05,19.745),(35.75,19.745),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.65,2.595),(44.65,19.745),(45.35,19.745),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.125,2.595),(30.125,19.745),(30.95,19.745),(30.95,2.595),(30.125,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.45,2.595),(49.45,19.745),(50.15,19.745),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.85,2.595),(39.85,19.745),(40.55,19.745),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.25,2.595),(54.25,19.745),(54.95,19.745),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.895,2.65),(52.895,19.69),(53.635,19.69),(53.635,2.65),(52.895,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((52.59,2.595),(52.59,19.745),(53.94,19.745),(53.94,2.595),(52.59,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.18,2.595),(42.18,19.745),(43.02,19.745),(43.02,2.595),(42.18,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.95,2.595),(54.95,19.745),(55.395,19.745),(55.395,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.15,2.595),(50.15,19.745),(50.595,19.745),(50.595,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.695,2.65),(33.695,19.69),(34.435,19.69),(34.435,2.65),(33.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((33.39,2.595),(33.39,19.745),(34.74,19.745),(34.74,2.595),(33.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.75,2.595),(35.75,19.745),(36.195,19.745),(36.195,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.86,2.595),(40.86,19.745),(42.21,19.745),(42.21,2.595),(40.86,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((39.405,2.595),(39.405,19.745),(39.85,19.745),(39.85,2.595),(39.405,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((34.605,2.595),(34.605,19.745),(35.05,19.745),(35.05,2.595),(34.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((30.95,2.595),(30.95,19.745),(31.395,19.745),(31.395,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((46.98,2.595),(46.98,19.745),(47.82,19.745),(47.82,2.595),(46.98,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((53.805,2.595),(53.805,19.745),(54.25,19.745),(54.25,2.595),(53.805,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.06,2.595),(36.06,19.745),(37.41,19.745),(37.41,2.595),(36.06,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((36.365,2.65),(36.365,19.69),(37.105,19.69),(37.105,2.65),(36.365,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.965,2.65),(45.965,19.69),(46.705,19.69),(46.705,2.65),(45.965,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.495,2.65),(38.495,19.69),(39.235,19.69),(39.235,2.65),(38.495,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((38.19,2.595),(38.19,19.745),(39.54,19.745),(39.54,2.595),(38.19,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((40.55,2.595),(40.55,19.745),(40.995,19.745),(40.995,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.565,2.65),(31.565,19.69),(32.305,19.69),(32.305,2.65),(31.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((31.26,2.595),(31.26,19.745),(32.61,19.745),(32.61,2.595),(31.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((41.165,2.65),(41.165,19.69),(41.905,19.69),(41.905,2.65),(41.165,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.205,2.595),(44.205,19.745),(44.65,19.745),(44.65,2.595),(44.205,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((56.58,2.595),(56.58,19.745),(57.42,19.745),(57.42,2.595),(56.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((48.095,2.65),(48.095,19.69),(48.835,19.69),(48.835,2.65),(48.095,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((47.79,2.595),(47.79,19.745),(49.14,19.745),(49.14,2.595),(47.79,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((37.38,2.595),(37.38,19.745),(38.22,19.745),(38.22,2.595),(37.38,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.005,2.595),(49.005,19.745),(49.45,19.745),(49.45,2.595),(49.005,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((42.99,2.595),(42.99,19.745),(44.34,19.745),(44.34,2.595),(42.99,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.66,2.595),(45.66,19.745),(47.01,19.745),(47.01,2.595),(45.66,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.765,2.65),(50.765,19.69),(51.505,19.69),(51.505,2.65),(50.765,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((50.46,2.595),(50.46,19.745),(51.81,19.745),(51.81,2.595),(50.46,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.695,2.65),(57.695,19.69),(58.435,19.69),(58.435,2.65),(57.695,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((45.35,2.595),(45.35,19.745),(45.795,19.745),(45.795,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((57.39,2.595),(57.39,19.745),(58.74,19.745),(58.74,2.595),(57.39,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((58.605,2.595),(58.605,19.745),(59.05,19.745),(59.05,2.595),(58.605,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((32.58,2.595),(32.58,19.745),(33.42,19.745),(33.42,2.595),(32.58,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.26,2.595),(55.26,19.745),(56.61,19.745),(56.61,2.595),(55.26,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((55.565,2.65),(55.565,19.69),(56.305,19.69),(56.305,2.65),(55.565,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((43.295,2.65),(43.295,19.69),(44.035,19.69),(44.035,2.65),(43.295,2.65)),
        )
        createRL(
            tech, net, 'nsdm',
            ((51.78,2.595),(51.78,19.745),(52.62,19.745),(52.62,2.595),(51.78,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.535,2.54),(52.535,19.8),(53.995,19.8),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.765,2.52),(52.765,19.82),(53.765,19.82),(53.765,2.52),(52.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.335,2.54),(33.335,19.8),(34.795,19.8),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.565,2.52),(33.565,19.82),(34.565,19.82),(34.565,2.52),(33.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.965,2.52),(47.965,19.82),(48.965,19.82),(48.965,2.52),(47.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.805,2.54),(40.805,19.8),(42.265,19.8),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.005,2.54),(36.005,19.8),(37.465,19.8),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.235,2.52),(36.235,19.82),(37.235,19.82),(37.235,2.52),(36.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.835,2.52),(45.835,19.82),(46.835,19.82),(46.835,2.52),(45.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.365,2.52),(38.365,19.82),(39.365,19.82),(39.365,2.52),(38.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.135,2.54),(38.135,19.8),(39.595,19.8),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.205,2.54),(31.205,19.8),(32.665,19.8),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.435,2.52),(31.435,19.82),(32.435,19.82),(32.435,2.52),(31.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.735,2.54),(47.735,19.8),(49.195,19.8),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((30.05,2.52),(30.05,19.82),(59.95,19.82),(59.95,2.52),(30.05,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.935,2.54),(42.935,19.8),(44.395,19.8),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.605,2.54),(45.605,19.8),(47.065,19.8),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.405,2.54),(50.405,19.8),(51.865,19.8),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.635,2.52),(50.635,19.82),(51.635,19.82),(51.635,2.52),(50.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.335,2.54),(57.335,19.8),(58.795,19.8),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.565,2.52),(57.565,19.82),(58.565,19.82),(58.565,2.52),(57.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.205,2.54),(55.205,19.8),(56.665,19.8),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.435,2.52),(55.435,19.82),(56.435,19.82),(56.435,2.52),(55.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.165,2.52),(43.165,19.82),(44.165,19.82),(44.165,2.52),(43.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.035,2.52),(41.035,19.82),(42.035,19.82),(42.035,2.52),(41.035,2.52)),
        )
        createRL(
            tech, net, 'polyres',
            ((73.675,11.005),(73.675,11.335),(74.015,11.335),(74.015,11.005),(73.675,11.005)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,11.005),(73.68,11.335),(74.01,11.335),(74.01,11.005),(73.68,11.005)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,19.62),(32.485,19.62),(32.485,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.915,2.72),(47.915,19.62),(48.165,19.62),(48.165,2.72),(47.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(43.115,19.62),(43.115,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,19.62),(46.885,19.62),(46.885,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.315,2.72),(38.315,19.62),(38.565,19.62),(38.565,2.72),(38.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.885,2.72),(46.885,19.62),(47.695,19.62),(47.695,2.72),(46.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,19.62),(42.085,19.62),(42.085,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,19.62),(56.485,19.62),(56.485,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.515,2.72),(33.515,19.62),(33.765,19.62),(33.765,2.72),(33.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.295,19.62),(57.295,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.085,2.72),(42.085,19.62),(42.895,19.62),(42.895,2.72),(42.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,19.62),(57.515,19.62),(57.515,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,19.62),(42.895,19.62),(42.895,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.485,2.72),(56.485,19.62),(57.295,19.62),(57.295,2.72),(56.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.095,19.62),(38.095,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.695,19.62),(47.695,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,19.62),(47.915,19.62),(47.915,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,19.62),(38.315,19.62),(38.315,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.285,2.72),(37.285,19.62),(38.095,19.62),(38.095,2.72),(37.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.715,2.72),(52.715,19.62),(52.965,19.62),(52.965,2.72),(52.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.515,2.72),(57.515,19.62),(57.765,19.62),(57.765,2.72),(57.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,19.62),(51.685,19.62),(51.685,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.115,2.72),(43.115,19.62),(43.365,19.62),(43.365,2.72),(43.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,19.62),(37.285,19.62),(37.285,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.295,19.62),(33.295,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,19.62),(33.515,19.62),(33.515,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.485,2.72),(32.485,19.62),(33.295,19.62),(33.295,2.72),(32.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.715,19.62),(52.715,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,19.62),(52.495,19.62),(52.495,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.685,2.72),(51.685,19.62),(52.495,19.62),(52.495,2.72),(51.685,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.225),(33.085,18.395),(33.255,18.395),(33.255,18.225),(33.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.565),(33.085,18.735),(33.255,18.735),(33.255,18.565),(33.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.025),(56.745,8.195),(56.915,8.195),(56.915,8.025),(56.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.365),(56.745,8.535),(56.915,8.535),(56.915,8.365),(56.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.705),(56.745,8.875),(56.915,8.875),(56.915,8.705),(56.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.245),(32.745,19.415),(32.915,19.415),(32.915,19.245),(32.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.665),(37.545,6.835),(37.715,6.835),(37.715,6.665),(37.545,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.325),(37.545,6.495),(37.715,6.495),(37.715,6.325),(37.545,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.765),(37.545,11.935),(37.715,11.935),(37.715,11.765),(37.545,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.085),(37.545,11.255),(37.715,11.255),(37.715,11.085),(37.545,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.425),(37.545,11.595),(37.715,11.595),(37.715,11.425),(37.545,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.285),(56.745,4.455),(56.915,4.455),(56.915,4.285),(56.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.625),(56.745,4.795),(56.915,4.795),(56.915,4.625),(56.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.165),(32.745,15.335),(32.915,15.335),(32.915,15.165),(32.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.505),(32.745,15.675),(32.915,15.675),(32.915,15.505),(32.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.265),(42.345,3.435),(42.515,3.435),(42.515,3.265),(42.345,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.265),(42.685,3.435),(42.855,3.435),(42.855,3.265),(42.685,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.605),(42.345,3.775),(42.515,3.775),(42.515,3.605),(42.345,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.605),(42.685,3.775),(42.855,3.775),(42.855,3.605),(42.685,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.885),(32.745,18.055),(32.915,18.055),(32.915,17.885),(32.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.285),(32.745,4.455),(32.915,4.455),(32.915,4.285),(32.745,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.625),(32.745,4.795),(32.915,4.795),(32.915,4.625),(32.745,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.385),(56.745,9.555),(56.915,9.555),(56.915,9.385),(56.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.725),(56.745,9.895),(56.915,9.895),(56.915,9.725),(56.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.045),(56.745,9.215),(56.915,9.215),(56.915,9.045),(56.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.645),(52.285,5.815),(52.455,5.815),(52.455,5.645),(52.285,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.305),(52.285,5.475),(52.455,5.475),(52.455,5.305),(52.285,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.925),(56.745,3.095),(56.915,3.095),(56.915,2.925),(56.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.505),(37.545,15.675),(37.715,15.675),(37.715,15.505),(37.545,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.165),(37.545,15.335),(37.715,15.335),(37.715,15.165),(37.545,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.385),(51.945,9.555),(52.115,9.555),(52.115,9.385),(51.945,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.725),(51.945,9.895),(52.115,9.895),(52.115,9.725),(51.945,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.045),(51.945,9.215),(52.115,9.215),(52.115,9.045),(51.945,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.925),(32.745,3.095),(32.915,3.095),(32.915,2.925),(32.745,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.965),(51.945,5.135),(52.115,5.135),(52.115,4.965),(51.945,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.185),(51.945,16.355),(52.115,16.355),(52.115,16.185),(51.945,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.525),(51.945,16.695),(52.115,16.695),(52.115,16.525),(51.945,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.305),(56.745,5.475),(56.915,5.475),(56.915,5.305),(56.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.645),(56.745,5.815),(56.915,5.815),(56.915,5.645),(56.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.305),(32.745,5.475),(32.915,5.475),(32.915,5.305),(32.745,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.645),(32.745,5.815),(32.915,5.815),(32.915,5.645),(32.745,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.165),(47.485,15.335),(47.655,15.335),(47.655,15.165),(47.485,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.905),(32.745,19.075),(32.915,19.075),(32.915,18.905),(32.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.425),(32.745,11.595),(32.915,11.595),(32.915,11.425),(32.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.765),(32.745,11.935),(32.915,11.935),(32.915,11.765),(32.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.085),(32.745,11.255),(32.915,11.255),(32.915,11.085),(32.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.265),(37.885,3.435),(38.055,3.435),(38.055,3.265),(37.885,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.605),(37.885,3.775),(38.055,3.775),(38.055,3.605),(37.885,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.925),(57.085,3.095),(57.255,3.095),(57.255,2.925),(57.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.185),(33.085,16.355),(33.255,16.355),(33.255,16.185),(33.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.525),(33.085,16.695),(33.255,16.695),(33.255,16.525),(33.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.925),(33.085,3.095),(33.255,3.095),(33.255,2.925),(33.085,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.285),(37.545,4.455),(37.715,4.455),(37.715,4.285),(37.545,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.625),(37.545,4.795),(37.715,4.795),(37.715,4.625),(37.545,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.265),(57.085,3.435),(57.255,3.435),(57.255,3.265),(57.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.245),(51.945,19.415),(52.115,19.415),(52.115,19.245),(51.945,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.605),(57.085,3.775),(57.255,3.775),(57.255,3.605),(57.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.405),(37.545,10.575),(37.715,10.575),(37.715,10.405),(37.545,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.745),(37.545,10.915),(37.715,10.915),(37.715,10.745),(37.545,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.325),(56.745,6.495),(56.915,6.495),(56.915,6.325),(56.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.665),(56.745,6.835),(56.915,6.835),(56.915,6.665),(56.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.065),(37.545,10.235),(37.715,10.235),(37.715,10.065),(37.545,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.265),(33.085,3.435),(33.255,3.435),(33.255,3.265),(33.085,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.605),(33.085,3.775),(33.255,3.775),(33.255,3.605),(33.085,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.445),(33.085,12.615),(33.255,12.615),(33.255,12.445),(33.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.785),(33.085,12.955),(33.255,12.955),(33.255,12.785),(33.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.325),(32.745,6.495),(32.915,6.495),(32.915,6.325),(32.745,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.665),(32.745,6.835),(32.915,6.835),(32.915,6.665),(32.745,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.105),(33.085,12.275),(33.255,12.275),(33.255,12.105),(33.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.025),(42.345,8.195),(42.515,8.195),(42.515,8.025),(42.345,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.025),(42.685,8.195),(42.855,8.195),(42.855,8.025),(42.685,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.365),(42.345,8.535),(42.515,8.535),(42.515,8.365),(42.345,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.365),(42.685,8.535),(42.855,8.535),(42.855,8.365),(42.685,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.705),(42.345,8.875),(42.515,8.875),(42.515,8.705),(42.345,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.705),(42.685,8.875),(42.855,8.875),(42.855,8.705),(42.685,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.645),(47.145,5.815),(47.315,5.815),(47.315,5.645),(47.145,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.645),(47.485,5.815),(47.655,5.815),(47.655,5.645),(47.485,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.225),(52.285,18.395),(52.455,18.395),(52.455,18.225),(52.285,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.565),(52.285,18.735),(52.455,18.735),(52.455,18.565),(52.285,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.905),(33.085,19.075),(33.255,19.075),(33.255,18.905),(33.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.305),(47.145,5.475),(47.315,5.475),(47.315,5.305),(47.145,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.305),(47.485,5.475),(47.655,5.475),(47.655,5.305),(47.485,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.645),(51.945,5.815),(52.115,5.815),(52.115,5.645),(51.945,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.305),(51.945,5.475),(52.115,5.475),(52.115,5.305),(51.945,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.405),(42.685,10.575),(42.855,10.575),(42.855,10.405),(42.685,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.745),(42.345,10.915),(42.515,10.915),(42.515,10.745),(42.345,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.745),(42.685,10.915),(42.855,10.915),(42.855,10.745),(42.685,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.065),(42.345,10.235),(42.515,10.235),(42.515,10.065),(42.345,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.065),(42.685,10.235),(42.855,10.235),(42.855,10.065),(42.685,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.405),(42.345,10.575),(42.515,10.575),(42.515,10.405),(42.345,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.845),(42.345,16.015),(42.515,16.015),(42.515,15.845),(42.345,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.845),(42.685,16.015),(42.855,16.015),(42.855,15.845),(42.685,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.145),(47.145,14.315),(47.315,14.315),(47.315,14.145),(47.145,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.145),(47.485,14.315),(47.655,14.315),(47.655,14.145),(47.485,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.945),(51.945,4.115),(52.115,4.115),(52.115,3.945),(51.945,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.485),(47.145,14.655),(47.315,14.655),(47.315,14.485),(47.145,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.485),(47.485,14.655),(47.655,14.655),(47.655,14.485),(47.485,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.825),(47.145,14.995),(47.315,14.995),(47.315,14.825),(47.145,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.825),(47.485,14.995),(47.655,14.995),(47.655,14.825),(47.485,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.005),(52.285,7.175),(52.455,7.175),(52.455,7.005),(52.285,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.345),(52.285,7.515),(52.455,7.515),(52.455,7.345),(52.285,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.685),(52.285,7.855),(52.455,7.855),(52.455,7.685),(52.285,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.245),(33.085,19.415),(33.255,19.415),(33.255,19.245),(33.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.445),(47.145,12.615),(47.315,12.615),(47.315,12.445),(47.145,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.445),(47.485,12.615),(47.655,12.615),(47.655,12.445),(47.485,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.785),(47.145,12.955),(47.315,12.955),(47.315,12.785),(47.145,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.785),(47.485,12.955),(47.655,12.955),(47.655,12.785),(47.485,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.105),(47.145,12.275),(47.315,12.275),(47.315,12.105),(47.145,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.105),(47.485,12.275),(47.655,12.275),(47.655,12.105),(47.485,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.965),(56.745,5.135),(56.915,5.135),(56.915,4.965),(56.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.065),(57.085,10.235),(57.255,10.235),(57.255,10.065),(57.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.745),(57.085,10.915),(57.255,10.915),(57.255,10.745),(57.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.405),(57.085,10.575),(57.255,10.575),(57.255,10.405),(57.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.965),(32.745,5.135),(32.915,5.135),(32.915,4.965),(32.745,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.945),(42.345,4.115),(42.515,4.115),(42.515,3.945),(42.345,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.945),(42.685,4.115),(42.855,4.115),(42.855,3.945),(42.685,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.005),(56.745,7.175),(56.915,7.175),(56.915,7.005),(56.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.345),(56.745,7.515),(56.915,7.515),(56.915,7.345),(56.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.685),(56.745,7.855),(56.915,7.855),(56.915,7.685),(56.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.325),(57.085,6.495),(57.255,6.495),(57.255,6.325),(57.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.665),(57.085,6.835),(57.255,6.835),(57.255,6.665),(57.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.885),(57.085,18.055),(57.255,18.055),(57.255,17.885),(57.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.005),(32.745,7.175),(32.915,7.175),(32.915,7.005),(32.745,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.345),(32.745,7.515),(32.915,7.515),(32.915,7.345),(32.745,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.685),(32.745,7.855),(32.915,7.855),(32.915,7.685),(32.745,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.925),(52.285,3.095),(52.455,3.095),(52.455,2.925),(52.285,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.325),(33.085,6.495),(33.255,6.495),(33.255,6.325),(33.085,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.665),(33.085,6.835),(33.255,6.835),(33.255,6.665),(33.085,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.225),(42.345,18.395),(42.515,18.395),(42.515,18.225),(42.345,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.225),(42.685,18.395),(42.855,18.395),(42.855,18.225),(42.685,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.565),(42.345,18.735),(42.515,18.735),(42.515,18.565),(42.345,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.565),(42.685,18.735),(42.855,18.735),(42.855,18.565),(42.685,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.185),(56.745,16.355),(56.915,16.355),(56.915,16.185),(56.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.525),(56.745,16.695),(56.915,16.695),(56.915,16.525),(56.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.285),(51.945,4.455),(52.115,4.455),(52.115,4.285),(51.945,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.625),(51.945,4.795),(52.115,4.795),(52.115,4.625),(51.945,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.505),(33.085,15.675),(33.255,15.675),(33.255,15.505),(33.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.165),(33.085,15.335),(33.255,15.335),(33.255,15.165),(33.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.985),(42.345,6.155),(42.515,6.155),(42.515,5.985),(42.345,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.985),(42.685,6.155),(42.855,6.155),(42.855,5.985),(42.685,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.845),(37.545,16.015),(37.715,16.015),(37.715,15.845),(37.545,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.065),(52.285,10.235),(52.455,10.235),(52.455,10.065),(52.285,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.405),(52.285,10.575),(52.455,10.575),(52.455,10.405),(52.285,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.745),(52.285,10.915),(52.455,10.915),(52.455,10.745),(52.285,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.025),(32.745,8.195),(32.915,8.195),(32.915,8.025),(32.745,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.445),(56.745,12.615),(56.915,12.615),(56.915,12.445),(56.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.785),(56.745,12.955),(56.915,12.955),(56.915,12.785),(56.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.365),(32.745,8.535),(32.915,8.535),(32.915,8.365),(32.745,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.705),(32.745,8.875),(32.915,8.875),(32.915,8.705),(32.745,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.845),(56.745,16.015),(56.915,16.015),(56.915,15.845),(56.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.105),(56.745,12.275),(56.915,12.275),(56.915,12.105),(56.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.905),(37.885,19.075),(38.055,19.075),(38.055,18.905),(37.885,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.185),(47.145,16.355),(47.315,16.355),(47.315,16.185),(47.145,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.185),(47.485,16.355),(47.655,16.355),(47.655,16.185),(47.485,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.525),(47.145,16.695),(47.315,16.695),(47.315,16.525),(47.145,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.525),(47.485,16.695),(47.655,16.695),(47.655,16.525),(47.485,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.405),(51.945,10.575),(52.115,10.575),(52.115,10.405),(51.945,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.745),(51.945,10.915),(52.115,10.915),(52.115,10.745),(51.945,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.065),(51.945,10.235),(52.115,10.235),(52.115,10.065),(51.945,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.825),(37.885,14.995),(38.055,14.995),(38.055,14.825),(37.885,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.125),(42.345,13.295),(42.515,13.295),(42.515,13.125),(42.345,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.125),(42.685,13.295),(42.855,13.295),(42.855,13.125),(42.685,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.465),(42.345,13.635),(42.515,13.635),(42.515,13.465),(42.345,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.465),(42.685,13.635),(42.855,13.635),(42.855,13.465),(42.685,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.805),(42.345,13.975),(42.515,13.975),(42.515,13.805),(42.345,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.945),(52.285,4.115),(52.455,4.115),(52.455,3.945),(52.285,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.805),(42.685,13.975),(42.855,13.975),(42.855,13.805),(42.685,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.865),(33.085,17.035),(33.255,17.035),(33.255,16.865),(33.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.005),(51.945,7.175),(52.115,7.175),(52.115,7.005),(51.945,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.045),(32.745,9.215),(32.915,9.215),(32.915,9.045),(32.745,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.385),(32.745,9.555),(32.915,9.555),(32.915,9.385),(32.745,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.725),(32.745,9.895),(32.915,9.895),(32.915,9.725),(32.745,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.345),(51.945,7.515),(52.115,7.515),(52.115,7.345),(51.945,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.685),(51.945,7.855),(52.115,7.855),(52.115,7.685),(51.945,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.765),(47.145,11.935),(47.315,11.935),(47.315,11.765),(47.145,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.765),(47.485,11.935),(47.655,11.935),(47.655,11.765),(47.485,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.425),(47.145,11.595),(47.315,11.595),(47.315,11.425),(47.145,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.425),(47.485,11.595),(47.655,11.595),(47.655,11.425),(47.485,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.085),(47.145,11.255),(47.315,11.255),(47.315,11.085),(47.145,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.425),(37.885,11.595),(38.055,11.595),(38.055,11.425),(37.885,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.625),(52.285,4.795),(52.455,4.795),(52.455,4.625),(52.285,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.285),(52.285,4.455),(52.455,4.455),(52.455,4.285),(52.285,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.085),(47.485,11.255),(47.655,11.255),(47.655,11.085),(47.485,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.765),(37.885,11.935),(38.055,11.935),(38.055,11.765),(37.885,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.085),(37.885,11.255),(38.055,11.255),(38.055,11.085),(37.885,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.945),(57.085,4.115),(57.255,4.115),(57.255,3.945),(57.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.965),(37.545,5.135),(37.715,5.135),(37.715,4.965),(37.545,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.645),(37.545,5.815),(37.715,5.815),(37.715,5.645),(37.545,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.465),(56.745,13.635),(56.915,13.635),(56.915,13.465),(56.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.805),(56.745,13.975),(56.915,13.975),(56.915,13.805),(56.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.125),(56.745,13.295),(56.915,13.295),(56.915,13.125),(56.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.945),(33.085,4.115),(33.255,4.115),(33.255,3.945),(33.085,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.805),(37.885,13.975),(38.055,13.975),(38.055,13.805),(37.885,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.465),(37.885,13.635),(38.055,13.635),(38.055,13.465),(37.885,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.125),(37.885,13.295),(38.055,13.295),(38.055,13.125),(37.885,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.905),(52.285,19.075),(52.455,19.075),(52.455,18.905),(52.285,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.985),(51.945,6.155),(52.115,6.155),(52.115,5.985),(51.945,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.705),(37.885,8.875),(38.055,8.875),(38.055,8.705),(37.885,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.365),(37.885,8.535),(38.055,8.535),(38.055,8.365),(37.885,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.025),(37.885,8.195),(38.055,8.195),(38.055,8.025),(37.885,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.445),(37.545,12.615),(37.715,12.615),(37.715,12.445),(37.545,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.785),(37.545,12.955),(37.715,12.955),(37.715,12.785),(37.545,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.105),(37.545,12.275),(37.715,12.275),(37.715,12.105),(37.545,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.285),(57.085,4.455),(57.255,4.455),(57.255,4.285),(57.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.625),(57.085,4.795),(57.255,4.795),(57.255,4.625),(57.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.405),(37.885,10.575),(38.055,10.575),(38.055,10.405),(37.885,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.745),(37.885,10.915),(38.055,10.915),(38.055,10.745),(37.885,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.065),(37.885,10.235),(38.055,10.235),(38.055,10.065),(37.885,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.285),(33.085,4.455),(33.255,4.455),(33.255,4.285),(33.085,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.625),(33.085,4.795),(33.255,4.795),(33.255,4.625),(33.085,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.325),(42.345,6.495),(42.515,6.495),(42.515,6.325),(42.345,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.325),(42.685,6.495),(42.855,6.495),(42.855,6.325),(42.685,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.665),(42.345,6.835),(42.515,6.835),(42.515,6.665),(42.345,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.665),(42.685,6.835),(42.855,6.835),(42.855,6.665),(42.685,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.225),(56.745,18.395),(56.915,18.395),(56.915,18.225),(56.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.565),(56.745,18.735),(56.915,18.735),(56.915,18.565),(56.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.325),(51.945,6.495),(52.115,6.495),(52.115,6.325),(51.945,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.665),(51.945,6.835),(52.115,6.835),(52.115,6.665),(51.945,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.525),(37.545,16.695),(37.715,16.695),(37.715,16.525),(37.545,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.185),(37.545,16.355),(37.715,16.355),(37.715,16.185),(37.545,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.445),(37.885,12.615),(38.055,12.615),(38.055,12.445),(37.885,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.505),(52.285,15.675),(52.455,15.675),(52.455,15.505),(52.285,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.165),(52.285,15.335),(52.455,15.335),(52.455,15.165),(52.285,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.785),(37.885,12.955),(38.055,12.955),(38.055,12.785),(37.885,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.845),(33.085,16.015),(33.255,16.015),(33.255,15.845),(33.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.105),(37.885,12.275),(38.055,12.275),(38.055,12.105),(37.885,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.545),(57.085,17.715),(57.255,17.715),(57.255,17.545),(57.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.205),(57.085,17.375),(57.255,17.375),(57.255,17.205),(57.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.205),(37.885,17.375),(38.055,17.375),(38.055,17.205),(37.885,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.545),(37.885,17.715),(38.055,17.715),(38.055,17.545),(37.885,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.905),(51.945,19.075),(52.115,19.075),(52.115,18.905),(51.945,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.185),(52.285,16.355),(52.455,16.355),(52.455,16.185),(52.285,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.525),(52.285,16.695),(52.455,16.695),(52.455,16.525),(52.285,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.905),(42.345,19.075),(42.515,19.075),(42.515,18.905),(42.345,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.905),(42.685,19.075),(42.855,19.075),(42.855,18.905),(42.685,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.885),(37.545,18.055),(37.715,18.055),(37.715,17.885),(37.545,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.865),(56.745,17.035),(56.915,17.035),(56.915,16.865),(56.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.225),(57.085,18.395),(57.255,18.395),(57.255,18.225),(57.085,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.565),(57.085,18.735),(57.255,18.735),(57.255,18.565),(57.085,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.005),(42.345,7.175),(42.515,7.175),(42.515,7.005),(42.345,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.005),(42.685,7.175),(42.855,7.175),(42.855,7.005),(42.685,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.125),(57.085,13.295),(57.255,13.295),(57.255,13.125),(57.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.465),(57.085,13.635),(57.255,13.635),(57.255,13.465),(57.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.805),(57.085,13.975),(57.255,13.975),(57.255,13.805),(57.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.345),(42.345,7.515),(42.515,7.515),(42.515,7.345),(42.345,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.345),(42.685,7.515),(42.855,7.515),(42.855,7.345),(42.685,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.445),(51.945,12.615),(52.115,12.615),(52.115,12.445),(51.945,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.785),(51.945,12.955),(52.115,12.955),(52.115,12.785),(51.945,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.105),(51.945,12.275),(52.115,12.275),(52.115,12.105),(51.945,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.245),(37.545,19.415),(37.715,19.415),(37.715,19.245),(37.545,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.665),(52.285,6.835),(52.455,6.835),(52.455,6.665),(52.285,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.325),(52.285,6.495),(52.455,6.495),(52.455,6.325),(52.285,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.025),(52.285,8.195),(52.455,8.195),(52.455,8.025),(52.285,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.365),(52.285,8.535),(52.455,8.535),(52.455,8.365),(52.285,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.705),(52.285,8.875),(52.455,8.875),(52.455,8.705),(52.285,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.225),(37.885,18.395),(38.055,18.395),(38.055,18.225),(37.885,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.565),(37.885,18.735),(38.055,18.735),(38.055,18.565),(37.885,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.205),(52.285,17.375),(52.455,17.375),(52.455,17.205),(52.285,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.545),(52.285,17.715),(52.455,17.715),(52.455,17.545),(52.285,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.945),(56.745,4.115),(56.915,4.115),(56.915,3.945),(56.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.885),(42.345,18.055),(42.515,18.055),(42.515,17.885),(42.345,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.885),(42.685,18.055),(42.855,18.055),(42.855,17.885),(42.685,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.745),(56.745,10.915),(56.915,10.915),(56.915,10.745),(56.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.065),(56.745,10.235),(56.915,10.235),(56.915,10.065),(56.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.405),(56.745,10.575),(56.915,10.575),(56.915,10.405),(56.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.865),(47.145,17.035),(47.315,17.035),(47.315,16.865),(47.145,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.745),(33.085,10.915),(33.255,10.915),(33.255,10.745),(33.085,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.485),(57.085,14.655),(57.255,14.655),(57.255,14.485),(57.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.825),(57.085,14.995),(57.255,14.995),(57.255,14.825),(57.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.865),(47.485,17.035),(47.655,17.035),(47.655,16.865),(47.485,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.145),(57.085,14.315),(57.255,14.315),(57.255,14.145),(57.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.405),(33.085,10.575),(33.255,10.575),(33.255,10.405),(33.085,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.065),(33.085,10.235),(33.255,10.235),(33.255,10.065),(33.085,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.945),(32.745,4.115),(32.915,4.115),(32.915,3.945),(32.745,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.885),(56.745,18.055),(56.915,18.055),(56.915,17.885),(56.745,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.265),(52.285,3.435),(52.455,3.435),(52.455,3.265),(52.285,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.605),(52.285,3.775),(52.455,3.775),(52.455,3.605),(52.285,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.385),(37.545,9.555),(37.715,9.555),(37.715,9.385),(37.545,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.725),(37.545,9.895),(37.715,9.895),(37.715,9.725),(37.545,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.045),(37.545,9.215),(37.715,9.215),(37.715,9.045),(37.545,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.005),(47.145,7.175),(47.315,7.175),(47.315,7.005),(47.145,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.005),(47.485,7.175),(47.655,7.175),(47.655,7.005),(47.485,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.345),(47.145,7.515),(47.315,7.515),(47.315,7.345),(47.145,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.345),(47.485,7.515),(47.655,7.515),(47.655,7.345),(47.485,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.685),(47.145,7.855),(47.315,7.855),(47.315,7.685),(47.145,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.965),(52.285,5.135),(52.455,5.135),(52.455,4.965),(52.285,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.025),(51.945,8.195),(52.115,8.195),(52.115,8.025),(51.945,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.685),(47.485,7.855),(47.655,7.855),(47.655,7.685),(47.485,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.365),(51.945,8.535),(52.115,8.535),(52.115,8.365),(51.945,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.705),(51.945,8.875),(52.115,8.875),(52.115,8.705),(51.945,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.845),(57.085,16.015),(57.255,16.015),(57.255,15.845),(57.085,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.505),(51.945,15.675),(52.115,15.675),(52.115,15.505),(51.945,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.165),(51.945,15.335),(52.115,15.335),(52.115,15.165),(51.945,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.005),(37.885,7.175),(38.055,7.175),(38.055,7.005),(37.885,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.345),(37.885,7.515),(38.055,7.515),(38.055,7.345),(37.885,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.685),(37.885,7.855),(38.055,7.855),(38.055,7.685),(37.885,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.885),(33.085,18.055),(33.255,18.055),(33.255,17.885),(33.085,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.985),(37.545,6.155),(37.715,6.155),(37.715,5.985),(37.545,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.385),(57.085,9.555),(57.255,9.555),(57.255,9.385),(57.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.725),(57.085,9.895),(57.255,9.895),(57.255,9.725),(57.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.045),(57.085,9.215),(57.255,9.215),(57.255,9.045),(57.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.965),(57.085,5.135),(57.255,5.135),(57.255,4.965),(57.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.105),(32.745,12.275),(32.915,12.275),(32.915,12.105),(32.745,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.445),(32.745,12.615),(32.915,12.615),(32.915,12.445),(32.745,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.785),(32.745,12.955),(32.915,12.955),(32.915,12.785),(32.745,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.965),(33.085,5.135),(33.255,5.135),(33.255,4.965),(33.085,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.205),(32.745,17.375),(32.915,17.375),(32.915,17.205),(32.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.545),(32.745,17.715),(32.915,17.715),(32.915,17.545),(32.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.385),(52.285,9.555),(52.455,9.555),(52.455,9.385),(52.285,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.725),(52.285,9.895),(52.455,9.895),(52.455,9.725),(52.285,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.045),(52.285,9.215),(52.455,9.215),(52.455,9.045),(52.285,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.905),(56.745,19.075),(56.915,19.075),(56.915,18.905),(56.745,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.145),(37.545,14.315),(37.715,14.315),(37.715,14.145),(37.545,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.485),(37.545,14.655),(37.715,14.655),(37.715,14.485),(37.545,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.825),(37.545,14.995),(37.715,14.995),(37.715,14.825),(37.545,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.525),(42.685,16.695),(42.855,16.695),(42.855,16.525),(42.685,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.185),(42.345,16.355),(42.515,16.355),(42.515,16.185),(42.345,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.185),(42.685,16.355),(42.855,16.355),(42.855,16.185),(42.685,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.525),(42.345,16.695),(42.515,16.695),(42.515,16.525),(42.345,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.865),(37.545,17.035),(37.715,17.035),(37.715,16.865),(37.545,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.005),(37.545,7.175),(37.715,7.175),(37.715,7.005),(37.545,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.685),(37.545,7.855),(37.715,7.855),(37.715,7.685),(37.545,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.345),(37.545,7.515),(37.715,7.515),(37.715,7.345),(37.545,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.845),(52.285,16.015),(52.455,16.015),(52.455,15.845),(52.285,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.325),(37.885,6.495),(38.055,6.495),(38.055,6.325),(37.885,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.665),(37.885,6.835),(38.055,6.835),(38.055,6.665),(37.885,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.885),(37.885,18.055),(38.055,18.055),(38.055,17.885),(37.885,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.225),(51.945,18.395),(52.115,18.395),(52.115,18.225),(51.945,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.565),(51.945,18.735),(52.115,18.735),(52.115,18.565),(51.945,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.985),(52.285,6.155),(52.455,6.155),(52.455,5.985),(52.285,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.525),(57.085,16.695),(57.255,16.695),(57.255,16.525),(57.085,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.185),(57.085,16.355),(57.255,16.355),(57.255,16.185),(57.085,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.865),(52.285,17.035),(52.455,17.035),(52.455,16.865),(52.285,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.205),(37.545,17.375),(37.715,17.375),(37.715,17.205),(37.545,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.545),(37.545,17.715),(37.715,17.715),(37.715,17.545),(37.545,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.045),(42.345,9.215),(42.515,9.215),(42.515,9.045),(42.345,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.045),(42.685,9.215),(42.855,9.215),(42.855,9.045),(42.685,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.385),(42.345,9.555),(42.515,9.555),(42.515,9.385),(42.345,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.385),(42.685,9.555),(42.855,9.555),(42.855,9.385),(42.685,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.465),(52.285,13.635),(52.455,13.635),(52.455,13.465),(52.285,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.805),(52.285,13.975),(52.455,13.975),(52.455,13.805),(52.285,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.245),(52.285,19.415),(52.455,19.415),(52.455,19.245),(52.285,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.725),(42.345,9.895),(42.515,9.895),(42.515,9.725),(42.345,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.725),(42.685,9.895),(42.855,9.895),(42.855,9.725),(42.685,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.125),(52.285,13.295),(52.455,13.295),(52.455,13.125),(52.285,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.465),(32.745,13.635),(32.915,13.635),(32.915,13.465),(32.745,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.805),(32.745,13.975),(32.915,13.975),(32.915,13.805),(32.745,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.125),(32.745,13.295),(32.915,13.295),(32.915,13.125),(32.745,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.425),(42.345,11.595),(42.515,11.595),(42.515,11.425),(42.345,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.425),(42.685,11.595),(42.855,11.595),(42.855,11.425),(42.685,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.765),(42.345,11.935),(42.515,11.935),(42.515,11.765),(42.345,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.765),(42.685,11.935),(42.855,11.935),(42.855,11.765),(42.685,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.865),(37.885,17.035),(38.055,17.035),(38.055,16.865),(37.885,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.085),(42.345,11.255),(42.515,11.255),(42.515,11.085),(42.345,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.085),(42.685,11.255),(42.855,11.255),(42.855,11.085),(42.685,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.985),(56.745,6.155),(56.915,6.155),(56.915,5.985),(56.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.225),(47.145,18.395),(47.315,18.395),(47.315,18.225),(47.145,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.225),(47.485,18.395),(47.655,18.395),(47.655,18.225),(47.485,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.565),(47.145,18.735),(47.315,18.735),(47.315,18.565),(47.145,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.565),(47.485,18.735),(47.655,18.735),(47.655,18.565),(47.485,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.985),(32.745,6.155),(32.915,6.155),(32.915,5.985),(32.745,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.905),(57.085,19.075),(57.255,19.075),(57.255,18.905),(57.085,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.225),(37.545,18.395),(37.715,18.395),(37.715,18.225),(37.545,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.565),(37.545,18.735),(37.715,18.735),(37.715,18.565),(37.545,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.685),(42.685,7.855),(42.855,7.855),(42.855,7.685),(42.685,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.265),(56.745,3.435),(56.915,3.435),(56.915,3.265),(56.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.605),(56.745,3.775),(56.915,3.775),(56.915,3.605),(56.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.245),(57.085,19.415),(57.255,19.415),(57.255,19.245),(57.085,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.265),(32.745,3.435),(32.915,3.435),(32.915,3.265),(32.745,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.605),(32.745,3.775),(32.915,3.775),(32.915,3.605),(32.745,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.145),(52.285,14.315),(52.455,14.315),(52.455,14.145),(52.285,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.485),(52.285,14.655),(52.455,14.655),(52.455,14.485),(52.285,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.825),(52.285,14.995),(52.455,14.995),(52.455,14.825),(52.285,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.285),(47.145,4.455),(47.315,4.455),(47.315,4.285),(47.145,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.285),(47.485,4.455),(47.655,4.455),(47.655,4.285),(47.485,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.625),(47.145,4.795),(47.315,4.795),(47.315,4.625),(47.145,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.625),(47.485,4.795),(47.655,4.795),(47.655,4.625),(47.485,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.245),(42.345,19.415),(42.515,19.415),(42.515,19.245),(42.345,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.245),(42.685,19.415),(42.855,19.415),(42.855,19.245),(42.685,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.365),(57.085,8.535),(57.255,8.535),(57.255,8.365),(57.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.705),(57.085,8.875),(57.255,8.875),(57.255,8.705),(57.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.025),(57.085,8.195),(57.255,8.195),(57.255,8.025),(57.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.205),(51.945,17.375),(52.115,17.375),(52.115,17.205),(51.945,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.545),(51.945,17.715),(52.115,17.715),(52.115,17.545),(51.945,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.165),(42.345,15.335),(42.515,15.335),(42.515,15.165),(42.345,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.165),(42.685,15.335),(42.855,15.335),(42.855,15.165),(42.685,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.505),(42.345,15.675),(42.515,15.675),(42.515,15.505),(42.345,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.505),(42.685,15.675),(42.855,15.675),(42.855,15.505),(42.685,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.925),(37.885,3.095),(38.055,3.095),(38.055,2.925),(37.885,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.885),(47.145,18.055),(47.315,18.055),(47.315,17.885),(47.145,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.885),(47.485,18.055),(47.655,18.055),(47.655,17.885),(47.485,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.285),(42.345,4.455),(42.515,4.455),(42.515,4.285),(42.345,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.285),(42.685,4.455),(42.855,4.455),(42.855,4.285),(42.685,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.625),(42.345,4.795),(42.515,4.795),(42.515,4.625),(42.345,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.625),(42.685,4.795),(42.855,4.795),(42.855,4.625),(42.685,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.385),(47.145,9.555),(47.315,9.555),(47.315,9.385),(47.145,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.385),(47.485,9.555),(47.655,9.555),(47.655,9.385),(47.485,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.725),(47.145,9.895),(47.315,9.895),(47.315,9.725),(47.145,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.725),(47.485,9.895),(47.655,9.895),(47.655,9.725),(47.485,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.205),(33.085,17.375),(33.255,17.375),(33.255,17.205),(33.085,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.545),(33.085,17.715),(33.255,17.715),(33.255,17.545),(33.085,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.045),(47.145,9.215),(47.315,9.215),(47.315,9.045),(47.145,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.045),(47.485,9.215),(47.655,9.215),(47.655,9.045),(47.485,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.305),(37.545,5.475),(37.715,5.475),(37.715,5.305),(37.545,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.605),(51.945,3.775),(52.115,3.775),(52.115,3.605),(51.945,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.265),(51.945,3.435),(52.115,3.435),(52.115,3.265),(51.945,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.465),(51.945,13.635),(52.115,13.635),(52.115,13.465),(51.945,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.805),(51.945,13.975),(52.115,13.975),(52.115,13.805),(51.945,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.125),(51.945,13.295),(52.115,13.295),(52.115,13.125),(51.945,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.465),(33.085,13.635),(33.255,13.635),(33.255,13.465),(33.085,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.805),(33.085,13.975),(33.255,13.975),(33.255,13.805),(33.085,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.125),(33.085,13.295),(33.255,13.295),(33.255,13.125),(33.085,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.165),(37.885,15.335),(38.055,15.335),(38.055,15.165),(37.885,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.505),(37.885,15.675),(38.055,15.675),(38.055,15.505),(37.885,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.965),(37.885,5.135),(38.055,5.135),(38.055,4.965),(37.885,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.425),(57.085,11.595),(57.255,11.595),(57.255,11.425),(57.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.865),(42.685,17.035),(42.855,17.035),(42.855,16.865),(42.685,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.765),(57.085,11.935),(57.255,11.935),(57.255,11.765),(57.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.085),(57.085,11.255),(57.255,11.255),(57.255,11.085),(57.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.865),(42.345,17.035),(42.515,17.035),(42.515,16.865),(42.345,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.405),(32.745,10.575),(32.915,10.575),(32.915,10.405),(32.745,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.745),(32.745,10.915),(32.915,10.915),(32.915,10.745),(32.745,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.065),(32.745,10.235),(32.915,10.235),(32.915,10.065),(32.745,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.505),(47.145,15.675),(47.315,15.675),(47.315,15.505),(47.145,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.505),(47.485,15.675),(47.655,15.675),(47.655,15.505),(47.485,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.145),(56.745,14.315),(56.915,14.315),(56.915,14.145),(56.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.145),(33.085,14.315),(33.255,14.315),(33.255,14.145),(33.085,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.485),(56.745,14.655),(56.915,14.655),(56.915,14.485),(56.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.825),(56.745,14.995),(56.915,14.995),(56.915,14.825),(56.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.485),(33.085,14.655),(33.255,14.655),(33.255,14.485),(33.085,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.825),(33.085,14.995),(33.255,14.995),(33.255,14.825),(33.085,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.985),(57.085,6.155),(57.255,6.155),(57.255,5.985),(57.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.985),(33.085,6.155),(33.255,6.155),(33.255,5.985),(33.085,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.465),(47.145,13.635),(47.315,13.635),(47.315,13.465),(47.145,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.465),(47.485,13.635),(47.655,13.635),(47.655,13.465),(47.485,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.805),(47.145,13.975),(47.315,13.975),(47.315,13.805),(47.145,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.805),(47.485,13.975),(47.655,13.975),(47.655,13.805),(47.485,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.125),(47.145,13.295),(47.315,13.295),(47.315,13.125),(47.145,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.125),(47.485,13.295),(47.655,13.295),(47.655,13.125),(47.485,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.245),(37.885,19.415),(38.055,19.415),(38.055,19.245),(37.885,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.245),(56.745,19.415),(56.915,19.415),(56.915,19.245),(56.745,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.865),(57.085,17.035),(57.255,17.035),(57.255,16.865),(57.085,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.925),(47.485,3.095),(47.655,3.095),(47.655,2.925),(47.485,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.925),(47.145,3.095),(47.315,3.095),(47.315,2.925),(47.145,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.305),(42.345,5.475),(42.515,5.475),(42.515,5.305),(42.345,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.305),(42.685,5.475),(42.855,5.475),(42.855,5.305),(42.685,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.645),(42.345,5.815),(42.515,5.815),(42.515,5.645),(42.345,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.645),(42.685,5.815),(42.855,5.815),(42.855,5.645),(42.685,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.985),(47.145,6.155),(47.315,6.155),(47.315,5.985),(47.145,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.685),(57.085,7.855),(57.255,7.855),(57.255,7.685),(57.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.345),(57.085,7.515),(57.255,7.515),(57.255,7.345),(57.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.005),(57.085,7.175),(57.255,7.175),(57.255,7.005),(57.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.265),(47.145,3.435),(47.315,3.435),(47.315,3.265),(47.145,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.265),(47.485,3.435),(47.655,3.435),(47.655,3.265),(47.485,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.605),(47.145,3.775),(47.315,3.775),(47.315,3.605),(47.145,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.605),(47.485,3.775),(47.655,3.775),(47.655,3.605),(47.485,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.145),(37.885,14.315),(38.055,14.315),(38.055,14.145),(37.885,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.185),(37.885,16.355),(38.055,16.355),(38.055,16.185),(37.885,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.525),(37.885,16.695),(38.055,16.695),(38.055,16.525),(37.885,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.485),(37.885,14.655),(38.055,14.655),(38.055,14.485),(37.885,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.005),(33.085,7.175),(33.255,7.175),(33.255,7.005),(33.085,7.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.345),(33.085,7.515),(33.255,7.515),(33.255,7.345),(33.085,7.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.685),(33.085,7.855),(33.255,7.855),(33.255,7.685),(33.085,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.905),(47.485,19.075),(47.655,19.075),(47.655,18.905),(47.485,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.905),(47.145,19.075),(47.315,19.075),(47.315,18.905),(47.145,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.865),(51.945,17.035),(52.115,17.035),(52.115,16.865),(51.945,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.505),(56.745,15.675),(56.915,15.675),(56.915,15.505),(56.745,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.165),(56.745,15.335),(56.915,15.335),(56.915,15.165),(56.745,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.385),(33.085,9.555),(33.255,9.555),(33.255,9.385),(33.085,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.725),(33.085,9.895),(33.255,9.895),(33.255,9.725),(33.085,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.045),(33.085,9.215),(33.255,9.215),(33.255,9.045),(33.085,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.905),(37.545,19.075),(37.715,19.075),(37.715,18.905),(37.545,18.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.245),(47.145,19.415),(47.315,19.415),(47.315,19.245),(47.145,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.245),(47.485,19.415),(47.655,19.415),(47.655,19.245),(47.485,19.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.925),(42.345,3.095),(42.515,3.095),(42.515,2.925),(42.345,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.925),(42.685,3.095),(42.855,3.095),(42.855,2.925),(42.685,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.065),(47.145,10.235),(47.315,10.235),(47.315,10.065),(47.145,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.065),(47.485,10.235),(47.655,10.235),(47.655,10.065),(47.485,10.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.745),(47.145,10.915),(47.315,10.915),(47.315,10.745),(47.145,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.745),(47.485,10.915),(47.655,10.915),(47.655,10.745),(47.485,10.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.405),(47.145,10.575),(47.315,10.575),(47.315,10.405),(47.145,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.405),(47.485,10.575),(47.655,10.575),(47.655,10.405),(47.485,10.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.925),(37.545,3.095),(37.715,3.095),(37.715,2.925),(37.545,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.965),(47.145,5.135),(47.315,5.135),(47.315,4.965),(47.145,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.965),(47.485,5.135),(47.655,5.135),(47.655,4.965),(47.485,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.525),(32.745,16.695),(32.915,16.695),(32.915,16.525),(32.745,16.525)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.185),(32.745,16.355),(32.915,16.355),(32.915,16.185),(32.745,16.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.305),(37.885,5.475),(38.055,5.475),(38.055,5.305),(37.885,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.645),(37.885,5.815),(38.055,5.815),(38.055,5.645),(37.885,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.025),(47.145,8.195),(47.315,8.195),(47.315,8.025),(47.145,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.025),(47.485,8.195),(47.655,8.195),(47.655,8.025),(47.485,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.705),(47.485,8.875),(47.655,8.875),(47.655,8.705),(47.485,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.365),(47.145,8.535),(47.315,8.535),(47.315,8.365),(47.145,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.365),(47.485,8.535),(47.655,8.535),(47.655,8.365),(47.485,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.705),(47.145,8.875),(47.315,8.875),(47.315,8.705),(47.145,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.785),(52.285,12.955),(52.455,12.955),(52.455,12.785),(52.285,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.445),(52.285,12.615),(52.455,12.615),(52.455,12.445),(52.285,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.605),(37.545,3.775),(37.715,3.775),(37.715,3.605),(37.545,3.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.265),(37.545,3.435),(37.715,3.435),(37.715,3.265),(37.545,3.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.105),(52.285,12.275),(52.455,12.275),(52.455,12.105),(52.285,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.885),(51.945,18.055),(52.115,18.055),(52.115,17.885),(51.945,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.545),(47.145,17.715),(47.315,17.715),(47.315,17.545),(47.145,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.205),(47.145,17.375),(47.315,17.375),(47.315,17.205),(47.145,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.205),(47.485,17.375),(47.655,17.375),(47.655,17.205),(47.485,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.545),(47.485,17.715),(47.655,17.715),(47.655,17.545),(47.485,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.965),(42.345,5.135),(42.515,5.135),(42.515,4.965),(42.345,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.965),(42.685,5.135),(42.855,5.135),(42.855,4.965),(42.685,4.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.425),(56.745,11.595),(56.915,11.595),(56.915,11.425),(56.745,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.085),(56.745,11.255),(56.915,11.255),(56.915,11.085),(56.745,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.765),(56.745,11.935),(56.915,11.935),(56.915,11.765),(56.745,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.845),(47.145,16.015),(47.315,16.015),(47.315,15.845),(47.145,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.845),(47.485,16.015),(47.655,16.015),(47.655,15.845),(47.485,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.165),(47.145,15.335),(47.315,15.335),(47.315,15.165),(47.145,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.685),(42.345,7.855),(42.515,7.855),(42.515,7.685),(42.345,7.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.285),(37.885,4.455),(38.055,4.455),(38.055,4.285),(37.885,4.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.625),(37.885,4.795),(38.055,4.795),(38.055,4.625),(37.885,4.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.845),(37.885,16.015),(38.055,16.015),(38.055,15.845),(37.885,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.805),(37.545,13.975),(37.715,13.975),(37.715,13.805),(37.545,13.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.465),(37.545,13.635),(37.715,13.635),(37.715,13.465),(37.545,13.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.125),(37.545,13.295),(37.715,13.295),(37.715,13.125),(37.545,13.125)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.305),(57.085,5.475),(57.255,5.475),(57.255,5.305),(57.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.085),(51.945,11.255),(52.115,11.255),(52.115,11.085),(51.945,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.425),(51.945,11.595),(52.115,11.595),(52.115,11.425),(51.945,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.765),(51.945,11.935),(52.115,11.935),(52.115,11.765),(51.945,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.845),(32.745,16.015),(32.915,16.015),(32.915,15.845),(32.745,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.645),(57.085,5.815),(57.255,5.815),(57.255,5.645),(57.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.485),(51.945,14.655),(52.115,14.655),(52.115,14.485),(51.945,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.825),(51.945,14.995),(52.115,14.995),(52.115,14.825),(51.945,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.145),(51.945,14.315),(52.115,14.315),(52.115,14.145),(51.945,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.305),(33.085,5.475),(33.255,5.475),(33.255,5.305),(33.085,5.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.645),(33.085,5.815),(33.255,5.815),(33.255,5.645),(33.085,5.645)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.445),(57.085,12.615),(57.255,12.615),(57.255,12.445),(57.085,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.785),(57.085,12.955),(57.255,12.955),(57.255,12.785),(57.085,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.025),(33.085,8.195),(33.255,8.195),(33.255,8.025),(33.085,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.105),(57.085,12.275),(57.255,12.275),(57.255,12.105),(57.085,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.365),(33.085,8.535),(33.255,8.535),(33.255,8.365),(33.085,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.705),(33.085,8.875),(33.255,8.875),(33.255,8.705),(33.085,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.105),(42.345,12.275),(42.515,12.275),(42.515,12.105),(42.345,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.105),(42.685,12.275),(42.855,12.275),(42.855,12.105),(42.685,12.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.445),(42.345,12.615),(42.515,12.615),(42.515,12.445),(42.345,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.445),(42.685,12.615),(42.855,12.615),(42.855,12.445),(42.685,12.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.785),(42.345,12.955),(42.515,12.955),(42.515,12.785),(42.345,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.785),(42.685,12.955),(42.855,12.955),(42.855,12.785),(42.685,12.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.945),(47.145,4.115),(47.315,4.115),(47.315,3.945),(47.145,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.945),(47.485,4.115),(47.655,4.115),(47.655,3.945),(47.485,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.145),(42.345,14.315),(42.515,14.315),(42.515,14.145),(42.345,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.145),(42.685,14.315),(42.855,14.315),(42.855,14.145),(42.685,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.485),(42.345,14.655),(42.515,14.655),(42.515,14.485),(42.345,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.485),(42.685,14.655),(42.855,14.655),(42.855,14.485),(42.685,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.825),(42.345,14.995),(42.515,14.995),(42.515,14.825),(42.345,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.825),(42.685,14.995),(42.855,14.995),(42.855,14.825),(42.685,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.925),(51.945,3.095),(52.115,3.095),(52.115,2.925),(51.945,2.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.225),(32.745,18.395),(32.915,18.395),(32.915,18.225),(32.745,18.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.565),(32.745,18.735),(32.915,18.735),(32.915,18.565),(32.745,18.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.385),(37.885,9.555),(38.055,9.555),(38.055,9.385),(37.885,9.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.725),(37.885,9.895),(38.055,9.895),(38.055,9.725),(37.885,9.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.045),(37.885,9.215),(38.055,9.215),(38.055,9.045),(37.885,9.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.325),(47.145,6.495),(47.315,6.495),(47.315,6.325),(47.145,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.325),(47.485,6.495),(47.655,6.495),(47.655,6.325),(47.485,6.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.665),(47.145,6.835),(47.315,6.835),(47.315,6.665),(47.145,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.885),(52.285,18.055),(52.455,18.055),(52.455,17.885),(52.285,17.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.665),(47.485,6.835),(47.655,6.835),(47.655,6.665),(47.485,6.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.205),(42.345,17.375),(42.515,17.375),(42.515,17.205),(42.345,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.205),(42.685,17.375),(42.855,17.375),(42.855,17.205),(42.685,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.545),(42.345,17.715),(42.515,17.715),(42.515,17.545),(42.345,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.545),(42.685,17.715),(42.855,17.715),(42.855,17.545),(42.685,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.945),(37.885,4.115),(38.055,4.115),(38.055,3.945),(37.885,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.205),(56.745,17.375),(56.915,17.375),(56.915,17.205),(56.745,17.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.545),(56.745,17.715),(56.915,17.715),(56.915,17.545),(56.745,17.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.025),(37.545,8.195),(37.715,8.195),(37.715,8.025),(37.545,8.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.705),(37.545,8.875),(37.715,8.875),(37.715,8.705),(37.545,8.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.365),(37.545,8.535),(37.715,8.535),(37.715,8.365),(37.545,8.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.425),(33.085,11.595),(33.255,11.595),(33.255,11.425),(33.085,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.085),(33.085,11.255),(33.255,11.255),(33.255,11.085),(33.085,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.765),(33.085,11.935),(33.255,11.935),(33.255,11.765),(33.085,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.145),(32.745,14.315),(32.915,14.315),(32.915,14.145),(32.745,14.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.485),(32.745,14.655),(32.915,14.655),(32.915,14.485),(32.745,14.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.825),(32.745,14.995),(32.915,14.995),(32.915,14.825),(32.745,14.825)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.845),(51.945,16.015),(52.115,16.015),(52.115,15.845),(51.945,15.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.865),(32.745,17.035),(32.915,17.035),(32.915,16.865),(32.745,16.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.985),(37.885,6.155),(38.055,6.155),(38.055,5.985),(37.885,5.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.085),(52.285,11.255),(52.455,11.255),(52.455,11.085),(52.285,11.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.425),(52.285,11.595),(52.455,11.595),(52.455,11.425),(52.285,11.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.765),(52.285,11.935),(52.455,11.935),(52.455,11.765),(52.285,11.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.165),(57.085,15.335),(57.255,15.335),(57.255,15.165),(57.085,15.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.505),(57.085,15.675),(57.255,15.675),(57.255,15.505),(57.085,15.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.945),(37.545,4.115),(37.715,4.115),(37.715,3.945),(37.545,3.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.985),(47.485,6.155),(47.655,6.155),(47.655,5.985),(47.485,5.985)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.985),(46.775,19.355),(48.025,19.355),(48.025,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.845),(46.775,19.495),(48.025,19.495),(48.025,2.845),(46.775,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.845),(56.375,19.495),(57.625,19.495),(57.625,2.845),(56.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.985),(37.175,19.355),(38.425,19.355),(38.425,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((47.145,2.845),(47.145,19.495),(47.655,19.495),(47.655,2.845),(47.145,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.845),(37.175,19.495),(38.425,19.495),(38.425,2.845),(37.175,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((37.545,2.845),(37.545,19.495),(38.055,19.495),(38.055,2.845),(37.545,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.745,2.845),(32.745,19.495),(33.255,19.495),(33.255,2.845),(32.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.985),(32.375,19.355),(33.625,19.355),(33.625,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.845),(32.375,19.495),(33.625,19.495),(33.625,2.845),(32.375,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.985),(41.975,19.355),(43.225,19.355),(43.225,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((51.945,2.845),(51.945,19.495),(52.455,19.495),(52.455,2.845),(51.945,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.985),(51.575,19.355),(52.825,19.355),(52.825,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.845),(51.575,19.495),(52.825,19.495),(52.825,2.845),(51.575,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.845),(41.975,19.495),(43.225,19.495),(43.225,2.845),(41.975,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.745,2.845),(56.745,19.495),(57.255,19.495),(57.255,2.845),(56.745,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((42.345,2.845),(42.345,19.495),(42.855,19.495),(42.855,2.845),(42.345,2.845)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.985),(56.375,19.355),(57.625,19.355),(57.625,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.985),(32.375,3.155),(32.545,3.155),(32.545,2.985),(32.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.985),(32.735,3.155),(32.905,3.155),(32.905,2.985),(32.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.985),(33.095,3.155),(33.265,3.155),(33.265,2.985),(33.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.985),(33.455,3.155),(33.625,3.155),(33.625,2.985),(33.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.345),(32.375,3.515),(32.545,3.515),(32.545,3.345),(32.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.345),(32.735,3.515),(32.905,3.515),(32.905,3.345),(32.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.345),(33.095,3.515),(33.265,3.515),(33.265,3.345),(33.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.345),(33.455,3.515),(33.625,3.515),(33.625,3.345),(33.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.705),(32.375,3.875),(32.545,3.875),(32.545,3.705),(32.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.705),(32.735,3.875),(32.905,3.875),(32.905,3.705),(32.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.705),(33.095,3.875),(33.265,3.875),(33.265,3.705),(33.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.705),(33.455,3.875),(33.625,3.875),(33.625,3.705),(33.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.065),(32.375,4.235),(32.545,4.235),(32.545,4.065),(32.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.065),(32.735,4.235),(32.905,4.235),(32.905,4.065),(32.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.065),(33.095,4.235),(33.265,4.235),(33.265,4.065),(33.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.065),(33.455,4.235),(33.625,4.235),(33.625,4.065),(33.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.425),(32.375,4.595),(32.545,4.595),(32.545,4.425),(32.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.425),(32.735,4.595),(32.905,4.595),(32.905,4.425),(32.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.425),(33.095,4.595),(33.265,4.595),(33.265,4.425),(33.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.425),(33.455,4.595),(33.625,4.595),(33.625,4.425),(33.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.785),(32.375,4.955),(32.545,4.955),(32.545,4.785),(32.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.785),(32.735,4.955),(32.905,4.955),(32.905,4.785),(32.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.785),(33.095,4.955),(33.265,4.955),(33.265,4.785),(33.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.785),(33.455,4.955),(33.625,4.955),(33.625,4.785),(33.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.145),(32.375,5.315),(32.545,5.315),(32.545,5.145),(32.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.145),(32.735,5.315),(32.905,5.315),(32.905,5.145),(32.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.145),(33.095,5.315),(33.265,5.315),(33.265,5.145),(33.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.145),(33.455,5.315),(33.625,5.315),(33.625,5.145),(33.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.505),(32.375,5.675),(32.545,5.675),(32.545,5.505),(32.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.505),(32.735,5.675),(32.905,5.675),(32.905,5.505),(32.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.505),(33.095,5.675),(33.265,5.675),(33.265,5.505),(33.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.505),(33.455,5.675),(33.625,5.675),(33.625,5.505),(33.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.865),(32.375,6.035),(32.545,6.035),(32.545,5.865),(32.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.865),(32.735,6.035),(32.905,6.035),(32.905,5.865),(32.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.865),(33.095,6.035),(33.265,6.035),(33.265,5.865),(33.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.865),(33.455,6.035),(33.625,6.035),(33.625,5.865),(33.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.225),(32.375,6.395),(32.545,6.395),(32.545,6.225),(32.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.225),(32.735,6.395),(32.905,6.395),(32.905,6.225),(32.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.225),(33.095,6.395),(33.265,6.395),(33.265,6.225),(33.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.225),(33.455,6.395),(33.625,6.395),(33.625,6.225),(33.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.585),(32.375,6.755),(32.545,6.755),(32.545,6.585),(32.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.585),(32.735,6.755),(32.905,6.755),(32.905,6.585),(32.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.585),(33.095,6.755),(33.265,6.755),(33.265,6.585),(33.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.585),(33.455,6.755),(33.625,6.755),(33.625,6.585),(33.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.945),(32.375,7.115),(32.545,7.115),(32.545,6.945),(32.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.945),(32.735,7.115),(32.905,7.115),(32.905,6.945),(32.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.945),(33.095,7.115),(33.265,7.115),(33.265,6.945),(33.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.945),(33.455,7.115),(33.625,7.115),(33.625,6.945),(33.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.305),(32.375,7.475),(32.545,7.475),(32.545,7.305),(32.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.305),(32.735,7.475),(32.905,7.475),(32.905,7.305),(32.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.305),(33.095,7.475),(33.265,7.475),(33.265,7.305),(33.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.305),(33.455,7.475),(33.625,7.475),(33.625,7.305),(33.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.665),(32.375,7.835),(32.545,7.835),(32.545,7.665),(32.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.665),(32.735,7.835),(32.905,7.835),(32.905,7.665),(32.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.665),(33.095,7.835),(33.265,7.835),(33.265,7.665),(33.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.665),(33.455,7.835),(33.625,7.835),(33.625,7.665),(33.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.025),(32.375,8.195),(32.545,8.195),(32.545,8.025),(32.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.025),(32.735,8.195),(32.905,8.195),(32.905,8.025),(32.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.025),(33.095,8.195),(33.265,8.195),(33.265,8.025),(33.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.025),(33.455,8.195),(33.625,8.195),(33.625,8.025),(33.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.385),(32.375,8.555),(32.545,8.555),(32.545,8.385),(32.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.385),(32.735,8.555),(32.905,8.555),(32.905,8.385),(32.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.385),(33.095,8.555),(33.265,8.555),(33.265,8.385),(33.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.385),(33.455,8.555),(33.625,8.555),(33.625,8.385),(33.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.745),(32.375,8.915),(32.545,8.915),(32.545,8.745),(32.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.745),(32.735,8.915),(32.905,8.915),(32.905,8.745),(32.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.745),(33.095,8.915),(33.265,8.915),(33.265,8.745),(33.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.745),(33.455,8.915),(33.625,8.915),(33.625,8.745),(33.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.105),(32.375,9.275),(32.545,9.275),(32.545,9.105),(32.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.105),(32.735,9.275),(32.905,9.275),(32.905,9.105),(32.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.105),(33.095,9.275),(33.265,9.275),(33.265,9.105),(33.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.105),(33.455,9.275),(33.625,9.275),(33.625,9.105),(33.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.465),(32.375,9.635),(32.545,9.635),(32.545,9.465),(32.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.465),(32.735,9.635),(32.905,9.635),(32.905,9.465),(32.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.465),(33.095,9.635),(33.265,9.635),(33.265,9.465),(33.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.465),(33.455,9.635),(33.625,9.635),(33.625,9.465),(33.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.825),(32.375,9.995),(32.545,9.995),(32.545,9.825),(32.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.825),(32.735,9.995),(32.905,9.995),(32.905,9.825),(32.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.825),(33.095,9.995),(33.265,9.995),(33.265,9.825),(33.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.825),(33.455,9.995),(33.625,9.995),(33.625,9.825),(33.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.185),(32.375,10.355),(32.545,10.355),(32.545,10.185),(32.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.185),(32.735,10.355),(32.905,10.355),(32.905,10.185),(32.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.185),(33.095,10.355),(33.265,10.355),(33.265,10.185),(33.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.185),(33.455,10.355),(33.625,10.355),(33.625,10.185),(33.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.545),(32.375,10.715),(32.545,10.715),(32.545,10.545),(32.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.545),(32.735,10.715),(32.905,10.715),(32.905,10.545),(32.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.545),(33.095,10.715),(33.265,10.715),(33.265,10.545),(33.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.545),(33.455,10.715),(33.625,10.715),(33.625,10.545),(33.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.905),(32.375,11.075),(32.545,11.075),(32.545,10.905),(32.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.905),(32.735,11.075),(32.905,11.075),(32.905,10.905),(32.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.905),(33.095,11.075),(33.265,11.075),(33.265,10.905),(33.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.905),(33.455,11.075),(33.625,11.075),(33.625,10.905),(33.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.265),(32.375,11.435),(32.545,11.435),(32.545,11.265),(32.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.265),(32.735,11.435),(32.905,11.435),(32.905,11.265),(32.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.265),(33.095,11.435),(33.265,11.435),(33.265,11.265),(33.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.265),(33.455,11.435),(33.625,11.435),(33.625,11.265),(33.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.625),(32.375,11.795),(32.545,11.795),(32.545,11.625),(32.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.625),(32.735,11.795),(32.905,11.795),(32.905,11.625),(32.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.625),(33.095,11.795),(33.265,11.795),(33.265,11.625),(33.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.625),(33.455,11.795),(33.625,11.795),(33.625,11.625),(33.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.985),(32.375,12.155),(32.545,12.155),(32.545,11.985),(32.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.985),(32.735,12.155),(32.905,12.155),(32.905,11.985),(32.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.985),(33.095,12.155),(33.265,12.155),(33.265,11.985),(33.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.985),(33.455,12.155),(33.625,12.155),(33.625,11.985),(33.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.345),(32.375,12.515),(32.545,12.515),(32.545,12.345),(32.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.345),(32.735,12.515),(32.905,12.515),(32.905,12.345),(32.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.345),(33.095,12.515),(33.265,12.515),(33.265,12.345),(33.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.345),(33.455,12.515),(33.625,12.515),(33.625,12.345),(33.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.705),(32.375,12.875),(32.545,12.875),(32.545,12.705),(32.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.705),(32.735,12.875),(32.905,12.875),(32.905,12.705),(32.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.705),(33.095,12.875),(33.265,12.875),(33.265,12.705),(33.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.705),(33.455,12.875),(33.625,12.875),(33.625,12.705),(33.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.065),(32.375,13.235),(32.545,13.235),(32.545,13.065),(32.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.065),(32.735,13.235),(32.905,13.235),(32.905,13.065),(32.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.065),(33.095,13.235),(33.265,13.235),(33.265,13.065),(33.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.065),(33.455,13.235),(33.625,13.235),(33.625,13.065),(33.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.425),(32.375,13.595),(32.545,13.595),(32.545,13.425),(32.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.425),(32.735,13.595),(32.905,13.595),(32.905,13.425),(32.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.425),(33.095,13.595),(33.265,13.595),(33.265,13.425),(33.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.425),(33.455,13.595),(33.625,13.595),(33.625,13.425),(33.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.785),(32.375,13.955),(32.545,13.955),(32.545,13.785),(32.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.785),(32.735,13.955),(32.905,13.955),(32.905,13.785),(32.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.785),(33.095,13.955),(33.265,13.955),(33.265,13.785),(33.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.785),(33.455,13.955),(33.625,13.955),(33.625,13.785),(33.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.145),(32.375,14.315),(32.545,14.315),(32.545,14.145),(32.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.145),(32.735,14.315),(32.905,14.315),(32.905,14.145),(32.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.145),(33.095,14.315),(33.265,14.315),(33.265,14.145),(33.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.145),(33.455,14.315),(33.625,14.315),(33.625,14.145),(33.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.505),(32.375,14.675),(32.545,14.675),(32.545,14.505),(32.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.505),(32.735,14.675),(32.905,14.675),(32.905,14.505),(32.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.505),(33.095,14.675),(33.265,14.675),(33.265,14.505),(33.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.505),(33.455,14.675),(33.625,14.675),(33.625,14.505),(33.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.865),(32.375,15.035),(32.545,15.035),(32.545,14.865),(32.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.865),(32.735,15.035),(32.905,15.035),(32.905,14.865),(32.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.865),(33.095,15.035),(33.265,15.035),(33.265,14.865),(33.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.865),(33.455,15.035),(33.625,15.035),(33.625,14.865),(33.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.225),(32.375,15.395),(32.545,15.395),(32.545,15.225),(32.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.225),(32.735,15.395),(32.905,15.395),(32.905,15.225),(32.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.225),(33.095,15.395),(33.265,15.395),(33.265,15.225),(33.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.225),(33.455,15.395),(33.625,15.395),(33.625,15.225),(33.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.585),(32.375,15.755),(32.545,15.755),(32.545,15.585),(32.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.585),(32.735,15.755),(32.905,15.755),(32.905,15.585),(32.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.585),(33.095,15.755),(33.265,15.755),(33.265,15.585),(33.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.585),(33.455,15.755),(33.625,15.755),(33.625,15.585),(33.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.945),(32.375,16.115),(32.545,16.115),(32.545,15.945),(32.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.945),(32.735,16.115),(32.905,16.115),(32.905,15.945),(32.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.945),(33.095,16.115),(33.265,16.115),(33.265,15.945),(33.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.945),(33.455,16.115),(33.625,16.115),(33.625,15.945),(33.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.305),(32.375,16.475),(32.545,16.475),(32.545,16.305),(32.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.305),(32.735,16.475),(32.905,16.475),(32.905,16.305),(32.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.305),(33.095,16.475),(33.265,16.475),(33.265,16.305),(33.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.305),(33.455,16.475),(33.625,16.475),(33.625,16.305),(33.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.665),(32.375,16.835),(32.545,16.835),(32.545,16.665),(32.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.665),(32.735,16.835),(32.905,16.835),(32.905,16.665),(32.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.665),(33.095,16.835),(33.265,16.835),(33.265,16.665),(33.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.665),(33.455,16.835),(33.625,16.835),(33.625,16.665),(33.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.025),(32.375,17.195),(32.545,17.195),(32.545,17.025),(32.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.025),(32.735,17.195),(32.905,17.195),(32.905,17.025),(32.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.025),(33.095,17.195),(33.265,17.195),(33.265,17.025),(33.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.025),(33.455,17.195),(33.625,17.195),(33.625,17.025),(33.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.385),(32.375,17.555),(32.545,17.555),(32.545,17.385),(32.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.385),(32.735,17.555),(32.905,17.555),(32.905,17.385),(32.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.385),(33.095,17.555),(33.265,17.555),(33.265,17.385),(33.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.385),(33.455,17.555),(33.625,17.555),(33.625,17.385),(33.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.745),(32.375,17.915),(32.545,17.915),(32.545,17.745),(32.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.745),(32.735,17.915),(32.905,17.915),(32.905,17.745),(32.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.745),(33.095,17.915),(33.265,17.915),(33.265,17.745),(33.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.745),(33.455,17.915),(33.625,17.915),(33.625,17.745),(33.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.105),(32.375,18.275),(32.545,18.275),(32.545,18.105),(32.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.105),(32.735,18.275),(32.905,18.275),(32.905,18.105),(32.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.105),(33.095,18.275),(33.265,18.275),(33.265,18.105),(33.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.105),(33.455,18.275),(33.625,18.275),(33.625,18.105),(33.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.465),(32.375,18.635),(32.545,18.635),(32.545,18.465),(32.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.465),(32.735,18.635),(32.905,18.635),(32.905,18.465),(32.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.465),(33.095,18.635),(33.265,18.635),(33.265,18.465),(33.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.465),(33.455,18.635),(33.625,18.635),(33.625,18.465),(33.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.825),(32.375,18.995),(32.545,18.995),(32.545,18.825),(32.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.825),(32.735,18.995),(32.905,18.995),(32.905,18.825),(32.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.825),(33.095,18.995),(33.265,18.995),(33.265,18.825),(33.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.825),(33.455,18.995),(33.625,18.995),(33.625,18.825),(33.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.185),(32.375,19.355),(32.545,19.355),(32.545,19.185),(32.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.185),(32.735,19.355),(32.905,19.355),(32.905,19.185),(32.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.185),(33.095,19.355),(33.265,19.355),(33.265,19.185),(33.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.185),(33.455,19.355),(33.625,19.355),(33.625,19.185),(33.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.985),(41.975,3.155),(42.145,3.155),(42.145,2.985),(41.975,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.985),(42.335,3.155),(42.505,3.155),(42.505,2.985),(42.335,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.985),(42.695,3.155),(42.865,3.155),(42.865,2.985),(42.695,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.985),(43.055,3.155),(43.225,3.155),(43.225,2.985),(43.055,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.345),(41.975,3.515),(42.145,3.515),(42.145,3.345),(41.975,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.345),(42.335,3.515),(42.505,3.515),(42.505,3.345),(42.335,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.345),(42.695,3.515),(42.865,3.515),(42.865,3.345),(42.695,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.345),(43.055,3.515),(43.225,3.515),(43.225,3.345),(43.055,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.705),(41.975,3.875),(42.145,3.875),(42.145,3.705),(41.975,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.705),(42.335,3.875),(42.505,3.875),(42.505,3.705),(42.335,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.705),(42.695,3.875),(42.865,3.875),(42.865,3.705),(42.695,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.705),(43.055,3.875),(43.225,3.875),(43.225,3.705),(43.055,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.065),(41.975,4.235),(42.145,4.235),(42.145,4.065),(41.975,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.065),(42.335,4.235),(42.505,4.235),(42.505,4.065),(42.335,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.065),(42.695,4.235),(42.865,4.235),(42.865,4.065),(42.695,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.065),(43.055,4.235),(43.225,4.235),(43.225,4.065),(43.055,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.425),(41.975,4.595),(42.145,4.595),(42.145,4.425),(41.975,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.425),(42.335,4.595),(42.505,4.595),(42.505,4.425),(42.335,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.425),(42.695,4.595),(42.865,4.595),(42.865,4.425),(42.695,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.425),(43.055,4.595),(43.225,4.595),(43.225,4.425),(43.055,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.785),(41.975,4.955),(42.145,4.955),(42.145,4.785),(41.975,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.785),(42.335,4.955),(42.505,4.955),(42.505,4.785),(42.335,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.785),(42.695,4.955),(42.865,4.955),(42.865,4.785),(42.695,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.785),(43.055,4.955),(43.225,4.955),(43.225,4.785),(43.055,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.145),(41.975,5.315),(42.145,5.315),(42.145,5.145),(41.975,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.145),(42.335,5.315),(42.505,5.315),(42.505,5.145),(42.335,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.145),(42.695,5.315),(42.865,5.315),(42.865,5.145),(42.695,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.145),(43.055,5.315),(43.225,5.315),(43.225,5.145),(43.055,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.505),(41.975,5.675),(42.145,5.675),(42.145,5.505),(41.975,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.505),(42.335,5.675),(42.505,5.675),(42.505,5.505),(42.335,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.505),(42.695,5.675),(42.865,5.675),(42.865,5.505),(42.695,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.505),(43.055,5.675),(43.225,5.675),(43.225,5.505),(43.055,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.865),(41.975,6.035),(42.145,6.035),(42.145,5.865),(41.975,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.865),(42.335,6.035),(42.505,6.035),(42.505,5.865),(42.335,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.865),(42.695,6.035),(42.865,6.035),(42.865,5.865),(42.695,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.865),(43.055,6.035),(43.225,6.035),(43.225,5.865),(43.055,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.225),(41.975,6.395),(42.145,6.395),(42.145,6.225),(41.975,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.225),(42.335,6.395),(42.505,6.395),(42.505,6.225),(42.335,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.225),(42.695,6.395),(42.865,6.395),(42.865,6.225),(42.695,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.225),(43.055,6.395),(43.225,6.395),(43.225,6.225),(43.055,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.585),(41.975,6.755),(42.145,6.755),(42.145,6.585),(41.975,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.585),(42.335,6.755),(42.505,6.755),(42.505,6.585),(42.335,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.585),(42.695,6.755),(42.865,6.755),(42.865,6.585),(42.695,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.585),(43.055,6.755),(43.225,6.755),(43.225,6.585),(43.055,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.945),(41.975,7.115),(42.145,7.115),(42.145,6.945),(41.975,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.945),(42.335,7.115),(42.505,7.115),(42.505,6.945),(42.335,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.945),(42.695,7.115),(42.865,7.115),(42.865,6.945),(42.695,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.945),(43.055,7.115),(43.225,7.115),(43.225,6.945),(43.055,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.305),(41.975,7.475),(42.145,7.475),(42.145,7.305),(41.975,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.305),(42.335,7.475),(42.505,7.475),(42.505,7.305),(42.335,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.305),(42.695,7.475),(42.865,7.475),(42.865,7.305),(42.695,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.305),(43.055,7.475),(43.225,7.475),(43.225,7.305),(43.055,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.665),(41.975,7.835),(42.145,7.835),(42.145,7.665),(41.975,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.665),(42.335,7.835),(42.505,7.835),(42.505,7.665),(42.335,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.665),(42.695,7.835),(42.865,7.835),(42.865,7.665),(42.695,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.665),(43.055,7.835),(43.225,7.835),(43.225,7.665),(43.055,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.025),(41.975,8.195),(42.145,8.195),(42.145,8.025),(41.975,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.025),(42.335,8.195),(42.505,8.195),(42.505,8.025),(42.335,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.025),(42.695,8.195),(42.865,8.195),(42.865,8.025),(42.695,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.025),(43.055,8.195),(43.225,8.195),(43.225,8.025),(43.055,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.385),(41.975,8.555),(42.145,8.555),(42.145,8.385),(41.975,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.385),(42.335,8.555),(42.505,8.555),(42.505,8.385),(42.335,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.385),(42.695,8.555),(42.865,8.555),(42.865,8.385),(42.695,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.385),(43.055,8.555),(43.225,8.555),(43.225,8.385),(43.055,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.745),(41.975,8.915),(42.145,8.915),(42.145,8.745),(41.975,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.745),(42.335,8.915),(42.505,8.915),(42.505,8.745),(42.335,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.745),(42.695,8.915),(42.865,8.915),(42.865,8.745),(42.695,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.745),(43.055,8.915),(43.225,8.915),(43.225,8.745),(43.055,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.105),(41.975,9.275),(42.145,9.275),(42.145,9.105),(41.975,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.105),(42.335,9.275),(42.505,9.275),(42.505,9.105),(42.335,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.105),(42.695,9.275),(42.865,9.275),(42.865,9.105),(42.695,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.105),(43.055,9.275),(43.225,9.275),(43.225,9.105),(43.055,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.465),(41.975,9.635),(42.145,9.635),(42.145,9.465),(41.975,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.465),(42.335,9.635),(42.505,9.635),(42.505,9.465),(42.335,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.465),(42.695,9.635),(42.865,9.635),(42.865,9.465),(42.695,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.465),(43.055,9.635),(43.225,9.635),(43.225,9.465),(43.055,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.825),(41.975,9.995),(42.145,9.995),(42.145,9.825),(41.975,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.825),(42.335,9.995),(42.505,9.995),(42.505,9.825),(42.335,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.825),(42.695,9.995),(42.865,9.995),(42.865,9.825),(42.695,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.825),(43.055,9.995),(43.225,9.995),(43.225,9.825),(43.055,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.185),(41.975,10.355),(42.145,10.355),(42.145,10.185),(41.975,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.185),(42.335,10.355),(42.505,10.355),(42.505,10.185),(42.335,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.185),(42.695,10.355),(42.865,10.355),(42.865,10.185),(42.695,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.185),(43.055,10.355),(43.225,10.355),(43.225,10.185),(43.055,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.545),(41.975,10.715),(42.145,10.715),(42.145,10.545),(41.975,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.545),(42.335,10.715),(42.505,10.715),(42.505,10.545),(42.335,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.545),(42.695,10.715),(42.865,10.715),(42.865,10.545),(42.695,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.545),(43.055,10.715),(43.225,10.715),(43.225,10.545),(43.055,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.905),(41.975,11.075),(42.145,11.075),(42.145,10.905),(41.975,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.905),(42.335,11.075),(42.505,11.075),(42.505,10.905),(42.335,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.905),(42.695,11.075),(42.865,11.075),(42.865,10.905),(42.695,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.905),(43.055,11.075),(43.225,11.075),(43.225,10.905),(43.055,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.265),(41.975,11.435),(42.145,11.435),(42.145,11.265),(41.975,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.265),(42.335,11.435),(42.505,11.435),(42.505,11.265),(42.335,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.265),(42.695,11.435),(42.865,11.435),(42.865,11.265),(42.695,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.265),(43.055,11.435),(43.225,11.435),(43.225,11.265),(43.055,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.625),(41.975,11.795),(42.145,11.795),(42.145,11.625),(41.975,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.625),(42.335,11.795),(42.505,11.795),(42.505,11.625),(42.335,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.625),(42.695,11.795),(42.865,11.795),(42.865,11.625),(42.695,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.625),(43.055,11.795),(43.225,11.795),(43.225,11.625),(43.055,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.985),(41.975,12.155),(42.145,12.155),(42.145,11.985),(41.975,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.985),(42.335,12.155),(42.505,12.155),(42.505,11.985),(42.335,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.985),(42.695,12.155),(42.865,12.155),(42.865,11.985),(42.695,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.985),(43.055,12.155),(43.225,12.155),(43.225,11.985),(43.055,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.345),(41.975,12.515),(42.145,12.515),(42.145,12.345),(41.975,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.345),(42.335,12.515),(42.505,12.515),(42.505,12.345),(42.335,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.345),(42.695,12.515),(42.865,12.515),(42.865,12.345),(42.695,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.345),(43.055,12.515),(43.225,12.515),(43.225,12.345),(43.055,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.705),(41.975,12.875),(42.145,12.875),(42.145,12.705),(41.975,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.705),(42.335,12.875),(42.505,12.875),(42.505,12.705),(42.335,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.705),(42.695,12.875),(42.865,12.875),(42.865,12.705),(42.695,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.705),(43.055,12.875),(43.225,12.875),(43.225,12.705),(43.055,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.065),(41.975,13.235),(42.145,13.235),(42.145,13.065),(41.975,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.065),(42.335,13.235),(42.505,13.235),(42.505,13.065),(42.335,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.065),(42.695,13.235),(42.865,13.235),(42.865,13.065),(42.695,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.065),(43.055,13.235),(43.225,13.235),(43.225,13.065),(43.055,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.425),(41.975,13.595),(42.145,13.595),(42.145,13.425),(41.975,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.425),(42.335,13.595),(42.505,13.595),(42.505,13.425),(42.335,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.425),(42.695,13.595),(42.865,13.595),(42.865,13.425),(42.695,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.425),(43.055,13.595),(43.225,13.595),(43.225,13.425),(43.055,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.785),(41.975,13.955),(42.145,13.955),(42.145,13.785),(41.975,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.785),(42.335,13.955),(42.505,13.955),(42.505,13.785),(42.335,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.785),(42.695,13.955),(42.865,13.955),(42.865,13.785),(42.695,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.785),(43.055,13.955),(43.225,13.955),(43.225,13.785),(43.055,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.145),(41.975,14.315),(42.145,14.315),(42.145,14.145),(41.975,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.145),(42.335,14.315),(42.505,14.315),(42.505,14.145),(42.335,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.145),(42.695,14.315),(42.865,14.315),(42.865,14.145),(42.695,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.145),(43.055,14.315),(43.225,14.315),(43.225,14.145),(43.055,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.505),(41.975,14.675),(42.145,14.675),(42.145,14.505),(41.975,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.505),(42.335,14.675),(42.505,14.675),(42.505,14.505),(42.335,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.505),(42.695,14.675),(42.865,14.675),(42.865,14.505),(42.695,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.505),(43.055,14.675),(43.225,14.675),(43.225,14.505),(43.055,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.865),(41.975,15.035),(42.145,15.035),(42.145,14.865),(41.975,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.865),(42.335,15.035),(42.505,15.035),(42.505,14.865),(42.335,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.865),(42.695,15.035),(42.865,15.035),(42.865,14.865),(42.695,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.865),(43.055,15.035),(43.225,15.035),(43.225,14.865),(43.055,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.225),(41.975,15.395),(42.145,15.395),(42.145,15.225),(41.975,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.225),(42.335,15.395),(42.505,15.395),(42.505,15.225),(42.335,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.225),(42.695,15.395),(42.865,15.395),(42.865,15.225),(42.695,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.225),(43.055,15.395),(43.225,15.395),(43.225,15.225),(43.055,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.585),(41.975,15.755),(42.145,15.755),(42.145,15.585),(41.975,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.585),(42.335,15.755),(42.505,15.755),(42.505,15.585),(42.335,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.585),(42.695,15.755),(42.865,15.755),(42.865,15.585),(42.695,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.585),(43.055,15.755),(43.225,15.755),(43.225,15.585),(43.055,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.945),(41.975,16.115),(42.145,16.115),(42.145,15.945),(41.975,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.945),(42.335,16.115),(42.505,16.115),(42.505,15.945),(42.335,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.945),(42.695,16.115),(42.865,16.115),(42.865,15.945),(42.695,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.945),(43.055,16.115),(43.225,16.115),(43.225,15.945),(43.055,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.305),(41.975,16.475),(42.145,16.475),(42.145,16.305),(41.975,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.305),(42.335,16.475),(42.505,16.475),(42.505,16.305),(42.335,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.305),(42.695,16.475),(42.865,16.475),(42.865,16.305),(42.695,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.305),(43.055,16.475),(43.225,16.475),(43.225,16.305),(43.055,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.665),(41.975,16.835),(42.145,16.835),(42.145,16.665),(41.975,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.665),(42.335,16.835),(42.505,16.835),(42.505,16.665),(42.335,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.665),(42.695,16.835),(42.865,16.835),(42.865,16.665),(42.695,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.665),(43.055,16.835),(43.225,16.835),(43.225,16.665),(43.055,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.025),(41.975,17.195),(42.145,17.195),(42.145,17.025),(41.975,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.025),(42.335,17.195),(42.505,17.195),(42.505,17.025),(42.335,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.025),(42.695,17.195),(42.865,17.195),(42.865,17.025),(42.695,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.025),(43.055,17.195),(43.225,17.195),(43.225,17.025),(43.055,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.385),(41.975,17.555),(42.145,17.555),(42.145,17.385),(41.975,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.385),(42.335,17.555),(42.505,17.555),(42.505,17.385),(42.335,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.385),(42.695,17.555),(42.865,17.555),(42.865,17.385),(42.695,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.385),(43.055,17.555),(43.225,17.555),(43.225,17.385),(43.055,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.745),(41.975,17.915),(42.145,17.915),(42.145,17.745),(41.975,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.745),(42.335,17.915),(42.505,17.915),(42.505,17.745),(42.335,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.745),(42.695,17.915),(42.865,17.915),(42.865,17.745),(42.695,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.745),(43.055,17.915),(43.225,17.915),(43.225,17.745),(43.055,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.105),(41.975,18.275),(42.145,18.275),(42.145,18.105),(41.975,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.105),(42.335,18.275),(42.505,18.275),(42.505,18.105),(42.335,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.105),(42.695,18.275),(42.865,18.275),(42.865,18.105),(42.695,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.105),(43.055,18.275),(43.225,18.275),(43.225,18.105),(43.055,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.465),(41.975,18.635),(42.145,18.635),(42.145,18.465),(41.975,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.465),(42.335,18.635),(42.505,18.635),(42.505,18.465),(42.335,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.465),(42.695,18.635),(42.865,18.635),(42.865,18.465),(42.695,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.465),(43.055,18.635),(43.225,18.635),(43.225,18.465),(43.055,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.825),(41.975,18.995),(42.145,18.995),(42.145,18.825),(41.975,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.825),(42.335,18.995),(42.505,18.995),(42.505,18.825),(42.335,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.825),(42.695,18.995),(42.865,18.995),(42.865,18.825),(42.695,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.825),(43.055,18.995),(43.225,18.995),(43.225,18.825),(43.055,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.185),(41.975,19.355),(42.145,19.355),(42.145,19.185),(41.975,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.185),(42.335,19.355),(42.505,19.355),(42.505,19.185),(42.335,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.185),(42.695,19.355),(42.865,19.355),(42.865,19.185),(42.695,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.185),(43.055,19.355),(43.225,19.355),(43.225,19.185),(43.055,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.985),(37.175,3.155),(37.345,3.155),(37.345,2.985),(37.175,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.985),(37.535,3.155),(37.705,3.155),(37.705,2.985),(37.535,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.985),(37.895,3.155),(38.065,3.155),(38.065,2.985),(37.895,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.985),(38.255,3.155),(38.425,3.155),(38.425,2.985),(38.255,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.345),(37.175,3.515),(37.345,3.515),(37.345,3.345),(37.175,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.345),(37.535,3.515),(37.705,3.515),(37.705,3.345),(37.535,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.345),(37.895,3.515),(38.065,3.515),(38.065,3.345),(37.895,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.345),(38.255,3.515),(38.425,3.515),(38.425,3.345),(38.255,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.705),(37.175,3.875),(37.345,3.875),(37.345,3.705),(37.175,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.705),(37.535,3.875),(37.705,3.875),(37.705,3.705),(37.535,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.705),(37.895,3.875),(38.065,3.875),(38.065,3.705),(37.895,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.705),(38.255,3.875),(38.425,3.875),(38.425,3.705),(38.255,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.065),(37.175,4.235),(37.345,4.235),(37.345,4.065),(37.175,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.065),(37.535,4.235),(37.705,4.235),(37.705,4.065),(37.535,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.065),(37.895,4.235),(38.065,4.235),(38.065,4.065),(37.895,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.065),(38.255,4.235),(38.425,4.235),(38.425,4.065),(38.255,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.425),(37.175,4.595),(37.345,4.595),(37.345,4.425),(37.175,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.425),(37.535,4.595),(37.705,4.595),(37.705,4.425),(37.535,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.425),(37.895,4.595),(38.065,4.595),(38.065,4.425),(37.895,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.425),(38.255,4.595),(38.425,4.595),(38.425,4.425),(38.255,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.785),(37.175,4.955),(37.345,4.955),(37.345,4.785),(37.175,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.785),(37.535,4.955),(37.705,4.955),(37.705,4.785),(37.535,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.785),(37.895,4.955),(38.065,4.955),(38.065,4.785),(37.895,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.785),(38.255,4.955),(38.425,4.955),(38.425,4.785),(38.255,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.145),(37.175,5.315),(37.345,5.315),(37.345,5.145),(37.175,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.145),(37.535,5.315),(37.705,5.315),(37.705,5.145),(37.535,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.145),(37.895,5.315),(38.065,5.315),(38.065,5.145),(37.895,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.145),(38.255,5.315),(38.425,5.315),(38.425,5.145),(38.255,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.505),(37.175,5.675),(37.345,5.675),(37.345,5.505),(37.175,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.505),(37.535,5.675),(37.705,5.675),(37.705,5.505),(37.535,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.505),(37.895,5.675),(38.065,5.675),(38.065,5.505),(37.895,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.505),(38.255,5.675),(38.425,5.675),(38.425,5.505),(38.255,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.865),(37.175,6.035),(37.345,6.035),(37.345,5.865),(37.175,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.865),(37.535,6.035),(37.705,6.035),(37.705,5.865),(37.535,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.865),(37.895,6.035),(38.065,6.035),(38.065,5.865),(37.895,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.865),(38.255,6.035),(38.425,6.035),(38.425,5.865),(38.255,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.225),(37.175,6.395),(37.345,6.395),(37.345,6.225),(37.175,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.225),(37.535,6.395),(37.705,6.395),(37.705,6.225),(37.535,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.225),(37.895,6.395),(38.065,6.395),(38.065,6.225),(37.895,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.225),(38.255,6.395),(38.425,6.395),(38.425,6.225),(38.255,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.585),(37.175,6.755),(37.345,6.755),(37.345,6.585),(37.175,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.585),(37.535,6.755),(37.705,6.755),(37.705,6.585),(37.535,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.585),(37.895,6.755),(38.065,6.755),(38.065,6.585),(37.895,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.585),(38.255,6.755),(38.425,6.755),(38.425,6.585),(38.255,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.945),(37.175,7.115),(37.345,7.115),(37.345,6.945),(37.175,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.945),(37.535,7.115),(37.705,7.115),(37.705,6.945),(37.535,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.945),(37.895,7.115),(38.065,7.115),(38.065,6.945),(37.895,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.945),(38.255,7.115),(38.425,7.115),(38.425,6.945),(38.255,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.305),(37.175,7.475),(37.345,7.475),(37.345,7.305),(37.175,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.305),(37.535,7.475),(37.705,7.475),(37.705,7.305),(37.535,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.305),(37.895,7.475),(38.065,7.475),(38.065,7.305),(37.895,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.305),(38.255,7.475),(38.425,7.475),(38.425,7.305),(38.255,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.665),(37.175,7.835),(37.345,7.835),(37.345,7.665),(37.175,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.665),(37.535,7.835),(37.705,7.835),(37.705,7.665),(37.535,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.665),(37.895,7.835),(38.065,7.835),(38.065,7.665),(37.895,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.665),(38.255,7.835),(38.425,7.835),(38.425,7.665),(38.255,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.025),(37.175,8.195),(37.345,8.195),(37.345,8.025),(37.175,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.025),(37.535,8.195),(37.705,8.195),(37.705,8.025),(37.535,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.025),(37.895,8.195),(38.065,8.195),(38.065,8.025),(37.895,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.025),(38.255,8.195),(38.425,8.195),(38.425,8.025),(38.255,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.385),(37.175,8.555),(37.345,8.555),(37.345,8.385),(37.175,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.385),(37.535,8.555),(37.705,8.555),(37.705,8.385),(37.535,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.385),(37.895,8.555),(38.065,8.555),(38.065,8.385),(37.895,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.385),(38.255,8.555),(38.425,8.555),(38.425,8.385),(38.255,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.745),(37.175,8.915),(37.345,8.915),(37.345,8.745),(37.175,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.745),(37.535,8.915),(37.705,8.915),(37.705,8.745),(37.535,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.745),(37.895,8.915),(38.065,8.915),(38.065,8.745),(37.895,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.745),(38.255,8.915),(38.425,8.915),(38.425,8.745),(38.255,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.105),(37.175,9.275),(37.345,9.275),(37.345,9.105),(37.175,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.105),(37.535,9.275),(37.705,9.275),(37.705,9.105),(37.535,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.105),(37.895,9.275),(38.065,9.275),(38.065,9.105),(37.895,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.105),(38.255,9.275),(38.425,9.275),(38.425,9.105),(38.255,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.465),(37.175,9.635),(37.345,9.635),(37.345,9.465),(37.175,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.465),(37.535,9.635),(37.705,9.635),(37.705,9.465),(37.535,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.465),(37.895,9.635),(38.065,9.635),(38.065,9.465),(37.895,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.465),(38.255,9.635),(38.425,9.635),(38.425,9.465),(38.255,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.825),(37.175,9.995),(37.345,9.995),(37.345,9.825),(37.175,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.825),(37.535,9.995),(37.705,9.995),(37.705,9.825),(37.535,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.825),(37.895,9.995),(38.065,9.995),(38.065,9.825),(37.895,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.825),(38.255,9.995),(38.425,9.995),(38.425,9.825),(38.255,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.185),(37.175,10.355),(37.345,10.355),(37.345,10.185),(37.175,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.185),(37.535,10.355),(37.705,10.355),(37.705,10.185),(37.535,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.185),(37.895,10.355),(38.065,10.355),(38.065,10.185),(37.895,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.185),(38.255,10.355),(38.425,10.355),(38.425,10.185),(38.255,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.545),(37.175,10.715),(37.345,10.715),(37.345,10.545),(37.175,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.545),(37.535,10.715),(37.705,10.715),(37.705,10.545),(37.535,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.545),(37.895,10.715),(38.065,10.715),(38.065,10.545),(37.895,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.545),(38.255,10.715),(38.425,10.715),(38.425,10.545),(38.255,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.905),(37.175,11.075),(37.345,11.075),(37.345,10.905),(37.175,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.905),(37.535,11.075),(37.705,11.075),(37.705,10.905),(37.535,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.905),(37.895,11.075),(38.065,11.075),(38.065,10.905),(37.895,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.905),(38.255,11.075),(38.425,11.075),(38.425,10.905),(38.255,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.265),(37.175,11.435),(37.345,11.435),(37.345,11.265),(37.175,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.265),(37.535,11.435),(37.705,11.435),(37.705,11.265),(37.535,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.265),(37.895,11.435),(38.065,11.435),(38.065,11.265),(37.895,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.265),(38.255,11.435),(38.425,11.435),(38.425,11.265),(38.255,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.625),(37.175,11.795),(37.345,11.795),(37.345,11.625),(37.175,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.625),(37.535,11.795),(37.705,11.795),(37.705,11.625),(37.535,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.625),(37.895,11.795),(38.065,11.795),(38.065,11.625),(37.895,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.625),(38.255,11.795),(38.425,11.795),(38.425,11.625),(38.255,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.985),(37.175,12.155),(37.345,12.155),(37.345,11.985),(37.175,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.985),(37.535,12.155),(37.705,12.155),(37.705,11.985),(37.535,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.985),(37.895,12.155),(38.065,12.155),(38.065,11.985),(37.895,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.985),(38.255,12.155),(38.425,12.155),(38.425,11.985),(38.255,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.345),(37.175,12.515),(37.345,12.515),(37.345,12.345),(37.175,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.345),(37.535,12.515),(37.705,12.515),(37.705,12.345),(37.535,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.345),(37.895,12.515),(38.065,12.515),(38.065,12.345),(37.895,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.345),(38.255,12.515),(38.425,12.515),(38.425,12.345),(38.255,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.705),(37.175,12.875),(37.345,12.875),(37.345,12.705),(37.175,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.705),(37.535,12.875),(37.705,12.875),(37.705,12.705),(37.535,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.705),(37.895,12.875),(38.065,12.875),(38.065,12.705),(37.895,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.705),(38.255,12.875),(38.425,12.875),(38.425,12.705),(38.255,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.065),(37.175,13.235),(37.345,13.235),(37.345,13.065),(37.175,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.065),(37.535,13.235),(37.705,13.235),(37.705,13.065),(37.535,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.065),(37.895,13.235),(38.065,13.235),(38.065,13.065),(37.895,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.065),(38.255,13.235),(38.425,13.235),(38.425,13.065),(38.255,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.425),(37.175,13.595),(37.345,13.595),(37.345,13.425),(37.175,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.425),(37.535,13.595),(37.705,13.595),(37.705,13.425),(37.535,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.425),(37.895,13.595),(38.065,13.595),(38.065,13.425),(37.895,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.425),(38.255,13.595),(38.425,13.595),(38.425,13.425),(38.255,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.785),(37.175,13.955),(37.345,13.955),(37.345,13.785),(37.175,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.785),(37.535,13.955),(37.705,13.955),(37.705,13.785),(37.535,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.785),(37.895,13.955),(38.065,13.955),(38.065,13.785),(37.895,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.785),(38.255,13.955),(38.425,13.955),(38.425,13.785),(38.255,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.145),(37.175,14.315),(37.345,14.315),(37.345,14.145),(37.175,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.145),(37.535,14.315),(37.705,14.315),(37.705,14.145),(37.535,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.145),(37.895,14.315),(38.065,14.315),(38.065,14.145),(37.895,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.145),(38.255,14.315),(38.425,14.315),(38.425,14.145),(38.255,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.505),(37.175,14.675),(37.345,14.675),(37.345,14.505),(37.175,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.505),(37.535,14.675),(37.705,14.675),(37.705,14.505),(37.535,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.505),(37.895,14.675),(38.065,14.675),(38.065,14.505),(37.895,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.505),(38.255,14.675),(38.425,14.675),(38.425,14.505),(38.255,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.865),(37.175,15.035),(37.345,15.035),(37.345,14.865),(37.175,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.865),(37.535,15.035),(37.705,15.035),(37.705,14.865),(37.535,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.865),(37.895,15.035),(38.065,15.035),(38.065,14.865),(37.895,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.865),(38.255,15.035),(38.425,15.035),(38.425,14.865),(38.255,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.225),(37.175,15.395),(37.345,15.395),(37.345,15.225),(37.175,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.225),(37.535,15.395),(37.705,15.395),(37.705,15.225),(37.535,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.225),(37.895,15.395),(38.065,15.395),(38.065,15.225),(37.895,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.225),(38.255,15.395),(38.425,15.395),(38.425,15.225),(38.255,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.585),(37.175,15.755),(37.345,15.755),(37.345,15.585),(37.175,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.585),(37.535,15.755),(37.705,15.755),(37.705,15.585),(37.535,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.585),(37.895,15.755),(38.065,15.755),(38.065,15.585),(37.895,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.585),(38.255,15.755),(38.425,15.755),(38.425,15.585),(38.255,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.945),(37.175,16.115),(37.345,16.115),(37.345,15.945),(37.175,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.945),(37.535,16.115),(37.705,16.115),(37.705,15.945),(37.535,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.945),(37.895,16.115),(38.065,16.115),(38.065,15.945),(37.895,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.945),(38.255,16.115),(38.425,16.115),(38.425,15.945),(38.255,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.305),(37.175,16.475),(37.345,16.475),(37.345,16.305),(37.175,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.305),(37.535,16.475),(37.705,16.475),(37.705,16.305),(37.535,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.305),(37.895,16.475),(38.065,16.475),(38.065,16.305),(37.895,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.305),(38.255,16.475),(38.425,16.475),(38.425,16.305),(38.255,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.665),(37.175,16.835),(37.345,16.835),(37.345,16.665),(37.175,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.665),(37.535,16.835),(37.705,16.835),(37.705,16.665),(37.535,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.665),(37.895,16.835),(38.065,16.835),(38.065,16.665),(37.895,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.665),(38.255,16.835),(38.425,16.835),(38.425,16.665),(38.255,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.025),(37.175,17.195),(37.345,17.195),(37.345,17.025),(37.175,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.025),(37.535,17.195),(37.705,17.195),(37.705,17.025),(37.535,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.025),(37.895,17.195),(38.065,17.195),(38.065,17.025),(37.895,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.025),(38.255,17.195),(38.425,17.195),(38.425,17.025),(38.255,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.385),(37.175,17.555),(37.345,17.555),(37.345,17.385),(37.175,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.385),(37.535,17.555),(37.705,17.555),(37.705,17.385),(37.535,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.385),(37.895,17.555),(38.065,17.555),(38.065,17.385),(37.895,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.385),(38.255,17.555),(38.425,17.555),(38.425,17.385),(38.255,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.745),(37.175,17.915),(37.345,17.915),(37.345,17.745),(37.175,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.745),(37.535,17.915),(37.705,17.915),(37.705,17.745),(37.535,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.745),(37.895,17.915),(38.065,17.915),(38.065,17.745),(37.895,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.745),(38.255,17.915),(38.425,17.915),(38.425,17.745),(38.255,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.105),(37.175,18.275),(37.345,18.275),(37.345,18.105),(37.175,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.105),(37.535,18.275),(37.705,18.275),(37.705,18.105),(37.535,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.105),(37.895,18.275),(38.065,18.275),(38.065,18.105),(37.895,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.105),(38.255,18.275),(38.425,18.275),(38.425,18.105),(38.255,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.465),(37.175,18.635),(37.345,18.635),(37.345,18.465),(37.175,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.465),(37.535,18.635),(37.705,18.635),(37.705,18.465),(37.535,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.465),(37.895,18.635),(38.065,18.635),(38.065,18.465),(37.895,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.465),(38.255,18.635),(38.425,18.635),(38.425,18.465),(38.255,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.825),(37.175,18.995),(37.345,18.995),(37.345,18.825),(37.175,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.825),(37.535,18.995),(37.705,18.995),(37.705,18.825),(37.535,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.825),(37.895,18.995),(38.065,18.995),(38.065,18.825),(37.895,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.825),(38.255,18.995),(38.425,18.995),(38.425,18.825),(38.255,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.185),(37.175,19.355),(37.345,19.355),(37.345,19.185),(37.175,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.185),(37.535,19.355),(37.705,19.355),(37.705,19.185),(37.535,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.185),(37.895,19.355),(38.065,19.355),(38.065,19.185),(37.895,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.185),(38.255,19.355),(38.425,19.355),(38.425,19.185),(38.255,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.985),(51.575,3.155),(51.745,3.155),(51.745,2.985),(51.575,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.985),(51.935,3.155),(52.105,3.155),(52.105,2.985),(51.935,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.985),(52.295,3.155),(52.465,3.155),(52.465,2.985),(52.295,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.985),(52.655,3.155),(52.825,3.155),(52.825,2.985),(52.655,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.345),(51.575,3.515),(51.745,3.515),(51.745,3.345),(51.575,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.345),(51.935,3.515),(52.105,3.515),(52.105,3.345),(51.935,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.345),(52.295,3.515),(52.465,3.515),(52.465,3.345),(52.295,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.345),(52.655,3.515),(52.825,3.515),(52.825,3.345),(52.655,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.705),(51.575,3.875),(51.745,3.875),(51.745,3.705),(51.575,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.705),(51.935,3.875),(52.105,3.875),(52.105,3.705),(51.935,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.705),(52.295,3.875),(52.465,3.875),(52.465,3.705),(52.295,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.705),(52.655,3.875),(52.825,3.875),(52.825,3.705),(52.655,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.065),(51.575,4.235),(51.745,4.235),(51.745,4.065),(51.575,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.065),(51.935,4.235),(52.105,4.235),(52.105,4.065),(51.935,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.065),(52.295,4.235),(52.465,4.235),(52.465,4.065),(52.295,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.065),(52.655,4.235),(52.825,4.235),(52.825,4.065),(52.655,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.425),(51.575,4.595),(51.745,4.595),(51.745,4.425),(51.575,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.425),(51.935,4.595),(52.105,4.595),(52.105,4.425),(51.935,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.425),(52.295,4.595),(52.465,4.595),(52.465,4.425),(52.295,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.425),(52.655,4.595),(52.825,4.595),(52.825,4.425),(52.655,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.785),(51.575,4.955),(51.745,4.955),(51.745,4.785),(51.575,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.785),(51.935,4.955),(52.105,4.955),(52.105,4.785),(51.935,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.785),(52.295,4.955),(52.465,4.955),(52.465,4.785),(52.295,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.785),(52.655,4.955),(52.825,4.955),(52.825,4.785),(52.655,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.145),(51.575,5.315),(51.745,5.315),(51.745,5.145),(51.575,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.145),(51.935,5.315),(52.105,5.315),(52.105,5.145),(51.935,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.145),(52.295,5.315),(52.465,5.315),(52.465,5.145),(52.295,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.145),(52.655,5.315),(52.825,5.315),(52.825,5.145),(52.655,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.505),(51.575,5.675),(51.745,5.675),(51.745,5.505),(51.575,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.505),(51.935,5.675),(52.105,5.675),(52.105,5.505),(51.935,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.505),(52.295,5.675),(52.465,5.675),(52.465,5.505),(52.295,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.505),(52.655,5.675),(52.825,5.675),(52.825,5.505),(52.655,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.865),(51.575,6.035),(51.745,6.035),(51.745,5.865),(51.575,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.865),(51.935,6.035),(52.105,6.035),(52.105,5.865),(51.935,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.865),(52.295,6.035),(52.465,6.035),(52.465,5.865),(52.295,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.865),(52.655,6.035),(52.825,6.035),(52.825,5.865),(52.655,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.225),(51.575,6.395),(51.745,6.395),(51.745,6.225),(51.575,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.225),(51.935,6.395),(52.105,6.395),(52.105,6.225),(51.935,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.225),(52.295,6.395),(52.465,6.395),(52.465,6.225),(52.295,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.225),(52.655,6.395),(52.825,6.395),(52.825,6.225),(52.655,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.585),(51.575,6.755),(51.745,6.755),(51.745,6.585),(51.575,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.585),(51.935,6.755),(52.105,6.755),(52.105,6.585),(51.935,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.585),(52.295,6.755),(52.465,6.755),(52.465,6.585),(52.295,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.585),(52.655,6.755),(52.825,6.755),(52.825,6.585),(52.655,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.945),(51.575,7.115),(51.745,7.115),(51.745,6.945),(51.575,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.945),(51.935,7.115),(52.105,7.115),(52.105,6.945),(51.935,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.945),(52.295,7.115),(52.465,7.115),(52.465,6.945),(52.295,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.945),(52.655,7.115),(52.825,7.115),(52.825,6.945),(52.655,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.305),(51.575,7.475),(51.745,7.475),(51.745,7.305),(51.575,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.305),(51.935,7.475),(52.105,7.475),(52.105,7.305),(51.935,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.305),(52.295,7.475),(52.465,7.475),(52.465,7.305),(52.295,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.305),(52.655,7.475),(52.825,7.475),(52.825,7.305),(52.655,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.665),(51.575,7.835),(51.745,7.835),(51.745,7.665),(51.575,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.665),(51.935,7.835),(52.105,7.835),(52.105,7.665),(51.935,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.665),(52.295,7.835),(52.465,7.835),(52.465,7.665),(52.295,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.665),(52.655,7.835),(52.825,7.835),(52.825,7.665),(52.655,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.025),(51.575,8.195),(51.745,8.195),(51.745,8.025),(51.575,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.025),(51.935,8.195),(52.105,8.195),(52.105,8.025),(51.935,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.025),(52.295,8.195),(52.465,8.195),(52.465,8.025),(52.295,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.025),(52.655,8.195),(52.825,8.195),(52.825,8.025),(52.655,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.385),(51.575,8.555),(51.745,8.555),(51.745,8.385),(51.575,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.385),(51.935,8.555),(52.105,8.555),(52.105,8.385),(51.935,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.385),(52.295,8.555),(52.465,8.555),(52.465,8.385),(52.295,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.385),(52.655,8.555),(52.825,8.555),(52.825,8.385),(52.655,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.745),(51.575,8.915),(51.745,8.915),(51.745,8.745),(51.575,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.745),(51.935,8.915),(52.105,8.915),(52.105,8.745),(51.935,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.745),(52.295,8.915),(52.465,8.915),(52.465,8.745),(52.295,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.745),(52.655,8.915),(52.825,8.915),(52.825,8.745),(52.655,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.105),(51.575,9.275),(51.745,9.275),(51.745,9.105),(51.575,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.105),(51.935,9.275),(52.105,9.275),(52.105,9.105),(51.935,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.105),(52.295,9.275),(52.465,9.275),(52.465,9.105),(52.295,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.105),(52.655,9.275),(52.825,9.275),(52.825,9.105),(52.655,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.465),(51.575,9.635),(51.745,9.635),(51.745,9.465),(51.575,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.465),(51.935,9.635),(52.105,9.635),(52.105,9.465),(51.935,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.465),(52.295,9.635),(52.465,9.635),(52.465,9.465),(52.295,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.465),(52.655,9.635),(52.825,9.635),(52.825,9.465),(52.655,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.825),(51.575,9.995),(51.745,9.995),(51.745,9.825),(51.575,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.825),(51.935,9.995),(52.105,9.995),(52.105,9.825),(51.935,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.825),(52.295,9.995),(52.465,9.995),(52.465,9.825),(52.295,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.825),(52.655,9.995),(52.825,9.995),(52.825,9.825),(52.655,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.185),(51.575,10.355),(51.745,10.355),(51.745,10.185),(51.575,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.185),(51.935,10.355),(52.105,10.355),(52.105,10.185),(51.935,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.185),(52.295,10.355),(52.465,10.355),(52.465,10.185),(52.295,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.185),(52.655,10.355),(52.825,10.355),(52.825,10.185),(52.655,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.545),(51.575,10.715),(51.745,10.715),(51.745,10.545),(51.575,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.545),(51.935,10.715),(52.105,10.715),(52.105,10.545),(51.935,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.545),(52.295,10.715),(52.465,10.715),(52.465,10.545),(52.295,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.545),(52.655,10.715),(52.825,10.715),(52.825,10.545),(52.655,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.905),(51.575,11.075),(51.745,11.075),(51.745,10.905),(51.575,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.905),(51.935,11.075),(52.105,11.075),(52.105,10.905),(51.935,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.905),(52.295,11.075),(52.465,11.075),(52.465,10.905),(52.295,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.905),(52.655,11.075),(52.825,11.075),(52.825,10.905),(52.655,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.265),(51.575,11.435),(51.745,11.435),(51.745,11.265),(51.575,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.265),(51.935,11.435),(52.105,11.435),(52.105,11.265),(51.935,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.265),(52.295,11.435),(52.465,11.435),(52.465,11.265),(52.295,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.265),(52.655,11.435),(52.825,11.435),(52.825,11.265),(52.655,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.625),(51.575,11.795),(51.745,11.795),(51.745,11.625),(51.575,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.625),(51.935,11.795),(52.105,11.795),(52.105,11.625),(51.935,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.625),(52.295,11.795),(52.465,11.795),(52.465,11.625),(52.295,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.625),(52.655,11.795),(52.825,11.795),(52.825,11.625),(52.655,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.985),(51.575,12.155),(51.745,12.155),(51.745,11.985),(51.575,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.985),(51.935,12.155),(52.105,12.155),(52.105,11.985),(51.935,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.985),(52.295,12.155),(52.465,12.155),(52.465,11.985),(52.295,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.985),(52.655,12.155),(52.825,12.155),(52.825,11.985),(52.655,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.345),(51.575,12.515),(51.745,12.515),(51.745,12.345),(51.575,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.345),(51.935,12.515),(52.105,12.515),(52.105,12.345),(51.935,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.345),(52.295,12.515),(52.465,12.515),(52.465,12.345),(52.295,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.345),(52.655,12.515),(52.825,12.515),(52.825,12.345),(52.655,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.705),(51.575,12.875),(51.745,12.875),(51.745,12.705),(51.575,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.705),(51.935,12.875),(52.105,12.875),(52.105,12.705),(51.935,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.705),(52.295,12.875),(52.465,12.875),(52.465,12.705),(52.295,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.705),(52.655,12.875),(52.825,12.875),(52.825,12.705),(52.655,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.065),(51.575,13.235),(51.745,13.235),(51.745,13.065),(51.575,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.065),(51.935,13.235),(52.105,13.235),(52.105,13.065),(51.935,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.065),(52.295,13.235),(52.465,13.235),(52.465,13.065),(52.295,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.065),(52.655,13.235),(52.825,13.235),(52.825,13.065),(52.655,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.425),(51.575,13.595),(51.745,13.595),(51.745,13.425),(51.575,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.425),(51.935,13.595),(52.105,13.595),(52.105,13.425),(51.935,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.425),(52.295,13.595),(52.465,13.595),(52.465,13.425),(52.295,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.425),(52.655,13.595),(52.825,13.595),(52.825,13.425),(52.655,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.785),(51.575,13.955),(51.745,13.955),(51.745,13.785),(51.575,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.785),(51.935,13.955),(52.105,13.955),(52.105,13.785),(51.935,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.785),(52.295,13.955),(52.465,13.955),(52.465,13.785),(52.295,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.785),(52.655,13.955),(52.825,13.955),(52.825,13.785),(52.655,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.145),(51.575,14.315),(51.745,14.315),(51.745,14.145),(51.575,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.145),(51.935,14.315),(52.105,14.315),(52.105,14.145),(51.935,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.145),(52.295,14.315),(52.465,14.315),(52.465,14.145),(52.295,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.145),(52.655,14.315),(52.825,14.315),(52.825,14.145),(52.655,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.505),(51.575,14.675),(51.745,14.675),(51.745,14.505),(51.575,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.505),(51.935,14.675),(52.105,14.675),(52.105,14.505),(51.935,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.505),(52.295,14.675),(52.465,14.675),(52.465,14.505),(52.295,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.505),(52.655,14.675),(52.825,14.675),(52.825,14.505),(52.655,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.865),(51.575,15.035),(51.745,15.035),(51.745,14.865),(51.575,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.865),(51.935,15.035),(52.105,15.035),(52.105,14.865),(51.935,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.865),(52.295,15.035),(52.465,15.035),(52.465,14.865),(52.295,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.865),(52.655,15.035),(52.825,15.035),(52.825,14.865),(52.655,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.225),(51.575,15.395),(51.745,15.395),(51.745,15.225),(51.575,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.225),(51.935,15.395),(52.105,15.395),(52.105,15.225),(51.935,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.225),(52.295,15.395),(52.465,15.395),(52.465,15.225),(52.295,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.225),(52.655,15.395),(52.825,15.395),(52.825,15.225),(52.655,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.585),(51.575,15.755),(51.745,15.755),(51.745,15.585),(51.575,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.585),(51.935,15.755),(52.105,15.755),(52.105,15.585),(51.935,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.585),(52.295,15.755),(52.465,15.755),(52.465,15.585),(52.295,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.585),(52.655,15.755),(52.825,15.755),(52.825,15.585),(52.655,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.945),(51.575,16.115),(51.745,16.115),(51.745,15.945),(51.575,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.945),(51.935,16.115),(52.105,16.115),(52.105,15.945),(51.935,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.945),(52.295,16.115),(52.465,16.115),(52.465,15.945),(52.295,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.945),(52.655,16.115),(52.825,16.115),(52.825,15.945),(52.655,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.305),(51.575,16.475),(51.745,16.475),(51.745,16.305),(51.575,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.305),(51.935,16.475),(52.105,16.475),(52.105,16.305),(51.935,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.305),(52.295,16.475),(52.465,16.475),(52.465,16.305),(52.295,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.305),(52.655,16.475),(52.825,16.475),(52.825,16.305),(52.655,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.665),(51.575,16.835),(51.745,16.835),(51.745,16.665),(51.575,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.665),(51.935,16.835),(52.105,16.835),(52.105,16.665),(51.935,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.665),(52.295,16.835),(52.465,16.835),(52.465,16.665),(52.295,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.665),(52.655,16.835),(52.825,16.835),(52.825,16.665),(52.655,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.025),(51.575,17.195),(51.745,17.195),(51.745,17.025),(51.575,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.025),(51.935,17.195),(52.105,17.195),(52.105,17.025),(51.935,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.025),(52.295,17.195),(52.465,17.195),(52.465,17.025),(52.295,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.025),(52.655,17.195),(52.825,17.195),(52.825,17.025),(52.655,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.385),(51.575,17.555),(51.745,17.555),(51.745,17.385),(51.575,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.385),(51.935,17.555),(52.105,17.555),(52.105,17.385),(51.935,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.385),(52.295,17.555),(52.465,17.555),(52.465,17.385),(52.295,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.385),(52.655,17.555),(52.825,17.555),(52.825,17.385),(52.655,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.745),(51.575,17.915),(51.745,17.915),(51.745,17.745),(51.575,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.745),(51.935,17.915),(52.105,17.915),(52.105,17.745),(51.935,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.745),(52.295,17.915),(52.465,17.915),(52.465,17.745),(52.295,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.745),(52.655,17.915),(52.825,17.915),(52.825,17.745),(52.655,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.105),(51.575,18.275),(51.745,18.275),(51.745,18.105),(51.575,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.105),(51.935,18.275),(52.105,18.275),(52.105,18.105),(51.935,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.105),(52.295,18.275),(52.465,18.275),(52.465,18.105),(52.295,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.105),(52.655,18.275),(52.825,18.275),(52.825,18.105),(52.655,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.465),(51.575,18.635),(51.745,18.635),(51.745,18.465),(51.575,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.465),(51.935,18.635),(52.105,18.635),(52.105,18.465),(51.935,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.465),(52.295,18.635),(52.465,18.635),(52.465,18.465),(52.295,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.465),(52.655,18.635),(52.825,18.635),(52.825,18.465),(52.655,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.825),(51.575,18.995),(51.745,18.995),(51.745,18.825),(51.575,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.825),(51.935,18.995),(52.105,18.995),(52.105,18.825),(51.935,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.825),(52.295,18.995),(52.465,18.995),(52.465,18.825),(52.295,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.825),(52.655,18.995),(52.825,18.995),(52.825,18.825),(52.655,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.185),(51.575,19.355),(51.745,19.355),(51.745,19.185),(51.575,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.185),(51.935,19.355),(52.105,19.355),(52.105,19.185),(51.935,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.185),(52.295,19.355),(52.465,19.355),(52.465,19.185),(52.295,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.185),(52.655,19.355),(52.825,19.355),(52.825,19.185),(52.655,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.985),(56.375,3.155),(56.545,3.155),(56.545,2.985),(56.375,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.985),(56.735,3.155),(56.905,3.155),(56.905,2.985),(56.735,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.985),(57.095,3.155),(57.265,3.155),(57.265,2.985),(57.095,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.985),(57.455,3.155),(57.625,3.155),(57.625,2.985),(57.455,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.345),(56.375,3.515),(56.545,3.515),(56.545,3.345),(56.375,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.345),(56.735,3.515),(56.905,3.515),(56.905,3.345),(56.735,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.345),(57.095,3.515),(57.265,3.515),(57.265,3.345),(57.095,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.345),(57.455,3.515),(57.625,3.515),(57.625,3.345),(57.455,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.705),(56.375,3.875),(56.545,3.875),(56.545,3.705),(56.375,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.705),(56.735,3.875),(56.905,3.875),(56.905,3.705),(56.735,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.705),(57.095,3.875),(57.265,3.875),(57.265,3.705),(57.095,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.705),(57.455,3.875),(57.625,3.875),(57.625,3.705),(57.455,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.065),(56.375,4.235),(56.545,4.235),(56.545,4.065),(56.375,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.065),(56.735,4.235),(56.905,4.235),(56.905,4.065),(56.735,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.065),(57.095,4.235),(57.265,4.235),(57.265,4.065),(57.095,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.065),(57.455,4.235),(57.625,4.235),(57.625,4.065),(57.455,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.425),(56.375,4.595),(56.545,4.595),(56.545,4.425),(56.375,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.425),(56.735,4.595),(56.905,4.595),(56.905,4.425),(56.735,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.425),(57.095,4.595),(57.265,4.595),(57.265,4.425),(57.095,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.425),(57.455,4.595),(57.625,4.595),(57.625,4.425),(57.455,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.785),(56.375,4.955),(56.545,4.955),(56.545,4.785),(56.375,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.785),(56.735,4.955),(56.905,4.955),(56.905,4.785),(56.735,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.785),(57.095,4.955),(57.265,4.955),(57.265,4.785),(57.095,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.785),(57.455,4.955),(57.625,4.955),(57.625,4.785),(57.455,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.145),(56.375,5.315),(56.545,5.315),(56.545,5.145),(56.375,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.145),(56.735,5.315),(56.905,5.315),(56.905,5.145),(56.735,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.145),(57.095,5.315),(57.265,5.315),(57.265,5.145),(57.095,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.145),(57.455,5.315),(57.625,5.315),(57.625,5.145),(57.455,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.505),(56.375,5.675),(56.545,5.675),(56.545,5.505),(56.375,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.505),(56.735,5.675),(56.905,5.675),(56.905,5.505),(56.735,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.505),(57.095,5.675),(57.265,5.675),(57.265,5.505),(57.095,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.505),(57.455,5.675),(57.625,5.675),(57.625,5.505),(57.455,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.865),(56.375,6.035),(56.545,6.035),(56.545,5.865),(56.375,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.865),(56.735,6.035),(56.905,6.035),(56.905,5.865),(56.735,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.865),(57.095,6.035),(57.265,6.035),(57.265,5.865),(57.095,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.865),(57.455,6.035),(57.625,6.035),(57.625,5.865),(57.455,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.225),(56.375,6.395),(56.545,6.395),(56.545,6.225),(56.375,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.225),(56.735,6.395),(56.905,6.395),(56.905,6.225),(56.735,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.225),(57.095,6.395),(57.265,6.395),(57.265,6.225),(57.095,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.225),(57.455,6.395),(57.625,6.395),(57.625,6.225),(57.455,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.585),(56.375,6.755),(56.545,6.755),(56.545,6.585),(56.375,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.585),(56.735,6.755),(56.905,6.755),(56.905,6.585),(56.735,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.585),(57.095,6.755),(57.265,6.755),(57.265,6.585),(57.095,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.585),(57.455,6.755),(57.625,6.755),(57.625,6.585),(57.455,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.945),(56.375,7.115),(56.545,7.115),(56.545,6.945),(56.375,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.945),(56.735,7.115),(56.905,7.115),(56.905,6.945),(56.735,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.945),(57.095,7.115),(57.265,7.115),(57.265,6.945),(57.095,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.945),(57.455,7.115),(57.625,7.115),(57.625,6.945),(57.455,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.305),(56.375,7.475),(56.545,7.475),(56.545,7.305),(56.375,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.305),(56.735,7.475),(56.905,7.475),(56.905,7.305),(56.735,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.305),(57.095,7.475),(57.265,7.475),(57.265,7.305),(57.095,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.305),(57.455,7.475),(57.625,7.475),(57.625,7.305),(57.455,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.665),(56.375,7.835),(56.545,7.835),(56.545,7.665),(56.375,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.665),(56.735,7.835),(56.905,7.835),(56.905,7.665),(56.735,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.665),(57.095,7.835),(57.265,7.835),(57.265,7.665),(57.095,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.665),(57.455,7.835),(57.625,7.835),(57.625,7.665),(57.455,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.025),(56.375,8.195),(56.545,8.195),(56.545,8.025),(56.375,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.025),(56.735,8.195),(56.905,8.195),(56.905,8.025),(56.735,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.025),(57.095,8.195),(57.265,8.195),(57.265,8.025),(57.095,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.025),(57.455,8.195),(57.625,8.195),(57.625,8.025),(57.455,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.385),(56.375,8.555),(56.545,8.555),(56.545,8.385),(56.375,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.385),(56.735,8.555),(56.905,8.555),(56.905,8.385),(56.735,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.385),(57.095,8.555),(57.265,8.555),(57.265,8.385),(57.095,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.385),(57.455,8.555),(57.625,8.555),(57.625,8.385),(57.455,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.745),(56.375,8.915),(56.545,8.915),(56.545,8.745),(56.375,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.745),(56.735,8.915),(56.905,8.915),(56.905,8.745),(56.735,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.745),(57.095,8.915),(57.265,8.915),(57.265,8.745),(57.095,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.745),(57.455,8.915),(57.625,8.915),(57.625,8.745),(57.455,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.105),(56.375,9.275),(56.545,9.275),(56.545,9.105),(56.375,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.105),(56.735,9.275),(56.905,9.275),(56.905,9.105),(56.735,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.105),(57.095,9.275),(57.265,9.275),(57.265,9.105),(57.095,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.105),(57.455,9.275),(57.625,9.275),(57.625,9.105),(57.455,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.465),(56.375,9.635),(56.545,9.635),(56.545,9.465),(56.375,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.465),(56.735,9.635),(56.905,9.635),(56.905,9.465),(56.735,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.465),(57.095,9.635),(57.265,9.635),(57.265,9.465),(57.095,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.465),(57.455,9.635),(57.625,9.635),(57.625,9.465),(57.455,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.825),(56.375,9.995),(56.545,9.995),(56.545,9.825),(56.375,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.825),(56.735,9.995),(56.905,9.995),(56.905,9.825),(56.735,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.825),(57.095,9.995),(57.265,9.995),(57.265,9.825),(57.095,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.825),(57.455,9.995),(57.625,9.995),(57.625,9.825),(57.455,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.185),(56.375,10.355),(56.545,10.355),(56.545,10.185),(56.375,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.185),(56.735,10.355),(56.905,10.355),(56.905,10.185),(56.735,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.185),(57.095,10.355),(57.265,10.355),(57.265,10.185),(57.095,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.185),(57.455,10.355),(57.625,10.355),(57.625,10.185),(57.455,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.545),(56.375,10.715),(56.545,10.715),(56.545,10.545),(56.375,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.545),(56.735,10.715),(56.905,10.715),(56.905,10.545),(56.735,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.545),(57.095,10.715),(57.265,10.715),(57.265,10.545),(57.095,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.545),(57.455,10.715),(57.625,10.715),(57.625,10.545),(57.455,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.905),(56.375,11.075),(56.545,11.075),(56.545,10.905),(56.375,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.905),(56.735,11.075),(56.905,11.075),(56.905,10.905),(56.735,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.905),(57.095,11.075),(57.265,11.075),(57.265,10.905),(57.095,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.905),(57.455,11.075),(57.625,11.075),(57.625,10.905),(57.455,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.265),(56.375,11.435),(56.545,11.435),(56.545,11.265),(56.375,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.265),(56.735,11.435),(56.905,11.435),(56.905,11.265),(56.735,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.265),(57.095,11.435),(57.265,11.435),(57.265,11.265),(57.095,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.265),(57.455,11.435),(57.625,11.435),(57.625,11.265),(57.455,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.625),(56.375,11.795),(56.545,11.795),(56.545,11.625),(56.375,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.625),(56.735,11.795),(56.905,11.795),(56.905,11.625),(56.735,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.625),(57.095,11.795),(57.265,11.795),(57.265,11.625),(57.095,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.625),(57.455,11.795),(57.625,11.795),(57.625,11.625),(57.455,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.985),(56.375,12.155),(56.545,12.155),(56.545,11.985),(56.375,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.985),(56.735,12.155),(56.905,12.155),(56.905,11.985),(56.735,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.985),(57.095,12.155),(57.265,12.155),(57.265,11.985),(57.095,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.985),(57.455,12.155),(57.625,12.155),(57.625,11.985),(57.455,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.345),(56.375,12.515),(56.545,12.515),(56.545,12.345),(56.375,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.345),(56.735,12.515),(56.905,12.515),(56.905,12.345),(56.735,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.345),(57.095,12.515),(57.265,12.515),(57.265,12.345),(57.095,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.345),(57.455,12.515),(57.625,12.515),(57.625,12.345),(57.455,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.705),(56.375,12.875),(56.545,12.875),(56.545,12.705),(56.375,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.705),(56.735,12.875),(56.905,12.875),(56.905,12.705),(56.735,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.705),(57.095,12.875),(57.265,12.875),(57.265,12.705),(57.095,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.705),(57.455,12.875),(57.625,12.875),(57.625,12.705),(57.455,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.065),(56.375,13.235),(56.545,13.235),(56.545,13.065),(56.375,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.065),(56.735,13.235),(56.905,13.235),(56.905,13.065),(56.735,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.065),(57.095,13.235),(57.265,13.235),(57.265,13.065),(57.095,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.065),(57.455,13.235),(57.625,13.235),(57.625,13.065),(57.455,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.425),(56.375,13.595),(56.545,13.595),(56.545,13.425),(56.375,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.425),(56.735,13.595),(56.905,13.595),(56.905,13.425),(56.735,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.425),(57.095,13.595),(57.265,13.595),(57.265,13.425),(57.095,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.425),(57.455,13.595),(57.625,13.595),(57.625,13.425),(57.455,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.785),(56.375,13.955),(56.545,13.955),(56.545,13.785),(56.375,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.785),(56.735,13.955),(56.905,13.955),(56.905,13.785),(56.735,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.785),(57.095,13.955),(57.265,13.955),(57.265,13.785),(57.095,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.785),(57.455,13.955),(57.625,13.955),(57.625,13.785),(57.455,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.145),(56.375,14.315),(56.545,14.315),(56.545,14.145),(56.375,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.145),(56.735,14.315),(56.905,14.315),(56.905,14.145),(56.735,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.145),(57.095,14.315),(57.265,14.315),(57.265,14.145),(57.095,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.145),(57.455,14.315),(57.625,14.315),(57.625,14.145),(57.455,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.505),(56.375,14.675),(56.545,14.675),(56.545,14.505),(56.375,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.505),(56.735,14.675),(56.905,14.675),(56.905,14.505),(56.735,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.505),(57.095,14.675),(57.265,14.675),(57.265,14.505),(57.095,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.505),(57.455,14.675),(57.625,14.675),(57.625,14.505),(57.455,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.865),(56.375,15.035),(56.545,15.035),(56.545,14.865),(56.375,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.865),(56.735,15.035),(56.905,15.035),(56.905,14.865),(56.735,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.865),(57.095,15.035),(57.265,15.035),(57.265,14.865),(57.095,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.865),(57.455,15.035),(57.625,15.035),(57.625,14.865),(57.455,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.225),(56.375,15.395),(56.545,15.395),(56.545,15.225),(56.375,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.225),(56.735,15.395),(56.905,15.395),(56.905,15.225),(56.735,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.225),(57.095,15.395),(57.265,15.395),(57.265,15.225),(57.095,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.225),(57.455,15.395),(57.625,15.395),(57.625,15.225),(57.455,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.585),(56.375,15.755),(56.545,15.755),(56.545,15.585),(56.375,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.585),(56.735,15.755),(56.905,15.755),(56.905,15.585),(56.735,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.585),(57.095,15.755),(57.265,15.755),(57.265,15.585),(57.095,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.585),(57.455,15.755),(57.625,15.755),(57.625,15.585),(57.455,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.945),(56.375,16.115),(56.545,16.115),(56.545,15.945),(56.375,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.945),(56.735,16.115),(56.905,16.115),(56.905,15.945),(56.735,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.945),(57.095,16.115),(57.265,16.115),(57.265,15.945),(57.095,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.945),(57.455,16.115),(57.625,16.115),(57.625,15.945),(57.455,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.305),(56.375,16.475),(56.545,16.475),(56.545,16.305),(56.375,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.305),(56.735,16.475),(56.905,16.475),(56.905,16.305),(56.735,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.305),(57.095,16.475),(57.265,16.475),(57.265,16.305),(57.095,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.305),(57.455,16.475),(57.625,16.475),(57.625,16.305),(57.455,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.665),(56.375,16.835),(56.545,16.835),(56.545,16.665),(56.375,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.665),(56.735,16.835),(56.905,16.835),(56.905,16.665),(56.735,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.665),(57.095,16.835),(57.265,16.835),(57.265,16.665),(57.095,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.665),(57.455,16.835),(57.625,16.835),(57.625,16.665),(57.455,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.025),(56.375,17.195),(56.545,17.195),(56.545,17.025),(56.375,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.025),(56.735,17.195),(56.905,17.195),(56.905,17.025),(56.735,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.025),(57.095,17.195),(57.265,17.195),(57.265,17.025),(57.095,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.025),(57.455,17.195),(57.625,17.195),(57.625,17.025),(57.455,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.385),(56.375,17.555),(56.545,17.555),(56.545,17.385),(56.375,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.385),(56.735,17.555),(56.905,17.555),(56.905,17.385),(56.735,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.385),(57.095,17.555),(57.265,17.555),(57.265,17.385),(57.095,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.385),(57.455,17.555),(57.625,17.555),(57.625,17.385),(57.455,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.745),(56.375,17.915),(56.545,17.915),(56.545,17.745),(56.375,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.745),(56.735,17.915),(56.905,17.915),(56.905,17.745),(56.735,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.745),(57.095,17.915),(57.265,17.915),(57.265,17.745),(57.095,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.745),(57.455,17.915),(57.625,17.915),(57.625,17.745),(57.455,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.105),(56.375,18.275),(56.545,18.275),(56.545,18.105),(56.375,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.105),(56.735,18.275),(56.905,18.275),(56.905,18.105),(56.735,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.105),(57.095,18.275),(57.265,18.275),(57.265,18.105),(57.095,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.105),(57.455,18.275),(57.625,18.275),(57.625,18.105),(57.455,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.465),(56.375,18.635),(56.545,18.635),(56.545,18.465),(56.375,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.465),(56.735,18.635),(56.905,18.635),(56.905,18.465),(56.735,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.465),(57.095,18.635),(57.265,18.635),(57.265,18.465),(57.095,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.465),(57.455,18.635),(57.625,18.635),(57.625,18.465),(57.455,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.825),(56.375,18.995),(56.545,18.995),(56.545,18.825),(56.375,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.825),(56.735,18.995),(56.905,18.995),(56.905,18.825),(56.735,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.825),(57.095,18.995),(57.265,18.995),(57.265,18.825),(57.095,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.825),(57.455,18.995),(57.625,18.995),(57.625,18.825),(57.455,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.185),(56.375,19.355),(56.545,19.355),(56.545,19.185),(56.375,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.185),(56.735,19.355),(56.905,19.355),(56.905,19.185),(56.735,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.185),(57.095,19.355),(57.265,19.355),(57.265,19.185),(57.095,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.185),(57.455,19.355),(57.625,19.355),(57.625,19.185),(57.455,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.985),(46.775,3.155),(46.945,3.155),(46.945,2.985),(46.775,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.985),(47.135,3.155),(47.305,3.155),(47.305,2.985),(47.135,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.985),(47.495,3.155),(47.665,3.155),(47.665,2.985),(47.495,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.985),(47.855,3.155),(48.025,3.155),(48.025,2.985),(47.855,2.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.345),(46.775,3.515),(46.945,3.515),(46.945,3.345),(46.775,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.345),(47.135,3.515),(47.305,3.515),(47.305,3.345),(47.135,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.345),(47.495,3.515),(47.665,3.515),(47.665,3.345),(47.495,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.345),(47.855,3.515),(48.025,3.515),(48.025,3.345),(47.855,3.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.705),(46.775,3.875),(46.945,3.875),(46.945,3.705),(46.775,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.705),(47.135,3.875),(47.305,3.875),(47.305,3.705),(47.135,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.705),(47.495,3.875),(47.665,3.875),(47.665,3.705),(47.495,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.705),(47.855,3.875),(48.025,3.875),(48.025,3.705),(47.855,3.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.065),(46.775,4.235),(46.945,4.235),(46.945,4.065),(46.775,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.065),(47.135,4.235),(47.305,4.235),(47.305,4.065),(47.135,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.065),(47.495,4.235),(47.665,4.235),(47.665,4.065),(47.495,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.065),(47.855,4.235),(48.025,4.235),(48.025,4.065),(47.855,4.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.425),(46.775,4.595),(46.945,4.595),(46.945,4.425),(46.775,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.425),(47.135,4.595),(47.305,4.595),(47.305,4.425),(47.135,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.425),(47.495,4.595),(47.665,4.595),(47.665,4.425),(47.495,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.425),(47.855,4.595),(48.025,4.595),(48.025,4.425),(47.855,4.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.785),(46.775,4.955),(46.945,4.955),(46.945,4.785),(46.775,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.785),(47.135,4.955),(47.305,4.955),(47.305,4.785),(47.135,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.785),(47.495,4.955),(47.665,4.955),(47.665,4.785),(47.495,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.785),(47.855,4.955),(48.025,4.955),(48.025,4.785),(47.855,4.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.145),(46.775,5.315),(46.945,5.315),(46.945,5.145),(46.775,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.145),(47.135,5.315),(47.305,5.315),(47.305,5.145),(47.135,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.145),(47.495,5.315),(47.665,5.315),(47.665,5.145),(47.495,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.145),(47.855,5.315),(48.025,5.315),(48.025,5.145),(47.855,5.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.505),(46.775,5.675),(46.945,5.675),(46.945,5.505),(46.775,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.505),(47.135,5.675),(47.305,5.675),(47.305,5.505),(47.135,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.505),(47.495,5.675),(47.665,5.675),(47.665,5.505),(47.495,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.505),(47.855,5.675),(48.025,5.675),(48.025,5.505),(47.855,5.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.865),(46.775,6.035),(46.945,6.035),(46.945,5.865),(46.775,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.865),(47.135,6.035),(47.305,6.035),(47.305,5.865),(47.135,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.865),(47.495,6.035),(47.665,6.035),(47.665,5.865),(47.495,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.865),(47.855,6.035),(48.025,6.035),(48.025,5.865),(47.855,5.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.225),(46.775,6.395),(46.945,6.395),(46.945,6.225),(46.775,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.225),(47.135,6.395),(47.305,6.395),(47.305,6.225),(47.135,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.225),(47.495,6.395),(47.665,6.395),(47.665,6.225),(47.495,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.225),(47.855,6.395),(48.025,6.395),(48.025,6.225),(47.855,6.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.585),(46.775,6.755),(46.945,6.755),(46.945,6.585),(46.775,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.585),(47.135,6.755),(47.305,6.755),(47.305,6.585),(47.135,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.585),(47.495,6.755),(47.665,6.755),(47.665,6.585),(47.495,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.585),(47.855,6.755),(48.025,6.755),(48.025,6.585),(47.855,6.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.945),(46.775,7.115),(46.945,7.115),(46.945,6.945),(46.775,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.945),(47.135,7.115),(47.305,7.115),(47.305,6.945),(47.135,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.945),(47.495,7.115),(47.665,7.115),(47.665,6.945),(47.495,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.945),(47.855,7.115),(48.025,7.115),(48.025,6.945),(47.855,6.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.305),(46.775,7.475),(46.945,7.475),(46.945,7.305),(46.775,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.305),(47.135,7.475),(47.305,7.475),(47.305,7.305),(47.135,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.305),(47.495,7.475),(47.665,7.475),(47.665,7.305),(47.495,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.305),(47.855,7.475),(48.025,7.475),(48.025,7.305),(47.855,7.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.665),(46.775,7.835),(46.945,7.835),(46.945,7.665),(46.775,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.665),(47.135,7.835),(47.305,7.835),(47.305,7.665),(47.135,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.665),(47.495,7.835),(47.665,7.835),(47.665,7.665),(47.495,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.665),(47.855,7.835),(48.025,7.835),(48.025,7.665),(47.855,7.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.025),(46.775,8.195),(46.945,8.195),(46.945,8.025),(46.775,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.025),(47.135,8.195),(47.305,8.195),(47.305,8.025),(47.135,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.025),(47.495,8.195),(47.665,8.195),(47.665,8.025),(47.495,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.025),(47.855,8.195),(48.025,8.195),(48.025,8.025),(47.855,8.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.385),(46.775,8.555),(46.945,8.555),(46.945,8.385),(46.775,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.385),(47.135,8.555),(47.305,8.555),(47.305,8.385),(47.135,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.385),(47.495,8.555),(47.665,8.555),(47.665,8.385),(47.495,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.385),(47.855,8.555),(48.025,8.555),(48.025,8.385),(47.855,8.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.745),(46.775,8.915),(46.945,8.915),(46.945,8.745),(46.775,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.745),(47.135,8.915),(47.305,8.915),(47.305,8.745),(47.135,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.745),(47.495,8.915),(47.665,8.915),(47.665,8.745),(47.495,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.745),(47.855,8.915),(48.025,8.915),(48.025,8.745),(47.855,8.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.105),(46.775,9.275),(46.945,9.275),(46.945,9.105),(46.775,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.105),(47.135,9.275),(47.305,9.275),(47.305,9.105),(47.135,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.105),(47.495,9.275),(47.665,9.275),(47.665,9.105),(47.495,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.105),(47.855,9.275),(48.025,9.275),(48.025,9.105),(47.855,9.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.465),(46.775,9.635),(46.945,9.635),(46.945,9.465),(46.775,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.465),(47.135,9.635),(47.305,9.635),(47.305,9.465),(47.135,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.465),(47.495,9.635),(47.665,9.635),(47.665,9.465),(47.495,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.465),(47.855,9.635),(48.025,9.635),(48.025,9.465),(47.855,9.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.825),(46.775,9.995),(46.945,9.995),(46.945,9.825),(46.775,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.825),(47.135,9.995),(47.305,9.995),(47.305,9.825),(47.135,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.825),(47.495,9.995),(47.665,9.995),(47.665,9.825),(47.495,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.825),(47.855,9.995),(48.025,9.995),(48.025,9.825),(47.855,9.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.185),(46.775,10.355),(46.945,10.355),(46.945,10.185),(46.775,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.185),(47.135,10.355),(47.305,10.355),(47.305,10.185),(47.135,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.185),(47.495,10.355),(47.665,10.355),(47.665,10.185),(47.495,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.185),(47.855,10.355),(48.025,10.355),(48.025,10.185),(47.855,10.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.545),(46.775,10.715),(46.945,10.715),(46.945,10.545),(46.775,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.545),(47.135,10.715),(47.305,10.715),(47.305,10.545),(47.135,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.545),(47.495,10.715),(47.665,10.715),(47.665,10.545),(47.495,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.545),(47.855,10.715),(48.025,10.715),(48.025,10.545),(47.855,10.545)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.905),(46.775,11.075),(46.945,11.075),(46.945,10.905),(46.775,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.905),(47.135,11.075),(47.305,11.075),(47.305,10.905),(47.135,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.905),(47.495,11.075),(47.665,11.075),(47.665,10.905),(47.495,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.905),(47.855,11.075),(48.025,11.075),(48.025,10.905),(47.855,10.905)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.265),(46.775,11.435),(46.945,11.435),(46.945,11.265),(46.775,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.265),(47.135,11.435),(47.305,11.435),(47.305,11.265),(47.135,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.265),(47.495,11.435),(47.665,11.435),(47.665,11.265),(47.495,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.265),(47.855,11.435),(48.025,11.435),(48.025,11.265),(47.855,11.265)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.625),(46.775,11.795),(46.945,11.795),(46.945,11.625),(46.775,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.625),(47.135,11.795),(47.305,11.795),(47.305,11.625),(47.135,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.625),(47.495,11.795),(47.665,11.795),(47.665,11.625),(47.495,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.625),(47.855,11.795),(48.025,11.795),(48.025,11.625),(47.855,11.625)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.985),(46.775,12.155),(46.945,12.155),(46.945,11.985),(46.775,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.985),(47.135,12.155),(47.305,12.155),(47.305,11.985),(47.135,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.985),(47.495,12.155),(47.665,12.155),(47.665,11.985),(47.495,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.985),(47.855,12.155),(48.025,12.155),(48.025,11.985),(47.855,11.985)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.345),(46.775,12.515),(46.945,12.515),(46.945,12.345),(46.775,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.345),(47.135,12.515),(47.305,12.515),(47.305,12.345),(47.135,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.345),(47.495,12.515),(47.665,12.515),(47.665,12.345),(47.495,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.345),(47.855,12.515),(48.025,12.515),(48.025,12.345),(47.855,12.345)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.705),(46.775,12.875),(46.945,12.875),(46.945,12.705),(46.775,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.705),(47.135,12.875),(47.305,12.875),(47.305,12.705),(47.135,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.705),(47.495,12.875),(47.665,12.875),(47.665,12.705),(47.495,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.705),(47.855,12.875),(48.025,12.875),(48.025,12.705),(47.855,12.705)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.065),(46.775,13.235),(46.945,13.235),(46.945,13.065),(46.775,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.065),(47.135,13.235),(47.305,13.235),(47.305,13.065),(47.135,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.065),(47.495,13.235),(47.665,13.235),(47.665,13.065),(47.495,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.065),(47.855,13.235),(48.025,13.235),(48.025,13.065),(47.855,13.065)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.425),(46.775,13.595),(46.945,13.595),(46.945,13.425),(46.775,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.425),(47.135,13.595),(47.305,13.595),(47.305,13.425),(47.135,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.425),(47.495,13.595),(47.665,13.595),(47.665,13.425),(47.495,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.425),(47.855,13.595),(48.025,13.595),(48.025,13.425),(47.855,13.425)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.785),(46.775,13.955),(46.945,13.955),(46.945,13.785),(46.775,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.785),(47.135,13.955),(47.305,13.955),(47.305,13.785),(47.135,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.785),(47.495,13.955),(47.665,13.955),(47.665,13.785),(47.495,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.785),(47.855,13.955),(48.025,13.955),(48.025,13.785),(47.855,13.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.145),(46.775,14.315),(46.945,14.315),(46.945,14.145),(46.775,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.145),(47.135,14.315),(47.305,14.315),(47.305,14.145),(47.135,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.145),(47.495,14.315),(47.665,14.315),(47.665,14.145),(47.495,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.145),(47.855,14.315),(48.025,14.315),(48.025,14.145),(47.855,14.145)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.505),(46.775,14.675),(46.945,14.675),(46.945,14.505),(46.775,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.505),(47.135,14.675),(47.305,14.675),(47.305,14.505),(47.135,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.505),(47.495,14.675),(47.665,14.675),(47.665,14.505),(47.495,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.505),(47.855,14.675),(48.025,14.675),(48.025,14.505),(47.855,14.505)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.865),(46.775,15.035),(46.945,15.035),(46.945,14.865),(46.775,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.865),(47.135,15.035),(47.305,15.035),(47.305,14.865),(47.135,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.865),(47.495,15.035),(47.665,15.035),(47.665,14.865),(47.495,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.865),(47.855,15.035),(48.025,15.035),(48.025,14.865),(47.855,14.865)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.225),(46.775,15.395),(46.945,15.395),(46.945,15.225),(46.775,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.225),(47.135,15.395),(47.305,15.395),(47.305,15.225),(47.135,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.225),(47.495,15.395),(47.665,15.395),(47.665,15.225),(47.495,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.225),(47.855,15.395),(48.025,15.395),(48.025,15.225),(47.855,15.225)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.585),(46.775,15.755),(46.945,15.755),(46.945,15.585),(46.775,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.585),(47.135,15.755),(47.305,15.755),(47.305,15.585),(47.135,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.585),(47.495,15.755),(47.665,15.755),(47.665,15.585),(47.495,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.585),(47.855,15.755),(48.025,15.755),(48.025,15.585),(47.855,15.585)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.945),(46.775,16.115),(46.945,16.115),(46.945,15.945),(46.775,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.945),(47.135,16.115),(47.305,16.115),(47.305,15.945),(47.135,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.945),(47.495,16.115),(47.665,16.115),(47.665,15.945),(47.495,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.945),(47.855,16.115),(48.025,16.115),(48.025,15.945),(47.855,15.945)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.305),(46.775,16.475),(46.945,16.475),(46.945,16.305),(46.775,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.305),(47.135,16.475),(47.305,16.475),(47.305,16.305),(47.135,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.305),(47.495,16.475),(47.665,16.475),(47.665,16.305),(47.495,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.305),(47.855,16.475),(48.025,16.475),(48.025,16.305),(47.855,16.305)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.665),(46.775,16.835),(46.945,16.835),(46.945,16.665),(46.775,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.665),(47.135,16.835),(47.305,16.835),(47.305,16.665),(47.135,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.665),(47.495,16.835),(47.665,16.835),(47.665,16.665),(47.495,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.665),(47.855,16.835),(48.025,16.835),(48.025,16.665),(47.855,16.665)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.025),(46.775,17.195),(46.945,17.195),(46.945,17.025),(46.775,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.025),(47.135,17.195),(47.305,17.195),(47.305,17.025),(47.135,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.025),(47.495,17.195),(47.665,17.195),(47.665,17.025),(47.495,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.025),(47.855,17.195),(48.025,17.195),(48.025,17.025),(47.855,17.025)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.385),(46.775,17.555),(46.945,17.555),(46.945,17.385),(46.775,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.385),(47.135,17.555),(47.305,17.555),(47.305,17.385),(47.135,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.385),(47.495,17.555),(47.665,17.555),(47.665,17.385),(47.495,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.385),(47.855,17.555),(48.025,17.555),(48.025,17.385),(47.855,17.385)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.745),(46.775,17.915),(46.945,17.915),(46.945,17.745),(46.775,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.745),(47.135,17.915),(47.305,17.915),(47.305,17.745),(47.135,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.745),(47.495,17.915),(47.665,17.915),(47.665,17.745),(47.495,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.745),(47.855,17.915),(48.025,17.915),(48.025,17.745),(47.855,17.745)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.105),(46.775,18.275),(46.945,18.275),(46.945,18.105),(46.775,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.105),(47.135,18.275),(47.305,18.275),(47.305,18.105),(47.135,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.105),(47.495,18.275),(47.665,18.275),(47.665,18.105),(47.495,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.105),(47.855,18.275),(48.025,18.275),(48.025,18.105),(47.855,18.105)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.465),(46.775,18.635),(46.945,18.635),(46.945,18.465),(46.775,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.465),(47.135,18.635),(47.305,18.635),(47.305,18.465),(47.135,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.465),(47.495,18.635),(47.665,18.635),(47.665,18.465),(47.495,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.465),(47.855,18.635),(48.025,18.635),(48.025,18.465),(47.855,18.465)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.825),(46.775,18.995),(46.945,18.995),(46.945,18.825),(46.775,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.825),(47.135,18.995),(47.305,18.995),(47.305,18.825),(47.135,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.825),(47.495,18.995),(47.665,18.995),(47.665,18.825),(47.495,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.825),(47.855,18.995),(48.025,18.995),(48.025,18.825),(47.855,18.825)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.185),(46.775,19.355),(46.945,19.355),(46.945,19.185),(46.775,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.185),(47.135,19.355),(47.305,19.355),(47.305,19.185),(47.135,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.185),(47.495,19.355),(47.665,19.355),(47.665,19.185),(47.495,19.185)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.185),(47.855,19.355),(48.025,19.355),(48.025,19.185),(47.855,19.185)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,19.415),(48.055,19.415),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,22.34),(38.455,22.34),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.925),(46.745,22.34),(48.055,22.34),(48.055,2.925),(46.745,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,22.34),(52.855,22.34),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.925),(37.145,19.415),(38.455,19.415),(38.455,2.925),(37.145,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,22.34),(33.655,22.34),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.925),(32.345,19.415),(33.655,19.415),(33.655,2.925),(32.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,19.415),(43.255,19.415),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.925),(51.545,19.415),(52.855,19.415),(52.855,2.925),(51.545,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.925),(41.945,22.34),(43.255,22.34),(43.255,2.925),(41.945,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,22.34),(57.655,22.34),(57.655,2.925),(56.345,2.925)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.925),(56.345,19.415),(57.655,19.415),(57.655,2.925),(56.345,2.925)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.925), u(22.34),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['off']
        createRL(
            tech, net, 'poly',
            ((33.93,19.78),(33.93,20.11),(34.2,20.11),(34.2,19.78),(33.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.59),(52.965,19.75),(53.565,19.75),(53.565,2.59),(52.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,19.78),(48.33,20.11),(48.6,20.11),(48.6,19.78),(48.33,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.56),(36.435,2.59),(37.035,2.59),(37.035,2.56),(36.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.59),(33.765,19.75),(34.365,19.75),(34.365,2.59),(33.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.56),(38.565,2.59),(39.165,2.59),(39.165,2.56),(38.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,19.75),(41.235,19.78),(41.835,19.78),(41.835,19.75),(41.235,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.56),(31.635,2.59),(32.235,2.59),(32.235,2.56),(31.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,11.34),(73.68,11.63),(74.01,11.63),(74.01,11.34),(73.68,11.34)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,19.75),(43.365,19.78),(43.965,19.78),(43.965,19.75),(43.365,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.59),(43.365,19.75),(43.965,19.75),(43.965,2.59),(43.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.56),(50.835,2.59),(51.435,2.59),(51.435,2.56),(50.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.59),(36.435,19.75),(37.035,19.75),(37.035,2.59),(36.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,19.78),(53.13,20.11),(53.4,20.11),(53.4,19.78),(53.13,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.59),(38.565,19.75),(39.165,19.75),(39.165,2.59),(38.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,19.78),(46.2,20.11),(46.47,20.11),(46.47,19.78),(46.2,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,19.78),(55.8,20.11),(56.07,20.11),(56.07,19.78),(55.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.59),(31.635,19.75),(32.235,19.75),(32.235,2.59),(31.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,19.75),(55.635,19.78),(56.235,19.78),(56.235,19.75),(55.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.59),(41.235,19.75),(41.835,19.75),(41.835,2.59),(41.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.56),(43.365,2.59),(43.965,2.59),(43.965,2.56),(43.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.56),(55.635,2.59),(56.235,2.59),(56.235,2.56),(55.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,19.75),(50.835,19.78),(51.435,19.78),(51.435,19.75),(50.835,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.59),(48.165,19.75),(48.765,19.75),(48.765,2.59),(48.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,19.75),(57.765,19.78),(58.365,19.78),(58.365,19.75),(57.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.56),(57.765,2.59),(58.365,2.59),(58.365,2.56),(57.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,19.75),(52.965,19.78),(53.565,19.78),(53.565,19.75),(52.965,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,19.75),(46.035,19.78),(46.635,19.78),(46.635,19.75),(46.035,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.56),(48.165,2.59),(48.765,2.59),(48.765,2.56),(48.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.59),(46.035,19.75),(46.635,19.75),(46.635,2.59),(46.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,19.75),(33.765,19.78),(34.365,19.78),(34.365,19.75),(33.765,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.56),(41.235,2.59),(41.835,2.59),(41.835,2.56),(41.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.56),(33.765,2.59),(34.365,2.59),(34.365,2.56),(33.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.59),(50.835,19.75),(51.435,19.75),(51.435,2.59),(50.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.59),(57.765,19.75),(58.365,19.75),(58.365,2.59),(57.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,19.78),(36.6,20.11),(36.87,20.11),(36.87,19.78),(36.6,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,19.75),(48.165,19.78),(48.765,19.78),(48.765,19.75),(48.165,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,19.78),(41.4,20.11),(41.67,20.11),(41.67,19.78),(41.4,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.56),(46.035,2.59),(46.635,2.59),(46.635,2.56),(46.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,19.78),(38.73,20.11),(39.0,20.11),(39.0,19.78),(38.73,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,19.75),(36.435,19.78),(37.035,19.78),(37.035,19.75),(36.435,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,19.78),(51.0,20.11),(51.27,20.11),(51.27,19.78),(51.0,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,19.78),(43.53,20.11),(43.8,20.11),(43.8,19.78),(43.53,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,11.335),(73.68,11.6),(74.01,11.6),(74.01,11.335),(73.68,11.335)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.56),(52.965,2.59),(53.565,2.59),(53.565,2.56),(52.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,19.75),(38.565,19.78),(39.165,19.78),(39.165,19.75),(38.565,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,19.78),(31.8,20.11),(32.07,20.11),(32.07,19.78),(31.8,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.59),(55.635,19.75),(56.235,19.75),(56.235,2.59),(55.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,19.78),(57.93,20.11),(58.2,20.11),(58.2,19.78),(57.93,19.78)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,19.75),(31.635,19.78),(32.235,19.78),(32.235,19.75),(31.635,19.75)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,19.86),(33.98,20.03),(34.15,20.03),(34.15,19.86),(33.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,19.86),(48.38,20.03),(48.55,20.03),(48.55,19.86),(48.38,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,19.86),(38.78,20.03),(38.95,20.03),(38.95,19.86),(38.78,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,19.86),(53.18,20.03),(53.35,20.03),(53.35,19.86),(53.18,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,19.86),(46.25,20.03),(46.42,20.03),(46.42,19.86),(46.25,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,19.86),(55.85,20.03),(56.02,20.03),(56.02,19.86),(55.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((73.76,11.38),(73.76,11.55),(73.93,11.55),(73.93,11.38),(73.76,11.38)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,19.86),(36.65,20.03),(36.82,20.03),(36.82,19.86),(36.65,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,19.86),(41.45,20.03),(41.62,20.03),(41.62,19.86),(41.45,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,19.86),(51.05,20.03),(51.22,20.03),(51.22,19.86),(51.05,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,19.86),(43.58,20.03),(43.75,20.03),(43.75,19.86),(43.58,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,19.86),(31.85,20.03),(32.02,20.03),(32.02,19.86),(31.85,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,19.86),(57.98,20.03),(58.15,20.03),(58.15,19.86),(57.98,19.86)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,19.94),(31.85,20.11),(58.15,20.11),(58.15,19.94),(31.85,19.94)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,19.78),(33.98,20.11),(34.15,20.11),(34.15,19.78),(33.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,19.78),(48.38,20.11),(48.55,20.11),(48.55,19.78),(48.38,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.56),(33.98,19.78),(34.15,19.78),(34.15,2.56),(33.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.23),(36.65,2.56),(36.82,2.56),(36.82,2.23),(36.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.23),(38.78,2.56),(38.95,2.56),(38.95,2.23),(38.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,19.78),(38.78,20.11),(38.95,20.11),(38.95,19.78),(38.78,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.56),(43.58,19.78),(43.75,19.78),(43.75,2.56),(43.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.56),(51.05,19.78),(51.22,19.78),(51.22,2.56),(51.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,19.78),(53.18,20.11),(53.35,20.11),(53.35,19.78),(53.18,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,19.78),(46.25,20.11),(46.42,20.11),(46.42,19.78),(46.25,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,19.78),(55.85,20.11),(56.02,20.11),(56.02,19.78),(55.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.56),(31.85,19.78),(32.02,19.78),(32.02,2.56),(31.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.56),(41.45,19.78),(41.62,19.78),(41.62,2.56),(41.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.23),(51.05,2.56),(51.22,2.56),(51.22,2.23),(51.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((73.76,11.3),(73.76,20.11),(73.93,20.11),(73.93,11.3),(73.76,11.3)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.23),(43.58,2.56),(43.75,2.56),(43.75,2.23),(43.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.23),(55.85,2.56),(56.02,2.56),(56.02,2.23),(55.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.56),(48.38,19.78),(48.55,19.78),(48.55,2.56),(48.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((73.76,11.3),(73.76,11.63),(73.93,11.63),(73.93,11.3),(73.76,11.3)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.23),(57.98,2.56),(58.15,2.56),(58.15,2.23),(57.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.56),(46.25,19.78),(46.42,19.78),(46.42,2.56),(46.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.23),(41.45,2.56),(41.62,2.56),(41.62,2.23),(41.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.23),(33.98,2.56),(34.15,2.56),(34.15,2.23),(33.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.56),(36.65,19.78),(36.82,19.78),(36.82,2.56),(36.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.56),(38.78,19.78),(38.95,19.78),(38.95,2.56),(38.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.56),(57.98,19.78),(58.15,19.78),(58.15,2.56),(57.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,19.78),(36.65,20.11),(36.82,20.11),(36.82,19.78),(36.65,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.56),(53.18,19.78),(53.35,19.78),(53.35,2.56),(53.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,19.78),(41.45,20.11),(41.62,20.11),(41.62,19.78),(41.45,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.23),(46.25,2.56),(46.42,2.56),(46.42,2.23),(46.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,19.78),(51.05,20.11),(51.22,20.11),(51.22,19.78),(51.05,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,19.78),(43.58,20.11),(43.75,20.11),(43.75,19.78),(43.58,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,19.78),(31.85,20.11),(32.02,20.11),(32.02,19.78),(31.85,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.56),(55.85,19.78),(56.02,19.78),(56.02,2.56),(55.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,19.78),(57.98,20.11),(58.15,20.11),(58.15,19.78),(57.98,19.78)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.23),(53.18,2.56),(53.35,2.56),(53.35,2.23),(53.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.23),(31.85,2.56),(32.02,2.56),(32.02,2.23),(31.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.23),(48.38,2.56),(48.55,2.56),(48.55,2.23),(48.38,2.23)),
        )
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_N18000W4468HFF']
        except:
            subcell = af.getCell('GuardRing_N18000W4468HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_P17368W3836HFF']
        except:
            subcell = af.getCell('GuardRing_P17368W3836HFF', 0)
        trans = Transformation(
            u(45.0), u(11.17), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    cell = new_cells['Clamp_P12N0D']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(90), u(43.64),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'iovdd': Net.create(cell, 'iovdd'),
            'off': Net.create(cell, 'off'),
            'pad': Net.create(cell, 'pad'),
        }
        net = nets['iovdd']
        createRL(
            tech, net, 'difftap',
            ((55.385,2.72),(55.385,40.92),(55.635,40.92),(55.635,2.72),(55.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.635,2.72),(31.635,40.92),(32.235,40.92),(32.235,2.72),(31.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.965,2.72),(43.965,40.92),(44.215,40.92),(44.215,2.72),(43.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((55.635,2.72),(55.635,40.92),(56.235,40.92),(56.235,2.72),(55.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((59.05,2.72),(59.05,40.92),(59.75,40.92),(59.75,2.72),(59.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.435,2.72),(36.435,40.92),(37.035,40.92),(37.035,2.72),(36.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.765,2.72),(33.765,40.92),(34.365,40.92),(34.365,2.72),(33.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.965,2.72),(52.965,40.92),(53.565,40.92),(53.565,2.72),(52.965,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.785,2.72),(45.785,40.92),(46.035,40.92),(46.035,2.72),(45.785,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,40.92),(54.25,40.92),(54.25,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.585,2.72),(50.585,40.92),(50.835,40.92),(50.835,2.72),(50.585,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.365,2.72),(43.365,40.92),(43.965,40.92),(43.965,2.72),(43.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.73,2.72),(58.73,40.92),(59.05,40.92),(59.05,2.72),(58.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.035,2.72),(46.035,40.92),(46.635,40.92),(46.635,2.72),(46.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.615,2.72),(58.615,40.92),(59.75,40.92),(59.75,2.72),(58.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.765,2.72),(48.765,40.92),(49.015,40.92),(49.015,2.72),(48.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((45.35,2.72),(45.35,40.92),(45.67,40.92),(45.67,2.72),(45.35,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.235,2.72),(41.235,40.92),(41.835,40.92),(41.835,2.72),(41.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.815,2.72),(53.815,40.92),(55.27,40.92),(55.27,2.72),(53.815,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.93,2.72),(53.93,40.92),(55.385,40.92),(55.385,2.72),(53.93,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.15,2.72),(50.15,40.92),(50.47,40.92),(50.47,2.72),(50.15,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.65,2.72),(44.65,40.92),(45.35,40.92),(45.35,2.72),(44.65,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.215,2.72),(44.215,40.92),(45.67,40.92),(45.67,2.72),(44.215,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,40.92),(45.785,40.92),(45.785,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.165,2.72),(39.165,40.92),(39.415,40.92),(39.415,2.72),(39.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,40.92),(49.45,40.92),(49.45,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((58.365,2.72),(58.365,40.92),(58.615,40.92),(58.615,2.72),(58.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.05,2.72),(35.05,40.92),(35.75,40.92),(35.75,2.72),(35.05,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.765,2.72),(57.765,40.92),(58.365,40.92),(58.365,2.72),(57.765,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.985,2.72),(40.985,40.92),(41.235,40.92),(41.235,2.72),(40.985,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((44.33,2.72),(44.33,40.92),(44.65,40.92),(44.65,2.72),(44.33,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((31.385,2.72),(31.385,40.92),(31.635,40.92),(31.635,2.72),(31.385,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((40.55,2.72),(40.55,40.92),(40.87,40.92),(40.87,2.72),(40.55,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.565,2.72),(38.565,40.92),(39.165,40.92),(39.165,2.72),(38.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,40.92),(36.185,40.92),(36.185,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.615,2.72),(34.615,40.92),(36.07,40.92),(36.07,2.72),(34.615,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((48.165,2.72),(48.165,40.92),(48.765,40.92),(48.765,2.72),(48.165,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.365,2.72),(34.365,40.92),(34.615,40.92),(34.615,2.72),(34.365,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((36.185,2.72),(36.185,40.92),(36.435,40.92),(36.435,2.72),(36.185,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((34.73,2.72),(34.73,40.92),(35.05,40.92),(35.05,2.72),(34.73,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,40.92),(31.385,40.92),(31.385,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.95,2.72),(30.95,40.92),(31.27,40.92),(31.27,2.72),(30.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,40.92),(39.85,40.92),(39.85,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((53.565,2.72),(53.565,40.92),(53.815,40.92),(53.815,2.72),(53.565,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((30.25,2.72),(30.25,40.92),(30.95,40.92),(30.95,2.72),(30.25,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.45,2.72),(49.45,40.92),(50.15,40.92),(50.15,2.72),(49.45,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.015,2.72),(49.015,40.92),(50.47,40.92),(50.47,2.72),(49.015,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((35.75,2.72),(35.75,40.92),(36.07,40.92),(36.07,2.72),(35.75,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((49.13,2.72),(49.13,40.92),(50.585,40.92),(50.585,2.72),(49.13,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.85,2.72),(39.85,40.92),(40.55,40.92),(40.55,2.72),(39.85,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.415,2.72),(39.415,40.92),(40.87,40.92),(40.87,2.72),(39.415,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((39.53,2.72),(39.53,40.92),(40.985,40.92),(40.985,2.72),(39.53,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((50.835,2.72),(50.835,40.92),(51.435,40.92),(51.435,2.72),(50.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.95,2.72),(54.95,40.92),(55.27,40.92),(55.27,2.72),(54.95,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((54.25,2.72),(54.25,40.92),(54.95,40.92),(54.95,2.72),(54.25,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.045),(31.025,29.215),(31.195,29.215),(31.195,29.045),(31.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.385),(31.025,29.555),(31.195,29.555),(31.195,29.385),(31.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,29.725),(31.025,29.895),(31.195,29.895),(31.195,29.725),(31.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.285),(39.605,24.455),(39.775,24.455),(39.775,24.285),(39.605,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.625),(39.605,24.795),(39.775,24.795),(39.775,24.625),(39.605,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.245),(30.515,22.415),(30.685,22.415),(30.685,22.245),(30.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.585),(30.515,22.755),(30.685,22.755),(30.685,22.585),(30.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,26.325),(55.025,26.495),(55.195,26.495),(55.195,26.325),(55.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,26.665),(55.025,26.835),(55.195,26.835),(55.195,26.665),(55.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.585),(39.605,39.755),(39.775,39.755),(39.775,39.585),(39.605,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.525),(35.825,19.695),(35.995,19.695),(35.995,19.525),(35.825,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.185),(35.825,19.355),(35.995,19.355),(35.995,19.185),(35.825,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.185),(35.315,19.355),(35.485,19.355),(35.485,19.185),(35.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.525),(35.315,19.695),(35.485,19.695),(35.485,19.525),(35.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.245),(39.605,39.415),(39.775,39.415),(39.775,39.245),(39.605,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.965),(59.315,25.135),(59.485,25.135),(59.485,24.965),(59.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.505),(44.405,18.675),(44.575,18.675),(44.575,18.505),(44.405,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.165),(44.405,18.335),(44.575,18.335),(44.575,18.165),(44.405,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.065),(55.025,30.235),(55.195,30.235),(55.195,30.065),(55.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.405),(55.025,30.575),(55.195,30.575),(55.195,30.405),(55.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,30.745),(55.025,30.915),(55.195,30.915),(55.195,30.745),(55.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.965),(31.025,8.135),(31.195,8.135),(31.195,7.965),(31.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.285),(59.315,7.455),(59.485,7.455),(59.485,7.285),(59.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.625),(59.315,7.795),(59.485,7.795),(59.485,7.625),(59.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.885),(34.805,21.055),(34.975,21.055),(34.975,20.885),(34.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.805),(35.825,33.975),(35.995,33.975),(35.995,33.805),(35.825,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.805),(35.315,33.975),(35.485,33.975),(35.485,33.805),(35.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.125),(35.825,33.295),(35.995,33.295),(35.995,33.125),(35.825,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,33.465),(35.825,33.635),(35.995,33.635),(35.995,33.465),(35.825,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.125),(35.315,33.295),(35.485,33.295),(35.485,33.125),(35.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,33.465),(35.315,33.635),(35.485,33.635),(35.485,33.465),(35.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.525),(58.805,36.695),(58.975,36.695),(58.975,36.525),(58.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.185),(58.805,36.355),(58.975,36.355),(58.975,36.185),(58.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.125),(59.315,16.295),(59.485,16.295),(59.485,16.125),(59.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.465),(59.315,16.635),(59.485,16.635),(59.485,16.465),(59.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,16.805),(59.315,16.975),(59.485,16.975),(59.485,16.805),(59.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.885),(44.915,38.055),(45.085,38.055),(45.085,37.885),(44.915,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.305),(44.405,8.475),(44.575,8.475),(44.575,8.305),(44.405,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.645),(44.405,8.815),(44.575,8.815),(44.575,8.645),(44.405,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.925),(50.225,40.095),(50.395,40.095),(50.395,39.925),(50.225,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.985),(35.315,26.155),(35.485,26.155),(35.485,25.985),(35.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.985),(35.825,26.155),(35.995,26.155),(35.995,25.985),(35.825,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.525),(34.805,36.695),(34.975,36.695),(34.975,36.525),(34.805,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.185),(34.805,36.355),(34.975,36.355),(34.975,36.185),(34.805,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.185),(45.425,36.355),(45.595,36.355),(45.595,36.185),(45.425,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.025),(58.805,11.195),(58.975,11.195),(58.975,11.025),(58.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.525),(45.425,36.695),(45.595,36.695),(45.595,36.525),(45.425,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.305),(49.715,25.475),(49.885,25.475),(49.885,25.305),(49.715,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.645),(49.205,25.815),(49.375,25.815),(49.375,25.645),(49.205,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.905),(39.605,39.075),(39.775,39.075),(39.775,38.905),(39.605,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.865),(34.805,20.035),(34.975,20.035),(34.975,19.865),(34.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.145),(31.025,17.315),(31.195,17.315),(31.195,17.145),(31.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.485),(31.025,17.655),(31.195,17.655),(31.195,17.485),(31.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,17.825),(31.025,17.995),(31.195,17.995),(31.195,17.825),(31.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.825),(31.025,34.995),(31.195,34.995),(31.195,34.825),(31.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.145),(31.025,34.315),(31.195,34.315),(31.195,34.145),(31.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,34.485),(31.025,34.655),(31.195,34.655),(31.195,34.485),(31.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.025),(49.715,28.195),(49.885,28.195),(49.885,28.025),(49.715,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.365),(49.715,28.535),(49.885,28.535),(49.885,28.365),(49.715,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.025),(49.205,28.195),(49.375,28.195),(49.375,28.025),(49.205,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.365),(49.205,28.535),(49.375,28.535),(49.375,28.365),(49.205,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,28.705),(49.205,28.875),(49.375,28.875),(49.375,28.705),(49.205,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,28.705),(49.715,28.875),(49.885,28.875),(49.885,28.705),(49.715,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.245),(35.825,22.415),(35.995,22.415),(35.995,22.245),(35.825,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.245),(35.315,22.415),(35.485,22.415),(35.485,22.245),(35.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.585),(35.315,22.755),(35.485,22.755),(35.485,22.585),(35.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.585),(35.825,22.755),(35.995,22.755),(35.995,22.585),(35.825,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.225),(39.605,21.395),(39.775,21.395),(39.775,21.225),(39.605,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.565),(39.605,21.735),(39.775,21.735),(39.775,21.565),(39.605,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.985),(50.225,26.155),(50.395,26.155),(50.395,25.985),(50.225,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.085),(49.715,14.255),(49.885,14.255),(49.885,14.085),(49.715,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.425),(49.715,14.595),(49.885,14.595),(49.885,14.425),(49.715,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.085),(49.205,14.255),(49.375,14.255),(49.375,14.085),(49.205,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.425),(49.205,14.595),(49.375,14.595),(49.375,14.425),(49.205,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.305),(35.315,8.475),(35.485,8.475),(35.485,8.305),(35.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.645),(35.315,8.815),(35.485,8.815),(35.485,8.645),(35.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.305),(35.825,8.475),(35.995,8.475),(35.995,8.305),(35.825,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.645),(35.825,8.815),(35.995,8.815),(35.995,8.645),(35.825,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.965),(55.025,8.135),(55.195,8.135),(55.195,7.965),(55.025,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,14.765),(49.715,14.935),(49.885,14.935),(49.885,14.765),(49.715,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.925),(49.715,6.095),(49.885,6.095),(49.885,5.925),(49.715,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.925),(49.205,6.095),(49.375,6.095),(49.375,5.925),(49.205,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.105),(49.205,32.275),(49.375,32.275),(49.375,32.105),(49.205,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.445),(49.715,32.615),(49.885,32.615),(49.885,32.445),(49.715,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.105),(49.715,32.275),(49.885,32.275),(49.885,32.105),(49.715,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,32.785),(49.715,32.955),(49.885,32.955),(49.885,32.785),(49.715,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.785),(49.205,32.955),(49.375,32.955),(49.375,32.785),(49.205,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,32.445),(49.205,32.615),(49.375,32.615),(49.375,32.445),(49.205,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.545),(40.625,3.715),(40.795,3.715),(40.795,3.545),(40.625,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.205),(40.115,3.375),(40.285,3.375),(40.285,3.205),(40.115,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.205),(40.625,3.375),(40.795,3.375),(40.795,3.205),(40.625,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,40.265),(45.425,40.435),(45.595,40.435),(45.595,40.265),(45.425,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,40.605),(45.425,40.775),(45.595,40.775),(45.595,40.605),(45.425,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.545),(40.115,3.715),(40.285,3.715),(40.285,3.545),(40.115,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.745),(40.625,30.915),(40.795,30.915),(40.795,30.745),(40.625,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.905),(39.605,5.075),(39.775,5.075),(39.775,4.905),(39.605,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.465),(50.225,33.635),(50.395,33.635),(50.395,33.465),(50.225,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.125),(50.225,33.295),(50.395,33.295),(50.395,33.125),(50.225,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,33.805),(50.225,33.975),(50.395,33.975),(50.395,33.805),(50.225,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.765),(35.825,31.935),(35.995,31.935),(35.995,31.765),(35.825,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.765),(35.315,31.935),(35.485,31.935),(35.485,31.765),(35.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.085),(35.825,31.255),(35.995,31.255),(35.995,31.085),(35.825,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.225),(55.025,4.395),(55.195,4.395),(55.195,4.225),(55.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.565),(55.025,4.735),(55.195,4.735),(55.195,4.565),(55.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,31.425),(35.825,31.595),(35.995,31.595),(35.995,31.425),(35.825,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.425),(35.315,31.595),(35.485,31.595),(35.485,31.425),(35.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,31.085),(35.315,31.255),(35.485,31.255),(35.485,31.085),(35.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.985),(31.025,26.155),(31.195,26.155),(31.195,25.985),(31.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.625),(49.715,7.795),(49.885,7.795),(49.885,7.625),(49.715,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.285),(49.715,7.455),(49.885,7.455),(49.885,7.285),(49.715,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.625),(49.205,7.795),(49.375,7.795),(49.375,7.625),(49.205,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.285),(49.205,7.455),(49.375,7.455),(49.375,7.285),(49.205,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.485),(59.315,34.655),(59.485,34.655),(59.485,34.485),(59.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.825),(59.315,34.995),(59.485,34.995),(59.485,34.825),(59.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,34.145),(59.315,34.315),(59.485,34.315),(59.485,34.145),(59.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.565),(50.225,21.735),(50.395,21.735),(50.395,21.565),(50.225,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.225),(50.225,21.395),(50.395,21.395),(50.395,21.225),(50.225,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.225),(49.715,21.395),(49.885,21.395),(49.885,21.225),(49.715,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.225),(49.205,21.395),(49.375,21.395),(49.375,21.225),(49.205,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.565),(49.715,21.735),(49.885,21.735),(49.885,21.565),(49.715,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.565),(49.205,21.735),(49.375,21.735),(49.375,21.565),(49.205,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.865),(31.025,20.035),(31.195,20.035),(31.195,19.865),(31.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.965),(44.405,25.135),(44.575,25.135),(44.575,24.965),(44.405,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.225),(40.115,21.395),(40.285,21.395),(40.285,21.225),(40.115,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.225),(40.625,21.395),(40.795,21.395),(40.795,21.225),(40.625,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.565),(40.625,21.735),(40.795,21.735),(40.795,21.565),(40.625,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.565),(40.115,21.735),(40.285,21.735),(40.285,21.565),(40.115,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.865),(39.605,20.035),(39.775,20.035),(39.775,19.865),(39.605,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.225),(31.025,4.395),(31.195,4.395),(31.195,4.225),(31.025,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.565),(31.025,4.735),(31.195,4.735),(31.195,4.565),(31.025,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.945),(39.605,24.115),(39.775,24.115),(39.775,23.945),(39.605,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.645),(54.515,25.815),(54.685,25.815),(54.685,25.645),(54.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.305),(54.515,25.475),(54.685,25.475),(54.685,25.305),(54.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.645),(54.005,25.815),(54.175,25.815),(54.175,25.645),(54.005,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.305),(54.005,25.475),(54.175,25.475),(54.175,25.305),(54.005,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.965),(35.825,25.135),(35.995,25.135),(35.995,24.965),(35.825,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.965),(35.315,25.135),(35.485,25.135),(35.485,24.965),(35.315,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.865),(49.715,20.035),(49.885,20.035),(49.885,19.865),(49.715,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.765),(58.805,31.935),(58.975,31.935),(58.975,31.765),(58.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.085),(58.805,31.255),(58.975,31.255),(58.975,31.085),(58.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.685),(49.715,27.855),(49.885,27.855),(49.885,27.685),(49.715,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.685),(49.205,27.855),(49.375,27.855),(49.375,27.685),(49.205,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.005),(49.715,27.175),(49.885,27.175),(49.885,27.005),(49.715,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,27.345),(49.715,27.515),(49.885,27.515),(49.885,27.345),(49.715,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.005),(49.205,27.175),(49.375,27.175),(49.375,27.005),(49.205,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,31.425),(58.805,31.595),(58.975,31.595),(58.975,31.425),(58.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,27.345),(49.205,27.515),(49.375,27.515),(49.375,27.345),(49.205,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.805),(44.405,16.975),(44.575,16.975),(44.575,16.805),(44.405,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.465),(44.405,16.635),(44.575,16.635),(44.575,16.465),(44.405,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,16.125),(44.405,16.295),(44.575,16.295),(44.575,16.125),(44.405,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.025),(50.225,28.195),(50.395,28.195),(50.395,28.025),(50.225,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.365),(50.225,28.535),(50.395,28.535),(50.395,28.365),(50.225,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,28.705),(50.225,28.875),(50.395,28.875),(50.395,28.705),(50.225,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.145),(45.425,34.315),(45.595,34.315),(45.595,34.145),(45.425,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.485),(45.425,34.655),(45.595,34.655),(45.595,34.485),(45.425,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,34.825),(45.425,34.995),(45.595,34.995),(45.595,34.825),(45.425,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.885),(31.025,21.055),(31.195,21.055),(31.195,20.885),(31.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.625),(31.025,24.795),(31.195,24.795),(31.195,24.625),(31.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.285),(31.025,24.455),(31.195,24.455),(31.195,24.285),(31.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.205),(44.405,20.375),(44.575,20.375),(44.575,20.205),(44.405,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.545),(44.405,20.715),(44.575,20.715),(44.575,20.545),(44.405,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,40.265),(39.605,40.435),(39.775,40.435),(39.775,40.265),(39.605,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,40.605),(39.605,40.775),(39.775,40.775),(39.775,40.605),(39.605,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.545),(54.005,37.715),(54.175,37.715),(54.175,37.545),(54.005,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.545),(54.515,37.715),(54.685,37.715),(54.685,37.545),(54.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.205),(54.005,37.375),(54.175,37.375),(54.175,37.205),(54.005,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.205),(54.515,37.375),(54.685,37.375),(54.685,37.205),(54.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.645),(49.205,8.815),(49.375,8.815),(49.375,8.645),(49.205,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.305),(49.715,8.475),(49.885,8.475),(49.885,8.305),(49.715,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.645),(49.715,8.815),(49.885,8.815),(49.885,8.645),(49.715,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.305),(49.205,8.475),(49.375,8.475),(49.375,8.305),(49.205,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.205),(58.805,20.375),(58.975,20.375),(58.975,20.205),(58.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.545),(58.805,20.715),(58.975,20.715),(58.975,20.545),(58.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.665),(34.805,9.835),(34.975,9.835),(34.975,9.665),(34.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.605),(34.805,23.775),(34.975,23.775),(34.975,23.605),(34.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.265),(34.805,23.435),(34.975,23.435),(34.975,23.265),(34.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,9.325),(34.805,9.495),(34.975,9.495),(34.975,9.325),(34.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.025),(31.025,28.195),(31.195,28.195),(31.195,28.025),(31.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.365),(31.025,28.535),(31.195,28.535),(31.195,28.365),(31.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,28.705),(31.025,28.875),(31.195,28.875),(31.195,28.705),(31.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.205),(54.515,20.375),(54.685,20.375),(54.685,20.205),(54.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.545),(54.515,20.715),(54.685,20.715),(54.685,20.545),(54.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.205),(54.005,20.375),(54.175,20.375),(54.175,20.205),(54.005,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.545),(54.005,20.715),(54.175,20.715),(54.175,20.545),(54.005,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.225),(54.515,38.395),(54.685,38.395),(54.685,38.225),(54.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.565),(54.515,38.735),(54.685,38.735),(54.685,38.565),(54.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.565),(54.005,38.735),(54.175,38.735),(54.175,38.565),(54.005,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.225),(54.005,38.395),(54.175,38.395),(54.175,38.225),(54.005,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.545),(54.515,3.715),(54.685,3.715),(54.685,3.545),(54.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.205),(54.005,3.375),(54.175,3.375),(54.175,3.205),(54.005,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.545),(54.005,3.715),(54.175,3.715),(54.175,3.545),(54.005,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.205),(54.515,3.375),(54.685,3.375),(54.685,3.205),(54.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.905),(35.825,5.075),(35.995,5.075),(35.995,4.905),(35.825,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.905),(35.315,5.075),(35.485,5.075),(35.485,4.905),(35.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.465),(54.005,16.635),(54.175,16.635),(54.175,16.465),(54.005,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.125),(54.005,16.295),(54.175,16.295),(54.175,16.125),(54.005,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.125),(54.515,16.295),(54.685,16.295),(54.685,16.125),(54.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.465),(54.515,16.635),(54.685,16.635),(54.685,16.465),(54.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,16.805),(54.005,16.975),(54.175,16.975),(54.175,16.805),(54.005,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,16.805),(54.515,16.975),(54.685,16.975),(54.685,16.805),(54.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.845),(34.805,19.015),(34.975,19.015),(34.975,18.845),(34.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.445),(44.405,32.615),(44.575,32.615),(44.575,32.445),(44.405,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.105),(44.405,32.275),(44.575,32.275),(44.575,32.105),(44.405,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,32.785),(44.405,32.955),(44.575,32.955),(44.575,32.785),(44.405,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.685),(59.315,27.855),(59.485,27.855),(59.485,27.685),(59.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.005),(59.315,27.175),(59.485,27.175),(59.485,27.005),(59.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.965),(49.715,25.135),(49.885,25.135),(49.885,24.965),(49.715,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.845),(35.825,19.015),(35.995,19.015),(35.995,18.845),(35.825,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,27.345),(59.315,27.515),(59.485,27.515),(59.485,27.345),(59.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.845),(35.315,19.015),(35.485,19.015),(35.485,18.845),(35.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.965),(49.205,25.135),(49.375,25.135),(49.375,24.965),(49.205,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.105),(40.625,32.275),(40.795,32.275),(40.795,32.105),(40.625,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.785),(40.625,32.955),(40.795,32.955),(40.795,32.785),(40.625,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.785),(40.115,32.955),(40.285,32.955),(40.285,32.785),(40.115,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.445),(40.115,32.615),(40.285,32.615),(40.285,32.445),(40.115,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,32.105),(40.115,32.275),(40.285,32.275),(40.285,32.105),(40.115,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,32.445),(40.625,32.615),(40.795,32.615),(40.795,32.445),(40.625,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.805),(31.025,16.975),(31.195,16.975),(31.195,16.805),(31.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.125),(31.025,16.295),(31.195,16.295),(31.195,16.125),(31.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,16.465),(31.025,16.635),(31.195,16.635),(31.195,16.465),(31.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.005),(39.605,10.175),(39.775,10.175),(39.775,10.005),(39.605,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.345),(39.605,10.515),(39.775,10.515),(39.775,10.345),(39.605,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,10.685),(39.605,10.855),(39.775,10.855),(39.775,10.685),(39.605,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.745),(59.315,30.915),(59.485,30.915),(59.485,30.745),(59.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.565),(35.315,38.735),(35.485,38.735),(35.485,38.565),(35.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.225),(35.315,38.395),(35.485,38.395),(35.485,38.225),(35.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.225),(35.825,38.395),(35.995,38.395),(35.995,38.225),(35.825,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.565),(35.825,38.735),(35.995,38.735),(35.995,38.565),(35.825,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.405),(59.315,30.575),(59.485,30.575),(59.485,30.405),(59.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,30.065),(59.315,30.235),(59.485,30.235),(59.485,30.065),(59.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.305),(59.315,8.475),(59.485,8.475),(59.485,8.305),(59.315,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.645),(59.315,8.815),(59.485,8.815),(59.485,8.645),(59.315,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.605),(55.025,23.775),(55.195,23.775),(55.195,23.605),(55.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.265),(55.025,23.435),(55.195,23.435),(55.195,23.265),(55.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.805),(50.225,16.975),(50.395,16.975),(50.395,16.805),(50.225,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.125),(50.225,16.295),(50.395,16.295),(50.395,16.125),(50.225,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,16.465),(50.225,16.635),(50.395,16.635),(50.395,16.465),(50.225,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.305),(30.515,8.475),(30.685,8.475),(30.685,8.305),(30.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.645),(30.515,8.815),(30.685,8.815),(30.685,8.645),(30.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.905),(50.225,5.075),(50.395,5.075),(50.395,4.905),(50.225,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.045),(34.805,29.215),(34.975,29.215),(34.975,29.045),(34.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.205),(30.515,3.375),(30.685,3.375),(30.685,3.205),(30.515,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.545),(30.515,3.715),(30.685,3.715),(30.685,3.545),(30.515,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.385),(34.805,29.555),(34.975,29.555),(34.975,29.385),(34.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,29.725),(34.805,29.895),(34.975,29.895),(34.975,29.725),(34.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.925),(54.515,6.095),(54.685,6.095),(54.685,5.925),(54.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.925),(54.005,6.095),(54.175,6.095),(54.175,5.925),(54.005,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.245),(44.405,5.415),(44.575,5.415),(44.575,5.245),(44.405,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.585),(44.405,5.755),(44.575,5.755),(44.575,5.585),(44.405,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.825),(54.005,17.995),(54.175,17.995),(54.175,17.825),(54.005,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.525),(44.405,19.695),(44.575,19.695),(44.575,19.525),(44.405,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.185),(44.405,19.355),(44.575,19.355),(44.575,19.185),(44.405,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.965),(54.515,8.135),(54.685,8.135),(54.685,7.965),(54.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.965),(54.005,8.135),(54.175,8.135),(54.175,7.965),(54.005,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.545),(59.315,3.715),(59.485,3.715),(59.485,3.545),(59.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.205),(59.315,3.375),(59.485,3.375),(59.485,3.205),(59.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.865),(45.425,20.035),(45.595,20.035),(45.595,19.865),(45.425,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.105),(31.025,15.275),(31.195,15.275),(31.195,15.105),(31.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.445),(31.025,15.615),(31.195,15.615),(31.195,15.445),(31.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,15.785),(31.025,15.955),(31.195,15.955),(31.195,15.785),(31.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.965),(30.515,25.135),(30.685,25.135),(30.685,24.965),(30.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.065),(54.515,30.235),(54.685,30.235),(54.685,30.065),(54.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.405),(54.515,30.575),(54.685,30.575),(54.685,30.405),(54.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.405),(54.005,30.575),(54.175,30.575),(54.175,30.405),(54.005,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,30.745),(54.515,30.915),(54.685,30.915),(54.685,30.745),(54.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.745),(54.005,30.915),(54.175,30.915),(54.175,30.745),(54.005,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,30.065),(54.005,30.235),(54.175,30.235),(54.175,30.065),(54.005,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,14.765),(49.205,14.935),(49.375,14.935),(49.375,14.765),(49.205,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.845),(44.915,36.015),(45.085,36.015),(45.085,35.845),(44.915,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.885),(30.515,21.055),(30.685,21.055),(30.685,20.885),(30.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.925),(59.315,40.095),(59.485,40.095),(59.485,39.925),(59.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.205),(31.025,3.375),(31.195,3.375),(31.195,3.205),(31.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.545),(31.025,3.715),(31.195,3.715),(31.195,3.545),(31.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.265),(58.805,6.435),(58.975,6.435),(58.975,6.265),(58.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.905),(35.315,22.075),(35.485,22.075),(35.485,21.905),(35.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.905),(35.825,22.075),(35.995,22.075),(35.995,21.905),(35.825,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.685),(30.515,27.855),(30.685,27.855),(30.685,27.685),(30.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,3.885),(54.515,4.055),(54.685,4.055),(54.685,3.885),(54.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,3.885),(54.005,4.055),(54.175,4.055),(54.175,3.885),(54.005,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.345),(30.515,27.515),(30.685,27.515),(30.685,27.345),(30.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,27.005),(30.515,27.175),(30.685,27.175),(30.685,27.005),(30.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.925),(30.515,6.095),(30.685,6.095),(30.685,5.925),(30.515,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.845),(55.025,36.015),(55.195,36.015),(55.195,35.845),(55.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.265),(59.315,6.435),(59.485,6.435),(59.485,6.265),(59.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.605),(59.315,6.775),(59.485,6.775),(59.485,6.605),(59.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.945),(45.425,24.115),(45.595,24.115),(45.595,23.945),(45.425,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.605),(44.405,23.775),(44.575,23.775),(44.575,23.605),(44.405,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.265),(44.405,23.435),(44.575,23.435),(44.575,23.265),(44.405,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.425),(40.625,14.595),(40.795,14.595),(40.795,14.425),(40.625,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.765),(40.625,14.935),(40.795,14.935),(40.795,14.765),(40.625,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.765),(40.115,14.935),(40.285,14.935),(40.285,14.765),(40.115,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.245),(45.425,5.415),(45.595,5.415),(45.595,5.245),(45.425,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.585),(45.425,5.755),(45.595,5.755),(45.595,5.585),(45.425,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.085),(40.115,14.255),(40.285,14.255),(40.285,14.085),(40.115,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,14.085),(40.625,14.255),(40.795,14.255),(40.795,14.085),(40.625,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.165),(55.025,18.335),(55.195,18.335),(55.195,18.165),(55.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.505),(55.025,18.675),(55.195,18.675),(55.195,18.505),(55.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,14.425),(40.115,14.595),(40.285,14.595),(40.285,14.425),(40.115,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.965),(30.515,8.135),(30.685,8.135),(30.685,7.965),(30.515,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,26.665),(50.225,26.835),(50.395,26.835),(50.395,26.665),(50.225,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,26.325),(50.225,26.495),(50.395,26.495),(50.395,26.325),(50.225,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.545),(44.915,3.715),(45.085,3.715),(45.085,3.545),(44.915,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.205),(44.915,3.375),(45.085,3.375),(45.085,3.205),(44.915,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.705),(30.515,28.875),(30.685,28.875),(30.685,28.705),(30.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.025),(30.515,28.195),(30.685,28.195),(30.685,28.025),(30.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,28.365),(30.515,28.535),(30.685,28.535),(30.685,28.365),(30.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.125),(39.605,16.295),(39.775,16.295),(39.775,16.125),(39.605,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.465),(39.605,16.635),(39.775,16.635),(39.775,16.465),(39.605,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,16.805),(39.605,16.975),(39.775,16.975),(39.775,16.805),(39.605,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.585),(55.025,22.755),(55.195,22.755),(55.195,22.585),(55.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.245),(55.025,22.415),(55.195,22.415),(55.195,22.245),(55.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.205),(49.205,3.375),(49.375,3.375),(49.375,3.205),(49.205,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.205),(49.715,3.375),(49.885,3.375),(49.885,3.205),(49.715,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.545),(49.715,3.715),(49.885,3.715),(49.885,3.545),(49.715,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.545),(49.205,3.715),(49.375,3.715),(49.375,3.545),(49.205,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.545),(55.025,3.715),(55.195,3.715),(55.195,3.545),(55.025,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.205),(55.025,3.375),(55.195,3.375),(55.195,3.205),(55.025,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.865),(40.625,20.035),(40.795,20.035),(40.795,19.865),(40.625,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.865),(40.115,20.035),(40.285,20.035),(40.285,19.865),(40.115,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.665),(45.425,9.835),(45.595,9.835),(45.595,9.665),(45.425,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,9.325),(45.425,9.495),(45.595,9.495),(45.595,9.325),(45.425,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.545),(39.605,20.715),(39.775,20.715),(39.775,20.545),(39.605,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.205),(39.605,20.375),(39.775,20.375),(39.775,20.205),(39.605,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.885),(35.825,4.055),(35.995,4.055),(35.995,3.885),(35.825,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.885),(35.315,4.055),(35.485,4.055),(35.485,3.885),(35.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.825),(49.715,17.995),(49.885,17.995),(49.885,17.825),(49.715,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.145),(49.205,17.315),(49.375,17.315),(49.375,17.145),(49.205,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.005),(35.315,27.175),(35.485,27.175),(35.485,27.005),(35.315,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.345),(35.315,27.515),(35.485,27.515),(35.485,27.345),(35.315,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.485),(49.205,17.655),(49.375,17.655),(49.375,17.485),(49.205,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.145),(49.715,17.315),(49.885,17.315),(49.885,17.145),(49.715,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,17.825),(49.205,17.995),(49.375,17.995),(49.375,17.825),(49.205,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.345),(35.825,27.515),(35.995,27.515),(35.995,27.345),(35.825,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.685),(35.825,27.855),(35.995,27.855),(35.995,27.685),(35.825,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,27.685),(35.315,27.855),(35.485,27.855),(35.485,27.685),(35.315,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.265),(30.515,23.435),(30.685,23.435),(30.685,23.265),(30.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.605),(30.515,23.775),(30.685,23.775),(30.685,23.605),(30.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,3.885),(30.515,4.055),(30.685,4.055),(30.685,3.885),(30.515,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.885),(55.025,38.055),(55.195,38.055),(55.195,37.885),(55.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.945),(44.915,7.115),(45.085,7.115),(45.085,6.945),(44.915,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.305),(50.225,25.475),(50.395,25.475),(50.395,25.305),(50.225,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,25.645),(50.225,25.815),(50.395,25.815),(50.395,25.645),(50.225,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.745),(35.825,30.915),(35.995,30.915),(35.995,30.745),(35.825,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.065),(35.315,30.235),(35.485,30.235),(35.485,30.065),(35.315,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.405),(35.315,30.575),(35.485,30.575),(35.485,30.405),(35.315,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.065),(35.825,30.235),(35.995,30.235),(35.995,30.065),(35.825,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,30.405),(35.825,30.575),(35.995,30.575),(35.995,30.405),(35.825,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,30.745),(35.315,30.915),(35.485,30.915),(35.485,30.745),(35.315,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.765),(44.405,31.935),(44.575,31.935),(44.575,31.765),(44.405,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.865),(31.025,37.035),(31.195,37.035),(31.195,36.865),(31.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.425),(44.405,31.595),(44.575,31.595),(44.575,31.425),(44.405,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,31.085),(44.405,31.255),(44.575,31.255),(44.575,31.085),(44.405,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.945),(55.025,7.115),(55.195,7.115),(55.195,6.945),(55.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.605),(49.715,6.775),(49.885,6.775),(49.885,6.605),(49.715,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.265),(49.205,6.435),(49.375,6.435),(49.375,6.265),(49.205,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.265),(49.715,6.435),(49.885,6.435),(49.885,6.265),(49.715,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.605),(49.205,6.775),(49.375,6.775),(49.375,6.605),(49.205,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.225),(44.915,4.395),(45.085,4.395),(45.085,4.225),(44.915,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.565),(44.915,4.735),(45.085,4.735),(45.085,4.565),(44.915,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.205),(49.715,20.375),(49.885,20.375),(49.885,20.205),(49.715,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.205),(49.205,20.375),(49.375,20.375),(49.375,20.205),(49.205,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.545),(49.715,20.715),(49.885,20.715),(49.885,20.545),(49.715,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.545),(49.205,20.715),(49.375,20.715),(49.375,20.545),(49.205,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.945),(59.315,24.115),(59.485,24.115),(59.485,23.945),(59.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.165),(44.915,18.335),(45.085,18.335),(45.085,18.165),(44.915,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.505),(44.915,18.675),(45.085,18.675),(45.085,18.505),(44.915,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.285),(55.025,24.455),(55.195,24.455),(55.195,24.285),(55.025,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.625),(55.025,24.795),(55.195,24.795),(55.195,24.625),(55.025,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.205),(45.425,3.375),(45.595,3.375),(45.595,3.205),(45.425,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.885),(31.025,38.055),(31.195,38.055),(31.195,37.885),(31.025,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.545),(45.425,3.715),(45.595,3.715),(45.595,3.545),(45.425,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.865),(55.025,37.035),(55.195,37.035),(55.195,36.865),(55.025,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.985),(55.025,26.155),(55.195,26.155),(55.195,25.985),(55.025,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,27.005),(35.825,27.175),(35.995,27.175),(35.995,27.005),(35.825,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.925),(49.715,23.095),(49.885,23.095),(49.885,22.925),(49.715,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.925),(49.205,23.095),(49.375,23.095),(49.375,22.925),(49.205,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.565),(45.425,4.735),(45.595,4.735),(45.595,4.565),(45.425,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.225),(45.425,4.395),(45.595,4.395),(45.595,4.225),(45.425,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.945),(31.025,7.115),(31.195,7.115),(31.195,6.945),(31.025,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.205),(39.605,37.375),(39.775,37.375),(39.775,37.205),(39.605,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.545),(39.605,37.715),(39.775,37.715),(39.775,37.545),(39.605,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.145),(35.315,17.315),(35.485,17.315),(35.485,17.145),(35.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.485),(35.315,17.655),(35.485,17.655),(35.485,17.485),(35.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.145),(35.825,17.315),(35.995,17.315),(35.995,17.145),(35.825,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.485),(35.825,17.655),(35.995,17.655),(35.995,17.485),(35.825,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,17.825),(35.315,17.995),(35.485,17.995),(35.485,17.825),(35.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,17.825),(35.825,17.995),(35.995,17.995),(35.995,17.825),(35.825,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.925),(58.805,6.095),(58.975,6.095),(58.975,5.925),(58.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.165),(59.315,18.335),(59.485,18.335),(59.485,18.165),(59.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.505),(59.315,18.675),(59.485,18.675),(59.485,18.505),(59.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.925),(34.805,6.095),(34.975,6.095),(34.975,5.925),(34.805,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.945),(45.425,7.115),(45.595,7.115),(45.595,6.945),(45.425,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.985),(55.025,9.155),(55.195,9.155),(55.195,8.985),(55.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.685),(54.005,10.855),(54.175,10.855),(54.175,10.685),(54.005,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.685),(54.515,10.855),(54.685,10.855),(54.685,10.685),(54.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.005),(54.005,10.175),(54.175,10.175),(54.175,10.005),(54.005,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,10.345),(54.005,10.515),(54.175,10.515),(54.175,10.345),(54.005,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.005),(54.515,10.175),(54.685,10.175),(54.685,10.005),(54.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,10.345),(54.515,10.515),(54.685,10.515),(54.685,10.345),(54.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.245),(59.315,5.415),(59.485,5.415),(59.485,5.245),(59.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.925),(34.805,23.095),(34.975,23.095),(34.975,22.925),(34.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.585),(59.315,5.755),(59.485,5.755),(59.485,5.585),(59.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,40.265),(35.825,40.435),(35.995,40.435),(35.995,40.265),(35.825,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,40.605),(35.825,40.775),(35.995,40.775),(35.995,40.605),(35.825,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,40.265),(35.315,40.435),(35.485,40.435),(35.485,40.265),(35.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,40.605),(35.315,40.775),(35.485,40.775),(35.485,40.605),(35.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.585),(44.915,22.755),(45.085,22.755),(45.085,22.585),(44.915,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.245),(44.915,22.415),(45.085,22.415),(45.085,22.245),(44.915,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.345),(35.315,10.515),(35.485,10.515),(35.485,10.345),(35.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.345),(35.825,10.515),(35.995,10.515),(35.995,10.345),(35.825,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.685),(35.315,10.855),(35.485,10.855),(35.485,10.685),(35.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.685),(35.825,10.855),(35.995,10.855),(35.995,10.685),(35.825,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.665),(55.025,9.835),(55.195,9.835),(55.195,9.665),(55.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.965),(58.805,8.135),(58.975,8.135),(58.975,7.965),(58.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,10.005),(35.315,10.175),(35.485,10.175),(35.485,10.005),(35.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,10.005),(35.825,10.175),(35.995,10.175),(35.995,10.005),(35.825,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,9.325),(55.025,9.495),(55.195,9.495),(55.195,9.325),(55.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.605),(58.805,6.775),(58.975,6.775),(58.975,6.605),(58.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.565),(58.805,38.735),(58.975,38.735),(58.975,38.565),(58.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.765),(50.225,14.935),(50.395,14.935),(50.395,14.765),(50.225,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.085),(50.225,14.255),(50.395,14.255),(50.395,14.085),(50.225,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,14.425),(50.225,14.595),(50.395,14.595),(50.395,14.425),(50.225,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.225),(58.805,38.395),(58.975,38.395),(58.975,38.225),(58.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.965),(34.805,8.135),(34.975,8.135),(34.975,7.965),(34.805,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.645),(45.425,8.815),(45.595,8.815),(45.595,8.645),(45.425,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.305),(45.425,8.475),(45.595,8.475),(45.595,8.305),(45.425,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.925),(40.625,23.095),(40.795,23.095),(40.795,22.925),(40.625,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.145),(54.005,17.315),(54.175,17.315),(54.175,17.145),(54.005,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.825),(54.515,17.995),(54.685,17.995),(54.685,17.825),(54.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.925),(40.115,23.095),(40.285,23.095),(40.285,22.925),(40.115,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.145),(54.515,17.315),(54.685,17.315),(54.685,17.145),(54.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.225),(34.805,38.395),(34.975,38.395),(34.975,38.225),(34.805,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.565),(34.805,38.735),(34.975,38.735),(34.975,38.565),(34.805,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,17.485),(54.515,17.655),(54.685,17.655),(54.685,17.485),(54.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,17.485),(54.005,17.655),(54.175,17.655),(54.175,17.485),(54.005,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.985),(34.805,9.155),(34.975,9.155),(34.975,8.985),(34.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.865),(39.605,37.035),(39.775,37.035),(39.775,36.865),(39.605,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.085),(31.025,14.255),(31.195,14.255),(31.195,14.085),(31.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.425),(31.025,14.595),(31.195,14.595),(31.195,14.425),(31.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,14.765),(31.025,14.935),(31.195,14.935),(31.195,14.765),(31.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.585),(49.715,39.755),(49.885,39.755),(49.885,39.585),(49.715,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.105),(31.025,32.275),(31.195,32.275),(31.195,32.105),(31.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.445),(31.025,32.615),(31.195,32.615),(31.195,32.445),(31.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,32.785),(31.025,32.955),(31.195,32.955),(31.195,32.785),(31.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.205),(50.225,20.375),(50.395,20.375),(50.395,20.205),(50.225,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.545),(50.225,20.715),(50.395,20.715),(50.395,20.545),(50.225,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.745),(55.025,13.915),(55.195,13.915),(55.195,13.745),(55.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.065),(55.025,13.235),(55.195,13.235),(55.195,13.065),(55.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,13.405),(55.025,13.575),(55.195,13.575),(55.195,13.405),(55.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.245),(44.915,5.415),(45.085,5.415),(45.085,5.245),(44.915,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.585),(44.915,5.755),(45.085,5.755),(45.085,5.585),(44.915,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.865),(54.515,37.035),(54.685,37.035),(54.685,36.865),(54.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.725),(44.405,29.895),(44.575,29.895),(44.575,29.725),(44.405,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.045),(44.405,29.215),(44.575,29.215),(44.575,29.045),(44.405,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,29.385),(44.405,29.555),(44.575,29.555),(44.575,29.385),(44.405,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.865),(54.005,37.035),(54.175,37.035),(54.175,36.865),(54.005,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.065),(44.915,30.235),(45.085,30.235),(45.085,30.065),(44.915,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.405),(44.915,30.575),(45.085,30.575),(45.085,30.405),(44.915,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,30.745),(44.915,30.915),(45.085,30.915),(45.085,30.745),(44.915,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.885),(45.425,21.055),(45.595,21.055),(45.595,20.885),(45.425,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.165),(50.225,35.335),(50.395,35.335),(50.395,35.165),(50.225,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.505),(50.225,35.675),(50.395,35.675),(50.395,35.505),(50.225,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.865),(49.715,37.035),(49.885,37.035),(49.885,36.865),(49.715,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.865),(49.205,37.035),(49.375,37.035),(49.375,36.865),(49.205,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.645),(49.715,25.815),(49.885,25.815),(49.885,25.645),(49.715,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.885),(59.315,21.055),(59.485,21.055),(59.485,20.885),(59.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,39.925),(39.605,40.095),(39.775,40.095),(39.775,39.925),(39.605,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.225),(40.115,4.395),(40.285,4.395),(40.285,4.225),(40.115,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.565),(40.115,4.735),(40.285,4.735),(40.285,4.565),(40.115,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.565),(40.625,4.735),(40.795,4.735),(40.795,4.565),(40.625,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.225),(40.625,4.395),(40.795,4.395),(40.795,4.225),(40.625,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.845),(31.025,19.015),(31.195,19.015),(31.195,18.845),(31.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.105),(59.315,32.275),(59.485,32.275),(59.485,32.105),(59.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.445),(59.315,32.615),(59.485,32.615),(59.485,32.445),(59.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,32.785),(59.315,32.955),(59.485,32.955),(59.485,32.785),(59.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.305),(39.605,25.475),(39.775,25.475),(39.775,25.305),(39.605,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.645),(39.605,25.815),(39.775,25.815),(39.775,25.645),(39.605,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.125),(45.425,33.295),(45.595,33.295),(45.595,33.125),(45.425,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.465),(45.425,33.635),(45.595,33.635),(45.595,33.465),(45.425,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,33.805),(45.425,33.975),(45.595,33.975),(45.595,33.805),(45.425,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.725),(58.805,29.895),(58.975,29.895),(58.975,29.725),(58.805,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.045),(58.805,29.215),(58.975,29.215),(58.975,29.045),(58.805,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,29.385),(58.805,29.555),(58.975,29.555),(58.975,29.385),(58.805,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,2.865),(40.115,3.035),(40.285,3.035),(40.285,2.865),(40.115,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,2.865),(40.625,3.035),(40.795,3.035),(40.795,2.865),(40.625,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.965),(45.425,25.135),(45.595,25.135),(45.595,24.965),(45.425,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.605),(44.915,23.775),(45.085,23.775),(45.085,23.605),(44.915,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.265),(44.915,23.435),(45.085,23.435),(45.085,23.265),(44.915,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.805),(45.425,16.975),(45.595,16.975),(45.595,16.805),(45.425,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,26.325),(31.025,26.495),(31.195,26.495),(31.195,26.325),(31.025,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.585),(30.515,39.755),(30.685,39.755),(30.685,39.585),(30.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.465),(45.425,16.635),(45.595,16.635),(45.595,16.465),(45.425,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,16.125),(45.425,16.295),(45.595,16.295),(45.595,16.125),(45.425,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.245),(30.515,39.415),(30.685,39.415),(30.685,39.245),(30.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,26.665),(31.025,26.835),(31.195,26.835),(31.195,26.665),(31.025,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.585),(54.515,5.755),(54.685,5.755),(54.685,5.585),(54.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.585),(54.005,5.755),(54.175,5.755),(54.175,5.585),(54.005,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.545),(35.315,37.715),(35.485,37.715),(35.485,37.545),(35.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.545),(35.825,37.715),(35.995,37.715),(35.995,37.545),(35.825,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.205),(35.825,37.375),(35.995,37.375),(35.995,37.205),(35.825,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.205),(35.315,37.375),(35.485,37.375),(35.485,37.205),(35.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,5.245),(54.515,5.415),(54.685,5.415),(54.685,5.245),(54.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.905),(40.115,39.075),(40.285,39.075),(40.285,38.905),(40.115,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.905),(40.625,39.075),(40.795,39.075),(40.795,38.905),(40.625,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,5.245),(54.005,5.415),(54.175,5.415),(54.175,5.245),(54.005,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.165),(44.405,35.335),(44.575,35.335),(44.575,35.165),(44.405,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.505),(44.405,35.675),(44.575,35.675),(44.575,35.505),(44.405,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,40.265),(49.715,40.435),(49.885,40.435),(49.885,40.265),(49.715,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,40.605),(49.715,40.775),(49.885,40.775),(49.885,40.605),(49.715,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,40.605),(49.205,40.775),(49.375,40.775),(49.375,40.605),(49.205,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,40.265),(49.205,40.435),(49.375,40.435),(49.375,40.265),(49.205,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.245),(44.405,39.415),(44.575,39.415),(44.575,39.245),(44.405,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.585),(44.405,39.755),(44.575,39.755),(44.575,39.585),(44.405,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.845),(49.205,36.015),(49.375,36.015),(49.375,35.845),(49.205,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.845),(49.715,36.015),(49.885,36.015),(49.885,35.845),(49.715,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.685),(45.425,10.855),(45.595,10.855),(45.595,10.685),(45.425,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.725),(55.025,12.895),(55.195,12.895),(55.195,12.725),(55.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.005),(45.425,10.175),(45.595,10.175),(45.595,10.005),(45.425,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,10.345),(45.425,10.515),(45.595,10.515),(45.595,10.345),(45.425,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.385),(55.025,12.555),(55.195,12.555),(55.195,12.385),(55.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,12.045),(55.025,12.215),(55.195,12.215),(55.195,12.045),(55.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.685),(44.915,27.855),(45.085,27.855),(45.085,27.685),(44.915,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.005),(44.915,27.175),(45.085,27.175),(45.085,27.005),(44.915,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,27.345),(44.915,27.515),(45.085,27.515),(45.085,27.345),(44.915,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.325),(30.515,9.495),(30.685,9.495),(30.685,9.325),(30.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,9.665),(30.515,9.835),(30.685,9.835),(30.685,9.665),(30.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.865),(35.825,37.035),(35.995,37.035),(35.995,36.865),(35.825,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.865),(35.315,37.035),(35.485,37.035),(35.485,36.865),(35.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.945),(44.405,7.115),(44.575,7.115),(44.575,6.945),(44.405,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,7.965),(49.205,8.135),(49.375,8.135),(49.375,7.965),(49.205,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,7.965),(49.715,8.135),(49.885,8.135),(49.885,7.965),(49.715,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.245),(59.315,39.415),(59.485,39.415),(59.485,39.245),(59.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,39.585),(59.315,39.755),(59.485,39.755),(59.485,39.585),(59.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.105),(44.915,32.275),(45.085,32.275),(45.085,32.105),(44.915,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.445),(44.915,32.615),(45.085,32.615),(45.085,32.445),(44.915,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,32.785),(44.915,32.955),(45.085,32.955),(45.085,32.785),(44.915,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.765),(44.915,31.935),(45.085,31.935),(45.085,31.765),(44.915,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.085),(44.915,31.255),(45.085,31.255),(45.085,31.085),(44.915,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,31.425),(44.915,31.595),(45.085,31.595),(45.085,31.425),(44.915,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.245),(54.515,39.415),(54.685,39.415),(54.685,39.245),(54.515,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.585),(54.515,39.755),(54.685,39.755),(54.685,39.585),(54.515,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.245),(54.005,39.415),(54.175,39.415),(54.175,39.245),(54.005,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.585),(54.005,39.755),(54.175,39.755),(54.175,39.585),(54.005,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.985),(40.115,9.155),(40.285,9.155),(40.285,8.985),(40.115,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.985),(40.625,9.155),(40.795,9.155),(40.795,8.985),(40.625,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.645),(50.225,8.815),(50.395,8.815),(50.395,8.645),(50.225,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.305),(50.225,8.475),(50.395,8.475),(50.395,8.305),(50.225,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.965),(54.515,25.135),(54.685,25.135),(54.685,24.965),(54.515,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.245),(58.805,22.415),(58.975,22.415),(58.975,22.245),(58.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.585),(58.805,22.755),(58.975,22.755),(58.975,22.585),(58.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.965),(54.005,25.135),(54.175,25.135),(54.175,24.965),(54.005,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,35.845),(50.225,36.015),(50.395,36.015),(50.395,35.845),(50.225,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.525),(30.515,36.695),(30.685,36.695),(30.685,36.525),(30.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.185),(30.515,36.355),(30.685,36.355),(30.685,36.185),(30.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.245),(30.515,5.415),(30.685,5.415),(30.685,5.245),(30.515,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,5.585),(30.515,5.755),(30.685,5.755),(30.685,5.585),(30.515,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.265),(45.425,23.435),(45.595,23.435),(45.595,23.265),(45.425,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,23.605),(45.425,23.775),(45.595,23.775),(45.595,23.605),(45.425,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.585),(54.515,22.755),(54.685,22.755),(54.685,22.585),(54.515,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.245),(54.005,22.415),(54.175,22.415),(54.175,22.245),(54.005,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.245),(54.515,22.415),(54.685,22.415),(54.685,22.245),(54.515,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.305),(59.315,25.475),(59.485,25.475),(59.485,25.305),(59.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.645),(59.315,25.815),(59.485,25.815),(59.485,25.645),(59.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.585),(54.005,22.755),(54.175,22.755),(54.175,22.585),(54.005,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.025),(44.915,28.195),(45.085,28.195),(45.085,28.025),(44.915,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.785),(54.005,32.955),(54.175,32.955),(54.175,32.785),(54.005,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.985),(45.425,26.155),(45.595,26.155),(45.595,25.985),(45.425,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.105),(54.005,32.275),(54.175,32.275),(54.175,32.105),(54.005,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,40.265),(59.315,40.435),(59.485,40.435),(59.485,40.265),(59.315,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,40.605),(59.315,40.775),(59.485,40.775),(59.485,40.605),(59.315,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.365),(44.915,28.535),(45.085,28.535),(45.085,28.365),(44.915,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,32.445),(54.005,32.615),(54.175,32.615),(54.175,32.445),(54.005,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.105),(54.515,32.275),(54.685,32.275),(54.685,32.105),(54.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.445),(54.515,32.615),(54.685,32.615),(54.685,32.445),(54.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,32.785),(54.515,32.955),(54.685,32.955),(54.685,32.785),(54.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.685),(59.315,10.855),(59.485,10.855),(59.485,10.685),(59.315,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.005),(59.315,10.175),(59.485,10.175),(59.485,10.005),(59.315,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,10.345),(59.315,10.515),(59.485,10.515),(59.485,10.345),(59.315,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,2.865),(30.515,3.035),(30.685,3.035),(30.685,2.865),(30.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.765),(30.515,14.935),(30.685,14.935),(30.685,14.765),(30.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.085),(30.515,14.255),(30.685,14.255),(30.685,14.085),(30.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.125),(49.205,16.295),(49.375,16.295),(49.375,16.125),(49.205,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.465),(49.205,16.635),(49.375,16.635),(49.375,16.465),(49.205,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.125),(49.715,16.295),(49.885,16.295),(49.885,16.125),(49.715,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,14.425),(30.515,14.595),(30.685,14.595),(30.685,14.425),(30.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.845),(39.605,19.015),(39.775,19.015),(39.775,18.845),(39.605,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.465),(49.715,16.635),(49.885,16.635),(49.885,16.465),(49.715,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,16.805),(49.715,16.975),(49.885,16.975),(49.885,16.805),(49.715,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,16.805),(49.205,16.975),(49.375,16.975),(49.375,16.805),(49.205,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.165),(54.515,18.335),(54.685,18.335),(54.685,18.165),(54.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.505),(54.515,18.675),(54.685,18.675),(54.685,18.505),(54.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.505),(54.005,18.675),(54.175,18.675),(54.175,18.505),(54.005,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.165),(54.005,18.335),(54.175,18.335),(54.175,18.165),(54.005,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.445),(34.805,32.615),(34.975,32.615),(34.975,32.445),(34.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.785),(34.805,32.955),(34.975,32.955),(34.975,32.785),(34.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,32.105),(34.805,32.275),(34.975,32.275),(34.975,32.105),(34.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.945),(50.225,24.115),(50.395,24.115),(50.395,23.945),(50.225,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.965),(50.225,25.135),(50.395,25.135),(50.395,24.965),(50.225,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.925),(39.605,23.095),(39.775,23.095),(39.775,22.925),(39.605,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.885),(49.715,38.055),(49.885,38.055),(49.885,37.885),(49.715,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.885),(49.205,38.055),(49.375,38.055),(49.375,37.885),(49.205,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.845),(49.205,19.015),(49.375,19.015),(49.375,18.845),(49.205,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.845),(49.715,19.015),(49.885,19.015),(49.885,18.845),(49.715,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.245),(55.025,39.415),(55.195,39.415),(55.195,39.245),(55.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.585),(55.025,39.755),(55.195,39.755),(55.195,39.585),(55.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.085),(58.805,14.255),(58.975,14.255),(58.975,14.085),(58.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.885),(44.915,21.055),(45.085,21.055),(45.085,20.885),(44.915,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.765),(58.805,14.935),(58.975,14.935),(58.975,14.765),(58.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,14.425),(58.805,14.595),(58.975,14.595),(58.975,14.425),(58.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.225),(55.025,21.395),(55.195,21.395),(55.195,21.225),(55.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.565),(55.025,21.735),(55.195,21.735),(55.195,21.565),(55.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.505),(50.225,18.675),(50.395,18.675),(50.395,18.505),(50.225,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.165),(50.225,18.335),(50.395,18.335),(50.395,18.165),(50.225,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.245),(49.715,39.415),(49.885,39.415),(49.885,39.245),(49.715,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.345),(45.425,27.515),(45.595,27.515),(45.595,27.345),(45.425,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.685),(45.425,27.855),(45.595,27.855),(45.595,27.685),(45.425,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.585),(49.205,39.755),(49.375,39.755),(49.375,39.585),(49.205,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,2.865),(54.515,3.035),(54.685,3.035),(54.685,2.865),(54.515,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.245),(49.205,39.415),(49.375,39.415),(49.375,39.245),(49.205,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.785),(54.005,15.955),(54.175,15.955),(54.175,15.785),(54.005,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.785),(54.515,15.955),(54.685,15.955),(54.685,15.785),(54.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.105),(54.005,15.275),(54.175,15.275),(54.175,15.105),(54.005,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,15.445),(54.005,15.615),(54.175,15.615),(54.175,15.445),(54.005,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.105),(54.515,15.275),(54.685,15.275),(54.685,15.105),(54.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,15.445),(54.515,15.615),(54.685,15.615),(54.685,15.445),(54.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.105),(30.515,32.275),(30.685,32.275),(30.685,32.105),(30.515,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.445),(30.515,32.615),(30.685,32.615),(30.685,32.445),(30.515,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,32.785),(30.515,32.955),(30.685,32.955),(30.685,32.785),(30.515,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.945),(50.225,7.115),(50.395,7.115),(50.395,6.945),(50.225,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.825),(50.225,17.995),(50.395,17.995),(50.395,17.825),(50.225,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.145),(50.225,17.315),(50.395,17.315),(50.395,17.145),(50.225,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,17.485),(50.225,17.655),(50.395,17.655),(50.395,17.485),(50.225,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.025),(54.005,11.195),(54.175,11.195),(54.175,11.025),(54.005,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.365),(54.005,11.535),(54.175,11.535),(54.175,11.365),(54.005,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.025),(54.515,11.195),(54.685,11.195),(54.685,11.025),(54.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.365),(54.515,11.535),(54.685,11.535),(54.685,11.365),(54.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,11.705),(54.005,11.875),(54.175,11.875),(54.175,11.705),(54.005,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,11.705),(54.515,11.875),(54.685,11.875),(54.685,11.705),(54.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,40.265),(44.915,40.435),(45.085,40.435),(45.085,40.265),(44.915,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,40.605),(44.915,40.775),(45.085,40.775),(45.085,40.605),(44.915,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.885),(45.425,38.055),(45.595,38.055),(45.595,37.885),(45.425,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.165),(45.425,18.335),(45.595,18.335),(45.595,18.165),(45.425,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.505),(45.425,18.675),(45.595,18.675),(45.595,18.505),(45.425,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.305),(44.915,25.475),(45.085,25.475),(45.085,25.305),(44.915,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.645),(44.915,25.815),(45.085,25.815),(45.085,25.645),(44.915,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.265),(59.315,23.435),(59.485,23.435),(59.485,23.265),(59.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,23.605),(59.315,23.775),(59.485,23.775),(59.485,23.605),(59.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.245),(31.025,39.415),(31.195,39.415),(31.195,39.245),(31.025,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.585),(31.025,39.755),(31.195,39.755),(31.195,39.585),(31.025,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.965),(44.915,25.135),(45.085,25.135),(45.085,24.965),(44.915,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,24.965),(39.605,25.135),(39.775,25.135),(39.775,24.965),(39.605,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.585),(45.425,22.755),(45.595,22.755),(45.595,22.585),(45.425,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.245),(45.425,22.415),(45.595,22.415),(45.595,22.245),(45.425,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.325),(49.715,9.495),(49.885,9.495),(49.885,9.325),(49.715,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,22.925),(30.515,23.095),(30.685,23.095),(30.685,22.925),(30.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.325),(49.205,9.495),(49.375,9.495),(49.375,9.325),(49.205,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,9.665),(49.715,9.835),(49.885,9.835),(49.885,9.665),(49.715,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,9.665),(49.205,9.835),(49.375,9.835),(49.375,9.665),(49.205,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.045),(44.915,29.215),(45.085,29.215),(45.085,29.045),(44.915,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.385),(44.915,29.555),(45.085,29.555),(45.085,29.385),(44.915,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,29.725),(44.915,29.895),(45.085,29.895),(45.085,29.725),(44.915,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.865),(55.025,20.035),(55.195,20.035),(55.195,19.865),(55.025,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,18.845),(44.405,19.015),(44.575,19.015),(44.575,18.845),(44.405,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.805),(58.805,16.975),(58.975,16.975),(58.975,16.805),(58.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.125),(58.805,16.295),(58.975,16.295),(58.975,16.125),(58.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.225),(59.315,4.395),(59.485,4.395),(59.485,4.225),(59.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.565),(59.315,4.735),(59.485,4.735),(59.485,4.565),(59.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,16.465),(58.805,16.635),(58.975,16.635),(58.975,16.465),(58.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.245),(58.805,5.415),(58.975,5.415),(58.975,5.245),(58.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,5.585),(58.805,5.755),(58.975,5.755),(58.975,5.585),(58.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,23.945),(55.025,24.115),(55.195,24.115),(55.195,23.945),(55.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,36.865),(58.805,37.035),(58.975,37.035),(58.975,36.865),(58.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.125),(55.025,16.295),(55.195,16.295),(55.195,16.125),(55.025,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.465),(55.025,16.635),(55.195,16.635),(55.195,16.465),(55.025,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.245),(34.805,5.415),(34.975,5.415),(34.975,5.245),(34.805,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,5.585),(34.805,5.755),(34.975,5.755),(34.975,5.585),(34.805,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,16.805),(55.025,16.975),(55.195,16.975),(55.195,16.805),(55.025,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,8.985),(44.405,9.155),(44.575,9.155),(44.575,8.985),(44.405,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.245),(50.225,39.415),(50.395,39.415),(50.395,39.245),(50.225,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,39.585),(50.225,39.755),(50.395,39.755),(50.395,39.585),(50.225,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.645),(35.825,25.815),(35.995,25.815),(35.995,25.645),(35.825,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,36.865),(34.805,37.035),(34.975,37.035),(34.975,36.865),(34.805,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,25.305),(35.825,25.475),(35.995,25.475),(35.995,25.305),(35.825,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,36.865),(45.425,37.035),(45.595,37.035),(45.595,36.865),(45.425,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.305),(35.315,25.475),(35.485,25.475),(35.485,25.305),(35.315,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,25.645),(35.315,25.815),(35.485,25.815),(35.485,25.645),(35.315,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.885),(39.605,4.055),(39.775,4.055),(39.775,3.885),(39.605,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.425),(40.115,31.595),(40.285,31.595),(40.285,31.425),(40.115,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.765),(40.625,31.935),(40.795,31.935),(40.795,31.765),(40.625,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.205),(55.025,20.375),(55.195,20.375),(55.195,20.205),(55.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.545),(55.025,20.715),(55.195,20.715),(55.195,20.545),(55.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.765),(40.115,31.935),(40.285,31.935),(40.285,31.765),(40.115,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.085),(40.625,31.255),(40.795,31.255),(40.795,31.085),(40.625,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,31.425),(40.625,31.595),(40.795,31.595),(40.795,31.425),(40.625,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,31.085),(40.115,31.255),(40.285,31.255),(40.285,31.085),(40.115,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.085),(44.405,14.255),(44.575,14.255),(44.575,14.085),(44.405,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.425),(44.405,14.595),(44.575,14.595),(44.575,14.425),(44.405,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,14.765),(44.405,14.935),(44.575,14.935),(44.575,14.765),(44.405,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.005),(50.225,27.175),(50.395,27.175),(50.395,27.005),(50.225,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.345),(50.225,27.515),(50.395,27.515),(50.395,27.345),(50.225,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,27.685),(50.225,27.855),(50.395,27.855),(50.395,27.685),(50.225,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,22.925),(35.315,23.095),(35.485,23.095),(35.485,22.925),(35.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,22.925),(35.825,23.095),(35.995,23.095),(35.995,22.925),(35.825,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,8.985),(35.825,9.155),(35.995,9.155),(35.995,8.985),(35.825,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,8.985),(35.315,9.155),(35.485,9.155),(35.485,8.985),(35.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.245),(49.205,5.415),(49.375,5.415),(49.375,5.245),(49.205,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,5.585),(49.205,5.755),(49.375,5.755),(49.375,5.585),(49.205,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.245),(49.715,5.415),(49.885,5.415),(49.885,5.245),(49.715,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,5.585),(49.715,5.755),(49.885,5.755),(49.885,5.585),(49.715,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.105),(39.605,15.275),(39.775,15.275),(39.775,15.105),(39.605,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.445),(39.605,15.615),(39.775,15.615),(39.775,15.445),(39.605,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,15.785),(39.605,15.955),(39.775,15.955),(39.775,15.785),(39.605,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.165),(39.605,35.335),(39.775,35.335),(39.775,35.165),(39.605,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.505),(39.605,35.675),(39.775,35.675),(39.775,35.505),(39.605,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.245),(44.915,39.415),(45.085,39.415),(45.085,39.245),(44.915,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.585),(44.915,39.755),(45.085,39.755),(45.085,39.585),(44.915,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,4.905),(55.025,5.075),(55.195,5.075),(55.195,4.905),(55.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.645),(31.025,25.815),(31.195,25.815),(31.195,25.645),(31.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,25.305),(31.025,25.475),(31.195,25.475),(31.195,25.305),(31.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.925),(39.605,6.095),(39.775,6.095),(39.775,5.925),(39.605,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.645),(58.805,8.815),(58.975,8.815),(58.975,8.645),(58.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.305),(58.805,8.475),(58.975,8.475),(58.975,8.305),(58.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.725),(34.805,12.895),(34.975,12.895),(34.975,12.725),(34.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.045),(34.805,12.215),(34.975,12.215),(34.975,12.045),(34.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,12.385),(34.805,12.555),(34.975,12.555),(34.975,12.385),(34.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.265),(40.625,23.435),(40.795,23.435),(40.795,23.265),(40.625,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.605),(40.625,23.775),(40.795,23.775),(40.795,23.605),(40.625,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.265),(40.115,23.435),(40.285,23.435),(40.285,23.265),(40.115,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.605),(40.115,23.775),(40.285,23.775),(40.285,23.605),(40.115,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.725),(54.005,12.895),(54.175,12.895),(54.175,12.725),(54.005,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.725),(54.515,12.895),(54.685,12.895),(54.685,12.725),(54.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.385),(54.515,12.555),(54.685,12.555),(54.685,12.385),(54.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.045),(54.005,12.215),(54.175,12.215),(54.175,12.045),(54.005,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,12.385),(54.005,12.555),(54.175,12.555),(54.175,12.385),(54.005,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,12.045),(54.515,12.215),(54.685,12.215),(54.685,12.045),(54.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.885),(58.805,38.055),(58.975,38.055),(58.975,37.885),(58.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.885),(34.805,38.055),(34.975,38.055),(34.975,37.885),(34.805,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.025),(40.625,11.195),(40.795,11.195),(40.795,11.025),(40.625,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.365),(40.625,11.535),(40.795,11.535),(40.795,11.365),(40.625,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,11.705),(40.625,11.875),(40.795,11.875),(40.795,11.705),(40.625,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.705),(40.115,11.875),(40.285,11.875),(40.285,11.705),(40.115,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.365),(40.115,11.535),(40.285,11.535),(40.285,11.365),(40.115,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,11.025),(40.115,11.195),(40.285,11.195),(40.285,11.025),(40.115,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.025),(49.715,11.195),(49.885,11.195),(49.885,11.025),(49.715,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.025),(49.205,11.195),(49.375,11.195),(49.375,11.025),(49.205,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.365),(49.715,11.535),(49.885,11.535),(49.885,11.365),(49.715,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.365),(49.205,11.535),(49.375,11.535),(49.375,11.365),(49.205,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,11.705),(49.715,11.875),(49.885,11.875),(49.885,11.705),(49.715,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,11.705),(49.205,11.875),(49.375,11.875),(49.375,11.705),(49.205,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.925),(58.805,40.095),(58.975,40.095),(58.975,39.925),(58.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.705),(55.025,11.875),(55.195,11.875),(55.195,11.705),(55.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.025),(55.025,11.195),(55.195,11.195),(55.195,11.025),(55.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,11.365),(55.025,11.535),(55.195,11.535),(55.195,11.365),(55.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.825),(39.605,17.995),(39.775,17.995),(39.775,17.825),(39.605,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.165),(59.315,35.335),(59.485,35.335),(59.485,35.165),(59.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.505),(59.315,35.675),(59.485,35.675),(59.485,35.505),(59.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.145),(39.605,17.315),(39.775,17.315),(39.775,17.145),(39.605,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,17.485),(39.605,17.655),(39.775,17.655),(39.775,17.485),(39.605,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,4.905),(31.025,5.075),(31.195,5.075),(31.195,4.905),(31.025,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,2.865),(35.825,3.035),(35.995,3.035),(35.995,2.865),(35.825,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,2.865),(35.315,3.035),(35.485,3.035),(35.485,2.865),(35.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,23.945),(44.915,24.115),(45.085,24.115),(45.085,23.945),(44.915,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.645),(31.025,8.815),(31.195,8.815),(31.195,8.645),(31.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.305),(31.025,8.475),(31.195,8.475),(31.195,8.305),(31.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.105),(45.425,32.275),(45.595,32.275),(45.595,32.105),(45.425,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.445),(45.425,32.615),(45.595,32.615),(45.595,32.445),(45.425,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.105),(34.805,15.275),(34.975,15.275),(34.975,15.105),(34.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.445),(34.805,15.615),(34.975,15.615),(34.975,15.445),(34.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,15.785),(34.805,15.955),(34.975,15.955),(34.975,15.785),(34.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,32.785),(45.425,32.955),(45.595,32.955),(45.595,32.785),(45.425,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.725),(40.115,29.895),(40.285,29.895),(40.285,29.725),(40.115,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.725),(40.625,29.895),(40.795,29.895),(40.795,29.725),(40.625,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.825),(55.025,34.995),(55.195,34.995),(55.195,34.825),(55.025,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.045),(40.625,29.215),(40.795,29.215),(40.795,29.045),(40.625,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,29.385),(40.625,29.555),(40.795,29.555),(40.795,29.385),(40.625,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.805),(58.805,33.975),(58.975,33.975),(58.975,33.805),(58.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.045),(40.115,29.215),(40.285,29.215),(40.285,29.045),(40.115,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,29.385),(40.115,29.555),(40.285,29.555),(40.285,29.385),(40.115,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.145),(55.025,34.315),(55.195,34.315),(55.195,34.145),(55.025,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,34.485),(55.025,34.655),(55.195,34.655),(55.195,34.485),(55.025,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.125),(58.805,33.295),(58.975,33.295),(58.975,33.125),(58.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,33.465),(58.805,33.635),(58.975,33.635),(58.975,33.465),(58.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.385),(44.405,12.555),(44.575,12.555),(44.575,12.385),(44.405,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.045),(44.405,12.215),(44.575,12.215),(44.575,12.045),(44.405,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,12.725),(44.405,12.895),(44.575,12.895),(44.575,12.725),(44.405,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.185),(54.005,19.355),(54.175,19.355),(54.175,19.185),(54.005,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.525),(54.005,19.695),(54.175,19.695),(54.175,19.525),(54.005,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.525),(54.515,19.695),(54.685,19.695),(54.685,19.525),(54.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.185),(54.515,19.355),(54.685,19.355),(54.685,19.185),(54.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,24.965),(31.025,25.135),(31.195,25.135),(31.195,24.965),(31.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,20.885),(44.405,21.055),(44.575,21.055),(44.575,20.885),(44.405,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.185),(50.225,36.355),(50.395,36.355),(50.395,36.185),(50.225,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.525),(50.225,36.695),(50.395,36.695),(50.395,36.525),(50.225,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,8.985),(49.205,9.155),(49.375,9.155),(49.375,8.985),(49.205,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,8.985),(49.715,9.155),(49.885,9.155),(49.885,8.985),(49.715,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.885),(40.625,38.055),(40.795,38.055),(40.795,37.885),(40.625,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.885),(40.115,38.055),(40.285,38.055),(40.285,37.885),(40.115,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,20.885),(58.805,21.055),(58.975,21.055),(58.975,20.885),(58.805,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.245),(50.225,22.415),(50.395,22.415),(50.395,22.245),(50.225,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.585),(50.225,22.755),(50.395,22.755),(50.395,22.585),(50.225,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.825),(44.405,34.995),(44.575,34.995),(44.575,34.825),(44.405,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.485),(44.405,34.655),(44.575,34.655),(44.575,34.485),(44.405,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,34.145),(44.405,34.315),(44.575,34.315),(44.575,34.145),(44.405,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,20.885),(54.005,21.055),(54.175,21.055),(54.175,20.885),(54.005,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,20.885),(54.515,21.055),(54.685,21.055),(54.685,20.885),(54.515,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.785),(35.315,15.955),(35.485,15.955),(35.485,15.785),(35.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,38.905),(54.515,39.075),(54.685,39.075),(54.685,38.905),(54.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,38.905),(54.005,39.075),(54.175,39.075),(54.175,38.905),(54.005,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.685),(39.605,27.855),(39.775,27.855),(39.775,27.685),(39.605,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.005),(39.605,27.175),(39.775,27.175),(39.775,27.005),(39.605,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,27.345),(39.605,27.515),(39.775,27.515),(39.775,27.345),(39.605,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.145),(40.625,34.315),(40.795,34.315),(40.795,34.145),(40.625,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.145),(40.115,34.315),(40.285,34.315),(40.285,34.145),(40.115,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.825),(40.625,34.995),(40.795,34.995),(40.795,34.825),(40.625,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.485),(40.115,34.655),(40.285,34.655),(40.285,34.485),(40.115,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,34.485),(40.625,34.655),(40.795,34.655),(40.795,34.485),(40.625,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,34.825),(40.115,34.995),(40.285,34.995),(40.285,34.825),(40.115,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,23.945),(40.625,24.115),(40.795,24.115),(40.795,23.945),(40.625,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,23.945),(40.115,24.115),(40.285,24.115),(40.285,23.945),(40.115,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.205),(58.805,3.375),(58.975,3.375),(58.975,3.205),(58.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.545),(58.805,3.715),(58.975,3.715),(58.975,3.545),(58.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.805),(44.915,33.975),(45.085,33.975),(45.085,33.805),(44.915,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.125),(44.915,33.295),(45.085,33.295),(45.085,33.125),(44.915,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,33.465),(44.915,33.635),(45.085,33.635),(45.085,33.465),(44.915,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.425),(49.715,31.595),(49.885,31.595),(49.885,31.425),(49.715,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.845),(35.315,36.015),(35.485,36.015),(35.485,35.845),(35.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.965),(35.315,8.135),(35.485,8.135),(35.485,7.965),(35.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.545),(34.805,3.715),(34.975,3.715),(34.975,3.545),(34.805,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.205),(34.805,3.375),(34.975,3.375),(34.975,3.205),(34.805,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.965),(35.825,8.135),(35.995,8.135),(35.995,7.965),(35.825,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.845),(35.825,36.015),(35.995,36.015),(35.995,35.845),(35.825,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.825),(39.605,34.995),(39.775,34.995),(39.775,34.825),(39.605,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.145),(39.605,34.315),(39.775,34.315),(39.775,34.145),(39.605,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,34.485),(39.605,34.655),(39.775,34.655),(39.775,34.485),(39.605,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.925),(35.315,6.095),(35.485,6.095),(35.485,5.925),(35.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.925),(35.825,6.095),(35.995,6.095),(35.995,5.925),(35.825,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.905),(44.405,22.075),(44.575,22.075),(44.575,21.905),(44.405,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.025),(58.805,28.195),(58.975,28.195),(58.975,28.025),(58.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.365),(58.805,28.535),(58.975,28.535),(58.975,28.365),(58.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,28.705),(58.805,28.875),(58.975,28.875),(58.975,28.705),(58.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.685),(55.025,10.855),(55.195,10.855),(55.195,10.685),(55.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.005),(55.025,10.175),(55.195,10.175),(55.195,10.005),(55.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,10.345),(55.025,10.515),(55.195,10.515),(55.195,10.345),(55.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.665),(40.625,9.835),(40.795,9.835),(40.795,9.665),(40.625,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.665),(40.115,9.835),(40.285,9.835),(40.285,9.665),(40.115,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,9.325),(40.625,9.495),(40.795,9.495),(40.795,9.325),(40.625,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,9.325),(40.115,9.495),(40.285,9.495),(40.285,9.325),(40.115,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.945),(54.515,24.115),(54.685,24.115),(54.685,23.945),(54.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.945),(54.005,24.115),(54.175,24.115),(54.175,23.945),(54.005,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.185),(59.315,19.355),(59.485,19.355),(59.485,19.185),(59.315,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.285),(44.405,7.455),(44.575,7.455),(44.575,7.285),(44.405,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.525),(59.315,19.695),(59.485,19.695),(59.485,19.525),(59.315,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.625),(44.405,7.795),(44.575,7.795),(44.575,7.625),(44.405,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,38.905),(35.315,39.075),(35.485,39.075),(35.485,38.905),(35.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.465),(40.115,16.635),(40.285,16.635),(40.285,16.465),(40.115,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,38.905),(35.825,39.075),(35.995,39.075),(35.995,38.905),(35.825,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.805),(40.625,16.975),(40.795,16.975),(40.795,16.805),(40.625,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.805),(40.115,16.975),(40.285,16.975),(40.285,16.805),(40.115,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.465),(40.625,16.635),(40.795,16.635),(40.795,16.465),(40.625,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,8.985),(59.315,9.155),(59.485,9.155),(59.485,8.985),(59.315,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,17.485),(49.715,17.655),(49.885,17.655),(49.885,17.485),(49.715,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,16.125),(40.115,16.295),(40.285,16.295),(40.285,16.125),(40.115,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,16.125),(40.625,16.295),(40.795,16.295),(40.795,16.125),(40.625,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,8.985),(30.515,9.155),(30.685,9.155),(30.685,8.985),(30.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.225),(44.405,38.395),(44.575,38.395),(44.575,38.225),(44.405,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.565),(44.405,38.735),(44.575,38.735),(44.575,38.565),(44.405,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.025),(44.405,11.195),(44.575,11.195),(44.575,11.025),(44.405,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.365),(44.405,11.535),(44.575,11.535),(44.575,11.365),(44.405,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.685),(34.805,10.855),(34.975,10.855),(34.975,10.685),(34.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.005),(34.805,10.175),(34.975,10.175),(34.975,10.005),(34.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,10.345),(34.805,10.515),(34.975,10.515),(34.975,10.345),(34.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,11.705),(44.405,11.875),(44.575,11.875),(44.575,11.705),(44.405,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.025),(35.825,11.195),(35.995,11.195),(35.995,11.025),(35.825,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.025),(35.315,11.195),(35.485,11.195),(35.485,11.025),(35.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.365),(35.825,11.535),(35.995,11.535),(35.995,11.365),(35.825,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.365),(35.315,11.535),(35.485,11.535),(35.485,11.365),(35.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,11.705),(35.825,11.875),(35.995,11.875),(35.995,11.705),(35.825,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,11.705),(35.315,11.875),(35.485,11.875),(35.485,11.705),(35.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.285),(54.005,7.455),(54.175,7.455),(54.175,7.285),(54.005,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.285),(54.515,7.455),(54.685,7.455),(54.685,7.285),(54.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,7.625),(54.515,7.795),(54.685,7.795),(54.685,7.625),(54.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,7.625),(54.005,7.795),(54.175,7.795),(54.175,7.625),(54.005,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,19.865),(54.005,20.035),(54.175,20.035),(54.175,19.865),(54.005,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,19.865),(54.515,20.035),(54.685,20.035),(54.685,19.865),(54.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.985),(44.405,26.155),(44.575,26.155),(44.575,25.985),(44.405,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.585),(59.315,22.755),(59.485,22.755),(59.485,22.585),(59.315,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.245),(59.315,22.415),(59.485,22.415),(59.485,22.245),(59.315,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.905),(31.025,22.075),(31.195,22.075),(31.195,21.905),(31.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,40.265),(55.025,40.435),(55.195,40.435),(55.195,40.265),(55.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,40.605),(55.025,40.775),(55.195,40.775),(55.195,40.605),(55.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.225),(45.425,38.395),(45.595,38.395),(45.595,38.225),(45.425,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.565),(45.425,38.735),(45.595,38.735),(45.595,38.565),(45.425,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.885),(44.405,4.055),(44.575,4.055),(44.575,3.885),(44.405,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.565),(35.825,21.735),(35.995,21.735),(35.995,21.565),(35.825,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.565),(35.315,21.735),(35.485,21.735),(35.485,21.565),(35.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,21.225),(35.825,21.395),(35.995,21.395),(35.995,21.225),(35.825,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,21.225),(35.315,21.395),(35.485,21.395),(35.485,21.225),(35.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,3.885),(58.805,4.055),(58.975,4.055),(58.975,3.885),(58.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,6.945),(59.315,7.115),(59.485,7.115),(59.485,6.945),(59.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,3.885),(34.805,4.055),(34.975,4.055),(34.975,3.885),(34.805,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.225),(30.515,38.395),(30.685,38.395),(30.685,38.225),(30.515,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.565),(30.515,38.735),(30.685,38.735),(30.685,38.565),(30.515,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.085),(50.225,31.255),(50.395,31.255),(50.395,31.085),(50.225,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.425),(50.225,31.595),(50.395,31.595),(50.395,31.425),(50.225,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.285),(30.515,7.455),(30.685,7.455),(30.685,7.285),(30.515,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,7.625),(30.515,7.795),(30.685,7.795),(30.685,7.625),(30.515,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,31.765),(50.225,31.935),(50.395,31.935),(50.395,31.765),(50.225,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,18.845),(55.025,19.015),(55.195,19.015),(55.195,18.845),(55.025,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.825),(54.515,34.995),(54.685,34.995),(54.685,34.825),(54.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.485),(54.515,34.655),(54.685,34.655),(54.685,34.485),(54.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.825),(54.005,34.995),(54.175,34.995),(54.175,34.825),(54.005,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.145),(54.005,34.315),(54.175,34.315),(54.175,34.145),(54.005,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,34.485),(54.005,34.655),(54.175,34.655),(54.175,34.485),(54.005,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,34.145),(54.515,34.315),(54.685,34.315),(54.685,34.145),(54.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.325),(50.225,9.495),(50.395,9.495),(50.395,9.325),(50.225,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,9.665),(50.225,9.835),(50.395,9.835),(50.395,9.665),(50.225,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,22.925),(55.025,23.095),(55.195,23.095),(55.195,22.925),(55.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.065),(54.515,13.235),(54.685,13.235),(54.685,13.065),(54.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.405),(54.515,13.575),(54.685,13.575),(54.685,13.405),(54.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.065),(54.005,13.235),(54.175,13.235),(54.175,13.065),(54.005,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.405),(54.005,13.575),(54.175,13.575),(54.175,13.405),(54.005,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,13.745),(54.515,13.915),(54.685,13.915),(54.685,13.745),(54.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,13.745),(54.005,13.915),(54.175,13.915),(54.175,13.745),(54.005,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.145),(34.805,34.315),(34.975,34.315),(34.975,34.145),(34.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.485),(34.805,34.655),(34.975,34.655),(34.975,34.485),(34.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.405),(34.805,30.575),(34.975,30.575),(34.975,30.405),(34.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,34.825),(34.805,34.995),(34.975,34.995),(34.975,34.825),(34.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.065),(34.805,30.235),(34.975,30.235),(34.975,30.065),(34.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,30.745),(34.805,30.915),(34.975,30.915),(34.975,30.745),(34.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.525),(40.625,19.695),(40.795,19.695),(40.795,19.525),(40.625,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.185),(40.115,19.355),(40.285,19.355),(40.285,19.185),(40.115,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,19.525),(40.115,19.695),(40.285,19.695),(40.285,19.525),(40.115,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,19.185),(40.625,19.355),(40.795,19.355),(40.795,19.185),(40.625,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.525),(44.405,36.695),(44.575,36.695),(44.575,36.525),(44.405,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.185),(44.405,36.355),(44.575,36.355),(44.575,36.185),(44.405,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,20.885),(39.605,21.055),(39.775,21.055),(39.775,20.885),(39.605,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.225),(49.715,4.395),(49.885,4.395),(49.885,4.225),(49.715,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.225),(49.205,4.395),(49.375,4.395),(49.375,4.225),(49.205,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.565),(49.205,4.735),(49.375,4.735),(49.375,4.565),(49.205,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.565),(49.715,4.735),(49.885,4.735),(49.885,4.565),(49.715,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.905),(34.805,22.075),(34.975,22.075),(34.975,21.905),(34.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.765),(39.605,14.935),(39.775,14.935),(39.775,14.765),(39.605,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.085),(39.605,14.255),(39.775,14.255),(39.775,14.085),(39.605,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,14.425),(39.605,14.595),(39.775,14.595),(39.775,14.425),(39.605,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.205),(55.025,37.375),(55.195,37.375),(55.195,37.205),(55.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,37.545),(55.025,37.715),(55.195,37.715),(55.195,37.545),(55.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.265),(44.915,6.435),(45.085,6.435),(45.085,6.265),(44.915,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,6.605),(44.915,6.775),(45.085,6.775),(45.085,6.605),(44.915,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,40.605),(54.005,40.775),(54.175,40.775),(54.175,40.605),(54.005,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,40.265),(54.515,40.435),(54.685,40.435),(54.685,40.265),(54.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.225),(30.515,4.395),(30.685,4.395),(30.685,4.225),(30.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.565),(30.515,4.735),(30.685,4.735),(30.685,4.565),(30.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,40.605),(54.515,40.775),(54.685,40.775),(54.685,40.605),(54.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,40.265),(54.005,40.435),(54.175,40.435),(54.175,40.265),(54.005,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.885),(59.315,38.055),(59.485,38.055),(59.485,37.885),(59.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.145),(30.515,34.315),(30.685,34.315),(30.685,34.145),(30.515,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,6.945),(49.205,7.115),(49.375,7.115),(49.375,6.945),(49.205,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.485),(30.515,34.655),(30.685,34.655),(30.685,34.485),(30.515,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,6.945),(49.715,7.115),(49.885,7.115),(49.885,6.945),(49.715,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,34.825),(30.515,34.995),(30.685,34.995),(30.685,34.825),(30.515,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,39.925),(44.915,40.095),(45.085,40.095),(45.085,39.925),(44.915,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.285),(39.605,7.455),(39.775,7.455),(39.775,7.285),(39.605,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.625),(39.605,7.795),(39.775,7.795),(39.775,7.625),(39.605,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,40.265),(34.805,40.435),(34.975,40.435),(34.975,40.265),(34.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,40.605),(34.805,40.775),(34.975,40.775),(34.975,40.605),(34.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,26.325),(58.805,26.495),(58.975,26.495),(58.975,26.325),(58.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,26.665),(58.805,26.835),(58.975,26.835),(58.975,26.665),(58.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.185),(50.225,19.355),(50.395,19.355),(50.395,19.185),(50.225,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.525),(50.225,19.695),(50.395,19.695),(50.395,19.525),(50.225,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.685),(44.915,10.855),(45.085,10.855),(45.085,10.685),(44.915,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.005),(44.915,10.175),(45.085,10.175),(45.085,10.005),(44.915,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,20.885),(49.715,21.055),(49.885,21.055),(49.885,20.885),(49.715,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,10.345),(44.915,10.515),(45.085,10.515),(45.085,10.345),(44.915,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,20.885),(49.205,21.055),(49.375,21.055),(49.375,20.885),(49.205,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.425),(30.515,31.595),(30.685,31.595),(30.685,31.425),(30.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.765),(30.515,31.935),(30.685,31.935),(30.685,31.765),(30.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,31.085),(30.515,31.255),(30.685,31.255),(30.685,31.085),(30.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.185),(59.315,36.355),(59.485,36.355),(59.485,36.185),(59.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.525),(59.315,36.695),(59.485,36.695),(59.485,36.525),(59.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.225),(58.805,4.395),(58.975,4.395),(58.975,4.225),(58.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.565),(58.805,4.735),(58.975,4.735),(58.975,4.565),(58.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,24.965),(55.025,25.135),(55.195,25.135),(55.195,24.965),(55.025,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,40.265),(44.405,40.435),(44.575,40.435),(44.575,40.265),(44.405,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,40.605),(44.405,40.775),(44.575,40.775),(44.575,40.605),(44.405,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.205),(58.805,37.375),(58.975,37.375),(58.975,37.205),(58.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,37.545),(58.805,37.715),(58.975,37.715),(58.975,37.545),(58.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.225),(34.805,4.395),(34.975,4.395),(34.975,4.225),(34.805,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.565),(34.805,4.735),(34.975,4.735),(34.975,4.565),(34.805,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.205),(31.025,37.375),(31.195,37.375),(31.195,37.205),(31.025,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,37.545),(31.025,37.715),(31.195,37.715),(31.195,37.545),(31.025,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.205),(34.805,37.375),(34.975,37.375),(34.975,37.205),(34.805,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,37.545),(34.805,37.715),(34.975,37.715),(34.975,37.545),(34.805,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.945),(58.805,24.115),(58.975,24.115),(58.975,23.945),(58.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.305),(55.025,25.475),(55.195,25.475),(55.195,25.305),(55.025,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.565),(54.515,4.735),(54.685,4.735),(54.685,4.565),(54.515,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.225),(54.515,4.395),(54.685,4.395),(54.685,4.225),(54.515,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.685),(49.205,10.855),(49.375,10.855),(49.375,10.685),(49.205,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.005),(49.715,10.175),(49.885,10.175),(49.885,10.005),(49.715,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.225),(54.005,4.395),(54.175,4.395),(54.175,4.225),(54.005,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.005),(49.205,10.175),(49.375,10.175),(49.375,10.005),(49.205,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.565),(54.005,4.735),(54.175,4.735),(54.175,4.565),(54.005,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.345),(49.715,10.515),(49.885,10.515),(49.885,10.345),(49.715,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,10.345),(49.205,10.515),(49.375,10.515),(49.375,10.345),(49.205,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,10.685),(49.715,10.855),(49.885,10.855),(49.885,10.685),(49.715,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,4.905),(45.425,5.075),(45.595,5.075),(45.595,4.905),(45.425,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.845),(31.025,36.015),(31.195,36.015),(31.195,35.845),(31.025,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,2.865),(44.915,3.035),(45.085,3.035),(45.085,2.865),(44.915,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.025),(59.315,11.195),(59.485,11.195),(59.485,11.025),(59.315,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.365),(59.315,11.535),(59.485,11.535),(59.485,11.365),(59.315,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,11.705),(59.315,11.875),(59.485,11.875),(59.485,11.705),(59.315,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,18.845),(59.315,19.015),(59.485,19.015),(59.485,18.845),(59.315,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,39.925),(55.025,40.095),(55.195,40.095),(55.195,39.925),(55.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.165),(58.805,18.335),(58.975,18.335),(58.975,18.165),(58.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.505),(58.805,18.675),(58.975,18.675),(58.975,18.505),(58.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.405),(35.825,13.575),(35.995,13.575),(35.995,13.405),(35.825,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.065),(35.315,13.235),(35.485,13.235),(35.485,13.065),(35.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.405),(35.315,13.575),(35.485,13.575),(35.485,13.405),(35.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.065),(35.825,13.235),(35.995,13.235),(35.995,13.065),(35.825,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,13.745),(35.315,13.915),(35.485,13.915),(35.485,13.745),(35.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,13.745),(35.825,13.915),(35.995,13.915),(35.995,13.745),(35.825,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.845),(45.425,36.015),(45.595,36.015),(45.595,35.845),(45.425,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.625),(58.805,7.795),(58.975,7.795),(58.975,7.625),(58.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,7.285),(58.805,7.455),(58.975,7.455),(58.975,7.285),(58.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,38.905),(58.805,39.075),(58.975,39.075),(58.975,38.905),(58.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,39.925),(49.715,40.095),(49.885,40.095),(49.885,39.925),(49.715,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.625),(34.805,7.795),(34.975,7.795),(34.975,7.625),(34.805,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,39.925),(49.205,40.095),(49.375,40.095),(49.375,39.925),(49.205,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,7.285),(34.805,7.455),(34.975,7.455),(34.975,7.285),(34.805,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,8.985),(45.425,9.155),(45.595,9.155),(45.595,8.985),(45.425,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,38.905),(34.805,39.075),(34.975,39.075),(34.975,38.905),(34.805,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.485),(58.805,17.655),(58.975,17.655),(58.975,17.485),(58.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.145),(58.805,17.315),(58.975,17.315),(58.975,17.145),(58.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,17.825),(58.805,17.995),(58.975,17.995),(58.975,17.825),(58.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.285),(44.915,7.455),(45.085,7.455),(45.085,7.285),(44.915,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.625),(44.915,7.795),(45.085,7.795),(45.085,7.625),(44.915,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.345),(31.025,27.515),(31.195,27.515),(31.195,27.345),(31.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.685),(31.025,27.855),(31.195,27.855),(31.195,27.685),(31.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,27.005),(31.025,27.175),(31.195,27.175),(31.195,27.005),(31.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,20.885),(50.225,21.055),(50.395,21.055),(50.395,20.885),(50.225,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,2.865),(58.805,3.035),(58.975,3.035),(58.975,2.865),(58.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,2.865),(34.805,3.035),(34.975,3.035),(34.975,2.865),(34.805,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.825),(40.115,17.995),(40.285,17.995),(40.285,17.825),(40.115,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.825),(40.625,17.995),(40.795,17.995),(40.795,17.825),(40.625,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.485),(40.115,17.655),(40.285,17.655),(40.285,17.485),(40.115,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.485),(40.625,17.655),(40.795,17.655),(40.795,17.485),(40.625,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,17.145),(40.115,17.315),(40.285,17.315),(40.285,17.145),(40.115,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,17.145),(40.625,17.315),(40.795,17.315),(40.795,17.145),(40.625,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.925),(45.425,40.095),(45.595,40.095),(45.595,39.925),(45.425,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,5.925),(44.915,6.095),(45.085,6.095),(45.085,5.925),(44.915,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.205),(40.115,37.375),(40.285,37.375),(40.285,37.205),(40.115,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.205),(40.625,37.375),(40.795,37.375),(40.795,37.205),(40.625,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,37.545),(40.115,37.715),(40.285,37.715),(40.285,37.545),(40.115,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,37.545),(40.625,37.715),(40.795,37.715),(40.795,37.545),(40.625,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.265),(40.115,6.435),(40.285,6.435),(40.285,6.265),(40.115,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.605),(40.115,6.775),(40.285,6.775),(40.285,6.605),(40.115,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.265),(40.625,6.435),(40.795,6.435),(40.795,6.265),(40.625,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.065),(45.425,13.235),(45.595,13.235),(45.595,13.065),(45.425,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.625),(34.805,24.795),(34.975,24.795),(34.975,24.625),(34.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.405),(45.425,13.575),(45.595,13.575),(45.595,13.405),(45.425,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,13.745),(45.425,13.915),(45.595,13.915),(45.595,13.745),(45.425,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.605),(40.625,6.775),(40.795,6.775),(40.795,6.605),(40.625,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.285),(34.805,24.455),(34.975,24.455),(34.975,24.285),(34.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,39.925),(31.025,40.095),(31.195,40.095),(31.195,39.925),(31.025,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,19.865),(50.225,20.035),(50.395,20.035),(50.395,19.865),(50.225,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.705),(44.915,11.875),(45.085,11.875),(45.085,11.705),(44.915,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.025),(44.915,11.195),(45.085,11.195),(45.085,11.025),(44.915,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,11.365),(44.915,11.535),(45.085,11.535),(45.085,11.365),(44.915,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.465),(39.605,33.635),(39.775,33.635),(39.775,33.465),(39.605,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.125),(39.605,33.295),(39.775,33.295),(39.775,33.125),(39.605,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,33.805),(39.605,33.975),(39.775,33.975),(39.775,33.805),(39.605,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.625),(35.315,7.795),(35.485,7.795),(35.485,7.625),(35.315,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.625),(35.825,7.795),(35.995,7.795),(35.995,7.625),(35.825,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,7.285),(35.315,7.455),(35.485,7.455),(35.485,7.285),(35.315,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,7.285),(35.825,7.455),(35.995,7.455),(35.995,7.285),(35.825,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,4.905),(40.115,5.075),(40.285,5.075),(40.285,4.905),(40.115,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,4.905),(40.625,5.075),(40.795,5.075),(40.795,4.905),(40.625,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,23.945),(44.405,24.115),(44.575,24.115),(44.575,23.945),(44.405,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.885),(44.405,38.055),(44.575,38.055),(44.575,37.885),(44.405,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.185),(31.025,19.355),(31.195,19.355),(31.195,19.185),(31.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,19.525),(31.025,19.695),(31.195,19.695),(31.195,19.525),(31.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.745),(34.805,13.915),(34.975,13.915),(34.975,13.745),(34.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.405),(34.805,13.575),(34.975,13.575),(34.975,13.405),(34.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,13.065),(34.805,13.235),(34.975,13.235),(34.975,13.065),(34.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.905),(59.315,22.075),(59.485,22.075),(59.485,21.905),(59.315,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.565),(44.405,21.735),(44.575,21.735),(44.575,21.565),(44.405,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,21.225),(44.405,21.395),(44.575,21.395),(44.575,21.225),(44.405,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.905),(30.515,22.075),(30.685,22.075),(30.685,21.905),(30.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.665),(58.805,9.835),(58.975,9.835),(58.975,9.665),(58.805,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,9.325),(58.805,9.495),(58.975,9.495),(58.975,9.325),(58.805,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.185),(39.605,19.355),(39.775,19.355),(39.775,19.185),(39.605,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,19.525),(39.605,19.695),(39.775,19.695),(39.775,19.525),(39.605,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.125),(30.515,16.295),(30.685,16.295),(30.685,16.125),(30.515,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.465),(30.515,16.635),(30.685,16.635),(30.685,16.465),(30.515,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,16.805),(30.515,16.975),(30.685,16.975),(30.685,16.805),(30.515,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,2.865),(39.605,3.035),(39.775,3.035),(39.775,2.865),(39.605,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.125),(59.315,33.295),(59.485,33.295),(59.485,33.125),(59.315,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.465),(59.315,33.635),(59.485,33.635),(59.485,33.465),(59.315,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,33.805),(59.315,33.975),(59.485,33.975),(59.485,33.805),(59.315,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.725),(40.625,12.895),(40.795,12.895),(40.795,12.725),(40.625,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.725),(40.115,12.895),(40.285,12.895),(40.285,12.725),(40.115,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.385),(40.115,12.555),(40.285,12.555),(40.285,12.385),(40.115,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.045),(40.625,12.215),(40.795,12.215),(40.795,12.045),(40.625,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,12.385),(40.625,12.555),(40.795,12.555),(40.795,12.385),(40.625,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,12.045),(40.115,12.215),(40.285,12.215),(40.285,12.045),(40.115,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.065),(49.715,13.235),(49.885,13.235),(49.885,13.065),(49.715,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.065),(49.205,13.235),(49.375,13.235),(49.375,13.065),(49.205,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.745),(49.205,13.915),(49.375,13.915),(49.375,13.745),(49.205,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.745),(49.715,13.915),(49.885,13.915),(49.885,13.745),(49.715,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.185),(49.205,19.355),(49.375,19.355),(49.375,19.185),(49.205,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,13.405),(49.715,13.575),(49.885,13.575),(49.885,13.405),(49.715,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,13.405),(49.205,13.575),(49.375,13.575),(49.375,13.405),(49.205,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.525),(49.715,19.695),(49.885,19.695),(49.885,19.525),(49.715,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,19.185),(49.715,19.355),(49.885,19.355),(49.885,19.185),(49.715,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.525),(49.205,19.695),(49.375,19.695),(49.375,19.525),(49.205,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.925),(40.115,6.095),(40.285,6.095),(40.285,5.925),(40.115,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.925),(40.625,6.095),(40.795,6.095),(40.795,5.925),(40.625,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.265),(31.025,23.435),(31.195,23.435),(31.195,23.265),(31.025,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.485),(44.915,34.655),(45.085,34.655),(45.085,34.485),(44.915,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.145),(44.915,34.315),(45.085,34.315),(45.085,34.145),(44.915,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,34.825),(44.915,34.995),(45.085,34.995),(45.085,34.825),(44.915,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.605),(31.025,23.775),(31.195,23.775),(31.195,23.605),(31.025,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.305),(44.405,25.475),(44.575,25.475),(44.575,25.305),(44.405,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,25.645),(44.405,25.815),(44.575,25.815),(44.575,25.645),(44.405,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.485),(35.825,34.655),(35.995,34.655),(35.995,34.485),(35.825,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.025),(45.425,11.195),(45.595,11.195),(45.595,11.025),(45.425,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.365),(45.425,11.535),(45.595,11.535),(45.595,11.365),(45.425,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,11.705),(45.425,11.875),(45.595,11.875),(45.595,11.705),(45.425,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.145),(35.315,34.315),(35.485,34.315),(35.485,34.145),(35.315,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.485),(35.315,34.655),(35.485,34.655),(35.485,34.485),(35.315,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.165),(58.805,35.335),(58.975,35.335),(58.975,35.165),(58.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.825),(35.825,34.995),(35.995,34.995),(35.995,34.825),(35.825,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.445),(55.025,32.615),(55.195,32.615),(55.195,32.445),(55.025,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.505),(58.805,35.675),(58.975,35.675),(58.975,35.505),(58.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.785),(55.025,32.955),(55.195,32.955),(55.195,32.785),(55.025,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,34.825),(35.315,34.995),(35.485,34.995),(35.485,34.825),(35.315,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,32.105),(55.025,32.275),(55.195,32.275),(55.195,32.105),(55.025,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,34.145),(35.825,34.315),(35.995,34.315),(35.995,34.145),(35.825,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.045),(45.425,12.215),(45.595,12.215),(45.595,12.045),(45.425,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.385),(45.425,12.555),(45.595,12.555),(45.595,12.385),(45.425,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.925),(50.225,6.095),(50.395,6.095),(50.395,5.925),(50.225,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,12.725),(45.425,12.895),(45.595,12.895),(45.595,12.725),(45.425,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.205),(35.315,20.375),(35.485,20.375),(35.485,20.205),(35.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.545),(35.315,20.715),(35.485,20.715),(35.485,20.545),(35.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.545),(35.825,20.715),(35.995,20.715),(35.995,20.545),(35.825,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.205),(35.825,20.375),(35.995,20.375),(35.995,20.205),(35.825,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.185),(44.915,19.355),(45.085,19.355),(45.085,19.185),(44.915,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.525),(44.915,19.695),(45.085,19.695),(45.085,19.525),(44.915,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.965),(50.225,8.135),(50.395,8.135),(50.395,7.965),(50.225,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,8.985),(50.225,9.155),(50.395,9.155),(50.395,8.985),(50.225,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.225),(50.225,38.395),(50.395,38.395),(50.395,38.225),(50.225,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.565),(50.225,38.735),(50.395,38.735),(50.395,38.565),(50.225,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,22.925),(58.805,23.095),(58.975,23.095),(58.975,22.925),(58.805,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.445),(45.425,15.615),(45.595,15.615),(45.595,15.445),(45.425,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.105),(45.425,15.275),(45.595,15.275),(45.595,15.105),(45.425,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,15.785),(45.425,15.955),(45.595,15.955),(45.595,15.785),(45.425,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,36.865),(30.515,37.035),(30.685,37.035),(30.685,36.865),(30.515,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.405),(59.315,13.575),(59.485,13.575),(59.485,13.405),(59.315,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,22.925),(54.515,23.095),(54.685,23.095),(54.685,22.925),(54.515,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,22.925),(54.005,23.095),(54.175,23.095),(54.175,22.925),(54.005,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.065),(59.315,13.235),(59.485,13.235),(59.485,13.065),(59.315,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,13.745),(59.315,13.915),(59.485,13.915),(59.485,13.745),(59.315,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.325),(44.915,9.495),(45.085,9.495),(45.085,9.325),(44.915,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,9.665),(44.915,9.835),(45.085,9.835),(45.085,9.665),(44.915,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.305),(45.425,25.475),(45.595,25.475),(45.595,25.305),(45.425,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,25.645),(45.425,25.815),(45.595,25.815),(45.595,25.645),(45.425,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,19.865),(35.315,20.035),(35.485,20.035),(35.485,19.865),(35.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,19.865),(35.825,20.035),(35.995,20.035),(35.995,19.865),(35.825,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.065),(58.805,30.235),(58.975,30.235),(58.975,30.065),(58.805,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.405),(58.805,30.575),(58.975,30.575),(58.975,30.405),(58.805,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,30.745),(58.805,30.915),(58.975,30.915),(58.975,30.745),(58.805,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.985),(44.915,9.155),(45.085,9.155),(45.085,8.985),(44.915,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.985),(34.805,26.155),(34.975,26.155),(34.975,25.985),(34.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,18.845),(54.005,19.015),(54.175,19.015),(54.175,18.845),(54.005,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,18.845),(54.515,19.015),(54.685,19.015),(54.685,18.845),(54.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.765),(54.515,31.935),(54.685,31.935),(54.685,31.765),(54.515,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.765),(54.005,31.935),(54.175,31.935),(54.175,31.765),(54.005,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.425),(54.515,31.595),(54.685,31.595),(54.685,31.425),(54.515,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.425),(54.005,31.595),(54.175,31.595),(54.175,31.425),(54.005,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,31.085),(54.515,31.255),(54.685,31.255),(54.685,31.085),(54.515,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,31.085),(54.005,31.255),(54.175,31.255),(54.175,31.085),(54.005,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.785),(39.605,32.955),(39.775,32.955),(39.775,32.785),(39.605,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.105),(39.605,32.275),(39.775,32.275),(39.775,32.105),(39.605,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,32.445),(39.605,32.615),(39.775,32.615),(39.775,32.445),(39.605,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.265),(50.225,23.435),(50.395,23.435),(50.395,23.265),(50.225,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,23.605),(50.225,23.775),(50.395,23.775),(50.395,23.605),(50.225,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.545),(49.715,37.715),(49.885,37.715),(49.885,37.545),(49.715,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.545),(49.205,37.715),(49.375,37.715),(49.375,37.545),(49.205,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,37.205),(49.205,37.375),(49.375,37.375),(49.375,37.205),(49.205,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,37.205),(49.715,37.375),(49.885,37.375),(49.885,37.205),(49.715,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.145),(59.315,17.315),(59.485,17.315),(59.485,17.145),(59.315,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.485),(59.315,17.655),(59.485,17.655),(59.485,17.485),(59.315,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,17.825),(59.315,17.995),(59.485,17.995),(59.485,17.825),(59.315,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.545),(44.915,20.715),(45.085,20.715),(45.085,20.545),(44.915,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,20.205),(44.915,20.375),(45.085,20.375),(45.085,20.205),(44.915,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.225),(34.805,21.395),(34.975,21.395),(34.975,21.225),(34.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,21.565),(34.805,21.735),(34.975,21.735),(34.975,21.565),(34.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,18.845),(50.225,19.015),(50.395,19.015),(50.395,18.845),(50.225,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,40.265),(58.805,40.435),(58.975,40.435),(58.975,40.265),(58.805,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,40.605),(58.805,40.775),(58.975,40.775),(58.975,40.605),(58.805,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.725),(39.605,29.895),(39.775,29.895),(39.775,29.725),(39.605,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.045),(39.605,29.215),(39.775,29.215),(39.775,29.045),(39.605,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,29.385),(39.605,29.555),(39.775,29.555),(39.775,29.385),(39.605,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.685),(40.625,10.855),(40.795,10.855),(40.795,10.685),(40.625,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.685),(40.115,10.855),(40.285,10.855),(40.285,10.685),(40.115,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.005),(40.115,10.175),(40.285,10.175),(40.285,10.005),(40.115,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.005),(40.625,10.175),(40.795,10.175),(40.795,10.005),(40.625,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,10.345),(40.625,10.515),(40.795,10.515),(40.795,10.345),(40.625,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,10.345),(40.115,10.515),(40.285,10.515),(40.285,10.345),(40.115,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.265),(39.605,6.435),(39.775,6.435),(39.775,6.265),(39.605,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.605),(39.605,6.775),(39.775,6.775),(39.775,6.605),(39.605,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.105),(40.115,15.275),(40.285,15.275),(40.285,15.105),(40.115,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.105),(40.625,15.275),(40.795,15.275),(40.795,15.105),(40.625,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.445),(40.625,15.615),(40.795,15.615),(40.795,15.445),(40.625,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.445),(40.115,15.615),(40.285,15.615),(40.285,15.445),(40.115,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,15.785),(40.625,15.955),(40.795,15.955),(40.795,15.785),(40.625,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,15.785),(40.115,15.955),(40.285,15.955),(40.285,15.785),(40.115,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.185),(45.425,19.355),(45.595,19.355),(45.595,19.185),(45.425,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,19.525),(45.425,19.695),(45.595,19.695),(45.595,19.525),(45.425,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,35.845),(58.805,36.015),(58.975,36.015),(58.975,35.845),(58.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.205),(45.425,37.375),(45.595,37.375),(45.595,37.205),(45.425,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,37.545),(45.425,37.715),(45.595,37.715),(45.595,37.545),(45.425,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.105),(58.805,32.275),(58.975,32.275),(58.975,32.105),(58.805,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.445),(58.805,32.615),(58.975,32.615),(58.975,32.445),(58.805,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,18.845),(45.425,19.015),(45.595,19.015),(45.595,18.845),(45.425,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,32.785),(58.805,32.955),(58.975,32.955),(58.975,32.785),(58.805,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,25.985),(44.915,26.155),(45.085,26.155),(45.085,25.985),(44.915,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.705),(34.805,11.875),(34.975,11.875),(34.975,11.705),(34.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.025),(34.805,11.195),(34.975,11.195),(34.975,11.025),(34.805,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,11.365),(34.805,11.535),(34.975,11.535),(34.975,11.365),(34.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.765),(45.425,14.935),(45.595,14.935),(45.595,14.765),(45.425,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.085),(45.425,14.255),(45.595,14.255),(45.595,14.085),(45.425,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.385),(50.225,29.555),(50.395,29.555),(50.395,29.385),(50.225,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,14.425),(45.425,14.595),(45.595,14.595),(45.595,14.425),(45.425,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.725),(50.225,29.895),(50.395,29.895),(50.395,29.725),(50.225,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,29.045),(50.225,29.215),(50.395,29.215),(50.395,29.045),(50.225,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.285),(44.915,24.455),(45.085,24.455),(45.085,24.285),(44.915,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,24.625),(44.915,24.795),(45.085,24.795),(45.085,24.625),(44.915,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.845),(40.115,36.015),(40.285,36.015),(40.285,35.845),(40.115,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.845),(40.625,36.015),(40.795,36.015),(40.795,35.845),(40.625,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.905),(45.425,22.075),(45.595,22.075),(45.595,21.905),(45.425,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,22.925),(45.425,23.095),(45.595,23.095),(45.595,22.925),(45.425,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.305),(49.205,25.475),(49.375,25.475),(49.375,25.305),(49.205,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.165),(55.025,35.335),(55.195,35.335),(55.195,35.165),(55.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,35.505),(55.025,35.675),(55.195,35.675),(55.195,35.505),(55.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.025),(34.805,28.195),(34.975,28.195),(34.975,28.025),(34.805,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.365),(34.805,28.535),(34.975,28.535),(34.975,28.365),(34.805,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,28.705),(34.805,28.875),(34.975,28.875),(34.975,28.705),(34.805,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.485),(55.025,17.655),(55.195,17.655),(55.195,17.485),(55.025,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.145),(55.025,17.315),(55.195,17.315),(55.195,17.145),(55.025,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,17.825),(55.025,17.995),(55.195,17.995),(55.195,17.825),(55.025,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.385),(35.315,12.555),(35.485,12.555),(35.485,12.385),(35.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.385),(35.825,12.555),(35.995,12.555),(35.995,12.385),(35.825,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.045),(35.825,12.215),(35.995,12.215),(35.995,12.045),(35.825,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.045),(35.315,12.215),(35.485,12.215),(35.485,12.045),(35.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,12.725),(35.825,12.895),(35.995,12.895),(35.995,12.725),(35.825,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,12.725),(35.315,12.895),(35.485,12.895),(35.485,12.725),(35.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.465),(40.115,33.635),(40.285,33.635),(40.285,33.465),(40.115,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.125),(40.115,33.295),(40.285,33.295),(40.285,33.125),(40.115,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.125),(40.625,33.295),(40.795,33.295),(40.795,33.125),(40.625,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.465),(40.625,33.635),(40.795,33.635),(40.795,33.465),(40.625,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,33.805),(40.115,33.975),(40.285,33.975),(40.285,33.805),(40.115,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,33.805),(40.625,33.975),(40.795,33.975),(40.795,33.805),(40.625,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,4.905),(59.315,5.075),(59.485,5.075),(59.485,4.905),(59.315,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,3.885),(44.915,4.055),(45.085,4.055),(45.085,3.885),(44.915,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.905),(44.915,39.075),(45.085,39.075),(45.085,38.905),(44.915,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.825),(44.915,17.995),(45.085,17.995),(45.085,17.825),(44.915,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.485),(44.915,17.655),(45.085,17.655),(45.085,17.485),(44.915,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,17.145),(44.915,17.315),(45.085,17.315),(45.085,17.145),(44.915,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.305),(39.605,8.475),(39.775,8.475),(39.775,8.305),(39.605,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.645),(39.605,8.815),(39.775,8.815),(39.775,8.645),(39.605,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.565),(44.915,21.735),(45.085,21.735),(45.085,21.565),(44.915,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.225),(44.915,21.395),(45.085,21.395),(45.085,21.225),(44.915,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.685),(30.515,10.855),(30.685,10.855),(30.685,10.685),(30.515,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.005),(30.515,10.175),(30.685,10.175),(30.685,10.005),(30.515,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,10.345),(30.515,10.515),(30.685,10.515),(30.685,10.345),(30.515,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.205),(35.315,3.375),(35.485,3.375),(35.485,3.205),(35.315,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,3.545),(35.315,3.715),(35.485,3.715),(35.485,3.545),(35.315,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.205),(35.825,3.375),(35.995,3.375),(35.995,3.205),(35.825,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,20.885),(55.025,21.055),(55.195,21.055),(55.195,20.885),(55.025,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,3.545),(35.825,3.715),(35.995,3.715),(35.995,3.545),(35.825,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.225),(59.315,38.395),(59.485,38.395),(59.485,38.225),(59.315,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.565),(59.315,38.735),(59.485,38.735),(59.485,38.565),(59.315,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.665),(31.025,9.835),(31.195,9.835),(31.195,9.665),(31.025,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,9.325),(31.025,9.495),(31.195,9.495),(31.195,9.325),(31.025,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,39.925),(44.405,40.095),(44.575,40.095),(44.575,39.925),(44.405,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.245),(31.025,22.415),(31.195,22.415),(31.195,22.245),(31.025,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.585),(31.025,22.755),(31.195,22.755),(31.195,22.585),(31.025,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,7.965),(44.915,8.135),(45.085,8.135),(45.085,7.965),(44.915,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.285),(58.805,24.455),(58.975,24.455),(58.975,24.285),(58.805,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.625),(58.805,24.795),(58.975,24.795),(58.975,24.625),(58.805,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.105),(50.225,32.275),(50.395,32.275),(50.395,32.105),(50.225,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.445),(50.225,32.615),(50.395,32.615),(50.395,32.445),(50.225,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,32.785),(50.225,32.955),(50.395,32.955),(50.395,32.785),(50.225,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.885),(30.515,38.055),(30.685,38.055),(30.685,37.885),(30.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.925),(35.315,40.095),(35.485,40.095),(35.485,39.925),(35.315,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.925),(35.825,40.095),(35.995,40.095),(35.995,39.925),(35.825,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.725),(30.515,29.895),(30.685,29.895),(30.685,29.725),(30.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.045),(30.515,29.215),(30.685,29.215),(30.685,29.045),(30.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,29.385),(30.515,29.555),(30.685,29.555),(30.685,29.385),(30.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.205),(40.115,20.375),(40.285,20.375),(40.285,20.205),(40.115,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.545),(40.115,20.715),(40.285,20.715),(40.285,20.545),(40.115,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.545),(40.625,20.715),(40.795,20.715),(40.795,20.545),(40.625,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.205),(40.625,20.375),(40.795,20.375),(40.795,20.205),(40.625,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.745),(31.025,13.915),(31.195,13.915),(31.195,13.745),(31.025,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.245),(45.425,39.415),(45.595,39.415),(45.595,39.245),(45.425,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,39.585),(45.425,39.755),(45.595,39.755),(45.595,39.585),(45.425,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.065),(31.025,13.235),(31.195,13.235),(31.195,13.065),(31.025,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,13.405),(31.025,13.575),(31.195,13.575),(31.195,13.405),(31.025,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.265),(30.515,6.435),(30.685,6.435),(30.685,6.265),(30.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.605),(30.515,6.775),(30.685,6.775),(30.685,6.605),(30.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.685),(55.025,27.855),(55.195,27.855),(55.195,27.685),(55.025,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.005),(55.025,27.175),(55.195,27.175),(55.195,27.005),(55.025,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,27.345),(55.025,27.515),(55.195,27.515),(55.195,27.345),(55.025,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.265),(35.315,6.435),(35.485,6.435),(35.485,6.265),(35.315,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.265),(35.825,6.435),(35.995,6.435),(35.995,6.265),(35.825,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.605),(35.825,6.775),(35.995,6.775),(35.995,6.605),(35.825,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.605),(35.315,6.775),(35.485,6.775),(35.485,6.605),(35.315,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.125),(34.805,16.295),(34.975,16.295),(34.975,16.125),(34.805,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.465),(34.805,16.635),(34.975,16.635),(34.975,16.465),(34.805,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,16.805),(34.805,16.975),(34.975,16.975),(34.975,16.805),(34.805,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.585),(39.605,5.755),(39.775,5.755),(39.775,5.585),(39.605,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,8.985),(58.805,9.155),(58.975,9.155),(58.975,8.985),(58.805,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,5.245),(39.605,5.415),(39.775,5.415),(39.775,5.245),(39.605,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.205),(44.405,37.375),(44.575,37.375),(44.575,37.205),(44.405,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,37.545),(44.405,37.715),(44.575,37.715),(44.575,37.545),(44.405,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.465),(35.315,16.635),(35.485,16.635),(35.485,16.465),(35.315,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.125),(35.315,16.295),(35.485,16.295),(35.485,16.125),(35.315,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.805),(35.825,16.975),(35.995,16.975),(35.995,16.805),(35.825,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,16.805),(35.315,16.975),(35.485,16.975),(35.485,16.805),(35.315,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.105),(35.825,15.275),(35.995,15.275),(35.995,15.105),(35.825,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.465),(35.825,16.635),(35.995,16.635),(35.995,16.465),(35.825,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.105),(35.315,15.275),(35.485,15.275),(35.485,15.105),(35.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,15.445),(35.315,15.615),(35.485,15.615),(35.485,15.445),(35.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,16.125),(35.825,16.295),(35.995,16.295),(35.995,16.125),(35.825,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,27.005),(45.425,27.175),(45.595,27.175),(45.595,27.005),(45.425,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.685),(58.805,27.855),(58.975,27.855),(58.975,27.685),(58.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.785),(35.825,15.955),(35.995,15.955),(35.995,15.785),(35.825,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.765),(49.205,31.935),(49.375,31.935),(49.375,31.765),(49.205,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.085),(49.205,31.255),(49.375,31.255),(49.375,31.085),(49.205,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.765),(49.715,31.935),(49.885,31.935),(49.885,31.765),(49.715,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,31.425),(49.205,31.595),(49.375,31.595),(49.375,31.425),(49.205,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.565),(49.205,38.735),(49.375,38.735),(49.375,38.565),(49.205,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.225),(49.205,38.395),(49.375,38.395),(49.375,38.225),(49.205,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.245),(58.805,39.415),(58.975,39.415),(58.975,39.245),(58.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.565),(49.715,38.735),(49.885,38.735),(49.885,38.565),(49.715,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.225),(49.715,38.395),(49.885,38.395),(49.885,38.225),(49.715,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,39.585),(58.805,39.755),(58.975,39.755),(58.975,39.585),(58.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.265),(34.805,6.435),(34.975,6.435),(34.975,6.265),(34.805,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.605),(34.805,6.775),(34.975,6.775),(34.975,6.605),(34.805,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.865),(44.915,37.035),(45.085,37.035),(45.085,36.865),(44.915,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.565),(30.515,21.735),(30.685,21.735),(30.685,21.565),(30.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,21.225),(30.515,21.395),(30.685,21.395),(30.685,21.225),(30.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.605),(54.005,6.775),(54.175,6.775),(54.175,6.605),(54.005,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.265),(54.005,6.435),(54.175,6.435),(54.175,6.265),(54.005,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.605),(54.515,6.775),(54.685,6.775),(54.685,6.605),(54.515,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.265),(54.515,6.435),(54.685,6.435),(54.685,6.265),(54.515,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.725),(49.715,12.895),(49.885,12.895),(49.885,12.725),(49.715,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.725),(49.205,12.895),(49.375,12.895),(49.375,12.725),(49.205,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.045),(49.205,12.215),(49.375,12.215),(49.375,12.045),(49.205,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.045),(49.715,12.215),(49.885,12.215),(49.885,12.045),(49.715,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,12.385),(49.205,12.555),(49.375,12.555),(49.375,12.385),(49.205,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,12.385),(49.715,12.555),(49.885,12.555),(49.885,12.385),(49.715,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,8.985),(31.025,9.155),(31.195,9.155),(31.195,8.985),(31.025,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.245),(40.115,5.415),(40.285,5.415),(40.285,5.245),(40.115,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.585),(40.625,5.755),(40.795,5.755),(40.795,5.585),(40.625,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,5.585),(40.115,5.755),(40.285,5.755),(40.285,5.585),(40.115,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,5.245),(40.625,5.415),(40.795,5.415),(40.795,5.245),(40.625,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,3.885),(59.315,4.055),(59.485,4.055),(59.485,3.885),(59.315,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.185),(58.805,19.355),(58.975,19.355),(58.975,19.185),(58.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.525),(58.805,19.695),(58.975,19.695),(58.975,19.525),(58.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,15.445),(35.825,15.615),(35.995,15.615),(35.995,15.445),(35.825,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.605),(35.315,23.775),(35.485,23.775),(35.485,23.605),(35.315,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.825),(30.515,17.995),(30.685,17.995),(30.685,17.825),(30.515,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.145),(30.515,17.315),(30.685,17.315),(30.685,17.145),(30.515,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,17.485),(30.515,17.655),(30.685,17.655),(30.685,17.485),(30.515,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.605),(35.825,23.775),(35.995,23.775),(35.995,23.605),(35.825,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.465),(49.715,33.635),(49.885,33.635),(49.885,33.465),(49.715,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.125),(49.715,33.295),(49.885,33.295),(49.885,33.125),(49.715,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.125),(49.205,33.295),(49.375,33.295),(49.375,33.125),(49.205,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,33.805),(49.715,33.975),(49.885,33.975),(49.885,33.805),(49.715,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.805),(49.205,33.975),(49.375,33.975),(49.375,33.805),(49.205,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,7.965),(39.605,8.135),(39.775,8.135),(39.775,7.965),(39.605,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,33.465),(49.205,33.635),(49.375,33.635),(49.375,33.465),(49.205,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.185),(40.115,36.355),(40.285,36.355),(40.285,36.185),(40.115,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.525),(40.115,36.695),(40.285,36.695),(40.285,36.525),(40.115,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.525),(40.625,36.695),(40.795,36.695),(40.795,36.525),(40.625,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,26.325),(34.805,26.495),(34.975,26.495),(34.975,26.325),(34.805,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,26.665),(34.805,26.835),(34.975,26.835),(34.975,26.665),(34.805,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.185),(40.625,36.355),(40.795,36.355),(40.795,36.185),(40.625,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.585),(50.225,5.755),(50.395,5.755),(50.395,5.585),(50.225,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,5.245),(50.225,5.415),(50.395,5.415),(50.395,5.245),(50.225,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,36.865),(50.225,37.035),(50.395,37.035),(50.395,36.865),(50.225,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.505),(44.915,35.675),(45.085,35.675),(45.085,35.505),(44.915,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,35.165),(44.915,35.335),(45.085,35.335),(45.085,35.165),(44.915,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,22.925),(50.225,23.095),(50.395,23.095),(50.395,22.925),(50.225,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.725),(59.315,12.895),(59.485,12.895),(59.485,12.725),(59.315,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.045),(59.315,12.215),(59.485,12.215),(59.485,12.045),(59.315,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,12.385),(59.315,12.555),(59.485,12.555),(59.485,12.385),(59.315,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.925),(34.805,40.095),(34.975,40.095),(34.975,39.925),(34.805,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,3.885),(31.025,4.055),(31.195,4.055),(31.195,3.885),(31.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.985),(58.805,26.155),(58.975,26.155),(58.975,25.985),(58.805,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.985),(40.625,26.155),(40.795,26.155),(40.795,25.985),(40.625,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.985),(40.115,26.155),(40.285,26.155),(40.285,25.985),(40.115,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.225),(44.405,4.395),(44.575,4.395),(44.575,4.225),(44.405,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.565),(44.405,4.735),(44.575,4.735),(44.575,4.565),(44.405,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.165),(40.625,18.335),(40.795,18.335),(40.795,18.165),(40.625,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.505),(40.625,18.675),(40.795,18.675),(40.795,18.505),(40.625,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.165),(40.115,18.335),(40.285,18.335),(40.285,18.165),(40.115,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.505),(40.115,18.675),(40.285,18.675),(40.285,18.505),(40.115,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.645),(34.805,25.815),(34.975,25.815),(34.975,25.645),(34.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,25.305),(34.805,25.475),(34.975,25.475),(34.975,25.305),(34.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.585),(35.825,5.755),(35.995,5.755),(35.995,5.585),(35.825,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.245),(35.315,5.415),(35.485,5.415),(35.485,5.245),(35.315,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,5.585),(35.315,5.755),(35.485,5.755),(35.485,5.585),(35.315,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,5.245),(35.825,5.415),(35.995,5.415),(35.995,5.245),(35.825,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.645),(54.515,8.815),(54.685,8.815),(54.685,8.645),(54.515,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.305),(54.515,8.475),(54.685,8.475),(54.685,8.305),(54.515,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.305),(54.005,8.475),(54.175,8.475),(54.175,8.305),(54.005,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.645),(54.005,8.815),(54.175,8.815),(54.175,8.645),(54.005,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.265),(54.515,23.435),(54.685,23.435),(54.685,23.265),(54.515,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,23.605),(54.515,23.775),(54.685,23.775),(54.685,23.605),(54.515,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.265),(54.005,23.435),(54.175,23.435),(54.175,23.265),(54.005,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,23.605),(54.005,23.775),(54.175,23.775),(54.175,23.605),(54.005,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,3.885),(49.205,4.055),(49.375,4.055),(49.375,3.885),(49.205,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,3.885),(49.715,4.055),(49.885,4.055),(49.885,3.885),(49.715,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,3.885),(55.025,4.055),(55.195,4.055),(55.195,3.885),(55.025,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.125),(34.805,33.295),(34.975,33.295),(34.975,33.125),(34.805,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.465),(34.805,33.635),(34.975,33.635),(34.975,33.465),(34.805,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,33.805),(34.805,33.975),(34.975,33.975),(34.975,33.805),(34.805,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.725),(50.225,12.895),(50.395,12.895),(50.395,12.725),(50.225,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.045),(50.225,12.215),(50.395,12.215),(50.395,12.045),(50.225,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,12.385),(50.225,12.555),(50.395,12.555),(50.395,12.385),(50.225,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.365),(39.605,28.535),(39.775,28.535),(39.775,28.365),(39.605,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.025),(39.605,28.195),(39.775,28.195),(39.775,28.025),(39.605,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,28.705),(39.605,28.875),(39.775,28.875),(39.775,28.705),(39.605,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.925),(31.025,6.095),(31.195,6.095),(31.195,5.925),(31.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.165),(30.515,18.335),(30.685,18.335),(30.685,18.165),(30.515,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.505),(30.515,18.675),(30.685,18.675),(30.685,18.505),(30.515,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.565),(31.025,38.735),(31.195,38.735),(31.195,38.565),(31.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.225),(31.025,38.395),(31.195,38.395),(31.195,38.225),(31.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,38.905),(44.405,39.075),(44.575,39.075),(44.575,38.905),(44.405,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.885),(50.225,38.055),(50.395,38.055),(50.395,37.885),(50.225,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.785),(55.025,15.955),(55.195,15.955),(55.195,15.785),(55.025,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.105),(55.025,15.275),(55.195,15.275),(55.195,15.105),(55.025,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,15.445),(55.025,15.615),(55.195,15.615),(55.195,15.445),(55.025,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.585),(44.405,22.755),(44.575,22.755),(44.575,22.585),(44.405,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.245),(44.405,22.415),(44.575,22.415),(44.575,22.245),(44.405,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.165),(49.715,35.335),(49.885,35.335),(49.885,35.165),(49.715,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.165),(49.205,35.335),(49.375,35.335),(49.375,35.165),(49.205,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,35.505),(49.715,35.675),(49.885,35.675),(49.885,35.505),(49.715,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,35.505),(49.205,35.675),(49.375,35.675),(49.375,35.505),(49.205,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.725),(31.025,12.895),(31.195,12.895),(31.195,12.725),(31.025,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.045),(31.025,12.215),(31.195,12.215),(31.195,12.045),(31.025,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,12.385),(31.025,12.555),(31.195,12.555),(31.195,12.385),(31.025,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,19.865),(58.805,20.035),(58.975,20.035),(58.975,19.865),(58.805,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,22.925),(59.315,23.095),(59.485,23.095),(59.485,22.925),(59.315,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.625),(40.625,24.795),(40.795,24.795),(40.795,24.625),(40.625,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.285),(40.625,24.455),(40.795,24.455),(40.795,24.285),(40.625,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.285),(40.115,24.455),(40.285,24.455),(40.285,24.285),(40.115,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.625),(40.115,24.795),(40.285,24.795),(40.285,24.625),(40.115,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.225),(31.025,21.395),(31.195,21.395),(31.195,21.225),(31.025,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,21.565),(31.025,21.735),(31.195,21.735),(31.195,21.565),(31.025,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.105),(50.225,15.275),(50.395,15.275),(50.395,15.105),(50.225,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.445),(50.225,15.615),(50.395,15.615),(50.395,15.445),(50.225,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.785),(59.315,15.955),(59.485,15.955),(59.485,15.785),(59.315,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,15.785),(50.225,15.955),(50.395,15.955),(50.395,15.785),(50.225,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.105),(59.315,15.275),(59.485,15.275),(59.485,15.105),(59.315,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,15.445),(59.315,15.615),(59.485,15.615),(59.485,15.445),(59.315,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((73.76,21.44),(73.76,21.61),(73.93,21.61),(73.93,21.44),(73.76,21.44)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.925),(55.025,6.095),(55.195,6.095),(55.195,5.925),(55.025,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,38.905),(45.425,39.075),(45.595,39.075),(45.595,38.905),(45.425,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.105),(35.825,32.275),(35.995,32.275),(35.995,32.105),(35.825,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.105),(35.315,32.275),(35.485,32.275),(35.485,32.105),(35.315,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.445),(35.315,32.615),(35.485,32.615),(35.485,32.445),(35.315,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.565),(55.025,38.735),(55.195,38.735),(55.195,38.565),(55.025,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.225),(55.025,38.395),(55.195,38.395),(55.195,38.225),(55.025,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.445),(35.825,32.615),(35.995,32.615),(35.995,32.445),(35.825,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,32.785),(35.825,32.955),(35.995,32.955),(35.995,32.785),(35.825,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,32.785),(35.315,32.955),(35.485,32.955),(35.485,32.785),(35.315,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.545),(44.405,3.715),(44.575,3.715),(44.575,3.545),(44.405,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,3.205),(44.405,3.375),(44.575,3.375),(44.575,3.205),(44.405,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.045),(54.515,29.215),(54.685,29.215),(54.685,29.045),(54.515,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.385),(54.515,29.555),(54.685,29.555),(54.685,29.385),(54.515,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.385),(54.005,29.555),(54.175,29.555),(54.175,29.385),(54.005,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.725),(54.005,29.895),(54.175,29.895),(54.175,29.725),(54.005,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,29.725),(54.515,29.895),(54.685,29.895),(54.685,29.725),(54.515,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,29.045),(54.005,29.215),(54.175,29.215),(54.175,29.045),(54.005,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,26.665),(44.405,26.835),(44.575,26.835),(44.575,26.665),(44.405,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,26.325),(44.405,26.495),(44.575,26.495),(44.575,26.325),(44.405,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,3.885),(45.425,4.055),(45.595,4.055),(45.595,3.885),(45.425,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,38.905),(30.515,39.075),(30.685,39.075),(30.685,38.905),(30.515,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.285),(59.315,24.455),(59.485,24.455),(59.485,24.285),(59.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,24.625),(59.315,24.795),(59.485,24.795),(59.485,24.625),(59.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.065),(44.405,30.235),(44.575,30.235),(44.575,30.065),(44.405,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.405),(44.405,30.575),(44.575,30.575),(44.575,30.405),(44.405,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,30.745),(44.405,30.915),(44.575,30.915),(44.575,30.745),(44.405,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.265),(35.825,23.435),(35.995,23.435),(35.995,23.265),(35.825,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.205),(34.805,20.375),(34.975,20.375),(34.975,20.205),(34.805,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,20.545),(34.805,20.715),(34.975,20.715),(34.975,20.545),(34.805,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,40.605),(40.115,40.775),(40.285,40.775),(40.285,40.605),(40.115,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,40.605),(40.625,40.775),(40.795,40.775),(40.795,40.605),(40.625,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,40.265),(40.115,40.435),(40.285,40.435),(40.285,40.265),(40.115,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,40.265),(40.625,40.435),(40.795,40.435),(40.795,40.265),(40.625,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.905),(54.515,22.075),(54.685,22.075),(54.685,21.905),(54.515,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.905),(54.005,22.075),(54.175,22.075),(54.175,21.905),(54.005,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.205),(44.915,37.375),(45.085,37.375),(45.085,37.205),(44.915,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,37.545),(44.915,37.715),(45.085,37.715),(45.085,37.545),(44.915,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,25.985),(49.715,26.155),(49.885,26.155),(49.885,25.985),(49.715,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,25.985),(49.205,26.155),(49.375,26.155),(49.375,25.985),(49.205,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.085),(39.605,31.255),(39.775,31.255),(39.775,31.085),(39.605,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.425),(39.605,31.595),(39.775,31.595),(39.775,31.425),(39.605,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,31.765),(39.605,31.935),(39.775,31.935),(39.775,31.765),(39.605,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.225),(39.605,38.395),(39.775,38.395),(39.775,38.225),(39.605,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,38.565),(39.605,38.735),(39.775,38.735),(39.775,38.565),(39.605,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.965),(45.425,8.135),(45.595,8.135),(45.595,7.965),(45.425,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,36.865),(44.405,37.035),(44.575,37.035),(44.575,36.865),(44.405,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.205),(50.225,3.375),(50.395,3.375),(50.395,3.205),(50.225,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.545),(50.225,3.715),(50.395,3.715),(50.395,3.545),(50.225,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,4.905),(49.715,5.075),(49.885,5.075),(49.885,4.905),(49.715,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,4.905),(49.205,5.075),(49.375,5.075),(49.375,4.905),(49.205,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.765),(55.025,14.935),(55.195,14.935),(55.195,14.765),(55.025,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.085),(55.025,14.255),(55.195,14.255),(55.195,14.085),(55.025,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.105),(30.515,15.275),(30.685,15.275),(30.685,15.105),(30.515,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.445),(30.515,15.615),(30.685,15.615),(30.685,15.445),(30.515,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,14.425),(55.025,14.595),(55.195,14.595),(55.195,14.425),(55.025,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,15.785),(30.515,15.955),(30.685,15.955),(30.685,15.785),(30.515,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,23.945),(31.025,24.115),(31.195,24.115),(31.195,23.945),(31.025,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,21.905),(39.605,22.075),(39.775,22.075),(39.775,21.905),(39.605,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.205),(30.515,37.375),(30.685,37.375),(30.685,37.205),(30.515,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,37.545),(30.515,37.715),(30.685,37.715),(30.685,37.545),(30.515,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.245),(39.605,22.415),(39.775,22.415),(39.775,22.245),(39.605,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.125),(30.515,33.295),(30.685,33.295),(30.685,33.125),(30.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.465),(30.515,33.635),(30.685,33.635),(30.685,33.465),(30.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.245),(35.315,39.415),(35.485,39.415),(35.485,39.245),(35.315,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,39.585),(35.315,39.755),(35.485,39.755),(35.485,39.585),(35.315,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.245),(35.825,39.415),(35.995,39.415),(35.995,39.245),(35.825,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,39.585),(35.825,39.755),(35.995,39.755),(35.995,39.585),(35.825,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,4.905),(30.515,5.075),(30.685,5.075),(30.685,4.905),(30.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,33.805),(30.515,33.975),(30.685,33.975),(30.685,33.805),(30.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.545),(59.315,37.715),(59.485,37.715),(59.485,37.545),(59.315,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,37.205),(59.315,37.375),(59.485,37.375),(59.485,37.205),(59.315,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,3.885),(40.625,4.055),(40.795,4.055),(40.795,3.885),(40.625,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,3.885),(40.115,4.055),(40.285,4.055),(40.285,3.885),(40.115,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,25.645),(55.025,25.815),(55.195,25.815),(55.195,25.645),(55.025,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.225),(39.605,4.395),(39.775,4.395),(39.775,4.225),(39.605,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,4.565),(39.605,4.735),(39.775,4.735),(39.775,4.565),(39.605,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.685),(40.625,27.855),(40.795,27.855),(40.795,27.685),(40.625,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.685),(40.115,27.855),(40.285,27.855),(40.285,27.685),(40.115,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.345),(40.625,27.515),(40.795,27.515),(40.795,27.345),(40.625,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.005),(40.115,27.175),(40.285,27.175),(40.285,27.005),(40.115,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,27.345),(40.115,27.515),(40.285,27.515),(40.285,27.345),(40.115,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,27.005),(40.625,27.175),(40.795,27.175),(40.795,27.005),(40.625,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.705),(30.515,11.875),(30.685,11.875),(30.685,11.705),(30.515,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.365),(30.515,11.535),(30.685,11.535),(30.685,11.365),(30.515,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,11.025),(30.515,11.195),(30.685,11.195),(30.685,11.025),(30.515,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.825),(49.715,34.995),(49.885,34.995),(49.885,34.825),(49.715,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.145),(49.715,34.315),(49.885,34.315),(49.885,34.145),(49.715,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,34.485),(49.715,34.655),(49.885,34.655),(49.885,34.485),(49.715,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.145),(49.205,34.315),(49.375,34.315),(49.375,34.145),(49.205,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.485),(49.205,34.655),(49.375,34.655),(49.375,34.485),(49.205,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,34.825),(49.205,34.995),(49.375,34.995),(49.375,34.825),(49.205,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,36.865),(59.315,37.035),(59.485,37.035),(59.485,36.865),(59.315,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.425),(35.315,14.595),(35.485,14.595),(35.485,14.425),(35.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.085),(35.315,14.255),(35.485,14.255),(35.485,14.085),(35.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.085),(35.825,14.255),(35.995,14.255),(35.995,14.085),(35.825,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.425),(35.825,14.595),(35.995,14.595),(35.995,14.425),(35.825,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,14.765),(35.825,14.935),(35.995,14.935),(35.995,14.765),(35.825,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,14.765),(35.315,14.935),(35.485,14.935),(35.485,14.765),(35.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.785),(44.405,15.955),(44.575,15.955),(44.575,15.785),(44.405,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.105),(44.405,15.275),(44.575,15.275),(44.575,15.105),(44.405,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.745),(49.205,30.915),(49.375,30.915),(49.375,30.745),(49.205,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.745),(49.715,30.915),(49.885,30.915),(49.885,30.745),(49.715,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.405),(49.205,30.575),(49.375,30.575),(49.375,30.405),(49.205,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.405),(49.715,30.575),(49.885,30.575),(49.885,30.405),(49.715,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,30.065),(49.205,30.235),(49.375,30.235),(49.375,30.065),(49.205,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,30.065),(49.715,30.235),(49.885,30.235),(49.885,30.065),(49.715,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,15.445),(44.405,15.615),(44.575,15.615),(44.575,15.445),(44.405,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,4.905),(58.805,5.075),(58.975,5.075),(58.975,4.905),(58.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.005),(50.225,10.175),(50.395,10.175),(50.395,10.005),(50.225,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.345),(50.225,10.515),(50.395,10.515),(50.395,10.345),(50.225,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.825),(58.805,34.995),(58.975,34.995),(58.975,34.825),(58.805,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,10.685),(50.225,10.855),(50.395,10.855),(50.395,10.685),(50.225,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.145),(58.805,34.315),(58.975,34.315),(58.975,34.145),(58.805,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,34.485),(58.805,34.655),(58.975,34.655),(58.975,34.485),(58.805,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.005),(58.805,27.175),(58.975,27.175),(58.975,27.005),(58.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,21.905),(49.205,22.075),(49.375,22.075),(49.375,21.905),(49.205,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,21.905),(49.715,22.075),(49.885,22.075),(49.885,21.905),(49.715,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,31.085),(49.715,31.255),(49.885,31.255),(49.885,31.085),(49.715,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,4.905),(34.805,5.075),(34.975,5.075),(34.975,4.905),(34.805,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.725),(30.515,12.895),(30.685,12.895),(30.685,12.725),(30.515,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.045),(30.515,12.215),(30.685,12.215),(30.685,12.045),(30.515,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,12.385),(30.515,12.555),(30.685,12.555),(30.685,12.385),(30.515,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.125),(54.515,33.295),(54.685,33.295),(54.685,33.125),(54.515,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.465),(54.515,33.635),(54.685,33.635),(54.685,33.465),(54.515,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.465),(54.005,33.635),(54.175,33.635),(54.175,33.465),(54.005,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,4.905),(54.005,5.075),(54.175,5.075),(54.175,4.905),(54.005,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,4.905),(54.515,5.075),(54.685,5.075),(54.685,4.905),(54.515,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.125),(54.005,33.295),(54.175,33.295),(54.175,33.125),(54.005,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.265),(58.805,23.435),(58.975,23.435),(58.975,23.265),(58.805,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,23.605),(58.805,23.775),(58.975,23.775),(58.975,23.605),(58.805,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,33.805),(54.005,33.975),(54.175,33.975),(54.175,33.805),(54.005,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,33.805),(54.515,33.975),(54.685,33.975),(54.685,33.805),(54.515,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.285),(44.405,24.455),(44.575,24.455),(44.575,24.285),(44.405,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,24.625),(44.405,24.795),(44.575,24.795),(44.575,24.625),(44.405,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.185),(55.025,19.355),(55.195,19.355),(55.195,19.185),(55.025,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,19.525),(55.025,19.695),(55.195,19.695),(55.195,19.525),(55.025,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.805),(55.025,33.975),(55.195,33.975),(55.195,33.805),(55.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.125),(55.025,33.295),(55.195,33.295),(55.195,33.125),(55.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,33.465),(55.025,33.635),(55.195,33.635),(55.195,33.465),(55.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.265),(49.715,23.435),(49.885,23.435),(49.885,23.265),(49.715,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.605),(49.715,23.775),(49.885,23.775),(49.885,23.605),(49.715,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.605),(49.205,23.775),(49.375,23.775),(49.375,23.605),(49.205,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,7.965),(44.405,8.135),(44.575,8.135),(44.575,7.965),(44.405,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.265),(49.205,23.435),(49.375,23.435),(49.375,23.265),(49.205,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.025),(31.025,11.195),(31.195,11.195),(31.195,11.025),(31.025,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.365),(31.025,11.535),(31.195,11.535),(31.195,11.365),(31.025,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,11.705),(31.025,11.875),(31.195,11.875),(31.195,11.705),(31.025,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.705),(44.405,28.875),(44.575,28.875),(44.575,28.705),(44.405,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.025),(44.405,28.195),(44.575,28.195),(44.575,28.025),(44.405,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,28.365),(44.405,28.535),(44.575,28.535),(44.575,28.365),(44.405,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,18.845),(58.805,19.015),(58.975,19.015),(58.975,18.845),(58.805,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.725),(58.805,12.895),(58.975,12.895),(58.975,12.725),(58.805,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.385),(58.805,12.555),(58.975,12.555),(58.975,12.385),(58.805,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,12.045),(58.805,12.215),(58.975,12.215),(58.975,12.045),(58.805,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.625),(35.315,24.795),(35.485,24.795),(35.485,24.625),(35.315,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.625),(35.825,24.795),(35.995,24.795),(35.995,24.625),(35.825,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,24.285),(35.825,24.455),(35.995,24.455),(35.995,24.285),(35.825,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,24.285),(35.315,24.455),(35.485,24.455),(35.485,24.285),(35.315,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.205),(39.605,3.375),(39.775,3.375),(39.775,3.205),(39.605,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,3.545),(39.605,3.715),(39.775,3.715),(39.775,3.545),(39.605,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,3.885),(50.225,4.055),(50.395,4.055),(50.395,3.885),(50.225,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.245),(40.115,39.415),(40.285,39.415),(40.285,39.245),(40.115,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.585),(40.115,39.755),(40.285,39.755),(40.285,39.585),(40.115,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.585),(40.625,39.755),(40.795,39.755),(40.795,39.585),(40.625,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.245),(40.625,39.415),(40.795,39.415),(40.795,39.245),(40.625,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.545),(31.025,20.715),(31.195,20.715),(31.195,20.545),(31.025,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,20.205),(31.025,20.375),(31.195,20.375),(31.195,20.205),(31.025,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,23.945),(35.825,24.115),(35.995,24.115),(35.995,23.945),(35.825,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.945),(35.315,24.115),(35.485,24.115),(35.485,23.945),(35.315,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.125),(31.025,33.295),(31.195,33.295),(31.195,33.125),(31.025,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.465),(31.025,33.635),(31.195,33.635),(31.195,33.465),(31.025,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,33.805),(31.025,33.975),(31.195,33.975),(31.195,33.805),(31.025,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.325),(54.005,9.495),(54.175,9.495),(54.175,9.325),(54.005,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.325),(54.515,9.495),(54.685,9.495),(54.685,9.325),(54.515,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,9.665),(54.005,9.835),(54.175,9.835),(54.175,9.665),(54.005,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,9.665),(54.515,9.835),(54.685,9.835),(54.685,9.665),(54.515,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.485),(50.225,34.655),(50.395,34.655),(50.395,34.485),(50.225,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.145),(50.225,34.315),(50.395,34.315),(50.395,34.145),(50.225,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,34.825),(50.225,34.995),(50.395,34.995),(50.395,34.825),(50.225,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,23.945),(34.805,24.115),(34.975,24.115),(34.975,23.945),(34.805,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,6.945),(40.115,7.115),(40.285,7.115),(40.285,6.945),(40.115,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.105),(58.805,15.275),(58.975,15.275),(58.975,15.105),(58.805,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.445),(58.805,15.615),(58.975,15.615),(58.975,15.445),(58.805,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,15.785),(58.805,15.955),(58.975,15.955),(58.975,15.785),(58.805,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,24.965),(34.805,25.135),(34.975,25.135),(34.975,24.965),(34.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,6.945),(40.625,7.115),(40.795,7.115),(40.795,6.945),(40.625,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.325),(44.405,9.495),(44.575,9.495),(44.575,9.325),(44.405,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,9.665),(44.405,9.835),(44.575,9.835),(44.575,9.665),(44.405,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.305),(58.805,25.475),(58.975,25.475),(58.975,25.305),(58.805,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,25.645),(58.805,25.815),(58.975,25.815),(58.975,25.645),(58.805,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.645),(40.625,25.815),(40.795,25.815),(40.795,25.645),(40.625,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,25.305),(40.625,25.475),(40.795,25.475),(40.795,25.305),(40.625,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.305),(40.115,25.475),(40.285,25.475),(40.285,25.305),(40.115,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,25.645),(40.115,25.815),(40.285,25.815),(40.285,25.645),(40.115,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.225),(35.315,4.395),(35.485,4.395),(35.485,4.225),(35.315,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,4.565),(35.315,4.735),(35.485,4.735),(35.485,4.565),(35.315,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.225),(35.825,4.395),(35.995,4.395),(35.995,4.225),(35.825,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,4.565),(35.825,4.735),(35.995,4.735),(35.995,4.565),(35.825,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.165),(34.805,18.335),(34.975,18.335),(34.975,18.165),(34.805,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,18.505),(34.805,18.675),(34.975,18.675),(34.975,18.505),(34.805,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.905),(58.805,22.075),(58.975,22.075),(58.975,21.905),(58.805,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.065),(44.405,13.235),(44.575,13.235),(44.575,13.065),(44.405,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.405),(44.405,13.575),(44.575,13.575),(44.575,13.405),(44.405,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,13.745),(44.405,13.915),(44.575,13.915),(44.575,13.745),(44.405,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.285),(49.205,24.455),(49.375,24.455),(49.375,24.285),(49.205,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,24.625),(49.205,24.795),(49.375,24.795),(49.375,24.625),(49.205,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.285),(49.715,24.455),(49.885,24.455),(49.885,24.285),(49.715,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,24.625),(49.715,24.795),(49.885,24.795),(49.885,24.625),(49.715,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.165),(35.825,18.335),(35.995,18.335),(35.995,18.165),(35.825,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,18.505),(35.825,18.675),(35.995,18.675),(35.995,18.505),(35.825,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.165),(35.315,18.335),(35.485,18.335),(35.485,18.165),(35.315,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,18.505),(35.315,18.675),(35.485,18.675),(35.485,18.505),(35.315,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,26.325),(54.515,26.495),(54.685,26.495),(54.685,26.325),(54.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,26.325),(54.005,26.495),(54.175,26.495),(54.175,26.325),(54.005,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,26.665),(54.515,26.835),(54.685,26.835),(54.685,26.665),(54.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,26.665),(54.005,26.835),(54.175,26.835),(54.175,26.665),(54.005,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.565),(59.315,21.735),(59.485,21.735),(59.485,21.565),(59.315,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,21.225),(59.315,21.395),(59.485,21.395),(59.485,21.225),(59.315,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.685),(44.405,27.855),(44.575,27.855),(44.575,27.685),(44.405,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.005),(44.405,27.175),(44.575,27.175),(44.575,27.005),(44.405,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,27.345),(44.405,27.515),(44.575,27.515),(44.575,27.345),(44.405,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,40.265),(50.225,40.435),(50.395,40.435),(50.395,40.265),(50.225,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,40.605),(50.225,40.775),(50.395,40.775),(50.395,40.605),(50.225,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.825),(34.805,17.995),(34.975,17.995),(34.975,17.825),(34.805,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.145),(34.805,17.315),(34.975,17.315),(34.975,17.145),(34.805,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,17.485),(34.805,17.655),(34.975,17.655),(34.975,17.485),(34.805,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.765),(44.915,14.935),(45.085,14.935),(45.085,14.765),(44.915,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.085),(44.915,14.255),(45.085,14.255),(45.085,14.085),(44.915,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,14.425),(44.915,14.595),(45.085,14.595),(45.085,14.425),(44.915,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.285),(31.025,7.455),(31.195,7.455),(31.195,7.285),(31.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,7.625),(31.025,7.795),(31.195,7.795),(31.195,7.625),(31.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,2.865),(55.025,3.035),(55.195,3.035),(55.195,2.865),(55.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.225),(50.225,4.395),(50.395,4.395),(50.395,4.225),(50.225,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,4.565),(50.225,4.735),(50.395,4.735),(50.395,4.565),(50.225,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.045),(55.025,29.215),(55.195,29.215),(55.195,29.045),(55.025,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.725),(55.025,29.895),(55.195,29.895),(55.195,29.725),(55.025,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,29.385),(55.025,29.555),(55.195,29.555),(55.195,29.385),(55.025,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.205),(50.225,37.375),(50.395,37.375),(50.395,37.205),(50.225,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,37.545),(50.225,37.715),(50.395,37.715),(50.395,37.545),(50.225,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.325),(39.605,9.495),(39.775,9.495),(39.775,9.325),(39.605,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,9.665),(39.605,9.835),(39.775,9.835),(39.775,9.665),(39.605,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,39.925),(40.115,40.095),(40.285,40.095),(40.285,39.925),(40.115,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,39.925),(40.625,40.095),(40.795,40.095),(40.795,39.925),(40.625,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,19.865),(44.405,20.035),(44.575,20.035),(44.575,19.865),(44.405,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.765),(59.315,14.935),(59.485,14.935),(59.485,14.765),(59.315,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.085),(59.315,14.255),(59.485,14.255),(59.485,14.085),(59.315,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,14.425),(59.315,14.595),(59.485,14.595),(59.485,14.425),(59.315,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.285),(55.025,7.455),(55.195,7.455),(55.195,7.285),(55.025,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,7.625),(55.025,7.795),(55.195,7.795),(55.195,7.625),(55.025,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.285),(30.515,24.455),(30.685,24.455),(30.685,24.285),(30.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,24.625),(30.515,24.795),(30.685,24.795),(30.685,24.625),(30.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.725),(59.315,29.895),(59.485,29.895),(59.485,29.725),(59.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.385),(59.315,29.555),(59.485,29.555),(59.485,29.385),(59.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,29.045),(59.315,29.215),(59.485,29.215),(59.485,29.045),(59.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.065),(39.605,13.235),(39.775,13.235),(39.775,13.065),(39.605,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.405),(39.605,13.575),(39.775,13.575),(39.775,13.405),(39.605,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,13.745),(39.605,13.915),(39.775,13.915),(39.775,13.745),(39.605,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,20.885),(35.825,21.055),(35.995,21.055),(35.995,20.885),(35.825,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,20.885),(35.315,21.055),(35.485,21.055),(35.485,20.885),(35.315,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.525),(30.515,19.695),(30.685,19.695),(30.685,19.525),(30.515,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.185),(30.515,19.355),(30.685,19.355),(30.685,19.185),(30.515,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.205),(30.515,20.375),(30.685,20.375),(30.685,20.205),(30.515,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,20.545),(30.515,20.715),(30.685,20.715),(30.685,20.545),(30.515,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.145),(44.405,17.315),(44.575,17.315),(44.575,17.145),(44.405,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.485),(44.405,17.655),(44.575,17.655),(44.575,17.485),(44.405,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,17.825),(44.405,17.995),(44.575,17.995),(44.575,17.825),(44.405,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,2.865),(31.025,3.035),(31.195,3.035),(31.195,2.865),(31.025,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.625),(50.225,7.795),(50.395,7.795),(50.395,7.625),(50.225,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,7.285),(50.225,7.455),(50.395,7.455),(50.395,7.285),(50.225,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,38.905),(50.225,39.075),(50.395,39.075),(50.395,38.905),(50.225,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,40.265),(31.025,40.435),(31.195,40.435),(31.195,40.265),(31.025,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,40.605),(31.025,40.775),(31.195,40.775),(31.195,40.605),(31.025,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.705),(58.805,11.875),(58.975,11.875),(58.975,11.705),(58.805,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.685),(58.805,10.855),(58.975,10.855),(58.975,10.685),(58.805,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.765),(34.805,14.935),(34.975,14.935),(34.975,14.765),(34.805,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.005),(58.805,10.175),(58.975,10.175),(58.975,10.005),(58.805,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,10.345),(58.805,10.515),(58.975,10.515),(58.975,10.345),(58.805,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.085),(34.805,14.255),(34.975,14.255),(34.975,14.085),(34.805,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,14.425),(34.805,14.595),(34.975,14.595),(34.975,14.425),(34.805,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.765),(31.025,31.935),(31.195,31.935),(31.195,31.765),(31.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.425),(31.025,31.595),(31.195,31.595),(31.195,31.425),(31.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,31.085),(31.025,31.255),(31.195,31.255),(31.195,31.085),(31.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,2.865),(45.425,3.035),(45.595,3.035),(45.595,2.865),(45.425,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,26.665),(39.605,26.835),(39.775,26.835),(39.775,26.665),(39.605,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,26.325),(39.605,26.495),(39.775,26.495),(39.775,26.325),(39.605,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.425),(54.515,14.595),(54.685,14.595),(54.685,14.425),(54.515,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.085),(54.515,14.255),(54.685,14.255),(54.685,14.085),(54.515,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,14.765),(54.515,14.935),(54.685,14.935),(54.685,14.765),(54.515,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.765),(54.005,14.935),(54.175,14.935),(54.175,14.765),(54.005,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.085),(54.005,14.255),(54.175,14.255),(54.175,14.085),(54.005,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,14.425),(54.005,14.595),(54.175,14.595),(54.175,14.425),(54.005,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.685),(34.805,27.855),(34.975,27.855),(34.975,27.685),(34.805,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.345),(34.805,27.515),(34.975,27.515),(34.975,27.345),(34.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.165),(35.315,35.335),(35.485,35.335),(35.485,35.165),(35.315,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,35.505),(35.315,35.675),(35.485,35.675),(35.485,35.505),(35.315,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.505),(35.825,35.675),(35.995,35.675),(35.995,35.505),(35.825,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,27.005),(34.805,27.175),(34.975,27.175),(34.975,27.005),(34.805,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,35.165),(35.825,35.335),(35.995,35.335),(35.995,35.165),(35.825,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.985),(30.515,26.155),(30.685,26.155),(30.685,25.985),(30.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,5.925),(45.425,6.095),(45.595,6.095),(45.595,5.925),(45.425,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.305),(44.915,8.475),(45.085,8.475),(45.085,8.305),(44.915,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,8.645),(44.915,8.815),(45.085,8.815),(45.085,8.645),(44.915,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,2.865),(50.225,3.035),(50.395,3.035),(50.395,2.865),(50.225,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.745),(39.605,30.915),(39.775,30.915),(39.775,30.745),(39.605,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.065),(39.605,30.235),(39.775,30.235),(39.775,30.065),(39.605,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,30.405),(39.605,30.575),(39.775,30.575),(39.775,30.405),(39.605,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.445),(44.915,15.615),(45.085,15.615),(45.085,15.445),(44.915,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.785),(44.915,15.955),(45.085,15.955),(45.085,15.785),(44.915,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,15.105),(44.915,15.275),(45.085,15.275),(45.085,15.105),(44.915,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,26.325),(49.205,26.495),(49.375,26.495),(49.375,26.325),(49.205,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,26.325),(49.715,26.495),(49.885,26.495),(49.885,26.325),(49.715,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.685),(31.025,10.855),(31.195,10.855),(31.195,10.685),(31.025,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,26.665),(49.205,26.835),(49.375,26.835),(49.375,26.665),(49.205,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,26.665),(49.715,26.835),(49.885,26.835),(49.885,26.665),(49.715,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.005),(31.025,10.175),(31.195,10.175),(31.195,10.005),(31.025,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,10.345),(31.025,10.515),(31.195,10.515),(31.195,10.345),(31.025,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.565),(54.005,21.735),(54.175,21.735),(54.175,21.565),(54.005,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.565),(54.515,21.735),(54.685,21.735),(54.685,21.565),(54.515,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,21.225),(54.005,21.395),(54.175,21.395),(54.175,21.225),(54.005,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,21.225),(54.515,21.395),(54.685,21.395),(54.685,21.225),(54.515,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.285),(45.425,7.455),(45.595,7.455),(45.595,7.285),(45.425,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,7.625),(45.425,7.795),(45.595,7.795),(45.595,7.625),(45.425,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,2.865),(54.005,3.035),(54.175,3.035),(54.175,2.865),(54.005,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.045),(44.915,12.215),(45.085,12.215),(45.085,12.045),(44.915,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.385),(44.915,12.555),(45.085,12.555),(45.085,12.385),(44.915,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,12.725),(44.915,12.895),(45.085,12.895),(45.085,12.725),(44.915,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.025),(55.025,28.195),(55.195,28.195),(55.195,28.025),(55.025,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.365),(55.025,28.535),(55.195,28.535),(55.195,28.365),(55.025,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,28.705),(55.025,28.875),(55.195,28.875),(55.195,28.705),(55.025,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.265),(39.605,23.435),(39.775,23.435),(39.775,23.265),(39.605,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,23.605),(39.605,23.775),(39.775,23.775),(39.775,23.605),(39.605,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.145),(45.425,17.315),(45.595,17.315),(45.595,17.145),(45.425,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.485),(45.425,17.655),(45.595,17.655),(45.595,17.485),(45.425,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,17.825),(45.425,17.995),(45.595,17.995),(45.595,17.825),(45.425,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.165),(34.805,35.335),(34.975,35.335),(34.975,35.165),(34.805,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,23.945),(30.515,24.115),(30.685,24.115),(30.685,23.945),(30.515,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.505),(34.805,35.675),(34.975,35.675),(34.975,35.505),(34.805,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,26.665),(44.915,26.835),(45.085,26.835),(45.085,26.665),(44.915,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,26.325),(44.915,26.495),(45.085,26.495),(45.085,26.325),(44.915,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,2.865),(59.315,3.035),(59.485,3.035),(59.485,2.865),(59.315,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.065),(50.225,13.235),(50.395,13.235),(50.395,13.065),(50.225,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.405),(50.225,13.575),(50.395,13.575),(50.395,13.405),(50.225,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,13.745),(50.225,13.915),(50.395,13.915),(50.395,13.745),(50.225,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,6.945),(39.605,7.115),(39.775,7.115),(39.775,6.945),(39.605,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.185),(31.025,36.355),(31.195,36.355),(31.195,36.185),(31.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,36.525),(31.025,36.695),(31.195,36.695),(31.195,36.525),(31.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.265),(55.025,6.435),(55.195,6.435),(55.195,6.265),(55.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,6.605),(55.025,6.775),(55.195,6.775),(55.195,6.605),(55.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,35.845),(39.605,36.015),(39.775,36.015),(39.775,35.845),(39.605,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,4.905),(44.915,5.075),(45.085,5.075),(45.085,4.905),(44.915,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,19.865),(30.515,20.035),(30.685,20.035),(30.685,19.865),(30.515,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,18.845),(44.915,19.015),(45.085,19.015),(45.085,18.845),(44.915,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,26.325),(59.315,26.495),(59.485,26.495),(59.485,26.325),(59.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,26.665),(59.315,26.835),(59.485,26.835),(59.485,26.665),(59.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.745),(40.115,30.915),(40.285,30.915),(40.285,30.745),(40.115,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.405),(40.625,30.575),(40.795,30.575),(40.795,30.405),(40.625,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,30.065),(40.625,30.235),(40.795,30.235),(40.795,30.065),(40.625,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.405),(40.115,30.575),(40.285,30.575),(40.285,30.405),(40.115,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,30.065),(40.115,30.235),(40.285,30.235),(40.285,30.065),(40.115,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.165),(40.115,35.335),(40.285,35.335),(40.285,35.165),(40.115,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.165),(40.625,35.335),(40.795,35.335),(40.795,35.165),(40.625,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,35.505),(40.625,35.675),(40.795,35.675),(40.795,35.505),(40.625,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,35.505),(40.115,35.675),(40.285,35.675),(40.285,35.505),(40.115,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.565),(45.425,21.735),(45.595,21.735),(45.595,21.565),(45.425,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,21.225),(45.425,21.395),(45.595,21.395),(45.595,21.225),(45.425,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,27.345),(58.805,27.515),(58.975,27.515),(58.975,27.345),(58.805,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.725),(35.315,29.895),(35.485,29.895),(35.485,29.725),(35.315,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.725),(35.825,29.895),(35.995,29.895),(35.995,29.725),(35.825,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.385),(35.825,29.555),(35.995,29.555),(35.995,29.385),(35.825,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,29.045),(35.825,29.215),(35.995,29.215),(35.995,29.045),(35.825,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.045),(35.315,29.215),(35.485,29.215),(35.485,29.045),(35.315,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,29.385),(35.315,29.555),(35.485,29.555),(35.485,29.385),(35.315,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.185),(55.025,36.355),(55.195,36.355),(55.195,36.185),(55.025,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,36.525),(55.025,36.695),(55.195,36.695),(55.195,36.525),(55.025,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.585),(49.715,22.755),(49.885,22.755),(49.885,22.585),(49.715,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.245),(49.205,22.415),(49.375,22.415),(49.375,22.245),(49.205,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,22.245),(49.715,22.415),(49.885,22.415),(49.885,22.245),(49.715,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,22.585),(49.205,22.755),(49.375,22.755),(49.375,22.585),(49.205,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.805),(44.915,16.975),(45.085,16.975),(45.085,16.805),(44.915,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.125),(44.915,16.295),(45.085,16.295),(45.085,16.125),(44.915,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,16.465),(44.915,16.635),(45.085,16.635),(45.085,16.465),(44.915,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.265),(31.025,6.435),(31.195,6.435),(31.195,6.265),(31.025,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,6.605),(31.025,6.775),(31.195,6.775),(31.195,6.605),(31.025,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,2.865),(49.715,3.035),(49.885,3.035),(49.885,2.865),(49.715,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,2.865),(49.205,3.035),(49.375,3.035),(49.375,2.865),(49.205,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,7.965),(59.315,8.135),(59.485,8.135),(59.485,7.965),(59.315,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,35.845),(59.315,36.015),(59.485,36.015),(59.485,35.845),(59.315,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,37.885),(39.605,38.055),(39.775,38.055),(39.775,37.885),(39.605,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.225),(44.915,38.395),(45.085,38.395),(45.085,38.225),(44.915,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,38.565),(44.915,38.735),(45.085,38.735),(45.085,38.565),(44.915,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,8.985),(39.605,9.155),(39.775,9.155),(39.775,8.985),(39.605,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,26.665),(40.625,26.835),(40.795,26.835),(40.795,26.665),(40.625,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.265),(45.425,6.435),(45.595,6.435),(45.595,6.265),(45.425,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,6.605),(45.425,6.775),(45.595,6.775),(45.595,6.605),(45.425,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.405),(30.515,13.575),(30.685,13.575),(30.685,13.405),(30.515,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.065),(30.515,13.235),(30.685,13.235),(30.685,13.065),(30.515,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,13.745),(30.515,13.915),(30.685,13.915),(30.685,13.745),(30.515,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.305),(55.025,8.475),(55.195,8.475),(55.195,8.305),(55.025,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,8.645),(55.025,8.815),(55.195,8.815),(55.195,8.645),(55.025,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.745),(44.915,13.915),(45.085,13.915),(45.085,13.745),(44.915,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.065),(44.915,13.235),(45.085,13.235),(45.085,13.065),(44.915,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,13.405),(44.915,13.575),(45.085,13.575),(45.085,13.405),(44.915,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,5.925),(59.315,6.095),(59.485,6.095),(59.485,5.925),(59.315,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.585),(34.805,22.755),(34.975,22.755),(34.975,22.585),(34.805,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,22.245),(34.805,22.415),(34.975,22.415),(34.975,22.245),(34.805,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,22.925),(44.915,23.095),(45.085,23.095),(45.085,22.925),(44.915,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,21.905),(44.915,22.075),(45.085,22.075),(45.085,21.905),(44.915,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.245),(40.625,22.415),(40.795,22.415),(40.795,22.245),(40.625,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.245),(40.115,22.415),(40.285,22.415),(40.285,22.245),(40.115,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.045),(45.425,29.215),(45.595,29.215),(45.595,29.045),(45.425,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.385),(45.425,29.555),(45.595,29.555),(45.595,29.385),(45.425,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.645),(34.805,8.815),(34.975,8.815),(34.975,8.645),(34.805,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,38.905),(59.315,39.075),(59.485,39.075),(59.485,38.905),(59.315,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,8.305),(34.805,8.475),(34.975,8.475),(34.975,8.305),(34.805,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,22.585),(40.625,22.755),(40.795,22.755),(40.795,22.585),(40.625,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,22.585),(40.115,22.755),(40.285,22.755),(40.285,22.585),(40.115,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,29.725),(45.425,29.895),(45.595,29.895),(45.595,29.725),(45.425,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,22.925),(31.025,23.095),(31.195,23.095),(31.195,22.925),(31.025,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.185),(39.605,36.355),(39.775,36.355),(39.775,36.185),(39.605,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,36.525),(39.605,36.695),(39.775,36.695),(39.775,36.525),(39.605,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,2.865),(44.405,3.035),(44.575,3.035),(44.575,2.865),(44.405,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,35.845),(34.805,36.015),(34.975,36.015),(34.975,35.845),(34.805,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,24.965),(58.805,25.135),(58.975,25.135),(58.975,24.965),(58.805,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.345),(54.515,27.515),(54.685,27.515),(54.685,27.345),(54.515,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.685),(54.515,27.855),(54.685,27.855),(54.685,27.685),(54.515,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.685),(54.005,27.855),(54.175,27.855),(54.175,27.685),(54.005,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.005),(54.005,27.175),(54.175,27.175),(54.175,27.005),(54.005,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,27.005),(54.515,27.175),(54.685,27.175),(54.685,27.005),(54.515,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,27.345),(54.005,27.515),(54.175,27.515),(54.175,27.345),(54.005,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,40.265),(30.515,40.435),(30.685,40.435),(30.685,40.265),(30.515,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,40.605),(30.515,40.775),(30.685,40.775),(30.685,40.605),(30.515,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.665),(35.825,9.835),(35.995,9.835),(35.995,9.665),(35.825,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.725),(49.715,29.895),(49.885,29.895),(49.885,29.725),(49.715,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.665),(35.315,9.835),(35.485,9.835),(35.485,9.665),(35.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,9.325),(35.825,9.495),(35.995,9.495),(35.995,9.325),(35.825,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,9.325),(35.315,9.495),(35.485,9.495),(35.485,9.325),(35.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.045),(49.205,29.215),(49.375,29.215),(49.375,29.045),(49.205,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.385),(49.205,29.555),(49.375,29.555),(49.375,29.385),(49.205,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.045),(49.715,29.215),(49.885,29.215),(49.885,29.045),(49.715,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,29.385),(49.715,29.555),(49.885,29.555),(49.885,29.385),(49.715,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,23.265),(35.315,23.435),(35.485,23.435),(35.485,23.265),(35.315,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,20.885),(40.625,21.055),(40.795,21.055),(40.795,20.885),(40.625,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,20.885),(40.115,21.055),(40.285,21.055),(40.285,20.885),(40.115,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.185),(54.515,36.355),(54.685,36.355),(54.685,36.185),(54.515,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,36.525),(54.515,36.695),(54.685,36.695),(54.685,36.525),(54.515,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.525),(54.005,36.695),(54.175,36.695),(54.175,36.525),(54.005,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,36.185),(54.005,36.355),(54.175,36.355),(54.175,36.185),(54.005,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.745),(50.225,30.915),(50.395,30.915),(50.395,30.745),(50.225,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.065),(50.225,30.235),(50.395,30.235),(50.395,30.065),(50.225,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,30.405),(50.225,30.575),(50.395,30.575),(50.395,30.405),(50.225,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.505),(30.515,35.675),(30.685,35.675),(30.685,35.505),(30.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.165),(30.515,35.335),(30.685,35.335),(30.685,35.165),(30.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.105),(49.205,15.275),(49.375,15.275),(49.375,15.105),(49.205,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.445),(49.205,15.615),(49.375,15.615),(49.375,15.445),(49.205,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.105),(49.715,15.275),(49.885,15.275),(49.885,15.105),(49.715,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.445),(49.715,15.615),(49.885,15.615),(49.885,15.445),(49.715,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,15.785),(49.715,15.955),(49.885,15.955),(49.885,15.785),(49.715,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,15.785),(49.205,15.955),(49.375,15.955),(49.375,15.785),(49.205,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,6.945),(30.515,7.115),(30.685,7.115),(30.685,6.945),(30.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,6.945),(35.315,7.115),(35.485,7.115),(35.485,6.945),(35.315,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,6.945),(35.825,7.115),(35.995,7.115),(35.995,6.945),(35.825,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.205),(45.425,20.375),(45.595,20.375),(45.595,20.205),(45.425,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,20.545),(45.425,20.715),(45.595,20.715),(45.595,20.545),(45.425,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.065),(31.025,30.235),(31.195,30.235),(31.195,30.065),(31.025,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.405),(31.025,30.575),(31.195,30.575),(31.195,30.405),(31.025,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,30.745),(31.025,30.915),(31.195,30.915),(31.195,30.745),(31.025,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.185),(49.715,36.355),(49.885,36.355),(49.885,36.185),(49.715,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,36.525),(49.715,36.695),(49.885,36.695),(49.885,36.525),(49.715,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.525),(49.205,36.695),(49.375,36.695),(49.375,36.525),(49.205,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,36.185),(49.205,36.355),(49.375,36.355),(49.375,36.185),(49.205,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,21.905),(50.225,22.075),(50.395,22.075),(50.395,21.905),(50.225,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.205),(59.315,20.375),(59.485,20.375),(59.485,20.205),(59.315,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,20.545),(59.315,20.715),(59.485,20.715),(59.485,20.545),(59.315,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.505),(31.025,18.675),(31.195,18.675),(31.195,18.505),(31.025,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,18.165),(31.025,18.335),(31.195,18.335),(31.195,18.165),(31.025,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.225),(58.805,21.395),(58.975,21.395),(58.975,21.225),(58.805,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,21.565),(58.805,21.735),(58.975,21.735),(58.975,21.565),(58.805,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.365),(40.625,28.535),(40.795,28.535),(40.795,28.365),(40.625,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.025),(40.625,28.195),(40.795,28.195),(40.795,28.025),(40.625,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.025),(40.115,28.195),(40.285,28.195),(40.285,28.025),(40.115,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.365),(40.115,28.535),(40.285,28.535),(40.285,28.365),(40.115,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,28.705),(40.115,28.875),(40.285,28.875),(40.285,28.705),(40.115,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,28.705),(40.625,28.875),(40.795,28.875),(40.795,28.705),(40.625,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,6.945),(58.805,7.115),(58.975,7.115),(58.975,6.945),(58.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,25.985),(39.605,26.155),(39.775,26.155),(39.775,25.985),(39.605,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,38.905),(49.715,39.075),(49.885,39.075),(49.885,38.905),(49.715,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,38.905),(49.205,39.075),(49.375,39.075),(49.375,38.905),(49.205,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,6.945),(34.805,7.115),(34.975,7.115),(34.975,6.945),(34.805,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.185),(44.915,36.355),(45.085,36.355),(45.085,36.185),(44.915,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,36.525),(44.915,36.695),(45.085,36.695),(45.085,36.525),(44.915,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,21.905),(40.625,22.075),(40.795,22.075),(40.795,21.905),(40.625,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,21.905),(40.115,22.075),(40.285,22.075),(40.285,21.905),(40.115,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,26.325),(35.315,26.495),(35.485,26.495),(35.485,26.325),(35.315,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,26.325),(35.825,26.495),(35.995,26.495),(35.995,26.325),(35.825,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,26.665),(35.315,26.835),(35.485,26.835),(35.485,26.665),(35.315,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,26.665),(35.825,26.835),(35.995,26.835),(35.995,26.665),(35.825,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.505),(54.515,35.675),(54.685,35.675),(54.685,35.505),(54.515,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,6.945),(54.515,7.115),(54.685,7.115),(54.685,6.945),(54.515,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.165),(54.005,35.335),(54.175,35.335),(54.175,35.165),(54.005,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.505),(54.005,35.675),(54.175,35.675),(54.175,35.505),(54.005,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.165),(54.515,35.335),(54.685,35.335),(54.685,35.165),(54.515,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,6.945),(54.005,7.115),(54.175,7.115),(54.175,6.945),(54.005,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.165),(31.025,35.335),(31.195,35.335),(31.195,35.165),(31.025,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,35.505),(31.025,35.675),(31.195,35.675),(31.195,35.505),(31.025,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,19.865),(59.315,20.035),(59.485,20.035),(59.485,19.865),(59.315,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.625),(45.425,24.795),(45.595,24.795),(45.595,24.625),(45.425,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,24.285),(45.425,24.455),(45.595,24.455),(45.595,24.285),(45.425,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.285),(40.115,7.455),(40.285,7.455),(40.285,7.285),(40.115,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.625),(40.115,7.795),(40.285,7.795),(40.285,7.625),(40.115,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.285),(40.625,7.455),(40.795,7.455),(40.795,7.285),(40.625,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.625),(40.625,7.795),(40.795,7.795),(40.795,7.625),(40.625,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.705),(50.225,11.875),(50.395,11.875),(50.395,11.705),(50.225,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.025),(50.225,11.195),(50.395,11.195),(50.395,11.025),(50.225,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,11.365),(50.225,11.535),(50.395,11.535),(50.395,11.365),(50.225,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,25.985),(54.005,26.155),(54.175,26.155),(54.175,25.985),(54.005,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,25.985),(54.515,26.155),(54.685,26.155),(54.685,25.985),(54.515,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.165),(45.425,35.335),(45.595,35.335),(45.595,35.165),(45.425,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,35.505),(45.425,35.675),(45.595,35.675),(45.595,35.505),(45.425,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.025),(45.425,28.195),(45.595,28.195),(45.595,28.025),(45.425,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.365),(45.425,28.535),(45.595,28.535),(45.595,28.365),(45.425,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,29.725),(49.205,29.895),(49.375,29.895),(49.375,29.725),(49.205,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,28.705),(45.425,28.875),(45.595,28.875),(45.595,28.705),(45.425,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,39.925),(30.515,40.095),(30.685,40.095),(30.685,39.925),(30.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,37.885),(35.315,38.055),(35.485,38.055),(35.485,37.885),(35.315,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,37.885),(35.825,38.055),(35.995,38.055),(35.995,37.885),(35.825,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.225),(40.625,38.395),(40.795,38.395),(40.795,38.225),(40.625,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.225),(40.115,38.395),(40.285,38.395),(40.285,38.225),(40.115,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,38.565),(40.115,38.735),(40.285,38.735),(40.285,38.565),(40.115,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,38.565),(40.625,38.735),(40.795,38.735),(40.795,38.565),(40.625,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,35.845),(44.405,36.015),(44.575,36.015),(44.575,35.845),(44.405,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.025),(59.315,28.195),(59.485,28.195),(59.485,28.025),(59.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.365),(59.315,28.535),(59.485,28.535),(59.485,28.365),(59.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,28.705),(59.315,28.875),(59.485,28.875),(59.485,28.705),(59.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,28.705),(44.915,28.875),(45.085,28.875),(45.085,28.705),(44.915,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.725),(39.605,12.895),(39.775,12.895),(39.775,12.725),(39.605,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.385),(39.605,12.555),(39.775,12.555),(39.775,12.385),(39.605,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,12.045),(39.605,12.215),(39.775,12.215),(39.775,12.045),(39.605,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.745),(58.805,13.915),(58.975,13.915),(58.975,13.745),(58.805,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.065),(58.805,13.235),(58.975,13.235),(58.975,13.065),(58.805,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,13.405),(58.805,13.575),(58.975,13.575),(58.975,13.405),(58.805,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.765),(45.425,31.935),(45.595,31.935),(45.595,31.765),(45.425,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.085),(45.425,31.255),(45.595,31.255),(45.595,31.085),(45.425,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,31.425),(45.425,31.595),(45.595,31.595),(45.595,31.425),(45.425,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.765),(34.805,31.935),(34.975,31.935),(34.975,31.765),(34.805,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.085),(34.805,31.255),(34.975,31.255),(34.975,31.085),(34.805,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,31.425),(34.805,31.595),(34.975,31.595),(34.975,31.425),(34.805,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,36.865),(40.115,37.035),(40.285,37.035),(40.285,36.865),(40.115,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,36.865),(40.625,37.035),(40.795,37.035),(40.795,36.865),(40.625,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,19.865),(49.205,20.035),(49.375,20.035),(49.375,19.865),(49.205,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.805),(44.405,33.975),(44.575,33.975),(44.575,33.805),(44.405,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,37.885),(54.515,38.055),(54.685,38.055),(54.685,37.885),(54.515,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.525),(35.315,36.695),(35.485,36.695),(35.485,36.525),(35.315,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,36.185),(35.315,36.355),(35.485,36.355),(35.485,36.185),(35.315,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,37.885),(54.005,38.055),(54.175,38.055),(54.175,37.885),(54.005,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.185),(35.825,36.355),(35.995,36.355),(35.995,36.185),(35.825,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,36.525),(35.825,36.695),(35.995,36.695),(35.995,36.525),(35.825,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.465),(44.405,33.635),(44.575,33.635),(44.575,33.465),(44.405,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,33.125),(44.405,33.295),(44.575,33.295),(44.575,33.125),(44.405,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.705),(54.515,28.875),(54.685,28.875),(54.685,28.705),(54.515,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.705),(54.005,28.875),(54.175,28.875),(54.175,28.705),(54.005,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.025),(54.005,28.195),(54.175,28.195),(54.175,28.025),(54.005,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,28.365),(54.005,28.535),(54.175,28.535),(54.175,28.365),(54.005,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.025),(54.515,28.195),(54.685,28.195),(54.685,28.025),(54.515,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,28.365),(54.515,28.535),(54.685,28.535),(54.685,28.365),(54.515,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.265),(44.405,6.435),(44.575,6.435),(44.575,6.265),(44.405,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,6.605),(44.405,6.775),(44.575,6.775),(44.575,6.605),(44.405,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,35.845),(30.515,36.015),(30.685,36.015),(30.685,35.845),(30.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,39.925),(54.005,40.095),(54.175,40.095),(54.175,39.925),(54.005,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,39.925),(54.515,40.095),(54.685,40.095),(54.685,39.925),(54.515,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.245),(34.805,39.415),(34.975,39.415),(34.975,39.245),(34.805,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,39.585),(34.805,39.755),(34.975,39.755),(34.975,39.585),(34.805,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.645),(40.625,8.815),(40.795,8.815),(40.795,8.645),(40.625,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,8.305),(40.625,8.475),(40.795,8.475),(40.795,8.305),(40.625,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.645),(40.115,8.815),(40.285,8.815),(40.285,8.645),(40.115,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,8.305),(40.115,8.475),(40.285,8.475),(40.285,8.305),(40.115,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.065),(40.625,13.235),(40.795,13.235),(40.795,13.065),(40.625,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.405),(40.625,13.575),(40.795,13.575),(40.795,13.405),(40.625,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.065),(40.115,13.235),(40.285,13.235),(40.285,13.065),(40.115,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.405),(40.115,13.575),(40.285,13.575),(40.285,13.405),(40.115,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,13.745),(40.625,13.915),(40.795,13.915),(40.795,13.745),(40.625,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,13.745),(40.115,13.915),(40.285,13.915),(40.285,13.745),(40.115,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.625),(54.005,24.795),(54.175,24.795),(54.175,24.625),(54.005,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,24.285),(54.005,24.455),(54.175,24.455),(54.175,24.285),(54.005,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.285),(54.515,24.455),(54.685,24.455),(54.685,24.285),(54.515,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,24.625),(54.515,24.795),(54.685,24.795),(54.685,24.625),(54.515,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((58.805,11.365),(58.805,11.535),(58.975,11.535),(58.975,11.365),(58.805,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,25.985),(59.315,26.155),(59.485,26.155),(59.485,25.985),(59.315,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,4.905),(44.405,5.075),(44.575,5.075),(44.575,4.905),(44.405,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,18.845),(40.115,19.015),(40.285,19.015),(40.285,18.845),(40.115,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,18.845),(40.625,19.015),(40.795,19.015),(40.795,18.845),(40.625,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.305),(30.515,25.475),(30.685,25.475),(30.685,25.305),(30.515,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,25.645),(30.515,25.815),(30.685,25.815),(30.685,25.645),(30.515,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.505),(39.605,18.675),(39.775,18.675),(39.775,18.505),(39.605,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,18.165),(39.605,18.335),(39.775,18.335),(39.775,18.165),(39.605,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,23.945),(49.715,24.115),(49.885,24.115),(49.885,23.945),(49.715,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,23.945),(49.205,24.115),(49.375,24.115),(49.375,23.945),(49.205,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.685),(44.405,10.855),(44.575,10.855),(44.575,10.685),(44.405,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.005),(44.405,10.175),(44.575,10.175),(44.575,10.005),(44.405,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,10.345),(44.405,10.515),(44.575,10.515),(44.575,10.345),(44.405,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,26.665),(40.115,26.835),(40.285,26.835),(40.285,26.665),(40.115,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,26.325),(40.625,26.495),(40.795,26.495),(40.795,26.325),(40.625,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,26.325),(40.115,26.495),(40.285,26.495),(40.285,26.325),(40.115,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,35.845),(54.515,36.015),(54.685,36.015),(54.685,35.845),(54.515,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,35.845),(54.005,36.015),(54.175,36.015),(54.175,35.845),(54.005,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.625),(50.225,24.795),(50.395,24.795),(50.395,24.625),(50.225,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,22.585),(39.605,22.755),(39.775,22.755),(39.775,22.585),(39.605,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,24.285),(50.225,24.455),(50.395,24.455),(50.395,24.285),(50.225,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.765),(55.025,31.935),(55.195,31.935),(55.195,31.765),(55.025,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.085),(55.025,31.255),(55.195,31.255),(55.195,31.085),(55.025,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,31.425),(55.025,31.595),(55.195,31.595),(55.195,31.425),(55.025,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.705),(39.605,11.875),(39.775,11.875),(39.775,11.705),(39.605,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((54.515,8.985),(54.515,9.155),(54.685,9.155),(54.685,8.985),(54.515,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((54.005,8.985),(54.005,9.155),(54.175,9.155),(54.175,8.985),(54.005,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.025),(39.605,11.195),(39.775,11.195),(39.775,11.025),(39.605,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((39.605,11.365),(39.605,11.535),(39.775,11.535),(39.775,11.365),(39.605,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,7.965),(40.115,8.135),(40.285,8.135),(40.285,7.965),(40.115,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,7.965),(40.625,8.135),(40.795,8.135),(40.795,7.965),(40.625,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.165),(49.715,18.335),(49.885,18.335),(49.885,18.165),(49.715,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.165),(49.205,18.335),(49.375,18.335),(49.375,18.165),(49.205,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((49.715,18.505),(49.715,18.675),(49.885,18.675),(49.885,18.505),(49.715,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((49.205,18.505),(49.205,18.675),(49.375,18.675),(49.375,18.505),(49.205,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.325),(59.315,9.495),(59.485,9.495),(59.485,9.325),(59.315,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,9.665),(59.315,9.835),(59.485,9.835),(59.485,9.665),(59.315,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.185),(34.805,19.355),(34.975,19.355),(34.975,19.185),(34.805,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((34.805,19.525),(34.805,19.695),(34.975,19.695),(34.975,19.525),(34.805,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.245),(31.025,5.415),(31.195,5.415),(31.195,5.245),(31.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,5.585),(31.025,5.755),(31.195,5.755),(31.195,5.585),(31.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,26.325),(45.425,26.495),(45.595,26.495),(45.595,26.325),(45.425,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,26.665),(45.425,26.835),(45.595,26.835),(45.595,26.665),(45.425,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,18.845),(30.515,19.015),(30.685,19.015),(30.685,18.845),(30.515,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.765),(59.315,31.935),(59.485,31.935),(59.485,31.765),(59.315,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.085),(59.315,31.255),(59.485,31.255),(59.485,31.085),(59.315,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.745),(30.515,30.915),(30.685,30.915),(30.685,30.745),(30.515,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((31.025,38.905),(31.025,39.075),(31.195,39.075),(31.195,38.905),(31.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.405),(30.515,30.575),(30.685,30.575),(30.685,30.405),(30.515,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,30.065),(30.515,30.235),(30.685,30.235),(30.685,30.065),(30.515,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((59.315,31.425),(59.315,31.595),(59.485,31.595),(59.485,31.425),(59.315,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,21.905),(55.025,22.075),(55.195,22.075),(55.195,21.905),(55.025,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,5.925),(44.405,6.095),(44.575,6.095),(44.575,5.925),(44.405,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.065),(45.425,30.235),(45.595,30.235),(45.595,30.065),(45.425,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.405),(45.425,30.575),(45.595,30.575),(45.595,30.405),(45.425,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((45.425,30.745),(45.425,30.915),(45.595,30.915),(45.595,30.745),(45.425,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,26.325),(30.515,26.495),(30.685,26.495),(30.685,26.325),(30.515,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.265),(50.225,6.435),(50.395,6.435),(50.395,6.265),(50.225,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((50.225,6.605),(50.225,6.775),(50.395,6.775),(50.395,6.605),(50.225,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((30.515,26.665),(30.515,26.835),(30.685,26.835),(30.685,26.665),(30.515,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((44.405,22.925),(44.405,23.095),(44.575,23.095),(44.575,22.925),(44.405,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((40.625,24.965),(40.625,25.135),(40.795,25.135),(40.795,24.965),(40.625,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((40.115,24.965),(40.115,25.135),(40.285,25.135),(40.285,24.965),(40.115,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.705),(35.315,28.875),(35.485,28.875),(35.485,28.705),(35.315,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.705),(35.825,28.875),(35.995,28.875),(35.995,28.705),(35.825,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.025),(35.825,28.195),(35.995,28.195),(35.995,28.025),(35.825,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.825,28.365),(35.825,28.535),(35.995,28.535),(35.995,28.365),(35.825,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.585),(55.025,5.755),(55.195,5.755),(55.195,5.585),(55.025,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,5.245),(55.025,5.415),(55.195,5.415),(55.195,5.245),(55.025,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.025),(35.315,28.195),(35.485,28.195),(35.485,28.025),(35.315,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((35.315,28.365),(35.315,28.535),(35.485,28.535),(35.485,28.365),(35.315,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((55.025,38.905),(55.025,39.075),(55.195,39.075),(55.195,38.905),(55.025,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((44.915,19.865),(44.915,20.035),(45.085,20.035),(45.085,19.865),(44.915,19.865)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.835),(54.515,40.805),(54.685,40.805),(54.685,2.835),(54.515,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,41.735),(44.915,41.905),(45.085,41.905),(45.085,41.735),(44.915,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,2.785),(59.06,40.855),(59.23,40.855),(59.23,2.785),(59.06,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,2.835),(59.06,40.805),(59.23,40.805),(59.23,2.835),(59.06,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,41.735),(59.06,41.905),(59.23,41.905),(59.23,41.735),(59.06,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.76,21.36),(73.76,21.69),(73.93,21.69),(73.93,21.36),(73.76,21.36)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((73.58,21.44),(73.58,21.61),(74.11,21.61),(74.11,21.44),(73.58,21.44)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,1.58),(40.115,2.06),(40.285,2.06),(40.285,1.58),(40.115,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.58),(35.315,2.06),(35.485,2.06),(35.485,1.58),(35.315,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((58.805,2.785),(58.805,40.855),(59.485,40.855),(59.485,2.785),(58.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((73.58,1.735),(73.58,1.905),(74.11,1.905),(74.11,1.735),(73.58,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,1.735),(59.06,1.905),(59.23,1.905),(59.23,1.735),(59.06,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,41.735),(49.715,41.905),(49.885,41.905),(49.885,41.735),(49.715,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,41.58),(59.06,42.06),(59.23,42.06),(59.23,41.58),(59.06,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((44.405,2.785),(44.405,40.855),(45.595,40.855),(45.595,2.785),(44.405,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.835),(44.915,40.805),(45.085,40.805),(45.085,2.835),(44.915,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,1.58),(49.715,2.06),(49.885,2.06),(49.885,1.58),(49.715,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,41.735),(40.115,41.905),(40.285,41.905),(40.285,41.735),(40.115,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,1.58),(54.515,2.06),(54.685,2.06),(54.685,1.58),(54.515,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.58),(44.915,2.06),(45.085,2.06),(45.085,1.58),(44.915,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,2.785),(44.915,40.855),(45.085,40.855),(45.085,2.785),(44.915,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.785),(49.715,40.855),(49.885,40.855),(49.885,2.785),(49.715,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,2.835),(49.715,40.805),(49.885,40.805),(49.885,2.835),(49.715,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,41.58),(40.115,42.06),(40.285,42.06),(40.285,41.58),(40.115,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.835),(35.315,40.805),(35.485,40.805),(35.485,2.835),(35.315,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,2.785),(35.315,40.855),(35.485,40.855),(35.485,2.785),(35.315,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,41.735),(35.315,41.905),(35.485,41.905),(35.485,41.735),(35.315,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,41.735),(30.77,41.905),(30.94,41.905),(30.94,41.735),(30.77,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,41.58),(30.77,42.06),(30.94,42.06),(30.94,41.58),(30.77,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((59.06,1.58),(59.06,2.06),(59.23,2.06),(59.23,1.58),(59.06,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.835),(40.115,40.805),(40.285,40.805),(40.285,2.835),(40.115,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((40.115,2.785),(40.115,40.855),(40.285,40.855),(40.285,2.785),(40.115,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,41.735),(54.515,41.905),(54.685,41.905),(54.685,41.735),(54.515,41.735)),
        )
        createRL(
            tech, net, 'li',
            ((49.715,41.58),(49.715,42.06),(49.885,42.06),(49.885,41.58),(49.715,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,41.58),(54.515,42.06),(54.685,42.06),(54.685,41.58),(54.515,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,41.58),(44.915,42.06),(45.085,42.06),(45.085,41.58),(44.915,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,1.735),(30.77,1.905),(30.94,1.905),(30.94,1.735),(30.77,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'li',
            ((34.805,2.785),(34.805,40.855),(35.995,40.855),(35.995,2.785),(34.805,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.515,2.785),(30.515,40.855),(31.195,40.855),(31.195,2.785),(30.515,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,1.58),(30.77,2.06),(30.94,2.06),(30.94,1.58),(30.77,1.58)),
        )
        createRL(
            tech, net, 'li',
            ((49.205,2.785),(49.205,40.855),(50.395,40.855),(50.395,2.785),(49.205,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,2.835),(30.77,40.805),(30.94,40.805),(30.94,2.835),(30.77,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((35.315,41.58),(35.315,42.06),(35.485,42.06),(35.485,41.58),(35.315,41.58)),
        )
        createRL(
            tech, net, 'li',
            ((30.77,2.785),(30.77,40.855),(30.94,40.855),(30.94,2.785),(30.77,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((39.605,2.785),(39.605,40.855),(40.795,40.855),(40.795,2.785),(39.605,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((54.005,2.785),(54.005,40.855),(55.195,40.855),(55.195,2.785),(54.005,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((54.515,2.785),(54.515,40.855),(54.685,40.855),(54.685,2.785),(54.515,2.785)),
        )
        createRL(
            tech, net, 'nwm',
            ((45.605,2.54),(45.605,41.1),(47.065,41.1),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((38.135,2.54),(38.135,41.1),(39.595,41.1),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((42.935,2.54),(42.935,41.1),(44.395,41.1),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((40.37,2.54),(40.37,41.1),(41.05,41.1),(41.05,2.54),(40.37,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((57.335,2.54),(57.335,41.1),(58.795,41.1),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((34.87,2.54),(34.87,41.1),(35.93,41.1),(35.93,2.54),(34.87,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((34.55,2.54),(34.55,41.1),(35.23,41.1),(35.23,2.54),(34.55,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((30.07,2.54),(30.07,41.1),(31.13,41.1),(31.13,2.54),(30.07,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((30.77,2.54),(30.77,41.1),(31.45,41.1),(31.45,2.54),(30.77,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((49.27,2.54),(49.27,41.1),(50.33,41.1),(50.33,2.54),(49.27,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((49.97,2.54),(49.97,41.1),(50.65,41.1),(50.65,2.54),(49.97,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((46.925,2.54),(46.925,41.1),(47.875,41.1),(47.875,2.54),(46.925,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((35.57,2.54),(35.57,41.1),(36.25,41.1),(36.25,2.54),(35.57,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((39.35,2.54),(39.35,41.1),(40.03,41.1),(40.03,2.54),(39.35,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((39.67,2.54),(39.67,41.1),(40.73,41.1),(40.73,2.54),(39.67,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((37.325,2.54),(37.325,41.1),(38.275,41.1),(38.275,2.54),(37.325,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((44.15,2.54),(44.15,41.1),(44.83,41.1),(44.83,2.54),(44.15,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((42.125,2.54),(42.125,41.1),(43.075,41.1),(43.075,2.54),(42.125,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((54.77,2.54),(54.77,41.1),(55.45,41.1),(55.45,2.54),(54.77,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((54.07,2.54),(54.07,41.1),(55.13,41.1),(55.13,2.54),(54.07,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((56.525,2.54),(56.525,41.1),(57.475,41.1),(57.475,2.54),(56.525,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((48.95,2.54),(48.95,41.1),(49.63,41.1),(49.63,2.54),(48.95,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((55.205,2.54),(55.205,41.1),(56.665,41.1),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((51.725,2.54),(51.725,41.1),(52.675,41.1),(52.675,2.54),(51.725,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((36.005,2.54),(36.005,41.1),(37.465,41.1),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((53.75,2.54),(53.75,41.1),(54.43,41.1),(54.43,2.54),(53.75,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((58.55,2.54),(58.55,41.1),(59.23,41.1),(59.23,2.54),(58.55,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((58.87,2.54),(58.87,41.1),(59.93,41.1),(59.93,2.54),(58.87,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((40.805,2.54),(40.805,41.1),(42.265,41.1),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((47.735,2.54),(47.735,41.1),(49.195,41.1),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((50.405,2.54),(50.405,41.1),(51.865,41.1),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((33.335,2.54),(33.335,41.1),(34.795,41.1),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((44.47,2.54),(44.47,41.1),(45.53,41.1),(45.53,2.54),(44.47,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((52.535,2.54),(52.535,41.1),(53.995,41.1),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((32.525,2.54),(32.525,41.1),(33.475,41.1),(33.475,2.54),(32.525,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((31.205,2.54),(31.205,41.1),(32.665,41.1),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'nwm',
            ((45.17,2.54),(45.17,41.1),(45.85,41.1),(45.85,2.54),(45.17,2.54)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,41.735),(44.915,41.905),(45.085,41.905),(45.085,41.735),(44.915,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,41.735),(59.06,41.905),(59.23,41.905),(59.23,41.735),(59.06,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,2.835),(30.77,3.005),(30.94,3.005),(30.94,2.835),(30.77,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,3.195),(30.77,3.365),(30.94,3.365),(30.94,3.195),(30.77,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,3.555),(30.77,3.725),(30.94,3.725),(30.94,3.555),(30.77,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,3.915),(30.77,4.085),(30.94,4.085),(30.94,3.915),(30.77,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,4.275),(30.77,4.445),(30.94,4.445),(30.94,4.275),(30.77,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,4.635),(30.77,4.805),(30.94,4.805),(30.94,4.635),(30.77,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,4.995),(30.77,5.165),(30.94,5.165),(30.94,4.995),(30.77,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,5.355),(30.77,5.525),(30.94,5.525),(30.94,5.355),(30.77,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,5.715),(30.77,5.885),(30.94,5.885),(30.94,5.715),(30.77,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,6.075),(30.77,6.245),(30.94,6.245),(30.94,6.075),(30.77,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,6.435),(30.77,6.605),(30.94,6.605),(30.94,6.435),(30.77,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,6.795),(30.77,6.965),(30.94,6.965),(30.94,6.795),(30.77,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,7.155),(30.77,7.325),(30.94,7.325),(30.94,7.155),(30.77,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,7.515),(30.77,7.685),(30.94,7.685),(30.94,7.515),(30.77,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,7.875),(30.77,8.045),(30.94,8.045),(30.94,7.875),(30.77,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,8.235),(30.77,8.405),(30.94,8.405),(30.94,8.235),(30.77,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,8.595),(30.77,8.765),(30.94,8.765),(30.94,8.595),(30.77,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,8.955),(30.77,9.125),(30.94,9.125),(30.94,8.955),(30.77,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,9.315),(30.77,9.485),(30.94,9.485),(30.94,9.315),(30.77,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,9.675),(30.77,9.845),(30.94,9.845),(30.94,9.675),(30.77,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,10.035),(30.77,10.205),(30.94,10.205),(30.94,10.035),(30.77,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,10.395),(30.77,10.565),(30.94,10.565),(30.94,10.395),(30.77,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,10.755),(30.77,10.925),(30.94,10.925),(30.94,10.755),(30.77,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,11.115),(30.77,11.285),(30.94,11.285),(30.94,11.115),(30.77,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,11.475),(30.77,11.645),(30.94,11.645),(30.94,11.475),(30.77,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,11.835),(30.77,12.005),(30.94,12.005),(30.94,11.835),(30.77,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,12.195),(30.77,12.365),(30.94,12.365),(30.94,12.195),(30.77,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,12.555),(30.77,12.725),(30.94,12.725),(30.94,12.555),(30.77,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,12.915),(30.77,13.085),(30.94,13.085),(30.94,12.915),(30.77,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,13.275),(30.77,13.445),(30.94,13.445),(30.94,13.275),(30.77,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,13.635),(30.77,13.805),(30.94,13.805),(30.94,13.635),(30.77,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,13.995),(30.77,14.165),(30.94,14.165),(30.94,13.995),(30.77,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,14.355),(30.77,14.525),(30.94,14.525),(30.94,14.355),(30.77,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,14.715),(30.77,14.885),(30.94,14.885),(30.94,14.715),(30.77,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,15.075),(30.77,15.245),(30.94,15.245),(30.94,15.075),(30.77,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,15.435),(30.77,15.605),(30.94,15.605),(30.94,15.435),(30.77,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,15.795),(30.77,15.965),(30.94,15.965),(30.94,15.795),(30.77,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,16.155),(30.77,16.325),(30.94,16.325),(30.94,16.155),(30.77,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,16.515),(30.77,16.685),(30.94,16.685),(30.94,16.515),(30.77,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,16.875),(30.77,17.045),(30.94,17.045),(30.94,16.875),(30.77,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,17.235),(30.77,17.405),(30.94,17.405),(30.94,17.235),(30.77,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,17.595),(30.77,17.765),(30.94,17.765),(30.94,17.595),(30.77,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,17.955),(30.77,18.125),(30.94,18.125),(30.94,17.955),(30.77,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,18.315),(30.77,18.485),(30.94,18.485),(30.94,18.315),(30.77,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,18.675),(30.77,18.845),(30.94,18.845),(30.94,18.675),(30.77,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,19.035),(30.77,19.205),(30.94,19.205),(30.94,19.035),(30.77,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,19.395),(30.77,19.565),(30.94,19.565),(30.94,19.395),(30.77,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,19.755),(30.77,19.925),(30.94,19.925),(30.94,19.755),(30.77,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,20.115),(30.77,20.285),(30.94,20.285),(30.94,20.115),(30.77,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,20.475),(30.77,20.645),(30.94,20.645),(30.94,20.475),(30.77,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,20.835),(30.77,21.005),(30.94,21.005),(30.94,20.835),(30.77,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,21.195),(30.77,21.365),(30.94,21.365),(30.94,21.195),(30.77,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,21.555),(30.77,21.725),(30.94,21.725),(30.94,21.555),(30.77,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,21.915),(30.77,22.085),(30.94,22.085),(30.94,21.915),(30.77,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,22.275),(30.77,22.445),(30.94,22.445),(30.94,22.275),(30.77,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,22.635),(30.77,22.805),(30.94,22.805),(30.94,22.635),(30.77,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,22.995),(30.77,23.165),(30.94,23.165),(30.94,22.995),(30.77,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,23.355),(30.77,23.525),(30.94,23.525),(30.94,23.355),(30.77,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,23.715),(30.77,23.885),(30.94,23.885),(30.94,23.715),(30.77,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,24.075),(30.77,24.245),(30.94,24.245),(30.94,24.075),(30.77,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,24.435),(30.77,24.605),(30.94,24.605),(30.94,24.435),(30.77,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,24.795),(30.77,24.965),(30.94,24.965),(30.94,24.795),(30.77,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,25.155),(30.77,25.325),(30.94,25.325),(30.94,25.155),(30.77,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,25.515),(30.77,25.685),(30.94,25.685),(30.94,25.515),(30.77,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,25.875),(30.77,26.045),(30.94,26.045),(30.94,25.875),(30.77,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,26.235),(30.77,26.405),(30.94,26.405),(30.94,26.235),(30.77,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,26.595),(30.77,26.765),(30.94,26.765),(30.94,26.595),(30.77,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,26.955),(30.77,27.125),(30.94,27.125),(30.94,26.955),(30.77,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,27.315),(30.77,27.485),(30.94,27.485),(30.94,27.315),(30.77,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,27.675),(30.77,27.845),(30.94,27.845),(30.94,27.675),(30.77,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,28.035),(30.77,28.205),(30.94,28.205),(30.94,28.035),(30.77,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,28.395),(30.77,28.565),(30.94,28.565),(30.94,28.395),(30.77,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,28.755),(30.77,28.925),(30.94,28.925),(30.94,28.755),(30.77,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,29.115),(30.77,29.285),(30.94,29.285),(30.94,29.115),(30.77,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,29.475),(30.77,29.645),(30.94,29.645),(30.94,29.475),(30.77,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,29.835),(30.77,30.005),(30.94,30.005),(30.94,29.835),(30.77,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,30.195),(30.77,30.365),(30.94,30.365),(30.94,30.195),(30.77,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,30.555),(30.77,30.725),(30.94,30.725),(30.94,30.555),(30.77,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,30.915),(30.77,31.085),(30.94,31.085),(30.94,30.915),(30.77,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,31.275),(30.77,31.445),(30.94,31.445),(30.94,31.275),(30.77,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,31.635),(30.77,31.805),(30.94,31.805),(30.94,31.635),(30.77,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,31.995),(30.77,32.165),(30.94,32.165),(30.94,31.995),(30.77,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,32.355),(30.77,32.525),(30.94,32.525),(30.94,32.355),(30.77,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,32.715),(30.77,32.885),(30.94,32.885),(30.94,32.715),(30.77,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,33.075),(30.77,33.245),(30.94,33.245),(30.94,33.075),(30.77,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,33.435),(30.77,33.605),(30.94,33.605),(30.94,33.435),(30.77,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,33.795),(30.77,33.965),(30.94,33.965),(30.94,33.795),(30.77,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,34.155),(30.77,34.325),(30.94,34.325),(30.94,34.155),(30.77,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,34.515),(30.77,34.685),(30.94,34.685),(30.94,34.515),(30.77,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,34.875),(30.77,35.045),(30.94,35.045),(30.94,34.875),(30.77,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,35.235),(30.77,35.405),(30.94,35.405),(30.94,35.235),(30.77,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,35.595),(30.77,35.765),(30.94,35.765),(30.94,35.595),(30.77,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,35.955),(30.77,36.125),(30.94,36.125),(30.94,35.955),(30.77,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,36.315),(30.77,36.485),(30.94,36.485),(30.94,36.315),(30.77,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,36.675),(30.77,36.845),(30.94,36.845),(30.94,36.675),(30.77,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,37.035),(30.77,37.205),(30.94,37.205),(30.94,37.035),(30.77,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,37.395),(30.77,37.565),(30.94,37.565),(30.94,37.395),(30.77,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,37.755),(30.77,37.925),(30.94,37.925),(30.94,37.755),(30.77,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,38.115),(30.77,38.285),(30.94,38.285),(30.94,38.115),(30.77,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,38.475),(30.77,38.645),(30.94,38.645),(30.94,38.475),(30.77,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,38.835),(30.77,39.005),(30.94,39.005),(30.94,38.835),(30.77,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,39.195),(30.77,39.365),(30.94,39.365),(30.94,39.195),(30.77,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,39.555),(30.77,39.725),(30.94,39.725),(30.94,39.555),(30.77,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,39.915),(30.77,40.085),(30.94,40.085),(30.94,39.915),(30.77,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,40.275),(30.77,40.445),(30.94,40.445),(30.94,40.275),(30.77,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,40.635),(30.77,40.805),(30.94,40.805),(30.94,40.635),(30.77,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,1.735),(40.115,1.905),(40.285,1.905),(40.285,1.735),(40.115,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,1.735),(49.715,1.905),(49.885,1.905),(49.885,1.735),(49.715,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,2.835),(44.915,3.005),(45.085,3.005),(45.085,2.835),(44.915,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.195),(44.915,3.365),(45.085,3.365),(45.085,3.195),(44.915,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.555),(44.915,3.725),(45.085,3.725),(45.085,3.555),(44.915,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,3.915),(44.915,4.085),(45.085,4.085),(45.085,3.915),(44.915,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.275),(44.915,4.445),(45.085,4.445),(45.085,4.275),(44.915,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.635),(44.915,4.805),(45.085,4.805),(45.085,4.635),(44.915,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,4.995),(44.915,5.165),(45.085,5.165),(45.085,4.995),(44.915,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.355),(44.915,5.525),(45.085,5.525),(45.085,5.355),(44.915,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,5.715),(44.915,5.885),(45.085,5.885),(45.085,5.715),(44.915,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.075),(44.915,6.245),(45.085,6.245),(45.085,6.075),(44.915,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.435),(44.915,6.605),(45.085,6.605),(45.085,6.435),(44.915,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,6.795),(44.915,6.965),(45.085,6.965),(45.085,6.795),(44.915,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.155),(44.915,7.325),(45.085,7.325),(45.085,7.155),(44.915,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.515),(44.915,7.685),(45.085,7.685),(45.085,7.515),(44.915,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,7.875),(44.915,8.045),(45.085,8.045),(45.085,7.875),(44.915,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.235),(44.915,8.405),(45.085,8.405),(45.085,8.235),(44.915,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.595),(44.915,8.765),(45.085,8.765),(45.085,8.595),(44.915,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,8.955),(44.915,9.125),(45.085,9.125),(45.085,8.955),(44.915,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.315),(44.915,9.485),(45.085,9.485),(45.085,9.315),(44.915,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,9.675),(44.915,9.845),(45.085,9.845),(45.085,9.675),(44.915,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.035),(44.915,10.205),(45.085,10.205),(45.085,10.035),(44.915,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.395),(44.915,10.565),(45.085,10.565),(45.085,10.395),(44.915,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,10.755),(44.915,10.925),(45.085,10.925),(45.085,10.755),(44.915,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.115),(44.915,11.285),(45.085,11.285),(45.085,11.115),(44.915,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.475),(44.915,11.645),(45.085,11.645),(45.085,11.475),(44.915,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,11.835),(44.915,12.005),(45.085,12.005),(45.085,11.835),(44.915,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.195),(44.915,12.365),(45.085,12.365),(45.085,12.195),(44.915,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.555),(44.915,12.725),(45.085,12.725),(45.085,12.555),(44.915,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,12.915),(44.915,13.085),(45.085,13.085),(45.085,12.915),(44.915,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.275),(44.915,13.445),(45.085,13.445),(45.085,13.275),(44.915,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.635),(44.915,13.805),(45.085,13.805),(45.085,13.635),(44.915,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,13.995),(44.915,14.165),(45.085,14.165),(45.085,13.995),(44.915,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.355),(44.915,14.525),(45.085,14.525),(45.085,14.355),(44.915,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,14.715),(44.915,14.885),(45.085,14.885),(45.085,14.715),(44.915,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.075),(44.915,15.245),(45.085,15.245),(45.085,15.075),(44.915,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.435),(44.915,15.605),(45.085,15.605),(45.085,15.435),(44.915,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,15.795),(44.915,15.965),(45.085,15.965),(45.085,15.795),(44.915,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.155),(44.915,16.325),(45.085,16.325),(45.085,16.155),(44.915,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.515),(44.915,16.685),(45.085,16.685),(45.085,16.515),(44.915,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,16.875),(44.915,17.045),(45.085,17.045),(45.085,16.875),(44.915,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.235),(44.915,17.405),(45.085,17.405),(45.085,17.235),(44.915,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.595),(44.915,17.765),(45.085,17.765),(45.085,17.595),(44.915,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,17.955),(44.915,18.125),(45.085,18.125),(45.085,17.955),(44.915,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.315),(44.915,18.485),(45.085,18.485),(45.085,18.315),(44.915,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,18.675),(44.915,18.845),(45.085,18.845),(45.085,18.675),(44.915,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.035),(44.915,19.205),(45.085,19.205),(45.085,19.035),(44.915,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.395),(44.915,19.565),(45.085,19.565),(45.085,19.395),(44.915,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,19.755),(44.915,19.925),(45.085,19.925),(45.085,19.755),(44.915,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.115),(44.915,20.285),(45.085,20.285),(45.085,20.115),(44.915,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.475),(44.915,20.645),(45.085,20.645),(45.085,20.475),(44.915,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,20.835),(44.915,21.005),(45.085,21.005),(45.085,20.835),(44.915,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.195),(44.915,21.365),(45.085,21.365),(45.085,21.195),(44.915,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.555),(44.915,21.725),(45.085,21.725),(45.085,21.555),(44.915,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,21.915),(44.915,22.085),(45.085,22.085),(45.085,21.915),(44.915,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.275),(44.915,22.445),(45.085,22.445),(45.085,22.275),(44.915,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.635),(44.915,22.805),(45.085,22.805),(45.085,22.635),(44.915,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,22.995),(44.915,23.165),(45.085,23.165),(45.085,22.995),(44.915,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,23.355),(44.915,23.525),(45.085,23.525),(45.085,23.355),(44.915,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,23.715),(44.915,23.885),(45.085,23.885),(45.085,23.715),(44.915,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.075),(44.915,24.245),(45.085,24.245),(45.085,24.075),(44.915,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.435),(44.915,24.605),(45.085,24.605),(45.085,24.435),(44.915,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,24.795),(44.915,24.965),(45.085,24.965),(45.085,24.795),(44.915,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.155),(44.915,25.325),(45.085,25.325),(45.085,25.155),(44.915,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.515),(44.915,25.685),(45.085,25.685),(45.085,25.515),(44.915,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,25.875),(44.915,26.045),(45.085,26.045),(45.085,25.875),(44.915,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.235),(44.915,26.405),(45.085,26.405),(45.085,26.235),(44.915,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.595),(44.915,26.765),(45.085,26.765),(45.085,26.595),(44.915,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,26.955),(44.915,27.125),(45.085,27.125),(45.085,26.955),(44.915,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,27.315),(44.915,27.485),(45.085,27.485),(45.085,27.315),(44.915,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,27.675),(44.915,27.845),(45.085,27.845),(45.085,27.675),(44.915,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.035),(44.915,28.205),(45.085,28.205),(45.085,28.035),(44.915,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.395),(44.915,28.565),(45.085,28.565),(45.085,28.395),(44.915,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,28.755),(44.915,28.925),(45.085,28.925),(45.085,28.755),(44.915,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.115),(44.915,29.285),(45.085,29.285),(45.085,29.115),(44.915,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.475),(44.915,29.645),(45.085,29.645),(45.085,29.475),(44.915,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,29.835),(44.915,30.005),(45.085,30.005),(45.085,29.835),(44.915,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.195),(44.915,30.365),(45.085,30.365),(45.085,30.195),(44.915,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.555),(44.915,30.725),(45.085,30.725),(45.085,30.555),(44.915,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,30.915),(44.915,31.085),(45.085,31.085),(45.085,30.915),(44.915,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.275),(44.915,31.445),(45.085,31.445),(45.085,31.275),(44.915,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.635),(44.915,31.805),(45.085,31.805),(45.085,31.635),(44.915,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,31.995),(44.915,32.165),(45.085,32.165),(45.085,31.995),(44.915,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.355),(44.915,32.525),(45.085,32.525),(45.085,32.355),(44.915,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,32.715),(44.915,32.885),(45.085,32.885),(45.085,32.715),(44.915,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.075),(44.915,33.245),(45.085,33.245),(45.085,33.075),(44.915,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.435),(44.915,33.605),(45.085,33.605),(45.085,33.435),(44.915,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,33.795),(44.915,33.965),(45.085,33.965),(45.085,33.795),(44.915,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.155),(44.915,34.325),(45.085,34.325),(45.085,34.155),(44.915,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.515),(44.915,34.685),(45.085,34.685),(45.085,34.515),(44.915,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,34.875),(44.915,35.045),(45.085,35.045),(45.085,34.875),(44.915,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.235),(44.915,35.405),(45.085,35.405),(45.085,35.235),(44.915,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.595),(44.915,35.765),(45.085,35.765),(45.085,35.595),(44.915,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,35.955),(44.915,36.125),(45.085,36.125),(45.085,35.955),(44.915,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.315),(44.915,36.485),(45.085,36.485),(45.085,36.315),(44.915,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,36.675),(44.915,36.845),(45.085,36.845),(45.085,36.675),(44.915,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.035),(44.915,37.205),(45.085,37.205),(45.085,37.035),(44.915,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.395),(44.915,37.565),(45.085,37.565),(45.085,37.395),(44.915,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,37.755),(44.915,37.925),(45.085,37.925),(45.085,37.755),(44.915,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.115),(44.915,38.285),(45.085,38.285),(45.085,38.115),(44.915,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.475),(44.915,38.645),(45.085,38.645),(45.085,38.475),(44.915,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,38.835),(44.915,39.005),(45.085,39.005),(45.085,38.835),(44.915,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.195),(44.915,39.365),(45.085,39.365),(45.085,39.195),(44.915,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.555),(44.915,39.725),(45.085,39.725),(45.085,39.555),(44.915,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,39.915),(44.915,40.085),(45.085,40.085),(45.085,39.915),(44.915,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,40.275),(44.915,40.445),(45.085,40.445),(45.085,40.275),(44.915,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,40.635),(44.915,40.805),(45.085,40.805),(45.085,40.635),(44.915,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,1.735),(59.06,1.905),(59.23,1.905),(59.23,1.735),(59.06,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,41.735),(49.715,41.905),(49.885,41.905),(49.885,41.735),(49.715,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,1.735),(54.515,1.905),(54.685,1.905),(54.685,1.735),(54.515,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,41.735),(40.115,41.905),(40.285,41.905),(40.285,41.735),(40.115,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.58,1.735),(73.58,1.905),(73.75,1.905),(73.75,1.735),(73.58,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.94,1.735),(73.94,1.905),(74.11,1.905),(74.11,1.735),(73.94,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,41.735),(30.77,41.905),(30.94,41.905),(30.94,41.735),(30.77,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,41.735),(35.315,41.905),(35.485,41.905),(35.485,41.735),(35.315,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,2.835),(49.715,3.005),(49.885,3.005),(49.885,2.835),(49.715,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.195),(49.715,3.365),(49.885,3.365),(49.885,3.195),(49.715,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.555),(49.715,3.725),(49.885,3.725),(49.885,3.555),(49.715,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,3.915),(49.715,4.085),(49.885,4.085),(49.885,3.915),(49.715,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.275),(49.715,4.445),(49.885,4.445),(49.885,4.275),(49.715,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.635),(49.715,4.805),(49.885,4.805),(49.885,4.635),(49.715,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,4.995),(49.715,5.165),(49.885,5.165),(49.885,4.995),(49.715,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.355),(49.715,5.525),(49.885,5.525),(49.885,5.355),(49.715,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,5.715),(49.715,5.885),(49.885,5.885),(49.885,5.715),(49.715,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.075),(49.715,6.245),(49.885,6.245),(49.885,6.075),(49.715,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.435),(49.715,6.605),(49.885,6.605),(49.885,6.435),(49.715,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,6.795),(49.715,6.965),(49.885,6.965),(49.885,6.795),(49.715,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.155),(49.715,7.325),(49.885,7.325),(49.885,7.155),(49.715,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.515),(49.715,7.685),(49.885,7.685),(49.885,7.515),(49.715,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,7.875),(49.715,8.045),(49.885,8.045),(49.885,7.875),(49.715,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.235),(49.715,8.405),(49.885,8.405),(49.885,8.235),(49.715,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.595),(49.715,8.765),(49.885,8.765),(49.885,8.595),(49.715,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,8.955),(49.715,9.125),(49.885,9.125),(49.885,8.955),(49.715,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.315),(49.715,9.485),(49.885,9.485),(49.885,9.315),(49.715,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,9.675),(49.715,9.845),(49.885,9.845),(49.885,9.675),(49.715,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.035),(49.715,10.205),(49.885,10.205),(49.885,10.035),(49.715,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.395),(49.715,10.565),(49.885,10.565),(49.885,10.395),(49.715,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,10.755),(49.715,10.925),(49.885,10.925),(49.885,10.755),(49.715,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.115),(49.715,11.285),(49.885,11.285),(49.885,11.115),(49.715,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.475),(49.715,11.645),(49.885,11.645),(49.885,11.475),(49.715,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,11.835),(49.715,12.005),(49.885,12.005),(49.885,11.835),(49.715,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.195),(49.715,12.365),(49.885,12.365),(49.885,12.195),(49.715,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.555),(49.715,12.725),(49.885,12.725),(49.885,12.555),(49.715,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,12.915),(49.715,13.085),(49.885,13.085),(49.885,12.915),(49.715,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.275),(49.715,13.445),(49.885,13.445),(49.885,13.275),(49.715,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.635),(49.715,13.805),(49.885,13.805),(49.885,13.635),(49.715,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,13.995),(49.715,14.165),(49.885,14.165),(49.885,13.995),(49.715,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.355),(49.715,14.525),(49.885,14.525),(49.885,14.355),(49.715,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,14.715),(49.715,14.885),(49.885,14.885),(49.885,14.715),(49.715,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.075),(49.715,15.245),(49.885,15.245),(49.885,15.075),(49.715,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.435),(49.715,15.605),(49.885,15.605),(49.885,15.435),(49.715,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,15.795),(49.715,15.965),(49.885,15.965),(49.885,15.795),(49.715,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.155),(49.715,16.325),(49.885,16.325),(49.885,16.155),(49.715,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.515),(49.715,16.685),(49.885,16.685),(49.885,16.515),(49.715,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,16.875),(49.715,17.045),(49.885,17.045),(49.885,16.875),(49.715,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.235),(49.715,17.405),(49.885,17.405),(49.885,17.235),(49.715,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.595),(49.715,17.765),(49.885,17.765),(49.885,17.595),(49.715,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,17.955),(49.715,18.125),(49.885,18.125),(49.885,17.955),(49.715,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.315),(49.715,18.485),(49.885,18.485),(49.885,18.315),(49.715,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,18.675),(49.715,18.845),(49.885,18.845),(49.885,18.675),(49.715,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.035),(49.715,19.205),(49.885,19.205),(49.885,19.035),(49.715,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.395),(49.715,19.565),(49.885,19.565),(49.885,19.395),(49.715,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,19.755),(49.715,19.925),(49.885,19.925),(49.885,19.755),(49.715,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.115),(49.715,20.285),(49.885,20.285),(49.885,20.115),(49.715,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.475),(49.715,20.645),(49.885,20.645),(49.885,20.475),(49.715,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,20.835),(49.715,21.005),(49.885,21.005),(49.885,20.835),(49.715,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.195),(49.715,21.365),(49.885,21.365),(49.885,21.195),(49.715,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.555),(49.715,21.725),(49.885,21.725),(49.885,21.555),(49.715,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,21.915),(49.715,22.085),(49.885,22.085),(49.885,21.915),(49.715,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.275),(49.715,22.445),(49.885,22.445),(49.885,22.275),(49.715,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.635),(49.715,22.805),(49.885,22.805),(49.885,22.635),(49.715,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,22.995),(49.715,23.165),(49.885,23.165),(49.885,22.995),(49.715,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,23.355),(49.715,23.525),(49.885,23.525),(49.885,23.355),(49.715,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,23.715),(49.715,23.885),(49.885,23.885),(49.885,23.715),(49.715,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.075),(49.715,24.245),(49.885,24.245),(49.885,24.075),(49.715,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.435),(49.715,24.605),(49.885,24.605),(49.885,24.435),(49.715,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,24.795),(49.715,24.965),(49.885,24.965),(49.885,24.795),(49.715,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.155),(49.715,25.325),(49.885,25.325),(49.885,25.155),(49.715,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.515),(49.715,25.685),(49.885,25.685),(49.885,25.515),(49.715,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,25.875),(49.715,26.045),(49.885,26.045),(49.885,25.875),(49.715,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.235),(49.715,26.405),(49.885,26.405),(49.885,26.235),(49.715,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.595),(49.715,26.765),(49.885,26.765),(49.885,26.595),(49.715,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,26.955),(49.715,27.125),(49.885,27.125),(49.885,26.955),(49.715,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,27.315),(49.715,27.485),(49.885,27.485),(49.885,27.315),(49.715,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,27.675),(49.715,27.845),(49.885,27.845),(49.885,27.675),(49.715,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.035),(49.715,28.205),(49.885,28.205),(49.885,28.035),(49.715,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.395),(49.715,28.565),(49.885,28.565),(49.885,28.395),(49.715,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,28.755),(49.715,28.925),(49.885,28.925),(49.885,28.755),(49.715,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.115),(49.715,29.285),(49.885,29.285),(49.885,29.115),(49.715,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.475),(49.715,29.645),(49.885,29.645),(49.885,29.475),(49.715,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,29.835),(49.715,30.005),(49.885,30.005),(49.885,29.835),(49.715,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.195),(49.715,30.365),(49.885,30.365),(49.885,30.195),(49.715,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.555),(49.715,30.725),(49.885,30.725),(49.885,30.555),(49.715,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,30.915),(49.715,31.085),(49.885,31.085),(49.885,30.915),(49.715,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.275),(49.715,31.445),(49.885,31.445),(49.885,31.275),(49.715,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.635),(49.715,31.805),(49.885,31.805),(49.885,31.635),(49.715,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,31.995),(49.715,32.165),(49.885,32.165),(49.885,31.995),(49.715,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,32.355),(49.715,32.525),(49.885,32.525),(49.885,32.355),(49.715,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,32.715),(49.715,32.885),(49.885,32.885),(49.885,32.715),(49.715,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.075),(49.715,33.245),(49.885,33.245),(49.885,33.075),(49.715,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.435),(49.715,33.605),(49.885,33.605),(49.885,33.435),(49.715,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,33.795),(49.715,33.965),(49.885,33.965),(49.885,33.795),(49.715,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.155),(49.715,34.325),(49.885,34.325),(49.885,34.155),(49.715,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.515),(49.715,34.685),(49.885,34.685),(49.885,34.515),(49.715,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,34.875),(49.715,35.045),(49.885,35.045),(49.885,34.875),(49.715,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.235),(49.715,35.405),(49.885,35.405),(49.885,35.235),(49.715,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.595),(49.715,35.765),(49.885,35.765),(49.885,35.595),(49.715,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,35.955),(49.715,36.125),(49.885,36.125),(49.885,35.955),(49.715,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,36.315),(49.715,36.485),(49.885,36.485),(49.885,36.315),(49.715,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,36.675),(49.715,36.845),(49.885,36.845),(49.885,36.675),(49.715,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.035),(49.715,37.205),(49.885,37.205),(49.885,37.035),(49.715,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.395),(49.715,37.565),(49.885,37.565),(49.885,37.395),(49.715,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,37.755),(49.715,37.925),(49.885,37.925),(49.885,37.755),(49.715,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.115),(49.715,38.285),(49.885,38.285),(49.885,38.115),(49.715,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.475),(49.715,38.645),(49.885,38.645),(49.885,38.475),(49.715,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,38.835),(49.715,39.005),(49.885,39.005),(49.885,38.835),(49.715,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.195),(49.715,39.365),(49.885,39.365),(49.885,39.195),(49.715,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.555),(49.715,39.725),(49.885,39.725),(49.885,39.555),(49.715,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,39.915),(49.715,40.085),(49.885,40.085),(49.885,39.915),(49.715,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,40.275),(49.715,40.445),(49.885,40.445),(49.885,40.275),(49.715,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((49.715,40.635),(49.715,40.805),(49.885,40.805),(49.885,40.635),(49.715,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,2.835),(54.515,3.005),(54.685,3.005),(54.685,2.835),(54.515,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.195),(54.515,3.365),(54.685,3.365),(54.685,3.195),(54.515,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.555),(54.515,3.725),(54.685,3.725),(54.685,3.555),(54.515,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,3.915),(54.515,4.085),(54.685,4.085),(54.685,3.915),(54.515,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.275),(54.515,4.445),(54.685,4.445),(54.685,4.275),(54.515,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.635),(54.515,4.805),(54.685,4.805),(54.685,4.635),(54.515,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,4.995),(54.515,5.165),(54.685,5.165),(54.685,4.995),(54.515,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.355),(54.515,5.525),(54.685,5.525),(54.685,5.355),(54.515,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,5.715),(54.515,5.885),(54.685,5.885),(54.685,5.715),(54.515,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.075),(54.515,6.245),(54.685,6.245),(54.685,6.075),(54.515,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.435),(54.515,6.605),(54.685,6.605),(54.685,6.435),(54.515,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,6.795),(54.515,6.965),(54.685,6.965),(54.685,6.795),(54.515,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.155),(54.515,7.325),(54.685,7.325),(54.685,7.155),(54.515,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.515),(54.515,7.685),(54.685,7.685),(54.685,7.515),(54.515,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,7.875),(54.515,8.045),(54.685,8.045),(54.685,7.875),(54.515,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.235),(54.515,8.405),(54.685,8.405),(54.685,8.235),(54.515,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.595),(54.515,8.765),(54.685,8.765),(54.685,8.595),(54.515,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,8.955),(54.515,9.125),(54.685,9.125),(54.685,8.955),(54.515,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.315),(54.515,9.485),(54.685,9.485),(54.685,9.315),(54.515,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,9.675),(54.515,9.845),(54.685,9.845),(54.685,9.675),(54.515,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.035),(54.515,10.205),(54.685,10.205),(54.685,10.035),(54.515,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.395),(54.515,10.565),(54.685,10.565),(54.685,10.395),(54.515,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,10.755),(54.515,10.925),(54.685,10.925),(54.685,10.755),(54.515,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.115),(54.515,11.285),(54.685,11.285),(54.685,11.115),(54.515,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.475),(54.515,11.645),(54.685,11.645),(54.685,11.475),(54.515,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,11.835),(54.515,12.005),(54.685,12.005),(54.685,11.835),(54.515,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.195),(54.515,12.365),(54.685,12.365),(54.685,12.195),(54.515,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.555),(54.515,12.725),(54.685,12.725),(54.685,12.555),(54.515,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,12.915),(54.515,13.085),(54.685,13.085),(54.685,12.915),(54.515,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.275),(54.515,13.445),(54.685,13.445),(54.685,13.275),(54.515,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.635),(54.515,13.805),(54.685,13.805),(54.685,13.635),(54.515,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,13.995),(54.515,14.165),(54.685,14.165),(54.685,13.995),(54.515,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.355),(54.515,14.525),(54.685,14.525),(54.685,14.355),(54.515,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,14.715),(54.515,14.885),(54.685,14.885),(54.685,14.715),(54.515,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.075),(54.515,15.245),(54.685,15.245),(54.685,15.075),(54.515,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.435),(54.515,15.605),(54.685,15.605),(54.685,15.435),(54.515,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,15.795),(54.515,15.965),(54.685,15.965),(54.685,15.795),(54.515,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.155),(54.515,16.325),(54.685,16.325),(54.685,16.155),(54.515,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.515),(54.515,16.685),(54.685,16.685),(54.685,16.515),(54.515,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,16.875),(54.515,17.045),(54.685,17.045),(54.685,16.875),(54.515,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.235),(54.515,17.405),(54.685,17.405),(54.685,17.235),(54.515,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.595),(54.515,17.765),(54.685,17.765),(54.685,17.595),(54.515,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,17.955),(54.515,18.125),(54.685,18.125),(54.685,17.955),(54.515,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.315),(54.515,18.485),(54.685,18.485),(54.685,18.315),(54.515,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,18.675),(54.515,18.845),(54.685,18.845),(54.685,18.675),(54.515,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.035),(54.515,19.205),(54.685,19.205),(54.685,19.035),(54.515,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.395),(54.515,19.565),(54.685,19.565),(54.685,19.395),(54.515,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,19.755),(54.515,19.925),(54.685,19.925),(54.685,19.755),(54.515,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.115),(54.515,20.285),(54.685,20.285),(54.685,20.115),(54.515,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.475),(54.515,20.645),(54.685,20.645),(54.685,20.475),(54.515,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,20.835),(54.515,21.005),(54.685,21.005),(54.685,20.835),(54.515,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.195),(54.515,21.365),(54.685,21.365),(54.685,21.195),(54.515,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.555),(54.515,21.725),(54.685,21.725),(54.685,21.555),(54.515,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,21.915),(54.515,22.085),(54.685,22.085),(54.685,21.915),(54.515,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.275),(54.515,22.445),(54.685,22.445),(54.685,22.275),(54.515,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.635),(54.515,22.805),(54.685,22.805),(54.685,22.635),(54.515,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,22.995),(54.515,23.165),(54.685,23.165),(54.685,22.995),(54.515,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,23.355),(54.515,23.525),(54.685,23.525),(54.685,23.355),(54.515,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,23.715),(54.515,23.885),(54.685,23.885),(54.685,23.715),(54.515,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.075),(54.515,24.245),(54.685,24.245),(54.685,24.075),(54.515,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.435),(54.515,24.605),(54.685,24.605),(54.685,24.435),(54.515,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,24.795),(54.515,24.965),(54.685,24.965),(54.685,24.795),(54.515,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.155),(54.515,25.325),(54.685,25.325),(54.685,25.155),(54.515,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.515),(54.515,25.685),(54.685,25.685),(54.685,25.515),(54.515,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,25.875),(54.515,26.045),(54.685,26.045),(54.685,25.875),(54.515,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.235),(54.515,26.405),(54.685,26.405),(54.685,26.235),(54.515,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.595),(54.515,26.765),(54.685,26.765),(54.685,26.595),(54.515,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,26.955),(54.515,27.125),(54.685,27.125),(54.685,26.955),(54.515,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,27.315),(54.515,27.485),(54.685,27.485),(54.685,27.315),(54.515,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,27.675),(54.515,27.845),(54.685,27.845),(54.685,27.675),(54.515,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.035),(54.515,28.205),(54.685,28.205),(54.685,28.035),(54.515,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.395),(54.515,28.565),(54.685,28.565),(54.685,28.395),(54.515,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,28.755),(54.515,28.925),(54.685,28.925),(54.685,28.755),(54.515,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.115),(54.515,29.285),(54.685,29.285),(54.685,29.115),(54.515,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.475),(54.515,29.645),(54.685,29.645),(54.685,29.475),(54.515,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,29.835),(54.515,30.005),(54.685,30.005),(54.685,29.835),(54.515,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.195),(54.515,30.365),(54.685,30.365),(54.685,30.195),(54.515,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.555),(54.515,30.725),(54.685,30.725),(54.685,30.555),(54.515,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,30.915),(54.515,31.085),(54.685,31.085),(54.685,30.915),(54.515,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.275),(54.515,31.445),(54.685,31.445),(54.685,31.275),(54.515,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.635),(54.515,31.805),(54.685,31.805),(54.685,31.635),(54.515,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,31.995),(54.515,32.165),(54.685,32.165),(54.685,31.995),(54.515,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,32.355),(54.515,32.525),(54.685,32.525),(54.685,32.355),(54.515,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,32.715),(54.515,32.885),(54.685,32.885),(54.685,32.715),(54.515,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.075),(54.515,33.245),(54.685,33.245),(54.685,33.075),(54.515,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.435),(54.515,33.605),(54.685,33.605),(54.685,33.435),(54.515,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,33.795),(54.515,33.965),(54.685,33.965),(54.685,33.795),(54.515,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.155),(54.515,34.325),(54.685,34.325),(54.685,34.155),(54.515,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.515),(54.515,34.685),(54.685,34.685),(54.685,34.515),(54.515,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,34.875),(54.515,35.045),(54.685,35.045),(54.685,34.875),(54.515,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.235),(54.515,35.405),(54.685,35.405),(54.685,35.235),(54.515,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.595),(54.515,35.765),(54.685,35.765),(54.685,35.595),(54.515,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,35.955),(54.515,36.125),(54.685,36.125),(54.685,35.955),(54.515,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,36.315),(54.515,36.485),(54.685,36.485),(54.685,36.315),(54.515,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,36.675),(54.515,36.845),(54.685,36.845),(54.685,36.675),(54.515,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.035),(54.515,37.205),(54.685,37.205),(54.685,37.035),(54.515,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.395),(54.515,37.565),(54.685,37.565),(54.685,37.395),(54.515,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,37.755),(54.515,37.925),(54.685,37.925),(54.685,37.755),(54.515,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.115),(54.515,38.285),(54.685,38.285),(54.685,38.115),(54.515,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.475),(54.515,38.645),(54.685,38.645),(54.685,38.475),(54.515,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,38.835),(54.515,39.005),(54.685,39.005),(54.685,38.835),(54.515,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.195),(54.515,39.365),(54.685,39.365),(54.685,39.195),(54.515,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.555),(54.515,39.725),(54.685,39.725),(54.685,39.555),(54.515,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,39.915),(54.515,40.085),(54.685,40.085),(54.685,39.915),(54.515,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,40.275),(54.515,40.445),(54.685,40.445),(54.685,40.275),(54.515,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,40.635),(54.515,40.805),(54.685,40.805),(54.685,40.635),(54.515,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,2.835),(59.06,3.005),(59.23,3.005),(59.23,2.835),(59.06,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,3.195),(59.06,3.365),(59.23,3.365),(59.23,3.195),(59.06,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,3.555),(59.06,3.725),(59.23,3.725),(59.23,3.555),(59.06,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,3.915),(59.06,4.085),(59.23,4.085),(59.23,3.915),(59.06,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,4.275),(59.06,4.445),(59.23,4.445),(59.23,4.275),(59.06,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,4.635),(59.06,4.805),(59.23,4.805),(59.23,4.635),(59.06,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,4.995),(59.06,5.165),(59.23,5.165),(59.23,4.995),(59.06,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,5.355),(59.06,5.525),(59.23,5.525),(59.23,5.355),(59.06,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,5.715),(59.06,5.885),(59.23,5.885),(59.23,5.715),(59.06,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,6.075),(59.06,6.245),(59.23,6.245),(59.23,6.075),(59.06,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,6.435),(59.06,6.605),(59.23,6.605),(59.23,6.435),(59.06,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,6.795),(59.06,6.965),(59.23,6.965),(59.23,6.795),(59.06,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,7.155),(59.06,7.325),(59.23,7.325),(59.23,7.155),(59.06,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,7.515),(59.06,7.685),(59.23,7.685),(59.23,7.515),(59.06,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,7.875),(59.06,8.045),(59.23,8.045),(59.23,7.875),(59.06,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,8.235),(59.06,8.405),(59.23,8.405),(59.23,8.235),(59.06,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,8.595),(59.06,8.765),(59.23,8.765),(59.23,8.595),(59.06,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,8.955),(59.06,9.125),(59.23,9.125),(59.23,8.955),(59.06,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,9.315),(59.06,9.485),(59.23,9.485),(59.23,9.315),(59.06,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,9.675),(59.06,9.845),(59.23,9.845),(59.23,9.675),(59.06,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,10.035),(59.06,10.205),(59.23,10.205),(59.23,10.035),(59.06,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,10.395),(59.06,10.565),(59.23,10.565),(59.23,10.395),(59.06,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,10.755),(59.06,10.925),(59.23,10.925),(59.23,10.755),(59.06,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,11.115),(59.06,11.285),(59.23,11.285),(59.23,11.115),(59.06,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,11.475),(59.06,11.645),(59.23,11.645),(59.23,11.475),(59.06,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,11.835),(59.06,12.005),(59.23,12.005),(59.23,11.835),(59.06,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,12.195),(59.06,12.365),(59.23,12.365),(59.23,12.195),(59.06,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,12.555),(59.06,12.725),(59.23,12.725),(59.23,12.555),(59.06,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,12.915),(59.06,13.085),(59.23,13.085),(59.23,12.915),(59.06,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,13.275),(59.06,13.445),(59.23,13.445),(59.23,13.275),(59.06,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,13.635),(59.06,13.805),(59.23,13.805),(59.23,13.635),(59.06,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,13.995),(59.06,14.165),(59.23,14.165),(59.23,13.995),(59.06,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,14.355),(59.06,14.525),(59.23,14.525),(59.23,14.355),(59.06,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,14.715),(59.06,14.885),(59.23,14.885),(59.23,14.715),(59.06,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,15.075),(59.06,15.245),(59.23,15.245),(59.23,15.075),(59.06,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,15.435),(59.06,15.605),(59.23,15.605),(59.23,15.435),(59.06,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,15.795),(59.06,15.965),(59.23,15.965),(59.23,15.795),(59.06,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,16.155),(59.06,16.325),(59.23,16.325),(59.23,16.155),(59.06,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,16.515),(59.06,16.685),(59.23,16.685),(59.23,16.515),(59.06,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,16.875),(59.06,17.045),(59.23,17.045),(59.23,16.875),(59.06,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,17.235),(59.06,17.405),(59.23,17.405),(59.23,17.235),(59.06,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,17.595),(59.06,17.765),(59.23,17.765),(59.23,17.595),(59.06,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,17.955),(59.06,18.125),(59.23,18.125),(59.23,17.955),(59.06,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,18.315),(59.06,18.485),(59.23,18.485),(59.23,18.315),(59.06,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,18.675),(59.06,18.845),(59.23,18.845),(59.23,18.675),(59.06,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,19.035),(59.06,19.205),(59.23,19.205),(59.23,19.035),(59.06,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,19.395),(59.06,19.565),(59.23,19.565),(59.23,19.395),(59.06,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,19.755),(59.06,19.925),(59.23,19.925),(59.23,19.755),(59.06,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,20.115),(59.06,20.285),(59.23,20.285),(59.23,20.115),(59.06,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,20.475),(59.06,20.645),(59.23,20.645),(59.23,20.475),(59.06,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,20.835),(59.06,21.005),(59.23,21.005),(59.23,20.835),(59.06,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,21.195),(59.06,21.365),(59.23,21.365),(59.23,21.195),(59.06,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,21.555),(59.06,21.725),(59.23,21.725),(59.23,21.555),(59.06,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,21.915),(59.06,22.085),(59.23,22.085),(59.23,21.915),(59.06,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,22.275),(59.06,22.445),(59.23,22.445),(59.23,22.275),(59.06,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,22.635),(59.06,22.805),(59.23,22.805),(59.23,22.635),(59.06,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,22.995),(59.06,23.165),(59.23,23.165),(59.23,22.995),(59.06,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,23.355),(59.06,23.525),(59.23,23.525),(59.23,23.355),(59.06,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,23.715),(59.06,23.885),(59.23,23.885),(59.23,23.715),(59.06,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,24.075),(59.06,24.245),(59.23,24.245),(59.23,24.075),(59.06,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,24.435),(59.06,24.605),(59.23,24.605),(59.23,24.435),(59.06,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,24.795),(59.06,24.965),(59.23,24.965),(59.23,24.795),(59.06,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,25.155),(59.06,25.325),(59.23,25.325),(59.23,25.155),(59.06,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,25.515),(59.06,25.685),(59.23,25.685),(59.23,25.515),(59.06,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,25.875),(59.06,26.045),(59.23,26.045),(59.23,25.875),(59.06,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,26.235),(59.06,26.405),(59.23,26.405),(59.23,26.235),(59.06,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,26.595),(59.06,26.765),(59.23,26.765),(59.23,26.595),(59.06,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,26.955),(59.06,27.125),(59.23,27.125),(59.23,26.955),(59.06,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,27.315),(59.06,27.485),(59.23,27.485),(59.23,27.315),(59.06,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,27.675),(59.06,27.845),(59.23,27.845),(59.23,27.675),(59.06,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,28.035),(59.06,28.205),(59.23,28.205),(59.23,28.035),(59.06,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,28.395),(59.06,28.565),(59.23,28.565),(59.23,28.395),(59.06,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,28.755),(59.06,28.925),(59.23,28.925),(59.23,28.755),(59.06,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,29.115),(59.06,29.285),(59.23,29.285),(59.23,29.115),(59.06,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,29.475),(59.06,29.645),(59.23,29.645),(59.23,29.475),(59.06,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,29.835),(59.06,30.005),(59.23,30.005),(59.23,29.835),(59.06,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,30.195),(59.06,30.365),(59.23,30.365),(59.23,30.195),(59.06,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,30.555),(59.06,30.725),(59.23,30.725),(59.23,30.555),(59.06,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,30.915),(59.06,31.085),(59.23,31.085),(59.23,30.915),(59.06,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,31.275),(59.06,31.445),(59.23,31.445),(59.23,31.275),(59.06,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,31.635),(59.06,31.805),(59.23,31.805),(59.23,31.635),(59.06,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,31.995),(59.06,32.165),(59.23,32.165),(59.23,31.995),(59.06,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,32.355),(59.06,32.525),(59.23,32.525),(59.23,32.355),(59.06,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,32.715),(59.06,32.885),(59.23,32.885),(59.23,32.715),(59.06,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,33.075),(59.06,33.245),(59.23,33.245),(59.23,33.075),(59.06,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,33.435),(59.06,33.605),(59.23,33.605),(59.23,33.435),(59.06,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,33.795),(59.06,33.965),(59.23,33.965),(59.23,33.795),(59.06,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,34.155),(59.06,34.325),(59.23,34.325),(59.23,34.155),(59.06,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,34.515),(59.06,34.685),(59.23,34.685),(59.23,34.515),(59.06,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,34.875),(59.06,35.045),(59.23,35.045),(59.23,34.875),(59.06,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,35.235),(59.06,35.405),(59.23,35.405),(59.23,35.235),(59.06,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,35.595),(59.06,35.765),(59.23,35.765),(59.23,35.595),(59.06,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,35.955),(59.06,36.125),(59.23,36.125),(59.23,35.955),(59.06,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,36.315),(59.06,36.485),(59.23,36.485),(59.23,36.315),(59.06,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,36.675),(59.06,36.845),(59.23,36.845),(59.23,36.675),(59.06,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,37.035),(59.06,37.205),(59.23,37.205),(59.23,37.035),(59.06,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,37.395),(59.06,37.565),(59.23,37.565),(59.23,37.395),(59.06,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,37.755),(59.06,37.925),(59.23,37.925),(59.23,37.755),(59.06,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,38.115),(59.06,38.285),(59.23,38.285),(59.23,38.115),(59.06,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,38.475),(59.06,38.645),(59.23,38.645),(59.23,38.475),(59.06,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,38.835),(59.06,39.005),(59.23,39.005),(59.23,38.835),(59.06,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,39.195),(59.06,39.365),(59.23,39.365),(59.23,39.195),(59.06,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,39.555),(59.06,39.725),(59.23,39.725),(59.23,39.555),(59.06,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,39.915),(59.06,40.085),(59.23,40.085),(59.23,39.915),(59.06,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,40.275),(59.06,40.445),(59.23,40.445),(59.23,40.275),(59.06,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((59.06,40.635),(59.06,40.805),(59.23,40.805),(59.23,40.635),(59.06,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,2.835),(40.115,3.005),(40.285,3.005),(40.285,2.835),(40.115,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.195),(40.115,3.365),(40.285,3.365),(40.285,3.195),(40.115,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.555),(40.115,3.725),(40.285,3.725),(40.285,3.555),(40.115,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,3.915),(40.115,4.085),(40.285,4.085),(40.285,3.915),(40.115,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.275),(40.115,4.445),(40.285,4.445),(40.285,4.275),(40.115,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.635),(40.115,4.805),(40.285,4.805),(40.285,4.635),(40.115,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,4.995),(40.115,5.165),(40.285,5.165),(40.285,4.995),(40.115,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.355),(40.115,5.525),(40.285,5.525),(40.285,5.355),(40.115,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,5.715),(40.115,5.885),(40.285,5.885),(40.285,5.715),(40.115,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.075),(40.115,6.245),(40.285,6.245),(40.285,6.075),(40.115,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.435),(40.115,6.605),(40.285,6.605),(40.285,6.435),(40.115,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,6.795),(40.115,6.965),(40.285,6.965),(40.285,6.795),(40.115,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.155),(40.115,7.325),(40.285,7.325),(40.285,7.155),(40.115,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.515),(40.115,7.685),(40.285,7.685),(40.285,7.515),(40.115,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,7.875),(40.115,8.045),(40.285,8.045),(40.285,7.875),(40.115,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.235),(40.115,8.405),(40.285,8.405),(40.285,8.235),(40.115,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.595),(40.115,8.765),(40.285,8.765),(40.285,8.595),(40.115,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,8.955),(40.115,9.125),(40.285,9.125),(40.285,8.955),(40.115,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.315),(40.115,9.485),(40.285,9.485),(40.285,9.315),(40.115,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,9.675),(40.115,9.845),(40.285,9.845),(40.285,9.675),(40.115,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.035),(40.115,10.205),(40.285,10.205),(40.285,10.035),(40.115,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.395),(40.115,10.565),(40.285,10.565),(40.285,10.395),(40.115,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,10.755),(40.115,10.925),(40.285,10.925),(40.285,10.755),(40.115,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.115),(40.115,11.285),(40.285,11.285),(40.285,11.115),(40.115,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.475),(40.115,11.645),(40.285,11.645),(40.285,11.475),(40.115,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,11.835),(40.115,12.005),(40.285,12.005),(40.285,11.835),(40.115,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.195),(40.115,12.365),(40.285,12.365),(40.285,12.195),(40.115,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.555),(40.115,12.725),(40.285,12.725),(40.285,12.555),(40.115,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,12.915),(40.115,13.085),(40.285,13.085),(40.285,12.915),(40.115,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.275),(40.115,13.445),(40.285,13.445),(40.285,13.275),(40.115,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.635),(40.115,13.805),(40.285,13.805),(40.285,13.635),(40.115,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,13.995),(40.115,14.165),(40.285,14.165),(40.285,13.995),(40.115,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.355),(40.115,14.525),(40.285,14.525),(40.285,14.355),(40.115,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,14.715),(40.115,14.885),(40.285,14.885),(40.285,14.715),(40.115,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.075),(40.115,15.245),(40.285,15.245),(40.285,15.075),(40.115,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.435),(40.115,15.605),(40.285,15.605),(40.285,15.435),(40.115,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,15.795),(40.115,15.965),(40.285,15.965),(40.285,15.795),(40.115,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.155),(40.115,16.325),(40.285,16.325),(40.285,16.155),(40.115,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.515),(40.115,16.685),(40.285,16.685),(40.285,16.515),(40.115,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,16.875),(40.115,17.045),(40.285,17.045),(40.285,16.875),(40.115,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.235),(40.115,17.405),(40.285,17.405),(40.285,17.235),(40.115,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.595),(40.115,17.765),(40.285,17.765),(40.285,17.595),(40.115,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,17.955),(40.115,18.125),(40.285,18.125),(40.285,17.955),(40.115,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.315),(40.115,18.485),(40.285,18.485),(40.285,18.315),(40.115,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,18.675),(40.115,18.845),(40.285,18.845),(40.285,18.675),(40.115,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.035),(40.115,19.205),(40.285,19.205),(40.285,19.035),(40.115,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.395),(40.115,19.565),(40.285,19.565),(40.285,19.395),(40.115,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,19.755),(40.115,19.925),(40.285,19.925),(40.285,19.755),(40.115,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.115),(40.115,20.285),(40.285,20.285),(40.285,20.115),(40.115,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.475),(40.115,20.645),(40.285,20.645),(40.285,20.475),(40.115,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,20.835),(40.115,21.005),(40.285,21.005),(40.285,20.835),(40.115,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.195),(40.115,21.365),(40.285,21.365),(40.285,21.195),(40.115,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.555),(40.115,21.725),(40.285,21.725),(40.285,21.555),(40.115,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,21.915),(40.115,22.085),(40.285,22.085),(40.285,21.915),(40.115,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.275),(40.115,22.445),(40.285,22.445),(40.285,22.275),(40.115,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.635),(40.115,22.805),(40.285,22.805),(40.285,22.635),(40.115,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,22.995),(40.115,23.165),(40.285,23.165),(40.285,22.995),(40.115,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,23.355),(40.115,23.525),(40.285,23.525),(40.285,23.355),(40.115,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,23.715),(40.115,23.885),(40.285,23.885),(40.285,23.715),(40.115,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.075),(40.115,24.245),(40.285,24.245),(40.285,24.075),(40.115,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.435),(40.115,24.605),(40.285,24.605),(40.285,24.435),(40.115,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,24.795),(40.115,24.965),(40.285,24.965),(40.285,24.795),(40.115,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.155),(40.115,25.325),(40.285,25.325),(40.285,25.155),(40.115,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.515),(40.115,25.685),(40.285,25.685),(40.285,25.515),(40.115,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,25.875),(40.115,26.045),(40.285,26.045),(40.285,25.875),(40.115,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.235),(40.115,26.405),(40.285,26.405),(40.285,26.235),(40.115,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.595),(40.115,26.765),(40.285,26.765),(40.285,26.595),(40.115,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,26.955),(40.115,27.125),(40.285,27.125),(40.285,26.955),(40.115,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,27.315),(40.115,27.485),(40.285,27.485),(40.285,27.315),(40.115,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,27.675),(40.115,27.845),(40.285,27.845),(40.285,27.675),(40.115,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.035),(40.115,28.205),(40.285,28.205),(40.285,28.035),(40.115,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.395),(40.115,28.565),(40.285,28.565),(40.285,28.395),(40.115,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,28.755),(40.115,28.925),(40.285,28.925),(40.285,28.755),(40.115,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.115),(40.115,29.285),(40.285,29.285),(40.285,29.115),(40.115,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.475),(40.115,29.645),(40.285,29.645),(40.285,29.475),(40.115,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,29.835),(40.115,30.005),(40.285,30.005),(40.285,29.835),(40.115,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.195),(40.115,30.365),(40.285,30.365),(40.285,30.195),(40.115,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.555),(40.115,30.725),(40.285,30.725),(40.285,30.555),(40.115,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,30.915),(40.115,31.085),(40.285,31.085),(40.285,30.915),(40.115,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.275),(40.115,31.445),(40.285,31.445),(40.285,31.275),(40.115,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.635),(40.115,31.805),(40.285,31.805),(40.285,31.635),(40.115,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,31.995),(40.115,32.165),(40.285,32.165),(40.285,31.995),(40.115,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,32.355),(40.115,32.525),(40.285,32.525),(40.285,32.355),(40.115,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,32.715),(40.115,32.885),(40.285,32.885),(40.285,32.715),(40.115,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.075),(40.115,33.245),(40.285,33.245),(40.285,33.075),(40.115,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.435),(40.115,33.605),(40.285,33.605),(40.285,33.435),(40.115,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,33.795),(40.115,33.965),(40.285,33.965),(40.285,33.795),(40.115,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.155),(40.115,34.325),(40.285,34.325),(40.285,34.155),(40.115,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.515),(40.115,34.685),(40.285,34.685),(40.285,34.515),(40.115,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,34.875),(40.115,35.045),(40.285,35.045),(40.285,34.875),(40.115,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.235),(40.115,35.405),(40.285,35.405),(40.285,35.235),(40.115,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.595),(40.115,35.765),(40.285,35.765),(40.285,35.595),(40.115,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,35.955),(40.115,36.125),(40.285,36.125),(40.285,35.955),(40.115,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,36.315),(40.115,36.485),(40.285,36.485),(40.285,36.315),(40.115,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,36.675),(40.115,36.845),(40.285,36.845),(40.285,36.675),(40.115,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.035),(40.115,37.205),(40.285,37.205),(40.285,37.035),(40.115,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.395),(40.115,37.565),(40.285,37.565),(40.285,37.395),(40.115,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,37.755),(40.115,37.925),(40.285,37.925),(40.285,37.755),(40.115,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.115),(40.115,38.285),(40.285,38.285),(40.285,38.115),(40.115,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.475),(40.115,38.645),(40.285,38.645),(40.285,38.475),(40.115,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,38.835),(40.115,39.005),(40.285,39.005),(40.285,38.835),(40.115,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.195),(40.115,39.365),(40.285,39.365),(40.285,39.195),(40.115,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.555),(40.115,39.725),(40.285,39.725),(40.285,39.555),(40.115,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,39.915),(40.115,40.085),(40.285,40.085),(40.285,39.915),(40.115,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,40.275),(40.115,40.445),(40.285,40.445),(40.285,40.275),(40.115,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((40.115,40.635),(40.115,40.805),(40.285,40.805),(40.285,40.635),(40.115,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((54.515,41.735),(54.515,41.905),(54.685,41.905),(54.685,41.735),(54.515,41.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.58,21.44),(73.58,21.61),(73.75,21.61),(73.75,21.44),(73.58,21.44)),
        )
        createRL(
            tech, net, 'mcon',
            ((73.94,21.44),(73.94,21.61),(74.11,21.61),(74.11,21.44),(73.94,21.44)),
        )
        createRL(
            tech, net, 'mcon',
            ((44.915,1.735),(44.915,1.905),(45.085,1.905),(45.085,1.735),(44.915,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((30.77,1.735),(30.77,1.905),(30.94,1.905),(30.94,1.735),(30.77,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,1.735),(35.315,1.905),(35.485,1.905),(35.485,1.735),(35.315,1.735)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,2.835),(35.315,3.005),(35.485,3.005),(35.485,2.835),(35.315,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.195),(35.315,3.365),(35.485,3.365),(35.485,3.195),(35.315,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.555),(35.315,3.725),(35.485,3.725),(35.485,3.555),(35.315,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,3.915),(35.315,4.085),(35.485,4.085),(35.485,3.915),(35.315,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.275),(35.315,4.445),(35.485,4.445),(35.485,4.275),(35.315,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.635),(35.315,4.805),(35.485,4.805),(35.485,4.635),(35.315,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,4.995),(35.315,5.165),(35.485,5.165),(35.485,4.995),(35.315,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.355),(35.315,5.525),(35.485,5.525),(35.485,5.355),(35.315,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,5.715),(35.315,5.885),(35.485,5.885),(35.485,5.715),(35.315,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.075),(35.315,6.245),(35.485,6.245),(35.485,6.075),(35.315,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.435),(35.315,6.605),(35.485,6.605),(35.485,6.435),(35.315,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,6.795),(35.315,6.965),(35.485,6.965),(35.485,6.795),(35.315,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.155),(35.315,7.325),(35.485,7.325),(35.485,7.155),(35.315,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.515),(35.315,7.685),(35.485,7.685),(35.485,7.515),(35.315,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,7.875),(35.315,8.045),(35.485,8.045),(35.485,7.875),(35.315,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.235),(35.315,8.405),(35.485,8.405),(35.485,8.235),(35.315,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.595),(35.315,8.765),(35.485,8.765),(35.485,8.595),(35.315,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,8.955),(35.315,9.125),(35.485,9.125),(35.485,8.955),(35.315,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.315),(35.315,9.485),(35.485,9.485),(35.485,9.315),(35.315,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,9.675),(35.315,9.845),(35.485,9.845),(35.485,9.675),(35.315,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.035),(35.315,10.205),(35.485,10.205),(35.485,10.035),(35.315,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.395),(35.315,10.565),(35.485,10.565),(35.485,10.395),(35.315,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,10.755),(35.315,10.925),(35.485,10.925),(35.485,10.755),(35.315,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.115),(35.315,11.285),(35.485,11.285),(35.485,11.115),(35.315,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.475),(35.315,11.645),(35.485,11.645),(35.485,11.475),(35.315,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,11.835),(35.315,12.005),(35.485,12.005),(35.485,11.835),(35.315,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.195),(35.315,12.365),(35.485,12.365),(35.485,12.195),(35.315,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.555),(35.315,12.725),(35.485,12.725),(35.485,12.555),(35.315,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,12.915),(35.315,13.085),(35.485,13.085),(35.485,12.915),(35.315,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.275),(35.315,13.445),(35.485,13.445),(35.485,13.275),(35.315,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.635),(35.315,13.805),(35.485,13.805),(35.485,13.635),(35.315,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,13.995),(35.315,14.165),(35.485,14.165),(35.485,13.995),(35.315,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.355),(35.315,14.525),(35.485,14.525),(35.485,14.355),(35.315,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,14.715),(35.315,14.885),(35.485,14.885),(35.485,14.715),(35.315,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.075),(35.315,15.245),(35.485,15.245),(35.485,15.075),(35.315,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.435),(35.315,15.605),(35.485,15.605),(35.485,15.435),(35.315,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,15.795),(35.315,15.965),(35.485,15.965),(35.485,15.795),(35.315,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.155),(35.315,16.325),(35.485,16.325),(35.485,16.155),(35.315,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.515),(35.315,16.685),(35.485,16.685),(35.485,16.515),(35.315,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,16.875),(35.315,17.045),(35.485,17.045),(35.485,16.875),(35.315,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.235),(35.315,17.405),(35.485,17.405),(35.485,17.235),(35.315,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.595),(35.315,17.765),(35.485,17.765),(35.485,17.595),(35.315,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,17.955),(35.315,18.125),(35.485,18.125),(35.485,17.955),(35.315,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.315),(35.315,18.485),(35.485,18.485),(35.485,18.315),(35.315,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,18.675),(35.315,18.845),(35.485,18.845),(35.485,18.675),(35.315,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.035),(35.315,19.205),(35.485,19.205),(35.485,19.035),(35.315,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.395),(35.315,19.565),(35.485,19.565),(35.485,19.395),(35.315,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,19.755),(35.315,19.925),(35.485,19.925),(35.485,19.755),(35.315,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.115),(35.315,20.285),(35.485,20.285),(35.485,20.115),(35.315,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.475),(35.315,20.645),(35.485,20.645),(35.485,20.475),(35.315,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,20.835),(35.315,21.005),(35.485,21.005),(35.485,20.835),(35.315,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.195),(35.315,21.365),(35.485,21.365),(35.485,21.195),(35.315,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.555),(35.315,21.725),(35.485,21.725),(35.485,21.555),(35.315,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,21.915),(35.315,22.085),(35.485,22.085),(35.485,21.915),(35.315,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.275),(35.315,22.445),(35.485,22.445),(35.485,22.275),(35.315,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.635),(35.315,22.805),(35.485,22.805),(35.485,22.635),(35.315,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,22.995),(35.315,23.165),(35.485,23.165),(35.485,22.995),(35.315,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,23.355),(35.315,23.525),(35.485,23.525),(35.485,23.355),(35.315,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,23.715),(35.315,23.885),(35.485,23.885),(35.485,23.715),(35.315,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.075),(35.315,24.245),(35.485,24.245),(35.485,24.075),(35.315,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.435),(35.315,24.605),(35.485,24.605),(35.485,24.435),(35.315,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,24.795),(35.315,24.965),(35.485,24.965),(35.485,24.795),(35.315,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.155),(35.315,25.325),(35.485,25.325),(35.485,25.155),(35.315,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.515),(35.315,25.685),(35.485,25.685),(35.485,25.515),(35.315,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,25.875),(35.315,26.045),(35.485,26.045),(35.485,25.875),(35.315,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.235),(35.315,26.405),(35.485,26.405),(35.485,26.235),(35.315,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.595),(35.315,26.765),(35.485,26.765),(35.485,26.595),(35.315,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,26.955),(35.315,27.125),(35.485,27.125),(35.485,26.955),(35.315,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,27.315),(35.315,27.485),(35.485,27.485),(35.485,27.315),(35.315,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,27.675),(35.315,27.845),(35.485,27.845),(35.485,27.675),(35.315,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.035),(35.315,28.205),(35.485,28.205),(35.485,28.035),(35.315,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.395),(35.315,28.565),(35.485,28.565),(35.485,28.395),(35.315,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,28.755),(35.315,28.925),(35.485,28.925),(35.485,28.755),(35.315,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.115),(35.315,29.285),(35.485,29.285),(35.485,29.115),(35.315,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.475),(35.315,29.645),(35.485,29.645),(35.485,29.475),(35.315,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,29.835),(35.315,30.005),(35.485,30.005),(35.485,29.835),(35.315,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.195),(35.315,30.365),(35.485,30.365),(35.485,30.195),(35.315,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.555),(35.315,30.725),(35.485,30.725),(35.485,30.555),(35.315,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,30.915),(35.315,31.085),(35.485,31.085),(35.485,30.915),(35.315,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.275),(35.315,31.445),(35.485,31.445),(35.485,31.275),(35.315,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.635),(35.315,31.805),(35.485,31.805),(35.485,31.635),(35.315,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,31.995),(35.315,32.165),(35.485,32.165),(35.485,31.995),(35.315,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,32.355),(35.315,32.525),(35.485,32.525),(35.485,32.355),(35.315,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,32.715),(35.315,32.885),(35.485,32.885),(35.485,32.715),(35.315,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.075),(35.315,33.245),(35.485,33.245),(35.485,33.075),(35.315,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.435),(35.315,33.605),(35.485,33.605),(35.485,33.435),(35.315,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,33.795),(35.315,33.965),(35.485,33.965),(35.485,33.795),(35.315,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.155),(35.315,34.325),(35.485,34.325),(35.485,34.155),(35.315,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.515),(35.315,34.685),(35.485,34.685),(35.485,34.515),(35.315,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,34.875),(35.315,35.045),(35.485,35.045),(35.485,34.875),(35.315,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.235),(35.315,35.405),(35.485,35.405),(35.485,35.235),(35.315,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.595),(35.315,35.765),(35.485,35.765),(35.485,35.595),(35.315,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,35.955),(35.315,36.125),(35.485,36.125),(35.485,35.955),(35.315,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,36.315),(35.315,36.485),(35.485,36.485),(35.485,36.315),(35.315,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,36.675),(35.315,36.845),(35.485,36.845),(35.485,36.675),(35.315,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.035),(35.315,37.205),(35.485,37.205),(35.485,37.035),(35.315,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.395),(35.315,37.565),(35.485,37.565),(35.485,37.395),(35.315,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,37.755),(35.315,37.925),(35.485,37.925),(35.485,37.755),(35.315,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.115),(35.315,38.285),(35.485,38.285),(35.485,38.115),(35.315,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.475),(35.315,38.645),(35.485,38.645),(35.485,38.475),(35.315,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,38.835),(35.315,39.005),(35.485,39.005),(35.485,38.835),(35.315,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.195),(35.315,39.365),(35.485,39.365),(35.485,39.195),(35.315,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.555),(35.315,39.725),(35.485,39.725),(35.485,39.555),(35.315,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,39.915),(35.315,40.085),(35.485,40.085),(35.485,39.915),(35.315,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,40.275),(35.315,40.445),(35.485,40.445),(35.485,40.275),(35.315,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((35.315,40.635),(35.315,40.805),(35.485,40.805),(35.485,40.635),(35.315,40.635)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,41.675),(44.885,41.965),(45.115,41.965),(45.115,41.675),(44.885,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,2.775),(59.03,40.865),(59.26,40.865),(59.26,2.775),(59.03,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,41.675),(59.03,41.965),(59.26,41.965),(59.26,41.675),(59.03,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,1.675),(73.55,21.67),(74.14,21.67),(74.14,1.675),(73.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,1.675),(40.085,1.965),(40.315,1.965),(40.315,1.675),(40.085,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.06),(49.67,43.58),(49.93,43.58),(49.93,0.06),(49.67,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,0.0),(49.685,43.64),(49.915,43.64),(49.915,0.0),(49.685,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.67,0.0),(49.67,43.64),(49.93,43.64),(49.93,0.0),(49.67,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,1.675),(49.685,1.965),(49.915,1.965),(49.915,1.675),(49.685,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,21.38),(73.55,21.67),(74.14,21.67),(74.14,21.38),(73.55,21.38)),
        )
        createRL(
            tech, net, 'm1',
            ((73.55,1.675),(73.55,1.965),(74.14,1.965),(74.14,1.675),(73.55,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,1.675),(59.03,1.965),(59.26,1.965),(59.26,1.675),(59.03,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,41.675),(49.685,41.965),(49.915,41.965),(49.915,41.675),(49.685,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,0.0),(40.085,43.64),(40.315,43.64),(40.315,0.0),(40.085,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.06),(40.07,43.58),(40.33,43.58),(40.33,0.06),(40.07,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,0.0),(35.285,43.64),(35.515,43.64),(35.515,0.0),(35.285,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.06),(35.27,43.58),(35.53,43.58),(35.53,0.06),(35.27,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((35.27,0.0),(35.27,43.64),(35.53,43.64),(35.53,0.0),(35.27,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,1.675),(54.485,1.965),(54.715,1.965),(54.715,1.675),(54.485,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((40.07,0.0),(40.07,43.64),(40.33,43.64),(40.33,0.0),(40.07,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,41.675),(40.085,41.965),(40.315,41.965),(40.315,41.675),(40.085,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,2.775),(44.885,40.865),(45.115,40.865),(45.115,2.775),(44.885,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((49.685,2.775),(49.685,40.865),(49.915,40.865),(49.915,2.775),(49.685,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,41.675),(30.74,41.965),(30.97,41.965),(30.97,41.675),(30.74,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,2.775),(35.285,40.865),(35.515,40.865),(35.515,2.775),(35.285,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,41.675),(35.285,41.965),(35.515,41.965),(35.515,41.675),(35.285,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,0.0),(30.725,43.64),(30.985,43.64),(30.985,0.0),(30.725,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.725,0.06),(30.725,43.58),(30.985,43.58),(30.985,0.06),(30.725,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,0.0),(30.74,43.64),(30.97,43.64),(30.97,0.0),(30.74,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((40.085,2.775),(40.085,40.865),(40.315,40.865),(40.315,2.775),(40.085,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,41.675),(54.485,41.965),(54.715,41.965),(54.715,41.675),(54.485,41.675)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,0.0),(54.485,43.64),(54.715,43.64),(54.715,0.0),(54.485,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.0),(54.47,43.64),(54.73,43.64),(54.73,0.0),(54.47,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.47,0.06),(54.47,43.58),(54.73,43.58),(54.73,0.06),(54.47,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,1.675),(44.885,1.965),(45.115,1.965),(45.115,1.675),(44.885,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,1.675),(30.74,1.965),(30.97,1.965),(30.97,1.675),(30.74,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((35.285,1.675),(35.285,1.965),(35.515,1.965),(35.515,1.675),(35.285,1.675)),
        )
        createRL(
            tech, net, 'm1',
            ((44.885,0.0),(44.885,43.64),(45.115,43.64),(45.115,0.0),(44.885,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.06),(44.87,43.58),(45.13,43.58),(45.13,0.06),(44.87,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((44.87,0.0),(44.87,43.64),(45.13,43.64),(45.13,0.0),(44.87,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((30.74,2.775),(30.74,40.865),(30.97,40.865),(30.97,2.775),(30.74,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((59.03,0.0),(59.03,43.64),(59.26,43.64),(59.26,0.0),(59.03,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,0.06),(59.015,43.58),(59.275,43.58),(59.275,0.06),(59.015,0.06)),
        )
        createRL(
            tech, net, 'm1',
            ((59.015,0.0),(59.015,43.64),(59.275,43.64),(59.275,0.0),(59.015,0.0)),
        )
        createRL(
            tech, net, 'm1',
            ((54.485,2.775),(54.485,40.865),(54.715,40.865),(54.715,2.775),(54.485,2.775)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.145),(35.325,0.295),(35.475,0.295),(35.475,0.145),(35.325,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.465),(35.325,0.615),(35.475,0.615),(35.475,0.465),(35.325,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,0.785),(35.325,0.935),(35.475,0.935),(35.475,0.785),(35.325,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.105),(35.325,1.255),(35.475,1.255),(35.475,1.105),(35.325,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.425),(35.325,1.575),(35.475,1.575),(35.475,1.425),(35.325,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,1.745),(35.325,1.895),(35.475,1.895),(35.475,1.745),(35.325,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.065),(35.325,2.215),(35.475,2.215),(35.475,2.065),(35.325,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.385),(35.325,2.535),(35.475,2.535),(35.475,2.385),(35.325,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,2.705),(35.325,2.855),(35.475,2.855),(35.475,2.705),(35.325,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.025),(35.325,3.175),(35.475,3.175),(35.475,3.025),(35.325,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.345),(35.325,3.495),(35.475,3.495),(35.475,3.345),(35.325,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.665),(35.325,3.815),(35.475,3.815),(35.475,3.665),(35.325,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,3.985),(35.325,4.135),(35.475,4.135),(35.475,3.985),(35.325,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.305),(35.325,4.455),(35.475,4.455),(35.475,4.305),(35.325,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.625),(35.325,4.775),(35.475,4.775),(35.475,4.625),(35.325,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,4.945),(35.325,5.095),(35.475,5.095),(35.475,4.945),(35.325,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.265),(35.325,5.415),(35.475,5.415),(35.475,5.265),(35.325,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.585),(35.325,5.735),(35.475,5.735),(35.475,5.585),(35.325,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,5.905),(35.325,6.055),(35.475,6.055),(35.475,5.905),(35.325,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.225),(35.325,6.375),(35.475,6.375),(35.475,6.225),(35.325,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.545),(35.325,6.695),(35.475,6.695),(35.475,6.545),(35.325,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,6.865),(35.325,7.015),(35.475,7.015),(35.475,6.865),(35.325,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.185),(35.325,7.335),(35.475,7.335),(35.475,7.185),(35.325,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.505),(35.325,7.655),(35.475,7.655),(35.475,7.505),(35.325,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,7.825),(35.325,7.975),(35.475,7.975),(35.475,7.825),(35.325,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.145),(35.325,8.295),(35.475,8.295),(35.475,8.145),(35.325,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.465),(35.325,8.615),(35.475,8.615),(35.475,8.465),(35.325,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,8.785),(35.325,8.935),(35.475,8.935),(35.475,8.785),(35.325,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.105),(35.325,9.255),(35.475,9.255),(35.475,9.105),(35.325,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.425),(35.325,9.575),(35.475,9.575),(35.475,9.425),(35.325,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,9.745),(35.325,9.895),(35.475,9.895),(35.475,9.745),(35.325,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.065),(35.325,10.215),(35.475,10.215),(35.475,10.065),(35.325,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.385),(35.325,10.535),(35.475,10.535),(35.475,10.385),(35.325,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,10.705),(35.325,10.855),(35.475,10.855),(35.475,10.705),(35.325,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.025),(35.325,11.175),(35.475,11.175),(35.475,11.025),(35.325,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.345),(35.325,11.495),(35.475,11.495),(35.475,11.345),(35.325,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.665),(35.325,11.815),(35.475,11.815),(35.475,11.665),(35.325,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,11.985),(35.325,12.135),(35.475,12.135),(35.475,11.985),(35.325,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.305),(35.325,12.455),(35.475,12.455),(35.475,12.305),(35.325,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.625),(35.325,12.775),(35.475,12.775),(35.475,12.625),(35.325,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,12.945),(35.325,13.095),(35.475,13.095),(35.475,12.945),(35.325,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.265),(35.325,13.415),(35.475,13.415),(35.475,13.265),(35.325,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.585),(35.325,13.735),(35.475,13.735),(35.475,13.585),(35.325,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,13.905),(35.325,14.055),(35.475,14.055),(35.475,13.905),(35.325,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.225),(35.325,14.375),(35.475,14.375),(35.475,14.225),(35.325,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.545),(35.325,14.695),(35.475,14.695),(35.475,14.545),(35.325,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,14.865),(35.325,15.015),(35.475,15.015),(35.475,14.865),(35.325,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.185),(35.325,15.335),(35.475,15.335),(35.475,15.185),(35.325,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.505),(35.325,15.655),(35.475,15.655),(35.475,15.505),(35.325,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,15.825),(35.325,15.975),(35.475,15.975),(35.475,15.825),(35.325,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.145),(35.325,16.295),(35.475,16.295),(35.475,16.145),(35.325,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.465),(35.325,16.615),(35.475,16.615),(35.475,16.465),(35.325,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,16.785),(35.325,16.935),(35.475,16.935),(35.475,16.785),(35.325,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.105),(35.325,17.255),(35.475,17.255),(35.475,17.105),(35.325,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.425),(35.325,17.575),(35.475,17.575),(35.475,17.425),(35.325,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,17.745),(35.325,17.895),(35.475,17.895),(35.475,17.745),(35.325,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.065),(35.325,18.215),(35.475,18.215),(35.475,18.065),(35.325,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.385),(35.325,18.535),(35.475,18.535),(35.475,18.385),(35.325,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,18.705),(35.325,18.855),(35.475,18.855),(35.475,18.705),(35.325,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.025),(35.325,19.175),(35.475,19.175),(35.475,19.025),(35.325,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.345),(35.325,19.495),(35.475,19.495),(35.475,19.345),(35.325,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.665),(35.325,19.815),(35.475,19.815),(35.475,19.665),(35.325,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,19.985),(35.325,20.135),(35.475,20.135),(35.475,19.985),(35.325,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.305),(35.325,20.455),(35.475,20.455),(35.475,20.305),(35.325,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.625),(35.325,20.775),(35.475,20.775),(35.475,20.625),(35.325,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,20.945),(35.325,21.095),(35.475,21.095),(35.475,20.945),(35.325,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.265),(35.325,21.415),(35.475,21.415),(35.475,21.265),(35.325,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.585),(35.325,21.735),(35.475,21.735),(35.475,21.585),(35.325,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,21.905),(35.325,22.055),(35.475,22.055),(35.475,21.905),(35.325,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.225),(35.325,22.375),(35.475,22.375),(35.475,22.225),(35.325,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.545),(35.325,22.695),(35.475,22.695),(35.475,22.545),(35.325,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,22.865),(35.325,23.015),(35.475,23.015),(35.475,22.865),(35.325,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.185),(35.325,23.335),(35.475,23.335),(35.475,23.185),(35.325,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.505),(35.325,23.655),(35.475,23.655),(35.475,23.505),(35.325,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,23.825),(35.325,23.975),(35.475,23.975),(35.475,23.825),(35.325,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.145),(35.325,24.295),(35.475,24.295),(35.475,24.145),(35.325,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.465),(35.325,24.615),(35.475,24.615),(35.475,24.465),(35.325,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,24.785),(35.325,24.935),(35.475,24.935),(35.475,24.785),(35.325,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.105),(35.325,25.255),(35.475,25.255),(35.475,25.105),(35.325,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.425),(35.325,25.575),(35.475,25.575),(35.475,25.425),(35.325,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,25.745),(35.325,25.895),(35.475,25.895),(35.475,25.745),(35.325,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.065),(35.325,26.215),(35.475,26.215),(35.475,26.065),(35.325,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.385),(35.325,26.535),(35.475,26.535),(35.475,26.385),(35.325,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,26.705),(35.325,26.855),(35.475,26.855),(35.475,26.705),(35.325,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.025),(35.325,27.175),(35.475,27.175),(35.475,27.025),(35.325,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.345),(35.325,27.495),(35.475,27.495),(35.475,27.345),(35.325,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.665),(35.325,27.815),(35.475,27.815),(35.475,27.665),(35.325,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,27.985),(35.325,28.135),(35.475,28.135),(35.475,27.985),(35.325,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.305),(35.325,28.455),(35.475,28.455),(35.475,28.305),(35.325,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.625),(35.325,28.775),(35.475,28.775),(35.475,28.625),(35.325,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,28.945),(35.325,29.095),(35.475,29.095),(35.475,28.945),(35.325,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.265),(35.325,29.415),(35.475,29.415),(35.475,29.265),(35.325,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.585),(35.325,29.735),(35.475,29.735),(35.475,29.585),(35.325,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,29.905),(35.325,30.055),(35.475,30.055),(35.475,29.905),(35.325,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.225),(35.325,30.375),(35.475,30.375),(35.475,30.225),(35.325,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.545),(35.325,30.695),(35.475,30.695),(35.475,30.545),(35.325,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,30.865),(35.325,31.015),(35.475,31.015),(35.475,30.865),(35.325,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.185),(35.325,31.335),(35.475,31.335),(35.475,31.185),(35.325,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.505),(35.325,31.655),(35.475,31.655),(35.475,31.505),(35.325,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,31.825),(35.325,31.975),(35.475,31.975),(35.475,31.825),(35.325,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.145),(35.325,32.295),(35.475,32.295),(35.475,32.145),(35.325,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.465),(35.325,32.615),(35.475,32.615),(35.475,32.465),(35.325,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,32.785),(35.325,32.935),(35.475,32.935),(35.475,32.785),(35.325,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.105),(35.325,33.255),(35.475,33.255),(35.475,33.105),(35.325,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.425),(35.325,33.575),(35.475,33.575),(35.475,33.425),(35.325,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,33.745),(35.325,33.895),(35.475,33.895),(35.475,33.745),(35.325,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.065),(35.325,34.215),(35.475,34.215),(35.475,34.065),(35.325,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.385),(35.325,34.535),(35.475,34.535),(35.475,34.385),(35.325,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,34.705),(35.325,34.855),(35.475,34.855),(35.475,34.705),(35.325,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.025),(35.325,35.175),(35.475,35.175),(35.475,35.025),(35.325,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.345),(35.325,35.495),(35.475,35.495),(35.475,35.345),(35.325,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.665),(35.325,35.815),(35.475,35.815),(35.475,35.665),(35.325,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,35.985),(35.325,36.135),(35.475,36.135),(35.475,35.985),(35.325,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.305),(35.325,36.455),(35.475,36.455),(35.475,36.305),(35.325,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.625),(35.325,36.775),(35.475,36.775),(35.475,36.625),(35.325,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,36.945),(35.325,37.095),(35.475,37.095),(35.475,36.945),(35.325,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.265),(35.325,37.415),(35.475,37.415),(35.475,37.265),(35.325,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.585),(35.325,37.735),(35.475,37.735),(35.475,37.585),(35.325,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,37.905),(35.325,38.055),(35.475,38.055),(35.475,37.905),(35.325,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.225),(35.325,38.375),(35.475,38.375),(35.475,38.225),(35.325,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.545),(35.325,38.695),(35.475,38.695),(35.475,38.545),(35.325,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,38.865),(35.325,39.015),(35.475,39.015),(35.475,38.865),(35.325,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.185),(35.325,39.335),(35.475,39.335),(35.475,39.185),(35.325,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.505),(35.325,39.655),(35.475,39.655),(35.475,39.505),(35.325,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,39.825),(35.325,39.975),(35.475,39.975),(35.475,39.825),(35.325,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.145),(35.325,40.295),(35.475,40.295),(35.475,40.145),(35.325,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.465),(35.325,40.615),(35.475,40.615),(35.475,40.465),(35.325,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,40.785),(35.325,40.935),(35.475,40.935),(35.475,40.785),(35.325,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.105),(35.325,41.255),(35.475,41.255),(35.475,41.105),(35.325,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.425),(35.325,41.575),(35.475,41.575),(35.475,41.425),(35.325,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,41.745),(35.325,41.895),(35.475,41.895),(35.475,41.745),(35.325,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.065),(35.325,42.215),(35.475,42.215),(35.475,42.065),(35.325,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.385),(35.325,42.535),(35.475,42.535),(35.475,42.385),(35.325,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,42.705),(35.325,42.855),(35.475,42.855),(35.475,42.705),(35.325,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,43.025),(35.325,43.175),(35.475,43.175),(35.475,43.025),(35.325,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((35.325,43.345),(35.325,43.495),(35.475,43.495),(35.475,43.345),(35.325,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.145),(40.125,0.295),(40.275,0.295),(40.275,0.145),(40.125,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.465),(40.125,0.615),(40.275,0.615),(40.275,0.465),(40.125,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,0.785),(40.125,0.935),(40.275,0.935),(40.275,0.785),(40.125,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.105),(40.125,1.255),(40.275,1.255),(40.275,1.105),(40.125,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.425),(40.125,1.575),(40.275,1.575),(40.275,1.425),(40.125,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,1.745),(40.125,1.895),(40.275,1.895),(40.275,1.745),(40.125,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.065),(40.125,2.215),(40.275,2.215),(40.275,2.065),(40.125,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.385),(40.125,2.535),(40.275,2.535),(40.275,2.385),(40.125,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,2.705),(40.125,2.855),(40.275,2.855),(40.275,2.705),(40.125,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.025),(40.125,3.175),(40.275,3.175),(40.275,3.025),(40.125,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.345),(40.125,3.495),(40.275,3.495),(40.275,3.345),(40.125,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.665),(40.125,3.815),(40.275,3.815),(40.275,3.665),(40.125,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,3.985),(40.125,4.135),(40.275,4.135),(40.275,3.985),(40.125,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.305),(40.125,4.455),(40.275,4.455),(40.275,4.305),(40.125,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.625),(40.125,4.775),(40.275,4.775),(40.275,4.625),(40.125,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,4.945),(40.125,5.095),(40.275,5.095),(40.275,4.945),(40.125,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.265),(40.125,5.415),(40.275,5.415),(40.275,5.265),(40.125,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.585),(40.125,5.735),(40.275,5.735),(40.275,5.585),(40.125,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,5.905),(40.125,6.055),(40.275,6.055),(40.275,5.905),(40.125,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.225),(40.125,6.375),(40.275,6.375),(40.275,6.225),(40.125,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.545),(40.125,6.695),(40.275,6.695),(40.275,6.545),(40.125,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,6.865),(40.125,7.015),(40.275,7.015),(40.275,6.865),(40.125,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.185),(40.125,7.335),(40.275,7.335),(40.275,7.185),(40.125,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.505),(40.125,7.655),(40.275,7.655),(40.275,7.505),(40.125,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,7.825),(40.125,7.975),(40.275,7.975),(40.275,7.825),(40.125,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.145),(40.125,8.295),(40.275,8.295),(40.275,8.145),(40.125,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.465),(40.125,8.615),(40.275,8.615),(40.275,8.465),(40.125,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,8.785),(40.125,8.935),(40.275,8.935),(40.275,8.785),(40.125,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.105),(40.125,9.255),(40.275,9.255),(40.275,9.105),(40.125,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.425),(40.125,9.575),(40.275,9.575),(40.275,9.425),(40.125,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,9.745),(40.125,9.895),(40.275,9.895),(40.275,9.745),(40.125,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.065),(40.125,10.215),(40.275,10.215),(40.275,10.065),(40.125,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.385),(40.125,10.535),(40.275,10.535),(40.275,10.385),(40.125,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,10.705),(40.125,10.855),(40.275,10.855),(40.275,10.705),(40.125,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.025),(40.125,11.175),(40.275,11.175),(40.275,11.025),(40.125,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.345),(40.125,11.495),(40.275,11.495),(40.275,11.345),(40.125,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.665),(40.125,11.815),(40.275,11.815),(40.275,11.665),(40.125,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,11.985),(40.125,12.135),(40.275,12.135),(40.275,11.985),(40.125,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.305),(40.125,12.455),(40.275,12.455),(40.275,12.305),(40.125,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.625),(40.125,12.775),(40.275,12.775),(40.275,12.625),(40.125,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,12.945),(40.125,13.095),(40.275,13.095),(40.275,12.945),(40.125,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.265),(40.125,13.415),(40.275,13.415),(40.275,13.265),(40.125,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.585),(40.125,13.735),(40.275,13.735),(40.275,13.585),(40.125,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,13.905),(40.125,14.055),(40.275,14.055),(40.275,13.905),(40.125,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.225),(40.125,14.375),(40.275,14.375),(40.275,14.225),(40.125,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.545),(40.125,14.695),(40.275,14.695),(40.275,14.545),(40.125,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,14.865),(40.125,15.015),(40.275,15.015),(40.275,14.865),(40.125,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.185),(40.125,15.335),(40.275,15.335),(40.275,15.185),(40.125,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.505),(40.125,15.655),(40.275,15.655),(40.275,15.505),(40.125,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,15.825),(40.125,15.975),(40.275,15.975),(40.275,15.825),(40.125,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.145),(40.125,16.295),(40.275,16.295),(40.275,16.145),(40.125,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.465),(40.125,16.615),(40.275,16.615),(40.275,16.465),(40.125,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,16.785),(40.125,16.935),(40.275,16.935),(40.275,16.785),(40.125,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.105),(40.125,17.255),(40.275,17.255),(40.275,17.105),(40.125,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.425),(40.125,17.575),(40.275,17.575),(40.275,17.425),(40.125,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,17.745),(40.125,17.895),(40.275,17.895),(40.275,17.745),(40.125,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.065),(40.125,18.215),(40.275,18.215),(40.275,18.065),(40.125,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.385),(40.125,18.535),(40.275,18.535),(40.275,18.385),(40.125,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,18.705),(40.125,18.855),(40.275,18.855),(40.275,18.705),(40.125,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.025),(40.125,19.175),(40.275,19.175),(40.275,19.025),(40.125,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.345),(40.125,19.495),(40.275,19.495),(40.275,19.345),(40.125,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.665),(40.125,19.815),(40.275,19.815),(40.275,19.665),(40.125,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,19.985),(40.125,20.135),(40.275,20.135),(40.275,19.985),(40.125,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.305),(40.125,20.455),(40.275,20.455),(40.275,20.305),(40.125,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.625),(40.125,20.775),(40.275,20.775),(40.275,20.625),(40.125,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,20.945),(40.125,21.095),(40.275,21.095),(40.275,20.945),(40.125,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.265),(40.125,21.415),(40.275,21.415),(40.275,21.265),(40.125,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.585),(40.125,21.735),(40.275,21.735),(40.275,21.585),(40.125,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,21.905),(40.125,22.055),(40.275,22.055),(40.275,21.905),(40.125,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.225),(40.125,22.375),(40.275,22.375),(40.275,22.225),(40.125,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.545),(40.125,22.695),(40.275,22.695),(40.275,22.545),(40.125,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,22.865),(40.125,23.015),(40.275,23.015),(40.275,22.865),(40.125,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.185),(40.125,23.335),(40.275,23.335),(40.275,23.185),(40.125,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.505),(40.125,23.655),(40.275,23.655),(40.275,23.505),(40.125,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,23.825),(40.125,23.975),(40.275,23.975),(40.275,23.825),(40.125,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.145),(40.125,24.295),(40.275,24.295),(40.275,24.145),(40.125,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.465),(40.125,24.615),(40.275,24.615),(40.275,24.465),(40.125,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,24.785),(40.125,24.935),(40.275,24.935),(40.275,24.785),(40.125,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.105),(40.125,25.255),(40.275,25.255),(40.275,25.105),(40.125,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.425),(40.125,25.575),(40.275,25.575),(40.275,25.425),(40.125,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,25.745),(40.125,25.895),(40.275,25.895),(40.275,25.745),(40.125,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.065),(40.125,26.215),(40.275,26.215),(40.275,26.065),(40.125,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.385),(40.125,26.535),(40.275,26.535),(40.275,26.385),(40.125,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,26.705),(40.125,26.855),(40.275,26.855),(40.275,26.705),(40.125,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.025),(40.125,27.175),(40.275,27.175),(40.275,27.025),(40.125,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.345),(40.125,27.495),(40.275,27.495),(40.275,27.345),(40.125,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.665),(40.125,27.815),(40.275,27.815),(40.275,27.665),(40.125,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,27.985),(40.125,28.135),(40.275,28.135),(40.275,27.985),(40.125,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.305),(40.125,28.455),(40.275,28.455),(40.275,28.305),(40.125,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.625),(40.125,28.775),(40.275,28.775),(40.275,28.625),(40.125,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,28.945),(40.125,29.095),(40.275,29.095),(40.275,28.945),(40.125,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.265),(40.125,29.415),(40.275,29.415),(40.275,29.265),(40.125,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.585),(40.125,29.735),(40.275,29.735),(40.275,29.585),(40.125,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,29.905),(40.125,30.055),(40.275,30.055),(40.275,29.905),(40.125,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.225),(40.125,30.375),(40.275,30.375),(40.275,30.225),(40.125,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.545),(40.125,30.695),(40.275,30.695),(40.275,30.545),(40.125,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,30.865),(40.125,31.015),(40.275,31.015),(40.275,30.865),(40.125,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.185),(40.125,31.335),(40.275,31.335),(40.275,31.185),(40.125,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.505),(40.125,31.655),(40.275,31.655),(40.275,31.505),(40.125,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,31.825),(40.125,31.975),(40.275,31.975),(40.275,31.825),(40.125,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.145),(40.125,32.295),(40.275,32.295),(40.275,32.145),(40.125,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.465),(40.125,32.615),(40.275,32.615),(40.275,32.465),(40.125,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,32.785),(40.125,32.935),(40.275,32.935),(40.275,32.785),(40.125,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.105),(40.125,33.255),(40.275,33.255),(40.275,33.105),(40.125,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.425),(40.125,33.575),(40.275,33.575),(40.275,33.425),(40.125,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,33.745),(40.125,33.895),(40.275,33.895),(40.275,33.745),(40.125,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.065),(40.125,34.215),(40.275,34.215),(40.275,34.065),(40.125,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.385),(40.125,34.535),(40.275,34.535),(40.275,34.385),(40.125,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,34.705),(40.125,34.855),(40.275,34.855),(40.275,34.705),(40.125,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.025),(40.125,35.175),(40.275,35.175),(40.275,35.025),(40.125,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.345),(40.125,35.495),(40.275,35.495),(40.275,35.345),(40.125,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.665),(40.125,35.815),(40.275,35.815),(40.275,35.665),(40.125,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,35.985),(40.125,36.135),(40.275,36.135),(40.275,35.985),(40.125,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.305),(40.125,36.455),(40.275,36.455),(40.275,36.305),(40.125,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.625),(40.125,36.775),(40.275,36.775),(40.275,36.625),(40.125,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,36.945),(40.125,37.095),(40.275,37.095),(40.275,36.945),(40.125,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.265),(40.125,37.415),(40.275,37.415),(40.275,37.265),(40.125,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.585),(40.125,37.735),(40.275,37.735),(40.275,37.585),(40.125,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,37.905),(40.125,38.055),(40.275,38.055),(40.275,37.905),(40.125,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.225),(40.125,38.375),(40.275,38.375),(40.275,38.225),(40.125,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.545),(40.125,38.695),(40.275,38.695),(40.275,38.545),(40.125,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,38.865),(40.125,39.015),(40.275,39.015),(40.275,38.865),(40.125,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.185),(40.125,39.335),(40.275,39.335),(40.275,39.185),(40.125,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.505),(40.125,39.655),(40.275,39.655),(40.275,39.505),(40.125,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,39.825),(40.125,39.975),(40.275,39.975),(40.275,39.825),(40.125,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.145),(40.125,40.295),(40.275,40.295),(40.275,40.145),(40.125,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.465),(40.125,40.615),(40.275,40.615),(40.275,40.465),(40.125,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,40.785),(40.125,40.935),(40.275,40.935),(40.275,40.785),(40.125,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.105),(40.125,41.255),(40.275,41.255),(40.275,41.105),(40.125,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.425),(40.125,41.575),(40.275,41.575),(40.275,41.425),(40.125,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,41.745),(40.125,41.895),(40.275,41.895),(40.275,41.745),(40.125,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.065),(40.125,42.215),(40.275,42.215),(40.275,42.065),(40.125,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.385),(40.125,42.535),(40.275,42.535),(40.275,42.385),(40.125,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,42.705),(40.125,42.855),(40.275,42.855),(40.275,42.705),(40.125,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,43.025),(40.125,43.175),(40.275,43.175),(40.275,43.025),(40.125,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((40.125,43.345),(40.125,43.495),(40.275,43.495),(40.275,43.345),(40.125,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,0.145),(59.07,0.295),(59.22,0.295),(59.22,0.145),(59.07,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,0.465),(59.07,0.615),(59.22,0.615),(59.22,0.465),(59.07,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,0.785),(59.07,0.935),(59.22,0.935),(59.22,0.785),(59.07,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,1.105),(59.07,1.255),(59.22,1.255),(59.22,1.105),(59.07,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,1.425),(59.07,1.575),(59.22,1.575),(59.22,1.425),(59.07,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,1.745),(59.07,1.895),(59.22,1.895),(59.22,1.745),(59.07,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,2.065),(59.07,2.215),(59.22,2.215),(59.22,2.065),(59.07,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,2.385),(59.07,2.535),(59.22,2.535),(59.22,2.385),(59.07,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,2.705),(59.07,2.855),(59.22,2.855),(59.22,2.705),(59.07,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.025),(59.07,3.175),(59.22,3.175),(59.22,3.025),(59.07,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.345),(59.07,3.495),(59.22,3.495),(59.22,3.345),(59.07,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.665),(59.07,3.815),(59.22,3.815),(59.22,3.665),(59.07,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,3.985),(59.07,4.135),(59.22,4.135),(59.22,3.985),(59.07,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,4.305),(59.07,4.455),(59.22,4.455),(59.22,4.305),(59.07,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,4.625),(59.07,4.775),(59.22,4.775),(59.22,4.625),(59.07,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,4.945),(59.07,5.095),(59.22,5.095),(59.22,4.945),(59.07,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.265),(59.07,5.415),(59.22,5.415),(59.22,5.265),(59.07,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.585),(59.07,5.735),(59.22,5.735),(59.22,5.585),(59.07,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,5.905),(59.07,6.055),(59.22,6.055),(59.22,5.905),(59.07,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,6.225),(59.07,6.375),(59.22,6.375),(59.22,6.225),(59.07,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,6.545),(59.07,6.695),(59.22,6.695),(59.22,6.545),(59.07,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,6.865),(59.07,7.015),(59.22,7.015),(59.22,6.865),(59.07,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,7.185),(59.07,7.335),(59.22,7.335),(59.22,7.185),(59.07,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,7.505),(59.07,7.655),(59.22,7.655),(59.22,7.505),(59.07,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,7.825),(59.07,7.975),(59.22,7.975),(59.22,7.825),(59.07,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,8.145),(59.07,8.295),(59.22,8.295),(59.22,8.145),(59.07,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,8.465),(59.07,8.615),(59.22,8.615),(59.22,8.465),(59.07,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,8.785),(59.07,8.935),(59.22,8.935),(59.22,8.785),(59.07,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,9.105),(59.07,9.255),(59.22,9.255),(59.22,9.105),(59.07,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,9.425),(59.07,9.575),(59.22,9.575),(59.22,9.425),(59.07,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,9.745),(59.07,9.895),(59.22,9.895),(59.22,9.745),(59.07,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,10.065),(59.07,10.215),(59.22,10.215),(59.22,10.065),(59.07,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,10.385),(59.07,10.535),(59.22,10.535),(59.22,10.385),(59.07,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,10.705),(59.07,10.855),(59.22,10.855),(59.22,10.705),(59.07,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.025),(59.07,11.175),(59.22,11.175),(59.22,11.025),(59.07,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.345),(59.07,11.495),(59.22,11.495),(59.22,11.345),(59.07,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.665),(59.07,11.815),(59.22,11.815),(59.22,11.665),(59.07,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,11.985),(59.07,12.135),(59.22,12.135),(59.22,11.985),(59.07,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,12.305),(59.07,12.455),(59.22,12.455),(59.22,12.305),(59.07,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,12.625),(59.07,12.775),(59.22,12.775),(59.22,12.625),(59.07,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,12.945),(59.07,13.095),(59.22,13.095),(59.22,12.945),(59.07,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.265),(59.07,13.415),(59.22,13.415),(59.22,13.265),(59.07,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.585),(59.07,13.735),(59.22,13.735),(59.22,13.585),(59.07,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,13.905),(59.07,14.055),(59.22,14.055),(59.22,13.905),(59.07,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,14.225),(59.07,14.375),(59.22,14.375),(59.22,14.225),(59.07,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,14.545),(59.07,14.695),(59.22,14.695),(59.22,14.545),(59.07,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,14.865),(59.07,15.015),(59.22,15.015),(59.22,14.865),(59.07,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,15.185),(59.07,15.335),(59.22,15.335),(59.22,15.185),(59.07,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,15.505),(59.07,15.655),(59.22,15.655),(59.22,15.505),(59.07,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,15.825),(59.07,15.975),(59.22,15.975),(59.22,15.825),(59.07,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,16.145),(59.07,16.295),(59.22,16.295),(59.22,16.145),(59.07,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,16.465),(59.07,16.615),(59.22,16.615),(59.22,16.465),(59.07,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,16.785),(59.07,16.935),(59.22,16.935),(59.22,16.785),(59.07,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,17.105),(59.07,17.255),(59.22,17.255),(59.22,17.105),(59.07,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,17.425),(59.07,17.575),(59.22,17.575),(59.22,17.425),(59.07,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,17.745),(59.07,17.895),(59.22,17.895),(59.22,17.745),(59.07,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,18.065),(59.07,18.215),(59.22,18.215),(59.22,18.065),(59.07,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,18.385),(59.07,18.535),(59.22,18.535),(59.22,18.385),(59.07,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,18.705),(59.07,18.855),(59.22,18.855),(59.22,18.705),(59.07,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.025),(59.07,19.175),(59.22,19.175),(59.22,19.025),(59.07,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.345),(59.07,19.495),(59.22,19.495),(59.22,19.345),(59.07,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.665),(59.07,19.815),(59.22,19.815),(59.22,19.665),(59.07,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,19.985),(59.07,20.135),(59.22,20.135),(59.22,19.985),(59.07,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,20.305),(59.07,20.455),(59.22,20.455),(59.22,20.305),(59.07,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,20.625),(59.07,20.775),(59.22,20.775),(59.22,20.625),(59.07,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,20.945),(59.07,21.095),(59.22,21.095),(59.22,20.945),(59.07,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.265),(59.07,21.415),(59.22,21.415),(59.22,21.265),(59.07,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.585),(59.07,21.735),(59.22,21.735),(59.22,21.585),(59.07,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,21.905),(59.07,22.055),(59.22,22.055),(59.22,21.905),(59.07,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,22.225),(59.07,22.375),(59.22,22.375),(59.22,22.225),(59.07,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,22.545),(59.07,22.695),(59.22,22.695),(59.22,22.545),(59.07,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,22.865),(59.07,23.015),(59.22,23.015),(59.22,22.865),(59.07,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,23.185),(59.07,23.335),(59.22,23.335),(59.22,23.185),(59.07,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,23.505),(59.07,23.655),(59.22,23.655),(59.22,23.505),(59.07,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,23.825),(59.07,23.975),(59.22,23.975),(59.22,23.825),(59.07,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,24.145),(59.07,24.295),(59.22,24.295),(59.22,24.145),(59.07,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,24.465),(59.07,24.615),(59.22,24.615),(59.22,24.465),(59.07,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,24.785),(59.07,24.935),(59.22,24.935),(59.22,24.785),(59.07,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,25.105),(59.07,25.255),(59.22,25.255),(59.22,25.105),(59.07,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,25.425),(59.07,25.575),(59.22,25.575),(59.22,25.425),(59.07,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,25.745),(59.07,25.895),(59.22,25.895),(59.22,25.745),(59.07,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,26.065),(59.07,26.215),(59.22,26.215),(59.22,26.065),(59.07,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,26.385),(59.07,26.535),(59.22,26.535),(59.22,26.385),(59.07,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,26.705),(59.07,26.855),(59.22,26.855),(59.22,26.705),(59.07,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,27.025),(59.07,27.175),(59.22,27.175),(59.22,27.025),(59.07,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,27.345),(59.07,27.495),(59.22,27.495),(59.22,27.345),(59.07,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,27.665),(59.07,27.815),(59.22,27.815),(59.22,27.665),(59.07,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,27.985),(59.07,28.135),(59.22,28.135),(59.22,27.985),(59.07,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,28.305),(59.07,28.455),(59.22,28.455),(59.22,28.305),(59.07,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,28.625),(59.07,28.775),(59.22,28.775),(59.22,28.625),(59.07,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,28.945),(59.07,29.095),(59.22,29.095),(59.22,28.945),(59.07,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,29.265),(59.07,29.415),(59.22,29.415),(59.22,29.265),(59.07,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,29.585),(59.07,29.735),(59.22,29.735),(59.22,29.585),(59.07,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,29.905),(59.07,30.055),(59.22,30.055),(59.22,29.905),(59.07,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,30.225),(59.07,30.375),(59.22,30.375),(59.22,30.225),(59.07,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,30.545),(59.07,30.695),(59.22,30.695),(59.22,30.545),(59.07,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,30.865),(59.07,31.015),(59.22,31.015),(59.22,30.865),(59.07,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,31.185),(59.07,31.335),(59.22,31.335),(59.22,31.185),(59.07,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,31.505),(59.07,31.655),(59.22,31.655),(59.22,31.505),(59.07,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,31.825),(59.07,31.975),(59.22,31.975),(59.22,31.825),(59.07,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,32.145),(59.07,32.295),(59.22,32.295),(59.22,32.145),(59.07,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,32.465),(59.07,32.615),(59.22,32.615),(59.22,32.465),(59.07,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,32.785),(59.07,32.935),(59.22,32.935),(59.22,32.785),(59.07,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,33.105),(59.07,33.255),(59.22,33.255),(59.22,33.105),(59.07,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,33.425),(59.07,33.575),(59.22,33.575),(59.22,33.425),(59.07,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,33.745),(59.07,33.895),(59.22,33.895),(59.22,33.745),(59.07,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,34.065),(59.07,34.215),(59.22,34.215),(59.22,34.065),(59.07,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,34.385),(59.07,34.535),(59.22,34.535),(59.22,34.385),(59.07,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,34.705),(59.07,34.855),(59.22,34.855),(59.22,34.705),(59.07,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,35.025),(59.07,35.175),(59.22,35.175),(59.22,35.025),(59.07,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,35.345),(59.07,35.495),(59.22,35.495),(59.22,35.345),(59.07,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,35.665),(59.07,35.815),(59.22,35.815),(59.22,35.665),(59.07,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,35.985),(59.07,36.135),(59.22,36.135),(59.22,35.985),(59.07,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,36.305),(59.07,36.455),(59.22,36.455),(59.22,36.305),(59.07,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,36.625),(59.07,36.775),(59.22,36.775),(59.22,36.625),(59.07,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,36.945),(59.07,37.095),(59.22,37.095),(59.22,36.945),(59.07,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,37.265),(59.07,37.415),(59.22,37.415),(59.22,37.265),(59.07,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,37.585),(59.07,37.735),(59.22,37.735),(59.22,37.585),(59.07,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,37.905),(59.07,38.055),(59.22,38.055),(59.22,37.905),(59.07,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,38.225),(59.07,38.375),(59.22,38.375),(59.22,38.225),(59.07,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,38.545),(59.07,38.695),(59.22,38.695),(59.22,38.545),(59.07,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,38.865),(59.07,39.015),(59.22,39.015),(59.22,38.865),(59.07,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,39.185),(59.07,39.335),(59.22,39.335),(59.22,39.185),(59.07,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,39.505),(59.07,39.655),(59.22,39.655),(59.22,39.505),(59.07,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,39.825),(59.07,39.975),(59.22,39.975),(59.22,39.825),(59.07,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,40.145),(59.07,40.295),(59.22,40.295),(59.22,40.145),(59.07,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,40.465),(59.07,40.615),(59.22,40.615),(59.22,40.465),(59.07,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,40.785),(59.07,40.935),(59.22,40.935),(59.22,40.785),(59.07,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,41.105),(59.07,41.255),(59.22,41.255),(59.22,41.105),(59.07,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,41.425),(59.07,41.575),(59.22,41.575),(59.22,41.425),(59.07,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,41.745),(59.07,41.895),(59.22,41.895),(59.22,41.745),(59.07,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,42.065),(59.07,42.215),(59.22,42.215),(59.22,42.065),(59.07,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,42.385),(59.07,42.535),(59.22,42.535),(59.22,42.385),(59.07,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,42.705),(59.07,42.855),(59.22,42.855),(59.22,42.705),(59.07,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,43.025),(59.07,43.175),(59.22,43.175),(59.22,43.025),(59.07,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((59.07,43.345),(59.07,43.495),(59.22,43.495),(59.22,43.345),(59.07,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.145),(54.525,0.295),(54.675,0.295),(54.675,0.145),(54.525,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.465),(54.525,0.615),(54.675,0.615),(54.675,0.465),(54.525,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,0.785),(54.525,0.935),(54.675,0.935),(54.675,0.785),(54.525,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.105),(54.525,1.255),(54.675,1.255),(54.675,1.105),(54.525,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.425),(54.525,1.575),(54.675,1.575),(54.675,1.425),(54.525,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,1.745),(54.525,1.895),(54.675,1.895),(54.675,1.745),(54.525,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.065),(54.525,2.215),(54.675,2.215),(54.675,2.065),(54.525,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.385),(54.525,2.535),(54.675,2.535),(54.675,2.385),(54.525,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,2.705),(54.525,2.855),(54.675,2.855),(54.675,2.705),(54.525,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.025),(54.525,3.175),(54.675,3.175),(54.675,3.025),(54.525,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.345),(54.525,3.495),(54.675,3.495),(54.675,3.345),(54.525,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.665),(54.525,3.815),(54.675,3.815),(54.675,3.665),(54.525,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,3.985),(54.525,4.135),(54.675,4.135),(54.675,3.985),(54.525,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.305),(54.525,4.455),(54.675,4.455),(54.675,4.305),(54.525,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.625),(54.525,4.775),(54.675,4.775),(54.675,4.625),(54.525,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,4.945),(54.525,5.095),(54.675,5.095),(54.675,4.945),(54.525,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.265),(54.525,5.415),(54.675,5.415),(54.675,5.265),(54.525,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.585),(54.525,5.735),(54.675,5.735),(54.675,5.585),(54.525,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,5.905),(54.525,6.055),(54.675,6.055),(54.675,5.905),(54.525,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.225),(54.525,6.375),(54.675,6.375),(54.675,6.225),(54.525,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.545),(54.525,6.695),(54.675,6.695),(54.675,6.545),(54.525,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,6.865),(54.525,7.015),(54.675,7.015),(54.675,6.865),(54.525,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.185),(54.525,7.335),(54.675,7.335),(54.675,7.185),(54.525,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.505),(54.525,7.655),(54.675,7.655),(54.675,7.505),(54.525,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,7.825),(54.525,7.975),(54.675,7.975),(54.675,7.825),(54.525,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.145),(54.525,8.295),(54.675,8.295),(54.675,8.145),(54.525,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.465),(54.525,8.615),(54.675,8.615),(54.675,8.465),(54.525,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,8.785),(54.525,8.935),(54.675,8.935),(54.675,8.785),(54.525,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.105),(54.525,9.255),(54.675,9.255),(54.675,9.105),(54.525,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.425),(54.525,9.575),(54.675,9.575),(54.675,9.425),(54.525,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,9.745),(54.525,9.895),(54.675,9.895),(54.675,9.745),(54.525,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.065),(54.525,10.215),(54.675,10.215),(54.675,10.065),(54.525,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.385),(54.525,10.535),(54.675,10.535),(54.675,10.385),(54.525,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,10.705),(54.525,10.855),(54.675,10.855),(54.675,10.705),(54.525,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.025),(54.525,11.175),(54.675,11.175),(54.675,11.025),(54.525,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.345),(54.525,11.495),(54.675,11.495),(54.675,11.345),(54.525,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.665),(54.525,11.815),(54.675,11.815),(54.675,11.665),(54.525,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,11.985),(54.525,12.135),(54.675,12.135),(54.675,11.985),(54.525,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.305),(54.525,12.455),(54.675,12.455),(54.675,12.305),(54.525,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.625),(54.525,12.775),(54.675,12.775),(54.675,12.625),(54.525,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,12.945),(54.525,13.095),(54.675,13.095),(54.675,12.945),(54.525,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.265),(54.525,13.415),(54.675,13.415),(54.675,13.265),(54.525,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.585),(54.525,13.735),(54.675,13.735),(54.675,13.585),(54.525,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,13.905),(54.525,14.055),(54.675,14.055),(54.675,13.905),(54.525,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.225),(54.525,14.375),(54.675,14.375),(54.675,14.225),(54.525,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.545),(54.525,14.695),(54.675,14.695),(54.675,14.545),(54.525,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,14.865),(54.525,15.015),(54.675,15.015),(54.675,14.865),(54.525,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.185),(54.525,15.335),(54.675,15.335),(54.675,15.185),(54.525,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.505),(54.525,15.655),(54.675,15.655),(54.675,15.505),(54.525,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,15.825),(54.525,15.975),(54.675,15.975),(54.675,15.825),(54.525,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.145),(54.525,16.295),(54.675,16.295),(54.675,16.145),(54.525,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.465),(54.525,16.615),(54.675,16.615),(54.675,16.465),(54.525,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,16.785),(54.525,16.935),(54.675,16.935),(54.675,16.785),(54.525,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.105),(54.525,17.255),(54.675,17.255),(54.675,17.105),(54.525,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.425),(54.525,17.575),(54.675,17.575),(54.675,17.425),(54.525,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,17.745),(54.525,17.895),(54.675,17.895),(54.675,17.745),(54.525,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.065),(54.525,18.215),(54.675,18.215),(54.675,18.065),(54.525,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.385),(54.525,18.535),(54.675,18.535),(54.675,18.385),(54.525,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,18.705),(54.525,18.855),(54.675,18.855),(54.675,18.705),(54.525,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.025),(54.525,19.175),(54.675,19.175),(54.675,19.025),(54.525,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.345),(54.525,19.495),(54.675,19.495),(54.675,19.345),(54.525,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.665),(54.525,19.815),(54.675,19.815),(54.675,19.665),(54.525,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,19.985),(54.525,20.135),(54.675,20.135),(54.675,19.985),(54.525,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.305),(54.525,20.455),(54.675,20.455),(54.675,20.305),(54.525,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.625),(54.525,20.775),(54.675,20.775),(54.675,20.625),(54.525,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,20.945),(54.525,21.095),(54.675,21.095),(54.675,20.945),(54.525,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.265),(54.525,21.415),(54.675,21.415),(54.675,21.265),(54.525,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.585),(54.525,21.735),(54.675,21.735),(54.675,21.585),(54.525,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,21.905),(54.525,22.055),(54.675,22.055),(54.675,21.905),(54.525,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.225),(54.525,22.375),(54.675,22.375),(54.675,22.225),(54.525,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.545),(54.525,22.695),(54.675,22.695),(54.675,22.545),(54.525,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,22.865),(54.525,23.015),(54.675,23.015),(54.675,22.865),(54.525,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.185),(54.525,23.335),(54.675,23.335),(54.675,23.185),(54.525,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.505),(54.525,23.655),(54.675,23.655),(54.675,23.505),(54.525,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,23.825),(54.525,23.975),(54.675,23.975),(54.675,23.825),(54.525,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.145),(54.525,24.295),(54.675,24.295),(54.675,24.145),(54.525,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.465),(54.525,24.615),(54.675,24.615),(54.675,24.465),(54.525,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,24.785),(54.525,24.935),(54.675,24.935),(54.675,24.785),(54.525,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.105),(54.525,25.255),(54.675,25.255),(54.675,25.105),(54.525,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.425),(54.525,25.575),(54.675,25.575),(54.675,25.425),(54.525,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,25.745),(54.525,25.895),(54.675,25.895),(54.675,25.745),(54.525,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.065),(54.525,26.215),(54.675,26.215),(54.675,26.065),(54.525,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.385),(54.525,26.535),(54.675,26.535),(54.675,26.385),(54.525,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,26.705),(54.525,26.855),(54.675,26.855),(54.675,26.705),(54.525,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.025),(54.525,27.175),(54.675,27.175),(54.675,27.025),(54.525,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.345),(54.525,27.495),(54.675,27.495),(54.675,27.345),(54.525,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.665),(54.525,27.815),(54.675,27.815),(54.675,27.665),(54.525,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,27.985),(54.525,28.135),(54.675,28.135),(54.675,27.985),(54.525,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.305),(54.525,28.455),(54.675,28.455),(54.675,28.305),(54.525,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.625),(54.525,28.775),(54.675,28.775),(54.675,28.625),(54.525,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,28.945),(54.525,29.095),(54.675,29.095),(54.675,28.945),(54.525,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.265),(54.525,29.415),(54.675,29.415),(54.675,29.265),(54.525,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.585),(54.525,29.735),(54.675,29.735),(54.675,29.585),(54.525,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,29.905),(54.525,30.055),(54.675,30.055),(54.675,29.905),(54.525,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.225),(54.525,30.375),(54.675,30.375),(54.675,30.225),(54.525,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.545),(54.525,30.695),(54.675,30.695),(54.675,30.545),(54.525,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,30.865),(54.525,31.015),(54.675,31.015),(54.675,30.865),(54.525,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.185),(54.525,31.335),(54.675,31.335),(54.675,31.185),(54.525,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.505),(54.525,31.655),(54.675,31.655),(54.675,31.505),(54.525,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,31.825),(54.525,31.975),(54.675,31.975),(54.675,31.825),(54.525,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.145),(54.525,32.295),(54.675,32.295),(54.675,32.145),(54.525,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.465),(54.525,32.615),(54.675,32.615),(54.675,32.465),(54.525,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,32.785),(54.525,32.935),(54.675,32.935),(54.675,32.785),(54.525,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.105),(54.525,33.255),(54.675,33.255),(54.675,33.105),(54.525,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.425),(54.525,33.575),(54.675,33.575),(54.675,33.425),(54.525,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,33.745),(54.525,33.895),(54.675,33.895),(54.675,33.745),(54.525,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.065),(54.525,34.215),(54.675,34.215),(54.675,34.065),(54.525,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.385),(54.525,34.535),(54.675,34.535),(54.675,34.385),(54.525,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,34.705),(54.525,34.855),(54.675,34.855),(54.675,34.705),(54.525,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.025),(54.525,35.175),(54.675,35.175),(54.675,35.025),(54.525,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.345),(54.525,35.495),(54.675,35.495),(54.675,35.345),(54.525,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.665),(54.525,35.815),(54.675,35.815),(54.675,35.665),(54.525,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,35.985),(54.525,36.135),(54.675,36.135),(54.675,35.985),(54.525,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.305),(54.525,36.455),(54.675,36.455),(54.675,36.305),(54.525,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.625),(54.525,36.775),(54.675,36.775),(54.675,36.625),(54.525,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,36.945),(54.525,37.095),(54.675,37.095),(54.675,36.945),(54.525,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.265),(54.525,37.415),(54.675,37.415),(54.675,37.265),(54.525,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.585),(54.525,37.735),(54.675,37.735),(54.675,37.585),(54.525,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,37.905),(54.525,38.055),(54.675,38.055),(54.675,37.905),(54.525,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.225),(54.525,38.375),(54.675,38.375),(54.675,38.225),(54.525,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.545),(54.525,38.695),(54.675,38.695),(54.675,38.545),(54.525,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,38.865),(54.525,39.015),(54.675,39.015),(54.675,38.865),(54.525,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.185),(54.525,39.335),(54.675,39.335),(54.675,39.185),(54.525,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.505),(54.525,39.655),(54.675,39.655),(54.675,39.505),(54.525,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,39.825),(54.525,39.975),(54.675,39.975),(54.675,39.825),(54.525,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.145),(54.525,40.295),(54.675,40.295),(54.675,40.145),(54.525,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.465),(54.525,40.615),(54.675,40.615),(54.675,40.465),(54.525,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,40.785),(54.525,40.935),(54.675,40.935),(54.675,40.785),(54.525,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.105),(54.525,41.255),(54.675,41.255),(54.675,41.105),(54.525,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.425),(54.525,41.575),(54.675,41.575),(54.675,41.425),(54.525,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,41.745),(54.525,41.895),(54.675,41.895),(54.675,41.745),(54.525,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.065),(54.525,42.215),(54.675,42.215),(54.675,42.065),(54.525,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.385),(54.525,42.535),(54.675,42.535),(54.675,42.385),(54.525,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,42.705),(54.525,42.855),(54.675,42.855),(54.675,42.705),(54.525,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,43.025),(54.525,43.175),(54.675,43.175),(54.675,43.025),(54.525,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((54.525,43.345),(54.525,43.495),(54.675,43.495),(54.675,43.345),(54.525,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.145),(49.725,0.295),(49.875,0.295),(49.875,0.145),(49.725,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.465),(49.725,0.615),(49.875,0.615),(49.875,0.465),(49.725,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,0.785),(49.725,0.935),(49.875,0.935),(49.875,0.785),(49.725,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.105),(49.725,1.255),(49.875,1.255),(49.875,1.105),(49.725,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.425),(49.725,1.575),(49.875,1.575),(49.875,1.425),(49.725,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,1.745),(49.725,1.895),(49.875,1.895),(49.875,1.745),(49.725,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.065),(49.725,2.215),(49.875,2.215),(49.875,2.065),(49.725,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.385),(49.725,2.535),(49.875,2.535),(49.875,2.385),(49.725,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,2.705),(49.725,2.855),(49.875,2.855),(49.875,2.705),(49.725,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.025),(49.725,3.175),(49.875,3.175),(49.875,3.025),(49.725,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.345),(49.725,3.495),(49.875,3.495),(49.875,3.345),(49.725,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.665),(49.725,3.815),(49.875,3.815),(49.875,3.665),(49.725,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,3.985),(49.725,4.135),(49.875,4.135),(49.875,3.985),(49.725,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.305),(49.725,4.455),(49.875,4.455),(49.875,4.305),(49.725,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.625),(49.725,4.775),(49.875,4.775),(49.875,4.625),(49.725,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,4.945),(49.725,5.095),(49.875,5.095),(49.875,4.945),(49.725,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.265),(49.725,5.415),(49.875,5.415),(49.875,5.265),(49.725,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.585),(49.725,5.735),(49.875,5.735),(49.875,5.585),(49.725,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,5.905),(49.725,6.055),(49.875,6.055),(49.875,5.905),(49.725,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.225),(49.725,6.375),(49.875,6.375),(49.875,6.225),(49.725,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.545),(49.725,6.695),(49.875,6.695),(49.875,6.545),(49.725,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,6.865),(49.725,7.015),(49.875,7.015),(49.875,6.865),(49.725,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.185),(49.725,7.335),(49.875,7.335),(49.875,7.185),(49.725,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.505),(49.725,7.655),(49.875,7.655),(49.875,7.505),(49.725,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,7.825),(49.725,7.975),(49.875,7.975),(49.875,7.825),(49.725,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.145),(49.725,8.295),(49.875,8.295),(49.875,8.145),(49.725,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.465),(49.725,8.615),(49.875,8.615),(49.875,8.465),(49.725,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,8.785),(49.725,8.935),(49.875,8.935),(49.875,8.785),(49.725,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.105),(49.725,9.255),(49.875,9.255),(49.875,9.105),(49.725,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.425),(49.725,9.575),(49.875,9.575),(49.875,9.425),(49.725,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,9.745),(49.725,9.895),(49.875,9.895),(49.875,9.745),(49.725,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.065),(49.725,10.215),(49.875,10.215),(49.875,10.065),(49.725,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.385),(49.725,10.535),(49.875,10.535),(49.875,10.385),(49.725,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,10.705),(49.725,10.855),(49.875,10.855),(49.875,10.705),(49.725,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.025),(49.725,11.175),(49.875,11.175),(49.875,11.025),(49.725,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.345),(49.725,11.495),(49.875,11.495),(49.875,11.345),(49.725,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.665),(49.725,11.815),(49.875,11.815),(49.875,11.665),(49.725,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,11.985),(49.725,12.135),(49.875,12.135),(49.875,11.985),(49.725,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.305),(49.725,12.455),(49.875,12.455),(49.875,12.305),(49.725,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.625),(49.725,12.775),(49.875,12.775),(49.875,12.625),(49.725,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,12.945),(49.725,13.095),(49.875,13.095),(49.875,12.945),(49.725,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.265),(49.725,13.415),(49.875,13.415),(49.875,13.265),(49.725,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.585),(49.725,13.735),(49.875,13.735),(49.875,13.585),(49.725,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,13.905),(49.725,14.055),(49.875,14.055),(49.875,13.905),(49.725,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.225),(49.725,14.375),(49.875,14.375),(49.875,14.225),(49.725,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.545),(49.725,14.695),(49.875,14.695),(49.875,14.545),(49.725,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,14.865),(49.725,15.015),(49.875,15.015),(49.875,14.865),(49.725,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.185),(49.725,15.335),(49.875,15.335),(49.875,15.185),(49.725,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.505),(49.725,15.655),(49.875,15.655),(49.875,15.505),(49.725,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,15.825),(49.725,15.975),(49.875,15.975),(49.875,15.825),(49.725,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.145),(49.725,16.295),(49.875,16.295),(49.875,16.145),(49.725,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.465),(49.725,16.615),(49.875,16.615),(49.875,16.465),(49.725,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,16.785),(49.725,16.935),(49.875,16.935),(49.875,16.785),(49.725,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.105),(49.725,17.255),(49.875,17.255),(49.875,17.105),(49.725,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.425),(49.725,17.575),(49.875,17.575),(49.875,17.425),(49.725,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,17.745),(49.725,17.895),(49.875,17.895),(49.875,17.745),(49.725,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.065),(49.725,18.215),(49.875,18.215),(49.875,18.065),(49.725,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.385),(49.725,18.535),(49.875,18.535),(49.875,18.385),(49.725,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,18.705),(49.725,18.855),(49.875,18.855),(49.875,18.705),(49.725,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.025),(49.725,19.175),(49.875,19.175),(49.875,19.025),(49.725,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.345),(49.725,19.495),(49.875,19.495),(49.875,19.345),(49.725,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.665),(49.725,19.815),(49.875,19.815),(49.875,19.665),(49.725,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,19.985),(49.725,20.135),(49.875,20.135),(49.875,19.985),(49.725,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.305),(49.725,20.455),(49.875,20.455),(49.875,20.305),(49.725,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.625),(49.725,20.775),(49.875,20.775),(49.875,20.625),(49.725,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,20.945),(49.725,21.095),(49.875,21.095),(49.875,20.945),(49.725,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.265),(49.725,21.415),(49.875,21.415),(49.875,21.265),(49.725,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.585),(49.725,21.735),(49.875,21.735),(49.875,21.585),(49.725,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,21.905),(49.725,22.055),(49.875,22.055),(49.875,21.905),(49.725,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.225),(49.725,22.375),(49.875,22.375),(49.875,22.225),(49.725,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.545),(49.725,22.695),(49.875,22.695),(49.875,22.545),(49.725,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,22.865),(49.725,23.015),(49.875,23.015),(49.875,22.865),(49.725,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.185),(49.725,23.335),(49.875,23.335),(49.875,23.185),(49.725,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.505),(49.725,23.655),(49.875,23.655),(49.875,23.505),(49.725,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,23.825),(49.725,23.975),(49.875,23.975),(49.875,23.825),(49.725,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.145),(49.725,24.295),(49.875,24.295),(49.875,24.145),(49.725,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.465),(49.725,24.615),(49.875,24.615),(49.875,24.465),(49.725,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,24.785),(49.725,24.935),(49.875,24.935),(49.875,24.785),(49.725,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.105),(49.725,25.255),(49.875,25.255),(49.875,25.105),(49.725,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.425),(49.725,25.575),(49.875,25.575),(49.875,25.425),(49.725,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,25.745),(49.725,25.895),(49.875,25.895),(49.875,25.745),(49.725,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.065),(49.725,26.215),(49.875,26.215),(49.875,26.065),(49.725,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.385),(49.725,26.535),(49.875,26.535),(49.875,26.385),(49.725,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,26.705),(49.725,26.855),(49.875,26.855),(49.875,26.705),(49.725,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.025),(49.725,27.175),(49.875,27.175),(49.875,27.025),(49.725,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.345),(49.725,27.495),(49.875,27.495),(49.875,27.345),(49.725,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.665),(49.725,27.815),(49.875,27.815),(49.875,27.665),(49.725,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,27.985),(49.725,28.135),(49.875,28.135),(49.875,27.985),(49.725,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.305),(49.725,28.455),(49.875,28.455),(49.875,28.305),(49.725,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.625),(49.725,28.775),(49.875,28.775),(49.875,28.625),(49.725,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,28.945),(49.725,29.095),(49.875,29.095),(49.875,28.945),(49.725,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.265),(49.725,29.415),(49.875,29.415),(49.875,29.265),(49.725,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.585),(49.725,29.735),(49.875,29.735),(49.875,29.585),(49.725,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,29.905),(49.725,30.055),(49.875,30.055),(49.875,29.905),(49.725,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.225),(49.725,30.375),(49.875,30.375),(49.875,30.225),(49.725,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.545),(49.725,30.695),(49.875,30.695),(49.875,30.545),(49.725,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,30.865),(49.725,31.015),(49.875,31.015),(49.875,30.865),(49.725,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.185),(49.725,31.335),(49.875,31.335),(49.875,31.185),(49.725,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.505),(49.725,31.655),(49.875,31.655),(49.875,31.505),(49.725,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,31.825),(49.725,31.975),(49.875,31.975),(49.875,31.825),(49.725,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.145),(49.725,32.295),(49.875,32.295),(49.875,32.145),(49.725,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.465),(49.725,32.615),(49.875,32.615),(49.875,32.465),(49.725,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,32.785),(49.725,32.935),(49.875,32.935),(49.875,32.785),(49.725,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.105),(49.725,33.255),(49.875,33.255),(49.875,33.105),(49.725,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.425),(49.725,33.575),(49.875,33.575),(49.875,33.425),(49.725,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,33.745),(49.725,33.895),(49.875,33.895),(49.875,33.745),(49.725,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.065),(49.725,34.215),(49.875,34.215),(49.875,34.065),(49.725,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.385),(49.725,34.535),(49.875,34.535),(49.875,34.385),(49.725,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,34.705),(49.725,34.855),(49.875,34.855),(49.875,34.705),(49.725,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.025),(49.725,35.175),(49.875,35.175),(49.875,35.025),(49.725,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.345),(49.725,35.495),(49.875,35.495),(49.875,35.345),(49.725,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.665),(49.725,35.815),(49.875,35.815),(49.875,35.665),(49.725,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,35.985),(49.725,36.135),(49.875,36.135),(49.875,35.985),(49.725,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.305),(49.725,36.455),(49.875,36.455),(49.875,36.305),(49.725,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.625),(49.725,36.775),(49.875,36.775),(49.875,36.625),(49.725,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,36.945),(49.725,37.095),(49.875,37.095),(49.875,36.945),(49.725,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.265),(49.725,37.415),(49.875,37.415),(49.875,37.265),(49.725,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.585),(49.725,37.735),(49.875,37.735),(49.875,37.585),(49.725,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,37.905),(49.725,38.055),(49.875,38.055),(49.875,37.905),(49.725,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.225),(49.725,38.375),(49.875,38.375),(49.875,38.225),(49.725,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.545),(49.725,38.695),(49.875,38.695),(49.875,38.545),(49.725,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,38.865),(49.725,39.015),(49.875,39.015),(49.875,38.865),(49.725,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.185),(49.725,39.335),(49.875,39.335),(49.875,39.185),(49.725,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.505),(49.725,39.655),(49.875,39.655),(49.875,39.505),(49.725,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,39.825),(49.725,39.975),(49.875,39.975),(49.875,39.825),(49.725,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.145),(49.725,40.295),(49.875,40.295),(49.875,40.145),(49.725,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.465),(49.725,40.615),(49.875,40.615),(49.875,40.465),(49.725,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,40.785),(49.725,40.935),(49.875,40.935),(49.875,40.785),(49.725,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.105),(49.725,41.255),(49.875,41.255),(49.875,41.105),(49.725,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.425),(49.725,41.575),(49.875,41.575),(49.875,41.425),(49.725,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,41.745),(49.725,41.895),(49.875,41.895),(49.875,41.745),(49.725,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.065),(49.725,42.215),(49.875,42.215),(49.875,42.065),(49.725,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.385),(49.725,42.535),(49.875,42.535),(49.875,42.385),(49.725,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,42.705),(49.725,42.855),(49.875,42.855),(49.875,42.705),(49.725,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,43.025),(49.725,43.175),(49.875,43.175),(49.875,43.025),(49.725,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((49.725,43.345),(49.725,43.495),(49.875,43.495),(49.875,43.345),(49.725,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,0.145),(30.78,0.295),(30.93,0.295),(30.93,0.145),(30.78,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,0.465),(30.78,0.615),(30.93,0.615),(30.93,0.465),(30.78,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,0.785),(30.78,0.935),(30.93,0.935),(30.93,0.785),(30.78,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,1.105),(30.78,1.255),(30.93,1.255),(30.93,1.105),(30.78,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,1.425),(30.78,1.575),(30.93,1.575),(30.93,1.425),(30.78,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,1.745),(30.78,1.895),(30.93,1.895),(30.93,1.745),(30.78,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,2.065),(30.78,2.215),(30.93,2.215),(30.93,2.065),(30.78,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,2.385),(30.78,2.535),(30.93,2.535),(30.93,2.385),(30.78,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,2.705),(30.78,2.855),(30.93,2.855),(30.93,2.705),(30.78,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.025),(30.78,3.175),(30.93,3.175),(30.93,3.025),(30.78,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.345),(30.78,3.495),(30.93,3.495),(30.93,3.345),(30.78,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.665),(30.78,3.815),(30.93,3.815),(30.93,3.665),(30.78,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,3.985),(30.78,4.135),(30.93,4.135),(30.93,3.985),(30.78,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,4.305),(30.78,4.455),(30.93,4.455),(30.93,4.305),(30.78,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,4.625),(30.78,4.775),(30.93,4.775),(30.93,4.625),(30.78,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,4.945),(30.78,5.095),(30.93,5.095),(30.93,4.945),(30.78,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.265),(30.78,5.415),(30.93,5.415),(30.93,5.265),(30.78,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.585),(30.78,5.735),(30.93,5.735),(30.93,5.585),(30.78,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,5.905),(30.78,6.055),(30.93,6.055),(30.93,5.905),(30.78,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,6.225),(30.78,6.375),(30.93,6.375),(30.93,6.225),(30.78,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,6.545),(30.78,6.695),(30.93,6.695),(30.93,6.545),(30.78,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,6.865),(30.78,7.015),(30.93,7.015),(30.93,6.865),(30.78,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,7.185),(30.78,7.335),(30.93,7.335),(30.93,7.185),(30.78,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,7.505),(30.78,7.655),(30.93,7.655),(30.93,7.505),(30.78,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,7.825),(30.78,7.975),(30.93,7.975),(30.93,7.825),(30.78,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,8.145),(30.78,8.295),(30.93,8.295),(30.93,8.145),(30.78,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,8.465),(30.78,8.615),(30.93,8.615),(30.93,8.465),(30.78,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,8.785),(30.78,8.935),(30.93,8.935),(30.93,8.785),(30.78,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,9.105),(30.78,9.255),(30.93,9.255),(30.93,9.105),(30.78,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,9.425),(30.78,9.575),(30.93,9.575),(30.93,9.425),(30.78,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,9.745),(30.78,9.895),(30.93,9.895),(30.93,9.745),(30.78,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,10.065),(30.78,10.215),(30.93,10.215),(30.93,10.065),(30.78,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,10.385),(30.78,10.535),(30.93,10.535),(30.93,10.385),(30.78,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,10.705),(30.78,10.855),(30.93,10.855),(30.93,10.705),(30.78,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.025),(30.78,11.175),(30.93,11.175),(30.93,11.025),(30.78,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.345),(30.78,11.495),(30.93,11.495),(30.93,11.345),(30.78,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.665),(30.78,11.815),(30.93,11.815),(30.93,11.665),(30.78,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,11.985),(30.78,12.135),(30.93,12.135),(30.93,11.985),(30.78,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,12.305),(30.78,12.455),(30.93,12.455),(30.93,12.305),(30.78,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,12.625),(30.78,12.775),(30.93,12.775),(30.93,12.625),(30.78,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,12.945),(30.78,13.095),(30.93,13.095),(30.93,12.945),(30.78,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.265),(30.78,13.415),(30.93,13.415),(30.93,13.265),(30.78,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.585),(30.78,13.735),(30.93,13.735),(30.93,13.585),(30.78,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,13.905),(30.78,14.055),(30.93,14.055),(30.93,13.905),(30.78,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,14.225),(30.78,14.375),(30.93,14.375),(30.93,14.225),(30.78,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,14.545),(30.78,14.695),(30.93,14.695),(30.93,14.545),(30.78,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,14.865),(30.78,15.015),(30.93,15.015),(30.93,14.865),(30.78,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,15.185),(30.78,15.335),(30.93,15.335),(30.93,15.185),(30.78,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,15.505),(30.78,15.655),(30.93,15.655),(30.93,15.505),(30.78,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,15.825),(30.78,15.975),(30.93,15.975),(30.93,15.825),(30.78,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,16.145),(30.78,16.295),(30.93,16.295),(30.93,16.145),(30.78,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,16.465),(30.78,16.615),(30.93,16.615),(30.93,16.465),(30.78,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,16.785),(30.78,16.935),(30.93,16.935),(30.93,16.785),(30.78,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,17.105),(30.78,17.255),(30.93,17.255),(30.93,17.105),(30.78,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,17.425),(30.78,17.575),(30.93,17.575),(30.93,17.425),(30.78,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,17.745),(30.78,17.895),(30.93,17.895),(30.93,17.745),(30.78,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,18.065),(30.78,18.215),(30.93,18.215),(30.93,18.065),(30.78,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,18.385),(30.78,18.535),(30.93,18.535),(30.93,18.385),(30.78,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,18.705),(30.78,18.855),(30.93,18.855),(30.93,18.705),(30.78,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.025),(30.78,19.175),(30.93,19.175),(30.93,19.025),(30.78,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.345),(30.78,19.495),(30.93,19.495),(30.93,19.345),(30.78,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.665),(30.78,19.815),(30.93,19.815),(30.93,19.665),(30.78,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,19.985),(30.78,20.135),(30.93,20.135),(30.93,19.985),(30.78,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,20.305),(30.78,20.455),(30.93,20.455),(30.93,20.305),(30.78,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,20.625),(30.78,20.775),(30.93,20.775),(30.93,20.625),(30.78,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,20.945),(30.78,21.095),(30.93,21.095),(30.93,20.945),(30.78,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.265),(30.78,21.415),(30.93,21.415),(30.93,21.265),(30.78,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.585),(30.78,21.735),(30.93,21.735),(30.93,21.585),(30.78,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,21.905),(30.78,22.055),(30.93,22.055),(30.93,21.905),(30.78,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,22.225),(30.78,22.375),(30.93,22.375),(30.93,22.225),(30.78,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,22.545),(30.78,22.695),(30.93,22.695),(30.93,22.545),(30.78,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,22.865),(30.78,23.015),(30.93,23.015),(30.93,22.865),(30.78,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,23.185),(30.78,23.335),(30.93,23.335),(30.93,23.185),(30.78,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,23.505),(30.78,23.655),(30.93,23.655),(30.93,23.505),(30.78,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,23.825),(30.78,23.975),(30.93,23.975),(30.93,23.825),(30.78,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,24.145),(30.78,24.295),(30.93,24.295),(30.93,24.145),(30.78,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,24.465),(30.78,24.615),(30.93,24.615),(30.93,24.465),(30.78,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,24.785),(30.78,24.935),(30.93,24.935),(30.93,24.785),(30.78,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,25.105),(30.78,25.255),(30.93,25.255),(30.93,25.105),(30.78,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,25.425),(30.78,25.575),(30.93,25.575),(30.93,25.425),(30.78,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,25.745),(30.78,25.895),(30.93,25.895),(30.93,25.745),(30.78,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,26.065),(30.78,26.215),(30.93,26.215),(30.93,26.065),(30.78,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,26.385),(30.78,26.535),(30.93,26.535),(30.93,26.385),(30.78,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,26.705),(30.78,26.855),(30.93,26.855),(30.93,26.705),(30.78,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,27.025),(30.78,27.175),(30.93,27.175),(30.93,27.025),(30.78,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,27.345),(30.78,27.495),(30.93,27.495),(30.93,27.345),(30.78,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,27.665),(30.78,27.815),(30.93,27.815),(30.93,27.665),(30.78,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,27.985),(30.78,28.135),(30.93,28.135),(30.93,27.985),(30.78,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,28.305),(30.78,28.455),(30.93,28.455),(30.93,28.305),(30.78,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,28.625),(30.78,28.775),(30.93,28.775),(30.93,28.625),(30.78,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,28.945),(30.78,29.095),(30.93,29.095),(30.93,28.945),(30.78,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,29.265),(30.78,29.415),(30.93,29.415),(30.93,29.265),(30.78,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,29.585),(30.78,29.735),(30.93,29.735),(30.93,29.585),(30.78,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,29.905),(30.78,30.055),(30.93,30.055),(30.93,29.905),(30.78,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,30.225),(30.78,30.375),(30.93,30.375),(30.93,30.225),(30.78,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,30.545),(30.78,30.695),(30.93,30.695),(30.93,30.545),(30.78,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,30.865),(30.78,31.015),(30.93,31.015),(30.93,30.865),(30.78,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,31.185),(30.78,31.335),(30.93,31.335),(30.93,31.185),(30.78,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,31.505),(30.78,31.655),(30.93,31.655),(30.93,31.505),(30.78,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,31.825),(30.78,31.975),(30.93,31.975),(30.93,31.825),(30.78,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,32.145),(30.78,32.295),(30.93,32.295),(30.93,32.145),(30.78,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,32.465),(30.78,32.615),(30.93,32.615),(30.93,32.465),(30.78,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,32.785),(30.78,32.935),(30.93,32.935),(30.93,32.785),(30.78,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,33.105),(30.78,33.255),(30.93,33.255),(30.93,33.105),(30.78,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,33.425),(30.78,33.575),(30.93,33.575),(30.93,33.425),(30.78,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,33.745),(30.78,33.895),(30.93,33.895),(30.93,33.745),(30.78,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,34.065),(30.78,34.215),(30.93,34.215),(30.93,34.065),(30.78,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,34.385),(30.78,34.535),(30.93,34.535),(30.93,34.385),(30.78,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,34.705),(30.78,34.855),(30.93,34.855),(30.93,34.705),(30.78,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,35.025),(30.78,35.175),(30.93,35.175),(30.93,35.025),(30.78,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,35.345),(30.78,35.495),(30.93,35.495),(30.93,35.345),(30.78,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,35.665),(30.78,35.815),(30.93,35.815),(30.93,35.665),(30.78,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,35.985),(30.78,36.135),(30.93,36.135),(30.93,35.985),(30.78,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,36.305),(30.78,36.455),(30.93,36.455),(30.93,36.305),(30.78,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,36.625),(30.78,36.775),(30.93,36.775),(30.93,36.625),(30.78,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,36.945),(30.78,37.095),(30.93,37.095),(30.93,36.945),(30.78,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,37.265),(30.78,37.415),(30.93,37.415),(30.93,37.265),(30.78,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,37.585),(30.78,37.735),(30.93,37.735),(30.93,37.585),(30.78,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,37.905),(30.78,38.055),(30.93,38.055),(30.93,37.905),(30.78,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,38.225),(30.78,38.375),(30.93,38.375),(30.93,38.225),(30.78,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,38.545),(30.78,38.695),(30.93,38.695),(30.93,38.545),(30.78,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,38.865),(30.78,39.015),(30.93,39.015),(30.93,38.865),(30.78,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,39.185),(30.78,39.335),(30.93,39.335),(30.93,39.185),(30.78,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,39.505),(30.78,39.655),(30.93,39.655),(30.93,39.505),(30.78,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,39.825),(30.78,39.975),(30.93,39.975),(30.93,39.825),(30.78,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,40.145),(30.78,40.295),(30.93,40.295),(30.93,40.145),(30.78,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,40.465),(30.78,40.615),(30.93,40.615),(30.93,40.465),(30.78,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,40.785),(30.78,40.935),(30.93,40.935),(30.93,40.785),(30.78,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,41.105),(30.78,41.255),(30.93,41.255),(30.93,41.105),(30.78,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,41.425),(30.78,41.575),(30.93,41.575),(30.93,41.425),(30.78,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,41.745),(30.78,41.895),(30.93,41.895),(30.93,41.745),(30.78,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,42.065),(30.78,42.215),(30.93,42.215),(30.93,42.065),(30.78,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,42.385),(30.78,42.535),(30.93,42.535),(30.93,42.385),(30.78,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,42.705),(30.78,42.855),(30.93,42.855),(30.93,42.705),(30.78,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,43.025),(30.78,43.175),(30.93,43.175),(30.93,43.025),(30.78,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((30.78,43.345),(30.78,43.495),(30.93,43.495),(30.93,43.345),(30.78,43.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.145),(44.925,0.295),(45.075,0.295),(45.075,0.145),(44.925,0.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.465),(44.925,0.615),(45.075,0.615),(45.075,0.465),(44.925,0.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,0.785),(44.925,0.935),(45.075,0.935),(45.075,0.785),(44.925,0.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.105),(44.925,1.255),(45.075,1.255),(45.075,1.105),(44.925,1.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.425),(44.925,1.575),(45.075,1.575),(45.075,1.425),(44.925,1.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,1.745),(44.925,1.895),(45.075,1.895),(45.075,1.745),(44.925,1.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.065),(44.925,2.215),(45.075,2.215),(45.075,2.065),(44.925,2.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.385),(44.925,2.535),(45.075,2.535),(45.075,2.385),(44.925,2.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,2.705),(44.925,2.855),(45.075,2.855),(45.075,2.705),(44.925,2.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.025),(44.925,3.175),(45.075,3.175),(45.075,3.025),(44.925,3.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.345),(44.925,3.495),(45.075,3.495),(45.075,3.345),(44.925,3.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.665),(44.925,3.815),(45.075,3.815),(45.075,3.665),(44.925,3.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,3.985),(44.925,4.135),(45.075,4.135),(45.075,3.985),(44.925,3.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.305),(44.925,4.455),(45.075,4.455),(45.075,4.305),(44.925,4.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.625),(44.925,4.775),(45.075,4.775),(45.075,4.625),(44.925,4.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,4.945),(44.925,5.095),(45.075,5.095),(45.075,4.945),(44.925,4.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.265),(44.925,5.415),(45.075,5.415),(45.075,5.265),(44.925,5.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.585),(44.925,5.735),(45.075,5.735),(45.075,5.585),(44.925,5.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,5.905),(44.925,6.055),(45.075,6.055),(45.075,5.905),(44.925,5.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.225),(44.925,6.375),(45.075,6.375),(45.075,6.225),(44.925,6.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.545),(44.925,6.695),(45.075,6.695),(45.075,6.545),(44.925,6.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,6.865),(44.925,7.015),(45.075,7.015),(45.075,6.865),(44.925,6.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.185),(44.925,7.335),(45.075,7.335),(45.075,7.185),(44.925,7.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.505),(44.925,7.655),(45.075,7.655),(45.075,7.505),(44.925,7.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,7.825),(44.925,7.975),(45.075,7.975),(45.075,7.825),(44.925,7.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.145),(44.925,8.295),(45.075,8.295),(45.075,8.145),(44.925,8.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.465),(44.925,8.615),(45.075,8.615),(45.075,8.465),(44.925,8.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,8.785),(44.925,8.935),(45.075,8.935),(45.075,8.785),(44.925,8.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.105),(44.925,9.255),(45.075,9.255),(45.075,9.105),(44.925,9.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.425),(44.925,9.575),(45.075,9.575),(45.075,9.425),(44.925,9.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,9.745),(44.925,9.895),(45.075,9.895),(45.075,9.745),(44.925,9.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.065),(44.925,10.215),(45.075,10.215),(45.075,10.065),(44.925,10.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.385),(44.925,10.535),(45.075,10.535),(45.075,10.385),(44.925,10.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,10.705),(44.925,10.855),(45.075,10.855),(45.075,10.705),(44.925,10.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.025),(44.925,11.175),(45.075,11.175),(45.075,11.025),(44.925,11.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.345),(44.925,11.495),(45.075,11.495),(45.075,11.345),(44.925,11.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.665),(44.925,11.815),(45.075,11.815),(45.075,11.665),(44.925,11.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,11.985),(44.925,12.135),(45.075,12.135),(45.075,11.985),(44.925,11.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.305),(44.925,12.455),(45.075,12.455),(45.075,12.305),(44.925,12.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.625),(44.925,12.775),(45.075,12.775),(45.075,12.625),(44.925,12.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,12.945),(44.925,13.095),(45.075,13.095),(45.075,12.945),(44.925,12.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.265),(44.925,13.415),(45.075,13.415),(45.075,13.265),(44.925,13.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.585),(44.925,13.735),(45.075,13.735),(45.075,13.585),(44.925,13.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,13.905),(44.925,14.055),(45.075,14.055),(45.075,13.905),(44.925,13.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.225),(44.925,14.375),(45.075,14.375),(45.075,14.225),(44.925,14.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.545),(44.925,14.695),(45.075,14.695),(45.075,14.545),(44.925,14.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,14.865),(44.925,15.015),(45.075,15.015),(45.075,14.865),(44.925,14.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.185),(44.925,15.335),(45.075,15.335),(45.075,15.185),(44.925,15.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.505),(44.925,15.655),(45.075,15.655),(45.075,15.505),(44.925,15.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,15.825),(44.925,15.975),(45.075,15.975),(45.075,15.825),(44.925,15.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.145),(44.925,16.295),(45.075,16.295),(45.075,16.145),(44.925,16.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.465),(44.925,16.615),(45.075,16.615),(45.075,16.465),(44.925,16.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,16.785),(44.925,16.935),(45.075,16.935),(45.075,16.785),(44.925,16.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.105),(44.925,17.255),(45.075,17.255),(45.075,17.105),(44.925,17.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.425),(44.925,17.575),(45.075,17.575),(45.075,17.425),(44.925,17.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,17.745),(44.925,17.895),(45.075,17.895),(45.075,17.745),(44.925,17.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.065),(44.925,18.215),(45.075,18.215),(45.075,18.065),(44.925,18.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.385),(44.925,18.535),(45.075,18.535),(45.075,18.385),(44.925,18.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,18.705),(44.925,18.855),(45.075,18.855),(45.075,18.705),(44.925,18.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.025),(44.925,19.175),(45.075,19.175),(45.075,19.025),(44.925,19.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.345),(44.925,19.495),(45.075,19.495),(45.075,19.345),(44.925,19.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.665),(44.925,19.815),(45.075,19.815),(45.075,19.665),(44.925,19.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,19.985),(44.925,20.135),(45.075,20.135),(45.075,19.985),(44.925,19.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.305),(44.925,20.455),(45.075,20.455),(45.075,20.305),(44.925,20.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.625),(44.925,20.775),(45.075,20.775),(45.075,20.625),(44.925,20.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,20.945),(44.925,21.095),(45.075,21.095),(45.075,20.945),(44.925,20.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.265),(44.925,21.415),(45.075,21.415),(45.075,21.265),(44.925,21.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.585),(44.925,21.735),(45.075,21.735),(45.075,21.585),(44.925,21.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,21.905),(44.925,22.055),(45.075,22.055),(45.075,21.905),(44.925,21.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.225),(44.925,22.375),(45.075,22.375),(45.075,22.225),(44.925,22.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.545),(44.925,22.695),(45.075,22.695),(45.075,22.545),(44.925,22.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,22.865),(44.925,23.015),(45.075,23.015),(45.075,22.865),(44.925,22.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.185),(44.925,23.335),(45.075,23.335),(45.075,23.185),(44.925,23.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.505),(44.925,23.655),(45.075,23.655),(45.075,23.505),(44.925,23.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,23.825),(44.925,23.975),(45.075,23.975),(45.075,23.825),(44.925,23.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.145),(44.925,24.295),(45.075,24.295),(45.075,24.145),(44.925,24.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.465),(44.925,24.615),(45.075,24.615),(45.075,24.465),(44.925,24.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,24.785),(44.925,24.935),(45.075,24.935),(45.075,24.785),(44.925,24.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.105),(44.925,25.255),(45.075,25.255),(45.075,25.105),(44.925,25.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.425),(44.925,25.575),(45.075,25.575),(45.075,25.425),(44.925,25.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,25.745),(44.925,25.895),(45.075,25.895),(45.075,25.745),(44.925,25.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.065),(44.925,26.215),(45.075,26.215),(45.075,26.065),(44.925,26.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.385),(44.925,26.535),(45.075,26.535),(45.075,26.385),(44.925,26.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,26.705),(44.925,26.855),(45.075,26.855),(45.075,26.705),(44.925,26.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.025),(44.925,27.175),(45.075,27.175),(45.075,27.025),(44.925,27.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.345),(44.925,27.495),(45.075,27.495),(45.075,27.345),(44.925,27.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.665),(44.925,27.815),(45.075,27.815),(45.075,27.665),(44.925,27.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,27.985),(44.925,28.135),(45.075,28.135),(45.075,27.985),(44.925,27.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.305),(44.925,28.455),(45.075,28.455),(45.075,28.305),(44.925,28.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.625),(44.925,28.775),(45.075,28.775),(45.075,28.625),(44.925,28.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,28.945),(44.925,29.095),(45.075,29.095),(45.075,28.945),(44.925,28.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.265),(44.925,29.415),(45.075,29.415),(45.075,29.265),(44.925,29.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.585),(44.925,29.735),(45.075,29.735),(45.075,29.585),(44.925,29.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,29.905),(44.925,30.055),(45.075,30.055),(45.075,29.905),(44.925,29.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.225),(44.925,30.375),(45.075,30.375),(45.075,30.225),(44.925,30.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.545),(44.925,30.695),(45.075,30.695),(45.075,30.545),(44.925,30.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,30.865),(44.925,31.015),(45.075,31.015),(45.075,30.865),(44.925,30.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.185),(44.925,31.335),(45.075,31.335),(45.075,31.185),(44.925,31.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.505),(44.925,31.655),(45.075,31.655),(45.075,31.505),(44.925,31.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,31.825),(44.925,31.975),(45.075,31.975),(45.075,31.825),(44.925,31.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.145),(44.925,32.295),(45.075,32.295),(45.075,32.145),(44.925,32.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.465),(44.925,32.615),(45.075,32.615),(45.075,32.465),(44.925,32.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,32.785),(44.925,32.935),(45.075,32.935),(45.075,32.785),(44.925,32.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.105),(44.925,33.255),(45.075,33.255),(45.075,33.105),(44.925,33.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.425),(44.925,33.575),(45.075,33.575),(45.075,33.425),(44.925,33.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,33.745),(44.925,33.895),(45.075,33.895),(45.075,33.745),(44.925,33.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.065),(44.925,34.215),(45.075,34.215),(45.075,34.065),(44.925,34.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.385),(44.925,34.535),(45.075,34.535),(45.075,34.385),(44.925,34.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,34.705),(44.925,34.855),(45.075,34.855),(45.075,34.705),(44.925,34.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.025),(44.925,35.175),(45.075,35.175),(45.075,35.025),(44.925,35.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.345),(44.925,35.495),(45.075,35.495),(45.075,35.345),(44.925,35.345)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.665),(44.925,35.815),(45.075,35.815),(45.075,35.665),(44.925,35.665)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,35.985),(44.925,36.135),(45.075,36.135),(45.075,35.985),(44.925,35.985)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.305),(44.925,36.455),(45.075,36.455),(45.075,36.305),(44.925,36.305)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.625),(44.925,36.775),(45.075,36.775),(45.075,36.625),(44.925,36.625)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,36.945),(44.925,37.095),(45.075,37.095),(45.075,36.945),(44.925,36.945)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.265),(44.925,37.415),(45.075,37.415),(45.075,37.265),(44.925,37.265)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.585),(44.925,37.735),(45.075,37.735),(45.075,37.585),(44.925,37.585)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,37.905),(44.925,38.055),(45.075,38.055),(45.075,37.905),(44.925,37.905)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.225),(44.925,38.375),(45.075,38.375),(45.075,38.225),(44.925,38.225)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.545),(44.925,38.695),(45.075,38.695),(45.075,38.545),(44.925,38.545)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,38.865),(44.925,39.015),(45.075,39.015),(45.075,38.865),(44.925,38.865)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.185),(44.925,39.335),(45.075,39.335),(45.075,39.185),(44.925,39.185)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.505),(44.925,39.655),(45.075,39.655),(45.075,39.505),(44.925,39.505)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,39.825),(44.925,39.975),(45.075,39.975),(45.075,39.825),(44.925,39.825)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.145),(44.925,40.295),(45.075,40.295),(45.075,40.145),(44.925,40.145)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.465),(44.925,40.615),(45.075,40.615),(45.075,40.465),(44.925,40.465)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,40.785),(44.925,40.935),(45.075,40.935),(45.075,40.785),(44.925,40.785)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.105),(44.925,41.255),(45.075,41.255),(45.075,41.105),(44.925,41.105)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.425),(44.925,41.575),(45.075,41.575),(45.075,41.425),(44.925,41.425)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,41.745),(44.925,41.895),(45.075,41.895),(45.075,41.745),(44.925,41.745)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.065),(44.925,42.215),(45.075,42.215),(45.075,42.065),(44.925,42.065)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.385),(44.925,42.535),(45.075,42.535),(45.075,42.385),(44.925,42.385)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,42.705),(44.925,42.855),(45.075,42.855),(45.075,42.705),(44.925,42.705)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,43.025),(44.925,43.175),(45.075,43.175),(45.075,43.025),(44.925,43.025)),
        )
        createRL(
            tech, net, 'via',
            ((44.925,43.345),(44.925,43.495),(45.075,43.495),(45.075,43.345),(44.925,43.345)),
        )
        createRL(
            tech, net, 'm2',
            ((44.87,0.06),(44.87,43.58),(45.13,43.58),(45.13,0.06),(44.87,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((49.67,0.06),(49.67,43.58),(49.93,43.58),(49.93,0.06),(49.67,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((30.725,0.06),(30.725,43.58),(30.985,43.58),(30.985,0.06),(30.725,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((40.07,0.06),(40.07,43.58),(40.33,43.58),(40.33,0.06),(40.07,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((35.27,0.06),(35.27,43.58),(35.53,43.58),(35.53,0.06),(35.27,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((59.015,0.06),(59.015,43.58),(59.275,43.58),(59.275,0.06),(59.015,0.06)),
        )
        createRL(
            tech, net, 'm2',
            ((54.47,0.06),(54.47,43.58),(54.73,43.58),(54.73,0.06),(54.47,0.06)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,21.36),(73.68,21.65),(74.01,21.65),(74.01,21.36),(73.68,21.36)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,21.39),(73.68,21.655),(74.01,21.655),(74.01,21.39),(73.68,21.39)),
        )
        net = nets['*']
        createRL(
            tech, net, 'nsdm',
            ((30.125,2.595),(30.125,41.045),(30.95,41.045),(30.95,2.595),(30.125,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((54.25,2.595),(54.25,41.045),(54.95,41.045),(54.95,2.595),(54.25,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((49.45,2.595),(49.45,41.045),(50.15,41.045),(50.15,2.595),(49.45,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((59.05,2.595),(59.05,41.045),(59.875,41.045),(59.875,2.595),(59.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((39.85,2.595),(39.85,41.045),(40.55,41.045),(40.55,2.595),(39.85,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((35.05,2.595),(35.05,41.045),(35.75,41.045),(35.75,2.595),(35.05,2.595)),
        )
        createRL(
            tech, net, 'nsdm',
            ((44.65,2.595),(44.65,41.045),(45.35,41.045),(45.35,2.595),(44.65,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.66,2.595),(45.66,41.045),(47.01,41.045),(47.01,2.595),(45.66,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.19,2.595),(38.19,41.045),(39.54,41.045),(39.54,2.595),(38.19,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.99,2.595),(42.99,41.045),(44.34,41.045),(44.34,2.595),(42.99,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.15,2.595),(50.15,41.045),(50.595,41.045),(50.595,2.595),(50.15,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.39,2.595),(57.39,41.045),(58.74,41.045),(58.74,2.595),(57.39,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.565,2.65),(55.565,40.99),(56.305,40.99),(56.305,2.65),(55.565,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((34.605,2.595),(34.605,41.045),(35.05,41.045),(35.05,2.595),(34.605,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((49.005,2.595),(49.005,41.045),(49.45,41.045),(49.45,2.595),(49.005,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((30.95,2.595),(30.95,41.045),(31.395,41.045),(31.395,2.595),(30.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.365,2.65),(36.365,40.99),(37.105,40.99),(37.105,2.65),(36.365,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.965,2.65),(45.965,40.99),(46.705,40.99),(46.705,2.65),(45.965,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((43.295,2.65),(43.295,40.99),(44.035,40.99),(44.035,2.65),(43.295,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((46.98,2.595),(46.98,41.045),(47.82,41.045),(47.82,2.595),(46.98,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((35.75,2.595),(35.75,41.045),(36.195,41.045),(36.195,2.595),(35.75,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((37.38,2.595),(37.38,41.045),(38.22,41.045),(38.22,2.595),(37.38,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((44.205,2.595),(44.205,41.045),(44.65,41.045),(44.65,2.595),(44.205,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((42.18,2.595),(42.18,41.045),(43.02,41.045),(43.02,2.595),(42.18,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((54.95,2.595),(54.95,41.045),(55.395,41.045),(55.395,2.595),(54.95,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((56.58,2.595),(56.58,41.045),(57.42,41.045),(57.42,2.595),(56.58,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.55,2.595),(40.55,41.045),(40.995,41.045),(40.995,2.595),(40.55,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.765,2.65),(50.765,40.99),(51.505,40.99),(51.505,2.65),(50.765,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.695,2.65),(33.695,40.99),(34.435,40.99),(34.435,2.65),(33.695,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.895,2.65),(52.895,40.99),(53.635,40.99),(53.635,2.65),(52.895,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((55.26,2.595),(55.26,41.045),(56.61,41.045),(56.61,2.595),(55.26,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((51.78,2.595),(51.78,41.045),(52.62,41.045),(52.62,2.595),(51.78,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((36.06,2.595),(36.06,41.045),(37.41,41.045),(37.41,2.595),(36.06,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((53.805,2.595),(53.805,41.045),(54.25,41.045),(54.25,2.595),(53.805,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((48.095,2.65),(48.095,40.99),(48.835,40.99),(48.835,2.65),(48.095,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((39.405,2.595),(39.405,41.045),(39.85,41.045),(39.85,2.595),(39.405,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((58.605,2.595),(58.605,41.045),(59.05,41.045),(59.05,2.595),(58.605,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((40.86,2.595),(40.86,41.045),(42.21,41.045),(42.21,2.595),(40.86,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((41.165,2.65),(41.165,40.99),(41.905,40.99),(41.905,2.65),(41.165,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((47.79,2.595),(47.79,41.045),(49.14,41.045),(49.14,2.595),(47.79,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.565,2.65),(31.565,40.99),(32.305,40.99),(32.305,2.65),(31.565,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((50.46,2.595),(50.46,41.045),(51.81,41.045),(51.81,2.595),(50.46,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((33.39,2.595),(33.39,41.045),(34.74,41.045),(34.74,2.595),(33.39,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((38.495,2.65),(38.495,40.99),(39.235,40.99),(39.235,2.65),(38.495,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((57.695,2.65),(57.695,40.99),(58.435,40.99),(58.435,2.65),(57.695,2.65)),
        )
        createRL(
            tech, net, 'psdm',
            ((52.59,2.595),(52.59,41.045),(53.94,41.045),(53.94,2.595),(52.59,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((32.58,2.595),(32.58,41.045),(33.42,41.045),(33.42,2.595),(32.58,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((31.26,2.595),(31.26,41.045),(32.61,41.045),(32.61,2.595),(31.26,2.595)),
        )
        createRL(
            tech, net, 'psdm',
            ((45.35,2.595),(45.35,41.045),(45.795,41.045),(45.795,2.595),(45.35,2.595)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.605,2.54),(45.605,41.1),(47.065,41.1),(47.065,2.54),(45.605,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.135,2.54),(38.135,41.1),(39.595,41.1),(39.595,2.54),(38.135,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((42.935,2.54),(42.935,41.1),(44.395,41.1),(44.395,2.54),(42.935,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((38.365,2.52),(38.365,41.12),(39.365,41.12),(39.365,2.52),(38.365,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.335,2.54),(57.335,41.1),(58.795,41.1),(58.795,2.54),(57.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((57.565,2.52),(57.565,41.12),(58.565,41.12),(58.565,2.52),(57.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((30.05,2.52),(30.05,41.12),(59.95,41.12),(59.95,2.52),(30.05,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.965,2.52),(47.965,41.12),(48.965,41.12),(48.965,2.52),(47.965,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.205,2.54),(55.205,41.1),(56.665,41.1),(56.665,2.54),(55.205,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((55.435,2.52),(55.435,41.12),(56.435,41.12),(56.435,2.52),(55.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((43.165,2.52),(43.165,41.12),(44.165,41.12),(44.165,2.52),(43.165,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.235,2.52),(36.235,41.12),(37.235,41.12),(37.235,2.52),(36.235,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((45.835,2.52),(45.835,41.12),(46.835,41.12),(46.835,2.52),(45.835,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((36.005,2.54),(36.005,41.1),(37.465,41.1),(37.465,2.54),(36.005,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((40.805,2.54),(40.805,41.1),(42.265,41.1),(42.265,2.54),(40.805,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((47.735,2.54),(47.735,41.1),(49.195,41.1),(49.195,2.54),(47.735,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.405,2.54),(50.405,41.1),(51.865,41.1),(51.865,2.54),(50.405,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((50.635,2.52),(50.635,41.12),(51.635,41.12),(51.635,2.52),(50.635,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.335,2.54),(33.335,41.1),(34.795,41.1),(34.795,2.54),(33.335,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((33.565,2.52),(33.565,41.12),(34.565,41.12),(34.565,2.52),(33.565,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.435,2.52),(31.435,41.12),(32.435,41.12),(32.435,2.52),(31.435,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.765,2.52),(52.765,41.12),(53.765,41.12),(53.765,2.52),(52.765,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((52.535,2.54),(52.535,41.1),(53.995,41.1),(53.995,2.54),(52.535,2.54)),
        )
        createRL(
            tech, net, 'hvi',
            ((41.035,2.52),(41.035,41.12),(42.035,41.12),(42.035,2.52),(41.035,2.52)),
        )
        createRL(
            tech, net, 'hvi',
            ((31.205,2.54),(31.205,41.1),(32.665,41.1),(32.665,2.54),(31.205,2.54)),
        )
        createRL(
            tech, net, 'polyres',
            ((73.675,21.655),(73.675,21.985),(74.015,21.985),(74.015,21.655),(73.675,21.655)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,21.655),(73.68,21.985),(74.01,21.985),(74.01,21.655),(73.68,21.655)),
        )
        net = nets['pad']
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,40.92),(52.495,40.92),(52.495,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.685,2.72),(51.685,40.92),(52.495,40.92),(52.495,2.72),(51.685,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.905,2.72),(51.905,40.92),(52.715,40.92),(52.715,2.72),(51.905,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((43.115,2.72),(43.115,40.92),(43.365,40.92),(43.365,2.72),(43.115,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.635,2.72),(46.635,40.92),(46.885,40.92),(46.885,2.72),(46.635,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((52.715,2.72),(52.715,40.92),(52.965,40.92),(52.965,2.72),(52.715,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.035,2.72),(37.035,40.92),(37.285,40.92),(37.285,2.72),(37.035,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((57.515,2.72),(57.515,40.92),(57.765,40.92),(57.765,2.72),(57.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,40.92),(47.695,40.92),(47.695,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.105,2.72),(47.105,40.92),(47.915,40.92),(47.915,2.72),(47.105,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.485,2.72),(32.485,40.92),(33.295,40.92),(33.295,2.72),(32.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,40.92),(33.295,40.92),(33.295,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.705,2.72),(32.705,40.92),(33.515,40.92),(33.515,2.72),(32.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((47.915,2.72),(47.915,40.92),(48.165,40.92),(48.165,2.72),(47.915,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,40.92),(57.295,40.92),(57.295,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.485,2.72),(56.485,40.92),(57.295,40.92),(57.295,2.72),(56.485,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((41.835,2.72),(41.835,40.92),(42.085,40.92),(42.085,2.72),(41.835,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((46.885,2.72),(46.885,40.92),(47.695,40.92),(47.695,2.72),(46.885,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((32.235,2.72),(32.235,40.92),(32.485,40.92),(32.485,2.72),(32.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((33.515,2.72),(33.515,40.92),(33.765,40.92),(33.765,2.72),(33.515,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.085,2.72),(42.085,40.92),(42.895,40.92),(42.895,2.72),(42.085,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((51.435,2.72),(51.435,40.92),(51.685,40.92),(51.685,2.72),(51.435,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.285,2.72),(37.285,40.92),(38.095,40.92),(38.095,2.72),(37.285,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,40.92),(38.315,40.92),(38.315,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((37.505,2.72),(37.505,40.92),(38.095,40.92),(38.095,2.72),(37.505,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((38.315,2.72),(38.315,40.92),(38.565,40.92),(38.565,2.72),(38.315,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,40.92),(43.115,40.92),(43.115,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.235,2.72),(56.235,40.92),(56.485,40.92),(56.485,2.72),(56.235,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((56.705,2.72),(56.705,40.92),(57.515,40.92),(57.515,2.72),(56.705,2.72)),
        )
        createRL(
            tech, net, 'difftap',
            ((42.305,2.72),(42.305,40.92),(42.895,40.92),(42.895,2.72),(42.305,2.72)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.165),(33.085,18.335),(33.255,18.335),(33.255,18.165),(33.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.505),(33.085,18.675),(33.255,18.675),(33.255,18.505),(33.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.305),(56.745,8.475),(56.915,8.475),(56.915,8.305),(56.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.645),(56.745,8.815),(56.915,8.815),(56.915,8.645),(56.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.225),(42.345,21.395),(42.515,21.395),(42.515,21.225),(42.345,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.085),(47.485,31.255),(47.655,31.255),(47.655,31.085),(47.485,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.665),(47.145,9.835),(47.315,9.835),(47.315,9.665),(47.145,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.925),(56.745,40.095),(56.915,40.095),(56.915,39.925),(56.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.905),(57.085,39.075),(57.255,39.075),(57.255,38.905),(57.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.185),(32.745,19.355),(32.915,19.355),(32.915,19.185),(32.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.525),(32.745,19.695),(32.915,19.695),(32.915,19.525),(32.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.905),(37.885,39.075),(38.055,39.075),(38.055,38.905),(37.885,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.905),(47.145,39.075),(47.315,39.075),(47.315,38.905),(47.145,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.905),(47.485,39.075),(47.655,39.075),(47.655,38.905),(47.485,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.265),(37.545,6.435),(37.715,6.435),(37.715,6.265),(37.545,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.605),(37.545,6.775),(37.715,6.775),(37.715,6.605),(37.545,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.025),(37.545,11.195),(37.715,11.195),(37.715,11.025),(37.545,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.365),(37.545,11.535),(37.715,11.535),(37.715,11.365),(37.545,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,11.705),(37.545,11.875),(37.715,11.875),(37.715,11.705),(37.545,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.125),(42.345,33.295),(42.515,33.295),(42.515,33.125),(42.345,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.465),(42.345,33.635),(42.515,33.635),(42.515,33.465),(42.345,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,33.805),(42.345,33.975),(42.515,33.975),(42.515,33.805),(42.345,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.585),(42.345,39.755),(42.515,39.755),(42.515,39.585),(42.345,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.225),(56.745,4.395),(56.915,4.395),(56.915,4.225),(56.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.565),(56.745,4.735),(56.915,4.735),(56.915,4.565),(56.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.105),(32.745,15.275),(32.915,15.275),(32.915,15.105),(32.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.445),(32.745,15.615),(32.915,15.615),(32.915,15.445),(32.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.205),(47.145,20.375),(47.315,20.375),(47.315,20.205),(47.145,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.205),(47.485,20.375),(47.655,20.375),(47.655,20.205),(47.485,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.545),(47.145,20.715),(47.315,20.715),(47.315,20.545),(47.145,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.545),(47.485,20.715),(47.655,20.715),(47.655,20.545),(47.485,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.205),(42.345,3.375),(42.515,3.375),(42.515,3.205),(42.345,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.205),(42.685,3.375),(42.855,3.375),(42.855,3.205),(42.685,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.545),(42.345,3.715),(42.515,3.715),(42.515,3.545),(42.345,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.545),(42.685,3.715),(42.855,3.715),(42.855,3.545),(42.685,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.225),(32.745,4.395),(32.915,4.395),(32.915,4.225),(32.745,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.565),(32.745,4.735),(32.915,4.735),(32.915,4.565),(32.745,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.805),(52.285,33.975),(52.455,33.975),(52.455,33.805),(52.285,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.725),(33.085,29.895),(33.255,29.895),(33.255,29.725),(33.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.265),(42.345,23.435),(42.515,23.435),(42.515,23.265),(42.345,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.605),(42.685,23.775),(42.855,23.775),(42.855,23.605),(42.685,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.265),(42.685,23.435),(42.855,23.435),(42.855,23.265),(42.685,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.605),(42.345,23.775),(42.515,23.775),(42.515,23.605),(42.345,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.325),(56.745,9.495),(56.915,9.495),(56.915,9.325),(56.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,9.665),(56.745,9.835),(56.915,9.835),(56.915,9.665),(56.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.345),(57.085,10.515),(57.255,10.515),(57.255,10.345),(57.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.785),(37.885,32.955),(38.055,32.955),(38.055,32.785),(37.885,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.105),(37.885,32.275),(38.055,32.275),(38.055,32.105),(37.885,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,32.445),(37.885,32.615),(38.055,32.615),(38.055,32.445),(37.885,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.025),(37.885,28.195),(38.055,28.195),(38.055,28.025),(37.885,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.965),(37.545,8.135),(37.715,8.135),(37.715,7.965),(37.545,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.165),(37.885,35.335),(38.055,35.335),(38.055,35.165),(37.885,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.505),(37.885,35.675),(38.055,35.675),(38.055,35.505),(37.885,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.365),(37.885,28.535),(38.055,28.535),(38.055,28.365),(37.885,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.925),(52.285,40.095),(52.455,40.095),(52.455,39.925),(52.285,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.785),(51.945,32.955),(52.115,32.955),(52.115,32.785),(51.945,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.105),(51.945,32.275),(52.115,32.275),(52.115,32.105),(51.945,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,32.445),(51.945,32.615),(52.115,32.615),(52.115,32.445),(51.945,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.425),(32.745,31.595),(32.915,31.595),(32.915,31.425),(32.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.245),(52.285,5.415),(52.455,5.415),(52.455,5.245),(52.285,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.585),(52.285,5.755),(52.455,5.755),(52.455,5.585),(52.285,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.085),(32.745,31.255),(32.915,31.255),(32.915,31.085),(32.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,31.765),(32.745,31.935),(32.915,31.935),(32.915,31.765),(32.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.885),(51.945,4.055),(52.115,4.055),(52.115,3.885),(51.945,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,2.865),(56.745,3.035),(56.915,3.035),(56.915,2.865),(56.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.105),(37.545,15.275),(37.715,15.275),(37.715,15.105),(37.545,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.445),(37.545,15.615),(37.715,15.615),(37.715,15.445),(37.545,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,15.785),(37.545,15.955),(37.715,15.955),(37.715,15.785),(37.545,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.205),(47.145,3.375),(47.315,3.375),(47.315,3.205),(47.145,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.305),(47.485,25.475),(47.655,25.475),(47.655,25.305),(47.485,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.305),(47.145,25.475),(47.315,25.475),(47.315,25.305),(47.145,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.665),(51.945,9.835),(52.115,9.835),(52.115,9.665),(51.945,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,9.325),(51.945,9.495),(52.115,9.495),(52.115,9.325),(51.945,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.645),(47.145,25.815),(47.315,25.815),(47.315,25.645),(47.145,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.805),(51.945,16.975),(52.115,16.975),(52.115,16.805),(51.945,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.905),(51.945,5.075),(52.115,5.075),(52.115,4.905),(51.945,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.645),(47.485,25.815),(47.655,25.815),(47.655,25.645),(47.485,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.985),(33.085,9.155),(33.255,9.155),(33.255,8.985),(33.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,15.785),(32.745,15.955),(32.915,15.955),(32.915,15.785),(32.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,2.865),(32.745,3.035),(32.915,3.035),(32.915,2.865),(32.745,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.845),(56.745,36.015),(56.915,36.015),(56.915,35.845),(56.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.985),(37.885,26.155),(38.055,26.155),(38.055,25.985),(37.885,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.925),(52.285,23.095),(52.455,23.095),(52.455,22.925),(52.285,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.125),(51.945,16.295),(52.115,16.295),(52.115,16.125),(51.945,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.965),(52.285,25.135),(52.455,25.135),(52.455,24.965),(52.285,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.645),(37.545,25.815),(37.715,25.815),(37.715,25.645),(37.545,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.305),(37.545,25.475),(37.715,25.475),(37.715,25.305),(37.545,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.245),(56.745,5.415),(56.915,5.415),(56.915,5.245),(56.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.585),(56.745,5.755),(56.915,5.755),(56.915,5.585),(56.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.685),(52.285,27.855),(52.455,27.855),(52.455,27.685),(52.285,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.005),(52.285,27.175),(52.455,27.175),(52.455,27.005),(52.285,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,27.345),(52.285,27.515),(52.455,27.515),(52.455,27.345),(52.285,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.765),(57.085,31.935),(57.255,31.935),(57.255,31.765),(57.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.085),(57.085,31.255),(57.255,31.255),(57.255,31.085),(57.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.585),(32.745,5.755),(32.915,5.755),(32.915,5.585),(32.745,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,31.425),(57.085,31.595),(57.255,31.595),(57.255,31.425),(57.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.905),(37.545,39.075),(37.715,39.075),(37.715,38.905),(37.545,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.245),(32.745,5.415),(32.915,5.415),(32.915,5.245),(32.745,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.345),(51.945,27.515),(52.115,27.515),(52.115,27.345),(51.945,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.205),(57.085,37.375),(57.255,37.375),(57.255,37.205),(57.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.545),(57.085,37.715),(57.255,37.715),(57.255,37.545),(57.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.965),(37.545,25.135),(37.715,25.135),(37.715,24.965),(37.545,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.225),(32.745,38.395),(32.915,38.395),(32.915,38.225),(32.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.565),(32.745,38.735),(32.915,38.735),(32.915,38.565),(32.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.765),(47.145,31.935),(47.315,31.935),(47.315,31.765),(47.145,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.765),(47.485,31.935),(47.655,31.935),(47.655,31.765),(47.485,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,31.425),(47.485,31.595),(47.655,31.595),(47.655,31.425),(47.485,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,26.325),(32.745,26.495),(32.915,26.495),(32.915,26.325),(32.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.065),(33.085,30.235),(33.255,30.235),(33.255,30.065),(33.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.845),(32.745,19.015),(32.915,19.015),(32.915,18.845),(32.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.405),(33.085,30.575),(33.255,30.575),(33.255,30.405),(33.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,30.745),(33.085,30.915),(33.255,30.915),(33.255,30.745),(33.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.205),(47.145,37.375),(47.315,37.375),(47.315,37.205),(47.145,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.545),(47.145,37.715),(47.315,37.715),(47.315,37.545),(47.145,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.545),(47.485,37.715),(47.655,37.715),(47.655,37.545),(47.485,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.205),(47.485,37.375),(47.655,37.375),(47.655,37.205),(47.485,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.905),(33.085,22.075),(33.255,22.075),(33.255,21.905),(33.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.025),(32.745,11.195),(32.915,11.195),(32.915,11.025),(32.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.365),(32.745,11.535),(32.915,11.535),(32.915,11.365),(32.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,11.705),(32.745,11.875),(32.915,11.875),(32.915,11.705),(32.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.905),(47.485,5.075),(47.655,5.075),(47.655,4.905),(47.485,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.805),(56.745,33.975),(56.915,33.975),(56.915,33.805),(56.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.945),(47.145,7.115),(47.315,7.115),(47.315,6.945),(47.145,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.945),(47.485,7.115),(47.655,7.115),(47.655,6.945),(47.485,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.205),(37.885,3.375),(38.055,3.375),(38.055,3.205),(37.885,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.545),(42.685,37.715),(42.855,37.715),(42.855,37.545),(42.685,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.545),(37.885,3.715),(38.055,3.715),(38.055,3.545),(37.885,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.825),(56.745,34.995),(56.915,34.995),(56.915,34.825),(56.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.145),(56.745,34.315),(56.915,34.315),(56.915,34.145),(56.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,34.485),(56.745,34.655),(56.915,34.655),(56.915,34.485),(56.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.545),(42.345,37.715),(42.515,37.715),(42.515,37.545),(42.345,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.205),(37.545,20.375),(37.715,20.375),(37.715,20.205),(37.545,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.545),(37.545,20.715),(37.715,20.715),(37.715,20.545),(37.545,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.825),(52.285,34.995),(52.455,34.995),(52.455,34.825),(52.285,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.205),(42.345,37.375),(42.515,37.375),(42.515,37.205),(42.345,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.145),(52.285,34.315),(52.455,34.315),(52.455,34.145),(52.285,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,34.485),(52.285,34.655),(52.455,34.655),(52.455,34.485),(52.285,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.805),(32.745,33.975),(32.915,33.975),(32.915,33.805),(32.745,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.125),(32.745,33.295),(32.915,33.295),(32.915,33.125),(32.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,26.325),(37.545,26.495),(37.715,26.495),(37.715,26.325),(37.545,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,33.465),(32.745,33.635),(32.915,33.635),(32.915,33.465),(32.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,26.665),(37.545,26.835),(37.715,26.835),(37.715,26.665),(37.545,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.825),(32.745,34.995),(32.915,34.995),(32.915,34.825),(32.745,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.145),(32.745,34.315),(32.915,34.315),(32.915,34.145),(32.745,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,34.485),(32.745,34.655),(32.915,34.655),(32.915,34.485),(32.745,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.065),(47.145,30.235),(47.315,30.235),(47.315,30.065),(47.145,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.585),(32.745,39.755),(32.915,39.755),(32.915,39.585),(32.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,2.865),(57.085,3.035),(57.255,3.035),(57.255,2.865),(57.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.125),(33.085,16.295),(33.255,16.295),(33.255,16.125),(33.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.985),(37.545,9.155),(37.715,9.155),(37.715,8.985),(37.545,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.465),(33.085,16.635),(33.255,16.635),(33.255,16.465),(33.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,16.805),(33.085,16.975),(33.255,16.975),(33.255,16.805),(33.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.245),(32.745,39.415),(32.915,39.415),(32.915,39.245),(32.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.805),(37.885,16.975),(38.055,16.975),(38.055,16.805),(37.885,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.125),(37.885,16.295),(38.055,16.295),(38.055,16.125),(37.885,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.225),(33.085,38.395),(33.255,38.395),(33.255,38.225),(33.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.565),(33.085,38.735),(33.255,38.735),(33.255,38.565),(33.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.205),(56.745,20.375),(56.915,20.375),(56.915,20.205),(56.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.545),(56.745,20.715),(56.915,20.715),(56.915,20.545),(56.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.845),(47.145,36.015),(47.315,36.015),(47.315,35.845),(47.145,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.845),(47.485,36.015),(47.655,36.015),(47.655,35.845),(47.485,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.585),(57.085,5.755),(57.255,5.755),(57.255,5.585),(57.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,2.865),(33.085,3.035),(33.255,3.035),(33.255,2.865),(33.085,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.245),(51.945,39.415),(52.115,39.415),(52.115,39.245),(51.945,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.865),(32.745,37.035),(32.915,37.035),(32.915,36.865),(32.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.585),(51.945,39.755),(52.115,39.755),(52.115,39.585),(51.945,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.965),(37.885,25.135),(38.055,25.135),(38.055,24.965),(37.885,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.865),(57.085,37.035),(57.255,37.035),(57.255,36.865),(57.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.685),(37.545,27.855),(37.715,27.855),(37.715,27.685),(37.545,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,26.325),(42.345,26.495),(42.515,26.495),(42.515,26.325),(42.345,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,26.325),(42.685,26.495),(42.855,26.495),(42.855,26.325),(42.685,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,26.665),(42.345,26.835),(42.515,26.835),(42.515,26.665),(42.345,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,26.665),(42.685,26.835),(42.855,26.835),(42.855,26.665),(42.685,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.745),(32.745,30.915),(32.915,30.915),(32.915,30.745),(32.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.065),(37.545,30.235),(37.715,30.235),(37.715,30.065),(37.545,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.265),(33.085,23.435),(33.255,23.435),(33.255,23.265),(33.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.605),(33.085,23.775),(33.255,23.775),(33.255,23.605),(33.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.405),(37.545,30.575),(37.715,30.575),(37.715,30.405),(37.545,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.945),(52.285,24.115),(52.455,24.115),(52.455,23.945),(52.285,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.565),(37.545,4.735),(37.715,4.735),(37.715,4.565),(37.545,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,30.745),(37.545,30.915),(37.715,30.915),(37.715,30.745),(37.545,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.225),(37.545,4.395),(37.715,4.395),(37.715,4.225),(37.545,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.545),(57.085,3.715),(57.255,3.715),(57.255,3.545),(57.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.205),(57.085,3.375),(57.255,3.375),(57.255,3.205),(57.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.305),(56.745,25.475),(56.915,25.475),(56.915,25.305),(56.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.645),(56.745,25.815),(56.915,25.815),(56.915,25.645),(56.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.685),(37.545,10.855),(37.715,10.855),(37.715,10.685),(37.545,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.005),(37.545,10.175),(37.715,10.175),(37.715,10.005),(37.545,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.265),(56.745,6.435),(56.915,6.435),(56.915,6.265),(56.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.605),(56.745,6.775),(56.915,6.775),(56.915,6.605),(56.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,10.345),(37.545,10.515),(37.715,10.515),(37.715,10.345),(37.545,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.725),(51.945,29.895),(52.115,29.895),(52.115,29.725),(51.945,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.705),(33.085,28.875),(33.255,28.875),(33.255,28.705),(33.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.205),(52.285,37.375),(52.455,37.375),(52.455,37.205),(52.285,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.045),(51.945,29.215),(52.115,29.215),(52.115,29.045),(51.945,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,29.385),(51.945,29.555),(52.115,29.555),(52.115,29.385),(51.945,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.265),(37.545,23.435),(37.715,23.435),(37.715,23.265),(37.545,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.605),(37.545,23.775),(37.715,23.775),(37.715,23.605),(37.545,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.205),(33.085,3.375),(33.255,3.375),(33.255,3.205),(33.085,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.545),(33.085,3.715),(33.255,3.715),(33.255,3.545),(33.085,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.385),(33.085,12.555),(33.255,12.555),(33.255,12.385),(33.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.725),(33.085,12.895),(33.255,12.895),(33.255,12.725),(33.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.265),(32.745,6.435),(32.915,6.435),(32.915,6.265),(32.745,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.605),(32.745,6.775),(32.915,6.775),(32.915,6.605),(32.745,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.645),(33.085,25.815),(33.255,25.815),(33.255,25.645),(33.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.305),(33.085,25.475),(33.255,25.475),(33.255,25.305),(33.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.305),(42.345,8.475),(42.515,8.475),(42.515,8.305),(42.345,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.305),(42.685,8.475),(42.855,8.475),(42.855,8.305),(42.685,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.645),(42.345,8.815),(42.515,8.815),(42.515,8.645),(42.345,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.645),(42.685,8.815),(42.855,8.815),(42.855,8.645),(42.685,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.865),(51.945,37.035),(52.115,37.035),(52.115,36.865),(51.945,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.165),(52.285,18.335),(52.455,18.335),(52.455,18.165),(52.285,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.585),(47.485,5.755),(47.655,5.755),(47.655,5.585),(47.485,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.245),(47.485,5.415),(47.655,5.415),(47.655,5.245),(47.485,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.505),(52.285,18.675),(52.455,18.675),(52.455,18.505),(52.285,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,18.845),(33.085,19.015),(33.255,19.015),(33.255,18.845),(33.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.245),(47.145,5.415),(47.315,5.415),(47.315,5.245),(47.145,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,8.985),(56.745,9.155),(56.915,9.155),(56.915,8.985),(56.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.285),(42.345,7.455),(42.515,7.455),(42.515,7.285),(42.345,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.225),(52.285,21.395),(52.455,21.395),(52.455,21.225),(52.285,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.565),(52.285,21.735),(52.455,21.735),(52.455,21.565),(52.285,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.245),(51.945,5.415),(52.115,5.415),(52.115,5.245),(51.945,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.585),(51.945,5.755),(52.115,5.755),(52.115,5.585),(51.945,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.985),(37.885,9.155),(38.055,9.155),(38.055,8.985),(37.885,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.685),(42.345,10.855),(42.515,10.855),(42.515,10.685),(42.345,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.685),(42.685,10.855),(42.855,10.855),(42.855,10.685),(42.685,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.005),(42.345,10.175),(42.515,10.175),(42.515,10.005),(42.345,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.005),(42.685,10.175),(42.855,10.175),(42.855,10.005),(42.685,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.065),(56.745,30.235),(56.915,30.235),(56.915,30.065),(56.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.405),(56.745,30.575),(56.915,30.575),(56.915,30.405),(56.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,30.745),(56.745,30.915),(56.915,30.915),(56.915,30.745),(56.745,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.305),(51.945,25.475),(52.115,25.475),(52.115,25.305),(51.945,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.645),(51.945,25.815),(52.115,25.815),(52.115,25.645),(51.945,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,10.345),(42.345,10.515),(42.515,10.515),(42.515,10.345),(42.345,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.085),(47.145,14.255),(47.315,14.255),(47.315,14.085),(47.145,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.085),(47.485,14.255),(47.655,14.255),(47.655,14.085),(47.485,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.425),(47.145,14.595),(47.315,14.595),(47.315,14.425),(47.145,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.425),(47.485,14.595),(47.655,14.595),(47.655,14.425),(47.485,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.645),(42.345,25.815),(42.515,25.815),(42.515,25.645),(42.345,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.225),(37.885,38.395),(38.055,38.395),(38.055,38.225),(37.885,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,38.565),(37.885,38.735),(38.055,38.735),(38.055,38.565),(37.885,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,14.765),(47.145,14.935),(47.315,14.935),(47.315,14.765),(47.145,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,14.765),(47.485,14.935),(47.655,14.935),(47.655,14.765),(47.485,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.885),(51.945,21.055),(52.115,21.055),(52.115,20.885),(51.945,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.305),(42.685,25.475),(42.855,25.475),(42.855,25.305),(42.685,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.645),(42.685,25.815),(42.855,25.815),(42.855,25.645),(42.685,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.405),(42.345,30.575),(42.515,30.575),(42.515,30.405),(42.345,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.285),(52.285,7.455),(52.455,7.455),(52.455,7.285),(52.285,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.625),(52.285,7.795),(52.455,7.795),(52.455,7.625),(52.285,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.825),(47.485,34.995),(47.655,34.995),(47.655,34.825),(47.485,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.485),(47.145,34.655),(47.315,34.655),(47.315,34.485),(47.145,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.485),(47.485,34.655),(47.655,34.655),(47.655,34.485),(47.485,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,6.945),(37.545,7.115),(37.715,7.115),(37.715,6.945),(37.545,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.525),(33.085,19.695),(33.255,19.695),(33.255,19.525),(33.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.185),(33.085,19.355),(33.255,19.355),(33.255,19.185),(33.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.145),(47.145,34.315),(47.315,34.315),(47.315,34.145),(47.145,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,34.145),(47.485,34.315),(47.655,34.315),(47.655,34.145),(47.485,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.385),(47.145,12.555),(47.315,12.555),(47.315,12.385),(47.145,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.385),(47.485,12.555),(47.655,12.555),(47.655,12.385),(47.485,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.725),(47.145,12.895),(47.315,12.895),(47.315,12.725),(47.145,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.725),(47.485,12.895),(47.655,12.895),(47.655,12.725),(47.485,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.025),(33.085,28.195),(33.255,28.195),(33.255,28.025),(33.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,28.365),(33.085,28.535),(33.255,28.535),(33.255,28.365),(33.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.565),(56.745,21.735),(56.915,21.735),(56.915,21.565),(56.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,12.045),(47.145,12.215),(47.315,12.215),(47.315,12.045),(47.145,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.685),(57.085,10.855),(57.255,10.855),(57.255,10.685),(57.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,20.885),(47.485,21.055),(47.655,21.055),(47.655,20.885),(47.485,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,40.605),(32.745,40.775),(32.915,40.775),(32.915,40.605),(32.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,20.885),(47.145,21.055),(47.315,21.055),(47.315,20.885),(47.145,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.985),(32.745,26.155),(32.915,26.155),(32.915,25.985),(32.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,34.825),(47.145,34.995),(47.315,34.995),(47.315,34.825),(47.145,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,40.265),(32.745,40.435),(32.915,40.435),(32.915,40.265),(32.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.225),(56.745,21.395),(56.915,21.395),(56.915,21.225),(56.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.625),(47.145,24.795),(47.315,24.795),(47.315,24.625),(47.145,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.625),(47.485,24.795),(47.655,24.795),(47.655,24.625),(47.485,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.285),(47.145,24.455),(47.315,24.455),(47.315,24.285),(47.145,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,4.905),(32.745,5.075),(32.915,5.075),(32.915,4.905),(32.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.945),(51.945,7.115),(52.115,7.115),(52.115,6.945),(51.945,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.285),(47.485,24.455),(47.655,24.455),(47.655,24.285),(47.485,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,3.885),(42.345,4.055),(42.515,4.055),(42.515,3.885),(42.345,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,3.885),(42.685,4.055),(42.855,4.055),(42.855,3.885),(42.685,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.865),(47.145,37.035),(47.315,37.035),(47.315,36.865),(47.145,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.905),(42.685,22.075),(42.855,22.075),(42.855,21.905),(42.685,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.905),(42.345,22.075),(42.515,22.075),(42.515,21.905),(42.345,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.885),(56.745,38.055),(56.915,38.055),(56.915,37.885),(56.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.925),(37.885,40.095),(38.055,40.095),(38.055,39.925),(37.885,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.285),(56.745,7.455),(56.915,7.455),(56.915,7.285),(56.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,12.045),(33.085,12.215),(33.255,12.215),(33.255,12.045),(33.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.625),(56.745,7.795),(56.915,7.795),(56.915,7.625),(56.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.265),(57.085,6.435),(57.255,6.435),(57.255,6.265),(57.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.605),(57.085,6.775),(57.255,6.775),(57.255,6.605),(57.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.225),(52.285,38.395),(52.455,38.395),(52.455,38.225),(52.285,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.565),(52.285,38.735),(52.455,38.735),(52.455,38.565),(52.285,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.725),(56.745,29.895),(56.915,29.895),(56.915,29.725),(56.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.285),(32.745,7.455),(32.915,7.455),(32.915,7.285),(32.745,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.705),(47.145,28.875),(47.315,28.875),(47.315,28.705),(47.145,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,2.865),(52.285,3.035),(52.455,3.035),(52.455,2.865),(52.285,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,40.605),(52.285,40.775),(52.455,40.775),(52.455,40.605),(52.285,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,40.265),(52.285,40.435),(52.455,40.435),(52.455,40.265),(52.285,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.125),(33.085,33.295),(33.255,33.295),(33.255,33.125),(33.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.465),(33.085,33.635),(33.255,33.635),(33.255,33.465),(33.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,33.805),(33.085,33.975),(33.255,33.975),(33.255,33.805),(33.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.705),(47.485,28.875),(47.655,28.875),(47.655,28.705),(47.485,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.265),(33.085,6.435),(33.255,6.435),(33.255,6.265),(33.085,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.605),(33.085,6.775),(33.255,6.775),(33.255,6.605),(33.085,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,40.265),(42.345,40.435),(42.515,40.435),(42.515,40.265),(42.345,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,40.265),(42.685,40.435),(42.855,40.435),(42.855,40.265),(42.685,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,40.605),(42.345,40.775),(42.515,40.775),(42.515,40.605),(42.345,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,40.605),(42.685,40.775),(42.855,40.775),(42.855,40.605),(42.685,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.165),(42.345,18.335),(42.515,18.335),(42.515,18.165),(42.345,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.165),(42.685,18.335),(42.855,18.335),(42.855,18.165),(42.685,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.505),(42.345,18.675),(42.515,18.675),(42.515,18.505),(42.345,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.505),(42.685,18.675),(42.855,18.675),(42.855,18.505),(42.685,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.545),(52.285,37.715),(52.455,37.715),(52.455,37.545),(52.285,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.205),(51.945,37.375),(52.115,37.375),(52.115,37.205),(51.945,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.545),(51.945,37.715),(52.115,37.715),(52.115,37.545),(51.945,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.925),(47.145,40.095),(47.315,40.095),(47.315,39.925),(47.145,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.805),(56.745,16.975),(56.915,16.975),(56.915,16.805),(56.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.925),(47.485,40.095),(47.655,40.095),(47.655,39.925),(47.485,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.125),(56.745,16.295),(56.915,16.295),(56.915,16.125),(56.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,16.465),(56.745,16.635),(56.915,16.635),(56.915,16.465),(56.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.765),(56.745,31.935),(56.915,31.935),(56.915,31.765),(56.745,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.085),(56.745,31.255),(56.915,31.255),(56.915,31.085),(56.745,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,31.425),(56.745,31.595),(56.915,31.595),(56.915,31.425),(56.745,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.225),(51.945,4.395),(52.115,4.395),(52.115,4.225),(51.945,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,4.565),(51.945,4.735),(52.115,4.735),(52.115,4.565),(51.945,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.785),(33.085,15.955),(33.255,15.955),(33.255,15.785),(33.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.105),(33.085,15.275),(33.255,15.275),(33.255,15.105),(33.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.165),(56.745,35.335),(56.915,35.335),(56.915,35.165),(56.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,35.505),(56.745,35.675),(56.915,35.675),(56.915,35.505),(56.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.925),(42.345,6.095),(42.515,6.095),(42.515,5.925),(42.345,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.925),(42.685,6.095),(42.855,6.095),(42.855,5.925),(42.685,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.185),(56.745,36.355),(56.915,36.355),(56.915,36.185),(56.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.525),(56.745,36.695),(56.915,36.695),(56.915,36.525),(56.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,15.445),(33.085,15.615),(33.255,15.615),(33.255,15.445),(33.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.645),(52.285,25.815),(52.455,25.815),(52.455,25.645),(52.285,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,26.665),(32.745,26.835),(32.915,26.835),(32.915,26.665),(32.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.685),(52.285,10.855),(52.455,10.855),(52.455,10.685),(52.285,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.345),(52.285,10.515),(52.455,10.515),(52.455,10.345),(52.285,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,10.005),(52.285,10.175),(52.455,10.175),(52.455,10.005),(52.285,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.425),(47.145,31.595),(47.315,31.595),(47.315,31.425),(47.145,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.665),(47.485,9.835),(47.655,9.835),(47.655,9.665),(47.485,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.045),(56.745,12.215),(56.915,12.215),(56.915,12.045),(56.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.385),(56.745,12.555),(56.915,12.555),(56.915,12.385),(56.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.305),(32.745,8.475),(32.915,8.475),(32.915,8.305),(32.745,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.645),(32.745,8.815),(32.915,8.815),(32.915,8.645),(32.745,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,12.725),(56.745,12.895),(56.915,12.895),(56.915,12.725),(56.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.185),(33.085,36.355),(33.255,36.355),(33.255,36.185),(33.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.525),(33.085,36.695),(33.255,36.695),(33.255,36.525),(33.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.245),(56.745,22.415),(56.915,22.415),(56.915,22.245),(56.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.965),(42.685,8.135),(42.855,8.135),(42.855,7.965),(42.685,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.965),(42.345,8.135),(42.515,8.135),(42.515,7.965),(42.345,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.585),(56.745,22.755),(56.915,22.755),(56.915,22.585),(56.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.285),(47.485,7.455),(47.655,7.455),(47.655,7.285),(47.485,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,38.905),(32.745,39.075),(32.915,39.075),(32.915,38.905),(32.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,23.945),(42.685,24.115),(42.855,24.115),(42.855,23.945),(42.685,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.125),(42.685,33.295),(42.855,33.295),(42.855,33.125),(42.685,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.805),(42.685,33.975),(42.855,33.975),(42.855,33.805),(42.685,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.625),(32.745,7.795),(32.915,7.795),(32.915,7.625),(32.745,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.085),(42.345,31.255),(42.515,31.255),(42.515,31.085),(42.345,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.085),(42.685,31.255),(42.855,31.255),(42.855,31.085),(42.685,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.425),(42.345,31.595),(42.515,31.595),(42.515,31.425),(42.345,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.425),(42.685,31.595),(42.855,31.595),(42.855,31.425),(42.685,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.845),(37.885,19.015),(38.055,19.015),(38.055,18.845),(37.885,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.225),(33.085,21.395),(33.255,21.395),(33.255,21.225),(33.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,31.765),(42.345,31.935),(42.515,31.935),(42.515,31.765),(42.345,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.005),(37.885,27.175),(38.055,27.175),(38.055,27.005),(37.885,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.345),(37.885,27.515),(38.055,27.515),(38.055,27.345),(37.885,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,27.685),(37.885,27.855),(38.055,27.855),(38.055,27.685),(37.885,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.565),(52.285,4.735),(52.455,4.735),(52.455,4.565),(52.285,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,21.565),(33.085,21.735),(33.255,21.735),(33.255,21.565),(33.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,20.885),(37.545,21.055),(37.715,21.055),(37.715,20.885),(37.545,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.125),(47.145,16.295),(47.315,16.295),(47.315,16.125),(47.145,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.125),(47.485,16.295),(47.655,16.295),(47.655,16.125),(47.485,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.465),(47.145,16.635),(47.315,16.635),(47.315,16.465),(47.145,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.005),(51.945,10.175),(52.115,10.175),(52.115,10.005),(51.945,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.345),(51.945,10.515),(52.115,10.515),(52.115,10.345),(51.945,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,16.805),(47.145,16.975),(47.315,16.975),(47.315,16.805),(47.145,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.805),(47.485,16.975),(47.655,16.975),(47.655,16.805),(47.485,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,16.465),(47.485,16.635),(47.655,16.635),(47.655,16.465),(47.485,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,10.685),(51.945,10.855),(52.115,10.855),(52.115,10.685),(51.945,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.285),(32.745,24.455),(32.915,24.455),(32.915,24.285),(32.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.625),(32.745,24.795),(32.915,24.795),(32.915,24.625),(32.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.285),(33.085,24.455),(33.255,24.455),(33.255,24.285),(33.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.625),(33.085,24.795),(33.255,24.795),(33.255,24.625),(33.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.065),(42.345,13.235),(42.515,13.235),(42.515,13.065),(42.345,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.065),(42.685,13.235),(42.855,13.235),(42.855,13.065),(42.685,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.405),(42.345,13.575),(42.515,13.575),(42.515,13.405),(42.345,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.405),(42.685,13.575),(42.855,13.575),(42.855,13.405),(42.685,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,13.745),(42.345,13.915),(42.515,13.915),(42.515,13.745),(42.345,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,13.745),(42.685,13.915),(42.855,13.915),(42.855,13.745),(42.685,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,7.625),(42.345,7.795),(42.515,7.795),(42.515,7.625),(42.345,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.965),(47.145,8.135),(47.315,8.135),(47.315,7.965),(47.145,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.965),(47.485,8.135),(47.655,8.135),(47.655,7.965),(47.485,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.885),(52.285,4.055),(52.455,4.055),(52.455,3.885),(52.285,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.285),(51.945,7.455),(52.115,7.455),(52.115,7.285),(51.945,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.625),(51.945,7.795),(52.115,7.795),(52.115,7.625),(51.945,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.325),(32.745,9.495),(32.915,9.495),(32.915,9.325),(32.745,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,39.925),(32.745,40.095),(32.915,40.095),(32.915,39.925),(32.745,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.085),(37.885,31.255),(38.055,31.255),(38.055,31.085),(37.885,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.425),(37.885,31.595),(38.055,31.595),(38.055,31.425),(37.885,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,31.765),(37.885,31.935),(38.055,31.935),(38.055,31.765),(37.885,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,9.665),(32.745,9.835),(32.915,9.835),(32.915,9.665),(32.745,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,20.885),(56.745,21.055),(56.915,21.055),(56.915,20.885),(56.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,38.905),(33.085,39.075),(33.255,39.075),(33.255,38.905),(33.085,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.025),(47.145,11.195),(47.315,11.195),(47.315,11.025),(47.145,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.025),(47.485,11.195),(47.655,11.195),(47.655,11.025),(47.485,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.885),(37.885,21.055),(38.055,21.055),(38.055,20.885),(37.885,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.365),(47.145,11.535),(47.315,11.535),(47.315,11.365),(47.145,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.365),(47.485,11.535),(47.655,11.535),(47.655,11.365),(47.485,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.285),(37.885,24.455),(38.055,24.455),(38.055,24.285),(37.885,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.925),(51.945,23.095),(52.115,23.095),(52.115,22.925),(51.945,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.985),(51.945,9.155),(52.115,9.155),(52.115,8.985),(51.945,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,24.625),(37.885,24.795),(38.055,24.795),(38.055,24.625),(37.885,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.905),(42.345,39.075),(42.515,39.075),(42.515,38.905),(42.345,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.905),(42.685,39.075),(42.855,39.075),(42.855,38.905),(42.685,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.705),(37.885,11.875),(38.055,11.875),(38.055,11.705),(37.885,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.125),(57.085,16.295),(57.255,16.295),(57.255,16.125),(57.085,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,3.885),(57.085,4.055),(57.255,4.055),(57.255,3.885),(57.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.465),(57.085,16.635),(57.255,16.635),(57.255,16.465),(57.085,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.225),(52.285,4.395),(52.455,4.395),(52.455,4.225),(52.285,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,4.905),(37.545,5.075),(37.715,5.075),(37.715,4.905),(37.545,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.545),(47.485,3.715),(47.655,3.715),(47.655,3.545),(47.485,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.205),(47.485,3.375),(47.655,3.375),(47.655,3.205),(47.485,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.065),(56.745,13.235),(56.915,13.235),(56.915,13.065),(56.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.405),(56.745,13.575),(56.915,13.575),(56.915,13.405),(56.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,13.745),(56.745,13.915),(56.915,13.915),(56.915,13.745),(56.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.065),(37.885,13.235),(38.055,13.235),(38.055,13.065),(37.885,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.405),(37.885,13.575),(38.055,13.575),(38.055,13.405),(37.885,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,6.945),(56.745,7.115),(56.915,7.115),(56.915,6.945),(56.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,3.885),(33.085,4.055),(33.255,4.055),(33.255,3.885),(33.085,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,13.745),(37.885,13.915),(38.055,13.915),(38.055,13.745),(37.885,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.265),(56.745,23.435),(56.915,23.435),(56.915,23.265),(56.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.605),(56.745,23.775),(56.915,23.775),(56.915,23.605),(56.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,5.925),(52.285,6.095),(52.455,6.095),(52.455,5.925),(52.285,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.245),(57.085,22.415),(57.255,22.415),(57.255,22.245),(57.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.585),(57.085,22.755),(57.255,22.755),(57.255,22.585),(57.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,6.945),(32.745,7.115),(32.915,7.115),(32.915,6.945),(32.745,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,8.985),(42.345,9.155),(42.515,9.155),(42.515,8.985),(42.345,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.245),(42.345,22.415),(42.515,22.415),(42.515,22.245),(42.345,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.245),(42.685,22.415),(42.855,22.415),(42.855,22.245),(42.685,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.585),(42.345,22.755),(42.515,22.755),(42.515,22.585),(42.345,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.185),(51.945,36.355),(52.115,36.355),(52.115,36.185),(51.945,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,36.525),(51.945,36.695),(52.115,36.695),(52.115,36.525),(51.945,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.585),(42.685,22.755),(42.855,22.755),(42.855,22.585),(42.685,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,18.845),(52.285,19.015),(52.455,19.015),(52.455,18.845),(52.285,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,8.985),(42.685,9.155),(42.855,9.155),(42.855,8.985),(42.685,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.245),(47.145,22.415),(47.315,22.415),(47.315,22.245),(47.145,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.585),(47.485,22.755),(47.655,22.755),(47.655,22.585),(47.485,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.245),(47.485,22.415),(47.655,22.415),(47.655,22.245),(47.485,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.585),(47.145,22.755),(47.315,22.755),(47.315,22.585),(47.145,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,5.925),(51.945,6.095),(52.115,6.095),(52.115,5.925),(51.945,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.645),(37.885,8.815),(38.055,8.815),(38.055,8.645),(37.885,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,8.305),(37.885,8.475),(38.055,8.475),(38.055,8.305),(37.885,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.845),(52.285,36.015),(52.455,36.015),(52.455,35.845),(52.285,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.725),(37.545,12.895),(37.715,12.895),(37.715,12.725),(37.545,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.045),(37.545,12.215),(37.715,12.215),(37.715,12.045),(37.545,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,12.385),(37.545,12.555),(37.715,12.555),(37.715,12.385),(37.545,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.645),(37.885,25.815),(38.055,25.815),(38.055,25.645),(37.885,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,25.985),(51.945,26.155),(52.115,26.155),(52.115,25.985),(51.945,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.685),(32.745,10.855),(32.915,10.855),(32.915,10.685),(32.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.225),(57.085,4.395),(57.255,4.395),(57.255,4.225),(57.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.205),(51.945,20.375),(52.115,20.375),(52.115,20.205),(51.945,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,20.545),(51.945,20.715),(52.115,20.715),(52.115,20.545),(51.945,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.565),(57.085,4.735),(57.255,4.735),(57.255,4.565),(57.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.125),(56.745,33.295),(56.915,33.295),(56.915,33.125),(56.745,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.005),(37.885,10.175),(38.055,10.175),(38.055,10.005),(37.885,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.345),(37.885,10.515),(38.055,10.515),(38.055,10.345),(37.885,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,10.685),(37.885,10.855),(38.055,10.855),(38.055,10.685),(37.885,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,33.465),(56.745,33.635),(56.915,33.635),(56.915,33.465),(56.745,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,19.865),(33.085,20.035),(33.255,20.035),(33.255,19.865),(33.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.685),(33.085,27.855),(33.255,27.855),(33.255,27.685),(33.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.005),(33.085,27.175),(33.255,27.175),(33.255,27.005),(33.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,27.345),(33.085,27.515),(33.255,27.515),(33.255,27.345),(33.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.525),(51.945,19.695),(52.115,19.695),(52.115,19.525),(51.945,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.225),(33.085,4.395),(33.255,4.395),(33.255,4.225),(33.085,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.565),(33.085,4.735),(33.255,4.735),(33.255,4.565),(33.085,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.925),(37.885,23.095),(38.055,23.095),(38.055,22.925),(37.885,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.805),(37.885,33.975),(38.055,33.975),(38.055,33.805),(37.885,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.125),(37.885,33.295),(38.055,33.295),(38.055,33.125),(37.885,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,33.465),(37.885,33.635),(38.055,33.635),(38.055,33.465),(37.885,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.745),(37.885,30.915),(38.055,30.915),(38.055,30.745),(37.885,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.265),(42.345,6.435),(42.515,6.435),(42.515,6.265),(42.345,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.845),(32.745,36.015),(32.915,36.015),(32.915,35.845),(32.745,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.265),(42.685,6.435),(42.855,6.435),(42.855,6.265),(42.685,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.605),(42.345,6.775),(42.515,6.775),(42.515,6.605),(42.345,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.165),(56.745,18.335),(56.915,18.335),(56.915,18.165),(56.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.505),(56.745,18.675),(56.915,18.675),(56.915,18.505),(56.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.605),(42.685,6.775),(42.855,6.775),(42.855,6.605),(42.685,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.065),(37.885,30.235),(38.055,30.235),(38.055,30.065),(37.885,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.585),(57.085,39.755),(57.255,39.755),(57.255,39.585),(57.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,24.965),(47.485,25.135),(47.655,25.135),(47.655,24.965),(47.485,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,24.965),(47.145,25.135),(47.315,25.135),(47.315,24.965),(47.145,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.265),(51.945,6.435),(52.115,6.435),(52.115,6.265),(51.945,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,6.605),(51.945,6.775),(52.115,6.775),(52.115,6.605),(51.945,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.025),(56.745,28.195),(56.915,28.195),(56.915,28.025),(56.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.365),(56.745,28.535),(56.915,28.535),(56.915,28.365),(56.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.165),(57.085,35.335),(57.255,35.335),(57.255,35.165),(57.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.505),(57.085,35.675),(57.255,35.675),(57.255,35.505),(57.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,28.705),(56.745,28.875),(56.915,28.875),(56.915,28.705),(56.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.025),(57.085,28.195),(57.255,28.195),(57.255,28.025),(57.085,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.365),(57.085,28.535),(57.255,28.535),(57.255,28.365),(57.085,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,28.705),(57.085,28.875),(57.255,28.875),(57.255,28.705),(57.085,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.225),(56.745,38.395),(56.915,38.395),(56.915,38.225),(56.745,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.565),(56.745,38.735),(56.915,38.735),(56.915,38.565),(56.745,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.065),(47.485,30.235),(47.655,30.235),(47.655,30.065),(47.485,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.185),(52.285,36.355),(52.455,36.355),(52.455,36.185),(52.285,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.525),(52.285,36.695),(52.455,36.695),(52.455,36.525),(52.285,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.805),(37.545,16.975),(37.715,16.975),(37.715,16.805),(37.545,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.125),(37.545,16.295),(37.715,16.295),(37.715,16.125),(37.545,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,16.465),(37.545,16.635),(37.715,16.635),(37.715,16.465),(37.545,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.165),(33.085,35.335),(33.255,35.335),(33.255,35.165),(33.085,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.505),(33.085,35.675),(33.255,35.675),(33.255,35.505),(33.085,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.805),(47.485,33.975),(47.655,33.975),(47.655,33.805),(47.485,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.125),(47.485,33.295),(47.655,33.295),(47.655,33.125),(47.485,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.105),(52.285,15.275),(52.455,15.275),(52.455,15.105),(52.285,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.445),(52.285,15.615),(52.455,15.615),(52.455,15.445),(52.285,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,15.785),(52.285,15.955),(52.455,15.955),(52.455,15.785),(52.285,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.045),(37.885,12.215),(38.055,12.215),(38.055,12.045),(37.885,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.385),(37.885,12.555),(38.055,12.555),(38.055,12.385),(37.885,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.465),(47.145,33.635),(47.315,33.635),(47.315,33.465),(47.145,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,12.725),(37.885,12.895),(38.055,12.895),(38.055,12.725),(37.885,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,33.465),(47.485,33.635),(47.655,33.635),(47.655,33.465),(47.485,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,7.965),(56.745,8.135),(56.915,8.135),(56.915,7.965),(56.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,6.945),(57.085,7.115),(57.255,7.115),(57.255,6.945),(57.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,38.905),(52.285,39.075),(52.455,39.075),(52.455,38.905),(52.285,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,40.265),(37.545,40.435),(37.715,40.435),(37.715,40.265),(37.545,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.825),(42.685,17.995),(42.855,17.995),(42.855,17.825),(42.685,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.825),(57.085,17.995),(57.255,17.995),(57.255,17.825),(57.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.905),(47.145,22.075),(47.315,22.075),(47.315,21.905),(47.145,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.945),(37.885,7.115),(38.055,7.115),(38.055,6.945),(37.885,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.905),(47.485,22.075),(47.655,22.075),(47.655,21.905),(47.485,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.145),(57.085,17.315),(57.255,17.315),(57.255,17.145),(57.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.485),(37.885,17.655),(38.055,17.655),(38.055,17.485),(37.885,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.145),(37.885,17.315),(38.055,17.315),(38.055,17.145),(37.885,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.085),(33.085,14.255),(33.255,14.255),(33.255,14.085),(33.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,17.825),(37.885,17.995),(38.055,17.995),(38.055,17.825),(37.885,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,17.485),(57.085,17.655),(57.255,17.655),(57.255,17.485),(57.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.765),(33.085,14.935),(33.255,14.935),(33.255,14.765),(33.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,7.965),(32.745,8.135),(32.915,8.135),(32.915,7.965),(32.745,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,6.945),(33.085,7.115),(33.255,7.115),(33.255,6.945),(33.085,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,26.325),(51.945,26.495),(52.115,26.495),(52.115,26.325),(51.945,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.125),(52.285,16.295),(52.455,16.295),(52.455,16.125),(52.285,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.465),(52.285,16.635),(52.455,16.635),(52.455,16.465),(52.285,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,16.805),(52.285,16.975),(52.455,16.975),(52.455,16.805),(52.285,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,18.845),(42.345,19.015),(42.515,19.015),(42.515,18.845),(42.345,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,18.845),(42.685,19.015),(42.855,19.015),(42.855,18.845),(42.685,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,26.665),(51.945,26.835),(52.115,26.835),(52.115,26.665),(51.945,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,37.885),(51.945,38.055),(52.115,38.055),(52.115,37.885),(51.945,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.925),(42.685,40.095),(42.855,40.095),(42.855,39.925),(42.685,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.825),(42.685,34.995),(42.855,34.995),(42.855,34.825),(42.685,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.825),(42.345,34.995),(42.515,34.995),(42.515,34.825),(42.345,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.145),(42.345,34.315),(42.515,34.315),(42.515,34.145),(42.345,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.145),(42.685,34.315),(42.855,34.315),(42.855,34.145),(42.685,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.165),(42.685,35.335),(42.855,35.335),(42.855,35.165),(42.685,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.165),(42.345,35.335),(42.515,35.335),(42.515,35.165),(42.345,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.505),(42.345,35.675),(42.515,35.675),(42.515,35.505),(42.345,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,34.485),(42.345,34.655),(42.515,34.655),(42.515,34.485),(42.345,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,34.485),(42.685,34.655),(42.855,34.655),(42.855,34.485),(42.685,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.865),(52.285,20.035),(52.455,20.035),(52.455,19.865),(52.285,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.505),(42.685,35.675),(42.855,35.675),(42.855,35.505),(42.685,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.385),(57.085,29.555),(57.255,29.555),(57.255,29.385),(57.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.345),(33.085,10.515),(33.255,10.515),(33.255,10.345),(33.085,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.265),(51.945,23.435),(52.115,23.435),(52.115,23.265),(51.945,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.605),(51.945,23.775),(52.115,23.775),(52.115,23.605),(51.945,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,36.865),(56.745,37.035),(56.915,37.035),(56.915,36.865),(56.745,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.245),(47.485,39.415),(47.655,39.415),(47.655,39.245),(47.485,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,39.585),(47.485,39.755),(47.655,39.755),(47.655,39.585),(47.485,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.245),(47.145,39.415),(47.315,39.415),(47.315,39.245),(47.145,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,39.585),(47.145,39.755),(47.315,39.755),(47.315,39.585),(47.145,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.565),(37.885,21.735),(38.055,21.735),(38.055,21.565),(37.885,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.225),(37.885,21.395),(38.055,21.395),(38.055,21.225),(37.885,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.965),(51.945,25.135),(52.115,25.135),(52.115,24.965),(51.945,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.205),(52.285,20.375),(52.455,20.375),(52.455,20.205),(52.285,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.545),(52.285,20.715),(52.455,20.715),(52.455,20.545),(52.285,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.285),(42.685,7.455),(42.855,7.455),(42.855,7.285),(42.685,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.205),(32.745,20.375),(32.915,20.375),(32.915,20.205),(32.745,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.545),(32.745,20.715),(32.915,20.715),(32.915,20.545),(32.745,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,8.985),(32.745,9.155),(32.915,9.155),(32.915,8.985),(32.745,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.045),(56.745,29.215),(56.915,29.215),(56.915,29.045),(56.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,36.865),(33.085,37.035),(33.255,37.035),(33.255,36.865),(33.085,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.165),(57.085,18.335),(57.255,18.335),(57.255,18.165),(57.085,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,22.925),(56.745,23.095),(56.915,23.095),(56.915,22.925),(56.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.505),(57.085,18.675),(57.255,18.675),(57.255,18.505),(57.085,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,29.385),(56.745,29.555),(56.915,29.555),(56.915,29.385),(56.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.065),(57.085,13.235),(57.255,13.235),(57.255,13.065),(57.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.405),(57.085,13.575),(57.255,13.575),(57.255,13.405),(57.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.125),(52.285,33.295),(52.455,33.295),(52.455,33.125),(52.285,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,33.465),(52.285,33.635),(52.455,33.635),(52.455,33.465),(52.285,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,13.745),(57.085,13.915),(57.255,13.915),(57.255,13.745),(57.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.045),(51.945,12.215),(52.115,12.215),(52.115,12.045),(51.945,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.385),(51.945,12.555),(52.115,12.555),(52.115,12.385),(51.945,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,40.265),(47.145,40.435),(47.315,40.435),(47.315,40.265),(47.145,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.185),(37.545,19.355),(37.715,19.355),(37.715,19.185),(37.545,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.525),(37.545,19.695),(37.715,19.695),(37.715,19.525),(37.545,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,40.265),(47.485,40.435),(47.655,40.435),(47.655,40.265),(47.485,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,40.605),(47.485,40.775),(47.655,40.775),(47.655,40.605),(47.485,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,12.725),(51.945,12.895),(52.115,12.895),(52.115,12.725),(51.945,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,40.605),(47.145,40.775),(47.315,40.775),(47.315,40.605),(47.145,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.265),(52.285,6.435),(52.455,6.435),(52.455,6.265),(52.285,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.605),(52.285,6.775),(52.455,6.775),(52.455,6.605),(52.285,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,25.305),(37.885,25.475),(38.055,25.475),(38.055,25.305),(37.885,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.305),(52.285,8.475),(52.455,8.475),(52.455,8.305),(52.285,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.645),(52.285,8.815),(52.455,8.815),(52.455,8.645),(52.285,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.165),(37.885,18.335),(38.055,18.335),(38.055,18.165),(37.885,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.145),(52.285,17.315),(52.455,17.315),(52.455,17.145),(52.285,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,18.505),(37.885,18.675),(38.055,18.675),(38.055,18.505),(37.885,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.825),(52.285,17.995),(52.455,17.995),(52.455,17.825),(52.285,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,17.485),(52.285,17.655),(52.455,17.655),(52.455,17.485),(52.285,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.885),(56.745,4.055),(56.915,4.055),(56.915,3.885),(56.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.005),(56.745,10.175),(56.915,10.175),(56.915,10.005),(56.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.345),(56.745,10.515),(56.915,10.515),(56.915,10.345),(56.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,10.685),(56.745,10.855),(56.915,10.855),(56.915,10.685),(56.745,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.865),(47.485,37.035),(47.655,37.035),(47.655,36.865),(47.485,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.185),(42.345,36.355),(42.515,36.355),(42.515,36.185),(42.345,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.185),(42.685,36.355),(42.855,36.355),(42.855,36.185),(42.685,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.525),(42.345,36.695),(42.515,36.695),(42.515,36.525),(42.345,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.525),(42.685,36.695),(42.855,36.695),(42.855,36.525),(42.685,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.765),(57.085,14.935),(57.255,14.935),(57.255,14.765),(57.085,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.685),(33.085,10.855),(33.255,10.855),(33.255,10.685),(33.085,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.085),(57.085,14.255),(57.255,14.255),(57.255,14.085),(57.085,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.985),(57.085,26.155),(57.255,26.155),(57.255,25.985),(57.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,14.425),(57.085,14.595),(57.255,14.595),(57.255,14.425),(57.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.885),(32.745,4.055),(32.915,4.055),(32.915,3.885),(32.745,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.205),(57.085,20.375),(57.255,20.375),(57.255,20.205),(57.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.545),(57.085,20.715),(57.255,20.715),(57.255,20.545),(57.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,24.965),(32.745,25.135),(32.915,25.135),(32.915,24.965),(32.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,7.965),(51.945,8.135),(52.115,8.135),(52.115,7.965),(51.945,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,24.965),(33.085,25.135),(33.255,25.135),(33.255,24.965),(33.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.225),(51.945,38.395),(52.115,38.395),(52.115,38.225),(51.945,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.565),(51.945,38.735),(52.115,38.735),(52.115,38.565),(51.945,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.165),(51.945,35.335),(52.115,35.335),(52.115,35.165),(51.945,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.205),(52.285,3.375),(52.455,3.375),(52.455,3.205),(52.285,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,3.545),(52.285,3.715),(52.455,3.715),(52.455,3.545),(52.285,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.505),(51.945,35.675),(52.115,35.675),(52.115,35.505),(51.945,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.825),(51.945,34.995),(52.115,34.995),(52.115,34.825),(51.945,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,12.045),(47.485,12.215),(47.655,12.215),(47.655,12.045),(47.485,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.145),(51.945,34.315),(52.115,34.315),(52.115,34.145),(51.945,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,34.485),(51.945,34.655),(52.115,34.655),(52.115,34.485),(51.945,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.265),(37.885,23.435),(38.055,23.435),(38.055,23.265),(37.885,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.605),(37.885,23.775),(38.055,23.775),(38.055,23.605),(37.885,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.285),(56.745,24.455),(56.915,24.455),(56.915,24.285),(56.745,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.625),(56.745,24.795),(56.915,24.795),(56.915,24.625),(56.745,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.325),(37.545,9.495),(37.715,9.495),(37.715,9.325),(37.545,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,9.665),(37.545,9.835),(37.715,9.835),(37.715,9.665),(37.545,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.505),(51.945,18.675),(52.115,18.675),(52.115,18.505),(51.945,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.305),(42.345,25.475),(42.515,25.475),(42.515,25.305),(42.345,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,7.625),(47.485,7.795),(47.655,7.795),(47.655,7.625),(47.485,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.205),(37.885,20.375),(38.055,20.375),(38.055,20.205),(37.885,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.445),(47.485,15.615),(47.655,15.615),(47.655,15.445),(47.485,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,20.545),(37.885,20.715),(38.055,20.715),(38.055,20.545),(37.885,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.285),(47.145,7.455),(47.315,7.455),(47.315,7.285),(47.145,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,4.905),(52.285,5.075),(52.455,5.075),(52.455,4.905),(52.285,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,7.625),(47.145,7.795),(47.315,7.795),(47.315,7.625),(47.145,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.305),(51.945,8.475),(52.115,8.475),(52.115,8.305),(51.945,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,8.645),(51.945,8.815),(52.115,8.815),(52.115,8.645),(51.945,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.245),(51.945,22.415),(52.115,22.415),(52.115,22.245),(51.945,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.045),(57.085,12.215),(57.255,12.215),(57.255,12.045),(57.085,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,22.585),(51.945,22.755),(52.115,22.755),(52.115,22.585),(51.945,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.905),(37.545,22.075),(37.715,22.075),(37.715,21.905),(37.545,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.725),(57.085,12.895),(57.255,12.895),(57.255,12.725),(57.085,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.705),(51.945,28.875),(52.115,28.875),(52.115,28.705),(51.945,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.725),(37.545,29.895),(37.715,29.895),(37.715,29.725),(37.545,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.045),(37.545,29.215),(37.715,29.215),(37.715,29.045),(37.545,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.565),(32.745,21.735),(32.915,21.735),(32.915,21.565),(32.745,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,29.385),(37.545,29.555),(37.715,29.555),(37.715,29.385),(37.545,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,26.325),(33.085,26.495),(33.255,26.495),(33.255,26.325),(33.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,26.665),(33.085,26.835),(33.255,26.835),(33.255,26.665),(33.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.225),(32.745,21.395),(32.915,21.395),(32.915,21.225),(32.745,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.245),(37.545,39.415),(37.715,39.415),(37.715,39.245),(37.545,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.585),(37.545,39.755),(37.715,39.755),(37.715,39.585),(37.545,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.765),(52.285,31.935),(52.455,31.935),(52.455,31.765),(52.285,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.085),(52.285,31.255),(52.455,31.255),(52.455,31.085),(52.285,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,31.425),(52.285,31.595),(52.455,31.595),(52.455,31.425),(52.285,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.785),(51.945,15.955),(52.115,15.955),(52.115,15.785),(51.945,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.105),(51.945,15.275),(52.115,15.275),(52.115,15.105),(51.945,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,23.945),(56.745,24.115),(56.915,24.115),(56.915,23.945),(56.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,22.925),(57.085,23.095),(57.255,23.095),(57.255,22.925),(57.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,15.445),(51.945,15.615),(52.115,15.615),(52.115,15.445),(51.945,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.285),(37.885,7.455),(38.055,7.455),(38.055,7.285),(37.885,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.625),(37.885,7.795),(38.055,7.795),(38.055,7.625),(37.885,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.465),(57.085,33.635),(57.255,33.635),(57.255,33.465),(57.085,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.805),(57.085,33.975),(57.255,33.975),(57.255,33.805),(57.085,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.005),(32.745,27.175),(32.915,27.175),(32.915,27.005),(32.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.345),(32.745,27.515),(32.915,27.515),(32.915,27.345),(32.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,22.925),(42.345,23.095),(42.515,23.095),(42.515,22.925),(42.345,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,22.925),(42.685,23.095),(42.855,23.095),(42.855,22.925),(42.685,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,27.685),(32.745,27.855),(32.915,27.855),(32.915,27.685),(32.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.985),(52.285,26.155),(52.455,26.155),(52.455,25.985),(52.285,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.885),(32.745,38.055),(32.915,38.055),(32.915,37.885),(32.745,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,33.125),(57.085,33.295),(57.255,33.295),(57.255,33.125),(57.085,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,22.925),(47.145,23.095),(47.315,23.095),(47.315,22.925),(47.145,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,22.925),(47.485,23.095),(47.655,23.095),(47.655,22.925),(47.485,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,40.265),(37.885,40.435),(38.055,40.435),(38.055,40.265),(37.885,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,40.605),(37.885,40.775),(38.055,40.775),(38.055,40.605),(37.885,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.745),(47.485,13.915),(47.655,13.915),(47.655,13.745),(47.485,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.925),(37.545,6.095),(37.715,6.095),(37.715,5.925),(37.545,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.365),(37.885,11.535),(38.055,11.535),(38.055,11.365),(37.885,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.325),(57.085,9.495),(57.255,9.495),(57.255,9.325),(57.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,9.665),(57.085,9.835),(57.255,9.835),(57.255,9.665),(57.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,4.905),(57.085,5.075),(57.255,5.075),(57.255,4.905),(57.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.925),(42.345,40.095),(42.515,40.095),(42.515,39.925),(42.345,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.925),(33.085,40.095),(33.255,40.095),(33.255,39.925),(33.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.045),(32.745,12.215),(32.915,12.215),(32.915,12.045),(32.745,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.385),(32.745,12.555),(32.915,12.555),(32.915,12.385),(32.745,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,12.725),(32.745,12.895),(32.915,12.895),(32.915,12.725),(32.745,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,39.925),(51.945,40.095),(52.115,40.095),(52.115,39.925),(51.945,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.225),(47.145,21.395),(47.315,21.395),(47.315,21.225),(47.145,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,4.905),(33.085,5.075),(33.255,5.075),(33.255,4.905),(33.085,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.245),(37.885,22.415),(38.055,22.415),(38.055,22.245),(37.885,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.745),(42.345,30.915),(42.515,30.915),(42.515,30.745),(42.345,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.745),(42.685,30.915),(42.855,30.915),(42.855,30.745),(42.685,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,40.265),(33.085,40.435),(33.255,40.435),(33.255,40.265),(33.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,40.605),(33.085,40.775),(33.255,40.775),(33.255,40.605),(33.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.825),(32.745,17.995),(32.915,17.995),(32.915,17.825),(32.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.145),(32.745,17.315),(32.915,17.315),(32.915,17.145),(32.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,17.485),(32.745,17.655),(32.915,17.655),(32.915,17.485),(32.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,6.945),(42.345,7.115),(42.515,7.115),(42.515,6.945),(42.345,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.165),(32.745,35.335),(32.915,35.335),(32.915,35.165),(32.745,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,6.945),(42.685,7.115),(42.855,7.115),(42.855,6.945),(42.685,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.325),(52.285,9.495),(52.455,9.495),(52.455,9.325),(52.285,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,35.845),(57.085,36.015),(57.255,36.015),(57.255,35.845),(57.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,18.845),(56.745,19.015),(56.915,19.015),(56.915,18.845),(56.745,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,35.505),(32.745,35.675),(32.915,35.675),(32.915,35.505),(32.745,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.025),(47.145,28.195),(47.315,28.195),(47.315,28.025),(47.145,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,9.665),(52.285,9.835),(52.455,9.835),(52.455,9.665),(52.285,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.085),(37.545,14.255),(37.715,14.255),(37.715,14.085),(37.545,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.425),(37.545,14.595),(37.715,14.595),(37.715,14.425),(37.545,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,14.765),(37.545,14.935),(37.715,14.935),(37.715,14.765),(37.545,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.465),(42.685,16.635),(42.855,16.635),(42.855,16.465),(42.685,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.125),(42.345,16.295),(42.515,16.295),(42.515,16.125),(42.345,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.125),(42.685,16.295),(42.855,16.295),(42.855,16.125),(42.685,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,35.845),(33.085,36.015),(33.255,36.015),(33.255,35.845),(33.085,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.465),(42.345,16.635),(42.515,16.635),(42.515,16.465),(42.345,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,16.805),(42.345,16.975),(42.515,16.975),(42.515,16.805),(42.345,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,16.805),(42.685,16.975),(42.855,16.975),(42.855,16.805),(42.685,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,36.865),(52.285,37.035),(52.455,37.035),(52.455,36.865),(52.285,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,38.905),(56.745,39.075),(56.915,39.075),(56.915,38.905),(56.745,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.465),(51.945,33.635),(52.115,33.635),(52.115,33.465),(51.945,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.185),(47.145,36.355),(47.315,36.355),(47.315,36.185),(47.145,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.185),(47.485,36.355),(47.655,36.355),(47.655,36.185),(47.485,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,36.525),(47.145,36.695),(47.315,36.695),(47.315,36.525),(47.145,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,36.525),(47.485,36.695),(47.655,36.695),(47.655,36.525),(47.485,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,7.625),(42.685,7.795),(42.855,7.795),(42.855,7.625),(42.685,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.825),(37.545,34.995),(37.715,34.995),(37.715,34.825),(37.545,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.145),(37.545,34.315),(37.715,34.315),(37.715,34.145),(37.545,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,34.485),(37.545,34.655),(37.715,34.655),(37.715,34.485),(37.545,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,10.005),(57.085,10.175),(57.255,10.175),(57.255,10.005),(57.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.285),(37.545,7.455),(37.715,7.455),(37.715,7.285),(37.545,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,7.625),(37.545,7.795),(37.715,7.795),(37.715,7.625),(37.545,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,40.265),(57.085,40.435),(57.255,40.435),(57.255,40.265),(57.085,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,40.605),(57.085,40.775),(57.255,40.775),(57.255,40.605),(57.085,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.245),(32.745,22.415),(32.915,22.415),(32.915,22.245),(32.745,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.005),(42.345,27.175),(42.515,27.175),(42.515,27.005),(42.345,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.005),(42.685,27.175),(42.855,27.175),(42.855,27.005),(42.685,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.345),(42.345,27.515),(42.515,27.515),(42.515,27.345),(42.345,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.345),(42.685,27.515),(42.855,27.515),(42.855,27.345),(42.685,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.585),(32.745,22.755),(32.915,22.755),(32.915,22.585),(32.745,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,27.685),(42.345,27.855),(42.515,27.855),(42.515,27.685),(42.345,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,27.685),(42.685,27.855),(42.855,27.855),(42.855,27.685),(42.685,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,21.565),(47.145,21.735),(47.315,21.735),(47.315,21.565),(47.145,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.565),(47.485,21.735),(47.655,21.735),(47.655,21.565),(47.485,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,21.225),(47.485,21.395),(47.655,21.395),(47.655,21.225),(47.485,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.865),(56.745,20.035),(56.915,20.035),(56.915,19.865),(56.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.265),(37.885,6.435),(38.055,6.435),(38.055,6.265),(37.885,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,6.605),(37.885,6.775),(38.055,6.775),(38.055,6.605),(37.885,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,26.325),(56.745,26.495),(56.915,26.495),(56.915,26.325),(56.745,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,26.665),(56.745,26.835),(56.915,26.835),(56.915,26.665),(56.745,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.865),(37.885,20.035),(38.055,20.035),(38.055,19.865),(37.885,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,16.805),(57.085,16.975),(57.255,16.975),(57.255,16.805),(57.085,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.165),(52.285,35.335),(52.455,35.335),(52.455,35.165),(52.285,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,35.505),(52.285,35.675),(52.455,35.675),(52.455,35.505),(52.285,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.065),(57.085,30.235),(57.255,30.235),(57.255,30.065),(57.085,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.405),(57.085,30.575),(57.255,30.575),(57.255,30.405),(57.085,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,30.745),(57.085,30.915),(57.255,30.915),(57.255,30.745),(57.085,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.245),(52.285,39.415),(52.455,39.415),(52.455,39.245),(52.285,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.825),(37.545,17.995),(37.715,17.995),(37.715,17.825),(37.545,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.485),(37.545,17.655),(37.715,17.655),(37.715,17.485),(37.545,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,39.585),(52.285,39.755),(52.455,39.755),(52.455,39.585),(52.285,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,17.145),(37.545,17.315),(37.715,17.315),(37.715,17.145),(37.545,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,23.945),(51.945,24.115),(52.115,24.115),(52.115,23.945),(51.945,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.225),(42.345,38.395),(42.515,38.395),(42.515,38.225),(42.345,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,38.565),(42.345,38.735),(42.515,38.735),(42.515,38.565),(42.345,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.745),(47.145,30.915),(47.315,30.915),(47.315,30.745),(47.145,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.745),(47.485,30.915),(47.655,30.915),(47.655,30.745),(47.485,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.965),(57.085,8.135),(57.255,8.135),(57.255,7.965),(57.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,30.405),(47.145,30.575),(47.315,30.575),(47.315,30.405),(47.145,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.325),(42.345,9.495),(42.515,9.495),(42.515,9.325),(42.345,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.325),(42.685,9.495),(42.855,9.495),(42.855,9.325),(42.685,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.065),(52.285,13.235),(52.455,13.235),(52.455,13.065),(52.285,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.405),(52.285,13.575),(52.455,13.575),(52.455,13.405),(52.285,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.445),(42.345,32.615),(42.515,32.615),(42.515,32.445),(42.345,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,13.745),(52.285,13.915),(52.455,13.915),(52.455,13.745),(52.285,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.785),(42.345,32.955),(42.515,32.955),(42.515,32.785),(42.345,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,35.845),(42.345,36.015),(42.515,36.015),(42.515,35.845),(42.345,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,35.845),(42.685,36.015),(42.855,36.015),(42.855,35.845),(42.685,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.185),(52.285,19.355),(52.455,19.355),(52.455,19.185),(52.285,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.065),(32.745,13.235),(32.915,13.235),(32.915,13.065),(32.745,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.405),(32.745,13.575),(32.915,13.575),(32.915,13.405),(32.745,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,13.745),(32.745,13.915),(32.915,13.915),(32.915,13.745),(32.745,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.965),(33.085,8.135),(33.255,8.135),(33.255,7.965),(33.085,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,38.905),(51.945,39.075),(52.115,39.075),(52.115,38.905),(51.945,38.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,21.905),(37.885,22.075),(38.055,22.075),(38.055,21.905),(37.885,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.705),(42.345,11.875),(42.515,11.875),(42.515,11.705),(42.345,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.705),(42.685,11.875),(42.855,11.875),(42.855,11.705),(42.685,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.025),(42.345,11.195),(42.515,11.195),(42.515,11.025),(42.345,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.025),(42.685,11.195),(42.855,11.195),(42.855,11.025),(42.685,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,11.365),(42.345,11.535),(42.515,11.535),(42.515,11.365),(42.345,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,11.365),(42.685,11.535),(42.855,11.535),(42.855,11.365),(42.685,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,40.605),(37.545,40.775),(37.715,40.775),(37.715,40.605),(37.545,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.285),(51.945,24.455),(52.115,24.455),(52.115,24.285),(51.945,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,24.625),(51.945,24.795),(52.115,24.795),(52.115,24.625),(51.945,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,5.925),(56.745,6.095),(56.915,6.095),(56.915,5.925),(56.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.825),(57.085,34.995),(57.255,34.995),(57.255,34.825),(57.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.145),(57.085,34.315),(57.255,34.315),(57.255,34.145),(57.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,34.485),(57.085,34.655),(57.255,34.655),(57.255,34.485),(57.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,20.885),(52.285,21.055),(52.455,21.055),(52.455,20.885),(52.285,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,31.085),(47.145,31.255),(47.315,31.255),(47.315,31.085),(47.145,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,20.885),(32.745,21.055),(32.915,21.055),(32.915,20.885),(32.745,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.005),(51.945,27.175),(52.115,27.175),(52.115,27.005),(51.945,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.505),(47.485,18.675),(47.655,18.675),(47.655,18.505),(47.485,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.825),(33.085,34.995),(33.255,34.995),(33.255,34.825),(33.085,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.145),(33.085,34.315),(33.255,34.315),(33.255,34.145),(33.085,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,34.485),(33.085,34.655),(33.255,34.655),(33.255,34.485),(33.085,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,5.925),(32.745,6.095),(32.915,6.095),(32.915,5.925),(32.745,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.165),(47.145,18.335),(47.315,18.335),(47.315,18.165),(47.145,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.165),(47.485,18.335),(47.655,18.335),(47.655,18.165),(47.485,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,18.845),(57.085,19.015),(57.255,19.015),(57.255,18.845),(57.085,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.505),(47.145,18.675),(47.315,18.675),(47.315,18.505),(47.145,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,19.865),(37.545,20.035),(37.715,20.035),(37.715,19.865),(37.545,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.785),(47.145,15.955),(47.315,15.955),(47.315,15.785),(47.145,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.865),(37.885,37.035),(38.055,37.035),(38.055,36.865),(37.885,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.165),(37.545,18.335),(37.715,18.335),(37.715,18.165),(37.545,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.505),(37.545,18.675),(37.715,18.675),(37.715,18.505),(37.545,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,6.945),(52.285,7.115),(52.455,7.115),(52.455,6.945),(52.285,6.945)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,8.985),(52.285,9.155),(52.455,9.155),(52.455,8.985),(52.285,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.265),(32.745,23.435),(32.915,23.435),(32.915,23.265),(32.745,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.605),(32.745,23.775),(32.915,23.775),(32.915,23.605),(32.745,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.805),(51.945,33.975),(52.115,33.975),(52.115,33.805),(51.945,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.205),(56.745,3.375),(56.915,3.375),(56.915,3.205),(56.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,3.545),(56.745,3.715),(56.915,3.715),(56.915,3.545),(56.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.245),(33.085,22.415),(33.255,22.415),(33.255,22.245),(33.085,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.585),(37.885,5.755),(38.055,5.755),(38.055,5.585),(37.885,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,37.885),(42.345,38.055),(42.515,38.055),(42.515,37.885),(42.345,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.885),(42.685,38.055),(42.855,38.055),(42.855,37.885),(42.685,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.185),(57.085,19.355),(57.255,19.355),(57.255,19.185),(57.085,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.525),(57.085,19.695),(57.255,19.695),(57.255,19.525),(57.085,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,36.865),(42.345,37.035),(42.515,37.035),(42.515,36.865),(42.345,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,36.865),(42.685,37.035),(42.855,37.035),(42.855,36.865),(42.685,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.585),(47.145,5.755),(47.315,5.755),(47.315,5.585),(47.145,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.585),(33.085,22.755),(33.255,22.755),(33.255,22.585),(33.085,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.305),(57.085,25.475),(57.255,25.475),(57.255,25.305),(57.085,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,25.645),(57.085,25.815),(57.255,25.815),(57.255,25.645),(57.085,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.205),(32.745,3.375),(32.915,3.375),(32.915,3.205),(32.745,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,20.885),(57.085,21.055),(57.255,21.055),(57.255,20.885),(57.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,3.545),(32.745,3.715),(32.915,3.715),(32.915,3.545),(32.745,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,9.665),(42.685,9.835),(42.855,9.835),(42.855,9.665),(42.685,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.245),(37.545,22.415),(37.715,22.415),(37.715,22.245),(37.545,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.585),(37.545,22.755),(37.715,22.755),(37.715,22.585),(37.545,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.425),(33.085,31.595),(33.255,31.595),(33.255,31.425),(33.085,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.085),(33.085,31.255),(33.255,31.255),(33.255,31.085),(33.085,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,31.765),(33.085,31.935),(33.255,31.935),(33.255,31.765),(33.085,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.765),(52.285,14.935),(52.455,14.935),(52.455,14.765),(52.285,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.425),(52.285,14.595),(52.455,14.595),(52.455,14.425),(52.285,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,14.085),(52.285,14.255),(52.455,14.255),(52.455,14.085),(52.285,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.225),(47.145,4.395),(47.315,4.395),(47.315,4.225),(47.145,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.225),(47.485,4.395),(47.655,4.395),(47.655,4.225),(47.485,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.185),(42.685,19.355),(42.855,19.355),(42.855,19.185),(42.685,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.525),(42.345,19.695),(42.515,19.695),(42.515,19.525),(42.345,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.525),(42.685,19.695),(42.855,19.695),(42.855,19.525),(42.685,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.185),(42.345,19.355),(42.515,19.355),(42.515,19.185),(42.345,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.565),(47.145,4.735),(47.315,4.735),(47.315,4.565),(47.145,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,4.565),(47.485,4.735),(47.655,4.735),(47.655,4.565),(47.485,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,24.965),(56.745,25.135),(56.915,25.135),(56.915,24.965),(56.745,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.385),(42.685,29.555),(42.855,29.555),(42.855,29.385),(42.685,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.225),(51.945,21.395),(52.115,21.395),(52.115,21.225),(51.945,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.565),(51.945,21.735),(52.115,21.735),(52.115,21.565),(51.945,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.205),(42.345,20.375),(42.515,20.375),(42.515,20.205),(42.345,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.205),(42.685,20.375),(42.855,20.375),(42.855,20.205),(42.685,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.405),(32.745,30.575),(32.915,30.575),(32.915,30.405),(32.745,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.545),(42.345,20.715),(42.515,20.715),(42.515,20.545),(42.345,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.305),(57.085,8.475),(57.255,8.475),(57.255,8.305),(57.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.645),(57.085,8.815),(57.255,8.815),(57.255,8.645),(57.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.225),(37.545,21.395),(37.715,21.395),(37.715,21.225),(37.545,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,21.565),(37.545,21.735),(37.715,21.735),(37.715,21.565),(37.545,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,22.585),(37.885,22.755),(38.055,22.755),(38.055,22.585),(37.885,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.865),(51.945,20.035),(52.115,20.035),(52.115,19.865),(51.945,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.165),(51.945,18.335),(52.115,18.335),(52.115,18.165),(51.945,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,25.985),(56.745,26.155),(56.915,26.155),(56.915,25.985),(56.745,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,37.885),(52.285,38.055),(52.455,38.055),(52.455,37.885),(52.285,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.885),(33.085,38.055),(33.255,38.055),(33.255,37.885),(33.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.265),(52.285,23.435),(52.455,23.435),(52.455,23.265),(52.285,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,23.605),(52.285,23.775),(52.455,23.775),(52.455,23.605),(52.285,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,10.005),(33.085,10.175),(33.255,10.175),(33.255,10.005),(33.085,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,23.945),(37.885,24.115),(38.055,24.115),(38.055,23.945),(37.885,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,23.945),(37.545,24.115),(37.715,24.115),(37.715,23.945),(37.545,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.725),(47.145,29.895),(47.315,29.895),(47.315,29.725),(47.145,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.145),(51.945,17.315),(52.115,17.315),(52.115,17.145),(51.945,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.485),(51.945,17.655),(52.115,17.655),(52.115,17.485),(51.945,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,17.825),(51.945,17.995),(52.115,17.995),(52.115,17.825),(51.945,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,26.665),(57.085,26.835),(57.255,26.835),(57.255,26.665),(57.085,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,26.325),(57.085,26.495),(57.255,26.495),(57.255,26.325),(57.085,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.785),(42.345,15.955),(42.515,15.955),(42.515,15.785),(42.345,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.785),(42.685,15.955),(42.855,15.955),(42.855,15.785),(42.685,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.105),(42.345,15.275),(42.515,15.275),(42.515,15.105),(42.345,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.105),(42.685,15.275),(42.855,15.275),(42.855,15.105),(42.685,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,2.865),(37.885,3.035),(38.055,3.035),(38.055,2.865),(37.885,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,15.445),(42.345,15.615),(42.515,15.615),(42.515,15.445),(42.345,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,15.445),(42.685,15.615),(42.855,15.615),(42.855,15.445),(42.685,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,21.905),(52.285,22.075),(52.455,22.075),(52.455,21.905),(52.285,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,11.705),(47.145,11.875),(47.315,11.875),(47.315,11.705),(47.145,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.225),(42.685,4.395),(42.855,4.395),(42.855,4.225),(42.685,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.565),(42.345,4.735),(42.515,4.735),(42.515,4.565),(42.345,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.565),(42.685,4.735),(42.855,4.735),(42.855,4.565),(42.685,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.225),(42.345,4.395),(42.515,4.395),(42.515,4.225),(42.345,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.105),(37.545,32.275),(37.715,32.275),(37.715,32.105),(37.545,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.445),(37.545,32.615),(37.715,32.615),(37.715,32.445),(37.545,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.765),(37.545,31.935),(37.715,31.935),(37.715,31.765),(37.545,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,32.785),(37.545,32.955),(37.715,32.955),(37.715,32.785),(37.545,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.085),(37.545,31.255),(37.715,31.255),(37.715,31.085),(37.545,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,31.425),(37.545,31.595),(37.715,31.595),(37.715,31.425),(37.545,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.245),(37.545,5.415),(37.715,5.415),(37.715,5.245),(37.545,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.145),(33.085,17.315),(33.255,17.315),(33.255,17.145),(33.085,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.485),(33.085,17.655),(33.255,17.655),(33.255,17.485),(33.085,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,5.585),(37.545,5.755),(37.715,5.755),(37.715,5.585),(37.545,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,17.825),(33.085,17.995),(33.255,17.995),(33.255,17.825),(33.085,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.945),(57.085,24.115),(57.255,24.115),(57.255,23.945),(57.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,9.325),(47.145,9.495),(47.315,9.495),(47.315,9.325),(47.145,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,9.325),(47.485,9.495),(47.655,9.495),(47.655,9.325),(47.485,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,7.965),(52.285,8.135),(52.455,8.135),(52.455,7.965),(52.285,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.545),(51.945,3.715),(52.115,3.715),(52.115,3.545),(51.945,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.045),(52.285,29.215),(52.455,29.215),(52.455,29.045),(52.285,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,25.985),(42.345,26.155),(42.515,26.155),(42.515,25.985),(42.345,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,25.985),(42.685,26.155),(42.855,26.155),(42.855,25.985),(42.685,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.385),(52.285,29.555),(52.455,29.555),(52.455,29.385),(52.285,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,3.205),(51.945,3.375),(52.115,3.375),(52.115,3.205),(51.945,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.065),(42.685,30.235),(42.855,30.235),(42.855,30.065),(42.685,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,29.725),(52.285,29.895),(52.455,29.895),(52.455,29.725),(52.285,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.745),(51.945,13.915),(52.115,13.915),(52.115,13.745),(51.945,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.065),(51.945,13.235),(52.115,13.235),(52.115,13.065),(51.945,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,13.405),(51.945,13.575),(52.115,13.575),(52.115,13.405),(51.945,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.945),(47.485,24.115),(47.655,24.115),(47.655,23.945),(47.485,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.945),(47.145,24.115),(47.315,24.115),(47.315,23.945),(47.145,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.065),(33.085,13.235),(33.255,13.235),(33.255,13.065),(33.085,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.405),(33.085,13.575),(33.255,13.575),(33.255,13.405),(33.085,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,13.745),(33.085,13.915),(33.255,13.915),(33.255,13.745),(33.085,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.305),(32.745,25.475),(32.915,25.475),(32.915,25.305),(32.745,25.305)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,25.645),(32.745,25.815),(32.915,25.815),(32.915,25.645),(32.745,25.645)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.785),(37.885,15.955),(38.055,15.955),(38.055,15.785),(37.885,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.105),(37.885,15.275),(38.055,15.275),(38.055,15.105),(37.885,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,15.445),(37.885,15.615),(38.055,15.615),(38.055,15.445),(37.885,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.245),(33.085,39.415),(33.255,39.415),(33.255,39.245),(33.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,39.585),(33.085,39.755),(33.255,39.755),(33.255,39.585),(33.085,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,10.345),(42.685,10.515),(42.855,10.515),(42.855,10.345),(42.685,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,21.905),(56.745,22.075),(56.915,22.075),(56.915,21.905),(56.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.345),(47.145,27.515),(47.315,27.515),(47.315,27.345),(47.145,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.345),(47.485,27.515),(47.655,27.515),(47.655,27.345),(47.485,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.905),(37.885,5.075),(38.055,5.075),(38.055,4.905),(37.885,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.685),(47.145,27.855),(47.315,27.855),(47.315,27.685),(47.145,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.205),(56.745,37.375),(56.915,37.375),(56.915,37.205),(56.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,37.545),(56.745,37.715),(56.915,37.715),(56.915,37.545),(56.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.685),(47.485,27.855),(47.655,27.855),(47.655,27.685),(47.485,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,27.005),(47.145,27.175),(47.315,27.175),(47.315,27.005),(47.145,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,27.005),(47.485,27.175),(47.655,27.175),(47.655,27.005),(47.485,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.025),(57.085,11.195),(57.255,11.195),(57.255,11.025),(57.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.365),(57.085,11.535),(57.255,11.535),(57.255,11.365),(57.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,11.705),(57.085,11.875),(57.255,11.875),(57.255,11.705),(57.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,21.565),(42.345,21.735),(42.515,21.735),(42.515,21.565),(42.345,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.565),(42.685,21.735),(42.855,21.735),(42.855,21.565),(42.685,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.765),(56.745,14.935),(56.915,14.935),(56.915,14.765),(56.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.085),(56.745,14.255),(56.915,14.255),(56.915,14.085),(56.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,14.425),(56.745,14.595),(56.915,14.595),(56.915,14.425),(56.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.005),(32.745,10.175),(32.915,10.175),(32.915,10.005),(32.745,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,14.425),(33.085,14.595),(33.255,14.595),(33.255,14.425),(33.085,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,10.345),(32.745,10.515),(32.915,10.515),(32.915,10.345),(32.745,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,33.465),(42.685,33.635),(42.855,33.635),(42.855,33.465),(42.685,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.105),(47.145,15.275),(47.315,15.275),(47.315,15.105),(47.145,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.105),(47.485,15.275),(47.655,15.275),(47.655,15.105),(47.485,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,15.445),(47.145,15.615),(47.315,15.615),(47.315,15.445),(47.145,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.925),(57.085,6.095),(57.255,6.095),(57.255,5.925),(57.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,32.105),(42.345,32.275),(42.515,32.275),(42.515,32.105),(42.345,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.105),(57.085,32.275),(57.255,32.275),(57.255,32.105),(57.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.445),(57.085,32.615),(57.255,32.615),(57.255,32.445),(57.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,32.785),(57.085,32.955),(57.255,32.955),(57.255,32.785),(57.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.245),(37.885,39.415),(38.055,39.415),(38.055,39.245),(37.885,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,39.585),(37.885,39.755),(38.055,39.755),(38.055,39.585),(37.885,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.925),(33.085,6.095),(33.255,6.095),(33.255,5.925),(33.085,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,11.025),(37.885,11.195),(38.055,11.195),(38.055,11.025),(37.885,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,22.925),(32.745,23.095),(32.915,23.095),(32.915,22.925),(32.745,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,26.325),(52.285,26.495),(52.455,26.495),(52.455,26.325),(52.285,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,26.665),(52.285,26.835),(52.455,26.835),(52.455,26.665),(52.285,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.385),(33.085,29.555),(33.255,29.555),(33.255,29.385),(33.085,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.065),(47.145,13.235),(47.315,13.235),(47.315,13.065),(47.145,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.065),(47.485,13.235),(47.655,13.235),(47.655,13.065),(47.485,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.405),(47.145,13.575),(47.315,13.575),(47.315,13.405),(47.145,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,13.405),(47.485,13.575),(47.655,13.575),(47.655,13.405),(47.485,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.185),(37.885,19.355),(38.055,19.355),(38.055,19.185),(37.885,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,19.525),(37.885,19.695),(38.055,19.695),(38.055,19.525),(37.885,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.445),(33.085,32.615),(33.255,32.615),(33.255,32.445),(33.085,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,29.045),(33.085,29.215),(33.255,29.215),(33.255,29.045),(33.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.785),(33.085,32.955),(33.255,32.955),(33.255,32.785),(33.085,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.185),(56.745,19.355),(56.915,19.355),(56.915,19.185),(56.745,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,19.525),(56.745,19.695),(56.915,19.695),(56.915,19.525),(56.745,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,31.765),(42.685,31.935),(42.855,31.935),(42.855,31.765),(42.685,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,32.105),(33.085,32.275),(33.255,32.275),(33.255,32.105),(33.085,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.885),(37.545,38.055),(37.715,38.055),(37.715,37.885),(37.545,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,2.865),(47.145,3.035),(47.315,3.035),(47.315,2.865),(47.145,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,2.865),(47.485,3.035),(47.655,3.035),(47.655,2.865),(47.485,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.585),(42.685,5.755),(42.855,5.755),(42.855,5.585),(42.685,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.245),(42.345,5.415),(42.515,5.415),(42.515,5.245),(42.345,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,5.245),(42.685,5.415),(42.855,5.415),(42.855,5.245),(42.685,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.145),(37.885,34.315),(38.055,34.315),(38.055,34.145),(37.885,34.145)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.485),(37.885,34.655),(38.055,34.655),(38.055,34.485),(37.885,34.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,5.585),(42.345,5.755),(42.515,5.755),(42.515,5.585),(42.345,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,34.825),(37.885,34.995),(38.055,34.995),(38.055,34.825),(37.885,34.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.545),(37.885,37.715),(38.055,37.715),(38.055,37.545),(37.885,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.205),(37.885,37.375),(38.055,37.375),(38.055,37.205),(37.885,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.065),(52.285,30.235),(52.455,30.235),(52.455,30.065),(52.285,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.405),(52.285,30.575),(52.455,30.575),(52.455,30.405),(52.285,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,5.925),(47.485,6.095),(47.655,6.095),(47.655,5.925),(47.485,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,30.745),(52.285,30.915),(52.455,30.915),(52.455,30.745),(52.285,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.205),(33.085,20.375),(33.255,20.375),(33.255,20.205),(33.085,20.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.545),(33.085,20.715),(33.255,20.715),(33.255,20.545),(33.085,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.285),(57.085,7.455),(57.255,7.455),(57.255,7.285),(57.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,7.625),(57.085,7.795),(57.255,7.795),(57.255,7.625),(57.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.045),(47.145,29.215),(47.315,29.215),(47.315,29.045),(47.145,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.085),(37.885,14.255),(38.055,14.255),(38.055,14.085),(37.885,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.425),(37.885,14.595),(38.055,14.595),(38.055,14.425),(37.885,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,14.765),(37.885,14.935),(38.055,14.935),(38.055,14.765),(37.885,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.045),(47.485,29.215),(47.655,29.215),(47.655,29.045),(47.485,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,29.385),(47.145,29.555),(47.315,29.555),(47.315,29.385),(47.145,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.545),(47.145,3.715),(47.315,3.715),(47.315,3.545),(47.145,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,21.225),(42.685,21.395),(42.855,21.395),(42.855,21.225),(42.685,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.285),(33.085,7.455),(33.255,7.455),(33.255,7.285),(33.085,7.285)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.385),(47.485,29.555),(47.655,29.555),(47.655,29.385),(47.485,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.285),(57.085,24.455),(57.255,24.455),(57.255,24.285),(57.085,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.625),(57.085,24.795),(57.255,24.795),(57.255,24.625),(57.085,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,7.625),(33.085,7.795),(33.255,7.795),(33.255,7.625),(33.085,7.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,18.845),(47.145,19.015),(47.315,19.015),(47.315,18.845),(47.145,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,18.845),(47.485,19.015),(47.655,19.015),(47.655,18.845),(47.485,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,19.525),(52.285,19.695),(52.455,19.695),(52.455,19.525),(52.285,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.125),(47.145,33.295),(47.315,33.295),(47.315,33.125),(47.145,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,33.805),(47.145,33.975),(47.315,33.975),(47.315,33.805),(47.145,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.165),(37.545,35.335),(37.715,35.335),(37.715,35.165),(37.545,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.505),(37.545,35.675),(37.715,35.675),(37.715,35.505),(37.545,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,16.465),(51.945,16.635),(52.115,16.635),(52.115,16.465),(51.945,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.785),(56.745,15.955),(56.915,15.955),(56.915,15.785),(56.745,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.105),(56.745,15.275),(56.915,15.275),(56.915,15.105),(56.745,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,15.445),(56.745,15.615),(56.915,15.615),(56.915,15.445),(56.745,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.325),(33.085,9.495),(33.255,9.495),(33.255,9.325),(33.085,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,9.665),(33.085,9.835),(33.255,9.835),(33.255,9.665),(33.085,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.285),(42.345,24.455),(42.515,24.455),(42.515,24.285),(42.345,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.285),(42.685,24.455),(42.855,24.455),(42.855,24.285),(42.685,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.625),(42.345,24.795),(42.515,24.795),(42.515,24.625),(42.345,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.625),(42.685,24.795),(42.855,24.795),(42.855,24.625),(42.685,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,18.845),(37.545,19.015),(37.715,19.015),(37.715,18.845),(37.545,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.185),(37.885,36.355),(38.055,36.355),(38.055,36.185),(37.885,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,36.525),(37.885,36.695),(38.055,36.695),(38.055,36.525),(37.885,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.185),(37.545,36.355),(37.715,36.355),(37.715,36.185),(37.545,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.525),(37.545,36.695),(37.715,36.695),(37.715,36.525),(37.545,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.025),(47.485,28.195),(47.655,28.195),(47.655,28.025),(47.485,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,28.365),(47.485,28.535),(47.655,28.535),(47.655,28.365),(47.485,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,19.865),(57.085,20.035),(57.255,20.035),(57.255,19.865),(57.085,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.525),(47.485,19.695),(47.655,19.695),(47.655,19.525),(47.485,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.525),(47.145,19.695),(47.315,19.695),(47.315,19.525),(47.145,19.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.185),(47.485,19.355),(47.655,19.355),(47.655,19.185),(47.485,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,23.945),(32.745,24.115),(32.915,24.115),(32.915,23.945),(32.745,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.185),(47.145,19.355),(47.315,19.355),(47.315,19.185),(47.145,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,18.845),(51.945,19.015),(52.115,19.015),(52.115,18.845),(51.945,18.845)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,22.925),(33.085,23.095),(33.255,23.095),(33.255,22.925),(33.085,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,2.865),(42.345,3.035),(42.515,3.035),(42.515,2.865),(42.345,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,2.865),(42.685,3.035),(42.855,3.035),(42.855,2.865),(42.685,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.925),(57.085,40.095),(57.255,40.095),(57.255,39.925),(57.085,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,22.925),(37.545,23.095),(37.715,23.095),(37.715,22.925),(37.545,22.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.685),(47.145,10.855),(47.315,10.855),(47.315,10.685),(47.145,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.685),(47.485,10.855),(47.655,10.855),(47.655,10.685),(47.485,10.685)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.005),(47.145,10.175),(47.315,10.175),(47.315,10.005),(47.145,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.005),(47.485,10.175),(47.655,10.175),(47.655,10.005),(47.485,10.005)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,10.345),(47.145,10.515),(47.315,10.515),(47.315,10.345),(47.145,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,10.345),(47.485,10.515),(47.655,10.515),(47.655,10.345),(47.485,10.345)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,2.865),(37.545,3.035),(37.715,3.035),(37.715,2.865),(37.545,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,4.905),(47.145,5.075),(47.315,5.075),(47.315,4.905),(47.145,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.245),(37.885,5.415),(38.055,5.415),(38.055,5.245),(37.885,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.245),(42.685,39.415),(42.855,39.415),(42.855,39.245),(42.685,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,39.585),(42.685,39.755),(42.855,39.755),(42.855,39.585),(42.685,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,39.245),(42.345,39.415),(42.515,39.415),(42.515,39.245),(42.345,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.805),(32.745,16.975),(32.915,16.975),(32.915,16.805),(32.745,16.805)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.125),(32.745,16.295),(32.915,16.295),(32.915,16.125),(32.745,16.125)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,16.465),(32.745,16.635),(32.915,16.635),(32.915,16.465),(32.745,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.645),(47.485,8.815),(47.655,8.815),(47.655,8.645),(47.485,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.305),(47.145,8.475),(47.315,8.475),(47.315,8.305),(47.145,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.305),(47.485,8.475),(47.655,8.475),(47.655,8.305),(47.485,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.645),(47.145,8.815),(47.315,8.815),(47.315,8.645),(47.145,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.885),(42.685,21.055),(42.855,21.055),(42.855,20.885),(42.685,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,20.885),(42.345,21.055),(42.515,21.055),(42.515,20.885),(42.345,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,19.865),(42.345,20.035),(42.515,20.035),(42.515,19.865),(42.345,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,8.985),(57.085,9.155),(57.255,9.155),(57.255,8.985),(57.085,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,19.865),(42.685,20.035),(42.855,20.035),(42.855,19.865),(42.685,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.685),(57.085,27.855),(57.255,27.855),(57.255,27.685),(57.085,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.005),(57.085,27.175),(57.255,27.175),(57.255,27.005),(57.085,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,27.345),(57.085,27.515),(57.255,27.515),(57.255,27.345),(57.085,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,28.365),(47.145,28.535),(47.315,28.535),(47.315,28.365),(47.145,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,33.125),(51.945,33.295),(52.115,33.295),(52.115,33.125),(51.945,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.225),(42.685,38.395),(42.855,38.395),(42.855,38.225),(42.685,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.905),(57.085,22.075),(57.255,22.075),(57.255,21.905),(57.085,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,38.565),(42.685,38.735),(42.855,38.735),(42.855,38.565),(42.685,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.205),(33.085,37.375),(33.255,37.375),(33.255,37.205),(33.085,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,37.545),(33.085,37.715),(33.255,37.715),(33.255,37.545),(33.085,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.105),(42.685,32.275),(42.855,32.275),(42.855,32.105),(42.685,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.445),(42.685,32.615),(42.855,32.615),(42.855,32.445),(42.685,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,32.785),(42.685,32.955),(42.855,32.955),(42.855,32.785),(42.685,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.725),(52.285,12.895),(52.455,12.895),(52.455,12.725),(52.285,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.205),(37.545,3.375),(37.715,3.375),(37.715,3.205),(37.545,3.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.545),(37.545,3.715),(37.715,3.715),(37.715,3.545),(37.545,3.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.045),(52.285,12.215),(52.455,12.215),(52.455,12.045),(52.285,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,12.385),(52.285,12.555),(52.455,12.555),(52.455,12.385),(52.285,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,26.325),(47.145,26.495),(47.315,26.495),(47.315,26.325),(47.145,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,26.325),(47.485,26.495),(47.655,26.495),(47.655,26.325),(47.485,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,26.665),(47.145,26.835),(47.315,26.835),(47.315,26.665),(47.145,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,26.665),(47.485,26.835),(47.655,26.835),(47.655,26.665),(47.485,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.145),(47.145,17.315),(47.315,17.315),(47.315,17.145),(47.145,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.145),(47.485,17.315),(47.655,17.315),(47.655,17.145),(47.485,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.485),(47.145,17.655),(47.315,17.655),(47.315,17.485),(47.145,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.485),(47.485,17.655),(47.655,17.655),(47.655,17.485),(47.485,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,17.825),(47.145,17.995),(47.315,17.995),(47.315,17.825),(47.145,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,17.825),(47.485,17.995),(47.655,17.995),(47.655,17.825),(47.485,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,37.885),(47.485,38.055),(47.655,38.055),(47.655,37.885),(47.485,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,4.905),(42.685,5.075),(42.855,5.075),(42.855,4.905),(42.685,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,4.905),(42.345,5.075),(42.515,5.075),(42.515,4.905),(42.345,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.245),(56.745,39.415),(56.915,39.415),(56.915,39.245),(56.745,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,39.585),(56.745,39.755),(56.915,39.755),(56.915,39.585),(56.745,39.585)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,21.905),(51.945,22.075),(52.115,22.075),(52.115,21.905),(51.945,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.225),(57.085,38.395),(57.255,38.395),(57.255,38.225),(57.085,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,38.565),(57.085,38.735),(57.255,38.735),(57.255,38.565),(57.085,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,19.865),(32.745,20.035),(32.915,20.035),(32.915,19.865),(32.745,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.025),(56.745,11.195),(56.915,11.195),(56.915,11.025),(56.745,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.365),(56.745,11.535),(56.915,11.535),(56.915,11.365),(56.745,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,15.785),(47.485,15.955),(47.655,15.955),(47.655,15.785),(47.485,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,40.265),(51.945,40.435),(52.115,40.435),(52.115,40.265),(51.945,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,40.605),(51.945,40.775),(52.115,40.775),(52.115,40.605),(51.945,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.225),(47.145,38.395),(47.315,38.395),(47.315,38.225),(47.145,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,38.565),(47.145,38.735),(47.315,38.735),(47.315,38.565),(47.145,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,11.705),(56.745,11.875),(56.915,11.875),(56.915,11.705),(56.745,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.225),(47.485,38.395),(47.655,38.395),(47.655,38.225),(47.485,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,38.565),(47.485,38.735),(47.655,38.735),(47.655,38.565),(47.485,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,19.185),(51.945,19.355),(52.115,19.355),(52.115,19.185),(51.945,19.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.265),(57.085,23.435),(57.255,23.435),(57.255,23.265),(57.085,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,23.605),(57.085,23.775),(57.255,23.775),(57.255,23.605),(57.085,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.605),(47.145,23.775),(47.315,23.775),(47.315,23.605),(47.145,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.225),(37.885,4.395),(38.055,4.395),(38.055,4.225),(37.885,4.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,4.565),(37.885,4.735),(38.055,4.735),(38.055,4.565),(37.885,4.565)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,23.265),(47.145,23.435),(47.315,23.435),(47.315,23.265),(47.145,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.265),(47.485,23.435),(47.655,23.435),(47.655,23.265),(47.485,23.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,23.605),(47.485,23.775),(47.655,23.775),(47.655,23.605),(47.485,23.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,30.405),(47.485,30.575),(47.655,30.575),(47.655,30.405),(47.485,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,23.945),(42.345,24.115),(42.515,24.115),(42.515,23.945),(42.345,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.065),(37.545,13.235),(37.715,13.235),(37.715,13.065),(37.545,13.065)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.405),(37.545,13.575),(37.715,13.575),(37.715,13.405),(37.545,13.405)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.025),(42.345,28.195),(42.515,28.195),(42.515,28.025),(42.345,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.025),(42.685,28.195),(42.855,28.195),(42.855,28.025),(42.685,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.365),(42.345,28.535),(42.515,28.535),(42.515,28.365),(42.345,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.365),(42.685,28.535),(42.855,28.535),(42.855,28.365),(42.685,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,28.705),(42.345,28.875),(42.515,28.875),(42.515,28.705),(42.345,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,28.705),(42.685,28.875),(42.855,28.875),(42.855,28.705),(42.685,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,13.745),(37.545,13.915),(37.715,13.915),(37.715,13.745),(37.545,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.705),(51.945,11.875),(52.115,11.875),(52.115,11.705),(51.945,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.025),(51.945,11.195),(52.115,11.195),(52.115,11.025),(51.945,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,11.365),(51.945,11.535),(52.115,11.535),(52.115,11.365),(51.945,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.105),(47.145,32.275),(47.315,32.275),(47.315,32.105),(47.145,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.785),(47.145,32.955),(47.315,32.955),(47.315,32.785),(47.145,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.785),(47.485,32.955),(47.655,32.955),(47.655,32.785),(47.485,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.105),(47.485,32.275),(47.655,32.275),(47.655,32.105),(47.485,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,32.445),(47.145,32.615),(47.315,32.615),(47.315,32.445),(47.145,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,5.245),(57.085,5.415),(57.255,5.415),(57.255,5.245),(57.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,16.465),(37.885,16.635),(38.055,16.635),(38.055,16.465),(37.885,16.465)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,32.445),(47.485,32.615),(47.655,32.615),(47.655,32.445),(47.485,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.085),(51.945,14.255),(52.115,14.255),(52.115,14.085),(51.945,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.425),(51.945,14.595),(52.115,14.595),(52.115,14.425),(51.945,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,14.765),(51.945,14.935),(52.115,14.935),(52.115,14.765),(51.945,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.245),(33.085,5.415),(33.255,5.415),(33.255,5.245),(33.085,5.245)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,5.585),(33.085,5.755),(33.255,5.755),(33.255,5.585),(33.085,5.585)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,30.405),(37.885,30.575),(38.055,30.575),(38.055,30.405),(37.885,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,35.845),(37.885,36.015),(38.055,36.015),(38.055,35.845),(37.885,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.385),(42.345,29.555),(42.515,29.555),(42.515,29.385),(42.345,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.465),(37.545,33.635),(37.715,33.635),(37.715,33.465),(37.545,33.465)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.125),(37.545,33.295),(37.715,33.295),(37.715,33.125),(37.545,33.125)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,33.805),(37.545,33.975),(37.715,33.975),(37.715,33.805),(37.545,33.805)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.205),(37.545,37.375),(37.715,37.375),(37.715,37.205),(37.545,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,37.545),(37.545,37.715),(37.715,37.715),(37.715,37.545),(37.545,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.725),(57.085,29.895),(57.255,29.895),(57.255,29.725),(57.085,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,25.985),(47.145,26.155),(47.315,26.155),(47.315,25.985),(47.145,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,25.985),(47.485,26.155),(47.655,26.155),(47.655,25.985),(47.485,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,29.045),(57.085,29.215),(57.255,29.215),(57.255,29.045),(57.085,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.305),(33.085,8.475),(33.255,8.475),(33.255,8.305),(33.085,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,8.645),(33.085,8.815),(33.255,8.815),(33.255,8.645),(33.085,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.725),(42.685,29.895),(42.855,29.895),(42.855,29.725),(42.685,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.725),(42.345,29.895),(42.515,29.895),(42.515,29.725),(42.345,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,29.045),(42.345,29.215),(42.515,29.215),(42.515,29.045),(42.345,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,29.045),(42.685,29.215),(42.855,29.215),(42.855,29.045),(42.685,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.725),(42.345,12.895),(42.515,12.895),(42.515,12.725),(42.345,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.725),(42.685,12.895),(42.855,12.895),(42.855,12.725),(42.685,12.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.045),(42.345,12.215),(42.515,12.215),(42.515,12.045),(42.345,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.045),(42.685,12.215),(42.855,12.215),(42.855,12.045),(42.685,12.045)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,12.385),(42.345,12.555),(42.515,12.555),(42.515,12.385),(42.345,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,12.385),(42.685,12.555),(42.855,12.555),(42.855,12.385),(42.685,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.025),(32.745,28.195),(32.915,28.195),(32.915,28.025),(32.745,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.365),(32.745,28.535),(32.915,28.535),(32.915,28.365),(32.745,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,28.705),(32.745,28.875),(32.915,28.875),(32.915,28.705),(32.745,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.245),(52.285,22.415),(52.455,22.415),(52.455,22.245),(52.285,22.245)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,37.885),(37.885,38.055),(38.055,38.055),(38.055,37.885),(37.885,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,22.585),(52.285,22.755),(52.455,22.755),(52.455,22.585),(52.285,22.585)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.285),(52.285,24.455),(52.455,24.455),(52.455,24.285),(52.285,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,24.625),(52.285,24.795),(52.455,24.795),(52.455,24.625),(52.285,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,29.725),(47.485,29.895),(47.655,29.895),(47.655,29.725),(47.485,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,25.985),(37.545,26.155),(37.715,26.155),(37.715,25.985),(37.545,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,20.885),(33.085,21.055),(33.255,21.055),(33.255,20.885),(33.085,20.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,3.885),(47.145,4.055),(47.315,4.055),(47.315,3.885),(47.145,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,3.885),(47.485,4.055),(47.655,4.055),(47.655,3.885),(47.485,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.085),(42.345,14.255),(42.515,14.255),(42.515,14.085),(42.345,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.085),(42.685,14.255),(42.855,14.255),(42.855,14.085),(42.685,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.425),(42.345,14.595),(42.515,14.595),(42.515,14.425),(42.345,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.425),(42.685,14.595),(42.855,14.595),(42.855,14.425),(42.685,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,14.765),(42.345,14.935),(42.515,14.935),(42.515,14.765),(42.345,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,14.765),(42.685,14.935),(42.855,14.935),(42.855,14.765),(42.685,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,11.705),(47.485,11.875),(47.655,11.875),(47.655,11.705),(47.485,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,37.205),(42.685,37.375),(42.855,37.375),(42.855,37.205),(42.685,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,24.965),(57.085,25.135),(57.255,25.135),(57.255,24.965),(57.085,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,2.865),(51.945,3.035),(52.115,3.035),(52.115,2.865),(51.945,2.865)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.225),(37.545,38.395),(37.715,38.395),(37.715,38.225),(37.545,38.225)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,38.565),(37.545,38.735),(37.715,38.735),(37.715,38.565),(37.545,38.565)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,35.845),(37.545,36.015),(37.715,36.015),(37.715,35.845),(37.545,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,37.885),(57.085,38.055),(57.255,38.055),(57.255,37.885),(57.085,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.285),(37.545,24.455),(37.715,24.455),(37.715,24.285),(37.545,24.285)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,24.625),(37.545,24.795),(37.715,24.795),(37.715,24.625),(37.545,24.625)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.045),(37.885,29.215),(38.055,29.215),(38.055,29.045),(37.885,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.385),(37.885,29.555),(38.055,29.555),(38.055,29.385),(37.885,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,29.725),(37.885,29.895),(38.055,29.895),(38.055,29.725),(37.885,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,30.065),(42.345,30.235),(42.515,30.235),(42.515,30.065),(42.345,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,30.405),(42.685,30.575),(42.855,30.575),(42.855,30.405),(42.685,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.025),(52.285,28.195),(52.455,28.195),(52.455,28.025),(52.285,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.365),(52.285,28.535),(52.455,28.535),(52.455,28.365),(52.285,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.165),(32.745,18.335),(32.915,18.335),(32.915,18.165),(32.745,18.165)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,18.505),(32.745,18.675),(32.915,18.675),(32.915,18.505),(32.745,18.505)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.205),(32.745,37.375),(32.915,37.375),(32.915,37.205),(32.745,37.205)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,37.545),(32.745,37.715),(32.915,37.715),(32.915,37.545),(32.745,37.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,28.705),(52.285,28.875),(52.455,28.875),(52.455,28.705),(52.285,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.665),(37.885,9.835),(38.055,9.835),(38.055,9.665),(37.885,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,40.265),(56.745,40.435),(56.915,40.435),(56.915,40.265),(56.745,40.265)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,40.605),(56.745,40.775),(56.915,40.775),(56.915,40.605),(56.745,40.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,37.885),(47.145,38.055),(47.315,38.055),(47.315,37.885),(47.145,37.885)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,4.905),(56.745,5.075),(56.915,5.075),(56.915,4.905),(56.745,4.905)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,9.325),(37.885,9.495),(38.055,9.495),(38.055,9.325),(37.885,9.325)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,36.865),(37.545,37.035),(37.715,37.035),(37.715,36.865),(37.545,36.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,24.965),(42.345,25.135),(42.515,25.135),(42.515,24.965),(42.345,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,24.965),(42.685,25.135),(42.855,25.135),(42.855,24.965),(42.685,24.965)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.265),(47.145,6.435),(47.315,6.435),(47.315,6.265),(47.145,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,19.865),(47.145,20.035),(47.315,20.035),(47.315,19.865),(47.145,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,19.865),(47.485,20.035),(47.655,20.035),(47.655,19.865),(47.485,19.865)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.145),(42.345,17.315),(42.515,17.315),(42.515,17.145),(42.345,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.145),(42.685,17.315),(42.855,17.315),(42.855,17.145),(42.685,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.485),(42.345,17.655),(42.515,17.655),(42.515,17.485),(42.345,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,17.485),(42.685,17.655),(42.855,17.655),(42.855,17.485),(42.685,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.265),(47.485,6.435),(47.655,6.435),(47.655,6.265),(47.485,6.265)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,6.605),(47.145,6.775),(47.315,6.775),(47.315,6.605),(47.145,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,6.605),(47.485,6.775),(47.655,6.775),(47.655,6.605),(47.485,6.605)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,9.665),(42.345,9.835),(42.515,9.835),(42.515,9.665),(42.345,9.665)),
        )
        createRL(
            tech, net, 'licon',
            ((42.345,17.825),(42.345,17.995),(42.515,17.995),(42.515,17.825),(42.345,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,3.885),(37.885,4.055),(38.055,4.055),(38.055,3.885),(37.885,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.025),(37.545,28.195),(37.715,28.195),(37.715,28.025),(37.545,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.365),(37.545,28.535),(37.715,28.535),(37.715,28.365),(37.545,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,28.705),(37.545,28.875),(37.715,28.875),(37.715,28.705),(37.545,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,26.325),(37.885,26.495),(38.055,26.495),(38.055,26.325),(37.885,26.325)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.145),(56.745,17.315),(56.915,17.315),(56.915,17.145),(56.745,17.145)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.485),(56.745,17.655),(56.915,17.655),(56.915,17.485),(56.745,17.485)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,17.825),(56.745,17.995),(56.915,17.995),(56.915,17.825),(56.745,17.825)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,26.665),(37.885,26.835),(38.055,26.835),(38.055,26.665),(37.885,26.665)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.685),(56.745,27.855),(56.915,27.855),(56.915,27.685),(56.745,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.005),(56.745,27.175),(56.915,27.175),(56.915,27.005),(56.745,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,35.845),(51.945,36.015),(52.115,36.015),(52.115,35.845),(51.945,35.845)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.305),(37.545,8.475),(37.715,8.475),(37.715,8.305),(37.545,8.305)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,8.645),(37.545,8.815),(37.715,8.815),(37.715,8.645),(37.545,8.645)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,27.345),(56.745,27.515),(56.915,27.515),(56.915,27.345),(56.745,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.025),(33.085,11.195),(33.255,11.195),(33.255,11.025),(33.085,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.765),(51.945,31.935),(52.115,31.935),(52.115,31.765),(51.945,31.765)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.365),(33.085,11.535),(33.255,11.535),(33.255,11.365),(33.085,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,11.705),(33.085,11.875),(33.255,11.875),(33.255,11.705),(33.085,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.085),(51.945,31.255),(52.115,31.255),(52.115,31.085),(51.945,31.085)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,31.425),(51.945,31.595),(52.115,31.595),(52.115,31.425),(51.945,31.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.085),(32.745,14.255),(32.915,14.255),(32.915,14.085),(32.745,14.085)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.425),(32.745,14.595),(32.915,14.595),(32.915,14.425),(32.745,14.425)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,14.765),(32.745,14.935),(32.915,14.935),(32.915,14.765),(32.745,14.765)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,39.245),(57.085,39.415),(57.255,39.415),(57.255,39.245),(57.085,39.245)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.045),(32.745,29.215),(32.915,29.215),(32.915,29.045),(32.745,29.045)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.385),(32.745,29.555),(32.915,29.555),(32.915,29.385),(32.745,29.385)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,29.725),(32.745,29.895),(32.915,29.895),(32.915,29.725),(32.745,29.725)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,23.945),(33.085,24.115),(33.255,24.115),(33.255,23.945),(33.085,23.945)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.185),(32.745,36.355),(32.915,36.355),(32.915,36.185),(32.745,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,36.525),(32.745,36.695),(32.915,36.695),(32.915,36.525),(32.745,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.165),(47.485,35.335),(47.655,35.335),(47.655,35.165),(47.485,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,35.505),(47.485,35.675),(47.655,35.675),(47.655,35.505),(47.485,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.165),(47.145,35.335),(47.315,35.335),(47.315,35.165),(47.145,35.165)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,35.505),(47.145,35.675),(47.315,35.675),(47.315,35.505),(47.145,35.505)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.185),(57.085,36.355),(57.255,36.355),(57.255,36.185),(57.085,36.185)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,36.525),(57.085,36.695),(57.255,36.695),(57.255,36.525),(57.085,36.525)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,5.925),(37.885,6.095),(38.055,6.095),(38.055,5.925),(37.885,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,13.745),(47.145,13.915),(47.315,13.915),(47.315,13.745),(47.145,13.745)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,8.985),(47.145,9.155),(47.315,9.155),(47.315,8.985),(47.145,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((47.485,8.985),(47.485,9.155),(47.655,9.155),(47.655,8.985),(47.485,8.985)),
        )
        createRL(
            tech, net, 'licon',
            ((42.685,20.545),(42.685,20.715),(42.855,20.715),(42.855,20.545),(42.685,20.545)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.025),(52.285,11.195),(52.455,11.195),(52.455,11.025),(52.285,11.025)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.365),(52.285,11.535),(52.455,11.535),(52.455,11.365),(52.285,11.365)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,11.705),(52.285,11.875),(52.455,11.875),(52.455,11.705),(52.285,11.705)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,12.385),(57.085,12.555),(57.255,12.555),(57.255,12.385),(57.085,12.385)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.025),(51.945,28.195),(52.115,28.195),(52.115,28.025),(51.945,28.025)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.445),(57.085,15.615),(57.255,15.615),(57.255,15.445),(57.085,15.445)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.105),(57.085,15.275),(57.255,15.275),(57.255,15.105),(57.085,15.105)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,15.785),(57.085,15.955),(57.255,15.955),(57.255,15.785),(57.085,15.785)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,28.365),(51.945,28.535),(52.115,28.535),(52.115,28.365),(51.945,28.365)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.785),(56.745,32.955),(56.915,32.955),(56.915,32.785),(56.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,21.905),(32.745,22.075),(32.915,22.075),(32.915,21.905),(32.745,21.905)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.565),(57.085,21.735),(57.255,21.735),(57.255,21.565),(57.085,21.565)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,27.685),(51.945,27.855),(52.115,27.855),(52.115,27.685),(51.945,27.685)),
        )
        createRL(
            tech, net, 'licon',
            ((57.085,21.225),(57.085,21.395),(57.255,21.395),(57.255,21.225),(57.085,21.225)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.105),(56.745,32.275),(56.915,32.275),(56.915,32.105),(56.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((56.745,32.445),(56.745,32.615),(56.915,32.615),(56.915,32.445),(56.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,39.925),(37.545,40.095),(37.715,40.095),(37.715,39.925),(37.545,39.925)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,3.885),(37.545,4.055),(37.715,4.055),(37.715,3.885),(37.545,3.885)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.105),(52.285,32.275),(52.455,32.275),(52.455,32.105),(52.285,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.005),(37.545,27.175),(37.715,27.175),(37.715,27.005),(37.545,27.005)),
        )
        createRL(
            tech, net, 'licon',
            ((37.545,27.345),(37.545,27.515),(37.715,27.515),(37.715,27.345),(37.545,27.345)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.445),(52.285,32.615),(52.455,32.615),(52.455,32.445),(52.285,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,32.785),(52.285,32.955),(52.455,32.955),(52.455,32.785),(52.285,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,28.705),(37.885,28.875),(38.055,28.875),(38.055,28.705),(37.885,28.705)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.745),(51.945,30.915),(52.115,30.915),(52.115,30.745),(51.945,30.745)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.065),(51.945,30.235),(52.115,30.235),(52.115,30.065),(51.945,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((51.945,30.405),(51.945,30.575),(52.115,30.575),(52.115,30.405),(51.945,30.405)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.105),(32.745,32.275),(32.915,32.275),(32.915,32.105),(32.745,32.105)),
        )
        createRL(
            tech, net, 'licon',
            ((33.085,25.985),(33.085,26.155),(33.255,26.155),(33.255,25.985),(33.085,25.985)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.445),(32.745,32.615),(32.915,32.615),(32.915,32.445),(32.745,32.445)),
        )
        createRL(
            tech, net, 'licon',
            ((37.885,7.965),(37.885,8.135),(38.055,8.135),(38.055,7.965),(37.885,7.965)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,32.785),(32.745,32.955),(32.915,32.955),(32.915,32.785),(32.745,32.785)),
        )
        createRL(
            tech, net, 'licon',
            ((32.745,30.065),(32.745,30.235),(32.915,30.235),(32.915,30.065),(32.745,30.065)),
        )
        createRL(
            tech, net, 'licon',
            ((47.145,5.925),(47.145,6.095),(47.315,6.095),(47.315,5.925),(47.145,5.925)),
        )
        createRL(
            tech, net, 'licon',
            ((52.285,25.305),(52.285,25.475),(52.455,25.475),(52.455,25.305),(52.285,25.305)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.835),(46.775,40.805),(48.025,40.805),(48.025,2.835),(46.775,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((46.775,2.785),(46.775,40.855),(48.025,40.855),(48.025,2.785),(46.775,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.835),(56.375,40.805),(57.625,40.805),(57.625,2.835),(56.375,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((56.375,2.785),(56.375,40.855),(57.625,40.855),(57.625,2.785),(56.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.785),(32.375,40.855),(33.625,40.855),(33.625,2.785),(32.375,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.745,2.785),(32.745,40.855),(33.255,40.855),(33.255,2.785),(32.745,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((32.375,2.835),(32.375,40.805),(33.625,40.805),(33.625,2.835),(32.375,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((51.945,2.785),(51.945,40.855),(52.455,40.855),(52.455,2.785),(51.945,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.835),(51.575,40.805),(52.825,40.805),(52.825,2.835),(51.575,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((51.575,2.785),(51.575,40.855),(52.825,40.855),(52.825,2.785),(51.575,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.835),(41.975,40.805),(43.225,40.805),(43.225,2.835),(41.975,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((37.545,2.785),(37.545,40.855),(38.055,40.855),(38.055,2.785),(37.545,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.835),(37.175,40.805),(38.425,40.805),(38.425,2.835),(37.175,2.835)),
        )
        createRL(
            tech, net, 'li',
            ((37.175,2.785),(37.175,40.855),(38.425,40.855),(38.425,2.785),(37.175,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((41.975,2.785),(41.975,40.855),(43.225,40.855),(43.225,2.785),(41.975,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((47.145,2.785),(47.145,40.855),(47.655,40.855),(47.655,2.785),(47.145,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((56.745,2.785),(56.745,40.855),(57.255,40.855),(57.255,2.785),(56.745,2.785)),
        )
        createRL(
            tech, net, 'li',
            ((42.345,2.785),(42.345,40.855),(42.855,40.855),(42.855,2.785),(42.345,2.785)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,2.835),(46.775,3.005),(46.945,3.005),(46.945,2.835),(46.775,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,2.835),(47.135,3.005),(47.305,3.005),(47.305,2.835),(47.135,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,2.835),(47.495,3.005),(47.665,3.005),(47.665,2.835),(47.495,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,2.835),(47.855,3.005),(48.025,3.005),(48.025,2.835),(47.855,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.195),(46.775,3.365),(46.945,3.365),(46.945,3.195),(46.775,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.195),(47.135,3.365),(47.305,3.365),(47.305,3.195),(47.135,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.195),(47.495,3.365),(47.665,3.365),(47.665,3.195),(47.495,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.195),(47.855,3.365),(48.025,3.365),(48.025,3.195),(47.855,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.555),(46.775,3.725),(46.945,3.725),(46.945,3.555),(46.775,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.555),(47.135,3.725),(47.305,3.725),(47.305,3.555),(47.135,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.555),(47.495,3.725),(47.665,3.725),(47.665,3.555),(47.495,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.555),(47.855,3.725),(48.025,3.725),(48.025,3.555),(47.855,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,3.915),(46.775,4.085),(46.945,4.085),(46.945,3.915),(46.775,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,3.915),(47.135,4.085),(47.305,4.085),(47.305,3.915),(47.135,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,3.915),(47.495,4.085),(47.665,4.085),(47.665,3.915),(47.495,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,3.915),(47.855,4.085),(48.025,4.085),(48.025,3.915),(47.855,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.275),(46.775,4.445),(46.945,4.445),(46.945,4.275),(46.775,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.275),(47.135,4.445),(47.305,4.445),(47.305,4.275),(47.135,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.275),(47.495,4.445),(47.665,4.445),(47.665,4.275),(47.495,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.275),(47.855,4.445),(48.025,4.445),(48.025,4.275),(47.855,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.635),(46.775,4.805),(46.945,4.805),(46.945,4.635),(46.775,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.635),(47.135,4.805),(47.305,4.805),(47.305,4.635),(47.135,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.635),(47.495,4.805),(47.665,4.805),(47.665,4.635),(47.495,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.635),(47.855,4.805),(48.025,4.805),(48.025,4.635),(47.855,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,4.995),(46.775,5.165),(46.945,5.165),(46.945,4.995),(46.775,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,4.995),(47.135,5.165),(47.305,5.165),(47.305,4.995),(47.135,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,4.995),(47.495,5.165),(47.665,5.165),(47.665,4.995),(47.495,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,4.995),(47.855,5.165),(48.025,5.165),(48.025,4.995),(47.855,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.355),(46.775,5.525),(46.945,5.525),(46.945,5.355),(46.775,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.355),(47.135,5.525),(47.305,5.525),(47.305,5.355),(47.135,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.355),(47.495,5.525),(47.665,5.525),(47.665,5.355),(47.495,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.355),(47.855,5.525),(48.025,5.525),(48.025,5.355),(47.855,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,5.715),(46.775,5.885),(46.945,5.885),(46.945,5.715),(46.775,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,5.715),(47.135,5.885),(47.305,5.885),(47.305,5.715),(47.135,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,5.715),(47.495,5.885),(47.665,5.885),(47.665,5.715),(47.495,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,5.715),(47.855,5.885),(48.025,5.885),(48.025,5.715),(47.855,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.075),(46.775,6.245),(46.945,6.245),(46.945,6.075),(46.775,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.075),(47.135,6.245),(47.305,6.245),(47.305,6.075),(47.135,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.075),(47.495,6.245),(47.665,6.245),(47.665,6.075),(47.495,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.075),(47.855,6.245),(48.025,6.245),(48.025,6.075),(47.855,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.435),(46.775,6.605),(46.945,6.605),(46.945,6.435),(46.775,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.435),(47.135,6.605),(47.305,6.605),(47.305,6.435),(47.135,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.435),(47.495,6.605),(47.665,6.605),(47.665,6.435),(47.495,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.435),(47.855,6.605),(48.025,6.605),(48.025,6.435),(47.855,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,6.795),(46.775,6.965),(46.945,6.965),(46.945,6.795),(46.775,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,6.795),(47.135,6.965),(47.305,6.965),(47.305,6.795),(47.135,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,6.795),(47.495,6.965),(47.665,6.965),(47.665,6.795),(47.495,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,6.795),(47.855,6.965),(48.025,6.965),(48.025,6.795),(47.855,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.155),(46.775,7.325),(46.945,7.325),(46.945,7.155),(46.775,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.155),(47.135,7.325),(47.305,7.325),(47.305,7.155),(47.135,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.155),(47.495,7.325),(47.665,7.325),(47.665,7.155),(47.495,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.155),(47.855,7.325),(48.025,7.325),(48.025,7.155),(47.855,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.515),(46.775,7.685),(46.945,7.685),(46.945,7.515),(46.775,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.515),(47.135,7.685),(47.305,7.685),(47.305,7.515),(47.135,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.515),(47.495,7.685),(47.665,7.685),(47.665,7.515),(47.495,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.515),(47.855,7.685),(48.025,7.685),(48.025,7.515),(47.855,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,7.875),(46.775,8.045),(46.945,8.045),(46.945,7.875),(46.775,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,7.875),(47.135,8.045),(47.305,8.045),(47.305,7.875),(47.135,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,7.875),(47.495,8.045),(47.665,8.045),(47.665,7.875),(47.495,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,7.875),(47.855,8.045),(48.025,8.045),(48.025,7.875),(47.855,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.235),(46.775,8.405),(46.945,8.405),(46.945,8.235),(46.775,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.235),(47.135,8.405),(47.305,8.405),(47.305,8.235),(47.135,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.235),(47.495,8.405),(47.665,8.405),(47.665,8.235),(47.495,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.235),(47.855,8.405),(48.025,8.405),(48.025,8.235),(47.855,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.595),(46.775,8.765),(46.945,8.765),(46.945,8.595),(46.775,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.595),(47.135,8.765),(47.305,8.765),(47.305,8.595),(47.135,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.595),(47.495,8.765),(47.665,8.765),(47.665,8.595),(47.495,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.595),(47.855,8.765),(48.025,8.765),(48.025,8.595),(47.855,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,8.955),(46.775,9.125),(46.945,9.125),(46.945,8.955),(46.775,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,8.955),(47.135,9.125),(47.305,9.125),(47.305,8.955),(47.135,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,8.955),(47.495,9.125),(47.665,9.125),(47.665,8.955),(47.495,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,8.955),(47.855,9.125),(48.025,9.125),(48.025,8.955),(47.855,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.315),(46.775,9.485),(46.945,9.485),(46.945,9.315),(46.775,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.315),(47.135,9.485),(47.305,9.485),(47.305,9.315),(47.135,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.315),(47.495,9.485),(47.665,9.485),(47.665,9.315),(47.495,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.315),(47.855,9.485),(48.025,9.485),(48.025,9.315),(47.855,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,9.675),(46.775,9.845),(46.945,9.845),(46.945,9.675),(46.775,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,9.675),(47.135,9.845),(47.305,9.845),(47.305,9.675),(47.135,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,9.675),(47.495,9.845),(47.665,9.845),(47.665,9.675),(47.495,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,9.675),(47.855,9.845),(48.025,9.845),(48.025,9.675),(47.855,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.035),(46.775,10.205),(46.945,10.205),(46.945,10.035),(46.775,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.035),(47.135,10.205),(47.305,10.205),(47.305,10.035),(47.135,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.035),(47.495,10.205),(47.665,10.205),(47.665,10.035),(47.495,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.035),(47.855,10.205),(48.025,10.205),(48.025,10.035),(47.855,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.395),(46.775,10.565),(46.945,10.565),(46.945,10.395),(46.775,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.395),(47.135,10.565),(47.305,10.565),(47.305,10.395),(47.135,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.395),(47.495,10.565),(47.665,10.565),(47.665,10.395),(47.495,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.395),(47.855,10.565),(48.025,10.565),(48.025,10.395),(47.855,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,10.755),(46.775,10.925),(46.945,10.925),(46.945,10.755),(46.775,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,10.755),(47.135,10.925),(47.305,10.925),(47.305,10.755),(47.135,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,10.755),(47.495,10.925),(47.665,10.925),(47.665,10.755),(47.495,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,10.755),(47.855,10.925),(48.025,10.925),(48.025,10.755),(47.855,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.115),(46.775,11.285),(46.945,11.285),(46.945,11.115),(46.775,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.115),(47.135,11.285),(47.305,11.285),(47.305,11.115),(47.135,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.115),(47.495,11.285),(47.665,11.285),(47.665,11.115),(47.495,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.115),(47.855,11.285),(48.025,11.285),(48.025,11.115),(47.855,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.475),(46.775,11.645),(46.945,11.645),(46.945,11.475),(46.775,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.475),(47.135,11.645),(47.305,11.645),(47.305,11.475),(47.135,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.475),(47.495,11.645),(47.665,11.645),(47.665,11.475),(47.495,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.475),(47.855,11.645),(48.025,11.645),(48.025,11.475),(47.855,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,11.835),(46.775,12.005),(46.945,12.005),(46.945,11.835),(46.775,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,11.835),(47.135,12.005),(47.305,12.005),(47.305,11.835),(47.135,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,11.835),(47.495,12.005),(47.665,12.005),(47.665,11.835),(47.495,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,11.835),(47.855,12.005),(48.025,12.005),(48.025,11.835),(47.855,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.195),(46.775,12.365),(46.945,12.365),(46.945,12.195),(46.775,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.195),(47.135,12.365),(47.305,12.365),(47.305,12.195),(47.135,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.195),(47.495,12.365),(47.665,12.365),(47.665,12.195),(47.495,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.195),(47.855,12.365),(48.025,12.365),(48.025,12.195),(47.855,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.555),(46.775,12.725),(46.945,12.725),(46.945,12.555),(46.775,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.555),(47.135,12.725),(47.305,12.725),(47.305,12.555),(47.135,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.555),(47.495,12.725),(47.665,12.725),(47.665,12.555),(47.495,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.555),(47.855,12.725),(48.025,12.725),(48.025,12.555),(47.855,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,12.915),(46.775,13.085),(46.945,13.085),(46.945,12.915),(46.775,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,12.915),(47.135,13.085),(47.305,13.085),(47.305,12.915),(47.135,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,12.915),(47.495,13.085),(47.665,13.085),(47.665,12.915),(47.495,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,12.915),(47.855,13.085),(48.025,13.085),(48.025,12.915),(47.855,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.275),(46.775,13.445),(46.945,13.445),(46.945,13.275),(46.775,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.275),(47.135,13.445),(47.305,13.445),(47.305,13.275),(47.135,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.275),(47.495,13.445),(47.665,13.445),(47.665,13.275),(47.495,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.275),(47.855,13.445),(48.025,13.445),(48.025,13.275),(47.855,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.635),(46.775,13.805),(46.945,13.805),(46.945,13.635),(46.775,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.635),(47.135,13.805),(47.305,13.805),(47.305,13.635),(47.135,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.635),(47.495,13.805),(47.665,13.805),(47.665,13.635),(47.495,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.635),(47.855,13.805),(48.025,13.805),(48.025,13.635),(47.855,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,13.995),(46.775,14.165),(46.945,14.165),(46.945,13.995),(46.775,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,13.995),(47.135,14.165),(47.305,14.165),(47.305,13.995),(47.135,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,13.995),(47.495,14.165),(47.665,14.165),(47.665,13.995),(47.495,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,13.995),(47.855,14.165),(48.025,14.165),(48.025,13.995),(47.855,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.355),(46.775,14.525),(46.945,14.525),(46.945,14.355),(46.775,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.355),(47.135,14.525),(47.305,14.525),(47.305,14.355),(47.135,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.355),(47.495,14.525),(47.665,14.525),(47.665,14.355),(47.495,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.355),(47.855,14.525),(48.025,14.525),(48.025,14.355),(47.855,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,14.715),(46.775,14.885),(46.945,14.885),(46.945,14.715),(46.775,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,14.715),(47.135,14.885),(47.305,14.885),(47.305,14.715),(47.135,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,14.715),(47.495,14.885),(47.665,14.885),(47.665,14.715),(47.495,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,14.715),(47.855,14.885),(48.025,14.885),(48.025,14.715),(47.855,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.075),(46.775,15.245),(46.945,15.245),(46.945,15.075),(46.775,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.075),(47.135,15.245),(47.305,15.245),(47.305,15.075),(47.135,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.075),(47.495,15.245),(47.665,15.245),(47.665,15.075),(47.495,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.075),(47.855,15.245),(48.025,15.245),(48.025,15.075),(47.855,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.435),(46.775,15.605),(46.945,15.605),(46.945,15.435),(46.775,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.435),(47.135,15.605),(47.305,15.605),(47.305,15.435),(47.135,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.435),(47.495,15.605),(47.665,15.605),(47.665,15.435),(47.495,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.435),(47.855,15.605),(48.025,15.605),(48.025,15.435),(47.855,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,15.795),(46.775,15.965),(46.945,15.965),(46.945,15.795),(46.775,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,15.795),(47.135,15.965),(47.305,15.965),(47.305,15.795),(47.135,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,15.795),(47.495,15.965),(47.665,15.965),(47.665,15.795),(47.495,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,15.795),(47.855,15.965),(48.025,15.965),(48.025,15.795),(47.855,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.155),(46.775,16.325),(46.945,16.325),(46.945,16.155),(46.775,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.155),(47.135,16.325),(47.305,16.325),(47.305,16.155),(47.135,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.155),(47.495,16.325),(47.665,16.325),(47.665,16.155),(47.495,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.155),(47.855,16.325),(48.025,16.325),(48.025,16.155),(47.855,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.515),(46.775,16.685),(46.945,16.685),(46.945,16.515),(46.775,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.515),(47.135,16.685),(47.305,16.685),(47.305,16.515),(47.135,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.515),(47.495,16.685),(47.665,16.685),(47.665,16.515),(47.495,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.515),(47.855,16.685),(48.025,16.685),(48.025,16.515),(47.855,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,16.875),(46.775,17.045),(46.945,17.045),(46.945,16.875),(46.775,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,16.875),(47.135,17.045),(47.305,17.045),(47.305,16.875),(47.135,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,16.875),(47.495,17.045),(47.665,17.045),(47.665,16.875),(47.495,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,16.875),(47.855,17.045),(48.025,17.045),(48.025,16.875),(47.855,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.235),(46.775,17.405),(46.945,17.405),(46.945,17.235),(46.775,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.235),(47.135,17.405),(47.305,17.405),(47.305,17.235),(47.135,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.235),(47.495,17.405),(47.665,17.405),(47.665,17.235),(47.495,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.235),(47.855,17.405),(48.025,17.405),(48.025,17.235),(47.855,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.595),(46.775,17.765),(46.945,17.765),(46.945,17.595),(46.775,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.595),(47.135,17.765),(47.305,17.765),(47.305,17.595),(47.135,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.595),(47.495,17.765),(47.665,17.765),(47.665,17.595),(47.495,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.595),(47.855,17.765),(48.025,17.765),(48.025,17.595),(47.855,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,17.955),(46.775,18.125),(46.945,18.125),(46.945,17.955),(46.775,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,17.955),(47.135,18.125),(47.305,18.125),(47.305,17.955),(47.135,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,17.955),(47.495,18.125),(47.665,18.125),(47.665,17.955),(47.495,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,17.955),(47.855,18.125),(48.025,18.125),(48.025,17.955),(47.855,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.315),(46.775,18.485),(46.945,18.485),(46.945,18.315),(46.775,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.315),(47.135,18.485),(47.305,18.485),(47.305,18.315),(47.135,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.315),(47.495,18.485),(47.665,18.485),(47.665,18.315),(47.495,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.315),(47.855,18.485),(48.025,18.485),(48.025,18.315),(47.855,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,18.675),(46.775,18.845),(46.945,18.845),(46.945,18.675),(46.775,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,18.675),(47.135,18.845),(47.305,18.845),(47.305,18.675),(47.135,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,18.675),(47.495,18.845),(47.665,18.845),(47.665,18.675),(47.495,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,18.675),(47.855,18.845),(48.025,18.845),(48.025,18.675),(47.855,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.035),(46.775,19.205),(46.945,19.205),(46.945,19.035),(46.775,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.035),(47.135,19.205),(47.305,19.205),(47.305,19.035),(47.135,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.035),(47.495,19.205),(47.665,19.205),(47.665,19.035),(47.495,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.035),(47.855,19.205),(48.025,19.205),(48.025,19.035),(47.855,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.395),(46.775,19.565),(46.945,19.565),(46.945,19.395),(46.775,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.395),(47.135,19.565),(47.305,19.565),(47.305,19.395),(47.135,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.395),(47.495,19.565),(47.665,19.565),(47.665,19.395),(47.495,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.395),(47.855,19.565),(48.025,19.565),(48.025,19.395),(47.855,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,19.755),(46.775,19.925),(46.945,19.925),(46.945,19.755),(46.775,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,19.755),(47.135,19.925),(47.305,19.925),(47.305,19.755),(47.135,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,19.755),(47.495,19.925),(47.665,19.925),(47.665,19.755),(47.495,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,19.755),(47.855,19.925),(48.025,19.925),(48.025,19.755),(47.855,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.115),(46.775,20.285),(46.945,20.285),(46.945,20.115),(46.775,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.115),(47.135,20.285),(47.305,20.285),(47.305,20.115),(47.135,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.115),(47.495,20.285),(47.665,20.285),(47.665,20.115),(47.495,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.115),(47.855,20.285),(48.025,20.285),(48.025,20.115),(47.855,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.475),(46.775,20.645),(46.945,20.645),(46.945,20.475),(46.775,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.475),(47.135,20.645),(47.305,20.645),(47.305,20.475),(47.135,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.475),(47.495,20.645),(47.665,20.645),(47.665,20.475),(47.495,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.475),(47.855,20.645),(48.025,20.645),(48.025,20.475),(47.855,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,20.835),(46.775,21.005),(46.945,21.005),(46.945,20.835),(46.775,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,20.835),(47.135,21.005),(47.305,21.005),(47.305,20.835),(47.135,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,20.835),(47.495,21.005),(47.665,21.005),(47.665,20.835),(47.495,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,20.835),(47.855,21.005),(48.025,21.005),(48.025,20.835),(47.855,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.195),(46.775,21.365),(46.945,21.365),(46.945,21.195),(46.775,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.195),(47.135,21.365),(47.305,21.365),(47.305,21.195),(47.135,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.195),(47.495,21.365),(47.665,21.365),(47.665,21.195),(47.495,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.195),(47.855,21.365),(48.025,21.365),(48.025,21.195),(47.855,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.555),(46.775,21.725),(46.945,21.725),(46.945,21.555),(46.775,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.555),(47.135,21.725),(47.305,21.725),(47.305,21.555),(47.135,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.555),(47.495,21.725),(47.665,21.725),(47.665,21.555),(47.495,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.555),(47.855,21.725),(48.025,21.725),(48.025,21.555),(47.855,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,21.915),(46.775,22.085),(46.945,22.085),(46.945,21.915),(46.775,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,21.915),(47.135,22.085),(47.305,22.085),(47.305,21.915),(47.135,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,21.915),(47.495,22.085),(47.665,22.085),(47.665,21.915),(47.495,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,21.915),(47.855,22.085),(48.025,22.085),(48.025,21.915),(47.855,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.275),(46.775,22.445),(46.945,22.445),(46.945,22.275),(46.775,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.275),(47.135,22.445),(47.305,22.445),(47.305,22.275),(47.135,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.275),(47.495,22.445),(47.665,22.445),(47.665,22.275),(47.495,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.275),(47.855,22.445),(48.025,22.445),(48.025,22.275),(47.855,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.635),(46.775,22.805),(46.945,22.805),(46.945,22.635),(46.775,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.635),(47.135,22.805),(47.305,22.805),(47.305,22.635),(47.135,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.635),(47.495,22.805),(47.665,22.805),(47.665,22.635),(47.495,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.635),(47.855,22.805),(48.025,22.805),(48.025,22.635),(47.855,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,22.995),(46.775,23.165),(46.945,23.165),(46.945,22.995),(46.775,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,22.995),(47.135,23.165),(47.305,23.165),(47.305,22.995),(47.135,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,22.995),(47.495,23.165),(47.665,23.165),(47.665,22.995),(47.495,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,22.995),(47.855,23.165),(48.025,23.165),(48.025,22.995),(47.855,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,23.355),(46.775,23.525),(46.945,23.525),(46.945,23.355),(46.775,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,23.355),(47.135,23.525),(47.305,23.525),(47.305,23.355),(47.135,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,23.355),(47.495,23.525),(47.665,23.525),(47.665,23.355),(47.495,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,23.355),(47.855,23.525),(48.025,23.525),(48.025,23.355),(47.855,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,23.715),(46.775,23.885),(46.945,23.885),(46.945,23.715),(46.775,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,23.715),(47.135,23.885),(47.305,23.885),(47.305,23.715),(47.135,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,23.715),(47.495,23.885),(47.665,23.885),(47.665,23.715),(47.495,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,23.715),(47.855,23.885),(48.025,23.885),(48.025,23.715),(47.855,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.075),(46.775,24.245),(46.945,24.245),(46.945,24.075),(46.775,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.075),(47.135,24.245),(47.305,24.245),(47.305,24.075),(47.135,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.075),(47.495,24.245),(47.665,24.245),(47.665,24.075),(47.495,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.075),(47.855,24.245),(48.025,24.245),(48.025,24.075),(47.855,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.435),(46.775,24.605),(46.945,24.605),(46.945,24.435),(46.775,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.435),(47.135,24.605),(47.305,24.605),(47.305,24.435),(47.135,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.435),(47.495,24.605),(47.665,24.605),(47.665,24.435),(47.495,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.435),(47.855,24.605),(48.025,24.605),(48.025,24.435),(47.855,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,24.795),(46.775,24.965),(46.945,24.965),(46.945,24.795),(46.775,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,24.795),(47.135,24.965),(47.305,24.965),(47.305,24.795),(47.135,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,24.795),(47.495,24.965),(47.665,24.965),(47.665,24.795),(47.495,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,24.795),(47.855,24.965),(48.025,24.965),(48.025,24.795),(47.855,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.155),(46.775,25.325),(46.945,25.325),(46.945,25.155),(46.775,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.155),(47.135,25.325),(47.305,25.325),(47.305,25.155),(47.135,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.155),(47.495,25.325),(47.665,25.325),(47.665,25.155),(47.495,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.155),(47.855,25.325),(48.025,25.325),(48.025,25.155),(47.855,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.515),(46.775,25.685),(46.945,25.685),(46.945,25.515),(46.775,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.515),(47.135,25.685),(47.305,25.685),(47.305,25.515),(47.135,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.515),(47.495,25.685),(47.665,25.685),(47.665,25.515),(47.495,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.515),(47.855,25.685),(48.025,25.685),(48.025,25.515),(47.855,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,25.875),(46.775,26.045),(46.945,26.045),(46.945,25.875),(46.775,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,25.875),(47.135,26.045),(47.305,26.045),(47.305,25.875),(47.135,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,25.875),(47.495,26.045),(47.665,26.045),(47.665,25.875),(47.495,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,25.875),(47.855,26.045),(48.025,26.045),(48.025,25.875),(47.855,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.235),(46.775,26.405),(46.945,26.405),(46.945,26.235),(46.775,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.235),(47.135,26.405),(47.305,26.405),(47.305,26.235),(47.135,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.235),(47.495,26.405),(47.665,26.405),(47.665,26.235),(47.495,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.235),(47.855,26.405),(48.025,26.405),(48.025,26.235),(47.855,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.595),(46.775,26.765),(46.945,26.765),(46.945,26.595),(46.775,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.595),(47.135,26.765),(47.305,26.765),(47.305,26.595),(47.135,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.595),(47.495,26.765),(47.665,26.765),(47.665,26.595),(47.495,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.595),(47.855,26.765),(48.025,26.765),(48.025,26.595),(47.855,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,26.955),(46.775,27.125),(46.945,27.125),(46.945,26.955),(46.775,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,26.955),(47.135,27.125),(47.305,27.125),(47.305,26.955),(47.135,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,26.955),(47.495,27.125),(47.665,27.125),(47.665,26.955),(47.495,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,26.955),(47.855,27.125),(48.025,27.125),(48.025,26.955),(47.855,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,27.315),(46.775,27.485),(46.945,27.485),(46.945,27.315),(46.775,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,27.315),(47.135,27.485),(47.305,27.485),(47.305,27.315),(47.135,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,27.315),(47.495,27.485),(47.665,27.485),(47.665,27.315),(47.495,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,27.315),(47.855,27.485),(48.025,27.485),(48.025,27.315),(47.855,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,27.675),(46.775,27.845),(46.945,27.845),(46.945,27.675),(46.775,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,27.675),(47.135,27.845),(47.305,27.845),(47.305,27.675),(47.135,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,27.675),(47.495,27.845),(47.665,27.845),(47.665,27.675),(47.495,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,27.675),(47.855,27.845),(48.025,27.845),(48.025,27.675),(47.855,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.035),(46.775,28.205),(46.945,28.205),(46.945,28.035),(46.775,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.035),(47.135,28.205),(47.305,28.205),(47.305,28.035),(47.135,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.035),(47.495,28.205),(47.665,28.205),(47.665,28.035),(47.495,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.035),(47.855,28.205),(48.025,28.205),(48.025,28.035),(47.855,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.395),(46.775,28.565),(46.945,28.565),(46.945,28.395),(46.775,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.395),(47.135,28.565),(47.305,28.565),(47.305,28.395),(47.135,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.395),(47.495,28.565),(47.665,28.565),(47.665,28.395),(47.495,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.395),(47.855,28.565),(48.025,28.565),(48.025,28.395),(47.855,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,28.755),(46.775,28.925),(46.945,28.925),(46.945,28.755),(46.775,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,28.755),(47.135,28.925),(47.305,28.925),(47.305,28.755),(47.135,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,28.755),(47.495,28.925),(47.665,28.925),(47.665,28.755),(47.495,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,28.755),(47.855,28.925),(48.025,28.925),(48.025,28.755),(47.855,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.115),(46.775,29.285),(46.945,29.285),(46.945,29.115),(46.775,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.115),(47.135,29.285),(47.305,29.285),(47.305,29.115),(47.135,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.115),(47.495,29.285),(47.665,29.285),(47.665,29.115),(47.495,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.115),(47.855,29.285),(48.025,29.285),(48.025,29.115),(47.855,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.475),(46.775,29.645),(46.945,29.645),(46.945,29.475),(46.775,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.475),(47.135,29.645),(47.305,29.645),(47.305,29.475),(47.135,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.475),(47.495,29.645),(47.665,29.645),(47.665,29.475),(47.495,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.475),(47.855,29.645),(48.025,29.645),(48.025,29.475),(47.855,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,29.835),(46.775,30.005),(46.945,30.005),(46.945,29.835),(46.775,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,29.835),(47.135,30.005),(47.305,30.005),(47.305,29.835),(47.135,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,29.835),(47.495,30.005),(47.665,30.005),(47.665,29.835),(47.495,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,29.835),(47.855,30.005),(48.025,30.005),(48.025,29.835),(47.855,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.195),(46.775,30.365),(46.945,30.365),(46.945,30.195),(46.775,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.195),(47.135,30.365),(47.305,30.365),(47.305,30.195),(47.135,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.195),(47.495,30.365),(47.665,30.365),(47.665,30.195),(47.495,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.195),(47.855,30.365),(48.025,30.365),(48.025,30.195),(47.855,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.555),(46.775,30.725),(46.945,30.725),(46.945,30.555),(46.775,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.555),(47.135,30.725),(47.305,30.725),(47.305,30.555),(47.135,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.555),(47.495,30.725),(47.665,30.725),(47.665,30.555),(47.495,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.555),(47.855,30.725),(48.025,30.725),(48.025,30.555),(47.855,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,30.915),(46.775,31.085),(46.945,31.085),(46.945,30.915),(46.775,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,30.915),(47.135,31.085),(47.305,31.085),(47.305,30.915),(47.135,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,30.915),(47.495,31.085),(47.665,31.085),(47.665,30.915),(47.495,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,30.915),(47.855,31.085),(48.025,31.085),(48.025,30.915),(47.855,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.275),(46.775,31.445),(46.945,31.445),(46.945,31.275),(46.775,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.275),(47.135,31.445),(47.305,31.445),(47.305,31.275),(47.135,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.275),(47.495,31.445),(47.665,31.445),(47.665,31.275),(47.495,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.275),(47.855,31.445),(48.025,31.445),(48.025,31.275),(47.855,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.635),(46.775,31.805),(46.945,31.805),(46.945,31.635),(46.775,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.635),(47.135,31.805),(47.305,31.805),(47.305,31.635),(47.135,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.635),(47.495,31.805),(47.665,31.805),(47.665,31.635),(47.495,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.635),(47.855,31.805),(48.025,31.805),(48.025,31.635),(47.855,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,31.995),(46.775,32.165),(46.945,32.165),(46.945,31.995),(46.775,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,31.995),(47.135,32.165),(47.305,32.165),(47.305,31.995),(47.135,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,31.995),(47.495,32.165),(47.665,32.165),(47.665,31.995),(47.495,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,31.995),(47.855,32.165),(48.025,32.165),(48.025,31.995),(47.855,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,32.355),(46.775,32.525),(46.945,32.525),(46.945,32.355),(46.775,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,32.355),(47.135,32.525),(47.305,32.525),(47.305,32.355),(47.135,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,32.355),(47.495,32.525),(47.665,32.525),(47.665,32.355),(47.495,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,32.355),(47.855,32.525),(48.025,32.525),(48.025,32.355),(47.855,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,32.715),(46.775,32.885),(46.945,32.885),(46.945,32.715),(46.775,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,32.715),(47.135,32.885),(47.305,32.885),(47.305,32.715),(47.135,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,32.715),(47.495,32.885),(47.665,32.885),(47.665,32.715),(47.495,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,32.715),(47.855,32.885),(48.025,32.885),(48.025,32.715),(47.855,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.075),(46.775,33.245),(46.945,33.245),(46.945,33.075),(46.775,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.075),(47.135,33.245),(47.305,33.245),(47.305,33.075),(47.135,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.075),(47.495,33.245),(47.665,33.245),(47.665,33.075),(47.495,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.075),(47.855,33.245),(48.025,33.245),(48.025,33.075),(47.855,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.435),(46.775,33.605),(46.945,33.605),(46.945,33.435),(46.775,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.435),(47.135,33.605),(47.305,33.605),(47.305,33.435),(47.135,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.435),(47.495,33.605),(47.665,33.605),(47.665,33.435),(47.495,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.435),(47.855,33.605),(48.025,33.605),(48.025,33.435),(47.855,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,33.795),(46.775,33.965),(46.945,33.965),(46.945,33.795),(46.775,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,33.795),(47.135,33.965),(47.305,33.965),(47.305,33.795),(47.135,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,33.795),(47.495,33.965),(47.665,33.965),(47.665,33.795),(47.495,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,33.795),(47.855,33.965),(48.025,33.965),(48.025,33.795),(47.855,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.155),(46.775,34.325),(46.945,34.325),(46.945,34.155),(46.775,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.155),(47.135,34.325),(47.305,34.325),(47.305,34.155),(47.135,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.155),(47.495,34.325),(47.665,34.325),(47.665,34.155),(47.495,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.155),(47.855,34.325),(48.025,34.325),(48.025,34.155),(47.855,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.515),(46.775,34.685),(46.945,34.685),(46.945,34.515),(46.775,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.515),(47.135,34.685),(47.305,34.685),(47.305,34.515),(47.135,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.515),(47.495,34.685),(47.665,34.685),(47.665,34.515),(47.495,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.515),(47.855,34.685),(48.025,34.685),(48.025,34.515),(47.855,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,34.875),(46.775,35.045),(46.945,35.045),(46.945,34.875),(46.775,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,34.875),(47.135,35.045),(47.305,35.045),(47.305,34.875),(47.135,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,34.875),(47.495,35.045),(47.665,35.045),(47.665,34.875),(47.495,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,34.875),(47.855,35.045),(48.025,35.045),(48.025,34.875),(47.855,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.235),(46.775,35.405),(46.945,35.405),(46.945,35.235),(46.775,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.235),(47.135,35.405),(47.305,35.405),(47.305,35.235),(47.135,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.235),(47.495,35.405),(47.665,35.405),(47.665,35.235),(47.495,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.235),(47.855,35.405),(48.025,35.405),(48.025,35.235),(47.855,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.595),(46.775,35.765),(46.945,35.765),(46.945,35.595),(46.775,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.595),(47.135,35.765),(47.305,35.765),(47.305,35.595),(47.135,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.595),(47.495,35.765),(47.665,35.765),(47.665,35.595),(47.495,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.595),(47.855,35.765),(48.025,35.765),(48.025,35.595),(47.855,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,35.955),(46.775,36.125),(46.945,36.125),(46.945,35.955),(46.775,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,35.955),(47.135,36.125),(47.305,36.125),(47.305,35.955),(47.135,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,35.955),(47.495,36.125),(47.665,36.125),(47.665,35.955),(47.495,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,35.955),(47.855,36.125),(48.025,36.125),(48.025,35.955),(47.855,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,36.315),(46.775,36.485),(46.945,36.485),(46.945,36.315),(46.775,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,36.315),(47.135,36.485),(47.305,36.485),(47.305,36.315),(47.135,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,36.315),(47.495,36.485),(47.665,36.485),(47.665,36.315),(47.495,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,36.315),(47.855,36.485),(48.025,36.485),(48.025,36.315),(47.855,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,36.675),(46.775,36.845),(46.945,36.845),(46.945,36.675),(46.775,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,36.675),(47.135,36.845),(47.305,36.845),(47.305,36.675),(47.135,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,36.675),(47.495,36.845),(47.665,36.845),(47.665,36.675),(47.495,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,36.675),(47.855,36.845),(48.025,36.845),(48.025,36.675),(47.855,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.035),(46.775,37.205),(46.945,37.205),(46.945,37.035),(46.775,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.035),(47.135,37.205),(47.305,37.205),(47.305,37.035),(47.135,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.035),(47.495,37.205),(47.665,37.205),(47.665,37.035),(47.495,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.035),(47.855,37.205),(48.025,37.205),(48.025,37.035),(47.855,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.395),(46.775,37.565),(46.945,37.565),(46.945,37.395),(46.775,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.395),(47.135,37.565),(47.305,37.565),(47.305,37.395),(47.135,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.395),(47.495,37.565),(47.665,37.565),(47.665,37.395),(47.495,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.395),(47.855,37.565),(48.025,37.565),(48.025,37.395),(47.855,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,37.755),(46.775,37.925),(46.945,37.925),(46.945,37.755),(46.775,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,37.755),(47.135,37.925),(47.305,37.925),(47.305,37.755),(47.135,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,37.755),(47.495,37.925),(47.665,37.925),(47.665,37.755),(47.495,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,37.755),(47.855,37.925),(48.025,37.925),(48.025,37.755),(47.855,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.115),(46.775,38.285),(46.945,38.285),(46.945,38.115),(46.775,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.115),(47.135,38.285),(47.305,38.285),(47.305,38.115),(47.135,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.115),(47.495,38.285),(47.665,38.285),(47.665,38.115),(47.495,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.115),(47.855,38.285),(48.025,38.285),(48.025,38.115),(47.855,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.475),(46.775,38.645),(46.945,38.645),(46.945,38.475),(46.775,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.475),(47.135,38.645),(47.305,38.645),(47.305,38.475),(47.135,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.475),(47.495,38.645),(47.665,38.645),(47.665,38.475),(47.495,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.475),(47.855,38.645),(48.025,38.645),(48.025,38.475),(47.855,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,38.835),(46.775,39.005),(46.945,39.005),(46.945,38.835),(46.775,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,38.835),(47.135,39.005),(47.305,39.005),(47.305,38.835),(47.135,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,38.835),(47.495,39.005),(47.665,39.005),(47.665,38.835),(47.495,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,38.835),(47.855,39.005),(48.025,39.005),(48.025,38.835),(47.855,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.195),(46.775,39.365),(46.945,39.365),(46.945,39.195),(46.775,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.195),(47.135,39.365),(47.305,39.365),(47.305,39.195),(47.135,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.195),(47.495,39.365),(47.665,39.365),(47.665,39.195),(47.495,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.195),(47.855,39.365),(48.025,39.365),(48.025,39.195),(47.855,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.555),(46.775,39.725),(46.945,39.725),(46.945,39.555),(46.775,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.555),(47.135,39.725),(47.305,39.725),(47.305,39.555),(47.135,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.555),(47.495,39.725),(47.665,39.725),(47.665,39.555),(47.495,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.555),(47.855,39.725),(48.025,39.725),(48.025,39.555),(47.855,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,39.915),(46.775,40.085),(46.945,40.085),(46.945,39.915),(46.775,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,39.915),(47.135,40.085),(47.305,40.085),(47.305,39.915),(47.135,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,39.915),(47.495,40.085),(47.665,40.085),(47.665,39.915),(47.495,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,39.915),(47.855,40.085),(48.025,40.085),(48.025,39.915),(47.855,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,40.275),(46.775,40.445),(46.945,40.445),(46.945,40.275),(46.775,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,40.275),(47.135,40.445),(47.305,40.445),(47.305,40.275),(47.135,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,40.275),(47.495,40.445),(47.665,40.445),(47.665,40.275),(47.495,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,40.275),(47.855,40.445),(48.025,40.445),(48.025,40.275),(47.855,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((46.775,40.635),(46.775,40.805),(46.945,40.805),(46.945,40.635),(46.775,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.135,40.635),(47.135,40.805),(47.305,40.805),(47.305,40.635),(47.135,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.495,40.635),(47.495,40.805),(47.665,40.805),(47.665,40.635),(47.495,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((47.855,40.635),(47.855,40.805),(48.025,40.805),(48.025,40.635),(47.855,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,2.835),(56.375,3.005),(56.545,3.005),(56.545,2.835),(56.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,2.835),(56.735,3.005),(56.905,3.005),(56.905,2.835),(56.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,2.835),(57.095,3.005),(57.265,3.005),(57.265,2.835),(57.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,2.835),(57.455,3.005),(57.625,3.005),(57.625,2.835),(57.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.195),(56.375,3.365),(56.545,3.365),(56.545,3.195),(56.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.195),(56.735,3.365),(56.905,3.365),(56.905,3.195),(56.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.195),(57.095,3.365),(57.265,3.365),(57.265,3.195),(57.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.195),(57.455,3.365),(57.625,3.365),(57.625,3.195),(57.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.555),(56.375,3.725),(56.545,3.725),(56.545,3.555),(56.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.555),(56.735,3.725),(56.905,3.725),(56.905,3.555),(56.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.555),(57.095,3.725),(57.265,3.725),(57.265,3.555),(57.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.555),(57.455,3.725),(57.625,3.725),(57.625,3.555),(57.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,3.915),(56.375,4.085),(56.545,4.085),(56.545,3.915),(56.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,3.915),(56.735,4.085),(56.905,4.085),(56.905,3.915),(56.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,3.915),(57.095,4.085),(57.265,4.085),(57.265,3.915),(57.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,3.915),(57.455,4.085),(57.625,4.085),(57.625,3.915),(57.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.275),(56.375,4.445),(56.545,4.445),(56.545,4.275),(56.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.275),(56.735,4.445),(56.905,4.445),(56.905,4.275),(56.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.275),(57.095,4.445),(57.265,4.445),(57.265,4.275),(57.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.275),(57.455,4.445),(57.625,4.445),(57.625,4.275),(57.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.635),(56.375,4.805),(56.545,4.805),(56.545,4.635),(56.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.635),(56.735,4.805),(56.905,4.805),(56.905,4.635),(56.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.635),(57.095,4.805),(57.265,4.805),(57.265,4.635),(57.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.635),(57.455,4.805),(57.625,4.805),(57.625,4.635),(57.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,4.995),(56.375,5.165),(56.545,5.165),(56.545,4.995),(56.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,4.995),(56.735,5.165),(56.905,5.165),(56.905,4.995),(56.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,4.995),(57.095,5.165),(57.265,5.165),(57.265,4.995),(57.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,4.995),(57.455,5.165),(57.625,5.165),(57.625,4.995),(57.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.355),(56.375,5.525),(56.545,5.525),(56.545,5.355),(56.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.355),(56.735,5.525),(56.905,5.525),(56.905,5.355),(56.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.355),(57.095,5.525),(57.265,5.525),(57.265,5.355),(57.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.355),(57.455,5.525),(57.625,5.525),(57.625,5.355),(57.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,5.715),(56.375,5.885),(56.545,5.885),(56.545,5.715),(56.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,5.715),(56.735,5.885),(56.905,5.885),(56.905,5.715),(56.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,5.715),(57.095,5.885),(57.265,5.885),(57.265,5.715),(57.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,5.715),(57.455,5.885),(57.625,5.885),(57.625,5.715),(57.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.075),(56.375,6.245),(56.545,6.245),(56.545,6.075),(56.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.075),(56.735,6.245),(56.905,6.245),(56.905,6.075),(56.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.075),(57.095,6.245),(57.265,6.245),(57.265,6.075),(57.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.075),(57.455,6.245),(57.625,6.245),(57.625,6.075),(57.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.435),(56.375,6.605),(56.545,6.605),(56.545,6.435),(56.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.435),(56.735,6.605),(56.905,6.605),(56.905,6.435),(56.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.435),(57.095,6.605),(57.265,6.605),(57.265,6.435),(57.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.435),(57.455,6.605),(57.625,6.605),(57.625,6.435),(57.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,6.795),(56.375,6.965),(56.545,6.965),(56.545,6.795),(56.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,6.795),(56.735,6.965),(56.905,6.965),(56.905,6.795),(56.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,6.795),(57.095,6.965),(57.265,6.965),(57.265,6.795),(57.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,6.795),(57.455,6.965),(57.625,6.965),(57.625,6.795),(57.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.155),(56.375,7.325),(56.545,7.325),(56.545,7.155),(56.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.155),(56.735,7.325),(56.905,7.325),(56.905,7.155),(56.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.155),(57.095,7.325),(57.265,7.325),(57.265,7.155),(57.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.155),(57.455,7.325),(57.625,7.325),(57.625,7.155),(57.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.515),(56.375,7.685),(56.545,7.685),(56.545,7.515),(56.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.515),(56.735,7.685),(56.905,7.685),(56.905,7.515),(56.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.515),(57.095,7.685),(57.265,7.685),(57.265,7.515),(57.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.515),(57.455,7.685),(57.625,7.685),(57.625,7.515),(57.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,7.875),(56.375,8.045),(56.545,8.045),(56.545,7.875),(56.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,7.875),(56.735,8.045),(56.905,8.045),(56.905,7.875),(56.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,7.875),(57.095,8.045),(57.265,8.045),(57.265,7.875),(57.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,7.875),(57.455,8.045),(57.625,8.045),(57.625,7.875),(57.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.235),(56.375,8.405),(56.545,8.405),(56.545,8.235),(56.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.235),(56.735,8.405),(56.905,8.405),(56.905,8.235),(56.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.235),(57.095,8.405),(57.265,8.405),(57.265,8.235),(57.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.235),(57.455,8.405),(57.625,8.405),(57.625,8.235),(57.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.595),(56.375,8.765),(56.545,8.765),(56.545,8.595),(56.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.595),(56.735,8.765),(56.905,8.765),(56.905,8.595),(56.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.595),(57.095,8.765),(57.265,8.765),(57.265,8.595),(57.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.595),(57.455,8.765),(57.625,8.765),(57.625,8.595),(57.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,8.955),(56.375,9.125),(56.545,9.125),(56.545,8.955),(56.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,8.955),(56.735,9.125),(56.905,9.125),(56.905,8.955),(56.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,8.955),(57.095,9.125),(57.265,9.125),(57.265,8.955),(57.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,8.955),(57.455,9.125),(57.625,9.125),(57.625,8.955),(57.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.315),(56.375,9.485),(56.545,9.485),(56.545,9.315),(56.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.315),(56.735,9.485),(56.905,9.485),(56.905,9.315),(56.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.315),(57.095,9.485),(57.265,9.485),(57.265,9.315),(57.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.315),(57.455,9.485),(57.625,9.485),(57.625,9.315),(57.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,9.675),(56.375,9.845),(56.545,9.845),(56.545,9.675),(56.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,9.675),(56.735,9.845),(56.905,9.845),(56.905,9.675),(56.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,9.675),(57.095,9.845),(57.265,9.845),(57.265,9.675),(57.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,9.675),(57.455,9.845),(57.625,9.845),(57.625,9.675),(57.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.035),(56.375,10.205),(56.545,10.205),(56.545,10.035),(56.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.035),(56.735,10.205),(56.905,10.205),(56.905,10.035),(56.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.035),(57.095,10.205),(57.265,10.205),(57.265,10.035),(57.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.035),(57.455,10.205),(57.625,10.205),(57.625,10.035),(57.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.395),(56.375,10.565),(56.545,10.565),(56.545,10.395),(56.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.395),(56.735,10.565),(56.905,10.565),(56.905,10.395),(56.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.395),(57.095,10.565),(57.265,10.565),(57.265,10.395),(57.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.395),(57.455,10.565),(57.625,10.565),(57.625,10.395),(57.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,10.755),(56.375,10.925),(56.545,10.925),(56.545,10.755),(56.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,10.755),(56.735,10.925),(56.905,10.925),(56.905,10.755),(56.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,10.755),(57.095,10.925),(57.265,10.925),(57.265,10.755),(57.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,10.755),(57.455,10.925),(57.625,10.925),(57.625,10.755),(57.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.115),(56.375,11.285),(56.545,11.285),(56.545,11.115),(56.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.115),(56.735,11.285),(56.905,11.285),(56.905,11.115),(56.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.115),(57.095,11.285),(57.265,11.285),(57.265,11.115),(57.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.115),(57.455,11.285),(57.625,11.285),(57.625,11.115),(57.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.475),(56.375,11.645),(56.545,11.645),(56.545,11.475),(56.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.475),(56.735,11.645),(56.905,11.645),(56.905,11.475),(56.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.475),(57.095,11.645),(57.265,11.645),(57.265,11.475),(57.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.475),(57.455,11.645),(57.625,11.645),(57.625,11.475),(57.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,11.835),(56.375,12.005),(56.545,12.005),(56.545,11.835),(56.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,11.835),(56.735,12.005),(56.905,12.005),(56.905,11.835),(56.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,11.835),(57.095,12.005),(57.265,12.005),(57.265,11.835),(57.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,11.835),(57.455,12.005),(57.625,12.005),(57.625,11.835),(57.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.195),(56.375,12.365),(56.545,12.365),(56.545,12.195),(56.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.195),(56.735,12.365),(56.905,12.365),(56.905,12.195),(56.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.195),(57.095,12.365),(57.265,12.365),(57.265,12.195),(57.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.195),(57.455,12.365),(57.625,12.365),(57.625,12.195),(57.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.555),(56.375,12.725),(56.545,12.725),(56.545,12.555),(56.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.555),(56.735,12.725),(56.905,12.725),(56.905,12.555),(56.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.555),(57.095,12.725),(57.265,12.725),(57.265,12.555),(57.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.555),(57.455,12.725),(57.625,12.725),(57.625,12.555),(57.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,12.915),(56.375,13.085),(56.545,13.085),(56.545,12.915),(56.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,12.915),(56.735,13.085),(56.905,13.085),(56.905,12.915),(56.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,12.915),(57.095,13.085),(57.265,13.085),(57.265,12.915),(57.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,12.915),(57.455,13.085),(57.625,13.085),(57.625,12.915),(57.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.275),(56.375,13.445),(56.545,13.445),(56.545,13.275),(56.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.275),(56.735,13.445),(56.905,13.445),(56.905,13.275),(56.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.275),(57.095,13.445),(57.265,13.445),(57.265,13.275),(57.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.275),(57.455,13.445),(57.625,13.445),(57.625,13.275),(57.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.635),(56.375,13.805),(56.545,13.805),(56.545,13.635),(56.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.635),(56.735,13.805),(56.905,13.805),(56.905,13.635),(56.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.635),(57.095,13.805),(57.265,13.805),(57.265,13.635),(57.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.635),(57.455,13.805),(57.625,13.805),(57.625,13.635),(57.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,13.995),(56.375,14.165),(56.545,14.165),(56.545,13.995),(56.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,13.995),(56.735,14.165),(56.905,14.165),(56.905,13.995),(56.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,13.995),(57.095,14.165),(57.265,14.165),(57.265,13.995),(57.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,13.995),(57.455,14.165),(57.625,14.165),(57.625,13.995),(57.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.355),(56.375,14.525),(56.545,14.525),(56.545,14.355),(56.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.355),(56.735,14.525),(56.905,14.525),(56.905,14.355),(56.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.355),(57.095,14.525),(57.265,14.525),(57.265,14.355),(57.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.355),(57.455,14.525),(57.625,14.525),(57.625,14.355),(57.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,14.715),(56.375,14.885),(56.545,14.885),(56.545,14.715),(56.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,14.715),(56.735,14.885),(56.905,14.885),(56.905,14.715),(56.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,14.715),(57.095,14.885),(57.265,14.885),(57.265,14.715),(57.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,14.715),(57.455,14.885),(57.625,14.885),(57.625,14.715),(57.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.075),(56.375,15.245),(56.545,15.245),(56.545,15.075),(56.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.075),(56.735,15.245),(56.905,15.245),(56.905,15.075),(56.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.075),(57.095,15.245),(57.265,15.245),(57.265,15.075),(57.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.075),(57.455,15.245),(57.625,15.245),(57.625,15.075),(57.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.435),(56.375,15.605),(56.545,15.605),(56.545,15.435),(56.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.435),(56.735,15.605),(56.905,15.605),(56.905,15.435),(56.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.435),(57.095,15.605),(57.265,15.605),(57.265,15.435),(57.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.435),(57.455,15.605),(57.625,15.605),(57.625,15.435),(57.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,15.795),(56.375,15.965),(56.545,15.965),(56.545,15.795),(56.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,15.795),(56.735,15.965),(56.905,15.965),(56.905,15.795),(56.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,15.795),(57.095,15.965),(57.265,15.965),(57.265,15.795),(57.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,15.795),(57.455,15.965),(57.625,15.965),(57.625,15.795),(57.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.155),(56.375,16.325),(56.545,16.325),(56.545,16.155),(56.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.155),(56.735,16.325),(56.905,16.325),(56.905,16.155),(56.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.155),(57.095,16.325),(57.265,16.325),(57.265,16.155),(57.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.155),(57.455,16.325),(57.625,16.325),(57.625,16.155),(57.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.515),(56.375,16.685),(56.545,16.685),(56.545,16.515),(56.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.515),(56.735,16.685),(56.905,16.685),(56.905,16.515),(56.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.515),(57.095,16.685),(57.265,16.685),(57.265,16.515),(57.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.515),(57.455,16.685),(57.625,16.685),(57.625,16.515),(57.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,16.875),(56.375,17.045),(56.545,17.045),(56.545,16.875),(56.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,16.875),(56.735,17.045),(56.905,17.045),(56.905,16.875),(56.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,16.875),(57.095,17.045),(57.265,17.045),(57.265,16.875),(57.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,16.875),(57.455,17.045),(57.625,17.045),(57.625,16.875),(57.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.235),(56.375,17.405),(56.545,17.405),(56.545,17.235),(56.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.235),(56.735,17.405),(56.905,17.405),(56.905,17.235),(56.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.235),(57.095,17.405),(57.265,17.405),(57.265,17.235),(57.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.235),(57.455,17.405),(57.625,17.405),(57.625,17.235),(57.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.595),(56.375,17.765),(56.545,17.765),(56.545,17.595),(56.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.595),(56.735,17.765),(56.905,17.765),(56.905,17.595),(56.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.595),(57.095,17.765),(57.265,17.765),(57.265,17.595),(57.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.595),(57.455,17.765),(57.625,17.765),(57.625,17.595),(57.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,17.955),(56.375,18.125),(56.545,18.125),(56.545,17.955),(56.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,17.955),(56.735,18.125),(56.905,18.125),(56.905,17.955),(56.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,17.955),(57.095,18.125),(57.265,18.125),(57.265,17.955),(57.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,17.955),(57.455,18.125),(57.625,18.125),(57.625,17.955),(57.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.315),(56.375,18.485),(56.545,18.485),(56.545,18.315),(56.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.315),(56.735,18.485),(56.905,18.485),(56.905,18.315),(56.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.315),(57.095,18.485),(57.265,18.485),(57.265,18.315),(57.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.315),(57.455,18.485),(57.625,18.485),(57.625,18.315),(57.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,18.675),(56.375,18.845),(56.545,18.845),(56.545,18.675),(56.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,18.675),(56.735,18.845),(56.905,18.845),(56.905,18.675),(56.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,18.675),(57.095,18.845),(57.265,18.845),(57.265,18.675),(57.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,18.675),(57.455,18.845),(57.625,18.845),(57.625,18.675),(57.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.035),(56.375,19.205),(56.545,19.205),(56.545,19.035),(56.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.035),(56.735,19.205),(56.905,19.205),(56.905,19.035),(56.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.035),(57.095,19.205),(57.265,19.205),(57.265,19.035),(57.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.035),(57.455,19.205),(57.625,19.205),(57.625,19.035),(57.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.395),(56.375,19.565),(56.545,19.565),(56.545,19.395),(56.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.395),(56.735,19.565),(56.905,19.565),(56.905,19.395),(56.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.395),(57.095,19.565),(57.265,19.565),(57.265,19.395),(57.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.395),(57.455,19.565),(57.625,19.565),(57.625,19.395),(57.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,19.755),(56.375,19.925),(56.545,19.925),(56.545,19.755),(56.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,19.755),(56.735,19.925),(56.905,19.925),(56.905,19.755),(56.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,19.755),(57.095,19.925),(57.265,19.925),(57.265,19.755),(57.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,19.755),(57.455,19.925),(57.625,19.925),(57.625,19.755),(57.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.115),(56.375,20.285),(56.545,20.285),(56.545,20.115),(56.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.115),(56.735,20.285),(56.905,20.285),(56.905,20.115),(56.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.115),(57.095,20.285),(57.265,20.285),(57.265,20.115),(57.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.115),(57.455,20.285),(57.625,20.285),(57.625,20.115),(57.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.475),(56.375,20.645),(56.545,20.645),(56.545,20.475),(56.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.475),(56.735,20.645),(56.905,20.645),(56.905,20.475),(56.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.475),(57.095,20.645),(57.265,20.645),(57.265,20.475),(57.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.475),(57.455,20.645),(57.625,20.645),(57.625,20.475),(57.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,20.835),(56.375,21.005),(56.545,21.005),(56.545,20.835),(56.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,20.835),(56.735,21.005),(56.905,21.005),(56.905,20.835),(56.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,20.835),(57.095,21.005),(57.265,21.005),(57.265,20.835),(57.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,20.835),(57.455,21.005),(57.625,21.005),(57.625,20.835),(57.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.195),(56.375,21.365),(56.545,21.365),(56.545,21.195),(56.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.195),(56.735,21.365),(56.905,21.365),(56.905,21.195),(56.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.195),(57.095,21.365),(57.265,21.365),(57.265,21.195),(57.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.195),(57.455,21.365),(57.625,21.365),(57.625,21.195),(57.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.555),(56.375,21.725),(56.545,21.725),(56.545,21.555),(56.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.555),(56.735,21.725),(56.905,21.725),(56.905,21.555),(56.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.555),(57.095,21.725),(57.265,21.725),(57.265,21.555),(57.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.555),(57.455,21.725),(57.625,21.725),(57.625,21.555),(57.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,21.915),(56.375,22.085),(56.545,22.085),(56.545,21.915),(56.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,21.915),(56.735,22.085),(56.905,22.085),(56.905,21.915),(56.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,21.915),(57.095,22.085),(57.265,22.085),(57.265,21.915),(57.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,21.915),(57.455,22.085),(57.625,22.085),(57.625,21.915),(57.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.275),(56.375,22.445),(56.545,22.445),(56.545,22.275),(56.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.275),(56.735,22.445),(56.905,22.445),(56.905,22.275),(56.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.275),(57.095,22.445),(57.265,22.445),(57.265,22.275),(57.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.275),(57.455,22.445),(57.625,22.445),(57.625,22.275),(57.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.635),(56.375,22.805),(56.545,22.805),(56.545,22.635),(56.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.635),(56.735,22.805),(56.905,22.805),(56.905,22.635),(56.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.635),(57.095,22.805),(57.265,22.805),(57.265,22.635),(57.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.635),(57.455,22.805),(57.625,22.805),(57.625,22.635),(57.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,22.995),(56.375,23.165),(56.545,23.165),(56.545,22.995),(56.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,22.995),(56.735,23.165),(56.905,23.165),(56.905,22.995),(56.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,22.995),(57.095,23.165),(57.265,23.165),(57.265,22.995),(57.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,22.995),(57.455,23.165),(57.625,23.165),(57.625,22.995),(57.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,23.355),(56.375,23.525),(56.545,23.525),(56.545,23.355),(56.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,23.355),(56.735,23.525),(56.905,23.525),(56.905,23.355),(56.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,23.355),(57.095,23.525),(57.265,23.525),(57.265,23.355),(57.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,23.355),(57.455,23.525),(57.625,23.525),(57.625,23.355),(57.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,23.715),(56.375,23.885),(56.545,23.885),(56.545,23.715),(56.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,23.715),(56.735,23.885),(56.905,23.885),(56.905,23.715),(56.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,23.715),(57.095,23.885),(57.265,23.885),(57.265,23.715),(57.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,23.715),(57.455,23.885),(57.625,23.885),(57.625,23.715),(57.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.075),(56.375,24.245),(56.545,24.245),(56.545,24.075),(56.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.075),(56.735,24.245),(56.905,24.245),(56.905,24.075),(56.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.075),(57.095,24.245),(57.265,24.245),(57.265,24.075),(57.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.075),(57.455,24.245),(57.625,24.245),(57.625,24.075),(57.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.435),(56.375,24.605),(56.545,24.605),(56.545,24.435),(56.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.435),(56.735,24.605),(56.905,24.605),(56.905,24.435),(56.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.435),(57.095,24.605),(57.265,24.605),(57.265,24.435),(57.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.435),(57.455,24.605),(57.625,24.605),(57.625,24.435),(57.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,24.795),(56.375,24.965),(56.545,24.965),(56.545,24.795),(56.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,24.795),(56.735,24.965),(56.905,24.965),(56.905,24.795),(56.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,24.795),(57.095,24.965),(57.265,24.965),(57.265,24.795),(57.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,24.795),(57.455,24.965),(57.625,24.965),(57.625,24.795),(57.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.155),(56.375,25.325),(56.545,25.325),(56.545,25.155),(56.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.155),(56.735,25.325),(56.905,25.325),(56.905,25.155),(56.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.155),(57.095,25.325),(57.265,25.325),(57.265,25.155),(57.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.155),(57.455,25.325),(57.625,25.325),(57.625,25.155),(57.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.515),(56.375,25.685),(56.545,25.685),(56.545,25.515),(56.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.515),(56.735,25.685),(56.905,25.685),(56.905,25.515),(56.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.515),(57.095,25.685),(57.265,25.685),(57.265,25.515),(57.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.515),(57.455,25.685),(57.625,25.685),(57.625,25.515),(57.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,25.875),(56.375,26.045),(56.545,26.045),(56.545,25.875),(56.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,25.875),(56.735,26.045),(56.905,26.045),(56.905,25.875),(56.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,25.875),(57.095,26.045),(57.265,26.045),(57.265,25.875),(57.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,25.875),(57.455,26.045),(57.625,26.045),(57.625,25.875),(57.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.235),(56.375,26.405),(56.545,26.405),(56.545,26.235),(56.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.235),(56.735,26.405),(56.905,26.405),(56.905,26.235),(56.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.235),(57.095,26.405),(57.265,26.405),(57.265,26.235),(57.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.235),(57.455,26.405),(57.625,26.405),(57.625,26.235),(57.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.595),(56.375,26.765),(56.545,26.765),(56.545,26.595),(56.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.595),(56.735,26.765),(56.905,26.765),(56.905,26.595),(56.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.595),(57.095,26.765),(57.265,26.765),(57.265,26.595),(57.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.595),(57.455,26.765),(57.625,26.765),(57.625,26.595),(57.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,26.955),(56.375,27.125),(56.545,27.125),(56.545,26.955),(56.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,26.955),(56.735,27.125),(56.905,27.125),(56.905,26.955),(56.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,26.955),(57.095,27.125),(57.265,27.125),(57.265,26.955),(57.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,26.955),(57.455,27.125),(57.625,27.125),(57.625,26.955),(57.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,27.315),(56.375,27.485),(56.545,27.485),(56.545,27.315),(56.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,27.315),(56.735,27.485),(56.905,27.485),(56.905,27.315),(56.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,27.315),(57.095,27.485),(57.265,27.485),(57.265,27.315),(57.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,27.315),(57.455,27.485),(57.625,27.485),(57.625,27.315),(57.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,27.675),(56.375,27.845),(56.545,27.845),(56.545,27.675),(56.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,27.675),(56.735,27.845),(56.905,27.845),(56.905,27.675),(56.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,27.675),(57.095,27.845),(57.265,27.845),(57.265,27.675),(57.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,27.675),(57.455,27.845),(57.625,27.845),(57.625,27.675),(57.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.035),(56.375,28.205),(56.545,28.205),(56.545,28.035),(56.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.035),(56.735,28.205),(56.905,28.205),(56.905,28.035),(56.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.035),(57.095,28.205),(57.265,28.205),(57.265,28.035),(57.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.035),(57.455,28.205),(57.625,28.205),(57.625,28.035),(57.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.395),(56.375,28.565),(56.545,28.565),(56.545,28.395),(56.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.395),(56.735,28.565),(56.905,28.565),(56.905,28.395),(56.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.395),(57.095,28.565),(57.265,28.565),(57.265,28.395),(57.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.395),(57.455,28.565),(57.625,28.565),(57.625,28.395),(57.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,28.755),(56.375,28.925),(56.545,28.925),(56.545,28.755),(56.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,28.755),(56.735,28.925),(56.905,28.925),(56.905,28.755),(56.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,28.755),(57.095,28.925),(57.265,28.925),(57.265,28.755),(57.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,28.755),(57.455,28.925),(57.625,28.925),(57.625,28.755),(57.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.115),(56.375,29.285),(56.545,29.285),(56.545,29.115),(56.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.115),(56.735,29.285),(56.905,29.285),(56.905,29.115),(56.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.115),(57.095,29.285),(57.265,29.285),(57.265,29.115),(57.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.115),(57.455,29.285),(57.625,29.285),(57.625,29.115),(57.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.475),(56.375,29.645),(56.545,29.645),(56.545,29.475),(56.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.475),(56.735,29.645),(56.905,29.645),(56.905,29.475),(56.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.475),(57.095,29.645),(57.265,29.645),(57.265,29.475),(57.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.475),(57.455,29.645),(57.625,29.645),(57.625,29.475),(57.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,29.835),(56.375,30.005),(56.545,30.005),(56.545,29.835),(56.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,29.835),(56.735,30.005),(56.905,30.005),(56.905,29.835),(56.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,29.835),(57.095,30.005),(57.265,30.005),(57.265,29.835),(57.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,29.835),(57.455,30.005),(57.625,30.005),(57.625,29.835),(57.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.195),(56.375,30.365),(56.545,30.365),(56.545,30.195),(56.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.195),(56.735,30.365),(56.905,30.365),(56.905,30.195),(56.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.195),(57.095,30.365),(57.265,30.365),(57.265,30.195),(57.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.195),(57.455,30.365),(57.625,30.365),(57.625,30.195),(57.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.555),(56.375,30.725),(56.545,30.725),(56.545,30.555),(56.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.555),(56.735,30.725),(56.905,30.725),(56.905,30.555),(56.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.555),(57.095,30.725),(57.265,30.725),(57.265,30.555),(57.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.555),(57.455,30.725),(57.625,30.725),(57.625,30.555),(57.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,30.915),(56.375,31.085),(56.545,31.085),(56.545,30.915),(56.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,30.915),(56.735,31.085),(56.905,31.085),(56.905,30.915),(56.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,30.915),(57.095,31.085),(57.265,31.085),(57.265,30.915),(57.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,30.915),(57.455,31.085),(57.625,31.085),(57.625,30.915),(57.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.275),(56.375,31.445),(56.545,31.445),(56.545,31.275),(56.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.275),(56.735,31.445),(56.905,31.445),(56.905,31.275),(56.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.275),(57.095,31.445),(57.265,31.445),(57.265,31.275),(57.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.275),(57.455,31.445),(57.625,31.445),(57.625,31.275),(57.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.635),(56.375,31.805),(56.545,31.805),(56.545,31.635),(56.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.635),(56.735,31.805),(56.905,31.805),(56.905,31.635),(56.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.635),(57.095,31.805),(57.265,31.805),(57.265,31.635),(57.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.635),(57.455,31.805),(57.625,31.805),(57.625,31.635),(57.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,31.995),(56.375,32.165),(56.545,32.165),(56.545,31.995),(56.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,31.995),(56.735,32.165),(56.905,32.165),(56.905,31.995),(56.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,31.995),(57.095,32.165),(57.265,32.165),(57.265,31.995),(57.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,31.995),(57.455,32.165),(57.625,32.165),(57.625,31.995),(57.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,32.355),(56.375,32.525),(56.545,32.525),(56.545,32.355),(56.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,32.355),(56.735,32.525),(56.905,32.525),(56.905,32.355),(56.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,32.355),(57.095,32.525),(57.265,32.525),(57.265,32.355),(57.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,32.355),(57.455,32.525),(57.625,32.525),(57.625,32.355),(57.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,32.715),(56.375,32.885),(56.545,32.885),(56.545,32.715),(56.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,32.715),(56.735,32.885),(56.905,32.885),(56.905,32.715),(56.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,32.715),(57.095,32.885),(57.265,32.885),(57.265,32.715),(57.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,32.715),(57.455,32.885),(57.625,32.885),(57.625,32.715),(57.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.075),(56.375,33.245),(56.545,33.245),(56.545,33.075),(56.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.075),(56.735,33.245),(56.905,33.245),(56.905,33.075),(56.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.075),(57.095,33.245),(57.265,33.245),(57.265,33.075),(57.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.075),(57.455,33.245),(57.625,33.245),(57.625,33.075),(57.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.435),(56.375,33.605),(56.545,33.605),(56.545,33.435),(56.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.435),(56.735,33.605),(56.905,33.605),(56.905,33.435),(56.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.435),(57.095,33.605),(57.265,33.605),(57.265,33.435),(57.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.435),(57.455,33.605),(57.625,33.605),(57.625,33.435),(57.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,33.795),(56.375,33.965),(56.545,33.965),(56.545,33.795),(56.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,33.795),(56.735,33.965),(56.905,33.965),(56.905,33.795),(56.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,33.795),(57.095,33.965),(57.265,33.965),(57.265,33.795),(57.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,33.795),(57.455,33.965),(57.625,33.965),(57.625,33.795),(57.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.155),(56.375,34.325),(56.545,34.325),(56.545,34.155),(56.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.155),(56.735,34.325),(56.905,34.325),(56.905,34.155),(56.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.155),(57.095,34.325),(57.265,34.325),(57.265,34.155),(57.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.155),(57.455,34.325),(57.625,34.325),(57.625,34.155),(57.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.515),(56.375,34.685),(56.545,34.685),(56.545,34.515),(56.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.515),(56.735,34.685),(56.905,34.685),(56.905,34.515),(56.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.515),(57.095,34.685),(57.265,34.685),(57.265,34.515),(57.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.515),(57.455,34.685),(57.625,34.685),(57.625,34.515),(57.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,34.875),(56.375,35.045),(56.545,35.045),(56.545,34.875),(56.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,34.875),(56.735,35.045),(56.905,35.045),(56.905,34.875),(56.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,34.875),(57.095,35.045),(57.265,35.045),(57.265,34.875),(57.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,34.875),(57.455,35.045),(57.625,35.045),(57.625,34.875),(57.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.235),(56.375,35.405),(56.545,35.405),(56.545,35.235),(56.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.235),(56.735,35.405),(56.905,35.405),(56.905,35.235),(56.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.235),(57.095,35.405),(57.265,35.405),(57.265,35.235),(57.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.235),(57.455,35.405),(57.625,35.405),(57.625,35.235),(57.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.595),(56.375,35.765),(56.545,35.765),(56.545,35.595),(56.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.595),(56.735,35.765),(56.905,35.765),(56.905,35.595),(56.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.595),(57.095,35.765),(57.265,35.765),(57.265,35.595),(57.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.595),(57.455,35.765),(57.625,35.765),(57.625,35.595),(57.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,35.955),(56.375,36.125),(56.545,36.125),(56.545,35.955),(56.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,35.955),(56.735,36.125),(56.905,36.125),(56.905,35.955),(56.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,35.955),(57.095,36.125),(57.265,36.125),(57.265,35.955),(57.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,35.955),(57.455,36.125),(57.625,36.125),(57.625,35.955),(57.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,36.315),(56.375,36.485),(56.545,36.485),(56.545,36.315),(56.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,36.315),(56.735,36.485),(56.905,36.485),(56.905,36.315),(56.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,36.315),(57.095,36.485),(57.265,36.485),(57.265,36.315),(57.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,36.315),(57.455,36.485),(57.625,36.485),(57.625,36.315),(57.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,36.675),(56.375,36.845),(56.545,36.845),(56.545,36.675),(56.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,36.675),(56.735,36.845),(56.905,36.845),(56.905,36.675),(56.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,36.675),(57.095,36.845),(57.265,36.845),(57.265,36.675),(57.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,36.675),(57.455,36.845),(57.625,36.845),(57.625,36.675),(57.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.035),(56.375,37.205),(56.545,37.205),(56.545,37.035),(56.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.035),(56.735,37.205),(56.905,37.205),(56.905,37.035),(56.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.035),(57.095,37.205),(57.265,37.205),(57.265,37.035),(57.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.035),(57.455,37.205),(57.625,37.205),(57.625,37.035),(57.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.395),(56.375,37.565),(56.545,37.565),(56.545,37.395),(56.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.395),(56.735,37.565),(56.905,37.565),(56.905,37.395),(56.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.395),(57.095,37.565),(57.265,37.565),(57.265,37.395),(57.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.395),(57.455,37.565),(57.625,37.565),(57.625,37.395),(57.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,37.755),(56.375,37.925),(56.545,37.925),(56.545,37.755),(56.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,37.755),(56.735,37.925),(56.905,37.925),(56.905,37.755),(56.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,37.755),(57.095,37.925),(57.265,37.925),(57.265,37.755),(57.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,37.755),(57.455,37.925),(57.625,37.925),(57.625,37.755),(57.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.115),(56.375,38.285),(56.545,38.285),(56.545,38.115),(56.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.115),(56.735,38.285),(56.905,38.285),(56.905,38.115),(56.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.115),(57.095,38.285),(57.265,38.285),(57.265,38.115),(57.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.115),(57.455,38.285),(57.625,38.285),(57.625,38.115),(57.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.475),(56.375,38.645),(56.545,38.645),(56.545,38.475),(56.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.475),(56.735,38.645),(56.905,38.645),(56.905,38.475),(56.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.475),(57.095,38.645),(57.265,38.645),(57.265,38.475),(57.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.475),(57.455,38.645),(57.625,38.645),(57.625,38.475),(57.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,38.835),(56.375,39.005),(56.545,39.005),(56.545,38.835),(56.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,38.835),(56.735,39.005),(56.905,39.005),(56.905,38.835),(56.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,38.835),(57.095,39.005),(57.265,39.005),(57.265,38.835),(57.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,38.835),(57.455,39.005),(57.625,39.005),(57.625,38.835),(57.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.195),(56.375,39.365),(56.545,39.365),(56.545,39.195),(56.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.195),(56.735,39.365),(56.905,39.365),(56.905,39.195),(56.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.195),(57.095,39.365),(57.265,39.365),(57.265,39.195),(57.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.195),(57.455,39.365),(57.625,39.365),(57.625,39.195),(57.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.555),(56.375,39.725),(56.545,39.725),(56.545,39.555),(56.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.555),(56.735,39.725),(56.905,39.725),(56.905,39.555),(56.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.555),(57.095,39.725),(57.265,39.725),(57.265,39.555),(57.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.555),(57.455,39.725),(57.625,39.725),(57.625,39.555),(57.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,39.915),(56.375,40.085),(56.545,40.085),(56.545,39.915),(56.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,39.915),(56.735,40.085),(56.905,40.085),(56.905,39.915),(56.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,39.915),(57.095,40.085),(57.265,40.085),(57.265,39.915),(57.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,39.915),(57.455,40.085),(57.625,40.085),(57.625,39.915),(57.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,40.275),(56.375,40.445),(56.545,40.445),(56.545,40.275),(56.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,40.275),(56.735,40.445),(56.905,40.445),(56.905,40.275),(56.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,40.275),(57.095,40.445),(57.265,40.445),(57.265,40.275),(57.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,40.275),(57.455,40.445),(57.625,40.445),(57.625,40.275),(57.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.375,40.635),(56.375,40.805),(56.545,40.805),(56.545,40.635),(56.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((56.735,40.635),(56.735,40.805),(56.905,40.805),(56.905,40.635),(56.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.095,40.635),(57.095,40.805),(57.265,40.805),(57.265,40.635),(57.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((57.455,40.635),(57.455,40.805),(57.625,40.805),(57.625,40.635),(57.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,2.835),(41.975,3.005),(42.145,3.005),(42.145,2.835),(41.975,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,2.835),(42.335,3.005),(42.505,3.005),(42.505,2.835),(42.335,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,2.835),(42.695,3.005),(42.865,3.005),(42.865,2.835),(42.695,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,2.835),(43.055,3.005),(43.225,3.005),(43.225,2.835),(43.055,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.195),(41.975,3.365),(42.145,3.365),(42.145,3.195),(41.975,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.195),(42.335,3.365),(42.505,3.365),(42.505,3.195),(42.335,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.195),(42.695,3.365),(42.865,3.365),(42.865,3.195),(42.695,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.195),(43.055,3.365),(43.225,3.365),(43.225,3.195),(43.055,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.555),(41.975,3.725),(42.145,3.725),(42.145,3.555),(41.975,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.555),(42.335,3.725),(42.505,3.725),(42.505,3.555),(42.335,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.555),(42.695,3.725),(42.865,3.725),(42.865,3.555),(42.695,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.555),(43.055,3.725),(43.225,3.725),(43.225,3.555),(43.055,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,3.915),(41.975,4.085),(42.145,4.085),(42.145,3.915),(41.975,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,3.915),(42.335,4.085),(42.505,4.085),(42.505,3.915),(42.335,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,3.915),(42.695,4.085),(42.865,4.085),(42.865,3.915),(42.695,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,3.915),(43.055,4.085),(43.225,4.085),(43.225,3.915),(43.055,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.275),(41.975,4.445),(42.145,4.445),(42.145,4.275),(41.975,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.275),(42.335,4.445),(42.505,4.445),(42.505,4.275),(42.335,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.275),(42.695,4.445),(42.865,4.445),(42.865,4.275),(42.695,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.275),(43.055,4.445),(43.225,4.445),(43.225,4.275),(43.055,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.635),(41.975,4.805),(42.145,4.805),(42.145,4.635),(41.975,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.635),(42.335,4.805),(42.505,4.805),(42.505,4.635),(42.335,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.635),(42.695,4.805),(42.865,4.805),(42.865,4.635),(42.695,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.635),(43.055,4.805),(43.225,4.805),(43.225,4.635),(43.055,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,4.995),(41.975,5.165),(42.145,5.165),(42.145,4.995),(41.975,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,4.995),(42.335,5.165),(42.505,5.165),(42.505,4.995),(42.335,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,4.995),(42.695,5.165),(42.865,5.165),(42.865,4.995),(42.695,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,4.995),(43.055,5.165),(43.225,5.165),(43.225,4.995),(43.055,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.355),(41.975,5.525),(42.145,5.525),(42.145,5.355),(41.975,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.355),(42.335,5.525),(42.505,5.525),(42.505,5.355),(42.335,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.355),(42.695,5.525),(42.865,5.525),(42.865,5.355),(42.695,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.355),(43.055,5.525),(43.225,5.525),(43.225,5.355),(43.055,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,5.715),(41.975,5.885),(42.145,5.885),(42.145,5.715),(41.975,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,5.715),(42.335,5.885),(42.505,5.885),(42.505,5.715),(42.335,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,5.715),(42.695,5.885),(42.865,5.885),(42.865,5.715),(42.695,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,5.715),(43.055,5.885),(43.225,5.885),(43.225,5.715),(43.055,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.075),(41.975,6.245),(42.145,6.245),(42.145,6.075),(41.975,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.075),(42.335,6.245),(42.505,6.245),(42.505,6.075),(42.335,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.075),(42.695,6.245),(42.865,6.245),(42.865,6.075),(42.695,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.075),(43.055,6.245),(43.225,6.245),(43.225,6.075),(43.055,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.435),(41.975,6.605),(42.145,6.605),(42.145,6.435),(41.975,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.435),(42.335,6.605),(42.505,6.605),(42.505,6.435),(42.335,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.435),(42.695,6.605),(42.865,6.605),(42.865,6.435),(42.695,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.435),(43.055,6.605),(43.225,6.605),(43.225,6.435),(43.055,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,6.795),(41.975,6.965),(42.145,6.965),(42.145,6.795),(41.975,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,6.795),(42.335,6.965),(42.505,6.965),(42.505,6.795),(42.335,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,6.795),(42.695,6.965),(42.865,6.965),(42.865,6.795),(42.695,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,6.795),(43.055,6.965),(43.225,6.965),(43.225,6.795),(43.055,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.155),(41.975,7.325),(42.145,7.325),(42.145,7.155),(41.975,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.155),(42.335,7.325),(42.505,7.325),(42.505,7.155),(42.335,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.155),(42.695,7.325),(42.865,7.325),(42.865,7.155),(42.695,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.155),(43.055,7.325),(43.225,7.325),(43.225,7.155),(43.055,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.515),(41.975,7.685),(42.145,7.685),(42.145,7.515),(41.975,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.515),(42.335,7.685),(42.505,7.685),(42.505,7.515),(42.335,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.515),(42.695,7.685),(42.865,7.685),(42.865,7.515),(42.695,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.515),(43.055,7.685),(43.225,7.685),(43.225,7.515),(43.055,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,7.875),(41.975,8.045),(42.145,8.045),(42.145,7.875),(41.975,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,7.875),(42.335,8.045),(42.505,8.045),(42.505,7.875),(42.335,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,7.875),(42.695,8.045),(42.865,8.045),(42.865,7.875),(42.695,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,7.875),(43.055,8.045),(43.225,8.045),(43.225,7.875),(43.055,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.235),(41.975,8.405),(42.145,8.405),(42.145,8.235),(41.975,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.235),(42.335,8.405),(42.505,8.405),(42.505,8.235),(42.335,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.235),(42.695,8.405),(42.865,8.405),(42.865,8.235),(42.695,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.235),(43.055,8.405),(43.225,8.405),(43.225,8.235),(43.055,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.595),(41.975,8.765),(42.145,8.765),(42.145,8.595),(41.975,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.595),(42.335,8.765),(42.505,8.765),(42.505,8.595),(42.335,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.595),(42.695,8.765),(42.865,8.765),(42.865,8.595),(42.695,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.595),(43.055,8.765),(43.225,8.765),(43.225,8.595),(43.055,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,8.955),(41.975,9.125),(42.145,9.125),(42.145,8.955),(41.975,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,8.955),(42.335,9.125),(42.505,9.125),(42.505,8.955),(42.335,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,8.955),(42.695,9.125),(42.865,9.125),(42.865,8.955),(42.695,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,8.955),(43.055,9.125),(43.225,9.125),(43.225,8.955),(43.055,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.315),(41.975,9.485),(42.145,9.485),(42.145,9.315),(41.975,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.315),(42.335,9.485),(42.505,9.485),(42.505,9.315),(42.335,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.315),(42.695,9.485),(42.865,9.485),(42.865,9.315),(42.695,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.315),(43.055,9.485),(43.225,9.485),(43.225,9.315),(43.055,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,9.675),(41.975,9.845),(42.145,9.845),(42.145,9.675),(41.975,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,9.675),(42.335,9.845),(42.505,9.845),(42.505,9.675),(42.335,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,9.675),(42.695,9.845),(42.865,9.845),(42.865,9.675),(42.695,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,9.675),(43.055,9.845),(43.225,9.845),(43.225,9.675),(43.055,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.035),(41.975,10.205),(42.145,10.205),(42.145,10.035),(41.975,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.035),(42.335,10.205),(42.505,10.205),(42.505,10.035),(42.335,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.035),(42.695,10.205),(42.865,10.205),(42.865,10.035),(42.695,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.035),(43.055,10.205),(43.225,10.205),(43.225,10.035),(43.055,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.395),(41.975,10.565),(42.145,10.565),(42.145,10.395),(41.975,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.395),(42.335,10.565),(42.505,10.565),(42.505,10.395),(42.335,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.395),(42.695,10.565),(42.865,10.565),(42.865,10.395),(42.695,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.395),(43.055,10.565),(43.225,10.565),(43.225,10.395),(43.055,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,10.755),(41.975,10.925),(42.145,10.925),(42.145,10.755),(41.975,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,10.755),(42.335,10.925),(42.505,10.925),(42.505,10.755),(42.335,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,10.755),(42.695,10.925),(42.865,10.925),(42.865,10.755),(42.695,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,10.755),(43.055,10.925),(43.225,10.925),(43.225,10.755),(43.055,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.115),(41.975,11.285),(42.145,11.285),(42.145,11.115),(41.975,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.115),(42.335,11.285),(42.505,11.285),(42.505,11.115),(42.335,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.115),(42.695,11.285),(42.865,11.285),(42.865,11.115),(42.695,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.115),(43.055,11.285),(43.225,11.285),(43.225,11.115),(43.055,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.475),(41.975,11.645),(42.145,11.645),(42.145,11.475),(41.975,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.475),(42.335,11.645),(42.505,11.645),(42.505,11.475),(42.335,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.475),(42.695,11.645),(42.865,11.645),(42.865,11.475),(42.695,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.475),(43.055,11.645),(43.225,11.645),(43.225,11.475),(43.055,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,11.835),(41.975,12.005),(42.145,12.005),(42.145,11.835),(41.975,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,11.835),(42.335,12.005),(42.505,12.005),(42.505,11.835),(42.335,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,11.835),(42.695,12.005),(42.865,12.005),(42.865,11.835),(42.695,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,11.835),(43.055,12.005),(43.225,12.005),(43.225,11.835),(43.055,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.195),(41.975,12.365),(42.145,12.365),(42.145,12.195),(41.975,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.195),(42.335,12.365),(42.505,12.365),(42.505,12.195),(42.335,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.195),(42.695,12.365),(42.865,12.365),(42.865,12.195),(42.695,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.195),(43.055,12.365),(43.225,12.365),(43.225,12.195),(43.055,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.555),(41.975,12.725),(42.145,12.725),(42.145,12.555),(41.975,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.555),(42.335,12.725),(42.505,12.725),(42.505,12.555),(42.335,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.555),(42.695,12.725),(42.865,12.725),(42.865,12.555),(42.695,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.555),(43.055,12.725),(43.225,12.725),(43.225,12.555),(43.055,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,12.915),(41.975,13.085),(42.145,13.085),(42.145,12.915),(41.975,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,12.915),(42.335,13.085),(42.505,13.085),(42.505,12.915),(42.335,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,12.915),(42.695,13.085),(42.865,13.085),(42.865,12.915),(42.695,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,12.915),(43.055,13.085),(43.225,13.085),(43.225,12.915),(43.055,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.275),(41.975,13.445),(42.145,13.445),(42.145,13.275),(41.975,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.275),(42.335,13.445),(42.505,13.445),(42.505,13.275),(42.335,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.275),(42.695,13.445),(42.865,13.445),(42.865,13.275),(42.695,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.275),(43.055,13.445),(43.225,13.445),(43.225,13.275),(43.055,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.635),(41.975,13.805),(42.145,13.805),(42.145,13.635),(41.975,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.635),(42.335,13.805),(42.505,13.805),(42.505,13.635),(42.335,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.635),(42.695,13.805),(42.865,13.805),(42.865,13.635),(42.695,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.635),(43.055,13.805),(43.225,13.805),(43.225,13.635),(43.055,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,13.995),(41.975,14.165),(42.145,14.165),(42.145,13.995),(41.975,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,13.995),(42.335,14.165),(42.505,14.165),(42.505,13.995),(42.335,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,13.995),(42.695,14.165),(42.865,14.165),(42.865,13.995),(42.695,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,13.995),(43.055,14.165),(43.225,14.165),(43.225,13.995),(43.055,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.355),(41.975,14.525),(42.145,14.525),(42.145,14.355),(41.975,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.355),(42.335,14.525),(42.505,14.525),(42.505,14.355),(42.335,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.355),(42.695,14.525),(42.865,14.525),(42.865,14.355),(42.695,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.355),(43.055,14.525),(43.225,14.525),(43.225,14.355),(43.055,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,14.715),(41.975,14.885),(42.145,14.885),(42.145,14.715),(41.975,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,14.715),(42.335,14.885),(42.505,14.885),(42.505,14.715),(42.335,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,14.715),(42.695,14.885),(42.865,14.885),(42.865,14.715),(42.695,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,14.715),(43.055,14.885),(43.225,14.885),(43.225,14.715),(43.055,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.075),(41.975,15.245),(42.145,15.245),(42.145,15.075),(41.975,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.075),(42.335,15.245),(42.505,15.245),(42.505,15.075),(42.335,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.075),(42.695,15.245),(42.865,15.245),(42.865,15.075),(42.695,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.075),(43.055,15.245),(43.225,15.245),(43.225,15.075),(43.055,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.435),(41.975,15.605),(42.145,15.605),(42.145,15.435),(41.975,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.435),(42.335,15.605),(42.505,15.605),(42.505,15.435),(42.335,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.435),(42.695,15.605),(42.865,15.605),(42.865,15.435),(42.695,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.435),(43.055,15.605),(43.225,15.605),(43.225,15.435),(43.055,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,15.795),(41.975,15.965),(42.145,15.965),(42.145,15.795),(41.975,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,15.795),(42.335,15.965),(42.505,15.965),(42.505,15.795),(42.335,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,15.795),(42.695,15.965),(42.865,15.965),(42.865,15.795),(42.695,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,15.795),(43.055,15.965),(43.225,15.965),(43.225,15.795),(43.055,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.155),(41.975,16.325),(42.145,16.325),(42.145,16.155),(41.975,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.155),(42.335,16.325),(42.505,16.325),(42.505,16.155),(42.335,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.155),(42.695,16.325),(42.865,16.325),(42.865,16.155),(42.695,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.155),(43.055,16.325),(43.225,16.325),(43.225,16.155),(43.055,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.515),(41.975,16.685),(42.145,16.685),(42.145,16.515),(41.975,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.515),(42.335,16.685),(42.505,16.685),(42.505,16.515),(42.335,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.515),(42.695,16.685),(42.865,16.685),(42.865,16.515),(42.695,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.515),(43.055,16.685),(43.225,16.685),(43.225,16.515),(43.055,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,16.875),(41.975,17.045),(42.145,17.045),(42.145,16.875),(41.975,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,16.875),(42.335,17.045),(42.505,17.045),(42.505,16.875),(42.335,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,16.875),(42.695,17.045),(42.865,17.045),(42.865,16.875),(42.695,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,16.875),(43.055,17.045),(43.225,17.045),(43.225,16.875),(43.055,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.235),(41.975,17.405),(42.145,17.405),(42.145,17.235),(41.975,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.235),(42.335,17.405),(42.505,17.405),(42.505,17.235),(42.335,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.235),(42.695,17.405),(42.865,17.405),(42.865,17.235),(42.695,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.235),(43.055,17.405),(43.225,17.405),(43.225,17.235),(43.055,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.595),(41.975,17.765),(42.145,17.765),(42.145,17.595),(41.975,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.595),(42.335,17.765),(42.505,17.765),(42.505,17.595),(42.335,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.595),(42.695,17.765),(42.865,17.765),(42.865,17.595),(42.695,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.595),(43.055,17.765),(43.225,17.765),(43.225,17.595),(43.055,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,17.955),(41.975,18.125),(42.145,18.125),(42.145,17.955),(41.975,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,17.955),(42.335,18.125),(42.505,18.125),(42.505,17.955),(42.335,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,17.955),(42.695,18.125),(42.865,18.125),(42.865,17.955),(42.695,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,17.955),(43.055,18.125),(43.225,18.125),(43.225,17.955),(43.055,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.315),(41.975,18.485),(42.145,18.485),(42.145,18.315),(41.975,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.315),(42.335,18.485),(42.505,18.485),(42.505,18.315),(42.335,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.315),(42.695,18.485),(42.865,18.485),(42.865,18.315),(42.695,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.315),(43.055,18.485),(43.225,18.485),(43.225,18.315),(43.055,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,18.675),(41.975,18.845),(42.145,18.845),(42.145,18.675),(41.975,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,18.675),(42.335,18.845),(42.505,18.845),(42.505,18.675),(42.335,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,18.675),(42.695,18.845),(42.865,18.845),(42.865,18.675),(42.695,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,18.675),(43.055,18.845),(43.225,18.845),(43.225,18.675),(43.055,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.035),(41.975,19.205),(42.145,19.205),(42.145,19.035),(41.975,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.035),(42.335,19.205),(42.505,19.205),(42.505,19.035),(42.335,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.035),(42.695,19.205),(42.865,19.205),(42.865,19.035),(42.695,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.035),(43.055,19.205),(43.225,19.205),(43.225,19.035),(43.055,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.395),(41.975,19.565),(42.145,19.565),(42.145,19.395),(41.975,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.395),(42.335,19.565),(42.505,19.565),(42.505,19.395),(42.335,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.395),(42.695,19.565),(42.865,19.565),(42.865,19.395),(42.695,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.395),(43.055,19.565),(43.225,19.565),(43.225,19.395),(43.055,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,19.755),(41.975,19.925),(42.145,19.925),(42.145,19.755),(41.975,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,19.755),(42.335,19.925),(42.505,19.925),(42.505,19.755),(42.335,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,19.755),(42.695,19.925),(42.865,19.925),(42.865,19.755),(42.695,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,19.755),(43.055,19.925),(43.225,19.925),(43.225,19.755),(43.055,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.115),(41.975,20.285),(42.145,20.285),(42.145,20.115),(41.975,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.115),(42.335,20.285),(42.505,20.285),(42.505,20.115),(42.335,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.115),(42.695,20.285),(42.865,20.285),(42.865,20.115),(42.695,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.115),(43.055,20.285),(43.225,20.285),(43.225,20.115),(43.055,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.475),(41.975,20.645),(42.145,20.645),(42.145,20.475),(41.975,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.475),(42.335,20.645),(42.505,20.645),(42.505,20.475),(42.335,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.475),(42.695,20.645),(42.865,20.645),(42.865,20.475),(42.695,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.475),(43.055,20.645),(43.225,20.645),(43.225,20.475),(43.055,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,20.835),(41.975,21.005),(42.145,21.005),(42.145,20.835),(41.975,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,20.835),(42.335,21.005),(42.505,21.005),(42.505,20.835),(42.335,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,20.835),(42.695,21.005),(42.865,21.005),(42.865,20.835),(42.695,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,20.835),(43.055,21.005),(43.225,21.005),(43.225,20.835),(43.055,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.195),(41.975,21.365),(42.145,21.365),(42.145,21.195),(41.975,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.195),(42.335,21.365),(42.505,21.365),(42.505,21.195),(42.335,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.195),(42.695,21.365),(42.865,21.365),(42.865,21.195),(42.695,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.195),(43.055,21.365),(43.225,21.365),(43.225,21.195),(43.055,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.555),(41.975,21.725),(42.145,21.725),(42.145,21.555),(41.975,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.555),(42.335,21.725),(42.505,21.725),(42.505,21.555),(42.335,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.555),(42.695,21.725),(42.865,21.725),(42.865,21.555),(42.695,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.555),(43.055,21.725),(43.225,21.725),(43.225,21.555),(43.055,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,21.915),(41.975,22.085),(42.145,22.085),(42.145,21.915),(41.975,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,21.915),(42.335,22.085),(42.505,22.085),(42.505,21.915),(42.335,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,21.915),(42.695,22.085),(42.865,22.085),(42.865,21.915),(42.695,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,21.915),(43.055,22.085),(43.225,22.085),(43.225,21.915),(43.055,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.275),(41.975,22.445),(42.145,22.445),(42.145,22.275),(41.975,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.275),(42.335,22.445),(42.505,22.445),(42.505,22.275),(42.335,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.275),(42.695,22.445),(42.865,22.445),(42.865,22.275),(42.695,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.275),(43.055,22.445),(43.225,22.445),(43.225,22.275),(43.055,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.635),(41.975,22.805),(42.145,22.805),(42.145,22.635),(41.975,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.635),(42.335,22.805),(42.505,22.805),(42.505,22.635),(42.335,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.635),(42.695,22.805),(42.865,22.805),(42.865,22.635),(42.695,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.635),(43.055,22.805),(43.225,22.805),(43.225,22.635),(43.055,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,22.995),(41.975,23.165),(42.145,23.165),(42.145,22.995),(41.975,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,22.995),(42.335,23.165),(42.505,23.165),(42.505,22.995),(42.335,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,22.995),(42.695,23.165),(42.865,23.165),(42.865,22.995),(42.695,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,22.995),(43.055,23.165),(43.225,23.165),(43.225,22.995),(43.055,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,23.355),(41.975,23.525),(42.145,23.525),(42.145,23.355),(41.975,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,23.355),(42.335,23.525),(42.505,23.525),(42.505,23.355),(42.335,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,23.355),(42.695,23.525),(42.865,23.525),(42.865,23.355),(42.695,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,23.355),(43.055,23.525),(43.225,23.525),(43.225,23.355),(43.055,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,23.715),(41.975,23.885),(42.145,23.885),(42.145,23.715),(41.975,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,23.715),(42.335,23.885),(42.505,23.885),(42.505,23.715),(42.335,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,23.715),(42.695,23.885),(42.865,23.885),(42.865,23.715),(42.695,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,23.715),(43.055,23.885),(43.225,23.885),(43.225,23.715),(43.055,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.075),(41.975,24.245),(42.145,24.245),(42.145,24.075),(41.975,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.075),(42.335,24.245),(42.505,24.245),(42.505,24.075),(42.335,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.075),(42.695,24.245),(42.865,24.245),(42.865,24.075),(42.695,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.075),(43.055,24.245),(43.225,24.245),(43.225,24.075),(43.055,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.435),(41.975,24.605),(42.145,24.605),(42.145,24.435),(41.975,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.435),(42.335,24.605),(42.505,24.605),(42.505,24.435),(42.335,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.435),(42.695,24.605),(42.865,24.605),(42.865,24.435),(42.695,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.435),(43.055,24.605),(43.225,24.605),(43.225,24.435),(43.055,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,24.795),(41.975,24.965),(42.145,24.965),(42.145,24.795),(41.975,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,24.795),(42.335,24.965),(42.505,24.965),(42.505,24.795),(42.335,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,24.795),(42.695,24.965),(42.865,24.965),(42.865,24.795),(42.695,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,24.795),(43.055,24.965),(43.225,24.965),(43.225,24.795),(43.055,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.155),(41.975,25.325),(42.145,25.325),(42.145,25.155),(41.975,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.155),(42.335,25.325),(42.505,25.325),(42.505,25.155),(42.335,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.155),(42.695,25.325),(42.865,25.325),(42.865,25.155),(42.695,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.155),(43.055,25.325),(43.225,25.325),(43.225,25.155),(43.055,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.515),(41.975,25.685),(42.145,25.685),(42.145,25.515),(41.975,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.515),(42.335,25.685),(42.505,25.685),(42.505,25.515),(42.335,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.515),(42.695,25.685),(42.865,25.685),(42.865,25.515),(42.695,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.515),(43.055,25.685),(43.225,25.685),(43.225,25.515),(43.055,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,25.875),(41.975,26.045),(42.145,26.045),(42.145,25.875),(41.975,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,25.875),(42.335,26.045),(42.505,26.045),(42.505,25.875),(42.335,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,25.875),(42.695,26.045),(42.865,26.045),(42.865,25.875),(42.695,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,25.875),(43.055,26.045),(43.225,26.045),(43.225,25.875),(43.055,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.235),(41.975,26.405),(42.145,26.405),(42.145,26.235),(41.975,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.235),(42.335,26.405),(42.505,26.405),(42.505,26.235),(42.335,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.235),(42.695,26.405),(42.865,26.405),(42.865,26.235),(42.695,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.235),(43.055,26.405),(43.225,26.405),(43.225,26.235),(43.055,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.595),(41.975,26.765),(42.145,26.765),(42.145,26.595),(41.975,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.595),(42.335,26.765),(42.505,26.765),(42.505,26.595),(42.335,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.595),(42.695,26.765),(42.865,26.765),(42.865,26.595),(42.695,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.595),(43.055,26.765),(43.225,26.765),(43.225,26.595),(43.055,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,26.955),(41.975,27.125),(42.145,27.125),(42.145,26.955),(41.975,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,26.955),(42.335,27.125),(42.505,27.125),(42.505,26.955),(42.335,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,26.955),(42.695,27.125),(42.865,27.125),(42.865,26.955),(42.695,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,26.955),(43.055,27.125),(43.225,27.125),(43.225,26.955),(43.055,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,27.315),(41.975,27.485),(42.145,27.485),(42.145,27.315),(41.975,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,27.315),(42.335,27.485),(42.505,27.485),(42.505,27.315),(42.335,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,27.315),(42.695,27.485),(42.865,27.485),(42.865,27.315),(42.695,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,27.315),(43.055,27.485),(43.225,27.485),(43.225,27.315),(43.055,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,27.675),(41.975,27.845),(42.145,27.845),(42.145,27.675),(41.975,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,27.675),(42.335,27.845),(42.505,27.845),(42.505,27.675),(42.335,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,27.675),(42.695,27.845),(42.865,27.845),(42.865,27.675),(42.695,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,27.675),(43.055,27.845),(43.225,27.845),(43.225,27.675),(43.055,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.035),(41.975,28.205),(42.145,28.205),(42.145,28.035),(41.975,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.035),(42.335,28.205),(42.505,28.205),(42.505,28.035),(42.335,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.035),(42.695,28.205),(42.865,28.205),(42.865,28.035),(42.695,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.035),(43.055,28.205),(43.225,28.205),(43.225,28.035),(43.055,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.395),(41.975,28.565),(42.145,28.565),(42.145,28.395),(41.975,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.395),(42.335,28.565),(42.505,28.565),(42.505,28.395),(42.335,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.395),(42.695,28.565),(42.865,28.565),(42.865,28.395),(42.695,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.395),(43.055,28.565),(43.225,28.565),(43.225,28.395),(43.055,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,28.755),(41.975,28.925),(42.145,28.925),(42.145,28.755),(41.975,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,28.755),(42.335,28.925),(42.505,28.925),(42.505,28.755),(42.335,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,28.755),(42.695,28.925),(42.865,28.925),(42.865,28.755),(42.695,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,28.755),(43.055,28.925),(43.225,28.925),(43.225,28.755),(43.055,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.115),(41.975,29.285),(42.145,29.285),(42.145,29.115),(41.975,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.115),(42.335,29.285),(42.505,29.285),(42.505,29.115),(42.335,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.115),(42.695,29.285),(42.865,29.285),(42.865,29.115),(42.695,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.115),(43.055,29.285),(43.225,29.285),(43.225,29.115),(43.055,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.475),(41.975,29.645),(42.145,29.645),(42.145,29.475),(41.975,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.475),(42.335,29.645),(42.505,29.645),(42.505,29.475),(42.335,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.475),(42.695,29.645),(42.865,29.645),(42.865,29.475),(42.695,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.475),(43.055,29.645),(43.225,29.645),(43.225,29.475),(43.055,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,29.835),(41.975,30.005),(42.145,30.005),(42.145,29.835),(41.975,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,29.835),(42.335,30.005),(42.505,30.005),(42.505,29.835),(42.335,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,29.835),(42.695,30.005),(42.865,30.005),(42.865,29.835),(42.695,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,29.835),(43.055,30.005),(43.225,30.005),(43.225,29.835),(43.055,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.195),(41.975,30.365),(42.145,30.365),(42.145,30.195),(41.975,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.195),(42.335,30.365),(42.505,30.365),(42.505,30.195),(42.335,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.195),(42.695,30.365),(42.865,30.365),(42.865,30.195),(42.695,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.195),(43.055,30.365),(43.225,30.365),(43.225,30.195),(43.055,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.555),(41.975,30.725),(42.145,30.725),(42.145,30.555),(41.975,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.555),(42.335,30.725),(42.505,30.725),(42.505,30.555),(42.335,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.555),(42.695,30.725),(42.865,30.725),(42.865,30.555),(42.695,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.555),(43.055,30.725),(43.225,30.725),(43.225,30.555),(43.055,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,30.915),(41.975,31.085),(42.145,31.085),(42.145,30.915),(41.975,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,30.915),(42.335,31.085),(42.505,31.085),(42.505,30.915),(42.335,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,30.915),(42.695,31.085),(42.865,31.085),(42.865,30.915),(42.695,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,30.915),(43.055,31.085),(43.225,31.085),(43.225,30.915),(43.055,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.275),(41.975,31.445),(42.145,31.445),(42.145,31.275),(41.975,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.275),(42.335,31.445),(42.505,31.445),(42.505,31.275),(42.335,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.275),(42.695,31.445),(42.865,31.445),(42.865,31.275),(42.695,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.275),(43.055,31.445),(43.225,31.445),(43.225,31.275),(43.055,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.635),(41.975,31.805),(42.145,31.805),(42.145,31.635),(41.975,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.635),(42.335,31.805),(42.505,31.805),(42.505,31.635),(42.335,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.635),(42.695,31.805),(42.865,31.805),(42.865,31.635),(42.695,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.635),(43.055,31.805),(43.225,31.805),(43.225,31.635),(43.055,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,31.995),(41.975,32.165),(42.145,32.165),(42.145,31.995),(41.975,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,31.995),(42.335,32.165),(42.505,32.165),(42.505,31.995),(42.335,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,31.995),(42.695,32.165),(42.865,32.165),(42.865,31.995),(42.695,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,31.995),(43.055,32.165),(43.225,32.165),(43.225,31.995),(43.055,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,32.355),(41.975,32.525),(42.145,32.525),(42.145,32.355),(41.975,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,32.355),(42.335,32.525),(42.505,32.525),(42.505,32.355),(42.335,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,32.355),(42.695,32.525),(42.865,32.525),(42.865,32.355),(42.695,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,32.355),(43.055,32.525),(43.225,32.525),(43.225,32.355),(43.055,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,32.715),(41.975,32.885),(42.145,32.885),(42.145,32.715),(41.975,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,32.715),(42.335,32.885),(42.505,32.885),(42.505,32.715),(42.335,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,32.715),(42.695,32.885),(42.865,32.885),(42.865,32.715),(42.695,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,32.715),(43.055,32.885),(43.225,32.885),(43.225,32.715),(43.055,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.075),(41.975,33.245),(42.145,33.245),(42.145,33.075),(41.975,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.075),(42.335,33.245),(42.505,33.245),(42.505,33.075),(42.335,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.075),(42.695,33.245),(42.865,33.245),(42.865,33.075),(42.695,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.075),(43.055,33.245),(43.225,33.245),(43.225,33.075),(43.055,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.435),(41.975,33.605),(42.145,33.605),(42.145,33.435),(41.975,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.435),(42.335,33.605),(42.505,33.605),(42.505,33.435),(42.335,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.435),(42.695,33.605),(42.865,33.605),(42.865,33.435),(42.695,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.435),(43.055,33.605),(43.225,33.605),(43.225,33.435),(43.055,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,33.795),(41.975,33.965),(42.145,33.965),(42.145,33.795),(41.975,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,33.795),(42.335,33.965),(42.505,33.965),(42.505,33.795),(42.335,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,33.795),(42.695,33.965),(42.865,33.965),(42.865,33.795),(42.695,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,33.795),(43.055,33.965),(43.225,33.965),(43.225,33.795),(43.055,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.155),(41.975,34.325),(42.145,34.325),(42.145,34.155),(41.975,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.155),(42.335,34.325),(42.505,34.325),(42.505,34.155),(42.335,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.155),(42.695,34.325),(42.865,34.325),(42.865,34.155),(42.695,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.155),(43.055,34.325),(43.225,34.325),(43.225,34.155),(43.055,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.515),(41.975,34.685),(42.145,34.685),(42.145,34.515),(41.975,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.515),(42.335,34.685),(42.505,34.685),(42.505,34.515),(42.335,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.515),(42.695,34.685),(42.865,34.685),(42.865,34.515),(42.695,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.515),(43.055,34.685),(43.225,34.685),(43.225,34.515),(43.055,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,34.875),(41.975,35.045),(42.145,35.045),(42.145,34.875),(41.975,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,34.875),(42.335,35.045),(42.505,35.045),(42.505,34.875),(42.335,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,34.875),(42.695,35.045),(42.865,35.045),(42.865,34.875),(42.695,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,34.875),(43.055,35.045),(43.225,35.045),(43.225,34.875),(43.055,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.235),(41.975,35.405),(42.145,35.405),(42.145,35.235),(41.975,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.235),(42.335,35.405),(42.505,35.405),(42.505,35.235),(42.335,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.235),(42.695,35.405),(42.865,35.405),(42.865,35.235),(42.695,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.235),(43.055,35.405),(43.225,35.405),(43.225,35.235),(43.055,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.595),(41.975,35.765),(42.145,35.765),(42.145,35.595),(41.975,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.595),(42.335,35.765),(42.505,35.765),(42.505,35.595),(42.335,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.595),(42.695,35.765),(42.865,35.765),(42.865,35.595),(42.695,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.595),(43.055,35.765),(43.225,35.765),(43.225,35.595),(43.055,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,35.955),(41.975,36.125),(42.145,36.125),(42.145,35.955),(41.975,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,35.955),(42.335,36.125),(42.505,36.125),(42.505,35.955),(42.335,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,35.955),(42.695,36.125),(42.865,36.125),(42.865,35.955),(42.695,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,35.955),(43.055,36.125),(43.225,36.125),(43.225,35.955),(43.055,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,36.315),(41.975,36.485),(42.145,36.485),(42.145,36.315),(41.975,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,36.315),(42.335,36.485),(42.505,36.485),(42.505,36.315),(42.335,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,36.315),(42.695,36.485),(42.865,36.485),(42.865,36.315),(42.695,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,36.315),(43.055,36.485),(43.225,36.485),(43.225,36.315),(43.055,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,36.675),(41.975,36.845),(42.145,36.845),(42.145,36.675),(41.975,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,36.675),(42.335,36.845),(42.505,36.845),(42.505,36.675),(42.335,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,36.675),(42.695,36.845),(42.865,36.845),(42.865,36.675),(42.695,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,36.675),(43.055,36.845),(43.225,36.845),(43.225,36.675),(43.055,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.035),(41.975,37.205),(42.145,37.205),(42.145,37.035),(41.975,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.035),(42.335,37.205),(42.505,37.205),(42.505,37.035),(42.335,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.035),(42.695,37.205),(42.865,37.205),(42.865,37.035),(42.695,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.035),(43.055,37.205),(43.225,37.205),(43.225,37.035),(43.055,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.395),(41.975,37.565),(42.145,37.565),(42.145,37.395),(41.975,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.395),(42.335,37.565),(42.505,37.565),(42.505,37.395),(42.335,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.395),(42.695,37.565),(42.865,37.565),(42.865,37.395),(42.695,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.395),(43.055,37.565),(43.225,37.565),(43.225,37.395),(43.055,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,37.755),(41.975,37.925),(42.145,37.925),(42.145,37.755),(41.975,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,37.755),(42.335,37.925),(42.505,37.925),(42.505,37.755),(42.335,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,37.755),(42.695,37.925),(42.865,37.925),(42.865,37.755),(42.695,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,37.755),(43.055,37.925),(43.225,37.925),(43.225,37.755),(43.055,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.115),(41.975,38.285),(42.145,38.285),(42.145,38.115),(41.975,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.115),(42.335,38.285),(42.505,38.285),(42.505,38.115),(42.335,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.115),(42.695,38.285),(42.865,38.285),(42.865,38.115),(42.695,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.115),(43.055,38.285),(43.225,38.285),(43.225,38.115),(43.055,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.475),(41.975,38.645),(42.145,38.645),(42.145,38.475),(41.975,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.475),(42.335,38.645),(42.505,38.645),(42.505,38.475),(42.335,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.475),(42.695,38.645),(42.865,38.645),(42.865,38.475),(42.695,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.475),(43.055,38.645),(43.225,38.645),(43.225,38.475),(43.055,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,38.835),(41.975,39.005),(42.145,39.005),(42.145,38.835),(41.975,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,38.835),(42.335,39.005),(42.505,39.005),(42.505,38.835),(42.335,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,38.835),(42.695,39.005),(42.865,39.005),(42.865,38.835),(42.695,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,38.835),(43.055,39.005),(43.225,39.005),(43.225,38.835),(43.055,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.195),(41.975,39.365),(42.145,39.365),(42.145,39.195),(41.975,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.195),(42.335,39.365),(42.505,39.365),(42.505,39.195),(42.335,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.195),(42.695,39.365),(42.865,39.365),(42.865,39.195),(42.695,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.195),(43.055,39.365),(43.225,39.365),(43.225,39.195),(43.055,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.555),(41.975,39.725),(42.145,39.725),(42.145,39.555),(41.975,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.555),(42.335,39.725),(42.505,39.725),(42.505,39.555),(42.335,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.555),(42.695,39.725),(42.865,39.725),(42.865,39.555),(42.695,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.555),(43.055,39.725),(43.225,39.725),(43.225,39.555),(43.055,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,39.915),(41.975,40.085),(42.145,40.085),(42.145,39.915),(41.975,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,39.915),(42.335,40.085),(42.505,40.085),(42.505,39.915),(42.335,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,39.915),(42.695,40.085),(42.865,40.085),(42.865,39.915),(42.695,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,39.915),(43.055,40.085),(43.225,40.085),(43.225,39.915),(43.055,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,40.275),(41.975,40.445),(42.145,40.445),(42.145,40.275),(41.975,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,40.275),(42.335,40.445),(42.505,40.445),(42.505,40.275),(42.335,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,40.275),(42.695,40.445),(42.865,40.445),(42.865,40.275),(42.695,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,40.275),(43.055,40.445),(43.225,40.445),(43.225,40.275),(43.055,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((41.975,40.635),(41.975,40.805),(42.145,40.805),(42.145,40.635),(41.975,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.335,40.635),(42.335,40.805),(42.505,40.805),(42.505,40.635),(42.335,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((42.695,40.635),(42.695,40.805),(42.865,40.805),(42.865,40.635),(42.695,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((43.055,40.635),(43.055,40.805),(43.225,40.805),(43.225,40.635),(43.055,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,2.835),(37.175,3.005),(37.345,3.005),(37.345,2.835),(37.175,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,2.835),(37.535,3.005),(37.705,3.005),(37.705,2.835),(37.535,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,2.835),(37.895,3.005),(38.065,3.005),(38.065,2.835),(37.895,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,2.835),(38.255,3.005),(38.425,3.005),(38.425,2.835),(38.255,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.195),(37.175,3.365),(37.345,3.365),(37.345,3.195),(37.175,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.195),(37.535,3.365),(37.705,3.365),(37.705,3.195),(37.535,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.195),(37.895,3.365),(38.065,3.365),(38.065,3.195),(37.895,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.195),(38.255,3.365),(38.425,3.365),(38.425,3.195),(38.255,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.555),(37.175,3.725),(37.345,3.725),(37.345,3.555),(37.175,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.555),(37.535,3.725),(37.705,3.725),(37.705,3.555),(37.535,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.555),(37.895,3.725),(38.065,3.725),(38.065,3.555),(37.895,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.555),(38.255,3.725),(38.425,3.725),(38.425,3.555),(38.255,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,3.915),(37.175,4.085),(37.345,4.085),(37.345,3.915),(37.175,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,3.915),(37.535,4.085),(37.705,4.085),(37.705,3.915),(37.535,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,3.915),(37.895,4.085),(38.065,4.085),(38.065,3.915),(37.895,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,3.915),(38.255,4.085),(38.425,4.085),(38.425,3.915),(38.255,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.275),(37.175,4.445),(37.345,4.445),(37.345,4.275),(37.175,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.275),(37.535,4.445),(37.705,4.445),(37.705,4.275),(37.535,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.275),(37.895,4.445),(38.065,4.445),(38.065,4.275),(37.895,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.275),(38.255,4.445),(38.425,4.445),(38.425,4.275),(38.255,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.635),(37.175,4.805),(37.345,4.805),(37.345,4.635),(37.175,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.635),(37.535,4.805),(37.705,4.805),(37.705,4.635),(37.535,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.635),(37.895,4.805),(38.065,4.805),(38.065,4.635),(37.895,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.635),(38.255,4.805),(38.425,4.805),(38.425,4.635),(38.255,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,4.995),(37.175,5.165),(37.345,5.165),(37.345,4.995),(37.175,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,4.995),(37.535,5.165),(37.705,5.165),(37.705,4.995),(37.535,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,4.995),(37.895,5.165),(38.065,5.165),(38.065,4.995),(37.895,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,4.995),(38.255,5.165),(38.425,5.165),(38.425,4.995),(38.255,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.355),(37.175,5.525),(37.345,5.525),(37.345,5.355),(37.175,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.355),(37.535,5.525),(37.705,5.525),(37.705,5.355),(37.535,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.355),(37.895,5.525),(38.065,5.525),(38.065,5.355),(37.895,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.355),(38.255,5.525),(38.425,5.525),(38.425,5.355),(38.255,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,5.715),(37.175,5.885),(37.345,5.885),(37.345,5.715),(37.175,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,5.715),(37.535,5.885),(37.705,5.885),(37.705,5.715),(37.535,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,5.715),(37.895,5.885),(38.065,5.885),(38.065,5.715),(37.895,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,5.715),(38.255,5.885),(38.425,5.885),(38.425,5.715),(38.255,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.075),(37.175,6.245),(37.345,6.245),(37.345,6.075),(37.175,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.075),(37.535,6.245),(37.705,6.245),(37.705,6.075),(37.535,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.075),(37.895,6.245),(38.065,6.245),(38.065,6.075),(37.895,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.075),(38.255,6.245),(38.425,6.245),(38.425,6.075),(38.255,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.435),(37.175,6.605),(37.345,6.605),(37.345,6.435),(37.175,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.435),(37.535,6.605),(37.705,6.605),(37.705,6.435),(37.535,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.435),(37.895,6.605),(38.065,6.605),(38.065,6.435),(37.895,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.435),(38.255,6.605),(38.425,6.605),(38.425,6.435),(38.255,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,6.795),(37.175,6.965),(37.345,6.965),(37.345,6.795),(37.175,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,6.795),(37.535,6.965),(37.705,6.965),(37.705,6.795),(37.535,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,6.795),(37.895,6.965),(38.065,6.965),(38.065,6.795),(37.895,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,6.795),(38.255,6.965),(38.425,6.965),(38.425,6.795),(38.255,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.155),(37.175,7.325),(37.345,7.325),(37.345,7.155),(37.175,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.155),(37.535,7.325),(37.705,7.325),(37.705,7.155),(37.535,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.155),(37.895,7.325),(38.065,7.325),(38.065,7.155),(37.895,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.155),(38.255,7.325),(38.425,7.325),(38.425,7.155),(38.255,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.515),(37.175,7.685),(37.345,7.685),(37.345,7.515),(37.175,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.515),(37.535,7.685),(37.705,7.685),(37.705,7.515),(37.535,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.515),(37.895,7.685),(38.065,7.685),(38.065,7.515),(37.895,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.515),(38.255,7.685),(38.425,7.685),(38.425,7.515),(38.255,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,7.875),(37.175,8.045),(37.345,8.045),(37.345,7.875),(37.175,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,7.875),(37.535,8.045),(37.705,8.045),(37.705,7.875),(37.535,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,7.875),(37.895,8.045),(38.065,8.045),(38.065,7.875),(37.895,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,7.875),(38.255,8.045),(38.425,8.045),(38.425,7.875),(38.255,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.235),(37.175,8.405),(37.345,8.405),(37.345,8.235),(37.175,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.235),(37.535,8.405),(37.705,8.405),(37.705,8.235),(37.535,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.235),(37.895,8.405),(38.065,8.405),(38.065,8.235),(37.895,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.235),(38.255,8.405),(38.425,8.405),(38.425,8.235),(38.255,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.595),(37.175,8.765),(37.345,8.765),(37.345,8.595),(37.175,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.595),(37.535,8.765),(37.705,8.765),(37.705,8.595),(37.535,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.595),(37.895,8.765),(38.065,8.765),(38.065,8.595),(37.895,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.595),(38.255,8.765),(38.425,8.765),(38.425,8.595),(38.255,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,8.955),(37.175,9.125),(37.345,9.125),(37.345,8.955),(37.175,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,8.955),(37.535,9.125),(37.705,9.125),(37.705,8.955),(37.535,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,8.955),(37.895,9.125),(38.065,9.125),(38.065,8.955),(37.895,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,8.955),(38.255,9.125),(38.425,9.125),(38.425,8.955),(38.255,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.315),(37.175,9.485),(37.345,9.485),(37.345,9.315),(37.175,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.315),(37.535,9.485),(37.705,9.485),(37.705,9.315),(37.535,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.315),(37.895,9.485),(38.065,9.485),(38.065,9.315),(37.895,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.315),(38.255,9.485),(38.425,9.485),(38.425,9.315),(38.255,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,9.675),(37.175,9.845),(37.345,9.845),(37.345,9.675),(37.175,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,9.675),(37.535,9.845),(37.705,9.845),(37.705,9.675),(37.535,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,9.675),(37.895,9.845),(38.065,9.845),(38.065,9.675),(37.895,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,9.675),(38.255,9.845),(38.425,9.845),(38.425,9.675),(38.255,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.035),(37.175,10.205),(37.345,10.205),(37.345,10.035),(37.175,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.035),(37.535,10.205),(37.705,10.205),(37.705,10.035),(37.535,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.035),(37.895,10.205),(38.065,10.205),(38.065,10.035),(37.895,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.035),(38.255,10.205),(38.425,10.205),(38.425,10.035),(38.255,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.395),(37.175,10.565),(37.345,10.565),(37.345,10.395),(37.175,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.395),(37.535,10.565),(37.705,10.565),(37.705,10.395),(37.535,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.395),(37.895,10.565),(38.065,10.565),(38.065,10.395),(37.895,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.395),(38.255,10.565),(38.425,10.565),(38.425,10.395),(38.255,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,10.755),(37.175,10.925),(37.345,10.925),(37.345,10.755),(37.175,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,10.755),(37.535,10.925),(37.705,10.925),(37.705,10.755),(37.535,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,10.755),(37.895,10.925),(38.065,10.925),(38.065,10.755),(37.895,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,10.755),(38.255,10.925),(38.425,10.925),(38.425,10.755),(38.255,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.115),(37.175,11.285),(37.345,11.285),(37.345,11.115),(37.175,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.115),(37.535,11.285),(37.705,11.285),(37.705,11.115),(37.535,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.115),(37.895,11.285),(38.065,11.285),(38.065,11.115),(37.895,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.115),(38.255,11.285),(38.425,11.285),(38.425,11.115),(38.255,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.475),(37.175,11.645),(37.345,11.645),(37.345,11.475),(37.175,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.475),(37.535,11.645),(37.705,11.645),(37.705,11.475),(37.535,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.475),(37.895,11.645),(38.065,11.645),(38.065,11.475),(37.895,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.475),(38.255,11.645),(38.425,11.645),(38.425,11.475),(38.255,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,11.835),(37.175,12.005),(37.345,12.005),(37.345,11.835),(37.175,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,11.835),(37.535,12.005),(37.705,12.005),(37.705,11.835),(37.535,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,11.835),(37.895,12.005),(38.065,12.005),(38.065,11.835),(37.895,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,11.835),(38.255,12.005),(38.425,12.005),(38.425,11.835),(38.255,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.195),(37.175,12.365),(37.345,12.365),(37.345,12.195),(37.175,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.195),(37.535,12.365),(37.705,12.365),(37.705,12.195),(37.535,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.195),(37.895,12.365),(38.065,12.365),(38.065,12.195),(37.895,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.195),(38.255,12.365),(38.425,12.365),(38.425,12.195),(38.255,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.555),(37.175,12.725),(37.345,12.725),(37.345,12.555),(37.175,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.555),(37.535,12.725),(37.705,12.725),(37.705,12.555),(37.535,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.555),(37.895,12.725),(38.065,12.725),(38.065,12.555),(37.895,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.555),(38.255,12.725),(38.425,12.725),(38.425,12.555),(38.255,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,12.915),(37.175,13.085),(37.345,13.085),(37.345,12.915),(37.175,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,12.915),(37.535,13.085),(37.705,13.085),(37.705,12.915),(37.535,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,12.915),(37.895,13.085),(38.065,13.085),(38.065,12.915),(37.895,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,12.915),(38.255,13.085),(38.425,13.085),(38.425,12.915),(38.255,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.275),(37.175,13.445),(37.345,13.445),(37.345,13.275),(37.175,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.275),(37.535,13.445),(37.705,13.445),(37.705,13.275),(37.535,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.275),(37.895,13.445),(38.065,13.445),(38.065,13.275),(37.895,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.275),(38.255,13.445),(38.425,13.445),(38.425,13.275),(38.255,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.635),(37.175,13.805),(37.345,13.805),(37.345,13.635),(37.175,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.635),(37.535,13.805),(37.705,13.805),(37.705,13.635),(37.535,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.635),(37.895,13.805),(38.065,13.805),(38.065,13.635),(37.895,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.635),(38.255,13.805),(38.425,13.805),(38.425,13.635),(38.255,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,13.995),(37.175,14.165),(37.345,14.165),(37.345,13.995),(37.175,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,13.995),(37.535,14.165),(37.705,14.165),(37.705,13.995),(37.535,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,13.995),(37.895,14.165),(38.065,14.165),(38.065,13.995),(37.895,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,13.995),(38.255,14.165),(38.425,14.165),(38.425,13.995),(38.255,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.355),(37.175,14.525),(37.345,14.525),(37.345,14.355),(37.175,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.355),(37.535,14.525),(37.705,14.525),(37.705,14.355),(37.535,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.355),(37.895,14.525),(38.065,14.525),(38.065,14.355),(37.895,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.355),(38.255,14.525),(38.425,14.525),(38.425,14.355),(38.255,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,14.715),(37.175,14.885),(37.345,14.885),(37.345,14.715),(37.175,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,14.715),(37.535,14.885),(37.705,14.885),(37.705,14.715),(37.535,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,14.715),(37.895,14.885),(38.065,14.885),(38.065,14.715),(37.895,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,14.715),(38.255,14.885),(38.425,14.885),(38.425,14.715),(38.255,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.075),(37.175,15.245),(37.345,15.245),(37.345,15.075),(37.175,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.075),(37.535,15.245),(37.705,15.245),(37.705,15.075),(37.535,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.075),(37.895,15.245),(38.065,15.245),(38.065,15.075),(37.895,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.075),(38.255,15.245),(38.425,15.245),(38.425,15.075),(38.255,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.435),(37.175,15.605),(37.345,15.605),(37.345,15.435),(37.175,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.435),(37.535,15.605),(37.705,15.605),(37.705,15.435),(37.535,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.435),(37.895,15.605),(38.065,15.605),(38.065,15.435),(37.895,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.435),(38.255,15.605),(38.425,15.605),(38.425,15.435),(38.255,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,15.795),(37.175,15.965),(37.345,15.965),(37.345,15.795),(37.175,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,15.795),(37.535,15.965),(37.705,15.965),(37.705,15.795),(37.535,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,15.795),(37.895,15.965),(38.065,15.965),(38.065,15.795),(37.895,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,15.795),(38.255,15.965),(38.425,15.965),(38.425,15.795),(38.255,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.155),(37.175,16.325),(37.345,16.325),(37.345,16.155),(37.175,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.155),(37.535,16.325),(37.705,16.325),(37.705,16.155),(37.535,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.155),(37.895,16.325),(38.065,16.325),(38.065,16.155),(37.895,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.155),(38.255,16.325),(38.425,16.325),(38.425,16.155),(38.255,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.515),(37.175,16.685),(37.345,16.685),(37.345,16.515),(37.175,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.515),(37.535,16.685),(37.705,16.685),(37.705,16.515),(37.535,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.515),(37.895,16.685),(38.065,16.685),(38.065,16.515),(37.895,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.515),(38.255,16.685),(38.425,16.685),(38.425,16.515),(38.255,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,16.875),(37.175,17.045),(37.345,17.045),(37.345,16.875),(37.175,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,16.875),(37.535,17.045),(37.705,17.045),(37.705,16.875),(37.535,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,16.875),(37.895,17.045),(38.065,17.045),(38.065,16.875),(37.895,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,16.875),(38.255,17.045),(38.425,17.045),(38.425,16.875),(38.255,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.235),(37.175,17.405),(37.345,17.405),(37.345,17.235),(37.175,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.235),(37.535,17.405),(37.705,17.405),(37.705,17.235),(37.535,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.235),(37.895,17.405),(38.065,17.405),(38.065,17.235),(37.895,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.235),(38.255,17.405),(38.425,17.405),(38.425,17.235),(38.255,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.595),(37.175,17.765),(37.345,17.765),(37.345,17.595),(37.175,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.595),(37.535,17.765),(37.705,17.765),(37.705,17.595),(37.535,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.595),(37.895,17.765),(38.065,17.765),(38.065,17.595),(37.895,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.595),(38.255,17.765),(38.425,17.765),(38.425,17.595),(38.255,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,17.955),(37.175,18.125),(37.345,18.125),(37.345,17.955),(37.175,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,17.955),(37.535,18.125),(37.705,18.125),(37.705,17.955),(37.535,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,17.955),(37.895,18.125),(38.065,18.125),(38.065,17.955),(37.895,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,17.955),(38.255,18.125),(38.425,18.125),(38.425,17.955),(38.255,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.315),(37.175,18.485),(37.345,18.485),(37.345,18.315),(37.175,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.315),(37.535,18.485),(37.705,18.485),(37.705,18.315),(37.535,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.315),(37.895,18.485),(38.065,18.485),(38.065,18.315),(37.895,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.315),(38.255,18.485),(38.425,18.485),(38.425,18.315),(38.255,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,18.675),(37.175,18.845),(37.345,18.845),(37.345,18.675),(37.175,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,18.675),(37.535,18.845),(37.705,18.845),(37.705,18.675),(37.535,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,18.675),(37.895,18.845),(38.065,18.845),(38.065,18.675),(37.895,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,18.675),(38.255,18.845),(38.425,18.845),(38.425,18.675),(38.255,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.035),(37.175,19.205),(37.345,19.205),(37.345,19.035),(37.175,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.035),(37.535,19.205),(37.705,19.205),(37.705,19.035),(37.535,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.035),(37.895,19.205),(38.065,19.205),(38.065,19.035),(37.895,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.035),(38.255,19.205),(38.425,19.205),(38.425,19.035),(38.255,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.395),(37.175,19.565),(37.345,19.565),(37.345,19.395),(37.175,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.395),(37.535,19.565),(37.705,19.565),(37.705,19.395),(37.535,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.395),(37.895,19.565),(38.065,19.565),(38.065,19.395),(37.895,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.395),(38.255,19.565),(38.425,19.565),(38.425,19.395),(38.255,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,19.755),(37.175,19.925),(37.345,19.925),(37.345,19.755),(37.175,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,19.755),(37.535,19.925),(37.705,19.925),(37.705,19.755),(37.535,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,19.755),(37.895,19.925),(38.065,19.925),(38.065,19.755),(37.895,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,19.755),(38.255,19.925),(38.425,19.925),(38.425,19.755),(38.255,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.115),(37.175,20.285),(37.345,20.285),(37.345,20.115),(37.175,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.115),(37.535,20.285),(37.705,20.285),(37.705,20.115),(37.535,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.115),(37.895,20.285),(38.065,20.285),(38.065,20.115),(37.895,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.115),(38.255,20.285),(38.425,20.285),(38.425,20.115),(38.255,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.475),(37.175,20.645),(37.345,20.645),(37.345,20.475),(37.175,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.475),(37.535,20.645),(37.705,20.645),(37.705,20.475),(37.535,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.475),(37.895,20.645),(38.065,20.645),(38.065,20.475),(37.895,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.475),(38.255,20.645),(38.425,20.645),(38.425,20.475),(38.255,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,20.835),(37.175,21.005),(37.345,21.005),(37.345,20.835),(37.175,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,20.835),(37.535,21.005),(37.705,21.005),(37.705,20.835),(37.535,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,20.835),(37.895,21.005),(38.065,21.005),(38.065,20.835),(37.895,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,20.835),(38.255,21.005),(38.425,21.005),(38.425,20.835),(38.255,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.195),(37.175,21.365),(37.345,21.365),(37.345,21.195),(37.175,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.195),(37.535,21.365),(37.705,21.365),(37.705,21.195),(37.535,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.195),(37.895,21.365),(38.065,21.365),(38.065,21.195),(37.895,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.195),(38.255,21.365),(38.425,21.365),(38.425,21.195),(38.255,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.555),(37.175,21.725),(37.345,21.725),(37.345,21.555),(37.175,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.555),(37.535,21.725),(37.705,21.725),(37.705,21.555),(37.535,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.555),(37.895,21.725),(38.065,21.725),(38.065,21.555),(37.895,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.555),(38.255,21.725),(38.425,21.725),(38.425,21.555),(38.255,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,21.915),(37.175,22.085),(37.345,22.085),(37.345,21.915),(37.175,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,21.915),(37.535,22.085),(37.705,22.085),(37.705,21.915),(37.535,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,21.915),(37.895,22.085),(38.065,22.085),(38.065,21.915),(37.895,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,21.915),(38.255,22.085),(38.425,22.085),(38.425,21.915),(38.255,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.275),(37.175,22.445),(37.345,22.445),(37.345,22.275),(37.175,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.275),(37.535,22.445),(37.705,22.445),(37.705,22.275),(37.535,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.275),(37.895,22.445),(38.065,22.445),(38.065,22.275),(37.895,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.275),(38.255,22.445),(38.425,22.445),(38.425,22.275),(38.255,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.635),(37.175,22.805),(37.345,22.805),(37.345,22.635),(37.175,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.635),(37.535,22.805),(37.705,22.805),(37.705,22.635),(37.535,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.635),(37.895,22.805),(38.065,22.805),(38.065,22.635),(37.895,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.635),(38.255,22.805),(38.425,22.805),(38.425,22.635),(38.255,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,22.995),(37.175,23.165),(37.345,23.165),(37.345,22.995),(37.175,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,22.995),(37.535,23.165),(37.705,23.165),(37.705,22.995),(37.535,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,22.995),(37.895,23.165),(38.065,23.165),(38.065,22.995),(37.895,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,22.995),(38.255,23.165),(38.425,23.165),(38.425,22.995),(38.255,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,23.355),(37.175,23.525),(37.345,23.525),(37.345,23.355),(37.175,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,23.355),(37.535,23.525),(37.705,23.525),(37.705,23.355),(37.535,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,23.355),(37.895,23.525),(38.065,23.525),(38.065,23.355),(37.895,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,23.355),(38.255,23.525),(38.425,23.525),(38.425,23.355),(38.255,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,23.715),(37.175,23.885),(37.345,23.885),(37.345,23.715),(37.175,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,23.715),(37.535,23.885),(37.705,23.885),(37.705,23.715),(37.535,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,23.715),(37.895,23.885),(38.065,23.885),(38.065,23.715),(37.895,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,23.715),(38.255,23.885),(38.425,23.885),(38.425,23.715),(38.255,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.075),(37.175,24.245),(37.345,24.245),(37.345,24.075),(37.175,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.075),(37.535,24.245),(37.705,24.245),(37.705,24.075),(37.535,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.075),(37.895,24.245),(38.065,24.245),(38.065,24.075),(37.895,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.075),(38.255,24.245),(38.425,24.245),(38.425,24.075),(38.255,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.435),(37.175,24.605),(37.345,24.605),(37.345,24.435),(37.175,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.435),(37.535,24.605),(37.705,24.605),(37.705,24.435),(37.535,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.435),(37.895,24.605),(38.065,24.605),(38.065,24.435),(37.895,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.435),(38.255,24.605),(38.425,24.605),(38.425,24.435),(38.255,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,24.795),(37.175,24.965),(37.345,24.965),(37.345,24.795),(37.175,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,24.795),(37.535,24.965),(37.705,24.965),(37.705,24.795),(37.535,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,24.795),(37.895,24.965),(38.065,24.965),(38.065,24.795),(37.895,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,24.795),(38.255,24.965),(38.425,24.965),(38.425,24.795),(38.255,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.155),(37.175,25.325),(37.345,25.325),(37.345,25.155),(37.175,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.155),(37.535,25.325),(37.705,25.325),(37.705,25.155),(37.535,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.155),(37.895,25.325),(38.065,25.325),(38.065,25.155),(37.895,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.155),(38.255,25.325),(38.425,25.325),(38.425,25.155),(38.255,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.515),(37.175,25.685),(37.345,25.685),(37.345,25.515),(37.175,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.515),(37.535,25.685),(37.705,25.685),(37.705,25.515),(37.535,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.515),(37.895,25.685),(38.065,25.685),(38.065,25.515),(37.895,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.515),(38.255,25.685),(38.425,25.685),(38.425,25.515),(38.255,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,25.875),(37.175,26.045),(37.345,26.045),(37.345,25.875),(37.175,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,25.875),(37.535,26.045),(37.705,26.045),(37.705,25.875),(37.535,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,25.875),(37.895,26.045),(38.065,26.045),(38.065,25.875),(37.895,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,25.875),(38.255,26.045),(38.425,26.045),(38.425,25.875),(38.255,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.235),(37.175,26.405),(37.345,26.405),(37.345,26.235),(37.175,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.235),(37.535,26.405),(37.705,26.405),(37.705,26.235),(37.535,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.235),(37.895,26.405),(38.065,26.405),(38.065,26.235),(37.895,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.235),(38.255,26.405),(38.425,26.405),(38.425,26.235),(38.255,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.595),(37.175,26.765),(37.345,26.765),(37.345,26.595),(37.175,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.595),(37.535,26.765),(37.705,26.765),(37.705,26.595),(37.535,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.595),(37.895,26.765),(38.065,26.765),(38.065,26.595),(37.895,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.595),(38.255,26.765),(38.425,26.765),(38.425,26.595),(38.255,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,26.955),(37.175,27.125),(37.345,27.125),(37.345,26.955),(37.175,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,26.955),(37.535,27.125),(37.705,27.125),(37.705,26.955),(37.535,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,26.955),(37.895,27.125),(38.065,27.125),(38.065,26.955),(37.895,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,26.955),(38.255,27.125),(38.425,27.125),(38.425,26.955),(38.255,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,27.315),(37.175,27.485),(37.345,27.485),(37.345,27.315),(37.175,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,27.315),(37.535,27.485),(37.705,27.485),(37.705,27.315),(37.535,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,27.315),(37.895,27.485),(38.065,27.485),(38.065,27.315),(37.895,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,27.315),(38.255,27.485),(38.425,27.485),(38.425,27.315),(38.255,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,27.675),(37.175,27.845),(37.345,27.845),(37.345,27.675),(37.175,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,27.675),(37.535,27.845),(37.705,27.845),(37.705,27.675),(37.535,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,27.675),(37.895,27.845),(38.065,27.845),(38.065,27.675),(37.895,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,27.675),(38.255,27.845),(38.425,27.845),(38.425,27.675),(38.255,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.035),(37.175,28.205),(37.345,28.205),(37.345,28.035),(37.175,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.035),(37.535,28.205),(37.705,28.205),(37.705,28.035),(37.535,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.035),(37.895,28.205),(38.065,28.205),(38.065,28.035),(37.895,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.035),(38.255,28.205),(38.425,28.205),(38.425,28.035),(38.255,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.395),(37.175,28.565),(37.345,28.565),(37.345,28.395),(37.175,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.395),(37.535,28.565),(37.705,28.565),(37.705,28.395),(37.535,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.395),(37.895,28.565),(38.065,28.565),(38.065,28.395),(37.895,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.395),(38.255,28.565),(38.425,28.565),(38.425,28.395),(38.255,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,28.755),(37.175,28.925),(37.345,28.925),(37.345,28.755),(37.175,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,28.755),(37.535,28.925),(37.705,28.925),(37.705,28.755),(37.535,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,28.755),(37.895,28.925),(38.065,28.925),(38.065,28.755),(37.895,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,28.755),(38.255,28.925),(38.425,28.925),(38.425,28.755),(38.255,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.115),(37.175,29.285),(37.345,29.285),(37.345,29.115),(37.175,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.115),(37.535,29.285),(37.705,29.285),(37.705,29.115),(37.535,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.115),(37.895,29.285),(38.065,29.285),(38.065,29.115),(37.895,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.115),(38.255,29.285),(38.425,29.285),(38.425,29.115),(38.255,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.475),(37.175,29.645),(37.345,29.645),(37.345,29.475),(37.175,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.475),(37.535,29.645),(37.705,29.645),(37.705,29.475),(37.535,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.475),(37.895,29.645),(38.065,29.645),(38.065,29.475),(37.895,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.475),(38.255,29.645),(38.425,29.645),(38.425,29.475),(38.255,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,29.835),(37.175,30.005),(37.345,30.005),(37.345,29.835),(37.175,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,29.835),(37.535,30.005),(37.705,30.005),(37.705,29.835),(37.535,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,29.835),(37.895,30.005),(38.065,30.005),(38.065,29.835),(37.895,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,29.835),(38.255,30.005),(38.425,30.005),(38.425,29.835),(38.255,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.195),(37.175,30.365),(37.345,30.365),(37.345,30.195),(37.175,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.195),(37.535,30.365),(37.705,30.365),(37.705,30.195),(37.535,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.195),(37.895,30.365),(38.065,30.365),(38.065,30.195),(37.895,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.195),(38.255,30.365),(38.425,30.365),(38.425,30.195),(38.255,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.555),(37.175,30.725),(37.345,30.725),(37.345,30.555),(37.175,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.555),(37.535,30.725),(37.705,30.725),(37.705,30.555),(37.535,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.555),(37.895,30.725),(38.065,30.725),(38.065,30.555),(37.895,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.555),(38.255,30.725),(38.425,30.725),(38.425,30.555),(38.255,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,30.915),(37.175,31.085),(37.345,31.085),(37.345,30.915),(37.175,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,30.915),(37.535,31.085),(37.705,31.085),(37.705,30.915),(37.535,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,30.915),(37.895,31.085),(38.065,31.085),(38.065,30.915),(37.895,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,30.915),(38.255,31.085),(38.425,31.085),(38.425,30.915),(38.255,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.275),(37.175,31.445),(37.345,31.445),(37.345,31.275),(37.175,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.275),(37.535,31.445),(37.705,31.445),(37.705,31.275),(37.535,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.275),(37.895,31.445),(38.065,31.445),(38.065,31.275),(37.895,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.275),(38.255,31.445),(38.425,31.445),(38.425,31.275),(38.255,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.635),(37.175,31.805),(37.345,31.805),(37.345,31.635),(37.175,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.635),(37.535,31.805),(37.705,31.805),(37.705,31.635),(37.535,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.635),(37.895,31.805),(38.065,31.805),(38.065,31.635),(37.895,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.635),(38.255,31.805),(38.425,31.805),(38.425,31.635),(38.255,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,31.995),(37.175,32.165),(37.345,32.165),(37.345,31.995),(37.175,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,31.995),(37.535,32.165),(37.705,32.165),(37.705,31.995),(37.535,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,31.995),(37.895,32.165),(38.065,32.165),(38.065,31.995),(37.895,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,31.995),(38.255,32.165),(38.425,32.165),(38.425,31.995),(38.255,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,32.355),(37.175,32.525),(37.345,32.525),(37.345,32.355),(37.175,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,32.355),(37.535,32.525),(37.705,32.525),(37.705,32.355),(37.535,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,32.355),(37.895,32.525),(38.065,32.525),(38.065,32.355),(37.895,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,32.355),(38.255,32.525),(38.425,32.525),(38.425,32.355),(38.255,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,32.715),(37.175,32.885),(37.345,32.885),(37.345,32.715),(37.175,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,32.715),(37.535,32.885),(37.705,32.885),(37.705,32.715),(37.535,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,32.715),(37.895,32.885),(38.065,32.885),(38.065,32.715),(37.895,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,32.715),(38.255,32.885),(38.425,32.885),(38.425,32.715),(38.255,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.075),(37.175,33.245),(37.345,33.245),(37.345,33.075),(37.175,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.075),(37.535,33.245),(37.705,33.245),(37.705,33.075),(37.535,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.075),(37.895,33.245),(38.065,33.245),(38.065,33.075),(37.895,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.075),(38.255,33.245),(38.425,33.245),(38.425,33.075),(38.255,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.435),(37.175,33.605),(37.345,33.605),(37.345,33.435),(37.175,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.435),(37.535,33.605),(37.705,33.605),(37.705,33.435),(37.535,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.435),(37.895,33.605),(38.065,33.605),(38.065,33.435),(37.895,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.435),(38.255,33.605),(38.425,33.605),(38.425,33.435),(38.255,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,33.795),(37.175,33.965),(37.345,33.965),(37.345,33.795),(37.175,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,33.795),(37.535,33.965),(37.705,33.965),(37.705,33.795),(37.535,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,33.795),(37.895,33.965),(38.065,33.965),(38.065,33.795),(37.895,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,33.795),(38.255,33.965),(38.425,33.965),(38.425,33.795),(38.255,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.155),(37.175,34.325),(37.345,34.325),(37.345,34.155),(37.175,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.155),(37.535,34.325),(37.705,34.325),(37.705,34.155),(37.535,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.155),(37.895,34.325),(38.065,34.325),(38.065,34.155),(37.895,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.155),(38.255,34.325),(38.425,34.325),(38.425,34.155),(38.255,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.515),(37.175,34.685),(37.345,34.685),(37.345,34.515),(37.175,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.515),(37.535,34.685),(37.705,34.685),(37.705,34.515),(37.535,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.515),(37.895,34.685),(38.065,34.685),(38.065,34.515),(37.895,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.515),(38.255,34.685),(38.425,34.685),(38.425,34.515),(38.255,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,34.875),(37.175,35.045),(37.345,35.045),(37.345,34.875),(37.175,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,34.875),(37.535,35.045),(37.705,35.045),(37.705,34.875),(37.535,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,34.875),(37.895,35.045),(38.065,35.045),(38.065,34.875),(37.895,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,34.875),(38.255,35.045),(38.425,35.045),(38.425,34.875),(38.255,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.235),(37.175,35.405),(37.345,35.405),(37.345,35.235),(37.175,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.235),(37.535,35.405),(37.705,35.405),(37.705,35.235),(37.535,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.235),(37.895,35.405),(38.065,35.405),(38.065,35.235),(37.895,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.235),(38.255,35.405),(38.425,35.405),(38.425,35.235),(38.255,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.595),(37.175,35.765),(37.345,35.765),(37.345,35.595),(37.175,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.595),(37.535,35.765),(37.705,35.765),(37.705,35.595),(37.535,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.595),(37.895,35.765),(38.065,35.765),(38.065,35.595),(37.895,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.595),(38.255,35.765),(38.425,35.765),(38.425,35.595),(38.255,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,35.955),(37.175,36.125),(37.345,36.125),(37.345,35.955),(37.175,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,35.955),(37.535,36.125),(37.705,36.125),(37.705,35.955),(37.535,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,35.955),(37.895,36.125),(38.065,36.125),(38.065,35.955),(37.895,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,35.955),(38.255,36.125),(38.425,36.125),(38.425,35.955),(38.255,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,36.315),(37.175,36.485),(37.345,36.485),(37.345,36.315),(37.175,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,36.315),(37.535,36.485),(37.705,36.485),(37.705,36.315),(37.535,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,36.315),(37.895,36.485),(38.065,36.485),(38.065,36.315),(37.895,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,36.315),(38.255,36.485),(38.425,36.485),(38.425,36.315),(38.255,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,36.675),(37.175,36.845),(37.345,36.845),(37.345,36.675),(37.175,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,36.675),(37.535,36.845),(37.705,36.845),(37.705,36.675),(37.535,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,36.675),(37.895,36.845),(38.065,36.845),(38.065,36.675),(37.895,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,36.675),(38.255,36.845),(38.425,36.845),(38.425,36.675),(38.255,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.035),(37.175,37.205),(37.345,37.205),(37.345,37.035),(37.175,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.035),(37.535,37.205),(37.705,37.205),(37.705,37.035),(37.535,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.035),(37.895,37.205),(38.065,37.205),(38.065,37.035),(37.895,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.035),(38.255,37.205),(38.425,37.205),(38.425,37.035),(38.255,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.395),(37.175,37.565),(37.345,37.565),(37.345,37.395),(37.175,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.395),(37.535,37.565),(37.705,37.565),(37.705,37.395),(37.535,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.395),(37.895,37.565),(38.065,37.565),(38.065,37.395),(37.895,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.395),(38.255,37.565),(38.425,37.565),(38.425,37.395),(38.255,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,37.755),(37.175,37.925),(37.345,37.925),(37.345,37.755),(37.175,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,37.755),(37.535,37.925),(37.705,37.925),(37.705,37.755),(37.535,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,37.755),(37.895,37.925),(38.065,37.925),(38.065,37.755),(37.895,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,37.755),(38.255,37.925),(38.425,37.925),(38.425,37.755),(38.255,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.115),(37.175,38.285),(37.345,38.285),(37.345,38.115),(37.175,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.115),(37.535,38.285),(37.705,38.285),(37.705,38.115),(37.535,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.115),(37.895,38.285),(38.065,38.285),(38.065,38.115),(37.895,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.115),(38.255,38.285),(38.425,38.285),(38.425,38.115),(38.255,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.475),(37.175,38.645),(37.345,38.645),(37.345,38.475),(37.175,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.475),(37.535,38.645),(37.705,38.645),(37.705,38.475),(37.535,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.475),(37.895,38.645),(38.065,38.645),(38.065,38.475),(37.895,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.475),(38.255,38.645),(38.425,38.645),(38.425,38.475),(38.255,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,38.835),(37.175,39.005),(37.345,39.005),(37.345,38.835),(37.175,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,38.835),(37.535,39.005),(37.705,39.005),(37.705,38.835),(37.535,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,38.835),(37.895,39.005),(38.065,39.005),(38.065,38.835),(37.895,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,38.835),(38.255,39.005),(38.425,39.005),(38.425,38.835),(38.255,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.195),(37.175,39.365),(37.345,39.365),(37.345,39.195),(37.175,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.195),(37.535,39.365),(37.705,39.365),(37.705,39.195),(37.535,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.195),(37.895,39.365),(38.065,39.365),(38.065,39.195),(37.895,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.195),(38.255,39.365),(38.425,39.365),(38.425,39.195),(38.255,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.555),(37.175,39.725),(37.345,39.725),(37.345,39.555),(37.175,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.555),(37.535,39.725),(37.705,39.725),(37.705,39.555),(37.535,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.555),(37.895,39.725),(38.065,39.725),(38.065,39.555),(37.895,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.555),(38.255,39.725),(38.425,39.725),(38.425,39.555),(38.255,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,39.915),(37.175,40.085),(37.345,40.085),(37.345,39.915),(37.175,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,39.915),(37.535,40.085),(37.705,40.085),(37.705,39.915),(37.535,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,39.915),(37.895,40.085),(38.065,40.085),(38.065,39.915),(37.895,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,39.915),(38.255,40.085),(38.425,40.085),(38.425,39.915),(38.255,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,40.275),(37.175,40.445),(37.345,40.445),(37.345,40.275),(37.175,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,40.275),(37.535,40.445),(37.705,40.445),(37.705,40.275),(37.535,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,40.275),(37.895,40.445),(38.065,40.445),(38.065,40.275),(37.895,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,40.275),(38.255,40.445),(38.425,40.445),(38.425,40.275),(38.255,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.175,40.635),(37.175,40.805),(37.345,40.805),(37.345,40.635),(37.175,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.535,40.635),(37.535,40.805),(37.705,40.805),(37.705,40.635),(37.535,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((37.895,40.635),(37.895,40.805),(38.065,40.805),(38.065,40.635),(37.895,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((38.255,40.635),(38.255,40.805),(38.425,40.805),(38.425,40.635),(38.255,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,2.835),(32.375,3.005),(32.545,3.005),(32.545,2.835),(32.375,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,2.835),(32.735,3.005),(32.905,3.005),(32.905,2.835),(32.735,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,2.835),(33.095,3.005),(33.265,3.005),(33.265,2.835),(33.095,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,2.835),(33.455,3.005),(33.625,3.005),(33.625,2.835),(33.455,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.195),(32.375,3.365),(32.545,3.365),(32.545,3.195),(32.375,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.195),(32.735,3.365),(32.905,3.365),(32.905,3.195),(32.735,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.195),(33.095,3.365),(33.265,3.365),(33.265,3.195),(33.095,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.195),(33.455,3.365),(33.625,3.365),(33.625,3.195),(33.455,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.555),(32.375,3.725),(32.545,3.725),(32.545,3.555),(32.375,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.555),(32.735,3.725),(32.905,3.725),(32.905,3.555),(32.735,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.555),(33.095,3.725),(33.265,3.725),(33.265,3.555),(33.095,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.555),(33.455,3.725),(33.625,3.725),(33.625,3.555),(33.455,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,3.915),(32.375,4.085),(32.545,4.085),(32.545,3.915),(32.375,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,3.915),(32.735,4.085),(32.905,4.085),(32.905,3.915),(32.735,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,3.915),(33.095,4.085),(33.265,4.085),(33.265,3.915),(33.095,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,3.915),(33.455,4.085),(33.625,4.085),(33.625,3.915),(33.455,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.275),(32.375,4.445),(32.545,4.445),(32.545,4.275),(32.375,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.275),(32.735,4.445),(32.905,4.445),(32.905,4.275),(32.735,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.275),(33.095,4.445),(33.265,4.445),(33.265,4.275),(33.095,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.275),(33.455,4.445),(33.625,4.445),(33.625,4.275),(33.455,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.635),(32.375,4.805),(32.545,4.805),(32.545,4.635),(32.375,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.635),(32.735,4.805),(32.905,4.805),(32.905,4.635),(32.735,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.635),(33.095,4.805),(33.265,4.805),(33.265,4.635),(33.095,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.635),(33.455,4.805),(33.625,4.805),(33.625,4.635),(33.455,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,4.995),(32.375,5.165),(32.545,5.165),(32.545,4.995),(32.375,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,4.995),(32.735,5.165),(32.905,5.165),(32.905,4.995),(32.735,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,4.995),(33.095,5.165),(33.265,5.165),(33.265,4.995),(33.095,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,4.995),(33.455,5.165),(33.625,5.165),(33.625,4.995),(33.455,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.355),(32.375,5.525),(32.545,5.525),(32.545,5.355),(32.375,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.355),(32.735,5.525),(32.905,5.525),(32.905,5.355),(32.735,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.355),(33.095,5.525),(33.265,5.525),(33.265,5.355),(33.095,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.355),(33.455,5.525),(33.625,5.525),(33.625,5.355),(33.455,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,5.715),(32.375,5.885),(32.545,5.885),(32.545,5.715),(32.375,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,5.715),(32.735,5.885),(32.905,5.885),(32.905,5.715),(32.735,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,5.715),(33.095,5.885),(33.265,5.885),(33.265,5.715),(33.095,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,5.715),(33.455,5.885),(33.625,5.885),(33.625,5.715),(33.455,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.075),(32.375,6.245),(32.545,6.245),(32.545,6.075),(32.375,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.075),(32.735,6.245),(32.905,6.245),(32.905,6.075),(32.735,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.075),(33.095,6.245),(33.265,6.245),(33.265,6.075),(33.095,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.075),(33.455,6.245),(33.625,6.245),(33.625,6.075),(33.455,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.435),(32.375,6.605),(32.545,6.605),(32.545,6.435),(32.375,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.435),(32.735,6.605),(32.905,6.605),(32.905,6.435),(32.735,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.435),(33.095,6.605),(33.265,6.605),(33.265,6.435),(33.095,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.435),(33.455,6.605),(33.625,6.605),(33.625,6.435),(33.455,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,6.795),(32.375,6.965),(32.545,6.965),(32.545,6.795),(32.375,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,6.795),(32.735,6.965),(32.905,6.965),(32.905,6.795),(32.735,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,6.795),(33.095,6.965),(33.265,6.965),(33.265,6.795),(33.095,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,6.795),(33.455,6.965),(33.625,6.965),(33.625,6.795),(33.455,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.155),(32.375,7.325),(32.545,7.325),(32.545,7.155),(32.375,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.155),(32.735,7.325),(32.905,7.325),(32.905,7.155),(32.735,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.155),(33.095,7.325),(33.265,7.325),(33.265,7.155),(33.095,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.155),(33.455,7.325),(33.625,7.325),(33.625,7.155),(33.455,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.515),(32.375,7.685),(32.545,7.685),(32.545,7.515),(32.375,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.515),(32.735,7.685),(32.905,7.685),(32.905,7.515),(32.735,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.515),(33.095,7.685),(33.265,7.685),(33.265,7.515),(33.095,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.515),(33.455,7.685),(33.625,7.685),(33.625,7.515),(33.455,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,7.875),(32.375,8.045),(32.545,8.045),(32.545,7.875),(32.375,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,7.875),(32.735,8.045),(32.905,8.045),(32.905,7.875),(32.735,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,7.875),(33.095,8.045),(33.265,8.045),(33.265,7.875),(33.095,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,7.875),(33.455,8.045),(33.625,8.045),(33.625,7.875),(33.455,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.235),(32.375,8.405),(32.545,8.405),(32.545,8.235),(32.375,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.235),(32.735,8.405),(32.905,8.405),(32.905,8.235),(32.735,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.235),(33.095,8.405),(33.265,8.405),(33.265,8.235),(33.095,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.235),(33.455,8.405),(33.625,8.405),(33.625,8.235),(33.455,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.595),(32.375,8.765),(32.545,8.765),(32.545,8.595),(32.375,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.595),(32.735,8.765),(32.905,8.765),(32.905,8.595),(32.735,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.595),(33.095,8.765),(33.265,8.765),(33.265,8.595),(33.095,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.595),(33.455,8.765),(33.625,8.765),(33.625,8.595),(33.455,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,8.955),(32.375,9.125),(32.545,9.125),(32.545,8.955),(32.375,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,8.955),(32.735,9.125),(32.905,9.125),(32.905,8.955),(32.735,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,8.955),(33.095,9.125),(33.265,9.125),(33.265,8.955),(33.095,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,8.955),(33.455,9.125),(33.625,9.125),(33.625,8.955),(33.455,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.315),(32.375,9.485),(32.545,9.485),(32.545,9.315),(32.375,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.315),(32.735,9.485),(32.905,9.485),(32.905,9.315),(32.735,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.315),(33.095,9.485),(33.265,9.485),(33.265,9.315),(33.095,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.315),(33.455,9.485),(33.625,9.485),(33.625,9.315),(33.455,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,9.675),(32.375,9.845),(32.545,9.845),(32.545,9.675),(32.375,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,9.675),(32.735,9.845),(32.905,9.845),(32.905,9.675),(32.735,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,9.675),(33.095,9.845),(33.265,9.845),(33.265,9.675),(33.095,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,9.675),(33.455,9.845),(33.625,9.845),(33.625,9.675),(33.455,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.035),(32.375,10.205),(32.545,10.205),(32.545,10.035),(32.375,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.035),(32.735,10.205),(32.905,10.205),(32.905,10.035),(32.735,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.035),(33.095,10.205),(33.265,10.205),(33.265,10.035),(33.095,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.035),(33.455,10.205),(33.625,10.205),(33.625,10.035),(33.455,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.395),(32.375,10.565),(32.545,10.565),(32.545,10.395),(32.375,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.395),(32.735,10.565),(32.905,10.565),(32.905,10.395),(32.735,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.395),(33.095,10.565),(33.265,10.565),(33.265,10.395),(33.095,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.395),(33.455,10.565),(33.625,10.565),(33.625,10.395),(33.455,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,10.755),(32.375,10.925),(32.545,10.925),(32.545,10.755),(32.375,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,10.755),(32.735,10.925),(32.905,10.925),(32.905,10.755),(32.735,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,10.755),(33.095,10.925),(33.265,10.925),(33.265,10.755),(33.095,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,10.755),(33.455,10.925),(33.625,10.925),(33.625,10.755),(33.455,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.115),(32.375,11.285),(32.545,11.285),(32.545,11.115),(32.375,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.115),(32.735,11.285),(32.905,11.285),(32.905,11.115),(32.735,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.115),(33.095,11.285),(33.265,11.285),(33.265,11.115),(33.095,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.115),(33.455,11.285),(33.625,11.285),(33.625,11.115),(33.455,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.475),(32.375,11.645),(32.545,11.645),(32.545,11.475),(32.375,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.475),(32.735,11.645),(32.905,11.645),(32.905,11.475),(32.735,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.475),(33.095,11.645),(33.265,11.645),(33.265,11.475),(33.095,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.475),(33.455,11.645),(33.625,11.645),(33.625,11.475),(33.455,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,11.835),(32.375,12.005),(32.545,12.005),(32.545,11.835),(32.375,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,11.835),(32.735,12.005),(32.905,12.005),(32.905,11.835),(32.735,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,11.835),(33.095,12.005),(33.265,12.005),(33.265,11.835),(33.095,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,11.835),(33.455,12.005),(33.625,12.005),(33.625,11.835),(33.455,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.195),(32.375,12.365),(32.545,12.365),(32.545,12.195),(32.375,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.195),(32.735,12.365),(32.905,12.365),(32.905,12.195),(32.735,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.195),(33.095,12.365),(33.265,12.365),(33.265,12.195),(33.095,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.195),(33.455,12.365),(33.625,12.365),(33.625,12.195),(33.455,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.555),(32.375,12.725),(32.545,12.725),(32.545,12.555),(32.375,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.555),(32.735,12.725),(32.905,12.725),(32.905,12.555),(32.735,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.555),(33.095,12.725),(33.265,12.725),(33.265,12.555),(33.095,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.555),(33.455,12.725),(33.625,12.725),(33.625,12.555),(33.455,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,12.915),(32.375,13.085),(32.545,13.085),(32.545,12.915),(32.375,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,12.915),(32.735,13.085),(32.905,13.085),(32.905,12.915),(32.735,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,12.915),(33.095,13.085),(33.265,13.085),(33.265,12.915),(33.095,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,12.915),(33.455,13.085),(33.625,13.085),(33.625,12.915),(33.455,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.275),(32.375,13.445),(32.545,13.445),(32.545,13.275),(32.375,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.275),(32.735,13.445),(32.905,13.445),(32.905,13.275),(32.735,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.275),(33.095,13.445),(33.265,13.445),(33.265,13.275),(33.095,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.275),(33.455,13.445),(33.625,13.445),(33.625,13.275),(33.455,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.635),(32.375,13.805),(32.545,13.805),(32.545,13.635),(32.375,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.635),(32.735,13.805),(32.905,13.805),(32.905,13.635),(32.735,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.635),(33.095,13.805),(33.265,13.805),(33.265,13.635),(33.095,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.635),(33.455,13.805),(33.625,13.805),(33.625,13.635),(33.455,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,13.995),(32.375,14.165),(32.545,14.165),(32.545,13.995),(32.375,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,13.995),(32.735,14.165),(32.905,14.165),(32.905,13.995),(32.735,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,13.995),(33.095,14.165),(33.265,14.165),(33.265,13.995),(33.095,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,13.995),(33.455,14.165),(33.625,14.165),(33.625,13.995),(33.455,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.355),(32.375,14.525),(32.545,14.525),(32.545,14.355),(32.375,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.355),(32.735,14.525),(32.905,14.525),(32.905,14.355),(32.735,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.355),(33.095,14.525),(33.265,14.525),(33.265,14.355),(33.095,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.355),(33.455,14.525),(33.625,14.525),(33.625,14.355),(33.455,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,14.715),(32.375,14.885),(32.545,14.885),(32.545,14.715),(32.375,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,14.715),(32.735,14.885),(32.905,14.885),(32.905,14.715),(32.735,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,14.715),(33.095,14.885),(33.265,14.885),(33.265,14.715),(33.095,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,14.715),(33.455,14.885),(33.625,14.885),(33.625,14.715),(33.455,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.075),(32.375,15.245),(32.545,15.245),(32.545,15.075),(32.375,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.075),(32.735,15.245),(32.905,15.245),(32.905,15.075),(32.735,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.075),(33.095,15.245),(33.265,15.245),(33.265,15.075),(33.095,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.075),(33.455,15.245),(33.625,15.245),(33.625,15.075),(33.455,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.435),(32.375,15.605),(32.545,15.605),(32.545,15.435),(32.375,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.435),(32.735,15.605),(32.905,15.605),(32.905,15.435),(32.735,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.435),(33.095,15.605),(33.265,15.605),(33.265,15.435),(33.095,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.435),(33.455,15.605),(33.625,15.605),(33.625,15.435),(33.455,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,15.795),(32.375,15.965),(32.545,15.965),(32.545,15.795),(32.375,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,15.795),(32.735,15.965),(32.905,15.965),(32.905,15.795),(32.735,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,15.795),(33.095,15.965),(33.265,15.965),(33.265,15.795),(33.095,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,15.795),(33.455,15.965),(33.625,15.965),(33.625,15.795),(33.455,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.155),(32.375,16.325),(32.545,16.325),(32.545,16.155),(32.375,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.155),(32.735,16.325),(32.905,16.325),(32.905,16.155),(32.735,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.155),(33.095,16.325),(33.265,16.325),(33.265,16.155),(33.095,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.155),(33.455,16.325),(33.625,16.325),(33.625,16.155),(33.455,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.515),(32.375,16.685),(32.545,16.685),(32.545,16.515),(32.375,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.515),(32.735,16.685),(32.905,16.685),(32.905,16.515),(32.735,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.515),(33.095,16.685),(33.265,16.685),(33.265,16.515),(33.095,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.515),(33.455,16.685),(33.625,16.685),(33.625,16.515),(33.455,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,16.875),(32.375,17.045),(32.545,17.045),(32.545,16.875),(32.375,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,16.875),(32.735,17.045),(32.905,17.045),(32.905,16.875),(32.735,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,16.875),(33.095,17.045),(33.265,17.045),(33.265,16.875),(33.095,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,16.875),(33.455,17.045),(33.625,17.045),(33.625,16.875),(33.455,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.235),(32.375,17.405),(32.545,17.405),(32.545,17.235),(32.375,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.235),(32.735,17.405),(32.905,17.405),(32.905,17.235),(32.735,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.235),(33.095,17.405),(33.265,17.405),(33.265,17.235),(33.095,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.235),(33.455,17.405),(33.625,17.405),(33.625,17.235),(33.455,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.595),(32.375,17.765),(32.545,17.765),(32.545,17.595),(32.375,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.595),(32.735,17.765),(32.905,17.765),(32.905,17.595),(32.735,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.595),(33.095,17.765),(33.265,17.765),(33.265,17.595),(33.095,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.595),(33.455,17.765),(33.625,17.765),(33.625,17.595),(33.455,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,17.955),(32.375,18.125),(32.545,18.125),(32.545,17.955),(32.375,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,17.955),(32.735,18.125),(32.905,18.125),(32.905,17.955),(32.735,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,17.955),(33.095,18.125),(33.265,18.125),(33.265,17.955),(33.095,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,17.955),(33.455,18.125),(33.625,18.125),(33.625,17.955),(33.455,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.315),(32.375,18.485),(32.545,18.485),(32.545,18.315),(32.375,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.315),(32.735,18.485),(32.905,18.485),(32.905,18.315),(32.735,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.315),(33.095,18.485),(33.265,18.485),(33.265,18.315),(33.095,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.315),(33.455,18.485),(33.625,18.485),(33.625,18.315),(33.455,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,18.675),(32.375,18.845),(32.545,18.845),(32.545,18.675),(32.375,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,18.675),(32.735,18.845),(32.905,18.845),(32.905,18.675),(32.735,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,18.675),(33.095,18.845),(33.265,18.845),(33.265,18.675),(33.095,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,18.675),(33.455,18.845),(33.625,18.845),(33.625,18.675),(33.455,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.035),(32.375,19.205),(32.545,19.205),(32.545,19.035),(32.375,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.035),(32.735,19.205),(32.905,19.205),(32.905,19.035),(32.735,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.035),(33.095,19.205),(33.265,19.205),(33.265,19.035),(33.095,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.035),(33.455,19.205),(33.625,19.205),(33.625,19.035),(33.455,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.395),(32.375,19.565),(32.545,19.565),(32.545,19.395),(32.375,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.395),(32.735,19.565),(32.905,19.565),(32.905,19.395),(32.735,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.395),(33.095,19.565),(33.265,19.565),(33.265,19.395),(33.095,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.395),(33.455,19.565),(33.625,19.565),(33.625,19.395),(33.455,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,19.755),(32.375,19.925),(32.545,19.925),(32.545,19.755),(32.375,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,19.755),(32.735,19.925),(32.905,19.925),(32.905,19.755),(32.735,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,19.755),(33.095,19.925),(33.265,19.925),(33.265,19.755),(33.095,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,19.755),(33.455,19.925),(33.625,19.925),(33.625,19.755),(33.455,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.115),(32.375,20.285),(32.545,20.285),(32.545,20.115),(32.375,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.115),(32.735,20.285),(32.905,20.285),(32.905,20.115),(32.735,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.115),(33.095,20.285),(33.265,20.285),(33.265,20.115),(33.095,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.115),(33.455,20.285),(33.625,20.285),(33.625,20.115),(33.455,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.475),(32.375,20.645),(32.545,20.645),(32.545,20.475),(32.375,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.475),(32.735,20.645),(32.905,20.645),(32.905,20.475),(32.735,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.475),(33.095,20.645),(33.265,20.645),(33.265,20.475),(33.095,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.475),(33.455,20.645),(33.625,20.645),(33.625,20.475),(33.455,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,20.835),(32.375,21.005),(32.545,21.005),(32.545,20.835),(32.375,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,20.835),(32.735,21.005),(32.905,21.005),(32.905,20.835),(32.735,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,20.835),(33.095,21.005),(33.265,21.005),(33.265,20.835),(33.095,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,20.835),(33.455,21.005),(33.625,21.005),(33.625,20.835),(33.455,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.195),(32.375,21.365),(32.545,21.365),(32.545,21.195),(32.375,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.195),(32.735,21.365),(32.905,21.365),(32.905,21.195),(32.735,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.195),(33.095,21.365),(33.265,21.365),(33.265,21.195),(33.095,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.195),(33.455,21.365),(33.625,21.365),(33.625,21.195),(33.455,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.555),(32.375,21.725),(32.545,21.725),(32.545,21.555),(32.375,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.555),(32.735,21.725),(32.905,21.725),(32.905,21.555),(32.735,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.555),(33.095,21.725),(33.265,21.725),(33.265,21.555),(33.095,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.555),(33.455,21.725),(33.625,21.725),(33.625,21.555),(33.455,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,21.915),(32.375,22.085),(32.545,22.085),(32.545,21.915),(32.375,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,21.915),(32.735,22.085),(32.905,22.085),(32.905,21.915),(32.735,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,21.915),(33.095,22.085),(33.265,22.085),(33.265,21.915),(33.095,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,21.915),(33.455,22.085),(33.625,22.085),(33.625,21.915),(33.455,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.275),(32.375,22.445),(32.545,22.445),(32.545,22.275),(32.375,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.275),(32.735,22.445),(32.905,22.445),(32.905,22.275),(32.735,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.275),(33.095,22.445),(33.265,22.445),(33.265,22.275),(33.095,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.275),(33.455,22.445),(33.625,22.445),(33.625,22.275),(33.455,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.635),(32.375,22.805),(32.545,22.805),(32.545,22.635),(32.375,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.635),(32.735,22.805),(32.905,22.805),(32.905,22.635),(32.735,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.635),(33.095,22.805),(33.265,22.805),(33.265,22.635),(33.095,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.635),(33.455,22.805),(33.625,22.805),(33.625,22.635),(33.455,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,22.995),(32.375,23.165),(32.545,23.165),(32.545,22.995),(32.375,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,22.995),(32.735,23.165),(32.905,23.165),(32.905,22.995),(32.735,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,22.995),(33.095,23.165),(33.265,23.165),(33.265,22.995),(33.095,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,22.995),(33.455,23.165),(33.625,23.165),(33.625,22.995),(33.455,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,23.355),(32.375,23.525),(32.545,23.525),(32.545,23.355),(32.375,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,23.355),(32.735,23.525),(32.905,23.525),(32.905,23.355),(32.735,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,23.355),(33.095,23.525),(33.265,23.525),(33.265,23.355),(33.095,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,23.355),(33.455,23.525),(33.625,23.525),(33.625,23.355),(33.455,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,23.715),(32.375,23.885),(32.545,23.885),(32.545,23.715),(32.375,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,23.715),(32.735,23.885),(32.905,23.885),(32.905,23.715),(32.735,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,23.715),(33.095,23.885),(33.265,23.885),(33.265,23.715),(33.095,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,23.715),(33.455,23.885),(33.625,23.885),(33.625,23.715),(33.455,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.075),(32.375,24.245),(32.545,24.245),(32.545,24.075),(32.375,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.075),(32.735,24.245),(32.905,24.245),(32.905,24.075),(32.735,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.075),(33.095,24.245),(33.265,24.245),(33.265,24.075),(33.095,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.075),(33.455,24.245),(33.625,24.245),(33.625,24.075),(33.455,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.435),(32.375,24.605),(32.545,24.605),(32.545,24.435),(32.375,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.435),(32.735,24.605),(32.905,24.605),(32.905,24.435),(32.735,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.435),(33.095,24.605),(33.265,24.605),(33.265,24.435),(33.095,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.435),(33.455,24.605),(33.625,24.605),(33.625,24.435),(33.455,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,24.795),(32.375,24.965),(32.545,24.965),(32.545,24.795),(32.375,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,24.795),(32.735,24.965),(32.905,24.965),(32.905,24.795),(32.735,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,24.795),(33.095,24.965),(33.265,24.965),(33.265,24.795),(33.095,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,24.795),(33.455,24.965),(33.625,24.965),(33.625,24.795),(33.455,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.155),(32.375,25.325),(32.545,25.325),(32.545,25.155),(32.375,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.155),(32.735,25.325),(32.905,25.325),(32.905,25.155),(32.735,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.155),(33.095,25.325),(33.265,25.325),(33.265,25.155),(33.095,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.155),(33.455,25.325),(33.625,25.325),(33.625,25.155),(33.455,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.515),(32.375,25.685),(32.545,25.685),(32.545,25.515),(32.375,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.515),(32.735,25.685),(32.905,25.685),(32.905,25.515),(32.735,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.515),(33.095,25.685),(33.265,25.685),(33.265,25.515),(33.095,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.515),(33.455,25.685),(33.625,25.685),(33.625,25.515),(33.455,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,25.875),(32.375,26.045),(32.545,26.045),(32.545,25.875),(32.375,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,25.875),(32.735,26.045),(32.905,26.045),(32.905,25.875),(32.735,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,25.875),(33.095,26.045),(33.265,26.045),(33.265,25.875),(33.095,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,25.875),(33.455,26.045),(33.625,26.045),(33.625,25.875),(33.455,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.235),(32.375,26.405),(32.545,26.405),(32.545,26.235),(32.375,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.235),(32.735,26.405),(32.905,26.405),(32.905,26.235),(32.735,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.235),(33.095,26.405),(33.265,26.405),(33.265,26.235),(33.095,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.235),(33.455,26.405),(33.625,26.405),(33.625,26.235),(33.455,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.595),(32.375,26.765),(32.545,26.765),(32.545,26.595),(32.375,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.595),(32.735,26.765),(32.905,26.765),(32.905,26.595),(32.735,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.595),(33.095,26.765),(33.265,26.765),(33.265,26.595),(33.095,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.595),(33.455,26.765),(33.625,26.765),(33.625,26.595),(33.455,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,26.955),(32.375,27.125),(32.545,27.125),(32.545,26.955),(32.375,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,26.955),(32.735,27.125),(32.905,27.125),(32.905,26.955),(32.735,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,26.955),(33.095,27.125),(33.265,27.125),(33.265,26.955),(33.095,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,26.955),(33.455,27.125),(33.625,27.125),(33.625,26.955),(33.455,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,27.315),(32.375,27.485),(32.545,27.485),(32.545,27.315),(32.375,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,27.315),(32.735,27.485),(32.905,27.485),(32.905,27.315),(32.735,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,27.315),(33.095,27.485),(33.265,27.485),(33.265,27.315),(33.095,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,27.315),(33.455,27.485),(33.625,27.485),(33.625,27.315),(33.455,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,27.675),(32.375,27.845),(32.545,27.845),(32.545,27.675),(32.375,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,27.675),(32.735,27.845),(32.905,27.845),(32.905,27.675),(32.735,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,27.675),(33.095,27.845),(33.265,27.845),(33.265,27.675),(33.095,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,27.675),(33.455,27.845),(33.625,27.845),(33.625,27.675),(33.455,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.035),(32.375,28.205),(32.545,28.205),(32.545,28.035),(32.375,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.035),(32.735,28.205),(32.905,28.205),(32.905,28.035),(32.735,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.035),(33.095,28.205),(33.265,28.205),(33.265,28.035),(33.095,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.035),(33.455,28.205),(33.625,28.205),(33.625,28.035),(33.455,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.395),(32.375,28.565),(32.545,28.565),(32.545,28.395),(32.375,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.395),(32.735,28.565),(32.905,28.565),(32.905,28.395),(32.735,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.395),(33.095,28.565),(33.265,28.565),(33.265,28.395),(33.095,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.395),(33.455,28.565),(33.625,28.565),(33.625,28.395),(33.455,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,28.755),(32.375,28.925),(32.545,28.925),(32.545,28.755),(32.375,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,28.755),(32.735,28.925),(32.905,28.925),(32.905,28.755),(32.735,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,28.755),(33.095,28.925),(33.265,28.925),(33.265,28.755),(33.095,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,28.755),(33.455,28.925),(33.625,28.925),(33.625,28.755),(33.455,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.115),(32.375,29.285),(32.545,29.285),(32.545,29.115),(32.375,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.115),(32.735,29.285),(32.905,29.285),(32.905,29.115),(32.735,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.115),(33.095,29.285),(33.265,29.285),(33.265,29.115),(33.095,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.115),(33.455,29.285),(33.625,29.285),(33.625,29.115),(33.455,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.475),(32.375,29.645),(32.545,29.645),(32.545,29.475),(32.375,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.475),(32.735,29.645),(32.905,29.645),(32.905,29.475),(32.735,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.475),(33.095,29.645),(33.265,29.645),(33.265,29.475),(33.095,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.475),(33.455,29.645),(33.625,29.645),(33.625,29.475),(33.455,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,29.835),(32.375,30.005),(32.545,30.005),(32.545,29.835),(32.375,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,29.835),(32.735,30.005),(32.905,30.005),(32.905,29.835),(32.735,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,29.835),(33.095,30.005),(33.265,30.005),(33.265,29.835),(33.095,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,29.835),(33.455,30.005),(33.625,30.005),(33.625,29.835),(33.455,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.195),(32.375,30.365),(32.545,30.365),(32.545,30.195),(32.375,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.195),(32.735,30.365),(32.905,30.365),(32.905,30.195),(32.735,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.195),(33.095,30.365),(33.265,30.365),(33.265,30.195),(33.095,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.195),(33.455,30.365),(33.625,30.365),(33.625,30.195),(33.455,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.555),(32.375,30.725),(32.545,30.725),(32.545,30.555),(32.375,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.555),(32.735,30.725),(32.905,30.725),(32.905,30.555),(32.735,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.555),(33.095,30.725),(33.265,30.725),(33.265,30.555),(33.095,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.555),(33.455,30.725),(33.625,30.725),(33.625,30.555),(33.455,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,30.915),(32.375,31.085),(32.545,31.085),(32.545,30.915),(32.375,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,30.915),(32.735,31.085),(32.905,31.085),(32.905,30.915),(32.735,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,30.915),(33.095,31.085),(33.265,31.085),(33.265,30.915),(33.095,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,30.915),(33.455,31.085),(33.625,31.085),(33.625,30.915),(33.455,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.275),(32.375,31.445),(32.545,31.445),(32.545,31.275),(32.375,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.275),(32.735,31.445),(32.905,31.445),(32.905,31.275),(32.735,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.275),(33.095,31.445),(33.265,31.445),(33.265,31.275),(33.095,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.275),(33.455,31.445),(33.625,31.445),(33.625,31.275),(33.455,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.635),(32.375,31.805),(32.545,31.805),(32.545,31.635),(32.375,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.635),(32.735,31.805),(32.905,31.805),(32.905,31.635),(32.735,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.635),(33.095,31.805),(33.265,31.805),(33.265,31.635),(33.095,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.635),(33.455,31.805),(33.625,31.805),(33.625,31.635),(33.455,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,31.995),(32.375,32.165),(32.545,32.165),(32.545,31.995),(32.375,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,31.995),(32.735,32.165),(32.905,32.165),(32.905,31.995),(32.735,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,31.995),(33.095,32.165),(33.265,32.165),(33.265,31.995),(33.095,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,31.995),(33.455,32.165),(33.625,32.165),(33.625,31.995),(33.455,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,32.355),(32.375,32.525),(32.545,32.525),(32.545,32.355),(32.375,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,32.355),(32.735,32.525),(32.905,32.525),(32.905,32.355),(32.735,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,32.355),(33.095,32.525),(33.265,32.525),(33.265,32.355),(33.095,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,32.355),(33.455,32.525),(33.625,32.525),(33.625,32.355),(33.455,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,32.715),(32.375,32.885),(32.545,32.885),(32.545,32.715),(32.375,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,32.715),(32.735,32.885),(32.905,32.885),(32.905,32.715),(32.735,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,32.715),(33.095,32.885),(33.265,32.885),(33.265,32.715),(33.095,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,32.715),(33.455,32.885),(33.625,32.885),(33.625,32.715),(33.455,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.075),(32.375,33.245),(32.545,33.245),(32.545,33.075),(32.375,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.075),(32.735,33.245),(32.905,33.245),(32.905,33.075),(32.735,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.075),(33.095,33.245),(33.265,33.245),(33.265,33.075),(33.095,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.075),(33.455,33.245),(33.625,33.245),(33.625,33.075),(33.455,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.435),(32.375,33.605),(32.545,33.605),(32.545,33.435),(32.375,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.435),(32.735,33.605),(32.905,33.605),(32.905,33.435),(32.735,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.435),(33.095,33.605),(33.265,33.605),(33.265,33.435),(33.095,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.435),(33.455,33.605),(33.625,33.605),(33.625,33.435),(33.455,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,33.795),(32.375,33.965),(32.545,33.965),(32.545,33.795),(32.375,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,33.795),(32.735,33.965),(32.905,33.965),(32.905,33.795),(32.735,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,33.795),(33.095,33.965),(33.265,33.965),(33.265,33.795),(33.095,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,33.795),(33.455,33.965),(33.625,33.965),(33.625,33.795),(33.455,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.155),(32.375,34.325),(32.545,34.325),(32.545,34.155),(32.375,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.155),(32.735,34.325),(32.905,34.325),(32.905,34.155),(32.735,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.155),(33.095,34.325),(33.265,34.325),(33.265,34.155),(33.095,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.155),(33.455,34.325),(33.625,34.325),(33.625,34.155),(33.455,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.515),(32.375,34.685),(32.545,34.685),(32.545,34.515),(32.375,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.515),(32.735,34.685),(32.905,34.685),(32.905,34.515),(32.735,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.515),(33.095,34.685),(33.265,34.685),(33.265,34.515),(33.095,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.515),(33.455,34.685),(33.625,34.685),(33.625,34.515),(33.455,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,34.875),(32.375,35.045),(32.545,35.045),(32.545,34.875),(32.375,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,34.875),(32.735,35.045),(32.905,35.045),(32.905,34.875),(32.735,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,34.875),(33.095,35.045),(33.265,35.045),(33.265,34.875),(33.095,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,34.875),(33.455,35.045),(33.625,35.045),(33.625,34.875),(33.455,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.235),(32.375,35.405),(32.545,35.405),(32.545,35.235),(32.375,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.235),(32.735,35.405),(32.905,35.405),(32.905,35.235),(32.735,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.235),(33.095,35.405),(33.265,35.405),(33.265,35.235),(33.095,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.235),(33.455,35.405),(33.625,35.405),(33.625,35.235),(33.455,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.595),(32.375,35.765),(32.545,35.765),(32.545,35.595),(32.375,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.595),(32.735,35.765),(32.905,35.765),(32.905,35.595),(32.735,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.595),(33.095,35.765),(33.265,35.765),(33.265,35.595),(33.095,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.595),(33.455,35.765),(33.625,35.765),(33.625,35.595),(33.455,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,35.955),(32.375,36.125),(32.545,36.125),(32.545,35.955),(32.375,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,35.955),(32.735,36.125),(32.905,36.125),(32.905,35.955),(32.735,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,35.955),(33.095,36.125),(33.265,36.125),(33.265,35.955),(33.095,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,35.955),(33.455,36.125),(33.625,36.125),(33.625,35.955),(33.455,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,36.315),(32.375,36.485),(32.545,36.485),(32.545,36.315),(32.375,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,36.315),(32.735,36.485),(32.905,36.485),(32.905,36.315),(32.735,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,36.315),(33.095,36.485),(33.265,36.485),(33.265,36.315),(33.095,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,36.315),(33.455,36.485),(33.625,36.485),(33.625,36.315),(33.455,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,36.675),(32.375,36.845),(32.545,36.845),(32.545,36.675),(32.375,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,36.675),(32.735,36.845),(32.905,36.845),(32.905,36.675),(32.735,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,36.675),(33.095,36.845),(33.265,36.845),(33.265,36.675),(33.095,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,36.675),(33.455,36.845),(33.625,36.845),(33.625,36.675),(33.455,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.035),(32.375,37.205),(32.545,37.205),(32.545,37.035),(32.375,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.035),(32.735,37.205),(32.905,37.205),(32.905,37.035),(32.735,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.035),(33.095,37.205),(33.265,37.205),(33.265,37.035),(33.095,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.035),(33.455,37.205),(33.625,37.205),(33.625,37.035),(33.455,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.395),(32.375,37.565),(32.545,37.565),(32.545,37.395),(32.375,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.395),(32.735,37.565),(32.905,37.565),(32.905,37.395),(32.735,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.395),(33.095,37.565),(33.265,37.565),(33.265,37.395),(33.095,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.395),(33.455,37.565),(33.625,37.565),(33.625,37.395),(33.455,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,37.755),(32.375,37.925),(32.545,37.925),(32.545,37.755),(32.375,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,37.755),(32.735,37.925),(32.905,37.925),(32.905,37.755),(32.735,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,37.755),(33.095,37.925),(33.265,37.925),(33.265,37.755),(33.095,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,37.755),(33.455,37.925),(33.625,37.925),(33.625,37.755),(33.455,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.115),(32.375,38.285),(32.545,38.285),(32.545,38.115),(32.375,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.115),(32.735,38.285),(32.905,38.285),(32.905,38.115),(32.735,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.115),(33.095,38.285),(33.265,38.285),(33.265,38.115),(33.095,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.115),(33.455,38.285),(33.625,38.285),(33.625,38.115),(33.455,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.475),(32.375,38.645),(32.545,38.645),(32.545,38.475),(32.375,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.475),(32.735,38.645),(32.905,38.645),(32.905,38.475),(32.735,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.475),(33.095,38.645),(33.265,38.645),(33.265,38.475),(33.095,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.475),(33.455,38.645),(33.625,38.645),(33.625,38.475),(33.455,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,38.835),(32.375,39.005),(32.545,39.005),(32.545,38.835),(32.375,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,38.835),(32.735,39.005),(32.905,39.005),(32.905,38.835),(32.735,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,38.835),(33.095,39.005),(33.265,39.005),(33.265,38.835),(33.095,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,38.835),(33.455,39.005),(33.625,39.005),(33.625,38.835),(33.455,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.195),(32.375,39.365),(32.545,39.365),(32.545,39.195),(32.375,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.195),(32.735,39.365),(32.905,39.365),(32.905,39.195),(32.735,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.195),(33.095,39.365),(33.265,39.365),(33.265,39.195),(33.095,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.195),(33.455,39.365),(33.625,39.365),(33.625,39.195),(33.455,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.555),(32.375,39.725),(32.545,39.725),(32.545,39.555),(32.375,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.555),(32.735,39.725),(32.905,39.725),(32.905,39.555),(32.735,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.555),(33.095,39.725),(33.265,39.725),(33.265,39.555),(33.095,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.555),(33.455,39.725),(33.625,39.725),(33.625,39.555),(33.455,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,39.915),(32.375,40.085),(32.545,40.085),(32.545,39.915),(32.375,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,39.915),(32.735,40.085),(32.905,40.085),(32.905,39.915),(32.735,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,39.915),(33.095,40.085),(33.265,40.085),(33.265,39.915),(33.095,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,39.915),(33.455,40.085),(33.625,40.085),(33.625,39.915),(33.455,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,40.275),(32.375,40.445),(32.545,40.445),(32.545,40.275),(32.375,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,40.275),(32.735,40.445),(32.905,40.445),(32.905,40.275),(32.735,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,40.275),(33.095,40.445),(33.265,40.445),(33.265,40.275),(33.095,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,40.275),(33.455,40.445),(33.625,40.445),(33.625,40.275),(33.455,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.375,40.635),(32.375,40.805),(32.545,40.805),(32.545,40.635),(32.375,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((32.735,40.635),(32.735,40.805),(32.905,40.805),(32.905,40.635),(32.735,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.095,40.635),(33.095,40.805),(33.265,40.805),(33.265,40.635),(33.095,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((33.455,40.635),(33.455,40.805),(33.625,40.805),(33.625,40.635),(33.455,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,2.835),(51.575,3.005),(51.745,3.005),(51.745,2.835),(51.575,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,2.835),(51.935,3.005),(52.105,3.005),(52.105,2.835),(51.935,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,2.835),(52.295,3.005),(52.465,3.005),(52.465,2.835),(52.295,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,2.835),(52.655,3.005),(52.825,3.005),(52.825,2.835),(52.655,2.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.195),(51.575,3.365),(51.745,3.365),(51.745,3.195),(51.575,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.195),(51.935,3.365),(52.105,3.365),(52.105,3.195),(51.935,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.195),(52.295,3.365),(52.465,3.365),(52.465,3.195),(52.295,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.195),(52.655,3.365),(52.825,3.365),(52.825,3.195),(52.655,3.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.555),(51.575,3.725),(51.745,3.725),(51.745,3.555),(51.575,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.555),(51.935,3.725),(52.105,3.725),(52.105,3.555),(51.935,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.555),(52.295,3.725),(52.465,3.725),(52.465,3.555),(52.295,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.555),(52.655,3.725),(52.825,3.725),(52.825,3.555),(52.655,3.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,3.915),(51.575,4.085),(51.745,4.085),(51.745,3.915),(51.575,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,3.915),(51.935,4.085),(52.105,4.085),(52.105,3.915),(51.935,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,3.915),(52.295,4.085),(52.465,4.085),(52.465,3.915),(52.295,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,3.915),(52.655,4.085),(52.825,4.085),(52.825,3.915),(52.655,3.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.275),(51.575,4.445),(51.745,4.445),(51.745,4.275),(51.575,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.275),(51.935,4.445),(52.105,4.445),(52.105,4.275),(51.935,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.275),(52.295,4.445),(52.465,4.445),(52.465,4.275),(52.295,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.275),(52.655,4.445),(52.825,4.445),(52.825,4.275),(52.655,4.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.635),(51.575,4.805),(51.745,4.805),(51.745,4.635),(51.575,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.635),(51.935,4.805),(52.105,4.805),(52.105,4.635),(51.935,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.635),(52.295,4.805),(52.465,4.805),(52.465,4.635),(52.295,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.635),(52.655,4.805),(52.825,4.805),(52.825,4.635),(52.655,4.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,4.995),(51.575,5.165),(51.745,5.165),(51.745,4.995),(51.575,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,4.995),(51.935,5.165),(52.105,5.165),(52.105,4.995),(51.935,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,4.995),(52.295,5.165),(52.465,5.165),(52.465,4.995),(52.295,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,4.995),(52.655,5.165),(52.825,5.165),(52.825,4.995),(52.655,4.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.355),(51.575,5.525),(51.745,5.525),(51.745,5.355),(51.575,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.355),(51.935,5.525),(52.105,5.525),(52.105,5.355),(51.935,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.355),(52.295,5.525),(52.465,5.525),(52.465,5.355),(52.295,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.355),(52.655,5.525),(52.825,5.525),(52.825,5.355),(52.655,5.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,5.715),(51.575,5.885),(51.745,5.885),(51.745,5.715),(51.575,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,5.715),(51.935,5.885),(52.105,5.885),(52.105,5.715),(51.935,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,5.715),(52.295,5.885),(52.465,5.885),(52.465,5.715),(52.295,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,5.715),(52.655,5.885),(52.825,5.885),(52.825,5.715),(52.655,5.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.075),(51.575,6.245),(51.745,6.245),(51.745,6.075),(51.575,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.075),(51.935,6.245),(52.105,6.245),(52.105,6.075),(51.935,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.075),(52.295,6.245),(52.465,6.245),(52.465,6.075),(52.295,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.075),(52.655,6.245),(52.825,6.245),(52.825,6.075),(52.655,6.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.435),(51.575,6.605),(51.745,6.605),(51.745,6.435),(51.575,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.435),(51.935,6.605),(52.105,6.605),(52.105,6.435),(51.935,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.435),(52.295,6.605),(52.465,6.605),(52.465,6.435),(52.295,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.435),(52.655,6.605),(52.825,6.605),(52.825,6.435),(52.655,6.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,6.795),(51.575,6.965),(51.745,6.965),(51.745,6.795),(51.575,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,6.795),(51.935,6.965),(52.105,6.965),(52.105,6.795),(51.935,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,6.795),(52.295,6.965),(52.465,6.965),(52.465,6.795),(52.295,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,6.795),(52.655,6.965),(52.825,6.965),(52.825,6.795),(52.655,6.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.155),(51.575,7.325),(51.745,7.325),(51.745,7.155),(51.575,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.155),(51.935,7.325),(52.105,7.325),(52.105,7.155),(51.935,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.155),(52.295,7.325),(52.465,7.325),(52.465,7.155),(52.295,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.155),(52.655,7.325),(52.825,7.325),(52.825,7.155),(52.655,7.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.515),(51.575,7.685),(51.745,7.685),(51.745,7.515),(51.575,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.515),(51.935,7.685),(52.105,7.685),(52.105,7.515),(51.935,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.515),(52.295,7.685),(52.465,7.685),(52.465,7.515),(52.295,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.515),(52.655,7.685),(52.825,7.685),(52.825,7.515),(52.655,7.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,7.875),(51.575,8.045),(51.745,8.045),(51.745,7.875),(51.575,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,7.875),(51.935,8.045),(52.105,8.045),(52.105,7.875),(51.935,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,7.875),(52.295,8.045),(52.465,8.045),(52.465,7.875),(52.295,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,7.875),(52.655,8.045),(52.825,8.045),(52.825,7.875),(52.655,7.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.235),(51.575,8.405),(51.745,8.405),(51.745,8.235),(51.575,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.235),(51.935,8.405),(52.105,8.405),(52.105,8.235),(51.935,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.235),(52.295,8.405),(52.465,8.405),(52.465,8.235),(52.295,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.235),(52.655,8.405),(52.825,8.405),(52.825,8.235),(52.655,8.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.595),(51.575,8.765),(51.745,8.765),(51.745,8.595),(51.575,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.595),(51.935,8.765),(52.105,8.765),(52.105,8.595),(51.935,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.595),(52.295,8.765),(52.465,8.765),(52.465,8.595),(52.295,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.595),(52.655,8.765),(52.825,8.765),(52.825,8.595),(52.655,8.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,8.955),(51.575,9.125),(51.745,9.125),(51.745,8.955),(51.575,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,8.955),(51.935,9.125),(52.105,9.125),(52.105,8.955),(51.935,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,8.955),(52.295,9.125),(52.465,9.125),(52.465,8.955),(52.295,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,8.955),(52.655,9.125),(52.825,9.125),(52.825,8.955),(52.655,8.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.315),(51.575,9.485),(51.745,9.485),(51.745,9.315),(51.575,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.315),(51.935,9.485),(52.105,9.485),(52.105,9.315),(51.935,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.315),(52.295,9.485),(52.465,9.485),(52.465,9.315),(52.295,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.315),(52.655,9.485),(52.825,9.485),(52.825,9.315),(52.655,9.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,9.675),(51.575,9.845),(51.745,9.845),(51.745,9.675),(51.575,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,9.675),(51.935,9.845),(52.105,9.845),(52.105,9.675),(51.935,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,9.675),(52.295,9.845),(52.465,9.845),(52.465,9.675),(52.295,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,9.675),(52.655,9.845),(52.825,9.845),(52.825,9.675),(52.655,9.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.035),(51.575,10.205),(51.745,10.205),(51.745,10.035),(51.575,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.035),(51.935,10.205),(52.105,10.205),(52.105,10.035),(51.935,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.035),(52.295,10.205),(52.465,10.205),(52.465,10.035),(52.295,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.035),(52.655,10.205),(52.825,10.205),(52.825,10.035),(52.655,10.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.395),(51.575,10.565),(51.745,10.565),(51.745,10.395),(51.575,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.395),(51.935,10.565),(52.105,10.565),(52.105,10.395),(51.935,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.395),(52.295,10.565),(52.465,10.565),(52.465,10.395),(52.295,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.395),(52.655,10.565),(52.825,10.565),(52.825,10.395),(52.655,10.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,10.755),(51.575,10.925),(51.745,10.925),(51.745,10.755),(51.575,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,10.755),(51.935,10.925),(52.105,10.925),(52.105,10.755),(51.935,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,10.755),(52.295,10.925),(52.465,10.925),(52.465,10.755),(52.295,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,10.755),(52.655,10.925),(52.825,10.925),(52.825,10.755),(52.655,10.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.115),(51.575,11.285),(51.745,11.285),(51.745,11.115),(51.575,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.115),(51.935,11.285),(52.105,11.285),(52.105,11.115),(51.935,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.115),(52.295,11.285),(52.465,11.285),(52.465,11.115),(52.295,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.115),(52.655,11.285),(52.825,11.285),(52.825,11.115),(52.655,11.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.475),(51.575,11.645),(51.745,11.645),(51.745,11.475),(51.575,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.475),(51.935,11.645),(52.105,11.645),(52.105,11.475),(51.935,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.475),(52.295,11.645),(52.465,11.645),(52.465,11.475),(52.295,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.475),(52.655,11.645),(52.825,11.645),(52.825,11.475),(52.655,11.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,11.835),(51.575,12.005),(51.745,12.005),(51.745,11.835),(51.575,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,11.835),(51.935,12.005),(52.105,12.005),(52.105,11.835),(51.935,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,11.835),(52.295,12.005),(52.465,12.005),(52.465,11.835),(52.295,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,11.835),(52.655,12.005),(52.825,12.005),(52.825,11.835),(52.655,11.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.195),(51.575,12.365),(51.745,12.365),(51.745,12.195),(51.575,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.195),(51.935,12.365),(52.105,12.365),(52.105,12.195),(51.935,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.195),(52.295,12.365),(52.465,12.365),(52.465,12.195),(52.295,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.195),(52.655,12.365),(52.825,12.365),(52.825,12.195),(52.655,12.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.555),(51.575,12.725),(51.745,12.725),(51.745,12.555),(51.575,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.555),(51.935,12.725),(52.105,12.725),(52.105,12.555),(51.935,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.555),(52.295,12.725),(52.465,12.725),(52.465,12.555),(52.295,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.555),(52.655,12.725),(52.825,12.725),(52.825,12.555),(52.655,12.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,12.915),(51.575,13.085),(51.745,13.085),(51.745,12.915),(51.575,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,12.915),(51.935,13.085),(52.105,13.085),(52.105,12.915),(51.935,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,12.915),(52.295,13.085),(52.465,13.085),(52.465,12.915),(52.295,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,12.915),(52.655,13.085),(52.825,13.085),(52.825,12.915),(52.655,12.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.275),(51.575,13.445),(51.745,13.445),(51.745,13.275),(51.575,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.275),(51.935,13.445),(52.105,13.445),(52.105,13.275),(51.935,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.275),(52.295,13.445),(52.465,13.445),(52.465,13.275),(52.295,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.275),(52.655,13.445),(52.825,13.445),(52.825,13.275),(52.655,13.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.635),(51.575,13.805),(51.745,13.805),(51.745,13.635),(51.575,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.635),(51.935,13.805),(52.105,13.805),(52.105,13.635),(51.935,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.635),(52.295,13.805),(52.465,13.805),(52.465,13.635),(52.295,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.635),(52.655,13.805),(52.825,13.805),(52.825,13.635),(52.655,13.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,13.995),(51.575,14.165),(51.745,14.165),(51.745,13.995),(51.575,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,13.995),(51.935,14.165),(52.105,14.165),(52.105,13.995),(51.935,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,13.995),(52.295,14.165),(52.465,14.165),(52.465,13.995),(52.295,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,13.995),(52.655,14.165),(52.825,14.165),(52.825,13.995),(52.655,13.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.355),(51.575,14.525),(51.745,14.525),(51.745,14.355),(51.575,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.355),(51.935,14.525),(52.105,14.525),(52.105,14.355),(51.935,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.355),(52.295,14.525),(52.465,14.525),(52.465,14.355),(52.295,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.355),(52.655,14.525),(52.825,14.525),(52.825,14.355),(52.655,14.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,14.715),(51.575,14.885),(51.745,14.885),(51.745,14.715),(51.575,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,14.715),(51.935,14.885),(52.105,14.885),(52.105,14.715),(51.935,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,14.715),(52.295,14.885),(52.465,14.885),(52.465,14.715),(52.295,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,14.715),(52.655,14.885),(52.825,14.885),(52.825,14.715),(52.655,14.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.075),(51.575,15.245),(51.745,15.245),(51.745,15.075),(51.575,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.075),(51.935,15.245),(52.105,15.245),(52.105,15.075),(51.935,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.075),(52.295,15.245),(52.465,15.245),(52.465,15.075),(52.295,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.075),(52.655,15.245),(52.825,15.245),(52.825,15.075),(52.655,15.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.435),(51.575,15.605),(51.745,15.605),(51.745,15.435),(51.575,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.435),(51.935,15.605),(52.105,15.605),(52.105,15.435),(51.935,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.435),(52.295,15.605),(52.465,15.605),(52.465,15.435),(52.295,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.435),(52.655,15.605),(52.825,15.605),(52.825,15.435),(52.655,15.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,15.795),(51.575,15.965),(51.745,15.965),(51.745,15.795),(51.575,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,15.795),(51.935,15.965),(52.105,15.965),(52.105,15.795),(51.935,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,15.795),(52.295,15.965),(52.465,15.965),(52.465,15.795),(52.295,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,15.795),(52.655,15.965),(52.825,15.965),(52.825,15.795),(52.655,15.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.155),(51.575,16.325),(51.745,16.325),(51.745,16.155),(51.575,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.155),(51.935,16.325),(52.105,16.325),(52.105,16.155),(51.935,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.155),(52.295,16.325),(52.465,16.325),(52.465,16.155),(52.295,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.155),(52.655,16.325),(52.825,16.325),(52.825,16.155),(52.655,16.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.515),(51.575,16.685),(51.745,16.685),(51.745,16.515),(51.575,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.515),(51.935,16.685),(52.105,16.685),(52.105,16.515),(51.935,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.515),(52.295,16.685),(52.465,16.685),(52.465,16.515),(52.295,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.515),(52.655,16.685),(52.825,16.685),(52.825,16.515),(52.655,16.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,16.875),(51.575,17.045),(51.745,17.045),(51.745,16.875),(51.575,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,16.875),(51.935,17.045),(52.105,17.045),(52.105,16.875),(51.935,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,16.875),(52.295,17.045),(52.465,17.045),(52.465,16.875),(52.295,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,16.875),(52.655,17.045),(52.825,17.045),(52.825,16.875),(52.655,16.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.235),(51.575,17.405),(51.745,17.405),(51.745,17.235),(51.575,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.235),(51.935,17.405),(52.105,17.405),(52.105,17.235),(51.935,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.235),(52.295,17.405),(52.465,17.405),(52.465,17.235),(52.295,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.235),(52.655,17.405),(52.825,17.405),(52.825,17.235),(52.655,17.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.595),(51.575,17.765),(51.745,17.765),(51.745,17.595),(51.575,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.595),(51.935,17.765),(52.105,17.765),(52.105,17.595),(51.935,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.595),(52.295,17.765),(52.465,17.765),(52.465,17.595),(52.295,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.595),(52.655,17.765),(52.825,17.765),(52.825,17.595),(52.655,17.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,17.955),(51.575,18.125),(51.745,18.125),(51.745,17.955),(51.575,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,17.955),(51.935,18.125),(52.105,18.125),(52.105,17.955),(51.935,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,17.955),(52.295,18.125),(52.465,18.125),(52.465,17.955),(52.295,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,17.955),(52.655,18.125),(52.825,18.125),(52.825,17.955),(52.655,17.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.315),(51.575,18.485),(51.745,18.485),(51.745,18.315),(51.575,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.315),(51.935,18.485),(52.105,18.485),(52.105,18.315),(51.935,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.315),(52.295,18.485),(52.465,18.485),(52.465,18.315),(52.295,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.315),(52.655,18.485),(52.825,18.485),(52.825,18.315),(52.655,18.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,18.675),(51.575,18.845),(51.745,18.845),(51.745,18.675),(51.575,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,18.675),(51.935,18.845),(52.105,18.845),(52.105,18.675),(51.935,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,18.675),(52.295,18.845),(52.465,18.845),(52.465,18.675),(52.295,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,18.675),(52.655,18.845),(52.825,18.845),(52.825,18.675),(52.655,18.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.035),(51.575,19.205),(51.745,19.205),(51.745,19.035),(51.575,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.035),(51.935,19.205),(52.105,19.205),(52.105,19.035),(51.935,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.035),(52.295,19.205),(52.465,19.205),(52.465,19.035),(52.295,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.035),(52.655,19.205),(52.825,19.205),(52.825,19.035),(52.655,19.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.395),(51.575,19.565),(51.745,19.565),(51.745,19.395),(51.575,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.395),(51.935,19.565),(52.105,19.565),(52.105,19.395),(51.935,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.395),(52.295,19.565),(52.465,19.565),(52.465,19.395),(52.295,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.395),(52.655,19.565),(52.825,19.565),(52.825,19.395),(52.655,19.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,19.755),(51.575,19.925),(51.745,19.925),(51.745,19.755),(51.575,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,19.755),(51.935,19.925),(52.105,19.925),(52.105,19.755),(51.935,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,19.755),(52.295,19.925),(52.465,19.925),(52.465,19.755),(52.295,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,19.755),(52.655,19.925),(52.825,19.925),(52.825,19.755),(52.655,19.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.115),(51.575,20.285),(51.745,20.285),(51.745,20.115),(51.575,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.115),(51.935,20.285),(52.105,20.285),(52.105,20.115),(51.935,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.115),(52.295,20.285),(52.465,20.285),(52.465,20.115),(52.295,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.115),(52.655,20.285),(52.825,20.285),(52.825,20.115),(52.655,20.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.475),(51.575,20.645),(51.745,20.645),(51.745,20.475),(51.575,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.475),(51.935,20.645),(52.105,20.645),(52.105,20.475),(51.935,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.475),(52.295,20.645),(52.465,20.645),(52.465,20.475),(52.295,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.475),(52.655,20.645),(52.825,20.645),(52.825,20.475),(52.655,20.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,20.835),(51.575,21.005),(51.745,21.005),(51.745,20.835),(51.575,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,20.835),(51.935,21.005),(52.105,21.005),(52.105,20.835),(51.935,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,20.835),(52.295,21.005),(52.465,21.005),(52.465,20.835),(52.295,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,20.835),(52.655,21.005),(52.825,21.005),(52.825,20.835),(52.655,20.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.195),(51.575,21.365),(51.745,21.365),(51.745,21.195),(51.575,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.195),(51.935,21.365),(52.105,21.365),(52.105,21.195),(51.935,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.195),(52.295,21.365),(52.465,21.365),(52.465,21.195),(52.295,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.195),(52.655,21.365),(52.825,21.365),(52.825,21.195),(52.655,21.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.555),(51.575,21.725),(51.745,21.725),(51.745,21.555),(51.575,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.555),(51.935,21.725),(52.105,21.725),(52.105,21.555),(51.935,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.555),(52.295,21.725),(52.465,21.725),(52.465,21.555),(52.295,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.555),(52.655,21.725),(52.825,21.725),(52.825,21.555),(52.655,21.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,21.915),(51.575,22.085),(51.745,22.085),(51.745,21.915),(51.575,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,21.915),(51.935,22.085),(52.105,22.085),(52.105,21.915),(51.935,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,21.915),(52.295,22.085),(52.465,22.085),(52.465,21.915),(52.295,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,21.915),(52.655,22.085),(52.825,22.085),(52.825,21.915),(52.655,21.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.275),(51.575,22.445),(51.745,22.445),(51.745,22.275),(51.575,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.275),(51.935,22.445),(52.105,22.445),(52.105,22.275),(51.935,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.275),(52.295,22.445),(52.465,22.445),(52.465,22.275),(52.295,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.275),(52.655,22.445),(52.825,22.445),(52.825,22.275),(52.655,22.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.635),(51.575,22.805),(51.745,22.805),(51.745,22.635),(51.575,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.635),(51.935,22.805),(52.105,22.805),(52.105,22.635),(51.935,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.635),(52.295,22.805),(52.465,22.805),(52.465,22.635),(52.295,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.635),(52.655,22.805),(52.825,22.805),(52.825,22.635),(52.655,22.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,22.995),(51.575,23.165),(51.745,23.165),(51.745,22.995),(51.575,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,22.995),(51.935,23.165),(52.105,23.165),(52.105,22.995),(51.935,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,22.995),(52.295,23.165),(52.465,23.165),(52.465,22.995),(52.295,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,22.995),(52.655,23.165),(52.825,23.165),(52.825,22.995),(52.655,22.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,23.355),(51.575,23.525),(51.745,23.525),(51.745,23.355),(51.575,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,23.355),(51.935,23.525),(52.105,23.525),(52.105,23.355),(51.935,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,23.355),(52.295,23.525),(52.465,23.525),(52.465,23.355),(52.295,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,23.355),(52.655,23.525),(52.825,23.525),(52.825,23.355),(52.655,23.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,23.715),(51.575,23.885),(51.745,23.885),(51.745,23.715),(51.575,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,23.715),(51.935,23.885),(52.105,23.885),(52.105,23.715),(51.935,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,23.715),(52.295,23.885),(52.465,23.885),(52.465,23.715),(52.295,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,23.715),(52.655,23.885),(52.825,23.885),(52.825,23.715),(52.655,23.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.075),(51.575,24.245),(51.745,24.245),(51.745,24.075),(51.575,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.075),(51.935,24.245),(52.105,24.245),(52.105,24.075),(51.935,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.075),(52.295,24.245),(52.465,24.245),(52.465,24.075),(52.295,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.075),(52.655,24.245),(52.825,24.245),(52.825,24.075),(52.655,24.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.435),(51.575,24.605),(51.745,24.605),(51.745,24.435),(51.575,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.435),(51.935,24.605),(52.105,24.605),(52.105,24.435),(51.935,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.435),(52.295,24.605),(52.465,24.605),(52.465,24.435),(52.295,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.435),(52.655,24.605),(52.825,24.605),(52.825,24.435),(52.655,24.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,24.795),(51.575,24.965),(51.745,24.965),(51.745,24.795),(51.575,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,24.795),(51.935,24.965),(52.105,24.965),(52.105,24.795),(51.935,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,24.795),(52.295,24.965),(52.465,24.965),(52.465,24.795),(52.295,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,24.795),(52.655,24.965),(52.825,24.965),(52.825,24.795),(52.655,24.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.155),(51.575,25.325),(51.745,25.325),(51.745,25.155),(51.575,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.155),(51.935,25.325),(52.105,25.325),(52.105,25.155),(51.935,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.155),(52.295,25.325),(52.465,25.325),(52.465,25.155),(52.295,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.155),(52.655,25.325),(52.825,25.325),(52.825,25.155),(52.655,25.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.515),(51.575,25.685),(51.745,25.685),(51.745,25.515),(51.575,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.515),(51.935,25.685),(52.105,25.685),(52.105,25.515),(51.935,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.515),(52.295,25.685),(52.465,25.685),(52.465,25.515),(52.295,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.515),(52.655,25.685),(52.825,25.685),(52.825,25.515),(52.655,25.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,25.875),(51.575,26.045),(51.745,26.045),(51.745,25.875),(51.575,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,25.875),(51.935,26.045),(52.105,26.045),(52.105,25.875),(51.935,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,25.875),(52.295,26.045),(52.465,26.045),(52.465,25.875),(52.295,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,25.875),(52.655,26.045),(52.825,26.045),(52.825,25.875),(52.655,25.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.235),(51.575,26.405),(51.745,26.405),(51.745,26.235),(51.575,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.235),(51.935,26.405),(52.105,26.405),(52.105,26.235),(51.935,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.235),(52.295,26.405),(52.465,26.405),(52.465,26.235),(52.295,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.235),(52.655,26.405),(52.825,26.405),(52.825,26.235),(52.655,26.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.595),(51.575,26.765),(51.745,26.765),(51.745,26.595),(51.575,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.595),(51.935,26.765),(52.105,26.765),(52.105,26.595),(51.935,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.595),(52.295,26.765),(52.465,26.765),(52.465,26.595),(52.295,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.595),(52.655,26.765),(52.825,26.765),(52.825,26.595),(52.655,26.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,26.955),(51.575,27.125),(51.745,27.125),(51.745,26.955),(51.575,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,26.955),(51.935,27.125),(52.105,27.125),(52.105,26.955),(51.935,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,26.955),(52.295,27.125),(52.465,27.125),(52.465,26.955),(52.295,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,26.955),(52.655,27.125),(52.825,27.125),(52.825,26.955),(52.655,26.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,27.315),(51.575,27.485),(51.745,27.485),(51.745,27.315),(51.575,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,27.315),(51.935,27.485),(52.105,27.485),(52.105,27.315),(51.935,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,27.315),(52.295,27.485),(52.465,27.485),(52.465,27.315),(52.295,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,27.315),(52.655,27.485),(52.825,27.485),(52.825,27.315),(52.655,27.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,27.675),(51.575,27.845),(51.745,27.845),(51.745,27.675),(51.575,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,27.675),(51.935,27.845),(52.105,27.845),(52.105,27.675),(51.935,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,27.675),(52.295,27.845),(52.465,27.845),(52.465,27.675),(52.295,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,27.675),(52.655,27.845),(52.825,27.845),(52.825,27.675),(52.655,27.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.035),(51.575,28.205),(51.745,28.205),(51.745,28.035),(51.575,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.035),(51.935,28.205),(52.105,28.205),(52.105,28.035),(51.935,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.035),(52.295,28.205),(52.465,28.205),(52.465,28.035),(52.295,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.035),(52.655,28.205),(52.825,28.205),(52.825,28.035),(52.655,28.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.395),(51.575,28.565),(51.745,28.565),(51.745,28.395),(51.575,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.395),(51.935,28.565),(52.105,28.565),(52.105,28.395),(51.935,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.395),(52.295,28.565),(52.465,28.565),(52.465,28.395),(52.295,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.395),(52.655,28.565),(52.825,28.565),(52.825,28.395),(52.655,28.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,28.755),(51.575,28.925),(51.745,28.925),(51.745,28.755),(51.575,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,28.755),(51.935,28.925),(52.105,28.925),(52.105,28.755),(51.935,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,28.755),(52.295,28.925),(52.465,28.925),(52.465,28.755),(52.295,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,28.755),(52.655,28.925),(52.825,28.925),(52.825,28.755),(52.655,28.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.115),(51.575,29.285),(51.745,29.285),(51.745,29.115),(51.575,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.115),(51.935,29.285),(52.105,29.285),(52.105,29.115),(51.935,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.115),(52.295,29.285),(52.465,29.285),(52.465,29.115),(52.295,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.115),(52.655,29.285),(52.825,29.285),(52.825,29.115),(52.655,29.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.475),(51.575,29.645),(51.745,29.645),(51.745,29.475),(51.575,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.475),(51.935,29.645),(52.105,29.645),(52.105,29.475),(51.935,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.475),(52.295,29.645),(52.465,29.645),(52.465,29.475),(52.295,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.475),(52.655,29.645),(52.825,29.645),(52.825,29.475),(52.655,29.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,29.835),(51.575,30.005),(51.745,30.005),(51.745,29.835),(51.575,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,29.835),(51.935,30.005),(52.105,30.005),(52.105,29.835),(51.935,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,29.835),(52.295,30.005),(52.465,30.005),(52.465,29.835),(52.295,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,29.835),(52.655,30.005),(52.825,30.005),(52.825,29.835),(52.655,29.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.195),(51.575,30.365),(51.745,30.365),(51.745,30.195),(51.575,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.195),(51.935,30.365),(52.105,30.365),(52.105,30.195),(51.935,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.195),(52.295,30.365),(52.465,30.365),(52.465,30.195),(52.295,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.195),(52.655,30.365),(52.825,30.365),(52.825,30.195),(52.655,30.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.555),(51.575,30.725),(51.745,30.725),(51.745,30.555),(51.575,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.555),(51.935,30.725),(52.105,30.725),(52.105,30.555),(51.935,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.555),(52.295,30.725),(52.465,30.725),(52.465,30.555),(52.295,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.555),(52.655,30.725),(52.825,30.725),(52.825,30.555),(52.655,30.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,30.915),(51.575,31.085),(51.745,31.085),(51.745,30.915),(51.575,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,30.915),(51.935,31.085),(52.105,31.085),(52.105,30.915),(51.935,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,30.915),(52.295,31.085),(52.465,31.085),(52.465,30.915),(52.295,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,30.915),(52.655,31.085),(52.825,31.085),(52.825,30.915),(52.655,30.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.275),(51.575,31.445),(51.745,31.445),(51.745,31.275),(51.575,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.275),(51.935,31.445),(52.105,31.445),(52.105,31.275),(51.935,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.275),(52.295,31.445),(52.465,31.445),(52.465,31.275),(52.295,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.275),(52.655,31.445),(52.825,31.445),(52.825,31.275),(52.655,31.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.635),(51.575,31.805),(51.745,31.805),(51.745,31.635),(51.575,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.635),(51.935,31.805),(52.105,31.805),(52.105,31.635),(51.935,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.635),(52.295,31.805),(52.465,31.805),(52.465,31.635),(52.295,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.635),(52.655,31.805),(52.825,31.805),(52.825,31.635),(52.655,31.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,31.995),(51.575,32.165),(51.745,32.165),(51.745,31.995),(51.575,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,31.995),(51.935,32.165),(52.105,32.165),(52.105,31.995),(51.935,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,31.995),(52.295,32.165),(52.465,32.165),(52.465,31.995),(52.295,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,31.995),(52.655,32.165),(52.825,32.165),(52.825,31.995),(52.655,31.995)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,32.355),(51.575,32.525),(51.745,32.525),(51.745,32.355),(51.575,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,32.355),(51.935,32.525),(52.105,32.525),(52.105,32.355),(51.935,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,32.355),(52.295,32.525),(52.465,32.525),(52.465,32.355),(52.295,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,32.355),(52.655,32.525),(52.825,32.525),(52.825,32.355),(52.655,32.355)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,32.715),(51.575,32.885),(51.745,32.885),(51.745,32.715),(51.575,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,32.715),(51.935,32.885),(52.105,32.885),(52.105,32.715),(51.935,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,32.715),(52.295,32.885),(52.465,32.885),(52.465,32.715),(52.295,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,32.715),(52.655,32.885),(52.825,32.885),(52.825,32.715),(52.655,32.715)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.075),(51.575,33.245),(51.745,33.245),(51.745,33.075),(51.575,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.075),(51.935,33.245),(52.105,33.245),(52.105,33.075),(51.935,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.075),(52.295,33.245),(52.465,33.245),(52.465,33.075),(52.295,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.075),(52.655,33.245),(52.825,33.245),(52.825,33.075),(52.655,33.075)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.435),(51.575,33.605),(51.745,33.605),(51.745,33.435),(51.575,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.435),(51.935,33.605),(52.105,33.605),(52.105,33.435),(51.935,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.435),(52.295,33.605),(52.465,33.605),(52.465,33.435),(52.295,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.435),(52.655,33.605),(52.825,33.605),(52.825,33.435),(52.655,33.435)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,33.795),(51.575,33.965),(51.745,33.965),(51.745,33.795),(51.575,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,33.795),(51.935,33.965),(52.105,33.965),(52.105,33.795),(51.935,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,33.795),(52.295,33.965),(52.465,33.965),(52.465,33.795),(52.295,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,33.795),(52.655,33.965),(52.825,33.965),(52.825,33.795),(52.655,33.795)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.155),(51.575,34.325),(51.745,34.325),(51.745,34.155),(51.575,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.155),(51.935,34.325),(52.105,34.325),(52.105,34.155),(51.935,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.155),(52.295,34.325),(52.465,34.325),(52.465,34.155),(52.295,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.155),(52.655,34.325),(52.825,34.325),(52.825,34.155),(52.655,34.155)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.515),(51.575,34.685),(51.745,34.685),(51.745,34.515),(51.575,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.515),(51.935,34.685),(52.105,34.685),(52.105,34.515),(51.935,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.515),(52.295,34.685),(52.465,34.685),(52.465,34.515),(52.295,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.515),(52.655,34.685),(52.825,34.685),(52.825,34.515),(52.655,34.515)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,34.875),(51.575,35.045),(51.745,35.045),(51.745,34.875),(51.575,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,34.875),(51.935,35.045),(52.105,35.045),(52.105,34.875),(51.935,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,34.875),(52.295,35.045),(52.465,35.045),(52.465,34.875),(52.295,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,34.875),(52.655,35.045),(52.825,35.045),(52.825,34.875),(52.655,34.875)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.235),(51.575,35.405),(51.745,35.405),(51.745,35.235),(51.575,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.235),(51.935,35.405),(52.105,35.405),(52.105,35.235),(51.935,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.235),(52.295,35.405),(52.465,35.405),(52.465,35.235),(52.295,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.235),(52.655,35.405),(52.825,35.405),(52.825,35.235),(52.655,35.235)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.595),(51.575,35.765),(51.745,35.765),(51.745,35.595),(51.575,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.595),(51.935,35.765),(52.105,35.765),(52.105,35.595),(51.935,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.595),(52.295,35.765),(52.465,35.765),(52.465,35.595),(52.295,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.595),(52.655,35.765),(52.825,35.765),(52.825,35.595),(52.655,35.595)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,35.955),(51.575,36.125),(51.745,36.125),(51.745,35.955),(51.575,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,35.955),(51.935,36.125),(52.105,36.125),(52.105,35.955),(51.935,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,35.955),(52.295,36.125),(52.465,36.125),(52.465,35.955),(52.295,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,35.955),(52.655,36.125),(52.825,36.125),(52.825,35.955),(52.655,35.955)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,36.315),(51.575,36.485),(51.745,36.485),(51.745,36.315),(51.575,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,36.315),(51.935,36.485),(52.105,36.485),(52.105,36.315),(51.935,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,36.315),(52.295,36.485),(52.465,36.485),(52.465,36.315),(52.295,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,36.315),(52.655,36.485),(52.825,36.485),(52.825,36.315),(52.655,36.315)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,36.675),(51.575,36.845),(51.745,36.845),(51.745,36.675),(51.575,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,36.675),(51.935,36.845),(52.105,36.845),(52.105,36.675),(51.935,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,36.675),(52.295,36.845),(52.465,36.845),(52.465,36.675),(52.295,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,36.675),(52.655,36.845),(52.825,36.845),(52.825,36.675),(52.655,36.675)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.035),(51.575,37.205),(51.745,37.205),(51.745,37.035),(51.575,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.035),(51.935,37.205),(52.105,37.205),(52.105,37.035),(51.935,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.035),(52.295,37.205),(52.465,37.205),(52.465,37.035),(52.295,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.035),(52.655,37.205),(52.825,37.205),(52.825,37.035),(52.655,37.035)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.395),(51.575,37.565),(51.745,37.565),(51.745,37.395),(51.575,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.395),(51.935,37.565),(52.105,37.565),(52.105,37.395),(51.935,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.395),(52.295,37.565),(52.465,37.565),(52.465,37.395),(52.295,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.395),(52.655,37.565),(52.825,37.565),(52.825,37.395),(52.655,37.395)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,37.755),(51.575,37.925),(51.745,37.925),(51.745,37.755),(51.575,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,37.755),(51.935,37.925),(52.105,37.925),(52.105,37.755),(51.935,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,37.755),(52.295,37.925),(52.465,37.925),(52.465,37.755),(52.295,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,37.755),(52.655,37.925),(52.825,37.925),(52.825,37.755),(52.655,37.755)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.115),(51.575,38.285),(51.745,38.285),(51.745,38.115),(51.575,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.115),(51.935,38.285),(52.105,38.285),(52.105,38.115),(51.935,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.115),(52.295,38.285),(52.465,38.285),(52.465,38.115),(52.295,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.115),(52.655,38.285),(52.825,38.285),(52.825,38.115),(52.655,38.115)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.475),(51.575,38.645),(51.745,38.645),(51.745,38.475),(51.575,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.475),(51.935,38.645),(52.105,38.645),(52.105,38.475),(51.935,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.475),(52.295,38.645),(52.465,38.645),(52.465,38.475),(52.295,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.475),(52.655,38.645),(52.825,38.645),(52.825,38.475),(52.655,38.475)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,38.835),(51.575,39.005),(51.745,39.005),(51.745,38.835),(51.575,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,38.835),(51.935,39.005),(52.105,39.005),(52.105,38.835),(51.935,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,38.835),(52.295,39.005),(52.465,39.005),(52.465,38.835),(52.295,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,38.835),(52.655,39.005),(52.825,39.005),(52.825,38.835),(52.655,38.835)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.195),(51.575,39.365),(51.745,39.365),(51.745,39.195),(51.575,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.195),(51.935,39.365),(52.105,39.365),(52.105,39.195),(51.935,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.195),(52.295,39.365),(52.465,39.365),(52.465,39.195),(52.295,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.195),(52.655,39.365),(52.825,39.365),(52.825,39.195),(52.655,39.195)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.555),(51.575,39.725),(51.745,39.725),(51.745,39.555),(51.575,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.555),(51.935,39.725),(52.105,39.725),(52.105,39.555),(51.935,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.555),(52.295,39.725),(52.465,39.725),(52.465,39.555),(52.295,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.555),(52.655,39.725),(52.825,39.725),(52.825,39.555),(52.655,39.555)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,39.915),(51.575,40.085),(51.745,40.085),(51.745,39.915),(51.575,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,39.915),(51.935,40.085),(52.105,40.085),(52.105,39.915),(51.935,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,39.915),(52.295,40.085),(52.465,40.085),(52.465,39.915),(52.295,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,39.915),(52.655,40.085),(52.825,40.085),(52.825,39.915),(52.655,39.915)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,40.275),(51.575,40.445),(51.745,40.445),(51.745,40.275),(51.575,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,40.275),(51.935,40.445),(52.105,40.445),(52.105,40.275),(51.935,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,40.275),(52.295,40.445),(52.465,40.445),(52.465,40.275),(52.295,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,40.275),(52.655,40.445),(52.825,40.445),(52.825,40.275),(52.655,40.275)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.575,40.635),(51.575,40.805),(51.745,40.805),(51.745,40.635),(51.575,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((51.935,40.635),(51.935,40.805),(52.105,40.805),(52.105,40.635),(51.935,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.295,40.635),(52.295,40.805),(52.465,40.805),(52.465,40.635),(52.295,40.635)),
        )
        createRL(
            tech, net, 'mcon',
            ((52.655,40.635),(52.655,40.805),(52.825,40.805),(52.825,40.635),(52.655,40.635)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.775),(46.745,40.865),(48.055,40.865),(48.055,2.775),(46.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.775),(32.345,43.64),(33.655,43.64),(33.655,2.775),(32.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((46.745,2.775),(46.745,43.64),(48.055,43.64),(48.055,2.775),(46.745,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.775),(51.545,43.64),(52.855,43.64),(52.855,2.775),(51.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((32.345,2.775),(32.345,40.865),(33.655,40.865),(33.655,2.775),(32.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.775),(37.145,43.64),(38.455,43.64),(38.455,2.775),(37.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((51.545,2.775),(51.545,40.865),(52.855,40.865),(52.855,2.775),(51.545,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.775),(41.945,40.865),(43.255,40.865),(43.255,2.775),(41.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((37.145,2.775),(37.145,40.865),(38.455,40.865),(38.455,2.775),(37.145,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.775),(56.345,43.64),(57.655,43.64),(57.655,2.775),(56.345,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((41.945,2.775),(41.945,43.64),(43.255,43.64),(43.255,2.775),(41.945,2.775)),
        )
        createRL(
            tech, net, 'm1',
            ((56.345,2.775),(56.345,40.865),(57.655,40.865),(57.655,2.775),(56.345,2.775)),
        )
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(33.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(33.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(47.4), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(47.4), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(52.2), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(52.2), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(37.8), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(37.8), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(57.0), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(57.0), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('m1.pin'),
            u(42.6), u(1.31), u(2.775), u(43.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('m1'),
            u(42.6), u(1.31), u(2.775), u(43.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['off']
        createRL(
            tech, net, 'poly',
            ((38.565,2.59),(38.565,41.05),(39.165,41.05),(39.165,2.59),(38.565,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,41.05),(52.965,41.08),(53.565,41.08),(53.565,41.05),(52.965,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,41.05),(46.035,41.08),(46.635,41.08),(46.635,41.05),(46.035,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,41.08),(46.2,41.41),(46.47,41.41),(46.47,41.08),(46.2,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.59),(57.765,41.05),(58.365,41.05),(58.365,2.59),(57.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,41.08),(31.8,41.41),(32.07,41.41),(32.07,41.08),(31.8,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,41.05),(31.635,41.08),(32.235,41.08),(32.235,41.05),(31.635,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.56),(36.435,2.59),(37.035,2.59),(37.035,2.56),(36.435,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,2.23),(53.13,2.56),(53.4,2.56),(53.4,2.23),(53.13,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,2.23),(38.73,2.56),(39.0,2.56),(39.0,2.23),(38.73,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,2.23),(36.6,2.56),(36.87,2.56),(36.87,2.23),(36.6,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,2.56),(38.565,2.59),(39.165,2.59),(39.165,2.56),(38.565,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((31.8,2.23),(31.8,2.56),(32.07,2.56),(32.07,2.23),(31.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.59),(48.165,41.05),(48.765,41.05),(48.765,2.59),(48.165,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.56),(50.835,2.59),(51.435,2.59),(51.435,2.56),(50.835,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.59),(41.235,41.05),(41.835,41.05),(41.835,2.59),(41.235,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,41.05),(36.435,41.08),(37.035,41.08),(37.035,41.05),(36.435,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,41.08),(43.53,41.41),(43.8,41.41),(43.8,41.08),(43.53,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,41.05),(43.365,41.08),(43.965,41.08),(43.965,41.05),(43.365,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,41.08),(51.0,41.41),(51.27,41.41),(51.27,41.08),(51.0,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((38.73,41.08),(38.73,41.41),(39.0,41.41),(39.0,41.08),(38.73,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((38.565,41.05),(38.565,41.08),(39.165,41.08),(39.165,41.05),(38.565,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,41.08),(48.33,41.41),(48.6,41.41),(48.6,41.08),(48.33,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,41.05),(48.165,41.08),(48.765,41.08),(48.765,41.05),(48.165,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((51.0,2.23),(51.0,2.56),(51.27,2.56),(51.27,2.23),(51.0,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.59),(43.365,41.05),(43.965,41.05),(43.965,2.59),(43.365,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,2.23),(55.8,2.56),(56.07,2.56),(56.07,2.23),(55.8,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.56),(55.635,2.59),(56.235,2.59),(56.235,2.56),(55.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((36.435,2.59),(36.435,41.05),(37.035,41.05),(37.035,2.59),(36.435,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,41.05),(41.235,41.08),(41.835,41.08),(41.835,41.05),(41.235,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,41.08),(41.4,41.41),(41.67,41.41),(41.67,41.08),(41.4,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((43.53,2.23),(43.53,2.56),(43.8,2.56),(43.8,2.23),(43.53,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((43.365,2.56),(43.365,2.59),(43.965,2.59),(43.965,2.56),(43.365,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,2.59),(55.635,41.05),(56.235,41.05),(56.235,2.59),(55.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.59),(46.035,41.05),(46.635,41.05),(46.635,2.59),(46.035,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,2.23),(57.93,2.56),(58.2,2.56),(58.2,2.23),(57.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,2.56),(57.765,2.59),(58.365,2.59),(58.365,2.56),(57.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.33,2.23),(48.33,2.56),(48.6,2.56),(48.6,2.23),(48.33,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((55.8,41.08),(55.8,41.41),(56.07,41.41),(56.07,41.08),(55.8,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((55.635,41.05),(55.635,41.08),(56.235,41.08),(56.235,41.05),(55.635,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((41.235,2.56),(41.235,2.59),(41.835,2.59),(41.835,2.56),(41.235,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,2.59),(50.835,41.05),(51.435,41.05),(51.435,2.59),(50.835,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((41.4,2.23),(41.4,2.56),(41.67,2.56),(41.67,2.23),(41.4,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.59),(33.765,41.05),(34.365,41.05),(34.365,2.59),(33.765,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,2.23),(33.93,2.56),(34.2,2.56),(34.2,2.23),(33.93,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,2.56),(33.765,2.59),(34.365,2.59),(34.365,2.56),(33.765,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((57.93,41.08),(57.93,41.41),(58.2,41.41),(58.2,41.08),(57.93,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((57.765,41.05),(57.765,41.08),(58.365,41.08),(58.365,41.05),(57.765,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.59),(52.965,41.05),(53.565,41.05),(53.565,2.59),(52.965,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((36.6,41.08),(36.6,41.41),(36.87,41.41),(36.87,41.08),(36.6,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,21.99),(73.68,22.28),(74.01,22.28),(74.01,21.99),(73.68,21.99)),
        )
        createRL(
            tech, net, 'poly',
            ((53.13,41.08),(53.13,41.41),(53.4,41.41),(53.4,41.08),(53.13,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((46.035,2.56),(46.035,2.59),(46.635,2.59),(46.635,2.56),(46.035,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((46.2,2.23),(46.2,2.56),(46.47,2.56),(46.47,2.23),(46.2,2.23)),
        )
        createRL(
            tech, net, 'poly',
            ((33.765,41.05),(33.765,41.08),(34.365,41.08),(34.365,41.05),(33.765,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((33.93,41.08),(33.93,41.41),(34.2,41.41),(34.2,41.08),(33.93,41.08)),
        )
        createRL(
            tech, net, 'poly',
            ((52.965,2.56),(52.965,2.59),(53.565,2.59),(53.565,2.56),(52.965,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((50.835,41.05),(50.835,41.08),(51.435,41.08),(51.435,41.05),(50.835,41.05)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.59),(31.635,41.05),(32.235,41.05),(32.235,2.59),(31.635,2.59)),
        )
        createRL(
            tech, net, 'poly',
            ((31.635,2.56),(31.635,2.59),(32.235,2.59),(32.235,2.56),(31.635,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((48.165,2.56),(48.165,2.59),(48.765,2.59),(48.765,2.56),(48.165,2.56)),
        )
        createRL(
            tech, net, 'poly',
            ((73.68,21.985),(73.68,22.25),(74.01,22.25),(74.01,21.985),(73.68,21.985)),
        )
        createRL(
            tech, net, 'licon',
            ((73.76,22.03),(73.76,22.2),(73.93,22.2),(73.93,22.03),(73.76,22.03)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,41.16),(46.25,41.33),(46.42,41.33),(46.42,41.16),(46.25,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,41.16),(31.85,41.33),(32.02,41.33),(32.02,41.16),(31.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,2.31),(36.65,2.48),(36.82,2.48),(36.82,2.31),(36.65,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,2.31),(38.78,2.48),(38.95,2.48),(38.95,2.31),(38.78,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,41.16),(43.58,41.33),(43.75,41.33),(43.75,41.16),(43.58,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,41.16),(51.05,41.33),(51.22,41.33),(51.22,41.16),(51.05,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,41.16),(48.38,41.33),(48.55,41.33),(48.55,41.16),(48.38,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((51.05,2.31),(51.05,2.48),(51.22,2.48),(51.22,2.31),(51.05,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((43.58,2.31),(43.58,2.48),(43.75,2.48),(43.75,2.31),(43.58,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,2.31),(55.85,2.48),(56.02,2.48),(56.02,2.31),(55.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,41.16),(41.45,41.33),(41.62,41.33),(41.62,41.16),(41.45,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,2.31),(57.98,2.48),(58.15,2.48),(58.15,2.31),(57.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((55.85,41.16),(55.85,41.33),(56.02,41.33),(56.02,41.16),(55.85,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((41.45,2.31),(41.45,2.48),(41.62,2.48),(41.62,2.31),(41.45,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,2.31),(33.98,2.48),(34.15,2.48),(34.15,2.31),(33.98,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((57.98,41.16),(57.98,41.33),(58.15,41.33),(58.15,41.16),(57.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((36.65,41.16),(36.65,41.33),(36.82,41.33),(36.82,41.16),(36.65,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,41.16),(53.18,41.33),(53.35,41.33),(53.35,41.16),(53.18,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((46.25,2.31),(46.25,2.48),(46.42,2.48),(46.42,2.31),(46.25,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((33.98,41.16),(33.98,41.33),(34.15,41.33),(34.15,41.16),(33.98,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((38.78,41.16),(38.78,41.33),(38.95,41.33),(38.95,41.16),(38.78,41.16)),
        )
        createRL(
            tech, net, 'licon',
            ((53.18,2.31),(53.18,2.48),(53.35,2.48),(53.35,2.31),(53.18,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((31.85,2.31),(31.85,2.48),(32.02,2.48),(32.02,2.31),(31.85,2.31)),
        )
        createRL(
            tech, net, 'licon',
            ((48.38,2.31),(48.38,2.48),(48.55,2.48),(48.55,2.31),(48.38,2.31)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.56),(36.65,41.08),(36.82,41.08),(36.82,2.56),(36.65,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,41.08),(46.25,41.41),(46.42,41.41),(46.42,41.08),(46.25,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.56),(57.98,41.08),(58.15,41.08),(58.15,2.56),(57.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,41.08),(31.85,41.41),(32.02,41.41),(32.02,41.08),(31.85,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,2.23),(36.65,2.56),(36.82,2.56),(36.82,2.23),(36.65,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.23),(38.78,2.56),(38.95,2.56),(38.95,2.23),(38.78,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.56),(48.38,41.08),(48.55,41.08),(48.55,2.56),(48.38,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.56),(41.45,41.08),(41.62,41.08),(41.62,2.56),(41.45,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,41.08),(43.58,41.41),(43.75,41.41),(43.75,41.08),(43.58,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,41.08),(51.05,41.41),(51.22,41.41),(51.22,41.08),(51.05,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,41.08),(48.38,41.41),(48.55,41.41),(48.55,41.08),(48.38,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((73.76,21.95),(73.76,22.28),(73.93,22.28),(73.93,21.95),(73.76,21.95)),
        )
        createRL(
            tech, net, 'li',
            ((73.76,21.95),(73.76,41.41),(73.93,41.41),(73.93,21.95),(73.76,21.95)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,2.56),(38.78,41.08),(38.95,41.08),(38.95,2.56),(38.78,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.23),(43.58,2.56),(43.75,2.56),(43.75,2.23),(43.58,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((43.58,2.56),(43.58,41.08),(43.75,41.08),(43.75,2.56),(43.58,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.56),(51.05,41.08),(51.22,41.08),(51.22,2.56),(51.05,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.23),(55.85,2.56),(56.02,2.56),(56.02,2.23),(55.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((51.05,2.23),(51.05,2.56),(51.22,2.56),(51.22,2.23),(51.05,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,2.56),(55.85,41.08),(56.02,41.08),(56.02,2.56),(55.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,41.08),(41.45,41.41),(41.62,41.41),(41.62,41.08),(41.45,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.56),(46.25,41.08),(46.42,41.08),(46.42,2.56),(46.25,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,2.23),(57.98,2.56),(58.15,2.56),(58.15,2.23),(57.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.56),(53.18,41.08),(53.35,41.08),(53.35,2.56),(53.18,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((55.85,41.08),(55.85,41.41),(56.02,41.41),(56.02,41.08),(55.85,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((41.45,2.23),(41.45,2.56),(41.62,2.56),(41.62,2.23),(41.45,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.56),(33.98,41.08),(34.15,41.08),(34.15,2.56),(33.98,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,2.23),(33.98,2.56),(34.15,2.56),(34.15,2.23),(33.98,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.56),(31.85,41.08),(32.02,41.08),(32.02,2.56),(31.85,2.56)),
        )
        createRL(
            tech, net, 'li',
            ((57.98,41.08),(57.98,41.41),(58.15,41.41),(58.15,41.08),(57.98,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((36.65,41.08),(36.65,41.41),(36.82,41.41),(36.82,41.08),(36.65,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,41.08),(53.18,41.41),(53.35,41.41),(53.35,41.08),(53.18,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((46.25,2.23),(46.25,2.56),(46.42,2.56),(46.42,2.23),(46.25,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((33.98,41.08),(33.98,41.41),(34.15,41.41),(34.15,41.08),(33.98,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((38.78,41.08),(38.78,41.41),(38.95,41.41),(38.95,41.08),(38.78,41.08)),
        )
        createRL(
            tech, net, 'li',
            ((53.18,2.23),(53.18,2.56),(53.35,2.56),(53.35,2.23),(53.18,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,2.23),(31.85,2.56),(32.02,2.56),(32.02,2.23),(31.85,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((48.38,2.23),(48.38,2.56),(48.55,2.56),(48.55,2.23),(48.38,2.23)),
        )
        createRL(
            tech, net, 'li',
            ((31.85,41.24),(31.85,41.41),(58.15,41.41),(58.15,41.24),(31.85,41.24)),
        )
        nets['iovss'].setDirection(Net.Direction.IN)
        nets['iovdd'].setDirection(Net.Direction.IN)
        nets['pad'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['GuardRing_P18000W8728HFF']
        except:
            subcell = af.getCell('GuardRing_P18000W8728HFF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'OuterRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['GuardRing_N17368W8096HTF']
        except:
            subcell = af.getCell('GuardRing_N17368W8096HTF', 0)
        trans = Transformation(
            u(45.0), u(21.82), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'InnerRing', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    af.wrapLibrary(lib, 0)

    return lib

def setup():
    lib = _load()
    _routing()
    try:
        from .IOLib_fix import fix
    except:
        pass
    else:
        fix(lib)

    return lib
